/* Automatically generated file. Do not edit. 
 * Format:     ANSI C source code
 * Creator:    McStas <http://www.mcstas.org>
 * Instrument: MACS_sample_kidney_box.instr (dmtas)
 * Date:       Thu Jul 15 11:56:17 2021
 * File:       MACS_sample_kidney_box.c
 * Compile:    cc -o dmtas.out MACS_sample_kidney_box.c  -I@MCCODE_LIB@/share/
 * CFLAGS= -I@MCCODE_LIB@/share/
 */


#define MCCODE_STRING "McStas 2.7 - Nov. 27, 2020"
#define FLAVOR "mcstas"
#define FLAVOR_UPPER "MCSTAS"
#define MC_USE_DEFAULT_MAIN
#define MC_EMBEDDED_RUNTIME

#line 1 "mccode-r.h"
/*******************************************************************************
*
* McCode, neutron/xray ray-tracing package
*         Copyright (C) 1997-2009, All rights reserved
*         Risoe National Laboratory, Roskilde, Denmark
*         Institut Laue Langevin, Grenoble, France
*
* Runtime: share/mccode-r.h
*
* %Identification
* Written by: KN
* Date:    Aug 29, 1997
* Release: McStas 2.7
* Version: $Revision$
*
* Runtime system header for McStas/McXtrace.
*
* In order to use this library as an external library, the following variables
* and macros must be declared (see details in the code)
*
*   struct mcinputtable_struct mcinputtable[];
*   int mcnumipar;
*   char mcinstrument_name[], mcinstrument_source[];
*   int mctraceenabled, mcdefaultmain;
*   extern MCNUM  mccomp_storein[];
*   extern MCNUM  mcAbsorbProp[];
*   extern MCNUM  mcScattered;
*   #define MCCODE_STRING "the McStas/McXtrace version"
*
* Usage: Automatically embbeded in the c code.
*
* $Id$
*
*******************************************************************************/

#ifndef MCCODE_R_H
#define MCCODE_R_H "$Revision$"

#include <math.h>
#include <string.h>
#include <strings.h>
#include <stdlib.h>
#include <stdio.h>
#include <stdarg.h>
#include <limits.h>
#include <errno.h>
#include <time.h>
#include <float.h>
#include <inttypes.h>

/* If the runtime is embedded in the simulation program, some definitions can
   be made static. */

#ifdef MC_EMBEDDED_RUNTIME
#define mcstatic static
#else
#define mcstatic
#endif

#ifdef __dest_os
#if (__dest_os == __mac_os)
#define MAC
#endif
#endif

#ifdef __FreeBSD__
#define NEED_STAT_H
#endif

#if defined(__APPLE__) && defined(__GNUC__)
#define NEED_STAT_H
#endif

#ifdef NEED_STAT_H
#include <sys/stat.h>
#endif

#ifndef MC_PATHSEP_C
#ifdef WIN32
#define MC_PATHSEP_C '\\'
#define MC_PATHSEP_S "\\"
#else  /* !WIN32 */
#define MC_PATHSEP_C '/'
#define MC_PATHSEP_S "/"
#endif /* !WIN32 */
#endif /* MC_PATHSEP_C */

#ifndef WIN32
#ifndef _POSIX_SOURCE
#define _POSIX_SOURCE 1
#endif
#endif

/* the version string is replaced when building distribution with mkdist */
#ifndef MCCODE_STRING
#define MCCODE_STRING "McStas 2.7 - Nov. 27, 2020"
#endif

#ifndef MCCODE_DATE
#define MCCODE_DATE "Nov. 27, 2020"
#endif

#ifndef MCCODE_VERSION
#define MCCODE_VERSION "2.7"
#endif

#ifndef MCCODE_NAME
#define MCCODE_NAME "McStas"
#endif

#ifndef MCCODE_PARTICLE
#define MCCODE_PARTICLE "neutron"
#endif

#ifndef MCCODE_LIBENV
#define MCCODE_LIBENV "MCSTAS"
#endif

#ifndef FLAVOR_UPPER
#define FLAVOR_UPPER MCCODE_NAME
#endif

#ifdef MC_PORTABLE
#ifndef NOSIGNALS
#define NOSIGNALS 1
#endif
#endif

#ifdef MAC
#ifndef NOSIGNALS
#define NOSIGNALS 1
#endif
#endif

#if (USE_MPI == 0)
#undef USE_MPI
#endif

#ifdef USE_MPI  /* default is to disable signals with MPI, as MPICH uses them to communicate */
#ifndef NOSIGNALS
#define NOSIGNALS 1
#endif
#endif

#if (NOSIGNALS == 0)
#undef NOSIGNALS
#endif

/* Note: the enum instr_formal_types definition MUST be kept
   synchronized with the one in mccode.h and with the
   instr_formal_type_names array in cogen.c. */
enum instr_formal_types
  {
    instr_type_double, instr_type_int, instr_type_string
  };
struct mcinputtable_struct { /* defines instrument parameters */
  char *name; /* name of parameter */
  void *par;  /* pointer to instrument parameter (variable) */
  enum instr_formal_types type;
  char *val;  /* default value */
};

typedef double MCNUM;
typedef struct {MCNUM x, y, z;} Coords;
typedef MCNUM Rotation[3][3];

/* the following variables are defined in the McStas generated C code
   but should be defined externally in case of independent library usage */
#ifndef DANSE
extern struct mcinputtable_struct mcinputtable[]; /* list of instrument parameters */
extern int    mcnumipar;                          /* number of instrument parameters */
extern char   mcinstrument_name[], mcinstrument_source[]; /* instrument name and filename */
extern char  *mcinstrument_exe;                           /* executable path = argv[0] or NULL */
extern MCNUM  mccomp_storein[]; /* 11 coords * number of components in instrument */
extern MCNUM  mcAbsorbProp[];
extern MCNUM  mcScattered;      /* number of SCATTER calls in current component */
extern MCNUM  mcRestore;        /* Flag to indicate if neutron needs to be restored */
#ifndef MC_ANCIENT_COMPATIBILITY
extern int mctraceenabled, mcdefaultmain;
#endif
#endif


/* Useful macros ============================================================ */

/* MPI stuff */

#ifdef USE_MPI
#include "mpi.h"

#ifdef OMPI_MPI_H  /* openmpi does not use signals: we may install our sighandler */
#undef NOSIGNALS
#endif

/*
 * MPI_MASTER(i):
 * execution of i only on master node
 */
#define MPI_MASTER(statement) { \
  if(mpi_node_rank == mpi_node_root)\
  { statement; } \
}

#ifndef MPI_REDUCE_BLOCKSIZE
#define MPI_REDUCE_BLOCKSIZE 1000
#endif

int mc_MPI_Sum(double* buf, long count);
int mc_MPI_Send(void *sbuf, long count, MPI_Datatype dtype, int dest);
int mc_MPI_Recv(void *rbuf, long count, MPI_Datatype dtype, int source);

/* MPI_Finalize exits gracefully and should be preferred to MPI_Abort */
#define exit(code) do {                                   \
    MPI_Finalize();                                       \
    exit(code);                                           \
  } while(0)

#else /* !USE_MPI */
#define MPI_MASTER(instr) instr
#endif /* USE_MPI */

#ifdef USE_MPI
static int mpi_node_count;
#endif

#ifdef USE_THREADS  /* user want threads */
#error Threading (USE_THREADS) support has been removed for very poor efficiency. Use MPI/SSH grid instead.
#endif


void   mcset_ncount(unsigned long long count);    /* wrapper to get mcncount */
unsigned long long int mcget_ncount(void);            /* wrapper to set mcncount */
unsigned long long mcget_run_num(void);           /* wrapper to get mcrun_num=0:mcncount */


/* Following part is only embedded when not redundant with mccode.h ========= */

#ifndef MCCODE_H

#ifndef NOSIGNALS
#include <signal.h>
#define SIG_MESSAGE(msg) strcpy(mcsig_message, msg);
#else
#define SIG_MESSAGE(msg)
#endif /* !NOSIGNALS */

/* Useful macros and constants ============================================== */

#ifndef FLT_MAX
#define FLT_MAX         3.40282347E+38F /* max decimal value of a "float" */
#endif

#ifndef MIN
#define MIN(a, b)  (((a) < (b)) ? (a) : (b))
#endif
#ifndef MAX
#define MAX(a, b)  (((a) > (b)) ? (a) : (b))
#endif
#ifndef SQR
#define SQR(x) ( (x) * (x) )
#endif
#ifndef SIGN
#define SIGN(x) (((x)>0.0)?(1):(-1))
#endif

#ifndef PI
# ifdef M_PI
#  define PI M_PI
# else
/* When using c99 in the CFLAGS, some of these consts
   are lost... Perhaps we should in fact include everything from
   https://www.gnu.org/software/libc/manual/html_node/Mathematical-Constants.html
*/
#  define PI 3.14159265358979323846
#  define M_PI PI
#  define M_PI_2 M_PI/2.0
#  define M_PI_4 M_PI/4.0
#  define M_1_PI 1.0/M_PI
#  define M_2_PI 2*M_1_PI
#  define M_2_SQRTPI 2/sqrt(M_PI)
#  define M_SQRT2 sqrt(2)
#  define M_SQRT1_2 sqrt(1/2)
# endif
#endif

#define RAD2MIN  ((180*60)/PI)
#define MIN2RAD  (PI/(180*60))
#define DEG2RAD  (PI/180)
#define RAD2DEG  (180/PI)
#define FWHM2RMS 0.424660900144    /* Convert between full-width-half-max and */
#define RMS2FWHM 2.35482004503     /* root-mean-square (standard deviation) */
#define HBAR     1.05457168e-34    /* [Js] h bar Planck constant CODATA 2002 */
#define MNEUTRON 1.67492728e-27    /* [kg] mass of neutron CODATA 2002 */
#define GRAVITY  9.81              /* [m/s^2] gravitational acceleration */
#define NA       6.02214179e23     /* [#atoms/g .mole] Avogadro's number*/


/* wrapper to get absolute and relative position of comp */
/* mccomp_posa and mccomp_posr are defined in McStas generated C code */
#define POS_A_COMP_INDEX(index) \
    (mccomp_posa[index])
#define POS_R_COMP_INDEX(index) \
    (mccomp_posr[index])
/* number of SCATTER calls in current comp: mcScattered defined in generated C code */
#define SCATTERED mcScattered
/* Flag to indicate if neutron needs to be restored: mcRestore defined in generated C code */
#define RESTORE mcRestore


/* Retrieve component information from the kernel */
/* Name, position and orientation (both absolute and relative)  */
/* Any component: For "redundancy", see comment by KN */
#define tmp_name_comp(comp) #comp
#define NAME_COMP(comp) tmp_name_comp(comp)
#define tmp_pos_a_comp(comp) (mcposa ## comp)
#define POS_A_COMP(comp) tmp_pos_a_comp(comp)
#define tmp_pos_r_comp(comp) (mcposr ## comp)
#define POS_R_COMP(comp) tmp_pos_r_comp(comp)
#define tmp_rot_a_comp(comp) (mcrota ## comp)
#define ROT_A_COMP(comp) tmp_rot_a_comp(comp)
#define tmp_rot_r_comp(comp) (mcrotr ## comp)
#define ROT_R_COMP(comp) tmp_rot_r_comp(comp)

/* Current component name, index, position and orientation */
#define NAME_CURRENT_COMP  NAME_COMP(mccompcurname)
#define INDEX_CURRENT_COMP mccompcurindex
#define POS_A_CURRENT_COMP POS_A_COMP(mccompcurname)
#define POS_R_CURRENT_COMP POS_R_COMP(mccompcurname)
#define ROT_A_CURRENT_COMP ROT_A_COMP(mccompcurname)
#define ROT_R_CURRENT_COMP ROT_R_COMP(mccompcurname)

/* Note: The two-stage approach to MC_GETPAR is NOT redundant; without it,
* after #define C sample, MC_GETPAR(C,x) would refer to component C, not to
* component sample. Such are the joys of ANSI C.

* Anyway the usage of MCGETPAR requires that we use sometimes bare names...
*/
#define MC_GETPAR2(comp, par) (mcc ## comp ## _ ## par)
#define MC_GETPAR(comp, par) MC_GETPAR2(comp,par)

/* MCDISPLAY/trace and debugging message sent to stdout */
#ifdef MC_TRACE_ENABLED
#define DEBUG
#endif

#ifdef DEBUG
#define mcDEBUG_INSTR() if(!mcdotrace); else { printf("\nINSTRUMENT:\n"); printf("Instrument '%s' (%s)\n", mcinstrument_name, mcinstrument_source); }
#define mcDEBUG_COMPONENT(name,c,t) if(!mcdotrace); else {\
  printf("COMPONENT: \"%s\"\n" \
         "POS: %g, %g, %g, %g, %g, %g, %g, %g, %g, %g, %g, %g\n", \
         name, c.x, c.y, c.z, t[0][0], t[0][1], t[0][2], \
         t[1][0], t[1][1], t[1][2], t[2][0], t[2][1], t[2][2]); \
  mcAccumulatedILength += coords_len(coords_sub(mcLastComp,c)); \
  printf("Component %30s AT (%g,%g,%g)    %g m from origin\n", name, c.x, c.y, c.z, mcAccumulatedILength); \
  mcLastComp=c;\
  }
#define mcDEBUG_INSTR_END() if(!mcdotrace); else printf("INSTRUMENT END:\n");
#define mcDEBUG_ENTER() if(!mcdotrace); else printf("ENTER:\n");
#define mcDEBUG_COMP(c) if(!mcdotrace); else printf("COMP: \"%s\"\n", c);
#define mcDEBUG_LEAVE() if(!mcdotrace); else printf("LEAVE:\n");
#define mcDEBUG_ABSORB() if(!mcdotrace); else printf("ABSORB:\n");
#else
#define mcDEBUG_INSTR()
#define mcDEBUG_COMPONENT(name,c,t)
#define mcDEBUG_INSTR_END()
#define mcDEBUG_ENTER()
#define mcDEBUG_COMP(c)
#define mcDEBUG_LEAVE()
#define mcDEBUG_ABSORB()
#endif

// mcDEBUG_STATE and mcDEBUG_SCATTER are defined by mcstas-r.h and mcxtrace-r.h



#ifdef TEST
#define test_printf printf
#else
#define test_printf while(0) printf
#endif

/* send MCDISPLAY message to stdout to show gemoetry */
void mcdis_magnify(char *what);
void mcdis_line(double x1, double y1, double z1,
                double x2, double y2, double z2);
void mcdis_dashed_linemcdis_dashed_line(double x1, double y1, double z1,
		       double x2, double y2, double z2, int n);
void mcdis_multiline(int count, ...);
void mcdis_rectangle(char* plane, double x, double y, double z,
		     double width, double height);
void mcdis_box(double x, double y, double z,
	       double width, double height, double length);
void mcdis_circle(char *plane, double x, double y, double z, double r);
void mcdis_Circle(double x, double y, double z, double r, double nx, double ny, double nz);
void mcdis_cylinder( double x, double y, double z,
        double r, double height, int N, double nx, double ny, double nz);
void mcdis_sphere(double x, double y, double z, double r, int N);

/* selection of random number generator. default is MT */
#ifndef MC_RAND_ALG
#define MC_RAND_ALG 1
#endif

#if MC_RAND_ALG == 0
   /* Use system random() (not recommended). */
#  define MC_RAND_MAX RAND_MAX
#elif MC_RAND_ALG == 1
   /* "Mersenne Twister", by Makoto Matsumoto and Takuji Nishimura. */
#  define MC_RAND_MAX ((unsigned long)0xffffffff)
#  define random mt_random
#  define srandom mt_srandom
#elif MC_RAND_ALG == 2
   /* Algorithm used in McStas CVS-080208 and earlier (not recommended). */
#  define MC_RAND_MAX 0x7fffffff
#  define random mc_random
#  define srandom mc_srandom
#else
#  error "Bad value for random number generator choice."
#endif

typedef int mc_int32_t;
mc_int32_t mc_random(void);
void mc_srandom (unsigned int x);
unsigned long mt_random(void);
void mt_srandom (unsigned long x);

double rand01();
double randpm1();
double rand0max(double max);
double randminmax(double min, double max);

double randnorm(void);
double randtriangle(void);

#ifndef DANSE
void mcinit(void);
void mcraytrace(void);
void mcsave(FILE *);
void mcfinally(void);
void mcdisplay(void);
#endif

/* simple vector algebra ==================================================== */
#define vec_prod(x, y, z, x1, y1, z1, x2, y2, z2) \
	vec_prod_func(&x, &y, &z, x1, y1, z1, x2, y2, z2)
mcstatic void vec_prod_func(double *x, double *y, double *z,
		double x1, double y1, double z1, double x2, double y2, double z2);

mcstatic double scalar_prod(
		double x1, double y1, double z1, double x2, double y2, double z2);

#define NORM(x,y,z) \
	norm_func(&x, &y, &z)
mcstatic void norm_func(double *x, double *y, double *z) {
	double temp = (*x * *x) + (*y * *y) + (*z * *z);
	if (temp != 0) {
		temp = sqrt(temp);
		*x /= temp;
		*y /= temp;
		*z /= temp;
	}
}
#define normal_vec(nx, ny, nz, x, y, z) \
    normal_vec_func(&(nx), &(ny), &(nz), x, y, z)
mcstatic void normal_vec_func(double *nx, double *ny, double *nz,
    double x, double y, double z);

/**
 * Rotate the vector vx,vy,vz psi radians around the vector ax,ay,az
 * and put the result in x,y,z.
 */
#define rotate(x, y, z, vx, vy, vz, phi, ax, ay, az) \
  do { \
    double mcrt_tmpx = (ax), mcrt_tmpy = (ay), mcrt_tmpz = (az); \
    double mcrt_vp, mcrt_vpx, mcrt_vpy, mcrt_vpz; \
    double mcrt_vnx, mcrt_vny, mcrt_vnz, mcrt_vn1x, mcrt_vn1y, mcrt_vn1z; \
    double mcrt_bx, mcrt_by, mcrt_bz; \
    double mcrt_cos, mcrt_sin; \
    NORM(mcrt_tmpx, mcrt_tmpy, mcrt_tmpz); \
    mcrt_vp = scalar_prod((vx), (vy), (vz), mcrt_tmpx, mcrt_tmpy, mcrt_tmpz); \
    mcrt_vpx = mcrt_vp*mcrt_tmpx; \
    mcrt_vpy = mcrt_vp*mcrt_tmpy; \
    mcrt_vpz = mcrt_vp*mcrt_tmpz; \
    mcrt_vnx = (vx) - mcrt_vpx; \
    mcrt_vny = (vy) - mcrt_vpy; \
    mcrt_vnz = (vz) - mcrt_vpz; \
    vec_prod(mcrt_bx, mcrt_by, mcrt_bz, \
             mcrt_tmpx, mcrt_tmpy, mcrt_tmpz, mcrt_vnx, mcrt_vny, mcrt_vnz); \
    mcrt_cos = cos((phi)); mcrt_sin = sin((phi)); \
    mcrt_vn1x = mcrt_vnx*mcrt_cos + mcrt_bx*mcrt_sin; \
    mcrt_vn1y = mcrt_vny*mcrt_cos + mcrt_by*mcrt_sin; \
    mcrt_vn1z = mcrt_vnz*mcrt_cos + mcrt_bz*mcrt_sin; \
    (x) = mcrt_vpx + mcrt_vn1x; \
    (y) = mcrt_vpy + mcrt_vn1y; \
    (z) = mcrt_vpz + mcrt_vn1z; \
  } while(0)

/**
 * Mirror (xyz) in the plane given by the point (rx,ry,rz) and normal (nx,ny,nz)
 *
 * TODO: This define is seemingly never used...
 */
#define mirror(x,y,z,rx,ry,rz,nx,ny,nz) \
  do { \
    double mcrt_tmpx= (nx), mcrt_tmpy = (ny), mcrt_tmpz = (nz); \
    double mcrt_tmpt; \
    NORM(mcrt_tmpx, mcrt_tmpy, mcrt_tmpz); \
    mcrt_tmpt=scalar_prod((rx),(ry),(rz),mcrt_tmpx,mcrt_tmpy,mcrt_tmpz); \
    (x) = rx -2 * mcrt_tmpt*mcrt_rmpx; \
    (y) = ry -2 * mcrt_tmpt*mcrt_rmpy; \
    (z) = rz -2 * mcrt_tmpt*mcrt_rmpz; \
  } while (0)

Coords coords_set(MCNUM x, MCNUM y, MCNUM z);
Coords coords_get(Coords a, MCNUM *x, MCNUM *y, MCNUM *z);
Coords coords_add(Coords a, Coords b);
Coords coords_sub(Coords a, Coords b);
Coords coords_neg(Coords a);
Coords coords_scale(Coords b, double scale);
double coords_sp(Coords a, Coords b);
Coords coords_xp(Coords b, Coords c);
double coords_len(Coords a);
void   coords_print(Coords a);
mcstatic void coords_norm(Coords* c);

void rot_set_rotation(Rotation t, double phx, double phy, double phz);
int  rot_test_identity(Rotation t);
void rot_mul(Rotation t1, Rotation t2, Rotation t3);
void rot_copy(Rotation dest, Rotation src);
void rot_transpose(Rotation src, Rotation dst);
Coords rot_apply(Rotation t, Coords a);

void mccoordschange(Coords a, Rotation t, double *x, double *y, double *z,
    double *vx, double *vy, double *vz, double *sx, double *sy, double *sz);
void
mccoordschange_polarisation(Rotation t, double *sx, double *sy, double *sz);

double mcestimate_error(double N, double p1, double p2);
void mcreadparams(void);

/* this is now in mcstas-r.h and mcxtrace-r.h as the number of state parameters is no longer equal*/
/* void mcsetstate(double x, double y, double z, double vx, double vy, double vz,
                double t, double sx, double sy, double sz, double p);
*/
void mcgenstate(void);

/* trajectory/shape intersection routines */
int inside_rectangle(double, double, double, double);
int box_intersect(double *dt_in, double *dt_out, double x, double y, double z,
    double vx, double vy, double vz, double dx, double dy, double dz);
int cylinder_intersect(double *t0, double *t1, double x, double y, double z,
    double vx, double vy, double vz, double r, double h);
int sphere_intersect(double *t0, double *t1, double x, double y, double z,
                 double vx, double vy, double vz, double r);
/* second order equation roots */
int solve_2nd_order(double *t1, double *t2,
    double A,  double B,  double C);

/* random vector generation to shape */
void randvec_target_circle(double *xo, double *yo, double *zo,
    double *solid_angle, double xi, double yi, double zi, double radius);
#define randvec_target_sphere randvec_target_circle
void randvec_target_rect_angular(double *xo, double *yo, double *zo,
    double *solid_angle,
               double xi, double yi, double zi, double height, double width, Rotation A);
#define randvec_target_rect(p0,p1,p2,p3,p4,p5,p6,p7,p8,p9)  randvec_target_rect_real(p0,p1,p2,p3,p4,p5,p6,p7,p8,p9,0,0,0,1)
void randvec_target_rect_real(double *xo, double *yo, double *zo,
    double *solid_angle,
	       double xi, double yi, double zi, double height, double width, Rotation A,
			 double lx, double ly, double lz, int order);

/* this is the main() */
int mccode_main(int argc, char *argv[]);


#endif /* !MCCODE_H */

#ifndef MCCODE_R_IO_H
#define MCCODE_R_IO_H "$Revision$"

#if (USE_NEXUS == 0)
#undef USE_NEXUS
#endif

#ifndef CHAR_BUF_LENGTH
#define CHAR_BUF_LENGTH 1024
#endif

/* I/O section part ========================================================= */

/* ========================================================================== */

/*                               MCCODE_R_IO_C                                */

/* ========================================================================== */


/* main DETECTOR structure which stores most information to write to data files */
struct mcdetector_struct {
  char   filename[CHAR_BUF_LENGTH];   /* file name of monitor */
  char   position[CHAR_BUF_LENGTH];   /* position of detector component */
  char   component[CHAR_BUF_LENGTH];  /* component instance name */
  char   instrument[CHAR_BUF_LENGTH]; /* instrument name */
  char   type[CHAR_BUF_LENGTH];       /* data type, e.g. 0d, 1d, 2d, 3d */
  char   user[CHAR_BUF_LENGTH];       /* user name, e.g. HOME */
  char   date[CHAR_BUF_LENGTH];       /* date of simulation end/write time */
  char   title[CHAR_BUF_LENGTH];      /* title of detector */
  char   xlabel[CHAR_BUF_LENGTH];     /* X axis label */
  char   ylabel[CHAR_BUF_LENGTH];     /* Y axis label */
  char   zlabel[CHAR_BUF_LENGTH];     /* Z axis label */
  char   xvar[CHAR_BUF_LENGTH];       /* X variable name */
  char   yvar[CHAR_BUF_LENGTH];       /* Y variable name */
  char   zvar[CHAR_BUF_LENGTH];       /* Z variable name */
  char   ncount[CHAR_BUF_LENGTH];     /* number of events initially generated */
  char   limits[CHAR_BUF_LENGTH];     /* X Y Z limits, e.g. [xmin xmax ymin ymax zmin zmax] */
  char   variables[CHAR_BUF_LENGTH];  /* variables written into data block */
  char   statistics[CHAR_BUF_LENGTH]; /* center, mean and half width along axis */
  char   signal[CHAR_BUF_LENGTH];     /* min max and mean of signal (data block) */
  char   values[CHAR_BUF_LENGTH];     /* integrated values e.g. [I I_err N] */
  double xmin,xmax;                   /* min max of axes */
  double ymin,ymax;
  double zmin,zmax;
  double intensity;                   /* integrated values for data block */
  double error;
  double events;
  double min;                         /* statistics for data block */
  double max;
  double mean;
  double centerX;                     /* statistics for axes */
  double halfwidthX;
  double centerY;
  double halfwidthY;
  int    rank;                        /* dimensionaly of monitor, e.g. 0 1 2 3 */
  char   istransposed;                /* flag to transpose matrix for some formats */

  long   m,n,p;                       /* dimensions of data block and along axes */
  long   date_l;                      /* same as date, but in sec since 1970 */

  double *p0, *p1, *p2;               /* pointers to saved data, NULL when freed */
  char   format[CHAR_BUF_LENGTH];    /* format for file generation */
};

typedef struct mcdetector_struct MCDETECTOR;

static   char *mcdirname             = NULL;      /* name of output directory */
static   char *mcsiminfo_name        = "mccode";  /* default output sim file name */
char    *mcformat                    = NULL;      /* NULL (default) or a specific format */

/* file I/O definitions and function prototypes */

#ifndef MC_EMBEDDED_RUNTIME /* the mcstatic variables (from mccode-r.c) */
extern FILE * mcsiminfo_file;     /* handle to the output siminfo file */
extern int    mcgravitation;      /* flag to enable gravitation */
extern int    mcdotrace;          /* flag to print MCDISPLAY messages */
#else
mcstatic FILE *mcsiminfo_file        = NULL;
#endif

/* I/O function prototypes ================================================== */

/* output functions */
MCDETECTOR mcdetector_out_0D(char *t, double p0, double p1, double p2, char *c, Coords pos);
MCDETECTOR mcdetector_out_1D(char *t, char *xl, char *yl,
                  char *xvar, double x1, double x2, long n,
                  double *p0, double *p1, double *p2, char *f, char *c, Coords pos);
MCDETECTOR mcdetector_out_2D(char *t, char *xl, char *yl,
                  double x1, double x2, double y1, double y2, long m,
                  long n, double *p0, double *p1, double *p2, char *f,
                  char *c, Coords pos);
MCDETECTOR mcdetector_out_list(char *t, char *xl, char *yl,
                  long m, long n,
                  double *p1, char *f,
                  char *c, Coords posa);

/* wrappers to output functions, that automatically set NAME and POSITION */
#define DETECTOR_OUT(p0,p1,p2) mcdetector_out_0D(NAME_CURRENT_COMP,p0,p1,p2,NAME_CURRENT_COMP,POS_A_CURRENT_COMP)
#define DETECTOR_OUT_0D(t,p0,p1,p2) mcdetector_out_0D(t,p0,p1,p2,NAME_CURRENT_COMP,POS_A_CURRENT_COMP)
#define DETECTOR_OUT_1D(t,xl,yl,xvar,x1,x2,n,p0,p1,p2,f) \
     mcdetector_out_1D(t,xl,yl,xvar,x1,x2,n,p0,p1,p2,f,NAME_CURRENT_COMP,POS_A_CURRENT_COMP)
#define DETECTOR_OUT_2D(t,xl,yl,x1,x2,y1,y2,m,n,p0,p1,p2,f) \
     mcdetector_out_2D(t,xl,yl,x1,x2,y1,y2,m,n,p0,p1,p2,f,NAME_CURRENT_COMP,POS_A_CURRENT_COMP)

#ifdef USE_NEXUS
#include "napi.h"
NXhandle nxhandle;
#endif

#endif /* ndef MCCODE_R_IO_H */

#endif /* MCCODE_R_H */
/* End of file "mccode-r.h". */

#line 711 "MACS_sample_kidney_box.c"

#line 1 "mcstas-r.h"
/*******************************************************************************
*
* McStas, neutron ray-tracing package
*         Copyright (C) 1997-2009, All rights reserved
*         Risoe National Laboratory, Roskilde, Denmark
*         Institut Laue Langevin, Grenoble, France
*
* Runtime: share/mcstas-r.h
*
* %Identification
* Written by: KN
* Date:    Aug 29, 1997
* Release: McStas X.Y
* Version: $Revision$
*
* Runtime system header for McStas.
*
* In order to use this library as an external library, the following variables
* and macros must be declared (see details in the code)
*
*   struct mcinputtable_struct mcinputtable[];
*   int mcnumipar;
*   char mcinstrument_name[], mcinstrument_source[];
*   int mctraceenabled, mcdefaultmain;
*   extern MCNUM  mccomp_storein[];
*   extern MCNUM  mcAbsorbProp[];
*   extern MCNUM  mcScattered;
*   #define MCCODE_STRING "the McStas version"
*
* Usage: Automatically embbeded in the c code.
*
* $Id$
*
*******************************************************************************/

#ifndef MCSTAS_R_H
#define MCSTAS_R_H "$Revision$"

/* Following part is only embedded when not redundant with mcstas.h ========= */

#ifndef MCCODE_H

#define AA2MS    629.622368        /* Convert k[1/AA] to v[m/s] */
#define MS2AA    1.58825361e-3     /* Convert v[m/s] to k[1/AA] */
#define K2V      AA2MS
#define V2K      MS2AA
#define Q2V      AA2MS
#define V2Q      MS2AA
#define SE2V     437.393377        /* Convert sqrt(E)[meV] to v[m/s] */
#define VS2E     5.22703725e-6     /* Convert (v[m/s])**2 to E[meV] */

#define SCATTER do {mcDEBUG_SCATTER(mcnlx, mcnly, mcnlz, mcnlvx, mcnlvy, mcnlvz, \
        mcnlt,mcnlsx,mcnlsy,mcnlsz, mcnlp); mcScattered++;} while(0)
#define ABSORB do {mcDEBUG_STATE(mcnlx, mcnly, mcnlz, mcnlvx, mcnlvy, mcnlvz, \
        mcnlt,mcnlsx,mcnlsy,mcnlsz, mcnlp); mcDEBUG_ABSORB(); MAGNET_OFF; goto mcabsorb;} while(0)

#define STORE_NEUTRON(index, x, y, z, vx, vy, vz, t, sx, sy, sz, p) \
  mcstore_neutron(mccomp_storein,index, x, y, z, vx, vy, vz, t, sx, sy, sz, p);
#define RESTORE_NEUTRON(index, x, y, z, vx, vy, vz, t, sx, sy, sz, p) \
  mcrestore_neutron(mccomp_storein,index, &x, &y, &z, &vx, &vy, &vz, &t, &sx, &sy, &sz, &p);

#define MAGNET_ON \
  do { \
    mcMagnet = 1; \
  } while(0)

#define MAGNET_OFF \
  do { \
    mcMagnet = 0; \
  } while(0)

#define ALLOW_BACKPROP \
  do { \
    mcallowbackprop = 1; \
  } while(0)

#define DISALLOW_BACKPROP \
  do { \
    mcallowbackprop = 0; \
  } while(0)

#define PROP_MAGNET(dt) \
  do { \
  }while (0)
    /* change coordinates from local system to magnet system */
/*    Rotation rotLM, rotTemp; \
      Coords   posLM = coords_sub(POS_A_CURRENT_COMP, mcMagnetPos); \
      rot_transpose(ROT_A_CURRENT_COMP, rotTemp); \
      rot_mul(rotTemp, mcMagnetRot, rotLM); \
      mcMagnetPrecession(mcnlx, mcnly, mcnlz, mcnlt, mcnlvx, mcnlvy, mcnlvz, \
               &mcnlsx, &mcnlsy, &mcnlsz, dt, posLM, rotLM); \
      } while(0)
*/

#define mcPROP_DT(dt) \
  do { \
    if (mcMagnet && dt > 0) PROP_MAGNET(dt);\
    mcnlx += mcnlvx*(dt); \
    mcnly += mcnlvy*(dt); \
    mcnlz += mcnlvz*(dt); \
    mcnlt += (dt); \
    if (isnan(p) || isinf(p)) { mcAbsorbProp[INDEX_CURRENT_COMP]++; ABSORB; }\
  } while(0)

/* ADD: E. Farhi, Aug 6th, 2001 PROP_GRAV_DT propagation with acceleration */
#define PROP_GRAV_DT(dt, Ax, Ay, Az) \
  do { \
    if(dt < 0 && mcallowbackprop == 0) { mcAbsorbProp[INDEX_CURRENT_COMP]++; ABSORB; }\
    if (mcMagnet) printf("Spin precession gravity\n"); \
    mcnlx  += mcnlvx*(dt) + (Ax)*(dt)*(dt)/2; \
    mcnly  += mcnlvy*(dt) + (Ay)*(dt)*(dt)/2; \
    mcnlz  += mcnlvz*(dt) + (Az)*(dt)*(dt)/2; \
    mcnlvx += (Ax)*(dt); \
    mcnlvy += (Ay)*(dt); \
    mcnlvz += (Az)*(dt); \
    mcnlt  += (dt); \
    DISALLOW_BACKPROP;\
  } while(0)


#define PROP_DT(dt) \
  do { \
    if(dt < 0) { RESTORE=1; goto mcabsorbComp; }; \
    if (mcgravitation) { Coords mcLocG; double mc_gx, mc_gy, mc_gz; \
    mcLocG = rot_apply(ROT_A_CURRENT_COMP, coords_set(0,-GRAVITY,0)); \
    coords_get(mcLocG, &mc_gx, &mc_gy, &mc_gz); \
    PROP_GRAV_DT(dt, mc_gx, mc_gy, mc_gz); } \
    else mcPROP_DT(dt); \
    DISALLOW_BACKPROP;\
  } while(0)


#define PROP_Z0 \
  do { \
    if (mcgravitation) { Coords mcLocG; int mc_ret; \
    double mc_dt, mc_gx, mc_gy, mc_gz; \
    mcLocG = rot_apply(ROT_A_CURRENT_COMP, coords_set(0,-GRAVITY,0)); \
    coords_get(mcLocG, &mc_gx, &mc_gy, &mc_gz); \
    mc_ret = solve_2nd_order(&mc_dt, NULL, -mc_gz/2, -mcnlvz, -mcnlz); \
    if (mc_ret && mc_dt>=0) {PROP_GRAV_DT(mc_dt, mc_gx, mc_gy, mc_gz); mcnlz=0;}\
    else { if (mcallowbackprop ==0) {mcAbsorbProp[INDEX_CURRENT_COMP]++; ABSORB; }}; }\
    else mcPROP_Z0; \
    DISALLOW_BACKPROP;\
  } while(0)

#define mcPROP_Z0 \
  do { \
    double mc_dt; \
    if(mcnlvz == 0) { mcAbsorbProp[INDEX_CURRENT_COMP]++; ABSORB; }; \
    mc_dt = -mcnlz/mcnlvz; \
    if(mc_dt < 0 && mcallowbackprop == 0) { mcAbsorbProp[INDEX_CURRENT_COMP]++; ABSORB; }; \
    mcPROP_DT(mc_dt); \
    mcnlz = 0; \
    DISALLOW_BACKPROP;\
  } while(0)

#define PROP_X0 \
  do { \
    if (mcgravitation) { Coords mcLocG; int mc_ret; \
    double mc_dt, mc_gx, mc_gy, mc_gz; \
    mcLocG = rot_apply(ROT_A_CURRENT_COMP, coords_set(0,-GRAVITY,0)); \
    coords_get(mcLocG, &mc_gx, &mc_gy, &mc_gz); \
    mc_ret = solve_2nd_order(&mc_dt, NULL, -mc_gx/2, -mcnlvx, -mcnlx); \
    if (mc_ret && mc_dt>=0) PROP_GRAV_DT(mc_dt, mc_gx, mc_gy, mc_gz); \
    else { if (mcallowbackprop ==0) {mcAbsorbProp[INDEX_CURRENT_COMP]++; ABSORB; }}; }\
    else mcPROP_X0; \
    DISALLOW_BACKPROP;\
  } while(0)

#define mcPROP_X0 \
  do { \
    double mc_dt; \
    if(mcnlvx == 0) { mcAbsorbProp[INDEX_CURRENT_COMP]++; ABSORB; }; \
    mc_dt = -mcnlx/mcnlvx; \
    if(mc_dt < 0 && mcallowbackprop == 0) { mcAbsorbProp[INDEX_CURRENT_COMP]++; ABSORB; }; \
    mcPROP_DT(mc_dt); \
    mcnlx = 0; \
    DISALLOW_BACKPROP;\
  } while(0)

#define PROP_Y0 \
  do { \
    if (mcgravitation) { Coords mcLocG; int mc_ret; \
    double mc_dt, mc_gx, mc_gy, mc_gz; \
    mcLocG = rot_apply(ROT_A_CURRENT_COMP, coords_set(0,-GRAVITY,0)); \
    coords_get(mcLocG, &mc_gx, &mc_gy, &mc_gz); \
    mc_ret = solve_2nd_order(&mc_dt, NULL, -mc_gy/2, -mcnlvy, -mcnly); \
    if (mc_ret && mc_dt>=0) PROP_GRAV_DT(mc_dt, mc_gx, mc_gy, mc_gz); \
    else { if (mcallowbackprop ==0) {mcAbsorbProp[INDEX_CURRENT_COMP]++; ABSORB; }}; }\
    else mcPROP_Y0; \
    DISALLOW_BACKPROP;\
  } while(0)


#define mcPROP_Y0 \
  do { \
    double mc_dt; \
    if(mcnlvy == 0) { mcAbsorbProp[INDEX_CURRENT_COMP]++; ABSORB; }; \
    mc_dt = -mcnly/mcnlvy; \
    if(mc_dt < 0 && mcallowbackprop == 0) { mcAbsorbProp[INDEX_CURRENT_COMP]++; ABSORB; }; \
    mcPROP_DT(mc_dt); \
    mcnly = 0; \
    DISALLOW_BACKPROP; \
  } while(0)

/*moved from mccode-r.h*/
void mcsetstate(double x, double y, double z, double vx, double vy, double vz,
                double t, double sx, double sy, double sz, double p);

#ifdef DEBUG

#define mcDEBUG_STATE(x,y,z,vx,vy,vz,t,sx,sy,sz,p) if(!mcdotrace); else \
  printf("STATE: %g, %g, %g, %g, %g, %g, %g, %g, %g, %g, %g\n", \
         x,y,z,vx,vy,vz,t,sx,sy,sz,p);
#define mcDEBUG_SCATTER(x,y,z,vx,vy,vz,t,sx,sy,sz,p) if(!mcdotrace); else \
  printf("SCATTER: %g, %g, %g, %g, %g, %g, %g, %g, %g, %g, %g\n", \
         x,y,z,vx,vy,vz,t,sx,sy,sz,p);

#else

#define mcDEBUG_STATE(x,y,z,vx,vy,vz,t,sx,sy,sz,p)
#define mcDEBUG_SCATTER(x,y,z,vx,vy,vz,t,sx,sy,sz,p)

#endif

#endif /* !MCCODE_H */

#endif /* MCSTAS_R_H */
/* End of file "mcstas-r.h". */

#line 944 "MACS_sample_kidney_box.c"

#line 1 "mccode-r.c"
/*******************************************************************************
*
* McCode, neutron/xray ray-tracing package
*         Copyright (C) 1997-2009, All rights reserved
*         Risoe National Laboratory, Roskilde, Denmark
*         Institut Laue Langevin, Grenoble, France
*
* Runtime: share/mccode-r.c
*
* %Identification
* Written by: KN
* Date:    Aug 29, 1997
* Release: McStas X.Y/McXtrace X.Y
* Version: $Revision$
*
* Runtime system for McStas and McXtrace.
* Embedded within instrument in runtime mode.
* Contains SECTIONS:
*   MPI handling (sum, send, recv)
*   format definitions
*   I/O
*   mcdisplay support
*   random numbers
*   coordinates handling
*   vectors math (solve 2nd order, normals, randvec...)
*   parameter handling
*   signal and main handlers
*
* Usage: Automatically embbeded in the c code whenever required.
*
* $Id$
*
*******************************************************************************/

/*******************************************************************************
* The I/O format definitions and functions
*******************************************************************************/


/** Include header files to avoid implicit declarations (not allowed on LLVM) */
#include <ctype.h>
#include <sys/types.h>

// UNIX specific headers (non-Windows)
#if defined(__unix__) || defined(__APPLE__)
#include <unistd.h>
#endif

#include <sys/stat.h>

#ifdef _WIN32 
#include <direct.h>
# define  mkdir( D, M )   _mkdir( D ) 
#endif 

#ifndef DANSE
#ifdef MC_ANCIENT_COMPATIBILITY
int mctraceenabled = 0;
int mcdefaultmain  = 0;
#endif
/* else defined directly in the McCode generated C code */

static   long mcseed                 = 0; /* seed for random generator */
static   long mcstartdate            = 0; /* start simulation time */
static   int  mcdisable_output_files = 0; /* --no-output-files */
mcstatic int  mcgravitation          = 0; /* use gravitation flag, for PROP macros */
int      mcMagnet                    = 0; /* magnet stack flag */
mcstatic int  mcdotrace              = 0; /* flag for --trace and messages for DISPLAY */
int      mcallowbackprop             = 0;         /* flag to enable negative/backprop */

/* Number of particle histories to simulate. */
#ifdef NEUTRONICS
mcstatic unsigned long long int mcncount             = 1;
mcstatic unsigned long long int mcrun_num            = 0;
#else
mcstatic unsigned long long int mcncount             = 1000000;
mcstatic unsigned long long int mcrun_num            = 0;
#endif /* NEUTRONICS */

#else
#include "mcstas-globals.h"
#endif /* !DANSE */

/* SECTION: MPI handling ==================================================== */

#ifdef USE_MPI
/* MPI rank */
static int mpi_node_rank;
static int mpi_node_root = 0;


/*******************************************************************************
* mc_MPI_Reduce: Gathers arrays from MPI nodes using Reduce function.
*******************************************************************************/
int mc_MPI_Sum(double *sbuf, long count)
{
  if (!sbuf || count <= 0) return(MPI_SUCCESS); /* nothing to reduce */
  else {
    /* we must cut the buffer into blocks not exceeding the MPI max buffer size of 32000 */
    long   offset=0;
    double *rbuf=NULL;
    int    length=MPI_REDUCE_BLOCKSIZE; /* defined in mccode-r.h */
    int    i=0;
    rbuf = calloc(count, sizeof(double));
    if (!rbuf)
      exit(-fprintf(stderr, "Error: Out of memory %li (mc_MPI_Sum)\n", count*sizeof(double)));
    while (offset < count) {
      if (!length || offset+length > count-1) length=count-offset;
      else length=MPI_REDUCE_BLOCKSIZE;
      if (MPI_Reduce((double*)(sbuf+offset), (double*)(rbuf+offset),
              length, MPI_DOUBLE, MPI_SUM, 0, MPI_COMM_WORLD) != MPI_SUCCESS)
        return MPI_ERR_COUNT;
      offset += length;
    }

    for (i=0; i<count; i++) sbuf[i] = rbuf[i];
    free(rbuf);
  }
  return MPI_SUCCESS;
} /* mc_MPI_Sum */

/*******************************************************************************
* mc_MPI_Send: Send array to MPI node by blocks to avoid buffer limit
*******************************************************************************/
int mc_MPI_Send(void *sbuf,
                  long count, MPI_Datatype dtype,
                  int dest)
{
  int dsize;
  long offset=0;
  int  tag=1;
  int  length=MPI_REDUCE_BLOCKSIZE; /* defined in mccode-r.h */

  if (!sbuf || count <= 0) return(MPI_SUCCESS); /* nothing to send */
  MPI_Type_size(dtype, &dsize);

  while (offset < count) {
    if (offset+length > count-1) length=count-offset;
    else length=MPI_REDUCE_BLOCKSIZE;
    if (MPI_Send((void*)(sbuf+offset*dsize), length, dtype, dest, tag++, MPI_COMM_WORLD) != MPI_SUCCESS)
      return MPI_ERR_COUNT;
    offset += length;
  }

  return MPI_SUCCESS;
} /* mc_MPI_Send */

/*******************************************************************************
* mc_MPI_Recv: Receives arrays from MPI nodes by blocks to avoid buffer limit
*             the buffer must have been allocated previously.
*******************************************************************************/
int mc_MPI_Recv(void *sbuf,
                  long count, MPI_Datatype dtype,
                  int source)
{
  int dsize;
  long offset=0;
  int  tag=1;
  int  length=MPI_REDUCE_BLOCKSIZE; /* defined in mccode-r.h */

  if (!sbuf || count <= 0) return(MPI_SUCCESS); /* nothing to recv */
  MPI_Type_size(dtype, &dsize);

  while (offset < count) {
    if (offset+length > count-1) length=count-offset;
    else length=MPI_REDUCE_BLOCKSIZE;
    if (MPI_Recv((void*)(sbuf+offset*dsize), length, dtype, source, tag++,
            MPI_COMM_WORLD, MPI_STATUS_IGNORE) != MPI_SUCCESS)
      return MPI_ERR_COUNT;
    offset += length;
  }

  return MPI_SUCCESS;
} /* mc_MPI_Recv */

#endif /* USE_MPI */

/* SECTION: parameters handling ============================================= */

/* Instrument input parameter type handling. */
/*******************************************************************************
* mcparm_double: extract double value from 's' into 'vptr'
*******************************************************************************/
static int
mcparm_double(char *s, void *vptr)
{
  char *p;
  double *v = (double *)vptr;

  if (!s) { *v = 0; return(1); }
  *v = strtod(s, &p);
  if(*s == '\0' || (p != NULL && *p != '\0') || errno == ERANGE)
    return 0;                        /* Failed */
  else
    return 1;                        /* Success */
}

/*******************************************************************************
* mcparminfo_double: display parameter type double
*******************************************************************************/
static char *
mcparminfo_double(char *parmname)
{
  return "double";
}

/*******************************************************************************
* mcparmerror_double: display error message when failed extract double
*******************************************************************************/
static void
mcparmerror_double(char *parm, char *val)
{
  fprintf(stderr, "Error: Invalid value '%s' for floating point parameter %s (mcparmerror_double)\n",
          val, parm);
}

/*******************************************************************************
* mcparmprinter_double: convert double to string
*******************************************************************************/
static void
mcparmprinter_double(char *f, void *vptr)
{
  double *v = (double *)vptr;
  sprintf(f, "%g", *v);
}

/*******************************************************************************
* mcparm_int: extract int value from 's' into 'vptr'
*******************************************************************************/
static int
mcparm_int(char *s, void *vptr)
{
  char *p;
  int *v = (int *)vptr;
  long x;

  if (!s) { *v = 0; return(1); }
  *v = 0;
  x = strtol(s, &p, 10);
  if(x < INT_MIN || x > INT_MAX)
    return 0;                        /* Under/overflow */
  *v = x;
  if(*s == '\0' || (p != NULL && *p != '\0') || errno == ERANGE)
    return 0;                        /* Failed */
  else
    return 1;                        /* Success */
}

/*******************************************************************************
* mcparminfo_int: display parameter type int
*******************************************************************************/
static char *
mcparminfo_int(char *parmname)
{
  return "int";
}

/*******************************************************************************
* mcparmerror_int: display error message when failed extract int
*******************************************************************************/
static void
mcparmerror_int(char *parm, char *val)
{
  fprintf(stderr, "Error: Invalid value '%s' for integer parameter %s (mcparmerror_int)\n",
          val, parm);
}

/*******************************************************************************
* mcparmprinter_int: convert int to string
*******************************************************************************/
static void
mcparmprinter_int(char *f, void *vptr)
{
  int *v = (int *)vptr;
  sprintf(f, "%d", *v);
}

/*******************************************************************************
* mcparm_string: extract char* value from 's' into 'vptr' (copy)
*******************************************************************************/
static int
mcparm_string(char *s, void *vptr)
{
  char **v = (char **)vptr;
  if (!s) { *v = NULL; return(1); }
  *v = (char *)malloc(strlen(s) + 1);
  if(*v == NULL)
  {
    exit(-fprintf(stderr, "Error: Out of memory %li (mcparm_string).\n", (long)strlen(s) + 1));
  }
  strcpy(*v, s);
  return 1;                        /* Success */
}

/*******************************************************************************
* mcparminfo_string: display parameter type string
*******************************************************************************/
static char *
mcparminfo_string(char *parmname)
{
  return "string";
}

/*******************************************************************************
* mcparmerror_string: display error message when failed extract string
*******************************************************************************/
static void
mcparmerror_string(char *parm, char *val)
{
  fprintf(stderr, "Error: Invalid value '%s' for string parameter %s (mcparmerror_string)\n",
          val, parm);
}

/*******************************************************************************
* mcparmprinter_string: convert string to string (including esc chars)
*******************************************************************************/
static void
mcparmprinter_string(char *f, void *vptr)
{
  char **v = (char **)vptr;
  char *p;

  if (!*v) { *f='\0'; return; }
  strcpy(f, "");
  for(p = *v; *p != '\0'; p++)
  {
    switch(*p)
    {
      case '\n':
        strcat(f, "\\n");
        break;
      case '\r':
        strcat(f, "\\r");
        break;
      case '"':
        strcat(f, "\\\"");
        break;
      case '\\':
        strcat(f, "\\\\");
        break;
      default:
        strncat(f, p, 1);
    }
  }
  /* strcat(f, "\""); */
} /* mcparmprinter_string */

/* now we may define the parameter structure, using previous functions */
static struct
  {
    int (*getparm)(char *, void *);
    char * (*parminfo)(char *);
    void (*error)(char *, char *);
    void (*printer)(char *, void *);
} mcinputtypes[] = {
  {
    mcparm_double, mcparminfo_double, mcparmerror_double,
    mcparmprinter_double
  }, {
    mcparm_int, mcparminfo_int, mcparmerror_int,
    mcparmprinter_int
  }, {
    mcparm_string, mcparminfo_string, mcparmerror_string,
    mcparmprinter_string
  }
};

/*******************************************************************************
* mcestimate_error: compute sigma from N,p,p2 in Gaussian large numbers approx
*******************************************************************************/
double mcestimate_error(double N, double p1, double p2)
{
  double pmean, n1;
  if(N <= 1)
    return p1;
  pmean = p1 / N;
  n1 = N - 1;
  /* Note: underflow may cause p2 to become zero; the fabs() below guards
     against this. */
  return sqrt((N/n1)*fabs(p2 - pmean*pmean));
}

double (*mcestimate_error_p)
  (double V2, double psum, double p2sum)=mcestimate_error;

/* ========================================================================== */

/*                               MCCODE_R_IO_C                                */

/* ========================================================================== */

#ifndef MCCODE_R_IO_C
#define MCCODE_R_IO_C "$Revision$"

/* SECTION: file i/o handling ================================================ */

#ifndef HAVE_STRCASESTR
// from msysgit: https://code.google.com/p/msysgit/source/browse/compat/strcasestr.c
char *strcasestr(const char *haystack, const char *needle)
{
  int nlen = strlen(needle);
  int hlen = strlen(haystack) - nlen + 1;
  int i;

  for (i = 0; i < hlen; i++) {
    int j;
    for (j = 0; j < nlen; j++) {
            unsigned char c1 = haystack[i+j];
            unsigned char c2 = needle[j];
            if (toupper(c1) != toupper(c2))
                    goto next;
    }
    return (char *) haystack + i;
  next:
    ;
  }
  return NULL;
}


#endif
#ifndef HAVE_STRCASECMP
int strcasecmp( const char *s1, const char *s2 )
{
  int c1, c2;
  do {
    c1 = tolower( (unsigned char) *s1++ );
    c2 = tolower( (unsigned char) *s2++ );
  } while (c1 == c2 && c1 != 0);
  return c2 > c1 ? -1 : c1 > c2;
}
#endif

/*******************************************************************************
* mcfull_file: allocates a full file name=mcdirname+file. Catenate extension if missing.
*******************************************************************************/
char *mcfull_file(char *name, char *ext)
{
  int   dirlen=0;
  char *mem   =NULL;

  dirlen = mcdirname ? strlen(mcdirname) : 0;
  mem = (char*)malloc(dirlen + strlen(name) + CHAR_BUF_LENGTH);
  if(!mem) {
    exit(-fprintf(stderr, "Error: Out of memory %li (mcfull_file)\n", (long)(dirlen + strlen(name) + 256)));
  }
  strcpy(mem, "");

  /* prepend directory name to path if name does not contain a path */
  if (dirlen > 0 && !strchr(name, MC_PATHSEP_C)) {
    strcat(mem, mcdirname);
    strcat(mem, MC_PATHSEP_S);
  } /* dirlen */

  strcat(mem, name);
  if (!strchr(name, '.') && ext && strlen(ext))
  { /* add extension if not in file name already */
    strcat(mem, ".");
    strcat(mem, ext);
  }
  return(mem);
} /* mcfull_file */

/*******************************************************************************
* mcnew_file: opens a new file within mcdirname if non NULL
*             the file is opened in "a" (append, create if does not exist)
*             the extension 'ext' is added if the file name does not include one.
*             the last argument is set to 0 if file did not exist, else to 1.
*******************************************************************************/
FILE *mcnew_file(char *name, char *ext, int *exists)
{
  char *mem;
  FILE *file=NULL;

  if (!name || strlen(name) == 0 || mcdisable_output_files) return(NULL);
  
  mem  = mcfull_file(name, ext); /* create mcdirname/name.ext */
  
  /* check for existence */
  file = fopen(mem, "r"); /* for reading -> fails if does not exist */
  if (file) {
    fclose(file);
    *exists=1;
  } else
    *exists=0;
  
  /* open the file for writing/appending */
#ifdef USE_NEXUS
  if (mcformat && strcasestr(mcformat, "NeXus")) {
    /* NXhandle nxhandle is defined in the .h with USE_NEXUS */
    NXaccess mode = (*exists ? NXACC_CREATE5 | NXACC_RDWR : NXACC_CREATE5);
      
    if (NXopen(mem, mode, &nxhandle) != NX_OK)
      file = NULL;
    else
      file = (FILE*)&nxhandle; /* to make it non NULL */
  } else
#endif
    file = fopen(mem, "a+"); 
    
  if(!file)
    fprintf(stderr, "Warning: could not open output file '%s' for %s (mcnew_file)\n", 
      mem, *exists ? "append" : "create");
  free(mem);

  return file;
} /* mcnew_file */

/*******************************************************************************
* mcdetector_statistics: compute detector statistics, error bars, [x I I_err N] 1D
* RETURN:            updated detector structure
* Used by: mcdetector_import
*******************************************************************************/
MCDETECTOR mcdetector_statistics(
  MCDETECTOR detector)
{

  if (!detector.p1 || !detector.m)
    return(detector);
  
  /* compute statistics and update MCDETECTOR structure ===================== */
  double sum_z  = 0, min_z  = 0, max_z  = 0;
  double fmon_x =0,  smon_x = 0, fmon_y =0, smon_y=0, mean_z=0;
  double Nsum=0, P2sum=0;

  double sum_xz = 0, sum_yz = 0, sum_x = 0, sum_y = 0, sum_x2z = 0, sum_y2z = 0;
  int    i,j;
  char   hasnan=0, hasinf=0;
  char   israw = ((char*)strcasestr(detector.format,"raw") != NULL);
  double *this_p1=NULL; /* new 1D McCode array [x I E N]. Freed after writing data */

  /* if McCode/PGPLOT and rank==1 we create a new m*4 data block=[x I E N] */
  if (detector.rank == 1 && strcasestr(detector.format,"McCode")) {
    this_p1 = (double *)calloc(detector.m*detector.n*detector.p*4, sizeof(double));
    if (!this_p1)
      exit(-fprintf(stderr, "Error: Out of memory creating %li 1D " MCCODE_STRING " data set for file '%s' (mcdetector_import)\n",
        detector.m*detector.n*detector.p*4*sizeof(double*), detector.filename));
  }

  max_z = min_z = detector.p1[0];
  
  /* compute sum and moments (not for lists) */
  if (!strcasestr(detector.format,"list") && detector.m)
  for(j = 0; j < detector.n*detector.p; j++)
  {
    for(i = 0; i < detector.m; i++)
    {
      double x,y,z;
      double N, E;
      long   index= !detector.istransposed ? i*detector.n*detector.p + j : i+j*detector.m;
      char   hasnaninf=0;

      if (detector.m) 
        x = detector.xmin + (i + 0.5)/detector.m*(detector.xmax - detector.xmin); 
      else x = 0;
      if (detector.n && detector.p) 
        y = detector.ymin + (j + 0.5)/detector.n/detector.p*(detector.ymax - detector.ymin); 
      else y = 0;
      z = detector.p1[index];
      N = detector.p0 ? detector.p0[index] : 1;
      E = detector.p2 ? detector.p2[index] : 0;
      if (detector.p2 && !israw) 
        detector.p2[index] = (*mcestimate_error_p)(detector.p0[index],detector.p1[index],detector.p2[index]); /* set sigma */
      
      if (detector.rank == 1 && this_p1 && strcasestr(detector.format,"McCode")) {
        /* fill-in 1D McCode array [x I E N] */
        this_p1[index*4]   = x;
        this_p1[index*4+1] = z;
        this_p1[index*4+2] = detector.p2 ? detector.p2[index] : 0;
        this_p1[index*4+3] = N;
      }
      
      if (isnan(z) || isnan(E) || isnan(N)) hasnaninf=hasnan=1;
      if (isinf(z) || isinf(E) || isinf(N)) hasnaninf=hasinf=1;

      /* compute stats integrals */
      if (!hasnaninf) {
        sum_xz += x*z;
        sum_yz += y*z;
        sum_x  += x;
        sum_y  += y;
        sum_z  += z;
        sum_x2z += x*x*z;
        sum_y2z += y*y*z;
        if (z > max_z) max_z = z;
        if (z < min_z) min_z = z;

        Nsum += N;
        P2sum += E;
      }

    }
  } /* for j */

  /* compute 1st and 2nd moments. For lists, sum_z=0 so this is skipped. */
  if (sum_z && detector.n*detector.m*detector.p)
  {
    fmon_x = sum_xz/sum_z;
    fmon_y = sum_yz/sum_z;
    smon_x = sum_x2z/sum_z-fmon_x*fmon_x; smon_x = smon_x > 0 ? sqrt(smon_x) : 0;
    smon_y = sum_y2z/sum_z-fmon_y*fmon_y; smon_y = smon_y > 0 ? sqrt(smon_y) : 0;
    mean_z = sum_z/detector.n/detector.m/detector.p;
  }
  /* store statistics into detector */
  detector.intensity = sum_z;
  detector.error     = Nsum ? (*mcestimate_error_p)(Nsum, sum_z, P2sum) : 0;
  detector.events    = Nsum;
  detector.min       = min_z;
  detector.max       = max_z;
  detector.mean      = mean_z;
  detector.centerX   = fmon_x;
  detector.halfwidthX= smon_x;
  detector.centerY   = fmon_y;
  detector.halfwidthY= smon_y;

  /* if McCode/PGPLOT and rank==1 replace p1 with new m*4 1D McCode and clear others */
  if (detector.rank == 1 && this_p1 && strcasestr(detector.format,"McCode")) {
    
    detector.p1 = this_p1;
    detector.n  = detector.m; detector.m  = 4;
    detector.p0 = detector.p2 = NULL;
    detector.istransposed = 1;
  }

  if (detector.n*detector.m*detector.p > 1)
    snprintf(detector.signal, CHAR_BUF_LENGTH, 
      "Min=%g; Max=%g; Mean=%g;", detector.min, detector.max, detector.mean);
  else
    strcpy(detector.signal, "None");
  snprintf(detector.values, CHAR_BUF_LENGTH,
    "%g %g %g", detector.intensity, detector.error, detector.events);

  switch (detector.rank) {
    case 1:  snprintf(detector.statistics, CHAR_BUF_LENGTH, "X0=%g; dX=%g;",
      detector.centerX, detector.halfwidthX); break;
    case 2:
    case 3:  snprintf(detector.statistics, CHAR_BUF_LENGTH, "X0=%g; dX=%g; Y0=%g; dY=%g;",
      detector.centerX, detector.halfwidthX, detector.centerY, detector.halfwidthY);
      break;
    default: strcpy(detector.statistics, "None");
  }
  
  if (hasnan)
    printf("WARNING: Nan detected in component/file %s %s\n", 
      detector.component, strlen(detector.filename) ? detector.filename : "");
  if (hasinf)
    printf("WARNING: Inf detected in component/file %s %s\n", 
      detector.component, strlen(detector.filename) ? detector.filename : "");
  
  return(detector);
  
} /* mcdetector_statistics */

/*******************************************************************************
* mcdetector_import: build detector structure, merge non-lists from MPI
*                    compute basic stat, write "Detector:" line
* RETURN:            detector structure. Invalid data if detector.p1 == NULL
*                    Invalid detector sets m=0 and filename=""
*                    Simulation data  sets m=0 and filename=mcsiminfo_name
* This function is equivalent to the old 'mcdetector_out', returning a structure
*******************************************************************************/
MCDETECTOR mcdetector_import(
  char *format,
  char *component, char *title,
  long m, long n,  long p,
  char *xlabel, char *ylabel, char *zlabel,
  char *xvar, char *yvar, char *zvar,
  double x1, double x2, double y1, double y2, double z1, double z2,
  char *filename,
  double *p0, double *p1, double *p2,
  Coords position)
{
  time_t t;       /* for detector.date */
  long   date_l;  /* date as a long number */
  char   istransposed=0;
  char   c[CHAR_BUF_LENGTH]; /* temp var for signal label */

  MCDETECTOR detector;

  /* build MCDETECTOR structure ============================================= */
  /* make sure we do not have NULL for char fields */

  /* these also apply to simfile */
  strncpy (detector.filename,  filename ? filename : "",        CHAR_BUF_LENGTH);
  strncpy (detector.format,    format   ? format   : "McCode" , CHAR_BUF_LENGTH);
  /* add extension if missing */
  if (strlen(detector.filename) && !strchr(detector.filename, '.'))
  { /* add extension if not in file name already */
    strcat(detector.filename, ".dat");
  }
  strncpy (detector.component, component ? component : MCCODE_STRING " component", CHAR_BUF_LENGTH);

  snprintf(detector.instrument, CHAR_BUF_LENGTH, "%s (%s)", mcinstrument_name, mcinstrument_source);
  snprintf(detector.user, CHAR_BUF_LENGTH,      "%s on %s",
        getenv("USER") ? getenv("USER") : MCCODE_NAME,
        getenv("HOST") ? getenv("HOST") : "localhost");
  time(&t);         /* get current write time */
  date_l = (long)t; /* same but as a long */
  snprintf(detector.date, CHAR_BUF_LENGTH, "%s", ctime(&t));
  if (strlen(detector.date))   detector.date[strlen(detector.date)-1] = '\0'; /* remove last \n in date */
  detector.date_l = date_l;

  if (!mcget_run_num() || mcget_run_num() >= mcget_ncount())
    snprintf(detector.ncount, CHAR_BUF_LENGTH, "%llu", mcget_ncount()
#ifdef USE_MPI
*mpi_node_count
#endif
  );
  else
    snprintf(detector.ncount, CHAR_BUF_LENGTH, "%g/%g", (double)mcget_run_num(), (double)mcget_ncount());

  detector.p0         = p0;
  detector.p1         = p1;
  detector.p2         = p2;

  /* handle transposition (not for NeXus) */
  if (!strcasestr(detector.format, "NeXus")) {
    if (m<0 || n<0 || p<0)             istransposed = !istransposed;
    if (strcasestr(detector.format, "transpose")) istransposed = !istransposed;
    if (istransposed) { /* do the swap once for all */
      long i=m; m=n; n=i;
    }
  }

  m=labs(m); n=labs(n); p=labs(p); /* make sure dimensions are positive */
  detector.istransposed = istransposed;

  /* determine detector rank (dimensionality) */
  if (!m || !n || !p || !p1) detector.rank = 4; /* invalid: exit with m=0 filename="" */
  else if (m*n*p == 1)       detector.rank = 0; /* 0D */
  else if (n == 1 || m == 1) detector.rank = 1; /* 1D */
  else if (p == 1)           detector.rank = 2; /* 2D */
  else                       detector.rank = 3; /* 3D */

  /* from rank, set type */
  switch (detector.rank) {
    case 0:  strcpy(detector.type,  "array_0d"); m=n=p=1; break;
    case 1:  snprintf(detector.type, CHAR_BUF_LENGTH, "array_1d(%ld)", m*n*p); m *= n*p; n=p=1; break;
    case 2:  snprintf(detector.type, CHAR_BUF_LENGTH, "array_2d(%ld, %ld)", m, n*p); n *= p; p=1; break;
    case 3:  snprintf(detector.type, CHAR_BUF_LENGTH, "array_3d(%ld, %ld, %ld)", m, n, p); break;
    default: m=0; strcpy(detector.type, ""); strcpy(detector.filename, "");/* invalid */
  }

  detector.m    = m;
  detector.n    = n;
  detector.p    = p;

  /* these only apply to detector files ===================================== */

  snprintf(detector.position, CHAR_BUF_LENGTH, "%g %g %g", position.x, position.y, position.z);
  /* may also store actual detector orientation in the future */

  strncpy(detector.title,      title && strlen(title) ? title : component,       CHAR_BUF_LENGTH);
  strncpy(detector.xlabel,     xlabel && strlen(xlabel) ? xlabel : "X", CHAR_BUF_LENGTH); /* axis labels */
  strncpy(detector.ylabel,     ylabel && strlen(ylabel) ? ylabel : "Y", CHAR_BUF_LENGTH);
  strncpy(detector.zlabel,     zlabel && strlen(zlabel) ? zlabel : "Z", CHAR_BUF_LENGTH);
  strncpy(detector.xvar,       xvar && strlen(xvar) ? xvar :       "x", CHAR_BUF_LENGTH); /* axis variables */
  strncpy(detector.yvar,       yvar && strlen(yvar) ? yvar :       detector.xvar, CHAR_BUF_LENGTH);
  strncpy(detector.zvar,       zvar && strlen(zvar) ? zvar :       detector.yvar, CHAR_BUF_LENGTH);

  /* set "variables" as e.g. "I I_err N" */
  strcpy(c, "I ");
  if (strlen(detector.zvar))      strncpy(c, detector.zvar,32);
  else if (strlen(detector.yvar)) strncpy(c, detector.yvar,32);
  else if (strlen(detector.xvar)) strncpy(c, detector.xvar,32);

  if (detector.rank == 1)
    snprintf(detector.variables, CHAR_BUF_LENGTH, "%s %s %s_err N", detector.xvar, c, c);
  else
    snprintf(detector.variables, CHAR_BUF_LENGTH, "%s %s_err N", c, c);

  /* limits */
  detector.xmin = x1;
  detector.xmax = x2;
  detector.ymin = y1;
  detector.ymax = y2;
  detector.zmin = z1;
  detector.zmax = z2;
  if (abs(detector.rank) == 1)
    snprintf(detector.limits, CHAR_BUF_LENGTH, "%g %g", x1, x2);
  else if (detector.rank == 2)
    snprintf(detector.limits, CHAR_BUF_LENGTH, "%g %g %g %g", x1, x2, y1, y2);
  else
    snprintf(detector.limits, CHAR_BUF_LENGTH, "%g %g %g %g %g %g", x1, x2, y1, y2, z1, z2);

  /* if MPI and nodes_nb > 1: reduce data sets when using MPI =============== */
#ifdef USE_MPI
  if (!strcasestr(detector.format,"list") && mpi_node_count > 1 && m) {
    /* we save additive data: reduce everything into mpi_node_root */
    if (p0) mc_MPI_Sum(p0, m*n*p);
    if (p1) mc_MPI_Sum(p1, m*n*p);
    if (p2) mc_MPI_Sum(p2, m*n*p);
    if (!p0) {  /* additive signal must be then divided by the number of nodes */
      int i;
      for (i=0; i<m*n*p; i++) {
        p1[i] /= mpi_node_count;
        if (p2) p2[i] /= mpi_node_count;
      }
    }
  }
#endif /* USE_MPI */

  /* compute statistics, Nsum, intensity, Error bars */
  detector = mcdetector_statistics(detector);

#ifdef USE_MPI
  /* slaves are done */
  if(mpi_node_rank != mpi_node_root) {
    return detector;
  }
#endif

  /* output "Detector:" line ================================================ */
  /* when this is a detector written by a component (not the SAVE from instrument),
     not an event lists */
  if (!m) return(detector);
  if (!strcasestr(detector.format,"list")) {
    if (!strcmp(detector.component, mcinstrument_name)) {
      if (strlen(detector.filename))  /* we name it from its filename, or from its title */
        strncpy(c, detector.filename, CHAR_BUF_LENGTH);
      else
        snprintf(c, CHAR_BUF_LENGTH, "%s", mcinstrument_name);
    } else
      strncpy(c, detector.component, CHAR_BUF_LENGTH);  /* usual detectors written by components */

    printf("Detector: %s_I=%g %s_ERR=%g %s_N=%g",
           c, detector.intensity,
           c, detector.error,
           c, detector.events);
    printf(" \"%s\"\n", strlen(detector.filename) ? detector.filename : detector.component);
  }
  

  return(detector);
} /* mcdetector_import */

/* end MCDETECTOR import section ============================================ */

















/* ========================================================================== */

/*                               ASCII output                                 */
/*     The SIM file is YAML based, the data files have '#' headers            */

/* ========================================================================== */


/*******************************************************************************
* mcinfo_out: output instrument tags/info (only in SIM)
* Used in: mcsiminfo_init (ascii), mcinfo(stdout)
*******************************************************************************/
static void mcinfo_out(char *pre, FILE *f)
{
  char Parameters[CHAR_BUF_LENGTH] = "";
  int  i;

  if (!f || mcdisable_output_files) return;

  /* create parameter string ================================================ */
  for(i = 0; i < mcnumipar; i++)
  {
    char ThisParam[CHAR_BUF_LENGTH];
    if (strlen(mcinputtable[i].name) > CHAR_BUF_LENGTH) break;
    snprintf(ThisParam, CHAR_BUF_LENGTH, " %s(%s)", mcinputtable[i].name,
            (*mcinputtypes[mcinputtable[i].type].parminfo)
                (mcinputtable[i].name));
    strcat(Parameters, ThisParam);
    if (strlen(Parameters) >= CHAR_BUF_LENGTH-64) break;
  }

  /* output data ============================================================ */
  if (f != stdout)
    fprintf(f, "%sFile: %s%c%s\n",    pre, mcdirname, MC_PATHSEP_C, mcsiminfo_name);
  else
    fprintf(f, "%sCreator: %s\n",     pre, MCCODE_STRING);

  fprintf(f, "%sSource: %s\n",   pre, mcinstrument_source);
  fprintf(f, "%sParameters: %s\n",    pre, Parameters);
  
  fprintf(f, "%sTrace_enabled: %s\n", pre, mctraceenabled ? "yes" : "no");
  fprintf(f, "%sDefault_main: %s\n",  pre, mcdefaultmain ?  "yes" : "no");
  fprintf(f, "%sEmbedded_runtime: %s\n", pre, 
#ifdef MC_EMBEDDED_RUNTIME
         "yes"
#else
         "no"
#endif
         );

  fflush(f);
} /* mcinfo_out */

/*******************************************************************************
* mcruninfo_out_backend: output simulation tags/info (both in SIM and data files)
* Used in: mcsiminfo_init (ascii case), mcdetector_out_xD_ascii, mcinfo(stdout)
*******************************************************************************/
static void mcruninfo_out_backend(char *pre, FILE *f, int info)
{
  int i;
  char Parameters[CHAR_BUF_LENGTH];

  if (!f || mcdisable_output_files) return;

  fprintf(f, "%sFormat: %s%s\n",      pre, 
    mcformat && strlen(mcformat) ? mcformat : MCCODE_NAME,
    mcformat && strcasestr(mcformat,"McCode") ? " with text headers" : "");
  fprintf(f, "%sURL: %s\n",         pre, "http://www.mccode.org");
  fprintf(f, "%sCreator: %s\n",     pre, MCCODE_STRING);
  fprintf(f, "%sInstrument: %s\n", pre, mcinstrument_source);
  fprintf(f, "%sNcount: %llu\n",        pre, mcget_ncount());
  fprintf(f, "%sTrace: %s\n",       pre, mcdotrace ? "yes" : "no");
  fprintf(f, "%sGravitation: %s\n", pre, mcgravitation ? "yes" : "no");
  snprintf(Parameters, CHAR_BUF_LENGTH, "%ld", mcseed);
  fprintf(f, "%sSeed: %s\n",        pre, Parameters);
  fprintf(f, "%sDirectory: %s\n",        pre, mcdirname ? mcdirname : ".");
#ifdef USE_MPI
  if (mpi_node_count > 1)
    fprintf(f, "%sNodes: %i\n",        pre, mpi_node_count);
#endif

  /* output parameter string ================================================ */
  for(i = 0; i < mcnumipar; i++) {
      if (!info){
          (*mcinputtypes[mcinputtable[i].type].printer)(Parameters, mcinputtable[i].par);
          fprintf(f, "%sParam: %s=%s\n", pre, mcinputtable[i].name, Parameters);
      }else{
        /*if an info run, some variables might not have values. Flag these by "NULL"*/
	if(mcinputtable[i].val && strlen(mcinputtable[i].val)){
            /* ... those with defautl values*/
            (*mcinputtypes[mcinputtable[i].type].printer)(Parameters, mcinputtable[i].par);
            fprintf(f, "%sParam: %s=%s\n", pre, mcinputtable[i].name, Parameters);
        }else{
            /* ... and those without */
            fprintf(f, "%sParam: %s=NULL\n", pre, mcinputtable[i].name);
	}
      }
  }
} /* mcruninfo_out_backend */

/************************
* wrapper function to mcruninfo_out_backend
*  Regular runs use this whereas the single call from mcinfo is directly to the backend
*************************/
static void mcruninfo_out(char *pre, FILE *f){
    mcruninfo_out_backend(pre,f,0);
}

/*******************************************************************************
* mcsiminfo_out:    wrapper to fprintf(mcsiminfo_file)
*******************************************************************************/
void mcsiminfo_out(char *format, ...)
{
  va_list ap;

  if(mcsiminfo_file && !mcdisable_output_files)
  {
    va_start(ap, format);
    vfprintf(mcsiminfo_file, format, ap);
    va_end(ap);
  }
} /* mcsiminfo_out */


/*******************************************************************************
* mcdatainfo_out: output detector header
*   mcdatainfo_out(prefix, file_handle, detector) writes info to data file
*******************************************************************************/
static void
mcdatainfo_out(char *pre, FILE *f, MCDETECTOR detector)
{
  if (!f || !detector.m || mcdisable_output_files) return;
  
  /* output data ============================================================ */
  fprintf(f, "%sDate: %s (%li)\n",       pre, detector.date, detector.date_l);
  fprintf(f, "%stype: %s\n",       pre, detector.type);
  fprintf(f, "%sSource: %s\n",     pre, detector.instrument);
  fprintf(f, "%scomponent: %s\n",  pre, detector.component);
  fprintf(f, "%sposition: %s\n",   pre, detector.position);

  fprintf(f, "%stitle: %s\n",      pre, detector.title);
  fprintf(f, !mcget_run_num() || mcget_run_num() >= mcget_ncount() ?
             "%sNcount: %s\n" : 
             "%sratio: %s\n",  pre, detector.ncount);

  if (strlen(detector.filename)) {
    fprintf(f, "%sfilename: %s\n", pre, detector.filename);
  }

  fprintf(f, "%sstatistics: %s\n", pre, detector.statistics);
  fprintf(f, "%ssignal: %s\n",     pre, detector.signal);
  fprintf(f, "%svalues: %s\n",     pre, detector.values);

  if (detector.rank >= 1)
  {
    fprintf(f, "%sxvar: %s\n",     pre, detector.xvar);
    fprintf(f, "%syvar: %s\n",     pre, detector.yvar);
    fprintf(f, "%sxlabel: %s\n",   pre, detector.xlabel);
    fprintf(f, "%sylabel: %s\n",   pre, detector.ylabel);
    if (detector.rank > 1) {
      fprintf(f, "%szvar: %s\n",   pre, detector.zvar);
      fprintf(f, "%szlabel: %s\n", pre, detector.zlabel);
    }
  }

  fprintf(f, 
    abs(detector.rank)==1 ?
             "%sxlimits: %s\n" : 
             "%sxylimits: %s\n", pre, detector.limits);
  fprintf(f, "%svariables: %s\n", pre, 
    strcasestr(detector.format, "list") ? detector.ylabel : detector.variables);
    
  fflush(f);

} /* mcdatainfo_out */

/* mcdetector_out_array_ascii: output a single array to a file
 *   m: columns
 *   n: rows
 *   p: array
 *   f: file handle (already opened)
 */
static void mcdetector_out_array_ascii(long m, long n, double *p, FILE *f, char istransposed)
{
  if(f)
  {
    int i,j;
    for(j = 0; j < n; j++)
    {
      for(i = 0; i < m; i++)
      {
          fprintf(f, "%.10g ", p[!istransposed ? i*n + j : j*m+i]);
      }
      fprintf(f,"\n");
    }
  }
} /* mcdetector_out_array_ascii */

/*******************************************************************************
* mcdetector_out_0D_ascii: called by mcdetector_out_0D for ascii output
*******************************************************************************/
MCDETECTOR mcdetector_out_0D_ascii(MCDETECTOR detector)
{
  int exists=0;
  FILE *outfile = NULL;
  
  /* Write data set information to simulation description file. */
  MPI_MASTER(
    mcsiminfo_out("\nbegin data\n"); // detector.component
    mcdatainfo_out("  ", mcsiminfo_file, detector);
    mcsiminfo_out("end data\n");
    /* Don't write if filename is NULL: mcnew_file handles this (return NULL) */
    outfile = mcnew_file(detector.component, "dat", &exists);
    if(outfile)
    {
      /* write data file header and entry in simulation description file */
      mcruninfo_out( "# ", outfile);
      mcdatainfo_out("# ", outfile, detector);
      /* write I I_err N */
      fprintf(outfile, "%g %g %g\n", 
        detector.intensity, detector.error, detector.events);
      fclose(outfile);
    }
  ); /* MPI_MASTER */
  return(detector);
} /* mcdetector_out_0D_ascii */

/*******************************************************************************
* mcdetector_out_1D_ascii: called by mcdetector_out_1D for ascii output
*******************************************************************************/
MCDETECTOR mcdetector_out_1D_ascii(MCDETECTOR detector)
{
  int exists=0;
  FILE *outfile = NULL;

  MPI_MASTER(
    /* Write data set information to simulation description file. */
    mcsiminfo_out("\nbegin data\n"); // detector.filename
    mcdatainfo_out("  ", mcsiminfo_file, detector);
    mcsiminfo_out("end data\n");
    /* Loop over array elements, writing to file. */
    /* Don't write if filename is NULL: mcnew_file handles this (return NULL) */
    outfile = mcnew_file(detector.filename, "dat", &exists);
    if(outfile)
    {
      /* write data file header and entry in simulation description file */
      mcruninfo_out( "# ", outfile);
      mcdatainfo_out("# ", outfile, detector);
      /* output the 1D array columns */
      mcdetector_out_array_ascii(detector.m, detector.n, detector.p1, outfile, detector.istransposed);
      
      fclose(outfile);
    }
  ); /* MPI_MASTER */
  return(detector);
  
}  /* mcdetector_out_1D_ascii */

/*******************************************************************************
* mcdetector_out_2D_ascii: called by mcdetector_out_2D for ascii output
*******************************************************************************/
MCDETECTOR mcdetector_out_2D_ascii(MCDETECTOR detector)
{
  int exists=0;
  FILE *outfile = NULL;
  
  MPI_MASTER(
    /* Loop over array elements, writing to file. */
    /* Don't write if filename is NULL: mcnew_file handles this (return NULL) */
    outfile = mcnew_file(detector.filename, "dat", &exists);
    if(outfile)
    {
      /* write header only if file has just been created (not appending) */
      if (!exists) {
        /* Write data set information to simulation description file. */
        mcsiminfo_out("\nbegin data\n"); // detector.filename
        mcdatainfo_out("  ", mcsiminfo_file, detector);
        mcsiminfo_out("end data\n");
      
        mcruninfo_out( "# ", outfile);
        mcdatainfo_out("# ", outfile,   detector);
      }
      fprintf(outfile, "# Data [%s/%s] %s:\n", detector.component, detector.filename, detector.zvar);
      mcdetector_out_array_ascii(detector.m, detector.n*detector.p, detector.p1, 
        outfile, detector.istransposed);
      if (detector.p2) {
        fprintf(outfile, "# Errors [%s/%s] %s_err:\n", detector.component, detector.filename, detector.zvar);
        mcdetector_out_array_ascii(detector.m, detector.n*detector.p, detector.p2, 
          outfile, detector.istransposed);
      }
      if (detector.p0) {
        fprintf(outfile, "# Events [%s/%s] N:\n", detector.component, detector.filename);
        mcdetector_out_array_ascii(detector.m, detector.n*detector.p, detector.p0, 
          outfile, detector.istransposed);
      }
      fclose(outfile);
      
      if (!exists) {
        if (strcasestr(detector.format, "list"))
          printf("Events:   \"%s\"\n",  
            strlen(detector.filename) ? detector.filename : detector.component);
      }
    } /* if outfile */
  ); /* MPI_MASTER */
#ifdef USE_MPI
  if (strcasestr(detector.format, "list") && mpi_node_count > 1) {
    int node_i=0;
    /* loop along MPI nodes to write sequentially */
    for(node_i=0; node_i<mpi_node_count; node_i++) {
      /* MPI: slaves wait for the master to write its block, then append theirs */
      MPI_Barrier(MPI_COMM_WORLD);
      if (node_i != mpi_node_root && node_i == mpi_node_rank) {
        if(strlen(detector.filename) && !mcdisable_output_files)	/* Don't write if filename is NULL */
          outfile = mcnew_file(detector.filename, "dat", &exists);
        if (!exists)
          fprintf(stderr, "Warning: [MPI node %i] file '%s' does not exist yet, "
                          "MASTER should have opened it before.\n",
            mpi_node_rank, detector.filename);
        if(outfile) {
          mcdetector_out_array_ascii(detector.m, detector.n*detector.p, detector.p1, 
            outfile, detector.istransposed);
          fclose(outfile);
        }
      }
    }
  } /* if strcasestr list */
#endif
  return(detector);
} /* mcdetector_out_2D_ascii */

/*******************************************************************************
* strcpy_valid: makes a valid string for variable names.
*   copy 'original' into 'valid', replacing invalid characters by '_'
*   char arrays must be pre-allocated
*******************************************************************************/
static char *strcpy_valid(char *valid, char *original)
{
  long i;
  int  n=32; /* max length of valid names */

  if (original == NULL || !strlen(original)) return(NULL);

  if (n > strlen(original)) n = strlen(original);
  else original += strlen(original)-n;
  strncpy(valid, original, n);

  for (i=0; i < n; i++)
  {
    if ( (valid[i] > 122)
      || (valid[i] < 32)
      || (strchr("!\"#$%&'()*+,-.:;<=>?@[\\]^`/ \n\r\t", valid[i]) != NULL) )
    {
      if (i) valid[i] = '_'; else valid[i] = 'm';
    }
  }
  valid[i] = '\0';

  return(valid);
} /* strcpy_valid */

/* end ascii output section ================================================= */







#ifdef USE_NEXUS

/* ========================================================================== */

/*                               NeXus output                                 */

/* ========================================================================== */

#define nxprintf(...)    nxstr('d', __VA_ARGS__)
#define nxprintattr(...) nxstr('a', __VA_ARGS__)

/*******************************************************************************
* nxstr: output a tag=value data set (char) in NeXus/current group
*   when 'format' is larger that 1024 chars it is used as value for the 'tag'
*   else the value is assembled with format and following arguments.
*   type='d' -> data set
*        'a' -> attribute for current data set
*******************************************************************************/
static int nxstr(char type, NXhandle *f, char *tag, char *format, ...)
{
  va_list ap;
  char value[CHAR_BUF_LENGTH];
  int  i;
  int  ret=NX_OK;
  
  if (!tag || !format || !strlen(tag) || !strlen(format)) return(NX_OK);
  
  /* assemble the value string */
  if (strlen(format) < CHAR_BUF_LENGTH) {
    va_start(ap, format);
    ret = vsnprintf(value, CHAR_BUF_LENGTH, format, ap);
    va_end(ap);
  
    i = strlen(value);
  } else {
    i = strlen(format);
  }

  if (type == 'd') {
    /* open/put/close data set */
    if (NXmakedata (f, tag, NX_CHAR, 1, &i) != NX_OK) return(NX_ERROR);
    NXopendata (f, tag);
    if (strlen(format) < CHAR_BUF_LENGTH)
      ret = NXputdata  (f, value);
    else
      ret = NXputdata  (f, format);
    NXclosedata(f);
  } else {
    if (strlen(format) < CHAR_BUF_LENGTH)
      ret = NXputattr  (f, tag, value, strlen(value), NX_CHAR);
    else
      ret = NXputattr  (f, tag, format, strlen(format), NX_CHAR);
  }
  
  return(ret);
  
} /* nxstr */

/*******************************************************************************
* mcinfo_readfile: read a full file into a string buffer which is allocated
*   Think to free the buffer after use.
* Used in: mcinfo_out_nexus (nexus)
*******************************************************************************/
char *mcinfo_readfile(char *filename)
{
  FILE *f = fopen(filename, "rb");
  if (!f) return(NULL);
  fseek(f, 0, SEEK_END);
  long fsize = ftell(f);
  rewind(f);
  char *string = malloc(fsize + 1);
  if (string) {
    int n = fread(string, fsize, 1, f);
    fclose(f);

    string[fsize] = 0;
  }
  return(string);
}

/*******************************************************************************
* mcinfo_out: output instrument/simulation groups in NeXus file
* Used in: mcsiminfo_init (nexus)
*******************************************************************************/
static void mcinfo_out_nexus(NXhandle f)
{
  FILE  *fid;     /* for intrument source code/C/IDF */
  char  *buffer=NULL;
  time_t t     =time(NULL); /* for date */
  char   entry0[CHAR_BUF_LENGTH];
  int    count=0;
  char   name[CHAR_BUF_LENGTH];
  char   class[CHAR_BUF_LENGTH];
  
  if (!f || mcdisable_output_files) return;
  
  /* write NeXus NXroot attributes */
  /* automatically added: file_name, HDF5_Version, file_time, NeXus_version */ 
  nxprintattr(f, "creator",   "%s generated with " MCCODE_STRING, mcinstrument_name);
  
  /* count the number of existing NXentry and create the next one */
  NXgetgroupinfo(f, &count, name, class);
  sprintf(entry0, "entry%i", count+1);

  /* create the main NXentry (mandatory in NeXus) */
  if (NXmakegroup(f, entry0, "NXentry") == NX_OK) 
  if (NXopengroup(f, entry0, "NXentry") == NX_OK) {
    
    nxprintf(nxhandle, "program_name", MCCODE_STRING);
    nxprintf(f, "start_time", ctime(&t));
    nxprintf(f, "title", "%s%s%s simulation generated by instrument %s", 
      mcdirname && strlen(mcdirname) ? mcdirname : ".", MC_PATHSEP_S, mcsiminfo_name,
      mcinstrument_name);
    nxprintattr(f, "program_name", MCCODE_STRING);
    nxprintattr(f, "instrument",   mcinstrument_name);
    nxprintattr(f, "simulation",   "%s%s%s",
        mcdirname && strlen(mcdirname) ? mcdirname : ".", MC_PATHSEP_S, mcsiminfo_name);

    /* write NeXus instrument group */
    if (NXmakegroup(f, "instrument", "NXinstrument") == NX_OK)
    if (NXopengroup(f, "instrument", "NXinstrument") == NX_OK) {
      int   i;
      char *string=NULL;

      /* write NeXus parameters(types) data =================================== */
      string = (char*)malloc(CHAR_BUF_LENGTH);
      if (string) {
        strcpy(string, "");
        for(i = 0; i < mcnumipar; i++)
        {
          char ThisParam[CHAR_BUF_LENGTH];
          snprintf(ThisParam, CHAR_BUF_LENGTH, " %s(%s)", mcinputtable[i].name,
                  (*mcinputtypes[mcinputtable[i].type].parminfo)
                      (mcinputtable[i].name));
          if (strlen(string) + strlen(ThisParam) < CHAR_BUF_LENGTH)
            strcat(string, ThisParam);
        }
        nxprintattr(f, "Parameters",    string);
        free(string);
      }
        
      nxprintattr(f, "name",          mcinstrument_name);
      nxprintf   (f, "name",          mcinstrument_name);
      nxprintattr(f, "Source",        mcinstrument_source);
      
      nxprintattr(f, "Trace_enabled", mctraceenabled ? "yes" : "no");
      nxprintattr(f, "Default_main",  mcdefaultmain ?  "yes" : "no");
      nxprintattr(f, "Embedded_runtime",  
  #ifdef MC_EMBEDDED_RUNTIME
           "yes"
  #else
           "no"
  #endif
           );
           
      /* add instrument source code when available */
      buffer = mcinfo_readfile(mcinstrument_source);
      if (buffer && strlen(buffer)) {
        long length=strlen(buffer);
        nxprintf (f, "description", buffer);
        NXopendata(f,"description");
        nxprintattr(f, "file_name", mcinstrument_source);
        nxprintattr(f, "file_size", "%li", length);
        nxprintattr(f, "MCCODE_STRING", MCCODE_STRING);
        NXclosedata(f);
        nxprintf (f,"instrument_source", "%s " MCCODE_NAME " " MCCODE_PARTICLE " Monte Carlo simulation", mcinstrument_name);
        free(buffer);
      } else
        nxprintf (f, "description", "File %s not found (instrument description %s is missing)", 
          mcinstrument_source, mcinstrument_name);
      
      /* add Mantid/IDF.xml when available */
      char *IDFfile=NULL;
      IDFfile = (char*)malloc(CHAR_BUF_LENGTH);
      sprintf(IDFfile,"%s%s",mcinstrument_source,".xml");
      buffer = mcinfo_readfile(IDFfile);
      if (buffer && strlen(buffer)) {
        NXmakegroup (nxhandle, "instrument_xml", "NXnote");
        NXopengroup (nxhandle, "instrument_xml", "NXnote");
        nxprintf(f, "data", buffer);
        nxprintf(f, "description", "IDF.xml file found with instrument %s", mcinstrument_source);
        nxprintf(f, "type", "text/xml");
        NXclosegroup(f); /* instrument_xml */
        free(buffer);
      }
      free(IDFfile);
      NXclosegroup(f); /* instrument */
    } /* NXinstrument */

    /* write NeXus simulation group */
    if (NXmakegroup(f, "simulation", "NXnote") == NX_OK)
    if (NXopengroup(f, "simulation", "NXnote") == NX_OK) {

      nxprintattr(f, "name",   "%s%s%s",
        mcdirname && strlen(mcdirname) ? mcdirname : ".", MC_PATHSEP_S, mcsiminfo_name);
      
      nxprintf   (f, "name",      "%s",     mcsiminfo_name);
      nxprintattr(f, "Format",    mcformat && strlen(mcformat) ? mcformat : MCCODE_NAME);
      nxprintattr(f, "URL",       "http://www.mccode.org");
      nxprintattr(f, "program",   MCCODE_STRING);
      nxprintattr(f, "Instrument",mcinstrument_source);
      nxprintattr(f, "Trace",     mcdotrace ?     "yes" : "no");
      nxprintattr(f, "Gravitation",mcgravitation ? "yes" : "no");
      nxprintattr(f, "Seed",      "%li", mcseed);
      nxprintattr(f, "Directory", mcdirname);
    #ifdef USE_MPI
      if (mpi_node_count > 1)
        nxprintf(f, "Nodes", "%i",        mpi_node_count);
    #endif
    
      /* output parameter string ================================================ */
      if (NXmakegroup(f, "Param", "NXparameters") == NX_OK)
      if (NXopengroup(f, "Param", "NXparameters") == NX_OK) {
        int i;
        char string[CHAR_BUF_LENGTH];
        for(i = 0; i < mcnumipar; i++) {
          if (mcget_run_num() || (mcinputtable[i].val && strlen(mcinputtable[i].val))) {
            if (mcinputtable[i].par == NULL)
              strncpy(string, (mcinputtable[i].val ? mcinputtable[i].val : ""), CHAR_BUF_LENGTH);
            else
              (*mcinputtypes[mcinputtable[i].type].printer)(string, mcinputtable[i].par);

            nxprintf(f,  mcinputtable[i].name, "%s", string);
            nxprintattr(f, mcinputtable[i].name, string);
          }
        }
        NXclosegroup(f); /* Param */
      } /* NXparameters */
      
      NXclosegroup(f); /* simulation */
    } /* NXsimulation */
    
    /* create a group to hold all monitors */
    NXmakegroup(f, "data", "NXdetector");

    /* leave the NXentry opened (closed at exit) */
  } /* NXentry */
} /* mcinfo_out_nexus */

/*******************************************************************************
* mcdatainfo_out_nexus: output detector header
*   mcdatainfo_out_nexus(detector) create group and write info to NeXus data file
*   open data:NXdetector then filename:NXdata and write headers/attributes
*   requires: NXentry to be opened
*******************************************************************************/
static void
mcdatainfo_out_nexus(NXhandle f, MCDETECTOR detector)
{
  char data_name[32];
  if (!f || !detector.m || mcdisable_output_files) return;
  
  strcpy_valid(data_name, 
    detector.filename && strlen(detector.filename) ? 
      detector.filename : detector.component);

  /* the NXdetector group has been created in mcinfo_out_nexus (mcsiminfo_init) */
  if (NXopengroup(f, "data", "NXdetector") == NX_OK) {

    /* create and open the data group */
    /* this may fail when appending to list -> ignore/skip */
    NXMDisableErrorReporting(); /* unactivate NeXus error messages, as creation may fail */
    
    if (NXmakegroup(f, data_name, "NXdata") == NX_OK)
    if (NXopengroup(f, data_name, "NXdata") == NX_OK) {
    
      /* output metadata (as attributes) ======================================== */
      nxprintattr(f, "Date",       detector.date);
      nxprintattr(f, "type",       detector.type);
      nxprintattr(f, "Source",     detector.instrument);
      nxprintattr(f, "component",  detector.component);
      nxprintattr(f, "position",   detector.position);

      nxprintattr(f, "title",      detector.title);
      nxprintattr(f, !mcget_run_num() || mcget_run_num() >= mcget_ncount() ?
                 "Ncount" : 
                 "ratio",  detector.ncount);

      if (strlen(detector.filename)) {
        nxprintattr(f, "filename", detector.filename);
      }

      nxprintattr(f, "statistics", detector.statistics);
      nxprintattr(f, "signal",     detector.signal);
      nxprintattr(f, "values",     detector.values);

      if (detector.rank >= 1)
      {
        nxprintattr(f, "xvar",     detector.xvar);
        nxprintattr(f, "yvar",     detector.yvar);
        nxprintattr(f, "xlabel",   detector.xlabel);
        nxprintattr(f, "ylabel",   detector.ylabel);
        if (detector.rank > 1) {
          nxprintattr(f, "zvar",   detector.zvar);
          nxprintattr(f, "zlabel", detector.zlabel);
        }
      }

      nxprintattr(f, abs(detector.rank)==1 ?
                 "xlimits" : 
                 "xylimits", detector.limits);
      nxprintattr(f, "variables", 
        strcasestr(detector.format, "list") ? detector.ylabel : detector.variables);
      nxprintf(f, "distance", detector.position);
      nxprintf(f, "acquisition_mode",
        strcasestr(detector.format, "list") ? "event" : "summed");
        
      NXclosegroup(f);
    } /* NXdata (filename) */
    NXMEnableErrorReporting();  /* re-enable NeXus error messages */
    NXclosegroup(f);
  } /* NXdetector (data) */
  
} /* mcdatainfo_out_nexus */

/*******************************************************************************
* mcdetector_out_axis_nexus: write detector axis into current NXdata
*   requires: NXdata to be opened
*******************************************************************************/
int mcdetector_out_axis_nexus(NXhandle f, char *label, char *var, int rank, long length, double min, double max)
{
  if (!f || length <= 1 || mcdisable_output_files || max == min) return(NX_OK);
  else {
    double axis[length];
    char valid[32];
    int dim=(int)length;
    int i;
    int nprimary=1;
    /* create an axis from [min:max] */
    for(i = 0; i < length; i++)
      axis[i] = min+(max-min)*(i+0.5)/length;
    /* create the data set */
    strcpy_valid(valid, label);
    NXcompmakedata(f, valid, NX_FLOAT64, 1, &dim, NX_COMP_LZW, &dim);
    /* open it */
    if (NXopendata(f, valid) != NX_OK) {
      fprintf(stderr, "Warning: could not open axis rank %i '%s' (NeXus)\n",
        rank, valid);
      return(NX_ERROR);
    }
    /* put the axis and its attributes */
    NXputdata  (f, axis);
    nxprintattr(f, "long_name",  label);
    nxprintattr(f, "short_name", var);
    NXputattr  (f, "axis",       &rank,     1, NX_INT32);
    nxprintattr(f, "units",      var);
    NXputattr  (f, "primary",    &nprimary, 1, NX_INT32);
    NXclosedata(f);
    
    return(NX_OK);
  }
} /* mcdetector_out_axis_nexus */

/*******************************************************************************
* mcdetector_out_array_nexus: write detector array into current NXdata (1D,2D)
*   requires: NXdata to be opened
*******************************************************************************/
int mcdetector_out_array_nexus(NXhandle f, char *part, double *data, MCDETECTOR detector)
{
  
  int dims[3]={detector.m,detector.n,detector.p};  /* number of elements to write */
  int signal=1;
  int exists=0;
  int current_dims[3]={0,0,0};
  int ret=NX_OK;
  
  if (!f || !data || !detector.m || mcdisable_output_files) return(NX_OK);
  
  /* when this is a list, we set 1st dimension to NX_UNLIMITED for creation */
  if (strcasestr(detector.format, "list")) dims[0] = NX_UNLIMITED;
  
  /* create the data set in NXdata group */
  NXMDisableErrorReporting(); /* unactivate NeXus error messages, as creation may fail */
  /* NXcompmakedata fails with NX_UNLIMITED */
  if (strcasestr(detector.format, "list"))
    ret = NXmakedata(    f, part, NX_FLOAT64, detector.rank, dims);
  else
    ret = NXcompmakedata(f, part, NX_FLOAT64, detector.rank, dims, NX_COMP_LZW, dims);
  if (ret != NX_OK) {
    /* failed: data set already exists */
    int datatype=0;
    int rank=0;
    exists=1;
    /* inquire current size of data set (nb of events stored) */
    NXopendata(f, part);
    NXgetinfo(f, &rank, current_dims, &datatype);
    NXclosedata(f);
  }
  NXMEnableErrorReporting();  /* re-enable NeXus error messages */
  dims[0] = detector.m; /* restore actual dimension from data writing */
  
  /* open the data set */
  if (NXopendata(f, part) == NX_ERROR) {
    fprintf(stderr, "Warning: could not open DataSet %s '%s' (NeXus)\n",
      part, detector.title);
    return(NX_ERROR);
  }
  if (strcasestr(detector.format, "list")) {
    current_dims[1] = current_dims[2] = 0; /* set starting location for writing slab */
    NXputslab(f, data, current_dims, dims);
    if (!exists)
      printf("Events:   \"%s\"\n",  
        strlen(detector.filename) ? detector.filename : detector.component);
  } else {
    NXputdata (f, data);
  }
  
  if (strstr(part,"data") || strstr(part, "events")) {
    NXputattr(f, "signal", &signal, 1, NX_INT32);
    nxprintattr(f, "short_name", detector.filename && strlen(detector.filename) ? 
      detector.filename : detector.component);
  }
  nxprintattr(f, "long_name", "%s '%s'", part, detector.title);
  NXclosedata(f);
  
  return(NX_OK);
} /* mcdetector_out_array_nexus */

/*******************************************************************************
* mcdetector_out_data_nexus: write detector axes+data into current NXdata
*   The data:NXdetector is opened, then filename:NXdata
*   requires: NXentry to be opened
*******************************************************************************/
int mcdetector_out_data_nexus(NXhandle f, MCDETECTOR detector)
{
  char data_name[32];
  
  if (!f || !detector.m || mcdisable_output_files) return(NX_OK);
  
  strcpy_valid(data_name, 
    detector.filename && strlen(detector.filename) ? 
      detector.filename : detector.component);

  /* the NXdetector group has been created in mcinfo_out_nexus (mcsiminfo_init) */
  if (NXopengroup(f, "data", "NXdetector") == NX_OK) {

    /* the NXdata group has been created in mcdatainfo_out_nexus */
    if (NXopengroup(f, data_name, "NXdata") == NX_OK) {
  
      /* write axes, for histogram data sets, not for lists */
      if (!strcasestr(detector.format, "list")) {
        mcdetector_out_axis_nexus(f, detector.xlabel, detector.xvar, 
          1, detector.m, detector.xmin, detector.xmax);
          
        mcdetector_out_axis_nexus(f, detector.ylabel, detector.yvar, 
          2, detector.n, detector.ymin, detector.ymax);
          
        mcdetector_out_axis_nexus(f, detector.zlabel, detector.zvar, 
          3, detector.p, detector.zmin, detector.zmax);

      } /* !list */
      
      /* write the actual data (appended if already exists) */
      if (!strcasestr(detector.format, "list")) {
        mcdetector_out_array_nexus(f, "data", detector.p1, detector);
        mcdetector_out_array_nexus(f, "errors", detector.p2, detector);
        mcdetector_out_array_nexus(f, "ncount", detector.p0, detector);
      } else
        mcdetector_out_array_nexus(  f, "events", detector.p1, detector);
      
      NXclosegroup(f);
    } /* NXdata */
    NXclosegroup(f);
  } /* NXdetector */
  
  return(NX_OK);
} /* mcdetector_out_array_nexus */

#ifdef USE_MPI
/*******************************************************************************
* mcdetector_out_list_slaves: slaves send their list data to master which writes
*   requires: NXentry to be opened
* WARNING: this method has a flaw: it requires all nodes to flush the lists
*   the same number of times. In case one node is just below the buffer size
*   when finishing (e.g. monitor_nd), it may not trigger save but others may. 
*   Then the number of recv/send is not constant along nodes, and simulation stalls.  
*******************************************************************************/
MCDETECTOR mcdetector_out_list_slaves(MCDETECTOR detector)
{
  int     node_i=0;
  MPI_MASTER(
	     printf("\n** MPI master gathering slave node list data ** \n");
  );
  
  if (mpi_node_rank != mpi_node_root) {
    /* MPI slave: slaves send their data to master: 2 MPI_Send calls */
    /* m, n, p must be sent first, since all slaves do not have the same number of events */
    int mnp[3]={detector.m,detector.n,detector.p};

    if (mc_MPI_Send(mnp, 3, MPI_INT, mpi_node_root)!= MPI_SUCCESS)
      fprintf(stderr, "Warning: proc %i to master: MPI_Send mnp list error (mcdetector_out_list_slaves)\n", mpi_node_rank);
    if (!detector.p1
     || mc_MPI_Send(detector.p1, mnp[0]*mnp[1]*mnp[2], MPI_DOUBLE, mpi_node_root) != MPI_SUCCESS)
      fprintf(stderr, "Warning: proc %i to master: MPI_Send p1 list error: mnp=%i (mcdetector_out_list_slaves)\n", mpi_node_rank, abs(mnp[0]*mnp[1]*mnp[2]));
    /* slaves are done: sent mnp and p1 */
    return (detector);
  } /* end slaves */

  /* MPI master: receive data from slaves sequentially: 2 MPI_Recv calls */

  if (mpi_node_rank == mpi_node_root) {
    for(node_i=0; node_i<mpi_node_count; node_i++) {
      double *this_p1=NULL;                               /* buffer to hold the list from slaves */
      int     mnp[3]={0,0,0};  /* size of this buffer */
      if (node_i != mpi_node_root) { /* get data from slaves */
	if (mc_MPI_Recv(mnp, 3, MPI_INT, node_i) != MPI_SUCCESS)
	  fprintf(stderr, "Warning: master from proc %i: "
		  "MPI_Recv mnp list error (mcdetector_write_data)\n", node_i);
	if (mnp[0]*mnp[1]*mnp[2]) {
	  this_p1 = (double *)calloc(mnp[0]*mnp[1]*mnp[2], sizeof(double));
	  if (!this_p1 || mc_MPI_Recv(this_p1, abs(mnp[0]*mnp[1]*mnp[2]), MPI_DOUBLE, node_i)!= MPI_SUCCESS)
	    fprintf(stderr, "Warning: master from proc %i: "
		    "MPI_Recv p1 list error: mnp=%i (mcdetector_write_data)\n", node_i, mnp[0]*mnp[1]*mnp[2]);
	  else {
	    printf(". MPI master writing data for slave node %i\n",node_i);
	    detector.p1 = this_p1;
	    detector.m  = mnp[0]; detector.n  = mnp[1]; detector.p  = mnp[2];
	    
	    mcdetector_out_data_nexus(nxhandle, detector);
	  }
	}
      } /* if not master */
    } /* for */
  MPI_MASTER(
	     printf("\n** Done ** \n");
  );   
  }
}
#endif

MCDETECTOR mcdetector_out_0D_nexus(MCDETECTOR detector)
{
  /* Write data set information to NeXus file. */
  MPI_MASTER(
    mcdatainfo_out_nexus(nxhandle, detector);
  );
  
  return(detector);
} /* mcdetector_out_0D_ascii */

MCDETECTOR mcdetector_out_1D_nexus(MCDETECTOR detector_inc)
{
  MCDETECTOR detector = detector_inc;
  MPI_MASTER(
  mcdatainfo_out_nexus(nxhandle, detector);
  mcdetector_out_data_nexus(nxhandle, detector);
  );
  return(detector);
} /* mcdetector_out_1D_ascii */

MCDETECTOR mcdetector_out_2D_nexus(MCDETECTOR detector_inc)
{
  MCDETECTOR detector = detector_inc;
  MPI_MASTER(
  mcdatainfo_out_nexus(nxhandle, detector);
  mcdetector_out_data_nexus(nxhandle, detector);
  );
  
#ifdef USE_MPI // and USE_NEXUS
  /* NeXus: slave nodes have master write their lists */
  if (strcasestr(detector.format, "list") && mpi_node_count > 1) {
    mcdetector_out_list_slaves(detector);
  }
#endif /* USE_MPI */

  return(detector);
} /* mcdetector_out_2D_nexus */

#endif /* USE_NEXUS*/








/* ========================================================================== */

/*                            Main input functions                            */
/*            DETECTOR_OUT_xD function calls -> ascii or NeXus                */

/* ========================================================================== */

/*******************************************************************************
* mcsiminfo_init:   open SIM and write header
*******************************************************************************/
FILE *mcsiminfo_init(FILE *f)
{
  int exists=0;
  int index;
  
  /* check format */      
  if (!mcformat || !strlen(mcformat) 
   || !strcasecmp(mcformat, "MCSTAS") || !strcasecmp(mcformat, "MCXTRACE") 
   || !strcasecmp(mcformat, "PGPLOT") || !strcasecmp(mcformat, "GNUPLOT") || !strcasecmp(mcformat, "MCCODE")
   || !strcasecmp(mcformat, "MATLAB")) {
    mcformat="McCode";
#ifdef USE_NEXUS
  } else if (strcasestr(mcformat, "NeXus")) {
    /* Do nothing */
#endif
  } else {
    fprintf(stderr,
	    "Warning: You have requested the output format %s which is unsupported by this binary. Resetting to standard %s format.\n",mcformat ,"McCode");
    mcformat="McCode";
  }
  
  /* open the SIM file if not defined yet */
  if (mcsiminfo_file || mcdisable_output_files) 
    return (mcsiminfo_file);
    
#ifdef USE_NEXUS
  /* only master writes NeXus header: calls NXopen(nxhandle) */
  if (mcformat && strcasestr(mcformat, "NeXus")) {
	  MPI_MASTER(
	  mcsiminfo_file = mcnew_file(mcsiminfo_name, "h5", &exists);
    if(!mcsiminfo_file)
      fprintf(stderr,
	      "Warning: could not open simulation description file '%s'\n",
	      mcsiminfo_name);
	  else
	    mcinfo_out_nexus(nxhandle);
	  );
    return(mcsiminfo_file); /* points to nxhandle */
  }
#endif
  
  /* write main description file (only MASTER) */
  MPI_MASTER(

  mcsiminfo_file = mcnew_file(mcsiminfo_name, "sim", &exists);
  if(!mcsiminfo_file)
    fprintf(stderr,
	    "Warning: could not open simulation description file '%s'\n",
	    mcsiminfo_name);
  else
  {
    /* write SIM header */
    time_t t=time(NULL);
    mcsiminfo_out("%s simulation description file for %s.\n", 
      MCCODE_NAME, mcinstrument_name);
    mcsiminfo_out("Date:    %s", ctime(&t)); /* includes \n */
    mcsiminfo_out("Program: %s\n\n", MCCODE_STRING);
    
    mcsiminfo_out("begin instrument: %s\n", mcinstrument_name);
    mcinfo_out(   "  ", mcsiminfo_file);
    mcsiminfo_out("end instrument\n");

    mcsiminfo_out("\nbegin simulation: %s\n", mcdirname);
    mcruninfo_out("  ", mcsiminfo_file);
    mcsiminfo_out("end simulation\n");

  }
  return (mcsiminfo_file);
  
  ); /* MPI_MASTER */
  
} /* mcsiminfo_init */

/*******************************************************************************
*   mcsiminfo_close:  close SIM
*******************************************************************************/
void mcsiminfo_close()
{
  MPI_MASTER(
  if(mcsiminfo_file && !mcdisable_output_files) {
#ifdef USE_NEXUS
    if (mcformat && strcasestr(mcformat, "NeXus")) {
      time_t t=time(NULL);
      nxprintf(nxhandle, "end_time", ctime(&t));
      nxprintf(nxhandle, "duration", "%li", (long)t-mcstartdate);
      NXclosegroup(nxhandle); /* NXentry */
      NXclose(&nxhandle);
    } else
#endif
      fclose(mcsiminfo_file);
    );
    mcsiminfo_file = NULL;
  }
} /* mcsiminfo_close */

/*******************************************************************************
* mcdetector_out_0D: wrapper for 0D (single value).
*   Output single detector/monitor data (p0, p1, p2).
*   Title is t, component name is c.
*******************************************************************************/
MCDETECTOR mcdetector_out_0D(char *t, double p0, double p1, double p2,
                         char *c, Coords posa)
{
  /* import and perform basic detector analysis (and handle MPI reduce) */
  MCDETECTOR detector = mcdetector_import(mcformat,
    c, (t ? t : MCCODE_STRING " data"),
    1, 1, 1,
    "I", "", "",
    "I", "", "",
    0, 0, 0, 0, 0, 0, "",
    &p0, &p1, &p2, posa); /* write Detector: line */

#ifdef USE_NEXUS
  if (strcasestr(detector.format, "NeXus"))
    return(mcdetector_out_0D_nexus(detector));
  else
#endif
    return(mcdetector_out_0D_ascii(detector));
    
} /* mcdetector_out_0D */



/*******************************************************************************
* mcdetector_out_1D: wrapper for 1D.
*   Output 1d detector data (p0, p1, p2) for n bins linearly
*   distributed across the range x1..x2 (x1 is lower limit of first
*   bin, x2 is upper limit of last bin). Title is t, axis labels are xl
*   and yl. File name is f, component name is c.
*******************************************************************************/
MCDETECTOR mcdetector_out_1D(char *t, char *xl, char *yl,
        char *xvar, double x1, double x2,
        long n,
        double *p0, double *p1, double *p2, char *f,
        char *c, Coords posa)
{
  /* import and perform basic detector analysis (and handle MPI_Reduce) */
  MCDETECTOR detector = mcdetector_import(mcformat,
    c, (t ? t : MCCODE_STRING " 1D data"),
    n, 1, 1,
    xl, yl, (n > 1 ? "Signal per bin" : " Signal"),
    xvar, "(I,I_err)", "I",
    x1, x2, 0, 0, 0, 0, f,
    p0, p1, p2, posa); /* write Detector: line */
  if (!detector.p1 || !detector.m) return(detector);

#ifdef USE_NEXUS
  if (strcasestr(detector.format, "NeXus"))
    return(mcdetector_out_1D_nexus(detector));
  else
#endif
    return(mcdetector_out_1D_ascii(detector));
  
} /* mcdetector_out_1D */

/*******************************************************************************
* mcdetector_out_2D: wrapper for 2D.
*   special case for list: master creates file first, then slaves append their blocks without header
*******************************************************************************/
MCDETECTOR mcdetector_out_2D(char *t, char *xl, char *yl,
                  double x1, double x2, double y1, double y2,
                  long m, long n,
                  double *p0, double *p1, double *p2, char *f,
                  char *c, Coords posa)
{
  char xvar[CHAR_BUF_LENGTH];
  char yvar[CHAR_BUF_LENGTH];
  
  /* create short axes labels */
  if (xl && strlen(xl)) { strncpy(xvar, xl, CHAR_BUF_LENGTH); xvar[strcspn(xvar,"\n\r ")]='\0'; }
  else strcpy(xvar, "x");
  if (yl && strlen(yl)) { strncpy(yvar, yl, CHAR_BUF_LENGTH); yvar[strcspn(yvar,"\n\r ")]='\0'; }
  else strcpy(yvar, "y");

  MCDETECTOR detector;

  /* import and perform basic detector analysis (and handle MPI_Reduce) */
  if (labs(m) == 1) {/* n>1 on Y, m==1 on X: 1D, no X axis*/
    detector = mcdetector_import(mcformat,
      c, (t ? t : MCCODE_STRING " 1D data"),
      n, 1, 1,
      yl, "", "Signal per bin",
      yvar, "(I,Ierr)", "I",
      y1, y2, x1, x2, 0, 0, f,
      p0, p1, p2, posa); /* write Detector: line */
  } else if (labs(n)==1) {/* m>1 on X, n==1 on Y: 1D, no Y axis*/
    detector = mcdetector_import(mcformat,
      c, (t ? t : MCCODE_STRING " 1D data"),
      m, 1, 1,
      xl, "", "Signal per bin",
      xvar, "(I,Ierr)", "I",
      x1, x2, y1, y2, 0, 0, f,
      p0, p1, p2, posa); /* write Detector: line */
  }else {
    detector = mcdetector_import(mcformat,
      c, (t ? t : MCCODE_STRING " 2D data"),
      m, n, 1,
      xl, yl, "Signal per bin",
      xvar, yvar, "I",
      x1, x2, y1, y2, 0, 0, f,
      p0, p1, p2, posa); /* write Detector: line */
  }

  if (!detector.p1 || !detector.m) return(detector);

#ifdef USE_NEXUS
  if (strcasestr(detector.format, "NeXus"))
    return(mcdetector_out_2D_nexus(detector));
  else
#endif
    return(mcdetector_out_2D_ascii(detector));
  
} /* mcdetector_out_2D */

/*******************************************************************************
* mcdetector_out_list: wrapper for list output (calls out_2D with mcformat+"list").
*   m=number of events, n=size of each event
*******************************************************************************/
MCDETECTOR mcdetector_out_list(char *t, char *xl, char *yl,
                  long m, long n,
                  double *p1, char *f,
                  char *c, Coords posa)
{
  char       format_new[CHAR_BUF_LENGTH];
  char      *format_org;
  MCDETECTOR detector;
  
  format_org = mcformat;
  strcpy(format_new, mcformat);
  strcat(format_new, " list");
  mcformat = format_new;

  detector = mcdetector_out_2D(t, xl, yl,
                  1,labs(m),1,labs(n),
                  m,n,
                  NULL, p1, NULL, f,
                  c, posa);
  
  mcformat = format_org;
  return(detector);
}

/*******************************************************************************
 * mcuse_dir: set data/sim storage directory and create it,
 * or exit with error if exists
 ******************************************************************************/
static void
mcuse_dir(char *dir)
{
  if (!dir || !strlen(dir)) return;
#ifdef MC_PORTABLE
  fprintf(stderr, "Error: "
          "Directory output cannot be used with portable simulation (mcuse_dir)\n");
  exit(1);
#else  /* !MC_PORTABLE */
  /* handle file://directory URL type */
  if (strncmp(dir, "file://", strlen("file://")))
    mcdirname = dir;
  else
    mcdirname = dir+strlen("file://");
  
  
  
  MPI_MASTER(
    if(mkdir(mcdirname, 0777)) {
#ifndef DANSE
      fprintf(stderr, "Error: unable to create directory '%s' (mcuse_dir)\n", dir);
      fprintf(stderr, "(Maybe the directory already exists?)\n");
#endif
#ifdef USE_MPI
    MPI_Abort(MPI_COMM_WORLD, -1);
#endif
    exit(-1);
    }
  ); /* MPI_MASTER */
  
  /* remove trailing PATHSEP (if any) */
  while (strlen(mcdirname) && mcdirname[strlen(mcdirname) - 1] == MC_PATHSEP_C)
    mcdirname[strlen(mcdirname) - 1]='\0';
#endif /* !MC_PORTABLE */
} /* mcuse_dir */

/*******************************************************************************
* mcinfo: display instrument simulation info to stdout and exit
*******************************************************************************/
static void
mcinfo(void)
{
  fprintf(stdout, "begin instrument: %s\n", mcinstrument_name);
  mcinfo_out("  ", stdout);
  fprintf(stdout, "end instrument\n");
  fprintf(stdout, "begin simulation: %s\n", mcdirname ? mcdirname : ".");
  mcruninfo_out_backend("  ", stdout,1);
  fprintf(stdout, "end simulation\n");
  exit(0); /* includes MPI_Finalize in MPI mode */
} /* mcinfo */

#endif /* ndef MCCODE_R_IO_C */

/* end of the I/O section =================================================== */







/*******************************************************************************
* mcset_ncount: set total number of rays to generate
*******************************************************************************/
void mcset_ncount(unsigned long long int count)
{
  mcncount = count;
}

/* mcget_ncount: get total number of rays to generate */
unsigned long long int mcget_ncount(void)
{
  return mcncount;
}

/* mcget_run_num: get curent number of rays in TRACE */
unsigned long long int mcget_run_num(void)
{
  return mcrun_num;
}

/* mcsetn_arg: get ncount from a string argument */
static void
mcsetn_arg(char *arg)
{
  mcset_ncount((long long int) strtod(arg, NULL));
}

/* mcsetseed: set the random generator seed from a string argument */
static void
mcsetseed(char *arg)
{
  mcseed = atol(arg);
  if(mcseed) {
    srandom(mcseed);
  } else {
    fprintf(stderr, "Error: seed must not be zero (mcsetseed)\n");
    exit(1);
  }
}

/* Following part is only embedded when not redundent with mccode-r.h ========= */

#ifndef MCCODE_H

/* SECTION: MCDISPLAY support. =============================================== */

/*******************************************************************************
* Just output MCDISPLAY keywords to be caught by an external plotter client.
*******************************************************************************/

void mcdis_magnify(char *what){
  // Do nothing here, better use interactive zoom from the tools
}

void mcdis_line(double x1, double y1, double z1,
                double x2, double y2, double z2){
  printf("MCDISPLAY: multiline(2,%g,%g,%g,%g,%g,%g)\n",
         x1,y1,z1,x2,y2,z2);
}

void mcdis_dashed_line(double x1, double y1, double z1,
		       double x2, double y2, double z2, int n){
  int i;
  const double dx = (x2-x1)/(2*n+1);
  const double dy = (y2-y1)/(2*n+1);
  const double dz = (z2-z1)/(2*n+1);

  for(i = 0; i < n+1; i++)
    mcdis_line(x1 + 2*i*dx,     y1 + 2*i*dy,     z1 + 2*i*dz,
	       x1 + (2*i+1)*dx, y1 + (2*i+1)*dy, z1 + (2*i+1)*dz);
}

void mcdis_multiline(int count, ...){
  va_list ap;
  double x,y,z;

  printf("MCDISPLAY: multiline(%d", count);
  va_start(ap, count);
  while(count--)
    {
    x = va_arg(ap, double);
    y = va_arg(ap, double);
    z = va_arg(ap, double);
    printf(",%g,%g,%g", x, y, z);
    }
  va_end(ap);
  printf(")\n");
}

void mcdis_rectangle(char* plane, double x, double y, double z,
		     double width, double height){
  /* draws a rectangle in the plane           */
  /* x is ALWAYS width and y is ALWAYS height */
  if (strcmp("xy", plane)==0) {
    mcdis_multiline(5,
		    x - width/2, y - height/2, z,
		    x + width/2, y - height/2, z,
		    x + width/2, y + height/2, z,
		    x - width/2, y + height/2, z,
		    x - width/2, y - height/2, z);
  } else if (strcmp("xz", plane)==0) {
    mcdis_multiline(5,
		    x - width/2, y, z - height/2,
		    x + width/2, y, z - height/2,
		    x + width/2, y, z + height/2,
		    x - width/2, y, z + height/2,
		    x - width/2, y, z - height/2);
  } else if (strcmp("yz", plane)==0) {
    mcdis_multiline(5,
		    x, y - height/2, z - width/2,
		    x, y - height/2, z + width/2,
		    x, y + height/2, z + width/2,
		    x, y + height/2, z - width/2,
		    x, y - height/2, z - width/2);
  } else {

    fprintf(stderr, "Error: Definition of plane %s unknown\n", plane);
    exit(1);
  }
}

/*  draws a box with center at (x, y, z) and
    width (deltax), height (deltay), length (deltaz) */
void mcdis_box(double x, double y, double z,
	       double width, double height, double length){

  mcdis_rectangle("xy", x, y, z-length/2, width, height);
  mcdis_rectangle("xy", x, y, z+length/2, width, height);
  mcdis_line(x-width/2, y-height/2, z-length/2,
	     x-width/2, y-height/2, z+length/2);
  mcdis_line(x-width/2, y+height/2, z-length/2,
	     x-width/2, y+height/2, z+length/2);
  mcdis_line(x+width/2, y-height/2, z-length/2,
	     x+width/2, y-height/2, z+length/2);
  mcdis_line(x+width/2, y+height/2, z-length/2,
	     x+width/2, y+height/2, z+length/2);
}

void mcdis_circle(char *plane, double x, double y, double z, double r){
  printf("MCDISPLAY: circle('%s',%g,%g,%g,%g)\n", plane, x, y, z, r);
}

/* Draws a circle with center (x,y,z), radius (r), and in the plane
 * with normal (nx,ny,nz)*/
void mcdis_Circle(double x, double y, double z, double r, double nx, double ny, double nz){
    int i;
    if(nx==0 && ny && nz==0){
        for (i=0;i<24; i++){
            mcdis_line(x+r*sin(i*2*M_PI/24),y,z+r*cos(i*2*M_PI/24),
                    x+r*sin((i+1)*2*M_PI/24),y,z+r*cos((i+1)*2*M_PI/24));
        }
    }else{
        double mx,my,mz;
        /*generate perpendicular vector using (nx,ny,nz) and (0,1,0)*/
        vec_prod(mx,my,mz, 0,1,0, nx,ny,nz);
        NORM(mx,my,mz);
        /*draw circle*/
        for (i=0;i<24; i++){
            double ux,uy,uz;
            double wx,wy,wz;
            rotate(ux,uy,uz, mx,my,mz, i*2*M_PI/24, nx,ny,nz);
            rotate(wx,wy,wz, mx,my,mz, (i+1)*2*M_PI/24, nx,ny,nz);
            mcdis_line(x+ux*r,y+uy*r,z+uz*r,
                    x+wx*r,y+wy*r,z+wz*r);
        }
    }
}

/* Draws a cylinder with center at (x,y,z) with extent (r,height).
 * The cylinder axis is along the vector nx,ny,nz.
 * N determines how many vertical lines are drawn.*/
void mcdis_cylinder( double x, double y, double z,
        double r, double height, int N, double nx, double ny, double nz){
    int i;
    /*no lines make little sense - so trigger the default*/
    if(N<=0) N=5;

    NORM(nx,ny,nz);
    double h_2=height/2.0;
    mcdis_Circle(x+nx*h_2,y+ny*h_2,z+nz*h_2,r,nx,ny,nz);
    mcdis_Circle(x-nx*h_2,y-ny*h_2,z-nz*h_2,r,nx,ny,nz);

    double mx,my,mz;
    /*generate perpendicular vector using (nx,ny,nz) and (0,1,0)*/
    if(nx==0 && ny && nz==0){
        mx=my=0;mz=1;
    }else{
        vec_prod(mx,my,mz, 0,1,0, nx,ny,nz);
        NORM(mx,my,mz);
    }
    /*draw circle*/
    for (i=0; i<24; i++){
        double ux,uy,uz;
        rotate(ux,uy,uz, mx,my,mz, i*2*M_PI/24, nx,ny,nz);
        mcdis_line(x+nx*h_2+ux*r, y+ny*h_2+uy*r, z+nz*h_2+uz*r,
                 x-nx*h_2+ux*r, y-ny*h_2+uy*r, z-nz*h_2+uz*r);
    }
}

/* draws a sphere with center at (x,y,z) with extent (r)
 * The sphere is drawn using N longitudes and N latitudes.*/
void mcdis_sphere(double x, double y, double z, double r, int N){
    double nx,ny,nz;
    int i;
    /*no lines make little sense - so trigger the default*/
    if(N<=0) N=5;

    nx=0;ny=0;nz=1;
    mcdis_Circle(x,y,z,r,nx,ny,nz);
    for (i=1;i<N;i++){
        rotate(nx,ny,nz, nx,ny,nz, M_PI/N, 0,1,0);
        mcdis_Circle(x,y,z,r,nx,ny,nz);
    }
    /*lastly draw a great circle perpendicular to all N circles*/
    //mcdis_Circle(x,y,z,radius,1,0,0);

    for (i=1;i<=N;i++){
        double yy=-r+ 2*r*((double)i/(N+1));
        mcdis_Circle(x,y+yy ,z,  sqrt(r*r-yy*yy) ,0,1,0);
    }
}

/* SECTION: coordinates handling ============================================ */

/*******************************************************************************
* Since we use a lot of geometric calculations using Cartesian coordinates,
* we collect some useful routines here. However, it is also permissible to
* work directly on the underlying struct coords whenever that is most
* convenient (that is, the type Coords is not abstract).
*
* Coordinates are also used to store rotation angles around x/y/z axis.
*
* Since coordinates are used much like a basic type (such as double), the
* structure itself is passed and returned, rather than a pointer.
*
* At compile-time, the values of the coordinates may be unknown (for example
* a motor position). Hence coordinates are general expressions and not simple
* numbers. For this we used the type Coords_exp which has three CExp
* fields. For runtime (or calculations possible at compile time), we use
* Coords which contains three double fields.
*******************************************************************************/

/* coords_set: Assign coordinates. */
Coords
coords_set(MCNUM x, MCNUM y, MCNUM z)
{
  Coords a;

  a.x = x;
  a.y = y;
  a.z = z;
  return a;
}

/* coords_get: get coordinates. Required when 'x','y','z' are #defined as ray pars */
Coords
coords_get(Coords a, MCNUM *x, MCNUM *y, MCNUM *z)
{
  *x = a.x;
  *y = a.y;
  *z = a.z;
  return a;
}

/* coords_add: Add two coordinates. */
Coords
coords_add(Coords a, Coords b)
{
  Coords c;

  c.x = a.x + b.x;
  c.y = a.y + b.y;
  c.z = a.z + b.z;
  if (fabs(c.z) < 1e-14) c.z=0.0;
  return c;
}

/* coords_sub: Subtract two coordinates. */
Coords
coords_sub(Coords a, Coords b)
{
  Coords c;

  c.x = a.x - b.x;
  c.y = a.y - b.y;
  c.z = a.z - b.z;
  if (fabs(c.z) < 1e-14) c.z=0.0;
  return c;
}

/* coords_neg: Negate coordinates. */
Coords
coords_neg(Coords a)
{
  Coords b;

  b.x = -a.x;
  b.y = -a.y;
  b.z = -a.z;
  return b;
}

/* coords_scale: Scale a vector. */
Coords coords_scale(Coords b, double scale) {
  Coords a;

  a.x = b.x*scale;
  a.y = b.y*scale;
  a.z = b.z*scale;
  return a;
}

/* coords_sp: Scalar product: a . b */
double coords_sp(Coords a, Coords b) {
  double value;

  value = a.x*b.x + a.y*b.y + a.z*b.z;
  return value;
}

/* coords_xp: Cross product: a = b x c. */
Coords coords_xp(Coords b, Coords c) {
  Coords a;

  a.x = b.y*c.z - c.y*b.z;
  a.y = b.z*c.x - c.z*b.x;
  a.z = b.x*c.y - c.x*b.y;
  return a;
}

/* coords_len: Gives length of coords set. */
double coords_len(Coords a) {
  return sqrt(a.x*a.x + a.y*a.y + a.z*a.z);
}

/* coords_mirror: Mirror a in plane (through the origin) defined by normal n*/
Coords coords_mirror(Coords a, Coords n) {
  double t = scalar_prod(n.x, n.y, n.z, n.x, n.y, n.z);
  Coords b;
  if (t!=1) {
    t = sqrt(t);
    n.x /= t;
    n.y /= t;
    n.z /= t;
  }
  t=scalar_prod(a.x, a.y, a.z, n.x, n.y, n.z);
  b.x = a.x-2*t*n.x;
  b.y = a.y-2*t*n.y;
  b.z = a.z-2*t*n.z;
  return b;
}

/* coords_print: Print out vector values. */
void coords_print(Coords a) {

  fprintf(stdout, "(%f, %f, %f)\n", a.x, a.y, a.z);
  return;
}

mcstatic void coords_norm(Coords* c) {
	double temp = coords_sp(*c,*c);

	// Skip if we will end dividing by zero
	if (temp == 0) return;

	temp = sqrt(temp);

	c->x /= temp;
	c->y /= temp;
	c->z /= temp;
}

/*******************************************************************************
* The Rotation type implements a rotation transformation of a coordinate
* system in the form of a double[3][3] matrix.
*
* Contrary to the Coords type in coords.c, rotations are passed by
* reference. Functions that yield new rotations do so by writing to an
* explicit result parameter; rotations are not returned from functions. The
* reason for this is that arrays cannot by returned from functions (though
* structures can; thus an alternative would have been to wrap the
* double[3][3] array up in a struct). Such are the ways of C programming.
*
* A rotation represents the tranformation of the coordinates of a vector when
* changing between coordinate systems that are rotated with respect to each
* other. For example, suppose that coordinate system Q is rotated 45 degrees
* around the Z axis with respect to coordinate system P. Let T be the
* rotation transformation representing a 45 degree rotation around Z. Then to
* get the coordinates of a vector r in system Q, apply T to the coordinates
* of r in P. If r=(1,0,0) in P, it will be (sqrt(1/2),-sqrt(1/2),0) in
* Q. Thus we should be careful when interpreting the sign of rotation angles:
* they represent the rotation of the coordinate systems, not of the
* coordinates (which has opposite sign).
*******************************************************************************/

/*******************************************************************************
* rot_set_rotation: Get transformation for rotation first phx around x axis,
* then phy around y, then phz around z.
*******************************************************************************/
void
rot_set_rotation(Rotation t, double phx, double phy, double phz)
{
  if ((phx == 0) && (phy == 0) && (phz == 0)) {
    t[0][0] = 1.0;
    t[0][1] = 0.0;
    t[0][2] = 0.0;
    t[1][0] = 0.0;
    t[1][1] = 1.0;
    t[1][2] = 0.0;
    t[2][0] = 0.0;
    t[2][1] = 0.0;
    t[2][2] = 1.0;
  } else {
    double cx = cos(phx);
    double sx = sin(phx);
    double cy = cos(phy);
    double sy = sin(phy);
    double cz = cos(phz);
    double sz = sin(phz);

    t[0][0] = cy*cz;
    t[0][1] = sx*sy*cz + cx*sz;
    t[0][2] = sx*sz - cx*sy*cz;
    t[1][0] = -cy*sz;
    t[1][1] = cx*cz - sx*sy*sz;
    t[1][2] = sx*cz + cx*sy*sz;
    t[2][0] = sy;
    t[2][1] = -sx*cy;
    t[2][2] = cx*cy;
  }
}

/*******************************************************************************
* rot_test_identity: Test if rotation is identity
*******************************************************************************/
int
rot_test_identity(Rotation t)
{
  return (t[0][0] + t[1][1] + t[2][2] == 3);
}

/*******************************************************************************
* rot_mul: Matrix multiplication of transformations (this corresponds to
* combining transformations). After rot_mul(T1, T2, T3), doing T3 is
* equal to doing first T2, then T1.
* Note that T3 must not alias (use the same array as) T1 or T2.
*******************************************************************************/
void
rot_mul(Rotation t1, Rotation t2, Rotation t3)
{
  if (rot_test_identity(t1)) {
    rot_copy(t3, t2);
  } else if (rot_test_identity(t2)) {
    rot_copy(t3, t1);
  } else {
    int i,j;
    for(i = 0; i < 3; i++)
      for(j = 0; j < 3; j++)
	t3[i][j] = t1[i][0]*t2[0][j] + t1[i][1]*t2[1][j] + t1[i][2]*t2[2][j];
  }
}

/*******************************************************************************
* rot_copy: Copy a rotation transformation (arrays cannot be assigned in C).
*******************************************************************************/
void
rot_copy(Rotation dest, Rotation src)
{
  int i,j;
  for(i = 0; i < 3; i++)
    for(j = 0; j < 3; j++)
      dest[i][j] = src[i][j];
}

/*******************************************************************************
* rot_transpose: Matrix transposition, which is inversion for Rotation matrices
*******************************************************************************/
void
rot_transpose(Rotation src, Rotation dst)
{
  dst[0][0] = src[0][0];
  dst[0][1] = src[1][0];
  dst[0][2] = src[2][0];
  dst[1][0] = src[0][1];
  dst[1][1] = src[1][1];
  dst[1][2] = src[2][1];
  dst[2][0] = src[0][2];
  dst[2][1] = src[1][2];
  dst[2][2] = src[2][2];
}

/*******************************************************************************
* rot_apply: returns t*a
*******************************************************************************/
Coords
rot_apply(Rotation t, Coords a)
{
  Coords b;
  if (rot_test_identity(t)) {
    return a;
  } else {
    b.x = t[0][0]*a.x + t[0][1]*a.y + t[0][2]*a.z;
    b.y = t[1][0]*a.x + t[1][1]*a.y + t[1][2]*a.z;
    b.z = t[2][0]*a.x + t[2][1]*a.y + t[2][2]*a.z;
    return b;
  }
}

/**
 * Pretty-printing of rotation matrices.
 */
void rot_print(Rotation rot) {
	printf("[ %4.2f %4.2f %4.2f ]\n",
			rot[0][0], rot[0][1], rot[0][2]);
	printf("[ %4.2f %4.2f %4.2f ]\n",
			rot[1][0], rot[1][1], rot[1][2]);
	printf("[ %4.2f %4.2f %4.2f ]\n\n",
			rot[2][0], rot[2][1], rot[2][2]);
}

/**
 * Vector product: used by vec_prod (mccode-r.h). Use coords_xp for Coords.
 */
mcstatic void vec_prod_func(double *x, double *y, double *z,
		double x1, double y1, double z1,
		double x2, double y2, double z2) {
    *x = (y1)*(z2) - (y2)*(z1);
    *y = (z1)*(x2) - (z2)*(x1);
    *z = (x1)*(y2) - (x2)*(y1);
}

/**
 * Scalar product: use coords_sp for Coords.
 */
mcstatic double scalar_prod(
		double x1, double y1, double z1,
		double x2, double y2, double z2) {
	return ((x1 * x2) + (y1 * y2) + (z1 * z2));
}

/*******************************************************************************
* mccoordschange: applies rotation to (x y z) and (vx vy vz) and Spin (sx,sy,sz)
*******************************************************************************/
void
mccoordschange(Coords a, Rotation t, double *x, double *y, double *z,
               double *vx, double *vy, double *vz, double *sx, double *sy, double *sz)
{
  Coords b, c;

  b.x = *x;
  b.y = *y;
  b.z = *z;
  c = rot_apply(t, b);
  b = coords_add(c, a);
  *x = b.x;
  *y = b.y;
  *z = b.z;

  if ( (vz && vy  && vx) && (*vz != 0.0 || *vx != 0.0 || *vy != 0.0) ) mccoordschange_polarisation(t, vx, vy, vz);

  if ( (sz && sy  && sx) && (*sz != 0.0 || *sx != 0.0 || *sy != 0.0) ) mccoordschange_polarisation(t, sx, sy, sz);

}

/*******************************************************************************
* mccoordschange_polarisation: applies rotation to vector (sx sy sz)
*******************************************************************************/
void
mccoordschange_polarisation(Rotation t, double *sx, double *sy, double *sz)
{
  Coords b, c;

  b.x = *sx;
  b.y = *sy;
  b.z = *sz;
  c = rot_apply(t, b);
  *sx = c.x;
  *sy = c.y;
  *sz = c.z;
}

/* SECTION: vector math  ==================================================== */

/* normal_vec_func: Compute normal vector to (x,y,z). */
mcstatic void normal_vec_func(double *nx, double *ny, double *nz,
                double x, double y, double z)
{
  double ax = fabs(x);
  double ay = fabs(y);
  double az = fabs(z);
  double l;
  if(x == 0 && y == 0 && z == 0)
  {
    *nx = 0;
    *ny = 0;
    *nz = 0;
    return;
  }
  if(ax < ay)
  {
    if(ax < az)
    {                           /* Use X axis */
      l = sqrt(z*z + y*y);
      *nx = 0;
      *ny = z/l;
      *nz = -y/l;
      return;
    }
  }
  else
  {
    if(ay < az)
    {                           /* Use Y axis */
      l = sqrt(z*z + x*x);
      *nx = z/l;
      *ny = 0;
      *nz = -x/l;
      return;
    }
  }
  /* Use Z axis */
  l = sqrt(y*y + x*x);
  *nx = y/l;
  *ny = -x/l;
  *nz = 0;
} /* normal_vec */

/*******************************************************************************
 * solve_2nd_order: second order equation solve: A*t^2 + B*t + C = 0
 * solve_2nd_order(&t1, NULL, A,B,C)
 *   returns 0 if no solution was found, or set 't1' to the smallest positive
 *   solution.
 * solve_2nd_order(&t1, &t2, A,B,C)
 *   same as with &t2=NULL, but also returns the second solution.
 * EXAMPLE usage for intersection of a trajectory with a plane in gravitation
 * field (gx,gy,gz):
 * The neutron starts at point r=(x,y,z) with velocityv=(vx vy vz). The plane
 * has a normal vector n=(nx,ny,nz) and contains the point W=(wx,wy,wz).
 * The problem consists in solving the 2nd order equation:
 *      1/2.n.g.t^2 + n.v.t + n.(r-W) = 0
 * so that A = 0.5 n.g; B = n.v; C = n.(r-W);
 * Without acceleration, t=-n.(r-W)/n.v
 ******************************************************************************/
int solve_2nd_order(double *t1, double *t2,
                  double A,  double B,  double C)
{
  int ret=0;

  if (!t1) return 0;
  *t1 = 0;
  if (t2) *t2=0;

  if (fabs(A) < 1E-10) /* approximate to linear equation: A ~ 0 */
  {
    if (B) {  *t1 = -C/B; ret=1; if (t2) *t2=*t1; }
    /* else no intersection: A=B=0 ret=0 */
  }
  else
  {
    double D;
    D = B*B - 4*A*C;
    if (D >= 0) /* Delta > 0: two solutions */
    {
      double sD, dt1, dt2;
      sD = sqrt(D);
      dt1 = (-B + sD)/2/A;
      dt2 = (-B - sD)/2/A;
      /* we identify very small values with zero */
      if (fabs(dt1) < 1e-10) dt1=0.0;
      if (fabs(dt2) < 1e-10) dt2=0.0;

      /* now we choose the smallest positive solution */
      if      (dt1<=0.0 && dt2>0.0) ret=2; /* dt2 positive */
      else if (dt2<=0.0 && dt1>0.0) ret=1; /* dt1 positive */
      else if (dt1> 0.0 && dt2>0.0)
      {  if (dt1 < dt2) ret=1; else ret=2; } /* all positive: min(dt1,dt2) */
      /* else two solutions are negative. ret=-1 */
      if (ret==1) { *t1 = dt1;  if (t2) *t2=dt2; }
      else        { *t1 = dt2;  if (t2) *t2=dt1; }
      ret=2;  /* found 2 solutions and t1 is the positive one */
    } /* else Delta <0: no intersection. ret=0 */
  }
  return(ret);
} /* solve_2nd_order */

/*******************************************************************************
 * randvec_target_circle: Choose random direction towards target at (x,y,z)
 * with given radius.
 * If radius is zero, choose random direction in full 4PI, no target.
 ******************************************************************************/
void
randvec_target_circle(double *xo, double *yo, double *zo, double *solid_angle,
               double xi, double yi, double zi, double radius)
{
  double l2, phi, theta, nx, ny, nz, xt, yt, zt, xu, yu, zu;

  if(radius == 0.0)
  {
    /* No target, choose uniformly a direction in full 4PI solid angle. */
    theta = acos (1 - rand0max(2));
    phi = rand0max(2 * PI);
    if(solid_angle)
      *solid_angle = 4*PI;
    nx = 1;
    ny = 0;
    nz = 0;
    yi = sqrt(xi*xi+yi*yi+zi*zi);
    zi = 0;
    xi = 0;
  }
  else
  {
    double costheta0;
    l2 = xi*xi + yi*yi + zi*zi; /* sqr Distance to target. */
    costheta0 = sqrt(l2/(radius*radius+l2));
    if (radius < 0) costheta0 *= -1;
    if(solid_angle)
    {
      /* Compute solid angle of target as seen from origin. */
        *solid_angle = 2*PI*(1 - costheta0);
    }

    /* Now choose point uniformly on circle surface within angle theta0 */
    theta = acos (1 - rand0max(1 - costheta0)); /* radius on circle */
    phi = rand0max(2 * PI); /* rotation on circle at given radius */
    /* Now, to obtain the desired vector rotate (xi,yi,zi) angle theta around a
       perpendicular axis u=i x n and then angle phi around i. */
    if(xi == 0 && zi == 0)
    {
      nx = 1;
      ny = 0;
      nz = 0;
    }
    else
    {
      nx = -zi;
      nz = xi;
      ny = 0;
    }
  }

  /* [xyz]u = [xyz]i x n[xyz] (usually vertical) */
  vec_prod(xu,  yu,  zu, xi, yi, zi,        nx, ny, nz);
  /* [xyz]t = [xyz]i rotated theta around [xyz]u */
  rotate  (xt,  yt,  zt, xi, yi, zi, theta, xu, yu, zu);
  /* [xyz]o = [xyz]t rotated phi around n[xyz] */
  rotate (*xo, *yo, *zo, xt, yt, zt, phi, xi, yi, zi);
} /* randvec_target_circle */

/*******************************************************************************
 * randvec_target_rect_angular: Choose random direction towards target at
 * (xi,yi,zi) with given ANGULAR dimension height x width. height=phi_x=[0,PI],
 * width=phi_y=[0,2*PI] (radians)
 * If height or width is zero, choose random direction in full 4PI, no target.
 *******************************************************************************/
void
randvec_target_rect_angular(double *xo, double *yo, double *zo, double *solid_angle,
               double xi, double yi, double zi, double width, double height, Rotation A)
{
  double theta, phi, nx, ny, nz, xt, yt, zt, xu, yu, zu;
  Coords tmp;
  Rotation Ainverse;

  rot_transpose(A, Ainverse);

  if(height == 0.0 || width == 0.0)
  {
    randvec_target_circle(xo, yo, zo, solid_angle,
               xi, yi, zi, 0);
    return;
  }
  else
  {
    if(solid_angle)
    {
      /* Compute solid angle of target as seen from origin. */
      *solid_angle = 2*fabs(width*sin(height/2));
    }

    /* Go to global coordinate system */

    tmp = coords_set(xi, yi, zi);
    tmp = rot_apply(Ainverse, tmp);
    coords_get(tmp, &xi, &yi, &zi);

    /* Now choose point uniformly on the unit sphere segment with angle theta/phi */
    phi   = width*randpm1()/2.0;
    theta = asin(randpm1()*sin(height/2.0));
    /* Now, to obtain the desired vector rotate (xi,yi,zi) angle theta around
       n, and then phi around u. */
    if(xi == 0 && zi == 0)
    {
      nx = 1;
      ny = 0;
      nz = 0;
    }
    else
    {
      nx = -zi;
      nz = xi;
      ny = 0;
    }
  }

  /* [xyz]u = [xyz]i x n[xyz] (usually vertical) */
  vec_prod(xu,  yu,  zu, xi, yi, zi,        nx, ny, nz);
  /* [xyz]t = [xyz]i rotated theta around [xyz]u */
  rotate  (xt,  yt,  zt, xi, yi, zi, theta, nx, ny, nz);
  /* [xyz]o = [xyz]t rotated phi around n[xyz] */
  rotate (*xo, *yo, *zo, xt, yt, zt, phi, xu,  yu,  zu);

  /* Go back to local coordinate system */
  tmp = coords_set(*xo, *yo, *zo);
  tmp = rot_apply(A, tmp);
  coords_get(tmp, &*xo, &*yo, &*zo);

} /* randvec_target_rect_angular */

/*******************************************************************************
 * randvec_target_rect_real: Choose random direction towards target at (xi,yi,zi)
 * with given dimension height x width (in meters !).
 *
 * Local emission coordinate is taken into account and corrected for 'order' times.
 * (See remarks posted to mcstas-users by George Apostolopoulus <gapost@ipta.demokritos.gr>)
 *
 * If height or width is zero, choose random direction in full 4PI, no target.
 *
 * Traditionally, this routine had the name randvec_target_rect - this is now a
 * a define (see mcstas-r.h) pointing here. If you use the old rouine, you are NOT
 * taking the local emmission coordinate into account.
*******************************************************************************/

void
randvec_target_rect_real(double *xo, double *yo, double *zo, double *solid_angle,
               double xi, double yi, double zi,
               double width, double height, Rotation A,
               double lx, double ly, double lz, int order)
{
  double dx, dy, dist, dist_p, nx, ny, nz, mx, my, mz, n_norm, m_norm;
  double cos_theta;
  Coords tmp;
  Rotation Ainverse;

  rot_transpose(A, Ainverse);

  if(height == 0.0 || width == 0.0)
  {
    randvec_target_circle(xo, yo, zo, solid_angle,
               xi, yi, zi, 0);
    return;
  }
  else
  {

    /* Now choose point uniformly on rectangle within width x height */
    dx = width*randpm1()/2.0;
    dy = height*randpm1()/2.0;

    /* Determine distance to target plane*/
    dist = sqrt(xi*xi + yi*yi + zi*zi);
    /* Go to global coordinate system */

    tmp = coords_set(xi, yi, zi);
    tmp = rot_apply(Ainverse, tmp);
    coords_get(tmp, &xi, &yi, &zi);

    /* Determine vector normal to trajectory axis (z) and gravity [0 1 0] */
    vec_prod(nx, ny, nz, xi, yi, zi, 0, 1, 0);

    /* This now defines the x-axis, normalize: */
    n_norm=sqrt(nx*nx + ny*ny + nz*nz);
    nx = nx/n_norm;
    ny = ny/n_norm;
    nz = nz/n_norm;

    /* Now, determine our y-axis (vertical in many cases...) */
    vec_prod(mx, my, mz, xi, yi, zi, nx, ny, nz);
    m_norm=sqrt(mx*mx + my*my + mz*mz);
    mx = mx/m_norm;
    my = my/m_norm;
    mz = mz/m_norm;

    /* Our output, random vector can now be defined by linear combination: */

    *xo = xi + dx * nx + dy * mx;
    *yo = yi + dx * ny + dy * my;
    *zo = zi + dx * nz + dy * mz;

    /* Go back to local coordinate system */
    tmp = coords_set(*xo, *yo, *zo);
    tmp = rot_apply(A, tmp);
    coords_get(tmp, &*xo, &*yo, &*zo);

    /* Go back to local coordinate system */
    tmp = coords_set(xi, yi, zi);
    tmp = rot_apply(A, tmp);
    coords_get(tmp, &xi, &yi, &zi);

    if (solid_angle) {
      /* Calculate vector from local point to remote random point */
      lx = *xo - lx;
      ly = *yo - ly;
      lz = *zo - lz;
      dist_p = sqrt(lx*lx + ly*ly + lz*lz);

      /* Adjust the 'solid angle' */
      /* 1/r^2 to the chosen point times cos(\theta) between the normal */
      /* vector of the target rectangle and direction vector of the chosen point. */
      cos_theta = (xi * lx + yi * ly + zi * lz) / (dist * dist_p);
      *solid_angle = width * height / (dist_p * dist_p);
      int counter;
      for (counter = 0; counter < order; counter++) {
	*solid_angle = *solid_angle * cos_theta;
      }
    }
  }
} /* randvec_target_rect_real */

/* SECTION: random numbers ================================================== */

/*
 * Copyright (c) 1983 Regents of the University of California.
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms are permitted
 * provided that the above copyright notice and this paragraph are
 * duplicated in all such forms and that any documentation,
 * advertising materials, and other materials related to such
 * distribution and use acknowledge that the software was developed
 * by the University of California, Berkeley.  The name of the
 * University may not be used to endorse or promote products derived
 * from this software without specific prior written permission.
 * THIS SOFTWARE IS PROVIDED ``AS IS'' AND WITHOUT ANY EXPRESS OR
 * IMPLIED WARRANTIES, INCLUDING, WITHOUT LIMITATION, THE IMPLIED
 * WARRANTIES OF MERCHANTIBILITY AND FITNESS FOR A PARTICULAR PURPOSE.
 */

/*
 * This is derived from the Berkeley source:
 *        @(#)random.c        5.5 (Berkeley) 7/6/88
 * It was reworked for the GNU C Library by Roland McGrath.
 * Rewritten to use reentrant functions by Ulrich Drepper, 1995.
 */

/*******************************************************************************
* Modified for McStas from glibc 2.0.7pre1 stdlib/random.c and
* stdlib/random_r.c.
*
* This way random() is more than four times faster compared to calling
* standard glibc random() on ix86 Linux, probably due to multithread support,
* ELF shared library overhead, etc. It also makes McStas generated
* simulations more portable (more likely to behave identically across
* platforms, important for parrallel computations).
*******************************************************************************/


#define        TYPE_3                3
#define        BREAK_3                128
#define        DEG_3                31
#define        SEP_3                3

static mc_int32_t randtbl[DEG_3 + 1] =
  {
    TYPE_3,

    -1726662223, 379960547, 1735697613, 1040273694, 1313901226,
    1627687941, -179304937, -2073333483, 1780058412, -1989503057,
    -615974602, 344556628, 939512070, -1249116260, 1507946756,
    -812545463, 154635395, 1388815473, -1926676823, 525320961,
    -1009028674, 968117788, -123449607, 1284210865, 435012392,
    -2017506339, -911064859, -370259173, 1132637927, 1398500161,
    -205601318,
  };

static mc_int32_t *fptr = &randtbl[SEP_3 + 1];
static mc_int32_t *rptr = &randtbl[1];
static mc_int32_t *state = &randtbl[1];
#define rand_deg DEG_3
#define rand_sep SEP_3
static mc_int32_t *end_ptr = &randtbl[sizeof (randtbl) / sizeof (randtbl[0])];

mc_int32_t
mc_random (void)
{
  mc_int32_t result;

  *fptr += *rptr;
  /* Chucking least random bit.  */
  result = (*fptr >> 1) & 0x7fffffff;
  ++fptr;
  if (fptr >= end_ptr)
  {
    fptr = state;
    ++rptr;
  }
  else
  {
    ++rptr;
    if (rptr >= end_ptr)
      rptr = state;
  }
  return result;
}

void
mc_srandom (unsigned int x)
{
  /* We must make sure the seed is not 0.  Take arbitrarily 1 in this case.  */
  state[0] = x ? x : 1;
  {
    long int i;
    for (i = 1; i < rand_deg; ++i)
    {
      /* This does:
         state[i] = (16807 * state[i - 1]) % 2147483647;
         but avoids overflowing 31 bits.  */
      long int hi = state[i - 1] / 127773;
      long int lo = state[i - 1] % 127773;
      long int test = 16807 * lo - 2836 * hi;
      state[i] = test + (test < 0 ? 2147483647 : 0);
    }
    fptr = &state[rand_sep];
    rptr = &state[0];
    for (i = 0; i < 10 * rand_deg; ++i)
      random ();
  }
}

/* "Mersenne Twister", by Makoto Matsumoto and Takuji Nishimura. */
/* See http://www.math.keio.ac.jp/~matumoto/emt.html for original source. */


/*
   A C-program for MT19937, with initialization improved 2002/1/26.
   Coded by Takuji Nishimura and Makoto Matsumoto.

   Before using, initialize the state by using mt_srandom(seed)
   or init_by_array(init_key, key_length).

   Copyright (C) 1997 - 2002, Makoto Matsumoto and Takuji Nishimura,
   All rights reserved.

   Redistribution and use in source and binary forms, with or without
   modification, are permitted provided that the following conditions
   are met:

     1. Redistributions of source code must retain the above copyright
        notice, this list of conditions and the following disclaimer.

     2. Redistributions in binary form must reproduce the above copyright
        notice, this list of conditions and the following disclaimer in the
        documentation and/or other materials provided with the distribution.

     3. The names of its contributors may not be used to endorse or promote
        products derived from this software without specific prior written
        permission.

   THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
   "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
   LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR
   A PARTICULAR PURPOSE ARE DISCLAIMED.  IN NO EVENT SHALL THE COPYRIGHT OWNER OR
   CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL,
   EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO,
   PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR
   PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF
   LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING
   NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
   SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.


   Any feedback is very welcome.
   http://www.math.keio.ac.jp/matumoto/emt.html
   email: matumoto@math.keio.ac.jp
*/

#include <stdio.h>

/* Period parameters */
#define N 624
#define M 397
#define MATRIX_A 0x9908b0dfUL   /* constant vector a */
#define UPPER_MASK 0x80000000UL /* most significant w-r bits */
#define LOWER_MASK 0x7fffffffUL /* least significant r bits */

static unsigned long mt[N]; /* the array for the state vector  */
static int mti=N+1; /* mti==N+1 means mt[N] is not initialized */

/* initializes mt[N] with a seed */
void mt_srandom(unsigned long s)
{
    mt[0]= s & 0xffffffffUL;
    for (mti=1; mti<N; mti++) {
        mt[mti] =
            (1812433253UL * (mt[mti-1] ^ (mt[mti-1] >> 30)) + mti);
        /* See Knuth TAOCP Vol2. 3rd Ed. P.106 for multiplier. */
        /* In the previous versions, MSBs of the seed affect   */
        /* only MSBs of the array mt[].                        */
        /* 2002/01/09 modified by Makoto Matsumoto             */
        mt[mti] &= 0xffffffffUL;
        /* for >32 bit machines */
    }
}

/* initialize by an array with array-length */
/* init_key is the array for initializing keys */
/* key_length is its length */
void init_by_array(unsigned long init_key[], unsigned long key_length)
{
    int i, j, k;
    mt_srandom(19650218UL);
    i=1; j=0;
    k = (N>key_length ? N : key_length);
    for (; k; k--) {
        mt[i] = (mt[i] ^ ((mt[i-1] ^ (mt[i-1] >> 30)) * 1664525UL))
          + init_key[j] + j; /* non linear */
        mt[i] &= 0xffffffffUL; /* for WORDSIZE > 32 machines */
        i++; j++;
        if (i>=N) { mt[0] = mt[N-1]; i=1; }
        if (j>=key_length) j=0;
    }
    for (k=N-1; k; k--) {
        mt[i] = (mt[i] ^ ((mt[i-1] ^ (mt[i-1] >> 30)) * 1566083941UL))
          - i; /* non linear */
        mt[i] &= 0xffffffffUL; /* for WORDSIZE > 32 machines */
        i++;
        if (i>=N) { mt[0] = mt[N-1]; i=1; }
    }

    mt[0] = 0x80000000UL; /* MSB is 1; assuring non-zero initial array */
}

/* generates a random number on [0,0xffffffff]-interval */
unsigned long mt_random(void)
{
    unsigned long y;
    static unsigned long mag01[2]={0x0UL, MATRIX_A};
    /* mag01[x] = x * MATRIX_A  for x=0,1 */

    if (mti >= N) { /* generate N words at one time */
        int kk;

        if (mti == N+1)   /* if mt_srandom() has not been called, */
            mt_srandom(5489UL); /* a default initial seed is used */

        for (kk=0;kk<N-M;kk++) {
            y = (mt[kk]&UPPER_MASK)|(mt[kk+1]&LOWER_MASK);
            mt[kk] = mt[kk+M] ^ (y >> 1) ^ mag01[y & 0x1UL];
        }
        for (;kk<N-1;kk++) {
            y = (mt[kk]&UPPER_MASK)|(mt[kk+1]&LOWER_MASK);
            mt[kk] = mt[kk+(M-N)] ^ (y >> 1) ^ mag01[y & 0x1UL];
        }
        y = (mt[N-1]&UPPER_MASK)|(mt[0]&LOWER_MASK);
        mt[N-1] = mt[M-1] ^ (y >> 1) ^ mag01[y & 0x1UL];

        mti = 0;
    }

    y = mt[mti++];

    /* Tempering */
    y ^= (y >> 11);
    y ^= (y << 7) & 0x9d2c5680UL;
    y ^= (y << 15) & 0xefc60000UL;
    y ^= (y >> 18);

    return y;
}

#undef N
#undef M
#undef MATRIX_A
#undef UPPER_MASK
#undef LOWER_MASK

/* End of "Mersenne Twister". */

/* End of McCode random number routine. */

/* randnorm: generate a random number from normal law */
double
randnorm(void)
{
  static double v1, v2, s;
  static int phase = 0;
  double X, u1, u2;

  if(phase == 0)
  {
    do
    {
      u1 = rand01();
      u2 = rand01();
      v1 = 2*u1 - 1;
      v2 = 2*u2 - 1;
      s = v1*v1 + v2*v2;
    } while(s >= 1 || s == 0);

    X = v1*sqrt(-2*log(s)/s);
  }
  else
  {
    X = v2*sqrt(-2*log(s)/s);
  }

  phase = 1 - phase;
  return X;
}

/**
 * Generate a random number from -1 to 1 with triangle distribution
 */
double randtriangle(void) {
	double randnum = rand01();
	if (randnum>0.5) return(1-sqrt(2*(randnum-0.5)));
	else return(sqrt(2*randnum)-1);
}

/**
 * Random number between 0.0 and 1.0 (including?)
 */
double rand01() {
	double randnum;
	randnum = (double) random();
	randnum /= (double) MC_RAND_MAX + 1;
	return randnum;
}

/**
 * Return a random number between 1 and -1
 */
double randpm1() {
	double randnum;
	randnum = (double) random();
	randnum /= ((double) MC_RAND_MAX + 1) / 2;
	randnum -= 1;
	return randnum;
}

/**
 * Return a random number between 0 and max.
 */
double rand0max(double max) {
	double randnum;
	randnum = (double) random();
	randnum /= ((double) MC_RAND_MAX + 1) / max;
	return randnum;
}

/**
 * Return a random number between min and max.
 */
double randminmax(double min, double max) {
	return rand0max(max - min) + max;
}

/* SECTION: main and signal handlers ======================================== */

/*******************************************************************************
* mchelp: displays instrument executable help with possible options
*******************************************************************************/
static void
mchelp(char *pgmname)
{
  int i;

  fprintf(stderr, "%s (%s) instrument simulation, generated with " MCCODE_STRING " (" MCCODE_DATE ")\n", mcinstrument_name, mcinstrument_source);
  fprintf(stderr, "Usage: %s [options] [parm=value ...]\n", pgmname);
  fprintf(stderr,
"Options are:\n"
"  -s SEED   --seed=SEED      Set random seed (must be != 0)\n"
"  -n COUNT  --ncount=COUNT   Set number of " MCCODE_PARTICLE "s to simulate.\n"
"  -d DIR    --dir=DIR        Put all data files in directory DIR.\n"
"  -t        --trace          Enable trace of " MCCODE_PARTICLE "s through instrument.\n"
"  -g        --gravitation    Enable gravitation for all trajectories.\n"
"  --no-output-files          Do not write any data files.\n"
"  -h        --help           Show this help message.\n"
"  -i        --info           Detailed instrument information.\n"
"  --format=FORMAT            Output data files using FORMAT="
   FLAVOR_UPPER
#ifdef USE_NEXUS
   " NEXUS"
#endif
"\n\n"
);
#ifdef USE_MPI
  fprintf(stderr,
  "This instrument has been compiled with MPI support.\n  Use 'mpirun %s [options] [parm=value ...]'.\n", pgmname);
#endif
  if(mcnumipar > 0)
  {
    fprintf(stderr, "Instrument parameters are:\n");
    for(i = 0; i < mcnumipar; i++)
      if (mcinputtable[i].val && strlen(mcinputtable[i].val))
        fprintf(stderr, "  %-16s(%s) [default='%s']\n", mcinputtable[i].name,
        (*mcinputtypes[mcinputtable[i].type].parminfo)(mcinputtable[i].name),
        mcinputtable[i].val);
      else
        fprintf(stderr, "  %-16s(%s)\n", mcinputtable[i].name,
        (*mcinputtypes[mcinputtable[i].type].parminfo)(mcinputtable[i].name));
  }

#ifndef NOSIGNALS
  fprintf(stderr, "Known signals are: "
#ifdef SIGUSR1
  "USR1 (status) "
#endif
#ifdef SIGUSR2
  "USR2 (save) "
#endif
#ifdef SIGBREAK
  "BREAK (save) "
#endif
#ifdef SIGTERM
  "TERM (save and exit)"
#endif
  "\n");
#endif /* !NOSIGNALS */
} /* mchelp */


/* mcshowhelp: show help and exit with 0 */
static void
mcshowhelp(char *pgmname)
{
  mchelp(pgmname);
  exit(0);
}

/* mcusage: display usage when error in input arguments and exit with 1 */
static void
mcusage(char *pgmname)
{
  fprintf(stderr, "Error: incorrect command line arguments\n");
  mchelp(pgmname);
  exit(1);
}

/* mcenabletrace: enable trace/mcdisplay or error if requires recompile */
static void
mcenabletrace(void)
{
 if(mctraceenabled)
  mcdotrace = 1;
 else
 {
   fprintf(stderr,
           "Error: trace not enabled (mcenabletrace)\n"
           "Please re-run the " MCCODE_NAME " compiler "
                   "with the --trace option, or rerun the\n"
           "C compiler with the MC_TRACE_ENABLED macro defined.\n");
   exit(1);
 }
}

/*******************************************************************************
* mcreadparams: request parameters from the prompt (or use default)
*******************************************************************************/
void
mcreadparams(void)
{
  int i,j,status;
  static char buf[CHAR_BUF_LENGTH];
  char *p;
  int len;

  MPI_MASTER(printf("Instrument parameters for %s (%s)\n",
                    mcinstrument_name, mcinstrument_source));

  for(i = 0; mcinputtable[i].name != 0; i++)
  {
    do
    {
      MPI_MASTER(
                 if (mcinputtable[i].val && strlen(mcinputtable[i].val))
                   printf("Set value of instrument parameter %s (%s) [default='%s']:\n",
                          mcinputtable[i].name,
                          (*mcinputtypes[mcinputtable[i].type].parminfo)
                          (mcinputtable[i].name), mcinputtable[i].val);
                 else
                   printf("Set value of instrument parameter %s (%s):\n",
                          mcinputtable[i].name,
                          (*mcinputtypes[mcinputtable[i].type].parminfo)
                          (mcinputtable[i].name));
                 fflush(stdout);
                 );
#ifdef USE_MPI
      if(mpi_node_rank == mpi_node_root)
        {
          p = fgets(buf, CHAR_BUF_LENGTH, stdin);
          if(p == NULL)
            {
              fprintf(stderr, "Error: empty input for paramater %s (mcreadparams)\n", mcinputtable[i].name);
              exit(1);
            }
        }
      else
        p = buf;
      MPI_Bcast(buf, CHAR_BUF_LENGTH, MPI_CHAR, mpi_node_root, MPI_COMM_WORLD);
#else /* !USE_MPI */
      p = fgets(buf, CHAR_BUF_LENGTH, stdin);
      if(p == NULL)
        {
          fprintf(stderr, "Error: empty input for paramater %s (mcreadparams)\n", mcinputtable[i].name);
          exit(1);
        }
#endif /* USE_MPI */
      len = strlen(buf);
      if (!len || (len == 1 && (buf[0] == '\n' || buf[0] == '\r')))
      {
        if (mcinputtable[i].val && strlen(mcinputtable[i].val)) {
          strncpy(buf, mcinputtable[i].val, CHAR_BUF_LENGTH);  /* use default value */
          len = strlen(buf);
        }
      }
      for(j = 0; j < 2; j++)
      {
        if(len > 0 && (buf[len - 1] == '\n' || buf[len - 1] == '\r'))
        {
          len--;
          buf[len] = '\0';
        }
      }

      status = (*mcinputtypes[mcinputtable[i].type].getparm)
                   (buf, mcinputtable[i].par);
      if(!status)
      {
        (*mcinputtypes[mcinputtable[i].type].error)(mcinputtable[i].name, buf);
        if (!mcinputtable[i].val || strlen(mcinputtable[i].val)) {
          fprintf(stderr, "       Change %s default value in instrument definition.\n", mcinputtable[i].name);
          exit(1);
        }
      }
    } while(!status);
  }
} /* mcreadparams */

/*******************************************************************************
* mcparseoptions: parse command line arguments (options, parameters)
*******************************************************************************/
void
mcparseoptions(int argc, char *argv[])
{
  int i, j;
  char *p;
  int paramset = 0, *paramsetarray;
  char *usedir=NULL;

  /* Add one to mcnumipar to avoid allocating zero size memory block. */
  paramsetarray = (int*)malloc((mcnumipar + 1)*sizeof(*paramsetarray));
  if(paramsetarray == NULL)
  {
    fprintf(stderr, "Error: insufficient memory (mcparseoptions)\n");
    exit(1);
  }
  for(j = 0; j < mcnumipar; j++)
    {
      paramsetarray[j] = 0;
      if (mcinputtable[j].val != NULL && strlen(mcinputtable[j].val))
      {
        int  status;
        char buf[CHAR_BUF_LENGTH];
        strncpy(buf, mcinputtable[j].val, CHAR_BUF_LENGTH);
        status = (*mcinputtypes[mcinputtable[j].type].getparm)
                   (buf, mcinputtable[j].par);
        if(!status) fprintf(stderr, "Invalid '%s' default value %s in instrument definition (mcparseoptions)\n", mcinputtable[j].name, buf);
        else paramsetarray[j] = 1;
      } else {
        (*mcinputtypes[mcinputtable[j].type].getparm)
          (NULL, mcinputtable[j].par);
        paramsetarray[j] = 0;
      }
    }
  for(i = 1; i < argc; i++)
  {
    if(!strcmp("-s", argv[i]) && (i + 1) < argc)
      mcsetseed(argv[++i]);
    else if(!strncmp("-s", argv[i], 2))
      mcsetseed(&argv[i][2]);
    else if(!strcmp("--seed", argv[i]) && (i + 1) < argc)
      mcsetseed(argv[++i]);
    else if(!strncmp("--seed=", argv[i], 7))
      mcsetseed(&argv[i][7]);
    else if(!strcmp("-n", argv[i]) && (i + 1) < argc)
      mcsetn_arg(argv[++i]);
    else if(!strncmp("-n", argv[i], 2))
      mcsetn_arg(&argv[i][2]);
    else if(!strcmp("--ncount", argv[i]) && (i + 1) < argc)
      mcsetn_arg(argv[++i]);
    else if(!strncmp("--ncount=", argv[i], 9))
      mcsetn_arg(&argv[i][9]);
    else if(!strcmp("-d", argv[i]) && (i + 1) < argc)
      usedir=argv[++i];  /* will create directory after parsing all arguments (end of this function) */
    else if(!strncmp("-d", argv[i], 2))
      usedir=&argv[i][2];
    else if(!strcmp("--dir", argv[i]) && (i + 1) < argc)
      usedir=argv[++i];
    else if(!strncmp("--dir=", argv[i], 6))
      usedir=&argv[i][6];
    else if(!strcmp("-h", argv[i]))
      mcshowhelp(argv[0]);
    else if(!strcmp("--help", argv[i]))
      mcshowhelp(argv[0]);
    else if(!strcmp("-i", argv[i])) {
      mcformat=FLAVOR_UPPER;
      mcinfo();
    }
    else if(!strcmp("--info", argv[i]))
      mcinfo();
    else if(!strcmp("-t", argv[i]))
      mcenabletrace();
    else if(!strcmp("--trace", argv[i]))
      mcenabletrace();
    else if(!strcmp("--gravitation", argv[i]))
      mcgravitation = 1;
    else if(!strcmp("-g", argv[i]))
      mcgravitation = 1;
    else if(!strncmp("--format=", argv[i], 9)) {
      mcformat=&argv[i][9];
    }
    else if(!strcmp("--format", argv[i]) && (i + 1) < argc) {
      mcformat=argv[++i];
    }
    else if(!strcmp("--no-output-files", argv[i]))
      mcdisable_output_files = 1;
    else if(argv[i][0] != '-' && (p = strchr(argv[i], '=')) != NULL)
    {
      *p++ = '\0';

      for(j = 0; j < mcnumipar; j++)
        if(!strcmp(mcinputtable[j].name, argv[i]))
        {
          int status;
          status = (*mcinputtypes[mcinputtable[j].type].getparm)(p,
                        mcinputtable[j].par);
          if(!status || !strlen(p))
          {
            (*mcinputtypes[mcinputtable[j].type].error)
              (mcinputtable[j].name, p);
            exit(1);
          }
          paramsetarray[j] = 1;
          paramset = 1;
          break;
        }
      if(j == mcnumipar)
      {                                /* Unrecognized parameter name */
        fprintf(stderr, "Error: unrecognized parameter %s (mcparseoptions)\n", argv[i]);
        exit(1);
      }
    }
    else if(argv[i][0] == '-') {
      fprintf(stderr, "Error: unrecognized option argument %s (mcparseoptions). Ignored.\n", argv[i++]);
    }
    else {
      fprintf(stderr, "Error: unrecognized argument %s (mcparseoptions). Aborting.\n", argv[i]);
      mcusage(argv[0]);
    }
  }
  if(!paramset)
    mcreadparams();                /* Prompt for parameters if not specified. */
  else
  {
    for(j = 0; j < mcnumipar; j++)
      if(!paramsetarray[j])
      {
        fprintf(stderr, "Error: Instrument parameter %s left unset (mcparseoptions)\n",
                mcinputtable[j].name);
        exit(1);
      }
  }
  free(paramsetarray);
#ifdef USE_MPI
  if (mcdotrace) mpi_node_count=1; /* disable threading when in trace mode */
#endif
  if (usedir && strlen(usedir) && !mcdisable_output_files) mcuse_dir(usedir);
} /* mcparseoptions */

#ifndef NOSIGNALS
mcstatic char  mcsig_message[256];


/*******************************************************************************
* sighandler: signal handler that makes simulation stop, and save results
*******************************************************************************/
void sighandler(int sig)
{
  /* MOD: E. Farhi, Sep 20th 2001: give more info */
  time_t t1, t0;
#define SIG_SAVE 0
#define SIG_TERM 1
#define SIG_STAT 2
#define SIG_ABRT 3

  printf("\n# " MCCODE_STRING ": [pid %i] Signal %i detected", getpid(), sig);
#ifdef USE_MPI
  printf(" [proc %i]", mpi_node_rank);
#endif
#if defined(SIGUSR1) && defined(SIGUSR2) && defined(SIGKILL)
  if (!strcmp(mcsig_message, "sighandler") && (sig != SIGUSR1) && (sig != SIGUSR2))
  {
    printf("\n# Fatal : unrecoverable loop ! Suicide (naughty boy).\n");
    kill(0, SIGKILL); /* kill myself if error occurs within sighandler: loops */
  }
#endif
  switch (sig) {
#ifdef SIGINT
    case SIGINT : printf(" SIGINT (interrupt from terminal, Ctrl-C)"); sig = SIG_TERM; break;
#endif
#ifdef SIGILL
    case SIGILL  : printf(" SIGILL (Illegal instruction)"); sig = SIG_ABRT; break;
#endif
#ifdef SIGFPE
    case SIGFPE  : printf(" SIGFPE (Math Error)"); sig = SIG_ABRT; break;
#endif
#ifdef SIGSEGV
    case SIGSEGV : printf(" SIGSEGV (Mem Error)"); sig = SIG_ABRT; break;
#endif
#ifdef SIGTERM
    case SIGTERM : printf(" SIGTERM (Termination)"); sig = SIG_TERM; break;
#endif
#ifdef SIGABRT
    case SIGABRT : printf(" SIGABRT (Abort)"); sig = SIG_ABRT; break;
#endif
#ifdef SIGQUIT
    case SIGQUIT : printf(" SIGQUIT (Quit from terminal)"); sig = SIG_TERM; break;
#endif
#ifdef SIGTRAP
    case SIGTRAP : printf(" SIGTRAP (Trace trap)"); sig = SIG_ABRT; break;
#endif
#ifdef SIGPIPE
    case SIGPIPE : printf(" SIGPIPE (Broken pipe)"); sig = SIG_ABRT; break;
#endif
#ifdef SIGUSR1
    case SIGUSR1 : printf(" SIGUSR1 (Display info)"); sig = SIG_STAT; break;
#endif
#ifdef SIGUSR2
    case SIGUSR2 : printf(" SIGUSR2 (Save simulation)"); sig = SIG_SAVE; break;
#endif
#ifdef SIGHUP
    case SIGHUP  : printf(" SIGHUP (Hangup/update)"); sig = SIG_SAVE; break;
#endif
#ifdef SIGBUS
    case SIGBUS  : printf(" SIGBUS (Bus error)"); sig = SIG_ABRT; break;
#endif
#ifdef SIGURG
    case SIGURG  : printf(" SIGURG (Urgent socket condition)"); sig = SIG_ABRT; break;
#endif
#ifdef SIGBREAK
    case SIGBREAK: printf(" SIGBREAK (Break signal, Ctrl-Break)"); sig = SIG_SAVE; break;
#endif
    default : printf(" (look at signal list for signification)"); sig = SIG_ABRT; break;
  }
  printf("\n");
  printf("# Simulation: %s (%s) \n", mcinstrument_name, mcinstrument_source);
  printf("# Breakpoint: %s ", mcsig_message);
  if (strstr(mcsig_message, "Save") && (sig == SIG_SAVE))
    sig = SIG_STAT;
  SIG_MESSAGE("sighandler");
  if (mcget_ncount() == 0)
    printf("(0 %%)\n" );
  else
  {
    printf("%.2f %% (%10.1f/%10.1f)\n", 100.0*mcget_run_num()/mcget_ncount(), 1.0*mcget_run_num(), 1.0*mcget_ncount());
  }
  t0 = (time_t)mcstartdate;
  t1 = time(NULL);
  printf("# Date:      %s", ctime(&t1));
  printf("# Started:   %s", ctime(&t0));

  if (sig == SIG_STAT)
  {
    printf("# " MCCODE_STRING ": Resuming simulation (continue)\n");
    fflush(stdout);
    return;
  }
  else
  if (sig == SIG_SAVE)
  {
    printf("# " MCCODE_STRING ": Saving data and resume simulation (continue)\n");
    mcsave(NULL);
    fflush(stdout);
    return;
  }
  else
  if (sig == SIG_TERM)
  {
    printf("# " MCCODE_STRING ": Finishing simulation (save results and exit)\n");
    mcfinally();
    exit(0);
  }
  else
  {
    fflush(stdout);
    perror("# Last I/O Error");
    printf("# " MCCODE_STRING ": Simulation stop (abort).\n");
// This portion of the signal handling only works on UNIX
#if defined(__unix__) || defined(__APPLE__)
    signal(sig, SIG_DFL); /* force to use default sighandler now */
    kill(getpid(), sig);  /* and trigger it with the current signal */
#endif
    exit(-1);
  }
#undef SIG_SAVE
#undef SIG_TERM
#undef SIG_STAT
#undef SIG_ABRT

} /* sighandler */
#endif /* !NOSIGNALS */

/*******************************************************************************
* mccode_main: McCode main() function.
*******************************************************************************/
int mccode_main(int argc, char *argv[])
{
/*  double run_num = 0; */
  time_t  t;
#ifdef USE_MPI
  char mpi_node_name[MPI_MAX_PROCESSOR_NAME];
  int  mpi_node_name_len;
#endif /* USE_MPI */

#ifdef MAC
  argc = ccommand(&argv);
#endif

#ifdef USE_MPI
  MPI_Init(&argc,&argv);
  MPI_Comm_size(MPI_COMM_WORLD, &mpi_node_count); /* get number of nodes */
  MPI_Comm_rank(MPI_COMM_WORLD, &mpi_node_rank);
  MPI_Comm_set_name(MPI_COMM_WORLD, mcinstrument_name);
  MPI_Get_processor_name(mpi_node_name, &mpi_node_name_len);
#endif /* USE_MPI */

t = time(NULL);
mcseed = (long)t+(long)getpid();

#ifdef USE_MPI
/* *** print number of nodes *********************************************** */
  if (mpi_node_count > 1) {
    MPI_MASTER(
    printf("Simulation '%s' (%s): running on %i nodes (master is '%s', MPI version %i.%i).\n",
      mcinstrument_name, mcinstrument_source, mpi_node_count, mpi_node_name, MPI_VERSION, MPI_SUBVERSION);
    );
  }
#endif /* USE_MPI */
  
  mcstartdate = (long)t;  /* set start date before parsing options and creating sim file */

/* *** parse options ******************************************************* */
  SIG_MESSAGE("main (Start)");
  mcformat=getenv(FLAVOR_UPPER "_FORMAT") ?
           getenv(FLAVOR_UPPER "_FORMAT") : FLAVOR_UPPER;
  mcinstrument_exe = argv[0]; /* store the executable path */
  /* read simulation parameters and options */
  mcparseoptions(argc, argv); /* sets output dir and format */
  
#ifdef USE_MPI
  if (mpi_node_count > 1) {
    /* share the same seed, then adapt random seed for each node */
    MPI_Bcast(&mcseed, 1, MPI_LONG, 0, MPI_COMM_WORLD); /* root sends its seed to slaves */
    mcseed += mpi_node_rank; /* make sure we use different seeds per node */
  }
#endif
  srandom(mcseed);

/* *** install sig handler, but only once !! after parameters parsing ******* */
#ifndef NOSIGNALS
#ifdef SIGQUIT
  if (signal( SIGQUIT ,sighandler) == SIG_IGN)
    signal( SIGQUIT,SIG_IGN);   /* quit (ASCII FS) */
#endif
#ifdef SIGABRT
  if (signal( SIGABRT ,sighandler) == SIG_IGN)
    signal( SIGABRT,SIG_IGN);   /* used by abort, replace SIGIOT in the future */
#endif
#ifdef SIGTERM
  if (signal( SIGTERM ,sighandler) == SIG_IGN)
    signal( SIGTERM,SIG_IGN);   /* software termination signal from kill */
#endif
#ifdef SIGUSR1
  if (signal( SIGUSR1 ,sighandler) == SIG_IGN)
    signal( SIGUSR1,SIG_IGN);   /* display simulation status */
#endif
#ifdef SIGUSR2
  if (signal( SIGUSR2 ,sighandler) == SIG_IGN)
    signal( SIGUSR2,SIG_IGN);
#endif
#ifdef SIGHUP
  if (signal( SIGHUP ,sighandler) == SIG_IGN)
    signal( SIGHUP,SIG_IGN);
#endif
#ifdef SIGILL
  if (signal( SIGILL ,sighandler) == SIG_IGN)
    signal( SIGILL,SIG_IGN);    /* illegal instruction (not reset when caught) */
#endif
#ifdef SIGFPE
  if (signal( SIGFPE ,sighandler) == SIG_IGN)
    signal( SIGSEGV,SIG_IGN);    /* floating point exception */
#endif
#ifdef SIGBUS
  if (signal( SIGBUS ,sighandler) == SIG_IGN)
    signal( SIGSEGV,SIG_IGN);    /* bus error */
#endif
#ifdef SIGSEGV
  if (signal( SIGSEGV ,sighandler) == SIG_IGN)
    signal( SIGSEGV,SIG_IGN);   /* segmentation violation */
#endif
#endif /* !NOSIGNALS */
  mcsiminfo_init(NULL); /* open SIM */
  SIG_MESSAGE("main (Init)");
  mcinit();
#ifndef NOSIGNALS
#ifdef SIGINT
  if (signal( SIGINT ,sighandler) == SIG_IGN)
    signal( SIGINT,SIG_IGN);    /* interrupt (rubout) only after INIT */
#endif
#endif /* !NOSIGNALS */

/* ================ main particle generation/propagation loop ================ */
#if defined (USE_MPI)
  /* sliced Ncount on each MPI node */
  mcncount = mpi_node_count > 1 ?
    floor(mcncount / mpi_node_count) :
    mcncount; /* number of rays per node */
#endif

/* main particle event loop */
while(mcrun_num < mcncount || mcrun_num < mcget_ncount())
  {
#ifndef NEUTRONICS
    mcgenstate();
#endif
    /* old init: mcsetstate(0, 0, 0, 0, 0, 1, 0, sx=0, sy=1, sz=0, 1); */
    mcraytrace();
    mcrun_num++;
  }

#ifdef USE_MPI
 /* merge run_num from MPI nodes */
  if (mpi_node_count > 1) {
  double mcrun_num_double = (double)mcrun_num;
  mc_MPI_Sum(&mcrun_num_double, 1);
  mcrun_num = (unsigned long long)mcrun_num_double;
  }
#endif

/* save/finally executed by master node/thread */
  mcfinally();

#ifdef USE_MPI
  MPI_Finalize();
#endif /* USE_MPI */

  return 0;
} /* mccode_main */

#ifdef NEUTRONICS
/*Main neutronics function steers the McStas calls, initializes parameters etc */
/* Only called in case NEUTRONICS = TRUE */
void neutronics_main_(float *inx, float *iny, float *inz, float *invx, float *invy, float *invz, float *intime, float *insx, float *insy, float *insz, float *inw, float *outx, float *outy, float *outz, float *outvx, float *outvy, float *outvz, float *outtime, float *outsx, float *outsy, float *outsz, float *outwgt)
{

  extern double mcnx, mcny, mcnz, mcnvx, mcnvy, mcnvz;
  extern double mcnt, mcnsx, mcnsy, mcnsz, mcnp;

  /* External code governs iteration - McStas is iterated once per call to neutronics_main. I.e. below counter must be initiancated for each call to neutronics_main*/
  mcrun_num=0;

  time_t t;
  t = (time_t)mcstartdate;
  mcstartdate = t;  /* set start date before parsing options and creating sim file */
  mcinit();

  /* *** parse options *** */
  SIG_MESSAGE("main (Start)");
  mcformat=getenv(FLAVOR_UPPER "_FORMAT") ?
           getenv(FLAVOR_UPPER "_FORMAT") : FLAVOR_UPPER;

  /* Set neutron state based on input from neutronics code */
  mcsetstate(*inx,*iny,*inz,*invx,*invy,*invz,*intime,*insx,*insy,*insz,*inw);

  /* main neutron event loop - runs only one iteration */

  //mcstas_raytrace(&mcncount); /* prior to McStas 1.12 */

  mcallowbackprop = 1; //avoid absorbtion from negative dt
  int argc=1;
  char *argv[0];
  int dummy = mccode_main(argc, argv);

  *outx =  mcnx;
  *outy =  mcny;
  *outz =  mcnz;
  *outvx =  mcnvx;
  *outvy =  mcnvy;
  *outvz =  mcnvz;
  *outtime =  mcnt;
  *outsx =  mcnsx;
  *outsy =  mcnsy;
  *outsz =  mcnsz;
  *outwgt =  mcnp;

  return;
} /* neutronics_main */

#endif /*NEUTRONICS*/

#endif /* !MCCODE_H */
/* End of file "mccode-r.c". */
/* End of file "mccode-r.c". */

#line 4976 "MACS_sample_kidney_box.c"

#line 1 "mcstas-r.c"
/*******************************************************************************
*
* McStas, neutron ray-tracing package
*         Copyright (C) 1997-2009, All rights reserved
*         Risoe National Laboratory, Roskilde, Denmark
*         Institut Laue Langevin, Grenoble, France
*
* Runtime: share/mcstas-r.c
*
* %Identification
* Written by: KN
* Date:    Aug 29, 1997
* Release: McStas X.Y
* Version: $Revision$
*
* Runtime system for McStas.
* Embedded within instrument in runtime mode.
*
* Usage: Automatically embbeded in the c code whenever required.
*
* $Id$
*
*******************************************************************************/

#ifndef MCSTAS_R_H
#include "mcstas-r.h"
#endif
#ifdef DANSE
#include "mcstas-globals.h"
#endif

/*******************************************************************************
* The I/O format definitions and functions
*******************************************************************************/

/*the magnet stack*/
#ifdef MC_POL_COMPAT
void (*mcMagnetPrecession) (double, double, double, double, double, double,
    double, double*, double*, double*, double, Coords, Rotation)=NULL;
Coords   mcMagnetPos;
Rotation mcMagnetRot;
double*  mcMagnetData                = NULL;
/* mcMagneticField(x, y, z, t, Bx, By, Bz) */
int (*mcMagneticField) (double, double, double, double,
    double*, double*, double*, void *) = NULL;
#endif

#ifndef MCSTAS_H

/*******************************************************************************
* mcstore_neutron: stores neutron coodinates into global array (per component)
*******************************************************************************/
void
mcstore_neutron(MCNUM *s, int index, double x, double y, double z,
               double vx, double vy, double vz, double t,
               double sx, double sy, double sz, double p)
{
    double *dptr = &s[11*index];
    *dptr++  = x;
    *dptr++  = y ;
    *dptr++  = z ;
    *dptr++  = vx;
    *dptr++  = vy;
    *dptr++  = vz;
    *dptr++  = t ;
    *dptr++  = sx;
    *dptr++  = sy;
    *dptr++  = sz;
    *dptr    = p ;
} /* mcstore_neutron */

/*******************************************************************************
* mcrestore_neutron: restores neutron coodinates from global array
*******************************************************************************/
void
mcrestore_neutron(MCNUM *s, int index, double *x, double *y, double *z,
               double *vx, double *vy, double *vz, double *t,
               double *sx, double *sy, double *sz, double *p)
{
    double *dptr = &s[11*index];
    *x  =  *dptr++;
    *y  =  *dptr++;
    *z  =  *dptr++;
    *vx =  *dptr++;
    *vy =  *dptr++;
    *vz =  *dptr++;
    *t  =  *dptr++;
    *sx =  *dptr++;
    *sy =  *dptr++;
    *sz =  *dptr++;
    *p  =  *dptr;
} /* mcrestore_neutron */

/*******************************************************************************
* mcsetstate: transfer parameters into global McStas variables 
*******************************************************************************/
void
mcsetstate(double x, double y, double z, double vx, double vy, double vz,
           double t, double sx, double sy, double sz, double p)
{
  extern double mcnx, mcny, mcnz, mcnvx, mcnvy, mcnvz;
  extern double mcnt, mcnsx, mcnsy, mcnsz, mcnp;

  mcnx = x;
  mcny = y;
  mcnz = z;
  mcnvx = vx;
  mcnvy = vy;
  mcnvz = vz;
  mcnt = t;
  mcnsx = sx;
  mcnsy = sy;
  mcnsz = sz;
  mcnp = p;
} /* mcsetstate */

/*******************************************************************************
* mcgenstate: set default neutron parameters 
*******************************************************************************/
void
mcgenstate(void)
{
  mcsetstate(0, 0, 0, 0, 0, 1, 0, 0, 0, 0, 1);
  /* old initialisation: mcsetstate(0, 0, 0, 0, 0, 1, 0, sx=0, sy=1, sz=0, 1); */
}

/* intersection routines ==================================================== */

/*******************************************************************************
* inside_rectangle: Check if (x,y) is inside rectangle (xwidth, yheight) 
* return 0 if outside and 1 if inside 
*******************************************************************************/
int inside_rectangle(double x, double y, double xwidth, double yheight)
{
  if (x>-xwidth/2 && x<xwidth/2 && y>-yheight/2 && y<yheight/2)
    return 1;
  else
    return 0;
}

/*******************************************************************************
 * box_intersect: compute time intersection with a box
 * returns 0 when no intersection is found
 *      or 1 in case of intersection with resulting times dt_in and dt_out
 * This function written by Stine Nyborg, 1999. 
 *******************************************************************************/
int box_intersect(double *dt_in, double *dt_out,
                  double x, double y, double z,
                  double vx, double vy, double vz,
                  double dx, double dy, double dz)
{
  double x_in, y_in, z_in, tt, t[6], a, b;
  int i, count, s;

      /* Calculate intersection time for each of the six box surface planes
       *  If the box surface plane is not hit, the result is zero.*/

  if(vx != 0)
   {
    tt = -(dx/2 + x)/vx;
    y_in = y + tt*vy;
    z_in = z + tt*vz;
    if( y_in > -dy/2 && y_in < dy/2 && z_in > -dz/2 && z_in < dz/2)
      t[0] = tt;
    else
      t[0] = 0;

    tt = (dx/2 - x)/vx;
    y_in = y + tt*vy;
    z_in = z + tt*vz;
    if( y_in > -dy/2 && y_in < dy/2 && z_in > -dz/2 && z_in < dz/2)
      t[1] = tt;
    else
      t[1] = 0;
   }
  else
    t[0] = t[1] = 0;

  if(vy != 0)
   {
    tt = -(dy/2 + y)/vy;
    x_in = x + tt*vx;
    z_in = z + tt*vz;
    if( x_in > -dx/2 && x_in < dx/2 && z_in > -dz/2 && z_in < dz/2)
      t[2] = tt;
    else
      t[2] = 0;

    tt = (dy/2 - y)/vy;
    x_in = x + tt*vx;
    z_in = z + tt*vz;
    if( x_in > -dx/2 && x_in < dx/2 && z_in > -dz/2 && z_in < dz/2)
      t[3] = tt;
    else
      t[3] = 0;
   }
  else
    t[2] = t[3] = 0;

  if(vz != 0)
   {
    tt = -(dz/2 + z)/vz;
    x_in = x + tt*vx;
    y_in = y + tt*vy;
    if( x_in > -dx/2 && x_in < dx/2 && y_in > -dy/2 && y_in < dy/2)
      t[4] = tt;
    else
      t[4] = 0;

    tt = (dz/2 - z)/vz;
    x_in = x + tt*vx;
    y_in = y + tt*vy;
    if( x_in > -dx/2 && x_in < dx/2 && y_in > -dy/2 && y_in < dy/2)
      t[5] = tt;
    else
      t[5] = 0;
   }
  else
    t[4] = t[5] = 0;

  /* The intersection is evaluated and *dt_in and *dt_out are assigned */

  a = b = s = 0;
  count = 0;

  for( i = 0; i < 6; i = i + 1 )
    if( t[i] == 0 )
      s = s+1;
    else if( count == 0 )
    {
      a = t[i];
      count = 1;
    }
    else
    {
      b = t[i];
      count = 2;
    }

  if ( a == 0 && b == 0 )
    return 0;
  else if( a < b )
  {
    *dt_in = a;
    *dt_out = b;
    return 1;
  }
  else
  {
    *dt_in = b;
    *dt_out = a;
    return 1;
  }

} /* box_intersect */

/*******************************************************************************
 * cylinder_intersect: compute intersection with a cylinder
 * returns 0 when no intersection is found
 *      or 2/4/8/16 bits depending on intersection,
 *     and resulting times t0 and t1
 * Written by: EM,NB,ABA 4.2.98 
  *******************************************************************************/
int
cylinder_intersect(double *t0, double *t1, double x, double y, double z,
                   double vx, double vy, double vz, double r, double h)
{
  double D, t_in, t_out, y_in, y_out;
  int ret=1;

  D = (2*vx*x + 2*vz*z)*(2*vx*x + 2*vz*z)
    - 4*(vx*vx + vz*vz)*(x*x + z*z - r*r);

  if (D>=0)
  {
    if (vz*vz + vx*vx) {
      t_in  = (-(2*vz*z + 2*vx*x) - sqrt(D))/(2*(vz*vz + vx*vx));
      t_out = (-(2*vz*z + 2*vx*x) + sqrt(D))/(2*(vz*vz + vx*vx));
    } else if (vy) { /* trajectory parallel to cylinder axis */
      t_in = (-h/2-y)/vy;
      t_out = (h/2-y)/vy;
      if (t_in>t_out){
        double tmp=t_in;
        t_in=t_out;t_out=tmp;
      }
    } else return 0;
    y_in = vy*t_in + y;
    y_out =vy*t_out + y;

    if ( (y_in > h/2 && y_out > h/2) || (y_in < -h/2 && y_out < -h/2) )
      return 0;
    else
    {
      if (y_in > h/2)
        { t_in = ((h/2)-y)/vy; ret += 2; }
      else if (y_in < -h/2)
        { t_in = ((-h/2)-y)/vy; ret += 4; }
      if (y_out > h/2)
        { t_out = ((h/2)-y)/vy; ret += 8; }
      else if (y_out < -h/2)
        { t_out = ((-h/2)-y)/vy; ret += 16; }
    }
    *t0 = t_in;
    *t1 = t_out;
    return ret;
  }
  else
  {
    *t0 = *t1 = 0;
    return 0;
  }
} /* cylinder_intersect */


/*******************************************************************************
 * sphere_intersect: Calculate intersection between a line and a sphere.
 * returns 0 when no intersection is found
 *      or 1 in case of intersection with resulting times t0 and t1 
 *******************************************************************************/
int
sphere_intersect(double *t0, double *t1, double x, double y, double z,
                 double vx, double vy, double vz, double r)
{
  double A, B, C, D, v;

  v = sqrt(vx*vx + vy*vy + vz*vz);
  A = v*v;
  B = 2*(x*vx + y*vy + z*vz);
  C = x*x + y*y + z*z - r*r;
  D = B*B - 4*A*C;
  if(D < 0)
    return 0;
  D = sqrt(D);
  *t0 = (-B - D) / (2*A);
  *t1 = (-B + D) / (2*A);
  return 1;
} /* sphere_intersect */

/*******************************************************************************
 * plane_intersect: Calculate intersection between a plane and a line.
 * returns 0 when no intersection is found (i.e. line is parallel to the plane)
 * returns 1 or -1 when intersection time is positive and negative respectively
 *******************************************************************************/
int
plane_intersect(double *t, double x, double y, double z,
                 double vx, double vy, double vz, double nx, double ny, double nz, double wx, double wy, double wz)
{
  double s;
  if (fabs(s=scalar_prod(nx,ny,nz,vx,vy,vz))<FLT_EPSILON) return 0;
  *t = - scalar_prod(nx,ny,nz,x-wx,y-wy,z-wz)/s;
  if (*t<0) return -1;
  else return 1;
} /* plane_intersect */

#endif /* !MCSTAS_H */
/* End of file "mcstas-r.c". */

#line 5336 "MACS_sample_kidney_box.c"
#ifdef MC_TRACE_ENABLED
int mctraceenabled = 1;
#else
int mctraceenabled = 0;
#endif
#define MCSTAS "/usr/share/mcstas/2.7/"
int mcdefaultmain = 1;
char mcinstrument_name[] = "dmtas";
char mcinstrument_source[] = "MACS_sample_kidney_box.instr";
char *mcinstrument_exe=NULL; /* will be set to argv[0] in main */
int main(int argc, char *argv[]){return mccode_main(argc, argv);}
void mcinit(void);
void mcraytrace(void);
void mcsave(FILE *);
void mcfinally(void);
void mcdisplay(void);

/* Shared user declarations for all components 'Incoherent_process'. */
#line 62 "Incoherent_process.comp"
#ifndef Union
#define Union $Revision: 0.8 $

#include "Union_functions.c"
#include "Union_initialization.c"

#endif


struct Incoherent_physics_storage_struct{
    // Variables that needs to be transfered between any of the following places:
    // The initialize in this component
    // The function for calculating my
    // The function for calculating scattering
    
    double my_scattering;
    double QE_sampling_frequency;
    double lorentzian_width;
    
};

// Function for calculating my in Incoherent case
int Incoherent_physics_my(double *my,double *k_initial, union data_transfer_union data_transfer, struct focus_data_struct *focus_data) {
    *my = data_transfer.pointer_to_a_Incoherent_physics_storage_struct->my_scattering;
    return 1;
};

// Function for basic incoherent scattering event
int Incoherent_physics_scattering(double *k_final, double *k_initial, double *weight, union data_transfer_union data_transfer, struct focus_data_struct *focus_data) {

    //New version of incoherent scattering
    double k_length = sqrt(k_initial[0]*k_initial[0]+k_initial[1]*k_initial[1]+k_initial[2]*k_initial[2]);

    Coords k_out;
    // Here is the focusing system in action, get a vector
    double solid_angle;
    focus_data->focusing_function(&k_out,&solid_angle,focus_data);
    NORM(k_out.x,k_out.y,k_out.z);
    *weight *= solid_angle*0.25/PI;
    
    double v_i,v_f,E_i,dE,E_f;
    
    if (rand01() < data_transfer.pointer_to_a_Incoherent_physics_storage_struct->QE_sampling_frequency) {
      v_i = k_length * K2V;
      E_i = VS2E*v_i*v_i;
      dE = data_transfer.pointer_to_a_Incoherent_physics_storage_struct->lorentzian_width*tan(PI/2*randpm1());
      E_f = E_i + dE;
      if (E_f <= 0)
        return 0;
      v_f = SE2V*sqrt(E_f);
      k_length = v_f*V2K;
    }
    
    k_final[0] = k_out.x*k_length; k_final[1] = k_out.y*k_length; k_final[2] = k_out.z*k_length;
    return 1;
};

#line 5413 "MACS_sample_kidney_box.c"

/* Shared user declarations for all components 'Powder_process'. */
#line 57 "Powder_process.comp"
#ifndef Union
#define Union $Revision: 0.8 $

#include "Union_functions.c"
#include "Union_initialization.c"

#endif



// Share section of PowderN 8/3 2016 from McStas.org

  /* used for reading data table from file */
/*******************************************************************************
*
* McStas, neutron ray-tracing package
*         Copyright 1997-2002, All rights reserved
*         Risoe National Laboratory, Roskilde, Denmark
*         Institut Laue Langevin, Grenoble, France
*
* Library: share/read_table-lib.h
*
* %Identification
* Written by: EF
* Date: Aug 28, 2002
* Origin: ILL
* Release: McStas 1.6
* Version: $Revision$
*
* This file is to be imported by components that may read data from table files
* It handles some shared functions.
*
* This library may be used directly as an external library. It has no dependency
*
* Usage: within SHARE
* %include "read_table-lib"
*
*******************************************************************************/

#ifndef READ_TABLE_LIB_H
#define READ_TABLE_LIB_H "$Revision$"

#define READ_TABLE_STEPTOL  0.04 /* tolerancy for constant step approx */

#ifndef MC_PATHSEP_C
#ifdef WIN32
#define MC_PATHSEP_C '\\'
#define MC_PATHSEP_S "\\"
#else  /* !WIN32 */
#ifdef MAC
#define MC_PATHSEP_C ':'
#define MC_PATHSEP_S ":"
#else  /* !MAC */
#define MC_PATHSEP_C '/'
#define MC_PATHSEP_S "/"
#endif /* !MAC */
#endif /* !WIN32 */
#endif /* !MC_PATHSEP_C */

#ifndef MCSTAS
#ifdef WIN32
#define MCSTAS "C:\\mcstas\\lib"
#else  /* !WIN32 */
#ifdef MAC
#define MCSTAS ":mcstas:lib" /* ToDo: What to put here? */
#else  /* !MAC */
#define MCSTAS "/usr/local/lib/mcstas"
#endif /* !MAC */
#endif /* !WIN32 */
#endif /* !MCSTAS */

#include <sys/stat.h>
#include <stdio.h>
#include <stdlib.h>

  typedef struct struct_table
  {
    char    filename[1024];
    long    filesize;
    char   *header;  /* text header, e.g. comments */
    double *data;    /* vector { x[0], y[0], ... x[n-1], y[n-1]... } */
    double  min_x;   /* min value of first column */
    double  max_x;   /* max value of first column */
    double  step_x;  /* minimal step value of first column */
    long    rows;    /* number of rows in matrix block */
    long    columns; /* number of columns in matrix block */

    long    begin;   /* start fseek index of block */
    long    end;     /* stop  fseek index of block */
    long    block_number;  /* block index. 0 is catenation of all */
    long    array_length;  /* number of elements in the t_Table array */
    char    monotonic;     /* true when 1st column/vector data is monotonic */
    char    constantstep;  /* true when 1st column/vector data has constant step */
    char    method[32];    /* interpolation method: nearest, linear */
  } t_Table;

/*maximum number of rows to rebin a table = 1M*/
enum { mcread_table_rebin_maxsize = 1000000 };

typedef struct t_Read_table_file_item {
    int ref_count;
    t_Table *table_ref;
} t_Read_table_file_item;

typedef enum enum_Read_table_file_actions {STORE,FIND,GC}  t_Read_table_file_actions;

/* read_table-lib function prototypes */
/* ========================================================================= */

/* 'public' functions */
long     Table_Read              (t_Table *Table, char *File, long block_number);
long     Table_Read_Offset       (t_Table *Table, char *File, long block_number,
                                  long *offset, long max_lines);
long     Table_Read_Offset_Binary(t_Table *Table, char *File, char *Type,
                                  long *Offset, long Rows, long Columns);
long     Table_Rebin(t_Table *Table); /* rebin table with regular 1st column and interpolate all columns 2:end */
long     Table_Info (t_Table Table);
double   Table_Index(t_Table Table,   long i, long j); /* get indexed value */
double   Table_Value(t_Table Table, double X, long j); /* search X in 1st column and return interpolated value in j-column */
t_Table *Table_Read_Array(char *File, long *blocks);
void     Table_Free_Array(t_Table *Table);
long     Table_Info_Array(t_Table *Table);
int      Table_SetElement(t_Table *Table, long i, long j, double value);
long     Table_Init(t_Table *Table, long rows, long columns); /* create a Table */
double   Table_Value2d(t_Table Table, double X, double Y);    /* same as Table_Index with non-integer indices and 2d interpolation */
MCDETECTOR Table_Write(t_Table Table, char*file, char*xl, char*yl, 
           double x1, double x2, double y1, double y2); /* write Table to disk */
void * Table_File_List_Handler(t_Read_table_file_actions action, void *item, void *item_modifier);
t_Table *Table_File_List_find(char *name, int block, int offset);
int Table_File_List_gc(t_Table *tab);
void *Table_File_List_store(t_Table *tab);

#define Table_ParseHeader(header, ...) \
  Table_ParseHeader_backend(header,__VA_ARGS__,NULL);

char **Table_ParseHeader_backend(char *header, ...);

/* private functions */
void Table_Free(t_Table *Table);
long Table_Read_Handle(t_Table *Table, FILE *fid, long block_number, long max_lines, char *name);
static void Table_Stat(t_Table *Table);
double Table_Interp1d(double x, double x1, double y1, double x2, double y2);
double Table_Interp1d_nearest(double x, double x1, double y1, double x2, double y2);
double Table_Interp2d(double x, double y, double x1, double y1, double x2, double y2,
double z11, double z12, double z21, double z22);

#endif

/* end of read_table-lib.h */
/*******************************************************************************
*
* McStas, neutron ray-tracing package
*         Copyright (C) 1997-2009, All rights reserved
*         Risoe National Laboratory, Roskilde, Denmark
*         Institut Laue Langevin, Grenoble, France
*
* Library: share/read_table-lib.c
*
* %Identification
* Written by: EF
* Date: Aug 28, 2002
* Origin: ILL
* Release: McStas CVS_090504
* Version: $Revision: 5052 $
*
* This file is to be imported by components that may read data from table files
* It handles some shared functions. Embedded within instrument in runtime mode.
*
* Usage: within SHARE
* %include "read_table-lib"
*
*******************************************************************************/

#ifndef READ_TABLE_LIB_H
#include "read_table-lib.h"
#endif


/*******************************************************************************
 * void *Table_File_List_Handler(action, item, item_modifier)
 *   ACTION: handle file entries in the read_table-lib file list. If a file is read - it is supposed to be
 *   stored in a list such that we can avoid reading the same file many times.
 *   input  action: FIND, STORE, GC. check if file exists in the list, store an item in the list, or check if it can be garbage collected.
 *   input item: depends on the action.
 *    FIND)  item is a filename, and item_modifier is the block number
 *    STORE) item is the Table to store - item_modifier is ignored
 *    GC)    item is the Table to check. If it has a ref_count >1 then this is simply decremented.
 *   return  depends on the action
 *    FIND)  return a reference to a table+ref_count item if found - NULL otherwise. I.e. NULL means the file has not been read before and must be read again.
 *    STORE) return NULL always
 *    GC)    return NULL if no garbage collection is needed, return an adress to the t_Table which should be garbage collected. 0x1 is returned if
 *           the item is not found in the list
*******************************************************************************/
void * Table_File_List_Handler(t_Read_table_file_actions action, void *item, void *item_modifier){

    /* logic here is Read_Table should include a call to FIND. If found the return value should just be used as
     * if the table had been read from disk. If not found then read the table and STORE.
     * Table_Free should include a call to GC. If this returns non-NULL then we should proceed with freeing the memory
     * associated with the table item - otherwise only decrement the reference counter since there are more references
     * that may need it.*/

    static t_Read_table_file_item read_table_file_list[1024];  
    static int read_table_file_count=0;

    t_Read_table_file_item *tr;
    switch(action){
        case FIND:
            /*interpret data item as a filename, if it is found return a pointer to the table and increment refcount.
             * if not found return the item itself*/
            tr=read_table_file_list;
            while ( tr->table_ref!=NULL ){
                int i=*((int*) item_modifier);
                int j=*( ((int*) item_modifier)+1);
                if ( !strcmp(tr->table_ref->filename,(char *) item) &&
                        tr->table_ref->block_number==i && tr->table_ref->begin==j ){
                    tr->ref_count++;
                    return (void *) tr;
                }
                tr++;
            }
            return NULL;
        case STORE:
            /*find an available slot and store references to table there*/
            tr=&(read_table_file_list[read_table_file_count++]);
            tr->table_ref = ((t_Table *) item);
            tr->ref_count++;
            return NULL;
        case GC:
            /* Should this item be garbage collected (freed) - if so scratch the entry and return the address of the item - 
             * else decrement ref_count and return NULL.
             * A non-NULL return expects the item to actually be freed afterwards.*/
            tr=read_table_file_list;
            while ( tr->table_ref!=NULL ){
                if ( tr->table_ref->data ==((t_Table *)item)->data && 
                        tr->table_ref->block_number == ((t_Table *)item)->block_number){
                    /*matching item found*/
                    if (tr->ref_count>1){
                        /*the item is found and no garbage collection needed*/
                        tr->ref_count--;
                        return NULL;
                    }else{
                        /* The item is found and the reference counter is 1.
                         * This means we should garbage collect. Move remaining list items up one slot,
                         * and return the table for garbage collection by caller*/
                        while (tr->table_ref!=NULL){
                            *tr=*(tr+1);
                            tr++;
                        }
                        read_table_file_count--;
                        return (t_Table *) item;
                    }
                }
                tr++;
            }
            /* item not found, and so should be garbage collected. This could be the case if freeing a
             * Table that has been constructed from code - not read from file. Return 0x1 to flag it for
             * collection.*/
            return (void *) 0x1 ;
    }
}

/* Access functions to the handler*/

/********************************************
 * t_Table *Table_File_List_find(char *name, int block, int offset)
 * input name: filename to search for in the file list
 * input block: data block in the file as each file may contain more than 1 data block.
 * return a ref. to a table if it is found (you may use this pointer and skip reading the file), NULL otherwise (i.e. go ahead and read the file)
*********************************************/
t_Table *Table_File_List_find(char *name, int block, int offset){
    int vars[2]={block,offset};
    t_Read_table_file_item *item = Table_File_List_Handler(FIND,name, vars);
    if (item == NULL){
        return NULL;
    }else{
        return item->table_ref;
    }
}
/********************************************
 * int Table_File_List_gc(t_Table *tab)
 * input tab: the table to check for references.
 * return 0: no garbage collection needed
 *        1: Table's data and header (at least) should be freed.
*********************************************/
int Table_File_List_gc(t_Table *tab){
    void *rval=Table_File_List_Handler(GC,tab,0);
    if (rval==NULL) return 0;
    else return 1;
}


/*****************************************************************************
 * void *Table_File_List_store(t_Table *tab)
 * input tab: pointer to table to store.
 * return None. 
*******************************************************************************/
void *Table_File_List_store(t_Table *tab){
    return Table_File_List_Handler(STORE,tab,0);
}


/*******************************************************************************
* FILE *Open_File(char *name, char *Mode, char *path)
*   ACTION: search for a file and open it. Optionally return the opened path.
*   input   name:  file name from which table should be extracted
*           mode: "r", "w", "a" or any valid fopen mode
*           path:  NULL or a pointer to at least 1024 allocated chars
*   return  initialized file handle or NULL in case of error
*******************************************************************************/

  FILE *Open_File(char *File, const char *Mode, char *Path)
  {
    char path[1024];
    FILE *hfile = NULL;
    
    if (!File || File[0]=='\0')                     return(NULL);
    if (!strcmp(File,"NULL") || !strcmp(File,"0"))  return(NULL);
    
    /* search in current or full path */
    strncpy(path, File, 1024);
    hfile = fopen(path, Mode);
    if(!hfile)
    {
      char dir[1024];

      if (!hfile && mcinstrument_source[0] != '\0' && strlen(mcinstrument_source)) /* search in instrument source location */
      {
        char *path_pos   = NULL;
        /* extract path: searches for last file separator */
        path_pos    = strrchr(mcinstrument_source, MC_PATHSEP_C);  /* last PATHSEP */
        if (path_pos) {
          long path_length = path_pos +1 - mcinstrument_source;  /* from start to path+sep */
          if (path_length) {
            strncpy(dir, mcinstrument_source, path_length);
            dir[path_length] = '\0';
            snprintf(path, 1024, "%s%c%s", dir, MC_PATHSEP_C, File);
            hfile = fopen(path, Mode);
          }
        }
      }
      if (!hfile && mcinstrument_exe[0] != '\0' && strlen(mcinstrument_exe)) /* search in PWD instrument executable location */
      {
        char *path_pos   = NULL;
        /* extract path: searches for last file separator */
        path_pos    = strrchr(mcinstrument_exe, MC_PATHSEP_C);  /* last PATHSEP */
        if (path_pos) {
          long path_length = path_pos +1 - mcinstrument_exe;  /* from start to path+sep */
          if (path_length) {
            strncpy(dir, mcinstrument_exe, path_length);
            dir[path_length] = '\0';
            snprintf(path, 1024, "%s%c%s", dir, MC_PATHSEP_C, File);
            hfile = fopen(path, Mode);
          }
        }
      }
      if (!hfile) /* search in HOME or . */
      {
        strcpy(dir, getenv("HOME") ? getenv("HOME") : ".");
        snprintf(path, 1024, "%s%c%s", dir, MC_PATHSEP_C, File);
        hfile = fopen(path, Mode);
      }
      if (!hfile) /* search in MCSTAS/data */
      {
        strcpy(dir, getenv(FLAVOR_UPPER) ? getenv(FLAVOR_UPPER) : MCSTAS);
        snprintf(path, 1024, "%s%c%s%c%s", dir, MC_PATHSEP_C, "data", MC_PATHSEP_C, File);
        hfile = fopen(path, Mode);
      }
      if (!hfile) /* search in MVCSTAS/contrib */
      {
        strcpy(dir, getenv(FLAVOR_UPPER) ? getenv(FLAVOR_UPPER) : MCSTAS);
        snprintf(path, 1024, "%s%c%s%c%s", dir, MC_PATHSEP_C, "contrib", MC_PATHSEP_C, File);
        hfile = fopen(path, Mode);
      }
      if(!hfile)
      {
        fprintf(stderr, "Error: Could not open input file '%s' (Open_File)\n", File);
        return (NULL);
      }
    }
    if (Path) strncpy(Path, path, 1024);
    return(hfile);
  } /* end Open_File */

/*******************************************************************************
* long Read_Table(t_Table *Table, char *name, int block_number)
*   ACTION: read a single Table from a text file
*   input   Table: pointer to a t_Table structure
*           name:  file name from which table should be extracted
*           block_number: if the file does contain more than one
*                 data block, then indicates which one to get (from index 1)
*                 a 0 value means append/catenate all
*   return  initialized single Table t_Table structure containing data, header, ...
*           number of read elements (-1: error, 0:header only)
* The routine stores any line starting with '#', '%' and ';' into the header
* File is opened, read and closed
* Other lines are interpreted as numerical data, and stored.
* Data block should be a rectangular matrix or vector.
* Data block may be rebinned with Table_Rebin (also sort in ascending order)
*******************************************************************************/
  long Table_Read(t_Table *Table, char *File, long block_number)
  { /* reads all or a single data block from 'file' and returns a Table structure  */
    return(Table_Read_Offset(Table, File, block_number, NULL, 0));
  } /* end Table_Read */

/*******************************************************************************
* long Table_Read_Offset(t_Table *Table, char *name, int block_number, long *offset
*                        long max_rows)
*   ACTION: read a single Table from a text file, starting at offset
*     Same as Table_Read(..) except:
*   input   offset:    pointer to an offset (*offset should be 0 at start)
*           max_rows: max number of data rows to read from file (0 means all)
*   return  initialized single Table t_Table structure containing data, header, ...
*           number of read elements (-1: error, 0:header only)
*           updated *offset position (where end of reading occured)
*******************************************************************************/
  long Table_Read_Offset(t_Table *Table, char *File,
                         long block_number, long *offset,
                         long max_rows)
  { /* reads all/a data block in 'file' and returns a Table structure  */
    FILE *hfile;
    long  nelements=0;
    long  begin=0;
    long  filesize=0;
    char  name[1024];
    char  path[1024];
    struct stat stfile;

    /*Need to be able to store the pointer*/
    if (!Table) return(-1);
    
    //if (offset && *offset) snprintf(name, 1024, "%s@%li", File, *offset);
    //else                   
    strncpy(name, File, 1024);
    if(offset && *offset){
        begin=*offset;
    }
    /* Check if the table has already been read from file.
     * If so just reuse the table, if not (this is flagged by returning NULL
     * set up a new table and read the data into it */
    t_Table *tab_p= Table_File_List_find(name,block_number,begin);
    if ( tab_p!=NULL ){
        /*table was found in the Table_File_List*/
        // printf("Reusing input file '%s' (Table_Read_Offset)\n", name);
        *Table=*tab_p;
        return Table->rows*Table->columns;
    }

    /* open the file */
    hfile = Open_File(File, "r", path);
    if (!hfile) return(-1);
    else {
      MPI_MASTER(
      printf("Opening input file '%s' (Table_Read_Offset)\n", path);
      );
    }
    
    /* read file state */
    stat(path,&stfile); filesize = stfile.st_size;
    if (offset && *offset) fseek(hfile, *offset, SEEK_SET);
    begin     = ftell(hfile);
    
    Table_Init(Table, 0, 0);

    /* read file content and set the Table */
    nelements = Table_Read_Handle(Table, hfile, block_number, max_rows, name);
    Table->begin = begin;
    Table->end   = ftell(hfile);
    Table->filesize = (filesize>0 ? filesize : 0);
    Table_Stat(Table);
    
    Table_File_List_store(Table);

    if (offset) *offset=Table->end;
    fclose(hfile);
    return(nelements);

  } /* end Table_Read_Offset */

/*******************************************************************************
* long Table_Read_Offset_Binary(t_Table *Table, char *File, char *type,
*                               long *offset, long rows, long columns)
*   ACTION: read a single Table from a binary file, starting at offset
*     Same as Table_Read_Offset(..) except that it handles binary files.
*   input   type: may be "float"/NULL or "double"
*           offset: pointer to an offset (*offset should be 0 at start)
*           rows   : number of rows (0 means read all)
*           columns: number of columns
*   return  initialized single Table t_Table structure containing data, header, ...
*           number of read elements (-1: error, 0:header only)
*           updated *offset position (where end of reading occured)
*******************************************************************************/
  long Table_Read_Offset_Binary(t_Table *Table, char *File, char *type,
                                long *offset, long rows, long columns)
  { /* reads all/a data block in binary 'file' and returns a Table structure  */
    long    nelements, sizeofelement;
    long    filesize;
    FILE   *hfile;
    char    path[1024];
    struct stat stfile;
    double *data;
    long    i;
    long    begin;

    if (!Table) return(-1);

    Table_Init(Table, 0, 0);
    
    /* open the file */
    hfile = Open_File(File, "r", path);
    if (!hfile) return(-1);
    else {
      MPI_MASTER(
      printf("Opening input file '%s' (Table_Read, Binary)\n", path);
      );
    }
    
    /* read file state */
    stat(File,&stfile);
    filesize = stfile.st_size;
    Table->filesize=filesize;
    
    /* read file content */
    if (type && !strcmp(type,"double")) sizeofelement = sizeof(double);
    else  sizeofelement = sizeof(float);
    if (offset && *offset) fseek(hfile, *offset, SEEK_SET);
    begin     = ftell(hfile);
    if (rows && filesize > sizeofelement*columns*rows)
      nelements = columns*rows;
    else nelements = (long)(filesize/sizeofelement);
    if (!nelements || filesize <= *offset) return(0);
    data    = (double*)malloc(nelements*sizeofelement);
    if (!data) {
      fprintf(stderr,"Error: allocating %ld elements for %s file '%s'. Too big (Table_Read_Offset_Binary).\n", nelements, type, File);
      exit(-1);
    }
    nelements = fread(data, sizeofelement, nelements, hfile);

    if (!data || !nelements)
    {
      fprintf(stderr,"Error: reading %ld elements from %s file '%s' (Table_Read_Offset_Binary)\n", nelements, type, File);
      exit(-1);
    }
    Table->begin   = begin;
    Table->end     = ftell(hfile);
    if (offset) *offset=Table->end;
    fclose(hfile);
    data = (double*)realloc(data, (double)nelements*sizeofelement);
    /* copy file data into Table */
    if (type && !strcmp(type,"double")) Table->data = data;
    else {
      float  *s;
      double *dataf;
      s     = (float*)data;
      dataf = (double*)malloc(sizeof(double)*nelements);
      for (i=0; i<nelements; i++)
        dataf[i]=s[i];
      free(data);
      Table->data = dataf;
    }
    strncpy(Table->filename, File, 1024);
    Table->rows    = nelements/columns;
    Table->columns = columns;
    Table->array_length = 1;
    Table->block_number = 1;

    Table_Stat(Table);

    return(nelements);
  } /* end Table_Read_Offset_Binary */

/*******************************************************************************
* long Table_Read_Handle(t_Table *Table, FILE *fid, int block_number, long max_rows, char *name)
*   ACTION: read a single Table from a text file handle (private)
*   input   Table:pointer to a t_Table structure
*           fid:  pointer to FILE handle
*           block_number: if the file does contain more than one
*                 data block, then indicates which one to get (from index 1)
*                 a 0 value means append/catenate all
*           max_rows: if non 0, only reads that number of lines
*   return  initialized single Table t_Table structure containing data, header, ...
*           modified Table t_Table structure containing data, header, ...
*           number of read elements (-1: error, 0:header only)
* The routine stores any line starting with '#', '%' and ';' into the header
* Other lines are interpreted as numerical data, and stored.
* Data block should be a rectangular matrix or vector.
* Data block may be rebined with Table_Rebin (also sort in ascending order)
*******************************************************************************/
  long Table_Read_Handle(t_Table *Table, FILE *hfile,
                         long block_number, long max_rows, char *name)
  { /* reads all/a data block from 'file' handle and returns a Table structure  */
    double *Data;
    char *Header              = NULL;
    long  malloc_size         = CHAR_BUF_LENGTH;
    long  malloc_size_h       = 4096;
    long  Rows = 0,   Columns = 0;
    long  count_in_array      = 0;
    long  count_in_header     = 0;
    long  block_Current_index = 0;
    char  flag_End_row_loop   = 0;

    if (!Table) return(-1);
    Table_Init(Table, 0, 0);
    if (name && name[0]!='\0') strncpy(Table->filename, name, 1024);

    if(!hfile) {
       fprintf(stderr, "Error: File handle is NULL (Table_Read_Handle).\n");
       return (-1);
    }
    Header = (char*)  calloc(malloc_size_h, sizeof(char));
    Data   = (double*)calloc(malloc_size,   sizeof(double));
    if ((Header == NULL) || (Data == NULL)) {
       fprintf(stderr, "Error: Could not allocate Table and Header (Table_Read_Handle).\n");
       return (-1);
    }

    int flag_In_array = 0;
    do { /* while (!flag_End_row_loop) */
      char  line[1024*CHAR_BUF_LENGTH];
      long  back_pos=0;   /* ftell start of line */

      back_pos = ftell(hfile);
      if (fgets(line, 1024*CHAR_BUF_LENGTH, hfile) != NULL) { /* analyse line */
        /* first skip blank and tabulation characters */
        int i = strspn(line, " \t");

        /* handle comments: stored in header */
        if (NULL != strchr("#%;/", line[i]))
        { /* line is a comment */
          count_in_header += strlen(line);
          if (count_in_header >= malloc_size_h) {
            /* if succeed and in array : add (and realloc if necessary) */
            malloc_size_h = count_in_header+4096;
            Header        = (char*)realloc(Header, malloc_size_h*sizeof(char));
          }
          strncat(Header, line, 4096);
          flag_In_array=0;
          /* exit line and file if passed desired block */
          if (block_number > 0 && block_number == block_Current_index) {
            flag_End_row_loop = 1;
          }

          /* Continue with next line */
          continue;
        }

        /* get the number of columns splitting line with strtok */
        char  *lexeme;
        char  flag_End_Line = 0;
        long  block_Num_Columns = 0;
        const char seps[] = " ,;\t\n\r";

        lexeme = strtok(line, seps);
        while (!flag_End_Line) {
          if ((lexeme != NULL) && (lexeme[0] != '\0')) {
            /* reading line: the token is not empty */
            double X;
            int    count=1;
            /* test if we have 'NaN','Inf' */
            if (!strncasecmp(lexeme,"NaN",3))
              X = 0;
            else if (!strncasecmp(lexeme,"Inf",3) || !strncasecmp(lexeme,"+Inf",4))
              X = FLT_MAX;
            else if (!strncasecmp(lexeme,"-Inf",4))
              X = -FLT_MAX;
            else
              count = sscanf(lexeme,"%lg",&X);
            if (count == 1) {
              /* reading line: the token is a number in the line */
              if (!flag_In_array) {
                /* reading num: not already in a block: starts a new data block */
                block_Current_index++;
                flag_In_array    = 1;
                block_Num_Columns= 0;
                if (block_number > 0) {
                  /* initialise a new data block */
                  Rows = 0;
                  count_in_array = 0;
                } /* else append */
              }
              /* reading num: all blocks or selected block */
              if (flag_In_array && (block_number == 0 ||
                  block_number == block_Current_index)) {
                /* starting block: already the desired number of rows ? */
                if (block_Num_Columns == 0 &&
                    max_rows > 0 && Rows >= max_rows) {
                  flag_End_Line      = 1;
                  flag_End_row_loop  = 1;
                  flag_In_array      = 0;
                  /* reposition to begining of line (ignore line) */
                  fseek(hfile, back_pos, SEEK_SET);
                } else { /* store into data array */
                  if (count_in_array >= malloc_size) {
                    /* realloc data buffer if necessary */
                    malloc_size = count_in_array*1.5;
                    Data = (double*) realloc(Data, malloc_size*sizeof(double));
                    if (Data == NULL) {
                      fprintf(stderr, "Error: Can not re-allocate memory %li (Table_Read_Handle).\n",
                              malloc_size*sizeof(double));
                      return (-1);
                    }
                  }
                  if (0 == block_Num_Columns) Rows++;
                  Data[count_in_array] = X;
                  count_in_array++;
                  block_Num_Columns++;
                }
              } /* reading num: end if flag_In_array */
            } /* end reading num: end if sscanf lexeme -> numerical */
            else {
              /* reading line: the token is not numerical in that line. end block */
              if (block_Current_index == block_number) {
                flag_End_Line = 1;
                flag_End_row_loop = 1;
              } else {
                flag_In_array = 0;
                flag_End_Line = 1;
              }
            }
          }
          else {
            /* no more tokens in line */
            flag_End_Line = 1;
            if (block_Num_Columns > 0) Columns = block_Num_Columns;
          }

          // parse next token
          lexeme = strtok(NULL, seps);

        } /* while (!flag_End_Line) */
      } /* end: if fgets */
      else flag_End_row_loop = 1; /* else fgets : end of file */

    } while (!flag_End_row_loop); /* end while flag_End_row_loop */

    Table->block_number = block_number;
    Table->array_length = 1;

    // shrink header to actual size (plus terminating 0-byte)
    if (count_in_header) {
      Header = (char*)realloc(Header, count_in_header*sizeof(char) + 1);
    }
    Table->header = Header;

    if (count_in_array*Rows*Columns == 0)
    {
      Table->rows         = 0;
      Table->columns      = 0;
      free(Data);
      return (0);
    }
    if (Rows * Columns != count_in_array)
    {
      fprintf(stderr, "Warning: Read_Table :%s %s Data has %li values that should be %li x %li\n",
        (Table->filename[0] != '\0' ? Table->filename : ""),
        (!block_number ? " catenated" : ""),
        count_in_array, Rows, Columns);
      Columns = count_in_array; Rows = 1;
    }
    Data     = (double*)realloc(Data, count_in_array*sizeof(double));
    Table->data         = Data;
    Table->rows         = Rows;
    Table->columns      = Columns;

    return (count_in_array);

  } /* end Table_Read_Handle */

/*******************************************************************************
* long Table_Rebin(t_Table *Table)
*   ACTION: rebin a single Table, sorting 1st column in ascending order
*   input   Table: single table containing data.
*                  The data block is reallocated in this process
*   return  updated Table with increasing, evenly spaced first column (index 0)
*           number of data elements (-1: error, 0:empty data)
*******************************************************************************/
  long Table_Rebin(t_Table *Table)
  {
    double new_step=0;
    long   i;
    /* performs linear interpolation on X axis (0-th column) */

    if (!Table) return(-1);
    if (!Table->data 
    || Table->rows*Table->columns == 0 || !Table->step_x)
      return(0);
    Table_Stat(Table); /* recompute statitstics and minimal step */
    new_step = Table->step_x; /* minimal step in 1st column */

    if (!(Table->constantstep)) /* not already evenly spaced */
    {
      long Length_Table;
      double *New_Table;

      Length_Table = ceil(fabs(Table->max_x - Table->min_x)/new_step)+1;
      /*return early if the rebinned table will become too large*/
      if (Length_Table > mcread_table_rebin_maxsize){
        fprintf(stderr,"WARNING: (Table_Rebin): Rebinning table from %s would exceed 1M rows. Skipping.\n", Table->filename); 
        return(Table->rows*Table->columns);
      }
      New_Table    = (double*)malloc(Length_Table*Table->columns*sizeof(double));

      for (i=0; i < Length_Table; i++)
      {
        long   j;
        double X;
        X = Table->min_x + i*new_step;
        New_Table[i*Table->columns] = X;
        for (j=1; j < Table->columns; j++)
          New_Table[i*Table->columns+j]
                = Table_Value(*Table, X, j);
      } /* end for i */

      Table->rows = Length_Table;
      Table->step_x = new_step;
      Table->max_x = Table->min_x + (Length_Table-1)*new_step; 
      /*max might not be the same anymore
       * Use Length_Table -1 since the first and laset rows are the limits of the defined interval.*/
      free(Table->data);
      Table->data = New_Table;
      Table->constantstep=1;
    } /* end else (!constantstep) */
    return (Table->rows*Table->columns);
  } /* end Table_Rebin */

/*******************************************************************************
* double Table_Index(t_Table Table, long i, long j)
*   ACTION: read an element [i,j] of a single Table
*   input   Table: table containing data
*           i : index of row      (0:Rows-1)
*           j : index of column   (0:Columns-1)
*   return  Value = data[i][j]
* Returns Value from the i-th row, j-th column of Table
* Tests are performed on indexes i,j to avoid errors
*******************************************************************************/

#ifndef MIN
#define MIN(a, b)  (((a) < (b)) ? (a) : (b))
#endif
#ifndef MAX
#define MAX(a, b)  (((a) > (b)) ? (a) : (b))
#endif

double Table_Index(t_Table Table, long i, long j)
{
  long AbsIndex;

  if (Table.rows == 1 || Table.columns == 1) {
    /* vector */
    j = MIN(MAX(0, i+j), Table.columns*Table.rows - 1);
    i = 0;
  } else {
    /* matrix */
    i = MIN(MAX(0, i), Table.rows - 1);
    j = MIN(MAX(0, j), Table.columns - 1);
  }

  /* handle vectors specifically */
  AbsIndex = i*(Table.columns)+j;

  if (Table.data != NULL)
    return (Table.data[AbsIndex]);
  else
    return 0;
} /* end Table_Index */

/*******************************************************************************
* void Table_SetElement(t_Table *Table, long i, long j, double value)
*   ACTION: set an element [i,j] of a single Table
*   input   Table: table containing data
*           i : index of row      (0:Rows-1)
*           j : index of column   (0:Columns-1)
*           value = data[i][j]
* Returns 0 in case of error
* Tests are performed on indexes i,j to avoid errors
*******************************************************************************/
int Table_SetElement(t_Table *Table, long i, long j,
                     double value)
{
  long AbsIndex;

  if (Table->rows == 1 || Table->columns == 1) {
    /* vector */
    j = MIN(MAX(0, i+j), Table->columns*Table->rows - 1); i=0;
  } else {
    /* matrix */
    i = MIN(MAX(0, i), Table->rows - 1);
    j = MIN(MAX(0, j), Table->columns - 1);
  }

  AbsIndex = i*(Table->columns)+j;
  if (Table->data != NULL) {
    Table->data[AbsIndex] = value;
    return 1;
  }

  return 0;
} /* end Table_SetElement */

/*******************************************************************************
* double Table_Value(t_Table Table, double X, long j)
*   ACTION: read column [j] of a single Table at row which 1st column is X
*   input   Table: table containing data.
*           X : data value in the first column (index 0)
*           j : index of column from which is extracted the Value (0:Columns-1)
*   return  Value = data[index for X][j] with linear interpolation
* Returns Value from the j-th column of Table corresponding to the
* X value for the 1st column (index 0)
* Tests are performed (within Table_Index) on indexes i,j to avoid errors
* NOTE: data should rather be monotonic, and evenly sampled.
*******************************************************************************/
double Table_Value(t_Table Table, double X, long j)
{
  long   Index = -1;
  double X1=0, Y1=0, X2=0, Y2=0;
  double ret=0;

  if (X > Table.max_x) return Table_Index(Table,Table.rows-1  ,j);
  if (X < Table.min_x) return Table_Index(Table,0  ,j);

  // Use constant-time lookup when possible
  if(Table.constantstep) {
    Index = (long)floor(
              (X - Table.min_x) / (Table.max_x - Table.min_x) * (Table.rows-1));
    X1 = Table_Index(Table,Index  ,0);
    X2 = Table_Index(Table,Index+1,0);
  }
  // Use binary search on large, monotonic tables
  else if(Table.monotonic && Table.rows > 100) {
    long left = Table.min_x;
    long right = Table.max_x;

    while (!((X1 <= X) && (X < X2)) && (right - left > 1)) {
      Index = (left + right) / 2;

      X1 = Table_Index(Table, Index-1, 0);
      X2 = Table_Index(Table, Index,   0);

      if (X < X1) {
        right = Index;
      } else {
        left  = Index;
      }
    }
  }

  // Fall back to linear search, if no-one else has set X1, X2 correctly
  if (!((X1 <= X) && (X < X2))) {
    /* look for index surrounding X in the table -> Index */
    for (Index=1; Index <= Table.rows-1; Index++) {
        X1 = Table_Index(Table, Index-1,0);
        X2 = Table_Index(Table, Index  ,0);
        if ((X1 <= X) && (X < X2)) break;
      } /* end for Index */
  }

  Y1 = Table_Index(Table,Index, j);
  Y2 = Table_Index(Table,Index+1, j);

  if (!strcmp(Table.method,"linear")) {
    ret = Table_Interp1d(X, X1,Y1, X2,Y2);
  }
  else if (!strcmp(Table.method,"nearest")) {
    ret = Table_Interp1d_nearest(X, X1,Y1, X2,Y2);
  }

  return ret;
} /* end Table_Value */

/*******************************************************************************
* double Table_Value2d(t_Table Table, double X, double Y)
*   ACTION: read element [X,Y] of a matrix Table
*   input   Table: table containing data.
*           X : row index, may be non integer
*           Y : column index, may be non integer
*   return  Value = data[index X][index Y] with bi-linear interpolation
* Returns Value for the indices [X,Y]
* Tests are performed (within Table_Index) on indexes i,j to avoid errors
* NOTE: data should rather be monotonic, and evenly sampled.
*******************************************************************************/
  double Table_Value2d(t_Table Table, double X, double Y)
  {
    long   x1,x2,y1,y2;
    double z11,z12,z21,z22;
    double ret=0;

    x1 = (long)floor(X);
    y1 = (long)floor(Y);

    if (x1 > Table.rows-1 || x1 < 0) {
      x2 = x1;
    } else {
      x2 = x1 + 1;
    }

    if (y1 > Table.columns-1 || y1 < 0) {
      y2 = y1;
    } else {
      y2 = y1 + 1;
    }

    z11 = Table_Index(Table, x1, y1);

    if (y2 != y1) z12=Table_Index(Table, x1, y2); else z12 = z11;
    if (x2 != x1) z21=Table_Index(Table, x2, y1); else z21 = z11;
    if (y2 != y1) z22=Table_Index(Table, x2, y2); else z22 = z21;

    if (!strcmp(Table.method,"linear"))
      ret = Table_Interp2d(X,Y, x1,y1,x2,y2, z11,z12,z21,z22);
    else {
      if (fabs(X-x1) < fabs(X-x2)) {
        if (fabs(Y-y1) < fabs(Y-y2)) ret = z11; else ret = z12;
      } else {
        if (fabs(Y-y1) < fabs(Y-y2)) ret = z21; else ret = z22;
      }
    }
    return ret;
  } /* end Table_Value2d */


/*******************************************************************************
* void Table_Free(t_Table *Table)
*   ACTION: free a single Table. First Call Table_File_list_gc. If this returns
*   non-zero it means there are more refernces to the table, and so the table
*   should not bee freed.
*   return: empty Table
*******************************************************************************/
  void Table_Free(t_Table *Table)
  {
    if( !Table_File_List_gc(Table) ){
       return;
    } 
    if (!Table) return;
    if (Table->data   != NULL) free(Table->data);
    if (Table->header != NULL) free(Table->header);
    Table->data   = NULL;
    Table->header = NULL;
  } /* end Table_Free */

/******************************************************************************
* void Table_Info(t_Table Table)
*    ACTION: print informations about a single Table
*******************************************************************************/
  long Table_Info(t_Table Table)
  {
    char buffer[256];
    long ret=0;

    if (!Table.block_number) strcpy(buffer, "catenated");
    else sprintf(buffer, "block %li", Table.block_number);
    printf("Table from file '%s' (%s)",
      Table.filename[0] != '\0' ? Table.filename : "", buffer);
    if ((Table.data != NULL) && (Table.rows*Table.columns))
    {
      printf(" is %li x %li ", Table.rows, Table.columns);
      if (Table.rows*Table.columns > 1)
        printf("(x=%g:%g)", Table.min_x, Table.max_x);
      else printf("(x=%g) ", Table.min_x);
      ret = Table.rows*Table.columns;
      if (Table.monotonic)    printf(", monotonic");
      if (Table.constantstep) printf(", constant step");
      printf(". interpolation: %s\n", Table.method);
    }
    else printf(" is empty.\n");

    if (Table.header && strlen(Table.header)) {
      char *header;
      int  i;
      header = malloc(80);
      if (!header) return(ret);
      for (i=0; i<80; header[i++]=0);
      strncpy(header, Table.header, 75);
      if (strlen(Table.header) > 75) {
        strcat( header, " ...");
      }
      for (i=0; i<strlen(header); i++)
        if (header[i] == '\n' || header[i] == '\r') header[i] = ';';
      printf("  '%s'\n", header);
      free(header);
    }

    return(ret);
  } /* end Table_Info */

/******************************************************************************
* long Table_Init(t_Table *Table, m, n)
*   ACTION: initialise a Table to empty m by n table
*   return: empty Table
******************************************************************************/
long Table_Init(t_Table *Table, long rows, long columns)
{
  double *data=NULL;
  long   i;

  if (!Table) return(0);

  Table->header  = NULL;
  Table->filename[0]= '\0';
  Table->filesize= 0;
  Table->min_x   = 0;
  Table->max_x   = 0;
  Table->step_x  = 0;
  Table->block_number = 0;
  Table->array_length = 0;
  Table->monotonic    = 0;
  Table->constantstep = 0;
  Table->begin   = 0;
  Table->end     = 0;
  strcpy(Table->method,"linear");

  if (rows*columns >= 1) {
    data    = (double*)malloc(rows*columns*sizeof(double));
    if (data) for (i=0; i < rows*columns; data[i++]=0);
    else {
      fprintf(stderr,"Error: allocating %ld double elements."
                     "Too big (Table_Init).\n", rows*columns);
      rows = columns = 0;
    }
  }
  Table->rows    = (rows >= 1 ? rows : 0);
  Table->columns = (columns >= 1 ? columns : 0);
  Table->data    = data;
  return(Table->rows*Table->columns);
} /* end Table_Init */

/******************************************************************************
* long Table_Write(t_Table Table, char *file, x1,x2, y1,y2)
*   ACTION: write a Table to disk (ascii).
*     when x1=x2=0 or y1=y2=0, the table default limits are used.
*   return: 0=all is fine, non-0: error
*******************************************************************************/
MCDETECTOR Table_Write(t_Table Table, char *file, char *xl, char *yl, 
  double x1, double x2, double y1, double y2)
{
  long    i =0;
  MCDETECTOR detector;

  if ((Table.data == NULL) && (Table.rows*Table.columns)) {
    detector.m = 0;
    return(detector); /* Table is empty - nothing to do */
  }
  if (!x1 && !x2) {
    x1 = Table.min_x;
    x2 = Table.max_x;
  }
  if (!y1 && !y2) {
    y1 = 1;
    y2 = Table.columns;
  }

  /* transfer content of the Table into a 2D detector */
  Coords coords = { 0, 0, 0};

  if (Table.rows == 1 || Table.columns == 1) {
    detector = mcdetector_out_1D(Table.filename,
                      xl ? xl : "", yl ? yl : "",
                      "x", x1, x2,
                      Table.rows * Table.columns,
                      NULL, Table.data, NULL,
                      file, file, coords);
  } else {
    detector = mcdetector_out_2D(Table.filename,
                      xl ? xl : "", yl ? yl : "",
                      x1, x2, y1, y2,
                      Table.rows, Table.columns,
                      NULL, Table.data, NULL,
                      file, file, coords);
  }
  return(detector);
}

/******************************************************************************
* void Table_Stat(t_Table *Table)
*   ACTION: computes min/max/mean step of 1st column for a single table (private)
*   return: updated Table
*******************************************************************************/
  static void Table_Stat(t_Table *Table)
  {
    long   i;
    double max_x, min_x;
    double row=1;
    char   monotonic=1;
    char   constantstep=1;
    double step=0;
    long n;

    if (!Table) return;
    if (!Table->rows || !Table->columns) return;
    if (Table->rows == 1) row=0; // single row
    max_x = -FLT_MAX;
    min_x =  FLT_MAX;
    n     = (row ? Table->rows : Table->columns);
    /* get min and max of first column/vector */
    for (i=0; i < n; i++)
    {
      double X;
      X = (row ? Table_Index(*Table,i  ,0)
                               : Table_Index(*Table,0, i));
      if (X < min_x) min_x = X;
      if (X > max_x) max_x = X;
    } /* for */
    
    /* test for monotonicity and constant step if the table is an XY or single vector */
    if (n > 1) {
      /* mean step */
      step = (max_x - min_x)/(n-1);
      /* now test if table is monotonic on first column, and get minimal step size */
      for (i=0; i < n-1; i++) {
        double X, diff;;
        X    = (row ? Table_Index(*Table,i  ,0)
                    : Table_Index(*Table,0,  i));
        diff = (row ? Table_Index(*Table,i+1,0)
                    : Table_Index(*Table,0,  i+1)) - X;
        if (diff && fabs(diff) < fabs(step)) step = diff;
        /* change sign ? */
        if ((max_x - min_x)*diff < 0 && monotonic)
          monotonic = 0;
      } /* end for */
      
      /* now test if steps are constant within READ_TABLE_STEPTOL */
      if(!step){
        /*means there's a disconitnuity -> not constantstep*/
        constantstep=0;
      }else if (monotonic) {
        for (i=0; i < n-1; i++) {
          double X, diff;
          X    = (row ? Table_Index(*Table,i  ,0)
              : Table_Index(*Table,0,  i));
          diff = (row ? Table_Index(*Table,i+1,0)
              : Table_Index(*Table,0,  i+1)) - X;
          if ( fabs(step)*(1+READ_TABLE_STEPTOL) < fabs(diff) ||
                fabs(diff) < fabs(step)*(1-READ_TABLE_STEPTOL) )
          { constantstep = 0; break; }
        }
      }

    }
    Table->step_x= step;
    Table->max_x = max_x;
    Table->min_x = min_x;
    Table->monotonic = monotonic;
    Table->constantstep = constantstep;
  } /* end Table_Stat */

/******************************************************************************
* t_Table *Table_Read_Array(char *File, long *blocks)
*   ACTION: read as many data blocks as available, iteratively from file
*   return: initialized t_Table array, last element is an empty Table.
*           the number of extracted blocks in non NULL pointer *blocks
*******************************************************************************/
  t_Table *Table_Read_Array(char *File, long *blocks)
  {
    t_Table *Table_Array=NULL;
    long offset=0;
    long block_number=0;
    long allocated=256;
    long nelements=1;

    /* first allocate an initial empty t_Table array */
    Table_Array = (t_Table *)malloc(allocated*sizeof(t_Table));
    if (!Table_Array) {
      fprintf(stderr, "Error: Can not allocate memory %li (Table_Read_Array).\n",
         allocated*sizeof(t_Table));
      *blocks = 0;
      return (NULL);
    }

    while (nelements > 0)
    {
      t_Table Table;

      /* if ok, set t_Table block number else exit loop */
      block_number++;
      Table.block_number = block_number;
      
      /* access file at offset and get following block. Block number is from the set offset
       * hence the hardcoded 1 - i.e. the next block counted from offset.*/
      nelements = Table_Read_Offset(&Table, File, 1, &offset,0);
      /*if the block is empty - don't store it*/
      if (nelements>0){
          /* if t_Table array is not long enough, expand and realocate */
          if (block_number >= allocated-1) {
              allocated += 256;
              Table_Array = (t_Table *)realloc(Table_Array,
                      allocated*sizeof(t_Table));
              if (!Table_Array) {
                  fprintf(stderr, "Error: Can not re-allocate memory %li (Table_Read_Array).\n",
                          allocated*sizeof(t_Table));
                  *blocks = 0;
                  return (NULL);
              }
          }
          /* store it into t_Table array */
          //snprintf(Table.filename, 1024, "%s#%li", File, block_number-1);
          Table_Array[block_number-1] = Table;
      }
      /* continues until we find an empty block */
    }
    /* send back number of extracted blocks */
    if (blocks) *blocks = block_number-1;

    /* now store total number of elements in Table array */
    for (offset=0; offset < block_number;
      Table_Array[offset++].array_length = block_number-1);

    return(Table_Array);
  } /* end Table_Read_Array */
/*******************************************************************************
* void Table_Free_Array(t_Table *Table)
*   ACTION: free a Table array
*******************************************************************************/
  void Table_Free_Array(t_Table *Table)
  {
    long index;
    if (!Table) return;
    for (index=0;index < Table[0].array_length; index++){
            Table_Free(&Table[index]);
    }
    free(Table);
  } /* end Table_Free_Array */

/******************************************************************************
* long Table_Info_Array(t_Table *Table)
*    ACTION: print informations about a Table array
*    return: number of elements in the Table array
*******************************************************************************/
  long Table_Info_Array(t_Table *Table)
  {
    long index=0;

    if (!Table) return(-1);
    while (index < Table[index].array_length
       && (Table[index].data || Table[index].header)
       && (Table[index].rows*Table[index].columns) ) {
      Table_Info(Table[index]);
      index++;
    }
    printf("This Table array contains %li elements\n", index);
    return(index);
  } /* end Table_Info_Array */

/******************************************************************************
* char **Table_ParseHeader(char *header, symbol1, symbol2, ..., NULL)
*    ACTION: search for char* symbols in header and return their value or NULL
*            the search is not case sensitive.
*            Last argument MUST be NULL
*    return: array of char* with line following each symbol, or NULL if not found
*******************************************************************************/
#ifndef MyNL_ARGMAX
#define MyNL_ARGMAX 50
#endif

char **Table_ParseHeader_backend(char *header, ...){
  va_list ap;
  char exit_flag=0;
  int counter   =0;
  char **ret    =NULL;
  if (!header || header[0]=='\0') return(NULL);

  ret = (char**)calloc(MyNL_ARGMAX, sizeof(char*));
  if (!ret) {
    printf("Table_ParseHeader: Cannot allocate %i values array for Parser (Table_ParseHeader).\n",
      MyNL_ARGMAX);
    return(NULL);
  }
  for (counter=0; counter < MyNL_ARGMAX; ret[counter++] = NULL);
  counter=0;

  va_start(ap, header);
  while(!exit_flag && counter < MyNL_ARGMAX-1)
  {
    char *arg_char=NULL;
    char *pos     =NULL;
    /* get variable argument value as a char */
    arg_char = va_arg(ap, char *);
    if (!arg_char || arg_char[0]=='\0'){
      exit_flag = 1; break;
    }
    /* search for the symbol in the header */
    pos = (char*)strcasestr(header, arg_char);
    if (pos) {
      char *eol_pos;
      eol_pos = strchr(pos+strlen(arg_char), '\n');
      if (!eol_pos)
        eol_pos = strchr(pos+strlen(arg_char), '\r');
      if (!eol_pos)
        eol_pos = pos+strlen(pos)-1;
      ret[counter] = (char*)malloc(eol_pos - pos);
      if (!ret[counter]) {
        printf("Table_ParseHeader: Cannot allocate value[%i] array for Parser searching for %s (Table_ParseHeader).\n",
          counter, arg_char);
        exit_flag = 1; break;
      }
      strncpy(ret[counter], pos+strlen(arg_char), eol_pos - pos - strlen(arg_char));
      ret[counter][eol_pos - pos - strlen(arg_char)]='\0';
    }
    counter++;
  }
  va_end(ap);
  return(ret);
} /* Table_ParseHeader */

/******************************************************************************
* double Table_Interp1d(x, x1, y1, x2, y2)
*    ACTION: interpolates linearly at x between y1=f(x1) and y2=f(x2)
*    return: y=f(x) value
*******************************************************************************/
double Table_Interp1d(double x,
  double x1, double y1,
  double x2, double y2)
{
  double slope;
  if (x2 == x1) return (y1+y2)/2;
  if (y1 == y2) return  y1;
  slope = (y2 - y1)/(x2 - x1);
  return y1+slope*(x - x1);
} /* Table_Interp1d */

/******************************************************************************
* double Table_Interp1d_nearest(x, x1, y1, x2, y2)
*    ACTION: table lookup with nearest method at x between y1=f(x1) and y2=f(x2)
*    return: y=f(x) value
*******************************************************************************/
double Table_Interp1d_nearest(double x,
  double x1, double y1,
  double x2, double y2)
{
  if (fabs(x-x1) < fabs(x-x2)) return (y1);
  else return(y2);
} /* Table_Interp1d_nearest */

/******************************************************************************
* double Table_Interp2d(x,y, x1,y1, x2,y2, z11,z12,z21,z22)
*    ACTION: interpolates bi-linearly at (x,y) between z1=f(x1,y1) and z2=f(x2,y2)
*    return: z=f(x,y) value
*    x,y |   x1   x2
*    ----------------
*     y1 |   z11  z21
*     y2 |   z12  z22
*******************************************************************************/
double Table_Interp2d(double x, double y,
  double x1, double y1,
  double x2, double y2,
  double z11, double z12, double z21, double z22)
{
  double ratio_x, ratio_y;
  if (x2 == x1) return Table_Interp1d(y, y1,z11, y2,z12);
  if (y1 == y2) return Table_Interp1d(x, x1,z11, x2,z21);

  ratio_y = (y - y1)/(y2 - y1);
  ratio_x = (x - x1)/(x2 - x1);
  return (1-ratio_x)*(1-ratio_y)*z11 + ratio_x*(1-ratio_y)*z21
    + ratio_x*ratio_y*z22         + (1-ratio_x)*ratio_y*z12;
} /* Table_Interp2d */

/* end of read_table-lib.c */

/*******************************************************************************
*
* McStas, neutron ray-tracing package
*         Copyright (C) 1997-2008, All rights reserved
*         Risoe National Laboratory, Roskilde, Denmark
*         Institut Laue Langevin, Grenoble, France
*
* Runtime: share/interoff.h
*
* %Identification
* Written by: Reynald Arnerin
* Date:    Jun 12, 2008
* Release: 
* Version: 
*
* Object File Format intersection header for McStas. Requires the qsort function.
*
* Such files may be obtained with e.g.
*   qhull < points.xyz Qx Qv Tv o > points.off
* where points.xyz has format:
*   3
*   <nb_points>
*   <x> <y> <z>
*   ...
* The resulting file should have its first line being changed from '3' into 'OFF'.
* It can then be displayed with geomview.
* A similar, but somewhat older solution is to use 'powercrust' with e.g.
*   powercrust -i points.xyz
* which will generate a 'pc.off' file to be renamed as suited.
*
*******************************************************************************/

#ifndef INTEROFF_LIB_H
#define INTEROFF_LIB_H "$Revision$"

#ifndef OFF_EPSILON
#define OFF_EPSILON 1e-13
#endif

#define OFF_INTERSECT_MAX 100

//#include <float.h>

#define N_VERTEX_DISPLAYED    200000

typedef struct intersection {
	MCNUM time;  	  //time of the intersection
	Coords v;	      //intersection point
	Coords normal;  //normal vector of the surface intersected
	short in_out;	  //1 if the ray enters the volume, -1 otherwise
	short edge;	    //1 if the intersection is on the boundary of the polygon, and error is possible
	unsigned long index; // index of the face
} intersection;

typedef struct polygon {
  MCNUM* p;       //vertices of the polygon in adjacent order, this way : x1 | y1 | z1 | x2 | y2 | z2 ...
  int npol;       //number of vertices
  Coords normal;
} polygon;

typedef struct off_struct {
    long vtxSize;
    long polySize;
    long faceSize;
    Coords* vtxArray;
    Coords* normalArray;
    unsigned long* faceArray;
    char *filename;
    int mantidflag;
    long mantidoffset;
    intersection intersects[OFF_INTERSECT_MAX]; // After a call to off_intersect_all contains the list of intersections.
    int nextintersect;                 // 'Next' intersection (first t>0) solution after call to off_intersect_all
    int numintersect;               // Number of intersections after call to off_intersect_all
} off_struct;

/*******************************************************************************
* long off_init(  char *offfile, double xwidth, double yheight, double zdepth, off_struct* data)
* ACTION: read an OFF file, optionally center object and rescale, initialize OFF data structure
* INPUT: 'offfile' OFF file to read
*        'xwidth,yheight,zdepth' if given as non-zero, apply bounding box. 
*           Specifying only one of these will also use the same ratio on all axes
*        'notcenter' center the object to the (0,0,0) position in local frame when set to zero
* RETURN: number of polyhedra and 'data' OFF structure 
*******************************************************************************/
long off_init(  char *offfile, double xwidth, double yheight, double zdepth, 
                int notcenter, off_struct* data);

/*******************************************************************************
* int off_intersect_all(double* t0, double* t3, 
     Coords *n0, Coords *n3,
     double x, double y, double z, 
     double vx, double vy, double vz, 
     off_struct *data )
* ACTION: computes intersection of neutron trajectory with an object. 
* INPUT:  x,y,z and vx,vy,vz are the position and velocity of the neutron
*         data points to the OFF data structure
* RETURN: the number of polyhedra which trajectory intersects
*         t0 and t3 are the smallest incoming and outgoing intersection times
*         n0 and n3 are the corresponding normal vectors to the surface
*         data is the full OFF structure, including a list intersection type
*******************************************************************************/
int off_intersect_all(double* t0, double* t3, 
     Coords *n0, Coords *n3,
     double x, double y, double z, 
     double vx, double vy, double vz, 
     off_struct *data );

/*******************************************************************************
* int off_intersect(double* t0, double* t3, 
     Coords *n0, Coords *n3,
     double x, double y, double z, 
     double vx, double vy, double vz, 
     off_struct data )
* ACTION: computes intersection of neutron trajectory with an object. 
* INPUT:  x,y,z and vx,vy,vz are the position and velocity of the neutron
*         data points to the OFF data structure
* RETURN: the number of polyhedra which trajectory intersects
*         t0 and t3 are the smallest incoming and outgoing intersection times
*         n0 and n3 are the corresponding normal vectors to the surface
*******************************************************************************/
int off_intersect(double* t0, double* t3, 
     Coords *n0, Coords *n3,
     double x, double y, double z, 
     double vx, double vy, double vz, 
     off_struct data );

/*****************************************************************************
* int off_intersectx(double* l0, double* l3, 
     Coords *n0, Coords *n3,
     double x, double y, double z, 
     double kx, double ky, double kz, 
     off_struct data )
* ACTION: computes intersection of an xray trajectory with an object.
* INPUT:  x,y,z and kx,ky,kz, are spatial coordinates and wavevector of the x-ray
*         respectively. data points to the OFF data structure.
* RETURN: the number of polyhedra the trajectory intersects
*         l0 and l3 are the smallest incoming and outgoing intersection lengths
*         n0 and n3 are the corresponding normal vectors to the surface
*******************************************************************************/
int off_x_intersect(double *l0,double *l3,
     Coords *n0, Coords *n3,
     double x,  double y,  double z, 
     double kx, double ky, double kz, 
     off_struct data );

/*******************************************************************************
* void off_display(off_struct data)
* ACTION: display up to N_VERTEX_DISPLAYED points from the object
*******************************************************************************/
void off_display(off_struct);

#endif

/* end of interoff-lib.h */
/*******************************************************************************
*
* McStas, neutron ray-tracing package
*         Copyright (C) 1997-2008, All rights reserved
*         Risoe National Laboratory, Roskilde, Denmark
*         Institut Laue Langevin, Grenoble, France
*
* Runtime: share/interoff-lib.c
*
* %Identification
* Written by: Reynald Arnerin
* Date:    Jun 12, 2008
* Origin: ILL
* Release: $Revision$
* Version: McStas X.Y
*
* Object File Format intersection library for McStas. Requires the qsort function.
*
* Such files may be obtained with e.g.
*   qhull < points.xyz Qx Qv Tv o > points.off
* where points.xyz has format (it supports comments):
*   3
*   <nb_points>
*   <x> <y> <z>
*   ...
* The resulting file should have its first line being changed from '3' into 'OFF'.
* It can then be displayed with geomview.
* A similar, but somewhat older solution is to use 'powercrust' with e.g.
*   powercrust -i points.xyz
* which will generate a 'pc.off' file to be renamed as suited.
*
*******************************************************************************/

#ifndef INTEROFF_LIB_H
#include "interoff-lib.h"
#endif

double off_F(double x, double y,double z,double A,double B,double C,double D) {
  return ( A*x + B*y + C*z + D );
}

char off_sign(double a) {
  if (a<0)       return(-1);
  else if (a==0) return(0);
  else           return(1);
}

// off_normal ******************************************************************
//gives the normal vector of p
void off_normal(Coords* n, polygon p)
{
  //using Newell method
  int i=0,j=0;
  n->x=0;n->y=0;n->z=0;
  for (i = 0, j = p.npol-1; i < p.npol; j = i++)
  {
    MCNUM x1=p.p[3*i],
          y1=p.p[3*i+1],
          z1=p.p[3*i+2];
    MCNUM x2=p.p[3*j],
          y2=p.p[3*j+1],
          z2=p.p[3*j+2];
    // n is the cross product of v1*v2
    n->x += (y1 - y2) * (z1 + z2);
    n->y += (z1 - z2) * (x1 + x2);
    n->z += (x1 - x2) * (y1 + y2);
  }
} /* off_normal */

// off_pnpoly ******************************************************************
//based on http://www.ecse.rpi.edu/Homepages/wrf/Research/Short_Notes/pnpoly.html
//return 0 if the vertex is out
//    1 if it is in
//   -1 if on the boundary
int off_pnpoly(polygon p, Coords v)
{
  int i=0, c = 0;
  MCNUM minx=FLT_MAX,maxx=-FLT_MAX,miny=FLT_MAX,maxy=-FLT_MAX,minz=FLT_MAX,maxz=-FLT_MAX;
  MCNUM rangex=0,rangey=0,rangez=0;

  int pol2dx=0,pol2dy=1;          //2d restriction of the poly
  MCNUM x=v.x,y=v.y;


  //take the most relevant 2D projection (prevent from instability)
  for (i=0; i<p.npol; ++i)
  {
    if (p.p[3*i]<minx)   minx=p.p[3*i];
    if (p.p[3*i]>maxx)   maxx=p.p[3*i];
    if (p.p[3*i+1]<miny) miny=p.p[3*i+1];
    if (p.p[3*i+1]>maxy) maxy=p.p[3*i+1];
    if (p.p[3*i+2]<minz) minz=p.p[3*i+2];
    if (p.p[3*i+2]>maxz) maxz=p.p[3*i+2];
  }
  rangex=maxx-minx;
  rangey=maxy-miny;
  rangez=maxz-minz;

  if (rangex<rangez)
  {
    if (rangex<rangey) {
      pol2dx=2;
      x=v.z;
    } else {
      pol2dy=2;
      y=v.z;
    }
  }
  else if (rangey<rangez) {
    pol2dy=2;
    y=v.z;
  }

  //trace rays and test number of intersection
  int j;
  for (i = 0, j = p.npol-1; i < p.npol; j = i++) {
    if (((((p.p[3*i+pol2dy])<=y) && (y<(p.p[3*j+pol2dy]))) ||
         (((p.p[3*j+pol2dy])<=y) && (y<(p.p[3*i+pol2dy])))) &&
        (x < ( (p.p[3*j+pol2dx] - p.p[3*i+pol2dx]) * (y - p.p[3*i+pol2dy])
             / (p.p[3*j+pol2dy] - p.p[3*i+pol2dy]) + p.p[3*i+pol2dx]) ))
      c = !c;

    if (((fabs(p.p[3*i+pol2dy]-y)<=OFF_EPSILON) || ((fabs(p.p[3*j+pol2dy]-y)<=OFF_EPSILON))) &&
        fabs(x -((p.p[3*j+pol2dx] - p.p[3*i+pol2dx]) * (y - p.p[3*i+pol2dy])
          / (p.p[3*j+pol2dy] - p.p[3*i+pol2dy]) + p.p[3*i+pol2dx])) < OFF_EPSILON)
    {
      //the point lies on the edge
      c=-1;
      break;
    }
  }

  return c;
} /* off_pnpoly */

// off_intersectPoly ***********************************************************
//gives the intersection vertex between ray [a,b) and polygon p and its parametric value on (a b)
//based on http://geometryalgorithms.com/Archive/algorithm_0105/algorithm_0105.htm
int off_intersectPoly(intersection *inter, Coords a, Coords b, polygon p)
{
  //direction vector of [a,b]
  Coords dir = {b.x-a.x, b.y-a.y, b.z-a.z};

  //the normal vector to the polygon
  Coords normale=p.normal;
  //off_normal(&normale, p); done at the init stage

  //direction vector from a to a vertex of the polygon
  Coords w0 = {a.x-p.p[0], a.y-p.p[1], a.z-p.p[2]};

  //scalar product
  MCNUM nw0  =-scalar_prod(normale.x,normale.y,normale.z,w0.x,w0.y,w0.z);
  MCNUM ndir = scalar_prod(normale.x,normale.y,normale.z,dir.x,dir.y,dir.z);
  inter->time = inter->edge = inter->in_out=0;
  inter->v = inter->normal = coords_set(0,0,1);

  if (fabs(ndir) < OFF_EPSILON)    // ray is parallel to polygon plane
  {
    if (nw0 == 0)              // ray lies in polygon plane (infinite number of solution)
      return 0;
    else return 0;             // ray disjoint from plane (no solution)
  }

  // get intersect point of ray with polygon plane
  inter->time = nw0 / ndir;            //parametric value the point on line (a,b)

  inter->v = coords_set(a.x + inter->time * dir.x,// intersect point of ray and plane
    a.y + inter->time * dir.y,
    a.z + inter->time * dir.z);

  int res=off_pnpoly(p,inter->v);

  inter->edge=(res==-1);
  if (ndir<0)
    inter->in_out=1;  //the negative dot product means we enter the surface
  else
    inter->in_out=-1;

  inter->normal=p.normal;

  return res;         //true if the intersection point lies inside the poly
} /* off_intersectPoly */


// off_getBlocksIndex **********************************************************
/*reads the indexes at the beginning of the off file as this :
line 1  OFF
line 2  nbVertex nbFaces nbEdges
*/
FILE *off_getBlocksIndex(char* filename, long* vtxSize, long* polySize )
{
  FILE* f = Open_File(filename,"r", NULL); /* from read_table-lib: FILE *Open_File(char *name, char *Mode, char *path) */
  if (!f) return (f);
  
  char line[CHAR_BUF_LENGTH];
  char *ret=0;
  *vtxSize = *polySize = 0;

  /* **************** start to read the file header */
  /* OFF file:
     'OFF' or '3'
   */

  ret=fgets(line,CHAR_BUF_LENGTH , f);// line 1 = "OFF"
  if (ret == NULL)
  {
    fprintf(stderr, "Error: Can not read 1st line in file %s (interoff/off_getBlocksIndex)\n", filename);
    exit(1);
  }
  if (strlen(line)>5)
  {
      fprintf(stderr,"Error: First line in %s is too long (=%lu). Possibly the line is not terminated by '\\n'.\n" 
              "       The first line is required to be exactly 'OFF', '3' or 'ply'.\n",filename,strlen(line));
      fclose(f);
      return(NULL);
  }

  if (strncmp(line,"OFF",3) && strncmp(line,"3",1) && strncmp(line,"ply",1))
  {
    fprintf(stderr, "Error: %s is probably not an OFF, NOFF or PLY file (interoff/off_getBlocksIndex).\n"
                    "       Requires first line to be 'OFF', '3' or 'ply'.\n",filename);
    fclose(f);
    return(NULL);
  }

  if (!strncmp(line,"OFF",3) || !strncmp(line,"3",1)) {
    do  /* OFF file: skip # comments which may be there */
    {
      ret=fgets(line,CHAR_BUF_LENGTH , f);
      if (ret == NULL)
      {
        fprintf(stderr, "Error: Can not read line in file %s (interoff/off_getBlocksIndex)\n", filename);
        exit(1);
      }
    } while (line[0]=='#');
    //line = nblines of vertex,faces and edges arrays
    sscanf(line,"%lu %lu",vtxSize,polySize);
  } else {
    do  /* PLY file: read all lines until find 'end_header'
           and locate 'element faces' and 'element vertex' */
    {
      ret=fgets(line,CHAR_BUF_LENGTH , f);
      if (ret == NULL)
      {
        fprintf(stderr, "Error: Can not read line in file %s (interoff/off_getBlocksIndex)\n", filename);
        exit(1);
      }
      if (!strncmp(line,"element face",12))
        sscanf(line,"element face %lu",polySize);
      else if (!strncmp(line,"element vertex",14))
        sscanf(line,"element vertex %lu",vtxSize);
      else if (!strncmp(line,"format binary",13))
        exit(fprintf(stderr,
          "Error: Can not read binary PLY file %s, only 'format ascii' (interoff/off_getBlocksIndex)\n%s\n",
          filename, line));
    } while (strncmp(line,"end_header",10));
  }
  
  /* The FILE is left opened ready to read 'vtxSize' vertices (vtxSize *3 numbers)
     and then polySize polygons (rows) */

  return(f);
} /* off_getBlocksIndex */

// off_init_planes *************************************************************
//gives the equations of 2 perpandicular planes of [ab]
void off_init_planes(Coords a, Coords b,
  MCNUM* A1, MCNUM* C1, MCNUM* D1, MCNUM *A2, MCNUM* B2, MCNUM* C2, MCNUM* D2)
{
  //direction vector of [a b]
  Coords dir={b.x-a.x, b.y-a.y, b.z-a.z};

  //the plane parallel to the 'y' is computed with the normal vector of the projection of [ab] on plane 'xz'
  *A1= dir.z;
  *C1=-dir.x;
  if(*A1!=0 || *C1!=0)
    *D1=-(a.x)*(*A1)-(a.z)*(*C1);
  else
  {
    //the plane does not support the vector, take the one parallel to 'z''
    *A1=1;
    //B1=dir.x=0
    *D1=-(a.x);
  }
  //the plane parallel to the 'x' is computed with the normal vector of the projection of [ab] on plane 'yz'
  *B2= dir.z;
  *C2=-dir.y;
  *A2= 0;
  if (*B2==0 && *C2==0)
  {
    //the plane does not support the vector, take the one parallel to 'z'
    *B2=1;
    //B1=dir.x=0
    *D2=-(a.y);
  }
  else {
    if (dir.z==0)
    {
      //the planes are the same, take the one parallel to 'z'
      *A2= dir.y;
      *B2=-dir.x;
      *D2=-(a.x)*(*A2)-(a.y)*(*B2);
    }
    else
      *D2=-(a.y)**B2-(a.z)**C2;
  }
} /* off_init_planes */

// off_clip_3D_mod *************************************************************
int off_clip_3D_mod(intersection* t, Coords a, Coords b,
  Coords* vtxArray, unsigned long vtxSize, unsigned long* faceArray,
  unsigned long faceSize, Coords* normalArray)
{
  MCNUM A1=0, C1=0, D1=0, A2=0, B2=0, C2=0, D2=0;      //perpendicular plane equations to [a,b]
  off_init_planes(a, b, &A1, &C1, &D1, &A2, &B2, &C2, &D2);

  int t_size=0;
  //unsigned long vtxSize=vtxTable.rows, faceSize=faceTable.columns;  //Size of the corresponding tables
  char sg[vtxSize];  //array telling if vertex is left or right of the plane
  MCNUM popol[3*CHAR_BUF_LENGTH];
  unsigned long i=0,indPoly=0;
  for (i=0; i < vtxSize; ++i)
  {
    sg[i]=off_sign(off_F(vtxArray[i].x,vtxArray[i].y,vtxArray[i].z,A1,0,C1,D1));
  }

  //exploring the polygons :
  i=indPoly=0;
  while (i<faceSize)
  {
    polygon pol;
    pol.npol  = faceArray[i];                //nb vertex of polygon
    pol.p     = popol;
    pol.normal= coords_set(0,0,1);
    unsigned long indVertP1=faceArray[++i];  //polygon's first vertex index in vtxTable
    int j=1;
    while (j<pol.npol)
    {
      //polygon's j-th vertex index in vtxTable
      if (sg[indVertP1]!=sg[faceArray[i+j]]) //if the plane intersect the polygon
        break;

      ++j;
    }

    if (j<pol.npol)          //ok, let's test with the second plane
    {
      char sg1=off_sign(off_F(vtxArray[indVertP1].x,vtxArray[indVertP1].y,vtxArray[indVertP1].z,A2,B2,C2,D2));//tells if vertex is left or right of the plane

      j=1;
      while (j<pol.npol)
      {
        //unsigned long indVertPi=faceArray[i+j];  //polyg's j-th vertex index in vtxTable
        Coords vertPi=vtxArray[faceArray[i+j]];
        if (sg1!=off_sign(off_F(vertPi.x,vertPi.y,vertPi.z,A2,B2,C2,D2)))//if the plane intersect the polygon
          break;
        ++j;
      }
      if (j<pol.npol)
      {
        if (t_size>CHAR_BUF_LENGTH)
        {
          fprintf(stderr, "Warning: number of intersection exceeded (%d) (interoff-lib/off_clip_3D_mod)\n", CHAR_BUF_LENGTH);
            return (t_size);
        }
        //both planes intersect the polygon, let's find the intersection point
        //our polygon :
        int k;
        for (k=0; k<pol.npol; ++k)
        {
          Coords vertPk=vtxArray[faceArray[i+k]];
          pol.p[3*k]  =vertPk.x;
          pol.p[3*k+1]=vertPk.y;
          pol.p[3*k+2]=vertPk.z;
        }
        pol.normal=normalArray[indPoly];
        intersection x;
        if (off_intersectPoly(&x, a, b, pol))
        {
          x.index = indPoly;
          t[t_size++]=x;
        }
      } /* if (j<pol.npol) */
    } /* if (j<pol.npol) */
    i += pol.npol;
    indPoly++;
  } /* while i<faceSize */
  return t_size;
} /* off_clip_3D_mod */


// off_compare *****************************************************************
int off_compare (void const *a, void const *b)
{
   intersection const *pa = a;
   intersection const *pb = b;

   return off_sign(pa->time - pb->time);
} /* off_compare */

// off_cleanDouble *************************************************************
//given an array of intersections throw those which appear several times
//returns 1 if there is a possibility of error
int off_cleanDouble(intersection* t, int* t_size)
{
  int i=1;
  intersection prev=t[0];
  while (i<*t_size)
  {
    int j=i;
    //for each intersection with the same time
    while (j<*t_size && fabs(prev.time-t[j].time)<OFF_EPSILON)
    {
      //if the intersection is the exact same erase it
      if (prev.in_out==t[j].in_out)
      {
        int k;
        for (k=j+1; k<*t_size; ++k)
        {
          t[k-1]=t[k];
        }
        *t_size-=1;
      }
      else
        ++j;
    }
    prev=t[i];
    ++i;

  }
  return 1;
} /* off_cleanDouble */

// off_cleanInOut **************************************************************
//given an array of intesections throw those which enter and exit in the same time
//Meaning the ray passes very close to the volume
//returns 1 if there is a possibility of error
int off_cleanInOut(intersection* t, int* t_size)
{
  int i=1;
  intersection prev=t[0];
  while (i<*t_size)
  {
    //if two intersection have the same time but one enters and the other exits erase both
    //(such intersections must be adjacent in the array : run off_cleanDouble before)
    if (fabs(prev.time-t[i].time)<OFF_EPSILON && prev.in_out!=t[i].in_out)
    {
      int j=0;
      for (j=i+1; j<*t_size; ++j)
      {
        t[j-2]=t[j];
      }
      *t_size-=2;
      prev=t[i-1];
    }
    else
    {
      prev=t[i];
      ++i;
    }
  }
  return (*t_size);
} /* off_cleanInOut */

/* PUBLIC functions ******************************************************** */

/*******************************************************************************
* long off_init(  char *offfile, double xwidth, double yheight, double zdepth, off_struct* data)
* ACTION: read an OFF file, optionally center object and rescale, initialize OFF data structure
* INPUT: 'offfile' OFF file to read
*        'xwidth,yheight,zdepth' if given as non-zero, apply bounding box.
*           Specifying only one of these will also use the same ratio on all axes
*        'notcenter' center the object to the (0,0,0) position in local frame when set to zero
* RETURN: number of polyhedra and 'data' OFF structure
*******************************************************************************/
long off_init(  char *offfile, double xwidth, double yheight, double zdepth,
                int notcenter, off_struct* data)
{
  // data to be initialized
  long    vtxSize =0, polySize=0, i=0, ret=0, faceSize=0;
  Coords* vtxArray        =NULL;
  Coords* normalArray     =NULL;
  unsigned long* faceArray=NULL;
  FILE*   f               =NULL; /* the FILE with vertices and polygons */
  double minx=FLT_MAX,maxx=-FLT_MAX,miny=FLT_MAX,maxy=-FLT_MAX,minz=FLT_MAX,maxz=-FLT_MAX;

  // get the indexes
  if (!data) return(0);
  
  MPI_MASTER(
  printf("Loading geometry file (OFF/PLY): %s\n", offfile);
  );
  
  f=off_getBlocksIndex(offfile,&vtxSize,&polySize);
  if (!f) return(0);
  
  // read vertex table = [x y z | x y z | ...] =================================
  // now we read the vertices as 'vtxSize*3' numbers and store it in vtxArray 
  MPI_MASTER(
  printf("  Number of vertices: %ld\n", vtxSize);
  );
  vtxArray   = malloc(vtxSize*sizeof(Coords));
  if (!vtxArray) return(0);
  i=0;
  while (i<vtxSize && ~feof(f))
  {
    double x,y,z;
    ret=fscanf(f, "%lg%lg%lg", &x,&y,&z);
    if (!ret) { 
      // invalid line: we skip it (probably a comment)
      char line[CHAR_BUF_LENGTH];
      fgets(line, CHAR_BUF_LENGTH, f);
      continue; 
    }
    if (ret != 3) {
      fprintf(stderr, "Error: can not read [xyz] coordinates for vertex %ld in file %s (interoff/off_init). Read %ld values.\n", 
        i, offfile, ret);
      exit(2);
    }
    vtxArray[i].x=x;
    vtxArray[i].y=y;
    vtxArray[i].z=z;

    //bounding box
    if (vtxArray[i].x<minx) minx=vtxArray[i].x;
    if (vtxArray[i].x>maxx) maxx=vtxArray[i].x;
    if (vtxArray[i].y<miny) miny=vtxArray[i].y;
    if (vtxArray[i].y>maxy) maxy=vtxArray[i].y;
    if (vtxArray[i].z<minz) minz=vtxArray[i].z;
    if (vtxArray[i].z>maxz) maxz=vtxArray[i].z;
    i++; // inquire next vertex
  }

  // resizing and repositioning params
  double centerx=0, centery=0, centerz=0;
  if (!notcenter) {
    centerx=(minx+maxx)*0.5;
    centery=(miny+maxy)*0.5;
    centerz=(minz+maxz)*0.5;
  }

  double rangex=-minx+maxx,
         rangey=-miny+maxy,
         rangez=-minz+maxz;

  double ratiox=1,ratioy=1,ratioz=1;

  if (xwidth && rangex)
  {
    ratiox=xwidth/rangex;
    ratioy=ratiox;
    ratioz=ratiox;
  }

  if (yheight && rangey)
  {
    ratioy=yheight/rangey;
    if(!xwidth)  ratiox=ratioy;
    ratioz=ratioy;
  }

  if (zdepth && rangez)
  {
    ratioz=zdepth/rangez;
    if(!xwidth)  ratiox=ratioz;
    if(!yheight) ratioy=ratioz;
  }

  rangex *= ratiox;
  rangey *= ratioy;
  rangez *= ratioz;

  //center and resize the object
  for (i=0; i<vtxSize; ++i)
  {
    vtxArray[i].x=(vtxArray[i].x-centerx)*ratiox+(!notcenter ? 0 : centerx);
    vtxArray[i].y=(vtxArray[i].y-centery)*ratioy+(!notcenter ? 0 : centery);
    vtxArray[i].z=(vtxArray[i].z-centerz)*ratioz+(!notcenter ? 0 : centerz);
  }
  
  // read face table = [nbvertex v1 v2 vn | nbvertex v1 v2 vn ...] =============
  MPI_MASTER(
  printf("  Number of polygons: %ld\n", polySize);
  );
  normalArray= malloc(polySize*sizeof(Coords));
  faceArray  = malloc(polySize*10*sizeof(unsigned long)); // we assume polygons have less than 9 vertices
  if (!normalArray || !faceArray) return(0);
  
  // fill faces
  faceSize=0;
  i=0;
  while (i<polySize && ~feof(f)) {
    int  nbVertex=0, j=0;
    // read the length of this polygon
    ret=fscanf(f, "%d", &nbVertex);
    if (!ret) { 
      // invalid line: we skip it (probably a comment)
      char line[CHAR_BUF_LENGTH];
      fgets(line, CHAR_BUF_LENGTH, f);
      continue; 
    }
    if (ret != 1) {
      fprintf(stderr, "Error: can not read polygon %ld length in file %s (interoff/off_init)\n", 
        i, offfile);
      exit(3);
    }
    if (faceSize > polySize*10) {
      fprintf(stderr, "Error: %li exceeded allocated polygon array[%li] in file %s (interoff/off_init)\n", 
        faceSize, polySize*10, offfile);
    }
    faceArray[faceSize++] = nbVertex; // length of the polygon/face
    // then read the vertex ID's
    for (j=0; j<nbVertex; j++) {
      double vtx=0;
      fscanf(f, "%lg", &vtx);
      faceArray[faceSize++] = vtx;   // add vertices index after length of polygon
    }
    i++;
  }

  // precomputes normals
  long indNormal=0;//index in polyArray
  i=0;    //index in faceArray
  while (i<faceSize)
  {
    int    nbVertex=faceArray[i];//nb of vertices of this polygon
    double vertices[3*nbVertex];
    int j;

    for (j=0; j<nbVertex; ++j)
    {
      unsigned long indVertPj=faceArray[i+j+1];
      vertices[3*j]  =vtxArray[indVertPj].x;
      vertices[3*j+1]=vtxArray[indVertPj].y;
      vertices[3*j+2]=vtxArray[indVertPj].z;
    }

    polygon p;
    p.p   =vertices;
    p.npol=nbVertex;
    off_normal(&(p.normal),p);

    normalArray[indNormal]=p.normal;

    i += nbVertex+1;
    indNormal++;

  }
  
  MPI_MASTER(
  if (ratiox!=ratioy || ratiox!=ratioz || ratioy!=ratioz)
    printf("Warning: Aspect ratio of the geometry %s was modified.\n"
           "         If you want to keep the original proportions, specifiy only one of the dimensions.\n",
           offfile);
  if ( xwidth==0 && yheight==0 && zdepth==0 ) {
    printf("Warning: Neither xwidth, yheight or zdepth are defined.\n"
	   "           The file-defined (non-scaled) geometry the OFF geometry %s will be applied!\n", 
           offfile);
  }
  printf("  Bounding box dimensions for geometry %s:\n", offfile);
  printf("    Length=%f (%.3f%%)\n", rangex, ratiox*100);
  printf("    Width= %f (%.3f%%)\n", rangey, ratioy*100);
  printf("    Depth= %f (%.3f%%)\n", rangez, ratioz*100);
  );

  data->vtxArray   = vtxArray;
  data->normalArray= normalArray;
  data->faceArray  = faceArray;
  data->vtxSize    = vtxSize;
  data->polySize   = polySize;
  data->faceSize   = faceSize;
  data->filename   = offfile;
  return(polySize);
} /* off_init */

/*******************************************************************************
* int off_intersect_all(double* t0, double* t3,
     Coords *n0, Coords *n3,
     double x, double y, double z,
     double vx, double vy, double vz,
     off_struct *data )
* ACTION: computes intersection of neutron trajectory with an object.
* INPUT:  x,y,z and vx,vy,vz are the position and velocity of the neutron
*         data points to the OFF data structure
* RETURN: the number of polyhedra which trajectory intersects
*         t0 and t3 are the smallest incoming and outgoing intersection times
*         n0 and n3 are the corresponding normal vectors to the surface
*         data is the full OFF structure, including a list intersection type
*******************************************************************************/
int off_intersect_all(double* t0, double* t3,
     Coords *n0, Coords *n3,
     double x,  double y,  double z,
     double vx, double vy, double vz,
     off_struct *data )
{
    Coords A={x, y, z};
    Coords B={x+vx, y+vy, z+vz};
    int t_size=off_clip_3D_mod(data->intersects, A, B,
      data->vtxArray, data->vtxSize, data->faceArray, data->faceSize, data->normalArray );
    qsort(data->intersects, t_size, sizeof(intersection),  off_compare);
    off_cleanDouble(data->intersects, &t_size);
    off_cleanInOut(data->intersects,  &t_size);

    /*find intersections "closest" to 0 (favouring positive ones)*/
    if(t_size>0){
      int i=0;
      if(t_size>1) {
        for (i=1; i < t_size-1; i++){
          if (data->intersects[i-1].time > 0 && data->intersects[i].time > 0)
            break;
        }
	
	data->nextintersect=i-1;
	data->numintersect=t_size;

        if (t0) *t0 = data->intersects[i-1].time;
        if (n0) *n0 = data->intersects[i-1].normal;
        if (t3) *t3 = data->intersects[i].time;
        if (n3) *n3 = data->intersects[i].normal;
      } else {
        if (t0) *t0 = data->intersects[0].time; 	 
	      if (n0) *n0 = data->intersects[0].normal;
      }
      /* should also return t[0].index and t[i].index as polygon ID */
      return t_size;
    }
    return 0;
} /* off_intersect */

/*******************************************************************************
* int off_intersect(double* t0, double* t3,
     Coords *n0, Coords *n3,
     double x, double y, double z,
     double vx, double vy, double vz,
     off_struct data )
* ACTION: computes intersection of neutron trajectory with an object.
* INPUT:  x,y,z and vx,vy,vz are the position and velocity of the neutron
*         data points to the OFF data structure
* RETURN: the number of polyhedra which trajectory intersects
*         t0 and t3 are the smallest incoming and outgoing intersection times
*         n0 and n3 are the corresponding normal vectors to the surface
*******************************************************************************/
int off_intersect(double* t0, double* t3,
     Coords *n0, Coords *n3,
     double x,  double y,  double z,
     double vx, double vy, double vz,
     off_struct data )
{
  return off_intersect_all(t0, t3, n0, n3, x, y, z, vx, vy, vz, &data );
} /* off_intersect */

/*****************************************************************************
* int off_x_intersect(double* l0, double* l3,
     Coords *n0, Coords *n3,
     double x, double y, double z,
     double kx, double ky, double kz,
     off_struct data )
* ACTION: computes intersection of an xray trajectory with an object.
* INPUT:  x,y,z and kx,ky,kz, are spatial coordinates and wavevector of the x-ray
*         respectively. data points to the OFF data structure.
* RETURN: the number of polyhedra the trajectory intersects
*         l0 and l3 are the smallest incoming and outgoing intersection lengths
*         n0 and n3 are the corresponding normal vectors to the surface
*******************************************************************************/
int off_x_intersect(double *l0,double *l3,
     Coords *n0, Coords *n3,
     double x,  double y,  double z,
     double kx, double ky, double kz,
     off_struct data )
{
  /*This function simply reformats and calls off_intersect (as for neutrons)
   *by normalizing the wavevector - this will yield the intersection lengths
   *in m*/
  double jx,jy,jz,invk;
  int n;
  invk=1/sqrt(scalar_prod(kx,ky,kz,kx,ky,kz));
  jx=kx*invk;jy=ky*invk;jz=kz*invk;
  n=off_intersect(l0,l3,n0,n3,x,y,z,jx,jy,jz,data);
  return n;
}


/*******************************************************************************
* void off_display(off_struct data)
* ACTION: display up to N_VERTEX_DISPLAYED polygons from the object
*******************************************************************************/
void off_display(off_struct data)
{
  unsigned int i;
  double ratio=(double)(N_VERTEX_DISPLAYED)/(double)data.faceSize;
  unsigned int pixel=0;
  for (i=0; i<data.faceSize-1; i++) {
    int j;
    int nbVertex = data.faceArray[i];
    double x0,y0,z0;
    x0 = data.vtxArray[data.faceArray[i+1]].x;
    y0 = data.vtxArray[data.faceArray[i+1]].y;
    z0 = data.vtxArray[data.faceArray[i+1]].z;
    double x1=x0,y1=y0,z1=z0;
    double cmx=0,cmy=0,cmz=0;
    
    int drawthis = rand01() < ratio;
    // First pass, calculate center of mass location...
    for (j=1; j<=nbVertex; j++) {
      cmx = cmx+data.vtxArray[data.faceArray[i+j]].x;
      cmy = cmy+data.vtxArray[data.faceArray[i+j]].y;
      cmz = cmz+data.vtxArray[data.faceArray[i+j]].z;
    }
    cmx /= nbVertex;
    cmy /= nbVertex;
    cmz /= nbVertex;
    
    char pixelinfo[1024];    
    sprintf(pixelinfo, "%lu,%lu,%lu,%i,%g,%g,%g,%g,%g,%g", data.mantidoffset+pixel, data.mantidoffset, data.mantidoffset+data.polySize-1, nbVertex, cmx, cmy, cmz, x1-cmx, y1-cmy, z1-cmz);
    for (j=2; j<=nbVertex; j++) {
      double x2,y2,z2;
      x2 = data.vtxArray[data.faceArray[i+j]].x;
      y2 = data.vtxArray[data.faceArray[i+j]].y;
      z2 = data.vtxArray[data.faceArray[i+j]].z;
      sprintf(pixelinfo, "%s,%g,%g,%g", pixelinfo, x2-cmx, y2-cmy, z2-cmz); 
      if (ratio > 1 || drawthis) {
	mcdis_line(x1,y1,z1,x2,y2,z2);
      }
      x1 = x2; y1 = y2; z1 = z2;
    }
    if (ratio > 1 || drawthis) {
	mcdis_line(x1,y1,z1,x0,y0,z0);
      }
    if (data.mantidflag) {
      printf("MANTID_PIXEL: %s\n", pixelinfo);
      pixel++;
    }
    i += nbVertex;
  }
} /* off_display */

/* end of interoff-lib.c */

/* Declare structures and functions only once in each instrument. */
#ifndef POWDERN_DECL_UNION
#define POWDERN_DECL_UNION
/* format definitions in the order {j d F2 DW Dd inv2d q F strain} */
#ifndef Crystallographica
#define Crystallographica { 4,5,7,0,0,0,0,0,0 }
#define Fullprof          { 4,0,8,0,0,5,0,0,0 }
#define Lazy              {17,6,0,0,0,0,0,13,0 }
#define Undefined         { 0,0,0,0,0,0,0,0,0 }
#endif

  struct line_data_union
    {
      double F2;                  /* Value of structure factor */
      double q;                   /* Qvector */
      int j;                      /* Multiplicity */
      double DWfactor;            /* Debye-Waller factor */
      double w;                   /* Intrinsic line width */
      double Epsilon;             /* Strain=delta_d_d/d shift in ppm */
    };

  struct line_info_struct_union
    {
      struct line_data_union *list;     /* Reflection array */
      int  count;                  /* Number of reflections */
      double Dd;
      double DWfactor;
      double V_0;
      double rho;
      double at_weight;
      double at_nb;
      double sigma_a; // should not be used
      double sigma_i; // should not be used
      char   compname[256];
      double flag_barns;
      int    shape; /* 0 cylinder, 1 box, 2 sphere, 3 OFF file */
      int    column_order[9]; /* column signification */
      int    flag_warning;
      char   type;  /* interaction type of event t=Transmit, i=Incoherent, c=Coherent */
      double dq;    /* wavevector transfer [Angs-1] */
      double Epsilon; /* global strain in ppm */
      double XsectionFactor;
      double my_s_v2_sum;
      double my_a_v;
      double my_inc;
      double *w_v,*q_v, *my_s_v2;
      double radius_i,xwidth_i,yheight_i,zdepth_i; // not to be used, but still here
      double v; /* last velocity (cached) */
      double Nq;
      int    nb_reuses, nb_refl, nb_refl_count;
      double v_min, v_max;
      double xs_Nq[CHAR_BUF_LENGTH];
      double xs_sum[CHAR_BUF_LENGTH];
      double neutron_passed;
      long   xs_compute, xs_reuse, xs_calls;
    };

  off_struct offdata_union;
  
  // PN_list_compare *****************************************************************

  int PN_list_compare_union (void const *a, void const *b)
  {
     struct line_data_union const *pa = a;
     struct line_data_union const *pb = b;
     double s = pa->q - pb->q;
     
     if (!s) return 0;
     else    return (s < 0 ? -1 : 1);
  } /* PN_list_compare */

  int read_line_data_union(char *SC_file, struct line_info_struct_union *info)
  {
    struct line_data_union *list = NULL;
    int    size = 0;
    t_Table sTable; /* sample data table structure from SC_file */
    int    i=0;
    int    mult_count  =0;
    char   flag=0;
    double q_count=0, j_count=0, F2_count=0;
    char **parsing;
    int    list_count=0;

    if (!SC_file || !strlen(SC_file) || !strcmp(SC_file, "NULL")) {
      printf("PowderN: %s: Using incoherent elastic scattering only\n",info->compname);
      info->count = 0;
      return(0);
    }
    Table_Read(&sTable, SC_file, 1); /* read 1st block data from SC_file into sTable*/

    /* parsing of header */
    parsing = Table_ParseHeader(sTable.header,
      "Vc","V_0",
      "sigma_abs","sigma_a ",
      "sigma_inc","sigma_i ",
      "column_j",
      "column_d",
      "column_F2",
      "column_DW",
      "column_Dd",
      "column_inv2d", "column_1/2d", "column_sintheta/lambda",
      "column_q", /* 14 */
      "DW", "Debye_Waller",
      "delta_d_d/d",
      "column_F ",
      "V_rho",
      "density",
      "weight",
      "nb_atoms","multiplicity", /* 23 */
      "column_ppm","column_strain",
      NULL);

    if (parsing) {
      if (parsing[0] && !info->V_0)     info->V_0    =atof(parsing[0]);
      if (parsing[1] && !info->V_0)     info->V_0    =atof(parsing[1]);
      if (parsing[2] && !info->sigma_a) info->sigma_a=atof(parsing[2]);
      if (parsing[3] && !info->sigma_a) info->sigma_a=atof(parsing[3]);
      if (parsing[4] && !info->sigma_i) info->sigma_i=atof(parsing[4]);
      if (parsing[5] && !info->sigma_i) info->sigma_i=atof(parsing[5]);
      if (parsing[6])                   info->column_order[0]=atoi(parsing[6]);
      if (parsing[7])                   info->column_order[1]=atoi(parsing[7]);
      if (parsing[8])                   info->column_order[2]=atoi(parsing[8]);
      if (parsing[9])                   info->column_order[3]=atoi(parsing[9]);
      if (parsing[10])                  info->column_order[4]=atoi(parsing[10]);
      if (parsing[11])                  info->column_order[5]=atoi(parsing[11]);
      if (parsing[12])                  info->column_order[5]=atoi(parsing[12]);
      if (parsing[13])                  info->column_order[5]=atoi(parsing[13]);
      if (parsing[14])                  info->column_order[6]=atoi(parsing[14]);
      if (parsing[15] && info->DWfactor<=0)    info->DWfactor=atof(parsing[15]);
      if (parsing[16] && info->DWfactor<=0)    info->DWfactor=atof(parsing[16]);
      if (parsing[17] && info->Dd <0)          info->Dd      =atof(parsing[17]);
      if (parsing[18])                  info->column_order[7]=atoi(parsing[18]);
      if (parsing[19] && !info->V_0)    info->V_0    =1/atof(parsing[19]);
      if (parsing[20] && !info->rho)    info->rho    =atof(parsing[20]);
      if (parsing[21] && !info->at_weight)     info->at_weight    =atof(parsing[21]);
      if (parsing[22] && info->at_nb <= 1)  info->at_nb    =atof(parsing[22]);
      if (parsing[23] && info->at_nb <= 1)  info->at_nb    =atof(parsing[23]);
      if (parsing[24])                  info->column_order[8]=atoi(parsing[24]);
      if (parsing[25])                  info->column_order[8]=atoi(parsing[25]);
      for (i=0; i<=25; i++) if (parsing[i]) free(parsing[i]);
      free(parsing);
    }

    if (!sTable.rows)
      exit(fprintf(stderr, "PowderN: %s: Error: The number of rows in %s "
       "should be at least %d\n", info->compname, SC_file, 1));
    else size = sTable.rows;
    Table_Info(sTable);
    printf("PowderN: %s: Reading %d rows from %s\n",
          info->compname, size, SC_file);

    if (info->column_order[0] == 4 && info->flag_barns !=0)
    printf("PowderN: %s: Powder file probably of type Crystallographica/Fullprof (lau)\n"
           "WARNING: but F2 unit is set to barns=1 (barns). Intensity might be 100 times too high.\n",
           info->compname);
  if (info->column_order[0] == 17 && info->flag_barns == 0)
    printf("PowderN: %s: Powder file probably of type Lazy Pulver (laz)\n"
           "WARNING: but F2 unit is set to barns=0 (fm^2). Intensity might be 100 times too low.\n",
           info->compname);
    /* allocate line_data array */
    list = (struct line_data_union*)malloc(size*sizeof(struct line_data_union));

    for (i=0; i<size; i++)
    {
      /*      printf("Reading in line %i\n",i);*/
      double j=0, d=0, w=0, q=0, DWfactor=0, F2=0, Epsilon=0;
      int index;

      if (info->Dd >= 0)      w         = info->Dd;
      if (info->DWfactor > 0) DWfactor  = info->DWfactor;
      if (info->Epsilon)      Epsilon   = info->Epsilon*1e-6;

      /* get data from table using columns {j d F2 DW Dd inv2d q F} */
      /* column indexes start at 1, thus need to substract 1 */
      if (info->column_order[0] >0)
        j = Table_Index(sTable, i, info->column_order[0]-1);
      if (info->column_order[1] >0)
        d = Table_Index(sTable, i, info->column_order[1]-1);
      if (info->column_order[2] >0)
        F2 = Table_Index(sTable, i, info->column_order[2]-1);
      if (info->column_order[3] >0)
        DWfactor = Table_Index(sTable, i, info->column_order[3]-1);
      if (info->column_order[4] >0)
        w = Table_Index(sTable, i, info->column_order[4]-1);
      if (info->column_order[5] >0)
        { d = Table_Index(sTable, i, info->column_order[5]-1);
          d = (d > 0? 1/d/2 : 0); }
      if (info->column_order[6] >0)
        { q = Table_Index(sTable, i, info->column_order[6]-1);
          d = (q > 0 ? 2*PI/q : 0); }
      if (info->column_order[7] >0  && !F2)
        { F2 = Table_Index(sTable, i, info->column_order[7]-1); F2 *= F2; }
      if (info->column_order[8] >0  && !Epsilon)
        { Epsilon = Table_Index(sTable, i, info->column_order[8]-1)*1e-6; }

      /* assign and check values */
      j        = (j > 0 ? j : 0);
      q        = (d > 0 ? 2*PI/d : 0); /* this is q */
      if (Epsilon && fabs(Epsilon) < 1e6) {
        q     -= Epsilon*q; /* dq/q = -delta_d_d/d = -Epsilon */
      }
      DWfactor = (DWfactor > 0 ? DWfactor : 1);
      w        = (w>0 ? w : 0); /* this is q and d relative spreading */
      F2       = (F2 >= 0 ? F2 : 0);
      if (j == 0 || q == 0) {
        printf("PowderN: %s: line %i has invalid definition\n"
               "         (mult=0 or q=0 or d=0)\n", info->compname, i);
        continue;
      }
      list[list_count].j = j;
      list[list_count].q = q;
      list[list_count].DWfactor = DWfactor;
      list[list_count].w = w;
      list[list_count].F2= F2;
      list[list_count].Epsilon = Epsilon;

      /* adjust multiplicity if j-column + multiple d-spacing lines */
      /* if  d = previous d, increase line duplication index */
      if (!q_count)      q_count  = q;
      if (!j_count)      j_count  = j;
      if (!F2_count)     F2_count = F2;
      if (fabs(q_count-q) < 0.0001*fabs(q)
       && fabs(F2_count-F2) < 0.0001*fabs(F2) && j_count == j) {
       mult_count++; flag=0; }
      else flag=1;
      if (i == size-1) flag=1;
      /* else if d != previous d : just passed equivalent lines */
      if (flag) {
        if (i == size-1) list_count++;
      /*   if duplication index == previous multiplicity */
      /*      set back multiplicity of previous lines to 1 */
        if ((mult_count && list_count>0)
            && (mult_count == list[list_count-1].j
                || ((list_count < size) && (i == size - 1)
                    && (mult_count == list[list_count].j))) ) {
          printf("PowderN: %s: Set multiplicity to 1 for lines [%i:%i]\n"
                  "         (d-spacing %g is duplicated %i times)\n",
            info->compname, list_count-mult_count, list_count-1, list[list_count-1].q, mult_count);
          for (index=list_count-mult_count; index<list_count; list[index++].j = 1);
          mult_count = 1;
          q_count   = q;
          j_count   = j;
          F2_count  = F2;
        }
        if (i == size-1) list_count--;
        flag=0;
      }
      list_count++;
    } /* end for */ 
    
    Table_Free(&sTable);
    
    /* sort the list with increasing q */
    qsort(list, list_count, sizeof(struct line_data_union),  PN_list_compare_union);
    
    printf("PowderN: %s: Read %i reflections from file '%s'\n", 
      info->compname, list_count, SC_file);
    
    info->list  = list;
    info->count = list_count;

    return(list_count);
  } /* read_line_data_union */


/* computes the number of possible reflections (return value), and the total xsection 'sum' */
/* this routine looks for a pre-computed value in the Nq and sum cache tables               */
/* when found, the earch starts from the corresponding lower element in the table           */
int calc_xsect_union(double v, double *qv, double *my_sv2, int count, double *sum,
  struct line_info_struct_union *line_info) {
  int    Nq = 0, line=0, line0=0;
  *sum=0;
  
  //printf("Line_info when entering cross_section calculation\n");
  //printf("v = %f, qv = %f, my_sv2 = %f, count = %d, sum = %f\n",v,*qv,*my_sv2,count,*sum);
  //printf("v = %f\n",v);
  //printf("line_info->v = %f, line_info->v_min = %f, line_info->v_max = %f, line_info->neutron_passed = %f\n",line_info->v,line_info->v_min,line_info->v_max,line_info->neutron_passed);
  //printf("line_info->xs_reuses = %d, line_info->xs_compute = %d\n",line_info->xs_reuse,line_info->xs_compute);
  
  
  /* check if a line_info element has been recorded already */
  if (v >= line_info->v_min && v <= line_info->v_max && line_info->neutron_passed >= CHAR_BUF_LENGTH) {
    line = (int)floor(v - line_info->v_min)*CHAR_BUF_LENGTH/(line_info->v_max - line_info->v_min);
    Nq    = line_info->xs_Nq[line];
    *sum  = line_info->xs_sum[line];
    if (!Nq && *sum == 0) {
      /* not yet set: we compute the sum up to the corresponding speed in the table cache */
      //printf("Nq and sum not yet set, have to do this calculation now\n");
      double line_v = line_info->v_min + line*(line_info->v_max - line_info->v_min)/CHAR_BUF_LENGTH;
      for(line0=0; line0<count; line0++) {
        if (qv[line0] <= 2*line_v) { /* q < 2*kf: restrict structural range */
          *sum += my_sv2[line0];
          if (Nq < line0+1) Nq=line0+1; /* determine maximum line index which can scatter */
        } else break;
      }
      line_info->xs_Nq[line] = Nq;
      line_info->xs_sum[line]= *sum;
      line_info->xs_compute++;
      //printf("line_info->xs_Nq[line] = %f, line_info->xs_sum[line] = %f, line_info->xs_compute = %d\n",line_info->xs_Nq[line],line_info->xs_sum[line],line_info->xs_compute);
    } else line_info->xs_reuse++;
    line0 = Nq;
  }
  
  line_info->xs_calls++;
  
  for(line=line0; line<count; line++) {
    if (qv[line] <= 2*v) { /* q < 2*kf: restrict structural range */
      *sum += my_sv2[line];
      if (Nq < line+1) Nq=line+1; /* determine maximum line index which can scatter */
    } else break;
  }
  
  //printf("cross_section function to return %d lines to scatter with, with cross section sum %f \n",Nq,*sum);
  return(Nq);
} /* calc_xsect_union */

#endif /* !POWDERN_DECL */



struct Powder_physics_storage_struct{
    // Variables that needs to be transfered between any of the following places:
    // The initialize in this component
    // The function for calculating my
    // The function for calculating scattering
    
    struct line_info_struct_union *line_info_storage;
    double my_scattering;
    double vertical_angular_limit;
};

// Obsolete: Function for initializing test_physics. Done in component instead.
int Powder_physics_initialize(union data_transfer_union data_transfer) {
      // Obsolte
      return 1;
};

// Function for calculating my in a test case.
int Powder_physics_my(double *my,double *k_initial, union data_transfer_union data_transfer, struct focus_data_struct *focus_data) {
    //*my = data_transfer.pointer_to_a_Powder_physics_storage_struct->my_scattering;
    
    
    int method_switch = 1;
    // For test
    int line_v,line0,line,count;
    
    // Should not interfer with the global variables
    double vx = k_initial[0]*K2V;
    double vy = k_initial[1]*K2V;
    double vz = k_initial[2]*K2V;
    
    // Not sure one can do this, but I do not see why not
    struct line_info_struct_union *line_info = data_transfer.pointer_to_a_Powder_physics_storage_struct->line_info_storage;
    
    double v = sqrt(vx*vx + vy*vy + vz*vz);
    //printf("Velocity = %f \n",v);
    
    //printf("line_info->v = %f, line_info->v_min = %f, line_info->v_max = %f, line_info->neutron_passed = %f\n",line_info->v,line_info->v_min,line_info->v_max,line_info->neutron_passed);
    // Here the maximum and minimum v is recorded, should this be for scattering events or cross section calculations?
    if (line_info->neutron_passed < CHAR_BUF_LENGTH) {
      if (v < line_info->v_min) line_info->v_min = v;
      if (v > line_info->v_max) line_info->v_max = v;
      line_info->neutron_passed++;
    }
    
    if (method_switch == 1) {
    // Here the cross section is calculated and stored
    if ( fabs(v - line_info->v) < 1e-6) {
        line_info->nb_reuses++;
      } else {
        //printf("calling crosssection calculation \n");
        // int calc_xsect_union(double v, double *qv, double *my_sv2, int count, double *sum, struct line_info_struct *line_info)
        line_info->Nq = calc_xsect_union(v, line_info->q_v, line_info->my_s_v2, line_info->count, &line_info->my_s_v2_sum, line_info);
        line_info->v = v;
        line_info->nb_refl += line_info->Nq;
        line_info->nb_refl_count++;
      }
    } else {
    if ( fabs(v - line_info->v) < 1e-6) {
        line_info->nb_reuses++;
      } else {
        //printf("calling crosssection calculation \n");
        if (v >= line_info->v_min && v <= line_info->v_max && line_info->neutron_passed >= CHAR_BUF_LENGTH) {
        line = (int)floor(v - line_info->v_min)*CHAR_BUF_LENGTH/(line_info->v_max - line_info->v_min);
        line_info->Nq = line_info->xs_Nq[line];
        line_info->my_s_v2_sum  = line_info->xs_sum[line];
        if (!line_info->Nq && line_info->my_s_v2_sum == 0) {
          /* not yet set: we compute the sum up to the corresponding speed in the table cache */
          //printf("Nq and sum not yet set, have to do this calculation now\n");
          double line_v = line_info->v_min + line*(line_info->v_max - line_info->v_min)/CHAR_BUF_LENGTH;
          for(line0=0; line0<count; line0++) {
            if (line_info->q_v[line0] <= 2*line_v) { /* q < 2*kf: restrict structural range */
              line_info->my_s_v2_sum += line_info->my_s_v2[line0];
              if (line_info->Nq < line0+1) line_info->Nq=line0+1; /* determine maximum line index which can scatter */
            } else break;
          }
          line_info->xs_Nq[line] = line_info->Nq;
          line_info->xs_sum[line]= line_info->my_s_v2_sum;
          line_info->xs_compute++;
          //printf("line_info->xs_Nq[line] = %f, line_info->xs_sum[line] = %f, line_info->xs_compute = %d\n",line_info->xs_Nq[line],line_info->xs_sum[line],line_info->xs_compute);
        } else line_info->xs_reuse++;
        line0 = line_info->Nq;
        }
          
        line_info->xs_calls++;
          
        for(line=line0; line<count; line++) {
          if (line_info->q_v[line] <= 2*v) { /* q < 2*kf: restrict structural range */
            line_info->my_s_v2_sum += line_info->my_s_v2[line];
            if (line_info->Nq < line+1) line_info->Nq=line+1; /* determine maximum line index which can scatter */
          } else break;
        }
        line_info->v = v;
        line_info->nb_refl += line_info->Nq;
        line_info->nb_refl_count++;
      }
    }
    
     *my = line_info->my_s_v2_sum/(v*v);
    //printf("Returned my scattering of %f \n",*my);
    //printf("compute = %d and reuse = %d \n",line_info->xs_compute,line_info->xs_reuse);
    
    return 1;
};

// Function that provides a basic nonuniform elastic scattering. Unphysical for testing purposes.
int Powder_physics_scattering(double *k_final, double *k_initial, double *weight, union data_transfer_union data_transfer, struct focus_data_struct *focus_data) {

    // This component need to write to its storage transfer for each event, is that possible with this structure?
    struct line_info_struct_union *line_info = data_transfer.pointer_to_a_Powder_physics_storage_struct->line_info_storage;
    double vertical_angular_limit = data_transfer.pointer_to_a_Powder_physics_storage_struct->vertical_angular_limit;
    
    
    // Should not interfer with the global variables
    double vx = k_initial[0]*K2V;
    double vy = k_initial[1]*K2V;
    double vz = k_initial[2]*K2V;
    
    double v = sqrt(vx*vx + vy*vy + vz*vz);
    
    int line;
    double arg;
    double theta;
    double alpha,alpha0;
    
    double vout_x,vout_y,vout_z;
    double tmp_vx,tmp_vy,tmp_vz;
    double nx,ny,nz;
    double my_s_n;
    
    // copy from PowderN component
    if (line_info->count > 0) {
          /* choose line */
          if (line_info->Nq > 1) line=floor(line_info->Nq*rand01());  /* Select between Nq powder lines */
          else line = 0;
          if (line_info->w_v[line])
            arg = line_info->q_v[line]*(1+line_info->w_v[line]*randnorm())/(2.0*v);
          else
            arg = line_info->q_v[line]/(2.0*v);
            my_s_n = line_info->my_s_v2[line]/(v*v);
          if(fabs(arg) > 1) {
            //printf("Powder scattering function returned 0, should not happen\n");
            return 0; /* No bragg scattering possible (was absorb)*/
          }
          theta = asin(arg);          /* Bragg scattering law */

          /* Choose point on Debye-Scherrer cone */
          if (vertical_angular_limit)
          { /* relate height of detector to the height on DS cone */
            arg = sin(vertical_angular_limit*DEG2RAD/2)/sin(2*theta);
            /* If full Debye-Scherrer cone is within d_phi, don't focus */
            if (arg < -1 || arg > 1) vertical_angular_limit = 0;
            /* Otherwise, determine alpha to rotate from scattering plane
               into vertical_angular_limit focusing area*/
            else alpha = 2*asin(arg);
          }
          if (vertical_angular_limit) {
            /* Focusing */
            alpha = fabs(alpha);
            /* Trick to get scattering for pos/neg theta's */
            alpha0= 2*rand01()*alpha;
            if (alpha0 > alpha) {
              alpha0=PI+(alpha0-1.5*alpha);
            } else {
              alpha0=alpha0-0.5*alpha;
            }
          }
          else
            alpha0 = PI*randpm1();

          /* now find a nearly vertical rotation axis:
           * Either
           *  (v along Z) x (X axis) -> nearly Y axis
           * Or
           *  (v along X) x (Z axis) -> nearly Y axis
           */
          if (fabs(scalar_prod(1,0,0,vx/v,vy/v,vz/v)) < fabs(scalar_prod(0,0,1,vx/v,vy/v,vz/v))) {
            nx = 1; ny = 0; nz = 0;
          } else {
            nx = 0; ny = 0; nz = 1;
          }
          vec_prod(tmp_vx,tmp_vy,tmp_vz, vx,vy,vz, nx,ny,nz);

          /* v_out = rotate 'v' by 2*theta around tmp_v: Bragg angle */
          rotate(vout_x,vout_y,vout_z, vx,vy,vz, 2*theta, tmp_vx,tmp_vy,tmp_vz);

          /* tmp_v = rotate v_out by alpha0 around 'v' (Debye-Scherrer cone) */
          rotate(tmp_vx,tmp_vy,tmp_vz, vout_x,vout_y,vout_z, alpha0, vx, vy, vz);
          vx = tmp_vx;
          vy = tmp_vy;
          vz = tmp_vz;
        
          k_final[0] = V2K*vx; k_final[1] = V2K*vy; k_final[2] = V2K*vz;
        
          //*weight *= line_info->Nq*my_s_n; I believe my_s_n is part of the correction for sampling posistion, not to be done here
          *weight *= line_info->Nq*my_s_n/line_info->my_s_v2_sum*v*v;
        
          //printf("my_s_n = %f \n",my_s_n);
        
          // What to do with my_s_n ?
          /*
          pmul  = line_info->Nq*l_full*my_s_n*exp(-(line_info->my_a_v/v+my_s)*(l+l_1))
                                  /(1-(p_inc+p_transmit));
          */
          // Correction in case of vertical_angular_limit focusing - BUT only when d_phi != 0
          if (vertical_angular_limit) *weight *= alpha/PI;
          
        
          line_info->type = 'c';
          line_info->dq = line_info->q_v[line]*V2K;
          
          
        } else {
        /* else transmit <-- No powder lines in file */
        printf("Error, need lines in the PowderN input file\n");
        }


    //printf("Powder scattering function returned 1\n");
    return 1;
};

#line 8407 "MACS_sample_kidney_box.c"

/* Shared user declarations for all components 'Union_make_material'. */
#line 57 "Union_make_material.comp"
#ifndef Union
#define Union $Revision: 0.8 $

#include "Union_functions.c"
#include "Union_initialization.c"

#endif

// This function checks if global_process_element should be included in this material when using automatic linking, returns 1 if yes, 0 if no.
int automatic_linking_materials_function(struct global_process_element_struct global_process_element, struct pointer_to_global_material_list global_material_list,int current_index) {
    // Remember this function is used before the current material is added to global_material_list
    // debug info
    //MPI_MASTER(
    //printf("Checking if process with index %d should be automatically linked to material with index %d\n",global_process_element.component_index,current_index);
    //)

    // Check if this is the first make_material, which makes the problem simpler.
    if (global_material_list.num_elements == 0) {
       if (global_process_element.component_index < current_index) return 1;
       else return 0;
    }
    // In case there are more than 1 make_material, global_material_list.elements[global_material_list.num_elements-1].component_index makes sense.
    if (global_process_element.component_index < current_index && global_process_element.component_index > global_material_list.elements[global_material_list.num_elements-1].component_index) return 1;
    else return 0;
}

void manual_linking_function_material(char *input_string, struct pointer_to_global_process_list *global_process_list, struct pointer_to_1d_int_list *accepted_processes, char *component_name) {
    // Need to check a input_string of text for an occurance of name. If it is in the inputstring, yes return 1, otherwise 0.
   char *token;
   int loop_index;
   char local_string[256];
   
   strcpy(local_string,input_string);
   // get the first token
   token = strtok(local_string,",");
   
   // walk through other tokens
   while( token != NULL ) 
   {
      //printf( " %s\n", token );
      for (loop_index=0;loop_index<global_process_list->num_elements;loop_index++) {
        if (strcmp(token,global_process_list->elements[loop_index].name) == 0) {
          add_element_to_int_list(accepted_processes,loop_index);
          break;
        }
        
        if (loop_index == global_process_list->num_elements - 1) {
          // All possible process names have been looked through, and the break was not executed.
          // Alert the user to this problem by showing the process name that was not found and the currently available processes
            printf("\n");
            printf("ERROR: The process string \"%s\" in Union material \"%s\" had an entry that did not match a specified process. \n",input_string,component_name);
            printf("       The unrecoignized process name was: \"%s\" \n",token);
            printf("       The processes available at this point (need to be defined before the material): \n");
            for (loop_index=0;loop_index<global_process_list->num_elements;loop_index++)
              printf("         %s\n",global_process_list->elements[loop_index].name);
            exit(1);
        }
      }
      
      // Updates the token
      token = strtok(NULL,",");
   }
}

// This function is needed in initialize of all geometry components
// Possible to insert these functions in make material, as they are only compiled once instead of many times
int manual_linking_function(char *name, char *input_string) {
    // Need to check a input_string of text for an occurance of name. If it is in the inputstring, yes return 1, otherwise 0.
   char *token;
   int return_integer=0;
   char local_string[124];
   
   strcpy(local_string,input_string);
   /* get the first token */
   token = strtok(local_string,",");
   
   /* walk through other tokens */
   while( token != NULL ) 
   {
      //printf( " %s\n", token );
      if (strcmp(token,name) == 0) return_integer=1;
      
      token = strtok(NULL,",");
   }
   
   return return_integer;
}



/*
int count_commas(char *string) {
  int return_value = 0;
  
  int index;
  for (index=0;index<strlen(string);index++) {
    printf("%c \n",string[index]);
    if (string[index]==',') return_value++;
  }
    
  //printf("number_of_commas = %d \n",return_value);
  return return_value;
}
*/


#line 8517 "MACS_sample_kidney_box.c"

/* Shared user declarations for all components 'Single_crystal_process'. */
#line 65 "Single_crystal_process.comp"
#ifndef Union
#define Union $Revision: 0.8 $

#include "Union_functions.c"
#include "Union_initialization.c"

#endif




#ifndef SINGLE_CRYSTAL_PROCESS_DECL
#define SINGLE_CRYSTAL_PROCESS_DECL

#ifndef Mosaic_AB_Undefined
#define Mosaic_AB_Undefined {0,0, 0,0,0, 0,0,0}
#endif

    struct hkl_data_union
    {
      int h,k,l;                  /* Indices for this reflection */
      double F2;                  /* Value of structure factor */
      double tau_x, tau_y, tau_z; /* Coordinates in reciprocal space */
      double tau;                 /* Length of (tau_x, tau_y, tau_z) */
      double u1x, u1y, u1z;       /* First axis of local coordinate system */
      double u2x, u2y, u2z;       /* Second axis of local coordinate system */
      double u3x, u3y, u3z;       /* Third axis of local coordinate system */
      double sig123;              /* The product sig1*sig2*sig3 = volume of spot */
      double m1, m2, m3;          /* Diagonal matrix representation of Gauss */
      double cutoff;              /* Cutoff value for Gaussian tails */
    };
    
  struct tau_data_union
    {
      int index;                  /* Index into reflection table */
      double refl;
      double xsect;
      /* The following vectors are in local koordinates. */
      double rho_x, rho_y, rho_z; /* The vector ki - tau */
      double rho;                 /* Length of rho vector */
      double ox, oy, oz;          /* Origin of Ewald sphere tangent plane */
      double b1x, b1y, b1z;       /* Spanning vectors of Ewald sphere tangent */
      double b2x, b2y, b2z;
      double l11, l12, l22;       /* Cholesky decomposition L of 2D Gauss */
      double y0x, y0y;            /* 2D Gauss center in tangent plane */
    };

  struct hkl_info_struct_union
    {
      struct hkl_data_union *list;      /* Reflection array */
      int count;                  /* Number of reflections */
      struct tau_data_union *tau_list;  /* Reflections close to Ewald Sphere */
      double m_delta_d_d;         /* Delta-d/d FWHM */
      double m_ax,m_ay,m_az;      /* First unit cell axis (direct space, AA) */
      double m_bx,m_by,m_bz;      /* Second unit cell axis */
      double m_cx,m_cy,m_cz;      /* Third unit cell axis */
      double asx,asy,asz;         /* First reciprocal lattice axis (1/AA) */
      double bsx,bsy,bsz;         /* Second reciprocal lattice axis */
      double csx,csy,csz;         /* Third reciprocal lattice axis */
      double m_a, m_b, m_c;       /* length of lattice parameter lengths */
      double m_aa, m_bb, m_cc;    /* lattice angles */
      double sigma_a, sigma_i;    /* abs and inc X sect */
      double rho;                 /* density */
      double at_weight;           /* atomic weight */
      double at_nb;               /* nb of atoms in a cell */
      double V0;                  /* Unit cell volume (AA**3) */
      int    column_order[5];     /* column signification [h,k,l,F,F2] */
      int    recip;               /* Flag to indicate if recip or direct cell axes given */
      int    shape;               /* 0:cylinder, 1:box, 2:sphere 3:any shape*/
      int    flag_warning;        /* number of warnings */
      char   type;                /* type of last event: t=transmit,c=coherent or i=incoherent */
      int    h,k,l;               /* last coherent scattering momentum transfer indices */
      int    tau_count;           /* Number of reflections within cutoff */
      double coh_refl, coh_xsect; /* cross section computed with last tau_list */
      double kix, kiy, kiz;       /* last incoming neutron ki */
      int    nb_reuses, nb_refl, nb_refl_count;
    };

  int SX_list_compare_union (void const *a, void const *b)
  {
     struct hkl_data_union const *pa = a;
     struct hkl_data_union const *pb = b;
     double s = pa->tau - pb->tau;
     
     if (!s) return 0;
     else    return (s < 0 ? -1 : 1);
  } /* PN_list_compare */
  
  /* ------------------------------------------------------------------------ */
  int
  read_hkl_data_union(char *SC_file, struct hkl_info_struct_union *info,
      double SC_mosaic, double SC_mosaic_a, double SC_mosaic_b, double SC_mosaic_c, double *SC_mosaic_AB)
  {
    struct hkl_data_union *list = NULL;
    int size = 0;
    t_Table sTable; /* sample data table structure from SC_file */
    int i=0;
    double tmp_x, tmp_y, tmp_z;
    char **parsing;
    char flag=0;
    double nb_atoms=1;

    if (!SC_file || !strlen(SC_file) || !strcmp(SC_file,"NULL") || !strcmp(SC_file,"0")) {
      info->count = 0;
      flag=1;
    }
    if (!flag) {
      Table_Read(&sTable, SC_file, 1); /* read 1st block data from SC_file into sTable*/
      if (sTable.columns < 4) {
        fprintf(stderr, "Single_crystal: Error: The number of columns in %s should be at least %d for [h,k,l,F2]\n", SC_file, 4);
        return(0);
      }
      if (!sTable.rows) {
        fprintf(stderr, "Single_crystal: Error: The number of rows in %s should be at least %d\n", SC_file, 1);
        return(0);
      } else size = sTable.rows;

      /* parsing of header */
      parsing = Table_ParseHeader(sTable.header,
        "sigma_abs","sigma_a ",
        "sigma_inc","sigma_i ",
        "column_h",
        "column_k",
        "column_l",
        "column_F ",
        "column_F2",
        "Delta_d/d",
        "lattice_a ",
        "lattice_b ",
        "lattice_c ",
        "lattice_aa",
        "lattice_bb",
        "lattice_cc",
        "nb_atoms","multiplicity",
        NULL);

      if (parsing) {
        if (parsing[0] && !info->sigma_a) info->sigma_a=atof(parsing[0]);
        if (parsing[1] && !info->sigma_a) info->sigma_a=atof(parsing[1]);
        if (parsing[2] && !info->sigma_i) info->sigma_i=atof(parsing[2]);
        if (parsing[3] && !info->sigma_i) info->sigma_i=atof(parsing[3]);
        if (parsing[4])                   info->column_order[0]=atoi(parsing[4]);
        if (parsing[5])                   info->column_order[1]=atoi(parsing[5]);
        if (parsing[6])                   info->column_order[2]=atoi(parsing[6]);
        if (parsing[7])                   info->column_order[3]=atoi(parsing[7]);
        if (parsing[8])                   info->column_order[4]=atoi(parsing[8]);
        if (parsing[9] && info->m_delta_d_d <0) info->m_delta_d_d=atof(parsing[9]);
        if (parsing[10] && !info->m_a)    info->m_a =atof(parsing[10]);
        if (parsing[11] && !info->m_b)    info->m_b =atof(parsing[11]);
        if (parsing[12] && !info->m_c)    info->m_c =atof(parsing[12]);
        if (parsing[13] && !info->m_aa)   info->m_aa=atof(parsing[13]);
        if (parsing[14] && !info->m_bb)   info->m_bb=atof(parsing[14]);
        if (parsing[15] && !info->m_cc)   info->m_cc=atof(parsing[15]);
        if (parsing[16])   nb_atoms=atof(parsing[16]);
        if (parsing[17])   nb_atoms=atof(parsing[17]);
        for (i=0; i<=17; i++) if (parsing[i]) free(parsing[i]);
        free(parsing);
      }
    }
    
    if (nb_atoms > 1) { info->sigma_a *= nb_atoms; info->sigma_i *= nb_atoms; }

    /* special cases for the structure definition */
    if (info->m_ax || info->m_ay || info->m_az) info->m_a=0; /* means we specify by hand the vectors */
    if (info->m_bx || info->m_by || info->m_bz) info->m_b=0;
    if (info->m_cx || info->m_cy || info->m_cz) info->m_c=0;

    /* compute the norm from vector a if missing */
    if (info->m_ax || info->m_ay || info->m_az) {
      double as=sqrt(info->m_ax*info->m_ax+info->m_ay*info->m_ay+info->m_az*info->m_az);
      if (!info->m_bx && !info->m_by && !info->m_bz) info->m_a=info->m_b=as;
      if (!info->m_cx && !info->m_cy && !info->m_cz) info->m_a=info->m_c=as;
    }
    if (info->m_a && !info->m_b) info->m_b=info->m_a;
    if (info->m_b && !info->m_c) info->m_c=info->m_b;
    
    /* compute the lattive angles if not set from data file. Not used when in vector mode. */
    if (info->m_a && !info->m_aa) info->m_aa=90;
    if (info->m_aa && !info->m_bb) info->m_bb=info->m_aa;
    if (info->m_bb && !info->m_cc) info->m_cc=info->m_bb;
    
    /* parameters consistency checks */
    if (!info->m_ax && !info->m_ay && !info->m_az && !info->m_a) {
      fprintf(stderr,
              "Single_crystal: Error: Wrong a lattice vector definition\n");
      return(0);
    }
    if (!info->m_bx && !info->m_by && !info->m_bz && !info->m_b) {
      fprintf(stderr,
              "Single_crystal: Error: Wrong b lattice vector definition\n");
      return(0);
    }
    if (!info->m_cx && !info->m_cy && !info->m_cz && !info->m_c) {
      fprintf(stderr,
              "Single_crystal: Error: Wrong c lattice vector definition\n");
      return(0);
    }
    
    if (info->m_aa && info->m_bb && info->m_cc && info->recip) {
      fprintf(stderr,
              "Single_crystal: Error: Selecting reciprocal cell and angles is unmeaningful\n");
      return(0);
    }


    /* when lengths a,b,c + angles are given (instead of vectors a,b,c) */
    if (info->m_aa && info->m_bb && info->m_cc)
    {
      double as,bs,cs;
      if (info->m_a) as = info->m_a;
      else as = sqrt(info->m_ax*info->m_ax+info->m_ay*info->m_ay+info->m_az*info->m_az);
      if (info->m_b) bs = info->m_b;
      else bs = sqrt(info->m_bx*info->m_bx+info->m_by*info->m_by+info->m_bz*info->m_bz);
      if (info->m_c) cs = info->m_c;
      else cs =  sqrt(info->m_cx*info->m_cx+info->m_cy*info->m_cy+info->m_cz*info->m_cz);

      info->m_bz = as; info->m_by = 0; info->m_bx = 0;
      info->m_az = bs*cos(info->m_cc*DEG2RAD);
      info->m_ay = bs*sin(info->m_cc*DEG2RAD);
      info->m_ax = 0;
      info->m_cz = cs*cos(info->m_bb*DEG2RAD);
      info->m_cy = cs*(cos(info->m_aa*DEG2RAD)-cos(info->m_cc*DEG2RAD)*cos(info->m_bb*DEG2RAD))
                     /sin(info->m_cc*DEG2RAD);
      info->m_cx = sqrt(cs*cs - info->m_cz*info->m_cz - info->m_cy*info->m_cy);

      printf("Single_crystal: %s structure a=%g b=%g c=%g aa=%g bb=%g cc=%g ",
        (flag ? "INC" : SC_file), as, bs, cs, info->m_aa, info->m_bb, info->m_cc);
    } else {
      if (!info->recip) {
        printf("Single_crystal: %s structure a=[%g,%g,%g] b=[%g,%g,%g] c=[%g,%g,%g] ",
	       (flag ? "INC" : SC_file), info->m_ax ,info->m_ay ,info->m_az,
	       info->m_bx ,info->m_by ,info->m_bz,
	       info->m_cx ,info->m_cy ,info->m_cz);
      } else {
        printf("Single_crystal: %s structure a*=[%g,%g,%g] b*=[%g,%g,%g] c*=[%g,%g,%g] ",
	       (flag ? "INC" : SC_file), info->m_ax ,info->m_ay ,info->m_az,
	       info->m_bx ,info->m_by ,info->m_bz,
	       info->m_cx ,info->m_cy ,info->m_cz);
      }
    }
    /* Compute reciprocal or direct lattice vectors. */
    if (!info->recip) {
      vec_prod(tmp_x, tmp_y, tmp_z,
	       info->m_bx, info->m_by, info->m_bz,
	       info->m_cx, info->m_cy, info->m_cz);
      info->V0 = fabs(scalar_prod(info->m_ax, info->m_ay, info->m_az, tmp_x, tmp_y, tmp_z));
      printf("V0=%g\n", info->V0);
      
      info->asx = 2*PI/info->V0*tmp_x;
      info->asy = 2*PI/info->V0*tmp_y;
      info->asz = 2*PI/info->V0*tmp_z;
      vec_prod(tmp_x, tmp_y, tmp_z, info->m_cx, info->m_cy, info->m_cz, info->m_ax, info->m_ay, info->m_az);
      info->bsx = 2*PI/info->V0*tmp_x;
      info->bsy = 2*PI/info->V0*tmp_y;
      info->bsz = 2*PI/info->V0*tmp_z;
      vec_prod(tmp_x, tmp_y, tmp_z, info->m_ax, info->m_ay, info->m_az, info->m_bx, info->m_by, info->m_bz);
      info->csx = 2*PI/info->V0*tmp_x;
      info->csy = 2*PI/info->V0*tmp_y;
      info->csz = 2*PI/info->V0*tmp_z;
    } else {
      info->asx = info->m_ax;
      info->asy = info->m_ay;
      info->asz = info->m_az;
      info->bsx = info->m_bx;
      info->bsy = info->m_by;
      info->bsz = info->m_bz;
      info->csx = info->m_cx;
      info->csy = info->m_cy;
      info->csz = info->m_cz;
      
      vec_prod(tmp_x, tmp_y, tmp_z,
	       info->bsx/(2*PI), info->bsy/(2*PI), info->bsz/(2*PI),
	       info->csx/(2*PI), info->csy/(2*PI), info->csz/(2*PI));
      info->V0 = 1/fabs(scalar_prod(info->asx/(2*PI), info->asy/(2*PI), info->asz/(2*PI), tmp_x, tmp_y, tmp_z));
      printf("V0=%g\n", info->V0);
      
      /*compute the direct cell parameters, ofr completeness*/ 
      info->m_ax = tmp_x*info->V0;
      info->m_ay = tmp_y*info->V0;
      info->m_az = tmp_z*info->V0;
      vec_prod(tmp_x, tmp_y, tmp_z,info->csx/(2*PI), info->csy/(2*PI), info->csz/(2*PI),info->asx/(2*PI), info->asy/(2*PI), info->asz/(2*PI));
      info->m_bx = tmp_x*info->V0;
      info->m_by = tmp_y*info->V0;
      info->m_bz = tmp_z*info->V0;
      vec_prod(tmp_x, tmp_y, tmp_z,info->asx/(2*PI), info->asy/(2*PI), info->asz/(2*PI),info->bsx/(2*PI), info->bsy/(2*PI), info->bsz/(2*PI));
      info->m_cx = tmp_x*info->V0;
      info->m_cy = tmp_y*info->V0;
      info->m_cz = tmp_z*info->V0;
    }

    if (flag) return(-1);

    if (!info->column_order[0] || !info->column_order[1] || !info->column_order[2]) {
      fprintf(stderr,
              "Single_crystal: Error: Wrong h,k,l column definition\n");
      return(0);
    }
    if (!info->column_order[3] && !info->column_order[4]) {
      fprintf(stderr,
              "Single_crystal: Error: Wrong F,F2 column definition\n");
      return(0);
    }

    /* allocate hkl_data array */
    list = (struct hkl_data_union*)malloc(size*sizeof(struct hkl_data_union));

    for (i=0; i<size; i++)
    {
      double h=0, k=0, l=0, F2=0;
      double b1[3], b2[3];
      double sig1, sig2, sig3;

      /* get data from table */
      h = Table_Index(sTable, i, info->column_order[0]-1);
      k = Table_Index(sTable, i, info->column_order[1]-1);
      l = Table_Index(sTable, i, info->column_order[2]-1);
      if (info->column_order[3])
      { F2= Table_Index(sTable, i, info->column_order[3]-1); F2 *= F2; }
      else if (info->column_order[4])
        F2= Table_Index(sTable, i, info->column_order[4]-1);

      list[i].h = h;
      list[i].k = k;
      list[i].l = l;
      list[i].F2 = F2;
      
      /* Precompute some values */
      list[i].tau_x = h*info->asx + k*info->bsx + l*info->csx;
      list[i].tau_y = h*info->asy + k*info->bsy + l*info->csy;
      list[i].tau_z = h*info->asz + k*info->bsz + l*info->csz;
      list[i].tau = sqrt(list[i].tau_x*list[i].tau_x +
                         list[i].tau_y*list[i].tau_y +
                         list[i].tau_z*list[i].tau_z);
      list[i].u1x = list[i].tau_x/list[i].tau;
      list[i].u1y = list[i].tau_y/list[i].tau;
      list[i].u1z = list[i].tau_z/list[i].tau;
      sig1 = FWHM2RMS*info->m_delta_d_d*list[i].tau;

      /* Find two arbitrary axes perpendicular to tau and each other. */
      normal_vec(b1[0], b1[1], b1[2],
                 list[i].u1x, list[i].u1y, list[i].u1z);
      vec_prod(b2[0], b2[1], b2[2],
               list[i].u1x, list[i].u1y, list[i].u1z,
               b1[0], b1[1], b1[2]);
               
      /* Find the two mosaic axes perpendicular to tau. */
      if(SC_mosaic > 0) {
        /* Use isotropic mosaic. */
        list[i].u2x = b1[0];
        list[i].u2y = b1[1];
        list[i].u2z = b1[2];
        sig2 = FWHM2RMS*list[i].tau*MIN2RAD*SC_mosaic;
        list[i].u3x = b2[0];
        list[i].u3y = b2[1];
        list[i].u3z = b2[2];
        sig3 = FWHM2RMS*list[i].tau*MIN2RAD*SC_mosaic;
      } else if(SC_mosaic_a > 0 && SC_mosaic_b > 0 && SC_mosaic_c > 0) {
        /* Use anisotropic mosaic. */
        fprintf(stderr,"Single_crystal: Warning: you are using an experimental feature:\n"
          "  anistropic mosaicity. Please examine your data carefully.\n");
        /* compute the jacobian of (tau_v,tau_n) from rotations around the unit cell vectors. */
        struct hkl_data_union *l =&(list[i]);
        double xia_x,xia_y,xia_z,xib_x,xib_y,xib_z,xic_x,xic_y,xic_z;
        /*input parameters are in arc minutes*/
        double sig_fi_a=SC_mosaic_a*MIN2RAD;
        double sig_fi_b=SC_mosaic_b*MIN2RAD;
        double sig_fi_c=SC_mosaic_c*MIN2RAD;
        if(info->m_a==0) info->m_a=sqrt(scalar_prod( info->m_ax,info->m_ay,info->m_az,info->m_ax,info->m_ay,info->m_az));
        if(info->m_b==0) info->m_b=sqrt(scalar_prod( info->m_bx,info->m_by,info->m_bz,info->m_bx,info->m_by,info->m_bz));
        if(info->m_c==0) info->m_c=sqrt(scalar_prod( info->m_cx,info->m_cy,info->m_cz,info->m_cx,info->m_cy,info->m_cz));

        l->u2x = b1[0];
        l->u2y = b1[1];
        l->u2z = b1[2];
        l->u3x = b2[0];
        l->u3y = b2[1];
        l->u3z = b2[2];
                                                                          
        xia_x=l->tau_x-(M_2_PI*h/info->m_a)*info->asx;
        xia_y=l->tau_y-(M_2_PI*h/info->m_a)*info->asy;
        xia_z=l->tau_z-(M_2_PI*h/info->m_a)*info->asz;
        xib_x=l->tau_x-(M_2_PI*h/info->m_b)*info->bsx;
        xib_y=l->tau_y-(M_2_PI*h/info->m_b)*info->bsy;
        xib_z=l->tau_z-(M_2_PI*h/info->m_b)*info->bsz;
        xic_x=l->tau_x-(M_2_PI*h/info->m_c)*info->csx;
        xic_y=l->tau_y-(M_2_PI*h/info->m_c)*info->csy;
        xic_z=l->tau_z-(M_2_PI*h/info->m_c)*info->csz;

        double xia=sqrt(xia_x*xia_x + xia_y*xia_y + xia_z*xia_z);
        double xib=sqrt(xib_x*xib_x + xib_y*xib_y + xib_z*xib_z);
        double xic=sqrt(xic_x*xic_x + xic_y*xic_y + xic_z*xic_z);

        vec_prod(tmp_x,tmp_y,tmp_z,l->tau_x,l->tau_y,l->tau_z, l->u2x,l->u2y,l->u2z);
        double J_n_fia= xia/info->m_a/l->tau*scalar_prod(info->asx,info->asy,info->asz,tmp_x,tmp_y,tmp_z);
        vec_prod(tmp_x,tmp_y,tmp_z,l->tau_x,l->tau_y,l->tau_z, l->u2x,l->u2y,l->u2z);
        double J_n_fib= xib/info->m_b/l->tau*scalar_prod(info->bsx,info->bsy,info->bsz,tmp_x,tmp_y,tmp_z);
        vec_prod(tmp_x,tmp_y,tmp_z,l->tau_x,l->tau_y,l->tau_z, l->u2x,l->u2y,l->u2z);
        double J_n_fic= xic/info->m_c/l->tau*scalar_prod(info->csx,info->csy,info->csz,tmp_x,tmp_y,tmp_z);

        vec_prod(tmp_x,tmp_y,tmp_z,l->tau_x,l->tau_y,l->tau_z, l->u3x,l->u3y,l->u3z);
        double J_v_fia= xia/info->m_a/l->tau*scalar_prod(info->asx,info->asy,info->asz,tmp_x,tmp_y,tmp_z);
        vec_prod(tmp_x,tmp_y,tmp_z,l->tau_x,l->tau_y,l->tau_z, l->u3x,l->u3y,l->u3z);
        double J_v_fib= xib/info->m_b/l->tau*scalar_prod(info->bsx,info->bsy,info->bsz,tmp_x,tmp_y,tmp_z);
        vec_prod(tmp_x,tmp_y,tmp_z,l->tau_x,l->tau_y,l->tau_z, l->u3x,l->u3y,l->u3z);
        double J_v_fic= xic/info->m_c/l->tau*scalar_prod(info->csx,info->csy,info->csz,tmp_x,tmp_y,tmp_z);

        /*with the jacobian we can compute the sigmas in terms of the orthogonal vectors u2 and u3*/
        sig2=sig_fi_a*fabs(J_v_fia) + sig_fi_b*fabs(J_v_fib) + sig_fi_c*fabs(J_v_fic);
        sig3=sig_fi_a*fabs(J_n_fia) + sig_fi_b*fabs(J_n_fib) + sig_fi_c*fabs(J_n_fic);
      } else if (SC_mosaic_AB[0]!=0 && SC_mosaic_AB[1]!=0){
        if ( (SC_mosaic_AB[2]==0 && SC_mosaic_AB[3]==0 && SC_mosaic_AB[4]==0) || (SC_mosaic_AB[5]==0 && SC_mosaic_AB[6]==0 && SC_mosaic_AB[7]==0) ){
          fprintf(stderr,"Single_crystal: Error: in-plane mosaics are specified but one (or both)\n"
              "  in-plane reciprocal vector is the zero vector\n");
          return(0);
        }
        fprintf(stderr,"Single_crystal: Warning: you are using an experimental feature: \n"
              "  \"in-plane\" anistropic mosaicity. Please examine your data carefully.\n");
 
        /*for given reflection in list - compute linear comb of tau_a and tau_b*/
        /*check for not in plane - f.i. check if (tau_a X tau_b).tau_i)==0*/
        struct hkl_data_union *l =&(list[i]);
        double det,c1,c2,sig_tau_c;
        double em_x,em_y,em_z, tmp_x,tmp_y,tmp_z;
        double tau_a[3],tau_b[3];
        /*convert Miller indices to taus*/
        if(info->m_a==0) info->m_a=sqrt(scalar_prod( info->m_ax,info->m_ay,info->m_az,info->m_ax,info->m_ay,info->m_az));
        if(info->m_b==0) info->m_b=sqrt(scalar_prod( info->m_bx,info->m_by,info->m_bz,info->m_bx,info->m_by,info->m_bz));
        if(info->m_c==0) info->m_c=sqrt(scalar_prod( info->m_cx,info->m_cy,info->m_cz,info->m_cx,info->m_cy,info->m_cz));
        tau_a[0]=M_2_PI*( (SC_mosaic_AB[2]/info->m_a)*info->asx + (SC_mosaic_AB[3]/info->m_b)*info->bsx + (SC_mosaic_AB[4]/info->m_c)*info->csx );
        tau_a[1]=M_2_PI*( (SC_mosaic_AB[2]/info->m_a)*info->asy + (SC_mosaic_AB[3]/info->m_b)*info->bsy + (SC_mosaic_AB[4]/info->m_c)*info->csy );
        tau_a[2]=M_2_PI*( (SC_mosaic_AB[2]/info->m_a)*info->asz + (SC_mosaic_AB[3]/info->m_b)*info->bsz + (SC_mosaic_AB[4]/info->m_c)*info->csz );
        tau_b[0]=M_2_PI*( (SC_mosaic_AB[5]/info->m_a)*info->asx + (SC_mosaic_AB[6]/info->m_b)*info->bsx + (SC_mosaic_AB[7]/info->m_c)*info->csx );
        tau_b[1]=M_2_PI*( (SC_mosaic_AB[5]/info->m_a)*info->asy + (SC_mosaic_AB[6]/info->m_b)*info->bsy + (SC_mosaic_AB[7]/info->m_c)*info->csy );
        tau_b[2]=M_2_PI*( (SC_mosaic_AB[5]/info->m_a)*info->asz + (SC_mosaic_AB[6]/info->m_b)*info->bsz + (SC_mosaic_AB[7]/info->m_c)*info->csz );
        
        /*check determinants to see how we should compute the linear combination of a and b (to match c)*/
        if ((det=tau_a[0]*tau_b[1]-tau_a[1]*tau_b[0])!=0){
          c1= (l->tau_x*tau_b[1] - l->tau_y*tau_b[0])/det;
          c2= (tau_a[0]*l->tau_y - tau_a[1]*l->tau_x)/det;
        }else if ((det=tau_a[1]*tau_b[2]-tau_a[2]*tau_b[1])!=0){
          c1= (l->tau_y*tau_b[2] - l->tau_z*tau_b[1])/det;
          c2= (tau_a[1]*l->tau_z - tau_a[2]*l->tau_y)/det;
        }else if ((det=tau_a[0]*tau_b[2]-tau_a[2]*tau_b[0])!=0){
          c1= (l->tau_x*tau_b[2] - l->tau_z*tau_b[0])/det;
          c2= (tau_a[0]*l->tau_z - tau_a[2]*l->tau_x)/det;
        }
        if ((c1==0) && (c2==0)){
          fprintf(stderr,"Single_crystal: Warning: reflection tau[%i]=(%g %g %g) "
          "has no component in defined mosaic plane\n", 
          i, l->tau_x,l->tau_y,l->tau_z);
        }
        /*compute linear combination => sig_tau_i = | c1*sig_tau_a + c2*sig_tau_b |  - also add in the minute to radian scaling factor*/;
        sig_tau_c = MIN2RAD*sqrt(c1*SC_mosaic_AB[0]*c1*SC_mosaic_AB[0] + c2*SC_mosaic_AB[1]*c2*SC_mosaic_AB[1]);
        l->u2x = b1[0]; l->u2y = b1[1]; l->u2z = b1[2];
        l->u3x = b2[0]; l->u3y = b2[1]; l->u3z = b2[2];

        /*so now let's compute the rotation around planenormal tau_a X tau_b*/
        /*g_bar (unit normal of rotation plane) = tau_a X tau_b / norm(tau_a X tau_b)*/
        vec_prod(tmp_x,tmp_y,tmp_z, tau_a[0],tau_a[1],tau_a[2],tau_b[0],tau_b[1],tau_b[2]);
        vec_prod(em_x,em_y,em_z, l->tau_x, l->tau_y, l->tau_z, tmp_x,tmp_y,tmp_z);
        NORM(em_x,em_y,em_z);
        sig2 = l->tau*sig_tau_c*fabs(scalar_prod(em_x,em_y,em_z, l->u2x,l->u2y,l->u2z));
        sig3 = l->tau*sig_tau_c*fabs(scalar_prod(em_x,em_y,em_z, l->u3x,l->u3y,l->u3z));
        /*protect against collapsing gaussians. These seem to be sensible values.*/
        if (sig2<1e-5) sig2=1e-5;
        if (sig3<1e-5) sig3=1e-5;
      }
      else {
        fprintf(stderr,
                "Single_crystal: Error: EITHER mosaic OR (mosaic_a, mosaic_b, mosaic_c)\n"
                "  must be given and be >0.\n");
        return(0);
      }
      list[i].sig123 = sig1*sig2*sig3;
      list[i].m1 = 1/(2*sig1*sig1);
      list[i].m2 = 1/(2*sig2*sig2);
      list[i].m3 = 1/(2*sig3*sig3);
      /* Set Gauss cutoff to 5 times the maximal sigma. */
      if(sig1 > sig2)
        if(sig1 > sig3)
          list[i].cutoff = 5*sig1;
        else
          list[i].cutoff = 5*sig3;
      else
        if(sig2 > sig3)
          list[i].cutoff = 5*sig2;
        else
          list[i].cutoff = 5*sig3;
    }
    Table_Free(&sTable);
    
    /* sort the list with increasing tau */
    qsort(list, i, sizeof(struct hkl_data_union),  SX_list_compare_union);
    
    info->list = list;
    info->count = i;
    info->tau_list = malloc(i*sizeof(*info->tau_list));
    if(!info->tau_list)
    {
      fprintf(stderr, "Single_crystal: Error: Out of memory!\n");
      return(0);
    }
    return(info->count);
  } /* read_hkl_data */

  /* ------------------------------------------------------------------------ */
  /* hkl_search
    search the HKL reflections which are on the Ewald sphere
    input:
      L,T,count,V0: constants for all calls
      kix,kiy,kiz: may be different for each call
    this function returns:
      tau_count (return), coh_refl, coh_xsect, T (updated elements in the array up to [j])
   */
  int hkl_search_union(struct hkl_data_union *L, struct tau_data_union *T, int count, double V0,
    double kix, double kiy, double kiz, double tau_max,
    double *coh_refl, double *coh_xsect)
  {
    double rho, rho_x, rho_y, rho_z;
    double diff;
    int    i,j;
    double ox,oy,oz;
    double b1x,b1y,b1z, b2x,b2y,b2z, kx, ky, kz, nx, ny, nz;
    double n11, n22, n12, det_N, inv_n11, inv_n22, inv_n12, l11, l22, l12,  det_L;
    double Bt_D_O_x, Bt_D_O_y, y0x, y0y, alpha;
    
    double ki = sqrt(kix*kix+kiy*kiy+kiz*kiz);

    /* Common factor in coherent cross-section */
    double xsect_factor = pow(2*PI, 5.0/2.0)/(V0*ki*ki);
    
    for(i = j = 0; i < count; i++)
      {
    /* Assuming reflections are sorted, stop search when max tau exceeded. */
        if(L[i].tau > tau_max)
          break;
        /* Check if this reciprocal lattice point is close enough to the
           Ewald sphere to make scattering possible. */
        rho_x = kix - L[i].tau_x;
        rho_y = kiy - L[i].tau_y;
        rho_z = kiz - L[i].tau_z;
        rho = sqrt(rho_x*rho_x + rho_y*rho_y + rho_z*rho_z);
        diff = fabs(rho - ki);

        /* Check if scattering is possible (cutoff of Gaussian tails). */
        if(diff <= L[i].cutoff)
        {
          /* Store reflection. */
          T[j].index = i;
          /* Get ki vector in local coordinates. */
          kx = kix*L[i].u1x + kiy*L[i].u1y + kiz*L[i].u1z;
          ky = kix*L[i].u2x + kiy*L[i].u2y + kiz*L[i].u2z;
          kz = kix*L[i].u3x + kiy*L[i].u3y + kiz*L[i].u3z;
          T[j].rho_x = kx - L[i].tau;
          T[j].rho_y = ky;
          T[j].rho_z = kz;
          T[j].rho = rho;
          /* Compute the tangent plane of the Ewald sphere. */
          nx = T[j].rho_x/T[j].rho;
          ny = T[j].rho_y/T[j].rho;
          nz = T[j].rho_z/T[j].rho;
          ox = (ki - T[j].rho)*nx;
          oy = (ki - T[j].rho)*ny;
          oz = (ki - T[j].rho)*nz;
          T[j].ox = ox;
          T[j].oy = oy;
          T[j].oz = oz;
          /* Compute unit vectors b1 and b2 that span the tangent plane. */
          normal_vec(b1x, b1y, b1z, nx, ny, nz);
          vec_prod(b2x, b2y, b2z, nx, ny, nz, b1x, b1y, b1z);
          T[j].b1x = b1x;
          T[j].b1y = b1y;
          T[j].b1z = b1z;
          T[j].b2x = b2x;
          T[j].b2y = b2y;
          T[j].b2z = b2z;
          /* Compute the 2D projection of the 3D Gauss of the reflection. */
          /* The symmetric 2x2 matrix N describing the 2D gauss. */
          n11 = L[i].m1*b1x*b1x + L[i].m2*b1y*b1y + L[i].m3*b1z*b1z;
          n12 = L[i].m1*b1x*b2x + L[i].m2*b1y*b2y + L[i].m3*b1z*b2z;
          n22 = L[i].m1*b2x*b2x + L[i].m2*b2y*b2y + L[i].m3*b2z*b2z;
          /* The (symmetric) inverse matrix of N. */
          det_N = n11*n22 - n12*n12;
          inv_n11 = n22/det_N;
          inv_n12 = -n12/det_N;
          inv_n22 = n11/det_N;
          /* The Cholesky decomposition of 1/2*inv_n (lower triangular L). */
          l11 = sqrt(inv_n11/2);
          l12 = inv_n12/(2*l11);
          l22 = sqrt(inv_n22/2 - l12*l12);
          T[j].l11 = l11;
          T[j].l12 = l12;
          T[j].l22 = l22;
          det_L = l11*l22;
          /* The product B^T D o. */
          Bt_D_O_x = b1x*L[i].m1*ox + b1y*L[i].m2*oy + b1z*L[i].m3*oz;
          Bt_D_O_y = b2x*L[i].m1*ox + b2y*L[i].m2*oy + b2z*L[i].m3*oz;
          /* Center of 2D Gauss in plane coordinates. */
          y0x = -(Bt_D_O_x*inv_n11 + Bt_D_O_y*inv_n12);
          y0y = -(Bt_D_O_x*inv_n12 + Bt_D_O_y*inv_n22);
          T[j].y0x = y0x;
          T[j].y0y = y0y;
          /* Factor alpha for the distance of the 2D Gauss from the origin. */
          alpha = L[i].m1*ox*ox + L[i].m2*oy*oy + L[i].m3*oz*oz -
                       (y0x*y0x*n11 + y0y*y0y*n22 + 2*y0x*y0y*n12);
          T[j].refl = xsect_factor*det_L*exp(-alpha)/L[i].sig123; /* intensity of that Bragg */
          *coh_refl += T[j].refl;                                  /* total scatterable intensity */
          T[j].xsect = T[j].refl*L[i].F2;
          *coh_xsect += T[j].xsect;
          j++;
        }
        
      } /* end for */
        return (j); // this is 'tau_count', i.e. number of reachable reflections
    } /* end hkl_search */
    
    int hkl_select_union(struct tau_data_union *T, int tau_count, double coh_refl, double *sum) {
      int j;
      double r = rand0max(coh_refl);
      *sum = 0;
      for(j = 0; j < tau_count; j++)
      {
        *sum += T[j].refl;
        if(*sum > r) break;
      }
      return j;
    }

    /* Functions for "reorientation", powder and PG modes */
    /* Powder, forward */
    void randrotate_union(double *nx, double *ny, double *nz, double a, double b) {
      double nvx, nvy, nvz;
      rotate(nvx,nvy,nvz, *nx, *ny, *nz, a, 1, 0, 0);
      rotate(*nx,*ny,*nz, nvx,nvy,nvz, b, 0, 1, 0);
    }
    /* Powder, back */
    void randderotate_union(double *nx, double *ny, double *nz, double a, double b) {
      double nvx, nvy, nvz;
      rotate(nvx,nvy,nvz,*nx,*ny,*nz, -b, 0, 1, 0);
      rotate(*nx, *ny, *nz, nvx,nvy,nvz, -a, 1, 0, 0);
    }
    /* PG, forward */
    void PGrotate_union(double *nx, double *ny, double *nz, double a, double csx, double csy, double csz) {
      /* Currently assumes c-axis along 'x', ought to be generalized... */
      double nvx, nvy, nvz;
      rotate(nvx,nvy,nvz, *nx, *ny, *nz, a, csx, csy, csz);
      *nx = nvx; *ny = nvy; *nz = nvz;
    }
    /* PG, back */
    void PGderotate_union(double *nx, double *ny, double *nz, double a, double csx, double csy, double csz) {
      /* Currently assumes c-axis along 'x', ought to be generalized... */
      double nvx, nvy, nvz;
      rotate(nvx,nvy,nvz, *nx, *ny, *nz, -a, csx, csy, csz);
      *nx = nvx; *ny = nvy; *nz = nvz;
    }


#endif /* !SINGLE_CRYSTAL_PROCESS_DECL */

// Very important to add a pointer to this struct in the Union_functions.c file
struct Single_crystal_physics_storage_struct{
    // Variables that needs to be transfered between any of the following places:
    // The initialize in this component
    // The function for calculating my
    // The function for calculating scattering
    
    // Avoid duplicates of output parameters and setting parameters in naming
    double PG_setting;     // 0 if PG mode is diabled, 1 if enabled. Values between apporximates texture?
    double powder_setting; // 0 if powder mode is disabled, 1 if enabled. Values between approximates texture?
    double Alpha;          // random angle between 0 and 2*Pi*powder
    double Beta;           // random angle between -Pi/2 and Pi/2
    
    struct hkl_info_struct_union *hkl_info_storage; // struct containing all necessary info for SC
    double pack; // packing factor
    double barns_setting; // Sets wether barns of fm^2 is used
};

// Function for calculating my, the inverse penetration depth (for only this scattering process).
// The input for this function and its order may not be changed, but the names may be updated.
int Single_crystal_physics_my(double *my, double *k_initial, union data_transfer_union data_transfer, struct focus_data_struct *focus_data) {
    // *k_initial is a pointer to a simple vector with 3 doubles, k[0], k[1], k[2] which describes the wavevector
    double kix = k_initial[0],kiy = k_initial[1],kiz = k_initial[2];
    double ki = sqrt(k_initial[0]*k_initial[0]+k_initial[1]*k_initial[1]+k_initial[2]*k_initial[2]);
    
    struct hkl_info_struct_union *hkl_info = data_transfer.pointer_to_a_Single_crystal_physics_storage_struct->hkl_info_storage;
    
    // Need the Powder/PG/curvature mode rotate added here
    
    // Taken from Single_crystal and changed hkl_info to a pointer.
    // The split optimization is less useful here than normally
    
    if (data_transfer.pointer_to_a_Single_crystal_physics_storage_struct->powder_setting) {
      //orientation of crystallite is random
	  data_transfer.pointer_to_a_Single_crystal_physics_storage_struct->Alpha = randpm1()*PI*data_transfer.pointer_to_a_Single_crystal_physics_storage_struct->powder_setting;
	  data_transfer.pointer_to_a_Single_crystal_physics_storage_struct->Beta = randpm1()*PI/2;
      
	  randrotate_union(&kix, &kiy, &kiz,
        data_transfer.pointer_to_a_Single_crystal_physics_storage_struct->Alpha,
        data_transfer.pointer_to_a_Single_crystal_physics_storage_struct->Beta);
    }
    if (data_transfer.pointer_to_a_Single_crystal_physics_storage_struct->PG_setting) {
      // orientation of crystallite is random
      data_transfer.pointer_to_a_Single_crystal_physics_storage_struct->Alpha = rand01()*2*PI*data_transfer.pointer_to_a_Single_crystal_physics_storage_struct->PG_setting;
	  PGrotate_union(&kix, &kiy, &kiz,
        data_transfer.pointer_to_a_Single_crystal_physics_storage_struct->Alpha,
        hkl_info->csx, hkl_info->csy, hkl_info->csz);
    }
    
    /* in case we use 'SPLIT' then consecutive neutrons can be identical when entering here
         and we may skip the hkl_search call */
    if ( fabs(kix - hkl_info->kix) < 1e-6
        && fabs(kiy - hkl_info->kiy) < 1e-6
        && fabs(kiz - hkl_info->kiz) < 1e-6) {
        hkl_info->nb_reuses++;
      } else {
        /* Max possible tau for this ki with 5*sigma delta-d/d cutoff. */
        double tau_max   = 2*ki/(1 - 5*hkl_info->m_delta_d_d);
        double coh_xsect = 0, coh_refl = 0;
        
        /* call hkl_search */
        hkl_info->tau_count = hkl_search_union(hkl_info->list, hkl_info->tau_list, hkl_info->count, hkl_info->V0, kix, kiy, kiz, tau_max, &coh_refl, &coh_xsect); /* CPU consuming */
          
        // This is problematic as there is no way to know if this is the first scattering in this material or not with the current structure.
        // Need to do one of the following:
        //  remove this optimization
        //  find a way to set event_counter to 0 when a neutron enters a volume with a SC process
        //  pass the number of scatterings in this volume to all my functions
        // temporary solution: all events are considered the first
        int event_counter = 0;
        
        
        /* store ki so that we can check for further SPLIT iterations */
        if (event_counter == 0 ) { /* only for incoming neutron */
          hkl_info->kix = kix;
          hkl_info->kiy = kiy;
          hkl_info->kiz = kiz;
        }
        
        hkl_info->coh_refl  = coh_refl;
        hkl_info->coh_xsect = coh_xsect;
        hkl_info->nb_refl += hkl_info->tau_count;
        hkl_info->nb_refl_count++;
        
        
      }

      /* (3). Probabilities of the different possible interactions. */
      //tot_xsect = abs_xsect + inc_xsect + hkl_info.coh_xsect;
      /* Cross-sections are in barns = 10**-28 m**2, and unit cell volumes are
         in AA**3 = 10**-30 m**2. Hence a factor of 100 is used to convert
         scattering lengths to m**-1 */
      double coh_xlen = hkl_info->coh_xsect/hkl_info->V0;
      if (data_transfer.pointer_to_a_Single_crystal_physics_storage_struct->barns_setting) {
        coh_xlen *= 100;
      }
    
      //printf("Single crystal process returned coh_xlen = %E \n",coh_xlen);
      *my = coh_xlen*data_transfer.pointer_to_a_Single_crystal_physics_storage_struct->pack;
      int iterate;
      //if (hkl_info->tau_count == 0) printf("my: ki=%f, no reflections matched \n",ki);
      for (iterate=0;iterate<hkl_info->tau_count;iterate++)
        //printf("my: ki=%f, hkl_info->coh_xsect = %f, T[%d].refl = %f, coh_xlen = %f \n",ki,hkl_info->coh_xsect,iterate,hkl_info->tau_list[iterate].refl,coh_xlen);
      // Probably need to rotate back from Powder/PG/curvature mode, as another process than this one could be selected. Would just need to send the used rotation parameters to the process to repeat that rotation.
    
    return 1;
};

// Function that provides description of a basic scattering event.
// Do not change the
int Single_crystal_physics_scattering(double *k_final, double *k_initial, double *weight, union data_transfer_union data_transfer, struct focus_data_struct *focus_data) {

    int i;                        /* Index into structure factor list */
    struct hkl_data_union *L;     /* Structure factor list */
    int j;                        /* Index into reflection list */
    struct tau_data_union *T;     /* List of reflections close to Ewald sphere */
    //double ox, oy, oz;            /* Origin of Ewald sphere tangent plane */
    //double l11, l12, l22;         /* Cholesky decomposition L of 1/2*inv(N) */
    double b1x, b1y, b1z;         /* First vector spanning tangent plane */
    double b2x, b2y, b2z;         /* Second vector spanning tangent plane */
    double z1, z2, y1, y2;        /* Temporaries to choose kf from 2D Gauss */
    double adjust, r, sum;        /* Temporaries */
    double kfx, kfy, kfz;         /* Final wave vector */

    double kix = k_initial[0],kiy = k_initial[1],kiz = k_initial[2];
    double ki = sqrt(k_initial[0]*k_initial[0]+k_initial[1]*k_initial[1]+k_initial[2]*k_initial[2]);
    
    struct hkl_info_struct_union *hkl_info = data_transfer.pointer_to_a_Single_crystal_physics_storage_struct->hkl_info_storage;
    
    L = hkl_info->list;
    T = hkl_info->tau_list;
    
    
    // Taken from Single_crystal.comp
    if(hkl_info->coh_refl <= 0){
          return 0; // Return 0 will use ABSORB in main component (as it is not allowed in a function)
    }
    sum = 0;
    j = hkl_select_union(T, hkl_info->tau_count, hkl_info->coh_refl, &sum);
    //printf("Selected j = %d with T[%d].refl = %f \n",j,j,T[j].refl);

    if(j >= hkl_info->tau_count)
    {
      if (hkl_info->flag_warning < 100)
        fprintf(stderr, "Single_crystal_process: Error: Illegal tau search "
          "(r=%g, sum=%g, j=%i, tau_count=%i).\n", r, sum, j , hkl_info->tau_count);
      hkl_info->flag_warning++;
      j = hkl_info->tau_count - 1;
    }
    i = T[j].index;
    /* (8). Pick scattered wavevector kf from 2D Gauss distribution. */
    z1 = randnorm();
    z2 = randnorm();
    y1 = T[j].l11*z1 + T[j].y0x;
    y2 = T[j].l12*z1 + T[j].l22*z2 + T[j].y0y;
    kfx = T[j].rho_x + T[j].ox + T[j].b1x*y1 + T[j].b2x*y2;
    kfy = T[j].rho_y + T[j].oy + T[j].b1y*y1 + T[j].b2y*y2;
    kfz = T[j].rho_z + T[j].oz + T[j].b1z*y1 + T[j].b2z*y2;
    /* Normalize kf to length of ki, to account for planer
      approximation of the Ewald sphere. */
    adjust = ki/sqrt(kfx*kfx + kfy*kfy + kfz*kfz);
    kfx *= adjust;
    kfy *= adjust;
    kfz *= adjust;
    /* Adjust neutron weight (see manual for explanation). */
    *weight *= T[j].xsect*hkl_info->coh_refl/(hkl_info->coh_xsect*T[j].refl);
    //printf("SCATTERING: hkl_info->coh_refl=%f, hkl_info->coh_xsect = %f, T[%d].refl = %f, hkl_info->tau.count = %d \n",hkl_info->coh_refl,hkl_info->coh_xsect,j,T[j].refl,hkl_info->tau_count);

    // These is the returned final wavevector
    k_final[0] = L[i].u1x*kfx + L[i].u2x*kfy + L[i].u3x*kfz;
    k_final[1] = L[i].u1y*kfx + L[i].u2y*kfy + L[i].u3y*kfz;
    k_final[2] = L[i].u1z*kfx + L[i].u2z*kfy + L[i].u3z*kfz;
    
    if (data_transfer.pointer_to_a_Single_crystal_physics_storage_struct->powder_setting) {
      // orientation of crystallite is no longer random
	  randderotate_union(&k_final[0], &k_final[1], &k_final[2], data_transfer.pointer_to_a_Single_crystal_physics_storage_struct->Alpha, data_transfer.pointer_to_a_Single_crystal_physics_storage_struct->Beta);
    }
    if (data_transfer.pointer_to_a_Single_crystal_physics_storage_struct->PG_setting) {
      // orientation of crystallite is longer random
	  PGderotate_union(&k_final[0], &k_final[1], &k_final[2], data_transfer.pointer_to_a_Single_crystal_physics_storage_struct->Alpha, hkl_info->csx, hkl_info->csy, hkl_info->csz);
    }

    hkl_info->type = 'c';
    hkl_info->h    = L[i].h;
    hkl_info->k    = L[i].k;
    hkl_info->l    = L[i].l;

    return 1;
};

#line 9370 "MACS_sample_kidney_box.c"

/* Shared user declarations for all components 'Virtual_input'. */
#line 74 "/usr/share/mcstas/2.7/obsolete/Virtual_input.comp"


long Virtual_input_Read_Input(char *aFile, char *aType, t_Table *aTable, long *aOffset)
  {
    long max_lines = 50000;
    long length=0;
    char bType[32];

    if (!aFile) return (0);
    if (aType) strcpy(bType, aType);
    else strcpy(bType, "???");

    Table_Free(aTable);

    /* Try to Open neutron input text filename. */
    if((aFile && aType == NULL) || !strcmp(bType,"text")) {
      Table_Read_Offset(aTable, aFile, 0, aOffset, max_lines);  /* read data from filename into rTable */
      strcpy(bType, "text");
    }
    if (!aTable->data && aType && aType[0] != 't')
      Table_Read_Offset_Binary(aTable, aFile, aType, aOffset, max_lines, 11);

    return(aTable->rows);
  }
#line 9398 "MACS_sample_kidney_box.c"

/* Shared user declarations for all components 'Union_box'. */
#line 78 "Union_box.comp"
#ifndef Union
#define Union $Revision: 0.8 $

#include "Union_functions.c"
#include "Union_initialization.c"

#endif


void mcdisplay_box_function(struct lines_to_draw *lines_to_draw_output,int index, struct geometry_struct **Geometries,int number_of_volumes) {
    // Function to call in mcdisplay section of the sample component for this volume
    // One can assume that Volumes[index] refers to a volume with the geometry described in this file
    
    double depth = Geometries[index]->geometry_parameters.p_box_storage->z_depth;
    double width1 = Geometries[index]->geometry_parameters.p_box_storage->x_width1;
    double width2 = Geometries[index]->geometry_parameters.p_box_storage->x_width2;
    double height1 = Geometries[index]->geometry_parameters.p_box_storage->y_height1;
    double height2 = Geometries[index]->geometry_parameters.p_box_storage->y_height2;
    
    Coords x_vector = Geometries[index]->geometry_parameters.p_box_storage->x_vector;
    Coords y_vector = Geometries[index]->geometry_parameters.p_box_storage->y_vector;
    Coords z_vector = Geometries[index]->geometry_parameters.p_box_storage->z_vector;
    
    Coords center = Geometries[index]->center;
    
    Coords square1[4],square2[4];
    
    square1[0] = coords_add(coords_add(coords_add(center,coords_scalar_mult(z_vector,-0.5*depth)),coords_scalar_mult(x_vector,-0.5*width1)),coords_scalar_mult(y_vector,-0.5*height1));
    
    square1[1] = coords_add(square1[0],coords_scalar_mult(x_vector,width1));
    square1[2] = coords_add(square1[1],coords_scalar_mult(y_vector,height1));
    square1[3] = coords_add(square1[0],coords_scalar_mult(y_vector,height1));
    
    square2[0] = coords_add(coords_add(coords_add(center,coords_scalar_mult(z_vector,0.5*depth)),coords_scalar_mult(x_vector,-0.5*width2)),coords_scalar_mult(y_vector,-0.5*height2));
    
    square2[1] = coords_add(square2[0],coords_scalar_mult(x_vector,width2));
    square2[2] = coords_add(square2[1],coords_scalar_mult(y_vector,height2));
    square2[3] = coords_add(square2[0],coords_scalar_mult(y_vector,height2));
    
    struct lines_to_draw lines_to_draw_temp;
    lines_to_draw_temp.number_of_lines = 0;
    
    int iterate;
    for (iterate=0;iterate<3;iterate++) {
        lines_to_draw_temp = draw_line_with_highest_priority(square1[iterate],square1[iterate+1],index,Geometries,number_of_volumes,2);
        merge_lines_to_draw(lines_to_draw_output,&lines_to_draw_temp);
    }
    lines_to_draw_temp = draw_line_with_highest_priority(square1[3],square1[0],index,Geometries,number_of_volumes,2);
    merge_lines_to_draw(lines_to_draw_output,&lines_to_draw_temp);

    for (iterate=0;iterate<3;iterate++) {
        lines_to_draw_temp = draw_line_with_highest_priority(square2[iterate],square2[iterate+1],index,Geometries,number_of_volumes,2);
        merge_lines_to_draw(lines_to_draw_output,&lines_to_draw_temp);
    }
    lines_to_draw_temp = draw_line_with_highest_priority(square2[3],square2[0],index,Geometries,number_of_volumes,2);
    merge_lines_to_draw(lines_to_draw_output,&lines_to_draw_temp);

    for (iterate=0;iterate<4;iterate++) {
        lines_to_draw_temp = draw_line_with_highest_priority(square1[iterate],square2[iterate],index,Geometries,number_of_volumes,2);
        merge_lines_to_draw(lines_to_draw_output,&lines_to_draw_temp);
    }
};

void initialize_box_geometry_from_main_component(struct geometry_struct *box) {
    // Function to be called in initialize of the main component
    // This is done as the rotation matrix needs to be relative to the main component instead of global
    // Everything done in initialize in this component file has the rotation matrix relative to global
    Coords simple_vector = coords_set(1,0,0);
    Coords rotated_vector;
    
    rotated_vector = rot_apply(box->rotation_matrix,simple_vector);
    NORM(rotated_vector.x,rotated_vector.y,rotated_vector.z);
    box->geometry_parameters.p_box_storage->x_vector = rotated_vector;
    
    simple_vector = coords_set(0,1,0);
    rotated_vector = rot_apply(box->rotation_matrix,simple_vector);
    NORM(rotated_vector.x,rotated_vector.y,rotated_vector.z);
    box->geometry_parameters.p_box_storage->y_vector = rotated_vector;
    
    simple_vector = coords_set(0,0,1);
    rotated_vector = rot_apply(box->rotation_matrix,simple_vector);
    NORM(rotated_vector.x,rotated_vector.y,rotated_vector.z);
    box->geometry_parameters.p_box_storage->z_vector = rotated_vector;
};

struct pointer_to_1d_coords_list box_shell_points(struct geometry_struct *geometry,int max_number_of_points) {
  // This function returns an array of corner positions for the box in the main coordinate system.
  // Normally one would limit it to a maximum number of points, but as there are only 8 for the box,
  //  it is hardcoded to 8. Other geometries can be approximated with a variable number of points.
  
  struct pointer_to_1d_coords_list corner_points;
  corner_points.elements = malloc(8*sizeof(Coords));
  corner_points.num_elements = 8;
  
  double depth = geometry->geometry_parameters.p_box_storage->z_depth;
  double width1 = geometry->geometry_parameters.p_box_storage->x_width1;
  double width2 = geometry->geometry_parameters.p_box_storage->x_width2;
  double height1 = geometry->geometry_parameters.p_box_storage->y_height1;
  double height2 = geometry->geometry_parameters.p_box_storage->y_height2;
    
  Coords x_vector = geometry->geometry_parameters.p_box_storage->x_vector;
  Coords y_vector = geometry->geometry_parameters.p_box_storage->y_vector;
  Coords z_vector = geometry->geometry_parameters.p_box_storage->z_vector;
    
  Coords center = geometry->center;
    
  corner_points.elements[0] = coords_add(coords_add(coords_add(center,coords_scalar_mult(z_vector,-0.5*depth)),coords_scalar_mult(x_vector,-0.5*width1)),coords_scalar_mult(y_vector,-0.5*height1));
    
  corner_points.elements[1] = coords_add(corner_points.elements[0],coords_scalar_mult(x_vector,width1));
  corner_points.elements[2] = coords_add(corner_points.elements[1],coords_scalar_mult(y_vector,height1));
  corner_points.elements[3] = coords_add(corner_points.elements[0],coords_scalar_mult(y_vector,height1));
    
  corner_points.elements[4] = coords_add(coords_add(coords_add(center,coords_scalar_mult(z_vector,0.5*depth)),coords_scalar_mult(x_vector,-0.5*width2)),coords_scalar_mult(y_vector,-0.5*height2));
    
  corner_points.elements[5] = coords_add(corner_points.elements[4],coords_scalar_mult(x_vector,width2));
  corner_points.elements[6] = coords_add(corner_points.elements[5],coords_scalar_mult(y_vector,height2));
  corner_points.elements[7] = coords_add(corner_points.elements[4],coords_scalar_mult(y_vector,height2));
  
  return corner_points;

}

#line 9524 "MACS_sample_kidney_box.c"

/* Shared user declarations for all components 'Union_cylinder'. */
#line 74 "Union_cylinder.comp"
#ifndef Union
#define Union $Revision: 0.8 $

#include "Union_functions.c"
#include "Union_initialization.c"

#endif


void mcdisplay_cylinder_function(struct lines_to_draw *lines_to_draw_output,int index, struct geometry_struct **Geometries,int number_of_volumes) {
    // Function to call in mcdisplay section of the sample component for this volume
    // One can assume that Geometries[index] refers to a geometry as described in this file
    // The 4 lines describin the cylinders side are aligned to the local frame of the cylinder,
    //   it would be nicer to have them alligned with the global frame so that they show up nicely in
    //   pgplotters on mcdisplay.
    // One could get the current global rotation and use this to counteract this effect.
    
    double height = Geometries[index]->geometry_parameters.p_cylinder_storage->height;
    double radius = Geometries[index]->geometry_parameters.p_cylinder_storage->cyl_radius;
    Coords direction = Geometries[index]->geometry_parameters.p_cylinder_storage->direction_vector;
    Coords center = Geometries[index]->center;
    
    Coords bottom_point = coords_add(center,coords_scalar_mult(direction,0.5*height));
    Coords top_point = coords_add(center,coords_scalar_mult(direction,-0.5*height));
    
    struct lines_to_draw lines_to_draw_temp;
    lines_to_draw_temp.number_of_lines = 0;
    
    lines_to_draw_temp = draw_circle_with_highest_priority(top_point,direction,radius,index,Geometries,number_of_volumes,2);
    merge_lines_to_draw(lines_to_draw_output,&lines_to_draw_temp);

    lines_to_draw_temp = draw_circle_with_highest_priority(bottom_point,direction,radius,index,Geometries,number_of_volumes,2);
    merge_lines_to_draw(lines_to_draw_output,&lines_to_draw_temp);
    
    Coords point1,point2;
    int iterate,number_of_points=4;
    
    for (iterate=0;iterate<number_of_points;iterate++) {
        point1 = point_on_circle(top_point,direction,radius,iterate,number_of_points);
        point2 = point_on_circle(bottom_point,direction,radius,iterate,number_of_points);
        lines_to_draw_temp = draw_line_with_highest_priority(point1,point2,index,Geometries,number_of_volumes,2);
        merge_lines_to_draw(lines_to_draw_output,&lines_to_draw_temp);
    }
};

void initialize_cylinder_geometry_from_main_component(struct geometry_struct *cylinder) {
    // Function to be called in initialize of the main component
    // This is done as the rotation matrix needs to be relative to the main component instead of global
    // Everything done in initialize in this component file has the rotation matrix relative to global
    
    Coords simple_vector;
    Coords cyl_vector;
    
    // Start with vector that points along the cylinder in the local frame
    simple_vector = coords_set(0,1,0);

    // Rotate the direction vector of the cylinder to the master component frame of reference
    cyl_vector = rot_apply(cylinder->rotation_matrix,simple_vector);
    NORM(cyl_vector.x,cyl_vector.y,cyl_vector.z);
    cylinder->geometry_parameters.p_cylinder_storage->direction_vector.x = cyl_vector.x;
    cylinder->geometry_parameters.p_cylinder_storage->direction_vector.y = cyl_vector.y;
    cylinder->geometry_parameters.p_cylinder_storage->direction_vector.z = cyl_vector.z;
    // if (verbal == 1) printf("Cords vector1 = (%f,%f,%f)\n",cyl_vector.x,cyl_vector.y,
}

struct pointer_to_1d_coords_list cylinder_shell_points(struct geometry_struct *geometry,int max_number_of_points) {
  // Function that returns a number (less than max) of points on the geometry surface
  // If used, remember to free the space allocated.
  int points_per_circle = floor(max_number_of_points/2.0);
  
  struct pointer_to_1d_coords_list cylinder_shell_array;
  cylinder_shell_array.elements = malloc(2*points_per_circle*sizeof(Coords));
  cylinder_shell_array.num_elements = 2*points_per_circle;
  
  Coords cyl_direction = geometry->geometry_parameters.p_cylinder_storage->direction_vector;
  Coords center = geometry->center;
  double radius = geometry->geometry_parameters.p_cylinder_storage->cyl_radius;
  double height = geometry->geometry_parameters.p_cylinder_storage->height;
  
  Coords cyl_top_point = coords_add(center,coords_scalar_mult(cyl_direction,0.5*height));
  Coords cyl_bottom_point = coords_add(center,coords_scalar_mult(cyl_direction,-0.5*height));
  
  points_on_circle(cylinder_shell_array.elements,cyl_top_point,cyl_direction,radius,points_per_circle);
  // Need to verify this pointer arithimatic works as intended
  points_on_circle(cylinder_shell_array.elements+points_per_circle,cyl_bottom_point,cyl_direction,radius,points_per_circle);
  
  return cylinder_shell_array;
}

#line 9617 "MACS_sample_kidney_box.c"

/* Shared user declarations for all components 'Union_master'. */
#line 54 "Union_master.comp"
#ifndef Union
#define Union $Revision: 0.9 $

#include "Union_functions.c"
#include "Union_initialization.c"

#endif
// TEST
struct logger_with_data_struct loggers_with_data_array;
#line 9630 "MACS_sample_kidney_box.c"

/* Shared user declarations for all components 'Res_sample'. */
#line 71 "/usr/share/mcstas/2.7/samples/Res_sample.comp"
struct Res_sample_struct
{
double ki_x,ki_y,ki_z,kf_x,kf_y,kf_z;
double rx,ry,rz,pi;
char   isrect;      /* true when sample is a box */
double aw,ah;       /* rectangular angular dimensions */
double xw,yh;       /* rectangular metrical dimensions */
double tx,ty,tz;    /* target coords */
};
#line 9643 "MACS_sample_kidney_box.c"

/* Shared user declarations for all components 'PSD_monitor'. */
#line 57 "/usr/share/mcstas/2.7/monitors/PSD_monitor.comp"

#ifndef ARRAYS_H
#define ARRAYS_H
typedef double* DArray1d;
DArray1d create_darr1d(int n);
void destroy_darr1d(DArray1d a);

typedef double** DArray2d;
DArray2d create_darr2d(int nx, int ny);
void destroy_darr2d(DArray2d a);

typedef double*** DArray3d;
DArray3d create_darr3d(int nx, int ny, int nz);
void destroy_darr3d(DArray3d a);
#endif
#ifndef ARRAYS_C
#define ARRAYS_C
#include <stdlib.h>

DArray1d create_darr1d(int n){
  DArray1d arr2d;
  arr2d = calloc(n, sizeof(double));
  return arr2d;
}
void destroy_darr1d(DArray1d a){
  free(a);
}

DArray2d create_darr2d(int nx, int ny){
  DArray2d arr2d;
  arr2d = calloc(nx, sizeof(double *));

  double *p1;
  p1 = calloc(nx*ny, sizeof(double));

  int i;
  for (i=0; i<nx; i++){
    arr2d[i] = &(p1[i*ny]);
  }
  return arr2d;
}
void destroy_darr2d(DArray2d a){
  free(a[0]);
  free(a);
}

DArray3d create_darr3d(int nx, int ny, int nz){
  DArray3d arr3d;
  int i, j;

  // 1d
  arr3d = calloc(nx, sizeof(double **));

  // d2
  double **p1;
  p1 = calloc(nx*ny, sizeof(double *));

  for (i=0; i<nx; i++){
    arr3d[i] = &(p1[i*ny]);
  }

  // 3d
  double *p2;
  p2 = calloc(nx*ny*nz, sizeof(double));
  for (i=0; i<nx; i++){
    for (j=0; j<ny; j++){
      arr3d[i][j] = &(p2[(i*ny+j)*nz]);
    }
  }
  return arr3d;
}
void destroy_darr3d(DArray3d a){
  free(a[0][0]);
  free(a[0]);
  free(a);
}
#endif

#line 9725 "MACS_sample_kidney_box.c"

/* Instrument parameters. */
MCNUM mcipA3_angle;
MCNUM mcipkidney_angle;
MCNUM mcipEM;
MCNUM mcipEF_all;
int mcipHF;
int mcipVF;
MCNUM mcipsample_diameter_d;
MCNUM mcipbeta_1;
MCNUM mcipbeta_2;
MCNUM mcipCPF;
MCNUM mcipMPL;
MCNUM mcipMPD;
MCNUM mcipAPE_h;
MCNUM mcipAPE_v;
MCNUM mcipmisalign_mono_deg;
MCNUM mcipDIRDEV;
MCNUM mcipDIVSOU;
MCNUM mcipL0_delta;
MCNUM mcipL1_delta;
MCNUM mcipmon_t;
MCNUM mcipmon_e;
MCNUM mcipmonrot_delta;
MCNUM mcipslit_h;
MCNUM mcipslit_v;
MCNUM mcipresolution_mode;
MCNUM mcipres_radius;
MCNUM mcipres_height;
int mciprepeat_count;
MCNUM mcipE0_resolution;
MCNUM mcipdE_resolution;

#define mcNUMIPAR 30
int mcnumipar = 30;
struct mcinputtable_struct mcinputtable[mcNUMIPAR+1] = {
  "A3_angle", &mcipA3_angle, instr_type_double, "0", 
  "kidney_angle", &mcipkidney_angle, instr_type_double, "0", 
  "EM", &mcipEM, instr_type_double, "3.4", 
  "EF_all", &mcipEF_all, instr_type_double, "3.4", 
  "HF", &mcipHF, instr_type_int, "1", 
  "VF", &mcipVF, instr_type_int, "1", 
  "sample_diameter_d", &mcipsample_diameter_d, instr_type_double, "0.02", 
  "beta_1", &mcipbeta_1, instr_type_double, "1", 
  "beta_2", &mcipbeta_2, instr_type_double, "1", 
  "CPF", &mcipCPF, instr_type_double, "0", 
  "MPL", &mcipMPL, instr_type_double, "6.06", 
  "MPD", &mcipMPD, instr_type_double, "0.775", 
  "APE_h", &mcipAPE_h, instr_type_double, "0.35", 
  "APE_v", &mcipAPE_v, instr_type_double, "0.35", 
  "misalign_mono_deg", &mcipmisalign_mono_deg, instr_type_double, "0.15", 
  "DIRDEV", &mcipDIRDEV, instr_type_double, "0", 
  "DIVSOU", &mcipDIVSOU, instr_type_double, "3.0", 
  "L0_delta", &mcipL0_delta, instr_type_double, "-1.06", 
  "L1_delta", &mcipL1_delta, instr_type_double, "0.0", 
  "mon_t", &mcipmon_t, instr_type_double, "0.0", 
  "mon_e", &mcipmon_e, instr_type_double, "0.0", 
  "monrot_delta", &mcipmonrot_delta, instr_type_double, "0", 
  "slit_h", &mcipslit_h, instr_type_double, "0.2", 
  "slit_v", &mcipslit_v, instr_type_double, "0.2", 
  "resolution_mode", &mcipresolution_mode, instr_type_double, "0", 
  "res_radius", &mcipres_radius, instr_type_double, "0.01", 
  "res_height", &mcipres_height, instr_type_double, "0.03", 
  "repeat_count", &mciprepeat_count, instr_type_int, "1", 
  "E0_resolution", &mcipE0_resolution, instr_type_double, "0", 
  "dE_resolution", &mcipdE_resolution, instr_type_double, "1", 
  NULL, NULL, instr_type_double, ""
};

/* User declarations from instrument definition. */
#define mccompcurname  dmtas
#define mccompcurtype  INSTRUMENT
#define mccompcurindex 0
#define mcposadmtas coords_set(0,0,0)
#define A3_angle mcipA3_angle
#define kidney_angle mcipkidney_angle
#define EM mcipEM
#define EF_all mcipEF_all
#define HF mcipHF
#define VF mcipVF
#define sample_diameter_d mcipsample_diameter_d
#define beta_1 mcipbeta_1
#define beta_2 mcipbeta_2
#define CPF mcipCPF
#define MPL mcipMPL
#define MPD mcipMPD
#define APE_h mcipAPE_h
#define APE_v mcipAPE_v
#define misalign_mono_deg mcipmisalign_mono_deg
#define DIRDEV mcipDIRDEV
#define DIVSOU mcipDIVSOU
#define L0_delta mcipL0_delta
#define L1_delta mcipL1_delta
#define mon_t mcipmon_t
#define mon_e mcipmon_e
#define monrot_delta mcipmonrot_delta
#define slit_h mcipslit_h
#define slit_v mcipslit_v
#define resolution_mode mcipresolution_mode
#define res_radius mcipres_radius
#define res_height mcipres_height
#define repeat_count mciprepeat_count
#define E0_resolution mcipE0_resolution
#define dE_resolution mcipdE_resolution
#line 53 "MACS_sample_kidney_box.instr"

  #define MAX_VOLUME_HISTORY_LENGTH 50
  #define DOUBLE_MAX_VOLUME_HISTORY_LENGTH 100
  
void splint(double xa[], double ya[], double y2a[], long n, double x, double *y)
{
	//void nrerror(char error_text[]);
	long klo,khi,k;
	double h,b,a;

	klo=1;
	khi=n;
	while (khi-klo > 1) {
		k=(khi+klo) >> 1;
		if (xa[k] > x) khi=k;
		else klo=k;
	}
	h=xa[khi]-xa[klo];
	//if (h == 0.0) nrerror("Bad xa input to routine splint");
	a=(xa[khi]-x)/h;
	b=(x-xa[klo])/h;
	*y=a*ya[klo]+b*ya[khi]+((a*a*a-a)*y2a[klo]+(b*b*b-b)*y2a[khi])*(h*h)/6.0;
}
/* (C) Copr. 1986-92 Numerical Recipes Software *1(.|a. */

/*Using the same definition of coordinate systems as in Monochromator.comp
  Counterclockwise rotation of the coordinate system is positive. */
void dmtas_rotate(double *x,double *y,double *z,double *vx,double *vy,
  double *vz,double r, double theta, double ang)
{
 double old_x=*x,old_y=*y,old_vx=*vx,old_vy=*vy,cos_t,sin_t;
 cos_t	=	cos(theta);
 sin_t	=	sin(theta);
 *x	=	r*ang+(old_x-r*ang)*cos_t-old_y*sin_t;
 *y	=	(old_x-r*ang)*sin_t+old_y*cos_t;
 *vx	=	old_vx*cos_t-old_vy*sin_t;
 *vy	=	old_vx*sin_t+old_vy*cos_t;
 /*z and vz remain the same.*/
}


void dmtas_rotate1(double *x,double *y,double *z,double *vx,double *vy,
  double *vz,double r, double theta)
{
 double old_x=*x,old_y=*y,old_vx=*vx,old_vy=*vy,cos_t,sin_t;
 cos_t	=	cos(theta);
 sin_t	=	sin(theta);
 *x	=	r+(old_x-r)*cos_t-old_y*sin_t;
 *y	=	(old_x-r)*sin_t+old_y*cos_t;
 *vx	=	old_vx*cos_t-old_vy*sin_t;
 *vy	=	old_vx*sin_t+old_vy*cos_t;
 /*z and vz remain the same.*/
}
/*A copy of the codes from monochromator.comp*/
void dmtas_analyzerblade(double div_cutoff, double zmin,double zmax,
  double ymin, double ymax, double mosaich, double mosaicv, double r0, 
  double Q, double *x, double *y, double *z, double *vx, double *vy, 
  double *vz, double *t, double *sx, double *sy, double *sz, double *p)
{
 double dphi, tmp1,tmp2,tmp3,vratio,phi,theta0,theta,v,cs,sn;
 double old_x=*x, old_y=*y,old_z=*z,old_t=*t;
 double dt;
 dt	=-(*x)/(*vx);
 if(*vx !=0.0 && dt>=0.0)
 {
	*y+=(*vy)*dt;*z+=(*vz)*dt;*t+=dt;*x=0.0;
	if(*z>zmin && *z<zmax && *y>ymin && *y<ymax)
	{
		/*First:scattering in plane*/
		theta0	=atan2(*vx,*vz); /*neutron angle to slab */
		v	=sqrt((*vx)*(*vx)+(*vy)*(*vy)+(*vz)*(*vz));
		theta	=asin(Q2V*Q/(2.0*v));	/*Bragg's law*/
		if (theta0<0) theta=-theta;
		tmp3	=	(theta-theta0)/(MIN2RAD*mosaich);
		if(tmp3>div_cutoff)
		{
			*x=old_x;
			*y=old_y;
			*z=old_z;
			*t=old_t;
		}
		else
		{
			(*p)*=r0*exp(-tmp3*tmp3*4.*log(2)); /*Use mosaics*/
			tmp1	=2*theta;
			cs	=cos(tmp1);
			sn	=sin(tmp1);
			tmp2	=cs*(*vx)-sn*(*vz);
			*vy	=*vy;
			*vz	=cs*(*vz)+sn*(*vx);
			*vx	=tmp2;
		/*Second:scattering out of plane.
		  Approximation is that Deby-Scherrer cone is a plane*/
			phi =atan2(*vy,*vz);  /*out-of plane angle */
			dphi=(MIN2RAD*mosaicv)/(2*sqrt(2*log(2)))*randnorm();
				/*MC choice*/
		/*Vertical angle of the crystallite*/
			*vy	=(*vz)*tan(phi+2*dphi*sin(theta));
			vratio	=v/sqrt((*vx)*(*vx)+(*vy)*(*vy)+(*vz)*(*vz));
			*vz	=(*vz)*vratio;
			*vy	=(*vy)*vratio;
			*vx	=(*vx)*vratio;
		}
	}
	else
	{
		*x=old_x;
		*y=old_y;
		*z=old_z;
		*t=old_t;
	}

 }
}
/*allow random direction of analyzer blade*/
void dmtas_analyzerblade1(double div_cutoff,double zmin,double zmax,
  double ymin, double ymax, double mosaich, double mosaicv, double dirdev,
  double r0, double Q, double *x, double *y, double *z, double *vx, 
  double *vy, double *vz, double *t, double *sx, double *sy, double *sz, double *p)
{
 double dphi, tmp1,tmp2,tmp3,vratio,phi,theta0,theta,v,cs,sn;
 double old_x=*x, old_y=*y,old_z=*z,old_t=*t;
 double old_vx=*vx,old_vy=*vy,old_vz=*vz;
 double dt;
 double dirdev_1=asin(sin(MIN2RAD*dirdev)*0.707107);	/*adjust dirdev*/
 double dthz=dirdev_1/(2*sqrt(2*log(2)))*randnorm();
 double dthy=dirdev_1/(2*sqrt(2*log(2)))*randnorm();
 double cdthz=cos(dthz), sdthz=sin(dthz),cdthy=cos(dthy),sdthy=sin(dthy);
/*rotate the blade to a random direction, dthz around z, then dthy around y'*/
 *x=old_x*cdthy*cdthz+old_y*cdthy*sdthz-old_z*sdthy;
 *y=-old_x*sdthz+old_y*cdthz;
 *z=old_x*sdthy*cdthz+old_y*sdthy*sdthz+old_z*cdthy;
 *vx=old_vx*cdthy*cdthz+old_vy*cdthy*sdthz-old_vz*sdthy;
 *vy=-old_vx*sdthz+old_vy*cdthz;
 *vz=old_vx*sdthy*cdthz+old_vy*sdthy*sdthz+old_vz*cdthy;

 old_x=*x;
 old_y=*y;
 old_z=*z;
 old_t=*t;

 dt	=-(*x)/(*vx);
 if(*vx !=0.0 && dt>=0.0)
 {
	*y+=(*vy)*dt;*z+=(*vz)*dt;*t+=dt;*x=0.0;
	if(*z>zmin && *z<zmax && *y>ymin && *y<ymax)
	{  
		/*First:scattering in plane*/
		theta0	=atan2(*vx,*vz); /*neutron angle to slab */
		v	=sqrt((*vx)*(*vx)+(*vy)*(*vy)+(*vz)*(*vz));
		theta	=asin(Q2V*Q/(2.0*v));	/*Bragg's law*/
		if (theta0<0) theta=-theta;
		tmp3	=	(theta-theta0)/(MIN2RAD*mosaich);
		if(tmp3>div_cutoff)
		{
			*x=old_x;
			*y=old_y;
			*z=old_z;
			*t=old_t;
		}
		else
		{
			(*p)*=r0*exp(-tmp3*tmp3*4.*log(2)); /*Use mosaics*/
			/* the reflectivity is given in r0  JAR*/
			tmp1	=2*theta;
			cs	=cos(tmp1);
			sn	=sin(tmp1);
			tmp2	=cs*(*vx)-sn*(*vz);
			*vy	=*vy;
			*vz	=cs*(*vz)+sn*(*vx);
			*vx	=tmp2;
		/*Second:scattering out of plane.
		  Approximation is that Deby-Scherrer cone is a plane*/
			phi =atan2(*vy,*vz);  /*out-of plane angle */
			dphi=(MIN2RAD*mosaicv)/(2*sqrt(2*log(2)))*randnorm();
				/*MC choice*/
		/*Vertical angle of the crystallite*/
			*vy	=(*vz)*tan(phi+2*dphi*sin(theta));
			vratio	=v/sqrt((*vx)*(*vx)+(*vy)*(*vy)+(*vz)*(*vz));
			*vz	=(*vz)*vratio;
			*vy	=(*vy)*vratio;
			*vx	=(*vx)*vratio;
		}
	}
	else
	{
		*x=old_x;
		*y=old_y;
		*z=old_z;
		*t=old_t;
	}
 }
 old_x=*x;
 old_y=*y;
 old_z=*z;
 old_vx=*vx;
 old_vy=*vy;
 old_vz=*vz;

/*rotate the blade back to its original direction*/
 *x=old_x*cdthz*cdthy+old_z*cdthz*sdthy-old_y*sdthz;
 *y=old_x*sdthz*cdthy+old_z*sdthz*sdthy+old_y*cdthz;
 *z=-old_x*sdthy+old_z*cdthy;
 *vx=old_vx*cdthz*cdthy+old_vz*cdthz*sdthy-old_vy*sdthz;
 *vy=old_vx*sdthz*cdthy+old_vz*sdthz*sdthy+old_vy*cdthz;
 *vz=-old_vx*sdthy+old_vz*cdthy;

}


/*allow random direction of analyzer blade*/
/*converted from Mosaic_anisotropic.comp  */
/*Yiming Qiu 6/29/2001			  */
#define GAUSS(x,mean,rms) \
  (exp(-((x)-(mean))*((x)-(mean))/(2*(rms)*(rms)))/(sqrt(2*PI)*(rms)))

void macs_analyzerblade_ani(double zmin,double zmax,
  double ymin, double ymax, double mosaich, double mosaicv, double dirdev,
  double r0, double Q, double *x, double *y, double *z, double *vx, 
  double *vy, double *vz, double *t, double *sx, double *sy, double *sz, double *p)
{
 double sqrt8ln2	=	sqrt(8.*log(2));

 /* Values for Gauss quadrature. Taken from Brice Carnahan, H. A. Luther and
    James O Wilkes, "Applied numerical methods", Wiley, 1996, page 103. */
 double X[] = {-0.987992518020485, 0.937273392400706, 0.848206583410427,
                0.724417731360170, 0.570972172608539, 0.394151347077563,
                0.201194093997435, 0, 0.201194093997435,
                0.394151347077563, 0.570972172608539, 0.724417731360170,
                0.848206583410427, 0.937273392400706, 0.987992518020485};
 double W[] = { 0.030753241996117, 0.070366047488108, 0.107159220467172,
                0.139570677926154, 0.166269205816994, 0.186161000115562,
                0.198431485327111, 0.202578241925561, 0.198431485327111,
                0.186161000115562, 0.166269205816994, 0.139570677926154,
                0.107159220467172, 0.070366047488108, 0.030753241996117};
 /* root-mean-square of mosaic, in radians*/
 double mos_rms_y=MIN2RAD*mosaich/sqrt8ln2; 
 double mos_rms_z=MIN2RAD*mosaicv/sqrt8ln2;
 double mos_rms_max=mos_rms_y>mos_rms_z?mos_rms_y:mos_rms_z;

 double y1,z1,t1,dt,kix,kiy,kiz,ratio,order,q0x,k,q0,theta;
 double bx,by,bz,kux,kuy,kuz,ax,ay,az,phi;
 double cos_2theta,k_sin_2theta,cos_phi,sin_phi,kfx,kfy,kfz,q_x,q_y,q_z;
 double delta,p_reflect,total,c1x,c1y,c1z,width,ds_factor;
 int i;

/*adjust the blade according to dirdev*/ 
 double old_x=*x, old_y=*y,old_z=*z,old_t=*t;
 double old_vx=*vx,old_vy=*vy,old_vz=*vz;
 double dirdev_1=asin(sin(MIN2RAD*dirdev)*0.707107);	/*adjust dirdev*/
 double dthz=dirdev_1/sqrt8ln2*randnorm();
 double dthy=dirdev_1/sqrt8ln2*randnorm();
 double cdthz=cos(dthz), sdthz=sin(dthz),cdthy=cos(dthy),sdthy=sin(dthy);
/*rotate the blade to a random direction, dthz around z, then dthy around y'*/
 *x=old_x*cdthy*cdthz+old_y*cdthy*sdthz-old_z*sdthy;
 *y=-old_x*sdthz+old_y*cdthz;
 *z=old_x*sdthy*cdthz+old_y*sdthy*sdthz+old_z*cdthy;
 *vx=old_vx*cdthy*cdthz+old_vy*cdthy*sdthz-old_vz*sdthy;
 *vy=-old_vx*sdthz+old_vy*cdthz;
 *vz=old_vx*sdthy*cdthz+old_vy*sdthy*sdthz+old_vz*cdthy;


 if(*vx != 0.0 && (dt = -(*x)/(*vx)) >= 0.0)
 { /* Moving towards crystal? */
    y1 = *y + (*vy)*dt;            /* Propagate to crystal plane */
    z1 = *z + (*vz)*dt;
    t1 = *t + dt;
    if (z1>zmin && z1<zmax && y1>ymin && y1<ymax)
    { /* Intersect the crystal? */
      kix = V2K*(*vx);             /* Initial wave vector */
      kiy = V2K*(*vy);
      kiz = V2K*(*vz);
      /* Get reflection order and corresponding nominal scattering vector q0
         of correct length and direction. Only the order with the closest
         scattering vector is considered */
      ratio = -2*kix/Q;
      order = floor(ratio + .5);
      if(order == 0.0)
        order = ratio < 0 ? -1 : 1;
      /* Order will be negative when the neutron enters from the back, in
         which case the direction of Q0 is flipped. */
      if(order < 0)
        order = -order;
      /* Make sure the order is small enough to allow Bragg scattering at the
         given neutron wavelength */
      k = sqrt(kix*kix + kiy*kiy + kiz*kiz);
      kux = kix/k;              /* Unit vector along ki */
      kuy = kiy/k;
      kuz = kiz/k;
      if(order > 2*k/Q)
        order--;
      if(order > 0)             /* Bragg scattering possible? */
      {
        q0 = order*Q;
        q0x = ratio < 0 ? -q0 : q0;
        theta = asin(q0/(2*k)); /* Actual bragg angle */
        /* Make MC choice: reflect or transmit? */
        delta = asin(fabs(kux)) - theta;
        p_reflect = r0*exp(-kiz*kiz/(kiy*kiy + kiz*kiz)*(delta*delta)/
                           (2*mos_rms_y*mos_rms_y))*
                       exp(-kiy*kiy/(kiy*kiy + kiz*kiz)*(delta*delta)/
                           (2*mos_rms_z*mos_rms_z));
        if(rand01() < p_reflect)
        {                       /* Reflect */
          cos_2theta = cos(2*theta);
          k_sin_2theta = k*sin(2*theta);
          /* Get unit normal to plane containing ki and most probable kf */
          vec_prod(bx, by, bz, kix, kiy, kiz, q0x, 0, 0);
          NORM(bx,by,bz);
          bx *= k_sin_2theta;
          by *= k_sin_2theta;
          bz *= k_sin_2theta;
          /* Get unit vector normal to ki and b */
          vec_prod(ax, ay, az, bx, by, bz, kux, kuy, kuz);
          /* Compute the total scattering probability at this ki */
          total = 0;
          /* Choose integration limits, using Gaussian tail cut-off at 5 times
	   * sigma. The radius of the Debye-Scherrer cone is smaller by a
	   * factor 1/cos(theta) than the radius of the (partial) sphere
	   * describing the possible orientations of Q due to mosaicity, so we
	   * must use an integration width 1/cos(theta) greater than 5 times
	   * the mosaic. */
          ds_factor = 1/cos(theta);
          width = 5*mos_rms_max*ds_factor;
          c1x = kix*(cos_2theta-1);
          c1y = kiy*(cos_2theta-1);
          c1z = kiz*(cos_2theta-1);
          for(i = 0; i < (sizeof(X)/sizeof(double)); i++)
          {
            phi = width*X[i];
            cos_phi = cos(phi);
            sin_phi = sin(phi);
            q_x = c1x + cos_phi*ax + sin_phi*bx;
            q_y = c1y + cos_phi*ay + sin_phi*by;
            q_z = c1z + cos_phi*az + sin_phi*bz;
            p_reflect = GAUSS((q_z/q_x),0,mos_rms_y)*
                        GAUSS((q_y/q_x),0,mos_rms_z);
            total += W[i]*p_reflect;
          }
          total *= width;
          /* Choose point on Debye-Scherrer cone. Sample from a Gaussian of
	   * width 1/cos(theta) greater than the mosaic and correct for any
	   * error by adjusting the neutron weight later. */
          phi = ds_factor*mos_rms_max*randnorm();
          /* Compute final wave vector kf and scattering vector q = ki - kf */
          cos_phi = cos(phi);
          sin_phi = sin(phi);
          q_x = c1x + cos_phi*ax + sin_phi*bx;
          q_y = c1y + cos_phi*ay + sin_phi*by;
          q_z = c1z + cos_phi*az + sin_phi*bz;
          p_reflect = GAUSS((q_z/q_x),0,mos_rms_y)*
                      GAUSS((q_y/q_x),0,mos_rms_z);
          *x = 0;
          *y = y1;
          *z = z1;
          *t = t1;
          *vx = K2V*(kix+q_x);
          *vy = K2V*(kiy+q_y);
          *vz = K2V*(kiz+q_z);
          (*p) *= p_reflect/(total*GAUSS(phi,0,ds_factor*mos_rms_max));
        } /* End MC choice to reflect or transmit neutron */
      } /* End bragg scattering possible */
    } /* End intersect the crystal */
 } /* End neutron moving towards crystal */

 old_x=*x;
 old_y=*y;
 old_z=*z;
 old_vx=*vx;
 old_vy=*vy;
 old_vz=*vz;

/*rotate the blade back to its original direction*/
 *x=old_x*cdthz*cdthy+old_z*cdthz*sdthy-old_y*sdthz;
 *y=old_x*sdthz*cdthy+old_z*sdthz*sdthy+old_y*cdthz;
 *z=-old_x*sdthy+old_z*cdthy;
 *vx=old_vx*cdthz*cdthy+old_vz*cdthz*sdthy-old_vy*sdthz;
 *vy=old_vx*sdthz*cdthy+old_vz*sdthz*sdthy+old_vy*cdthz;
 *vz=-old_vx*sdthy+old_vz*cdthy;
}





/*allow random direction of analyzer blade*/
/*converted from monochromator_flat.comp  */
/*Jose A. Rodriguez 2/12/2007*/
#define GAUSS(x,mean,rms) \
  (exp(-((x)-(mean))*((x)-(mean))/(2*(rms)*(rms)))/(sqrt(2*PI)*(rms)))

void macs_mono_flat(double zmin,double zmax,
  double ymin, double ymax, double mosaich, double mosaicv, double dirdev,
  double r0, double Q, double *x, double *y, double *z, double *vx, 
  double *vy, double *vz, double *t, double *sx, double *sy, double *sz, double *p)
{
 double sqrt8ln2	=	sqrt(8.*log(2));

 /* Values for Gauss quadrature. Taken from Brice Carnahan, H. A. Luther and
    James O Wilkes, "Applied numerical methods", Wiley, 1996, page 103. */
 double X[] = {-0.987992518020485, 0.937273392400706, 0.848206583410427,
                0.724417731360170, 0.570972172608539, 0.394151347077563,
                0.201194093997435, 0, 0.201194093997435,
                0.394151347077563, 0.570972172608539, 0.724417731360170,
                0.848206583410427, 0.937273392400706, 0.987992518020485};
 double W[] = { 0.030753241996117, 0.070366047488108, 0.107159220467172,
                0.139570677926154, 0.166269205816994, 0.186161000115562,
                0.198431485327111, 0.202578241925561, 0.198431485327111,
                0.186161000115562, 0.166269205816994, 0.139570677926154,
                0.107159220467172, 0.070366047488108, 0.030753241996117};
 /* root-mean-square of mosaic, in radians*/
 double mos_rms_y=MIN2RAD*mosaich/sqrt8ln2; 
 double mos_rms_z=MIN2RAD*mosaicv/sqrt8ln2;

 
 
 double mos_rms_max=mos_rms_y>mos_rms_z?mos_rms_y:mos_rms_z,mos_sample;

 double y1,z1,t1,dt,kix,kiy,kiz,ratio,order,q0x,k,q0,theta;
 double bx,by,bz,kux,kuy,kuz,ax,ay,az,phi;
 double cos_2theta,k_sin_2theta,cos_phi,sin_phi,kfx,kfy,kfz,q_x,q_y,q_z;
 double delta,p_reflect,total,c1x,c1y,c1z,width,ds_factor;
 int i;

/*adjust the blade according to dirdev*/ 
 double old_x=*x, old_y=*y,old_z=*z,old_t=*t;
 double old_vx=*vx,old_vy=*vy,old_vz=*vz;
 double dirdev_1=asin(sin(MIN2RAD*dirdev)*0.707107);	/*adjust dirdev*/
 double dthz=dirdev_1/sqrt8ln2*randnorm();
 double dthy=dirdev_1/sqrt8ln2*randnorm();
 double cdthz=cos(dthz), sdthz=sin(dthz),cdthy=cos(dthy),sdthy=sin(dthy);
/*rotate the blade to a random direction, dthz around z, then dthy around y'*/
 *x=old_x*cdthy*cdthz+old_y*cdthy*sdthz-old_z*sdthy;
 *y=-old_x*sdthz+old_y*cdthz;
 *z=old_x*sdthy*cdthz+old_y*sdthy*sdthz+old_z*cdthy;
 *vx=old_vx*cdthy*cdthz+old_vy*cdthy*sdthz-old_vz*sdthy;
 *vy=-old_vx*sdthz+old_vy*cdthz;
 *vz=old_vx*sdthy*cdthz+old_vy*sdthy*sdthz+old_vz*cdthy;

 if(*vx != 0.0 && (dt = -(*x)/(*vx)) >= 0.0)
  {                             /* Moving towards crystal? */
    y1 = *y + (*vy)*dt;            /* Propagate to crystal plane */
    z1 = *z + (*vz)*dt;
    t1 = *t + dt;
    if (z1>zmin && z1<zmax && y1>ymin && y1<ymax)
    {                           /* Intersect the crystal? */
      kix = V2K*(*vx);             /* Initial wave vector */
      kiy = V2K*(*vy);
      kiz = V2K*(*vz);
      /* Get reflection order and corresponding nominal scattering vector q0
         of correct length and direction. Only the order with the closest
         scattering vector is considered */
      ratio = -2*kix/Q;
      order = floor(ratio + .5);
      if(order == 0.0)
        order = ratio < 0 ? -1 : 1;
      /* Order will be negative when the neutron enters from the back, in
         which case the direction of Q0 is flipped. */
      if(order < 0)
        order = -order;
      /* Make sure the order is small enough to allow Bragg scattering at the
         given neutron wavelength */
      k = sqrt(kix*kix + kiy*kiy + kiz*kiz);
      kux = kix/k;              /* Unit vector along ki */
      kuy = kiy/k;
      kuz = kiz/k;
      if(order > 2*k/Q)
        order--;
      if(order > 0)             /* Bragg scattering possible? */
      {
        q0 = order*Q;
        q0x = ratio < 0 ? -q0 : q0;
        theta = asin(q0/(2*k)); /* Actual bragg angle */
        /* Make MC choice: reflect or transmit? */
        delta = asin(fabs(kux)) - theta;
        p_reflect = r0*exp(-kiz*kiz/(kiy*kiy + kiz*kiz)*(delta*delta)/
                           (2*mos_rms_y*mos_rms_y))*
                       exp(-kiy*kiy/(kiy*kiy + kiz*kiz)*(delta*delta)/
                           (2*mos_rms_z*mos_rms_z));
        if(rand01() < p_reflect)
        {                       /* Reflect */
          cos_2theta = cos(2*theta);
          k_sin_2theta = k*sin(2*theta);
          /* Get unit normal to plane containing ki and most probable kf */
          vec_prod(bx, by, bz, kix, kiy, kiz, q0x, 0, 0);
          NORM(bx,by,bz);
          bx *= k_sin_2theta;
          by *= k_sin_2theta;
          bz *= k_sin_2theta;
          /* Get unit vector normal to ki and b */
          vec_prod(ax, ay, az, bx, by, bz, kux, kuy, kuz);
          /* Compute the total scattering probability at this ki */
          total = 0;
          /* Choose width of Gaussian distribution to sample the angle
           * phi on the Debye-Scherrer cone for the scattered neutron.
           * The radius of the Debye-Scherrer cone is smaller by a
           * factor 1/cos(theta) than the radius of the (partial) sphere
           * describing the possible orientations of Q due to mosaicity, so we
           * start with a width 1/cos(theta) greater than the largest of
           * the two mosaics. */
          mos_sample = mos_rms_max/cos(theta);
          c1x = kix*(cos_2theta-1);
          c1y = kiy*(cos_2theta-1);
          c1z = kiz*(cos_2theta-1);
          /* Loop, repeatedly reducing the sample width until it is small
           * enough to avoid sampling scattering directions with
           * ridiculously low scattering probability.
           * Use a cut-off at 5 times the gauss width for considering
           * scattering probability as well as for integration limits
           * when integrating the sampled distribution below. */
          for(;;) {
            width = 5*mos_sample;
            cos_phi = cos(width);
            sin_phi = sin(width);
            q_x = c1x + cos_phi*ax + sin_phi*bx;
            q_y = (c1y + cos_phi*ay + sin_phi*by)/mos_rms_z;
            q_z = (c1z + cos_phi*az + sin_phi*bz)/mos_rms_y;
            /* Stop when we get near a factor of 25=5^2. */
            if(q_z*q_z + q_y*q_y < (25/(2.0/3.0))*(q_x*q_x))
              break;
            mos_sample *= (2.0/3.0);
          }
          /* Now integrate the chosen sampling distribution, using a
           * cut-off at five times sigma. */
          for(i = 0; i < (sizeof(X)/sizeof(double)); i++)
          {
            phi = width*X[i];
            cos_phi = cos(phi);
            sin_phi = sin(phi);
            q_x = c1x + cos_phi*ax + sin_phi*bx;
            q_y = c1y + cos_phi*ay + sin_phi*by;
            q_z = c1z + cos_phi*az + sin_phi*bz;
            p_reflect = GAUSS((q_z/q_x),0,mos_rms_y)*
                        GAUSS((q_y/q_x),0,mos_rms_z);
            total += W[i]*p_reflect;
          }
          total *= width;
          /* Choose point on Debye-Scherrer cone. Sample from a Gaussian of
           * width 1/cos(theta) greater than the mosaic and correct for any
           * error by adjusting the neutron weight later. */
          phi = mos_sample*randnorm();
          /* Compute final wave vector kf and scattering vector q = ki - kf */
          cos_phi = cos(phi);
          sin_phi = sin(phi);
          q_x = c1x + cos_phi*ax + sin_phi*bx;
          q_y = c1y + cos_phi*ay + sin_phi*by;
          q_z = c1z + cos_phi*az + sin_phi*bz;
          p_reflect = GAUSS((q_z/q_x),0,mos_rms_y)*
                      GAUSS((q_y/q_x),0,mos_rms_z);
          *x = 0;
          *y = y1;
          *z = z1;
          *t = t1;
          *vx = K2V*(kix+q_x);
          *vy = K2V*(kiy+q_y);
          *vz = K2V*(kiz+q_z);
          (*p) *= p_reflect/(total*GAUSS(phi,0,mos_sample));
        } /* End MC choice to reflect or transmit neutron */
      } /* End bragg scattering possible */
    } /* End intersect the crystal */
  } /* End neutron moving towards crystal */

 old_x=*x;
 old_y=*y;
 old_z=*z;
 old_vx=*vx;
 old_vy=*vy;
 old_vz=*vz;

/*rotate the blade back to its original direction*/
 *x=old_x*cdthz*cdthy+old_z*cdthz*sdthy-old_y*sdthz;
 *y=old_x*sdthz*cdthy+old_z*sdthz*sdthy+old_y*cdthz;
 *z=-old_x*sdthy+old_z*cdthy;
 *vx=old_vx*cdthz*cdthy+old_vz*cdthz*sdthy-old_vy*sdthz;
 *vy=old_vx*sdthz*cdthy+old_vz*sdthz*sdthy+old_vy*cdthz;
 *vz=-old_vx*sdthy+old_vz*cdthy;
}

  
  double dmtas_sou_radusv=0.055;  /*source (in cm)*/
  double dmtas_sou_radush=0.055;    
  
  double phi_source=0;

  double diverg;
 
  double dmtas_sou_E0, dmtas_sou_dE, MPL;
  // double mon_tras, mon_ele;
  double dist_slit1,dist_slit2;
  double xmax_slit1,xmin_slit1,ymax_slit1,ymin_slit1;
  double xmax_slit2,xmin_slit2,ymax_slit2,ymin_slit2;
  double emin, emax;
  double lambda;
   
  double dist_tub1  = 0.15;   /*tube1 Pee Wee*/
  double tub1_r1  =0.065  ;
  double tub1_r2  =0.065  ;
  double tub1_length =0.79;

  double sample_radius; 

  //Below are user defined.
  double samp_ax; //can be calculated from lattice params and u v matrix 
  double samp_ay; 
  double samp_az; 
  double samp_bx; 
  double samp_by; 
  double samp_bz; 
  double samp_cx; 
  double samp_cy; 
  double samp_cz; 
  double samp_abs_xc; 
  double samp_mosaic; 
  double samp_delta_d; 
  double samp_inc_xc; 
  double samp_cell_vol; 
  double samp_xwidth;
  double samp_ywidth;
  double samp_zwidth;
  double crystal_axis_xrot; 
  double crystal_axis_yrot; 
  double crystal_axis_zrot; 

  double plate_distance;

  double dist_tub1A = 0.95;   /*tube1A Pee Wee*/
  double tub1A_r1 =0.165  ;
  double tub1A_r2 =0.165  ;
  double tub1A_length   =1.69;

  double dist_tub2   =2.650;      /*tube2*/
  double tub2_r1     =0.1187       ;
  double tub2_r2     =0.1411       ;
  double tub2_length =0.8;

  double dist_tub3   =3.475 ;      /*tube3*/
  double tub3_r1     =0.1418       ;
  double tub3_r2     =0.1543       ;
  double tub3_length =0.45         ;
 
  double dist_tub4   =3.935 ;      /*tube4*/
  double tub4_r1     =0.1546       ;
  double tub4_r2     =0.159        ;
  double tub4_length =0.159        ;

  double apev, apeh;              /*aptertures*/
  double dist_ape_v=4.550;
  double dist_ape_h=4.655;
  double slv_xmin,slv_xmax,slv_ymin,slv_ymax;
  double slh_xmin,slh_xmax,slh_ymin,slh_ymax;

  
  double dist_collA =4.150;       /*collimatorA*/
  double dmtas_collA_R1 =4.152,dmtas_collA_R2 =4.287;
  double dmtas_collA_h =0.460;
  double dmtas_collA_n  =98;
  double dmtas_collA_w  =0.0033;

  double dist_collB =4.295;       /*collimatorB*/
  double dmtas_collB_R1 =4.295,dmtas_collB_R2 =4.503;
  double dmtas_collB_h =0.460;
  double dmtas_collB_n  =98;
  double dmtas_collB_w  =0.003415;

  double hight_at_reference,R_at_reference;
  double tan_ver,tan_hor;
  double angle_of_ver,len_of_ver;
  double dmtas_guide_w1;        /*super mirror guide*/
  double dmtas_guide_w2;
  double dmtas_guide_h1, dmtas_guide_h2;
  double dmtas_guide_len;
  double dmtas_guide_l  =1.7;     /*only use the geometry*/

// declare section for monochromator 
double mono_column_displacements[21] = {-0.210000,-0.189000,-0.168000,-0.147000,-0.126000,-0.105000,-0.084000,-0.063000,-0.042000,-0.021000,0.000000,0.021000,0.042000,0.063000,0.084000,0.105000,0.126000,0.147000,0.168000,0.189000,0.210000};
double mono_crystal_width = 0.020000;
double mono_number_of_rows = 17.000000;
double mono_q = 1.873250;
double mono_theta;
double dist_mono_L0;
double dist_mono_L0_pos;
double dist_mono_L1;
double dist_mono_L1_pos;
double R_at_reference;
double height_at_reference;
double mono_Radius_of_curvature;
double mono_total_height;
double mono_phi;
double mono_psi[21];
int mono_iterate;
double mono_mosaicity_eta_min = 14.107000;
double mono_mosaicity_eta_rad;
double mono_crystal_thickness = 20000000.000000;
double mono_g;
double mono_Ff;
double mono_b_c = 0.000066;
double mono_Vc;
double mono_Qc;
double mono_t;
double mono_xx;
double mono_r0;
double mono_mosaicity_rad;
double mono_mosaicity_min;
double mono_array0_crystal_height = 0.020000;
double mono_array0_crystal_depth = 0.002000;
int mono_array0_number_of_crystals = 17;
double mono_array0_effective_radius_of_curvature;
double mono_array0_theta_max;
double mono_array0_delta_theta;
double mono_array0_theta[17];
int mono_array0_iterate;
double mono_array0_support_arch_thickness = 0.001830;
double mono_array0_support_arch_width = 0.018800;
double mono_array0_support_arch_spacing = 0.000251;
double mono_array0_arch_outer_radius;
double mono_array0_arch_inner_radius;
double mono_array0_mask_depth;
double mono_array1_crystal_height = 0.020000;
double mono_array1_crystal_depth = 0.002000;
int mono_array1_number_of_crystals = 17;
double mono_array1_effective_radius_of_curvature;
double mono_array1_theta_max;
double mono_array1_delta_theta;
double mono_array1_theta[17];
int mono_array1_iterate;
double mono_array1_support_arch_thickness = 0.001830;
double mono_array1_support_arch_width = 0.018800;
double mono_array1_support_arch_spacing = 0.000251;
double mono_array1_arch_outer_radius;
double mono_array1_arch_inner_radius;
double mono_array1_mask_depth;
double mono_array2_crystal_height = 0.020000;
double mono_array2_crystal_depth = 0.002000;
int mono_array2_number_of_crystals = 17;
double mono_array2_effective_radius_of_curvature;
double mono_array2_theta_max;
double mono_array2_delta_theta;
double mono_array2_theta[17];
int mono_array2_iterate;
double mono_array2_support_arch_thickness = 0.001830;
double mono_array2_support_arch_width = 0.018800;
double mono_array2_support_arch_spacing = 0.000251;
double mono_array2_arch_outer_radius;
double mono_array2_arch_inner_radius;
double mono_array2_mask_depth;
double mono_array3_crystal_height = 0.020000;
double mono_array3_crystal_depth = 0.002000;
int mono_array3_number_of_crystals = 17;
double mono_array3_effective_radius_of_curvature;
double mono_array3_theta_max;
double mono_array3_delta_theta;
double mono_array3_theta[17];
int mono_array3_iterate;
double mono_array3_support_arch_thickness = 0.001830;
double mono_array3_support_arch_width = 0.018800;
double mono_array3_support_arch_spacing = 0.000251;
double mono_array3_arch_outer_radius;
double mono_array3_arch_inner_radius;
double mono_array3_mask_depth;
double mono_array4_crystal_height = 0.020000;
double mono_array4_crystal_depth = 0.002000;
int mono_array4_number_of_crystals = 17;
double mono_array4_effective_radius_of_curvature;
double mono_array4_theta_max;
double mono_array4_delta_theta;
double mono_array4_theta[17];
int mono_array4_iterate;
double mono_array4_support_arch_thickness = 0.001830;
double mono_array4_support_arch_width = 0.018800;
double mono_array4_support_arch_spacing = 0.000251;
double mono_array4_arch_outer_radius;
double mono_array4_arch_inner_radius;
double mono_array4_mask_depth;
double mono_array5_crystal_height = 0.020000;
double mono_array5_crystal_depth = 0.002000;
int mono_array5_number_of_crystals = 17;
double mono_array5_effective_radius_of_curvature;
double mono_array5_theta_max;
double mono_array5_delta_theta;
double mono_array5_theta[17];
int mono_array5_iterate;
double mono_array5_support_arch_thickness = 0.001830;
double mono_array5_support_arch_width = 0.018800;
double mono_array5_support_arch_spacing = 0.000251;
double mono_array5_arch_outer_radius;
double mono_array5_arch_inner_radius;
double mono_array5_mask_depth;
double mono_array6_crystal_height = 0.020000;
double mono_array6_crystal_depth = 0.002000;
int mono_array6_number_of_crystals = 17;
double mono_array6_effective_radius_of_curvature;
double mono_array6_theta_max;
double mono_array6_delta_theta;
double mono_array6_theta[17];
int mono_array6_iterate;
double mono_array6_support_arch_thickness = 0.001830;
double mono_array6_support_arch_width = 0.018800;
double mono_array6_support_arch_spacing = 0.000251;
double mono_array6_arch_outer_radius;
double mono_array6_arch_inner_radius;
double mono_array6_mask_depth;
double mono_array7_crystal_height = 0.020000;
double mono_array7_crystal_depth = 0.002000;
int mono_array7_number_of_crystals = 17;
double mono_array7_effective_radius_of_curvature;
double mono_array7_theta_max;
double mono_array7_delta_theta;
double mono_array7_theta[17];
int mono_array7_iterate;
double mono_array7_support_arch_thickness = 0.001830;
double mono_array7_support_arch_width = 0.018800;
double mono_array7_support_arch_spacing = 0.000251;
double mono_array7_arch_outer_radius;
double mono_array7_arch_inner_radius;
double mono_array7_mask_depth;
double mono_array8_crystal_height = 0.020000;
double mono_array8_crystal_depth = 0.002000;
int mono_array8_number_of_crystals = 17;
double mono_array8_effective_radius_of_curvature;
double mono_array8_theta_max;
double mono_array8_delta_theta;
double mono_array8_theta[17];
int mono_array8_iterate;
double mono_array8_support_arch_thickness = 0.001830;
double mono_array8_support_arch_width = 0.018800;
double mono_array8_support_arch_spacing = 0.000251;
double mono_array8_arch_outer_radius;
double mono_array8_arch_inner_radius;
double mono_array8_mask_depth;
double mono_array9_crystal_height = 0.020000;
double mono_array9_crystal_depth = 0.002000;
int mono_array9_number_of_crystals = 17;
double mono_array9_effective_radius_of_curvature;
double mono_array9_theta_max;
double mono_array9_delta_theta;
double mono_array9_theta[17];
int mono_array9_iterate;
double mono_array9_support_arch_thickness = 0.001830;
double mono_array9_support_arch_width = 0.018800;
double mono_array9_support_arch_spacing = 0.000251;
double mono_array9_arch_outer_radius;
double mono_array9_arch_inner_radius;
double mono_array9_mask_depth;
double mono_array10_crystal_height = 0.020000;
double mono_array10_crystal_depth = 0.002000;
int mono_array10_number_of_crystals = 17;
double mono_array10_effective_radius_of_curvature;
double mono_array10_theta_max;
double mono_array10_delta_theta;
double mono_array10_theta[17];
int mono_array10_iterate;
double mono_array10_support_arch_thickness = 0.001830;
double mono_array10_support_arch_width = 0.018800;
double mono_array10_support_arch_spacing = 0.000251;
double mono_array10_arch_outer_radius;
double mono_array10_arch_inner_radius;
double mono_array10_mask_depth;
double mono_array11_crystal_height = 0.020000;
double mono_array11_crystal_depth = 0.002000;
int mono_array11_number_of_crystals = 17;
double mono_array11_effective_radius_of_curvature;
double mono_array11_theta_max;
double mono_array11_delta_theta;
double mono_array11_theta[17];
int mono_array11_iterate;
double mono_array11_support_arch_thickness = 0.001830;
double mono_array11_support_arch_width = 0.018800;
double mono_array11_support_arch_spacing = 0.000251;
double mono_array11_arch_outer_radius;
double mono_array11_arch_inner_radius;
double mono_array11_mask_depth;
double mono_array12_crystal_height = 0.020000;
double mono_array12_crystal_depth = 0.002000;
int mono_array12_number_of_crystals = 17;
double mono_array12_effective_radius_of_curvature;
double mono_array12_theta_max;
double mono_array12_delta_theta;
double mono_array12_theta[17];
int mono_array12_iterate;
double mono_array12_support_arch_thickness = 0.001830;
double mono_array12_support_arch_width = 0.018800;
double mono_array12_support_arch_spacing = 0.000251;
double mono_array12_arch_outer_radius;
double mono_array12_arch_inner_radius;
double mono_array12_mask_depth;
double mono_array13_crystal_height = 0.020000;
double mono_array13_crystal_depth = 0.002000;
int mono_array13_number_of_crystals = 17;
double mono_array13_effective_radius_of_curvature;
double mono_array13_theta_max;
double mono_array13_delta_theta;
double mono_array13_theta[17];
int mono_array13_iterate;
double mono_array13_support_arch_thickness = 0.001830;
double mono_array13_support_arch_width = 0.018800;
double mono_array13_support_arch_spacing = 0.000251;
double mono_array13_arch_outer_radius;
double mono_array13_arch_inner_radius;
double mono_array13_mask_depth;
double mono_array14_crystal_height = 0.020000;
double mono_array14_crystal_depth = 0.002000;
int mono_array14_number_of_crystals = 17;
double mono_array14_effective_radius_of_curvature;
double mono_array14_theta_max;
double mono_array14_delta_theta;
double mono_array14_theta[17];
int mono_array14_iterate;
double mono_array14_support_arch_thickness = 0.001830;
double mono_array14_support_arch_width = 0.018800;
double mono_array14_support_arch_spacing = 0.000251;
double mono_array14_arch_outer_radius;
double mono_array14_arch_inner_radius;
double mono_array14_mask_depth;
double mono_array15_crystal_height = 0.020000;
double mono_array15_crystal_depth = 0.002000;
int mono_array15_number_of_crystals = 17;
double mono_array15_effective_radius_of_curvature;
double mono_array15_theta_max;
double mono_array15_delta_theta;
double mono_array15_theta[17];
int mono_array15_iterate;
double mono_array15_support_arch_thickness = 0.001830;
double mono_array15_support_arch_width = 0.018800;
double mono_array15_support_arch_spacing = 0.000251;
double mono_array15_arch_outer_radius;
double mono_array15_arch_inner_radius;
double mono_array15_mask_depth;
double mono_array16_crystal_height = 0.020000;
double mono_array16_crystal_depth = 0.002000;
int mono_array16_number_of_crystals = 17;
double mono_array16_effective_radius_of_curvature;
double mono_array16_theta_max;
double mono_array16_delta_theta;
double mono_array16_theta[17];
int mono_array16_iterate;
double mono_array16_support_arch_thickness = 0.001830;
double mono_array16_support_arch_width = 0.018800;
double mono_array16_support_arch_spacing = 0.000251;
double mono_array16_arch_outer_radius;
double mono_array16_arch_inner_radius;
double mono_array16_mask_depth;
double mono_array17_crystal_height = 0.020000;
double mono_array17_crystal_depth = 0.002000;
int mono_array17_number_of_crystals = 17;
double mono_array17_effective_radius_of_curvature;
double mono_array17_theta_max;
double mono_array17_delta_theta;
double mono_array17_theta[17];
int mono_array17_iterate;
double mono_array17_support_arch_thickness = 0.001830;
double mono_array17_support_arch_width = 0.018800;
double mono_array17_support_arch_spacing = 0.000251;
double mono_array17_arch_outer_radius;
double mono_array17_arch_inner_radius;
double mono_array17_mask_depth;
double mono_array18_crystal_height = 0.020000;
double mono_array18_crystal_depth = 0.002000;
int mono_array18_number_of_crystals = 17;
double mono_array18_effective_radius_of_curvature;
double mono_array18_theta_max;
double mono_array18_delta_theta;
double mono_array18_theta[17];
int mono_array18_iterate;
double mono_array18_support_arch_thickness = 0.001830;
double mono_array18_support_arch_width = 0.018800;
double mono_array18_support_arch_spacing = 0.000251;
double mono_array18_arch_outer_radius;
double mono_array18_arch_inner_radius;
double mono_array18_mask_depth;
double mono_array19_crystal_height = 0.020000;
double mono_array19_crystal_depth = 0.002000;
int mono_array19_number_of_crystals = 17;
double mono_array19_effective_radius_of_curvature;
double mono_array19_theta_max;
double mono_array19_delta_theta;
double mono_array19_theta[17];
int mono_array19_iterate;
double mono_array19_support_arch_thickness = 0.001830;
double mono_array19_support_arch_width = 0.018800;
double mono_array19_support_arch_spacing = 0.000251;
double mono_array19_arch_outer_radius;
double mono_array19_arch_inner_radius;
double mono_array19_mask_depth;
double mono_array20_crystal_height = 0.020000;
double mono_array20_crystal_depth = 0.002000;
int mono_array20_number_of_crystals = 17;
double mono_array20_effective_radius_of_curvature;
double mono_array20_theta_max;
double mono_array20_delta_theta;
double mono_array20_theta[17];
int mono_array20_iterate;
double mono_array20_support_arch_thickness = 0.001830;
double mono_array20_support_arch_width = 0.018800;
double mono_array20_support_arch_spacing = 0.000251;
double mono_array20_arch_outer_radius;
double mono_array20_arch_inner_radius;
double mono_array20_mask_depth;


  double dmtas_det_w    =0.02;    /*detector*/
  double dmtas_det_h  =0.04;
  double xmax_det, xmin_det, ymax_det, ymin_det;
  double tmp_dist,xx_mon;


// declare section for kidney 
int channel_selected;
double target_filter_dist = 0.350000;
double filter_width = 0.040000;
double filter_height = 0.120000;
double channel_colimator_length = 0.060000;
double channel_colimator_width = 0.034600;
double channel_colimator_height = 0.118400;
double channel_colimator_divergence_arcmin = 90.000000;
double channel_colimator_transmission = 0.900000;
double channel_colimator_target_dist = 0.400000;
double kidney_hull_radius = 1.375000;
double kidney_hull_height = 0.400000;
double kidney_hull_inner_radius = 0.685000;
double kidney_cylinder_angle = 160.000000;
double zx_log_z_min = -0.500000;
double zx_log_z_max = 1.500000;
double zx_log_x_min = -1.500000;
double zx_log_x_max = 1.500000;
int zx_log_z_pixels = 1000;
int zx_log_x_pixels = 1000;
double zy_log_z_min = -0.500000;
double zy_log_z_max = 1.500000;
double zy_log_y_min = -0.200000;
double zy_log_y_max = 0.200000;
int zy_log_z_pixels = 1000;
int zy_log_y_pixels = 300;
double kidney_cave1_width = 0.048740;
double kidney_cave1_height = 0.140000;
double kidney_cave1_depth = 0.550000;
double kidney_cave1_start_target_dist = 0.590000;
double kidney_cave1_box1_width1 = 0.048030;
double kidney_cave1_box1_width2 = 0.057166;
double kidney_cave1_box1_center_to_target;
double kidney_cave1_box1_depth = 0.260890;
double kidney_cave1_box1_height1 = 0.140000;
double kidney_cave1_box1_height2 = 0.173000;
double kidney_cave1_box2_width1 = 0.062634;
double kidney_cave1_box2_width2 = 0.067257;
double kidney_cave1_box2_center_to_target;
double kidney_cave1_box2_x_offset = -0.002764;
double kidney_cave1_box2_depth = 0.132400;
double kidney_cave1_box2_height1 = 0.206100;
double kidney_cave1_box2_height2 = 0.206100;
double kidney_cave1_box3_width1 = 0.061729;
double kidney_cave1_box3_width2 = 0.045340;
double kidney_cave1_box3_center_to_target;
double kidney_cave1_box3_depth = 0.031392;
double kidney_cave1_box3_height1 = 0.206000;
double kidney_cave1_box3_height2 = 0.206000;
double kidney_cave1_cyl1_radius = 0.024000;
double kidney_cave1_cyl1_center_to_target;
double kidney_cave1_cyl1_height = 0.250000;
double kidney_cave2_box1_y_rotation = 18.110000;
double kidney_cave2_box1_width1 = 0.063000;
double kidney_cave2_box1_depth = 0.112900;
double kidney_cave2_box1_width2;
double kidney_cave2_box1_center_to_spec_detector_z;
double kidney_cave2_box1_center_to_spec_detector_x;
double kidney_cave2_box1_height1 = 0.206000;
double kidney_cave2_box1_height2 = 0.206000;
double kidney_cave2_box2_width1 = 0.060170;
double kidney_cave2_box2_width2 = 0.057210;
double kidney_cave2_box2_center_to_detector = -0.196110;
double kidney_cave2_box2_depth = 0.049620;
double kidney_cave2_box2_height1 = 0.206100;
double kidney_cave2_box2_height2 = 0.206100;
double kidney_cave2_box3_width1 = 0.057210;
double kidney_cave2_box3_width2 = 0.047000;
double kidney_cave2_box3_center_to_detector = -0.085650;
double kidney_cave2_box3_depth = 0.171800;
double kidney_cave2_box3_height1 = 0.185000;
double kidney_cave2_box3_height2 = 0.120000;
double kidney_cave2_cyl1_radius = 0.023500;
double kidney_cave2_cyl1_height = 0.250000;
double kidney_cave2_start_target_dist = 0.960000;
double analyzer_1_center_to_sample = 0.999390;
double analyzer_seperation = 0.070000;
double analyzer_2theta_min = 40.000000;
double analyzer_2theta_max = 140.000000;
double delta_analyzer_2theta;
double analyzer_2theta[20];
double analyzer_theta[20];
int kidney_iterate;
double inter_analyzer_colimator_width = 0.000600;
double inter_analyzer_colimator_height = 0.202000;
double inter_analyzer_colimator_depth = 0.012700;
double inter_analyzer_colimator_start_pos = 0.032000;
double inter_analyzer_colimator_seperation = 0.016000;
double detector_radius = 0.018000;
double detector_height = 0.140000;
double diffraction_detector_to_sample;
double spec_detector_to_sample = 1.250000;
double spec_detector_to_analyzer_2_center;
double channel_0_analyzer_1_array_crystal_width = 0.060000;
double channel_0_analyzer_1_array_crystal_height = 0.020000;
double channel_0_analyzer_1_array_crystal_depth = 0.002000;
int channel_0_analyzer_1_array_number_of_crystals = 9;
double channel_0_analyzer_1_array_total_height = 0.180000;
double channel_0_analyzer_1_array_radius_of_curvature = 0.500000;
double channel_0_analyzer_1_array_effective_radius_of_curvature;
double channel_0_analyzer_1_array_theta_max;
double channel_0_analyzer_1_array_delta_theta;
double channel_0_analyzer_1_array_theta[9];
int channel_0_analyzer_1_array_iterate;
double channel_0_analyzer_2_array_crystal_width = 0.060000;
double channel_0_analyzer_2_array_crystal_height = 0.020000;
double channel_0_analyzer_2_array_crystal_depth = 0.002000;
int channel_0_analyzer_2_array_number_of_crystals = 9;
double channel_0_analyzer_2_array_total_height = 0.180000;
double channel_0_analyzer_2_array_radius_of_curvature = 0.500000;
double channel_0_analyzer_2_array_effective_radius_of_curvature;
double channel_0_analyzer_2_array_theta_max;
double channel_0_analyzer_2_array_delta_theta;
double channel_0_analyzer_2_array_theta[9];
int channel_0_analyzer_2_array_iterate;
double channel_1_analyzer_1_array_crystal_width = 0.060000;
double channel_1_analyzer_1_array_crystal_height = 0.020000;
double channel_1_analyzer_1_array_crystal_depth = 0.002000;
int channel_1_analyzer_1_array_number_of_crystals = 9;
double channel_1_analyzer_1_array_total_height = 0.180000;
double channel_1_analyzer_1_array_radius_of_curvature = 0.500000;
double channel_1_analyzer_1_array_effective_radius_of_curvature;
double channel_1_analyzer_1_array_theta_max;
double channel_1_analyzer_1_array_delta_theta;
double channel_1_analyzer_1_array_theta[9];
int channel_1_analyzer_1_array_iterate;
double channel_1_analyzer_2_array_crystal_width = 0.060000;
double channel_1_analyzer_2_array_crystal_height = 0.020000;
double channel_1_analyzer_2_array_crystal_depth = 0.002000;
int channel_1_analyzer_2_array_number_of_crystals = 9;
double channel_1_analyzer_2_array_total_height = 0.180000;
double channel_1_analyzer_2_array_radius_of_curvature = 0.500000;
double channel_1_analyzer_2_array_effective_radius_of_curvature;
double channel_1_analyzer_2_array_theta_max;
double channel_1_analyzer_2_array_delta_theta;
double channel_1_analyzer_2_array_theta[9];
int channel_1_analyzer_2_array_iterate;
double channel_2_analyzer_1_array_crystal_width = 0.060000;
double channel_2_analyzer_1_array_crystal_height = 0.020000;
double channel_2_analyzer_1_array_crystal_depth = 0.002000;
int channel_2_analyzer_1_array_number_of_crystals = 9;
double channel_2_analyzer_1_array_total_height = 0.180000;
double channel_2_analyzer_1_array_radius_of_curvature = 0.500000;
double channel_2_analyzer_1_array_effective_radius_of_curvature;
double channel_2_analyzer_1_array_theta_max;
double channel_2_analyzer_1_array_delta_theta;
double channel_2_analyzer_1_array_theta[9];
int channel_2_analyzer_1_array_iterate;
double channel_2_analyzer_2_array_crystal_width = 0.060000;
double channel_2_analyzer_2_array_crystal_height = 0.020000;
double channel_2_analyzer_2_array_crystal_depth = 0.002000;
int channel_2_analyzer_2_array_number_of_crystals = 9;
double channel_2_analyzer_2_array_total_height = 0.180000;
double channel_2_analyzer_2_array_radius_of_curvature = 0.500000;
double channel_2_analyzer_2_array_effective_radius_of_curvature;
double channel_2_analyzer_2_array_theta_max;
double channel_2_analyzer_2_array_delta_theta;
double channel_2_analyzer_2_array_theta[9];
int channel_2_analyzer_2_array_iterate;
double channel_3_analyzer_1_array_crystal_width = 0.060000;
double channel_3_analyzer_1_array_crystal_height = 0.020000;
double channel_3_analyzer_1_array_crystal_depth = 0.002000;
int channel_3_analyzer_1_array_number_of_crystals = 9;
double channel_3_analyzer_1_array_total_height = 0.180000;
double channel_3_analyzer_1_array_radius_of_curvature = 0.500000;
double channel_3_analyzer_1_array_effective_radius_of_curvature;
double channel_3_analyzer_1_array_theta_max;
double channel_3_analyzer_1_array_delta_theta;
double channel_3_analyzer_1_array_theta[9];
int channel_3_analyzer_1_array_iterate;
double channel_3_analyzer_2_array_crystal_width = 0.060000;
double channel_3_analyzer_2_array_crystal_height = 0.020000;
double channel_3_analyzer_2_array_crystal_depth = 0.002000;
int channel_3_analyzer_2_array_number_of_crystals = 9;
double channel_3_analyzer_2_array_total_height = 0.180000;
double channel_3_analyzer_2_array_radius_of_curvature = 0.500000;
double channel_3_analyzer_2_array_effective_radius_of_curvature;
double channel_3_analyzer_2_array_theta_max;
double channel_3_analyzer_2_array_delta_theta;
double channel_3_analyzer_2_array_theta[9];
int channel_3_analyzer_2_array_iterate;
double channel_4_analyzer_1_array_crystal_width = 0.060000;
double channel_4_analyzer_1_array_crystal_height = 0.020000;
double channel_4_analyzer_1_array_crystal_depth = 0.002000;
int channel_4_analyzer_1_array_number_of_crystals = 9;
double channel_4_analyzer_1_array_total_height = 0.180000;
double channel_4_analyzer_1_array_radius_of_curvature = 0.500000;
double channel_4_analyzer_1_array_effective_radius_of_curvature;
double channel_4_analyzer_1_array_theta_max;
double channel_4_analyzer_1_array_delta_theta;
double channel_4_analyzer_1_array_theta[9];
int channel_4_analyzer_1_array_iterate;
double channel_4_analyzer_2_array_crystal_width = 0.060000;
double channel_4_analyzer_2_array_crystal_height = 0.020000;
double channel_4_analyzer_2_array_crystal_depth = 0.002000;
int channel_4_analyzer_2_array_number_of_crystals = 9;
double channel_4_analyzer_2_array_total_height = 0.180000;
double channel_4_analyzer_2_array_radius_of_curvature = 0.500000;
double channel_4_analyzer_2_array_effective_radius_of_curvature;
double channel_4_analyzer_2_array_theta_max;
double channel_4_analyzer_2_array_delta_theta;
double channel_4_analyzer_2_array_theta[9];
int channel_4_analyzer_2_array_iterate;
double channel_5_analyzer_1_array_crystal_width = 0.060000;
double channel_5_analyzer_1_array_crystal_height = 0.020000;
double channel_5_analyzer_1_array_crystal_depth = 0.002000;
int channel_5_analyzer_1_array_number_of_crystals = 9;
double channel_5_analyzer_1_array_total_height = 0.180000;
double channel_5_analyzer_1_array_radius_of_curvature = 0.500000;
double channel_5_analyzer_1_array_effective_radius_of_curvature;
double channel_5_analyzer_1_array_theta_max;
double channel_5_analyzer_1_array_delta_theta;
double channel_5_analyzer_1_array_theta[9];
int channel_5_analyzer_1_array_iterate;
double channel_5_analyzer_2_array_crystal_width = 0.060000;
double channel_5_analyzer_2_array_crystal_height = 0.020000;
double channel_5_analyzer_2_array_crystal_depth = 0.002000;
int channel_5_analyzer_2_array_number_of_crystals = 9;
double channel_5_analyzer_2_array_total_height = 0.180000;
double channel_5_analyzer_2_array_radius_of_curvature = 0.500000;
double channel_5_analyzer_2_array_effective_radius_of_curvature;
double channel_5_analyzer_2_array_theta_max;
double channel_5_analyzer_2_array_delta_theta;
double channel_5_analyzer_2_array_theta[9];
int channel_5_analyzer_2_array_iterate;
double channel_6_analyzer_1_array_crystal_width = 0.060000;
double channel_6_analyzer_1_array_crystal_height = 0.020000;
double channel_6_analyzer_1_array_crystal_depth = 0.002000;
int channel_6_analyzer_1_array_number_of_crystals = 9;
double channel_6_analyzer_1_array_total_height = 0.180000;
double channel_6_analyzer_1_array_radius_of_curvature = 0.500000;
double channel_6_analyzer_1_array_effective_radius_of_curvature;
double channel_6_analyzer_1_array_theta_max;
double channel_6_analyzer_1_array_delta_theta;
double channel_6_analyzer_1_array_theta[9];
int channel_6_analyzer_1_array_iterate;
double channel_6_analyzer_2_array_crystal_width = 0.060000;
double channel_6_analyzer_2_array_crystal_height = 0.020000;
double channel_6_analyzer_2_array_crystal_depth = 0.002000;
int channel_6_analyzer_2_array_number_of_crystals = 9;
double channel_6_analyzer_2_array_total_height = 0.180000;
double channel_6_analyzer_2_array_radius_of_curvature = 0.500000;
double channel_6_analyzer_2_array_effective_radius_of_curvature;
double channel_6_analyzer_2_array_theta_max;
double channel_6_analyzer_2_array_delta_theta;
double channel_6_analyzer_2_array_theta[9];
int channel_6_analyzer_2_array_iterate;
double channel_7_analyzer_1_array_crystal_width = 0.060000;
double channel_7_analyzer_1_array_crystal_height = 0.020000;
double channel_7_analyzer_1_array_crystal_depth = 0.002000;
int channel_7_analyzer_1_array_number_of_crystals = 9;
double channel_7_analyzer_1_array_total_height = 0.180000;
double channel_7_analyzer_1_array_radius_of_curvature = 0.500000;
double channel_7_analyzer_1_array_effective_radius_of_curvature;
double channel_7_analyzer_1_array_theta_max;
double channel_7_analyzer_1_array_delta_theta;
double channel_7_analyzer_1_array_theta[9];
int channel_7_analyzer_1_array_iterate;
double channel_7_analyzer_2_array_crystal_width = 0.060000;
double channel_7_analyzer_2_array_crystal_height = 0.020000;
double channel_7_analyzer_2_array_crystal_depth = 0.002000;
int channel_7_analyzer_2_array_number_of_crystals = 9;
double channel_7_analyzer_2_array_total_height = 0.180000;
double channel_7_analyzer_2_array_radius_of_curvature = 0.500000;
double channel_7_analyzer_2_array_effective_radius_of_curvature;
double channel_7_analyzer_2_array_theta_max;
double channel_7_analyzer_2_array_delta_theta;
double channel_7_analyzer_2_array_theta[9];
int channel_7_analyzer_2_array_iterate;
double channel_8_analyzer_1_array_crystal_width = 0.060000;
double channel_8_analyzer_1_array_crystal_height = 0.020000;
double channel_8_analyzer_1_array_crystal_depth = 0.002000;
int channel_8_analyzer_1_array_number_of_crystals = 9;
double channel_8_analyzer_1_array_total_height = 0.180000;
double channel_8_analyzer_1_array_radius_of_curvature = 0.500000;
double channel_8_analyzer_1_array_effective_radius_of_curvature;
double channel_8_analyzer_1_array_theta_max;
double channel_8_analyzer_1_array_delta_theta;
double channel_8_analyzer_1_array_theta[9];
int channel_8_analyzer_1_array_iterate;
double channel_8_analyzer_2_array_crystal_width = 0.060000;
double channel_8_analyzer_2_array_crystal_height = 0.020000;
double channel_8_analyzer_2_array_crystal_depth = 0.002000;
int channel_8_analyzer_2_array_number_of_crystals = 9;
double channel_8_analyzer_2_array_total_height = 0.180000;
double channel_8_analyzer_2_array_radius_of_curvature = 0.500000;
double channel_8_analyzer_2_array_effective_radius_of_curvature;
double channel_8_analyzer_2_array_theta_max;
double channel_8_analyzer_2_array_delta_theta;
double channel_8_analyzer_2_array_theta[9];
int channel_8_analyzer_2_array_iterate;
double channel_9_analyzer_1_array_crystal_width = 0.060000;
double channel_9_analyzer_1_array_crystal_height = 0.020000;
double channel_9_analyzer_1_array_crystal_depth = 0.002000;
int channel_9_analyzer_1_array_number_of_crystals = 9;
double channel_9_analyzer_1_array_total_height = 0.180000;
double channel_9_analyzer_1_array_radius_of_curvature = 0.500000;
double channel_9_analyzer_1_array_effective_radius_of_curvature;
double channel_9_analyzer_1_array_theta_max;
double channel_9_analyzer_1_array_delta_theta;
double channel_9_analyzer_1_array_theta[9];
int channel_9_analyzer_1_array_iterate;
double channel_9_analyzer_2_array_crystal_width = 0.060000;
double channel_9_analyzer_2_array_crystal_height = 0.020000;
double channel_9_analyzer_2_array_crystal_depth = 0.002000;
int channel_9_analyzer_2_array_number_of_crystals = 9;
double channel_9_analyzer_2_array_total_height = 0.180000;
double channel_9_analyzer_2_array_radius_of_curvature = 0.500000;
double channel_9_analyzer_2_array_effective_radius_of_curvature;
double channel_9_analyzer_2_array_theta_max;
double channel_9_analyzer_2_array_delta_theta;
double channel_9_analyzer_2_array_theta[9];
int channel_9_analyzer_2_array_iterate;
double channel_10_analyzer_1_array_crystal_width = 0.060000;
double channel_10_analyzer_1_array_crystal_height = 0.020000;
double channel_10_analyzer_1_array_crystal_depth = 0.002000;
int channel_10_analyzer_1_array_number_of_crystals = 9;
double channel_10_analyzer_1_array_total_height = 0.180000;
double channel_10_analyzer_1_array_radius_of_curvature = 0.500000;
double channel_10_analyzer_1_array_effective_radius_of_curvature;
double channel_10_analyzer_1_array_theta_max;
double channel_10_analyzer_1_array_delta_theta;
double channel_10_analyzer_1_array_theta[9];
int channel_10_analyzer_1_array_iterate;
double channel_10_analyzer_2_array_crystal_width = 0.060000;
double channel_10_analyzer_2_array_crystal_height = 0.020000;
double channel_10_analyzer_2_array_crystal_depth = 0.002000;
int channel_10_analyzer_2_array_number_of_crystals = 9;
double channel_10_analyzer_2_array_total_height = 0.180000;
double channel_10_analyzer_2_array_radius_of_curvature = 0.500000;
double channel_10_analyzer_2_array_effective_radius_of_curvature;
double channel_10_analyzer_2_array_theta_max;
double channel_10_analyzer_2_array_delta_theta;
double channel_10_analyzer_2_array_theta[9];
int channel_10_analyzer_2_array_iterate;
double channel_11_analyzer_1_array_crystal_width = 0.060000;
double channel_11_analyzer_1_array_crystal_height = 0.020000;
double channel_11_analyzer_1_array_crystal_depth = 0.002000;
int channel_11_analyzer_1_array_number_of_crystals = 9;
double channel_11_analyzer_1_array_total_height = 0.180000;
double channel_11_analyzer_1_array_radius_of_curvature = 0.500000;
double channel_11_analyzer_1_array_effective_radius_of_curvature;
double channel_11_analyzer_1_array_theta_max;
double channel_11_analyzer_1_array_delta_theta;
double channel_11_analyzer_1_array_theta[9];
int channel_11_analyzer_1_array_iterate;
double channel_11_analyzer_2_array_crystal_width = 0.060000;
double channel_11_analyzer_2_array_crystal_height = 0.020000;
double channel_11_analyzer_2_array_crystal_depth = 0.002000;
int channel_11_analyzer_2_array_number_of_crystals = 9;
double channel_11_analyzer_2_array_total_height = 0.180000;
double channel_11_analyzer_2_array_radius_of_curvature = 0.500000;
double channel_11_analyzer_2_array_effective_radius_of_curvature;
double channel_11_analyzer_2_array_theta_max;
double channel_11_analyzer_2_array_delta_theta;
double channel_11_analyzer_2_array_theta[9];
int channel_11_analyzer_2_array_iterate;
double channel_12_analyzer_1_array_crystal_width = 0.060000;
double channel_12_analyzer_1_array_crystal_height = 0.020000;
double channel_12_analyzer_1_array_crystal_depth = 0.002000;
int channel_12_analyzer_1_array_number_of_crystals = 9;
double channel_12_analyzer_1_array_total_height = 0.180000;
double channel_12_analyzer_1_array_radius_of_curvature = 0.500000;
double channel_12_analyzer_1_array_effective_radius_of_curvature;
double channel_12_analyzer_1_array_theta_max;
double channel_12_analyzer_1_array_delta_theta;
double channel_12_analyzer_1_array_theta[9];
int channel_12_analyzer_1_array_iterate;
double channel_12_analyzer_2_array_crystal_width = 0.060000;
double channel_12_analyzer_2_array_crystal_height = 0.020000;
double channel_12_analyzer_2_array_crystal_depth = 0.002000;
int channel_12_analyzer_2_array_number_of_crystals = 9;
double channel_12_analyzer_2_array_total_height = 0.180000;
double channel_12_analyzer_2_array_radius_of_curvature = 0.500000;
double channel_12_analyzer_2_array_effective_radius_of_curvature;
double channel_12_analyzer_2_array_theta_max;
double channel_12_analyzer_2_array_delta_theta;
double channel_12_analyzer_2_array_theta[9];
int channel_12_analyzer_2_array_iterate;
double channel_13_analyzer_1_array_crystal_width = 0.060000;
double channel_13_analyzer_1_array_crystal_height = 0.020000;
double channel_13_analyzer_1_array_crystal_depth = 0.002000;
int channel_13_analyzer_1_array_number_of_crystals = 9;
double channel_13_analyzer_1_array_total_height = 0.180000;
double channel_13_analyzer_1_array_radius_of_curvature = 0.500000;
double channel_13_analyzer_1_array_effective_radius_of_curvature;
double channel_13_analyzer_1_array_theta_max;
double channel_13_analyzer_1_array_delta_theta;
double channel_13_analyzer_1_array_theta[9];
int channel_13_analyzer_1_array_iterate;
double channel_13_analyzer_2_array_crystal_width = 0.060000;
double channel_13_analyzer_2_array_crystal_height = 0.020000;
double channel_13_analyzer_2_array_crystal_depth = 0.002000;
int channel_13_analyzer_2_array_number_of_crystals = 9;
double channel_13_analyzer_2_array_total_height = 0.180000;
double channel_13_analyzer_2_array_radius_of_curvature = 0.500000;
double channel_13_analyzer_2_array_effective_radius_of_curvature;
double channel_13_analyzer_2_array_theta_max;
double channel_13_analyzer_2_array_delta_theta;
double channel_13_analyzer_2_array_theta[9];
int channel_13_analyzer_2_array_iterate;
double channel_14_analyzer_1_array_crystal_width = 0.060000;
double channel_14_analyzer_1_array_crystal_height = 0.020000;
double channel_14_analyzer_1_array_crystal_depth = 0.002000;
int channel_14_analyzer_1_array_number_of_crystals = 9;
double channel_14_analyzer_1_array_total_height = 0.180000;
double channel_14_analyzer_1_array_radius_of_curvature = 0.500000;
double channel_14_analyzer_1_array_effective_radius_of_curvature;
double channel_14_analyzer_1_array_theta_max;
double channel_14_analyzer_1_array_delta_theta;
double channel_14_analyzer_1_array_theta[9];
int channel_14_analyzer_1_array_iterate;
double channel_14_analyzer_2_array_crystal_width = 0.060000;
double channel_14_analyzer_2_array_crystal_height = 0.020000;
double channel_14_analyzer_2_array_crystal_depth = 0.002000;
int channel_14_analyzer_2_array_number_of_crystals = 9;
double channel_14_analyzer_2_array_total_height = 0.180000;
double channel_14_analyzer_2_array_radius_of_curvature = 0.500000;
double channel_14_analyzer_2_array_effective_radius_of_curvature;
double channel_14_analyzer_2_array_theta_max;
double channel_14_analyzer_2_array_delta_theta;
double channel_14_analyzer_2_array_theta[9];
int channel_14_analyzer_2_array_iterate;
double channel_15_analyzer_1_array_crystal_width = 0.060000;
double channel_15_analyzer_1_array_crystal_height = 0.020000;
double channel_15_analyzer_1_array_crystal_depth = 0.002000;
int channel_15_analyzer_1_array_number_of_crystals = 9;
double channel_15_analyzer_1_array_total_height = 0.180000;
double channel_15_analyzer_1_array_radius_of_curvature = 0.500000;
double channel_15_analyzer_1_array_effective_radius_of_curvature;
double channel_15_analyzer_1_array_theta_max;
double channel_15_analyzer_1_array_delta_theta;
double channel_15_analyzer_1_array_theta[9];
int channel_15_analyzer_1_array_iterate;
double channel_15_analyzer_2_array_crystal_width = 0.060000;
double channel_15_analyzer_2_array_crystal_height = 0.020000;
double channel_15_analyzer_2_array_crystal_depth = 0.002000;
int channel_15_analyzer_2_array_number_of_crystals = 9;
double channel_15_analyzer_2_array_total_height = 0.180000;
double channel_15_analyzer_2_array_radius_of_curvature = 0.500000;
double channel_15_analyzer_2_array_effective_radius_of_curvature;
double channel_15_analyzer_2_array_theta_max;
double channel_15_analyzer_2_array_delta_theta;
double channel_15_analyzer_2_array_theta[9];
int channel_15_analyzer_2_array_iterate;
double channel_16_analyzer_1_array_crystal_width = 0.060000;
double channel_16_analyzer_1_array_crystal_height = 0.020000;
double channel_16_analyzer_1_array_crystal_depth = 0.002000;
int channel_16_analyzer_1_array_number_of_crystals = 9;
double channel_16_analyzer_1_array_total_height = 0.180000;
double channel_16_analyzer_1_array_radius_of_curvature = 0.500000;
double channel_16_analyzer_1_array_effective_radius_of_curvature;
double channel_16_analyzer_1_array_theta_max;
double channel_16_analyzer_1_array_delta_theta;
double channel_16_analyzer_1_array_theta[9];
int channel_16_analyzer_1_array_iterate;
double channel_16_analyzer_2_array_crystal_width = 0.060000;
double channel_16_analyzer_2_array_crystal_height = 0.020000;
double channel_16_analyzer_2_array_crystal_depth = 0.002000;
int channel_16_analyzer_2_array_number_of_crystals = 9;
double channel_16_analyzer_2_array_total_height = 0.180000;
double channel_16_analyzer_2_array_radius_of_curvature = 0.500000;
double channel_16_analyzer_2_array_effective_radius_of_curvature;
double channel_16_analyzer_2_array_theta_max;
double channel_16_analyzer_2_array_delta_theta;
double channel_16_analyzer_2_array_theta[9];
int channel_16_analyzer_2_array_iterate;
double channel_17_analyzer_1_array_crystal_width = 0.060000;
double channel_17_analyzer_1_array_crystal_height = 0.020000;
double channel_17_analyzer_1_array_crystal_depth = 0.002000;
int channel_17_analyzer_1_array_number_of_crystals = 9;
double channel_17_analyzer_1_array_total_height = 0.180000;
double channel_17_analyzer_1_array_radius_of_curvature = 0.500000;
double channel_17_analyzer_1_array_effective_radius_of_curvature;
double channel_17_analyzer_1_array_theta_max;
double channel_17_analyzer_1_array_delta_theta;
double channel_17_analyzer_1_array_theta[9];
int channel_17_analyzer_1_array_iterate;
double channel_17_analyzer_2_array_crystal_width = 0.060000;
double channel_17_analyzer_2_array_crystal_height = 0.020000;
double channel_17_analyzer_2_array_crystal_depth = 0.002000;
int channel_17_analyzer_2_array_number_of_crystals = 9;
double channel_17_analyzer_2_array_total_height = 0.180000;
double channel_17_analyzer_2_array_radius_of_curvature = 0.500000;
double channel_17_analyzer_2_array_effective_radius_of_curvature;
double channel_17_analyzer_2_array_theta_max;
double channel_17_analyzer_2_array_delta_theta;
double channel_17_analyzer_2_array_theta[9];
int channel_17_analyzer_2_array_iterate;
double channel_18_analyzer_1_array_crystal_width = 0.060000;
double channel_18_analyzer_1_array_crystal_height = 0.020000;
double channel_18_analyzer_1_array_crystal_depth = 0.002000;
int channel_18_analyzer_1_array_number_of_crystals = 9;
double channel_18_analyzer_1_array_total_height = 0.180000;
double channel_18_analyzer_1_array_radius_of_curvature = 0.500000;
double channel_18_analyzer_1_array_effective_radius_of_curvature;
double channel_18_analyzer_1_array_theta_max;
double channel_18_analyzer_1_array_delta_theta;
double channel_18_analyzer_1_array_theta[9];
int channel_18_analyzer_1_array_iterate;
double channel_18_analyzer_2_array_crystal_width = 0.060000;
double channel_18_analyzer_2_array_crystal_height = 0.020000;
double channel_18_analyzer_2_array_crystal_depth = 0.002000;
int channel_18_analyzer_2_array_number_of_crystals = 9;
double channel_18_analyzer_2_array_total_height = 0.180000;
double channel_18_analyzer_2_array_radius_of_curvature = 0.500000;
double channel_18_analyzer_2_array_effective_radius_of_curvature;
double channel_18_analyzer_2_array_theta_max;
double channel_18_analyzer_2_array_delta_theta;
double channel_18_analyzer_2_array_theta[9];
int channel_18_analyzer_2_array_iterate;
double channel_19_analyzer_1_array_crystal_width = 0.060000;
double channel_19_analyzer_1_array_crystal_height = 0.020000;
double channel_19_analyzer_1_array_crystal_depth = 0.002000;
int channel_19_analyzer_1_array_number_of_crystals = 9;
double channel_19_analyzer_1_array_total_height = 0.180000;
double channel_19_analyzer_1_array_radius_of_curvature = 0.500000;
double channel_19_analyzer_1_array_effective_radius_of_curvature;
double channel_19_analyzer_1_array_theta_max;
double channel_19_analyzer_1_array_delta_theta;
double channel_19_analyzer_1_array_theta[9];
int channel_19_analyzer_1_array_iterate;
double channel_19_analyzer_2_array_crystal_width = 0.060000;
double channel_19_analyzer_2_array_crystal_height = 0.020000;
double channel_19_analyzer_2_array_crystal_depth = 0.002000;
int channel_19_analyzer_2_array_number_of_crystals = 9;
double channel_19_analyzer_2_array_total_height = 0.180000;
double channel_19_analyzer_2_array_radius_of_curvature = 0.500000;
double channel_19_analyzer_2_array_effective_radius_of_curvature;
double channel_19_analyzer_2_array_theta_max;
double channel_19_analyzer_2_array_delta_theta;
double channel_19_analyzer_2_array_theta[9];
int channel_19_analyzer_2_array_iterate;
int detector_channel_diff;
int detector_channel_spec;
int nx_detector = 5;
int ny_detector = 5;
int detector_found;
int flag_sum;
int flag_single;
int flag_sum;
int flag_single;
int flag_sum;
int flag_single;
int flag_sum;
int flag_single;
int flag_sum;
int flag_single;
int flag_sum;
int flag_single;
int flag_sum;
int flag_single;
int flag_sum;
int flag_single;
int flag_sum;
int flag_single;
int flag_sum;
int flag_single;
int flag_sum;
int flag_single;
int flag_sum;
int flag_single;
int flag_sum;
int flag_single;
int flag_sum;
int flag_single;
int flag_sum;
int flag_single;
int flag_sum;
int flag_single;
int flag_sum;
int flag_single;
int flag_sum;
int flag_single;
int flag_sum;
int flag_single;
int flag_sum;
int flag_single;


/**** Defining reflectivity vectors  ******/

/**** Virtual output/input ****/
  char virtual_file_name[2048];

/***spline calculation ***/

/* Analyzators */
int iterate;
double analyzator_theta[20];
double delta_analyzator_position[20];
double distance_between_analyzators[20];
double EF[20];

double analyzator_1_radius;
double analyzator_2_radius;
double analyzator_depth;
double number_of_analyzator_blades;
double analyzator_horizontal_mosaic;
double analyzator_vertical_mosaic;
double analyzator_dirdev;
double analyzator_r0;
double analyzator_q;
double analyzator_transverse_distance;
double sample_analyzator_channel_distance;
double detector_analyzator_center_distance;

int analyzator_flag;
int channel_number;

/* ** nD ** */

// Sample environment
double stick_displacement;

// Flags

int scatter_events_in_sample;
int scatter_events_in_sample_environment;
int only_sample_scattering;

int flag_index;
// Update 50 if we go beyond 49 volumes in sample/sample environment
int scattering_history_sample_master[MAX_VOLUME_HISTORY_LENGTH];
int number_of_volumes_sample_main;

// Resolution mode
// When resolution_mode == 1, the system
int number_of_activations_normal;
int number_of_activations_exit;
int number_of_activations_sample;

// Temp test
int E_off;
double E,vlength;


#line 11474 "MACS_sample_kidney_box.c"
#undef dE_resolution
#undef E0_resolution
#undef repeat_count
#undef res_height
#undef res_radius
#undef resolution_mode
#undef slit_v
#undef slit_h
#undef monrot_delta
#undef mon_e
#undef mon_t
#undef L1_delta
#undef L0_delta
#undef DIVSOU
#undef DIRDEV
#undef misalign_mono_deg
#undef APE_v
#undef APE_h
#undef MPD
#undef MPL
#undef CPF
#undef beta_2
#undef beta_1
#undef sample_diameter_d
#undef VF
#undef HF
#undef EF_all
#undef EM
#undef kidney_angle
#undef A3_angle
#undef mcposadmtas
#undef mccompcurindex
#undef mccompcurtype
#undef mccompcurname

/* neutron state table at each component input (local coords) */
/* [x, y, z, vx, vy, vz, t, sx, sy, sz, p] */
MCNUM mccomp_storein[11*946];
/* Components position table (absolute and relative coords) */
Coords mccomp_posa[946];
Coords mccomp_posr[946];
/* Counter for each comp to check for inactive ones */
MCNUM  mcNCounter[946];
MCNUM  mcPCounter[946];
MCNUM  mcP2Counter[946];
#define mcNUMCOMP 945 /* number of components */
/* Counter for PROP ABSORB */
MCNUM  mcAbsorbProp[946];
/* Flag true when previous component acted on the neutron (SCATTER) */
MCNUM mcScattered=0;
/* Flag true when neutron should be restored (RESTORE) */
MCNUM mcRestore=0;
/* Component group definitions (flags), equals index of scattering comp */
int mcGroupfilter_group=0;
int mcGroupdetector_group=0;
/* Declarations of component definition and setting parameters. */

/* Setting parameters for component 'Al_incoherent' [1]. */
MCNUM mccAl_incoherent_sigma;
MCNUM mccAl_incoherent_f_QE;
MCNUM mccAl_incoherent_gamma;
MCNUM mccAl_incoherent_packing_factor;
MCNUM mccAl_incoherent_unit_cell_volume;
MCNUM mccAl_incoherent_interact_fraction;

/* Definition parameters for component 'Al_powder' [2]. */
#define mccAl_powder_format Undefined
/* Setting parameters for component 'Al_powder' [2]. */
char mccAl_powder_reflections[16384];
MCNUM mccAl_powder_packing_factor;
MCNUM mccAl_powder_Vc;
MCNUM mccAl_powder_delta_d_d;
MCNUM mccAl_powder_DW;
MCNUM mccAl_powder_nb_atoms;
MCNUM mccAl_powder_d_phi;
MCNUM mccAl_powder_density;
MCNUM mccAl_powder_weight;
MCNUM mccAl_powder_barns;
MCNUM mccAl_powder_Strain;
MCNUM mccAl_powder_interact_fraction;

/* Setting parameters for component 'Al' [3]. */
char mccAl_process_string[16384];
MCNUM mccAl_my_absorption;
MCNUM mccAl_absorber;

/* Setting parameters for component 'TiO2_incoherent' [4]. */
MCNUM mccTiO2_incoherent_sigma;
MCNUM mccTiO2_incoherent_f_QE;
MCNUM mccTiO2_incoherent_gamma;
MCNUM mccTiO2_incoherent_packing_factor;
MCNUM mccTiO2_incoherent_unit_cell_volume;
MCNUM mccTiO2_incoherent_interact_fraction;

/* Definition parameters for component 'TiO2_single_crystal' [5]. */
#define mccTiO2_single_crystal_mosaic_AB Mosaic_AB_Undefined
/* Setting parameters for component 'TiO2_single_crystal' [5]. */
char mccTiO2_single_crystal_reflections[16384];
MCNUM mccTiO2_single_crystal_delta_d_d;
MCNUM mccTiO2_single_crystal_mosaic;
MCNUM mccTiO2_single_crystal_mosaic_a;
MCNUM mccTiO2_single_crystal_mosaic_b;
MCNUM mccTiO2_single_crystal_mosaic_c;
MCNUM mccTiO2_single_crystal_recip_cell;
MCNUM mccTiO2_single_crystal_barns;
MCNUM mccTiO2_single_crystal_ax;
MCNUM mccTiO2_single_crystal_ay;
MCNUM mccTiO2_single_crystal_az;
MCNUM mccTiO2_single_crystal_bx;
MCNUM mccTiO2_single_crystal_by;
MCNUM mccTiO2_single_crystal_bz;
MCNUM mccTiO2_single_crystal_cx;
MCNUM mccTiO2_single_crystal_cy;
MCNUM mccTiO2_single_crystal_cz;
MCNUM mccTiO2_single_crystal_aa;
MCNUM mccTiO2_single_crystal_bb;
MCNUM mccTiO2_single_crystal_cc;
MCNUM mccTiO2_single_crystal_order;
MCNUM mccTiO2_single_crystal_RX;
MCNUM mccTiO2_single_crystal_RY;
MCNUM mccTiO2_single_crystal_RZ;
MCNUM mccTiO2_single_crystal_powder;
MCNUM mccTiO2_single_crystal_PG;
MCNUM mccTiO2_single_crystal_interact_fraction;
MCNUM mccTiO2_single_crystal_packing_factor;

/* Setting parameters for component 'TiO2' [6]. */
char mccTiO2_process_string[16384];
MCNUM mccTiO2_my_absorption;
MCNUM mccTiO2_absorber;

/* Setting parameters for component 'TiO2_poly_incoherent' [7]. */
MCNUM mccTiO2_poly_incoherent_sigma;
MCNUM mccTiO2_poly_incoherent_f_QE;
MCNUM mccTiO2_poly_incoherent_gamma;
MCNUM mccTiO2_poly_incoherent_packing_factor;
MCNUM mccTiO2_poly_incoherent_unit_cell_volume;
MCNUM mccTiO2_poly_incoherent_interact_fraction;

/* Setting parameters for component 'TiO2_poly' [8]. */
char mccTiO2_poly_process_string[16384];
MCNUM mccTiO2_poly_my_absorption;
MCNUM mccTiO2_poly_absorber;

/* Setting parameters for component 'Al_incoherent_B' [9]. */
MCNUM mccAl_incoherent_B_sigma;
MCNUM mccAl_incoherent_B_f_QE;
MCNUM mccAl_incoherent_B_gamma;
MCNUM mccAl_incoherent_B_packing_factor;
MCNUM mccAl_incoherent_B_unit_cell_volume;
MCNUM mccAl_incoherent_B_interact_fraction;

/* Definition parameters for component 'Al_powder_B' [10]. */
#define mccAl_powder_B_format Undefined
/* Setting parameters for component 'Al_powder_B' [10]. */
char mccAl_powder_B_reflections[16384];
MCNUM mccAl_powder_B_packing_factor;
MCNUM mccAl_powder_B_Vc;
MCNUM mccAl_powder_B_delta_d_d;
MCNUM mccAl_powder_B_DW;
MCNUM mccAl_powder_B_nb_atoms;
MCNUM mccAl_powder_B_d_phi;
MCNUM mccAl_powder_B_density;
MCNUM mccAl_powder_B_weight;
MCNUM mccAl_powder_B_barns;
MCNUM mccAl_powder_B_Strain;
MCNUM mccAl_powder_B_interact_fraction;

/* Setting parameters for component 'Al_B' [11]. */
char mccAl_B_process_string[16384];
MCNUM mccAl_B_my_absorption;
MCNUM mccAl_B_absorber;

/* Setting parameters for component 'Arm0' [12]. */
char mccArm0_profile[16384];
MCNUM mccArm0_percent;
MCNUM mccArm0_flag_save;
MCNUM mccArm0_minutes;

/* Setting parameters for component 'Guide_end' [13]. */
char mccGuide_end_filename[16384];
MCNUM mccGuide_end_verbose;
MCNUM mccGuide_end_repeat_count;
MCNUM mccGuide_end_smooth;
MCNUM mccGuide_end_display;

/* Setting parameters for component 'main_slit' [14]. */
MCNUM mccmain_slit_xmin;
MCNUM mccmain_slit_xmax;
MCNUM mccmain_slit_ymin;
MCNUM mccmain_slit_ymax;
MCNUM mccmain_slit_radius;
MCNUM mccmain_slit_xwidth;
MCNUM mccmain_slit_yheight;

/* Setting parameters for component 'sample' [20]. */
char mccsample_material_string[16384];
MCNUM mccsample_priority;
MCNUM mccsample_xwidth;
MCNUM mccsample_yheight;
MCNUM mccsample_zdepth;
MCNUM mccsample_xwidth2;
MCNUM mccsample_yheight2;
MCNUM mccsample_visualize;
int mccsample_target_index;
MCNUM mccsample_target_x;
MCNUM mccsample_target_y;
MCNUM mccsample_target_z;
MCNUM mccsample_focus_aw;
MCNUM mccsample_focus_ah;
MCNUM mccsample_focus_xw;
MCNUM mccsample_focus_xh;
MCNUM mccsample_focus_r;
MCNUM mccsample_p_interact;
char mccsample_mask_string[16384];
char mccsample_mask_setting[16384];
MCNUM mccsample_number_of_activations;

/* Setting parameters for component 'sample_plate' [21]. */
char mccsample_plate_material_string[16384];
MCNUM mccsample_plate_priority;
MCNUM mccsample_plate_radius;
MCNUM mccsample_plate_yheight;
MCNUM mccsample_plate_visualize;
int mccsample_plate_target_index;
MCNUM mccsample_plate_target_x;
MCNUM mccsample_plate_target_y;
MCNUM mccsample_plate_target_z;
MCNUM mccsample_plate_focus_aw;
MCNUM mccsample_plate_focus_ah;
MCNUM mccsample_plate_focus_xw;
MCNUM mccsample_plate_focus_xh;
MCNUM mccsample_plate_focus_r;
MCNUM mccsample_plate_p_interact;
char mccsample_plate_mask_string[16384];
char mccsample_plate_mask_setting[16384];
MCNUM mccsample_plate_number_of_activations;

/* Setting parameters for component 'sample_plate_rod' [22]. */
char mccsample_plate_rod_material_string[16384];
MCNUM mccsample_plate_rod_priority;
MCNUM mccsample_plate_rod_radius;
MCNUM mccsample_plate_rod_yheight;
MCNUM mccsample_plate_rod_visualize;
int mccsample_plate_rod_target_index;
MCNUM mccsample_plate_rod_target_x;
MCNUM mccsample_plate_rod_target_y;
MCNUM mccsample_plate_rod_target_z;
MCNUM mccsample_plate_rod_focus_aw;
MCNUM mccsample_plate_rod_focus_ah;
MCNUM mccsample_plate_rod_focus_xw;
MCNUM mccsample_plate_rod_focus_xh;
MCNUM mccsample_plate_rod_focus_r;
MCNUM mccsample_plate_rod_p_interact;
char mccsample_plate_rod_mask_string[16384];
char mccsample_plate_rod_mask_setting[16384];
MCNUM mccsample_plate_rod_number_of_activations;

/* Setting parameters for component 'sample_base' [23]. */
char mccsample_base_material_string[16384];
MCNUM mccsample_base_priority;
MCNUM mccsample_base_radius;
MCNUM mccsample_base_yheight;
MCNUM mccsample_base_visualize;
int mccsample_base_target_index;
MCNUM mccsample_base_target_x;
MCNUM mccsample_base_target_y;
MCNUM mccsample_base_target_z;
MCNUM mccsample_base_focus_aw;
MCNUM mccsample_base_focus_ah;
MCNUM mccsample_base_focus_xw;
MCNUM mccsample_base_focus_xh;
MCNUM mccsample_base_focus_r;
MCNUM mccsample_base_p_interact;
char mccsample_base_mask_string[16384];
char mccsample_base_mask_setting[16384];
MCNUM mccsample_base_number_of_activations;

/* Setting parameters for component 'sample_base_gap' [24]. */
char mccsample_base_gap_material_string[16384];
MCNUM mccsample_base_gap_priority;
MCNUM mccsample_base_gap_radius;
MCNUM mccsample_base_gap_yheight;
MCNUM mccsample_base_gap_visualize;
int mccsample_base_gap_target_index;
MCNUM mccsample_base_gap_target_x;
MCNUM mccsample_base_gap_target_y;
MCNUM mccsample_base_gap_target_z;
MCNUM mccsample_base_gap_focus_aw;
MCNUM mccsample_base_gap_focus_ah;
MCNUM mccsample_base_gap_focus_xw;
MCNUM mccsample_base_gap_focus_xh;
MCNUM mccsample_base_gap_focus_r;
MCNUM mccsample_base_gap_p_interact;
char mccsample_base_gap_mask_string[16384];
char mccsample_base_gap_mask_setting[16384];
MCNUM mccsample_base_gap_number_of_activations;

/* Setting parameters for component 'cryostat_mountin_plate' [25]. */
char mcccryostat_mountin_plate_material_string[16384];
MCNUM mcccryostat_mountin_plate_priority;
MCNUM mcccryostat_mountin_plate_radius;
MCNUM mcccryostat_mountin_plate_yheight;
MCNUM mcccryostat_mountin_plate_visualize;
int mcccryostat_mountin_plate_target_index;
MCNUM mcccryostat_mountin_plate_target_x;
MCNUM mcccryostat_mountin_plate_target_y;
MCNUM mcccryostat_mountin_plate_target_z;
MCNUM mcccryostat_mountin_plate_focus_aw;
MCNUM mcccryostat_mountin_plate_focus_ah;
MCNUM mcccryostat_mountin_plate_focus_xw;
MCNUM mcccryostat_mountin_plate_focus_xh;
MCNUM mcccryostat_mountin_plate_focus_r;
MCNUM mcccryostat_mountin_plate_p_interact;
char mcccryostat_mountin_plate_mask_string[16384];
char mcccryostat_mountin_plate_mask_setting[16384];
MCNUM mcccryostat_mountin_plate_number_of_activations;

/* Setting parameters for component 'cryostat_drum_walls' [26]. */
char mcccryostat_drum_walls_material_string[16384];
MCNUM mcccryostat_drum_walls_priority;
MCNUM mcccryostat_drum_walls_radius;
MCNUM mcccryostat_drum_walls_yheight;
MCNUM mcccryostat_drum_walls_visualize;
int mcccryostat_drum_walls_target_index;
MCNUM mcccryostat_drum_walls_target_x;
MCNUM mcccryostat_drum_walls_target_y;
MCNUM mcccryostat_drum_walls_target_z;
MCNUM mcccryostat_drum_walls_focus_aw;
MCNUM mcccryostat_drum_walls_focus_ah;
MCNUM mcccryostat_drum_walls_focus_xw;
MCNUM mcccryostat_drum_walls_focus_xh;
MCNUM mcccryostat_drum_walls_focus_r;
MCNUM mcccryostat_drum_walls_p_interact;
char mcccryostat_drum_walls_mask_string[16384];
char mcccryostat_drum_walls_mask_setting[16384];
MCNUM mcccryostat_drum_walls_number_of_activations;

/* Setting parameters for component 'cryostat_drum_vacuum' [27]. */
char mcccryostat_drum_vacuum_material_string[16384];
MCNUM mcccryostat_drum_vacuum_priority;
MCNUM mcccryostat_drum_vacuum_radius;
MCNUM mcccryostat_drum_vacuum_yheight;
MCNUM mcccryostat_drum_vacuum_visualize;
int mcccryostat_drum_vacuum_target_index;
MCNUM mcccryostat_drum_vacuum_target_x;
MCNUM mcccryostat_drum_vacuum_target_y;
MCNUM mcccryostat_drum_vacuum_target_z;
MCNUM mcccryostat_drum_vacuum_focus_aw;
MCNUM mcccryostat_drum_vacuum_focus_ah;
MCNUM mcccryostat_drum_vacuum_focus_xw;
MCNUM mcccryostat_drum_vacuum_focus_xh;
MCNUM mcccryostat_drum_vacuum_focus_r;
MCNUM mcccryostat_drum_vacuum_p_interact;
char mcccryostat_drum_vacuum_mask_string[16384];
char mcccryostat_drum_vacuum_mask_setting[16384];
MCNUM mcccryostat_drum_vacuum_number_of_activations;

/* Setting parameters for component 'outer_cryostat_wall' [28]. */
char mccouter_cryostat_wall_material_string[16384];
MCNUM mccouter_cryostat_wall_priority;
MCNUM mccouter_cryostat_wall_radius;
MCNUM mccouter_cryostat_wall_yheight;
MCNUM mccouter_cryostat_wall_visualize;
int mccouter_cryostat_wall_target_index;
MCNUM mccouter_cryostat_wall_target_x;
MCNUM mccouter_cryostat_wall_target_y;
MCNUM mccouter_cryostat_wall_target_z;
MCNUM mccouter_cryostat_wall_focus_aw;
MCNUM mccouter_cryostat_wall_focus_ah;
MCNUM mccouter_cryostat_wall_focus_xw;
MCNUM mccouter_cryostat_wall_focus_xh;
MCNUM mccouter_cryostat_wall_focus_r;
MCNUM mccouter_cryostat_wall_p_interact;
char mccouter_cryostat_wall_mask_string[16384];
char mccouter_cryostat_wall_mask_setting[16384];
MCNUM mccouter_cryostat_wall_number_of_activations;

/* Setting parameters for component 'outer_cryostat_vacuum' [29]. */
char mccouter_cryostat_vacuum_material_string[16384];
MCNUM mccouter_cryostat_vacuum_priority;
MCNUM mccouter_cryostat_vacuum_radius;
MCNUM mccouter_cryostat_vacuum_yheight;
MCNUM mccouter_cryostat_vacuum_visualize;
int mccouter_cryostat_vacuum_target_index;
MCNUM mccouter_cryostat_vacuum_target_x;
MCNUM mccouter_cryostat_vacuum_target_y;
MCNUM mccouter_cryostat_vacuum_target_z;
MCNUM mccouter_cryostat_vacuum_focus_aw;
MCNUM mccouter_cryostat_vacuum_focus_ah;
MCNUM mccouter_cryostat_vacuum_focus_xw;
MCNUM mccouter_cryostat_vacuum_focus_xh;
MCNUM mccouter_cryostat_vacuum_focus_r;
MCNUM mccouter_cryostat_vacuum_p_interact;
char mccouter_cryostat_vacuum_mask_string[16384];
char mccouter_cryostat_vacuum_mask_setting[16384];
MCNUM mccouter_cryostat_vacuum_number_of_activations;

/* Setting parameters for component 'inner_cryostat_wall' [30]. */
char mccinner_cryostat_wall_material_string[16384];
MCNUM mccinner_cryostat_wall_priority;
MCNUM mccinner_cryostat_wall_radius;
MCNUM mccinner_cryostat_wall_yheight;
MCNUM mccinner_cryostat_wall_visualize;
int mccinner_cryostat_wall_target_index;
MCNUM mccinner_cryostat_wall_target_x;
MCNUM mccinner_cryostat_wall_target_y;
MCNUM mccinner_cryostat_wall_target_z;
MCNUM mccinner_cryostat_wall_focus_aw;
MCNUM mccinner_cryostat_wall_focus_ah;
MCNUM mccinner_cryostat_wall_focus_xw;
MCNUM mccinner_cryostat_wall_focus_xh;
MCNUM mccinner_cryostat_wall_focus_r;
MCNUM mccinner_cryostat_wall_p_interact;
char mccinner_cryostat_wall_mask_string[16384];
char mccinner_cryostat_wall_mask_setting[16384];
MCNUM mccinner_cryostat_wall_number_of_activations;

/* Setting parameters for component 'inner_cryostat_vacuum' [31]. */
char mccinner_cryostat_vacuum_material_string[16384];
MCNUM mccinner_cryostat_vacuum_priority;
MCNUM mccinner_cryostat_vacuum_radius;
MCNUM mccinner_cryostat_vacuum_yheight;
MCNUM mccinner_cryostat_vacuum_visualize;
int mccinner_cryostat_vacuum_target_index;
MCNUM mccinner_cryostat_vacuum_target_x;
MCNUM mccinner_cryostat_vacuum_target_y;
MCNUM mccinner_cryostat_vacuum_target_z;
MCNUM mccinner_cryostat_vacuum_focus_aw;
MCNUM mccinner_cryostat_vacuum_focus_ah;
MCNUM mccinner_cryostat_vacuum_focus_xw;
MCNUM mccinner_cryostat_vacuum_focus_xh;
MCNUM mccinner_cryostat_vacuum_focus_r;
MCNUM mccinner_cryostat_vacuum_p_interact;
char mccinner_cryostat_vacuum_mask_string[16384];
char mccinner_cryostat_vacuum_mask_setting[16384];
MCNUM mccinner_cryostat_vacuum_number_of_activations;

/* Setting parameters for component 'sample_stick_walls' [32]. */
char mccsample_stick_walls_material_string[16384];
MCNUM mccsample_stick_walls_priority;
MCNUM mccsample_stick_walls_radius;
MCNUM mccsample_stick_walls_yheight;
MCNUM mccsample_stick_walls_visualize;
int mccsample_stick_walls_target_index;
MCNUM mccsample_stick_walls_target_x;
MCNUM mccsample_stick_walls_target_y;
MCNUM mccsample_stick_walls_target_z;
MCNUM mccsample_stick_walls_focus_aw;
MCNUM mccsample_stick_walls_focus_ah;
MCNUM mccsample_stick_walls_focus_xw;
MCNUM mccsample_stick_walls_focus_xh;
MCNUM mccsample_stick_walls_focus_r;
MCNUM mccsample_stick_walls_p_interact;
char mccsample_stick_walls_mask_string[16384];
char mccsample_stick_walls_mask_setting[16384];
MCNUM mccsample_stick_walls_number_of_activations;

/* Setting parameters for component 'sample_stick_vacuum' [33]. */
char mccsample_stick_vacuum_material_string[16384];
MCNUM mccsample_stick_vacuum_priority;
MCNUM mccsample_stick_vacuum_radius;
MCNUM mccsample_stick_vacuum_yheight;
MCNUM mccsample_stick_vacuum_visualize;
int mccsample_stick_vacuum_target_index;
MCNUM mccsample_stick_vacuum_target_x;
MCNUM mccsample_stick_vacuum_target_y;
MCNUM mccsample_stick_vacuum_target_z;
MCNUM mccsample_stick_vacuum_focus_aw;
MCNUM mccsample_stick_vacuum_focus_ah;
MCNUM mccsample_stick_vacuum_focus_xw;
MCNUM mccsample_stick_vacuum_focus_xh;
MCNUM mccsample_stick_vacuum_focus_r;
MCNUM mccsample_stick_vacuum_p_interact;
char mccsample_stick_vacuum_mask_string[16384];
char mccsample_stick_vacuum_mask_setting[16384];
MCNUM mccsample_stick_vacuum_number_of_activations;

/* Setting parameters for component 'sample_rod' [35]. */
char mccsample_rod_material_string[16384];
MCNUM mccsample_rod_priority;
MCNUM mccsample_rod_radius;
MCNUM mccsample_rod_yheight;
MCNUM mccsample_rod_visualize;
int mccsample_rod_target_index;
MCNUM mccsample_rod_target_x;
MCNUM mccsample_rod_target_y;
MCNUM mccsample_rod_target_z;
MCNUM mccsample_rod_focus_aw;
MCNUM mccsample_rod_focus_ah;
MCNUM mccsample_rod_focus_xw;
MCNUM mccsample_rod_focus_xh;
MCNUM mccsample_rod_focus_r;
MCNUM mccsample_rod_p_interact;
char mccsample_rod_mask_string[16384];
char mccsample_rod_mask_setting[16384];
MCNUM mccsample_rod_number_of_activations;

/* Setting parameters for component 'sample_rod_collar_1' [36]. */
char mccsample_rod_collar_1_material_string[16384];
MCNUM mccsample_rod_collar_1_priority;
MCNUM mccsample_rod_collar_1_radius;
MCNUM mccsample_rod_collar_1_yheight;
MCNUM mccsample_rod_collar_1_visualize;
int mccsample_rod_collar_1_target_index;
MCNUM mccsample_rod_collar_1_target_x;
MCNUM mccsample_rod_collar_1_target_y;
MCNUM mccsample_rod_collar_1_target_z;
MCNUM mccsample_rod_collar_1_focus_aw;
MCNUM mccsample_rod_collar_1_focus_ah;
MCNUM mccsample_rod_collar_1_focus_xw;
MCNUM mccsample_rod_collar_1_focus_xh;
MCNUM mccsample_rod_collar_1_focus_r;
MCNUM mccsample_rod_collar_1_p_interact;
char mccsample_rod_collar_1_mask_string[16384];
char mccsample_rod_collar_1_mask_setting[16384];
MCNUM mccsample_rod_collar_1_number_of_activations;

/* Setting parameters for component 'sample_rod_collar_2' [37]. */
char mccsample_rod_collar_2_material_string[16384];
MCNUM mccsample_rod_collar_2_priority;
MCNUM mccsample_rod_collar_2_radius;
MCNUM mccsample_rod_collar_2_yheight;
MCNUM mccsample_rod_collar_2_visualize;
int mccsample_rod_collar_2_target_index;
MCNUM mccsample_rod_collar_2_target_x;
MCNUM mccsample_rod_collar_2_target_y;
MCNUM mccsample_rod_collar_2_target_z;
MCNUM mccsample_rod_collar_2_focus_aw;
MCNUM mccsample_rod_collar_2_focus_ah;
MCNUM mccsample_rod_collar_2_focus_xw;
MCNUM mccsample_rod_collar_2_focus_xh;
MCNUM mccsample_rod_collar_2_focus_r;
MCNUM mccsample_rod_collar_2_p_interact;
char mccsample_rod_collar_2_mask_string[16384];
char mccsample_rod_collar_2_mask_setting[16384];
MCNUM mccsample_rod_collar_2_number_of_activations;

/* Setting parameters for component 'sample_rod_collar_3' [38]. */
char mccsample_rod_collar_3_material_string[16384];
MCNUM mccsample_rod_collar_3_priority;
MCNUM mccsample_rod_collar_3_radius;
MCNUM mccsample_rod_collar_3_yheight;
MCNUM mccsample_rod_collar_3_visualize;
int mccsample_rod_collar_3_target_index;
MCNUM mccsample_rod_collar_3_target_x;
MCNUM mccsample_rod_collar_3_target_y;
MCNUM mccsample_rod_collar_3_target_z;
MCNUM mccsample_rod_collar_3_focus_aw;
MCNUM mccsample_rod_collar_3_focus_ah;
MCNUM mccsample_rod_collar_3_focus_xw;
MCNUM mccsample_rod_collar_3_focus_xh;
MCNUM mccsample_rod_collar_3_focus_r;
MCNUM mccsample_rod_collar_3_p_interact;
char mccsample_rod_collar_3_mask_string[16384];
char mccsample_rod_collar_3_mask_setting[16384];
MCNUM mccsample_rod_collar_3_number_of_activations;

/* Setting parameters for component 'sample_rod_collar_4' [39]. */
char mccsample_rod_collar_4_material_string[16384];
MCNUM mccsample_rod_collar_4_priority;
MCNUM mccsample_rod_collar_4_radius;
MCNUM mccsample_rod_collar_4_yheight;
MCNUM mccsample_rod_collar_4_visualize;
int mccsample_rod_collar_4_target_index;
MCNUM mccsample_rod_collar_4_target_x;
MCNUM mccsample_rod_collar_4_target_y;
MCNUM mccsample_rod_collar_4_target_z;
MCNUM mccsample_rod_collar_4_focus_aw;
MCNUM mccsample_rod_collar_4_focus_ah;
MCNUM mccsample_rod_collar_4_focus_xw;
MCNUM mccsample_rod_collar_4_focus_xh;
MCNUM mccsample_rod_collar_4_focus_r;
MCNUM mccsample_rod_collar_4_p_interact;
char mccsample_rod_collar_4_mask_string[16384];
char mccsample_rod_collar_4_mask_setting[16384];
MCNUM mccsample_rod_collar_4_number_of_activations;

/* Setting parameters for component 'sample_rod_collar_1_vacuum' [40]. */
char mccsample_rod_collar_1_vacuum_material_string[16384];
MCNUM mccsample_rod_collar_1_vacuum_priority;
MCNUM mccsample_rod_collar_1_vacuum_radius;
MCNUM mccsample_rod_collar_1_vacuum_yheight;
MCNUM mccsample_rod_collar_1_vacuum_visualize;
int mccsample_rod_collar_1_vacuum_target_index;
MCNUM mccsample_rod_collar_1_vacuum_target_x;
MCNUM mccsample_rod_collar_1_vacuum_target_y;
MCNUM mccsample_rod_collar_1_vacuum_target_z;
MCNUM mccsample_rod_collar_1_vacuum_focus_aw;
MCNUM mccsample_rod_collar_1_vacuum_focus_ah;
MCNUM mccsample_rod_collar_1_vacuum_focus_xw;
MCNUM mccsample_rod_collar_1_vacuum_focus_xh;
MCNUM mccsample_rod_collar_1_vacuum_focus_r;
MCNUM mccsample_rod_collar_1_vacuum_p_interact;
char mccsample_rod_collar_1_vacuum_mask_string[16384];
char mccsample_rod_collar_1_vacuum_mask_setting[16384];
MCNUM mccsample_rod_collar_1_vacuum_number_of_activations;

/* Setting parameters for component 'sample_rod_collar_2_vacuum' [41]. */
char mccsample_rod_collar_2_vacuum_material_string[16384];
MCNUM mccsample_rod_collar_2_vacuum_priority;
MCNUM mccsample_rod_collar_2_vacuum_radius;
MCNUM mccsample_rod_collar_2_vacuum_yheight;
MCNUM mccsample_rod_collar_2_vacuum_visualize;
int mccsample_rod_collar_2_vacuum_target_index;
MCNUM mccsample_rod_collar_2_vacuum_target_x;
MCNUM mccsample_rod_collar_2_vacuum_target_y;
MCNUM mccsample_rod_collar_2_vacuum_target_z;
MCNUM mccsample_rod_collar_2_vacuum_focus_aw;
MCNUM mccsample_rod_collar_2_vacuum_focus_ah;
MCNUM mccsample_rod_collar_2_vacuum_focus_xw;
MCNUM mccsample_rod_collar_2_vacuum_focus_xh;
MCNUM mccsample_rod_collar_2_vacuum_focus_r;
MCNUM mccsample_rod_collar_2_vacuum_p_interact;
char mccsample_rod_collar_2_vacuum_mask_string[16384];
char mccsample_rod_collar_2_vacuum_mask_setting[16384];
MCNUM mccsample_rod_collar_2_vacuum_number_of_activations;

/* Setting parameters for component 'sample_rod_collar_3_vacuum' [42]. */
char mccsample_rod_collar_3_vacuum_material_string[16384];
MCNUM mccsample_rod_collar_3_vacuum_priority;
MCNUM mccsample_rod_collar_3_vacuum_radius;
MCNUM mccsample_rod_collar_3_vacuum_yheight;
MCNUM mccsample_rod_collar_3_vacuum_visualize;
int mccsample_rod_collar_3_vacuum_target_index;
MCNUM mccsample_rod_collar_3_vacuum_target_x;
MCNUM mccsample_rod_collar_3_vacuum_target_y;
MCNUM mccsample_rod_collar_3_vacuum_target_z;
MCNUM mccsample_rod_collar_3_vacuum_focus_aw;
MCNUM mccsample_rod_collar_3_vacuum_focus_ah;
MCNUM mccsample_rod_collar_3_vacuum_focus_xw;
MCNUM mccsample_rod_collar_3_vacuum_focus_xh;
MCNUM mccsample_rod_collar_3_vacuum_focus_r;
MCNUM mccsample_rod_collar_3_vacuum_p_interact;
char mccsample_rod_collar_3_vacuum_mask_string[16384];
char mccsample_rod_collar_3_vacuum_mask_setting[16384];
MCNUM mccsample_rod_collar_3_vacuum_number_of_activations;

/* Setting parameters for component 'sample_rod_collar_4_vacuum' [43]. */
char mccsample_rod_collar_4_vacuum_material_string[16384];
MCNUM mccsample_rod_collar_4_vacuum_priority;
MCNUM mccsample_rod_collar_4_vacuum_radius;
MCNUM mccsample_rod_collar_4_vacuum_yheight;
MCNUM mccsample_rod_collar_4_vacuum_visualize;
int mccsample_rod_collar_4_vacuum_target_index;
MCNUM mccsample_rod_collar_4_vacuum_target_x;
MCNUM mccsample_rod_collar_4_vacuum_target_y;
MCNUM mccsample_rod_collar_4_vacuum_target_z;
MCNUM mccsample_rod_collar_4_vacuum_focus_aw;
MCNUM mccsample_rod_collar_4_vacuum_focus_ah;
MCNUM mccsample_rod_collar_4_vacuum_focus_xw;
MCNUM mccsample_rod_collar_4_vacuum_focus_xh;
MCNUM mccsample_rod_collar_4_vacuum_focus_r;
MCNUM mccsample_rod_collar_4_vacuum_p_interact;
char mccsample_rod_collar_4_vacuum_mask_string[16384];
char mccsample_rod_collar_4_vacuum_mask_setting[16384];
MCNUM mccsample_rod_collar_4_vacuum_number_of_activations;

/* Setting parameters for component 'resolution_sample_exit' [44]. */
char mccresolution_sample_exit_material_string[16384];
MCNUM mccresolution_sample_exit_priority;
MCNUM mccresolution_sample_exit_radius;
MCNUM mccresolution_sample_exit_yheight;
MCNUM mccresolution_sample_exit_visualize;
int mccresolution_sample_exit_target_index;
MCNUM mccresolution_sample_exit_target_x;
MCNUM mccresolution_sample_exit_target_y;
MCNUM mccresolution_sample_exit_target_z;
MCNUM mccresolution_sample_exit_focus_aw;
MCNUM mccresolution_sample_exit_focus_ah;
MCNUM mccresolution_sample_exit_focus_xw;
MCNUM mccresolution_sample_exit_focus_xh;
MCNUM mccresolution_sample_exit_focus_r;
MCNUM mccresolution_sample_exit_p_interact;
char mccresolution_sample_exit_mask_string[16384];
char mccresolution_sample_exit_mask_setting[16384];
MCNUM mccresolution_sample_exit_number_of_activations;

/* Setting parameters for component 'sample_cryostat' [45]. */
MCNUM mccsample_cryostat_allow_inside_start;
MCNUM mccsample_cryostat_history_limit;
MCNUM mccsample_cryostat_enable_conditionals;
MCNUM mccsample_cryostat_inherit_number_of_scattering_events;

/* Setting parameters for component 'Resolution_sample' [46]. */
MCNUM mccResolution_sample_thickness;
MCNUM mccResolution_sample_radius;
MCNUM mccResolution_sample_focus_r;
MCNUM mccResolution_sample_E0;
MCNUM mccResolution_sample_dE;
MCNUM mccResolution_sample_target_x;
MCNUM mccResolution_sample_target_y;
MCNUM mccResolution_sample_target_z;
MCNUM mccResolution_sample_focus_xw;
MCNUM mccResolution_sample_focus_yh;
MCNUM mccResolution_sample_focus_aw;
MCNUM mccResolution_sample_focus_ah;
MCNUM mccResolution_sample_xwidth;
MCNUM mccResolution_sample_yheight;
MCNUM mccResolution_sample_zdepth;
int mccResolution_sample_target_index;

/* Setting parameters for component 'post_sample_beamstop' [47]. */
MCNUM mccpost_sample_beamstop_xmin;
MCNUM mccpost_sample_beamstop_xmax;
MCNUM mccpost_sample_beamstop_ymin;
MCNUM mccpost_sample_beamstop_ymax;
MCNUM mccpost_sample_beamstop_xwidth;
MCNUM mccpost_sample_beamstop_yheight;
MCNUM mccpost_sample_beamstop_radius;

/* Setting parameters for component 'channel_0_filter' [69]. */
MCNUM mccchannel_0_filter_xmin;
MCNUM mccchannel_0_filter_xmax;
MCNUM mccchannel_0_filter_ymin;
MCNUM mccchannel_0_filter_ymax;
MCNUM mccchannel_0_filter_radius;
MCNUM mccchannel_0_filter_xwidth;
MCNUM mccchannel_0_filter_yheight;

/* Setting parameters for component 'channel_1_filter' [70]. */
MCNUM mccchannel_1_filter_xmin;
MCNUM mccchannel_1_filter_xmax;
MCNUM mccchannel_1_filter_ymin;
MCNUM mccchannel_1_filter_ymax;
MCNUM mccchannel_1_filter_radius;
MCNUM mccchannel_1_filter_xwidth;
MCNUM mccchannel_1_filter_yheight;

/* Setting parameters for component 'channel_2_filter' [71]. */
MCNUM mccchannel_2_filter_xmin;
MCNUM mccchannel_2_filter_xmax;
MCNUM mccchannel_2_filter_ymin;
MCNUM mccchannel_2_filter_ymax;
MCNUM mccchannel_2_filter_radius;
MCNUM mccchannel_2_filter_xwidth;
MCNUM mccchannel_2_filter_yheight;

/* Setting parameters for component 'channel_3_filter' [72]. */
MCNUM mccchannel_3_filter_xmin;
MCNUM mccchannel_3_filter_xmax;
MCNUM mccchannel_3_filter_ymin;
MCNUM mccchannel_3_filter_ymax;
MCNUM mccchannel_3_filter_radius;
MCNUM mccchannel_3_filter_xwidth;
MCNUM mccchannel_3_filter_yheight;

/* Setting parameters for component 'channel_4_filter' [73]. */
MCNUM mccchannel_4_filter_xmin;
MCNUM mccchannel_4_filter_xmax;
MCNUM mccchannel_4_filter_ymin;
MCNUM mccchannel_4_filter_ymax;
MCNUM mccchannel_4_filter_radius;
MCNUM mccchannel_4_filter_xwidth;
MCNUM mccchannel_4_filter_yheight;

/* Setting parameters for component 'channel_5_filter' [74]. */
MCNUM mccchannel_5_filter_xmin;
MCNUM mccchannel_5_filter_xmax;
MCNUM mccchannel_5_filter_ymin;
MCNUM mccchannel_5_filter_ymax;
MCNUM mccchannel_5_filter_radius;
MCNUM mccchannel_5_filter_xwidth;
MCNUM mccchannel_5_filter_yheight;

/* Setting parameters for component 'channel_6_filter' [75]. */
MCNUM mccchannel_6_filter_xmin;
MCNUM mccchannel_6_filter_xmax;
MCNUM mccchannel_6_filter_ymin;
MCNUM mccchannel_6_filter_ymax;
MCNUM mccchannel_6_filter_radius;
MCNUM mccchannel_6_filter_xwidth;
MCNUM mccchannel_6_filter_yheight;

/* Setting parameters for component 'channel_7_filter' [76]. */
MCNUM mccchannel_7_filter_xmin;
MCNUM mccchannel_7_filter_xmax;
MCNUM mccchannel_7_filter_ymin;
MCNUM mccchannel_7_filter_ymax;
MCNUM mccchannel_7_filter_radius;
MCNUM mccchannel_7_filter_xwidth;
MCNUM mccchannel_7_filter_yheight;

/* Setting parameters for component 'channel_8_filter' [77]. */
MCNUM mccchannel_8_filter_xmin;
MCNUM mccchannel_8_filter_xmax;
MCNUM mccchannel_8_filter_ymin;
MCNUM mccchannel_8_filter_ymax;
MCNUM mccchannel_8_filter_radius;
MCNUM mccchannel_8_filter_xwidth;
MCNUM mccchannel_8_filter_yheight;

/* Setting parameters for component 'channel_9_filter' [78]. */
MCNUM mccchannel_9_filter_xmin;
MCNUM mccchannel_9_filter_xmax;
MCNUM mccchannel_9_filter_ymin;
MCNUM mccchannel_9_filter_ymax;
MCNUM mccchannel_9_filter_radius;
MCNUM mccchannel_9_filter_xwidth;
MCNUM mccchannel_9_filter_yheight;

/* Setting parameters for component 'channel_10_filter' [79]. */
MCNUM mccchannel_10_filter_xmin;
MCNUM mccchannel_10_filter_xmax;
MCNUM mccchannel_10_filter_ymin;
MCNUM mccchannel_10_filter_ymax;
MCNUM mccchannel_10_filter_radius;
MCNUM mccchannel_10_filter_xwidth;
MCNUM mccchannel_10_filter_yheight;

/* Setting parameters for component 'channel_11_filter' [80]. */
MCNUM mccchannel_11_filter_xmin;
MCNUM mccchannel_11_filter_xmax;
MCNUM mccchannel_11_filter_ymin;
MCNUM mccchannel_11_filter_ymax;
MCNUM mccchannel_11_filter_radius;
MCNUM mccchannel_11_filter_xwidth;
MCNUM mccchannel_11_filter_yheight;

/* Setting parameters for component 'channel_12_filter' [81]. */
MCNUM mccchannel_12_filter_xmin;
MCNUM mccchannel_12_filter_xmax;
MCNUM mccchannel_12_filter_ymin;
MCNUM mccchannel_12_filter_ymax;
MCNUM mccchannel_12_filter_radius;
MCNUM mccchannel_12_filter_xwidth;
MCNUM mccchannel_12_filter_yheight;

/* Setting parameters for component 'channel_13_filter' [82]. */
MCNUM mccchannel_13_filter_xmin;
MCNUM mccchannel_13_filter_xmax;
MCNUM mccchannel_13_filter_ymin;
MCNUM mccchannel_13_filter_ymax;
MCNUM mccchannel_13_filter_radius;
MCNUM mccchannel_13_filter_xwidth;
MCNUM mccchannel_13_filter_yheight;

/* Setting parameters for component 'channel_14_filter' [83]. */
MCNUM mccchannel_14_filter_xmin;
MCNUM mccchannel_14_filter_xmax;
MCNUM mccchannel_14_filter_ymin;
MCNUM mccchannel_14_filter_ymax;
MCNUM mccchannel_14_filter_radius;
MCNUM mccchannel_14_filter_xwidth;
MCNUM mccchannel_14_filter_yheight;

/* Setting parameters for component 'channel_15_filter' [84]. */
MCNUM mccchannel_15_filter_xmin;
MCNUM mccchannel_15_filter_xmax;
MCNUM mccchannel_15_filter_ymin;
MCNUM mccchannel_15_filter_ymax;
MCNUM mccchannel_15_filter_radius;
MCNUM mccchannel_15_filter_xwidth;
MCNUM mccchannel_15_filter_yheight;

/* Setting parameters for component 'channel_16_filter' [85]. */
MCNUM mccchannel_16_filter_xmin;
MCNUM mccchannel_16_filter_xmax;
MCNUM mccchannel_16_filter_ymin;
MCNUM mccchannel_16_filter_ymax;
MCNUM mccchannel_16_filter_radius;
MCNUM mccchannel_16_filter_xwidth;
MCNUM mccchannel_16_filter_yheight;

/* Setting parameters for component 'channel_17_filter' [86]. */
MCNUM mccchannel_17_filter_xmin;
MCNUM mccchannel_17_filter_xmax;
MCNUM mccchannel_17_filter_ymin;
MCNUM mccchannel_17_filter_ymax;
MCNUM mccchannel_17_filter_radius;
MCNUM mccchannel_17_filter_xwidth;
MCNUM mccchannel_17_filter_yheight;

/* Setting parameters for component 'channel_18_filter' [87]. */
MCNUM mccchannel_18_filter_xmin;
MCNUM mccchannel_18_filter_xmax;
MCNUM mccchannel_18_filter_ymin;
MCNUM mccchannel_18_filter_ymax;
MCNUM mccchannel_18_filter_radius;
MCNUM mccchannel_18_filter_xwidth;
MCNUM mccchannel_18_filter_yheight;

/* Setting parameters for component 'channel_19_filter' [88]. */
MCNUM mccchannel_19_filter_xmin;
MCNUM mccchannel_19_filter_xmax;
MCNUM mccchannel_19_filter_ymin;
MCNUM mccchannel_19_filter_ymax;
MCNUM mccchannel_19_filter_radius;
MCNUM mccchannel_19_filter_xwidth;
MCNUM mccchannel_19_filter_yheight;

/* Setting parameters for component 'channel_0_colimator' [90]. */
MCNUM mccchannel_0_colimator_xmin;
MCNUM mccchannel_0_colimator_xmax;
MCNUM mccchannel_0_colimator_ymin;
MCNUM mccchannel_0_colimator_ymax;
MCNUM mccchannel_0_colimator_xwidth;
MCNUM mccchannel_0_colimator_yheight;
MCNUM mccchannel_0_colimator_length;
MCNUM mccchannel_0_colimator_divergence;
MCNUM mccchannel_0_colimator_transmission;
MCNUM mccchannel_0_colimator_divergenceV;

/* Setting parameters for component 'channel_1_colimator' [91]. */
MCNUM mccchannel_1_colimator_xmin;
MCNUM mccchannel_1_colimator_xmax;
MCNUM mccchannel_1_colimator_ymin;
MCNUM mccchannel_1_colimator_ymax;
MCNUM mccchannel_1_colimator_xwidth;
MCNUM mccchannel_1_colimator_yheight;
MCNUM mccchannel_1_colimator_length;
MCNUM mccchannel_1_colimator_divergence;
MCNUM mccchannel_1_colimator_transmission;
MCNUM mccchannel_1_colimator_divergenceV;

/* Setting parameters for component 'channel_2_colimator' [92]. */
MCNUM mccchannel_2_colimator_xmin;
MCNUM mccchannel_2_colimator_xmax;
MCNUM mccchannel_2_colimator_ymin;
MCNUM mccchannel_2_colimator_ymax;
MCNUM mccchannel_2_colimator_xwidth;
MCNUM mccchannel_2_colimator_yheight;
MCNUM mccchannel_2_colimator_length;
MCNUM mccchannel_2_colimator_divergence;
MCNUM mccchannel_2_colimator_transmission;
MCNUM mccchannel_2_colimator_divergenceV;

/* Setting parameters for component 'channel_3_colimator' [93]. */
MCNUM mccchannel_3_colimator_xmin;
MCNUM mccchannel_3_colimator_xmax;
MCNUM mccchannel_3_colimator_ymin;
MCNUM mccchannel_3_colimator_ymax;
MCNUM mccchannel_3_colimator_xwidth;
MCNUM mccchannel_3_colimator_yheight;
MCNUM mccchannel_3_colimator_length;
MCNUM mccchannel_3_colimator_divergence;
MCNUM mccchannel_3_colimator_transmission;
MCNUM mccchannel_3_colimator_divergenceV;

/* Setting parameters for component 'channel_4_colimator' [94]. */
MCNUM mccchannel_4_colimator_xmin;
MCNUM mccchannel_4_colimator_xmax;
MCNUM mccchannel_4_colimator_ymin;
MCNUM mccchannel_4_colimator_ymax;
MCNUM mccchannel_4_colimator_xwidth;
MCNUM mccchannel_4_colimator_yheight;
MCNUM mccchannel_4_colimator_length;
MCNUM mccchannel_4_colimator_divergence;
MCNUM mccchannel_4_colimator_transmission;
MCNUM mccchannel_4_colimator_divergenceV;

/* Setting parameters for component 'channel_5_colimator' [95]. */
MCNUM mccchannel_5_colimator_xmin;
MCNUM mccchannel_5_colimator_xmax;
MCNUM mccchannel_5_colimator_ymin;
MCNUM mccchannel_5_colimator_ymax;
MCNUM mccchannel_5_colimator_xwidth;
MCNUM mccchannel_5_colimator_yheight;
MCNUM mccchannel_5_colimator_length;
MCNUM mccchannel_5_colimator_divergence;
MCNUM mccchannel_5_colimator_transmission;
MCNUM mccchannel_5_colimator_divergenceV;

/* Setting parameters for component 'channel_6_colimator' [96]. */
MCNUM mccchannel_6_colimator_xmin;
MCNUM mccchannel_6_colimator_xmax;
MCNUM mccchannel_6_colimator_ymin;
MCNUM mccchannel_6_colimator_ymax;
MCNUM mccchannel_6_colimator_xwidth;
MCNUM mccchannel_6_colimator_yheight;
MCNUM mccchannel_6_colimator_length;
MCNUM mccchannel_6_colimator_divergence;
MCNUM mccchannel_6_colimator_transmission;
MCNUM mccchannel_6_colimator_divergenceV;

/* Setting parameters for component 'channel_7_colimator' [97]. */
MCNUM mccchannel_7_colimator_xmin;
MCNUM mccchannel_7_colimator_xmax;
MCNUM mccchannel_7_colimator_ymin;
MCNUM mccchannel_7_colimator_ymax;
MCNUM mccchannel_7_colimator_xwidth;
MCNUM mccchannel_7_colimator_yheight;
MCNUM mccchannel_7_colimator_length;
MCNUM mccchannel_7_colimator_divergence;
MCNUM mccchannel_7_colimator_transmission;
MCNUM mccchannel_7_colimator_divergenceV;

/* Setting parameters for component 'channel_8_colimator' [98]. */
MCNUM mccchannel_8_colimator_xmin;
MCNUM mccchannel_8_colimator_xmax;
MCNUM mccchannel_8_colimator_ymin;
MCNUM mccchannel_8_colimator_ymax;
MCNUM mccchannel_8_colimator_xwidth;
MCNUM mccchannel_8_colimator_yheight;
MCNUM mccchannel_8_colimator_length;
MCNUM mccchannel_8_colimator_divergence;
MCNUM mccchannel_8_colimator_transmission;
MCNUM mccchannel_8_colimator_divergenceV;

/* Setting parameters for component 'channel_9_colimator' [99]. */
MCNUM mccchannel_9_colimator_xmin;
MCNUM mccchannel_9_colimator_xmax;
MCNUM mccchannel_9_colimator_ymin;
MCNUM mccchannel_9_colimator_ymax;
MCNUM mccchannel_9_colimator_xwidth;
MCNUM mccchannel_9_colimator_yheight;
MCNUM mccchannel_9_colimator_length;
MCNUM mccchannel_9_colimator_divergence;
MCNUM mccchannel_9_colimator_transmission;
MCNUM mccchannel_9_colimator_divergenceV;

/* Setting parameters for component 'channel_10_colimator' [100]. */
MCNUM mccchannel_10_colimator_xmin;
MCNUM mccchannel_10_colimator_xmax;
MCNUM mccchannel_10_colimator_ymin;
MCNUM mccchannel_10_colimator_ymax;
MCNUM mccchannel_10_colimator_xwidth;
MCNUM mccchannel_10_colimator_yheight;
MCNUM mccchannel_10_colimator_length;
MCNUM mccchannel_10_colimator_divergence;
MCNUM mccchannel_10_colimator_transmission;
MCNUM mccchannel_10_colimator_divergenceV;

/* Setting parameters for component 'channel_11_colimator' [101]. */
MCNUM mccchannel_11_colimator_xmin;
MCNUM mccchannel_11_colimator_xmax;
MCNUM mccchannel_11_colimator_ymin;
MCNUM mccchannel_11_colimator_ymax;
MCNUM mccchannel_11_colimator_xwidth;
MCNUM mccchannel_11_colimator_yheight;
MCNUM mccchannel_11_colimator_length;
MCNUM mccchannel_11_colimator_divergence;
MCNUM mccchannel_11_colimator_transmission;
MCNUM mccchannel_11_colimator_divergenceV;

/* Setting parameters for component 'channel_12_colimator' [102]. */
MCNUM mccchannel_12_colimator_xmin;
MCNUM mccchannel_12_colimator_xmax;
MCNUM mccchannel_12_colimator_ymin;
MCNUM mccchannel_12_colimator_ymax;
MCNUM mccchannel_12_colimator_xwidth;
MCNUM mccchannel_12_colimator_yheight;
MCNUM mccchannel_12_colimator_length;
MCNUM mccchannel_12_colimator_divergence;
MCNUM mccchannel_12_colimator_transmission;
MCNUM mccchannel_12_colimator_divergenceV;

/* Setting parameters for component 'channel_13_colimator' [103]. */
MCNUM mccchannel_13_colimator_xmin;
MCNUM mccchannel_13_colimator_xmax;
MCNUM mccchannel_13_colimator_ymin;
MCNUM mccchannel_13_colimator_ymax;
MCNUM mccchannel_13_colimator_xwidth;
MCNUM mccchannel_13_colimator_yheight;
MCNUM mccchannel_13_colimator_length;
MCNUM mccchannel_13_colimator_divergence;
MCNUM mccchannel_13_colimator_transmission;
MCNUM mccchannel_13_colimator_divergenceV;

/* Setting parameters for component 'channel_14_colimator' [104]. */
MCNUM mccchannel_14_colimator_xmin;
MCNUM mccchannel_14_colimator_xmax;
MCNUM mccchannel_14_colimator_ymin;
MCNUM mccchannel_14_colimator_ymax;
MCNUM mccchannel_14_colimator_xwidth;
MCNUM mccchannel_14_colimator_yheight;
MCNUM mccchannel_14_colimator_length;
MCNUM mccchannel_14_colimator_divergence;
MCNUM mccchannel_14_colimator_transmission;
MCNUM mccchannel_14_colimator_divergenceV;

/* Setting parameters for component 'channel_15_colimator' [105]. */
MCNUM mccchannel_15_colimator_xmin;
MCNUM mccchannel_15_colimator_xmax;
MCNUM mccchannel_15_colimator_ymin;
MCNUM mccchannel_15_colimator_ymax;
MCNUM mccchannel_15_colimator_xwidth;
MCNUM mccchannel_15_colimator_yheight;
MCNUM mccchannel_15_colimator_length;
MCNUM mccchannel_15_colimator_divergence;
MCNUM mccchannel_15_colimator_transmission;
MCNUM mccchannel_15_colimator_divergenceV;

/* Setting parameters for component 'channel_16_colimator' [106]. */
MCNUM mccchannel_16_colimator_xmin;
MCNUM mccchannel_16_colimator_xmax;
MCNUM mccchannel_16_colimator_ymin;
MCNUM mccchannel_16_colimator_ymax;
MCNUM mccchannel_16_colimator_xwidth;
MCNUM mccchannel_16_colimator_yheight;
MCNUM mccchannel_16_colimator_length;
MCNUM mccchannel_16_colimator_divergence;
MCNUM mccchannel_16_colimator_transmission;
MCNUM mccchannel_16_colimator_divergenceV;

/* Setting parameters for component 'channel_17_colimator' [107]. */
MCNUM mccchannel_17_colimator_xmin;
MCNUM mccchannel_17_colimator_xmax;
MCNUM mccchannel_17_colimator_ymin;
MCNUM mccchannel_17_colimator_ymax;
MCNUM mccchannel_17_colimator_xwidth;
MCNUM mccchannel_17_colimator_yheight;
MCNUM mccchannel_17_colimator_length;
MCNUM mccchannel_17_colimator_divergence;
MCNUM mccchannel_17_colimator_transmission;
MCNUM mccchannel_17_colimator_divergenceV;

/* Setting parameters for component 'channel_18_colimator' [108]. */
MCNUM mccchannel_18_colimator_xmin;
MCNUM mccchannel_18_colimator_xmax;
MCNUM mccchannel_18_colimator_ymin;
MCNUM mccchannel_18_colimator_ymax;
MCNUM mccchannel_18_colimator_xwidth;
MCNUM mccchannel_18_colimator_yheight;
MCNUM mccchannel_18_colimator_length;
MCNUM mccchannel_18_colimator_divergence;
MCNUM mccchannel_18_colimator_transmission;
MCNUM mccchannel_18_colimator_divergenceV;

/* Setting parameters for component 'channel_19_colimator' [109]. */
MCNUM mccchannel_19_colimator_xmin;
MCNUM mccchannel_19_colimator_xmax;
MCNUM mccchannel_19_colimator_ymin;
MCNUM mccchannel_19_colimator_ymax;
MCNUM mccchannel_19_colimator_xwidth;
MCNUM mccchannel_19_colimator_yheight;
MCNUM mccchannel_19_colimator_length;
MCNUM mccchannel_19_colimator_divergence;
MCNUM mccchannel_19_colimator_transmission;
MCNUM mccchannel_19_colimator_divergenceV;

/* Setting parameters for component 'boron_plastic_incoherent' [110]. */
MCNUM mccboron_plastic_incoherent_sigma;
MCNUM mccboron_plastic_incoherent_f_QE;
MCNUM mccboron_plastic_incoherent_gamma;
MCNUM mccboron_plastic_incoherent_packing_factor;
MCNUM mccboron_plastic_incoherent_unit_cell_volume;
MCNUM mccboron_plastic_incoherent_interact_fraction;

/* Setting parameters for component 'boron_plastic' [111]. */
char mccboron_plastic_process_string[16384];
MCNUM mccboron_plastic_my_absorption;
MCNUM mccboron_plastic_absorber;

/* Setting parameters for component 'boron_plastic_enriched_incoherent' [112]. */
MCNUM mccboron_plastic_enriched_incoherent_sigma;
MCNUM mccboron_plastic_enriched_incoherent_f_QE;
MCNUM mccboron_plastic_enriched_incoherent_gamma;
MCNUM mccboron_plastic_enriched_incoherent_packing_factor;
MCNUM mccboron_plastic_enriched_incoherent_unit_cell_volume;
MCNUM mccboron_plastic_enriched_incoherent_interact_fraction;

/* Setting parameters for component 'boron_plastic_enriched' [113]. */
char mccboron_plastic_enriched_process_string[16384];
MCNUM mccboron_plastic_enriched_my_absorption;
MCNUM mccboron_plastic_enriched_absorber;

/* Setting parameters for component 'Collimator_gad' [114]. */
char mccCollimator_gad_process_string[16384];
MCNUM mccCollimator_gad_my_absorption;
MCNUM mccCollimator_gad_absorber;

/* Setting parameters for component 'Incoherent_PG_analyzer' [115]. */
MCNUM mccIncoherent_PG_analyzer_sigma;
MCNUM mccIncoherent_PG_analyzer_f_QE;
MCNUM mccIncoherent_PG_analyzer_gamma;
MCNUM mccIncoherent_PG_analyzer_packing_factor;
MCNUM mccIncoherent_PG_analyzer_unit_cell_volume;
MCNUM mccIncoherent_PG_analyzer_interact_fraction;

/* Definition parameters for component 'Single_crystal_PG_analyzer' [116]. */
#define mccSingle_crystal_PG_analyzer_mosaic_AB Mosaic_AB_Undefined
/* Setting parameters for component 'Single_crystal_PG_analyzer' [116]. */
char mccSingle_crystal_PG_analyzer_reflections[16384];
MCNUM mccSingle_crystal_PG_analyzer_delta_d_d;
MCNUM mccSingle_crystal_PG_analyzer_mosaic;
MCNUM mccSingle_crystal_PG_analyzer_mosaic_a;
MCNUM mccSingle_crystal_PG_analyzer_mosaic_b;
MCNUM mccSingle_crystal_PG_analyzer_mosaic_c;
MCNUM mccSingle_crystal_PG_analyzer_recip_cell;
MCNUM mccSingle_crystal_PG_analyzer_barns;
MCNUM mccSingle_crystal_PG_analyzer_ax;
MCNUM mccSingle_crystal_PG_analyzer_ay;
MCNUM mccSingle_crystal_PG_analyzer_az;
MCNUM mccSingle_crystal_PG_analyzer_bx;
MCNUM mccSingle_crystal_PG_analyzer_by;
MCNUM mccSingle_crystal_PG_analyzer_bz;
MCNUM mccSingle_crystal_PG_analyzer_cx;
MCNUM mccSingle_crystal_PG_analyzer_cy;
MCNUM mccSingle_crystal_PG_analyzer_cz;
MCNUM mccSingle_crystal_PG_analyzer_aa;
MCNUM mccSingle_crystal_PG_analyzer_bb;
MCNUM mccSingle_crystal_PG_analyzer_cc;
MCNUM mccSingle_crystal_PG_analyzer_order;
MCNUM mccSingle_crystal_PG_analyzer_RX;
MCNUM mccSingle_crystal_PG_analyzer_RY;
MCNUM mccSingle_crystal_PG_analyzer_RZ;
MCNUM mccSingle_crystal_PG_analyzer_powder;
MCNUM mccSingle_crystal_PG_analyzer_PG;
MCNUM mccSingle_crystal_PG_analyzer_interact_fraction;
MCNUM mccSingle_crystal_PG_analyzer_packing_factor;

/* Setting parameters for component 'PG_analyzer' [117]. */
char mccPG_analyzer_process_string[16384];
MCNUM mccPG_analyzer_my_absorption;
MCNUM mccPG_analyzer_absorber;

/* Setting parameters for component 'kidney_hull' [118]. */
char mcckidney_hull_material_string[16384];
MCNUM mcckidney_hull_priority;
MCNUM mcckidney_hull_radius;
MCNUM mcckidney_hull_yheight;
MCNUM mcckidney_hull_visualize;
int mcckidney_hull_target_index;
MCNUM mcckidney_hull_target_x;
MCNUM mcckidney_hull_target_y;
MCNUM mcckidney_hull_target_z;
MCNUM mcckidney_hull_focus_aw;
MCNUM mcckidney_hull_focus_ah;
MCNUM mcckidney_hull_focus_xw;
MCNUM mcckidney_hull_focus_xh;
MCNUM mcckidney_hull_focus_r;
MCNUM mcckidney_hull_p_interact;
char mcckidney_hull_mask_string[16384];
char mcckidney_hull_mask_setting[16384];
MCNUM mcckidney_hull_number_of_activations;

/* Setting parameters for component 'kidney_hull_cut' [119]. */
char mcckidney_hull_cut_material_string[16384];
MCNUM mcckidney_hull_cut_priority;
MCNUM mcckidney_hull_cut_radius;
MCNUM mcckidney_hull_cut_yheight;
MCNUM mcckidney_hull_cut_visualize;
int mcckidney_hull_cut_target_index;
MCNUM mcckidney_hull_cut_target_x;
MCNUM mcckidney_hull_cut_target_y;
MCNUM mcckidney_hull_cut_target_z;
MCNUM mcckidney_hull_cut_focus_aw;
MCNUM mcckidney_hull_cut_focus_ah;
MCNUM mcckidney_hull_cut_focus_xw;
MCNUM mcckidney_hull_cut_focus_xh;
MCNUM mcckidney_hull_cut_focus_r;
MCNUM mcckidney_hull_cut_p_interact;
char mcckidney_hull_cut_mask_string[16384];
char mcckidney_hull_cut_mask_setting[16384];
MCNUM mcckidney_hull_cut_number_of_activations;

/* Setting parameters for component 'kidney_hull_box_cut1' [121]. */
char mcckidney_hull_box_cut1_material_string[16384];
MCNUM mcckidney_hull_box_cut1_priority;
MCNUM mcckidney_hull_box_cut1_xwidth;
MCNUM mcckidney_hull_box_cut1_yheight;
MCNUM mcckidney_hull_box_cut1_zdepth;
MCNUM mcckidney_hull_box_cut1_xwidth2;
MCNUM mcckidney_hull_box_cut1_yheight2;
MCNUM mcckidney_hull_box_cut1_visualize;
int mcckidney_hull_box_cut1_target_index;
MCNUM mcckidney_hull_box_cut1_target_x;
MCNUM mcckidney_hull_box_cut1_target_y;
MCNUM mcckidney_hull_box_cut1_target_z;
MCNUM mcckidney_hull_box_cut1_focus_aw;
MCNUM mcckidney_hull_box_cut1_focus_ah;
MCNUM mcckidney_hull_box_cut1_focus_xw;
MCNUM mcckidney_hull_box_cut1_focus_xh;
MCNUM mcckidney_hull_box_cut1_focus_r;
MCNUM mcckidney_hull_box_cut1_p_interact;
char mcckidney_hull_box_cut1_mask_string[16384];
char mcckidney_hull_box_cut1_mask_setting[16384];
MCNUM mcckidney_hull_box_cut1_number_of_activations;

/* Setting parameters for component 'kidney_hull_box_cut2' [123]. */
char mcckidney_hull_box_cut2_material_string[16384];
MCNUM mcckidney_hull_box_cut2_priority;
MCNUM mcckidney_hull_box_cut2_xwidth;
MCNUM mcckidney_hull_box_cut2_yheight;
MCNUM mcckidney_hull_box_cut2_zdepth;
MCNUM mcckidney_hull_box_cut2_xwidth2;
MCNUM mcckidney_hull_box_cut2_yheight2;
MCNUM mcckidney_hull_box_cut2_visualize;
int mcckidney_hull_box_cut2_target_index;
MCNUM mcckidney_hull_box_cut2_target_x;
MCNUM mcckidney_hull_box_cut2_target_y;
MCNUM mcckidney_hull_box_cut2_target_z;
MCNUM mcckidney_hull_box_cut2_focus_aw;
MCNUM mcckidney_hull_box_cut2_focus_ah;
MCNUM mcckidney_hull_box_cut2_focus_xw;
MCNUM mcckidney_hull_box_cut2_focus_xh;
MCNUM mcckidney_hull_box_cut2_focus_r;
MCNUM mcckidney_hull_box_cut2_p_interact;
char mcckidney_hull_box_cut2_mask_string[16384];
char mcckidney_hull_box_cut2_mask_setting[16384];
MCNUM mcckidney_hull_box_cut2_number_of_activations;

/* Setting parameters for component 'channel_0_cave1_box1' [124]. */
char mccchannel_0_cave1_box1_material_string[16384];
MCNUM mccchannel_0_cave1_box1_priority;
MCNUM mccchannel_0_cave1_box1_xwidth;
MCNUM mccchannel_0_cave1_box1_yheight;
MCNUM mccchannel_0_cave1_box1_zdepth;
MCNUM mccchannel_0_cave1_box1_xwidth2;
MCNUM mccchannel_0_cave1_box1_yheight2;
MCNUM mccchannel_0_cave1_box1_visualize;
int mccchannel_0_cave1_box1_target_index;
MCNUM mccchannel_0_cave1_box1_target_x;
MCNUM mccchannel_0_cave1_box1_target_y;
MCNUM mccchannel_0_cave1_box1_target_z;
MCNUM mccchannel_0_cave1_box1_focus_aw;
MCNUM mccchannel_0_cave1_box1_focus_ah;
MCNUM mccchannel_0_cave1_box1_focus_xw;
MCNUM mccchannel_0_cave1_box1_focus_xh;
MCNUM mccchannel_0_cave1_box1_focus_r;
MCNUM mccchannel_0_cave1_box1_p_interact;
char mccchannel_0_cave1_box1_mask_string[16384];
char mccchannel_0_cave1_box1_mask_setting[16384];
MCNUM mccchannel_0_cave1_box1_number_of_activations;

/* Setting parameters for component 'channel_0_cave1_box2' [125]. */
char mccchannel_0_cave1_box2_material_string[16384];
MCNUM mccchannel_0_cave1_box2_priority;
MCNUM mccchannel_0_cave1_box2_xwidth;
MCNUM mccchannel_0_cave1_box2_yheight;
MCNUM mccchannel_0_cave1_box2_zdepth;
MCNUM mccchannel_0_cave1_box2_xwidth2;
MCNUM mccchannel_0_cave1_box2_yheight2;
MCNUM mccchannel_0_cave1_box2_visualize;
int mccchannel_0_cave1_box2_target_index;
MCNUM mccchannel_0_cave1_box2_target_x;
MCNUM mccchannel_0_cave1_box2_target_y;
MCNUM mccchannel_0_cave1_box2_target_z;
MCNUM mccchannel_0_cave1_box2_focus_aw;
MCNUM mccchannel_0_cave1_box2_focus_ah;
MCNUM mccchannel_0_cave1_box2_focus_xw;
MCNUM mccchannel_0_cave1_box2_focus_xh;
MCNUM mccchannel_0_cave1_box2_focus_r;
MCNUM mccchannel_0_cave1_box2_p_interact;
char mccchannel_0_cave1_box2_mask_string[16384];
char mccchannel_0_cave1_box2_mask_setting[16384];
MCNUM mccchannel_0_cave1_box2_number_of_activations;

/* Setting parameters for component 'channel_0_cave1_box3' [126]. */
char mccchannel_0_cave1_box3_material_string[16384];
MCNUM mccchannel_0_cave1_box3_priority;
MCNUM mccchannel_0_cave1_box3_xwidth;
MCNUM mccchannel_0_cave1_box3_yheight;
MCNUM mccchannel_0_cave1_box3_zdepth;
MCNUM mccchannel_0_cave1_box3_xwidth2;
MCNUM mccchannel_0_cave1_box3_yheight2;
MCNUM mccchannel_0_cave1_box3_visualize;
int mccchannel_0_cave1_box3_target_index;
MCNUM mccchannel_0_cave1_box3_target_x;
MCNUM mccchannel_0_cave1_box3_target_y;
MCNUM mccchannel_0_cave1_box3_target_z;
MCNUM mccchannel_0_cave1_box3_focus_aw;
MCNUM mccchannel_0_cave1_box3_focus_ah;
MCNUM mccchannel_0_cave1_box3_focus_xw;
MCNUM mccchannel_0_cave1_box3_focus_xh;
MCNUM mccchannel_0_cave1_box3_focus_r;
MCNUM mccchannel_0_cave1_box3_p_interact;
char mccchannel_0_cave1_box3_mask_string[16384];
char mccchannel_0_cave1_box3_mask_setting[16384];
MCNUM mccchannel_0_cave1_box3_number_of_activations;

/* Setting parameters for component 'channel_0_cave1_cyl1' [127]. */
char mccchannel_0_cave1_cyl1_material_string[16384];
MCNUM mccchannel_0_cave1_cyl1_priority;
MCNUM mccchannel_0_cave1_cyl1_radius;
MCNUM mccchannel_0_cave1_cyl1_yheight;
MCNUM mccchannel_0_cave1_cyl1_visualize;
int mccchannel_0_cave1_cyl1_target_index;
MCNUM mccchannel_0_cave1_cyl1_target_x;
MCNUM mccchannel_0_cave1_cyl1_target_y;
MCNUM mccchannel_0_cave1_cyl1_target_z;
MCNUM mccchannel_0_cave1_cyl1_focus_aw;
MCNUM mccchannel_0_cave1_cyl1_focus_ah;
MCNUM mccchannel_0_cave1_cyl1_focus_xw;
MCNUM mccchannel_0_cave1_cyl1_focus_xh;
MCNUM mccchannel_0_cave1_cyl1_focus_r;
MCNUM mccchannel_0_cave1_cyl1_p_interact;
char mccchannel_0_cave1_cyl1_mask_string[16384];
char mccchannel_0_cave1_cyl1_mask_setting[16384];
MCNUM mccchannel_0_cave1_cyl1_number_of_activations;

/* Setting parameters for component 'channel_0_analyzer_1_array_crystal_array_0' [130]. */
char mccchannel_0_analyzer_1_array_crystal_array_0_material_string[16384];
MCNUM mccchannel_0_analyzer_1_array_crystal_array_0_priority;
MCNUM mccchannel_0_analyzer_1_array_crystal_array_0_xwidth;
MCNUM mccchannel_0_analyzer_1_array_crystal_array_0_yheight;
MCNUM mccchannel_0_analyzer_1_array_crystal_array_0_zdepth;
MCNUM mccchannel_0_analyzer_1_array_crystal_array_0_xwidth2;
MCNUM mccchannel_0_analyzer_1_array_crystal_array_0_yheight2;
MCNUM mccchannel_0_analyzer_1_array_crystal_array_0_visualize;
int mccchannel_0_analyzer_1_array_crystal_array_0_target_index;
MCNUM mccchannel_0_analyzer_1_array_crystal_array_0_target_x;
MCNUM mccchannel_0_analyzer_1_array_crystal_array_0_target_y;
MCNUM mccchannel_0_analyzer_1_array_crystal_array_0_target_z;
MCNUM mccchannel_0_analyzer_1_array_crystal_array_0_focus_aw;
MCNUM mccchannel_0_analyzer_1_array_crystal_array_0_focus_ah;
MCNUM mccchannel_0_analyzer_1_array_crystal_array_0_focus_xw;
MCNUM mccchannel_0_analyzer_1_array_crystal_array_0_focus_xh;
MCNUM mccchannel_0_analyzer_1_array_crystal_array_0_focus_r;
MCNUM mccchannel_0_analyzer_1_array_crystal_array_0_p_interact;
char mccchannel_0_analyzer_1_array_crystal_array_0_mask_string[16384];
char mccchannel_0_analyzer_1_array_crystal_array_0_mask_setting[16384];
MCNUM mccchannel_0_analyzer_1_array_crystal_array_0_number_of_activations;

/* Setting parameters for component 'channel_0_analyzer_1_array_crystal_array_1' [131]. */
char mccchannel_0_analyzer_1_array_crystal_array_1_material_string[16384];
MCNUM mccchannel_0_analyzer_1_array_crystal_array_1_priority;
MCNUM mccchannel_0_analyzer_1_array_crystal_array_1_xwidth;
MCNUM mccchannel_0_analyzer_1_array_crystal_array_1_yheight;
MCNUM mccchannel_0_analyzer_1_array_crystal_array_1_zdepth;
MCNUM mccchannel_0_analyzer_1_array_crystal_array_1_xwidth2;
MCNUM mccchannel_0_analyzer_1_array_crystal_array_1_yheight2;
MCNUM mccchannel_0_analyzer_1_array_crystal_array_1_visualize;
int mccchannel_0_analyzer_1_array_crystal_array_1_target_index;
MCNUM mccchannel_0_analyzer_1_array_crystal_array_1_target_x;
MCNUM mccchannel_0_analyzer_1_array_crystal_array_1_target_y;
MCNUM mccchannel_0_analyzer_1_array_crystal_array_1_target_z;
MCNUM mccchannel_0_analyzer_1_array_crystal_array_1_focus_aw;
MCNUM mccchannel_0_analyzer_1_array_crystal_array_1_focus_ah;
MCNUM mccchannel_0_analyzer_1_array_crystal_array_1_focus_xw;
MCNUM mccchannel_0_analyzer_1_array_crystal_array_1_focus_xh;
MCNUM mccchannel_0_analyzer_1_array_crystal_array_1_focus_r;
MCNUM mccchannel_0_analyzer_1_array_crystal_array_1_p_interact;
char mccchannel_0_analyzer_1_array_crystal_array_1_mask_string[16384];
char mccchannel_0_analyzer_1_array_crystal_array_1_mask_setting[16384];
MCNUM mccchannel_0_analyzer_1_array_crystal_array_1_number_of_activations;

/* Setting parameters for component 'channel_0_analyzer_1_array_crystal_array_2' [132]. */
char mccchannel_0_analyzer_1_array_crystal_array_2_material_string[16384];
MCNUM mccchannel_0_analyzer_1_array_crystal_array_2_priority;
MCNUM mccchannel_0_analyzer_1_array_crystal_array_2_xwidth;
MCNUM mccchannel_0_analyzer_1_array_crystal_array_2_yheight;
MCNUM mccchannel_0_analyzer_1_array_crystal_array_2_zdepth;
MCNUM mccchannel_0_analyzer_1_array_crystal_array_2_xwidth2;
MCNUM mccchannel_0_analyzer_1_array_crystal_array_2_yheight2;
MCNUM mccchannel_0_analyzer_1_array_crystal_array_2_visualize;
int mccchannel_0_analyzer_1_array_crystal_array_2_target_index;
MCNUM mccchannel_0_analyzer_1_array_crystal_array_2_target_x;
MCNUM mccchannel_0_analyzer_1_array_crystal_array_2_target_y;
MCNUM mccchannel_0_analyzer_1_array_crystal_array_2_target_z;
MCNUM mccchannel_0_analyzer_1_array_crystal_array_2_focus_aw;
MCNUM mccchannel_0_analyzer_1_array_crystal_array_2_focus_ah;
MCNUM mccchannel_0_analyzer_1_array_crystal_array_2_focus_xw;
MCNUM mccchannel_0_analyzer_1_array_crystal_array_2_focus_xh;
MCNUM mccchannel_0_analyzer_1_array_crystal_array_2_focus_r;
MCNUM mccchannel_0_analyzer_1_array_crystal_array_2_p_interact;
char mccchannel_0_analyzer_1_array_crystal_array_2_mask_string[16384];
char mccchannel_0_analyzer_1_array_crystal_array_2_mask_setting[16384];
MCNUM mccchannel_0_analyzer_1_array_crystal_array_2_number_of_activations;

/* Setting parameters for component 'channel_0_analyzer_1_array_crystal_array_3' [133]. */
char mccchannel_0_analyzer_1_array_crystal_array_3_material_string[16384];
MCNUM mccchannel_0_analyzer_1_array_crystal_array_3_priority;
MCNUM mccchannel_0_analyzer_1_array_crystal_array_3_xwidth;
MCNUM mccchannel_0_analyzer_1_array_crystal_array_3_yheight;
MCNUM mccchannel_0_analyzer_1_array_crystal_array_3_zdepth;
MCNUM mccchannel_0_analyzer_1_array_crystal_array_3_xwidth2;
MCNUM mccchannel_0_analyzer_1_array_crystal_array_3_yheight2;
MCNUM mccchannel_0_analyzer_1_array_crystal_array_3_visualize;
int mccchannel_0_analyzer_1_array_crystal_array_3_target_index;
MCNUM mccchannel_0_analyzer_1_array_crystal_array_3_target_x;
MCNUM mccchannel_0_analyzer_1_array_crystal_array_3_target_y;
MCNUM mccchannel_0_analyzer_1_array_crystal_array_3_target_z;
MCNUM mccchannel_0_analyzer_1_array_crystal_array_3_focus_aw;
MCNUM mccchannel_0_analyzer_1_array_crystal_array_3_focus_ah;
MCNUM mccchannel_0_analyzer_1_array_crystal_array_3_focus_xw;
MCNUM mccchannel_0_analyzer_1_array_crystal_array_3_focus_xh;
MCNUM mccchannel_0_analyzer_1_array_crystal_array_3_focus_r;
MCNUM mccchannel_0_analyzer_1_array_crystal_array_3_p_interact;
char mccchannel_0_analyzer_1_array_crystal_array_3_mask_string[16384];
char mccchannel_0_analyzer_1_array_crystal_array_3_mask_setting[16384];
MCNUM mccchannel_0_analyzer_1_array_crystal_array_3_number_of_activations;

/* Setting parameters for component 'channel_0_analyzer_1_array_crystal_array_4' [134]. */
char mccchannel_0_analyzer_1_array_crystal_array_4_material_string[16384];
MCNUM mccchannel_0_analyzer_1_array_crystal_array_4_priority;
MCNUM mccchannel_0_analyzer_1_array_crystal_array_4_xwidth;
MCNUM mccchannel_0_analyzer_1_array_crystal_array_4_yheight;
MCNUM mccchannel_0_analyzer_1_array_crystal_array_4_zdepth;
MCNUM mccchannel_0_analyzer_1_array_crystal_array_4_xwidth2;
MCNUM mccchannel_0_analyzer_1_array_crystal_array_4_yheight2;
MCNUM mccchannel_0_analyzer_1_array_crystal_array_4_visualize;
int mccchannel_0_analyzer_1_array_crystal_array_4_target_index;
MCNUM mccchannel_0_analyzer_1_array_crystal_array_4_target_x;
MCNUM mccchannel_0_analyzer_1_array_crystal_array_4_target_y;
MCNUM mccchannel_0_analyzer_1_array_crystal_array_4_target_z;
MCNUM mccchannel_0_analyzer_1_array_crystal_array_4_focus_aw;
MCNUM mccchannel_0_analyzer_1_array_crystal_array_4_focus_ah;
MCNUM mccchannel_0_analyzer_1_array_crystal_array_4_focus_xw;
MCNUM mccchannel_0_analyzer_1_array_crystal_array_4_focus_xh;
MCNUM mccchannel_0_analyzer_1_array_crystal_array_4_focus_r;
MCNUM mccchannel_0_analyzer_1_array_crystal_array_4_p_interact;
char mccchannel_0_analyzer_1_array_crystal_array_4_mask_string[16384];
char mccchannel_0_analyzer_1_array_crystal_array_4_mask_setting[16384];
MCNUM mccchannel_0_analyzer_1_array_crystal_array_4_number_of_activations;

/* Setting parameters for component 'channel_0_analyzer_1_array_crystal_array_5' [135]. */
char mccchannel_0_analyzer_1_array_crystal_array_5_material_string[16384];
MCNUM mccchannel_0_analyzer_1_array_crystal_array_5_priority;
MCNUM mccchannel_0_analyzer_1_array_crystal_array_5_xwidth;
MCNUM mccchannel_0_analyzer_1_array_crystal_array_5_yheight;
MCNUM mccchannel_0_analyzer_1_array_crystal_array_5_zdepth;
MCNUM mccchannel_0_analyzer_1_array_crystal_array_5_xwidth2;
MCNUM mccchannel_0_analyzer_1_array_crystal_array_5_yheight2;
MCNUM mccchannel_0_analyzer_1_array_crystal_array_5_visualize;
int mccchannel_0_analyzer_1_array_crystal_array_5_target_index;
MCNUM mccchannel_0_analyzer_1_array_crystal_array_5_target_x;
MCNUM mccchannel_0_analyzer_1_array_crystal_array_5_target_y;
MCNUM mccchannel_0_analyzer_1_array_crystal_array_5_target_z;
MCNUM mccchannel_0_analyzer_1_array_crystal_array_5_focus_aw;
MCNUM mccchannel_0_analyzer_1_array_crystal_array_5_focus_ah;
MCNUM mccchannel_0_analyzer_1_array_crystal_array_5_focus_xw;
MCNUM mccchannel_0_analyzer_1_array_crystal_array_5_focus_xh;
MCNUM mccchannel_0_analyzer_1_array_crystal_array_5_focus_r;
MCNUM mccchannel_0_analyzer_1_array_crystal_array_5_p_interact;
char mccchannel_0_analyzer_1_array_crystal_array_5_mask_string[16384];
char mccchannel_0_analyzer_1_array_crystal_array_5_mask_setting[16384];
MCNUM mccchannel_0_analyzer_1_array_crystal_array_5_number_of_activations;

/* Setting parameters for component 'channel_0_analyzer_1_array_crystal_array_6' [136]. */
char mccchannel_0_analyzer_1_array_crystal_array_6_material_string[16384];
MCNUM mccchannel_0_analyzer_1_array_crystal_array_6_priority;
MCNUM mccchannel_0_analyzer_1_array_crystal_array_6_xwidth;
MCNUM mccchannel_0_analyzer_1_array_crystal_array_6_yheight;
MCNUM mccchannel_0_analyzer_1_array_crystal_array_6_zdepth;
MCNUM mccchannel_0_analyzer_1_array_crystal_array_6_xwidth2;
MCNUM mccchannel_0_analyzer_1_array_crystal_array_6_yheight2;
MCNUM mccchannel_0_analyzer_1_array_crystal_array_6_visualize;
int mccchannel_0_analyzer_1_array_crystal_array_6_target_index;
MCNUM mccchannel_0_analyzer_1_array_crystal_array_6_target_x;
MCNUM mccchannel_0_analyzer_1_array_crystal_array_6_target_y;
MCNUM mccchannel_0_analyzer_1_array_crystal_array_6_target_z;
MCNUM mccchannel_0_analyzer_1_array_crystal_array_6_focus_aw;
MCNUM mccchannel_0_analyzer_1_array_crystal_array_6_focus_ah;
MCNUM mccchannel_0_analyzer_1_array_crystal_array_6_focus_xw;
MCNUM mccchannel_0_analyzer_1_array_crystal_array_6_focus_xh;
MCNUM mccchannel_0_analyzer_1_array_crystal_array_6_focus_r;
MCNUM mccchannel_0_analyzer_1_array_crystal_array_6_p_interact;
char mccchannel_0_analyzer_1_array_crystal_array_6_mask_string[16384];
char mccchannel_0_analyzer_1_array_crystal_array_6_mask_setting[16384];
MCNUM mccchannel_0_analyzer_1_array_crystal_array_6_number_of_activations;

/* Setting parameters for component 'channel_0_analyzer_1_array_crystal_array_7' [137]. */
char mccchannel_0_analyzer_1_array_crystal_array_7_material_string[16384];
MCNUM mccchannel_0_analyzer_1_array_crystal_array_7_priority;
MCNUM mccchannel_0_analyzer_1_array_crystal_array_7_xwidth;
MCNUM mccchannel_0_analyzer_1_array_crystal_array_7_yheight;
MCNUM mccchannel_0_analyzer_1_array_crystal_array_7_zdepth;
MCNUM mccchannel_0_analyzer_1_array_crystal_array_7_xwidth2;
MCNUM mccchannel_0_analyzer_1_array_crystal_array_7_yheight2;
MCNUM mccchannel_0_analyzer_1_array_crystal_array_7_visualize;
int mccchannel_0_analyzer_1_array_crystal_array_7_target_index;
MCNUM mccchannel_0_analyzer_1_array_crystal_array_7_target_x;
MCNUM mccchannel_0_analyzer_1_array_crystal_array_7_target_y;
MCNUM mccchannel_0_analyzer_1_array_crystal_array_7_target_z;
MCNUM mccchannel_0_analyzer_1_array_crystal_array_7_focus_aw;
MCNUM mccchannel_0_analyzer_1_array_crystal_array_7_focus_ah;
MCNUM mccchannel_0_analyzer_1_array_crystal_array_7_focus_xw;
MCNUM mccchannel_0_analyzer_1_array_crystal_array_7_focus_xh;
MCNUM mccchannel_0_analyzer_1_array_crystal_array_7_focus_r;
MCNUM mccchannel_0_analyzer_1_array_crystal_array_7_p_interact;
char mccchannel_0_analyzer_1_array_crystal_array_7_mask_string[16384];
char mccchannel_0_analyzer_1_array_crystal_array_7_mask_setting[16384];
MCNUM mccchannel_0_analyzer_1_array_crystal_array_7_number_of_activations;

/* Setting parameters for component 'channel_0_analyzer_1_array_crystal_array_8' [138]. */
char mccchannel_0_analyzer_1_array_crystal_array_8_material_string[16384];
MCNUM mccchannel_0_analyzer_1_array_crystal_array_8_priority;
MCNUM mccchannel_0_analyzer_1_array_crystal_array_8_xwidth;
MCNUM mccchannel_0_analyzer_1_array_crystal_array_8_yheight;
MCNUM mccchannel_0_analyzer_1_array_crystal_array_8_zdepth;
MCNUM mccchannel_0_analyzer_1_array_crystal_array_8_xwidth2;
MCNUM mccchannel_0_analyzer_1_array_crystal_array_8_yheight2;
MCNUM mccchannel_0_analyzer_1_array_crystal_array_8_visualize;
int mccchannel_0_analyzer_1_array_crystal_array_8_target_index;
MCNUM mccchannel_0_analyzer_1_array_crystal_array_8_target_x;
MCNUM mccchannel_0_analyzer_1_array_crystal_array_8_target_y;
MCNUM mccchannel_0_analyzer_1_array_crystal_array_8_target_z;
MCNUM mccchannel_0_analyzer_1_array_crystal_array_8_focus_aw;
MCNUM mccchannel_0_analyzer_1_array_crystal_array_8_focus_ah;
MCNUM mccchannel_0_analyzer_1_array_crystal_array_8_focus_xw;
MCNUM mccchannel_0_analyzer_1_array_crystal_array_8_focus_xh;
MCNUM mccchannel_0_analyzer_1_array_crystal_array_8_focus_r;
MCNUM mccchannel_0_analyzer_1_array_crystal_array_8_p_interact;
char mccchannel_0_analyzer_1_array_crystal_array_8_mask_string[16384];
char mccchannel_0_analyzer_1_array_crystal_array_8_mask_setting[16384];
MCNUM mccchannel_0_analyzer_1_array_crystal_array_8_number_of_activations;

/* Setting parameters for component 'channel_0_analyzer_2_array_crystal_array_0' [141]. */
char mccchannel_0_analyzer_2_array_crystal_array_0_material_string[16384];
MCNUM mccchannel_0_analyzer_2_array_crystal_array_0_priority;
MCNUM mccchannel_0_analyzer_2_array_crystal_array_0_xwidth;
MCNUM mccchannel_0_analyzer_2_array_crystal_array_0_yheight;
MCNUM mccchannel_0_analyzer_2_array_crystal_array_0_zdepth;
MCNUM mccchannel_0_analyzer_2_array_crystal_array_0_xwidth2;
MCNUM mccchannel_0_analyzer_2_array_crystal_array_0_yheight2;
MCNUM mccchannel_0_analyzer_2_array_crystal_array_0_visualize;
int mccchannel_0_analyzer_2_array_crystal_array_0_target_index;
MCNUM mccchannel_0_analyzer_2_array_crystal_array_0_target_x;
MCNUM mccchannel_0_analyzer_2_array_crystal_array_0_target_y;
MCNUM mccchannel_0_analyzer_2_array_crystal_array_0_target_z;
MCNUM mccchannel_0_analyzer_2_array_crystal_array_0_focus_aw;
MCNUM mccchannel_0_analyzer_2_array_crystal_array_0_focus_ah;
MCNUM mccchannel_0_analyzer_2_array_crystal_array_0_focus_xw;
MCNUM mccchannel_0_analyzer_2_array_crystal_array_0_focus_xh;
MCNUM mccchannel_0_analyzer_2_array_crystal_array_0_focus_r;
MCNUM mccchannel_0_analyzer_2_array_crystal_array_0_p_interact;
char mccchannel_0_analyzer_2_array_crystal_array_0_mask_string[16384];
char mccchannel_0_analyzer_2_array_crystal_array_0_mask_setting[16384];
MCNUM mccchannel_0_analyzer_2_array_crystal_array_0_number_of_activations;

/* Setting parameters for component 'channel_0_analyzer_2_array_crystal_array_1' [142]. */
char mccchannel_0_analyzer_2_array_crystal_array_1_material_string[16384];
MCNUM mccchannel_0_analyzer_2_array_crystal_array_1_priority;
MCNUM mccchannel_0_analyzer_2_array_crystal_array_1_xwidth;
MCNUM mccchannel_0_analyzer_2_array_crystal_array_1_yheight;
MCNUM mccchannel_0_analyzer_2_array_crystal_array_1_zdepth;
MCNUM mccchannel_0_analyzer_2_array_crystal_array_1_xwidth2;
MCNUM mccchannel_0_analyzer_2_array_crystal_array_1_yheight2;
MCNUM mccchannel_0_analyzer_2_array_crystal_array_1_visualize;
int mccchannel_0_analyzer_2_array_crystal_array_1_target_index;
MCNUM mccchannel_0_analyzer_2_array_crystal_array_1_target_x;
MCNUM mccchannel_0_analyzer_2_array_crystal_array_1_target_y;
MCNUM mccchannel_0_analyzer_2_array_crystal_array_1_target_z;
MCNUM mccchannel_0_analyzer_2_array_crystal_array_1_focus_aw;
MCNUM mccchannel_0_analyzer_2_array_crystal_array_1_focus_ah;
MCNUM mccchannel_0_analyzer_2_array_crystal_array_1_focus_xw;
MCNUM mccchannel_0_analyzer_2_array_crystal_array_1_focus_xh;
MCNUM mccchannel_0_analyzer_2_array_crystal_array_1_focus_r;
MCNUM mccchannel_0_analyzer_2_array_crystal_array_1_p_interact;
char mccchannel_0_analyzer_2_array_crystal_array_1_mask_string[16384];
char mccchannel_0_analyzer_2_array_crystal_array_1_mask_setting[16384];
MCNUM mccchannel_0_analyzer_2_array_crystal_array_1_number_of_activations;

/* Setting parameters for component 'channel_0_analyzer_2_array_crystal_array_2' [143]. */
char mccchannel_0_analyzer_2_array_crystal_array_2_material_string[16384];
MCNUM mccchannel_0_analyzer_2_array_crystal_array_2_priority;
MCNUM mccchannel_0_analyzer_2_array_crystal_array_2_xwidth;
MCNUM mccchannel_0_analyzer_2_array_crystal_array_2_yheight;
MCNUM mccchannel_0_analyzer_2_array_crystal_array_2_zdepth;
MCNUM mccchannel_0_analyzer_2_array_crystal_array_2_xwidth2;
MCNUM mccchannel_0_analyzer_2_array_crystal_array_2_yheight2;
MCNUM mccchannel_0_analyzer_2_array_crystal_array_2_visualize;
int mccchannel_0_analyzer_2_array_crystal_array_2_target_index;
MCNUM mccchannel_0_analyzer_2_array_crystal_array_2_target_x;
MCNUM mccchannel_0_analyzer_2_array_crystal_array_2_target_y;
MCNUM mccchannel_0_analyzer_2_array_crystal_array_2_target_z;
MCNUM mccchannel_0_analyzer_2_array_crystal_array_2_focus_aw;
MCNUM mccchannel_0_analyzer_2_array_crystal_array_2_focus_ah;
MCNUM mccchannel_0_analyzer_2_array_crystal_array_2_focus_xw;
MCNUM mccchannel_0_analyzer_2_array_crystal_array_2_focus_xh;
MCNUM mccchannel_0_analyzer_2_array_crystal_array_2_focus_r;
MCNUM mccchannel_0_analyzer_2_array_crystal_array_2_p_interact;
char mccchannel_0_analyzer_2_array_crystal_array_2_mask_string[16384];
char mccchannel_0_analyzer_2_array_crystal_array_2_mask_setting[16384];
MCNUM mccchannel_0_analyzer_2_array_crystal_array_2_number_of_activations;

/* Setting parameters for component 'channel_0_analyzer_2_array_crystal_array_3' [144]. */
char mccchannel_0_analyzer_2_array_crystal_array_3_material_string[16384];
MCNUM mccchannel_0_analyzer_2_array_crystal_array_3_priority;
MCNUM mccchannel_0_analyzer_2_array_crystal_array_3_xwidth;
MCNUM mccchannel_0_analyzer_2_array_crystal_array_3_yheight;
MCNUM mccchannel_0_analyzer_2_array_crystal_array_3_zdepth;
MCNUM mccchannel_0_analyzer_2_array_crystal_array_3_xwidth2;
MCNUM mccchannel_0_analyzer_2_array_crystal_array_3_yheight2;
MCNUM mccchannel_0_analyzer_2_array_crystal_array_3_visualize;
int mccchannel_0_analyzer_2_array_crystal_array_3_target_index;
MCNUM mccchannel_0_analyzer_2_array_crystal_array_3_target_x;
MCNUM mccchannel_0_analyzer_2_array_crystal_array_3_target_y;
MCNUM mccchannel_0_analyzer_2_array_crystal_array_3_target_z;
MCNUM mccchannel_0_analyzer_2_array_crystal_array_3_focus_aw;
MCNUM mccchannel_0_analyzer_2_array_crystal_array_3_focus_ah;
MCNUM mccchannel_0_analyzer_2_array_crystal_array_3_focus_xw;
MCNUM mccchannel_0_analyzer_2_array_crystal_array_3_focus_xh;
MCNUM mccchannel_0_analyzer_2_array_crystal_array_3_focus_r;
MCNUM mccchannel_0_analyzer_2_array_crystal_array_3_p_interact;
char mccchannel_0_analyzer_2_array_crystal_array_3_mask_string[16384];
char mccchannel_0_analyzer_2_array_crystal_array_3_mask_setting[16384];
MCNUM mccchannel_0_analyzer_2_array_crystal_array_3_number_of_activations;

/* Setting parameters for component 'channel_0_analyzer_2_array_crystal_array_4' [145]. */
char mccchannel_0_analyzer_2_array_crystal_array_4_material_string[16384];
MCNUM mccchannel_0_analyzer_2_array_crystal_array_4_priority;
MCNUM mccchannel_0_analyzer_2_array_crystal_array_4_xwidth;
MCNUM mccchannel_0_analyzer_2_array_crystal_array_4_yheight;
MCNUM mccchannel_0_analyzer_2_array_crystal_array_4_zdepth;
MCNUM mccchannel_0_analyzer_2_array_crystal_array_4_xwidth2;
MCNUM mccchannel_0_analyzer_2_array_crystal_array_4_yheight2;
MCNUM mccchannel_0_analyzer_2_array_crystal_array_4_visualize;
int mccchannel_0_analyzer_2_array_crystal_array_4_target_index;
MCNUM mccchannel_0_analyzer_2_array_crystal_array_4_target_x;
MCNUM mccchannel_0_analyzer_2_array_crystal_array_4_target_y;
MCNUM mccchannel_0_analyzer_2_array_crystal_array_4_target_z;
MCNUM mccchannel_0_analyzer_2_array_crystal_array_4_focus_aw;
MCNUM mccchannel_0_analyzer_2_array_crystal_array_4_focus_ah;
MCNUM mccchannel_0_analyzer_2_array_crystal_array_4_focus_xw;
MCNUM mccchannel_0_analyzer_2_array_crystal_array_4_focus_xh;
MCNUM mccchannel_0_analyzer_2_array_crystal_array_4_focus_r;
MCNUM mccchannel_0_analyzer_2_array_crystal_array_4_p_interact;
char mccchannel_0_analyzer_2_array_crystal_array_4_mask_string[16384];
char mccchannel_0_analyzer_2_array_crystal_array_4_mask_setting[16384];
MCNUM mccchannel_0_analyzer_2_array_crystal_array_4_number_of_activations;

/* Setting parameters for component 'channel_0_analyzer_2_array_crystal_array_5' [146]. */
char mccchannel_0_analyzer_2_array_crystal_array_5_material_string[16384];
MCNUM mccchannel_0_analyzer_2_array_crystal_array_5_priority;
MCNUM mccchannel_0_analyzer_2_array_crystal_array_5_xwidth;
MCNUM mccchannel_0_analyzer_2_array_crystal_array_5_yheight;
MCNUM mccchannel_0_analyzer_2_array_crystal_array_5_zdepth;
MCNUM mccchannel_0_analyzer_2_array_crystal_array_5_xwidth2;
MCNUM mccchannel_0_analyzer_2_array_crystal_array_5_yheight2;
MCNUM mccchannel_0_analyzer_2_array_crystal_array_5_visualize;
int mccchannel_0_analyzer_2_array_crystal_array_5_target_index;
MCNUM mccchannel_0_analyzer_2_array_crystal_array_5_target_x;
MCNUM mccchannel_0_analyzer_2_array_crystal_array_5_target_y;
MCNUM mccchannel_0_analyzer_2_array_crystal_array_5_target_z;
MCNUM mccchannel_0_analyzer_2_array_crystal_array_5_focus_aw;
MCNUM mccchannel_0_analyzer_2_array_crystal_array_5_focus_ah;
MCNUM mccchannel_0_analyzer_2_array_crystal_array_5_focus_xw;
MCNUM mccchannel_0_analyzer_2_array_crystal_array_5_focus_xh;
MCNUM mccchannel_0_analyzer_2_array_crystal_array_5_focus_r;
MCNUM mccchannel_0_analyzer_2_array_crystal_array_5_p_interact;
char mccchannel_0_analyzer_2_array_crystal_array_5_mask_string[16384];
char mccchannel_0_analyzer_2_array_crystal_array_5_mask_setting[16384];
MCNUM mccchannel_0_analyzer_2_array_crystal_array_5_number_of_activations;

/* Setting parameters for component 'channel_0_analyzer_2_array_crystal_array_6' [147]. */
char mccchannel_0_analyzer_2_array_crystal_array_6_material_string[16384];
MCNUM mccchannel_0_analyzer_2_array_crystal_array_6_priority;
MCNUM mccchannel_0_analyzer_2_array_crystal_array_6_xwidth;
MCNUM mccchannel_0_analyzer_2_array_crystal_array_6_yheight;
MCNUM mccchannel_0_analyzer_2_array_crystal_array_6_zdepth;
MCNUM mccchannel_0_analyzer_2_array_crystal_array_6_xwidth2;
MCNUM mccchannel_0_analyzer_2_array_crystal_array_6_yheight2;
MCNUM mccchannel_0_analyzer_2_array_crystal_array_6_visualize;
int mccchannel_0_analyzer_2_array_crystal_array_6_target_index;
MCNUM mccchannel_0_analyzer_2_array_crystal_array_6_target_x;
MCNUM mccchannel_0_analyzer_2_array_crystal_array_6_target_y;
MCNUM mccchannel_0_analyzer_2_array_crystal_array_6_target_z;
MCNUM mccchannel_0_analyzer_2_array_crystal_array_6_focus_aw;
MCNUM mccchannel_0_analyzer_2_array_crystal_array_6_focus_ah;
MCNUM mccchannel_0_analyzer_2_array_crystal_array_6_focus_xw;
MCNUM mccchannel_0_analyzer_2_array_crystal_array_6_focus_xh;
MCNUM mccchannel_0_analyzer_2_array_crystal_array_6_focus_r;
MCNUM mccchannel_0_analyzer_2_array_crystal_array_6_p_interact;
char mccchannel_0_analyzer_2_array_crystal_array_6_mask_string[16384];
char mccchannel_0_analyzer_2_array_crystal_array_6_mask_setting[16384];
MCNUM mccchannel_0_analyzer_2_array_crystal_array_6_number_of_activations;

/* Setting parameters for component 'channel_0_analyzer_2_array_crystal_array_7' [148]. */
char mccchannel_0_analyzer_2_array_crystal_array_7_material_string[16384];
MCNUM mccchannel_0_analyzer_2_array_crystal_array_7_priority;
MCNUM mccchannel_0_analyzer_2_array_crystal_array_7_xwidth;
MCNUM mccchannel_0_analyzer_2_array_crystal_array_7_yheight;
MCNUM mccchannel_0_analyzer_2_array_crystal_array_7_zdepth;
MCNUM mccchannel_0_analyzer_2_array_crystal_array_7_xwidth2;
MCNUM mccchannel_0_analyzer_2_array_crystal_array_7_yheight2;
MCNUM mccchannel_0_analyzer_2_array_crystal_array_7_visualize;
int mccchannel_0_analyzer_2_array_crystal_array_7_target_index;
MCNUM mccchannel_0_analyzer_2_array_crystal_array_7_target_x;
MCNUM mccchannel_0_analyzer_2_array_crystal_array_7_target_y;
MCNUM mccchannel_0_analyzer_2_array_crystal_array_7_target_z;
MCNUM mccchannel_0_analyzer_2_array_crystal_array_7_focus_aw;
MCNUM mccchannel_0_analyzer_2_array_crystal_array_7_focus_ah;
MCNUM mccchannel_0_analyzer_2_array_crystal_array_7_focus_xw;
MCNUM mccchannel_0_analyzer_2_array_crystal_array_7_focus_xh;
MCNUM mccchannel_0_analyzer_2_array_crystal_array_7_focus_r;
MCNUM mccchannel_0_analyzer_2_array_crystal_array_7_p_interact;
char mccchannel_0_analyzer_2_array_crystal_array_7_mask_string[16384];
char mccchannel_0_analyzer_2_array_crystal_array_7_mask_setting[16384];
MCNUM mccchannel_0_analyzer_2_array_crystal_array_7_number_of_activations;

/* Setting parameters for component 'channel_0_analyzer_2_array_crystal_array_8' [149]. */
char mccchannel_0_analyzer_2_array_crystal_array_8_material_string[16384];
MCNUM mccchannel_0_analyzer_2_array_crystal_array_8_priority;
MCNUM mccchannel_0_analyzer_2_array_crystal_array_8_xwidth;
MCNUM mccchannel_0_analyzer_2_array_crystal_array_8_yheight;
MCNUM mccchannel_0_analyzer_2_array_crystal_array_8_zdepth;
MCNUM mccchannel_0_analyzer_2_array_crystal_array_8_xwidth2;
MCNUM mccchannel_0_analyzer_2_array_crystal_array_8_yheight2;
MCNUM mccchannel_0_analyzer_2_array_crystal_array_8_visualize;
int mccchannel_0_analyzer_2_array_crystal_array_8_target_index;
MCNUM mccchannel_0_analyzer_2_array_crystal_array_8_target_x;
MCNUM mccchannel_0_analyzer_2_array_crystal_array_8_target_y;
MCNUM mccchannel_0_analyzer_2_array_crystal_array_8_target_z;
MCNUM mccchannel_0_analyzer_2_array_crystal_array_8_focus_aw;
MCNUM mccchannel_0_analyzer_2_array_crystal_array_8_focus_ah;
MCNUM mccchannel_0_analyzer_2_array_crystal_array_8_focus_xw;
MCNUM mccchannel_0_analyzer_2_array_crystal_array_8_focus_xh;
MCNUM mccchannel_0_analyzer_2_array_crystal_array_8_focus_r;
MCNUM mccchannel_0_analyzer_2_array_crystal_array_8_p_interact;
char mccchannel_0_analyzer_2_array_crystal_array_8_mask_string[16384];
char mccchannel_0_analyzer_2_array_crystal_array_8_mask_setting[16384];
MCNUM mccchannel_0_analyzer_2_array_crystal_array_8_number_of_activations;

/* Setting parameters for component 'channel_0_cave2_cyl1' [150]. */
char mccchannel_0_cave2_cyl1_material_string[16384];
MCNUM mccchannel_0_cave2_cyl1_priority;
MCNUM mccchannel_0_cave2_cyl1_radius;
MCNUM mccchannel_0_cave2_cyl1_yheight;
MCNUM mccchannel_0_cave2_cyl1_visualize;
int mccchannel_0_cave2_cyl1_target_index;
MCNUM mccchannel_0_cave2_cyl1_target_x;
MCNUM mccchannel_0_cave2_cyl1_target_y;
MCNUM mccchannel_0_cave2_cyl1_target_z;
MCNUM mccchannel_0_cave2_cyl1_focus_aw;
MCNUM mccchannel_0_cave2_cyl1_focus_ah;
MCNUM mccchannel_0_cave2_cyl1_focus_xw;
MCNUM mccchannel_0_cave2_cyl1_focus_xh;
MCNUM mccchannel_0_cave2_cyl1_focus_r;
MCNUM mccchannel_0_cave2_cyl1_p_interact;
char mccchannel_0_cave2_cyl1_mask_string[16384];
char mccchannel_0_cave2_cyl1_mask_setting[16384];
MCNUM mccchannel_0_cave2_cyl1_number_of_activations;

/* Setting parameters for component 'channel_0_cave2_box1' [151]. */
char mccchannel_0_cave2_box1_material_string[16384];
MCNUM mccchannel_0_cave2_box1_priority;
MCNUM mccchannel_0_cave2_box1_xwidth;
MCNUM mccchannel_0_cave2_box1_yheight;
MCNUM mccchannel_0_cave2_box1_zdepth;
MCNUM mccchannel_0_cave2_box1_xwidth2;
MCNUM mccchannel_0_cave2_box1_yheight2;
MCNUM mccchannel_0_cave2_box1_visualize;
int mccchannel_0_cave2_box1_target_index;
MCNUM mccchannel_0_cave2_box1_target_x;
MCNUM mccchannel_0_cave2_box1_target_y;
MCNUM mccchannel_0_cave2_box1_target_z;
MCNUM mccchannel_0_cave2_box1_focus_aw;
MCNUM mccchannel_0_cave2_box1_focus_ah;
MCNUM mccchannel_0_cave2_box1_focus_xw;
MCNUM mccchannel_0_cave2_box1_focus_xh;
MCNUM mccchannel_0_cave2_box1_focus_r;
MCNUM mccchannel_0_cave2_box1_p_interact;
char mccchannel_0_cave2_box1_mask_string[16384];
char mccchannel_0_cave2_box1_mask_setting[16384];
MCNUM mccchannel_0_cave2_box1_number_of_activations;

/* Setting parameters for component 'channel_0_cave2_box2' [152]. */
char mccchannel_0_cave2_box2_material_string[16384];
MCNUM mccchannel_0_cave2_box2_priority;
MCNUM mccchannel_0_cave2_box2_xwidth;
MCNUM mccchannel_0_cave2_box2_yheight;
MCNUM mccchannel_0_cave2_box2_zdepth;
MCNUM mccchannel_0_cave2_box2_xwidth2;
MCNUM mccchannel_0_cave2_box2_yheight2;
MCNUM mccchannel_0_cave2_box2_visualize;
int mccchannel_0_cave2_box2_target_index;
MCNUM mccchannel_0_cave2_box2_target_x;
MCNUM mccchannel_0_cave2_box2_target_y;
MCNUM mccchannel_0_cave2_box2_target_z;
MCNUM mccchannel_0_cave2_box2_focus_aw;
MCNUM mccchannel_0_cave2_box2_focus_ah;
MCNUM mccchannel_0_cave2_box2_focus_xw;
MCNUM mccchannel_0_cave2_box2_focus_xh;
MCNUM mccchannel_0_cave2_box2_focus_r;
MCNUM mccchannel_0_cave2_box2_p_interact;
char mccchannel_0_cave2_box2_mask_string[16384];
char mccchannel_0_cave2_box2_mask_setting[16384];
MCNUM mccchannel_0_cave2_box2_number_of_activations;

/* Setting parameters for component 'channel_0_cave2_box3' [153]. */
char mccchannel_0_cave2_box3_material_string[16384];
MCNUM mccchannel_0_cave2_box3_priority;
MCNUM mccchannel_0_cave2_box3_xwidth;
MCNUM mccchannel_0_cave2_box3_yheight;
MCNUM mccchannel_0_cave2_box3_zdepth;
MCNUM mccchannel_0_cave2_box3_xwidth2;
MCNUM mccchannel_0_cave2_box3_yheight2;
MCNUM mccchannel_0_cave2_box3_visualize;
int mccchannel_0_cave2_box3_target_index;
MCNUM mccchannel_0_cave2_box3_target_x;
MCNUM mccchannel_0_cave2_box3_target_y;
MCNUM mccchannel_0_cave2_box3_target_z;
MCNUM mccchannel_0_cave2_box3_focus_aw;
MCNUM mccchannel_0_cave2_box3_focus_ah;
MCNUM mccchannel_0_cave2_box3_focus_xw;
MCNUM mccchannel_0_cave2_box3_focus_xh;
MCNUM mccchannel_0_cave2_box3_focus_r;
MCNUM mccchannel_0_cave2_box3_p_interact;
char mccchannel_0_cave2_box3_mask_string[16384];
char mccchannel_0_cave2_box3_mask_setting[16384];
MCNUM mccchannel_0_cave2_box3_number_of_activations;

/* Setting parameters for component 'inter_analyzer_colimator_0_blade_0' [155]. */
char mccinter_analyzer_colimator_0_blade_0_material_string[16384];
MCNUM mccinter_analyzer_colimator_0_blade_0_priority;
MCNUM mccinter_analyzer_colimator_0_blade_0_xwidth;
MCNUM mccinter_analyzer_colimator_0_blade_0_yheight;
MCNUM mccinter_analyzer_colimator_0_blade_0_zdepth;
MCNUM mccinter_analyzer_colimator_0_blade_0_xwidth2;
MCNUM mccinter_analyzer_colimator_0_blade_0_yheight2;
MCNUM mccinter_analyzer_colimator_0_blade_0_visualize;
int mccinter_analyzer_colimator_0_blade_0_target_index;
MCNUM mccinter_analyzer_colimator_0_blade_0_target_x;
MCNUM mccinter_analyzer_colimator_0_blade_0_target_y;
MCNUM mccinter_analyzer_colimator_0_blade_0_target_z;
MCNUM mccinter_analyzer_colimator_0_blade_0_focus_aw;
MCNUM mccinter_analyzer_colimator_0_blade_0_focus_ah;
MCNUM mccinter_analyzer_colimator_0_blade_0_focus_xw;
MCNUM mccinter_analyzer_colimator_0_blade_0_focus_xh;
MCNUM mccinter_analyzer_colimator_0_blade_0_focus_r;
MCNUM mccinter_analyzer_colimator_0_blade_0_p_interact;
char mccinter_analyzer_colimator_0_blade_0_mask_string[16384];
char mccinter_analyzer_colimator_0_blade_0_mask_setting[16384];
MCNUM mccinter_analyzer_colimator_0_blade_0_number_of_activations;

/* Setting parameters for component 'inter_analyzer_colimator_0_blade_1' [156]. */
char mccinter_analyzer_colimator_0_blade_1_material_string[16384];
MCNUM mccinter_analyzer_colimator_0_blade_1_priority;
MCNUM mccinter_analyzer_colimator_0_blade_1_xwidth;
MCNUM mccinter_analyzer_colimator_0_blade_1_yheight;
MCNUM mccinter_analyzer_colimator_0_blade_1_zdepth;
MCNUM mccinter_analyzer_colimator_0_blade_1_xwidth2;
MCNUM mccinter_analyzer_colimator_0_blade_1_yheight2;
MCNUM mccinter_analyzer_colimator_0_blade_1_visualize;
int mccinter_analyzer_colimator_0_blade_1_target_index;
MCNUM mccinter_analyzer_colimator_0_blade_1_target_x;
MCNUM mccinter_analyzer_colimator_0_blade_1_target_y;
MCNUM mccinter_analyzer_colimator_0_blade_1_target_z;
MCNUM mccinter_analyzer_colimator_0_blade_1_focus_aw;
MCNUM mccinter_analyzer_colimator_0_blade_1_focus_ah;
MCNUM mccinter_analyzer_colimator_0_blade_1_focus_xw;
MCNUM mccinter_analyzer_colimator_0_blade_1_focus_xh;
MCNUM mccinter_analyzer_colimator_0_blade_1_focus_r;
MCNUM mccinter_analyzer_colimator_0_blade_1_p_interact;
char mccinter_analyzer_colimator_0_blade_1_mask_string[16384];
char mccinter_analyzer_colimator_0_blade_1_mask_setting[16384];
MCNUM mccinter_analyzer_colimator_0_blade_1_number_of_activations;

/* Setting parameters for component 'inter_analyzer_colimator_0_blade_2' [157]. */
char mccinter_analyzer_colimator_0_blade_2_material_string[16384];
MCNUM mccinter_analyzer_colimator_0_blade_2_priority;
MCNUM mccinter_analyzer_colimator_0_blade_2_xwidth;
MCNUM mccinter_analyzer_colimator_0_blade_2_yheight;
MCNUM mccinter_analyzer_colimator_0_blade_2_zdepth;
MCNUM mccinter_analyzer_colimator_0_blade_2_xwidth2;
MCNUM mccinter_analyzer_colimator_0_blade_2_yheight2;
MCNUM mccinter_analyzer_colimator_0_blade_2_visualize;
int mccinter_analyzer_colimator_0_blade_2_target_index;
MCNUM mccinter_analyzer_colimator_0_blade_2_target_x;
MCNUM mccinter_analyzer_colimator_0_blade_2_target_y;
MCNUM mccinter_analyzer_colimator_0_blade_2_target_z;
MCNUM mccinter_analyzer_colimator_0_blade_2_focus_aw;
MCNUM mccinter_analyzer_colimator_0_blade_2_focus_ah;
MCNUM mccinter_analyzer_colimator_0_blade_2_focus_xw;
MCNUM mccinter_analyzer_colimator_0_blade_2_focus_xh;
MCNUM mccinter_analyzer_colimator_0_blade_2_focus_r;
MCNUM mccinter_analyzer_colimator_0_blade_2_p_interact;
char mccinter_analyzer_colimator_0_blade_2_mask_string[16384];
char mccinter_analyzer_colimator_0_blade_2_mask_setting[16384];
MCNUM mccinter_analyzer_colimator_0_blade_2_number_of_activations;

/* Setting parameters for component 'inter_analyzer_colimator_0_blade_3' [158]. */
char mccinter_analyzer_colimator_0_blade_3_material_string[16384];
MCNUM mccinter_analyzer_colimator_0_blade_3_priority;
MCNUM mccinter_analyzer_colimator_0_blade_3_xwidth;
MCNUM mccinter_analyzer_colimator_0_blade_3_yheight;
MCNUM mccinter_analyzer_colimator_0_blade_3_zdepth;
MCNUM mccinter_analyzer_colimator_0_blade_3_xwidth2;
MCNUM mccinter_analyzer_colimator_0_blade_3_yheight2;
MCNUM mccinter_analyzer_colimator_0_blade_3_visualize;
int mccinter_analyzer_colimator_0_blade_3_target_index;
MCNUM mccinter_analyzer_colimator_0_blade_3_target_x;
MCNUM mccinter_analyzer_colimator_0_blade_3_target_y;
MCNUM mccinter_analyzer_colimator_0_blade_3_target_z;
MCNUM mccinter_analyzer_colimator_0_blade_3_focus_aw;
MCNUM mccinter_analyzer_colimator_0_blade_3_focus_ah;
MCNUM mccinter_analyzer_colimator_0_blade_3_focus_xw;
MCNUM mccinter_analyzer_colimator_0_blade_3_focus_xh;
MCNUM mccinter_analyzer_colimator_0_blade_3_focus_r;
MCNUM mccinter_analyzer_colimator_0_blade_3_p_interact;
char mccinter_analyzer_colimator_0_blade_3_mask_string[16384];
char mccinter_analyzer_colimator_0_blade_3_mask_setting[16384];
MCNUM mccinter_analyzer_colimator_0_blade_3_number_of_activations;

/* Setting parameters for component 'inter_analyzer_colimator_0_blade_4' [159]. */
char mccinter_analyzer_colimator_0_blade_4_material_string[16384];
MCNUM mccinter_analyzer_colimator_0_blade_4_priority;
MCNUM mccinter_analyzer_colimator_0_blade_4_xwidth;
MCNUM mccinter_analyzer_colimator_0_blade_4_yheight;
MCNUM mccinter_analyzer_colimator_0_blade_4_zdepth;
MCNUM mccinter_analyzer_colimator_0_blade_4_xwidth2;
MCNUM mccinter_analyzer_colimator_0_blade_4_yheight2;
MCNUM mccinter_analyzer_colimator_0_blade_4_visualize;
int mccinter_analyzer_colimator_0_blade_4_target_index;
MCNUM mccinter_analyzer_colimator_0_blade_4_target_x;
MCNUM mccinter_analyzer_colimator_0_blade_4_target_y;
MCNUM mccinter_analyzer_colimator_0_blade_4_target_z;
MCNUM mccinter_analyzer_colimator_0_blade_4_focus_aw;
MCNUM mccinter_analyzer_colimator_0_blade_4_focus_ah;
MCNUM mccinter_analyzer_colimator_0_blade_4_focus_xw;
MCNUM mccinter_analyzer_colimator_0_blade_4_focus_xh;
MCNUM mccinter_analyzer_colimator_0_blade_4_focus_r;
MCNUM mccinter_analyzer_colimator_0_blade_4_p_interact;
char mccinter_analyzer_colimator_0_blade_4_mask_string[16384];
char mccinter_analyzer_colimator_0_blade_4_mask_setting[16384];
MCNUM mccinter_analyzer_colimator_0_blade_4_number_of_activations;

/* Setting parameters for component 'diffraction_detector_0_exit_volume' [160]. */
char mccdiffraction_detector_0_exit_volume_material_string[16384];
MCNUM mccdiffraction_detector_0_exit_volume_priority;
MCNUM mccdiffraction_detector_0_exit_volume_xwidth;
MCNUM mccdiffraction_detector_0_exit_volume_yheight;
MCNUM mccdiffraction_detector_0_exit_volume_zdepth;
MCNUM mccdiffraction_detector_0_exit_volume_xwidth2;
MCNUM mccdiffraction_detector_0_exit_volume_yheight2;
MCNUM mccdiffraction_detector_0_exit_volume_visualize;
int mccdiffraction_detector_0_exit_volume_target_index;
MCNUM mccdiffraction_detector_0_exit_volume_target_x;
MCNUM mccdiffraction_detector_0_exit_volume_target_y;
MCNUM mccdiffraction_detector_0_exit_volume_target_z;
MCNUM mccdiffraction_detector_0_exit_volume_focus_aw;
MCNUM mccdiffraction_detector_0_exit_volume_focus_ah;
MCNUM mccdiffraction_detector_0_exit_volume_focus_xw;
MCNUM mccdiffraction_detector_0_exit_volume_focus_xh;
MCNUM mccdiffraction_detector_0_exit_volume_focus_r;
MCNUM mccdiffraction_detector_0_exit_volume_p_interact;
char mccdiffraction_detector_0_exit_volume_mask_string[16384];
char mccdiffraction_detector_0_exit_volume_mask_setting[16384];
MCNUM mccdiffraction_detector_0_exit_volume_number_of_activations;

/* Setting parameters for component 'spec_detector_0_exit_volume' [161]. */
char mccspec_detector_0_exit_volume_material_string[16384];
MCNUM mccspec_detector_0_exit_volume_priority;
MCNUM mccspec_detector_0_exit_volume_xwidth;
MCNUM mccspec_detector_0_exit_volume_yheight;
MCNUM mccspec_detector_0_exit_volume_zdepth;
MCNUM mccspec_detector_0_exit_volume_xwidth2;
MCNUM mccspec_detector_0_exit_volume_yheight2;
MCNUM mccspec_detector_0_exit_volume_visualize;
int mccspec_detector_0_exit_volume_target_index;
MCNUM mccspec_detector_0_exit_volume_target_x;
MCNUM mccspec_detector_0_exit_volume_target_y;
MCNUM mccspec_detector_0_exit_volume_target_z;
MCNUM mccspec_detector_0_exit_volume_focus_aw;
MCNUM mccspec_detector_0_exit_volume_focus_ah;
MCNUM mccspec_detector_0_exit_volume_focus_xw;
MCNUM mccspec_detector_0_exit_volume_focus_xh;
MCNUM mccspec_detector_0_exit_volume_focus_r;
MCNUM mccspec_detector_0_exit_volume_p_interact;
char mccspec_detector_0_exit_volume_mask_string[16384];
char mccspec_detector_0_exit_volume_mask_setting[16384];
MCNUM mccspec_detector_0_exit_volume_number_of_activations;

/* Setting parameters for component 'channel_1_cave1_box1' [162]. */
char mccchannel_1_cave1_box1_material_string[16384];
MCNUM mccchannel_1_cave1_box1_priority;
MCNUM mccchannel_1_cave1_box1_xwidth;
MCNUM mccchannel_1_cave1_box1_yheight;
MCNUM mccchannel_1_cave1_box1_zdepth;
MCNUM mccchannel_1_cave1_box1_xwidth2;
MCNUM mccchannel_1_cave1_box1_yheight2;
MCNUM mccchannel_1_cave1_box1_visualize;
int mccchannel_1_cave1_box1_target_index;
MCNUM mccchannel_1_cave1_box1_target_x;
MCNUM mccchannel_1_cave1_box1_target_y;
MCNUM mccchannel_1_cave1_box1_target_z;
MCNUM mccchannel_1_cave1_box1_focus_aw;
MCNUM mccchannel_1_cave1_box1_focus_ah;
MCNUM mccchannel_1_cave1_box1_focus_xw;
MCNUM mccchannel_1_cave1_box1_focus_xh;
MCNUM mccchannel_1_cave1_box1_focus_r;
MCNUM mccchannel_1_cave1_box1_p_interact;
char mccchannel_1_cave1_box1_mask_string[16384];
char mccchannel_1_cave1_box1_mask_setting[16384];
MCNUM mccchannel_1_cave1_box1_number_of_activations;

/* Setting parameters for component 'channel_1_cave1_box2' [163]. */
char mccchannel_1_cave1_box2_material_string[16384];
MCNUM mccchannel_1_cave1_box2_priority;
MCNUM mccchannel_1_cave1_box2_xwidth;
MCNUM mccchannel_1_cave1_box2_yheight;
MCNUM mccchannel_1_cave1_box2_zdepth;
MCNUM mccchannel_1_cave1_box2_xwidth2;
MCNUM mccchannel_1_cave1_box2_yheight2;
MCNUM mccchannel_1_cave1_box2_visualize;
int mccchannel_1_cave1_box2_target_index;
MCNUM mccchannel_1_cave1_box2_target_x;
MCNUM mccchannel_1_cave1_box2_target_y;
MCNUM mccchannel_1_cave1_box2_target_z;
MCNUM mccchannel_1_cave1_box2_focus_aw;
MCNUM mccchannel_1_cave1_box2_focus_ah;
MCNUM mccchannel_1_cave1_box2_focus_xw;
MCNUM mccchannel_1_cave1_box2_focus_xh;
MCNUM mccchannel_1_cave1_box2_focus_r;
MCNUM mccchannel_1_cave1_box2_p_interact;
char mccchannel_1_cave1_box2_mask_string[16384];
char mccchannel_1_cave1_box2_mask_setting[16384];
MCNUM mccchannel_1_cave1_box2_number_of_activations;

/* Setting parameters for component 'channel_1_cave1_box3' [164]. */
char mccchannel_1_cave1_box3_material_string[16384];
MCNUM mccchannel_1_cave1_box3_priority;
MCNUM mccchannel_1_cave1_box3_xwidth;
MCNUM mccchannel_1_cave1_box3_yheight;
MCNUM mccchannel_1_cave1_box3_zdepth;
MCNUM mccchannel_1_cave1_box3_xwidth2;
MCNUM mccchannel_1_cave1_box3_yheight2;
MCNUM mccchannel_1_cave1_box3_visualize;
int mccchannel_1_cave1_box3_target_index;
MCNUM mccchannel_1_cave1_box3_target_x;
MCNUM mccchannel_1_cave1_box3_target_y;
MCNUM mccchannel_1_cave1_box3_target_z;
MCNUM mccchannel_1_cave1_box3_focus_aw;
MCNUM mccchannel_1_cave1_box3_focus_ah;
MCNUM mccchannel_1_cave1_box3_focus_xw;
MCNUM mccchannel_1_cave1_box3_focus_xh;
MCNUM mccchannel_1_cave1_box3_focus_r;
MCNUM mccchannel_1_cave1_box3_p_interact;
char mccchannel_1_cave1_box3_mask_string[16384];
char mccchannel_1_cave1_box3_mask_setting[16384];
MCNUM mccchannel_1_cave1_box3_number_of_activations;

/* Setting parameters for component 'channel_1_cave1_cyl1' [165]. */
char mccchannel_1_cave1_cyl1_material_string[16384];
MCNUM mccchannel_1_cave1_cyl1_priority;
MCNUM mccchannel_1_cave1_cyl1_radius;
MCNUM mccchannel_1_cave1_cyl1_yheight;
MCNUM mccchannel_1_cave1_cyl1_visualize;
int mccchannel_1_cave1_cyl1_target_index;
MCNUM mccchannel_1_cave1_cyl1_target_x;
MCNUM mccchannel_1_cave1_cyl1_target_y;
MCNUM mccchannel_1_cave1_cyl1_target_z;
MCNUM mccchannel_1_cave1_cyl1_focus_aw;
MCNUM mccchannel_1_cave1_cyl1_focus_ah;
MCNUM mccchannel_1_cave1_cyl1_focus_xw;
MCNUM mccchannel_1_cave1_cyl1_focus_xh;
MCNUM mccchannel_1_cave1_cyl1_focus_r;
MCNUM mccchannel_1_cave1_cyl1_p_interact;
char mccchannel_1_cave1_cyl1_mask_string[16384];
char mccchannel_1_cave1_cyl1_mask_setting[16384];
MCNUM mccchannel_1_cave1_cyl1_number_of_activations;

/* Setting parameters for component 'channel_1_analyzer_1_array_crystal_array_0' [168]. */
char mccchannel_1_analyzer_1_array_crystal_array_0_material_string[16384];
MCNUM mccchannel_1_analyzer_1_array_crystal_array_0_priority;
MCNUM mccchannel_1_analyzer_1_array_crystal_array_0_xwidth;
MCNUM mccchannel_1_analyzer_1_array_crystal_array_0_yheight;
MCNUM mccchannel_1_analyzer_1_array_crystal_array_0_zdepth;
MCNUM mccchannel_1_analyzer_1_array_crystal_array_0_xwidth2;
MCNUM mccchannel_1_analyzer_1_array_crystal_array_0_yheight2;
MCNUM mccchannel_1_analyzer_1_array_crystal_array_0_visualize;
int mccchannel_1_analyzer_1_array_crystal_array_0_target_index;
MCNUM mccchannel_1_analyzer_1_array_crystal_array_0_target_x;
MCNUM mccchannel_1_analyzer_1_array_crystal_array_0_target_y;
MCNUM mccchannel_1_analyzer_1_array_crystal_array_0_target_z;
MCNUM mccchannel_1_analyzer_1_array_crystal_array_0_focus_aw;
MCNUM mccchannel_1_analyzer_1_array_crystal_array_0_focus_ah;
MCNUM mccchannel_1_analyzer_1_array_crystal_array_0_focus_xw;
MCNUM mccchannel_1_analyzer_1_array_crystal_array_0_focus_xh;
MCNUM mccchannel_1_analyzer_1_array_crystal_array_0_focus_r;
MCNUM mccchannel_1_analyzer_1_array_crystal_array_0_p_interact;
char mccchannel_1_analyzer_1_array_crystal_array_0_mask_string[16384];
char mccchannel_1_analyzer_1_array_crystal_array_0_mask_setting[16384];
MCNUM mccchannel_1_analyzer_1_array_crystal_array_0_number_of_activations;

/* Setting parameters for component 'channel_1_analyzer_1_array_crystal_array_1' [169]. */
char mccchannel_1_analyzer_1_array_crystal_array_1_material_string[16384];
MCNUM mccchannel_1_analyzer_1_array_crystal_array_1_priority;
MCNUM mccchannel_1_analyzer_1_array_crystal_array_1_xwidth;
MCNUM mccchannel_1_analyzer_1_array_crystal_array_1_yheight;
MCNUM mccchannel_1_analyzer_1_array_crystal_array_1_zdepth;
MCNUM mccchannel_1_analyzer_1_array_crystal_array_1_xwidth2;
MCNUM mccchannel_1_analyzer_1_array_crystal_array_1_yheight2;
MCNUM mccchannel_1_analyzer_1_array_crystal_array_1_visualize;
int mccchannel_1_analyzer_1_array_crystal_array_1_target_index;
MCNUM mccchannel_1_analyzer_1_array_crystal_array_1_target_x;
MCNUM mccchannel_1_analyzer_1_array_crystal_array_1_target_y;
MCNUM mccchannel_1_analyzer_1_array_crystal_array_1_target_z;
MCNUM mccchannel_1_analyzer_1_array_crystal_array_1_focus_aw;
MCNUM mccchannel_1_analyzer_1_array_crystal_array_1_focus_ah;
MCNUM mccchannel_1_analyzer_1_array_crystal_array_1_focus_xw;
MCNUM mccchannel_1_analyzer_1_array_crystal_array_1_focus_xh;
MCNUM mccchannel_1_analyzer_1_array_crystal_array_1_focus_r;
MCNUM mccchannel_1_analyzer_1_array_crystal_array_1_p_interact;
char mccchannel_1_analyzer_1_array_crystal_array_1_mask_string[16384];
char mccchannel_1_analyzer_1_array_crystal_array_1_mask_setting[16384];
MCNUM mccchannel_1_analyzer_1_array_crystal_array_1_number_of_activations;

/* Setting parameters for component 'channel_1_analyzer_1_array_crystal_array_2' [170]. */
char mccchannel_1_analyzer_1_array_crystal_array_2_material_string[16384];
MCNUM mccchannel_1_analyzer_1_array_crystal_array_2_priority;
MCNUM mccchannel_1_analyzer_1_array_crystal_array_2_xwidth;
MCNUM mccchannel_1_analyzer_1_array_crystal_array_2_yheight;
MCNUM mccchannel_1_analyzer_1_array_crystal_array_2_zdepth;
MCNUM mccchannel_1_analyzer_1_array_crystal_array_2_xwidth2;
MCNUM mccchannel_1_analyzer_1_array_crystal_array_2_yheight2;
MCNUM mccchannel_1_analyzer_1_array_crystal_array_2_visualize;
int mccchannel_1_analyzer_1_array_crystal_array_2_target_index;
MCNUM mccchannel_1_analyzer_1_array_crystal_array_2_target_x;
MCNUM mccchannel_1_analyzer_1_array_crystal_array_2_target_y;
MCNUM mccchannel_1_analyzer_1_array_crystal_array_2_target_z;
MCNUM mccchannel_1_analyzer_1_array_crystal_array_2_focus_aw;
MCNUM mccchannel_1_analyzer_1_array_crystal_array_2_focus_ah;
MCNUM mccchannel_1_analyzer_1_array_crystal_array_2_focus_xw;
MCNUM mccchannel_1_analyzer_1_array_crystal_array_2_focus_xh;
MCNUM mccchannel_1_analyzer_1_array_crystal_array_2_focus_r;
MCNUM mccchannel_1_analyzer_1_array_crystal_array_2_p_interact;
char mccchannel_1_analyzer_1_array_crystal_array_2_mask_string[16384];
char mccchannel_1_analyzer_1_array_crystal_array_2_mask_setting[16384];
MCNUM mccchannel_1_analyzer_1_array_crystal_array_2_number_of_activations;

/* Setting parameters for component 'channel_1_analyzer_1_array_crystal_array_3' [171]. */
char mccchannel_1_analyzer_1_array_crystal_array_3_material_string[16384];
MCNUM mccchannel_1_analyzer_1_array_crystal_array_3_priority;
MCNUM mccchannel_1_analyzer_1_array_crystal_array_3_xwidth;
MCNUM mccchannel_1_analyzer_1_array_crystal_array_3_yheight;
MCNUM mccchannel_1_analyzer_1_array_crystal_array_3_zdepth;
MCNUM mccchannel_1_analyzer_1_array_crystal_array_3_xwidth2;
MCNUM mccchannel_1_analyzer_1_array_crystal_array_3_yheight2;
MCNUM mccchannel_1_analyzer_1_array_crystal_array_3_visualize;
int mccchannel_1_analyzer_1_array_crystal_array_3_target_index;
MCNUM mccchannel_1_analyzer_1_array_crystal_array_3_target_x;
MCNUM mccchannel_1_analyzer_1_array_crystal_array_3_target_y;
MCNUM mccchannel_1_analyzer_1_array_crystal_array_3_target_z;
MCNUM mccchannel_1_analyzer_1_array_crystal_array_3_focus_aw;
MCNUM mccchannel_1_analyzer_1_array_crystal_array_3_focus_ah;
MCNUM mccchannel_1_analyzer_1_array_crystal_array_3_focus_xw;
MCNUM mccchannel_1_analyzer_1_array_crystal_array_3_focus_xh;
MCNUM mccchannel_1_analyzer_1_array_crystal_array_3_focus_r;
MCNUM mccchannel_1_analyzer_1_array_crystal_array_3_p_interact;
char mccchannel_1_analyzer_1_array_crystal_array_3_mask_string[16384];
char mccchannel_1_analyzer_1_array_crystal_array_3_mask_setting[16384];
MCNUM mccchannel_1_analyzer_1_array_crystal_array_3_number_of_activations;

/* Setting parameters for component 'channel_1_analyzer_1_array_crystal_array_4' [172]. */
char mccchannel_1_analyzer_1_array_crystal_array_4_material_string[16384];
MCNUM mccchannel_1_analyzer_1_array_crystal_array_4_priority;
MCNUM mccchannel_1_analyzer_1_array_crystal_array_4_xwidth;
MCNUM mccchannel_1_analyzer_1_array_crystal_array_4_yheight;
MCNUM mccchannel_1_analyzer_1_array_crystal_array_4_zdepth;
MCNUM mccchannel_1_analyzer_1_array_crystal_array_4_xwidth2;
MCNUM mccchannel_1_analyzer_1_array_crystal_array_4_yheight2;
MCNUM mccchannel_1_analyzer_1_array_crystal_array_4_visualize;
int mccchannel_1_analyzer_1_array_crystal_array_4_target_index;
MCNUM mccchannel_1_analyzer_1_array_crystal_array_4_target_x;
MCNUM mccchannel_1_analyzer_1_array_crystal_array_4_target_y;
MCNUM mccchannel_1_analyzer_1_array_crystal_array_4_target_z;
MCNUM mccchannel_1_analyzer_1_array_crystal_array_4_focus_aw;
MCNUM mccchannel_1_analyzer_1_array_crystal_array_4_focus_ah;
MCNUM mccchannel_1_analyzer_1_array_crystal_array_4_focus_xw;
MCNUM mccchannel_1_analyzer_1_array_crystal_array_4_focus_xh;
MCNUM mccchannel_1_analyzer_1_array_crystal_array_4_focus_r;
MCNUM mccchannel_1_analyzer_1_array_crystal_array_4_p_interact;
char mccchannel_1_analyzer_1_array_crystal_array_4_mask_string[16384];
char mccchannel_1_analyzer_1_array_crystal_array_4_mask_setting[16384];
MCNUM mccchannel_1_analyzer_1_array_crystal_array_4_number_of_activations;

/* Setting parameters for component 'channel_1_analyzer_1_array_crystal_array_5' [173]. */
char mccchannel_1_analyzer_1_array_crystal_array_5_material_string[16384];
MCNUM mccchannel_1_analyzer_1_array_crystal_array_5_priority;
MCNUM mccchannel_1_analyzer_1_array_crystal_array_5_xwidth;
MCNUM mccchannel_1_analyzer_1_array_crystal_array_5_yheight;
MCNUM mccchannel_1_analyzer_1_array_crystal_array_5_zdepth;
MCNUM mccchannel_1_analyzer_1_array_crystal_array_5_xwidth2;
MCNUM mccchannel_1_analyzer_1_array_crystal_array_5_yheight2;
MCNUM mccchannel_1_analyzer_1_array_crystal_array_5_visualize;
int mccchannel_1_analyzer_1_array_crystal_array_5_target_index;
MCNUM mccchannel_1_analyzer_1_array_crystal_array_5_target_x;
MCNUM mccchannel_1_analyzer_1_array_crystal_array_5_target_y;
MCNUM mccchannel_1_analyzer_1_array_crystal_array_5_target_z;
MCNUM mccchannel_1_analyzer_1_array_crystal_array_5_focus_aw;
MCNUM mccchannel_1_analyzer_1_array_crystal_array_5_focus_ah;
MCNUM mccchannel_1_analyzer_1_array_crystal_array_5_focus_xw;
MCNUM mccchannel_1_analyzer_1_array_crystal_array_5_focus_xh;
MCNUM mccchannel_1_analyzer_1_array_crystal_array_5_focus_r;
MCNUM mccchannel_1_analyzer_1_array_crystal_array_5_p_interact;
char mccchannel_1_analyzer_1_array_crystal_array_5_mask_string[16384];
char mccchannel_1_analyzer_1_array_crystal_array_5_mask_setting[16384];
MCNUM mccchannel_1_analyzer_1_array_crystal_array_5_number_of_activations;

/* Setting parameters for component 'channel_1_analyzer_1_array_crystal_array_6' [174]. */
char mccchannel_1_analyzer_1_array_crystal_array_6_material_string[16384];
MCNUM mccchannel_1_analyzer_1_array_crystal_array_6_priority;
MCNUM mccchannel_1_analyzer_1_array_crystal_array_6_xwidth;
MCNUM mccchannel_1_analyzer_1_array_crystal_array_6_yheight;
MCNUM mccchannel_1_analyzer_1_array_crystal_array_6_zdepth;
MCNUM mccchannel_1_analyzer_1_array_crystal_array_6_xwidth2;
MCNUM mccchannel_1_analyzer_1_array_crystal_array_6_yheight2;
MCNUM mccchannel_1_analyzer_1_array_crystal_array_6_visualize;
int mccchannel_1_analyzer_1_array_crystal_array_6_target_index;
MCNUM mccchannel_1_analyzer_1_array_crystal_array_6_target_x;
MCNUM mccchannel_1_analyzer_1_array_crystal_array_6_target_y;
MCNUM mccchannel_1_analyzer_1_array_crystal_array_6_target_z;
MCNUM mccchannel_1_analyzer_1_array_crystal_array_6_focus_aw;
MCNUM mccchannel_1_analyzer_1_array_crystal_array_6_focus_ah;
MCNUM mccchannel_1_analyzer_1_array_crystal_array_6_focus_xw;
MCNUM mccchannel_1_analyzer_1_array_crystal_array_6_focus_xh;
MCNUM mccchannel_1_analyzer_1_array_crystal_array_6_focus_r;
MCNUM mccchannel_1_analyzer_1_array_crystal_array_6_p_interact;
char mccchannel_1_analyzer_1_array_crystal_array_6_mask_string[16384];
char mccchannel_1_analyzer_1_array_crystal_array_6_mask_setting[16384];
MCNUM mccchannel_1_analyzer_1_array_crystal_array_6_number_of_activations;

/* Setting parameters for component 'channel_1_analyzer_1_array_crystal_array_7' [175]. */
char mccchannel_1_analyzer_1_array_crystal_array_7_material_string[16384];
MCNUM mccchannel_1_analyzer_1_array_crystal_array_7_priority;
MCNUM mccchannel_1_analyzer_1_array_crystal_array_7_xwidth;
MCNUM mccchannel_1_analyzer_1_array_crystal_array_7_yheight;
MCNUM mccchannel_1_analyzer_1_array_crystal_array_7_zdepth;
MCNUM mccchannel_1_analyzer_1_array_crystal_array_7_xwidth2;
MCNUM mccchannel_1_analyzer_1_array_crystal_array_7_yheight2;
MCNUM mccchannel_1_analyzer_1_array_crystal_array_7_visualize;
int mccchannel_1_analyzer_1_array_crystal_array_7_target_index;
MCNUM mccchannel_1_analyzer_1_array_crystal_array_7_target_x;
MCNUM mccchannel_1_analyzer_1_array_crystal_array_7_target_y;
MCNUM mccchannel_1_analyzer_1_array_crystal_array_7_target_z;
MCNUM mccchannel_1_analyzer_1_array_crystal_array_7_focus_aw;
MCNUM mccchannel_1_analyzer_1_array_crystal_array_7_focus_ah;
MCNUM mccchannel_1_analyzer_1_array_crystal_array_7_focus_xw;
MCNUM mccchannel_1_analyzer_1_array_crystal_array_7_focus_xh;
MCNUM mccchannel_1_analyzer_1_array_crystal_array_7_focus_r;
MCNUM mccchannel_1_analyzer_1_array_crystal_array_7_p_interact;
char mccchannel_1_analyzer_1_array_crystal_array_7_mask_string[16384];
char mccchannel_1_analyzer_1_array_crystal_array_7_mask_setting[16384];
MCNUM mccchannel_1_analyzer_1_array_crystal_array_7_number_of_activations;

/* Setting parameters for component 'channel_1_analyzer_1_array_crystal_array_8' [176]. */
char mccchannel_1_analyzer_1_array_crystal_array_8_material_string[16384];
MCNUM mccchannel_1_analyzer_1_array_crystal_array_8_priority;
MCNUM mccchannel_1_analyzer_1_array_crystal_array_8_xwidth;
MCNUM mccchannel_1_analyzer_1_array_crystal_array_8_yheight;
MCNUM mccchannel_1_analyzer_1_array_crystal_array_8_zdepth;
MCNUM mccchannel_1_analyzer_1_array_crystal_array_8_xwidth2;
MCNUM mccchannel_1_analyzer_1_array_crystal_array_8_yheight2;
MCNUM mccchannel_1_analyzer_1_array_crystal_array_8_visualize;
int mccchannel_1_analyzer_1_array_crystal_array_8_target_index;
MCNUM mccchannel_1_analyzer_1_array_crystal_array_8_target_x;
MCNUM mccchannel_1_analyzer_1_array_crystal_array_8_target_y;
MCNUM mccchannel_1_analyzer_1_array_crystal_array_8_target_z;
MCNUM mccchannel_1_analyzer_1_array_crystal_array_8_focus_aw;
MCNUM mccchannel_1_analyzer_1_array_crystal_array_8_focus_ah;
MCNUM mccchannel_1_analyzer_1_array_crystal_array_8_focus_xw;
MCNUM mccchannel_1_analyzer_1_array_crystal_array_8_focus_xh;
MCNUM mccchannel_1_analyzer_1_array_crystal_array_8_focus_r;
MCNUM mccchannel_1_analyzer_1_array_crystal_array_8_p_interact;
char mccchannel_1_analyzer_1_array_crystal_array_8_mask_string[16384];
char mccchannel_1_analyzer_1_array_crystal_array_8_mask_setting[16384];
MCNUM mccchannel_1_analyzer_1_array_crystal_array_8_number_of_activations;

/* Setting parameters for component 'channel_1_analyzer_2_array_crystal_array_0' [179]. */
char mccchannel_1_analyzer_2_array_crystal_array_0_material_string[16384];
MCNUM mccchannel_1_analyzer_2_array_crystal_array_0_priority;
MCNUM mccchannel_1_analyzer_2_array_crystal_array_0_xwidth;
MCNUM mccchannel_1_analyzer_2_array_crystal_array_0_yheight;
MCNUM mccchannel_1_analyzer_2_array_crystal_array_0_zdepth;
MCNUM mccchannel_1_analyzer_2_array_crystal_array_0_xwidth2;
MCNUM mccchannel_1_analyzer_2_array_crystal_array_0_yheight2;
MCNUM mccchannel_1_analyzer_2_array_crystal_array_0_visualize;
int mccchannel_1_analyzer_2_array_crystal_array_0_target_index;
MCNUM mccchannel_1_analyzer_2_array_crystal_array_0_target_x;
MCNUM mccchannel_1_analyzer_2_array_crystal_array_0_target_y;
MCNUM mccchannel_1_analyzer_2_array_crystal_array_0_target_z;
MCNUM mccchannel_1_analyzer_2_array_crystal_array_0_focus_aw;
MCNUM mccchannel_1_analyzer_2_array_crystal_array_0_focus_ah;
MCNUM mccchannel_1_analyzer_2_array_crystal_array_0_focus_xw;
MCNUM mccchannel_1_analyzer_2_array_crystal_array_0_focus_xh;
MCNUM mccchannel_1_analyzer_2_array_crystal_array_0_focus_r;
MCNUM mccchannel_1_analyzer_2_array_crystal_array_0_p_interact;
char mccchannel_1_analyzer_2_array_crystal_array_0_mask_string[16384];
char mccchannel_1_analyzer_2_array_crystal_array_0_mask_setting[16384];
MCNUM mccchannel_1_analyzer_2_array_crystal_array_0_number_of_activations;

/* Setting parameters for component 'channel_1_analyzer_2_array_crystal_array_1' [180]. */
char mccchannel_1_analyzer_2_array_crystal_array_1_material_string[16384];
MCNUM mccchannel_1_analyzer_2_array_crystal_array_1_priority;
MCNUM mccchannel_1_analyzer_2_array_crystal_array_1_xwidth;
MCNUM mccchannel_1_analyzer_2_array_crystal_array_1_yheight;
MCNUM mccchannel_1_analyzer_2_array_crystal_array_1_zdepth;
MCNUM mccchannel_1_analyzer_2_array_crystal_array_1_xwidth2;
MCNUM mccchannel_1_analyzer_2_array_crystal_array_1_yheight2;
MCNUM mccchannel_1_analyzer_2_array_crystal_array_1_visualize;
int mccchannel_1_analyzer_2_array_crystal_array_1_target_index;
MCNUM mccchannel_1_analyzer_2_array_crystal_array_1_target_x;
MCNUM mccchannel_1_analyzer_2_array_crystal_array_1_target_y;
MCNUM mccchannel_1_analyzer_2_array_crystal_array_1_target_z;
MCNUM mccchannel_1_analyzer_2_array_crystal_array_1_focus_aw;
MCNUM mccchannel_1_analyzer_2_array_crystal_array_1_focus_ah;
MCNUM mccchannel_1_analyzer_2_array_crystal_array_1_focus_xw;
MCNUM mccchannel_1_analyzer_2_array_crystal_array_1_focus_xh;
MCNUM mccchannel_1_analyzer_2_array_crystal_array_1_focus_r;
MCNUM mccchannel_1_analyzer_2_array_crystal_array_1_p_interact;
char mccchannel_1_analyzer_2_array_crystal_array_1_mask_string[16384];
char mccchannel_1_analyzer_2_array_crystal_array_1_mask_setting[16384];
MCNUM mccchannel_1_analyzer_2_array_crystal_array_1_number_of_activations;

/* Setting parameters for component 'channel_1_analyzer_2_array_crystal_array_2' [181]. */
char mccchannel_1_analyzer_2_array_crystal_array_2_material_string[16384];
MCNUM mccchannel_1_analyzer_2_array_crystal_array_2_priority;
MCNUM mccchannel_1_analyzer_2_array_crystal_array_2_xwidth;
MCNUM mccchannel_1_analyzer_2_array_crystal_array_2_yheight;
MCNUM mccchannel_1_analyzer_2_array_crystal_array_2_zdepth;
MCNUM mccchannel_1_analyzer_2_array_crystal_array_2_xwidth2;
MCNUM mccchannel_1_analyzer_2_array_crystal_array_2_yheight2;
MCNUM mccchannel_1_analyzer_2_array_crystal_array_2_visualize;
int mccchannel_1_analyzer_2_array_crystal_array_2_target_index;
MCNUM mccchannel_1_analyzer_2_array_crystal_array_2_target_x;
MCNUM mccchannel_1_analyzer_2_array_crystal_array_2_target_y;
MCNUM mccchannel_1_analyzer_2_array_crystal_array_2_target_z;
MCNUM mccchannel_1_analyzer_2_array_crystal_array_2_focus_aw;
MCNUM mccchannel_1_analyzer_2_array_crystal_array_2_focus_ah;
MCNUM mccchannel_1_analyzer_2_array_crystal_array_2_focus_xw;
MCNUM mccchannel_1_analyzer_2_array_crystal_array_2_focus_xh;
MCNUM mccchannel_1_analyzer_2_array_crystal_array_2_focus_r;
MCNUM mccchannel_1_analyzer_2_array_crystal_array_2_p_interact;
char mccchannel_1_analyzer_2_array_crystal_array_2_mask_string[16384];
char mccchannel_1_analyzer_2_array_crystal_array_2_mask_setting[16384];
MCNUM mccchannel_1_analyzer_2_array_crystal_array_2_number_of_activations;

/* Setting parameters for component 'channel_1_analyzer_2_array_crystal_array_3' [182]. */
char mccchannel_1_analyzer_2_array_crystal_array_3_material_string[16384];
MCNUM mccchannel_1_analyzer_2_array_crystal_array_3_priority;
MCNUM mccchannel_1_analyzer_2_array_crystal_array_3_xwidth;
MCNUM mccchannel_1_analyzer_2_array_crystal_array_3_yheight;
MCNUM mccchannel_1_analyzer_2_array_crystal_array_3_zdepth;
MCNUM mccchannel_1_analyzer_2_array_crystal_array_3_xwidth2;
MCNUM mccchannel_1_analyzer_2_array_crystal_array_3_yheight2;
MCNUM mccchannel_1_analyzer_2_array_crystal_array_3_visualize;
int mccchannel_1_analyzer_2_array_crystal_array_3_target_index;
MCNUM mccchannel_1_analyzer_2_array_crystal_array_3_target_x;
MCNUM mccchannel_1_analyzer_2_array_crystal_array_3_target_y;
MCNUM mccchannel_1_analyzer_2_array_crystal_array_3_target_z;
MCNUM mccchannel_1_analyzer_2_array_crystal_array_3_focus_aw;
MCNUM mccchannel_1_analyzer_2_array_crystal_array_3_focus_ah;
MCNUM mccchannel_1_analyzer_2_array_crystal_array_3_focus_xw;
MCNUM mccchannel_1_analyzer_2_array_crystal_array_3_focus_xh;
MCNUM mccchannel_1_analyzer_2_array_crystal_array_3_focus_r;
MCNUM mccchannel_1_analyzer_2_array_crystal_array_3_p_interact;
char mccchannel_1_analyzer_2_array_crystal_array_3_mask_string[16384];
char mccchannel_1_analyzer_2_array_crystal_array_3_mask_setting[16384];
MCNUM mccchannel_1_analyzer_2_array_crystal_array_3_number_of_activations;

/* Setting parameters for component 'channel_1_analyzer_2_array_crystal_array_4' [183]. */
char mccchannel_1_analyzer_2_array_crystal_array_4_material_string[16384];
MCNUM mccchannel_1_analyzer_2_array_crystal_array_4_priority;
MCNUM mccchannel_1_analyzer_2_array_crystal_array_4_xwidth;
MCNUM mccchannel_1_analyzer_2_array_crystal_array_4_yheight;
MCNUM mccchannel_1_analyzer_2_array_crystal_array_4_zdepth;
MCNUM mccchannel_1_analyzer_2_array_crystal_array_4_xwidth2;
MCNUM mccchannel_1_analyzer_2_array_crystal_array_4_yheight2;
MCNUM mccchannel_1_analyzer_2_array_crystal_array_4_visualize;
int mccchannel_1_analyzer_2_array_crystal_array_4_target_index;
MCNUM mccchannel_1_analyzer_2_array_crystal_array_4_target_x;
MCNUM mccchannel_1_analyzer_2_array_crystal_array_4_target_y;
MCNUM mccchannel_1_analyzer_2_array_crystal_array_4_target_z;
MCNUM mccchannel_1_analyzer_2_array_crystal_array_4_focus_aw;
MCNUM mccchannel_1_analyzer_2_array_crystal_array_4_focus_ah;
MCNUM mccchannel_1_analyzer_2_array_crystal_array_4_focus_xw;
MCNUM mccchannel_1_analyzer_2_array_crystal_array_4_focus_xh;
MCNUM mccchannel_1_analyzer_2_array_crystal_array_4_focus_r;
MCNUM mccchannel_1_analyzer_2_array_crystal_array_4_p_interact;
char mccchannel_1_analyzer_2_array_crystal_array_4_mask_string[16384];
char mccchannel_1_analyzer_2_array_crystal_array_4_mask_setting[16384];
MCNUM mccchannel_1_analyzer_2_array_crystal_array_4_number_of_activations;

/* Setting parameters for component 'channel_1_analyzer_2_array_crystal_array_5' [184]. */
char mccchannel_1_analyzer_2_array_crystal_array_5_material_string[16384];
MCNUM mccchannel_1_analyzer_2_array_crystal_array_5_priority;
MCNUM mccchannel_1_analyzer_2_array_crystal_array_5_xwidth;
MCNUM mccchannel_1_analyzer_2_array_crystal_array_5_yheight;
MCNUM mccchannel_1_analyzer_2_array_crystal_array_5_zdepth;
MCNUM mccchannel_1_analyzer_2_array_crystal_array_5_xwidth2;
MCNUM mccchannel_1_analyzer_2_array_crystal_array_5_yheight2;
MCNUM mccchannel_1_analyzer_2_array_crystal_array_5_visualize;
int mccchannel_1_analyzer_2_array_crystal_array_5_target_index;
MCNUM mccchannel_1_analyzer_2_array_crystal_array_5_target_x;
MCNUM mccchannel_1_analyzer_2_array_crystal_array_5_target_y;
MCNUM mccchannel_1_analyzer_2_array_crystal_array_5_target_z;
MCNUM mccchannel_1_analyzer_2_array_crystal_array_5_focus_aw;
MCNUM mccchannel_1_analyzer_2_array_crystal_array_5_focus_ah;
MCNUM mccchannel_1_analyzer_2_array_crystal_array_5_focus_xw;
MCNUM mccchannel_1_analyzer_2_array_crystal_array_5_focus_xh;
MCNUM mccchannel_1_analyzer_2_array_crystal_array_5_focus_r;
MCNUM mccchannel_1_analyzer_2_array_crystal_array_5_p_interact;
char mccchannel_1_analyzer_2_array_crystal_array_5_mask_string[16384];
char mccchannel_1_analyzer_2_array_crystal_array_5_mask_setting[16384];
MCNUM mccchannel_1_analyzer_2_array_crystal_array_5_number_of_activations;

/* Setting parameters for component 'channel_1_analyzer_2_array_crystal_array_6' [185]. */
char mccchannel_1_analyzer_2_array_crystal_array_6_material_string[16384];
MCNUM mccchannel_1_analyzer_2_array_crystal_array_6_priority;
MCNUM mccchannel_1_analyzer_2_array_crystal_array_6_xwidth;
MCNUM mccchannel_1_analyzer_2_array_crystal_array_6_yheight;
MCNUM mccchannel_1_analyzer_2_array_crystal_array_6_zdepth;
MCNUM mccchannel_1_analyzer_2_array_crystal_array_6_xwidth2;
MCNUM mccchannel_1_analyzer_2_array_crystal_array_6_yheight2;
MCNUM mccchannel_1_analyzer_2_array_crystal_array_6_visualize;
int mccchannel_1_analyzer_2_array_crystal_array_6_target_index;
MCNUM mccchannel_1_analyzer_2_array_crystal_array_6_target_x;
MCNUM mccchannel_1_analyzer_2_array_crystal_array_6_target_y;
MCNUM mccchannel_1_analyzer_2_array_crystal_array_6_target_z;
MCNUM mccchannel_1_analyzer_2_array_crystal_array_6_focus_aw;
MCNUM mccchannel_1_analyzer_2_array_crystal_array_6_focus_ah;
MCNUM mccchannel_1_analyzer_2_array_crystal_array_6_focus_xw;
MCNUM mccchannel_1_analyzer_2_array_crystal_array_6_focus_xh;
MCNUM mccchannel_1_analyzer_2_array_crystal_array_6_focus_r;
MCNUM mccchannel_1_analyzer_2_array_crystal_array_6_p_interact;
char mccchannel_1_analyzer_2_array_crystal_array_6_mask_string[16384];
char mccchannel_1_analyzer_2_array_crystal_array_6_mask_setting[16384];
MCNUM mccchannel_1_analyzer_2_array_crystal_array_6_number_of_activations;

/* Setting parameters for component 'channel_1_analyzer_2_array_crystal_array_7' [186]. */
char mccchannel_1_analyzer_2_array_crystal_array_7_material_string[16384];
MCNUM mccchannel_1_analyzer_2_array_crystal_array_7_priority;
MCNUM mccchannel_1_analyzer_2_array_crystal_array_7_xwidth;
MCNUM mccchannel_1_analyzer_2_array_crystal_array_7_yheight;
MCNUM mccchannel_1_analyzer_2_array_crystal_array_7_zdepth;
MCNUM mccchannel_1_analyzer_2_array_crystal_array_7_xwidth2;
MCNUM mccchannel_1_analyzer_2_array_crystal_array_7_yheight2;
MCNUM mccchannel_1_analyzer_2_array_crystal_array_7_visualize;
int mccchannel_1_analyzer_2_array_crystal_array_7_target_index;
MCNUM mccchannel_1_analyzer_2_array_crystal_array_7_target_x;
MCNUM mccchannel_1_analyzer_2_array_crystal_array_7_target_y;
MCNUM mccchannel_1_analyzer_2_array_crystal_array_7_target_z;
MCNUM mccchannel_1_analyzer_2_array_crystal_array_7_focus_aw;
MCNUM mccchannel_1_analyzer_2_array_crystal_array_7_focus_ah;
MCNUM mccchannel_1_analyzer_2_array_crystal_array_7_focus_xw;
MCNUM mccchannel_1_analyzer_2_array_crystal_array_7_focus_xh;
MCNUM mccchannel_1_analyzer_2_array_crystal_array_7_focus_r;
MCNUM mccchannel_1_analyzer_2_array_crystal_array_7_p_interact;
char mccchannel_1_analyzer_2_array_crystal_array_7_mask_string[16384];
char mccchannel_1_analyzer_2_array_crystal_array_7_mask_setting[16384];
MCNUM mccchannel_1_analyzer_2_array_crystal_array_7_number_of_activations;

/* Setting parameters for component 'channel_1_analyzer_2_array_crystal_array_8' [187]. */
char mccchannel_1_analyzer_2_array_crystal_array_8_material_string[16384];
MCNUM mccchannel_1_analyzer_2_array_crystal_array_8_priority;
MCNUM mccchannel_1_analyzer_2_array_crystal_array_8_xwidth;
MCNUM mccchannel_1_analyzer_2_array_crystal_array_8_yheight;
MCNUM mccchannel_1_analyzer_2_array_crystal_array_8_zdepth;
MCNUM mccchannel_1_analyzer_2_array_crystal_array_8_xwidth2;
MCNUM mccchannel_1_analyzer_2_array_crystal_array_8_yheight2;
MCNUM mccchannel_1_analyzer_2_array_crystal_array_8_visualize;
int mccchannel_1_analyzer_2_array_crystal_array_8_target_index;
MCNUM mccchannel_1_analyzer_2_array_crystal_array_8_target_x;
MCNUM mccchannel_1_analyzer_2_array_crystal_array_8_target_y;
MCNUM mccchannel_1_analyzer_2_array_crystal_array_8_target_z;
MCNUM mccchannel_1_analyzer_2_array_crystal_array_8_focus_aw;
MCNUM mccchannel_1_analyzer_2_array_crystal_array_8_focus_ah;
MCNUM mccchannel_1_analyzer_2_array_crystal_array_8_focus_xw;
MCNUM mccchannel_1_analyzer_2_array_crystal_array_8_focus_xh;
MCNUM mccchannel_1_analyzer_2_array_crystal_array_8_focus_r;
MCNUM mccchannel_1_analyzer_2_array_crystal_array_8_p_interact;
char mccchannel_1_analyzer_2_array_crystal_array_8_mask_string[16384];
char mccchannel_1_analyzer_2_array_crystal_array_8_mask_setting[16384];
MCNUM mccchannel_1_analyzer_2_array_crystal_array_8_number_of_activations;

/* Setting parameters for component 'channel_1_cave2_cyl1' [188]. */
char mccchannel_1_cave2_cyl1_material_string[16384];
MCNUM mccchannel_1_cave2_cyl1_priority;
MCNUM mccchannel_1_cave2_cyl1_radius;
MCNUM mccchannel_1_cave2_cyl1_yheight;
MCNUM mccchannel_1_cave2_cyl1_visualize;
int mccchannel_1_cave2_cyl1_target_index;
MCNUM mccchannel_1_cave2_cyl1_target_x;
MCNUM mccchannel_1_cave2_cyl1_target_y;
MCNUM mccchannel_1_cave2_cyl1_target_z;
MCNUM mccchannel_1_cave2_cyl1_focus_aw;
MCNUM mccchannel_1_cave2_cyl1_focus_ah;
MCNUM mccchannel_1_cave2_cyl1_focus_xw;
MCNUM mccchannel_1_cave2_cyl1_focus_xh;
MCNUM mccchannel_1_cave2_cyl1_focus_r;
MCNUM mccchannel_1_cave2_cyl1_p_interact;
char mccchannel_1_cave2_cyl1_mask_string[16384];
char mccchannel_1_cave2_cyl1_mask_setting[16384];
MCNUM mccchannel_1_cave2_cyl1_number_of_activations;

/* Setting parameters for component 'channel_1_cave2_box1' [189]. */
char mccchannel_1_cave2_box1_material_string[16384];
MCNUM mccchannel_1_cave2_box1_priority;
MCNUM mccchannel_1_cave2_box1_xwidth;
MCNUM mccchannel_1_cave2_box1_yheight;
MCNUM mccchannel_1_cave2_box1_zdepth;
MCNUM mccchannel_1_cave2_box1_xwidth2;
MCNUM mccchannel_1_cave2_box1_yheight2;
MCNUM mccchannel_1_cave2_box1_visualize;
int mccchannel_1_cave2_box1_target_index;
MCNUM mccchannel_1_cave2_box1_target_x;
MCNUM mccchannel_1_cave2_box1_target_y;
MCNUM mccchannel_1_cave2_box1_target_z;
MCNUM mccchannel_1_cave2_box1_focus_aw;
MCNUM mccchannel_1_cave2_box1_focus_ah;
MCNUM mccchannel_1_cave2_box1_focus_xw;
MCNUM mccchannel_1_cave2_box1_focus_xh;
MCNUM mccchannel_1_cave2_box1_focus_r;
MCNUM mccchannel_1_cave2_box1_p_interact;
char mccchannel_1_cave2_box1_mask_string[16384];
char mccchannel_1_cave2_box1_mask_setting[16384];
MCNUM mccchannel_1_cave2_box1_number_of_activations;

/* Setting parameters for component 'channel_1_cave2_box2' [190]. */
char mccchannel_1_cave2_box2_material_string[16384];
MCNUM mccchannel_1_cave2_box2_priority;
MCNUM mccchannel_1_cave2_box2_xwidth;
MCNUM mccchannel_1_cave2_box2_yheight;
MCNUM mccchannel_1_cave2_box2_zdepth;
MCNUM mccchannel_1_cave2_box2_xwidth2;
MCNUM mccchannel_1_cave2_box2_yheight2;
MCNUM mccchannel_1_cave2_box2_visualize;
int mccchannel_1_cave2_box2_target_index;
MCNUM mccchannel_1_cave2_box2_target_x;
MCNUM mccchannel_1_cave2_box2_target_y;
MCNUM mccchannel_1_cave2_box2_target_z;
MCNUM mccchannel_1_cave2_box2_focus_aw;
MCNUM mccchannel_1_cave2_box2_focus_ah;
MCNUM mccchannel_1_cave2_box2_focus_xw;
MCNUM mccchannel_1_cave2_box2_focus_xh;
MCNUM mccchannel_1_cave2_box2_focus_r;
MCNUM mccchannel_1_cave2_box2_p_interact;
char mccchannel_1_cave2_box2_mask_string[16384];
char mccchannel_1_cave2_box2_mask_setting[16384];
MCNUM mccchannel_1_cave2_box2_number_of_activations;

/* Setting parameters for component 'channel_1_cave2_box3' [191]. */
char mccchannel_1_cave2_box3_material_string[16384];
MCNUM mccchannel_1_cave2_box3_priority;
MCNUM mccchannel_1_cave2_box3_xwidth;
MCNUM mccchannel_1_cave2_box3_yheight;
MCNUM mccchannel_1_cave2_box3_zdepth;
MCNUM mccchannel_1_cave2_box3_xwidth2;
MCNUM mccchannel_1_cave2_box3_yheight2;
MCNUM mccchannel_1_cave2_box3_visualize;
int mccchannel_1_cave2_box3_target_index;
MCNUM mccchannel_1_cave2_box3_target_x;
MCNUM mccchannel_1_cave2_box3_target_y;
MCNUM mccchannel_1_cave2_box3_target_z;
MCNUM mccchannel_1_cave2_box3_focus_aw;
MCNUM mccchannel_1_cave2_box3_focus_ah;
MCNUM mccchannel_1_cave2_box3_focus_xw;
MCNUM mccchannel_1_cave2_box3_focus_xh;
MCNUM mccchannel_1_cave2_box3_focus_r;
MCNUM mccchannel_1_cave2_box3_p_interact;
char mccchannel_1_cave2_box3_mask_string[16384];
char mccchannel_1_cave2_box3_mask_setting[16384];
MCNUM mccchannel_1_cave2_box3_number_of_activations;

/* Setting parameters for component 'inter_analyzer_colimator_1_blade_0' [193]. */
char mccinter_analyzer_colimator_1_blade_0_material_string[16384];
MCNUM mccinter_analyzer_colimator_1_blade_0_priority;
MCNUM mccinter_analyzer_colimator_1_blade_0_xwidth;
MCNUM mccinter_analyzer_colimator_1_blade_0_yheight;
MCNUM mccinter_analyzer_colimator_1_blade_0_zdepth;
MCNUM mccinter_analyzer_colimator_1_blade_0_xwidth2;
MCNUM mccinter_analyzer_colimator_1_blade_0_yheight2;
MCNUM mccinter_analyzer_colimator_1_blade_0_visualize;
int mccinter_analyzer_colimator_1_blade_0_target_index;
MCNUM mccinter_analyzer_colimator_1_blade_0_target_x;
MCNUM mccinter_analyzer_colimator_1_blade_0_target_y;
MCNUM mccinter_analyzer_colimator_1_blade_0_target_z;
MCNUM mccinter_analyzer_colimator_1_blade_0_focus_aw;
MCNUM mccinter_analyzer_colimator_1_blade_0_focus_ah;
MCNUM mccinter_analyzer_colimator_1_blade_0_focus_xw;
MCNUM mccinter_analyzer_colimator_1_blade_0_focus_xh;
MCNUM mccinter_analyzer_colimator_1_blade_0_focus_r;
MCNUM mccinter_analyzer_colimator_1_blade_0_p_interact;
char mccinter_analyzer_colimator_1_blade_0_mask_string[16384];
char mccinter_analyzer_colimator_1_blade_0_mask_setting[16384];
MCNUM mccinter_analyzer_colimator_1_blade_0_number_of_activations;

/* Setting parameters for component 'inter_analyzer_colimator_1_blade_1' [194]. */
char mccinter_analyzer_colimator_1_blade_1_material_string[16384];
MCNUM mccinter_analyzer_colimator_1_blade_1_priority;
MCNUM mccinter_analyzer_colimator_1_blade_1_xwidth;
MCNUM mccinter_analyzer_colimator_1_blade_1_yheight;
MCNUM mccinter_analyzer_colimator_1_blade_1_zdepth;
MCNUM mccinter_analyzer_colimator_1_blade_1_xwidth2;
MCNUM mccinter_analyzer_colimator_1_blade_1_yheight2;
MCNUM mccinter_analyzer_colimator_1_blade_1_visualize;
int mccinter_analyzer_colimator_1_blade_1_target_index;
MCNUM mccinter_analyzer_colimator_1_blade_1_target_x;
MCNUM mccinter_analyzer_colimator_1_blade_1_target_y;
MCNUM mccinter_analyzer_colimator_1_blade_1_target_z;
MCNUM mccinter_analyzer_colimator_1_blade_1_focus_aw;
MCNUM mccinter_analyzer_colimator_1_blade_1_focus_ah;
MCNUM mccinter_analyzer_colimator_1_blade_1_focus_xw;
MCNUM mccinter_analyzer_colimator_1_blade_1_focus_xh;
MCNUM mccinter_analyzer_colimator_1_blade_1_focus_r;
MCNUM mccinter_analyzer_colimator_1_blade_1_p_interact;
char mccinter_analyzer_colimator_1_blade_1_mask_string[16384];
char mccinter_analyzer_colimator_1_blade_1_mask_setting[16384];
MCNUM mccinter_analyzer_colimator_1_blade_1_number_of_activations;

/* Setting parameters for component 'inter_analyzer_colimator_1_blade_2' [195]. */
char mccinter_analyzer_colimator_1_blade_2_material_string[16384];
MCNUM mccinter_analyzer_colimator_1_blade_2_priority;
MCNUM mccinter_analyzer_colimator_1_blade_2_xwidth;
MCNUM mccinter_analyzer_colimator_1_blade_2_yheight;
MCNUM mccinter_analyzer_colimator_1_blade_2_zdepth;
MCNUM mccinter_analyzer_colimator_1_blade_2_xwidth2;
MCNUM mccinter_analyzer_colimator_1_blade_2_yheight2;
MCNUM mccinter_analyzer_colimator_1_blade_2_visualize;
int mccinter_analyzer_colimator_1_blade_2_target_index;
MCNUM mccinter_analyzer_colimator_1_blade_2_target_x;
MCNUM mccinter_analyzer_colimator_1_blade_2_target_y;
MCNUM mccinter_analyzer_colimator_1_blade_2_target_z;
MCNUM mccinter_analyzer_colimator_1_blade_2_focus_aw;
MCNUM mccinter_analyzer_colimator_1_blade_2_focus_ah;
MCNUM mccinter_analyzer_colimator_1_blade_2_focus_xw;
MCNUM mccinter_analyzer_colimator_1_blade_2_focus_xh;
MCNUM mccinter_analyzer_colimator_1_blade_2_focus_r;
MCNUM mccinter_analyzer_colimator_1_blade_2_p_interact;
char mccinter_analyzer_colimator_1_blade_2_mask_string[16384];
char mccinter_analyzer_colimator_1_blade_2_mask_setting[16384];
MCNUM mccinter_analyzer_colimator_1_blade_2_number_of_activations;

/* Setting parameters for component 'inter_analyzer_colimator_1_blade_3' [196]. */
char mccinter_analyzer_colimator_1_blade_3_material_string[16384];
MCNUM mccinter_analyzer_colimator_1_blade_3_priority;
MCNUM mccinter_analyzer_colimator_1_blade_3_xwidth;
MCNUM mccinter_analyzer_colimator_1_blade_3_yheight;
MCNUM mccinter_analyzer_colimator_1_blade_3_zdepth;
MCNUM mccinter_analyzer_colimator_1_blade_3_xwidth2;
MCNUM mccinter_analyzer_colimator_1_blade_3_yheight2;
MCNUM mccinter_analyzer_colimator_1_blade_3_visualize;
int mccinter_analyzer_colimator_1_blade_3_target_index;
MCNUM mccinter_analyzer_colimator_1_blade_3_target_x;
MCNUM mccinter_analyzer_colimator_1_blade_3_target_y;
MCNUM mccinter_analyzer_colimator_1_blade_3_target_z;
MCNUM mccinter_analyzer_colimator_1_blade_3_focus_aw;
MCNUM mccinter_analyzer_colimator_1_blade_3_focus_ah;
MCNUM mccinter_analyzer_colimator_1_blade_3_focus_xw;
MCNUM mccinter_analyzer_colimator_1_blade_3_focus_xh;
MCNUM mccinter_analyzer_colimator_1_blade_3_focus_r;
MCNUM mccinter_analyzer_colimator_1_blade_3_p_interact;
char mccinter_analyzer_colimator_1_blade_3_mask_string[16384];
char mccinter_analyzer_colimator_1_blade_3_mask_setting[16384];
MCNUM mccinter_analyzer_colimator_1_blade_3_number_of_activations;

/* Setting parameters for component 'inter_analyzer_colimator_1_blade_4' [197]. */
char mccinter_analyzer_colimator_1_blade_4_material_string[16384];
MCNUM mccinter_analyzer_colimator_1_blade_4_priority;
MCNUM mccinter_analyzer_colimator_1_blade_4_xwidth;
MCNUM mccinter_analyzer_colimator_1_blade_4_yheight;
MCNUM mccinter_analyzer_colimator_1_blade_4_zdepth;
MCNUM mccinter_analyzer_colimator_1_blade_4_xwidth2;
MCNUM mccinter_analyzer_colimator_1_blade_4_yheight2;
MCNUM mccinter_analyzer_colimator_1_blade_4_visualize;
int mccinter_analyzer_colimator_1_blade_4_target_index;
MCNUM mccinter_analyzer_colimator_1_blade_4_target_x;
MCNUM mccinter_analyzer_colimator_1_blade_4_target_y;
MCNUM mccinter_analyzer_colimator_1_blade_4_target_z;
MCNUM mccinter_analyzer_colimator_1_blade_4_focus_aw;
MCNUM mccinter_analyzer_colimator_1_blade_4_focus_ah;
MCNUM mccinter_analyzer_colimator_1_blade_4_focus_xw;
MCNUM mccinter_analyzer_colimator_1_blade_4_focus_xh;
MCNUM mccinter_analyzer_colimator_1_blade_4_focus_r;
MCNUM mccinter_analyzer_colimator_1_blade_4_p_interact;
char mccinter_analyzer_colimator_1_blade_4_mask_string[16384];
char mccinter_analyzer_colimator_1_blade_4_mask_setting[16384];
MCNUM mccinter_analyzer_colimator_1_blade_4_number_of_activations;

/* Setting parameters for component 'diffraction_detector_1_exit_volume' [198]. */
char mccdiffraction_detector_1_exit_volume_material_string[16384];
MCNUM mccdiffraction_detector_1_exit_volume_priority;
MCNUM mccdiffraction_detector_1_exit_volume_xwidth;
MCNUM mccdiffraction_detector_1_exit_volume_yheight;
MCNUM mccdiffraction_detector_1_exit_volume_zdepth;
MCNUM mccdiffraction_detector_1_exit_volume_xwidth2;
MCNUM mccdiffraction_detector_1_exit_volume_yheight2;
MCNUM mccdiffraction_detector_1_exit_volume_visualize;
int mccdiffraction_detector_1_exit_volume_target_index;
MCNUM mccdiffraction_detector_1_exit_volume_target_x;
MCNUM mccdiffraction_detector_1_exit_volume_target_y;
MCNUM mccdiffraction_detector_1_exit_volume_target_z;
MCNUM mccdiffraction_detector_1_exit_volume_focus_aw;
MCNUM mccdiffraction_detector_1_exit_volume_focus_ah;
MCNUM mccdiffraction_detector_1_exit_volume_focus_xw;
MCNUM mccdiffraction_detector_1_exit_volume_focus_xh;
MCNUM mccdiffraction_detector_1_exit_volume_focus_r;
MCNUM mccdiffraction_detector_1_exit_volume_p_interact;
char mccdiffraction_detector_1_exit_volume_mask_string[16384];
char mccdiffraction_detector_1_exit_volume_mask_setting[16384];
MCNUM mccdiffraction_detector_1_exit_volume_number_of_activations;

/* Setting parameters for component 'spec_detector_1_exit_volume' [199]. */
char mccspec_detector_1_exit_volume_material_string[16384];
MCNUM mccspec_detector_1_exit_volume_priority;
MCNUM mccspec_detector_1_exit_volume_xwidth;
MCNUM mccspec_detector_1_exit_volume_yheight;
MCNUM mccspec_detector_1_exit_volume_zdepth;
MCNUM mccspec_detector_1_exit_volume_xwidth2;
MCNUM mccspec_detector_1_exit_volume_yheight2;
MCNUM mccspec_detector_1_exit_volume_visualize;
int mccspec_detector_1_exit_volume_target_index;
MCNUM mccspec_detector_1_exit_volume_target_x;
MCNUM mccspec_detector_1_exit_volume_target_y;
MCNUM mccspec_detector_1_exit_volume_target_z;
MCNUM mccspec_detector_1_exit_volume_focus_aw;
MCNUM mccspec_detector_1_exit_volume_focus_ah;
MCNUM mccspec_detector_1_exit_volume_focus_xw;
MCNUM mccspec_detector_1_exit_volume_focus_xh;
MCNUM mccspec_detector_1_exit_volume_focus_r;
MCNUM mccspec_detector_1_exit_volume_p_interact;
char mccspec_detector_1_exit_volume_mask_string[16384];
char mccspec_detector_1_exit_volume_mask_setting[16384];
MCNUM mccspec_detector_1_exit_volume_number_of_activations;

/* Setting parameters for component 'channel_2_cave1_box1' [200]. */
char mccchannel_2_cave1_box1_material_string[16384];
MCNUM mccchannel_2_cave1_box1_priority;
MCNUM mccchannel_2_cave1_box1_xwidth;
MCNUM mccchannel_2_cave1_box1_yheight;
MCNUM mccchannel_2_cave1_box1_zdepth;
MCNUM mccchannel_2_cave1_box1_xwidth2;
MCNUM mccchannel_2_cave1_box1_yheight2;
MCNUM mccchannel_2_cave1_box1_visualize;
int mccchannel_2_cave1_box1_target_index;
MCNUM mccchannel_2_cave1_box1_target_x;
MCNUM mccchannel_2_cave1_box1_target_y;
MCNUM mccchannel_2_cave1_box1_target_z;
MCNUM mccchannel_2_cave1_box1_focus_aw;
MCNUM mccchannel_2_cave1_box1_focus_ah;
MCNUM mccchannel_2_cave1_box1_focus_xw;
MCNUM mccchannel_2_cave1_box1_focus_xh;
MCNUM mccchannel_2_cave1_box1_focus_r;
MCNUM mccchannel_2_cave1_box1_p_interact;
char mccchannel_2_cave1_box1_mask_string[16384];
char mccchannel_2_cave1_box1_mask_setting[16384];
MCNUM mccchannel_2_cave1_box1_number_of_activations;

/* Setting parameters for component 'channel_2_cave1_box2' [201]. */
char mccchannel_2_cave1_box2_material_string[16384];
MCNUM mccchannel_2_cave1_box2_priority;
MCNUM mccchannel_2_cave1_box2_xwidth;
MCNUM mccchannel_2_cave1_box2_yheight;
MCNUM mccchannel_2_cave1_box2_zdepth;
MCNUM mccchannel_2_cave1_box2_xwidth2;
MCNUM mccchannel_2_cave1_box2_yheight2;
MCNUM mccchannel_2_cave1_box2_visualize;
int mccchannel_2_cave1_box2_target_index;
MCNUM mccchannel_2_cave1_box2_target_x;
MCNUM mccchannel_2_cave1_box2_target_y;
MCNUM mccchannel_2_cave1_box2_target_z;
MCNUM mccchannel_2_cave1_box2_focus_aw;
MCNUM mccchannel_2_cave1_box2_focus_ah;
MCNUM mccchannel_2_cave1_box2_focus_xw;
MCNUM mccchannel_2_cave1_box2_focus_xh;
MCNUM mccchannel_2_cave1_box2_focus_r;
MCNUM mccchannel_2_cave1_box2_p_interact;
char mccchannel_2_cave1_box2_mask_string[16384];
char mccchannel_2_cave1_box2_mask_setting[16384];
MCNUM mccchannel_2_cave1_box2_number_of_activations;

/* Setting parameters for component 'channel_2_cave1_box3' [202]. */
char mccchannel_2_cave1_box3_material_string[16384];
MCNUM mccchannel_2_cave1_box3_priority;
MCNUM mccchannel_2_cave1_box3_xwidth;
MCNUM mccchannel_2_cave1_box3_yheight;
MCNUM mccchannel_2_cave1_box3_zdepth;
MCNUM mccchannel_2_cave1_box3_xwidth2;
MCNUM mccchannel_2_cave1_box3_yheight2;
MCNUM mccchannel_2_cave1_box3_visualize;
int mccchannel_2_cave1_box3_target_index;
MCNUM mccchannel_2_cave1_box3_target_x;
MCNUM mccchannel_2_cave1_box3_target_y;
MCNUM mccchannel_2_cave1_box3_target_z;
MCNUM mccchannel_2_cave1_box3_focus_aw;
MCNUM mccchannel_2_cave1_box3_focus_ah;
MCNUM mccchannel_2_cave1_box3_focus_xw;
MCNUM mccchannel_2_cave1_box3_focus_xh;
MCNUM mccchannel_2_cave1_box3_focus_r;
MCNUM mccchannel_2_cave1_box3_p_interact;
char mccchannel_2_cave1_box3_mask_string[16384];
char mccchannel_2_cave1_box3_mask_setting[16384];
MCNUM mccchannel_2_cave1_box3_number_of_activations;

/* Setting parameters for component 'channel_2_cave1_cyl1' [203]. */
char mccchannel_2_cave1_cyl1_material_string[16384];
MCNUM mccchannel_2_cave1_cyl1_priority;
MCNUM mccchannel_2_cave1_cyl1_radius;
MCNUM mccchannel_2_cave1_cyl1_yheight;
MCNUM mccchannel_2_cave1_cyl1_visualize;
int mccchannel_2_cave1_cyl1_target_index;
MCNUM mccchannel_2_cave1_cyl1_target_x;
MCNUM mccchannel_2_cave1_cyl1_target_y;
MCNUM mccchannel_2_cave1_cyl1_target_z;
MCNUM mccchannel_2_cave1_cyl1_focus_aw;
MCNUM mccchannel_2_cave1_cyl1_focus_ah;
MCNUM mccchannel_2_cave1_cyl1_focus_xw;
MCNUM mccchannel_2_cave1_cyl1_focus_xh;
MCNUM mccchannel_2_cave1_cyl1_focus_r;
MCNUM mccchannel_2_cave1_cyl1_p_interact;
char mccchannel_2_cave1_cyl1_mask_string[16384];
char mccchannel_2_cave1_cyl1_mask_setting[16384];
MCNUM mccchannel_2_cave1_cyl1_number_of_activations;

/* Setting parameters for component 'channel_2_analyzer_1_array_crystal_array_0' [206]. */
char mccchannel_2_analyzer_1_array_crystal_array_0_material_string[16384];
MCNUM mccchannel_2_analyzer_1_array_crystal_array_0_priority;
MCNUM mccchannel_2_analyzer_1_array_crystal_array_0_xwidth;
MCNUM mccchannel_2_analyzer_1_array_crystal_array_0_yheight;
MCNUM mccchannel_2_analyzer_1_array_crystal_array_0_zdepth;
MCNUM mccchannel_2_analyzer_1_array_crystal_array_0_xwidth2;
MCNUM mccchannel_2_analyzer_1_array_crystal_array_0_yheight2;
MCNUM mccchannel_2_analyzer_1_array_crystal_array_0_visualize;
int mccchannel_2_analyzer_1_array_crystal_array_0_target_index;
MCNUM mccchannel_2_analyzer_1_array_crystal_array_0_target_x;
MCNUM mccchannel_2_analyzer_1_array_crystal_array_0_target_y;
MCNUM mccchannel_2_analyzer_1_array_crystal_array_0_target_z;
MCNUM mccchannel_2_analyzer_1_array_crystal_array_0_focus_aw;
MCNUM mccchannel_2_analyzer_1_array_crystal_array_0_focus_ah;
MCNUM mccchannel_2_analyzer_1_array_crystal_array_0_focus_xw;
MCNUM mccchannel_2_analyzer_1_array_crystal_array_0_focus_xh;
MCNUM mccchannel_2_analyzer_1_array_crystal_array_0_focus_r;
MCNUM mccchannel_2_analyzer_1_array_crystal_array_0_p_interact;
char mccchannel_2_analyzer_1_array_crystal_array_0_mask_string[16384];
char mccchannel_2_analyzer_1_array_crystal_array_0_mask_setting[16384];
MCNUM mccchannel_2_analyzer_1_array_crystal_array_0_number_of_activations;

/* Setting parameters for component 'channel_2_analyzer_1_array_crystal_array_1' [207]. */
char mccchannel_2_analyzer_1_array_crystal_array_1_material_string[16384];
MCNUM mccchannel_2_analyzer_1_array_crystal_array_1_priority;
MCNUM mccchannel_2_analyzer_1_array_crystal_array_1_xwidth;
MCNUM mccchannel_2_analyzer_1_array_crystal_array_1_yheight;
MCNUM mccchannel_2_analyzer_1_array_crystal_array_1_zdepth;
MCNUM mccchannel_2_analyzer_1_array_crystal_array_1_xwidth2;
MCNUM mccchannel_2_analyzer_1_array_crystal_array_1_yheight2;
MCNUM mccchannel_2_analyzer_1_array_crystal_array_1_visualize;
int mccchannel_2_analyzer_1_array_crystal_array_1_target_index;
MCNUM mccchannel_2_analyzer_1_array_crystal_array_1_target_x;
MCNUM mccchannel_2_analyzer_1_array_crystal_array_1_target_y;
MCNUM mccchannel_2_analyzer_1_array_crystal_array_1_target_z;
MCNUM mccchannel_2_analyzer_1_array_crystal_array_1_focus_aw;
MCNUM mccchannel_2_analyzer_1_array_crystal_array_1_focus_ah;
MCNUM mccchannel_2_analyzer_1_array_crystal_array_1_focus_xw;
MCNUM mccchannel_2_analyzer_1_array_crystal_array_1_focus_xh;
MCNUM mccchannel_2_analyzer_1_array_crystal_array_1_focus_r;
MCNUM mccchannel_2_analyzer_1_array_crystal_array_1_p_interact;
char mccchannel_2_analyzer_1_array_crystal_array_1_mask_string[16384];
char mccchannel_2_analyzer_1_array_crystal_array_1_mask_setting[16384];
MCNUM mccchannel_2_analyzer_1_array_crystal_array_1_number_of_activations;

/* Setting parameters for component 'channel_2_analyzer_1_array_crystal_array_2' [208]. */
char mccchannel_2_analyzer_1_array_crystal_array_2_material_string[16384];
MCNUM mccchannel_2_analyzer_1_array_crystal_array_2_priority;
MCNUM mccchannel_2_analyzer_1_array_crystal_array_2_xwidth;
MCNUM mccchannel_2_analyzer_1_array_crystal_array_2_yheight;
MCNUM mccchannel_2_analyzer_1_array_crystal_array_2_zdepth;
MCNUM mccchannel_2_analyzer_1_array_crystal_array_2_xwidth2;
MCNUM mccchannel_2_analyzer_1_array_crystal_array_2_yheight2;
MCNUM mccchannel_2_analyzer_1_array_crystal_array_2_visualize;
int mccchannel_2_analyzer_1_array_crystal_array_2_target_index;
MCNUM mccchannel_2_analyzer_1_array_crystal_array_2_target_x;
MCNUM mccchannel_2_analyzer_1_array_crystal_array_2_target_y;
MCNUM mccchannel_2_analyzer_1_array_crystal_array_2_target_z;
MCNUM mccchannel_2_analyzer_1_array_crystal_array_2_focus_aw;
MCNUM mccchannel_2_analyzer_1_array_crystal_array_2_focus_ah;
MCNUM mccchannel_2_analyzer_1_array_crystal_array_2_focus_xw;
MCNUM mccchannel_2_analyzer_1_array_crystal_array_2_focus_xh;
MCNUM mccchannel_2_analyzer_1_array_crystal_array_2_focus_r;
MCNUM mccchannel_2_analyzer_1_array_crystal_array_2_p_interact;
char mccchannel_2_analyzer_1_array_crystal_array_2_mask_string[16384];
char mccchannel_2_analyzer_1_array_crystal_array_2_mask_setting[16384];
MCNUM mccchannel_2_analyzer_1_array_crystal_array_2_number_of_activations;

/* Setting parameters for component 'channel_2_analyzer_1_array_crystal_array_3' [209]. */
char mccchannel_2_analyzer_1_array_crystal_array_3_material_string[16384];
MCNUM mccchannel_2_analyzer_1_array_crystal_array_3_priority;
MCNUM mccchannel_2_analyzer_1_array_crystal_array_3_xwidth;
MCNUM mccchannel_2_analyzer_1_array_crystal_array_3_yheight;
MCNUM mccchannel_2_analyzer_1_array_crystal_array_3_zdepth;
MCNUM mccchannel_2_analyzer_1_array_crystal_array_3_xwidth2;
MCNUM mccchannel_2_analyzer_1_array_crystal_array_3_yheight2;
MCNUM mccchannel_2_analyzer_1_array_crystal_array_3_visualize;
int mccchannel_2_analyzer_1_array_crystal_array_3_target_index;
MCNUM mccchannel_2_analyzer_1_array_crystal_array_3_target_x;
MCNUM mccchannel_2_analyzer_1_array_crystal_array_3_target_y;
MCNUM mccchannel_2_analyzer_1_array_crystal_array_3_target_z;
MCNUM mccchannel_2_analyzer_1_array_crystal_array_3_focus_aw;
MCNUM mccchannel_2_analyzer_1_array_crystal_array_3_focus_ah;
MCNUM mccchannel_2_analyzer_1_array_crystal_array_3_focus_xw;
MCNUM mccchannel_2_analyzer_1_array_crystal_array_3_focus_xh;
MCNUM mccchannel_2_analyzer_1_array_crystal_array_3_focus_r;
MCNUM mccchannel_2_analyzer_1_array_crystal_array_3_p_interact;
char mccchannel_2_analyzer_1_array_crystal_array_3_mask_string[16384];
char mccchannel_2_analyzer_1_array_crystal_array_3_mask_setting[16384];
MCNUM mccchannel_2_analyzer_1_array_crystal_array_3_number_of_activations;

/* Setting parameters for component 'channel_2_analyzer_1_array_crystal_array_4' [210]. */
char mccchannel_2_analyzer_1_array_crystal_array_4_material_string[16384];
MCNUM mccchannel_2_analyzer_1_array_crystal_array_4_priority;
MCNUM mccchannel_2_analyzer_1_array_crystal_array_4_xwidth;
MCNUM mccchannel_2_analyzer_1_array_crystal_array_4_yheight;
MCNUM mccchannel_2_analyzer_1_array_crystal_array_4_zdepth;
MCNUM mccchannel_2_analyzer_1_array_crystal_array_4_xwidth2;
MCNUM mccchannel_2_analyzer_1_array_crystal_array_4_yheight2;
MCNUM mccchannel_2_analyzer_1_array_crystal_array_4_visualize;
int mccchannel_2_analyzer_1_array_crystal_array_4_target_index;
MCNUM mccchannel_2_analyzer_1_array_crystal_array_4_target_x;
MCNUM mccchannel_2_analyzer_1_array_crystal_array_4_target_y;
MCNUM mccchannel_2_analyzer_1_array_crystal_array_4_target_z;
MCNUM mccchannel_2_analyzer_1_array_crystal_array_4_focus_aw;
MCNUM mccchannel_2_analyzer_1_array_crystal_array_4_focus_ah;
MCNUM mccchannel_2_analyzer_1_array_crystal_array_4_focus_xw;
MCNUM mccchannel_2_analyzer_1_array_crystal_array_4_focus_xh;
MCNUM mccchannel_2_analyzer_1_array_crystal_array_4_focus_r;
MCNUM mccchannel_2_analyzer_1_array_crystal_array_4_p_interact;
char mccchannel_2_analyzer_1_array_crystal_array_4_mask_string[16384];
char mccchannel_2_analyzer_1_array_crystal_array_4_mask_setting[16384];
MCNUM mccchannel_2_analyzer_1_array_crystal_array_4_number_of_activations;

/* Setting parameters for component 'channel_2_analyzer_1_array_crystal_array_5' [211]. */
char mccchannel_2_analyzer_1_array_crystal_array_5_material_string[16384];
MCNUM mccchannel_2_analyzer_1_array_crystal_array_5_priority;
MCNUM mccchannel_2_analyzer_1_array_crystal_array_5_xwidth;
MCNUM mccchannel_2_analyzer_1_array_crystal_array_5_yheight;
MCNUM mccchannel_2_analyzer_1_array_crystal_array_5_zdepth;
MCNUM mccchannel_2_analyzer_1_array_crystal_array_5_xwidth2;
MCNUM mccchannel_2_analyzer_1_array_crystal_array_5_yheight2;
MCNUM mccchannel_2_analyzer_1_array_crystal_array_5_visualize;
int mccchannel_2_analyzer_1_array_crystal_array_5_target_index;
MCNUM mccchannel_2_analyzer_1_array_crystal_array_5_target_x;
MCNUM mccchannel_2_analyzer_1_array_crystal_array_5_target_y;
MCNUM mccchannel_2_analyzer_1_array_crystal_array_5_target_z;
MCNUM mccchannel_2_analyzer_1_array_crystal_array_5_focus_aw;
MCNUM mccchannel_2_analyzer_1_array_crystal_array_5_focus_ah;
MCNUM mccchannel_2_analyzer_1_array_crystal_array_5_focus_xw;
MCNUM mccchannel_2_analyzer_1_array_crystal_array_5_focus_xh;
MCNUM mccchannel_2_analyzer_1_array_crystal_array_5_focus_r;
MCNUM mccchannel_2_analyzer_1_array_crystal_array_5_p_interact;
char mccchannel_2_analyzer_1_array_crystal_array_5_mask_string[16384];
char mccchannel_2_analyzer_1_array_crystal_array_5_mask_setting[16384];
MCNUM mccchannel_2_analyzer_1_array_crystal_array_5_number_of_activations;

/* Setting parameters for component 'channel_2_analyzer_1_array_crystal_array_6' [212]. */
char mccchannel_2_analyzer_1_array_crystal_array_6_material_string[16384];
MCNUM mccchannel_2_analyzer_1_array_crystal_array_6_priority;
MCNUM mccchannel_2_analyzer_1_array_crystal_array_6_xwidth;
MCNUM mccchannel_2_analyzer_1_array_crystal_array_6_yheight;
MCNUM mccchannel_2_analyzer_1_array_crystal_array_6_zdepth;
MCNUM mccchannel_2_analyzer_1_array_crystal_array_6_xwidth2;
MCNUM mccchannel_2_analyzer_1_array_crystal_array_6_yheight2;
MCNUM mccchannel_2_analyzer_1_array_crystal_array_6_visualize;
int mccchannel_2_analyzer_1_array_crystal_array_6_target_index;
MCNUM mccchannel_2_analyzer_1_array_crystal_array_6_target_x;
MCNUM mccchannel_2_analyzer_1_array_crystal_array_6_target_y;
MCNUM mccchannel_2_analyzer_1_array_crystal_array_6_target_z;
MCNUM mccchannel_2_analyzer_1_array_crystal_array_6_focus_aw;
MCNUM mccchannel_2_analyzer_1_array_crystal_array_6_focus_ah;
MCNUM mccchannel_2_analyzer_1_array_crystal_array_6_focus_xw;
MCNUM mccchannel_2_analyzer_1_array_crystal_array_6_focus_xh;
MCNUM mccchannel_2_analyzer_1_array_crystal_array_6_focus_r;
MCNUM mccchannel_2_analyzer_1_array_crystal_array_6_p_interact;
char mccchannel_2_analyzer_1_array_crystal_array_6_mask_string[16384];
char mccchannel_2_analyzer_1_array_crystal_array_6_mask_setting[16384];
MCNUM mccchannel_2_analyzer_1_array_crystal_array_6_number_of_activations;

/* Setting parameters for component 'channel_2_analyzer_1_array_crystal_array_7' [213]. */
char mccchannel_2_analyzer_1_array_crystal_array_7_material_string[16384];
MCNUM mccchannel_2_analyzer_1_array_crystal_array_7_priority;
MCNUM mccchannel_2_analyzer_1_array_crystal_array_7_xwidth;
MCNUM mccchannel_2_analyzer_1_array_crystal_array_7_yheight;
MCNUM mccchannel_2_analyzer_1_array_crystal_array_7_zdepth;
MCNUM mccchannel_2_analyzer_1_array_crystal_array_7_xwidth2;
MCNUM mccchannel_2_analyzer_1_array_crystal_array_7_yheight2;
MCNUM mccchannel_2_analyzer_1_array_crystal_array_7_visualize;
int mccchannel_2_analyzer_1_array_crystal_array_7_target_index;
MCNUM mccchannel_2_analyzer_1_array_crystal_array_7_target_x;
MCNUM mccchannel_2_analyzer_1_array_crystal_array_7_target_y;
MCNUM mccchannel_2_analyzer_1_array_crystal_array_7_target_z;
MCNUM mccchannel_2_analyzer_1_array_crystal_array_7_focus_aw;
MCNUM mccchannel_2_analyzer_1_array_crystal_array_7_focus_ah;
MCNUM mccchannel_2_analyzer_1_array_crystal_array_7_focus_xw;
MCNUM mccchannel_2_analyzer_1_array_crystal_array_7_focus_xh;
MCNUM mccchannel_2_analyzer_1_array_crystal_array_7_focus_r;
MCNUM mccchannel_2_analyzer_1_array_crystal_array_7_p_interact;
char mccchannel_2_analyzer_1_array_crystal_array_7_mask_string[16384];
char mccchannel_2_analyzer_1_array_crystal_array_7_mask_setting[16384];
MCNUM mccchannel_2_analyzer_1_array_crystal_array_7_number_of_activations;

/* Setting parameters for component 'channel_2_analyzer_1_array_crystal_array_8' [214]. */
char mccchannel_2_analyzer_1_array_crystal_array_8_material_string[16384];
MCNUM mccchannel_2_analyzer_1_array_crystal_array_8_priority;
MCNUM mccchannel_2_analyzer_1_array_crystal_array_8_xwidth;
MCNUM mccchannel_2_analyzer_1_array_crystal_array_8_yheight;
MCNUM mccchannel_2_analyzer_1_array_crystal_array_8_zdepth;
MCNUM mccchannel_2_analyzer_1_array_crystal_array_8_xwidth2;
MCNUM mccchannel_2_analyzer_1_array_crystal_array_8_yheight2;
MCNUM mccchannel_2_analyzer_1_array_crystal_array_8_visualize;
int mccchannel_2_analyzer_1_array_crystal_array_8_target_index;
MCNUM mccchannel_2_analyzer_1_array_crystal_array_8_target_x;
MCNUM mccchannel_2_analyzer_1_array_crystal_array_8_target_y;
MCNUM mccchannel_2_analyzer_1_array_crystal_array_8_target_z;
MCNUM mccchannel_2_analyzer_1_array_crystal_array_8_focus_aw;
MCNUM mccchannel_2_analyzer_1_array_crystal_array_8_focus_ah;
MCNUM mccchannel_2_analyzer_1_array_crystal_array_8_focus_xw;
MCNUM mccchannel_2_analyzer_1_array_crystal_array_8_focus_xh;
MCNUM mccchannel_2_analyzer_1_array_crystal_array_8_focus_r;
MCNUM mccchannel_2_analyzer_1_array_crystal_array_8_p_interact;
char mccchannel_2_analyzer_1_array_crystal_array_8_mask_string[16384];
char mccchannel_2_analyzer_1_array_crystal_array_8_mask_setting[16384];
MCNUM mccchannel_2_analyzer_1_array_crystal_array_8_number_of_activations;

/* Setting parameters for component 'channel_2_analyzer_2_array_crystal_array_0' [217]. */
char mccchannel_2_analyzer_2_array_crystal_array_0_material_string[16384];
MCNUM mccchannel_2_analyzer_2_array_crystal_array_0_priority;
MCNUM mccchannel_2_analyzer_2_array_crystal_array_0_xwidth;
MCNUM mccchannel_2_analyzer_2_array_crystal_array_0_yheight;
MCNUM mccchannel_2_analyzer_2_array_crystal_array_0_zdepth;
MCNUM mccchannel_2_analyzer_2_array_crystal_array_0_xwidth2;
MCNUM mccchannel_2_analyzer_2_array_crystal_array_0_yheight2;
MCNUM mccchannel_2_analyzer_2_array_crystal_array_0_visualize;
int mccchannel_2_analyzer_2_array_crystal_array_0_target_index;
MCNUM mccchannel_2_analyzer_2_array_crystal_array_0_target_x;
MCNUM mccchannel_2_analyzer_2_array_crystal_array_0_target_y;
MCNUM mccchannel_2_analyzer_2_array_crystal_array_0_target_z;
MCNUM mccchannel_2_analyzer_2_array_crystal_array_0_focus_aw;
MCNUM mccchannel_2_analyzer_2_array_crystal_array_0_focus_ah;
MCNUM mccchannel_2_analyzer_2_array_crystal_array_0_focus_xw;
MCNUM mccchannel_2_analyzer_2_array_crystal_array_0_focus_xh;
MCNUM mccchannel_2_analyzer_2_array_crystal_array_0_focus_r;
MCNUM mccchannel_2_analyzer_2_array_crystal_array_0_p_interact;
char mccchannel_2_analyzer_2_array_crystal_array_0_mask_string[16384];
char mccchannel_2_analyzer_2_array_crystal_array_0_mask_setting[16384];
MCNUM mccchannel_2_analyzer_2_array_crystal_array_0_number_of_activations;

/* Setting parameters for component 'channel_2_analyzer_2_array_crystal_array_1' [218]. */
char mccchannel_2_analyzer_2_array_crystal_array_1_material_string[16384];
MCNUM mccchannel_2_analyzer_2_array_crystal_array_1_priority;
MCNUM mccchannel_2_analyzer_2_array_crystal_array_1_xwidth;
MCNUM mccchannel_2_analyzer_2_array_crystal_array_1_yheight;
MCNUM mccchannel_2_analyzer_2_array_crystal_array_1_zdepth;
MCNUM mccchannel_2_analyzer_2_array_crystal_array_1_xwidth2;
MCNUM mccchannel_2_analyzer_2_array_crystal_array_1_yheight2;
MCNUM mccchannel_2_analyzer_2_array_crystal_array_1_visualize;
int mccchannel_2_analyzer_2_array_crystal_array_1_target_index;
MCNUM mccchannel_2_analyzer_2_array_crystal_array_1_target_x;
MCNUM mccchannel_2_analyzer_2_array_crystal_array_1_target_y;
MCNUM mccchannel_2_analyzer_2_array_crystal_array_1_target_z;
MCNUM mccchannel_2_analyzer_2_array_crystal_array_1_focus_aw;
MCNUM mccchannel_2_analyzer_2_array_crystal_array_1_focus_ah;
MCNUM mccchannel_2_analyzer_2_array_crystal_array_1_focus_xw;
MCNUM mccchannel_2_analyzer_2_array_crystal_array_1_focus_xh;
MCNUM mccchannel_2_analyzer_2_array_crystal_array_1_focus_r;
MCNUM mccchannel_2_analyzer_2_array_crystal_array_1_p_interact;
char mccchannel_2_analyzer_2_array_crystal_array_1_mask_string[16384];
char mccchannel_2_analyzer_2_array_crystal_array_1_mask_setting[16384];
MCNUM mccchannel_2_analyzer_2_array_crystal_array_1_number_of_activations;

/* Setting parameters for component 'channel_2_analyzer_2_array_crystal_array_2' [219]. */
char mccchannel_2_analyzer_2_array_crystal_array_2_material_string[16384];
MCNUM mccchannel_2_analyzer_2_array_crystal_array_2_priority;
MCNUM mccchannel_2_analyzer_2_array_crystal_array_2_xwidth;
MCNUM mccchannel_2_analyzer_2_array_crystal_array_2_yheight;
MCNUM mccchannel_2_analyzer_2_array_crystal_array_2_zdepth;
MCNUM mccchannel_2_analyzer_2_array_crystal_array_2_xwidth2;
MCNUM mccchannel_2_analyzer_2_array_crystal_array_2_yheight2;
MCNUM mccchannel_2_analyzer_2_array_crystal_array_2_visualize;
int mccchannel_2_analyzer_2_array_crystal_array_2_target_index;
MCNUM mccchannel_2_analyzer_2_array_crystal_array_2_target_x;
MCNUM mccchannel_2_analyzer_2_array_crystal_array_2_target_y;
MCNUM mccchannel_2_analyzer_2_array_crystal_array_2_target_z;
MCNUM mccchannel_2_analyzer_2_array_crystal_array_2_focus_aw;
MCNUM mccchannel_2_analyzer_2_array_crystal_array_2_focus_ah;
MCNUM mccchannel_2_analyzer_2_array_crystal_array_2_focus_xw;
MCNUM mccchannel_2_analyzer_2_array_crystal_array_2_focus_xh;
MCNUM mccchannel_2_analyzer_2_array_crystal_array_2_focus_r;
MCNUM mccchannel_2_analyzer_2_array_crystal_array_2_p_interact;
char mccchannel_2_analyzer_2_array_crystal_array_2_mask_string[16384];
char mccchannel_2_analyzer_2_array_crystal_array_2_mask_setting[16384];
MCNUM mccchannel_2_analyzer_2_array_crystal_array_2_number_of_activations;

/* Setting parameters for component 'channel_2_analyzer_2_array_crystal_array_3' [220]. */
char mccchannel_2_analyzer_2_array_crystal_array_3_material_string[16384];
MCNUM mccchannel_2_analyzer_2_array_crystal_array_3_priority;
MCNUM mccchannel_2_analyzer_2_array_crystal_array_3_xwidth;
MCNUM mccchannel_2_analyzer_2_array_crystal_array_3_yheight;
MCNUM mccchannel_2_analyzer_2_array_crystal_array_3_zdepth;
MCNUM mccchannel_2_analyzer_2_array_crystal_array_3_xwidth2;
MCNUM mccchannel_2_analyzer_2_array_crystal_array_3_yheight2;
MCNUM mccchannel_2_analyzer_2_array_crystal_array_3_visualize;
int mccchannel_2_analyzer_2_array_crystal_array_3_target_index;
MCNUM mccchannel_2_analyzer_2_array_crystal_array_3_target_x;
MCNUM mccchannel_2_analyzer_2_array_crystal_array_3_target_y;
MCNUM mccchannel_2_analyzer_2_array_crystal_array_3_target_z;
MCNUM mccchannel_2_analyzer_2_array_crystal_array_3_focus_aw;
MCNUM mccchannel_2_analyzer_2_array_crystal_array_3_focus_ah;
MCNUM mccchannel_2_analyzer_2_array_crystal_array_3_focus_xw;
MCNUM mccchannel_2_analyzer_2_array_crystal_array_3_focus_xh;
MCNUM mccchannel_2_analyzer_2_array_crystal_array_3_focus_r;
MCNUM mccchannel_2_analyzer_2_array_crystal_array_3_p_interact;
char mccchannel_2_analyzer_2_array_crystal_array_3_mask_string[16384];
char mccchannel_2_analyzer_2_array_crystal_array_3_mask_setting[16384];
MCNUM mccchannel_2_analyzer_2_array_crystal_array_3_number_of_activations;

/* Setting parameters for component 'channel_2_analyzer_2_array_crystal_array_4' [221]. */
char mccchannel_2_analyzer_2_array_crystal_array_4_material_string[16384];
MCNUM mccchannel_2_analyzer_2_array_crystal_array_4_priority;
MCNUM mccchannel_2_analyzer_2_array_crystal_array_4_xwidth;
MCNUM mccchannel_2_analyzer_2_array_crystal_array_4_yheight;
MCNUM mccchannel_2_analyzer_2_array_crystal_array_4_zdepth;
MCNUM mccchannel_2_analyzer_2_array_crystal_array_4_xwidth2;
MCNUM mccchannel_2_analyzer_2_array_crystal_array_4_yheight2;
MCNUM mccchannel_2_analyzer_2_array_crystal_array_4_visualize;
int mccchannel_2_analyzer_2_array_crystal_array_4_target_index;
MCNUM mccchannel_2_analyzer_2_array_crystal_array_4_target_x;
MCNUM mccchannel_2_analyzer_2_array_crystal_array_4_target_y;
MCNUM mccchannel_2_analyzer_2_array_crystal_array_4_target_z;
MCNUM mccchannel_2_analyzer_2_array_crystal_array_4_focus_aw;
MCNUM mccchannel_2_analyzer_2_array_crystal_array_4_focus_ah;
MCNUM mccchannel_2_analyzer_2_array_crystal_array_4_focus_xw;
MCNUM mccchannel_2_analyzer_2_array_crystal_array_4_focus_xh;
MCNUM mccchannel_2_analyzer_2_array_crystal_array_4_focus_r;
MCNUM mccchannel_2_analyzer_2_array_crystal_array_4_p_interact;
char mccchannel_2_analyzer_2_array_crystal_array_4_mask_string[16384];
char mccchannel_2_analyzer_2_array_crystal_array_4_mask_setting[16384];
MCNUM mccchannel_2_analyzer_2_array_crystal_array_4_number_of_activations;

/* Setting parameters for component 'channel_2_analyzer_2_array_crystal_array_5' [222]. */
char mccchannel_2_analyzer_2_array_crystal_array_5_material_string[16384];
MCNUM mccchannel_2_analyzer_2_array_crystal_array_5_priority;
MCNUM mccchannel_2_analyzer_2_array_crystal_array_5_xwidth;
MCNUM mccchannel_2_analyzer_2_array_crystal_array_5_yheight;
MCNUM mccchannel_2_analyzer_2_array_crystal_array_5_zdepth;
MCNUM mccchannel_2_analyzer_2_array_crystal_array_5_xwidth2;
MCNUM mccchannel_2_analyzer_2_array_crystal_array_5_yheight2;
MCNUM mccchannel_2_analyzer_2_array_crystal_array_5_visualize;
int mccchannel_2_analyzer_2_array_crystal_array_5_target_index;
MCNUM mccchannel_2_analyzer_2_array_crystal_array_5_target_x;
MCNUM mccchannel_2_analyzer_2_array_crystal_array_5_target_y;
MCNUM mccchannel_2_analyzer_2_array_crystal_array_5_target_z;
MCNUM mccchannel_2_analyzer_2_array_crystal_array_5_focus_aw;
MCNUM mccchannel_2_analyzer_2_array_crystal_array_5_focus_ah;
MCNUM mccchannel_2_analyzer_2_array_crystal_array_5_focus_xw;
MCNUM mccchannel_2_analyzer_2_array_crystal_array_5_focus_xh;
MCNUM mccchannel_2_analyzer_2_array_crystal_array_5_focus_r;
MCNUM mccchannel_2_analyzer_2_array_crystal_array_5_p_interact;
char mccchannel_2_analyzer_2_array_crystal_array_5_mask_string[16384];
char mccchannel_2_analyzer_2_array_crystal_array_5_mask_setting[16384];
MCNUM mccchannel_2_analyzer_2_array_crystal_array_5_number_of_activations;

/* Setting parameters for component 'channel_2_analyzer_2_array_crystal_array_6' [223]. */
char mccchannel_2_analyzer_2_array_crystal_array_6_material_string[16384];
MCNUM mccchannel_2_analyzer_2_array_crystal_array_6_priority;
MCNUM mccchannel_2_analyzer_2_array_crystal_array_6_xwidth;
MCNUM mccchannel_2_analyzer_2_array_crystal_array_6_yheight;
MCNUM mccchannel_2_analyzer_2_array_crystal_array_6_zdepth;
MCNUM mccchannel_2_analyzer_2_array_crystal_array_6_xwidth2;
MCNUM mccchannel_2_analyzer_2_array_crystal_array_6_yheight2;
MCNUM mccchannel_2_analyzer_2_array_crystal_array_6_visualize;
int mccchannel_2_analyzer_2_array_crystal_array_6_target_index;
MCNUM mccchannel_2_analyzer_2_array_crystal_array_6_target_x;
MCNUM mccchannel_2_analyzer_2_array_crystal_array_6_target_y;
MCNUM mccchannel_2_analyzer_2_array_crystal_array_6_target_z;
MCNUM mccchannel_2_analyzer_2_array_crystal_array_6_focus_aw;
MCNUM mccchannel_2_analyzer_2_array_crystal_array_6_focus_ah;
MCNUM mccchannel_2_analyzer_2_array_crystal_array_6_focus_xw;
MCNUM mccchannel_2_analyzer_2_array_crystal_array_6_focus_xh;
MCNUM mccchannel_2_analyzer_2_array_crystal_array_6_focus_r;
MCNUM mccchannel_2_analyzer_2_array_crystal_array_6_p_interact;
char mccchannel_2_analyzer_2_array_crystal_array_6_mask_string[16384];
char mccchannel_2_analyzer_2_array_crystal_array_6_mask_setting[16384];
MCNUM mccchannel_2_analyzer_2_array_crystal_array_6_number_of_activations;

/* Setting parameters for component 'channel_2_analyzer_2_array_crystal_array_7' [224]. */
char mccchannel_2_analyzer_2_array_crystal_array_7_material_string[16384];
MCNUM mccchannel_2_analyzer_2_array_crystal_array_7_priority;
MCNUM mccchannel_2_analyzer_2_array_crystal_array_7_xwidth;
MCNUM mccchannel_2_analyzer_2_array_crystal_array_7_yheight;
MCNUM mccchannel_2_analyzer_2_array_crystal_array_7_zdepth;
MCNUM mccchannel_2_analyzer_2_array_crystal_array_7_xwidth2;
MCNUM mccchannel_2_analyzer_2_array_crystal_array_7_yheight2;
MCNUM mccchannel_2_analyzer_2_array_crystal_array_7_visualize;
int mccchannel_2_analyzer_2_array_crystal_array_7_target_index;
MCNUM mccchannel_2_analyzer_2_array_crystal_array_7_target_x;
MCNUM mccchannel_2_analyzer_2_array_crystal_array_7_target_y;
MCNUM mccchannel_2_analyzer_2_array_crystal_array_7_target_z;
MCNUM mccchannel_2_analyzer_2_array_crystal_array_7_focus_aw;
MCNUM mccchannel_2_analyzer_2_array_crystal_array_7_focus_ah;
MCNUM mccchannel_2_analyzer_2_array_crystal_array_7_focus_xw;
MCNUM mccchannel_2_analyzer_2_array_crystal_array_7_focus_xh;
MCNUM mccchannel_2_analyzer_2_array_crystal_array_7_focus_r;
MCNUM mccchannel_2_analyzer_2_array_crystal_array_7_p_interact;
char mccchannel_2_analyzer_2_array_crystal_array_7_mask_string[16384];
char mccchannel_2_analyzer_2_array_crystal_array_7_mask_setting[16384];
MCNUM mccchannel_2_analyzer_2_array_crystal_array_7_number_of_activations;

/* Setting parameters for component 'channel_2_analyzer_2_array_crystal_array_8' [225]. */
char mccchannel_2_analyzer_2_array_crystal_array_8_material_string[16384];
MCNUM mccchannel_2_analyzer_2_array_crystal_array_8_priority;
MCNUM mccchannel_2_analyzer_2_array_crystal_array_8_xwidth;
MCNUM mccchannel_2_analyzer_2_array_crystal_array_8_yheight;
MCNUM mccchannel_2_analyzer_2_array_crystal_array_8_zdepth;
MCNUM mccchannel_2_analyzer_2_array_crystal_array_8_xwidth2;
MCNUM mccchannel_2_analyzer_2_array_crystal_array_8_yheight2;
MCNUM mccchannel_2_analyzer_2_array_crystal_array_8_visualize;
int mccchannel_2_analyzer_2_array_crystal_array_8_target_index;
MCNUM mccchannel_2_analyzer_2_array_crystal_array_8_target_x;
MCNUM mccchannel_2_analyzer_2_array_crystal_array_8_target_y;
MCNUM mccchannel_2_analyzer_2_array_crystal_array_8_target_z;
MCNUM mccchannel_2_analyzer_2_array_crystal_array_8_focus_aw;
MCNUM mccchannel_2_analyzer_2_array_crystal_array_8_focus_ah;
MCNUM mccchannel_2_analyzer_2_array_crystal_array_8_focus_xw;
MCNUM mccchannel_2_analyzer_2_array_crystal_array_8_focus_xh;
MCNUM mccchannel_2_analyzer_2_array_crystal_array_8_focus_r;
MCNUM mccchannel_2_analyzer_2_array_crystal_array_8_p_interact;
char mccchannel_2_analyzer_2_array_crystal_array_8_mask_string[16384];
char mccchannel_2_analyzer_2_array_crystal_array_8_mask_setting[16384];
MCNUM mccchannel_2_analyzer_2_array_crystal_array_8_number_of_activations;

/* Setting parameters for component 'channel_2_cave2_cyl1' [226]. */
char mccchannel_2_cave2_cyl1_material_string[16384];
MCNUM mccchannel_2_cave2_cyl1_priority;
MCNUM mccchannel_2_cave2_cyl1_radius;
MCNUM mccchannel_2_cave2_cyl1_yheight;
MCNUM mccchannel_2_cave2_cyl1_visualize;
int mccchannel_2_cave2_cyl1_target_index;
MCNUM mccchannel_2_cave2_cyl1_target_x;
MCNUM mccchannel_2_cave2_cyl1_target_y;
MCNUM mccchannel_2_cave2_cyl1_target_z;
MCNUM mccchannel_2_cave2_cyl1_focus_aw;
MCNUM mccchannel_2_cave2_cyl1_focus_ah;
MCNUM mccchannel_2_cave2_cyl1_focus_xw;
MCNUM mccchannel_2_cave2_cyl1_focus_xh;
MCNUM mccchannel_2_cave2_cyl1_focus_r;
MCNUM mccchannel_2_cave2_cyl1_p_interact;
char mccchannel_2_cave2_cyl1_mask_string[16384];
char mccchannel_2_cave2_cyl1_mask_setting[16384];
MCNUM mccchannel_2_cave2_cyl1_number_of_activations;

/* Setting parameters for component 'channel_2_cave2_box1' [227]. */
char mccchannel_2_cave2_box1_material_string[16384];
MCNUM mccchannel_2_cave2_box1_priority;
MCNUM mccchannel_2_cave2_box1_xwidth;
MCNUM mccchannel_2_cave2_box1_yheight;
MCNUM mccchannel_2_cave2_box1_zdepth;
MCNUM mccchannel_2_cave2_box1_xwidth2;
MCNUM mccchannel_2_cave2_box1_yheight2;
MCNUM mccchannel_2_cave2_box1_visualize;
int mccchannel_2_cave2_box1_target_index;
MCNUM mccchannel_2_cave2_box1_target_x;
MCNUM mccchannel_2_cave2_box1_target_y;
MCNUM mccchannel_2_cave2_box1_target_z;
MCNUM mccchannel_2_cave2_box1_focus_aw;
MCNUM mccchannel_2_cave2_box1_focus_ah;
MCNUM mccchannel_2_cave2_box1_focus_xw;
MCNUM mccchannel_2_cave2_box1_focus_xh;
MCNUM mccchannel_2_cave2_box1_focus_r;
MCNUM mccchannel_2_cave2_box1_p_interact;
char mccchannel_2_cave2_box1_mask_string[16384];
char mccchannel_2_cave2_box1_mask_setting[16384];
MCNUM mccchannel_2_cave2_box1_number_of_activations;

/* Setting parameters for component 'channel_2_cave2_box2' [228]. */
char mccchannel_2_cave2_box2_material_string[16384];
MCNUM mccchannel_2_cave2_box2_priority;
MCNUM mccchannel_2_cave2_box2_xwidth;
MCNUM mccchannel_2_cave2_box2_yheight;
MCNUM mccchannel_2_cave2_box2_zdepth;
MCNUM mccchannel_2_cave2_box2_xwidth2;
MCNUM mccchannel_2_cave2_box2_yheight2;
MCNUM mccchannel_2_cave2_box2_visualize;
int mccchannel_2_cave2_box2_target_index;
MCNUM mccchannel_2_cave2_box2_target_x;
MCNUM mccchannel_2_cave2_box2_target_y;
MCNUM mccchannel_2_cave2_box2_target_z;
MCNUM mccchannel_2_cave2_box2_focus_aw;
MCNUM mccchannel_2_cave2_box2_focus_ah;
MCNUM mccchannel_2_cave2_box2_focus_xw;
MCNUM mccchannel_2_cave2_box2_focus_xh;
MCNUM mccchannel_2_cave2_box2_focus_r;
MCNUM mccchannel_2_cave2_box2_p_interact;
char mccchannel_2_cave2_box2_mask_string[16384];
char mccchannel_2_cave2_box2_mask_setting[16384];
MCNUM mccchannel_2_cave2_box2_number_of_activations;

/* Setting parameters for component 'channel_2_cave2_box3' [229]. */
char mccchannel_2_cave2_box3_material_string[16384];
MCNUM mccchannel_2_cave2_box3_priority;
MCNUM mccchannel_2_cave2_box3_xwidth;
MCNUM mccchannel_2_cave2_box3_yheight;
MCNUM mccchannel_2_cave2_box3_zdepth;
MCNUM mccchannel_2_cave2_box3_xwidth2;
MCNUM mccchannel_2_cave2_box3_yheight2;
MCNUM mccchannel_2_cave2_box3_visualize;
int mccchannel_2_cave2_box3_target_index;
MCNUM mccchannel_2_cave2_box3_target_x;
MCNUM mccchannel_2_cave2_box3_target_y;
MCNUM mccchannel_2_cave2_box3_target_z;
MCNUM mccchannel_2_cave2_box3_focus_aw;
MCNUM mccchannel_2_cave2_box3_focus_ah;
MCNUM mccchannel_2_cave2_box3_focus_xw;
MCNUM mccchannel_2_cave2_box3_focus_xh;
MCNUM mccchannel_2_cave2_box3_focus_r;
MCNUM mccchannel_2_cave2_box3_p_interact;
char mccchannel_2_cave2_box3_mask_string[16384];
char mccchannel_2_cave2_box3_mask_setting[16384];
MCNUM mccchannel_2_cave2_box3_number_of_activations;

/* Setting parameters for component 'inter_analyzer_colimator_2_blade_0' [231]. */
char mccinter_analyzer_colimator_2_blade_0_material_string[16384];
MCNUM mccinter_analyzer_colimator_2_blade_0_priority;
MCNUM mccinter_analyzer_colimator_2_blade_0_xwidth;
MCNUM mccinter_analyzer_colimator_2_blade_0_yheight;
MCNUM mccinter_analyzer_colimator_2_blade_0_zdepth;
MCNUM mccinter_analyzer_colimator_2_blade_0_xwidth2;
MCNUM mccinter_analyzer_colimator_2_blade_0_yheight2;
MCNUM mccinter_analyzer_colimator_2_blade_0_visualize;
int mccinter_analyzer_colimator_2_blade_0_target_index;
MCNUM mccinter_analyzer_colimator_2_blade_0_target_x;
MCNUM mccinter_analyzer_colimator_2_blade_0_target_y;
MCNUM mccinter_analyzer_colimator_2_blade_0_target_z;
MCNUM mccinter_analyzer_colimator_2_blade_0_focus_aw;
MCNUM mccinter_analyzer_colimator_2_blade_0_focus_ah;
MCNUM mccinter_analyzer_colimator_2_blade_0_focus_xw;
MCNUM mccinter_analyzer_colimator_2_blade_0_focus_xh;
MCNUM mccinter_analyzer_colimator_2_blade_0_focus_r;
MCNUM mccinter_analyzer_colimator_2_blade_0_p_interact;
char mccinter_analyzer_colimator_2_blade_0_mask_string[16384];
char mccinter_analyzer_colimator_2_blade_0_mask_setting[16384];
MCNUM mccinter_analyzer_colimator_2_blade_0_number_of_activations;

/* Setting parameters for component 'inter_analyzer_colimator_2_blade_1' [232]. */
char mccinter_analyzer_colimator_2_blade_1_material_string[16384];
MCNUM mccinter_analyzer_colimator_2_blade_1_priority;
MCNUM mccinter_analyzer_colimator_2_blade_1_xwidth;
MCNUM mccinter_analyzer_colimator_2_blade_1_yheight;
MCNUM mccinter_analyzer_colimator_2_blade_1_zdepth;
MCNUM mccinter_analyzer_colimator_2_blade_1_xwidth2;
MCNUM mccinter_analyzer_colimator_2_blade_1_yheight2;
MCNUM mccinter_analyzer_colimator_2_blade_1_visualize;
int mccinter_analyzer_colimator_2_blade_1_target_index;
MCNUM mccinter_analyzer_colimator_2_blade_1_target_x;
MCNUM mccinter_analyzer_colimator_2_blade_1_target_y;
MCNUM mccinter_analyzer_colimator_2_blade_1_target_z;
MCNUM mccinter_analyzer_colimator_2_blade_1_focus_aw;
MCNUM mccinter_analyzer_colimator_2_blade_1_focus_ah;
MCNUM mccinter_analyzer_colimator_2_blade_1_focus_xw;
MCNUM mccinter_analyzer_colimator_2_blade_1_focus_xh;
MCNUM mccinter_analyzer_colimator_2_blade_1_focus_r;
MCNUM mccinter_analyzer_colimator_2_blade_1_p_interact;
char mccinter_analyzer_colimator_2_blade_1_mask_string[16384];
char mccinter_analyzer_colimator_2_blade_1_mask_setting[16384];
MCNUM mccinter_analyzer_colimator_2_blade_1_number_of_activations;

/* Setting parameters for component 'inter_analyzer_colimator_2_blade_2' [233]. */
char mccinter_analyzer_colimator_2_blade_2_material_string[16384];
MCNUM mccinter_analyzer_colimator_2_blade_2_priority;
MCNUM mccinter_analyzer_colimator_2_blade_2_xwidth;
MCNUM mccinter_analyzer_colimator_2_blade_2_yheight;
MCNUM mccinter_analyzer_colimator_2_blade_2_zdepth;
MCNUM mccinter_analyzer_colimator_2_blade_2_xwidth2;
MCNUM mccinter_analyzer_colimator_2_blade_2_yheight2;
MCNUM mccinter_analyzer_colimator_2_blade_2_visualize;
int mccinter_analyzer_colimator_2_blade_2_target_index;
MCNUM mccinter_analyzer_colimator_2_blade_2_target_x;
MCNUM mccinter_analyzer_colimator_2_blade_2_target_y;
MCNUM mccinter_analyzer_colimator_2_blade_2_target_z;
MCNUM mccinter_analyzer_colimator_2_blade_2_focus_aw;
MCNUM mccinter_analyzer_colimator_2_blade_2_focus_ah;
MCNUM mccinter_analyzer_colimator_2_blade_2_focus_xw;
MCNUM mccinter_analyzer_colimator_2_blade_2_focus_xh;
MCNUM mccinter_analyzer_colimator_2_blade_2_focus_r;
MCNUM mccinter_analyzer_colimator_2_blade_2_p_interact;
char mccinter_analyzer_colimator_2_blade_2_mask_string[16384];
char mccinter_analyzer_colimator_2_blade_2_mask_setting[16384];
MCNUM mccinter_analyzer_colimator_2_blade_2_number_of_activations;

/* Setting parameters for component 'inter_analyzer_colimator_2_blade_3' [234]. */
char mccinter_analyzer_colimator_2_blade_3_material_string[16384];
MCNUM mccinter_analyzer_colimator_2_blade_3_priority;
MCNUM mccinter_analyzer_colimator_2_blade_3_xwidth;
MCNUM mccinter_analyzer_colimator_2_blade_3_yheight;
MCNUM mccinter_analyzer_colimator_2_blade_3_zdepth;
MCNUM mccinter_analyzer_colimator_2_blade_3_xwidth2;
MCNUM mccinter_analyzer_colimator_2_blade_3_yheight2;
MCNUM mccinter_analyzer_colimator_2_blade_3_visualize;
int mccinter_analyzer_colimator_2_blade_3_target_index;
MCNUM mccinter_analyzer_colimator_2_blade_3_target_x;
MCNUM mccinter_analyzer_colimator_2_blade_3_target_y;
MCNUM mccinter_analyzer_colimator_2_blade_3_target_z;
MCNUM mccinter_analyzer_colimator_2_blade_3_focus_aw;
MCNUM mccinter_analyzer_colimator_2_blade_3_focus_ah;
MCNUM mccinter_analyzer_colimator_2_blade_3_focus_xw;
MCNUM mccinter_analyzer_colimator_2_blade_3_focus_xh;
MCNUM mccinter_analyzer_colimator_2_blade_3_focus_r;
MCNUM mccinter_analyzer_colimator_2_blade_3_p_interact;
char mccinter_analyzer_colimator_2_blade_3_mask_string[16384];
char mccinter_analyzer_colimator_2_blade_3_mask_setting[16384];
MCNUM mccinter_analyzer_colimator_2_blade_3_number_of_activations;

/* Setting parameters for component 'inter_analyzer_colimator_2_blade_4' [235]. */
char mccinter_analyzer_colimator_2_blade_4_material_string[16384];
MCNUM mccinter_analyzer_colimator_2_blade_4_priority;
MCNUM mccinter_analyzer_colimator_2_blade_4_xwidth;
MCNUM mccinter_analyzer_colimator_2_blade_4_yheight;
MCNUM mccinter_analyzer_colimator_2_blade_4_zdepth;
MCNUM mccinter_analyzer_colimator_2_blade_4_xwidth2;
MCNUM mccinter_analyzer_colimator_2_blade_4_yheight2;
MCNUM mccinter_analyzer_colimator_2_blade_4_visualize;
int mccinter_analyzer_colimator_2_blade_4_target_index;
MCNUM mccinter_analyzer_colimator_2_blade_4_target_x;
MCNUM mccinter_analyzer_colimator_2_blade_4_target_y;
MCNUM mccinter_analyzer_colimator_2_blade_4_target_z;
MCNUM mccinter_analyzer_colimator_2_blade_4_focus_aw;
MCNUM mccinter_analyzer_colimator_2_blade_4_focus_ah;
MCNUM mccinter_analyzer_colimator_2_blade_4_focus_xw;
MCNUM mccinter_analyzer_colimator_2_blade_4_focus_xh;
MCNUM mccinter_analyzer_colimator_2_blade_4_focus_r;
MCNUM mccinter_analyzer_colimator_2_blade_4_p_interact;
char mccinter_analyzer_colimator_2_blade_4_mask_string[16384];
char mccinter_analyzer_colimator_2_blade_4_mask_setting[16384];
MCNUM mccinter_analyzer_colimator_2_blade_4_number_of_activations;

/* Setting parameters for component 'diffraction_detector_2_exit_volume' [236]. */
char mccdiffraction_detector_2_exit_volume_material_string[16384];
MCNUM mccdiffraction_detector_2_exit_volume_priority;
MCNUM mccdiffraction_detector_2_exit_volume_xwidth;
MCNUM mccdiffraction_detector_2_exit_volume_yheight;
MCNUM mccdiffraction_detector_2_exit_volume_zdepth;
MCNUM mccdiffraction_detector_2_exit_volume_xwidth2;
MCNUM mccdiffraction_detector_2_exit_volume_yheight2;
MCNUM mccdiffraction_detector_2_exit_volume_visualize;
int mccdiffraction_detector_2_exit_volume_target_index;
MCNUM mccdiffraction_detector_2_exit_volume_target_x;
MCNUM mccdiffraction_detector_2_exit_volume_target_y;
MCNUM mccdiffraction_detector_2_exit_volume_target_z;
MCNUM mccdiffraction_detector_2_exit_volume_focus_aw;
MCNUM mccdiffraction_detector_2_exit_volume_focus_ah;
MCNUM mccdiffraction_detector_2_exit_volume_focus_xw;
MCNUM mccdiffraction_detector_2_exit_volume_focus_xh;
MCNUM mccdiffraction_detector_2_exit_volume_focus_r;
MCNUM mccdiffraction_detector_2_exit_volume_p_interact;
char mccdiffraction_detector_2_exit_volume_mask_string[16384];
char mccdiffraction_detector_2_exit_volume_mask_setting[16384];
MCNUM mccdiffraction_detector_2_exit_volume_number_of_activations;

/* Setting parameters for component 'spec_detector_2_exit_volume' [237]. */
char mccspec_detector_2_exit_volume_material_string[16384];
MCNUM mccspec_detector_2_exit_volume_priority;
MCNUM mccspec_detector_2_exit_volume_xwidth;
MCNUM mccspec_detector_2_exit_volume_yheight;
MCNUM mccspec_detector_2_exit_volume_zdepth;
MCNUM mccspec_detector_2_exit_volume_xwidth2;
MCNUM mccspec_detector_2_exit_volume_yheight2;
MCNUM mccspec_detector_2_exit_volume_visualize;
int mccspec_detector_2_exit_volume_target_index;
MCNUM mccspec_detector_2_exit_volume_target_x;
MCNUM mccspec_detector_2_exit_volume_target_y;
MCNUM mccspec_detector_2_exit_volume_target_z;
MCNUM mccspec_detector_2_exit_volume_focus_aw;
MCNUM mccspec_detector_2_exit_volume_focus_ah;
MCNUM mccspec_detector_2_exit_volume_focus_xw;
MCNUM mccspec_detector_2_exit_volume_focus_xh;
MCNUM mccspec_detector_2_exit_volume_focus_r;
MCNUM mccspec_detector_2_exit_volume_p_interact;
char mccspec_detector_2_exit_volume_mask_string[16384];
char mccspec_detector_2_exit_volume_mask_setting[16384];
MCNUM mccspec_detector_2_exit_volume_number_of_activations;

/* Setting parameters for component 'channel_3_cave1_box1' [238]. */
char mccchannel_3_cave1_box1_material_string[16384];
MCNUM mccchannel_3_cave1_box1_priority;
MCNUM mccchannel_3_cave1_box1_xwidth;
MCNUM mccchannel_3_cave1_box1_yheight;
MCNUM mccchannel_3_cave1_box1_zdepth;
MCNUM mccchannel_3_cave1_box1_xwidth2;
MCNUM mccchannel_3_cave1_box1_yheight2;
MCNUM mccchannel_3_cave1_box1_visualize;
int mccchannel_3_cave1_box1_target_index;
MCNUM mccchannel_3_cave1_box1_target_x;
MCNUM mccchannel_3_cave1_box1_target_y;
MCNUM mccchannel_3_cave1_box1_target_z;
MCNUM mccchannel_3_cave1_box1_focus_aw;
MCNUM mccchannel_3_cave1_box1_focus_ah;
MCNUM mccchannel_3_cave1_box1_focus_xw;
MCNUM mccchannel_3_cave1_box1_focus_xh;
MCNUM mccchannel_3_cave1_box1_focus_r;
MCNUM mccchannel_3_cave1_box1_p_interact;
char mccchannel_3_cave1_box1_mask_string[16384];
char mccchannel_3_cave1_box1_mask_setting[16384];
MCNUM mccchannel_3_cave1_box1_number_of_activations;

/* Setting parameters for component 'channel_3_cave1_box2' [239]. */
char mccchannel_3_cave1_box2_material_string[16384];
MCNUM mccchannel_3_cave1_box2_priority;
MCNUM mccchannel_3_cave1_box2_xwidth;
MCNUM mccchannel_3_cave1_box2_yheight;
MCNUM mccchannel_3_cave1_box2_zdepth;
MCNUM mccchannel_3_cave1_box2_xwidth2;
MCNUM mccchannel_3_cave1_box2_yheight2;
MCNUM mccchannel_3_cave1_box2_visualize;
int mccchannel_3_cave1_box2_target_index;
MCNUM mccchannel_3_cave1_box2_target_x;
MCNUM mccchannel_3_cave1_box2_target_y;
MCNUM mccchannel_3_cave1_box2_target_z;
MCNUM mccchannel_3_cave1_box2_focus_aw;
MCNUM mccchannel_3_cave1_box2_focus_ah;
MCNUM mccchannel_3_cave1_box2_focus_xw;
MCNUM mccchannel_3_cave1_box2_focus_xh;
MCNUM mccchannel_3_cave1_box2_focus_r;
MCNUM mccchannel_3_cave1_box2_p_interact;
char mccchannel_3_cave1_box2_mask_string[16384];
char mccchannel_3_cave1_box2_mask_setting[16384];
MCNUM mccchannel_3_cave1_box2_number_of_activations;

/* Setting parameters for component 'channel_3_cave1_box3' [240]. */
char mccchannel_3_cave1_box3_material_string[16384];
MCNUM mccchannel_3_cave1_box3_priority;
MCNUM mccchannel_3_cave1_box3_xwidth;
MCNUM mccchannel_3_cave1_box3_yheight;
MCNUM mccchannel_3_cave1_box3_zdepth;
MCNUM mccchannel_3_cave1_box3_xwidth2;
MCNUM mccchannel_3_cave1_box3_yheight2;
MCNUM mccchannel_3_cave1_box3_visualize;
int mccchannel_3_cave1_box3_target_index;
MCNUM mccchannel_3_cave1_box3_target_x;
MCNUM mccchannel_3_cave1_box3_target_y;
MCNUM mccchannel_3_cave1_box3_target_z;
MCNUM mccchannel_3_cave1_box3_focus_aw;
MCNUM mccchannel_3_cave1_box3_focus_ah;
MCNUM mccchannel_3_cave1_box3_focus_xw;
MCNUM mccchannel_3_cave1_box3_focus_xh;
MCNUM mccchannel_3_cave1_box3_focus_r;
MCNUM mccchannel_3_cave1_box3_p_interact;
char mccchannel_3_cave1_box3_mask_string[16384];
char mccchannel_3_cave1_box3_mask_setting[16384];
MCNUM mccchannel_3_cave1_box3_number_of_activations;

/* Setting parameters for component 'channel_3_cave1_cyl1' [241]. */
char mccchannel_3_cave1_cyl1_material_string[16384];
MCNUM mccchannel_3_cave1_cyl1_priority;
MCNUM mccchannel_3_cave1_cyl1_radius;
MCNUM mccchannel_3_cave1_cyl1_yheight;
MCNUM mccchannel_3_cave1_cyl1_visualize;
int mccchannel_3_cave1_cyl1_target_index;
MCNUM mccchannel_3_cave1_cyl1_target_x;
MCNUM mccchannel_3_cave1_cyl1_target_y;
MCNUM mccchannel_3_cave1_cyl1_target_z;
MCNUM mccchannel_3_cave1_cyl1_focus_aw;
MCNUM mccchannel_3_cave1_cyl1_focus_ah;
MCNUM mccchannel_3_cave1_cyl1_focus_xw;
MCNUM mccchannel_3_cave1_cyl1_focus_xh;
MCNUM mccchannel_3_cave1_cyl1_focus_r;
MCNUM mccchannel_3_cave1_cyl1_p_interact;
char mccchannel_3_cave1_cyl1_mask_string[16384];
char mccchannel_3_cave1_cyl1_mask_setting[16384];
MCNUM mccchannel_3_cave1_cyl1_number_of_activations;

/* Setting parameters for component 'channel_3_analyzer_1_array_crystal_array_0' [244]. */
char mccchannel_3_analyzer_1_array_crystal_array_0_material_string[16384];
MCNUM mccchannel_3_analyzer_1_array_crystal_array_0_priority;
MCNUM mccchannel_3_analyzer_1_array_crystal_array_0_xwidth;
MCNUM mccchannel_3_analyzer_1_array_crystal_array_0_yheight;
MCNUM mccchannel_3_analyzer_1_array_crystal_array_0_zdepth;
MCNUM mccchannel_3_analyzer_1_array_crystal_array_0_xwidth2;
MCNUM mccchannel_3_analyzer_1_array_crystal_array_0_yheight2;
MCNUM mccchannel_3_analyzer_1_array_crystal_array_0_visualize;
int mccchannel_3_analyzer_1_array_crystal_array_0_target_index;
MCNUM mccchannel_3_analyzer_1_array_crystal_array_0_target_x;
MCNUM mccchannel_3_analyzer_1_array_crystal_array_0_target_y;
MCNUM mccchannel_3_analyzer_1_array_crystal_array_0_target_z;
MCNUM mccchannel_3_analyzer_1_array_crystal_array_0_focus_aw;
MCNUM mccchannel_3_analyzer_1_array_crystal_array_0_focus_ah;
MCNUM mccchannel_3_analyzer_1_array_crystal_array_0_focus_xw;
MCNUM mccchannel_3_analyzer_1_array_crystal_array_0_focus_xh;
MCNUM mccchannel_3_analyzer_1_array_crystal_array_0_focus_r;
MCNUM mccchannel_3_analyzer_1_array_crystal_array_0_p_interact;
char mccchannel_3_analyzer_1_array_crystal_array_0_mask_string[16384];
char mccchannel_3_analyzer_1_array_crystal_array_0_mask_setting[16384];
MCNUM mccchannel_3_analyzer_1_array_crystal_array_0_number_of_activations;

/* Setting parameters for component 'channel_3_analyzer_1_array_crystal_array_1' [245]. */
char mccchannel_3_analyzer_1_array_crystal_array_1_material_string[16384];
MCNUM mccchannel_3_analyzer_1_array_crystal_array_1_priority;
MCNUM mccchannel_3_analyzer_1_array_crystal_array_1_xwidth;
MCNUM mccchannel_3_analyzer_1_array_crystal_array_1_yheight;
MCNUM mccchannel_3_analyzer_1_array_crystal_array_1_zdepth;
MCNUM mccchannel_3_analyzer_1_array_crystal_array_1_xwidth2;
MCNUM mccchannel_3_analyzer_1_array_crystal_array_1_yheight2;
MCNUM mccchannel_3_analyzer_1_array_crystal_array_1_visualize;
int mccchannel_3_analyzer_1_array_crystal_array_1_target_index;
MCNUM mccchannel_3_analyzer_1_array_crystal_array_1_target_x;
MCNUM mccchannel_3_analyzer_1_array_crystal_array_1_target_y;
MCNUM mccchannel_3_analyzer_1_array_crystal_array_1_target_z;
MCNUM mccchannel_3_analyzer_1_array_crystal_array_1_focus_aw;
MCNUM mccchannel_3_analyzer_1_array_crystal_array_1_focus_ah;
MCNUM mccchannel_3_analyzer_1_array_crystal_array_1_focus_xw;
MCNUM mccchannel_3_analyzer_1_array_crystal_array_1_focus_xh;
MCNUM mccchannel_3_analyzer_1_array_crystal_array_1_focus_r;
MCNUM mccchannel_3_analyzer_1_array_crystal_array_1_p_interact;
char mccchannel_3_analyzer_1_array_crystal_array_1_mask_string[16384];
char mccchannel_3_analyzer_1_array_crystal_array_1_mask_setting[16384];
MCNUM mccchannel_3_analyzer_1_array_crystal_array_1_number_of_activations;

/* Setting parameters for component 'channel_3_analyzer_1_array_crystal_array_2' [246]. */
char mccchannel_3_analyzer_1_array_crystal_array_2_material_string[16384];
MCNUM mccchannel_3_analyzer_1_array_crystal_array_2_priority;
MCNUM mccchannel_3_analyzer_1_array_crystal_array_2_xwidth;
MCNUM mccchannel_3_analyzer_1_array_crystal_array_2_yheight;
MCNUM mccchannel_3_analyzer_1_array_crystal_array_2_zdepth;
MCNUM mccchannel_3_analyzer_1_array_crystal_array_2_xwidth2;
MCNUM mccchannel_3_analyzer_1_array_crystal_array_2_yheight2;
MCNUM mccchannel_3_analyzer_1_array_crystal_array_2_visualize;
int mccchannel_3_analyzer_1_array_crystal_array_2_target_index;
MCNUM mccchannel_3_analyzer_1_array_crystal_array_2_target_x;
MCNUM mccchannel_3_analyzer_1_array_crystal_array_2_target_y;
MCNUM mccchannel_3_analyzer_1_array_crystal_array_2_target_z;
MCNUM mccchannel_3_analyzer_1_array_crystal_array_2_focus_aw;
MCNUM mccchannel_3_analyzer_1_array_crystal_array_2_focus_ah;
MCNUM mccchannel_3_analyzer_1_array_crystal_array_2_focus_xw;
MCNUM mccchannel_3_analyzer_1_array_crystal_array_2_focus_xh;
MCNUM mccchannel_3_analyzer_1_array_crystal_array_2_focus_r;
MCNUM mccchannel_3_analyzer_1_array_crystal_array_2_p_interact;
char mccchannel_3_analyzer_1_array_crystal_array_2_mask_string[16384];
char mccchannel_3_analyzer_1_array_crystal_array_2_mask_setting[16384];
MCNUM mccchannel_3_analyzer_1_array_crystal_array_2_number_of_activations;

/* Setting parameters for component 'channel_3_analyzer_1_array_crystal_array_3' [247]. */
char mccchannel_3_analyzer_1_array_crystal_array_3_material_string[16384];
MCNUM mccchannel_3_analyzer_1_array_crystal_array_3_priority;
MCNUM mccchannel_3_analyzer_1_array_crystal_array_3_xwidth;
MCNUM mccchannel_3_analyzer_1_array_crystal_array_3_yheight;
MCNUM mccchannel_3_analyzer_1_array_crystal_array_3_zdepth;
MCNUM mccchannel_3_analyzer_1_array_crystal_array_3_xwidth2;
MCNUM mccchannel_3_analyzer_1_array_crystal_array_3_yheight2;
MCNUM mccchannel_3_analyzer_1_array_crystal_array_3_visualize;
int mccchannel_3_analyzer_1_array_crystal_array_3_target_index;
MCNUM mccchannel_3_analyzer_1_array_crystal_array_3_target_x;
MCNUM mccchannel_3_analyzer_1_array_crystal_array_3_target_y;
MCNUM mccchannel_3_analyzer_1_array_crystal_array_3_target_z;
MCNUM mccchannel_3_analyzer_1_array_crystal_array_3_focus_aw;
MCNUM mccchannel_3_analyzer_1_array_crystal_array_3_focus_ah;
MCNUM mccchannel_3_analyzer_1_array_crystal_array_3_focus_xw;
MCNUM mccchannel_3_analyzer_1_array_crystal_array_3_focus_xh;
MCNUM mccchannel_3_analyzer_1_array_crystal_array_3_focus_r;
MCNUM mccchannel_3_analyzer_1_array_crystal_array_3_p_interact;
char mccchannel_3_analyzer_1_array_crystal_array_3_mask_string[16384];
char mccchannel_3_analyzer_1_array_crystal_array_3_mask_setting[16384];
MCNUM mccchannel_3_analyzer_1_array_crystal_array_3_number_of_activations;

/* Setting parameters for component 'channel_3_analyzer_1_array_crystal_array_4' [248]. */
char mccchannel_3_analyzer_1_array_crystal_array_4_material_string[16384];
MCNUM mccchannel_3_analyzer_1_array_crystal_array_4_priority;
MCNUM mccchannel_3_analyzer_1_array_crystal_array_4_xwidth;
MCNUM mccchannel_3_analyzer_1_array_crystal_array_4_yheight;
MCNUM mccchannel_3_analyzer_1_array_crystal_array_4_zdepth;
MCNUM mccchannel_3_analyzer_1_array_crystal_array_4_xwidth2;
MCNUM mccchannel_3_analyzer_1_array_crystal_array_4_yheight2;
MCNUM mccchannel_3_analyzer_1_array_crystal_array_4_visualize;
int mccchannel_3_analyzer_1_array_crystal_array_4_target_index;
MCNUM mccchannel_3_analyzer_1_array_crystal_array_4_target_x;
MCNUM mccchannel_3_analyzer_1_array_crystal_array_4_target_y;
MCNUM mccchannel_3_analyzer_1_array_crystal_array_4_target_z;
MCNUM mccchannel_3_analyzer_1_array_crystal_array_4_focus_aw;
MCNUM mccchannel_3_analyzer_1_array_crystal_array_4_focus_ah;
MCNUM mccchannel_3_analyzer_1_array_crystal_array_4_focus_xw;
MCNUM mccchannel_3_analyzer_1_array_crystal_array_4_focus_xh;
MCNUM mccchannel_3_analyzer_1_array_crystal_array_4_focus_r;
MCNUM mccchannel_3_analyzer_1_array_crystal_array_4_p_interact;
char mccchannel_3_analyzer_1_array_crystal_array_4_mask_string[16384];
char mccchannel_3_analyzer_1_array_crystal_array_4_mask_setting[16384];
MCNUM mccchannel_3_analyzer_1_array_crystal_array_4_number_of_activations;

/* Setting parameters for component 'channel_3_analyzer_1_array_crystal_array_5' [249]. */
char mccchannel_3_analyzer_1_array_crystal_array_5_material_string[16384];
MCNUM mccchannel_3_analyzer_1_array_crystal_array_5_priority;
MCNUM mccchannel_3_analyzer_1_array_crystal_array_5_xwidth;
MCNUM mccchannel_3_analyzer_1_array_crystal_array_5_yheight;
MCNUM mccchannel_3_analyzer_1_array_crystal_array_5_zdepth;
MCNUM mccchannel_3_analyzer_1_array_crystal_array_5_xwidth2;
MCNUM mccchannel_3_analyzer_1_array_crystal_array_5_yheight2;
MCNUM mccchannel_3_analyzer_1_array_crystal_array_5_visualize;
int mccchannel_3_analyzer_1_array_crystal_array_5_target_index;
MCNUM mccchannel_3_analyzer_1_array_crystal_array_5_target_x;
MCNUM mccchannel_3_analyzer_1_array_crystal_array_5_target_y;
MCNUM mccchannel_3_analyzer_1_array_crystal_array_5_target_z;
MCNUM mccchannel_3_analyzer_1_array_crystal_array_5_focus_aw;
MCNUM mccchannel_3_analyzer_1_array_crystal_array_5_focus_ah;
MCNUM mccchannel_3_analyzer_1_array_crystal_array_5_focus_xw;
MCNUM mccchannel_3_analyzer_1_array_crystal_array_5_focus_xh;
MCNUM mccchannel_3_analyzer_1_array_crystal_array_5_focus_r;
MCNUM mccchannel_3_analyzer_1_array_crystal_array_5_p_interact;
char mccchannel_3_analyzer_1_array_crystal_array_5_mask_string[16384];
char mccchannel_3_analyzer_1_array_crystal_array_5_mask_setting[16384];
MCNUM mccchannel_3_analyzer_1_array_crystal_array_5_number_of_activations;

/* Setting parameters for component 'channel_3_analyzer_1_array_crystal_array_6' [250]. */
char mccchannel_3_analyzer_1_array_crystal_array_6_material_string[16384];
MCNUM mccchannel_3_analyzer_1_array_crystal_array_6_priority;
MCNUM mccchannel_3_analyzer_1_array_crystal_array_6_xwidth;
MCNUM mccchannel_3_analyzer_1_array_crystal_array_6_yheight;
MCNUM mccchannel_3_analyzer_1_array_crystal_array_6_zdepth;
MCNUM mccchannel_3_analyzer_1_array_crystal_array_6_xwidth2;
MCNUM mccchannel_3_analyzer_1_array_crystal_array_6_yheight2;
MCNUM mccchannel_3_analyzer_1_array_crystal_array_6_visualize;
int mccchannel_3_analyzer_1_array_crystal_array_6_target_index;
MCNUM mccchannel_3_analyzer_1_array_crystal_array_6_target_x;
MCNUM mccchannel_3_analyzer_1_array_crystal_array_6_target_y;
MCNUM mccchannel_3_analyzer_1_array_crystal_array_6_target_z;
MCNUM mccchannel_3_analyzer_1_array_crystal_array_6_focus_aw;
MCNUM mccchannel_3_analyzer_1_array_crystal_array_6_focus_ah;
MCNUM mccchannel_3_analyzer_1_array_crystal_array_6_focus_xw;
MCNUM mccchannel_3_analyzer_1_array_crystal_array_6_focus_xh;
MCNUM mccchannel_3_analyzer_1_array_crystal_array_6_focus_r;
MCNUM mccchannel_3_analyzer_1_array_crystal_array_6_p_interact;
char mccchannel_3_analyzer_1_array_crystal_array_6_mask_string[16384];
char mccchannel_3_analyzer_1_array_crystal_array_6_mask_setting[16384];
MCNUM mccchannel_3_analyzer_1_array_crystal_array_6_number_of_activations;

/* Setting parameters for component 'channel_3_analyzer_1_array_crystal_array_7' [251]. */
char mccchannel_3_analyzer_1_array_crystal_array_7_material_string[16384];
MCNUM mccchannel_3_analyzer_1_array_crystal_array_7_priority;
MCNUM mccchannel_3_analyzer_1_array_crystal_array_7_xwidth;
MCNUM mccchannel_3_analyzer_1_array_crystal_array_7_yheight;
MCNUM mccchannel_3_analyzer_1_array_crystal_array_7_zdepth;
MCNUM mccchannel_3_analyzer_1_array_crystal_array_7_xwidth2;
MCNUM mccchannel_3_analyzer_1_array_crystal_array_7_yheight2;
MCNUM mccchannel_3_analyzer_1_array_crystal_array_7_visualize;
int mccchannel_3_analyzer_1_array_crystal_array_7_target_index;
MCNUM mccchannel_3_analyzer_1_array_crystal_array_7_target_x;
MCNUM mccchannel_3_analyzer_1_array_crystal_array_7_target_y;
MCNUM mccchannel_3_analyzer_1_array_crystal_array_7_target_z;
MCNUM mccchannel_3_analyzer_1_array_crystal_array_7_focus_aw;
MCNUM mccchannel_3_analyzer_1_array_crystal_array_7_focus_ah;
MCNUM mccchannel_3_analyzer_1_array_crystal_array_7_focus_xw;
MCNUM mccchannel_3_analyzer_1_array_crystal_array_7_focus_xh;
MCNUM mccchannel_3_analyzer_1_array_crystal_array_7_focus_r;
MCNUM mccchannel_3_analyzer_1_array_crystal_array_7_p_interact;
char mccchannel_3_analyzer_1_array_crystal_array_7_mask_string[16384];
char mccchannel_3_analyzer_1_array_crystal_array_7_mask_setting[16384];
MCNUM mccchannel_3_analyzer_1_array_crystal_array_7_number_of_activations;

/* Setting parameters for component 'channel_3_analyzer_1_array_crystal_array_8' [252]. */
char mccchannel_3_analyzer_1_array_crystal_array_8_material_string[16384];
MCNUM mccchannel_3_analyzer_1_array_crystal_array_8_priority;
MCNUM mccchannel_3_analyzer_1_array_crystal_array_8_xwidth;
MCNUM mccchannel_3_analyzer_1_array_crystal_array_8_yheight;
MCNUM mccchannel_3_analyzer_1_array_crystal_array_8_zdepth;
MCNUM mccchannel_3_analyzer_1_array_crystal_array_8_xwidth2;
MCNUM mccchannel_3_analyzer_1_array_crystal_array_8_yheight2;
MCNUM mccchannel_3_analyzer_1_array_crystal_array_8_visualize;
int mccchannel_3_analyzer_1_array_crystal_array_8_target_index;
MCNUM mccchannel_3_analyzer_1_array_crystal_array_8_target_x;
MCNUM mccchannel_3_analyzer_1_array_crystal_array_8_target_y;
MCNUM mccchannel_3_analyzer_1_array_crystal_array_8_target_z;
MCNUM mccchannel_3_analyzer_1_array_crystal_array_8_focus_aw;
MCNUM mccchannel_3_analyzer_1_array_crystal_array_8_focus_ah;
MCNUM mccchannel_3_analyzer_1_array_crystal_array_8_focus_xw;
MCNUM mccchannel_3_analyzer_1_array_crystal_array_8_focus_xh;
MCNUM mccchannel_3_analyzer_1_array_crystal_array_8_focus_r;
MCNUM mccchannel_3_analyzer_1_array_crystal_array_8_p_interact;
char mccchannel_3_analyzer_1_array_crystal_array_8_mask_string[16384];
char mccchannel_3_analyzer_1_array_crystal_array_8_mask_setting[16384];
MCNUM mccchannel_3_analyzer_1_array_crystal_array_8_number_of_activations;

/* Setting parameters for component 'channel_3_analyzer_2_array_crystal_array_0' [255]. */
char mccchannel_3_analyzer_2_array_crystal_array_0_material_string[16384];
MCNUM mccchannel_3_analyzer_2_array_crystal_array_0_priority;
MCNUM mccchannel_3_analyzer_2_array_crystal_array_0_xwidth;
MCNUM mccchannel_3_analyzer_2_array_crystal_array_0_yheight;
MCNUM mccchannel_3_analyzer_2_array_crystal_array_0_zdepth;
MCNUM mccchannel_3_analyzer_2_array_crystal_array_0_xwidth2;
MCNUM mccchannel_3_analyzer_2_array_crystal_array_0_yheight2;
MCNUM mccchannel_3_analyzer_2_array_crystal_array_0_visualize;
int mccchannel_3_analyzer_2_array_crystal_array_0_target_index;
MCNUM mccchannel_3_analyzer_2_array_crystal_array_0_target_x;
MCNUM mccchannel_3_analyzer_2_array_crystal_array_0_target_y;
MCNUM mccchannel_3_analyzer_2_array_crystal_array_0_target_z;
MCNUM mccchannel_3_analyzer_2_array_crystal_array_0_focus_aw;
MCNUM mccchannel_3_analyzer_2_array_crystal_array_0_focus_ah;
MCNUM mccchannel_3_analyzer_2_array_crystal_array_0_focus_xw;
MCNUM mccchannel_3_analyzer_2_array_crystal_array_0_focus_xh;
MCNUM mccchannel_3_analyzer_2_array_crystal_array_0_focus_r;
MCNUM mccchannel_3_analyzer_2_array_crystal_array_0_p_interact;
char mccchannel_3_analyzer_2_array_crystal_array_0_mask_string[16384];
char mccchannel_3_analyzer_2_array_crystal_array_0_mask_setting[16384];
MCNUM mccchannel_3_analyzer_2_array_crystal_array_0_number_of_activations;

/* Setting parameters for component 'channel_3_analyzer_2_array_crystal_array_1' [256]. */
char mccchannel_3_analyzer_2_array_crystal_array_1_material_string[16384];
MCNUM mccchannel_3_analyzer_2_array_crystal_array_1_priority;
MCNUM mccchannel_3_analyzer_2_array_crystal_array_1_xwidth;
MCNUM mccchannel_3_analyzer_2_array_crystal_array_1_yheight;
MCNUM mccchannel_3_analyzer_2_array_crystal_array_1_zdepth;
MCNUM mccchannel_3_analyzer_2_array_crystal_array_1_xwidth2;
MCNUM mccchannel_3_analyzer_2_array_crystal_array_1_yheight2;
MCNUM mccchannel_3_analyzer_2_array_crystal_array_1_visualize;
int mccchannel_3_analyzer_2_array_crystal_array_1_target_index;
MCNUM mccchannel_3_analyzer_2_array_crystal_array_1_target_x;
MCNUM mccchannel_3_analyzer_2_array_crystal_array_1_target_y;
MCNUM mccchannel_3_analyzer_2_array_crystal_array_1_target_z;
MCNUM mccchannel_3_analyzer_2_array_crystal_array_1_focus_aw;
MCNUM mccchannel_3_analyzer_2_array_crystal_array_1_focus_ah;
MCNUM mccchannel_3_analyzer_2_array_crystal_array_1_focus_xw;
MCNUM mccchannel_3_analyzer_2_array_crystal_array_1_focus_xh;
MCNUM mccchannel_3_analyzer_2_array_crystal_array_1_focus_r;
MCNUM mccchannel_3_analyzer_2_array_crystal_array_1_p_interact;
char mccchannel_3_analyzer_2_array_crystal_array_1_mask_string[16384];
char mccchannel_3_analyzer_2_array_crystal_array_1_mask_setting[16384];
MCNUM mccchannel_3_analyzer_2_array_crystal_array_1_number_of_activations;

/* Setting parameters for component 'channel_3_analyzer_2_array_crystal_array_2' [257]. */
char mccchannel_3_analyzer_2_array_crystal_array_2_material_string[16384];
MCNUM mccchannel_3_analyzer_2_array_crystal_array_2_priority;
MCNUM mccchannel_3_analyzer_2_array_crystal_array_2_xwidth;
MCNUM mccchannel_3_analyzer_2_array_crystal_array_2_yheight;
MCNUM mccchannel_3_analyzer_2_array_crystal_array_2_zdepth;
MCNUM mccchannel_3_analyzer_2_array_crystal_array_2_xwidth2;
MCNUM mccchannel_3_analyzer_2_array_crystal_array_2_yheight2;
MCNUM mccchannel_3_analyzer_2_array_crystal_array_2_visualize;
int mccchannel_3_analyzer_2_array_crystal_array_2_target_index;
MCNUM mccchannel_3_analyzer_2_array_crystal_array_2_target_x;
MCNUM mccchannel_3_analyzer_2_array_crystal_array_2_target_y;
MCNUM mccchannel_3_analyzer_2_array_crystal_array_2_target_z;
MCNUM mccchannel_3_analyzer_2_array_crystal_array_2_focus_aw;
MCNUM mccchannel_3_analyzer_2_array_crystal_array_2_focus_ah;
MCNUM mccchannel_3_analyzer_2_array_crystal_array_2_focus_xw;
MCNUM mccchannel_3_analyzer_2_array_crystal_array_2_focus_xh;
MCNUM mccchannel_3_analyzer_2_array_crystal_array_2_focus_r;
MCNUM mccchannel_3_analyzer_2_array_crystal_array_2_p_interact;
char mccchannel_3_analyzer_2_array_crystal_array_2_mask_string[16384];
char mccchannel_3_analyzer_2_array_crystal_array_2_mask_setting[16384];
MCNUM mccchannel_3_analyzer_2_array_crystal_array_2_number_of_activations;

/* Setting parameters for component 'channel_3_analyzer_2_array_crystal_array_3' [258]. */
char mccchannel_3_analyzer_2_array_crystal_array_3_material_string[16384];
MCNUM mccchannel_3_analyzer_2_array_crystal_array_3_priority;
MCNUM mccchannel_3_analyzer_2_array_crystal_array_3_xwidth;
MCNUM mccchannel_3_analyzer_2_array_crystal_array_3_yheight;
MCNUM mccchannel_3_analyzer_2_array_crystal_array_3_zdepth;
MCNUM mccchannel_3_analyzer_2_array_crystal_array_3_xwidth2;
MCNUM mccchannel_3_analyzer_2_array_crystal_array_3_yheight2;
MCNUM mccchannel_3_analyzer_2_array_crystal_array_3_visualize;
int mccchannel_3_analyzer_2_array_crystal_array_3_target_index;
MCNUM mccchannel_3_analyzer_2_array_crystal_array_3_target_x;
MCNUM mccchannel_3_analyzer_2_array_crystal_array_3_target_y;
MCNUM mccchannel_3_analyzer_2_array_crystal_array_3_target_z;
MCNUM mccchannel_3_analyzer_2_array_crystal_array_3_focus_aw;
MCNUM mccchannel_3_analyzer_2_array_crystal_array_3_focus_ah;
MCNUM mccchannel_3_analyzer_2_array_crystal_array_3_focus_xw;
MCNUM mccchannel_3_analyzer_2_array_crystal_array_3_focus_xh;
MCNUM mccchannel_3_analyzer_2_array_crystal_array_3_focus_r;
MCNUM mccchannel_3_analyzer_2_array_crystal_array_3_p_interact;
char mccchannel_3_analyzer_2_array_crystal_array_3_mask_string[16384];
char mccchannel_3_analyzer_2_array_crystal_array_3_mask_setting[16384];
MCNUM mccchannel_3_analyzer_2_array_crystal_array_3_number_of_activations;

/* Setting parameters for component 'channel_3_analyzer_2_array_crystal_array_4' [259]. */
char mccchannel_3_analyzer_2_array_crystal_array_4_material_string[16384];
MCNUM mccchannel_3_analyzer_2_array_crystal_array_4_priority;
MCNUM mccchannel_3_analyzer_2_array_crystal_array_4_xwidth;
MCNUM mccchannel_3_analyzer_2_array_crystal_array_4_yheight;
MCNUM mccchannel_3_analyzer_2_array_crystal_array_4_zdepth;
MCNUM mccchannel_3_analyzer_2_array_crystal_array_4_xwidth2;
MCNUM mccchannel_3_analyzer_2_array_crystal_array_4_yheight2;
MCNUM mccchannel_3_analyzer_2_array_crystal_array_4_visualize;
int mccchannel_3_analyzer_2_array_crystal_array_4_target_index;
MCNUM mccchannel_3_analyzer_2_array_crystal_array_4_target_x;
MCNUM mccchannel_3_analyzer_2_array_crystal_array_4_target_y;
MCNUM mccchannel_3_analyzer_2_array_crystal_array_4_target_z;
MCNUM mccchannel_3_analyzer_2_array_crystal_array_4_focus_aw;
MCNUM mccchannel_3_analyzer_2_array_crystal_array_4_focus_ah;
MCNUM mccchannel_3_analyzer_2_array_crystal_array_4_focus_xw;
MCNUM mccchannel_3_analyzer_2_array_crystal_array_4_focus_xh;
MCNUM mccchannel_3_analyzer_2_array_crystal_array_4_focus_r;
MCNUM mccchannel_3_analyzer_2_array_crystal_array_4_p_interact;
char mccchannel_3_analyzer_2_array_crystal_array_4_mask_string[16384];
char mccchannel_3_analyzer_2_array_crystal_array_4_mask_setting[16384];
MCNUM mccchannel_3_analyzer_2_array_crystal_array_4_number_of_activations;

/* Setting parameters for component 'channel_3_analyzer_2_array_crystal_array_5' [260]. */
char mccchannel_3_analyzer_2_array_crystal_array_5_material_string[16384];
MCNUM mccchannel_3_analyzer_2_array_crystal_array_5_priority;
MCNUM mccchannel_3_analyzer_2_array_crystal_array_5_xwidth;
MCNUM mccchannel_3_analyzer_2_array_crystal_array_5_yheight;
MCNUM mccchannel_3_analyzer_2_array_crystal_array_5_zdepth;
MCNUM mccchannel_3_analyzer_2_array_crystal_array_5_xwidth2;
MCNUM mccchannel_3_analyzer_2_array_crystal_array_5_yheight2;
MCNUM mccchannel_3_analyzer_2_array_crystal_array_5_visualize;
int mccchannel_3_analyzer_2_array_crystal_array_5_target_index;
MCNUM mccchannel_3_analyzer_2_array_crystal_array_5_target_x;
MCNUM mccchannel_3_analyzer_2_array_crystal_array_5_target_y;
MCNUM mccchannel_3_analyzer_2_array_crystal_array_5_target_z;
MCNUM mccchannel_3_analyzer_2_array_crystal_array_5_focus_aw;
MCNUM mccchannel_3_analyzer_2_array_crystal_array_5_focus_ah;
MCNUM mccchannel_3_analyzer_2_array_crystal_array_5_focus_xw;
MCNUM mccchannel_3_analyzer_2_array_crystal_array_5_focus_xh;
MCNUM mccchannel_3_analyzer_2_array_crystal_array_5_focus_r;
MCNUM mccchannel_3_analyzer_2_array_crystal_array_5_p_interact;
char mccchannel_3_analyzer_2_array_crystal_array_5_mask_string[16384];
char mccchannel_3_analyzer_2_array_crystal_array_5_mask_setting[16384];
MCNUM mccchannel_3_analyzer_2_array_crystal_array_5_number_of_activations;

/* Setting parameters for component 'channel_3_analyzer_2_array_crystal_array_6' [261]. */
char mccchannel_3_analyzer_2_array_crystal_array_6_material_string[16384];
MCNUM mccchannel_3_analyzer_2_array_crystal_array_6_priority;
MCNUM mccchannel_3_analyzer_2_array_crystal_array_6_xwidth;
MCNUM mccchannel_3_analyzer_2_array_crystal_array_6_yheight;
MCNUM mccchannel_3_analyzer_2_array_crystal_array_6_zdepth;
MCNUM mccchannel_3_analyzer_2_array_crystal_array_6_xwidth2;
MCNUM mccchannel_3_analyzer_2_array_crystal_array_6_yheight2;
MCNUM mccchannel_3_analyzer_2_array_crystal_array_6_visualize;
int mccchannel_3_analyzer_2_array_crystal_array_6_target_index;
MCNUM mccchannel_3_analyzer_2_array_crystal_array_6_target_x;
MCNUM mccchannel_3_analyzer_2_array_crystal_array_6_target_y;
MCNUM mccchannel_3_analyzer_2_array_crystal_array_6_target_z;
MCNUM mccchannel_3_analyzer_2_array_crystal_array_6_focus_aw;
MCNUM mccchannel_3_analyzer_2_array_crystal_array_6_focus_ah;
MCNUM mccchannel_3_analyzer_2_array_crystal_array_6_focus_xw;
MCNUM mccchannel_3_analyzer_2_array_crystal_array_6_focus_xh;
MCNUM mccchannel_3_analyzer_2_array_crystal_array_6_focus_r;
MCNUM mccchannel_3_analyzer_2_array_crystal_array_6_p_interact;
char mccchannel_3_analyzer_2_array_crystal_array_6_mask_string[16384];
char mccchannel_3_analyzer_2_array_crystal_array_6_mask_setting[16384];
MCNUM mccchannel_3_analyzer_2_array_crystal_array_6_number_of_activations;

/* Setting parameters for component 'channel_3_analyzer_2_array_crystal_array_7' [262]. */
char mccchannel_3_analyzer_2_array_crystal_array_7_material_string[16384];
MCNUM mccchannel_3_analyzer_2_array_crystal_array_7_priority;
MCNUM mccchannel_3_analyzer_2_array_crystal_array_7_xwidth;
MCNUM mccchannel_3_analyzer_2_array_crystal_array_7_yheight;
MCNUM mccchannel_3_analyzer_2_array_crystal_array_7_zdepth;
MCNUM mccchannel_3_analyzer_2_array_crystal_array_7_xwidth2;
MCNUM mccchannel_3_analyzer_2_array_crystal_array_7_yheight2;
MCNUM mccchannel_3_analyzer_2_array_crystal_array_7_visualize;
int mccchannel_3_analyzer_2_array_crystal_array_7_target_index;
MCNUM mccchannel_3_analyzer_2_array_crystal_array_7_target_x;
MCNUM mccchannel_3_analyzer_2_array_crystal_array_7_target_y;
MCNUM mccchannel_3_analyzer_2_array_crystal_array_7_target_z;
MCNUM mccchannel_3_analyzer_2_array_crystal_array_7_focus_aw;
MCNUM mccchannel_3_analyzer_2_array_crystal_array_7_focus_ah;
MCNUM mccchannel_3_analyzer_2_array_crystal_array_7_focus_xw;
MCNUM mccchannel_3_analyzer_2_array_crystal_array_7_focus_xh;
MCNUM mccchannel_3_analyzer_2_array_crystal_array_7_focus_r;
MCNUM mccchannel_3_analyzer_2_array_crystal_array_7_p_interact;
char mccchannel_3_analyzer_2_array_crystal_array_7_mask_string[16384];
char mccchannel_3_analyzer_2_array_crystal_array_7_mask_setting[16384];
MCNUM mccchannel_3_analyzer_2_array_crystal_array_7_number_of_activations;

/* Setting parameters for component 'channel_3_analyzer_2_array_crystal_array_8' [263]. */
char mccchannel_3_analyzer_2_array_crystal_array_8_material_string[16384];
MCNUM mccchannel_3_analyzer_2_array_crystal_array_8_priority;
MCNUM mccchannel_3_analyzer_2_array_crystal_array_8_xwidth;
MCNUM mccchannel_3_analyzer_2_array_crystal_array_8_yheight;
MCNUM mccchannel_3_analyzer_2_array_crystal_array_8_zdepth;
MCNUM mccchannel_3_analyzer_2_array_crystal_array_8_xwidth2;
MCNUM mccchannel_3_analyzer_2_array_crystal_array_8_yheight2;
MCNUM mccchannel_3_analyzer_2_array_crystal_array_8_visualize;
int mccchannel_3_analyzer_2_array_crystal_array_8_target_index;
MCNUM mccchannel_3_analyzer_2_array_crystal_array_8_target_x;
MCNUM mccchannel_3_analyzer_2_array_crystal_array_8_target_y;
MCNUM mccchannel_3_analyzer_2_array_crystal_array_8_target_z;
MCNUM mccchannel_3_analyzer_2_array_crystal_array_8_focus_aw;
MCNUM mccchannel_3_analyzer_2_array_crystal_array_8_focus_ah;
MCNUM mccchannel_3_analyzer_2_array_crystal_array_8_focus_xw;
MCNUM mccchannel_3_analyzer_2_array_crystal_array_8_focus_xh;
MCNUM mccchannel_3_analyzer_2_array_crystal_array_8_focus_r;
MCNUM mccchannel_3_analyzer_2_array_crystal_array_8_p_interact;
char mccchannel_3_analyzer_2_array_crystal_array_8_mask_string[16384];
char mccchannel_3_analyzer_2_array_crystal_array_8_mask_setting[16384];
MCNUM mccchannel_3_analyzer_2_array_crystal_array_8_number_of_activations;

/* Setting parameters for component 'channel_3_cave2_cyl1' [264]. */
char mccchannel_3_cave2_cyl1_material_string[16384];
MCNUM mccchannel_3_cave2_cyl1_priority;
MCNUM mccchannel_3_cave2_cyl1_radius;
MCNUM mccchannel_3_cave2_cyl1_yheight;
MCNUM mccchannel_3_cave2_cyl1_visualize;
int mccchannel_3_cave2_cyl1_target_index;
MCNUM mccchannel_3_cave2_cyl1_target_x;
MCNUM mccchannel_3_cave2_cyl1_target_y;
MCNUM mccchannel_3_cave2_cyl1_target_z;
MCNUM mccchannel_3_cave2_cyl1_focus_aw;
MCNUM mccchannel_3_cave2_cyl1_focus_ah;
MCNUM mccchannel_3_cave2_cyl1_focus_xw;
MCNUM mccchannel_3_cave2_cyl1_focus_xh;
MCNUM mccchannel_3_cave2_cyl1_focus_r;
MCNUM mccchannel_3_cave2_cyl1_p_interact;
char mccchannel_3_cave2_cyl1_mask_string[16384];
char mccchannel_3_cave2_cyl1_mask_setting[16384];
MCNUM mccchannel_3_cave2_cyl1_number_of_activations;

/* Setting parameters for component 'channel_3_cave2_box1' [265]. */
char mccchannel_3_cave2_box1_material_string[16384];
MCNUM mccchannel_3_cave2_box1_priority;
MCNUM mccchannel_3_cave2_box1_xwidth;
MCNUM mccchannel_3_cave2_box1_yheight;
MCNUM mccchannel_3_cave2_box1_zdepth;
MCNUM mccchannel_3_cave2_box1_xwidth2;
MCNUM mccchannel_3_cave2_box1_yheight2;
MCNUM mccchannel_3_cave2_box1_visualize;
int mccchannel_3_cave2_box1_target_index;
MCNUM mccchannel_3_cave2_box1_target_x;
MCNUM mccchannel_3_cave2_box1_target_y;
MCNUM mccchannel_3_cave2_box1_target_z;
MCNUM mccchannel_3_cave2_box1_focus_aw;
MCNUM mccchannel_3_cave2_box1_focus_ah;
MCNUM mccchannel_3_cave2_box1_focus_xw;
MCNUM mccchannel_3_cave2_box1_focus_xh;
MCNUM mccchannel_3_cave2_box1_focus_r;
MCNUM mccchannel_3_cave2_box1_p_interact;
char mccchannel_3_cave2_box1_mask_string[16384];
char mccchannel_3_cave2_box1_mask_setting[16384];
MCNUM mccchannel_3_cave2_box1_number_of_activations;

/* Setting parameters for component 'channel_3_cave2_box2' [266]. */
char mccchannel_3_cave2_box2_material_string[16384];
MCNUM mccchannel_3_cave2_box2_priority;
MCNUM mccchannel_3_cave2_box2_xwidth;
MCNUM mccchannel_3_cave2_box2_yheight;
MCNUM mccchannel_3_cave2_box2_zdepth;
MCNUM mccchannel_3_cave2_box2_xwidth2;
MCNUM mccchannel_3_cave2_box2_yheight2;
MCNUM mccchannel_3_cave2_box2_visualize;
int mccchannel_3_cave2_box2_target_index;
MCNUM mccchannel_3_cave2_box2_target_x;
MCNUM mccchannel_3_cave2_box2_target_y;
MCNUM mccchannel_3_cave2_box2_target_z;
MCNUM mccchannel_3_cave2_box2_focus_aw;
MCNUM mccchannel_3_cave2_box2_focus_ah;
MCNUM mccchannel_3_cave2_box2_focus_xw;
MCNUM mccchannel_3_cave2_box2_focus_xh;
MCNUM mccchannel_3_cave2_box2_focus_r;
MCNUM mccchannel_3_cave2_box2_p_interact;
char mccchannel_3_cave2_box2_mask_string[16384];
char mccchannel_3_cave2_box2_mask_setting[16384];
MCNUM mccchannel_3_cave2_box2_number_of_activations;

/* Setting parameters for component 'channel_3_cave2_box3' [267]. */
char mccchannel_3_cave2_box3_material_string[16384];
MCNUM mccchannel_3_cave2_box3_priority;
MCNUM mccchannel_3_cave2_box3_xwidth;
MCNUM mccchannel_3_cave2_box3_yheight;
MCNUM mccchannel_3_cave2_box3_zdepth;
MCNUM mccchannel_3_cave2_box3_xwidth2;
MCNUM mccchannel_3_cave2_box3_yheight2;
MCNUM mccchannel_3_cave2_box3_visualize;
int mccchannel_3_cave2_box3_target_index;
MCNUM mccchannel_3_cave2_box3_target_x;
MCNUM mccchannel_3_cave2_box3_target_y;
MCNUM mccchannel_3_cave2_box3_target_z;
MCNUM mccchannel_3_cave2_box3_focus_aw;
MCNUM mccchannel_3_cave2_box3_focus_ah;
MCNUM mccchannel_3_cave2_box3_focus_xw;
MCNUM mccchannel_3_cave2_box3_focus_xh;
MCNUM mccchannel_3_cave2_box3_focus_r;
MCNUM mccchannel_3_cave2_box3_p_interact;
char mccchannel_3_cave2_box3_mask_string[16384];
char mccchannel_3_cave2_box3_mask_setting[16384];
MCNUM mccchannel_3_cave2_box3_number_of_activations;

/* Setting parameters for component 'inter_analyzer_colimator_3_blade_0' [269]. */
char mccinter_analyzer_colimator_3_blade_0_material_string[16384];
MCNUM mccinter_analyzer_colimator_3_blade_0_priority;
MCNUM mccinter_analyzer_colimator_3_blade_0_xwidth;
MCNUM mccinter_analyzer_colimator_3_blade_0_yheight;
MCNUM mccinter_analyzer_colimator_3_blade_0_zdepth;
MCNUM mccinter_analyzer_colimator_3_blade_0_xwidth2;
MCNUM mccinter_analyzer_colimator_3_blade_0_yheight2;
MCNUM mccinter_analyzer_colimator_3_blade_0_visualize;
int mccinter_analyzer_colimator_3_blade_0_target_index;
MCNUM mccinter_analyzer_colimator_3_blade_0_target_x;
MCNUM mccinter_analyzer_colimator_3_blade_0_target_y;
MCNUM mccinter_analyzer_colimator_3_blade_0_target_z;
MCNUM mccinter_analyzer_colimator_3_blade_0_focus_aw;
MCNUM mccinter_analyzer_colimator_3_blade_0_focus_ah;
MCNUM mccinter_analyzer_colimator_3_blade_0_focus_xw;
MCNUM mccinter_analyzer_colimator_3_blade_0_focus_xh;
MCNUM mccinter_analyzer_colimator_3_blade_0_focus_r;
MCNUM mccinter_analyzer_colimator_3_blade_0_p_interact;
char mccinter_analyzer_colimator_3_blade_0_mask_string[16384];
char mccinter_analyzer_colimator_3_blade_0_mask_setting[16384];
MCNUM mccinter_analyzer_colimator_3_blade_0_number_of_activations;

/* Setting parameters for component 'inter_analyzer_colimator_3_blade_1' [270]. */
char mccinter_analyzer_colimator_3_blade_1_material_string[16384];
MCNUM mccinter_analyzer_colimator_3_blade_1_priority;
MCNUM mccinter_analyzer_colimator_3_blade_1_xwidth;
MCNUM mccinter_analyzer_colimator_3_blade_1_yheight;
MCNUM mccinter_analyzer_colimator_3_blade_1_zdepth;
MCNUM mccinter_analyzer_colimator_3_blade_1_xwidth2;
MCNUM mccinter_analyzer_colimator_3_blade_1_yheight2;
MCNUM mccinter_analyzer_colimator_3_blade_1_visualize;
int mccinter_analyzer_colimator_3_blade_1_target_index;
MCNUM mccinter_analyzer_colimator_3_blade_1_target_x;
MCNUM mccinter_analyzer_colimator_3_blade_1_target_y;
MCNUM mccinter_analyzer_colimator_3_blade_1_target_z;
MCNUM mccinter_analyzer_colimator_3_blade_1_focus_aw;
MCNUM mccinter_analyzer_colimator_3_blade_1_focus_ah;
MCNUM mccinter_analyzer_colimator_3_blade_1_focus_xw;
MCNUM mccinter_analyzer_colimator_3_blade_1_focus_xh;
MCNUM mccinter_analyzer_colimator_3_blade_1_focus_r;
MCNUM mccinter_analyzer_colimator_3_blade_1_p_interact;
char mccinter_analyzer_colimator_3_blade_1_mask_string[16384];
char mccinter_analyzer_colimator_3_blade_1_mask_setting[16384];
MCNUM mccinter_analyzer_colimator_3_blade_1_number_of_activations;

/* Setting parameters for component 'inter_analyzer_colimator_3_blade_2' [271]. */
char mccinter_analyzer_colimator_3_blade_2_material_string[16384];
MCNUM mccinter_analyzer_colimator_3_blade_2_priority;
MCNUM mccinter_analyzer_colimator_3_blade_2_xwidth;
MCNUM mccinter_analyzer_colimator_3_blade_2_yheight;
MCNUM mccinter_analyzer_colimator_3_blade_2_zdepth;
MCNUM mccinter_analyzer_colimator_3_blade_2_xwidth2;
MCNUM mccinter_analyzer_colimator_3_blade_2_yheight2;
MCNUM mccinter_analyzer_colimator_3_blade_2_visualize;
int mccinter_analyzer_colimator_3_blade_2_target_index;
MCNUM mccinter_analyzer_colimator_3_blade_2_target_x;
MCNUM mccinter_analyzer_colimator_3_blade_2_target_y;
MCNUM mccinter_analyzer_colimator_3_blade_2_target_z;
MCNUM mccinter_analyzer_colimator_3_blade_2_focus_aw;
MCNUM mccinter_analyzer_colimator_3_blade_2_focus_ah;
MCNUM mccinter_analyzer_colimator_3_blade_2_focus_xw;
MCNUM mccinter_analyzer_colimator_3_blade_2_focus_xh;
MCNUM mccinter_analyzer_colimator_3_blade_2_focus_r;
MCNUM mccinter_analyzer_colimator_3_blade_2_p_interact;
char mccinter_analyzer_colimator_3_blade_2_mask_string[16384];
char mccinter_analyzer_colimator_3_blade_2_mask_setting[16384];
MCNUM mccinter_analyzer_colimator_3_blade_2_number_of_activations;

/* Setting parameters for component 'inter_analyzer_colimator_3_blade_3' [272]. */
char mccinter_analyzer_colimator_3_blade_3_material_string[16384];
MCNUM mccinter_analyzer_colimator_3_blade_3_priority;
MCNUM mccinter_analyzer_colimator_3_blade_3_xwidth;
MCNUM mccinter_analyzer_colimator_3_blade_3_yheight;
MCNUM mccinter_analyzer_colimator_3_blade_3_zdepth;
MCNUM mccinter_analyzer_colimator_3_blade_3_xwidth2;
MCNUM mccinter_analyzer_colimator_3_blade_3_yheight2;
MCNUM mccinter_analyzer_colimator_3_blade_3_visualize;
int mccinter_analyzer_colimator_3_blade_3_target_index;
MCNUM mccinter_analyzer_colimator_3_blade_3_target_x;
MCNUM mccinter_analyzer_colimator_3_blade_3_target_y;
MCNUM mccinter_analyzer_colimator_3_blade_3_target_z;
MCNUM mccinter_analyzer_colimator_3_blade_3_focus_aw;
MCNUM mccinter_analyzer_colimator_3_blade_3_focus_ah;
MCNUM mccinter_analyzer_colimator_3_blade_3_focus_xw;
MCNUM mccinter_analyzer_colimator_3_blade_3_focus_xh;
MCNUM mccinter_analyzer_colimator_3_blade_3_focus_r;
MCNUM mccinter_analyzer_colimator_3_blade_3_p_interact;
char mccinter_analyzer_colimator_3_blade_3_mask_string[16384];
char mccinter_analyzer_colimator_3_blade_3_mask_setting[16384];
MCNUM mccinter_analyzer_colimator_3_blade_3_number_of_activations;

/* Setting parameters for component 'inter_analyzer_colimator_3_blade_4' [273]. */
char mccinter_analyzer_colimator_3_blade_4_material_string[16384];
MCNUM mccinter_analyzer_colimator_3_blade_4_priority;
MCNUM mccinter_analyzer_colimator_3_blade_4_xwidth;
MCNUM mccinter_analyzer_colimator_3_blade_4_yheight;
MCNUM mccinter_analyzer_colimator_3_blade_4_zdepth;
MCNUM mccinter_analyzer_colimator_3_blade_4_xwidth2;
MCNUM mccinter_analyzer_colimator_3_blade_4_yheight2;
MCNUM mccinter_analyzer_colimator_3_blade_4_visualize;
int mccinter_analyzer_colimator_3_blade_4_target_index;
MCNUM mccinter_analyzer_colimator_3_blade_4_target_x;
MCNUM mccinter_analyzer_colimator_3_blade_4_target_y;
MCNUM mccinter_analyzer_colimator_3_blade_4_target_z;
MCNUM mccinter_analyzer_colimator_3_blade_4_focus_aw;
MCNUM mccinter_analyzer_colimator_3_blade_4_focus_ah;
MCNUM mccinter_analyzer_colimator_3_blade_4_focus_xw;
MCNUM mccinter_analyzer_colimator_3_blade_4_focus_xh;
MCNUM mccinter_analyzer_colimator_3_blade_4_focus_r;
MCNUM mccinter_analyzer_colimator_3_blade_4_p_interact;
char mccinter_analyzer_colimator_3_blade_4_mask_string[16384];
char mccinter_analyzer_colimator_3_blade_4_mask_setting[16384];
MCNUM mccinter_analyzer_colimator_3_blade_4_number_of_activations;

/* Setting parameters for component 'diffraction_detector_3_exit_volume' [274]. */
char mccdiffraction_detector_3_exit_volume_material_string[16384];
MCNUM mccdiffraction_detector_3_exit_volume_priority;
MCNUM mccdiffraction_detector_3_exit_volume_xwidth;
MCNUM mccdiffraction_detector_3_exit_volume_yheight;
MCNUM mccdiffraction_detector_3_exit_volume_zdepth;
MCNUM mccdiffraction_detector_3_exit_volume_xwidth2;
MCNUM mccdiffraction_detector_3_exit_volume_yheight2;
MCNUM mccdiffraction_detector_3_exit_volume_visualize;
int mccdiffraction_detector_3_exit_volume_target_index;
MCNUM mccdiffraction_detector_3_exit_volume_target_x;
MCNUM mccdiffraction_detector_3_exit_volume_target_y;
MCNUM mccdiffraction_detector_3_exit_volume_target_z;
MCNUM mccdiffraction_detector_3_exit_volume_focus_aw;
MCNUM mccdiffraction_detector_3_exit_volume_focus_ah;
MCNUM mccdiffraction_detector_3_exit_volume_focus_xw;
MCNUM mccdiffraction_detector_3_exit_volume_focus_xh;
MCNUM mccdiffraction_detector_3_exit_volume_focus_r;
MCNUM mccdiffraction_detector_3_exit_volume_p_interact;
char mccdiffraction_detector_3_exit_volume_mask_string[16384];
char mccdiffraction_detector_3_exit_volume_mask_setting[16384];
MCNUM mccdiffraction_detector_3_exit_volume_number_of_activations;

/* Setting parameters for component 'spec_detector_3_exit_volume' [275]. */
char mccspec_detector_3_exit_volume_material_string[16384];
MCNUM mccspec_detector_3_exit_volume_priority;
MCNUM mccspec_detector_3_exit_volume_xwidth;
MCNUM mccspec_detector_3_exit_volume_yheight;
MCNUM mccspec_detector_3_exit_volume_zdepth;
MCNUM mccspec_detector_3_exit_volume_xwidth2;
MCNUM mccspec_detector_3_exit_volume_yheight2;
MCNUM mccspec_detector_3_exit_volume_visualize;
int mccspec_detector_3_exit_volume_target_index;
MCNUM mccspec_detector_3_exit_volume_target_x;
MCNUM mccspec_detector_3_exit_volume_target_y;
MCNUM mccspec_detector_3_exit_volume_target_z;
MCNUM mccspec_detector_3_exit_volume_focus_aw;
MCNUM mccspec_detector_3_exit_volume_focus_ah;
MCNUM mccspec_detector_3_exit_volume_focus_xw;
MCNUM mccspec_detector_3_exit_volume_focus_xh;
MCNUM mccspec_detector_3_exit_volume_focus_r;
MCNUM mccspec_detector_3_exit_volume_p_interact;
char mccspec_detector_3_exit_volume_mask_string[16384];
char mccspec_detector_3_exit_volume_mask_setting[16384];
MCNUM mccspec_detector_3_exit_volume_number_of_activations;

/* Setting parameters for component 'channel_4_cave1_box1' [276]. */
char mccchannel_4_cave1_box1_material_string[16384];
MCNUM mccchannel_4_cave1_box1_priority;
MCNUM mccchannel_4_cave1_box1_xwidth;
MCNUM mccchannel_4_cave1_box1_yheight;
MCNUM mccchannel_4_cave1_box1_zdepth;
MCNUM mccchannel_4_cave1_box1_xwidth2;
MCNUM mccchannel_4_cave1_box1_yheight2;
MCNUM mccchannel_4_cave1_box1_visualize;
int mccchannel_4_cave1_box1_target_index;
MCNUM mccchannel_4_cave1_box1_target_x;
MCNUM mccchannel_4_cave1_box1_target_y;
MCNUM mccchannel_4_cave1_box1_target_z;
MCNUM mccchannel_4_cave1_box1_focus_aw;
MCNUM mccchannel_4_cave1_box1_focus_ah;
MCNUM mccchannel_4_cave1_box1_focus_xw;
MCNUM mccchannel_4_cave1_box1_focus_xh;
MCNUM mccchannel_4_cave1_box1_focus_r;
MCNUM mccchannel_4_cave1_box1_p_interact;
char mccchannel_4_cave1_box1_mask_string[16384];
char mccchannel_4_cave1_box1_mask_setting[16384];
MCNUM mccchannel_4_cave1_box1_number_of_activations;

/* Setting parameters for component 'channel_4_cave1_box2' [277]. */
char mccchannel_4_cave1_box2_material_string[16384];
MCNUM mccchannel_4_cave1_box2_priority;
MCNUM mccchannel_4_cave1_box2_xwidth;
MCNUM mccchannel_4_cave1_box2_yheight;
MCNUM mccchannel_4_cave1_box2_zdepth;
MCNUM mccchannel_4_cave1_box2_xwidth2;
MCNUM mccchannel_4_cave1_box2_yheight2;
MCNUM mccchannel_4_cave1_box2_visualize;
int mccchannel_4_cave1_box2_target_index;
MCNUM mccchannel_4_cave1_box2_target_x;
MCNUM mccchannel_4_cave1_box2_target_y;
MCNUM mccchannel_4_cave1_box2_target_z;
MCNUM mccchannel_4_cave1_box2_focus_aw;
MCNUM mccchannel_4_cave1_box2_focus_ah;
MCNUM mccchannel_4_cave1_box2_focus_xw;
MCNUM mccchannel_4_cave1_box2_focus_xh;
MCNUM mccchannel_4_cave1_box2_focus_r;
MCNUM mccchannel_4_cave1_box2_p_interact;
char mccchannel_4_cave1_box2_mask_string[16384];
char mccchannel_4_cave1_box2_mask_setting[16384];
MCNUM mccchannel_4_cave1_box2_number_of_activations;

/* Setting parameters for component 'channel_4_cave1_box3' [278]. */
char mccchannel_4_cave1_box3_material_string[16384];
MCNUM mccchannel_4_cave1_box3_priority;
MCNUM mccchannel_4_cave1_box3_xwidth;
MCNUM mccchannel_4_cave1_box3_yheight;
MCNUM mccchannel_4_cave1_box3_zdepth;
MCNUM mccchannel_4_cave1_box3_xwidth2;
MCNUM mccchannel_4_cave1_box3_yheight2;
MCNUM mccchannel_4_cave1_box3_visualize;
int mccchannel_4_cave1_box3_target_index;
MCNUM mccchannel_4_cave1_box3_target_x;
MCNUM mccchannel_4_cave1_box3_target_y;
MCNUM mccchannel_4_cave1_box3_target_z;
MCNUM mccchannel_4_cave1_box3_focus_aw;
MCNUM mccchannel_4_cave1_box3_focus_ah;
MCNUM mccchannel_4_cave1_box3_focus_xw;
MCNUM mccchannel_4_cave1_box3_focus_xh;
MCNUM mccchannel_4_cave1_box3_focus_r;
MCNUM mccchannel_4_cave1_box3_p_interact;
char mccchannel_4_cave1_box3_mask_string[16384];
char mccchannel_4_cave1_box3_mask_setting[16384];
MCNUM mccchannel_4_cave1_box3_number_of_activations;

/* Setting parameters for component 'channel_4_cave1_cyl1' [279]. */
char mccchannel_4_cave1_cyl1_material_string[16384];
MCNUM mccchannel_4_cave1_cyl1_priority;
MCNUM mccchannel_4_cave1_cyl1_radius;
MCNUM mccchannel_4_cave1_cyl1_yheight;
MCNUM mccchannel_4_cave1_cyl1_visualize;
int mccchannel_4_cave1_cyl1_target_index;
MCNUM mccchannel_4_cave1_cyl1_target_x;
MCNUM mccchannel_4_cave1_cyl1_target_y;
MCNUM mccchannel_4_cave1_cyl1_target_z;
MCNUM mccchannel_4_cave1_cyl1_focus_aw;
MCNUM mccchannel_4_cave1_cyl1_focus_ah;
MCNUM mccchannel_4_cave1_cyl1_focus_xw;
MCNUM mccchannel_4_cave1_cyl1_focus_xh;
MCNUM mccchannel_4_cave1_cyl1_focus_r;
MCNUM mccchannel_4_cave1_cyl1_p_interact;
char mccchannel_4_cave1_cyl1_mask_string[16384];
char mccchannel_4_cave1_cyl1_mask_setting[16384];
MCNUM mccchannel_4_cave1_cyl1_number_of_activations;

/* Setting parameters for component 'channel_4_analyzer_1_array_crystal_array_0' [282]. */
char mccchannel_4_analyzer_1_array_crystal_array_0_material_string[16384];
MCNUM mccchannel_4_analyzer_1_array_crystal_array_0_priority;
MCNUM mccchannel_4_analyzer_1_array_crystal_array_0_xwidth;
MCNUM mccchannel_4_analyzer_1_array_crystal_array_0_yheight;
MCNUM mccchannel_4_analyzer_1_array_crystal_array_0_zdepth;
MCNUM mccchannel_4_analyzer_1_array_crystal_array_0_xwidth2;
MCNUM mccchannel_4_analyzer_1_array_crystal_array_0_yheight2;
MCNUM mccchannel_4_analyzer_1_array_crystal_array_0_visualize;
int mccchannel_4_analyzer_1_array_crystal_array_0_target_index;
MCNUM mccchannel_4_analyzer_1_array_crystal_array_0_target_x;
MCNUM mccchannel_4_analyzer_1_array_crystal_array_0_target_y;
MCNUM mccchannel_4_analyzer_1_array_crystal_array_0_target_z;
MCNUM mccchannel_4_analyzer_1_array_crystal_array_0_focus_aw;
MCNUM mccchannel_4_analyzer_1_array_crystal_array_0_focus_ah;
MCNUM mccchannel_4_analyzer_1_array_crystal_array_0_focus_xw;
MCNUM mccchannel_4_analyzer_1_array_crystal_array_0_focus_xh;
MCNUM mccchannel_4_analyzer_1_array_crystal_array_0_focus_r;
MCNUM mccchannel_4_analyzer_1_array_crystal_array_0_p_interact;
char mccchannel_4_analyzer_1_array_crystal_array_0_mask_string[16384];
char mccchannel_4_analyzer_1_array_crystal_array_0_mask_setting[16384];
MCNUM mccchannel_4_analyzer_1_array_crystal_array_0_number_of_activations;

/* Setting parameters for component 'channel_4_analyzer_1_array_crystal_array_1' [283]. */
char mccchannel_4_analyzer_1_array_crystal_array_1_material_string[16384];
MCNUM mccchannel_4_analyzer_1_array_crystal_array_1_priority;
MCNUM mccchannel_4_analyzer_1_array_crystal_array_1_xwidth;
MCNUM mccchannel_4_analyzer_1_array_crystal_array_1_yheight;
MCNUM mccchannel_4_analyzer_1_array_crystal_array_1_zdepth;
MCNUM mccchannel_4_analyzer_1_array_crystal_array_1_xwidth2;
MCNUM mccchannel_4_analyzer_1_array_crystal_array_1_yheight2;
MCNUM mccchannel_4_analyzer_1_array_crystal_array_1_visualize;
int mccchannel_4_analyzer_1_array_crystal_array_1_target_index;
MCNUM mccchannel_4_analyzer_1_array_crystal_array_1_target_x;
MCNUM mccchannel_4_analyzer_1_array_crystal_array_1_target_y;
MCNUM mccchannel_4_analyzer_1_array_crystal_array_1_target_z;
MCNUM mccchannel_4_analyzer_1_array_crystal_array_1_focus_aw;
MCNUM mccchannel_4_analyzer_1_array_crystal_array_1_focus_ah;
MCNUM mccchannel_4_analyzer_1_array_crystal_array_1_focus_xw;
MCNUM mccchannel_4_analyzer_1_array_crystal_array_1_focus_xh;
MCNUM mccchannel_4_analyzer_1_array_crystal_array_1_focus_r;
MCNUM mccchannel_4_analyzer_1_array_crystal_array_1_p_interact;
char mccchannel_4_analyzer_1_array_crystal_array_1_mask_string[16384];
char mccchannel_4_analyzer_1_array_crystal_array_1_mask_setting[16384];
MCNUM mccchannel_4_analyzer_1_array_crystal_array_1_number_of_activations;

/* Setting parameters for component 'channel_4_analyzer_1_array_crystal_array_2' [284]. */
char mccchannel_4_analyzer_1_array_crystal_array_2_material_string[16384];
MCNUM mccchannel_4_analyzer_1_array_crystal_array_2_priority;
MCNUM mccchannel_4_analyzer_1_array_crystal_array_2_xwidth;
MCNUM mccchannel_4_analyzer_1_array_crystal_array_2_yheight;
MCNUM mccchannel_4_analyzer_1_array_crystal_array_2_zdepth;
MCNUM mccchannel_4_analyzer_1_array_crystal_array_2_xwidth2;
MCNUM mccchannel_4_analyzer_1_array_crystal_array_2_yheight2;
MCNUM mccchannel_4_analyzer_1_array_crystal_array_2_visualize;
int mccchannel_4_analyzer_1_array_crystal_array_2_target_index;
MCNUM mccchannel_4_analyzer_1_array_crystal_array_2_target_x;
MCNUM mccchannel_4_analyzer_1_array_crystal_array_2_target_y;
MCNUM mccchannel_4_analyzer_1_array_crystal_array_2_target_z;
MCNUM mccchannel_4_analyzer_1_array_crystal_array_2_focus_aw;
MCNUM mccchannel_4_analyzer_1_array_crystal_array_2_focus_ah;
MCNUM mccchannel_4_analyzer_1_array_crystal_array_2_focus_xw;
MCNUM mccchannel_4_analyzer_1_array_crystal_array_2_focus_xh;
MCNUM mccchannel_4_analyzer_1_array_crystal_array_2_focus_r;
MCNUM mccchannel_4_analyzer_1_array_crystal_array_2_p_interact;
char mccchannel_4_analyzer_1_array_crystal_array_2_mask_string[16384];
char mccchannel_4_analyzer_1_array_crystal_array_2_mask_setting[16384];
MCNUM mccchannel_4_analyzer_1_array_crystal_array_2_number_of_activations;

/* Setting parameters for component 'channel_4_analyzer_1_array_crystal_array_3' [285]. */
char mccchannel_4_analyzer_1_array_crystal_array_3_material_string[16384];
MCNUM mccchannel_4_analyzer_1_array_crystal_array_3_priority;
MCNUM mccchannel_4_analyzer_1_array_crystal_array_3_xwidth;
MCNUM mccchannel_4_analyzer_1_array_crystal_array_3_yheight;
MCNUM mccchannel_4_analyzer_1_array_crystal_array_3_zdepth;
MCNUM mccchannel_4_analyzer_1_array_crystal_array_3_xwidth2;
MCNUM mccchannel_4_analyzer_1_array_crystal_array_3_yheight2;
MCNUM mccchannel_4_analyzer_1_array_crystal_array_3_visualize;
int mccchannel_4_analyzer_1_array_crystal_array_3_target_index;
MCNUM mccchannel_4_analyzer_1_array_crystal_array_3_target_x;
MCNUM mccchannel_4_analyzer_1_array_crystal_array_3_target_y;
MCNUM mccchannel_4_analyzer_1_array_crystal_array_3_target_z;
MCNUM mccchannel_4_analyzer_1_array_crystal_array_3_focus_aw;
MCNUM mccchannel_4_analyzer_1_array_crystal_array_3_focus_ah;
MCNUM mccchannel_4_analyzer_1_array_crystal_array_3_focus_xw;
MCNUM mccchannel_4_analyzer_1_array_crystal_array_3_focus_xh;
MCNUM mccchannel_4_analyzer_1_array_crystal_array_3_focus_r;
MCNUM mccchannel_4_analyzer_1_array_crystal_array_3_p_interact;
char mccchannel_4_analyzer_1_array_crystal_array_3_mask_string[16384];
char mccchannel_4_analyzer_1_array_crystal_array_3_mask_setting[16384];
MCNUM mccchannel_4_analyzer_1_array_crystal_array_3_number_of_activations;

/* Setting parameters for component 'channel_4_analyzer_1_array_crystal_array_4' [286]. */
char mccchannel_4_analyzer_1_array_crystal_array_4_material_string[16384];
MCNUM mccchannel_4_analyzer_1_array_crystal_array_4_priority;
MCNUM mccchannel_4_analyzer_1_array_crystal_array_4_xwidth;
MCNUM mccchannel_4_analyzer_1_array_crystal_array_4_yheight;
MCNUM mccchannel_4_analyzer_1_array_crystal_array_4_zdepth;
MCNUM mccchannel_4_analyzer_1_array_crystal_array_4_xwidth2;
MCNUM mccchannel_4_analyzer_1_array_crystal_array_4_yheight2;
MCNUM mccchannel_4_analyzer_1_array_crystal_array_4_visualize;
int mccchannel_4_analyzer_1_array_crystal_array_4_target_index;
MCNUM mccchannel_4_analyzer_1_array_crystal_array_4_target_x;
MCNUM mccchannel_4_analyzer_1_array_crystal_array_4_target_y;
MCNUM mccchannel_4_analyzer_1_array_crystal_array_4_target_z;
MCNUM mccchannel_4_analyzer_1_array_crystal_array_4_focus_aw;
MCNUM mccchannel_4_analyzer_1_array_crystal_array_4_focus_ah;
MCNUM mccchannel_4_analyzer_1_array_crystal_array_4_focus_xw;
MCNUM mccchannel_4_analyzer_1_array_crystal_array_4_focus_xh;
MCNUM mccchannel_4_analyzer_1_array_crystal_array_4_focus_r;
MCNUM mccchannel_4_analyzer_1_array_crystal_array_4_p_interact;
char mccchannel_4_analyzer_1_array_crystal_array_4_mask_string[16384];
char mccchannel_4_analyzer_1_array_crystal_array_4_mask_setting[16384];
MCNUM mccchannel_4_analyzer_1_array_crystal_array_4_number_of_activations;

/* Setting parameters for component 'channel_4_analyzer_1_array_crystal_array_5' [287]. */
char mccchannel_4_analyzer_1_array_crystal_array_5_material_string[16384];
MCNUM mccchannel_4_analyzer_1_array_crystal_array_5_priority;
MCNUM mccchannel_4_analyzer_1_array_crystal_array_5_xwidth;
MCNUM mccchannel_4_analyzer_1_array_crystal_array_5_yheight;
MCNUM mccchannel_4_analyzer_1_array_crystal_array_5_zdepth;
MCNUM mccchannel_4_analyzer_1_array_crystal_array_5_xwidth2;
MCNUM mccchannel_4_analyzer_1_array_crystal_array_5_yheight2;
MCNUM mccchannel_4_analyzer_1_array_crystal_array_5_visualize;
int mccchannel_4_analyzer_1_array_crystal_array_5_target_index;
MCNUM mccchannel_4_analyzer_1_array_crystal_array_5_target_x;
MCNUM mccchannel_4_analyzer_1_array_crystal_array_5_target_y;
MCNUM mccchannel_4_analyzer_1_array_crystal_array_5_target_z;
MCNUM mccchannel_4_analyzer_1_array_crystal_array_5_focus_aw;
MCNUM mccchannel_4_analyzer_1_array_crystal_array_5_focus_ah;
MCNUM mccchannel_4_analyzer_1_array_crystal_array_5_focus_xw;
MCNUM mccchannel_4_analyzer_1_array_crystal_array_5_focus_xh;
MCNUM mccchannel_4_analyzer_1_array_crystal_array_5_focus_r;
MCNUM mccchannel_4_analyzer_1_array_crystal_array_5_p_interact;
char mccchannel_4_analyzer_1_array_crystal_array_5_mask_string[16384];
char mccchannel_4_analyzer_1_array_crystal_array_5_mask_setting[16384];
MCNUM mccchannel_4_analyzer_1_array_crystal_array_5_number_of_activations;

/* Setting parameters for component 'channel_4_analyzer_1_array_crystal_array_6' [288]. */
char mccchannel_4_analyzer_1_array_crystal_array_6_material_string[16384];
MCNUM mccchannel_4_analyzer_1_array_crystal_array_6_priority;
MCNUM mccchannel_4_analyzer_1_array_crystal_array_6_xwidth;
MCNUM mccchannel_4_analyzer_1_array_crystal_array_6_yheight;
MCNUM mccchannel_4_analyzer_1_array_crystal_array_6_zdepth;
MCNUM mccchannel_4_analyzer_1_array_crystal_array_6_xwidth2;
MCNUM mccchannel_4_analyzer_1_array_crystal_array_6_yheight2;
MCNUM mccchannel_4_analyzer_1_array_crystal_array_6_visualize;
int mccchannel_4_analyzer_1_array_crystal_array_6_target_index;
MCNUM mccchannel_4_analyzer_1_array_crystal_array_6_target_x;
MCNUM mccchannel_4_analyzer_1_array_crystal_array_6_target_y;
MCNUM mccchannel_4_analyzer_1_array_crystal_array_6_target_z;
MCNUM mccchannel_4_analyzer_1_array_crystal_array_6_focus_aw;
MCNUM mccchannel_4_analyzer_1_array_crystal_array_6_focus_ah;
MCNUM mccchannel_4_analyzer_1_array_crystal_array_6_focus_xw;
MCNUM mccchannel_4_analyzer_1_array_crystal_array_6_focus_xh;
MCNUM mccchannel_4_analyzer_1_array_crystal_array_6_focus_r;
MCNUM mccchannel_4_analyzer_1_array_crystal_array_6_p_interact;
char mccchannel_4_analyzer_1_array_crystal_array_6_mask_string[16384];
char mccchannel_4_analyzer_1_array_crystal_array_6_mask_setting[16384];
MCNUM mccchannel_4_analyzer_1_array_crystal_array_6_number_of_activations;

/* Setting parameters for component 'channel_4_analyzer_1_array_crystal_array_7' [289]. */
char mccchannel_4_analyzer_1_array_crystal_array_7_material_string[16384];
MCNUM mccchannel_4_analyzer_1_array_crystal_array_7_priority;
MCNUM mccchannel_4_analyzer_1_array_crystal_array_7_xwidth;
MCNUM mccchannel_4_analyzer_1_array_crystal_array_7_yheight;
MCNUM mccchannel_4_analyzer_1_array_crystal_array_7_zdepth;
MCNUM mccchannel_4_analyzer_1_array_crystal_array_7_xwidth2;
MCNUM mccchannel_4_analyzer_1_array_crystal_array_7_yheight2;
MCNUM mccchannel_4_analyzer_1_array_crystal_array_7_visualize;
int mccchannel_4_analyzer_1_array_crystal_array_7_target_index;
MCNUM mccchannel_4_analyzer_1_array_crystal_array_7_target_x;
MCNUM mccchannel_4_analyzer_1_array_crystal_array_7_target_y;
MCNUM mccchannel_4_analyzer_1_array_crystal_array_7_target_z;
MCNUM mccchannel_4_analyzer_1_array_crystal_array_7_focus_aw;
MCNUM mccchannel_4_analyzer_1_array_crystal_array_7_focus_ah;
MCNUM mccchannel_4_analyzer_1_array_crystal_array_7_focus_xw;
MCNUM mccchannel_4_analyzer_1_array_crystal_array_7_focus_xh;
MCNUM mccchannel_4_analyzer_1_array_crystal_array_7_focus_r;
MCNUM mccchannel_4_analyzer_1_array_crystal_array_7_p_interact;
char mccchannel_4_analyzer_1_array_crystal_array_7_mask_string[16384];
char mccchannel_4_analyzer_1_array_crystal_array_7_mask_setting[16384];
MCNUM mccchannel_4_analyzer_1_array_crystal_array_7_number_of_activations;

/* Setting parameters for component 'channel_4_analyzer_1_array_crystal_array_8' [290]. */
char mccchannel_4_analyzer_1_array_crystal_array_8_material_string[16384];
MCNUM mccchannel_4_analyzer_1_array_crystal_array_8_priority;
MCNUM mccchannel_4_analyzer_1_array_crystal_array_8_xwidth;
MCNUM mccchannel_4_analyzer_1_array_crystal_array_8_yheight;
MCNUM mccchannel_4_analyzer_1_array_crystal_array_8_zdepth;
MCNUM mccchannel_4_analyzer_1_array_crystal_array_8_xwidth2;
MCNUM mccchannel_4_analyzer_1_array_crystal_array_8_yheight2;
MCNUM mccchannel_4_analyzer_1_array_crystal_array_8_visualize;
int mccchannel_4_analyzer_1_array_crystal_array_8_target_index;
MCNUM mccchannel_4_analyzer_1_array_crystal_array_8_target_x;
MCNUM mccchannel_4_analyzer_1_array_crystal_array_8_target_y;
MCNUM mccchannel_4_analyzer_1_array_crystal_array_8_target_z;
MCNUM mccchannel_4_analyzer_1_array_crystal_array_8_focus_aw;
MCNUM mccchannel_4_analyzer_1_array_crystal_array_8_focus_ah;
MCNUM mccchannel_4_analyzer_1_array_crystal_array_8_focus_xw;
MCNUM mccchannel_4_analyzer_1_array_crystal_array_8_focus_xh;
MCNUM mccchannel_4_analyzer_1_array_crystal_array_8_focus_r;
MCNUM mccchannel_4_analyzer_1_array_crystal_array_8_p_interact;
char mccchannel_4_analyzer_1_array_crystal_array_8_mask_string[16384];
char mccchannel_4_analyzer_1_array_crystal_array_8_mask_setting[16384];
MCNUM mccchannel_4_analyzer_1_array_crystal_array_8_number_of_activations;

/* Setting parameters for component 'channel_4_analyzer_2_array_crystal_array_0' [293]. */
char mccchannel_4_analyzer_2_array_crystal_array_0_material_string[16384];
MCNUM mccchannel_4_analyzer_2_array_crystal_array_0_priority;
MCNUM mccchannel_4_analyzer_2_array_crystal_array_0_xwidth;
MCNUM mccchannel_4_analyzer_2_array_crystal_array_0_yheight;
MCNUM mccchannel_4_analyzer_2_array_crystal_array_0_zdepth;
MCNUM mccchannel_4_analyzer_2_array_crystal_array_0_xwidth2;
MCNUM mccchannel_4_analyzer_2_array_crystal_array_0_yheight2;
MCNUM mccchannel_4_analyzer_2_array_crystal_array_0_visualize;
int mccchannel_4_analyzer_2_array_crystal_array_0_target_index;
MCNUM mccchannel_4_analyzer_2_array_crystal_array_0_target_x;
MCNUM mccchannel_4_analyzer_2_array_crystal_array_0_target_y;
MCNUM mccchannel_4_analyzer_2_array_crystal_array_0_target_z;
MCNUM mccchannel_4_analyzer_2_array_crystal_array_0_focus_aw;
MCNUM mccchannel_4_analyzer_2_array_crystal_array_0_focus_ah;
MCNUM mccchannel_4_analyzer_2_array_crystal_array_0_focus_xw;
MCNUM mccchannel_4_analyzer_2_array_crystal_array_0_focus_xh;
MCNUM mccchannel_4_analyzer_2_array_crystal_array_0_focus_r;
MCNUM mccchannel_4_analyzer_2_array_crystal_array_0_p_interact;
char mccchannel_4_analyzer_2_array_crystal_array_0_mask_string[16384];
char mccchannel_4_analyzer_2_array_crystal_array_0_mask_setting[16384];
MCNUM mccchannel_4_analyzer_2_array_crystal_array_0_number_of_activations;

/* Setting parameters for component 'channel_4_analyzer_2_array_crystal_array_1' [294]. */
char mccchannel_4_analyzer_2_array_crystal_array_1_material_string[16384];
MCNUM mccchannel_4_analyzer_2_array_crystal_array_1_priority;
MCNUM mccchannel_4_analyzer_2_array_crystal_array_1_xwidth;
MCNUM mccchannel_4_analyzer_2_array_crystal_array_1_yheight;
MCNUM mccchannel_4_analyzer_2_array_crystal_array_1_zdepth;
MCNUM mccchannel_4_analyzer_2_array_crystal_array_1_xwidth2;
MCNUM mccchannel_4_analyzer_2_array_crystal_array_1_yheight2;
MCNUM mccchannel_4_analyzer_2_array_crystal_array_1_visualize;
int mccchannel_4_analyzer_2_array_crystal_array_1_target_index;
MCNUM mccchannel_4_analyzer_2_array_crystal_array_1_target_x;
MCNUM mccchannel_4_analyzer_2_array_crystal_array_1_target_y;
MCNUM mccchannel_4_analyzer_2_array_crystal_array_1_target_z;
MCNUM mccchannel_4_analyzer_2_array_crystal_array_1_focus_aw;
MCNUM mccchannel_4_analyzer_2_array_crystal_array_1_focus_ah;
MCNUM mccchannel_4_analyzer_2_array_crystal_array_1_focus_xw;
MCNUM mccchannel_4_analyzer_2_array_crystal_array_1_focus_xh;
MCNUM mccchannel_4_analyzer_2_array_crystal_array_1_focus_r;
MCNUM mccchannel_4_analyzer_2_array_crystal_array_1_p_interact;
char mccchannel_4_analyzer_2_array_crystal_array_1_mask_string[16384];
char mccchannel_4_analyzer_2_array_crystal_array_1_mask_setting[16384];
MCNUM mccchannel_4_analyzer_2_array_crystal_array_1_number_of_activations;

/* Setting parameters for component 'channel_4_analyzer_2_array_crystal_array_2' [295]. */
char mccchannel_4_analyzer_2_array_crystal_array_2_material_string[16384];
MCNUM mccchannel_4_analyzer_2_array_crystal_array_2_priority;
MCNUM mccchannel_4_analyzer_2_array_crystal_array_2_xwidth;
MCNUM mccchannel_4_analyzer_2_array_crystal_array_2_yheight;
MCNUM mccchannel_4_analyzer_2_array_crystal_array_2_zdepth;
MCNUM mccchannel_4_analyzer_2_array_crystal_array_2_xwidth2;
MCNUM mccchannel_4_analyzer_2_array_crystal_array_2_yheight2;
MCNUM mccchannel_4_analyzer_2_array_crystal_array_2_visualize;
int mccchannel_4_analyzer_2_array_crystal_array_2_target_index;
MCNUM mccchannel_4_analyzer_2_array_crystal_array_2_target_x;
MCNUM mccchannel_4_analyzer_2_array_crystal_array_2_target_y;
MCNUM mccchannel_4_analyzer_2_array_crystal_array_2_target_z;
MCNUM mccchannel_4_analyzer_2_array_crystal_array_2_focus_aw;
MCNUM mccchannel_4_analyzer_2_array_crystal_array_2_focus_ah;
MCNUM mccchannel_4_analyzer_2_array_crystal_array_2_focus_xw;
MCNUM mccchannel_4_analyzer_2_array_crystal_array_2_focus_xh;
MCNUM mccchannel_4_analyzer_2_array_crystal_array_2_focus_r;
MCNUM mccchannel_4_analyzer_2_array_crystal_array_2_p_interact;
char mccchannel_4_analyzer_2_array_crystal_array_2_mask_string[16384];
char mccchannel_4_analyzer_2_array_crystal_array_2_mask_setting[16384];
MCNUM mccchannel_4_analyzer_2_array_crystal_array_2_number_of_activations;

/* Setting parameters for component 'channel_4_analyzer_2_array_crystal_array_3' [296]. */
char mccchannel_4_analyzer_2_array_crystal_array_3_material_string[16384];
MCNUM mccchannel_4_analyzer_2_array_crystal_array_3_priority;
MCNUM mccchannel_4_analyzer_2_array_crystal_array_3_xwidth;
MCNUM mccchannel_4_analyzer_2_array_crystal_array_3_yheight;
MCNUM mccchannel_4_analyzer_2_array_crystal_array_3_zdepth;
MCNUM mccchannel_4_analyzer_2_array_crystal_array_3_xwidth2;
MCNUM mccchannel_4_analyzer_2_array_crystal_array_3_yheight2;
MCNUM mccchannel_4_analyzer_2_array_crystal_array_3_visualize;
int mccchannel_4_analyzer_2_array_crystal_array_3_target_index;
MCNUM mccchannel_4_analyzer_2_array_crystal_array_3_target_x;
MCNUM mccchannel_4_analyzer_2_array_crystal_array_3_target_y;
MCNUM mccchannel_4_analyzer_2_array_crystal_array_3_target_z;
MCNUM mccchannel_4_analyzer_2_array_crystal_array_3_focus_aw;
MCNUM mccchannel_4_analyzer_2_array_crystal_array_3_focus_ah;
MCNUM mccchannel_4_analyzer_2_array_crystal_array_3_focus_xw;
MCNUM mccchannel_4_analyzer_2_array_crystal_array_3_focus_xh;
MCNUM mccchannel_4_analyzer_2_array_crystal_array_3_focus_r;
MCNUM mccchannel_4_analyzer_2_array_crystal_array_3_p_interact;
char mccchannel_4_analyzer_2_array_crystal_array_3_mask_string[16384];
char mccchannel_4_analyzer_2_array_crystal_array_3_mask_setting[16384];
MCNUM mccchannel_4_analyzer_2_array_crystal_array_3_number_of_activations;

/* Setting parameters for component 'channel_4_analyzer_2_array_crystal_array_4' [297]. */
char mccchannel_4_analyzer_2_array_crystal_array_4_material_string[16384];
MCNUM mccchannel_4_analyzer_2_array_crystal_array_4_priority;
MCNUM mccchannel_4_analyzer_2_array_crystal_array_4_xwidth;
MCNUM mccchannel_4_analyzer_2_array_crystal_array_4_yheight;
MCNUM mccchannel_4_analyzer_2_array_crystal_array_4_zdepth;
MCNUM mccchannel_4_analyzer_2_array_crystal_array_4_xwidth2;
MCNUM mccchannel_4_analyzer_2_array_crystal_array_4_yheight2;
MCNUM mccchannel_4_analyzer_2_array_crystal_array_4_visualize;
int mccchannel_4_analyzer_2_array_crystal_array_4_target_index;
MCNUM mccchannel_4_analyzer_2_array_crystal_array_4_target_x;
MCNUM mccchannel_4_analyzer_2_array_crystal_array_4_target_y;
MCNUM mccchannel_4_analyzer_2_array_crystal_array_4_target_z;
MCNUM mccchannel_4_analyzer_2_array_crystal_array_4_focus_aw;
MCNUM mccchannel_4_analyzer_2_array_crystal_array_4_focus_ah;
MCNUM mccchannel_4_analyzer_2_array_crystal_array_4_focus_xw;
MCNUM mccchannel_4_analyzer_2_array_crystal_array_4_focus_xh;
MCNUM mccchannel_4_analyzer_2_array_crystal_array_4_focus_r;
MCNUM mccchannel_4_analyzer_2_array_crystal_array_4_p_interact;
char mccchannel_4_analyzer_2_array_crystal_array_4_mask_string[16384];
char mccchannel_4_analyzer_2_array_crystal_array_4_mask_setting[16384];
MCNUM mccchannel_4_analyzer_2_array_crystal_array_4_number_of_activations;

/* Setting parameters for component 'channel_4_analyzer_2_array_crystal_array_5' [298]. */
char mccchannel_4_analyzer_2_array_crystal_array_5_material_string[16384];
MCNUM mccchannel_4_analyzer_2_array_crystal_array_5_priority;
MCNUM mccchannel_4_analyzer_2_array_crystal_array_5_xwidth;
MCNUM mccchannel_4_analyzer_2_array_crystal_array_5_yheight;
MCNUM mccchannel_4_analyzer_2_array_crystal_array_5_zdepth;
MCNUM mccchannel_4_analyzer_2_array_crystal_array_5_xwidth2;
MCNUM mccchannel_4_analyzer_2_array_crystal_array_5_yheight2;
MCNUM mccchannel_4_analyzer_2_array_crystal_array_5_visualize;
int mccchannel_4_analyzer_2_array_crystal_array_5_target_index;
MCNUM mccchannel_4_analyzer_2_array_crystal_array_5_target_x;
MCNUM mccchannel_4_analyzer_2_array_crystal_array_5_target_y;
MCNUM mccchannel_4_analyzer_2_array_crystal_array_5_target_z;
MCNUM mccchannel_4_analyzer_2_array_crystal_array_5_focus_aw;
MCNUM mccchannel_4_analyzer_2_array_crystal_array_5_focus_ah;
MCNUM mccchannel_4_analyzer_2_array_crystal_array_5_focus_xw;
MCNUM mccchannel_4_analyzer_2_array_crystal_array_5_focus_xh;
MCNUM mccchannel_4_analyzer_2_array_crystal_array_5_focus_r;
MCNUM mccchannel_4_analyzer_2_array_crystal_array_5_p_interact;
char mccchannel_4_analyzer_2_array_crystal_array_5_mask_string[16384];
char mccchannel_4_analyzer_2_array_crystal_array_5_mask_setting[16384];
MCNUM mccchannel_4_analyzer_2_array_crystal_array_5_number_of_activations;

/* Setting parameters for component 'channel_4_analyzer_2_array_crystal_array_6' [299]. */
char mccchannel_4_analyzer_2_array_crystal_array_6_material_string[16384];
MCNUM mccchannel_4_analyzer_2_array_crystal_array_6_priority;
MCNUM mccchannel_4_analyzer_2_array_crystal_array_6_xwidth;
MCNUM mccchannel_4_analyzer_2_array_crystal_array_6_yheight;
MCNUM mccchannel_4_analyzer_2_array_crystal_array_6_zdepth;
MCNUM mccchannel_4_analyzer_2_array_crystal_array_6_xwidth2;
MCNUM mccchannel_4_analyzer_2_array_crystal_array_6_yheight2;
MCNUM mccchannel_4_analyzer_2_array_crystal_array_6_visualize;
int mccchannel_4_analyzer_2_array_crystal_array_6_target_index;
MCNUM mccchannel_4_analyzer_2_array_crystal_array_6_target_x;
MCNUM mccchannel_4_analyzer_2_array_crystal_array_6_target_y;
MCNUM mccchannel_4_analyzer_2_array_crystal_array_6_target_z;
MCNUM mccchannel_4_analyzer_2_array_crystal_array_6_focus_aw;
MCNUM mccchannel_4_analyzer_2_array_crystal_array_6_focus_ah;
MCNUM mccchannel_4_analyzer_2_array_crystal_array_6_focus_xw;
MCNUM mccchannel_4_analyzer_2_array_crystal_array_6_focus_xh;
MCNUM mccchannel_4_analyzer_2_array_crystal_array_6_focus_r;
MCNUM mccchannel_4_analyzer_2_array_crystal_array_6_p_interact;
char mccchannel_4_analyzer_2_array_crystal_array_6_mask_string[16384];
char mccchannel_4_analyzer_2_array_crystal_array_6_mask_setting[16384];
MCNUM mccchannel_4_analyzer_2_array_crystal_array_6_number_of_activations;

/* Setting parameters for component 'channel_4_analyzer_2_array_crystal_array_7' [300]. */
char mccchannel_4_analyzer_2_array_crystal_array_7_material_string[16384];
MCNUM mccchannel_4_analyzer_2_array_crystal_array_7_priority;
MCNUM mccchannel_4_analyzer_2_array_crystal_array_7_xwidth;
MCNUM mccchannel_4_analyzer_2_array_crystal_array_7_yheight;
MCNUM mccchannel_4_analyzer_2_array_crystal_array_7_zdepth;
MCNUM mccchannel_4_analyzer_2_array_crystal_array_7_xwidth2;
MCNUM mccchannel_4_analyzer_2_array_crystal_array_7_yheight2;
MCNUM mccchannel_4_analyzer_2_array_crystal_array_7_visualize;
int mccchannel_4_analyzer_2_array_crystal_array_7_target_index;
MCNUM mccchannel_4_analyzer_2_array_crystal_array_7_target_x;
MCNUM mccchannel_4_analyzer_2_array_crystal_array_7_target_y;
MCNUM mccchannel_4_analyzer_2_array_crystal_array_7_target_z;
MCNUM mccchannel_4_analyzer_2_array_crystal_array_7_focus_aw;
MCNUM mccchannel_4_analyzer_2_array_crystal_array_7_focus_ah;
MCNUM mccchannel_4_analyzer_2_array_crystal_array_7_focus_xw;
MCNUM mccchannel_4_analyzer_2_array_crystal_array_7_focus_xh;
MCNUM mccchannel_4_analyzer_2_array_crystal_array_7_focus_r;
MCNUM mccchannel_4_analyzer_2_array_crystal_array_7_p_interact;
char mccchannel_4_analyzer_2_array_crystal_array_7_mask_string[16384];
char mccchannel_4_analyzer_2_array_crystal_array_7_mask_setting[16384];
MCNUM mccchannel_4_analyzer_2_array_crystal_array_7_number_of_activations;

/* Setting parameters for component 'channel_4_analyzer_2_array_crystal_array_8' [301]. */
char mccchannel_4_analyzer_2_array_crystal_array_8_material_string[16384];
MCNUM mccchannel_4_analyzer_2_array_crystal_array_8_priority;
MCNUM mccchannel_4_analyzer_2_array_crystal_array_8_xwidth;
MCNUM mccchannel_4_analyzer_2_array_crystal_array_8_yheight;
MCNUM mccchannel_4_analyzer_2_array_crystal_array_8_zdepth;
MCNUM mccchannel_4_analyzer_2_array_crystal_array_8_xwidth2;
MCNUM mccchannel_4_analyzer_2_array_crystal_array_8_yheight2;
MCNUM mccchannel_4_analyzer_2_array_crystal_array_8_visualize;
int mccchannel_4_analyzer_2_array_crystal_array_8_target_index;
MCNUM mccchannel_4_analyzer_2_array_crystal_array_8_target_x;
MCNUM mccchannel_4_analyzer_2_array_crystal_array_8_target_y;
MCNUM mccchannel_4_analyzer_2_array_crystal_array_8_target_z;
MCNUM mccchannel_4_analyzer_2_array_crystal_array_8_focus_aw;
MCNUM mccchannel_4_analyzer_2_array_crystal_array_8_focus_ah;
MCNUM mccchannel_4_analyzer_2_array_crystal_array_8_focus_xw;
MCNUM mccchannel_4_analyzer_2_array_crystal_array_8_focus_xh;
MCNUM mccchannel_4_analyzer_2_array_crystal_array_8_focus_r;
MCNUM mccchannel_4_analyzer_2_array_crystal_array_8_p_interact;
char mccchannel_4_analyzer_2_array_crystal_array_8_mask_string[16384];
char mccchannel_4_analyzer_2_array_crystal_array_8_mask_setting[16384];
MCNUM mccchannel_4_analyzer_2_array_crystal_array_8_number_of_activations;

/* Setting parameters for component 'channel_4_cave2_cyl1' [302]. */
char mccchannel_4_cave2_cyl1_material_string[16384];
MCNUM mccchannel_4_cave2_cyl1_priority;
MCNUM mccchannel_4_cave2_cyl1_radius;
MCNUM mccchannel_4_cave2_cyl1_yheight;
MCNUM mccchannel_4_cave2_cyl1_visualize;
int mccchannel_4_cave2_cyl1_target_index;
MCNUM mccchannel_4_cave2_cyl1_target_x;
MCNUM mccchannel_4_cave2_cyl1_target_y;
MCNUM mccchannel_4_cave2_cyl1_target_z;
MCNUM mccchannel_4_cave2_cyl1_focus_aw;
MCNUM mccchannel_4_cave2_cyl1_focus_ah;
MCNUM mccchannel_4_cave2_cyl1_focus_xw;
MCNUM mccchannel_4_cave2_cyl1_focus_xh;
MCNUM mccchannel_4_cave2_cyl1_focus_r;
MCNUM mccchannel_4_cave2_cyl1_p_interact;
char mccchannel_4_cave2_cyl1_mask_string[16384];
char mccchannel_4_cave2_cyl1_mask_setting[16384];
MCNUM mccchannel_4_cave2_cyl1_number_of_activations;

/* Setting parameters for component 'channel_4_cave2_box1' [303]. */
char mccchannel_4_cave2_box1_material_string[16384];
MCNUM mccchannel_4_cave2_box1_priority;
MCNUM mccchannel_4_cave2_box1_xwidth;
MCNUM mccchannel_4_cave2_box1_yheight;
MCNUM mccchannel_4_cave2_box1_zdepth;
MCNUM mccchannel_4_cave2_box1_xwidth2;
MCNUM mccchannel_4_cave2_box1_yheight2;
MCNUM mccchannel_4_cave2_box1_visualize;
int mccchannel_4_cave2_box1_target_index;
MCNUM mccchannel_4_cave2_box1_target_x;
MCNUM mccchannel_4_cave2_box1_target_y;
MCNUM mccchannel_4_cave2_box1_target_z;
MCNUM mccchannel_4_cave2_box1_focus_aw;
MCNUM mccchannel_4_cave2_box1_focus_ah;
MCNUM mccchannel_4_cave2_box1_focus_xw;
MCNUM mccchannel_4_cave2_box1_focus_xh;
MCNUM mccchannel_4_cave2_box1_focus_r;
MCNUM mccchannel_4_cave2_box1_p_interact;
char mccchannel_4_cave2_box1_mask_string[16384];
char mccchannel_4_cave2_box1_mask_setting[16384];
MCNUM mccchannel_4_cave2_box1_number_of_activations;

/* Setting parameters for component 'channel_4_cave2_box2' [304]. */
char mccchannel_4_cave2_box2_material_string[16384];
MCNUM mccchannel_4_cave2_box2_priority;
MCNUM mccchannel_4_cave2_box2_xwidth;
MCNUM mccchannel_4_cave2_box2_yheight;
MCNUM mccchannel_4_cave2_box2_zdepth;
MCNUM mccchannel_4_cave2_box2_xwidth2;
MCNUM mccchannel_4_cave2_box2_yheight2;
MCNUM mccchannel_4_cave2_box2_visualize;
int mccchannel_4_cave2_box2_target_index;
MCNUM mccchannel_4_cave2_box2_target_x;
MCNUM mccchannel_4_cave2_box2_target_y;
MCNUM mccchannel_4_cave2_box2_target_z;
MCNUM mccchannel_4_cave2_box2_focus_aw;
MCNUM mccchannel_4_cave2_box2_focus_ah;
MCNUM mccchannel_4_cave2_box2_focus_xw;
MCNUM mccchannel_4_cave2_box2_focus_xh;
MCNUM mccchannel_4_cave2_box2_focus_r;
MCNUM mccchannel_4_cave2_box2_p_interact;
char mccchannel_4_cave2_box2_mask_string[16384];
char mccchannel_4_cave2_box2_mask_setting[16384];
MCNUM mccchannel_4_cave2_box2_number_of_activations;

/* Setting parameters for component 'channel_4_cave2_box3' [305]. */
char mccchannel_4_cave2_box3_material_string[16384];
MCNUM mccchannel_4_cave2_box3_priority;
MCNUM mccchannel_4_cave2_box3_xwidth;
MCNUM mccchannel_4_cave2_box3_yheight;
MCNUM mccchannel_4_cave2_box3_zdepth;
MCNUM mccchannel_4_cave2_box3_xwidth2;
MCNUM mccchannel_4_cave2_box3_yheight2;
MCNUM mccchannel_4_cave2_box3_visualize;
int mccchannel_4_cave2_box3_target_index;
MCNUM mccchannel_4_cave2_box3_target_x;
MCNUM mccchannel_4_cave2_box3_target_y;
MCNUM mccchannel_4_cave2_box3_target_z;
MCNUM mccchannel_4_cave2_box3_focus_aw;
MCNUM mccchannel_4_cave2_box3_focus_ah;
MCNUM mccchannel_4_cave2_box3_focus_xw;
MCNUM mccchannel_4_cave2_box3_focus_xh;
MCNUM mccchannel_4_cave2_box3_focus_r;
MCNUM mccchannel_4_cave2_box3_p_interact;
char mccchannel_4_cave2_box3_mask_string[16384];
char mccchannel_4_cave2_box3_mask_setting[16384];
MCNUM mccchannel_4_cave2_box3_number_of_activations;

/* Setting parameters for component 'inter_analyzer_colimator_4_blade_0' [307]. */
char mccinter_analyzer_colimator_4_blade_0_material_string[16384];
MCNUM mccinter_analyzer_colimator_4_blade_0_priority;
MCNUM mccinter_analyzer_colimator_4_blade_0_xwidth;
MCNUM mccinter_analyzer_colimator_4_blade_0_yheight;
MCNUM mccinter_analyzer_colimator_4_blade_0_zdepth;
MCNUM mccinter_analyzer_colimator_4_blade_0_xwidth2;
MCNUM mccinter_analyzer_colimator_4_blade_0_yheight2;
MCNUM mccinter_analyzer_colimator_4_blade_0_visualize;
int mccinter_analyzer_colimator_4_blade_0_target_index;
MCNUM mccinter_analyzer_colimator_4_blade_0_target_x;
MCNUM mccinter_analyzer_colimator_4_blade_0_target_y;
MCNUM mccinter_analyzer_colimator_4_blade_0_target_z;
MCNUM mccinter_analyzer_colimator_4_blade_0_focus_aw;
MCNUM mccinter_analyzer_colimator_4_blade_0_focus_ah;
MCNUM mccinter_analyzer_colimator_4_blade_0_focus_xw;
MCNUM mccinter_analyzer_colimator_4_blade_0_focus_xh;
MCNUM mccinter_analyzer_colimator_4_blade_0_focus_r;
MCNUM mccinter_analyzer_colimator_4_blade_0_p_interact;
char mccinter_analyzer_colimator_4_blade_0_mask_string[16384];
char mccinter_analyzer_colimator_4_blade_0_mask_setting[16384];
MCNUM mccinter_analyzer_colimator_4_blade_0_number_of_activations;

/* Setting parameters for component 'inter_analyzer_colimator_4_blade_1' [308]. */
char mccinter_analyzer_colimator_4_blade_1_material_string[16384];
MCNUM mccinter_analyzer_colimator_4_blade_1_priority;
MCNUM mccinter_analyzer_colimator_4_blade_1_xwidth;
MCNUM mccinter_analyzer_colimator_4_blade_1_yheight;
MCNUM mccinter_analyzer_colimator_4_blade_1_zdepth;
MCNUM mccinter_analyzer_colimator_4_blade_1_xwidth2;
MCNUM mccinter_analyzer_colimator_4_blade_1_yheight2;
MCNUM mccinter_analyzer_colimator_4_blade_1_visualize;
int mccinter_analyzer_colimator_4_blade_1_target_index;
MCNUM mccinter_analyzer_colimator_4_blade_1_target_x;
MCNUM mccinter_analyzer_colimator_4_blade_1_target_y;
MCNUM mccinter_analyzer_colimator_4_blade_1_target_z;
MCNUM mccinter_analyzer_colimator_4_blade_1_focus_aw;
MCNUM mccinter_analyzer_colimator_4_blade_1_focus_ah;
MCNUM mccinter_analyzer_colimator_4_blade_1_focus_xw;
MCNUM mccinter_analyzer_colimator_4_blade_1_focus_xh;
MCNUM mccinter_analyzer_colimator_4_blade_1_focus_r;
MCNUM mccinter_analyzer_colimator_4_blade_1_p_interact;
char mccinter_analyzer_colimator_4_blade_1_mask_string[16384];
char mccinter_analyzer_colimator_4_blade_1_mask_setting[16384];
MCNUM mccinter_analyzer_colimator_4_blade_1_number_of_activations;

/* Setting parameters for component 'inter_analyzer_colimator_4_blade_2' [309]. */
char mccinter_analyzer_colimator_4_blade_2_material_string[16384];
MCNUM mccinter_analyzer_colimator_4_blade_2_priority;
MCNUM mccinter_analyzer_colimator_4_blade_2_xwidth;
MCNUM mccinter_analyzer_colimator_4_blade_2_yheight;
MCNUM mccinter_analyzer_colimator_4_blade_2_zdepth;
MCNUM mccinter_analyzer_colimator_4_blade_2_xwidth2;
MCNUM mccinter_analyzer_colimator_4_blade_2_yheight2;
MCNUM mccinter_analyzer_colimator_4_blade_2_visualize;
int mccinter_analyzer_colimator_4_blade_2_target_index;
MCNUM mccinter_analyzer_colimator_4_blade_2_target_x;
MCNUM mccinter_analyzer_colimator_4_blade_2_target_y;
MCNUM mccinter_analyzer_colimator_4_blade_2_target_z;
MCNUM mccinter_analyzer_colimator_4_blade_2_focus_aw;
MCNUM mccinter_analyzer_colimator_4_blade_2_focus_ah;
MCNUM mccinter_analyzer_colimator_4_blade_2_focus_xw;
MCNUM mccinter_analyzer_colimator_4_blade_2_focus_xh;
MCNUM mccinter_analyzer_colimator_4_blade_2_focus_r;
MCNUM mccinter_analyzer_colimator_4_blade_2_p_interact;
char mccinter_analyzer_colimator_4_blade_2_mask_string[16384];
char mccinter_analyzer_colimator_4_blade_2_mask_setting[16384];
MCNUM mccinter_analyzer_colimator_4_blade_2_number_of_activations;

/* Setting parameters for component 'inter_analyzer_colimator_4_blade_3' [310]. */
char mccinter_analyzer_colimator_4_blade_3_material_string[16384];
MCNUM mccinter_analyzer_colimator_4_blade_3_priority;
MCNUM mccinter_analyzer_colimator_4_blade_3_xwidth;
MCNUM mccinter_analyzer_colimator_4_blade_3_yheight;
MCNUM mccinter_analyzer_colimator_4_blade_3_zdepth;
MCNUM mccinter_analyzer_colimator_4_blade_3_xwidth2;
MCNUM mccinter_analyzer_colimator_4_blade_3_yheight2;
MCNUM mccinter_analyzer_colimator_4_blade_3_visualize;
int mccinter_analyzer_colimator_4_blade_3_target_index;
MCNUM mccinter_analyzer_colimator_4_blade_3_target_x;
MCNUM mccinter_analyzer_colimator_4_blade_3_target_y;
MCNUM mccinter_analyzer_colimator_4_blade_3_target_z;
MCNUM mccinter_analyzer_colimator_4_blade_3_focus_aw;
MCNUM mccinter_analyzer_colimator_4_blade_3_focus_ah;
MCNUM mccinter_analyzer_colimator_4_blade_3_focus_xw;
MCNUM mccinter_analyzer_colimator_4_blade_3_focus_xh;
MCNUM mccinter_analyzer_colimator_4_blade_3_focus_r;
MCNUM mccinter_analyzer_colimator_4_blade_3_p_interact;
char mccinter_analyzer_colimator_4_blade_3_mask_string[16384];
char mccinter_analyzer_colimator_4_blade_3_mask_setting[16384];
MCNUM mccinter_analyzer_colimator_4_blade_3_number_of_activations;

/* Setting parameters for component 'inter_analyzer_colimator_4_blade_4' [311]. */
char mccinter_analyzer_colimator_4_blade_4_material_string[16384];
MCNUM mccinter_analyzer_colimator_4_blade_4_priority;
MCNUM mccinter_analyzer_colimator_4_blade_4_xwidth;
MCNUM mccinter_analyzer_colimator_4_blade_4_yheight;
MCNUM mccinter_analyzer_colimator_4_blade_4_zdepth;
MCNUM mccinter_analyzer_colimator_4_blade_4_xwidth2;
MCNUM mccinter_analyzer_colimator_4_blade_4_yheight2;
MCNUM mccinter_analyzer_colimator_4_blade_4_visualize;
int mccinter_analyzer_colimator_4_blade_4_target_index;
MCNUM mccinter_analyzer_colimator_4_blade_4_target_x;
MCNUM mccinter_analyzer_colimator_4_blade_4_target_y;
MCNUM mccinter_analyzer_colimator_4_blade_4_target_z;
MCNUM mccinter_analyzer_colimator_4_blade_4_focus_aw;
MCNUM mccinter_analyzer_colimator_4_blade_4_focus_ah;
MCNUM mccinter_analyzer_colimator_4_blade_4_focus_xw;
MCNUM mccinter_analyzer_colimator_4_blade_4_focus_xh;
MCNUM mccinter_analyzer_colimator_4_blade_4_focus_r;
MCNUM mccinter_analyzer_colimator_4_blade_4_p_interact;
char mccinter_analyzer_colimator_4_blade_4_mask_string[16384];
char mccinter_analyzer_colimator_4_blade_4_mask_setting[16384];
MCNUM mccinter_analyzer_colimator_4_blade_4_number_of_activations;

/* Setting parameters for component 'diffraction_detector_4_exit_volume' [312]. */
char mccdiffraction_detector_4_exit_volume_material_string[16384];
MCNUM mccdiffraction_detector_4_exit_volume_priority;
MCNUM mccdiffraction_detector_4_exit_volume_xwidth;
MCNUM mccdiffraction_detector_4_exit_volume_yheight;
MCNUM mccdiffraction_detector_4_exit_volume_zdepth;
MCNUM mccdiffraction_detector_4_exit_volume_xwidth2;
MCNUM mccdiffraction_detector_4_exit_volume_yheight2;
MCNUM mccdiffraction_detector_4_exit_volume_visualize;
int mccdiffraction_detector_4_exit_volume_target_index;
MCNUM mccdiffraction_detector_4_exit_volume_target_x;
MCNUM mccdiffraction_detector_4_exit_volume_target_y;
MCNUM mccdiffraction_detector_4_exit_volume_target_z;
MCNUM mccdiffraction_detector_4_exit_volume_focus_aw;
MCNUM mccdiffraction_detector_4_exit_volume_focus_ah;
MCNUM mccdiffraction_detector_4_exit_volume_focus_xw;
MCNUM mccdiffraction_detector_4_exit_volume_focus_xh;
MCNUM mccdiffraction_detector_4_exit_volume_focus_r;
MCNUM mccdiffraction_detector_4_exit_volume_p_interact;
char mccdiffraction_detector_4_exit_volume_mask_string[16384];
char mccdiffraction_detector_4_exit_volume_mask_setting[16384];
MCNUM mccdiffraction_detector_4_exit_volume_number_of_activations;

/* Setting parameters for component 'spec_detector_4_exit_volume' [313]. */
char mccspec_detector_4_exit_volume_material_string[16384];
MCNUM mccspec_detector_4_exit_volume_priority;
MCNUM mccspec_detector_4_exit_volume_xwidth;
MCNUM mccspec_detector_4_exit_volume_yheight;
MCNUM mccspec_detector_4_exit_volume_zdepth;
MCNUM mccspec_detector_4_exit_volume_xwidth2;
MCNUM mccspec_detector_4_exit_volume_yheight2;
MCNUM mccspec_detector_4_exit_volume_visualize;
int mccspec_detector_4_exit_volume_target_index;
MCNUM mccspec_detector_4_exit_volume_target_x;
MCNUM mccspec_detector_4_exit_volume_target_y;
MCNUM mccspec_detector_4_exit_volume_target_z;
MCNUM mccspec_detector_4_exit_volume_focus_aw;
MCNUM mccspec_detector_4_exit_volume_focus_ah;
MCNUM mccspec_detector_4_exit_volume_focus_xw;
MCNUM mccspec_detector_4_exit_volume_focus_xh;
MCNUM mccspec_detector_4_exit_volume_focus_r;
MCNUM mccspec_detector_4_exit_volume_p_interact;
char mccspec_detector_4_exit_volume_mask_string[16384];
char mccspec_detector_4_exit_volume_mask_setting[16384];
MCNUM mccspec_detector_4_exit_volume_number_of_activations;

/* Setting parameters for component 'channel_5_cave1_box1' [314]. */
char mccchannel_5_cave1_box1_material_string[16384];
MCNUM mccchannel_5_cave1_box1_priority;
MCNUM mccchannel_5_cave1_box1_xwidth;
MCNUM mccchannel_5_cave1_box1_yheight;
MCNUM mccchannel_5_cave1_box1_zdepth;
MCNUM mccchannel_5_cave1_box1_xwidth2;
MCNUM mccchannel_5_cave1_box1_yheight2;
MCNUM mccchannel_5_cave1_box1_visualize;
int mccchannel_5_cave1_box1_target_index;
MCNUM mccchannel_5_cave1_box1_target_x;
MCNUM mccchannel_5_cave1_box1_target_y;
MCNUM mccchannel_5_cave1_box1_target_z;
MCNUM mccchannel_5_cave1_box1_focus_aw;
MCNUM mccchannel_5_cave1_box1_focus_ah;
MCNUM mccchannel_5_cave1_box1_focus_xw;
MCNUM mccchannel_5_cave1_box1_focus_xh;
MCNUM mccchannel_5_cave1_box1_focus_r;
MCNUM mccchannel_5_cave1_box1_p_interact;
char mccchannel_5_cave1_box1_mask_string[16384];
char mccchannel_5_cave1_box1_mask_setting[16384];
MCNUM mccchannel_5_cave1_box1_number_of_activations;

/* Setting parameters for component 'channel_5_cave1_box2' [315]. */
char mccchannel_5_cave1_box2_material_string[16384];
MCNUM mccchannel_5_cave1_box2_priority;
MCNUM mccchannel_5_cave1_box2_xwidth;
MCNUM mccchannel_5_cave1_box2_yheight;
MCNUM mccchannel_5_cave1_box2_zdepth;
MCNUM mccchannel_5_cave1_box2_xwidth2;
MCNUM mccchannel_5_cave1_box2_yheight2;
MCNUM mccchannel_5_cave1_box2_visualize;
int mccchannel_5_cave1_box2_target_index;
MCNUM mccchannel_5_cave1_box2_target_x;
MCNUM mccchannel_5_cave1_box2_target_y;
MCNUM mccchannel_5_cave1_box2_target_z;
MCNUM mccchannel_5_cave1_box2_focus_aw;
MCNUM mccchannel_5_cave1_box2_focus_ah;
MCNUM mccchannel_5_cave1_box2_focus_xw;
MCNUM mccchannel_5_cave1_box2_focus_xh;
MCNUM mccchannel_5_cave1_box2_focus_r;
MCNUM mccchannel_5_cave1_box2_p_interact;
char mccchannel_5_cave1_box2_mask_string[16384];
char mccchannel_5_cave1_box2_mask_setting[16384];
MCNUM mccchannel_5_cave1_box2_number_of_activations;

/* Setting parameters for component 'channel_5_cave1_box3' [316]. */
char mccchannel_5_cave1_box3_material_string[16384];
MCNUM mccchannel_5_cave1_box3_priority;
MCNUM mccchannel_5_cave1_box3_xwidth;
MCNUM mccchannel_5_cave1_box3_yheight;
MCNUM mccchannel_5_cave1_box3_zdepth;
MCNUM mccchannel_5_cave1_box3_xwidth2;
MCNUM mccchannel_5_cave1_box3_yheight2;
MCNUM mccchannel_5_cave1_box3_visualize;
int mccchannel_5_cave1_box3_target_index;
MCNUM mccchannel_5_cave1_box3_target_x;
MCNUM mccchannel_5_cave1_box3_target_y;
MCNUM mccchannel_5_cave1_box3_target_z;
MCNUM mccchannel_5_cave1_box3_focus_aw;
MCNUM mccchannel_5_cave1_box3_focus_ah;
MCNUM mccchannel_5_cave1_box3_focus_xw;
MCNUM mccchannel_5_cave1_box3_focus_xh;
MCNUM mccchannel_5_cave1_box3_focus_r;
MCNUM mccchannel_5_cave1_box3_p_interact;
char mccchannel_5_cave1_box3_mask_string[16384];
char mccchannel_5_cave1_box3_mask_setting[16384];
MCNUM mccchannel_5_cave1_box3_number_of_activations;

/* Setting parameters for component 'channel_5_cave1_cyl1' [317]. */
char mccchannel_5_cave1_cyl1_material_string[16384];
MCNUM mccchannel_5_cave1_cyl1_priority;
MCNUM mccchannel_5_cave1_cyl1_radius;
MCNUM mccchannel_5_cave1_cyl1_yheight;
MCNUM mccchannel_5_cave1_cyl1_visualize;
int mccchannel_5_cave1_cyl1_target_index;
MCNUM mccchannel_5_cave1_cyl1_target_x;
MCNUM mccchannel_5_cave1_cyl1_target_y;
MCNUM mccchannel_5_cave1_cyl1_target_z;
MCNUM mccchannel_5_cave1_cyl1_focus_aw;
MCNUM mccchannel_5_cave1_cyl1_focus_ah;
MCNUM mccchannel_5_cave1_cyl1_focus_xw;
MCNUM mccchannel_5_cave1_cyl1_focus_xh;
MCNUM mccchannel_5_cave1_cyl1_focus_r;
MCNUM mccchannel_5_cave1_cyl1_p_interact;
char mccchannel_5_cave1_cyl1_mask_string[16384];
char mccchannel_5_cave1_cyl1_mask_setting[16384];
MCNUM mccchannel_5_cave1_cyl1_number_of_activations;

/* Setting parameters for component 'channel_5_analyzer_1_array_crystal_array_0' [320]. */
char mccchannel_5_analyzer_1_array_crystal_array_0_material_string[16384];
MCNUM mccchannel_5_analyzer_1_array_crystal_array_0_priority;
MCNUM mccchannel_5_analyzer_1_array_crystal_array_0_xwidth;
MCNUM mccchannel_5_analyzer_1_array_crystal_array_0_yheight;
MCNUM mccchannel_5_analyzer_1_array_crystal_array_0_zdepth;
MCNUM mccchannel_5_analyzer_1_array_crystal_array_0_xwidth2;
MCNUM mccchannel_5_analyzer_1_array_crystal_array_0_yheight2;
MCNUM mccchannel_5_analyzer_1_array_crystal_array_0_visualize;
int mccchannel_5_analyzer_1_array_crystal_array_0_target_index;
MCNUM mccchannel_5_analyzer_1_array_crystal_array_0_target_x;
MCNUM mccchannel_5_analyzer_1_array_crystal_array_0_target_y;
MCNUM mccchannel_5_analyzer_1_array_crystal_array_0_target_z;
MCNUM mccchannel_5_analyzer_1_array_crystal_array_0_focus_aw;
MCNUM mccchannel_5_analyzer_1_array_crystal_array_0_focus_ah;
MCNUM mccchannel_5_analyzer_1_array_crystal_array_0_focus_xw;
MCNUM mccchannel_5_analyzer_1_array_crystal_array_0_focus_xh;
MCNUM mccchannel_5_analyzer_1_array_crystal_array_0_focus_r;
MCNUM mccchannel_5_analyzer_1_array_crystal_array_0_p_interact;
char mccchannel_5_analyzer_1_array_crystal_array_0_mask_string[16384];
char mccchannel_5_analyzer_1_array_crystal_array_0_mask_setting[16384];
MCNUM mccchannel_5_analyzer_1_array_crystal_array_0_number_of_activations;

/* Setting parameters for component 'channel_5_analyzer_1_array_crystal_array_1' [321]. */
char mccchannel_5_analyzer_1_array_crystal_array_1_material_string[16384];
MCNUM mccchannel_5_analyzer_1_array_crystal_array_1_priority;
MCNUM mccchannel_5_analyzer_1_array_crystal_array_1_xwidth;
MCNUM mccchannel_5_analyzer_1_array_crystal_array_1_yheight;
MCNUM mccchannel_5_analyzer_1_array_crystal_array_1_zdepth;
MCNUM mccchannel_5_analyzer_1_array_crystal_array_1_xwidth2;
MCNUM mccchannel_5_analyzer_1_array_crystal_array_1_yheight2;
MCNUM mccchannel_5_analyzer_1_array_crystal_array_1_visualize;
int mccchannel_5_analyzer_1_array_crystal_array_1_target_index;
MCNUM mccchannel_5_analyzer_1_array_crystal_array_1_target_x;
MCNUM mccchannel_5_analyzer_1_array_crystal_array_1_target_y;
MCNUM mccchannel_5_analyzer_1_array_crystal_array_1_target_z;
MCNUM mccchannel_5_analyzer_1_array_crystal_array_1_focus_aw;
MCNUM mccchannel_5_analyzer_1_array_crystal_array_1_focus_ah;
MCNUM mccchannel_5_analyzer_1_array_crystal_array_1_focus_xw;
MCNUM mccchannel_5_analyzer_1_array_crystal_array_1_focus_xh;
MCNUM mccchannel_5_analyzer_1_array_crystal_array_1_focus_r;
MCNUM mccchannel_5_analyzer_1_array_crystal_array_1_p_interact;
char mccchannel_5_analyzer_1_array_crystal_array_1_mask_string[16384];
char mccchannel_5_analyzer_1_array_crystal_array_1_mask_setting[16384];
MCNUM mccchannel_5_analyzer_1_array_crystal_array_1_number_of_activations;

/* Setting parameters for component 'channel_5_analyzer_1_array_crystal_array_2' [322]. */
char mccchannel_5_analyzer_1_array_crystal_array_2_material_string[16384];
MCNUM mccchannel_5_analyzer_1_array_crystal_array_2_priority;
MCNUM mccchannel_5_analyzer_1_array_crystal_array_2_xwidth;
MCNUM mccchannel_5_analyzer_1_array_crystal_array_2_yheight;
MCNUM mccchannel_5_analyzer_1_array_crystal_array_2_zdepth;
MCNUM mccchannel_5_analyzer_1_array_crystal_array_2_xwidth2;
MCNUM mccchannel_5_analyzer_1_array_crystal_array_2_yheight2;
MCNUM mccchannel_5_analyzer_1_array_crystal_array_2_visualize;
int mccchannel_5_analyzer_1_array_crystal_array_2_target_index;
MCNUM mccchannel_5_analyzer_1_array_crystal_array_2_target_x;
MCNUM mccchannel_5_analyzer_1_array_crystal_array_2_target_y;
MCNUM mccchannel_5_analyzer_1_array_crystal_array_2_target_z;
MCNUM mccchannel_5_analyzer_1_array_crystal_array_2_focus_aw;
MCNUM mccchannel_5_analyzer_1_array_crystal_array_2_focus_ah;
MCNUM mccchannel_5_analyzer_1_array_crystal_array_2_focus_xw;
MCNUM mccchannel_5_analyzer_1_array_crystal_array_2_focus_xh;
MCNUM mccchannel_5_analyzer_1_array_crystal_array_2_focus_r;
MCNUM mccchannel_5_analyzer_1_array_crystal_array_2_p_interact;
char mccchannel_5_analyzer_1_array_crystal_array_2_mask_string[16384];
char mccchannel_5_analyzer_1_array_crystal_array_2_mask_setting[16384];
MCNUM mccchannel_5_analyzer_1_array_crystal_array_2_number_of_activations;

/* Setting parameters for component 'channel_5_analyzer_1_array_crystal_array_3' [323]. */
char mccchannel_5_analyzer_1_array_crystal_array_3_material_string[16384];
MCNUM mccchannel_5_analyzer_1_array_crystal_array_3_priority;
MCNUM mccchannel_5_analyzer_1_array_crystal_array_3_xwidth;
MCNUM mccchannel_5_analyzer_1_array_crystal_array_3_yheight;
MCNUM mccchannel_5_analyzer_1_array_crystal_array_3_zdepth;
MCNUM mccchannel_5_analyzer_1_array_crystal_array_3_xwidth2;
MCNUM mccchannel_5_analyzer_1_array_crystal_array_3_yheight2;
MCNUM mccchannel_5_analyzer_1_array_crystal_array_3_visualize;
int mccchannel_5_analyzer_1_array_crystal_array_3_target_index;
MCNUM mccchannel_5_analyzer_1_array_crystal_array_3_target_x;
MCNUM mccchannel_5_analyzer_1_array_crystal_array_3_target_y;
MCNUM mccchannel_5_analyzer_1_array_crystal_array_3_target_z;
MCNUM mccchannel_5_analyzer_1_array_crystal_array_3_focus_aw;
MCNUM mccchannel_5_analyzer_1_array_crystal_array_3_focus_ah;
MCNUM mccchannel_5_analyzer_1_array_crystal_array_3_focus_xw;
MCNUM mccchannel_5_analyzer_1_array_crystal_array_3_focus_xh;
MCNUM mccchannel_5_analyzer_1_array_crystal_array_3_focus_r;
MCNUM mccchannel_5_analyzer_1_array_crystal_array_3_p_interact;
char mccchannel_5_analyzer_1_array_crystal_array_3_mask_string[16384];
char mccchannel_5_analyzer_1_array_crystal_array_3_mask_setting[16384];
MCNUM mccchannel_5_analyzer_1_array_crystal_array_3_number_of_activations;

/* Setting parameters for component 'channel_5_analyzer_1_array_crystal_array_4' [324]. */
char mccchannel_5_analyzer_1_array_crystal_array_4_material_string[16384];
MCNUM mccchannel_5_analyzer_1_array_crystal_array_4_priority;
MCNUM mccchannel_5_analyzer_1_array_crystal_array_4_xwidth;
MCNUM mccchannel_5_analyzer_1_array_crystal_array_4_yheight;
MCNUM mccchannel_5_analyzer_1_array_crystal_array_4_zdepth;
MCNUM mccchannel_5_analyzer_1_array_crystal_array_4_xwidth2;
MCNUM mccchannel_5_analyzer_1_array_crystal_array_4_yheight2;
MCNUM mccchannel_5_analyzer_1_array_crystal_array_4_visualize;
int mccchannel_5_analyzer_1_array_crystal_array_4_target_index;
MCNUM mccchannel_5_analyzer_1_array_crystal_array_4_target_x;
MCNUM mccchannel_5_analyzer_1_array_crystal_array_4_target_y;
MCNUM mccchannel_5_analyzer_1_array_crystal_array_4_target_z;
MCNUM mccchannel_5_analyzer_1_array_crystal_array_4_focus_aw;
MCNUM mccchannel_5_analyzer_1_array_crystal_array_4_focus_ah;
MCNUM mccchannel_5_analyzer_1_array_crystal_array_4_focus_xw;
MCNUM mccchannel_5_analyzer_1_array_crystal_array_4_focus_xh;
MCNUM mccchannel_5_analyzer_1_array_crystal_array_4_focus_r;
MCNUM mccchannel_5_analyzer_1_array_crystal_array_4_p_interact;
char mccchannel_5_analyzer_1_array_crystal_array_4_mask_string[16384];
char mccchannel_5_analyzer_1_array_crystal_array_4_mask_setting[16384];
MCNUM mccchannel_5_analyzer_1_array_crystal_array_4_number_of_activations;

/* Setting parameters for component 'channel_5_analyzer_1_array_crystal_array_5' [325]. */
char mccchannel_5_analyzer_1_array_crystal_array_5_material_string[16384];
MCNUM mccchannel_5_analyzer_1_array_crystal_array_5_priority;
MCNUM mccchannel_5_analyzer_1_array_crystal_array_5_xwidth;
MCNUM mccchannel_5_analyzer_1_array_crystal_array_5_yheight;
MCNUM mccchannel_5_analyzer_1_array_crystal_array_5_zdepth;
MCNUM mccchannel_5_analyzer_1_array_crystal_array_5_xwidth2;
MCNUM mccchannel_5_analyzer_1_array_crystal_array_5_yheight2;
MCNUM mccchannel_5_analyzer_1_array_crystal_array_5_visualize;
int mccchannel_5_analyzer_1_array_crystal_array_5_target_index;
MCNUM mccchannel_5_analyzer_1_array_crystal_array_5_target_x;
MCNUM mccchannel_5_analyzer_1_array_crystal_array_5_target_y;
MCNUM mccchannel_5_analyzer_1_array_crystal_array_5_target_z;
MCNUM mccchannel_5_analyzer_1_array_crystal_array_5_focus_aw;
MCNUM mccchannel_5_analyzer_1_array_crystal_array_5_focus_ah;
MCNUM mccchannel_5_analyzer_1_array_crystal_array_5_focus_xw;
MCNUM mccchannel_5_analyzer_1_array_crystal_array_5_focus_xh;
MCNUM mccchannel_5_analyzer_1_array_crystal_array_5_focus_r;
MCNUM mccchannel_5_analyzer_1_array_crystal_array_5_p_interact;
char mccchannel_5_analyzer_1_array_crystal_array_5_mask_string[16384];
char mccchannel_5_analyzer_1_array_crystal_array_5_mask_setting[16384];
MCNUM mccchannel_5_analyzer_1_array_crystal_array_5_number_of_activations;

/* Setting parameters for component 'channel_5_analyzer_1_array_crystal_array_6' [326]. */
char mccchannel_5_analyzer_1_array_crystal_array_6_material_string[16384];
MCNUM mccchannel_5_analyzer_1_array_crystal_array_6_priority;
MCNUM mccchannel_5_analyzer_1_array_crystal_array_6_xwidth;
MCNUM mccchannel_5_analyzer_1_array_crystal_array_6_yheight;
MCNUM mccchannel_5_analyzer_1_array_crystal_array_6_zdepth;
MCNUM mccchannel_5_analyzer_1_array_crystal_array_6_xwidth2;
MCNUM mccchannel_5_analyzer_1_array_crystal_array_6_yheight2;
MCNUM mccchannel_5_analyzer_1_array_crystal_array_6_visualize;
int mccchannel_5_analyzer_1_array_crystal_array_6_target_index;
MCNUM mccchannel_5_analyzer_1_array_crystal_array_6_target_x;
MCNUM mccchannel_5_analyzer_1_array_crystal_array_6_target_y;
MCNUM mccchannel_5_analyzer_1_array_crystal_array_6_target_z;
MCNUM mccchannel_5_analyzer_1_array_crystal_array_6_focus_aw;
MCNUM mccchannel_5_analyzer_1_array_crystal_array_6_focus_ah;
MCNUM mccchannel_5_analyzer_1_array_crystal_array_6_focus_xw;
MCNUM mccchannel_5_analyzer_1_array_crystal_array_6_focus_xh;
MCNUM mccchannel_5_analyzer_1_array_crystal_array_6_focus_r;
MCNUM mccchannel_5_analyzer_1_array_crystal_array_6_p_interact;
char mccchannel_5_analyzer_1_array_crystal_array_6_mask_string[16384];
char mccchannel_5_analyzer_1_array_crystal_array_6_mask_setting[16384];
MCNUM mccchannel_5_analyzer_1_array_crystal_array_6_number_of_activations;

/* Setting parameters for component 'channel_5_analyzer_1_array_crystal_array_7' [327]. */
char mccchannel_5_analyzer_1_array_crystal_array_7_material_string[16384];
MCNUM mccchannel_5_analyzer_1_array_crystal_array_7_priority;
MCNUM mccchannel_5_analyzer_1_array_crystal_array_7_xwidth;
MCNUM mccchannel_5_analyzer_1_array_crystal_array_7_yheight;
MCNUM mccchannel_5_analyzer_1_array_crystal_array_7_zdepth;
MCNUM mccchannel_5_analyzer_1_array_crystal_array_7_xwidth2;
MCNUM mccchannel_5_analyzer_1_array_crystal_array_7_yheight2;
MCNUM mccchannel_5_analyzer_1_array_crystal_array_7_visualize;
int mccchannel_5_analyzer_1_array_crystal_array_7_target_index;
MCNUM mccchannel_5_analyzer_1_array_crystal_array_7_target_x;
MCNUM mccchannel_5_analyzer_1_array_crystal_array_7_target_y;
MCNUM mccchannel_5_analyzer_1_array_crystal_array_7_target_z;
MCNUM mccchannel_5_analyzer_1_array_crystal_array_7_focus_aw;
MCNUM mccchannel_5_analyzer_1_array_crystal_array_7_focus_ah;
MCNUM mccchannel_5_analyzer_1_array_crystal_array_7_focus_xw;
MCNUM mccchannel_5_analyzer_1_array_crystal_array_7_focus_xh;
MCNUM mccchannel_5_analyzer_1_array_crystal_array_7_focus_r;
MCNUM mccchannel_5_analyzer_1_array_crystal_array_7_p_interact;
char mccchannel_5_analyzer_1_array_crystal_array_7_mask_string[16384];
char mccchannel_5_analyzer_1_array_crystal_array_7_mask_setting[16384];
MCNUM mccchannel_5_analyzer_1_array_crystal_array_7_number_of_activations;

/* Setting parameters for component 'channel_5_analyzer_1_array_crystal_array_8' [328]. */
char mccchannel_5_analyzer_1_array_crystal_array_8_material_string[16384];
MCNUM mccchannel_5_analyzer_1_array_crystal_array_8_priority;
MCNUM mccchannel_5_analyzer_1_array_crystal_array_8_xwidth;
MCNUM mccchannel_5_analyzer_1_array_crystal_array_8_yheight;
MCNUM mccchannel_5_analyzer_1_array_crystal_array_8_zdepth;
MCNUM mccchannel_5_analyzer_1_array_crystal_array_8_xwidth2;
MCNUM mccchannel_5_analyzer_1_array_crystal_array_8_yheight2;
MCNUM mccchannel_5_analyzer_1_array_crystal_array_8_visualize;
int mccchannel_5_analyzer_1_array_crystal_array_8_target_index;
MCNUM mccchannel_5_analyzer_1_array_crystal_array_8_target_x;
MCNUM mccchannel_5_analyzer_1_array_crystal_array_8_target_y;
MCNUM mccchannel_5_analyzer_1_array_crystal_array_8_target_z;
MCNUM mccchannel_5_analyzer_1_array_crystal_array_8_focus_aw;
MCNUM mccchannel_5_analyzer_1_array_crystal_array_8_focus_ah;
MCNUM mccchannel_5_analyzer_1_array_crystal_array_8_focus_xw;
MCNUM mccchannel_5_analyzer_1_array_crystal_array_8_focus_xh;
MCNUM mccchannel_5_analyzer_1_array_crystal_array_8_focus_r;
MCNUM mccchannel_5_analyzer_1_array_crystal_array_8_p_interact;
char mccchannel_5_analyzer_1_array_crystal_array_8_mask_string[16384];
char mccchannel_5_analyzer_1_array_crystal_array_8_mask_setting[16384];
MCNUM mccchannel_5_analyzer_1_array_crystal_array_8_number_of_activations;

/* Setting parameters for component 'channel_5_analyzer_2_array_crystal_array_0' [331]. */
char mccchannel_5_analyzer_2_array_crystal_array_0_material_string[16384];
MCNUM mccchannel_5_analyzer_2_array_crystal_array_0_priority;
MCNUM mccchannel_5_analyzer_2_array_crystal_array_0_xwidth;
MCNUM mccchannel_5_analyzer_2_array_crystal_array_0_yheight;
MCNUM mccchannel_5_analyzer_2_array_crystal_array_0_zdepth;
MCNUM mccchannel_5_analyzer_2_array_crystal_array_0_xwidth2;
MCNUM mccchannel_5_analyzer_2_array_crystal_array_0_yheight2;
MCNUM mccchannel_5_analyzer_2_array_crystal_array_0_visualize;
int mccchannel_5_analyzer_2_array_crystal_array_0_target_index;
MCNUM mccchannel_5_analyzer_2_array_crystal_array_0_target_x;
MCNUM mccchannel_5_analyzer_2_array_crystal_array_0_target_y;
MCNUM mccchannel_5_analyzer_2_array_crystal_array_0_target_z;
MCNUM mccchannel_5_analyzer_2_array_crystal_array_0_focus_aw;
MCNUM mccchannel_5_analyzer_2_array_crystal_array_0_focus_ah;
MCNUM mccchannel_5_analyzer_2_array_crystal_array_0_focus_xw;
MCNUM mccchannel_5_analyzer_2_array_crystal_array_0_focus_xh;
MCNUM mccchannel_5_analyzer_2_array_crystal_array_0_focus_r;
MCNUM mccchannel_5_analyzer_2_array_crystal_array_0_p_interact;
char mccchannel_5_analyzer_2_array_crystal_array_0_mask_string[16384];
char mccchannel_5_analyzer_2_array_crystal_array_0_mask_setting[16384];
MCNUM mccchannel_5_analyzer_2_array_crystal_array_0_number_of_activations;

/* Setting parameters for component 'channel_5_analyzer_2_array_crystal_array_1' [332]. */
char mccchannel_5_analyzer_2_array_crystal_array_1_material_string[16384];
MCNUM mccchannel_5_analyzer_2_array_crystal_array_1_priority;
MCNUM mccchannel_5_analyzer_2_array_crystal_array_1_xwidth;
MCNUM mccchannel_5_analyzer_2_array_crystal_array_1_yheight;
MCNUM mccchannel_5_analyzer_2_array_crystal_array_1_zdepth;
MCNUM mccchannel_5_analyzer_2_array_crystal_array_1_xwidth2;
MCNUM mccchannel_5_analyzer_2_array_crystal_array_1_yheight2;
MCNUM mccchannel_5_analyzer_2_array_crystal_array_1_visualize;
int mccchannel_5_analyzer_2_array_crystal_array_1_target_index;
MCNUM mccchannel_5_analyzer_2_array_crystal_array_1_target_x;
MCNUM mccchannel_5_analyzer_2_array_crystal_array_1_target_y;
MCNUM mccchannel_5_analyzer_2_array_crystal_array_1_target_z;
MCNUM mccchannel_5_analyzer_2_array_crystal_array_1_focus_aw;
MCNUM mccchannel_5_analyzer_2_array_crystal_array_1_focus_ah;
MCNUM mccchannel_5_analyzer_2_array_crystal_array_1_focus_xw;
MCNUM mccchannel_5_analyzer_2_array_crystal_array_1_focus_xh;
MCNUM mccchannel_5_analyzer_2_array_crystal_array_1_focus_r;
MCNUM mccchannel_5_analyzer_2_array_crystal_array_1_p_interact;
char mccchannel_5_analyzer_2_array_crystal_array_1_mask_string[16384];
char mccchannel_5_analyzer_2_array_crystal_array_1_mask_setting[16384];
MCNUM mccchannel_5_analyzer_2_array_crystal_array_1_number_of_activations;

/* Setting parameters for component 'channel_5_analyzer_2_array_crystal_array_2' [333]. */
char mccchannel_5_analyzer_2_array_crystal_array_2_material_string[16384];
MCNUM mccchannel_5_analyzer_2_array_crystal_array_2_priority;
MCNUM mccchannel_5_analyzer_2_array_crystal_array_2_xwidth;
MCNUM mccchannel_5_analyzer_2_array_crystal_array_2_yheight;
MCNUM mccchannel_5_analyzer_2_array_crystal_array_2_zdepth;
MCNUM mccchannel_5_analyzer_2_array_crystal_array_2_xwidth2;
MCNUM mccchannel_5_analyzer_2_array_crystal_array_2_yheight2;
MCNUM mccchannel_5_analyzer_2_array_crystal_array_2_visualize;
int mccchannel_5_analyzer_2_array_crystal_array_2_target_index;
MCNUM mccchannel_5_analyzer_2_array_crystal_array_2_target_x;
MCNUM mccchannel_5_analyzer_2_array_crystal_array_2_target_y;
MCNUM mccchannel_5_analyzer_2_array_crystal_array_2_target_z;
MCNUM mccchannel_5_analyzer_2_array_crystal_array_2_focus_aw;
MCNUM mccchannel_5_analyzer_2_array_crystal_array_2_focus_ah;
MCNUM mccchannel_5_analyzer_2_array_crystal_array_2_focus_xw;
MCNUM mccchannel_5_analyzer_2_array_crystal_array_2_focus_xh;
MCNUM mccchannel_5_analyzer_2_array_crystal_array_2_focus_r;
MCNUM mccchannel_5_analyzer_2_array_crystal_array_2_p_interact;
char mccchannel_5_analyzer_2_array_crystal_array_2_mask_string[16384];
char mccchannel_5_analyzer_2_array_crystal_array_2_mask_setting[16384];
MCNUM mccchannel_5_analyzer_2_array_crystal_array_2_number_of_activations;

/* Setting parameters for component 'channel_5_analyzer_2_array_crystal_array_3' [334]. */
char mccchannel_5_analyzer_2_array_crystal_array_3_material_string[16384];
MCNUM mccchannel_5_analyzer_2_array_crystal_array_3_priority;
MCNUM mccchannel_5_analyzer_2_array_crystal_array_3_xwidth;
MCNUM mccchannel_5_analyzer_2_array_crystal_array_3_yheight;
MCNUM mccchannel_5_analyzer_2_array_crystal_array_3_zdepth;
MCNUM mccchannel_5_analyzer_2_array_crystal_array_3_xwidth2;
MCNUM mccchannel_5_analyzer_2_array_crystal_array_3_yheight2;
MCNUM mccchannel_5_analyzer_2_array_crystal_array_3_visualize;
int mccchannel_5_analyzer_2_array_crystal_array_3_target_index;
MCNUM mccchannel_5_analyzer_2_array_crystal_array_3_target_x;
MCNUM mccchannel_5_analyzer_2_array_crystal_array_3_target_y;
MCNUM mccchannel_5_analyzer_2_array_crystal_array_3_target_z;
MCNUM mccchannel_5_analyzer_2_array_crystal_array_3_focus_aw;
MCNUM mccchannel_5_analyzer_2_array_crystal_array_3_focus_ah;
MCNUM mccchannel_5_analyzer_2_array_crystal_array_3_focus_xw;
MCNUM mccchannel_5_analyzer_2_array_crystal_array_3_focus_xh;
MCNUM mccchannel_5_analyzer_2_array_crystal_array_3_focus_r;
MCNUM mccchannel_5_analyzer_2_array_crystal_array_3_p_interact;
char mccchannel_5_analyzer_2_array_crystal_array_3_mask_string[16384];
char mccchannel_5_analyzer_2_array_crystal_array_3_mask_setting[16384];
MCNUM mccchannel_5_analyzer_2_array_crystal_array_3_number_of_activations;

/* Setting parameters for component 'channel_5_analyzer_2_array_crystal_array_4' [335]. */
char mccchannel_5_analyzer_2_array_crystal_array_4_material_string[16384];
MCNUM mccchannel_5_analyzer_2_array_crystal_array_4_priority;
MCNUM mccchannel_5_analyzer_2_array_crystal_array_4_xwidth;
MCNUM mccchannel_5_analyzer_2_array_crystal_array_4_yheight;
MCNUM mccchannel_5_analyzer_2_array_crystal_array_4_zdepth;
MCNUM mccchannel_5_analyzer_2_array_crystal_array_4_xwidth2;
MCNUM mccchannel_5_analyzer_2_array_crystal_array_4_yheight2;
MCNUM mccchannel_5_analyzer_2_array_crystal_array_4_visualize;
int mccchannel_5_analyzer_2_array_crystal_array_4_target_index;
MCNUM mccchannel_5_analyzer_2_array_crystal_array_4_target_x;
MCNUM mccchannel_5_analyzer_2_array_crystal_array_4_target_y;
MCNUM mccchannel_5_analyzer_2_array_crystal_array_4_target_z;
MCNUM mccchannel_5_analyzer_2_array_crystal_array_4_focus_aw;
MCNUM mccchannel_5_analyzer_2_array_crystal_array_4_focus_ah;
MCNUM mccchannel_5_analyzer_2_array_crystal_array_4_focus_xw;
MCNUM mccchannel_5_analyzer_2_array_crystal_array_4_focus_xh;
MCNUM mccchannel_5_analyzer_2_array_crystal_array_4_focus_r;
MCNUM mccchannel_5_analyzer_2_array_crystal_array_4_p_interact;
char mccchannel_5_analyzer_2_array_crystal_array_4_mask_string[16384];
char mccchannel_5_analyzer_2_array_crystal_array_4_mask_setting[16384];
MCNUM mccchannel_5_analyzer_2_array_crystal_array_4_number_of_activations;

/* Setting parameters for component 'channel_5_analyzer_2_array_crystal_array_5' [336]. */
char mccchannel_5_analyzer_2_array_crystal_array_5_material_string[16384];
MCNUM mccchannel_5_analyzer_2_array_crystal_array_5_priority;
MCNUM mccchannel_5_analyzer_2_array_crystal_array_5_xwidth;
MCNUM mccchannel_5_analyzer_2_array_crystal_array_5_yheight;
MCNUM mccchannel_5_analyzer_2_array_crystal_array_5_zdepth;
MCNUM mccchannel_5_analyzer_2_array_crystal_array_5_xwidth2;
MCNUM mccchannel_5_analyzer_2_array_crystal_array_5_yheight2;
MCNUM mccchannel_5_analyzer_2_array_crystal_array_5_visualize;
int mccchannel_5_analyzer_2_array_crystal_array_5_target_index;
MCNUM mccchannel_5_analyzer_2_array_crystal_array_5_target_x;
MCNUM mccchannel_5_analyzer_2_array_crystal_array_5_target_y;
MCNUM mccchannel_5_analyzer_2_array_crystal_array_5_target_z;
MCNUM mccchannel_5_analyzer_2_array_crystal_array_5_focus_aw;
MCNUM mccchannel_5_analyzer_2_array_crystal_array_5_focus_ah;
MCNUM mccchannel_5_analyzer_2_array_crystal_array_5_focus_xw;
MCNUM mccchannel_5_analyzer_2_array_crystal_array_5_focus_xh;
MCNUM mccchannel_5_analyzer_2_array_crystal_array_5_focus_r;
MCNUM mccchannel_5_analyzer_2_array_crystal_array_5_p_interact;
char mccchannel_5_analyzer_2_array_crystal_array_5_mask_string[16384];
char mccchannel_5_analyzer_2_array_crystal_array_5_mask_setting[16384];
MCNUM mccchannel_5_analyzer_2_array_crystal_array_5_number_of_activations;

/* Setting parameters for component 'channel_5_analyzer_2_array_crystal_array_6' [337]. */
char mccchannel_5_analyzer_2_array_crystal_array_6_material_string[16384];
MCNUM mccchannel_5_analyzer_2_array_crystal_array_6_priority;
MCNUM mccchannel_5_analyzer_2_array_crystal_array_6_xwidth;
MCNUM mccchannel_5_analyzer_2_array_crystal_array_6_yheight;
MCNUM mccchannel_5_analyzer_2_array_crystal_array_6_zdepth;
MCNUM mccchannel_5_analyzer_2_array_crystal_array_6_xwidth2;
MCNUM mccchannel_5_analyzer_2_array_crystal_array_6_yheight2;
MCNUM mccchannel_5_analyzer_2_array_crystal_array_6_visualize;
int mccchannel_5_analyzer_2_array_crystal_array_6_target_index;
MCNUM mccchannel_5_analyzer_2_array_crystal_array_6_target_x;
MCNUM mccchannel_5_analyzer_2_array_crystal_array_6_target_y;
MCNUM mccchannel_5_analyzer_2_array_crystal_array_6_target_z;
MCNUM mccchannel_5_analyzer_2_array_crystal_array_6_focus_aw;
MCNUM mccchannel_5_analyzer_2_array_crystal_array_6_focus_ah;
MCNUM mccchannel_5_analyzer_2_array_crystal_array_6_focus_xw;
MCNUM mccchannel_5_analyzer_2_array_crystal_array_6_focus_xh;
MCNUM mccchannel_5_analyzer_2_array_crystal_array_6_focus_r;
MCNUM mccchannel_5_analyzer_2_array_crystal_array_6_p_interact;
char mccchannel_5_analyzer_2_array_crystal_array_6_mask_string[16384];
char mccchannel_5_analyzer_2_array_crystal_array_6_mask_setting[16384];
MCNUM mccchannel_5_analyzer_2_array_crystal_array_6_number_of_activations;

/* Setting parameters for component 'channel_5_analyzer_2_array_crystal_array_7' [338]. */
char mccchannel_5_analyzer_2_array_crystal_array_7_material_string[16384];
MCNUM mccchannel_5_analyzer_2_array_crystal_array_7_priority;
MCNUM mccchannel_5_analyzer_2_array_crystal_array_7_xwidth;
MCNUM mccchannel_5_analyzer_2_array_crystal_array_7_yheight;
MCNUM mccchannel_5_analyzer_2_array_crystal_array_7_zdepth;
MCNUM mccchannel_5_analyzer_2_array_crystal_array_7_xwidth2;
MCNUM mccchannel_5_analyzer_2_array_crystal_array_7_yheight2;
MCNUM mccchannel_5_analyzer_2_array_crystal_array_7_visualize;
int mccchannel_5_analyzer_2_array_crystal_array_7_target_index;
MCNUM mccchannel_5_analyzer_2_array_crystal_array_7_target_x;
MCNUM mccchannel_5_analyzer_2_array_crystal_array_7_target_y;
MCNUM mccchannel_5_analyzer_2_array_crystal_array_7_target_z;
MCNUM mccchannel_5_analyzer_2_array_crystal_array_7_focus_aw;
MCNUM mccchannel_5_analyzer_2_array_crystal_array_7_focus_ah;
MCNUM mccchannel_5_analyzer_2_array_crystal_array_7_focus_xw;
MCNUM mccchannel_5_analyzer_2_array_crystal_array_7_focus_xh;
MCNUM mccchannel_5_analyzer_2_array_crystal_array_7_focus_r;
MCNUM mccchannel_5_analyzer_2_array_crystal_array_7_p_interact;
char mccchannel_5_analyzer_2_array_crystal_array_7_mask_string[16384];
char mccchannel_5_analyzer_2_array_crystal_array_7_mask_setting[16384];
MCNUM mccchannel_5_analyzer_2_array_crystal_array_7_number_of_activations;

/* Setting parameters for component 'channel_5_analyzer_2_array_crystal_array_8' [339]. */
char mccchannel_5_analyzer_2_array_crystal_array_8_material_string[16384];
MCNUM mccchannel_5_analyzer_2_array_crystal_array_8_priority;
MCNUM mccchannel_5_analyzer_2_array_crystal_array_8_xwidth;
MCNUM mccchannel_5_analyzer_2_array_crystal_array_8_yheight;
MCNUM mccchannel_5_analyzer_2_array_crystal_array_8_zdepth;
MCNUM mccchannel_5_analyzer_2_array_crystal_array_8_xwidth2;
MCNUM mccchannel_5_analyzer_2_array_crystal_array_8_yheight2;
MCNUM mccchannel_5_analyzer_2_array_crystal_array_8_visualize;
int mccchannel_5_analyzer_2_array_crystal_array_8_target_index;
MCNUM mccchannel_5_analyzer_2_array_crystal_array_8_target_x;
MCNUM mccchannel_5_analyzer_2_array_crystal_array_8_target_y;
MCNUM mccchannel_5_analyzer_2_array_crystal_array_8_target_z;
MCNUM mccchannel_5_analyzer_2_array_crystal_array_8_focus_aw;
MCNUM mccchannel_5_analyzer_2_array_crystal_array_8_focus_ah;
MCNUM mccchannel_5_analyzer_2_array_crystal_array_8_focus_xw;
MCNUM mccchannel_5_analyzer_2_array_crystal_array_8_focus_xh;
MCNUM mccchannel_5_analyzer_2_array_crystal_array_8_focus_r;
MCNUM mccchannel_5_analyzer_2_array_crystal_array_8_p_interact;
char mccchannel_5_analyzer_2_array_crystal_array_8_mask_string[16384];
char mccchannel_5_analyzer_2_array_crystal_array_8_mask_setting[16384];
MCNUM mccchannel_5_analyzer_2_array_crystal_array_8_number_of_activations;

/* Setting parameters for component 'channel_5_cave2_cyl1' [340]. */
char mccchannel_5_cave2_cyl1_material_string[16384];
MCNUM mccchannel_5_cave2_cyl1_priority;
MCNUM mccchannel_5_cave2_cyl1_radius;
MCNUM mccchannel_5_cave2_cyl1_yheight;
MCNUM mccchannel_5_cave2_cyl1_visualize;
int mccchannel_5_cave2_cyl1_target_index;
MCNUM mccchannel_5_cave2_cyl1_target_x;
MCNUM mccchannel_5_cave2_cyl1_target_y;
MCNUM mccchannel_5_cave2_cyl1_target_z;
MCNUM mccchannel_5_cave2_cyl1_focus_aw;
MCNUM mccchannel_5_cave2_cyl1_focus_ah;
MCNUM mccchannel_5_cave2_cyl1_focus_xw;
MCNUM mccchannel_5_cave2_cyl1_focus_xh;
MCNUM mccchannel_5_cave2_cyl1_focus_r;
MCNUM mccchannel_5_cave2_cyl1_p_interact;
char mccchannel_5_cave2_cyl1_mask_string[16384];
char mccchannel_5_cave2_cyl1_mask_setting[16384];
MCNUM mccchannel_5_cave2_cyl1_number_of_activations;

/* Setting parameters for component 'channel_5_cave2_box1' [341]. */
char mccchannel_5_cave2_box1_material_string[16384];
MCNUM mccchannel_5_cave2_box1_priority;
MCNUM mccchannel_5_cave2_box1_xwidth;
MCNUM mccchannel_5_cave2_box1_yheight;
MCNUM mccchannel_5_cave2_box1_zdepth;
MCNUM mccchannel_5_cave2_box1_xwidth2;
MCNUM mccchannel_5_cave2_box1_yheight2;
MCNUM mccchannel_5_cave2_box1_visualize;
int mccchannel_5_cave2_box1_target_index;
MCNUM mccchannel_5_cave2_box1_target_x;
MCNUM mccchannel_5_cave2_box1_target_y;
MCNUM mccchannel_5_cave2_box1_target_z;
MCNUM mccchannel_5_cave2_box1_focus_aw;
MCNUM mccchannel_5_cave2_box1_focus_ah;
MCNUM mccchannel_5_cave2_box1_focus_xw;
MCNUM mccchannel_5_cave2_box1_focus_xh;
MCNUM mccchannel_5_cave2_box1_focus_r;
MCNUM mccchannel_5_cave2_box1_p_interact;
char mccchannel_5_cave2_box1_mask_string[16384];
char mccchannel_5_cave2_box1_mask_setting[16384];
MCNUM mccchannel_5_cave2_box1_number_of_activations;

/* Setting parameters for component 'channel_5_cave2_box2' [342]. */
char mccchannel_5_cave2_box2_material_string[16384];
MCNUM mccchannel_5_cave2_box2_priority;
MCNUM mccchannel_5_cave2_box2_xwidth;
MCNUM mccchannel_5_cave2_box2_yheight;
MCNUM mccchannel_5_cave2_box2_zdepth;
MCNUM mccchannel_5_cave2_box2_xwidth2;
MCNUM mccchannel_5_cave2_box2_yheight2;
MCNUM mccchannel_5_cave2_box2_visualize;
int mccchannel_5_cave2_box2_target_index;
MCNUM mccchannel_5_cave2_box2_target_x;
MCNUM mccchannel_5_cave2_box2_target_y;
MCNUM mccchannel_5_cave2_box2_target_z;
MCNUM mccchannel_5_cave2_box2_focus_aw;
MCNUM mccchannel_5_cave2_box2_focus_ah;
MCNUM mccchannel_5_cave2_box2_focus_xw;
MCNUM mccchannel_5_cave2_box2_focus_xh;
MCNUM mccchannel_5_cave2_box2_focus_r;
MCNUM mccchannel_5_cave2_box2_p_interact;
char mccchannel_5_cave2_box2_mask_string[16384];
char mccchannel_5_cave2_box2_mask_setting[16384];
MCNUM mccchannel_5_cave2_box2_number_of_activations;

/* Setting parameters for component 'channel_5_cave2_box3' [343]. */
char mccchannel_5_cave2_box3_material_string[16384];
MCNUM mccchannel_5_cave2_box3_priority;
MCNUM mccchannel_5_cave2_box3_xwidth;
MCNUM mccchannel_5_cave2_box3_yheight;
MCNUM mccchannel_5_cave2_box3_zdepth;
MCNUM mccchannel_5_cave2_box3_xwidth2;
MCNUM mccchannel_5_cave2_box3_yheight2;
MCNUM mccchannel_5_cave2_box3_visualize;
int mccchannel_5_cave2_box3_target_index;
MCNUM mccchannel_5_cave2_box3_target_x;
MCNUM mccchannel_5_cave2_box3_target_y;
MCNUM mccchannel_5_cave2_box3_target_z;
MCNUM mccchannel_5_cave2_box3_focus_aw;
MCNUM mccchannel_5_cave2_box3_focus_ah;
MCNUM mccchannel_5_cave2_box3_focus_xw;
MCNUM mccchannel_5_cave2_box3_focus_xh;
MCNUM mccchannel_5_cave2_box3_focus_r;
MCNUM mccchannel_5_cave2_box3_p_interact;
char mccchannel_5_cave2_box3_mask_string[16384];
char mccchannel_5_cave2_box3_mask_setting[16384];
MCNUM mccchannel_5_cave2_box3_number_of_activations;

/* Setting parameters for component 'inter_analyzer_colimator_5_blade_0' [345]. */
char mccinter_analyzer_colimator_5_blade_0_material_string[16384];
MCNUM mccinter_analyzer_colimator_5_blade_0_priority;
MCNUM mccinter_analyzer_colimator_5_blade_0_xwidth;
MCNUM mccinter_analyzer_colimator_5_blade_0_yheight;
MCNUM mccinter_analyzer_colimator_5_blade_0_zdepth;
MCNUM mccinter_analyzer_colimator_5_blade_0_xwidth2;
MCNUM mccinter_analyzer_colimator_5_blade_0_yheight2;
MCNUM mccinter_analyzer_colimator_5_blade_0_visualize;
int mccinter_analyzer_colimator_5_blade_0_target_index;
MCNUM mccinter_analyzer_colimator_5_blade_0_target_x;
MCNUM mccinter_analyzer_colimator_5_blade_0_target_y;
MCNUM mccinter_analyzer_colimator_5_blade_0_target_z;
MCNUM mccinter_analyzer_colimator_5_blade_0_focus_aw;
MCNUM mccinter_analyzer_colimator_5_blade_0_focus_ah;
MCNUM mccinter_analyzer_colimator_5_blade_0_focus_xw;
MCNUM mccinter_analyzer_colimator_5_blade_0_focus_xh;
MCNUM mccinter_analyzer_colimator_5_blade_0_focus_r;
MCNUM mccinter_analyzer_colimator_5_blade_0_p_interact;
char mccinter_analyzer_colimator_5_blade_0_mask_string[16384];
char mccinter_analyzer_colimator_5_blade_0_mask_setting[16384];
MCNUM mccinter_analyzer_colimator_5_blade_0_number_of_activations;

/* Setting parameters for component 'inter_analyzer_colimator_5_blade_1' [346]. */
char mccinter_analyzer_colimator_5_blade_1_material_string[16384];
MCNUM mccinter_analyzer_colimator_5_blade_1_priority;
MCNUM mccinter_analyzer_colimator_5_blade_1_xwidth;
MCNUM mccinter_analyzer_colimator_5_blade_1_yheight;
MCNUM mccinter_analyzer_colimator_5_blade_1_zdepth;
MCNUM mccinter_analyzer_colimator_5_blade_1_xwidth2;
MCNUM mccinter_analyzer_colimator_5_blade_1_yheight2;
MCNUM mccinter_analyzer_colimator_5_blade_1_visualize;
int mccinter_analyzer_colimator_5_blade_1_target_index;
MCNUM mccinter_analyzer_colimator_5_blade_1_target_x;
MCNUM mccinter_analyzer_colimator_5_blade_1_target_y;
MCNUM mccinter_analyzer_colimator_5_blade_1_target_z;
MCNUM mccinter_analyzer_colimator_5_blade_1_focus_aw;
MCNUM mccinter_analyzer_colimator_5_blade_1_focus_ah;
MCNUM mccinter_analyzer_colimator_5_blade_1_focus_xw;
MCNUM mccinter_analyzer_colimator_5_blade_1_focus_xh;
MCNUM mccinter_analyzer_colimator_5_blade_1_focus_r;
MCNUM mccinter_analyzer_colimator_5_blade_1_p_interact;
char mccinter_analyzer_colimator_5_blade_1_mask_string[16384];
char mccinter_analyzer_colimator_5_blade_1_mask_setting[16384];
MCNUM mccinter_analyzer_colimator_5_blade_1_number_of_activations;

/* Setting parameters for component 'inter_analyzer_colimator_5_blade_2' [347]. */
char mccinter_analyzer_colimator_5_blade_2_material_string[16384];
MCNUM mccinter_analyzer_colimator_5_blade_2_priority;
MCNUM mccinter_analyzer_colimator_5_blade_2_xwidth;
MCNUM mccinter_analyzer_colimator_5_blade_2_yheight;
MCNUM mccinter_analyzer_colimator_5_blade_2_zdepth;
MCNUM mccinter_analyzer_colimator_5_blade_2_xwidth2;
MCNUM mccinter_analyzer_colimator_5_blade_2_yheight2;
MCNUM mccinter_analyzer_colimator_5_blade_2_visualize;
int mccinter_analyzer_colimator_5_blade_2_target_index;
MCNUM mccinter_analyzer_colimator_5_blade_2_target_x;
MCNUM mccinter_analyzer_colimator_5_blade_2_target_y;
MCNUM mccinter_analyzer_colimator_5_blade_2_target_z;
MCNUM mccinter_analyzer_colimator_5_blade_2_focus_aw;
MCNUM mccinter_analyzer_colimator_5_blade_2_focus_ah;
MCNUM mccinter_analyzer_colimator_5_blade_2_focus_xw;
MCNUM mccinter_analyzer_colimator_5_blade_2_focus_xh;
MCNUM mccinter_analyzer_colimator_5_blade_2_focus_r;
MCNUM mccinter_analyzer_colimator_5_blade_2_p_interact;
char mccinter_analyzer_colimator_5_blade_2_mask_string[16384];
char mccinter_analyzer_colimator_5_blade_2_mask_setting[16384];
MCNUM mccinter_analyzer_colimator_5_blade_2_number_of_activations;

/* Setting parameters for component 'inter_analyzer_colimator_5_blade_3' [348]. */
char mccinter_analyzer_colimator_5_blade_3_material_string[16384];
MCNUM mccinter_analyzer_colimator_5_blade_3_priority;
MCNUM mccinter_analyzer_colimator_5_blade_3_xwidth;
MCNUM mccinter_analyzer_colimator_5_blade_3_yheight;
MCNUM mccinter_analyzer_colimator_5_blade_3_zdepth;
MCNUM mccinter_analyzer_colimator_5_blade_3_xwidth2;
MCNUM mccinter_analyzer_colimator_5_blade_3_yheight2;
MCNUM mccinter_analyzer_colimator_5_blade_3_visualize;
int mccinter_analyzer_colimator_5_blade_3_target_index;
MCNUM mccinter_analyzer_colimator_5_blade_3_target_x;
MCNUM mccinter_analyzer_colimator_5_blade_3_target_y;
MCNUM mccinter_analyzer_colimator_5_blade_3_target_z;
MCNUM mccinter_analyzer_colimator_5_blade_3_focus_aw;
MCNUM mccinter_analyzer_colimator_5_blade_3_focus_ah;
MCNUM mccinter_analyzer_colimator_5_blade_3_focus_xw;
MCNUM mccinter_analyzer_colimator_5_blade_3_focus_xh;
MCNUM mccinter_analyzer_colimator_5_blade_3_focus_r;
MCNUM mccinter_analyzer_colimator_5_blade_3_p_interact;
char mccinter_analyzer_colimator_5_blade_3_mask_string[16384];
char mccinter_analyzer_colimator_5_blade_3_mask_setting[16384];
MCNUM mccinter_analyzer_colimator_5_blade_3_number_of_activations;

/* Setting parameters for component 'inter_analyzer_colimator_5_blade_4' [349]. */
char mccinter_analyzer_colimator_5_blade_4_material_string[16384];
MCNUM mccinter_analyzer_colimator_5_blade_4_priority;
MCNUM mccinter_analyzer_colimator_5_blade_4_xwidth;
MCNUM mccinter_analyzer_colimator_5_blade_4_yheight;
MCNUM mccinter_analyzer_colimator_5_blade_4_zdepth;
MCNUM mccinter_analyzer_colimator_5_blade_4_xwidth2;
MCNUM mccinter_analyzer_colimator_5_blade_4_yheight2;
MCNUM mccinter_analyzer_colimator_5_blade_4_visualize;
int mccinter_analyzer_colimator_5_blade_4_target_index;
MCNUM mccinter_analyzer_colimator_5_blade_4_target_x;
MCNUM mccinter_analyzer_colimator_5_blade_4_target_y;
MCNUM mccinter_analyzer_colimator_5_blade_4_target_z;
MCNUM mccinter_analyzer_colimator_5_blade_4_focus_aw;
MCNUM mccinter_analyzer_colimator_5_blade_4_focus_ah;
MCNUM mccinter_analyzer_colimator_5_blade_4_focus_xw;
MCNUM mccinter_analyzer_colimator_5_blade_4_focus_xh;
MCNUM mccinter_analyzer_colimator_5_blade_4_focus_r;
MCNUM mccinter_analyzer_colimator_5_blade_4_p_interact;
char mccinter_analyzer_colimator_5_blade_4_mask_string[16384];
char mccinter_analyzer_colimator_5_blade_4_mask_setting[16384];
MCNUM mccinter_analyzer_colimator_5_blade_4_number_of_activations;

/* Setting parameters for component 'diffraction_detector_5_exit_volume' [350]. */
char mccdiffraction_detector_5_exit_volume_material_string[16384];
MCNUM mccdiffraction_detector_5_exit_volume_priority;
MCNUM mccdiffraction_detector_5_exit_volume_xwidth;
MCNUM mccdiffraction_detector_5_exit_volume_yheight;
MCNUM mccdiffraction_detector_5_exit_volume_zdepth;
MCNUM mccdiffraction_detector_5_exit_volume_xwidth2;
MCNUM mccdiffraction_detector_5_exit_volume_yheight2;
MCNUM mccdiffraction_detector_5_exit_volume_visualize;
int mccdiffraction_detector_5_exit_volume_target_index;
MCNUM mccdiffraction_detector_5_exit_volume_target_x;
MCNUM mccdiffraction_detector_5_exit_volume_target_y;
MCNUM mccdiffraction_detector_5_exit_volume_target_z;
MCNUM mccdiffraction_detector_5_exit_volume_focus_aw;
MCNUM mccdiffraction_detector_5_exit_volume_focus_ah;
MCNUM mccdiffraction_detector_5_exit_volume_focus_xw;
MCNUM mccdiffraction_detector_5_exit_volume_focus_xh;
MCNUM mccdiffraction_detector_5_exit_volume_focus_r;
MCNUM mccdiffraction_detector_5_exit_volume_p_interact;
char mccdiffraction_detector_5_exit_volume_mask_string[16384];
char mccdiffraction_detector_5_exit_volume_mask_setting[16384];
MCNUM mccdiffraction_detector_5_exit_volume_number_of_activations;

/* Setting parameters for component 'spec_detector_5_exit_volume' [351]. */
char mccspec_detector_5_exit_volume_material_string[16384];
MCNUM mccspec_detector_5_exit_volume_priority;
MCNUM mccspec_detector_5_exit_volume_xwidth;
MCNUM mccspec_detector_5_exit_volume_yheight;
MCNUM mccspec_detector_5_exit_volume_zdepth;
MCNUM mccspec_detector_5_exit_volume_xwidth2;
MCNUM mccspec_detector_5_exit_volume_yheight2;
MCNUM mccspec_detector_5_exit_volume_visualize;
int mccspec_detector_5_exit_volume_target_index;
MCNUM mccspec_detector_5_exit_volume_target_x;
MCNUM mccspec_detector_5_exit_volume_target_y;
MCNUM mccspec_detector_5_exit_volume_target_z;
MCNUM mccspec_detector_5_exit_volume_focus_aw;
MCNUM mccspec_detector_5_exit_volume_focus_ah;
MCNUM mccspec_detector_5_exit_volume_focus_xw;
MCNUM mccspec_detector_5_exit_volume_focus_xh;
MCNUM mccspec_detector_5_exit_volume_focus_r;
MCNUM mccspec_detector_5_exit_volume_p_interact;
char mccspec_detector_5_exit_volume_mask_string[16384];
char mccspec_detector_5_exit_volume_mask_setting[16384];
MCNUM mccspec_detector_5_exit_volume_number_of_activations;

/* Setting parameters for component 'channel_6_cave1_box1' [352]. */
char mccchannel_6_cave1_box1_material_string[16384];
MCNUM mccchannel_6_cave1_box1_priority;
MCNUM mccchannel_6_cave1_box1_xwidth;
MCNUM mccchannel_6_cave1_box1_yheight;
MCNUM mccchannel_6_cave1_box1_zdepth;
MCNUM mccchannel_6_cave1_box1_xwidth2;
MCNUM mccchannel_6_cave1_box1_yheight2;
MCNUM mccchannel_6_cave1_box1_visualize;
int mccchannel_6_cave1_box1_target_index;
MCNUM mccchannel_6_cave1_box1_target_x;
MCNUM mccchannel_6_cave1_box1_target_y;
MCNUM mccchannel_6_cave1_box1_target_z;
MCNUM mccchannel_6_cave1_box1_focus_aw;
MCNUM mccchannel_6_cave1_box1_focus_ah;
MCNUM mccchannel_6_cave1_box1_focus_xw;
MCNUM mccchannel_6_cave1_box1_focus_xh;
MCNUM mccchannel_6_cave1_box1_focus_r;
MCNUM mccchannel_6_cave1_box1_p_interact;
char mccchannel_6_cave1_box1_mask_string[16384];
char mccchannel_6_cave1_box1_mask_setting[16384];
MCNUM mccchannel_6_cave1_box1_number_of_activations;

/* Setting parameters for component 'channel_6_cave1_box2' [353]. */
char mccchannel_6_cave1_box2_material_string[16384];
MCNUM mccchannel_6_cave1_box2_priority;
MCNUM mccchannel_6_cave1_box2_xwidth;
MCNUM mccchannel_6_cave1_box2_yheight;
MCNUM mccchannel_6_cave1_box2_zdepth;
MCNUM mccchannel_6_cave1_box2_xwidth2;
MCNUM mccchannel_6_cave1_box2_yheight2;
MCNUM mccchannel_6_cave1_box2_visualize;
int mccchannel_6_cave1_box2_target_index;
MCNUM mccchannel_6_cave1_box2_target_x;
MCNUM mccchannel_6_cave1_box2_target_y;
MCNUM mccchannel_6_cave1_box2_target_z;
MCNUM mccchannel_6_cave1_box2_focus_aw;
MCNUM mccchannel_6_cave1_box2_focus_ah;
MCNUM mccchannel_6_cave1_box2_focus_xw;
MCNUM mccchannel_6_cave1_box2_focus_xh;
MCNUM mccchannel_6_cave1_box2_focus_r;
MCNUM mccchannel_6_cave1_box2_p_interact;
char mccchannel_6_cave1_box2_mask_string[16384];
char mccchannel_6_cave1_box2_mask_setting[16384];
MCNUM mccchannel_6_cave1_box2_number_of_activations;

/* Setting parameters for component 'channel_6_cave1_box3' [354]. */
char mccchannel_6_cave1_box3_material_string[16384];
MCNUM mccchannel_6_cave1_box3_priority;
MCNUM mccchannel_6_cave1_box3_xwidth;
MCNUM mccchannel_6_cave1_box3_yheight;
MCNUM mccchannel_6_cave1_box3_zdepth;
MCNUM mccchannel_6_cave1_box3_xwidth2;
MCNUM mccchannel_6_cave1_box3_yheight2;
MCNUM mccchannel_6_cave1_box3_visualize;
int mccchannel_6_cave1_box3_target_index;
MCNUM mccchannel_6_cave1_box3_target_x;
MCNUM mccchannel_6_cave1_box3_target_y;
MCNUM mccchannel_6_cave1_box3_target_z;
MCNUM mccchannel_6_cave1_box3_focus_aw;
MCNUM mccchannel_6_cave1_box3_focus_ah;
MCNUM mccchannel_6_cave1_box3_focus_xw;
MCNUM mccchannel_6_cave1_box3_focus_xh;
MCNUM mccchannel_6_cave1_box3_focus_r;
MCNUM mccchannel_6_cave1_box3_p_interact;
char mccchannel_6_cave1_box3_mask_string[16384];
char mccchannel_6_cave1_box3_mask_setting[16384];
MCNUM mccchannel_6_cave1_box3_number_of_activations;

/* Setting parameters for component 'channel_6_cave1_cyl1' [355]. */
char mccchannel_6_cave1_cyl1_material_string[16384];
MCNUM mccchannel_6_cave1_cyl1_priority;
MCNUM mccchannel_6_cave1_cyl1_radius;
MCNUM mccchannel_6_cave1_cyl1_yheight;
MCNUM mccchannel_6_cave1_cyl1_visualize;
int mccchannel_6_cave1_cyl1_target_index;
MCNUM mccchannel_6_cave1_cyl1_target_x;
MCNUM mccchannel_6_cave1_cyl1_target_y;
MCNUM mccchannel_6_cave1_cyl1_target_z;
MCNUM mccchannel_6_cave1_cyl1_focus_aw;
MCNUM mccchannel_6_cave1_cyl1_focus_ah;
MCNUM mccchannel_6_cave1_cyl1_focus_xw;
MCNUM mccchannel_6_cave1_cyl1_focus_xh;
MCNUM mccchannel_6_cave1_cyl1_focus_r;
MCNUM mccchannel_6_cave1_cyl1_p_interact;
char mccchannel_6_cave1_cyl1_mask_string[16384];
char mccchannel_6_cave1_cyl1_mask_setting[16384];
MCNUM mccchannel_6_cave1_cyl1_number_of_activations;

/* Setting parameters for component 'channel_6_analyzer_1_array_crystal_array_0' [358]. */
char mccchannel_6_analyzer_1_array_crystal_array_0_material_string[16384];
MCNUM mccchannel_6_analyzer_1_array_crystal_array_0_priority;
MCNUM mccchannel_6_analyzer_1_array_crystal_array_0_xwidth;
MCNUM mccchannel_6_analyzer_1_array_crystal_array_0_yheight;
MCNUM mccchannel_6_analyzer_1_array_crystal_array_0_zdepth;
MCNUM mccchannel_6_analyzer_1_array_crystal_array_0_xwidth2;
MCNUM mccchannel_6_analyzer_1_array_crystal_array_0_yheight2;
MCNUM mccchannel_6_analyzer_1_array_crystal_array_0_visualize;
int mccchannel_6_analyzer_1_array_crystal_array_0_target_index;
MCNUM mccchannel_6_analyzer_1_array_crystal_array_0_target_x;
MCNUM mccchannel_6_analyzer_1_array_crystal_array_0_target_y;
MCNUM mccchannel_6_analyzer_1_array_crystal_array_0_target_z;
MCNUM mccchannel_6_analyzer_1_array_crystal_array_0_focus_aw;
MCNUM mccchannel_6_analyzer_1_array_crystal_array_0_focus_ah;
MCNUM mccchannel_6_analyzer_1_array_crystal_array_0_focus_xw;
MCNUM mccchannel_6_analyzer_1_array_crystal_array_0_focus_xh;
MCNUM mccchannel_6_analyzer_1_array_crystal_array_0_focus_r;
MCNUM mccchannel_6_analyzer_1_array_crystal_array_0_p_interact;
char mccchannel_6_analyzer_1_array_crystal_array_0_mask_string[16384];
char mccchannel_6_analyzer_1_array_crystal_array_0_mask_setting[16384];
MCNUM mccchannel_6_analyzer_1_array_crystal_array_0_number_of_activations;

/* Setting parameters for component 'channel_6_analyzer_1_array_crystal_array_1' [359]. */
char mccchannel_6_analyzer_1_array_crystal_array_1_material_string[16384];
MCNUM mccchannel_6_analyzer_1_array_crystal_array_1_priority;
MCNUM mccchannel_6_analyzer_1_array_crystal_array_1_xwidth;
MCNUM mccchannel_6_analyzer_1_array_crystal_array_1_yheight;
MCNUM mccchannel_6_analyzer_1_array_crystal_array_1_zdepth;
MCNUM mccchannel_6_analyzer_1_array_crystal_array_1_xwidth2;
MCNUM mccchannel_6_analyzer_1_array_crystal_array_1_yheight2;
MCNUM mccchannel_6_analyzer_1_array_crystal_array_1_visualize;
int mccchannel_6_analyzer_1_array_crystal_array_1_target_index;
MCNUM mccchannel_6_analyzer_1_array_crystal_array_1_target_x;
MCNUM mccchannel_6_analyzer_1_array_crystal_array_1_target_y;
MCNUM mccchannel_6_analyzer_1_array_crystal_array_1_target_z;
MCNUM mccchannel_6_analyzer_1_array_crystal_array_1_focus_aw;
MCNUM mccchannel_6_analyzer_1_array_crystal_array_1_focus_ah;
MCNUM mccchannel_6_analyzer_1_array_crystal_array_1_focus_xw;
MCNUM mccchannel_6_analyzer_1_array_crystal_array_1_focus_xh;
MCNUM mccchannel_6_analyzer_1_array_crystal_array_1_focus_r;
MCNUM mccchannel_6_analyzer_1_array_crystal_array_1_p_interact;
char mccchannel_6_analyzer_1_array_crystal_array_1_mask_string[16384];
char mccchannel_6_analyzer_1_array_crystal_array_1_mask_setting[16384];
MCNUM mccchannel_6_analyzer_1_array_crystal_array_1_number_of_activations;

/* Setting parameters for component 'channel_6_analyzer_1_array_crystal_array_2' [360]. */
char mccchannel_6_analyzer_1_array_crystal_array_2_material_string[16384];
MCNUM mccchannel_6_analyzer_1_array_crystal_array_2_priority;
MCNUM mccchannel_6_analyzer_1_array_crystal_array_2_xwidth;
MCNUM mccchannel_6_analyzer_1_array_crystal_array_2_yheight;
MCNUM mccchannel_6_analyzer_1_array_crystal_array_2_zdepth;
MCNUM mccchannel_6_analyzer_1_array_crystal_array_2_xwidth2;
MCNUM mccchannel_6_analyzer_1_array_crystal_array_2_yheight2;
MCNUM mccchannel_6_analyzer_1_array_crystal_array_2_visualize;
int mccchannel_6_analyzer_1_array_crystal_array_2_target_index;
MCNUM mccchannel_6_analyzer_1_array_crystal_array_2_target_x;
MCNUM mccchannel_6_analyzer_1_array_crystal_array_2_target_y;
MCNUM mccchannel_6_analyzer_1_array_crystal_array_2_target_z;
MCNUM mccchannel_6_analyzer_1_array_crystal_array_2_focus_aw;
MCNUM mccchannel_6_analyzer_1_array_crystal_array_2_focus_ah;
MCNUM mccchannel_6_analyzer_1_array_crystal_array_2_focus_xw;
MCNUM mccchannel_6_analyzer_1_array_crystal_array_2_focus_xh;
MCNUM mccchannel_6_analyzer_1_array_crystal_array_2_focus_r;
MCNUM mccchannel_6_analyzer_1_array_crystal_array_2_p_interact;
char mccchannel_6_analyzer_1_array_crystal_array_2_mask_string[16384];
char mccchannel_6_analyzer_1_array_crystal_array_2_mask_setting[16384];
MCNUM mccchannel_6_analyzer_1_array_crystal_array_2_number_of_activations;

/* Setting parameters for component 'channel_6_analyzer_1_array_crystal_array_3' [361]. */
char mccchannel_6_analyzer_1_array_crystal_array_3_material_string[16384];
MCNUM mccchannel_6_analyzer_1_array_crystal_array_3_priority;
MCNUM mccchannel_6_analyzer_1_array_crystal_array_3_xwidth;
MCNUM mccchannel_6_analyzer_1_array_crystal_array_3_yheight;
MCNUM mccchannel_6_analyzer_1_array_crystal_array_3_zdepth;
MCNUM mccchannel_6_analyzer_1_array_crystal_array_3_xwidth2;
MCNUM mccchannel_6_analyzer_1_array_crystal_array_3_yheight2;
MCNUM mccchannel_6_analyzer_1_array_crystal_array_3_visualize;
int mccchannel_6_analyzer_1_array_crystal_array_3_target_index;
MCNUM mccchannel_6_analyzer_1_array_crystal_array_3_target_x;
MCNUM mccchannel_6_analyzer_1_array_crystal_array_3_target_y;
MCNUM mccchannel_6_analyzer_1_array_crystal_array_3_target_z;
MCNUM mccchannel_6_analyzer_1_array_crystal_array_3_focus_aw;
MCNUM mccchannel_6_analyzer_1_array_crystal_array_3_focus_ah;
MCNUM mccchannel_6_analyzer_1_array_crystal_array_3_focus_xw;
MCNUM mccchannel_6_analyzer_1_array_crystal_array_3_focus_xh;
MCNUM mccchannel_6_analyzer_1_array_crystal_array_3_focus_r;
MCNUM mccchannel_6_analyzer_1_array_crystal_array_3_p_interact;
char mccchannel_6_analyzer_1_array_crystal_array_3_mask_string[16384];
char mccchannel_6_analyzer_1_array_crystal_array_3_mask_setting[16384];
MCNUM mccchannel_6_analyzer_1_array_crystal_array_3_number_of_activations;

/* Setting parameters for component 'channel_6_analyzer_1_array_crystal_array_4' [362]. */
char mccchannel_6_analyzer_1_array_crystal_array_4_material_string[16384];
MCNUM mccchannel_6_analyzer_1_array_crystal_array_4_priority;
MCNUM mccchannel_6_analyzer_1_array_crystal_array_4_xwidth;
MCNUM mccchannel_6_analyzer_1_array_crystal_array_4_yheight;
MCNUM mccchannel_6_analyzer_1_array_crystal_array_4_zdepth;
MCNUM mccchannel_6_analyzer_1_array_crystal_array_4_xwidth2;
MCNUM mccchannel_6_analyzer_1_array_crystal_array_4_yheight2;
MCNUM mccchannel_6_analyzer_1_array_crystal_array_4_visualize;
int mccchannel_6_analyzer_1_array_crystal_array_4_target_index;
MCNUM mccchannel_6_analyzer_1_array_crystal_array_4_target_x;
MCNUM mccchannel_6_analyzer_1_array_crystal_array_4_target_y;
MCNUM mccchannel_6_analyzer_1_array_crystal_array_4_target_z;
MCNUM mccchannel_6_analyzer_1_array_crystal_array_4_focus_aw;
MCNUM mccchannel_6_analyzer_1_array_crystal_array_4_focus_ah;
MCNUM mccchannel_6_analyzer_1_array_crystal_array_4_focus_xw;
MCNUM mccchannel_6_analyzer_1_array_crystal_array_4_focus_xh;
MCNUM mccchannel_6_analyzer_1_array_crystal_array_4_focus_r;
MCNUM mccchannel_6_analyzer_1_array_crystal_array_4_p_interact;
char mccchannel_6_analyzer_1_array_crystal_array_4_mask_string[16384];
char mccchannel_6_analyzer_1_array_crystal_array_4_mask_setting[16384];
MCNUM mccchannel_6_analyzer_1_array_crystal_array_4_number_of_activations;

/* Setting parameters for component 'channel_6_analyzer_1_array_crystal_array_5' [363]. */
char mccchannel_6_analyzer_1_array_crystal_array_5_material_string[16384];
MCNUM mccchannel_6_analyzer_1_array_crystal_array_5_priority;
MCNUM mccchannel_6_analyzer_1_array_crystal_array_5_xwidth;
MCNUM mccchannel_6_analyzer_1_array_crystal_array_5_yheight;
MCNUM mccchannel_6_analyzer_1_array_crystal_array_5_zdepth;
MCNUM mccchannel_6_analyzer_1_array_crystal_array_5_xwidth2;
MCNUM mccchannel_6_analyzer_1_array_crystal_array_5_yheight2;
MCNUM mccchannel_6_analyzer_1_array_crystal_array_5_visualize;
int mccchannel_6_analyzer_1_array_crystal_array_5_target_index;
MCNUM mccchannel_6_analyzer_1_array_crystal_array_5_target_x;
MCNUM mccchannel_6_analyzer_1_array_crystal_array_5_target_y;
MCNUM mccchannel_6_analyzer_1_array_crystal_array_5_target_z;
MCNUM mccchannel_6_analyzer_1_array_crystal_array_5_focus_aw;
MCNUM mccchannel_6_analyzer_1_array_crystal_array_5_focus_ah;
MCNUM mccchannel_6_analyzer_1_array_crystal_array_5_focus_xw;
MCNUM mccchannel_6_analyzer_1_array_crystal_array_5_focus_xh;
MCNUM mccchannel_6_analyzer_1_array_crystal_array_5_focus_r;
MCNUM mccchannel_6_analyzer_1_array_crystal_array_5_p_interact;
char mccchannel_6_analyzer_1_array_crystal_array_5_mask_string[16384];
char mccchannel_6_analyzer_1_array_crystal_array_5_mask_setting[16384];
MCNUM mccchannel_6_analyzer_1_array_crystal_array_5_number_of_activations;

/* Setting parameters for component 'channel_6_analyzer_1_array_crystal_array_6' [364]. */
char mccchannel_6_analyzer_1_array_crystal_array_6_material_string[16384];
MCNUM mccchannel_6_analyzer_1_array_crystal_array_6_priority;
MCNUM mccchannel_6_analyzer_1_array_crystal_array_6_xwidth;
MCNUM mccchannel_6_analyzer_1_array_crystal_array_6_yheight;
MCNUM mccchannel_6_analyzer_1_array_crystal_array_6_zdepth;
MCNUM mccchannel_6_analyzer_1_array_crystal_array_6_xwidth2;
MCNUM mccchannel_6_analyzer_1_array_crystal_array_6_yheight2;
MCNUM mccchannel_6_analyzer_1_array_crystal_array_6_visualize;
int mccchannel_6_analyzer_1_array_crystal_array_6_target_index;
MCNUM mccchannel_6_analyzer_1_array_crystal_array_6_target_x;
MCNUM mccchannel_6_analyzer_1_array_crystal_array_6_target_y;
MCNUM mccchannel_6_analyzer_1_array_crystal_array_6_target_z;
MCNUM mccchannel_6_analyzer_1_array_crystal_array_6_focus_aw;
MCNUM mccchannel_6_analyzer_1_array_crystal_array_6_focus_ah;
MCNUM mccchannel_6_analyzer_1_array_crystal_array_6_focus_xw;
MCNUM mccchannel_6_analyzer_1_array_crystal_array_6_focus_xh;
MCNUM mccchannel_6_analyzer_1_array_crystal_array_6_focus_r;
MCNUM mccchannel_6_analyzer_1_array_crystal_array_6_p_interact;
char mccchannel_6_analyzer_1_array_crystal_array_6_mask_string[16384];
char mccchannel_6_analyzer_1_array_crystal_array_6_mask_setting[16384];
MCNUM mccchannel_6_analyzer_1_array_crystal_array_6_number_of_activations;

/* Setting parameters for component 'channel_6_analyzer_1_array_crystal_array_7' [365]. */
char mccchannel_6_analyzer_1_array_crystal_array_7_material_string[16384];
MCNUM mccchannel_6_analyzer_1_array_crystal_array_7_priority;
MCNUM mccchannel_6_analyzer_1_array_crystal_array_7_xwidth;
MCNUM mccchannel_6_analyzer_1_array_crystal_array_7_yheight;
MCNUM mccchannel_6_analyzer_1_array_crystal_array_7_zdepth;
MCNUM mccchannel_6_analyzer_1_array_crystal_array_7_xwidth2;
MCNUM mccchannel_6_analyzer_1_array_crystal_array_7_yheight2;
MCNUM mccchannel_6_analyzer_1_array_crystal_array_7_visualize;
int mccchannel_6_analyzer_1_array_crystal_array_7_target_index;
MCNUM mccchannel_6_analyzer_1_array_crystal_array_7_target_x;
MCNUM mccchannel_6_analyzer_1_array_crystal_array_7_target_y;
MCNUM mccchannel_6_analyzer_1_array_crystal_array_7_target_z;
MCNUM mccchannel_6_analyzer_1_array_crystal_array_7_focus_aw;
MCNUM mccchannel_6_analyzer_1_array_crystal_array_7_focus_ah;
MCNUM mccchannel_6_analyzer_1_array_crystal_array_7_focus_xw;
MCNUM mccchannel_6_analyzer_1_array_crystal_array_7_focus_xh;
MCNUM mccchannel_6_analyzer_1_array_crystal_array_7_focus_r;
MCNUM mccchannel_6_analyzer_1_array_crystal_array_7_p_interact;
char mccchannel_6_analyzer_1_array_crystal_array_7_mask_string[16384];
char mccchannel_6_analyzer_1_array_crystal_array_7_mask_setting[16384];
MCNUM mccchannel_6_analyzer_1_array_crystal_array_7_number_of_activations;

/* Setting parameters for component 'channel_6_analyzer_1_array_crystal_array_8' [366]. */
char mccchannel_6_analyzer_1_array_crystal_array_8_material_string[16384];
MCNUM mccchannel_6_analyzer_1_array_crystal_array_8_priority;
MCNUM mccchannel_6_analyzer_1_array_crystal_array_8_xwidth;
MCNUM mccchannel_6_analyzer_1_array_crystal_array_8_yheight;
MCNUM mccchannel_6_analyzer_1_array_crystal_array_8_zdepth;
MCNUM mccchannel_6_analyzer_1_array_crystal_array_8_xwidth2;
MCNUM mccchannel_6_analyzer_1_array_crystal_array_8_yheight2;
MCNUM mccchannel_6_analyzer_1_array_crystal_array_8_visualize;
int mccchannel_6_analyzer_1_array_crystal_array_8_target_index;
MCNUM mccchannel_6_analyzer_1_array_crystal_array_8_target_x;
MCNUM mccchannel_6_analyzer_1_array_crystal_array_8_target_y;
MCNUM mccchannel_6_analyzer_1_array_crystal_array_8_target_z;
MCNUM mccchannel_6_analyzer_1_array_crystal_array_8_focus_aw;
MCNUM mccchannel_6_analyzer_1_array_crystal_array_8_focus_ah;
MCNUM mccchannel_6_analyzer_1_array_crystal_array_8_focus_xw;
MCNUM mccchannel_6_analyzer_1_array_crystal_array_8_focus_xh;
MCNUM mccchannel_6_analyzer_1_array_crystal_array_8_focus_r;
MCNUM mccchannel_6_analyzer_1_array_crystal_array_8_p_interact;
char mccchannel_6_analyzer_1_array_crystal_array_8_mask_string[16384];
char mccchannel_6_analyzer_1_array_crystal_array_8_mask_setting[16384];
MCNUM mccchannel_6_analyzer_1_array_crystal_array_8_number_of_activations;

/* Setting parameters for component 'channel_6_analyzer_2_array_crystal_array_0' [369]. */
char mccchannel_6_analyzer_2_array_crystal_array_0_material_string[16384];
MCNUM mccchannel_6_analyzer_2_array_crystal_array_0_priority;
MCNUM mccchannel_6_analyzer_2_array_crystal_array_0_xwidth;
MCNUM mccchannel_6_analyzer_2_array_crystal_array_0_yheight;
MCNUM mccchannel_6_analyzer_2_array_crystal_array_0_zdepth;
MCNUM mccchannel_6_analyzer_2_array_crystal_array_0_xwidth2;
MCNUM mccchannel_6_analyzer_2_array_crystal_array_0_yheight2;
MCNUM mccchannel_6_analyzer_2_array_crystal_array_0_visualize;
int mccchannel_6_analyzer_2_array_crystal_array_0_target_index;
MCNUM mccchannel_6_analyzer_2_array_crystal_array_0_target_x;
MCNUM mccchannel_6_analyzer_2_array_crystal_array_0_target_y;
MCNUM mccchannel_6_analyzer_2_array_crystal_array_0_target_z;
MCNUM mccchannel_6_analyzer_2_array_crystal_array_0_focus_aw;
MCNUM mccchannel_6_analyzer_2_array_crystal_array_0_focus_ah;
MCNUM mccchannel_6_analyzer_2_array_crystal_array_0_focus_xw;
MCNUM mccchannel_6_analyzer_2_array_crystal_array_0_focus_xh;
MCNUM mccchannel_6_analyzer_2_array_crystal_array_0_focus_r;
MCNUM mccchannel_6_analyzer_2_array_crystal_array_0_p_interact;
char mccchannel_6_analyzer_2_array_crystal_array_0_mask_string[16384];
char mccchannel_6_analyzer_2_array_crystal_array_0_mask_setting[16384];
MCNUM mccchannel_6_analyzer_2_array_crystal_array_0_number_of_activations;

/* Setting parameters for component 'channel_6_analyzer_2_array_crystal_array_1' [370]. */
char mccchannel_6_analyzer_2_array_crystal_array_1_material_string[16384];
MCNUM mccchannel_6_analyzer_2_array_crystal_array_1_priority;
MCNUM mccchannel_6_analyzer_2_array_crystal_array_1_xwidth;
MCNUM mccchannel_6_analyzer_2_array_crystal_array_1_yheight;
MCNUM mccchannel_6_analyzer_2_array_crystal_array_1_zdepth;
MCNUM mccchannel_6_analyzer_2_array_crystal_array_1_xwidth2;
MCNUM mccchannel_6_analyzer_2_array_crystal_array_1_yheight2;
MCNUM mccchannel_6_analyzer_2_array_crystal_array_1_visualize;
int mccchannel_6_analyzer_2_array_crystal_array_1_target_index;
MCNUM mccchannel_6_analyzer_2_array_crystal_array_1_target_x;
MCNUM mccchannel_6_analyzer_2_array_crystal_array_1_target_y;
MCNUM mccchannel_6_analyzer_2_array_crystal_array_1_target_z;
MCNUM mccchannel_6_analyzer_2_array_crystal_array_1_focus_aw;
MCNUM mccchannel_6_analyzer_2_array_crystal_array_1_focus_ah;
MCNUM mccchannel_6_analyzer_2_array_crystal_array_1_focus_xw;
MCNUM mccchannel_6_analyzer_2_array_crystal_array_1_focus_xh;
MCNUM mccchannel_6_analyzer_2_array_crystal_array_1_focus_r;
MCNUM mccchannel_6_analyzer_2_array_crystal_array_1_p_interact;
char mccchannel_6_analyzer_2_array_crystal_array_1_mask_string[16384];
char mccchannel_6_analyzer_2_array_crystal_array_1_mask_setting[16384];
MCNUM mccchannel_6_analyzer_2_array_crystal_array_1_number_of_activations;

/* Setting parameters for component 'channel_6_analyzer_2_array_crystal_array_2' [371]. */
char mccchannel_6_analyzer_2_array_crystal_array_2_material_string[16384];
MCNUM mccchannel_6_analyzer_2_array_crystal_array_2_priority;
MCNUM mccchannel_6_analyzer_2_array_crystal_array_2_xwidth;
MCNUM mccchannel_6_analyzer_2_array_crystal_array_2_yheight;
MCNUM mccchannel_6_analyzer_2_array_crystal_array_2_zdepth;
MCNUM mccchannel_6_analyzer_2_array_crystal_array_2_xwidth2;
MCNUM mccchannel_6_analyzer_2_array_crystal_array_2_yheight2;
MCNUM mccchannel_6_analyzer_2_array_crystal_array_2_visualize;
int mccchannel_6_analyzer_2_array_crystal_array_2_target_index;
MCNUM mccchannel_6_analyzer_2_array_crystal_array_2_target_x;
MCNUM mccchannel_6_analyzer_2_array_crystal_array_2_target_y;
MCNUM mccchannel_6_analyzer_2_array_crystal_array_2_target_z;
MCNUM mccchannel_6_analyzer_2_array_crystal_array_2_focus_aw;
MCNUM mccchannel_6_analyzer_2_array_crystal_array_2_focus_ah;
MCNUM mccchannel_6_analyzer_2_array_crystal_array_2_focus_xw;
MCNUM mccchannel_6_analyzer_2_array_crystal_array_2_focus_xh;
MCNUM mccchannel_6_analyzer_2_array_crystal_array_2_focus_r;
MCNUM mccchannel_6_analyzer_2_array_crystal_array_2_p_interact;
char mccchannel_6_analyzer_2_array_crystal_array_2_mask_string[16384];
char mccchannel_6_analyzer_2_array_crystal_array_2_mask_setting[16384];
MCNUM mccchannel_6_analyzer_2_array_crystal_array_2_number_of_activations;

/* Setting parameters for component 'channel_6_analyzer_2_array_crystal_array_3' [372]. */
char mccchannel_6_analyzer_2_array_crystal_array_3_material_string[16384];
MCNUM mccchannel_6_analyzer_2_array_crystal_array_3_priority;
MCNUM mccchannel_6_analyzer_2_array_crystal_array_3_xwidth;
MCNUM mccchannel_6_analyzer_2_array_crystal_array_3_yheight;
MCNUM mccchannel_6_analyzer_2_array_crystal_array_3_zdepth;
MCNUM mccchannel_6_analyzer_2_array_crystal_array_3_xwidth2;
MCNUM mccchannel_6_analyzer_2_array_crystal_array_3_yheight2;
MCNUM mccchannel_6_analyzer_2_array_crystal_array_3_visualize;
int mccchannel_6_analyzer_2_array_crystal_array_3_target_index;
MCNUM mccchannel_6_analyzer_2_array_crystal_array_3_target_x;
MCNUM mccchannel_6_analyzer_2_array_crystal_array_3_target_y;
MCNUM mccchannel_6_analyzer_2_array_crystal_array_3_target_z;
MCNUM mccchannel_6_analyzer_2_array_crystal_array_3_focus_aw;
MCNUM mccchannel_6_analyzer_2_array_crystal_array_3_focus_ah;
MCNUM mccchannel_6_analyzer_2_array_crystal_array_3_focus_xw;
MCNUM mccchannel_6_analyzer_2_array_crystal_array_3_focus_xh;
MCNUM mccchannel_6_analyzer_2_array_crystal_array_3_focus_r;
MCNUM mccchannel_6_analyzer_2_array_crystal_array_3_p_interact;
char mccchannel_6_analyzer_2_array_crystal_array_3_mask_string[16384];
char mccchannel_6_analyzer_2_array_crystal_array_3_mask_setting[16384];
MCNUM mccchannel_6_analyzer_2_array_crystal_array_3_number_of_activations;

/* Setting parameters for component 'channel_6_analyzer_2_array_crystal_array_4' [373]. */
char mccchannel_6_analyzer_2_array_crystal_array_4_material_string[16384];
MCNUM mccchannel_6_analyzer_2_array_crystal_array_4_priority;
MCNUM mccchannel_6_analyzer_2_array_crystal_array_4_xwidth;
MCNUM mccchannel_6_analyzer_2_array_crystal_array_4_yheight;
MCNUM mccchannel_6_analyzer_2_array_crystal_array_4_zdepth;
MCNUM mccchannel_6_analyzer_2_array_crystal_array_4_xwidth2;
MCNUM mccchannel_6_analyzer_2_array_crystal_array_4_yheight2;
MCNUM mccchannel_6_analyzer_2_array_crystal_array_4_visualize;
int mccchannel_6_analyzer_2_array_crystal_array_4_target_index;
MCNUM mccchannel_6_analyzer_2_array_crystal_array_4_target_x;
MCNUM mccchannel_6_analyzer_2_array_crystal_array_4_target_y;
MCNUM mccchannel_6_analyzer_2_array_crystal_array_4_target_z;
MCNUM mccchannel_6_analyzer_2_array_crystal_array_4_focus_aw;
MCNUM mccchannel_6_analyzer_2_array_crystal_array_4_focus_ah;
MCNUM mccchannel_6_analyzer_2_array_crystal_array_4_focus_xw;
MCNUM mccchannel_6_analyzer_2_array_crystal_array_4_focus_xh;
MCNUM mccchannel_6_analyzer_2_array_crystal_array_4_focus_r;
MCNUM mccchannel_6_analyzer_2_array_crystal_array_4_p_interact;
char mccchannel_6_analyzer_2_array_crystal_array_4_mask_string[16384];
char mccchannel_6_analyzer_2_array_crystal_array_4_mask_setting[16384];
MCNUM mccchannel_6_analyzer_2_array_crystal_array_4_number_of_activations;

/* Setting parameters for component 'channel_6_analyzer_2_array_crystal_array_5' [374]. */
char mccchannel_6_analyzer_2_array_crystal_array_5_material_string[16384];
MCNUM mccchannel_6_analyzer_2_array_crystal_array_5_priority;
MCNUM mccchannel_6_analyzer_2_array_crystal_array_5_xwidth;
MCNUM mccchannel_6_analyzer_2_array_crystal_array_5_yheight;
MCNUM mccchannel_6_analyzer_2_array_crystal_array_5_zdepth;
MCNUM mccchannel_6_analyzer_2_array_crystal_array_5_xwidth2;
MCNUM mccchannel_6_analyzer_2_array_crystal_array_5_yheight2;
MCNUM mccchannel_6_analyzer_2_array_crystal_array_5_visualize;
int mccchannel_6_analyzer_2_array_crystal_array_5_target_index;
MCNUM mccchannel_6_analyzer_2_array_crystal_array_5_target_x;
MCNUM mccchannel_6_analyzer_2_array_crystal_array_5_target_y;
MCNUM mccchannel_6_analyzer_2_array_crystal_array_5_target_z;
MCNUM mccchannel_6_analyzer_2_array_crystal_array_5_focus_aw;
MCNUM mccchannel_6_analyzer_2_array_crystal_array_5_focus_ah;
MCNUM mccchannel_6_analyzer_2_array_crystal_array_5_focus_xw;
MCNUM mccchannel_6_analyzer_2_array_crystal_array_5_focus_xh;
MCNUM mccchannel_6_analyzer_2_array_crystal_array_5_focus_r;
MCNUM mccchannel_6_analyzer_2_array_crystal_array_5_p_interact;
char mccchannel_6_analyzer_2_array_crystal_array_5_mask_string[16384];
char mccchannel_6_analyzer_2_array_crystal_array_5_mask_setting[16384];
MCNUM mccchannel_6_analyzer_2_array_crystal_array_5_number_of_activations;

/* Setting parameters for component 'channel_6_analyzer_2_array_crystal_array_6' [375]. */
char mccchannel_6_analyzer_2_array_crystal_array_6_material_string[16384];
MCNUM mccchannel_6_analyzer_2_array_crystal_array_6_priority;
MCNUM mccchannel_6_analyzer_2_array_crystal_array_6_xwidth;
MCNUM mccchannel_6_analyzer_2_array_crystal_array_6_yheight;
MCNUM mccchannel_6_analyzer_2_array_crystal_array_6_zdepth;
MCNUM mccchannel_6_analyzer_2_array_crystal_array_6_xwidth2;
MCNUM mccchannel_6_analyzer_2_array_crystal_array_6_yheight2;
MCNUM mccchannel_6_analyzer_2_array_crystal_array_6_visualize;
int mccchannel_6_analyzer_2_array_crystal_array_6_target_index;
MCNUM mccchannel_6_analyzer_2_array_crystal_array_6_target_x;
MCNUM mccchannel_6_analyzer_2_array_crystal_array_6_target_y;
MCNUM mccchannel_6_analyzer_2_array_crystal_array_6_target_z;
MCNUM mccchannel_6_analyzer_2_array_crystal_array_6_focus_aw;
MCNUM mccchannel_6_analyzer_2_array_crystal_array_6_focus_ah;
MCNUM mccchannel_6_analyzer_2_array_crystal_array_6_focus_xw;
MCNUM mccchannel_6_analyzer_2_array_crystal_array_6_focus_xh;
MCNUM mccchannel_6_analyzer_2_array_crystal_array_6_focus_r;
MCNUM mccchannel_6_analyzer_2_array_crystal_array_6_p_interact;
char mccchannel_6_analyzer_2_array_crystal_array_6_mask_string[16384];
char mccchannel_6_analyzer_2_array_crystal_array_6_mask_setting[16384];
MCNUM mccchannel_6_analyzer_2_array_crystal_array_6_number_of_activations;

/* Setting parameters for component 'channel_6_analyzer_2_array_crystal_array_7' [376]. */
char mccchannel_6_analyzer_2_array_crystal_array_7_material_string[16384];
MCNUM mccchannel_6_analyzer_2_array_crystal_array_7_priority;
MCNUM mccchannel_6_analyzer_2_array_crystal_array_7_xwidth;
MCNUM mccchannel_6_analyzer_2_array_crystal_array_7_yheight;
MCNUM mccchannel_6_analyzer_2_array_crystal_array_7_zdepth;
MCNUM mccchannel_6_analyzer_2_array_crystal_array_7_xwidth2;
MCNUM mccchannel_6_analyzer_2_array_crystal_array_7_yheight2;
MCNUM mccchannel_6_analyzer_2_array_crystal_array_7_visualize;
int mccchannel_6_analyzer_2_array_crystal_array_7_target_index;
MCNUM mccchannel_6_analyzer_2_array_crystal_array_7_target_x;
MCNUM mccchannel_6_analyzer_2_array_crystal_array_7_target_y;
MCNUM mccchannel_6_analyzer_2_array_crystal_array_7_target_z;
MCNUM mccchannel_6_analyzer_2_array_crystal_array_7_focus_aw;
MCNUM mccchannel_6_analyzer_2_array_crystal_array_7_focus_ah;
MCNUM mccchannel_6_analyzer_2_array_crystal_array_7_focus_xw;
MCNUM mccchannel_6_analyzer_2_array_crystal_array_7_focus_xh;
MCNUM mccchannel_6_analyzer_2_array_crystal_array_7_focus_r;
MCNUM mccchannel_6_analyzer_2_array_crystal_array_7_p_interact;
char mccchannel_6_analyzer_2_array_crystal_array_7_mask_string[16384];
char mccchannel_6_analyzer_2_array_crystal_array_7_mask_setting[16384];
MCNUM mccchannel_6_analyzer_2_array_crystal_array_7_number_of_activations;

/* Setting parameters for component 'channel_6_analyzer_2_array_crystal_array_8' [377]. */
char mccchannel_6_analyzer_2_array_crystal_array_8_material_string[16384];
MCNUM mccchannel_6_analyzer_2_array_crystal_array_8_priority;
MCNUM mccchannel_6_analyzer_2_array_crystal_array_8_xwidth;
MCNUM mccchannel_6_analyzer_2_array_crystal_array_8_yheight;
MCNUM mccchannel_6_analyzer_2_array_crystal_array_8_zdepth;
MCNUM mccchannel_6_analyzer_2_array_crystal_array_8_xwidth2;
MCNUM mccchannel_6_analyzer_2_array_crystal_array_8_yheight2;
MCNUM mccchannel_6_analyzer_2_array_crystal_array_8_visualize;
int mccchannel_6_analyzer_2_array_crystal_array_8_target_index;
MCNUM mccchannel_6_analyzer_2_array_crystal_array_8_target_x;
MCNUM mccchannel_6_analyzer_2_array_crystal_array_8_target_y;
MCNUM mccchannel_6_analyzer_2_array_crystal_array_8_target_z;
MCNUM mccchannel_6_analyzer_2_array_crystal_array_8_focus_aw;
MCNUM mccchannel_6_analyzer_2_array_crystal_array_8_focus_ah;
MCNUM mccchannel_6_analyzer_2_array_crystal_array_8_focus_xw;
MCNUM mccchannel_6_analyzer_2_array_crystal_array_8_focus_xh;
MCNUM mccchannel_6_analyzer_2_array_crystal_array_8_focus_r;
MCNUM mccchannel_6_analyzer_2_array_crystal_array_8_p_interact;
char mccchannel_6_analyzer_2_array_crystal_array_8_mask_string[16384];
char mccchannel_6_analyzer_2_array_crystal_array_8_mask_setting[16384];
MCNUM mccchannel_6_analyzer_2_array_crystal_array_8_number_of_activations;

/* Setting parameters for component 'channel_6_cave2_cyl1' [378]. */
char mccchannel_6_cave2_cyl1_material_string[16384];
MCNUM mccchannel_6_cave2_cyl1_priority;
MCNUM mccchannel_6_cave2_cyl1_radius;
MCNUM mccchannel_6_cave2_cyl1_yheight;
MCNUM mccchannel_6_cave2_cyl1_visualize;
int mccchannel_6_cave2_cyl1_target_index;
MCNUM mccchannel_6_cave2_cyl1_target_x;
MCNUM mccchannel_6_cave2_cyl1_target_y;
MCNUM mccchannel_6_cave2_cyl1_target_z;
MCNUM mccchannel_6_cave2_cyl1_focus_aw;
MCNUM mccchannel_6_cave2_cyl1_focus_ah;
MCNUM mccchannel_6_cave2_cyl1_focus_xw;
MCNUM mccchannel_6_cave2_cyl1_focus_xh;
MCNUM mccchannel_6_cave2_cyl1_focus_r;
MCNUM mccchannel_6_cave2_cyl1_p_interact;
char mccchannel_6_cave2_cyl1_mask_string[16384];
char mccchannel_6_cave2_cyl1_mask_setting[16384];
MCNUM mccchannel_6_cave2_cyl1_number_of_activations;

/* Setting parameters for component 'channel_6_cave2_box1' [379]. */
char mccchannel_6_cave2_box1_material_string[16384];
MCNUM mccchannel_6_cave2_box1_priority;
MCNUM mccchannel_6_cave2_box1_xwidth;
MCNUM mccchannel_6_cave2_box1_yheight;
MCNUM mccchannel_6_cave2_box1_zdepth;
MCNUM mccchannel_6_cave2_box1_xwidth2;
MCNUM mccchannel_6_cave2_box1_yheight2;
MCNUM mccchannel_6_cave2_box1_visualize;
int mccchannel_6_cave2_box1_target_index;
MCNUM mccchannel_6_cave2_box1_target_x;
MCNUM mccchannel_6_cave2_box1_target_y;
MCNUM mccchannel_6_cave2_box1_target_z;
MCNUM mccchannel_6_cave2_box1_focus_aw;
MCNUM mccchannel_6_cave2_box1_focus_ah;
MCNUM mccchannel_6_cave2_box1_focus_xw;
MCNUM mccchannel_6_cave2_box1_focus_xh;
MCNUM mccchannel_6_cave2_box1_focus_r;
MCNUM mccchannel_6_cave2_box1_p_interact;
char mccchannel_6_cave2_box1_mask_string[16384];
char mccchannel_6_cave2_box1_mask_setting[16384];
MCNUM mccchannel_6_cave2_box1_number_of_activations;

/* Setting parameters for component 'channel_6_cave2_box2' [380]. */
char mccchannel_6_cave2_box2_material_string[16384];
MCNUM mccchannel_6_cave2_box2_priority;
MCNUM mccchannel_6_cave2_box2_xwidth;
MCNUM mccchannel_6_cave2_box2_yheight;
MCNUM mccchannel_6_cave2_box2_zdepth;
MCNUM mccchannel_6_cave2_box2_xwidth2;
MCNUM mccchannel_6_cave2_box2_yheight2;
MCNUM mccchannel_6_cave2_box2_visualize;
int mccchannel_6_cave2_box2_target_index;
MCNUM mccchannel_6_cave2_box2_target_x;
MCNUM mccchannel_6_cave2_box2_target_y;
MCNUM mccchannel_6_cave2_box2_target_z;
MCNUM mccchannel_6_cave2_box2_focus_aw;
MCNUM mccchannel_6_cave2_box2_focus_ah;
MCNUM mccchannel_6_cave2_box2_focus_xw;
MCNUM mccchannel_6_cave2_box2_focus_xh;
MCNUM mccchannel_6_cave2_box2_focus_r;
MCNUM mccchannel_6_cave2_box2_p_interact;
char mccchannel_6_cave2_box2_mask_string[16384];
char mccchannel_6_cave2_box2_mask_setting[16384];
MCNUM mccchannel_6_cave2_box2_number_of_activations;

/* Setting parameters for component 'channel_6_cave2_box3' [381]. */
char mccchannel_6_cave2_box3_material_string[16384];
MCNUM mccchannel_6_cave2_box3_priority;
MCNUM mccchannel_6_cave2_box3_xwidth;
MCNUM mccchannel_6_cave2_box3_yheight;
MCNUM mccchannel_6_cave2_box3_zdepth;
MCNUM mccchannel_6_cave2_box3_xwidth2;
MCNUM mccchannel_6_cave2_box3_yheight2;
MCNUM mccchannel_6_cave2_box3_visualize;
int mccchannel_6_cave2_box3_target_index;
MCNUM mccchannel_6_cave2_box3_target_x;
MCNUM mccchannel_6_cave2_box3_target_y;
MCNUM mccchannel_6_cave2_box3_target_z;
MCNUM mccchannel_6_cave2_box3_focus_aw;
MCNUM mccchannel_6_cave2_box3_focus_ah;
MCNUM mccchannel_6_cave2_box3_focus_xw;
MCNUM mccchannel_6_cave2_box3_focus_xh;
MCNUM mccchannel_6_cave2_box3_focus_r;
MCNUM mccchannel_6_cave2_box3_p_interact;
char mccchannel_6_cave2_box3_mask_string[16384];
char mccchannel_6_cave2_box3_mask_setting[16384];
MCNUM mccchannel_6_cave2_box3_number_of_activations;

/* Setting parameters for component 'inter_analyzer_colimator_6_blade_0' [383]. */
char mccinter_analyzer_colimator_6_blade_0_material_string[16384];
MCNUM mccinter_analyzer_colimator_6_blade_0_priority;
MCNUM mccinter_analyzer_colimator_6_blade_0_xwidth;
MCNUM mccinter_analyzer_colimator_6_blade_0_yheight;
MCNUM mccinter_analyzer_colimator_6_blade_0_zdepth;
MCNUM mccinter_analyzer_colimator_6_blade_0_xwidth2;
MCNUM mccinter_analyzer_colimator_6_blade_0_yheight2;
MCNUM mccinter_analyzer_colimator_6_blade_0_visualize;
int mccinter_analyzer_colimator_6_blade_0_target_index;
MCNUM mccinter_analyzer_colimator_6_blade_0_target_x;
MCNUM mccinter_analyzer_colimator_6_blade_0_target_y;
MCNUM mccinter_analyzer_colimator_6_blade_0_target_z;
MCNUM mccinter_analyzer_colimator_6_blade_0_focus_aw;
MCNUM mccinter_analyzer_colimator_6_blade_0_focus_ah;
MCNUM mccinter_analyzer_colimator_6_blade_0_focus_xw;
MCNUM mccinter_analyzer_colimator_6_blade_0_focus_xh;
MCNUM mccinter_analyzer_colimator_6_blade_0_focus_r;
MCNUM mccinter_analyzer_colimator_6_blade_0_p_interact;
char mccinter_analyzer_colimator_6_blade_0_mask_string[16384];
char mccinter_analyzer_colimator_6_blade_0_mask_setting[16384];
MCNUM mccinter_analyzer_colimator_6_blade_0_number_of_activations;

/* Setting parameters for component 'inter_analyzer_colimator_6_blade_1' [384]. */
char mccinter_analyzer_colimator_6_blade_1_material_string[16384];
MCNUM mccinter_analyzer_colimator_6_blade_1_priority;
MCNUM mccinter_analyzer_colimator_6_blade_1_xwidth;
MCNUM mccinter_analyzer_colimator_6_blade_1_yheight;
MCNUM mccinter_analyzer_colimator_6_blade_1_zdepth;
MCNUM mccinter_analyzer_colimator_6_blade_1_xwidth2;
MCNUM mccinter_analyzer_colimator_6_blade_1_yheight2;
MCNUM mccinter_analyzer_colimator_6_blade_1_visualize;
int mccinter_analyzer_colimator_6_blade_1_target_index;
MCNUM mccinter_analyzer_colimator_6_blade_1_target_x;
MCNUM mccinter_analyzer_colimator_6_blade_1_target_y;
MCNUM mccinter_analyzer_colimator_6_blade_1_target_z;
MCNUM mccinter_analyzer_colimator_6_blade_1_focus_aw;
MCNUM mccinter_analyzer_colimator_6_blade_1_focus_ah;
MCNUM mccinter_analyzer_colimator_6_blade_1_focus_xw;
MCNUM mccinter_analyzer_colimator_6_blade_1_focus_xh;
MCNUM mccinter_analyzer_colimator_6_blade_1_focus_r;
MCNUM mccinter_analyzer_colimator_6_blade_1_p_interact;
char mccinter_analyzer_colimator_6_blade_1_mask_string[16384];
char mccinter_analyzer_colimator_6_blade_1_mask_setting[16384];
MCNUM mccinter_analyzer_colimator_6_blade_1_number_of_activations;

/* Setting parameters for component 'inter_analyzer_colimator_6_blade_2' [385]. */
char mccinter_analyzer_colimator_6_blade_2_material_string[16384];
MCNUM mccinter_analyzer_colimator_6_blade_2_priority;
MCNUM mccinter_analyzer_colimator_6_blade_2_xwidth;
MCNUM mccinter_analyzer_colimator_6_blade_2_yheight;
MCNUM mccinter_analyzer_colimator_6_blade_2_zdepth;
MCNUM mccinter_analyzer_colimator_6_blade_2_xwidth2;
MCNUM mccinter_analyzer_colimator_6_blade_2_yheight2;
MCNUM mccinter_analyzer_colimator_6_blade_2_visualize;
int mccinter_analyzer_colimator_6_blade_2_target_index;
MCNUM mccinter_analyzer_colimator_6_blade_2_target_x;
MCNUM mccinter_analyzer_colimator_6_blade_2_target_y;
MCNUM mccinter_analyzer_colimator_6_blade_2_target_z;
MCNUM mccinter_analyzer_colimator_6_blade_2_focus_aw;
MCNUM mccinter_analyzer_colimator_6_blade_2_focus_ah;
MCNUM mccinter_analyzer_colimator_6_blade_2_focus_xw;
MCNUM mccinter_analyzer_colimator_6_blade_2_focus_xh;
MCNUM mccinter_analyzer_colimator_6_blade_2_focus_r;
MCNUM mccinter_analyzer_colimator_6_blade_2_p_interact;
char mccinter_analyzer_colimator_6_blade_2_mask_string[16384];
char mccinter_analyzer_colimator_6_blade_2_mask_setting[16384];
MCNUM mccinter_analyzer_colimator_6_blade_2_number_of_activations;

/* Setting parameters for component 'inter_analyzer_colimator_6_blade_3' [386]. */
char mccinter_analyzer_colimator_6_blade_3_material_string[16384];
MCNUM mccinter_analyzer_colimator_6_blade_3_priority;
MCNUM mccinter_analyzer_colimator_6_blade_3_xwidth;
MCNUM mccinter_analyzer_colimator_6_blade_3_yheight;
MCNUM mccinter_analyzer_colimator_6_blade_3_zdepth;
MCNUM mccinter_analyzer_colimator_6_blade_3_xwidth2;
MCNUM mccinter_analyzer_colimator_6_blade_3_yheight2;
MCNUM mccinter_analyzer_colimator_6_blade_3_visualize;
int mccinter_analyzer_colimator_6_blade_3_target_index;
MCNUM mccinter_analyzer_colimator_6_blade_3_target_x;
MCNUM mccinter_analyzer_colimator_6_blade_3_target_y;
MCNUM mccinter_analyzer_colimator_6_blade_3_target_z;
MCNUM mccinter_analyzer_colimator_6_blade_3_focus_aw;
MCNUM mccinter_analyzer_colimator_6_blade_3_focus_ah;
MCNUM mccinter_analyzer_colimator_6_blade_3_focus_xw;
MCNUM mccinter_analyzer_colimator_6_blade_3_focus_xh;
MCNUM mccinter_analyzer_colimator_6_blade_3_focus_r;
MCNUM mccinter_analyzer_colimator_6_blade_3_p_interact;
char mccinter_analyzer_colimator_6_blade_3_mask_string[16384];
char mccinter_analyzer_colimator_6_blade_3_mask_setting[16384];
MCNUM mccinter_analyzer_colimator_6_blade_3_number_of_activations;

/* Setting parameters for component 'inter_analyzer_colimator_6_blade_4' [387]. */
char mccinter_analyzer_colimator_6_blade_4_material_string[16384];
MCNUM mccinter_analyzer_colimator_6_blade_4_priority;
MCNUM mccinter_analyzer_colimator_6_blade_4_xwidth;
MCNUM mccinter_analyzer_colimator_6_blade_4_yheight;
MCNUM mccinter_analyzer_colimator_6_blade_4_zdepth;
MCNUM mccinter_analyzer_colimator_6_blade_4_xwidth2;
MCNUM mccinter_analyzer_colimator_6_blade_4_yheight2;
MCNUM mccinter_analyzer_colimator_6_blade_4_visualize;
int mccinter_analyzer_colimator_6_blade_4_target_index;
MCNUM mccinter_analyzer_colimator_6_blade_4_target_x;
MCNUM mccinter_analyzer_colimator_6_blade_4_target_y;
MCNUM mccinter_analyzer_colimator_6_blade_4_target_z;
MCNUM mccinter_analyzer_colimator_6_blade_4_focus_aw;
MCNUM mccinter_analyzer_colimator_6_blade_4_focus_ah;
MCNUM mccinter_analyzer_colimator_6_blade_4_focus_xw;
MCNUM mccinter_analyzer_colimator_6_blade_4_focus_xh;
MCNUM mccinter_analyzer_colimator_6_blade_4_focus_r;
MCNUM mccinter_analyzer_colimator_6_blade_4_p_interact;
char mccinter_analyzer_colimator_6_blade_4_mask_string[16384];
char mccinter_analyzer_colimator_6_blade_4_mask_setting[16384];
MCNUM mccinter_analyzer_colimator_6_blade_4_number_of_activations;

/* Setting parameters for component 'diffraction_detector_6_exit_volume' [388]. */
char mccdiffraction_detector_6_exit_volume_material_string[16384];
MCNUM mccdiffraction_detector_6_exit_volume_priority;
MCNUM mccdiffraction_detector_6_exit_volume_xwidth;
MCNUM mccdiffraction_detector_6_exit_volume_yheight;
MCNUM mccdiffraction_detector_6_exit_volume_zdepth;
MCNUM mccdiffraction_detector_6_exit_volume_xwidth2;
MCNUM mccdiffraction_detector_6_exit_volume_yheight2;
MCNUM mccdiffraction_detector_6_exit_volume_visualize;
int mccdiffraction_detector_6_exit_volume_target_index;
MCNUM mccdiffraction_detector_6_exit_volume_target_x;
MCNUM mccdiffraction_detector_6_exit_volume_target_y;
MCNUM mccdiffraction_detector_6_exit_volume_target_z;
MCNUM mccdiffraction_detector_6_exit_volume_focus_aw;
MCNUM mccdiffraction_detector_6_exit_volume_focus_ah;
MCNUM mccdiffraction_detector_6_exit_volume_focus_xw;
MCNUM mccdiffraction_detector_6_exit_volume_focus_xh;
MCNUM mccdiffraction_detector_6_exit_volume_focus_r;
MCNUM mccdiffraction_detector_6_exit_volume_p_interact;
char mccdiffraction_detector_6_exit_volume_mask_string[16384];
char mccdiffraction_detector_6_exit_volume_mask_setting[16384];
MCNUM mccdiffraction_detector_6_exit_volume_number_of_activations;

/* Setting parameters for component 'spec_detector_6_exit_volume' [389]. */
char mccspec_detector_6_exit_volume_material_string[16384];
MCNUM mccspec_detector_6_exit_volume_priority;
MCNUM mccspec_detector_6_exit_volume_xwidth;
MCNUM mccspec_detector_6_exit_volume_yheight;
MCNUM mccspec_detector_6_exit_volume_zdepth;
MCNUM mccspec_detector_6_exit_volume_xwidth2;
MCNUM mccspec_detector_6_exit_volume_yheight2;
MCNUM mccspec_detector_6_exit_volume_visualize;
int mccspec_detector_6_exit_volume_target_index;
MCNUM mccspec_detector_6_exit_volume_target_x;
MCNUM mccspec_detector_6_exit_volume_target_y;
MCNUM mccspec_detector_6_exit_volume_target_z;
MCNUM mccspec_detector_6_exit_volume_focus_aw;
MCNUM mccspec_detector_6_exit_volume_focus_ah;
MCNUM mccspec_detector_6_exit_volume_focus_xw;
MCNUM mccspec_detector_6_exit_volume_focus_xh;
MCNUM mccspec_detector_6_exit_volume_focus_r;
MCNUM mccspec_detector_6_exit_volume_p_interact;
char mccspec_detector_6_exit_volume_mask_string[16384];
char mccspec_detector_6_exit_volume_mask_setting[16384];
MCNUM mccspec_detector_6_exit_volume_number_of_activations;

/* Setting parameters for component 'channel_7_cave1_box1' [390]. */
char mccchannel_7_cave1_box1_material_string[16384];
MCNUM mccchannel_7_cave1_box1_priority;
MCNUM mccchannel_7_cave1_box1_xwidth;
MCNUM mccchannel_7_cave1_box1_yheight;
MCNUM mccchannel_7_cave1_box1_zdepth;
MCNUM mccchannel_7_cave1_box1_xwidth2;
MCNUM mccchannel_7_cave1_box1_yheight2;
MCNUM mccchannel_7_cave1_box1_visualize;
int mccchannel_7_cave1_box1_target_index;
MCNUM mccchannel_7_cave1_box1_target_x;
MCNUM mccchannel_7_cave1_box1_target_y;
MCNUM mccchannel_7_cave1_box1_target_z;
MCNUM mccchannel_7_cave1_box1_focus_aw;
MCNUM mccchannel_7_cave1_box1_focus_ah;
MCNUM mccchannel_7_cave1_box1_focus_xw;
MCNUM mccchannel_7_cave1_box1_focus_xh;
MCNUM mccchannel_7_cave1_box1_focus_r;
MCNUM mccchannel_7_cave1_box1_p_interact;
char mccchannel_7_cave1_box1_mask_string[16384];
char mccchannel_7_cave1_box1_mask_setting[16384];
MCNUM mccchannel_7_cave1_box1_number_of_activations;

/* Setting parameters for component 'channel_7_cave1_box2' [391]. */
char mccchannel_7_cave1_box2_material_string[16384];
MCNUM mccchannel_7_cave1_box2_priority;
MCNUM mccchannel_7_cave1_box2_xwidth;
MCNUM mccchannel_7_cave1_box2_yheight;
MCNUM mccchannel_7_cave1_box2_zdepth;
MCNUM mccchannel_7_cave1_box2_xwidth2;
MCNUM mccchannel_7_cave1_box2_yheight2;
MCNUM mccchannel_7_cave1_box2_visualize;
int mccchannel_7_cave1_box2_target_index;
MCNUM mccchannel_7_cave1_box2_target_x;
MCNUM mccchannel_7_cave1_box2_target_y;
MCNUM mccchannel_7_cave1_box2_target_z;
MCNUM mccchannel_7_cave1_box2_focus_aw;
MCNUM mccchannel_7_cave1_box2_focus_ah;
MCNUM mccchannel_7_cave1_box2_focus_xw;
MCNUM mccchannel_7_cave1_box2_focus_xh;
MCNUM mccchannel_7_cave1_box2_focus_r;
MCNUM mccchannel_7_cave1_box2_p_interact;
char mccchannel_7_cave1_box2_mask_string[16384];
char mccchannel_7_cave1_box2_mask_setting[16384];
MCNUM mccchannel_7_cave1_box2_number_of_activations;

/* Setting parameters for component 'channel_7_cave1_box3' [392]. */
char mccchannel_7_cave1_box3_material_string[16384];
MCNUM mccchannel_7_cave1_box3_priority;
MCNUM mccchannel_7_cave1_box3_xwidth;
MCNUM mccchannel_7_cave1_box3_yheight;
MCNUM mccchannel_7_cave1_box3_zdepth;
MCNUM mccchannel_7_cave1_box3_xwidth2;
MCNUM mccchannel_7_cave1_box3_yheight2;
MCNUM mccchannel_7_cave1_box3_visualize;
int mccchannel_7_cave1_box3_target_index;
MCNUM mccchannel_7_cave1_box3_target_x;
MCNUM mccchannel_7_cave1_box3_target_y;
MCNUM mccchannel_7_cave1_box3_target_z;
MCNUM mccchannel_7_cave1_box3_focus_aw;
MCNUM mccchannel_7_cave1_box3_focus_ah;
MCNUM mccchannel_7_cave1_box3_focus_xw;
MCNUM mccchannel_7_cave1_box3_focus_xh;
MCNUM mccchannel_7_cave1_box3_focus_r;
MCNUM mccchannel_7_cave1_box3_p_interact;
char mccchannel_7_cave1_box3_mask_string[16384];
char mccchannel_7_cave1_box3_mask_setting[16384];
MCNUM mccchannel_7_cave1_box3_number_of_activations;

/* Setting parameters for component 'channel_7_cave1_cyl1' [393]. */
char mccchannel_7_cave1_cyl1_material_string[16384];
MCNUM mccchannel_7_cave1_cyl1_priority;
MCNUM mccchannel_7_cave1_cyl1_radius;
MCNUM mccchannel_7_cave1_cyl1_yheight;
MCNUM mccchannel_7_cave1_cyl1_visualize;
int mccchannel_7_cave1_cyl1_target_index;
MCNUM mccchannel_7_cave1_cyl1_target_x;
MCNUM mccchannel_7_cave1_cyl1_target_y;
MCNUM mccchannel_7_cave1_cyl1_target_z;
MCNUM mccchannel_7_cave1_cyl1_focus_aw;
MCNUM mccchannel_7_cave1_cyl1_focus_ah;
MCNUM mccchannel_7_cave1_cyl1_focus_xw;
MCNUM mccchannel_7_cave1_cyl1_focus_xh;
MCNUM mccchannel_7_cave1_cyl1_focus_r;
MCNUM mccchannel_7_cave1_cyl1_p_interact;
char mccchannel_7_cave1_cyl1_mask_string[16384];
char mccchannel_7_cave1_cyl1_mask_setting[16384];
MCNUM mccchannel_7_cave1_cyl1_number_of_activations;

/* Setting parameters for component 'channel_7_analyzer_1_array_crystal_array_0' [396]. */
char mccchannel_7_analyzer_1_array_crystal_array_0_material_string[16384];
MCNUM mccchannel_7_analyzer_1_array_crystal_array_0_priority;
MCNUM mccchannel_7_analyzer_1_array_crystal_array_0_xwidth;
MCNUM mccchannel_7_analyzer_1_array_crystal_array_0_yheight;
MCNUM mccchannel_7_analyzer_1_array_crystal_array_0_zdepth;
MCNUM mccchannel_7_analyzer_1_array_crystal_array_0_xwidth2;
MCNUM mccchannel_7_analyzer_1_array_crystal_array_0_yheight2;
MCNUM mccchannel_7_analyzer_1_array_crystal_array_0_visualize;
int mccchannel_7_analyzer_1_array_crystal_array_0_target_index;
MCNUM mccchannel_7_analyzer_1_array_crystal_array_0_target_x;
MCNUM mccchannel_7_analyzer_1_array_crystal_array_0_target_y;
MCNUM mccchannel_7_analyzer_1_array_crystal_array_0_target_z;
MCNUM mccchannel_7_analyzer_1_array_crystal_array_0_focus_aw;
MCNUM mccchannel_7_analyzer_1_array_crystal_array_0_focus_ah;
MCNUM mccchannel_7_analyzer_1_array_crystal_array_0_focus_xw;
MCNUM mccchannel_7_analyzer_1_array_crystal_array_0_focus_xh;
MCNUM mccchannel_7_analyzer_1_array_crystal_array_0_focus_r;
MCNUM mccchannel_7_analyzer_1_array_crystal_array_0_p_interact;
char mccchannel_7_analyzer_1_array_crystal_array_0_mask_string[16384];
char mccchannel_7_analyzer_1_array_crystal_array_0_mask_setting[16384];
MCNUM mccchannel_7_analyzer_1_array_crystal_array_0_number_of_activations;

/* Setting parameters for component 'channel_7_analyzer_1_array_crystal_array_1' [397]. */
char mccchannel_7_analyzer_1_array_crystal_array_1_material_string[16384];
MCNUM mccchannel_7_analyzer_1_array_crystal_array_1_priority;
MCNUM mccchannel_7_analyzer_1_array_crystal_array_1_xwidth;
MCNUM mccchannel_7_analyzer_1_array_crystal_array_1_yheight;
MCNUM mccchannel_7_analyzer_1_array_crystal_array_1_zdepth;
MCNUM mccchannel_7_analyzer_1_array_crystal_array_1_xwidth2;
MCNUM mccchannel_7_analyzer_1_array_crystal_array_1_yheight2;
MCNUM mccchannel_7_analyzer_1_array_crystal_array_1_visualize;
int mccchannel_7_analyzer_1_array_crystal_array_1_target_index;
MCNUM mccchannel_7_analyzer_1_array_crystal_array_1_target_x;
MCNUM mccchannel_7_analyzer_1_array_crystal_array_1_target_y;
MCNUM mccchannel_7_analyzer_1_array_crystal_array_1_target_z;
MCNUM mccchannel_7_analyzer_1_array_crystal_array_1_focus_aw;
MCNUM mccchannel_7_analyzer_1_array_crystal_array_1_focus_ah;
MCNUM mccchannel_7_analyzer_1_array_crystal_array_1_focus_xw;
MCNUM mccchannel_7_analyzer_1_array_crystal_array_1_focus_xh;
MCNUM mccchannel_7_analyzer_1_array_crystal_array_1_focus_r;
MCNUM mccchannel_7_analyzer_1_array_crystal_array_1_p_interact;
char mccchannel_7_analyzer_1_array_crystal_array_1_mask_string[16384];
char mccchannel_7_analyzer_1_array_crystal_array_1_mask_setting[16384];
MCNUM mccchannel_7_analyzer_1_array_crystal_array_1_number_of_activations;

/* Setting parameters for component 'channel_7_analyzer_1_array_crystal_array_2' [398]. */
char mccchannel_7_analyzer_1_array_crystal_array_2_material_string[16384];
MCNUM mccchannel_7_analyzer_1_array_crystal_array_2_priority;
MCNUM mccchannel_7_analyzer_1_array_crystal_array_2_xwidth;
MCNUM mccchannel_7_analyzer_1_array_crystal_array_2_yheight;
MCNUM mccchannel_7_analyzer_1_array_crystal_array_2_zdepth;
MCNUM mccchannel_7_analyzer_1_array_crystal_array_2_xwidth2;
MCNUM mccchannel_7_analyzer_1_array_crystal_array_2_yheight2;
MCNUM mccchannel_7_analyzer_1_array_crystal_array_2_visualize;
int mccchannel_7_analyzer_1_array_crystal_array_2_target_index;
MCNUM mccchannel_7_analyzer_1_array_crystal_array_2_target_x;
MCNUM mccchannel_7_analyzer_1_array_crystal_array_2_target_y;
MCNUM mccchannel_7_analyzer_1_array_crystal_array_2_target_z;
MCNUM mccchannel_7_analyzer_1_array_crystal_array_2_focus_aw;
MCNUM mccchannel_7_analyzer_1_array_crystal_array_2_focus_ah;
MCNUM mccchannel_7_analyzer_1_array_crystal_array_2_focus_xw;
MCNUM mccchannel_7_analyzer_1_array_crystal_array_2_focus_xh;
MCNUM mccchannel_7_analyzer_1_array_crystal_array_2_focus_r;
MCNUM mccchannel_7_analyzer_1_array_crystal_array_2_p_interact;
char mccchannel_7_analyzer_1_array_crystal_array_2_mask_string[16384];
char mccchannel_7_analyzer_1_array_crystal_array_2_mask_setting[16384];
MCNUM mccchannel_7_analyzer_1_array_crystal_array_2_number_of_activations;

/* Setting parameters for component 'channel_7_analyzer_1_array_crystal_array_3' [399]. */
char mccchannel_7_analyzer_1_array_crystal_array_3_material_string[16384];
MCNUM mccchannel_7_analyzer_1_array_crystal_array_3_priority;
MCNUM mccchannel_7_analyzer_1_array_crystal_array_3_xwidth;
MCNUM mccchannel_7_analyzer_1_array_crystal_array_3_yheight;
MCNUM mccchannel_7_analyzer_1_array_crystal_array_3_zdepth;
MCNUM mccchannel_7_analyzer_1_array_crystal_array_3_xwidth2;
MCNUM mccchannel_7_analyzer_1_array_crystal_array_3_yheight2;
MCNUM mccchannel_7_analyzer_1_array_crystal_array_3_visualize;
int mccchannel_7_analyzer_1_array_crystal_array_3_target_index;
MCNUM mccchannel_7_analyzer_1_array_crystal_array_3_target_x;
MCNUM mccchannel_7_analyzer_1_array_crystal_array_3_target_y;
MCNUM mccchannel_7_analyzer_1_array_crystal_array_3_target_z;
MCNUM mccchannel_7_analyzer_1_array_crystal_array_3_focus_aw;
MCNUM mccchannel_7_analyzer_1_array_crystal_array_3_focus_ah;
MCNUM mccchannel_7_analyzer_1_array_crystal_array_3_focus_xw;
MCNUM mccchannel_7_analyzer_1_array_crystal_array_3_focus_xh;
MCNUM mccchannel_7_analyzer_1_array_crystal_array_3_focus_r;
MCNUM mccchannel_7_analyzer_1_array_crystal_array_3_p_interact;
char mccchannel_7_analyzer_1_array_crystal_array_3_mask_string[16384];
char mccchannel_7_analyzer_1_array_crystal_array_3_mask_setting[16384];
MCNUM mccchannel_7_analyzer_1_array_crystal_array_3_number_of_activations;

/* Setting parameters for component 'channel_7_analyzer_1_array_crystal_array_4' [400]. */
char mccchannel_7_analyzer_1_array_crystal_array_4_material_string[16384];
MCNUM mccchannel_7_analyzer_1_array_crystal_array_4_priority;
MCNUM mccchannel_7_analyzer_1_array_crystal_array_4_xwidth;
MCNUM mccchannel_7_analyzer_1_array_crystal_array_4_yheight;
MCNUM mccchannel_7_analyzer_1_array_crystal_array_4_zdepth;
MCNUM mccchannel_7_analyzer_1_array_crystal_array_4_xwidth2;
MCNUM mccchannel_7_analyzer_1_array_crystal_array_4_yheight2;
MCNUM mccchannel_7_analyzer_1_array_crystal_array_4_visualize;
int mccchannel_7_analyzer_1_array_crystal_array_4_target_index;
MCNUM mccchannel_7_analyzer_1_array_crystal_array_4_target_x;
MCNUM mccchannel_7_analyzer_1_array_crystal_array_4_target_y;
MCNUM mccchannel_7_analyzer_1_array_crystal_array_4_target_z;
MCNUM mccchannel_7_analyzer_1_array_crystal_array_4_focus_aw;
MCNUM mccchannel_7_analyzer_1_array_crystal_array_4_focus_ah;
MCNUM mccchannel_7_analyzer_1_array_crystal_array_4_focus_xw;
MCNUM mccchannel_7_analyzer_1_array_crystal_array_4_focus_xh;
MCNUM mccchannel_7_analyzer_1_array_crystal_array_4_focus_r;
MCNUM mccchannel_7_analyzer_1_array_crystal_array_4_p_interact;
char mccchannel_7_analyzer_1_array_crystal_array_4_mask_string[16384];
char mccchannel_7_analyzer_1_array_crystal_array_4_mask_setting[16384];
MCNUM mccchannel_7_analyzer_1_array_crystal_array_4_number_of_activations;

/* Setting parameters for component 'channel_7_analyzer_1_array_crystal_array_5' [401]. */
char mccchannel_7_analyzer_1_array_crystal_array_5_material_string[16384];
MCNUM mccchannel_7_analyzer_1_array_crystal_array_5_priority;
MCNUM mccchannel_7_analyzer_1_array_crystal_array_5_xwidth;
MCNUM mccchannel_7_analyzer_1_array_crystal_array_5_yheight;
MCNUM mccchannel_7_analyzer_1_array_crystal_array_5_zdepth;
MCNUM mccchannel_7_analyzer_1_array_crystal_array_5_xwidth2;
MCNUM mccchannel_7_analyzer_1_array_crystal_array_5_yheight2;
MCNUM mccchannel_7_analyzer_1_array_crystal_array_5_visualize;
int mccchannel_7_analyzer_1_array_crystal_array_5_target_index;
MCNUM mccchannel_7_analyzer_1_array_crystal_array_5_target_x;
MCNUM mccchannel_7_analyzer_1_array_crystal_array_5_target_y;
MCNUM mccchannel_7_analyzer_1_array_crystal_array_5_target_z;
MCNUM mccchannel_7_analyzer_1_array_crystal_array_5_focus_aw;
MCNUM mccchannel_7_analyzer_1_array_crystal_array_5_focus_ah;
MCNUM mccchannel_7_analyzer_1_array_crystal_array_5_focus_xw;
MCNUM mccchannel_7_analyzer_1_array_crystal_array_5_focus_xh;
MCNUM mccchannel_7_analyzer_1_array_crystal_array_5_focus_r;
MCNUM mccchannel_7_analyzer_1_array_crystal_array_5_p_interact;
char mccchannel_7_analyzer_1_array_crystal_array_5_mask_string[16384];
char mccchannel_7_analyzer_1_array_crystal_array_5_mask_setting[16384];
MCNUM mccchannel_7_analyzer_1_array_crystal_array_5_number_of_activations;

/* Setting parameters for component 'channel_7_analyzer_1_array_crystal_array_6' [402]. */
char mccchannel_7_analyzer_1_array_crystal_array_6_material_string[16384];
MCNUM mccchannel_7_analyzer_1_array_crystal_array_6_priority;
MCNUM mccchannel_7_analyzer_1_array_crystal_array_6_xwidth;
MCNUM mccchannel_7_analyzer_1_array_crystal_array_6_yheight;
MCNUM mccchannel_7_analyzer_1_array_crystal_array_6_zdepth;
MCNUM mccchannel_7_analyzer_1_array_crystal_array_6_xwidth2;
MCNUM mccchannel_7_analyzer_1_array_crystal_array_6_yheight2;
MCNUM mccchannel_7_analyzer_1_array_crystal_array_6_visualize;
int mccchannel_7_analyzer_1_array_crystal_array_6_target_index;
MCNUM mccchannel_7_analyzer_1_array_crystal_array_6_target_x;
MCNUM mccchannel_7_analyzer_1_array_crystal_array_6_target_y;
MCNUM mccchannel_7_analyzer_1_array_crystal_array_6_target_z;
MCNUM mccchannel_7_analyzer_1_array_crystal_array_6_focus_aw;
MCNUM mccchannel_7_analyzer_1_array_crystal_array_6_focus_ah;
MCNUM mccchannel_7_analyzer_1_array_crystal_array_6_focus_xw;
MCNUM mccchannel_7_analyzer_1_array_crystal_array_6_focus_xh;
MCNUM mccchannel_7_analyzer_1_array_crystal_array_6_focus_r;
MCNUM mccchannel_7_analyzer_1_array_crystal_array_6_p_interact;
char mccchannel_7_analyzer_1_array_crystal_array_6_mask_string[16384];
char mccchannel_7_analyzer_1_array_crystal_array_6_mask_setting[16384];
MCNUM mccchannel_7_analyzer_1_array_crystal_array_6_number_of_activations;

/* Setting parameters for component 'channel_7_analyzer_1_array_crystal_array_7' [403]. */
char mccchannel_7_analyzer_1_array_crystal_array_7_material_string[16384];
MCNUM mccchannel_7_analyzer_1_array_crystal_array_7_priority;
MCNUM mccchannel_7_analyzer_1_array_crystal_array_7_xwidth;
MCNUM mccchannel_7_analyzer_1_array_crystal_array_7_yheight;
MCNUM mccchannel_7_analyzer_1_array_crystal_array_7_zdepth;
MCNUM mccchannel_7_analyzer_1_array_crystal_array_7_xwidth2;
MCNUM mccchannel_7_analyzer_1_array_crystal_array_7_yheight2;
MCNUM mccchannel_7_analyzer_1_array_crystal_array_7_visualize;
int mccchannel_7_analyzer_1_array_crystal_array_7_target_index;
MCNUM mccchannel_7_analyzer_1_array_crystal_array_7_target_x;
MCNUM mccchannel_7_analyzer_1_array_crystal_array_7_target_y;
MCNUM mccchannel_7_analyzer_1_array_crystal_array_7_target_z;
MCNUM mccchannel_7_analyzer_1_array_crystal_array_7_focus_aw;
MCNUM mccchannel_7_analyzer_1_array_crystal_array_7_focus_ah;
MCNUM mccchannel_7_analyzer_1_array_crystal_array_7_focus_xw;
MCNUM mccchannel_7_analyzer_1_array_crystal_array_7_focus_xh;
MCNUM mccchannel_7_analyzer_1_array_crystal_array_7_focus_r;
MCNUM mccchannel_7_analyzer_1_array_crystal_array_7_p_interact;
char mccchannel_7_analyzer_1_array_crystal_array_7_mask_string[16384];
char mccchannel_7_analyzer_1_array_crystal_array_7_mask_setting[16384];
MCNUM mccchannel_7_analyzer_1_array_crystal_array_7_number_of_activations;

/* Setting parameters for component 'channel_7_analyzer_1_array_crystal_array_8' [404]. */
char mccchannel_7_analyzer_1_array_crystal_array_8_material_string[16384];
MCNUM mccchannel_7_analyzer_1_array_crystal_array_8_priority;
MCNUM mccchannel_7_analyzer_1_array_crystal_array_8_xwidth;
MCNUM mccchannel_7_analyzer_1_array_crystal_array_8_yheight;
MCNUM mccchannel_7_analyzer_1_array_crystal_array_8_zdepth;
MCNUM mccchannel_7_analyzer_1_array_crystal_array_8_xwidth2;
MCNUM mccchannel_7_analyzer_1_array_crystal_array_8_yheight2;
MCNUM mccchannel_7_analyzer_1_array_crystal_array_8_visualize;
int mccchannel_7_analyzer_1_array_crystal_array_8_target_index;
MCNUM mccchannel_7_analyzer_1_array_crystal_array_8_target_x;
MCNUM mccchannel_7_analyzer_1_array_crystal_array_8_target_y;
MCNUM mccchannel_7_analyzer_1_array_crystal_array_8_target_z;
MCNUM mccchannel_7_analyzer_1_array_crystal_array_8_focus_aw;
MCNUM mccchannel_7_analyzer_1_array_crystal_array_8_focus_ah;
MCNUM mccchannel_7_analyzer_1_array_crystal_array_8_focus_xw;
MCNUM mccchannel_7_analyzer_1_array_crystal_array_8_focus_xh;
MCNUM mccchannel_7_analyzer_1_array_crystal_array_8_focus_r;
MCNUM mccchannel_7_analyzer_1_array_crystal_array_8_p_interact;
char mccchannel_7_analyzer_1_array_crystal_array_8_mask_string[16384];
char mccchannel_7_analyzer_1_array_crystal_array_8_mask_setting[16384];
MCNUM mccchannel_7_analyzer_1_array_crystal_array_8_number_of_activations;

/* Setting parameters for component 'channel_7_analyzer_2_array_crystal_array_0' [407]. */
char mccchannel_7_analyzer_2_array_crystal_array_0_material_string[16384];
MCNUM mccchannel_7_analyzer_2_array_crystal_array_0_priority;
MCNUM mccchannel_7_analyzer_2_array_crystal_array_0_xwidth;
MCNUM mccchannel_7_analyzer_2_array_crystal_array_0_yheight;
MCNUM mccchannel_7_analyzer_2_array_crystal_array_0_zdepth;
MCNUM mccchannel_7_analyzer_2_array_crystal_array_0_xwidth2;
MCNUM mccchannel_7_analyzer_2_array_crystal_array_0_yheight2;
MCNUM mccchannel_7_analyzer_2_array_crystal_array_0_visualize;
int mccchannel_7_analyzer_2_array_crystal_array_0_target_index;
MCNUM mccchannel_7_analyzer_2_array_crystal_array_0_target_x;
MCNUM mccchannel_7_analyzer_2_array_crystal_array_0_target_y;
MCNUM mccchannel_7_analyzer_2_array_crystal_array_0_target_z;
MCNUM mccchannel_7_analyzer_2_array_crystal_array_0_focus_aw;
MCNUM mccchannel_7_analyzer_2_array_crystal_array_0_focus_ah;
MCNUM mccchannel_7_analyzer_2_array_crystal_array_0_focus_xw;
MCNUM mccchannel_7_analyzer_2_array_crystal_array_0_focus_xh;
MCNUM mccchannel_7_analyzer_2_array_crystal_array_0_focus_r;
MCNUM mccchannel_7_analyzer_2_array_crystal_array_0_p_interact;
char mccchannel_7_analyzer_2_array_crystal_array_0_mask_string[16384];
char mccchannel_7_analyzer_2_array_crystal_array_0_mask_setting[16384];
MCNUM mccchannel_7_analyzer_2_array_crystal_array_0_number_of_activations;

/* Setting parameters for component 'channel_7_analyzer_2_array_crystal_array_1' [408]. */
char mccchannel_7_analyzer_2_array_crystal_array_1_material_string[16384];
MCNUM mccchannel_7_analyzer_2_array_crystal_array_1_priority;
MCNUM mccchannel_7_analyzer_2_array_crystal_array_1_xwidth;
MCNUM mccchannel_7_analyzer_2_array_crystal_array_1_yheight;
MCNUM mccchannel_7_analyzer_2_array_crystal_array_1_zdepth;
MCNUM mccchannel_7_analyzer_2_array_crystal_array_1_xwidth2;
MCNUM mccchannel_7_analyzer_2_array_crystal_array_1_yheight2;
MCNUM mccchannel_7_analyzer_2_array_crystal_array_1_visualize;
int mccchannel_7_analyzer_2_array_crystal_array_1_target_index;
MCNUM mccchannel_7_analyzer_2_array_crystal_array_1_target_x;
MCNUM mccchannel_7_analyzer_2_array_crystal_array_1_target_y;
MCNUM mccchannel_7_analyzer_2_array_crystal_array_1_target_z;
MCNUM mccchannel_7_analyzer_2_array_crystal_array_1_focus_aw;
MCNUM mccchannel_7_analyzer_2_array_crystal_array_1_focus_ah;
MCNUM mccchannel_7_analyzer_2_array_crystal_array_1_focus_xw;
MCNUM mccchannel_7_analyzer_2_array_crystal_array_1_focus_xh;
MCNUM mccchannel_7_analyzer_2_array_crystal_array_1_focus_r;
MCNUM mccchannel_7_analyzer_2_array_crystal_array_1_p_interact;
char mccchannel_7_analyzer_2_array_crystal_array_1_mask_string[16384];
char mccchannel_7_analyzer_2_array_crystal_array_1_mask_setting[16384];
MCNUM mccchannel_7_analyzer_2_array_crystal_array_1_number_of_activations;

/* Setting parameters for component 'channel_7_analyzer_2_array_crystal_array_2' [409]. */
char mccchannel_7_analyzer_2_array_crystal_array_2_material_string[16384];
MCNUM mccchannel_7_analyzer_2_array_crystal_array_2_priority;
MCNUM mccchannel_7_analyzer_2_array_crystal_array_2_xwidth;
MCNUM mccchannel_7_analyzer_2_array_crystal_array_2_yheight;
MCNUM mccchannel_7_analyzer_2_array_crystal_array_2_zdepth;
MCNUM mccchannel_7_analyzer_2_array_crystal_array_2_xwidth2;
MCNUM mccchannel_7_analyzer_2_array_crystal_array_2_yheight2;
MCNUM mccchannel_7_analyzer_2_array_crystal_array_2_visualize;
int mccchannel_7_analyzer_2_array_crystal_array_2_target_index;
MCNUM mccchannel_7_analyzer_2_array_crystal_array_2_target_x;
MCNUM mccchannel_7_analyzer_2_array_crystal_array_2_target_y;
MCNUM mccchannel_7_analyzer_2_array_crystal_array_2_target_z;
MCNUM mccchannel_7_analyzer_2_array_crystal_array_2_focus_aw;
MCNUM mccchannel_7_analyzer_2_array_crystal_array_2_focus_ah;
MCNUM mccchannel_7_analyzer_2_array_crystal_array_2_focus_xw;
MCNUM mccchannel_7_analyzer_2_array_crystal_array_2_focus_xh;
MCNUM mccchannel_7_analyzer_2_array_crystal_array_2_focus_r;
MCNUM mccchannel_7_analyzer_2_array_crystal_array_2_p_interact;
char mccchannel_7_analyzer_2_array_crystal_array_2_mask_string[16384];
char mccchannel_7_analyzer_2_array_crystal_array_2_mask_setting[16384];
MCNUM mccchannel_7_analyzer_2_array_crystal_array_2_number_of_activations;

/* Setting parameters for component 'channel_7_analyzer_2_array_crystal_array_3' [410]. */
char mccchannel_7_analyzer_2_array_crystal_array_3_material_string[16384];
MCNUM mccchannel_7_analyzer_2_array_crystal_array_3_priority;
MCNUM mccchannel_7_analyzer_2_array_crystal_array_3_xwidth;
MCNUM mccchannel_7_analyzer_2_array_crystal_array_3_yheight;
MCNUM mccchannel_7_analyzer_2_array_crystal_array_3_zdepth;
MCNUM mccchannel_7_analyzer_2_array_crystal_array_3_xwidth2;
MCNUM mccchannel_7_analyzer_2_array_crystal_array_3_yheight2;
MCNUM mccchannel_7_analyzer_2_array_crystal_array_3_visualize;
int mccchannel_7_analyzer_2_array_crystal_array_3_target_index;
MCNUM mccchannel_7_analyzer_2_array_crystal_array_3_target_x;
MCNUM mccchannel_7_analyzer_2_array_crystal_array_3_target_y;
MCNUM mccchannel_7_analyzer_2_array_crystal_array_3_target_z;
MCNUM mccchannel_7_analyzer_2_array_crystal_array_3_focus_aw;
MCNUM mccchannel_7_analyzer_2_array_crystal_array_3_focus_ah;
MCNUM mccchannel_7_analyzer_2_array_crystal_array_3_focus_xw;
MCNUM mccchannel_7_analyzer_2_array_crystal_array_3_focus_xh;
MCNUM mccchannel_7_analyzer_2_array_crystal_array_3_focus_r;
MCNUM mccchannel_7_analyzer_2_array_crystal_array_3_p_interact;
char mccchannel_7_analyzer_2_array_crystal_array_3_mask_string[16384];
char mccchannel_7_analyzer_2_array_crystal_array_3_mask_setting[16384];
MCNUM mccchannel_7_analyzer_2_array_crystal_array_3_number_of_activations;

/* Setting parameters for component 'channel_7_analyzer_2_array_crystal_array_4' [411]. */
char mccchannel_7_analyzer_2_array_crystal_array_4_material_string[16384];
MCNUM mccchannel_7_analyzer_2_array_crystal_array_4_priority;
MCNUM mccchannel_7_analyzer_2_array_crystal_array_4_xwidth;
MCNUM mccchannel_7_analyzer_2_array_crystal_array_4_yheight;
MCNUM mccchannel_7_analyzer_2_array_crystal_array_4_zdepth;
MCNUM mccchannel_7_analyzer_2_array_crystal_array_4_xwidth2;
MCNUM mccchannel_7_analyzer_2_array_crystal_array_4_yheight2;
MCNUM mccchannel_7_analyzer_2_array_crystal_array_4_visualize;
int mccchannel_7_analyzer_2_array_crystal_array_4_target_index;
MCNUM mccchannel_7_analyzer_2_array_crystal_array_4_target_x;
MCNUM mccchannel_7_analyzer_2_array_crystal_array_4_target_y;
MCNUM mccchannel_7_analyzer_2_array_crystal_array_4_target_z;
MCNUM mccchannel_7_analyzer_2_array_crystal_array_4_focus_aw;
MCNUM mccchannel_7_analyzer_2_array_crystal_array_4_focus_ah;
MCNUM mccchannel_7_analyzer_2_array_crystal_array_4_focus_xw;
MCNUM mccchannel_7_analyzer_2_array_crystal_array_4_focus_xh;
MCNUM mccchannel_7_analyzer_2_array_crystal_array_4_focus_r;
MCNUM mccchannel_7_analyzer_2_array_crystal_array_4_p_interact;
char mccchannel_7_analyzer_2_array_crystal_array_4_mask_string[16384];
char mccchannel_7_analyzer_2_array_crystal_array_4_mask_setting[16384];
MCNUM mccchannel_7_analyzer_2_array_crystal_array_4_number_of_activations;

/* Setting parameters for component 'channel_7_analyzer_2_array_crystal_array_5' [412]. */
char mccchannel_7_analyzer_2_array_crystal_array_5_material_string[16384];
MCNUM mccchannel_7_analyzer_2_array_crystal_array_5_priority;
MCNUM mccchannel_7_analyzer_2_array_crystal_array_5_xwidth;
MCNUM mccchannel_7_analyzer_2_array_crystal_array_5_yheight;
MCNUM mccchannel_7_analyzer_2_array_crystal_array_5_zdepth;
MCNUM mccchannel_7_analyzer_2_array_crystal_array_5_xwidth2;
MCNUM mccchannel_7_analyzer_2_array_crystal_array_5_yheight2;
MCNUM mccchannel_7_analyzer_2_array_crystal_array_5_visualize;
int mccchannel_7_analyzer_2_array_crystal_array_5_target_index;
MCNUM mccchannel_7_analyzer_2_array_crystal_array_5_target_x;
MCNUM mccchannel_7_analyzer_2_array_crystal_array_5_target_y;
MCNUM mccchannel_7_analyzer_2_array_crystal_array_5_target_z;
MCNUM mccchannel_7_analyzer_2_array_crystal_array_5_focus_aw;
MCNUM mccchannel_7_analyzer_2_array_crystal_array_5_focus_ah;
MCNUM mccchannel_7_analyzer_2_array_crystal_array_5_focus_xw;
MCNUM mccchannel_7_analyzer_2_array_crystal_array_5_focus_xh;
MCNUM mccchannel_7_analyzer_2_array_crystal_array_5_focus_r;
MCNUM mccchannel_7_analyzer_2_array_crystal_array_5_p_interact;
char mccchannel_7_analyzer_2_array_crystal_array_5_mask_string[16384];
char mccchannel_7_analyzer_2_array_crystal_array_5_mask_setting[16384];
MCNUM mccchannel_7_analyzer_2_array_crystal_array_5_number_of_activations;

/* Setting parameters for component 'channel_7_analyzer_2_array_crystal_array_6' [413]. */
char mccchannel_7_analyzer_2_array_crystal_array_6_material_string[16384];
MCNUM mccchannel_7_analyzer_2_array_crystal_array_6_priority;
MCNUM mccchannel_7_analyzer_2_array_crystal_array_6_xwidth;
MCNUM mccchannel_7_analyzer_2_array_crystal_array_6_yheight;
MCNUM mccchannel_7_analyzer_2_array_crystal_array_6_zdepth;
MCNUM mccchannel_7_analyzer_2_array_crystal_array_6_xwidth2;
MCNUM mccchannel_7_analyzer_2_array_crystal_array_6_yheight2;
MCNUM mccchannel_7_analyzer_2_array_crystal_array_6_visualize;
int mccchannel_7_analyzer_2_array_crystal_array_6_target_index;
MCNUM mccchannel_7_analyzer_2_array_crystal_array_6_target_x;
MCNUM mccchannel_7_analyzer_2_array_crystal_array_6_target_y;
MCNUM mccchannel_7_analyzer_2_array_crystal_array_6_target_z;
MCNUM mccchannel_7_analyzer_2_array_crystal_array_6_focus_aw;
MCNUM mccchannel_7_analyzer_2_array_crystal_array_6_focus_ah;
MCNUM mccchannel_7_analyzer_2_array_crystal_array_6_focus_xw;
MCNUM mccchannel_7_analyzer_2_array_crystal_array_6_focus_xh;
MCNUM mccchannel_7_analyzer_2_array_crystal_array_6_focus_r;
MCNUM mccchannel_7_analyzer_2_array_crystal_array_6_p_interact;
char mccchannel_7_analyzer_2_array_crystal_array_6_mask_string[16384];
char mccchannel_7_analyzer_2_array_crystal_array_6_mask_setting[16384];
MCNUM mccchannel_7_analyzer_2_array_crystal_array_6_number_of_activations;

/* Setting parameters for component 'channel_7_analyzer_2_array_crystal_array_7' [414]. */
char mccchannel_7_analyzer_2_array_crystal_array_7_material_string[16384];
MCNUM mccchannel_7_analyzer_2_array_crystal_array_7_priority;
MCNUM mccchannel_7_analyzer_2_array_crystal_array_7_xwidth;
MCNUM mccchannel_7_analyzer_2_array_crystal_array_7_yheight;
MCNUM mccchannel_7_analyzer_2_array_crystal_array_7_zdepth;
MCNUM mccchannel_7_analyzer_2_array_crystal_array_7_xwidth2;
MCNUM mccchannel_7_analyzer_2_array_crystal_array_7_yheight2;
MCNUM mccchannel_7_analyzer_2_array_crystal_array_7_visualize;
int mccchannel_7_analyzer_2_array_crystal_array_7_target_index;
MCNUM mccchannel_7_analyzer_2_array_crystal_array_7_target_x;
MCNUM mccchannel_7_analyzer_2_array_crystal_array_7_target_y;
MCNUM mccchannel_7_analyzer_2_array_crystal_array_7_target_z;
MCNUM mccchannel_7_analyzer_2_array_crystal_array_7_focus_aw;
MCNUM mccchannel_7_analyzer_2_array_crystal_array_7_focus_ah;
MCNUM mccchannel_7_analyzer_2_array_crystal_array_7_focus_xw;
MCNUM mccchannel_7_analyzer_2_array_crystal_array_7_focus_xh;
MCNUM mccchannel_7_analyzer_2_array_crystal_array_7_focus_r;
MCNUM mccchannel_7_analyzer_2_array_crystal_array_7_p_interact;
char mccchannel_7_analyzer_2_array_crystal_array_7_mask_string[16384];
char mccchannel_7_analyzer_2_array_crystal_array_7_mask_setting[16384];
MCNUM mccchannel_7_analyzer_2_array_crystal_array_7_number_of_activations;

/* Setting parameters for component 'channel_7_analyzer_2_array_crystal_array_8' [415]. */
char mccchannel_7_analyzer_2_array_crystal_array_8_material_string[16384];
MCNUM mccchannel_7_analyzer_2_array_crystal_array_8_priority;
MCNUM mccchannel_7_analyzer_2_array_crystal_array_8_xwidth;
MCNUM mccchannel_7_analyzer_2_array_crystal_array_8_yheight;
MCNUM mccchannel_7_analyzer_2_array_crystal_array_8_zdepth;
MCNUM mccchannel_7_analyzer_2_array_crystal_array_8_xwidth2;
MCNUM mccchannel_7_analyzer_2_array_crystal_array_8_yheight2;
MCNUM mccchannel_7_analyzer_2_array_crystal_array_8_visualize;
int mccchannel_7_analyzer_2_array_crystal_array_8_target_index;
MCNUM mccchannel_7_analyzer_2_array_crystal_array_8_target_x;
MCNUM mccchannel_7_analyzer_2_array_crystal_array_8_target_y;
MCNUM mccchannel_7_analyzer_2_array_crystal_array_8_target_z;
MCNUM mccchannel_7_analyzer_2_array_crystal_array_8_focus_aw;
MCNUM mccchannel_7_analyzer_2_array_crystal_array_8_focus_ah;
MCNUM mccchannel_7_analyzer_2_array_crystal_array_8_focus_xw;
MCNUM mccchannel_7_analyzer_2_array_crystal_array_8_focus_xh;
MCNUM mccchannel_7_analyzer_2_array_crystal_array_8_focus_r;
MCNUM mccchannel_7_analyzer_2_array_crystal_array_8_p_interact;
char mccchannel_7_analyzer_2_array_crystal_array_8_mask_string[16384];
char mccchannel_7_analyzer_2_array_crystal_array_8_mask_setting[16384];
MCNUM mccchannel_7_analyzer_2_array_crystal_array_8_number_of_activations;

/* Setting parameters for component 'channel_7_cave2_cyl1' [416]. */
char mccchannel_7_cave2_cyl1_material_string[16384];
MCNUM mccchannel_7_cave2_cyl1_priority;
MCNUM mccchannel_7_cave2_cyl1_radius;
MCNUM mccchannel_7_cave2_cyl1_yheight;
MCNUM mccchannel_7_cave2_cyl1_visualize;
int mccchannel_7_cave2_cyl1_target_index;
MCNUM mccchannel_7_cave2_cyl1_target_x;
MCNUM mccchannel_7_cave2_cyl1_target_y;
MCNUM mccchannel_7_cave2_cyl1_target_z;
MCNUM mccchannel_7_cave2_cyl1_focus_aw;
MCNUM mccchannel_7_cave2_cyl1_focus_ah;
MCNUM mccchannel_7_cave2_cyl1_focus_xw;
MCNUM mccchannel_7_cave2_cyl1_focus_xh;
MCNUM mccchannel_7_cave2_cyl1_focus_r;
MCNUM mccchannel_7_cave2_cyl1_p_interact;
char mccchannel_7_cave2_cyl1_mask_string[16384];
char mccchannel_7_cave2_cyl1_mask_setting[16384];
MCNUM mccchannel_7_cave2_cyl1_number_of_activations;

/* Setting parameters for component 'channel_7_cave2_box1' [417]. */
char mccchannel_7_cave2_box1_material_string[16384];
MCNUM mccchannel_7_cave2_box1_priority;
MCNUM mccchannel_7_cave2_box1_xwidth;
MCNUM mccchannel_7_cave2_box1_yheight;
MCNUM mccchannel_7_cave2_box1_zdepth;
MCNUM mccchannel_7_cave2_box1_xwidth2;
MCNUM mccchannel_7_cave2_box1_yheight2;
MCNUM mccchannel_7_cave2_box1_visualize;
int mccchannel_7_cave2_box1_target_index;
MCNUM mccchannel_7_cave2_box1_target_x;
MCNUM mccchannel_7_cave2_box1_target_y;
MCNUM mccchannel_7_cave2_box1_target_z;
MCNUM mccchannel_7_cave2_box1_focus_aw;
MCNUM mccchannel_7_cave2_box1_focus_ah;
MCNUM mccchannel_7_cave2_box1_focus_xw;
MCNUM mccchannel_7_cave2_box1_focus_xh;
MCNUM mccchannel_7_cave2_box1_focus_r;
MCNUM mccchannel_7_cave2_box1_p_interact;
char mccchannel_7_cave2_box1_mask_string[16384];
char mccchannel_7_cave2_box1_mask_setting[16384];
MCNUM mccchannel_7_cave2_box1_number_of_activations;

/* Setting parameters for component 'channel_7_cave2_box2' [418]. */
char mccchannel_7_cave2_box2_material_string[16384];
MCNUM mccchannel_7_cave2_box2_priority;
MCNUM mccchannel_7_cave2_box2_xwidth;
MCNUM mccchannel_7_cave2_box2_yheight;
MCNUM mccchannel_7_cave2_box2_zdepth;
MCNUM mccchannel_7_cave2_box2_xwidth2;
MCNUM mccchannel_7_cave2_box2_yheight2;
MCNUM mccchannel_7_cave2_box2_visualize;
int mccchannel_7_cave2_box2_target_index;
MCNUM mccchannel_7_cave2_box2_target_x;
MCNUM mccchannel_7_cave2_box2_target_y;
MCNUM mccchannel_7_cave2_box2_target_z;
MCNUM mccchannel_7_cave2_box2_focus_aw;
MCNUM mccchannel_7_cave2_box2_focus_ah;
MCNUM mccchannel_7_cave2_box2_focus_xw;
MCNUM mccchannel_7_cave2_box2_focus_xh;
MCNUM mccchannel_7_cave2_box2_focus_r;
MCNUM mccchannel_7_cave2_box2_p_interact;
char mccchannel_7_cave2_box2_mask_string[16384];
char mccchannel_7_cave2_box2_mask_setting[16384];
MCNUM mccchannel_7_cave2_box2_number_of_activations;

/* Setting parameters for component 'channel_7_cave2_box3' [419]. */
char mccchannel_7_cave2_box3_material_string[16384];
MCNUM mccchannel_7_cave2_box3_priority;
MCNUM mccchannel_7_cave2_box3_xwidth;
MCNUM mccchannel_7_cave2_box3_yheight;
MCNUM mccchannel_7_cave2_box3_zdepth;
MCNUM mccchannel_7_cave2_box3_xwidth2;
MCNUM mccchannel_7_cave2_box3_yheight2;
MCNUM mccchannel_7_cave2_box3_visualize;
int mccchannel_7_cave2_box3_target_index;
MCNUM mccchannel_7_cave2_box3_target_x;
MCNUM mccchannel_7_cave2_box3_target_y;
MCNUM mccchannel_7_cave2_box3_target_z;
MCNUM mccchannel_7_cave2_box3_focus_aw;
MCNUM mccchannel_7_cave2_box3_focus_ah;
MCNUM mccchannel_7_cave2_box3_focus_xw;
MCNUM mccchannel_7_cave2_box3_focus_xh;
MCNUM mccchannel_7_cave2_box3_focus_r;
MCNUM mccchannel_7_cave2_box3_p_interact;
char mccchannel_7_cave2_box3_mask_string[16384];
char mccchannel_7_cave2_box3_mask_setting[16384];
MCNUM mccchannel_7_cave2_box3_number_of_activations;

/* Setting parameters for component 'inter_analyzer_colimator_7_blade_0' [421]. */
char mccinter_analyzer_colimator_7_blade_0_material_string[16384];
MCNUM mccinter_analyzer_colimator_7_blade_0_priority;
MCNUM mccinter_analyzer_colimator_7_blade_0_xwidth;
MCNUM mccinter_analyzer_colimator_7_blade_0_yheight;
MCNUM mccinter_analyzer_colimator_7_blade_0_zdepth;
MCNUM mccinter_analyzer_colimator_7_blade_0_xwidth2;
MCNUM mccinter_analyzer_colimator_7_blade_0_yheight2;
MCNUM mccinter_analyzer_colimator_7_blade_0_visualize;
int mccinter_analyzer_colimator_7_blade_0_target_index;
MCNUM mccinter_analyzer_colimator_7_blade_0_target_x;
MCNUM mccinter_analyzer_colimator_7_blade_0_target_y;
MCNUM mccinter_analyzer_colimator_7_blade_0_target_z;
MCNUM mccinter_analyzer_colimator_7_blade_0_focus_aw;
MCNUM mccinter_analyzer_colimator_7_blade_0_focus_ah;
MCNUM mccinter_analyzer_colimator_7_blade_0_focus_xw;
MCNUM mccinter_analyzer_colimator_7_blade_0_focus_xh;
MCNUM mccinter_analyzer_colimator_7_blade_0_focus_r;
MCNUM mccinter_analyzer_colimator_7_blade_0_p_interact;
char mccinter_analyzer_colimator_7_blade_0_mask_string[16384];
char mccinter_analyzer_colimator_7_blade_0_mask_setting[16384];
MCNUM mccinter_analyzer_colimator_7_blade_0_number_of_activations;

/* Setting parameters for component 'inter_analyzer_colimator_7_blade_1' [422]. */
char mccinter_analyzer_colimator_7_blade_1_material_string[16384];
MCNUM mccinter_analyzer_colimator_7_blade_1_priority;
MCNUM mccinter_analyzer_colimator_7_blade_1_xwidth;
MCNUM mccinter_analyzer_colimator_7_blade_1_yheight;
MCNUM mccinter_analyzer_colimator_7_blade_1_zdepth;
MCNUM mccinter_analyzer_colimator_7_blade_1_xwidth2;
MCNUM mccinter_analyzer_colimator_7_blade_1_yheight2;
MCNUM mccinter_analyzer_colimator_7_blade_1_visualize;
int mccinter_analyzer_colimator_7_blade_1_target_index;
MCNUM mccinter_analyzer_colimator_7_blade_1_target_x;
MCNUM mccinter_analyzer_colimator_7_blade_1_target_y;
MCNUM mccinter_analyzer_colimator_7_blade_1_target_z;
MCNUM mccinter_analyzer_colimator_7_blade_1_focus_aw;
MCNUM mccinter_analyzer_colimator_7_blade_1_focus_ah;
MCNUM mccinter_analyzer_colimator_7_blade_1_focus_xw;
MCNUM mccinter_analyzer_colimator_7_blade_1_focus_xh;
MCNUM mccinter_analyzer_colimator_7_blade_1_focus_r;
MCNUM mccinter_analyzer_colimator_7_blade_1_p_interact;
char mccinter_analyzer_colimator_7_blade_1_mask_string[16384];
char mccinter_analyzer_colimator_7_blade_1_mask_setting[16384];
MCNUM mccinter_analyzer_colimator_7_blade_1_number_of_activations;

/* Setting parameters for component 'inter_analyzer_colimator_7_blade_2' [423]. */
char mccinter_analyzer_colimator_7_blade_2_material_string[16384];
MCNUM mccinter_analyzer_colimator_7_blade_2_priority;
MCNUM mccinter_analyzer_colimator_7_blade_2_xwidth;
MCNUM mccinter_analyzer_colimator_7_blade_2_yheight;
MCNUM mccinter_analyzer_colimator_7_blade_2_zdepth;
MCNUM mccinter_analyzer_colimator_7_blade_2_xwidth2;
MCNUM mccinter_analyzer_colimator_7_blade_2_yheight2;
MCNUM mccinter_analyzer_colimator_7_blade_2_visualize;
int mccinter_analyzer_colimator_7_blade_2_target_index;
MCNUM mccinter_analyzer_colimator_7_blade_2_target_x;
MCNUM mccinter_analyzer_colimator_7_blade_2_target_y;
MCNUM mccinter_analyzer_colimator_7_blade_2_target_z;
MCNUM mccinter_analyzer_colimator_7_blade_2_focus_aw;
MCNUM mccinter_analyzer_colimator_7_blade_2_focus_ah;
MCNUM mccinter_analyzer_colimator_7_blade_2_focus_xw;
MCNUM mccinter_analyzer_colimator_7_blade_2_focus_xh;
MCNUM mccinter_analyzer_colimator_7_blade_2_focus_r;
MCNUM mccinter_analyzer_colimator_7_blade_2_p_interact;
char mccinter_analyzer_colimator_7_blade_2_mask_string[16384];
char mccinter_analyzer_colimator_7_blade_2_mask_setting[16384];
MCNUM mccinter_analyzer_colimator_7_blade_2_number_of_activations;

/* Setting parameters for component 'inter_analyzer_colimator_7_blade_3' [424]. */
char mccinter_analyzer_colimator_7_blade_3_material_string[16384];
MCNUM mccinter_analyzer_colimator_7_blade_3_priority;
MCNUM mccinter_analyzer_colimator_7_blade_3_xwidth;
MCNUM mccinter_analyzer_colimator_7_blade_3_yheight;
MCNUM mccinter_analyzer_colimator_7_blade_3_zdepth;
MCNUM mccinter_analyzer_colimator_7_blade_3_xwidth2;
MCNUM mccinter_analyzer_colimator_7_blade_3_yheight2;
MCNUM mccinter_analyzer_colimator_7_blade_3_visualize;
int mccinter_analyzer_colimator_7_blade_3_target_index;
MCNUM mccinter_analyzer_colimator_7_blade_3_target_x;
MCNUM mccinter_analyzer_colimator_7_blade_3_target_y;
MCNUM mccinter_analyzer_colimator_7_blade_3_target_z;
MCNUM mccinter_analyzer_colimator_7_blade_3_focus_aw;
MCNUM mccinter_analyzer_colimator_7_blade_3_focus_ah;
MCNUM mccinter_analyzer_colimator_7_blade_3_focus_xw;
MCNUM mccinter_analyzer_colimator_7_blade_3_focus_xh;
MCNUM mccinter_analyzer_colimator_7_blade_3_focus_r;
MCNUM mccinter_analyzer_colimator_7_blade_3_p_interact;
char mccinter_analyzer_colimator_7_blade_3_mask_string[16384];
char mccinter_analyzer_colimator_7_blade_3_mask_setting[16384];
MCNUM mccinter_analyzer_colimator_7_blade_3_number_of_activations;

/* Setting parameters for component 'inter_analyzer_colimator_7_blade_4' [425]. */
char mccinter_analyzer_colimator_7_blade_4_material_string[16384];
MCNUM mccinter_analyzer_colimator_7_blade_4_priority;
MCNUM mccinter_analyzer_colimator_7_blade_4_xwidth;
MCNUM mccinter_analyzer_colimator_7_blade_4_yheight;
MCNUM mccinter_analyzer_colimator_7_blade_4_zdepth;
MCNUM mccinter_analyzer_colimator_7_blade_4_xwidth2;
MCNUM mccinter_analyzer_colimator_7_blade_4_yheight2;
MCNUM mccinter_analyzer_colimator_7_blade_4_visualize;
int mccinter_analyzer_colimator_7_blade_4_target_index;
MCNUM mccinter_analyzer_colimator_7_blade_4_target_x;
MCNUM mccinter_analyzer_colimator_7_blade_4_target_y;
MCNUM mccinter_analyzer_colimator_7_blade_4_target_z;
MCNUM mccinter_analyzer_colimator_7_blade_4_focus_aw;
MCNUM mccinter_analyzer_colimator_7_blade_4_focus_ah;
MCNUM mccinter_analyzer_colimator_7_blade_4_focus_xw;
MCNUM mccinter_analyzer_colimator_7_blade_4_focus_xh;
MCNUM mccinter_analyzer_colimator_7_blade_4_focus_r;
MCNUM mccinter_analyzer_colimator_7_blade_4_p_interact;
char mccinter_analyzer_colimator_7_blade_4_mask_string[16384];
char mccinter_analyzer_colimator_7_blade_4_mask_setting[16384];
MCNUM mccinter_analyzer_colimator_7_blade_4_number_of_activations;

/* Setting parameters for component 'diffraction_detector_7_exit_volume' [426]. */
char mccdiffraction_detector_7_exit_volume_material_string[16384];
MCNUM mccdiffraction_detector_7_exit_volume_priority;
MCNUM mccdiffraction_detector_7_exit_volume_xwidth;
MCNUM mccdiffraction_detector_7_exit_volume_yheight;
MCNUM mccdiffraction_detector_7_exit_volume_zdepth;
MCNUM mccdiffraction_detector_7_exit_volume_xwidth2;
MCNUM mccdiffraction_detector_7_exit_volume_yheight2;
MCNUM mccdiffraction_detector_7_exit_volume_visualize;
int mccdiffraction_detector_7_exit_volume_target_index;
MCNUM mccdiffraction_detector_7_exit_volume_target_x;
MCNUM mccdiffraction_detector_7_exit_volume_target_y;
MCNUM mccdiffraction_detector_7_exit_volume_target_z;
MCNUM mccdiffraction_detector_7_exit_volume_focus_aw;
MCNUM mccdiffraction_detector_7_exit_volume_focus_ah;
MCNUM mccdiffraction_detector_7_exit_volume_focus_xw;
MCNUM mccdiffraction_detector_7_exit_volume_focus_xh;
MCNUM mccdiffraction_detector_7_exit_volume_focus_r;
MCNUM mccdiffraction_detector_7_exit_volume_p_interact;
char mccdiffraction_detector_7_exit_volume_mask_string[16384];
char mccdiffraction_detector_7_exit_volume_mask_setting[16384];
MCNUM mccdiffraction_detector_7_exit_volume_number_of_activations;

/* Setting parameters for component 'spec_detector_7_exit_volume' [427]. */
char mccspec_detector_7_exit_volume_material_string[16384];
MCNUM mccspec_detector_7_exit_volume_priority;
MCNUM mccspec_detector_7_exit_volume_xwidth;
MCNUM mccspec_detector_7_exit_volume_yheight;
MCNUM mccspec_detector_7_exit_volume_zdepth;
MCNUM mccspec_detector_7_exit_volume_xwidth2;
MCNUM mccspec_detector_7_exit_volume_yheight2;
MCNUM mccspec_detector_7_exit_volume_visualize;
int mccspec_detector_7_exit_volume_target_index;
MCNUM mccspec_detector_7_exit_volume_target_x;
MCNUM mccspec_detector_7_exit_volume_target_y;
MCNUM mccspec_detector_7_exit_volume_target_z;
MCNUM mccspec_detector_7_exit_volume_focus_aw;
MCNUM mccspec_detector_7_exit_volume_focus_ah;
MCNUM mccspec_detector_7_exit_volume_focus_xw;
MCNUM mccspec_detector_7_exit_volume_focus_xh;
MCNUM mccspec_detector_7_exit_volume_focus_r;
MCNUM mccspec_detector_7_exit_volume_p_interact;
char mccspec_detector_7_exit_volume_mask_string[16384];
char mccspec_detector_7_exit_volume_mask_setting[16384];
MCNUM mccspec_detector_7_exit_volume_number_of_activations;

/* Setting parameters for component 'channel_8_cave1_box1' [428]. */
char mccchannel_8_cave1_box1_material_string[16384];
MCNUM mccchannel_8_cave1_box1_priority;
MCNUM mccchannel_8_cave1_box1_xwidth;
MCNUM mccchannel_8_cave1_box1_yheight;
MCNUM mccchannel_8_cave1_box1_zdepth;
MCNUM mccchannel_8_cave1_box1_xwidth2;
MCNUM mccchannel_8_cave1_box1_yheight2;
MCNUM mccchannel_8_cave1_box1_visualize;
int mccchannel_8_cave1_box1_target_index;
MCNUM mccchannel_8_cave1_box1_target_x;
MCNUM mccchannel_8_cave1_box1_target_y;
MCNUM mccchannel_8_cave1_box1_target_z;
MCNUM mccchannel_8_cave1_box1_focus_aw;
MCNUM mccchannel_8_cave1_box1_focus_ah;
MCNUM mccchannel_8_cave1_box1_focus_xw;
MCNUM mccchannel_8_cave1_box1_focus_xh;
MCNUM mccchannel_8_cave1_box1_focus_r;
MCNUM mccchannel_8_cave1_box1_p_interact;
char mccchannel_8_cave1_box1_mask_string[16384];
char mccchannel_8_cave1_box1_mask_setting[16384];
MCNUM mccchannel_8_cave1_box1_number_of_activations;

/* Setting parameters for component 'channel_8_cave1_box2' [429]. */
char mccchannel_8_cave1_box2_material_string[16384];
MCNUM mccchannel_8_cave1_box2_priority;
MCNUM mccchannel_8_cave1_box2_xwidth;
MCNUM mccchannel_8_cave1_box2_yheight;
MCNUM mccchannel_8_cave1_box2_zdepth;
MCNUM mccchannel_8_cave1_box2_xwidth2;
MCNUM mccchannel_8_cave1_box2_yheight2;
MCNUM mccchannel_8_cave1_box2_visualize;
int mccchannel_8_cave1_box2_target_index;
MCNUM mccchannel_8_cave1_box2_target_x;
MCNUM mccchannel_8_cave1_box2_target_y;
MCNUM mccchannel_8_cave1_box2_target_z;
MCNUM mccchannel_8_cave1_box2_focus_aw;
MCNUM mccchannel_8_cave1_box2_focus_ah;
MCNUM mccchannel_8_cave1_box2_focus_xw;
MCNUM mccchannel_8_cave1_box2_focus_xh;
MCNUM mccchannel_8_cave1_box2_focus_r;
MCNUM mccchannel_8_cave1_box2_p_interact;
char mccchannel_8_cave1_box2_mask_string[16384];
char mccchannel_8_cave1_box2_mask_setting[16384];
MCNUM mccchannel_8_cave1_box2_number_of_activations;

/* Setting parameters for component 'channel_8_cave1_box3' [430]. */
char mccchannel_8_cave1_box3_material_string[16384];
MCNUM mccchannel_8_cave1_box3_priority;
MCNUM mccchannel_8_cave1_box3_xwidth;
MCNUM mccchannel_8_cave1_box3_yheight;
MCNUM mccchannel_8_cave1_box3_zdepth;
MCNUM mccchannel_8_cave1_box3_xwidth2;
MCNUM mccchannel_8_cave1_box3_yheight2;
MCNUM mccchannel_8_cave1_box3_visualize;
int mccchannel_8_cave1_box3_target_index;
MCNUM mccchannel_8_cave1_box3_target_x;
MCNUM mccchannel_8_cave1_box3_target_y;
MCNUM mccchannel_8_cave1_box3_target_z;
MCNUM mccchannel_8_cave1_box3_focus_aw;
MCNUM mccchannel_8_cave1_box3_focus_ah;
MCNUM mccchannel_8_cave1_box3_focus_xw;
MCNUM mccchannel_8_cave1_box3_focus_xh;
MCNUM mccchannel_8_cave1_box3_focus_r;
MCNUM mccchannel_8_cave1_box3_p_interact;
char mccchannel_8_cave1_box3_mask_string[16384];
char mccchannel_8_cave1_box3_mask_setting[16384];
MCNUM mccchannel_8_cave1_box3_number_of_activations;

/* Setting parameters for component 'channel_8_cave1_cyl1' [431]. */
char mccchannel_8_cave1_cyl1_material_string[16384];
MCNUM mccchannel_8_cave1_cyl1_priority;
MCNUM mccchannel_8_cave1_cyl1_radius;
MCNUM mccchannel_8_cave1_cyl1_yheight;
MCNUM mccchannel_8_cave1_cyl1_visualize;
int mccchannel_8_cave1_cyl1_target_index;
MCNUM mccchannel_8_cave1_cyl1_target_x;
MCNUM mccchannel_8_cave1_cyl1_target_y;
MCNUM mccchannel_8_cave1_cyl1_target_z;
MCNUM mccchannel_8_cave1_cyl1_focus_aw;
MCNUM mccchannel_8_cave1_cyl1_focus_ah;
MCNUM mccchannel_8_cave1_cyl1_focus_xw;
MCNUM mccchannel_8_cave1_cyl1_focus_xh;
MCNUM mccchannel_8_cave1_cyl1_focus_r;
MCNUM mccchannel_8_cave1_cyl1_p_interact;
char mccchannel_8_cave1_cyl1_mask_string[16384];
char mccchannel_8_cave1_cyl1_mask_setting[16384];
MCNUM mccchannel_8_cave1_cyl1_number_of_activations;

/* Setting parameters for component 'channel_8_analyzer_1_array_crystal_array_0' [434]. */
char mccchannel_8_analyzer_1_array_crystal_array_0_material_string[16384];
MCNUM mccchannel_8_analyzer_1_array_crystal_array_0_priority;
MCNUM mccchannel_8_analyzer_1_array_crystal_array_0_xwidth;
MCNUM mccchannel_8_analyzer_1_array_crystal_array_0_yheight;
MCNUM mccchannel_8_analyzer_1_array_crystal_array_0_zdepth;
MCNUM mccchannel_8_analyzer_1_array_crystal_array_0_xwidth2;
MCNUM mccchannel_8_analyzer_1_array_crystal_array_0_yheight2;
MCNUM mccchannel_8_analyzer_1_array_crystal_array_0_visualize;
int mccchannel_8_analyzer_1_array_crystal_array_0_target_index;
MCNUM mccchannel_8_analyzer_1_array_crystal_array_0_target_x;
MCNUM mccchannel_8_analyzer_1_array_crystal_array_0_target_y;
MCNUM mccchannel_8_analyzer_1_array_crystal_array_0_target_z;
MCNUM mccchannel_8_analyzer_1_array_crystal_array_0_focus_aw;
MCNUM mccchannel_8_analyzer_1_array_crystal_array_0_focus_ah;
MCNUM mccchannel_8_analyzer_1_array_crystal_array_0_focus_xw;
MCNUM mccchannel_8_analyzer_1_array_crystal_array_0_focus_xh;
MCNUM mccchannel_8_analyzer_1_array_crystal_array_0_focus_r;
MCNUM mccchannel_8_analyzer_1_array_crystal_array_0_p_interact;
char mccchannel_8_analyzer_1_array_crystal_array_0_mask_string[16384];
char mccchannel_8_analyzer_1_array_crystal_array_0_mask_setting[16384];
MCNUM mccchannel_8_analyzer_1_array_crystal_array_0_number_of_activations;

/* Setting parameters for component 'channel_8_analyzer_1_array_crystal_array_1' [435]. */
char mccchannel_8_analyzer_1_array_crystal_array_1_material_string[16384];
MCNUM mccchannel_8_analyzer_1_array_crystal_array_1_priority;
MCNUM mccchannel_8_analyzer_1_array_crystal_array_1_xwidth;
MCNUM mccchannel_8_analyzer_1_array_crystal_array_1_yheight;
MCNUM mccchannel_8_analyzer_1_array_crystal_array_1_zdepth;
MCNUM mccchannel_8_analyzer_1_array_crystal_array_1_xwidth2;
MCNUM mccchannel_8_analyzer_1_array_crystal_array_1_yheight2;
MCNUM mccchannel_8_analyzer_1_array_crystal_array_1_visualize;
int mccchannel_8_analyzer_1_array_crystal_array_1_target_index;
MCNUM mccchannel_8_analyzer_1_array_crystal_array_1_target_x;
MCNUM mccchannel_8_analyzer_1_array_crystal_array_1_target_y;
MCNUM mccchannel_8_analyzer_1_array_crystal_array_1_target_z;
MCNUM mccchannel_8_analyzer_1_array_crystal_array_1_focus_aw;
MCNUM mccchannel_8_analyzer_1_array_crystal_array_1_focus_ah;
MCNUM mccchannel_8_analyzer_1_array_crystal_array_1_focus_xw;
MCNUM mccchannel_8_analyzer_1_array_crystal_array_1_focus_xh;
MCNUM mccchannel_8_analyzer_1_array_crystal_array_1_focus_r;
MCNUM mccchannel_8_analyzer_1_array_crystal_array_1_p_interact;
char mccchannel_8_analyzer_1_array_crystal_array_1_mask_string[16384];
char mccchannel_8_analyzer_1_array_crystal_array_1_mask_setting[16384];
MCNUM mccchannel_8_analyzer_1_array_crystal_array_1_number_of_activations;

/* Setting parameters for component 'channel_8_analyzer_1_array_crystal_array_2' [436]. */
char mccchannel_8_analyzer_1_array_crystal_array_2_material_string[16384];
MCNUM mccchannel_8_analyzer_1_array_crystal_array_2_priority;
MCNUM mccchannel_8_analyzer_1_array_crystal_array_2_xwidth;
MCNUM mccchannel_8_analyzer_1_array_crystal_array_2_yheight;
MCNUM mccchannel_8_analyzer_1_array_crystal_array_2_zdepth;
MCNUM mccchannel_8_analyzer_1_array_crystal_array_2_xwidth2;
MCNUM mccchannel_8_analyzer_1_array_crystal_array_2_yheight2;
MCNUM mccchannel_8_analyzer_1_array_crystal_array_2_visualize;
int mccchannel_8_analyzer_1_array_crystal_array_2_target_index;
MCNUM mccchannel_8_analyzer_1_array_crystal_array_2_target_x;
MCNUM mccchannel_8_analyzer_1_array_crystal_array_2_target_y;
MCNUM mccchannel_8_analyzer_1_array_crystal_array_2_target_z;
MCNUM mccchannel_8_analyzer_1_array_crystal_array_2_focus_aw;
MCNUM mccchannel_8_analyzer_1_array_crystal_array_2_focus_ah;
MCNUM mccchannel_8_analyzer_1_array_crystal_array_2_focus_xw;
MCNUM mccchannel_8_analyzer_1_array_crystal_array_2_focus_xh;
MCNUM mccchannel_8_analyzer_1_array_crystal_array_2_focus_r;
MCNUM mccchannel_8_analyzer_1_array_crystal_array_2_p_interact;
char mccchannel_8_analyzer_1_array_crystal_array_2_mask_string[16384];
char mccchannel_8_analyzer_1_array_crystal_array_2_mask_setting[16384];
MCNUM mccchannel_8_analyzer_1_array_crystal_array_2_number_of_activations;

/* Setting parameters for component 'channel_8_analyzer_1_array_crystal_array_3' [437]. */
char mccchannel_8_analyzer_1_array_crystal_array_3_material_string[16384];
MCNUM mccchannel_8_analyzer_1_array_crystal_array_3_priority;
MCNUM mccchannel_8_analyzer_1_array_crystal_array_3_xwidth;
MCNUM mccchannel_8_analyzer_1_array_crystal_array_3_yheight;
MCNUM mccchannel_8_analyzer_1_array_crystal_array_3_zdepth;
MCNUM mccchannel_8_analyzer_1_array_crystal_array_3_xwidth2;
MCNUM mccchannel_8_analyzer_1_array_crystal_array_3_yheight2;
MCNUM mccchannel_8_analyzer_1_array_crystal_array_3_visualize;
int mccchannel_8_analyzer_1_array_crystal_array_3_target_index;
MCNUM mccchannel_8_analyzer_1_array_crystal_array_3_target_x;
MCNUM mccchannel_8_analyzer_1_array_crystal_array_3_target_y;
MCNUM mccchannel_8_analyzer_1_array_crystal_array_3_target_z;
MCNUM mccchannel_8_analyzer_1_array_crystal_array_3_focus_aw;
MCNUM mccchannel_8_analyzer_1_array_crystal_array_3_focus_ah;
MCNUM mccchannel_8_analyzer_1_array_crystal_array_3_focus_xw;
MCNUM mccchannel_8_analyzer_1_array_crystal_array_3_focus_xh;
MCNUM mccchannel_8_analyzer_1_array_crystal_array_3_focus_r;
MCNUM mccchannel_8_analyzer_1_array_crystal_array_3_p_interact;
char mccchannel_8_analyzer_1_array_crystal_array_3_mask_string[16384];
char mccchannel_8_analyzer_1_array_crystal_array_3_mask_setting[16384];
MCNUM mccchannel_8_analyzer_1_array_crystal_array_3_number_of_activations;

/* Setting parameters for component 'channel_8_analyzer_1_array_crystal_array_4' [438]. */
char mccchannel_8_analyzer_1_array_crystal_array_4_material_string[16384];
MCNUM mccchannel_8_analyzer_1_array_crystal_array_4_priority;
MCNUM mccchannel_8_analyzer_1_array_crystal_array_4_xwidth;
MCNUM mccchannel_8_analyzer_1_array_crystal_array_4_yheight;
MCNUM mccchannel_8_analyzer_1_array_crystal_array_4_zdepth;
MCNUM mccchannel_8_analyzer_1_array_crystal_array_4_xwidth2;
MCNUM mccchannel_8_analyzer_1_array_crystal_array_4_yheight2;
MCNUM mccchannel_8_analyzer_1_array_crystal_array_4_visualize;
int mccchannel_8_analyzer_1_array_crystal_array_4_target_index;
MCNUM mccchannel_8_analyzer_1_array_crystal_array_4_target_x;
MCNUM mccchannel_8_analyzer_1_array_crystal_array_4_target_y;
MCNUM mccchannel_8_analyzer_1_array_crystal_array_4_target_z;
MCNUM mccchannel_8_analyzer_1_array_crystal_array_4_focus_aw;
MCNUM mccchannel_8_analyzer_1_array_crystal_array_4_focus_ah;
MCNUM mccchannel_8_analyzer_1_array_crystal_array_4_focus_xw;
MCNUM mccchannel_8_analyzer_1_array_crystal_array_4_focus_xh;
MCNUM mccchannel_8_analyzer_1_array_crystal_array_4_focus_r;
MCNUM mccchannel_8_analyzer_1_array_crystal_array_4_p_interact;
char mccchannel_8_analyzer_1_array_crystal_array_4_mask_string[16384];
char mccchannel_8_analyzer_1_array_crystal_array_4_mask_setting[16384];
MCNUM mccchannel_8_analyzer_1_array_crystal_array_4_number_of_activations;

/* Setting parameters for component 'channel_8_analyzer_1_array_crystal_array_5' [439]. */
char mccchannel_8_analyzer_1_array_crystal_array_5_material_string[16384];
MCNUM mccchannel_8_analyzer_1_array_crystal_array_5_priority;
MCNUM mccchannel_8_analyzer_1_array_crystal_array_5_xwidth;
MCNUM mccchannel_8_analyzer_1_array_crystal_array_5_yheight;
MCNUM mccchannel_8_analyzer_1_array_crystal_array_5_zdepth;
MCNUM mccchannel_8_analyzer_1_array_crystal_array_5_xwidth2;
MCNUM mccchannel_8_analyzer_1_array_crystal_array_5_yheight2;
MCNUM mccchannel_8_analyzer_1_array_crystal_array_5_visualize;
int mccchannel_8_analyzer_1_array_crystal_array_5_target_index;
MCNUM mccchannel_8_analyzer_1_array_crystal_array_5_target_x;
MCNUM mccchannel_8_analyzer_1_array_crystal_array_5_target_y;
MCNUM mccchannel_8_analyzer_1_array_crystal_array_5_target_z;
MCNUM mccchannel_8_analyzer_1_array_crystal_array_5_focus_aw;
MCNUM mccchannel_8_analyzer_1_array_crystal_array_5_focus_ah;
MCNUM mccchannel_8_analyzer_1_array_crystal_array_5_focus_xw;
MCNUM mccchannel_8_analyzer_1_array_crystal_array_5_focus_xh;
MCNUM mccchannel_8_analyzer_1_array_crystal_array_5_focus_r;
MCNUM mccchannel_8_analyzer_1_array_crystal_array_5_p_interact;
char mccchannel_8_analyzer_1_array_crystal_array_5_mask_string[16384];
char mccchannel_8_analyzer_1_array_crystal_array_5_mask_setting[16384];
MCNUM mccchannel_8_analyzer_1_array_crystal_array_5_number_of_activations;

/* Setting parameters for component 'channel_8_analyzer_1_array_crystal_array_6' [440]. */
char mccchannel_8_analyzer_1_array_crystal_array_6_material_string[16384];
MCNUM mccchannel_8_analyzer_1_array_crystal_array_6_priority;
MCNUM mccchannel_8_analyzer_1_array_crystal_array_6_xwidth;
MCNUM mccchannel_8_analyzer_1_array_crystal_array_6_yheight;
MCNUM mccchannel_8_analyzer_1_array_crystal_array_6_zdepth;
MCNUM mccchannel_8_analyzer_1_array_crystal_array_6_xwidth2;
MCNUM mccchannel_8_analyzer_1_array_crystal_array_6_yheight2;
MCNUM mccchannel_8_analyzer_1_array_crystal_array_6_visualize;
int mccchannel_8_analyzer_1_array_crystal_array_6_target_index;
MCNUM mccchannel_8_analyzer_1_array_crystal_array_6_target_x;
MCNUM mccchannel_8_analyzer_1_array_crystal_array_6_target_y;
MCNUM mccchannel_8_analyzer_1_array_crystal_array_6_target_z;
MCNUM mccchannel_8_analyzer_1_array_crystal_array_6_focus_aw;
MCNUM mccchannel_8_analyzer_1_array_crystal_array_6_focus_ah;
MCNUM mccchannel_8_analyzer_1_array_crystal_array_6_focus_xw;
MCNUM mccchannel_8_analyzer_1_array_crystal_array_6_focus_xh;
MCNUM mccchannel_8_analyzer_1_array_crystal_array_6_focus_r;
MCNUM mccchannel_8_analyzer_1_array_crystal_array_6_p_interact;
char mccchannel_8_analyzer_1_array_crystal_array_6_mask_string[16384];
char mccchannel_8_analyzer_1_array_crystal_array_6_mask_setting[16384];
MCNUM mccchannel_8_analyzer_1_array_crystal_array_6_number_of_activations;

/* Setting parameters for component 'channel_8_analyzer_1_array_crystal_array_7' [441]. */
char mccchannel_8_analyzer_1_array_crystal_array_7_material_string[16384];
MCNUM mccchannel_8_analyzer_1_array_crystal_array_7_priority;
MCNUM mccchannel_8_analyzer_1_array_crystal_array_7_xwidth;
MCNUM mccchannel_8_analyzer_1_array_crystal_array_7_yheight;
MCNUM mccchannel_8_analyzer_1_array_crystal_array_7_zdepth;
MCNUM mccchannel_8_analyzer_1_array_crystal_array_7_xwidth2;
MCNUM mccchannel_8_analyzer_1_array_crystal_array_7_yheight2;
MCNUM mccchannel_8_analyzer_1_array_crystal_array_7_visualize;
int mccchannel_8_analyzer_1_array_crystal_array_7_target_index;
MCNUM mccchannel_8_analyzer_1_array_crystal_array_7_target_x;
MCNUM mccchannel_8_analyzer_1_array_crystal_array_7_target_y;
MCNUM mccchannel_8_analyzer_1_array_crystal_array_7_target_z;
MCNUM mccchannel_8_analyzer_1_array_crystal_array_7_focus_aw;
MCNUM mccchannel_8_analyzer_1_array_crystal_array_7_focus_ah;
MCNUM mccchannel_8_analyzer_1_array_crystal_array_7_focus_xw;
MCNUM mccchannel_8_analyzer_1_array_crystal_array_7_focus_xh;
MCNUM mccchannel_8_analyzer_1_array_crystal_array_7_focus_r;
MCNUM mccchannel_8_analyzer_1_array_crystal_array_7_p_interact;
char mccchannel_8_analyzer_1_array_crystal_array_7_mask_string[16384];
char mccchannel_8_analyzer_1_array_crystal_array_7_mask_setting[16384];
MCNUM mccchannel_8_analyzer_1_array_crystal_array_7_number_of_activations;

/* Setting parameters for component 'channel_8_analyzer_1_array_crystal_array_8' [442]. */
char mccchannel_8_analyzer_1_array_crystal_array_8_material_string[16384];
MCNUM mccchannel_8_analyzer_1_array_crystal_array_8_priority;
MCNUM mccchannel_8_analyzer_1_array_crystal_array_8_xwidth;
MCNUM mccchannel_8_analyzer_1_array_crystal_array_8_yheight;
MCNUM mccchannel_8_analyzer_1_array_crystal_array_8_zdepth;
MCNUM mccchannel_8_analyzer_1_array_crystal_array_8_xwidth2;
MCNUM mccchannel_8_analyzer_1_array_crystal_array_8_yheight2;
MCNUM mccchannel_8_analyzer_1_array_crystal_array_8_visualize;
int mccchannel_8_analyzer_1_array_crystal_array_8_target_index;
MCNUM mccchannel_8_analyzer_1_array_crystal_array_8_target_x;
MCNUM mccchannel_8_analyzer_1_array_crystal_array_8_target_y;
MCNUM mccchannel_8_analyzer_1_array_crystal_array_8_target_z;
MCNUM mccchannel_8_analyzer_1_array_crystal_array_8_focus_aw;
MCNUM mccchannel_8_analyzer_1_array_crystal_array_8_focus_ah;
MCNUM mccchannel_8_analyzer_1_array_crystal_array_8_focus_xw;
MCNUM mccchannel_8_analyzer_1_array_crystal_array_8_focus_xh;
MCNUM mccchannel_8_analyzer_1_array_crystal_array_8_focus_r;
MCNUM mccchannel_8_analyzer_1_array_crystal_array_8_p_interact;
char mccchannel_8_analyzer_1_array_crystal_array_8_mask_string[16384];
char mccchannel_8_analyzer_1_array_crystal_array_8_mask_setting[16384];
MCNUM mccchannel_8_analyzer_1_array_crystal_array_8_number_of_activations;

/* Setting parameters for component 'channel_8_analyzer_2_array_crystal_array_0' [445]. */
char mccchannel_8_analyzer_2_array_crystal_array_0_material_string[16384];
MCNUM mccchannel_8_analyzer_2_array_crystal_array_0_priority;
MCNUM mccchannel_8_analyzer_2_array_crystal_array_0_xwidth;
MCNUM mccchannel_8_analyzer_2_array_crystal_array_0_yheight;
MCNUM mccchannel_8_analyzer_2_array_crystal_array_0_zdepth;
MCNUM mccchannel_8_analyzer_2_array_crystal_array_0_xwidth2;
MCNUM mccchannel_8_analyzer_2_array_crystal_array_0_yheight2;
MCNUM mccchannel_8_analyzer_2_array_crystal_array_0_visualize;
int mccchannel_8_analyzer_2_array_crystal_array_0_target_index;
MCNUM mccchannel_8_analyzer_2_array_crystal_array_0_target_x;
MCNUM mccchannel_8_analyzer_2_array_crystal_array_0_target_y;
MCNUM mccchannel_8_analyzer_2_array_crystal_array_0_target_z;
MCNUM mccchannel_8_analyzer_2_array_crystal_array_0_focus_aw;
MCNUM mccchannel_8_analyzer_2_array_crystal_array_0_focus_ah;
MCNUM mccchannel_8_analyzer_2_array_crystal_array_0_focus_xw;
MCNUM mccchannel_8_analyzer_2_array_crystal_array_0_focus_xh;
MCNUM mccchannel_8_analyzer_2_array_crystal_array_0_focus_r;
MCNUM mccchannel_8_analyzer_2_array_crystal_array_0_p_interact;
char mccchannel_8_analyzer_2_array_crystal_array_0_mask_string[16384];
char mccchannel_8_analyzer_2_array_crystal_array_0_mask_setting[16384];
MCNUM mccchannel_8_analyzer_2_array_crystal_array_0_number_of_activations;

/* Setting parameters for component 'channel_8_analyzer_2_array_crystal_array_1' [446]. */
char mccchannel_8_analyzer_2_array_crystal_array_1_material_string[16384];
MCNUM mccchannel_8_analyzer_2_array_crystal_array_1_priority;
MCNUM mccchannel_8_analyzer_2_array_crystal_array_1_xwidth;
MCNUM mccchannel_8_analyzer_2_array_crystal_array_1_yheight;
MCNUM mccchannel_8_analyzer_2_array_crystal_array_1_zdepth;
MCNUM mccchannel_8_analyzer_2_array_crystal_array_1_xwidth2;
MCNUM mccchannel_8_analyzer_2_array_crystal_array_1_yheight2;
MCNUM mccchannel_8_analyzer_2_array_crystal_array_1_visualize;
int mccchannel_8_analyzer_2_array_crystal_array_1_target_index;
MCNUM mccchannel_8_analyzer_2_array_crystal_array_1_target_x;
MCNUM mccchannel_8_analyzer_2_array_crystal_array_1_target_y;
MCNUM mccchannel_8_analyzer_2_array_crystal_array_1_target_z;
MCNUM mccchannel_8_analyzer_2_array_crystal_array_1_focus_aw;
MCNUM mccchannel_8_analyzer_2_array_crystal_array_1_focus_ah;
MCNUM mccchannel_8_analyzer_2_array_crystal_array_1_focus_xw;
MCNUM mccchannel_8_analyzer_2_array_crystal_array_1_focus_xh;
MCNUM mccchannel_8_analyzer_2_array_crystal_array_1_focus_r;
MCNUM mccchannel_8_analyzer_2_array_crystal_array_1_p_interact;
char mccchannel_8_analyzer_2_array_crystal_array_1_mask_string[16384];
char mccchannel_8_analyzer_2_array_crystal_array_1_mask_setting[16384];
MCNUM mccchannel_8_analyzer_2_array_crystal_array_1_number_of_activations;

/* Setting parameters for component 'channel_8_analyzer_2_array_crystal_array_2' [447]. */
char mccchannel_8_analyzer_2_array_crystal_array_2_material_string[16384];
MCNUM mccchannel_8_analyzer_2_array_crystal_array_2_priority;
MCNUM mccchannel_8_analyzer_2_array_crystal_array_2_xwidth;
MCNUM mccchannel_8_analyzer_2_array_crystal_array_2_yheight;
MCNUM mccchannel_8_analyzer_2_array_crystal_array_2_zdepth;
MCNUM mccchannel_8_analyzer_2_array_crystal_array_2_xwidth2;
MCNUM mccchannel_8_analyzer_2_array_crystal_array_2_yheight2;
MCNUM mccchannel_8_analyzer_2_array_crystal_array_2_visualize;
int mccchannel_8_analyzer_2_array_crystal_array_2_target_index;
MCNUM mccchannel_8_analyzer_2_array_crystal_array_2_target_x;
MCNUM mccchannel_8_analyzer_2_array_crystal_array_2_target_y;
MCNUM mccchannel_8_analyzer_2_array_crystal_array_2_target_z;
MCNUM mccchannel_8_analyzer_2_array_crystal_array_2_focus_aw;
MCNUM mccchannel_8_analyzer_2_array_crystal_array_2_focus_ah;
MCNUM mccchannel_8_analyzer_2_array_crystal_array_2_focus_xw;
MCNUM mccchannel_8_analyzer_2_array_crystal_array_2_focus_xh;
MCNUM mccchannel_8_analyzer_2_array_crystal_array_2_focus_r;
MCNUM mccchannel_8_analyzer_2_array_crystal_array_2_p_interact;
char mccchannel_8_analyzer_2_array_crystal_array_2_mask_string[16384];
char mccchannel_8_analyzer_2_array_crystal_array_2_mask_setting[16384];
MCNUM mccchannel_8_analyzer_2_array_crystal_array_2_number_of_activations;

/* Setting parameters for component 'channel_8_analyzer_2_array_crystal_array_3' [448]. */
char mccchannel_8_analyzer_2_array_crystal_array_3_material_string[16384];
MCNUM mccchannel_8_analyzer_2_array_crystal_array_3_priority;
MCNUM mccchannel_8_analyzer_2_array_crystal_array_3_xwidth;
MCNUM mccchannel_8_analyzer_2_array_crystal_array_3_yheight;
MCNUM mccchannel_8_analyzer_2_array_crystal_array_3_zdepth;
MCNUM mccchannel_8_analyzer_2_array_crystal_array_3_xwidth2;
MCNUM mccchannel_8_analyzer_2_array_crystal_array_3_yheight2;
MCNUM mccchannel_8_analyzer_2_array_crystal_array_3_visualize;
int mccchannel_8_analyzer_2_array_crystal_array_3_target_index;
MCNUM mccchannel_8_analyzer_2_array_crystal_array_3_target_x;
MCNUM mccchannel_8_analyzer_2_array_crystal_array_3_target_y;
MCNUM mccchannel_8_analyzer_2_array_crystal_array_3_target_z;
MCNUM mccchannel_8_analyzer_2_array_crystal_array_3_focus_aw;
MCNUM mccchannel_8_analyzer_2_array_crystal_array_3_focus_ah;
MCNUM mccchannel_8_analyzer_2_array_crystal_array_3_focus_xw;
MCNUM mccchannel_8_analyzer_2_array_crystal_array_3_focus_xh;
MCNUM mccchannel_8_analyzer_2_array_crystal_array_3_focus_r;
MCNUM mccchannel_8_analyzer_2_array_crystal_array_3_p_interact;
char mccchannel_8_analyzer_2_array_crystal_array_3_mask_string[16384];
char mccchannel_8_analyzer_2_array_crystal_array_3_mask_setting[16384];
MCNUM mccchannel_8_analyzer_2_array_crystal_array_3_number_of_activations;

/* Setting parameters for component 'channel_8_analyzer_2_array_crystal_array_4' [449]. */
char mccchannel_8_analyzer_2_array_crystal_array_4_material_string[16384];
MCNUM mccchannel_8_analyzer_2_array_crystal_array_4_priority;
MCNUM mccchannel_8_analyzer_2_array_crystal_array_4_xwidth;
MCNUM mccchannel_8_analyzer_2_array_crystal_array_4_yheight;
MCNUM mccchannel_8_analyzer_2_array_crystal_array_4_zdepth;
MCNUM mccchannel_8_analyzer_2_array_crystal_array_4_xwidth2;
MCNUM mccchannel_8_analyzer_2_array_crystal_array_4_yheight2;
MCNUM mccchannel_8_analyzer_2_array_crystal_array_4_visualize;
int mccchannel_8_analyzer_2_array_crystal_array_4_target_index;
MCNUM mccchannel_8_analyzer_2_array_crystal_array_4_target_x;
MCNUM mccchannel_8_analyzer_2_array_crystal_array_4_target_y;
MCNUM mccchannel_8_analyzer_2_array_crystal_array_4_target_z;
MCNUM mccchannel_8_analyzer_2_array_crystal_array_4_focus_aw;
MCNUM mccchannel_8_analyzer_2_array_crystal_array_4_focus_ah;
MCNUM mccchannel_8_analyzer_2_array_crystal_array_4_focus_xw;
MCNUM mccchannel_8_analyzer_2_array_crystal_array_4_focus_xh;
MCNUM mccchannel_8_analyzer_2_array_crystal_array_4_focus_r;
MCNUM mccchannel_8_analyzer_2_array_crystal_array_4_p_interact;
char mccchannel_8_analyzer_2_array_crystal_array_4_mask_string[16384];
char mccchannel_8_analyzer_2_array_crystal_array_4_mask_setting[16384];
MCNUM mccchannel_8_analyzer_2_array_crystal_array_4_number_of_activations;

/* Setting parameters for component 'channel_8_analyzer_2_array_crystal_array_5' [450]. */
char mccchannel_8_analyzer_2_array_crystal_array_5_material_string[16384];
MCNUM mccchannel_8_analyzer_2_array_crystal_array_5_priority;
MCNUM mccchannel_8_analyzer_2_array_crystal_array_5_xwidth;
MCNUM mccchannel_8_analyzer_2_array_crystal_array_5_yheight;
MCNUM mccchannel_8_analyzer_2_array_crystal_array_5_zdepth;
MCNUM mccchannel_8_analyzer_2_array_crystal_array_5_xwidth2;
MCNUM mccchannel_8_analyzer_2_array_crystal_array_5_yheight2;
MCNUM mccchannel_8_analyzer_2_array_crystal_array_5_visualize;
int mccchannel_8_analyzer_2_array_crystal_array_5_target_index;
MCNUM mccchannel_8_analyzer_2_array_crystal_array_5_target_x;
MCNUM mccchannel_8_analyzer_2_array_crystal_array_5_target_y;
MCNUM mccchannel_8_analyzer_2_array_crystal_array_5_target_z;
MCNUM mccchannel_8_analyzer_2_array_crystal_array_5_focus_aw;
MCNUM mccchannel_8_analyzer_2_array_crystal_array_5_focus_ah;
MCNUM mccchannel_8_analyzer_2_array_crystal_array_5_focus_xw;
MCNUM mccchannel_8_analyzer_2_array_crystal_array_5_focus_xh;
MCNUM mccchannel_8_analyzer_2_array_crystal_array_5_focus_r;
MCNUM mccchannel_8_analyzer_2_array_crystal_array_5_p_interact;
char mccchannel_8_analyzer_2_array_crystal_array_5_mask_string[16384];
char mccchannel_8_analyzer_2_array_crystal_array_5_mask_setting[16384];
MCNUM mccchannel_8_analyzer_2_array_crystal_array_5_number_of_activations;

/* Setting parameters for component 'channel_8_analyzer_2_array_crystal_array_6' [451]. */
char mccchannel_8_analyzer_2_array_crystal_array_6_material_string[16384];
MCNUM mccchannel_8_analyzer_2_array_crystal_array_6_priority;
MCNUM mccchannel_8_analyzer_2_array_crystal_array_6_xwidth;
MCNUM mccchannel_8_analyzer_2_array_crystal_array_6_yheight;
MCNUM mccchannel_8_analyzer_2_array_crystal_array_6_zdepth;
MCNUM mccchannel_8_analyzer_2_array_crystal_array_6_xwidth2;
MCNUM mccchannel_8_analyzer_2_array_crystal_array_6_yheight2;
MCNUM mccchannel_8_analyzer_2_array_crystal_array_6_visualize;
int mccchannel_8_analyzer_2_array_crystal_array_6_target_index;
MCNUM mccchannel_8_analyzer_2_array_crystal_array_6_target_x;
MCNUM mccchannel_8_analyzer_2_array_crystal_array_6_target_y;
MCNUM mccchannel_8_analyzer_2_array_crystal_array_6_target_z;
MCNUM mccchannel_8_analyzer_2_array_crystal_array_6_focus_aw;
MCNUM mccchannel_8_analyzer_2_array_crystal_array_6_focus_ah;
MCNUM mccchannel_8_analyzer_2_array_crystal_array_6_focus_xw;
MCNUM mccchannel_8_analyzer_2_array_crystal_array_6_focus_xh;
MCNUM mccchannel_8_analyzer_2_array_crystal_array_6_focus_r;
MCNUM mccchannel_8_analyzer_2_array_crystal_array_6_p_interact;
char mccchannel_8_analyzer_2_array_crystal_array_6_mask_string[16384];
char mccchannel_8_analyzer_2_array_crystal_array_6_mask_setting[16384];
MCNUM mccchannel_8_analyzer_2_array_crystal_array_6_number_of_activations;

/* Setting parameters for component 'channel_8_analyzer_2_array_crystal_array_7' [452]. */
char mccchannel_8_analyzer_2_array_crystal_array_7_material_string[16384];
MCNUM mccchannel_8_analyzer_2_array_crystal_array_7_priority;
MCNUM mccchannel_8_analyzer_2_array_crystal_array_7_xwidth;
MCNUM mccchannel_8_analyzer_2_array_crystal_array_7_yheight;
MCNUM mccchannel_8_analyzer_2_array_crystal_array_7_zdepth;
MCNUM mccchannel_8_analyzer_2_array_crystal_array_7_xwidth2;
MCNUM mccchannel_8_analyzer_2_array_crystal_array_7_yheight2;
MCNUM mccchannel_8_analyzer_2_array_crystal_array_7_visualize;
int mccchannel_8_analyzer_2_array_crystal_array_7_target_index;
MCNUM mccchannel_8_analyzer_2_array_crystal_array_7_target_x;
MCNUM mccchannel_8_analyzer_2_array_crystal_array_7_target_y;
MCNUM mccchannel_8_analyzer_2_array_crystal_array_7_target_z;
MCNUM mccchannel_8_analyzer_2_array_crystal_array_7_focus_aw;
MCNUM mccchannel_8_analyzer_2_array_crystal_array_7_focus_ah;
MCNUM mccchannel_8_analyzer_2_array_crystal_array_7_focus_xw;
MCNUM mccchannel_8_analyzer_2_array_crystal_array_7_focus_xh;
MCNUM mccchannel_8_analyzer_2_array_crystal_array_7_focus_r;
MCNUM mccchannel_8_analyzer_2_array_crystal_array_7_p_interact;
char mccchannel_8_analyzer_2_array_crystal_array_7_mask_string[16384];
char mccchannel_8_analyzer_2_array_crystal_array_7_mask_setting[16384];
MCNUM mccchannel_8_analyzer_2_array_crystal_array_7_number_of_activations;

/* Setting parameters for component 'channel_8_analyzer_2_array_crystal_array_8' [453]. */
char mccchannel_8_analyzer_2_array_crystal_array_8_material_string[16384];
MCNUM mccchannel_8_analyzer_2_array_crystal_array_8_priority;
MCNUM mccchannel_8_analyzer_2_array_crystal_array_8_xwidth;
MCNUM mccchannel_8_analyzer_2_array_crystal_array_8_yheight;
MCNUM mccchannel_8_analyzer_2_array_crystal_array_8_zdepth;
MCNUM mccchannel_8_analyzer_2_array_crystal_array_8_xwidth2;
MCNUM mccchannel_8_analyzer_2_array_crystal_array_8_yheight2;
MCNUM mccchannel_8_analyzer_2_array_crystal_array_8_visualize;
int mccchannel_8_analyzer_2_array_crystal_array_8_target_index;
MCNUM mccchannel_8_analyzer_2_array_crystal_array_8_target_x;
MCNUM mccchannel_8_analyzer_2_array_crystal_array_8_target_y;
MCNUM mccchannel_8_analyzer_2_array_crystal_array_8_target_z;
MCNUM mccchannel_8_analyzer_2_array_crystal_array_8_focus_aw;
MCNUM mccchannel_8_analyzer_2_array_crystal_array_8_focus_ah;
MCNUM mccchannel_8_analyzer_2_array_crystal_array_8_focus_xw;
MCNUM mccchannel_8_analyzer_2_array_crystal_array_8_focus_xh;
MCNUM mccchannel_8_analyzer_2_array_crystal_array_8_focus_r;
MCNUM mccchannel_8_analyzer_2_array_crystal_array_8_p_interact;
char mccchannel_8_analyzer_2_array_crystal_array_8_mask_string[16384];
char mccchannel_8_analyzer_2_array_crystal_array_8_mask_setting[16384];
MCNUM mccchannel_8_analyzer_2_array_crystal_array_8_number_of_activations;

/* Setting parameters for component 'channel_8_cave2_cyl1' [454]. */
char mccchannel_8_cave2_cyl1_material_string[16384];
MCNUM mccchannel_8_cave2_cyl1_priority;
MCNUM mccchannel_8_cave2_cyl1_radius;
MCNUM mccchannel_8_cave2_cyl1_yheight;
MCNUM mccchannel_8_cave2_cyl1_visualize;
int mccchannel_8_cave2_cyl1_target_index;
MCNUM mccchannel_8_cave2_cyl1_target_x;
MCNUM mccchannel_8_cave2_cyl1_target_y;
MCNUM mccchannel_8_cave2_cyl1_target_z;
MCNUM mccchannel_8_cave2_cyl1_focus_aw;
MCNUM mccchannel_8_cave2_cyl1_focus_ah;
MCNUM mccchannel_8_cave2_cyl1_focus_xw;
MCNUM mccchannel_8_cave2_cyl1_focus_xh;
MCNUM mccchannel_8_cave2_cyl1_focus_r;
MCNUM mccchannel_8_cave2_cyl1_p_interact;
char mccchannel_8_cave2_cyl1_mask_string[16384];
char mccchannel_8_cave2_cyl1_mask_setting[16384];
MCNUM mccchannel_8_cave2_cyl1_number_of_activations;

/* Setting parameters for component 'channel_8_cave2_box1' [455]. */
char mccchannel_8_cave2_box1_material_string[16384];
MCNUM mccchannel_8_cave2_box1_priority;
MCNUM mccchannel_8_cave2_box1_xwidth;
MCNUM mccchannel_8_cave2_box1_yheight;
MCNUM mccchannel_8_cave2_box1_zdepth;
MCNUM mccchannel_8_cave2_box1_xwidth2;
MCNUM mccchannel_8_cave2_box1_yheight2;
MCNUM mccchannel_8_cave2_box1_visualize;
int mccchannel_8_cave2_box1_target_index;
MCNUM mccchannel_8_cave2_box1_target_x;
MCNUM mccchannel_8_cave2_box1_target_y;
MCNUM mccchannel_8_cave2_box1_target_z;
MCNUM mccchannel_8_cave2_box1_focus_aw;
MCNUM mccchannel_8_cave2_box1_focus_ah;
MCNUM mccchannel_8_cave2_box1_focus_xw;
MCNUM mccchannel_8_cave2_box1_focus_xh;
MCNUM mccchannel_8_cave2_box1_focus_r;
MCNUM mccchannel_8_cave2_box1_p_interact;
char mccchannel_8_cave2_box1_mask_string[16384];
char mccchannel_8_cave2_box1_mask_setting[16384];
MCNUM mccchannel_8_cave2_box1_number_of_activations;

/* Setting parameters for component 'channel_8_cave2_box2' [456]. */
char mccchannel_8_cave2_box2_material_string[16384];
MCNUM mccchannel_8_cave2_box2_priority;
MCNUM mccchannel_8_cave2_box2_xwidth;
MCNUM mccchannel_8_cave2_box2_yheight;
MCNUM mccchannel_8_cave2_box2_zdepth;
MCNUM mccchannel_8_cave2_box2_xwidth2;
MCNUM mccchannel_8_cave2_box2_yheight2;
MCNUM mccchannel_8_cave2_box2_visualize;
int mccchannel_8_cave2_box2_target_index;
MCNUM mccchannel_8_cave2_box2_target_x;
MCNUM mccchannel_8_cave2_box2_target_y;
MCNUM mccchannel_8_cave2_box2_target_z;
MCNUM mccchannel_8_cave2_box2_focus_aw;
MCNUM mccchannel_8_cave2_box2_focus_ah;
MCNUM mccchannel_8_cave2_box2_focus_xw;
MCNUM mccchannel_8_cave2_box2_focus_xh;
MCNUM mccchannel_8_cave2_box2_focus_r;
MCNUM mccchannel_8_cave2_box2_p_interact;
char mccchannel_8_cave2_box2_mask_string[16384];
char mccchannel_8_cave2_box2_mask_setting[16384];
MCNUM mccchannel_8_cave2_box2_number_of_activations;

/* Setting parameters for component 'channel_8_cave2_box3' [457]. */
char mccchannel_8_cave2_box3_material_string[16384];
MCNUM mccchannel_8_cave2_box3_priority;
MCNUM mccchannel_8_cave2_box3_xwidth;
MCNUM mccchannel_8_cave2_box3_yheight;
MCNUM mccchannel_8_cave2_box3_zdepth;
MCNUM mccchannel_8_cave2_box3_xwidth2;
MCNUM mccchannel_8_cave2_box3_yheight2;
MCNUM mccchannel_8_cave2_box3_visualize;
int mccchannel_8_cave2_box3_target_index;
MCNUM mccchannel_8_cave2_box3_target_x;
MCNUM mccchannel_8_cave2_box3_target_y;
MCNUM mccchannel_8_cave2_box3_target_z;
MCNUM mccchannel_8_cave2_box3_focus_aw;
MCNUM mccchannel_8_cave2_box3_focus_ah;
MCNUM mccchannel_8_cave2_box3_focus_xw;
MCNUM mccchannel_8_cave2_box3_focus_xh;
MCNUM mccchannel_8_cave2_box3_focus_r;
MCNUM mccchannel_8_cave2_box3_p_interact;
char mccchannel_8_cave2_box3_mask_string[16384];
char mccchannel_8_cave2_box3_mask_setting[16384];
MCNUM mccchannel_8_cave2_box3_number_of_activations;

/* Setting parameters for component 'inter_analyzer_colimator_8_blade_0' [459]. */
char mccinter_analyzer_colimator_8_blade_0_material_string[16384];
MCNUM mccinter_analyzer_colimator_8_blade_0_priority;
MCNUM mccinter_analyzer_colimator_8_blade_0_xwidth;
MCNUM mccinter_analyzer_colimator_8_blade_0_yheight;
MCNUM mccinter_analyzer_colimator_8_blade_0_zdepth;
MCNUM mccinter_analyzer_colimator_8_blade_0_xwidth2;
MCNUM mccinter_analyzer_colimator_8_blade_0_yheight2;
MCNUM mccinter_analyzer_colimator_8_blade_0_visualize;
int mccinter_analyzer_colimator_8_blade_0_target_index;
MCNUM mccinter_analyzer_colimator_8_blade_0_target_x;
MCNUM mccinter_analyzer_colimator_8_blade_0_target_y;
MCNUM mccinter_analyzer_colimator_8_blade_0_target_z;
MCNUM mccinter_analyzer_colimator_8_blade_0_focus_aw;
MCNUM mccinter_analyzer_colimator_8_blade_0_focus_ah;
MCNUM mccinter_analyzer_colimator_8_blade_0_focus_xw;
MCNUM mccinter_analyzer_colimator_8_blade_0_focus_xh;
MCNUM mccinter_analyzer_colimator_8_blade_0_focus_r;
MCNUM mccinter_analyzer_colimator_8_blade_0_p_interact;
char mccinter_analyzer_colimator_8_blade_0_mask_string[16384];
char mccinter_analyzer_colimator_8_blade_0_mask_setting[16384];
MCNUM mccinter_analyzer_colimator_8_blade_0_number_of_activations;

/* Setting parameters for component 'inter_analyzer_colimator_8_blade_1' [460]. */
char mccinter_analyzer_colimator_8_blade_1_material_string[16384];
MCNUM mccinter_analyzer_colimator_8_blade_1_priority;
MCNUM mccinter_analyzer_colimator_8_blade_1_xwidth;
MCNUM mccinter_analyzer_colimator_8_blade_1_yheight;
MCNUM mccinter_analyzer_colimator_8_blade_1_zdepth;
MCNUM mccinter_analyzer_colimator_8_blade_1_xwidth2;
MCNUM mccinter_analyzer_colimator_8_blade_1_yheight2;
MCNUM mccinter_analyzer_colimator_8_blade_1_visualize;
int mccinter_analyzer_colimator_8_blade_1_target_index;
MCNUM mccinter_analyzer_colimator_8_blade_1_target_x;
MCNUM mccinter_analyzer_colimator_8_blade_1_target_y;
MCNUM mccinter_analyzer_colimator_8_blade_1_target_z;
MCNUM mccinter_analyzer_colimator_8_blade_1_focus_aw;
MCNUM mccinter_analyzer_colimator_8_blade_1_focus_ah;
MCNUM mccinter_analyzer_colimator_8_blade_1_focus_xw;
MCNUM mccinter_analyzer_colimator_8_blade_1_focus_xh;
MCNUM mccinter_analyzer_colimator_8_blade_1_focus_r;
MCNUM mccinter_analyzer_colimator_8_blade_1_p_interact;
char mccinter_analyzer_colimator_8_blade_1_mask_string[16384];
char mccinter_analyzer_colimator_8_blade_1_mask_setting[16384];
MCNUM mccinter_analyzer_colimator_8_blade_1_number_of_activations;

/* Setting parameters for component 'inter_analyzer_colimator_8_blade_2' [461]. */
char mccinter_analyzer_colimator_8_blade_2_material_string[16384];
MCNUM mccinter_analyzer_colimator_8_blade_2_priority;
MCNUM mccinter_analyzer_colimator_8_blade_2_xwidth;
MCNUM mccinter_analyzer_colimator_8_blade_2_yheight;
MCNUM mccinter_analyzer_colimator_8_blade_2_zdepth;
MCNUM mccinter_analyzer_colimator_8_blade_2_xwidth2;
MCNUM mccinter_analyzer_colimator_8_blade_2_yheight2;
MCNUM mccinter_analyzer_colimator_8_blade_2_visualize;
int mccinter_analyzer_colimator_8_blade_2_target_index;
MCNUM mccinter_analyzer_colimator_8_blade_2_target_x;
MCNUM mccinter_analyzer_colimator_8_blade_2_target_y;
MCNUM mccinter_analyzer_colimator_8_blade_2_target_z;
MCNUM mccinter_analyzer_colimator_8_blade_2_focus_aw;
MCNUM mccinter_analyzer_colimator_8_blade_2_focus_ah;
MCNUM mccinter_analyzer_colimator_8_blade_2_focus_xw;
MCNUM mccinter_analyzer_colimator_8_blade_2_focus_xh;
MCNUM mccinter_analyzer_colimator_8_blade_2_focus_r;
MCNUM mccinter_analyzer_colimator_8_blade_2_p_interact;
char mccinter_analyzer_colimator_8_blade_2_mask_string[16384];
char mccinter_analyzer_colimator_8_blade_2_mask_setting[16384];
MCNUM mccinter_analyzer_colimator_8_blade_2_number_of_activations;

/* Setting parameters for component 'inter_analyzer_colimator_8_blade_3' [462]. */
char mccinter_analyzer_colimator_8_blade_3_material_string[16384];
MCNUM mccinter_analyzer_colimator_8_blade_3_priority;
MCNUM mccinter_analyzer_colimator_8_blade_3_xwidth;
MCNUM mccinter_analyzer_colimator_8_blade_3_yheight;
MCNUM mccinter_analyzer_colimator_8_blade_3_zdepth;
MCNUM mccinter_analyzer_colimator_8_blade_3_xwidth2;
MCNUM mccinter_analyzer_colimator_8_blade_3_yheight2;
MCNUM mccinter_analyzer_colimator_8_blade_3_visualize;
int mccinter_analyzer_colimator_8_blade_3_target_index;
MCNUM mccinter_analyzer_colimator_8_blade_3_target_x;
MCNUM mccinter_analyzer_colimator_8_blade_3_target_y;
MCNUM mccinter_analyzer_colimator_8_blade_3_target_z;
MCNUM mccinter_analyzer_colimator_8_blade_3_focus_aw;
MCNUM mccinter_analyzer_colimator_8_blade_3_focus_ah;
MCNUM mccinter_analyzer_colimator_8_blade_3_focus_xw;
MCNUM mccinter_analyzer_colimator_8_blade_3_focus_xh;
MCNUM mccinter_analyzer_colimator_8_blade_3_focus_r;
MCNUM mccinter_analyzer_colimator_8_blade_3_p_interact;
char mccinter_analyzer_colimator_8_blade_3_mask_string[16384];
char mccinter_analyzer_colimator_8_blade_3_mask_setting[16384];
MCNUM mccinter_analyzer_colimator_8_blade_3_number_of_activations;

/* Setting parameters for component 'inter_analyzer_colimator_8_blade_4' [463]. */
char mccinter_analyzer_colimator_8_blade_4_material_string[16384];
MCNUM mccinter_analyzer_colimator_8_blade_4_priority;
MCNUM mccinter_analyzer_colimator_8_blade_4_xwidth;
MCNUM mccinter_analyzer_colimator_8_blade_4_yheight;
MCNUM mccinter_analyzer_colimator_8_blade_4_zdepth;
MCNUM mccinter_analyzer_colimator_8_blade_4_xwidth2;
MCNUM mccinter_analyzer_colimator_8_blade_4_yheight2;
MCNUM mccinter_analyzer_colimator_8_blade_4_visualize;
int mccinter_analyzer_colimator_8_blade_4_target_index;
MCNUM mccinter_analyzer_colimator_8_blade_4_target_x;
MCNUM mccinter_analyzer_colimator_8_blade_4_target_y;
MCNUM mccinter_analyzer_colimator_8_blade_4_target_z;
MCNUM mccinter_analyzer_colimator_8_blade_4_focus_aw;
MCNUM mccinter_analyzer_colimator_8_blade_4_focus_ah;
MCNUM mccinter_analyzer_colimator_8_blade_4_focus_xw;
MCNUM mccinter_analyzer_colimator_8_blade_4_focus_xh;
MCNUM mccinter_analyzer_colimator_8_blade_4_focus_r;
MCNUM mccinter_analyzer_colimator_8_blade_4_p_interact;
char mccinter_analyzer_colimator_8_blade_4_mask_string[16384];
char mccinter_analyzer_colimator_8_blade_4_mask_setting[16384];
MCNUM mccinter_analyzer_colimator_8_blade_4_number_of_activations;

/* Setting parameters for component 'diffraction_detector_8_exit_volume' [464]. */
char mccdiffraction_detector_8_exit_volume_material_string[16384];
MCNUM mccdiffraction_detector_8_exit_volume_priority;
MCNUM mccdiffraction_detector_8_exit_volume_xwidth;
MCNUM mccdiffraction_detector_8_exit_volume_yheight;
MCNUM mccdiffraction_detector_8_exit_volume_zdepth;
MCNUM mccdiffraction_detector_8_exit_volume_xwidth2;
MCNUM mccdiffraction_detector_8_exit_volume_yheight2;
MCNUM mccdiffraction_detector_8_exit_volume_visualize;
int mccdiffraction_detector_8_exit_volume_target_index;
MCNUM mccdiffraction_detector_8_exit_volume_target_x;
MCNUM mccdiffraction_detector_8_exit_volume_target_y;
MCNUM mccdiffraction_detector_8_exit_volume_target_z;
MCNUM mccdiffraction_detector_8_exit_volume_focus_aw;
MCNUM mccdiffraction_detector_8_exit_volume_focus_ah;
MCNUM mccdiffraction_detector_8_exit_volume_focus_xw;
MCNUM mccdiffraction_detector_8_exit_volume_focus_xh;
MCNUM mccdiffraction_detector_8_exit_volume_focus_r;
MCNUM mccdiffraction_detector_8_exit_volume_p_interact;
char mccdiffraction_detector_8_exit_volume_mask_string[16384];
char mccdiffraction_detector_8_exit_volume_mask_setting[16384];
MCNUM mccdiffraction_detector_8_exit_volume_number_of_activations;

/* Setting parameters for component 'spec_detector_8_exit_volume' [465]. */
char mccspec_detector_8_exit_volume_material_string[16384];
MCNUM mccspec_detector_8_exit_volume_priority;
MCNUM mccspec_detector_8_exit_volume_xwidth;
MCNUM mccspec_detector_8_exit_volume_yheight;
MCNUM mccspec_detector_8_exit_volume_zdepth;
MCNUM mccspec_detector_8_exit_volume_xwidth2;
MCNUM mccspec_detector_8_exit_volume_yheight2;
MCNUM mccspec_detector_8_exit_volume_visualize;
int mccspec_detector_8_exit_volume_target_index;
MCNUM mccspec_detector_8_exit_volume_target_x;
MCNUM mccspec_detector_8_exit_volume_target_y;
MCNUM mccspec_detector_8_exit_volume_target_z;
MCNUM mccspec_detector_8_exit_volume_focus_aw;
MCNUM mccspec_detector_8_exit_volume_focus_ah;
MCNUM mccspec_detector_8_exit_volume_focus_xw;
MCNUM mccspec_detector_8_exit_volume_focus_xh;
MCNUM mccspec_detector_8_exit_volume_focus_r;
MCNUM mccspec_detector_8_exit_volume_p_interact;
char mccspec_detector_8_exit_volume_mask_string[16384];
char mccspec_detector_8_exit_volume_mask_setting[16384];
MCNUM mccspec_detector_8_exit_volume_number_of_activations;

/* Setting parameters for component 'channel_9_cave1_box1' [466]. */
char mccchannel_9_cave1_box1_material_string[16384];
MCNUM mccchannel_9_cave1_box1_priority;
MCNUM mccchannel_9_cave1_box1_xwidth;
MCNUM mccchannel_9_cave1_box1_yheight;
MCNUM mccchannel_9_cave1_box1_zdepth;
MCNUM mccchannel_9_cave1_box1_xwidth2;
MCNUM mccchannel_9_cave1_box1_yheight2;
MCNUM mccchannel_9_cave1_box1_visualize;
int mccchannel_9_cave1_box1_target_index;
MCNUM mccchannel_9_cave1_box1_target_x;
MCNUM mccchannel_9_cave1_box1_target_y;
MCNUM mccchannel_9_cave1_box1_target_z;
MCNUM mccchannel_9_cave1_box1_focus_aw;
MCNUM mccchannel_9_cave1_box1_focus_ah;
MCNUM mccchannel_9_cave1_box1_focus_xw;
MCNUM mccchannel_9_cave1_box1_focus_xh;
MCNUM mccchannel_9_cave1_box1_focus_r;
MCNUM mccchannel_9_cave1_box1_p_interact;
char mccchannel_9_cave1_box1_mask_string[16384];
char mccchannel_9_cave1_box1_mask_setting[16384];
MCNUM mccchannel_9_cave1_box1_number_of_activations;

/* Setting parameters for component 'channel_9_cave1_box2' [467]. */
char mccchannel_9_cave1_box2_material_string[16384];
MCNUM mccchannel_9_cave1_box2_priority;
MCNUM mccchannel_9_cave1_box2_xwidth;
MCNUM mccchannel_9_cave1_box2_yheight;
MCNUM mccchannel_9_cave1_box2_zdepth;
MCNUM mccchannel_9_cave1_box2_xwidth2;
MCNUM mccchannel_9_cave1_box2_yheight2;
MCNUM mccchannel_9_cave1_box2_visualize;
int mccchannel_9_cave1_box2_target_index;
MCNUM mccchannel_9_cave1_box2_target_x;
MCNUM mccchannel_9_cave1_box2_target_y;
MCNUM mccchannel_9_cave1_box2_target_z;
MCNUM mccchannel_9_cave1_box2_focus_aw;
MCNUM mccchannel_9_cave1_box2_focus_ah;
MCNUM mccchannel_9_cave1_box2_focus_xw;
MCNUM mccchannel_9_cave1_box2_focus_xh;
MCNUM mccchannel_9_cave1_box2_focus_r;
MCNUM mccchannel_9_cave1_box2_p_interact;
char mccchannel_9_cave1_box2_mask_string[16384];
char mccchannel_9_cave1_box2_mask_setting[16384];
MCNUM mccchannel_9_cave1_box2_number_of_activations;

/* Setting parameters for component 'channel_9_cave1_box3' [468]. */
char mccchannel_9_cave1_box3_material_string[16384];
MCNUM mccchannel_9_cave1_box3_priority;
MCNUM mccchannel_9_cave1_box3_xwidth;
MCNUM mccchannel_9_cave1_box3_yheight;
MCNUM mccchannel_9_cave1_box3_zdepth;
MCNUM mccchannel_9_cave1_box3_xwidth2;
MCNUM mccchannel_9_cave1_box3_yheight2;
MCNUM mccchannel_9_cave1_box3_visualize;
int mccchannel_9_cave1_box3_target_index;
MCNUM mccchannel_9_cave1_box3_target_x;
MCNUM mccchannel_9_cave1_box3_target_y;
MCNUM mccchannel_9_cave1_box3_target_z;
MCNUM mccchannel_9_cave1_box3_focus_aw;
MCNUM mccchannel_9_cave1_box3_focus_ah;
MCNUM mccchannel_9_cave1_box3_focus_xw;
MCNUM mccchannel_9_cave1_box3_focus_xh;
MCNUM mccchannel_9_cave1_box3_focus_r;
MCNUM mccchannel_9_cave1_box3_p_interact;
char mccchannel_9_cave1_box3_mask_string[16384];
char mccchannel_9_cave1_box3_mask_setting[16384];
MCNUM mccchannel_9_cave1_box3_number_of_activations;

/* Setting parameters for component 'channel_9_cave1_cyl1' [469]. */
char mccchannel_9_cave1_cyl1_material_string[16384];
MCNUM mccchannel_9_cave1_cyl1_priority;
MCNUM mccchannel_9_cave1_cyl1_radius;
MCNUM mccchannel_9_cave1_cyl1_yheight;
MCNUM mccchannel_9_cave1_cyl1_visualize;
int mccchannel_9_cave1_cyl1_target_index;
MCNUM mccchannel_9_cave1_cyl1_target_x;
MCNUM mccchannel_9_cave1_cyl1_target_y;
MCNUM mccchannel_9_cave1_cyl1_target_z;
MCNUM mccchannel_9_cave1_cyl1_focus_aw;
MCNUM mccchannel_9_cave1_cyl1_focus_ah;
MCNUM mccchannel_9_cave1_cyl1_focus_xw;
MCNUM mccchannel_9_cave1_cyl1_focus_xh;
MCNUM mccchannel_9_cave1_cyl1_focus_r;
MCNUM mccchannel_9_cave1_cyl1_p_interact;
char mccchannel_9_cave1_cyl1_mask_string[16384];
char mccchannel_9_cave1_cyl1_mask_setting[16384];
MCNUM mccchannel_9_cave1_cyl1_number_of_activations;

/* Setting parameters for component 'channel_9_analyzer_1_array_crystal_array_0' [472]. */
char mccchannel_9_analyzer_1_array_crystal_array_0_material_string[16384];
MCNUM mccchannel_9_analyzer_1_array_crystal_array_0_priority;
MCNUM mccchannel_9_analyzer_1_array_crystal_array_0_xwidth;
MCNUM mccchannel_9_analyzer_1_array_crystal_array_0_yheight;
MCNUM mccchannel_9_analyzer_1_array_crystal_array_0_zdepth;
MCNUM mccchannel_9_analyzer_1_array_crystal_array_0_xwidth2;
MCNUM mccchannel_9_analyzer_1_array_crystal_array_0_yheight2;
MCNUM mccchannel_9_analyzer_1_array_crystal_array_0_visualize;
int mccchannel_9_analyzer_1_array_crystal_array_0_target_index;
MCNUM mccchannel_9_analyzer_1_array_crystal_array_0_target_x;
MCNUM mccchannel_9_analyzer_1_array_crystal_array_0_target_y;
MCNUM mccchannel_9_analyzer_1_array_crystal_array_0_target_z;
MCNUM mccchannel_9_analyzer_1_array_crystal_array_0_focus_aw;
MCNUM mccchannel_9_analyzer_1_array_crystal_array_0_focus_ah;
MCNUM mccchannel_9_analyzer_1_array_crystal_array_0_focus_xw;
MCNUM mccchannel_9_analyzer_1_array_crystal_array_0_focus_xh;
MCNUM mccchannel_9_analyzer_1_array_crystal_array_0_focus_r;
MCNUM mccchannel_9_analyzer_1_array_crystal_array_0_p_interact;
char mccchannel_9_analyzer_1_array_crystal_array_0_mask_string[16384];
char mccchannel_9_analyzer_1_array_crystal_array_0_mask_setting[16384];
MCNUM mccchannel_9_analyzer_1_array_crystal_array_0_number_of_activations;

/* Setting parameters for component 'channel_9_analyzer_1_array_crystal_array_1' [473]. */
char mccchannel_9_analyzer_1_array_crystal_array_1_material_string[16384];
MCNUM mccchannel_9_analyzer_1_array_crystal_array_1_priority;
MCNUM mccchannel_9_analyzer_1_array_crystal_array_1_xwidth;
MCNUM mccchannel_9_analyzer_1_array_crystal_array_1_yheight;
MCNUM mccchannel_9_analyzer_1_array_crystal_array_1_zdepth;
MCNUM mccchannel_9_analyzer_1_array_crystal_array_1_xwidth2;
MCNUM mccchannel_9_analyzer_1_array_crystal_array_1_yheight2;
MCNUM mccchannel_9_analyzer_1_array_crystal_array_1_visualize;
int mccchannel_9_analyzer_1_array_crystal_array_1_target_index;
MCNUM mccchannel_9_analyzer_1_array_crystal_array_1_target_x;
MCNUM mccchannel_9_analyzer_1_array_crystal_array_1_target_y;
MCNUM mccchannel_9_analyzer_1_array_crystal_array_1_target_z;
MCNUM mccchannel_9_analyzer_1_array_crystal_array_1_focus_aw;
MCNUM mccchannel_9_analyzer_1_array_crystal_array_1_focus_ah;
MCNUM mccchannel_9_analyzer_1_array_crystal_array_1_focus_xw;
MCNUM mccchannel_9_analyzer_1_array_crystal_array_1_focus_xh;
MCNUM mccchannel_9_analyzer_1_array_crystal_array_1_focus_r;
MCNUM mccchannel_9_analyzer_1_array_crystal_array_1_p_interact;
char mccchannel_9_analyzer_1_array_crystal_array_1_mask_string[16384];
char mccchannel_9_analyzer_1_array_crystal_array_1_mask_setting[16384];
MCNUM mccchannel_9_analyzer_1_array_crystal_array_1_number_of_activations;

/* Setting parameters for component 'channel_9_analyzer_1_array_crystal_array_2' [474]. */
char mccchannel_9_analyzer_1_array_crystal_array_2_material_string[16384];
MCNUM mccchannel_9_analyzer_1_array_crystal_array_2_priority;
MCNUM mccchannel_9_analyzer_1_array_crystal_array_2_xwidth;
MCNUM mccchannel_9_analyzer_1_array_crystal_array_2_yheight;
MCNUM mccchannel_9_analyzer_1_array_crystal_array_2_zdepth;
MCNUM mccchannel_9_analyzer_1_array_crystal_array_2_xwidth2;
MCNUM mccchannel_9_analyzer_1_array_crystal_array_2_yheight2;
MCNUM mccchannel_9_analyzer_1_array_crystal_array_2_visualize;
int mccchannel_9_analyzer_1_array_crystal_array_2_target_index;
MCNUM mccchannel_9_analyzer_1_array_crystal_array_2_target_x;
MCNUM mccchannel_9_analyzer_1_array_crystal_array_2_target_y;
MCNUM mccchannel_9_analyzer_1_array_crystal_array_2_target_z;
MCNUM mccchannel_9_analyzer_1_array_crystal_array_2_focus_aw;
MCNUM mccchannel_9_analyzer_1_array_crystal_array_2_focus_ah;
MCNUM mccchannel_9_analyzer_1_array_crystal_array_2_focus_xw;
MCNUM mccchannel_9_analyzer_1_array_crystal_array_2_focus_xh;
MCNUM mccchannel_9_analyzer_1_array_crystal_array_2_focus_r;
MCNUM mccchannel_9_analyzer_1_array_crystal_array_2_p_interact;
char mccchannel_9_analyzer_1_array_crystal_array_2_mask_string[16384];
char mccchannel_9_analyzer_1_array_crystal_array_2_mask_setting[16384];
MCNUM mccchannel_9_analyzer_1_array_crystal_array_2_number_of_activations;

/* Setting parameters for component 'channel_9_analyzer_1_array_crystal_array_3' [475]. */
char mccchannel_9_analyzer_1_array_crystal_array_3_material_string[16384];
MCNUM mccchannel_9_analyzer_1_array_crystal_array_3_priority;
MCNUM mccchannel_9_analyzer_1_array_crystal_array_3_xwidth;
MCNUM mccchannel_9_analyzer_1_array_crystal_array_3_yheight;
MCNUM mccchannel_9_analyzer_1_array_crystal_array_3_zdepth;
MCNUM mccchannel_9_analyzer_1_array_crystal_array_3_xwidth2;
MCNUM mccchannel_9_analyzer_1_array_crystal_array_3_yheight2;
MCNUM mccchannel_9_analyzer_1_array_crystal_array_3_visualize;
int mccchannel_9_analyzer_1_array_crystal_array_3_target_index;
MCNUM mccchannel_9_analyzer_1_array_crystal_array_3_target_x;
MCNUM mccchannel_9_analyzer_1_array_crystal_array_3_target_y;
MCNUM mccchannel_9_analyzer_1_array_crystal_array_3_target_z;
MCNUM mccchannel_9_analyzer_1_array_crystal_array_3_focus_aw;
MCNUM mccchannel_9_analyzer_1_array_crystal_array_3_focus_ah;
MCNUM mccchannel_9_analyzer_1_array_crystal_array_3_focus_xw;
MCNUM mccchannel_9_analyzer_1_array_crystal_array_3_focus_xh;
MCNUM mccchannel_9_analyzer_1_array_crystal_array_3_focus_r;
MCNUM mccchannel_9_analyzer_1_array_crystal_array_3_p_interact;
char mccchannel_9_analyzer_1_array_crystal_array_3_mask_string[16384];
char mccchannel_9_analyzer_1_array_crystal_array_3_mask_setting[16384];
MCNUM mccchannel_9_analyzer_1_array_crystal_array_3_number_of_activations;

/* Setting parameters for component 'channel_9_analyzer_1_array_crystal_array_4' [476]. */
char mccchannel_9_analyzer_1_array_crystal_array_4_material_string[16384];
MCNUM mccchannel_9_analyzer_1_array_crystal_array_4_priority;
MCNUM mccchannel_9_analyzer_1_array_crystal_array_4_xwidth;
MCNUM mccchannel_9_analyzer_1_array_crystal_array_4_yheight;
MCNUM mccchannel_9_analyzer_1_array_crystal_array_4_zdepth;
MCNUM mccchannel_9_analyzer_1_array_crystal_array_4_xwidth2;
MCNUM mccchannel_9_analyzer_1_array_crystal_array_4_yheight2;
MCNUM mccchannel_9_analyzer_1_array_crystal_array_4_visualize;
int mccchannel_9_analyzer_1_array_crystal_array_4_target_index;
MCNUM mccchannel_9_analyzer_1_array_crystal_array_4_target_x;
MCNUM mccchannel_9_analyzer_1_array_crystal_array_4_target_y;
MCNUM mccchannel_9_analyzer_1_array_crystal_array_4_target_z;
MCNUM mccchannel_9_analyzer_1_array_crystal_array_4_focus_aw;
MCNUM mccchannel_9_analyzer_1_array_crystal_array_4_focus_ah;
MCNUM mccchannel_9_analyzer_1_array_crystal_array_4_focus_xw;
MCNUM mccchannel_9_analyzer_1_array_crystal_array_4_focus_xh;
MCNUM mccchannel_9_analyzer_1_array_crystal_array_4_focus_r;
MCNUM mccchannel_9_analyzer_1_array_crystal_array_4_p_interact;
char mccchannel_9_analyzer_1_array_crystal_array_4_mask_string[16384];
char mccchannel_9_analyzer_1_array_crystal_array_4_mask_setting[16384];
MCNUM mccchannel_9_analyzer_1_array_crystal_array_4_number_of_activations;

/* Setting parameters for component 'channel_9_analyzer_1_array_crystal_array_5' [477]. */
char mccchannel_9_analyzer_1_array_crystal_array_5_material_string[16384];
MCNUM mccchannel_9_analyzer_1_array_crystal_array_5_priority;
MCNUM mccchannel_9_analyzer_1_array_crystal_array_5_xwidth;
MCNUM mccchannel_9_analyzer_1_array_crystal_array_5_yheight;
MCNUM mccchannel_9_analyzer_1_array_crystal_array_5_zdepth;
MCNUM mccchannel_9_analyzer_1_array_crystal_array_5_xwidth2;
MCNUM mccchannel_9_analyzer_1_array_crystal_array_5_yheight2;
MCNUM mccchannel_9_analyzer_1_array_crystal_array_5_visualize;
int mccchannel_9_analyzer_1_array_crystal_array_5_target_index;
MCNUM mccchannel_9_analyzer_1_array_crystal_array_5_target_x;
MCNUM mccchannel_9_analyzer_1_array_crystal_array_5_target_y;
MCNUM mccchannel_9_analyzer_1_array_crystal_array_5_target_z;
MCNUM mccchannel_9_analyzer_1_array_crystal_array_5_focus_aw;
MCNUM mccchannel_9_analyzer_1_array_crystal_array_5_focus_ah;
MCNUM mccchannel_9_analyzer_1_array_crystal_array_5_focus_xw;
MCNUM mccchannel_9_analyzer_1_array_crystal_array_5_focus_xh;
MCNUM mccchannel_9_analyzer_1_array_crystal_array_5_focus_r;
MCNUM mccchannel_9_analyzer_1_array_crystal_array_5_p_interact;
char mccchannel_9_analyzer_1_array_crystal_array_5_mask_string[16384];
char mccchannel_9_analyzer_1_array_crystal_array_5_mask_setting[16384];
MCNUM mccchannel_9_analyzer_1_array_crystal_array_5_number_of_activations;

/* Setting parameters for component 'channel_9_analyzer_1_array_crystal_array_6' [478]. */
char mccchannel_9_analyzer_1_array_crystal_array_6_material_string[16384];
MCNUM mccchannel_9_analyzer_1_array_crystal_array_6_priority;
MCNUM mccchannel_9_analyzer_1_array_crystal_array_6_xwidth;
MCNUM mccchannel_9_analyzer_1_array_crystal_array_6_yheight;
MCNUM mccchannel_9_analyzer_1_array_crystal_array_6_zdepth;
MCNUM mccchannel_9_analyzer_1_array_crystal_array_6_xwidth2;
MCNUM mccchannel_9_analyzer_1_array_crystal_array_6_yheight2;
MCNUM mccchannel_9_analyzer_1_array_crystal_array_6_visualize;
int mccchannel_9_analyzer_1_array_crystal_array_6_target_index;
MCNUM mccchannel_9_analyzer_1_array_crystal_array_6_target_x;
MCNUM mccchannel_9_analyzer_1_array_crystal_array_6_target_y;
MCNUM mccchannel_9_analyzer_1_array_crystal_array_6_target_z;
MCNUM mccchannel_9_analyzer_1_array_crystal_array_6_focus_aw;
MCNUM mccchannel_9_analyzer_1_array_crystal_array_6_focus_ah;
MCNUM mccchannel_9_analyzer_1_array_crystal_array_6_focus_xw;
MCNUM mccchannel_9_analyzer_1_array_crystal_array_6_focus_xh;
MCNUM mccchannel_9_analyzer_1_array_crystal_array_6_focus_r;
MCNUM mccchannel_9_analyzer_1_array_crystal_array_6_p_interact;
char mccchannel_9_analyzer_1_array_crystal_array_6_mask_string[16384];
char mccchannel_9_analyzer_1_array_crystal_array_6_mask_setting[16384];
MCNUM mccchannel_9_analyzer_1_array_crystal_array_6_number_of_activations;

/* Setting parameters for component 'channel_9_analyzer_1_array_crystal_array_7' [479]. */
char mccchannel_9_analyzer_1_array_crystal_array_7_material_string[16384];
MCNUM mccchannel_9_analyzer_1_array_crystal_array_7_priority;
MCNUM mccchannel_9_analyzer_1_array_crystal_array_7_xwidth;
MCNUM mccchannel_9_analyzer_1_array_crystal_array_7_yheight;
MCNUM mccchannel_9_analyzer_1_array_crystal_array_7_zdepth;
MCNUM mccchannel_9_analyzer_1_array_crystal_array_7_xwidth2;
MCNUM mccchannel_9_analyzer_1_array_crystal_array_7_yheight2;
MCNUM mccchannel_9_analyzer_1_array_crystal_array_7_visualize;
int mccchannel_9_analyzer_1_array_crystal_array_7_target_index;
MCNUM mccchannel_9_analyzer_1_array_crystal_array_7_target_x;
MCNUM mccchannel_9_analyzer_1_array_crystal_array_7_target_y;
MCNUM mccchannel_9_analyzer_1_array_crystal_array_7_target_z;
MCNUM mccchannel_9_analyzer_1_array_crystal_array_7_focus_aw;
MCNUM mccchannel_9_analyzer_1_array_crystal_array_7_focus_ah;
MCNUM mccchannel_9_analyzer_1_array_crystal_array_7_focus_xw;
MCNUM mccchannel_9_analyzer_1_array_crystal_array_7_focus_xh;
MCNUM mccchannel_9_analyzer_1_array_crystal_array_7_focus_r;
MCNUM mccchannel_9_analyzer_1_array_crystal_array_7_p_interact;
char mccchannel_9_analyzer_1_array_crystal_array_7_mask_string[16384];
char mccchannel_9_analyzer_1_array_crystal_array_7_mask_setting[16384];
MCNUM mccchannel_9_analyzer_1_array_crystal_array_7_number_of_activations;

/* Setting parameters for component 'channel_9_analyzer_1_array_crystal_array_8' [480]. */
char mccchannel_9_analyzer_1_array_crystal_array_8_material_string[16384];
MCNUM mccchannel_9_analyzer_1_array_crystal_array_8_priority;
MCNUM mccchannel_9_analyzer_1_array_crystal_array_8_xwidth;
MCNUM mccchannel_9_analyzer_1_array_crystal_array_8_yheight;
MCNUM mccchannel_9_analyzer_1_array_crystal_array_8_zdepth;
MCNUM mccchannel_9_analyzer_1_array_crystal_array_8_xwidth2;
MCNUM mccchannel_9_analyzer_1_array_crystal_array_8_yheight2;
MCNUM mccchannel_9_analyzer_1_array_crystal_array_8_visualize;
int mccchannel_9_analyzer_1_array_crystal_array_8_target_index;
MCNUM mccchannel_9_analyzer_1_array_crystal_array_8_target_x;
MCNUM mccchannel_9_analyzer_1_array_crystal_array_8_target_y;
MCNUM mccchannel_9_analyzer_1_array_crystal_array_8_target_z;
MCNUM mccchannel_9_analyzer_1_array_crystal_array_8_focus_aw;
MCNUM mccchannel_9_analyzer_1_array_crystal_array_8_focus_ah;
MCNUM mccchannel_9_analyzer_1_array_crystal_array_8_focus_xw;
MCNUM mccchannel_9_analyzer_1_array_crystal_array_8_focus_xh;
MCNUM mccchannel_9_analyzer_1_array_crystal_array_8_focus_r;
MCNUM mccchannel_9_analyzer_1_array_crystal_array_8_p_interact;
char mccchannel_9_analyzer_1_array_crystal_array_8_mask_string[16384];
char mccchannel_9_analyzer_1_array_crystal_array_8_mask_setting[16384];
MCNUM mccchannel_9_analyzer_1_array_crystal_array_8_number_of_activations;

/* Setting parameters for component 'channel_9_analyzer_2_array_crystal_array_0' [483]. */
char mccchannel_9_analyzer_2_array_crystal_array_0_material_string[16384];
MCNUM mccchannel_9_analyzer_2_array_crystal_array_0_priority;
MCNUM mccchannel_9_analyzer_2_array_crystal_array_0_xwidth;
MCNUM mccchannel_9_analyzer_2_array_crystal_array_0_yheight;
MCNUM mccchannel_9_analyzer_2_array_crystal_array_0_zdepth;
MCNUM mccchannel_9_analyzer_2_array_crystal_array_0_xwidth2;
MCNUM mccchannel_9_analyzer_2_array_crystal_array_0_yheight2;
MCNUM mccchannel_9_analyzer_2_array_crystal_array_0_visualize;
int mccchannel_9_analyzer_2_array_crystal_array_0_target_index;
MCNUM mccchannel_9_analyzer_2_array_crystal_array_0_target_x;
MCNUM mccchannel_9_analyzer_2_array_crystal_array_0_target_y;
MCNUM mccchannel_9_analyzer_2_array_crystal_array_0_target_z;
MCNUM mccchannel_9_analyzer_2_array_crystal_array_0_focus_aw;
MCNUM mccchannel_9_analyzer_2_array_crystal_array_0_focus_ah;
MCNUM mccchannel_9_analyzer_2_array_crystal_array_0_focus_xw;
MCNUM mccchannel_9_analyzer_2_array_crystal_array_0_focus_xh;
MCNUM mccchannel_9_analyzer_2_array_crystal_array_0_focus_r;
MCNUM mccchannel_9_analyzer_2_array_crystal_array_0_p_interact;
char mccchannel_9_analyzer_2_array_crystal_array_0_mask_string[16384];
char mccchannel_9_analyzer_2_array_crystal_array_0_mask_setting[16384];
MCNUM mccchannel_9_analyzer_2_array_crystal_array_0_number_of_activations;

/* Setting parameters for component 'channel_9_analyzer_2_array_crystal_array_1' [484]. */
char mccchannel_9_analyzer_2_array_crystal_array_1_material_string[16384];
MCNUM mccchannel_9_analyzer_2_array_crystal_array_1_priority;
MCNUM mccchannel_9_analyzer_2_array_crystal_array_1_xwidth;
MCNUM mccchannel_9_analyzer_2_array_crystal_array_1_yheight;
MCNUM mccchannel_9_analyzer_2_array_crystal_array_1_zdepth;
MCNUM mccchannel_9_analyzer_2_array_crystal_array_1_xwidth2;
MCNUM mccchannel_9_analyzer_2_array_crystal_array_1_yheight2;
MCNUM mccchannel_9_analyzer_2_array_crystal_array_1_visualize;
int mccchannel_9_analyzer_2_array_crystal_array_1_target_index;
MCNUM mccchannel_9_analyzer_2_array_crystal_array_1_target_x;
MCNUM mccchannel_9_analyzer_2_array_crystal_array_1_target_y;
MCNUM mccchannel_9_analyzer_2_array_crystal_array_1_target_z;
MCNUM mccchannel_9_analyzer_2_array_crystal_array_1_focus_aw;
MCNUM mccchannel_9_analyzer_2_array_crystal_array_1_focus_ah;
MCNUM mccchannel_9_analyzer_2_array_crystal_array_1_focus_xw;
MCNUM mccchannel_9_analyzer_2_array_crystal_array_1_focus_xh;
MCNUM mccchannel_9_analyzer_2_array_crystal_array_1_focus_r;
MCNUM mccchannel_9_analyzer_2_array_crystal_array_1_p_interact;
char mccchannel_9_analyzer_2_array_crystal_array_1_mask_string[16384];
char mccchannel_9_analyzer_2_array_crystal_array_1_mask_setting[16384];
MCNUM mccchannel_9_analyzer_2_array_crystal_array_1_number_of_activations;

/* Setting parameters for component 'channel_9_analyzer_2_array_crystal_array_2' [485]. */
char mccchannel_9_analyzer_2_array_crystal_array_2_material_string[16384];
MCNUM mccchannel_9_analyzer_2_array_crystal_array_2_priority;
MCNUM mccchannel_9_analyzer_2_array_crystal_array_2_xwidth;
MCNUM mccchannel_9_analyzer_2_array_crystal_array_2_yheight;
MCNUM mccchannel_9_analyzer_2_array_crystal_array_2_zdepth;
MCNUM mccchannel_9_analyzer_2_array_crystal_array_2_xwidth2;
MCNUM mccchannel_9_analyzer_2_array_crystal_array_2_yheight2;
MCNUM mccchannel_9_analyzer_2_array_crystal_array_2_visualize;
int mccchannel_9_analyzer_2_array_crystal_array_2_target_index;
MCNUM mccchannel_9_analyzer_2_array_crystal_array_2_target_x;
MCNUM mccchannel_9_analyzer_2_array_crystal_array_2_target_y;
MCNUM mccchannel_9_analyzer_2_array_crystal_array_2_target_z;
MCNUM mccchannel_9_analyzer_2_array_crystal_array_2_focus_aw;
MCNUM mccchannel_9_analyzer_2_array_crystal_array_2_focus_ah;
MCNUM mccchannel_9_analyzer_2_array_crystal_array_2_focus_xw;
MCNUM mccchannel_9_analyzer_2_array_crystal_array_2_focus_xh;
MCNUM mccchannel_9_analyzer_2_array_crystal_array_2_focus_r;
MCNUM mccchannel_9_analyzer_2_array_crystal_array_2_p_interact;
char mccchannel_9_analyzer_2_array_crystal_array_2_mask_string[16384];
char mccchannel_9_analyzer_2_array_crystal_array_2_mask_setting[16384];
MCNUM mccchannel_9_analyzer_2_array_crystal_array_2_number_of_activations;

/* Setting parameters for component 'channel_9_analyzer_2_array_crystal_array_3' [486]. */
char mccchannel_9_analyzer_2_array_crystal_array_3_material_string[16384];
MCNUM mccchannel_9_analyzer_2_array_crystal_array_3_priority;
MCNUM mccchannel_9_analyzer_2_array_crystal_array_3_xwidth;
MCNUM mccchannel_9_analyzer_2_array_crystal_array_3_yheight;
MCNUM mccchannel_9_analyzer_2_array_crystal_array_3_zdepth;
MCNUM mccchannel_9_analyzer_2_array_crystal_array_3_xwidth2;
MCNUM mccchannel_9_analyzer_2_array_crystal_array_3_yheight2;
MCNUM mccchannel_9_analyzer_2_array_crystal_array_3_visualize;
int mccchannel_9_analyzer_2_array_crystal_array_3_target_index;
MCNUM mccchannel_9_analyzer_2_array_crystal_array_3_target_x;
MCNUM mccchannel_9_analyzer_2_array_crystal_array_3_target_y;
MCNUM mccchannel_9_analyzer_2_array_crystal_array_3_target_z;
MCNUM mccchannel_9_analyzer_2_array_crystal_array_3_focus_aw;
MCNUM mccchannel_9_analyzer_2_array_crystal_array_3_focus_ah;
MCNUM mccchannel_9_analyzer_2_array_crystal_array_3_focus_xw;
MCNUM mccchannel_9_analyzer_2_array_crystal_array_3_focus_xh;
MCNUM mccchannel_9_analyzer_2_array_crystal_array_3_focus_r;
MCNUM mccchannel_9_analyzer_2_array_crystal_array_3_p_interact;
char mccchannel_9_analyzer_2_array_crystal_array_3_mask_string[16384];
char mccchannel_9_analyzer_2_array_crystal_array_3_mask_setting[16384];
MCNUM mccchannel_9_analyzer_2_array_crystal_array_3_number_of_activations;

/* Setting parameters for component 'channel_9_analyzer_2_array_crystal_array_4' [487]. */
char mccchannel_9_analyzer_2_array_crystal_array_4_material_string[16384];
MCNUM mccchannel_9_analyzer_2_array_crystal_array_4_priority;
MCNUM mccchannel_9_analyzer_2_array_crystal_array_4_xwidth;
MCNUM mccchannel_9_analyzer_2_array_crystal_array_4_yheight;
MCNUM mccchannel_9_analyzer_2_array_crystal_array_4_zdepth;
MCNUM mccchannel_9_analyzer_2_array_crystal_array_4_xwidth2;
MCNUM mccchannel_9_analyzer_2_array_crystal_array_4_yheight2;
MCNUM mccchannel_9_analyzer_2_array_crystal_array_4_visualize;
int mccchannel_9_analyzer_2_array_crystal_array_4_target_index;
MCNUM mccchannel_9_analyzer_2_array_crystal_array_4_target_x;
MCNUM mccchannel_9_analyzer_2_array_crystal_array_4_target_y;
MCNUM mccchannel_9_analyzer_2_array_crystal_array_4_target_z;
MCNUM mccchannel_9_analyzer_2_array_crystal_array_4_focus_aw;
MCNUM mccchannel_9_analyzer_2_array_crystal_array_4_focus_ah;
MCNUM mccchannel_9_analyzer_2_array_crystal_array_4_focus_xw;
MCNUM mccchannel_9_analyzer_2_array_crystal_array_4_focus_xh;
MCNUM mccchannel_9_analyzer_2_array_crystal_array_4_focus_r;
MCNUM mccchannel_9_analyzer_2_array_crystal_array_4_p_interact;
char mccchannel_9_analyzer_2_array_crystal_array_4_mask_string[16384];
char mccchannel_9_analyzer_2_array_crystal_array_4_mask_setting[16384];
MCNUM mccchannel_9_analyzer_2_array_crystal_array_4_number_of_activations;

/* Setting parameters for component 'channel_9_analyzer_2_array_crystal_array_5' [488]. */
char mccchannel_9_analyzer_2_array_crystal_array_5_material_string[16384];
MCNUM mccchannel_9_analyzer_2_array_crystal_array_5_priority;
MCNUM mccchannel_9_analyzer_2_array_crystal_array_5_xwidth;
MCNUM mccchannel_9_analyzer_2_array_crystal_array_5_yheight;
MCNUM mccchannel_9_analyzer_2_array_crystal_array_5_zdepth;
MCNUM mccchannel_9_analyzer_2_array_crystal_array_5_xwidth2;
MCNUM mccchannel_9_analyzer_2_array_crystal_array_5_yheight2;
MCNUM mccchannel_9_analyzer_2_array_crystal_array_5_visualize;
int mccchannel_9_analyzer_2_array_crystal_array_5_target_index;
MCNUM mccchannel_9_analyzer_2_array_crystal_array_5_target_x;
MCNUM mccchannel_9_analyzer_2_array_crystal_array_5_target_y;
MCNUM mccchannel_9_analyzer_2_array_crystal_array_5_target_z;
MCNUM mccchannel_9_analyzer_2_array_crystal_array_5_focus_aw;
MCNUM mccchannel_9_analyzer_2_array_crystal_array_5_focus_ah;
MCNUM mccchannel_9_analyzer_2_array_crystal_array_5_focus_xw;
MCNUM mccchannel_9_analyzer_2_array_crystal_array_5_focus_xh;
MCNUM mccchannel_9_analyzer_2_array_crystal_array_5_focus_r;
MCNUM mccchannel_9_analyzer_2_array_crystal_array_5_p_interact;
char mccchannel_9_analyzer_2_array_crystal_array_5_mask_string[16384];
char mccchannel_9_analyzer_2_array_crystal_array_5_mask_setting[16384];
MCNUM mccchannel_9_analyzer_2_array_crystal_array_5_number_of_activations;

/* Setting parameters for component 'channel_9_analyzer_2_array_crystal_array_6' [489]. */
char mccchannel_9_analyzer_2_array_crystal_array_6_material_string[16384];
MCNUM mccchannel_9_analyzer_2_array_crystal_array_6_priority;
MCNUM mccchannel_9_analyzer_2_array_crystal_array_6_xwidth;
MCNUM mccchannel_9_analyzer_2_array_crystal_array_6_yheight;
MCNUM mccchannel_9_analyzer_2_array_crystal_array_6_zdepth;
MCNUM mccchannel_9_analyzer_2_array_crystal_array_6_xwidth2;
MCNUM mccchannel_9_analyzer_2_array_crystal_array_6_yheight2;
MCNUM mccchannel_9_analyzer_2_array_crystal_array_6_visualize;
int mccchannel_9_analyzer_2_array_crystal_array_6_target_index;
MCNUM mccchannel_9_analyzer_2_array_crystal_array_6_target_x;
MCNUM mccchannel_9_analyzer_2_array_crystal_array_6_target_y;
MCNUM mccchannel_9_analyzer_2_array_crystal_array_6_target_z;
MCNUM mccchannel_9_analyzer_2_array_crystal_array_6_focus_aw;
MCNUM mccchannel_9_analyzer_2_array_crystal_array_6_focus_ah;
MCNUM mccchannel_9_analyzer_2_array_crystal_array_6_focus_xw;
MCNUM mccchannel_9_analyzer_2_array_crystal_array_6_focus_xh;
MCNUM mccchannel_9_analyzer_2_array_crystal_array_6_focus_r;
MCNUM mccchannel_9_analyzer_2_array_crystal_array_6_p_interact;
char mccchannel_9_analyzer_2_array_crystal_array_6_mask_string[16384];
char mccchannel_9_analyzer_2_array_crystal_array_6_mask_setting[16384];
MCNUM mccchannel_9_analyzer_2_array_crystal_array_6_number_of_activations;

/* Setting parameters for component 'channel_9_analyzer_2_array_crystal_array_7' [490]. */
char mccchannel_9_analyzer_2_array_crystal_array_7_material_string[16384];
MCNUM mccchannel_9_analyzer_2_array_crystal_array_7_priority;
MCNUM mccchannel_9_analyzer_2_array_crystal_array_7_xwidth;
MCNUM mccchannel_9_analyzer_2_array_crystal_array_7_yheight;
MCNUM mccchannel_9_analyzer_2_array_crystal_array_7_zdepth;
MCNUM mccchannel_9_analyzer_2_array_crystal_array_7_xwidth2;
MCNUM mccchannel_9_analyzer_2_array_crystal_array_7_yheight2;
MCNUM mccchannel_9_analyzer_2_array_crystal_array_7_visualize;
int mccchannel_9_analyzer_2_array_crystal_array_7_target_index;
MCNUM mccchannel_9_analyzer_2_array_crystal_array_7_target_x;
MCNUM mccchannel_9_analyzer_2_array_crystal_array_7_target_y;
MCNUM mccchannel_9_analyzer_2_array_crystal_array_7_target_z;
MCNUM mccchannel_9_analyzer_2_array_crystal_array_7_focus_aw;
MCNUM mccchannel_9_analyzer_2_array_crystal_array_7_focus_ah;
MCNUM mccchannel_9_analyzer_2_array_crystal_array_7_focus_xw;
MCNUM mccchannel_9_analyzer_2_array_crystal_array_7_focus_xh;
MCNUM mccchannel_9_analyzer_2_array_crystal_array_7_focus_r;
MCNUM mccchannel_9_analyzer_2_array_crystal_array_7_p_interact;
char mccchannel_9_analyzer_2_array_crystal_array_7_mask_string[16384];
char mccchannel_9_analyzer_2_array_crystal_array_7_mask_setting[16384];
MCNUM mccchannel_9_analyzer_2_array_crystal_array_7_number_of_activations;

/* Setting parameters for component 'channel_9_analyzer_2_array_crystal_array_8' [491]. */
char mccchannel_9_analyzer_2_array_crystal_array_8_material_string[16384];
MCNUM mccchannel_9_analyzer_2_array_crystal_array_8_priority;
MCNUM mccchannel_9_analyzer_2_array_crystal_array_8_xwidth;
MCNUM mccchannel_9_analyzer_2_array_crystal_array_8_yheight;
MCNUM mccchannel_9_analyzer_2_array_crystal_array_8_zdepth;
MCNUM mccchannel_9_analyzer_2_array_crystal_array_8_xwidth2;
MCNUM mccchannel_9_analyzer_2_array_crystal_array_8_yheight2;
MCNUM mccchannel_9_analyzer_2_array_crystal_array_8_visualize;
int mccchannel_9_analyzer_2_array_crystal_array_8_target_index;
MCNUM mccchannel_9_analyzer_2_array_crystal_array_8_target_x;
MCNUM mccchannel_9_analyzer_2_array_crystal_array_8_target_y;
MCNUM mccchannel_9_analyzer_2_array_crystal_array_8_target_z;
MCNUM mccchannel_9_analyzer_2_array_crystal_array_8_focus_aw;
MCNUM mccchannel_9_analyzer_2_array_crystal_array_8_focus_ah;
MCNUM mccchannel_9_analyzer_2_array_crystal_array_8_focus_xw;
MCNUM mccchannel_9_analyzer_2_array_crystal_array_8_focus_xh;
MCNUM mccchannel_9_analyzer_2_array_crystal_array_8_focus_r;
MCNUM mccchannel_9_analyzer_2_array_crystal_array_8_p_interact;
char mccchannel_9_analyzer_2_array_crystal_array_8_mask_string[16384];
char mccchannel_9_analyzer_2_array_crystal_array_8_mask_setting[16384];
MCNUM mccchannel_9_analyzer_2_array_crystal_array_8_number_of_activations;

/* Setting parameters for component 'channel_9_cave2_cyl1' [492]. */
char mccchannel_9_cave2_cyl1_material_string[16384];
MCNUM mccchannel_9_cave2_cyl1_priority;
MCNUM mccchannel_9_cave2_cyl1_radius;
MCNUM mccchannel_9_cave2_cyl1_yheight;
MCNUM mccchannel_9_cave2_cyl1_visualize;
int mccchannel_9_cave2_cyl1_target_index;
MCNUM mccchannel_9_cave2_cyl1_target_x;
MCNUM mccchannel_9_cave2_cyl1_target_y;
MCNUM mccchannel_9_cave2_cyl1_target_z;
MCNUM mccchannel_9_cave2_cyl1_focus_aw;
MCNUM mccchannel_9_cave2_cyl1_focus_ah;
MCNUM mccchannel_9_cave2_cyl1_focus_xw;
MCNUM mccchannel_9_cave2_cyl1_focus_xh;
MCNUM mccchannel_9_cave2_cyl1_focus_r;
MCNUM mccchannel_9_cave2_cyl1_p_interact;
char mccchannel_9_cave2_cyl1_mask_string[16384];
char mccchannel_9_cave2_cyl1_mask_setting[16384];
MCNUM mccchannel_9_cave2_cyl1_number_of_activations;

/* Setting parameters for component 'channel_9_cave2_box1' [493]. */
char mccchannel_9_cave2_box1_material_string[16384];
MCNUM mccchannel_9_cave2_box1_priority;
MCNUM mccchannel_9_cave2_box1_xwidth;
MCNUM mccchannel_9_cave2_box1_yheight;
MCNUM mccchannel_9_cave2_box1_zdepth;
MCNUM mccchannel_9_cave2_box1_xwidth2;
MCNUM mccchannel_9_cave2_box1_yheight2;
MCNUM mccchannel_9_cave2_box1_visualize;
int mccchannel_9_cave2_box1_target_index;
MCNUM mccchannel_9_cave2_box1_target_x;
MCNUM mccchannel_9_cave2_box1_target_y;
MCNUM mccchannel_9_cave2_box1_target_z;
MCNUM mccchannel_9_cave2_box1_focus_aw;
MCNUM mccchannel_9_cave2_box1_focus_ah;
MCNUM mccchannel_9_cave2_box1_focus_xw;
MCNUM mccchannel_9_cave2_box1_focus_xh;
MCNUM mccchannel_9_cave2_box1_focus_r;
MCNUM mccchannel_9_cave2_box1_p_interact;
char mccchannel_9_cave2_box1_mask_string[16384];
char mccchannel_9_cave2_box1_mask_setting[16384];
MCNUM mccchannel_9_cave2_box1_number_of_activations;

/* Setting parameters for component 'channel_9_cave2_box2' [494]. */
char mccchannel_9_cave2_box2_material_string[16384];
MCNUM mccchannel_9_cave2_box2_priority;
MCNUM mccchannel_9_cave2_box2_xwidth;
MCNUM mccchannel_9_cave2_box2_yheight;
MCNUM mccchannel_9_cave2_box2_zdepth;
MCNUM mccchannel_9_cave2_box2_xwidth2;
MCNUM mccchannel_9_cave2_box2_yheight2;
MCNUM mccchannel_9_cave2_box2_visualize;
int mccchannel_9_cave2_box2_target_index;
MCNUM mccchannel_9_cave2_box2_target_x;
MCNUM mccchannel_9_cave2_box2_target_y;
MCNUM mccchannel_9_cave2_box2_target_z;
MCNUM mccchannel_9_cave2_box2_focus_aw;
MCNUM mccchannel_9_cave2_box2_focus_ah;
MCNUM mccchannel_9_cave2_box2_focus_xw;
MCNUM mccchannel_9_cave2_box2_focus_xh;
MCNUM mccchannel_9_cave2_box2_focus_r;
MCNUM mccchannel_9_cave2_box2_p_interact;
char mccchannel_9_cave2_box2_mask_string[16384];
char mccchannel_9_cave2_box2_mask_setting[16384];
MCNUM mccchannel_9_cave2_box2_number_of_activations;

/* Setting parameters for component 'channel_9_cave2_box3' [495]. */
char mccchannel_9_cave2_box3_material_string[16384];
MCNUM mccchannel_9_cave2_box3_priority;
MCNUM mccchannel_9_cave2_box3_xwidth;
MCNUM mccchannel_9_cave2_box3_yheight;
MCNUM mccchannel_9_cave2_box3_zdepth;
MCNUM mccchannel_9_cave2_box3_xwidth2;
MCNUM mccchannel_9_cave2_box3_yheight2;
MCNUM mccchannel_9_cave2_box3_visualize;
int mccchannel_9_cave2_box3_target_index;
MCNUM mccchannel_9_cave2_box3_target_x;
MCNUM mccchannel_9_cave2_box3_target_y;
MCNUM mccchannel_9_cave2_box3_target_z;
MCNUM mccchannel_9_cave2_box3_focus_aw;
MCNUM mccchannel_9_cave2_box3_focus_ah;
MCNUM mccchannel_9_cave2_box3_focus_xw;
MCNUM mccchannel_9_cave2_box3_focus_xh;
MCNUM mccchannel_9_cave2_box3_focus_r;
MCNUM mccchannel_9_cave2_box3_p_interact;
char mccchannel_9_cave2_box3_mask_string[16384];
char mccchannel_9_cave2_box3_mask_setting[16384];
MCNUM mccchannel_9_cave2_box3_number_of_activations;

/* Setting parameters for component 'inter_analyzer_colimator_9_blade_0' [497]. */
char mccinter_analyzer_colimator_9_blade_0_material_string[16384];
MCNUM mccinter_analyzer_colimator_9_blade_0_priority;
MCNUM mccinter_analyzer_colimator_9_blade_0_xwidth;
MCNUM mccinter_analyzer_colimator_9_blade_0_yheight;
MCNUM mccinter_analyzer_colimator_9_blade_0_zdepth;
MCNUM mccinter_analyzer_colimator_9_blade_0_xwidth2;
MCNUM mccinter_analyzer_colimator_9_blade_0_yheight2;
MCNUM mccinter_analyzer_colimator_9_blade_0_visualize;
int mccinter_analyzer_colimator_9_blade_0_target_index;
MCNUM mccinter_analyzer_colimator_9_blade_0_target_x;
MCNUM mccinter_analyzer_colimator_9_blade_0_target_y;
MCNUM mccinter_analyzer_colimator_9_blade_0_target_z;
MCNUM mccinter_analyzer_colimator_9_blade_0_focus_aw;
MCNUM mccinter_analyzer_colimator_9_blade_0_focus_ah;
MCNUM mccinter_analyzer_colimator_9_blade_0_focus_xw;
MCNUM mccinter_analyzer_colimator_9_blade_0_focus_xh;
MCNUM mccinter_analyzer_colimator_9_blade_0_focus_r;
MCNUM mccinter_analyzer_colimator_9_blade_0_p_interact;
char mccinter_analyzer_colimator_9_blade_0_mask_string[16384];
char mccinter_analyzer_colimator_9_blade_0_mask_setting[16384];
MCNUM mccinter_analyzer_colimator_9_blade_0_number_of_activations;

/* Setting parameters for component 'inter_analyzer_colimator_9_blade_1' [498]. */
char mccinter_analyzer_colimator_9_blade_1_material_string[16384];
MCNUM mccinter_analyzer_colimator_9_blade_1_priority;
MCNUM mccinter_analyzer_colimator_9_blade_1_xwidth;
MCNUM mccinter_analyzer_colimator_9_blade_1_yheight;
MCNUM mccinter_analyzer_colimator_9_blade_1_zdepth;
MCNUM mccinter_analyzer_colimator_9_blade_1_xwidth2;
MCNUM mccinter_analyzer_colimator_9_blade_1_yheight2;
MCNUM mccinter_analyzer_colimator_9_blade_1_visualize;
int mccinter_analyzer_colimator_9_blade_1_target_index;
MCNUM mccinter_analyzer_colimator_9_blade_1_target_x;
MCNUM mccinter_analyzer_colimator_9_blade_1_target_y;
MCNUM mccinter_analyzer_colimator_9_blade_1_target_z;
MCNUM mccinter_analyzer_colimator_9_blade_1_focus_aw;
MCNUM mccinter_analyzer_colimator_9_blade_1_focus_ah;
MCNUM mccinter_analyzer_colimator_9_blade_1_focus_xw;
MCNUM mccinter_analyzer_colimator_9_blade_1_focus_xh;
MCNUM mccinter_analyzer_colimator_9_blade_1_focus_r;
MCNUM mccinter_analyzer_colimator_9_blade_1_p_interact;
char mccinter_analyzer_colimator_9_blade_1_mask_string[16384];
char mccinter_analyzer_colimator_9_blade_1_mask_setting[16384];
MCNUM mccinter_analyzer_colimator_9_blade_1_number_of_activations;

/* Setting parameters for component 'inter_analyzer_colimator_9_blade_2' [499]. */
char mccinter_analyzer_colimator_9_blade_2_material_string[16384];
MCNUM mccinter_analyzer_colimator_9_blade_2_priority;
MCNUM mccinter_analyzer_colimator_9_blade_2_xwidth;
MCNUM mccinter_analyzer_colimator_9_blade_2_yheight;
MCNUM mccinter_analyzer_colimator_9_blade_2_zdepth;
MCNUM mccinter_analyzer_colimator_9_blade_2_xwidth2;
MCNUM mccinter_analyzer_colimator_9_blade_2_yheight2;
MCNUM mccinter_analyzer_colimator_9_blade_2_visualize;
int mccinter_analyzer_colimator_9_blade_2_target_index;
MCNUM mccinter_analyzer_colimator_9_blade_2_target_x;
MCNUM mccinter_analyzer_colimator_9_blade_2_target_y;
MCNUM mccinter_analyzer_colimator_9_blade_2_target_z;
MCNUM mccinter_analyzer_colimator_9_blade_2_focus_aw;
MCNUM mccinter_analyzer_colimator_9_blade_2_focus_ah;
MCNUM mccinter_analyzer_colimator_9_blade_2_focus_xw;
MCNUM mccinter_analyzer_colimator_9_blade_2_focus_xh;
MCNUM mccinter_analyzer_colimator_9_blade_2_focus_r;
MCNUM mccinter_analyzer_colimator_9_blade_2_p_interact;
char mccinter_analyzer_colimator_9_blade_2_mask_string[16384];
char mccinter_analyzer_colimator_9_blade_2_mask_setting[16384];
MCNUM mccinter_analyzer_colimator_9_blade_2_number_of_activations;

/* Setting parameters for component 'inter_analyzer_colimator_9_blade_3' [500]. */
char mccinter_analyzer_colimator_9_blade_3_material_string[16384];
MCNUM mccinter_analyzer_colimator_9_blade_3_priority;
MCNUM mccinter_analyzer_colimator_9_blade_3_xwidth;
MCNUM mccinter_analyzer_colimator_9_blade_3_yheight;
MCNUM mccinter_analyzer_colimator_9_blade_3_zdepth;
MCNUM mccinter_analyzer_colimator_9_blade_3_xwidth2;
MCNUM mccinter_analyzer_colimator_9_blade_3_yheight2;
MCNUM mccinter_analyzer_colimator_9_blade_3_visualize;
int mccinter_analyzer_colimator_9_blade_3_target_index;
MCNUM mccinter_analyzer_colimator_9_blade_3_target_x;
MCNUM mccinter_analyzer_colimator_9_blade_3_target_y;
MCNUM mccinter_analyzer_colimator_9_blade_3_target_z;
MCNUM mccinter_analyzer_colimator_9_blade_3_focus_aw;
MCNUM mccinter_analyzer_colimator_9_blade_3_focus_ah;
MCNUM mccinter_analyzer_colimator_9_blade_3_focus_xw;
MCNUM mccinter_analyzer_colimator_9_blade_3_focus_xh;
MCNUM mccinter_analyzer_colimator_9_blade_3_focus_r;
MCNUM mccinter_analyzer_colimator_9_blade_3_p_interact;
char mccinter_analyzer_colimator_9_blade_3_mask_string[16384];
char mccinter_analyzer_colimator_9_blade_3_mask_setting[16384];
MCNUM mccinter_analyzer_colimator_9_blade_3_number_of_activations;

/* Setting parameters for component 'inter_analyzer_colimator_9_blade_4' [501]. */
char mccinter_analyzer_colimator_9_blade_4_material_string[16384];
MCNUM mccinter_analyzer_colimator_9_blade_4_priority;
MCNUM mccinter_analyzer_colimator_9_blade_4_xwidth;
MCNUM mccinter_analyzer_colimator_9_blade_4_yheight;
MCNUM mccinter_analyzer_colimator_9_blade_4_zdepth;
MCNUM mccinter_analyzer_colimator_9_blade_4_xwidth2;
MCNUM mccinter_analyzer_colimator_9_blade_4_yheight2;
MCNUM mccinter_analyzer_colimator_9_blade_4_visualize;
int mccinter_analyzer_colimator_9_blade_4_target_index;
MCNUM mccinter_analyzer_colimator_9_blade_4_target_x;
MCNUM mccinter_analyzer_colimator_9_blade_4_target_y;
MCNUM mccinter_analyzer_colimator_9_blade_4_target_z;
MCNUM mccinter_analyzer_colimator_9_blade_4_focus_aw;
MCNUM mccinter_analyzer_colimator_9_blade_4_focus_ah;
MCNUM mccinter_analyzer_colimator_9_blade_4_focus_xw;
MCNUM mccinter_analyzer_colimator_9_blade_4_focus_xh;
MCNUM mccinter_analyzer_colimator_9_blade_4_focus_r;
MCNUM mccinter_analyzer_colimator_9_blade_4_p_interact;
char mccinter_analyzer_colimator_9_blade_4_mask_string[16384];
char mccinter_analyzer_colimator_9_blade_4_mask_setting[16384];
MCNUM mccinter_analyzer_colimator_9_blade_4_number_of_activations;

/* Setting parameters for component 'diffraction_detector_9_exit_volume' [502]. */
char mccdiffraction_detector_9_exit_volume_material_string[16384];
MCNUM mccdiffraction_detector_9_exit_volume_priority;
MCNUM mccdiffraction_detector_9_exit_volume_xwidth;
MCNUM mccdiffraction_detector_9_exit_volume_yheight;
MCNUM mccdiffraction_detector_9_exit_volume_zdepth;
MCNUM mccdiffraction_detector_9_exit_volume_xwidth2;
MCNUM mccdiffraction_detector_9_exit_volume_yheight2;
MCNUM mccdiffraction_detector_9_exit_volume_visualize;
int mccdiffraction_detector_9_exit_volume_target_index;
MCNUM mccdiffraction_detector_9_exit_volume_target_x;
MCNUM mccdiffraction_detector_9_exit_volume_target_y;
MCNUM mccdiffraction_detector_9_exit_volume_target_z;
MCNUM mccdiffraction_detector_9_exit_volume_focus_aw;
MCNUM mccdiffraction_detector_9_exit_volume_focus_ah;
MCNUM mccdiffraction_detector_9_exit_volume_focus_xw;
MCNUM mccdiffraction_detector_9_exit_volume_focus_xh;
MCNUM mccdiffraction_detector_9_exit_volume_focus_r;
MCNUM mccdiffraction_detector_9_exit_volume_p_interact;
char mccdiffraction_detector_9_exit_volume_mask_string[16384];
char mccdiffraction_detector_9_exit_volume_mask_setting[16384];
MCNUM mccdiffraction_detector_9_exit_volume_number_of_activations;

/* Setting parameters for component 'spec_detector_9_exit_volume' [503]. */
char mccspec_detector_9_exit_volume_material_string[16384];
MCNUM mccspec_detector_9_exit_volume_priority;
MCNUM mccspec_detector_9_exit_volume_xwidth;
MCNUM mccspec_detector_9_exit_volume_yheight;
MCNUM mccspec_detector_9_exit_volume_zdepth;
MCNUM mccspec_detector_9_exit_volume_xwidth2;
MCNUM mccspec_detector_9_exit_volume_yheight2;
MCNUM mccspec_detector_9_exit_volume_visualize;
int mccspec_detector_9_exit_volume_target_index;
MCNUM mccspec_detector_9_exit_volume_target_x;
MCNUM mccspec_detector_9_exit_volume_target_y;
MCNUM mccspec_detector_9_exit_volume_target_z;
MCNUM mccspec_detector_9_exit_volume_focus_aw;
MCNUM mccspec_detector_9_exit_volume_focus_ah;
MCNUM mccspec_detector_9_exit_volume_focus_xw;
MCNUM mccspec_detector_9_exit_volume_focus_xh;
MCNUM mccspec_detector_9_exit_volume_focus_r;
MCNUM mccspec_detector_9_exit_volume_p_interact;
char mccspec_detector_9_exit_volume_mask_string[16384];
char mccspec_detector_9_exit_volume_mask_setting[16384];
MCNUM mccspec_detector_9_exit_volume_number_of_activations;

/* Setting parameters for component 'channel_10_cave1_box1' [504]. */
char mccchannel_10_cave1_box1_material_string[16384];
MCNUM mccchannel_10_cave1_box1_priority;
MCNUM mccchannel_10_cave1_box1_xwidth;
MCNUM mccchannel_10_cave1_box1_yheight;
MCNUM mccchannel_10_cave1_box1_zdepth;
MCNUM mccchannel_10_cave1_box1_xwidth2;
MCNUM mccchannel_10_cave1_box1_yheight2;
MCNUM mccchannel_10_cave1_box1_visualize;
int mccchannel_10_cave1_box1_target_index;
MCNUM mccchannel_10_cave1_box1_target_x;
MCNUM mccchannel_10_cave1_box1_target_y;
MCNUM mccchannel_10_cave1_box1_target_z;
MCNUM mccchannel_10_cave1_box1_focus_aw;
MCNUM mccchannel_10_cave1_box1_focus_ah;
MCNUM mccchannel_10_cave1_box1_focus_xw;
MCNUM mccchannel_10_cave1_box1_focus_xh;
MCNUM mccchannel_10_cave1_box1_focus_r;
MCNUM mccchannel_10_cave1_box1_p_interact;
char mccchannel_10_cave1_box1_mask_string[16384];
char mccchannel_10_cave1_box1_mask_setting[16384];
MCNUM mccchannel_10_cave1_box1_number_of_activations;

/* Setting parameters for component 'channel_10_cave1_box2' [505]. */
char mccchannel_10_cave1_box2_material_string[16384];
MCNUM mccchannel_10_cave1_box2_priority;
MCNUM mccchannel_10_cave1_box2_xwidth;
MCNUM mccchannel_10_cave1_box2_yheight;
MCNUM mccchannel_10_cave1_box2_zdepth;
MCNUM mccchannel_10_cave1_box2_xwidth2;
MCNUM mccchannel_10_cave1_box2_yheight2;
MCNUM mccchannel_10_cave1_box2_visualize;
int mccchannel_10_cave1_box2_target_index;
MCNUM mccchannel_10_cave1_box2_target_x;
MCNUM mccchannel_10_cave1_box2_target_y;
MCNUM mccchannel_10_cave1_box2_target_z;
MCNUM mccchannel_10_cave1_box2_focus_aw;
MCNUM mccchannel_10_cave1_box2_focus_ah;
MCNUM mccchannel_10_cave1_box2_focus_xw;
MCNUM mccchannel_10_cave1_box2_focus_xh;
MCNUM mccchannel_10_cave1_box2_focus_r;
MCNUM mccchannel_10_cave1_box2_p_interact;
char mccchannel_10_cave1_box2_mask_string[16384];
char mccchannel_10_cave1_box2_mask_setting[16384];
MCNUM mccchannel_10_cave1_box2_number_of_activations;

/* Setting parameters for component 'channel_10_cave1_box3' [506]. */
char mccchannel_10_cave1_box3_material_string[16384];
MCNUM mccchannel_10_cave1_box3_priority;
MCNUM mccchannel_10_cave1_box3_xwidth;
MCNUM mccchannel_10_cave1_box3_yheight;
MCNUM mccchannel_10_cave1_box3_zdepth;
MCNUM mccchannel_10_cave1_box3_xwidth2;
MCNUM mccchannel_10_cave1_box3_yheight2;
MCNUM mccchannel_10_cave1_box3_visualize;
int mccchannel_10_cave1_box3_target_index;
MCNUM mccchannel_10_cave1_box3_target_x;
MCNUM mccchannel_10_cave1_box3_target_y;
MCNUM mccchannel_10_cave1_box3_target_z;
MCNUM mccchannel_10_cave1_box3_focus_aw;
MCNUM mccchannel_10_cave1_box3_focus_ah;
MCNUM mccchannel_10_cave1_box3_focus_xw;
MCNUM mccchannel_10_cave1_box3_focus_xh;
MCNUM mccchannel_10_cave1_box3_focus_r;
MCNUM mccchannel_10_cave1_box3_p_interact;
char mccchannel_10_cave1_box3_mask_string[16384];
char mccchannel_10_cave1_box3_mask_setting[16384];
MCNUM mccchannel_10_cave1_box3_number_of_activations;

/* Setting parameters for component 'channel_10_cave1_cyl1' [507]. */
char mccchannel_10_cave1_cyl1_material_string[16384];
MCNUM mccchannel_10_cave1_cyl1_priority;
MCNUM mccchannel_10_cave1_cyl1_radius;
MCNUM mccchannel_10_cave1_cyl1_yheight;
MCNUM mccchannel_10_cave1_cyl1_visualize;
int mccchannel_10_cave1_cyl1_target_index;
MCNUM mccchannel_10_cave1_cyl1_target_x;
MCNUM mccchannel_10_cave1_cyl1_target_y;
MCNUM mccchannel_10_cave1_cyl1_target_z;
MCNUM mccchannel_10_cave1_cyl1_focus_aw;
MCNUM mccchannel_10_cave1_cyl1_focus_ah;
MCNUM mccchannel_10_cave1_cyl1_focus_xw;
MCNUM mccchannel_10_cave1_cyl1_focus_xh;
MCNUM mccchannel_10_cave1_cyl1_focus_r;
MCNUM mccchannel_10_cave1_cyl1_p_interact;
char mccchannel_10_cave1_cyl1_mask_string[16384];
char mccchannel_10_cave1_cyl1_mask_setting[16384];
MCNUM mccchannel_10_cave1_cyl1_number_of_activations;

/* Setting parameters for component 'channel_10_analyzer_1_array_crystal_array_0' [510]. */
char mccchannel_10_analyzer_1_array_crystal_array_0_material_string[16384];
MCNUM mccchannel_10_analyzer_1_array_crystal_array_0_priority;
MCNUM mccchannel_10_analyzer_1_array_crystal_array_0_xwidth;
MCNUM mccchannel_10_analyzer_1_array_crystal_array_0_yheight;
MCNUM mccchannel_10_analyzer_1_array_crystal_array_0_zdepth;
MCNUM mccchannel_10_analyzer_1_array_crystal_array_0_xwidth2;
MCNUM mccchannel_10_analyzer_1_array_crystal_array_0_yheight2;
MCNUM mccchannel_10_analyzer_1_array_crystal_array_0_visualize;
int mccchannel_10_analyzer_1_array_crystal_array_0_target_index;
MCNUM mccchannel_10_analyzer_1_array_crystal_array_0_target_x;
MCNUM mccchannel_10_analyzer_1_array_crystal_array_0_target_y;
MCNUM mccchannel_10_analyzer_1_array_crystal_array_0_target_z;
MCNUM mccchannel_10_analyzer_1_array_crystal_array_0_focus_aw;
MCNUM mccchannel_10_analyzer_1_array_crystal_array_0_focus_ah;
MCNUM mccchannel_10_analyzer_1_array_crystal_array_0_focus_xw;
MCNUM mccchannel_10_analyzer_1_array_crystal_array_0_focus_xh;
MCNUM mccchannel_10_analyzer_1_array_crystal_array_0_focus_r;
MCNUM mccchannel_10_analyzer_1_array_crystal_array_0_p_interact;
char mccchannel_10_analyzer_1_array_crystal_array_0_mask_string[16384];
char mccchannel_10_analyzer_1_array_crystal_array_0_mask_setting[16384];
MCNUM mccchannel_10_analyzer_1_array_crystal_array_0_number_of_activations;

/* Setting parameters for component 'channel_10_analyzer_1_array_crystal_array_1' [511]. */
char mccchannel_10_analyzer_1_array_crystal_array_1_material_string[16384];
MCNUM mccchannel_10_analyzer_1_array_crystal_array_1_priority;
MCNUM mccchannel_10_analyzer_1_array_crystal_array_1_xwidth;
MCNUM mccchannel_10_analyzer_1_array_crystal_array_1_yheight;
MCNUM mccchannel_10_analyzer_1_array_crystal_array_1_zdepth;
MCNUM mccchannel_10_analyzer_1_array_crystal_array_1_xwidth2;
MCNUM mccchannel_10_analyzer_1_array_crystal_array_1_yheight2;
MCNUM mccchannel_10_analyzer_1_array_crystal_array_1_visualize;
int mccchannel_10_analyzer_1_array_crystal_array_1_target_index;
MCNUM mccchannel_10_analyzer_1_array_crystal_array_1_target_x;
MCNUM mccchannel_10_analyzer_1_array_crystal_array_1_target_y;
MCNUM mccchannel_10_analyzer_1_array_crystal_array_1_target_z;
MCNUM mccchannel_10_analyzer_1_array_crystal_array_1_focus_aw;
MCNUM mccchannel_10_analyzer_1_array_crystal_array_1_focus_ah;
MCNUM mccchannel_10_analyzer_1_array_crystal_array_1_focus_xw;
MCNUM mccchannel_10_analyzer_1_array_crystal_array_1_focus_xh;
MCNUM mccchannel_10_analyzer_1_array_crystal_array_1_focus_r;
MCNUM mccchannel_10_analyzer_1_array_crystal_array_1_p_interact;
char mccchannel_10_analyzer_1_array_crystal_array_1_mask_string[16384];
char mccchannel_10_analyzer_1_array_crystal_array_1_mask_setting[16384];
MCNUM mccchannel_10_analyzer_1_array_crystal_array_1_number_of_activations;

/* Setting parameters for component 'channel_10_analyzer_1_array_crystal_array_2' [512]. */
char mccchannel_10_analyzer_1_array_crystal_array_2_material_string[16384];
MCNUM mccchannel_10_analyzer_1_array_crystal_array_2_priority;
MCNUM mccchannel_10_analyzer_1_array_crystal_array_2_xwidth;
MCNUM mccchannel_10_analyzer_1_array_crystal_array_2_yheight;
MCNUM mccchannel_10_analyzer_1_array_crystal_array_2_zdepth;
MCNUM mccchannel_10_analyzer_1_array_crystal_array_2_xwidth2;
MCNUM mccchannel_10_analyzer_1_array_crystal_array_2_yheight2;
MCNUM mccchannel_10_analyzer_1_array_crystal_array_2_visualize;
int mccchannel_10_analyzer_1_array_crystal_array_2_target_index;
MCNUM mccchannel_10_analyzer_1_array_crystal_array_2_target_x;
MCNUM mccchannel_10_analyzer_1_array_crystal_array_2_target_y;
MCNUM mccchannel_10_analyzer_1_array_crystal_array_2_target_z;
MCNUM mccchannel_10_analyzer_1_array_crystal_array_2_focus_aw;
MCNUM mccchannel_10_analyzer_1_array_crystal_array_2_focus_ah;
MCNUM mccchannel_10_analyzer_1_array_crystal_array_2_focus_xw;
MCNUM mccchannel_10_analyzer_1_array_crystal_array_2_focus_xh;
MCNUM mccchannel_10_analyzer_1_array_crystal_array_2_focus_r;
MCNUM mccchannel_10_analyzer_1_array_crystal_array_2_p_interact;
char mccchannel_10_analyzer_1_array_crystal_array_2_mask_string[16384];
char mccchannel_10_analyzer_1_array_crystal_array_2_mask_setting[16384];
MCNUM mccchannel_10_analyzer_1_array_crystal_array_2_number_of_activations;

/* Setting parameters for component 'channel_10_analyzer_1_array_crystal_array_3' [513]. */
char mccchannel_10_analyzer_1_array_crystal_array_3_material_string[16384];
MCNUM mccchannel_10_analyzer_1_array_crystal_array_3_priority;
MCNUM mccchannel_10_analyzer_1_array_crystal_array_3_xwidth;
MCNUM mccchannel_10_analyzer_1_array_crystal_array_3_yheight;
MCNUM mccchannel_10_analyzer_1_array_crystal_array_3_zdepth;
MCNUM mccchannel_10_analyzer_1_array_crystal_array_3_xwidth2;
MCNUM mccchannel_10_analyzer_1_array_crystal_array_3_yheight2;
MCNUM mccchannel_10_analyzer_1_array_crystal_array_3_visualize;
int mccchannel_10_analyzer_1_array_crystal_array_3_target_index;
MCNUM mccchannel_10_analyzer_1_array_crystal_array_3_target_x;
MCNUM mccchannel_10_analyzer_1_array_crystal_array_3_target_y;
MCNUM mccchannel_10_analyzer_1_array_crystal_array_3_target_z;
MCNUM mccchannel_10_analyzer_1_array_crystal_array_3_focus_aw;
MCNUM mccchannel_10_analyzer_1_array_crystal_array_3_focus_ah;
MCNUM mccchannel_10_analyzer_1_array_crystal_array_3_focus_xw;
MCNUM mccchannel_10_analyzer_1_array_crystal_array_3_focus_xh;
MCNUM mccchannel_10_analyzer_1_array_crystal_array_3_focus_r;
MCNUM mccchannel_10_analyzer_1_array_crystal_array_3_p_interact;
char mccchannel_10_analyzer_1_array_crystal_array_3_mask_string[16384];
char mccchannel_10_analyzer_1_array_crystal_array_3_mask_setting[16384];
MCNUM mccchannel_10_analyzer_1_array_crystal_array_3_number_of_activations;

/* Setting parameters for component 'channel_10_analyzer_1_array_crystal_array_4' [514]. */
char mccchannel_10_analyzer_1_array_crystal_array_4_material_string[16384];
MCNUM mccchannel_10_analyzer_1_array_crystal_array_4_priority;
MCNUM mccchannel_10_analyzer_1_array_crystal_array_4_xwidth;
MCNUM mccchannel_10_analyzer_1_array_crystal_array_4_yheight;
MCNUM mccchannel_10_analyzer_1_array_crystal_array_4_zdepth;
MCNUM mccchannel_10_analyzer_1_array_crystal_array_4_xwidth2;
MCNUM mccchannel_10_analyzer_1_array_crystal_array_4_yheight2;
MCNUM mccchannel_10_analyzer_1_array_crystal_array_4_visualize;
int mccchannel_10_analyzer_1_array_crystal_array_4_target_index;
MCNUM mccchannel_10_analyzer_1_array_crystal_array_4_target_x;
MCNUM mccchannel_10_analyzer_1_array_crystal_array_4_target_y;
MCNUM mccchannel_10_analyzer_1_array_crystal_array_4_target_z;
MCNUM mccchannel_10_analyzer_1_array_crystal_array_4_focus_aw;
MCNUM mccchannel_10_analyzer_1_array_crystal_array_4_focus_ah;
MCNUM mccchannel_10_analyzer_1_array_crystal_array_4_focus_xw;
MCNUM mccchannel_10_analyzer_1_array_crystal_array_4_focus_xh;
MCNUM mccchannel_10_analyzer_1_array_crystal_array_4_focus_r;
MCNUM mccchannel_10_analyzer_1_array_crystal_array_4_p_interact;
char mccchannel_10_analyzer_1_array_crystal_array_4_mask_string[16384];
char mccchannel_10_analyzer_1_array_crystal_array_4_mask_setting[16384];
MCNUM mccchannel_10_analyzer_1_array_crystal_array_4_number_of_activations;

/* Setting parameters for component 'channel_10_analyzer_1_array_crystal_array_5' [515]. */
char mccchannel_10_analyzer_1_array_crystal_array_5_material_string[16384];
MCNUM mccchannel_10_analyzer_1_array_crystal_array_5_priority;
MCNUM mccchannel_10_analyzer_1_array_crystal_array_5_xwidth;
MCNUM mccchannel_10_analyzer_1_array_crystal_array_5_yheight;
MCNUM mccchannel_10_analyzer_1_array_crystal_array_5_zdepth;
MCNUM mccchannel_10_analyzer_1_array_crystal_array_5_xwidth2;
MCNUM mccchannel_10_analyzer_1_array_crystal_array_5_yheight2;
MCNUM mccchannel_10_analyzer_1_array_crystal_array_5_visualize;
int mccchannel_10_analyzer_1_array_crystal_array_5_target_index;
MCNUM mccchannel_10_analyzer_1_array_crystal_array_5_target_x;
MCNUM mccchannel_10_analyzer_1_array_crystal_array_5_target_y;
MCNUM mccchannel_10_analyzer_1_array_crystal_array_5_target_z;
MCNUM mccchannel_10_analyzer_1_array_crystal_array_5_focus_aw;
MCNUM mccchannel_10_analyzer_1_array_crystal_array_5_focus_ah;
MCNUM mccchannel_10_analyzer_1_array_crystal_array_5_focus_xw;
MCNUM mccchannel_10_analyzer_1_array_crystal_array_5_focus_xh;
MCNUM mccchannel_10_analyzer_1_array_crystal_array_5_focus_r;
MCNUM mccchannel_10_analyzer_1_array_crystal_array_5_p_interact;
char mccchannel_10_analyzer_1_array_crystal_array_5_mask_string[16384];
char mccchannel_10_analyzer_1_array_crystal_array_5_mask_setting[16384];
MCNUM mccchannel_10_analyzer_1_array_crystal_array_5_number_of_activations;

/* Setting parameters for component 'channel_10_analyzer_1_array_crystal_array_6' [516]. */
char mccchannel_10_analyzer_1_array_crystal_array_6_material_string[16384];
MCNUM mccchannel_10_analyzer_1_array_crystal_array_6_priority;
MCNUM mccchannel_10_analyzer_1_array_crystal_array_6_xwidth;
MCNUM mccchannel_10_analyzer_1_array_crystal_array_6_yheight;
MCNUM mccchannel_10_analyzer_1_array_crystal_array_6_zdepth;
MCNUM mccchannel_10_analyzer_1_array_crystal_array_6_xwidth2;
MCNUM mccchannel_10_analyzer_1_array_crystal_array_6_yheight2;
MCNUM mccchannel_10_analyzer_1_array_crystal_array_6_visualize;
int mccchannel_10_analyzer_1_array_crystal_array_6_target_index;
MCNUM mccchannel_10_analyzer_1_array_crystal_array_6_target_x;
MCNUM mccchannel_10_analyzer_1_array_crystal_array_6_target_y;
MCNUM mccchannel_10_analyzer_1_array_crystal_array_6_target_z;
MCNUM mccchannel_10_analyzer_1_array_crystal_array_6_focus_aw;
MCNUM mccchannel_10_analyzer_1_array_crystal_array_6_focus_ah;
MCNUM mccchannel_10_analyzer_1_array_crystal_array_6_focus_xw;
MCNUM mccchannel_10_analyzer_1_array_crystal_array_6_focus_xh;
MCNUM mccchannel_10_analyzer_1_array_crystal_array_6_focus_r;
MCNUM mccchannel_10_analyzer_1_array_crystal_array_6_p_interact;
char mccchannel_10_analyzer_1_array_crystal_array_6_mask_string[16384];
char mccchannel_10_analyzer_1_array_crystal_array_6_mask_setting[16384];
MCNUM mccchannel_10_analyzer_1_array_crystal_array_6_number_of_activations;

/* Setting parameters for component 'channel_10_analyzer_1_array_crystal_array_7' [517]. */
char mccchannel_10_analyzer_1_array_crystal_array_7_material_string[16384];
MCNUM mccchannel_10_analyzer_1_array_crystal_array_7_priority;
MCNUM mccchannel_10_analyzer_1_array_crystal_array_7_xwidth;
MCNUM mccchannel_10_analyzer_1_array_crystal_array_7_yheight;
MCNUM mccchannel_10_analyzer_1_array_crystal_array_7_zdepth;
MCNUM mccchannel_10_analyzer_1_array_crystal_array_7_xwidth2;
MCNUM mccchannel_10_analyzer_1_array_crystal_array_7_yheight2;
MCNUM mccchannel_10_analyzer_1_array_crystal_array_7_visualize;
int mccchannel_10_analyzer_1_array_crystal_array_7_target_index;
MCNUM mccchannel_10_analyzer_1_array_crystal_array_7_target_x;
MCNUM mccchannel_10_analyzer_1_array_crystal_array_7_target_y;
MCNUM mccchannel_10_analyzer_1_array_crystal_array_7_target_z;
MCNUM mccchannel_10_analyzer_1_array_crystal_array_7_focus_aw;
MCNUM mccchannel_10_analyzer_1_array_crystal_array_7_focus_ah;
MCNUM mccchannel_10_analyzer_1_array_crystal_array_7_focus_xw;
MCNUM mccchannel_10_analyzer_1_array_crystal_array_7_focus_xh;
MCNUM mccchannel_10_analyzer_1_array_crystal_array_7_focus_r;
MCNUM mccchannel_10_analyzer_1_array_crystal_array_7_p_interact;
char mccchannel_10_analyzer_1_array_crystal_array_7_mask_string[16384];
char mccchannel_10_analyzer_1_array_crystal_array_7_mask_setting[16384];
MCNUM mccchannel_10_analyzer_1_array_crystal_array_7_number_of_activations;

/* Setting parameters for component 'channel_10_analyzer_1_array_crystal_array_8' [518]. */
char mccchannel_10_analyzer_1_array_crystal_array_8_material_string[16384];
MCNUM mccchannel_10_analyzer_1_array_crystal_array_8_priority;
MCNUM mccchannel_10_analyzer_1_array_crystal_array_8_xwidth;
MCNUM mccchannel_10_analyzer_1_array_crystal_array_8_yheight;
MCNUM mccchannel_10_analyzer_1_array_crystal_array_8_zdepth;
MCNUM mccchannel_10_analyzer_1_array_crystal_array_8_xwidth2;
MCNUM mccchannel_10_analyzer_1_array_crystal_array_8_yheight2;
MCNUM mccchannel_10_analyzer_1_array_crystal_array_8_visualize;
int mccchannel_10_analyzer_1_array_crystal_array_8_target_index;
MCNUM mccchannel_10_analyzer_1_array_crystal_array_8_target_x;
MCNUM mccchannel_10_analyzer_1_array_crystal_array_8_target_y;
MCNUM mccchannel_10_analyzer_1_array_crystal_array_8_target_z;
MCNUM mccchannel_10_analyzer_1_array_crystal_array_8_focus_aw;
MCNUM mccchannel_10_analyzer_1_array_crystal_array_8_focus_ah;
MCNUM mccchannel_10_analyzer_1_array_crystal_array_8_focus_xw;
MCNUM mccchannel_10_analyzer_1_array_crystal_array_8_focus_xh;
MCNUM mccchannel_10_analyzer_1_array_crystal_array_8_focus_r;
MCNUM mccchannel_10_analyzer_1_array_crystal_array_8_p_interact;
char mccchannel_10_analyzer_1_array_crystal_array_8_mask_string[16384];
char mccchannel_10_analyzer_1_array_crystal_array_8_mask_setting[16384];
MCNUM mccchannel_10_analyzer_1_array_crystal_array_8_number_of_activations;

/* Setting parameters for component 'channel_10_analyzer_2_array_crystal_array_0' [521]. */
char mccchannel_10_analyzer_2_array_crystal_array_0_material_string[16384];
MCNUM mccchannel_10_analyzer_2_array_crystal_array_0_priority;
MCNUM mccchannel_10_analyzer_2_array_crystal_array_0_xwidth;
MCNUM mccchannel_10_analyzer_2_array_crystal_array_0_yheight;
MCNUM mccchannel_10_analyzer_2_array_crystal_array_0_zdepth;
MCNUM mccchannel_10_analyzer_2_array_crystal_array_0_xwidth2;
MCNUM mccchannel_10_analyzer_2_array_crystal_array_0_yheight2;
MCNUM mccchannel_10_analyzer_2_array_crystal_array_0_visualize;
int mccchannel_10_analyzer_2_array_crystal_array_0_target_index;
MCNUM mccchannel_10_analyzer_2_array_crystal_array_0_target_x;
MCNUM mccchannel_10_analyzer_2_array_crystal_array_0_target_y;
MCNUM mccchannel_10_analyzer_2_array_crystal_array_0_target_z;
MCNUM mccchannel_10_analyzer_2_array_crystal_array_0_focus_aw;
MCNUM mccchannel_10_analyzer_2_array_crystal_array_0_focus_ah;
MCNUM mccchannel_10_analyzer_2_array_crystal_array_0_focus_xw;
MCNUM mccchannel_10_analyzer_2_array_crystal_array_0_focus_xh;
MCNUM mccchannel_10_analyzer_2_array_crystal_array_0_focus_r;
MCNUM mccchannel_10_analyzer_2_array_crystal_array_0_p_interact;
char mccchannel_10_analyzer_2_array_crystal_array_0_mask_string[16384];
char mccchannel_10_analyzer_2_array_crystal_array_0_mask_setting[16384];
MCNUM mccchannel_10_analyzer_2_array_crystal_array_0_number_of_activations;

/* Setting parameters for component 'channel_10_analyzer_2_array_crystal_array_1' [522]. */
char mccchannel_10_analyzer_2_array_crystal_array_1_material_string[16384];
MCNUM mccchannel_10_analyzer_2_array_crystal_array_1_priority;
MCNUM mccchannel_10_analyzer_2_array_crystal_array_1_xwidth;
MCNUM mccchannel_10_analyzer_2_array_crystal_array_1_yheight;
MCNUM mccchannel_10_analyzer_2_array_crystal_array_1_zdepth;
MCNUM mccchannel_10_analyzer_2_array_crystal_array_1_xwidth2;
MCNUM mccchannel_10_analyzer_2_array_crystal_array_1_yheight2;
MCNUM mccchannel_10_analyzer_2_array_crystal_array_1_visualize;
int mccchannel_10_analyzer_2_array_crystal_array_1_target_index;
MCNUM mccchannel_10_analyzer_2_array_crystal_array_1_target_x;
MCNUM mccchannel_10_analyzer_2_array_crystal_array_1_target_y;
MCNUM mccchannel_10_analyzer_2_array_crystal_array_1_target_z;
MCNUM mccchannel_10_analyzer_2_array_crystal_array_1_focus_aw;
MCNUM mccchannel_10_analyzer_2_array_crystal_array_1_focus_ah;
MCNUM mccchannel_10_analyzer_2_array_crystal_array_1_focus_xw;
MCNUM mccchannel_10_analyzer_2_array_crystal_array_1_focus_xh;
MCNUM mccchannel_10_analyzer_2_array_crystal_array_1_focus_r;
MCNUM mccchannel_10_analyzer_2_array_crystal_array_1_p_interact;
char mccchannel_10_analyzer_2_array_crystal_array_1_mask_string[16384];
char mccchannel_10_analyzer_2_array_crystal_array_1_mask_setting[16384];
MCNUM mccchannel_10_analyzer_2_array_crystal_array_1_number_of_activations;

/* Setting parameters for component 'channel_10_analyzer_2_array_crystal_array_2' [523]. */
char mccchannel_10_analyzer_2_array_crystal_array_2_material_string[16384];
MCNUM mccchannel_10_analyzer_2_array_crystal_array_2_priority;
MCNUM mccchannel_10_analyzer_2_array_crystal_array_2_xwidth;
MCNUM mccchannel_10_analyzer_2_array_crystal_array_2_yheight;
MCNUM mccchannel_10_analyzer_2_array_crystal_array_2_zdepth;
MCNUM mccchannel_10_analyzer_2_array_crystal_array_2_xwidth2;
MCNUM mccchannel_10_analyzer_2_array_crystal_array_2_yheight2;
MCNUM mccchannel_10_analyzer_2_array_crystal_array_2_visualize;
int mccchannel_10_analyzer_2_array_crystal_array_2_target_index;
MCNUM mccchannel_10_analyzer_2_array_crystal_array_2_target_x;
MCNUM mccchannel_10_analyzer_2_array_crystal_array_2_target_y;
MCNUM mccchannel_10_analyzer_2_array_crystal_array_2_target_z;
MCNUM mccchannel_10_analyzer_2_array_crystal_array_2_focus_aw;
MCNUM mccchannel_10_analyzer_2_array_crystal_array_2_focus_ah;
MCNUM mccchannel_10_analyzer_2_array_crystal_array_2_focus_xw;
MCNUM mccchannel_10_analyzer_2_array_crystal_array_2_focus_xh;
MCNUM mccchannel_10_analyzer_2_array_crystal_array_2_focus_r;
MCNUM mccchannel_10_analyzer_2_array_crystal_array_2_p_interact;
char mccchannel_10_analyzer_2_array_crystal_array_2_mask_string[16384];
char mccchannel_10_analyzer_2_array_crystal_array_2_mask_setting[16384];
MCNUM mccchannel_10_analyzer_2_array_crystal_array_2_number_of_activations;

/* Setting parameters for component 'channel_10_analyzer_2_array_crystal_array_3' [524]. */
char mccchannel_10_analyzer_2_array_crystal_array_3_material_string[16384];
MCNUM mccchannel_10_analyzer_2_array_crystal_array_3_priority;
MCNUM mccchannel_10_analyzer_2_array_crystal_array_3_xwidth;
MCNUM mccchannel_10_analyzer_2_array_crystal_array_3_yheight;
MCNUM mccchannel_10_analyzer_2_array_crystal_array_3_zdepth;
MCNUM mccchannel_10_analyzer_2_array_crystal_array_3_xwidth2;
MCNUM mccchannel_10_analyzer_2_array_crystal_array_3_yheight2;
MCNUM mccchannel_10_analyzer_2_array_crystal_array_3_visualize;
int mccchannel_10_analyzer_2_array_crystal_array_3_target_index;
MCNUM mccchannel_10_analyzer_2_array_crystal_array_3_target_x;
MCNUM mccchannel_10_analyzer_2_array_crystal_array_3_target_y;
MCNUM mccchannel_10_analyzer_2_array_crystal_array_3_target_z;
MCNUM mccchannel_10_analyzer_2_array_crystal_array_3_focus_aw;
MCNUM mccchannel_10_analyzer_2_array_crystal_array_3_focus_ah;
MCNUM mccchannel_10_analyzer_2_array_crystal_array_3_focus_xw;
MCNUM mccchannel_10_analyzer_2_array_crystal_array_3_focus_xh;
MCNUM mccchannel_10_analyzer_2_array_crystal_array_3_focus_r;
MCNUM mccchannel_10_analyzer_2_array_crystal_array_3_p_interact;
char mccchannel_10_analyzer_2_array_crystal_array_3_mask_string[16384];
char mccchannel_10_analyzer_2_array_crystal_array_3_mask_setting[16384];
MCNUM mccchannel_10_analyzer_2_array_crystal_array_3_number_of_activations;

/* Setting parameters for component 'channel_10_analyzer_2_array_crystal_array_4' [525]. */
char mccchannel_10_analyzer_2_array_crystal_array_4_material_string[16384];
MCNUM mccchannel_10_analyzer_2_array_crystal_array_4_priority;
MCNUM mccchannel_10_analyzer_2_array_crystal_array_4_xwidth;
MCNUM mccchannel_10_analyzer_2_array_crystal_array_4_yheight;
MCNUM mccchannel_10_analyzer_2_array_crystal_array_4_zdepth;
MCNUM mccchannel_10_analyzer_2_array_crystal_array_4_xwidth2;
MCNUM mccchannel_10_analyzer_2_array_crystal_array_4_yheight2;
MCNUM mccchannel_10_analyzer_2_array_crystal_array_4_visualize;
int mccchannel_10_analyzer_2_array_crystal_array_4_target_index;
MCNUM mccchannel_10_analyzer_2_array_crystal_array_4_target_x;
MCNUM mccchannel_10_analyzer_2_array_crystal_array_4_target_y;
MCNUM mccchannel_10_analyzer_2_array_crystal_array_4_target_z;
MCNUM mccchannel_10_analyzer_2_array_crystal_array_4_focus_aw;
MCNUM mccchannel_10_analyzer_2_array_crystal_array_4_focus_ah;
MCNUM mccchannel_10_analyzer_2_array_crystal_array_4_focus_xw;
MCNUM mccchannel_10_analyzer_2_array_crystal_array_4_focus_xh;
MCNUM mccchannel_10_analyzer_2_array_crystal_array_4_focus_r;
MCNUM mccchannel_10_analyzer_2_array_crystal_array_4_p_interact;
char mccchannel_10_analyzer_2_array_crystal_array_4_mask_string[16384];
char mccchannel_10_analyzer_2_array_crystal_array_4_mask_setting[16384];
MCNUM mccchannel_10_analyzer_2_array_crystal_array_4_number_of_activations;

/* Setting parameters for component 'channel_10_analyzer_2_array_crystal_array_5' [526]. */
char mccchannel_10_analyzer_2_array_crystal_array_5_material_string[16384];
MCNUM mccchannel_10_analyzer_2_array_crystal_array_5_priority;
MCNUM mccchannel_10_analyzer_2_array_crystal_array_5_xwidth;
MCNUM mccchannel_10_analyzer_2_array_crystal_array_5_yheight;
MCNUM mccchannel_10_analyzer_2_array_crystal_array_5_zdepth;
MCNUM mccchannel_10_analyzer_2_array_crystal_array_5_xwidth2;
MCNUM mccchannel_10_analyzer_2_array_crystal_array_5_yheight2;
MCNUM mccchannel_10_analyzer_2_array_crystal_array_5_visualize;
int mccchannel_10_analyzer_2_array_crystal_array_5_target_index;
MCNUM mccchannel_10_analyzer_2_array_crystal_array_5_target_x;
MCNUM mccchannel_10_analyzer_2_array_crystal_array_5_target_y;
MCNUM mccchannel_10_analyzer_2_array_crystal_array_5_target_z;
MCNUM mccchannel_10_analyzer_2_array_crystal_array_5_focus_aw;
MCNUM mccchannel_10_analyzer_2_array_crystal_array_5_focus_ah;
MCNUM mccchannel_10_analyzer_2_array_crystal_array_5_focus_xw;
MCNUM mccchannel_10_analyzer_2_array_crystal_array_5_focus_xh;
MCNUM mccchannel_10_analyzer_2_array_crystal_array_5_focus_r;
MCNUM mccchannel_10_analyzer_2_array_crystal_array_5_p_interact;
char mccchannel_10_analyzer_2_array_crystal_array_5_mask_string[16384];
char mccchannel_10_analyzer_2_array_crystal_array_5_mask_setting[16384];
MCNUM mccchannel_10_analyzer_2_array_crystal_array_5_number_of_activations;

/* Setting parameters for component 'channel_10_analyzer_2_array_crystal_array_6' [527]. */
char mccchannel_10_analyzer_2_array_crystal_array_6_material_string[16384];
MCNUM mccchannel_10_analyzer_2_array_crystal_array_6_priority;
MCNUM mccchannel_10_analyzer_2_array_crystal_array_6_xwidth;
MCNUM mccchannel_10_analyzer_2_array_crystal_array_6_yheight;
MCNUM mccchannel_10_analyzer_2_array_crystal_array_6_zdepth;
MCNUM mccchannel_10_analyzer_2_array_crystal_array_6_xwidth2;
MCNUM mccchannel_10_analyzer_2_array_crystal_array_6_yheight2;
MCNUM mccchannel_10_analyzer_2_array_crystal_array_6_visualize;
int mccchannel_10_analyzer_2_array_crystal_array_6_target_index;
MCNUM mccchannel_10_analyzer_2_array_crystal_array_6_target_x;
MCNUM mccchannel_10_analyzer_2_array_crystal_array_6_target_y;
MCNUM mccchannel_10_analyzer_2_array_crystal_array_6_target_z;
MCNUM mccchannel_10_analyzer_2_array_crystal_array_6_focus_aw;
MCNUM mccchannel_10_analyzer_2_array_crystal_array_6_focus_ah;
MCNUM mccchannel_10_analyzer_2_array_crystal_array_6_focus_xw;
MCNUM mccchannel_10_analyzer_2_array_crystal_array_6_focus_xh;
MCNUM mccchannel_10_analyzer_2_array_crystal_array_6_focus_r;
MCNUM mccchannel_10_analyzer_2_array_crystal_array_6_p_interact;
char mccchannel_10_analyzer_2_array_crystal_array_6_mask_string[16384];
char mccchannel_10_analyzer_2_array_crystal_array_6_mask_setting[16384];
MCNUM mccchannel_10_analyzer_2_array_crystal_array_6_number_of_activations;

/* Setting parameters for component 'channel_10_analyzer_2_array_crystal_array_7' [528]. */
char mccchannel_10_analyzer_2_array_crystal_array_7_material_string[16384];
MCNUM mccchannel_10_analyzer_2_array_crystal_array_7_priority;
MCNUM mccchannel_10_analyzer_2_array_crystal_array_7_xwidth;
MCNUM mccchannel_10_analyzer_2_array_crystal_array_7_yheight;
MCNUM mccchannel_10_analyzer_2_array_crystal_array_7_zdepth;
MCNUM mccchannel_10_analyzer_2_array_crystal_array_7_xwidth2;
MCNUM mccchannel_10_analyzer_2_array_crystal_array_7_yheight2;
MCNUM mccchannel_10_analyzer_2_array_crystal_array_7_visualize;
int mccchannel_10_analyzer_2_array_crystal_array_7_target_index;
MCNUM mccchannel_10_analyzer_2_array_crystal_array_7_target_x;
MCNUM mccchannel_10_analyzer_2_array_crystal_array_7_target_y;
MCNUM mccchannel_10_analyzer_2_array_crystal_array_7_target_z;
MCNUM mccchannel_10_analyzer_2_array_crystal_array_7_focus_aw;
MCNUM mccchannel_10_analyzer_2_array_crystal_array_7_focus_ah;
MCNUM mccchannel_10_analyzer_2_array_crystal_array_7_focus_xw;
MCNUM mccchannel_10_analyzer_2_array_crystal_array_7_focus_xh;
MCNUM mccchannel_10_analyzer_2_array_crystal_array_7_focus_r;
MCNUM mccchannel_10_analyzer_2_array_crystal_array_7_p_interact;
char mccchannel_10_analyzer_2_array_crystal_array_7_mask_string[16384];
char mccchannel_10_analyzer_2_array_crystal_array_7_mask_setting[16384];
MCNUM mccchannel_10_analyzer_2_array_crystal_array_7_number_of_activations;

/* Setting parameters for component 'channel_10_analyzer_2_array_crystal_array_8' [529]. */
char mccchannel_10_analyzer_2_array_crystal_array_8_material_string[16384];
MCNUM mccchannel_10_analyzer_2_array_crystal_array_8_priority;
MCNUM mccchannel_10_analyzer_2_array_crystal_array_8_xwidth;
MCNUM mccchannel_10_analyzer_2_array_crystal_array_8_yheight;
MCNUM mccchannel_10_analyzer_2_array_crystal_array_8_zdepth;
MCNUM mccchannel_10_analyzer_2_array_crystal_array_8_xwidth2;
MCNUM mccchannel_10_analyzer_2_array_crystal_array_8_yheight2;
MCNUM mccchannel_10_analyzer_2_array_crystal_array_8_visualize;
int mccchannel_10_analyzer_2_array_crystal_array_8_target_index;
MCNUM mccchannel_10_analyzer_2_array_crystal_array_8_target_x;
MCNUM mccchannel_10_analyzer_2_array_crystal_array_8_target_y;
MCNUM mccchannel_10_analyzer_2_array_crystal_array_8_target_z;
MCNUM mccchannel_10_analyzer_2_array_crystal_array_8_focus_aw;
MCNUM mccchannel_10_analyzer_2_array_crystal_array_8_focus_ah;
MCNUM mccchannel_10_analyzer_2_array_crystal_array_8_focus_xw;
MCNUM mccchannel_10_analyzer_2_array_crystal_array_8_focus_xh;
MCNUM mccchannel_10_analyzer_2_array_crystal_array_8_focus_r;
MCNUM mccchannel_10_analyzer_2_array_crystal_array_8_p_interact;
char mccchannel_10_analyzer_2_array_crystal_array_8_mask_string[16384];
char mccchannel_10_analyzer_2_array_crystal_array_8_mask_setting[16384];
MCNUM mccchannel_10_analyzer_2_array_crystal_array_8_number_of_activations;

/* Setting parameters for component 'channel_10_cave2_cyl1' [530]. */
char mccchannel_10_cave2_cyl1_material_string[16384];
MCNUM mccchannel_10_cave2_cyl1_priority;
MCNUM mccchannel_10_cave2_cyl1_radius;
MCNUM mccchannel_10_cave2_cyl1_yheight;
MCNUM mccchannel_10_cave2_cyl1_visualize;
int mccchannel_10_cave2_cyl1_target_index;
MCNUM mccchannel_10_cave2_cyl1_target_x;
MCNUM mccchannel_10_cave2_cyl1_target_y;
MCNUM mccchannel_10_cave2_cyl1_target_z;
MCNUM mccchannel_10_cave2_cyl1_focus_aw;
MCNUM mccchannel_10_cave2_cyl1_focus_ah;
MCNUM mccchannel_10_cave2_cyl1_focus_xw;
MCNUM mccchannel_10_cave2_cyl1_focus_xh;
MCNUM mccchannel_10_cave2_cyl1_focus_r;
MCNUM mccchannel_10_cave2_cyl1_p_interact;
char mccchannel_10_cave2_cyl1_mask_string[16384];
char mccchannel_10_cave2_cyl1_mask_setting[16384];
MCNUM mccchannel_10_cave2_cyl1_number_of_activations;

/* Setting parameters for component 'channel_10_cave2_box1' [531]. */
char mccchannel_10_cave2_box1_material_string[16384];
MCNUM mccchannel_10_cave2_box1_priority;
MCNUM mccchannel_10_cave2_box1_xwidth;
MCNUM mccchannel_10_cave2_box1_yheight;
MCNUM mccchannel_10_cave2_box1_zdepth;
MCNUM mccchannel_10_cave2_box1_xwidth2;
MCNUM mccchannel_10_cave2_box1_yheight2;
MCNUM mccchannel_10_cave2_box1_visualize;
int mccchannel_10_cave2_box1_target_index;
MCNUM mccchannel_10_cave2_box1_target_x;
MCNUM mccchannel_10_cave2_box1_target_y;
MCNUM mccchannel_10_cave2_box1_target_z;
MCNUM mccchannel_10_cave2_box1_focus_aw;
MCNUM mccchannel_10_cave2_box1_focus_ah;
MCNUM mccchannel_10_cave2_box1_focus_xw;
MCNUM mccchannel_10_cave2_box1_focus_xh;
MCNUM mccchannel_10_cave2_box1_focus_r;
MCNUM mccchannel_10_cave2_box1_p_interact;
char mccchannel_10_cave2_box1_mask_string[16384];
char mccchannel_10_cave2_box1_mask_setting[16384];
MCNUM mccchannel_10_cave2_box1_number_of_activations;

/* Setting parameters for component 'channel_10_cave2_box2' [532]. */
char mccchannel_10_cave2_box2_material_string[16384];
MCNUM mccchannel_10_cave2_box2_priority;
MCNUM mccchannel_10_cave2_box2_xwidth;
MCNUM mccchannel_10_cave2_box2_yheight;
MCNUM mccchannel_10_cave2_box2_zdepth;
MCNUM mccchannel_10_cave2_box2_xwidth2;
MCNUM mccchannel_10_cave2_box2_yheight2;
MCNUM mccchannel_10_cave2_box2_visualize;
int mccchannel_10_cave2_box2_target_index;
MCNUM mccchannel_10_cave2_box2_target_x;
MCNUM mccchannel_10_cave2_box2_target_y;
MCNUM mccchannel_10_cave2_box2_target_z;
MCNUM mccchannel_10_cave2_box2_focus_aw;
MCNUM mccchannel_10_cave2_box2_focus_ah;
MCNUM mccchannel_10_cave2_box2_focus_xw;
MCNUM mccchannel_10_cave2_box2_focus_xh;
MCNUM mccchannel_10_cave2_box2_focus_r;
MCNUM mccchannel_10_cave2_box2_p_interact;
char mccchannel_10_cave2_box2_mask_string[16384];
char mccchannel_10_cave2_box2_mask_setting[16384];
MCNUM mccchannel_10_cave2_box2_number_of_activations;

/* Setting parameters for component 'channel_10_cave2_box3' [533]. */
char mccchannel_10_cave2_box3_material_string[16384];
MCNUM mccchannel_10_cave2_box3_priority;
MCNUM mccchannel_10_cave2_box3_xwidth;
MCNUM mccchannel_10_cave2_box3_yheight;
MCNUM mccchannel_10_cave2_box3_zdepth;
MCNUM mccchannel_10_cave2_box3_xwidth2;
MCNUM mccchannel_10_cave2_box3_yheight2;
MCNUM mccchannel_10_cave2_box3_visualize;
int mccchannel_10_cave2_box3_target_index;
MCNUM mccchannel_10_cave2_box3_target_x;
MCNUM mccchannel_10_cave2_box3_target_y;
MCNUM mccchannel_10_cave2_box3_target_z;
MCNUM mccchannel_10_cave2_box3_focus_aw;
MCNUM mccchannel_10_cave2_box3_focus_ah;
MCNUM mccchannel_10_cave2_box3_focus_xw;
MCNUM mccchannel_10_cave2_box3_focus_xh;
MCNUM mccchannel_10_cave2_box3_focus_r;
MCNUM mccchannel_10_cave2_box3_p_interact;
char mccchannel_10_cave2_box3_mask_string[16384];
char mccchannel_10_cave2_box3_mask_setting[16384];
MCNUM mccchannel_10_cave2_box3_number_of_activations;

/* Setting parameters for component 'inter_analyzer_colimator_10_blade_0' [535]. */
char mccinter_analyzer_colimator_10_blade_0_material_string[16384];
MCNUM mccinter_analyzer_colimator_10_blade_0_priority;
MCNUM mccinter_analyzer_colimator_10_blade_0_xwidth;
MCNUM mccinter_analyzer_colimator_10_blade_0_yheight;
MCNUM mccinter_analyzer_colimator_10_blade_0_zdepth;
MCNUM mccinter_analyzer_colimator_10_blade_0_xwidth2;
MCNUM mccinter_analyzer_colimator_10_blade_0_yheight2;
MCNUM mccinter_analyzer_colimator_10_blade_0_visualize;
int mccinter_analyzer_colimator_10_blade_0_target_index;
MCNUM mccinter_analyzer_colimator_10_blade_0_target_x;
MCNUM mccinter_analyzer_colimator_10_blade_0_target_y;
MCNUM mccinter_analyzer_colimator_10_blade_0_target_z;
MCNUM mccinter_analyzer_colimator_10_blade_0_focus_aw;
MCNUM mccinter_analyzer_colimator_10_blade_0_focus_ah;
MCNUM mccinter_analyzer_colimator_10_blade_0_focus_xw;
MCNUM mccinter_analyzer_colimator_10_blade_0_focus_xh;
MCNUM mccinter_analyzer_colimator_10_blade_0_focus_r;
MCNUM mccinter_analyzer_colimator_10_blade_0_p_interact;
char mccinter_analyzer_colimator_10_blade_0_mask_string[16384];
char mccinter_analyzer_colimator_10_blade_0_mask_setting[16384];
MCNUM mccinter_analyzer_colimator_10_blade_0_number_of_activations;

/* Setting parameters for component 'inter_analyzer_colimator_10_blade_1' [536]. */
char mccinter_analyzer_colimator_10_blade_1_material_string[16384];
MCNUM mccinter_analyzer_colimator_10_blade_1_priority;
MCNUM mccinter_analyzer_colimator_10_blade_1_xwidth;
MCNUM mccinter_analyzer_colimator_10_blade_1_yheight;
MCNUM mccinter_analyzer_colimator_10_blade_1_zdepth;
MCNUM mccinter_analyzer_colimator_10_blade_1_xwidth2;
MCNUM mccinter_analyzer_colimator_10_blade_1_yheight2;
MCNUM mccinter_analyzer_colimator_10_blade_1_visualize;
int mccinter_analyzer_colimator_10_blade_1_target_index;
MCNUM mccinter_analyzer_colimator_10_blade_1_target_x;
MCNUM mccinter_analyzer_colimator_10_blade_1_target_y;
MCNUM mccinter_analyzer_colimator_10_blade_1_target_z;
MCNUM mccinter_analyzer_colimator_10_blade_1_focus_aw;
MCNUM mccinter_analyzer_colimator_10_blade_1_focus_ah;
MCNUM mccinter_analyzer_colimator_10_blade_1_focus_xw;
MCNUM mccinter_analyzer_colimator_10_blade_1_focus_xh;
MCNUM mccinter_analyzer_colimator_10_blade_1_focus_r;
MCNUM mccinter_analyzer_colimator_10_blade_1_p_interact;
char mccinter_analyzer_colimator_10_blade_1_mask_string[16384];
char mccinter_analyzer_colimator_10_blade_1_mask_setting[16384];
MCNUM mccinter_analyzer_colimator_10_blade_1_number_of_activations;

/* Setting parameters for component 'inter_analyzer_colimator_10_blade_2' [537]. */
char mccinter_analyzer_colimator_10_blade_2_material_string[16384];
MCNUM mccinter_analyzer_colimator_10_blade_2_priority;
MCNUM mccinter_analyzer_colimator_10_blade_2_xwidth;
MCNUM mccinter_analyzer_colimator_10_blade_2_yheight;
MCNUM mccinter_analyzer_colimator_10_blade_2_zdepth;
MCNUM mccinter_analyzer_colimator_10_blade_2_xwidth2;
MCNUM mccinter_analyzer_colimator_10_blade_2_yheight2;
MCNUM mccinter_analyzer_colimator_10_blade_2_visualize;
int mccinter_analyzer_colimator_10_blade_2_target_index;
MCNUM mccinter_analyzer_colimator_10_blade_2_target_x;
MCNUM mccinter_analyzer_colimator_10_blade_2_target_y;
MCNUM mccinter_analyzer_colimator_10_blade_2_target_z;
MCNUM mccinter_analyzer_colimator_10_blade_2_focus_aw;
MCNUM mccinter_analyzer_colimator_10_blade_2_focus_ah;
MCNUM mccinter_analyzer_colimator_10_blade_2_focus_xw;
MCNUM mccinter_analyzer_colimator_10_blade_2_focus_xh;
MCNUM mccinter_analyzer_colimator_10_blade_2_focus_r;
MCNUM mccinter_analyzer_colimator_10_blade_2_p_interact;
char mccinter_analyzer_colimator_10_blade_2_mask_string[16384];
char mccinter_analyzer_colimator_10_blade_2_mask_setting[16384];
MCNUM mccinter_analyzer_colimator_10_blade_2_number_of_activations;

/* Setting parameters for component 'inter_analyzer_colimator_10_blade_3' [538]. */
char mccinter_analyzer_colimator_10_blade_3_material_string[16384];
MCNUM mccinter_analyzer_colimator_10_blade_3_priority;
MCNUM mccinter_analyzer_colimator_10_blade_3_xwidth;
MCNUM mccinter_analyzer_colimator_10_blade_3_yheight;
MCNUM mccinter_analyzer_colimator_10_blade_3_zdepth;
MCNUM mccinter_analyzer_colimator_10_blade_3_xwidth2;
MCNUM mccinter_analyzer_colimator_10_blade_3_yheight2;
MCNUM mccinter_analyzer_colimator_10_blade_3_visualize;
int mccinter_analyzer_colimator_10_blade_3_target_index;
MCNUM mccinter_analyzer_colimator_10_blade_3_target_x;
MCNUM mccinter_analyzer_colimator_10_blade_3_target_y;
MCNUM mccinter_analyzer_colimator_10_blade_3_target_z;
MCNUM mccinter_analyzer_colimator_10_blade_3_focus_aw;
MCNUM mccinter_analyzer_colimator_10_blade_3_focus_ah;
MCNUM mccinter_analyzer_colimator_10_blade_3_focus_xw;
MCNUM mccinter_analyzer_colimator_10_blade_3_focus_xh;
MCNUM mccinter_analyzer_colimator_10_blade_3_focus_r;
MCNUM mccinter_analyzer_colimator_10_blade_3_p_interact;
char mccinter_analyzer_colimator_10_blade_3_mask_string[16384];
char mccinter_analyzer_colimator_10_blade_3_mask_setting[16384];
MCNUM mccinter_analyzer_colimator_10_blade_3_number_of_activations;

/* Setting parameters for component 'inter_analyzer_colimator_10_blade_4' [539]. */
char mccinter_analyzer_colimator_10_blade_4_material_string[16384];
MCNUM mccinter_analyzer_colimator_10_blade_4_priority;
MCNUM mccinter_analyzer_colimator_10_blade_4_xwidth;
MCNUM mccinter_analyzer_colimator_10_blade_4_yheight;
MCNUM mccinter_analyzer_colimator_10_blade_4_zdepth;
MCNUM mccinter_analyzer_colimator_10_blade_4_xwidth2;
MCNUM mccinter_analyzer_colimator_10_blade_4_yheight2;
MCNUM mccinter_analyzer_colimator_10_blade_4_visualize;
int mccinter_analyzer_colimator_10_blade_4_target_index;
MCNUM mccinter_analyzer_colimator_10_blade_4_target_x;
MCNUM mccinter_analyzer_colimator_10_blade_4_target_y;
MCNUM mccinter_analyzer_colimator_10_blade_4_target_z;
MCNUM mccinter_analyzer_colimator_10_blade_4_focus_aw;
MCNUM mccinter_analyzer_colimator_10_blade_4_focus_ah;
MCNUM mccinter_analyzer_colimator_10_blade_4_focus_xw;
MCNUM mccinter_analyzer_colimator_10_blade_4_focus_xh;
MCNUM mccinter_analyzer_colimator_10_blade_4_focus_r;
MCNUM mccinter_analyzer_colimator_10_blade_4_p_interact;
char mccinter_analyzer_colimator_10_blade_4_mask_string[16384];
char mccinter_analyzer_colimator_10_blade_4_mask_setting[16384];
MCNUM mccinter_analyzer_colimator_10_blade_4_number_of_activations;

/* Setting parameters for component 'diffraction_detector_10_exit_volume' [540]. */
char mccdiffraction_detector_10_exit_volume_material_string[16384];
MCNUM mccdiffraction_detector_10_exit_volume_priority;
MCNUM mccdiffraction_detector_10_exit_volume_xwidth;
MCNUM mccdiffraction_detector_10_exit_volume_yheight;
MCNUM mccdiffraction_detector_10_exit_volume_zdepth;
MCNUM mccdiffraction_detector_10_exit_volume_xwidth2;
MCNUM mccdiffraction_detector_10_exit_volume_yheight2;
MCNUM mccdiffraction_detector_10_exit_volume_visualize;
int mccdiffraction_detector_10_exit_volume_target_index;
MCNUM mccdiffraction_detector_10_exit_volume_target_x;
MCNUM mccdiffraction_detector_10_exit_volume_target_y;
MCNUM mccdiffraction_detector_10_exit_volume_target_z;
MCNUM mccdiffraction_detector_10_exit_volume_focus_aw;
MCNUM mccdiffraction_detector_10_exit_volume_focus_ah;
MCNUM mccdiffraction_detector_10_exit_volume_focus_xw;
MCNUM mccdiffraction_detector_10_exit_volume_focus_xh;
MCNUM mccdiffraction_detector_10_exit_volume_focus_r;
MCNUM mccdiffraction_detector_10_exit_volume_p_interact;
char mccdiffraction_detector_10_exit_volume_mask_string[16384];
char mccdiffraction_detector_10_exit_volume_mask_setting[16384];
MCNUM mccdiffraction_detector_10_exit_volume_number_of_activations;

/* Setting parameters for component 'spec_detector_10_exit_volume' [541]. */
char mccspec_detector_10_exit_volume_material_string[16384];
MCNUM mccspec_detector_10_exit_volume_priority;
MCNUM mccspec_detector_10_exit_volume_xwidth;
MCNUM mccspec_detector_10_exit_volume_yheight;
MCNUM mccspec_detector_10_exit_volume_zdepth;
MCNUM mccspec_detector_10_exit_volume_xwidth2;
MCNUM mccspec_detector_10_exit_volume_yheight2;
MCNUM mccspec_detector_10_exit_volume_visualize;
int mccspec_detector_10_exit_volume_target_index;
MCNUM mccspec_detector_10_exit_volume_target_x;
MCNUM mccspec_detector_10_exit_volume_target_y;
MCNUM mccspec_detector_10_exit_volume_target_z;
MCNUM mccspec_detector_10_exit_volume_focus_aw;
MCNUM mccspec_detector_10_exit_volume_focus_ah;
MCNUM mccspec_detector_10_exit_volume_focus_xw;
MCNUM mccspec_detector_10_exit_volume_focus_xh;
MCNUM mccspec_detector_10_exit_volume_focus_r;
MCNUM mccspec_detector_10_exit_volume_p_interact;
char mccspec_detector_10_exit_volume_mask_string[16384];
char mccspec_detector_10_exit_volume_mask_setting[16384];
MCNUM mccspec_detector_10_exit_volume_number_of_activations;

/* Setting parameters for component 'channel_11_cave1_box1' [542]. */
char mccchannel_11_cave1_box1_material_string[16384];
MCNUM mccchannel_11_cave1_box1_priority;
MCNUM mccchannel_11_cave1_box1_xwidth;
MCNUM mccchannel_11_cave1_box1_yheight;
MCNUM mccchannel_11_cave1_box1_zdepth;
MCNUM mccchannel_11_cave1_box1_xwidth2;
MCNUM mccchannel_11_cave1_box1_yheight2;
MCNUM mccchannel_11_cave1_box1_visualize;
int mccchannel_11_cave1_box1_target_index;
MCNUM mccchannel_11_cave1_box1_target_x;
MCNUM mccchannel_11_cave1_box1_target_y;
MCNUM mccchannel_11_cave1_box1_target_z;
MCNUM mccchannel_11_cave1_box1_focus_aw;
MCNUM mccchannel_11_cave1_box1_focus_ah;
MCNUM mccchannel_11_cave1_box1_focus_xw;
MCNUM mccchannel_11_cave1_box1_focus_xh;
MCNUM mccchannel_11_cave1_box1_focus_r;
MCNUM mccchannel_11_cave1_box1_p_interact;
char mccchannel_11_cave1_box1_mask_string[16384];
char mccchannel_11_cave1_box1_mask_setting[16384];
MCNUM mccchannel_11_cave1_box1_number_of_activations;

/* Setting parameters for component 'channel_11_cave1_box2' [543]. */
char mccchannel_11_cave1_box2_material_string[16384];
MCNUM mccchannel_11_cave1_box2_priority;
MCNUM mccchannel_11_cave1_box2_xwidth;
MCNUM mccchannel_11_cave1_box2_yheight;
MCNUM mccchannel_11_cave1_box2_zdepth;
MCNUM mccchannel_11_cave1_box2_xwidth2;
MCNUM mccchannel_11_cave1_box2_yheight2;
MCNUM mccchannel_11_cave1_box2_visualize;
int mccchannel_11_cave1_box2_target_index;
MCNUM mccchannel_11_cave1_box2_target_x;
MCNUM mccchannel_11_cave1_box2_target_y;
MCNUM mccchannel_11_cave1_box2_target_z;
MCNUM mccchannel_11_cave1_box2_focus_aw;
MCNUM mccchannel_11_cave1_box2_focus_ah;
MCNUM mccchannel_11_cave1_box2_focus_xw;
MCNUM mccchannel_11_cave1_box2_focus_xh;
MCNUM mccchannel_11_cave1_box2_focus_r;
MCNUM mccchannel_11_cave1_box2_p_interact;
char mccchannel_11_cave1_box2_mask_string[16384];
char mccchannel_11_cave1_box2_mask_setting[16384];
MCNUM mccchannel_11_cave1_box2_number_of_activations;

/* Setting parameters for component 'channel_11_cave1_box3' [544]. */
char mccchannel_11_cave1_box3_material_string[16384];
MCNUM mccchannel_11_cave1_box3_priority;
MCNUM mccchannel_11_cave1_box3_xwidth;
MCNUM mccchannel_11_cave1_box3_yheight;
MCNUM mccchannel_11_cave1_box3_zdepth;
MCNUM mccchannel_11_cave1_box3_xwidth2;
MCNUM mccchannel_11_cave1_box3_yheight2;
MCNUM mccchannel_11_cave1_box3_visualize;
int mccchannel_11_cave1_box3_target_index;
MCNUM mccchannel_11_cave1_box3_target_x;
MCNUM mccchannel_11_cave1_box3_target_y;
MCNUM mccchannel_11_cave1_box3_target_z;
MCNUM mccchannel_11_cave1_box3_focus_aw;
MCNUM mccchannel_11_cave1_box3_focus_ah;
MCNUM mccchannel_11_cave1_box3_focus_xw;
MCNUM mccchannel_11_cave1_box3_focus_xh;
MCNUM mccchannel_11_cave1_box3_focus_r;
MCNUM mccchannel_11_cave1_box3_p_interact;
char mccchannel_11_cave1_box3_mask_string[16384];
char mccchannel_11_cave1_box3_mask_setting[16384];
MCNUM mccchannel_11_cave1_box3_number_of_activations;

/* Setting parameters for component 'channel_11_cave1_cyl1' [545]. */
char mccchannel_11_cave1_cyl1_material_string[16384];
MCNUM mccchannel_11_cave1_cyl1_priority;
MCNUM mccchannel_11_cave1_cyl1_radius;
MCNUM mccchannel_11_cave1_cyl1_yheight;
MCNUM mccchannel_11_cave1_cyl1_visualize;
int mccchannel_11_cave1_cyl1_target_index;
MCNUM mccchannel_11_cave1_cyl1_target_x;
MCNUM mccchannel_11_cave1_cyl1_target_y;
MCNUM mccchannel_11_cave1_cyl1_target_z;
MCNUM mccchannel_11_cave1_cyl1_focus_aw;
MCNUM mccchannel_11_cave1_cyl1_focus_ah;
MCNUM mccchannel_11_cave1_cyl1_focus_xw;
MCNUM mccchannel_11_cave1_cyl1_focus_xh;
MCNUM mccchannel_11_cave1_cyl1_focus_r;
MCNUM mccchannel_11_cave1_cyl1_p_interact;
char mccchannel_11_cave1_cyl1_mask_string[16384];
char mccchannel_11_cave1_cyl1_mask_setting[16384];
MCNUM mccchannel_11_cave1_cyl1_number_of_activations;

/* Setting parameters for component 'channel_11_analyzer_1_array_crystal_array_0' [548]. */
char mccchannel_11_analyzer_1_array_crystal_array_0_material_string[16384];
MCNUM mccchannel_11_analyzer_1_array_crystal_array_0_priority;
MCNUM mccchannel_11_analyzer_1_array_crystal_array_0_xwidth;
MCNUM mccchannel_11_analyzer_1_array_crystal_array_0_yheight;
MCNUM mccchannel_11_analyzer_1_array_crystal_array_0_zdepth;
MCNUM mccchannel_11_analyzer_1_array_crystal_array_0_xwidth2;
MCNUM mccchannel_11_analyzer_1_array_crystal_array_0_yheight2;
MCNUM mccchannel_11_analyzer_1_array_crystal_array_0_visualize;
int mccchannel_11_analyzer_1_array_crystal_array_0_target_index;
MCNUM mccchannel_11_analyzer_1_array_crystal_array_0_target_x;
MCNUM mccchannel_11_analyzer_1_array_crystal_array_0_target_y;
MCNUM mccchannel_11_analyzer_1_array_crystal_array_0_target_z;
MCNUM mccchannel_11_analyzer_1_array_crystal_array_0_focus_aw;
MCNUM mccchannel_11_analyzer_1_array_crystal_array_0_focus_ah;
MCNUM mccchannel_11_analyzer_1_array_crystal_array_0_focus_xw;
MCNUM mccchannel_11_analyzer_1_array_crystal_array_0_focus_xh;
MCNUM mccchannel_11_analyzer_1_array_crystal_array_0_focus_r;
MCNUM mccchannel_11_analyzer_1_array_crystal_array_0_p_interact;
char mccchannel_11_analyzer_1_array_crystal_array_0_mask_string[16384];
char mccchannel_11_analyzer_1_array_crystal_array_0_mask_setting[16384];
MCNUM mccchannel_11_analyzer_1_array_crystal_array_0_number_of_activations;

/* Setting parameters for component 'channel_11_analyzer_1_array_crystal_array_1' [549]. */
char mccchannel_11_analyzer_1_array_crystal_array_1_material_string[16384];
MCNUM mccchannel_11_analyzer_1_array_crystal_array_1_priority;
MCNUM mccchannel_11_analyzer_1_array_crystal_array_1_xwidth;
MCNUM mccchannel_11_analyzer_1_array_crystal_array_1_yheight;
MCNUM mccchannel_11_analyzer_1_array_crystal_array_1_zdepth;
MCNUM mccchannel_11_analyzer_1_array_crystal_array_1_xwidth2;
MCNUM mccchannel_11_analyzer_1_array_crystal_array_1_yheight2;
MCNUM mccchannel_11_analyzer_1_array_crystal_array_1_visualize;
int mccchannel_11_analyzer_1_array_crystal_array_1_target_index;
MCNUM mccchannel_11_analyzer_1_array_crystal_array_1_target_x;
MCNUM mccchannel_11_analyzer_1_array_crystal_array_1_target_y;
MCNUM mccchannel_11_analyzer_1_array_crystal_array_1_target_z;
MCNUM mccchannel_11_analyzer_1_array_crystal_array_1_focus_aw;
MCNUM mccchannel_11_analyzer_1_array_crystal_array_1_focus_ah;
MCNUM mccchannel_11_analyzer_1_array_crystal_array_1_focus_xw;
MCNUM mccchannel_11_analyzer_1_array_crystal_array_1_focus_xh;
MCNUM mccchannel_11_analyzer_1_array_crystal_array_1_focus_r;
MCNUM mccchannel_11_analyzer_1_array_crystal_array_1_p_interact;
char mccchannel_11_analyzer_1_array_crystal_array_1_mask_string[16384];
char mccchannel_11_analyzer_1_array_crystal_array_1_mask_setting[16384];
MCNUM mccchannel_11_analyzer_1_array_crystal_array_1_number_of_activations;

/* Setting parameters for component 'channel_11_analyzer_1_array_crystal_array_2' [550]. */
char mccchannel_11_analyzer_1_array_crystal_array_2_material_string[16384];
MCNUM mccchannel_11_analyzer_1_array_crystal_array_2_priority;
MCNUM mccchannel_11_analyzer_1_array_crystal_array_2_xwidth;
MCNUM mccchannel_11_analyzer_1_array_crystal_array_2_yheight;
MCNUM mccchannel_11_analyzer_1_array_crystal_array_2_zdepth;
MCNUM mccchannel_11_analyzer_1_array_crystal_array_2_xwidth2;
MCNUM mccchannel_11_analyzer_1_array_crystal_array_2_yheight2;
MCNUM mccchannel_11_analyzer_1_array_crystal_array_2_visualize;
int mccchannel_11_analyzer_1_array_crystal_array_2_target_index;
MCNUM mccchannel_11_analyzer_1_array_crystal_array_2_target_x;
MCNUM mccchannel_11_analyzer_1_array_crystal_array_2_target_y;
MCNUM mccchannel_11_analyzer_1_array_crystal_array_2_target_z;
MCNUM mccchannel_11_analyzer_1_array_crystal_array_2_focus_aw;
MCNUM mccchannel_11_analyzer_1_array_crystal_array_2_focus_ah;
MCNUM mccchannel_11_analyzer_1_array_crystal_array_2_focus_xw;
MCNUM mccchannel_11_analyzer_1_array_crystal_array_2_focus_xh;
MCNUM mccchannel_11_analyzer_1_array_crystal_array_2_focus_r;
MCNUM mccchannel_11_analyzer_1_array_crystal_array_2_p_interact;
char mccchannel_11_analyzer_1_array_crystal_array_2_mask_string[16384];
char mccchannel_11_analyzer_1_array_crystal_array_2_mask_setting[16384];
MCNUM mccchannel_11_analyzer_1_array_crystal_array_2_number_of_activations;

/* Setting parameters for component 'channel_11_analyzer_1_array_crystal_array_3' [551]. */
char mccchannel_11_analyzer_1_array_crystal_array_3_material_string[16384];
MCNUM mccchannel_11_analyzer_1_array_crystal_array_3_priority;
MCNUM mccchannel_11_analyzer_1_array_crystal_array_3_xwidth;
MCNUM mccchannel_11_analyzer_1_array_crystal_array_3_yheight;
MCNUM mccchannel_11_analyzer_1_array_crystal_array_3_zdepth;
MCNUM mccchannel_11_analyzer_1_array_crystal_array_3_xwidth2;
MCNUM mccchannel_11_analyzer_1_array_crystal_array_3_yheight2;
MCNUM mccchannel_11_analyzer_1_array_crystal_array_3_visualize;
int mccchannel_11_analyzer_1_array_crystal_array_3_target_index;
MCNUM mccchannel_11_analyzer_1_array_crystal_array_3_target_x;
MCNUM mccchannel_11_analyzer_1_array_crystal_array_3_target_y;
MCNUM mccchannel_11_analyzer_1_array_crystal_array_3_target_z;
MCNUM mccchannel_11_analyzer_1_array_crystal_array_3_focus_aw;
MCNUM mccchannel_11_analyzer_1_array_crystal_array_3_focus_ah;
MCNUM mccchannel_11_analyzer_1_array_crystal_array_3_focus_xw;
MCNUM mccchannel_11_analyzer_1_array_crystal_array_3_focus_xh;
MCNUM mccchannel_11_analyzer_1_array_crystal_array_3_focus_r;
MCNUM mccchannel_11_analyzer_1_array_crystal_array_3_p_interact;
char mccchannel_11_analyzer_1_array_crystal_array_3_mask_string[16384];
char mccchannel_11_analyzer_1_array_crystal_array_3_mask_setting[16384];
MCNUM mccchannel_11_analyzer_1_array_crystal_array_3_number_of_activations;

/* Setting parameters for component 'channel_11_analyzer_1_array_crystal_array_4' [552]. */
char mccchannel_11_analyzer_1_array_crystal_array_4_material_string[16384];
MCNUM mccchannel_11_analyzer_1_array_crystal_array_4_priority;
MCNUM mccchannel_11_analyzer_1_array_crystal_array_4_xwidth;
MCNUM mccchannel_11_analyzer_1_array_crystal_array_4_yheight;
MCNUM mccchannel_11_analyzer_1_array_crystal_array_4_zdepth;
MCNUM mccchannel_11_analyzer_1_array_crystal_array_4_xwidth2;
MCNUM mccchannel_11_analyzer_1_array_crystal_array_4_yheight2;
MCNUM mccchannel_11_analyzer_1_array_crystal_array_4_visualize;
int mccchannel_11_analyzer_1_array_crystal_array_4_target_index;
MCNUM mccchannel_11_analyzer_1_array_crystal_array_4_target_x;
MCNUM mccchannel_11_analyzer_1_array_crystal_array_4_target_y;
MCNUM mccchannel_11_analyzer_1_array_crystal_array_4_target_z;
MCNUM mccchannel_11_analyzer_1_array_crystal_array_4_focus_aw;
MCNUM mccchannel_11_analyzer_1_array_crystal_array_4_focus_ah;
MCNUM mccchannel_11_analyzer_1_array_crystal_array_4_focus_xw;
MCNUM mccchannel_11_analyzer_1_array_crystal_array_4_focus_xh;
MCNUM mccchannel_11_analyzer_1_array_crystal_array_4_focus_r;
MCNUM mccchannel_11_analyzer_1_array_crystal_array_4_p_interact;
char mccchannel_11_analyzer_1_array_crystal_array_4_mask_string[16384];
char mccchannel_11_analyzer_1_array_crystal_array_4_mask_setting[16384];
MCNUM mccchannel_11_analyzer_1_array_crystal_array_4_number_of_activations;

/* Setting parameters for component 'channel_11_analyzer_1_array_crystal_array_5' [553]. */
char mccchannel_11_analyzer_1_array_crystal_array_5_material_string[16384];
MCNUM mccchannel_11_analyzer_1_array_crystal_array_5_priority;
MCNUM mccchannel_11_analyzer_1_array_crystal_array_5_xwidth;
MCNUM mccchannel_11_analyzer_1_array_crystal_array_5_yheight;
MCNUM mccchannel_11_analyzer_1_array_crystal_array_5_zdepth;
MCNUM mccchannel_11_analyzer_1_array_crystal_array_5_xwidth2;
MCNUM mccchannel_11_analyzer_1_array_crystal_array_5_yheight2;
MCNUM mccchannel_11_analyzer_1_array_crystal_array_5_visualize;
int mccchannel_11_analyzer_1_array_crystal_array_5_target_index;
MCNUM mccchannel_11_analyzer_1_array_crystal_array_5_target_x;
MCNUM mccchannel_11_analyzer_1_array_crystal_array_5_target_y;
MCNUM mccchannel_11_analyzer_1_array_crystal_array_5_target_z;
MCNUM mccchannel_11_analyzer_1_array_crystal_array_5_focus_aw;
MCNUM mccchannel_11_analyzer_1_array_crystal_array_5_focus_ah;
MCNUM mccchannel_11_analyzer_1_array_crystal_array_5_focus_xw;
MCNUM mccchannel_11_analyzer_1_array_crystal_array_5_focus_xh;
MCNUM mccchannel_11_analyzer_1_array_crystal_array_5_focus_r;
MCNUM mccchannel_11_analyzer_1_array_crystal_array_5_p_interact;
char mccchannel_11_analyzer_1_array_crystal_array_5_mask_string[16384];
char mccchannel_11_analyzer_1_array_crystal_array_5_mask_setting[16384];
MCNUM mccchannel_11_analyzer_1_array_crystal_array_5_number_of_activations;

/* Setting parameters for component 'channel_11_analyzer_1_array_crystal_array_6' [554]. */
char mccchannel_11_analyzer_1_array_crystal_array_6_material_string[16384];
MCNUM mccchannel_11_analyzer_1_array_crystal_array_6_priority;
MCNUM mccchannel_11_analyzer_1_array_crystal_array_6_xwidth;
MCNUM mccchannel_11_analyzer_1_array_crystal_array_6_yheight;
MCNUM mccchannel_11_analyzer_1_array_crystal_array_6_zdepth;
MCNUM mccchannel_11_analyzer_1_array_crystal_array_6_xwidth2;
MCNUM mccchannel_11_analyzer_1_array_crystal_array_6_yheight2;
MCNUM mccchannel_11_analyzer_1_array_crystal_array_6_visualize;
int mccchannel_11_analyzer_1_array_crystal_array_6_target_index;
MCNUM mccchannel_11_analyzer_1_array_crystal_array_6_target_x;
MCNUM mccchannel_11_analyzer_1_array_crystal_array_6_target_y;
MCNUM mccchannel_11_analyzer_1_array_crystal_array_6_target_z;
MCNUM mccchannel_11_analyzer_1_array_crystal_array_6_focus_aw;
MCNUM mccchannel_11_analyzer_1_array_crystal_array_6_focus_ah;
MCNUM mccchannel_11_analyzer_1_array_crystal_array_6_focus_xw;
MCNUM mccchannel_11_analyzer_1_array_crystal_array_6_focus_xh;
MCNUM mccchannel_11_analyzer_1_array_crystal_array_6_focus_r;
MCNUM mccchannel_11_analyzer_1_array_crystal_array_6_p_interact;
char mccchannel_11_analyzer_1_array_crystal_array_6_mask_string[16384];
char mccchannel_11_analyzer_1_array_crystal_array_6_mask_setting[16384];
MCNUM mccchannel_11_analyzer_1_array_crystal_array_6_number_of_activations;

/* Setting parameters for component 'channel_11_analyzer_1_array_crystal_array_7' [555]. */
char mccchannel_11_analyzer_1_array_crystal_array_7_material_string[16384];
MCNUM mccchannel_11_analyzer_1_array_crystal_array_7_priority;
MCNUM mccchannel_11_analyzer_1_array_crystal_array_7_xwidth;
MCNUM mccchannel_11_analyzer_1_array_crystal_array_7_yheight;
MCNUM mccchannel_11_analyzer_1_array_crystal_array_7_zdepth;
MCNUM mccchannel_11_analyzer_1_array_crystal_array_7_xwidth2;
MCNUM mccchannel_11_analyzer_1_array_crystal_array_7_yheight2;
MCNUM mccchannel_11_analyzer_1_array_crystal_array_7_visualize;
int mccchannel_11_analyzer_1_array_crystal_array_7_target_index;
MCNUM mccchannel_11_analyzer_1_array_crystal_array_7_target_x;
MCNUM mccchannel_11_analyzer_1_array_crystal_array_7_target_y;
MCNUM mccchannel_11_analyzer_1_array_crystal_array_7_target_z;
MCNUM mccchannel_11_analyzer_1_array_crystal_array_7_focus_aw;
MCNUM mccchannel_11_analyzer_1_array_crystal_array_7_focus_ah;
MCNUM mccchannel_11_analyzer_1_array_crystal_array_7_focus_xw;
MCNUM mccchannel_11_analyzer_1_array_crystal_array_7_focus_xh;
MCNUM mccchannel_11_analyzer_1_array_crystal_array_7_focus_r;
MCNUM mccchannel_11_analyzer_1_array_crystal_array_7_p_interact;
char mccchannel_11_analyzer_1_array_crystal_array_7_mask_string[16384];
char mccchannel_11_analyzer_1_array_crystal_array_7_mask_setting[16384];
MCNUM mccchannel_11_analyzer_1_array_crystal_array_7_number_of_activations;

/* Setting parameters for component 'channel_11_analyzer_1_array_crystal_array_8' [556]. */
char mccchannel_11_analyzer_1_array_crystal_array_8_material_string[16384];
MCNUM mccchannel_11_analyzer_1_array_crystal_array_8_priority;
MCNUM mccchannel_11_analyzer_1_array_crystal_array_8_xwidth;
MCNUM mccchannel_11_analyzer_1_array_crystal_array_8_yheight;
MCNUM mccchannel_11_analyzer_1_array_crystal_array_8_zdepth;
MCNUM mccchannel_11_analyzer_1_array_crystal_array_8_xwidth2;
MCNUM mccchannel_11_analyzer_1_array_crystal_array_8_yheight2;
MCNUM mccchannel_11_analyzer_1_array_crystal_array_8_visualize;
int mccchannel_11_analyzer_1_array_crystal_array_8_target_index;
MCNUM mccchannel_11_analyzer_1_array_crystal_array_8_target_x;
MCNUM mccchannel_11_analyzer_1_array_crystal_array_8_target_y;
MCNUM mccchannel_11_analyzer_1_array_crystal_array_8_target_z;
MCNUM mccchannel_11_analyzer_1_array_crystal_array_8_focus_aw;
MCNUM mccchannel_11_analyzer_1_array_crystal_array_8_focus_ah;
MCNUM mccchannel_11_analyzer_1_array_crystal_array_8_focus_xw;
MCNUM mccchannel_11_analyzer_1_array_crystal_array_8_focus_xh;
MCNUM mccchannel_11_analyzer_1_array_crystal_array_8_focus_r;
MCNUM mccchannel_11_analyzer_1_array_crystal_array_8_p_interact;
char mccchannel_11_analyzer_1_array_crystal_array_8_mask_string[16384];
char mccchannel_11_analyzer_1_array_crystal_array_8_mask_setting[16384];
MCNUM mccchannel_11_analyzer_1_array_crystal_array_8_number_of_activations;

/* Setting parameters for component 'channel_11_analyzer_2_array_crystal_array_0' [559]. */
char mccchannel_11_analyzer_2_array_crystal_array_0_material_string[16384];
MCNUM mccchannel_11_analyzer_2_array_crystal_array_0_priority;
MCNUM mccchannel_11_analyzer_2_array_crystal_array_0_xwidth;
MCNUM mccchannel_11_analyzer_2_array_crystal_array_0_yheight;
MCNUM mccchannel_11_analyzer_2_array_crystal_array_0_zdepth;
MCNUM mccchannel_11_analyzer_2_array_crystal_array_0_xwidth2;
MCNUM mccchannel_11_analyzer_2_array_crystal_array_0_yheight2;
MCNUM mccchannel_11_analyzer_2_array_crystal_array_0_visualize;
int mccchannel_11_analyzer_2_array_crystal_array_0_target_index;
MCNUM mccchannel_11_analyzer_2_array_crystal_array_0_target_x;
MCNUM mccchannel_11_analyzer_2_array_crystal_array_0_target_y;
MCNUM mccchannel_11_analyzer_2_array_crystal_array_0_target_z;
MCNUM mccchannel_11_analyzer_2_array_crystal_array_0_focus_aw;
MCNUM mccchannel_11_analyzer_2_array_crystal_array_0_focus_ah;
MCNUM mccchannel_11_analyzer_2_array_crystal_array_0_focus_xw;
MCNUM mccchannel_11_analyzer_2_array_crystal_array_0_focus_xh;
MCNUM mccchannel_11_analyzer_2_array_crystal_array_0_focus_r;
MCNUM mccchannel_11_analyzer_2_array_crystal_array_0_p_interact;
char mccchannel_11_analyzer_2_array_crystal_array_0_mask_string[16384];
char mccchannel_11_analyzer_2_array_crystal_array_0_mask_setting[16384];
MCNUM mccchannel_11_analyzer_2_array_crystal_array_0_number_of_activations;

/* Setting parameters for component 'channel_11_analyzer_2_array_crystal_array_1' [560]. */
char mccchannel_11_analyzer_2_array_crystal_array_1_material_string[16384];
MCNUM mccchannel_11_analyzer_2_array_crystal_array_1_priority;
MCNUM mccchannel_11_analyzer_2_array_crystal_array_1_xwidth;
MCNUM mccchannel_11_analyzer_2_array_crystal_array_1_yheight;
MCNUM mccchannel_11_analyzer_2_array_crystal_array_1_zdepth;
MCNUM mccchannel_11_analyzer_2_array_crystal_array_1_xwidth2;
MCNUM mccchannel_11_analyzer_2_array_crystal_array_1_yheight2;
MCNUM mccchannel_11_analyzer_2_array_crystal_array_1_visualize;
int mccchannel_11_analyzer_2_array_crystal_array_1_target_index;
MCNUM mccchannel_11_analyzer_2_array_crystal_array_1_target_x;
MCNUM mccchannel_11_analyzer_2_array_crystal_array_1_target_y;
MCNUM mccchannel_11_analyzer_2_array_crystal_array_1_target_z;
MCNUM mccchannel_11_analyzer_2_array_crystal_array_1_focus_aw;
MCNUM mccchannel_11_analyzer_2_array_crystal_array_1_focus_ah;
MCNUM mccchannel_11_analyzer_2_array_crystal_array_1_focus_xw;
MCNUM mccchannel_11_analyzer_2_array_crystal_array_1_focus_xh;
MCNUM mccchannel_11_analyzer_2_array_crystal_array_1_focus_r;
MCNUM mccchannel_11_analyzer_2_array_crystal_array_1_p_interact;
char mccchannel_11_analyzer_2_array_crystal_array_1_mask_string[16384];
char mccchannel_11_analyzer_2_array_crystal_array_1_mask_setting[16384];
MCNUM mccchannel_11_analyzer_2_array_crystal_array_1_number_of_activations;

/* Setting parameters for component 'channel_11_analyzer_2_array_crystal_array_2' [561]. */
char mccchannel_11_analyzer_2_array_crystal_array_2_material_string[16384];
MCNUM mccchannel_11_analyzer_2_array_crystal_array_2_priority;
MCNUM mccchannel_11_analyzer_2_array_crystal_array_2_xwidth;
MCNUM mccchannel_11_analyzer_2_array_crystal_array_2_yheight;
MCNUM mccchannel_11_analyzer_2_array_crystal_array_2_zdepth;
MCNUM mccchannel_11_analyzer_2_array_crystal_array_2_xwidth2;
MCNUM mccchannel_11_analyzer_2_array_crystal_array_2_yheight2;
MCNUM mccchannel_11_analyzer_2_array_crystal_array_2_visualize;
int mccchannel_11_analyzer_2_array_crystal_array_2_target_index;
MCNUM mccchannel_11_analyzer_2_array_crystal_array_2_target_x;
MCNUM mccchannel_11_analyzer_2_array_crystal_array_2_target_y;
MCNUM mccchannel_11_analyzer_2_array_crystal_array_2_target_z;
MCNUM mccchannel_11_analyzer_2_array_crystal_array_2_focus_aw;
MCNUM mccchannel_11_analyzer_2_array_crystal_array_2_focus_ah;
MCNUM mccchannel_11_analyzer_2_array_crystal_array_2_focus_xw;
MCNUM mccchannel_11_analyzer_2_array_crystal_array_2_focus_xh;
MCNUM mccchannel_11_analyzer_2_array_crystal_array_2_focus_r;
MCNUM mccchannel_11_analyzer_2_array_crystal_array_2_p_interact;
char mccchannel_11_analyzer_2_array_crystal_array_2_mask_string[16384];
char mccchannel_11_analyzer_2_array_crystal_array_2_mask_setting[16384];
MCNUM mccchannel_11_analyzer_2_array_crystal_array_2_number_of_activations;

/* Setting parameters for component 'channel_11_analyzer_2_array_crystal_array_3' [562]. */
char mccchannel_11_analyzer_2_array_crystal_array_3_material_string[16384];
MCNUM mccchannel_11_analyzer_2_array_crystal_array_3_priority;
MCNUM mccchannel_11_analyzer_2_array_crystal_array_3_xwidth;
MCNUM mccchannel_11_analyzer_2_array_crystal_array_3_yheight;
MCNUM mccchannel_11_analyzer_2_array_crystal_array_3_zdepth;
MCNUM mccchannel_11_analyzer_2_array_crystal_array_3_xwidth2;
MCNUM mccchannel_11_analyzer_2_array_crystal_array_3_yheight2;
MCNUM mccchannel_11_analyzer_2_array_crystal_array_3_visualize;
int mccchannel_11_analyzer_2_array_crystal_array_3_target_index;
MCNUM mccchannel_11_analyzer_2_array_crystal_array_3_target_x;
MCNUM mccchannel_11_analyzer_2_array_crystal_array_3_target_y;
MCNUM mccchannel_11_analyzer_2_array_crystal_array_3_target_z;
MCNUM mccchannel_11_analyzer_2_array_crystal_array_3_focus_aw;
MCNUM mccchannel_11_analyzer_2_array_crystal_array_3_focus_ah;
MCNUM mccchannel_11_analyzer_2_array_crystal_array_3_focus_xw;
MCNUM mccchannel_11_analyzer_2_array_crystal_array_3_focus_xh;
MCNUM mccchannel_11_analyzer_2_array_crystal_array_3_focus_r;
MCNUM mccchannel_11_analyzer_2_array_crystal_array_3_p_interact;
char mccchannel_11_analyzer_2_array_crystal_array_3_mask_string[16384];
char mccchannel_11_analyzer_2_array_crystal_array_3_mask_setting[16384];
MCNUM mccchannel_11_analyzer_2_array_crystal_array_3_number_of_activations;

/* Setting parameters for component 'channel_11_analyzer_2_array_crystal_array_4' [563]. */
char mccchannel_11_analyzer_2_array_crystal_array_4_material_string[16384];
MCNUM mccchannel_11_analyzer_2_array_crystal_array_4_priority;
MCNUM mccchannel_11_analyzer_2_array_crystal_array_4_xwidth;
MCNUM mccchannel_11_analyzer_2_array_crystal_array_4_yheight;
MCNUM mccchannel_11_analyzer_2_array_crystal_array_4_zdepth;
MCNUM mccchannel_11_analyzer_2_array_crystal_array_4_xwidth2;
MCNUM mccchannel_11_analyzer_2_array_crystal_array_4_yheight2;
MCNUM mccchannel_11_analyzer_2_array_crystal_array_4_visualize;
int mccchannel_11_analyzer_2_array_crystal_array_4_target_index;
MCNUM mccchannel_11_analyzer_2_array_crystal_array_4_target_x;
MCNUM mccchannel_11_analyzer_2_array_crystal_array_4_target_y;
MCNUM mccchannel_11_analyzer_2_array_crystal_array_4_target_z;
MCNUM mccchannel_11_analyzer_2_array_crystal_array_4_focus_aw;
MCNUM mccchannel_11_analyzer_2_array_crystal_array_4_focus_ah;
MCNUM mccchannel_11_analyzer_2_array_crystal_array_4_focus_xw;
MCNUM mccchannel_11_analyzer_2_array_crystal_array_4_focus_xh;
MCNUM mccchannel_11_analyzer_2_array_crystal_array_4_focus_r;
MCNUM mccchannel_11_analyzer_2_array_crystal_array_4_p_interact;
char mccchannel_11_analyzer_2_array_crystal_array_4_mask_string[16384];
char mccchannel_11_analyzer_2_array_crystal_array_4_mask_setting[16384];
MCNUM mccchannel_11_analyzer_2_array_crystal_array_4_number_of_activations;

/* Setting parameters for component 'channel_11_analyzer_2_array_crystal_array_5' [564]. */
char mccchannel_11_analyzer_2_array_crystal_array_5_material_string[16384];
MCNUM mccchannel_11_analyzer_2_array_crystal_array_5_priority;
MCNUM mccchannel_11_analyzer_2_array_crystal_array_5_xwidth;
MCNUM mccchannel_11_analyzer_2_array_crystal_array_5_yheight;
MCNUM mccchannel_11_analyzer_2_array_crystal_array_5_zdepth;
MCNUM mccchannel_11_analyzer_2_array_crystal_array_5_xwidth2;
MCNUM mccchannel_11_analyzer_2_array_crystal_array_5_yheight2;
MCNUM mccchannel_11_analyzer_2_array_crystal_array_5_visualize;
int mccchannel_11_analyzer_2_array_crystal_array_5_target_index;
MCNUM mccchannel_11_analyzer_2_array_crystal_array_5_target_x;
MCNUM mccchannel_11_analyzer_2_array_crystal_array_5_target_y;
MCNUM mccchannel_11_analyzer_2_array_crystal_array_5_target_z;
MCNUM mccchannel_11_analyzer_2_array_crystal_array_5_focus_aw;
MCNUM mccchannel_11_analyzer_2_array_crystal_array_5_focus_ah;
MCNUM mccchannel_11_analyzer_2_array_crystal_array_5_focus_xw;
MCNUM mccchannel_11_analyzer_2_array_crystal_array_5_focus_xh;
MCNUM mccchannel_11_analyzer_2_array_crystal_array_5_focus_r;
MCNUM mccchannel_11_analyzer_2_array_crystal_array_5_p_interact;
char mccchannel_11_analyzer_2_array_crystal_array_5_mask_string[16384];
char mccchannel_11_analyzer_2_array_crystal_array_5_mask_setting[16384];
MCNUM mccchannel_11_analyzer_2_array_crystal_array_5_number_of_activations;

/* Setting parameters for component 'channel_11_analyzer_2_array_crystal_array_6' [565]. */
char mccchannel_11_analyzer_2_array_crystal_array_6_material_string[16384];
MCNUM mccchannel_11_analyzer_2_array_crystal_array_6_priority;
MCNUM mccchannel_11_analyzer_2_array_crystal_array_6_xwidth;
MCNUM mccchannel_11_analyzer_2_array_crystal_array_6_yheight;
MCNUM mccchannel_11_analyzer_2_array_crystal_array_6_zdepth;
MCNUM mccchannel_11_analyzer_2_array_crystal_array_6_xwidth2;
MCNUM mccchannel_11_analyzer_2_array_crystal_array_6_yheight2;
MCNUM mccchannel_11_analyzer_2_array_crystal_array_6_visualize;
int mccchannel_11_analyzer_2_array_crystal_array_6_target_index;
MCNUM mccchannel_11_analyzer_2_array_crystal_array_6_target_x;
MCNUM mccchannel_11_analyzer_2_array_crystal_array_6_target_y;
MCNUM mccchannel_11_analyzer_2_array_crystal_array_6_target_z;
MCNUM mccchannel_11_analyzer_2_array_crystal_array_6_focus_aw;
MCNUM mccchannel_11_analyzer_2_array_crystal_array_6_focus_ah;
MCNUM mccchannel_11_analyzer_2_array_crystal_array_6_focus_xw;
MCNUM mccchannel_11_analyzer_2_array_crystal_array_6_focus_xh;
MCNUM mccchannel_11_analyzer_2_array_crystal_array_6_focus_r;
MCNUM mccchannel_11_analyzer_2_array_crystal_array_6_p_interact;
char mccchannel_11_analyzer_2_array_crystal_array_6_mask_string[16384];
char mccchannel_11_analyzer_2_array_crystal_array_6_mask_setting[16384];
MCNUM mccchannel_11_analyzer_2_array_crystal_array_6_number_of_activations;

/* Setting parameters for component 'channel_11_analyzer_2_array_crystal_array_7' [566]. */
char mccchannel_11_analyzer_2_array_crystal_array_7_material_string[16384];
MCNUM mccchannel_11_analyzer_2_array_crystal_array_7_priority;
MCNUM mccchannel_11_analyzer_2_array_crystal_array_7_xwidth;
MCNUM mccchannel_11_analyzer_2_array_crystal_array_7_yheight;
MCNUM mccchannel_11_analyzer_2_array_crystal_array_7_zdepth;
MCNUM mccchannel_11_analyzer_2_array_crystal_array_7_xwidth2;
MCNUM mccchannel_11_analyzer_2_array_crystal_array_7_yheight2;
MCNUM mccchannel_11_analyzer_2_array_crystal_array_7_visualize;
int mccchannel_11_analyzer_2_array_crystal_array_7_target_index;
MCNUM mccchannel_11_analyzer_2_array_crystal_array_7_target_x;
MCNUM mccchannel_11_analyzer_2_array_crystal_array_7_target_y;
MCNUM mccchannel_11_analyzer_2_array_crystal_array_7_target_z;
MCNUM mccchannel_11_analyzer_2_array_crystal_array_7_focus_aw;
MCNUM mccchannel_11_analyzer_2_array_crystal_array_7_focus_ah;
MCNUM mccchannel_11_analyzer_2_array_crystal_array_7_focus_xw;
MCNUM mccchannel_11_analyzer_2_array_crystal_array_7_focus_xh;
MCNUM mccchannel_11_analyzer_2_array_crystal_array_7_focus_r;
MCNUM mccchannel_11_analyzer_2_array_crystal_array_7_p_interact;
char mccchannel_11_analyzer_2_array_crystal_array_7_mask_string[16384];
char mccchannel_11_analyzer_2_array_crystal_array_7_mask_setting[16384];
MCNUM mccchannel_11_analyzer_2_array_crystal_array_7_number_of_activations;

/* Setting parameters for component 'channel_11_analyzer_2_array_crystal_array_8' [567]. */
char mccchannel_11_analyzer_2_array_crystal_array_8_material_string[16384];
MCNUM mccchannel_11_analyzer_2_array_crystal_array_8_priority;
MCNUM mccchannel_11_analyzer_2_array_crystal_array_8_xwidth;
MCNUM mccchannel_11_analyzer_2_array_crystal_array_8_yheight;
MCNUM mccchannel_11_analyzer_2_array_crystal_array_8_zdepth;
MCNUM mccchannel_11_analyzer_2_array_crystal_array_8_xwidth2;
MCNUM mccchannel_11_analyzer_2_array_crystal_array_8_yheight2;
MCNUM mccchannel_11_analyzer_2_array_crystal_array_8_visualize;
int mccchannel_11_analyzer_2_array_crystal_array_8_target_index;
MCNUM mccchannel_11_analyzer_2_array_crystal_array_8_target_x;
MCNUM mccchannel_11_analyzer_2_array_crystal_array_8_target_y;
MCNUM mccchannel_11_analyzer_2_array_crystal_array_8_target_z;
MCNUM mccchannel_11_analyzer_2_array_crystal_array_8_focus_aw;
MCNUM mccchannel_11_analyzer_2_array_crystal_array_8_focus_ah;
MCNUM mccchannel_11_analyzer_2_array_crystal_array_8_focus_xw;
MCNUM mccchannel_11_analyzer_2_array_crystal_array_8_focus_xh;
MCNUM mccchannel_11_analyzer_2_array_crystal_array_8_focus_r;
MCNUM mccchannel_11_analyzer_2_array_crystal_array_8_p_interact;
char mccchannel_11_analyzer_2_array_crystal_array_8_mask_string[16384];
char mccchannel_11_analyzer_2_array_crystal_array_8_mask_setting[16384];
MCNUM mccchannel_11_analyzer_2_array_crystal_array_8_number_of_activations;

/* Setting parameters for component 'channel_11_cave2_cyl1' [568]. */
char mccchannel_11_cave2_cyl1_material_string[16384];
MCNUM mccchannel_11_cave2_cyl1_priority;
MCNUM mccchannel_11_cave2_cyl1_radius;
MCNUM mccchannel_11_cave2_cyl1_yheight;
MCNUM mccchannel_11_cave2_cyl1_visualize;
int mccchannel_11_cave2_cyl1_target_index;
MCNUM mccchannel_11_cave2_cyl1_target_x;
MCNUM mccchannel_11_cave2_cyl1_target_y;
MCNUM mccchannel_11_cave2_cyl1_target_z;
MCNUM mccchannel_11_cave2_cyl1_focus_aw;
MCNUM mccchannel_11_cave2_cyl1_focus_ah;
MCNUM mccchannel_11_cave2_cyl1_focus_xw;
MCNUM mccchannel_11_cave2_cyl1_focus_xh;
MCNUM mccchannel_11_cave2_cyl1_focus_r;
MCNUM mccchannel_11_cave2_cyl1_p_interact;
char mccchannel_11_cave2_cyl1_mask_string[16384];
char mccchannel_11_cave2_cyl1_mask_setting[16384];
MCNUM mccchannel_11_cave2_cyl1_number_of_activations;

/* Setting parameters for component 'channel_11_cave2_box1' [569]. */
char mccchannel_11_cave2_box1_material_string[16384];
MCNUM mccchannel_11_cave2_box1_priority;
MCNUM mccchannel_11_cave2_box1_xwidth;
MCNUM mccchannel_11_cave2_box1_yheight;
MCNUM mccchannel_11_cave2_box1_zdepth;
MCNUM mccchannel_11_cave2_box1_xwidth2;
MCNUM mccchannel_11_cave2_box1_yheight2;
MCNUM mccchannel_11_cave2_box1_visualize;
int mccchannel_11_cave2_box1_target_index;
MCNUM mccchannel_11_cave2_box1_target_x;
MCNUM mccchannel_11_cave2_box1_target_y;
MCNUM mccchannel_11_cave2_box1_target_z;
MCNUM mccchannel_11_cave2_box1_focus_aw;
MCNUM mccchannel_11_cave2_box1_focus_ah;
MCNUM mccchannel_11_cave2_box1_focus_xw;
MCNUM mccchannel_11_cave2_box1_focus_xh;
MCNUM mccchannel_11_cave2_box1_focus_r;
MCNUM mccchannel_11_cave2_box1_p_interact;
char mccchannel_11_cave2_box1_mask_string[16384];
char mccchannel_11_cave2_box1_mask_setting[16384];
MCNUM mccchannel_11_cave2_box1_number_of_activations;

/* Setting parameters for component 'channel_11_cave2_box2' [570]. */
char mccchannel_11_cave2_box2_material_string[16384];
MCNUM mccchannel_11_cave2_box2_priority;
MCNUM mccchannel_11_cave2_box2_xwidth;
MCNUM mccchannel_11_cave2_box2_yheight;
MCNUM mccchannel_11_cave2_box2_zdepth;
MCNUM mccchannel_11_cave2_box2_xwidth2;
MCNUM mccchannel_11_cave2_box2_yheight2;
MCNUM mccchannel_11_cave2_box2_visualize;
int mccchannel_11_cave2_box2_target_index;
MCNUM mccchannel_11_cave2_box2_target_x;
MCNUM mccchannel_11_cave2_box2_target_y;
MCNUM mccchannel_11_cave2_box2_target_z;
MCNUM mccchannel_11_cave2_box2_focus_aw;
MCNUM mccchannel_11_cave2_box2_focus_ah;
MCNUM mccchannel_11_cave2_box2_focus_xw;
MCNUM mccchannel_11_cave2_box2_focus_xh;
MCNUM mccchannel_11_cave2_box2_focus_r;
MCNUM mccchannel_11_cave2_box2_p_interact;
char mccchannel_11_cave2_box2_mask_string[16384];
char mccchannel_11_cave2_box2_mask_setting[16384];
MCNUM mccchannel_11_cave2_box2_number_of_activations;

/* Setting parameters for component 'channel_11_cave2_box3' [571]. */
char mccchannel_11_cave2_box3_material_string[16384];
MCNUM mccchannel_11_cave2_box3_priority;
MCNUM mccchannel_11_cave2_box3_xwidth;
MCNUM mccchannel_11_cave2_box3_yheight;
MCNUM mccchannel_11_cave2_box3_zdepth;
MCNUM mccchannel_11_cave2_box3_xwidth2;
MCNUM mccchannel_11_cave2_box3_yheight2;
MCNUM mccchannel_11_cave2_box3_visualize;
int mccchannel_11_cave2_box3_target_index;
MCNUM mccchannel_11_cave2_box3_target_x;
MCNUM mccchannel_11_cave2_box3_target_y;
MCNUM mccchannel_11_cave2_box3_target_z;
MCNUM mccchannel_11_cave2_box3_focus_aw;
MCNUM mccchannel_11_cave2_box3_focus_ah;
MCNUM mccchannel_11_cave2_box3_focus_xw;
MCNUM mccchannel_11_cave2_box3_focus_xh;
MCNUM mccchannel_11_cave2_box3_focus_r;
MCNUM mccchannel_11_cave2_box3_p_interact;
char mccchannel_11_cave2_box3_mask_string[16384];
char mccchannel_11_cave2_box3_mask_setting[16384];
MCNUM mccchannel_11_cave2_box3_number_of_activations;

/* Setting parameters for component 'inter_analyzer_colimator_11_blade_0' [573]. */
char mccinter_analyzer_colimator_11_blade_0_material_string[16384];
MCNUM mccinter_analyzer_colimator_11_blade_0_priority;
MCNUM mccinter_analyzer_colimator_11_blade_0_xwidth;
MCNUM mccinter_analyzer_colimator_11_blade_0_yheight;
MCNUM mccinter_analyzer_colimator_11_blade_0_zdepth;
MCNUM mccinter_analyzer_colimator_11_blade_0_xwidth2;
MCNUM mccinter_analyzer_colimator_11_blade_0_yheight2;
MCNUM mccinter_analyzer_colimator_11_blade_0_visualize;
int mccinter_analyzer_colimator_11_blade_0_target_index;
MCNUM mccinter_analyzer_colimator_11_blade_0_target_x;
MCNUM mccinter_analyzer_colimator_11_blade_0_target_y;
MCNUM mccinter_analyzer_colimator_11_blade_0_target_z;
MCNUM mccinter_analyzer_colimator_11_blade_0_focus_aw;
MCNUM mccinter_analyzer_colimator_11_blade_0_focus_ah;
MCNUM mccinter_analyzer_colimator_11_blade_0_focus_xw;
MCNUM mccinter_analyzer_colimator_11_blade_0_focus_xh;
MCNUM mccinter_analyzer_colimator_11_blade_0_focus_r;
MCNUM mccinter_analyzer_colimator_11_blade_0_p_interact;
char mccinter_analyzer_colimator_11_blade_0_mask_string[16384];
char mccinter_analyzer_colimator_11_blade_0_mask_setting[16384];
MCNUM mccinter_analyzer_colimator_11_blade_0_number_of_activations;

/* Setting parameters for component 'inter_analyzer_colimator_11_blade_1' [574]. */
char mccinter_analyzer_colimator_11_blade_1_material_string[16384];
MCNUM mccinter_analyzer_colimator_11_blade_1_priority;
MCNUM mccinter_analyzer_colimator_11_blade_1_xwidth;
MCNUM mccinter_analyzer_colimator_11_blade_1_yheight;
MCNUM mccinter_analyzer_colimator_11_blade_1_zdepth;
MCNUM mccinter_analyzer_colimator_11_blade_1_xwidth2;
MCNUM mccinter_analyzer_colimator_11_blade_1_yheight2;
MCNUM mccinter_analyzer_colimator_11_blade_1_visualize;
int mccinter_analyzer_colimator_11_blade_1_target_index;
MCNUM mccinter_analyzer_colimator_11_blade_1_target_x;
MCNUM mccinter_analyzer_colimator_11_blade_1_target_y;
MCNUM mccinter_analyzer_colimator_11_blade_1_target_z;
MCNUM mccinter_analyzer_colimator_11_blade_1_focus_aw;
MCNUM mccinter_analyzer_colimator_11_blade_1_focus_ah;
MCNUM mccinter_analyzer_colimator_11_blade_1_focus_xw;
MCNUM mccinter_analyzer_colimator_11_blade_1_focus_xh;
MCNUM mccinter_analyzer_colimator_11_blade_1_focus_r;
MCNUM mccinter_analyzer_colimator_11_blade_1_p_interact;
char mccinter_analyzer_colimator_11_blade_1_mask_string[16384];
char mccinter_analyzer_colimator_11_blade_1_mask_setting[16384];
MCNUM mccinter_analyzer_colimator_11_blade_1_number_of_activations;

/* Setting parameters for component 'inter_analyzer_colimator_11_blade_2' [575]. */
char mccinter_analyzer_colimator_11_blade_2_material_string[16384];
MCNUM mccinter_analyzer_colimator_11_blade_2_priority;
MCNUM mccinter_analyzer_colimator_11_blade_2_xwidth;
MCNUM mccinter_analyzer_colimator_11_blade_2_yheight;
MCNUM mccinter_analyzer_colimator_11_blade_2_zdepth;
MCNUM mccinter_analyzer_colimator_11_blade_2_xwidth2;
MCNUM mccinter_analyzer_colimator_11_blade_2_yheight2;
MCNUM mccinter_analyzer_colimator_11_blade_2_visualize;
int mccinter_analyzer_colimator_11_blade_2_target_index;
MCNUM mccinter_analyzer_colimator_11_blade_2_target_x;
MCNUM mccinter_analyzer_colimator_11_blade_2_target_y;
MCNUM mccinter_analyzer_colimator_11_blade_2_target_z;
MCNUM mccinter_analyzer_colimator_11_blade_2_focus_aw;
MCNUM mccinter_analyzer_colimator_11_blade_2_focus_ah;
MCNUM mccinter_analyzer_colimator_11_blade_2_focus_xw;
MCNUM mccinter_analyzer_colimator_11_blade_2_focus_xh;
MCNUM mccinter_analyzer_colimator_11_blade_2_focus_r;
MCNUM mccinter_analyzer_colimator_11_blade_2_p_interact;
char mccinter_analyzer_colimator_11_blade_2_mask_string[16384];
char mccinter_analyzer_colimator_11_blade_2_mask_setting[16384];
MCNUM mccinter_analyzer_colimator_11_blade_2_number_of_activations;

/* Setting parameters for component 'inter_analyzer_colimator_11_blade_3' [576]. */
char mccinter_analyzer_colimator_11_blade_3_material_string[16384];
MCNUM mccinter_analyzer_colimator_11_blade_3_priority;
MCNUM mccinter_analyzer_colimator_11_blade_3_xwidth;
MCNUM mccinter_analyzer_colimator_11_blade_3_yheight;
MCNUM mccinter_analyzer_colimator_11_blade_3_zdepth;
MCNUM mccinter_analyzer_colimator_11_blade_3_xwidth2;
MCNUM mccinter_analyzer_colimator_11_blade_3_yheight2;
MCNUM mccinter_analyzer_colimator_11_blade_3_visualize;
int mccinter_analyzer_colimator_11_blade_3_target_index;
MCNUM mccinter_analyzer_colimator_11_blade_3_target_x;
MCNUM mccinter_analyzer_colimator_11_blade_3_target_y;
MCNUM mccinter_analyzer_colimator_11_blade_3_target_z;
MCNUM mccinter_analyzer_colimator_11_blade_3_focus_aw;
MCNUM mccinter_analyzer_colimator_11_blade_3_focus_ah;
MCNUM mccinter_analyzer_colimator_11_blade_3_focus_xw;
MCNUM mccinter_analyzer_colimator_11_blade_3_focus_xh;
MCNUM mccinter_analyzer_colimator_11_blade_3_focus_r;
MCNUM mccinter_analyzer_colimator_11_blade_3_p_interact;
char mccinter_analyzer_colimator_11_blade_3_mask_string[16384];
char mccinter_analyzer_colimator_11_blade_3_mask_setting[16384];
MCNUM mccinter_analyzer_colimator_11_blade_3_number_of_activations;

/* Setting parameters for component 'inter_analyzer_colimator_11_blade_4' [577]. */
char mccinter_analyzer_colimator_11_blade_4_material_string[16384];
MCNUM mccinter_analyzer_colimator_11_blade_4_priority;
MCNUM mccinter_analyzer_colimator_11_blade_4_xwidth;
MCNUM mccinter_analyzer_colimator_11_blade_4_yheight;
MCNUM mccinter_analyzer_colimator_11_blade_4_zdepth;
MCNUM mccinter_analyzer_colimator_11_blade_4_xwidth2;
MCNUM mccinter_analyzer_colimator_11_blade_4_yheight2;
MCNUM mccinter_analyzer_colimator_11_blade_4_visualize;
int mccinter_analyzer_colimator_11_blade_4_target_index;
MCNUM mccinter_analyzer_colimator_11_blade_4_target_x;
MCNUM mccinter_analyzer_colimator_11_blade_4_target_y;
MCNUM mccinter_analyzer_colimator_11_blade_4_target_z;
MCNUM mccinter_analyzer_colimator_11_blade_4_focus_aw;
MCNUM mccinter_analyzer_colimator_11_blade_4_focus_ah;
MCNUM mccinter_analyzer_colimator_11_blade_4_focus_xw;
MCNUM mccinter_analyzer_colimator_11_blade_4_focus_xh;
MCNUM mccinter_analyzer_colimator_11_blade_4_focus_r;
MCNUM mccinter_analyzer_colimator_11_blade_4_p_interact;
char mccinter_analyzer_colimator_11_blade_4_mask_string[16384];
char mccinter_analyzer_colimator_11_blade_4_mask_setting[16384];
MCNUM mccinter_analyzer_colimator_11_blade_4_number_of_activations;

/* Setting parameters for component 'diffraction_detector_11_exit_volume' [578]. */
char mccdiffraction_detector_11_exit_volume_material_string[16384];
MCNUM mccdiffraction_detector_11_exit_volume_priority;
MCNUM mccdiffraction_detector_11_exit_volume_xwidth;
MCNUM mccdiffraction_detector_11_exit_volume_yheight;
MCNUM mccdiffraction_detector_11_exit_volume_zdepth;
MCNUM mccdiffraction_detector_11_exit_volume_xwidth2;
MCNUM mccdiffraction_detector_11_exit_volume_yheight2;
MCNUM mccdiffraction_detector_11_exit_volume_visualize;
int mccdiffraction_detector_11_exit_volume_target_index;
MCNUM mccdiffraction_detector_11_exit_volume_target_x;
MCNUM mccdiffraction_detector_11_exit_volume_target_y;
MCNUM mccdiffraction_detector_11_exit_volume_target_z;
MCNUM mccdiffraction_detector_11_exit_volume_focus_aw;
MCNUM mccdiffraction_detector_11_exit_volume_focus_ah;
MCNUM mccdiffraction_detector_11_exit_volume_focus_xw;
MCNUM mccdiffraction_detector_11_exit_volume_focus_xh;
MCNUM mccdiffraction_detector_11_exit_volume_focus_r;
MCNUM mccdiffraction_detector_11_exit_volume_p_interact;
char mccdiffraction_detector_11_exit_volume_mask_string[16384];
char mccdiffraction_detector_11_exit_volume_mask_setting[16384];
MCNUM mccdiffraction_detector_11_exit_volume_number_of_activations;

/* Setting parameters for component 'spec_detector_11_exit_volume' [579]. */
char mccspec_detector_11_exit_volume_material_string[16384];
MCNUM mccspec_detector_11_exit_volume_priority;
MCNUM mccspec_detector_11_exit_volume_xwidth;
MCNUM mccspec_detector_11_exit_volume_yheight;
MCNUM mccspec_detector_11_exit_volume_zdepth;
MCNUM mccspec_detector_11_exit_volume_xwidth2;
MCNUM mccspec_detector_11_exit_volume_yheight2;
MCNUM mccspec_detector_11_exit_volume_visualize;
int mccspec_detector_11_exit_volume_target_index;
MCNUM mccspec_detector_11_exit_volume_target_x;
MCNUM mccspec_detector_11_exit_volume_target_y;
MCNUM mccspec_detector_11_exit_volume_target_z;
MCNUM mccspec_detector_11_exit_volume_focus_aw;
MCNUM mccspec_detector_11_exit_volume_focus_ah;
MCNUM mccspec_detector_11_exit_volume_focus_xw;
MCNUM mccspec_detector_11_exit_volume_focus_xh;
MCNUM mccspec_detector_11_exit_volume_focus_r;
MCNUM mccspec_detector_11_exit_volume_p_interact;
char mccspec_detector_11_exit_volume_mask_string[16384];
char mccspec_detector_11_exit_volume_mask_setting[16384];
MCNUM mccspec_detector_11_exit_volume_number_of_activations;

/* Setting parameters for component 'channel_12_cave1_box1' [580]. */
char mccchannel_12_cave1_box1_material_string[16384];
MCNUM mccchannel_12_cave1_box1_priority;
MCNUM mccchannel_12_cave1_box1_xwidth;
MCNUM mccchannel_12_cave1_box1_yheight;
MCNUM mccchannel_12_cave1_box1_zdepth;
MCNUM mccchannel_12_cave1_box1_xwidth2;
MCNUM mccchannel_12_cave1_box1_yheight2;
MCNUM mccchannel_12_cave1_box1_visualize;
int mccchannel_12_cave1_box1_target_index;
MCNUM mccchannel_12_cave1_box1_target_x;
MCNUM mccchannel_12_cave1_box1_target_y;
MCNUM mccchannel_12_cave1_box1_target_z;
MCNUM mccchannel_12_cave1_box1_focus_aw;
MCNUM mccchannel_12_cave1_box1_focus_ah;
MCNUM mccchannel_12_cave1_box1_focus_xw;
MCNUM mccchannel_12_cave1_box1_focus_xh;
MCNUM mccchannel_12_cave1_box1_focus_r;
MCNUM mccchannel_12_cave1_box1_p_interact;
char mccchannel_12_cave1_box1_mask_string[16384];
char mccchannel_12_cave1_box1_mask_setting[16384];
MCNUM mccchannel_12_cave1_box1_number_of_activations;

/* Setting parameters for component 'channel_12_cave1_box2' [581]. */
char mccchannel_12_cave1_box2_material_string[16384];
MCNUM mccchannel_12_cave1_box2_priority;
MCNUM mccchannel_12_cave1_box2_xwidth;
MCNUM mccchannel_12_cave1_box2_yheight;
MCNUM mccchannel_12_cave1_box2_zdepth;
MCNUM mccchannel_12_cave1_box2_xwidth2;
MCNUM mccchannel_12_cave1_box2_yheight2;
MCNUM mccchannel_12_cave1_box2_visualize;
int mccchannel_12_cave1_box2_target_index;
MCNUM mccchannel_12_cave1_box2_target_x;
MCNUM mccchannel_12_cave1_box2_target_y;
MCNUM mccchannel_12_cave1_box2_target_z;
MCNUM mccchannel_12_cave1_box2_focus_aw;
MCNUM mccchannel_12_cave1_box2_focus_ah;
MCNUM mccchannel_12_cave1_box2_focus_xw;
MCNUM mccchannel_12_cave1_box2_focus_xh;
MCNUM mccchannel_12_cave1_box2_focus_r;
MCNUM mccchannel_12_cave1_box2_p_interact;
char mccchannel_12_cave1_box2_mask_string[16384];
char mccchannel_12_cave1_box2_mask_setting[16384];
MCNUM mccchannel_12_cave1_box2_number_of_activations;

/* Setting parameters for component 'channel_12_cave1_box3' [582]. */
char mccchannel_12_cave1_box3_material_string[16384];
MCNUM mccchannel_12_cave1_box3_priority;
MCNUM mccchannel_12_cave1_box3_xwidth;
MCNUM mccchannel_12_cave1_box3_yheight;
MCNUM mccchannel_12_cave1_box3_zdepth;
MCNUM mccchannel_12_cave1_box3_xwidth2;
MCNUM mccchannel_12_cave1_box3_yheight2;
MCNUM mccchannel_12_cave1_box3_visualize;
int mccchannel_12_cave1_box3_target_index;
MCNUM mccchannel_12_cave1_box3_target_x;
MCNUM mccchannel_12_cave1_box3_target_y;
MCNUM mccchannel_12_cave1_box3_target_z;
MCNUM mccchannel_12_cave1_box3_focus_aw;
MCNUM mccchannel_12_cave1_box3_focus_ah;
MCNUM mccchannel_12_cave1_box3_focus_xw;
MCNUM mccchannel_12_cave1_box3_focus_xh;
MCNUM mccchannel_12_cave1_box3_focus_r;
MCNUM mccchannel_12_cave1_box3_p_interact;
char mccchannel_12_cave1_box3_mask_string[16384];
char mccchannel_12_cave1_box3_mask_setting[16384];
MCNUM mccchannel_12_cave1_box3_number_of_activations;

/* Setting parameters for component 'channel_12_cave1_cyl1' [583]. */
char mccchannel_12_cave1_cyl1_material_string[16384];
MCNUM mccchannel_12_cave1_cyl1_priority;
MCNUM mccchannel_12_cave1_cyl1_radius;
MCNUM mccchannel_12_cave1_cyl1_yheight;
MCNUM mccchannel_12_cave1_cyl1_visualize;
int mccchannel_12_cave1_cyl1_target_index;
MCNUM mccchannel_12_cave1_cyl1_target_x;
MCNUM mccchannel_12_cave1_cyl1_target_y;
MCNUM mccchannel_12_cave1_cyl1_target_z;
MCNUM mccchannel_12_cave1_cyl1_focus_aw;
MCNUM mccchannel_12_cave1_cyl1_focus_ah;
MCNUM mccchannel_12_cave1_cyl1_focus_xw;
MCNUM mccchannel_12_cave1_cyl1_focus_xh;
MCNUM mccchannel_12_cave1_cyl1_focus_r;
MCNUM mccchannel_12_cave1_cyl1_p_interact;
char mccchannel_12_cave1_cyl1_mask_string[16384];
char mccchannel_12_cave1_cyl1_mask_setting[16384];
MCNUM mccchannel_12_cave1_cyl1_number_of_activations;

/* Setting parameters for component 'channel_12_analyzer_1_array_crystal_array_0' [586]. */
char mccchannel_12_analyzer_1_array_crystal_array_0_material_string[16384];
MCNUM mccchannel_12_analyzer_1_array_crystal_array_0_priority;
MCNUM mccchannel_12_analyzer_1_array_crystal_array_0_xwidth;
MCNUM mccchannel_12_analyzer_1_array_crystal_array_0_yheight;
MCNUM mccchannel_12_analyzer_1_array_crystal_array_0_zdepth;
MCNUM mccchannel_12_analyzer_1_array_crystal_array_0_xwidth2;
MCNUM mccchannel_12_analyzer_1_array_crystal_array_0_yheight2;
MCNUM mccchannel_12_analyzer_1_array_crystal_array_0_visualize;
int mccchannel_12_analyzer_1_array_crystal_array_0_target_index;
MCNUM mccchannel_12_analyzer_1_array_crystal_array_0_target_x;
MCNUM mccchannel_12_analyzer_1_array_crystal_array_0_target_y;
MCNUM mccchannel_12_analyzer_1_array_crystal_array_0_target_z;
MCNUM mccchannel_12_analyzer_1_array_crystal_array_0_focus_aw;
MCNUM mccchannel_12_analyzer_1_array_crystal_array_0_focus_ah;
MCNUM mccchannel_12_analyzer_1_array_crystal_array_0_focus_xw;
MCNUM mccchannel_12_analyzer_1_array_crystal_array_0_focus_xh;
MCNUM mccchannel_12_analyzer_1_array_crystal_array_0_focus_r;
MCNUM mccchannel_12_analyzer_1_array_crystal_array_0_p_interact;
char mccchannel_12_analyzer_1_array_crystal_array_0_mask_string[16384];
char mccchannel_12_analyzer_1_array_crystal_array_0_mask_setting[16384];
MCNUM mccchannel_12_analyzer_1_array_crystal_array_0_number_of_activations;

/* Setting parameters for component 'channel_12_analyzer_1_array_crystal_array_1' [587]. */
char mccchannel_12_analyzer_1_array_crystal_array_1_material_string[16384];
MCNUM mccchannel_12_analyzer_1_array_crystal_array_1_priority;
MCNUM mccchannel_12_analyzer_1_array_crystal_array_1_xwidth;
MCNUM mccchannel_12_analyzer_1_array_crystal_array_1_yheight;
MCNUM mccchannel_12_analyzer_1_array_crystal_array_1_zdepth;
MCNUM mccchannel_12_analyzer_1_array_crystal_array_1_xwidth2;
MCNUM mccchannel_12_analyzer_1_array_crystal_array_1_yheight2;
MCNUM mccchannel_12_analyzer_1_array_crystal_array_1_visualize;
int mccchannel_12_analyzer_1_array_crystal_array_1_target_index;
MCNUM mccchannel_12_analyzer_1_array_crystal_array_1_target_x;
MCNUM mccchannel_12_analyzer_1_array_crystal_array_1_target_y;
MCNUM mccchannel_12_analyzer_1_array_crystal_array_1_target_z;
MCNUM mccchannel_12_analyzer_1_array_crystal_array_1_focus_aw;
MCNUM mccchannel_12_analyzer_1_array_crystal_array_1_focus_ah;
MCNUM mccchannel_12_analyzer_1_array_crystal_array_1_focus_xw;
MCNUM mccchannel_12_analyzer_1_array_crystal_array_1_focus_xh;
MCNUM mccchannel_12_analyzer_1_array_crystal_array_1_focus_r;
MCNUM mccchannel_12_analyzer_1_array_crystal_array_1_p_interact;
char mccchannel_12_analyzer_1_array_crystal_array_1_mask_string[16384];
char mccchannel_12_analyzer_1_array_crystal_array_1_mask_setting[16384];
MCNUM mccchannel_12_analyzer_1_array_crystal_array_1_number_of_activations;

/* Setting parameters for component 'channel_12_analyzer_1_array_crystal_array_2' [588]. */
char mccchannel_12_analyzer_1_array_crystal_array_2_material_string[16384];
MCNUM mccchannel_12_analyzer_1_array_crystal_array_2_priority;
MCNUM mccchannel_12_analyzer_1_array_crystal_array_2_xwidth;
MCNUM mccchannel_12_analyzer_1_array_crystal_array_2_yheight;
MCNUM mccchannel_12_analyzer_1_array_crystal_array_2_zdepth;
MCNUM mccchannel_12_analyzer_1_array_crystal_array_2_xwidth2;
MCNUM mccchannel_12_analyzer_1_array_crystal_array_2_yheight2;
MCNUM mccchannel_12_analyzer_1_array_crystal_array_2_visualize;
int mccchannel_12_analyzer_1_array_crystal_array_2_target_index;
MCNUM mccchannel_12_analyzer_1_array_crystal_array_2_target_x;
MCNUM mccchannel_12_analyzer_1_array_crystal_array_2_target_y;
MCNUM mccchannel_12_analyzer_1_array_crystal_array_2_target_z;
MCNUM mccchannel_12_analyzer_1_array_crystal_array_2_focus_aw;
MCNUM mccchannel_12_analyzer_1_array_crystal_array_2_focus_ah;
MCNUM mccchannel_12_analyzer_1_array_crystal_array_2_focus_xw;
MCNUM mccchannel_12_analyzer_1_array_crystal_array_2_focus_xh;
MCNUM mccchannel_12_analyzer_1_array_crystal_array_2_focus_r;
MCNUM mccchannel_12_analyzer_1_array_crystal_array_2_p_interact;
char mccchannel_12_analyzer_1_array_crystal_array_2_mask_string[16384];
char mccchannel_12_analyzer_1_array_crystal_array_2_mask_setting[16384];
MCNUM mccchannel_12_analyzer_1_array_crystal_array_2_number_of_activations;

/* Setting parameters for component 'channel_12_analyzer_1_array_crystal_array_3' [589]. */
char mccchannel_12_analyzer_1_array_crystal_array_3_material_string[16384];
MCNUM mccchannel_12_analyzer_1_array_crystal_array_3_priority;
MCNUM mccchannel_12_analyzer_1_array_crystal_array_3_xwidth;
MCNUM mccchannel_12_analyzer_1_array_crystal_array_3_yheight;
MCNUM mccchannel_12_analyzer_1_array_crystal_array_3_zdepth;
MCNUM mccchannel_12_analyzer_1_array_crystal_array_3_xwidth2;
MCNUM mccchannel_12_analyzer_1_array_crystal_array_3_yheight2;
MCNUM mccchannel_12_analyzer_1_array_crystal_array_3_visualize;
int mccchannel_12_analyzer_1_array_crystal_array_3_target_index;
MCNUM mccchannel_12_analyzer_1_array_crystal_array_3_target_x;
MCNUM mccchannel_12_analyzer_1_array_crystal_array_3_target_y;
MCNUM mccchannel_12_analyzer_1_array_crystal_array_3_target_z;
MCNUM mccchannel_12_analyzer_1_array_crystal_array_3_focus_aw;
MCNUM mccchannel_12_analyzer_1_array_crystal_array_3_focus_ah;
MCNUM mccchannel_12_analyzer_1_array_crystal_array_3_focus_xw;
MCNUM mccchannel_12_analyzer_1_array_crystal_array_3_focus_xh;
MCNUM mccchannel_12_analyzer_1_array_crystal_array_3_focus_r;
MCNUM mccchannel_12_analyzer_1_array_crystal_array_3_p_interact;
char mccchannel_12_analyzer_1_array_crystal_array_3_mask_string[16384];
char mccchannel_12_analyzer_1_array_crystal_array_3_mask_setting[16384];
MCNUM mccchannel_12_analyzer_1_array_crystal_array_3_number_of_activations;

/* Setting parameters for component 'channel_12_analyzer_1_array_crystal_array_4' [590]. */
char mccchannel_12_analyzer_1_array_crystal_array_4_material_string[16384];
MCNUM mccchannel_12_analyzer_1_array_crystal_array_4_priority;
MCNUM mccchannel_12_analyzer_1_array_crystal_array_4_xwidth;
MCNUM mccchannel_12_analyzer_1_array_crystal_array_4_yheight;
MCNUM mccchannel_12_analyzer_1_array_crystal_array_4_zdepth;
MCNUM mccchannel_12_analyzer_1_array_crystal_array_4_xwidth2;
MCNUM mccchannel_12_analyzer_1_array_crystal_array_4_yheight2;
MCNUM mccchannel_12_analyzer_1_array_crystal_array_4_visualize;
int mccchannel_12_analyzer_1_array_crystal_array_4_target_index;
MCNUM mccchannel_12_analyzer_1_array_crystal_array_4_target_x;
MCNUM mccchannel_12_analyzer_1_array_crystal_array_4_target_y;
MCNUM mccchannel_12_analyzer_1_array_crystal_array_4_target_z;
MCNUM mccchannel_12_analyzer_1_array_crystal_array_4_focus_aw;
MCNUM mccchannel_12_analyzer_1_array_crystal_array_4_focus_ah;
MCNUM mccchannel_12_analyzer_1_array_crystal_array_4_focus_xw;
MCNUM mccchannel_12_analyzer_1_array_crystal_array_4_focus_xh;
MCNUM mccchannel_12_analyzer_1_array_crystal_array_4_focus_r;
MCNUM mccchannel_12_analyzer_1_array_crystal_array_4_p_interact;
char mccchannel_12_analyzer_1_array_crystal_array_4_mask_string[16384];
char mccchannel_12_analyzer_1_array_crystal_array_4_mask_setting[16384];
MCNUM mccchannel_12_analyzer_1_array_crystal_array_4_number_of_activations;

/* Setting parameters for component 'channel_12_analyzer_1_array_crystal_array_5' [591]. */
char mccchannel_12_analyzer_1_array_crystal_array_5_material_string[16384];
MCNUM mccchannel_12_analyzer_1_array_crystal_array_5_priority;
MCNUM mccchannel_12_analyzer_1_array_crystal_array_5_xwidth;
MCNUM mccchannel_12_analyzer_1_array_crystal_array_5_yheight;
MCNUM mccchannel_12_analyzer_1_array_crystal_array_5_zdepth;
MCNUM mccchannel_12_analyzer_1_array_crystal_array_5_xwidth2;
MCNUM mccchannel_12_analyzer_1_array_crystal_array_5_yheight2;
MCNUM mccchannel_12_analyzer_1_array_crystal_array_5_visualize;
int mccchannel_12_analyzer_1_array_crystal_array_5_target_index;
MCNUM mccchannel_12_analyzer_1_array_crystal_array_5_target_x;
MCNUM mccchannel_12_analyzer_1_array_crystal_array_5_target_y;
MCNUM mccchannel_12_analyzer_1_array_crystal_array_5_target_z;
MCNUM mccchannel_12_analyzer_1_array_crystal_array_5_focus_aw;
MCNUM mccchannel_12_analyzer_1_array_crystal_array_5_focus_ah;
MCNUM mccchannel_12_analyzer_1_array_crystal_array_5_focus_xw;
MCNUM mccchannel_12_analyzer_1_array_crystal_array_5_focus_xh;
MCNUM mccchannel_12_analyzer_1_array_crystal_array_5_focus_r;
MCNUM mccchannel_12_analyzer_1_array_crystal_array_5_p_interact;
char mccchannel_12_analyzer_1_array_crystal_array_5_mask_string[16384];
char mccchannel_12_analyzer_1_array_crystal_array_5_mask_setting[16384];
MCNUM mccchannel_12_analyzer_1_array_crystal_array_5_number_of_activations;

/* Setting parameters for component 'channel_12_analyzer_1_array_crystal_array_6' [592]. */
char mccchannel_12_analyzer_1_array_crystal_array_6_material_string[16384];
MCNUM mccchannel_12_analyzer_1_array_crystal_array_6_priority;
MCNUM mccchannel_12_analyzer_1_array_crystal_array_6_xwidth;
MCNUM mccchannel_12_analyzer_1_array_crystal_array_6_yheight;
MCNUM mccchannel_12_analyzer_1_array_crystal_array_6_zdepth;
MCNUM mccchannel_12_analyzer_1_array_crystal_array_6_xwidth2;
MCNUM mccchannel_12_analyzer_1_array_crystal_array_6_yheight2;
MCNUM mccchannel_12_analyzer_1_array_crystal_array_6_visualize;
int mccchannel_12_analyzer_1_array_crystal_array_6_target_index;
MCNUM mccchannel_12_analyzer_1_array_crystal_array_6_target_x;
MCNUM mccchannel_12_analyzer_1_array_crystal_array_6_target_y;
MCNUM mccchannel_12_analyzer_1_array_crystal_array_6_target_z;
MCNUM mccchannel_12_analyzer_1_array_crystal_array_6_focus_aw;
MCNUM mccchannel_12_analyzer_1_array_crystal_array_6_focus_ah;
MCNUM mccchannel_12_analyzer_1_array_crystal_array_6_focus_xw;
MCNUM mccchannel_12_analyzer_1_array_crystal_array_6_focus_xh;
MCNUM mccchannel_12_analyzer_1_array_crystal_array_6_focus_r;
MCNUM mccchannel_12_analyzer_1_array_crystal_array_6_p_interact;
char mccchannel_12_analyzer_1_array_crystal_array_6_mask_string[16384];
char mccchannel_12_analyzer_1_array_crystal_array_6_mask_setting[16384];
MCNUM mccchannel_12_analyzer_1_array_crystal_array_6_number_of_activations;

/* Setting parameters for component 'channel_12_analyzer_1_array_crystal_array_7' [593]. */
char mccchannel_12_analyzer_1_array_crystal_array_7_material_string[16384];
MCNUM mccchannel_12_analyzer_1_array_crystal_array_7_priority;
MCNUM mccchannel_12_analyzer_1_array_crystal_array_7_xwidth;
MCNUM mccchannel_12_analyzer_1_array_crystal_array_7_yheight;
MCNUM mccchannel_12_analyzer_1_array_crystal_array_7_zdepth;
MCNUM mccchannel_12_analyzer_1_array_crystal_array_7_xwidth2;
MCNUM mccchannel_12_analyzer_1_array_crystal_array_7_yheight2;
MCNUM mccchannel_12_analyzer_1_array_crystal_array_7_visualize;
int mccchannel_12_analyzer_1_array_crystal_array_7_target_index;
MCNUM mccchannel_12_analyzer_1_array_crystal_array_7_target_x;
MCNUM mccchannel_12_analyzer_1_array_crystal_array_7_target_y;
MCNUM mccchannel_12_analyzer_1_array_crystal_array_7_target_z;
MCNUM mccchannel_12_analyzer_1_array_crystal_array_7_focus_aw;
MCNUM mccchannel_12_analyzer_1_array_crystal_array_7_focus_ah;
MCNUM mccchannel_12_analyzer_1_array_crystal_array_7_focus_xw;
MCNUM mccchannel_12_analyzer_1_array_crystal_array_7_focus_xh;
MCNUM mccchannel_12_analyzer_1_array_crystal_array_7_focus_r;
MCNUM mccchannel_12_analyzer_1_array_crystal_array_7_p_interact;
char mccchannel_12_analyzer_1_array_crystal_array_7_mask_string[16384];
char mccchannel_12_analyzer_1_array_crystal_array_7_mask_setting[16384];
MCNUM mccchannel_12_analyzer_1_array_crystal_array_7_number_of_activations;

/* Setting parameters for component 'channel_12_analyzer_1_array_crystal_array_8' [594]. */
char mccchannel_12_analyzer_1_array_crystal_array_8_material_string[16384];
MCNUM mccchannel_12_analyzer_1_array_crystal_array_8_priority;
MCNUM mccchannel_12_analyzer_1_array_crystal_array_8_xwidth;
MCNUM mccchannel_12_analyzer_1_array_crystal_array_8_yheight;
MCNUM mccchannel_12_analyzer_1_array_crystal_array_8_zdepth;
MCNUM mccchannel_12_analyzer_1_array_crystal_array_8_xwidth2;
MCNUM mccchannel_12_analyzer_1_array_crystal_array_8_yheight2;
MCNUM mccchannel_12_analyzer_1_array_crystal_array_8_visualize;
int mccchannel_12_analyzer_1_array_crystal_array_8_target_index;
MCNUM mccchannel_12_analyzer_1_array_crystal_array_8_target_x;
MCNUM mccchannel_12_analyzer_1_array_crystal_array_8_target_y;
MCNUM mccchannel_12_analyzer_1_array_crystal_array_8_target_z;
MCNUM mccchannel_12_analyzer_1_array_crystal_array_8_focus_aw;
MCNUM mccchannel_12_analyzer_1_array_crystal_array_8_focus_ah;
MCNUM mccchannel_12_analyzer_1_array_crystal_array_8_focus_xw;
MCNUM mccchannel_12_analyzer_1_array_crystal_array_8_focus_xh;
MCNUM mccchannel_12_analyzer_1_array_crystal_array_8_focus_r;
MCNUM mccchannel_12_analyzer_1_array_crystal_array_8_p_interact;
char mccchannel_12_analyzer_1_array_crystal_array_8_mask_string[16384];
char mccchannel_12_analyzer_1_array_crystal_array_8_mask_setting[16384];
MCNUM mccchannel_12_analyzer_1_array_crystal_array_8_number_of_activations;

/* Setting parameters for component 'channel_12_analyzer_2_array_crystal_array_0' [597]. */
char mccchannel_12_analyzer_2_array_crystal_array_0_material_string[16384];
MCNUM mccchannel_12_analyzer_2_array_crystal_array_0_priority;
MCNUM mccchannel_12_analyzer_2_array_crystal_array_0_xwidth;
MCNUM mccchannel_12_analyzer_2_array_crystal_array_0_yheight;
MCNUM mccchannel_12_analyzer_2_array_crystal_array_0_zdepth;
MCNUM mccchannel_12_analyzer_2_array_crystal_array_0_xwidth2;
MCNUM mccchannel_12_analyzer_2_array_crystal_array_0_yheight2;
MCNUM mccchannel_12_analyzer_2_array_crystal_array_0_visualize;
int mccchannel_12_analyzer_2_array_crystal_array_0_target_index;
MCNUM mccchannel_12_analyzer_2_array_crystal_array_0_target_x;
MCNUM mccchannel_12_analyzer_2_array_crystal_array_0_target_y;
MCNUM mccchannel_12_analyzer_2_array_crystal_array_0_target_z;
MCNUM mccchannel_12_analyzer_2_array_crystal_array_0_focus_aw;
MCNUM mccchannel_12_analyzer_2_array_crystal_array_0_focus_ah;
MCNUM mccchannel_12_analyzer_2_array_crystal_array_0_focus_xw;
MCNUM mccchannel_12_analyzer_2_array_crystal_array_0_focus_xh;
MCNUM mccchannel_12_analyzer_2_array_crystal_array_0_focus_r;
MCNUM mccchannel_12_analyzer_2_array_crystal_array_0_p_interact;
char mccchannel_12_analyzer_2_array_crystal_array_0_mask_string[16384];
char mccchannel_12_analyzer_2_array_crystal_array_0_mask_setting[16384];
MCNUM mccchannel_12_analyzer_2_array_crystal_array_0_number_of_activations;

/* Setting parameters for component 'channel_12_analyzer_2_array_crystal_array_1' [598]. */
char mccchannel_12_analyzer_2_array_crystal_array_1_material_string[16384];
MCNUM mccchannel_12_analyzer_2_array_crystal_array_1_priority;
MCNUM mccchannel_12_analyzer_2_array_crystal_array_1_xwidth;
MCNUM mccchannel_12_analyzer_2_array_crystal_array_1_yheight;
MCNUM mccchannel_12_analyzer_2_array_crystal_array_1_zdepth;
MCNUM mccchannel_12_analyzer_2_array_crystal_array_1_xwidth2;
MCNUM mccchannel_12_analyzer_2_array_crystal_array_1_yheight2;
MCNUM mccchannel_12_analyzer_2_array_crystal_array_1_visualize;
int mccchannel_12_analyzer_2_array_crystal_array_1_target_index;
MCNUM mccchannel_12_analyzer_2_array_crystal_array_1_target_x;
MCNUM mccchannel_12_analyzer_2_array_crystal_array_1_target_y;
MCNUM mccchannel_12_analyzer_2_array_crystal_array_1_target_z;
MCNUM mccchannel_12_analyzer_2_array_crystal_array_1_focus_aw;
MCNUM mccchannel_12_analyzer_2_array_crystal_array_1_focus_ah;
MCNUM mccchannel_12_analyzer_2_array_crystal_array_1_focus_xw;
MCNUM mccchannel_12_analyzer_2_array_crystal_array_1_focus_xh;
MCNUM mccchannel_12_analyzer_2_array_crystal_array_1_focus_r;
MCNUM mccchannel_12_analyzer_2_array_crystal_array_1_p_interact;
char mccchannel_12_analyzer_2_array_crystal_array_1_mask_string[16384];
char mccchannel_12_analyzer_2_array_crystal_array_1_mask_setting[16384];
MCNUM mccchannel_12_analyzer_2_array_crystal_array_1_number_of_activations;

/* Setting parameters for component 'channel_12_analyzer_2_array_crystal_array_2' [599]. */
char mccchannel_12_analyzer_2_array_crystal_array_2_material_string[16384];
MCNUM mccchannel_12_analyzer_2_array_crystal_array_2_priority;
MCNUM mccchannel_12_analyzer_2_array_crystal_array_2_xwidth;
MCNUM mccchannel_12_analyzer_2_array_crystal_array_2_yheight;
MCNUM mccchannel_12_analyzer_2_array_crystal_array_2_zdepth;
MCNUM mccchannel_12_analyzer_2_array_crystal_array_2_xwidth2;
MCNUM mccchannel_12_analyzer_2_array_crystal_array_2_yheight2;
MCNUM mccchannel_12_analyzer_2_array_crystal_array_2_visualize;
int mccchannel_12_analyzer_2_array_crystal_array_2_target_index;
MCNUM mccchannel_12_analyzer_2_array_crystal_array_2_target_x;
MCNUM mccchannel_12_analyzer_2_array_crystal_array_2_target_y;
MCNUM mccchannel_12_analyzer_2_array_crystal_array_2_target_z;
MCNUM mccchannel_12_analyzer_2_array_crystal_array_2_focus_aw;
MCNUM mccchannel_12_analyzer_2_array_crystal_array_2_focus_ah;
MCNUM mccchannel_12_analyzer_2_array_crystal_array_2_focus_xw;
MCNUM mccchannel_12_analyzer_2_array_crystal_array_2_focus_xh;
MCNUM mccchannel_12_analyzer_2_array_crystal_array_2_focus_r;
MCNUM mccchannel_12_analyzer_2_array_crystal_array_2_p_interact;
char mccchannel_12_analyzer_2_array_crystal_array_2_mask_string[16384];
char mccchannel_12_analyzer_2_array_crystal_array_2_mask_setting[16384];
MCNUM mccchannel_12_analyzer_2_array_crystal_array_2_number_of_activations;

/* Setting parameters for component 'channel_12_analyzer_2_array_crystal_array_3' [600]. */
char mccchannel_12_analyzer_2_array_crystal_array_3_material_string[16384];
MCNUM mccchannel_12_analyzer_2_array_crystal_array_3_priority;
MCNUM mccchannel_12_analyzer_2_array_crystal_array_3_xwidth;
MCNUM mccchannel_12_analyzer_2_array_crystal_array_3_yheight;
MCNUM mccchannel_12_analyzer_2_array_crystal_array_3_zdepth;
MCNUM mccchannel_12_analyzer_2_array_crystal_array_3_xwidth2;
MCNUM mccchannel_12_analyzer_2_array_crystal_array_3_yheight2;
MCNUM mccchannel_12_analyzer_2_array_crystal_array_3_visualize;
int mccchannel_12_analyzer_2_array_crystal_array_3_target_index;
MCNUM mccchannel_12_analyzer_2_array_crystal_array_3_target_x;
MCNUM mccchannel_12_analyzer_2_array_crystal_array_3_target_y;
MCNUM mccchannel_12_analyzer_2_array_crystal_array_3_target_z;
MCNUM mccchannel_12_analyzer_2_array_crystal_array_3_focus_aw;
MCNUM mccchannel_12_analyzer_2_array_crystal_array_3_focus_ah;
MCNUM mccchannel_12_analyzer_2_array_crystal_array_3_focus_xw;
MCNUM mccchannel_12_analyzer_2_array_crystal_array_3_focus_xh;
MCNUM mccchannel_12_analyzer_2_array_crystal_array_3_focus_r;
MCNUM mccchannel_12_analyzer_2_array_crystal_array_3_p_interact;
char mccchannel_12_analyzer_2_array_crystal_array_3_mask_string[16384];
char mccchannel_12_analyzer_2_array_crystal_array_3_mask_setting[16384];
MCNUM mccchannel_12_analyzer_2_array_crystal_array_3_number_of_activations;

/* Setting parameters for component 'channel_12_analyzer_2_array_crystal_array_4' [601]. */
char mccchannel_12_analyzer_2_array_crystal_array_4_material_string[16384];
MCNUM mccchannel_12_analyzer_2_array_crystal_array_4_priority;
MCNUM mccchannel_12_analyzer_2_array_crystal_array_4_xwidth;
MCNUM mccchannel_12_analyzer_2_array_crystal_array_4_yheight;
MCNUM mccchannel_12_analyzer_2_array_crystal_array_4_zdepth;
MCNUM mccchannel_12_analyzer_2_array_crystal_array_4_xwidth2;
MCNUM mccchannel_12_analyzer_2_array_crystal_array_4_yheight2;
MCNUM mccchannel_12_analyzer_2_array_crystal_array_4_visualize;
int mccchannel_12_analyzer_2_array_crystal_array_4_target_index;
MCNUM mccchannel_12_analyzer_2_array_crystal_array_4_target_x;
MCNUM mccchannel_12_analyzer_2_array_crystal_array_4_target_y;
MCNUM mccchannel_12_analyzer_2_array_crystal_array_4_target_z;
MCNUM mccchannel_12_analyzer_2_array_crystal_array_4_focus_aw;
MCNUM mccchannel_12_analyzer_2_array_crystal_array_4_focus_ah;
MCNUM mccchannel_12_analyzer_2_array_crystal_array_4_focus_xw;
MCNUM mccchannel_12_analyzer_2_array_crystal_array_4_focus_xh;
MCNUM mccchannel_12_analyzer_2_array_crystal_array_4_focus_r;
MCNUM mccchannel_12_analyzer_2_array_crystal_array_4_p_interact;
char mccchannel_12_analyzer_2_array_crystal_array_4_mask_string[16384];
char mccchannel_12_analyzer_2_array_crystal_array_4_mask_setting[16384];
MCNUM mccchannel_12_analyzer_2_array_crystal_array_4_number_of_activations;

/* Setting parameters for component 'channel_12_analyzer_2_array_crystal_array_5' [602]. */
char mccchannel_12_analyzer_2_array_crystal_array_5_material_string[16384];
MCNUM mccchannel_12_analyzer_2_array_crystal_array_5_priority;
MCNUM mccchannel_12_analyzer_2_array_crystal_array_5_xwidth;
MCNUM mccchannel_12_analyzer_2_array_crystal_array_5_yheight;
MCNUM mccchannel_12_analyzer_2_array_crystal_array_5_zdepth;
MCNUM mccchannel_12_analyzer_2_array_crystal_array_5_xwidth2;
MCNUM mccchannel_12_analyzer_2_array_crystal_array_5_yheight2;
MCNUM mccchannel_12_analyzer_2_array_crystal_array_5_visualize;
int mccchannel_12_analyzer_2_array_crystal_array_5_target_index;
MCNUM mccchannel_12_analyzer_2_array_crystal_array_5_target_x;
MCNUM mccchannel_12_analyzer_2_array_crystal_array_5_target_y;
MCNUM mccchannel_12_analyzer_2_array_crystal_array_5_target_z;
MCNUM mccchannel_12_analyzer_2_array_crystal_array_5_focus_aw;
MCNUM mccchannel_12_analyzer_2_array_crystal_array_5_focus_ah;
MCNUM mccchannel_12_analyzer_2_array_crystal_array_5_focus_xw;
MCNUM mccchannel_12_analyzer_2_array_crystal_array_5_focus_xh;
MCNUM mccchannel_12_analyzer_2_array_crystal_array_5_focus_r;
MCNUM mccchannel_12_analyzer_2_array_crystal_array_5_p_interact;
char mccchannel_12_analyzer_2_array_crystal_array_5_mask_string[16384];
char mccchannel_12_analyzer_2_array_crystal_array_5_mask_setting[16384];
MCNUM mccchannel_12_analyzer_2_array_crystal_array_5_number_of_activations;

/* Setting parameters for component 'channel_12_analyzer_2_array_crystal_array_6' [603]. */
char mccchannel_12_analyzer_2_array_crystal_array_6_material_string[16384];
MCNUM mccchannel_12_analyzer_2_array_crystal_array_6_priority;
MCNUM mccchannel_12_analyzer_2_array_crystal_array_6_xwidth;
MCNUM mccchannel_12_analyzer_2_array_crystal_array_6_yheight;
MCNUM mccchannel_12_analyzer_2_array_crystal_array_6_zdepth;
MCNUM mccchannel_12_analyzer_2_array_crystal_array_6_xwidth2;
MCNUM mccchannel_12_analyzer_2_array_crystal_array_6_yheight2;
MCNUM mccchannel_12_analyzer_2_array_crystal_array_6_visualize;
int mccchannel_12_analyzer_2_array_crystal_array_6_target_index;
MCNUM mccchannel_12_analyzer_2_array_crystal_array_6_target_x;
MCNUM mccchannel_12_analyzer_2_array_crystal_array_6_target_y;
MCNUM mccchannel_12_analyzer_2_array_crystal_array_6_target_z;
MCNUM mccchannel_12_analyzer_2_array_crystal_array_6_focus_aw;
MCNUM mccchannel_12_analyzer_2_array_crystal_array_6_focus_ah;
MCNUM mccchannel_12_analyzer_2_array_crystal_array_6_focus_xw;
MCNUM mccchannel_12_analyzer_2_array_crystal_array_6_focus_xh;
MCNUM mccchannel_12_analyzer_2_array_crystal_array_6_focus_r;
MCNUM mccchannel_12_analyzer_2_array_crystal_array_6_p_interact;
char mccchannel_12_analyzer_2_array_crystal_array_6_mask_string[16384];
char mccchannel_12_analyzer_2_array_crystal_array_6_mask_setting[16384];
MCNUM mccchannel_12_analyzer_2_array_crystal_array_6_number_of_activations;

/* Setting parameters for component 'channel_12_analyzer_2_array_crystal_array_7' [604]. */
char mccchannel_12_analyzer_2_array_crystal_array_7_material_string[16384];
MCNUM mccchannel_12_analyzer_2_array_crystal_array_7_priority;
MCNUM mccchannel_12_analyzer_2_array_crystal_array_7_xwidth;
MCNUM mccchannel_12_analyzer_2_array_crystal_array_7_yheight;
MCNUM mccchannel_12_analyzer_2_array_crystal_array_7_zdepth;
MCNUM mccchannel_12_analyzer_2_array_crystal_array_7_xwidth2;
MCNUM mccchannel_12_analyzer_2_array_crystal_array_7_yheight2;
MCNUM mccchannel_12_analyzer_2_array_crystal_array_7_visualize;
int mccchannel_12_analyzer_2_array_crystal_array_7_target_index;
MCNUM mccchannel_12_analyzer_2_array_crystal_array_7_target_x;
MCNUM mccchannel_12_analyzer_2_array_crystal_array_7_target_y;
MCNUM mccchannel_12_analyzer_2_array_crystal_array_7_target_z;
MCNUM mccchannel_12_analyzer_2_array_crystal_array_7_focus_aw;
MCNUM mccchannel_12_analyzer_2_array_crystal_array_7_focus_ah;
MCNUM mccchannel_12_analyzer_2_array_crystal_array_7_focus_xw;
MCNUM mccchannel_12_analyzer_2_array_crystal_array_7_focus_xh;
MCNUM mccchannel_12_analyzer_2_array_crystal_array_7_focus_r;
MCNUM mccchannel_12_analyzer_2_array_crystal_array_7_p_interact;
char mccchannel_12_analyzer_2_array_crystal_array_7_mask_string[16384];
char mccchannel_12_analyzer_2_array_crystal_array_7_mask_setting[16384];
MCNUM mccchannel_12_analyzer_2_array_crystal_array_7_number_of_activations;

/* Setting parameters for component 'channel_12_analyzer_2_array_crystal_array_8' [605]. */
char mccchannel_12_analyzer_2_array_crystal_array_8_material_string[16384];
MCNUM mccchannel_12_analyzer_2_array_crystal_array_8_priority;
MCNUM mccchannel_12_analyzer_2_array_crystal_array_8_xwidth;
MCNUM mccchannel_12_analyzer_2_array_crystal_array_8_yheight;
MCNUM mccchannel_12_analyzer_2_array_crystal_array_8_zdepth;
MCNUM mccchannel_12_analyzer_2_array_crystal_array_8_xwidth2;
MCNUM mccchannel_12_analyzer_2_array_crystal_array_8_yheight2;
MCNUM mccchannel_12_analyzer_2_array_crystal_array_8_visualize;
int mccchannel_12_analyzer_2_array_crystal_array_8_target_index;
MCNUM mccchannel_12_analyzer_2_array_crystal_array_8_target_x;
MCNUM mccchannel_12_analyzer_2_array_crystal_array_8_target_y;
MCNUM mccchannel_12_analyzer_2_array_crystal_array_8_target_z;
MCNUM mccchannel_12_analyzer_2_array_crystal_array_8_focus_aw;
MCNUM mccchannel_12_analyzer_2_array_crystal_array_8_focus_ah;
MCNUM mccchannel_12_analyzer_2_array_crystal_array_8_focus_xw;
MCNUM mccchannel_12_analyzer_2_array_crystal_array_8_focus_xh;
MCNUM mccchannel_12_analyzer_2_array_crystal_array_8_focus_r;
MCNUM mccchannel_12_analyzer_2_array_crystal_array_8_p_interact;
char mccchannel_12_analyzer_2_array_crystal_array_8_mask_string[16384];
char mccchannel_12_analyzer_2_array_crystal_array_8_mask_setting[16384];
MCNUM mccchannel_12_analyzer_2_array_crystal_array_8_number_of_activations;

/* Setting parameters for component 'channel_12_cave2_cyl1' [606]. */
char mccchannel_12_cave2_cyl1_material_string[16384];
MCNUM mccchannel_12_cave2_cyl1_priority;
MCNUM mccchannel_12_cave2_cyl1_radius;
MCNUM mccchannel_12_cave2_cyl1_yheight;
MCNUM mccchannel_12_cave2_cyl1_visualize;
int mccchannel_12_cave2_cyl1_target_index;
MCNUM mccchannel_12_cave2_cyl1_target_x;
MCNUM mccchannel_12_cave2_cyl1_target_y;
MCNUM mccchannel_12_cave2_cyl1_target_z;
MCNUM mccchannel_12_cave2_cyl1_focus_aw;
MCNUM mccchannel_12_cave2_cyl1_focus_ah;
MCNUM mccchannel_12_cave2_cyl1_focus_xw;
MCNUM mccchannel_12_cave2_cyl1_focus_xh;
MCNUM mccchannel_12_cave2_cyl1_focus_r;
MCNUM mccchannel_12_cave2_cyl1_p_interact;
char mccchannel_12_cave2_cyl1_mask_string[16384];
char mccchannel_12_cave2_cyl1_mask_setting[16384];
MCNUM mccchannel_12_cave2_cyl1_number_of_activations;

/* Setting parameters for component 'channel_12_cave2_box1' [607]. */
char mccchannel_12_cave2_box1_material_string[16384];
MCNUM mccchannel_12_cave2_box1_priority;
MCNUM mccchannel_12_cave2_box1_xwidth;
MCNUM mccchannel_12_cave2_box1_yheight;
MCNUM mccchannel_12_cave2_box1_zdepth;
MCNUM mccchannel_12_cave2_box1_xwidth2;
MCNUM mccchannel_12_cave2_box1_yheight2;
MCNUM mccchannel_12_cave2_box1_visualize;
int mccchannel_12_cave2_box1_target_index;
MCNUM mccchannel_12_cave2_box1_target_x;
MCNUM mccchannel_12_cave2_box1_target_y;
MCNUM mccchannel_12_cave2_box1_target_z;
MCNUM mccchannel_12_cave2_box1_focus_aw;
MCNUM mccchannel_12_cave2_box1_focus_ah;
MCNUM mccchannel_12_cave2_box1_focus_xw;
MCNUM mccchannel_12_cave2_box1_focus_xh;
MCNUM mccchannel_12_cave2_box1_focus_r;
MCNUM mccchannel_12_cave2_box1_p_interact;
char mccchannel_12_cave2_box1_mask_string[16384];
char mccchannel_12_cave2_box1_mask_setting[16384];
MCNUM mccchannel_12_cave2_box1_number_of_activations;

/* Setting parameters for component 'channel_12_cave2_box2' [608]. */
char mccchannel_12_cave2_box2_material_string[16384];
MCNUM mccchannel_12_cave2_box2_priority;
MCNUM mccchannel_12_cave2_box2_xwidth;
MCNUM mccchannel_12_cave2_box2_yheight;
MCNUM mccchannel_12_cave2_box2_zdepth;
MCNUM mccchannel_12_cave2_box2_xwidth2;
MCNUM mccchannel_12_cave2_box2_yheight2;
MCNUM mccchannel_12_cave2_box2_visualize;
int mccchannel_12_cave2_box2_target_index;
MCNUM mccchannel_12_cave2_box2_target_x;
MCNUM mccchannel_12_cave2_box2_target_y;
MCNUM mccchannel_12_cave2_box2_target_z;
MCNUM mccchannel_12_cave2_box2_focus_aw;
MCNUM mccchannel_12_cave2_box2_focus_ah;
MCNUM mccchannel_12_cave2_box2_focus_xw;
MCNUM mccchannel_12_cave2_box2_focus_xh;
MCNUM mccchannel_12_cave2_box2_focus_r;
MCNUM mccchannel_12_cave2_box2_p_interact;
char mccchannel_12_cave2_box2_mask_string[16384];
char mccchannel_12_cave2_box2_mask_setting[16384];
MCNUM mccchannel_12_cave2_box2_number_of_activations;

/* Setting parameters for component 'channel_12_cave2_box3' [609]. */
char mccchannel_12_cave2_box3_material_string[16384];
MCNUM mccchannel_12_cave2_box3_priority;
MCNUM mccchannel_12_cave2_box3_xwidth;
MCNUM mccchannel_12_cave2_box3_yheight;
MCNUM mccchannel_12_cave2_box3_zdepth;
MCNUM mccchannel_12_cave2_box3_xwidth2;
MCNUM mccchannel_12_cave2_box3_yheight2;
MCNUM mccchannel_12_cave2_box3_visualize;
int mccchannel_12_cave2_box3_target_index;
MCNUM mccchannel_12_cave2_box3_target_x;
MCNUM mccchannel_12_cave2_box3_target_y;
MCNUM mccchannel_12_cave2_box3_target_z;
MCNUM mccchannel_12_cave2_box3_focus_aw;
MCNUM mccchannel_12_cave2_box3_focus_ah;
MCNUM mccchannel_12_cave2_box3_focus_xw;
MCNUM mccchannel_12_cave2_box3_focus_xh;
MCNUM mccchannel_12_cave2_box3_focus_r;
MCNUM mccchannel_12_cave2_box3_p_interact;
char mccchannel_12_cave2_box3_mask_string[16384];
char mccchannel_12_cave2_box3_mask_setting[16384];
MCNUM mccchannel_12_cave2_box3_number_of_activations;

/* Setting parameters for component 'inter_analyzer_colimator_12_blade_0' [611]. */
char mccinter_analyzer_colimator_12_blade_0_material_string[16384];
MCNUM mccinter_analyzer_colimator_12_blade_0_priority;
MCNUM mccinter_analyzer_colimator_12_blade_0_xwidth;
MCNUM mccinter_analyzer_colimator_12_blade_0_yheight;
MCNUM mccinter_analyzer_colimator_12_blade_0_zdepth;
MCNUM mccinter_analyzer_colimator_12_blade_0_xwidth2;
MCNUM mccinter_analyzer_colimator_12_blade_0_yheight2;
MCNUM mccinter_analyzer_colimator_12_blade_0_visualize;
int mccinter_analyzer_colimator_12_blade_0_target_index;
MCNUM mccinter_analyzer_colimator_12_blade_0_target_x;
MCNUM mccinter_analyzer_colimator_12_blade_0_target_y;
MCNUM mccinter_analyzer_colimator_12_blade_0_target_z;
MCNUM mccinter_analyzer_colimator_12_blade_0_focus_aw;
MCNUM mccinter_analyzer_colimator_12_blade_0_focus_ah;
MCNUM mccinter_analyzer_colimator_12_blade_0_focus_xw;
MCNUM mccinter_analyzer_colimator_12_blade_0_focus_xh;
MCNUM mccinter_analyzer_colimator_12_blade_0_focus_r;
MCNUM mccinter_analyzer_colimator_12_blade_0_p_interact;
char mccinter_analyzer_colimator_12_blade_0_mask_string[16384];
char mccinter_analyzer_colimator_12_blade_0_mask_setting[16384];
MCNUM mccinter_analyzer_colimator_12_blade_0_number_of_activations;

/* Setting parameters for component 'inter_analyzer_colimator_12_blade_1' [612]. */
char mccinter_analyzer_colimator_12_blade_1_material_string[16384];
MCNUM mccinter_analyzer_colimator_12_blade_1_priority;
MCNUM mccinter_analyzer_colimator_12_blade_1_xwidth;
MCNUM mccinter_analyzer_colimator_12_blade_1_yheight;
MCNUM mccinter_analyzer_colimator_12_blade_1_zdepth;
MCNUM mccinter_analyzer_colimator_12_blade_1_xwidth2;
MCNUM mccinter_analyzer_colimator_12_blade_1_yheight2;
MCNUM mccinter_analyzer_colimator_12_blade_1_visualize;
int mccinter_analyzer_colimator_12_blade_1_target_index;
MCNUM mccinter_analyzer_colimator_12_blade_1_target_x;
MCNUM mccinter_analyzer_colimator_12_blade_1_target_y;
MCNUM mccinter_analyzer_colimator_12_blade_1_target_z;
MCNUM mccinter_analyzer_colimator_12_blade_1_focus_aw;
MCNUM mccinter_analyzer_colimator_12_blade_1_focus_ah;
MCNUM mccinter_analyzer_colimator_12_blade_1_focus_xw;
MCNUM mccinter_analyzer_colimator_12_blade_1_focus_xh;
MCNUM mccinter_analyzer_colimator_12_blade_1_focus_r;
MCNUM mccinter_analyzer_colimator_12_blade_1_p_interact;
char mccinter_analyzer_colimator_12_blade_1_mask_string[16384];
char mccinter_analyzer_colimator_12_blade_1_mask_setting[16384];
MCNUM mccinter_analyzer_colimator_12_blade_1_number_of_activations;

/* Setting parameters for component 'inter_analyzer_colimator_12_blade_2' [613]. */
char mccinter_analyzer_colimator_12_blade_2_material_string[16384];
MCNUM mccinter_analyzer_colimator_12_blade_2_priority;
MCNUM mccinter_analyzer_colimator_12_blade_2_xwidth;
MCNUM mccinter_analyzer_colimator_12_blade_2_yheight;
MCNUM mccinter_analyzer_colimator_12_blade_2_zdepth;
MCNUM mccinter_analyzer_colimator_12_blade_2_xwidth2;
MCNUM mccinter_analyzer_colimator_12_blade_2_yheight2;
MCNUM mccinter_analyzer_colimator_12_blade_2_visualize;
int mccinter_analyzer_colimator_12_blade_2_target_index;
MCNUM mccinter_analyzer_colimator_12_blade_2_target_x;
MCNUM mccinter_analyzer_colimator_12_blade_2_target_y;
MCNUM mccinter_analyzer_colimator_12_blade_2_target_z;
MCNUM mccinter_analyzer_colimator_12_blade_2_focus_aw;
MCNUM mccinter_analyzer_colimator_12_blade_2_focus_ah;
MCNUM mccinter_analyzer_colimator_12_blade_2_focus_xw;
MCNUM mccinter_analyzer_colimator_12_blade_2_focus_xh;
MCNUM mccinter_analyzer_colimator_12_blade_2_focus_r;
MCNUM mccinter_analyzer_colimator_12_blade_2_p_interact;
char mccinter_analyzer_colimator_12_blade_2_mask_string[16384];
char mccinter_analyzer_colimator_12_blade_2_mask_setting[16384];
MCNUM mccinter_analyzer_colimator_12_blade_2_number_of_activations;

/* Setting parameters for component 'inter_analyzer_colimator_12_blade_3' [614]. */
char mccinter_analyzer_colimator_12_blade_3_material_string[16384];
MCNUM mccinter_analyzer_colimator_12_blade_3_priority;
MCNUM mccinter_analyzer_colimator_12_blade_3_xwidth;
MCNUM mccinter_analyzer_colimator_12_blade_3_yheight;
MCNUM mccinter_analyzer_colimator_12_blade_3_zdepth;
MCNUM mccinter_analyzer_colimator_12_blade_3_xwidth2;
MCNUM mccinter_analyzer_colimator_12_blade_3_yheight2;
MCNUM mccinter_analyzer_colimator_12_blade_3_visualize;
int mccinter_analyzer_colimator_12_blade_3_target_index;
MCNUM mccinter_analyzer_colimator_12_blade_3_target_x;
MCNUM mccinter_analyzer_colimator_12_blade_3_target_y;
MCNUM mccinter_analyzer_colimator_12_blade_3_target_z;
MCNUM mccinter_analyzer_colimator_12_blade_3_focus_aw;
MCNUM mccinter_analyzer_colimator_12_blade_3_focus_ah;
MCNUM mccinter_analyzer_colimator_12_blade_3_focus_xw;
MCNUM mccinter_analyzer_colimator_12_blade_3_focus_xh;
MCNUM mccinter_analyzer_colimator_12_blade_3_focus_r;
MCNUM mccinter_analyzer_colimator_12_blade_3_p_interact;
char mccinter_analyzer_colimator_12_blade_3_mask_string[16384];
char mccinter_analyzer_colimator_12_blade_3_mask_setting[16384];
MCNUM mccinter_analyzer_colimator_12_blade_3_number_of_activations;

/* Setting parameters for component 'inter_analyzer_colimator_12_blade_4' [615]. */
char mccinter_analyzer_colimator_12_blade_4_material_string[16384];
MCNUM mccinter_analyzer_colimator_12_blade_4_priority;
MCNUM mccinter_analyzer_colimator_12_blade_4_xwidth;
MCNUM mccinter_analyzer_colimator_12_blade_4_yheight;
MCNUM mccinter_analyzer_colimator_12_blade_4_zdepth;
MCNUM mccinter_analyzer_colimator_12_blade_4_xwidth2;
MCNUM mccinter_analyzer_colimator_12_blade_4_yheight2;
MCNUM mccinter_analyzer_colimator_12_blade_4_visualize;
int mccinter_analyzer_colimator_12_blade_4_target_index;
MCNUM mccinter_analyzer_colimator_12_blade_4_target_x;
MCNUM mccinter_analyzer_colimator_12_blade_4_target_y;
MCNUM mccinter_analyzer_colimator_12_blade_4_target_z;
MCNUM mccinter_analyzer_colimator_12_blade_4_focus_aw;
MCNUM mccinter_analyzer_colimator_12_blade_4_focus_ah;
MCNUM mccinter_analyzer_colimator_12_blade_4_focus_xw;
MCNUM mccinter_analyzer_colimator_12_blade_4_focus_xh;
MCNUM mccinter_analyzer_colimator_12_blade_4_focus_r;
MCNUM mccinter_analyzer_colimator_12_blade_4_p_interact;
char mccinter_analyzer_colimator_12_blade_4_mask_string[16384];
char mccinter_analyzer_colimator_12_blade_4_mask_setting[16384];
MCNUM mccinter_analyzer_colimator_12_blade_4_number_of_activations;

/* Setting parameters for component 'diffraction_detector_12_exit_volume' [616]. */
char mccdiffraction_detector_12_exit_volume_material_string[16384];
MCNUM mccdiffraction_detector_12_exit_volume_priority;
MCNUM mccdiffraction_detector_12_exit_volume_xwidth;
MCNUM mccdiffraction_detector_12_exit_volume_yheight;
MCNUM mccdiffraction_detector_12_exit_volume_zdepth;
MCNUM mccdiffraction_detector_12_exit_volume_xwidth2;
MCNUM mccdiffraction_detector_12_exit_volume_yheight2;
MCNUM mccdiffraction_detector_12_exit_volume_visualize;
int mccdiffraction_detector_12_exit_volume_target_index;
MCNUM mccdiffraction_detector_12_exit_volume_target_x;
MCNUM mccdiffraction_detector_12_exit_volume_target_y;
MCNUM mccdiffraction_detector_12_exit_volume_target_z;
MCNUM mccdiffraction_detector_12_exit_volume_focus_aw;
MCNUM mccdiffraction_detector_12_exit_volume_focus_ah;
MCNUM mccdiffraction_detector_12_exit_volume_focus_xw;
MCNUM mccdiffraction_detector_12_exit_volume_focus_xh;
MCNUM mccdiffraction_detector_12_exit_volume_focus_r;
MCNUM mccdiffraction_detector_12_exit_volume_p_interact;
char mccdiffraction_detector_12_exit_volume_mask_string[16384];
char mccdiffraction_detector_12_exit_volume_mask_setting[16384];
MCNUM mccdiffraction_detector_12_exit_volume_number_of_activations;

/* Setting parameters for component 'spec_detector_12_exit_volume' [617]. */
char mccspec_detector_12_exit_volume_material_string[16384];
MCNUM mccspec_detector_12_exit_volume_priority;
MCNUM mccspec_detector_12_exit_volume_xwidth;
MCNUM mccspec_detector_12_exit_volume_yheight;
MCNUM mccspec_detector_12_exit_volume_zdepth;
MCNUM mccspec_detector_12_exit_volume_xwidth2;
MCNUM mccspec_detector_12_exit_volume_yheight2;
MCNUM mccspec_detector_12_exit_volume_visualize;
int mccspec_detector_12_exit_volume_target_index;
MCNUM mccspec_detector_12_exit_volume_target_x;
MCNUM mccspec_detector_12_exit_volume_target_y;
MCNUM mccspec_detector_12_exit_volume_target_z;
MCNUM mccspec_detector_12_exit_volume_focus_aw;
MCNUM mccspec_detector_12_exit_volume_focus_ah;
MCNUM mccspec_detector_12_exit_volume_focus_xw;
MCNUM mccspec_detector_12_exit_volume_focus_xh;
MCNUM mccspec_detector_12_exit_volume_focus_r;
MCNUM mccspec_detector_12_exit_volume_p_interact;
char mccspec_detector_12_exit_volume_mask_string[16384];
char mccspec_detector_12_exit_volume_mask_setting[16384];
MCNUM mccspec_detector_12_exit_volume_number_of_activations;

/* Setting parameters for component 'channel_13_cave1_box1' [618]. */
char mccchannel_13_cave1_box1_material_string[16384];
MCNUM mccchannel_13_cave1_box1_priority;
MCNUM mccchannel_13_cave1_box1_xwidth;
MCNUM mccchannel_13_cave1_box1_yheight;
MCNUM mccchannel_13_cave1_box1_zdepth;
MCNUM mccchannel_13_cave1_box1_xwidth2;
MCNUM mccchannel_13_cave1_box1_yheight2;
MCNUM mccchannel_13_cave1_box1_visualize;
int mccchannel_13_cave1_box1_target_index;
MCNUM mccchannel_13_cave1_box1_target_x;
MCNUM mccchannel_13_cave1_box1_target_y;
MCNUM mccchannel_13_cave1_box1_target_z;
MCNUM mccchannel_13_cave1_box1_focus_aw;
MCNUM mccchannel_13_cave1_box1_focus_ah;
MCNUM mccchannel_13_cave1_box1_focus_xw;
MCNUM mccchannel_13_cave1_box1_focus_xh;
MCNUM mccchannel_13_cave1_box1_focus_r;
MCNUM mccchannel_13_cave1_box1_p_interact;
char mccchannel_13_cave1_box1_mask_string[16384];
char mccchannel_13_cave1_box1_mask_setting[16384];
MCNUM mccchannel_13_cave1_box1_number_of_activations;

/* Setting parameters for component 'channel_13_cave1_box2' [619]. */
char mccchannel_13_cave1_box2_material_string[16384];
MCNUM mccchannel_13_cave1_box2_priority;
MCNUM mccchannel_13_cave1_box2_xwidth;
MCNUM mccchannel_13_cave1_box2_yheight;
MCNUM mccchannel_13_cave1_box2_zdepth;
MCNUM mccchannel_13_cave1_box2_xwidth2;
MCNUM mccchannel_13_cave1_box2_yheight2;
MCNUM mccchannel_13_cave1_box2_visualize;
int mccchannel_13_cave1_box2_target_index;
MCNUM mccchannel_13_cave1_box2_target_x;
MCNUM mccchannel_13_cave1_box2_target_y;
MCNUM mccchannel_13_cave1_box2_target_z;
MCNUM mccchannel_13_cave1_box2_focus_aw;
MCNUM mccchannel_13_cave1_box2_focus_ah;
MCNUM mccchannel_13_cave1_box2_focus_xw;
MCNUM mccchannel_13_cave1_box2_focus_xh;
MCNUM mccchannel_13_cave1_box2_focus_r;
MCNUM mccchannel_13_cave1_box2_p_interact;
char mccchannel_13_cave1_box2_mask_string[16384];
char mccchannel_13_cave1_box2_mask_setting[16384];
MCNUM mccchannel_13_cave1_box2_number_of_activations;

/* Setting parameters for component 'channel_13_cave1_box3' [620]. */
char mccchannel_13_cave1_box3_material_string[16384];
MCNUM mccchannel_13_cave1_box3_priority;
MCNUM mccchannel_13_cave1_box3_xwidth;
MCNUM mccchannel_13_cave1_box3_yheight;
MCNUM mccchannel_13_cave1_box3_zdepth;
MCNUM mccchannel_13_cave1_box3_xwidth2;
MCNUM mccchannel_13_cave1_box3_yheight2;
MCNUM mccchannel_13_cave1_box3_visualize;
int mccchannel_13_cave1_box3_target_index;
MCNUM mccchannel_13_cave1_box3_target_x;
MCNUM mccchannel_13_cave1_box3_target_y;
MCNUM mccchannel_13_cave1_box3_target_z;
MCNUM mccchannel_13_cave1_box3_focus_aw;
MCNUM mccchannel_13_cave1_box3_focus_ah;
MCNUM mccchannel_13_cave1_box3_focus_xw;
MCNUM mccchannel_13_cave1_box3_focus_xh;
MCNUM mccchannel_13_cave1_box3_focus_r;
MCNUM mccchannel_13_cave1_box3_p_interact;
char mccchannel_13_cave1_box3_mask_string[16384];
char mccchannel_13_cave1_box3_mask_setting[16384];
MCNUM mccchannel_13_cave1_box3_number_of_activations;

/* Setting parameters for component 'channel_13_cave1_cyl1' [621]. */
char mccchannel_13_cave1_cyl1_material_string[16384];
MCNUM mccchannel_13_cave1_cyl1_priority;
MCNUM mccchannel_13_cave1_cyl1_radius;
MCNUM mccchannel_13_cave1_cyl1_yheight;
MCNUM mccchannel_13_cave1_cyl1_visualize;
int mccchannel_13_cave1_cyl1_target_index;
MCNUM mccchannel_13_cave1_cyl1_target_x;
MCNUM mccchannel_13_cave1_cyl1_target_y;
MCNUM mccchannel_13_cave1_cyl1_target_z;
MCNUM mccchannel_13_cave1_cyl1_focus_aw;
MCNUM mccchannel_13_cave1_cyl1_focus_ah;
MCNUM mccchannel_13_cave1_cyl1_focus_xw;
MCNUM mccchannel_13_cave1_cyl1_focus_xh;
MCNUM mccchannel_13_cave1_cyl1_focus_r;
MCNUM mccchannel_13_cave1_cyl1_p_interact;
char mccchannel_13_cave1_cyl1_mask_string[16384];
char mccchannel_13_cave1_cyl1_mask_setting[16384];
MCNUM mccchannel_13_cave1_cyl1_number_of_activations;

/* Setting parameters for component 'channel_13_analyzer_1_array_crystal_array_0' [624]. */
char mccchannel_13_analyzer_1_array_crystal_array_0_material_string[16384];
MCNUM mccchannel_13_analyzer_1_array_crystal_array_0_priority;
MCNUM mccchannel_13_analyzer_1_array_crystal_array_0_xwidth;
MCNUM mccchannel_13_analyzer_1_array_crystal_array_0_yheight;
MCNUM mccchannel_13_analyzer_1_array_crystal_array_0_zdepth;
MCNUM mccchannel_13_analyzer_1_array_crystal_array_0_xwidth2;
MCNUM mccchannel_13_analyzer_1_array_crystal_array_0_yheight2;
MCNUM mccchannel_13_analyzer_1_array_crystal_array_0_visualize;
int mccchannel_13_analyzer_1_array_crystal_array_0_target_index;
MCNUM mccchannel_13_analyzer_1_array_crystal_array_0_target_x;
MCNUM mccchannel_13_analyzer_1_array_crystal_array_0_target_y;
MCNUM mccchannel_13_analyzer_1_array_crystal_array_0_target_z;
MCNUM mccchannel_13_analyzer_1_array_crystal_array_0_focus_aw;
MCNUM mccchannel_13_analyzer_1_array_crystal_array_0_focus_ah;
MCNUM mccchannel_13_analyzer_1_array_crystal_array_0_focus_xw;
MCNUM mccchannel_13_analyzer_1_array_crystal_array_0_focus_xh;
MCNUM mccchannel_13_analyzer_1_array_crystal_array_0_focus_r;
MCNUM mccchannel_13_analyzer_1_array_crystal_array_0_p_interact;
char mccchannel_13_analyzer_1_array_crystal_array_0_mask_string[16384];
char mccchannel_13_analyzer_1_array_crystal_array_0_mask_setting[16384];
MCNUM mccchannel_13_analyzer_1_array_crystal_array_0_number_of_activations;

/* Setting parameters for component 'channel_13_analyzer_1_array_crystal_array_1' [625]. */
char mccchannel_13_analyzer_1_array_crystal_array_1_material_string[16384];
MCNUM mccchannel_13_analyzer_1_array_crystal_array_1_priority;
MCNUM mccchannel_13_analyzer_1_array_crystal_array_1_xwidth;
MCNUM mccchannel_13_analyzer_1_array_crystal_array_1_yheight;
MCNUM mccchannel_13_analyzer_1_array_crystal_array_1_zdepth;
MCNUM mccchannel_13_analyzer_1_array_crystal_array_1_xwidth2;
MCNUM mccchannel_13_analyzer_1_array_crystal_array_1_yheight2;
MCNUM mccchannel_13_analyzer_1_array_crystal_array_1_visualize;
int mccchannel_13_analyzer_1_array_crystal_array_1_target_index;
MCNUM mccchannel_13_analyzer_1_array_crystal_array_1_target_x;
MCNUM mccchannel_13_analyzer_1_array_crystal_array_1_target_y;
MCNUM mccchannel_13_analyzer_1_array_crystal_array_1_target_z;
MCNUM mccchannel_13_analyzer_1_array_crystal_array_1_focus_aw;
MCNUM mccchannel_13_analyzer_1_array_crystal_array_1_focus_ah;
MCNUM mccchannel_13_analyzer_1_array_crystal_array_1_focus_xw;
MCNUM mccchannel_13_analyzer_1_array_crystal_array_1_focus_xh;
MCNUM mccchannel_13_analyzer_1_array_crystal_array_1_focus_r;
MCNUM mccchannel_13_analyzer_1_array_crystal_array_1_p_interact;
char mccchannel_13_analyzer_1_array_crystal_array_1_mask_string[16384];
char mccchannel_13_analyzer_1_array_crystal_array_1_mask_setting[16384];
MCNUM mccchannel_13_analyzer_1_array_crystal_array_1_number_of_activations;

/* Setting parameters for component 'channel_13_analyzer_1_array_crystal_array_2' [626]. */
char mccchannel_13_analyzer_1_array_crystal_array_2_material_string[16384];
MCNUM mccchannel_13_analyzer_1_array_crystal_array_2_priority;
MCNUM mccchannel_13_analyzer_1_array_crystal_array_2_xwidth;
MCNUM mccchannel_13_analyzer_1_array_crystal_array_2_yheight;
MCNUM mccchannel_13_analyzer_1_array_crystal_array_2_zdepth;
MCNUM mccchannel_13_analyzer_1_array_crystal_array_2_xwidth2;
MCNUM mccchannel_13_analyzer_1_array_crystal_array_2_yheight2;
MCNUM mccchannel_13_analyzer_1_array_crystal_array_2_visualize;
int mccchannel_13_analyzer_1_array_crystal_array_2_target_index;
MCNUM mccchannel_13_analyzer_1_array_crystal_array_2_target_x;
MCNUM mccchannel_13_analyzer_1_array_crystal_array_2_target_y;
MCNUM mccchannel_13_analyzer_1_array_crystal_array_2_target_z;
MCNUM mccchannel_13_analyzer_1_array_crystal_array_2_focus_aw;
MCNUM mccchannel_13_analyzer_1_array_crystal_array_2_focus_ah;
MCNUM mccchannel_13_analyzer_1_array_crystal_array_2_focus_xw;
MCNUM mccchannel_13_analyzer_1_array_crystal_array_2_focus_xh;
MCNUM mccchannel_13_analyzer_1_array_crystal_array_2_focus_r;
MCNUM mccchannel_13_analyzer_1_array_crystal_array_2_p_interact;
char mccchannel_13_analyzer_1_array_crystal_array_2_mask_string[16384];
char mccchannel_13_analyzer_1_array_crystal_array_2_mask_setting[16384];
MCNUM mccchannel_13_analyzer_1_array_crystal_array_2_number_of_activations;

/* Setting parameters for component 'channel_13_analyzer_1_array_crystal_array_3' [627]. */
char mccchannel_13_analyzer_1_array_crystal_array_3_material_string[16384];
MCNUM mccchannel_13_analyzer_1_array_crystal_array_3_priority;
MCNUM mccchannel_13_analyzer_1_array_crystal_array_3_xwidth;
MCNUM mccchannel_13_analyzer_1_array_crystal_array_3_yheight;
MCNUM mccchannel_13_analyzer_1_array_crystal_array_3_zdepth;
MCNUM mccchannel_13_analyzer_1_array_crystal_array_3_xwidth2;
MCNUM mccchannel_13_analyzer_1_array_crystal_array_3_yheight2;
MCNUM mccchannel_13_analyzer_1_array_crystal_array_3_visualize;
int mccchannel_13_analyzer_1_array_crystal_array_3_target_index;
MCNUM mccchannel_13_analyzer_1_array_crystal_array_3_target_x;
MCNUM mccchannel_13_analyzer_1_array_crystal_array_3_target_y;
MCNUM mccchannel_13_analyzer_1_array_crystal_array_3_target_z;
MCNUM mccchannel_13_analyzer_1_array_crystal_array_3_focus_aw;
MCNUM mccchannel_13_analyzer_1_array_crystal_array_3_focus_ah;
MCNUM mccchannel_13_analyzer_1_array_crystal_array_3_focus_xw;
MCNUM mccchannel_13_analyzer_1_array_crystal_array_3_focus_xh;
MCNUM mccchannel_13_analyzer_1_array_crystal_array_3_focus_r;
MCNUM mccchannel_13_analyzer_1_array_crystal_array_3_p_interact;
char mccchannel_13_analyzer_1_array_crystal_array_3_mask_string[16384];
char mccchannel_13_analyzer_1_array_crystal_array_3_mask_setting[16384];
MCNUM mccchannel_13_analyzer_1_array_crystal_array_3_number_of_activations;

/* Setting parameters for component 'channel_13_analyzer_1_array_crystal_array_4' [628]. */
char mccchannel_13_analyzer_1_array_crystal_array_4_material_string[16384];
MCNUM mccchannel_13_analyzer_1_array_crystal_array_4_priority;
MCNUM mccchannel_13_analyzer_1_array_crystal_array_4_xwidth;
MCNUM mccchannel_13_analyzer_1_array_crystal_array_4_yheight;
MCNUM mccchannel_13_analyzer_1_array_crystal_array_4_zdepth;
MCNUM mccchannel_13_analyzer_1_array_crystal_array_4_xwidth2;
MCNUM mccchannel_13_analyzer_1_array_crystal_array_4_yheight2;
MCNUM mccchannel_13_analyzer_1_array_crystal_array_4_visualize;
int mccchannel_13_analyzer_1_array_crystal_array_4_target_index;
MCNUM mccchannel_13_analyzer_1_array_crystal_array_4_target_x;
MCNUM mccchannel_13_analyzer_1_array_crystal_array_4_target_y;
MCNUM mccchannel_13_analyzer_1_array_crystal_array_4_target_z;
MCNUM mccchannel_13_analyzer_1_array_crystal_array_4_focus_aw;
MCNUM mccchannel_13_analyzer_1_array_crystal_array_4_focus_ah;
MCNUM mccchannel_13_analyzer_1_array_crystal_array_4_focus_xw;
MCNUM mccchannel_13_analyzer_1_array_crystal_array_4_focus_xh;
MCNUM mccchannel_13_analyzer_1_array_crystal_array_4_focus_r;
MCNUM mccchannel_13_analyzer_1_array_crystal_array_4_p_interact;
char mccchannel_13_analyzer_1_array_crystal_array_4_mask_string[16384];
char mccchannel_13_analyzer_1_array_crystal_array_4_mask_setting[16384];
MCNUM mccchannel_13_analyzer_1_array_crystal_array_4_number_of_activations;

/* Setting parameters for component 'channel_13_analyzer_1_array_crystal_array_5' [629]. */
char mccchannel_13_analyzer_1_array_crystal_array_5_material_string[16384];
MCNUM mccchannel_13_analyzer_1_array_crystal_array_5_priority;
MCNUM mccchannel_13_analyzer_1_array_crystal_array_5_xwidth;
MCNUM mccchannel_13_analyzer_1_array_crystal_array_5_yheight;
MCNUM mccchannel_13_analyzer_1_array_crystal_array_5_zdepth;
MCNUM mccchannel_13_analyzer_1_array_crystal_array_5_xwidth2;
MCNUM mccchannel_13_analyzer_1_array_crystal_array_5_yheight2;
MCNUM mccchannel_13_analyzer_1_array_crystal_array_5_visualize;
int mccchannel_13_analyzer_1_array_crystal_array_5_target_index;
MCNUM mccchannel_13_analyzer_1_array_crystal_array_5_target_x;
MCNUM mccchannel_13_analyzer_1_array_crystal_array_5_target_y;
MCNUM mccchannel_13_analyzer_1_array_crystal_array_5_target_z;
MCNUM mccchannel_13_analyzer_1_array_crystal_array_5_focus_aw;
MCNUM mccchannel_13_analyzer_1_array_crystal_array_5_focus_ah;
MCNUM mccchannel_13_analyzer_1_array_crystal_array_5_focus_xw;
MCNUM mccchannel_13_analyzer_1_array_crystal_array_5_focus_xh;
MCNUM mccchannel_13_analyzer_1_array_crystal_array_5_focus_r;
MCNUM mccchannel_13_analyzer_1_array_crystal_array_5_p_interact;
char mccchannel_13_analyzer_1_array_crystal_array_5_mask_string[16384];
char mccchannel_13_analyzer_1_array_crystal_array_5_mask_setting[16384];
MCNUM mccchannel_13_analyzer_1_array_crystal_array_5_number_of_activations;

/* Setting parameters for component 'channel_13_analyzer_1_array_crystal_array_6' [630]. */
char mccchannel_13_analyzer_1_array_crystal_array_6_material_string[16384];
MCNUM mccchannel_13_analyzer_1_array_crystal_array_6_priority;
MCNUM mccchannel_13_analyzer_1_array_crystal_array_6_xwidth;
MCNUM mccchannel_13_analyzer_1_array_crystal_array_6_yheight;
MCNUM mccchannel_13_analyzer_1_array_crystal_array_6_zdepth;
MCNUM mccchannel_13_analyzer_1_array_crystal_array_6_xwidth2;
MCNUM mccchannel_13_analyzer_1_array_crystal_array_6_yheight2;
MCNUM mccchannel_13_analyzer_1_array_crystal_array_6_visualize;
int mccchannel_13_analyzer_1_array_crystal_array_6_target_index;
MCNUM mccchannel_13_analyzer_1_array_crystal_array_6_target_x;
MCNUM mccchannel_13_analyzer_1_array_crystal_array_6_target_y;
MCNUM mccchannel_13_analyzer_1_array_crystal_array_6_target_z;
MCNUM mccchannel_13_analyzer_1_array_crystal_array_6_focus_aw;
MCNUM mccchannel_13_analyzer_1_array_crystal_array_6_focus_ah;
MCNUM mccchannel_13_analyzer_1_array_crystal_array_6_focus_xw;
MCNUM mccchannel_13_analyzer_1_array_crystal_array_6_focus_xh;
MCNUM mccchannel_13_analyzer_1_array_crystal_array_6_focus_r;
MCNUM mccchannel_13_analyzer_1_array_crystal_array_6_p_interact;
char mccchannel_13_analyzer_1_array_crystal_array_6_mask_string[16384];
char mccchannel_13_analyzer_1_array_crystal_array_6_mask_setting[16384];
MCNUM mccchannel_13_analyzer_1_array_crystal_array_6_number_of_activations;

/* Setting parameters for component 'channel_13_analyzer_1_array_crystal_array_7' [631]. */
char mccchannel_13_analyzer_1_array_crystal_array_7_material_string[16384];
MCNUM mccchannel_13_analyzer_1_array_crystal_array_7_priority;
MCNUM mccchannel_13_analyzer_1_array_crystal_array_7_xwidth;
MCNUM mccchannel_13_analyzer_1_array_crystal_array_7_yheight;
MCNUM mccchannel_13_analyzer_1_array_crystal_array_7_zdepth;
MCNUM mccchannel_13_analyzer_1_array_crystal_array_7_xwidth2;
MCNUM mccchannel_13_analyzer_1_array_crystal_array_7_yheight2;
MCNUM mccchannel_13_analyzer_1_array_crystal_array_7_visualize;
int mccchannel_13_analyzer_1_array_crystal_array_7_target_index;
MCNUM mccchannel_13_analyzer_1_array_crystal_array_7_target_x;
MCNUM mccchannel_13_analyzer_1_array_crystal_array_7_target_y;
MCNUM mccchannel_13_analyzer_1_array_crystal_array_7_target_z;
MCNUM mccchannel_13_analyzer_1_array_crystal_array_7_focus_aw;
MCNUM mccchannel_13_analyzer_1_array_crystal_array_7_focus_ah;
MCNUM mccchannel_13_analyzer_1_array_crystal_array_7_focus_xw;
MCNUM mccchannel_13_analyzer_1_array_crystal_array_7_focus_xh;
MCNUM mccchannel_13_analyzer_1_array_crystal_array_7_focus_r;
MCNUM mccchannel_13_analyzer_1_array_crystal_array_7_p_interact;
char mccchannel_13_analyzer_1_array_crystal_array_7_mask_string[16384];
char mccchannel_13_analyzer_1_array_crystal_array_7_mask_setting[16384];
MCNUM mccchannel_13_analyzer_1_array_crystal_array_7_number_of_activations;

/* Setting parameters for component 'channel_13_analyzer_1_array_crystal_array_8' [632]. */
char mccchannel_13_analyzer_1_array_crystal_array_8_material_string[16384];
MCNUM mccchannel_13_analyzer_1_array_crystal_array_8_priority;
MCNUM mccchannel_13_analyzer_1_array_crystal_array_8_xwidth;
MCNUM mccchannel_13_analyzer_1_array_crystal_array_8_yheight;
MCNUM mccchannel_13_analyzer_1_array_crystal_array_8_zdepth;
MCNUM mccchannel_13_analyzer_1_array_crystal_array_8_xwidth2;
MCNUM mccchannel_13_analyzer_1_array_crystal_array_8_yheight2;
MCNUM mccchannel_13_analyzer_1_array_crystal_array_8_visualize;
int mccchannel_13_analyzer_1_array_crystal_array_8_target_index;
MCNUM mccchannel_13_analyzer_1_array_crystal_array_8_target_x;
MCNUM mccchannel_13_analyzer_1_array_crystal_array_8_target_y;
MCNUM mccchannel_13_analyzer_1_array_crystal_array_8_target_z;
MCNUM mccchannel_13_analyzer_1_array_crystal_array_8_focus_aw;
MCNUM mccchannel_13_analyzer_1_array_crystal_array_8_focus_ah;
MCNUM mccchannel_13_analyzer_1_array_crystal_array_8_focus_xw;
MCNUM mccchannel_13_analyzer_1_array_crystal_array_8_focus_xh;
MCNUM mccchannel_13_analyzer_1_array_crystal_array_8_focus_r;
MCNUM mccchannel_13_analyzer_1_array_crystal_array_8_p_interact;
char mccchannel_13_analyzer_1_array_crystal_array_8_mask_string[16384];
char mccchannel_13_analyzer_1_array_crystal_array_8_mask_setting[16384];
MCNUM mccchannel_13_analyzer_1_array_crystal_array_8_number_of_activations;

/* Setting parameters for component 'channel_13_analyzer_2_array_crystal_array_0' [635]. */
char mccchannel_13_analyzer_2_array_crystal_array_0_material_string[16384];
MCNUM mccchannel_13_analyzer_2_array_crystal_array_0_priority;
MCNUM mccchannel_13_analyzer_2_array_crystal_array_0_xwidth;
MCNUM mccchannel_13_analyzer_2_array_crystal_array_0_yheight;
MCNUM mccchannel_13_analyzer_2_array_crystal_array_0_zdepth;
MCNUM mccchannel_13_analyzer_2_array_crystal_array_0_xwidth2;
MCNUM mccchannel_13_analyzer_2_array_crystal_array_0_yheight2;
MCNUM mccchannel_13_analyzer_2_array_crystal_array_0_visualize;
int mccchannel_13_analyzer_2_array_crystal_array_0_target_index;
MCNUM mccchannel_13_analyzer_2_array_crystal_array_0_target_x;
MCNUM mccchannel_13_analyzer_2_array_crystal_array_0_target_y;
MCNUM mccchannel_13_analyzer_2_array_crystal_array_0_target_z;
MCNUM mccchannel_13_analyzer_2_array_crystal_array_0_focus_aw;
MCNUM mccchannel_13_analyzer_2_array_crystal_array_0_focus_ah;
MCNUM mccchannel_13_analyzer_2_array_crystal_array_0_focus_xw;
MCNUM mccchannel_13_analyzer_2_array_crystal_array_0_focus_xh;
MCNUM mccchannel_13_analyzer_2_array_crystal_array_0_focus_r;
MCNUM mccchannel_13_analyzer_2_array_crystal_array_0_p_interact;
char mccchannel_13_analyzer_2_array_crystal_array_0_mask_string[16384];
char mccchannel_13_analyzer_2_array_crystal_array_0_mask_setting[16384];
MCNUM mccchannel_13_analyzer_2_array_crystal_array_0_number_of_activations;

/* Setting parameters for component 'channel_13_analyzer_2_array_crystal_array_1' [636]. */
char mccchannel_13_analyzer_2_array_crystal_array_1_material_string[16384];
MCNUM mccchannel_13_analyzer_2_array_crystal_array_1_priority;
MCNUM mccchannel_13_analyzer_2_array_crystal_array_1_xwidth;
MCNUM mccchannel_13_analyzer_2_array_crystal_array_1_yheight;
MCNUM mccchannel_13_analyzer_2_array_crystal_array_1_zdepth;
MCNUM mccchannel_13_analyzer_2_array_crystal_array_1_xwidth2;
MCNUM mccchannel_13_analyzer_2_array_crystal_array_1_yheight2;
MCNUM mccchannel_13_analyzer_2_array_crystal_array_1_visualize;
int mccchannel_13_analyzer_2_array_crystal_array_1_target_index;
MCNUM mccchannel_13_analyzer_2_array_crystal_array_1_target_x;
MCNUM mccchannel_13_analyzer_2_array_crystal_array_1_target_y;
MCNUM mccchannel_13_analyzer_2_array_crystal_array_1_target_z;
MCNUM mccchannel_13_analyzer_2_array_crystal_array_1_focus_aw;
MCNUM mccchannel_13_analyzer_2_array_crystal_array_1_focus_ah;
MCNUM mccchannel_13_analyzer_2_array_crystal_array_1_focus_xw;
MCNUM mccchannel_13_analyzer_2_array_crystal_array_1_focus_xh;
MCNUM mccchannel_13_analyzer_2_array_crystal_array_1_focus_r;
MCNUM mccchannel_13_analyzer_2_array_crystal_array_1_p_interact;
char mccchannel_13_analyzer_2_array_crystal_array_1_mask_string[16384];
char mccchannel_13_analyzer_2_array_crystal_array_1_mask_setting[16384];
MCNUM mccchannel_13_analyzer_2_array_crystal_array_1_number_of_activations;

/* Setting parameters for component 'channel_13_analyzer_2_array_crystal_array_2' [637]. */
char mccchannel_13_analyzer_2_array_crystal_array_2_material_string[16384];
MCNUM mccchannel_13_analyzer_2_array_crystal_array_2_priority;
MCNUM mccchannel_13_analyzer_2_array_crystal_array_2_xwidth;
MCNUM mccchannel_13_analyzer_2_array_crystal_array_2_yheight;
MCNUM mccchannel_13_analyzer_2_array_crystal_array_2_zdepth;
MCNUM mccchannel_13_analyzer_2_array_crystal_array_2_xwidth2;
MCNUM mccchannel_13_analyzer_2_array_crystal_array_2_yheight2;
MCNUM mccchannel_13_analyzer_2_array_crystal_array_2_visualize;
int mccchannel_13_analyzer_2_array_crystal_array_2_target_index;
MCNUM mccchannel_13_analyzer_2_array_crystal_array_2_target_x;
MCNUM mccchannel_13_analyzer_2_array_crystal_array_2_target_y;
MCNUM mccchannel_13_analyzer_2_array_crystal_array_2_target_z;
MCNUM mccchannel_13_analyzer_2_array_crystal_array_2_focus_aw;
MCNUM mccchannel_13_analyzer_2_array_crystal_array_2_focus_ah;
MCNUM mccchannel_13_analyzer_2_array_crystal_array_2_focus_xw;
MCNUM mccchannel_13_analyzer_2_array_crystal_array_2_focus_xh;
MCNUM mccchannel_13_analyzer_2_array_crystal_array_2_focus_r;
MCNUM mccchannel_13_analyzer_2_array_crystal_array_2_p_interact;
char mccchannel_13_analyzer_2_array_crystal_array_2_mask_string[16384];
char mccchannel_13_analyzer_2_array_crystal_array_2_mask_setting[16384];
MCNUM mccchannel_13_analyzer_2_array_crystal_array_2_number_of_activations;

/* Setting parameters for component 'channel_13_analyzer_2_array_crystal_array_3' [638]. */
char mccchannel_13_analyzer_2_array_crystal_array_3_material_string[16384];
MCNUM mccchannel_13_analyzer_2_array_crystal_array_3_priority;
MCNUM mccchannel_13_analyzer_2_array_crystal_array_3_xwidth;
MCNUM mccchannel_13_analyzer_2_array_crystal_array_3_yheight;
MCNUM mccchannel_13_analyzer_2_array_crystal_array_3_zdepth;
MCNUM mccchannel_13_analyzer_2_array_crystal_array_3_xwidth2;
MCNUM mccchannel_13_analyzer_2_array_crystal_array_3_yheight2;
MCNUM mccchannel_13_analyzer_2_array_crystal_array_3_visualize;
int mccchannel_13_analyzer_2_array_crystal_array_3_target_index;
MCNUM mccchannel_13_analyzer_2_array_crystal_array_3_target_x;
MCNUM mccchannel_13_analyzer_2_array_crystal_array_3_target_y;
MCNUM mccchannel_13_analyzer_2_array_crystal_array_3_target_z;
MCNUM mccchannel_13_analyzer_2_array_crystal_array_3_focus_aw;
MCNUM mccchannel_13_analyzer_2_array_crystal_array_3_focus_ah;
MCNUM mccchannel_13_analyzer_2_array_crystal_array_3_focus_xw;
MCNUM mccchannel_13_analyzer_2_array_crystal_array_3_focus_xh;
MCNUM mccchannel_13_analyzer_2_array_crystal_array_3_focus_r;
MCNUM mccchannel_13_analyzer_2_array_crystal_array_3_p_interact;
char mccchannel_13_analyzer_2_array_crystal_array_3_mask_string[16384];
char mccchannel_13_analyzer_2_array_crystal_array_3_mask_setting[16384];
MCNUM mccchannel_13_analyzer_2_array_crystal_array_3_number_of_activations;

/* Setting parameters for component 'channel_13_analyzer_2_array_crystal_array_4' [639]. */
char mccchannel_13_analyzer_2_array_crystal_array_4_material_string[16384];
MCNUM mccchannel_13_analyzer_2_array_crystal_array_4_priority;
MCNUM mccchannel_13_analyzer_2_array_crystal_array_4_xwidth;
MCNUM mccchannel_13_analyzer_2_array_crystal_array_4_yheight;
MCNUM mccchannel_13_analyzer_2_array_crystal_array_4_zdepth;
MCNUM mccchannel_13_analyzer_2_array_crystal_array_4_xwidth2;
MCNUM mccchannel_13_analyzer_2_array_crystal_array_4_yheight2;
MCNUM mccchannel_13_analyzer_2_array_crystal_array_4_visualize;
int mccchannel_13_analyzer_2_array_crystal_array_4_target_index;
MCNUM mccchannel_13_analyzer_2_array_crystal_array_4_target_x;
MCNUM mccchannel_13_analyzer_2_array_crystal_array_4_target_y;
MCNUM mccchannel_13_analyzer_2_array_crystal_array_4_target_z;
MCNUM mccchannel_13_analyzer_2_array_crystal_array_4_focus_aw;
MCNUM mccchannel_13_analyzer_2_array_crystal_array_4_focus_ah;
MCNUM mccchannel_13_analyzer_2_array_crystal_array_4_focus_xw;
MCNUM mccchannel_13_analyzer_2_array_crystal_array_4_focus_xh;
MCNUM mccchannel_13_analyzer_2_array_crystal_array_4_focus_r;
MCNUM mccchannel_13_analyzer_2_array_crystal_array_4_p_interact;
char mccchannel_13_analyzer_2_array_crystal_array_4_mask_string[16384];
char mccchannel_13_analyzer_2_array_crystal_array_4_mask_setting[16384];
MCNUM mccchannel_13_analyzer_2_array_crystal_array_4_number_of_activations;

/* Setting parameters for component 'channel_13_analyzer_2_array_crystal_array_5' [640]. */
char mccchannel_13_analyzer_2_array_crystal_array_5_material_string[16384];
MCNUM mccchannel_13_analyzer_2_array_crystal_array_5_priority;
MCNUM mccchannel_13_analyzer_2_array_crystal_array_5_xwidth;
MCNUM mccchannel_13_analyzer_2_array_crystal_array_5_yheight;
MCNUM mccchannel_13_analyzer_2_array_crystal_array_5_zdepth;
MCNUM mccchannel_13_analyzer_2_array_crystal_array_5_xwidth2;
MCNUM mccchannel_13_analyzer_2_array_crystal_array_5_yheight2;
MCNUM mccchannel_13_analyzer_2_array_crystal_array_5_visualize;
int mccchannel_13_analyzer_2_array_crystal_array_5_target_index;
MCNUM mccchannel_13_analyzer_2_array_crystal_array_5_target_x;
MCNUM mccchannel_13_analyzer_2_array_crystal_array_5_target_y;
MCNUM mccchannel_13_analyzer_2_array_crystal_array_5_target_z;
MCNUM mccchannel_13_analyzer_2_array_crystal_array_5_focus_aw;
MCNUM mccchannel_13_analyzer_2_array_crystal_array_5_focus_ah;
MCNUM mccchannel_13_analyzer_2_array_crystal_array_5_focus_xw;
MCNUM mccchannel_13_analyzer_2_array_crystal_array_5_focus_xh;
MCNUM mccchannel_13_analyzer_2_array_crystal_array_5_focus_r;
MCNUM mccchannel_13_analyzer_2_array_crystal_array_5_p_interact;
char mccchannel_13_analyzer_2_array_crystal_array_5_mask_string[16384];
char mccchannel_13_analyzer_2_array_crystal_array_5_mask_setting[16384];
MCNUM mccchannel_13_analyzer_2_array_crystal_array_5_number_of_activations;

/* Setting parameters for component 'channel_13_analyzer_2_array_crystal_array_6' [641]. */
char mccchannel_13_analyzer_2_array_crystal_array_6_material_string[16384];
MCNUM mccchannel_13_analyzer_2_array_crystal_array_6_priority;
MCNUM mccchannel_13_analyzer_2_array_crystal_array_6_xwidth;
MCNUM mccchannel_13_analyzer_2_array_crystal_array_6_yheight;
MCNUM mccchannel_13_analyzer_2_array_crystal_array_6_zdepth;
MCNUM mccchannel_13_analyzer_2_array_crystal_array_6_xwidth2;
MCNUM mccchannel_13_analyzer_2_array_crystal_array_6_yheight2;
MCNUM mccchannel_13_analyzer_2_array_crystal_array_6_visualize;
int mccchannel_13_analyzer_2_array_crystal_array_6_target_index;
MCNUM mccchannel_13_analyzer_2_array_crystal_array_6_target_x;
MCNUM mccchannel_13_analyzer_2_array_crystal_array_6_target_y;
MCNUM mccchannel_13_analyzer_2_array_crystal_array_6_target_z;
MCNUM mccchannel_13_analyzer_2_array_crystal_array_6_focus_aw;
MCNUM mccchannel_13_analyzer_2_array_crystal_array_6_focus_ah;
MCNUM mccchannel_13_analyzer_2_array_crystal_array_6_focus_xw;
MCNUM mccchannel_13_analyzer_2_array_crystal_array_6_focus_xh;
MCNUM mccchannel_13_analyzer_2_array_crystal_array_6_focus_r;
MCNUM mccchannel_13_analyzer_2_array_crystal_array_6_p_interact;
char mccchannel_13_analyzer_2_array_crystal_array_6_mask_string[16384];
char mccchannel_13_analyzer_2_array_crystal_array_6_mask_setting[16384];
MCNUM mccchannel_13_analyzer_2_array_crystal_array_6_number_of_activations;

/* Setting parameters for component 'channel_13_analyzer_2_array_crystal_array_7' [642]. */
char mccchannel_13_analyzer_2_array_crystal_array_7_material_string[16384];
MCNUM mccchannel_13_analyzer_2_array_crystal_array_7_priority;
MCNUM mccchannel_13_analyzer_2_array_crystal_array_7_xwidth;
MCNUM mccchannel_13_analyzer_2_array_crystal_array_7_yheight;
MCNUM mccchannel_13_analyzer_2_array_crystal_array_7_zdepth;
MCNUM mccchannel_13_analyzer_2_array_crystal_array_7_xwidth2;
MCNUM mccchannel_13_analyzer_2_array_crystal_array_7_yheight2;
MCNUM mccchannel_13_analyzer_2_array_crystal_array_7_visualize;
int mccchannel_13_analyzer_2_array_crystal_array_7_target_index;
MCNUM mccchannel_13_analyzer_2_array_crystal_array_7_target_x;
MCNUM mccchannel_13_analyzer_2_array_crystal_array_7_target_y;
MCNUM mccchannel_13_analyzer_2_array_crystal_array_7_target_z;
MCNUM mccchannel_13_analyzer_2_array_crystal_array_7_focus_aw;
MCNUM mccchannel_13_analyzer_2_array_crystal_array_7_focus_ah;
MCNUM mccchannel_13_analyzer_2_array_crystal_array_7_focus_xw;
MCNUM mccchannel_13_analyzer_2_array_crystal_array_7_focus_xh;
MCNUM mccchannel_13_analyzer_2_array_crystal_array_7_focus_r;
MCNUM mccchannel_13_analyzer_2_array_crystal_array_7_p_interact;
char mccchannel_13_analyzer_2_array_crystal_array_7_mask_string[16384];
char mccchannel_13_analyzer_2_array_crystal_array_7_mask_setting[16384];
MCNUM mccchannel_13_analyzer_2_array_crystal_array_7_number_of_activations;

/* Setting parameters for component 'channel_13_analyzer_2_array_crystal_array_8' [643]. */
char mccchannel_13_analyzer_2_array_crystal_array_8_material_string[16384];
MCNUM mccchannel_13_analyzer_2_array_crystal_array_8_priority;
MCNUM mccchannel_13_analyzer_2_array_crystal_array_8_xwidth;
MCNUM mccchannel_13_analyzer_2_array_crystal_array_8_yheight;
MCNUM mccchannel_13_analyzer_2_array_crystal_array_8_zdepth;
MCNUM mccchannel_13_analyzer_2_array_crystal_array_8_xwidth2;
MCNUM mccchannel_13_analyzer_2_array_crystal_array_8_yheight2;
MCNUM mccchannel_13_analyzer_2_array_crystal_array_8_visualize;
int mccchannel_13_analyzer_2_array_crystal_array_8_target_index;
MCNUM mccchannel_13_analyzer_2_array_crystal_array_8_target_x;
MCNUM mccchannel_13_analyzer_2_array_crystal_array_8_target_y;
MCNUM mccchannel_13_analyzer_2_array_crystal_array_8_target_z;
MCNUM mccchannel_13_analyzer_2_array_crystal_array_8_focus_aw;
MCNUM mccchannel_13_analyzer_2_array_crystal_array_8_focus_ah;
MCNUM mccchannel_13_analyzer_2_array_crystal_array_8_focus_xw;
MCNUM mccchannel_13_analyzer_2_array_crystal_array_8_focus_xh;
MCNUM mccchannel_13_analyzer_2_array_crystal_array_8_focus_r;
MCNUM mccchannel_13_analyzer_2_array_crystal_array_8_p_interact;
char mccchannel_13_analyzer_2_array_crystal_array_8_mask_string[16384];
char mccchannel_13_analyzer_2_array_crystal_array_8_mask_setting[16384];
MCNUM mccchannel_13_analyzer_2_array_crystal_array_8_number_of_activations;

/* Setting parameters for component 'channel_13_cave2_cyl1' [644]. */
char mccchannel_13_cave2_cyl1_material_string[16384];
MCNUM mccchannel_13_cave2_cyl1_priority;
MCNUM mccchannel_13_cave2_cyl1_radius;
MCNUM mccchannel_13_cave2_cyl1_yheight;
MCNUM mccchannel_13_cave2_cyl1_visualize;
int mccchannel_13_cave2_cyl1_target_index;
MCNUM mccchannel_13_cave2_cyl1_target_x;
MCNUM mccchannel_13_cave2_cyl1_target_y;
MCNUM mccchannel_13_cave2_cyl1_target_z;
MCNUM mccchannel_13_cave2_cyl1_focus_aw;
MCNUM mccchannel_13_cave2_cyl1_focus_ah;
MCNUM mccchannel_13_cave2_cyl1_focus_xw;
MCNUM mccchannel_13_cave2_cyl1_focus_xh;
MCNUM mccchannel_13_cave2_cyl1_focus_r;
MCNUM mccchannel_13_cave2_cyl1_p_interact;
char mccchannel_13_cave2_cyl1_mask_string[16384];
char mccchannel_13_cave2_cyl1_mask_setting[16384];
MCNUM mccchannel_13_cave2_cyl1_number_of_activations;

/* Setting parameters for component 'channel_13_cave2_box1' [645]. */
char mccchannel_13_cave2_box1_material_string[16384];
MCNUM mccchannel_13_cave2_box1_priority;
MCNUM mccchannel_13_cave2_box1_xwidth;
MCNUM mccchannel_13_cave2_box1_yheight;
MCNUM mccchannel_13_cave2_box1_zdepth;
MCNUM mccchannel_13_cave2_box1_xwidth2;
MCNUM mccchannel_13_cave2_box1_yheight2;
MCNUM mccchannel_13_cave2_box1_visualize;
int mccchannel_13_cave2_box1_target_index;
MCNUM mccchannel_13_cave2_box1_target_x;
MCNUM mccchannel_13_cave2_box1_target_y;
MCNUM mccchannel_13_cave2_box1_target_z;
MCNUM mccchannel_13_cave2_box1_focus_aw;
MCNUM mccchannel_13_cave2_box1_focus_ah;
MCNUM mccchannel_13_cave2_box1_focus_xw;
MCNUM mccchannel_13_cave2_box1_focus_xh;
MCNUM mccchannel_13_cave2_box1_focus_r;
MCNUM mccchannel_13_cave2_box1_p_interact;
char mccchannel_13_cave2_box1_mask_string[16384];
char mccchannel_13_cave2_box1_mask_setting[16384];
MCNUM mccchannel_13_cave2_box1_number_of_activations;

/* Setting parameters for component 'channel_13_cave2_box2' [646]. */
char mccchannel_13_cave2_box2_material_string[16384];
MCNUM mccchannel_13_cave2_box2_priority;
MCNUM mccchannel_13_cave2_box2_xwidth;
MCNUM mccchannel_13_cave2_box2_yheight;
MCNUM mccchannel_13_cave2_box2_zdepth;
MCNUM mccchannel_13_cave2_box2_xwidth2;
MCNUM mccchannel_13_cave2_box2_yheight2;
MCNUM mccchannel_13_cave2_box2_visualize;
int mccchannel_13_cave2_box2_target_index;
MCNUM mccchannel_13_cave2_box2_target_x;
MCNUM mccchannel_13_cave2_box2_target_y;
MCNUM mccchannel_13_cave2_box2_target_z;
MCNUM mccchannel_13_cave2_box2_focus_aw;
MCNUM mccchannel_13_cave2_box2_focus_ah;
MCNUM mccchannel_13_cave2_box2_focus_xw;
MCNUM mccchannel_13_cave2_box2_focus_xh;
MCNUM mccchannel_13_cave2_box2_focus_r;
MCNUM mccchannel_13_cave2_box2_p_interact;
char mccchannel_13_cave2_box2_mask_string[16384];
char mccchannel_13_cave2_box2_mask_setting[16384];
MCNUM mccchannel_13_cave2_box2_number_of_activations;

/* Setting parameters for component 'channel_13_cave2_box3' [647]. */
char mccchannel_13_cave2_box3_material_string[16384];
MCNUM mccchannel_13_cave2_box3_priority;
MCNUM mccchannel_13_cave2_box3_xwidth;
MCNUM mccchannel_13_cave2_box3_yheight;
MCNUM mccchannel_13_cave2_box3_zdepth;
MCNUM mccchannel_13_cave2_box3_xwidth2;
MCNUM mccchannel_13_cave2_box3_yheight2;
MCNUM mccchannel_13_cave2_box3_visualize;
int mccchannel_13_cave2_box3_target_index;
MCNUM mccchannel_13_cave2_box3_target_x;
MCNUM mccchannel_13_cave2_box3_target_y;
MCNUM mccchannel_13_cave2_box3_target_z;
MCNUM mccchannel_13_cave2_box3_focus_aw;
MCNUM mccchannel_13_cave2_box3_focus_ah;
MCNUM mccchannel_13_cave2_box3_focus_xw;
MCNUM mccchannel_13_cave2_box3_focus_xh;
MCNUM mccchannel_13_cave2_box3_focus_r;
MCNUM mccchannel_13_cave2_box3_p_interact;
char mccchannel_13_cave2_box3_mask_string[16384];
char mccchannel_13_cave2_box3_mask_setting[16384];
MCNUM mccchannel_13_cave2_box3_number_of_activations;

/* Setting parameters for component 'inter_analyzer_colimator_13_blade_0' [649]. */
char mccinter_analyzer_colimator_13_blade_0_material_string[16384];
MCNUM mccinter_analyzer_colimator_13_blade_0_priority;
MCNUM mccinter_analyzer_colimator_13_blade_0_xwidth;
MCNUM mccinter_analyzer_colimator_13_blade_0_yheight;
MCNUM mccinter_analyzer_colimator_13_blade_0_zdepth;
MCNUM mccinter_analyzer_colimator_13_blade_0_xwidth2;
MCNUM mccinter_analyzer_colimator_13_blade_0_yheight2;
MCNUM mccinter_analyzer_colimator_13_blade_0_visualize;
int mccinter_analyzer_colimator_13_blade_0_target_index;
MCNUM mccinter_analyzer_colimator_13_blade_0_target_x;
MCNUM mccinter_analyzer_colimator_13_blade_0_target_y;
MCNUM mccinter_analyzer_colimator_13_blade_0_target_z;
MCNUM mccinter_analyzer_colimator_13_blade_0_focus_aw;
MCNUM mccinter_analyzer_colimator_13_blade_0_focus_ah;
MCNUM mccinter_analyzer_colimator_13_blade_0_focus_xw;
MCNUM mccinter_analyzer_colimator_13_blade_0_focus_xh;
MCNUM mccinter_analyzer_colimator_13_blade_0_focus_r;
MCNUM mccinter_analyzer_colimator_13_blade_0_p_interact;
char mccinter_analyzer_colimator_13_blade_0_mask_string[16384];
char mccinter_analyzer_colimator_13_blade_0_mask_setting[16384];
MCNUM mccinter_analyzer_colimator_13_blade_0_number_of_activations;

/* Setting parameters for component 'inter_analyzer_colimator_13_blade_1' [650]. */
char mccinter_analyzer_colimator_13_blade_1_material_string[16384];
MCNUM mccinter_analyzer_colimator_13_blade_1_priority;
MCNUM mccinter_analyzer_colimator_13_blade_1_xwidth;
MCNUM mccinter_analyzer_colimator_13_blade_1_yheight;
MCNUM mccinter_analyzer_colimator_13_blade_1_zdepth;
MCNUM mccinter_analyzer_colimator_13_blade_1_xwidth2;
MCNUM mccinter_analyzer_colimator_13_blade_1_yheight2;
MCNUM mccinter_analyzer_colimator_13_blade_1_visualize;
int mccinter_analyzer_colimator_13_blade_1_target_index;
MCNUM mccinter_analyzer_colimator_13_blade_1_target_x;
MCNUM mccinter_analyzer_colimator_13_blade_1_target_y;
MCNUM mccinter_analyzer_colimator_13_blade_1_target_z;
MCNUM mccinter_analyzer_colimator_13_blade_1_focus_aw;
MCNUM mccinter_analyzer_colimator_13_blade_1_focus_ah;
MCNUM mccinter_analyzer_colimator_13_blade_1_focus_xw;
MCNUM mccinter_analyzer_colimator_13_blade_1_focus_xh;
MCNUM mccinter_analyzer_colimator_13_blade_1_focus_r;
MCNUM mccinter_analyzer_colimator_13_blade_1_p_interact;
char mccinter_analyzer_colimator_13_blade_1_mask_string[16384];
char mccinter_analyzer_colimator_13_blade_1_mask_setting[16384];
MCNUM mccinter_analyzer_colimator_13_blade_1_number_of_activations;

/* Setting parameters for component 'inter_analyzer_colimator_13_blade_2' [651]. */
char mccinter_analyzer_colimator_13_blade_2_material_string[16384];
MCNUM mccinter_analyzer_colimator_13_blade_2_priority;
MCNUM mccinter_analyzer_colimator_13_blade_2_xwidth;
MCNUM mccinter_analyzer_colimator_13_blade_2_yheight;
MCNUM mccinter_analyzer_colimator_13_blade_2_zdepth;
MCNUM mccinter_analyzer_colimator_13_blade_2_xwidth2;
MCNUM mccinter_analyzer_colimator_13_blade_2_yheight2;
MCNUM mccinter_analyzer_colimator_13_blade_2_visualize;
int mccinter_analyzer_colimator_13_blade_2_target_index;
MCNUM mccinter_analyzer_colimator_13_blade_2_target_x;
MCNUM mccinter_analyzer_colimator_13_blade_2_target_y;
MCNUM mccinter_analyzer_colimator_13_blade_2_target_z;
MCNUM mccinter_analyzer_colimator_13_blade_2_focus_aw;
MCNUM mccinter_analyzer_colimator_13_blade_2_focus_ah;
MCNUM mccinter_analyzer_colimator_13_blade_2_focus_xw;
MCNUM mccinter_analyzer_colimator_13_blade_2_focus_xh;
MCNUM mccinter_analyzer_colimator_13_blade_2_focus_r;
MCNUM mccinter_analyzer_colimator_13_blade_2_p_interact;
char mccinter_analyzer_colimator_13_blade_2_mask_string[16384];
char mccinter_analyzer_colimator_13_blade_2_mask_setting[16384];
MCNUM mccinter_analyzer_colimator_13_blade_2_number_of_activations;

/* Setting parameters for component 'inter_analyzer_colimator_13_blade_3' [652]. */
char mccinter_analyzer_colimator_13_blade_3_material_string[16384];
MCNUM mccinter_analyzer_colimator_13_blade_3_priority;
MCNUM mccinter_analyzer_colimator_13_blade_3_xwidth;
MCNUM mccinter_analyzer_colimator_13_blade_3_yheight;
MCNUM mccinter_analyzer_colimator_13_blade_3_zdepth;
MCNUM mccinter_analyzer_colimator_13_blade_3_xwidth2;
MCNUM mccinter_analyzer_colimator_13_blade_3_yheight2;
MCNUM mccinter_analyzer_colimator_13_blade_3_visualize;
int mccinter_analyzer_colimator_13_blade_3_target_index;
MCNUM mccinter_analyzer_colimator_13_blade_3_target_x;
MCNUM mccinter_analyzer_colimator_13_blade_3_target_y;
MCNUM mccinter_analyzer_colimator_13_blade_3_target_z;
MCNUM mccinter_analyzer_colimator_13_blade_3_focus_aw;
MCNUM mccinter_analyzer_colimator_13_blade_3_focus_ah;
MCNUM mccinter_analyzer_colimator_13_blade_3_focus_xw;
MCNUM mccinter_analyzer_colimator_13_blade_3_focus_xh;
MCNUM mccinter_analyzer_colimator_13_blade_3_focus_r;
MCNUM mccinter_analyzer_colimator_13_blade_3_p_interact;
char mccinter_analyzer_colimator_13_blade_3_mask_string[16384];
char mccinter_analyzer_colimator_13_blade_3_mask_setting[16384];
MCNUM mccinter_analyzer_colimator_13_blade_3_number_of_activations;

/* Setting parameters for component 'inter_analyzer_colimator_13_blade_4' [653]. */
char mccinter_analyzer_colimator_13_blade_4_material_string[16384];
MCNUM mccinter_analyzer_colimator_13_blade_4_priority;
MCNUM mccinter_analyzer_colimator_13_blade_4_xwidth;
MCNUM mccinter_analyzer_colimator_13_blade_4_yheight;
MCNUM mccinter_analyzer_colimator_13_blade_4_zdepth;
MCNUM mccinter_analyzer_colimator_13_blade_4_xwidth2;
MCNUM mccinter_analyzer_colimator_13_blade_4_yheight2;
MCNUM mccinter_analyzer_colimator_13_blade_4_visualize;
int mccinter_analyzer_colimator_13_blade_4_target_index;
MCNUM mccinter_analyzer_colimator_13_blade_4_target_x;
MCNUM mccinter_analyzer_colimator_13_blade_4_target_y;
MCNUM mccinter_analyzer_colimator_13_blade_4_target_z;
MCNUM mccinter_analyzer_colimator_13_blade_4_focus_aw;
MCNUM mccinter_analyzer_colimator_13_blade_4_focus_ah;
MCNUM mccinter_analyzer_colimator_13_blade_4_focus_xw;
MCNUM mccinter_analyzer_colimator_13_blade_4_focus_xh;
MCNUM mccinter_analyzer_colimator_13_blade_4_focus_r;
MCNUM mccinter_analyzer_colimator_13_blade_4_p_interact;
char mccinter_analyzer_colimator_13_blade_4_mask_string[16384];
char mccinter_analyzer_colimator_13_blade_4_mask_setting[16384];
MCNUM mccinter_analyzer_colimator_13_blade_4_number_of_activations;

/* Setting parameters for component 'diffraction_detector_13_exit_volume' [654]. */
char mccdiffraction_detector_13_exit_volume_material_string[16384];
MCNUM mccdiffraction_detector_13_exit_volume_priority;
MCNUM mccdiffraction_detector_13_exit_volume_xwidth;
MCNUM mccdiffraction_detector_13_exit_volume_yheight;
MCNUM mccdiffraction_detector_13_exit_volume_zdepth;
MCNUM mccdiffraction_detector_13_exit_volume_xwidth2;
MCNUM mccdiffraction_detector_13_exit_volume_yheight2;
MCNUM mccdiffraction_detector_13_exit_volume_visualize;
int mccdiffraction_detector_13_exit_volume_target_index;
MCNUM mccdiffraction_detector_13_exit_volume_target_x;
MCNUM mccdiffraction_detector_13_exit_volume_target_y;
MCNUM mccdiffraction_detector_13_exit_volume_target_z;
MCNUM mccdiffraction_detector_13_exit_volume_focus_aw;
MCNUM mccdiffraction_detector_13_exit_volume_focus_ah;
MCNUM mccdiffraction_detector_13_exit_volume_focus_xw;
MCNUM mccdiffraction_detector_13_exit_volume_focus_xh;
MCNUM mccdiffraction_detector_13_exit_volume_focus_r;
MCNUM mccdiffraction_detector_13_exit_volume_p_interact;
char mccdiffraction_detector_13_exit_volume_mask_string[16384];
char mccdiffraction_detector_13_exit_volume_mask_setting[16384];
MCNUM mccdiffraction_detector_13_exit_volume_number_of_activations;

/* Setting parameters for component 'spec_detector_13_exit_volume' [655]. */
char mccspec_detector_13_exit_volume_material_string[16384];
MCNUM mccspec_detector_13_exit_volume_priority;
MCNUM mccspec_detector_13_exit_volume_xwidth;
MCNUM mccspec_detector_13_exit_volume_yheight;
MCNUM mccspec_detector_13_exit_volume_zdepth;
MCNUM mccspec_detector_13_exit_volume_xwidth2;
MCNUM mccspec_detector_13_exit_volume_yheight2;
MCNUM mccspec_detector_13_exit_volume_visualize;
int mccspec_detector_13_exit_volume_target_index;
MCNUM mccspec_detector_13_exit_volume_target_x;
MCNUM mccspec_detector_13_exit_volume_target_y;
MCNUM mccspec_detector_13_exit_volume_target_z;
MCNUM mccspec_detector_13_exit_volume_focus_aw;
MCNUM mccspec_detector_13_exit_volume_focus_ah;
MCNUM mccspec_detector_13_exit_volume_focus_xw;
MCNUM mccspec_detector_13_exit_volume_focus_xh;
MCNUM mccspec_detector_13_exit_volume_focus_r;
MCNUM mccspec_detector_13_exit_volume_p_interact;
char mccspec_detector_13_exit_volume_mask_string[16384];
char mccspec_detector_13_exit_volume_mask_setting[16384];
MCNUM mccspec_detector_13_exit_volume_number_of_activations;

/* Setting parameters for component 'channel_14_cave1_box1' [656]. */
char mccchannel_14_cave1_box1_material_string[16384];
MCNUM mccchannel_14_cave1_box1_priority;
MCNUM mccchannel_14_cave1_box1_xwidth;
MCNUM mccchannel_14_cave1_box1_yheight;
MCNUM mccchannel_14_cave1_box1_zdepth;
MCNUM mccchannel_14_cave1_box1_xwidth2;
MCNUM mccchannel_14_cave1_box1_yheight2;
MCNUM mccchannel_14_cave1_box1_visualize;
int mccchannel_14_cave1_box1_target_index;
MCNUM mccchannel_14_cave1_box1_target_x;
MCNUM mccchannel_14_cave1_box1_target_y;
MCNUM mccchannel_14_cave1_box1_target_z;
MCNUM mccchannel_14_cave1_box1_focus_aw;
MCNUM mccchannel_14_cave1_box1_focus_ah;
MCNUM mccchannel_14_cave1_box1_focus_xw;
MCNUM mccchannel_14_cave1_box1_focus_xh;
MCNUM mccchannel_14_cave1_box1_focus_r;
MCNUM mccchannel_14_cave1_box1_p_interact;
char mccchannel_14_cave1_box1_mask_string[16384];
char mccchannel_14_cave1_box1_mask_setting[16384];
MCNUM mccchannel_14_cave1_box1_number_of_activations;

/* Setting parameters for component 'channel_14_cave1_box2' [657]. */
char mccchannel_14_cave1_box2_material_string[16384];
MCNUM mccchannel_14_cave1_box2_priority;
MCNUM mccchannel_14_cave1_box2_xwidth;
MCNUM mccchannel_14_cave1_box2_yheight;
MCNUM mccchannel_14_cave1_box2_zdepth;
MCNUM mccchannel_14_cave1_box2_xwidth2;
MCNUM mccchannel_14_cave1_box2_yheight2;
MCNUM mccchannel_14_cave1_box2_visualize;
int mccchannel_14_cave1_box2_target_index;
MCNUM mccchannel_14_cave1_box2_target_x;
MCNUM mccchannel_14_cave1_box2_target_y;
MCNUM mccchannel_14_cave1_box2_target_z;
MCNUM mccchannel_14_cave1_box2_focus_aw;
MCNUM mccchannel_14_cave1_box2_focus_ah;
MCNUM mccchannel_14_cave1_box2_focus_xw;
MCNUM mccchannel_14_cave1_box2_focus_xh;
MCNUM mccchannel_14_cave1_box2_focus_r;
MCNUM mccchannel_14_cave1_box2_p_interact;
char mccchannel_14_cave1_box2_mask_string[16384];
char mccchannel_14_cave1_box2_mask_setting[16384];
MCNUM mccchannel_14_cave1_box2_number_of_activations;

/* Setting parameters for component 'channel_14_cave1_box3' [658]. */
char mccchannel_14_cave1_box3_material_string[16384];
MCNUM mccchannel_14_cave1_box3_priority;
MCNUM mccchannel_14_cave1_box3_xwidth;
MCNUM mccchannel_14_cave1_box3_yheight;
MCNUM mccchannel_14_cave1_box3_zdepth;
MCNUM mccchannel_14_cave1_box3_xwidth2;
MCNUM mccchannel_14_cave1_box3_yheight2;
MCNUM mccchannel_14_cave1_box3_visualize;
int mccchannel_14_cave1_box3_target_index;
MCNUM mccchannel_14_cave1_box3_target_x;
MCNUM mccchannel_14_cave1_box3_target_y;
MCNUM mccchannel_14_cave1_box3_target_z;
MCNUM mccchannel_14_cave1_box3_focus_aw;
MCNUM mccchannel_14_cave1_box3_focus_ah;
MCNUM mccchannel_14_cave1_box3_focus_xw;
MCNUM mccchannel_14_cave1_box3_focus_xh;
MCNUM mccchannel_14_cave1_box3_focus_r;
MCNUM mccchannel_14_cave1_box3_p_interact;
char mccchannel_14_cave1_box3_mask_string[16384];
char mccchannel_14_cave1_box3_mask_setting[16384];
MCNUM mccchannel_14_cave1_box3_number_of_activations;

/* Setting parameters for component 'channel_14_cave1_cyl1' [659]. */
char mccchannel_14_cave1_cyl1_material_string[16384];
MCNUM mccchannel_14_cave1_cyl1_priority;
MCNUM mccchannel_14_cave1_cyl1_radius;
MCNUM mccchannel_14_cave1_cyl1_yheight;
MCNUM mccchannel_14_cave1_cyl1_visualize;
int mccchannel_14_cave1_cyl1_target_index;
MCNUM mccchannel_14_cave1_cyl1_target_x;
MCNUM mccchannel_14_cave1_cyl1_target_y;
MCNUM mccchannel_14_cave1_cyl1_target_z;
MCNUM mccchannel_14_cave1_cyl1_focus_aw;
MCNUM mccchannel_14_cave1_cyl1_focus_ah;
MCNUM mccchannel_14_cave1_cyl1_focus_xw;
MCNUM mccchannel_14_cave1_cyl1_focus_xh;
MCNUM mccchannel_14_cave1_cyl1_focus_r;
MCNUM mccchannel_14_cave1_cyl1_p_interact;
char mccchannel_14_cave1_cyl1_mask_string[16384];
char mccchannel_14_cave1_cyl1_mask_setting[16384];
MCNUM mccchannel_14_cave1_cyl1_number_of_activations;

/* Setting parameters for component 'channel_14_analyzer_1_array_crystal_array_0' [662]. */
char mccchannel_14_analyzer_1_array_crystal_array_0_material_string[16384];
MCNUM mccchannel_14_analyzer_1_array_crystal_array_0_priority;
MCNUM mccchannel_14_analyzer_1_array_crystal_array_0_xwidth;
MCNUM mccchannel_14_analyzer_1_array_crystal_array_0_yheight;
MCNUM mccchannel_14_analyzer_1_array_crystal_array_0_zdepth;
MCNUM mccchannel_14_analyzer_1_array_crystal_array_0_xwidth2;
MCNUM mccchannel_14_analyzer_1_array_crystal_array_0_yheight2;
MCNUM mccchannel_14_analyzer_1_array_crystal_array_0_visualize;
int mccchannel_14_analyzer_1_array_crystal_array_0_target_index;
MCNUM mccchannel_14_analyzer_1_array_crystal_array_0_target_x;
MCNUM mccchannel_14_analyzer_1_array_crystal_array_0_target_y;
MCNUM mccchannel_14_analyzer_1_array_crystal_array_0_target_z;
MCNUM mccchannel_14_analyzer_1_array_crystal_array_0_focus_aw;
MCNUM mccchannel_14_analyzer_1_array_crystal_array_0_focus_ah;
MCNUM mccchannel_14_analyzer_1_array_crystal_array_0_focus_xw;
MCNUM mccchannel_14_analyzer_1_array_crystal_array_0_focus_xh;
MCNUM mccchannel_14_analyzer_1_array_crystal_array_0_focus_r;
MCNUM mccchannel_14_analyzer_1_array_crystal_array_0_p_interact;
char mccchannel_14_analyzer_1_array_crystal_array_0_mask_string[16384];
char mccchannel_14_analyzer_1_array_crystal_array_0_mask_setting[16384];
MCNUM mccchannel_14_analyzer_1_array_crystal_array_0_number_of_activations;

/* Setting parameters for component 'channel_14_analyzer_1_array_crystal_array_1' [663]. */
char mccchannel_14_analyzer_1_array_crystal_array_1_material_string[16384];
MCNUM mccchannel_14_analyzer_1_array_crystal_array_1_priority;
MCNUM mccchannel_14_analyzer_1_array_crystal_array_1_xwidth;
MCNUM mccchannel_14_analyzer_1_array_crystal_array_1_yheight;
MCNUM mccchannel_14_analyzer_1_array_crystal_array_1_zdepth;
MCNUM mccchannel_14_analyzer_1_array_crystal_array_1_xwidth2;
MCNUM mccchannel_14_analyzer_1_array_crystal_array_1_yheight2;
MCNUM mccchannel_14_analyzer_1_array_crystal_array_1_visualize;
int mccchannel_14_analyzer_1_array_crystal_array_1_target_index;
MCNUM mccchannel_14_analyzer_1_array_crystal_array_1_target_x;
MCNUM mccchannel_14_analyzer_1_array_crystal_array_1_target_y;
MCNUM mccchannel_14_analyzer_1_array_crystal_array_1_target_z;
MCNUM mccchannel_14_analyzer_1_array_crystal_array_1_focus_aw;
MCNUM mccchannel_14_analyzer_1_array_crystal_array_1_focus_ah;
MCNUM mccchannel_14_analyzer_1_array_crystal_array_1_focus_xw;
MCNUM mccchannel_14_analyzer_1_array_crystal_array_1_focus_xh;
MCNUM mccchannel_14_analyzer_1_array_crystal_array_1_focus_r;
MCNUM mccchannel_14_analyzer_1_array_crystal_array_1_p_interact;
char mccchannel_14_analyzer_1_array_crystal_array_1_mask_string[16384];
char mccchannel_14_analyzer_1_array_crystal_array_1_mask_setting[16384];
MCNUM mccchannel_14_analyzer_1_array_crystal_array_1_number_of_activations;

/* Setting parameters for component 'channel_14_analyzer_1_array_crystal_array_2' [664]. */
char mccchannel_14_analyzer_1_array_crystal_array_2_material_string[16384];
MCNUM mccchannel_14_analyzer_1_array_crystal_array_2_priority;
MCNUM mccchannel_14_analyzer_1_array_crystal_array_2_xwidth;
MCNUM mccchannel_14_analyzer_1_array_crystal_array_2_yheight;
MCNUM mccchannel_14_analyzer_1_array_crystal_array_2_zdepth;
MCNUM mccchannel_14_analyzer_1_array_crystal_array_2_xwidth2;
MCNUM mccchannel_14_analyzer_1_array_crystal_array_2_yheight2;
MCNUM mccchannel_14_analyzer_1_array_crystal_array_2_visualize;
int mccchannel_14_analyzer_1_array_crystal_array_2_target_index;
MCNUM mccchannel_14_analyzer_1_array_crystal_array_2_target_x;
MCNUM mccchannel_14_analyzer_1_array_crystal_array_2_target_y;
MCNUM mccchannel_14_analyzer_1_array_crystal_array_2_target_z;
MCNUM mccchannel_14_analyzer_1_array_crystal_array_2_focus_aw;
MCNUM mccchannel_14_analyzer_1_array_crystal_array_2_focus_ah;
MCNUM mccchannel_14_analyzer_1_array_crystal_array_2_focus_xw;
MCNUM mccchannel_14_analyzer_1_array_crystal_array_2_focus_xh;
MCNUM mccchannel_14_analyzer_1_array_crystal_array_2_focus_r;
MCNUM mccchannel_14_analyzer_1_array_crystal_array_2_p_interact;
char mccchannel_14_analyzer_1_array_crystal_array_2_mask_string[16384];
char mccchannel_14_analyzer_1_array_crystal_array_2_mask_setting[16384];
MCNUM mccchannel_14_analyzer_1_array_crystal_array_2_number_of_activations;

/* Setting parameters for component 'channel_14_analyzer_1_array_crystal_array_3' [665]. */
char mccchannel_14_analyzer_1_array_crystal_array_3_material_string[16384];
MCNUM mccchannel_14_analyzer_1_array_crystal_array_3_priority;
MCNUM mccchannel_14_analyzer_1_array_crystal_array_3_xwidth;
MCNUM mccchannel_14_analyzer_1_array_crystal_array_3_yheight;
MCNUM mccchannel_14_analyzer_1_array_crystal_array_3_zdepth;
MCNUM mccchannel_14_analyzer_1_array_crystal_array_3_xwidth2;
MCNUM mccchannel_14_analyzer_1_array_crystal_array_3_yheight2;
MCNUM mccchannel_14_analyzer_1_array_crystal_array_3_visualize;
int mccchannel_14_analyzer_1_array_crystal_array_3_target_index;
MCNUM mccchannel_14_analyzer_1_array_crystal_array_3_target_x;
MCNUM mccchannel_14_analyzer_1_array_crystal_array_3_target_y;
MCNUM mccchannel_14_analyzer_1_array_crystal_array_3_target_z;
MCNUM mccchannel_14_analyzer_1_array_crystal_array_3_focus_aw;
MCNUM mccchannel_14_analyzer_1_array_crystal_array_3_focus_ah;
MCNUM mccchannel_14_analyzer_1_array_crystal_array_3_focus_xw;
MCNUM mccchannel_14_analyzer_1_array_crystal_array_3_focus_xh;
MCNUM mccchannel_14_analyzer_1_array_crystal_array_3_focus_r;
MCNUM mccchannel_14_analyzer_1_array_crystal_array_3_p_interact;
char mccchannel_14_analyzer_1_array_crystal_array_3_mask_string[16384];
char mccchannel_14_analyzer_1_array_crystal_array_3_mask_setting[16384];
MCNUM mccchannel_14_analyzer_1_array_crystal_array_3_number_of_activations;

/* Setting parameters for component 'channel_14_analyzer_1_array_crystal_array_4' [666]. */
char mccchannel_14_analyzer_1_array_crystal_array_4_material_string[16384];
MCNUM mccchannel_14_analyzer_1_array_crystal_array_4_priority;
MCNUM mccchannel_14_analyzer_1_array_crystal_array_4_xwidth;
MCNUM mccchannel_14_analyzer_1_array_crystal_array_4_yheight;
MCNUM mccchannel_14_analyzer_1_array_crystal_array_4_zdepth;
MCNUM mccchannel_14_analyzer_1_array_crystal_array_4_xwidth2;
MCNUM mccchannel_14_analyzer_1_array_crystal_array_4_yheight2;
MCNUM mccchannel_14_analyzer_1_array_crystal_array_4_visualize;
int mccchannel_14_analyzer_1_array_crystal_array_4_target_index;
MCNUM mccchannel_14_analyzer_1_array_crystal_array_4_target_x;
MCNUM mccchannel_14_analyzer_1_array_crystal_array_4_target_y;
MCNUM mccchannel_14_analyzer_1_array_crystal_array_4_target_z;
MCNUM mccchannel_14_analyzer_1_array_crystal_array_4_focus_aw;
MCNUM mccchannel_14_analyzer_1_array_crystal_array_4_focus_ah;
MCNUM mccchannel_14_analyzer_1_array_crystal_array_4_focus_xw;
MCNUM mccchannel_14_analyzer_1_array_crystal_array_4_focus_xh;
MCNUM mccchannel_14_analyzer_1_array_crystal_array_4_focus_r;
MCNUM mccchannel_14_analyzer_1_array_crystal_array_4_p_interact;
char mccchannel_14_analyzer_1_array_crystal_array_4_mask_string[16384];
char mccchannel_14_analyzer_1_array_crystal_array_4_mask_setting[16384];
MCNUM mccchannel_14_analyzer_1_array_crystal_array_4_number_of_activations;

/* Setting parameters for component 'channel_14_analyzer_1_array_crystal_array_5' [667]. */
char mccchannel_14_analyzer_1_array_crystal_array_5_material_string[16384];
MCNUM mccchannel_14_analyzer_1_array_crystal_array_5_priority;
MCNUM mccchannel_14_analyzer_1_array_crystal_array_5_xwidth;
MCNUM mccchannel_14_analyzer_1_array_crystal_array_5_yheight;
MCNUM mccchannel_14_analyzer_1_array_crystal_array_5_zdepth;
MCNUM mccchannel_14_analyzer_1_array_crystal_array_5_xwidth2;
MCNUM mccchannel_14_analyzer_1_array_crystal_array_5_yheight2;
MCNUM mccchannel_14_analyzer_1_array_crystal_array_5_visualize;
int mccchannel_14_analyzer_1_array_crystal_array_5_target_index;
MCNUM mccchannel_14_analyzer_1_array_crystal_array_5_target_x;
MCNUM mccchannel_14_analyzer_1_array_crystal_array_5_target_y;
MCNUM mccchannel_14_analyzer_1_array_crystal_array_5_target_z;
MCNUM mccchannel_14_analyzer_1_array_crystal_array_5_focus_aw;
MCNUM mccchannel_14_analyzer_1_array_crystal_array_5_focus_ah;
MCNUM mccchannel_14_analyzer_1_array_crystal_array_5_focus_xw;
MCNUM mccchannel_14_analyzer_1_array_crystal_array_5_focus_xh;
MCNUM mccchannel_14_analyzer_1_array_crystal_array_5_focus_r;
MCNUM mccchannel_14_analyzer_1_array_crystal_array_5_p_interact;
char mccchannel_14_analyzer_1_array_crystal_array_5_mask_string[16384];
char mccchannel_14_analyzer_1_array_crystal_array_5_mask_setting[16384];
MCNUM mccchannel_14_analyzer_1_array_crystal_array_5_number_of_activations;

/* Setting parameters for component 'channel_14_analyzer_1_array_crystal_array_6' [668]. */
char mccchannel_14_analyzer_1_array_crystal_array_6_material_string[16384];
MCNUM mccchannel_14_analyzer_1_array_crystal_array_6_priority;
MCNUM mccchannel_14_analyzer_1_array_crystal_array_6_xwidth;
MCNUM mccchannel_14_analyzer_1_array_crystal_array_6_yheight;
MCNUM mccchannel_14_analyzer_1_array_crystal_array_6_zdepth;
MCNUM mccchannel_14_analyzer_1_array_crystal_array_6_xwidth2;
MCNUM mccchannel_14_analyzer_1_array_crystal_array_6_yheight2;
MCNUM mccchannel_14_analyzer_1_array_crystal_array_6_visualize;
int mccchannel_14_analyzer_1_array_crystal_array_6_target_index;
MCNUM mccchannel_14_analyzer_1_array_crystal_array_6_target_x;
MCNUM mccchannel_14_analyzer_1_array_crystal_array_6_target_y;
MCNUM mccchannel_14_analyzer_1_array_crystal_array_6_target_z;
MCNUM mccchannel_14_analyzer_1_array_crystal_array_6_focus_aw;
MCNUM mccchannel_14_analyzer_1_array_crystal_array_6_focus_ah;
MCNUM mccchannel_14_analyzer_1_array_crystal_array_6_focus_xw;
MCNUM mccchannel_14_analyzer_1_array_crystal_array_6_focus_xh;
MCNUM mccchannel_14_analyzer_1_array_crystal_array_6_focus_r;
MCNUM mccchannel_14_analyzer_1_array_crystal_array_6_p_interact;
char mccchannel_14_analyzer_1_array_crystal_array_6_mask_string[16384];
char mccchannel_14_analyzer_1_array_crystal_array_6_mask_setting[16384];
MCNUM mccchannel_14_analyzer_1_array_crystal_array_6_number_of_activations;

/* Setting parameters for component 'channel_14_analyzer_1_array_crystal_array_7' [669]. */
char mccchannel_14_analyzer_1_array_crystal_array_7_material_string[16384];
MCNUM mccchannel_14_analyzer_1_array_crystal_array_7_priority;
MCNUM mccchannel_14_analyzer_1_array_crystal_array_7_xwidth;
MCNUM mccchannel_14_analyzer_1_array_crystal_array_7_yheight;
MCNUM mccchannel_14_analyzer_1_array_crystal_array_7_zdepth;
MCNUM mccchannel_14_analyzer_1_array_crystal_array_7_xwidth2;
MCNUM mccchannel_14_analyzer_1_array_crystal_array_7_yheight2;
MCNUM mccchannel_14_analyzer_1_array_crystal_array_7_visualize;
int mccchannel_14_analyzer_1_array_crystal_array_7_target_index;
MCNUM mccchannel_14_analyzer_1_array_crystal_array_7_target_x;
MCNUM mccchannel_14_analyzer_1_array_crystal_array_7_target_y;
MCNUM mccchannel_14_analyzer_1_array_crystal_array_7_target_z;
MCNUM mccchannel_14_analyzer_1_array_crystal_array_7_focus_aw;
MCNUM mccchannel_14_analyzer_1_array_crystal_array_7_focus_ah;
MCNUM mccchannel_14_analyzer_1_array_crystal_array_7_focus_xw;
MCNUM mccchannel_14_analyzer_1_array_crystal_array_7_focus_xh;
MCNUM mccchannel_14_analyzer_1_array_crystal_array_7_focus_r;
MCNUM mccchannel_14_analyzer_1_array_crystal_array_7_p_interact;
char mccchannel_14_analyzer_1_array_crystal_array_7_mask_string[16384];
char mccchannel_14_analyzer_1_array_crystal_array_7_mask_setting[16384];
MCNUM mccchannel_14_analyzer_1_array_crystal_array_7_number_of_activations;

/* Setting parameters for component 'channel_14_analyzer_1_array_crystal_array_8' [670]. */
char mccchannel_14_analyzer_1_array_crystal_array_8_material_string[16384];
MCNUM mccchannel_14_analyzer_1_array_crystal_array_8_priority;
MCNUM mccchannel_14_analyzer_1_array_crystal_array_8_xwidth;
MCNUM mccchannel_14_analyzer_1_array_crystal_array_8_yheight;
MCNUM mccchannel_14_analyzer_1_array_crystal_array_8_zdepth;
MCNUM mccchannel_14_analyzer_1_array_crystal_array_8_xwidth2;
MCNUM mccchannel_14_analyzer_1_array_crystal_array_8_yheight2;
MCNUM mccchannel_14_analyzer_1_array_crystal_array_8_visualize;
int mccchannel_14_analyzer_1_array_crystal_array_8_target_index;
MCNUM mccchannel_14_analyzer_1_array_crystal_array_8_target_x;
MCNUM mccchannel_14_analyzer_1_array_crystal_array_8_target_y;
MCNUM mccchannel_14_analyzer_1_array_crystal_array_8_target_z;
MCNUM mccchannel_14_analyzer_1_array_crystal_array_8_focus_aw;
MCNUM mccchannel_14_analyzer_1_array_crystal_array_8_focus_ah;
MCNUM mccchannel_14_analyzer_1_array_crystal_array_8_focus_xw;
MCNUM mccchannel_14_analyzer_1_array_crystal_array_8_focus_xh;
MCNUM mccchannel_14_analyzer_1_array_crystal_array_8_focus_r;
MCNUM mccchannel_14_analyzer_1_array_crystal_array_8_p_interact;
char mccchannel_14_analyzer_1_array_crystal_array_8_mask_string[16384];
char mccchannel_14_analyzer_1_array_crystal_array_8_mask_setting[16384];
MCNUM mccchannel_14_analyzer_1_array_crystal_array_8_number_of_activations;

/* Setting parameters for component 'channel_14_analyzer_2_array_crystal_array_0' [673]. */
char mccchannel_14_analyzer_2_array_crystal_array_0_material_string[16384];
MCNUM mccchannel_14_analyzer_2_array_crystal_array_0_priority;
MCNUM mccchannel_14_analyzer_2_array_crystal_array_0_xwidth;
MCNUM mccchannel_14_analyzer_2_array_crystal_array_0_yheight;
MCNUM mccchannel_14_analyzer_2_array_crystal_array_0_zdepth;
MCNUM mccchannel_14_analyzer_2_array_crystal_array_0_xwidth2;
MCNUM mccchannel_14_analyzer_2_array_crystal_array_0_yheight2;
MCNUM mccchannel_14_analyzer_2_array_crystal_array_0_visualize;
int mccchannel_14_analyzer_2_array_crystal_array_0_target_index;
MCNUM mccchannel_14_analyzer_2_array_crystal_array_0_target_x;
MCNUM mccchannel_14_analyzer_2_array_crystal_array_0_target_y;
MCNUM mccchannel_14_analyzer_2_array_crystal_array_0_target_z;
MCNUM mccchannel_14_analyzer_2_array_crystal_array_0_focus_aw;
MCNUM mccchannel_14_analyzer_2_array_crystal_array_0_focus_ah;
MCNUM mccchannel_14_analyzer_2_array_crystal_array_0_focus_xw;
MCNUM mccchannel_14_analyzer_2_array_crystal_array_0_focus_xh;
MCNUM mccchannel_14_analyzer_2_array_crystal_array_0_focus_r;
MCNUM mccchannel_14_analyzer_2_array_crystal_array_0_p_interact;
char mccchannel_14_analyzer_2_array_crystal_array_0_mask_string[16384];
char mccchannel_14_analyzer_2_array_crystal_array_0_mask_setting[16384];
MCNUM mccchannel_14_analyzer_2_array_crystal_array_0_number_of_activations;

/* Setting parameters for component 'channel_14_analyzer_2_array_crystal_array_1' [674]. */
char mccchannel_14_analyzer_2_array_crystal_array_1_material_string[16384];
MCNUM mccchannel_14_analyzer_2_array_crystal_array_1_priority;
MCNUM mccchannel_14_analyzer_2_array_crystal_array_1_xwidth;
MCNUM mccchannel_14_analyzer_2_array_crystal_array_1_yheight;
MCNUM mccchannel_14_analyzer_2_array_crystal_array_1_zdepth;
MCNUM mccchannel_14_analyzer_2_array_crystal_array_1_xwidth2;
MCNUM mccchannel_14_analyzer_2_array_crystal_array_1_yheight2;
MCNUM mccchannel_14_analyzer_2_array_crystal_array_1_visualize;
int mccchannel_14_analyzer_2_array_crystal_array_1_target_index;
MCNUM mccchannel_14_analyzer_2_array_crystal_array_1_target_x;
MCNUM mccchannel_14_analyzer_2_array_crystal_array_1_target_y;
MCNUM mccchannel_14_analyzer_2_array_crystal_array_1_target_z;
MCNUM mccchannel_14_analyzer_2_array_crystal_array_1_focus_aw;
MCNUM mccchannel_14_analyzer_2_array_crystal_array_1_focus_ah;
MCNUM mccchannel_14_analyzer_2_array_crystal_array_1_focus_xw;
MCNUM mccchannel_14_analyzer_2_array_crystal_array_1_focus_xh;
MCNUM mccchannel_14_analyzer_2_array_crystal_array_1_focus_r;
MCNUM mccchannel_14_analyzer_2_array_crystal_array_1_p_interact;
char mccchannel_14_analyzer_2_array_crystal_array_1_mask_string[16384];
char mccchannel_14_analyzer_2_array_crystal_array_1_mask_setting[16384];
MCNUM mccchannel_14_analyzer_2_array_crystal_array_1_number_of_activations;

/* Setting parameters for component 'channel_14_analyzer_2_array_crystal_array_2' [675]. */
char mccchannel_14_analyzer_2_array_crystal_array_2_material_string[16384];
MCNUM mccchannel_14_analyzer_2_array_crystal_array_2_priority;
MCNUM mccchannel_14_analyzer_2_array_crystal_array_2_xwidth;
MCNUM mccchannel_14_analyzer_2_array_crystal_array_2_yheight;
MCNUM mccchannel_14_analyzer_2_array_crystal_array_2_zdepth;
MCNUM mccchannel_14_analyzer_2_array_crystal_array_2_xwidth2;
MCNUM mccchannel_14_analyzer_2_array_crystal_array_2_yheight2;
MCNUM mccchannel_14_analyzer_2_array_crystal_array_2_visualize;
int mccchannel_14_analyzer_2_array_crystal_array_2_target_index;
MCNUM mccchannel_14_analyzer_2_array_crystal_array_2_target_x;
MCNUM mccchannel_14_analyzer_2_array_crystal_array_2_target_y;
MCNUM mccchannel_14_analyzer_2_array_crystal_array_2_target_z;
MCNUM mccchannel_14_analyzer_2_array_crystal_array_2_focus_aw;
MCNUM mccchannel_14_analyzer_2_array_crystal_array_2_focus_ah;
MCNUM mccchannel_14_analyzer_2_array_crystal_array_2_focus_xw;
MCNUM mccchannel_14_analyzer_2_array_crystal_array_2_focus_xh;
MCNUM mccchannel_14_analyzer_2_array_crystal_array_2_focus_r;
MCNUM mccchannel_14_analyzer_2_array_crystal_array_2_p_interact;
char mccchannel_14_analyzer_2_array_crystal_array_2_mask_string[16384];
char mccchannel_14_analyzer_2_array_crystal_array_2_mask_setting[16384];
MCNUM mccchannel_14_analyzer_2_array_crystal_array_2_number_of_activations;

/* Setting parameters for component 'channel_14_analyzer_2_array_crystal_array_3' [676]. */
char mccchannel_14_analyzer_2_array_crystal_array_3_material_string[16384];
MCNUM mccchannel_14_analyzer_2_array_crystal_array_3_priority;
MCNUM mccchannel_14_analyzer_2_array_crystal_array_3_xwidth;
MCNUM mccchannel_14_analyzer_2_array_crystal_array_3_yheight;
MCNUM mccchannel_14_analyzer_2_array_crystal_array_3_zdepth;
MCNUM mccchannel_14_analyzer_2_array_crystal_array_3_xwidth2;
MCNUM mccchannel_14_analyzer_2_array_crystal_array_3_yheight2;
MCNUM mccchannel_14_analyzer_2_array_crystal_array_3_visualize;
int mccchannel_14_analyzer_2_array_crystal_array_3_target_index;
MCNUM mccchannel_14_analyzer_2_array_crystal_array_3_target_x;
MCNUM mccchannel_14_analyzer_2_array_crystal_array_3_target_y;
MCNUM mccchannel_14_analyzer_2_array_crystal_array_3_target_z;
MCNUM mccchannel_14_analyzer_2_array_crystal_array_3_focus_aw;
MCNUM mccchannel_14_analyzer_2_array_crystal_array_3_focus_ah;
MCNUM mccchannel_14_analyzer_2_array_crystal_array_3_focus_xw;
MCNUM mccchannel_14_analyzer_2_array_crystal_array_3_focus_xh;
MCNUM mccchannel_14_analyzer_2_array_crystal_array_3_focus_r;
MCNUM mccchannel_14_analyzer_2_array_crystal_array_3_p_interact;
char mccchannel_14_analyzer_2_array_crystal_array_3_mask_string[16384];
char mccchannel_14_analyzer_2_array_crystal_array_3_mask_setting[16384];
MCNUM mccchannel_14_analyzer_2_array_crystal_array_3_number_of_activations;

/* Setting parameters for component 'channel_14_analyzer_2_array_crystal_array_4' [677]. */
char mccchannel_14_analyzer_2_array_crystal_array_4_material_string[16384];
MCNUM mccchannel_14_analyzer_2_array_crystal_array_4_priority;
MCNUM mccchannel_14_analyzer_2_array_crystal_array_4_xwidth;
MCNUM mccchannel_14_analyzer_2_array_crystal_array_4_yheight;
MCNUM mccchannel_14_analyzer_2_array_crystal_array_4_zdepth;
MCNUM mccchannel_14_analyzer_2_array_crystal_array_4_xwidth2;
MCNUM mccchannel_14_analyzer_2_array_crystal_array_4_yheight2;
MCNUM mccchannel_14_analyzer_2_array_crystal_array_4_visualize;
int mccchannel_14_analyzer_2_array_crystal_array_4_target_index;
MCNUM mccchannel_14_analyzer_2_array_crystal_array_4_target_x;
MCNUM mccchannel_14_analyzer_2_array_crystal_array_4_target_y;
MCNUM mccchannel_14_analyzer_2_array_crystal_array_4_target_z;
MCNUM mccchannel_14_analyzer_2_array_crystal_array_4_focus_aw;
MCNUM mccchannel_14_analyzer_2_array_crystal_array_4_focus_ah;
MCNUM mccchannel_14_analyzer_2_array_crystal_array_4_focus_xw;
MCNUM mccchannel_14_analyzer_2_array_crystal_array_4_focus_xh;
MCNUM mccchannel_14_analyzer_2_array_crystal_array_4_focus_r;
MCNUM mccchannel_14_analyzer_2_array_crystal_array_4_p_interact;
char mccchannel_14_analyzer_2_array_crystal_array_4_mask_string[16384];
char mccchannel_14_analyzer_2_array_crystal_array_4_mask_setting[16384];
MCNUM mccchannel_14_analyzer_2_array_crystal_array_4_number_of_activations;

/* Setting parameters for component 'channel_14_analyzer_2_array_crystal_array_5' [678]. */
char mccchannel_14_analyzer_2_array_crystal_array_5_material_string[16384];
MCNUM mccchannel_14_analyzer_2_array_crystal_array_5_priority;
MCNUM mccchannel_14_analyzer_2_array_crystal_array_5_xwidth;
MCNUM mccchannel_14_analyzer_2_array_crystal_array_5_yheight;
MCNUM mccchannel_14_analyzer_2_array_crystal_array_5_zdepth;
MCNUM mccchannel_14_analyzer_2_array_crystal_array_5_xwidth2;
MCNUM mccchannel_14_analyzer_2_array_crystal_array_5_yheight2;
MCNUM mccchannel_14_analyzer_2_array_crystal_array_5_visualize;
int mccchannel_14_analyzer_2_array_crystal_array_5_target_index;
MCNUM mccchannel_14_analyzer_2_array_crystal_array_5_target_x;
MCNUM mccchannel_14_analyzer_2_array_crystal_array_5_target_y;
MCNUM mccchannel_14_analyzer_2_array_crystal_array_5_target_z;
MCNUM mccchannel_14_analyzer_2_array_crystal_array_5_focus_aw;
MCNUM mccchannel_14_analyzer_2_array_crystal_array_5_focus_ah;
MCNUM mccchannel_14_analyzer_2_array_crystal_array_5_focus_xw;
MCNUM mccchannel_14_analyzer_2_array_crystal_array_5_focus_xh;
MCNUM mccchannel_14_analyzer_2_array_crystal_array_5_focus_r;
MCNUM mccchannel_14_analyzer_2_array_crystal_array_5_p_interact;
char mccchannel_14_analyzer_2_array_crystal_array_5_mask_string[16384];
char mccchannel_14_analyzer_2_array_crystal_array_5_mask_setting[16384];
MCNUM mccchannel_14_analyzer_2_array_crystal_array_5_number_of_activations;

/* Setting parameters for component 'channel_14_analyzer_2_array_crystal_array_6' [679]. */
char mccchannel_14_analyzer_2_array_crystal_array_6_material_string[16384];
MCNUM mccchannel_14_analyzer_2_array_crystal_array_6_priority;
MCNUM mccchannel_14_analyzer_2_array_crystal_array_6_xwidth;
MCNUM mccchannel_14_analyzer_2_array_crystal_array_6_yheight;
MCNUM mccchannel_14_analyzer_2_array_crystal_array_6_zdepth;
MCNUM mccchannel_14_analyzer_2_array_crystal_array_6_xwidth2;
MCNUM mccchannel_14_analyzer_2_array_crystal_array_6_yheight2;
MCNUM mccchannel_14_analyzer_2_array_crystal_array_6_visualize;
int mccchannel_14_analyzer_2_array_crystal_array_6_target_index;
MCNUM mccchannel_14_analyzer_2_array_crystal_array_6_target_x;
MCNUM mccchannel_14_analyzer_2_array_crystal_array_6_target_y;
MCNUM mccchannel_14_analyzer_2_array_crystal_array_6_target_z;
MCNUM mccchannel_14_analyzer_2_array_crystal_array_6_focus_aw;
MCNUM mccchannel_14_analyzer_2_array_crystal_array_6_focus_ah;
MCNUM mccchannel_14_analyzer_2_array_crystal_array_6_focus_xw;
MCNUM mccchannel_14_analyzer_2_array_crystal_array_6_focus_xh;
MCNUM mccchannel_14_analyzer_2_array_crystal_array_6_focus_r;
MCNUM mccchannel_14_analyzer_2_array_crystal_array_6_p_interact;
char mccchannel_14_analyzer_2_array_crystal_array_6_mask_string[16384];
char mccchannel_14_analyzer_2_array_crystal_array_6_mask_setting[16384];
MCNUM mccchannel_14_analyzer_2_array_crystal_array_6_number_of_activations;

/* Setting parameters for component 'channel_14_analyzer_2_array_crystal_array_7' [680]. */
char mccchannel_14_analyzer_2_array_crystal_array_7_material_string[16384];
MCNUM mccchannel_14_analyzer_2_array_crystal_array_7_priority;
MCNUM mccchannel_14_analyzer_2_array_crystal_array_7_xwidth;
MCNUM mccchannel_14_analyzer_2_array_crystal_array_7_yheight;
MCNUM mccchannel_14_analyzer_2_array_crystal_array_7_zdepth;
MCNUM mccchannel_14_analyzer_2_array_crystal_array_7_xwidth2;
MCNUM mccchannel_14_analyzer_2_array_crystal_array_7_yheight2;
MCNUM mccchannel_14_analyzer_2_array_crystal_array_7_visualize;
int mccchannel_14_analyzer_2_array_crystal_array_7_target_index;
MCNUM mccchannel_14_analyzer_2_array_crystal_array_7_target_x;
MCNUM mccchannel_14_analyzer_2_array_crystal_array_7_target_y;
MCNUM mccchannel_14_analyzer_2_array_crystal_array_7_target_z;
MCNUM mccchannel_14_analyzer_2_array_crystal_array_7_focus_aw;
MCNUM mccchannel_14_analyzer_2_array_crystal_array_7_focus_ah;
MCNUM mccchannel_14_analyzer_2_array_crystal_array_7_focus_xw;
MCNUM mccchannel_14_analyzer_2_array_crystal_array_7_focus_xh;
MCNUM mccchannel_14_analyzer_2_array_crystal_array_7_focus_r;
MCNUM mccchannel_14_analyzer_2_array_crystal_array_7_p_interact;
char mccchannel_14_analyzer_2_array_crystal_array_7_mask_string[16384];
char mccchannel_14_analyzer_2_array_crystal_array_7_mask_setting[16384];
MCNUM mccchannel_14_analyzer_2_array_crystal_array_7_number_of_activations;

/* Setting parameters for component 'channel_14_analyzer_2_array_crystal_array_8' [681]. */
char mccchannel_14_analyzer_2_array_crystal_array_8_material_string[16384];
MCNUM mccchannel_14_analyzer_2_array_crystal_array_8_priority;
MCNUM mccchannel_14_analyzer_2_array_crystal_array_8_xwidth;
MCNUM mccchannel_14_analyzer_2_array_crystal_array_8_yheight;
MCNUM mccchannel_14_analyzer_2_array_crystal_array_8_zdepth;
MCNUM mccchannel_14_analyzer_2_array_crystal_array_8_xwidth2;
MCNUM mccchannel_14_analyzer_2_array_crystal_array_8_yheight2;
MCNUM mccchannel_14_analyzer_2_array_crystal_array_8_visualize;
int mccchannel_14_analyzer_2_array_crystal_array_8_target_index;
MCNUM mccchannel_14_analyzer_2_array_crystal_array_8_target_x;
MCNUM mccchannel_14_analyzer_2_array_crystal_array_8_target_y;
MCNUM mccchannel_14_analyzer_2_array_crystal_array_8_target_z;
MCNUM mccchannel_14_analyzer_2_array_crystal_array_8_focus_aw;
MCNUM mccchannel_14_analyzer_2_array_crystal_array_8_focus_ah;
MCNUM mccchannel_14_analyzer_2_array_crystal_array_8_focus_xw;
MCNUM mccchannel_14_analyzer_2_array_crystal_array_8_focus_xh;
MCNUM mccchannel_14_analyzer_2_array_crystal_array_8_focus_r;
MCNUM mccchannel_14_analyzer_2_array_crystal_array_8_p_interact;
char mccchannel_14_analyzer_2_array_crystal_array_8_mask_string[16384];
char mccchannel_14_analyzer_2_array_crystal_array_8_mask_setting[16384];
MCNUM mccchannel_14_analyzer_2_array_crystal_array_8_number_of_activations;

/* Setting parameters for component 'channel_14_cave2_cyl1' [682]. */
char mccchannel_14_cave2_cyl1_material_string[16384];
MCNUM mccchannel_14_cave2_cyl1_priority;
MCNUM mccchannel_14_cave2_cyl1_radius;
MCNUM mccchannel_14_cave2_cyl1_yheight;
MCNUM mccchannel_14_cave2_cyl1_visualize;
int mccchannel_14_cave2_cyl1_target_index;
MCNUM mccchannel_14_cave2_cyl1_target_x;
MCNUM mccchannel_14_cave2_cyl1_target_y;
MCNUM mccchannel_14_cave2_cyl1_target_z;
MCNUM mccchannel_14_cave2_cyl1_focus_aw;
MCNUM mccchannel_14_cave2_cyl1_focus_ah;
MCNUM mccchannel_14_cave2_cyl1_focus_xw;
MCNUM mccchannel_14_cave2_cyl1_focus_xh;
MCNUM mccchannel_14_cave2_cyl1_focus_r;
MCNUM mccchannel_14_cave2_cyl1_p_interact;
char mccchannel_14_cave2_cyl1_mask_string[16384];
char mccchannel_14_cave2_cyl1_mask_setting[16384];
MCNUM mccchannel_14_cave2_cyl1_number_of_activations;

/* Setting parameters for component 'channel_14_cave2_box1' [683]. */
char mccchannel_14_cave2_box1_material_string[16384];
MCNUM mccchannel_14_cave2_box1_priority;
MCNUM mccchannel_14_cave2_box1_xwidth;
MCNUM mccchannel_14_cave2_box1_yheight;
MCNUM mccchannel_14_cave2_box1_zdepth;
MCNUM mccchannel_14_cave2_box1_xwidth2;
MCNUM mccchannel_14_cave2_box1_yheight2;
MCNUM mccchannel_14_cave2_box1_visualize;
int mccchannel_14_cave2_box1_target_index;
MCNUM mccchannel_14_cave2_box1_target_x;
MCNUM mccchannel_14_cave2_box1_target_y;
MCNUM mccchannel_14_cave2_box1_target_z;
MCNUM mccchannel_14_cave2_box1_focus_aw;
MCNUM mccchannel_14_cave2_box1_focus_ah;
MCNUM mccchannel_14_cave2_box1_focus_xw;
MCNUM mccchannel_14_cave2_box1_focus_xh;
MCNUM mccchannel_14_cave2_box1_focus_r;
MCNUM mccchannel_14_cave2_box1_p_interact;
char mccchannel_14_cave2_box1_mask_string[16384];
char mccchannel_14_cave2_box1_mask_setting[16384];
MCNUM mccchannel_14_cave2_box1_number_of_activations;

/* Setting parameters for component 'channel_14_cave2_box2' [684]. */
char mccchannel_14_cave2_box2_material_string[16384];
MCNUM mccchannel_14_cave2_box2_priority;
MCNUM mccchannel_14_cave2_box2_xwidth;
MCNUM mccchannel_14_cave2_box2_yheight;
MCNUM mccchannel_14_cave2_box2_zdepth;
MCNUM mccchannel_14_cave2_box2_xwidth2;
MCNUM mccchannel_14_cave2_box2_yheight2;
MCNUM mccchannel_14_cave2_box2_visualize;
int mccchannel_14_cave2_box2_target_index;
MCNUM mccchannel_14_cave2_box2_target_x;
MCNUM mccchannel_14_cave2_box2_target_y;
MCNUM mccchannel_14_cave2_box2_target_z;
MCNUM mccchannel_14_cave2_box2_focus_aw;
MCNUM mccchannel_14_cave2_box2_focus_ah;
MCNUM mccchannel_14_cave2_box2_focus_xw;
MCNUM mccchannel_14_cave2_box2_focus_xh;
MCNUM mccchannel_14_cave2_box2_focus_r;
MCNUM mccchannel_14_cave2_box2_p_interact;
char mccchannel_14_cave2_box2_mask_string[16384];
char mccchannel_14_cave2_box2_mask_setting[16384];
MCNUM mccchannel_14_cave2_box2_number_of_activations;

/* Setting parameters for component 'channel_14_cave2_box3' [685]. */
char mccchannel_14_cave2_box3_material_string[16384];
MCNUM mccchannel_14_cave2_box3_priority;
MCNUM mccchannel_14_cave2_box3_xwidth;
MCNUM mccchannel_14_cave2_box3_yheight;
MCNUM mccchannel_14_cave2_box3_zdepth;
MCNUM mccchannel_14_cave2_box3_xwidth2;
MCNUM mccchannel_14_cave2_box3_yheight2;
MCNUM mccchannel_14_cave2_box3_visualize;
int mccchannel_14_cave2_box3_target_index;
MCNUM mccchannel_14_cave2_box3_target_x;
MCNUM mccchannel_14_cave2_box3_target_y;
MCNUM mccchannel_14_cave2_box3_target_z;
MCNUM mccchannel_14_cave2_box3_focus_aw;
MCNUM mccchannel_14_cave2_box3_focus_ah;
MCNUM mccchannel_14_cave2_box3_focus_xw;
MCNUM mccchannel_14_cave2_box3_focus_xh;
MCNUM mccchannel_14_cave2_box3_focus_r;
MCNUM mccchannel_14_cave2_box3_p_interact;
char mccchannel_14_cave2_box3_mask_string[16384];
char mccchannel_14_cave2_box3_mask_setting[16384];
MCNUM mccchannel_14_cave2_box3_number_of_activations;

/* Setting parameters for component 'inter_analyzer_colimator_14_blade_0' [687]. */
char mccinter_analyzer_colimator_14_blade_0_material_string[16384];
MCNUM mccinter_analyzer_colimator_14_blade_0_priority;
MCNUM mccinter_analyzer_colimator_14_blade_0_xwidth;
MCNUM mccinter_analyzer_colimator_14_blade_0_yheight;
MCNUM mccinter_analyzer_colimator_14_blade_0_zdepth;
MCNUM mccinter_analyzer_colimator_14_blade_0_xwidth2;
MCNUM mccinter_analyzer_colimator_14_blade_0_yheight2;
MCNUM mccinter_analyzer_colimator_14_blade_0_visualize;
int mccinter_analyzer_colimator_14_blade_0_target_index;
MCNUM mccinter_analyzer_colimator_14_blade_0_target_x;
MCNUM mccinter_analyzer_colimator_14_blade_0_target_y;
MCNUM mccinter_analyzer_colimator_14_blade_0_target_z;
MCNUM mccinter_analyzer_colimator_14_blade_0_focus_aw;
MCNUM mccinter_analyzer_colimator_14_blade_0_focus_ah;
MCNUM mccinter_analyzer_colimator_14_blade_0_focus_xw;
MCNUM mccinter_analyzer_colimator_14_blade_0_focus_xh;
MCNUM mccinter_analyzer_colimator_14_blade_0_focus_r;
MCNUM mccinter_analyzer_colimator_14_blade_0_p_interact;
char mccinter_analyzer_colimator_14_blade_0_mask_string[16384];
char mccinter_analyzer_colimator_14_blade_0_mask_setting[16384];
MCNUM mccinter_analyzer_colimator_14_blade_0_number_of_activations;

/* Setting parameters for component 'inter_analyzer_colimator_14_blade_1' [688]. */
char mccinter_analyzer_colimator_14_blade_1_material_string[16384];
MCNUM mccinter_analyzer_colimator_14_blade_1_priority;
MCNUM mccinter_analyzer_colimator_14_blade_1_xwidth;
MCNUM mccinter_analyzer_colimator_14_blade_1_yheight;
MCNUM mccinter_analyzer_colimator_14_blade_1_zdepth;
MCNUM mccinter_analyzer_colimator_14_blade_1_xwidth2;
MCNUM mccinter_analyzer_colimator_14_blade_1_yheight2;
MCNUM mccinter_analyzer_colimator_14_blade_1_visualize;
int mccinter_analyzer_colimator_14_blade_1_target_index;
MCNUM mccinter_analyzer_colimator_14_blade_1_target_x;
MCNUM mccinter_analyzer_colimator_14_blade_1_target_y;
MCNUM mccinter_analyzer_colimator_14_blade_1_target_z;
MCNUM mccinter_analyzer_colimator_14_blade_1_focus_aw;
MCNUM mccinter_analyzer_colimator_14_blade_1_focus_ah;
MCNUM mccinter_analyzer_colimator_14_blade_1_focus_xw;
MCNUM mccinter_analyzer_colimator_14_blade_1_focus_xh;
MCNUM mccinter_analyzer_colimator_14_blade_1_focus_r;
MCNUM mccinter_analyzer_colimator_14_blade_1_p_interact;
char mccinter_analyzer_colimator_14_blade_1_mask_string[16384];
char mccinter_analyzer_colimator_14_blade_1_mask_setting[16384];
MCNUM mccinter_analyzer_colimator_14_blade_1_number_of_activations;

/* Setting parameters for component 'inter_analyzer_colimator_14_blade_2' [689]. */
char mccinter_analyzer_colimator_14_blade_2_material_string[16384];
MCNUM mccinter_analyzer_colimator_14_blade_2_priority;
MCNUM mccinter_analyzer_colimator_14_blade_2_xwidth;
MCNUM mccinter_analyzer_colimator_14_blade_2_yheight;
MCNUM mccinter_analyzer_colimator_14_blade_2_zdepth;
MCNUM mccinter_analyzer_colimator_14_blade_2_xwidth2;
MCNUM mccinter_analyzer_colimator_14_blade_2_yheight2;
MCNUM mccinter_analyzer_colimator_14_blade_2_visualize;
int mccinter_analyzer_colimator_14_blade_2_target_index;
MCNUM mccinter_analyzer_colimator_14_blade_2_target_x;
MCNUM mccinter_analyzer_colimator_14_blade_2_target_y;
MCNUM mccinter_analyzer_colimator_14_blade_2_target_z;
MCNUM mccinter_analyzer_colimator_14_blade_2_focus_aw;
MCNUM mccinter_analyzer_colimator_14_blade_2_focus_ah;
MCNUM mccinter_analyzer_colimator_14_blade_2_focus_xw;
MCNUM mccinter_analyzer_colimator_14_blade_2_focus_xh;
MCNUM mccinter_analyzer_colimator_14_blade_2_focus_r;
MCNUM mccinter_analyzer_colimator_14_blade_2_p_interact;
char mccinter_analyzer_colimator_14_blade_2_mask_string[16384];
char mccinter_analyzer_colimator_14_blade_2_mask_setting[16384];
MCNUM mccinter_analyzer_colimator_14_blade_2_number_of_activations;

/* Setting parameters for component 'inter_analyzer_colimator_14_blade_3' [690]. */
char mccinter_analyzer_colimator_14_blade_3_material_string[16384];
MCNUM mccinter_analyzer_colimator_14_blade_3_priority;
MCNUM mccinter_analyzer_colimator_14_blade_3_xwidth;
MCNUM mccinter_analyzer_colimator_14_blade_3_yheight;
MCNUM mccinter_analyzer_colimator_14_blade_3_zdepth;
MCNUM mccinter_analyzer_colimator_14_blade_3_xwidth2;
MCNUM mccinter_analyzer_colimator_14_blade_3_yheight2;
MCNUM mccinter_analyzer_colimator_14_blade_3_visualize;
int mccinter_analyzer_colimator_14_blade_3_target_index;
MCNUM mccinter_analyzer_colimator_14_blade_3_target_x;
MCNUM mccinter_analyzer_colimator_14_blade_3_target_y;
MCNUM mccinter_analyzer_colimator_14_blade_3_target_z;
MCNUM mccinter_analyzer_colimator_14_blade_3_focus_aw;
MCNUM mccinter_analyzer_colimator_14_blade_3_focus_ah;
MCNUM mccinter_analyzer_colimator_14_blade_3_focus_xw;
MCNUM mccinter_analyzer_colimator_14_blade_3_focus_xh;
MCNUM mccinter_analyzer_colimator_14_blade_3_focus_r;
MCNUM mccinter_analyzer_colimator_14_blade_3_p_interact;
char mccinter_analyzer_colimator_14_blade_3_mask_string[16384];
char mccinter_analyzer_colimator_14_blade_3_mask_setting[16384];
MCNUM mccinter_analyzer_colimator_14_blade_3_number_of_activations;

/* Setting parameters for component 'inter_analyzer_colimator_14_blade_4' [691]. */
char mccinter_analyzer_colimator_14_blade_4_material_string[16384];
MCNUM mccinter_analyzer_colimator_14_blade_4_priority;
MCNUM mccinter_analyzer_colimator_14_blade_4_xwidth;
MCNUM mccinter_analyzer_colimator_14_blade_4_yheight;
MCNUM mccinter_analyzer_colimator_14_blade_4_zdepth;
MCNUM mccinter_analyzer_colimator_14_blade_4_xwidth2;
MCNUM mccinter_analyzer_colimator_14_blade_4_yheight2;
MCNUM mccinter_analyzer_colimator_14_blade_4_visualize;
int mccinter_analyzer_colimator_14_blade_4_target_index;
MCNUM mccinter_analyzer_colimator_14_blade_4_target_x;
MCNUM mccinter_analyzer_colimator_14_blade_4_target_y;
MCNUM mccinter_analyzer_colimator_14_blade_4_target_z;
MCNUM mccinter_analyzer_colimator_14_blade_4_focus_aw;
MCNUM mccinter_analyzer_colimator_14_blade_4_focus_ah;
MCNUM mccinter_analyzer_colimator_14_blade_4_focus_xw;
MCNUM mccinter_analyzer_colimator_14_blade_4_focus_xh;
MCNUM mccinter_analyzer_colimator_14_blade_4_focus_r;
MCNUM mccinter_analyzer_colimator_14_blade_4_p_interact;
char mccinter_analyzer_colimator_14_blade_4_mask_string[16384];
char mccinter_analyzer_colimator_14_blade_4_mask_setting[16384];
MCNUM mccinter_analyzer_colimator_14_blade_4_number_of_activations;

/* Setting parameters for component 'diffraction_detector_14_exit_volume' [692]. */
char mccdiffraction_detector_14_exit_volume_material_string[16384];
MCNUM mccdiffraction_detector_14_exit_volume_priority;
MCNUM mccdiffraction_detector_14_exit_volume_xwidth;
MCNUM mccdiffraction_detector_14_exit_volume_yheight;
MCNUM mccdiffraction_detector_14_exit_volume_zdepth;
MCNUM mccdiffraction_detector_14_exit_volume_xwidth2;
MCNUM mccdiffraction_detector_14_exit_volume_yheight2;
MCNUM mccdiffraction_detector_14_exit_volume_visualize;
int mccdiffraction_detector_14_exit_volume_target_index;
MCNUM mccdiffraction_detector_14_exit_volume_target_x;
MCNUM mccdiffraction_detector_14_exit_volume_target_y;
MCNUM mccdiffraction_detector_14_exit_volume_target_z;
MCNUM mccdiffraction_detector_14_exit_volume_focus_aw;
MCNUM mccdiffraction_detector_14_exit_volume_focus_ah;
MCNUM mccdiffraction_detector_14_exit_volume_focus_xw;
MCNUM mccdiffraction_detector_14_exit_volume_focus_xh;
MCNUM mccdiffraction_detector_14_exit_volume_focus_r;
MCNUM mccdiffraction_detector_14_exit_volume_p_interact;
char mccdiffraction_detector_14_exit_volume_mask_string[16384];
char mccdiffraction_detector_14_exit_volume_mask_setting[16384];
MCNUM mccdiffraction_detector_14_exit_volume_number_of_activations;

/* Setting parameters for component 'spec_detector_14_exit_volume' [693]. */
char mccspec_detector_14_exit_volume_material_string[16384];
MCNUM mccspec_detector_14_exit_volume_priority;
MCNUM mccspec_detector_14_exit_volume_xwidth;
MCNUM mccspec_detector_14_exit_volume_yheight;
MCNUM mccspec_detector_14_exit_volume_zdepth;
MCNUM mccspec_detector_14_exit_volume_xwidth2;
MCNUM mccspec_detector_14_exit_volume_yheight2;
MCNUM mccspec_detector_14_exit_volume_visualize;
int mccspec_detector_14_exit_volume_target_index;
MCNUM mccspec_detector_14_exit_volume_target_x;
MCNUM mccspec_detector_14_exit_volume_target_y;
MCNUM mccspec_detector_14_exit_volume_target_z;
MCNUM mccspec_detector_14_exit_volume_focus_aw;
MCNUM mccspec_detector_14_exit_volume_focus_ah;
MCNUM mccspec_detector_14_exit_volume_focus_xw;
MCNUM mccspec_detector_14_exit_volume_focus_xh;
MCNUM mccspec_detector_14_exit_volume_focus_r;
MCNUM mccspec_detector_14_exit_volume_p_interact;
char mccspec_detector_14_exit_volume_mask_string[16384];
char mccspec_detector_14_exit_volume_mask_setting[16384];
MCNUM mccspec_detector_14_exit_volume_number_of_activations;

/* Setting parameters for component 'channel_15_cave1_box1' [694]. */
char mccchannel_15_cave1_box1_material_string[16384];
MCNUM mccchannel_15_cave1_box1_priority;
MCNUM mccchannel_15_cave1_box1_xwidth;
MCNUM mccchannel_15_cave1_box1_yheight;
MCNUM mccchannel_15_cave1_box1_zdepth;
MCNUM mccchannel_15_cave1_box1_xwidth2;
MCNUM mccchannel_15_cave1_box1_yheight2;
MCNUM mccchannel_15_cave1_box1_visualize;
int mccchannel_15_cave1_box1_target_index;
MCNUM mccchannel_15_cave1_box1_target_x;
MCNUM mccchannel_15_cave1_box1_target_y;
MCNUM mccchannel_15_cave1_box1_target_z;
MCNUM mccchannel_15_cave1_box1_focus_aw;
MCNUM mccchannel_15_cave1_box1_focus_ah;
MCNUM mccchannel_15_cave1_box1_focus_xw;
MCNUM mccchannel_15_cave1_box1_focus_xh;
MCNUM mccchannel_15_cave1_box1_focus_r;
MCNUM mccchannel_15_cave1_box1_p_interact;
char mccchannel_15_cave1_box1_mask_string[16384];
char mccchannel_15_cave1_box1_mask_setting[16384];
MCNUM mccchannel_15_cave1_box1_number_of_activations;

/* Setting parameters for component 'channel_15_cave1_box2' [695]. */
char mccchannel_15_cave1_box2_material_string[16384];
MCNUM mccchannel_15_cave1_box2_priority;
MCNUM mccchannel_15_cave1_box2_xwidth;
MCNUM mccchannel_15_cave1_box2_yheight;
MCNUM mccchannel_15_cave1_box2_zdepth;
MCNUM mccchannel_15_cave1_box2_xwidth2;
MCNUM mccchannel_15_cave1_box2_yheight2;
MCNUM mccchannel_15_cave1_box2_visualize;
int mccchannel_15_cave1_box2_target_index;
MCNUM mccchannel_15_cave1_box2_target_x;
MCNUM mccchannel_15_cave1_box2_target_y;
MCNUM mccchannel_15_cave1_box2_target_z;
MCNUM mccchannel_15_cave1_box2_focus_aw;
MCNUM mccchannel_15_cave1_box2_focus_ah;
MCNUM mccchannel_15_cave1_box2_focus_xw;
MCNUM mccchannel_15_cave1_box2_focus_xh;
MCNUM mccchannel_15_cave1_box2_focus_r;
MCNUM mccchannel_15_cave1_box2_p_interact;
char mccchannel_15_cave1_box2_mask_string[16384];
char mccchannel_15_cave1_box2_mask_setting[16384];
MCNUM mccchannel_15_cave1_box2_number_of_activations;

/* Setting parameters for component 'channel_15_cave1_box3' [696]. */
char mccchannel_15_cave1_box3_material_string[16384];
MCNUM mccchannel_15_cave1_box3_priority;
MCNUM mccchannel_15_cave1_box3_xwidth;
MCNUM mccchannel_15_cave1_box3_yheight;
MCNUM mccchannel_15_cave1_box3_zdepth;
MCNUM mccchannel_15_cave1_box3_xwidth2;
MCNUM mccchannel_15_cave1_box3_yheight2;
MCNUM mccchannel_15_cave1_box3_visualize;
int mccchannel_15_cave1_box3_target_index;
MCNUM mccchannel_15_cave1_box3_target_x;
MCNUM mccchannel_15_cave1_box3_target_y;
MCNUM mccchannel_15_cave1_box3_target_z;
MCNUM mccchannel_15_cave1_box3_focus_aw;
MCNUM mccchannel_15_cave1_box3_focus_ah;
MCNUM mccchannel_15_cave1_box3_focus_xw;
MCNUM mccchannel_15_cave1_box3_focus_xh;
MCNUM mccchannel_15_cave1_box3_focus_r;
MCNUM mccchannel_15_cave1_box3_p_interact;
char mccchannel_15_cave1_box3_mask_string[16384];
char mccchannel_15_cave1_box3_mask_setting[16384];
MCNUM mccchannel_15_cave1_box3_number_of_activations;

/* Setting parameters for component 'channel_15_cave1_cyl1' [697]. */
char mccchannel_15_cave1_cyl1_material_string[16384];
MCNUM mccchannel_15_cave1_cyl1_priority;
MCNUM mccchannel_15_cave1_cyl1_radius;
MCNUM mccchannel_15_cave1_cyl1_yheight;
MCNUM mccchannel_15_cave1_cyl1_visualize;
int mccchannel_15_cave1_cyl1_target_index;
MCNUM mccchannel_15_cave1_cyl1_target_x;
MCNUM mccchannel_15_cave1_cyl1_target_y;
MCNUM mccchannel_15_cave1_cyl1_target_z;
MCNUM mccchannel_15_cave1_cyl1_focus_aw;
MCNUM mccchannel_15_cave1_cyl1_focus_ah;
MCNUM mccchannel_15_cave1_cyl1_focus_xw;
MCNUM mccchannel_15_cave1_cyl1_focus_xh;
MCNUM mccchannel_15_cave1_cyl1_focus_r;
MCNUM mccchannel_15_cave1_cyl1_p_interact;
char mccchannel_15_cave1_cyl1_mask_string[16384];
char mccchannel_15_cave1_cyl1_mask_setting[16384];
MCNUM mccchannel_15_cave1_cyl1_number_of_activations;

/* Setting parameters for component 'channel_15_analyzer_1_array_crystal_array_0' [700]. */
char mccchannel_15_analyzer_1_array_crystal_array_0_material_string[16384];
MCNUM mccchannel_15_analyzer_1_array_crystal_array_0_priority;
MCNUM mccchannel_15_analyzer_1_array_crystal_array_0_xwidth;
MCNUM mccchannel_15_analyzer_1_array_crystal_array_0_yheight;
MCNUM mccchannel_15_analyzer_1_array_crystal_array_0_zdepth;
MCNUM mccchannel_15_analyzer_1_array_crystal_array_0_xwidth2;
MCNUM mccchannel_15_analyzer_1_array_crystal_array_0_yheight2;
MCNUM mccchannel_15_analyzer_1_array_crystal_array_0_visualize;
int mccchannel_15_analyzer_1_array_crystal_array_0_target_index;
MCNUM mccchannel_15_analyzer_1_array_crystal_array_0_target_x;
MCNUM mccchannel_15_analyzer_1_array_crystal_array_0_target_y;
MCNUM mccchannel_15_analyzer_1_array_crystal_array_0_target_z;
MCNUM mccchannel_15_analyzer_1_array_crystal_array_0_focus_aw;
MCNUM mccchannel_15_analyzer_1_array_crystal_array_0_focus_ah;
MCNUM mccchannel_15_analyzer_1_array_crystal_array_0_focus_xw;
MCNUM mccchannel_15_analyzer_1_array_crystal_array_0_focus_xh;
MCNUM mccchannel_15_analyzer_1_array_crystal_array_0_focus_r;
MCNUM mccchannel_15_analyzer_1_array_crystal_array_0_p_interact;
char mccchannel_15_analyzer_1_array_crystal_array_0_mask_string[16384];
char mccchannel_15_analyzer_1_array_crystal_array_0_mask_setting[16384];
MCNUM mccchannel_15_analyzer_1_array_crystal_array_0_number_of_activations;

/* Setting parameters for component 'channel_15_analyzer_1_array_crystal_array_1' [701]. */
char mccchannel_15_analyzer_1_array_crystal_array_1_material_string[16384];
MCNUM mccchannel_15_analyzer_1_array_crystal_array_1_priority;
MCNUM mccchannel_15_analyzer_1_array_crystal_array_1_xwidth;
MCNUM mccchannel_15_analyzer_1_array_crystal_array_1_yheight;
MCNUM mccchannel_15_analyzer_1_array_crystal_array_1_zdepth;
MCNUM mccchannel_15_analyzer_1_array_crystal_array_1_xwidth2;
MCNUM mccchannel_15_analyzer_1_array_crystal_array_1_yheight2;
MCNUM mccchannel_15_analyzer_1_array_crystal_array_1_visualize;
int mccchannel_15_analyzer_1_array_crystal_array_1_target_index;
MCNUM mccchannel_15_analyzer_1_array_crystal_array_1_target_x;
MCNUM mccchannel_15_analyzer_1_array_crystal_array_1_target_y;
MCNUM mccchannel_15_analyzer_1_array_crystal_array_1_target_z;
MCNUM mccchannel_15_analyzer_1_array_crystal_array_1_focus_aw;
MCNUM mccchannel_15_analyzer_1_array_crystal_array_1_focus_ah;
MCNUM mccchannel_15_analyzer_1_array_crystal_array_1_focus_xw;
MCNUM mccchannel_15_analyzer_1_array_crystal_array_1_focus_xh;
MCNUM mccchannel_15_analyzer_1_array_crystal_array_1_focus_r;
MCNUM mccchannel_15_analyzer_1_array_crystal_array_1_p_interact;
char mccchannel_15_analyzer_1_array_crystal_array_1_mask_string[16384];
char mccchannel_15_analyzer_1_array_crystal_array_1_mask_setting[16384];
MCNUM mccchannel_15_analyzer_1_array_crystal_array_1_number_of_activations;

/* Setting parameters for component 'channel_15_analyzer_1_array_crystal_array_2' [702]. */
char mccchannel_15_analyzer_1_array_crystal_array_2_material_string[16384];
MCNUM mccchannel_15_analyzer_1_array_crystal_array_2_priority;
MCNUM mccchannel_15_analyzer_1_array_crystal_array_2_xwidth;
MCNUM mccchannel_15_analyzer_1_array_crystal_array_2_yheight;
MCNUM mccchannel_15_analyzer_1_array_crystal_array_2_zdepth;
MCNUM mccchannel_15_analyzer_1_array_crystal_array_2_xwidth2;
MCNUM mccchannel_15_analyzer_1_array_crystal_array_2_yheight2;
MCNUM mccchannel_15_analyzer_1_array_crystal_array_2_visualize;
int mccchannel_15_analyzer_1_array_crystal_array_2_target_index;
MCNUM mccchannel_15_analyzer_1_array_crystal_array_2_target_x;
MCNUM mccchannel_15_analyzer_1_array_crystal_array_2_target_y;
MCNUM mccchannel_15_analyzer_1_array_crystal_array_2_target_z;
MCNUM mccchannel_15_analyzer_1_array_crystal_array_2_focus_aw;
MCNUM mccchannel_15_analyzer_1_array_crystal_array_2_focus_ah;
MCNUM mccchannel_15_analyzer_1_array_crystal_array_2_focus_xw;
MCNUM mccchannel_15_analyzer_1_array_crystal_array_2_focus_xh;
MCNUM mccchannel_15_analyzer_1_array_crystal_array_2_focus_r;
MCNUM mccchannel_15_analyzer_1_array_crystal_array_2_p_interact;
char mccchannel_15_analyzer_1_array_crystal_array_2_mask_string[16384];
char mccchannel_15_analyzer_1_array_crystal_array_2_mask_setting[16384];
MCNUM mccchannel_15_analyzer_1_array_crystal_array_2_number_of_activations;

/* Setting parameters for component 'channel_15_analyzer_1_array_crystal_array_3' [703]. */
char mccchannel_15_analyzer_1_array_crystal_array_3_material_string[16384];
MCNUM mccchannel_15_analyzer_1_array_crystal_array_3_priority;
MCNUM mccchannel_15_analyzer_1_array_crystal_array_3_xwidth;
MCNUM mccchannel_15_analyzer_1_array_crystal_array_3_yheight;
MCNUM mccchannel_15_analyzer_1_array_crystal_array_3_zdepth;
MCNUM mccchannel_15_analyzer_1_array_crystal_array_3_xwidth2;
MCNUM mccchannel_15_analyzer_1_array_crystal_array_3_yheight2;
MCNUM mccchannel_15_analyzer_1_array_crystal_array_3_visualize;
int mccchannel_15_analyzer_1_array_crystal_array_3_target_index;
MCNUM mccchannel_15_analyzer_1_array_crystal_array_3_target_x;
MCNUM mccchannel_15_analyzer_1_array_crystal_array_3_target_y;
MCNUM mccchannel_15_analyzer_1_array_crystal_array_3_target_z;
MCNUM mccchannel_15_analyzer_1_array_crystal_array_3_focus_aw;
MCNUM mccchannel_15_analyzer_1_array_crystal_array_3_focus_ah;
MCNUM mccchannel_15_analyzer_1_array_crystal_array_3_focus_xw;
MCNUM mccchannel_15_analyzer_1_array_crystal_array_3_focus_xh;
MCNUM mccchannel_15_analyzer_1_array_crystal_array_3_focus_r;
MCNUM mccchannel_15_analyzer_1_array_crystal_array_3_p_interact;
char mccchannel_15_analyzer_1_array_crystal_array_3_mask_string[16384];
char mccchannel_15_analyzer_1_array_crystal_array_3_mask_setting[16384];
MCNUM mccchannel_15_analyzer_1_array_crystal_array_3_number_of_activations;

/* Setting parameters for component 'channel_15_analyzer_1_array_crystal_array_4' [704]. */
char mccchannel_15_analyzer_1_array_crystal_array_4_material_string[16384];
MCNUM mccchannel_15_analyzer_1_array_crystal_array_4_priority;
MCNUM mccchannel_15_analyzer_1_array_crystal_array_4_xwidth;
MCNUM mccchannel_15_analyzer_1_array_crystal_array_4_yheight;
MCNUM mccchannel_15_analyzer_1_array_crystal_array_4_zdepth;
MCNUM mccchannel_15_analyzer_1_array_crystal_array_4_xwidth2;
MCNUM mccchannel_15_analyzer_1_array_crystal_array_4_yheight2;
MCNUM mccchannel_15_analyzer_1_array_crystal_array_4_visualize;
int mccchannel_15_analyzer_1_array_crystal_array_4_target_index;
MCNUM mccchannel_15_analyzer_1_array_crystal_array_4_target_x;
MCNUM mccchannel_15_analyzer_1_array_crystal_array_4_target_y;
MCNUM mccchannel_15_analyzer_1_array_crystal_array_4_target_z;
MCNUM mccchannel_15_analyzer_1_array_crystal_array_4_focus_aw;
MCNUM mccchannel_15_analyzer_1_array_crystal_array_4_focus_ah;
MCNUM mccchannel_15_analyzer_1_array_crystal_array_4_focus_xw;
MCNUM mccchannel_15_analyzer_1_array_crystal_array_4_focus_xh;
MCNUM mccchannel_15_analyzer_1_array_crystal_array_4_focus_r;
MCNUM mccchannel_15_analyzer_1_array_crystal_array_4_p_interact;
char mccchannel_15_analyzer_1_array_crystal_array_4_mask_string[16384];
char mccchannel_15_analyzer_1_array_crystal_array_4_mask_setting[16384];
MCNUM mccchannel_15_analyzer_1_array_crystal_array_4_number_of_activations;

/* Setting parameters for component 'channel_15_analyzer_1_array_crystal_array_5' [705]. */
char mccchannel_15_analyzer_1_array_crystal_array_5_material_string[16384];
MCNUM mccchannel_15_analyzer_1_array_crystal_array_5_priority;
MCNUM mccchannel_15_analyzer_1_array_crystal_array_5_xwidth;
MCNUM mccchannel_15_analyzer_1_array_crystal_array_5_yheight;
MCNUM mccchannel_15_analyzer_1_array_crystal_array_5_zdepth;
MCNUM mccchannel_15_analyzer_1_array_crystal_array_5_xwidth2;
MCNUM mccchannel_15_analyzer_1_array_crystal_array_5_yheight2;
MCNUM mccchannel_15_analyzer_1_array_crystal_array_5_visualize;
int mccchannel_15_analyzer_1_array_crystal_array_5_target_index;
MCNUM mccchannel_15_analyzer_1_array_crystal_array_5_target_x;
MCNUM mccchannel_15_analyzer_1_array_crystal_array_5_target_y;
MCNUM mccchannel_15_analyzer_1_array_crystal_array_5_target_z;
MCNUM mccchannel_15_analyzer_1_array_crystal_array_5_focus_aw;
MCNUM mccchannel_15_analyzer_1_array_crystal_array_5_focus_ah;
MCNUM mccchannel_15_analyzer_1_array_crystal_array_5_focus_xw;
MCNUM mccchannel_15_analyzer_1_array_crystal_array_5_focus_xh;
MCNUM mccchannel_15_analyzer_1_array_crystal_array_5_focus_r;
MCNUM mccchannel_15_analyzer_1_array_crystal_array_5_p_interact;
char mccchannel_15_analyzer_1_array_crystal_array_5_mask_string[16384];
char mccchannel_15_analyzer_1_array_crystal_array_5_mask_setting[16384];
MCNUM mccchannel_15_analyzer_1_array_crystal_array_5_number_of_activations;

/* Setting parameters for component 'channel_15_analyzer_1_array_crystal_array_6' [706]. */
char mccchannel_15_analyzer_1_array_crystal_array_6_material_string[16384];
MCNUM mccchannel_15_analyzer_1_array_crystal_array_6_priority;
MCNUM mccchannel_15_analyzer_1_array_crystal_array_6_xwidth;
MCNUM mccchannel_15_analyzer_1_array_crystal_array_6_yheight;
MCNUM mccchannel_15_analyzer_1_array_crystal_array_6_zdepth;
MCNUM mccchannel_15_analyzer_1_array_crystal_array_6_xwidth2;
MCNUM mccchannel_15_analyzer_1_array_crystal_array_6_yheight2;
MCNUM mccchannel_15_analyzer_1_array_crystal_array_6_visualize;
int mccchannel_15_analyzer_1_array_crystal_array_6_target_index;
MCNUM mccchannel_15_analyzer_1_array_crystal_array_6_target_x;
MCNUM mccchannel_15_analyzer_1_array_crystal_array_6_target_y;
MCNUM mccchannel_15_analyzer_1_array_crystal_array_6_target_z;
MCNUM mccchannel_15_analyzer_1_array_crystal_array_6_focus_aw;
MCNUM mccchannel_15_analyzer_1_array_crystal_array_6_focus_ah;
MCNUM mccchannel_15_analyzer_1_array_crystal_array_6_focus_xw;
MCNUM mccchannel_15_analyzer_1_array_crystal_array_6_focus_xh;
MCNUM mccchannel_15_analyzer_1_array_crystal_array_6_focus_r;
MCNUM mccchannel_15_analyzer_1_array_crystal_array_6_p_interact;
char mccchannel_15_analyzer_1_array_crystal_array_6_mask_string[16384];
char mccchannel_15_analyzer_1_array_crystal_array_6_mask_setting[16384];
MCNUM mccchannel_15_analyzer_1_array_crystal_array_6_number_of_activations;

/* Setting parameters for component 'channel_15_analyzer_1_array_crystal_array_7' [707]. */
char mccchannel_15_analyzer_1_array_crystal_array_7_material_string[16384];
MCNUM mccchannel_15_analyzer_1_array_crystal_array_7_priority;
MCNUM mccchannel_15_analyzer_1_array_crystal_array_7_xwidth;
MCNUM mccchannel_15_analyzer_1_array_crystal_array_7_yheight;
MCNUM mccchannel_15_analyzer_1_array_crystal_array_7_zdepth;
MCNUM mccchannel_15_analyzer_1_array_crystal_array_7_xwidth2;
MCNUM mccchannel_15_analyzer_1_array_crystal_array_7_yheight2;
MCNUM mccchannel_15_analyzer_1_array_crystal_array_7_visualize;
int mccchannel_15_analyzer_1_array_crystal_array_7_target_index;
MCNUM mccchannel_15_analyzer_1_array_crystal_array_7_target_x;
MCNUM mccchannel_15_analyzer_1_array_crystal_array_7_target_y;
MCNUM mccchannel_15_analyzer_1_array_crystal_array_7_target_z;
MCNUM mccchannel_15_analyzer_1_array_crystal_array_7_focus_aw;
MCNUM mccchannel_15_analyzer_1_array_crystal_array_7_focus_ah;
MCNUM mccchannel_15_analyzer_1_array_crystal_array_7_focus_xw;
MCNUM mccchannel_15_analyzer_1_array_crystal_array_7_focus_xh;
MCNUM mccchannel_15_analyzer_1_array_crystal_array_7_focus_r;
MCNUM mccchannel_15_analyzer_1_array_crystal_array_7_p_interact;
char mccchannel_15_analyzer_1_array_crystal_array_7_mask_string[16384];
char mccchannel_15_analyzer_1_array_crystal_array_7_mask_setting[16384];
MCNUM mccchannel_15_analyzer_1_array_crystal_array_7_number_of_activations;

/* Setting parameters for component 'channel_15_analyzer_1_array_crystal_array_8' [708]. */
char mccchannel_15_analyzer_1_array_crystal_array_8_material_string[16384];
MCNUM mccchannel_15_analyzer_1_array_crystal_array_8_priority;
MCNUM mccchannel_15_analyzer_1_array_crystal_array_8_xwidth;
MCNUM mccchannel_15_analyzer_1_array_crystal_array_8_yheight;
MCNUM mccchannel_15_analyzer_1_array_crystal_array_8_zdepth;
MCNUM mccchannel_15_analyzer_1_array_crystal_array_8_xwidth2;
MCNUM mccchannel_15_analyzer_1_array_crystal_array_8_yheight2;
MCNUM mccchannel_15_analyzer_1_array_crystal_array_8_visualize;
int mccchannel_15_analyzer_1_array_crystal_array_8_target_index;
MCNUM mccchannel_15_analyzer_1_array_crystal_array_8_target_x;
MCNUM mccchannel_15_analyzer_1_array_crystal_array_8_target_y;
MCNUM mccchannel_15_analyzer_1_array_crystal_array_8_target_z;
MCNUM mccchannel_15_analyzer_1_array_crystal_array_8_focus_aw;
MCNUM mccchannel_15_analyzer_1_array_crystal_array_8_focus_ah;
MCNUM mccchannel_15_analyzer_1_array_crystal_array_8_focus_xw;
MCNUM mccchannel_15_analyzer_1_array_crystal_array_8_focus_xh;
MCNUM mccchannel_15_analyzer_1_array_crystal_array_8_focus_r;
MCNUM mccchannel_15_analyzer_1_array_crystal_array_8_p_interact;
char mccchannel_15_analyzer_1_array_crystal_array_8_mask_string[16384];
char mccchannel_15_analyzer_1_array_crystal_array_8_mask_setting[16384];
MCNUM mccchannel_15_analyzer_1_array_crystal_array_8_number_of_activations;

/* Setting parameters for component 'channel_15_analyzer_2_array_crystal_array_0' [711]. */
char mccchannel_15_analyzer_2_array_crystal_array_0_material_string[16384];
MCNUM mccchannel_15_analyzer_2_array_crystal_array_0_priority;
MCNUM mccchannel_15_analyzer_2_array_crystal_array_0_xwidth;
MCNUM mccchannel_15_analyzer_2_array_crystal_array_0_yheight;
MCNUM mccchannel_15_analyzer_2_array_crystal_array_0_zdepth;
MCNUM mccchannel_15_analyzer_2_array_crystal_array_0_xwidth2;
MCNUM mccchannel_15_analyzer_2_array_crystal_array_0_yheight2;
MCNUM mccchannel_15_analyzer_2_array_crystal_array_0_visualize;
int mccchannel_15_analyzer_2_array_crystal_array_0_target_index;
MCNUM mccchannel_15_analyzer_2_array_crystal_array_0_target_x;
MCNUM mccchannel_15_analyzer_2_array_crystal_array_0_target_y;
MCNUM mccchannel_15_analyzer_2_array_crystal_array_0_target_z;
MCNUM mccchannel_15_analyzer_2_array_crystal_array_0_focus_aw;
MCNUM mccchannel_15_analyzer_2_array_crystal_array_0_focus_ah;
MCNUM mccchannel_15_analyzer_2_array_crystal_array_0_focus_xw;
MCNUM mccchannel_15_analyzer_2_array_crystal_array_0_focus_xh;
MCNUM mccchannel_15_analyzer_2_array_crystal_array_0_focus_r;
MCNUM mccchannel_15_analyzer_2_array_crystal_array_0_p_interact;
char mccchannel_15_analyzer_2_array_crystal_array_0_mask_string[16384];
char mccchannel_15_analyzer_2_array_crystal_array_0_mask_setting[16384];
MCNUM mccchannel_15_analyzer_2_array_crystal_array_0_number_of_activations;

/* Setting parameters for component 'channel_15_analyzer_2_array_crystal_array_1' [712]. */
char mccchannel_15_analyzer_2_array_crystal_array_1_material_string[16384];
MCNUM mccchannel_15_analyzer_2_array_crystal_array_1_priority;
MCNUM mccchannel_15_analyzer_2_array_crystal_array_1_xwidth;
MCNUM mccchannel_15_analyzer_2_array_crystal_array_1_yheight;
MCNUM mccchannel_15_analyzer_2_array_crystal_array_1_zdepth;
MCNUM mccchannel_15_analyzer_2_array_crystal_array_1_xwidth2;
MCNUM mccchannel_15_analyzer_2_array_crystal_array_1_yheight2;
MCNUM mccchannel_15_analyzer_2_array_crystal_array_1_visualize;
int mccchannel_15_analyzer_2_array_crystal_array_1_target_index;
MCNUM mccchannel_15_analyzer_2_array_crystal_array_1_target_x;
MCNUM mccchannel_15_analyzer_2_array_crystal_array_1_target_y;
MCNUM mccchannel_15_analyzer_2_array_crystal_array_1_target_z;
MCNUM mccchannel_15_analyzer_2_array_crystal_array_1_focus_aw;
MCNUM mccchannel_15_analyzer_2_array_crystal_array_1_focus_ah;
MCNUM mccchannel_15_analyzer_2_array_crystal_array_1_focus_xw;
MCNUM mccchannel_15_analyzer_2_array_crystal_array_1_focus_xh;
MCNUM mccchannel_15_analyzer_2_array_crystal_array_1_focus_r;
MCNUM mccchannel_15_analyzer_2_array_crystal_array_1_p_interact;
char mccchannel_15_analyzer_2_array_crystal_array_1_mask_string[16384];
char mccchannel_15_analyzer_2_array_crystal_array_1_mask_setting[16384];
MCNUM mccchannel_15_analyzer_2_array_crystal_array_1_number_of_activations;

/* Setting parameters for component 'channel_15_analyzer_2_array_crystal_array_2' [713]. */
char mccchannel_15_analyzer_2_array_crystal_array_2_material_string[16384];
MCNUM mccchannel_15_analyzer_2_array_crystal_array_2_priority;
MCNUM mccchannel_15_analyzer_2_array_crystal_array_2_xwidth;
MCNUM mccchannel_15_analyzer_2_array_crystal_array_2_yheight;
MCNUM mccchannel_15_analyzer_2_array_crystal_array_2_zdepth;
MCNUM mccchannel_15_analyzer_2_array_crystal_array_2_xwidth2;
MCNUM mccchannel_15_analyzer_2_array_crystal_array_2_yheight2;
MCNUM mccchannel_15_analyzer_2_array_crystal_array_2_visualize;
int mccchannel_15_analyzer_2_array_crystal_array_2_target_index;
MCNUM mccchannel_15_analyzer_2_array_crystal_array_2_target_x;
MCNUM mccchannel_15_analyzer_2_array_crystal_array_2_target_y;
MCNUM mccchannel_15_analyzer_2_array_crystal_array_2_target_z;
MCNUM mccchannel_15_analyzer_2_array_crystal_array_2_focus_aw;
MCNUM mccchannel_15_analyzer_2_array_crystal_array_2_focus_ah;
MCNUM mccchannel_15_analyzer_2_array_crystal_array_2_focus_xw;
MCNUM mccchannel_15_analyzer_2_array_crystal_array_2_focus_xh;
MCNUM mccchannel_15_analyzer_2_array_crystal_array_2_focus_r;
MCNUM mccchannel_15_analyzer_2_array_crystal_array_2_p_interact;
char mccchannel_15_analyzer_2_array_crystal_array_2_mask_string[16384];
char mccchannel_15_analyzer_2_array_crystal_array_2_mask_setting[16384];
MCNUM mccchannel_15_analyzer_2_array_crystal_array_2_number_of_activations;

/* Setting parameters for component 'channel_15_analyzer_2_array_crystal_array_3' [714]. */
char mccchannel_15_analyzer_2_array_crystal_array_3_material_string[16384];
MCNUM mccchannel_15_analyzer_2_array_crystal_array_3_priority;
MCNUM mccchannel_15_analyzer_2_array_crystal_array_3_xwidth;
MCNUM mccchannel_15_analyzer_2_array_crystal_array_3_yheight;
MCNUM mccchannel_15_analyzer_2_array_crystal_array_3_zdepth;
MCNUM mccchannel_15_analyzer_2_array_crystal_array_3_xwidth2;
MCNUM mccchannel_15_analyzer_2_array_crystal_array_3_yheight2;
MCNUM mccchannel_15_analyzer_2_array_crystal_array_3_visualize;
int mccchannel_15_analyzer_2_array_crystal_array_3_target_index;
MCNUM mccchannel_15_analyzer_2_array_crystal_array_3_target_x;
MCNUM mccchannel_15_analyzer_2_array_crystal_array_3_target_y;
MCNUM mccchannel_15_analyzer_2_array_crystal_array_3_target_z;
MCNUM mccchannel_15_analyzer_2_array_crystal_array_3_focus_aw;
MCNUM mccchannel_15_analyzer_2_array_crystal_array_3_focus_ah;
MCNUM mccchannel_15_analyzer_2_array_crystal_array_3_focus_xw;
MCNUM mccchannel_15_analyzer_2_array_crystal_array_3_focus_xh;
MCNUM mccchannel_15_analyzer_2_array_crystal_array_3_focus_r;
MCNUM mccchannel_15_analyzer_2_array_crystal_array_3_p_interact;
char mccchannel_15_analyzer_2_array_crystal_array_3_mask_string[16384];
char mccchannel_15_analyzer_2_array_crystal_array_3_mask_setting[16384];
MCNUM mccchannel_15_analyzer_2_array_crystal_array_3_number_of_activations;

/* Setting parameters for component 'channel_15_analyzer_2_array_crystal_array_4' [715]. */
char mccchannel_15_analyzer_2_array_crystal_array_4_material_string[16384];
MCNUM mccchannel_15_analyzer_2_array_crystal_array_4_priority;
MCNUM mccchannel_15_analyzer_2_array_crystal_array_4_xwidth;
MCNUM mccchannel_15_analyzer_2_array_crystal_array_4_yheight;
MCNUM mccchannel_15_analyzer_2_array_crystal_array_4_zdepth;
MCNUM mccchannel_15_analyzer_2_array_crystal_array_4_xwidth2;
MCNUM mccchannel_15_analyzer_2_array_crystal_array_4_yheight2;
MCNUM mccchannel_15_analyzer_2_array_crystal_array_4_visualize;
int mccchannel_15_analyzer_2_array_crystal_array_4_target_index;
MCNUM mccchannel_15_analyzer_2_array_crystal_array_4_target_x;
MCNUM mccchannel_15_analyzer_2_array_crystal_array_4_target_y;
MCNUM mccchannel_15_analyzer_2_array_crystal_array_4_target_z;
MCNUM mccchannel_15_analyzer_2_array_crystal_array_4_focus_aw;
MCNUM mccchannel_15_analyzer_2_array_crystal_array_4_focus_ah;
MCNUM mccchannel_15_analyzer_2_array_crystal_array_4_focus_xw;
MCNUM mccchannel_15_analyzer_2_array_crystal_array_4_focus_xh;
MCNUM mccchannel_15_analyzer_2_array_crystal_array_4_focus_r;
MCNUM mccchannel_15_analyzer_2_array_crystal_array_4_p_interact;
char mccchannel_15_analyzer_2_array_crystal_array_4_mask_string[16384];
char mccchannel_15_analyzer_2_array_crystal_array_4_mask_setting[16384];
MCNUM mccchannel_15_analyzer_2_array_crystal_array_4_number_of_activations;

/* Setting parameters for component 'channel_15_analyzer_2_array_crystal_array_5' [716]. */
char mccchannel_15_analyzer_2_array_crystal_array_5_material_string[16384];
MCNUM mccchannel_15_analyzer_2_array_crystal_array_5_priority;
MCNUM mccchannel_15_analyzer_2_array_crystal_array_5_xwidth;
MCNUM mccchannel_15_analyzer_2_array_crystal_array_5_yheight;
MCNUM mccchannel_15_analyzer_2_array_crystal_array_5_zdepth;
MCNUM mccchannel_15_analyzer_2_array_crystal_array_5_xwidth2;
MCNUM mccchannel_15_analyzer_2_array_crystal_array_5_yheight2;
MCNUM mccchannel_15_analyzer_2_array_crystal_array_5_visualize;
int mccchannel_15_analyzer_2_array_crystal_array_5_target_index;
MCNUM mccchannel_15_analyzer_2_array_crystal_array_5_target_x;
MCNUM mccchannel_15_analyzer_2_array_crystal_array_5_target_y;
MCNUM mccchannel_15_analyzer_2_array_crystal_array_5_target_z;
MCNUM mccchannel_15_analyzer_2_array_crystal_array_5_focus_aw;
MCNUM mccchannel_15_analyzer_2_array_crystal_array_5_focus_ah;
MCNUM mccchannel_15_analyzer_2_array_crystal_array_5_focus_xw;
MCNUM mccchannel_15_analyzer_2_array_crystal_array_5_focus_xh;
MCNUM mccchannel_15_analyzer_2_array_crystal_array_5_focus_r;
MCNUM mccchannel_15_analyzer_2_array_crystal_array_5_p_interact;
char mccchannel_15_analyzer_2_array_crystal_array_5_mask_string[16384];
char mccchannel_15_analyzer_2_array_crystal_array_5_mask_setting[16384];
MCNUM mccchannel_15_analyzer_2_array_crystal_array_5_number_of_activations;

/* Setting parameters for component 'channel_15_analyzer_2_array_crystal_array_6' [717]. */
char mccchannel_15_analyzer_2_array_crystal_array_6_material_string[16384];
MCNUM mccchannel_15_analyzer_2_array_crystal_array_6_priority;
MCNUM mccchannel_15_analyzer_2_array_crystal_array_6_xwidth;
MCNUM mccchannel_15_analyzer_2_array_crystal_array_6_yheight;
MCNUM mccchannel_15_analyzer_2_array_crystal_array_6_zdepth;
MCNUM mccchannel_15_analyzer_2_array_crystal_array_6_xwidth2;
MCNUM mccchannel_15_analyzer_2_array_crystal_array_6_yheight2;
MCNUM mccchannel_15_analyzer_2_array_crystal_array_6_visualize;
int mccchannel_15_analyzer_2_array_crystal_array_6_target_index;
MCNUM mccchannel_15_analyzer_2_array_crystal_array_6_target_x;
MCNUM mccchannel_15_analyzer_2_array_crystal_array_6_target_y;
MCNUM mccchannel_15_analyzer_2_array_crystal_array_6_target_z;
MCNUM mccchannel_15_analyzer_2_array_crystal_array_6_focus_aw;
MCNUM mccchannel_15_analyzer_2_array_crystal_array_6_focus_ah;
MCNUM mccchannel_15_analyzer_2_array_crystal_array_6_focus_xw;
MCNUM mccchannel_15_analyzer_2_array_crystal_array_6_focus_xh;
MCNUM mccchannel_15_analyzer_2_array_crystal_array_6_focus_r;
MCNUM mccchannel_15_analyzer_2_array_crystal_array_6_p_interact;
char mccchannel_15_analyzer_2_array_crystal_array_6_mask_string[16384];
char mccchannel_15_analyzer_2_array_crystal_array_6_mask_setting[16384];
MCNUM mccchannel_15_analyzer_2_array_crystal_array_6_number_of_activations;

/* Setting parameters for component 'channel_15_analyzer_2_array_crystal_array_7' [718]. */
char mccchannel_15_analyzer_2_array_crystal_array_7_material_string[16384];
MCNUM mccchannel_15_analyzer_2_array_crystal_array_7_priority;
MCNUM mccchannel_15_analyzer_2_array_crystal_array_7_xwidth;
MCNUM mccchannel_15_analyzer_2_array_crystal_array_7_yheight;
MCNUM mccchannel_15_analyzer_2_array_crystal_array_7_zdepth;
MCNUM mccchannel_15_analyzer_2_array_crystal_array_7_xwidth2;
MCNUM mccchannel_15_analyzer_2_array_crystal_array_7_yheight2;
MCNUM mccchannel_15_analyzer_2_array_crystal_array_7_visualize;
int mccchannel_15_analyzer_2_array_crystal_array_7_target_index;
MCNUM mccchannel_15_analyzer_2_array_crystal_array_7_target_x;
MCNUM mccchannel_15_analyzer_2_array_crystal_array_7_target_y;
MCNUM mccchannel_15_analyzer_2_array_crystal_array_7_target_z;
MCNUM mccchannel_15_analyzer_2_array_crystal_array_7_focus_aw;
MCNUM mccchannel_15_analyzer_2_array_crystal_array_7_focus_ah;
MCNUM mccchannel_15_analyzer_2_array_crystal_array_7_focus_xw;
MCNUM mccchannel_15_analyzer_2_array_crystal_array_7_focus_xh;
MCNUM mccchannel_15_analyzer_2_array_crystal_array_7_focus_r;
MCNUM mccchannel_15_analyzer_2_array_crystal_array_7_p_interact;
char mccchannel_15_analyzer_2_array_crystal_array_7_mask_string[16384];
char mccchannel_15_analyzer_2_array_crystal_array_7_mask_setting[16384];
MCNUM mccchannel_15_analyzer_2_array_crystal_array_7_number_of_activations;

/* Setting parameters for component 'channel_15_analyzer_2_array_crystal_array_8' [719]. */
char mccchannel_15_analyzer_2_array_crystal_array_8_material_string[16384];
MCNUM mccchannel_15_analyzer_2_array_crystal_array_8_priority;
MCNUM mccchannel_15_analyzer_2_array_crystal_array_8_xwidth;
MCNUM mccchannel_15_analyzer_2_array_crystal_array_8_yheight;
MCNUM mccchannel_15_analyzer_2_array_crystal_array_8_zdepth;
MCNUM mccchannel_15_analyzer_2_array_crystal_array_8_xwidth2;
MCNUM mccchannel_15_analyzer_2_array_crystal_array_8_yheight2;
MCNUM mccchannel_15_analyzer_2_array_crystal_array_8_visualize;
int mccchannel_15_analyzer_2_array_crystal_array_8_target_index;
MCNUM mccchannel_15_analyzer_2_array_crystal_array_8_target_x;
MCNUM mccchannel_15_analyzer_2_array_crystal_array_8_target_y;
MCNUM mccchannel_15_analyzer_2_array_crystal_array_8_target_z;
MCNUM mccchannel_15_analyzer_2_array_crystal_array_8_focus_aw;
MCNUM mccchannel_15_analyzer_2_array_crystal_array_8_focus_ah;
MCNUM mccchannel_15_analyzer_2_array_crystal_array_8_focus_xw;
MCNUM mccchannel_15_analyzer_2_array_crystal_array_8_focus_xh;
MCNUM mccchannel_15_analyzer_2_array_crystal_array_8_focus_r;
MCNUM mccchannel_15_analyzer_2_array_crystal_array_8_p_interact;
char mccchannel_15_analyzer_2_array_crystal_array_8_mask_string[16384];
char mccchannel_15_analyzer_2_array_crystal_array_8_mask_setting[16384];
MCNUM mccchannel_15_analyzer_2_array_crystal_array_8_number_of_activations;

/* Setting parameters for component 'channel_15_cave2_cyl1' [720]. */
char mccchannel_15_cave2_cyl1_material_string[16384];
MCNUM mccchannel_15_cave2_cyl1_priority;
MCNUM mccchannel_15_cave2_cyl1_radius;
MCNUM mccchannel_15_cave2_cyl1_yheight;
MCNUM mccchannel_15_cave2_cyl1_visualize;
int mccchannel_15_cave2_cyl1_target_index;
MCNUM mccchannel_15_cave2_cyl1_target_x;
MCNUM mccchannel_15_cave2_cyl1_target_y;
MCNUM mccchannel_15_cave2_cyl1_target_z;
MCNUM mccchannel_15_cave2_cyl1_focus_aw;
MCNUM mccchannel_15_cave2_cyl1_focus_ah;
MCNUM mccchannel_15_cave2_cyl1_focus_xw;
MCNUM mccchannel_15_cave2_cyl1_focus_xh;
MCNUM mccchannel_15_cave2_cyl1_focus_r;
MCNUM mccchannel_15_cave2_cyl1_p_interact;
char mccchannel_15_cave2_cyl1_mask_string[16384];
char mccchannel_15_cave2_cyl1_mask_setting[16384];
MCNUM mccchannel_15_cave2_cyl1_number_of_activations;

/* Setting parameters for component 'channel_15_cave2_box1' [721]. */
char mccchannel_15_cave2_box1_material_string[16384];
MCNUM mccchannel_15_cave2_box1_priority;
MCNUM mccchannel_15_cave2_box1_xwidth;
MCNUM mccchannel_15_cave2_box1_yheight;
MCNUM mccchannel_15_cave2_box1_zdepth;
MCNUM mccchannel_15_cave2_box1_xwidth2;
MCNUM mccchannel_15_cave2_box1_yheight2;
MCNUM mccchannel_15_cave2_box1_visualize;
int mccchannel_15_cave2_box1_target_index;
MCNUM mccchannel_15_cave2_box1_target_x;
MCNUM mccchannel_15_cave2_box1_target_y;
MCNUM mccchannel_15_cave2_box1_target_z;
MCNUM mccchannel_15_cave2_box1_focus_aw;
MCNUM mccchannel_15_cave2_box1_focus_ah;
MCNUM mccchannel_15_cave2_box1_focus_xw;
MCNUM mccchannel_15_cave2_box1_focus_xh;
MCNUM mccchannel_15_cave2_box1_focus_r;
MCNUM mccchannel_15_cave2_box1_p_interact;
char mccchannel_15_cave2_box1_mask_string[16384];
char mccchannel_15_cave2_box1_mask_setting[16384];
MCNUM mccchannel_15_cave2_box1_number_of_activations;

/* Setting parameters for component 'channel_15_cave2_box2' [722]. */
char mccchannel_15_cave2_box2_material_string[16384];
MCNUM mccchannel_15_cave2_box2_priority;
MCNUM mccchannel_15_cave2_box2_xwidth;
MCNUM mccchannel_15_cave2_box2_yheight;
MCNUM mccchannel_15_cave2_box2_zdepth;
MCNUM mccchannel_15_cave2_box2_xwidth2;
MCNUM mccchannel_15_cave2_box2_yheight2;
MCNUM mccchannel_15_cave2_box2_visualize;
int mccchannel_15_cave2_box2_target_index;
MCNUM mccchannel_15_cave2_box2_target_x;
MCNUM mccchannel_15_cave2_box2_target_y;
MCNUM mccchannel_15_cave2_box2_target_z;
MCNUM mccchannel_15_cave2_box2_focus_aw;
MCNUM mccchannel_15_cave2_box2_focus_ah;
MCNUM mccchannel_15_cave2_box2_focus_xw;
MCNUM mccchannel_15_cave2_box2_focus_xh;
MCNUM mccchannel_15_cave2_box2_focus_r;
MCNUM mccchannel_15_cave2_box2_p_interact;
char mccchannel_15_cave2_box2_mask_string[16384];
char mccchannel_15_cave2_box2_mask_setting[16384];
MCNUM mccchannel_15_cave2_box2_number_of_activations;

/* Setting parameters for component 'channel_15_cave2_box3' [723]. */
char mccchannel_15_cave2_box3_material_string[16384];
MCNUM mccchannel_15_cave2_box3_priority;
MCNUM mccchannel_15_cave2_box3_xwidth;
MCNUM mccchannel_15_cave2_box3_yheight;
MCNUM mccchannel_15_cave2_box3_zdepth;
MCNUM mccchannel_15_cave2_box3_xwidth2;
MCNUM mccchannel_15_cave2_box3_yheight2;
MCNUM mccchannel_15_cave2_box3_visualize;
int mccchannel_15_cave2_box3_target_index;
MCNUM mccchannel_15_cave2_box3_target_x;
MCNUM mccchannel_15_cave2_box3_target_y;
MCNUM mccchannel_15_cave2_box3_target_z;
MCNUM mccchannel_15_cave2_box3_focus_aw;
MCNUM mccchannel_15_cave2_box3_focus_ah;
MCNUM mccchannel_15_cave2_box3_focus_xw;
MCNUM mccchannel_15_cave2_box3_focus_xh;
MCNUM mccchannel_15_cave2_box3_focus_r;
MCNUM mccchannel_15_cave2_box3_p_interact;
char mccchannel_15_cave2_box3_mask_string[16384];
char mccchannel_15_cave2_box3_mask_setting[16384];
MCNUM mccchannel_15_cave2_box3_number_of_activations;

/* Setting parameters for component 'inter_analyzer_colimator_15_blade_0' [725]. */
char mccinter_analyzer_colimator_15_blade_0_material_string[16384];
MCNUM mccinter_analyzer_colimator_15_blade_0_priority;
MCNUM mccinter_analyzer_colimator_15_blade_0_xwidth;
MCNUM mccinter_analyzer_colimator_15_blade_0_yheight;
MCNUM mccinter_analyzer_colimator_15_blade_0_zdepth;
MCNUM mccinter_analyzer_colimator_15_blade_0_xwidth2;
MCNUM mccinter_analyzer_colimator_15_blade_0_yheight2;
MCNUM mccinter_analyzer_colimator_15_blade_0_visualize;
int mccinter_analyzer_colimator_15_blade_0_target_index;
MCNUM mccinter_analyzer_colimator_15_blade_0_target_x;
MCNUM mccinter_analyzer_colimator_15_blade_0_target_y;
MCNUM mccinter_analyzer_colimator_15_blade_0_target_z;
MCNUM mccinter_analyzer_colimator_15_blade_0_focus_aw;
MCNUM mccinter_analyzer_colimator_15_blade_0_focus_ah;
MCNUM mccinter_analyzer_colimator_15_blade_0_focus_xw;
MCNUM mccinter_analyzer_colimator_15_blade_0_focus_xh;
MCNUM mccinter_analyzer_colimator_15_blade_0_focus_r;
MCNUM mccinter_analyzer_colimator_15_blade_0_p_interact;
char mccinter_analyzer_colimator_15_blade_0_mask_string[16384];
char mccinter_analyzer_colimator_15_blade_0_mask_setting[16384];
MCNUM mccinter_analyzer_colimator_15_blade_0_number_of_activations;

/* Setting parameters for component 'inter_analyzer_colimator_15_blade_1' [726]. */
char mccinter_analyzer_colimator_15_blade_1_material_string[16384];
MCNUM mccinter_analyzer_colimator_15_blade_1_priority;
MCNUM mccinter_analyzer_colimator_15_blade_1_xwidth;
MCNUM mccinter_analyzer_colimator_15_blade_1_yheight;
MCNUM mccinter_analyzer_colimator_15_blade_1_zdepth;
MCNUM mccinter_analyzer_colimator_15_blade_1_xwidth2;
MCNUM mccinter_analyzer_colimator_15_blade_1_yheight2;
MCNUM mccinter_analyzer_colimator_15_blade_1_visualize;
int mccinter_analyzer_colimator_15_blade_1_target_index;
MCNUM mccinter_analyzer_colimator_15_blade_1_target_x;
MCNUM mccinter_analyzer_colimator_15_blade_1_target_y;
MCNUM mccinter_analyzer_colimator_15_blade_1_target_z;
MCNUM mccinter_analyzer_colimator_15_blade_1_focus_aw;
MCNUM mccinter_analyzer_colimator_15_blade_1_focus_ah;
MCNUM mccinter_analyzer_colimator_15_blade_1_focus_xw;
MCNUM mccinter_analyzer_colimator_15_blade_1_focus_xh;
MCNUM mccinter_analyzer_colimator_15_blade_1_focus_r;
MCNUM mccinter_analyzer_colimator_15_blade_1_p_interact;
char mccinter_analyzer_colimator_15_blade_1_mask_string[16384];
char mccinter_analyzer_colimator_15_blade_1_mask_setting[16384];
MCNUM mccinter_analyzer_colimator_15_blade_1_number_of_activations;

/* Setting parameters for component 'inter_analyzer_colimator_15_blade_2' [727]. */
char mccinter_analyzer_colimator_15_blade_2_material_string[16384];
MCNUM mccinter_analyzer_colimator_15_blade_2_priority;
MCNUM mccinter_analyzer_colimator_15_blade_2_xwidth;
MCNUM mccinter_analyzer_colimator_15_blade_2_yheight;
MCNUM mccinter_analyzer_colimator_15_blade_2_zdepth;
MCNUM mccinter_analyzer_colimator_15_blade_2_xwidth2;
MCNUM mccinter_analyzer_colimator_15_blade_2_yheight2;
MCNUM mccinter_analyzer_colimator_15_blade_2_visualize;
int mccinter_analyzer_colimator_15_blade_2_target_index;
MCNUM mccinter_analyzer_colimator_15_blade_2_target_x;
MCNUM mccinter_analyzer_colimator_15_blade_2_target_y;
MCNUM mccinter_analyzer_colimator_15_blade_2_target_z;
MCNUM mccinter_analyzer_colimator_15_blade_2_focus_aw;
MCNUM mccinter_analyzer_colimator_15_blade_2_focus_ah;
MCNUM mccinter_analyzer_colimator_15_blade_2_focus_xw;
MCNUM mccinter_analyzer_colimator_15_blade_2_focus_xh;
MCNUM mccinter_analyzer_colimator_15_blade_2_focus_r;
MCNUM mccinter_analyzer_colimator_15_blade_2_p_interact;
char mccinter_analyzer_colimator_15_blade_2_mask_string[16384];
char mccinter_analyzer_colimator_15_blade_2_mask_setting[16384];
MCNUM mccinter_analyzer_colimator_15_blade_2_number_of_activations;

/* Setting parameters for component 'inter_analyzer_colimator_15_blade_3' [728]. */
char mccinter_analyzer_colimator_15_blade_3_material_string[16384];
MCNUM mccinter_analyzer_colimator_15_blade_3_priority;
MCNUM mccinter_analyzer_colimator_15_blade_3_xwidth;
MCNUM mccinter_analyzer_colimator_15_blade_3_yheight;
MCNUM mccinter_analyzer_colimator_15_blade_3_zdepth;
MCNUM mccinter_analyzer_colimator_15_blade_3_xwidth2;
MCNUM mccinter_analyzer_colimator_15_blade_3_yheight2;
MCNUM mccinter_analyzer_colimator_15_blade_3_visualize;
int mccinter_analyzer_colimator_15_blade_3_target_index;
MCNUM mccinter_analyzer_colimator_15_blade_3_target_x;
MCNUM mccinter_analyzer_colimator_15_blade_3_target_y;
MCNUM mccinter_analyzer_colimator_15_blade_3_target_z;
MCNUM mccinter_analyzer_colimator_15_blade_3_focus_aw;
MCNUM mccinter_analyzer_colimator_15_blade_3_focus_ah;
MCNUM mccinter_analyzer_colimator_15_blade_3_focus_xw;
MCNUM mccinter_analyzer_colimator_15_blade_3_focus_xh;
MCNUM mccinter_analyzer_colimator_15_blade_3_focus_r;
MCNUM mccinter_analyzer_colimator_15_blade_3_p_interact;
char mccinter_analyzer_colimator_15_blade_3_mask_string[16384];
char mccinter_analyzer_colimator_15_blade_3_mask_setting[16384];
MCNUM mccinter_analyzer_colimator_15_blade_3_number_of_activations;

/* Setting parameters for component 'inter_analyzer_colimator_15_blade_4' [729]. */
char mccinter_analyzer_colimator_15_blade_4_material_string[16384];
MCNUM mccinter_analyzer_colimator_15_blade_4_priority;
MCNUM mccinter_analyzer_colimator_15_blade_4_xwidth;
MCNUM mccinter_analyzer_colimator_15_blade_4_yheight;
MCNUM mccinter_analyzer_colimator_15_blade_4_zdepth;
MCNUM mccinter_analyzer_colimator_15_blade_4_xwidth2;
MCNUM mccinter_analyzer_colimator_15_blade_4_yheight2;
MCNUM mccinter_analyzer_colimator_15_blade_4_visualize;
int mccinter_analyzer_colimator_15_blade_4_target_index;
MCNUM mccinter_analyzer_colimator_15_blade_4_target_x;
MCNUM mccinter_analyzer_colimator_15_blade_4_target_y;
MCNUM mccinter_analyzer_colimator_15_blade_4_target_z;
MCNUM mccinter_analyzer_colimator_15_blade_4_focus_aw;
MCNUM mccinter_analyzer_colimator_15_blade_4_focus_ah;
MCNUM mccinter_analyzer_colimator_15_blade_4_focus_xw;
MCNUM mccinter_analyzer_colimator_15_blade_4_focus_xh;
MCNUM mccinter_analyzer_colimator_15_blade_4_focus_r;
MCNUM mccinter_analyzer_colimator_15_blade_4_p_interact;
char mccinter_analyzer_colimator_15_blade_4_mask_string[16384];
char mccinter_analyzer_colimator_15_blade_4_mask_setting[16384];
MCNUM mccinter_analyzer_colimator_15_blade_4_number_of_activations;

/* Setting parameters for component 'diffraction_detector_15_exit_volume' [730]. */
char mccdiffraction_detector_15_exit_volume_material_string[16384];
MCNUM mccdiffraction_detector_15_exit_volume_priority;
MCNUM mccdiffraction_detector_15_exit_volume_xwidth;
MCNUM mccdiffraction_detector_15_exit_volume_yheight;
MCNUM mccdiffraction_detector_15_exit_volume_zdepth;
MCNUM mccdiffraction_detector_15_exit_volume_xwidth2;
MCNUM mccdiffraction_detector_15_exit_volume_yheight2;
MCNUM mccdiffraction_detector_15_exit_volume_visualize;
int mccdiffraction_detector_15_exit_volume_target_index;
MCNUM mccdiffraction_detector_15_exit_volume_target_x;
MCNUM mccdiffraction_detector_15_exit_volume_target_y;
MCNUM mccdiffraction_detector_15_exit_volume_target_z;
MCNUM mccdiffraction_detector_15_exit_volume_focus_aw;
MCNUM mccdiffraction_detector_15_exit_volume_focus_ah;
MCNUM mccdiffraction_detector_15_exit_volume_focus_xw;
MCNUM mccdiffraction_detector_15_exit_volume_focus_xh;
MCNUM mccdiffraction_detector_15_exit_volume_focus_r;
MCNUM mccdiffraction_detector_15_exit_volume_p_interact;
char mccdiffraction_detector_15_exit_volume_mask_string[16384];
char mccdiffraction_detector_15_exit_volume_mask_setting[16384];
MCNUM mccdiffraction_detector_15_exit_volume_number_of_activations;

/* Setting parameters for component 'spec_detector_15_exit_volume' [731]. */
char mccspec_detector_15_exit_volume_material_string[16384];
MCNUM mccspec_detector_15_exit_volume_priority;
MCNUM mccspec_detector_15_exit_volume_xwidth;
MCNUM mccspec_detector_15_exit_volume_yheight;
MCNUM mccspec_detector_15_exit_volume_zdepth;
MCNUM mccspec_detector_15_exit_volume_xwidth2;
MCNUM mccspec_detector_15_exit_volume_yheight2;
MCNUM mccspec_detector_15_exit_volume_visualize;
int mccspec_detector_15_exit_volume_target_index;
MCNUM mccspec_detector_15_exit_volume_target_x;
MCNUM mccspec_detector_15_exit_volume_target_y;
MCNUM mccspec_detector_15_exit_volume_target_z;
MCNUM mccspec_detector_15_exit_volume_focus_aw;
MCNUM mccspec_detector_15_exit_volume_focus_ah;
MCNUM mccspec_detector_15_exit_volume_focus_xw;
MCNUM mccspec_detector_15_exit_volume_focus_xh;
MCNUM mccspec_detector_15_exit_volume_focus_r;
MCNUM mccspec_detector_15_exit_volume_p_interact;
char mccspec_detector_15_exit_volume_mask_string[16384];
char mccspec_detector_15_exit_volume_mask_setting[16384];
MCNUM mccspec_detector_15_exit_volume_number_of_activations;

/* Setting parameters for component 'channel_16_cave1_box1' [732]. */
char mccchannel_16_cave1_box1_material_string[16384];
MCNUM mccchannel_16_cave1_box1_priority;
MCNUM mccchannel_16_cave1_box1_xwidth;
MCNUM mccchannel_16_cave1_box1_yheight;
MCNUM mccchannel_16_cave1_box1_zdepth;
MCNUM mccchannel_16_cave1_box1_xwidth2;
MCNUM mccchannel_16_cave1_box1_yheight2;
MCNUM mccchannel_16_cave1_box1_visualize;
int mccchannel_16_cave1_box1_target_index;
MCNUM mccchannel_16_cave1_box1_target_x;
MCNUM mccchannel_16_cave1_box1_target_y;
MCNUM mccchannel_16_cave1_box1_target_z;
MCNUM mccchannel_16_cave1_box1_focus_aw;
MCNUM mccchannel_16_cave1_box1_focus_ah;
MCNUM mccchannel_16_cave1_box1_focus_xw;
MCNUM mccchannel_16_cave1_box1_focus_xh;
MCNUM mccchannel_16_cave1_box1_focus_r;
MCNUM mccchannel_16_cave1_box1_p_interact;
char mccchannel_16_cave1_box1_mask_string[16384];
char mccchannel_16_cave1_box1_mask_setting[16384];
MCNUM mccchannel_16_cave1_box1_number_of_activations;

/* Setting parameters for component 'channel_16_cave1_box2' [733]. */
char mccchannel_16_cave1_box2_material_string[16384];
MCNUM mccchannel_16_cave1_box2_priority;
MCNUM mccchannel_16_cave1_box2_xwidth;
MCNUM mccchannel_16_cave1_box2_yheight;
MCNUM mccchannel_16_cave1_box2_zdepth;
MCNUM mccchannel_16_cave1_box2_xwidth2;
MCNUM mccchannel_16_cave1_box2_yheight2;
MCNUM mccchannel_16_cave1_box2_visualize;
int mccchannel_16_cave1_box2_target_index;
MCNUM mccchannel_16_cave1_box2_target_x;
MCNUM mccchannel_16_cave1_box2_target_y;
MCNUM mccchannel_16_cave1_box2_target_z;
MCNUM mccchannel_16_cave1_box2_focus_aw;
MCNUM mccchannel_16_cave1_box2_focus_ah;
MCNUM mccchannel_16_cave1_box2_focus_xw;
MCNUM mccchannel_16_cave1_box2_focus_xh;
MCNUM mccchannel_16_cave1_box2_focus_r;
MCNUM mccchannel_16_cave1_box2_p_interact;
char mccchannel_16_cave1_box2_mask_string[16384];
char mccchannel_16_cave1_box2_mask_setting[16384];
MCNUM mccchannel_16_cave1_box2_number_of_activations;

/* Setting parameters for component 'channel_16_cave1_box3' [734]. */
char mccchannel_16_cave1_box3_material_string[16384];
MCNUM mccchannel_16_cave1_box3_priority;
MCNUM mccchannel_16_cave1_box3_xwidth;
MCNUM mccchannel_16_cave1_box3_yheight;
MCNUM mccchannel_16_cave1_box3_zdepth;
MCNUM mccchannel_16_cave1_box3_xwidth2;
MCNUM mccchannel_16_cave1_box3_yheight2;
MCNUM mccchannel_16_cave1_box3_visualize;
int mccchannel_16_cave1_box3_target_index;
MCNUM mccchannel_16_cave1_box3_target_x;
MCNUM mccchannel_16_cave1_box3_target_y;
MCNUM mccchannel_16_cave1_box3_target_z;
MCNUM mccchannel_16_cave1_box3_focus_aw;
MCNUM mccchannel_16_cave1_box3_focus_ah;
MCNUM mccchannel_16_cave1_box3_focus_xw;
MCNUM mccchannel_16_cave1_box3_focus_xh;
MCNUM mccchannel_16_cave1_box3_focus_r;
MCNUM mccchannel_16_cave1_box3_p_interact;
char mccchannel_16_cave1_box3_mask_string[16384];
char mccchannel_16_cave1_box3_mask_setting[16384];
MCNUM mccchannel_16_cave1_box3_number_of_activations;

/* Setting parameters for component 'channel_16_cave1_cyl1' [735]. */
char mccchannel_16_cave1_cyl1_material_string[16384];
MCNUM mccchannel_16_cave1_cyl1_priority;
MCNUM mccchannel_16_cave1_cyl1_radius;
MCNUM mccchannel_16_cave1_cyl1_yheight;
MCNUM mccchannel_16_cave1_cyl1_visualize;
int mccchannel_16_cave1_cyl1_target_index;
MCNUM mccchannel_16_cave1_cyl1_target_x;
MCNUM mccchannel_16_cave1_cyl1_target_y;
MCNUM mccchannel_16_cave1_cyl1_target_z;
MCNUM mccchannel_16_cave1_cyl1_focus_aw;
MCNUM mccchannel_16_cave1_cyl1_focus_ah;
MCNUM mccchannel_16_cave1_cyl1_focus_xw;
MCNUM mccchannel_16_cave1_cyl1_focus_xh;
MCNUM mccchannel_16_cave1_cyl1_focus_r;
MCNUM mccchannel_16_cave1_cyl1_p_interact;
char mccchannel_16_cave1_cyl1_mask_string[16384];
char mccchannel_16_cave1_cyl1_mask_setting[16384];
MCNUM mccchannel_16_cave1_cyl1_number_of_activations;

/* Setting parameters for component 'channel_16_analyzer_1_array_crystal_array_0' [738]. */
char mccchannel_16_analyzer_1_array_crystal_array_0_material_string[16384];
MCNUM mccchannel_16_analyzer_1_array_crystal_array_0_priority;
MCNUM mccchannel_16_analyzer_1_array_crystal_array_0_xwidth;
MCNUM mccchannel_16_analyzer_1_array_crystal_array_0_yheight;
MCNUM mccchannel_16_analyzer_1_array_crystal_array_0_zdepth;
MCNUM mccchannel_16_analyzer_1_array_crystal_array_0_xwidth2;
MCNUM mccchannel_16_analyzer_1_array_crystal_array_0_yheight2;
MCNUM mccchannel_16_analyzer_1_array_crystal_array_0_visualize;
int mccchannel_16_analyzer_1_array_crystal_array_0_target_index;
MCNUM mccchannel_16_analyzer_1_array_crystal_array_0_target_x;
MCNUM mccchannel_16_analyzer_1_array_crystal_array_0_target_y;
MCNUM mccchannel_16_analyzer_1_array_crystal_array_0_target_z;
MCNUM mccchannel_16_analyzer_1_array_crystal_array_0_focus_aw;
MCNUM mccchannel_16_analyzer_1_array_crystal_array_0_focus_ah;
MCNUM mccchannel_16_analyzer_1_array_crystal_array_0_focus_xw;
MCNUM mccchannel_16_analyzer_1_array_crystal_array_0_focus_xh;
MCNUM mccchannel_16_analyzer_1_array_crystal_array_0_focus_r;
MCNUM mccchannel_16_analyzer_1_array_crystal_array_0_p_interact;
char mccchannel_16_analyzer_1_array_crystal_array_0_mask_string[16384];
char mccchannel_16_analyzer_1_array_crystal_array_0_mask_setting[16384];
MCNUM mccchannel_16_analyzer_1_array_crystal_array_0_number_of_activations;

/* Setting parameters for component 'channel_16_analyzer_1_array_crystal_array_1' [739]. */
char mccchannel_16_analyzer_1_array_crystal_array_1_material_string[16384];
MCNUM mccchannel_16_analyzer_1_array_crystal_array_1_priority;
MCNUM mccchannel_16_analyzer_1_array_crystal_array_1_xwidth;
MCNUM mccchannel_16_analyzer_1_array_crystal_array_1_yheight;
MCNUM mccchannel_16_analyzer_1_array_crystal_array_1_zdepth;
MCNUM mccchannel_16_analyzer_1_array_crystal_array_1_xwidth2;
MCNUM mccchannel_16_analyzer_1_array_crystal_array_1_yheight2;
MCNUM mccchannel_16_analyzer_1_array_crystal_array_1_visualize;
int mccchannel_16_analyzer_1_array_crystal_array_1_target_index;
MCNUM mccchannel_16_analyzer_1_array_crystal_array_1_target_x;
MCNUM mccchannel_16_analyzer_1_array_crystal_array_1_target_y;
MCNUM mccchannel_16_analyzer_1_array_crystal_array_1_target_z;
MCNUM mccchannel_16_analyzer_1_array_crystal_array_1_focus_aw;
MCNUM mccchannel_16_analyzer_1_array_crystal_array_1_focus_ah;
MCNUM mccchannel_16_analyzer_1_array_crystal_array_1_focus_xw;
MCNUM mccchannel_16_analyzer_1_array_crystal_array_1_focus_xh;
MCNUM mccchannel_16_analyzer_1_array_crystal_array_1_focus_r;
MCNUM mccchannel_16_analyzer_1_array_crystal_array_1_p_interact;
char mccchannel_16_analyzer_1_array_crystal_array_1_mask_string[16384];
char mccchannel_16_analyzer_1_array_crystal_array_1_mask_setting[16384];
MCNUM mccchannel_16_analyzer_1_array_crystal_array_1_number_of_activations;

/* Setting parameters for component 'channel_16_analyzer_1_array_crystal_array_2' [740]. */
char mccchannel_16_analyzer_1_array_crystal_array_2_material_string[16384];
MCNUM mccchannel_16_analyzer_1_array_crystal_array_2_priority;
MCNUM mccchannel_16_analyzer_1_array_crystal_array_2_xwidth;
MCNUM mccchannel_16_analyzer_1_array_crystal_array_2_yheight;
MCNUM mccchannel_16_analyzer_1_array_crystal_array_2_zdepth;
MCNUM mccchannel_16_analyzer_1_array_crystal_array_2_xwidth2;
MCNUM mccchannel_16_analyzer_1_array_crystal_array_2_yheight2;
MCNUM mccchannel_16_analyzer_1_array_crystal_array_2_visualize;
int mccchannel_16_analyzer_1_array_crystal_array_2_target_index;
MCNUM mccchannel_16_analyzer_1_array_crystal_array_2_target_x;
MCNUM mccchannel_16_analyzer_1_array_crystal_array_2_target_y;
MCNUM mccchannel_16_analyzer_1_array_crystal_array_2_target_z;
MCNUM mccchannel_16_analyzer_1_array_crystal_array_2_focus_aw;
MCNUM mccchannel_16_analyzer_1_array_crystal_array_2_focus_ah;
MCNUM mccchannel_16_analyzer_1_array_crystal_array_2_focus_xw;
MCNUM mccchannel_16_analyzer_1_array_crystal_array_2_focus_xh;
MCNUM mccchannel_16_analyzer_1_array_crystal_array_2_focus_r;
MCNUM mccchannel_16_analyzer_1_array_crystal_array_2_p_interact;
char mccchannel_16_analyzer_1_array_crystal_array_2_mask_string[16384];
char mccchannel_16_analyzer_1_array_crystal_array_2_mask_setting[16384];
MCNUM mccchannel_16_analyzer_1_array_crystal_array_2_number_of_activations;

/* Setting parameters for component 'channel_16_analyzer_1_array_crystal_array_3' [741]. */
char mccchannel_16_analyzer_1_array_crystal_array_3_material_string[16384];
MCNUM mccchannel_16_analyzer_1_array_crystal_array_3_priority;
MCNUM mccchannel_16_analyzer_1_array_crystal_array_3_xwidth;
MCNUM mccchannel_16_analyzer_1_array_crystal_array_3_yheight;
MCNUM mccchannel_16_analyzer_1_array_crystal_array_3_zdepth;
MCNUM mccchannel_16_analyzer_1_array_crystal_array_3_xwidth2;
MCNUM mccchannel_16_analyzer_1_array_crystal_array_3_yheight2;
MCNUM mccchannel_16_analyzer_1_array_crystal_array_3_visualize;
int mccchannel_16_analyzer_1_array_crystal_array_3_target_index;
MCNUM mccchannel_16_analyzer_1_array_crystal_array_3_target_x;
MCNUM mccchannel_16_analyzer_1_array_crystal_array_3_target_y;
MCNUM mccchannel_16_analyzer_1_array_crystal_array_3_target_z;
MCNUM mccchannel_16_analyzer_1_array_crystal_array_3_focus_aw;
MCNUM mccchannel_16_analyzer_1_array_crystal_array_3_focus_ah;
MCNUM mccchannel_16_analyzer_1_array_crystal_array_3_focus_xw;
MCNUM mccchannel_16_analyzer_1_array_crystal_array_3_focus_xh;
MCNUM mccchannel_16_analyzer_1_array_crystal_array_3_focus_r;
MCNUM mccchannel_16_analyzer_1_array_crystal_array_3_p_interact;
char mccchannel_16_analyzer_1_array_crystal_array_3_mask_string[16384];
char mccchannel_16_analyzer_1_array_crystal_array_3_mask_setting[16384];
MCNUM mccchannel_16_analyzer_1_array_crystal_array_3_number_of_activations;

/* Setting parameters for component 'channel_16_analyzer_1_array_crystal_array_4' [742]. */
char mccchannel_16_analyzer_1_array_crystal_array_4_material_string[16384];
MCNUM mccchannel_16_analyzer_1_array_crystal_array_4_priority;
MCNUM mccchannel_16_analyzer_1_array_crystal_array_4_xwidth;
MCNUM mccchannel_16_analyzer_1_array_crystal_array_4_yheight;
MCNUM mccchannel_16_analyzer_1_array_crystal_array_4_zdepth;
MCNUM mccchannel_16_analyzer_1_array_crystal_array_4_xwidth2;
MCNUM mccchannel_16_analyzer_1_array_crystal_array_4_yheight2;
MCNUM mccchannel_16_analyzer_1_array_crystal_array_4_visualize;
int mccchannel_16_analyzer_1_array_crystal_array_4_target_index;
MCNUM mccchannel_16_analyzer_1_array_crystal_array_4_target_x;
MCNUM mccchannel_16_analyzer_1_array_crystal_array_4_target_y;
MCNUM mccchannel_16_analyzer_1_array_crystal_array_4_target_z;
MCNUM mccchannel_16_analyzer_1_array_crystal_array_4_focus_aw;
MCNUM mccchannel_16_analyzer_1_array_crystal_array_4_focus_ah;
MCNUM mccchannel_16_analyzer_1_array_crystal_array_4_focus_xw;
MCNUM mccchannel_16_analyzer_1_array_crystal_array_4_focus_xh;
MCNUM mccchannel_16_analyzer_1_array_crystal_array_4_focus_r;
MCNUM mccchannel_16_analyzer_1_array_crystal_array_4_p_interact;
char mccchannel_16_analyzer_1_array_crystal_array_4_mask_string[16384];
char mccchannel_16_analyzer_1_array_crystal_array_4_mask_setting[16384];
MCNUM mccchannel_16_analyzer_1_array_crystal_array_4_number_of_activations;

/* Setting parameters for component 'channel_16_analyzer_1_array_crystal_array_5' [743]. */
char mccchannel_16_analyzer_1_array_crystal_array_5_material_string[16384];
MCNUM mccchannel_16_analyzer_1_array_crystal_array_5_priority;
MCNUM mccchannel_16_analyzer_1_array_crystal_array_5_xwidth;
MCNUM mccchannel_16_analyzer_1_array_crystal_array_5_yheight;
MCNUM mccchannel_16_analyzer_1_array_crystal_array_5_zdepth;
MCNUM mccchannel_16_analyzer_1_array_crystal_array_5_xwidth2;
MCNUM mccchannel_16_analyzer_1_array_crystal_array_5_yheight2;
MCNUM mccchannel_16_analyzer_1_array_crystal_array_5_visualize;
int mccchannel_16_analyzer_1_array_crystal_array_5_target_index;
MCNUM mccchannel_16_analyzer_1_array_crystal_array_5_target_x;
MCNUM mccchannel_16_analyzer_1_array_crystal_array_5_target_y;
MCNUM mccchannel_16_analyzer_1_array_crystal_array_5_target_z;
MCNUM mccchannel_16_analyzer_1_array_crystal_array_5_focus_aw;
MCNUM mccchannel_16_analyzer_1_array_crystal_array_5_focus_ah;
MCNUM mccchannel_16_analyzer_1_array_crystal_array_5_focus_xw;
MCNUM mccchannel_16_analyzer_1_array_crystal_array_5_focus_xh;
MCNUM mccchannel_16_analyzer_1_array_crystal_array_5_focus_r;
MCNUM mccchannel_16_analyzer_1_array_crystal_array_5_p_interact;
char mccchannel_16_analyzer_1_array_crystal_array_5_mask_string[16384];
char mccchannel_16_analyzer_1_array_crystal_array_5_mask_setting[16384];
MCNUM mccchannel_16_analyzer_1_array_crystal_array_5_number_of_activations;

/* Setting parameters for component 'channel_16_analyzer_1_array_crystal_array_6' [744]. */
char mccchannel_16_analyzer_1_array_crystal_array_6_material_string[16384];
MCNUM mccchannel_16_analyzer_1_array_crystal_array_6_priority;
MCNUM mccchannel_16_analyzer_1_array_crystal_array_6_xwidth;
MCNUM mccchannel_16_analyzer_1_array_crystal_array_6_yheight;
MCNUM mccchannel_16_analyzer_1_array_crystal_array_6_zdepth;
MCNUM mccchannel_16_analyzer_1_array_crystal_array_6_xwidth2;
MCNUM mccchannel_16_analyzer_1_array_crystal_array_6_yheight2;
MCNUM mccchannel_16_analyzer_1_array_crystal_array_6_visualize;
int mccchannel_16_analyzer_1_array_crystal_array_6_target_index;
MCNUM mccchannel_16_analyzer_1_array_crystal_array_6_target_x;
MCNUM mccchannel_16_analyzer_1_array_crystal_array_6_target_y;
MCNUM mccchannel_16_analyzer_1_array_crystal_array_6_target_z;
MCNUM mccchannel_16_analyzer_1_array_crystal_array_6_focus_aw;
MCNUM mccchannel_16_analyzer_1_array_crystal_array_6_focus_ah;
MCNUM mccchannel_16_analyzer_1_array_crystal_array_6_focus_xw;
MCNUM mccchannel_16_analyzer_1_array_crystal_array_6_focus_xh;
MCNUM mccchannel_16_analyzer_1_array_crystal_array_6_focus_r;
MCNUM mccchannel_16_analyzer_1_array_crystal_array_6_p_interact;
char mccchannel_16_analyzer_1_array_crystal_array_6_mask_string[16384];
char mccchannel_16_analyzer_1_array_crystal_array_6_mask_setting[16384];
MCNUM mccchannel_16_analyzer_1_array_crystal_array_6_number_of_activations;

/* Setting parameters for component 'channel_16_analyzer_1_array_crystal_array_7' [745]. */
char mccchannel_16_analyzer_1_array_crystal_array_7_material_string[16384];
MCNUM mccchannel_16_analyzer_1_array_crystal_array_7_priority;
MCNUM mccchannel_16_analyzer_1_array_crystal_array_7_xwidth;
MCNUM mccchannel_16_analyzer_1_array_crystal_array_7_yheight;
MCNUM mccchannel_16_analyzer_1_array_crystal_array_7_zdepth;
MCNUM mccchannel_16_analyzer_1_array_crystal_array_7_xwidth2;
MCNUM mccchannel_16_analyzer_1_array_crystal_array_7_yheight2;
MCNUM mccchannel_16_analyzer_1_array_crystal_array_7_visualize;
int mccchannel_16_analyzer_1_array_crystal_array_7_target_index;
MCNUM mccchannel_16_analyzer_1_array_crystal_array_7_target_x;
MCNUM mccchannel_16_analyzer_1_array_crystal_array_7_target_y;
MCNUM mccchannel_16_analyzer_1_array_crystal_array_7_target_z;
MCNUM mccchannel_16_analyzer_1_array_crystal_array_7_focus_aw;
MCNUM mccchannel_16_analyzer_1_array_crystal_array_7_focus_ah;
MCNUM mccchannel_16_analyzer_1_array_crystal_array_7_focus_xw;
MCNUM mccchannel_16_analyzer_1_array_crystal_array_7_focus_xh;
MCNUM mccchannel_16_analyzer_1_array_crystal_array_7_focus_r;
MCNUM mccchannel_16_analyzer_1_array_crystal_array_7_p_interact;
char mccchannel_16_analyzer_1_array_crystal_array_7_mask_string[16384];
char mccchannel_16_analyzer_1_array_crystal_array_7_mask_setting[16384];
MCNUM mccchannel_16_analyzer_1_array_crystal_array_7_number_of_activations;

/* Setting parameters for component 'channel_16_analyzer_1_array_crystal_array_8' [746]. */
char mccchannel_16_analyzer_1_array_crystal_array_8_material_string[16384];
MCNUM mccchannel_16_analyzer_1_array_crystal_array_8_priority;
MCNUM mccchannel_16_analyzer_1_array_crystal_array_8_xwidth;
MCNUM mccchannel_16_analyzer_1_array_crystal_array_8_yheight;
MCNUM mccchannel_16_analyzer_1_array_crystal_array_8_zdepth;
MCNUM mccchannel_16_analyzer_1_array_crystal_array_8_xwidth2;
MCNUM mccchannel_16_analyzer_1_array_crystal_array_8_yheight2;
MCNUM mccchannel_16_analyzer_1_array_crystal_array_8_visualize;
int mccchannel_16_analyzer_1_array_crystal_array_8_target_index;
MCNUM mccchannel_16_analyzer_1_array_crystal_array_8_target_x;
MCNUM mccchannel_16_analyzer_1_array_crystal_array_8_target_y;
MCNUM mccchannel_16_analyzer_1_array_crystal_array_8_target_z;
MCNUM mccchannel_16_analyzer_1_array_crystal_array_8_focus_aw;
MCNUM mccchannel_16_analyzer_1_array_crystal_array_8_focus_ah;
MCNUM mccchannel_16_analyzer_1_array_crystal_array_8_focus_xw;
MCNUM mccchannel_16_analyzer_1_array_crystal_array_8_focus_xh;
MCNUM mccchannel_16_analyzer_1_array_crystal_array_8_focus_r;
MCNUM mccchannel_16_analyzer_1_array_crystal_array_8_p_interact;
char mccchannel_16_analyzer_1_array_crystal_array_8_mask_string[16384];
char mccchannel_16_analyzer_1_array_crystal_array_8_mask_setting[16384];
MCNUM mccchannel_16_analyzer_1_array_crystal_array_8_number_of_activations;

/* Setting parameters for component 'channel_16_analyzer_2_array_crystal_array_0' [749]. */
char mccchannel_16_analyzer_2_array_crystal_array_0_material_string[16384];
MCNUM mccchannel_16_analyzer_2_array_crystal_array_0_priority;
MCNUM mccchannel_16_analyzer_2_array_crystal_array_0_xwidth;
MCNUM mccchannel_16_analyzer_2_array_crystal_array_0_yheight;
MCNUM mccchannel_16_analyzer_2_array_crystal_array_0_zdepth;
MCNUM mccchannel_16_analyzer_2_array_crystal_array_0_xwidth2;
MCNUM mccchannel_16_analyzer_2_array_crystal_array_0_yheight2;
MCNUM mccchannel_16_analyzer_2_array_crystal_array_0_visualize;
int mccchannel_16_analyzer_2_array_crystal_array_0_target_index;
MCNUM mccchannel_16_analyzer_2_array_crystal_array_0_target_x;
MCNUM mccchannel_16_analyzer_2_array_crystal_array_0_target_y;
MCNUM mccchannel_16_analyzer_2_array_crystal_array_0_target_z;
MCNUM mccchannel_16_analyzer_2_array_crystal_array_0_focus_aw;
MCNUM mccchannel_16_analyzer_2_array_crystal_array_0_focus_ah;
MCNUM mccchannel_16_analyzer_2_array_crystal_array_0_focus_xw;
MCNUM mccchannel_16_analyzer_2_array_crystal_array_0_focus_xh;
MCNUM mccchannel_16_analyzer_2_array_crystal_array_0_focus_r;
MCNUM mccchannel_16_analyzer_2_array_crystal_array_0_p_interact;
char mccchannel_16_analyzer_2_array_crystal_array_0_mask_string[16384];
char mccchannel_16_analyzer_2_array_crystal_array_0_mask_setting[16384];
MCNUM mccchannel_16_analyzer_2_array_crystal_array_0_number_of_activations;

/* Setting parameters for component 'channel_16_analyzer_2_array_crystal_array_1' [750]. */
char mccchannel_16_analyzer_2_array_crystal_array_1_material_string[16384];
MCNUM mccchannel_16_analyzer_2_array_crystal_array_1_priority;
MCNUM mccchannel_16_analyzer_2_array_crystal_array_1_xwidth;
MCNUM mccchannel_16_analyzer_2_array_crystal_array_1_yheight;
MCNUM mccchannel_16_analyzer_2_array_crystal_array_1_zdepth;
MCNUM mccchannel_16_analyzer_2_array_crystal_array_1_xwidth2;
MCNUM mccchannel_16_analyzer_2_array_crystal_array_1_yheight2;
MCNUM mccchannel_16_analyzer_2_array_crystal_array_1_visualize;
int mccchannel_16_analyzer_2_array_crystal_array_1_target_index;
MCNUM mccchannel_16_analyzer_2_array_crystal_array_1_target_x;
MCNUM mccchannel_16_analyzer_2_array_crystal_array_1_target_y;
MCNUM mccchannel_16_analyzer_2_array_crystal_array_1_target_z;
MCNUM mccchannel_16_analyzer_2_array_crystal_array_1_focus_aw;
MCNUM mccchannel_16_analyzer_2_array_crystal_array_1_focus_ah;
MCNUM mccchannel_16_analyzer_2_array_crystal_array_1_focus_xw;
MCNUM mccchannel_16_analyzer_2_array_crystal_array_1_focus_xh;
MCNUM mccchannel_16_analyzer_2_array_crystal_array_1_focus_r;
MCNUM mccchannel_16_analyzer_2_array_crystal_array_1_p_interact;
char mccchannel_16_analyzer_2_array_crystal_array_1_mask_string[16384];
char mccchannel_16_analyzer_2_array_crystal_array_1_mask_setting[16384];
MCNUM mccchannel_16_analyzer_2_array_crystal_array_1_number_of_activations;

/* Setting parameters for component 'channel_16_analyzer_2_array_crystal_array_2' [751]. */
char mccchannel_16_analyzer_2_array_crystal_array_2_material_string[16384];
MCNUM mccchannel_16_analyzer_2_array_crystal_array_2_priority;
MCNUM mccchannel_16_analyzer_2_array_crystal_array_2_xwidth;
MCNUM mccchannel_16_analyzer_2_array_crystal_array_2_yheight;
MCNUM mccchannel_16_analyzer_2_array_crystal_array_2_zdepth;
MCNUM mccchannel_16_analyzer_2_array_crystal_array_2_xwidth2;
MCNUM mccchannel_16_analyzer_2_array_crystal_array_2_yheight2;
MCNUM mccchannel_16_analyzer_2_array_crystal_array_2_visualize;
int mccchannel_16_analyzer_2_array_crystal_array_2_target_index;
MCNUM mccchannel_16_analyzer_2_array_crystal_array_2_target_x;
MCNUM mccchannel_16_analyzer_2_array_crystal_array_2_target_y;
MCNUM mccchannel_16_analyzer_2_array_crystal_array_2_target_z;
MCNUM mccchannel_16_analyzer_2_array_crystal_array_2_focus_aw;
MCNUM mccchannel_16_analyzer_2_array_crystal_array_2_focus_ah;
MCNUM mccchannel_16_analyzer_2_array_crystal_array_2_focus_xw;
MCNUM mccchannel_16_analyzer_2_array_crystal_array_2_focus_xh;
MCNUM mccchannel_16_analyzer_2_array_crystal_array_2_focus_r;
MCNUM mccchannel_16_analyzer_2_array_crystal_array_2_p_interact;
char mccchannel_16_analyzer_2_array_crystal_array_2_mask_string[16384];
char mccchannel_16_analyzer_2_array_crystal_array_2_mask_setting[16384];
MCNUM mccchannel_16_analyzer_2_array_crystal_array_2_number_of_activations;

/* Setting parameters for component 'channel_16_analyzer_2_array_crystal_array_3' [752]. */
char mccchannel_16_analyzer_2_array_crystal_array_3_material_string[16384];
MCNUM mccchannel_16_analyzer_2_array_crystal_array_3_priority;
MCNUM mccchannel_16_analyzer_2_array_crystal_array_3_xwidth;
MCNUM mccchannel_16_analyzer_2_array_crystal_array_3_yheight;
MCNUM mccchannel_16_analyzer_2_array_crystal_array_3_zdepth;
MCNUM mccchannel_16_analyzer_2_array_crystal_array_3_xwidth2;
MCNUM mccchannel_16_analyzer_2_array_crystal_array_3_yheight2;
MCNUM mccchannel_16_analyzer_2_array_crystal_array_3_visualize;
int mccchannel_16_analyzer_2_array_crystal_array_3_target_index;
MCNUM mccchannel_16_analyzer_2_array_crystal_array_3_target_x;
MCNUM mccchannel_16_analyzer_2_array_crystal_array_3_target_y;
MCNUM mccchannel_16_analyzer_2_array_crystal_array_3_target_z;
MCNUM mccchannel_16_analyzer_2_array_crystal_array_3_focus_aw;
MCNUM mccchannel_16_analyzer_2_array_crystal_array_3_focus_ah;
MCNUM mccchannel_16_analyzer_2_array_crystal_array_3_focus_xw;
MCNUM mccchannel_16_analyzer_2_array_crystal_array_3_focus_xh;
MCNUM mccchannel_16_analyzer_2_array_crystal_array_3_focus_r;
MCNUM mccchannel_16_analyzer_2_array_crystal_array_3_p_interact;
char mccchannel_16_analyzer_2_array_crystal_array_3_mask_string[16384];
char mccchannel_16_analyzer_2_array_crystal_array_3_mask_setting[16384];
MCNUM mccchannel_16_analyzer_2_array_crystal_array_3_number_of_activations;

/* Setting parameters for component 'channel_16_analyzer_2_array_crystal_array_4' [753]. */
char mccchannel_16_analyzer_2_array_crystal_array_4_material_string[16384];
MCNUM mccchannel_16_analyzer_2_array_crystal_array_4_priority;
MCNUM mccchannel_16_analyzer_2_array_crystal_array_4_xwidth;
MCNUM mccchannel_16_analyzer_2_array_crystal_array_4_yheight;
MCNUM mccchannel_16_analyzer_2_array_crystal_array_4_zdepth;
MCNUM mccchannel_16_analyzer_2_array_crystal_array_4_xwidth2;
MCNUM mccchannel_16_analyzer_2_array_crystal_array_4_yheight2;
MCNUM mccchannel_16_analyzer_2_array_crystal_array_4_visualize;
int mccchannel_16_analyzer_2_array_crystal_array_4_target_index;
MCNUM mccchannel_16_analyzer_2_array_crystal_array_4_target_x;
MCNUM mccchannel_16_analyzer_2_array_crystal_array_4_target_y;
MCNUM mccchannel_16_analyzer_2_array_crystal_array_4_target_z;
MCNUM mccchannel_16_analyzer_2_array_crystal_array_4_focus_aw;
MCNUM mccchannel_16_analyzer_2_array_crystal_array_4_focus_ah;
MCNUM mccchannel_16_analyzer_2_array_crystal_array_4_focus_xw;
MCNUM mccchannel_16_analyzer_2_array_crystal_array_4_focus_xh;
MCNUM mccchannel_16_analyzer_2_array_crystal_array_4_focus_r;
MCNUM mccchannel_16_analyzer_2_array_crystal_array_4_p_interact;
char mccchannel_16_analyzer_2_array_crystal_array_4_mask_string[16384];
char mccchannel_16_analyzer_2_array_crystal_array_4_mask_setting[16384];
MCNUM mccchannel_16_analyzer_2_array_crystal_array_4_number_of_activations;

/* Setting parameters for component 'channel_16_analyzer_2_array_crystal_array_5' [754]. */
char mccchannel_16_analyzer_2_array_crystal_array_5_material_string[16384];
MCNUM mccchannel_16_analyzer_2_array_crystal_array_5_priority;
MCNUM mccchannel_16_analyzer_2_array_crystal_array_5_xwidth;
MCNUM mccchannel_16_analyzer_2_array_crystal_array_5_yheight;
MCNUM mccchannel_16_analyzer_2_array_crystal_array_5_zdepth;
MCNUM mccchannel_16_analyzer_2_array_crystal_array_5_xwidth2;
MCNUM mccchannel_16_analyzer_2_array_crystal_array_5_yheight2;
MCNUM mccchannel_16_analyzer_2_array_crystal_array_5_visualize;
int mccchannel_16_analyzer_2_array_crystal_array_5_target_index;
MCNUM mccchannel_16_analyzer_2_array_crystal_array_5_target_x;
MCNUM mccchannel_16_analyzer_2_array_crystal_array_5_target_y;
MCNUM mccchannel_16_analyzer_2_array_crystal_array_5_target_z;
MCNUM mccchannel_16_analyzer_2_array_crystal_array_5_focus_aw;
MCNUM mccchannel_16_analyzer_2_array_crystal_array_5_focus_ah;
MCNUM mccchannel_16_analyzer_2_array_crystal_array_5_focus_xw;
MCNUM mccchannel_16_analyzer_2_array_crystal_array_5_focus_xh;
MCNUM mccchannel_16_analyzer_2_array_crystal_array_5_focus_r;
MCNUM mccchannel_16_analyzer_2_array_crystal_array_5_p_interact;
char mccchannel_16_analyzer_2_array_crystal_array_5_mask_string[16384];
char mccchannel_16_analyzer_2_array_crystal_array_5_mask_setting[16384];
MCNUM mccchannel_16_analyzer_2_array_crystal_array_5_number_of_activations;

/* Setting parameters for component 'channel_16_analyzer_2_array_crystal_array_6' [755]. */
char mccchannel_16_analyzer_2_array_crystal_array_6_material_string[16384];
MCNUM mccchannel_16_analyzer_2_array_crystal_array_6_priority;
MCNUM mccchannel_16_analyzer_2_array_crystal_array_6_xwidth;
MCNUM mccchannel_16_analyzer_2_array_crystal_array_6_yheight;
MCNUM mccchannel_16_analyzer_2_array_crystal_array_6_zdepth;
MCNUM mccchannel_16_analyzer_2_array_crystal_array_6_xwidth2;
MCNUM mccchannel_16_analyzer_2_array_crystal_array_6_yheight2;
MCNUM mccchannel_16_analyzer_2_array_crystal_array_6_visualize;
int mccchannel_16_analyzer_2_array_crystal_array_6_target_index;
MCNUM mccchannel_16_analyzer_2_array_crystal_array_6_target_x;
MCNUM mccchannel_16_analyzer_2_array_crystal_array_6_target_y;
MCNUM mccchannel_16_analyzer_2_array_crystal_array_6_target_z;
MCNUM mccchannel_16_analyzer_2_array_crystal_array_6_focus_aw;
MCNUM mccchannel_16_analyzer_2_array_crystal_array_6_focus_ah;
MCNUM mccchannel_16_analyzer_2_array_crystal_array_6_focus_xw;
MCNUM mccchannel_16_analyzer_2_array_crystal_array_6_focus_xh;
MCNUM mccchannel_16_analyzer_2_array_crystal_array_6_focus_r;
MCNUM mccchannel_16_analyzer_2_array_crystal_array_6_p_interact;
char mccchannel_16_analyzer_2_array_crystal_array_6_mask_string[16384];
char mccchannel_16_analyzer_2_array_crystal_array_6_mask_setting[16384];
MCNUM mccchannel_16_analyzer_2_array_crystal_array_6_number_of_activations;

/* Setting parameters for component 'channel_16_analyzer_2_array_crystal_array_7' [756]. */
char mccchannel_16_analyzer_2_array_crystal_array_7_material_string[16384];
MCNUM mccchannel_16_analyzer_2_array_crystal_array_7_priority;
MCNUM mccchannel_16_analyzer_2_array_crystal_array_7_xwidth;
MCNUM mccchannel_16_analyzer_2_array_crystal_array_7_yheight;
MCNUM mccchannel_16_analyzer_2_array_crystal_array_7_zdepth;
MCNUM mccchannel_16_analyzer_2_array_crystal_array_7_xwidth2;
MCNUM mccchannel_16_analyzer_2_array_crystal_array_7_yheight2;
MCNUM mccchannel_16_analyzer_2_array_crystal_array_7_visualize;
int mccchannel_16_analyzer_2_array_crystal_array_7_target_index;
MCNUM mccchannel_16_analyzer_2_array_crystal_array_7_target_x;
MCNUM mccchannel_16_analyzer_2_array_crystal_array_7_target_y;
MCNUM mccchannel_16_analyzer_2_array_crystal_array_7_target_z;
MCNUM mccchannel_16_analyzer_2_array_crystal_array_7_focus_aw;
MCNUM mccchannel_16_analyzer_2_array_crystal_array_7_focus_ah;
MCNUM mccchannel_16_analyzer_2_array_crystal_array_7_focus_xw;
MCNUM mccchannel_16_analyzer_2_array_crystal_array_7_focus_xh;
MCNUM mccchannel_16_analyzer_2_array_crystal_array_7_focus_r;
MCNUM mccchannel_16_analyzer_2_array_crystal_array_7_p_interact;
char mccchannel_16_analyzer_2_array_crystal_array_7_mask_string[16384];
char mccchannel_16_analyzer_2_array_crystal_array_7_mask_setting[16384];
MCNUM mccchannel_16_analyzer_2_array_crystal_array_7_number_of_activations;

/* Setting parameters for component 'channel_16_analyzer_2_array_crystal_array_8' [757]. */
char mccchannel_16_analyzer_2_array_crystal_array_8_material_string[16384];
MCNUM mccchannel_16_analyzer_2_array_crystal_array_8_priority;
MCNUM mccchannel_16_analyzer_2_array_crystal_array_8_xwidth;
MCNUM mccchannel_16_analyzer_2_array_crystal_array_8_yheight;
MCNUM mccchannel_16_analyzer_2_array_crystal_array_8_zdepth;
MCNUM mccchannel_16_analyzer_2_array_crystal_array_8_xwidth2;
MCNUM mccchannel_16_analyzer_2_array_crystal_array_8_yheight2;
MCNUM mccchannel_16_analyzer_2_array_crystal_array_8_visualize;
int mccchannel_16_analyzer_2_array_crystal_array_8_target_index;
MCNUM mccchannel_16_analyzer_2_array_crystal_array_8_target_x;
MCNUM mccchannel_16_analyzer_2_array_crystal_array_8_target_y;
MCNUM mccchannel_16_analyzer_2_array_crystal_array_8_target_z;
MCNUM mccchannel_16_analyzer_2_array_crystal_array_8_focus_aw;
MCNUM mccchannel_16_analyzer_2_array_crystal_array_8_focus_ah;
MCNUM mccchannel_16_analyzer_2_array_crystal_array_8_focus_xw;
MCNUM mccchannel_16_analyzer_2_array_crystal_array_8_focus_xh;
MCNUM mccchannel_16_analyzer_2_array_crystal_array_8_focus_r;
MCNUM mccchannel_16_analyzer_2_array_crystal_array_8_p_interact;
char mccchannel_16_analyzer_2_array_crystal_array_8_mask_string[16384];
char mccchannel_16_analyzer_2_array_crystal_array_8_mask_setting[16384];
MCNUM mccchannel_16_analyzer_2_array_crystal_array_8_number_of_activations;

/* Setting parameters for component 'channel_16_cave2_cyl1' [758]. */
char mccchannel_16_cave2_cyl1_material_string[16384];
MCNUM mccchannel_16_cave2_cyl1_priority;
MCNUM mccchannel_16_cave2_cyl1_radius;
MCNUM mccchannel_16_cave2_cyl1_yheight;
MCNUM mccchannel_16_cave2_cyl1_visualize;
int mccchannel_16_cave2_cyl1_target_index;
MCNUM mccchannel_16_cave2_cyl1_target_x;
MCNUM mccchannel_16_cave2_cyl1_target_y;
MCNUM mccchannel_16_cave2_cyl1_target_z;
MCNUM mccchannel_16_cave2_cyl1_focus_aw;
MCNUM mccchannel_16_cave2_cyl1_focus_ah;
MCNUM mccchannel_16_cave2_cyl1_focus_xw;
MCNUM mccchannel_16_cave2_cyl1_focus_xh;
MCNUM mccchannel_16_cave2_cyl1_focus_r;
MCNUM mccchannel_16_cave2_cyl1_p_interact;
char mccchannel_16_cave2_cyl1_mask_string[16384];
char mccchannel_16_cave2_cyl1_mask_setting[16384];
MCNUM mccchannel_16_cave2_cyl1_number_of_activations;

/* Setting parameters for component 'channel_16_cave2_box1' [759]. */
char mccchannel_16_cave2_box1_material_string[16384];
MCNUM mccchannel_16_cave2_box1_priority;
MCNUM mccchannel_16_cave2_box1_xwidth;
MCNUM mccchannel_16_cave2_box1_yheight;
MCNUM mccchannel_16_cave2_box1_zdepth;
MCNUM mccchannel_16_cave2_box1_xwidth2;
MCNUM mccchannel_16_cave2_box1_yheight2;
MCNUM mccchannel_16_cave2_box1_visualize;
int mccchannel_16_cave2_box1_target_index;
MCNUM mccchannel_16_cave2_box1_target_x;
MCNUM mccchannel_16_cave2_box1_target_y;
MCNUM mccchannel_16_cave2_box1_target_z;
MCNUM mccchannel_16_cave2_box1_focus_aw;
MCNUM mccchannel_16_cave2_box1_focus_ah;
MCNUM mccchannel_16_cave2_box1_focus_xw;
MCNUM mccchannel_16_cave2_box1_focus_xh;
MCNUM mccchannel_16_cave2_box1_focus_r;
MCNUM mccchannel_16_cave2_box1_p_interact;
char mccchannel_16_cave2_box1_mask_string[16384];
char mccchannel_16_cave2_box1_mask_setting[16384];
MCNUM mccchannel_16_cave2_box1_number_of_activations;

/* Setting parameters for component 'channel_16_cave2_box2' [760]. */
char mccchannel_16_cave2_box2_material_string[16384];
MCNUM mccchannel_16_cave2_box2_priority;
MCNUM mccchannel_16_cave2_box2_xwidth;
MCNUM mccchannel_16_cave2_box2_yheight;
MCNUM mccchannel_16_cave2_box2_zdepth;
MCNUM mccchannel_16_cave2_box2_xwidth2;
MCNUM mccchannel_16_cave2_box2_yheight2;
MCNUM mccchannel_16_cave2_box2_visualize;
int mccchannel_16_cave2_box2_target_index;
MCNUM mccchannel_16_cave2_box2_target_x;
MCNUM mccchannel_16_cave2_box2_target_y;
MCNUM mccchannel_16_cave2_box2_target_z;
MCNUM mccchannel_16_cave2_box2_focus_aw;
MCNUM mccchannel_16_cave2_box2_focus_ah;
MCNUM mccchannel_16_cave2_box2_focus_xw;
MCNUM mccchannel_16_cave2_box2_focus_xh;
MCNUM mccchannel_16_cave2_box2_focus_r;
MCNUM mccchannel_16_cave2_box2_p_interact;
char mccchannel_16_cave2_box2_mask_string[16384];
char mccchannel_16_cave2_box2_mask_setting[16384];
MCNUM mccchannel_16_cave2_box2_number_of_activations;

/* Setting parameters for component 'channel_16_cave2_box3' [761]. */
char mccchannel_16_cave2_box3_material_string[16384];
MCNUM mccchannel_16_cave2_box3_priority;
MCNUM mccchannel_16_cave2_box3_xwidth;
MCNUM mccchannel_16_cave2_box3_yheight;
MCNUM mccchannel_16_cave2_box3_zdepth;
MCNUM mccchannel_16_cave2_box3_xwidth2;
MCNUM mccchannel_16_cave2_box3_yheight2;
MCNUM mccchannel_16_cave2_box3_visualize;
int mccchannel_16_cave2_box3_target_index;
MCNUM mccchannel_16_cave2_box3_target_x;
MCNUM mccchannel_16_cave2_box3_target_y;
MCNUM mccchannel_16_cave2_box3_target_z;
MCNUM mccchannel_16_cave2_box3_focus_aw;
MCNUM mccchannel_16_cave2_box3_focus_ah;
MCNUM mccchannel_16_cave2_box3_focus_xw;
MCNUM mccchannel_16_cave2_box3_focus_xh;
MCNUM mccchannel_16_cave2_box3_focus_r;
MCNUM mccchannel_16_cave2_box3_p_interact;
char mccchannel_16_cave2_box3_mask_string[16384];
char mccchannel_16_cave2_box3_mask_setting[16384];
MCNUM mccchannel_16_cave2_box3_number_of_activations;

/* Setting parameters for component 'inter_analyzer_colimator_16_blade_0' [763]. */
char mccinter_analyzer_colimator_16_blade_0_material_string[16384];
MCNUM mccinter_analyzer_colimator_16_blade_0_priority;
MCNUM mccinter_analyzer_colimator_16_blade_0_xwidth;
MCNUM mccinter_analyzer_colimator_16_blade_0_yheight;
MCNUM mccinter_analyzer_colimator_16_blade_0_zdepth;
MCNUM mccinter_analyzer_colimator_16_blade_0_xwidth2;
MCNUM mccinter_analyzer_colimator_16_blade_0_yheight2;
MCNUM mccinter_analyzer_colimator_16_blade_0_visualize;
int mccinter_analyzer_colimator_16_blade_0_target_index;
MCNUM mccinter_analyzer_colimator_16_blade_0_target_x;
MCNUM mccinter_analyzer_colimator_16_blade_0_target_y;
MCNUM mccinter_analyzer_colimator_16_blade_0_target_z;
MCNUM mccinter_analyzer_colimator_16_blade_0_focus_aw;
MCNUM mccinter_analyzer_colimator_16_blade_0_focus_ah;
MCNUM mccinter_analyzer_colimator_16_blade_0_focus_xw;
MCNUM mccinter_analyzer_colimator_16_blade_0_focus_xh;
MCNUM mccinter_analyzer_colimator_16_blade_0_focus_r;
MCNUM mccinter_analyzer_colimator_16_blade_0_p_interact;
char mccinter_analyzer_colimator_16_blade_0_mask_string[16384];
char mccinter_analyzer_colimator_16_blade_0_mask_setting[16384];
MCNUM mccinter_analyzer_colimator_16_blade_0_number_of_activations;

/* Setting parameters for component 'inter_analyzer_colimator_16_blade_1' [764]. */
char mccinter_analyzer_colimator_16_blade_1_material_string[16384];
MCNUM mccinter_analyzer_colimator_16_blade_1_priority;
MCNUM mccinter_analyzer_colimator_16_blade_1_xwidth;
MCNUM mccinter_analyzer_colimator_16_blade_1_yheight;
MCNUM mccinter_analyzer_colimator_16_blade_1_zdepth;
MCNUM mccinter_analyzer_colimator_16_blade_1_xwidth2;
MCNUM mccinter_analyzer_colimator_16_blade_1_yheight2;
MCNUM mccinter_analyzer_colimator_16_blade_1_visualize;
int mccinter_analyzer_colimator_16_blade_1_target_index;
MCNUM mccinter_analyzer_colimator_16_blade_1_target_x;
MCNUM mccinter_analyzer_colimator_16_blade_1_target_y;
MCNUM mccinter_analyzer_colimator_16_blade_1_target_z;
MCNUM mccinter_analyzer_colimator_16_blade_1_focus_aw;
MCNUM mccinter_analyzer_colimator_16_blade_1_focus_ah;
MCNUM mccinter_analyzer_colimator_16_blade_1_focus_xw;
MCNUM mccinter_analyzer_colimator_16_blade_1_focus_xh;
MCNUM mccinter_analyzer_colimator_16_blade_1_focus_r;
MCNUM mccinter_analyzer_colimator_16_blade_1_p_interact;
char mccinter_analyzer_colimator_16_blade_1_mask_string[16384];
char mccinter_analyzer_colimator_16_blade_1_mask_setting[16384];
MCNUM mccinter_analyzer_colimator_16_blade_1_number_of_activations;

/* Setting parameters for component 'inter_analyzer_colimator_16_blade_2' [765]. */
char mccinter_analyzer_colimator_16_blade_2_material_string[16384];
MCNUM mccinter_analyzer_colimator_16_blade_2_priority;
MCNUM mccinter_analyzer_colimator_16_blade_2_xwidth;
MCNUM mccinter_analyzer_colimator_16_blade_2_yheight;
MCNUM mccinter_analyzer_colimator_16_blade_2_zdepth;
MCNUM mccinter_analyzer_colimator_16_blade_2_xwidth2;
MCNUM mccinter_analyzer_colimator_16_blade_2_yheight2;
MCNUM mccinter_analyzer_colimator_16_blade_2_visualize;
int mccinter_analyzer_colimator_16_blade_2_target_index;
MCNUM mccinter_analyzer_colimator_16_blade_2_target_x;
MCNUM mccinter_analyzer_colimator_16_blade_2_target_y;
MCNUM mccinter_analyzer_colimator_16_blade_2_target_z;
MCNUM mccinter_analyzer_colimator_16_blade_2_focus_aw;
MCNUM mccinter_analyzer_colimator_16_blade_2_focus_ah;
MCNUM mccinter_analyzer_colimator_16_blade_2_focus_xw;
MCNUM mccinter_analyzer_colimator_16_blade_2_focus_xh;
MCNUM mccinter_analyzer_colimator_16_blade_2_focus_r;
MCNUM mccinter_analyzer_colimator_16_blade_2_p_interact;
char mccinter_analyzer_colimator_16_blade_2_mask_string[16384];
char mccinter_analyzer_colimator_16_blade_2_mask_setting[16384];
MCNUM mccinter_analyzer_colimator_16_blade_2_number_of_activations;

/* Setting parameters for component 'inter_analyzer_colimator_16_blade_3' [766]. */
char mccinter_analyzer_colimator_16_blade_3_material_string[16384];
MCNUM mccinter_analyzer_colimator_16_blade_3_priority;
MCNUM mccinter_analyzer_colimator_16_blade_3_xwidth;
MCNUM mccinter_analyzer_colimator_16_blade_3_yheight;
MCNUM mccinter_analyzer_colimator_16_blade_3_zdepth;
MCNUM mccinter_analyzer_colimator_16_blade_3_xwidth2;
MCNUM mccinter_analyzer_colimator_16_blade_3_yheight2;
MCNUM mccinter_analyzer_colimator_16_blade_3_visualize;
int mccinter_analyzer_colimator_16_blade_3_target_index;
MCNUM mccinter_analyzer_colimator_16_blade_3_target_x;
MCNUM mccinter_analyzer_colimator_16_blade_3_target_y;
MCNUM mccinter_analyzer_colimator_16_blade_3_target_z;
MCNUM mccinter_analyzer_colimator_16_blade_3_focus_aw;
MCNUM mccinter_analyzer_colimator_16_blade_3_focus_ah;
MCNUM mccinter_analyzer_colimator_16_blade_3_focus_xw;
MCNUM mccinter_analyzer_colimator_16_blade_3_focus_xh;
MCNUM mccinter_analyzer_colimator_16_blade_3_focus_r;
MCNUM mccinter_analyzer_colimator_16_blade_3_p_interact;
char mccinter_analyzer_colimator_16_blade_3_mask_string[16384];
char mccinter_analyzer_colimator_16_blade_3_mask_setting[16384];
MCNUM mccinter_analyzer_colimator_16_blade_3_number_of_activations;

/* Setting parameters for component 'inter_analyzer_colimator_16_blade_4' [767]. */
char mccinter_analyzer_colimator_16_blade_4_material_string[16384];
MCNUM mccinter_analyzer_colimator_16_blade_4_priority;
MCNUM mccinter_analyzer_colimator_16_blade_4_xwidth;
MCNUM mccinter_analyzer_colimator_16_blade_4_yheight;
MCNUM mccinter_analyzer_colimator_16_blade_4_zdepth;
MCNUM mccinter_analyzer_colimator_16_blade_4_xwidth2;
MCNUM mccinter_analyzer_colimator_16_blade_4_yheight2;
MCNUM mccinter_analyzer_colimator_16_blade_4_visualize;
int mccinter_analyzer_colimator_16_blade_4_target_index;
MCNUM mccinter_analyzer_colimator_16_blade_4_target_x;
MCNUM mccinter_analyzer_colimator_16_blade_4_target_y;
MCNUM mccinter_analyzer_colimator_16_blade_4_target_z;
MCNUM mccinter_analyzer_colimator_16_blade_4_focus_aw;
MCNUM mccinter_analyzer_colimator_16_blade_4_focus_ah;
MCNUM mccinter_analyzer_colimator_16_blade_4_focus_xw;
MCNUM mccinter_analyzer_colimator_16_blade_4_focus_xh;
MCNUM mccinter_analyzer_colimator_16_blade_4_focus_r;
MCNUM mccinter_analyzer_colimator_16_blade_4_p_interact;
char mccinter_analyzer_colimator_16_blade_4_mask_string[16384];
char mccinter_analyzer_colimator_16_blade_4_mask_setting[16384];
MCNUM mccinter_analyzer_colimator_16_blade_4_number_of_activations;

/* Setting parameters for component 'diffraction_detector_16_exit_volume' [768]. */
char mccdiffraction_detector_16_exit_volume_material_string[16384];
MCNUM mccdiffraction_detector_16_exit_volume_priority;
MCNUM mccdiffraction_detector_16_exit_volume_xwidth;
MCNUM mccdiffraction_detector_16_exit_volume_yheight;
MCNUM mccdiffraction_detector_16_exit_volume_zdepth;
MCNUM mccdiffraction_detector_16_exit_volume_xwidth2;
MCNUM mccdiffraction_detector_16_exit_volume_yheight2;
MCNUM mccdiffraction_detector_16_exit_volume_visualize;
int mccdiffraction_detector_16_exit_volume_target_index;
MCNUM mccdiffraction_detector_16_exit_volume_target_x;
MCNUM mccdiffraction_detector_16_exit_volume_target_y;
MCNUM mccdiffraction_detector_16_exit_volume_target_z;
MCNUM mccdiffraction_detector_16_exit_volume_focus_aw;
MCNUM mccdiffraction_detector_16_exit_volume_focus_ah;
MCNUM mccdiffraction_detector_16_exit_volume_focus_xw;
MCNUM mccdiffraction_detector_16_exit_volume_focus_xh;
MCNUM mccdiffraction_detector_16_exit_volume_focus_r;
MCNUM mccdiffraction_detector_16_exit_volume_p_interact;
char mccdiffraction_detector_16_exit_volume_mask_string[16384];
char mccdiffraction_detector_16_exit_volume_mask_setting[16384];
MCNUM mccdiffraction_detector_16_exit_volume_number_of_activations;

/* Setting parameters for component 'spec_detector_16_exit_volume' [769]. */
char mccspec_detector_16_exit_volume_material_string[16384];
MCNUM mccspec_detector_16_exit_volume_priority;
MCNUM mccspec_detector_16_exit_volume_xwidth;
MCNUM mccspec_detector_16_exit_volume_yheight;
MCNUM mccspec_detector_16_exit_volume_zdepth;
MCNUM mccspec_detector_16_exit_volume_xwidth2;
MCNUM mccspec_detector_16_exit_volume_yheight2;
MCNUM mccspec_detector_16_exit_volume_visualize;
int mccspec_detector_16_exit_volume_target_index;
MCNUM mccspec_detector_16_exit_volume_target_x;
MCNUM mccspec_detector_16_exit_volume_target_y;
MCNUM mccspec_detector_16_exit_volume_target_z;
MCNUM mccspec_detector_16_exit_volume_focus_aw;
MCNUM mccspec_detector_16_exit_volume_focus_ah;
MCNUM mccspec_detector_16_exit_volume_focus_xw;
MCNUM mccspec_detector_16_exit_volume_focus_xh;
MCNUM mccspec_detector_16_exit_volume_focus_r;
MCNUM mccspec_detector_16_exit_volume_p_interact;
char mccspec_detector_16_exit_volume_mask_string[16384];
char mccspec_detector_16_exit_volume_mask_setting[16384];
MCNUM mccspec_detector_16_exit_volume_number_of_activations;

/* Setting parameters for component 'channel_17_cave1_box1' [770]. */
char mccchannel_17_cave1_box1_material_string[16384];
MCNUM mccchannel_17_cave1_box1_priority;
MCNUM mccchannel_17_cave1_box1_xwidth;
MCNUM mccchannel_17_cave1_box1_yheight;
MCNUM mccchannel_17_cave1_box1_zdepth;
MCNUM mccchannel_17_cave1_box1_xwidth2;
MCNUM mccchannel_17_cave1_box1_yheight2;
MCNUM mccchannel_17_cave1_box1_visualize;
int mccchannel_17_cave1_box1_target_index;
MCNUM mccchannel_17_cave1_box1_target_x;
MCNUM mccchannel_17_cave1_box1_target_y;
MCNUM mccchannel_17_cave1_box1_target_z;
MCNUM mccchannel_17_cave1_box1_focus_aw;
MCNUM mccchannel_17_cave1_box1_focus_ah;
MCNUM mccchannel_17_cave1_box1_focus_xw;
MCNUM mccchannel_17_cave1_box1_focus_xh;
MCNUM mccchannel_17_cave1_box1_focus_r;
MCNUM mccchannel_17_cave1_box1_p_interact;
char mccchannel_17_cave1_box1_mask_string[16384];
char mccchannel_17_cave1_box1_mask_setting[16384];
MCNUM mccchannel_17_cave1_box1_number_of_activations;

/* Setting parameters for component 'channel_17_cave1_box2' [771]. */
char mccchannel_17_cave1_box2_material_string[16384];
MCNUM mccchannel_17_cave1_box2_priority;
MCNUM mccchannel_17_cave1_box2_xwidth;
MCNUM mccchannel_17_cave1_box2_yheight;
MCNUM mccchannel_17_cave1_box2_zdepth;
MCNUM mccchannel_17_cave1_box2_xwidth2;
MCNUM mccchannel_17_cave1_box2_yheight2;
MCNUM mccchannel_17_cave1_box2_visualize;
int mccchannel_17_cave1_box2_target_index;
MCNUM mccchannel_17_cave1_box2_target_x;
MCNUM mccchannel_17_cave1_box2_target_y;
MCNUM mccchannel_17_cave1_box2_target_z;
MCNUM mccchannel_17_cave1_box2_focus_aw;
MCNUM mccchannel_17_cave1_box2_focus_ah;
MCNUM mccchannel_17_cave1_box2_focus_xw;
MCNUM mccchannel_17_cave1_box2_focus_xh;
MCNUM mccchannel_17_cave1_box2_focus_r;
MCNUM mccchannel_17_cave1_box2_p_interact;
char mccchannel_17_cave1_box2_mask_string[16384];
char mccchannel_17_cave1_box2_mask_setting[16384];
MCNUM mccchannel_17_cave1_box2_number_of_activations;

/* Setting parameters for component 'channel_17_cave1_box3' [772]. */
char mccchannel_17_cave1_box3_material_string[16384];
MCNUM mccchannel_17_cave1_box3_priority;
MCNUM mccchannel_17_cave1_box3_xwidth;
MCNUM mccchannel_17_cave1_box3_yheight;
MCNUM mccchannel_17_cave1_box3_zdepth;
MCNUM mccchannel_17_cave1_box3_xwidth2;
MCNUM mccchannel_17_cave1_box3_yheight2;
MCNUM mccchannel_17_cave1_box3_visualize;
int mccchannel_17_cave1_box3_target_index;
MCNUM mccchannel_17_cave1_box3_target_x;
MCNUM mccchannel_17_cave1_box3_target_y;
MCNUM mccchannel_17_cave1_box3_target_z;
MCNUM mccchannel_17_cave1_box3_focus_aw;
MCNUM mccchannel_17_cave1_box3_focus_ah;
MCNUM mccchannel_17_cave1_box3_focus_xw;
MCNUM mccchannel_17_cave1_box3_focus_xh;
MCNUM mccchannel_17_cave1_box3_focus_r;
MCNUM mccchannel_17_cave1_box3_p_interact;
char mccchannel_17_cave1_box3_mask_string[16384];
char mccchannel_17_cave1_box3_mask_setting[16384];
MCNUM mccchannel_17_cave1_box3_number_of_activations;

/* Setting parameters for component 'channel_17_cave1_cyl1' [773]. */
char mccchannel_17_cave1_cyl1_material_string[16384];
MCNUM mccchannel_17_cave1_cyl1_priority;
MCNUM mccchannel_17_cave1_cyl1_radius;
MCNUM mccchannel_17_cave1_cyl1_yheight;
MCNUM mccchannel_17_cave1_cyl1_visualize;
int mccchannel_17_cave1_cyl1_target_index;
MCNUM mccchannel_17_cave1_cyl1_target_x;
MCNUM mccchannel_17_cave1_cyl1_target_y;
MCNUM mccchannel_17_cave1_cyl1_target_z;
MCNUM mccchannel_17_cave1_cyl1_focus_aw;
MCNUM mccchannel_17_cave1_cyl1_focus_ah;
MCNUM mccchannel_17_cave1_cyl1_focus_xw;
MCNUM mccchannel_17_cave1_cyl1_focus_xh;
MCNUM mccchannel_17_cave1_cyl1_focus_r;
MCNUM mccchannel_17_cave1_cyl1_p_interact;
char mccchannel_17_cave1_cyl1_mask_string[16384];
char mccchannel_17_cave1_cyl1_mask_setting[16384];
MCNUM mccchannel_17_cave1_cyl1_number_of_activations;

/* Setting parameters for component 'channel_17_analyzer_1_array_crystal_array_0' [776]. */
char mccchannel_17_analyzer_1_array_crystal_array_0_material_string[16384];
MCNUM mccchannel_17_analyzer_1_array_crystal_array_0_priority;
MCNUM mccchannel_17_analyzer_1_array_crystal_array_0_xwidth;
MCNUM mccchannel_17_analyzer_1_array_crystal_array_0_yheight;
MCNUM mccchannel_17_analyzer_1_array_crystal_array_0_zdepth;
MCNUM mccchannel_17_analyzer_1_array_crystal_array_0_xwidth2;
MCNUM mccchannel_17_analyzer_1_array_crystal_array_0_yheight2;
MCNUM mccchannel_17_analyzer_1_array_crystal_array_0_visualize;
int mccchannel_17_analyzer_1_array_crystal_array_0_target_index;
MCNUM mccchannel_17_analyzer_1_array_crystal_array_0_target_x;
MCNUM mccchannel_17_analyzer_1_array_crystal_array_0_target_y;
MCNUM mccchannel_17_analyzer_1_array_crystal_array_0_target_z;
MCNUM mccchannel_17_analyzer_1_array_crystal_array_0_focus_aw;
MCNUM mccchannel_17_analyzer_1_array_crystal_array_0_focus_ah;
MCNUM mccchannel_17_analyzer_1_array_crystal_array_0_focus_xw;
MCNUM mccchannel_17_analyzer_1_array_crystal_array_0_focus_xh;
MCNUM mccchannel_17_analyzer_1_array_crystal_array_0_focus_r;
MCNUM mccchannel_17_analyzer_1_array_crystal_array_0_p_interact;
char mccchannel_17_analyzer_1_array_crystal_array_0_mask_string[16384];
char mccchannel_17_analyzer_1_array_crystal_array_0_mask_setting[16384];
MCNUM mccchannel_17_analyzer_1_array_crystal_array_0_number_of_activations;

/* Setting parameters for component 'channel_17_analyzer_1_array_crystal_array_1' [777]. */
char mccchannel_17_analyzer_1_array_crystal_array_1_material_string[16384];
MCNUM mccchannel_17_analyzer_1_array_crystal_array_1_priority;
MCNUM mccchannel_17_analyzer_1_array_crystal_array_1_xwidth;
MCNUM mccchannel_17_analyzer_1_array_crystal_array_1_yheight;
MCNUM mccchannel_17_analyzer_1_array_crystal_array_1_zdepth;
MCNUM mccchannel_17_analyzer_1_array_crystal_array_1_xwidth2;
MCNUM mccchannel_17_analyzer_1_array_crystal_array_1_yheight2;
MCNUM mccchannel_17_analyzer_1_array_crystal_array_1_visualize;
int mccchannel_17_analyzer_1_array_crystal_array_1_target_index;
MCNUM mccchannel_17_analyzer_1_array_crystal_array_1_target_x;
MCNUM mccchannel_17_analyzer_1_array_crystal_array_1_target_y;
MCNUM mccchannel_17_analyzer_1_array_crystal_array_1_target_z;
MCNUM mccchannel_17_analyzer_1_array_crystal_array_1_focus_aw;
MCNUM mccchannel_17_analyzer_1_array_crystal_array_1_focus_ah;
MCNUM mccchannel_17_analyzer_1_array_crystal_array_1_focus_xw;
MCNUM mccchannel_17_analyzer_1_array_crystal_array_1_focus_xh;
MCNUM mccchannel_17_analyzer_1_array_crystal_array_1_focus_r;
MCNUM mccchannel_17_analyzer_1_array_crystal_array_1_p_interact;
char mccchannel_17_analyzer_1_array_crystal_array_1_mask_string[16384];
char mccchannel_17_analyzer_1_array_crystal_array_1_mask_setting[16384];
MCNUM mccchannel_17_analyzer_1_array_crystal_array_1_number_of_activations;

/* Setting parameters for component 'channel_17_analyzer_1_array_crystal_array_2' [778]. */
char mccchannel_17_analyzer_1_array_crystal_array_2_material_string[16384];
MCNUM mccchannel_17_analyzer_1_array_crystal_array_2_priority;
MCNUM mccchannel_17_analyzer_1_array_crystal_array_2_xwidth;
MCNUM mccchannel_17_analyzer_1_array_crystal_array_2_yheight;
MCNUM mccchannel_17_analyzer_1_array_crystal_array_2_zdepth;
MCNUM mccchannel_17_analyzer_1_array_crystal_array_2_xwidth2;
MCNUM mccchannel_17_analyzer_1_array_crystal_array_2_yheight2;
MCNUM mccchannel_17_analyzer_1_array_crystal_array_2_visualize;
int mccchannel_17_analyzer_1_array_crystal_array_2_target_index;
MCNUM mccchannel_17_analyzer_1_array_crystal_array_2_target_x;
MCNUM mccchannel_17_analyzer_1_array_crystal_array_2_target_y;
MCNUM mccchannel_17_analyzer_1_array_crystal_array_2_target_z;
MCNUM mccchannel_17_analyzer_1_array_crystal_array_2_focus_aw;
MCNUM mccchannel_17_analyzer_1_array_crystal_array_2_focus_ah;
MCNUM mccchannel_17_analyzer_1_array_crystal_array_2_focus_xw;
MCNUM mccchannel_17_analyzer_1_array_crystal_array_2_focus_xh;
MCNUM mccchannel_17_analyzer_1_array_crystal_array_2_focus_r;
MCNUM mccchannel_17_analyzer_1_array_crystal_array_2_p_interact;
char mccchannel_17_analyzer_1_array_crystal_array_2_mask_string[16384];
char mccchannel_17_analyzer_1_array_crystal_array_2_mask_setting[16384];
MCNUM mccchannel_17_analyzer_1_array_crystal_array_2_number_of_activations;

/* Setting parameters for component 'channel_17_analyzer_1_array_crystal_array_3' [779]. */
char mccchannel_17_analyzer_1_array_crystal_array_3_material_string[16384];
MCNUM mccchannel_17_analyzer_1_array_crystal_array_3_priority;
MCNUM mccchannel_17_analyzer_1_array_crystal_array_3_xwidth;
MCNUM mccchannel_17_analyzer_1_array_crystal_array_3_yheight;
MCNUM mccchannel_17_analyzer_1_array_crystal_array_3_zdepth;
MCNUM mccchannel_17_analyzer_1_array_crystal_array_3_xwidth2;
MCNUM mccchannel_17_analyzer_1_array_crystal_array_3_yheight2;
MCNUM mccchannel_17_analyzer_1_array_crystal_array_3_visualize;
int mccchannel_17_analyzer_1_array_crystal_array_3_target_index;
MCNUM mccchannel_17_analyzer_1_array_crystal_array_3_target_x;
MCNUM mccchannel_17_analyzer_1_array_crystal_array_3_target_y;
MCNUM mccchannel_17_analyzer_1_array_crystal_array_3_target_z;
MCNUM mccchannel_17_analyzer_1_array_crystal_array_3_focus_aw;
MCNUM mccchannel_17_analyzer_1_array_crystal_array_3_focus_ah;
MCNUM mccchannel_17_analyzer_1_array_crystal_array_3_focus_xw;
MCNUM mccchannel_17_analyzer_1_array_crystal_array_3_focus_xh;
MCNUM mccchannel_17_analyzer_1_array_crystal_array_3_focus_r;
MCNUM mccchannel_17_analyzer_1_array_crystal_array_3_p_interact;
char mccchannel_17_analyzer_1_array_crystal_array_3_mask_string[16384];
char mccchannel_17_analyzer_1_array_crystal_array_3_mask_setting[16384];
MCNUM mccchannel_17_analyzer_1_array_crystal_array_3_number_of_activations;

/* Setting parameters for component 'channel_17_analyzer_1_array_crystal_array_4' [780]. */
char mccchannel_17_analyzer_1_array_crystal_array_4_material_string[16384];
MCNUM mccchannel_17_analyzer_1_array_crystal_array_4_priority;
MCNUM mccchannel_17_analyzer_1_array_crystal_array_4_xwidth;
MCNUM mccchannel_17_analyzer_1_array_crystal_array_4_yheight;
MCNUM mccchannel_17_analyzer_1_array_crystal_array_4_zdepth;
MCNUM mccchannel_17_analyzer_1_array_crystal_array_4_xwidth2;
MCNUM mccchannel_17_analyzer_1_array_crystal_array_4_yheight2;
MCNUM mccchannel_17_analyzer_1_array_crystal_array_4_visualize;
int mccchannel_17_analyzer_1_array_crystal_array_4_target_index;
MCNUM mccchannel_17_analyzer_1_array_crystal_array_4_target_x;
MCNUM mccchannel_17_analyzer_1_array_crystal_array_4_target_y;
MCNUM mccchannel_17_analyzer_1_array_crystal_array_4_target_z;
MCNUM mccchannel_17_analyzer_1_array_crystal_array_4_focus_aw;
MCNUM mccchannel_17_analyzer_1_array_crystal_array_4_focus_ah;
MCNUM mccchannel_17_analyzer_1_array_crystal_array_4_focus_xw;
MCNUM mccchannel_17_analyzer_1_array_crystal_array_4_focus_xh;
MCNUM mccchannel_17_analyzer_1_array_crystal_array_4_focus_r;
MCNUM mccchannel_17_analyzer_1_array_crystal_array_4_p_interact;
char mccchannel_17_analyzer_1_array_crystal_array_4_mask_string[16384];
char mccchannel_17_analyzer_1_array_crystal_array_4_mask_setting[16384];
MCNUM mccchannel_17_analyzer_1_array_crystal_array_4_number_of_activations;

/* Setting parameters for component 'channel_17_analyzer_1_array_crystal_array_5' [781]. */
char mccchannel_17_analyzer_1_array_crystal_array_5_material_string[16384];
MCNUM mccchannel_17_analyzer_1_array_crystal_array_5_priority;
MCNUM mccchannel_17_analyzer_1_array_crystal_array_5_xwidth;
MCNUM mccchannel_17_analyzer_1_array_crystal_array_5_yheight;
MCNUM mccchannel_17_analyzer_1_array_crystal_array_5_zdepth;
MCNUM mccchannel_17_analyzer_1_array_crystal_array_5_xwidth2;
MCNUM mccchannel_17_analyzer_1_array_crystal_array_5_yheight2;
MCNUM mccchannel_17_analyzer_1_array_crystal_array_5_visualize;
int mccchannel_17_analyzer_1_array_crystal_array_5_target_index;
MCNUM mccchannel_17_analyzer_1_array_crystal_array_5_target_x;
MCNUM mccchannel_17_analyzer_1_array_crystal_array_5_target_y;
MCNUM mccchannel_17_analyzer_1_array_crystal_array_5_target_z;
MCNUM mccchannel_17_analyzer_1_array_crystal_array_5_focus_aw;
MCNUM mccchannel_17_analyzer_1_array_crystal_array_5_focus_ah;
MCNUM mccchannel_17_analyzer_1_array_crystal_array_5_focus_xw;
MCNUM mccchannel_17_analyzer_1_array_crystal_array_5_focus_xh;
MCNUM mccchannel_17_analyzer_1_array_crystal_array_5_focus_r;
MCNUM mccchannel_17_analyzer_1_array_crystal_array_5_p_interact;
char mccchannel_17_analyzer_1_array_crystal_array_5_mask_string[16384];
char mccchannel_17_analyzer_1_array_crystal_array_5_mask_setting[16384];
MCNUM mccchannel_17_analyzer_1_array_crystal_array_5_number_of_activations;

/* Setting parameters for component 'channel_17_analyzer_1_array_crystal_array_6' [782]. */
char mccchannel_17_analyzer_1_array_crystal_array_6_material_string[16384];
MCNUM mccchannel_17_analyzer_1_array_crystal_array_6_priority;
MCNUM mccchannel_17_analyzer_1_array_crystal_array_6_xwidth;
MCNUM mccchannel_17_analyzer_1_array_crystal_array_6_yheight;
MCNUM mccchannel_17_analyzer_1_array_crystal_array_6_zdepth;
MCNUM mccchannel_17_analyzer_1_array_crystal_array_6_xwidth2;
MCNUM mccchannel_17_analyzer_1_array_crystal_array_6_yheight2;
MCNUM mccchannel_17_analyzer_1_array_crystal_array_6_visualize;
int mccchannel_17_analyzer_1_array_crystal_array_6_target_index;
MCNUM mccchannel_17_analyzer_1_array_crystal_array_6_target_x;
MCNUM mccchannel_17_analyzer_1_array_crystal_array_6_target_y;
MCNUM mccchannel_17_analyzer_1_array_crystal_array_6_target_z;
MCNUM mccchannel_17_analyzer_1_array_crystal_array_6_focus_aw;
MCNUM mccchannel_17_analyzer_1_array_crystal_array_6_focus_ah;
MCNUM mccchannel_17_analyzer_1_array_crystal_array_6_focus_xw;
MCNUM mccchannel_17_analyzer_1_array_crystal_array_6_focus_xh;
MCNUM mccchannel_17_analyzer_1_array_crystal_array_6_focus_r;
MCNUM mccchannel_17_analyzer_1_array_crystal_array_6_p_interact;
char mccchannel_17_analyzer_1_array_crystal_array_6_mask_string[16384];
char mccchannel_17_analyzer_1_array_crystal_array_6_mask_setting[16384];
MCNUM mccchannel_17_analyzer_1_array_crystal_array_6_number_of_activations;

/* Setting parameters for component 'channel_17_analyzer_1_array_crystal_array_7' [783]. */
char mccchannel_17_analyzer_1_array_crystal_array_7_material_string[16384];
MCNUM mccchannel_17_analyzer_1_array_crystal_array_7_priority;
MCNUM mccchannel_17_analyzer_1_array_crystal_array_7_xwidth;
MCNUM mccchannel_17_analyzer_1_array_crystal_array_7_yheight;
MCNUM mccchannel_17_analyzer_1_array_crystal_array_7_zdepth;
MCNUM mccchannel_17_analyzer_1_array_crystal_array_7_xwidth2;
MCNUM mccchannel_17_analyzer_1_array_crystal_array_7_yheight2;
MCNUM mccchannel_17_analyzer_1_array_crystal_array_7_visualize;
int mccchannel_17_analyzer_1_array_crystal_array_7_target_index;
MCNUM mccchannel_17_analyzer_1_array_crystal_array_7_target_x;
MCNUM mccchannel_17_analyzer_1_array_crystal_array_7_target_y;
MCNUM mccchannel_17_analyzer_1_array_crystal_array_7_target_z;
MCNUM mccchannel_17_analyzer_1_array_crystal_array_7_focus_aw;
MCNUM mccchannel_17_analyzer_1_array_crystal_array_7_focus_ah;
MCNUM mccchannel_17_analyzer_1_array_crystal_array_7_focus_xw;
MCNUM mccchannel_17_analyzer_1_array_crystal_array_7_focus_xh;
MCNUM mccchannel_17_analyzer_1_array_crystal_array_7_focus_r;
MCNUM mccchannel_17_analyzer_1_array_crystal_array_7_p_interact;
char mccchannel_17_analyzer_1_array_crystal_array_7_mask_string[16384];
char mccchannel_17_analyzer_1_array_crystal_array_7_mask_setting[16384];
MCNUM mccchannel_17_analyzer_1_array_crystal_array_7_number_of_activations;

/* Setting parameters for component 'channel_17_analyzer_1_array_crystal_array_8' [784]. */
char mccchannel_17_analyzer_1_array_crystal_array_8_material_string[16384];
MCNUM mccchannel_17_analyzer_1_array_crystal_array_8_priority;
MCNUM mccchannel_17_analyzer_1_array_crystal_array_8_xwidth;
MCNUM mccchannel_17_analyzer_1_array_crystal_array_8_yheight;
MCNUM mccchannel_17_analyzer_1_array_crystal_array_8_zdepth;
MCNUM mccchannel_17_analyzer_1_array_crystal_array_8_xwidth2;
MCNUM mccchannel_17_analyzer_1_array_crystal_array_8_yheight2;
MCNUM mccchannel_17_analyzer_1_array_crystal_array_8_visualize;
int mccchannel_17_analyzer_1_array_crystal_array_8_target_index;
MCNUM mccchannel_17_analyzer_1_array_crystal_array_8_target_x;
MCNUM mccchannel_17_analyzer_1_array_crystal_array_8_target_y;
MCNUM mccchannel_17_analyzer_1_array_crystal_array_8_target_z;
MCNUM mccchannel_17_analyzer_1_array_crystal_array_8_focus_aw;
MCNUM mccchannel_17_analyzer_1_array_crystal_array_8_focus_ah;
MCNUM mccchannel_17_analyzer_1_array_crystal_array_8_focus_xw;
MCNUM mccchannel_17_analyzer_1_array_crystal_array_8_focus_xh;
MCNUM mccchannel_17_analyzer_1_array_crystal_array_8_focus_r;
MCNUM mccchannel_17_analyzer_1_array_crystal_array_8_p_interact;
char mccchannel_17_analyzer_1_array_crystal_array_8_mask_string[16384];
char mccchannel_17_analyzer_1_array_crystal_array_8_mask_setting[16384];
MCNUM mccchannel_17_analyzer_1_array_crystal_array_8_number_of_activations;

/* Setting parameters for component 'channel_17_analyzer_2_array_crystal_array_0' [787]. */
char mccchannel_17_analyzer_2_array_crystal_array_0_material_string[16384];
MCNUM mccchannel_17_analyzer_2_array_crystal_array_0_priority;
MCNUM mccchannel_17_analyzer_2_array_crystal_array_0_xwidth;
MCNUM mccchannel_17_analyzer_2_array_crystal_array_0_yheight;
MCNUM mccchannel_17_analyzer_2_array_crystal_array_0_zdepth;
MCNUM mccchannel_17_analyzer_2_array_crystal_array_0_xwidth2;
MCNUM mccchannel_17_analyzer_2_array_crystal_array_0_yheight2;
MCNUM mccchannel_17_analyzer_2_array_crystal_array_0_visualize;
int mccchannel_17_analyzer_2_array_crystal_array_0_target_index;
MCNUM mccchannel_17_analyzer_2_array_crystal_array_0_target_x;
MCNUM mccchannel_17_analyzer_2_array_crystal_array_0_target_y;
MCNUM mccchannel_17_analyzer_2_array_crystal_array_0_target_z;
MCNUM mccchannel_17_analyzer_2_array_crystal_array_0_focus_aw;
MCNUM mccchannel_17_analyzer_2_array_crystal_array_0_focus_ah;
MCNUM mccchannel_17_analyzer_2_array_crystal_array_0_focus_xw;
MCNUM mccchannel_17_analyzer_2_array_crystal_array_0_focus_xh;
MCNUM mccchannel_17_analyzer_2_array_crystal_array_0_focus_r;
MCNUM mccchannel_17_analyzer_2_array_crystal_array_0_p_interact;
char mccchannel_17_analyzer_2_array_crystal_array_0_mask_string[16384];
char mccchannel_17_analyzer_2_array_crystal_array_0_mask_setting[16384];
MCNUM mccchannel_17_analyzer_2_array_crystal_array_0_number_of_activations;

/* Setting parameters for component 'channel_17_analyzer_2_array_crystal_array_1' [788]. */
char mccchannel_17_analyzer_2_array_crystal_array_1_material_string[16384];
MCNUM mccchannel_17_analyzer_2_array_crystal_array_1_priority;
MCNUM mccchannel_17_analyzer_2_array_crystal_array_1_xwidth;
MCNUM mccchannel_17_analyzer_2_array_crystal_array_1_yheight;
MCNUM mccchannel_17_analyzer_2_array_crystal_array_1_zdepth;
MCNUM mccchannel_17_analyzer_2_array_crystal_array_1_xwidth2;
MCNUM mccchannel_17_analyzer_2_array_crystal_array_1_yheight2;
MCNUM mccchannel_17_analyzer_2_array_crystal_array_1_visualize;
int mccchannel_17_analyzer_2_array_crystal_array_1_target_index;
MCNUM mccchannel_17_analyzer_2_array_crystal_array_1_target_x;
MCNUM mccchannel_17_analyzer_2_array_crystal_array_1_target_y;
MCNUM mccchannel_17_analyzer_2_array_crystal_array_1_target_z;
MCNUM mccchannel_17_analyzer_2_array_crystal_array_1_focus_aw;
MCNUM mccchannel_17_analyzer_2_array_crystal_array_1_focus_ah;
MCNUM mccchannel_17_analyzer_2_array_crystal_array_1_focus_xw;
MCNUM mccchannel_17_analyzer_2_array_crystal_array_1_focus_xh;
MCNUM mccchannel_17_analyzer_2_array_crystal_array_1_focus_r;
MCNUM mccchannel_17_analyzer_2_array_crystal_array_1_p_interact;
char mccchannel_17_analyzer_2_array_crystal_array_1_mask_string[16384];
char mccchannel_17_analyzer_2_array_crystal_array_1_mask_setting[16384];
MCNUM mccchannel_17_analyzer_2_array_crystal_array_1_number_of_activations;

/* Setting parameters for component 'channel_17_analyzer_2_array_crystal_array_2' [789]. */
char mccchannel_17_analyzer_2_array_crystal_array_2_material_string[16384];
MCNUM mccchannel_17_analyzer_2_array_crystal_array_2_priority;
MCNUM mccchannel_17_analyzer_2_array_crystal_array_2_xwidth;
MCNUM mccchannel_17_analyzer_2_array_crystal_array_2_yheight;
MCNUM mccchannel_17_analyzer_2_array_crystal_array_2_zdepth;
MCNUM mccchannel_17_analyzer_2_array_crystal_array_2_xwidth2;
MCNUM mccchannel_17_analyzer_2_array_crystal_array_2_yheight2;
MCNUM mccchannel_17_analyzer_2_array_crystal_array_2_visualize;
int mccchannel_17_analyzer_2_array_crystal_array_2_target_index;
MCNUM mccchannel_17_analyzer_2_array_crystal_array_2_target_x;
MCNUM mccchannel_17_analyzer_2_array_crystal_array_2_target_y;
MCNUM mccchannel_17_analyzer_2_array_crystal_array_2_target_z;
MCNUM mccchannel_17_analyzer_2_array_crystal_array_2_focus_aw;
MCNUM mccchannel_17_analyzer_2_array_crystal_array_2_focus_ah;
MCNUM mccchannel_17_analyzer_2_array_crystal_array_2_focus_xw;
MCNUM mccchannel_17_analyzer_2_array_crystal_array_2_focus_xh;
MCNUM mccchannel_17_analyzer_2_array_crystal_array_2_focus_r;
MCNUM mccchannel_17_analyzer_2_array_crystal_array_2_p_interact;
char mccchannel_17_analyzer_2_array_crystal_array_2_mask_string[16384];
char mccchannel_17_analyzer_2_array_crystal_array_2_mask_setting[16384];
MCNUM mccchannel_17_analyzer_2_array_crystal_array_2_number_of_activations;

/* Setting parameters for component 'channel_17_analyzer_2_array_crystal_array_3' [790]. */
char mccchannel_17_analyzer_2_array_crystal_array_3_material_string[16384];
MCNUM mccchannel_17_analyzer_2_array_crystal_array_3_priority;
MCNUM mccchannel_17_analyzer_2_array_crystal_array_3_xwidth;
MCNUM mccchannel_17_analyzer_2_array_crystal_array_3_yheight;
MCNUM mccchannel_17_analyzer_2_array_crystal_array_3_zdepth;
MCNUM mccchannel_17_analyzer_2_array_crystal_array_3_xwidth2;
MCNUM mccchannel_17_analyzer_2_array_crystal_array_3_yheight2;
MCNUM mccchannel_17_analyzer_2_array_crystal_array_3_visualize;
int mccchannel_17_analyzer_2_array_crystal_array_3_target_index;
MCNUM mccchannel_17_analyzer_2_array_crystal_array_3_target_x;
MCNUM mccchannel_17_analyzer_2_array_crystal_array_3_target_y;
MCNUM mccchannel_17_analyzer_2_array_crystal_array_3_target_z;
MCNUM mccchannel_17_analyzer_2_array_crystal_array_3_focus_aw;
MCNUM mccchannel_17_analyzer_2_array_crystal_array_3_focus_ah;
MCNUM mccchannel_17_analyzer_2_array_crystal_array_3_focus_xw;
MCNUM mccchannel_17_analyzer_2_array_crystal_array_3_focus_xh;
MCNUM mccchannel_17_analyzer_2_array_crystal_array_3_focus_r;
MCNUM mccchannel_17_analyzer_2_array_crystal_array_3_p_interact;
char mccchannel_17_analyzer_2_array_crystal_array_3_mask_string[16384];
char mccchannel_17_analyzer_2_array_crystal_array_3_mask_setting[16384];
MCNUM mccchannel_17_analyzer_2_array_crystal_array_3_number_of_activations;

/* Setting parameters for component 'channel_17_analyzer_2_array_crystal_array_4' [791]. */
char mccchannel_17_analyzer_2_array_crystal_array_4_material_string[16384];
MCNUM mccchannel_17_analyzer_2_array_crystal_array_4_priority;
MCNUM mccchannel_17_analyzer_2_array_crystal_array_4_xwidth;
MCNUM mccchannel_17_analyzer_2_array_crystal_array_4_yheight;
MCNUM mccchannel_17_analyzer_2_array_crystal_array_4_zdepth;
MCNUM mccchannel_17_analyzer_2_array_crystal_array_4_xwidth2;
MCNUM mccchannel_17_analyzer_2_array_crystal_array_4_yheight2;
MCNUM mccchannel_17_analyzer_2_array_crystal_array_4_visualize;
int mccchannel_17_analyzer_2_array_crystal_array_4_target_index;
MCNUM mccchannel_17_analyzer_2_array_crystal_array_4_target_x;
MCNUM mccchannel_17_analyzer_2_array_crystal_array_4_target_y;
MCNUM mccchannel_17_analyzer_2_array_crystal_array_4_target_z;
MCNUM mccchannel_17_analyzer_2_array_crystal_array_4_focus_aw;
MCNUM mccchannel_17_analyzer_2_array_crystal_array_4_focus_ah;
MCNUM mccchannel_17_analyzer_2_array_crystal_array_4_focus_xw;
MCNUM mccchannel_17_analyzer_2_array_crystal_array_4_focus_xh;
MCNUM mccchannel_17_analyzer_2_array_crystal_array_4_focus_r;
MCNUM mccchannel_17_analyzer_2_array_crystal_array_4_p_interact;
char mccchannel_17_analyzer_2_array_crystal_array_4_mask_string[16384];
char mccchannel_17_analyzer_2_array_crystal_array_4_mask_setting[16384];
MCNUM mccchannel_17_analyzer_2_array_crystal_array_4_number_of_activations;

/* Setting parameters for component 'channel_17_analyzer_2_array_crystal_array_5' [792]. */
char mccchannel_17_analyzer_2_array_crystal_array_5_material_string[16384];
MCNUM mccchannel_17_analyzer_2_array_crystal_array_5_priority;
MCNUM mccchannel_17_analyzer_2_array_crystal_array_5_xwidth;
MCNUM mccchannel_17_analyzer_2_array_crystal_array_5_yheight;
MCNUM mccchannel_17_analyzer_2_array_crystal_array_5_zdepth;
MCNUM mccchannel_17_analyzer_2_array_crystal_array_5_xwidth2;
MCNUM mccchannel_17_analyzer_2_array_crystal_array_5_yheight2;
MCNUM mccchannel_17_analyzer_2_array_crystal_array_5_visualize;
int mccchannel_17_analyzer_2_array_crystal_array_5_target_index;
MCNUM mccchannel_17_analyzer_2_array_crystal_array_5_target_x;
MCNUM mccchannel_17_analyzer_2_array_crystal_array_5_target_y;
MCNUM mccchannel_17_analyzer_2_array_crystal_array_5_target_z;
MCNUM mccchannel_17_analyzer_2_array_crystal_array_5_focus_aw;
MCNUM mccchannel_17_analyzer_2_array_crystal_array_5_focus_ah;
MCNUM mccchannel_17_analyzer_2_array_crystal_array_5_focus_xw;
MCNUM mccchannel_17_analyzer_2_array_crystal_array_5_focus_xh;
MCNUM mccchannel_17_analyzer_2_array_crystal_array_5_focus_r;
MCNUM mccchannel_17_analyzer_2_array_crystal_array_5_p_interact;
char mccchannel_17_analyzer_2_array_crystal_array_5_mask_string[16384];
char mccchannel_17_analyzer_2_array_crystal_array_5_mask_setting[16384];
MCNUM mccchannel_17_analyzer_2_array_crystal_array_5_number_of_activations;

/* Setting parameters for component 'channel_17_analyzer_2_array_crystal_array_6' [793]. */
char mccchannel_17_analyzer_2_array_crystal_array_6_material_string[16384];
MCNUM mccchannel_17_analyzer_2_array_crystal_array_6_priority;
MCNUM mccchannel_17_analyzer_2_array_crystal_array_6_xwidth;
MCNUM mccchannel_17_analyzer_2_array_crystal_array_6_yheight;
MCNUM mccchannel_17_analyzer_2_array_crystal_array_6_zdepth;
MCNUM mccchannel_17_analyzer_2_array_crystal_array_6_xwidth2;
MCNUM mccchannel_17_analyzer_2_array_crystal_array_6_yheight2;
MCNUM mccchannel_17_analyzer_2_array_crystal_array_6_visualize;
int mccchannel_17_analyzer_2_array_crystal_array_6_target_index;
MCNUM mccchannel_17_analyzer_2_array_crystal_array_6_target_x;
MCNUM mccchannel_17_analyzer_2_array_crystal_array_6_target_y;
MCNUM mccchannel_17_analyzer_2_array_crystal_array_6_target_z;
MCNUM mccchannel_17_analyzer_2_array_crystal_array_6_focus_aw;
MCNUM mccchannel_17_analyzer_2_array_crystal_array_6_focus_ah;
MCNUM mccchannel_17_analyzer_2_array_crystal_array_6_focus_xw;
MCNUM mccchannel_17_analyzer_2_array_crystal_array_6_focus_xh;
MCNUM mccchannel_17_analyzer_2_array_crystal_array_6_focus_r;
MCNUM mccchannel_17_analyzer_2_array_crystal_array_6_p_interact;
char mccchannel_17_analyzer_2_array_crystal_array_6_mask_string[16384];
char mccchannel_17_analyzer_2_array_crystal_array_6_mask_setting[16384];
MCNUM mccchannel_17_analyzer_2_array_crystal_array_6_number_of_activations;

/* Setting parameters for component 'channel_17_analyzer_2_array_crystal_array_7' [794]. */
char mccchannel_17_analyzer_2_array_crystal_array_7_material_string[16384];
MCNUM mccchannel_17_analyzer_2_array_crystal_array_7_priority;
MCNUM mccchannel_17_analyzer_2_array_crystal_array_7_xwidth;
MCNUM mccchannel_17_analyzer_2_array_crystal_array_7_yheight;
MCNUM mccchannel_17_analyzer_2_array_crystal_array_7_zdepth;
MCNUM mccchannel_17_analyzer_2_array_crystal_array_7_xwidth2;
MCNUM mccchannel_17_analyzer_2_array_crystal_array_7_yheight2;
MCNUM mccchannel_17_analyzer_2_array_crystal_array_7_visualize;
int mccchannel_17_analyzer_2_array_crystal_array_7_target_index;
MCNUM mccchannel_17_analyzer_2_array_crystal_array_7_target_x;
MCNUM mccchannel_17_analyzer_2_array_crystal_array_7_target_y;
MCNUM mccchannel_17_analyzer_2_array_crystal_array_7_target_z;
MCNUM mccchannel_17_analyzer_2_array_crystal_array_7_focus_aw;
MCNUM mccchannel_17_analyzer_2_array_crystal_array_7_focus_ah;
MCNUM mccchannel_17_analyzer_2_array_crystal_array_7_focus_xw;
MCNUM mccchannel_17_analyzer_2_array_crystal_array_7_focus_xh;
MCNUM mccchannel_17_analyzer_2_array_crystal_array_7_focus_r;
MCNUM mccchannel_17_analyzer_2_array_crystal_array_7_p_interact;
char mccchannel_17_analyzer_2_array_crystal_array_7_mask_string[16384];
char mccchannel_17_analyzer_2_array_crystal_array_7_mask_setting[16384];
MCNUM mccchannel_17_analyzer_2_array_crystal_array_7_number_of_activations;

/* Setting parameters for component 'channel_17_analyzer_2_array_crystal_array_8' [795]. */
char mccchannel_17_analyzer_2_array_crystal_array_8_material_string[16384];
MCNUM mccchannel_17_analyzer_2_array_crystal_array_8_priority;
MCNUM mccchannel_17_analyzer_2_array_crystal_array_8_xwidth;
MCNUM mccchannel_17_analyzer_2_array_crystal_array_8_yheight;
MCNUM mccchannel_17_analyzer_2_array_crystal_array_8_zdepth;
MCNUM mccchannel_17_analyzer_2_array_crystal_array_8_xwidth2;
MCNUM mccchannel_17_analyzer_2_array_crystal_array_8_yheight2;
MCNUM mccchannel_17_analyzer_2_array_crystal_array_8_visualize;
int mccchannel_17_analyzer_2_array_crystal_array_8_target_index;
MCNUM mccchannel_17_analyzer_2_array_crystal_array_8_target_x;
MCNUM mccchannel_17_analyzer_2_array_crystal_array_8_target_y;
MCNUM mccchannel_17_analyzer_2_array_crystal_array_8_target_z;
MCNUM mccchannel_17_analyzer_2_array_crystal_array_8_focus_aw;
MCNUM mccchannel_17_analyzer_2_array_crystal_array_8_focus_ah;
MCNUM mccchannel_17_analyzer_2_array_crystal_array_8_focus_xw;
MCNUM mccchannel_17_analyzer_2_array_crystal_array_8_focus_xh;
MCNUM mccchannel_17_analyzer_2_array_crystal_array_8_focus_r;
MCNUM mccchannel_17_analyzer_2_array_crystal_array_8_p_interact;
char mccchannel_17_analyzer_2_array_crystal_array_8_mask_string[16384];
char mccchannel_17_analyzer_2_array_crystal_array_8_mask_setting[16384];
MCNUM mccchannel_17_analyzer_2_array_crystal_array_8_number_of_activations;

/* Setting parameters for component 'channel_17_cave2_cyl1' [796]. */
char mccchannel_17_cave2_cyl1_material_string[16384];
MCNUM mccchannel_17_cave2_cyl1_priority;
MCNUM mccchannel_17_cave2_cyl1_radius;
MCNUM mccchannel_17_cave2_cyl1_yheight;
MCNUM mccchannel_17_cave2_cyl1_visualize;
int mccchannel_17_cave2_cyl1_target_index;
MCNUM mccchannel_17_cave2_cyl1_target_x;
MCNUM mccchannel_17_cave2_cyl1_target_y;
MCNUM mccchannel_17_cave2_cyl1_target_z;
MCNUM mccchannel_17_cave2_cyl1_focus_aw;
MCNUM mccchannel_17_cave2_cyl1_focus_ah;
MCNUM mccchannel_17_cave2_cyl1_focus_xw;
MCNUM mccchannel_17_cave2_cyl1_focus_xh;
MCNUM mccchannel_17_cave2_cyl1_focus_r;
MCNUM mccchannel_17_cave2_cyl1_p_interact;
char mccchannel_17_cave2_cyl1_mask_string[16384];
char mccchannel_17_cave2_cyl1_mask_setting[16384];
MCNUM mccchannel_17_cave2_cyl1_number_of_activations;

/* Setting parameters for component 'channel_17_cave2_box1' [797]. */
char mccchannel_17_cave2_box1_material_string[16384];
MCNUM mccchannel_17_cave2_box1_priority;
MCNUM mccchannel_17_cave2_box1_xwidth;
MCNUM mccchannel_17_cave2_box1_yheight;
MCNUM mccchannel_17_cave2_box1_zdepth;
MCNUM mccchannel_17_cave2_box1_xwidth2;
MCNUM mccchannel_17_cave2_box1_yheight2;
MCNUM mccchannel_17_cave2_box1_visualize;
int mccchannel_17_cave2_box1_target_index;
MCNUM mccchannel_17_cave2_box1_target_x;
MCNUM mccchannel_17_cave2_box1_target_y;
MCNUM mccchannel_17_cave2_box1_target_z;
MCNUM mccchannel_17_cave2_box1_focus_aw;
MCNUM mccchannel_17_cave2_box1_focus_ah;
MCNUM mccchannel_17_cave2_box1_focus_xw;
MCNUM mccchannel_17_cave2_box1_focus_xh;
MCNUM mccchannel_17_cave2_box1_focus_r;
MCNUM mccchannel_17_cave2_box1_p_interact;
char mccchannel_17_cave2_box1_mask_string[16384];
char mccchannel_17_cave2_box1_mask_setting[16384];
MCNUM mccchannel_17_cave2_box1_number_of_activations;

/* Setting parameters for component 'channel_17_cave2_box2' [798]. */
char mccchannel_17_cave2_box2_material_string[16384];
MCNUM mccchannel_17_cave2_box2_priority;
MCNUM mccchannel_17_cave2_box2_xwidth;
MCNUM mccchannel_17_cave2_box2_yheight;
MCNUM mccchannel_17_cave2_box2_zdepth;
MCNUM mccchannel_17_cave2_box2_xwidth2;
MCNUM mccchannel_17_cave2_box2_yheight2;
MCNUM mccchannel_17_cave2_box2_visualize;
int mccchannel_17_cave2_box2_target_index;
MCNUM mccchannel_17_cave2_box2_target_x;
MCNUM mccchannel_17_cave2_box2_target_y;
MCNUM mccchannel_17_cave2_box2_target_z;
MCNUM mccchannel_17_cave2_box2_focus_aw;
MCNUM mccchannel_17_cave2_box2_focus_ah;
MCNUM mccchannel_17_cave2_box2_focus_xw;
MCNUM mccchannel_17_cave2_box2_focus_xh;
MCNUM mccchannel_17_cave2_box2_focus_r;
MCNUM mccchannel_17_cave2_box2_p_interact;
char mccchannel_17_cave2_box2_mask_string[16384];
char mccchannel_17_cave2_box2_mask_setting[16384];
MCNUM mccchannel_17_cave2_box2_number_of_activations;

/* Setting parameters for component 'channel_17_cave2_box3' [799]. */
char mccchannel_17_cave2_box3_material_string[16384];
MCNUM mccchannel_17_cave2_box3_priority;
MCNUM mccchannel_17_cave2_box3_xwidth;
MCNUM mccchannel_17_cave2_box3_yheight;
MCNUM mccchannel_17_cave2_box3_zdepth;
MCNUM mccchannel_17_cave2_box3_xwidth2;
MCNUM mccchannel_17_cave2_box3_yheight2;
MCNUM mccchannel_17_cave2_box3_visualize;
int mccchannel_17_cave2_box3_target_index;
MCNUM mccchannel_17_cave2_box3_target_x;
MCNUM mccchannel_17_cave2_box3_target_y;
MCNUM mccchannel_17_cave2_box3_target_z;
MCNUM mccchannel_17_cave2_box3_focus_aw;
MCNUM mccchannel_17_cave2_box3_focus_ah;
MCNUM mccchannel_17_cave2_box3_focus_xw;
MCNUM mccchannel_17_cave2_box3_focus_xh;
MCNUM mccchannel_17_cave2_box3_focus_r;
MCNUM mccchannel_17_cave2_box3_p_interact;
char mccchannel_17_cave2_box3_mask_string[16384];
char mccchannel_17_cave2_box3_mask_setting[16384];
MCNUM mccchannel_17_cave2_box3_number_of_activations;

/* Setting parameters for component 'inter_analyzer_colimator_17_blade_0' [801]. */
char mccinter_analyzer_colimator_17_blade_0_material_string[16384];
MCNUM mccinter_analyzer_colimator_17_blade_0_priority;
MCNUM mccinter_analyzer_colimator_17_blade_0_xwidth;
MCNUM mccinter_analyzer_colimator_17_blade_0_yheight;
MCNUM mccinter_analyzer_colimator_17_blade_0_zdepth;
MCNUM mccinter_analyzer_colimator_17_blade_0_xwidth2;
MCNUM mccinter_analyzer_colimator_17_blade_0_yheight2;
MCNUM mccinter_analyzer_colimator_17_blade_0_visualize;
int mccinter_analyzer_colimator_17_blade_0_target_index;
MCNUM mccinter_analyzer_colimator_17_blade_0_target_x;
MCNUM mccinter_analyzer_colimator_17_blade_0_target_y;
MCNUM mccinter_analyzer_colimator_17_blade_0_target_z;
MCNUM mccinter_analyzer_colimator_17_blade_0_focus_aw;
MCNUM mccinter_analyzer_colimator_17_blade_0_focus_ah;
MCNUM mccinter_analyzer_colimator_17_blade_0_focus_xw;
MCNUM mccinter_analyzer_colimator_17_blade_0_focus_xh;
MCNUM mccinter_analyzer_colimator_17_blade_0_focus_r;
MCNUM mccinter_analyzer_colimator_17_blade_0_p_interact;
char mccinter_analyzer_colimator_17_blade_0_mask_string[16384];
char mccinter_analyzer_colimator_17_blade_0_mask_setting[16384];
MCNUM mccinter_analyzer_colimator_17_blade_0_number_of_activations;

/* Setting parameters for component 'inter_analyzer_colimator_17_blade_1' [802]. */
char mccinter_analyzer_colimator_17_blade_1_material_string[16384];
MCNUM mccinter_analyzer_colimator_17_blade_1_priority;
MCNUM mccinter_analyzer_colimator_17_blade_1_xwidth;
MCNUM mccinter_analyzer_colimator_17_blade_1_yheight;
MCNUM mccinter_analyzer_colimator_17_blade_1_zdepth;
MCNUM mccinter_analyzer_colimator_17_blade_1_xwidth2;
MCNUM mccinter_analyzer_colimator_17_blade_1_yheight2;
MCNUM mccinter_analyzer_colimator_17_blade_1_visualize;
int mccinter_analyzer_colimator_17_blade_1_target_index;
MCNUM mccinter_analyzer_colimator_17_blade_1_target_x;
MCNUM mccinter_analyzer_colimator_17_blade_1_target_y;
MCNUM mccinter_analyzer_colimator_17_blade_1_target_z;
MCNUM mccinter_analyzer_colimator_17_blade_1_focus_aw;
MCNUM mccinter_analyzer_colimator_17_blade_1_focus_ah;
MCNUM mccinter_analyzer_colimator_17_blade_1_focus_xw;
MCNUM mccinter_analyzer_colimator_17_blade_1_focus_xh;
MCNUM mccinter_analyzer_colimator_17_blade_1_focus_r;
MCNUM mccinter_analyzer_colimator_17_blade_1_p_interact;
char mccinter_analyzer_colimator_17_blade_1_mask_string[16384];
char mccinter_analyzer_colimator_17_blade_1_mask_setting[16384];
MCNUM mccinter_analyzer_colimator_17_blade_1_number_of_activations;

/* Setting parameters for component 'inter_analyzer_colimator_17_blade_2' [803]. */
char mccinter_analyzer_colimator_17_blade_2_material_string[16384];
MCNUM mccinter_analyzer_colimator_17_blade_2_priority;
MCNUM mccinter_analyzer_colimator_17_blade_2_xwidth;
MCNUM mccinter_analyzer_colimator_17_blade_2_yheight;
MCNUM mccinter_analyzer_colimator_17_blade_2_zdepth;
MCNUM mccinter_analyzer_colimator_17_blade_2_xwidth2;
MCNUM mccinter_analyzer_colimator_17_blade_2_yheight2;
MCNUM mccinter_analyzer_colimator_17_blade_2_visualize;
int mccinter_analyzer_colimator_17_blade_2_target_index;
MCNUM mccinter_analyzer_colimator_17_blade_2_target_x;
MCNUM mccinter_analyzer_colimator_17_blade_2_target_y;
MCNUM mccinter_analyzer_colimator_17_blade_2_target_z;
MCNUM mccinter_analyzer_colimator_17_blade_2_focus_aw;
MCNUM mccinter_analyzer_colimator_17_blade_2_focus_ah;
MCNUM mccinter_analyzer_colimator_17_blade_2_focus_xw;
MCNUM mccinter_analyzer_colimator_17_blade_2_focus_xh;
MCNUM mccinter_analyzer_colimator_17_blade_2_focus_r;
MCNUM mccinter_analyzer_colimator_17_blade_2_p_interact;
char mccinter_analyzer_colimator_17_blade_2_mask_string[16384];
char mccinter_analyzer_colimator_17_blade_2_mask_setting[16384];
MCNUM mccinter_analyzer_colimator_17_blade_2_number_of_activations;

/* Setting parameters for component 'inter_analyzer_colimator_17_blade_3' [804]. */
char mccinter_analyzer_colimator_17_blade_3_material_string[16384];
MCNUM mccinter_analyzer_colimator_17_blade_3_priority;
MCNUM mccinter_analyzer_colimator_17_blade_3_xwidth;
MCNUM mccinter_analyzer_colimator_17_blade_3_yheight;
MCNUM mccinter_analyzer_colimator_17_blade_3_zdepth;
MCNUM mccinter_analyzer_colimator_17_blade_3_xwidth2;
MCNUM mccinter_analyzer_colimator_17_blade_3_yheight2;
MCNUM mccinter_analyzer_colimator_17_blade_3_visualize;
int mccinter_analyzer_colimator_17_blade_3_target_index;
MCNUM mccinter_analyzer_colimator_17_blade_3_target_x;
MCNUM mccinter_analyzer_colimator_17_blade_3_target_y;
MCNUM mccinter_analyzer_colimator_17_blade_3_target_z;
MCNUM mccinter_analyzer_colimator_17_blade_3_focus_aw;
MCNUM mccinter_analyzer_colimator_17_blade_3_focus_ah;
MCNUM mccinter_analyzer_colimator_17_blade_3_focus_xw;
MCNUM mccinter_analyzer_colimator_17_blade_3_focus_xh;
MCNUM mccinter_analyzer_colimator_17_blade_3_focus_r;
MCNUM mccinter_analyzer_colimator_17_blade_3_p_interact;
char mccinter_analyzer_colimator_17_blade_3_mask_string[16384];
char mccinter_analyzer_colimator_17_blade_3_mask_setting[16384];
MCNUM mccinter_analyzer_colimator_17_blade_3_number_of_activations;

/* Setting parameters for component 'inter_analyzer_colimator_17_blade_4' [805]. */
char mccinter_analyzer_colimator_17_blade_4_material_string[16384];
MCNUM mccinter_analyzer_colimator_17_blade_4_priority;
MCNUM mccinter_analyzer_colimator_17_blade_4_xwidth;
MCNUM mccinter_analyzer_colimator_17_blade_4_yheight;
MCNUM mccinter_analyzer_colimator_17_blade_4_zdepth;
MCNUM mccinter_analyzer_colimator_17_blade_4_xwidth2;
MCNUM mccinter_analyzer_colimator_17_blade_4_yheight2;
MCNUM mccinter_analyzer_colimator_17_blade_4_visualize;
int mccinter_analyzer_colimator_17_blade_4_target_index;
MCNUM mccinter_analyzer_colimator_17_blade_4_target_x;
MCNUM mccinter_analyzer_colimator_17_blade_4_target_y;
MCNUM mccinter_analyzer_colimator_17_blade_4_target_z;
MCNUM mccinter_analyzer_colimator_17_blade_4_focus_aw;
MCNUM mccinter_analyzer_colimator_17_blade_4_focus_ah;
MCNUM mccinter_analyzer_colimator_17_blade_4_focus_xw;
MCNUM mccinter_analyzer_colimator_17_blade_4_focus_xh;
MCNUM mccinter_analyzer_colimator_17_blade_4_focus_r;
MCNUM mccinter_analyzer_colimator_17_blade_4_p_interact;
char mccinter_analyzer_colimator_17_blade_4_mask_string[16384];
char mccinter_analyzer_colimator_17_blade_4_mask_setting[16384];
MCNUM mccinter_analyzer_colimator_17_blade_4_number_of_activations;

/* Setting parameters for component 'diffraction_detector_17_exit_volume' [806]. */
char mccdiffraction_detector_17_exit_volume_material_string[16384];
MCNUM mccdiffraction_detector_17_exit_volume_priority;
MCNUM mccdiffraction_detector_17_exit_volume_xwidth;
MCNUM mccdiffraction_detector_17_exit_volume_yheight;
MCNUM mccdiffraction_detector_17_exit_volume_zdepth;
MCNUM mccdiffraction_detector_17_exit_volume_xwidth2;
MCNUM mccdiffraction_detector_17_exit_volume_yheight2;
MCNUM mccdiffraction_detector_17_exit_volume_visualize;
int mccdiffraction_detector_17_exit_volume_target_index;
MCNUM mccdiffraction_detector_17_exit_volume_target_x;
MCNUM mccdiffraction_detector_17_exit_volume_target_y;
MCNUM mccdiffraction_detector_17_exit_volume_target_z;
MCNUM mccdiffraction_detector_17_exit_volume_focus_aw;
MCNUM mccdiffraction_detector_17_exit_volume_focus_ah;
MCNUM mccdiffraction_detector_17_exit_volume_focus_xw;
MCNUM mccdiffraction_detector_17_exit_volume_focus_xh;
MCNUM mccdiffraction_detector_17_exit_volume_focus_r;
MCNUM mccdiffraction_detector_17_exit_volume_p_interact;
char mccdiffraction_detector_17_exit_volume_mask_string[16384];
char mccdiffraction_detector_17_exit_volume_mask_setting[16384];
MCNUM mccdiffraction_detector_17_exit_volume_number_of_activations;

/* Setting parameters for component 'spec_detector_17_exit_volume' [807]. */
char mccspec_detector_17_exit_volume_material_string[16384];
MCNUM mccspec_detector_17_exit_volume_priority;
MCNUM mccspec_detector_17_exit_volume_xwidth;
MCNUM mccspec_detector_17_exit_volume_yheight;
MCNUM mccspec_detector_17_exit_volume_zdepth;
MCNUM mccspec_detector_17_exit_volume_xwidth2;
MCNUM mccspec_detector_17_exit_volume_yheight2;
MCNUM mccspec_detector_17_exit_volume_visualize;
int mccspec_detector_17_exit_volume_target_index;
MCNUM mccspec_detector_17_exit_volume_target_x;
MCNUM mccspec_detector_17_exit_volume_target_y;
MCNUM mccspec_detector_17_exit_volume_target_z;
MCNUM mccspec_detector_17_exit_volume_focus_aw;
MCNUM mccspec_detector_17_exit_volume_focus_ah;
MCNUM mccspec_detector_17_exit_volume_focus_xw;
MCNUM mccspec_detector_17_exit_volume_focus_xh;
MCNUM mccspec_detector_17_exit_volume_focus_r;
MCNUM mccspec_detector_17_exit_volume_p_interact;
char mccspec_detector_17_exit_volume_mask_string[16384];
char mccspec_detector_17_exit_volume_mask_setting[16384];
MCNUM mccspec_detector_17_exit_volume_number_of_activations;

/* Setting parameters for component 'channel_18_cave1_box1' [808]. */
char mccchannel_18_cave1_box1_material_string[16384];
MCNUM mccchannel_18_cave1_box1_priority;
MCNUM mccchannel_18_cave1_box1_xwidth;
MCNUM mccchannel_18_cave1_box1_yheight;
MCNUM mccchannel_18_cave1_box1_zdepth;
MCNUM mccchannel_18_cave1_box1_xwidth2;
MCNUM mccchannel_18_cave1_box1_yheight2;
MCNUM mccchannel_18_cave1_box1_visualize;
int mccchannel_18_cave1_box1_target_index;
MCNUM mccchannel_18_cave1_box1_target_x;
MCNUM mccchannel_18_cave1_box1_target_y;
MCNUM mccchannel_18_cave1_box1_target_z;
MCNUM mccchannel_18_cave1_box1_focus_aw;
MCNUM mccchannel_18_cave1_box1_focus_ah;
MCNUM mccchannel_18_cave1_box1_focus_xw;
MCNUM mccchannel_18_cave1_box1_focus_xh;
MCNUM mccchannel_18_cave1_box1_focus_r;
MCNUM mccchannel_18_cave1_box1_p_interact;
char mccchannel_18_cave1_box1_mask_string[16384];
char mccchannel_18_cave1_box1_mask_setting[16384];
MCNUM mccchannel_18_cave1_box1_number_of_activations;

/* Setting parameters for component 'channel_18_cave1_box2' [809]. */
char mccchannel_18_cave1_box2_material_string[16384];
MCNUM mccchannel_18_cave1_box2_priority;
MCNUM mccchannel_18_cave1_box2_xwidth;
MCNUM mccchannel_18_cave1_box2_yheight;
MCNUM mccchannel_18_cave1_box2_zdepth;
MCNUM mccchannel_18_cave1_box2_xwidth2;
MCNUM mccchannel_18_cave1_box2_yheight2;
MCNUM mccchannel_18_cave1_box2_visualize;
int mccchannel_18_cave1_box2_target_index;
MCNUM mccchannel_18_cave1_box2_target_x;
MCNUM mccchannel_18_cave1_box2_target_y;
MCNUM mccchannel_18_cave1_box2_target_z;
MCNUM mccchannel_18_cave1_box2_focus_aw;
MCNUM mccchannel_18_cave1_box2_focus_ah;
MCNUM mccchannel_18_cave1_box2_focus_xw;
MCNUM mccchannel_18_cave1_box2_focus_xh;
MCNUM mccchannel_18_cave1_box2_focus_r;
MCNUM mccchannel_18_cave1_box2_p_interact;
char mccchannel_18_cave1_box2_mask_string[16384];
char mccchannel_18_cave1_box2_mask_setting[16384];
MCNUM mccchannel_18_cave1_box2_number_of_activations;

/* Setting parameters for component 'channel_18_cave1_box3' [810]. */
char mccchannel_18_cave1_box3_material_string[16384];
MCNUM mccchannel_18_cave1_box3_priority;
MCNUM mccchannel_18_cave1_box3_xwidth;
MCNUM mccchannel_18_cave1_box3_yheight;
MCNUM mccchannel_18_cave1_box3_zdepth;
MCNUM mccchannel_18_cave1_box3_xwidth2;
MCNUM mccchannel_18_cave1_box3_yheight2;
MCNUM mccchannel_18_cave1_box3_visualize;
int mccchannel_18_cave1_box3_target_index;
MCNUM mccchannel_18_cave1_box3_target_x;
MCNUM mccchannel_18_cave1_box3_target_y;
MCNUM mccchannel_18_cave1_box3_target_z;
MCNUM mccchannel_18_cave1_box3_focus_aw;
MCNUM mccchannel_18_cave1_box3_focus_ah;
MCNUM mccchannel_18_cave1_box3_focus_xw;
MCNUM mccchannel_18_cave1_box3_focus_xh;
MCNUM mccchannel_18_cave1_box3_focus_r;
MCNUM mccchannel_18_cave1_box3_p_interact;
char mccchannel_18_cave1_box3_mask_string[16384];
char mccchannel_18_cave1_box3_mask_setting[16384];
MCNUM mccchannel_18_cave1_box3_number_of_activations;

/* Setting parameters for component 'channel_18_cave1_cyl1' [811]. */
char mccchannel_18_cave1_cyl1_material_string[16384];
MCNUM mccchannel_18_cave1_cyl1_priority;
MCNUM mccchannel_18_cave1_cyl1_radius;
MCNUM mccchannel_18_cave1_cyl1_yheight;
MCNUM mccchannel_18_cave1_cyl1_visualize;
int mccchannel_18_cave1_cyl1_target_index;
MCNUM mccchannel_18_cave1_cyl1_target_x;
MCNUM mccchannel_18_cave1_cyl1_target_y;
MCNUM mccchannel_18_cave1_cyl1_target_z;
MCNUM mccchannel_18_cave1_cyl1_focus_aw;
MCNUM mccchannel_18_cave1_cyl1_focus_ah;
MCNUM mccchannel_18_cave1_cyl1_focus_xw;
MCNUM mccchannel_18_cave1_cyl1_focus_xh;
MCNUM mccchannel_18_cave1_cyl1_focus_r;
MCNUM mccchannel_18_cave1_cyl1_p_interact;
char mccchannel_18_cave1_cyl1_mask_string[16384];
char mccchannel_18_cave1_cyl1_mask_setting[16384];
MCNUM mccchannel_18_cave1_cyl1_number_of_activations;

/* Setting parameters for component 'channel_18_analyzer_1_array_crystal_array_0' [814]. */
char mccchannel_18_analyzer_1_array_crystal_array_0_material_string[16384];
MCNUM mccchannel_18_analyzer_1_array_crystal_array_0_priority;
MCNUM mccchannel_18_analyzer_1_array_crystal_array_0_xwidth;
MCNUM mccchannel_18_analyzer_1_array_crystal_array_0_yheight;
MCNUM mccchannel_18_analyzer_1_array_crystal_array_0_zdepth;
MCNUM mccchannel_18_analyzer_1_array_crystal_array_0_xwidth2;
MCNUM mccchannel_18_analyzer_1_array_crystal_array_0_yheight2;
MCNUM mccchannel_18_analyzer_1_array_crystal_array_0_visualize;
int mccchannel_18_analyzer_1_array_crystal_array_0_target_index;
MCNUM mccchannel_18_analyzer_1_array_crystal_array_0_target_x;
MCNUM mccchannel_18_analyzer_1_array_crystal_array_0_target_y;
MCNUM mccchannel_18_analyzer_1_array_crystal_array_0_target_z;
MCNUM mccchannel_18_analyzer_1_array_crystal_array_0_focus_aw;
MCNUM mccchannel_18_analyzer_1_array_crystal_array_0_focus_ah;
MCNUM mccchannel_18_analyzer_1_array_crystal_array_0_focus_xw;
MCNUM mccchannel_18_analyzer_1_array_crystal_array_0_focus_xh;
MCNUM mccchannel_18_analyzer_1_array_crystal_array_0_focus_r;
MCNUM mccchannel_18_analyzer_1_array_crystal_array_0_p_interact;
char mccchannel_18_analyzer_1_array_crystal_array_0_mask_string[16384];
char mccchannel_18_analyzer_1_array_crystal_array_0_mask_setting[16384];
MCNUM mccchannel_18_analyzer_1_array_crystal_array_0_number_of_activations;

/* Setting parameters for component 'channel_18_analyzer_1_array_crystal_array_1' [815]. */
char mccchannel_18_analyzer_1_array_crystal_array_1_material_string[16384];
MCNUM mccchannel_18_analyzer_1_array_crystal_array_1_priority;
MCNUM mccchannel_18_analyzer_1_array_crystal_array_1_xwidth;
MCNUM mccchannel_18_analyzer_1_array_crystal_array_1_yheight;
MCNUM mccchannel_18_analyzer_1_array_crystal_array_1_zdepth;
MCNUM mccchannel_18_analyzer_1_array_crystal_array_1_xwidth2;
MCNUM mccchannel_18_analyzer_1_array_crystal_array_1_yheight2;
MCNUM mccchannel_18_analyzer_1_array_crystal_array_1_visualize;
int mccchannel_18_analyzer_1_array_crystal_array_1_target_index;
MCNUM mccchannel_18_analyzer_1_array_crystal_array_1_target_x;
MCNUM mccchannel_18_analyzer_1_array_crystal_array_1_target_y;
MCNUM mccchannel_18_analyzer_1_array_crystal_array_1_target_z;
MCNUM mccchannel_18_analyzer_1_array_crystal_array_1_focus_aw;
MCNUM mccchannel_18_analyzer_1_array_crystal_array_1_focus_ah;
MCNUM mccchannel_18_analyzer_1_array_crystal_array_1_focus_xw;
MCNUM mccchannel_18_analyzer_1_array_crystal_array_1_focus_xh;
MCNUM mccchannel_18_analyzer_1_array_crystal_array_1_focus_r;
MCNUM mccchannel_18_analyzer_1_array_crystal_array_1_p_interact;
char mccchannel_18_analyzer_1_array_crystal_array_1_mask_string[16384];
char mccchannel_18_analyzer_1_array_crystal_array_1_mask_setting[16384];
MCNUM mccchannel_18_analyzer_1_array_crystal_array_1_number_of_activations;

/* Setting parameters for component 'channel_18_analyzer_1_array_crystal_array_2' [816]. */
char mccchannel_18_analyzer_1_array_crystal_array_2_material_string[16384];
MCNUM mccchannel_18_analyzer_1_array_crystal_array_2_priority;
MCNUM mccchannel_18_analyzer_1_array_crystal_array_2_xwidth;
MCNUM mccchannel_18_analyzer_1_array_crystal_array_2_yheight;
MCNUM mccchannel_18_analyzer_1_array_crystal_array_2_zdepth;
MCNUM mccchannel_18_analyzer_1_array_crystal_array_2_xwidth2;
MCNUM mccchannel_18_analyzer_1_array_crystal_array_2_yheight2;
MCNUM mccchannel_18_analyzer_1_array_crystal_array_2_visualize;
int mccchannel_18_analyzer_1_array_crystal_array_2_target_index;
MCNUM mccchannel_18_analyzer_1_array_crystal_array_2_target_x;
MCNUM mccchannel_18_analyzer_1_array_crystal_array_2_target_y;
MCNUM mccchannel_18_analyzer_1_array_crystal_array_2_target_z;
MCNUM mccchannel_18_analyzer_1_array_crystal_array_2_focus_aw;
MCNUM mccchannel_18_analyzer_1_array_crystal_array_2_focus_ah;
MCNUM mccchannel_18_analyzer_1_array_crystal_array_2_focus_xw;
MCNUM mccchannel_18_analyzer_1_array_crystal_array_2_focus_xh;
MCNUM mccchannel_18_analyzer_1_array_crystal_array_2_focus_r;
MCNUM mccchannel_18_analyzer_1_array_crystal_array_2_p_interact;
char mccchannel_18_analyzer_1_array_crystal_array_2_mask_string[16384];
char mccchannel_18_analyzer_1_array_crystal_array_2_mask_setting[16384];
MCNUM mccchannel_18_analyzer_1_array_crystal_array_2_number_of_activations;

/* Setting parameters for component 'channel_18_analyzer_1_array_crystal_array_3' [817]. */
char mccchannel_18_analyzer_1_array_crystal_array_3_material_string[16384];
MCNUM mccchannel_18_analyzer_1_array_crystal_array_3_priority;
MCNUM mccchannel_18_analyzer_1_array_crystal_array_3_xwidth;
MCNUM mccchannel_18_analyzer_1_array_crystal_array_3_yheight;
MCNUM mccchannel_18_analyzer_1_array_crystal_array_3_zdepth;
MCNUM mccchannel_18_analyzer_1_array_crystal_array_3_xwidth2;
MCNUM mccchannel_18_analyzer_1_array_crystal_array_3_yheight2;
MCNUM mccchannel_18_analyzer_1_array_crystal_array_3_visualize;
int mccchannel_18_analyzer_1_array_crystal_array_3_target_index;
MCNUM mccchannel_18_analyzer_1_array_crystal_array_3_target_x;
MCNUM mccchannel_18_analyzer_1_array_crystal_array_3_target_y;
MCNUM mccchannel_18_analyzer_1_array_crystal_array_3_target_z;
MCNUM mccchannel_18_analyzer_1_array_crystal_array_3_focus_aw;
MCNUM mccchannel_18_analyzer_1_array_crystal_array_3_focus_ah;
MCNUM mccchannel_18_analyzer_1_array_crystal_array_3_focus_xw;
MCNUM mccchannel_18_analyzer_1_array_crystal_array_3_focus_xh;
MCNUM mccchannel_18_analyzer_1_array_crystal_array_3_focus_r;
MCNUM mccchannel_18_analyzer_1_array_crystal_array_3_p_interact;
char mccchannel_18_analyzer_1_array_crystal_array_3_mask_string[16384];
char mccchannel_18_analyzer_1_array_crystal_array_3_mask_setting[16384];
MCNUM mccchannel_18_analyzer_1_array_crystal_array_3_number_of_activations;

/* Setting parameters for component 'channel_18_analyzer_1_array_crystal_array_4' [818]. */
char mccchannel_18_analyzer_1_array_crystal_array_4_material_string[16384];
MCNUM mccchannel_18_analyzer_1_array_crystal_array_4_priority;
MCNUM mccchannel_18_analyzer_1_array_crystal_array_4_xwidth;
MCNUM mccchannel_18_analyzer_1_array_crystal_array_4_yheight;
MCNUM mccchannel_18_analyzer_1_array_crystal_array_4_zdepth;
MCNUM mccchannel_18_analyzer_1_array_crystal_array_4_xwidth2;
MCNUM mccchannel_18_analyzer_1_array_crystal_array_4_yheight2;
MCNUM mccchannel_18_analyzer_1_array_crystal_array_4_visualize;
int mccchannel_18_analyzer_1_array_crystal_array_4_target_index;
MCNUM mccchannel_18_analyzer_1_array_crystal_array_4_target_x;
MCNUM mccchannel_18_analyzer_1_array_crystal_array_4_target_y;
MCNUM mccchannel_18_analyzer_1_array_crystal_array_4_target_z;
MCNUM mccchannel_18_analyzer_1_array_crystal_array_4_focus_aw;
MCNUM mccchannel_18_analyzer_1_array_crystal_array_4_focus_ah;
MCNUM mccchannel_18_analyzer_1_array_crystal_array_4_focus_xw;
MCNUM mccchannel_18_analyzer_1_array_crystal_array_4_focus_xh;
MCNUM mccchannel_18_analyzer_1_array_crystal_array_4_focus_r;
MCNUM mccchannel_18_analyzer_1_array_crystal_array_4_p_interact;
char mccchannel_18_analyzer_1_array_crystal_array_4_mask_string[16384];
char mccchannel_18_analyzer_1_array_crystal_array_4_mask_setting[16384];
MCNUM mccchannel_18_analyzer_1_array_crystal_array_4_number_of_activations;

/* Setting parameters for component 'channel_18_analyzer_1_array_crystal_array_5' [819]. */
char mccchannel_18_analyzer_1_array_crystal_array_5_material_string[16384];
MCNUM mccchannel_18_analyzer_1_array_crystal_array_5_priority;
MCNUM mccchannel_18_analyzer_1_array_crystal_array_5_xwidth;
MCNUM mccchannel_18_analyzer_1_array_crystal_array_5_yheight;
MCNUM mccchannel_18_analyzer_1_array_crystal_array_5_zdepth;
MCNUM mccchannel_18_analyzer_1_array_crystal_array_5_xwidth2;
MCNUM mccchannel_18_analyzer_1_array_crystal_array_5_yheight2;
MCNUM mccchannel_18_analyzer_1_array_crystal_array_5_visualize;
int mccchannel_18_analyzer_1_array_crystal_array_5_target_index;
MCNUM mccchannel_18_analyzer_1_array_crystal_array_5_target_x;
MCNUM mccchannel_18_analyzer_1_array_crystal_array_5_target_y;
MCNUM mccchannel_18_analyzer_1_array_crystal_array_5_target_z;
MCNUM mccchannel_18_analyzer_1_array_crystal_array_5_focus_aw;
MCNUM mccchannel_18_analyzer_1_array_crystal_array_5_focus_ah;
MCNUM mccchannel_18_analyzer_1_array_crystal_array_5_focus_xw;
MCNUM mccchannel_18_analyzer_1_array_crystal_array_5_focus_xh;
MCNUM mccchannel_18_analyzer_1_array_crystal_array_5_focus_r;
MCNUM mccchannel_18_analyzer_1_array_crystal_array_5_p_interact;
char mccchannel_18_analyzer_1_array_crystal_array_5_mask_string[16384];
char mccchannel_18_analyzer_1_array_crystal_array_5_mask_setting[16384];
MCNUM mccchannel_18_analyzer_1_array_crystal_array_5_number_of_activations;

/* Setting parameters for component 'channel_18_analyzer_1_array_crystal_array_6' [820]. */
char mccchannel_18_analyzer_1_array_crystal_array_6_material_string[16384];
MCNUM mccchannel_18_analyzer_1_array_crystal_array_6_priority;
MCNUM mccchannel_18_analyzer_1_array_crystal_array_6_xwidth;
MCNUM mccchannel_18_analyzer_1_array_crystal_array_6_yheight;
MCNUM mccchannel_18_analyzer_1_array_crystal_array_6_zdepth;
MCNUM mccchannel_18_analyzer_1_array_crystal_array_6_xwidth2;
MCNUM mccchannel_18_analyzer_1_array_crystal_array_6_yheight2;
MCNUM mccchannel_18_analyzer_1_array_crystal_array_6_visualize;
int mccchannel_18_analyzer_1_array_crystal_array_6_target_index;
MCNUM mccchannel_18_analyzer_1_array_crystal_array_6_target_x;
MCNUM mccchannel_18_analyzer_1_array_crystal_array_6_target_y;
MCNUM mccchannel_18_analyzer_1_array_crystal_array_6_target_z;
MCNUM mccchannel_18_analyzer_1_array_crystal_array_6_focus_aw;
MCNUM mccchannel_18_analyzer_1_array_crystal_array_6_focus_ah;
MCNUM mccchannel_18_analyzer_1_array_crystal_array_6_focus_xw;
MCNUM mccchannel_18_analyzer_1_array_crystal_array_6_focus_xh;
MCNUM mccchannel_18_analyzer_1_array_crystal_array_6_focus_r;
MCNUM mccchannel_18_analyzer_1_array_crystal_array_6_p_interact;
char mccchannel_18_analyzer_1_array_crystal_array_6_mask_string[16384];
char mccchannel_18_analyzer_1_array_crystal_array_6_mask_setting[16384];
MCNUM mccchannel_18_analyzer_1_array_crystal_array_6_number_of_activations;

/* Setting parameters for component 'channel_18_analyzer_1_array_crystal_array_7' [821]. */
char mccchannel_18_analyzer_1_array_crystal_array_7_material_string[16384];
MCNUM mccchannel_18_analyzer_1_array_crystal_array_7_priority;
MCNUM mccchannel_18_analyzer_1_array_crystal_array_7_xwidth;
MCNUM mccchannel_18_analyzer_1_array_crystal_array_7_yheight;
MCNUM mccchannel_18_analyzer_1_array_crystal_array_7_zdepth;
MCNUM mccchannel_18_analyzer_1_array_crystal_array_7_xwidth2;
MCNUM mccchannel_18_analyzer_1_array_crystal_array_7_yheight2;
MCNUM mccchannel_18_analyzer_1_array_crystal_array_7_visualize;
int mccchannel_18_analyzer_1_array_crystal_array_7_target_index;
MCNUM mccchannel_18_analyzer_1_array_crystal_array_7_target_x;
MCNUM mccchannel_18_analyzer_1_array_crystal_array_7_target_y;
MCNUM mccchannel_18_analyzer_1_array_crystal_array_7_target_z;
MCNUM mccchannel_18_analyzer_1_array_crystal_array_7_focus_aw;
MCNUM mccchannel_18_analyzer_1_array_crystal_array_7_focus_ah;
MCNUM mccchannel_18_analyzer_1_array_crystal_array_7_focus_xw;
MCNUM mccchannel_18_analyzer_1_array_crystal_array_7_focus_xh;
MCNUM mccchannel_18_analyzer_1_array_crystal_array_7_focus_r;
MCNUM mccchannel_18_analyzer_1_array_crystal_array_7_p_interact;
char mccchannel_18_analyzer_1_array_crystal_array_7_mask_string[16384];
char mccchannel_18_analyzer_1_array_crystal_array_7_mask_setting[16384];
MCNUM mccchannel_18_analyzer_1_array_crystal_array_7_number_of_activations;

/* Setting parameters for component 'channel_18_analyzer_1_array_crystal_array_8' [822]. */
char mccchannel_18_analyzer_1_array_crystal_array_8_material_string[16384];
MCNUM mccchannel_18_analyzer_1_array_crystal_array_8_priority;
MCNUM mccchannel_18_analyzer_1_array_crystal_array_8_xwidth;
MCNUM mccchannel_18_analyzer_1_array_crystal_array_8_yheight;
MCNUM mccchannel_18_analyzer_1_array_crystal_array_8_zdepth;
MCNUM mccchannel_18_analyzer_1_array_crystal_array_8_xwidth2;
MCNUM mccchannel_18_analyzer_1_array_crystal_array_8_yheight2;
MCNUM mccchannel_18_analyzer_1_array_crystal_array_8_visualize;
int mccchannel_18_analyzer_1_array_crystal_array_8_target_index;
MCNUM mccchannel_18_analyzer_1_array_crystal_array_8_target_x;
MCNUM mccchannel_18_analyzer_1_array_crystal_array_8_target_y;
MCNUM mccchannel_18_analyzer_1_array_crystal_array_8_target_z;
MCNUM mccchannel_18_analyzer_1_array_crystal_array_8_focus_aw;
MCNUM mccchannel_18_analyzer_1_array_crystal_array_8_focus_ah;
MCNUM mccchannel_18_analyzer_1_array_crystal_array_8_focus_xw;
MCNUM mccchannel_18_analyzer_1_array_crystal_array_8_focus_xh;
MCNUM mccchannel_18_analyzer_1_array_crystal_array_8_focus_r;
MCNUM mccchannel_18_analyzer_1_array_crystal_array_8_p_interact;
char mccchannel_18_analyzer_1_array_crystal_array_8_mask_string[16384];
char mccchannel_18_analyzer_1_array_crystal_array_8_mask_setting[16384];
MCNUM mccchannel_18_analyzer_1_array_crystal_array_8_number_of_activations;

/* Setting parameters for component 'channel_18_analyzer_2_array_crystal_array_0' [825]. */
char mccchannel_18_analyzer_2_array_crystal_array_0_material_string[16384];
MCNUM mccchannel_18_analyzer_2_array_crystal_array_0_priority;
MCNUM mccchannel_18_analyzer_2_array_crystal_array_0_xwidth;
MCNUM mccchannel_18_analyzer_2_array_crystal_array_0_yheight;
MCNUM mccchannel_18_analyzer_2_array_crystal_array_0_zdepth;
MCNUM mccchannel_18_analyzer_2_array_crystal_array_0_xwidth2;
MCNUM mccchannel_18_analyzer_2_array_crystal_array_0_yheight2;
MCNUM mccchannel_18_analyzer_2_array_crystal_array_0_visualize;
int mccchannel_18_analyzer_2_array_crystal_array_0_target_index;
MCNUM mccchannel_18_analyzer_2_array_crystal_array_0_target_x;
MCNUM mccchannel_18_analyzer_2_array_crystal_array_0_target_y;
MCNUM mccchannel_18_analyzer_2_array_crystal_array_0_target_z;
MCNUM mccchannel_18_analyzer_2_array_crystal_array_0_focus_aw;
MCNUM mccchannel_18_analyzer_2_array_crystal_array_0_focus_ah;
MCNUM mccchannel_18_analyzer_2_array_crystal_array_0_focus_xw;
MCNUM mccchannel_18_analyzer_2_array_crystal_array_0_focus_xh;
MCNUM mccchannel_18_analyzer_2_array_crystal_array_0_focus_r;
MCNUM mccchannel_18_analyzer_2_array_crystal_array_0_p_interact;
char mccchannel_18_analyzer_2_array_crystal_array_0_mask_string[16384];
char mccchannel_18_analyzer_2_array_crystal_array_0_mask_setting[16384];
MCNUM mccchannel_18_analyzer_2_array_crystal_array_0_number_of_activations;

/* Setting parameters for component 'channel_18_analyzer_2_array_crystal_array_1' [826]. */
char mccchannel_18_analyzer_2_array_crystal_array_1_material_string[16384];
MCNUM mccchannel_18_analyzer_2_array_crystal_array_1_priority;
MCNUM mccchannel_18_analyzer_2_array_crystal_array_1_xwidth;
MCNUM mccchannel_18_analyzer_2_array_crystal_array_1_yheight;
MCNUM mccchannel_18_analyzer_2_array_crystal_array_1_zdepth;
MCNUM mccchannel_18_analyzer_2_array_crystal_array_1_xwidth2;
MCNUM mccchannel_18_analyzer_2_array_crystal_array_1_yheight2;
MCNUM mccchannel_18_analyzer_2_array_crystal_array_1_visualize;
int mccchannel_18_analyzer_2_array_crystal_array_1_target_index;
MCNUM mccchannel_18_analyzer_2_array_crystal_array_1_target_x;
MCNUM mccchannel_18_analyzer_2_array_crystal_array_1_target_y;
MCNUM mccchannel_18_analyzer_2_array_crystal_array_1_target_z;
MCNUM mccchannel_18_analyzer_2_array_crystal_array_1_focus_aw;
MCNUM mccchannel_18_analyzer_2_array_crystal_array_1_focus_ah;
MCNUM mccchannel_18_analyzer_2_array_crystal_array_1_focus_xw;
MCNUM mccchannel_18_analyzer_2_array_crystal_array_1_focus_xh;
MCNUM mccchannel_18_analyzer_2_array_crystal_array_1_focus_r;
MCNUM mccchannel_18_analyzer_2_array_crystal_array_1_p_interact;
char mccchannel_18_analyzer_2_array_crystal_array_1_mask_string[16384];
char mccchannel_18_analyzer_2_array_crystal_array_1_mask_setting[16384];
MCNUM mccchannel_18_analyzer_2_array_crystal_array_1_number_of_activations;

/* Setting parameters for component 'channel_18_analyzer_2_array_crystal_array_2' [827]. */
char mccchannel_18_analyzer_2_array_crystal_array_2_material_string[16384];
MCNUM mccchannel_18_analyzer_2_array_crystal_array_2_priority;
MCNUM mccchannel_18_analyzer_2_array_crystal_array_2_xwidth;
MCNUM mccchannel_18_analyzer_2_array_crystal_array_2_yheight;
MCNUM mccchannel_18_analyzer_2_array_crystal_array_2_zdepth;
MCNUM mccchannel_18_analyzer_2_array_crystal_array_2_xwidth2;
MCNUM mccchannel_18_analyzer_2_array_crystal_array_2_yheight2;
MCNUM mccchannel_18_analyzer_2_array_crystal_array_2_visualize;
int mccchannel_18_analyzer_2_array_crystal_array_2_target_index;
MCNUM mccchannel_18_analyzer_2_array_crystal_array_2_target_x;
MCNUM mccchannel_18_analyzer_2_array_crystal_array_2_target_y;
MCNUM mccchannel_18_analyzer_2_array_crystal_array_2_target_z;
MCNUM mccchannel_18_analyzer_2_array_crystal_array_2_focus_aw;
MCNUM mccchannel_18_analyzer_2_array_crystal_array_2_focus_ah;
MCNUM mccchannel_18_analyzer_2_array_crystal_array_2_focus_xw;
MCNUM mccchannel_18_analyzer_2_array_crystal_array_2_focus_xh;
MCNUM mccchannel_18_analyzer_2_array_crystal_array_2_focus_r;
MCNUM mccchannel_18_analyzer_2_array_crystal_array_2_p_interact;
char mccchannel_18_analyzer_2_array_crystal_array_2_mask_string[16384];
char mccchannel_18_analyzer_2_array_crystal_array_2_mask_setting[16384];
MCNUM mccchannel_18_analyzer_2_array_crystal_array_2_number_of_activations;

/* Setting parameters for component 'channel_18_analyzer_2_array_crystal_array_3' [828]. */
char mccchannel_18_analyzer_2_array_crystal_array_3_material_string[16384];
MCNUM mccchannel_18_analyzer_2_array_crystal_array_3_priority;
MCNUM mccchannel_18_analyzer_2_array_crystal_array_3_xwidth;
MCNUM mccchannel_18_analyzer_2_array_crystal_array_3_yheight;
MCNUM mccchannel_18_analyzer_2_array_crystal_array_3_zdepth;
MCNUM mccchannel_18_analyzer_2_array_crystal_array_3_xwidth2;
MCNUM mccchannel_18_analyzer_2_array_crystal_array_3_yheight2;
MCNUM mccchannel_18_analyzer_2_array_crystal_array_3_visualize;
int mccchannel_18_analyzer_2_array_crystal_array_3_target_index;
MCNUM mccchannel_18_analyzer_2_array_crystal_array_3_target_x;
MCNUM mccchannel_18_analyzer_2_array_crystal_array_3_target_y;
MCNUM mccchannel_18_analyzer_2_array_crystal_array_3_target_z;
MCNUM mccchannel_18_analyzer_2_array_crystal_array_3_focus_aw;
MCNUM mccchannel_18_analyzer_2_array_crystal_array_3_focus_ah;
MCNUM mccchannel_18_analyzer_2_array_crystal_array_3_focus_xw;
MCNUM mccchannel_18_analyzer_2_array_crystal_array_3_focus_xh;
MCNUM mccchannel_18_analyzer_2_array_crystal_array_3_focus_r;
MCNUM mccchannel_18_analyzer_2_array_crystal_array_3_p_interact;
char mccchannel_18_analyzer_2_array_crystal_array_3_mask_string[16384];
char mccchannel_18_analyzer_2_array_crystal_array_3_mask_setting[16384];
MCNUM mccchannel_18_analyzer_2_array_crystal_array_3_number_of_activations;

/* Setting parameters for component 'channel_18_analyzer_2_array_crystal_array_4' [829]. */
char mccchannel_18_analyzer_2_array_crystal_array_4_material_string[16384];
MCNUM mccchannel_18_analyzer_2_array_crystal_array_4_priority;
MCNUM mccchannel_18_analyzer_2_array_crystal_array_4_xwidth;
MCNUM mccchannel_18_analyzer_2_array_crystal_array_4_yheight;
MCNUM mccchannel_18_analyzer_2_array_crystal_array_4_zdepth;
MCNUM mccchannel_18_analyzer_2_array_crystal_array_4_xwidth2;
MCNUM mccchannel_18_analyzer_2_array_crystal_array_4_yheight2;
MCNUM mccchannel_18_analyzer_2_array_crystal_array_4_visualize;
int mccchannel_18_analyzer_2_array_crystal_array_4_target_index;
MCNUM mccchannel_18_analyzer_2_array_crystal_array_4_target_x;
MCNUM mccchannel_18_analyzer_2_array_crystal_array_4_target_y;
MCNUM mccchannel_18_analyzer_2_array_crystal_array_4_target_z;
MCNUM mccchannel_18_analyzer_2_array_crystal_array_4_focus_aw;
MCNUM mccchannel_18_analyzer_2_array_crystal_array_4_focus_ah;
MCNUM mccchannel_18_analyzer_2_array_crystal_array_4_focus_xw;
MCNUM mccchannel_18_analyzer_2_array_crystal_array_4_focus_xh;
MCNUM mccchannel_18_analyzer_2_array_crystal_array_4_focus_r;
MCNUM mccchannel_18_analyzer_2_array_crystal_array_4_p_interact;
char mccchannel_18_analyzer_2_array_crystal_array_4_mask_string[16384];
char mccchannel_18_analyzer_2_array_crystal_array_4_mask_setting[16384];
MCNUM mccchannel_18_analyzer_2_array_crystal_array_4_number_of_activations;

/* Setting parameters for component 'channel_18_analyzer_2_array_crystal_array_5' [830]. */
char mccchannel_18_analyzer_2_array_crystal_array_5_material_string[16384];
MCNUM mccchannel_18_analyzer_2_array_crystal_array_5_priority;
MCNUM mccchannel_18_analyzer_2_array_crystal_array_5_xwidth;
MCNUM mccchannel_18_analyzer_2_array_crystal_array_5_yheight;
MCNUM mccchannel_18_analyzer_2_array_crystal_array_5_zdepth;
MCNUM mccchannel_18_analyzer_2_array_crystal_array_5_xwidth2;
MCNUM mccchannel_18_analyzer_2_array_crystal_array_5_yheight2;
MCNUM mccchannel_18_analyzer_2_array_crystal_array_5_visualize;
int mccchannel_18_analyzer_2_array_crystal_array_5_target_index;
MCNUM mccchannel_18_analyzer_2_array_crystal_array_5_target_x;
MCNUM mccchannel_18_analyzer_2_array_crystal_array_5_target_y;
MCNUM mccchannel_18_analyzer_2_array_crystal_array_5_target_z;
MCNUM mccchannel_18_analyzer_2_array_crystal_array_5_focus_aw;
MCNUM mccchannel_18_analyzer_2_array_crystal_array_5_focus_ah;
MCNUM mccchannel_18_analyzer_2_array_crystal_array_5_focus_xw;
MCNUM mccchannel_18_analyzer_2_array_crystal_array_5_focus_xh;
MCNUM mccchannel_18_analyzer_2_array_crystal_array_5_focus_r;
MCNUM mccchannel_18_analyzer_2_array_crystal_array_5_p_interact;
char mccchannel_18_analyzer_2_array_crystal_array_5_mask_string[16384];
char mccchannel_18_analyzer_2_array_crystal_array_5_mask_setting[16384];
MCNUM mccchannel_18_analyzer_2_array_crystal_array_5_number_of_activations;

/* Setting parameters for component 'channel_18_analyzer_2_array_crystal_array_6' [831]. */
char mccchannel_18_analyzer_2_array_crystal_array_6_material_string[16384];
MCNUM mccchannel_18_analyzer_2_array_crystal_array_6_priority;
MCNUM mccchannel_18_analyzer_2_array_crystal_array_6_xwidth;
MCNUM mccchannel_18_analyzer_2_array_crystal_array_6_yheight;
MCNUM mccchannel_18_analyzer_2_array_crystal_array_6_zdepth;
MCNUM mccchannel_18_analyzer_2_array_crystal_array_6_xwidth2;
MCNUM mccchannel_18_analyzer_2_array_crystal_array_6_yheight2;
MCNUM mccchannel_18_analyzer_2_array_crystal_array_6_visualize;
int mccchannel_18_analyzer_2_array_crystal_array_6_target_index;
MCNUM mccchannel_18_analyzer_2_array_crystal_array_6_target_x;
MCNUM mccchannel_18_analyzer_2_array_crystal_array_6_target_y;
MCNUM mccchannel_18_analyzer_2_array_crystal_array_6_target_z;
MCNUM mccchannel_18_analyzer_2_array_crystal_array_6_focus_aw;
MCNUM mccchannel_18_analyzer_2_array_crystal_array_6_focus_ah;
MCNUM mccchannel_18_analyzer_2_array_crystal_array_6_focus_xw;
MCNUM mccchannel_18_analyzer_2_array_crystal_array_6_focus_xh;
MCNUM mccchannel_18_analyzer_2_array_crystal_array_6_focus_r;
MCNUM mccchannel_18_analyzer_2_array_crystal_array_6_p_interact;
char mccchannel_18_analyzer_2_array_crystal_array_6_mask_string[16384];
char mccchannel_18_analyzer_2_array_crystal_array_6_mask_setting[16384];
MCNUM mccchannel_18_analyzer_2_array_crystal_array_6_number_of_activations;

/* Setting parameters for component 'channel_18_analyzer_2_array_crystal_array_7' [832]. */
char mccchannel_18_analyzer_2_array_crystal_array_7_material_string[16384];
MCNUM mccchannel_18_analyzer_2_array_crystal_array_7_priority;
MCNUM mccchannel_18_analyzer_2_array_crystal_array_7_xwidth;
MCNUM mccchannel_18_analyzer_2_array_crystal_array_7_yheight;
MCNUM mccchannel_18_analyzer_2_array_crystal_array_7_zdepth;
MCNUM mccchannel_18_analyzer_2_array_crystal_array_7_xwidth2;
MCNUM mccchannel_18_analyzer_2_array_crystal_array_7_yheight2;
MCNUM mccchannel_18_analyzer_2_array_crystal_array_7_visualize;
int mccchannel_18_analyzer_2_array_crystal_array_7_target_index;
MCNUM mccchannel_18_analyzer_2_array_crystal_array_7_target_x;
MCNUM mccchannel_18_analyzer_2_array_crystal_array_7_target_y;
MCNUM mccchannel_18_analyzer_2_array_crystal_array_7_target_z;
MCNUM mccchannel_18_analyzer_2_array_crystal_array_7_focus_aw;
MCNUM mccchannel_18_analyzer_2_array_crystal_array_7_focus_ah;
MCNUM mccchannel_18_analyzer_2_array_crystal_array_7_focus_xw;
MCNUM mccchannel_18_analyzer_2_array_crystal_array_7_focus_xh;
MCNUM mccchannel_18_analyzer_2_array_crystal_array_7_focus_r;
MCNUM mccchannel_18_analyzer_2_array_crystal_array_7_p_interact;
char mccchannel_18_analyzer_2_array_crystal_array_7_mask_string[16384];
char mccchannel_18_analyzer_2_array_crystal_array_7_mask_setting[16384];
MCNUM mccchannel_18_analyzer_2_array_crystal_array_7_number_of_activations;

/* Setting parameters for component 'channel_18_analyzer_2_array_crystal_array_8' [833]. */
char mccchannel_18_analyzer_2_array_crystal_array_8_material_string[16384];
MCNUM mccchannel_18_analyzer_2_array_crystal_array_8_priority;
MCNUM mccchannel_18_analyzer_2_array_crystal_array_8_xwidth;
MCNUM mccchannel_18_analyzer_2_array_crystal_array_8_yheight;
MCNUM mccchannel_18_analyzer_2_array_crystal_array_8_zdepth;
MCNUM mccchannel_18_analyzer_2_array_crystal_array_8_xwidth2;
MCNUM mccchannel_18_analyzer_2_array_crystal_array_8_yheight2;
MCNUM mccchannel_18_analyzer_2_array_crystal_array_8_visualize;
int mccchannel_18_analyzer_2_array_crystal_array_8_target_index;
MCNUM mccchannel_18_analyzer_2_array_crystal_array_8_target_x;
MCNUM mccchannel_18_analyzer_2_array_crystal_array_8_target_y;
MCNUM mccchannel_18_analyzer_2_array_crystal_array_8_target_z;
MCNUM mccchannel_18_analyzer_2_array_crystal_array_8_focus_aw;
MCNUM mccchannel_18_analyzer_2_array_crystal_array_8_focus_ah;
MCNUM mccchannel_18_analyzer_2_array_crystal_array_8_focus_xw;
MCNUM mccchannel_18_analyzer_2_array_crystal_array_8_focus_xh;
MCNUM mccchannel_18_analyzer_2_array_crystal_array_8_focus_r;
MCNUM mccchannel_18_analyzer_2_array_crystal_array_8_p_interact;
char mccchannel_18_analyzer_2_array_crystal_array_8_mask_string[16384];
char mccchannel_18_analyzer_2_array_crystal_array_8_mask_setting[16384];
MCNUM mccchannel_18_analyzer_2_array_crystal_array_8_number_of_activations;

/* Setting parameters for component 'channel_18_cave2_cyl1' [834]. */
char mccchannel_18_cave2_cyl1_material_string[16384];
MCNUM mccchannel_18_cave2_cyl1_priority;
MCNUM mccchannel_18_cave2_cyl1_radius;
MCNUM mccchannel_18_cave2_cyl1_yheight;
MCNUM mccchannel_18_cave2_cyl1_visualize;
int mccchannel_18_cave2_cyl1_target_index;
MCNUM mccchannel_18_cave2_cyl1_target_x;
MCNUM mccchannel_18_cave2_cyl1_target_y;
MCNUM mccchannel_18_cave2_cyl1_target_z;
MCNUM mccchannel_18_cave2_cyl1_focus_aw;
MCNUM mccchannel_18_cave2_cyl1_focus_ah;
MCNUM mccchannel_18_cave2_cyl1_focus_xw;
MCNUM mccchannel_18_cave2_cyl1_focus_xh;
MCNUM mccchannel_18_cave2_cyl1_focus_r;
MCNUM mccchannel_18_cave2_cyl1_p_interact;
char mccchannel_18_cave2_cyl1_mask_string[16384];
char mccchannel_18_cave2_cyl1_mask_setting[16384];
MCNUM mccchannel_18_cave2_cyl1_number_of_activations;

/* Setting parameters for component 'channel_18_cave2_box1' [835]. */
char mccchannel_18_cave2_box1_material_string[16384];
MCNUM mccchannel_18_cave2_box1_priority;
MCNUM mccchannel_18_cave2_box1_xwidth;
MCNUM mccchannel_18_cave2_box1_yheight;
MCNUM mccchannel_18_cave2_box1_zdepth;
MCNUM mccchannel_18_cave2_box1_xwidth2;
MCNUM mccchannel_18_cave2_box1_yheight2;
MCNUM mccchannel_18_cave2_box1_visualize;
int mccchannel_18_cave2_box1_target_index;
MCNUM mccchannel_18_cave2_box1_target_x;
MCNUM mccchannel_18_cave2_box1_target_y;
MCNUM mccchannel_18_cave2_box1_target_z;
MCNUM mccchannel_18_cave2_box1_focus_aw;
MCNUM mccchannel_18_cave2_box1_focus_ah;
MCNUM mccchannel_18_cave2_box1_focus_xw;
MCNUM mccchannel_18_cave2_box1_focus_xh;
MCNUM mccchannel_18_cave2_box1_focus_r;
MCNUM mccchannel_18_cave2_box1_p_interact;
char mccchannel_18_cave2_box1_mask_string[16384];
char mccchannel_18_cave2_box1_mask_setting[16384];
MCNUM mccchannel_18_cave2_box1_number_of_activations;

/* Setting parameters for component 'channel_18_cave2_box2' [836]. */
char mccchannel_18_cave2_box2_material_string[16384];
MCNUM mccchannel_18_cave2_box2_priority;
MCNUM mccchannel_18_cave2_box2_xwidth;
MCNUM mccchannel_18_cave2_box2_yheight;
MCNUM mccchannel_18_cave2_box2_zdepth;
MCNUM mccchannel_18_cave2_box2_xwidth2;
MCNUM mccchannel_18_cave2_box2_yheight2;
MCNUM mccchannel_18_cave2_box2_visualize;
int mccchannel_18_cave2_box2_target_index;
MCNUM mccchannel_18_cave2_box2_target_x;
MCNUM mccchannel_18_cave2_box2_target_y;
MCNUM mccchannel_18_cave2_box2_target_z;
MCNUM mccchannel_18_cave2_box2_focus_aw;
MCNUM mccchannel_18_cave2_box2_focus_ah;
MCNUM mccchannel_18_cave2_box2_focus_xw;
MCNUM mccchannel_18_cave2_box2_focus_xh;
MCNUM mccchannel_18_cave2_box2_focus_r;
MCNUM mccchannel_18_cave2_box2_p_interact;
char mccchannel_18_cave2_box2_mask_string[16384];
char mccchannel_18_cave2_box2_mask_setting[16384];
MCNUM mccchannel_18_cave2_box2_number_of_activations;

/* Setting parameters for component 'channel_18_cave2_box3' [837]. */
char mccchannel_18_cave2_box3_material_string[16384];
MCNUM mccchannel_18_cave2_box3_priority;
MCNUM mccchannel_18_cave2_box3_xwidth;
MCNUM mccchannel_18_cave2_box3_yheight;
MCNUM mccchannel_18_cave2_box3_zdepth;
MCNUM mccchannel_18_cave2_box3_xwidth2;
MCNUM mccchannel_18_cave2_box3_yheight2;
MCNUM mccchannel_18_cave2_box3_visualize;
int mccchannel_18_cave2_box3_target_index;
MCNUM mccchannel_18_cave2_box3_target_x;
MCNUM mccchannel_18_cave2_box3_target_y;
MCNUM mccchannel_18_cave2_box3_target_z;
MCNUM mccchannel_18_cave2_box3_focus_aw;
MCNUM mccchannel_18_cave2_box3_focus_ah;
MCNUM mccchannel_18_cave2_box3_focus_xw;
MCNUM mccchannel_18_cave2_box3_focus_xh;
MCNUM mccchannel_18_cave2_box3_focus_r;
MCNUM mccchannel_18_cave2_box3_p_interact;
char mccchannel_18_cave2_box3_mask_string[16384];
char mccchannel_18_cave2_box3_mask_setting[16384];
MCNUM mccchannel_18_cave2_box3_number_of_activations;

/* Setting parameters for component 'inter_analyzer_colimator_18_blade_0' [839]. */
char mccinter_analyzer_colimator_18_blade_0_material_string[16384];
MCNUM mccinter_analyzer_colimator_18_blade_0_priority;
MCNUM mccinter_analyzer_colimator_18_blade_0_xwidth;
MCNUM mccinter_analyzer_colimator_18_blade_0_yheight;
MCNUM mccinter_analyzer_colimator_18_blade_0_zdepth;
MCNUM mccinter_analyzer_colimator_18_blade_0_xwidth2;
MCNUM mccinter_analyzer_colimator_18_blade_0_yheight2;
MCNUM mccinter_analyzer_colimator_18_blade_0_visualize;
int mccinter_analyzer_colimator_18_blade_0_target_index;
MCNUM mccinter_analyzer_colimator_18_blade_0_target_x;
MCNUM mccinter_analyzer_colimator_18_blade_0_target_y;
MCNUM mccinter_analyzer_colimator_18_blade_0_target_z;
MCNUM mccinter_analyzer_colimator_18_blade_0_focus_aw;
MCNUM mccinter_analyzer_colimator_18_blade_0_focus_ah;
MCNUM mccinter_analyzer_colimator_18_blade_0_focus_xw;
MCNUM mccinter_analyzer_colimator_18_blade_0_focus_xh;
MCNUM mccinter_analyzer_colimator_18_blade_0_focus_r;
MCNUM mccinter_analyzer_colimator_18_blade_0_p_interact;
char mccinter_analyzer_colimator_18_blade_0_mask_string[16384];
char mccinter_analyzer_colimator_18_blade_0_mask_setting[16384];
MCNUM mccinter_analyzer_colimator_18_blade_0_number_of_activations;

/* Setting parameters for component 'inter_analyzer_colimator_18_blade_1' [840]. */
char mccinter_analyzer_colimator_18_blade_1_material_string[16384];
MCNUM mccinter_analyzer_colimator_18_blade_1_priority;
MCNUM mccinter_analyzer_colimator_18_blade_1_xwidth;
MCNUM mccinter_analyzer_colimator_18_blade_1_yheight;
MCNUM mccinter_analyzer_colimator_18_blade_1_zdepth;
MCNUM mccinter_analyzer_colimator_18_blade_1_xwidth2;
MCNUM mccinter_analyzer_colimator_18_blade_1_yheight2;
MCNUM mccinter_analyzer_colimator_18_blade_1_visualize;
int mccinter_analyzer_colimator_18_blade_1_target_index;
MCNUM mccinter_analyzer_colimator_18_blade_1_target_x;
MCNUM mccinter_analyzer_colimator_18_blade_1_target_y;
MCNUM mccinter_analyzer_colimator_18_blade_1_target_z;
MCNUM mccinter_analyzer_colimator_18_blade_1_focus_aw;
MCNUM mccinter_analyzer_colimator_18_blade_1_focus_ah;
MCNUM mccinter_analyzer_colimator_18_blade_1_focus_xw;
MCNUM mccinter_analyzer_colimator_18_blade_1_focus_xh;
MCNUM mccinter_analyzer_colimator_18_blade_1_focus_r;
MCNUM mccinter_analyzer_colimator_18_blade_1_p_interact;
char mccinter_analyzer_colimator_18_blade_1_mask_string[16384];
char mccinter_analyzer_colimator_18_blade_1_mask_setting[16384];
MCNUM mccinter_analyzer_colimator_18_blade_1_number_of_activations;

/* Setting parameters for component 'inter_analyzer_colimator_18_blade_2' [841]. */
char mccinter_analyzer_colimator_18_blade_2_material_string[16384];
MCNUM mccinter_analyzer_colimator_18_blade_2_priority;
MCNUM mccinter_analyzer_colimator_18_blade_2_xwidth;
MCNUM mccinter_analyzer_colimator_18_blade_2_yheight;
MCNUM mccinter_analyzer_colimator_18_blade_2_zdepth;
MCNUM mccinter_analyzer_colimator_18_blade_2_xwidth2;
MCNUM mccinter_analyzer_colimator_18_blade_2_yheight2;
MCNUM mccinter_analyzer_colimator_18_blade_2_visualize;
int mccinter_analyzer_colimator_18_blade_2_target_index;
MCNUM mccinter_analyzer_colimator_18_blade_2_target_x;
MCNUM mccinter_analyzer_colimator_18_blade_2_target_y;
MCNUM mccinter_analyzer_colimator_18_blade_2_target_z;
MCNUM mccinter_analyzer_colimator_18_blade_2_focus_aw;
MCNUM mccinter_analyzer_colimator_18_blade_2_focus_ah;
MCNUM mccinter_analyzer_colimator_18_blade_2_focus_xw;
MCNUM mccinter_analyzer_colimator_18_blade_2_focus_xh;
MCNUM mccinter_analyzer_colimator_18_blade_2_focus_r;
MCNUM mccinter_analyzer_colimator_18_blade_2_p_interact;
char mccinter_analyzer_colimator_18_blade_2_mask_string[16384];
char mccinter_analyzer_colimator_18_blade_2_mask_setting[16384];
MCNUM mccinter_analyzer_colimator_18_blade_2_number_of_activations;

/* Setting parameters for component 'inter_analyzer_colimator_18_blade_3' [842]. */
char mccinter_analyzer_colimator_18_blade_3_material_string[16384];
MCNUM mccinter_analyzer_colimator_18_blade_3_priority;
MCNUM mccinter_analyzer_colimator_18_blade_3_xwidth;
MCNUM mccinter_analyzer_colimator_18_blade_3_yheight;
MCNUM mccinter_analyzer_colimator_18_blade_3_zdepth;
MCNUM mccinter_analyzer_colimator_18_blade_3_xwidth2;
MCNUM mccinter_analyzer_colimator_18_blade_3_yheight2;
MCNUM mccinter_analyzer_colimator_18_blade_3_visualize;
int mccinter_analyzer_colimator_18_blade_3_target_index;
MCNUM mccinter_analyzer_colimator_18_blade_3_target_x;
MCNUM mccinter_analyzer_colimator_18_blade_3_target_y;
MCNUM mccinter_analyzer_colimator_18_blade_3_target_z;
MCNUM mccinter_analyzer_colimator_18_blade_3_focus_aw;
MCNUM mccinter_analyzer_colimator_18_blade_3_focus_ah;
MCNUM mccinter_analyzer_colimator_18_blade_3_focus_xw;
MCNUM mccinter_analyzer_colimator_18_blade_3_focus_xh;
MCNUM mccinter_analyzer_colimator_18_blade_3_focus_r;
MCNUM mccinter_analyzer_colimator_18_blade_3_p_interact;
char mccinter_analyzer_colimator_18_blade_3_mask_string[16384];
char mccinter_analyzer_colimator_18_blade_3_mask_setting[16384];
MCNUM mccinter_analyzer_colimator_18_blade_3_number_of_activations;

/* Setting parameters for component 'inter_analyzer_colimator_18_blade_4' [843]. */
char mccinter_analyzer_colimator_18_blade_4_material_string[16384];
MCNUM mccinter_analyzer_colimator_18_blade_4_priority;
MCNUM mccinter_analyzer_colimator_18_blade_4_xwidth;
MCNUM mccinter_analyzer_colimator_18_blade_4_yheight;
MCNUM mccinter_analyzer_colimator_18_blade_4_zdepth;
MCNUM mccinter_analyzer_colimator_18_blade_4_xwidth2;
MCNUM mccinter_analyzer_colimator_18_blade_4_yheight2;
MCNUM mccinter_analyzer_colimator_18_blade_4_visualize;
int mccinter_analyzer_colimator_18_blade_4_target_index;
MCNUM mccinter_analyzer_colimator_18_blade_4_target_x;
MCNUM mccinter_analyzer_colimator_18_blade_4_target_y;
MCNUM mccinter_analyzer_colimator_18_blade_4_target_z;
MCNUM mccinter_analyzer_colimator_18_blade_4_focus_aw;
MCNUM mccinter_analyzer_colimator_18_blade_4_focus_ah;
MCNUM mccinter_analyzer_colimator_18_blade_4_focus_xw;
MCNUM mccinter_analyzer_colimator_18_blade_4_focus_xh;
MCNUM mccinter_analyzer_colimator_18_blade_4_focus_r;
MCNUM mccinter_analyzer_colimator_18_blade_4_p_interact;
char mccinter_analyzer_colimator_18_blade_4_mask_string[16384];
char mccinter_analyzer_colimator_18_blade_4_mask_setting[16384];
MCNUM mccinter_analyzer_colimator_18_blade_4_number_of_activations;

/* Setting parameters for component 'diffraction_detector_18_exit_volume' [844]. */
char mccdiffraction_detector_18_exit_volume_material_string[16384];
MCNUM mccdiffraction_detector_18_exit_volume_priority;
MCNUM mccdiffraction_detector_18_exit_volume_xwidth;
MCNUM mccdiffraction_detector_18_exit_volume_yheight;
MCNUM mccdiffraction_detector_18_exit_volume_zdepth;
MCNUM mccdiffraction_detector_18_exit_volume_xwidth2;
MCNUM mccdiffraction_detector_18_exit_volume_yheight2;
MCNUM mccdiffraction_detector_18_exit_volume_visualize;
int mccdiffraction_detector_18_exit_volume_target_index;
MCNUM mccdiffraction_detector_18_exit_volume_target_x;
MCNUM mccdiffraction_detector_18_exit_volume_target_y;
MCNUM mccdiffraction_detector_18_exit_volume_target_z;
MCNUM mccdiffraction_detector_18_exit_volume_focus_aw;
MCNUM mccdiffraction_detector_18_exit_volume_focus_ah;
MCNUM mccdiffraction_detector_18_exit_volume_focus_xw;
MCNUM mccdiffraction_detector_18_exit_volume_focus_xh;
MCNUM mccdiffraction_detector_18_exit_volume_focus_r;
MCNUM mccdiffraction_detector_18_exit_volume_p_interact;
char mccdiffraction_detector_18_exit_volume_mask_string[16384];
char mccdiffraction_detector_18_exit_volume_mask_setting[16384];
MCNUM mccdiffraction_detector_18_exit_volume_number_of_activations;

/* Setting parameters for component 'spec_detector_18_exit_volume' [845]. */
char mccspec_detector_18_exit_volume_material_string[16384];
MCNUM mccspec_detector_18_exit_volume_priority;
MCNUM mccspec_detector_18_exit_volume_xwidth;
MCNUM mccspec_detector_18_exit_volume_yheight;
MCNUM mccspec_detector_18_exit_volume_zdepth;
MCNUM mccspec_detector_18_exit_volume_xwidth2;
MCNUM mccspec_detector_18_exit_volume_yheight2;
MCNUM mccspec_detector_18_exit_volume_visualize;
int mccspec_detector_18_exit_volume_target_index;
MCNUM mccspec_detector_18_exit_volume_target_x;
MCNUM mccspec_detector_18_exit_volume_target_y;
MCNUM mccspec_detector_18_exit_volume_target_z;
MCNUM mccspec_detector_18_exit_volume_focus_aw;
MCNUM mccspec_detector_18_exit_volume_focus_ah;
MCNUM mccspec_detector_18_exit_volume_focus_xw;
MCNUM mccspec_detector_18_exit_volume_focus_xh;
MCNUM mccspec_detector_18_exit_volume_focus_r;
MCNUM mccspec_detector_18_exit_volume_p_interact;
char mccspec_detector_18_exit_volume_mask_string[16384];
char mccspec_detector_18_exit_volume_mask_setting[16384];
MCNUM mccspec_detector_18_exit_volume_number_of_activations;

/* Setting parameters for component 'channel_19_cave1_box1' [846]. */
char mccchannel_19_cave1_box1_material_string[16384];
MCNUM mccchannel_19_cave1_box1_priority;
MCNUM mccchannel_19_cave1_box1_xwidth;
MCNUM mccchannel_19_cave1_box1_yheight;
MCNUM mccchannel_19_cave1_box1_zdepth;
MCNUM mccchannel_19_cave1_box1_xwidth2;
MCNUM mccchannel_19_cave1_box1_yheight2;
MCNUM mccchannel_19_cave1_box1_visualize;
int mccchannel_19_cave1_box1_target_index;
MCNUM mccchannel_19_cave1_box1_target_x;
MCNUM mccchannel_19_cave1_box1_target_y;
MCNUM mccchannel_19_cave1_box1_target_z;
MCNUM mccchannel_19_cave1_box1_focus_aw;
MCNUM mccchannel_19_cave1_box1_focus_ah;
MCNUM mccchannel_19_cave1_box1_focus_xw;
MCNUM mccchannel_19_cave1_box1_focus_xh;
MCNUM mccchannel_19_cave1_box1_focus_r;
MCNUM mccchannel_19_cave1_box1_p_interact;
char mccchannel_19_cave1_box1_mask_string[16384];
char mccchannel_19_cave1_box1_mask_setting[16384];
MCNUM mccchannel_19_cave1_box1_number_of_activations;

/* Setting parameters for component 'channel_19_cave1_box2' [847]. */
char mccchannel_19_cave1_box2_material_string[16384];
MCNUM mccchannel_19_cave1_box2_priority;
MCNUM mccchannel_19_cave1_box2_xwidth;
MCNUM mccchannel_19_cave1_box2_yheight;
MCNUM mccchannel_19_cave1_box2_zdepth;
MCNUM mccchannel_19_cave1_box2_xwidth2;
MCNUM mccchannel_19_cave1_box2_yheight2;
MCNUM mccchannel_19_cave1_box2_visualize;
int mccchannel_19_cave1_box2_target_index;
MCNUM mccchannel_19_cave1_box2_target_x;
MCNUM mccchannel_19_cave1_box2_target_y;
MCNUM mccchannel_19_cave1_box2_target_z;
MCNUM mccchannel_19_cave1_box2_focus_aw;
MCNUM mccchannel_19_cave1_box2_focus_ah;
MCNUM mccchannel_19_cave1_box2_focus_xw;
MCNUM mccchannel_19_cave1_box2_focus_xh;
MCNUM mccchannel_19_cave1_box2_focus_r;
MCNUM mccchannel_19_cave1_box2_p_interact;
char mccchannel_19_cave1_box2_mask_string[16384];
char mccchannel_19_cave1_box2_mask_setting[16384];
MCNUM mccchannel_19_cave1_box2_number_of_activations;

/* Setting parameters for component 'channel_19_cave1_box3' [848]. */
char mccchannel_19_cave1_box3_material_string[16384];
MCNUM mccchannel_19_cave1_box3_priority;
MCNUM mccchannel_19_cave1_box3_xwidth;
MCNUM mccchannel_19_cave1_box3_yheight;
MCNUM mccchannel_19_cave1_box3_zdepth;
MCNUM mccchannel_19_cave1_box3_xwidth2;
MCNUM mccchannel_19_cave1_box3_yheight2;
MCNUM mccchannel_19_cave1_box3_visualize;
int mccchannel_19_cave1_box3_target_index;
MCNUM mccchannel_19_cave1_box3_target_x;
MCNUM mccchannel_19_cave1_box3_target_y;
MCNUM mccchannel_19_cave1_box3_target_z;
MCNUM mccchannel_19_cave1_box3_focus_aw;
MCNUM mccchannel_19_cave1_box3_focus_ah;
MCNUM mccchannel_19_cave1_box3_focus_xw;
MCNUM mccchannel_19_cave1_box3_focus_xh;
MCNUM mccchannel_19_cave1_box3_focus_r;
MCNUM mccchannel_19_cave1_box3_p_interact;
char mccchannel_19_cave1_box3_mask_string[16384];
char mccchannel_19_cave1_box3_mask_setting[16384];
MCNUM mccchannel_19_cave1_box3_number_of_activations;

/* Setting parameters for component 'channel_19_cave1_cyl1' [849]. */
char mccchannel_19_cave1_cyl1_material_string[16384];
MCNUM mccchannel_19_cave1_cyl1_priority;
MCNUM mccchannel_19_cave1_cyl1_radius;
MCNUM mccchannel_19_cave1_cyl1_yheight;
MCNUM mccchannel_19_cave1_cyl1_visualize;
int mccchannel_19_cave1_cyl1_target_index;
MCNUM mccchannel_19_cave1_cyl1_target_x;
MCNUM mccchannel_19_cave1_cyl1_target_y;
MCNUM mccchannel_19_cave1_cyl1_target_z;
MCNUM mccchannel_19_cave1_cyl1_focus_aw;
MCNUM mccchannel_19_cave1_cyl1_focus_ah;
MCNUM mccchannel_19_cave1_cyl1_focus_xw;
MCNUM mccchannel_19_cave1_cyl1_focus_xh;
MCNUM mccchannel_19_cave1_cyl1_focus_r;
MCNUM mccchannel_19_cave1_cyl1_p_interact;
char mccchannel_19_cave1_cyl1_mask_string[16384];
char mccchannel_19_cave1_cyl1_mask_setting[16384];
MCNUM mccchannel_19_cave1_cyl1_number_of_activations;

/* Setting parameters for component 'channel_19_analyzer_1_array_crystal_array_0' [852]. */
char mccchannel_19_analyzer_1_array_crystal_array_0_material_string[16384];
MCNUM mccchannel_19_analyzer_1_array_crystal_array_0_priority;
MCNUM mccchannel_19_analyzer_1_array_crystal_array_0_xwidth;
MCNUM mccchannel_19_analyzer_1_array_crystal_array_0_yheight;
MCNUM mccchannel_19_analyzer_1_array_crystal_array_0_zdepth;
MCNUM mccchannel_19_analyzer_1_array_crystal_array_0_xwidth2;
MCNUM mccchannel_19_analyzer_1_array_crystal_array_0_yheight2;
MCNUM mccchannel_19_analyzer_1_array_crystal_array_0_visualize;
int mccchannel_19_analyzer_1_array_crystal_array_0_target_index;
MCNUM mccchannel_19_analyzer_1_array_crystal_array_0_target_x;
MCNUM mccchannel_19_analyzer_1_array_crystal_array_0_target_y;
MCNUM mccchannel_19_analyzer_1_array_crystal_array_0_target_z;
MCNUM mccchannel_19_analyzer_1_array_crystal_array_0_focus_aw;
MCNUM mccchannel_19_analyzer_1_array_crystal_array_0_focus_ah;
MCNUM mccchannel_19_analyzer_1_array_crystal_array_0_focus_xw;
MCNUM mccchannel_19_analyzer_1_array_crystal_array_0_focus_xh;
MCNUM mccchannel_19_analyzer_1_array_crystal_array_0_focus_r;
MCNUM mccchannel_19_analyzer_1_array_crystal_array_0_p_interact;
char mccchannel_19_analyzer_1_array_crystal_array_0_mask_string[16384];
char mccchannel_19_analyzer_1_array_crystal_array_0_mask_setting[16384];
MCNUM mccchannel_19_analyzer_1_array_crystal_array_0_number_of_activations;

/* Setting parameters for component 'channel_19_analyzer_1_array_crystal_array_1' [853]. */
char mccchannel_19_analyzer_1_array_crystal_array_1_material_string[16384];
MCNUM mccchannel_19_analyzer_1_array_crystal_array_1_priority;
MCNUM mccchannel_19_analyzer_1_array_crystal_array_1_xwidth;
MCNUM mccchannel_19_analyzer_1_array_crystal_array_1_yheight;
MCNUM mccchannel_19_analyzer_1_array_crystal_array_1_zdepth;
MCNUM mccchannel_19_analyzer_1_array_crystal_array_1_xwidth2;
MCNUM mccchannel_19_analyzer_1_array_crystal_array_1_yheight2;
MCNUM mccchannel_19_analyzer_1_array_crystal_array_1_visualize;
int mccchannel_19_analyzer_1_array_crystal_array_1_target_index;
MCNUM mccchannel_19_analyzer_1_array_crystal_array_1_target_x;
MCNUM mccchannel_19_analyzer_1_array_crystal_array_1_target_y;
MCNUM mccchannel_19_analyzer_1_array_crystal_array_1_target_z;
MCNUM mccchannel_19_analyzer_1_array_crystal_array_1_focus_aw;
MCNUM mccchannel_19_analyzer_1_array_crystal_array_1_focus_ah;
MCNUM mccchannel_19_analyzer_1_array_crystal_array_1_focus_xw;
MCNUM mccchannel_19_analyzer_1_array_crystal_array_1_focus_xh;
MCNUM mccchannel_19_analyzer_1_array_crystal_array_1_focus_r;
MCNUM mccchannel_19_analyzer_1_array_crystal_array_1_p_interact;
char mccchannel_19_analyzer_1_array_crystal_array_1_mask_string[16384];
char mccchannel_19_analyzer_1_array_crystal_array_1_mask_setting[16384];
MCNUM mccchannel_19_analyzer_1_array_crystal_array_1_number_of_activations;

/* Setting parameters for component 'channel_19_analyzer_1_array_crystal_array_2' [854]. */
char mccchannel_19_analyzer_1_array_crystal_array_2_material_string[16384];
MCNUM mccchannel_19_analyzer_1_array_crystal_array_2_priority;
MCNUM mccchannel_19_analyzer_1_array_crystal_array_2_xwidth;
MCNUM mccchannel_19_analyzer_1_array_crystal_array_2_yheight;
MCNUM mccchannel_19_analyzer_1_array_crystal_array_2_zdepth;
MCNUM mccchannel_19_analyzer_1_array_crystal_array_2_xwidth2;
MCNUM mccchannel_19_analyzer_1_array_crystal_array_2_yheight2;
MCNUM mccchannel_19_analyzer_1_array_crystal_array_2_visualize;
int mccchannel_19_analyzer_1_array_crystal_array_2_target_index;
MCNUM mccchannel_19_analyzer_1_array_crystal_array_2_target_x;
MCNUM mccchannel_19_analyzer_1_array_crystal_array_2_target_y;
MCNUM mccchannel_19_analyzer_1_array_crystal_array_2_target_z;
MCNUM mccchannel_19_analyzer_1_array_crystal_array_2_focus_aw;
MCNUM mccchannel_19_analyzer_1_array_crystal_array_2_focus_ah;
MCNUM mccchannel_19_analyzer_1_array_crystal_array_2_focus_xw;
MCNUM mccchannel_19_analyzer_1_array_crystal_array_2_focus_xh;
MCNUM mccchannel_19_analyzer_1_array_crystal_array_2_focus_r;
MCNUM mccchannel_19_analyzer_1_array_crystal_array_2_p_interact;
char mccchannel_19_analyzer_1_array_crystal_array_2_mask_string[16384];
char mccchannel_19_analyzer_1_array_crystal_array_2_mask_setting[16384];
MCNUM mccchannel_19_analyzer_1_array_crystal_array_2_number_of_activations;

/* Setting parameters for component 'channel_19_analyzer_1_array_crystal_array_3' [855]. */
char mccchannel_19_analyzer_1_array_crystal_array_3_material_string[16384];
MCNUM mccchannel_19_analyzer_1_array_crystal_array_3_priority;
MCNUM mccchannel_19_analyzer_1_array_crystal_array_3_xwidth;
MCNUM mccchannel_19_analyzer_1_array_crystal_array_3_yheight;
MCNUM mccchannel_19_analyzer_1_array_crystal_array_3_zdepth;
MCNUM mccchannel_19_analyzer_1_array_crystal_array_3_xwidth2;
MCNUM mccchannel_19_analyzer_1_array_crystal_array_3_yheight2;
MCNUM mccchannel_19_analyzer_1_array_crystal_array_3_visualize;
int mccchannel_19_analyzer_1_array_crystal_array_3_target_index;
MCNUM mccchannel_19_analyzer_1_array_crystal_array_3_target_x;
MCNUM mccchannel_19_analyzer_1_array_crystal_array_3_target_y;
MCNUM mccchannel_19_analyzer_1_array_crystal_array_3_target_z;
MCNUM mccchannel_19_analyzer_1_array_crystal_array_3_focus_aw;
MCNUM mccchannel_19_analyzer_1_array_crystal_array_3_focus_ah;
MCNUM mccchannel_19_analyzer_1_array_crystal_array_3_focus_xw;
MCNUM mccchannel_19_analyzer_1_array_crystal_array_3_focus_xh;
MCNUM mccchannel_19_analyzer_1_array_crystal_array_3_focus_r;
MCNUM mccchannel_19_analyzer_1_array_crystal_array_3_p_interact;
char mccchannel_19_analyzer_1_array_crystal_array_3_mask_string[16384];
char mccchannel_19_analyzer_1_array_crystal_array_3_mask_setting[16384];
MCNUM mccchannel_19_analyzer_1_array_crystal_array_3_number_of_activations;

/* Setting parameters for component 'channel_19_analyzer_1_array_crystal_array_4' [856]. */
char mccchannel_19_analyzer_1_array_crystal_array_4_material_string[16384];
MCNUM mccchannel_19_analyzer_1_array_crystal_array_4_priority;
MCNUM mccchannel_19_analyzer_1_array_crystal_array_4_xwidth;
MCNUM mccchannel_19_analyzer_1_array_crystal_array_4_yheight;
MCNUM mccchannel_19_analyzer_1_array_crystal_array_4_zdepth;
MCNUM mccchannel_19_analyzer_1_array_crystal_array_4_xwidth2;
MCNUM mccchannel_19_analyzer_1_array_crystal_array_4_yheight2;
MCNUM mccchannel_19_analyzer_1_array_crystal_array_4_visualize;
int mccchannel_19_analyzer_1_array_crystal_array_4_target_index;
MCNUM mccchannel_19_analyzer_1_array_crystal_array_4_target_x;
MCNUM mccchannel_19_analyzer_1_array_crystal_array_4_target_y;
MCNUM mccchannel_19_analyzer_1_array_crystal_array_4_target_z;
MCNUM mccchannel_19_analyzer_1_array_crystal_array_4_focus_aw;
MCNUM mccchannel_19_analyzer_1_array_crystal_array_4_focus_ah;
MCNUM mccchannel_19_analyzer_1_array_crystal_array_4_focus_xw;
MCNUM mccchannel_19_analyzer_1_array_crystal_array_4_focus_xh;
MCNUM mccchannel_19_analyzer_1_array_crystal_array_4_focus_r;
MCNUM mccchannel_19_analyzer_1_array_crystal_array_4_p_interact;
char mccchannel_19_analyzer_1_array_crystal_array_4_mask_string[16384];
char mccchannel_19_analyzer_1_array_crystal_array_4_mask_setting[16384];
MCNUM mccchannel_19_analyzer_1_array_crystal_array_4_number_of_activations;

/* Setting parameters for component 'channel_19_analyzer_1_array_crystal_array_5' [857]. */
char mccchannel_19_analyzer_1_array_crystal_array_5_material_string[16384];
MCNUM mccchannel_19_analyzer_1_array_crystal_array_5_priority;
MCNUM mccchannel_19_analyzer_1_array_crystal_array_5_xwidth;
MCNUM mccchannel_19_analyzer_1_array_crystal_array_5_yheight;
MCNUM mccchannel_19_analyzer_1_array_crystal_array_5_zdepth;
MCNUM mccchannel_19_analyzer_1_array_crystal_array_5_xwidth2;
MCNUM mccchannel_19_analyzer_1_array_crystal_array_5_yheight2;
MCNUM mccchannel_19_analyzer_1_array_crystal_array_5_visualize;
int mccchannel_19_analyzer_1_array_crystal_array_5_target_index;
MCNUM mccchannel_19_analyzer_1_array_crystal_array_5_target_x;
MCNUM mccchannel_19_analyzer_1_array_crystal_array_5_target_y;
MCNUM mccchannel_19_analyzer_1_array_crystal_array_5_target_z;
MCNUM mccchannel_19_analyzer_1_array_crystal_array_5_focus_aw;
MCNUM mccchannel_19_analyzer_1_array_crystal_array_5_focus_ah;
MCNUM mccchannel_19_analyzer_1_array_crystal_array_5_focus_xw;
MCNUM mccchannel_19_analyzer_1_array_crystal_array_5_focus_xh;
MCNUM mccchannel_19_analyzer_1_array_crystal_array_5_focus_r;
MCNUM mccchannel_19_analyzer_1_array_crystal_array_5_p_interact;
char mccchannel_19_analyzer_1_array_crystal_array_5_mask_string[16384];
char mccchannel_19_analyzer_1_array_crystal_array_5_mask_setting[16384];
MCNUM mccchannel_19_analyzer_1_array_crystal_array_5_number_of_activations;

/* Setting parameters for component 'channel_19_analyzer_1_array_crystal_array_6' [858]. */
char mccchannel_19_analyzer_1_array_crystal_array_6_material_string[16384];
MCNUM mccchannel_19_analyzer_1_array_crystal_array_6_priority;
MCNUM mccchannel_19_analyzer_1_array_crystal_array_6_xwidth;
MCNUM mccchannel_19_analyzer_1_array_crystal_array_6_yheight;
MCNUM mccchannel_19_analyzer_1_array_crystal_array_6_zdepth;
MCNUM mccchannel_19_analyzer_1_array_crystal_array_6_xwidth2;
MCNUM mccchannel_19_analyzer_1_array_crystal_array_6_yheight2;
MCNUM mccchannel_19_analyzer_1_array_crystal_array_6_visualize;
int mccchannel_19_analyzer_1_array_crystal_array_6_target_index;
MCNUM mccchannel_19_analyzer_1_array_crystal_array_6_target_x;
MCNUM mccchannel_19_analyzer_1_array_crystal_array_6_target_y;
MCNUM mccchannel_19_analyzer_1_array_crystal_array_6_target_z;
MCNUM mccchannel_19_analyzer_1_array_crystal_array_6_focus_aw;
MCNUM mccchannel_19_analyzer_1_array_crystal_array_6_focus_ah;
MCNUM mccchannel_19_analyzer_1_array_crystal_array_6_focus_xw;
MCNUM mccchannel_19_analyzer_1_array_crystal_array_6_focus_xh;
MCNUM mccchannel_19_analyzer_1_array_crystal_array_6_focus_r;
MCNUM mccchannel_19_analyzer_1_array_crystal_array_6_p_interact;
char mccchannel_19_analyzer_1_array_crystal_array_6_mask_string[16384];
char mccchannel_19_analyzer_1_array_crystal_array_6_mask_setting[16384];
MCNUM mccchannel_19_analyzer_1_array_crystal_array_6_number_of_activations;

/* Setting parameters for component 'channel_19_analyzer_1_array_crystal_array_7' [859]. */
char mccchannel_19_analyzer_1_array_crystal_array_7_material_string[16384];
MCNUM mccchannel_19_analyzer_1_array_crystal_array_7_priority;
MCNUM mccchannel_19_analyzer_1_array_crystal_array_7_xwidth;
MCNUM mccchannel_19_analyzer_1_array_crystal_array_7_yheight;
MCNUM mccchannel_19_analyzer_1_array_crystal_array_7_zdepth;
MCNUM mccchannel_19_analyzer_1_array_crystal_array_7_xwidth2;
MCNUM mccchannel_19_analyzer_1_array_crystal_array_7_yheight2;
MCNUM mccchannel_19_analyzer_1_array_crystal_array_7_visualize;
int mccchannel_19_analyzer_1_array_crystal_array_7_target_index;
MCNUM mccchannel_19_analyzer_1_array_crystal_array_7_target_x;
MCNUM mccchannel_19_analyzer_1_array_crystal_array_7_target_y;
MCNUM mccchannel_19_analyzer_1_array_crystal_array_7_target_z;
MCNUM mccchannel_19_analyzer_1_array_crystal_array_7_focus_aw;
MCNUM mccchannel_19_analyzer_1_array_crystal_array_7_focus_ah;
MCNUM mccchannel_19_analyzer_1_array_crystal_array_7_focus_xw;
MCNUM mccchannel_19_analyzer_1_array_crystal_array_7_focus_xh;
MCNUM mccchannel_19_analyzer_1_array_crystal_array_7_focus_r;
MCNUM mccchannel_19_analyzer_1_array_crystal_array_7_p_interact;
char mccchannel_19_analyzer_1_array_crystal_array_7_mask_string[16384];
char mccchannel_19_analyzer_1_array_crystal_array_7_mask_setting[16384];
MCNUM mccchannel_19_analyzer_1_array_crystal_array_7_number_of_activations;

/* Setting parameters for component 'channel_19_analyzer_1_array_crystal_array_8' [860]. */
char mccchannel_19_analyzer_1_array_crystal_array_8_material_string[16384];
MCNUM mccchannel_19_analyzer_1_array_crystal_array_8_priority;
MCNUM mccchannel_19_analyzer_1_array_crystal_array_8_xwidth;
MCNUM mccchannel_19_analyzer_1_array_crystal_array_8_yheight;
MCNUM mccchannel_19_analyzer_1_array_crystal_array_8_zdepth;
MCNUM mccchannel_19_analyzer_1_array_crystal_array_8_xwidth2;
MCNUM mccchannel_19_analyzer_1_array_crystal_array_8_yheight2;
MCNUM mccchannel_19_analyzer_1_array_crystal_array_8_visualize;
int mccchannel_19_analyzer_1_array_crystal_array_8_target_index;
MCNUM mccchannel_19_analyzer_1_array_crystal_array_8_target_x;
MCNUM mccchannel_19_analyzer_1_array_crystal_array_8_target_y;
MCNUM mccchannel_19_analyzer_1_array_crystal_array_8_target_z;
MCNUM mccchannel_19_analyzer_1_array_crystal_array_8_focus_aw;
MCNUM mccchannel_19_analyzer_1_array_crystal_array_8_focus_ah;
MCNUM mccchannel_19_analyzer_1_array_crystal_array_8_focus_xw;
MCNUM mccchannel_19_analyzer_1_array_crystal_array_8_focus_xh;
MCNUM mccchannel_19_analyzer_1_array_crystal_array_8_focus_r;
MCNUM mccchannel_19_analyzer_1_array_crystal_array_8_p_interact;
char mccchannel_19_analyzer_1_array_crystal_array_8_mask_string[16384];
char mccchannel_19_analyzer_1_array_crystal_array_8_mask_setting[16384];
MCNUM mccchannel_19_analyzer_1_array_crystal_array_8_number_of_activations;

/* Setting parameters for component 'channel_19_analyzer_2_array_crystal_array_0' [863]. */
char mccchannel_19_analyzer_2_array_crystal_array_0_material_string[16384];
MCNUM mccchannel_19_analyzer_2_array_crystal_array_0_priority;
MCNUM mccchannel_19_analyzer_2_array_crystal_array_0_xwidth;
MCNUM mccchannel_19_analyzer_2_array_crystal_array_0_yheight;
MCNUM mccchannel_19_analyzer_2_array_crystal_array_0_zdepth;
MCNUM mccchannel_19_analyzer_2_array_crystal_array_0_xwidth2;
MCNUM mccchannel_19_analyzer_2_array_crystal_array_0_yheight2;
MCNUM mccchannel_19_analyzer_2_array_crystal_array_0_visualize;
int mccchannel_19_analyzer_2_array_crystal_array_0_target_index;
MCNUM mccchannel_19_analyzer_2_array_crystal_array_0_target_x;
MCNUM mccchannel_19_analyzer_2_array_crystal_array_0_target_y;
MCNUM mccchannel_19_analyzer_2_array_crystal_array_0_target_z;
MCNUM mccchannel_19_analyzer_2_array_crystal_array_0_focus_aw;
MCNUM mccchannel_19_analyzer_2_array_crystal_array_0_focus_ah;
MCNUM mccchannel_19_analyzer_2_array_crystal_array_0_focus_xw;
MCNUM mccchannel_19_analyzer_2_array_crystal_array_0_focus_xh;
MCNUM mccchannel_19_analyzer_2_array_crystal_array_0_focus_r;
MCNUM mccchannel_19_analyzer_2_array_crystal_array_0_p_interact;
char mccchannel_19_analyzer_2_array_crystal_array_0_mask_string[16384];
char mccchannel_19_analyzer_2_array_crystal_array_0_mask_setting[16384];
MCNUM mccchannel_19_analyzer_2_array_crystal_array_0_number_of_activations;

/* Setting parameters for component 'channel_19_analyzer_2_array_crystal_array_1' [864]. */
char mccchannel_19_analyzer_2_array_crystal_array_1_material_string[16384];
MCNUM mccchannel_19_analyzer_2_array_crystal_array_1_priority;
MCNUM mccchannel_19_analyzer_2_array_crystal_array_1_xwidth;
MCNUM mccchannel_19_analyzer_2_array_crystal_array_1_yheight;
MCNUM mccchannel_19_analyzer_2_array_crystal_array_1_zdepth;
MCNUM mccchannel_19_analyzer_2_array_crystal_array_1_xwidth2;
MCNUM mccchannel_19_analyzer_2_array_crystal_array_1_yheight2;
MCNUM mccchannel_19_analyzer_2_array_crystal_array_1_visualize;
int mccchannel_19_analyzer_2_array_crystal_array_1_target_index;
MCNUM mccchannel_19_analyzer_2_array_crystal_array_1_target_x;
MCNUM mccchannel_19_analyzer_2_array_crystal_array_1_target_y;
MCNUM mccchannel_19_analyzer_2_array_crystal_array_1_target_z;
MCNUM mccchannel_19_analyzer_2_array_crystal_array_1_focus_aw;
MCNUM mccchannel_19_analyzer_2_array_crystal_array_1_focus_ah;
MCNUM mccchannel_19_analyzer_2_array_crystal_array_1_focus_xw;
MCNUM mccchannel_19_analyzer_2_array_crystal_array_1_focus_xh;
MCNUM mccchannel_19_analyzer_2_array_crystal_array_1_focus_r;
MCNUM mccchannel_19_analyzer_2_array_crystal_array_1_p_interact;
char mccchannel_19_analyzer_2_array_crystal_array_1_mask_string[16384];
char mccchannel_19_analyzer_2_array_crystal_array_1_mask_setting[16384];
MCNUM mccchannel_19_analyzer_2_array_crystal_array_1_number_of_activations;

/* Setting parameters for component 'channel_19_analyzer_2_array_crystal_array_2' [865]. */
char mccchannel_19_analyzer_2_array_crystal_array_2_material_string[16384];
MCNUM mccchannel_19_analyzer_2_array_crystal_array_2_priority;
MCNUM mccchannel_19_analyzer_2_array_crystal_array_2_xwidth;
MCNUM mccchannel_19_analyzer_2_array_crystal_array_2_yheight;
MCNUM mccchannel_19_analyzer_2_array_crystal_array_2_zdepth;
MCNUM mccchannel_19_analyzer_2_array_crystal_array_2_xwidth2;
MCNUM mccchannel_19_analyzer_2_array_crystal_array_2_yheight2;
MCNUM mccchannel_19_analyzer_2_array_crystal_array_2_visualize;
int mccchannel_19_analyzer_2_array_crystal_array_2_target_index;
MCNUM mccchannel_19_analyzer_2_array_crystal_array_2_target_x;
MCNUM mccchannel_19_analyzer_2_array_crystal_array_2_target_y;
MCNUM mccchannel_19_analyzer_2_array_crystal_array_2_target_z;
MCNUM mccchannel_19_analyzer_2_array_crystal_array_2_focus_aw;
MCNUM mccchannel_19_analyzer_2_array_crystal_array_2_focus_ah;
MCNUM mccchannel_19_analyzer_2_array_crystal_array_2_focus_xw;
MCNUM mccchannel_19_analyzer_2_array_crystal_array_2_focus_xh;
MCNUM mccchannel_19_analyzer_2_array_crystal_array_2_focus_r;
MCNUM mccchannel_19_analyzer_2_array_crystal_array_2_p_interact;
char mccchannel_19_analyzer_2_array_crystal_array_2_mask_string[16384];
char mccchannel_19_analyzer_2_array_crystal_array_2_mask_setting[16384];
MCNUM mccchannel_19_analyzer_2_array_crystal_array_2_number_of_activations;

/* Setting parameters for component 'channel_19_analyzer_2_array_crystal_array_3' [866]. */
char mccchannel_19_analyzer_2_array_crystal_array_3_material_string[16384];
MCNUM mccchannel_19_analyzer_2_array_crystal_array_3_priority;
MCNUM mccchannel_19_analyzer_2_array_crystal_array_3_xwidth;
MCNUM mccchannel_19_analyzer_2_array_crystal_array_3_yheight;
MCNUM mccchannel_19_analyzer_2_array_crystal_array_3_zdepth;
MCNUM mccchannel_19_analyzer_2_array_crystal_array_3_xwidth2;
MCNUM mccchannel_19_analyzer_2_array_crystal_array_3_yheight2;
MCNUM mccchannel_19_analyzer_2_array_crystal_array_3_visualize;
int mccchannel_19_analyzer_2_array_crystal_array_3_target_index;
MCNUM mccchannel_19_analyzer_2_array_crystal_array_3_target_x;
MCNUM mccchannel_19_analyzer_2_array_crystal_array_3_target_y;
MCNUM mccchannel_19_analyzer_2_array_crystal_array_3_target_z;
MCNUM mccchannel_19_analyzer_2_array_crystal_array_3_focus_aw;
MCNUM mccchannel_19_analyzer_2_array_crystal_array_3_focus_ah;
MCNUM mccchannel_19_analyzer_2_array_crystal_array_3_focus_xw;
MCNUM mccchannel_19_analyzer_2_array_crystal_array_3_focus_xh;
MCNUM mccchannel_19_analyzer_2_array_crystal_array_3_focus_r;
MCNUM mccchannel_19_analyzer_2_array_crystal_array_3_p_interact;
char mccchannel_19_analyzer_2_array_crystal_array_3_mask_string[16384];
char mccchannel_19_analyzer_2_array_crystal_array_3_mask_setting[16384];
MCNUM mccchannel_19_analyzer_2_array_crystal_array_3_number_of_activations;

/* Setting parameters for component 'channel_19_analyzer_2_array_crystal_array_4' [867]. */
char mccchannel_19_analyzer_2_array_crystal_array_4_material_string[16384];
MCNUM mccchannel_19_analyzer_2_array_crystal_array_4_priority;
MCNUM mccchannel_19_analyzer_2_array_crystal_array_4_xwidth;
MCNUM mccchannel_19_analyzer_2_array_crystal_array_4_yheight;
MCNUM mccchannel_19_analyzer_2_array_crystal_array_4_zdepth;
MCNUM mccchannel_19_analyzer_2_array_crystal_array_4_xwidth2;
MCNUM mccchannel_19_analyzer_2_array_crystal_array_4_yheight2;
MCNUM mccchannel_19_analyzer_2_array_crystal_array_4_visualize;
int mccchannel_19_analyzer_2_array_crystal_array_4_target_index;
MCNUM mccchannel_19_analyzer_2_array_crystal_array_4_target_x;
MCNUM mccchannel_19_analyzer_2_array_crystal_array_4_target_y;
MCNUM mccchannel_19_analyzer_2_array_crystal_array_4_target_z;
MCNUM mccchannel_19_analyzer_2_array_crystal_array_4_focus_aw;
MCNUM mccchannel_19_analyzer_2_array_crystal_array_4_focus_ah;
MCNUM mccchannel_19_analyzer_2_array_crystal_array_4_focus_xw;
MCNUM mccchannel_19_analyzer_2_array_crystal_array_4_focus_xh;
MCNUM mccchannel_19_analyzer_2_array_crystal_array_4_focus_r;
MCNUM mccchannel_19_analyzer_2_array_crystal_array_4_p_interact;
char mccchannel_19_analyzer_2_array_crystal_array_4_mask_string[16384];
char mccchannel_19_analyzer_2_array_crystal_array_4_mask_setting[16384];
MCNUM mccchannel_19_analyzer_2_array_crystal_array_4_number_of_activations;

/* Setting parameters for component 'channel_19_analyzer_2_array_crystal_array_5' [868]. */
char mccchannel_19_analyzer_2_array_crystal_array_5_material_string[16384];
MCNUM mccchannel_19_analyzer_2_array_crystal_array_5_priority;
MCNUM mccchannel_19_analyzer_2_array_crystal_array_5_xwidth;
MCNUM mccchannel_19_analyzer_2_array_crystal_array_5_yheight;
MCNUM mccchannel_19_analyzer_2_array_crystal_array_5_zdepth;
MCNUM mccchannel_19_analyzer_2_array_crystal_array_5_xwidth2;
MCNUM mccchannel_19_analyzer_2_array_crystal_array_5_yheight2;
MCNUM mccchannel_19_analyzer_2_array_crystal_array_5_visualize;
int mccchannel_19_analyzer_2_array_crystal_array_5_target_index;
MCNUM mccchannel_19_analyzer_2_array_crystal_array_5_target_x;
MCNUM mccchannel_19_analyzer_2_array_crystal_array_5_target_y;
MCNUM mccchannel_19_analyzer_2_array_crystal_array_5_target_z;
MCNUM mccchannel_19_analyzer_2_array_crystal_array_5_focus_aw;
MCNUM mccchannel_19_analyzer_2_array_crystal_array_5_focus_ah;
MCNUM mccchannel_19_analyzer_2_array_crystal_array_5_focus_xw;
MCNUM mccchannel_19_analyzer_2_array_crystal_array_5_focus_xh;
MCNUM mccchannel_19_analyzer_2_array_crystal_array_5_focus_r;
MCNUM mccchannel_19_analyzer_2_array_crystal_array_5_p_interact;
char mccchannel_19_analyzer_2_array_crystal_array_5_mask_string[16384];
char mccchannel_19_analyzer_2_array_crystal_array_5_mask_setting[16384];
MCNUM mccchannel_19_analyzer_2_array_crystal_array_5_number_of_activations;

/* Setting parameters for component 'channel_19_analyzer_2_array_crystal_array_6' [869]. */
char mccchannel_19_analyzer_2_array_crystal_array_6_material_string[16384];
MCNUM mccchannel_19_analyzer_2_array_crystal_array_6_priority;
MCNUM mccchannel_19_analyzer_2_array_crystal_array_6_xwidth;
MCNUM mccchannel_19_analyzer_2_array_crystal_array_6_yheight;
MCNUM mccchannel_19_analyzer_2_array_crystal_array_6_zdepth;
MCNUM mccchannel_19_analyzer_2_array_crystal_array_6_xwidth2;
MCNUM mccchannel_19_analyzer_2_array_crystal_array_6_yheight2;
MCNUM mccchannel_19_analyzer_2_array_crystal_array_6_visualize;
int mccchannel_19_analyzer_2_array_crystal_array_6_target_index;
MCNUM mccchannel_19_analyzer_2_array_crystal_array_6_target_x;
MCNUM mccchannel_19_analyzer_2_array_crystal_array_6_target_y;
MCNUM mccchannel_19_analyzer_2_array_crystal_array_6_target_z;
MCNUM mccchannel_19_analyzer_2_array_crystal_array_6_focus_aw;
MCNUM mccchannel_19_analyzer_2_array_crystal_array_6_focus_ah;
MCNUM mccchannel_19_analyzer_2_array_crystal_array_6_focus_xw;
MCNUM mccchannel_19_analyzer_2_array_crystal_array_6_focus_xh;
MCNUM mccchannel_19_analyzer_2_array_crystal_array_6_focus_r;
MCNUM mccchannel_19_analyzer_2_array_crystal_array_6_p_interact;
char mccchannel_19_analyzer_2_array_crystal_array_6_mask_string[16384];
char mccchannel_19_analyzer_2_array_crystal_array_6_mask_setting[16384];
MCNUM mccchannel_19_analyzer_2_array_crystal_array_6_number_of_activations;

/* Setting parameters for component 'channel_19_analyzer_2_array_crystal_array_7' [870]. */
char mccchannel_19_analyzer_2_array_crystal_array_7_material_string[16384];
MCNUM mccchannel_19_analyzer_2_array_crystal_array_7_priority;
MCNUM mccchannel_19_analyzer_2_array_crystal_array_7_xwidth;
MCNUM mccchannel_19_analyzer_2_array_crystal_array_7_yheight;
MCNUM mccchannel_19_analyzer_2_array_crystal_array_7_zdepth;
MCNUM mccchannel_19_analyzer_2_array_crystal_array_7_xwidth2;
MCNUM mccchannel_19_analyzer_2_array_crystal_array_7_yheight2;
MCNUM mccchannel_19_analyzer_2_array_crystal_array_7_visualize;
int mccchannel_19_analyzer_2_array_crystal_array_7_target_index;
MCNUM mccchannel_19_analyzer_2_array_crystal_array_7_target_x;
MCNUM mccchannel_19_analyzer_2_array_crystal_array_7_target_y;
MCNUM mccchannel_19_analyzer_2_array_crystal_array_7_target_z;
MCNUM mccchannel_19_analyzer_2_array_crystal_array_7_focus_aw;
MCNUM mccchannel_19_analyzer_2_array_crystal_array_7_focus_ah;
MCNUM mccchannel_19_analyzer_2_array_crystal_array_7_focus_xw;
MCNUM mccchannel_19_analyzer_2_array_crystal_array_7_focus_xh;
MCNUM mccchannel_19_analyzer_2_array_crystal_array_7_focus_r;
MCNUM mccchannel_19_analyzer_2_array_crystal_array_7_p_interact;
char mccchannel_19_analyzer_2_array_crystal_array_7_mask_string[16384];
char mccchannel_19_analyzer_2_array_crystal_array_7_mask_setting[16384];
MCNUM mccchannel_19_analyzer_2_array_crystal_array_7_number_of_activations;

/* Setting parameters for component 'channel_19_analyzer_2_array_crystal_array_8' [871]. */
char mccchannel_19_analyzer_2_array_crystal_array_8_material_string[16384];
MCNUM mccchannel_19_analyzer_2_array_crystal_array_8_priority;
MCNUM mccchannel_19_analyzer_2_array_crystal_array_8_xwidth;
MCNUM mccchannel_19_analyzer_2_array_crystal_array_8_yheight;
MCNUM mccchannel_19_analyzer_2_array_crystal_array_8_zdepth;
MCNUM mccchannel_19_analyzer_2_array_crystal_array_8_xwidth2;
MCNUM mccchannel_19_analyzer_2_array_crystal_array_8_yheight2;
MCNUM mccchannel_19_analyzer_2_array_crystal_array_8_visualize;
int mccchannel_19_analyzer_2_array_crystal_array_8_target_index;
MCNUM mccchannel_19_analyzer_2_array_crystal_array_8_target_x;
MCNUM mccchannel_19_analyzer_2_array_crystal_array_8_target_y;
MCNUM mccchannel_19_analyzer_2_array_crystal_array_8_target_z;
MCNUM mccchannel_19_analyzer_2_array_crystal_array_8_focus_aw;
MCNUM mccchannel_19_analyzer_2_array_crystal_array_8_focus_ah;
MCNUM mccchannel_19_analyzer_2_array_crystal_array_8_focus_xw;
MCNUM mccchannel_19_analyzer_2_array_crystal_array_8_focus_xh;
MCNUM mccchannel_19_analyzer_2_array_crystal_array_8_focus_r;
MCNUM mccchannel_19_analyzer_2_array_crystal_array_8_p_interact;
char mccchannel_19_analyzer_2_array_crystal_array_8_mask_string[16384];
char mccchannel_19_analyzer_2_array_crystal_array_8_mask_setting[16384];
MCNUM mccchannel_19_analyzer_2_array_crystal_array_8_number_of_activations;

/* Setting parameters for component 'channel_19_cave2_cyl1' [872]. */
char mccchannel_19_cave2_cyl1_material_string[16384];
MCNUM mccchannel_19_cave2_cyl1_priority;
MCNUM mccchannel_19_cave2_cyl1_radius;
MCNUM mccchannel_19_cave2_cyl1_yheight;
MCNUM mccchannel_19_cave2_cyl1_visualize;
int mccchannel_19_cave2_cyl1_target_index;
MCNUM mccchannel_19_cave2_cyl1_target_x;
MCNUM mccchannel_19_cave2_cyl1_target_y;
MCNUM mccchannel_19_cave2_cyl1_target_z;
MCNUM mccchannel_19_cave2_cyl1_focus_aw;
MCNUM mccchannel_19_cave2_cyl1_focus_ah;
MCNUM mccchannel_19_cave2_cyl1_focus_xw;
MCNUM mccchannel_19_cave2_cyl1_focus_xh;
MCNUM mccchannel_19_cave2_cyl1_focus_r;
MCNUM mccchannel_19_cave2_cyl1_p_interact;
char mccchannel_19_cave2_cyl1_mask_string[16384];
char mccchannel_19_cave2_cyl1_mask_setting[16384];
MCNUM mccchannel_19_cave2_cyl1_number_of_activations;

/* Setting parameters for component 'channel_19_cave2_box1' [873]. */
char mccchannel_19_cave2_box1_material_string[16384];
MCNUM mccchannel_19_cave2_box1_priority;
MCNUM mccchannel_19_cave2_box1_xwidth;
MCNUM mccchannel_19_cave2_box1_yheight;
MCNUM mccchannel_19_cave2_box1_zdepth;
MCNUM mccchannel_19_cave2_box1_xwidth2;
MCNUM mccchannel_19_cave2_box1_yheight2;
MCNUM mccchannel_19_cave2_box1_visualize;
int mccchannel_19_cave2_box1_target_index;
MCNUM mccchannel_19_cave2_box1_target_x;
MCNUM mccchannel_19_cave2_box1_target_y;
MCNUM mccchannel_19_cave2_box1_target_z;
MCNUM mccchannel_19_cave2_box1_focus_aw;
MCNUM mccchannel_19_cave2_box1_focus_ah;
MCNUM mccchannel_19_cave2_box1_focus_xw;
MCNUM mccchannel_19_cave2_box1_focus_xh;
MCNUM mccchannel_19_cave2_box1_focus_r;
MCNUM mccchannel_19_cave2_box1_p_interact;
char mccchannel_19_cave2_box1_mask_string[16384];
char mccchannel_19_cave2_box1_mask_setting[16384];
MCNUM mccchannel_19_cave2_box1_number_of_activations;

/* Setting parameters for component 'channel_19_cave2_box2' [874]. */
char mccchannel_19_cave2_box2_material_string[16384];
MCNUM mccchannel_19_cave2_box2_priority;
MCNUM mccchannel_19_cave2_box2_xwidth;
MCNUM mccchannel_19_cave2_box2_yheight;
MCNUM mccchannel_19_cave2_box2_zdepth;
MCNUM mccchannel_19_cave2_box2_xwidth2;
MCNUM mccchannel_19_cave2_box2_yheight2;
MCNUM mccchannel_19_cave2_box2_visualize;
int mccchannel_19_cave2_box2_target_index;
MCNUM mccchannel_19_cave2_box2_target_x;
MCNUM mccchannel_19_cave2_box2_target_y;
MCNUM mccchannel_19_cave2_box2_target_z;
MCNUM mccchannel_19_cave2_box2_focus_aw;
MCNUM mccchannel_19_cave2_box2_focus_ah;
MCNUM mccchannel_19_cave2_box2_focus_xw;
MCNUM mccchannel_19_cave2_box2_focus_xh;
MCNUM mccchannel_19_cave2_box2_focus_r;
MCNUM mccchannel_19_cave2_box2_p_interact;
char mccchannel_19_cave2_box2_mask_string[16384];
char mccchannel_19_cave2_box2_mask_setting[16384];
MCNUM mccchannel_19_cave2_box2_number_of_activations;

/* Setting parameters for component 'channel_19_cave2_box3' [875]. */
char mccchannel_19_cave2_box3_material_string[16384];
MCNUM mccchannel_19_cave2_box3_priority;
MCNUM mccchannel_19_cave2_box3_xwidth;
MCNUM mccchannel_19_cave2_box3_yheight;
MCNUM mccchannel_19_cave2_box3_zdepth;
MCNUM mccchannel_19_cave2_box3_xwidth2;
MCNUM mccchannel_19_cave2_box3_yheight2;
MCNUM mccchannel_19_cave2_box3_visualize;
int mccchannel_19_cave2_box3_target_index;
MCNUM mccchannel_19_cave2_box3_target_x;
MCNUM mccchannel_19_cave2_box3_target_y;
MCNUM mccchannel_19_cave2_box3_target_z;
MCNUM mccchannel_19_cave2_box3_focus_aw;
MCNUM mccchannel_19_cave2_box3_focus_ah;
MCNUM mccchannel_19_cave2_box3_focus_xw;
MCNUM mccchannel_19_cave2_box3_focus_xh;
MCNUM mccchannel_19_cave2_box3_focus_r;
MCNUM mccchannel_19_cave2_box3_p_interact;
char mccchannel_19_cave2_box3_mask_string[16384];
char mccchannel_19_cave2_box3_mask_setting[16384];
MCNUM mccchannel_19_cave2_box3_number_of_activations;

/* Setting parameters for component 'inter_analyzer_colimator_19_blade_0' [877]. */
char mccinter_analyzer_colimator_19_blade_0_material_string[16384];
MCNUM mccinter_analyzer_colimator_19_blade_0_priority;
MCNUM mccinter_analyzer_colimator_19_blade_0_xwidth;
MCNUM mccinter_analyzer_colimator_19_blade_0_yheight;
MCNUM mccinter_analyzer_colimator_19_blade_0_zdepth;
MCNUM mccinter_analyzer_colimator_19_blade_0_xwidth2;
MCNUM mccinter_analyzer_colimator_19_blade_0_yheight2;
MCNUM mccinter_analyzer_colimator_19_blade_0_visualize;
int mccinter_analyzer_colimator_19_blade_0_target_index;
MCNUM mccinter_analyzer_colimator_19_blade_0_target_x;
MCNUM mccinter_analyzer_colimator_19_blade_0_target_y;
MCNUM mccinter_analyzer_colimator_19_blade_0_target_z;
MCNUM mccinter_analyzer_colimator_19_blade_0_focus_aw;
MCNUM mccinter_analyzer_colimator_19_blade_0_focus_ah;
MCNUM mccinter_analyzer_colimator_19_blade_0_focus_xw;
MCNUM mccinter_analyzer_colimator_19_blade_0_focus_xh;
MCNUM mccinter_analyzer_colimator_19_blade_0_focus_r;
MCNUM mccinter_analyzer_colimator_19_blade_0_p_interact;
char mccinter_analyzer_colimator_19_blade_0_mask_string[16384];
char mccinter_analyzer_colimator_19_blade_0_mask_setting[16384];
MCNUM mccinter_analyzer_colimator_19_blade_0_number_of_activations;

/* Setting parameters for component 'inter_analyzer_colimator_19_blade_1' [878]. */
char mccinter_analyzer_colimator_19_blade_1_material_string[16384];
MCNUM mccinter_analyzer_colimator_19_blade_1_priority;
MCNUM mccinter_analyzer_colimator_19_blade_1_xwidth;
MCNUM mccinter_analyzer_colimator_19_blade_1_yheight;
MCNUM mccinter_analyzer_colimator_19_blade_1_zdepth;
MCNUM mccinter_analyzer_colimator_19_blade_1_xwidth2;
MCNUM mccinter_analyzer_colimator_19_blade_1_yheight2;
MCNUM mccinter_analyzer_colimator_19_blade_1_visualize;
int mccinter_analyzer_colimator_19_blade_1_target_index;
MCNUM mccinter_analyzer_colimator_19_blade_1_target_x;
MCNUM mccinter_analyzer_colimator_19_blade_1_target_y;
MCNUM mccinter_analyzer_colimator_19_blade_1_target_z;
MCNUM mccinter_analyzer_colimator_19_blade_1_focus_aw;
MCNUM mccinter_analyzer_colimator_19_blade_1_focus_ah;
MCNUM mccinter_analyzer_colimator_19_blade_1_focus_xw;
MCNUM mccinter_analyzer_colimator_19_blade_1_focus_xh;
MCNUM mccinter_analyzer_colimator_19_blade_1_focus_r;
MCNUM mccinter_analyzer_colimator_19_blade_1_p_interact;
char mccinter_analyzer_colimator_19_blade_1_mask_string[16384];
char mccinter_analyzer_colimator_19_blade_1_mask_setting[16384];
MCNUM mccinter_analyzer_colimator_19_blade_1_number_of_activations;

/* Setting parameters for component 'inter_analyzer_colimator_19_blade_2' [879]. */
char mccinter_analyzer_colimator_19_blade_2_material_string[16384];
MCNUM mccinter_analyzer_colimator_19_blade_2_priority;
MCNUM mccinter_analyzer_colimator_19_blade_2_xwidth;
MCNUM mccinter_analyzer_colimator_19_blade_2_yheight;
MCNUM mccinter_analyzer_colimator_19_blade_2_zdepth;
MCNUM mccinter_analyzer_colimator_19_blade_2_xwidth2;
MCNUM mccinter_analyzer_colimator_19_blade_2_yheight2;
MCNUM mccinter_analyzer_colimator_19_blade_2_visualize;
int mccinter_analyzer_colimator_19_blade_2_target_index;
MCNUM mccinter_analyzer_colimator_19_blade_2_target_x;
MCNUM mccinter_analyzer_colimator_19_blade_2_target_y;
MCNUM mccinter_analyzer_colimator_19_blade_2_target_z;
MCNUM mccinter_analyzer_colimator_19_blade_2_focus_aw;
MCNUM mccinter_analyzer_colimator_19_blade_2_focus_ah;
MCNUM mccinter_analyzer_colimator_19_blade_2_focus_xw;
MCNUM mccinter_analyzer_colimator_19_blade_2_focus_xh;
MCNUM mccinter_analyzer_colimator_19_blade_2_focus_r;
MCNUM mccinter_analyzer_colimator_19_blade_2_p_interact;
char mccinter_analyzer_colimator_19_blade_2_mask_string[16384];
char mccinter_analyzer_colimator_19_blade_2_mask_setting[16384];
MCNUM mccinter_analyzer_colimator_19_blade_2_number_of_activations;

/* Setting parameters for component 'inter_analyzer_colimator_19_blade_3' [880]. */
char mccinter_analyzer_colimator_19_blade_3_material_string[16384];
MCNUM mccinter_analyzer_colimator_19_blade_3_priority;
MCNUM mccinter_analyzer_colimator_19_blade_3_xwidth;
MCNUM mccinter_analyzer_colimator_19_blade_3_yheight;
MCNUM mccinter_analyzer_colimator_19_blade_3_zdepth;
MCNUM mccinter_analyzer_colimator_19_blade_3_xwidth2;
MCNUM mccinter_analyzer_colimator_19_blade_3_yheight2;
MCNUM mccinter_analyzer_colimator_19_blade_3_visualize;
int mccinter_analyzer_colimator_19_blade_3_target_index;
MCNUM mccinter_analyzer_colimator_19_blade_3_target_x;
MCNUM mccinter_analyzer_colimator_19_blade_3_target_y;
MCNUM mccinter_analyzer_colimator_19_blade_3_target_z;
MCNUM mccinter_analyzer_colimator_19_blade_3_focus_aw;
MCNUM mccinter_analyzer_colimator_19_blade_3_focus_ah;
MCNUM mccinter_analyzer_colimator_19_blade_3_focus_xw;
MCNUM mccinter_analyzer_colimator_19_blade_3_focus_xh;
MCNUM mccinter_analyzer_colimator_19_blade_3_focus_r;
MCNUM mccinter_analyzer_colimator_19_blade_3_p_interact;
char mccinter_analyzer_colimator_19_blade_3_mask_string[16384];
char mccinter_analyzer_colimator_19_blade_3_mask_setting[16384];
MCNUM mccinter_analyzer_colimator_19_blade_3_number_of_activations;

/* Setting parameters for component 'inter_analyzer_colimator_19_blade_4' [881]. */
char mccinter_analyzer_colimator_19_blade_4_material_string[16384];
MCNUM mccinter_analyzer_colimator_19_blade_4_priority;
MCNUM mccinter_analyzer_colimator_19_blade_4_xwidth;
MCNUM mccinter_analyzer_colimator_19_blade_4_yheight;
MCNUM mccinter_analyzer_colimator_19_blade_4_zdepth;
MCNUM mccinter_analyzer_colimator_19_blade_4_xwidth2;
MCNUM mccinter_analyzer_colimator_19_blade_4_yheight2;
MCNUM mccinter_analyzer_colimator_19_blade_4_visualize;
int mccinter_analyzer_colimator_19_blade_4_target_index;
MCNUM mccinter_analyzer_colimator_19_blade_4_target_x;
MCNUM mccinter_analyzer_colimator_19_blade_4_target_y;
MCNUM mccinter_analyzer_colimator_19_blade_4_target_z;
MCNUM mccinter_analyzer_colimator_19_blade_4_focus_aw;
MCNUM mccinter_analyzer_colimator_19_blade_4_focus_ah;
MCNUM mccinter_analyzer_colimator_19_blade_4_focus_xw;
MCNUM mccinter_analyzer_colimator_19_blade_4_focus_xh;
MCNUM mccinter_analyzer_colimator_19_blade_4_focus_r;
MCNUM mccinter_analyzer_colimator_19_blade_4_p_interact;
char mccinter_analyzer_colimator_19_blade_4_mask_string[16384];
char mccinter_analyzer_colimator_19_blade_4_mask_setting[16384];
MCNUM mccinter_analyzer_colimator_19_blade_4_number_of_activations;

/* Setting parameters for component 'diffraction_detector_19_exit_volume' [882]. */
char mccdiffraction_detector_19_exit_volume_material_string[16384];
MCNUM mccdiffraction_detector_19_exit_volume_priority;
MCNUM mccdiffraction_detector_19_exit_volume_xwidth;
MCNUM mccdiffraction_detector_19_exit_volume_yheight;
MCNUM mccdiffraction_detector_19_exit_volume_zdepth;
MCNUM mccdiffraction_detector_19_exit_volume_xwidth2;
MCNUM mccdiffraction_detector_19_exit_volume_yheight2;
MCNUM mccdiffraction_detector_19_exit_volume_visualize;
int mccdiffraction_detector_19_exit_volume_target_index;
MCNUM mccdiffraction_detector_19_exit_volume_target_x;
MCNUM mccdiffraction_detector_19_exit_volume_target_y;
MCNUM mccdiffraction_detector_19_exit_volume_target_z;
MCNUM mccdiffraction_detector_19_exit_volume_focus_aw;
MCNUM mccdiffraction_detector_19_exit_volume_focus_ah;
MCNUM mccdiffraction_detector_19_exit_volume_focus_xw;
MCNUM mccdiffraction_detector_19_exit_volume_focus_xh;
MCNUM mccdiffraction_detector_19_exit_volume_focus_r;
MCNUM mccdiffraction_detector_19_exit_volume_p_interact;
char mccdiffraction_detector_19_exit_volume_mask_string[16384];
char mccdiffraction_detector_19_exit_volume_mask_setting[16384];
MCNUM mccdiffraction_detector_19_exit_volume_number_of_activations;

/* Setting parameters for component 'spec_detector_19_exit_volume' [883]. */
char mccspec_detector_19_exit_volume_material_string[16384];
MCNUM mccspec_detector_19_exit_volume_priority;
MCNUM mccspec_detector_19_exit_volume_xwidth;
MCNUM mccspec_detector_19_exit_volume_yheight;
MCNUM mccspec_detector_19_exit_volume_zdepth;
MCNUM mccspec_detector_19_exit_volume_xwidth2;
MCNUM mccspec_detector_19_exit_volume_yheight2;
MCNUM mccspec_detector_19_exit_volume_visualize;
int mccspec_detector_19_exit_volume_target_index;
MCNUM mccspec_detector_19_exit_volume_target_x;
MCNUM mccspec_detector_19_exit_volume_target_y;
MCNUM mccspec_detector_19_exit_volume_target_z;
MCNUM mccspec_detector_19_exit_volume_focus_aw;
MCNUM mccspec_detector_19_exit_volume_focus_ah;
MCNUM mccspec_detector_19_exit_volume_focus_xw;
MCNUM mccspec_detector_19_exit_volume_focus_xh;
MCNUM mccspec_detector_19_exit_volume_focus_r;
MCNUM mccspec_detector_19_exit_volume_p_interact;
char mccspec_detector_19_exit_volume_mask_string[16384];
char mccspec_detector_19_exit_volume_mask_setting[16384];
MCNUM mccspec_detector_19_exit_volume_number_of_activations;

/* Setting parameters for component 'kidney_union_master' [884]. */
MCNUM mcckidney_union_master_allow_inside_start;
MCNUM mcckidney_union_master_history_limit;
MCNUM mcckidney_union_master_enable_conditionals;
MCNUM mcckidney_union_master_inherit_number_of_scattering_events;

/* Setting parameters for component 'diffraction_detector_0' [885]. */
int mccdiffraction_detector_0_nx;
int mccdiffraction_detector_0_ny;
char mccdiffraction_detector_0_filename[16384];
MCNUM mccdiffraction_detector_0_xmin;
MCNUM mccdiffraction_detector_0_xmax;
MCNUM mccdiffraction_detector_0_ymin;
MCNUM mccdiffraction_detector_0_ymax;
MCNUM mccdiffraction_detector_0_xwidth;
MCNUM mccdiffraction_detector_0_yheight;
MCNUM mccdiffraction_detector_0_restore_neutron;

/* Setting parameters for component 'spec_detector_0' [886]. */
int mccspec_detector_0_nx;
int mccspec_detector_0_ny;
char mccspec_detector_0_filename[16384];
MCNUM mccspec_detector_0_xmin;
MCNUM mccspec_detector_0_xmax;
MCNUM mccspec_detector_0_ymin;
MCNUM mccspec_detector_0_ymax;
MCNUM mccspec_detector_0_xwidth;
MCNUM mccspec_detector_0_yheight;
MCNUM mccspec_detector_0_restore_neutron;

/* Setting parameters for component 'diffraction_detector_1' [887]. */
int mccdiffraction_detector_1_nx;
int mccdiffraction_detector_1_ny;
char mccdiffraction_detector_1_filename[16384];
MCNUM mccdiffraction_detector_1_xmin;
MCNUM mccdiffraction_detector_1_xmax;
MCNUM mccdiffraction_detector_1_ymin;
MCNUM mccdiffraction_detector_1_ymax;
MCNUM mccdiffraction_detector_1_xwidth;
MCNUM mccdiffraction_detector_1_yheight;
MCNUM mccdiffraction_detector_1_restore_neutron;

/* Setting parameters for component 'spec_detector_1' [888]. */
int mccspec_detector_1_nx;
int mccspec_detector_1_ny;
char mccspec_detector_1_filename[16384];
MCNUM mccspec_detector_1_xmin;
MCNUM mccspec_detector_1_xmax;
MCNUM mccspec_detector_1_ymin;
MCNUM mccspec_detector_1_ymax;
MCNUM mccspec_detector_1_xwidth;
MCNUM mccspec_detector_1_yheight;
MCNUM mccspec_detector_1_restore_neutron;

/* Setting parameters for component 'diffraction_detector_2' [889]. */
int mccdiffraction_detector_2_nx;
int mccdiffraction_detector_2_ny;
char mccdiffraction_detector_2_filename[16384];
MCNUM mccdiffraction_detector_2_xmin;
MCNUM mccdiffraction_detector_2_xmax;
MCNUM mccdiffraction_detector_2_ymin;
MCNUM mccdiffraction_detector_2_ymax;
MCNUM mccdiffraction_detector_2_xwidth;
MCNUM mccdiffraction_detector_2_yheight;
MCNUM mccdiffraction_detector_2_restore_neutron;

/* Setting parameters for component 'spec_detector_2' [890]. */
int mccspec_detector_2_nx;
int mccspec_detector_2_ny;
char mccspec_detector_2_filename[16384];
MCNUM mccspec_detector_2_xmin;
MCNUM mccspec_detector_2_xmax;
MCNUM mccspec_detector_2_ymin;
MCNUM mccspec_detector_2_ymax;
MCNUM mccspec_detector_2_xwidth;
MCNUM mccspec_detector_2_yheight;
MCNUM mccspec_detector_2_restore_neutron;

/* Setting parameters for component 'diffraction_detector_3' [891]. */
int mccdiffraction_detector_3_nx;
int mccdiffraction_detector_3_ny;
char mccdiffraction_detector_3_filename[16384];
MCNUM mccdiffraction_detector_3_xmin;
MCNUM mccdiffraction_detector_3_xmax;
MCNUM mccdiffraction_detector_3_ymin;
MCNUM mccdiffraction_detector_3_ymax;
MCNUM mccdiffraction_detector_3_xwidth;
MCNUM mccdiffraction_detector_3_yheight;
MCNUM mccdiffraction_detector_3_restore_neutron;

/* Setting parameters for component 'spec_detector_3' [892]. */
int mccspec_detector_3_nx;
int mccspec_detector_3_ny;
char mccspec_detector_3_filename[16384];
MCNUM mccspec_detector_3_xmin;
MCNUM mccspec_detector_3_xmax;
MCNUM mccspec_detector_3_ymin;
MCNUM mccspec_detector_3_ymax;
MCNUM mccspec_detector_3_xwidth;
MCNUM mccspec_detector_3_yheight;
MCNUM mccspec_detector_3_restore_neutron;

/* Setting parameters for component 'diffraction_detector_4' [893]. */
int mccdiffraction_detector_4_nx;
int mccdiffraction_detector_4_ny;
char mccdiffraction_detector_4_filename[16384];
MCNUM mccdiffraction_detector_4_xmin;
MCNUM mccdiffraction_detector_4_xmax;
MCNUM mccdiffraction_detector_4_ymin;
MCNUM mccdiffraction_detector_4_ymax;
MCNUM mccdiffraction_detector_4_xwidth;
MCNUM mccdiffraction_detector_4_yheight;
MCNUM mccdiffraction_detector_4_restore_neutron;

/* Setting parameters for component 'spec_detector_4' [894]. */
int mccspec_detector_4_nx;
int mccspec_detector_4_ny;
char mccspec_detector_4_filename[16384];
MCNUM mccspec_detector_4_xmin;
MCNUM mccspec_detector_4_xmax;
MCNUM mccspec_detector_4_ymin;
MCNUM mccspec_detector_4_ymax;
MCNUM mccspec_detector_4_xwidth;
MCNUM mccspec_detector_4_yheight;
MCNUM mccspec_detector_4_restore_neutron;

/* Setting parameters for component 'diffraction_detector_5' [895]. */
int mccdiffraction_detector_5_nx;
int mccdiffraction_detector_5_ny;
char mccdiffraction_detector_5_filename[16384];
MCNUM mccdiffraction_detector_5_xmin;
MCNUM mccdiffraction_detector_5_xmax;
MCNUM mccdiffraction_detector_5_ymin;
MCNUM mccdiffraction_detector_5_ymax;
MCNUM mccdiffraction_detector_5_xwidth;
MCNUM mccdiffraction_detector_5_yheight;
MCNUM mccdiffraction_detector_5_restore_neutron;

/* Setting parameters for component 'spec_detector_5' [896]. */
int mccspec_detector_5_nx;
int mccspec_detector_5_ny;
char mccspec_detector_5_filename[16384];
MCNUM mccspec_detector_5_xmin;
MCNUM mccspec_detector_5_xmax;
MCNUM mccspec_detector_5_ymin;
MCNUM mccspec_detector_5_ymax;
MCNUM mccspec_detector_5_xwidth;
MCNUM mccspec_detector_5_yheight;
MCNUM mccspec_detector_5_restore_neutron;

/* Setting parameters for component 'diffraction_detector_6' [897]. */
int mccdiffraction_detector_6_nx;
int mccdiffraction_detector_6_ny;
char mccdiffraction_detector_6_filename[16384];
MCNUM mccdiffraction_detector_6_xmin;
MCNUM mccdiffraction_detector_6_xmax;
MCNUM mccdiffraction_detector_6_ymin;
MCNUM mccdiffraction_detector_6_ymax;
MCNUM mccdiffraction_detector_6_xwidth;
MCNUM mccdiffraction_detector_6_yheight;
MCNUM mccdiffraction_detector_6_restore_neutron;

/* Setting parameters for component 'spec_detector_6' [898]. */
int mccspec_detector_6_nx;
int mccspec_detector_6_ny;
char mccspec_detector_6_filename[16384];
MCNUM mccspec_detector_6_xmin;
MCNUM mccspec_detector_6_xmax;
MCNUM mccspec_detector_6_ymin;
MCNUM mccspec_detector_6_ymax;
MCNUM mccspec_detector_6_xwidth;
MCNUM mccspec_detector_6_yheight;
MCNUM mccspec_detector_6_restore_neutron;

/* Setting parameters for component 'diffraction_detector_7' [899]. */
int mccdiffraction_detector_7_nx;
int mccdiffraction_detector_7_ny;
char mccdiffraction_detector_7_filename[16384];
MCNUM mccdiffraction_detector_7_xmin;
MCNUM mccdiffraction_detector_7_xmax;
MCNUM mccdiffraction_detector_7_ymin;
MCNUM mccdiffraction_detector_7_ymax;
MCNUM mccdiffraction_detector_7_xwidth;
MCNUM mccdiffraction_detector_7_yheight;
MCNUM mccdiffraction_detector_7_restore_neutron;

/* Setting parameters for component 'spec_detector_7' [900]. */
int mccspec_detector_7_nx;
int mccspec_detector_7_ny;
char mccspec_detector_7_filename[16384];
MCNUM mccspec_detector_7_xmin;
MCNUM mccspec_detector_7_xmax;
MCNUM mccspec_detector_7_ymin;
MCNUM mccspec_detector_7_ymax;
MCNUM mccspec_detector_7_xwidth;
MCNUM mccspec_detector_7_yheight;
MCNUM mccspec_detector_7_restore_neutron;

/* Setting parameters for component 'diffraction_detector_8' [901]. */
int mccdiffraction_detector_8_nx;
int mccdiffraction_detector_8_ny;
char mccdiffraction_detector_8_filename[16384];
MCNUM mccdiffraction_detector_8_xmin;
MCNUM mccdiffraction_detector_8_xmax;
MCNUM mccdiffraction_detector_8_ymin;
MCNUM mccdiffraction_detector_8_ymax;
MCNUM mccdiffraction_detector_8_xwidth;
MCNUM mccdiffraction_detector_8_yheight;
MCNUM mccdiffraction_detector_8_restore_neutron;

/* Setting parameters for component 'spec_detector_8' [902]. */
int mccspec_detector_8_nx;
int mccspec_detector_8_ny;
char mccspec_detector_8_filename[16384];
MCNUM mccspec_detector_8_xmin;
MCNUM mccspec_detector_8_xmax;
MCNUM mccspec_detector_8_ymin;
MCNUM mccspec_detector_8_ymax;
MCNUM mccspec_detector_8_xwidth;
MCNUM mccspec_detector_8_yheight;
MCNUM mccspec_detector_8_restore_neutron;

/* Setting parameters for component 'diffraction_detector_9' [903]. */
int mccdiffraction_detector_9_nx;
int mccdiffraction_detector_9_ny;
char mccdiffraction_detector_9_filename[16384];
MCNUM mccdiffraction_detector_9_xmin;
MCNUM mccdiffraction_detector_9_xmax;
MCNUM mccdiffraction_detector_9_ymin;
MCNUM mccdiffraction_detector_9_ymax;
MCNUM mccdiffraction_detector_9_xwidth;
MCNUM mccdiffraction_detector_9_yheight;
MCNUM mccdiffraction_detector_9_restore_neutron;

/* Setting parameters for component 'spec_detector_9' [904]. */
int mccspec_detector_9_nx;
int mccspec_detector_9_ny;
char mccspec_detector_9_filename[16384];
MCNUM mccspec_detector_9_xmin;
MCNUM mccspec_detector_9_xmax;
MCNUM mccspec_detector_9_ymin;
MCNUM mccspec_detector_9_ymax;
MCNUM mccspec_detector_9_xwidth;
MCNUM mccspec_detector_9_yheight;
MCNUM mccspec_detector_9_restore_neutron;

/* Setting parameters for component 'diffraction_detector_10' [905]. */
int mccdiffraction_detector_10_nx;
int mccdiffraction_detector_10_ny;
char mccdiffraction_detector_10_filename[16384];
MCNUM mccdiffraction_detector_10_xmin;
MCNUM mccdiffraction_detector_10_xmax;
MCNUM mccdiffraction_detector_10_ymin;
MCNUM mccdiffraction_detector_10_ymax;
MCNUM mccdiffraction_detector_10_xwidth;
MCNUM mccdiffraction_detector_10_yheight;
MCNUM mccdiffraction_detector_10_restore_neutron;

/* Setting parameters for component 'spec_detector_10' [906]. */
int mccspec_detector_10_nx;
int mccspec_detector_10_ny;
char mccspec_detector_10_filename[16384];
MCNUM mccspec_detector_10_xmin;
MCNUM mccspec_detector_10_xmax;
MCNUM mccspec_detector_10_ymin;
MCNUM mccspec_detector_10_ymax;
MCNUM mccspec_detector_10_xwidth;
MCNUM mccspec_detector_10_yheight;
MCNUM mccspec_detector_10_restore_neutron;

/* Setting parameters for component 'diffraction_detector_11' [907]. */
int mccdiffraction_detector_11_nx;
int mccdiffraction_detector_11_ny;
char mccdiffraction_detector_11_filename[16384];
MCNUM mccdiffraction_detector_11_xmin;
MCNUM mccdiffraction_detector_11_xmax;
MCNUM mccdiffraction_detector_11_ymin;
MCNUM mccdiffraction_detector_11_ymax;
MCNUM mccdiffraction_detector_11_xwidth;
MCNUM mccdiffraction_detector_11_yheight;
MCNUM mccdiffraction_detector_11_restore_neutron;

/* Setting parameters for component 'spec_detector_11' [908]. */
int mccspec_detector_11_nx;
int mccspec_detector_11_ny;
char mccspec_detector_11_filename[16384];
MCNUM mccspec_detector_11_xmin;
MCNUM mccspec_detector_11_xmax;
MCNUM mccspec_detector_11_ymin;
MCNUM mccspec_detector_11_ymax;
MCNUM mccspec_detector_11_xwidth;
MCNUM mccspec_detector_11_yheight;
MCNUM mccspec_detector_11_restore_neutron;

/* Setting parameters for component 'diffraction_detector_12' [909]. */
int mccdiffraction_detector_12_nx;
int mccdiffraction_detector_12_ny;
char mccdiffraction_detector_12_filename[16384];
MCNUM mccdiffraction_detector_12_xmin;
MCNUM mccdiffraction_detector_12_xmax;
MCNUM mccdiffraction_detector_12_ymin;
MCNUM mccdiffraction_detector_12_ymax;
MCNUM mccdiffraction_detector_12_xwidth;
MCNUM mccdiffraction_detector_12_yheight;
MCNUM mccdiffraction_detector_12_restore_neutron;

/* Setting parameters for component 'spec_detector_12' [910]. */
int mccspec_detector_12_nx;
int mccspec_detector_12_ny;
char mccspec_detector_12_filename[16384];
MCNUM mccspec_detector_12_xmin;
MCNUM mccspec_detector_12_xmax;
MCNUM mccspec_detector_12_ymin;
MCNUM mccspec_detector_12_ymax;
MCNUM mccspec_detector_12_xwidth;
MCNUM mccspec_detector_12_yheight;
MCNUM mccspec_detector_12_restore_neutron;

/* Setting parameters for component 'diffraction_detector_13' [911]. */
int mccdiffraction_detector_13_nx;
int mccdiffraction_detector_13_ny;
char mccdiffraction_detector_13_filename[16384];
MCNUM mccdiffraction_detector_13_xmin;
MCNUM mccdiffraction_detector_13_xmax;
MCNUM mccdiffraction_detector_13_ymin;
MCNUM mccdiffraction_detector_13_ymax;
MCNUM mccdiffraction_detector_13_xwidth;
MCNUM mccdiffraction_detector_13_yheight;
MCNUM mccdiffraction_detector_13_restore_neutron;

/* Setting parameters for component 'spec_detector_13' [912]. */
int mccspec_detector_13_nx;
int mccspec_detector_13_ny;
char mccspec_detector_13_filename[16384];
MCNUM mccspec_detector_13_xmin;
MCNUM mccspec_detector_13_xmax;
MCNUM mccspec_detector_13_ymin;
MCNUM mccspec_detector_13_ymax;
MCNUM mccspec_detector_13_xwidth;
MCNUM mccspec_detector_13_yheight;
MCNUM mccspec_detector_13_restore_neutron;

/* Setting parameters for component 'diffraction_detector_14' [913]. */
int mccdiffraction_detector_14_nx;
int mccdiffraction_detector_14_ny;
char mccdiffraction_detector_14_filename[16384];
MCNUM mccdiffraction_detector_14_xmin;
MCNUM mccdiffraction_detector_14_xmax;
MCNUM mccdiffraction_detector_14_ymin;
MCNUM mccdiffraction_detector_14_ymax;
MCNUM mccdiffraction_detector_14_xwidth;
MCNUM mccdiffraction_detector_14_yheight;
MCNUM mccdiffraction_detector_14_restore_neutron;

/* Setting parameters for component 'spec_detector_14' [914]. */
int mccspec_detector_14_nx;
int mccspec_detector_14_ny;
char mccspec_detector_14_filename[16384];
MCNUM mccspec_detector_14_xmin;
MCNUM mccspec_detector_14_xmax;
MCNUM mccspec_detector_14_ymin;
MCNUM mccspec_detector_14_ymax;
MCNUM mccspec_detector_14_xwidth;
MCNUM mccspec_detector_14_yheight;
MCNUM mccspec_detector_14_restore_neutron;

/* Setting parameters for component 'diffraction_detector_15' [915]. */
int mccdiffraction_detector_15_nx;
int mccdiffraction_detector_15_ny;
char mccdiffraction_detector_15_filename[16384];
MCNUM mccdiffraction_detector_15_xmin;
MCNUM mccdiffraction_detector_15_xmax;
MCNUM mccdiffraction_detector_15_ymin;
MCNUM mccdiffraction_detector_15_ymax;
MCNUM mccdiffraction_detector_15_xwidth;
MCNUM mccdiffraction_detector_15_yheight;
MCNUM mccdiffraction_detector_15_restore_neutron;

/* Setting parameters for component 'spec_detector_15' [916]. */
int mccspec_detector_15_nx;
int mccspec_detector_15_ny;
char mccspec_detector_15_filename[16384];
MCNUM mccspec_detector_15_xmin;
MCNUM mccspec_detector_15_xmax;
MCNUM mccspec_detector_15_ymin;
MCNUM mccspec_detector_15_ymax;
MCNUM mccspec_detector_15_xwidth;
MCNUM mccspec_detector_15_yheight;
MCNUM mccspec_detector_15_restore_neutron;

/* Setting parameters for component 'diffraction_detector_16' [917]. */
int mccdiffraction_detector_16_nx;
int mccdiffraction_detector_16_ny;
char mccdiffraction_detector_16_filename[16384];
MCNUM mccdiffraction_detector_16_xmin;
MCNUM mccdiffraction_detector_16_xmax;
MCNUM mccdiffraction_detector_16_ymin;
MCNUM mccdiffraction_detector_16_ymax;
MCNUM mccdiffraction_detector_16_xwidth;
MCNUM mccdiffraction_detector_16_yheight;
MCNUM mccdiffraction_detector_16_restore_neutron;

/* Setting parameters for component 'spec_detector_16' [918]. */
int mccspec_detector_16_nx;
int mccspec_detector_16_ny;
char mccspec_detector_16_filename[16384];
MCNUM mccspec_detector_16_xmin;
MCNUM mccspec_detector_16_xmax;
MCNUM mccspec_detector_16_ymin;
MCNUM mccspec_detector_16_ymax;
MCNUM mccspec_detector_16_xwidth;
MCNUM mccspec_detector_16_yheight;
MCNUM mccspec_detector_16_restore_neutron;

/* Setting parameters for component 'diffraction_detector_17' [919]. */
int mccdiffraction_detector_17_nx;
int mccdiffraction_detector_17_ny;
char mccdiffraction_detector_17_filename[16384];
MCNUM mccdiffraction_detector_17_xmin;
MCNUM mccdiffraction_detector_17_xmax;
MCNUM mccdiffraction_detector_17_ymin;
MCNUM mccdiffraction_detector_17_ymax;
MCNUM mccdiffraction_detector_17_xwidth;
MCNUM mccdiffraction_detector_17_yheight;
MCNUM mccdiffraction_detector_17_restore_neutron;

/* Setting parameters for component 'spec_detector_17' [920]. */
int mccspec_detector_17_nx;
int mccspec_detector_17_ny;
char mccspec_detector_17_filename[16384];
MCNUM mccspec_detector_17_xmin;
MCNUM mccspec_detector_17_xmax;
MCNUM mccspec_detector_17_ymin;
MCNUM mccspec_detector_17_ymax;
MCNUM mccspec_detector_17_xwidth;
MCNUM mccspec_detector_17_yheight;
MCNUM mccspec_detector_17_restore_neutron;

/* Setting parameters for component 'diffraction_detector_18' [921]. */
int mccdiffraction_detector_18_nx;
int mccdiffraction_detector_18_ny;
char mccdiffraction_detector_18_filename[16384];
MCNUM mccdiffraction_detector_18_xmin;
MCNUM mccdiffraction_detector_18_xmax;
MCNUM mccdiffraction_detector_18_ymin;
MCNUM mccdiffraction_detector_18_ymax;
MCNUM mccdiffraction_detector_18_xwidth;
MCNUM mccdiffraction_detector_18_yheight;
MCNUM mccdiffraction_detector_18_restore_neutron;

/* Setting parameters for component 'spec_detector_18' [922]. */
int mccspec_detector_18_nx;
int mccspec_detector_18_ny;
char mccspec_detector_18_filename[16384];
MCNUM mccspec_detector_18_xmin;
MCNUM mccspec_detector_18_xmax;
MCNUM mccspec_detector_18_ymin;
MCNUM mccspec_detector_18_ymax;
MCNUM mccspec_detector_18_xwidth;
MCNUM mccspec_detector_18_yheight;
MCNUM mccspec_detector_18_restore_neutron;

/* Setting parameters for component 'diffraction_detector_19' [923]. */
int mccdiffraction_detector_19_nx;
int mccdiffraction_detector_19_ny;
char mccdiffraction_detector_19_filename[16384];
MCNUM mccdiffraction_detector_19_xmin;
MCNUM mccdiffraction_detector_19_xmax;
MCNUM mccdiffraction_detector_19_ymin;
MCNUM mccdiffraction_detector_19_ymax;
MCNUM mccdiffraction_detector_19_xwidth;
MCNUM mccdiffraction_detector_19_yheight;
MCNUM mccdiffraction_detector_19_restore_neutron;

/* Setting parameters for component 'spec_detector_19' [924]. */
int mccspec_detector_19_nx;
int mccspec_detector_19_ny;
char mccspec_detector_19_filename[16384];
MCNUM mccspec_detector_19_xmin;
MCNUM mccspec_detector_19_xmax;
MCNUM mccspec_detector_19_ymin;
MCNUM mccspec_detector_19_ymax;
MCNUM mccspec_detector_19_xwidth;
MCNUM mccspec_detector_19_yheight;
MCNUM mccspec_detector_19_restore_neutron;

/* Definition parameters for component 'spec_detector_history_0' [925]. */
#define mccspec_detector_history_0_nb DOUBLE_MAX_VOLUME_HISTORY_LENGTH
/* Setting parameters for component 'spec_detector_history_0' [925]. */
char mccspec_detector_history_0_filename[16384];
MCNUM mccspec_detector_history_0_xmin;
MCNUM mccspec_detector_history_0_xmax;
MCNUM mccspec_detector_history_0_ymin;
MCNUM mccspec_detector_history_0_ymax;
MCNUM mccspec_detector_history_0_xwidth;
MCNUM mccspec_detector_history_0_yheight;
MCNUM mccspec_detector_history_0_restore_neutron;

/* Definition parameters for component 'spec_detector_history_1' [926]. */
#define mccspec_detector_history_1_nb DOUBLE_MAX_VOLUME_HISTORY_LENGTH
/* Setting parameters for component 'spec_detector_history_1' [926]. */
char mccspec_detector_history_1_filename[16384];
MCNUM mccspec_detector_history_1_xmin;
MCNUM mccspec_detector_history_1_xmax;
MCNUM mccspec_detector_history_1_ymin;
MCNUM mccspec_detector_history_1_ymax;
MCNUM mccspec_detector_history_1_xwidth;
MCNUM mccspec_detector_history_1_yheight;
MCNUM mccspec_detector_history_1_restore_neutron;

/* Definition parameters for component 'spec_detector_history_2' [927]. */
#define mccspec_detector_history_2_nb DOUBLE_MAX_VOLUME_HISTORY_LENGTH
/* Setting parameters for component 'spec_detector_history_2' [927]. */
char mccspec_detector_history_2_filename[16384];
MCNUM mccspec_detector_history_2_xmin;
MCNUM mccspec_detector_history_2_xmax;
MCNUM mccspec_detector_history_2_ymin;
MCNUM mccspec_detector_history_2_ymax;
MCNUM mccspec_detector_history_2_xwidth;
MCNUM mccspec_detector_history_2_yheight;
MCNUM mccspec_detector_history_2_restore_neutron;

/* Definition parameters for component 'spec_detector_history_3' [928]. */
#define mccspec_detector_history_3_nb DOUBLE_MAX_VOLUME_HISTORY_LENGTH
/* Setting parameters for component 'spec_detector_history_3' [928]. */
char mccspec_detector_history_3_filename[16384];
MCNUM mccspec_detector_history_3_xmin;
MCNUM mccspec_detector_history_3_xmax;
MCNUM mccspec_detector_history_3_ymin;
MCNUM mccspec_detector_history_3_ymax;
MCNUM mccspec_detector_history_3_xwidth;
MCNUM mccspec_detector_history_3_yheight;
MCNUM mccspec_detector_history_3_restore_neutron;

/* Definition parameters for component 'spec_detector_history_4' [929]. */
#define mccspec_detector_history_4_nb DOUBLE_MAX_VOLUME_HISTORY_LENGTH
/* Setting parameters for component 'spec_detector_history_4' [929]. */
char mccspec_detector_history_4_filename[16384];
MCNUM mccspec_detector_history_4_xmin;
MCNUM mccspec_detector_history_4_xmax;
MCNUM mccspec_detector_history_4_ymin;
MCNUM mccspec_detector_history_4_ymax;
MCNUM mccspec_detector_history_4_xwidth;
MCNUM mccspec_detector_history_4_yheight;
MCNUM mccspec_detector_history_4_restore_neutron;

/* Definition parameters for component 'spec_detector_history_5' [930]. */
#define mccspec_detector_history_5_nb DOUBLE_MAX_VOLUME_HISTORY_LENGTH
/* Setting parameters for component 'spec_detector_history_5' [930]. */
char mccspec_detector_history_5_filename[16384];
MCNUM mccspec_detector_history_5_xmin;
MCNUM mccspec_detector_history_5_xmax;
MCNUM mccspec_detector_history_5_ymin;
MCNUM mccspec_detector_history_5_ymax;
MCNUM mccspec_detector_history_5_xwidth;
MCNUM mccspec_detector_history_5_yheight;
MCNUM mccspec_detector_history_5_restore_neutron;

/* Definition parameters for component 'spec_detector_history_6' [931]. */
#define mccspec_detector_history_6_nb DOUBLE_MAX_VOLUME_HISTORY_LENGTH
/* Setting parameters for component 'spec_detector_history_6' [931]. */
char mccspec_detector_history_6_filename[16384];
MCNUM mccspec_detector_history_6_xmin;
MCNUM mccspec_detector_history_6_xmax;
MCNUM mccspec_detector_history_6_ymin;
MCNUM mccspec_detector_history_6_ymax;
MCNUM mccspec_detector_history_6_xwidth;
MCNUM mccspec_detector_history_6_yheight;
MCNUM mccspec_detector_history_6_restore_neutron;

/* Definition parameters for component 'spec_detector_history_7' [932]. */
#define mccspec_detector_history_7_nb DOUBLE_MAX_VOLUME_HISTORY_LENGTH
/* Setting parameters for component 'spec_detector_history_7' [932]. */
char mccspec_detector_history_7_filename[16384];
MCNUM mccspec_detector_history_7_xmin;
MCNUM mccspec_detector_history_7_xmax;
MCNUM mccspec_detector_history_7_ymin;
MCNUM mccspec_detector_history_7_ymax;
MCNUM mccspec_detector_history_7_xwidth;
MCNUM mccspec_detector_history_7_yheight;
MCNUM mccspec_detector_history_7_restore_neutron;

/* Definition parameters for component 'spec_detector_history_8' [933]. */
#define mccspec_detector_history_8_nb DOUBLE_MAX_VOLUME_HISTORY_LENGTH
/* Setting parameters for component 'spec_detector_history_8' [933]. */
char mccspec_detector_history_8_filename[16384];
MCNUM mccspec_detector_history_8_xmin;
MCNUM mccspec_detector_history_8_xmax;
MCNUM mccspec_detector_history_8_ymin;
MCNUM mccspec_detector_history_8_ymax;
MCNUM mccspec_detector_history_8_xwidth;
MCNUM mccspec_detector_history_8_yheight;
MCNUM mccspec_detector_history_8_restore_neutron;

/* Definition parameters for component 'spec_detector_history_9' [934]. */
#define mccspec_detector_history_9_nb DOUBLE_MAX_VOLUME_HISTORY_LENGTH
/* Setting parameters for component 'spec_detector_history_9' [934]. */
char mccspec_detector_history_9_filename[16384];
MCNUM mccspec_detector_history_9_xmin;
MCNUM mccspec_detector_history_9_xmax;
MCNUM mccspec_detector_history_9_ymin;
MCNUM mccspec_detector_history_9_ymax;
MCNUM mccspec_detector_history_9_xwidth;
MCNUM mccspec_detector_history_9_yheight;
MCNUM mccspec_detector_history_9_restore_neutron;

/* Definition parameters for component 'spec_detector_history_10' [935]. */
#define mccspec_detector_history_10_nb DOUBLE_MAX_VOLUME_HISTORY_LENGTH
/* Setting parameters for component 'spec_detector_history_10' [935]. */
char mccspec_detector_history_10_filename[16384];
MCNUM mccspec_detector_history_10_xmin;
MCNUM mccspec_detector_history_10_xmax;
MCNUM mccspec_detector_history_10_ymin;
MCNUM mccspec_detector_history_10_ymax;
MCNUM mccspec_detector_history_10_xwidth;
MCNUM mccspec_detector_history_10_yheight;
MCNUM mccspec_detector_history_10_restore_neutron;

/* Definition parameters for component 'spec_detector_history_11' [936]. */
#define mccspec_detector_history_11_nb DOUBLE_MAX_VOLUME_HISTORY_LENGTH
/* Setting parameters for component 'spec_detector_history_11' [936]. */
char mccspec_detector_history_11_filename[16384];
MCNUM mccspec_detector_history_11_xmin;
MCNUM mccspec_detector_history_11_xmax;
MCNUM mccspec_detector_history_11_ymin;
MCNUM mccspec_detector_history_11_ymax;
MCNUM mccspec_detector_history_11_xwidth;
MCNUM mccspec_detector_history_11_yheight;
MCNUM mccspec_detector_history_11_restore_neutron;

/* Definition parameters for component 'spec_detector_history_12' [937]. */
#define mccspec_detector_history_12_nb DOUBLE_MAX_VOLUME_HISTORY_LENGTH
/* Setting parameters for component 'spec_detector_history_12' [937]. */
char mccspec_detector_history_12_filename[16384];
MCNUM mccspec_detector_history_12_xmin;
MCNUM mccspec_detector_history_12_xmax;
MCNUM mccspec_detector_history_12_ymin;
MCNUM mccspec_detector_history_12_ymax;
MCNUM mccspec_detector_history_12_xwidth;
MCNUM mccspec_detector_history_12_yheight;
MCNUM mccspec_detector_history_12_restore_neutron;

/* Definition parameters for component 'spec_detector_history_13' [938]. */
#define mccspec_detector_history_13_nb DOUBLE_MAX_VOLUME_HISTORY_LENGTH
/* Setting parameters for component 'spec_detector_history_13' [938]. */
char mccspec_detector_history_13_filename[16384];
MCNUM mccspec_detector_history_13_xmin;
MCNUM mccspec_detector_history_13_xmax;
MCNUM mccspec_detector_history_13_ymin;
MCNUM mccspec_detector_history_13_ymax;
MCNUM mccspec_detector_history_13_xwidth;
MCNUM mccspec_detector_history_13_yheight;
MCNUM mccspec_detector_history_13_restore_neutron;

/* Definition parameters for component 'spec_detector_history_14' [939]. */
#define mccspec_detector_history_14_nb DOUBLE_MAX_VOLUME_HISTORY_LENGTH
/* Setting parameters for component 'spec_detector_history_14' [939]. */
char mccspec_detector_history_14_filename[16384];
MCNUM mccspec_detector_history_14_xmin;
MCNUM mccspec_detector_history_14_xmax;
MCNUM mccspec_detector_history_14_ymin;
MCNUM mccspec_detector_history_14_ymax;
MCNUM mccspec_detector_history_14_xwidth;
MCNUM mccspec_detector_history_14_yheight;
MCNUM mccspec_detector_history_14_restore_neutron;

/* Definition parameters for component 'spec_detector_history_15' [940]. */
#define mccspec_detector_history_15_nb DOUBLE_MAX_VOLUME_HISTORY_LENGTH
/* Setting parameters for component 'spec_detector_history_15' [940]. */
char mccspec_detector_history_15_filename[16384];
MCNUM mccspec_detector_history_15_xmin;
MCNUM mccspec_detector_history_15_xmax;
MCNUM mccspec_detector_history_15_ymin;
MCNUM mccspec_detector_history_15_ymax;
MCNUM mccspec_detector_history_15_xwidth;
MCNUM mccspec_detector_history_15_yheight;
MCNUM mccspec_detector_history_15_restore_neutron;

/* Definition parameters for component 'spec_detector_history_16' [941]. */
#define mccspec_detector_history_16_nb DOUBLE_MAX_VOLUME_HISTORY_LENGTH
/* Setting parameters for component 'spec_detector_history_16' [941]. */
char mccspec_detector_history_16_filename[16384];
MCNUM mccspec_detector_history_16_xmin;
MCNUM mccspec_detector_history_16_xmax;
MCNUM mccspec_detector_history_16_ymin;
MCNUM mccspec_detector_history_16_ymax;
MCNUM mccspec_detector_history_16_xwidth;
MCNUM mccspec_detector_history_16_yheight;
MCNUM mccspec_detector_history_16_restore_neutron;

/* Definition parameters for component 'spec_detector_history_17' [942]. */
#define mccspec_detector_history_17_nb DOUBLE_MAX_VOLUME_HISTORY_LENGTH
/* Setting parameters for component 'spec_detector_history_17' [942]. */
char mccspec_detector_history_17_filename[16384];
MCNUM mccspec_detector_history_17_xmin;
MCNUM mccspec_detector_history_17_xmax;
MCNUM mccspec_detector_history_17_ymin;
MCNUM mccspec_detector_history_17_ymax;
MCNUM mccspec_detector_history_17_xwidth;
MCNUM mccspec_detector_history_17_yheight;
MCNUM mccspec_detector_history_17_restore_neutron;

/* Definition parameters for component 'spec_detector_history_18' [943]. */
#define mccspec_detector_history_18_nb DOUBLE_MAX_VOLUME_HISTORY_LENGTH
/* Setting parameters for component 'spec_detector_history_18' [943]. */
char mccspec_detector_history_18_filename[16384];
MCNUM mccspec_detector_history_18_xmin;
MCNUM mccspec_detector_history_18_xmax;
MCNUM mccspec_detector_history_18_ymin;
MCNUM mccspec_detector_history_18_ymax;
MCNUM mccspec_detector_history_18_xwidth;
MCNUM mccspec_detector_history_18_yheight;
MCNUM mccspec_detector_history_18_restore_neutron;

/* Definition parameters for component 'spec_detector_history_19' [944]. */
#define mccspec_detector_history_19_nb DOUBLE_MAX_VOLUME_HISTORY_LENGTH
/* Setting parameters for component 'spec_detector_history_19' [944]. */
char mccspec_detector_history_19_filename[16384];
MCNUM mccspec_detector_history_19_xmin;
MCNUM mccspec_detector_history_19_xmax;
MCNUM mccspec_detector_history_19_ymin;
MCNUM mccspec_detector_history_19_ymax;
MCNUM mccspec_detector_history_19_xwidth;
MCNUM mccspec_detector_history_19_yheight;
MCNUM mccspec_detector_history_19_restore_neutron;

/* User component declarations. */

/* User declarations for component 'Al_incoherent' [1]. */
#define mccompcurname  Al_incoherent
#define mccompcurtype  Incoherent_process
#define mccompcurindex 1
#define This_process mccAl_incoherent_This_process
#define Incoherent_storage mccAl_incoherent_Incoherent_storage
#define effective_my_scattering mccAl_incoherent_effective_my_scattering
#define sigma mccAl_incoherent_sigma
#define f_QE mccAl_incoherent_f_QE
#define gamma mccAl_incoherent_gamma
#define packing_factor mccAl_incoherent_packing_factor
#define unit_cell_volume mccAl_incoherent_unit_cell_volume
#define interact_fraction mccAl_incoherent_interact_fraction
#line 123 "Incoherent_process.comp"
// Needed for transport to the main component
struct global_process_element_struct global_process_element;
struct scattering_process_struct This_process;

#ifndef PROCESS_DETECTOR
	//struct pointer_to_global_process_list global_process_list = {0,NULL};
	#define PROCESS_DETECTOR dummy
#endif

// Declare for this component, to do calculations on the input / store in the transported data
struct Incoherent_physics_storage_struct Incoherent_storage;
double effective_my_scattering;

#line 28583 "MACS_sample_kidney_box.c"
#undef interact_fraction
#undef unit_cell_volume
#undef packing_factor
#undef gamma
#undef f_QE
#undef sigma
#undef effective_my_scattering
#undef Incoherent_storage
#undef This_process
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

/* User declarations for component 'Al_powder' [2]. */
#define mccompcurname  Al_powder
#define mccompcurtype  Powder_process
#define mccompcurindex 2
#define format mccAl_powder_format
#define This_process mccAl_powder_This_process
#define Powder_storage mccAl_powder_Powder_storage
#define effective_my_scattering mccAl_powder_effective_my_scattering
#define d_phi mccAl_powder_d_phi
#define line_info mccAl_powder_line_info
#define columns mccAl_powder_columns
#define reflections mccAl_powder_reflections
#define packing_factor mccAl_powder_packing_factor
#define Vc mccAl_powder_Vc
#define delta_d_d mccAl_powder_delta_d_d
#define DW mccAl_powder_DW
#define nb_atoms mccAl_powder_nb_atoms
#define d_phi mccAl_powder_d_phi
#define density mccAl_powder_density
#define weight mccAl_powder_weight
#define barns mccAl_powder_barns
#define Strain mccAl_powder_Strain
#define interact_fraction mccAl_powder_interact_fraction
#line 618 "Powder_process.comp"
// Needed for transport to the main component
struct global_process_element_struct global_process_element;
struct scattering_process_struct This_process;

#ifndef PROCESS_DETECTOR
	//struct pointer_to_global_process_list global_process_list = {0,NULL};
	#define PROCESS_DETECTOR dummy
#endif

// Declare for this component, to do calculations on the input / store in the transported data
struct Powder_physics_storage_struct Powder_storage;
struct line_info_struct_union line_info;
double effective_my_scattering;

int columns[9] = format;


#line 28638 "MACS_sample_kidney_box.c"
#undef interact_fraction
#undef Strain
#undef barns
#undef weight
#undef density
#undef d_phi
#undef nb_atoms
#undef DW
#undef delta_d_d
#undef Vc
#undef packing_factor
#undef reflections
#undef columns
#undef line_info
#undef d_phi
#undef effective_my_scattering
#undef Powder_storage
#undef This_process
#undef format
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

/* User declarations for component 'Al' [3]. */
#define mccompcurname  Al
#define mccompcurtype  Union_make_material
#define mccompcurindex 3
#define loop_index mccAl_loop_index
#define this_material mccAl_this_material
#define accepted_processes mccAl_accepted_processes
#define global_material_element mccAl_global_material_element
#define process_string mccAl_process_string
#define my_absorption mccAl_my_absorption
#define absorber mccAl_absorber
#line 167 "Union_make_material.comp"
// Needed for transport to the main component
struct global_material_element_struct global_material_element;
struct physics_struct this_material;

#ifndef MATERIAL_DETECTOR
	//struct pointer_to_global_material_list global_material_list = {0,NULL};
	#define MATERIAL_DETECTOR dummy
#endif

int loop_index;
int found_process;
int specified_processes;
char local_string[256];

struct pointer_to_1d_int_list accepted_processes = {0,NULL};

// Add setup for loggers since make_material is called before any volume / master
#ifndef UNION_LOGGER_DECLARE
	//struct pointer_to_global_logger_list global_all_volume_logger_list = {0,NULL};
    //struct pointer_to_global_logger_list global_specific_volumes_logger_list = {0,NULL};
	#define UNION_LOGGER_DECLARE dummy
#endif

#line 28697 "MACS_sample_kidney_box.c"
#undef absorber
#undef my_absorption
#undef process_string
#undef global_material_element
#undef accepted_processes
#undef this_material
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

/* User declarations for component 'TiO2_incoherent' [4]. */
#define mccompcurname  TiO2_incoherent
#define mccompcurtype  Incoherent_process
#define mccompcurindex 4
#define This_process mccTiO2_incoherent_This_process
#define Incoherent_storage mccTiO2_incoherent_Incoherent_storage
#define effective_my_scattering mccTiO2_incoherent_effective_my_scattering
#define sigma mccTiO2_incoherent_sigma
#define f_QE mccTiO2_incoherent_f_QE
#define gamma mccTiO2_incoherent_gamma
#define packing_factor mccTiO2_incoherent_packing_factor
#define unit_cell_volume mccTiO2_incoherent_unit_cell_volume
#define interact_fraction mccTiO2_incoherent_interact_fraction
#line 123 "Incoherent_process.comp"
// Needed for transport to the main component
struct global_process_element_struct global_process_element;
struct scattering_process_struct This_process;

#ifndef PROCESS_DETECTOR
	//struct pointer_to_global_process_list global_process_list = {0,NULL};
	#define PROCESS_DETECTOR dummy
#endif

// Declare for this component, to do calculations on the input / store in the transported data
struct Incoherent_physics_storage_struct Incoherent_storage;
double effective_my_scattering;

#line 28736 "MACS_sample_kidney_box.c"
#undef interact_fraction
#undef unit_cell_volume
#undef packing_factor
#undef gamma
#undef f_QE
#undef sigma
#undef effective_my_scattering
#undef Incoherent_storage
#undef This_process
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

/* User declarations for component 'TiO2_single_crystal' [5]. */
#define mccompcurname  TiO2_single_crystal
#define mccompcurtype  Single_crystal_process
#define mccompcurindex 5
#define mosaic_AB mccTiO2_single_crystal_mosaic_AB
#define This_process mccTiO2_single_crystal_This_process
#define Single_crystal_storage mccTiO2_single_crystal_Single_crystal_storage
#define effective_my_scattering mccTiO2_single_crystal_effective_my_scattering
#define hkl_info_union mccTiO2_single_crystal_hkl_info_union
#define packing_factor mccTiO2_single_crystal_packing_factor
#define reflections mccTiO2_single_crystal_reflections
#define delta_d_d mccTiO2_single_crystal_delta_d_d
#define mosaic mccTiO2_single_crystal_mosaic
#define mosaic_a mccTiO2_single_crystal_mosaic_a
#define mosaic_b mccTiO2_single_crystal_mosaic_b
#define mosaic_c mccTiO2_single_crystal_mosaic_c
#define recip_cell mccTiO2_single_crystal_recip_cell
#define barns mccTiO2_single_crystal_barns
#define ax mccTiO2_single_crystal_ax
#define ay mccTiO2_single_crystal_ay
#define az mccTiO2_single_crystal_az
#define bx mccTiO2_single_crystal_bx
#define by mccTiO2_single_crystal_by
#define bz mccTiO2_single_crystal_bz
#define cx mccTiO2_single_crystal_cx
#define cy mccTiO2_single_crystal_cy
#define cz mccTiO2_single_crystal_cz
#define aa mccTiO2_single_crystal_aa
#define bb mccTiO2_single_crystal_bb
#define cc mccTiO2_single_crystal_cc
#define order mccTiO2_single_crystal_order
#define RX mccTiO2_single_crystal_RX
#define RY mccTiO2_single_crystal_RY
#define RZ mccTiO2_single_crystal_RZ
#define powder mccTiO2_single_crystal_powder
#define PG mccTiO2_single_crystal_PG
#define interact_fraction mccTiO2_single_crystal_interact_fraction
#define packing_factor mccTiO2_single_crystal_packing_factor
#line 920 "Single_crystal_process.comp"
// Declare for this component, to do calculations on the input / store in the transported data
struct Single_crystal_physics_storage_struct Single_crystal_storage;

// Variables needed in initialize of this function.
struct hkl_info_struct_union hkl_info_union;

// Needed for transport to the main component, will be the same for all processes
struct global_process_element_struct global_process_element;
struct scattering_process_struct This_process;

#ifndef PROCESS_DETECTOR
	//struct pointer_to_global_process_list global_process_list = {0,NULL};
	#define PROCESS_DETECTOR dummy
#endif
#line 28803 "MACS_sample_kidney_box.c"
#undef packing_factor
#undef interact_fraction
#undef PG
#undef powder
#undef RZ
#undef RY
#undef RX
#undef order
#undef cc
#undef bb
#undef aa
#undef cz
#undef cy
#undef cx
#undef bz
#undef by
#undef bx
#undef az
#undef ay
#undef ax
#undef barns
#undef recip_cell
#undef mosaic_c
#undef mosaic_b
#undef mosaic_a
#undef mosaic
#undef delta_d_d
#undef reflections
#undef packing_factor
#undef hkl_info_union
#undef effective_my_scattering
#undef Single_crystal_storage
#undef This_process
#undef mosaic_AB
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

/* User declarations for component 'TiO2' [6]. */
#define mccompcurname  TiO2
#define mccompcurtype  Union_make_material
#define mccompcurindex 6
#define loop_index mccTiO2_loop_index
#define this_material mccTiO2_this_material
#define accepted_processes mccTiO2_accepted_processes
#define global_material_element mccTiO2_global_material_element
#define process_string mccTiO2_process_string
#define my_absorption mccTiO2_my_absorption
#define absorber mccTiO2_absorber
#line 167 "Union_make_material.comp"
// Needed for transport to the main component
struct global_material_element_struct global_material_element;
struct physics_struct this_material;

#ifndef MATERIAL_DETECTOR
	//struct pointer_to_global_material_list global_material_list = {0,NULL};
	#define MATERIAL_DETECTOR dummy
#endif

int loop_index;
int found_process;
int specified_processes;
char local_string[256];

struct pointer_to_1d_int_list accepted_processes = {0,NULL};

// Add setup for loggers since make_material is called before any volume / master
#ifndef UNION_LOGGER_DECLARE
	//struct pointer_to_global_logger_list global_all_volume_logger_list = {0,NULL};
    //struct pointer_to_global_logger_list global_specific_volumes_logger_list = {0,NULL};
	#define UNION_LOGGER_DECLARE dummy
#endif

#line 28877 "MACS_sample_kidney_box.c"
#undef absorber
#undef my_absorption
#undef process_string
#undef global_material_element
#undef accepted_processes
#undef this_material
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

/* User declarations for component 'TiO2_poly_incoherent' [7]. */
#define mccompcurname  TiO2_poly_incoherent
#define mccompcurtype  Incoherent_process
#define mccompcurindex 7
#define This_process mccTiO2_poly_incoherent_This_process
#define Incoherent_storage mccTiO2_poly_incoherent_Incoherent_storage
#define effective_my_scattering mccTiO2_poly_incoherent_effective_my_scattering
#define sigma mccTiO2_poly_incoherent_sigma
#define f_QE mccTiO2_poly_incoherent_f_QE
#define gamma mccTiO2_poly_incoherent_gamma
#define packing_factor mccTiO2_poly_incoherent_packing_factor
#define unit_cell_volume mccTiO2_poly_incoherent_unit_cell_volume
#define interact_fraction mccTiO2_poly_incoherent_interact_fraction
#line 123 "Incoherent_process.comp"
// Needed for transport to the main component
struct global_process_element_struct global_process_element;
struct scattering_process_struct This_process;

#ifndef PROCESS_DETECTOR
	//struct pointer_to_global_process_list global_process_list = {0,NULL};
	#define PROCESS_DETECTOR dummy
#endif

// Declare for this component, to do calculations on the input / store in the transported data
struct Incoherent_physics_storage_struct Incoherent_storage;
double effective_my_scattering;

#line 28916 "MACS_sample_kidney_box.c"
#undef interact_fraction
#undef unit_cell_volume
#undef packing_factor
#undef gamma
#undef f_QE
#undef sigma
#undef effective_my_scattering
#undef Incoherent_storage
#undef This_process
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

/* User declarations for component 'TiO2_poly' [8]. */
#define mccompcurname  TiO2_poly
#define mccompcurtype  Union_make_material
#define mccompcurindex 8
#define loop_index mccTiO2_poly_loop_index
#define this_material mccTiO2_poly_this_material
#define accepted_processes mccTiO2_poly_accepted_processes
#define global_material_element mccTiO2_poly_global_material_element
#define process_string mccTiO2_poly_process_string
#define my_absorption mccTiO2_poly_my_absorption
#define absorber mccTiO2_poly_absorber
#line 167 "Union_make_material.comp"
// Needed for transport to the main component
struct global_material_element_struct global_material_element;
struct physics_struct this_material;

#ifndef MATERIAL_DETECTOR
	//struct pointer_to_global_material_list global_material_list = {0,NULL};
	#define MATERIAL_DETECTOR dummy
#endif

int loop_index;
int found_process;
int specified_processes;
char local_string[256];

struct pointer_to_1d_int_list accepted_processes = {0,NULL};

// Add setup for loggers since make_material is called before any volume / master
#ifndef UNION_LOGGER_DECLARE
	//struct pointer_to_global_logger_list global_all_volume_logger_list = {0,NULL};
    //struct pointer_to_global_logger_list global_specific_volumes_logger_list = {0,NULL};
	#define UNION_LOGGER_DECLARE dummy
#endif

#line 28965 "MACS_sample_kidney_box.c"
#undef absorber
#undef my_absorption
#undef process_string
#undef global_material_element
#undef accepted_processes
#undef this_material
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

/* User declarations for component 'Al_incoherent_B' [9]. */
#define mccompcurname  Al_incoherent_B
#define mccompcurtype  Incoherent_process
#define mccompcurindex 9
#define This_process mccAl_incoherent_B_This_process
#define Incoherent_storage mccAl_incoherent_B_Incoherent_storage
#define effective_my_scattering mccAl_incoherent_B_effective_my_scattering
#define sigma mccAl_incoherent_B_sigma
#define f_QE mccAl_incoherent_B_f_QE
#define gamma mccAl_incoherent_B_gamma
#define packing_factor mccAl_incoherent_B_packing_factor
#define unit_cell_volume mccAl_incoherent_B_unit_cell_volume
#define interact_fraction mccAl_incoherent_B_interact_fraction
#line 123 "Incoherent_process.comp"
// Needed for transport to the main component
struct global_process_element_struct global_process_element;
struct scattering_process_struct This_process;

#ifndef PROCESS_DETECTOR
	//struct pointer_to_global_process_list global_process_list = {0,NULL};
	#define PROCESS_DETECTOR dummy
#endif

// Declare for this component, to do calculations on the input / store in the transported data
struct Incoherent_physics_storage_struct Incoherent_storage;
double effective_my_scattering;

#line 29004 "MACS_sample_kidney_box.c"
#undef interact_fraction
#undef unit_cell_volume
#undef packing_factor
#undef gamma
#undef f_QE
#undef sigma
#undef effective_my_scattering
#undef Incoherent_storage
#undef This_process
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

/* User declarations for component 'Al_powder_B' [10]. */
#define mccompcurname  Al_powder_B
#define mccompcurtype  Powder_process
#define mccompcurindex 10
#define format mccAl_powder_B_format
#define This_process mccAl_powder_B_This_process
#define Powder_storage mccAl_powder_B_Powder_storage
#define effective_my_scattering mccAl_powder_B_effective_my_scattering
#define d_phi mccAl_powder_B_d_phi
#define line_info mccAl_powder_B_line_info
#define columns mccAl_powder_B_columns
#define reflections mccAl_powder_B_reflections
#define packing_factor mccAl_powder_B_packing_factor
#define Vc mccAl_powder_B_Vc
#define delta_d_d mccAl_powder_B_delta_d_d
#define DW mccAl_powder_B_DW
#define nb_atoms mccAl_powder_B_nb_atoms
#define d_phi mccAl_powder_B_d_phi
#define density mccAl_powder_B_density
#define weight mccAl_powder_B_weight
#define barns mccAl_powder_B_barns
#define Strain mccAl_powder_B_Strain
#define interact_fraction mccAl_powder_B_interact_fraction
#line 618 "Powder_process.comp"
// Needed for transport to the main component
struct global_process_element_struct global_process_element;
struct scattering_process_struct This_process;

#ifndef PROCESS_DETECTOR
	//struct pointer_to_global_process_list global_process_list = {0,NULL};
	#define PROCESS_DETECTOR dummy
#endif

// Declare for this component, to do calculations on the input / store in the transported data
struct Powder_physics_storage_struct Powder_storage;
struct line_info_struct_union line_info;
double effective_my_scattering;

int columns[9] = format;


#line 29059 "MACS_sample_kidney_box.c"
#undef interact_fraction
#undef Strain
#undef barns
#undef weight
#undef density
#undef d_phi
#undef nb_atoms
#undef DW
#undef delta_d_d
#undef Vc
#undef packing_factor
#undef reflections
#undef columns
#undef line_info
#undef d_phi
#undef effective_my_scattering
#undef Powder_storage
#undef This_process
#undef format
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

/* User declarations for component 'Al_B' [11]. */
#define mccompcurname  Al_B
#define mccompcurtype  Union_make_material
#define mccompcurindex 11
#define loop_index mccAl_B_loop_index
#define this_material mccAl_B_this_material
#define accepted_processes mccAl_B_accepted_processes
#define global_material_element mccAl_B_global_material_element
#define process_string mccAl_B_process_string
#define my_absorption mccAl_B_my_absorption
#define absorber mccAl_B_absorber
#line 167 "Union_make_material.comp"
// Needed for transport to the main component
struct global_material_element_struct global_material_element;
struct physics_struct this_material;

#ifndef MATERIAL_DETECTOR
	//struct pointer_to_global_material_list global_material_list = {0,NULL};
	#define MATERIAL_DETECTOR dummy
#endif

int loop_index;
int found_process;
int specified_processes;
char local_string[256];

struct pointer_to_1d_int_list accepted_processes = {0,NULL};

// Add setup for loggers since make_material is called before any volume / master
#ifndef UNION_LOGGER_DECLARE
	//struct pointer_to_global_logger_list global_all_volume_logger_list = {0,NULL};
    //struct pointer_to_global_logger_list global_specific_volumes_logger_list = {0,NULL};
	#define UNION_LOGGER_DECLARE dummy
#endif

#line 29118 "MACS_sample_kidney_box.c"
#undef absorber
#undef my_absorption
#undef process_string
#undef global_material_element
#undef accepted_processes
#undef this_material
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

/* User declarations for component 'Arm0' [12]. */
#define mccompcurname  Arm0
#define mccompcurtype  Progress_bar
#define mccompcurindex 12
#define IntermediateCnts mccArm0_IntermediateCnts
#define StartTime mccArm0_StartTime
#define EndTime mccArm0_EndTime
#define CurrentTime mccArm0_CurrentTime
#define profile mccArm0_profile
#define percent mccArm0_percent
#define flag_save mccArm0_flag_save
#define minutes mccArm0_minutes
#line 44 "/usr/share/mcstas/2.7/misc/Progress_bar.comp"
#ifndef PROGRESS_BAR
#define PROGRESS_BAR
#else
#error Only one Progress_bar component may be used in an instrument definition.
#endif

double IntermediateCnts;
time_t StartTime;
time_t EndTime;
time_t CurrentTime;
#line 29153 "MACS_sample_kidney_box.c"
#undef minutes
#undef flag_save
#undef percent
#undef profile
#undef CurrentTime
#undef EndTime
#undef StartTime
#undef IntermediateCnts
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

/* User declarations for component 'Guide_end' [13]. */
#define mccompcurname  Guide_end
#define mccompcurtype  Virtual_input
#define mccompcurindex 13
#define read_block mccGuide_end_read_block
#define pos mccGuide_end_pos
#define nrows mccGuide_end_nrows
#define Offset mccGuide_end_Offset
#define rTable mccGuide_end_rTable
#define repeat_number mccGuide_end_repeat_number
#define filename_ncount mccGuide_end_filename_ncount
#define mean_vx mccGuide_end_mean_vx
#define mean_vy mccGuide_end_mean_vy
#define mean_vz mccGuide_end_mean_vz
#define mean_dx mccGuide_end_mean_dx
#define mean_dy mccGuide_end_mean_dy
#define mean_dz mccGuide_end_mean_dz
#define n_neutrons mccGuide_end_n_neutrons
#define min_x mccGuide_end_min_x
#define min_y mccGuide_end_min_y
#define min_z mccGuide_end_min_z
#define max_x mccGuide_end_max_x
#define max_y mccGuide_end_max_y
#define max_z mccGuide_end_max_z
#define min_vx mccGuide_end_min_vx
#define min_vy mccGuide_end_min_vy
#define min_vz mccGuide_end_min_vz
#define max_vx mccGuide_end_max_vx
#define max_vy mccGuide_end_max_vy
#define max_vz mccGuide_end_max_vz
#define first_block mccGuide_end_first_block
#define mean_x mccGuide_end_mean_x
#define mean_y mccGuide_end_mean_y
#define mean_z mccGuide_end_mean_z
#define end_reading mccGuide_end_end_reading
#define n_count_extrapolated mccGuide_end_n_count_extrapolated
#define repeat_cnt mccGuide_end_repeat_cnt
#define filename mccGuide_end_filename
#define verbose mccGuide_end_verbose
#define repeat_count mccGuide_end_repeat_count
#define smooth mccGuide_end_smooth
#define display mccGuide_end_display
#line 103 "/usr/share/mcstas/2.7/obsolete/Virtual_input.comp"
  int repeat_number;      /* Neutron repeat of the filename */
  int repeat_cnt;         /* Repeat count, MPI taken into account */
  long pos;               /* current pos in block */
  long nrows;             /* total nrows in block */
  long Offset;            /* offset in filename */
  double filename_ncount; /* total number of neutrons in filename */
  double n_neutrons;
  char read_block;        /* flag to start by reading block */
  char first_block;
  char end_reading;
  t_Table rTable;

  /* statistics on first block */
  double mean_x, mean_y, mean_z;
  double mean_vx, mean_vy, mean_vz;
  double mean_dx, mean_dy, mean_dz;
  double min_x, min_y, min_z;
  double max_x, max_y, max_z;
  double min_vx, min_vy, min_vz;
  double max_vx, max_vy, max_vz;
  double n_count_extrapolated;
  char type[10];
#line 29231 "MACS_sample_kidney_box.c"
#undef display
#undef smooth
#undef repeat_count
#undef verbose
#undef filename
#undef repeat_cnt
#undef n_count_extrapolated
#undef end_reading
#undef mean_z
#undef mean_y
#undef mean_x
#undef first_block
#undef max_vz
#undef max_vy
#undef max_vx
#undef min_vz
#undef min_vy
#undef min_vx
#undef max_z
#undef max_y
#undef max_x
#undef min_z
#undef min_y
#undef min_x
#undef n_neutrons
#undef mean_dz
#undef mean_dy
#undef mean_dx
#undef mean_vz
#undef mean_vy
#undef mean_vx
#undef filename_ncount
#undef repeat_number
#undef rTable
#undef Offset
#undef nrows
#undef pos
#undef read_block
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

/* User declarations for component 'main_slit' [14]. */
#define mccompcurname  main_slit
#define mccompcurtype  Slit
#define mccompcurindex 14
#define xmin mccmain_slit_xmin
#define xmax mccmain_slit_xmax
#define ymin mccmain_slit_ymin
#define ymax mccmain_slit_ymax
#define radius mccmain_slit_radius
#define xwidth mccmain_slit_xwidth
#define yheight mccmain_slit_yheight
#undef yheight
#undef xwidth
#undef radius
#undef ymax
#undef ymin
#undef xmax
#undef xmin
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

/* User declarations for component 'target' [15]. */
#define mccompcurname  target
#define mccompcurtype  Arm
#define mccompcurindex 15
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

/* User declarations for component 'cryostat_center' [16]. */
#define mccompcurname  cryostat_center
#define mccompcurtype  Arm
#define mccompcurindex 16
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

/* User declarations for component 'drum_center' [17]. */
#define mccompcurname  drum_center
#define mccompcurtype  Arm
#define mccompcurindex 17
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

/* User declarations for component 'crystal_assembly' [18]. */
#define mccompcurname  crystal_assembly
#define mccompcurtype  Arm
#define mccompcurindex 18
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

/* User declarations for component 'crystal_axis' [19]. */
#define mccompcurname  crystal_axis
#define mccompcurtype  Arm
#define mccompcurindex 19
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

/* User declarations for component 'sample' [20]. */
#define mccompcurname  sample
#define mccompcurtype  Union_box
#define mccompcurindex 20
#define loop_index mccsample_loop_index
#define this_box_volume mccsample_this_box_volume
#define global_geometry_element mccsample_global_geometry_element
#define this_box_storage mccsample_this_box_storage
#define material_string mccsample_material_string
#define priority mccsample_priority
#define xwidth mccsample_xwidth
#define yheight mccsample_yheight
#define zdepth mccsample_zdepth
#define xwidth2 mccsample_xwidth2
#define yheight2 mccsample_yheight2
#define visualize mccsample_visualize
#define target_index mccsample_target_index
#define target_x mccsample_target_x
#define target_y mccsample_target_y
#define target_z mccsample_target_z
#define focus_aw mccsample_focus_aw
#define focus_ah mccsample_focus_ah
#define focus_xw mccsample_focus_xw
#define focus_xh mccsample_focus_xh
#define focus_r mccsample_focus_r
#define p_interact mccsample_p_interact
#define mask_string mccsample_mask_string
#define mask_setting mccsample_mask_setting
#define number_of_activations mccsample_number_of_activations
#line 204 "Union_box.comp"
// Needed for transport to the main component
struct global_geometry_element_struct global_geometry_element;

#ifndef ANY_GEOMETRY_DETECTOR_DECLARE
    #define ANY_GEOMETRY_DETECTOR_DECLARE dummy
	//struct pointer_to_global_geometry_list global_geometry_list = {0,NULL};
#endif

int loop_index,found_geometries;

double x_component;
double y_component;
double z_component;

struct Volume_struct this_box_volume;
struct box_storage this_box_storage;

#line 29383 "MACS_sample_kidney_box.c"
#undef number_of_activations
#undef mask_setting
#undef mask_string
#undef p_interact
#undef focus_r
#undef focus_xh
#undef focus_xw
#undef focus_ah
#undef focus_aw
#undef target_z
#undef target_y
#undef target_x
#undef target_index
#undef visualize
#undef yheight2
#undef xwidth2
#undef zdepth
#undef yheight
#undef xwidth
#undef priority
#undef material_string
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

/* User declarations for component 'sample_plate' [21]. */
#define mccompcurname  sample_plate
#define mccompcurtype  Union_cylinder
#define mccompcurindex 21
#define loop_index mccsample_plate_loop_index
#define this_cylinder_volume mccsample_plate_this_cylinder_volume
#define global_geometry_element mccsample_plate_global_geometry_element
#define this_cylinder_storage mccsample_plate_this_cylinder_storage
#define material_string mccsample_plate_material_string
#define priority mccsample_plate_priority
#define radius mccsample_plate_radius
#define yheight mccsample_plate_yheight
#define visualize mccsample_plate_visualize
#define target_index mccsample_plate_target_index
#define target_x mccsample_plate_target_x
#define target_y mccsample_plate_target_y
#define target_z mccsample_plate_target_z
#define focus_aw mccsample_plate_focus_aw
#define focus_ah mccsample_plate_focus_ah
#define focus_xw mccsample_plate_focus_xw
#define focus_xh mccsample_plate_focus_xh
#define focus_r mccsample_plate_focus_r
#define p_interact mccsample_plate_p_interact
#define mask_string mccsample_plate_mask_string
#define mask_setting mccsample_plate_mask_setting
#define number_of_activations mccsample_plate_number_of_activations
#line 167 "Union_cylinder.comp"
// Needed for transport to the main component
struct global_geometry_element_struct global_geometry_element;

#ifndef ANY_GEOMETRY_DETECTOR_DECLARE
    #define ANY_GEOMETRY_DETECTOR_DECLARE dummy
	//struct pointer_to_global_geometry_list global_geometry_list = {0,NULL};
#endif

int dummy;
int loop_index,found_geometries;
int loop_2_index;
int material_index;

struct Volume_struct this_cylinder_volume;
struct cylinder_storage this_cylinder_storage;
#line 29455 "MACS_sample_kidney_box.c"
#undef number_of_activations
#undef mask_setting
#undef mask_string
#undef p_interact
#undef focus_r
#undef focus_xh
#undef focus_xw
#undef focus_ah
#undef focus_aw
#undef target_z
#undef target_y
#undef target_x
#undef target_index
#undef visualize
#undef yheight
#undef radius
#undef priority
#undef material_string
#undef this_cylinder_storage
#undef global_geometry_element
#undef this_cylinder_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

/* User declarations for component 'sample_plate_rod' [22]. */
#define mccompcurname  sample_plate_rod
#define mccompcurtype  Union_cylinder
#define mccompcurindex 22
#define loop_index mccsample_plate_rod_loop_index
#define this_cylinder_volume mccsample_plate_rod_this_cylinder_volume
#define global_geometry_element mccsample_plate_rod_global_geometry_element
#define this_cylinder_storage mccsample_plate_rod_this_cylinder_storage
#define material_string mccsample_plate_rod_material_string
#define priority mccsample_plate_rod_priority
#define radius mccsample_plate_rod_radius
#define yheight mccsample_plate_rod_yheight
#define visualize mccsample_plate_rod_visualize
#define target_index mccsample_plate_rod_target_index
#define target_x mccsample_plate_rod_target_x
#define target_y mccsample_plate_rod_target_y
#define target_z mccsample_plate_rod_target_z
#define focus_aw mccsample_plate_rod_focus_aw
#define focus_ah mccsample_plate_rod_focus_ah
#define focus_xw mccsample_plate_rod_focus_xw
#define focus_xh mccsample_plate_rod_focus_xh
#define focus_r mccsample_plate_rod_focus_r
#define p_interact mccsample_plate_rod_p_interact
#define mask_string mccsample_plate_rod_mask_string
#define mask_setting mccsample_plate_rod_mask_setting
#define number_of_activations mccsample_plate_rod_number_of_activations
#line 167 "Union_cylinder.comp"
// Needed for transport to the main component
struct global_geometry_element_struct global_geometry_element;

#ifndef ANY_GEOMETRY_DETECTOR_DECLARE
    #define ANY_GEOMETRY_DETECTOR_DECLARE dummy
	//struct pointer_to_global_geometry_list global_geometry_list = {0,NULL};
#endif

int dummy;
int loop_index,found_geometries;
int loop_2_index;
int material_index;

struct Volume_struct this_cylinder_volume;
struct cylinder_storage this_cylinder_storage;
#line 29524 "MACS_sample_kidney_box.c"
#undef number_of_activations
#undef mask_setting
#undef mask_string
#undef p_interact
#undef focus_r
#undef focus_xh
#undef focus_xw
#undef focus_ah
#undef focus_aw
#undef target_z
#undef target_y
#undef target_x
#undef target_index
#undef visualize
#undef yheight
#undef radius
#undef priority
#undef material_string
#undef this_cylinder_storage
#undef global_geometry_element
#undef this_cylinder_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

/* User declarations for component 'sample_base' [23]. */
#define mccompcurname  sample_base
#define mccompcurtype  Union_cylinder
#define mccompcurindex 23
#define loop_index mccsample_base_loop_index
#define this_cylinder_volume mccsample_base_this_cylinder_volume
#define global_geometry_element mccsample_base_global_geometry_element
#define this_cylinder_storage mccsample_base_this_cylinder_storage
#define material_string mccsample_base_material_string
#define priority mccsample_base_priority
#define radius mccsample_base_radius
#define yheight mccsample_base_yheight
#define visualize mccsample_base_visualize
#define target_index mccsample_base_target_index
#define target_x mccsample_base_target_x
#define target_y mccsample_base_target_y
#define target_z mccsample_base_target_z
#define focus_aw mccsample_base_focus_aw
#define focus_ah mccsample_base_focus_ah
#define focus_xw mccsample_base_focus_xw
#define focus_xh mccsample_base_focus_xh
#define focus_r mccsample_base_focus_r
#define p_interact mccsample_base_p_interact
#define mask_string mccsample_base_mask_string
#define mask_setting mccsample_base_mask_setting
#define number_of_activations mccsample_base_number_of_activations
#line 167 "Union_cylinder.comp"
// Needed for transport to the main component
struct global_geometry_element_struct global_geometry_element;

#ifndef ANY_GEOMETRY_DETECTOR_DECLARE
    #define ANY_GEOMETRY_DETECTOR_DECLARE dummy
	//struct pointer_to_global_geometry_list global_geometry_list = {0,NULL};
#endif

int dummy;
int loop_index,found_geometries;
int loop_2_index;
int material_index;

struct Volume_struct this_cylinder_volume;
struct cylinder_storage this_cylinder_storage;
#line 29593 "MACS_sample_kidney_box.c"
#undef number_of_activations
#undef mask_setting
#undef mask_string
#undef p_interact
#undef focus_r
#undef focus_xh
#undef focus_xw
#undef focus_ah
#undef focus_aw
#undef target_z
#undef target_y
#undef target_x
#undef target_index
#undef visualize
#undef yheight
#undef radius
#undef priority
#undef material_string
#undef this_cylinder_storage
#undef global_geometry_element
#undef this_cylinder_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

/* User declarations for component 'sample_base_gap' [24]. */
#define mccompcurname  sample_base_gap
#define mccompcurtype  Union_cylinder
#define mccompcurindex 24
#define loop_index mccsample_base_gap_loop_index
#define this_cylinder_volume mccsample_base_gap_this_cylinder_volume
#define global_geometry_element mccsample_base_gap_global_geometry_element
#define this_cylinder_storage mccsample_base_gap_this_cylinder_storage
#define material_string mccsample_base_gap_material_string
#define priority mccsample_base_gap_priority
#define radius mccsample_base_gap_radius
#define yheight mccsample_base_gap_yheight
#define visualize mccsample_base_gap_visualize
#define target_index mccsample_base_gap_target_index
#define target_x mccsample_base_gap_target_x
#define target_y mccsample_base_gap_target_y
#define target_z mccsample_base_gap_target_z
#define focus_aw mccsample_base_gap_focus_aw
#define focus_ah mccsample_base_gap_focus_ah
#define focus_xw mccsample_base_gap_focus_xw
#define focus_xh mccsample_base_gap_focus_xh
#define focus_r mccsample_base_gap_focus_r
#define p_interact mccsample_base_gap_p_interact
#define mask_string mccsample_base_gap_mask_string
#define mask_setting mccsample_base_gap_mask_setting
#define number_of_activations mccsample_base_gap_number_of_activations
#line 167 "Union_cylinder.comp"
// Needed for transport to the main component
struct global_geometry_element_struct global_geometry_element;

#ifndef ANY_GEOMETRY_DETECTOR_DECLARE
    #define ANY_GEOMETRY_DETECTOR_DECLARE dummy
	//struct pointer_to_global_geometry_list global_geometry_list = {0,NULL};
#endif

int dummy;
int loop_index,found_geometries;
int loop_2_index;
int material_index;

struct Volume_struct this_cylinder_volume;
struct cylinder_storage this_cylinder_storage;
#line 29662 "MACS_sample_kidney_box.c"
#undef number_of_activations
#undef mask_setting
#undef mask_string
#undef p_interact
#undef focus_r
#undef focus_xh
#undef focus_xw
#undef focus_ah
#undef focus_aw
#undef target_z
#undef target_y
#undef target_x
#undef target_index
#undef visualize
#undef yheight
#undef radius
#undef priority
#undef material_string
#undef this_cylinder_storage
#undef global_geometry_element
#undef this_cylinder_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

/* User declarations for component 'cryostat_mountin_plate' [25]. */
#define mccompcurname  cryostat_mountin_plate
#define mccompcurtype  Union_cylinder
#define mccompcurindex 25
#define loop_index mcccryostat_mountin_plate_loop_index
#define this_cylinder_volume mcccryostat_mountin_plate_this_cylinder_volume
#define global_geometry_element mcccryostat_mountin_plate_global_geometry_element
#define this_cylinder_storage mcccryostat_mountin_plate_this_cylinder_storage
#define material_string mcccryostat_mountin_plate_material_string
#define priority mcccryostat_mountin_plate_priority
#define radius mcccryostat_mountin_plate_radius
#define yheight mcccryostat_mountin_plate_yheight
#define visualize mcccryostat_mountin_plate_visualize
#define target_index mcccryostat_mountin_plate_target_index
#define target_x mcccryostat_mountin_plate_target_x
#define target_y mcccryostat_mountin_plate_target_y
#define target_z mcccryostat_mountin_plate_target_z
#define focus_aw mcccryostat_mountin_plate_focus_aw
#define focus_ah mcccryostat_mountin_plate_focus_ah
#define focus_xw mcccryostat_mountin_plate_focus_xw
#define focus_xh mcccryostat_mountin_plate_focus_xh
#define focus_r mcccryostat_mountin_plate_focus_r
#define p_interact mcccryostat_mountin_plate_p_interact
#define mask_string mcccryostat_mountin_plate_mask_string
#define mask_setting mcccryostat_mountin_plate_mask_setting
#define number_of_activations mcccryostat_mountin_plate_number_of_activations
#line 167 "Union_cylinder.comp"
// Needed for transport to the main component
struct global_geometry_element_struct global_geometry_element;

#ifndef ANY_GEOMETRY_DETECTOR_DECLARE
    #define ANY_GEOMETRY_DETECTOR_DECLARE dummy
	//struct pointer_to_global_geometry_list global_geometry_list = {0,NULL};
#endif

int dummy;
int loop_index,found_geometries;
int loop_2_index;
int material_index;

struct Volume_struct this_cylinder_volume;
struct cylinder_storage this_cylinder_storage;
#line 29731 "MACS_sample_kidney_box.c"
#undef number_of_activations
#undef mask_setting
#undef mask_string
#undef p_interact
#undef focus_r
#undef focus_xh
#undef focus_xw
#undef focus_ah
#undef focus_aw
#undef target_z
#undef target_y
#undef target_x
#undef target_index
#undef visualize
#undef yheight
#undef radius
#undef priority
#undef material_string
#undef this_cylinder_storage
#undef global_geometry_element
#undef this_cylinder_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

/* User declarations for component 'cryostat_drum_walls' [26]. */
#define mccompcurname  cryostat_drum_walls
#define mccompcurtype  Union_cylinder
#define mccompcurindex 26
#define loop_index mcccryostat_drum_walls_loop_index
#define this_cylinder_volume mcccryostat_drum_walls_this_cylinder_volume
#define global_geometry_element mcccryostat_drum_walls_global_geometry_element
#define this_cylinder_storage mcccryostat_drum_walls_this_cylinder_storage
#define material_string mcccryostat_drum_walls_material_string
#define priority mcccryostat_drum_walls_priority
#define radius mcccryostat_drum_walls_radius
#define yheight mcccryostat_drum_walls_yheight
#define visualize mcccryostat_drum_walls_visualize
#define target_index mcccryostat_drum_walls_target_index
#define target_x mcccryostat_drum_walls_target_x
#define target_y mcccryostat_drum_walls_target_y
#define target_z mcccryostat_drum_walls_target_z
#define focus_aw mcccryostat_drum_walls_focus_aw
#define focus_ah mcccryostat_drum_walls_focus_ah
#define focus_xw mcccryostat_drum_walls_focus_xw
#define focus_xh mcccryostat_drum_walls_focus_xh
#define focus_r mcccryostat_drum_walls_focus_r
#define p_interact mcccryostat_drum_walls_p_interact
#define mask_string mcccryostat_drum_walls_mask_string
#define mask_setting mcccryostat_drum_walls_mask_setting
#define number_of_activations mcccryostat_drum_walls_number_of_activations
#line 167 "Union_cylinder.comp"
// Needed for transport to the main component
struct global_geometry_element_struct global_geometry_element;

#ifndef ANY_GEOMETRY_DETECTOR_DECLARE
    #define ANY_GEOMETRY_DETECTOR_DECLARE dummy
	//struct pointer_to_global_geometry_list global_geometry_list = {0,NULL};
#endif

int dummy;
int loop_index,found_geometries;
int loop_2_index;
int material_index;

struct Volume_struct this_cylinder_volume;
struct cylinder_storage this_cylinder_storage;
#line 29800 "MACS_sample_kidney_box.c"
#undef number_of_activations
#undef mask_setting
#undef mask_string
#undef p_interact
#undef focus_r
#undef focus_xh
#undef focus_xw
#undef focus_ah
#undef focus_aw
#undef target_z
#undef target_y
#undef target_x
#undef target_index
#undef visualize
#undef yheight
#undef radius
#undef priority
#undef material_string
#undef this_cylinder_storage
#undef global_geometry_element
#undef this_cylinder_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

/* User declarations for component 'cryostat_drum_vacuum' [27]. */
#define mccompcurname  cryostat_drum_vacuum
#define mccompcurtype  Union_cylinder
#define mccompcurindex 27
#define loop_index mcccryostat_drum_vacuum_loop_index
#define this_cylinder_volume mcccryostat_drum_vacuum_this_cylinder_volume
#define global_geometry_element mcccryostat_drum_vacuum_global_geometry_element
#define this_cylinder_storage mcccryostat_drum_vacuum_this_cylinder_storage
#define material_string mcccryostat_drum_vacuum_material_string
#define priority mcccryostat_drum_vacuum_priority
#define radius mcccryostat_drum_vacuum_radius
#define yheight mcccryostat_drum_vacuum_yheight
#define visualize mcccryostat_drum_vacuum_visualize
#define target_index mcccryostat_drum_vacuum_target_index
#define target_x mcccryostat_drum_vacuum_target_x
#define target_y mcccryostat_drum_vacuum_target_y
#define target_z mcccryostat_drum_vacuum_target_z
#define focus_aw mcccryostat_drum_vacuum_focus_aw
#define focus_ah mcccryostat_drum_vacuum_focus_ah
#define focus_xw mcccryostat_drum_vacuum_focus_xw
#define focus_xh mcccryostat_drum_vacuum_focus_xh
#define focus_r mcccryostat_drum_vacuum_focus_r
#define p_interact mcccryostat_drum_vacuum_p_interact
#define mask_string mcccryostat_drum_vacuum_mask_string
#define mask_setting mcccryostat_drum_vacuum_mask_setting
#define number_of_activations mcccryostat_drum_vacuum_number_of_activations
#line 167 "Union_cylinder.comp"
// Needed for transport to the main component
struct global_geometry_element_struct global_geometry_element;

#ifndef ANY_GEOMETRY_DETECTOR_DECLARE
    #define ANY_GEOMETRY_DETECTOR_DECLARE dummy
	//struct pointer_to_global_geometry_list global_geometry_list = {0,NULL};
#endif

int dummy;
int loop_index,found_geometries;
int loop_2_index;
int material_index;

struct Volume_struct this_cylinder_volume;
struct cylinder_storage this_cylinder_storage;
#line 29869 "MACS_sample_kidney_box.c"
#undef number_of_activations
#undef mask_setting
#undef mask_string
#undef p_interact
#undef focus_r
#undef focus_xh
#undef focus_xw
#undef focus_ah
#undef focus_aw
#undef target_z
#undef target_y
#undef target_x
#undef target_index
#undef visualize
#undef yheight
#undef radius
#undef priority
#undef material_string
#undef this_cylinder_storage
#undef global_geometry_element
#undef this_cylinder_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

/* User declarations for component 'outer_cryostat_wall' [28]. */
#define mccompcurname  outer_cryostat_wall
#define mccompcurtype  Union_cylinder
#define mccompcurindex 28
#define loop_index mccouter_cryostat_wall_loop_index
#define this_cylinder_volume mccouter_cryostat_wall_this_cylinder_volume
#define global_geometry_element mccouter_cryostat_wall_global_geometry_element
#define this_cylinder_storage mccouter_cryostat_wall_this_cylinder_storage
#define material_string mccouter_cryostat_wall_material_string
#define priority mccouter_cryostat_wall_priority
#define radius mccouter_cryostat_wall_radius
#define yheight mccouter_cryostat_wall_yheight
#define visualize mccouter_cryostat_wall_visualize
#define target_index mccouter_cryostat_wall_target_index
#define target_x mccouter_cryostat_wall_target_x
#define target_y mccouter_cryostat_wall_target_y
#define target_z mccouter_cryostat_wall_target_z
#define focus_aw mccouter_cryostat_wall_focus_aw
#define focus_ah mccouter_cryostat_wall_focus_ah
#define focus_xw mccouter_cryostat_wall_focus_xw
#define focus_xh mccouter_cryostat_wall_focus_xh
#define focus_r mccouter_cryostat_wall_focus_r
#define p_interact mccouter_cryostat_wall_p_interact
#define mask_string mccouter_cryostat_wall_mask_string
#define mask_setting mccouter_cryostat_wall_mask_setting
#define number_of_activations mccouter_cryostat_wall_number_of_activations
#line 167 "Union_cylinder.comp"
// Needed for transport to the main component
struct global_geometry_element_struct global_geometry_element;

#ifndef ANY_GEOMETRY_DETECTOR_DECLARE
    #define ANY_GEOMETRY_DETECTOR_DECLARE dummy
	//struct pointer_to_global_geometry_list global_geometry_list = {0,NULL};
#endif

int dummy;
int loop_index,found_geometries;
int loop_2_index;
int material_index;

struct Volume_struct this_cylinder_volume;
struct cylinder_storage this_cylinder_storage;
#line 29938 "MACS_sample_kidney_box.c"
#undef number_of_activations
#undef mask_setting
#undef mask_string
#undef p_interact
#undef focus_r
#undef focus_xh
#undef focus_xw
#undef focus_ah
#undef focus_aw
#undef target_z
#undef target_y
#undef target_x
#undef target_index
#undef visualize
#undef yheight
#undef radius
#undef priority
#undef material_string
#undef this_cylinder_storage
#undef global_geometry_element
#undef this_cylinder_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

/* User declarations for component 'outer_cryostat_vacuum' [29]. */
#define mccompcurname  outer_cryostat_vacuum
#define mccompcurtype  Union_cylinder
#define mccompcurindex 29
#define loop_index mccouter_cryostat_vacuum_loop_index
#define this_cylinder_volume mccouter_cryostat_vacuum_this_cylinder_volume
#define global_geometry_element mccouter_cryostat_vacuum_global_geometry_element
#define this_cylinder_storage mccouter_cryostat_vacuum_this_cylinder_storage
#define material_string mccouter_cryostat_vacuum_material_string
#define priority mccouter_cryostat_vacuum_priority
#define radius mccouter_cryostat_vacuum_radius
#define yheight mccouter_cryostat_vacuum_yheight
#define visualize mccouter_cryostat_vacuum_visualize
#define target_index mccouter_cryostat_vacuum_target_index
#define target_x mccouter_cryostat_vacuum_target_x
#define target_y mccouter_cryostat_vacuum_target_y
#define target_z mccouter_cryostat_vacuum_target_z
#define focus_aw mccouter_cryostat_vacuum_focus_aw
#define focus_ah mccouter_cryostat_vacuum_focus_ah
#define focus_xw mccouter_cryostat_vacuum_focus_xw
#define focus_xh mccouter_cryostat_vacuum_focus_xh
#define focus_r mccouter_cryostat_vacuum_focus_r
#define p_interact mccouter_cryostat_vacuum_p_interact
#define mask_string mccouter_cryostat_vacuum_mask_string
#define mask_setting mccouter_cryostat_vacuum_mask_setting
#define number_of_activations mccouter_cryostat_vacuum_number_of_activations
#line 167 "Union_cylinder.comp"
// Needed for transport to the main component
struct global_geometry_element_struct global_geometry_element;

#ifndef ANY_GEOMETRY_DETECTOR_DECLARE
    #define ANY_GEOMETRY_DETECTOR_DECLARE dummy
	//struct pointer_to_global_geometry_list global_geometry_list = {0,NULL};
#endif

int dummy;
int loop_index,found_geometries;
int loop_2_index;
int material_index;

struct Volume_struct this_cylinder_volume;
struct cylinder_storage this_cylinder_storage;
#line 30007 "MACS_sample_kidney_box.c"
#undef number_of_activations
#undef mask_setting
#undef mask_string
#undef p_interact
#undef focus_r
#undef focus_xh
#undef focus_xw
#undef focus_ah
#undef focus_aw
#undef target_z
#undef target_y
#undef target_x
#undef target_index
#undef visualize
#undef yheight
#undef radius
#undef priority
#undef material_string
#undef this_cylinder_storage
#undef global_geometry_element
#undef this_cylinder_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

/* User declarations for component 'inner_cryostat_wall' [30]. */
#define mccompcurname  inner_cryostat_wall
#define mccompcurtype  Union_cylinder
#define mccompcurindex 30
#define loop_index mccinner_cryostat_wall_loop_index
#define this_cylinder_volume mccinner_cryostat_wall_this_cylinder_volume
#define global_geometry_element mccinner_cryostat_wall_global_geometry_element
#define this_cylinder_storage mccinner_cryostat_wall_this_cylinder_storage
#define material_string mccinner_cryostat_wall_material_string
#define priority mccinner_cryostat_wall_priority
#define radius mccinner_cryostat_wall_radius
#define yheight mccinner_cryostat_wall_yheight
#define visualize mccinner_cryostat_wall_visualize
#define target_index mccinner_cryostat_wall_target_index
#define target_x mccinner_cryostat_wall_target_x
#define target_y mccinner_cryostat_wall_target_y
#define target_z mccinner_cryostat_wall_target_z
#define focus_aw mccinner_cryostat_wall_focus_aw
#define focus_ah mccinner_cryostat_wall_focus_ah
#define focus_xw mccinner_cryostat_wall_focus_xw
#define focus_xh mccinner_cryostat_wall_focus_xh
#define focus_r mccinner_cryostat_wall_focus_r
#define p_interact mccinner_cryostat_wall_p_interact
#define mask_string mccinner_cryostat_wall_mask_string
#define mask_setting mccinner_cryostat_wall_mask_setting
#define number_of_activations mccinner_cryostat_wall_number_of_activations
#line 167 "Union_cylinder.comp"
// Needed for transport to the main component
struct global_geometry_element_struct global_geometry_element;

#ifndef ANY_GEOMETRY_DETECTOR_DECLARE
    #define ANY_GEOMETRY_DETECTOR_DECLARE dummy
	//struct pointer_to_global_geometry_list global_geometry_list = {0,NULL};
#endif

int dummy;
int loop_index,found_geometries;
int loop_2_index;
int material_index;

struct Volume_struct this_cylinder_volume;
struct cylinder_storage this_cylinder_storage;
#line 30076 "MACS_sample_kidney_box.c"
#undef number_of_activations
#undef mask_setting
#undef mask_string
#undef p_interact
#undef focus_r
#undef focus_xh
#undef focus_xw
#undef focus_ah
#undef focus_aw
#undef target_z
#undef target_y
#undef target_x
#undef target_index
#undef visualize
#undef yheight
#undef radius
#undef priority
#undef material_string
#undef this_cylinder_storage
#undef global_geometry_element
#undef this_cylinder_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

/* User declarations for component 'inner_cryostat_vacuum' [31]. */
#define mccompcurname  inner_cryostat_vacuum
#define mccompcurtype  Union_cylinder
#define mccompcurindex 31
#define loop_index mccinner_cryostat_vacuum_loop_index
#define this_cylinder_volume mccinner_cryostat_vacuum_this_cylinder_volume
#define global_geometry_element mccinner_cryostat_vacuum_global_geometry_element
#define this_cylinder_storage mccinner_cryostat_vacuum_this_cylinder_storage
#define material_string mccinner_cryostat_vacuum_material_string
#define priority mccinner_cryostat_vacuum_priority
#define radius mccinner_cryostat_vacuum_radius
#define yheight mccinner_cryostat_vacuum_yheight
#define visualize mccinner_cryostat_vacuum_visualize
#define target_index mccinner_cryostat_vacuum_target_index
#define target_x mccinner_cryostat_vacuum_target_x
#define target_y mccinner_cryostat_vacuum_target_y
#define target_z mccinner_cryostat_vacuum_target_z
#define focus_aw mccinner_cryostat_vacuum_focus_aw
#define focus_ah mccinner_cryostat_vacuum_focus_ah
#define focus_xw mccinner_cryostat_vacuum_focus_xw
#define focus_xh mccinner_cryostat_vacuum_focus_xh
#define focus_r mccinner_cryostat_vacuum_focus_r
#define p_interact mccinner_cryostat_vacuum_p_interact
#define mask_string mccinner_cryostat_vacuum_mask_string
#define mask_setting mccinner_cryostat_vacuum_mask_setting
#define number_of_activations mccinner_cryostat_vacuum_number_of_activations
#line 167 "Union_cylinder.comp"
// Needed for transport to the main component
struct global_geometry_element_struct global_geometry_element;

#ifndef ANY_GEOMETRY_DETECTOR_DECLARE
    #define ANY_GEOMETRY_DETECTOR_DECLARE dummy
	//struct pointer_to_global_geometry_list global_geometry_list = {0,NULL};
#endif

int dummy;
int loop_index,found_geometries;
int loop_2_index;
int material_index;

struct Volume_struct this_cylinder_volume;
struct cylinder_storage this_cylinder_storage;
#line 30145 "MACS_sample_kidney_box.c"
#undef number_of_activations
#undef mask_setting
#undef mask_string
#undef p_interact
#undef focus_r
#undef focus_xh
#undef focus_xw
#undef focus_ah
#undef focus_aw
#undef target_z
#undef target_y
#undef target_x
#undef target_index
#undef visualize
#undef yheight
#undef radius
#undef priority
#undef material_string
#undef this_cylinder_storage
#undef global_geometry_element
#undef this_cylinder_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

/* User declarations for component 'sample_stick_walls' [32]. */
#define mccompcurname  sample_stick_walls
#define mccompcurtype  Union_cylinder
#define mccompcurindex 32
#define loop_index mccsample_stick_walls_loop_index
#define this_cylinder_volume mccsample_stick_walls_this_cylinder_volume
#define global_geometry_element mccsample_stick_walls_global_geometry_element
#define this_cylinder_storage mccsample_stick_walls_this_cylinder_storage
#define material_string mccsample_stick_walls_material_string
#define priority mccsample_stick_walls_priority
#define radius mccsample_stick_walls_radius
#define yheight mccsample_stick_walls_yheight
#define visualize mccsample_stick_walls_visualize
#define target_index mccsample_stick_walls_target_index
#define target_x mccsample_stick_walls_target_x
#define target_y mccsample_stick_walls_target_y
#define target_z mccsample_stick_walls_target_z
#define focus_aw mccsample_stick_walls_focus_aw
#define focus_ah mccsample_stick_walls_focus_ah
#define focus_xw mccsample_stick_walls_focus_xw
#define focus_xh mccsample_stick_walls_focus_xh
#define focus_r mccsample_stick_walls_focus_r
#define p_interact mccsample_stick_walls_p_interact
#define mask_string mccsample_stick_walls_mask_string
#define mask_setting mccsample_stick_walls_mask_setting
#define number_of_activations mccsample_stick_walls_number_of_activations
#line 167 "Union_cylinder.comp"
// Needed for transport to the main component
struct global_geometry_element_struct global_geometry_element;

#ifndef ANY_GEOMETRY_DETECTOR_DECLARE
    #define ANY_GEOMETRY_DETECTOR_DECLARE dummy
	//struct pointer_to_global_geometry_list global_geometry_list = {0,NULL};
#endif

int dummy;
int loop_index,found_geometries;
int loop_2_index;
int material_index;

struct Volume_struct this_cylinder_volume;
struct cylinder_storage this_cylinder_storage;
#line 30214 "MACS_sample_kidney_box.c"
#undef number_of_activations
#undef mask_setting
#undef mask_string
#undef p_interact
#undef focus_r
#undef focus_xh
#undef focus_xw
#undef focus_ah
#undef focus_aw
#undef target_z
#undef target_y
#undef target_x
#undef target_index
#undef visualize
#undef yheight
#undef radius
#undef priority
#undef material_string
#undef this_cylinder_storage
#undef global_geometry_element
#undef this_cylinder_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

/* User declarations for component 'sample_stick_vacuum' [33]. */
#define mccompcurname  sample_stick_vacuum
#define mccompcurtype  Union_cylinder
#define mccompcurindex 33
#define loop_index mccsample_stick_vacuum_loop_index
#define this_cylinder_volume mccsample_stick_vacuum_this_cylinder_volume
#define global_geometry_element mccsample_stick_vacuum_global_geometry_element
#define this_cylinder_storage mccsample_stick_vacuum_this_cylinder_storage
#define material_string mccsample_stick_vacuum_material_string
#define priority mccsample_stick_vacuum_priority
#define radius mccsample_stick_vacuum_radius
#define yheight mccsample_stick_vacuum_yheight
#define visualize mccsample_stick_vacuum_visualize
#define target_index mccsample_stick_vacuum_target_index
#define target_x mccsample_stick_vacuum_target_x
#define target_y mccsample_stick_vacuum_target_y
#define target_z mccsample_stick_vacuum_target_z
#define focus_aw mccsample_stick_vacuum_focus_aw
#define focus_ah mccsample_stick_vacuum_focus_ah
#define focus_xw mccsample_stick_vacuum_focus_xw
#define focus_xh mccsample_stick_vacuum_focus_xh
#define focus_r mccsample_stick_vacuum_focus_r
#define p_interact mccsample_stick_vacuum_p_interact
#define mask_string mccsample_stick_vacuum_mask_string
#define mask_setting mccsample_stick_vacuum_mask_setting
#define number_of_activations mccsample_stick_vacuum_number_of_activations
#line 167 "Union_cylinder.comp"
// Needed for transport to the main component
struct global_geometry_element_struct global_geometry_element;

#ifndef ANY_GEOMETRY_DETECTOR_DECLARE
    #define ANY_GEOMETRY_DETECTOR_DECLARE dummy
	//struct pointer_to_global_geometry_list global_geometry_list = {0,NULL};
#endif

int dummy;
int loop_index,found_geometries;
int loop_2_index;
int material_index;

struct Volume_struct this_cylinder_volume;
struct cylinder_storage this_cylinder_storage;
#line 30283 "MACS_sample_kidney_box.c"
#undef number_of_activations
#undef mask_setting
#undef mask_string
#undef p_interact
#undef focus_r
#undef focus_xh
#undef focus_xw
#undef focus_ah
#undef focus_aw
#undef target_z
#undef target_y
#undef target_x
#undef target_index
#undef visualize
#undef yheight
#undef radius
#undef priority
#undef material_string
#undef this_cylinder_storage
#undef global_geometry_element
#undef this_cylinder_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

/* User declarations for component 'sample_rod_bottom' [34]. */
#define mccompcurname  sample_rod_bottom
#define mccompcurtype  Arm
#define mccompcurindex 34
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

/* User declarations for component 'sample_rod' [35]. */
#define mccompcurname  sample_rod
#define mccompcurtype  Union_cylinder
#define mccompcurindex 35
#define loop_index mccsample_rod_loop_index
#define this_cylinder_volume mccsample_rod_this_cylinder_volume
#define global_geometry_element mccsample_rod_global_geometry_element
#define this_cylinder_storage mccsample_rod_this_cylinder_storage
#define material_string mccsample_rod_material_string
#define priority mccsample_rod_priority
#define radius mccsample_rod_radius
#define yheight mccsample_rod_yheight
#define visualize mccsample_rod_visualize
#define target_index mccsample_rod_target_index
#define target_x mccsample_rod_target_x
#define target_y mccsample_rod_target_y
#define target_z mccsample_rod_target_z
#define focus_aw mccsample_rod_focus_aw
#define focus_ah mccsample_rod_focus_ah
#define focus_xw mccsample_rod_focus_xw
#define focus_xh mccsample_rod_focus_xh
#define focus_r mccsample_rod_focus_r
#define p_interact mccsample_rod_p_interact
#define mask_string mccsample_rod_mask_string
#define mask_setting mccsample_rod_mask_setting
#define number_of_activations mccsample_rod_number_of_activations
#line 167 "Union_cylinder.comp"
// Needed for transport to the main component
struct global_geometry_element_struct global_geometry_element;

#ifndef ANY_GEOMETRY_DETECTOR_DECLARE
    #define ANY_GEOMETRY_DETECTOR_DECLARE dummy
	//struct pointer_to_global_geometry_list global_geometry_list = {0,NULL};
#endif

int dummy;
int loop_index,found_geometries;
int loop_2_index;
int material_index;

struct Volume_struct this_cylinder_volume;
struct cylinder_storage this_cylinder_storage;
#line 30360 "MACS_sample_kidney_box.c"
#undef number_of_activations
#undef mask_setting
#undef mask_string
#undef p_interact
#undef focus_r
#undef focus_xh
#undef focus_xw
#undef focus_ah
#undef focus_aw
#undef target_z
#undef target_y
#undef target_x
#undef target_index
#undef visualize
#undef yheight
#undef radius
#undef priority
#undef material_string
#undef this_cylinder_storage
#undef global_geometry_element
#undef this_cylinder_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

/* User declarations for component 'sample_rod_collar_1' [36]. */
#define mccompcurname  sample_rod_collar_1
#define mccompcurtype  Union_cylinder
#define mccompcurindex 36
#define loop_index mccsample_rod_collar_1_loop_index
#define this_cylinder_volume mccsample_rod_collar_1_this_cylinder_volume
#define global_geometry_element mccsample_rod_collar_1_global_geometry_element
#define this_cylinder_storage mccsample_rod_collar_1_this_cylinder_storage
#define material_string mccsample_rod_collar_1_material_string
#define priority mccsample_rod_collar_1_priority
#define radius mccsample_rod_collar_1_radius
#define yheight mccsample_rod_collar_1_yheight
#define visualize mccsample_rod_collar_1_visualize
#define target_index mccsample_rod_collar_1_target_index
#define target_x mccsample_rod_collar_1_target_x
#define target_y mccsample_rod_collar_1_target_y
#define target_z mccsample_rod_collar_1_target_z
#define focus_aw mccsample_rod_collar_1_focus_aw
#define focus_ah mccsample_rod_collar_1_focus_ah
#define focus_xw mccsample_rod_collar_1_focus_xw
#define focus_xh mccsample_rod_collar_1_focus_xh
#define focus_r mccsample_rod_collar_1_focus_r
#define p_interact mccsample_rod_collar_1_p_interact
#define mask_string mccsample_rod_collar_1_mask_string
#define mask_setting mccsample_rod_collar_1_mask_setting
#define number_of_activations mccsample_rod_collar_1_number_of_activations
#line 167 "Union_cylinder.comp"
// Needed for transport to the main component
struct global_geometry_element_struct global_geometry_element;

#ifndef ANY_GEOMETRY_DETECTOR_DECLARE
    #define ANY_GEOMETRY_DETECTOR_DECLARE dummy
	//struct pointer_to_global_geometry_list global_geometry_list = {0,NULL};
#endif

int dummy;
int loop_index,found_geometries;
int loop_2_index;
int material_index;

struct Volume_struct this_cylinder_volume;
struct cylinder_storage this_cylinder_storage;
#line 30429 "MACS_sample_kidney_box.c"
#undef number_of_activations
#undef mask_setting
#undef mask_string
#undef p_interact
#undef focus_r
#undef focus_xh
#undef focus_xw
#undef focus_ah
#undef focus_aw
#undef target_z
#undef target_y
#undef target_x
#undef target_index
#undef visualize
#undef yheight
#undef radius
#undef priority
#undef material_string
#undef this_cylinder_storage
#undef global_geometry_element
#undef this_cylinder_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

/* User declarations for component 'sample_rod_collar_2' [37]. */
#define mccompcurname  sample_rod_collar_2
#define mccompcurtype  Union_cylinder
#define mccompcurindex 37
#define loop_index mccsample_rod_collar_2_loop_index
#define this_cylinder_volume mccsample_rod_collar_2_this_cylinder_volume
#define global_geometry_element mccsample_rod_collar_2_global_geometry_element
#define this_cylinder_storage mccsample_rod_collar_2_this_cylinder_storage
#define material_string mccsample_rod_collar_2_material_string
#define priority mccsample_rod_collar_2_priority
#define radius mccsample_rod_collar_2_radius
#define yheight mccsample_rod_collar_2_yheight
#define visualize mccsample_rod_collar_2_visualize
#define target_index mccsample_rod_collar_2_target_index
#define target_x mccsample_rod_collar_2_target_x
#define target_y mccsample_rod_collar_2_target_y
#define target_z mccsample_rod_collar_2_target_z
#define focus_aw mccsample_rod_collar_2_focus_aw
#define focus_ah mccsample_rod_collar_2_focus_ah
#define focus_xw mccsample_rod_collar_2_focus_xw
#define focus_xh mccsample_rod_collar_2_focus_xh
#define focus_r mccsample_rod_collar_2_focus_r
#define p_interact mccsample_rod_collar_2_p_interact
#define mask_string mccsample_rod_collar_2_mask_string
#define mask_setting mccsample_rod_collar_2_mask_setting
#define number_of_activations mccsample_rod_collar_2_number_of_activations
#line 167 "Union_cylinder.comp"
// Needed for transport to the main component
struct global_geometry_element_struct global_geometry_element;

#ifndef ANY_GEOMETRY_DETECTOR_DECLARE
    #define ANY_GEOMETRY_DETECTOR_DECLARE dummy
	//struct pointer_to_global_geometry_list global_geometry_list = {0,NULL};
#endif

int dummy;
int loop_index,found_geometries;
int loop_2_index;
int material_index;

struct Volume_struct this_cylinder_volume;
struct cylinder_storage this_cylinder_storage;
#line 30498 "MACS_sample_kidney_box.c"
#undef number_of_activations
#undef mask_setting
#undef mask_string
#undef p_interact
#undef focus_r
#undef focus_xh
#undef focus_xw
#undef focus_ah
#undef focus_aw
#undef target_z
#undef target_y
#undef target_x
#undef target_index
#undef visualize
#undef yheight
#undef radius
#undef priority
#undef material_string
#undef this_cylinder_storage
#undef global_geometry_element
#undef this_cylinder_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

/* User declarations for component 'sample_rod_collar_3' [38]. */
#define mccompcurname  sample_rod_collar_3
#define mccompcurtype  Union_cylinder
#define mccompcurindex 38
#define loop_index mccsample_rod_collar_3_loop_index
#define this_cylinder_volume mccsample_rod_collar_3_this_cylinder_volume
#define global_geometry_element mccsample_rod_collar_3_global_geometry_element
#define this_cylinder_storage mccsample_rod_collar_3_this_cylinder_storage
#define material_string mccsample_rod_collar_3_material_string
#define priority mccsample_rod_collar_3_priority
#define radius mccsample_rod_collar_3_radius
#define yheight mccsample_rod_collar_3_yheight
#define visualize mccsample_rod_collar_3_visualize
#define target_index mccsample_rod_collar_3_target_index
#define target_x mccsample_rod_collar_3_target_x
#define target_y mccsample_rod_collar_3_target_y
#define target_z mccsample_rod_collar_3_target_z
#define focus_aw mccsample_rod_collar_3_focus_aw
#define focus_ah mccsample_rod_collar_3_focus_ah
#define focus_xw mccsample_rod_collar_3_focus_xw
#define focus_xh mccsample_rod_collar_3_focus_xh
#define focus_r mccsample_rod_collar_3_focus_r
#define p_interact mccsample_rod_collar_3_p_interact
#define mask_string mccsample_rod_collar_3_mask_string
#define mask_setting mccsample_rod_collar_3_mask_setting
#define number_of_activations mccsample_rod_collar_3_number_of_activations
#line 167 "Union_cylinder.comp"
// Needed for transport to the main component
struct global_geometry_element_struct global_geometry_element;

#ifndef ANY_GEOMETRY_DETECTOR_DECLARE
    #define ANY_GEOMETRY_DETECTOR_DECLARE dummy
	//struct pointer_to_global_geometry_list global_geometry_list = {0,NULL};
#endif

int dummy;
int loop_index,found_geometries;
int loop_2_index;
int material_index;

struct Volume_struct this_cylinder_volume;
struct cylinder_storage this_cylinder_storage;
#line 30567 "MACS_sample_kidney_box.c"
#undef number_of_activations
#undef mask_setting
#undef mask_string
#undef p_interact
#undef focus_r
#undef focus_xh
#undef focus_xw
#undef focus_ah
#undef focus_aw
#undef target_z
#undef target_y
#undef target_x
#undef target_index
#undef visualize
#undef yheight
#undef radius
#undef priority
#undef material_string
#undef this_cylinder_storage
#undef global_geometry_element
#undef this_cylinder_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

/* User declarations for component 'sample_rod_collar_4' [39]. */
#define mccompcurname  sample_rod_collar_4
#define mccompcurtype  Union_cylinder
#define mccompcurindex 39
#define loop_index mccsample_rod_collar_4_loop_index
#define this_cylinder_volume mccsample_rod_collar_4_this_cylinder_volume
#define global_geometry_element mccsample_rod_collar_4_global_geometry_element
#define this_cylinder_storage mccsample_rod_collar_4_this_cylinder_storage
#define material_string mccsample_rod_collar_4_material_string
#define priority mccsample_rod_collar_4_priority
#define radius mccsample_rod_collar_4_radius
#define yheight mccsample_rod_collar_4_yheight
#define visualize mccsample_rod_collar_4_visualize
#define target_index mccsample_rod_collar_4_target_index
#define target_x mccsample_rod_collar_4_target_x
#define target_y mccsample_rod_collar_4_target_y
#define target_z mccsample_rod_collar_4_target_z
#define focus_aw mccsample_rod_collar_4_focus_aw
#define focus_ah mccsample_rod_collar_4_focus_ah
#define focus_xw mccsample_rod_collar_4_focus_xw
#define focus_xh mccsample_rod_collar_4_focus_xh
#define focus_r mccsample_rod_collar_4_focus_r
#define p_interact mccsample_rod_collar_4_p_interact
#define mask_string mccsample_rod_collar_4_mask_string
#define mask_setting mccsample_rod_collar_4_mask_setting
#define number_of_activations mccsample_rod_collar_4_number_of_activations
#line 167 "Union_cylinder.comp"
// Needed for transport to the main component
struct global_geometry_element_struct global_geometry_element;

#ifndef ANY_GEOMETRY_DETECTOR_DECLARE
    #define ANY_GEOMETRY_DETECTOR_DECLARE dummy
	//struct pointer_to_global_geometry_list global_geometry_list = {0,NULL};
#endif

int dummy;
int loop_index,found_geometries;
int loop_2_index;
int material_index;

struct Volume_struct this_cylinder_volume;
struct cylinder_storage this_cylinder_storage;
#line 30636 "MACS_sample_kidney_box.c"
#undef number_of_activations
#undef mask_setting
#undef mask_string
#undef p_interact
#undef focus_r
#undef focus_xh
#undef focus_xw
#undef focus_ah
#undef focus_aw
#undef target_z
#undef target_y
#undef target_x
#undef target_index
#undef visualize
#undef yheight
#undef radius
#undef priority
#undef material_string
#undef this_cylinder_storage
#undef global_geometry_element
#undef this_cylinder_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

/* User declarations for component 'sample_rod_collar_1_vacuum' [40]. */
#define mccompcurname  sample_rod_collar_1_vacuum
#define mccompcurtype  Union_cylinder
#define mccompcurindex 40
#define loop_index mccsample_rod_collar_1_vacuum_loop_index
#define this_cylinder_volume mccsample_rod_collar_1_vacuum_this_cylinder_volume
#define global_geometry_element mccsample_rod_collar_1_vacuum_global_geometry_element
#define this_cylinder_storage mccsample_rod_collar_1_vacuum_this_cylinder_storage
#define material_string mccsample_rod_collar_1_vacuum_material_string
#define priority mccsample_rod_collar_1_vacuum_priority
#define radius mccsample_rod_collar_1_vacuum_radius
#define yheight mccsample_rod_collar_1_vacuum_yheight
#define visualize mccsample_rod_collar_1_vacuum_visualize
#define target_index mccsample_rod_collar_1_vacuum_target_index
#define target_x mccsample_rod_collar_1_vacuum_target_x
#define target_y mccsample_rod_collar_1_vacuum_target_y
#define target_z mccsample_rod_collar_1_vacuum_target_z
#define focus_aw mccsample_rod_collar_1_vacuum_focus_aw
#define focus_ah mccsample_rod_collar_1_vacuum_focus_ah
#define focus_xw mccsample_rod_collar_1_vacuum_focus_xw
#define focus_xh mccsample_rod_collar_1_vacuum_focus_xh
#define focus_r mccsample_rod_collar_1_vacuum_focus_r
#define p_interact mccsample_rod_collar_1_vacuum_p_interact
#define mask_string mccsample_rod_collar_1_vacuum_mask_string
#define mask_setting mccsample_rod_collar_1_vacuum_mask_setting
#define number_of_activations mccsample_rod_collar_1_vacuum_number_of_activations
#line 167 "Union_cylinder.comp"
// Needed for transport to the main component
struct global_geometry_element_struct global_geometry_element;

#ifndef ANY_GEOMETRY_DETECTOR_DECLARE
    #define ANY_GEOMETRY_DETECTOR_DECLARE dummy
	//struct pointer_to_global_geometry_list global_geometry_list = {0,NULL};
#endif

int dummy;
int loop_index,found_geometries;
int loop_2_index;
int material_index;

struct Volume_struct this_cylinder_volume;
struct cylinder_storage this_cylinder_storage;
#line 30705 "MACS_sample_kidney_box.c"
#undef number_of_activations
#undef mask_setting
#undef mask_string
#undef p_interact
#undef focus_r
#undef focus_xh
#undef focus_xw
#undef focus_ah
#undef focus_aw
#undef target_z
#undef target_y
#undef target_x
#undef target_index
#undef visualize
#undef yheight
#undef radius
#undef priority
#undef material_string
#undef this_cylinder_storage
#undef global_geometry_element
#undef this_cylinder_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

/* User declarations for component 'sample_rod_collar_2_vacuum' [41]. */
#define mccompcurname  sample_rod_collar_2_vacuum
#define mccompcurtype  Union_cylinder
#define mccompcurindex 41
#define loop_index mccsample_rod_collar_2_vacuum_loop_index
#define this_cylinder_volume mccsample_rod_collar_2_vacuum_this_cylinder_volume
#define global_geometry_element mccsample_rod_collar_2_vacuum_global_geometry_element
#define this_cylinder_storage mccsample_rod_collar_2_vacuum_this_cylinder_storage
#define material_string mccsample_rod_collar_2_vacuum_material_string
#define priority mccsample_rod_collar_2_vacuum_priority
#define radius mccsample_rod_collar_2_vacuum_radius
#define yheight mccsample_rod_collar_2_vacuum_yheight
#define visualize mccsample_rod_collar_2_vacuum_visualize
#define target_index mccsample_rod_collar_2_vacuum_target_index
#define target_x mccsample_rod_collar_2_vacuum_target_x
#define target_y mccsample_rod_collar_2_vacuum_target_y
#define target_z mccsample_rod_collar_2_vacuum_target_z
#define focus_aw mccsample_rod_collar_2_vacuum_focus_aw
#define focus_ah mccsample_rod_collar_2_vacuum_focus_ah
#define focus_xw mccsample_rod_collar_2_vacuum_focus_xw
#define focus_xh mccsample_rod_collar_2_vacuum_focus_xh
#define focus_r mccsample_rod_collar_2_vacuum_focus_r
#define p_interact mccsample_rod_collar_2_vacuum_p_interact
#define mask_string mccsample_rod_collar_2_vacuum_mask_string
#define mask_setting mccsample_rod_collar_2_vacuum_mask_setting
#define number_of_activations mccsample_rod_collar_2_vacuum_number_of_activations
#line 167 "Union_cylinder.comp"
// Needed for transport to the main component
struct global_geometry_element_struct global_geometry_element;

#ifndef ANY_GEOMETRY_DETECTOR_DECLARE
    #define ANY_GEOMETRY_DETECTOR_DECLARE dummy
	//struct pointer_to_global_geometry_list global_geometry_list = {0,NULL};
#endif

int dummy;
int loop_index,found_geometries;
int loop_2_index;
int material_index;

struct Volume_struct this_cylinder_volume;
struct cylinder_storage this_cylinder_storage;
#line 30774 "MACS_sample_kidney_box.c"
#undef number_of_activations
#undef mask_setting
#undef mask_string
#undef p_interact
#undef focus_r
#undef focus_xh
#undef focus_xw
#undef focus_ah
#undef focus_aw
#undef target_z
#undef target_y
#undef target_x
#undef target_index
#undef visualize
#undef yheight
#undef radius
#undef priority
#undef material_string
#undef this_cylinder_storage
#undef global_geometry_element
#undef this_cylinder_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

/* User declarations for component 'sample_rod_collar_3_vacuum' [42]. */
#define mccompcurname  sample_rod_collar_3_vacuum
#define mccompcurtype  Union_cylinder
#define mccompcurindex 42
#define loop_index mccsample_rod_collar_3_vacuum_loop_index
#define this_cylinder_volume mccsample_rod_collar_3_vacuum_this_cylinder_volume
#define global_geometry_element mccsample_rod_collar_3_vacuum_global_geometry_element
#define this_cylinder_storage mccsample_rod_collar_3_vacuum_this_cylinder_storage
#define material_string mccsample_rod_collar_3_vacuum_material_string
#define priority mccsample_rod_collar_3_vacuum_priority
#define radius mccsample_rod_collar_3_vacuum_radius
#define yheight mccsample_rod_collar_3_vacuum_yheight
#define visualize mccsample_rod_collar_3_vacuum_visualize
#define target_index mccsample_rod_collar_3_vacuum_target_index
#define target_x mccsample_rod_collar_3_vacuum_target_x
#define target_y mccsample_rod_collar_3_vacuum_target_y
#define target_z mccsample_rod_collar_3_vacuum_target_z
#define focus_aw mccsample_rod_collar_3_vacuum_focus_aw
#define focus_ah mccsample_rod_collar_3_vacuum_focus_ah
#define focus_xw mccsample_rod_collar_3_vacuum_focus_xw
#define focus_xh mccsample_rod_collar_3_vacuum_focus_xh
#define focus_r mccsample_rod_collar_3_vacuum_focus_r
#define p_interact mccsample_rod_collar_3_vacuum_p_interact
#define mask_string mccsample_rod_collar_3_vacuum_mask_string
#define mask_setting mccsample_rod_collar_3_vacuum_mask_setting
#define number_of_activations mccsample_rod_collar_3_vacuum_number_of_activations
#line 167 "Union_cylinder.comp"
// Needed for transport to the main component
struct global_geometry_element_struct global_geometry_element;

#ifndef ANY_GEOMETRY_DETECTOR_DECLARE
    #define ANY_GEOMETRY_DETECTOR_DECLARE dummy
	//struct pointer_to_global_geometry_list global_geometry_list = {0,NULL};
#endif

int dummy;
int loop_index,found_geometries;
int loop_2_index;
int material_index;

struct Volume_struct this_cylinder_volume;
struct cylinder_storage this_cylinder_storage;
#line 30843 "MACS_sample_kidney_box.c"
#undef number_of_activations
#undef mask_setting
#undef mask_string
#undef p_interact
#undef focus_r
#undef focus_xh
#undef focus_xw
#undef focus_ah
#undef focus_aw
#undef target_z
#undef target_y
#undef target_x
#undef target_index
#undef visualize
#undef yheight
#undef radius
#undef priority
#undef material_string
#undef this_cylinder_storage
#undef global_geometry_element
#undef this_cylinder_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

/* User declarations for component 'sample_rod_collar_4_vacuum' [43]. */
#define mccompcurname  sample_rod_collar_4_vacuum
#define mccompcurtype  Union_cylinder
#define mccompcurindex 43
#define loop_index mccsample_rod_collar_4_vacuum_loop_index
#define this_cylinder_volume mccsample_rod_collar_4_vacuum_this_cylinder_volume
#define global_geometry_element mccsample_rod_collar_4_vacuum_global_geometry_element
#define this_cylinder_storage mccsample_rod_collar_4_vacuum_this_cylinder_storage
#define material_string mccsample_rod_collar_4_vacuum_material_string
#define priority mccsample_rod_collar_4_vacuum_priority
#define radius mccsample_rod_collar_4_vacuum_radius
#define yheight mccsample_rod_collar_4_vacuum_yheight
#define visualize mccsample_rod_collar_4_vacuum_visualize
#define target_index mccsample_rod_collar_4_vacuum_target_index
#define target_x mccsample_rod_collar_4_vacuum_target_x
#define target_y mccsample_rod_collar_4_vacuum_target_y
#define target_z mccsample_rod_collar_4_vacuum_target_z
#define focus_aw mccsample_rod_collar_4_vacuum_focus_aw
#define focus_ah mccsample_rod_collar_4_vacuum_focus_ah
#define focus_xw mccsample_rod_collar_4_vacuum_focus_xw
#define focus_xh mccsample_rod_collar_4_vacuum_focus_xh
#define focus_r mccsample_rod_collar_4_vacuum_focus_r
#define p_interact mccsample_rod_collar_4_vacuum_p_interact
#define mask_string mccsample_rod_collar_4_vacuum_mask_string
#define mask_setting mccsample_rod_collar_4_vacuum_mask_setting
#define number_of_activations mccsample_rod_collar_4_vacuum_number_of_activations
#line 167 "Union_cylinder.comp"
// Needed for transport to the main component
struct global_geometry_element_struct global_geometry_element;

#ifndef ANY_GEOMETRY_DETECTOR_DECLARE
    #define ANY_GEOMETRY_DETECTOR_DECLARE dummy
	//struct pointer_to_global_geometry_list global_geometry_list = {0,NULL};
#endif

int dummy;
int loop_index,found_geometries;
int loop_2_index;
int material_index;

struct Volume_struct this_cylinder_volume;
struct cylinder_storage this_cylinder_storage;
#line 30912 "MACS_sample_kidney_box.c"
#undef number_of_activations
#undef mask_setting
#undef mask_string
#undef p_interact
#undef focus_r
#undef focus_xh
#undef focus_xw
#undef focus_ah
#undef focus_aw
#undef target_z
#undef target_y
#undef target_x
#undef target_index
#undef visualize
#undef yheight
#undef radius
#undef priority
#undef material_string
#undef this_cylinder_storage
#undef global_geometry_element
#undef this_cylinder_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

/* User declarations for component 'resolution_sample_exit' [44]. */
#define mccompcurname  resolution_sample_exit
#define mccompcurtype  Union_cylinder
#define mccompcurindex 44
#define loop_index mccresolution_sample_exit_loop_index
#define this_cylinder_volume mccresolution_sample_exit_this_cylinder_volume
#define global_geometry_element mccresolution_sample_exit_global_geometry_element
#define this_cylinder_storage mccresolution_sample_exit_this_cylinder_storage
#define material_string mccresolution_sample_exit_material_string
#define priority mccresolution_sample_exit_priority
#define radius mccresolution_sample_exit_radius
#define yheight mccresolution_sample_exit_yheight
#define visualize mccresolution_sample_exit_visualize
#define target_index mccresolution_sample_exit_target_index
#define target_x mccresolution_sample_exit_target_x
#define target_y mccresolution_sample_exit_target_y
#define target_z mccresolution_sample_exit_target_z
#define focus_aw mccresolution_sample_exit_focus_aw
#define focus_ah mccresolution_sample_exit_focus_ah
#define focus_xw mccresolution_sample_exit_focus_xw
#define focus_xh mccresolution_sample_exit_focus_xh
#define focus_r mccresolution_sample_exit_focus_r
#define p_interact mccresolution_sample_exit_p_interact
#define mask_string mccresolution_sample_exit_mask_string
#define mask_setting mccresolution_sample_exit_mask_setting
#define number_of_activations mccresolution_sample_exit_number_of_activations
#line 167 "Union_cylinder.comp"
// Needed for transport to the main component
struct global_geometry_element_struct global_geometry_element;

#ifndef ANY_GEOMETRY_DETECTOR_DECLARE
    #define ANY_GEOMETRY_DETECTOR_DECLARE dummy
	//struct pointer_to_global_geometry_list global_geometry_list = {0,NULL};
#endif

int dummy;
int loop_index,found_geometries;
int loop_2_index;
int material_index;

struct Volume_struct this_cylinder_volume;
struct cylinder_storage this_cylinder_storage;
#line 30981 "MACS_sample_kidney_box.c"
#undef number_of_activations
#undef mask_setting
#undef mask_string
#undef p_interact
#undef focus_r
#undef focus_xh
#undef focus_xw
#undef focus_ah
#undef focus_aw
#undef target_z
#undef target_y
#undef target_x
#undef target_index
#undef visualize
#undef yheight
#undef radius
#undef priority
#undef material_string
#undef this_cylinder_storage
#undef global_geometry_element
#undef this_cylinder_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

/* User declarations for component 'sample_cryostat' [45]. */
#define mccompcurname  sample_cryostat
#define mccompcurtype  Union_master
#define mccompcurindex 45
#define verbal mccsample_cryostat_verbal
#define list_verbal mccsample_cryostat_list_verbal
#define trace_verbal mccsample_cryostat_trace_verbal
#define finally_verbal mccsample_cryostat_finally_verbal
#define starting_volume_warning mccsample_cryostat_starting_volume_warning
#define global_master_element mccsample_cryostat_global_master_element
#define this_global_master_index mccsample_cryostat_this_global_master_index
#define previous_master_index mccsample_cryostat_previous_master_index
#define geometry_list_index mccsample_cryostat_geometry_list_index
#define intersection_time_table mccsample_cryostat_intersection_time_table
#define Volumes mccsample_cryostat_Volumes
#define Geometries mccsample_cryostat_Geometries
#define starting_lists mccsample_cryostat_starting_lists
#define r mccsample_cryostat_r
#define r_start mccsample_cryostat_r_start
#define v mccsample_cryostat_v
#define error_msg mccsample_cryostat_error_msg
#define component_error_msg mccsample_cryostat_component_error_msg
#define string_output mccsample_cryostat_string_output
#define number_of_volumes mccsample_cryostat_number_of_volumes
#define volume_index mccsample_cryostat_volume_index
#define process_index mccsample_cryostat_process_index
#define solutions mccsample_cryostat_solutions
#define max_number_of_processes mccsample_cryostat_max_number_of_processes
#define limit mccsample_cryostat_limit
#define solution mccsample_cryostat_solution
#define min_solution mccsample_cryostat_min_solution
#define min_volume mccsample_cryostat_min_volume
#define time_found mccsample_cryostat_time_found
#define intersection_time mccsample_cryostat_intersection_time
#define min_intersection_time mccsample_cryostat_min_intersection_time
#define process mccsample_cryostat_process
#define process_start mccsample_cryostat_process_start
#define my_trace mccsample_cryostat_my_trace
#define p_my_trace mccsample_cryostat_p_my_trace
#define my_trace_fraction_control mccsample_cryostat_my_trace_fraction_control
#define k mccsample_cryostat_k
#define k_new mccsample_cryostat_k_new
#define k_old mccsample_cryostat_k_old
#define v_length mccsample_cryostat_v_length
#define my_sum mccsample_cryostat_my_sum
#define my_sum_plus_abs mccsample_cryostat_my_sum_plus_abs
#define culmative_probability mccsample_cryostat_culmative_probability
#define mc_prop mccsample_cryostat_mc_prop
#define time_to_scattering mccsample_cryostat_time_to_scattering
#define length_to_scattering mccsample_cryostat_length_to_scattering
#define length_to_boundery mccsample_cryostat_length_to_boundery
#define time_to_boundery mccsample_cryostat_time_to_boundery
#define selected_process mccsample_cryostat_selected_process
#define scattering_event mccsample_cryostat_scattering_event
#define time_propagated_without_scattering mccsample_cryostat_time_propagated_without_scattering
#define a_next_volume_found mccsample_cryostat_a_next_volume_found
#define next_volume mccsample_cryostat_next_volume
#define next_volume_priority mccsample_cryostat_next_volume_priority
#define done mccsample_cryostat_done
#define current_volume mccsample_cryostat_current_volume
#define number_of_solutions mccsample_cryostat_number_of_solutions
#define number_of_solutions_static mccsample_cryostat_number_of_solutions_static
#define check mccsample_cryostat_check
#define start mccsample_cryostat_start
#define intersection_with_children mccsample_cryostat_intersection_with_children
#define geometry_output mccsample_cryostat_geometry_output
#define tree_next_volume mccsample_cryostat_tree_next_volume
#define pre_allocated1 mccsample_cryostat_pre_allocated1
#define pre_allocated2 mccsample_cryostat_pre_allocated2
#define pre_allocated3 mccsample_cryostat_pre_allocated3
#define ray_position mccsample_cryostat_ray_position
#define ray_velocity mccsample_cryostat_ray_velocity
#define ray_velocity_final mccsample_cryostat_ray_velocity_final
#define volume_0_found mccsample_cryostat_volume_0_found
#define scattered_flag mccsample_cryostat_scattered_flag
#define scattered_flag_VP mccsample_cryostat_scattered_flag_VP
#define master_transposed_rotation_matrix mccsample_cryostat_master_transposed_rotation_matrix
#define temp_rotation_matrix mccsample_cryostat_temp_rotation_matrix
#define non_rotated_position mccsample_cryostat_non_rotated_position
#define rotated_position mccsample_cryostat_rotated_position
#define enable_tagging mccsample_cryostat_enable_tagging
#define stop_tagging_ray mccsample_cryostat_stop_tagging_ray
#define stop_creating_nodes mccsample_cryostat_stop_creating_nodes
#define enable_tagging_check mccsample_cryostat_enable_tagging_check
#define master_tagging_node_list mccsample_cryostat_master_tagging_node_list
#define current_tagging_node mccsample_cryostat_current_tagging_node
#define tagging_leaf_counter mccsample_cryostat_tagging_leaf_counter
#define number_of_scattering_events mccsample_cryostat_number_of_scattering_events
#define real_transmission_probability mccsample_cryostat_real_transmission_probability
#define mc_transmission_probability mccsample_cryostat_mc_transmission_probability
#define number_of_masks mccsample_cryostat_number_of_masks
#define number_of_masked_volumes mccsample_cryostat_number_of_masked_volumes
#define need_to_run_within_which_volume mccsample_cryostat_need_to_run_within_which_volume
#define mask_index_main mccsample_cryostat_mask_index_main
#define mask_iterate mccsample_cryostat_mask_iterate
#define mask_status_list mccsample_cryostat_mask_status_list
#define current_mask_intersect_list_status mccsample_cryostat_current_mask_intersect_list_status
#define mask_volume_index_list mccsample_cryostat_mask_volume_index_list
#define geometry_component_index_list mccsample_cryostat_geometry_component_index_list
#define Volume_copies_allocated mccsample_cryostat_Volume_copies_allocated
#define p_old mccsample_cryostat_p_old
#define this_logger mccsample_cryostat_this_logger
#define conditional_status mccsample_cryostat_conditional_status
#define tagging_conditional_list mccsample_cryostat_tagging_conditional_list
#define free_tagging_conditioanl_list mccsample_cryostat_free_tagging_conditioanl_list
#define logger_conditional_extend_array mccsample_cryostat_logger_conditional_extend_array
#define tagging_conditional_extend mccsample_cryostat_tagging_conditional_extend
#define max_conditional_extend_index mccsample_cryostat_max_conditional_extend_index
#define safty_distance mccsample_cryostat_safty_distance
#define safty_distance2 mccsample_cryostat_safty_distance2
#define number_of_processes_array mccsample_cryostat_number_of_processes_array
#define temporary_focus_data mccsample_cryostat_temporary_focus_data
#define focus_data_index mccsample_cryostat_focus_data_index
#define allow_inside_start mccsample_cryostat_allow_inside_start
#define history_limit mccsample_cryostat_history_limit
#define enable_conditionals mccsample_cryostat_enable_conditionals
#define inherit_number_of_scattering_events mccsample_cryostat_inherit_number_of_scattering_events
#line 68 "Union_master.comp"
  // Settings that can be moved to input.
  int verbal = 1;
  int list_verbal = 1;
  int finally_verbal = 0;
  
  // Performance intensive, and should be done in precompiler
  int trace_verbal = 0;
  int enable_tagging = 0;

  // It is possible to surpress warnings on starting volume by setting this to 1
  int starting_volume_warning = 0;
  
  // New precompiler settings
  //#define Union_trace_verbal_setting
  //#define Union_enable_tagging_setting

  // Declare the global variables (not to be in output parameters)
  struct global_master_element_struct global_master_element;
  int this_global_master_index;
  
  #ifndef MASTER_DETECTOR
	//struct pointer_to_global_master_list global_master_list = {0,NULL};
	#define MASTER_DETECTOR dummy
  #endif
  
  // variables used for assigning global information to local variables
  int previous_master_index,geometry_list_index;

  // The main structures used in this component
  struct intersection_time_table_struct intersection_time_table;
  struct Volume_struct **Volumes;
  struct geometry_struct **Geometries;
  struct Volume_struct **Volume_copies;
  struct starting_lists_struct starting_lists;
  
  // garbage collection for volume_copies
  struct pointer_to_1d_int_list Volume_copies_allocated;

  // Vectors in old format (still used by intersect function, will go to Coords in future)
  double r[3],r_start[3],v[3];

  // Error handling
  int error_msg, component_error_msg=0;
  
  // For verbal output
  char string_output[128];
  
  // Variables for ray-tracing algorithm
  int number_of_volumes, volume_index, process_index;
  int iterate,solutions,max_number_of_processes,limit;
  int solution,min_solution,min_volume,time_found;
  double intersection_time,min_intersection_time;
  
  struct scattering_process_struct *process,*process_start;
  double *my_trace,*p_my_trace,*my_trace_fraction_control;
  double k[3],k_new[3],k_old[3],k_rotated[3];
  double v_length,my_sum,my_sum_plus_abs,culmative_probability,mc_prop,time_to_scattering;
  double length_to_scattering,length_to_boundery,length_to_boundery_fp,time_to_boundery;
  int selected_process,scattering_event;
  double time_propagated_without_scattering;
  
  int a_next_volume_found,next_volume;
  double next_volume_priority;
  
  int done,current_volume,ray_sucseeded;
  int *number_of_solutions;
  int number_of_solutions_static;
  int *check,*start;
  int intersection_with_children,geometry_output;
  
  // For within_which_volume
  int tree_next_volume;
  int *pre_allocated1,*pre_allocated2,*pre_allocated3;
  Coords ray_position,ray_velocity,ray_velocity_rotated,ray_velocity_final,wavevector,wavevector_rotated;
  int volume_0_found=0;
  
  int *scattered_flag;
  int **scattered_flag_VP;
  
  // For coordinate transformations
  Rotation master_transposed_rotation_matrix;
  Rotation temp_rotation_matrix;
  Rotation temp_transpose_rotation_matrix;
  Coords non_rotated_position;
  Coords rotated_position;
  int non_isotropic_found;
  
  // For tagging
  struct list_of_tagging_tree_node_pointers master_tagging_node_list;
  struct tagging_tree_node_struct *current_tagging_node;
  
  int tagging_leaf_counter=0,stop_tagging_ray,stop_creating_nodes;
  int number_of_scattering_events;
  
  // For geometry p interact
  double real_transmission_probability,mc_transmission_probability;
  
  // Process p interact
  int number_of_process_interacts_set,index_of_lacking_process;
  double total_process_interact;
  
  // Volume nr -> component index
  struct pointer_to_1d_int_list geometry_component_index_list;
  
  // Masks
  struct pointer_to_1d_int_list mask_volume_index_list;
  int number_of_masks=0;
  int number_of_masked_volumes=0;
  struct pointer_to_1d_int_list mask_status_list;
  struct pointer_to_1d_int_list current_mask_intersect_list_status;
  int mask_index_main,mask_iterate;
  int *mask_start,*mask_check;
  int need_to_run_within_which_volume;
  
  // Loggers
  //struct logger_with_data_struct loggers_with_data_array;
  int *number_of_processes_array;
  double p_old;
  int log_index,conditional_status;
  struct logger_struct *this_logger;
  //  union detector_pointer_union detector_pointer;
  
  // Conditionals
  struct conditional_list_struct *tagging_conditional_list;
  int *logger_conditional_extend_array;
  int max_conditional_extend_index;
  int tagging_conditional_extend;
  int free_tagging_conditioanl_list;
  
  // Reliability control
  // Safty distance is needed to avoid having ray positions closer to a wall than the precision of intersection functions
  double safty_distance,safty_distance2;
  
  // Focusing
  struct focus_data_struct temporary_focus_data;
  int focus_data_index;
  
#line 31263 "MACS_sample_kidney_box.c"
#undef inherit_number_of_scattering_events
#undef enable_conditionals
#undef history_limit
#undef allow_inside_start
#undef focus_data_index
#undef temporary_focus_data
#undef number_of_processes_array
#undef safty_distance2
#undef safty_distance
#undef max_conditional_extend_index
#undef tagging_conditional_extend
#undef logger_conditional_extend_array
#undef free_tagging_conditioanl_list
#undef tagging_conditional_list
#undef conditional_status
#undef this_logger
#undef p_old
#undef Volume_copies_allocated
#undef geometry_component_index_list
#undef mask_volume_index_list
#undef current_mask_intersect_list_status
#undef mask_status_list
#undef mask_iterate
#undef mask_index_main
#undef need_to_run_within_which_volume
#undef number_of_masked_volumes
#undef number_of_masks
#undef mc_transmission_probability
#undef real_transmission_probability
#undef number_of_scattering_events
#undef tagging_leaf_counter
#undef current_tagging_node
#undef master_tagging_node_list
#undef enable_tagging_check
#undef stop_creating_nodes
#undef stop_tagging_ray
#undef enable_tagging
#undef rotated_position
#undef non_rotated_position
#undef temp_rotation_matrix
#undef master_transposed_rotation_matrix
#undef scattered_flag_VP
#undef scattered_flag
#undef volume_0_found
#undef ray_velocity_final
#undef ray_velocity
#undef ray_position
#undef pre_allocated3
#undef pre_allocated2
#undef pre_allocated1
#undef tree_next_volume
#undef geometry_output
#undef intersection_with_children
#undef start
#undef check
#undef number_of_solutions_static
#undef number_of_solutions
#undef current_volume
#undef done
#undef next_volume_priority
#undef next_volume
#undef a_next_volume_found
#undef time_propagated_without_scattering
#undef scattering_event
#undef selected_process
#undef time_to_boundery
#undef length_to_boundery
#undef length_to_scattering
#undef time_to_scattering
#undef mc_prop
#undef culmative_probability
#undef my_sum_plus_abs
#undef my_sum
#undef v_length
#undef k_old
#undef k_new
#undef k
#undef my_trace_fraction_control
#undef p_my_trace
#undef my_trace
#undef process_start
#undef process
#undef min_intersection_time
#undef intersection_time
#undef time_found
#undef min_volume
#undef min_solution
#undef solution
#undef limit
#undef max_number_of_processes
#undef solutions
#undef process_index
#undef volume_index
#undef number_of_volumes
#undef string_output
#undef component_error_msg
#undef error_msg
#undef v
#undef r_start
#undef r
#undef starting_lists
#undef Geometries
#undef Volumes
#undef intersection_time_table
#undef geometry_list_index
#undef previous_master_index
#undef this_global_master_index
#undef global_master_element
#undef starting_volume_warning
#undef finally_verbal
#undef trace_verbal
#undef list_verbal
#undef verbal
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

/* User declarations for component 'Resolution_sample' [46]. */
#define mccompcurname  Resolution_sample
#define mccompcurtype  Res_sample
#define mccompcurindex 46
#define res_struct mccResolution_sample_res_struct
#define thickness mccResolution_sample_thickness
#define radius mccResolution_sample_radius
#define focus_r mccResolution_sample_focus_r
#define E0 mccResolution_sample_E0
#define dE mccResolution_sample_dE
#define target_x mccResolution_sample_target_x
#define target_y mccResolution_sample_target_y
#define target_z mccResolution_sample_target_z
#define focus_xw mccResolution_sample_focus_xw
#define focus_yh mccResolution_sample_focus_yh
#define focus_aw mccResolution_sample_focus_aw
#define focus_ah mccResolution_sample_focus_ah
#define xwidth mccResolution_sample_xwidth
#define yheight mccResolution_sample_yheight
#define zdepth mccResolution_sample_zdepth
#define target_index mccResolution_sample_target_index
#line 84 "/usr/share/mcstas/2.7/samples/Res_sample.comp"
struct Res_sample_struct res_struct;
#line 31404 "MACS_sample_kidney_box.c"
#undef target_index
#undef zdepth
#undef yheight
#undef xwidth
#undef focus_ah
#undef focus_aw
#undef focus_yh
#undef focus_xw
#undef target_z
#undef target_y
#undef target_x
#undef dE
#undef E0
#undef focus_r
#undef radius
#undef thickness
#undef res_struct
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

/* User declarations for component 'post_sample_beamstop' [47]. */
#define mccompcurname  post_sample_beamstop
#define mccompcurtype  Beamstop
#define mccompcurindex 47
#define xmin mccpost_sample_beamstop_xmin
#define xmax mccpost_sample_beamstop_xmax
#define ymin mccpost_sample_beamstop_ymin
#define ymax mccpost_sample_beamstop_ymax
#define xwidth mccpost_sample_beamstop_xwidth
#define yheight mccpost_sample_beamstop_yheight
#define radius mccpost_sample_beamstop_radius
#undef radius
#undef yheight
#undef xwidth
#undef ymax
#undef ymin
#undef xmax
#undef xmin
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

/* User declarations for component 'kidney_master' [48]. */
#define mccompcurname  kidney_master
#define mccompcurtype  Arm
#define mccompcurindex 48
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

/* User declarations for component 'kidney_channel_0' [49]. */
#define mccompcurname  kidney_channel_0
#define mccompcurtype  Arm
#define mccompcurindex 49
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

/* User declarations for component 'kidney_channel_1' [50]. */
#define mccompcurname  kidney_channel_1
#define mccompcurtype  Arm
#define mccompcurindex 50
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

/* User declarations for component 'kidney_channel_2' [51]. */
#define mccompcurname  kidney_channel_2
#define mccompcurtype  Arm
#define mccompcurindex 51
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

/* User declarations for component 'kidney_channel_3' [52]. */
#define mccompcurname  kidney_channel_3
#define mccompcurtype  Arm
#define mccompcurindex 52
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

/* User declarations for component 'kidney_channel_4' [53]. */
#define mccompcurname  kidney_channel_4
#define mccompcurtype  Arm
#define mccompcurindex 53
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

/* User declarations for component 'kidney_channel_5' [54]. */
#define mccompcurname  kidney_channel_5
#define mccompcurtype  Arm
#define mccompcurindex 54
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

/* User declarations for component 'kidney_channel_6' [55]. */
#define mccompcurname  kidney_channel_6
#define mccompcurtype  Arm
#define mccompcurindex 55
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

/* User declarations for component 'kidney_channel_7' [56]. */
#define mccompcurname  kidney_channel_7
#define mccompcurtype  Arm
#define mccompcurindex 56
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

/* User declarations for component 'kidney_channel_8' [57]. */
#define mccompcurname  kidney_channel_8
#define mccompcurtype  Arm
#define mccompcurindex 57
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

/* User declarations for component 'kidney_channel_9' [58]. */
#define mccompcurname  kidney_channel_9
#define mccompcurtype  Arm
#define mccompcurindex 58
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

/* User declarations for component 'kidney_channel_10' [59]. */
#define mccompcurname  kidney_channel_10
#define mccompcurtype  Arm
#define mccompcurindex 59
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

/* User declarations for component 'kidney_channel_11' [60]. */
#define mccompcurname  kidney_channel_11
#define mccompcurtype  Arm
#define mccompcurindex 60
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

/* User declarations for component 'kidney_channel_12' [61]. */
#define mccompcurname  kidney_channel_12
#define mccompcurtype  Arm
#define mccompcurindex 61
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

/* User declarations for component 'kidney_channel_13' [62]. */
#define mccompcurname  kidney_channel_13
#define mccompcurtype  Arm
#define mccompcurindex 62
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

/* User declarations for component 'kidney_channel_14' [63]. */
#define mccompcurname  kidney_channel_14
#define mccompcurtype  Arm
#define mccompcurindex 63
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

/* User declarations for component 'kidney_channel_15' [64]. */
#define mccompcurname  kidney_channel_15
#define mccompcurtype  Arm
#define mccompcurindex 64
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

/* User declarations for component 'kidney_channel_16' [65]. */
#define mccompcurname  kidney_channel_16
#define mccompcurtype  Arm
#define mccompcurindex 65
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

/* User declarations for component 'kidney_channel_17' [66]. */
#define mccompcurname  kidney_channel_17
#define mccompcurtype  Arm
#define mccompcurindex 66
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

/* User declarations for component 'kidney_channel_18' [67]. */
#define mccompcurname  kidney_channel_18
#define mccompcurtype  Arm
#define mccompcurindex 67
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

/* User declarations for component 'kidney_channel_19' [68]. */
#define mccompcurname  kidney_channel_19
#define mccompcurtype  Arm
#define mccompcurindex 68
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

/* User declarations for component 'channel_0_filter' [69]. */
#define mccompcurname  channel_0_filter
#define mccompcurtype  Slit_MACS
#define mccompcurindex 69
#define xmin mccchannel_0_filter_xmin
#define xmax mccchannel_0_filter_xmax
#define ymin mccchannel_0_filter_ymin
#define ymax mccchannel_0_filter_ymax
#define radius mccchannel_0_filter_radius
#define xwidth mccchannel_0_filter_xwidth
#define yheight mccchannel_0_filter_yheight
#undef yheight
#undef xwidth
#undef radius
#undef ymax
#undef ymin
#undef xmax
#undef xmin
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

/* User declarations for component 'channel_1_filter' [70]. */
#define mccompcurname  channel_1_filter
#define mccompcurtype  Slit_MACS
#define mccompcurindex 70
#define xmin mccchannel_1_filter_xmin
#define xmax mccchannel_1_filter_xmax
#define ymin mccchannel_1_filter_ymin
#define ymax mccchannel_1_filter_ymax
#define radius mccchannel_1_filter_radius
#define xwidth mccchannel_1_filter_xwidth
#define yheight mccchannel_1_filter_yheight
#undef yheight
#undef xwidth
#undef radius
#undef ymax
#undef ymin
#undef xmax
#undef xmin
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

/* User declarations for component 'channel_2_filter' [71]. */
#define mccompcurname  channel_2_filter
#define mccompcurtype  Slit_MACS
#define mccompcurindex 71
#define xmin mccchannel_2_filter_xmin
#define xmax mccchannel_2_filter_xmax
#define ymin mccchannel_2_filter_ymin
#define ymax mccchannel_2_filter_ymax
#define radius mccchannel_2_filter_radius
#define xwidth mccchannel_2_filter_xwidth
#define yheight mccchannel_2_filter_yheight
#undef yheight
#undef xwidth
#undef radius
#undef ymax
#undef ymin
#undef xmax
#undef xmin
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

/* User declarations for component 'channel_3_filter' [72]. */
#define mccompcurname  channel_3_filter
#define mccompcurtype  Slit_MACS
#define mccompcurindex 72
#define xmin mccchannel_3_filter_xmin
#define xmax mccchannel_3_filter_xmax
#define ymin mccchannel_3_filter_ymin
#define ymax mccchannel_3_filter_ymax
#define radius mccchannel_3_filter_radius
#define xwidth mccchannel_3_filter_xwidth
#define yheight mccchannel_3_filter_yheight
#undef yheight
#undef xwidth
#undef radius
#undef ymax
#undef ymin
#undef xmax
#undef xmin
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

/* User declarations for component 'channel_4_filter' [73]. */
#define mccompcurname  channel_4_filter
#define mccompcurtype  Slit_MACS
#define mccompcurindex 73
#define xmin mccchannel_4_filter_xmin
#define xmax mccchannel_4_filter_xmax
#define ymin mccchannel_4_filter_ymin
#define ymax mccchannel_4_filter_ymax
#define radius mccchannel_4_filter_radius
#define xwidth mccchannel_4_filter_xwidth
#define yheight mccchannel_4_filter_yheight
#undef yheight
#undef xwidth
#undef radius
#undef ymax
#undef ymin
#undef xmax
#undef xmin
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

/* User declarations for component 'channel_5_filter' [74]. */
#define mccompcurname  channel_5_filter
#define mccompcurtype  Slit_MACS
#define mccompcurindex 74
#define xmin mccchannel_5_filter_xmin
#define xmax mccchannel_5_filter_xmax
#define ymin mccchannel_5_filter_ymin
#define ymax mccchannel_5_filter_ymax
#define radius mccchannel_5_filter_radius
#define xwidth mccchannel_5_filter_xwidth
#define yheight mccchannel_5_filter_yheight
#undef yheight
#undef xwidth
#undef radius
#undef ymax
#undef ymin
#undef xmax
#undef xmin
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

/* User declarations for component 'channel_6_filter' [75]. */
#define mccompcurname  channel_6_filter
#define mccompcurtype  Slit_MACS
#define mccompcurindex 75
#define xmin mccchannel_6_filter_xmin
#define xmax mccchannel_6_filter_xmax
#define ymin mccchannel_6_filter_ymin
#define ymax mccchannel_6_filter_ymax
#define radius mccchannel_6_filter_radius
#define xwidth mccchannel_6_filter_xwidth
#define yheight mccchannel_6_filter_yheight
#undef yheight
#undef xwidth
#undef radius
#undef ymax
#undef ymin
#undef xmax
#undef xmin
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

/* User declarations for component 'channel_7_filter' [76]. */
#define mccompcurname  channel_7_filter
#define mccompcurtype  Slit_MACS
#define mccompcurindex 76
#define xmin mccchannel_7_filter_xmin
#define xmax mccchannel_7_filter_xmax
#define ymin mccchannel_7_filter_ymin
#define ymax mccchannel_7_filter_ymax
#define radius mccchannel_7_filter_radius
#define xwidth mccchannel_7_filter_xwidth
#define yheight mccchannel_7_filter_yheight
#undef yheight
#undef xwidth
#undef radius
#undef ymax
#undef ymin
#undef xmax
#undef xmin
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

/* User declarations for component 'channel_8_filter' [77]. */
#define mccompcurname  channel_8_filter
#define mccompcurtype  Slit_MACS
#define mccompcurindex 77
#define xmin mccchannel_8_filter_xmin
#define xmax mccchannel_8_filter_xmax
#define ymin mccchannel_8_filter_ymin
#define ymax mccchannel_8_filter_ymax
#define radius mccchannel_8_filter_radius
#define xwidth mccchannel_8_filter_xwidth
#define yheight mccchannel_8_filter_yheight
#undef yheight
#undef xwidth
#undef radius
#undef ymax
#undef ymin
#undef xmax
#undef xmin
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

/* User declarations for component 'channel_9_filter' [78]. */
#define mccompcurname  channel_9_filter
#define mccompcurtype  Slit_MACS
#define mccompcurindex 78
#define xmin mccchannel_9_filter_xmin
#define xmax mccchannel_9_filter_xmax
#define ymin mccchannel_9_filter_ymin
#define ymax mccchannel_9_filter_ymax
#define radius mccchannel_9_filter_radius
#define xwidth mccchannel_9_filter_xwidth
#define yheight mccchannel_9_filter_yheight
#undef yheight
#undef xwidth
#undef radius
#undef ymax
#undef ymin
#undef xmax
#undef xmin
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

/* User declarations for component 'channel_10_filter' [79]. */
#define mccompcurname  channel_10_filter
#define mccompcurtype  Slit_MACS
#define mccompcurindex 79
#define xmin mccchannel_10_filter_xmin
#define xmax mccchannel_10_filter_xmax
#define ymin mccchannel_10_filter_ymin
#define ymax mccchannel_10_filter_ymax
#define radius mccchannel_10_filter_radius
#define xwidth mccchannel_10_filter_xwidth
#define yheight mccchannel_10_filter_yheight
#undef yheight
#undef xwidth
#undef radius
#undef ymax
#undef ymin
#undef xmax
#undef xmin
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

/* User declarations for component 'channel_11_filter' [80]. */
#define mccompcurname  channel_11_filter
#define mccompcurtype  Slit_MACS
#define mccompcurindex 80
#define xmin mccchannel_11_filter_xmin
#define xmax mccchannel_11_filter_xmax
#define ymin mccchannel_11_filter_ymin
#define ymax mccchannel_11_filter_ymax
#define radius mccchannel_11_filter_radius
#define xwidth mccchannel_11_filter_xwidth
#define yheight mccchannel_11_filter_yheight
#undef yheight
#undef xwidth
#undef radius
#undef ymax
#undef ymin
#undef xmax
#undef xmin
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

/* User declarations for component 'channel_12_filter' [81]. */
#define mccompcurname  channel_12_filter
#define mccompcurtype  Slit_MACS
#define mccompcurindex 81
#define xmin mccchannel_12_filter_xmin
#define xmax mccchannel_12_filter_xmax
#define ymin mccchannel_12_filter_ymin
#define ymax mccchannel_12_filter_ymax
#define radius mccchannel_12_filter_radius
#define xwidth mccchannel_12_filter_xwidth
#define yheight mccchannel_12_filter_yheight
#undef yheight
#undef xwidth
#undef radius
#undef ymax
#undef ymin
#undef xmax
#undef xmin
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

/* User declarations for component 'channel_13_filter' [82]. */
#define mccompcurname  channel_13_filter
#define mccompcurtype  Slit_MACS
#define mccompcurindex 82
#define xmin mccchannel_13_filter_xmin
#define xmax mccchannel_13_filter_xmax
#define ymin mccchannel_13_filter_ymin
#define ymax mccchannel_13_filter_ymax
#define radius mccchannel_13_filter_radius
#define xwidth mccchannel_13_filter_xwidth
#define yheight mccchannel_13_filter_yheight
#undef yheight
#undef xwidth
#undef radius
#undef ymax
#undef ymin
#undef xmax
#undef xmin
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

/* User declarations for component 'channel_14_filter' [83]. */
#define mccompcurname  channel_14_filter
#define mccompcurtype  Slit_MACS
#define mccompcurindex 83
#define xmin mccchannel_14_filter_xmin
#define xmax mccchannel_14_filter_xmax
#define ymin mccchannel_14_filter_ymin
#define ymax mccchannel_14_filter_ymax
#define radius mccchannel_14_filter_radius
#define xwidth mccchannel_14_filter_xwidth
#define yheight mccchannel_14_filter_yheight
#undef yheight
#undef xwidth
#undef radius
#undef ymax
#undef ymin
#undef xmax
#undef xmin
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

/* User declarations for component 'channel_15_filter' [84]. */
#define mccompcurname  channel_15_filter
#define mccompcurtype  Slit_MACS
#define mccompcurindex 84
#define xmin mccchannel_15_filter_xmin
#define xmax mccchannel_15_filter_xmax
#define ymin mccchannel_15_filter_ymin
#define ymax mccchannel_15_filter_ymax
#define radius mccchannel_15_filter_radius
#define xwidth mccchannel_15_filter_xwidth
#define yheight mccchannel_15_filter_yheight
#undef yheight
#undef xwidth
#undef radius
#undef ymax
#undef ymin
#undef xmax
#undef xmin
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

/* User declarations for component 'channel_16_filter' [85]. */
#define mccompcurname  channel_16_filter
#define mccompcurtype  Slit_MACS
#define mccompcurindex 85
#define xmin mccchannel_16_filter_xmin
#define xmax mccchannel_16_filter_xmax
#define ymin mccchannel_16_filter_ymin
#define ymax mccchannel_16_filter_ymax
#define radius mccchannel_16_filter_radius
#define xwidth mccchannel_16_filter_xwidth
#define yheight mccchannel_16_filter_yheight
#undef yheight
#undef xwidth
#undef radius
#undef ymax
#undef ymin
#undef xmax
#undef xmin
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

/* User declarations for component 'channel_17_filter' [86]. */
#define mccompcurname  channel_17_filter
#define mccompcurtype  Slit_MACS
#define mccompcurindex 86
#define xmin mccchannel_17_filter_xmin
#define xmax mccchannel_17_filter_xmax
#define ymin mccchannel_17_filter_ymin
#define ymax mccchannel_17_filter_ymax
#define radius mccchannel_17_filter_radius
#define xwidth mccchannel_17_filter_xwidth
#define yheight mccchannel_17_filter_yheight
#undef yheight
#undef xwidth
#undef radius
#undef ymax
#undef ymin
#undef xmax
#undef xmin
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

/* User declarations for component 'channel_18_filter' [87]. */
#define mccompcurname  channel_18_filter
#define mccompcurtype  Slit_MACS
#define mccompcurindex 87
#define xmin mccchannel_18_filter_xmin
#define xmax mccchannel_18_filter_xmax
#define ymin mccchannel_18_filter_ymin
#define ymax mccchannel_18_filter_ymax
#define radius mccchannel_18_filter_radius
#define xwidth mccchannel_18_filter_xwidth
#define yheight mccchannel_18_filter_yheight
#undef yheight
#undef xwidth
#undef radius
#undef ymax
#undef ymin
#undef xmax
#undef xmin
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

/* User declarations for component 'channel_19_filter' [88]. */
#define mccompcurname  channel_19_filter
#define mccompcurtype  Slit_MACS
#define mccompcurindex 88
#define xmin mccchannel_19_filter_xmin
#define xmax mccchannel_19_filter_xmax
#define ymin mccchannel_19_filter_ymin
#define ymax mccchannel_19_filter_ymax
#define radius mccchannel_19_filter_radius
#define xwidth mccchannel_19_filter_xwidth
#define yheight mccchannel_19_filter_yheight
#undef yheight
#undef xwidth
#undef radius
#undef ymax
#undef ymin
#undef xmax
#undef xmin
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

/* User declarations for component 'channel_selector' [89]. */
#define mccompcurname  channel_selector
#define mccompcurtype  Arm
#define mccompcurindex 89
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

/* User declarations for component 'channel_0_colimator' [90]. */
#define mccompcurname  channel_0_colimator
#define mccompcurtype  Collimator_linear
#define mccompcurindex 90
#define slope mccchannel_0_colimator_slope
#define slopeV mccchannel_0_colimator_slopeV
#define xmin mccchannel_0_colimator_xmin
#define xmax mccchannel_0_colimator_xmax
#define ymin mccchannel_0_colimator_ymin
#define ymax mccchannel_0_colimator_ymax
#define xwidth mccchannel_0_colimator_xwidth
#define yheight mccchannel_0_colimator_yheight
#define length mccchannel_0_colimator_length
#define divergence mccchannel_0_colimator_divergence
#define transmission mccchannel_0_colimator_transmission
#define divergenceV mccchannel_0_colimator_divergenceV
#line 51 "/usr/share/mcstas/2.7/optics/Collimator_linear.comp"
double slope, slopeV;
#line 32082 "MACS_sample_kidney_box.c"
#undef divergenceV
#undef transmission
#undef divergence
#undef length
#undef yheight
#undef xwidth
#undef ymax
#undef ymin
#undef xmax
#undef xmin
#undef slopeV
#undef slope
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

/* User declarations for component 'channel_1_colimator' [91]. */
#define mccompcurname  channel_1_colimator
#define mccompcurtype  Collimator_linear
#define mccompcurindex 91
#define slope mccchannel_1_colimator_slope
#define slopeV mccchannel_1_colimator_slopeV
#define xmin mccchannel_1_colimator_xmin
#define xmax mccchannel_1_colimator_xmax
#define ymin mccchannel_1_colimator_ymin
#define ymax mccchannel_1_colimator_ymax
#define xwidth mccchannel_1_colimator_xwidth
#define yheight mccchannel_1_colimator_yheight
#define length mccchannel_1_colimator_length
#define divergence mccchannel_1_colimator_divergence
#define transmission mccchannel_1_colimator_transmission
#define divergenceV mccchannel_1_colimator_divergenceV
#line 51 "/usr/share/mcstas/2.7/optics/Collimator_linear.comp"
double slope, slopeV;
#line 32117 "MACS_sample_kidney_box.c"
#undef divergenceV
#undef transmission
#undef divergence
#undef length
#undef yheight
#undef xwidth
#undef ymax
#undef ymin
#undef xmax
#undef xmin
#undef slopeV
#undef slope
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

/* User declarations for component 'channel_2_colimator' [92]. */
#define mccompcurname  channel_2_colimator
#define mccompcurtype  Collimator_linear
#define mccompcurindex 92
#define slope mccchannel_2_colimator_slope
#define slopeV mccchannel_2_colimator_slopeV
#define xmin mccchannel_2_colimator_xmin
#define xmax mccchannel_2_colimator_xmax
#define ymin mccchannel_2_colimator_ymin
#define ymax mccchannel_2_colimator_ymax
#define xwidth mccchannel_2_colimator_xwidth
#define yheight mccchannel_2_colimator_yheight
#define length mccchannel_2_colimator_length
#define divergence mccchannel_2_colimator_divergence
#define transmission mccchannel_2_colimator_transmission
#define divergenceV mccchannel_2_colimator_divergenceV
#line 51 "/usr/share/mcstas/2.7/optics/Collimator_linear.comp"
double slope, slopeV;
#line 32152 "MACS_sample_kidney_box.c"
#undef divergenceV
#undef transmission
#undef divergence
#undef length
#undef yheight
#undef xwidth
#undef ymax
#undef ymin
#undef xmax
#undef xmin
#undef slopeV
#undef slope
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

/* User declarations for component 'channel_3_colimator' [93]. */
#define mccompcurname  channel_3_colimator
#define mccompcurtype  Collimator_linear
#define mccompcurindex 93
#define slope mccchannel_3_colimator_slope
#define slopeV mccchannel_3_colimator_slopeV
#define xmin mccchannel_3_colimator_xmin
#define xmax mccchannel_3_colimator_xmax
#define ymin mccchannel_3_colimator_ymin
#define ymax mccchannel_3_colimator_ymax
#define xwidth mccchannel_3_colimator_xwidth
#define yheight mccchannel_3_colimator_yheight
#define length mccchannel_3_colimator_length
#define divergence mccchannel_3_colimator_divergence
#define transmission mccchannel_3_colimator_transmission
#define divergenceV mccchannel_3_colimator_divergenceV
#line 51 "/usr/share/mcstas/2.7/optics/Collimator_linear.comp"
double slope, slopeV;
#line 32187 "MACS_sample_kidney_box.c"
#undef divergenceV
#undef transmission
#undef divergence
#undef length
#undef yheight
#undef xwidth
#undef ymax
#undef ymin
#undef xmax
#undef xmin
#undef slopeV
#undef slope
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

/* User declarations for component 'channel_4_colimator' [94]. */
#define mccompcurname  channel_4_colimator
#define mccompcurtype  Collimator_linear
#define mccompcurindex 94
#define slope mccchannel_4_colimator_slope
#define slopeV mccchannel_4_colimator_slopeV
#define xmin mccchannel_4_colimator_xmin
#define xmax mccchannel_4_colimator_xmax
#define ymin mccchannel_4_colimator_ymin
#define ymax mccchannel_4_colimator_ymax
#define xwidth mccchannel_4_colimator_xwidth
#define yheight mccchannel_4_colimator_yheight
#define length mccchannel_4_colimator_length
#define divergence mccchannel_4_colimator_divergence
#define transmission mccchannel_4_colimator_transmission
#define divergenceV mccchannel_4_colimator_divergenceV
#line 51 "/usr/share/mcstas/2.7/optics/Collimator_linear.comp"
double slope, slopeV;
#line 32222 "MACS_sample_kidney_box.c"
#undef divergenceV
#undef transmission
#undef divergence
#undef length
#undef yheight
#undef xwidth
#undef ymax
#undef ymin
#undef xmax
#undef xmin
#undef slopeV
#undef slope
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

/* User declarations for component 'channel_5_colimator' [95]. */
#define mccompcurname  channel_5_colimator
#define mccompcurtype  Collimator_linear
#define mccompcurindex 95
#define slope mccchannel_5_colimator_slope
#define slopeV mccchannel_5_colimator_slopeV
#define xmin mccchannel_5_colimator_xmin
#define xmax mccchannel_5_colimator_xmax
#define ymin mccchannel_5_colimator_ymin
#define ymax mccchannel_5_colimator_ymax
#define xwidth mccchannel_5_colimator_xwidth
#define yheight mccchannel_5_colimator_yheight
#define length mccchannel_5_colimator_length
#define divergence mccchannel_5_colimator_divergence
#define transmission mccchannel_5_colimator_transmission
#define divergenceV mccchannel_5_colimator_divergenceV
#line 51 "/usr/share/mcstas/2.7/optics/Collimator_linear.comp"
double slope, slopeV;
#line 32257 "MACS_sample_kidney_box.c"
#undef divergenceV
#undef transmission
#undef divergence
#undef length
#undef yheight
#undef xwidth
#undef ymax
#undef ymin
#undef xmax
#undef xmin
#undef slopeV
#undef slope
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

/* User declarations for component 'channel_6_colimator' [96]. */
#define mccompcurname  channel_6_colimator
#define mccompcurtype  Collimator_linear
#define mccompcurindex 96
#define slope mccchannel_6_colimator_slope
#define slopeV mccchannel_6_colimator_slopeV
#define xmin mccchannel_6_colimator_xmin
#define xmax mccchannel_6_colimator_xmax
#define ymin mccchannel_6_colimator_ymin
#define ymax mccchannel_6_colimator_ymax
#define xwidth mccchannel_6_colimator_xwidth
#define yheight mccchannel_6_colimator_yheight
#define length mccchannel_6_colimator_length
#define divergence mccchannel_6_colimator_divergence
#define transmission mccchannel_6_colimator_transmission
#define divergenceV mccchannel_6_colimator_divergenceV
#line 51 "/usr/share/mcstas/2.7/optics/Collimator_linear.comp"
double slope, slopeV;
#line 32292 "MACS_sample_kidney_box.c"
#undef divergenceV
#undef transmission
#undef divergence
#undef length
#undef yheight
#undef xwidth
#undef ymax
#undef ymin
#undef xmax
#undef xmin
#undef slopeV
#undef slope
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

/* User declarations for component 'channel_7_colimator' [97]. */
#define mccompcurname  channel_7_colimator
#define mccompcurtype  Collimator_linear
#define mccompcurindex 97
#define slope mccchannel_7_colimator_slope
#define slopeV mccchannel_7_colimator_slopeV
#define xmin mccchannel_7_colimator_xmin
#define xmax mccchannel_7_colimator_xmax
#define ymin mccchannel_7_colimator_ymin
#define ymax mccchannel_7_colimator_ymax
#define xwidth mccchannel_7_colimator_xwidth
#define yheight mccchannel_7_colimator_yheight
#define length mccchannel_7_colimator_length
#define divergence mccchannel_7_colimator_divergence
#define transmission mccchannel_7_colimator_transmission
#define divergenceV mccchannel_7_colimator_divergenceV
#line 51 "/usr/share/mcstas/2.7/optics/Collimator_linear.comp"
double slope, slopeV;
#line 32327 "MACS_sample_kidney_box.c"
#undef divergenceV
#undef transmission
#undef divergence
#undef length
#undef yheight
#undef xwidth
#undef ymax
#undef ymin
#undef xmax
#undef xmin
#undef slopeV
#undef slope
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

/* User declarations for component 'channel_8_colimator' [98]. */
#define mccompcurname  channel_8_colimator
#define mccompcurtype  Collimator_linear
#define mccompcurindex 98
#define slope mccchannel_8_colimator_slope
#define slopeV mccchannel_8_colimator_slopeV
#define xmin mccchannel_8_colimator_xmin
#define xmax mccchannel_8_colimator_xmax
#define ymin mccchannel_8_colimator_ymin
#define ymax mccchannel_8_colimator_ymax
#define xwidth mccchannel_8_colimator_xwidth
#define yheight mccchannel_8_colimator_yheight
#define length mccchannel_8_colimator_length
#define divergence mccchannel_8_colimator_divergence
#define transmission mccchannel_8_colimator_transmission
#define divergenceV mccchannel_8_colimator_divergenceV
#line 51 "/usr/share/mcstas/2.7/optics/Collimator_linear.comp"
double slope, slopeV;
#line 32362 "MACS_sample_kidney_box.c"
#undef divergenceV
#undef transmission
#undef divergence
#undef length
#undef yheight
#undef xwidth
#undef ymax
#undef ymin
#undef xmax
#undef xmin
#undef slopeV
#undef slope
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

/* User declarations for component 'channel_9_colimator' [99]. */
#define mccompcurname  channel_9_colimator
#define mccompcurtype  Collimator_linear
#define mccompcurindex 99
#define slope mccchannel_9_colimator_slope
#define slopeV mccchannel_9_colimator_slopeV
#define xmin mccchannel_9_colimator_xmin
#define xmax mccchannel_9_colimator_xmax
#define ymin mccchannel_9_colimator_ymin
#define ymax mccchannel_9_colimator_ymax
#define xwidth mccchannel_9_colimator_xwidth
#define yheight mccchannel_9_colimator_yheight
#define length mccchannel_9_colimator_length
#define divergence mccchannel_9_colimator_divergence
#define transmission mccchannel_9_colimator_transmission
#define divergenceV mccchannel_9_colimator_divergenceV
#line 51 "/usr/share/mcstas/2.7/optics/Collimator_linear.comp"
double slope, slopeV;
#line 32397 "MACS_sample_kidney_box.c"
#undef divergenceV
#undef transmission
#undef divergence
#undef length
#undef yheight
#undef xwidth
#undef ymax
#undef ymin
#undef xmax
#undef xmin
#undef slopeV
#undef slope
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

/* User declarations for component 'channel_10_colimator' [100]. */
#define mccompcurname  channel_10_colimator
#define mccompcurtype  Collimator_linear
#define mccompcurindex 100
#define slope mccchannel_10_colimator_slope
#define slopeV mccchannel_10_colimator_slopeV
#define xmin mccchannel_10_colimator_xmin
#define xmax mccchannel_10_colimator_xmax
#define ymin mccchannel_10_colimator_ymin
#define ymax mccchannel_10_colimator_ymax
#define xwidth mccchannel_10_colimator_xwidth
#define yheight mccchannel_10_colimator_yheight
#define length mccchannel_10_colimator_length
#define divergence mccchannel_10_colimator_divergence
#define transmission mccchannel_10_colimator_transmission
#define divergenceV mccchannel_10_colimator_divergenceV
#line 51 "/usr/share/mcstas/2.7/optics/Collimator_linear.comp"
double slope, slopeV;
#line 32432 "MACS_sample_kidney_box.c"
#undef divergenceV
#undef transmission
#undef divergence
#undef length
#undef yheight
#undef xwidth
#undef ymax
#undef ymin
#undef xmax
#undef xmin
#undef slopeV
#undef slope
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

/* User declarations for component 'channel_11_colimator' [101]. */
#define mccompcurname  channel_11_colimator
#define mccompcurtype  Collimator_linear
#define mccompcurindex 101
#define slope mccchannel_11_colimator_slope
#define slopeV mccchannel_11_colimator_slopeV
#define xmin mccchannel_11_colimator_xmin
#define xmax mccchannel_11_colimator_xmax
#define ymin mccchannel_11_colimator_ymin
#define ymax mccchannel_11_colimator_ymax
#define xwidth mccchannel_11_colimator_xwidth
#define yheight mccchannel_11_colimator_yheight
#define length mccchannel_11_colimator_length
#define divergence mccchannel_11_colimator_divergence
#define transmission mccchannel_11_colimator_transmission
#define divergenceV mccchannel_11_colimator_divergenceV
#line 51 "/usr/share/mcstas/2.7/optics/Collimator_linear.comp"
double slope, slopeV;
#line 32467 "MACS_sample_kidney_box.c"
#undef divergenceV
#undef transmission
#undef divergence
#undef length
#undef yheight
#undef xwidth
#undef ymax
#undef ymin
#undef xmax
#undef xmin
#undef slopeV
#undef slope
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

/* User declarations for component 'channel_12_colimator' [102]. */
#define mccompcurname  channel_12_colimator
#define mccompcurtype  Collimator_linear
#define mccompcurindex 102
#define slope mccchannel_12_colimator_slope
#define slopeV mccchannel_12_colimator_slopeV
#define xmin mccchannel_12_colimator_xmin
#define xmax mccchannel_12_colimator_xmax
#define ymin mccchannel_12_colimator_ymin
#define ymax mccchannel_12_colimator_ymax
#define xwidth mccchannel_12_colimator_xwidth
#define yheight mccchannel_12_colimator_yheight
#define length mccchannel_12_colimator_length
#define divergence mccchannel_12_colimator_divergence
#define transmission mccchannel_12_colimator_transmission
#define divergenceV mccchannel_12_colimator_divergenceV
#line 51 "/usr/share/mcstas/2.7/optics/Collimator_linear.comp"
double slope, slopeV;
#line 32502 "MACS_sample_kidney_box.c"
#undef divergenceV
#undef transmission
#undef divergence
#undef length
#undef yheight
#undef xwidth
#undef ymax
#undef ymin
#undef xmax
#undef xmin
#undef slopeV
#undef slope
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

/* User declarations for component 'channel_13_colimator' [103]. */
#define mccompcurname  channel_13_colimator
#define mccompcurtype  Collimator_linear
#define mccompcurindex 103
#define slope mccchannel_13_colimator_slope
#define slopeV mccchannel_13_colimator_slopeV
#define xmin mccchannel_13_colimator_xmin
#define xmax mccchannel_13_colimator_xmax
#define ymin mccchannel_13_colimator_ymin
#define ymax mccchannel_13_colimator_ymax
#define xwidth mccchannel_13_colimator_xwidth
#define yheight mccchannel_13_colimator_yheight
#define length mccchannel_13_colimator_length
#define divergence mccchannel_13_colimator_divergence
#define transmission mccchannel_13_colimator_transmission
#define divergenceV mccchannel_13_colimator_divergenceV
#line 51 "/usr/share/mcstas/2.7/optics/Collimator_linear.comp"
double slope, slopeV;
#line 32537 "MACS_sample_kidney_box.c"
#undef divergenceV
#undef transmission
#undef divergence
#undef length
#undef yheight
#undef xwidth
#undef ymax
#undef ymin
#undef xmax
#undef xmin
#undef slopeV
#undef slope
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

/* User declarations for component 'channel_14_colimator' [104]. */
#define mccompcurname  channel_14_colimator
#define mccompcurtype  Collimator_linear
#define mccompcurindex 104
#define slope mccchannel_14_colimator_slope
#define slopeV mccchannel_14_colimator_slopeV
#define xmin mccchannel_14_colimator_xmin
#define xmax mccchannel_14_colimator_xmax
#define ymin mccchannel_14_colimator_ymin
#define ymax mccchannel_14_colimator_ymax
#define xwidth mccchannel_14_colimator_xwidth
#define yheight mccchannel_14_colimator_yheight
#define length mccchannel_14_colimator_length
#define divergence mccchannel_14_colimator_divergence
#define transmission mccchannel_14_colimator_transmission
#define divergenceV mccchannel_14_colimator_divergenceV
#line 51 "/usr/share/mcstas/2.7/optics/Collimator_linear.comp"
double slope, slopeV;
#line 32572 "MACS_sample_kidney_box.c"
#undef divergenceV
#undef transmission
#undef divergence
#undef length
#undef yheight
#undef xwidth
#undef ymax
#undef ymin
#undef xmax
#undef xmin
#undef slopeV
#undef slope
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

/* User declarations for component 'channel_15_colimator' [105]. */
#define mccompcurname  channel_15_colimator
#define mccompcurtype  Collimator_linear
#define mccompcurindex 105
#define slope mccchannel_15_colimator_slope
#define slopeV mccchannel_15_colimator_slopeV
#define xmin mccchannel_15_colimator_xmin
#define xmax mccchannel_15_colimator_xmax
#define ymin mccchannel_15_colimator_ymin
#define ymax mccchannel_15_colimator_ymax
#define xwidth mccchannel_15_colimator_xwidth
#define yheight mccchannel_15_colimator_yheight
#define length mccchannel_15_colimator_length
#define divergence mccchannel_15_colimator_divergence
#define transmission mccchannel_15_colimator_transmission
#define divergenceV mccchannel_15_colimator_divergenceV
#line 51 "/usr/share/mcstas/2.7/optics/Collimator_linear.comp"
double slope, slopeV;
#line 32607 "MACS_sample_kidney_box.c"
#undef divergenceV
#undef transmission
#undef divergence
#undef length
#undef yheight
#undef xwidth
#undef ymax
#undef ymin
#undef xmax
#undef xmin
#undef slopeV
#undef slope
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

/* User declarations for component 'channel_16_colimator' [106]. */
#define mccompcurname  channel_16_colimator
#define mccompcurtype  Collimator_linear
#define mccompcurindex 106
#define slope mccchannel_16_colimator_slope
#define slopeV mccchannel_16_colimator_slopeV
#define xmin mccchannel_16_colimator_xmin
#define xmax mccchannel_16_colimator_xmax
#define ymin mccchannel_16_colimator_ymin
#define ymax mccchannel_16_colimator_ymax
#define xwidth mccchannel_16_colimator_xwidth
#define yheight mccchannel_16_colimator_yheight
#define length mccchannel_16_colimator_length
#define divergence mccchannel_16_colimator_divergence
#define transmission mccchannel_16_colimator_transmission
#define divergenceV mccchannel_16_colimator_divergenceV
#line 51 "/usr/share/mcstas/2.7/optics/Collimator_linear.comp"
double slope, slopeV;
#line 32642 "MACS_sample_kidney_box.c"
#undef divergenceV
#undef transmission
#undef divergence
#undef length
#undef yheight
#undef xwidth
#undef ymax
#undef ymin
#undef xmax
#undef xmin
#undef slopeV
#undef slope
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

/* User declarations for component 'channel_17_colimator' [107]. */
#define mccompcurname  channel_17_colimator
#define mccompcurtype  Collimator_linear
#define mccompcurindex 107
#define slope mccchannel_17_colimator_slope
#define slopeV mccchannel_17_colimator_slopeV
#define xmin mccchannel_17_colimator_xmin
#define xmax mccchannel_17_colimator_xmax
#define ymin mccchannel_17_colimator_ymin
#define ymax mccchannel_17_colimator_ymax
#define xwidth mccchannel_17_colimator_xwidth
#define yheight mccchannel_17_colimator_yheight
#define length mccchannel_17_colimator_length
#define divergence mccchannel_17_colimator_divergence
#define transmission mccchannel_17_colimator_transmission
#define divergenceV mccchannel_17_colimator_divergenceV
#line 51 "/usr/share/mcstas/2.7/optics/Collimator_linear.comp"
double slope, slopeV;
#line 32677 "MACS_sample_kidney_box.c"
#undef divergenceV
#undef transmission
#undef divergence
#undef length
#undef yheight
#undef xwidth
#undef ymax
#undef ymin
#undef xmax
#undef xmin
#undef slopeV
#undef slope
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

/* User declarations for component 'channel_18_colimator' [108]. */
#define mccompcurname  channel_18_colimator
#define mccompcurtype  Collimator_linear
#define mccompcurindex 108
#define slope mccchannel_18_colimator_slope
#define slopeV mccchannel_18_colimator_slopeV
#define xmin mccchannel_18_colimator_xmin
#define xmax mccchannel_18_colimator_xmax
#define ymin mccchannel_18_colimator_ymin
#define ymax mccchannel_18_colimator_ymax
#define xwidth mccchannel_18_colimator_xwidth
#define yheight mccchannel_18_colimator_yheight
#define length mccchannel_18_colimator_length
#define divergence mccchannel_18_colimator_divergence
#define transmission mccchannel_18_colimator_transmission
#define divergenceV mccchannel_18_colimator_divergenceV
#line 51 "/usr/share/mcstas/2.7/optics/Collimator_linear.comp"
double slope, slopeV;
#line 32712 "MACS_sample_kidney_box.c"
#undef divergenceV
#undef transmission
#undef divergence
#undef length
#undef yheight
#undef xwidth
#undef ymax
#undef ymin
#undef xmax
#undef xmin
#undef slopeV
#undef slope
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

/* User declarations for component 'channel_19_colimator' [109]. */
#define mccompcurname  channel_19_colimator
#define mccompcurtype  Collimator_linear
#define mccompcurindex 109
#define slope mccchannel_19_colimator_slope
#define slopeV mccchannel_19_colimator_slopeV
#define xmin mccchannel_19_colimator_xmin
#define xmax mccchannel_19_colimator_xmax
#define ymin mccchannel_19_colimator_ymin
#define ymax mccchannel_19_colimator_ymax
#define xwidth mccchannel_19_colimator_xwidth
#define yheight mccchannel_19_colimator_yheight
#define length mccchannel_19_colimator_length
#define divergence mccchannel_19_colimator_divergence
#define transmission mccchannel_19_colimator_transmission
#define divergenceV mccchannel_19_colimator_divergenceV
#line 51 "/usr/share/mcstas/2.7/optics/Collimator_linear.comp"
double slope, slopeV;
#line 32747 "MACS_sample_kidney_box.c"
#undef divergenceV
#undef transmission
#undef divergence
#undef length
#undef yheight
#undef xwidth
#undef ymax
#undef ymin
#undef xmax
#undef xmin
#undef slopeV
#undef slope
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

/* User declarations for component 'boron_plastic_incoherent' [110]. */
#define mccompcurname  boron_plastic_incoherent
#define mccompcurtype  Incoherent_process
#define mccompcurindex 110
#define This_process mccboron_plastic_incoherent_This_process
#define Incoherent_storage mccboron_plastic_incoherent_Incoherent_storage
#define effective_my_scattering mccboron_plastic_incoherent_effective_my_scattering
#define sigma mccboron_plastic_incoherent_sigma
#define f_QE mccboron_plastic_incoherent_f_QE
#define gamma mccboron_plastic_incoherent_gamma
#define packing_factor mccboron_plastic_incoherent_packing_factor
#define unit_cell_volume mccboron_plastic_incoherent_unit_cell_volume
#define interact_fraction mccboron_plastic_incoherent_interact_fraction
#line 123 "Incoherent_process.comp"
// Needed for transport to the main component
struct global_process_element_struct global_process_element;
struct scattering_process_struct This_process;

#ifndef PROCESS_DETECTOR
	//struct pointer_to_global_process_list global_process_list = {0,NULL};
	#define PROCESS_DETECTOR dummy
#endif

// Declare for this component, to do calculations on the input / store in the transported data
struct Incoherent_physics_storage_struct Incoherent_storage;
double effective_my_scattering;

#line 32791 "MACS_sample_kidney_box.c"
#undef interact_fraction
#undef unit_cell_volume
#undef packing_factor
#undef gamma
#undef f_QE
#undef sigma
#undef effective_my_scattering
#undef Incoherent_storage
#undef This_process
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

/* User declarations for component 'boron_plastic' [111]. */
#define mccompcurname  boron_plastic
#define mccompcurtype  Union_make_material
#define mccompcurindex 111
#define loop_index mccboron_plastic_loop_index
#define this_material mccboron_plastic_this_material
#define accepted_processes mccboron_plastic_accepted_processes
#define global_material_element mccboron_plastic_global_material_element
#define process_string mccboron_plastic_process_string
#define my_absorption mccboron_plastic_my_absorption
#define absorber mccboron_plastic_absorber
#line 167 "Union_make_material.comp"
// Needed for transport to the main component
struct global_material_element_struct global_material_element;
struct physics_struct this_material;

#ifndef MATERIAL_DETECTOR
	//struct pointer_to_global_material_list global_material_list = {0,NULL};
	#define MATERIAL_DETECTOR dummy
#endif

int loop_index;
int found_process;
int specified_processes;
char local_string[256];

struct pointer_to_1d_int_list accepted_processes = {0,NULL};

// Add setup for loggers since make_material is called before any volume / master
#ifndef UNION_LOGGER_DECLARE
	//struct pointer_to_global_logger_list global_all_volume_logger_list = {0,NULL};
    //struct pointer_to_global_logger_list global_specific_volumes_logger_list = {0,NULL};
	#define UNION_LOGGER_DECLARE dummy
#endif

#line 32840 "MACS_sample_kidney_box.c"
#undef absorber
#undef my_absorption
#undef process_string
#undef global_material_element
#undef accepted_processes
#undef this_material
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

/* User declarations for component 'boron_plastic_enriched_incoherent' [112]. */
#define mccompcurname  boron_plastic_enriched_incoherent
#define mccompcurtype  Incoherent_process
#define mccompcurindex 112
#define This_process mccboron_plastic_enriched_incoherent_This_process
#define Incoherent_storage mccboron_plastic_enriched_incoherent_Incoherent_storage
#define effective_my_scattering mccboron_plastic_enriched_incoherent_effective_my_scattering
#define sigma mccboron_plastic_enriched_incoherent_sigma
#define f_QE mccboron_plastic_enriched_incoherent_f_QE
#define gamma mccboron_plastic_enriched_incoherent_gamma
#define packing_factor mccboron_plastic_enriched_incoherent_packing_factor
#define unit_cell_volume mccboron_plastic_enriched_incoherent_unit_cell_volume
#define interact_fraction mccboron_plastic_enriched_incoherent_interact_fraction
#line 123 "Incoherent_process.comp"
// Needed for transport to the main component
struct global_process_element_struct global_process_element;
struct scattering_process_struct This_process;

#ifndef PROCESS_DETECTOR
	//struct pointer_to_global_process_list global_process_list = {0,NULL};
	#define PROCESS_DETECTOR dummy
#endif

// Declare for this component, to do calculations on the input / store in the transported data
struct Incoherent_physics_storage_struct Incoherent_storage;
double effective_my_scattering;

#line 32879 "MACS_sample_kidney_box.c"
#undef interact_fraction
#undef unit_cell_volume
#undef packing_factor
#undef gamma
#undef f_QE
#undef sigma
#undef effective_my_scattering
#undef Incoherent_storage
#undef This_process
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

/* User declarations for component 'boron_plastic_enriched' [113]. */
#define mccompcurname  boron_plastic_enriched
#define mccompcurtype  Union_make_material
#define mccompcurindex 113
#define loop_index mccboron_plastic_enriched_loop_index
#define this_material mccboron_plastic_enriched_this_material
#define accepted_processes mccboron_plastic_enriched_accepted_processes
#define global_material_element mccboron_plastic_enriched_global_material_element
#define process_string mccboron_plastic_enriched_process_string
#define my_absorption mccboron_plastic_enriched_my_absorption
#define absorber mccboron_plastic_enriched_absorber
#line 167 "Union_make_material.comp"
// Needed for transport to the main component
struct global_material_element_struct global_material_element;
struct physics_struct this_material;

#ifndef MATERIAL_DETECTOR
	//struct pointer_to_global_material_list global_material_list = {0,NULL};
	#define MATERIAL_DETECTOR dummy
#endif

int loop_index;
int found_process;
int specified_processes;
char local_string[256];

struct pointer_to_1d_int_list accepted_processes = {0,NULL};

// Add setup for loggers since make_material is called before any volume / master
#ifndef UNION_LOGGER_DECLARE
	//struct pointer_to_global_logger_list global_all_volume_logger_list = {0,NULL};
    //struct pointer_to_global_logger_list global_specific_volumes_logger_list = {0,NULL};
	#define UNION_LOGGER_DECLARE dummy
#endif

#line 32928 "MACS_sample_kidney_box.c"
#undef absorber
#undef my_absorption
#undef process_string
#undef global_material_element
#undef accepted_processes
#undef this_material
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

/* User declarations for component 'Collimator_gad' [114]. */
#define mccompcurname  Collimator_gad
#define mccompcurtype  Union_make_material
#define mccompcurindex 114
#define loop_index mccCollimator_gad_loop_index
#define this_material mccCollimator_gad_this_material
#define accepted_processes mccCollimator_gad_accepted_processes
#define global_material_element mccCollimator_gad_global_material_element
#define process_string mccCollimator_gad_process_string
#define my_absorption mccCollimator_gad_my_absorption
#define absorber mccCollimator_gad_absorber
#line 167 "Union_make_material.comp"
// Needed for transport to the main component
struct global_material_element_struct global_material_element;
struct physics_struct this_material;

#ifndef MATERIAL_DETECTOR
	//struct pointer_to_global_material_list global_material_list = {0,NULL};
	#define MATERIAL_DETECTOR dummy
#endif

int loop_index;
int found_process;
int specified_processes;
char local_string[256];

struct pointer_to_1d_int_list accepted_processes = {0,NULL};

// Add setup for loggers since make_material is called before any volume / master
#ifndef UNION_LOGGER_DECLARE
	//struct pointer_to_global_logger_list global_all_volume_logger_list = {0,NULL};
    //struct pointer_to_global_logger_list global_specific_volumes_logger_list = {0,NULL};
	#define UNION_LOGGER_DECLARE dummy
#endif

#line 32975 "MACS_sample_kidney_box.c"
#undef absorber
#undef my_absorption
#undef process_string
#undef global_material_element
#undef accepted_processes
#undef this_material
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

/* User declarations for component 'Incoherent_PG_analyzer' [115]. */
#define mccompcurname  Incoherent_PG_analyzer
#define mccompcurtype  Incoherent_process
#define mccompcurindex 115
#define This_process mccIncoherent_PG_analyzer_This_process
#define Incoherent_storage mccIncoherent_PG_analyzer_Incoherent_storage
#define effective_my_scattering mccIncoherent_PG_analyzer_effective_my_scattering
#define sigma mccIncoherent_PG_analyzer_sigma
#define f_QE mccIncoherent_PG_analyzer_f_QE
#define gamma mccIncoherent_PG_analyzer_gamma
#define packing_factor mccIncoherent_PG_analyzer_packing_factor
#define unit_cell_volume mccIncoherent_PG_analyzer_unit_cell_volume
#define interact_fraction mccIncoherent_PG_analyzer_interact_fraction
#line 123 "Incoherent_process.comp"
// Needed for transport to the main component
struct global_process_element_struct global_process_element;
struct scattering_process_struct This_process;

#ifndef PROCESS_DETECTOR
	//struct pointer_to_global_process_list global_process_list = {0,NULL};
	#define PROCESS_DETECTOR dummy
#endif

// Declare for this component, to do calculations on the input / store in the transported data
struct Incoherent_physics_storage_struct Incoherent_storage;
double effective_my_scattering;

#line 33014 "MACS_sample_kidney_box.c"
#undef interact_fraction
#undef unit_cell_volume
#undef packing_factor
#undef gamma
#undef f_QE
#undef sigma
#undef effective_my_scattering
#undef Incoherent_storage
#undef This_process
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

/* User declarations for component 'Single_crystal_PG_analyzer' [116]. */
#define mccompcurname  Single_crystal_PG_analyzer
#define mccompcurtype  Single_crystal_process
#define mccompcurindex 116
#define mosaic_AB mccSingle_crystal_PG_analyzer_mosaic_AB
#define This_process mccSingle_crystal_PG_analyzer_This_process
#define Single_crystal_storage mccSingle_crystal_PG_analyzer_Single_crystal_storage
#define effective_my_scattering mccSingle_crystal_PG_analyzer_effective_my_scattering
#define hkl_info_union mccSingle_crystal_PG_analyzer_hkl_info_union
#define packing_factor mccSingle_crystal_PG_analyzer_packing_factor
#define reflections mccSingle_crystal_PG_analyzer_reflections
#define delta_d_d mccSingle_crystal_PG_analyzer_delta_d_d
#define mosaic mccSingle_crystal_PG_analyzer_mosaic
#define mosaic_a mccSingle_crystal_PG_analyzer_mosaic_a
#define mosaic_b mccSingle_crystal_PG_analyzer_mosaic_b
#define mosaic_c mccSingle_crystal_PG_analyzer_mosaic_c
#define recip_cell mccSingle_crystal_PG_analyzer_recip_cell
#define barns mccSingle_crystal_PG_analyzer_barns
#define ax mccSingle_crystal_PG_analyzer_ax
#define ay mccSingle_crystal_PG_analyzer_ay
#define az mccSingle_crystal_PG_analyzer_az
#define bx mccSingle_crystal_PG_analyzer_bx
#define by mccSingle_crystal_PG_analyzer_by
#define bz mccSingle_crystal_PG_analyzer_bz
#define cx mccSingle_crystal_PG_analyzer_cx
#define cy mccSingle_crystal_PG_analyzer_cy
#define cz mccSingle_crystal_PG_analyzer_cz
#define aa mccSingle_crystal_PG_analyzer_aa
#define bb mccSingle_crystal_PG_analyzer_bb
#define cc mccSingle_crystal_PG_analyzer_cc
#define order mccSingle_crystal_PG_analyzer_order
#define RX mccSingle_crystal_PG_analyzer_RX
#define RY mccSingle_crystal_PG_analyzer_RY
#define RZ mccSingle_crystal_PG_analyzer_RZ
#define powder mccSingle_crystal_PG_analyzer_powder
#define PG mccSingle_crystal_PG_analyzer_PG
#define interact_fraction mccSingle_crystal_PG_analyzer_interact_fraction
#define packing_factor mccSingle_crystal_PG_analyzer_packing_factor
#line 920 "Single_crystal_process.comp"
// Declare for this component, to do calculations on the input / store in the transported data
struct Single_crystal_physics_storage_struct Single_crystal_storage;

// Variables needed in initialize of this function.
struct hkl_info_struct_union hkl_info_union;

// Needed for transport to the main component, will be the same for all processes
struct global_process_element_struct global_process_element;
struct scattering_process_struct This_process;

#ifndef PROCESS_DETECTOR
	//struct pointer_to_global_process_list global_process_list = {0,NULL};
	#define PROCESS_DETECTOR dummy
#endif
#line 33081 "MACS_sample_kidney_box.c"
#undef packing_factor
#undef interact_fraction
#undef PG
#undef powder
#undef RZ
#undef RY
#undef RX
#undef order
#undef cc
#undef bb
#undef aa
#undef cz
#undef cy
#undef cx
#undef bz
#undef by
#undef bx
#undef az
#undef ay
#undef ax
#undef barns
#undef recip_cell
#undef mosaic_c
#undef mosaic_b
#undef mosaic_a
#undef mosaic
#undef delta_d_d
#undef reflections
#undef packing_factor
#undef hkl_info_union
#undef effective_my_scattering
#undef Single_crystal_storage
#undef This_process
#undef mosaic_AB
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

/* User declarations for component 'PG_analyzer' [117]. */
#define mccompcurname  PG_analyzer
#define mccompcurtype  Union_make_material
#define mccompcurindex 117
#define loop_index mccPG_analyzer_loop_index
#define this_material mccPG_analyzer_this_material
#define accepted_processes mccPG_analyzer_accepted_processes
#define global_material_element mccPG_analyzer_global_material_element
#define process_string mccPG_analyzer_process_string
#define my_absorption mccPG_analyzer_my_absorption
#define absorber mccPG_analyzer_absorber
#line 167 "Union_make_material.comp"
// Needed for transport to the main component
struct global_material_element_struct global_material_element;
struct physics_struct this_material;

#ifndef MATERIAL_DETECTOR
	//struct pointer_to_global_material_list global_material_list = {0,NULL};
	#define MATERIAL_DETECTOR dummy
#endif

int loop_index;
int found_process;
int specified_processes;
char local_string[256];

struct pointer_to_1d_int_list accepted_processes = {0,NULL};

// Add setup for loggers since make_material is called before any volume / master
#ifndef UNION_LOGGER_DECLARE
	//struct pointer_to_global_logger_list global_all_volume_logger_list = {0,NULL};
    //struct pointer_to_global_logger_list global_specific_volumes_logger_list = {0,NULL};
	#define UNION_LOGGER_DECLARE dummy
#endif

#line 33155 "MACS_sample_kidney_box.c"
#undef absorber
#undef my_absorption
#undef process_string
#undef global_material_element
#undef accepted_processes
#undef this_material
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

/* User declarations for component 'kidney_hull' [118]. */
#define mccompcurname  kidney_hull
#define mccompcurtype  Union_cylinder
#define mccompcurindex 118
#define loop_index mcckidney_hull_loop_index
#define this_cylinder_volume mcckidney_hull_this_cylinder_volume
#define global_geometry_element mcckidney_hull_global_geometry_element
#define this_cylinder_storage mcckidney_hull_this_cylinder_storage
#define material_string mcckidney_hull_material_string
#define priority mcckidney_hull_priority
#define radius mcckidney_hull_radius
#define yheight mcckidney_hull_yheight
#define visualize mcckidney_hull_visualize
#define target_index mcckidney_hull_target_index
#define target_x mcckidney_hull_target_x
#define target_y mcckidney_hull_target_y
#define target_z mcckidney_hull_target_z
#define focus_aw mcckidney_hull_focus_aw
#define focus_ah mcckidney_hull_focus_ah
#define focus_xw mcckidney_hull_focus_xw
#define focus_xh mcckidney_hull_focus_xh
#define focus_r mcckidney_hull_focus_r
#define p_interact mcckidney_hull_p_interact
#define mask_string mcckidney_hull_mask_string
#define mask_setting mcckidney_hull_mask_setting
#define number_of_activations mcckidney_hull_number_of_activations
#line 167 "Union_cylinder.comp"
// Needed for transport to the main component
struct global_geometry_element_struct global_geometry_element;

#ifndef ANY_GEOMETRY_DETECTOR_DECLARE
    #define ANY_GEOMETRY_DETECTOR_DECLARE dummy
	//struct pointer_to_global_geometry_list global_geometry_list = {0,NULL};
#endif

int dummy;
int loop_index,found_geometries;
int loop_2_index;
int material_index;

struct Volume_struct this_cylinder_volume;
struct cylinder_storage this_cylinder_storage;
#line 33209 "MACS_sample_kidney_box.c"
#undef number_of_activations
#undef mask_setting
#undef mask_string
#undef p_interact
#undef focus_r
#undef focus_xh
#undef focus_xw
#undef focus_ah
#undef focus_aw
#undef target_z
#undef target_y
#undef target_x
#undef target_index
#undef visualize
#undef yheight
#undef radius
#undef priority
#undef material_string
#undef this_cylinder_storage
#undef global_geometry_element
#undef this_cylinder_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

/* User declarations for component 'kidney_hull_cut' [119]. */
#define mccompcurname  kidney_hull_cut
#define mccompcurtype  Union_cylinder
#define mccompcurindex 119
#define loop_index mcckidney_hull_cut_loop_index
#define this_cylinder_volume mcckidney_hull_cut_this_cylinder_volume
#define global_geometry_element mcckidney_hull_cut_global_geometry_element
#define this_cylinder_storage mcckidney_hull_cut_this_cylinder_storage
#define material_string mcckidney_hull_cut_material_string
#define priority mcckidney_hull_cut_priority
#define radius mcckidney_hull_cut_radius
#define yheight mcckidney_hull_cut_yheight
#define visualize mcckidney_hull_cut_visualize
#define target_index mcckidney_hull_cut_target_index
#define target_x mcckidney_hull_cut_target_x
#define target_y mcckidney_hull_cut_target_y
#define target_z mcckidney_hull_cut_target_z
#define focus_aw mcckidney_hull_cut_focus_aw
#define focus_ah mcckidney_hull_cut_focus_ah
#define focus_xw mcckidney_hull_cut_focus_xw
#define focus_xh mcckidney_hull_cut_focus_xh
#define focus_r mcckidney_hull_cut_focus_r
#define p_interact mcckidney_hull_cut_p_interact
#define mask_string mcckidney_hull_cut_mask_string
#define mask_setting mcckidney_hull_cut_mask_setting
#define number_of_activations mcckidney_hull_cut_number_of_activations
#line 167 "Union_cylinder.comp"
// Needed for transport to the main component
struct global_geometry_element_struct global_geometry_element;

#ifndef ANY_GEOMETRY_DETECTOR_DECLARE
    #define ANY_GEOMETRY_DETECTOR_DECLARE dummy
	//struct pointer_to_global_geometry_list global_geometry_list = {0,NULL};
#endif

int dummy;
int loop_index,found_geometries;
int loop_2_index;
int material_index;

struct Volume_struct this_cylinder_volume;
struct cylinder_storage this_cylinder_storage;
#line 33278 "MACS_sample_kidney_box.c"
#undef number_of_activations
#undef mask_setting
#undef mask_string
#undef p_interact
#undef focus_r
#undef focus_xh
#undef focus_xw
#undef focus_ah
#undef focus_aw
#undef target_z
#undef target_y
#undef target_x
#undef target_index
#undef visualize
#undef yheight
#undef radius
#undef priority
#undef material_string
#undef this_cylinder_storage
#undef global_geometry_element
#undef this_cylinder_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

/* User declarations for component 'kidney_hull_box_cut_arm1' [120]. */
#define mccompcurname  kidney_hull_box_cut_arm1
#define mccompcurtype  Arm
#define mccompcurindex 120
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

/* User declarations for component 'kidney_hull_box_cut1' [121]. */
#define mccompcurname  kidney_hull_box_cut1
#define mccompcurtype  Union_box
#define mccompcurindex 121
#define loop_index mcckidney_hull_box_cut1_loop_index
#define this_box_volume mcckidney_hull_box_cut1_this_box_volume
#define global_geometry_element mcckidney_hull_box_cut1_global_geometry_element
#define this_box_storage mcckidney_hull_box_cut1_this_box_storage
#define material_string mcckidney_hull_box_cut1_material_string
#define priority mcckidney_hull_box_cut1_priority
#define xwidth mcckidney_hull_box_cut1_xwidth
#define yheight mcckidney_hull_box_cut1_yheight
#define zdepth mcckidney_hull_box_cut1_zdepth
#define xwidth2 mcckidney_hull_box_cut1_xwidth2
#define yheight2 mcckidney_hull_box_cut1_yheight2
#define visualize mcckidney_hull_box_cut1_visualize
#define target_index mcckidney_hull_box_cut1_target_index
#define target_x mcckidney_hull_box_cut1_target_x
#define target_y mcckidney_hull_box_cut1_target_y
#define target_z mcckidney_hull_box_cut1_target_z
#define focus_aw mcckidney_hull_box_cut1_focus_aw
#define focus_ah mcckidney_hull_box_cut1_focus_ah
#define focus_xw mcckidney_hull_box_cut1_focus_xw
#define focus_xh mcckidney_hull_box_cut1_focus_xh
#define focus_r mcckidney_hull_box_cut1_focus_r
#define p_interact mcckidney_hull_box_cut1_p_interact
#define mask_string mcckidney_hull_box_cut1_mask_string
#define mask_setting mcckidney_hull_box_cut1_mask_setting
#define number_of_activations mcckidney_hull_box_cut1_number_of_activations
#line 204 "Union_box.comp"
// Needed for transport to the main component
struct global_geometry_element_struct global_geometry_element;

#ifndef ANY_GEOMETRY_DETECTOR_DECLARE
    #define ANY_GEOMETRY_DETECTOR_DECLARE dummy
	//struct pointer_to_global_geometry_list global_geometry_list = {0,NULL};
#endif

int loop_index,found_geometries;

double x_component;
double y_component;
double z_component;

struct Volume_struct this_box_volume;
struct box_storage this_box_storage;

#line 33360 "MACS_sample_kidney_box.c"
#undef number_of_activations
#undef mask_setting
#undef mask_string
#undef p_interact
#undef focus_r
#undef focus_xh
#undef focus_xw
#undef focus_ah
#undef focus_aw
#undef target_z
#undef target_y
#undef target_x
#undef target_index
#undef visualize
#undef yheight2
#undef xwidth2
#undef zdepth
#undef yheight
#undef xwidth
#undef priority
#undef material_string
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

/* User declarations for component 'kidney_hull_box_cut_arm2' [122]. */
#define mccompcurname  kidney_hull_box_cut_arm2
#define mccompcurtype  Arm
#define mccompcurindex 122
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

/* User declarations for component 'kidney_hull_box_cut2' [123]. */
#define mccompcurname  kidney_hull_box_cut2
#define mccompcurtype  Union_box
#define mccompcurindex 123
#define loop_index mcckidney_hull_box_cut2_loop_index
#define this_box_volume mcckidney_hull_box_cut2_this_box_volume
#define global_geometry_element mcckidney_hull_box_cut2_global_geometry_element
#define this_box_storage mcckidney_hull_box_cut2_this_box_storage
#define material_string mcckidney_hull_box_cut2_material_string
#define priority mcckidney_hull_box_cut2_priority
#define xwidth mcckidney_hull_box_cut2_xwidth
#define yheight mcckidney_hull_box_cut2_yheight
#define zdepth mcckidney_hull_box_cut2_zdepth
#define xwidth2 mcckidney_hull_box_cut2_xwidth2
#define yheight2 mcckidney_hull_box_cut2_yheight2
#define visualize mcckidney_hull_box_cut2_visualize
#define target_index mcckidney_hull_box_cut2_target_index
#define target_x mcckidney_hull_box_cut2_target_x
#define target_y mcckidney_hull_box_cut2_target_y
#define target_z mcckidney_hull_box_cut2_target_z
#define focus_aw mcckidney_hull_box_cut2_focus_aw
#define focus_ah mcckidney_hull_box_cut2_focus_ah
#define focus_xw mcckidney_hull_box_cut2_focus_xw
#define focus_xh mcckidney_hull_box_cut2_focus_xh
#define focus_r mcckidney_hull_box_cut2_focus_r
#define p_interact mcckidney_hull_box_cut2_p_interact
#define mask_string mcckidney_hull_box_cut2_mask_string
#define mask_setting mcckidney_hull_box_cut2_mask_setting
#define number_of_activations mcckidney_hull_box_cut2_number_of_activations
#line 204 "Union_box.comp"
// Needed for transport to the main component
struct global_geometry_element_struct global_geometry_element;

#ifndef ANY_GEOMETRY_DETECTOR_DECLARE
    #define ANY_GEOMETRY_DETECTOR_DECLARE dummy
	//struct pointer_to_global_geometry_list global_geometry_list = {0,NULL};
#endif

int loop_index,found_geometries;

double x_component;
double y_component;
double z_component;

struct Volume_struct this_box_volume;
struct box_storage this_box_storage;

#line 33445 "MACS_sample_kidney_box.c"
#undef number_of_activations
#undef mask_setting
#undef mask_string
#undef p_interact
#undef focus_r
#undef focus_xh
#undef focus_xw
#undef focus_ah
#undef focus_aw
#undef target_z
#undef target_y
#undef target_x
#undef target_index
#undef visualize
#undef yheight2
#undef xwidth2
#undef zdepth
#undef yheight
#undef xwidth
#undef priority
#undef material_string
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

/* User declarations for component 'channel_0_cave1_box1' [124]. */
#define mccompcurname  channel_0_cave1_box1
#define mccompcurtype  Union_box
#define mccompcurindex 124
#define loop_index mccchannel_0_cave1_box1_loop_index
#define this_box_volume mccchannel_0_cave1_box1_this_box_volume
#define global_geometry_element mccchannel_0_cave1_box1_global_geometry_element
#define this_box_storage mccchannel_0_cave1_box1_this_box_storage
#define material_string mccchannel_0_cave1_box1_material_string
#define priority mccchannel_0_cave1_box1_priority
#define xwidth mccchannel_0_cave1_box1_xwidth
#define yheight mccchannel_0_cave1_box1_yheight
#define zdepth mccchannel_0_cave1_box1_zdepth
#define xwidth2 mccchannel_0_cave1_box1_xwidth2
#define yheight2 mccchannel_0_cave1_box1_yheight2
#define visualize mccchannel_0_cave1_box1_visualize
#define target_index mccchannel_0_cave1_box1_target_index
#define target_x mccchannel_0_cave1_box1_target_x
#define target_y mccchannel_0_cave1_box1_target_y
#define target_z mccchannel_0_cave1_box1_target_z
#define focus_aw mccchannel_0_cave1_box1_focus_aw
#define focus_ah mccchannel_0_cave1_box1_focus_ah
#define focus_xw mccchannel_0_cave1_box1_focus_xw
#define focus_xh mccchannel_0_cave1_box1_focus_xh
#define focus_r mccchannel_0_cave1_box1_focus_r
#define p_interact mccchannel_0_cave1_box1_p_interact
#define mask_string mccchannel_0_cave1_box1_mask_string
#define mask_setting mccchannel_0_cave1_box1_mask_setting
#define number_of_activations mccchannel_0_cave1_box1_number_of_activations
#line 204 "Union_box.comp"
// Needed for transport to the main component
struct global_geometry_element_struct global_geometry_element;

#ifndef ANY_GEOMETRY_DETECTOR_DECLARE
    #define ANY_GEOMETRY_DETECTOR_DECLARE dummy
	//struct pointer_to_global_geometry_list global_geometry_list = {0,NULL};
#endif

int loop_index,found_geometries;

double x_component;
double y_component;
double z_component;

struct Volume_struct this_box_volume;
struct box_storage this_box_storage;

#line 33522 "MACS_sample_kidney_box.c"
#undef number_of_activations
#undef mask_setting
#undef mask_string
#undef p_interact
#undef focus_r
#undef focus_xh
#undef focus_xw
#undef focus_ah
#undef focus_aw
#undef target_z
#undef target_y
#undef target_x
#undef target_index
#undef visualize
#undef yheight2
#undef xwidth2
#undef zdepth
#undef yheight
#undef xwidth
#undef priority
#undef material_string
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

/* User declarations for component 'channel_0_cave1_box2' [125]. */
#define mccompcurname  channel_0_cave1_box2
#define mccompcurtype  Union_box
#define mccompcurindex 125
#define loop_index mccchannel_0_cave1_box2_loop_index
#define this_box_volume mccchannel_0_cave1_box2_this_box_volume
#define global_geometry_element mccchannel_0_cave1_box2_global_geometry_element
#define this_box_storage mccchannel_0_cave1_box2_this_box_storage
#define material_string mccchannel_0_cave1_box2_material_string
#define priority mccchannel_0_cave1_box2_priority
#define xwidth mccchannel_0_cave1_box2_xwidth
#define yheight mccchannel_0_cave1_box2_yheight
#define zdepth mccchannel_0_cave1_box2_zdepth
#define xwidth2 mccchannel_0_cave1_box2_xwidth2
#define yheight2 mccchannel_0_cave1_box2_yheight2
#define visualize mccchannel_0_cave1_box2_visualize
#define target_index mccchannel_0_cave1_box2_target_index
#define target_x mccchannel_0_cave1_box2_target_x
#define target_y mccchannel_0_cave1_box2_target_y
#define target_z mccchannel_0_cave1_box2_target_z
#define focus_aw mccchannel_0_cave1_box2_focus_aw
#define focus_ah mccchannel_0_cave1_box2_focus_ah
#define focus_xw mccchannel_0_cave1_box2_focus_xw
#define focus_xh mccchannel_0_cave1_box2_focus_xh
#define focus_r mccchannel_0_cave1_box2_focus_r
#define p_interact mccchannel_0_cave1_box2_p_interact
#define mask_string mccchannel_0_cave1_box2_mask_string
#define mask_setting mccchannel_0_cave1_box2_mask_setting
#define number_of_activations mccchannel_0_cave1_box2_number_of_activations
#line 204 "Union_box.comp"
// Needed for transport to the main component
struct global_geometry_element_struct global_geometry_element;

#ifndef ANY_GEOMETRY_DETECTOR_DECLARE
    #define ANY_GEOMETRY_DETECTOR_DECLARE dummy
	//struct pointer_to_global_geometry_list global_geometry_list = {0,NULL};
#endif

int loop_index,found_geometries;

double x_component;
double y_component;
double z_component;

struct Volume_struct this_box_volume;
struct box_storage this_box_storage;

#line 33599 "MACS_sample_kidney_box.c"
#undef number_of_activations
#undef mask_setting
#undef mask_string
#undef p_interact
#undef focus_r
#undef focus_xh
#undef focus_xw
#undef focus_ah
#undef focus_aw
#undef target_z
#undef target_y
#undef target_x
#undef target_index
#undef visualize
#undef yheight2
#undef xwidth2
#undef zdepth
#undef yheight
#undef xwidth
#undef priority
#undef material_string
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

/* User declarations for component 'channel_0_cave1_box3' [126]. */
#define mccompcurname  channel_0_cave1_box3
#define mccompcurtype  Union_box
#define mccompcurindex 126
#define loop_index mccchannel_0_cave1_box3_loop_index
#define this_box_volume mccchannel_0_cave1_box3_this_box_volume
#define global_geometry_element mccchannel_0_cave1_box3_global_geometry_element
#define this_box_storage mccchannel_0_cave1_box3_this_box_storage
#define material_string mccchannel_0_cave1_box3_material_string
#define priority mccchannel_0_cave1_box3_priority
#define xwidth mccchannel_0_cave1_box3_xwidth
#define yheight mccchannel_0_cave1_box3_yheight
#define zdepth mccchannel_0_cave1_box3_zdepth
#define xwidth2 mccchannel_0_cave1_box3_xwidth2
#define yheight2 mccchannel_0_cave1_box3_yheight2
#define visualize mccchannel_0_cave1_box3_visualize
#define target_index mccchannel_0_cave1_box3_target_index
#define target_x mccchannel_0_cave1_box3_target_x
#define target_y mccchannel_0_cave1_box3_target_y
#define target_z mccchannel_0_cave1_box3_target_z
#define focus_aw mccchannel_0_cave1_box3_focus_aw
#define focus_ah mccchannel_0_cave1_box3_focus_ah
#define focus_xw mccchannel_0_cave1_box3_focus_xw
#define focus_xh mccchannel_0_cave1_box3_focus_xh
#define focus_r mccchannel_0_cave1_box3_focus_r
#define p_interact mccchannel_0_cave1_box3_p_interact
#define mask_string mccchannel_0_cave1_box3_mask_string
#define mask_setting mccchannel_0_cave1_box3_mask_setting
#define number_of_activations mccchannel_0_cave1_box3_number_of_activations
#line 204 "Union_box.comp"
// Needed for transport to the main component
struct global_geometry_element_struct global_geometry_element;

#ifndef ANY_GEOMETRY_DETECTOR_DECLARE
    #define ANY_GEOMETRY_DETECTOR_DECLARE dummy
	//struct pointer_to_global_geometry_list global_geometry_list = {0,NULL};
#endif

int loop_index,found_geometries;

double x_component;
double y_component;
double z_component;

struct Volume_struct this_box_volume;
struct box_storage this_box_storage;

#line 33676 "MACS_sample_kidney_box.c"
#undef number_of_activations
#undef mask_setting
#undef mask_string
#undef p_interact
#undef focus_r
#undef focus_xh
#undef focus_xw
#undef focus_ah
#undef focus_aw
#undef target_z
#undef target_y
#undef target_x
#undef target_index
#undef visualize
#undef yheight2
#undef xwidth2
#undef zdepth
#undef yheight
#undef xwidth
#undef priority
#undef material_string
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

/* User declarations for component 'channel_0_cave1_cyl1' [127]. */
#define mccompcurname  channel_0_cave1_cyl1
#define mccompcurtype  Union_cylinder
#define mccompcurindex 127
#define loop_index mccchannel_0_cave1_cyl1_loop_index
#define this_cylinder_volume mccchannel_0_cave1_cyl1_this_cylinder_volume
#define global_geometry_element mccchannel_0_cave1_cyl1_global_geometry_element
#define this_cylinder_storage mccchannel_0_cave1_cyl1_this_cylinder_storage
#define material_string mccchannel_0_cave1_cyl1_material_string
#define priority mccchannel_0_cave1_cyl1_priority
#define radius mccchannel_0_cave1_cyl1_radius
#define yheight mccchannel_0_cave1_cyl1_yheight
#define visualize mccchannel_0_cave1_cyl1_visualize
#define target_index mccchannel_0_cave1_cyl1_target_index
#define target_x mccchannel_0_cave1_cyl1_target_x
#define target_y mccchannel_0_cave1_cyl1_target_y
#define target_z mccchannel_0_cave1_cyl1_target_z
#define focus_aw mccchannel_0_cave1_cyl1_focus_aw
#define focus_ah mccchannel_0_cave1_cyl1_focus_ah
#define focus_xw mccchannel_0_cave1_cyl1_focus_xw
#define focus_xh mccchannel_0_cave1_cyl1_focus_xh
#define focus_r mccchannel_0_cave1_cyl1_focus_r
#define p_interact mccchannel_0_cave1_cyl1_p_interact
#define mask_string mccchannel_0_cave1_cyl1_mask_string
#define mask_setting mccchannel_0_cave1_cyl1_mask_setting
#define number_of_activations mccchannel_0_cave1_cyl1_number_of_activations
#line 167 "Union_cylinder.comp"
// Needed for transport to the main component
struct global_geometry_element_struct global_geometry_element;

#ifndef ANY_GEOMETRY_DETECTOR_DECLARE
    #define ANY_GEOMETRY_DETECTOR_DECLARE dummy
	//struct pointer_to_global_geometry_list global_geometry_list = {0,NULL};
#endif

int dummy;
int loop_index,found_geometries;
int loop_2_index;
int material_index;

struct Volume_struct this_cylinder_volume;
struct cylinder_storage this_cylinder_storage;
#line 33748 "MACS_sample_kidney_box.c"
#undef number_of_activations
#undef mask_setting
#undef mask_string
#undef p_interact
#undef focus_r
#undef focus_xh
#undef focus_xw
#undef focus_ah
#undef focus_aw
#undef target_z
#undef target_y
#undef target_x
#undef target_index
#undef visualize
#undef yheight
#undef radius
#undef priority
#undef material_string
#undef this_cylinder_storage
#undef global_geometry_element
#undef this_cylinder_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

/* User declarations for component 'channel_0_analyzer_1_center' [128]. */
#define mccompcurname  channel_0_analyzer_1_center
#define mccompcurtype  Arm
#define mccompcurindex 128
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

/* User declarations for component 'channel_0_analyzer_1_rotated' [129]. */
#define mccompcurname  channel_0_analyzer_1_rotated
#define mccompcurtype  Arm
#define mccompcurindex 129
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

/* User declarations for component 'channel_0_analyzer_1_array_crystal_array_0' [130]. */
#define mccompcurname  channel_0_analyzer_1_array_crystal_array_0
#define mccompcurtype  Union_box
#define mccompcurindex 130
#define loop_index mccchannel_0_analyzer_1_array_crystal_array_0_loop_index
#define this_box_volume mccchannel_0_analyzer_1_array_crystal_array_0_this_box_volume
#define global_geometry_element mccchannel_0_analyzer_1_array_crystal_array_0_global_geometry_element
#define this_box_storage mccchannel_0_analyzer_1_array_crystal_array_0_this_box_storage
#define material_string mccchannel_0_analyzer_1_array_crystal_array_0_material_string
#define priority mccchannel_0_analyzer_1_array_crystal_array_0_priority
#define xwidth mccchannel_0_analyzer_1_array_crystal_array_0_xwidth
#define yheight mccchannel_0_analyzer_1_array_crystal_array_0_yheight
#define zdepth mccchannel_0_analyzer_1_array_crystal_array_0_zdepth
#define xwidth2 mccchannel_0_analyzer_1_array_crystal_array_0_xwidth2
#define yheight2 mccchannel_0_analyzer_1_array_crystal_array_0_yheight2
#define visualize mccchannel_0_analyzer_1_array_crystal_array_0_visualize
#define target_index mccchannel_0_analyzer_1_array_crystal_array_0_target_index
#define target_x mccchannel_0_analyzer_1_array_crystal_array_0_target_x
#define target_y mccchannel_0_analyzer_1_array_crystal_array_0_target_y
#define target_z mccchannel_0_analyzer_1_array_crystal_array_0_target_z
#define focus_aw mccchannel_0_analyzer_1_array_crystal_array_0_focus_aw
#define focus_ah mccchannel_0_analyzer_1_array_crystal_array_0_focus_ah
#define focus_xw mccchannel_0_analyzer_1_array_crystal_array_0_focus_xw
#define focus_xh mccchannel_0_analyzer_1_array_crystal_array_0_focus_xh
#define focus_r mccchannel_0_analyzer_1_array_crystal_array_0_focus_r
#define p_interact mccchannel_0_analyzer_1_array_crystal_array_0_p_interact
#define mask_string mccchannel_0_analyzer_1_array_crystal_array_0_mask_string
#define mask_setting mccchannel_0_analyzer_1_array_crystal_array_0_mask_setting
#define number_of_activations mccchannel_0_analyzer_1_array_crystal_array_0_number_of_activations
#line 204 "Union_box.comp"
// Needed for transport to the main component
struct global_geometry_element_struct global_geometry_element;

#ifndef ANY_GEOMETRY_DETECTOR_DECLARE
    #define ANY_GEOMETRY_DETECTOR_DECLARE dummy
	//struct pointer_to_global_geometry_list global_geometry_list = {0,NULL};
#endif

int loop_index,found_geometries;

double x_component;
double y_component;
double z_component;

struct Volume_struct this_box_volume;
struct box_storage this_box_storage;

#line 33838 "MACS_sample_kidney_box.c"
#undef number_of_activations
#undef mask_setting
#undef mask_string
#undef p_interact
#undef focus_r
#undef focus_xh
#undef focus_xw
#undef focus_ah
#undef focus_aw
#undef target_z
#undef target_y
#undef target_x
#undef target_index
#undef visualize
#undef yheight2
#undef xwidth2
#undef zdepth
#undef yheight
#undef xwidth
#undef priority
#undef material_string
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

/* User declarations for component 'channel_0_analyzer_1_array_crystal_array_1' [131]. */
#define mccompcurname  channel_0_analyzer_1_array_crystal_array_1
#define mccompcurtype  Union_box
#define mccompcurindex 131
#define loop_index mccchannel_0_analyzer_1_array_crystal_array_1_loop_index
#define this_box_volume mccchannel_0_analyzer_1_array_crystal_array_1_this_box_volume
#define global_geometry_element mccchannel_0_analyzer_1_array_crystal_array_1_global_geometry_element
#define this_box_storage mccchannel_0_analyzer_1_array_crystal_array_1_this_box_storage
#define material_string mccchannel_0_analyzer_1_array_crystal_array_1_material_string
#define priority mccchannel_0_analyzer_1_array_crystal_array_1_priority
#define xwidth mccchannel_0_analyzer_1_array_crystal_array_1_xwidth
#define yheight mccchannel_0_analyzer_1_array_crystal_array_1_yheight
#define zdepth mccchannel_0_analyzer_1_array_crystal_array_1_zdepth
#define xwidth2 mccchannel_0_analyzer_1_array_crystal_array_1_xwidth2
#define yheight2 mccchannel_0_analyzer_1_array_crystal_array_1_yheight2
#define visualize mccchannel_0_analyzer_1_array_crystal_array_1_visualize
#define target_index mccchannel_0_analyzer_1_array_crystal_array_1_target_index
#define target_x mccchannel_0_analyzer_1_array_crystal_array_1_target_x
#define target_y mccchannel_0_analyzer_1_array_crystal_array_1_target_y
#define target_z mccchannel_0_analyzer_1_array_crystal_array_1_target_z
#define focus_aw mccchannel_0_analyzer_1_array_crystal_array_1_focus_aw
#define focus_ah mccchannel_0_analyzer_1_array_crystal_array_1_focus_ah
#define focus_xw mccchannel_0_analyzer_1_array_crystal_array_1_focus_xw
#define focus_xh mccchannel_0_analyzer_1_array_crystal_array_1_focus_xh
#define focus_r mccchannel_0_analyzer_1_array_crystal_array_1_focus_r
#define p_interact mccchannel_0_analyzer_1_array_crystal_array_1_p_interact
#define mask_string mccchannel_0_analyzer_1_array_crystal_array_1_mask_string
#define mask_setting mccchannel_0_analyzer_1_array_crystal_array_1_mask_setting
#define number_of_activations mccchannel_0_analyzer_1_array_crystal_array_1_number_of_activations
#line 204 "Union_box.comp"
// Needed for transport to the main component
struct global_geometry_element_struct global_geometry_element;

#ifndef ANY_GEOMETRY_DETECTOR_DECLARE
    #define ANY_GEOMETRY_DETECTOR_DECLARE dummy
	//struct pointer_to_global_geometry_list global_geometry_list = {0,NULL};
#endif

int loop_index,found_geometries;

double x_component;
double y_component;
double z_component;

struct Volume_struct this_box_volume;
struct box_storage this_box_storage;

#line 33915 "MACS_sample_kidney_box.c"
#undef number_of_activations
#undef mask_setting
#undef mask_string
#undef p_interact
#undef focus_r
#undef focus_xh
#undef focus_xw
#undef focus_ah
#undef focus_aw
#undef target_z
#undef target_y
#undef target_x
#undef target_index
#undef visualize
#undef yheight2
#undef xwidth2
#undef zdepth
#undef yheight
#undef xwidth
#undef priority
#undef material_string
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

/* User declarations for component 'channel_0_analyzer_1_array_crystal_array_2' [132]. */
#define mccompcurname  channel_0_analyzer_1_array_crystal_array_2
#define mccompcurtype  Union_box
#define mccompcurindex 132
#define loop_index mccchannel_0_analyzer_1_array_crystal_array_2_loop_index
#define this_box_volume mccchannel_0_analyzer_1_array_crystal_array_2_this_box_volume
#define global_geometry_element mccchannel_0_analyzer_1_array_crystal_array_2_global_geometry_element
#define this_box_storage mccchannel_0_analyzer_1_array_crystal_array_2_this_box_storage
#define material_string mccchannel_0_analyzer_1_array_crystal_array_2_material_string
#define priority mccchannel_0_analyzer_1_array_crystal_array_2_priority
#define xwidth mccchannel_0_analyzer_1_array_crystal_array_2_xwidth
#define yheight mccchannel_0_analyzer_1_array_crystal_array_2_yheight
#define zdepth mccchannel_0_analyzer_1_array_crystal_array_2_zdepth
#define xwidth2 mccchannel_0_analyzer_1_array_crystal_array_2_xwidth2
#define yheight2 mccchannel_0_analyzer_1_array_crystal_array_2_yheight2
#define visualize mccchannel_0_analyzer_1_array_crystal_array_2_visualize
#define target_index mccchannel_0_analyzer_1_array_crystal_array_2_target_index
#define target_x mccchannel_0_analyzer_1_array_crystal_array_2_target_x
#define target_y mccchannel_0_analyzer_1_array_crystal_array_2_target_y
#define target_z mccchannel_0_analyzer_1_array_crystal_array_2_target_z
#define focus_aw mccchannel_0_analyzer_1_array_crystal_array_2_focus_aw
#define focus_ah mccchannel_0_analyzer_1_array_crystal_array_2_focus_ah
#define focus_xw mccchannel_0_analyzer_1_array_crystal_array_2_focus_xw
#define focus_xh mccchannel_0_analyzer_1_array_crystal_array_2_focus_xh
#define focus_r mccchannel_0_analyzer_1_array_crystal_array_2_focus_r
#define p_interact mccchannel_0_analyzer_1_array_crystal_array_2_p_interact
#define mask_string mccchannel_0_analyzer_1_array_crystal_array_2_mask_string
#define mask_setting mccchannel_0_analyzer_1_array_crystal_array_2_mask_setting
#define number_of_activations mccchannel_0_analyzer_1_array_crystal_array_2_number_of_activations
#line 204 "Union_box.comp"
// Needed for transport to the main component
struct global_geometry_element_struct global_geometry_element;

#ifndef ANY_GEOMETRY_DETECTOR_DECLARE
    #define ANY_GEOMETRY_DETECTOR_DECLARE dummy
	//struct pointer_to_global_geometry_list global_geometry_list = {0,NULL};
#endif

int loop_index,found_geometries;

double x_component;
double y_component;
double z_component;

struct Volume_struct this_box_volume;
struct box_storage this_box_storage;

#line 33992 "MACS_sample_kidney_box.c"
#undef number_of_activations
#undef mask_setting
#undef mask_string
#undef p_interact
#undef focus_r
#undef focus_xh
#undef focus_xw
#undef focus_ah
#undef focus_aw
#undef target_z
#undef target_y
#undef target_x
#undef target_index
#undef visualize
#undef yheight2
#undef xwidth2
#undef zdepth
#undef yheight
#undef xwidth
#undef priority
#undef material_string
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

/* User declarations for component 'channel_0_analyzer_1_array_crystal_array_3' [133]. */
#define mccompcurname  channel_0_analyzer_1_array_crystal_array_3
#define mccompcurtype  Union_box
#define mccompcurindex 133
#define loop_index mccchannel_0_analyzer_1_array_crystal_array_3_loop_index
#define this_box_volume mccchannel_0_analyzer_1_array_crystal_array_3_this_box_volume
#define global_geometry_element mccchannel_0_analyzer_1_array_crystal_array_3_global_geometry_element
#define this_box_storage mccchannel_0_analyzer_1_array_crystal_array_3_this_box_storage
#define material_string mccchannel_0_analyzer_1_array_crystal_array_3_material_string
#define priority mccchannel_0_analyzer_1_array_crystal_array_3_priority
#define xwidth mccchannel_0_analyzer_1_array_crystal_array_3_xwidth
#define yheight mccchannel_0_analyzer_1_array_crystal_array_3_yheight
#define zdepth mccchannel_0_analyzer_1_array_crystal_array_3_zdepth
#define xwidth2 mccchannel_0_analyzer_1_array_crystal_array_3_xwidth2
#define yheight2 mccchannel_0_analyzer_1_array_crystal_array_3_yheight2
#define visualize mccchannel_0_analyzer_1_array_crystal_array_3_visualize
#define target_index mccchannel_0_analyzer_1_array_crystal_array_3_target_index
#define target_x mccchannel_0_analyzer_1_array_crystal_array_3_target_x
#define target_y mccchannel_0_analyzer_1_array_crystal_array_3_target_y
#define target_z mccchannel_0_analyzer_1_array_crystal_array_3_target_z
#define focus_aw mccchannel_0_analyzer_1_array_crystal_array_3_focus_aw
#define focus_ah mccchannel_0_analyzer_1_array_crystal_array_3_focus_ah
#define focus_xw mccchannel_0_analyzer_1_array_crystal_array_3_focus_xw
#define focus_xh mccchannel_0_analyzer_1_array_crystal_array_3_focus_xh
#define focus_r mccchannel_0_analyzer_1_array_crystal_array_3_focus_r
#define p_interact mccchannel_0_analyzer_1_array_crystal_array_3_p_interact
#define mask_string mccchannel_0_analyzer_1_array_crystal_array_3_mask_string
#define mask_setting mccchannel_0_analyzer_1_array_crystal_array_3_mask_setting
#define number_of_activations mccchannel_0_analyzer_1_array_crystal_array_3_number_of_activations
#line 204 "Union_box.comp"
// Needed for transport to the main component
struct global_geometry_element_struct global_geometry_element;

#ifndef ANY_GEOMETRY_DETECTOR_DECLARE
    #define ANY_GEOMETRY_DETECTOR_DECLARE dummy
	//struct pointer_to_global_geometry_list global_geometry_list = {0,NULL};
#endif

int loop_index,found_geometries;

double x_component;
double y_component;
double z_component;

struct Volume_struct this_box_volume;
struct box_storage this_box_storage;

#line 34069 "MACS_sample_kidney_box.c"
#undef number_of_activations
#undef mask_setting
#undef mask_string
#undef p_interact
#undef focus_r
#undef focus_xh
#undef focus_xw
#undef focus_ah
#undef focus_aw
#undef target_z
#undef target_y
#undef target_x
#undef target_index
#undef visualize
#undef yheight2
#undef xwidth2
#undef zdepth
#undef yheight
#undef xwidth
#undef priority
#undef material_string
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

/* User declarations for component 'channel_0_analyzer_1_array_crystal_array_4' [134]. */
#define mccompcurname  channel_0_analyzer_1_array_crystal_array_4
#define mccompcurtype  Union_box
#define mccompcurindex 134
#define loop_index mccchannel_0_analyzer_1_array_crystal_array_4_loop_index
#define this_box_volume mccchannel_0_analyzer_1_array_crystal_array_4_this_box_volume
#define global_geometry_element mccchannel_0_analyzer_1_array_crystal_array_4_global_geometry_element
#define this_box_storage mccchannel_0_analyzer_1_array_crystal_array_4_this_box_storage
#define material_string mccchannel_0_analyzer_1_array_crystal_array_4_material_string
#define priority mccchannel_0_analyzer_1_array_crystal_array_4_priority
#define xwidth mccchannel_0_analyzer_1_array_crystal_array_4_xwidth
#define yheight mccchannel_0_analyzer_1_array_crystal_array_4_yheight
#define zdepth mccchannel_0_analyzer_1_array_crystal_array_4_zdepth
#define xwidth2 mccchannel_0_analyzer_1_array_crystal_array_4_xwidth2
#define yheight2 mccchannel_0_analyzer_1_array_crystal_array_4_yheight2
#define visualize mccchannel_0_analyzer_1_array_crystal_array_4_visualize
#define target_index mccchannel_0_analyzer_1_array_crystal_array_4_target_index
#define target_x mccchannel_0_analyzer_1_array_crystal_array_4_target_x
#define target_y mccchannel_0_analyzer_1_array_crystal_array_4_target_y
#define target_z mccchannel_0_analyzer_1_array_crystal_array_4_target_z
#define focus_aw mccchannel_0_analyzer_1_array_crystal_array_4_focus_aw
#define focus_ah mccchannel_0_analyzer_1_array_crystal_array_4_focus_ah
#define focus_xw mccchannel_0_analyzer_1_array_crystal_array_4_focus_xw
#define focus_xh mccchannel_0_analyzer_1_array_crystal_array_4_focus_xh
#define focus_r mccchannel_0_analyzer_1_array_crystal_array_4_focus_r
#define p_interact mccchannel_0_analyzer_1_array_crystal_array_4_p_interact
#define mask_string mccchannel_0_analyzer_1_array_crystal_array_4_mask_string
#define mask_setting mccchannel_0_analyzer_1_array_crystal_array_4_mask_setting
#define number_of_activations mccchannel_0_analyzer_1_array_crystal_array_4_number_of_activations
#line 204 "Union_box.comp"
// Needed for transport to the main component
struct global_geometry_element_struct global_geometry_element;

#ifndef ANY_GEOMETRY_DETECTOR_DECLARE
    #define ANY_GEOMETRY_DETECTOR_DECLARE dummy
	//struct pointer_to_global_geometry_list global_geometry_list = {0,NULL};
#endif

int loop_index,found_geometries;

double x_component;
double y_component;
double z_component;

struct Volume_struct this_box_volume;
struct box_storage this_box_storage;

#line 34146 "MACS_sample_kidney_box.c"
#undef number_of_activations
#undef mask_setting
#undef mask_string
#undef p_interact
#undef focus_r
#undef focus_xh
#undef focus_xw
#undef focus_ah
#undef focus_aw
#undef target_z
#undef target_y
#undef target_x
#undef target_index
#undef visualize
#undef yheight2
#undef xwidth2
#undef zdepth
#undef yheight
#undef xwidth
#undef priority
#undef material_string
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

/* User declarations for component 'channel_0_analyzer_1_array_crystal_array_5' [135]. */
#define mccompcurname  channel_0_analyzer_1_array_crystal_array_5
#define mccompcurtype  Union_box
#define mccompcurindex 135
#define loop_index mccchannel_0_analyzer_1_array_crystal_array_5_loop_index
#define this_box_volume mccchannel_0_analyzer_1_array_crystal_array_5_this_box_volume
#define global_geometry_element mccchannel_0_analyzer_1_array_crystal_array_5_global_geometry_element
#define this_box_storage mccchannel_0_analyzer_1_array_crystal_array_5_this_box_storage
#define material_string mccchannel_0_analyzer_1_array_crystal_array_5_material_string
#define priority mccchannel_0_analyzer_1_array_crystal_array_5_priority
#define xwidth mccchannel_0_analyzer_1_array_crystal_array_5_xwidth
#define yheight mccchannel_0_analyzer_1_array_crystal_array_5_yheight
#define zdepth mccchannel_0_analyzer_1_array_crystal_array_5_zdepth
#define xwidth2 mccchannel_0_analyzer_1_array_crystal_array_5_xwidth2
#define yheight2 mccchannel_0_analyzer_1_array_crystal_array_5_yheight2
#define visualize mccchannel_0_analyzer_1_array_crystal_array_5_visualize
#define target_index mccchannel_0_analyzer_1_array_crystal_array_5_target_index
#define target_x mccchannel_0_analyzer_1_array_crystal_array_5_target_x
#define target_y mccchannel_0_analyzer_1_array_crystal_array_5_target_y
#define target_z mccchannel_0_analyzer_1_array_crystal_array_5_target_z
#define focus_aw mccchannel_0_analyzer_1_array_crystal_array_5_focus_aw
#define focus_ah mccchannel_0_analyzer_1_array_crystal_array_5_focus_ah
#define focus_xw mccchannel_0_analyzer_1_array_crystal_array_5_focus_xw
#define focus_xh mccchannel_0_analyzer_1_array_crystal_array_5_focus_xh
#define focus_r mccchannel_0_analyzer_1_array_crystal_array_5_focus_r
#define p_interact mccchannel_0_analyzer_1_array_crystal_array_5_p_interact
#define mask_string mccchannel_0_analyzer_1_array_crystal_array_5_mask_string
#define mask_setting mccchannel_0_analyzer_1_array_crystal_array_5_mask_setting
#define number_of_activations mccchannel_0_analyzer_1_array_crystal_array_5_number_of_activations
#line 204 "Union_box.comp"
// Needed for transport to the main component
struct global_geometry_element_struct global_geometry_element;

#ifndef ANY_GEOMETRY_DETECTOR_DECLARE
    #define ANY_GEOMETRY_DETECTOR_DECLARE dummy
	//struct pointer_to_global_geometry_list global_geometry_list = {0,NULL};
#endif

int loop_index,found_geometries;

double x_component;
double y_component;
double z_component;

struct Volume_struct this_box_volume;
struct box_storage this_box_storage;

#line 34223 "MACS_sample_kidney_box.c"
#undef number_of_activations
#undef mask_setting
#undef mask_string
#undef p_interact
#undef focus_r
#undef focus_xh
#undef focus_xw
#undef focus_ah
#undef focus_aw
#undef target_z
#undef target_y
#undef target_x
#undef target_index
#undef visualize
#undef yheight2
#undef xwidth2
#undef zdepth
#undef yheight
#undef xwidth
#undef priority
#undef material_string
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

/* User declarations for component 'channel_0_analyzer_1_array_crystal_array_6' [136]. */
#define mccompcurname  channel_0_analyzer_1_array_crystal_array_6
#define mccompcurtype  Union_box
#define mccompcurindex 136
#define loop_index mccchannel_0_analyzer_1_array_crystal_array_6_loop_index
#define this_box_volume mccchannel_0_analyzer_1_array_crystal_array_6_this_box_volume
#define global_geometry_element mccchannel_0_analyzer_1_array_crystal_array_6_global_geometry_element
#define this_box_storage mccchannel_0_analyzer_1_array_crystal_array_6_this_box_storage
#define material_string mccchannel_0_analyzer_1_array_crystal_array_6_material_string
#define priority mccchannel_0_analyzer_1_array_crystal_array_6_priority
#define xwidth mccchannel_0_analyzer_1_array_crystal_array_6_xwidth
#define yheight mccchannel_0_analyzer_1_array_crystal_array_6_yheight
#define zdepth mccchannel_0_analyzer_1_array_crystal_array_6_zdepth
#define xwidth2 mccchannel_0_analyzer_1_array_crystal_array_6_xwidth2
#define yheight2 mccchannel_0_analyzer_1_array_crystal_array_6_yheight2
#define visualize mccchannel_0_analyzer_1_array_crystal_array_6_visualize
#define target_index mccchannel_0_analyzer_1_array_crystal_array_6_target_index
#define target_x mccchannel_0_analyzer_1_array_crystal_array_6_target_x
#define target_y mccchannel_0_analyzer_1_array_crystal_array_6_target_y
#define target_z mccchannel_0_analyzer_1_array_crystal_array_6_target_z
#define focus_aw mccchannel_0_analyzer_1_array_crystal_array_6_focus_aw
#define focus_ah mccchannel_0_analyzer_1_array_crystal_array_6_focus_ah
#define focus_xw mccchannel_0_analyzer_1_array_crystal_array_6_focus_xw
#define focus_xh mccchannel_0_analyzer_1_array_crystal_array_6_focus_xh
#define focus_r mccchannel_0_analyzer_1_array_crystal_array_6_focus_r
#define p_interact mccchannel_0_analyzer_1_array_crystal_array_6_p_interact
#define mask_string mccchannel_0_analyzer_1_array_crystal_array_6_mask_string
#define mask_setting mccchannel_0_analyzer_1_array_crystal_array_6_mask_setting
#define number_of_activations mccchannel_0_analyzer_1_array_crystal_array_6_number_of_activations
#line 204 "Union_box.comp"
// Needed for transport to the main component
struct global_geometry_element_struct global_geometry_element;

#ifndef ANY_GEOMETRY_DETECTOR_DECLARE
    #define ANY_GEOMETRY_DETECTOR_DECLARE dummy
	//struct pointer_to_global_geometry_list global_geometry_list = {0,NULL};
#endif

int loop_index,found_geometries;

double x_component;
double y_component;
double z_component;

struct Volume_struct this_box_volume;
struct box_storage this_box_storage;

#line 34300 "MACS_sample_kidney_box.c"
#undef number_of_activations
#undef mask_setting
#undef mask_string
#undef p_interact
#undef focus_r
#undef focus_xh
#undef focus_xw
#undef focus_ah
#undef focus_aw
#undef target_z
#undef target_y
#undef target_x
#undef target_index
#undef visualize
#undef yheight2
#undef xwidth2
#undef zdepth
#undef yheight
#undef xwidth
#undef priority
#undef material_string
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

/* User declarations for component 'channel_0_analyzer_1_array_crystal_array_7' [137]. */
#define mccompcurname  channel_0_analyzer_1_array_crystal_array_7
#define mccompcurtype  Union_box
#define mccompcurindex 137
#define loop_index mccchannel_0_analyzer_1_array_crystal_array_7_loop_index
#define this_box_volume mccchannel_0_analyzer_1_array_crystal_array_7_this_box_volume
#define global_geometry_element mccchannel_0_analyzer_1_array_crystal_array_7_global_geometry_element
#define this_box_storage mccchannel_0_analyzer_1_array_crystal_array_7_this_box_storage
#define material_string mccchannel_0_analyzer_1_array_crystal_array_7_material_string
#define priority mccchannel_0_analyzer_1_array_crystal_array_7_priority
#define xwidth mccchannel_0_analyzer_1_array_crystal_array_7_xwidth
#define yheight mccchannel_0_analyzer_1_array_crystal_array_7_yheight
#define zdepth mccchannel_0_analyzer_1_array_crystal_array_7_zdepth
#define xwidth2 mccchannel_0_analyzer_1_array_crystal_array_7_xwidth2
#define yheight2 mccchannel_0_analyzer_1_array_crystal_array_7_yheight2
#define visualize mccchannel_0_analyzer_1_array_crystal_array_7_visualize
#define target_index mccchannel_0_analyzer_1_array_crystal_array_7_target_index
#define target_x mccchannel_0_analyzer_1_array_crystal_array_7_target_x
#define target_y mccchannel_0_analyzer_1_array_crystal_array_7_target_y
#define target_z mccchannel_0_analyzer_1_array_crystal_array_7_target_z
#define focus_aw mccchannel_0_analyzer_1_array_crystal_array_7_focus_aw
#define focus_ah mccchannel_0_analyzer_1_array_crystal_array_7_focus_ah
#define focus_xw mccchannel_0_analyzer_1_array_crystal_array_7_focus_xw
#define focus_xh mccchannel_0_analyzer_1_array_crystal_array_7_focus_xh
#define focus_r mccchannel_0_analyzer_1_array_crystal_array_7_focus_r
#define p_interact mccchannel_0_analyzer_1_array_crystal_array_7_p_interact
#define mask_string mccchannel_0_analyzer_1_array_crystal_array_7_mask_string
#define mask_setting mccchannel_0_analyzer_1_array_crystal_array_7_mask_setting
#define number_of_activations mccchannel_0_analyzer_1_array_crystal_array_7_number_of_activations
#line 204 "Union_box.comp"
// Needed for transport to the main component
struct global_geometry_element_struct global_geometry_element;

#ifndef ANY_GEOMETRY_DETECTOR_DECLARE
    #define ANY_GEOMETRY_DETECTOR_DECLARE dummy
	//struct pointer_to_global_geometry_list global_geometry_list = {0,NULL};
#endif

int loop_index,found_geometries;

double x_component;
double y_component;
double z_component;

struct Volume_struct this_box_volume;
struct box_storage this_box_storage;

#line 34377 "MACS_sample_kidney_box.c"
#undef number_of_activations
#undef mask_setting
#undef mask_string
#undef p_interact
#undef focus_r
#undef focus_xh
#undef focus_xw
#undef focus_ah
#undef focus_aw
#undef target_z
#undef target_y
#undef target_x
#undef target_index
#undef visualize
#undef yheight2
#undef xwidth2
#undef zdepth
#undef yheight
#undef xwidth
#undef priority
#undef material_string
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

/* User declarations for component 'channel_0_analyzer_1_array_crystal_array_8' [138]. */
#define mccompcurname  channel_0_analyzer_1_array_crystal_array_8
#define mccompcurtype  Union_box
#define mccompcurindex 138
#define loop_index mccchannel_0_analyzer_1_array_crystal_array_8_loop_index
#define this_box_volume mccchannel_0_analyzer_1_array_crystal_array_8_this_box_volume
#define global_geometry_element mccchannel_0_analyzer_1_array_crystal_array_8_global_geometry_element
#define this_box_storage mccchannel_0_analyzer_1_array_crystal_array_8_this_box_storage
#define material_string mccchannel_0_analyzer_1_array_crystal_array_8_material_string
#define priority mccchannel_0_analyzer_1_array_crystal_array_8_priority
#define xwidth mccchannel_0_analyzer_1_array_crystal_array_8_xwidth
#define yheight mccchannel_0_analyzer_1_array_crystal_array_8_yheight
#define zdepth mccchannel_0_analyzer_1_array_crystal_array_8_zdepth
#define xwidth2 mccchannel_0_analyzer_1_array_crystal_array_8_xwidth2
#define yheight2 mccchannel_0_analyzer_1_array_crystal_array_8_yheight2
#define visualize mccchannel_0_analyzer_1_array_crystal_array_8_visualize
#define target_index mccchannel_0_analyzer_1_array_crystal_array_8_target_index
#define target_x mccchannel_0_analyzer_1_array_crystal_array_8_target_x
#define target_y mccchannel_0_analyzer_1_array_crystal_array_8_target_y
#define target_z mccchannel_0_analyzer_1_array_crystal_array_8_target_z
#define focus_aw mccchannel_0_analyzer_1_array_crystal_array_8_focus_aw
#define focus_ah mccchannel_0_analyzer_1_array_crystal_array_8_focus_ah
#define focus_xw mccchannel_0_analyzer_1_array_crystal_array_8_focus_xw
#define focus_xh mccchannel_0_analyzer_1_array_crystal_array_8_focus_xh
#define focus_r mccchannel_0_analyzer_1_array_crystal_array_8_focus_r
#define p_interact mccchannel_0_analyzer_1_array_crystal_array_8_p_interact
#define mask_string mccchannel_0_analyzer_1_array_crystal_array_8_mask_string
#define mask_setting mccchannel_0_analyzer_1_array_crystal_array_8_mask_setting
#define number_of_activations mccchannel_0_analyzer_1_array_crystal_array_8_number_of_activations
#line 204 "Union_box.comp"
// Needed for transport to the main component
struct global_geometry_element_struct global_geometry_element;

#ifndef ANY_GEOMETRY_DETECTOR_DECLARE
    #define ANY_GEOMETRY_DETECTOR_DECLARE dummy
	//struct pointer_to_global_geometry_list global_geometry_list = {0,NULL};
#endif

int loop_index,found_geometries;

double x_component;
double y_component;
double z_component;

struct Volume_struct this_box_volume;
struct box_storage this_box_storage;

#line 34454 "MACS_sample_kidney_box.c"
#undef number_of_activations
#undef mask_setting
#undef mask_string
#undef p_interact
#undef focus_r
#undef focus_xh
#undef focus_xw
#undef focus_ah
#undef focus_aw
#undef target_z
#undef target_y
#undef target_x
#undef target_index
#undef visualize
#undef yheight2
#undef xwidth2
#undef zdepth
#undef yheight
#undef xwidth
#undef priority
#undef material_string
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

/* User declarations for component 'channel_0_analyzer_2_center' [139]. */
#define mccompcurname  channel_0_analyzer_2_center
#define mccompcurtype  Arm
#define mccompcurindex 139
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

/* User declarations for component 'channel_0_analyzer_2_rotated' [140]. */
#define mccompcurname  channel_0_analyzer_2_rotated
#define mccompcurtype  Arm
#define mccompcurindex 140
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

/* User declarations for component 'channel_0_analyzer_2_array_crystal_array_0' [141]. */
#define mccompcurname  channel_0_analyzer_2_array_crystal_array_0
#define mccompcurtype  Union_box
#define mccompcurindex 141
#define loop_index mccchannel_0_analyzer_2_array_crystal_array_0_loop_index
#define this_box_volume mccchannel_0_analyzer_2_array_crystal_array_0_this_box_volume
#define global_geometry_element mccchannel_0_analyzer_2_array_crystal_array_0_global_geometry_element
#define this_box_storage mccchannel_0_analyzer_2_array_crystal_array_0_this_box_storage
#define material_string mccchannel_0_analyzer_2_array_crystal_array_0_material_string
#define priority mccchannel_0_analyzer_2_array_crystal_array_0_priority
#define xwidth mccchannel_0_analyzer_2_array_crystal_array_0_xwidth
#define yheight mccchannel_0_analyzer_2_array_crystal_array_0_yheight
#define zdepth mccchannel_0_analyzer_2_array_crystal_array_0_zdepth
#define xwidth2 mccchannel_0_analyzer_2_array_crystal_array_0_xwidth2
#define yheight2 mccchannel_0_analyzer_2_array_crystal_array_0_yheight2
#define visualize mccchannel_0_analyzer_2_array_crystal_array_0_visualize
#define target_index mccchannel_0_analyzer_2_array_crystal_array_0_target_index
#define target_x mccchannel_0_analyzer_2_array_crystal_array_0_target_x
#define target_y mccchannel_0_analyzer_2_array_crystal_array_0_target_y
#define target_z mccchannel_0_analyzer_2_array_crystal_array_0_target_z
#define focus_aw mccchannel_0_analyzer_2_array_crystal_array_0_focus_aw
#define focus_ah mccchannel_0_analyzer_2_array_crystal_array_0_focus_ah
#define focus_xw mccchannel_0_analyzer_2_array_crystal_array_0_focus_xw
#define focus_xh mccchannel_0_analyzer_2_array_crystal_array_0_focus_xh
#define focus_r mccchannel_0_analyzer_2_array_crystal_array_0_focus_r
#define p_interact mccchannel_0_analyzer_2_array_crystal_array_0_p_interact
#define mask_string mccchannel_0_analyzer_2_array_crystal_array_0_mask_string
#define mask_setting mccchannel_0_analyzer_2_array_crystal_array_0_mask_setting
#define number_of_activations mccchannel_0_analyzer_2_array_crystal_array_0_number_of_activations
#line 204 "Union_box.comp"
// Needed for transport to the main component
struct global_geometry_element_struct global_geometry_element;

#ifndef ANY_GEOMETRY_DETECTOR_DECLARE
    #define ANY_GEOMETRY_DETECTOR_DECLARE dummy
	//struct pointer_to_global_geometry_list global_geometry_list = {0,NULL};
#endif

int loop_index,found_geometries;

double x_component;
double y_component;
double z_component;

struct Volume_struct this_box_volume;
struct box_storage this_box_storage;

#line 34547 "MACS_sample_kidney_box.c"
#undef number_of_activations
#undef mask_setting
#undef mask_string
#undef p_interact
#undef focus_r
#undef focus_xh
#undef focus_xw
#undef focus_ah
#undef focus_aw
#undef target_z
#undef target_y
#undef target_x
#undef target_index
#undef visualize
#undef yheight2
#undef xwidth2
#undef zdepth
#undef yheight
#undef xwidth
#undef priority
#undef material_string
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

/* User declarations for component 'channel_0_analyzer_2_array_crystal_array_1' [142]. */
#define mccompcurname  channel_0_analyzer_2_array_crystal_array_1
#define mccompcurtype  Union_box
#define mccompcurindex 142
#define loop_index mccchannel_0_analyzer_2_array_crystal_array_1_loop_index
#define this_box_volume mccchannel_0_analyzer_2_array_crystal_array_1_this_box_volume
#define global_geometry_element mccchannel_0_analyzer_2_array_crystal_array_1_global_geometry_element
#define this_box_storage mccchannel_0_analyzer_2_array_crystal_array_1_this_box_storage
#define material_string mccchannel_0_analyzer_2_array_crystal_array_1_material_string
#define priority mccchannel_0_analyzer_2_array_crystal_array_1_priority
#define xwidth mccchannel_0_analyzer_2_array_crystal_array_1_xwidth
#define yheight mccchannel_0_analyzer_2_array_crystal_array_1_yheight
#define zdepth mccchannel_0_analyzer_2_array_crystal_array_1_zdepth
#define xwidth2 mccchannel_0_analyzer_2_array_crystal_array_1_xwidth2
#define yheight2 mccchannel_0_analyzer_2_array_crystal_array_1_yheight2
#define visualize mccchannel_0_analyzer_2_array_crystal_array_1_visualize
#define target_index mccchannel_0_analyzer_2_array_crystal_array_1_target_index
#define target_x mccchannel_0_analyzer_2_array_crystal_array_1_target_x
#define target_y mccchannel_0_analyzer_2_array_crystal_array_1_target_y
#define target_z mccchannel_0_analyzer_2_array_crystal_array_1_target_z
#define focus_aw mccchannel_0_analyzer_2_array_crystal_array_1_focus_aw
#define focus_ah mccchannel_0_analyzer_2_array_crystal_array_1_focus_ah
#define focus_xw mccchannel_0_analyzer_2_array_crystal_array_1_focus_xw
#define focus_xh mccchannel_0_analyzer_2_array_crystal_array_1_focus_xh
#define focus_r mccchannel_0_analyzer_2_array_crystal_array_1_focus_r
#define p_interact mccchannel_0_analyzer_2_array_crystal_array_1_p_interact
#define mask_string mccchannel_0_analyzer_2_array_crystal_array_1_mask_string
#define mask_setting mccchannel_0_analyzer_2_array_crystal_array_1_mask_setting
#define number_of_activations mccchannel_0_analyzer_2_array_crystal_array_1_number_of_activations
#line 204 "Union_box.comp"
// Needed for transport to the main component
struct global_geometry_element_struct global_geometry_element;

#ifndef ANY_GEOMETRY_DETECTOR_DECLARE
    #define ANY_GEOMETRY_DETECTOR_DECLARE dummy
	//struct pointer_to_global_geometry_list global_geometry_list = {0,NULL};
#endif

int loop_index,found_geometries;

double x_component;
double y_component;
double z_component;

struct Volume_struct this_box_volume;
struct box_storage this_box_storage;

#line 34624 "MACS_sample_kidney_box.c"
#undef number_of_activations
#undef mask_setting
#undef mask_string
#undef p_interact
#undef focus_r
#undef focus_xh
#undef focus_xw
#undef focus_ah
#undef focus_aw
#undef target_z
#undef target_y
#undef target_x
#undef target_index
#undef visualize
#undef yheight2
#undef xwidth2
#undef zdepth
#undef yheight
#undef xwidth
#undef priority
#undef material_string
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

/* User declarations for component 'channel_0_analyzer_2_array_crystal_array_2' [143]. */
#define mccompcurname  channel_0_analyzer_2_array_crystal_array_2
#define mccompcurtype  Union_box
#define mccompcurindex 143
#define loop_index mccchannel_0_analyzer_2_array_crystal_array_2_loop_index
#define this_box_volume mccchannel_0_analyzer_2_array_crystal_array_2_this_box_volume
#define global_geometry_element mccchannel_0_analyzer_2_array_crystal_array_2_global_geometry_element
#define this_box_storage mccchannel_0_analyzer_2_array_crystal_array_2_this_box_storage
#define material_string mccchannel_0_analyzer_2_array_crystal_array_2_material_string
#define priority mccchannel_0_analyzer_2_array_crystal_array_2_priority
#define xwidth mccchannel_0_analyzer_2_array_crystal_array_2_xwidth
#define yheight mccchannel_0_analyzer_2_array_crystal_array_2_yheight
#define zdepth mccchannel_0_analyzer_2_array_crystal_array_2_zdepth
#define xwidth2 mccchannel_0_analyzer_2_array_crystal_array_2_xwidth2
#define yheight2 mccchannel_0_analyzer_2_array_crystal_array_2_yheight2
#define visualize mccchannel_0_analyzer_2_array_crystal_array_2_visualize
#define target_index mccchannel_0_analyzer_2_array_crystal_array_2_target_index
#define target_x mccchannel_0_analyzer_2_array_crystal_array_2_target_x
#define target_y mccchannel_0_analyzer_2_array_crystal_array_2_target_y
#define target_z mccchannel_0_analyzer_2_array_crystal_array_2_target_z
#define focus_aw mccchannel_0_analyzer_2_array_crystal_array_2_focus_aw
#define focus_ah mccchannel_0_analyzer_2_array_crystal_array_2_focus_ah
#define focus_xw mccchannel_0_analyzer_2_array_crystal_array_2_focus_xw
#define focus_xh mccchannel_0_analyzer_2_array_crystal_array_2_focus_xh
#define focus_r mccchannel_0_analyzer_2_array_crystal_array_2_focus_r
#define p_interact mccchannel_0_analyzer_2_array_crystal_array_2_p_interact
#define mask_string mccchannel_0_analyzer_2_array_crystal_array_2_mask_string
#define mask_setting mccchannel_0_analyzer_2_array_crystal_array_2_mask_setting
#define number_of_activations mccchannel_0_analyzer_2_array_crystal_array_2_number_of_activations
#line 204 "Union_box.comp"
// Needed for transport to the main component
struct global_geometry_element_struct global_geometry_element;

#ifndef ANY_GEOMETRY_DETECTOR_DECLARE
    #define ANY_GEOMETRY_DETECTOR_DECLARE dummy
	//struct pointer_to_global_geometry_list global_geometry_list = {0,NULL};
#endif

int loop_index,found_geometries;

double x_component;
double y_component;
double z_component;

struct Volume_struct this_box_volume;
struct box_storage this_box_storage;

#line 34701 "MACS_sample_kidney_box.c"
#undef number_of_activations
#undef mask_setting
#undef mask_string
#undef p_interact
#undef focus_r
#undef focus_xh
#undef focus_xw
#undef focus_ah
#undef focus_aw
#undef target_z
#undef target_y
#undef target_x
#undef target_index
#undef visualize
#undef yheight2
#undef xwidth2
#undef zdepth
#undef yheight
#undef xwidth
#undef priority
#undef material_string
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

/* User declarations for component 'channel_0_analyzer_2_array_crystal_array_3' [144]. */
#define mccompcurname  channel_0_analyzer_2_array_crystal_array_3
#define mccompcurtype  Union_box
#define mccompcurindex 144
#define loop_index mccchannel_0_analyzer_2_array_crystal_array_3_loop_index
#define this_box_volume mccchannel_0_analyzer_2_array_crystal_array_3_this_box_volume
#define global_geometry_element mccchannel_0_analyzer_2_array_crystal_array_3_global_geometry_element
#define this_box_storage mccchannel_0_analyzer_2_array_crystal_array_3_this_box_storage
#define material_string mccchannel_0_analyzer_2_array_crystal_array_3_material_string
#define priority mccchannel_0_analyzer_2_array_crystal_array_3_priority
#define xwidth mccchannel_0_analyzer_2_array_crystal_array_3_xwidth
#define yheight mccchannel_0_analyzer_2_array_crystal_array_3_yheight
#define zdepth mccchannel_0_analyzer_2_array_crystal_array_3_zdepth
#define xwidth2 mccchannel_0_analyzer_2_array_crystal_array_3_xwidth2
#define yheight2 mccchannel_0_analyzer_2_array_crystal_array_3_yheight2
#define visualize mccchannel_0_analyzer_2_array_crystal_array_3_visualize
#define target_index mccchannel_0_analyzer_2_array_crystal_array_3_target_index
#define target_x mccchannel_0_analyzer_2_array_crystal_array_3_target_x
#define target_y mccchannel_0_analyzer_2_array_crystal_array_3_target_y
#define target_z mccchannel_0_analyzer_2_array_crystal_array_3_target_z
#define focus_aw mccchannel_0_analyzer_2_array_crystal_array_3_focus_aw
#define focus_ah mccchannel_0_analyzer_2_array_crystal_array_3_focus_ah
#define focus_xw mccchannel_0_analyzer_2_array_crystal_array_3_focus_xw
#define focus_xh mccchannel_0_analyzer_2_array_crystal_array_3_focus_xh
#define focus_r mccchannel_0_analyzer_2_array_crystal_array_3_focus_r
#define p_interact mccchannel_0_analyzer_2_array_crystal_array_3_p_interact
#define mask_string mccchannel_0_analyzer_2_array_crystal_array_3_mask_string
#define mask_setting mccchannel_0_analyzer_2_array_crystal_array_3_mask_setting
#define number_of_activations mccchannel_0_analyzer_2_array_crystal_array_3_number_of_activations
#line 204 "Union_box.comp"
// Needed for transport to the main component
struct global_geometry_element_struct global_geometry_element;

#ifndef ANY_GEOMETRY_DETECTOR_DECLARE
    #define ANY_GEOMETRY_DETECTOR_DECLARE dummy
	//struct pointer_to_global_geometry_list global_geometry_list = {0,NULL};
#endif

int loop_index,found_geometries;

double x_component;
double y_component;
double z_component;

struct Volume_struct this_box_volume;
struct box_storage this_box_storage;

#line 34778 "MACS_sample_kidney_box.c"
#undef number_of_activations
#undef mask_setting
#undef mask_string
#undef p_interact
#undef focus_r
#undef focus_xh
#undef focus_xw
#undef focus_ah
#undef focus_aw
#undef target_z
#undef target_y
#undef target_x
#undef target_index
#undef visualize
#undef yheight2
#undef xwidth2
#undef zdepth
#undef yheight
#undef xwidth
#undef priority
#undef material_string
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

/* User declarations for component 'channel_0_analyzer_2_array_crystal_array_4' [145]. */
#define mccompcurname  channel_0_analyzer_2_array_crystal_array_4
#define mccompcurtype  Union_box
#define mccompcurindex 145
#define loop_index mccchannel_0_analyzer_2_array_crystal_array_4_loop_index
#define this_box_volume mccchannel_0_analyzer_2_array_crystal_array_4_this_box_volume
#define global_geometry_element mccchannel_0_analyzer_2_array_crystal_array_4_global_geometry_element
#define this_box_storage mccchannel_0_analyzer_2_array_crystal_array_4_this_box_storage
#define material_string mccchannel_0_analyzer_2_array_crystal_array_4_material_string
#define priority mccchannel_0_analyzer_2_array_crystal_array_4_priority
#define xwidth mccchannel_0_analyzer_2_array_crystal_array_4_xwidth
#define yheight mccchannel_0_analyzer_2_array_crystal_array_4_yheight
#define zdepth mccchannel_0_analyzer_2_array_crystal_array_4_zdepth
#define xwidth2 mccchannel_0_analyzer_2_array_crystal_array_4_xwidth2
#define yheight2 mccchannel_0_analyzer_2_array_crystal_array_4_yheight2
#define visualize mccchannel_0_analyzer_2_array_crystal_array_4_visualize
#define target_index mccchannel_0_analyzer_2_array_crystal_array_4_target_index
#define target_x mccchannel_0_analyzer_2_array_crystal_array_4_target_x
#define target_y mccchannel_0_analyzer_2_array_crystal_array_4_target_y
#define target_z mccchannel_0_analyzer_2_array_crystal_array_4_target_z
#define focus_aw mccchannel_0_analyzer_2_array_crystal_array_4_focus_aw
#define focus_ah mccchannel_0_analyzer_2_array_crystal_array_4_focus_ah
#define focus_xw mccchannel_0_analyzer_2_array_crystal_array_4_focus_xw
#define focus_xh mccchannel_0_analyzer_2_array_crystal_array_4_focus_xh
#define focus_r mccchannel_0_analyzer_2_array_crystal_array_4_focus_r
#define p_interact mccchannel_0_analyzer_2_array_crystal_array_4_p_interact
#define mask_string mccchannel_0_analyzer_2_array_crystal_array_4_mask_string
#define mask_setting mccchannel_0_analyzer_2_array_crystal_array_4_mask_setting
#define number_of_activations mccchannel_0_analyzer_2_array_crystal_array_4_number_of_activations
#line 204 "Union_box.comp"
// Needed for transport to the main component
struct global_geometry_element_struct global_geometry_element;

#ifndef ANY_GEOMETRY_DETECTOR_DECLARE
    #define ANY_GEOMETRY_DETECTOR_DECLARE dummy
	//struct pointer_to_global_geometry_list global_geometry_list = {0,NULL};
#endif

int loop_index,found_geometries;

double x_component;
double y_component;
double z_component;

struct Volume_struct this_box_volume;
struct box_storage this_box_storage;

#line 34855 "MACS_sample_kidney_box.c"
#undef number_of_activations
#undef mask_setting
#undef mask_string
#undef p_interact
#undef focus_r
#undef focus_xh
#undef focus_xw
#undef focus_ah
#undef focus_aw
#undef target_z
#undef target_y
#undef target_x
#undef target_index
#undef visualize
#undef yheight2
#undef xwidth2
#undef zdepth
#undef yheight
#undef xwidth
#undef priority
#undef material_string
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

/* User declarations for component 'channel_0_analyzer_2_array_crystal_array_5' [146]. */
#define mccompcurname  channel_0_analyzer_2_array_crystal_array_5
#define mccompcurtype  Union_box
#define mccompcurindex 146
#define loop_index mccchannel_0_analyzer_2_array_crystal_array_5_loop_index
#define this_box_volume mccchannel_0_analyzer_2_array_crystal_array_5_this_box_volume
#define global_geometry_element mccchannel_0_analyzer_2_array_crystal_array_5_global_geometry_element
#define this_box_storage mccchannel_0_analyzer_2_array_crystal_array_5_this_box_storage
#define material_string mccchannel_0_analyzer_2_array_crystal_array_5_material_string
#define priority mccchannel_0_analyzer_2_array_crystal_array_5_priority
#define xwidth mccchannel_0_analyzer_2_array_crystal_array_5_xwidth
#define yheight mccchannel_0_analyzer_2_array_crystal_array_5_yheight
#define zdepth mccchannel_0_analyzer_2_array_crystal_array_5_zdepth
#define xwidth2 mccchannel_0_analyzer_2_array_crystal_array_5_xwidth2
#define yheight2 mccchannel_0_analyzer_2_array_crystal_array_5_yheight2
#define visualize mccchannel_0_analyzer_2_array_crystal_array_5_visualize
#define target_index mccchannel_0_analyzer_2_array_crystal_array_5_target_index
#define target_x mccchannel_0_analyzer_2_array_crystal_array_5_target_x
#define target_y mccchannel_0_analyzer_2_array_crystal_array_5_target_y
#define target_z mccchannel_0_analyzer_2_array_crystal_array_5_target_z
#define focus_aw mccchannel_0_analyzer_2_array_crystal_array_5_focus_aw
#define focus_ah mccchannel_0_analyzer_2_array_crystal_array_5_focus_ah
#define focus_xw mccchannel_0_analyzer_2_array_crystal_array_5_focus_xw
#define focus_xh mccchannel_0_analyzer_2_array_crystal_array_5_focus_xh
#define focus_r mccchannel_0_analyzer_2_array_crystal_array_5_focus_r
#define p_interact mccchannel_0_analyzer_2_array_crystal_array_5_p_interact
#define mask_string mccchannel_0_analyzer_2_array_crystal_array_5_mask_string
#define mask_setting mccchannel_0_analyzer_2_array_crystal_array_5_mask_setting
#define number_of_activations mccchannel_0_analyzer_2_array_crystal_array_5_number_of_activations
#line 204 "Union_box.comp"
// Needed for transport to the main component
struct global_geometry_element_struct global_geometry_element;

#ifndef ANY_GEOMETRY_DETECTOR_DECLARE
    #define ANY_GEOMETRY_DETECTOR_DECLARE dummy
	//struct pointer_to_global_geometry_list global_geometry_list = {0,NULL};
#endif

int loop_index,found_geometries;

double x_component;
double y_component;
double z_component;

struct Volume_struct this_box_volume;
struct box_storage this_box_storage;

#line 34932 "MACS_sample_kidney_box.c"
#undef number_of_activations
#undef mask_setting
#undef mask_string
#undef p_interact
#undef focus_r
#undef focus_xh
#undef focus_xw
#undef focus_ah
#undef focus_aw
#undef target_z
#undef target_y
#undef target_x
#undef target_index
#undef visualize
#undef yheight2
#undef xwidth2
#undef zdepth
#undef yheight
#undef xwidth
#undef priority
#undef material_string
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

/* User declarations for component 'channel_0_analyzer_2_array_crystal_array_6' [147]. */
#define mccompcurname  channel_0_analyzer_2_array_crystal_array_6
#define mccompcurtype  Union_box
#define mccompcurindex 147
#define loop_index mccchannel_0_analyzer_2_array_crystal_array_6_loop_index
#define this_box_volume mccchannel_0_analyzer_2_array_crystal_array_6_this_box_volume
#define global_geometry_element mccchannel_0_analyzer_2_array_crystal_array_6_global_geometry_element
#define this_box_storage mccchannel_0_analyzer_2_array_crystal_array_6_this_box_storage
#define material_string mccchannel_0_analyzer_2_array_crystal_array_6_material_string
#define priority mccchannel_0_analyzer_2_array_crystal_array_6_priority
#define xwidth mccchannel_0_analyzer_2_array_crystal_array_6_xwidth
#define yheight mccchannel_0_analyzer_2_array_crystal_array_6_yheight
#define zdepth mccchannel_0_analyzer_2_array_crystal_array_6_zdepth
#define xwidth2 mccchannel_0_analyzer_2_array_crystal_array_6_xwidth2
#define yheight2 mccchannel_0_analyzer_2_array_crystal_array_6_yheight2
#define visualize mccchannel_0_analyzer_2_array_crystal_array_6_visualize
#define target_index mccchannel_0_analyzer_2_array_crystal_array_6_target_index
#define target_x mccchannel_0_analyzer_2_array_crystal_array_6_target_x
#define target_y mccchannel_0_analyzer_2_array_crystal_array_6_target_y
#define target_z mccchannel_0_analyzer_2_array_crystal_array_6_target_z
#define focus_aw mccchannel_0_analyzer_2_array_crystal_array_6_focus_aw
#define focus_ah mccchannel_0_analyzer_2_array_crystal_array_6_focus_ah
#define focus_xw mccchannel_0_analyzer_2_array_crystal_array_6_focus_xw
#define focus_xh mccchannel_0_analyzer_2_array_crystal_array_6_focus_xh
#define focus_r mccchannel_0_analyzer_2_array_crystal_array_6_focus_r
#define p_interact mccchannel_0_analyzer_2_array_crystal_array_6_p_interact
#define mask_string mccchannel_0_analyzer_2_array_crystal_array_6_mask_string
#define mask_setting mccchannel_0_analyzer_2_array_crystal_array_6_mask_setting
#define number_of_activations mccchannel_0_analyzer_2_array_crystal_array_6_number_of_activations
#line 204 "Union_box.comp"
// Needed for transport to the main component
struct global_geometry_element_struct global_geometry_element;

#ifndef ANY_GEOMETRY_DETECTOR_DECLARE
    #define ANY_GEOMETRY_DETECTOR_DECLARE dummy
	//struct pointer_to_global_geometry_list global_geometry_list = {0,NULL};
#endif

int loop_index,found_geometries;

double x_component;
double y_component;
double z_component;

struct Volume_struct this_box_volume;
struct box_storage this_box_storage;

#line 35009 "MACS_sample_kidney_box.c"
#undef number_of_activations
#undef mask_setting
#undef mask_string
#undef p_interact
#undef focus_r
#undef focus_xh
#undef focus_xw
#undef focus_ah
#undef focus_aw
#undef target_z
#undef target_y
#undef target_x
#undef target_index
#undef visualize
#undef yheight2
#undef xwidth2
#undef zdepth
#undef yheight
#undef xwidth
#undef priority
#undef material_string
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

/* User declarations for component 'channel_0_analyzer_2_array_crystal_array_7' [148]. */
#define mccompcurname  channel_0_analyzer_2_array_crystal_array_7
#define mccompcurtype  Union_box
#define mccompcurindex 148
#define loop_index mccchannel_0_analyzer_2_array_crystal_array_7_loop_index
#define this_box_volume mccchannel_0_analyzer_2_array_crystal_array_7_this_box_volume
#define global_geometry_element mccchannel_0_analyzer_2_array_crystal_array_7_global_geometry_element
#define this_box_storage mccchannel_0_analyzer_2_array_crystal_array_7_this_box_storage
#define material_string mccchannel_0_analyzer_2_array_crystal_array_7_material_string
#define priority mccchannel_0_analyzer_2_array_crystal_array_7_priority
#define xwidth mccchannel_0_analyzer_2_array_crystal_array_7_xwidth
#define yheight mccchannel_0_analyzer_2_array_crystal_array_7_yheight
#define zdepth mccchannel_0_analyzer_2_array_crystal_array_7_zdepth
#define xwidth2 mccchannel_0_analyzer_2_array_crystal_array_7_xwidth2
#define yheight2 mccchannel_0_analyzer_2_array_crystal_array_7_yheight2
#define visualize mccchannel_0_analyzer_2_array_crystal_array_7_visualize
#define target_index mccchannel_0_analyzer_2_array_crystal_array_7_target_index
#define target_x mccchannel_0_analyzer_2_array_crystal_array_7_target_x
#define target_y mccchannel_0_analyzer_2_array_crystal_array_7_target_y
#define target_z mccchannel_0_analyzer_2_array_crystal_array_7_target_z
#define focus_aw mccchannel_0_analyzer_2_array_crystal_array_7_focus_aw
#define focus_ah mccchannel_0_analyzer_2_array_crystal_array_7_focus_ah
#define focus_xw mccchannel_0_analyzer_2_array_crystal_array_7_focus_xw
#define focus_xh mccchannel_0_analyzer_2_array_crystal_array_7_focus_xh
#define focus_r mccchannel_0_analyzer_2_array_crystal_array_7_focus_r
#define p_interact mccchannel_0_analyzer_2_array_crystal_array_7_p_interact
#define mask_string mccchannel_0_analyzer_2_array_crystal_array_7_mask_string
#define mask_setting mccchannel_0_analyzer_2_array_crystal_array_7_mask_setting
#define number_of_activations mccchannel_0_analyzer_2_array_crystal_array_7_number_of_activations
#line 204 "Union_box.comp"
// Needed for transport to the main component
struct global_geometry_element_struct global_geometry_element;

#ifndef ANY_GEOMETRY_DETECTOR_DECLARE
    #define ANY_GEOMETRY_DETECTOR_DECLARE dummy
	//struct pointer_to_global_geometry_list global_geometry_list = {0,NULL};
#endif

int loop_index,found_geometries;

double x_component;
double y_component;
double z_component;

struct Volume_struct this_box_volume;
struct box_storage this_box_storage;

#line 35086 "MACS_sample_kidney_box.c"
#undef number_of_activations
#undef mask_setting
#undef mask_string
#undef p_interact
#undef focus_r
#undef focus_xh
#undef focus_xw
#undef focus_ah
#undef focus_aw
#undef target_z
#undef target_y
#undef target_x
#undef target_index
#undef visualize
#undef yheight2
#undef xwidth2
#undef zdepth
#undef yheight
#undef xwidth
#undef priority
#undef material_string
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

/* User declarations for component 'channel_0_analyzer_2_array_crystal_array_8' [149]. */
#define mccompcurname  channel_0_analyzer_2_array_crystal_array_8
#define mccompcurtype  Union_box
#define mccompcurindex 149
#define loop_index mccchannel_0_analyzer_2_array_crystal_array_8_loop_index
#define this_box_volume mccchannel_0_analyzer_2_array_crystal_array_8_this_box_volume
#define global_geometry_element mccchannel_0_analyzer_2_array_crystal_array_8_global_geometry_element
#define this_box_storage mccchannel_0_analyzer_2_array_crystal_array_8_this_box_storage
#define material_string mccchannel_0_analyzer_2_array_crystal_array_8_material_string
#define priority mccchannel_0_analyzer_2_array_crystal_array_8_priority
#define xwidth mccchannel_0_analyzer_2_array_crystal_array_8_xwidth
#define yheight mccchannel_0_analyzer_2_array_crystal_array_8_yheight
#define zdepth mccchannel_0_analyzer_2_array_crystal_array_8_zdepth
#define xwidth2 mccchannel_0_analyzer_2_array_crystal_array_8_xwidth2
#define yheight2 mccchannel_0_analyzer_2_array_crystal_array_8_yheight2
#define visualize mccchannel_0_analyzer_2_array_crystal_array_8_visualize
#define target_index mccchannel_0_analyzer_2_array_crystal_array_8_target_index
#define target_x mccchannel_0_analyzer_2_array_crystal_array_8_target_x
#define target_y mccchannel_0_analyzer_2_array_crystal_array_8_target_y
#define target_z mccchannel_0_analyzer_2_array_crystal_array_8_target_z
#define focus_aw mccchannel_0_analyzer_2_array_crystal_array_8_focus_aw
#define focus_ah mccchannel_0_analyzer_2_array_crystal_array_8_focus_ah
#define focus_xw mccchannel_0_analyzer_2_array_crystal_array_8_focus_xw
#define focus_xh mccchannel_0_analyzer_2_array_crystal_array_8_focus_xh
#define focus_r mccchannel_0_analyzer_2_array_crystal_array_8_focus_r
#define p_interact mccchannel_0_analyzer_2_array_crystal_array_8_p_interact
#define mask_string mccchannel_0_analyzer_2_array_crystal_array_8_mask_string
#define mask_setting mccchannel_0_analyzer_2_array_crystal_array_8_mask_setting
#define number_of_activations mccchannel_0_analyzer_2_array_crystal_array_8_number_of_activations
#line 204 "Union_box.comp"
// Needed for transport to the main component
struct global_geometry_element_struct global_geometry_element;

#ifndef ANY_GEOMETRY_DETECTOR_DECLARE
    #define ANY_GEOMETRY_DETECTOR_DECLARE dummy
	//struct pointer_to_global_geometry_list global_geometry_list = {0,NULL};
#endif

int loop_index,found_geometries;

double x_component;
double y_component;
double z_component;

struct Volume_struct this_box_volume;
struct box_storage this_box_storage;

#line 35163 "MACS_sample_kidney_box.c"
#undef number_of_activations
#undef mask_setting
#undef mask_string
#undef p_interact
#undef focus_r
#undef focus_xh
#undef focus_xw
#undef focus_ah
#undef focus_aw
#undef target_z
#undef target_y
#undef target_x
#undef target_index
#undef visualize
#undef yheight2
#undef xwidth2
#undef zdepth
#undef yheight
#undef xwidth
#undef priority
#undef material_string
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

/* User declarations for component 'channel_0_cave2_cyl1' [150]. */
#define mccompcurname  channel_0_cave2_cyl1
#define mccompcurtype  Union_cylinder
#define mccompcurindex 150
#define loop_index mccchannel_0_cave2_cyl1_loop_index
#define this_cylinder_volume mccchannel_0_cave2_cyl1_this_cylinder_volume
#define global_geometry_element mccchannel_0_cave2_cyl1_global_geometry_element
#define this_cylinder_storage mccchannel_0_cave2_cyl1_this_cylinder_storage
#define material_string mccchannel_0_cave2_cyl1_material_string
#define priority mccchannel_0_cave2_cyl1_priority
#define radius mccchannel_0_cave2_cyl1_radius
#define yheight mccchannel_0_cave2_cyl1_yheight
#define visualize mccchannel_0_cave2_cyl1_visualize
#define target_index mccchannel_0_cave2_cyl1_target_index
#define target_x mccchannel_0_cave2_cyl1_target_x
#define target_y mccchannel_0_cave2_cyl1_target_y
#define target_z mccchannel_0_cave2_cyl1_target_z
#define focus_aw mccchannel_0_cave2_cyl1_focus_aw
#define focus_ah mccchannel_0_cave2_cyl1_focus_ah
#define focus_xw mccchannel_0_cave2_cyl1_focus_xw
#define focus_xh mccchannel_0_cave2_cyl1_focus_xh
#define focus_r mccchannel_0_cave2_cyl1_focus_r
#define p_interact mccchannel_0_cave2_cyl1_p_interact
#define mask_string mccchannel_0_cave2_cyl1_mask_string
#define mask_setting mccchannel_0_cave2_cyl1_mask_setting
#define number_of_activations mccchannel_0_cave2_cyl1_number_of_activations
#line 167 "Union_cylinder.comp"
// Needed for transport to the main component
struct global_geometry_element_struct global_geometry_element;

#ifndef ANY_GEOMETRY_DETECTOR_DECLARE
    #define ANY_GEOMETRY_DETECTOR_DECLARE dummy
	//struct pointer_to_global_geometry_list global_geometry_list = {0,NULL};
#endif

int dummy;
int loop_index,found_geometries;
int loop_2_index;
int material_index;

struct Volume_struct this_cylinder_volume;
struct cylinder_storage this_cylinder_storage;
#line 35235 "MACS_sample_kidney_box.c"
#undef number_of_activations
#undef mask_setting
#undef mask_string
#undef p_interact
#undef focus_r
#undef focus_xh
#undef focus_xw
#undef focus_ah
#undef focus_aw
#undef target_z
#undef target_y
#undef target_x
#undef target_index
#undef visualize
#undef yheight
#undef radius
#undef priority
#undef material_string
#undef this_cylinder_storage
#undef global_geometry_element
#undef this_cylinder_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

/* User declarations for component 'channel_0_cave2_box1' [151]. */
#define mccompcurname  channel_0_cave2_box1
#define mccompcurtype  Union_box
#define mccompcurindex 151
#define loop_index mccchannel_0_cave2_box1_loop_index
#define this_box_volume mccchannel_0_cave2_box1_this_box_volume
#define global_geometry_element mccchannel_0_cave2_box1_global_geometry_element
#define this_box_storage mccchannel_0_cave2_box1_this_box_storage
#define material_string mccchannel_0_cave2_box1_material_string
#define priority mccchannel_0_cave2_box1_priority
#define xwidth mccchannel_0_cave2_box1_xwidth
#define yheight mccchannel_0_cave2_box1_yheight
#define zdepth mccchannel_0_cave2_box1_zdepth
#define xwidth2 mccchannel_0_cave2_box1_xwidth2
#define yheight2 mccchannel_0_cave2_box1_yheight2
#define visualize mccchannel_0_cave2_box1_visualize
#define target_index mccchannel_0_cave2_box1_target_index
#define target_x mccchannel_0_cave2_box1_target_x
#define target_y mccchannel_0_cave2_box1_target_y
#define target_z mccchannel_0_cave2_box1_target_z
#define focus_aw mccchannel_0_cave2_box1_focus_aw
#define focus_ah mccchannel_0_cave2_box1_focus_ah
#define focus_xw mccchannel_0_cave2_box1_focus_xw
#define focus_xh mccchannel_0_cave2_box1_focus_xh
#define focus_r mccchannel_0_cave2_box1_focus_r
#define p_interact mccchannel_0_cave2_box1_p_interact
#define mask_string mccchannel_0_cave2_box1_mask_string
#define mask_setting mccchannel_0_cave2_box1_mask_setting
#define number_of_activations mccchannel_0_cave2_box1_number_of_activations
#line 204 "Union_box.comp"
// Needed for transport to the main component
struct global_geometry_element_struct global_geometry_element;

#ifndef ANY_GEOMETRY_DETECTOR_DECLARE
    #define ANY_GEOMETRY_DETECTOR_DECLARE dummy
	//struct pointer_to_global_geometry_list global_geometry_list = {0,NULL};
#endif

int loop_index,found_geometries;

double x_component;
double y_component;
double z_component;

struct Volume_struct this_box_volume;
struct box_storage this_box_storage;

#line 35309 "MACS_sample_kidney_box.c"
#undef number_of_activations
#undef mask_setting
#undef mask_string
#undef p_interact
#undef focus_r
#undef focus_xh
#undef focus_xw
#undef focus_ah
#undef focus_aw
#undef target_z
#undef target_y
#undef target_x
#undef target_index
#undef visualize
#undef yheight2
#undef xwidth2
#undef zdepth
#undef yheight
#undef xwidth
#undef priority
#undef material_string
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

/* User declarations for component 'channel_0_cave2_box2' [152]. */
#define mccompcurname  channel_0_cave2_box2
#define mccompcurtype  Union_box
#define mccompcurindex 152
#define loop_index mccchannel_0_cave2_box2_loop_index
#define this_box_volume mccchannel_0_cave2_box2_this_box_volume
#define global_geometry_element mccchannel_0_cave2_box2_global_geometry_element
#define this_box_storage mccchannel_0_cave2_box2_this_box_storage
#define material_string mccchannel_0_cave2_box2_material_string
#define priority mccchannel_0_cave2_box2_priority
#define xwidth mccchannel_0_cave2_box2_xwidth
#define yheight mccchannel_0_cave2_box2_yheight
#define zdepth mccchannel_0_cave2_box2_zdepth
#define xwidth2 mccchannel_0_cave2_box2_xwidth2
#define yheight2 mccchannel_0_cave2_box2_yheight2
#define visualize mccchannel_0_cave2_box2_visualize
#define target_index mccchannel_0_cave2_box2_target_index
#define target_x mccchannel_0_cave2_box2_target_x
#define target_y mccchannel_0_cave2_box2_target_y
#define target_z mccchannel_0_cave2_box2_target_z
#define focus_aw mccchannel_0_cave2_box2_focus_aw
#define focus_ah mccchannel_0_cave2_box2_focus_ah
#define focus_xw mccchannel_0_cave2_box2_focus_xw
#define focus_xh mccchannel_0_cave2_box2_focus_xh
#define focus_r mccchannel_0_cave2_box2_focus_r
#define p_interact mccchannel_0_cave2_box2_p_interact
#define mask_string mccchannel_0_cave2_box2_mask_string
#define mask_setting mccchannel_0_cave2_box2_mask_setting
#define number_of_activations mccchannel_0_cave2_box2_number_of_activations
#line 204 "Union_box.comp"
// Needed for transport to the main component
struct global_geometry_element_struct global_geometry_element;

#ifndef ANY_GEOMETRY_DETECTOR_DECLARE
    #define ANY_GEOMETRY_DETECTOR_DECLARE dummy
	//struct pointer_to_global_geometry_list global_geometry_list = {0,NULL};
#endif

int loop_index,found_geometries;

double x_component;
double y_component;
double z_component;

struct Volume_struct this_box_volume;
struct box_storage this_box_storage;

#line 35386 "MACS_sample_kidney_box.c"
#undef number_of_activations
#undef mask_setting
#undef mask_string
#undef p_interact
#undef focus_r
#undef focus_xh
#undef focus_xw
#undef focus_ah
#undef focus_aw
#undef target_z
#undef target_y
#undef target_x
#undef target_index
#undef visualize
#undef yheight2
#undef xwidth2
#undef zdepth
#undef yheight
#undef xwidth
#undef priority
#undef material_string
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

/* User declarations for component 'channel_0_cave2_box3' [153]. */
#define mccompcurname  channel_0_cave2_box3
#define mccompcurtype  Union_box
#define mccompcurindex 153
#define loop_index mccchannel_0_cave2_box3_loop_index
#define this_box_volume mccchannel_0_cave2_box3_this_box_volume
#define global_geometry_element mccchannel_0_cave2_box3_global_geometry_element
#define this_box_storage mccchannel_0_cave2_box3_this_box_storage
#define material_string mccchannel_0_cave2_box3_material_string
#define priority mccchannel_0_cave2_box3_priority
#define xwidth mccchannel_0_cave2_box3_xwidth
#define yheight mccchannel_0_cave2_box3_yheight
#define zdepth mccchannel_0_cave2_box3_zdepth
#define xwidth2 mccchannel_0_cave2_box3_xwidth2
#define yheight2 mccchannel_0_cave2_box3_yheight2
#define visualize mccchannel_0_cave2_box3_visualize
#define target_index mccchannel_0_cave2_box3_target_index
#define target_x mccchannel_0_cave2_box3_target_x
#define target_y mccchannel_0_cave2_box3_target_y
#define target_z mccchannel_0_cave2_box3_target_z
#define focus_aw mccchannel_0_cave2_box3_focus_aw
#define focus_ah mccchannel_0_cave2_box3_focus_ah
#define focus_xw mccchannel_0_cave2_box3_focus_xw
#define focus_xh mccchannel_0_cave2_box3_focus_xh
#define focus_r mccchannel_0_cave2_box3_focus_r
#define p_interact mccchannel_0_cave2_box3_p_interact
#define mask_string mccchannel_0_cave2_box3_mask_string
#define mask_setting mccchannel_0_cave2_box3_mask_setting
#define number_of_activations mccchannel_0_cave2_box3_number_of_activations
#line 204 "Union_box.comp"
// Needed for transport to the main component
struct global_geometry_element_struct global_geometry_element;

#ifndef ANY_GEOMETRY_DETECTOR_DECLARE
    #define ANY_GEOMETRY_DETECTOR_DECLARE dummy
	//struct pointer_to_global_geometry_list global_geometry_list = {0,NULL};
#endif

int loop_index,found_geometries;

double x_component;
double y_component;
double z_component;

struct Volume_struct this_box_volume;
struct box_storage this_box_storage;

#line 35463 "MACS_sample_kidney_box.c"
#undef number_of_activations
#undef mask_setting
#undef mask_string
#undef p_interact
#undef focus_r
#undef focus_xh
#undef focus_xw
#undef focus_ah
#undef focus_aw
#undef target_z
#undef target_y
#undef target_x
#undef target_index
#undef visualize
#undef yheight2
#undef xwidth2
#undef zdepth
#undef yheight
#undef xwidth
#undef priority
#undef material_string
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

/* User declarations for component 'inter_analyzer_colimator_center_0' [154]. */
#define mccompcurname  inter_analyzer_colimator_center_0
#define mccompcurtype  Arm
#define mccompcurindex 154
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

/* User declarations for component 'inter_analyzer_colimator_0_blade_0' [155]. */
#define mccompcurname  inter_analyzer_colimator_0_blade_0
#define mccompcurtype  Union_box
#define mccompcurindex 155
#define loop_index mccinter_analyzer_colimator_0_blade_0_loop_index
#define this_box_volume mccinter_analyzer_colimator_0_blade_0_this_box_volume
#define global_geometry_element mccinter_analyzer_colimator_0_blade_0_global_geometry_element
#define this_box_storage mccinter_analyzer_colimator_0_blade_0_this_box_storage
#define material_string mccinter_analyzer_colimator_0_blade_0_material_string
#define priority mccinter_analyzer_colimator_0_blade_0_priority
#define xwidth mccinter_analyzer_colimator_0_blade_0_xwidth
#define yheight mccinter_analyzer_colimator_0_blade_0_yheight
#define zdepth mccinter_analyzer_colimator_0_blade_0_zdepth
#define xwidth2 mccinter_analyzer_colimator_0_blade_0_xwidth2
#define yheight2 mccinter_analyzer_colimator_0_blade_0_yheight2
#define visualize mccinter_analyzer_colimator_0_blade_0_visualize
#define target_index mccinter_analyzer_colimator_0_blade_0_target_index
#define target_x mccinter_analyzer_colimator_0_blade_0_target_x
#define target_y mccinter_analyzer_colimator_0_blade_0_target_y
#define target_z mccinter_analyzer_colimator_0_blade_0_target_z
#define focus_aw mccinter_analyzer_colimator_0_blade_0_focus_aw
#define focus_ah mccinter_analyzer_colimator_0_blade_0_focus_ah
#define focus_xw mccinter_analyzer_colimator_0_blade_0_focus_xw
#define focus_xh mccinter_analyzer_colimator_0_blade_0_focus_xh
#define focus_r mccinter_analyzer_colimator_0_blade_0_focus_r
#define p_interact mccinter_analyzer_colimator_0_blade_0_p_interact
#define mask_string mccinter_analyzer_colimator_0_blade_0_mask_string
#define mask_setting mccinter_analyzer_colimator_0_blade_0_mask_setting
#define number_of_activations mccinter_analyzer_colimator_0_blade_0_number_of_activations
#line 204 "Union_box.comp"
// Needed for transport to the main component
struct global_geometry_element_struct global_geometry_element;

#ifndef ANY_GEOMETRY_DETECTOR_DECLARE
    #define ANY_GEOMETRY_DETECTOR_DECLARE dummy
	//struct pointer_to_global_geometry_list global_geometry_list = {0,NULL};
#endif

int loop_index,found_geometries;

double x_component;
double y_component;
double z_component;

struct Volume_struct this_box_volume;
struct box_storage this_box_storage;

#line 35548 "MACS_sample_kidney_box.c"
#undef number_of_activations
#undef mask_setting
#undef mask_string
#undef p_interact
#undef focus_r
#undef focus_xh
#undef focus_xw
#undef focus_ah
#undef focus_aw
#undef target_z
#undef target_y
#undef target_x
#undef target_index
#undef visualize
#undef yheight2
#undef xwidth2
#undef zdepth
#undef yheight
#undef xwidth
#undef priority
#undef material_string
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

/* User declarations for component 'inter_analyzer_colimator_0_blade_1' [156]. */
#define mccompcurname  inter_analyzer_colimator_0_blade_1
#define mccompcurtype  Union_box
#define mccompcurindex 156
#define loop_index mccinter_analyzer_colimator_0_blade_1_loop_index
#define this_box_volume mccinter_analyzer_colimator_0_blade_1_this_box_volume
#define global_geometry_element mccinter_analyzer_colimator_0_blade_1_global_geometry_element
#define this_box_storage mccinter_analyzer_colimator_0_blade_1_this_box_storage
#define material_string mccinter_analyzer_colimator_0_blade_1_material_string
#define priority mccinter_analyzer_colimator_0_blade_1_priority
#define xwidth mccinter_analyzer_colimator_0_blade_1_xwidth
#define yheight mccinter_analyzer_colimator_0_blade_1_yheight
#define zdepth mccinter_analyzer_colimator_0_blade_1_zdepth
#define xwidth2 mccinter_analyzer_colimator_0_blade_1_xwidth2
#define yheight2 mccinter_analyzer_colimator_0_blade_1_yheight2
#define visualize mccinter_analyzer_colimator_0_blade_1_visualize
#define target_index mccinter_analyzer_colimator_0_blade_1_target_index
#define target_x mccinter_analyzer_colimator_0_blade_1_target_x
#define target_y mccinter_analyzer_colimator_0_blade_1_target_y
#define target_z mccinter_analyzer_colimator_0_blade_1_target_z
#define focus_aw mccinter_analyzer_colimator_0_blade_1_focus_aw
#define focus_ah mccinter_analyzer_colimator_0_blade_1_focus_ah
#define focus_xw mccinter_analyzer_colimator_0_blade_1_focus_xw
#define focus_xh mccinter_analyzer_colimator_0_blade_1_focus_xh
#define focus_r mccinter_analyzer_colimator_0_blade_1_focus_r
#define p_interact mccinter_analyzer_colimator_0_blade_1_p_interact
#define mask_string mccinter_analyzer_colimator_0_blade_1_mask_string
#define mask_setting mccinter_analyzer_colimator_0_blade_1_mask_setting
#define number_of_activations mccinter_analyzer_colimator_0_blade_1_number_of_activations
#line 204 "Union_box.comp"
// Needed for transport to the main component
struct global_geometry_element_struct global_geometry_element;

#ifndef ANY_GEOMETRY_DETECTOR_DECLARE
    #define ANY_GEOMETRY_DETECTOR_DECLARE dummy
	//struct pointer_to_global_geometry_list global_geometry_list = {0,NULL};
#endif

int loop_index,found_geometries;

double x_component;
double y_component;
double z_component;

struct Volume_struct this_box_volume;
struct box_storage this_box_storage;

#line 35625 "MACS_sample_kidney_box.c"
#undef number_of_activations
#undef mask_setting
#undef mask_string
#undef p_interact
#undef focus_r
#undef focus_xh
#undef focus_xw
#undef focus_ah
#undef focus_aw
#undef target_z
#undef target_y
#undef target_x
#undef target_index
#undef visualize
#undef yheight2
#undef xwidth2
#undef zdepth
#undef yheight
#undef xwidth
#undef priority
#undef material_string
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

/* User declarations for component 'inter_analyzer_colimator_0_blade_2' [157]. */
#define mccompcurname  inter_analyzer_colimator_0_blade_2
#define mccompcurtype  Union_box
#define mccompcurindex 157
#define loop_index mccinter_analyzer_colimator_0_blade_2_loop_index
#define this_box_volume mccinter_analyzer_colimator_0_blade_2_this_box_volume
#define global_geometry_element mccinter_analyzer_colimator_0_blade_2_global_geometry_element
#define this_box_storage mccinter_analyzer_colimator_0_blade_2_this_box_storage
#define material_string mccinter_analyzer_colimator_0_blade_2_material_string
#define priority mccinter_analyzer_colimator_0_blade_2_priority
#define xwidth mccinter_analyzer_colimator_0_blade_2_xwidth
#define yheight mccinter_analyzer_colimator_0_blade_2_yheight
#define zdepth mccinter_analyzer_colimator_0_blade_2_zdepth
#define xwidth2 mccinter_analyzer_colimator_0_blade_2_xwidth2
#define yheight2 mccinter_analyzer_colimator_0_blade_2_yheight2
#define visualize mccinter_analyzer_colimator_0_blade_2_visualize
#define target_index mccinter_analyzer_colimator_0_blade_2_target_index
#define target_x mccinter_analyzer_colimator_0_blade_2_target_x
#define target_y mccinter_analyzer_colimator_0_blade_2_target_y
#define target_z mccinter_analyzer_colimator_0_blade_2_target_z
#define focus_aw mccinter_analyzer_colimator_0_blade_2_focus_aw
#define focus_ah mccinter_analyzer_colimator_0_blade_2_focus_ah
#define focus_xw mccinter_analyzer_colimator_0_blade_2_focus_xw
#define focus_xh mccinter_analyzer_colimator_0_blade_2_focus_xh
#define focus_r mccinter_analyzer_colimator_0_blade_2_focus_r
#define p_interact mccinter_analyzer_colimator_0_blade_2_p_interact
#define mask_string mccinter_analyzer_colimator_0_blade_2_mask_string
#define mask_setting mccinter_analyzer_colimator_0_blade_2_mask_setting
#define number_of_activations mccinter_analyzer_colimator_0_blade_2_number_of_activations
#line 204 "Union_box.comp"
// Needed for transport to the main component
struct global_geometry_element_struct global_geometry_element;

#ifndef ANY_GEOMETRY_DETECTOR_DECLARE
    #define ANY_GEOMETRY_DETECTOR_DECLARE dummy
	//struct pointer_to_global_geometry_list global_geometry_list = {0,NULL};
#endif

int loop_index,found_geometries;

double x_component;
double y_component;
double z_component;

struct Volume_struct this_box_volume;
struct box_storage this_box_storage;

#line 35702 "MACS_sample_kidney_box.c"
#undef number_of_activations
#undef mask_setting
#undef mask_string
#undef p_interact
#undef focus_r
#undef focus_xh
#undef focus_xw
#undef focus_ah
#undef focus_aw
#undef target_z
#undef target_y
#undef target_x
#undef target_index
#undef visualize
#undef yheight2
#undef xwidth2
#undef zdepth
#undef yheight
#undef xwidth
#undef priority
#undef material_string
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

/* User declarations for component 'inter_analyzer_colimator_0_blade_3' [158]. */
#define mccompcurname  inter_analyzer_colimator_0_blade_3
#define mccompcurtype  Union_box
#define mccompcurindex 158
#define loop_index mccinter_analyzer_colimator_0_blade_3_loop_index
#define this_box_volume mccinter_analyzer_colimator_0_blade_3_this_box_volume
#define global_geometry_element mccinter_analyzer_colimator_0_blade_3_global_geometry_element
#define this_box_storage mccinter_analyzer_colimator_0_blade_3_this_box_storage
#define material_string mccinter_analyzer_colimator_0_blade_3_material_string
#define priority mccinter_analyzer_colimator_0_blade_3_priority
#define xwidth mccinter_analyzer_colimator_0_blade_3_xwidth
#define yheight mccinter_analyzer_colimator_0_blade_3_yheight
#define zdepth mccinter_analyzer_colimator_0_blade_3_zdepth
#define xwidth2 mccinter_analyzer_colimator_0_blade_3_xwidth2
#define yheight2 mccinter_analyzer_colimator_0_blade_3_yheight2
#define visualize mccinter_analyzer_colimator_0_blade_3_visualize
#define target_index mccinter_analyzer_colimator_0_blade_3_target_index
#define target_x mccinter_analyzer_colimator_0_blade_3_target_x
#define target_y mccinter_analyzer_colimator_0_blade_3_target_y
#define target_z mccinter_analyzer_colimator_0_blade_3_target_z
#define focus_aw mccinter_analyzer_colimator_0_blade_3_focus_aw
#define focus_ah mccinter_analyzer_colimator_0_blade_3_focus_ah
#define focus_xw mccinter_analyzer_colimator_0_blade_3_focus_xw
#define focus_xh mccinter_analyzer_colimator_0_blade_3_focus_xh
#define focus_r mccinter_analyzer_colimator_0_blade_3_focus_r
#define p_interact mccinter_analyzer_colimator_0_blade_3_p_interact
#define mask_string mccinter_analyzer_colimator_0_blade_3_mask_string
#define mask_setting mccinter_analyzer_colimator_0_blade_3_mask_setting
#define number_of_activations mccinter_analyzer_colimator_0_blade_3_number_of_activations
#line 204 "Union_box.comp"
// Needed for transport to the main component
struct global_geometry_element_struct global_geometry_element;

#ifndef ANY_GEOMETRY_DETECTOR_DECLARE
    #define ANY_GEOMETRY_DETECTOR_DECLARE dummy
	//struct pointer_to_global_geometry_list global_geometry_list = {0,NULL};
#endif

int loop_index,found_geometries;

double x_component;
double y_component;
double z_component;

struct Volume_struct this_box_volume;
struct box_storage this_box_storage;

#line 35779 "MACS_sample_kidney_box.c"
#undef number_of_activations
#undef mask_setting
#undef mask_string
#undef p_interact
#undef focus_r
#undef focus_xh
#undef focus_xw
#undef focus_ah
#undef focus_aw
#undef target_z
#undef target_y
#undef target_x
#undef target_index
#undef visualize
#undef yheight2
#undef xwidth2
#undef zdepth
#undef yheight
#undef xwidth
#undef priority
#undef material_string
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

/* User declarations for component 'inter_analyzer_colimator_0_blade_4' [159]. */
#define mccompcurname  inter_analyzer_colimator_0_blade_4
#define mccompcurtype  Union_box
#define mccompcurindex 159
#define loop_index mccinter_analyzer_colimator_0_blade_4_loop_index
#define this_box_volume mccinter_analyzer_colimator_0_blade_4_this_box_volume
#define global_geometry_element mccinter_analyzer_colimator_0_blade_4_global_geometry_element
#define this_box_storage mccinter_analyzer_colimator_0_blade_4_this_box_storage
#define material_string mccinter_analyzer_colimator_0_blade_4_material_string
#define priority mccinter_analyzer_colimator_0_blade_4_priority
#define xwidth mccinter_analyzer_colimator_0_blade_4_xwidth
#define yheight mccinter_analyzer_colimator_0_blade_4_yheight
#define zdepth mccinter_analyzer_colimator_0_blade_4_zdepth
#define xwidth2 mccinter_analyzer_colimator_0_blade_4_xwidth2
#define yheight2 mccinter_analyzer_colimator_0_blade_4_yheight2
#define visualize mccinter_analyzer_colimator_0_blade_4_visualize
#define target_index mccinter_analyzer_colimator_0_blade_4_target_index
#define target_x mccinter_analyzer_colimator_0_blade_4_target_x
#define target_y mccinter_analyzer_colimator_0_blade_4_target_y
#define target_z mccinter_analyzer_colimator_0_blade_4_target_z
#define focus_aw mccinter_analyzer_colimator_0_blade_4_focus_aw
#define focus_ah mccinter_analyzer_colimator_0_blade_4_focus_ah
#define focus_xw mccinter_analyzer_colimator_0_blade_4_focus_xw
#define focus_xh mccinter_analyzer_colimator_0_blade_4_focus_xh
#define focus_r mccinter_analyzer_colimator_0_blade_4_focus_r
#define p_interact mccinter_analyzer_colimator_0_blade_4_p_interact
#define mask_string mccinter_analyzer_colimator_0_blade_4_mask_string
#define mask_setting mccinter_analyzer_colimator_0_blade_4_mask_setting
#define number_of_activations mccinter_analyzer_colimator_0_blade_4_number_of_activations
#line 204 "Union_box.comp"
// Needed for transport to the main component
struct global_geometry_element_struct global_geometry_element;

#ifndef ANY_GEOMETRY_DETECTOR_DECLARE
    #define ANY_GEOMETRY_DETECTOR_DECLARE dummy
	//struct pointer_to_global_geometry_list global_geometry_list = {0,NULL};
#endif

int loop_index,found_geometries;

double x_component;
double y_component;
double z_component;

struct Volume_struct this_box_volume;
struct box_storage this_box_storage;

#line 35856 "MACS_sample_kidney_box.c"
#undef number_of_activations
#undef mask_setting
#undef mask_string
#undef p_interact
#undef focus_r
#undef focus_xh
#undef focus_xw
#undef focus_ah
#undef focus_aw
#undef target_z
#undef target_y
#undef target_x
#undef target_index
#undef visualize
#undef yheight2
#undef xwidth2
#undef zdepth
#undef yheight
#undef xwidth
#undef priority
#undef material_string
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

/* User declarations for component 'diffraction_detector_0_exit_volume' [160]. */
#define mccompcurname  diffraction_detector_0_exit_volume
#define mccompcurtype  Union_box
#define mccompcurindex 160
#define loop_index mccdiffraction_detector_0_exit_volume_loop_index
#define this_box_volume mccdiffraction_detector_0_exit_volume_this_box_volume
#define global_geometry_element mccdiffraction_detector_0_exit_volume_global_geometry_element
#define this_box_storage mccdiffraction_detector_0_exit_volume_this_box_storage
#define material_string mccdiffraction_detector_0_exit_volume_material_string
#define priority mccdiffraction_detector_0_exit_volume_priority
#define xwidth mccdiffraction_detector_0_exit_volume_xwidth
#define yheight mccdiffraction_detector_0_exit_volume_yheight
#define zdepth mccdiffraction_detector_0_exit_volume_zdepth
#define xwidth2 mccdiffraction_detector_0_exit_volume_xwidth2
#define yheight2 mccdiffraction_detector_0_exit_volume_yheight2
#define visualize mccdiffraction_detector_0_exit_volume_visualize
#define target_index mccdiffraction_detector_0_exit_volume_target_index
#define target_x mccdiffraction_detector_0_exit_volume_target_x
#define target_y mccdiffraction_detector_0_exit_volume_target_y
#define target_z mccdiffraction_detector_0_exit_volume_target_z
#define focus_aw mccdiffraction_detector_0_exit_volume_focus_aw
#define focus_ah mccdiffraction_detector_0_exit_volume_focus_ah
#define focus_xw mccdiffraction_detector_0_exit_volume_focus_xw
#define focus_xh mccdiffraction_detector_0_exit_volume_focus_xh
#define focus_r mccdiffraction_detector_0_exit_volume_focus_r
#define p_interact mccdiffraction_detector_0_exit_volume_p_interact
#define mask_string mccdiffraction_detector_0_exit_volume_mask_string
#define mask_setting mccdiffraction_detector_0_exit_volume_mask_setting
#define number_of_activations mccdiffraction_detector_0_exit_volume_number_of_activations
#line 204 "Union_box.comp"
// Needed for transport to the main component
struct global_geometry_element_struct global_geometry_element;

#ifndef ANY_GEOMETRY_DETECTOR_DECLARE
    #define ANY_GEOMETRY_DETECTOR_DECLARE dummy
	//struct pointer_to_global_geometry_list global_geometry_list = {0,NULL};
#endif

int loop_index,found_geometries;

double x_component;
double y_component;
double z_component;

struct Volume_struct this_box_volume;
struct box_storage this_box_storage;

#line 35933 "MACS_sample_kidney_box.c"
#undef number_of_activations
#undef mask_setting
#undef mask_string
#undef p_interact
#undef focus_r
#undef focus_xh
#undef focus_xw
#undef focus_ah
#undef focus_aw
#undef target_z
#undef target_y
#undef target_x
#undef target_index
#undef visualize
#undef yheight2
#undef xwidth2
#undef zdepth
#undef yheight
#undef xwidth
#undef priority
#undef material_string
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

/* User declarations for component 'spec_detector_0_exit_volume' [161]. */
#define mccompcurname  spec_detector_0_exit_volume
#define mccompcurtype  Union_box
#define mccompcurindex 161
#define loop_index mccspec_detector_0_exit_volume_loop_index
#define this_box_volume mccspec_detector_0_exit_volume_this_box_volume
#define global_geometry_element mccspec_detector_0_exit_volume_global_geometry_element
#define this_box_storage mccspec_detector_0_exit_volume_this_box_storage
#define material_string mccspec_detector_0_exit_volume_material_string
#define priority mccspec_detector_0_exit_volume_priority
#define xwidth mccspec_detector_0_exit_volume_xwidth
#define yheight mccspec_detector_0_exit_volume_yheight
#define zdepth mccspec_detector_0_exit_volume_zdepth
#define xwidth2 mccspec_detector_0_exit_volume_xwidth2
#define yheight2 mccspec_detector_0_exit_volume_yheight2
#define visualize mccspec_detector_0_exit_volume_visualize
#define target_index mccspec_detector_0_exit_volume_target_index
#define target_x mccspec_detector_0_exit_volume_target_x
#define target_y mccspec_detector_0_exit_volume_target_y
#define target_z mccspec_detector_0_exit_volume_target_z
#define focus_aw mccspec_detector_0_exit_volume_focus_aw
#define focus_ah mccspec_detector_0_exit_volume_focus_ah
#define focus_xw mccspec_detector_0_exit_volume_focus_xw
#define focus_xh mccspec_detector_0_exit_volume_focus_xh
#define focus_r mccspec_detector_0_exit_volume_focus_r
#define p_interact mccspec_detector_0_exit_volume_p_interact
#define mask_string mccspec_detector_0_exit_volume_mask_string
#define mask_setting mccspec_detector_0_exit_volume_mask_setting
#define number_of_activations mccspec_detector_0_exit_volume_number_of_activations
#line 204 "Union_box.comp"
// Needed for transport to the main component
struct global_geometry_element_struct global_geometry_element;

#ifndef ANY_GEOMETRY_DETECTOR_DECLARE
    #define ANY_GEOMETRY_DETECTOR_DECLARE dummy
	//struct pointer_to_global_geometry_list global_geometry_list = {0,NULL};
#endif

int loop_index,found_geometries;

double x_component;
double y_component;
double z_component;

struct Volume_struct this_box_volume;
struct box_storage this_box_storage;

#line 36010 "MACS_sample_kidney_box.c"
#undef number_of_activations
#undef mask_setting
#undef mask_string
#undef p_interact
#undef focus_r
#undef focus_xh
#undef focus_xw
#undef focus_ah
#undef focus_aw
#undef target_z
#undef target_y
#undef target_x
#undef target_index
#undef visualize
#undef yheight2
#undef xwidth2
#undef zdepth
#undef yheight
#undef xwidth
#undef priority
#undef material_string
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

/* User declarations for component 'channel_1_cave1_box1' [162]. */
#define mccompcurname  channel_1_cave1_box1
#define mccompcurtype  Union_box
#define mccompcurindex 162
#define loop_index mccchannel_1_cave1_box1_loop_index
#define this_box_volume mccchannel_1_cave1_box1_this_box_volume
#define global_geometry_element mccchannel_1_cave1_box1_global_geometry_element
#define this_box_storage mccchannel_1_cave1_box1_this_box_storage
#define material_string mccchannel_1_cave1_box1_material_string
#define priority mccchannel_1_cave1_box1_priority
#define xwidth mccchannel_1_cave1_box1_xwidth
#define yheight mccchannel_1_cave1_box1_yheight
#define zdepth mccchannel_1_cave1_box1_zdepth
#define xwidth2 mccchannel_1_cave1_box1_xwidth2
#define yheight2 mccchannel_1_cave1_box1_yheight2
#define visualize mccchannel_1_cave1_box1_visualize
#define target_index mccchannel_1_cave1_box1_target_index
#define target_x mccchannel_1_cave1_box1_target_x
#define target_y mccchannel_1_cave1_box1_target_y
#define target_z mccchannel_1_cave1_box1_target_z
#define focus_aw mccchannel_1_cave1_box1_focus_aw
#define focus_ah mccchannel_1_cave1_box1_focus_ah
#define focus_xw mccchannel_1_cave1_box1_focus_xw
#define focus_xh mccchannel_1_cave1_box1_focus_xh
#define focus_r mccchannel_1_cave1_box1_focus_r
#define p_interact mccchannel_1_cave1_box1_p_interact
#define mask_string mccchannel_1_cave1_box1_mask_string
#define mask_setting mccchannel_1_cave1_box1_mask_setting
#define number_of_activations mccchannel_1_cave1_box1_number_of_activations
#line 204 "Union_box.comp"
// Needed for transport to the main component
struct global_geometry_element_struct global_geometry_element;

#ifndef ANY_GEOMETRY_DETECTOR_DECLARE
    #define ANY_GEOMETRY_DETECTOR_DECLARE dummy
	//struct pointer_to_global_geometry_list global_geometry_list = {0,NULL};
#endif

int loop_index,found_geometries;

double x_component;
double y_component;
double z_component;

struct Volume_struct this_box_volume;
struct box_storage this_box_storage;

#line 36087 "MACS_sample_kidney_box.c"
#undef number_of_activations
#undef mask_setting
#undef mask_string
#undef p_interact
#undef focus_r
#undef focus_xh
#undef focus_xw
#undef focus_ah
#undef focus_aw
#undef target_z
#undef target_y
#undef target_x
#undef target_index
#undef visualize
#undef yheight2
#undef xwidth2
#undef zdepth
#undef yheight
#undef xwidth
#undef priority
#undef material_string
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

/* User declarations for component 'channel_1_cave1_box2' [163]. */
#define mccompcurname  channel_1_cave1_box2
#define mccompcurtype  Union_box
#define mccompcurindex 163
#define loop_index mccchannel_1_cave1_box2_loop_index
#define this_box_volume mccchannel_1_cave1_box2_this_box_volume
#define global_geometry_element mccchannel_1_cave1_box2_global_geometry_element
#define this_box_storage mccchannel_1_cave1_box2_this_box_storage
#define material_string mccchannel_1_cave1_box2_material_string
#define priority mccchannel_1_cave1_box2_priority
#define xwidth mccchannel_1_cave1_box2_xwidth
#define yheight mccchannel_1_cave1_box2_yheight
#define zdepth mccchannel_1_cave1_box2_zdepth
#define xwidth2 mccchannel_1_cave1_box2_xwidth2
#define yheight2 mccchannel_1_cave1_box2_yheight2
#define visualize mccchannel_1_cave1_box2_visualize
#define target_index mccchannel_1_cave1_box2_target_index
#define target_x mccchannel_1_cave1_box2_target_x
#define target_y mccchannel_1_cave1_box2_target_y
#define target_z mccchannel_1_cave1_box2_target_z
#define focus_aw mccchannel_1_cave1_box2_focus_aw
#define focus_ah mccchannel_1_cave1_box2_focus_ah
#define focus_xw mccchannel_1_cave1_box2_focus_xw
#define focus_xh mccchannel_1_cave1_box2_focus_xh
#define focus_r mccchannel_1_cave1_box2_focus_r
#define p_interact mccchannel_1_cave1_box2_p_interact
#define mask_string mccchannel_1_cave1_box2_mask_string
#define mask_setting mccchannel_1_cave1_box2_mask_setting
#define number_of_activations mccchannel_1_cave1_box2_number_of_activations
#line 204 "Union_box.comp"
// Needed for transport to the main component
struct global_geometry_element_struct global_geometry_element;

#ifndef ANY_GEOMETRY_DETECTOR_DECLARE
    #define ANY_GEOMETRY_DETECTOR_DECLARE dummy
	//struct pointer_to_global_geometry_list global_geometry_list = {0,NULL};
#endif

int loop_index,found_geometries;

double x_component;
double y_component;
double z_component;

struct Volume_struct this_box_volume;
struct box_storage this_box_storage;

#line 36164 "MACS_sample_kidney_box.c"
#undef number_of_activations
#undef mask_setting
#undef mask_string
#undef p_interact
#undef focus_r
#undef focus_xh
#undef focus_xw
#undef focus_ah
#undef focus_aw
#undef target_z
#undef target_y
#undef target_x
#undef target_index
#undef visualize
#undef yheight2
#undef xwidth2
#undef zdepth
#undef yheight
#undef xwidth
#undef priority
#undef material_string
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

/* User declarations for component 'channel_1_cave1_box3' [164]. */
#define mccompcurname  channel_1_cave1_box3
#define mccompcurtype  Union_box
#define mccompcurindex 164
#define loop_index mccchannel_1_cave1_box3_loop_index
#define this_box_volume mccchannel_1_cave1_box3_this_box_volume
#define global_geometry_element mccchannel_1_cave1_box3_global_geometry_element
#define this_box_storage mccchannel_1_cave1_box3_this_box_storage
#define material_string mccchannel_1_cave1_box3_material_string
#define priority mccchannel_1_cave1_box3_priority
#define xwidth mccchannel_1_cave1_box3_xwidth
#define yheight mccchannel_1_cave1_box3_yheight
#define zdepth mccchannel_1_cave1_box3_zdepth
#define xwidth2 mccchannel_1_cave1_box3_xwidth2
#define yheight2 mccchannel_1_cave1_box3_yheight2
#define visualize mccchannel_1_cave1_box3_visualize
#define target_index mccchannel_1_cave1_box3_target_index
#define target_x mccchannel_1_cave1_box3_target_x
#define target_y mccchannel_1_cave1_box3_target_y
#define target_z mccchannel_1_cave1_box3_target_z
#define focus_aw mccchannel_1_cave1_box3_focus_aw
#define focus_ah mccchannel_1_cave1_box3_focus_ah
#define focus_xw mccchannel_1_cave1_box3_focus_xw
#define focus_xh mccchannel_1_cave1_box3_focus_xh
#define focus_r mccchannel_1_cave1_box3_focus_r
#define p_interact mccchannel_1_cave1_box3_p_interact
#define mask_string mccchannel_1_cave1_box3_mask_string
#define mask_setting mccchannel_1_cave1_box3_mask_setting
#define number_of_activations mccchannel_1_cave1_box3_number_of_activations
#line 204 "Union_box.comp"
// Needed for transport to the main component
struct global_geometry_element_struct global_geometry_element;

#ifndef ANY_GEOMETRY_DETECTOR_DECLARE
    #define ANY_GEOMETRY_DETECTOR_DECLARE dummy
	//struct pointer_to_global_geometry_list global_geometry_list = {0,NULL};
#endif

int loop_index,found_geometries;

double x_component;
double y_component;
double z_component;

struct Volume_struct this_box_volume;
struct box_storage this_box_storage;

#line 36241 "MACS_sample_kidney_box.c"
#undef number_of_activations
#undef mask_setting
#undef mask_string
#undef p_interact
#undef focus_r
#undef focus_xh
#undef focus_xw
#undef focus_ah
#undef focus_aw
#undef target_z
#undef target_y
#undef target_x
#undef target_index
#undef visualize
#undef yheight2
#undef xwidth2
#undef zdepth
#undef yheight
#undef xwidth
#undef priority
#undef material_string
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

/* User declarations for component 'channel_1_cave1_cyl1' [165]. */
#define mccompcurname  channel_1_cave1_cyl1
#define mccompcurtype  Union_cylinder
#define mccompcurindex 165
#define loop_index mccchannel_1_cave1_cyl1_loop_index
#define this_cylinder_volume mccchannel_1_cave1_cyl1_this_cylinder_volume
#define global_geometry_element mccchannel_1_cave1_cyl1_global_geometry_element
#define this_cylinder_storage mccchannel_1_cave1_cyl1_this_cylinder_storage
#define material_string mccchannel_1_cave1_cyl1_material_string
#define priority mccchannel_1_cave1_cyl1_priority
#define radius mccchannel_1_cave1_cyl1_radius
#define yheight mccchannel_1_cave1_cyl1_yheight
#define visualize mccchannel_1_cave1_cyl1_visualize
#define target_index mccchannel_1_cave1_cyl1_target_index
#define target_x mccchannel_1_cave1_cyl1_target_x
#define target_y mccchannel_1_cave1_cyl1_target_y
#define target_z mccchannel_1_cave1_cyl1_target_z
#define focus_aw mccchannel_1_cave1_cyl1_focus_aw
#define focus_ah mccchannel_1_cave1_cyl1_focus_ah
#define focus_xw mccchannel_1_cave1_cyl1_focus_xw
#define focus_xh mccchannel_1_cave1_cyl1_focus_xh
#define focus_r mccchannel_1_cave1_cyl1_focus_r
#define p_interact mccchannel_1_cave1_cyl1_p_interact
#define mask_string mccchannel_1_cave1_cyl1_mask_string
#define mask_setting mccchannel_1_cave1_cyl1_mask_setting
#define number_of_activations mccchannel_1_cave1_cyl1_number_of_activations
#line 167 "Union_cylinder.comp"
// Needed for transport to the main component
struct global_geometry_element_struct global_geometry_element;

#ifndef ANY_GEOMETRY_DETECTOR_DECLARE
    #define ANY_GEOMETRY_DETECTOR_DECLARE dummy
	//struct pointer_to_global_geometry_list global_geometry_list = {0,NULL};
#endif

int dummy;
int loop_index,found_geometries;
int loop_2_index;
int material_index;

struct Volume_struct this_cylinder_volume;
struct cylinder_storage this_cylinder_storage;
#line 36313 "MACS_sample_kidney_box.c"
#undef number_of_activations
#undef mask_setting
#undef mask_string
#undef p_interact
#undef focus_r
#undef focus_xh
#undef focus_xw
#undef focus_ah
#undef focus_aw
#undef target_z
#undef target_y
#undef target_x
#undef target_index
#undef visualize
#undef yheight
#undef radius
#undef priority
#undef material_string
#undef this_cylinder_storage
#undef global_geometry_element
#undef this_cylinder_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

/* User declarations for component 'channel_1_analyzer_1_center' [166]. */
#define mccompcurname  channel_1_analyzer_1_center
#define mccompcurtype  Arm
#define mccompcurindex 166
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

/* User declarations for component 'channel_1_analyzer_1_rotated' [167]. */
#define mccompcurname  channel_1_analyzer_1_rotated
#define mccompcurtype  Arm
#define mccompcurindex 167
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

/* User declarations for component 'channel_1_analyzer_1_array_crystal_array_0' [168]. */
#define mccompcurname  channel_1_analyzer_1_array_crystal_array_0
#define mccompcurtype  Union_box
#define mccompcurindex 168
#define loop_index mccchannel_1_analyzer_1_array_crystal_array_0_loop_index
#define this_box_volume mccchannel_1_analyzer_1_array_crystal_array_0_this_box_volume
#define global_geometry_element mccchannel_1_analyzer_1_array_crystal_array_0_global_geometry_element
#define this_box_storage mccchannel_1_analyzer_1_array_crystal_array_0_this_box_storage
#define material_string mccchannel_1_analyzer_1_array_crystal_array_0_material_string
#define priority mccchannel_1_analyzer_1_array_crystal_array_0_priority
#define xwidth mccchannel_1_analyzer_1_array_crystal_array_0_xwidth
#define yheight mccchannel_1_analyzer_1_array_crystal_array_0_yheight
#define zdepth mccchannel_1_analyzer_1_array_crystal_array_0_zdepth
#define xwidth2 mccchannel_1_analyzer_1_array_crystal_array_0_xwidth2
#define yheight2 mccchannel_1_analyzer_1_array_crystal_array_0_yheight2
#define visualize mccchannel_1_analyzer_1_array_crystal_array_0_visualize
#define target_index mccchannel_1_analyzer_1_array_crystal_array_0_target_index
#define target_x mccchannel_1_analyzer_1_array_crystal_array_0_target_x
#define target_y mccchannel_1_analyzer_1_array_crystal_array_0_target_y
#define target_z mccchannel_1_analyzer_1_array_crystal_array_0_target_z
#define focus_aw mccchannel_1_analyzer_1_array_crystal_array_0_focus_aw
#define focus_ah mccchannel_1_analyzer_1_array_crystal_array_0_focus_ah
#define focus_xw mccchannel_1_analyzer_1_array_crystal_array_0_focus_xw
#define focus_xh mccchannel_1_analyzer_1_array_crystal_array_0_focus_xh
#define focus_r mccchannel_1_analyzer_1_array_crystal_array_0_focus_r
#define p_interact mccchannel_1_analyzer_1_array_crystal_array_0_p_interact
#define mask_string mccchannel_1_analyzer_1_array_crystal_array_0_mask_string
#define mask_setting mccchannel_1_analyzer_1_array_crystal_array_0_mask_setting
#define number_of_activations mccchannel_1_analyzer_1_array_crystal_array_0_number_of_activations
#line 204 "Union_box.comp"
// Needed for transport to the main component
struct global_geometry_element_struct global_geometry_element;

#ifndef ANY_GEOMETRY_DETECTOR_DECLARE
    #define ANY_GEOMETRY_DETECTOR_DECLARE dummy
	//struct pointer_to_global_geometry_list global_geometry_list = {0,NULL};
#endif

int loop_index,found_geometries;

double x_component;
double y_component;
double z_component;

struct Volume_struct this_box_volume;
struct box_storage this_box_storage;

#line 36403 "MACS_sample_kidney_box.c"
#undef number_of_activations
#undef mask_setting
#undef mask_string
#undef p_interact
#undef focus_r
#undef focus_xh
#undef focus_xw
#undef focus_ah
#undef focus_aw
#undef target_z
#undef target_y
#undef target_x
#undef target_index
#undef visualize
#undef yheight2
#undef xwidth2
#undef zdepth
#undef yheight
#undef xwidth
#undef priority
#undef material_string
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

/* User declarations for component 'channel_1_analyzer_1_array_crystal_array_1' [169]. */
#define mccompcurname  channel_1_analyzer_1_array_crystal_array_1
#define mccompcurtype  Union_box
#define mccompcurindex 169
#define loop_index mccchannel_1_analyzer_1_array_crystal_array_1_loop_index
#define this_box_volume mccchannel_1_analyzer_1_array_crystal_array_1_this_box_volume
#define global_geometry_element mccchannel_1_analyzer_1_array_crystal_array_1_global_geometry_element
#define this_box_storage mccchannel_1_analyzer_1_array_crystal_array_1_this_box_storage
#define material_string mccchannel_1_analyzer_1_array_crystal_array_1_material_string
#define priority mccchannel_1_analyzer_1_array_crystal_array_1_priority
#define xwidth mccchannel_1_analyzer_1_array_crystal_array_1_xwidth
#define yheight mccchannel_1_analyzer_1_array_crystal_array_1_yheight
#define zdepth mccchannel_1_analyzer_1_array_crystal_array_1_zdepth
#define xwidth2 mccchannel_1_analyzer_1_array_crystal_array_1_xwidth2
#define yheight2 mccchannel_1_analyzer_1_array_crystal_array_1_yheight2
#define visualize mccchannel_1_analyzer_1_array_crystal_array_1_visualize
#define target_index mccchannel_1_analyzer_1_array_crystal_array_1_target_index
#define target_x mccchannel_1_analyzer_1_array_crystal_array_1_target_x
#define target_y mccchannel_1_analyzer_1_array_crystal_array_1_target_y
#define target_z mccchannel_1_analyzer_1_array_crystal_array_1_target_z
#define focus_aw mccchannel_1_analyzer_1_array_crystal_array_1_focus_aw
#define focus_ah mccchannel_1_analyzer_1_array_crystal_array_1_focus_ah
#define focus_xw mccchannel_1_analyzer_1_array_crystal_array_1_focus_xw
#define focus_xh mccchannel_1_analyzer_1_array_crystal_array_1_focus_xh
#define focus_r mccchannel_1_analyzer_1_array_crystal_array_1_focus_r
#define p_interact mccchannel_1_analyzer_1_array_crystal_array_1_p_interact
#define mask_string mccchannel_1_analyzer_1_array_crystal_array_1_mask_string
#define mask_setting mccchannel_1_analyzer_1_array_crystal_array_1_mask_setting
#define number_of_activations mccchannel_1_analyzer_1_array_crystal_array_1_number_of_activations
#line 204 "Union_box.comp"
// Needed for transport to the main component
struct global_geometry_element_struct global_geometry_element;

#ifndef ANY_GEOMETRY_DETECTOR_DECLARE
    #define ANY_GEOMETRY_DETECTOR_DECLARE dummy
	//struct pointer_to_global_geometry_list global_geometry_list = {0,NULL};
#endif

int loop_index,found_geometries;

double x_component;
double y_component;
double z_component;

struct Volume_struct this_box_volume;
struct box_storage this_box_storage;

#line 36480 "MACS_sample_kidney_box.c"
#undef number_of_activations
#undef mask_setting
#undef mask_string
#undef p_interact
#undef focus_r
#undef focus_xh
#undef focus_xw
#undef focus_ah
#undef focus_aw
#undef target_z
#undef target_y
#undef target_x
#undef target_index
#undef visualize
#undef yheight2
#undef xwidth2
#undef zdepth
#undef yheight
#undef xwidth
#undef priority
#undef material_string
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

/* User declarations for component 'channel_1_analyzer_1_array_crystal_array_2' [170]. */
#define mccompcurname  channel_1_analyzer_1_array_crystal_array_2
#define mccompcurtype  Union_box
#define mccompcurindex 170
#define loop_index mccchannel_1_analyzer_1_array_crystal_array_2_loop_index
#define this_box_volume mccchannel_1_analyzer_1_array_crystal_array_2_this_box_volume
#define global_geometry_element mccchannel_1_analyzer_1_array_crystal_array_2_global_geometry_element
#define this_box_storage mccchannel_1_analyzer_1_array_crystal_array_2_this_box_storage
#define material_string mccchannel_1_analyzer_1_array_crystal_array_2_material_string
#define priority mccchannel_1_analyzer_1_array_crystal_array_2_priority
#define xwidth mccchannel_1_analyzer_1_array_crystal_array_2_xwidth
#define yheight mccchannel_1_analyzer_1_array_crystal_array_2_yheight
#define zdepth mccchannel_1_analyzer_1_array_crystal_array_2_zdepth
#define xwidth2 mccchannel_1_analyzer_1_array_crystal_array_2_xwidth2
#define yheight2 mccchannel_1_analyzer_1_array_crystal_array_2_yheight2
#define visualize mccchannel_1_analyzer_1_array_crystal_array_2_visualize
#define target_index mccchannel_1_analyzer_1_array_crystal_array_2_target_index
#define target_x mccchannel_1_analyzer_1_array_crystal_array_2_target_x
#define target_y mccchannel_1_analyzer_1_array_crystal_array_2_target_y
#define target_z mccchannel_1_analyzer_1_array_crystal_array_2_target_z
#define focus_aw mccchannel_1_analyzer_1_array_crystal_array_2_focus_aw
#define focus_ah mccchannel_1_analyzer_1_array_crystal_array_2_focus_ah
#define focus_xw mccchannel_1_analyzer_1_array_crystal_array_2_focus_xw
#define focus_xh mccchannel_1_analyzer_1_array_crystal_array_2_focus_xh
#define focus_r mccchannel_1_analyzer_1_array_crystal_array_2_focus_r
#define p_interact mccchannel_1_analyzer_1_array_crystal_array_2_p_interact
#define mask_string mccchannel_1_analyzer_1_array_crystal_array_2_mask_string
#define mask_setting mccchannel_1_analyzer_1_array_crystal_array_2_mask_setting
#define number_of_activations mccchannel_1_analyzer_1_array_crystal_array_2_number_of_activations
#line 204 "Union_box.comp"
// Needed for transport to the main component
struct global_geometry_element_struct global_geometry_element;

#ifndef ANY_GEOMETRY_DETECTOR_DECLARE
    #define ANY_GEOMETRY_DETECTOR_DECLARE dummy
	//struct pointer_to_global_geometry_list global_geometry_list = {0,NULL};
#endif

int loop_index,found_geometries;

double x_component;
double y_component;
double z_component;

struct Volume_struct this_box_volume;
struct box_storage this_box_storage;

#line 36557 "MACS_sample_kidney_box.c"
#undef number_of_activations
#undef mask_setting
#undef mask_string
#undef p_interact
#undef focus_r
#undef focus_xh
#undef focus_xw
#undef focus_ah
#undef focus_aw
#undef target_z
#undef target_y
#undef target_x
#undef target_index
#undef visualize
#undef yheight2
#undef xwidth2
#undef zdepth
#undef yheight
#undef xwidth
#undef priority
#undef material_string
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

/* User declarations for component 'channel_1_analyzer_1_array_crystal_array_3' [171]. */
#define mccompcurname  channel_1_analyzer_1_array_crystal_array_3
#define mccompcurtype  Union_box
#define mccompcurindex 171
#define loop_index mccchannel_1_analyzer_1_array_crystal_array_3_loop_index
#define this_box_volume mccchannel_1_analyzer_1_array_crystal_array_3_this_box_volume
#define global_geometry_element mccchannel_1_analyzer_1_array_crystal_array_3_global_geometry_element
#define this_box_storage mccchannel_1_analyzer_1_array_crystal_array_3_this_box_storage
#define material_string mccchannel_1_analyzer_1_array_crystal_array_3_material_string
#define priority mccchannel_1_analyzer_1_array_crystal_array_3_priority
#define xwidth mccchannel_1_analyzer_1_array_crystal_array_3_xwidth
#define yheight mccchannel_1_analyzer_1_array_crystal_array_3_yheight
#define zdepth mccchannel_1_analyzer_1_array_crystal_array_3_zdepth
#define xwidth2 mccchannel_1_analyzer_1_array_crystal_array_3_xwidth2
#define yheight2 mccchannel_1_analyzer_1_array_crystal_array_3_yheight2
#define visualize mccchannel_1_analyzer_1_array_crystal_array_3_visualize
#define target_index mccchannel_1_analyzer_1_array_crystal_array_3_target_index
#define target_x mccchannel_1_analyzer_1_array_crystal_array_3_target_x
#define target_y mccchannel_1_analyzer_1_array_crystal_array_3_target_y
#define target_z mccchannel_1_analyzer_1_array_crystal_array_3_target_z
#define focus_aw mccchannel_1_analyzer_1_array_crystal_array_3_focus_aw
#define focus_ah mccchannel_1_analyzer_1_array_crystal_array_3_focus_ah
#define focus_xw mccchannel_1_analyzer_1_array_crystal_array_3_focus_xw
#define focus_xh mccchannel_1_analyzer_1_array_crystal_array_3_focus_xh
#define focus_r mccchannel_1_analyzer_1_array_crystal_array_3_focus_r
#define p_interact mccchannel_1_analyzer_1_array_crystal_array_3_p_interact
#define mask_string mccchannel_1_analyzer_1_array_crystal_array_3_mask_string
#define mask_setting mccchannel_1_analyzer_1_array_crystal_array_3_mask_setting
#define number_of_activations mccchannel_1_analyzer_1_array_crystal_array_3_number_of_activations
#line 204 "Union_box.comp"
// Needed for transport to the main component
struct global_geometry_element_struct global_geometry_element;

#ifndef ANY_GEOMETRY_DETECTOR_DECLARE
    #define ANY_GEOMETRY_DETECTOR_DECLARE dummy
	//struct pointer_to_global_geometry_list global_geometry_list = {0,NULL};
#endif

int loop_index,found_geometries;

double x_component;
double y_component;
double z_component;

struct Volume_struct this_box_volume;
struct box_storage this_box_storage;

#line 36634 "MACS_sample_kidney_box.c"
#undef number_of_activations
#undef mask_setting
#undef mask_string
#undef p_interact
#undef focus_r
#undef focus_xh
#undef focus_xw
#undef focus_ah
#undef focus_aw
#undef target_z
#undef target_y
#undef target_x
#undef target_index
#undef visualize
#undef yheight2
#undef xwidth2
#undef zdepth
#undef yheight
#undef xwidth
#undef priority
#undef material_string
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

/* User declarations for component 'channel_1_analyzer_1_array_crystal_array_4' [172]. */
#define mccompcurname  channel_1_analyzer_1_array_crystal_array_4
#define mccompcurtype  Union_box
#define mccompcurindex 172
#define loop_index mccchannel_1_analyzer_1_array_crystal_array_4_loop_index
#define this_box_volume mccchannel_1_analyzer_1_array_crystal_array_4_this_box_volume
#define global_geometry_element mccchannel_1_analyzer_1_array_crystal_array_4_global_geometry_element
#define this_box_storage mccchannel_1_analyzer_1_array_crystal_array_4_this_box_storage
#define material_string mccchannel_1_analyzer_1_array_crystal_array_4_material_string
#define priority mccchannel_1_analyzer_1_array_crystal_array_4_priority
#define xwidth mccchannel_1_analyzer_1_array_crystal_array_4_xwidth
#define yheight mccchannel_1_analyzer_1_array_crystal_array_4_yheight
#define zdepth mccchannel_1_analyzer_1_array_crystal_array_4_zdepth
#define xwidth2 mccchannel_1_analyzer_1_array_crystal_array_4_xwidth2
#define yheight2 mccchannel_1_analyzer_1_array_crystal_array_4_yheight2
#define visualize mccchannel_1_analyzer_1_array_crystal_array_4_visualize
#define target_index mccchannel_1_analyzer_1_array_crystal_array_4_target_index
#define target_x mccchannel_1_analyzer_1_array_crystal_array_4_target_x
#define target_y mccchannel_1_analyzer_1_array_crystal_array_4_target_y
#define target_z mccchannel_1_analyzer_1_array_crystal_array_4_target_z
#define focus_aw mccchannel_1_analyzer_1_array_crystal_array_4_focus_aw
#define focus_ah mccchannel_1_analyzer_1_array_crystal_array_4_focus_ah
#define focus_xw mccchannel_1_analyzer_1_array_crystal_array_4_focus_xw
#define focus_xh mccchannel_1_analyzer_1_array_crystal_array_4_focus_xh
#define focus_r mccchannel_1_analyzer_1_array_crystal_array_4_focus_r
#define p_interact mccchannel_1_analyzer_1_array_crystal_array_4_p_interact
#define mask_string mccchannel_1_analyzer_1_array_crystal_array_4_mask_string
#define mask_setting mccchannel_1_analyzer_1_array_crystal_array_4_mask_setting
#define number_of_activations mccchannel_1_analyzer_1_array_crystal_array_4_number_of_activations
#line 204 "Union_box.comp"
// Needed for transport to the main component
struct global_geometry_element_struct global_geometry_element;

#ifndef ANY_GEOMETRY_DETECTOR_DECLARE
    #define ANY_GEOMETRY_DETECTOR_DECLARE dummy
	//struct pointer_to_global_geometry_list global_geometry_list = {0,NULL};
#endif

int loop_index,found_geometries;

double x_component;
double y_component;
double z_component;

struct Volume_struct this_box_volume;
struct box_storage this_box_storage;

#line 36711 "MACS_sample_kidney_box.c"
#undef number_of_activations
#undef mask_setting
#undef mask_string
#undef p_interact
#undef focus_r
#undef focus_xh
#undef focus_xw
#undef focus_ah
#undef focus_aw
#undef target_z
#undef target_y
#undef target_x
#undef target_index
#undef visualize
#undef yheight2
#undef xwidth2
#undef zdepth
#undef yheight
#undef xwidth
#undef priority
#undef material_string
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

/* User declarations for component 'channel_1_analyzer_1_array_crystal_array_5' [173]. */
#define mccompcurname  channel_1_analyzer_1_array_crystal_array_5
#define mccompcurtype  Union_box
#define mccompcurindex 173
#define loop_index mccchannel_1_analyzer_1_array_crystal_array_5_loop_index
#define this_box_volume mccchannel_1_analyzer_1_array_crystal_array_5_this_box_volume
#define global_geometry_element mccchannel_1_analyzer_1_array_crystal_array_5_global_geometry_element
#define this_box_storage mccchannel_1_analyzer_1_array_crystal_array_5_this_box_storage
#define material_string mccchannel_1_analyzer_1_array_crystal_array_5_material_string
#define priority mccchannel_1_analyzer_1_array_crystal_array_5_priority
#define xwidth mccchannel_1_analyzer_1_array_crystal_array_5_xwidth
#define yheight mccchannel_1_analyzer_1_array_crystal_array_5_yheight
#define zdepth mccchannel_1_analyzer_1_array_crystal_array_5_zdepth
#define xwidth2 mccchannel_1_analyzer_1_array_crystal_array_5_xwidth2
#define yheight2 mccchannel_1_analyzer_1_array_crystal_array_5_yheight2
#define visualize mccchannel_1_analyzer_1_array_crystal_array_5_visualize
#define target_index mccchannel_1_analyzer_1_array_crystal_array_5_target_index
#define target_x mccchannel_1_analyzer_1_array_crystal_array_5_target_x
#define target_y mccchannel_1_analyzer_1_array_crystal_array_5_target_y
#define target_z mccchannel_1_analyzer_1_array_crystal_array_5_target_z
#define focus_aw mccchannel_1_analyzer_1_array_crystal_array_5_focus_aw
#define focus_ah mccchannel_1_analyzer_1_array_crystal_array_5_focus_ah
#define focus_xw mccchannel_1_analyzer_1_array_crystal_array_5_focus_xw
#define focus_xh mccchannel_1_analyzer_1_array_crystal_array_5_focus_xh
#define focus_r mccchannel_1_analyzer_1_array_crystal_array_5_focus_r
#define p_interact mccchannel_1_analyzer_1_array_crystal_array_5_p_interact
#define mask_string mccchannel_1_analyzer_1_array_crystal_array_5_mask_string
#define mask_setting mccchannel_1_analyzer_1_array_crystal_array_5_mask_setting
#define number_of_activations mccchannel_1_analyzer_1_array_crystal_array_5_number_of_activations
#line 204 "Union_box.comp"
// Needed for transport to the main component
struct global_geometry_element_struct global_geometry_element;

#ifndef ANY_GEOMETRY_DETECTOR_DECLARE
    #define ANY_GEOMETRY_DETECTOR_DECLARE dummy
	//struct pointer_to_global_geometry_list global_geometry_list = {0,NULL};
#endif

int loop_index,found_geometries;

double x_component;
double y_component;
double z_component;

struct Volume_struct this_box_volume;
struct box_storage this_box_storage;

#line 36788 "MACS_sample_kidney_box.c"
#undef number_of_activations
#undef mask_setting
#undef mask_string
#undef p_interact
#undef focus_r
#undef focus_xh
#undef focus_xw
#undef focus_ah
#undef focus_aw
#undef target_z
#undef target_y
#undef target_x
#undef target_index
#undef visualize
#undef yheight2
#undef xwidth2
#undef zdepth
#undef yheight
#undef xwidth
#undef priority
#undef material_string
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

/* User declarations for component 'channel_1_analyzer_1_array_crystal_array_6' [174]. */
#define mccompcurname  channel_1_analyzer_1_array_crystal_array_6
#define mccompcurtype  Union_box
#define mccompcurindex 174
#define loop_index mccchannel_1_analyzer_1_array_crystal_array_6_loop_index
#define this_box_volume mccchannel_1_analyzer_1_array_crystal_array_6_this_box_volume
#define global_geometry_element mccchannel_1_analyzer_1_array_crystal_array_6_global_geometry_element
#define this_box_storage mccchannel_1_analyzer_1_array_crystal_array_6_this_box_storage
#define material_string mccchannel_1_analyzer_1_array_crystal_array_6_material_string
#define priority mccchannel_1_analyzer_1_array_crystal_array_6_priority
#define xwidth mccchannel_1_analyzer_1_array_crystal_array_6_xwidth
#define yheight mccchannel_1_analyzer_1_array_crystal_array_6_yheight
#define zdepth mccchannel_1_analyzer_1_array_crystal_array_6_zdepth
#define xwidth2 mccchannel_1_analyzer_1_array_crystal_array_6_xwidth2
#define yheight2 mccchannel_1_analyzer_1_array_crystal_array_6_yheight2
#define visualize mccchannel_1_analyzer_1_array_crystal_array_6_visualize
#define target_index mccchannel_1_analyzer_1_array_crystal_array_6_target_index
#define target_x mccchannel_1_analyzer_1_array_crystal_array_6_target_x
#define target_y mccchannel_1_analyzer_1_array_crystal_array_6_target_y
#define target_z mccchannel_1_analyzer_1_array_crystal_array_6_target_z
#define focus_aw mccchannel_1_analyzer_1_array_crystal_array_6_focus_aw
#define focus_ah mccchannel_1_analyzer_1_array_crystal_array_6_focus_ah
#define focus_xw mccchannel_1_analyzer_1_array_crystal_array_6_focus_xw
#define focus_xh mccchannel_1_analyzer_1_array_crystal_array_6_focus_xh
#define focus_r mccchannel_1_analyzer_1_array_crystal_array_6_focus_r
#define p_interact mccchannel_1_analyzer_1_array_crystal_array_6_p_interact
#define mask_string mccchannel_1_analyzer_1_array_crystal_array_6_mask_string
#define mask_setting mccchannel_1_analyzer_1_array_crystal_array_6_mask_setting
#define number_of_activations mccchannel_1_analyzer_1_array_crystal_array_6_number_of_activations
#line 204 "Union_box.comp"
// Needed for transport to the main component
struct global_geometry_element_struct global_geometry_element;

#ifndef ANY_GEOMETRY_DETECTOR_DECLARE
    #define ANY_GEOMETRY_DETECTOR_DECLARE dummy
	//struct pointer_to_global_geometry_list global_geometry_list = {0,NULL};
#endif

int loop_index,found_geometries;

double x_component;
double y_component;
double z_component;

struct Volume_struct this_box_volume;
struct box_storage this_box_storage;

#line 36865 "MACS_sample_kidney_box.c"
#undef number_of_activations
#undef mask_setting
#undef mask_string
#undef p_interact
#undef focus_r
#undef focus_xh
#undef focus_xw
#undef focus_ah
#undef focus_aw
#undef target_z
#undef target_y
#undef target_x
#undef target_index
#undef visualize
#undef yheight2
#undef xwidth2
#undef zdepth
#undef yheight
#undef xwidth
#undef priority
#undef material_string
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

/* User declarations for component 'channel_1_analyzer_1_array_crystal_array_7' [175]. */
#define mccompcurname  channel_1_analyzer_1_array_crystal_array_7
#define mccompcurtype  Union_box
#define mccompcurindex 175
#define loop_index mccchannel_1_analyzer_1_array_crystal_array_7_loop_index
#define this_box_volume mccchannel_1_analyzer_1_array_crystal_array_7_this_box_volume
#define global_geometry_element mccchannel_1_analyzer_1_array_crystal_array_7_global_geometry_element
#define this_box_storage mccchannel_1_analyzer_1_array_crystal_array_7_this_box_storage
#define material_string mccchannel_1_analyzer_1_array_crystal_array_7_material_string
#define priority mccchannel_1_analyzer_1_array_crystal_array_7_priority
#define xwidth mccchannel_1_analyzer_1_array_crystal_array_7_xwidth
#define yheight mccchannel_1_analyzer_1_array_crystal_array_7_yheight
#define zdepth mccchannel_1_analyzer_1_array_crystal_array_7_zdepth
#define xwidth2 mccchannel_1_analyzer_1_array_crystal_array_7_xwidth2
#define yheight2 mccchannel_1_analyzer_1_array_crystal_array_7_yheight2
#define visualize mccchannel_1_analyzer_1_array_crystal_array_7_visualize
#define target_index mccchannel_1_analyzer_1_array_crystal_array_7_target_index
#define target_x mccchannel_1_analyzer_1_array_crystal_array_7_target_x
#define target_y mccchannel_1_analyzer_1_array_crystal_array_7_target_y
#define target_z mccchannel_1_analyzer_1_array_crystal_array_7_target_z
#define focus_aw mccchannel_1_analyzer_1_array_crystal_array_7_focus_aw
#define focus_ah mccchannel_1_analyzer_1_array_crystal_array_7_focus_ah
#define focus_xw mccchannel_1_analyzer_1_array_crystal_array_7_focus_xw
#define focus_xh mccchannel_1_analyzer_1_array_crystal_array_7_focus_xh
#define focus_r mccchannel_1_analyzer_1_array_crystal_array_7_focus_r
#define p_interact mccchannel_1_analyzer_1_array_crystal_array_7_p_interact
#define mask_string mccchannel_1_analyzer_1_array_crystal_array_7_mask_string
#define mask_setting mccchannel_1_analyzer_1_array_crystal_array_7_mask_setting
#define number_of_activations mccchannel_1_analyzer_1_array_crystal_array_7_number_of_activations
#line 204 "Union_box.comp"
// Needed for transport to the main component
struct global_geometry_element_struct global_geometry_element;

#ifndef ANY_GEOMETRY_DETECTOR_DECLARE
    #define ANY_GEOMETRY_DETECTOR_DECLARE dummy
	//struct pointer_to_global_geometry_list global_geometry_list = {0,NULL};
#endif

int loop_index,found_geometries;

double x_component;
double y_component;
double z_component;

struct Volume_struct this_box_volume;
struct box_storage this_box_storage;

#line 36942 "MACS_sample_kidney_box.c"
#undef number_of_activations
#undef mask_setting
#undef mask_string
#undef p_interact
#undef focus_r
#undef focus_xh
#undef focus_xw
#undef focus_ah
#undef focus_aw
#undef target_z
#undef target_y
#undef target_x
#undef target_index
#undef visualize
#undef yheight2
#undef xwidth2
#undef zdepth
#undef yheight
#undef xwidth
#undef priority
#undef material_string
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

/* User declarations for component 'channel_1_analyzer_1_array_crystal_array_8' [176]. */
#define mccompcurname  channel_1_analyzer_1_array_crystal_array_8
#define mccompcurtype  Union_box
#define mccompcurindex 176
#define loop_index mccchannel_1_analyzer_1_array_crystal_array_8_loop_index
#define this_box_volume mccchannel_1_analyzer_1_array_crystal_array_8_this_box_volume
#define global_geometry_element mccchannel_1_analyzer_1_array_crystal_array_8_global_geometry_element
#define this_box_storage mccchannel_1_analyzer_1_array_crystal_array_8_this_box_storage
#define material_string mccchannel_1_analyzer_1_array_crystal_array_8_material_string
#define priority mccchannel_1_analyzer_1_array_crystal_array_8_priority
#define xwidth mccchannel_1_analyzer_1_array_crystal_array_8_xwidth
#define yheight mccchannel_1_analyzer_1_array_crystal_array_8_yheight
#define zdepth mccchannel_1_analyzer_1_array_crystal_array_8_zdepth
#define xwidth2 mccchannel_1_analyzer_1_array_crystal_array_8_xwidth2
#define yheight2 mccchannel_1_analyzer_1_array_crystal_array_8_yheight2
#define visualize mccchannel_1_analyzer_1_array_crystal_array_8_visualize
#define target_index mccchannel_1_analyzer_1_array_crystal_array_8_target_index
#define target_x mccchannel_1_analyzer_1_array_crystal_array_8_target_x
#define target_y mccchannel_1_analyzer_1_array_crystal_array_8_target_y
#define target_z mccchannel_1_analyzer_1_array_crystal_array_8_target_z
#define focus_aw mccchannel_1_analyzer_1_array_crystal_array_8_focus_aw
#define focus_ah mccchannel_1_analyzer_1_array_crystal_array_8_focus_ah
#define focus_xw mccchannel_1_analyzer_1_array_crystal_array_8_focus_xw
#define focus_xh mccchannel_1_analyzer_1_array_crystal_array_8_focus_xh
#define focus_r mccchannel_1_analyzer_1_array_crystal_array_8_focus_r
#define p_interact mccchannel_1_analyzer_1_array_crystal_array_8_p_interact
#define mask_string mccchannel_1_analyzer_1_array_crystal_array_8_mask_string
#define mask_setting mccchannel_1_analyzer_1_array_crystal_array_8_mask_setting
#define number_of_activations mccchannel_1_analyzer_1_array_crystal_array_8_number_of_activations
#line 204 "Union_box.comp"
// Needed for transport to the main component
struct global_geometry_element_struct global_geometry_element;

#ifndef ANY_GEOMETRY_DETECTOR_DECLARE
    #define ANY_GEOMETRY_DETECTOR_DECLARE dummy
	//struct pointer_to_global_geometry_list global_geometry_list = {0,NULL};
#endif

int loop_index,found_geometries;

double x_component;
double y_component;
double z_component;

struct Volume_struct this_box_volume;
struct box_storage this_box_storage;

#line 37019 "MACS_sample_kidney_box.c"
#undef number_of_activations
#undef mask_setting
#undef mask_string
#undef p_interact
#undef focus_r
#undef focus_xh
#undef focus_xw
#undef focus_ah
#undef focus_aw
#undef target_z
#undef target_y
#undef target_x
#undef target_index
#undef visualize
#undef yheight2
#undef xwidth2
#undef zdepth
#undef yheight
#undef xwidth
#undef priority
#undef material_string
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

/* User declarations for component 'channel_1_analyzer_2_center' [177]. */
#define mccompcurname  channel_1_analyzer_2_center
#define mccompcurtype  Arm
#define mccompcurindex 177
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

/* User declarations for component 'channel_1_analyzer_2_rotated' [178]. */
#define mccompcurname  channel_1_analyzer_2_rotated
#define mccompcurtype  Arm
#define mccompcurindex 178
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

/* User declarations for component 'channel_1_analyzer_2_array_crystal_array_0' [179]. */
#define mccompcurname  channel_1_analyzer_2_array_crystal_array_0
#define mccompcurtype  Union_box
#define mccompcurindex 179
#define loop_index mccchannel_1_analyzer_2_array_crystal_array_0_loop_index
#define this_box_volume mccchannel_1_analyzer_2_array_crystal_array_0_this_box_volume
#define global_geometry_element mccchannel_1_analyzer_2_array_crystal_array_0_global_geometry_element
#define this_box_storage mccchannel_1_analyzer_2_array_crystal_array_0_this_box_storage
#define material_string mccchannel_1_analyzer_2_array_crystal_array_0_material_string
#define priority mccchannel_1_analyzer_2_array_crystal_array_0_priority
#define xwidth mccchannel_1_analyzer_2_array_crystal_array_0_xwidth
#define yheight mccchannel_1_analyzer_2_array_crystal_array_0_yheight
#define zdepth mccchannel_1_analyzer_2_array_crystal_array_0_zdepth
#define xwidth2 mccchannel_1_analyzer_2_array_crystal_array_0_xwidth2
#define yheight2 mccchannel_1_analyzer_2_array_crystal_array_0_yheight2
#define visualize mccchannel_1_analyzer_2_array_crystal_array_0_visualize
#define target_index mccchannel_1_analyzer_2_array_crystal_array_0_target_index
#define target_x mccchannel_1_analyzer_2_array_crystal_array_0_target_x
#define target_y mccchannel_1_analyzer_2_array_crystal_array_0_target_y
#define target_z mccchannel_1_analyzer_2_array_crystal_array_0_target_z
#define focus_aw mccchannel_1_analyzer_2_array_crystal_array_0_focus_aw
#define focus_ah mccchannel_1_analyzer_2_array_crystal_array_0_focus_ah
#define focus_xw mccchannel_1_analyzer_2_array_crystal_array_0_focus_xw
#define focus_xh mccchannel_1_analyzer_2_array_crystal_array_0_focus_xh
#define focus_r mccchannel_1_analyzer_2_array_crystal_array_0_focus_r
#define p_interact mccchannel_1_analyzer_2_array_crystal_array_0_p_interact
#define mask_string mccchannel_1_analyzer_2_array_crystal_array_0_mask_string
#define mask_setting mccchannel_1_analyzer_2_array_crystal_array_0_mask_setting
#define number_of_activations mccchannel_1_analyzer_2_array_crystal_array_0_number_of_activations
#line 204 "Union_box.comp"
// Needed for transport to the main component
struct global_geometry_element_struct global_geometry_element;

#ifndef ANY_GEOMETRY_DETECTOR_DECLARE
    #define ANY_GEOMETRY_DETECTOR_DECLARE dummy
	//struct pointer_to_global_geometry_list global_geometry_list = {0,NULL};
#endif

int loop_index,found_geometries;

double x_component;
double y_component;
double z_component;

struct Volume_struct this_box_volume;
struct box_storage this_box_storage;

#line 37112 "MACS_sample_kidney_box.c"
#undef number_of_activations
#undef mask_setting
#undef mask_string
#undef p_interact
#undef focus_r
#undef focus_xh
#undef focus_xw
#undef focus_ah
#undef focus_aw
#undef target_z
#undef target_y
#undef target_x
#undef target_index
#undef visualize
#undef yheight2
#undef xwidth2
#undef zdepth
#undef yheight
#undef xwidth
#undef priority
#undef material_string
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

/* User declarations for component 'channel_1_analyzer_2_array_crystal_array_1' [180]. */
#define mccompcurname  channel_1_analyzer_2_array_crystal_array_1
#define mccompcurtype  Union_box
#define mccompcurindex 180
#define loop_index mccchannel_1_analyzer_2_array_crystal_array_1_loop_index
#define this_box_volume mccchannel_1_analyzer_2_array_crystal_array_1_this_box_volume
#define global_geometry_element mccchannel_1_analyzer_2_array_crystal_array_1_global_geometry_element
#define this_box_storage mccchannel_1_analyzer_2_array_crystal_array_1_this_box_storage
#define material_string mccchannel_1_analyzer_2_array_crystal_array_1_material_string
#define priority mccchannel_1_analyzer_2_array_crystal_array_1_priority
#define xwidth mccchannel_1_analyzer_2_array_crystal_array_1_xwidth
#define yheight mccchannel_1_analyzer_2_array_crystal_array_1_yheight
#define zdepth mccchannel_1_analyzer_2_array_crystal_array_1_zdepth
#define xwidth2 mccchannel_1_analyzer_2_array_crystal_array_1_xwidth2
#define yheight2 mccchannel_1_analyzer_2_array_crystal_array_1_yheight2
#define visualize mccchannel_1_analyzer_2_array_crystal_array_1_visualize
#define target_index mccchannel_1_analyzer_2_array_crystal_array_1_target_index
#define target_x mccchannel_1_analyzer_2_array_crystal_array_1_target_x
#define target_y mccchannel_1_analyzer_2_array_crystal_array_1_target_y
#define target_z mccchannel_1_analyzer_2_array_crystal_array_1_target_z
#define focus_aw mccchannel_1_analyzer_2_array_crystal_array_1_focus_aw
#define focus_ah mccchannel_1_analyzer_2_array_crystal_array_1_focus_ah
#define focus_xw mccchannel_1_analyzer_2_array_crystal_array_1_focus_xw
#define focus_xh mccchannel_1_analyzer_2_array_crystal_array_1_focus_xh
#define focus_r mccchannel_1_analyzer_2_array_crystal_array_1_focus_r
#define p_interact mccchannel_1_analyzer_2_array_crystal_array_1_p_interact
#define mask_string mccchannel_1_analyzer_2_array_crystal_array_1_mask_string
#define mask_setting mccchannel_1_analyzer_2_array_crystal_array_1_mask_setting
#define number_of_activations mccchannel_1_analyzer_2_array_crystal_array_1_number_of_activations
#line 204 "Union_box.comp"
// Needed for transport to the main component
struct global_geometry_element_struct global_geometry_element;

#ifndef ANY_GEOMETRY_DETECTOR_DECLARE
    #define ANY_GEOMETRY_DETECTOR_DECLARE dummy
	//struct pointer_to_global_geometry_list global_geometry_list = {0,NULL};
#endif

int loop_index,found_geometries;

double x_component;
double y_component;
double z_component;

struct Volume_struct this_box_volume;
struct box_storage this_box_storage;

#line 37189 "MACS_sample_kidney_box.c"
#undef number_of_activations
#undef mask_setting
#undef mask_string
#undef p_interact
#undef focus_r
#undef focus_xh
#undef focus_xw
#undef focus_ah
#undef focus_aw
#undef target_z
#undef target_y
#undef target_x
#undef target_index
#undef visualize
#undef yheight2
#undef xwidth2
#undef zdepth
#undef yheight
#undef xwidth
#undef priority
#undef material_string
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

/* User declarations for component 'channel_1_analyzer_2_array_crystal_array_2' [181]. */
#define mccompcurname  channel_1_analyzer_2_array_crystal_array_2
#define mccompcurtype  Union_box
#define mccompcurindex 181
#define loop_index mccchannel_1_analyzer_2_array_crystal_array_2_loop_index
#define this_box_volume mccchannel_1_analyzer_2_array_crystal_array_2_this_box_volume
#define global_geometry_element mccchannel_1_analyzer_2_array_crystal_array_2_global_geometry_element
#define this_box_storage mccchannel_1_analyzer_2_array_crystal_array_2_this_box_storage
#define material_string mccchannel_1_analyzer_2_array_crystal_array_2_material_string
#define priority mccchannel_1_analyzer_2_array_crystal_array_2_priority
#define xwidth mccchannel_1_analyzer_2_array_crystal_array_2_xwidth
#define yheight mccchannel_1_analyzer_2_array_crystal_array_2_yheight
#define zdepth mccchannel_1_analyzer_2_array_crystal_array_2_zdepth
#define xwidth2 mccchannel_1_analyzer_2_array_crystal_array_2_xwidth2
#define yheight2 mccchannel_1_analyzer_2_array_crystal_array_2_yheight2
#define visualize mccchannel_1_analyzer_2_array_crystal_array_2_visualize
#define target_index mccchannel_1_analyzer_2_array_crystal_array_2_target_index
#define target_x mccchannel_1_analyzer_2_array_crystal_array_2_target_x
#define target_y mccchannel_1_analyzer_2_array_crystal_array_2_target_y
#define target_z mccchannel_1_analyzer_2_array_crystal_array_2_target_z
#define focus_aw mccchannel_1_analyzer_2_array_crystal_array_2_focus_aw
#define focus_ah mccchannel_1_analyzer_2_array_crystal_array_2_focus_ah
#define focus_xw mccchannel_1_analyzer_2_array_crystal_array_2_focus_xw
#define focus_xh mccchannel_1_analyzer_2_array_crystal_array_2_focus_xh
#define focus_r mccchannel_1_analyzer_2_array_crystal_array_2_focus_r
#define p_interact mccchannel_1_analyzer_2_array_crystal_array_2_p_interact
#define mask_string mccchannel_1_analyzer_2_array_crystal_array_2_mask_string
#define mask_setting mccchannel_1_analyzer_2_array_crystal_array_2_mask_setting
#define number_of_activations mccchannel_1_analyzer_2_array_crystal_array_2_number_of_activations
#line 204 "Union_box.comp"
// Needed for transport to the main component
struct global_geometry_element_struct global_geometry_element;

#ifndef ANY_GEOMETRY_DETECTOR_DECLARE
    #define ANY_GEOMETRY_DETECTOR_DECLARE dummy
	//struct pointer_to_global_geometry_list global_geometry_list = {0,NULL};
#endif

int loop_index,found_geometries;

double x_component;
double y_component;
double z_component;

struct Volume_struct this_box_volume;
struct box_storage this_box_storage;

#line 37266 "MACS_sample_kidney_box.c"
#undef number_of_activations
#undef mask_setting
#undef mask_string
#undef p_interact
#undef focus_r
#undef focus_xh
#undef focus_xw
#undef focus_ah
#undef focus_aw
#undef target_z
#undef target_y
#undef target_x
#undef target_index
#undef visualize
#undef yheight2
#undef xwidth2
#undef zdepth
#undef yheight
#undef xwidth
#undef priority
#undef material_string
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

/* User declarations for component 'channel_1_analyzer_2_array_crystal_array_3' [182]. */
#define mccompcurname  channel_1_analyzer_2_array_crystal_array_3
#define mccompcurtype  Union_box
#define mccompcurindex 182
#define loop_index mccchannel_1_analyzer_2_array_crystal_array_3_loop_index
#define this_box_volume mccchannel_1_analyzer_2_array_crystal_array_3_this_box_volume
#define global_geometry_element mccchannel_1_analyzer_2_array_crystal_array_3_global_geometry_element
#define this_box_storage mccchannel_1_analyzer_2_array_crystal_array_3_this_box_storage
#define material_string mccchannel_1_analyzer_2_array_crystal_array_3_material_string
#define priority mccchannel_1_analyzer_2_array_crystal_array_3_priority
#define xwidth mccchannel_1_analyzer_2_array_crystal_array_3_xwidth
#define yheight mccchannel_1_analyzer_2_array_crystal_array_3_yheight
#define zdepth mccchannel_1_analyzer_2_array_crystal_array_3_zdepth
#define xwidth2 mccchannel_1_analyzer_2_array_crystal_array_3_xwidth2
#define yheight2 mccchannel_1_analyzer_2_array_crystal_array_3_yheight2
#define visualize mccchannel_1_analyzer_2_array_crystal_array_3_visualize
#define target_index mccchannel_1_analyzer_2_array_crystal_array_3_target_index
#define target_x mccchannel_1_analyzer_2_array_crystal_array_3_target_x
#define target_y mccchannel_1_analyzer_2_array_crystal_array_3_target_y
#define target_z mccchannel_1_analyzer_2_array_crystal_array_3_target_z
#define focus_aw mccchannel_1_analyzer_2_array_crystal_array_3_focus_aw
#define focus_ah mccchannel_1_analyzer_2_array_crystal_array_3_focus_ah
#define focus_xw mccchannel_1_analyzer_2_array_crystal_array_3_focus_xw
#define focus_xh mccchannel_1_analyzer_2_array_crystal_array_3_focus_xh
#define focus_r mccchannel_1_analyzer_2_array_crystal_array_3_focus_r
#define p_interact mccchannel_1_analyzer_2_array_crystal_array_3_p_interact
#define mask_string mccchannel_1_analyzer_2_array_crystal_array_3_mask_string
#define mask_setting mccchannel_1_analyzer_2_array_crystal_array_3_mask_setting
#define number_of_activations mccchannel_1_analyzer_2_array_crystal_array_3_number_of_activations
#line 204 "Union_box.comp"
// Needed for transport to the main component
struct global_geometry_element_struct global_geometry_element;

#ifndef ANY_GEOMETRY_DETECTOR_DECLARE
    #define ANY_GEOMETRY_DETECTOR_DECLARE dummy
	//struct pointer_to_global_geometry_list global_geometry_list = {0,NULL};
#endif

int loop_index,found_geometries;

double x_component;
double y_component;
double z_component;

struct Volume_struct this_box_volume;
struct box_storage this_box_storage;

#line 37343 "MACS_sample_kidney_box.c"
#undef number_of_activations
#undef mask_setting
#undef mask_string
#undef p_interact
#undef focus_r
#undef focus_xh
#undef focus_xw
#undef focus_ah
#undef focus_aw
#undef target_z
#undef target_y
#undef target_x
#undef target_index
#undef visualize
#undef yheight2
#undef xwidth2
#undef zdepth
#undef yheight
#undef xwidth
#undef priority
#undef material_string
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

/* User declarations for component 'channel_1_analyzer_2_array_crystal_array_4' [183]. */
#define mccompcurname  channel_1_analyzer_2_array_crystal_array_4
#define mccompcurtype  Union_box
#define mccompcurindex 183
#define loop_index mccchannel_1_analyzer_2_array_crystal_array_4_loop_index
#define this_box_volume mccchannel_1_analyzer_2_array_crystal_array_4_this_box_volume
#define global_geometry_element mccchannel_1_analyzer_2_array_crystal_array_4_global_geometry_element
#define this_box_storage mccchannel_1_analyzer_2_array_crystal_array_4_this_box_storage
#define material_string mccchannel_1_analyzer_2_array_crystal_array_4_material_string
#define priority mccchannel_1_analyzer_2_array_crystal_array_4_priority
#define xwidth mccchannel_1_analyzer_2_array_crystal_array_4_xwidth
#define yheight mccchannel_1_analyzer_2_array_crystal_array_4_yheight
#define zdepth mccchannel_1_analyzer_2_array_crystal_array_4_zdepth
#define xwidth2 mccchannel_1_analyzer_2_array_crystal_array_4_xwidth2
#define yheight2 mccchannel_1_analyzer_2_array_crystal_array_4_yheight2
#define visualize mccchannel_1_analyzer_2_array_crystal_array_4_visualize
#define target_index mccchannel_1_analyzer_2_array_crystal_array_4_target_index
#define target_x mccchannel_1_analyzer_2_array_crystal_array_4_target_x
#define target_y mccchannel_1_analyzer_2_array_crystal_array_4_target_y
#define target_z mccchannel_1_analyzer_2_array_crystal_array_4_target_z
#define focus_aw mccchannel_1_analyzer_2_array_crystal_array_4_focus_aw
#define focus_ah mccchannel_1_analyzer_2_array_crystal_array_4_focus_ah
#define focus_xw mccchannel_1_analyzer_2_array_crystal_array_4_focus_xw
#define focus_xh mccchannel_1_analyzer_2_array_crystal_array_4_focus_xh
#define focus_r mccchannel_1_analyzer_2_array_crystal_array_4_focus_r
#define p_interact mccchannel_1_analyzer_2_array_crystal_array_4_p_interact
#define mask_string mccchannel_1_analyzer_2_array_crystal_array_4_mask_string
#define mask_setting mccchannel_1_analyzer_2_array_crystal_array_4_mask_setting
#define number_of_activations mccchannel_1_analyzer_2_array_crystal_array_4_number_of_activations
#line 204 "Union_box.comp"
// Needed for transport to the main component
struct global_geometry_element_struct global_geometry_element;

#ifndef ANY_GEOMETRY_DETECTOR_DECLARE
    #define ANY_GEOMETRY_DETECTOR_DECLARE dummy
	//struct pointer_to_global_geometry_list global_geometry_list = {0,NULL};
#endif

int loop_index,found_geometries;

double x_component;
double y_component;
double z_component;

struct Volume_struct this_box_volume;
struct box_storage this_box_storage;

#line 37420 "MACS_sample_kidney_box.c"
#undef number_of_activations
#undef mask_setting
#undef mask_string
#undef p_interact
#undef focus_r
#undef focus_xh
#undef focus_xw
#undef focus_ah
#undef focus_aw
#undef target_z
#undef target_y
#undef target_x
#undef target_index
#undef visualize
#undef yheight2
#undef xwidth2
#undef zdepth
#undef yheight
#undef xwidth
#undef priority
#undef material_string
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

/* User declarations for component 'channel_1_analyzer_2_array_crystal_array_5' [184]. */
#define mccompcurname  channel_1_analyzer_2_array_crystal_array_5
#define mccompcurtype  Union_box
#define mccompcurindex 184
#define loop_index mccchannel_1_analyzer_2_array_crystal_array_5_loop_index
#define this_box_volume mccchannel_1_analyzer_2_array_crystal_array_5_this_box_volume
#define global_geometry_element mccchannel_1_analyzer_2_array_crystal_array_5_global_geometry_element
#define this_box_storage mccchannel_1_analyzer_2_array_crystal_array_5_this_box_storage
#define material_string mccchannel_1_analyzer_2_array_crystal_array_5_material_string
#define priority mccchannel_1_analyzer_2_array_crystal_array_5_priority
#define xwidth mccchannel_1_analyzer_2_array_crystal_array_5_xwidth
#define yheight mccchannel_1_analyzer_2_array_crystal_array_5_yheight
#define zdepth mccchannel_1_analyzer_2_array_crystal_array_5_zdepth
#define xwidth2 mccchannel_1_analyzer_2_array_crystal_array_5_xwidth2
#define yheight2 mccchannel_1_analyzer_2_array_crystal_array_5_yheight2
#define visualize mccchannel_1_analyzer_2_array_crystal_array_5_visualize
#define target_index mccchannel_1_analyzer_2_array_crystal_array_5_target_index
#define target_x mccchannel_1_analyzer_2_array_crystal_array_5_target_x
#define target_y mccchannel_1_analyzer_2_array_crystal_array_5_target_y
#define target_z mccchannel_1_analyzer_2_array_crystal_array_5_target_z
#define focus_aw mccchannel_1_analyzer_2_array_crystal_array_5_focus_aw
#define focus_ah mccchannel_1_analyzer_2_array_crystal_array_5_focus_ah
#define focus_xw mccchannel_1_analyzer_2_array_crystal_array_5_focus_xw
#define focus_xh mccchannel_1_analyzer_2_array_crystal_array_5_focus_xh
#define focus_r mccchannel_1_analyzer_2_array_crystal_array_5_focus_r
#define p_interact mccchannel_1_analyzer_2_array_crystal_array_5_p_interact
#define mask_string mccchannel_1_analyzer_2_array_crystal_array_5_mask_string
#define mask_setting mccchannel_1_analyzer_2_array_crystal_array_5_mask_setting
#define number_of_activations mccchannel_1_analyzer_2_array_crystal_array_5_number_of_activations
#line 204 "Union_box.comp"
// Needed for transport to the main component
struct global_geometry_element_struct global_geometry_element;

#ifndef ANY_GEOMETRY_DETECTOR_DECLARE
    #define ANY_GEOMETRY_DETECTOR_DECLARE dummy
	//struct pointer_to_global_geometry_list global_geometry_list = {0,NULL};
#endif

int loop_index,found_geometries;

double x_component;
double y_component;
double z_component;

struct Volume_struct this_box_volume;
struct box_storage this_box_storage;

#line 37497 "MACS_sample_kidney_box.c"
#undef number_of_activations
#undef mask_setting
#undef mask_string
#undef p_interact
#undef focus_r
#undef focus_xh
#undef focus_xw
#undef focus_ah
#undef focus_aw
#undef target_z
#undef target_y
#undef target_x
#undef target_index
#undef visualize
#undef yheight2
#undef xwidth2
#undef zdepth
#undef yheight
#undef xwidth
#undef priority
#undef material_string
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

/* User declarations for component 'channel_1_analyzer_2_array_crystal_array_6' [185]. */
#define mccompcurname  channel_1_analyzer_2_array_crystal_array_6
#define mccompcurtype  Union_box
#define mccompcurindex 185
#define loop_index mccchannel_1_analyzer_2_array_crystal_array_6_loop_index
#define this_box_volume mccchannel_1_analyzer_2_array_crystal_array_6_this_box_volume
#define global_geometry_element mccchannel_1_analyzer_2_array_crystal_array_6_global_geometry_element
#define this_box_storage mccchannel_1_analyzer_2_array_crystal_array_6_this_box_storage
#define material_string mccchannel_1_analyzer_2_array_crystal_array_6_material_string
#define priority mccchannel_1_analyzer_2_array_crystal_array_6_priority
#define xwidth mccchannel_1_analyzer_2_array_crystal_array_6_xwidth
#define yheight mccchannel_1_analyzer_2_array_crystal_array_6_yheight
#define zdepth mccchannel_1_analyzer_2_array_crystal_array_6_zdepth
#define xwidth2 mccchannel_1_analyzer_2_array_crystal_array_6_xwidth2
#define yheight2 mccchannel_1_analyzer_2_array_crystal_array_6_yheight2
#define visualize mccchannel_1_analyzer_2_array_crystal_array_6_visualize
#define target_index mccchannel_1_analyzer_2_array_crystal_array_6_target_index
#define target_x mccchannel_1_analyzer_2_array_crystal_array_6_target_x
#define target_y mccchannel_1_analyzer_2_array_crystal_array_6_target_y
#define target_z mccchannel_1_analyzer_2_array_crystal_array_6_target_z
#define focus_aw mccchannel_1_analyzer_2_array_crystal_array_6_focus_aw
#define focus_ah mccchannel_1_analyzer_2_array_crystal_array_6_focus_ah
#define focus_xw mccchannel_1_analyzer_2_array_crystal_array_6_focus_xw
#define focus_xh mccchannel_1_analyzer_2_array_crystal_array_6_focus_xh
#define focus_r mccchannel_1_analyzer_2_array_crystal_array_6_focus_r
#define p_interact mccchannel_1_analyzer_2_array_crystal_array_6_p_interact
#define mask_string mccchannel_1_analyzer_2_array_crystal_array_6_mask_string
#define mask_setting mccchannel_1_analyzer_2_array_crystal_array_6_mask_setting
#define number_of_activations mccchannel_1_analyzer_2_array_crystal_array_6_number_of_activations
#line 204 "Union_box.comp"
// Needed for transport to the main component
struct global_geometry_element_struct global_geometry_element;

#ifndef ANY_GEOMETRY_DETECTOR_DECLARE
    #define ANY_GEOMETRY_DETECTOR_DECLARE dummy
	//struct pointer_to_global_geometry_list global_geometry_list = {0,NULL};
#endif

int loop_index,found_geometries;

double x_component;
double y_component;
double z_component;

struct Volume_struct this_box_volume;
struct box_storage this_box_storage;

#line 37574 "MACS_sample_kidney_box.c"
#undef number_of_activations
#undef mask_setting
#undef mask_string
#undef p_interact
#undef focus_r
#undef focus_xh
#undef focus_xw
#undef focus_ah
#undef focus_aw
#undef target_z
#undef target_y
#undef target_x
#undef target_index
#undef visualize
#undef yheight2
#undef xwidth2
#undef zdepth
#undef yheight
#undef xwidth
#undef priority
#undef material_string
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

/* User declarations for component 'channel_1_analyzer_2_array_crystal_array_7' [186]. */
#define mccompcurname  channel_1_analyzer_2_array_crystal_array_7
#define mccompcurtype  Union_box
#define mccompcurindex 186
#define loop_index mccchannel_1_analyzer_2_array_crystal_array_7_loop_index
#define this_box_volume mccchannel_1_analyzer_2_array_crystal_array_7_this_box_volume
#define global_geometry_element mccchannel_1_analyzer_2_array_crystal_array_7_global_geometry_element
#define this_box_storage mccchannel_1_analyzer_2_array_crystal_array_7_this_box_storage
#define material_string mccchannel_1_analyzer_2_array_crystal_array_7_material_string
#define priority mccchannel_1_analyzer_2_array_crystal_array_7_priority
#define xwidth mccchannel_1_analyzer_2_array_crystal_array_7_xwidth
#define yheight mccchannel_1_analyzer_2_array_crystal_array_7_yheight
#define zdepth mccchannel_1_analyzer_2_array_crystal_array_7_zdepth
#define xwidth2 mccchannel_1_analyzer_2_array_crystal_array_7_xwidth2
#define yheight2 mccchannel_1_analyzer_2_array_crystal_array_7_yheight2
#define visualize mccchannel_1_analyzer_2_array_crystal_array_7_visualize
#define target_index mccchannel_1_analyzer_2_array_crystal_array_7_target_index
#define target_x mccchannel_1_analyzer_2_array_crystal_array_7_target_x
#define target_y mccchannel_1_analyzer_2_array_crystal_array_7_target_y
#define target_z mccchannel_1_analyzer_2_array_crystal_array_7_target_z
#define focus_aw mccchannel_1_analyzer_2_array_crystal_array_7_focus_aw
#define focus_ah mccchannel_1_analyzer_2_array_crystal_array_7_focus_ah
#define focus_xw mccchannel_1_analyzer_2_array_crystal_array_7_focus_xw
#define focus_xh mccchannel_1_analyzer_2_array_crystal_array_7_focus_xh
#define focus_r mccchannel_1_analyzer_2_array_crystal_array_7_focus_r
#define p_interact mccchannel_1_analyzer_2_array_crystal_array_7_p_interact
#define mask_string mccchannel_1_analyzer_2_array_crystal_array_7_mask_string
#define mask_setting mccchannel_1_analyzer_2_array_crystal_array_7_mask_setting
#define number_of_activations mccchannel_1_analyzer_2_array_crystal_array_7_number_of_activations
#line 204 "Union_box.comp"
// Needed for transport to the main component
struct global_geometry_element_struct global_geometry_element;

#ifndef ANY_GEOMETRY_DETECTOR_DECLARE
    #define ANY_GEOMETRY_DETECTOR_DECLARE dummy
	//struct pointer_to_global_geometry_list global_geometry_list = {0,NULL};
#endif

int loop_index,found_geometries;

double x_component;
double y_component;
double z_component;

struct Volume_struct this_box_volume;
struct box_storage this_box_storage;

#line 37651 "MACS_sample_kidney_box.c"
#undef number_of_activations
#undef mask_setting
#undef mask_string
#undef p_interact
#undef focus_r
#undef focus_xh
#undef focus_xw
#undef focus_ah
#undef focus_aw
#undef target_z
#undef target_y
#undef target_x
#undef target_index
#undef visualize
#undef yheight2
#undef xwidth2
#undef zdepth
#undef yheight
#undef xwidth
#undef priority
#undef material_string
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

/* User declarations for component 'channel_1_analyzer_2_array_crystal_array_8' [187]. */
#define mccompcurname  channel_1_analyzer_2_array_crystal_array_8
#define mccompcurtype  Union_box
#define mccompcurindex 187
#define loop_index mccchannel_1_analyzer_2_array_crystal_array_8_loop_index
#define this_box_volume mccchannel_1_analyzer_2_array_crystal_array_8_this_box_volume
#define global_geometry_element mccchannel_1_analyzer_2_array_crystal_array_8_global_geometry_element
#define this_box_storage mccchannel_1_analyzer_2_array_crystal_array_8_this_box_storage
#define material_string mccchannel_1_analyzer_2_array_crystal_array_8_material_string
#define priority mccchannel_1_analyzer_2_array_crystal_array_8_priority
#define xwidth mccchannel_1_analyzer_2_array_crystal_array_8_xwidth
#define yheight mccchannel_1_analyzer_2_array_crystal_array_8_yheight
#define zdepth mccchannel_1_analyzer_2_array_crystal_array_8_zdepth
#define xwidth2 mccchannel_1_analyzer_2_array_crystal_array_8_xwidth2
#define yheight2 mccchannel_1_analyzer_2_array_crystal_array_8_yheight2
#define visualize mccchannel_1_analyzer_2_array_crystal_array_8_visualize
#define target_index mccchannel_1_analyzer_2_array_crystal_array_8_target_index
#define target_x mccchannel_1_analyzer_2_array_crystal_array_8_target_x
#define target_y mccchannel_1_analyzer_2_array_crystal_array_8_target_y
#define target_z mccchannel_1_analyzer_2_array_crystal_array_8_target_z
#define focus_aw mccchannel_1_analyzer_2_array_crystal_array_8_focus_aw
#define focus_ah mccchannel_1_analyzer_2_array_crystal_array_8_focus_ah
#define focus_xw mccchannel_1_analyzer_2_array_crystal_array_8_focus_xw
#define focus_xh mccchannel_1_analyzer_2_array_crystal_array_8_focus_xh
#define focus_r mccchannel_1_analyzer_2_array_crystal_array_8_focus_r
#define p_interact mccchannel_1_analyzer_2_array_crystal_array_8_p_interact
#define mask_string mccchannel_1_analyzer_2_array_crystal_array_8_mask_string
#define mask_setting mccchannel_1_analyzer_2_array_crystal_array_8_mask_setting
#define number_of_activations mccchannel_1_analyzer_2_array_crystal_array_8_number_of_activations
#line 204 "Union_box.comp"
// Needed for transport to the main component
struct global_geometry_element_struct global_geometry_element;

#ifndef ANY_GEOMETRY_DETECTOR_DECLARE
    #define ANY_GEOMETRY_DETECTOR_DECLARE dummy
	//struct pointer_to_global_geometry_list global_geometry_list = {0,NULL};
#endif

int loop_index,found_geometries;

double x_component;
double y_component;
double z_component;

struct Volume_struct this_box_volume;
struct box_storage this_box_storage;

#line 37728 "MACS_sample_kidney_box.c"
#undef number_of_activations
#undef mask_setting
#undef mask_string
#undef p_interact
#undef focus_r
#undef focus_xh
#undef focus_xw
#undef focus_ah
#undef focus_aw
#undef target_z
#undef target_y
#undef target_x
#undef target_index
#undef visualize
#undef yheight2
#undef xwidth2
#undef zdepth
#undef yheight
#undef xwidth
#undef priority
#undef material_string
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

/* User declarations for component 'channel_1_cave2_cyl1' [188]. */
#define mccompcurname  channel_1_cave2_cyl1
#define mccompcurtype  Union_cylinder
#define mccompcurindex 188
#define loop_index mccchannel_1_cave2_cyl1_loop_index
#define this_cylinder_volume mccchannel_1_cave2_cyl1_this_cylinder_volume
#define global_geometry_element mccchannel_1_cave2_cyl1_global_geometry_element
#define this_cylinder_storage mccchannel_1_cave2_cyl1_this_cylinder_storage
#define material_string mccchannel_1_cave2_cyl1_material_string
#define priority mccchannel_1_cave2_cyl1_priority
#define radius mccchannel_1_cave2_cyl1_radius
#define yheight mccchannel_1_cave2_cyl1_yheight
#define visualize mccchannel_1_cave2_cyl1_visualize
#define target_index mccchannel_1_cave2_cyl1_target_index
#define target_x mccchannel_1_cave2_cyl1_target_x
#define target_y mccchannel_1_cave2_cyl1_target_y
#define target_z mccchannel_1_cave2_cyl1_target_z
#define focus_aw mccchannel_1_cave2_cyl1_focus_aw
#define focus_ah mccchannel_1_cave2_cyl1_focus_ah
#define focus_xw mccchannel_1_cave2_cyl1_focus_xw
#define focus_xh mccchannel_1_cave2_cyl1_focus_xh
#define focus_r mccchannel_1_cave2_cyl1_focus_r
#define p_interact mccchannel_1_cave2_cyl1_p_interact
#define mask_string mccchannel_1_cave2_cyl1_mask_string
#define mask_setting mccchannel_1_cave2_cyl1_mask_setting
#define number_of_activations mccchannel_1_cave2_cyl1_number_of_activations
#line 167 "Union_cylinder.comp"
// Needed for transport to the main component
struct global_geometry_element_struct global_geometry_element;

#ifndef ANY_GEOMETRY_DETECTOR_DECLARE
    #define ANY_GEOMETRY_DETECTOR_DECLARE dummy
	//struct pointer_to_global_geometry_list global_geometry_list = {0,NULL};
#endif

int dummy;
int loop_index,found_geometries;
int loop_2_index;
int material_index;

struct Volume_struct this_cylinder_volume;
struct cylinder_storage this_cylinder_storage;
#line 37800 "MACS_sample_kidney_box.c"
#undef number_of_activations
#undef mask_setting
#undef mask_string
#undef p_interact
#undef focus_r
#undef focus_xh
#undef focus_xw
#undef focus_ah
#undef focus_aw
#undef target_z
#undef target_y
#undef target_x
#undef target_index
#undef visualize
#undef yheight
#undef radius
#undef priority
#undef material_string
#undef this_cylinder_storage
#undef global_geometry_element
#undef this_cylinder_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

/* User declarations for component 'channel_1_cave2_box1' [189]. */
#define mccompcurname  channel_1_cave2_box1
#define mccompcurtype  Union_box
#define mccompcurindex 189
#define loop_index mccchannel_1_cave2_box1_loop_index
#define this_box_volume mccchannel_1_cave2_box1_this_box_volume
#define global_geometry_element mccchannel_1_cave2_box1_global_geometry_element
#define this_box_storage mccchannel_1_cave2_box1_this_box_storage
#define material_string mccchannel_1_cave2_box1_material_string
#define priority mccchannel_1_cave2_box1_priority
#define xwidth mccchannel_1_cave2_box1_xwidth
#define yheight mccchannel_1_cave2_box1_yheight
#define zdepth mccchannel_1_cave2_box1_zdepth
#define xwidth2 mccchannel_1_cave2_box1_xwidth2
#define yheight2 mccchannel_1_cave2_box1_yheight2
#define visualize mccchannel_1_cave2_box1_visualize
#define target_index mccchannel_1_cave2_box1_target_index
#define target_x mccchannel_1_cave2_box1_target_x
#define target_y mccchannel_1_cave2_box1_target_y
#define target_z mccchannel_1_cave2_box1_target_z
#define focus_aw mccchannel_1_cave2_box1_focus_aw
#define focus_ah mccchannel_1_cave2_box1_focus_ah
#define focus_xw mccchannel_1_cave2_box1_focus_xw
#define focus_xh mccchannel_1_cave2_box1_focus_xh
#define focus_r mccchannel_1_cave2_box1_focus_r
#define p_interact mccchannel_1_cave2_box1_p_interact
#define mask_string mccchannel_1_cave2_box1_mask_string
#define mask_setting mccchannel_1_cave2_box1_mask_setting
#define number_of_activations mccchannel_1_cave2_box1_number_of_activations
#line 204 "Union_box.comp"
// Needed for transport to the main component
struct global_geometry_element_struct global_geometry_element;

#ifndef ANY_GEOMETRY_DETECTOR_DECLARE
    #define ANY_GEOMETRY_DETECTOR_DECLARE dummy
	//struct pointer_to_global_geometry_list global_geometry_list = {0,NULL};
#endif

int loop_index,found_geometries;

double x_component;
double y_component;
double z_component;

struct Volume_struct this_box_volume;
struct box_storage this_box_storage;

#line 37874 "MACS_sample_kidney_box.c"
#undef number_of_activations
#undef mask_setting
#undef mask_string
#undef p_interact
#undef focus_r
#undef focus_xh
#undef focus_xw
#undef focus_ah
#undef focus_aw
#undef target_z
#undef target_y
#undef target_x
#undef target_index
#undef visualize
#undef yheight2
#undef xwidth2
#undef zdepth
#undef yheight
#undef xwidth
#undef priority
#undef material_string
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

/* User declarations for component 'channel_1_cave2_box2' [190]. */
#define mccompcurname  channel_1_cave2_box2
#define mccompcurtype  Union_box
#define mccompcurindex 190
#define loop_index mccchannel_1_cave2_box2_loop_index
#define this_box_volume mccchannel_1_cave2_box2_this_box_volume
#define global_geometry_element mccchannel_1_cave2_box2_global_geometry_element
#define this_box_storage mccchannel_1_cave2_box2_this_box_storage
#define material_string mccchannel_1_cave2_box2_material_string
#define priority mccchannel_1_cave2_box2_priority
#define xwidth mccchannel_1_cave2_box2_xwidth
#define yheight mccchannel_1_cave2_box2_yheight
#define zdepth mccchannel_1_cave2_box2_zdepth
#define xwidth2 mccchannel_1_cave2_box2_xwidth2
#define yheight2 mccchannel_1_cave2_box2_yheight2
#define visualize mccchannel_1_cave2_box2_visualize
#define target_index mccchannel_1_cave2_box2_target_index
#define target_x mccchannel_1_cave2_box2_target_x
#define target_y mccchannel_1_cave2_box2_target_y
#define target_z mccchannel_1_cave2_box2_target_z
#define focus_aw mccchannel_1_cave2_box2_focus_aw
#define focus_ah mccchannel_1_cave2_box2_focus_ah
#define focus_xw mccchannel_1_cave2_box2_focus_xw
#define focus_xh mccchannel_1_cave2_box2_focus_xh
#define focus_r mccchannel_1_cave2_box2_focus_r
#define p_interact mccchannel_1_cave2_box2_p_interact
#define mask_string mccchannel_1_cave2_box2_mask_string
#define mask_setting mccchannel_1_cave2_box2_mask_setting
#define number_of_activations mccchannel_1_cave2_box2_number_of_activations
#line 204 "Union_box.comp"
// Needed for transport to the main component
struct global_geometry_element_struct global_geometry_element;

#ifndef ANY_GEOMETRY_DETECTOR_DECLARE
    #define ANY_GEOMETRY_DETECTOR_DECLARE dummy
	//struct pointer_to_global_geometry_list global_geometry_list = {0,NULL};
#endif

int loop_index,found_geometries;

double x_component;
double y_component;
double z_component;

struct Volume_struct this_box_volume;
struct box_storage this_box_storage;

#line 37951 "MACS_sample_kidney_box.c"
#undef number_of_activations
#undef mask_setting
#undef mask_string
#undef p_interact
#undef focus_r
#undef focus_xh
#undef focus_xw
#undef focus_ah
#undef focus_aw
#undef target_z
#undef target_y
#undef target_x
#undef target_index
#undef visualize
#undef yheight2
#undef xwidth2
#undef zdepth
#undef yheight
#undef xwidth
#undef priority
#undef material_string
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

/* User declarations for component 'channel_1_cave2_box3' [191]. */
#define mccompcurname  channel_1_cave2_box3
#define mccompcurtype  Union_box
#define mccompcurindex 191
#define loop_index mccchannel_1_cave2_box3_loop_index
#define this_box_volume mccchannel_1_cave2_box3_this_box_volume
#define global_geometry_element mccchannel_1_cave2_box3_global_geometry_element
#define this_box_storage mccchannel_1_cave2_box3_this_box_storage
#define material_string mccchannel_1_cave2_box3_material_string
#define priority mccchannel_1_cave2_box3_priority
#define xwidth mccchannel_1_cave2_box3_xwidth
#define yheight mccchannel_1_cave2_box3_yheight
#define zdepth mccchannel_1_cave2_box3_zdepth
#define xwidth2 mccchannel_1_cave2_box3_xwidth2
#define yheight2 mccchannel_1_cave2_box3_yheight2
#define visualize mccchannel_1_cave2_box3_visualize
#define target_index mccchannel_1_cave2_box3_target_index
#define target_x mccchannel_1_cave2_box3_target_x
#define target_y mccchannel_1_cave2_box3_target_y
#define target_z mccchannel_1_cave2_box3_target_z
#define focus_aw mccchannel_1_cave2_box3_focus_aw
#define focus_ah mccchannel_1_cave2_box3_focus_ah
#define focus_xw mccchannel_1_cave2_box3_focus_xw
#define focus_xh mccchannel_1_cave2_box3_focus_xh
#define focus_r mccchannel_1_cave2_box3_focus_r
#define p_interact mccchannel_1_cave2_box3_p_interact
#define mask_string mccchannel_1_cave2_box3_mask_string
#define mask_setting mccchannel_1_cave2_box3_mask_setting
#define number_of_activations mccchannel_1_cave2_box3_number_of_activations
#line 204 "Union_box.comp"
// Needed for transport to the main component
struct global_geometry_element_struct global_geometry_element;

#ifndef ANY_GEOMETRY_DETECTOR_DECLARE
    #define ANY_GEOMETRY_DETECTOR_DECLARE dummy
	//struct pointer_to_global_geometry_list global_geometry_list = {0,NULL};
#endif

int loop_index,found_geometries;

double x_component;
double y_component;
double z_component;

struct Volume_struct this_box_volume;
struct box_storage this_box_storage;

#line 38028 "MACS_sample_kidney_box.c"
#undef number_of_activations
#undef mask_setting
#undef mask_string
#undef p_interact
#undef focus_r
#undef focus_xh
#undef focus_xw
#undef focus_ah
#undef focus_aw
#undef target_z
#undef target_y
#undef target_x
#undef target_index
#undef visualize
#undef yheight2
#undef xwidth2
#undef zdepth
#undef yheight
#undef xwidth
#undef priority
#undef material_string
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

/* User declarations for component 'inter_analyzer_colimator_center_1' [192]. */
#define mccompcurname  inter_analyzer_colimator_center_1
#define mccompcurtype  Arm
#define mccompcurindex 192
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

/* User declarations for component 'inter_analyzer_colimator_1_blade_0' [193]. */
#define mccompcurname  inter_analyzer_colimator_1_blade_0
#define mccompcurtype  Union_box
#define mccompcurindex 193
#define loop_index mccinter_analyzer_colimator_1_blade_0_loop_index
#define this_box_volume mccinter_analyzer_colimator_1_blade_0_this_box_volume
#define global_geometry_element mccinter_analyzer_colimator_1_blade_0_global_geometry_element
#define this_box_storage mccinter_analyzer_colimator_1_blade_0_this_box_storage
#define material_string mccinter_analyzer_colimator_1_blade_0_material_string
#define priority mccinter_analyzer_colimator_1_blade_0_priority
#define xwidth mccinter_analyzer_colimator_1_blade_0_xwidth
#define yheight mccinter_analyzer_colimator_1_blade_0_yheight
#define zdepth mccinter_analyzer_colimator_1_blade_0_zdepth
#define xwidth2 mccinter_analyzer_colimator_1_blade_0_xwidth2
#define yheight2 mccinter_analyzer_colimator_1_blade_0_yheight2
#define visualize mccinter_analyzer_colimator_1_blade_0_visualize
#define target_index mccinter_analyzer_colimator_1_blade_0_target_index
#define target_x mccinter_analyzer_colimator_1_blade_0_target_x
#define target_y mccinter_analyzer_colimator_1_blade_0_target_y
#define target_z mccinter_analyzer_colimator_1_blade_0_target_z
#define focus_aw mccinter_analyzer_colimator_1_blade_0_focus_aw
#define focus_ah mccinter_analyzer_colimator_1_blade_0_focus_ah
#define focus_xw mccinter_analyzer_colimator_1_blade_0_focus_xw
#define focus_xh mccinter_analyzer_colimator_1_blade_0_focus_xh
#define focus_r mccinter_analyzer_colimator_1_blade_0_focus_r
#define p_interact mccinter_analyzer_colimator_1_blade_0_p_interact
#define mask_string mccinter_analyzer_colimator_1_blade_0_mask_string
#define mask_setting mccinter_analyzer_colimator_1_blade_0_mask_setting
#define number_of_activations mccinter_analyzer_colimator_1_blade_0_number_of_activations
#line 204 "Union_box.comp"
// Needed for transport to the main component
struct global_geometry_element_struct global_geometry_element;

#ifndef ANY_GEOMETRY_DETECTOR_DECLARE
    #define ANY_GEOMETRY_DETECTOR_DECLARE dummy
	//struct pointer_to_global_geometry_list global_geometry_list = {0,NULL};
#endif

int loop_index,found_geometries;

double x_component;
double y_component;
double z_component;

struct Volume_struct this_box_volume;
struct box_storage this_box_storage;

#line 38113 "MACS_sample_kidney_box.c"
#undef number_of_activations
#undef mask_setting
#undef mask_string
#undef p_interact
#undef focus_r
#undef focus_xh
#undef focus_xw
#undef focus_ah
#undef focus_aw
#undef target_z
#undef target_y
#undef target_x
#undef target_index
#undef visualize
#undef yheight2
#undef xwidth2
#undef zdepth
#undef yheight
#undef xwidth
#undef priority
#undef material_string
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

/* User declarations for component 'inter_analyzer_colimator_1_blade_1' [194]. */
#define mccompcurname  inter_analyzer_colimator_1_blade_1
#define mccompcurtype  Union_box
#define mccompcurindex 194
#define loop_index mccinter_analyzer_colimator_1_blade_1_loop_index
#define this_box_volume mccinter_analyzer_colimator_1_blade_1_this_box_volume
#define global_geometry_element mccinter_analyzer_colimator_1_blade_1_global_geometry_element
#define this_box_storage mccinter_analyzer_colimator_1_blade_1_this_box_storage
#define material_string mccinter_analyzer_colimator_1_blade_1_material_string
#define priority mccinter_analyzer_colimator_1_blade_1_priority
#define xwidth mccinter_analyzer_colimator_1_blade_1_xwidth
#define yheight mccinter_analyzer_colimator_1_blade_1_yheight
#define zdepth mccinter_analyzer_colimator_1_blade_1_zdepth
#define xwidth2 mccinter_analyzer_colimator_1_blade_1_xwidth2
#define yheight2 mccinter_analyzer_colimator_1_blade_1_yheight2
#define visualize mccinter_analyzer_colimator_1_blade_1_visualize
#define target_index mccinter_analyzer_colimator_1_blade_1_target_index
#define target_x mccinter_analyzer_colimator_1_blade_1_target_x
#define target_y mccinter_analyzer_colimator_1_blade_1_target_y
#define target_z mccinter_analyzer_colimator_1_blade_1_target_z
#define focus_aw mccinter_analyzer_colimator_1_blade_1_focus_aw
#define focus_ah mccinter_analyzer_colimator_1_blade_1_focus_ah
#define focus_xw mccinter_analyzer_colimator_1_blade_1_focus_xw
#define focus_xh mccinter_analyzer_colimator_1_blade_1_focus_xh
#define focus_r mccinter_analyzer_colimator_1_blade_1_focus_r
#define p_interact mccinter_analyzer_colimator_1_blade_1_p_interact
#define mask_string mccinter_analyzer_colimator_1_blade_1_mask_string
#define mask_setting mccinter_analyzer_colimator_1_blade_1_mask_setting
#define number_of_activations mccinter_analyzer_colimator_1_blade_1_number_of_activations
#line 204 "Union_box.comp"
// Needed for transport to the main component
struct global_geometry_element_struct global_geometry_element;

#ifndef ANY_GEOMETRY_DETECTOR_DECLARE
    #define ANY_GEOMETRY_DETECTOR_DECLARE dummy
	//struct pointer_to_global_geometry_list global_geometry_list = {0,NULL};
#endif

int loop_index,found_geometries;

double x_component;
double y_component;
double z_component;

struct Volume_struct this_box_volume;
struct box_storage this_box_storage;

#line 38190 "MACS_sample_kidney_box.c"
#undef number_of_activations
#undef mask_setting
#undef mask_string
#undef p_interact
#undef focus_r
#undef focus_xh
#undef focus_xw
#undef focus_ah
#undef focus_aw
#undef target_z
#undef target_y
#undef target_x
#undef target_index
#undef visualize
#undef yheight2
#undef xwidth2
#undef zdepth
#undef yheight
#undef xwidth
#undef priority
#undef material_string
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

/* User declarations for component 'inter_analyzer_colimator_1_blade_2' [195]. */
#define mccompcurname  inter_analyzer_colimator_1_blade_2
#define mccompcurtype  Union_box
#define mccompcurindex 195
#define loop_index mccinter_analyzer_colimator_1_blade_2_loop_index
#define this_box_volume mccinter_analyzer_colimator_1_blade_2_this_box_volume
#define global_geometry_element mccinter_analyzer_colimator_1_blade_2_global_geometry_element
#define this_box_storage mccinter_analyzer_colimator_1_blade_2_this_box_storage
#define material_string mccinter_analyzer_colimator_1_blade_2_material_string
#define priority mccinter_analyzer_colimator_1_blade_2_priority
#define xwidth mccinter_analyzer_colimator_1_blade_2_xwidth
#define yheight mccinter_analyzer_colimator_1_blade_2_yheight
#define zdepth mccinter_analyzer_colimator_1_blade_2_zdepth
#define xwidth2 mccinter_analyzer_colimator_1_blade_2_xwidth2
#define yheight2 mccinter_analyzer_colimator_1_blade_2_yheight2
#define visualize mccinter_analyzer_colimator_1_blade_2_visualize
#define target_index mccinter_analyzer_colimator_1_blade_2_target_index
#define target_x mccinter_analyzer_colimator_1_blade_2_target_x
#define target_y mccinter_analyzer_colimator_1_blade_2_target_y
#define target_z mccinter_analyzer_colimator_1_blade_2_target_z
#define focus_aw mccinter_analyzer_colimator_1_blade_2_focus_aw
#define focus_ah mccinter_analyzer_colimator_1_blade_2_focus_ah
#define focus_xw mccinter_analyzer_colimator_1_blade_2_focus_xw
#define focus_xh mccinter_analyzer_colimator_1_blade_2_focus_xh
#define focus_r mccinter_analyzer_colimator_1_blade_2_focus_r
#define p_interact mccinter_analyzer_colimator_1_blade_2_p_interact
#define mask_string mccinter_analyzer_colimator_1_blade_2_mask_string
#define mask_setting mccinter_analyzer_colimator_1_blade_2_mask_setting
#define number_of_activations mccinter_analyzer_colimator_1_blade_2_number_of_activations
#line 204 "Union_box.comp"
// Needed for transport to the main component
struct global_geometry_element_struct global_geometry_element;

#ifndef ANY_GEOMETRY_DETECTOR_DECLARE
    #define ANY_GEOMETRY_DETECTOR_DECLARE dummy
	//struct pointer_to_global_geometry_list global_geometry_list = {0,NULL};
#endif

int loop_index,found_geometries;

double x_component;
double y_component;
double z_component;

struct Volume_struct this_box_volume;
struct box_storage this_box_storage;

#line 38267 "MACS_sample_kidney_box.c"
#undef number_of_activations
#undef mask_setting
#undef mask_string
#undef p_interact
#undef focus_r
#undef focus_xh
#undef focus_xw
#undef focus_ah
#undef focus_aw
#undef target_z
#undef target_y
#undef target_x
#undef target_index
#undef visualize
#undef yheight2
#undef xwidth2
#undef zdepth
#undef yheight
#undef xwidth
#undef priority
#undef material_string
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

/* User declarations for component 'inter_analyzer_colimator_1_blade_3' [196]. */
#define mccompcurname  inter_analyzer_colimator_1_blade_3
#define mccompcurtype  Union_box
#define mccompcurindex 196
#define loop_index mccinter_analyzer_colimator_1_blade_3_loop_index
#define this_box_volume mccinter_analyzer_colimator_1_blade_3_this_box_volume
#define global_geometry_element mccinter_analyzer_colimator_1_blade_3_global_geometry_element
#define this_box_storage mccinter_analyzer_colimator_1_blade_3_this_box_storage
#define material_string mccinter_analyzer_colimator_1_blade_3_material_string
#define priority mccinter_analyzer_colimator_1_blade_3_priority
#define xwidth mccinter_analyzer_colimator_1_blade_3_xwidth
#define yheight mccinter_analyzer_colimator_1_blade_3_yheight
#define zdepth mccinter_analyzer_colimator_1_blade_3_zdepth
#define xwidth2 mccinter_analyzer_colimator_1_blade_3_xwidth2
#define yheight2 mccinter_analyzer_colimator_1_blade_3_yheight2
#define visualize mccinter_analyzer_colimator_1_blade_3_visualize
#define target_index mccinter_analyzer_colimator_1_blade_3_target_index
#define target_x mccinter_analyzer_colimator_1_blade_3_target_x
#define target_y mccinter_analyzer_colimator_1_blade_3_target_y
#define target_z mccinter_analyzer_colimator_1_blade_3_target_z
#define focus_aw mccinter_analyzer_colimator_1_blade_3_focus_aw
#define focus_ah mccinter_analyzer_colimator_1_blade_3_focus_ah
#define focus_xw mccinter_analyzer_colimator_1_blade_3_focus_xw
#define focus_xh mccinter_analyzer_colimator_1_blade_3_focus_xh
#define focus_r mccinter_analyzer_colimator_1_blade_3_focus_r
#define p_interact mccinter_analyzer_colimator_1_blade_3_p_interact
#define mask_string mccinter_analyzer_colimator_1_blade_3_mask_string
#define mask_setting mccinter_analyzer_colimator_1_blade_3_mask_setting
#define number_of_activations mccinter_analyzer_colimator_1_blade_3_number_of_activations
#line 204 "Union_box.comp"
// Needed for transport to the main component
struct global_geometry_element_struct global_geometry_element;

#ifndef ANY_GEOMETRY_DETECTOR_DECLARE
    #define ANY_GEOMETRY_DETECTOR_DECLARE dummy
	//struct pointer_to_global_geometry_list global_geometry_list = {0,NULL};
#endif

int loop_index,found_geometries;

double x_component;
double y_component;
double z_component;

struct Volume_struct this_box_volume;
struct box_storage this_box_storage;

#line 38344 "MACS_sample_kidney_box.c"
#undef number_of_activations
#undef mask_setting
#undef mask_string
#undef p_interact
#undef focus_r
#undef focus_xh
#undef focus_xw
#undef focus_ah
#undef focus_aw
#undef target_z
#undef target_y
#undef target_x
#undef target_index
#undef visualize
#undef yheight2
#undef xwidth2
#undef zdepth
#undef yheight
#undef xwidth
#undef priority
#undef material_string
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

/* User declarations for component 'inter_analyzer_colimator_1_blade_4' [197]. */
#define mccompcurname  inter_analyzer_colimator_1_blade_4
#define mccompcurtype  Union_box
#define mccompcurindex 197
#define loop_index mccinter_analyzer_colimator_1_blade_4_loop_index
#define this_box_volume mccinter_analyzer_colimator_1_blade_4_this_box_volume
#define global_geometry_element mccinter_analyzer_colimator_1_blade_4_global_geometry_element
#define this_box_storage mccinter_analyzer_colimator_1_blade_4_this_box_storage
#define material_string mccinter_analyzer_colimator_1_blade_4_material_string
#define priority mccinter_analyzer_colimator_1_blade_4_priority
#define xwidth mccinter_analyzer_colimator_1_blade_4_xwidth
#define yheight mccinter_analyzer_colimator_1_blade_4_yheight
#define zdepth mccinter_analyzer_colimator_1_blade_4_zdepth
#define xwidth2 mccinter_analyzer_colimator_1_blade_4_xwidth2
#define yheight2 mccinter_analyzer_colimator_1_blade_4_yheight2
#define visualize mccinter_analyzer_colimator_1_blade_4_visualize
#define target_index mccinter_analyzer_colimator_1_blade_4_target_index
#define target_x mccinter_analyzer_colimator_1_blade_4_target_x
#define target_y mccinter_analyzer_colimator_1_blade_4_target_y
#define target_z mccinter_analyzer_colimator_1_blade_4_target_z
#define focus_aw mccinter_analyzer_colimator_1_blade_4_focus_aw
#define focus_ah mccinter_analyzer_colimator_1_blade_4_focus_ah
#define focus_xw mccinter_analyzer_colimator_1_blade_4_focus_xw
#define focus_xh mccinter_analyzer_colimator_1_blade_4_focus_xh
#define focus_r mccinter_analyzer_colimator_1_blade_4_focus_r
#define p_interact mccinter_analyzer_colimator_1_blade_4_p_interact
#define mask_string mccinter_analyzer_colimator_1_blade_4_mask_string
#define mask_setting mccinter_analyzer_colimator_1_blade_4_mask_setting
#define number_of_activations mccinter_analyzer_colimator_1_blade_4_number_of_activations
#line 204 "Union_box.comp"
// Needed for transport to the main component
struct global_geometry_element_struct global_geometry_element;

#ifndef ANY_GEOMETRY_DETECTOR_DECLARE
    #define ANY_GEOMETRY_DETECTOR_DECLARE dummy
	//struct pointer_to_global_geometry_list global_geometry_list = {0,NULL};
#endif

int loop_index,found_geometries;

double x_component;
double y_component;
double z_component;

struct Volume_struct this_box_volume;
struct box_storage this_box_storage;

#line 38421 "MACS_sample_kidney_box.c"
#undef number_of_activations
#undef mask_setting
#undef mask_string
#undef p_interact
#undef focus_r
#undef focus_xh
#undef focus_xw
#undef focus_ah
#undef focus_aw
#undef target_z
#undef target_y
#undef target_x
#undef target_index
#undef visualize
#undef yheight2
#undef xwidth2
#undef zdepth
#undef yheight
#undef xwidth
#undef priority
#undef material_string
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

/* User declarations for component 'diffraction_detector_1_exit_volume' [198]. */
#define mccompcurname  diffraction_detector_1_exit_volume
#define mccompcurtype  Union_box
#define mccompcurindex 198
#define loop_index mccdiffraction_detector_1_exit_volume_loop_index
#define this_box_volume mccdiffraction_detector_1_exit_volume_this_box_volume
#define global_geometry_element mccdiffraction_detector_1_exit_volume_global_geometry_element
#define this_box_storage mccdiffraction_detector_1_exit_volume_this_box_storage
#define material_string mccdiffraction_detector_1_exit_volume_material_string
#define priority mccdiffraction_detector_1_exit_volume_priority
#define xwidth mccdiffraction_detector_1_exit_volume_xwidth
#define yheight mccdiffraction_detector_1_exit_volume_yheight
#define zdepth mccdiffraction_detector_1_exit_volume_zdepth
#define xwidth2 mccdiffraction_detector_1_exit_volume_xwidth2
#define yheight2 mccdiffraction_detector_1_exit_volume_yheight2
#define visualize mccdiffraction_detector_1_exit_volume_visualize
#define target_index mccdiffraction_detector_1_exit_volume_target_index
#define target_x mccdiffraction_detector_1_exit_volume_target_x
#define target_y mccdiffraction_detector_1_exit_volume_target_y
#define target_z mccdiffraction_detector_1_exit_volume_target_z
#define focus_aw mccdiffraction_detector_1_exit_volume_focus_aw
#define focus_ah mccdiffraction_detector_1_exit_volume_focus_ah
#define focus_xw mccdiffraction_detector_1_exit_volume_focus_xw
#define focus_xh mccdiffraction_detector_1_exit_volume_focus_xh
#define focus_r mccdiffraction_detector_1_exit_volume_focus_r
#define p_interact mccdiffraction_detector_1_exit_volume_p_interact
#define mask_string mccdiffraction_detector_1_exit_volume_mask_string
#define mask_setting mccdiffraction_detector_1_exit_volume_mask_setting
#define number_of_activations mccdiffraction_detector_1_exit_volume_number_of_activations
#line 204 "Union_box.comp"
// Needed for transport to the main component
struct global_geometry_element_struct global_geometry_element;

#ifndef ANY_GEOMETRY_DETECTOR_DECLARE
    #define ANY_GEOMETRY_DETECTOR_DECLARE dummy
	//struct pointer_to_global_geometry_list global_geometry_list = {0,NULL};
#endif

int loop_index,found_geometries;

double x_component;
double y_component;
double z_component;

struct Volume_struct this_box_volume;
struct box_storage this_box_storage;

#line 38498 "MACS_sample_kidney_box.c"
#undef number_of_activations
#undef mask_setting
#undef mask_string
#undef p_interact
#undef focus_r
#undef focus_xh
#undef focus_xw
#undef focus_ah
#undef focus_aw
#undef target_z
#undef target_y
#undef target_x
#undef target_index
#undef visualize
#undef yheight2
#undef xwidth2
#undef zdepth
#undef yheight
#undef xwidth
#undef priority
#undef material_string
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

/* User declarations for component 'spec_detector_1_exit_volume' [199]. */
#define mccompcurname  spec_detector_1_exit_volume
#define mccompcurtype  Union_box
#define mccompcurindex 199
#define loop_index mccspec_detector_1_exit_volume_loop_index
#define this_box_volume mccspec_detector_1_exit_volume_this_box_volume
#define global_geometry_element mccspec_detector_1_exit_volume_global_geometry_element
#define this_box_storage mccspec_detector_1_exit_volume_this_box_storage
#define material_string mccspec_detector_1_exit_volume_material_string
#define priority mccspec_detector_1_exit_volume_priority
#define xwidth mccspec_detector_1_exit_volume_xwidth
#define yheight mccspec_detector_1_exit_volume_yheight
#define zdepth mccspec_detector_1_exit_volume_zdepth
#define xwidth2 mccspec_detector_1_exit_volume_xwidth2
#define yheight2 mccspec_detector_1_exit_volume_yheight2
#define visualize mccspec_detector_1_exit_volume_visualize
#define target_index mccspec_detector_1_exit_volume_target_index
#define target_x mccspec_detector_1_exit_volume_target_x
#define target_y mccspec_detector_1_exit_volume_target_y
#define target_z mccspec_detector_1_exit_volume_target_z
#define focus_aw mccspec_detector_1_exit_volume_focus_aw
#define focus_ah mccspec_detector_1_exit_volume_focus_ah
#define focus_xw mccspec_detector_1_exit_volume_focus_xw
#define focus_xh mccspec_detector_1_exit_volume_focus_xh
#define focus_r mccspec_detector_1_exit_volume_focus_r
#define p_interact mccspec_detector_1_exit_volume_p_interact
#define mask_string mccspec_detector_1_exit_volume_mask_string
#define mask_setting mccspec_detector_1_exit_volume_mask_setting
#define number_of_activations mccspec_detector_1_exit_volume_number_of_activations
#line 204 "Union_box.comp"
// Needed for transport to the main component
struct global_geometry_element_struct global_geometry_element;

#ifndef ANY_GEOMETRY_DETECTOR_DECLARE
    #define ANY_GEOMETRY_DETECTOR_DECLARE dummy
	//struct pointer_to_global_geometry_list global_geometry_list = {0,NULL};
#endif

int loop_index,found_geometries;

double x_component;
double y_component;
double z_component;

struct Volume_struct this_box_volume;
struct box_storage this_box_storage;

#line 38575 "MACS_sample_kidney_box.c"
#undef number_of_activations
#undef mask_setting
#undef mask_string
#undef p_interact
#undef focus_r
#undef focus_xh
#undef focus_xw
#undef focus_ah
#undef focus_aw
#undef target_z
#undef target_y
#undef target_x
#undef target_index
#undef visualize
#undef yheight2
#undef xwidth2
#undef zdepth
#undef yheight
#undef xwidth
#undef priority
#undef material_string
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

/* User declarations for component 'channel_2_cave1_box1' [200]. */
#define mccompcurname  channel_2_cave1_box1
#define mccompcurtype  Union_box
#define mccompcurindex 200
#define loop_index mccchannel_2_cave1_box1_loop_index
#define this_box_volume mccchannel_2_cave1_box1_this_box_volume
#define global_geometry_element mccchannel_2_cave1_box1_global_geometry_element
#define this_box_storage mccchannel_2_cave1_box1_this_box_storage
#define material_string mccchannel_2_cave1_box1_material_string
#define priority mccchannel_2_cave1_box1_priority
#define xwidth mccchannel_2_cave1_box1_xwidth
#define yheight mccchannel_2_cave1_box1_yheight
#define zdepth mccchannel_2_cave1_box1_zdepth
#define xwidth2 mccchannel_2_cave1_box1_xwidth2
#define yheight2 mccchannel_2_cave1_box1_yheight2
#define visualize mccchannel_2_cave1_box1_visualize
#define target_index mccchannel_2_cave1_box1_target_index
#define target_x mccchannel_2_cave1_box1_target_x
#define target_y mccchannel_2_cave1_box1_target_y
#define target_z mccchannel_2_cave1_box1_target_z
#define focus_aw mccchannel_2_cave1_box1_focus_aw
#define focus_ah mccchannel_2_cave1_box1_focus_ah
#define focus_xw mccchannel_2_cave1_box1_focus_xw
#define focus_xh mccchannel_2_cave1_box1_focus_xh
#define focus_r mccchannel_2_cave1_box1_focus_r
#define p_interact mccchannel_2_cave1_box1_p_interact
#define mask_string mccchannel_2_cave1_box1_mask_string
#define mask_setting mccchannel_2_cave1_box1_mask_setting
#define number_of_activations mccchannel_2_cave1_box1_number_of_activations
#line 204 "Union_box.comp"
// Needed for transport to the main component
struct global_geometry_element_struct global_geometry_element;

#ifndef ANY_GEOMETRY_DETECTOR_DECLARE
    #define ANY_GEOMETRY_DETECTOR_DECLARE dummy
	//struct pointer_to_global_geometry_list global_geometry_list = {0,NULL};
#endif

int loop_index,found_geometries;

double x_component;
double y_component;
double z_component;

struct Volume_struct this_box_volume;
struct box_storage this_box_storage;

#line 38652 "MACS_sample_kidney_box.c"
#undef number_of_activations
#undef mask_setting
#undef mask_string
#undef p_interact
#undef focus_r
#undef focus_xh
#undef focus_xw
#undef focus_ah
#undef focus_aw
#undef target_z
#undef target_y
#undef target_x
#undef target_index
#undef visualize
#undef yheight2
#undef xwidth2
#undef zdepth
#undef yheight
#undef xwidth
#undef priority
#undef material_string
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

/* User declarations for component 'channel_2_cave1_box2' [201]. */
#define mccompcurname  channel_2_cave1_box2
#define mccompcurtype  Union_box
#define mccompcurindex 201
#define loop_index mccchannel_2_cave1_box2_loop_index
#define this_box_volume mccchannel_2_cave1_box2_this_box_volume
#define global_geometry_element mccchannel_2_cave1_box2_global_geometry_element
#define this_box_storage mccchannel_2_cave1_box2_this_box_storage
#define material_string mccchannel_2_cave1_box2_material_string
#define priority mccchannel_2_cave1_box2_priority
#define xwidth mccchannel_2_cave1_box2_xwidth
#define yheight mccchannel_2_cave1_box2_yheight
#define zdepth mccchannel_2_cave1_box2_zdepth
#define xwidth2 mccchannel_2_cave1_box2_xwidth2
#define yheight2 mccchannel_2_cave1_box2_yheight2
#define visualize mccchannel_2_cave1_box2_visualize
#define target_index mccchannel_2_cave1_box2_target_index
#define target_x mccchannel_2_cave1_box2_target_x
#define target_y mccchannel_2_cave1_box2_target_y
#define target_z mccchannel_2_cave1_box2_target_z
#define focus_aw mccchannel_2_cave1_box2_focus_aw
#define focus_ah mccchannel_2_cave1_box2_focus_ah
#define focus_xw mccchannel_2_cave1_box2_focus_xw
#define focus_xh mccchannel_2_cave1_box2_focus_xh
#define focus_r mccchannel_2_cave1_box2_focus_r
#define p_interact mccchannel_2_cave1_box2_p_interact
#define mask_string mccchannel_2_cave1_box2_mask_string
#define mask_setting mccchannel_2_cave1_box2_mask_setting
#define number_of_activations mccchannel_2_cave1_box2_number_of_activations
#line 204 "Union_box.comp"
// Needed for transport to the main component
struct global_geometry_element_struct global_geometry_element;

#ifndef ANY_GEOMETRY_DETECTOR_DECLARE
    #define ANY_GEOMETRY_DETECTOR_DECLARE dummy
	//struct pointer_to_global_geometry_list global_geometry_list = {0,NULL};
#endif

int loop_index,found_geometries;

double x_component;
double y_component;
double z_component;

struct Volume_struct this_box_volume;
struct box_storage this_box_storage;

#line 38729 "MACS_sample_kidney_box.c"
#undef number_of_activations
#undef mask_setting
#undef mask_string
#undef p_interact
#undef focus_r
#undef focus_xh
#undef focus_xw
#undef focus_ah
#undef focus_aw
#undef target_z
#undef target_y
#undef target_x
#undef target_index
#undef visualize
#undef yheight2
#undef xwidth2
#undef zdepth
#undef yheight
#undef xwidth
#undef priority
#undef material_string
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

/* User declarations for component 'channel_2_cave1_box3' [202]. */
#define mccompcurname  channel_2_cave1_box3
#define mccompcurtype  Union_box
#define mccompcurindex 202
#define loop_index mccchannel_2_cave1_box3_loop_index
#define this_box_volume mccchannel_2_cave1_box3_this_box_volume
#define global_geometry_element mccchannel_2_cave1_box3_global_geometry_element
#define this_box_storage mccchannel_2_cave1_box3_this_box_storage
#define material_string mccchannel_2_cave1_box3_material_string
#define priority mccchannel_2_cave1_box3_priority
#define xwidth mccchannel_2_cave1_box3_xwidth
#define yheight mccchannel_2_cave1_box3_yheight
#define zdepth mccchannel_2_cave1_box3_zdepth
#define xwidth2 mccchannel_2_cave1_box3_xwidth2
#define yheight2 mccchannel_2_cave1_box3_yheight2
#define visualize mccchannel_2_cave1_box3_visualize
#define target_index mccchannel_2_cave1_box3_target_index
#define target_x mccchannel_2_cave1_box3_target_x
#define target_y mccchannel_2_cave1_box3_target_y
#define target_z mccchannel_2_cave1_box3_target_z
#define focus_aw mccchannel_2_cave1_box3_focus_aw
#define focus_ah mccchannel_2_cave1_box3_focus_ah
#define focus_xw mccchannel_2_cave1_box3_focus_xw
#define focus_xh mccchannel_2_cave1_box3_focus_xh
#define focus_r mccchannel_2_cave1_box3_focus_r
#define p_interact mccchannel_2_cave1_box3_p_interact
#define mask_string mccchannel_2_cave1_box3_mask_string
#define mask_setting mccchannel_2_cave1_box3_mask_setting
#define number_of_activations mccchannel_2_cave1_box3_number_of_activations
#line 204 "Union_box.comp"
// Needed for transport to the main component
struct global_geometry_element_struct global_geometry_element;

#ifndef ANY_GEOMETRY_DETECTOR_DECLARE
    #define ANY_GEOMETRY_DETECTOR_DECLARE dummy
	//struct pointer_to_global_geometry_list global_geometry_list = {0,NULL};
#endif

int loop_index,found_geometries;

double x_component;
double y_component;
double z_component;

struct Volume_struct this_box_volume;
struct box_storage this_box_storage;

#line 38806 "MACS_sample_kidney_box.c"
#undef number_of_activations
#undef mask_setting
#undef mask_string
#undef p_interact
#undef focus_r
#undef focus_xh
#undef focus_xw
#undef focus_ah
#undef focus_aw
#undef target_z
#undef target_y
#undef target_x
#undef target_index
#undef visualize
#undef yheight2
#undef xwidth2
#undef zdepth
#undef yheight
#undef xwidth
#undef priority
#undef material_string
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

/* User declarations for component 'channel_2_cave1_cyl1' [203]. */
#define mccompcurname  channel_2_cave1_cyl1
#define mccompcurtype  Union_cylinder
#define mccompcurindex 203
#define loop_index mccchannel_2_cave1_cyl1_loop_index
#define this_cylinder_volume mccchannel_2_cave1_cyl1_this_cylinder_volume
#define global_geometry_element mccchannel_2_cave1_cyl1_global_geometry_element
#define this_cylinder_storage mccchannel_2_cave1_cyl1_this_cylinder_storage
#define material_string mccchannel_2_cave1_cyl1_material_string
#define priority mccchannel_2_cave1_cyl1_priority
#define radius mccchannel_2_cave1_cyl1_radius
#define yheight mccchannel_2_cave1_cyl1_yheight
#define visualize mccchannel_2_cave1_cyl1_visualize
#define target_index mccchannel_2_cave1_cyl1_target_index
#define target_x mccchannel_2_cave1_cyl1_target_x
#define target_y mccchannel_2_cave1_cyl1_target_y
#define target_z mccchannel_2_cave1_cyl1_target_z
#define focus_aw mccchannel_2_cave1_cyl1_focus_aw
#define focus_ah mccchannel_2_cave1_cyl1_focus_ah
#define focus_xw mccchannel_2_cave1_cyl1_focus_xw
#define focus_xh mccchannel_2_cave1_cyl1_focus_xh
#define focus_r mccchannel_2_cave1_cyl1_focus_r
#define p_interact mccchannel_2_cave1_cyl1_p_interact
#define mask_string mccchannel_2_cave1_cyl1_mask_string
#define mask_setting mccchannel_2_cave1_cyl1_mask_setting
#define number_of_activations mccchannel_2_cave1_cyl1_number_of_activations
#line 167 "Union_cylinder.comp"
// Needed for transport to the main component
struct global_geometry_element_struct global_geometry_element;

#ifndef ANY_GEOMETRY_DETECTOR_DECLARE
    #define ANY_GEOMETRY_DETECTOR_DECLARE dummy
	//struct pointer_to_global_geometry_list global_geometry_list = {0,NULL};
#endif

int dummy;
int loop_index,found_geometries;
int loop_2_index;
int material_index;

struct Volume_struct this_cylinder_volume;
struct cylinder_storage this_cylinder_storage;
#line 38878 "MACS_sample_kidney_box.c"
#undef number_of_activations
#undef mask_setting
#undef mask_string
#undef p_interact
#undef focus_r
#undef focus_xh
#undef focus_xw
#undef focus_ah
#undef focus_aw
#undef target_z
#undef target_y
#undef target_x
#undef target_index
#undef visualize
#undef yheight
#undef radius
#undef priority
#undef material_string
#undef this_cylinder_storage
#undef global_geometry_element
#undef this_cylinder_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

/* User declarations for component 'channel_2_analyzer_1_center' [204]. */
#define mccompcurname  channel_2_analyzer_1_center
#define mccompcurtype  Arm
#define mccompcurindex 204
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

/* User declarations for component 'channel_2_analyzer_1_rotated' [205]. */
#define mccompcurname  channel_2_analyzer_1_rotated
#define mccompcurtype  Arm
#define mccompcurindex 205
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

/* User declarations for component 'channel_2_analyzer_1_array_crystal_array_0' [206]. */
#define mccompcurname  channel_2_analyzer_1_array_crystal_array_0
#define mccompcurtype  Union_box
#define mccompcurindex 206
#define loop_index mccchannel_2_analyzer_1_array_crystal_array_0_loop_index
#define this_box_volume mccchannel_2_analyzer_1_array_crystal_array_0_this_box_volume
#define global_geometry_element mccchannel_2_analyzer_1_array_crystal_array_0_global_geometry_element
#define this_box_storage mccchannel_2_analyzer_1_array_crystal_array_0_this_box_storage
#define material_string mccchannel_2_analyzer_1_array_crystal_array_0_material_string
#define priority mccchannel_2_analyzer_1_array_crystal_array_0_priority
#define xwidth mccchannel_2_analyzer_1_array_crystal_array_0_xwidth
#define yheight mccchannel_2_analyzer_1_array_crystal_array_0_yheight
#define zdepth mccchannel_2_analyzer_1_array_crystal_array_0_zdepth
#define xwidth2 mccchannel_2_analyzer_1_array_crystal_array_0_xwidth2
#define yheight2 mccchannel_2_analyzer_1_array_crystal_array_0_yheight2
#define visualize mccchannel_2_analyzer_1_array_crystal_array_0_visualize
#define target_index mccchannel_2_analyzer_1_array_crystal_array_0_target_index
#define target_x mccchannel_2_analyzer_1_array_crystal_array_0_target_x
#define target_y mccchannel_2_analyzer_1_array_crystal_array_0_target_y
#define target_z mccchannel_2_analyzer_1_array_crystal_array_0_target_z
#define focus_aw mccchannel_2_analyzer_1_array_crystal_array_0_focus_aw
#define focus_ah mccchannel_2_analyzer_1_array_crystal_array_0_focus_ah
#define focus_xw mccchannel_2_analyzer_1_array_crystal_array_0_focus_xw
#define focus_xh mccchannel_2_analyzer_1_array_crystal_array_0_focus_xh
#define focus_r mccchannel_2_analyzer_1_array_crystal_array_0_focus_r
#define p_interact mccchannel_2_analyzer_1_array_crystal_array_0_p_interact
#define mask_string mccchannel_2_analyzer_1_array_crystal_array_0_mask_string
#define mask_setting mccchannel_2_analyzer_1_array_crystal_array_0_mask_setting
#define number_of_activations mccchannel_2_analyzer_1_array_crystal_array_0_number_of_activations
#line 204 "Union_box.comp"
// Needed for transport to the main component
struct global_geometry_element_struct global_geometry_element;

#ifndef ANY_GEOMETRY_DETECTOR_DECLARE
    #define ANY_GEOMETRY_DETECTOR_DECLARE dummy
	//struct pointer_to_global_geometry_list global_geometry_list = {0,NULL};
#endif

int loop_index,found_geometries;

double x_component;
double y_component;
double z_component;

struct Volume_struct this_box_volume;
struct box_storage this_box_storage;

#line 38968 "MACS_sample_kidney_box.c"
#undef number_of_activations
#undef mask_setting
#undef mask_string
#undef p_interact
#undef focus_r
#undef focus_xh
#undef focus_xw
#undef focus_ah
#undef focus_aw
#undef target_z
#undef target_y
#undef target_x
#undef target_index
#undef visualize
#undef yheight2
#undef xwidth2
#undef zdepth
#undef yheight
#undef xwidth
#undef priority
#undef material_string
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

/* User declarations for component 'channel_2_analyzer_1_array_crystal_array_1' [207]. */
#define mccompcurname  channel_2_analyzer_1_array_crystal_array_1
#define mccompcurtype  Union_box
#define mccompcurindex 207
#define loop_index mccchannel_2_analyzer_1_array_crystal_array_1_loop_index
#define this_box_volume mccchannel_2_analyzer_1_array_crystal_array_1_this_box_volume
#define global_geometry_element mccchannel_2_analyzer_1_array_crystal_array_1_global_geometry_element
#define this_box_storage mccchannel_2_analyzer_1_array_crystal_array_1_this_box_storage
#define material_string mccchannel_2_analyzer_1_array_crystal_array_1_material_string
#define priority mccchannel_2_analyzer_1_array_crystal_array_1_priority
#define xwidth mccchannel_2_analyzer_1_array_crystal_array_1_xwidth
#define yheight mccchannel_2_analyzer_1_array_crystal_array_1_yheight
#define zdepth mccchannel_2_analyzer_1_array_crystal_array_1_zdepth
#define xwidth2 mccchannel_2_analyzer_1_array_crystal_array_1_xwidth2
#define yheight2 mccchannel_2_analyzer_1_array_crystal_array_1_yheight2
#define visualize mccchannel_2_analyzer_1_array_crystal_array_1_visualize
#define target_index mccchannel_2_analyzer_1_array_crystal_array_1_target_index
#define target_x mccchannel_2_analyzer_1_array_crystal_array_1_target_x
#define target_y mccchannel_2_analyzer_1_array_crystal_array_1_target_y
#define target_z mccchannel_2_analyzer_1_array_crystal_array_1_target_z
#define focus_aw mccchannel_2_analyzer_1_array_crystal_array_1_focus_aw
#define focus_ah mccchannel_2_analyzer_1_array_crystal_array_1_focus_ah
#define focus_xw mccchannel_2_analyzer_1_array_crystal_array_1_focus_xw
#define focus_xh mccchannel_2_analyzer_1_array_crystal_array_1_focus_xh
#define focus_r mccchannel_2_analyzer_1_array_crystal_array_1_focus_r
#define p_interact mccchannel_2_analyzer_1_array_crystal_array_1_p_interact
#define mask_string mccchannel_2_analyzer_1_array_crystal_array_1_mask_string
#define mask_setting mccchannel_2_analyzer_1_array_crystal_array_1_mask_setting
#define number_of_activations mccchannel_2_analyzer_1_array_crystal_array_1_number_of_activations
#line 204 "Union_box.comp"
// Needed for transport to the main component
struct global_geometry_element_struct global_geometry_element;

#ifndef ANY_GEOMETRY_DETECTOR_DECLARE
    #define ANY_GEOMETRY_DETECTOR_DECLARE dummy
	//struct pointer_to_global_geometry_list global_geometry_list = {0,NULL};
#endif

int loop_index,found_geometries;

double x_component;
double y_component;
double z_component;

struct Volume_struct this_box_volume;
struct box_storage this_box_storage;

#line 39045 "MACS_sample_kidney_box.c"
#undef number_of_activations
#undef mask_setting
#undef mask_string
#undef p_interact
#undef focus_r
#undef focus_xh
#undef focus_xw
#undef focus_ah
#undef focus_aw
#undef target_z
#undef target_y
#undef target_x
#undef target_index
#undef visualize
#undef yheight2
#undef xwidth2
#undef zdepth
#undef yheight
#undef xwidth
#undef priority
#undef material_string
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

/* User declarations for component 'channel_2_analyzer_1_array_crystal_array_2' [208]. */
#define mccompcurname  channel_2_analyzer_1_array_crystal_array_2
#define mccompcurtype  Union_box
#define mccompcurindex 208
#define loop_index mccchannel_2_analyzer_1_array_crystal_array_2_loop_index
#define this_box_volume mccchannel_2_analyzer_1_array_crystal_array_2_this_box_volume
#define global_geometry_element mccchannel_2_analyzer_1_array_crystal_array_2_global_geometry_element
#define this_box_storage mccchannel_2_analyzer_1_array_crystal_array_2_this_box_storage
#define material_string mccchannel_2_analyzer_1_array_crystal_array_2_material_string
#define priority mccchannel_2_analyzer_1_array_crystal_array_2_priority
#define xwidth mccchannel_2_analyzer_1_array_crystal_array_2_xwidth
#define yheight mccchannel_2_analyzer_1_array_crystal_array_2_yheight
#define zdepth mccchannel_2_analyzer_1_array_crystal_array_2_zdepth
#define xwidth2 mccchannel_2_analyzer_1_array_crystal_array_2_xwidth2
#define yheight2 mccchannel_2_analyzer_1_array_crystal_array_2_yheight2
#define visualize mccchannel_2_analyzer_1_array_crystal_array_2_visualize
#define target_index mccchannel_2_analyzer_1_array_crystal_array_2_target_index
#define target_x mccchannel_2_analyzer_1_array_crystal_array_2_target_x
#define target_y mccchannel_2_analyzer_1_array_crystal_array_2_target_y
#define target_z mccchannel_2_analyzer_1_array_crystal_array_2_target_z
#define focus_aw mccchannel_2_analyzer_1_array_crystal_array_2_focus_aw
#define focus_ah mccchannel_2_analyzer_1_array_crystal_array_2_focus_ah
#define focus_xw mccchannel_2_analyzer_1_array_crystal_array_2_focus_xw
#define focus_xh mccchannel_2_analyzer_1_array_crystal_array_2_focus_xh
#define focus_r mccchannel_2_analyzer_1_array_crystal_array_2_focus_r
#define p_interact mccchannel_2_analyzer_1_array_crystal_array_2_p_interact
#define mask_string mccchannel_2_analyzer_1_array_crystal_array_2_mask_string
#define mask_setting mccchannel_2_analyzer_1_array_crystal_array_2_mask_setting
#define number_of_activations mccchannel_2_analyzer_1_array_crystal_array_2_number_of_activations
#line 204 "Union_box.comp"
// Needed for transport to the main component
struct global_geometry_element_struct global_geometry_element;

#ifndef ANY_GEOMETRY_DETECTOR_DECLARE
    #define ANY_GEOMETRY_DETECTOR_DECLARE dummy
	//struct pointer_to_global_geometry_list global_geometry_list = {0,NULL};
#endif

int loop_index,found_geometries;

double x_component;
double y_component;
double z_component;

struct Volume_struct this_box_volume;
struct box_storage this_box_storage;

#line 39122 "MACS_sample_kidney_box.c"
#undef number_of_activations
#undef mask_setting
#undef mask_string
#undef p_interact
#undef focus_r
#undef focus_xh
#undef focus_xw
#undef focus_ah
#undef focus_aw
#undef target_z
#undef target_y
#undef target_x
#undef target_index
#undef visualize
#undef yheight2
#undef xwidth2
#undef zdepth
#undef yheight
#undef xwidth
#undef priority
#undef material_string
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

/* User declarations for component 'channel_2_analyzer_1_array_crystal_array_3' [209]. */
#define mccompcurname  channel_2_analyzer_1_array_crystal_array_3
#define mccompcurtype  Union_box
#define mccompcurindex 209
#define loop_index mccchannel_2_analyzer_1_array_crystal_array_3_loop_index
#define this_box_volume mccchannel_2_analyzer_1_array_crystal_array_3_this_box_volume
#define global_geometry_element mccchannel_2_analyzer_1_array_crystal_array_3_global_geometry_element
#define this_box_storage mccchannel_2_analyzer_1_array_crystal_array_3_this_box_storage
#define material_string mccchannel_2_analyzer_1_array_crystal_array_3_material_string
#define priority mccchannel_2_analyzer_1_array_crystal_array_3_priority
#define xwidth mccchannel_2_analyzer_1_array_crystal_array_3_xwidth
#define yheight mccchannel_2_analyzer_1_array_crystal_array_3_yheight
#define zdepth mccchannel_2_analyzer_1_array_crystal_array_3_zdepth
#define xwidth2 mccchannel_2_analyzer_1_array_crystal_array_3_xwidth2
#define yheight2 mccchannel_2_analyzer_1_array_crystal_array_3_yheight2
#define visualize mccchannel_2_analyzer_1_array_crystal_array_3_visualize
#define target_index mccchannel_2_analyzer_1_array_crystal_array_3_target_index
#define target_x mccchannel_2_analyzer_1_array_crystal_array_3_target_x
#define target_y mccchannel_2_analyzer_1_array_crystal_array_3_target_y
#define target_z mccchannel_2_analyzer_1_array_crystal_array_3_target_z
#define focus_aw mccchannel_2_analyzer_1_array_crystal_array_3_focus_aw
#define focus_ah mccchannel_2_analyzer_1_array_crystal_array_3_focus_ah
#define focus_xw mccchannel_2_analyzer_1_array_crystal_array_3_focus_xw
#define focus_xh mccchannel_2_analyzer_1_array_crystal_array_3_focus_xh
#define focus_r mccchannel_2_analyzer_1_array_crystal_array_3_focus_r
#define p_interact mccchannel_2_analyzer_1_array_crystal_array_3_p_interact
#define mask_string mccchannel_2_analyzer_1_array_crystal_array_3_mask_string
#define mask_setting mccchannel_2_analyzer_1_array_crystal_array_3_mask_setting
#define number_of_activations mccchannel_2_analyzer_1_array_crystal_array_3_number_of_activations
#line 204 "Union_box.comp"
// Needed for transport to the main component
struct global_geometry_element_struct global_geometry_element;

#ifndef ANY_GEOMETRY_DETECTOR_DECLARE
    #define ANY_GEOMETRY_DETECTOR_DECLARE dummy
	//struct pointer_to_global_geometry_list global_geometry_list = {0,NULL};
#endif

int loop_index,found_geometries;

double x_component;
double y_component;
double z_component;

struct Volume_struct this_box_volume;
struct box_storage this_box_storage;

#line 39199 "MACS_sample_kidney_box.c"
#undef number_of_activations
#undef mask_setting
#undef mask_string
#undef p_interact
#undef focus_r
#undef focus_xh
#undef focus_xw
#undef focus_ah
#undef focus_aw
#undef target_z
#undef target_y
#undef target_x
#undef target_index
#undef visualize
#undef yheight2
#undef xwidth2
#undef zdepth
#undef yheight
#undef xwidth
#undef priority
#undef material_string
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

/* User declarations for component 'channel_2_analyzer_1_array_crystal_array_4' [210]. */
#define mccompcurname  channel_2_analyzer_1_array_crystal_array_4
#define mccompcurtype  Union_box
#define mccompcurindex 210
#define loop_index mccchannel_2_analyzer_1_array_crystal_array_4_loop_index
#define this_box_volume mccchannel_2_analyzer_1_array_crystal_array_4_this_box_volume
#define global_geometry_element mccchannel_2_analyzer_1_array_crystal_array_4_global_geometry_element
#define this_box_storage mccchannel_2_analyzer_1_array_crystal_array_4_this_box_storage
#define material_string mccchannel_2_analyzer_1_array_crystal_array_4_material_string
#define priority mccchannel_2_analyzer_1_array_crystal_array_4_priority
#define xwidth mccchannel_2_analyzer_1_array_crystal_array_4_xwidth
#define yheight mccchannel_2_analyzer_1_array_crystal_array_4_yheight
#define zdepth mccchannel_2_analyzer_1_array_crystal_array_4_zdepth
#define xwidth2 mccchannel_2_analyzer_1_array_crystal_array_4_xwidth2
#define yheight2 mccchannel_2_analyzer_1_array_crystal_array_4_yheight2
#define visualize mccchannel_2_analyzer_1_array_crystal_array_4_visualize
#define target_index mccchannel_2_analyzer_1_array_crystal_array_4_target_index
#define target_x mccchannel_2_analyzer_1_array_crystal_array_4_target_x
#define target_y mccchannel_2_analyzer_1_array_crystal_array_4_target_y
#define target_z mccchannel_2_analyzer_1_array_crystal_array_4_target_z
#define focus_aw mccchannel_2_analyzer_1_array_crystal_array_4_focus_aw
#define focus_ah mccchannel_2_analyzer_1_array_crystal_array_4_focus_ah
#define focus_xw mccchannel_2_analyzer_1_array_crystal_array_4_focus_xw
#define focus_xh mccchannel_2_analyzer_1_array_crystal_array_4_focus_xh
#define focus_r mccchannel_2_analyzer_1_array_crystal_array_4_focus_r
#define p_interact mccchannel_2_analyzer_1_array_crystal_array_4_p_interact
#define mask_string mccchannel_2_analyzer_1_array_crystal_array_4_mask_string
#define mask_setting mccchannel_2_analyzer_1_array_crystal_array_4_mask_setting
#define number_of_activations mccchannel_2_analyzer_1_array_crystal_array_4_number_of_activations
#line 204 "Union_box.comp"
// Needed for transport to the main component
struct global_geometry_element_struct global_geometry_element;

#ifndef ANY_GEOMETRY_DETECTOR_DECLARE
    #define ANY_GEOMETRY_DETECTOR_DECLARE dummy
	//struct pointer_to_global_geometry_list global_geometry_list = {0,NULL};
#endif

int loop_index,found_geometries;

double x_component;
double y_component;
double z_component;

struct Volume_struct this_box_volume;
struct box_storage this_box_storage;

#line 39276 "MACS_sample_kidney_box.c"
#undef number_of_activations
#undef mask_setting
#undef mask_string
#undef p_interact
#undef focus_r
#undef focus_xh
#undef focus_xw
#undef focus_ah
#undef focus_aw
#undef target_z
#undef target_y
#undef target_x
#undef target_index
#undef visualize
#undef yheight2
#undef xwidth2
#undef zdepth
#undef yheight
#undef xwidth
#undef priority
#undef material_string
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

/* User declarations for component 'channel_2_analyzer_1_array_crystal_array_5' [211]. */
#define mccompcurname  channel_2_analyzer_1_array_crystal_array_5
#define mccompcurtype  Union_box
#define mccompcurindex 211
#define loop_index mccchannel_2_analyzer_1_array_crystal_array_5_loop_index
#define this_box_volume mccchannel_2_analyzer_1_array_crystal_array_5_this_box_volume
#define global_geometry_element mccchannel_2_analyzer_1_array_crystal_array_5_global_geometry_element
#define this_box_storage mccchannel_2_analyzer_1_array_crystal_array_5_this_box_storage
#define material_string mccchannel_2_analyzer_1_array_crystal_array_5_material_string
#define priority mccchannel_2_analyzer_1_array_crystal_array_5_priority
#define xwidth mccchannel_2_analyzer_1_array_crystal_array_5_xwidth
#define yheight mccchannel_2_analyzer_1_array_crystal_array_5_yheight
#define zdepth mccchannel_2_analyzer_1_array_crystal_array_5_zdepth
#define xwidth2 mccchannel_2_analyzer_1_array_crystal_array_5_xwidth2
#define yheight2 mccchannel_2_analyzer_1_array_crystal_array_5_yheight2
#define visualize mccchannel_2_analyzer_1_array_crystal_array_5_visualize
#define target_index mccchannel_2_analyzer_1_array_crystal_array_5_target_index
#define target_x mccchannel_2_analyzer_1_array_crystal_array_5_target_x
#define target_y mccchannel_2_analyzer_1_array_crystal_array_5_target_y
#define target_z mccchannel_2_analyzer_1_array_crystal_array_5_target_z
#define focus_aw mccchannel_2_analyzer_1_array_crystal_array_5_focus_aw
#define focus_ah mccchannel_2_analyzer_1_array_crystal_array_5_focus_ah
#define focus_xw mccchannel_2_analyzer_1_array_crystal_array_5_focus_xw
#define focus_xh mccchannel_2_analyzer_1_array_crystal_array_5_focus_xh
#define focus_r mccchannel_2_analyzer_1_array_crystal_array_5_focus_r
#define p_interact mccchannel_2_analyzer_1_array_crystal_array_5_p_interact
#define mask_string mccchannel_2_analyzer_1_array_crystal_array_5_mask_string
#define mask_setting mccchannel_2_analyzer_1_array_crystal_array_5_mask_setting
#define number_of_activations mccchannel_2_analyzer_1_array_crystal_array_5_number_of_activations
#line 204 "Union_box.comp"
// Needed for transport to the main component
struct global_geometry_element_struct global_geometry_element;

#ifndef ANY_GEOMETRY_DETECTOR_DECLARE
    #define ANY_GEOMETRY_DETECTOR_DECLARE dummy
	//struct pointer_to_global_geometry_list global_geometry_list = {0,NULL};
#endif

int loop_index,found_geometries;

double x_component;
double y_component;
double z_component;

struct Volume_struct this_box_volume;
struct box_storage this_box_storage;

#line 39353 "MACS_sample_kidney_box.c"
#undef number_of_activations
#undef mask_setting
#undef mask_string
#undef p_interact
#undef focus_r
#undef focus_xh
#undef focus_xw
#undef focus_ah
#undef focus_aw
#undef target_z
#undef target_y
#undef target_x
#undef target_index
#undef visualize
#undef yheight2
#undef xwidth2
#undef zdepth
#undef yheight
#undef xwidth
#undef priority
#undef material_string
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

/* User declarations for component 'channel_2_analyzer_1_array_crystal_array_6' [212]. */
#define mccompcurname  channel_2_analyzer_1_array_crystal_array_6
#define mccompcurtype  Union_box
#define mccompcurindex 212
#define loop_index mccchannel_2_analyzer_1_array_crystal_array_6_loop_index
#define this_box_volume mccchannel_2_analyzer_1_array_crystal_array_6_this_box_volume
#define global_geometry_element mccchannel_2_analyzer_1_array_crystal_array_6_global_geometry_element
#define this_box_storage mccchannel_2_analyzer_1_array_crystal_array_6_this_box_storage
#define material_string mccchannel_2_analyzer_1_array_crystal_array_6_material_string
#define priority mccchannel_2_analyzer_1_array_crystal_array_6_priority
#define xwidth mccchannel_2_analyzer_1_array_crystal_array_6_xwidth
#define yheight mccchannel_2_analyzer_1_array_crystal_array_6_yheight
#define zdepth mccchannel_2_analyzer_1_array_crystal_array_6_zdepth
#define xwidth2 mccchannel_2_analyzer_1_array_crystal_array_6_xwidth2
#define yheight2 mccchannel_2_analyzer_1_array_crystal_array_6_yheight2
#define visualize mccchannel_2_analyzer_1_array_crystal_array_6_visualize
#define target_index mccchannel_2_analyzer_1_array_crystal_array_6_target_index
#define target_x mccchannel_2_analyzer_1_array_crystal_array_6_target_x
#define target_y mccchannel_2_analyzer_1_array_crystal_array_6_target_y
#define target_z mccchannel_2_analyzer_1_array_crystal_array_6_target_z
#define focus_aw mccchannel_2_analyzer_1_array_crystal_array_6_focus_aw
#define focus_ah mccchannel_2_analyzer_1_array_crystal_array_6_focus_ah
#define focus_xw mccchannel_2_analyzer_1_array_crystal_array_6_focus_xw
#define focus_xh mccchannel_2_analyzer_1_array_crystal_array_6_focus_xh
#define focus_r mccchannel_2_analyzer_1_array_crystal_array_6_focus_r
#define p_interact mccchannel_2_analyzer_1_array_crystal_array_6_p_interact
#define mask_string mccchannel_2_analyzer_1_array_crystal_array_6_mask_string
#define mask_setting mccchannel_2_analyzer_1_array_crystal_array_6_mask_setting
#define number_of_activations mccchannel_2_analyzer_1_array_crystal_array_6_number_of_activations
#line 204 "Union_box.comp"
// Needed for transport to the main component
struct global_geometry_element_struct global_geometry_element;

#ifndef ANY_GEOMETRY_DETECTOR_DECLARE
    #define ANY_GEOMETRY_DETECTOR_DECLARE dummy
	//struct pointer_to_global_geometry_list global_geometry_list = {0,NULL};
#endif

int loop_index,found_geometries;

double x_component;
double y_component;
double z_component;

struct Volume_struct this_box_volume;
struct box_storage this_box_storage;

#line 39430 "MACS_sample_kidney_box.c"
#undef number_of_activations
#undef mask_setting
#undef mask_string
#undef p_interact
#undef focus_r
#undef focus_xh
#undef focus_xw
#undef focus_ah
#undef focus_aw
#undef target_z
#undef target_y
#undef target_x
#undef target_index
#undef visualize
#undef yheight2
#undef xwidth2
#undef zdepth
#undef yheight
#undef xwidth
#undef priority
#undef material_string
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

/* User declarations for component 'channel_2_analyzer_1_array_crystal_array_7' [213]. */
#define mccompcurname  channel_2_analyzer_1_array_crystal_array_7
#define mccompcurtype  Union_box
#define mccompcurindex 213
#define loop_index mccchannel_2_analyzer_1_array_crystal_array_7_loop_index
#define this_box_volume mccchannel_2_analyzer_1_array_crystal_array_7_this_box_volume
#define global_geometry_element mccchannel_2_analyzer_1_array_crystal_array_7_global_geometry_element
#define this_box_storage mccchannel_2_analyzer_1_array_crystal_array_7_this_box_storage
#define material_string mccchannel_2_analyzer_1_array_crystal_array_7_material_string
#define priority mccchannel_2_analyzer_1_array_crystal_array_7_priority
#define xwidth mccchannel_2_analyzer_1_array_crystal_array_7_xwidth
#define yheight mccchannel_2_analyzer_1_array_crystal_array_7_yheight
#define zdepth mccchannel_2_analyzer_1_array_crystal_array_7_zdepth
#define xwidth2 mccchannel_2_analyzer_1_array_crystal_array_7_xwidth2
#define yheight2 mccchannel_2_analyzer_1_array_crystal_array_7_yheight2
#define visualize mccchannel_2_analyzer_1_array_crystal_array_7_visualize
#define target_index mccchannel_2_analyzer_1_array_crystal_array_7_target_index
#define target_x mccchannel_2_analyzer_1_array_crystal_array_7_target_x
#define target_y mccchannel_2_analyzer_1_array_crystal_array_7_target_y
#define target_z mccchannel_2_analyzer_1_array_crystal_array_7_target_z
#define focus_aw mccchannel_2_analyzer_1_array_crystal_array_7_focus_aw
#define focus_ah mccchannel_2_analyzer_1_array_crystal_array_7_focus_ah
#define focus_xw mccchannel_2_analyzer_1_array_crystal_array_7_focus_xw
#define focus_xh mccchannel_2_analyzer_1_array_crystal_array_7_focus_xh
#define focus_r mccchannel_2_analyzer_1_array_crystal_array_7_focus_r
#define p_interact mccchannel_2_analyzer_1_array_crystal_array_7_p_interact
#define mask_string mccchannel_2_analyzer_1_array_crystal_array_7_mask_string
#define mask_setting mccchannel_2_analyzer_1_array_crystal_array_7_mask_setting
#define number_of_activations mccchannel_2_analyzer_1_array_crystal_array_7_number_of_activations
#line 204 "Union_box.comp"
// Needed for transport to the main component
struct global_geometry_element_struct global_geometry_element;

#ifndef ANY_GEOMETRY_DETECTOR_DECLARE
    #define ANY_GEOMETRY_DETECTOR_DECLARE dummy
	//struct pointer_to_global_geometry_list global_geometry_list = {0,NULL};
#endif

int loop_index,found_geometries;

double x_component;
double y_component;
double z_component;

struct Volume_struct this_box_volume;
struct box_storage this_box_storage;

#line 39507 "MACS_sample_kidney_box.c"
#undef number_of_activations
#undef mask_setting
#undef mask_string
#undef p_interact
#undef focus_r
#undef focus_xh
#undef focus_xw
#undef focus_ah
#undef focus_aw
#undef target_z
#undef target_y
#undef target_x
#undef target_index
#undef visualize
#undef yheight2
#undef xwidth2
#undef zdepth
#undef yheight
#undef xwidth
#undef priority
#undef material_string
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

/* User declarations for component 'channel_2_analyzer_1_array_crystal_array_8' [214]. */
#define mccompcurname  channel_2_analyzer_1_array_crystal_array_8
#define mccompcurtype  Union_box
#define mccompcurindex 214
#define loop_index mccchannel_2_analyzer_1_array_crystal_array_8_loop_index
#define this_box_volume mccchannel_2_analyzer_1_array_crystal_array_8_this_box_volume
#define global_geometry_element mccchannel_2_analyzer_1_array_crystal_array_8_global_geometry_element
#define this_box_storage mccchannel_2_analyzer_1_array_crystal_array_8_this_box_storage
#define material_string mccchannel_2_analyzer_1_array_crystal_array_8_material_string
#define priority mccchannel_2_analyzer_1_array_crystal_array_8_priority
#define xwidth mccchannel_2_analyzer_1_array_crystal_array_8_xwidth
#define yheight mccchannel_2_analyzer_1_array_crystal_array_8_yheight
#define zdepth mccchannel_2_analyzer_1_array_crystal_array_8_zdepth
#define xwidth2 mccchannel_2_analyzer_1_array_crystal_array_8_xwidth2
#define yheight2 mccchannel_2_analyzer_1_array_crystal_array_8_yheight2
#define visualize mccchannel_2_analyzer_1_array_crystal_array_8_visualize
#define target_index mccchannel_2_analyzer_1_array_crystal_array_8_target_index
#define target_x mccchannel_2_analyzer_1_array_crystal_array_8_target_x
#define target_y mccchannel_2_analyzer_1_array_crystal_array_8_target_y
#define target_z mccchannel_2_analyzer_1_array_crystal_array_8_target_z
#define focus_aw mccchannel_2_analyzer_1_array_crystal_array_8_focus_aw
#define focus_ah mccchannel_2_analyzer_1_array_crystal_array_8_focus_ah
#define focus_xw mccchannel_2_analyzer_1_array_crystal_array_8_focus_xw
#define focus_xh mccchannel_2_analyzer_1_array_crystal_array_8_focus_xh
#define focus_r mccchannel_2_analyzer_1_array_crystal_array_8_focus_r
#define p_interact mccchannel_2_analyzer_1_array_crystal_array_8_p_interact
#define mask_string mccchannel_2_analyzer_1_array_crystal_array_8_mask_string
#define mask_setting mccchannel_2_analyzer_1_array_crystal_array_8_mask_setting
#define number_of_activations mccchannel_2_analyzer_1_array_crystal_array_8_number_of_activations
#line 204 "Union_box.comp"
// Needed for transport to the main component
struct global_geometry_element_struct global_geometry_element;

#ifndef ANY_GEOMETRY_DETECTOR_DECLARE
    #define ANY_GEOMETRY_DETECTOR_DECLARE dummy
	//struct pointer_to_global_geometry_list global_geometry_list = {0,NULL};
#endif

int loop_index,found_geometries;

double x_component;
double y_component;
double z_component;

struct Volume_struct this_box_volume;
struct box_storage this_box_storage;

#line 39584 "MACS_sample_kidney_box.c"
#undef number_of_activations
#undef mask_setting
#undef mask_string
#undef p_interact
#undef focus_r
#undef focus_xh
#undef focus_xw
#undef focus_ah
#undef focus_aw
#undef target_z
#undef target_y
#undef target_x
#undef target_index
#undef visualize
#undef yheight2
#undef xwidth2
#undef zdepth
#undef yheight
#undef xwidth
#undef priority
#undef material_string
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

/* User declarations for component 'channel_2_analyzer_2_center' [215]. */
#define mccompcurname  channel_2_analyzer_2_center
#define mccompcurtype  Arm
#define mccompcurindex 215
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

/* User declarations for component 'channel_2_analyzer_2_rotated' [216]. */
#define mccompcurname  channel_2_analyzer_2_rotated
#define mccompcurtype  Arm
#define mccompcurindex 216
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

/* User declarations for component 'channel_2_analyzer_2_array_crystal_array_0' [217]. */
#define mccompcurname  channel_2_analyzer_2_array_crystal_array_0
#define mccompcurtype  Union_box
#define mccompcurindex 217
#define loop_index mccchannel_2_analyzer_2_array_crystal_array_0_loop_index
#define this_box_volume mccchannel_2_analyzer_2_array_crystal_array_0_this_box_volume
#define global_geometry_element mccchannel_2_analyzer_2_array_crystal_array_0_global_geometry_element
#define this_box_storage mccchannel_2_analyzer_2_array_crystal_array_0_this_box_storage
#define material_string mccchannel_2_analyzer_2_array_crystal_array_0_material_string
#define priority mccchannel_2_analyzer_2_array_crystal_array_0_priority
#define xwidth mccchannel_2_analyzer_2_array_crystal_array_0_xwidth
#define yheight mccchannel_2_analyzer_2_array_crystal_array_0_yheight
#define zdepth mccchannel_2_analyzer_2_array_crystal_array_0_zdepth
#define xwidth2 mccchannel_2_analyzer_2_array_crystal_array_0_xwidth2
#define yheight2 mccchannel_2_analyzer_2_array_crystal_array_0_yheight2
#define visualize mccchannel_2_analyzer_2_array_crystal_array_0_visualize
#define target_index mccchannel_2_analyzer_2_array_crystal_array_0_target_index
#define target_x mccchannel_2_analyzer_2_array_crystal_array_0_target_x
#define target_y mccchannel_2_analyzer_2_array_crystal_array_0_target_y
#define target_z mccchannel_2_analyzer_2_array_crystal_array_0_target_z
#define focus_aw mccchannel_2_analyzer_2_array_crystal_array_0_focus_aw
#define focus_ah mccchannel_2_analyzer_2_array_crystal_array_0_focus_ah
#define focus_xw mccchannel_2_analyzer_2_array_crystal_array_0_focus_xw
#define focus_xh mccchannel_2_analyzer_2_array_crystal_array_0_focus_xh
#define focus_r mccchannel_2_analyzer_2_array_crystal_array_0_focus_r
#define p_interact mccchannel_2_analyzer_2_array_crystal_array_0_p_interact
#define mask_string mccchannel_2_analyzer_2_array_crystal_array_0_mask_string
#define mask_setting mccchannel_2_analyzer_2_array_crystal_array_0_mask_setting
#define number_of_activations mccchannel_2_analyzer_2_array_crystal_array_0_number_of_activations
#line 204 "Union_box.comp"
// Needed for transport to the main component
struct global_geometry_element_struct global_geometry_element;

#ifndef ANY_GEOMETRY_DETECTOR_DECLARE
    #define ANY_GEOMETRY_DETECTOR_DECLARE dummy
	//struct pointer_to_global_geometry_list global_geometry_list = {0,NULL};
#endif

int loop_index,found_geometries;

double x_component;
double y_component;
double z_component;

struct Volume_struct this_box_volume;
struct box_storage this_box_storage;

#line 39677 "MACS_sample_kidney_box.c"
#undef number_of_activations
#undef mask_setting
#undef mask_string
#undef p_interact
#undef focus_r
#undef focus_xh
#undef focus_xw
#undef focus_ah
#undef focus_aw
#undef target_z
#undef target_y
#undef target_x
#undef target_index
#undef visualize
#undef yheight2
#undef xwidth2
#undef zdepth
#undef yheight
#undef xwidth
#undef priority
#undef material_string
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

/* User declarations for component 'channel_2_analyzer_2_array_crystal_array_1' [218]. */
#define mccompcurname  channel_2_analyzer_2_array_crystal_array_1
#define mccompcurtype  Union_box
#define mccompcurindex 218
#define loop_index mccchannel_2_analyzer_2_array_crystal_array_1_loop_index
#define this_box_volume mccchannel_2_analyzer_2_array_crystal_array_1_this_box_volume
#define global_geometry_element mccchannel_2_analyzer_2_array_crystal_array_1_global_geometry_element
#define this_box_storage mccchannel_2_analyzer_2_array_crystal_array_1_this_box_storage
#define material_string mccchannel_2_analyzer_2_array_crystal_array_1_material_string
#define priority mccchannel_2_analyzer_2_array_crystal_array_1_priority
#define xwidth mccchannel_2_analyzer_2_array_crystal_array_1_xwidth
#define yheight mccchannel_2_analyzer_2_array_crystal_array_1_yheight
#define zdepth mccchannel_2_analyzer_2_array_crystal_array_1_zdepth
#define xwidth2 mccchannel_2_analyzer_2_array_crystal_array_1_xwidth2
#define yheight2 mccchannel_2_analyzer_2_array_crystal_array_1_yheight2
#define visualize mccchannel_2_analyzer_2_array_crystal_array_1_visualize
#define target_index mccchannel_2_analyzer_2_array_crystal_array_1_target_index
#define target_x mccchannel_2_analyzer_2_array_crystal_array_1_target_x
#define target_y mccchannel_2_analyzer_2_array_crystal_array_1_target_y
#define target_z mccchannel_2_analyzer_2_array_crystal_array_1_target_z
#define focus_aw mccchannel_2_analyzer_2_array_crystal_array_1_focus_aw
#define focus_ah mccchannel_2_analyzer_2_array_crystal_array_1_focus_ah
#define focus_xw mccchannel_2_analyzer_2_array_crystal_array_1_focus_xw
#define focus_xh mccchannel_2_analyzer_2_array_crystal_array_1_focus_xh
#define focus_r mccchannel_2_analyzer_2_array_crystal_array_1_focus_r
#define p_interact mccchannel_2_analyzer_2_array_crystal_array_1_p_interact
#define mask_string mccchannel_2_analyzer_2_array_crystal_array_1_mask_string
#define mask_setting mccchannel_2_analyzer_2_array_crystal_array_1_mask_setting
#define number_of_activations mccchannel_2_analyzer_2_array_crystal_array_1_number_of_activations
#line 204 "Union_box.comp"
// Needed for transport to the main component
struct global_geometry_element_struct global_geometry_element;

#ifndef ANY_GEOMETRY_DETECTOR_DECLARE
    #define ANY_GEOMETRY_DETECTOR_DECLARE dummy
	//struct pointer_to_global_geometry_list global_geometry_list = {0,NULL};
#endif

int loop_index,found_geometries;

double x_component;
double y_component;
double z_component;

struct Volume_struct this_box_volume;
struct box_storage this_box_storage;

#line 39754 "MACS_sample_kidney_box.c"
#undef number_of_activations
#undef mask_setting
#undef mask_string
#undef p_interact
#undef focus_r
#undef focus_xh
#undef focus_xw
#undef focus_ah
#undef focus_aw
#undef target_z
#undef target_y
#undef target_x
#undef target_index
#undef visualize
#undef yheight2
#undef xwidth2
#undef zdepth
#undef yheight
#undef xwidth
#undef priority
#undef material_string
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

/* User declarations for component 'channel_2_analyzer_2_array_crystal_array_2' [219]. */
#define mccompcurname  channel_2_analyzer_2_array_crystal_array_2
#define mccompcurtype  Union_box
#define mccompcurindex 219
#define loop_index mccchannel_2_analyzer_2_array_crystal_array_2_loop_index
#define this_box_volume mccchannel_2_analyzer_2_array_crystal_array_2_this_box_volume
#define global_geometry_element mccchannel_2_analyzer_2_array_crystal_array_2_global_geometry_element
#define this_box_storage mccchannel_2_analyzer_2_array_crystal_array_2_this_box_storage
#define material_string mccchannel_2_analyzer_2_array_crystal_array_2_material_string
#define priority mccchannel_2_analyzer_2_array_crystal_array_2_priority
#define xwidth mccchannel_2_analyzer_2_array_crystal_array_2_xwidth
#define yheight mccchannel_2_analyzer_2_array_crystal_array_2_yheight
#define zdepth mccchannel_2_analyzer_2_array_crystal_array_2_zdepth
#define xwidth2 mccchannel_2_analyzer_2_array_crystal_array_2_xwidth2
#define yheight2 mccchannel_2_analyzer_2_array_crystal_array_2_yheight2
#define visualize mccchannel_2_analyzer_2_array_crystal_array_2_visualize
#define target_index mccchannel_2_analyzer_2_array_crystal_array_2_target_index
#define target_x mccchannel_2_analyzer_2_array_crystal_array_2_target_x
#define target_y mccchannel_2_analyzer_2_array_crystal_array_2_target_y
#define target_z mccchannel_2_analyzer_2_array_crystal_array_2_target_z
#define focus_aw mccchannel_2_analyzer_2_array_crystal_array_2_focus_aw
#define focus_ah mccchannel_2_analyzer_2_array_crystal_array_2_focus_ah
#define focus_xw mccchannel_2_analyzer_2_array_crystal_array_2_focus_xw
#define focus_xh mccchannel_2_analyzer_2_array_crystal_array_2_focus_xh
#define focus_r mccchannel_2_analyzer_2_array_crystal_array_2_focus_r
#define p_interact mccchannel_2_analyzer_2_array_crystal_array_2_p_interact
#define mask_string mccchannel_2_analyzer_2_array_crystal_array_2_mask_string
#define mask_setting mccchannel_2_analyzer_2_array_crystal_array_2_mask_setting
#define number_of_activations mccchannel_2_analyzer_2_array_crystal_array_2_number_of_activations
#line 204 "Union_box.comp"
// Needed for transport to the main component
struct global_geometry_element_struct global_geometry_element;

#ifndef ANY_GEOMETRY_DETECTOR_DECLARE
    #define ANY_GEOMETRY_DETECTOR_DECLARE dummy
	//struct pointer_to_global_geometry_list global_geometry_list = {0,NULL};
#endif

int loop_index,found_geometries;

double x_component;
double y_component;
double z_component;

struct Volume_struct this_box_volume;
struct box_storage this_box_storage;

#line 39831 "MACS_sample_kidney_box.c"
#undef number_of_activations
#undef mask_setting
#undef mask_string
#undef p_interact
#undef focus_r
#undef focus_xh
#undef focus_xw
#undef focus_ah
#undef focus_aw
#undef target_z
#undef target_y
#undef target_x
#undef target_index
#undef visualize
#undef yheight2
#undef xwidth2
#undef zdepth
#undef yheight
#undef xwidth
#undef priority
#undef material_string
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

/* User declarations for component 'channel_2_analyzer_2_array_crystal_array_3' [220]. */
#define mccompcurname  channel_2_analyzer_2_array_crystal_array_3
#define mccompcurtype  Union_box
#define mccompcurindex 220
#define loop_index mccchannel_2_analyzer_2_array_crystal_array_3_loop_index
#define this_box_volume mccchannel_2_analyzer_2_array_crystal_array_3_this_box_volume
#define global_geometry_element mccchannel_2_analyzer_2_array_crystal_array_3_global_geometry_element
#define this_box_storage mccchannel_2_analyzer_2_array_crystal_array_3_this_box_storage
#define material_string mccchannel_2_analyzer_2_array_crystal_array_3_material_string
#define priority mccchannel_2_analyzer_2_array_crystal_array_3_priority
#define xwidth mccchannel_2_analyzer_2_array_crystal_array_3_xwidth
#define yheight mccchannel_2_analyzer_2_array_crystal_array_3_yheight
#define zdepth mccchannel_2_analyzer_2_array_crystal_array_3_zdepth
#define xwidth2 mccchannel_2_analyzer_2_array_crystal_array_3_xwidth2
#define yheight2 mccchannel_2_analyzer_2_array_crystal_array_3_yheight2
#define visualize mccchannel_2_analyzer_2_array_crystal_array_3_visualize
#define target_index mccchannel_2_analyzer_2_array_crystal_array_3_target_index
#define target_x mccchannel_2_analyzer_2_array_crystal_array_3_target_x
#define target_y mccchannel_2_analyzer_2_array_crystal_array_3_target_y
#define target_z mccchannel_2_analyzer_2_array_crystal_array_3_target_z
#define focus_aw mccchannel_2_analyzer_2_array_crystal_array_3_focus_aw
#define focus_ah mccchannel_2_analyzer_2_array_crystal_array_3_focus_ah
#define focus_xw mccchannel_2_analyzer_2_array_crystal_array_3_focus_xw
#define focus_xh mccchannel_2_analyzer_2_array_crystal_array_3_focus_xh
#define focus_r mccchannel_2_analyzer_2_array_crystal_array_3_focus_r
#define p_interact mccchannel_2_analyzer_2_array_crystal_array_3_p_interact
#define mask_string mccchannel_2_analyzer_2_array_crystal_array_3_mask_string
#define mask_setting mccchannel_2_analyzer_2_array_crystal_array_3_mask_setting
#define number_of_activations mccchannel_2_analyzer_2_array_crystal_array_3_number_of_activations
#line 204 "Union_box.comp"
// Needed for transport to the main component
struct global_geometry_element_struct global_geometry_element;

#ifndef ANY_GEOMETRY_DETECTOR_DECLARE
    #define ANY_GEOMETRY_DETECTOR_DECLARE dummy
	//struct pointer_to_global_geometry_list global_geometry_list = {0,NULL};
#endif

int loop_index,found_geometries;

double x_component;
double y_component;
double z_component;

struct Volume_struct this_box_volume;
struct box_storage this_box_storage;

#line 39908 "MACS_sample_kidney_box.c"
#undef number_of_activations
#undef mask_setting
#undef mask_string
#undef p_interact
#undef focus_r
#undef focus_xh
#undef focus_xw
#undef focus_ah
#undef focus_aw
#undef target_z
#undef target_y
#undef target_x
#undef target_index
#undef visualize
#undef yheight2
#undef xwidth2
#undef zdepth
#undef yheight
#undef xwidth
#undef priority
#undef material_string
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

/* User declarations for component 'channel_2_analyzer_2_array_crystal_array_4' [221]. */
#define mccompcurname  channel_2_analyzer_2_array_crystal_array_4
#define mccompcurtype  Union_box
#define mccompcurindex 221
#define loop_index mccchannel_2_analyzer_2_array_crystal_array_4_loop_index
#define this_box_volume mccchannel_2_analyzer_2_array_crystal_array_4_this_box_volume
#define global_geometry_element mccchannel_2_analyzer_2_array_crystal_array_4_global_geometry_element
#define this_box_storage mccchannel_2_analyzer_2_array_crystal_array_4_this_box_storage
#define material_string mccchannel_2_analyzer_2_array_crystal_array_4_material_string
#define priority mccchannel_2_analyzer_2_array_crystal_array_4_priority
#define xwidth mccchannel_2_analyzer_2_array_crystal_array_4_xwidth
#define yheight mccchannel_2_analyzer_2_array_crystal_array_4_yheight
#define zdepth mccchannel_2_analyzer_2_array_crystal_array_4_zdepth
#define xwidth2 mccchannel_2_analyzer_2_array_crystal_array_4_xwidth2
#define yheight2 mccchannel_2_analyzer_2_array_crystal_array_4_yheight2
#define visualize mccchannel_2_analyzer_2_array_crystal_array_4_visualize
#define target_index mccchannel_2_analyzer_2_array_crystal_array_4_target_index
#define target_x mccchannel_2_analyzer_2_array_crystal_array_4_target_x
#define target_y mccchannel_2_analyzer_2_array_crystal_array_4_target_y
#define target_z mccchannel_2_analyzer_2_array_crystal_array_4_target_z
#define focus_aw mccchannel_2_analyzer_2_array_crystal_array_4_focus_aw
#define focus_ah mccchannel_2_analyzer_2_array_crystal_array_4_focus_ah
#define focus_xw mccchannel_2_analyzer_2_array_crystal_array_4_focus_xw
#define focus_xh mccchannel_2_analyzer_2_array_crystal_array_4_focus_xh
#define focus_r mccchannel_2_analyzer_2_array_crystal_array_4_focus_r
#define p_interact mccchannel_2_analyzer_2_array_crystal_array_4_p_interact
#define mask_string mccchannel_2_analyzer_2_array_crystal_array_4_mask_string
#define mask_setting mccchannel_2_analyzer_2_array_crystal_array_4_mask_setting
#define number_of_activations mccchannel_2_analyzer_2_array_crystal_array_4_number_of_activations
#line 204 "Union_box.comp"
// Needed for transport to the main component
struct global_geometry_element_struct global_geometry_element;

#ifndef ANY_GEOMETRY_DETECTOR_DECLARE
    #define ANY_GEOMETRY_DETECTOR_DECLARE dummy
	//struct pointer_to_global_geometry_list global_geometry_list = {0,NULL};
#endif

int loop_index,found_geometries;

double x_component;
double y_component;
double z_component;

struct Volume_struct this_box_volume;
struct box_storage this_box_storage;

#line 39985 "MACS_sample_kidney_box.c"
#undef number_of_activations
#undef mask_setting
#undef mask_string
#undef p_interact
#undef focus_r
#undef focus_xh
#undef focus_xw
#undef focus_ah
#undef focus_aw
#undef target_z
#undef target_y
#undef target_x
#undef target_index
#undef visualize
#undef yheight2
#undef xwidth2
#undef zdepth
#undef yheight
#undef xwidth
#undef priority
#undef material_string
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

/* User declarations for component 'channel_2_analyzer_2_array_crystal_array_5' [222]. */
#define mccompcurname  channel_2_analyzer_2_array_crystal_array_5
#define mccompcurtype  Union_box
#define mccompcurindex 222
#define loop_index mccchannel_2_analyzer_2_array_crystal_array_5_loop_index
#define this_box_volume mccchannel_2_analyzer_2_array_crystal_array_5_this_box_volume
#define global_geometry_element mccchannel_2_analyzer_2_array_crystal_array_5_global_geometry_element
#define this_box_storage mccchannel_2_analyzer_2_array_crystal_array_5_this_box_storage
#define material_string mccchannel_2_analyzer_2_array_crystal_array_5_material_string
#define priority mccchannel_2_analyzer_2_array_crystal_array_5_priority
#define xwidth mccchannel_2_analyzer_2_array_crystal_array_5_xwidth
#define yheight mccchannel_2_analyzer_2_array_crystal_array_5_yheight
#define zdepth mccchannel_2_analyzer_2_array_crystal_array_5_zdepth
#define xwidth2 mccchannel_2_analyzer_2_array_crystal_array_5_xwidth2
#define yheight2 mccchannel_2_analyzer_2_array_crystal_array_5_yheight2
#define visualize mccchannel_2_analyzer_2_array_crystal_array_5_visualize
#define target_index mccchannel_2_analyzer_2_array_crystal_array_5_target_index
#define target_x mccchannel_2_analyzer_2_array_crystal_array_5_target_x
#define target_y mccchannel_2_analyzer_2_array_crystal_array_5_target_y
#define target_z mccchannel_2_analyzer_2_array_crystal_array_5_target_z
#define focus_aw mccchannel_2_analyzer_2_array_crystal_array_5_focus_aw
#define focus_ah mccchannel_2_analyzer_2_array_crystal_array_5_focus_ah
#define focus_xw mccchannel_2_analyzer_2_array_crystal_array_5_focus_xw
#define focus_xh mccchannel_2_analyzer_2_array_crystal_array_5_focus_xh
#define focus_r mccchannel_2_analyzer_2_array_crystal_array_5_focus_r
#define p_interact mccchannel_2_analyzer_2_array_crystal_array_5_p_interact
#define mask_string mccchannel_2_analyzer_2_array_crystal_array_5_mask_string
#define mask_setting mccchannel_2_analyzer_2_array_crystal_array_5_mask_setting
#define number_of_activations mccchannel_2_analyzer_2_array_crystal_array_5_number_of_activations
#line 204 "Union_box.comp"
// Needed for transport to the main component
struct global_geometry_element_struct global_geometry_element;

#ifndef ANY_GEOMETRY_DETECTOR_DECLARE
    #define ANY_GEOMETRY_DETECTOR_DECLARE dummy
	//struct pointer_to_global_geometry_list global_geometry_list = {0,NULL};
#endif

int loop_index,found_geometries;

double x_component;
double y_component;
double z_component;

struct Volume_struct this_box_volume;
struct box_storage this_box_storage;

#line 40062 "MACS_sample_kidney_box.c"
#undef number_of_activations
#undef mask_setting
#undef mask_string
#undef p_interact
#undef focus_r
#undef focus_xh
#undef focus_xw
#undef focus_ah
#undef focus_aw
#undef target_z
#undef target_y
#undef target_x
#undef target_index
#undef visualize
#undef yheight2
#undef xwidth2
#undef zdepth
#undef yheight
#undef xwidth
#undef priority
#undef material_string
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

/* User declarations for component 'channel_2_analyzer_2_array_crystal_array_6' [223]. */
#define mccompcurname  channel_2_analyzer_2_array_crystal_array_6
#define mccompcurtype  Union_box
#define mccompcurindex 223
#define loop_index mccchannel_2_analyzer_2_array_crystal_array_6_loop_index
#define this_box_volume mccchannel_2_analyzer_2_array_crystal_array_6_this_box_volume
#define global_geometry_element mccchannel_2_analyzer_2_array_crystal_array_6_global_geometry_element
#define this_box_storage mccchannel_2_analyzer_2_array_crystal_array_6_this_box_storage
#define material_string mccchannel_2_analyzer_2_array_crystal_array_6_material_string
#define priority mccchannel_2_analyzer_2_array_crystal_array_6_priority
#define xwidth mccchannel_2_analyzer_2_array_crystal_array_6_xwidth
#define yheight mccchannel_2_analyzer_2_array_crystal_array_6_yheight
#define zdepth mccchannel_2_analyzer_2_array_crystal_array_6_zdepth
#define xwidth2 mccchannel_2_analyzer_2_array_crystal_array_6_xwidth2
#define yheight2 mccchannel_2_analyzer_2_array_crystal_array_6_yheight2
#define visualize mccchannel_2_analyzer_2_array_crystal_array_6_visualize
#define target_index mccchannel_2_analyzer_2_array_crystal_array_6_target_index
#define target_x mccchannel_2_analyzer_2_array_crystal_array_6_target_x
#define target_y mccchannel_2_analyzer_2_array_crystal_array_6_target_y
#define target_z mccchannel_2_analyzer_2_array_crystal_array_6_target_z
#define focus_aw mccchannel_2_analyzer_2_array_crystal_array_6_focus_aw
#define focus_ah mccchannel_2_analyzer_2_array_crystal_array_6_focus_ah
#define focus_xw mccchannel_2_analyzer_2_array_crystal_array_6_focus_xw
#define focus_xh mccchannel_2_analyzer_2_array_crystal_array_6_focus_xh
#define focus_r mccchannel_2_analyzer_2_array_crystal_array_6_focus_r
#define p_interact mccchannel_2_analyzer_2_array_crystal_array_6_p_interact
#define mask_string mccchannel_2_analyzer_2_array_crystal_array_6_mask_string
#define mask_setting mccchannel_2_analyzer_2_array_crystal_array_6_mask_setting
#define number_of_activations mccchannel_2_analyzer_2_array_crystal_array_6_number_of_activations
#line 204 "Union_box.comp"
// Needed for transport to the main component
struct global_geometry_element_struct global_geometry_element;

#ifndef ANY_GEOMETRY_DETECTOR_DECLARE
    #define ANY_GEOMETRY_DETECTOR_DECLARE dummy
	//struct pointer_to_global_geometry_list global_geometry_list = {0,NULL};
#endif

int loop_index,found_geometries;

double x_component;
double y_component;
double z_component;

struct Volume_struct this_box_volume;
struct box_storage this_box_storage;

#line 40139 "MACS_sample_kidney_box.c"
#undef number_of_activations
#undef mask_setting
#undef mask_string
#undef p_interact
#undef focus_r
#undef focus_xh
#undef focus_xw
#undef focus_ah
#undef focus_aw
#undef target_z
#undef target_y
#undef target_x
#undef target_index
#undef visualize
#undef yheight2
#undef xwidth2
#undef zdepth
#undef yheight
#undef xwidth
#undef priority
#undef material_string
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

/* User declarations for component 'channel_2_analyzer_2_array_crystal_array_7' [224]. */
#define mccompcurname  channel_2_analyzer_2_array_crystal_array_7
#define mccompcurtype  Union_box
#define mccompcurindex 224
#define loop_index mccchannel_2_analyzer_2_array_crystal_array_7_loop_index
#define this_box_volume mccchannel_2_analyzer_2_array_crystal_array_7_this_box_volume
#define global_geometry_element mccchannel_2_analyzer_2_array_crystal_array_7_global_geometry_element
#define this_box_storage mccchannel_2_analyzer_2_array_crystal_array_7_this_box_storage
#define material_string mccchannel_2_analyzer_2_array_crystal_array_7_material_string
#define priority mccchannel_2_analyzer_2_array_crystal_array_7_priority
#define xwidth mccchannel_2_analyzer_2_array_crystal_array_7_xwidth
#define yheight mccchannel_2_analyzer_2_array_crystal_array_7_yheight
#define zdepth mccchannel_2_analyzer_2_array_crystal_array_7_zdepth
#define xwidth2 mccchannel_2_analyzer_2_array_crystal_array_7_xwidth2
#define yheight2 mccchannel_2_analyzer_2_array_crystal_array_7_yheight2
#define visualize mccchannel_2_analyzer_2_array_crystal_array_7_visualize
#define target_index mccchannel_2_analyzer_2_array_crystal_array_7_target_index
#define target_x mccchannel_2_analyzer_2_array_crystal_array_7_target_x
#define target_y mccchannel_2_analyzer_2_array_crystal_array_7_target_y
#define target_z mccchannel_2_analyzer_2_array_crystal_array_7_target_z
#define focus_aw mccchannel_2_analyzer_2_array_crystal_array_7_focus_aw
#define focus_ah mccchannel_2_analyzer_2_array_crystal_array_7_focus_ah
#define focus_xw mccchannel_2_analyzer_2_array_crystal_array_7_focus_xw
#define focus_xh mccchannel_2_analyzer_2_array_crystal_array_7_focus_xh
#define focus_r mccchannel_2_analyzer_2_array_crystal_array_7_focus_r
#define p_interact mccchannel_2_analyzer_2_array_crystal_array_7_p_interact
#define mask_string mccchannel_2_analyzer_2_array_crystal_array_7_mask_string
#define mask_setting mccchannel_2_analyzer_2_array_crystal_array_7_mask_setting
#define number_of_activations mccchannel_2_analyzer_2_array_crystal_array_7_number_of_activations
#line 204 "Union_box.comp"
// Needed for transport to the main component
struct global_geometry_element_struct global_geometry_element;

#ifndef ANY_GEOMETRY_DETECTOR_DECLARE
    #define ANY_GEOMETRY_DETECTOR_DECLARE dummy
	//struct pointer_to_global_geometry_list global_geometry_list = {0,NULL};
#endif

int loop_index,found_geometries;

double x_component;
double y_component;
double z_component;

struct Volume_struct this_box_volume;
struct box_storage this_box_storage;

#line 40216 "MACS_sample_kidney_box.c"
#undef number_of_activations
#undef mask_setting
#undef mask_string
#undef p_interact
#undef focus_r
#undef focus_xh
#undef focus_xw
#undef focus_ah
#undef focus_aw
#undef target_z
#undef target_y
#undef target_x
#undef target_index
#undef visualize
#undef yheight2
#undef xwidth2
#undef zdepth
#undef yheight
#undef xwidth
#undef priority
#undef material_string
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

/* User declarations for component 'channel_2_analyzer_2_array_crystal_array_8' [225]. */
#define mccompcurname  channel_2_analyzer_2_array_crystal_array_8
#define mccompcurtype  Union_box
#define mccompcurindex 225
#define loop_index mccchannel_2_analyzer_2_array_crystal_array_8_loop_index
#define this_box_volume mccchannel_2_analyzer_2_array_crystal_array_8_this_box_volume
#define global_geometry_element mccchannel_2_analyzer_2_array_crystal_array_8_global_geometry_element
#define this_box_storage mccchannel_2_analyzer_2_array_crystal_array_8_this_box_storage
#define material_string mccchannel_2_analyzer_2_array_crystal_array_8_material_string
#define priority mccchannel_2_analyzer_2_array_crystal_array_8_priority
#define xwidth mccchannel_2_analyzer_2_array_crystal_array_8_xwidth
#define yheight mccchannel_2_analyzer_2_array_crystal_array_8_yheight
#define zdepth mccchannel_2_analyzer_2_array_crystal_array_8_zdepth
#define xwidth2 mccchannel_2_analyzer_2_array_crystal_array_8_xwidth2
#define yheight2 mccchannel_2_analyzer_2_array_crystal_array_8_yheight2
#define visualize mccchannel_2_analyzer_2_array_crystal_array_8_visualize
#define target_index mccchannel_2_analyzer_2_array_crystal_array_8_target_index
#define target_x mccchannel_2_analyzer_2_array_crystal_array_8_target_x
#define target_y mccchannel_2_analyzer_2_array_crystal_array_8_target_y
#define target_z mccchannel_2_analyzer_2_array_crystal_array_8_target_z
#define focus_aw mccchannel_2_analyzer_2_array_crystal_array_8_focus_aw
#define focus_ah mccchannel_2_analyzer_2_array_crystal_array_8_focus_ah
#define focus_xw mccchannel_2_analyzer_2_array_crystal_array_8_focus_xw
#define focus_xh mccchannel_2_analyzer_2_array_crystal_array_8_focus_xh
#define focus_r mccchannel_2_analyzer_2_array_crystal_array_8_focus_r
#define p_interact mccchannel_2_analyzer_2_array_crystal_array_8_p_interact
#define mask_string mccchannel_2_analyzer_2_array_crystal_array_8_mask_string
#define mask_setting mccchannel_2_analyzer_2_array_crystal_array_8_mask_setting
#define number_of_activations mccchannel_2_analyzer_2_array_crystal_array_8_number_of_activations
#line 204 "Union_box.comp"
// Needed for transport to the main component
struct global_geometry_element_struct global_geometry_element;

#ifndef ANY_GEOMETRY_DETECTOR_DECLARE
    #define ANY_GEOMETRY_DETECTOR_DECLARE dummy
	//struct pointer_to_global_geometry_list global_geometry_list = {0,NULL};
#endif

int loop_index,found_geometries;

double x_component;
double y_component;
double z_component;

struct Volume_struct this_box_volume;
struct box_storage this_box_storage;

#line 40293 "MACS_sample_kidney_box.c"
#undef number_of_activations
#undef mask_setting
#undef mask_string
#undef p_interact
#undef focus_r
#undef focus_xh
#undef focus_xw
#undef focus_ah
#undef focus_aw
#undef target_z
#undef target_y
#undef target_x
#undef target_index
#undef visualize
#undef yheight2
#undef xwidth2
#undef zdepth
#undef yheight
#undef xwidth
#undef priority
#undef material_string
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

/* User declarations for component 'channel_2_cave2_cyl1' [226]. */
#define mccompcurname  channel_2_cave2_cyl1
#define mccompcurtype  Union_cylinder
#define mccompcurindex 226
#define loop_index mccchannel_2_cave2_cyl1_loop_index
#define this_cylinder_volume mccchannel_2_cave2_cyl1_this_cylinder_volume
#define global_geometry_element mccchannel_2_cave2_cyl1_global_geometry_element
#define this_cylinder_storage mccchannel_2_cave2_cyl1_this_cylinder_storage
#define material_string mccchannel_2_cave2_cyl1_material_string
#define priority mccchannel_2_cave2_cyl1_priority
#define radius mccchannel_2_cave2_cyl1_radius
#define yheight mccchannel_2_cave2_cyl1_yheight
#define visualize mccchannel_2_cave2_cyl1_visualize
#define target_index mccchannel_2_cave2_cyl1_target_index
#define target_x mccchannel_2_cave2_cyl1_target_x
#define target_y mccchannel_2_cave2_cyl1_target_y
#define target_z mccchannel_2_cave2_cyl1_target_z
#define focus_aw mccchannel_2_cave2_cyl1_focus_aw
#define focus_ah mccchannel_2_cave2_cyl1_focus_ah
#define focus_xw mccchannel_2_cave2_cyl1_focus_xw
#define focus_xh mccchannel_2_cave2_cyl1_focus_xh
#define focus_r mccchannel_2_cave2_cyl1_focus_r
#define p_interact mccchannel_2_cave2_cyl1_p_interact
#define mask_string mccchannel_2_cave2_cyl1_mask_string
#define mask_setting mccchannel_2_cave2_cyl1_mask_setting
#define number_of_activations mccchannel_2_cave2_cyl1_number_of_activations
#line 167 "Union_cylinder.comp"
// Needed for transport to the main component
struct global_geometry_element_struct global_geometry_element;

#ifndef ANY_GEOMETRY_DETECTOR_DECLARE
    #define ANY_GEOMETRY_DETECTOR_DECLARE dummy
	//struct pointer_to_global_geometry_list global_geometry_list = {0,NULL};
#endif

int dummy;
int loop_index,found_geometries;
int loop_2_index;
int material_index;

struct Volume_struct this_cylinder_volume;
struct cylinder_storage this_cylinder_storage;
#line 40365 "MACS_sample_kidney_box.c"
#undef number_of_activations
#undef mask_setting
#undef mask_string
#undef p_interact
#undef focus_r
#undef focus_xh
#undef focus_xw
#undef focus_ah
#undef focus_aw
#undef target_z
#undef target_y
#undef target_x
#undef target_index
#undef visualize
#undef yheight
#undef radius
#undef priority
#undef material_string
#undef this_cylinder_storage
#undef global_geometry_element
#undef this_cylinder_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

/* User declarations for component 'channel_2_cave2_box1' [227]. */
#define mccompcurname  channel_2_cave2_box1
#define mccompcurtype  Union_box
#define mccompcurindex 227
#define loop_index mccchannel_2_cave2_box1_loop_index
#define this_box_volume mccchannel_2_cave2_box1_this_box_volume
#define global_geometry_element mccchannel_2_cave2_box1_global_geometry_element
#define this_box_storage mccchannel_2_cave2_box1_this_box_storage
#define material_string mccchannel_2_cave2_box1_material_string
#define priority mccchannel_2_cave2_box1_priority
#define xwidth mccchannel_2_cave2_box1_xwidth
#define yheight mccchannel_2_cave2_box1_yheight
#define zdepth mccchannel_2_cave2_box1_zdepth
#define xwidth2 mccchannel_2_cave2_box1_xwidth2
#define yheight2 mccchannel_2_cave2_box1_yheight2
#define visualize mccchannel_2_cave2_box1_visualize
#define target_index mccchannel_2_cave2_box1_target_index
#define target_x mccchannel_2_cave2_box1_target_x
#define target_y mccchannel_2_cave2_box1_target_y
#define target_z mccchannel_2_cave2_box1_target_z
#define focus_aw mccchannel_2_cave2_box1_focus_aw
#define focus_ah mccchannel_2_cave2_box1_focus_ah
#define focus_xw mccchannel_2_cave2_box1_focus_xw
#define focus_xh mccchannel_2_cave2_box1_focus_xh
#define focus_r mccchannel_2_cave2_box1_focus_r
#define p_interact mccchannel_2_cave2_box1_p_interact
#define mask_string mccchannel_2_cave2_box1_mask_string
#define mask_setting mccchannel_2_cave2_box1_mask_setting
#define number_of_activations mccchannel_2_cave2_box1_number_of_activations
#line 204 "Union_box.comp"
// Needed for transport to the main component
struct global_geometry_element_struct global_geometry_element;

#ifndef ANY_GEOMETRY_DETECTOR_DECLARE
    #define ANY_GEOMETRY_DETECTOR_DECLARE dummy
	//struct pointer_to_global_geometry_list global_geometry_list = {0,NULL};
#endif

int loop_index,found_geometries;

double x_component;
double y_component;
double z_component;

struct Volume_struct this_box_volume;
struct box_storage this_box_storage;

#line 40439 "MACS_sample_kidney_box.c"
#undef number_of_activations
#undef mask_setting
#undef mask_string
#undef p_interact
#undef focus_r
#undef focus_xh
#undef focus_xw
#undef focus_ah
#undef focus_aw
#undef target_z
#undef target_y
#undef target_x
#undef target_index
#undef visualize
#undef yheight2
#undef xwidth2
#undef zdepth
#undef yheight
#undef xwidth
#undef priority
#undef material_string
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

/* User declarations for component 'channel_2_cave2_box2' [228]. */
#define mccompcurname  channel_2_cave2_box2
#define mccompcurtype  Union_box
#define mccompcurindex 228
#define loop_index mccchannel_2_cave2_box2_loop_index
#define this_box_volume mccchannel_2_cave2_box2_this_box_volume
#define global_geometry_element mccchannel_2_cave2_box2_global_geometry_element
#define this_box_storage mccchannel_2_cave2_box2_this_box_storage
#define material_string mccchannel_2_cave2_box2_material_string
#define priority mccchannel_2_cave2_box2_priority
#define xwidth mccchannel_2_cave2_box2_xwidth
#define yheight mccchannel_2_cave2_box2_yheight
#define zdepth mccchannel_2_cave2_box2_zdepth
#define xwidth2 mccchannel_2_cave2_box2_xwidth2
#define yheight2 mccchannel_2_cave2_box2_yheight2
#define visualize mccchannel_2_cave2_box2_visualize
#define target_index mccchannel_2_cave2_box2_target_index
#define target_x mccchannel_2_cave2_box2_target_x
#define target_y mccchannel_2_cave2_box2_target_y
#define target_z mccchannel_2_cave2_box2_target_z
#define focus_aw mccchannel_2_cave2_box2_focus_aw
#define focus_ah mccchannel_2_cave2_box2_focus_ah
#define focus_xw mccchannel_2_cave2_box2_focus_xw
#define focus_xh mccchannel_2_cave2_box2_focus_xh
#define focus_r mccchannel_2_cave2_box2_focus_r
#define p_interact mccchannel_2_cave2_box2_p_interact
#define mask_string mccchannel_2_cave2_box2_mask_string
#define mask_setting mccchannel_2_cave2_box2_mask_setting
#define number_of_activations mccchannel_2_cave2_box2_number_of_activations
#line 204 "Union_box.comp"
// Needed for transport to the main component
struct global_geometry_element_struct global_geometry_element;

#ifndef ANY_GEOMETRY_DETECTOR_DECLARE
    #define ANY_GEOMETRY_DETECTOR_DECLARE dummy
	//struct pointer_to_global_geometry_list global_geometry_list = {0,NULL};
#endif

int loop_index,found_geometries;

double x_component;
double y_component;
double z_component;

struct Volume_struct this_box_volume;
struct box_storage this_box_storage;

#line 40516 "MACS_sample_kidney_box.c"
#undef number_of_activations
#undef mask_setting
#undef mask_string
#undef p_interact
#undef focus_r
#undef focus_xh
#undef focus_xw
#undef focus_ah
#undef focus_aw
#undef target_z
#undef target_y
#undef target_x
#undef target_index
#undef visualize
#undef yheight2
#undef xwidth2
#undef zdepth
#undef yheight
#undef xwidth
#undef priority
#undef material_string
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

/* User declarations for component 'channel_2_cave2_box3' [229]. */
#define mccompcurname  channel_2_cave2_box3
#define mccompcurtype  Union_box
#define mccompcurindex 229
#define loop_index mccchannel_2_cave2_box3_loop_index
#define this_box_volume mccchannel_2_cave2_box3_this_box_volume
#define global_geometry_element mccchannel_2_cave2_box3_global_geometry_element
#define this_box_storage mccchannel_2_cave2_box3_this_box_storage
#define material_string mccchannel_2_cave2_box3_material_string
#define priority mccchannel_2_cave2_box3_priority
#define xwidth mccchannel_2_cave2_box3_xwidth
#define yheight mccchannel_2_cave2_box3_yheight
#define zdepth mccchannel_2_cave2_box3_zdepth
#define xwidth2 mccchannel_2_cave2_box3_xwidth2
#define yheight2 mccchannel_2_cave2_box3_yheight2
#define visualize mccchannel_2_cave2_box3_visualize
#define target_index mccchannel_2_cave2_box3_target_index
#define target_x mccchannel_2_cave2_box3_target_x
#define target_y mccchannel_2_cave2_box3_target_y
#define target_z mccchannel_2_cave2_box3_target_z
#define focus_aw mccchannel_2_cave2_box3_focus_aw
#define focus_ah mccchannel_2_cave2_box3_focus_ah
#define focus_xw mccchannel_2_cave2_box3_focus_xw
#define focus_xh mccchannel_2_cave2_box3_focus_xh
#define focus_r mccchannel_2_cave2_box3_focus_r
#define p_interact mccchannel_2_cave2_box3_p_interact
#define mask_string mccchannel_2_cave2_box3_mask_string
#define mask_setting mccchannel_2_cave2_box3_mask_setting
#define number_of_activations mccchannel_2_cave2_box3_number_of_activations
#line 204 "Union_box.comp"
// Needed for transport to the main component
struct global_geometry_element_struct global_geometry_element;

#ifndef ANY_GEOMETRY_DETECTOR_DECLARE
    #define ANY_GEOMETRY_DETECTOR_DECLARE dummy
	//struct pointer_to_global_geometry_list global_geometry_list = {0,NULL};
#endif

int loop_index,found_geometries;

double x_component;
double y_component;
double z_component;

struct Volume_struct this_box_volume;
struct box_storage this_box_storage;

#line 40593 "MACS_sample_kidney_box.c"
#undef number_of_activations
#undef mask_setting
#undef mask_string
#undef p_interact
#undef focus_r
#undef focus_xh
#undef focus_xw
#undef focus_ah
#undef focus_aw
#undef target_z
#undef target_y
#undef target_x
#undef target_index
#undef visualize
#undef yheight2
#undef xwidth2
#undef zdepth
#undef yheight
#undef xwidth
#undef priority
#undef material_string
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

/* User declarations for component 'inter_analyzer_colimator_center_2' [230]. */
#define mccompcurname  inter_analyzer_colimator_center_2
#define mccompcurtype  Arm
#define mccompcurindex 230
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

/* User declarations for component 'inter_analyzer_colimator_2_blade_0' [231]. */
#define mccompcurname  inter_analyzer_colimator_2_blade_0
#define mccompcurtype  Union_box
#define mccompcurindex 231
#define loop_index mccinter_analyzer_colimator_2_blade_0_loop_index
#define this_box_volume mccinter_analyzer_colimator_2_blade_0_this_box_volume
#define global_geometry_element mccinter_analyzer_colimator_2_blade_0_global_geometry_element
#define this_box_storage mccinter_analyzer_colimator_2_blade_0_this_box_storage
#define material_string mccinter_analyzer_colimator_2_blade_0_material_string
#define priority mccinter_analyzer_colimator_2_blade_0_priority
#define xwidth mccinter_analyzer_colimator_2_blade_0_xwidth
#define yheight mccinter_analyzer_colimator_2_blade_0_yheight
#define zdepth mccinter_analyzer_colimator_2_blade_0_zdepth
#define xwidth2 mccinter_analyzer_colimator_2_blade_0_xwidth2
#define yheight2 mccinter_analyzer_colimator_2_blade_0_yheight2
#define visualize mccinter_analyzer_colimator_2_blade_0_visualize
#define target_index mccinter_analyzer_colimator_2_blade_0_target_index
#define target_x mccinter_analyzer_colimator_2_blade_0_target_x
#define target_y mccinter_analyzer_colimator_2_blade_0_target_y
#define target_z mccinter_analyzer_colimator_2_blade_0_target_z
#define focus_aw mccinter_analyzer_colimator_2_blade_0_focus_aw
#define focus_ah mccinter_analyzer_colimator_2_blade_0_focus_ah
#define focus_xw mccinter_analyzer_colimator_2_blade_0_focus_xw
#define focus_xh mccinter_analyzer_colimator_2_blade_0_focus_xh
#define focus_r mccinter_analyzer_colimator_2_blade_0_focus_r
#define p_interact mccinter_analyzer_colimator_2_blade_0_p_interact
#define mask_string mccinter_analyzer_colimator_2_blade_0_mask_string
#define mask_setting mccinter_analyzer_colimator_2_blade_0_mask_setting
#define number_of_activations mccinter_analyzer_colimator_2_blade_0_number_of_activations
#line 204 "Union_box.comp"
// Needed for transport to the main component
struct global_geometry_element_struct global_geometry_element;

#ifndef ANY_GEOMETRY_DETECTOR_DECLARE
    #define ANY_GEOMETRY_DETECTOR_DECLARE dummy
	//struct pointer_to_global_geometry_list global_geometry_list = {0,NULL};
#endif

int loop_index,found_geometries;

double x_component;
double y_component;
double z_component;

struct Volume_struct this_box_volume;
struct box_storage this_box_storage;

#line 40678 "MACS_sample_kidney_box.c"
#undef number_of_activations
#undef mask_setting
#undef mask_string
#undef p_interact
#undef focus_r
#undef focus_xh
#undef focus_xw
#undef focus_ah
#undef focus_aw
#undef target_z
#undef target_y
#undef target_x
#undef target_index
#undef visualize
#undef yheight2
#undef xwidth2
#undef zdepth
#undef yheight
#undef xwidth
#undef priority
#undef material_string
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

/* User declarations for component 'inter_analyzer_colimator_2_blade_1' [232]. */
#define mccompcurname  inter_analyzer_colimator_2_blade_1
#define mccompcurtype  Union_box
#define mccompcurindex 232
#define loop_index mccinter_analyzer_colimator_2_blade_1_loop_index
#define this_box_volume mccinter_analyzer_colimator_2_blade_1_this_box_volume
#define global_geometry_element mccinter_analyzer_colimator_2_blade_1_global_geometry_element
#define this_box_storage mccinter_analyzer_colimator_2_blade_1_this_box_storage
#define material_string mccinter_analyzer_colimator_2_blade_1_material_string
#define priority mccinter_analyzer_colimator_2_blade_1_priority
#define xwidth mccinter_analyzer_colimator_2_blade_1_xwidth
#define yheight mccinter_analyzer_colimator_2_blade_1_yheight
#define zdepth mccinter_analyzer_colimator_2_blade_1_zdepth
#define xwidth2 mccinter_analyzer_colimator_2_blade_1_xwidth2
#define yheight2 mccinter_analyzer_colimator_2_blade_1_yheight2
#define visualize mccinter_analyzer_colimator_2_blade_1_visualize
#define target_index mccinter_analyzer_colimator_2_blade_1_target_index
#define target_x mccinter_analyzer_colimator_2_blade_1_target_x
#define target_y mccinter_analyzer_colimator_2_blade_1_target_y
#define target_z mccinter_analyzer_colimator_2_blade_1_target_z
#define focus_aw mccinter_analyzer_colimator_2_blade_1_focus_aw
#define focus_ah mccinter_analyzer_colimator_2_blade_1_focus_ah
#define focus_xw mccinter_analyzer_colimator_2_blade_1_focus_xw
#define focus_xh mccinter_analyzer_colimator_2_blade_1_focus_xh
#define focus_r mccinter_analyzer_colimator_2_blade_1_focus_r
#define p_interact mccinter_analyzer_colimator_2_blade_1_p_interact
#define mask_string mccinter_analyzer_colimator_2_blade_1_mask_string
#define mask_setting mccinter_analyzer_colimator_2_blade_1_mask_setting
#define number_of_activations mccinter_analyzer_colimator_2_blade_1_number_of_activations
#line 204 "Union_box.comp"
// Needed for transport to the main component
struct global_geometry_element_struct global_geometry_element;

#ifndef ANY_GEOMETRY_DETECTOR_DECLARE
    #define ANY_GEOMETRY_DETECTOR_DECLARE dummy
	//struct pointer_to_global_geometry_list global_geometry_list = {0,NULL};
#endif

int loop_index,found_geometries;

double x_component;
double y_component;
double z_component;

struct Volume_struct this_box_volume;
struct box_storage this_box_storage;

#line 40755 "MACS_sample_kidney_box.c"
#undef number_of_activations
#undef mask_setting
#undef mask_string
#undef p_interact
#undef focus_r
#undef focus_xh
#undef focus_xw
#undef focus_ah
#undef focus_aw
#undef target_z
#undef target_y
#undef target_x
#undef target_index
#undef visualize
#undef yheight2
#undef xwidth2
#undef zdepth
#undef yheight
#undef xwidth
#undef priority
#undef material_string
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

/* User declarations for component 'inter_analyzer_colimator_2_blade_2' [233]. */
#define mccompcurname  inter_analyzer_colimator_2_blade_2
#define mccompcurtype  Union_box
#define mccompcurindex 233
#define loop_index mccinter_analyzer_colimator_2_blade_2_loop_index
#define this_box_volume mccinter_analyzer_colimator_2_blade_2_this_box_volume
#define global_geometry_element mccinter_analyzer_colimator_2_blade_2_global_geometry_element
#define this_box_storage mccinter_analyzer_colimator_2_blade_2_this_box_storage
#define material_string mccinter_analyzer_colimator_2_blade_2_material_string
#define priority mccinter_analyzer_colimator_2_blade_2_priority
#define xwidth mccinter_analyzer_colimator_2_blade_2_xwidth
#define yheight mccinter_analyzer_colimator_2_blade_2_yheight
#define zdepth mccinter_analyzer_colimator_2_blade_2_zdepth
#define xwidth2 mccinter_analyzer_colimator_2_blade_2_xwidth2
#define yheight2 mccinter_analyzer_colimator_2_blade_2_yheight2
#define visualize mccinter_analyzer_colimator_2_blade_2_visualize
#define target_index mccinter_analyzer_colimator_2_blade_2_target_index
#define target_x mccinter_analyzer_colimator_2_blade_2_target_x
#define target_y mccinter_analyzer_colimator_2_blade_2_target_y
#define target_z mccinter_analyzer_colimator_2_blade_2_target_z
#define focus_aw mccinter_analyzer_colimator_2_blade_2_focus_aw
#define focus_ah mccinter_analyzer_colimator_2_blade_2_focus_ah
#define focus_xw mccinter_analyzer_colimator_2_blade_2_focus_xw
#define focus_xh mccinter_analyzer_colimator_2_blade_2_focus_xh
#define focus_r mccinter_analyzer_colimator_2_blade_2_focus_r
#define p_interact mccinter_analyzer_colimator_2_blade_2_p_interact
#define mask_string mccinter_analyzer_colimator_2_blade_2_mask_string
#define mask_setting mccinter_analyzer_colimator_2_blade_2_mask_setting
#define number_of_activations mccinter_analyzer_colimator_2_blade_2_number_of_activations
#line 204 "Union_box.comp"
// Needed for transport to the main component
struct global_geometry_element_struct global_geometry_element;

#ifndef ANY_GEOMETRY_DETECTOR_DECLARE
    #define ANY_GEOMETRY_DETECTOR_DECLARE dummy
	//struct pointer_to_global_geometry_list global_geometry_list = {0,NULL};
#endif

int loop_index,found_geometries;

double x_component;
double y_component;
double z_component;

struct Volume_struct this_box_volume;
struct box_storage this_box_storage;

#line 40832 "MACS_sample_kidney_box.c"
#undef number_of_activations
#undef mask_setting
#undef mask_string
#undef p_interact
#undef focus_r
#undef focus_xh
#undef focus_xw
#undef focus_ah
#undef focus_aw
#undef target_z
#undef target_y
#undef target_x
#undef target_index
#undef visualize
#undef yheight2
#undef xwidth2
#undef zdepth
#undef yheight
#undef xwidth
#undef priority
#undef material_string
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

/* User declarations for component 'inter_analyzer_colimator_2_blade_3' [234]. */
#define mccompcurname  inter_analyzer_colimator_2_blade_3
#define mccompcurtype  Union_box
#define mccompcurindex 234
#define loop_index mccinter_analyzer_colimator_2_blade_3_loop_index
#define this_box_volume mccinter_analyzer_colimator_2_blade_3_this_box_volume
#define global_geometry_element mccinter_analyzer_colimator_2_blade_3_global_geometry_element
#define this_box_storage mccinter_analyzer_colimator_2_blade_3_this_box_storage
#define material_string mccinter_analyzer_colimator_2_blade_3_material_string
#define priority mccinter_analyzer_colimator_2_blade_3_priority
#define xwidth mccinter_analyzer_colimator_2_blade_3_xwidth
#define yheight mccinter_analyzer_colimator_2_blade_3_yheight
#define zdepth mccinter_analyzer_colimator_2_blade_3_zdepth
#define xwidth2 mccinter_analyzer_colimator_2_blade_3_xwidth2
#define yheight2 mccinter_analyzer_colimator_2_blade_3_yheight2
#define visualize mccinter_analyzer_colimator_2_blade_3_visualize
#define target_index mccinter_analyzer_colimator_2_blade_3_target_index
#define target_x mccinter_analyzer_colimator_2_blade_3_target_x
#define target_y mccinter_analyzer_colimator_2_blade_3_target_y
#define target_z mccinter_analyzer_colimator_2_blade_3_target_z
#define focus_aw mccinter_analyzer_colimator_2_blade_3_focus_aw
#define focus_ah mccinter_analyzer_colimator_2_blade_3_focus_ah
#define focus_xw mccinter_analyzer_colimator_2_blade_3_focus_xw
#define focus_xh mccinter_analyzer_colimator_2_blade_3_focus_xh
#define focus_r mccinter_analyzer_colimator_2_blade_3_focus_r
#define p_interact mccinter_analyzer_colimator_2_blade_3_p_interact
#define mask_string mccinter_analyzer_colimator_2_blade_3_mask_string
#define mask_setting mccinter_analyzer_colimator_2_blade_3_mask_setting
#define number_of_activations mccinter_analyzer_colimator_2_blade_3_number_of_activations
#line 204 "Union_box.comp"
// Needed for transport to the main component
struct global_geometry_element_struct global_geometry_element;

#ifndef ANY_GEOMETRY_DETECTOR_DECLARE
    #define ANY_GEOMETRY_DETECTOR_DECLARE dummy
	//struct pointer_to_global_geometry_list global_geometry_list = {0,NULL};
#endif

int loop_index,found_geometries;

double x_component;
double y_component;
double z_component;

struct Volume_struct this_box_volume;
struct box_storage this_box_storage;

#line 40909 "MACS_sample_kidney_box.c"
#undef number_of_activations
#undef mask_setting
#undef mask_string
#undef p_interact
#undef focus_r
#undef focus_xh
#undef focus_xw
#undef focus_ah
#undef focus_aw
#undef target_z
#undef target_y
#undef target_x
#undef target_index
#undef visualize
#undef yheight2
#undef xwidth2
#undef zdepth
#undef yheight
#undef xwidth
#undef priority
#undef material_string
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

/* User declarations for component 'inter_analyzer_colimator_2_blade_4' [235]. */
#define mccompcurname  inter_analyzer_colimator_2_blade_4
#define mccompcurtype  Union_box
#define mccompcurindex 235
#define loop_index mccinter_analyzer_colimator_2_blade_4_loop_index
#define this_box_volume mccinter_analyzer_colimator_2_blade_4_this_box_volume
#define global_geometry_element mccinter_analyzer_colimator_2_blade_4_global_geometry_element
#define this_box_storage mccinter_analyzer_colimator_2_blade_4_this_box_storage
#define material_string mccinter_analyzer_colimator_2_blade_4_material_string
#define priority mccinter_analyzer_colimator_2_blade_4_priority
#define xwidth mccinter_analyzer_colimator_2_blade_4_xwidth
#define yheight mccinter_analyzer_colimator_2_blade_4_yheight
#define zdepth mccinter_analyzer_colimator_2_blade_4_zdepth
#define xwidth2 mccinter_analyzer_colimator_2_blade_4_xwidth2
#define yheight2 mccinter_analyzer_colimator_2_blade_4_yheight2
#define visualize mccinter_analyzer_colimator_2_blade_4_visualize
#define target_index mccinter_analyzer_colimator_2_blade_4_target_index
#define target_x mccinter_analyzer_colimator_2_blade_4_target_x
#define target_y mccinter_analyzer_colimator_2_blade_4_target_y
#define target_z mccinter_analyzer_colimator_2_blade_4_target_z
#define focus_aw mccinter_analyzer_colimator_2_blade_4_focus_aw
#define focus_ah mccinter_analyzer_colimator_2_blade_4_focus_ah
#define focus_xw mccinter_analyzer_colimator_2_blade_4_focus_xw
#define focus_xh mccinter_analyzer_colimator_2_blade_4_focus_xh
#define focus_r mccinter_analyzer_colimator_2_blade_4_focus_r
#define p_interact mccinter_analyzer_colimator_2_blade_4_p_interact
#define mask_string mccinter_analyzer_colimator_2_blade_4_mask_string
#define mask_setting mccinter_analyzer_colimator_2_blade_4_mask_setting
#define number_of_activations mccinter_analyzer_colimator_2_blade_4_number_of_activations
#line 204 "Union_box.comp"
// Needed for transport to the main component
struct global_geometry_element_struct global_geometry_element;

#ifndef ANY_GEOMETRY_DETECTOR_DECLARE
    #define ANY_GEOMETRY_DETECTOR_DECLARE dummy
	//struct pointer_to_global_geometry_list global_geometry_list = {0,NULL};
#endif

int loop_index,found_geometries;

double x_component;
double y_component;
double z_component;

struct Volume_struct this_box_volume;
struct box_storage this_box_storage;

#line 40986 "MACS_sample_kidney_box.c"
#undef number_of_activations
#undef mask_setting
#undef mask_string
#undef p_interact
#undef focus_r
#undef focus_xh
#undef focus_xw
#undef focus_ah
#undef focus_aw
#undef target_z
#undef target_y
#undef target_x
#undef target_index
#undef visualize
#undef yheight2
#undef xwidth2
#undef zdepth
#undef yheight
#undef xwidth
#undef priority
#undef material_string
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

/* User declarations for component 'diffraction_detector_2_exit_volume' [236]. */
#define mccompcurname  diffraction_detector_2_exit_volume
#define mccompcurtype  Union_box
#define mccompcurindex 236
#define loop_index mccdiffraction_detector_2_exit_volume_loop_index
#define this_box_volume mccdiffraction_detector_2_exit_volume_this_box_volume
#define global_geometry_element mccdiffraction_detector_2_exit_volume_global_geometry_element
#define this_box_storage mccdiffraction_detector_2_exit_volume_this_box_storage
#define material_string mccdiffraction_detector_2_exit_volume_material_string
#define priority mccdiffraction_detector_2_exit_volume_priority
#define xwidth mccdiffraction_detector_2_exit_volume_xwidth
#define yheight mccdiffraction_detector_2_exit_volume_yheight
#define zdepth mccdiffraction_detector_2_exit_volume_zdepth
#define xwidth2 mccdiffraction_detector_2_exit_volume_xwidth2
#define yheight2 mccdiffraction_detector_2_exit_volume_yheight2
#define visualize mccdiffraction_detector_2_exit_volume_visualize
#define target_index mccdiffraction_detector_2_exit_volume_target_index
#define target_x mccdiffraction_detector_2_exit_volume_target_x
#define target_y mccdiffraction_detector_2_exit_volume_target_y
#define target_z mccdiffraction_detector_2_exit_volume_target_z
#define focus_aw mccdiffraction_detector_2_exit_volume_focus_aw
#define focus_ah mccdiffraction_detector_2_exit_volume_focus_ah
#define focus_xw mccdiffraction_detector_2_exit_volume_focus_xw
#define focus_xh mccdiffraction_detector_2_exit_volume_focus_xh
#define focus_r mccdiffraction_detector_2_exit_volume_focus_r
#define p_interact mccdiffraction_detector_2_exit_volume_p_interact
#define mask_string mccdiffraction_detector_2_exit_volume_mask_string
#define mask_setting mccdiffraction_detector_2_exit_volume_mask_setting
#define number_of_activations mccdiffraction_detector_2_exit_volume_number_of_activations
#line 204 "Union_box.comp"
// Needed for transport to the main component
struct global_geometry_element_struct global_geometry_element;

#ifndef ANY_GEOMETRY_DETECTOR_DECLARE
    #define ANY_GEOMETRY_DETECTOR_DECLARE dummy
	//struct pointer_to_global_geometry_list global_geometry_list = {0,NULL};
#endif

int loop_index,found_geometries;

double x_component;
double y_component;
double z_component;

struct Volume_struct this_box_volume;
struct box_storage this_box_storage;

#line 41063 "MACS_sample_kidney_box.c"
#undef number_of_activations
#undef mask_setting
#undef mask_string
#undef p_interact
#undef focus_r
#undef focus_xh
#undef focus_xw
#undef focus_ah
#undef focus_aw
#undef target_z
#undef target_y
#undef target_x
#undef target_index
#undef visualize
#undef yheight2
#undef xwidth2
#undef zdepth
#undef yheight
#undef xwidth
#undef priority
#undef material_string
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

/* User declarations for component 'spec_detector_2_exit_volume' [237]. */
#define mccompcurname  spec_detector_2_exit_volume
#define mccompcurtype  Union_box
#define mccompcurindex 237
#define loop_index mccspec_detector_2_exit_volume_loop_index
#define this_box_volume mccspec_detector_2_exit_volume_this_box_volume
#define global_geometry_element mccspec_detector_2_exit_volume_global_geometry_element
#define this_box_storage mccspec_detector_2_exit_volume_this_box_storage
#define material_string mccspec_detector_2_exit_volume_material_string
#define priority mccspec_detector_2_exit_volume_priority
#define xwidth mccspec_detector_2_exit_volume_xwidth
#define yheight mccspec_detector_2_exit_volume_yheight
#define zdepth mccspec_detector_2_exit_volume_zdepth
#define xwidth2 mccspec_detector_2_exit_volume_xwidth2
#define yheight2 mccspec_detector_2_exit_volume_yheight2
#define visualize mccspec_detector_2_exit_volume_visualize
#define target_index mccspec_detector_2_exit_volume_target_index
#define target_x mccspec_detector_2_exit_volume_target_x
#define target_y mccspec_detector_2_exit_volume_target_y
#define target_z mccspec_detector_2_exit_volume_target_z
#define focus_aw mccspec_detector_2_exit_volume_focus_aw
#define focus_ah mccspec_detector_2_exit_volume_focus_ah
#define focus_xw mccspec_detector_2_exit_volume_focus_xw
#define focus_xh mccspec_detector_2_exit_volume_focus_xh
#define focus_r mccspec_detector_2_exit_volume_focus_r
#define p_interact mccspec_detector_2_exit_volume_p_interact
#define mask_string mccspec_detector_2_exit_volume_mask_string
#define mask_setting mccspec_detector_2_exit_volume_mask_setting
#define number_of_activations mccspec_detector_2_exit_volume_number_of_activations
#line 204 "Union_box.comp"
// Needed for transport to the main component
struct global_geometry_element_struct global_geometry_element;

#ifndef ANY_GEOMETRY_DETECTOR_DECLARE
    #define ANY_GEOMETRY_DETECTOR_DECLARE dummy
	//struct pointer_to_global_geometry_list global_geometry_list = {0,NULL};
#endif

int loop_index,found_geometries;

double x_component;
double y_component;
double z_component;

struct Volume_struct this_box_volume;
struct box_storage this_box_storage;

#line 41140 "MACS_sample_kidney_box.c"
#undef number_of_activations
#undef mask_setting
#undef mask_string
#undef p_interact
#undef focus_r
#undef focus_xh
#undef focus_xw
#undef focus_ah
#undef focus_aw
#undef target_z
#undef target_y
#undef target_x
#undef target_index
#undef visualize
#undef yheight2
#undef xwidth2
#undef zdepth
#undef yheight
#undef xwidth
#undef priority
#undef material_string
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

/* User declarations for component 'channel_3_cave1_box1' [238]. */
#define mccompcurname  channel_3_cave1_box1
#define mccompcurtype  Union_box
#define mccompcurindex 238
#define loop_index mccchannel_3_cave1_box1_loop_index
#define this_box_volume mccchannel_3_cave1_box1_this_box_volume
#define global_geometry_element mccchannel_3_cave1_box1_global_geometry_element
#define this_box_storage mccchannel_3_cave1_box1_this_box_storage
#define material_string mccchannel_3_cave1_box1_material_string
#define priority mccchannel_3_cave1_box1_priority
#define xwidth mccchannel_3_cave1_box1_xwidth
#define yheight mccchannel_3_cave1_box1_yheight
#define zdepth mccchannel_3_cave1_box1_zdepth
#define xwidth2 mccchannel_3_cave1_box1_xwidth2
#define yheight2 mccchannel_3_cave1_box1_yheight2
#define visualize mccchannel_3_cave1_box1_visualize
#define target_index mccchannel_3_cave1_box1_target_index
#define target_x mccchannel_3_cave1_box1_target_x
#define target_y mccchannel_3_cave1_box1_target_y
#define target_z mccchannel_3_cave1_box1_target_z
#define focus_aw mccchannel_3_cave1_box1_focus_aw
#define focus_ah mccchannel_3_cave1_box1_focus_ah
#define focus_xw mccchannel_3_cave1_box1_focus_xw
#define focus_xh mccchannel_3_cave1_box1_focus_xh
#define focus_r mccchannel_3_cave1_box1_focus_r
#define p_interact mccchannel_3_cave1_box1_p_interact
#define mask_string mccchannel_3_cave1_box1_mask_string
#define mask_setting mccchannel_3_cave1_box1_mask_setting
#define number_of_activations mccchannel_3_cave1_box1_number_of_activations
#line 204 "Union_box.comp"
// Needed for transport to the main component
struct global_geometry_element_struct global_geometry_element;

#ifndef ANY_GEOMETRY_DETECTOR_DECLARE
    #define ANY_GEOMETRY_DETECTOR_DECLARE dummy
	//struct pointer_to_global_geometry_list global_geometry_list = {0,NULL};
#endif

int loop_index,found_geometries;

double x_component;
double y_component;
double z_component;

struct Volume_struct this_box_volume;
struct box_storage this_box_storage;

#line 41217 "MACS_sample_kidney_box.c"
#undef number_of_activations
#undef mask_setting
#undef mask_string
#undef p_interact
#undef focus_r
#undef focus_xh
#undef focus_xw
#undef focus_ah
#undef focus_aw
#undef target_z
#undef target_y
#undef target_x
#undef target_index
#undef visualize
#undef yheight2
#undef xwidth2
#undef zdepth
#undef yheight
#undef xwidth
#undef priority
#undef material_string
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

/* User declarations for component 'channel_3_cave1_box2' [239]. */
#define mccompcurname  channel_3_cave1_box2
#define mccompcurtype  Union_box
#define mccompcurindex 239
#define loop_index mccchannel_3_cave1_box2_loop_index
#define this_box_volume mccchannel_3_cave1_box2_this_box_volume
#define global_geometry_element mccchannel_3_cave1_box2_global_geometry_element
#define this_box_storage mccchannel_3_cave1_box2_this_box_storage
#define material_string mccchannel_3_cave1_box2_material_string
#define priority mccchannel_3_cave1_box2_priority
#define xwidth mccchannel_3_cave1_box2_xwidth
#define yheight mccchannel_3_cave1_box2_yheight
#define zdepth mccchannel_3_cave1_box2_zdepth
#define xwidth2 mccchannel_3_cave1_box2_xwidth2
#define yheight2 mccchannel_3_cave1_box2_yheight2
#define visualize mccchannel_3_cave1_box2_visualize
#define target_index mccchannel_3_cave1_box2_target_index
#define target_x mccchannel_3_cave1_box2_target_x
#define target_y mccchannel_3_cave1_box2_target_y
#define target_z mccchannel_3_cave1_box2_target_z
#define focus_aw mccchannel_3_cave1_box2_focus_aw
#define focus_ah mccchannel_3_cave1_box2_focus_ah
#define focus_xw mccchannel_3_cave1_box2_focus_xw
#define focus_xh mccchannel_3_cave1_box2_focus_xh
#define focus_r mccchannel_3_cave1_box2_focus_r
#define p_interact mccchannel_3_cave1_box2_p_interact
#define mask_string mccchannel_3_cave1_box2_mask_string
#define mask_setting mccchannel_3_cave1_box2_mask_setting
#define number_of_activations mccchannel_3_cave1_box2_number_of_activations
#line 204 "Union_box.comp"
// Needed for transport to the main component
struct global_geometry_element_struct global_geometry_element;

#ifndef ANY_GEOMETRY_DETECTOR_DECLARE
    #define ANY_GEOMETRY_DETECTOR_DECLARE dummy
	//struct pointer_to_global_geometry_list global_geometry_list = {0,NULL};
#endif

int loop_index,found_geometries;

double x_component;
double y_component;
double z_component;

struct Volume_struct this_box_volume;
struct box_storage this_box_storage;

#line 41294 "MACS_sample_kidney_box.c"
#undef number_of_activations
#undef mask_setting
#undef mask_string
#undef p_interact
#undef focus_r
#undef focus_xh
#undef focus_xw
#undef focus_ah
#undef focus_aw
#undef target_z
#undef target_y
#undef target_x
#undef target_index
#undef visualize
#undef yheight2
#undef xwidth2
#undef zdepth
#undef yheight
#undef xwidth
#undef priority
#undef material_string
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

/* User declarations for component 'channel_3_cave1_box3' [240]. */
#define mccompcurname  channel_3_cave1_box3
#define mccompcurtype  Union_box
#define mccompcurindex 240
#define loop_index mccchannel_3_cave1_box3_loop_index
#define this_box_volume mccchannel_3_cave1_box3_this_box_volume
#define global_geometry_element mccchannel_3_cave1_box3_global_geometry_element
#define this_box_storage mccchannel_3_cave1_box3_this_box_storage
#define material_string mccchannel_3_cave1_box3_material_string
#define priority mccchannel_3_cave1_box3_priority
#define xwidth mccchannel_3_cave1_box3_xwidth
#define yheight mccchannel_3_cave1_box3_yheight
#define zdepth mccchannel_3_cave1_box3_zdepth
#define xwidth2 mccchannel_3_cave1_box3_xwidth2
#define yheight2 mccchannel_3_cave1_box3_yheight2
#define visualize mccchannel_3_cave1_box3_visualize
#define target_index mccchannel_3_cave1_box3_target_index
#define target_x mccchannel_3_cave1_box3_target_x
#define target_y mccchannel_3_cave1_box3_target_y
#define target_z mccchannel_3_cave1_box3_target_z
#define focus_aw mccchannel_3_cave1_box3_focus_aw
#define focus_ah mccchannel_3_cave1_box3_focus_ah
#define focus_xw mccchannel_3_cave1_box3_focus_xw
#define focus_xh mccchannel_3_cave1_box3_focus_xh
#define focus_r mccchannel_3_cave1_box3_focus_r
#define p_interact mccchannel_3_cave1_box3_p_interact
#define mask_string mccchannel_3_cave1_box3_mask_string
#define mask_setting mccchannel_3_cave1_box3_mask_setting
#define number_of_activations mccchannel_3_cave1_box3_number_of_activations
#line 204 "Union_box.comp"
// Needed for transport to the main component
struct global_geometry_element_struct global_geometry_element;

#ifndef ANY_GEOMETRY_DETECTOR_DECLARE
    #define ANY_GEOMETRY_DETECTOR_DECLARE dummy
	//struct pointer_to_global_geometry_list global_geometry_list = {0,NULL};
#endif

int loop_index,found_geometries;

double x_component;
double y_component;
double z_component;

struct Volume_struct this_box_volume;
struct box_storage this_box_storage;

#line 41371 "MACS_sample_kidney_box.c"
#undef number_of_activations
#undef mask_setting
#undef mask_string
#undef p_interact
#undef focus_r
#undef focus_xh
#undef focus_xw
#undef focus_ah
#undef focus_aw
#undef target_z
#undef target_y
#undef target_x
#undef target_index
#undef visualize
#undef yheight2
#undef xwidth2
#undef zdepth
#undef yheight
#undef xwidth
#undef priority
#undef material_string
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

/* User declarations for component 'channel_3_cave1_cyl1' [241]. */
#define mccompcurname  channel_3_cave1_cyl1
#define mccompcurtype  Union_cylinder
#define mccompcurindex 241
#define loop_index mccchannel_3_cave1_cyl1_loop_index
#define this_cylinder_volume mccchannel_3_cave1_cyl1_this_cylinder_volume
#define global_geometry_element mccchannel_3_cave1_cyl1_global_geometry_element
#define this_cylinder_storage mccchannel_3_cave1_cyl1_this_cylinder_storage
#define material_string mccchannel_3_cave1_cyl1_material_string
#define priority mccchannel_3_cave1_cyl1_priority
#define radius mccchannel_3_cave1_cyl1_radius
#define yheight mccchannel_3_cave1_cyl1_yheight
#define visualize mccchannel_3_cave1_cyl1_visualize
#define target_index mccchannel_3_cave1_cyl1_target_index
#define target_x mccchannel_3_cave1_cyl1_target_x
#define target_y mccchannel_3_cave1_cyl1_target_y
#define target_z mccchannel_3_cave1_cyl1_target_z
#define focus_aw mccchannel_3_cave1_cyl1_focus_aw
#define focus_ah mccchannel_3_cave1_cyl1_focus_ah
#define focus_xw mccchannel_3_cave1_cyl1_focus_xw
#define focus_xh mccchannel_3_cave1_cyl1_focus_xh
#define focus_r mccchannel_3_cave1_cyl1_focus_r
#define p_interact mccchannel_3_cave1_cyl1_p_interact
#define mask_string mccchannel_3_cave1_cyl1_mask_string
#define mask_setting mccchannel_3_cave1_cyl1_mask_setting
#define number_of_activations mccchannel_3_cave1_cyl1_number_of_activations
#line 167 "Union_cylinder.comp"
// Needed for transport to the main component
struct global_geometry_element_struct global_geometry_element;

#ifndef ANY_GEOMETRY_DETECTOR_DECLARE
    #define ANY_GEOMETRY_DETECTOR_DECLARE dummy
	//struct pointer_to_global_geometry_list global_geometry_list = {0,NULL};
#endif

int dummy;
int loop_index,found_geometries;
int loop_2_index;
int material_index;

struct Volume_struct this_cylinder_volume;
struct cylinder_storage this_cylinder_storage;
#line 41443 "MACS_sample_kidney_box.c"
#undef number_of_activations
#undef mask_setting
#undef mask_string
#undef p_interact
#undef focus_r
#undef focus_xh
#undef focus_xw
#undef focus_ah
#undef focus_aw
#undef target_z
#undef target_y
#undef target_x
#undef target_index
#undef visualize
#undef yheight
#undef radius
#undef priority
#undef material_string
#undef this_cylinder_storage
#undef global_geometry_element
#undef this_cylinder_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

/* User declarations for component 'channel_3_analyzer_1_center' [242]. */
#define mccompcurname  channel_3_analyzer_1_center
#define mccompcurtype  Arm
#define mccompcurindex 242
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

/* User declarations for component 'channel_3_analyzer_1_rotated' [243]. */
#define mccompcurname  channel_3_analyzer_1_rotated
#define mccompcurtype  Arm
#define mccompcurindex 243
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

/* User declarations for component 'channel_3_analyzer_1_array_crystal_array_0' [244]. */
#define mccompcurname  channel_3_analyzer_1_array_crystal_array_0
#define mccompcurtype  Union_box
#define mccompcurindex 244
#define loop_index mccchannel_3_analyzer_1_array_crystal_array_0_loop_index
#define this_box_volume mccchannel_3_analyzer_1_array_crystal_array_0_this_box_volume
#define global_geometry_element mccchannel_3_analyzer_1_array_crystal_array_0_global_geometry_element
#define this_box_storage mccchannel_3_analyzer_1_array_crystal_array_0_this_box_storage
#define material_string mccchannel_3_analyzer_1_array_crystal_array_0_material_string
#define priority mccchannel_3_analyzer_1_array_crystal_array_0_priority
#define xwidth mccchannel_3_analyzer_1_array_crystal_array_0_xwidth
#define yheight mccchannel_3_analyzer_1_array_crystal_array_0_yheight
#define zdepth mccchannel_3_analyzer_1_array_crystal_array_0_zdepth
#define xwidth2 mccchannel_3_analyzer_1_array_crystal_array_0_xwidth2
#define yheight2 mccchannel_3_analyzer_1_array_crystal_array_0_yheight2
#define visualize mccchannel_3_analyzer_1_array_crystal_array_0_visualize
#define target_index mccchannel_3_analyzer_1_array_crystal_array_0_target_index
#define target_x mccchannel_3_analyzer_1_array_crystal_array_0_target_x
#define target_y mccchannel_3_analyzer_1_array_crystal_array_0_target_y
#define target_z mccchannel_3_analyzer_1_array_crystal_array_0_target_z
#define focus_aw mccchannel_3_analyzer_1_array_crystal_array_0_focus_aw
#define focus_ah mccchannel_3_analyzer_1_array_crystal_array_0_focus_ah
#define focus_xw mccchannel_3_analyzer_1_array_crystal_array_0_focus_xw
#define focus_xh mccchannel_3_analyzer_1_array_crystal_array_0_focus_xh
#define focus_r mccchannel_3_analyzer_1_array_crystal_array_0_focus_r
#define p_interact mccchannel_3_analyzer_1_array_crystal_array_0_p_interact
#define mask_string mccchannel_3_analyzer_1_array_crystal_array_0_mask_string
#define mask_setting mccchannel_3_analyzer_1_array_crystal_array_0_mask_setting
#define number_of_activations mccchannel_3_analyzer_1_array_crystal_array_0_number_of_activations
#line 204 "Union_box.comp"
// Needed for transport to the main component
struct global_geometry_element_struct global_geometry_element;

#ifndef ANY_GEOMETRY_DETECTOR_DECLARE
    #define ANY_GEOMETRY_DETECTOR_DECLARE dummy
	//struct pointer_to_global_geometry_list global_geometry_list = {0,NULL};
#endif

int loop_index,found_geometries;

double x_component;
double y_component;
double z_component;

struct Volume_struct this_box_volume;
struct box_storage this_box_storage;

#line 41533 "MACS_sample_kidney_box.c"
#undef number_of_activations
#undef mask_setting
#undef mask_string
#undef p_interact
#undef focus_r
#undef focus_xh
#undef focus_xw
#undef focus_ah
#undef focus_aw
#undef target_z
#undef target_y
#undef target_x
#undef target_index
#undef visualize
#undef yheight2
#undef xwidth2
#undef zdepth
#undef yheight
#undef xwidth
#undef priority
#undef material_string
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

/* User declarations for component 'channel_3_analyzer_1_array_crystal_array_1' [245]. */
#define mccompcurname  channel_3_analyzer_1_array_crystal_array_1
#define mccompcurtype  Union_box
#define mccompcurindex 245
#define loop_index mccchannel_3_analyzer_1_array_crystal_array_1_loop_index
#define this_box_volume mccchannel_3_analyzer_1_array_crystal_array_1_this_box_volume
#define global_geometry_element mccchannel_3_analyzer_1_array_crystal_array_1_global_geometry_element
#define this_box_storage mccchannel_3_analyzer_1_array_crystal_array_1_this_box_storage
#define material_string mccchannel_3_analyzer_1_array_crystal_array_1_material_string
#define priority mccchannel_3_analyzer_1_array_crystal_array_1_priority
#define xwidth mccchannel_3_analyzer_1_array_crystal_array_1_xwidth
#define yheight mccchannel_3_analyzer_1_array_crystal_array_1_yheight
#define zdepth mccchannel_3_analyzer_1_array_crystal_array_1_zdepth
#define xwidth2 mccchannel_3_analyzer_1_array_crystal_array_1_xwidth2
#define yheight2 mccchannel_3_analyzer_1_array_crystal_array_1_yheight2
#define visualize mccchannel_3_analyzer_1_array_crystal_array_1_visualize
#define target_index mccchannel_3_analyzer_1_array_crystal_array_1_target_index
#define target_x mccchannel_3_analyzer_1_array_crystal_array_1_target_x
#define target_y mccchannel_3_analyzer_1_array_crystal_array_1_target_y
#define target_z mccchannel_3_analyzer_1_array_crystal_array_1_target_z
#define focus_aw mccchannel_3_analyzer_1_array_crystal_array_1_focus_aw
#define focus_ah mccchannel_3_analyzer_1_array_crystal_array_1_focus_ah
#define focus_xw mccchannel_3_analyzer_1_array_crystal_array_1_focus_xw
#define focus_xh mccchannel_3_analyzer_1_array_crystal_array_1_focus_xh
#define focus_r mccchannel_3_analyzer_1_array_crystal_array_1_focus_r
#define p_interact mccchannel_3_analyzer_1_array_crystal_array_1_p_interact
#define mask_string mccchannel_3_analyzer_1_array_crystal_array_1_mask_string
#define mask_setting mccchannel_3_analyzer_1_array_crystal_array_1_mask_setting
#define number_of_activations mccchannel_3_analyzer_1_array_crystal_array_1_number_of_activations
#line 204 "Union_box.comp"
// Needed for transport to the main component
struct global_geometry_element_struct global_geometry_element;

#ifndef ANY_GEOMETRY_DETECTOR_DECLARE
    #define ANY_GEOMETRY_DETECTOR_DECLARE dummy
	//struct pointer_to_global_geometry_list global_geometry_list = {0,NULL};
#endif

int loop_index,found_geometries;

double x_component;
double y_component;
double z_component;

struct Volume_struct this_box_volume;
struct box_storage this_box_storage;

#line 41610 "MACS_sample_kidney_box.c"
#undef number_of_activations
#undef mask_setting
#undef mask_string
#undef p_interact
#undef focus_r
#undef focus_xh
#undef focus_xw
#undef focus_ah
#undef focus_aw
#undef target_z
#undef target_y
#undef target_x
#undef target_index
#undef visualize
#undef yheight2
#undef xwidth2
#undef zdepth
#undef yheight
#undef xwidth
#undef priority
#undef material_string
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

/* User declarations for component 'channel_3_analyzer_1_array_crystal_array_2' [246]. */
#define mccompcurname  channel_3_analyzer_1_array_crystal_array_2
#define mccompcurtype  Union_box
#define mccompcurindex 246
#define loop_index mccchannel_3_analyzer_1_array_crystal_array_2_loop_index
#define this_box_volume mccchannel_3_analyzer_1_array_crystal_array_2_this_box_volume
#define global_geometry_element mccchannel_3_analyzer_1_array_crystal_array_2_global_geometry_element
#define this_box_storage mccchannel_3_analyzer_1_array_crystal_array_2_this_box_storage
#define material_string mccchannel_3_analyzer_1_array_crystal_array_2_material_string
#define priority mccchannel_3_analyzer_1_array_crystal_array_2_priority
#define xwidth mccchannel_3_analyzer_1_array_crystal_array_2_xwidth
#define yheight mccchannel_3_analyzer_1_array_crystal_array_2_yheight
#define zdepth mccchannel_3_analyzer_1_array_crystal_array_2_zdepth
#define xwidth2 mccchannel_3_analyzer_1_array_crystal_array_2_xwidth2
#define yheight2 mccchannel_3_analyzer_1_array_crystal_array_2_yheight2
#define visualize mccchannel_3_analyzer_1_array_crystal_array_2_visualize
#define target_index mccchannel_3_analyzer_1_array_crystal_array_2_target_index
#define target_x mccchannel_3_analyzer_1_array_crystal_array_2_target_x
#define target_y mccchannel_3_analyzer_1_array_crystal_array_2_target_y
#define target_z mccchannel_3_analyzer_1_array_crystal_array_2_target_z
#define focus_aw mccchannel_3_analyzer_1_array_crystal_array_2_focus_aw
#define focus_ah mccchannel_3_analyzer_1_array_crystal_array_2_focus_ah
#define focus_xw mccchannel_3_analyzer_1_array_crystal_array_2_focus_xw
#define focus_xh mccchannel_3_analyzer_1_array_crystal_array_2_focus_xh
#define focus_r mccchannel_3_analyzer_1_array_crystal_array_2_focus_r
#define p_interact mccchannel_3_analyzer_1_array_crystal_array_2_p_interact
#define mask_string mccchannel_3_analyzer_1_array_crystal_array_2_mask_string
#define mask_setting mccchannel_3_analyzer_1_array_crystal_array_2_mask_setting
#define number_of_activations mccchannel_3_analyzer_1_array_crystal_array_2_number_of_activations
#line 204 "Union_box.comp"
// Needed for transport to the main component
struct global_geometry_element_struct global_geometry_element;

#ifndef ANY_GEOMETRY_DETECTOR_DECLARE
    #define ANY_GEOMETRY_DETECTOR_DECLARE dummy
	//struct pointer_to_global_geometry_list global_geometry_list = {0,NULL};
#endif

int loop_index,found_geometries;

double x_component;
double y_component;
double z_component;

struct Volume_struct this_box_volume;
struct box_storage this_box_storage;

#line 41687 "MACS_sample_kidney_box.c"
#undef number_of_activations
#undef mask_setting
#undef mask_string
#undef p_interact
#undef focus_r
#undef focus_xh
#undef focus_xw
#undef focus_ah
#undef focus_aw
#undef target_z
#undef target_y
#undef target_x
#undef target_index
#undef visualize
#undef yheight2
#undef xwidth2
#undef zdepth
#undef yheight
#undef xwidth
#undef priority
#undef material_string
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

/* User declarations for component 'channel_3_analyzer_1_array_crystal_array_3' [247]. */
#define mccompcurname  channel_3_analyzer_1_array_crystal_array_3
#define mccompcurtype  Union_box
#define mccompcurindex 247
#define loop_index mccchannel_3_analyzer_1_array_crystal_array_3_loop_index
#define this_box_volume mccchannel_3_analyzer_1_array_crystal_array_3_this_box_volume
#define global_geometry_element mccchannel_3_analyzer_1_array_crystal_array_3_global_geometry_element
#define this_box_storage mccchannel_3_analyzer_1_array_crystal_array_3_this_box_storage
#define material_string mccchannel_3_analyzer_1_array_crystal_array_3_material_string
#define priority mccchannel_3_analyzer_1_array_crystal_array_3_priority
#define xwidth mccchannel_3_analyzer_1_array_crystal_array_3_xwidth
#define yheight mccchannel_3_analyzer_1_array_crystal_array_3_yheight
#define zdepth mccchannel_3_analyzer_1_array_crystal_array_3_zdepth
#define xwidth2 mccchannel_3_analyzer_1_array_crystal_array_3_xwidth2
#define yheight2 mccchannel_3_analyzer_1_array_crystal_array_3_yheight2
#define visualize mccchannel_3_analyzer_1_array_crystal_array_3_visualize
#define target_index mccchannel_3_analyzer_1_array_crystal_array_3_target_index
#define target_x mccchannel_3_analyzer_1_array_crystal_array_3_target_x
#define target_y mccchannel_3_analyzer_1_array_crystal_array_3_target_y
#define target_z mccchannel_3_analyzer_1_array_crystal_array_3_target_z
#define focus_aw mccchannel_3_analyzer_1_array_crystal_array_3_focus_aw
#define focus_ah mccchannel_3_analyzer_1_array_crystal_array_3_focus_ah
#define focus_xw mccchannel_3_analyzer_1_array_crystal_array_3_focus_xw
#define focus_xh mccchannel_3_analyzer_1_array_crystal_array_3_focus_xh
#define focus_r mccchannel_3_analyzer_1_array_crystal_array_3_focus_r
#define p_interact mccchannel_3_analyzer_1_array_crystal_array_3_p_interact
#define mask_string mccchannel_3_analyzer_1_array_crystal_array_3_mask_string
#define mask_setting mccchannel_3_analyzer_1_array_crystal_array_3_mask_setting
#define number_of_activations mccchannel_3_analyzer_1_array_crystal_array_3_number_of_activations
#line 204 "Union_box.comp"
// Needed for transport to the main component
struct global_geometry_element_struct global_geometry_element;

#ifndef ANY_GEOMETRY_DETECTOR_DECLARE
    #define ANY_GEOMETRY_DETECTOR_DECLARE dummy
	//struct pointer_to_global_geometry_list global_geometry_list = {0,NULL};
#endif

int loop_index,found_geometries;

double x_component;
double y_component;
double z_component;

struct Volume_struct this_box_volume;
struct box_storage this_box_storage;

#line 41764 "MACS_sample_kidney_box.c"
#undef number_of_activations
#undef mask_setting
#undef mask_string
#undef p_interact
#undef focus_r
#undef focus_xh
#undef focus_xw
#undef focus_ah
#undef focus_aw
#undef target_z
#undef target_y
#undef target_x
#undef target_index
#undef visualize
#undef yheight2
#undef xwidth2
#undef zdepth
#undef yheight
#undef xwidth
#undef priority
#undef material_string
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

/* User declarations for component 'channel_3_analyzer_1_array_crystal_array_4' [248]. */
#define mccompcurname  channel_3_analyzer_1_array_crystal_array_4
#define mccompcurtype  Union_box
#define mccompcurindex 248
#define loop_index mccchannel_3_analyzer_1_array_crystal_array_4_loop_index
#define this_box_volume mccchannel_3_analyzer_1_array_crystal_array_4_this_box_volume
#define global_geometry_element mccchannel_3_analyzer_1_array_crystal_array_4_global_geometry_element
#define this_box_storage mccchannel_3_analyzer_1_array_crystal_array_4_this_box_storage
#define material_string mccchannel_3_analyzer_1_array_crystal_array_4_material_string
#define priority mccchannel_3_analyzer_1_array_crystal_array_4_priority
#define xwidth mccchannel_3_analyzer_1_array_crystal_array_4_xwidth
#define yheight mccchannel_3_analyzer_1_array_crystal_array_4_yheight
#define zdepth mccchannel_3_analyzer_1_array_crystal_array_4_zdepth
#define xwidth2 mccchannel_3_analyzer_1_array_crystal_array_4_xwidth2
#define yheight2 mccchannel_3_analyzer_1_array_crystal_array_4_yheight2
#define visualize mccchannel_3_analyzer_1_array_crystal_array_4_visualize
#define target_index mccchannel_3_analyzer_1_array_crystal_array_4_target_index
#define target_x mccchannel_3_analyzer_1_array_crystal_array_4_target_x
#define target_y mccchannel_3_analyzer_1_array_crystal_array_4_target_y
#define target_z mccchannel_3_analyzer_1_array_crystal_array_4_target_z
#define focus_aw mccchannel_3_analyzer_1_array_crystal_array_4_focus_aw
#define focus_ah mccchannel_3_analyzer_1_array_crystal_array_4_focus_ah
#define focus_xw mccchannel_3_analyzer_1_array_crystal_array_4_focus_xw
#define focus_xh mccchannel_3_analyzer_1_array_crystal_array_4_focus_xh
#define focus_r mccchannel_3_analyzer_1_array_crystal_array_4_focus_r
#define p_interact mccchannel_3_analyzer_1_array_crystal_array_4_p_interact
#define mask_string mccchannel_3_analyzer_1_array_crystal_array_4_mask_string
#define mask_setting mccchannel_3_analyzer_1_array_crystal_array_4_mask_setting
#define number_of_activations mccchannel_3_analyzer_1_array_crystal_array_4_number_of_activations
#line 204 "Union_box.comp"
// Needed for transport to the main component
struct global_geometry_element_struct global_geometry_element;

#ifndef ANY_GEOMETRY_DETECTOR_DECLARE
    #define ANY_GEOMETRY_DETECTOR_DECLARE dummy
	//struct pointer_to_global_geometry_list global_geometry_list = {0,NULL};
#endif

int loop_index,found_geometries;

double x_component;
double y_component;
double z_component;

struct Volume_struct this_box_volume;
struct box_storage this_box_storage;

#line 41841 "MACS_sample_kidney_box.c"
#undef number_of_activations
#undef mask_setting
#undef mask_string
#undef p_interact
#undef focus_r
#undef focus_xh
#undef focus_xw
#undef focus_ah
#undef focus_aw
#undef target_z
#undef target_y
#undef target_x
#undef target_index
#undef visualize
#undef yheight2
#undef xwidth2
#undef zdepth
#undef yheight
#undef xwidth
#undef priority
#undef material_string
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

/* User declarations for component 'channel_3_analyzer_1_array_crystal_array_5' [249]. */
#define mccompcurname  channel_3_analyzer_1_array_crystal_array_5
#define mccompcurtype  Union_box
#define mccompcurindex 249
#define loop_index mccchannel_3_analyzer_1_array_crystal_array_5_loop_index
#define this_box_volume mccchannel_3_analyzer_1_array_crystal_array_5_this_box_volume
#define global_geometry_element mccchannel_3_analyzer_1_array_crystal_array_5_global_geometry_element
#define this_box_storage mccchannel_3_analyzer_1_array_crystal_array_5_this_box_storage
#define material_string mccchannel_3_analyzer_1_array_crystal_array_5_material_string
#define priority mccchannel_3_analyzer_1_array_crystal_array_5_priority
#define xwidth mccchannel_3_analyzer_1_array_crystal_array_5_xwidth
#define yheight mccchannel_3_analyzer_1_array_crystal_array_5_yheight
#define zdepth mccchannel_3_analyzer_1_array_crystal_array_5_zdepth
#define xwidth2 mccchannel_3_analyzer_1_array_crystal_array_5_xwidth2
#define yheight2 mccchannel_3_analyzer_1_array_crystal_array_5_yheight2
#define visualize mccchannel_3_analyzer_1_array_crystal_array_5_visualize
#define target_index mccchannel_3_analyzer_1_array_crystal_array_5_target_index
#define target_x mccchannel_3_analyzer_1_array_crystal_array_5_target_x
#define target_y mccchannel_3_analyzer_1_array_crystal_array_5_target_y
#define target_z mccchannel_3_analyzer_1_array_crystal_array_5_target_z
#define focus_aw mccchannel_3_analyzer_1_array_crystal_array_5_focus_aw
#define focus_ah mccchannel_3_analyzer_1_array_crystal_array_5_focus_ah
#define focus_xw mccchannel_3_analyzer_1_array_crystal_array_5_focus_xw
#define focus_xh mccchannel_3_analyzer_1_array_crystal_array_5_focus_xh
#define focus_r mccchannel_3_analyzer_1_array_crystal_array_5_focus_r
#define p_interact mccchannel_3_analyzer_1_array_crystal_array_5_p_interact
#define mask_string mccchannel_3_analyzer_1_array_crystal_array_5_mask_string
#define mask_setting mccchannel_3_analyzer_1_array_crystal_array_5_mask_setting
#define number_of_activations mccchannel_3_analyzer_1_array_crystal_array_5_number_of_activations
#line 204 "Union_box.comp"
// Needed for transport to the main component
struct global_geometry_element_struct global_geometry_element;

#ifndef ANY_GEOMETRY_DETECTOR_DECLARE
    #define ANY_GEOMETRY_DETECTOR_DECLARE dummy
	//struct pointer_to_global_geometry_list global_geometry_list = {0,NULL};
#endif

int loop_index,found_geometries;

double x_component;
double y_component;
double z_component;

struct Volume_struct this_box_volume;
struct box_storage this_box_storage;

#line 41918 "MACS_sample_kidney_box.c"
#undef number_of_activations
#undef mask_setting
#undef mask_string
#undef p_interact
#undef focus_r
#undef focus_xh
#undef focus_xw
#undef focus_ah
#undef focus_aw
#undef target_z
#undef target_y
#undef target_x
#undef target_index
#undef visualize
#undef yheight2
#undef xwidth2
#undef zdepth
#undef yheight
#undef xwidth
#undef priority
#undef material_string
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

/* User declarations for component 'channel_3_analyzer_1_array_crystal_array_6' [250]. */
#define mccompcurname  channel_3_analyzer_1_array_crystal_array_6
#define mccompcurtype  Union_box
#define mccompcurindex 250
#define loop_index mccchannel_3_analyzer_1_array_crystal_array_6_loop_index
#define this_box_volume mccchannel_3_analyzer_1_array_crystal_array_6_this_box_volume
#define global_geometry_element mccchannel_3_analyzer_1_array_crystal_array_6_global_geometry_element
#define this_box_storage mccchannel_3_analyzer_1_array_crystal_array_6_this_box_storage
#define material_string mccchannel_3_analyzer_1_array_crystal_array_6_material_string
#define priority mccchannel_3_analyzer_1_array_crystal_array_6_priority
#define xwidth mccchannel_3_analyzer_1_array_crystal_array_6_xwidth
#define yheight mccchannel_3_analyzer_1_array_crystal_array_6_yheight
#define zdepth mccchannel_3_analyzer_1_array_crystal_array_6_zdepth
#define xwidth2 mccchannel_3_analyzer_1_array_crystal_array_6_xwidth2
#define yheight2 mccchannel_3_analyzer_1_array_crystal_array_6_yheight2
#define visualize mccchannel_3_analyzer_1_array_crystal_array_6_visualize
#define target_index mccchannel_3_analyzer_1_array_crystal_array_6_target_index
#define target_x mccchannel_3_analyzer_1_array_crystal_array_6_target_x
#define target_y mccchannel_3_analyzer_1_array_crystal_array_6_target_y
#define target_z mccchannel_3_analyzer_1_array_crystal_array_6_target_z
#define focus_aw mccchannel_3_analyzer_1_array_crystal_array_6_focus_aw
#define focus_ah mccchannel_3_analyzer_1_array_crystal_array_6_focus_ah
#define focus_xw mccchannel_3_analyzer_1_array_crystal_array_6_focus_xw
#define focus_xh mccchannel_3_analyzer_1_array_crystal_array_6_focus_xh
#define focus_r mccchannel_3_analyzer_1_array_crystal_array_6_focus_r
#define p_interact mccchannel_3_analyzer_1_array_crystal_array_6_p_interact
#define mask_string mccchannel_3_analyzer_1_array_crystal_array_6_mask_string
#define mask_setting mccchannel_3_analyzer_1_array_crystal_array_6_mask_setting
#define number_of_activations mccchannel_3_analyzer_1_array_crystal_array_6_number_of_activations
#line 204 "Union_box.comp"
// Needed for transport to the main component
struct global_geometry_element_struct global_geometry_element;

#ifndef ANY_GEOMETRY_DETECTOR_DECLARE
    #define ANY_GEOMETRY_DETECTOR_DECLARE dummy
	//struct pointer_to_global_geometry_list global_geometry_list = {0,NULL};
#endif

int loop_index,found_geometries;

double x_component;
double y_component;
double z_component;

struct Volume_struct this_box_volume;
struct box_storage this_box_storage;

#line 41995 "MACS_sample_kidney_box.c"
#undef number_of_activations
#undef mask_setting
#undef mask_string
#undef p_interact
#undef focus_r
#undef focus_xh
#undef focus_xw
#undef focus_ah
#undef focus_aw
#undef target_z
#undef target_y
#undef target_x
#undef target_index
#undef visualize
#undef yheight2
#undef xwidth2
#undef zdepth
#undef yheight
#undef xwidth
#undef priority
#undef material_string
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

/* User declarations for component 'channel_3_analyzer_1_array_crystal_array_7' [251]. */
#define mccompcurname  channel_3_analyzer_1_array_crystal_array_7
#define mccompcurtype  Union_box
#define mccompcurindex 251
#define loop_index mccchannel_3_analyzer_1_array_crystal_array_7_loop_index
#define this_box_volume mccchannel_3_analyzer_1_array_crystal_array_7_this_box_volume
#define global_geometry_element mccchannel_3_analyzer_1_array_crystal_array_7_global_geometry_element
#define this_box_storage mccchannel_3_analyzer_1_array_crystal_array_7_this_box_storage
#define material_string mccchannel_3_analyzer_1_array_crystal_array_7_material_string
#define priority mccchannel_3_analyzer_1_array_crystal_array_7_priority
#define xwidth mccchannel_3_analyzer_1_array_crystal_array_7_xwidth
#define yheight mccchannel_3_analyzer_1_array_crystal_array_7_yheight
#define zdepth mccchannel_3_analyzer_1_array_crystal_array_7_zdepth
#define xwidth2 mccchannel_3_analyzer_1_array_crystal_array_7_xwidth2
#define yheight2 mccchannel_3_analyzer_1_array_crystal_array_7_yheight2
#define visualize mccchannel_3_analyzer_1_array_crystal_array_7_visualize
#define target_index mccchannel_3_analyzer_1_array_crystal_array_7_target_index
#define target_x mccchannel_3_analyzer_1_array_crystal_array_7_target_x
#define target_y mccchannel_3_analyzer_1_array_crystal_array_7_target_y
#define target_z mccchannel_3_analyzer_1_array_crystal_array_7_target_z
#define focus_aw mccchannel_3_analyzer_1_array_crystal_array_7_focus_aw
#define focus_ah mccchannel_3_analyzer_1_array_crystal_array_7_focus_ah
#define focus_xw mccchannel_3_analyzer_1_array_crystal_array_7_focus_xw
#define focus_xh mccchannel_3_analyzer_1_array_crystal_array_7_focus_xh
#define focus_r mccchannel_3_analyzer_1_array_crystal_array_7_focus_r
#define p_interact mccchannel_3_analyzer_1_array_crystal_array_7_p_interact
#define mask_string mccchannel_3_analyzer_1_array_crystal_array_7_mask_string
#define mask_setting mccchannel_3_analyzer_1_array_crystal_array_7_mask_setting
#define number_of_activations mccchannel_3_analyzer_1_array_crystal_array_7_number_of_activations
#line 204 "Union_box.comp"
// Needed for transport to the main component
struct global_geometry_element_struct global_geometry_element;

#ifndef ANY_GEOMETRY_DETECTOR_DECLARE
    #define ANY_GEOMETRY_DETECTOR_DECLARE dummy
	//struct pointer_to_global_geometry_list global_geometry_list = {0,NULL};
#endif

int loop_index,found_geometries;

double x_component;
double y_component;
double z_component;

struct Volume_struct this_box_volume;
struct box_storage this_box_storage;

#line 42072 "MACS_sample_kidney_box.c"
#undef number_of_activations
#undef mask_setting
#undef mask_string
#undef p_interact
#undef focus_r
#undef focus_xh
#undef focus_xw
#undef focus_ah
#undef focus_aw
#undef target_z
#undef target_y
#undef target_x
#undef target_index
#undef visualize
#undef yheight2
#undef xwidth2
#undef zdepth
#undef yheight
#undef xwidth
#undef priority
#undef material_string
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

/* User declarations for component 'channel_3_analyzer_1_array_crystal_array_8' [252]. */
#define mccompcurname  channel_3_analyzer_1_array_crystal_array_8
#define mccompcurtype  Union_box
#define mccompcurindex 252
#define loop_index mccchannel_3_analyzer_1_array_crystal_array_8_loop_index
#define this_box_volume mccchannel_3_analyzer_1_array_crystal_array_8_this_box_volume
#define global_geometry_element mccchannel_3_analyzer_1_array_crystal_array_8_global_geometry_element
#define this_box_storage mccchannel_3_analyzer_1_array_crystal_array_8_this_box_storage
#define material_string mccchannel_3_analyzer_1_array_crystal_array_8_material_string
#define priority mccchannel_3_analyzer_1_array_crystal_array_8_priority
#define xwidth mccchannel_3_analyzer_1_array_crystal_array_8_xwidth
#define yheight mccchannel_3_analyzer_1_array_crystal_array_8_yheight
#define zdepth mccchannel_3_analyzer_1_array_crystal_array_8_zdepth
#define xwidth2 mccchannel_3_analyzer_1_array_crystal_array_8_xwidth2
#define yheight2 mccchannel_3_analyzer_1_array_crystal_array_8_yheight2
#define visualize mccchannel_3_analyzer_1_array_crystal_array_8_visualize
#define target_index mccchannel_3_analyzer_1_array_crystal_array_8_target_index
#define target_x mccchannel_3_analyzer_1_array_crystal_array_8_target_x
#define target_y mccchannel_3_analyzer_1_array_crystal_array_8_target_y
#define target_z mccchannel_3_analyzer_1_array_crystal_array_8_target_z
#define focus_aw mccchannel_3_analyzer_1_array_crystal_array_8_focus_aw
#define focus_ah mccchannel_3_analyzer_1_array_crystal_array_8_focus_ah
#define focus_xw mccchannel_3_analyzer_1_array_crystal_array_8_focus_xw
#define focus_xh mccchannel_3_analyzer_1_array_crystal_array_8_focus_xh
#define focus_r mccchannel_3_analyzer_1_array_crystal_array_8_focus_r
#define p_interact mccchannel_3_analyzer_1_array_crystal_array_8_p_interact
#define mask_string mccchannel_3_analyzer_1_array_crystal_array_8_mask_string
#define mask_setting mccchannel_3_analyzer_1_array_crystal_array_8_mask_setting
#define number_of_activations mccchannel_3_analyzer_1_array_crystal_array_8_number_of_activations
#line 204 "Union_box.comp"
// Needed for transport to the main component
struct global_geometry_element_struct global_geometry_element;

#ifndef ANY_GEOMETRY_DETECTOR_DECLARE
    #define ANY_GEOMETRY_DETECTOR_DECLARE dummy
	//struct pointer_to_global_geometry_list global_geometry_list = {0,NULL};
#endif

int loop_index,found_geometries;

double x_component;
double y_component;
double z_component;

struct Volume_struct this_box_volume;
struct box_storage this_box_storage;

#line 42149 "MACS_sample_kidney_box.c"
#undef number_of_activations
#undef mask_setting
#undef mask_string
#undef p_interact
#undef focus_r
#undef focus_xh
#undef focus_xw
#undef focus_ah
#undef focus_aw
#undef target_z
#undef target_y
#undef target_x
#undef target_index
#undef visualize
#undef yheight2
#undef xwidth2
#undef zdepth
#undef yheight
#undef xwidth
#undef priority
#undef material_string
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

/* User declarations for component 'channel_3_analyzer_2_center' [253]. */
#define mccompcurname  channel_3_analyzer_2_center
#define mccompcurtype  Arm
#define mccompcurindex 253
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

/* User declarations for component 'channel_3_analyzer_2_rotated' [254]. */
#define mccompcurname  channel_3_analyzer_2_rotated
#define mccompcurtype  Arm
#define mccompcurindex 254
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

/* User declarations for component 'channel_3_analyzer_2_array_crystal_array_0' [255]. */
#define mccompcurname  channel_3_analyzer_2_array_crystal_array_0
#define mccompcurtype  Union_box
#define mccompcurindex 255
#define loop_index mccchannel_3_analyzer_2_array_crystal_array_0_loop_index
#define this_box_volume mccchannel_3_analyzer_2_array_crystal_array_0_this_box_volume
#define global_geometry_element mccchannel_3_analyzer_2_array_crystal_array_0_global_geometry_element
#define this_box_storage mccchannel_3_analyzer_2_array_crystal_array_0_this_box_storage
#define material_string mccchannel_3_analyzer_2_array_crystal_array_0_material_string
#define priority mccchannel_3_analyzer_2_array_crystal_array_0_priority
#define xwidth mccchannel_3_analyzer_2_array_crystal_array_0_xwidth
#define yheight mccchannel_3_analyzer_2_array_crystal_array_0_yheight
#define zdepth mccchannel_3_analyzer_2_array_crystal_array_0_zdepth
#define xwidth2 mccchannel_3_analyzer_2_array_crystal_array_0_xwidth2
#define yheight2 mccchannel_3_analyzer_2_array_crystal_array_0_yheight2
#define visualize mccchannel_3_analyzer_2_array_crystal_array_0_visualize
#define target_index mccchannel_3_analyzer_2_array_crystal_array_0_target_index
#define target_x mccchannel_3_analyzer_2_array_crystal_array_0_target_x
#define target_y mccchannel_3_analyzer_2_array_crystal_array_0_target_y
#define target_z mccchannel_3_analyzer_2_array_crystal_array_0_target_z
#define focus_aw mccchannel_3_analyzer_2_array_crystal_array_0_focus_aw
#define focus_ah mccchannel_3_analyzer_2_array_crystal_array_0_focus_ah
#define focus_xw mccchannel_3_analyzer_2_array_crystal_array_0_focus_xw
#define focus_xh mccchannel_3_analyzer_2_array_crystal_array_0_focus_xh
#define focus_r mccchannel_3_analyzer_2_array_crystal_array_0_focus_r
#define p_interact mccchannel_3_analyzer_2_array_crystal_array_0_p_interact
#define mask_string mccchannel_3_analyzer_2_array_crystal_array_0_mask_string
#define mask_setting mccchannel_3_analyzer_2_array_crystal_array_0_mask_setting
#define number_of_activations mccchannel_3_analyzer_2_array_crystal_array_0_number_of_activations
#line 204 "Union_box.comp"
// Needed for transport to the main component
struct global_geometry_element_struct global_geometry_element;

#ifndef ANY_GEOMETRY_DETECTOR_DECLARE
    #define ANY_GEOMETRY_DETECTOR_DECLARE dummy
	//struct pointer_to_global_geometry_list global_geometry_list = {0,NULL};
#endif

int loop_index,found_geometries;

double x_component;
double y_component;
double z_component;

struct Volume_struct this_box_volume;
struct box_storage this_box_storage;

#line 42242 "MACS_sample_kidney_box.c"
#undef number_of_activations
#undef mask_setting
#undef mask_string
#undef p_interact
#undef focus_r
#undef focus_xh
#undef focus_xw
#undef focus_ah
#undef focus_aw
#undef target_z
#undef target_y
#undef target_x
#undef target_index
#undef visualize
#undef yheight2
#undef xwidth2
#undef zdepth
#undef yheight
#undef xwidth
#undef priority
#undef material_string
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

/* User declarations for component 'channel_3_analyzer_2_array_crystal_array_1' [256]. */
#define mccompcurname  channel_3_analyzer_2_array_crystal_array_1
#define mccompcurtype  Union_box
#define mccompcurindex 256
#define loop_index mccchannel_3_analyzer_2_array_crystal_array_1_loop_index
#define this_box_volume mccchannel_3_analyzer_2_array_crystal_array_1_this_box_volume
#define global_geometry_element mccchannel_3_analyzer_2_array_crystal_array_1_global_geometry_element
#define this_box_storage mccchannel_3_analyzer_2_array_crystal_array_1_this_box_storage
#define material_string mccchannel_3_analyzer_2_array_crystal_array_1_material_string
#define priority mccchannel_3_analyzer_2_array_crystal_array_1_priority
#define xwidth mccchannel_3_analyzer_2_array_crystal_array_1_xwidth
#define yheight mccchannel_3_analyzer_2_array_crystal_array_1_yheight
#define zdepth mccchannel_3_analyzer_2_array_crystal_array_1_zdepth
#define xwidth2 mccchannel_3_analyzer_2_array_crystal_array_1_xwidth2
#define yheight2 mccchannel_3_analyzer_2_array_crystal_array_1_yheight2
#define visualize mccchannel_3_analyzer_2_array_crystal_array_1_visualize
#define target_index mccchannel_3_analyzer_2_array_crystal_array_1_target_index
#define target_x mccchannel_3_analyzer_2_array_crystal_array_1_target_x
#define target_y mccchannel_3_analyzer_2_array_crystal_array_1_target_y
#define target_z mccchannel_3_analyzer_2_array_crystal_array_1_target_z
#define focus_aw mccchannel_3_analyzer_2_array_crystal_array_1_focus_aw
#define focus_ah mccchannel_3_analyzer_2_array_crystal_array_1_focus_ah
#define focus_xw mccchannel_3_analyzer_2_array_crystal_array_1_focus_xw
#define focus_xh mccchannel_3_analyzer_2_array_crystal_array_1_focus_xh
#define focus_r mccchannel_3_analyzer_2_array_crystal_array_1_focus_r
#define p_interact mccchannel_3_analyzer_2_array_crystal_array_1_p_interact
#define mask_string mccchannel_3_analyzer_2_array_crystal_array_1_mask_string
#define mask_setting mccchannel_3_analyzer_2_array_crystal_array_1_mask_setting
#define number_of_activations mccchannel_3_analyzer_2_array_crystal_array_1_number_of_activations
#line 204 "Union_box.comp"
// Needed for transport to the main component
struct global_geometry_element_struct global_geometry_element;

#ifndef ANY_GEOMETRY_DETECTOR_DECLARE
    #define ANY_GEOMETRY_DETECTOR_DECLARE dummy
	//struct pointer_to_global_geometry_list global_geometry_list = {0,NULL};
#endif

int loop_index,found_geometries;

double x_component;
double y_component;
double z_component;

struct Volume_struct this_box_volume;
struct box_storage this_box_storage;

#line 42319 "MACS_sample_kidney_box.c"
#undef number_of_activations
#undef mask_setting
#undef mask_string
#undef p_interact
#undef focus_r
#undef focus_xh
#undef focus_xw
#undef focus_ah
#undef focus_aw
#undef target_z
#undef target_y
#undef target_x
#undef target_index
#undef visualize
#undef yheight2
#undef xwidth2
#undef zdepth
#undef yheight
#undef xwidth
#undef priority
#undef material_string
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

/* User declarations for component 'channel_3_analyzer_2_array_crystal_array_2' [257]. */
#define mccompcurname  channel_3_analyzer_2_array_crystal_array_2
#define mccompcurtype  Union_box
#define mccompcurindex 257
#define loop_index mccchannel_3_analyzer_2_array_crystal_array_2_loop_index
#define this_box_volume mccchannel_3_analyzer_2_array_crystal_array_2_this_box_volume
#define global_geometry_element mccchannel_3_analyzer_2_array_crystal_array_2_global_geometry_element
#define this_box_storage mccchannel_3_analyzer_2_array_crystal_array_2_this_box_storage
#define material_string mccchannel_3_analyzer_2_array_crystal_array_2_material_string
#define priority mccchannel_3_analyzer_2_array_crystal_array_2_priority
#define xwidth mccchannel_3_analyzer_2_array_crystal_array_2_xwidth
#define yheight mccchannel_3_analyzer_2_array_crystal_array_2_yheight
#define zdepth mccchannel_3_analyzer_2_array_crystal_array_2_zdepth
#define xwidth2 mccchannel_3_analyzer_2_array_crystal_array_2_xwidth2
#define yheight2 mccchannel_3_analyzer_2_array_crystal_array_2_yheight2
#define visualize mccchannel_3_analyzer_2_array_crystal_array_2_visualize
#define target_index mccchannel_3_analyzer_2_array_crystal_array_2_target_index
#define target_x mccchannel_3_analyzer_2_array_crystal_array_2_target_x
#define target_y mccchannel_3_analyzer_2_array_crystal_array_2_target_y
#define target_z mccchannel_3_analyzer_2_array_crystal_array_2_target_z
#define focus_aw mccchannel_3_analyzer_2_array_crystal_array_2_focus_aw
#define focus_ah mccchannel_3_analyzer_2_array_crystal_array_2_focus_ah
#define focus_xw mccchannel_3_analyzer_2_array_crystal_array_2_focus_xw
#define focus_xh mccchannel_3_analyzer_2_array_crystal_array_2_focus_xh
#define focus_r mccchannel_3_analyzer_2_array_crystal_array_2_focus_r
#define p_interact mccchannel_3_analyzer_2_array_crystal_array_2_p_interact
#define mask_string mccchannel_3_analyzer_2_array_crystal_array_2_mask_string
#define mask_setting mccchannel_3_analyzer_2_array_crystal_array_2_mask_setting
#define number_of_activations mccchannel_3_analyzer_2_array_crystal_array_2_number_of_activations
#line 204 "Union_box.comp"
// Needed for transport to the main component
struct global_geometry_element_struct global_geometry_element;

#ifndef ANY_GEOMETRY_DETECTOR_DECLARE
    #define ANY_GEOMETRY_DETECTOR_DECLARE dummy
	//struct pointer_to_global_geometry_list global_geometry_list = {0,NULL};
#endif

int loop_index,found_geometries;

double x_component;
double y_component;
double z_component;

struct Volume_struct this_box_volume;
struct box_storage this_box_storage;

#line 42396 "MACS_sample_kidney_box.c"
#undef number_of_activations
#undef mask_setting
#undef mask_string
#undef p_interact
#undef focus_r
#undef focus_xh
#undef focus_xw
#undef focus_ah
#undef focus_aw
#undef target_z
#undef target_y
#undef target_x
#undef target_index
#undef visualize
#undef yheight2
#undef xwidth2
#undef zdepth
#undef yheight
#undef xwidth
#undef priority
#undef material_string
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

/* User declarations for component 'channel_3_analyzer_2_array_crystal_array_3' [258]. */
#define mccompcurname  channel_3_analyzer_2_array_crystal_array_3
#define mccompcurtype  Union_box
#define mccompcurindex 258
#define loop_index mccchannel_3_analyzer_2_array_crystal_array_3_loop_index
#define this_box_volume mccchannel_3_analyzer_2_array_crystal_array_3_this_box_volume
#define global_geometry_element mccchannel_3_analyzer_2_array_crystal_array_3_global_geometry_element
#define this_box_storage mccchannel_3_analyzer_2_array_crystal_array_3_this_box_storage
#define material_string mccchannel_3_analyzer_2_array_crystal_array_3_material_string
#define priority mccchannel_3_analyzer_2_array_crystal_array_3_priority
#define xwidth mccchannel_3_analyzer_2_array_crystal_array_3_xwidth
#define yheight mccchannel_3_analyzer_2_array_crystal_array_3_yheight
#define zdepth mccchannel_3_analyzer_2_array_crystal_array_3_zdepth
#define xwidth2 mccchannel_3_analyzer_2_array_crystal_array_3_xwidth2
#define yheight2 mccchannel_3_analyzer_2_array_crystal_array_3_yheight2
#define visualize mccchannel_3_analyzer_2_array_crystal_array_3_visualize
#define target_index mccchannel_3_analyzer_2_array_crystal_array_3_target_index
#define target_x mccchannel_3_analyzer_2_array_crystal_array_3_target_x
#define target_y mccchannel_3_analyzer_2_array_crystal_array_3_target_y
#define target_z mccchannel_3_analyzer_2_array_crystal_array_3_target_z
#define focus_aw mccchannel_3_analyzer_2_array_crystal_array_3_focus_aw
#define focus_ah mccchannel_3_analyzer_2_array_crystal_array_3_focus_ah
#define focus_xw mccchannel_3_analyzer_2_array_crystal_array_3_focus_xw
#define focus_xh mccchannel_3_analyzer_2_array_crystal_array_3_focus_xh
#define focus_r mccchannel_3_analyzer_2_array_crystal_array_3_focus_r
#define p_interact mccchannel_3_analyzer_2_array_crystal_array_3_p_interact
#define mask_string mccchannel_3_analyzer_2_array_crystal_array_3_mask_string
#define mask_setting mccchannel_3_analyzer_2_array_crystal_array_3_mask_setting
#define number_of_activations mccchannel_3_analyzer_2_array_crystal_array_3_number_of_activations
#line 204 "Union_box.comp"
// Needed for transport to the main component
struct global_geometry_element_struct global_geometry_element;

#ifndef ANY_GEOMETRY_DETECTOR_DECLARE
    #define ANY_GEOMETRY_DETECTOR_DECLARE dummy
	//struct pointer_to_global_geometry_list global_geometry_list = {0,NULL};
#endif

int loop_index,found_geometries;

double x_component;
double y_component;
double z_component;

struct Volume_struct this_box_volume;
struct box_storage this_box_storage;

#line 42473 "MACS_sample_kidney_box.c"
#undef number_of_activations
#undef mask_setting
#undef mask_string
#undef p_interact
#undef focus_r
#undef focus_xh
#undef focus_xw
#undef focus_ah
#undef focus_aw
#undef target_z
#undef target_y
#undef target_x
#undef target_index
#undef visualize
#undef yheight2
#undef xwidth2
#undef zdepth
#undef yheight
#undef xwidth
#undef priority
#undef material_string
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

/* User declarations for component 'channel_3_analyzer_2_array_crystal_array_4' [259]. */
#define mccompcurname  channel_3_analyzer_2_array_crystal_array_4
#define mccompcurtype  Union_box
#define mccompcurindex 259
#define loop_index mccchannel_3_analyzer_2_array_crystal_array_4_loop_index
#define this_box_volume mccchannel_3_analyzer_2_array_crystal_array_4_this_box_volume
#define global_geometry_element mccchannel_3_analyzer_2_array_crystal_array_4_global_geometry_element
#define this_box_storage mccchannel_3_analyzer_2_array_crystal_array_4_this_box_storage
#define material_string mccchannel_3_analyzer_2_array_crystal_array_4_material_string
#define priority mccchannel_3_analyzer_2_array_crystal_array_4_priority
#define xwidth mccchannel_3_analyzer_2_array_crystal_array_4_xwidth
#define yheight mccchannel_3_analyzer_2_array_crystal_array_4_yheight
#define zdepth mccchannel_3_analyzer_2_array_crystal_array_4_zdepth
#define xwidth2 mccchannel_3_analyzer_2_array_crystal_array_4_xwidth2
#define yheight2 mccchannel_3_analyzer_2_array_crystal_array_4_yheight2
#define visualize mccchannel_3_analyzer_2_array_crystal_array_4_visualize
#define target_index mccchannel_3_analyzer_2_array_crystal_array_4_target_index
#define target_x mccchannel_3_analyzer_2_array_crystal_array_4_target_x
#define target_y mccchannel_3_analyzer_2_array_crystal_array_4_target_y
#define target_z mccchannel_3_analyzer_2_array_crystal_array_4_target_z
#define focus_aw mccchannel_3_analyzer_2_array_crystal_array_4_focus_aw
#define focus_ah mccchannel_3_analyzer_2_array_crystal_array_4_focus_ah
#define focus_xw mccchannel_3_analyzer_2_array_crystal_array_4_focus_xw
#define focus_xh mccchannel_3_analyzer_2_array_crystal_array_4_focus_xh
#define focus_r mccchannel_3_analyzer_2_array_crystal_array_4_focus_r
#define p_interact mccchannel_3_analyzer_2_array_crystal_array_4_p_interact
#define mask_string mccchannel_3_analyzer_2_array_crystal_array_4_mask_string
#define mask_setting mccchannel_3_analyzer_2_array_crystal_array_4_mask_setting
#define number_of_activations mccchannel_3_analyzer_2_array_crystal_array_4_number_of_activations
#line 204 "Union_box.comp"
// Needed for transport to the main component
struct global_geometry_element_struct global_geometry_element;

#ifndef ANY_GEOMETRY_DETECTOR_DECLARE
    #define ANY_GEOMETRY_DETECTOR_DECLARE dummy
	//struct pointer_to_global_geometry_list global_geometry_list = {0,NULL};
#endif

int loop_index,found_geometries;

double x_component;
double y_component;
double z_component;

struct Volume_struct this_box_volume;
struct box_storage this_box_storage;

#line 42550 "MACS_sample_kidney_box.c"
#undef number_of_activations
#undef mask_setting
#undef mask_string
#undef p_interact
#undef focus_r
#undef focus_xh
#undef focus_xw
#undef focus_ah
#undef focus_aw
#undef target_z
#undef target_y
#undef target_x
#undef target_index
#undef visualize
#undef yheight2
#undef xwidth2
#undef zdepth
#undef yheight
#undef xwidth
#undef priority
#undef material_string
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

/* User declarations for component 'channel_3_analyzer_2_array_crystal_array_5' [260]. */
#define mccompcurname  channel_3_analyzer_2_array_crystal_array_5
#define mccompcurtype  Union_box
#define mccompcurindex 260
#define loop_index mccchannel_3_analyzer_2_array_crystal_array_5_loop_index
#define this_box_volume mccchannel_3_analyzer_2_array_crystal_array_5_this_box_volume
#define global_geometry_element mccchannel_3_analyzer_2_array_crystal_array_5_global_geometry_element
#define this_box_storage mccchannel_3_analyzer_2_array_crystal_array_5_this_box_storage
#define material_string mccchannel_3_analyzer_2_array_crystal_array_5_material_string
#define priority mccchannel_3_analyzer_2_array_crystal_array_5_priority
#define xwidth mccchannel_3_analyzer_2_array_crystal_array_5_xwidth
#define yheight mccchannel_3_analyzer_2_array_crystal_array_5_yheight
#define zdepth mccchannel_3_analyzer_2_array_crystal_array_5_zdepth
#define xwidth2 mccchannel_3_analyzer_2_array_crystal_array_5_xwidth2
#define yheight2 mccchannel_3_analyzer_2_array_crystal_array_5_yheight2
#define visualize mccchannel_3_analyzer_2_array_crystal_array_5_visualize
#define target_index mccchannel_3_analyzer_2_array_crystal_array_5_target_index
#define target_x mccchannel_3_analyzer_2_array_crystal_array_5_target_x
#define target_y mccchannel_3_analyzer_2_array_crystal_array_5_target_y
#define target_z mccchannel_3_analyzer_2_array_crystal_array_5_target_z
#define focus_aw mccchannel_3_analyzer_2_array_crystal_array_5_focus_aw
#define focus_ah mccchannel_3_analyzer_2_array_crystal_array_5_focus_ah
#define focus_xw mccchannel_3_analyzer_2_array_crystal_array_5_focus_xw
#define focus_xh mccchannel_3_analyzer_2_array_crystal_array_5_focus_xh
#define focus_r mccchannel_3_analyzer_2_array_crystal_array_5_focus_r
#define p_interact mccchannel_3_analyzer_2_array_crystal_array_5_p_interact
#define mask_string mccchannel_3_analyzer_2_array_crystal_array_5_mask_string
#define mask_setting mccchannel_3_analyzer_2_array_crystal_array_5_mask_setting
#define number_of_activations mccchannel_3_analyzer_2_array_crystal_array_5_number_of_activations
#line 204 "Union_box.comp"
// Needed for transport to the main component
struct global_geometry_element_struct global_geometry_element;

#ifndef ANY_GEOMETRY_DETECTOR_DECLARE
    #define ANY_GEOMETRY_DETECTOR_DECLARE dummy
	//struct pointer_to_global_geometry_list global_geometry_list = {0,NULL};
#endif

int loop_index,found_geometries;

double x_component;
double y_component;
double z_component;

struct Volume_struct this_box_volume;
struct box_storage this_box_storage;

#line 42627 "MACS_sample_kidney_box.c"
#undef number_of_activations
#undef mask_setting
#undef mask_string
#undef p_interact
#undef focus_r
#undef focus_xh
#undef focus_xw
#undef focus_ah
#undef focus_aw
#undef target_z
#undef target_y
#undef target_x
#undef target_index
#undef visualize
#undef yheight2
#undef xwidth2
#undef zdepth
#undef yheight
#undef xwidth
#undef priority
#undef material_string
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

/* User declarations for component 'channel_3_analyzer_2_array_crystal_array_6' [261]. */
#define mccompcurname  channel_3_analyzer_2_array_crystal_array_6
#define mccompcurtype  Union_box
#define mccompcurindex 261
#define loop_index mccchannel_3_analyzer_2_array_crystal_array_6_loop_index
#define this_box_volume mccchannel_3_analyzer_2_array_crystal_array_6_this_box_volume
#define global_geometry_element mccchannel_3_analyzer_2_array_crystal_array_6_global_geometry_element
#define this_box_storage mccchannel_3_analyzer_2_array_crystal_array_6_this_box_storage
#define material_string mccchannel_3_analyzer_2_array_crystal_array_6_material_string
#define priority mccchannel_3_analyzer_2_array_crystal_array_6_priority
#define xwidth mccchannel_3_analyzer_2_array_crystal_array_6_xwidth
#define yheight mccchannel_3_analyzer_2_array_crystal_array_6_yheight
#define zdepth mccchannel_3_analyzer_2_array_crystal_array_6_zdepth
#define xwidth2 mccchannel_3_analyzer_2_array_crystal_array_6_xwidth2
#define yheight2 mccchannel_3_analyzer_2_array_crystal_array_6_yheight2
#define visualize mccchannel_3_analyzer_2_array_crystal_array_6_visualize
#define target_index mccchannel_3_analyzer_2_array_crystal_array_6_target_index
#define target_x mccchannel_3_analyzer_2_array_crystal_array_6_target_x
#define target_y mccchannel_3_analyzer_2_array_crystal_array_6_target_y
#define target_z mccchannel_3_analyzer_2_array_crystal_array_6_target_z
#define focus_aw mccchannel_3_analyzer_2_array_crystal_array_6_focus_aw
#define focus_ah mccchannel_3_analyzer_2_array_crystal_array_6_focus_ah
#define focus_xw mccchannel_3_analyzer_2_array_crystal_array_6_focus_xw
#define focus_xh mccchannel_3_analyzer_2_array_crystal_array_6_focus_xh
#define focus_r mccchannel_3_analyzer_2_array_crystal_array_6_focus_r
#define p_interact mccchannel_3_analyzer_2_array_crystal_array_6_p_interact
#define mask_string mccchannel_3_analyzer_2_array_crystal_array_6_mask_string
#define mask_setting mccchannel_3_analyzer_2_array_crystal_array_6_mask_setting
#define number_of_activations mccchannel_3_analyzer_2_array_crystal_array_6_number_of_activations
#line 204 "Union_box.comp"
// Needed for transport to the main component
struct global_geometry_element_struct global_geometry_element;

#ifndef ANY_GEOMETRY_DETECTOR_DECLARE
    #define ANY_GEOMETRY_DETECTOR_DECLARE dummy
	//struct pointer_to_global_geometry_list global_geometry_list = {0,NULL};
#endif

int loop_index,found_geometries;

double x_component;
double y_component;
double z_component;

struct Volume_struct this_box_volume;
struct box_storage this_box_storage;

#line 42704 "MACS_sample_kidney_box.c"
#undef number_of_activations
#undef mask_setting
#undef mask_string
#undef p_interact
#undef focus_r
#undef focus_xh
#undef focus_xw
#undef focus_ah
#undef focus_aw
#undef target_z
#undef target_y
#undef target_x
#undef target_index
#undef visualize
#undef yheight2
#undef xwidth2
#undef zdepth
#undef yheight
#undef xwidth
#undef priority
#undef material_string
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

/* User declarations for component 'channel_3_analyzer_2_array_crystal_array_7' [262]. */
#define mccompcurname  channel_3_analyzer_2_array_crystal_array_7
#define mccompcurtype  Union_box
#define mccompcurindex 262
#define loop_index mccchannel_3_analyzer_2_array_crystal_array_7_loop_index
#define this_box_volume mccchannel_3_analyzer_2_array_crystal_array_7_this_box_volume
#define global_geometry_element mccchannel_3_analyzer_2_array_crystal_array_7_global_geometry_element
#define this_box_storage mccchannel_3_analyzer_2_array_crystal_array_7_this_box_storage
#define material_string mccchannel_3_analyzer_2_array_crystal_array_7_material_string
#define priority mccchannel_3_analyzer_2_array_crystal_array_7_priority
#define xwidth mccchannel_3_analyzer_2_array_crystal_array_7_xwidth
#define yheight mccchannel_3_analyzer_2_array_crystal_array_7_yheight
#define zdepth mccchannel_3_analyzer_2_array_crystal_array_7_zdepth
#define xwidth2 mccchannel_3_analyzer_2_array_crystal_array_7_xwidth2
#define yheight2 mccchannel_3_analyzer_2_array_crystal_array_7_yheight2
#define visualize mccchannel_3_analyzer_2_array_crystal_array_7_visualize
#define target_index mccchannel_3_analyzer_2_array_crystal_array_7_target_index
#define target_x mccchannel_3_analyzer_2_array_crystal_array_7_target_x
#define target_y mccchannel_3_analyzer_2_array_crystal_array_7_target_y
#define target_z mccchannel_3_analyzer_2_array_crystal_array_7_target_z
#define focus_aw mccchannel_3_analyzer_2_array_crystal_array_7_focus_aw
#define focus_ah mccchannel_3_analyzer_2_array_crystal_array_7_focus_ah
#define focus_xw mccchannel_3_analyzer_2_array_crystal_array_7_focus_xw
#define focus_xh mccchannel_3_analyzer_2_array_crystal_array_7_focus_xh
#define focus_r mccchannel_3_analyzer_2_array_crystal_array_7_focus_r
#define p_interact mccchannel_3_analyzer_2_array_crystal_array_7_p_interact
#define mask_string mccchannel_3_analyzer_2_array_crystal_array_7_mask_string
#define mask_setting mccchannel_3_analyzer_2_array_crystal_array_7_mask_setting
#define number_of_activations mccchannel_3_analyzer_2_array_crystal_array_7_number_of_activations
#line 204 "Union_box.comp"
// Needed for transport to the main component
struct global_geometry_element_struct global_geometry_element;

#ifndef ANY_GEOMETRY_DETECTOR_DECLARE
    #define ANY_GEOMETRY_DETECTOR_DECLARE dummy
	//struct pointer_to_global_geometry_list global_geometry_list = {0,NULL};
#endif

int loop_index,found_geometries;

double x_component;
double y_component;
double z_component;

struct Volume_struct this_box_volume;
struct box_storage this_box_storage;

#line 42781 "MACS_sample_kidney_box.c"
#undef number_of_activations
#undef mask_setting
#undef mask_string
#undef p_interact
#undef focus_r
#undef focus_xh
#undef focus_xw
#undef focus_ah
#undef focus_aw
#undef target_z
#undef target_y
#undef target_x
#undef target_index
#undef visualize
#undef yheight2
#undef xwidth2
#undef zdepth
#undef yheight
#undef xwidth
#undef priority
#undef material_string
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

/* User declarations for component 'channel_3_analyzer_2_array_crystal_array_8' [263]. */
#define mccompcurname  channel_3_analyzer_2_array_crystal_array_8
#define mccompcurtype  Union_box
#define mccompcurindex 263
#define loop_index mccchannel_3_analyzer_2_array_crystal_array_8_loop_index
#define this_box_volume mccchannel_3_analyzer_2_array_crystal_array_8_this_box_volume
#define global_geometry_element mccchannel_3_analyzer_2_array_crystal_array_8_global_geometry_element
#define this_box_storage mccchannel_3_analyzer_2_array_crystal_array_8_this_box_storage
#define material_string mccchannel_3_analyzer_2_array_crystal_array_8_material_string
#define priority mccchannel_3_analyzer_2_array_crystal_array_8_priority
#define xwidth mccchannel_3_analyzer_2_array_crystal_array_8_xwidth
#define yheight mccchannel_3_analyzer_2_array_crystal_array_8_yheight
#define zdepth mccchannel_3_analyzer_2_array_crystal_array_8_zdepth
#define xwidth2 mccchannel_3_analyzer_2_array_crystal_array_8_xwidth2
#define yheight2 mccchannel_3_analyzer_2_array_crystal_array_8_yheight2
#define visualize mccchannel_3_analyzer_2_array_crystal_array_8_visualize
#define target_index mccchannel_3_analyzer_2_array_crystal_array_8_target_index
#define target_x mccchannel_3_analyzer_2_array_crystal_array_8_target_x
#define target_y mccchannel_3_analyzer_2_array_crystal_array_8_target_y
#define target_z mccchannel_3_analyzer_2_array_crystal_array_8_target_z
#define focus_aw mccchannel_3_analyzer_2_array_crystal_array_8_focus_aw
#define focus_ah mccchannel_3_analyzer_2_array_crystal_array_8_focus_ah
#define focus_xw mccchannel_3_analyzer_2_array_crystal_array_8_focus_xw
#define focus_xh mccchannel_3_analyzer_2_array_crystal_array_8_focus_xh
#define focus_r mccchannel_3_analyzer_2_array_crystal_array_8_focus_r
#define p_interact mccchannel_3_analyzer_2_array_crystal_array_8_p_interact
#define mask_string mccchannel_3_analyzer_2_array_crystal_array_8_mask_string
#define mask_setting mccchannel_3_analyzer_2_array_crystal_array_8_mask_setting
#define number_of_activations mccchannel_3_analyzer_2_array_crystal_array_8_number_of_activations
#line 204 "Union_box.comp"
// Needed for transport to the main component
struct global_geometry_element_struct global_geometry_element;

#ifndef ANY_GEOMETRY_DETECTOR_DECLARE
    #define ANY_GEOMETRY_DETECTOR_DECLARE dummy
	//struct pointer_to_global_geometry_list global_geometry_list = {0,NULL};
#endif

int loop_index,found_geometries;

double x_component;
double y_component;
double z_component;

struct Volume_struct this_box_volume;
struct box_storage this_box_storage;

#line 42858 "MACS_sample_kidney_box.c"
#undef number_of_activations
#undef mask_setting
#undef mask_string
#undef p_interact
#undef focus_r
#undef focus_xh
#undef focus_xw
#undef focus_ah
#undef focus_aw
#undef target_z
#undef target_y
#undef target_x
#undef target_index
#undef visualize
#undef yheight2
#undef xwidth2
#undef zdepth
#undef yheight
#undef xwidth
#undef priority
#undef material_string
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

/* User declarations for component 'channel_3_cave2_cyl1' [264]. */
#define mccompcurname  channel_3_cave2_cyl1
#define mccompcurtype  Union_cylinder
#define mccompcurindex 264
#define loop_index mccchannel_3_cave2_cyl1_loop_index
#define this_cylinder_volume mccchannel_3_cave2_cyl1_this_cylinder_volume
#define global_geometry_element mccchannel_3_cave2_cyl1_global_geometry_element
#define this_cylinder_storage mccchannel_3_cave2_cyl1_this_cylinder_storage
#define material_string mccchannel_3_cave2_cyl1_material_string
#define priority mccchannel_3_cave2_cyl1_priority
#define radius mccchannel_3_cave2_cyl1_radius
#define yheight mccchannel_3_cave2_cyl1_yheight
#define visualize mccchannel_3_cave2_cyl1_visualize
#define target_index mccchannel_3_cave2_cyl1_target_index
#define target_x mccchannel_3_cave2_cyl1_target_x
#define target_y mccchannel_3_cave2_cyl1_target_y
#define target_z mccchannel_3_cave2_cyl1_target_z
#define focus_aw mccchannel_3_cave2_cyl1_focus_aw
#define focus_ah mccchannel_3_cave2_cyl1_focus_ah
#define focus_xw mccchannel_3_cave2_cyl1_focus_xw
#define focus_xh mccchannel_3_cave2_cyl1_focus_xh
#define focus_r mccchannel_3_cave2_cyl1_focus_r
#define p_interact mccchannel_3_cave2_cyl1_p_interact
#define mask_string mccchannel_3_cave2_cyl1_mask_string
#define mask_setting mccchannel_3_cave2_cyl1_mask_setting
#define number_of_activations mccchannel_3_cave2_cyl1_number_of_activations
#line 167 "Union_cylinder.comp"
// Needed for transport to the main component
struct global_geometry_element_struct global_geometry_element;

#ifndef ANY_GEOMETRY_DETECTOR_DECLARE
    #define ANY_GEOMETRY_DETECTOR_DECLARE dummy
	//struct pointer_to_global_geometry_list global_geometry_list = {0,NULL};
#endif

int dummy;
int loop_index,found_geometries;
int loop_2_index;
int material_index;

struct Volume_struct this_cylinder_volume;
struct cylinder_storage this_cylinder_storage;
#line 42930 "MACS_sample_kidney_box.c"
#undef number_of_activations
#undef mask_setting
#undef mask_string
#undef p_interact
#undef focus_r
#undef focus_xh
#undef focus_xw
#undef focus_ah
#undef focus_aw
#undef target_z
#undef target_y
#undef target_x
#undef target_index
#undef visualize
#undef yheight
#undef radius
#undef priority
#undef material_string
#undef this_cylinder_storage
#undef global_geometry_element
#undef this_cylinder_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

/* User declarations for component 'channel_3_cave2_box1' [265]. */
#define mccompcurname  channel_3_cave2_box1
#define mccompcurtype  Union_box
#define mccompcurindex 265
#define loop_index mccchannel_3_cave2_box1_loop_index
#define this_box_volume mccchannel_3_cave2_box1_this_box_volume
#define global_geometry_element mccchannel_3_cave2_box1_global_geometry_element
#define this_box_storage mccchannel_3_cave2_box1_this_box_storage
#define material_string mccchannel_3_cave2_box1_material_string
#define priority mccchannel_3_cave2_box1_priority
#define xwidth mccchannel_3_cave2_box1_xwidth
#define yheight mccchannel_3_cave2_box1_yheight
#define zdepth mccchannel_3_cave2_box1_zdepth
#define xwidth2 mccchannel_3_cave2_box1_xwidth2
#define yheight2 mccchannel_3_cave2_box1_yheight2
#define visualize mccchannel_3_cave2_box1_visualize
#define target_index mccchannel_3_cave2_box1_target_index
#define target_x mccchannel_3_cave2_box1_target_x
#define target_y mccchannel_3_cave2_box1_target_y
#define target_z mccchannel_3_cave2_box1_target_z
#define focus_aw mccchannel_3_cave2_box1_focus_aw
#define focus_ah mccchannel_3_cave2_box1_focus_ah
#define focus_xw mccchannel_3_cave2_box1_focus_xw
#define focus_xh mccchannel_3_cave2_box1_focus_xh
#define focus_r mccchannel_3_cave2_box1_focus_r
#define p_interact mccchannel_3_cave2_box1_p_interact
#define mask_string mccchannel_3_cave2_box1_mask_string
#define mask_setting mccchannel_3_cave2_box1_mask_setting
#define number_of_activations mccchannel_3_cave2_box1_number_of_activations
#line 204 "Union_box.comp"
// Needed for transport to the main component
struct global_geometry_element_struct global_geometry_element;

#ifndef ANY_GEOMETRY_DETECTOR_DECLARE
    #define ANY_GEOMETRY_DETECTOR_DECLARE dummy
	//struct pointer_to_global_geometry_list global_geometry_list = {0,NULL};
#endif

int loop_index,found_geometries;

double x_component;
double y_component;
double z_component;

struct Volume_struct this_box_volume;
struct box_storage this_box_storage;

#line 43004 "MACS_sample_kidney_box.c"
#undef number_of_activations
#undef mask_setting
#undef mask_string
#undef p_interact
#undef focus_r
#undef focus_xh
#undef focus_xw
#undef focus_ah
#undef focus_aw
#undef target_z
#undef target_y
#undef target_x
#undef target_index
#undef visualize
#undef yheight2
#undef xwidth2
#undef zdepth
#undef yheight
#undef xwidth
#undef priority
#undef material_string
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

/* User declarations for component 'channel_3_cave2_box2' [266]. */
#define mccompcurname  channel_3_cave2_box2
#define mccompcurtype  Union_box
#define mccompcurindex 266
#define loop_index mccchannel_3_cave2_box2_loop_index
#define this_box_volume mccchannel_3_cave2_box2_this_box_volume
#define global_geometry_element mccchannel_3_cave2_box2_global_geometry_element
#define this_box_storage mccchannel_3_cave2_box2_this_box_storage
#define material_string mccchannel_3_cave2_box2_material_string
#define priority mccchannel_3_cave2_box2_priority
#define xwidth mccchannel_3_cave2_box2_xwidth
#define yheight mccchannel_3_cave2_box2_yheight
#define zdepth mccchannel_3_cave2_box2_zdepth
#define xwidth2 mccchannel_3_cave2_box2_xwidth2
#define yheight2 mccchannel_3_cave2_box2_yheight2
#define visualize mccchannel_3_cave2_box2_visualize
#define target_index mccchannel_3_cave2_box2_target_index
#define target_x mccchannel_3_cave2_box2_target_x
#define target_y mccchannel_3_cave2_box2_target_y
#define target_z mccchannel_3_cave2_box2_target_z
#define focus_aw mccchannel_3_cave2_box2_focus_aw
#define focus_ah mccchannel_3_cave2_box2_focus_ah
#define focus_xw mccchannel_3_cave2_box2_focus_xw
#define focus_xh mccchannel_3_cave2_box2_focus_xh
#define focus_r mccchannel_3_cave2_box2_focus_r
#define p_interact mccchannel_3_cave2_box2_p_interact
#define mask_string mccchannel_3_cave2_box2_mask_string
#define mask_setting mccchannel_3_cave2_box2_mask_setting
#define number_of_activations mccchannel_3_cave2_box2_number_of_activations
#line 204 "Union_box.comp"
// Needed for transport to the main component
struct global_geometry_element_struct global_geometry_element;

#ifndef ANY_GEOMETRY_DETECTOR_DECLARE
    #define ANY_GEOMETRY_DETECTOR_DECLARE dummy
	//struct pointer_to_global_geometry_list global_geometry_list = {0,NULL};
#endif

int loop_index,found_geometries;

double x_component;
double y_component;
double z_component;

struct Volume_struct this_box_volume;
struct box_storage this_box_storage;

#line 43081 "MACS_sample_kidney_box.c"
#undef number_of_activations
#undef mask_setting
#undef mask_string
#undef p_interact
#undef focus_r
#undef focus_xh
#undef focus_xw
#undef focus_ah
#undef focus_aw
#undef target_z
#undef target_y
#undef target_x
#undef target_index
#undef visualize
#undef yheight2
#undef xwidth2
#undef zdepth
#undef yheight
#undef xwidth
#undef priority
#undef material_string
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

/* User declarations for component 'channel_3_cave2_box3' [267]. */
#define mccompcurname  channel_3_cave2_box3
#define mccompcurtype  Union_box
#define mccompcurindex 267
#define loop_index mccchannel_3_cave2_box3_loop_index
#define this_box_volume mccchannel_3_cave2_box3_this_box_volume
#define global_geometry_element mccchannel_3_cave2_box3_global_geometry_element
#define this_box_storage mccchannel_3_cave2_box3_this_box_storage
#define material_string mccchannel_3_cave2_box3_material_string
#define priority mccchannel_3_cave2_box3_priority
#define xwidth mccchannel_3_cave2_box3_xwidth
#define yheight mccchannel_3_cave2_box3_yheight
#define zdepth mccchannel_3_cave2_box3_zdepth
#define xwidth2 mccchannel_3_cave2_box3_xwidth2
#define yheight2 mccchannel_3_cave2_box3_yheight2
#define visualize mccchannel_3_cave2_box3_visualize
#define target_index mccchannel_3_cave2_box3_target_index
#define target_x mccchannel_3_cave2_box3_target_x
#define target_y mccchannel_3_cave2_box3_target_y
#define target_z mccchannel_3_cave2_box3_target_z
#define focus_aw mccchannel_3_cave2_box3_focus_aw
#define focus_ah mccchannel_3_cave2_box3_focus_ah
#define focus_xw mccchannel_3_cave2_box3_focus_xw
#define focus_xh mccchannel_3_cave2_box3_focus_xh
#define focus_r mccchannel_3_cave2_box3_focus_r
#define p_interact mccchannel_3_cave2_box3_p_interact
#define mask_string mccchannel_3_cave2_box3_mask_string
#define mask_setting mccchannel_3_cave2_box3_mask_setting
#define number_of_activations mccchannel_3_cave2_box3_number_of_activations
#line 204 "Union_box.comp"
// Needed for transport to the main component
struct global_geometry_element_struct global_geometry_element;

#ifndef ANY_GEOMETRY_DETECTOR_DECLARE
    #define ANY_GEOMETRY_DETECTOR_DECLARE dummy
	//struct pointer_to_global_geometry_list global_geometry_list = {0,NULL};
#endif

int loop_index,found_geometries;

double x_component;
double y_component;
double z_component;

struct Volume_struct this_box_volume;
struct box_storage this_box_storage;

#line 43158 "MACS_sample_kidney_box.c"
#undef number_of_activations
#undef mask_setting
#undef mask_string
#undef p_interact
#undef focus_r
#undef focus_xh
#undef focus_xw
#undef focus_ah
#undef focus_aw
#undef target_z
#undef target_y
#undef target_x
#undef target_index
#undef visualize
#undef yheight2
#undef xwidth2
#undef zdepth
#undef yheight
#undef xwidth
#undef priority
#undef material_string
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

/* User declarations for component 'inter_analyzer_colimator_center_3' [268]. */
#define mccompcurname  inter_analyzer_colimator_center_3
#define mccompcurtype  Arm
#define mccompcurindex 268
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

/* User declarations for component 'inter_analyzer_colimator_3_blade_0' [269]. */
#define mccompcurname  inter_analyzer_colimator_3_blade_0
#define mccompcurtype  Union_box
#define mccompcurindex 269
#define loop_index mccinter_analyzer_colimator_3_blade_0_loop_index
#define this_box_volume mccinter_analyzer_colimator_3_blade_0_this_box_volume
#define global_geometry_element mccinter_analyzer_colimator_3_blade_0_global_geometry_element
#define this_box_storage mccinter_analyzer_colimator_3_blade_0_this_box_storage
#define material_string mccinter_analyzer_colimator_3_blade_0_material_string
#define priority mccinter_analyzer_colimator_3_blade_0_priority
#define xwidth mccinter_analyzer_colimator_3_blade_0_xwidth
#define yheight mccinter_analyzer_colimator_3_blade_0_yheight
#define zdepth mccinter_analyzer_colimator_3_blade_0_zdepth
#define xwidth2 mccinter_analyzer_colimator_3_blade_0_xwidth2
#define yheight2 mccinter_analyzer_colimator_3_blade_0_yheight2
#define visualize mccinter_analyzer_colimator_3_blade_0_visualize
#define target_index mccinter_analyzer_colimator_3_blade_0_target_index
#define target_x mccinter_analyzer_colimator_3_blade_0_target_x
#define target_y mccinter_analyzer_colimator_3_blade_0_target_y
#define target_z mccinter_analyzer_colimator_3_blade_0_target_z
#define focus_aw mccinter_analyzer_colimator_3_blade_0_focus_aw
#define focus_ah mccinter_analyzer_colimator_3_blade_0_focus_ah
#define focus_xw mccinter_analyzer_colimator_3_blade_0_focus_xw
#define focus_xh mccinter_analyzer_colimator_3_blade_0_focus_xh
#define focus_r mccinter_analyzer_colimator_3_blade_0_focus_r
#define p_interact mccinter_analyzer_colimator_3_blade_0_p_interact
#define mask_string mccinter_analyzer_colimator_3_blade_0_mask_string
#define mask_setting mccinter_analyzer_colimator_3_blade_0_mask_setting
#define number_of_activations mccinter_analyzer_colimator_3_blade_0_number_of_activations
#line 204 "Union_box.comp"
// Needed for transport to the main component
struct global_geometry_element_struct global_geometry_element;

#ifndef ANY_GEOMETRY_DETECTOR_DECLARE
    #define ANY_GEOMETRY_DETECTOR_DECLARE dummy
	//struct pointer_to_global_geometry_list global_geometry_list = {0,NULL};
#endif

int loop_index,found_geometries;

double x_component;
double y_component;
double z_component;

struct Volume_struct this_box_volume;
struct box_storage this_box_storage;

#line 43243 "MACS_sample_kidney_box.c"
#undef number_of_activations
#undef mask_setting
#undef mask_string
#undef p_interact
#undef focus_r
#undef focus_xh
#undef focus_xw
#undef focus_ah
#undef focus_aw
#undef target_z
#undef target_y
#undef target_x
#undef target_index
#undef visualize
#undef yheight2
#undef xwidth2
#undef zdepth
#undef yheight
#undef xwidth
#undef priority
#undef material_string
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

/* User declarations for component 'inter_analyzer_colimator_3_blade_1' [270]. */
#define mccompcurname  inter_analyzer_colimator_3_blade_1
#define mccompcurtype  Union_box
#define mccompcurindex 270
#define loop_index mccinter_analyzer_colimator_3_blade_1_loop_index
#define this_box_volume mccinter_analyzer_colimator_3_blade_1_this_box_volume
#define global_geometry_element mccinter_analyzer_colimator_3_blade_1_global_geometry_element
#define this_box_storage mccinter_analyzer_colimator_3_blade_1_this_box_storage
#define material_string mccinter_analyzer_colimator_3_blade_1_material_string
#define priority mccinter_analyzer_colimator_3_blade_1_priority
#define xwidth mccinter_analyzer_colimator_3_blade_1_xwidth
#define yheight mccinter_analyzer_colimator_3_blade_1_yheight
#define zdepth mccinter_analyzer_colimator_3_blade_1_zdepth
#define xwidth2 mccinter_analyzer_colimator_3_blade_1_xwidth2
#define yheight2 mccinter_analyzer_colimator_3_blade_1_yheight2
#define visualize mccinter_analyzer_colimator_3_blade_1_visualize
#define target_index mccinter_analyzer_colimator_3_blade_1_target_index
#define target_x mccinter_analyzer_colimator_3_blade_1_target_x
#define target_y mccinter_analyzer_colimator_3_blade_1_target_y
#define target_z mccinter_analyzer_colimator_3_blade_1_target_z
#define focus_aw mccinter_analyzer_colimator_3_blade_1_focus_aw
#define focus_ah mccinter_analyzer_colimator_3_blade_1_focus_ah
#define focus_xw mccinter_analyzer_colimator_3_blade_1_focus_xw
#define focus_xh mccinter_analyzer_colimator_3_blade_1_focus_xh
#define focus_r mccinter_analyzer_colimator_3_blade_1_focus_r
#define p_interact mccinter_analyzer_colimator_3_blade_1_p_interact
#define mask_string mccinter_analyzer_colimator_3_blade_1_mask_string
#define mask_setting mccinter_analyzer_colimator_3_blade_1_mask_setting
#define number_of_activations mccinter_analyzer_colimator_3_blade_1_number_of_activations
#line 204 "Union_box.comp"
// Needed for transport to the main component
struct global_geometry_element_struct global_geometry_element;

#ifndef ANY_GEOMETRY_DETECTOR_DECLARE
    #define ANY_GEOMETRY_DETECTOR_DECLARE dummy
	//struct pointer_to_global_geometry_list global_geometry_list = {0,NULL};
#endif

int loop_index,found_geometries;

double x_component;
double y_component;
double z_component;

struct Volume_struct this_box_volume;
struct box_storage this_box_storage;

#line 43320 "MACS_sample_kidney_box.c"
#undef number_of_activations
#undef mask_setting
#undef mask_string
#undef p_interact
#undef focus_r
#undef focus_xh
#undef focus_xw
#undef focus_ah
#undef focus_aw
#undef target_z
#undef target_y
#undef target_x
#undef target_index
#undef visualize
#undef yheight2
#undef xwidth2
#undef zdepth
#undef yheight
#undef xwidth
#undef priority
#undef material_string
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

/* User declarations for component 'inter_analyzer_colimator_3_blade_2' [271]. */
#define mccompcurname  inter_analyzer_colimator_3_blade_2
#define mccompcurtype  Union_box
#define mccompcurindex 271
#define loop_index mccinter_analyzer_colimator_3_blade_2_loop_index
#define this_box_volume mccinter_analyzer_colimator_3_blade_2_this_box_volume
#define global_geometry_element mccinter_analyzer_colimator_3_blade_2_global_geometry_element
#define this_box_storage mccinter_analyzer_colimator_3_blade_2_this_box_storage
#define material_string mccinter_analyzer_colimator_3_blade_2_material_string
#define priority mccinter_analyzer_colimator_3_blade_2_priority
#define xwidth mccinter_analyzer_colimator_3_blade_2_xwidth
#define yheight mccinter_analyzer_colimator_3_blade_2_yheight
#define zdepth mccinter_analyzer_colimator_3_blade_2_zdepth
#define xwidth2 mccinter_analyzer_colimator_3_blade_2_xwidth2
#define yheight2 mccinter_analyzer_colimator_3_blade_2_yheight2
#define visualize mccinter_analyzer_colimator_3_blade_2_visualize
#define target_index mccinter_analyzer_colimator_3_blade_2_target_index
#define target_x mccinter_analyzer_colimator_3_blade_2_target_x
#define target_y mccinter_analyzer_colimator_3_blade_2_target_y
#define target_z mccinter_analyzer_colimator_3_blade_2_target_z
#define focus_aw mccinter_analyzer_colimator_3_blade_2_focus_aw
#define focus_ah mccinter_analyzer_colimator_3_blade_2_focus_ah
#define focus_xw mccinter_analyzer_colimator_3_blade_2_focus_xw
#define focus_xh mccinter_analyzer_colimator_3_blade_2_focus_xh
#define focus_r mccinter_analyzer_colimator_3_blade_2_focus_r
#define p_interact mccinter_analyzer_colimator_3_blade_2_p_interact
#define mask_string mccinter_analyzer_colimator_3_blade_2_mask_string
#define mask_setting mccinter_analyzer_colimator_3_blade_2_mask_setting
#define number_of_activations mccinter_analyzer_colimator_3_blade_2_number_of_activations
#line 204 "Union_box.comp"
// Needed for transport to the main component
struct global_geometry_element_struct global_geometry_element;

#ifndef ANY_GEOMETRY_DETECTOR_DECLARE
    #define ANY_GEOMETRY_DETECTOR_DECLARE dummy
	//struct pointer_to_global_geometry_list global_geometry_list = {0,NULL};
#endif

int loop_index,found_geometries;

double x_component;
double y_component;
double z_component;

struct Volume_struct this_box_volume;
struct box_storage this_box_storage;

#line 43397 "MACS_sample_kidney_box.c"
#undef number_of_activations
#undef mask_setting
#undef mask_string
#undef p_interact
#undef focus_r
#undef focus_xh
#undef focus_xw
#undef focus_ah
#undef focus_aw
#undef target_z
#undef target_y
#undef target_x
#undef target_index
#undef visualize
#undef yheight2
#undef xwidth2
#undef zdepth
#undef yheight
#undef xwidth
#undef priority
#undef material_string
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

/* User declarations for component 'inter_analyzer_colimator_3_blade_3' [272]. */
#define mccompcurname  inter_analyzer_colimator_3_blade_3
#define mccompcurtype  Union_box
#define mccompcurindex 272
#define loop_index mccinter_analyzer_colimator_3_blade_3_loop_index
#define this_box_volume mccinter_analyzer_colimator_3_blade_3_this_box_volume
#define global_geometry_element mccinter_analyzer_colimator_3_blade_3_global_geometry_element
#define this_box_storage mccinter_analyzer_colimator_3_blade_3_this_box_storage
#define material_string mccinter_analyzer_colimator_3_blade_3_material_string
#define priority mccinter_analyzer_colimator_3_blade_3_priority
#define xwidth mccinter_analyzer_colimator_3_blade_3_xwidth
#define yheight mccinter_analyzer_colimator_3_blade_3_yheight
#define zdepth mccinter_analyzer_colimator_3_blade_3_zdepth
#define xwidth2 mccinter_analyzer_colimator_3_blade_3_xwidth2
#define yheight2 mccinter_analyzer_colimator_3_blade_3_yheight2
#define visualize mccinter_analyzer_colimator_3_blade_3_visualize
#define target_index mccinter_analyzer_colimator_3_blade_3_target_index
#define target_x mccinter_analyzer_colimator_3_blade_3_target_x
#define target_y mccinter_analyzer_colimator_3_blade_3_target_y
#define target_z mccinter_analyzer_colimator_3_blade_3_target_z
#define focus_aw mccinter_analyzer_colimator_3_blade_3_focus_aw
#define focus_ah mccinter_analyzer_colimator_3_blade_3_focus_ah
#define focus_xw mccinter_analyzer_colimator_3_blade_3_focus_xw
#define focus_xh mccinter_analyzer_colimator_3_blade_3_focus_xh
#define focus_r mccinter_analyzer_colimator_3_blade_3_focus_r
#define p_interact mccinter_analyzer_colimator_3_blade_3_p_interact
#define mask_string mccinter_analyzer_colimator_3_blade_3_mask_string
#define mask_setting mccinter_analyzer_colimator_3_blade_3_mask_setting
#define number_of_activations mccinter_analyzer_colimator_3_blade_3_number_of_activations
#line 204 "Union_box.comp"
// Needed for transport to the main component
struct global_geometry_element_struct global_geometry_element;

#ifndef ANY_GEOMETRY_DETECTOR_DECLARE
    #define ANY_GEOMETRY_DETECTOR_DECLARE dummy
	//struct pointer_to_global_geometry_list global_geometry_list = {0,NULL};
#endif

int loop_index,found_geometries;

double x_component;
double y_component;
double z_component;

struct Volume_struct this_box_volume;
struct box_storage this_box_storage;

#line 43474 "MACS_sample_kidney_box.c"
#undef number_of_activations
#undef mask_setting
#undef mask_string
#undef p_interact
#undef focus_r
#undef focus_xh
#undef focus_xw
#undef focus_ah
#undef focus_aw
#undef target_z
#undef target_y
#undef target_x
#undef target_index
#undef visualize
#undef yheight2
#undef xwidth2
#undef zdepth
#undef yheight
#undef xwidth
#undef priority
#undef material_string
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

/* User declarations for component 'inter_analyzer_colimator_3_blade_4' [273]. */
#define mccompcurname  inter_analyzer_colimator_3_blade_4
#define mccompcurtype  Union_box
#define mccompcurindex 273
#define loop_index mccinter_analyzer_colimator_3_blade_4_loop_index
#define this_box_volume mccinter_analyzer_colimator_3_blade_4_this_box_volume
#define global_geometry_element mccinter_analyzer_colimator_3_blade_4_global_geometry_element
#define this_box_storage mccinter_analyzer_colimator_3_blade_4_this_box_storage
#define material_string mccinter_analyzer_colimator_3_blade_4_material_string
#define priority mccinter_analyzer_colimator_3_blade_4_priority
#define xwidth mccinter_analyzer_colimator_3_blade_4_xwidth
#define yheight mccinter_analyzer_colimator_3_blade_4_yheight
#define zdepth mccinter_analyzer_colimator_3_blade_4_zdepth
#define xwidth2 mccinter_analyzer_colimator_3_blade_4_xwidth2
#define yheight2 mccinter_analyzer_colimator_3_blade_4_yheight2
#define visualize mccinter_analyzer_colimator_3_blade_4_visualize
#define target_index mccinter_analyzer_colimator_3_blade_4_target_index
#define target_x mccinter_analyzer_colimator_3_blade_4_target_x
#define target_y mccinter_analyzer_colimator_3_blade_4_target_y
#define target_z mccinter_analyzer_colimator_3_blade_4_target_z
#define focus_aw mccinter_analyzer_colimator_3_blade_4_focus_aw
#define focus_ah mccinter_analyzer_colimator_3_blade_4_focus_ah
#define focus_xw mccinter_analyzer_colimator_3_blade_4_focus_xw
#define focus_xh mccinter_analyzer_colimator_3_blade_4_focus_xh
#define focus_r mccinter_analyzer_colimator_3_blade_4_focus_r
#define p_interact mccinter_analyzer_colimator_3_blade_4_p_interact
#define mask_string mccinter_analyzer_colimator_3_blade_4_mask_string
#define mask_setting mccinter_analyzer_colimator_3_blade_4_mask_setting
#define number_of_activations mccinter_analyzer_colimator_3_blade_4_number_of_activations
#line 204 "Union_box.comp"
// Needed for transport to the main component
struct global_geometry_element_struct global_geometry_element;

#ifndef ANY_GEOMETRY_DETECTOR_DECLARE
    #define ANY_GEOMETRY_DETECTOR_DECLARE dummy
	//struct pointer_to_global_geometry_list global_geometry_list = {0,NULL};
#endif

int loop_index,found_geometries;

double x_component;
double y_component;
double z_component;

struct Volume_struct this_box_volume;
struct box_storage this_box_storage;

#line 43551 "MACS_sample_kidney_box.c"
#undef number_of_activations
#undef mask_setting
#undef mask_string
#undef p_interact
#undef focus_r
#undef focus_xh
#undef focus_xw
#undef focus_ah
#undef focus_aw
#undef target_z
#undef target_y
#undef target_x
#undef target_index
#undef visualize
#undef yheight2
#undef xwidth2
#undef zdepth
#undef yheight
#undef xwidth
#undef priority
#undef material_string
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

/* User declarations for component 'diffraction_detector_3_exit_volume' [274]. */
#define mccompcurname  diffraction_detector_3_exit_volume
#define mccompcurtype  Union_box
#define mccompcurindex 274
#define loop_index mccdiffraction_detector_3_exit_volume_loop_index
#define this_box_volume mccdiffraction_detector_3_exit_volume_this_box_volume
#define global_geometry_element mccdiffraction_detector_3_exit_volume_global_geometry_element
#define this_box_storage mccdiffraction_detector_3_exit_volume_this_box_storage
#define material_string mccdiffraction_detector_3_exit_volume_material_string
#define priority mccdiffraction_detector_3_exit_volume_priority
#define xwidth mccdiffraction_detector_3_exit_volume_xwidth
#define yheight mccdiffraction_detector_3_exit_volume_yheight
#define zdepth mccdiffraction_detector_3_exit_volume_zdepth
#define xwidth2 mccdiffraction_detector_3_exit_volume_xwidth2
#define yheight2 mccdiffraction_detector_3_exit_volume_yheight2
#define visualize mccdiffraction_detector_3_exit_volume_visualize
#define target_index mccdiffraction_detector_3_exit_volume_target_index
#define target_x mccdiffraction_detector_3_exit_volume_target_x
#define target_y mccdiffraction_detector_3_exit_volume_target_y
#define target_z mccdiffraction_detector_3_exit_volume_target_z
#define focus_aw mccdiffraction_detector_3_exit_volume_focus_aw
#define focus_ah mccdiffraction_detector_3_exit_volume_focus_ah
#define focus_xw mccdiffraction_detector_3_exit_volume_focus_xw
#define focus_xh mccdiffraction_detector_3_exit_volume_focus_xh
#define focus_r mccdiffraction_detector_3_exit_volume_focus_r
#define p_interact mccdiffraction_detector_3_exit_volume_p_interact
#define mask_string mccdiffraction_detector_3_exit_volume_mask_string
#define mask_setting mccdiffraction_detector_3_exit_volume_mask_setting
#define number_of_activations mccdiffraction_detector_3_exit_volume_number_of_activations
#line 204 "Union_box.comp"
// Needed for transport to the main component
struct global_geometry_element_struct global_geometry_element;

#ifndef ANY_GEOMETRY_DETECTOR_DECLARE
    #define ANY_GEOMETRY_DETECTOR_DECLARE dummy
	//struct pointer_to_global_geometry_list global_geometry_list = {0,NULL};
#endif

int loop_index,found_geometries;

double x_component;
double y_component;
double z_component;

struct Volume_struct this_box_volume;
struct box_storage this_box_storage;

#line 43628 "MACS_sample_kidney_box.c"
#undef number_of_activations
#undef mask_setting
#undef mask_string
#undef p_interact
#undef focus_r
#undef focus_xh
#undef focus_xw
#undef focus_ah
#undef focus_aw
#undef target_z
#undef target_y
#undef target_x
#undef target_index
#undef visualize
#undef yheight2
#undef xwidth2
#undef zdepth
#undef yheight
#undef xwidth
#undef priority
#undef material_string
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

/* User declarations for component 'spec_detector_3_exit_volume' [275]. */
#define mccompcurname  spec_detector_3_exit_volume
#define mccompcurtype  Union_box
#define mccompcurindex 275
#define loop_index mccspec_detector_3_exit_volume_loop_index
#define this_box_volume mccspec_detector_3_exit_volume_this_box_volume
#define global_geometry_element mccspec_detector_3_exit_volume_global_geometry_element
#define this_box_storage mccspec_detector_3_exit_volume_this_box_storage
#define material_string mccspec_detector_3_exit_volume_material_string
#define priority mccspec_detector_3_exit_volume_priority
#define xwidth mccspec_detector_3_exit_volume_xwidth
#define yheight mccspec_detector_3_exit_volume_yheight
#define zdepth mccspec_detector_3_exit_volume_zdepth
#define xwidth2 mccspec_detector_3_exit_volume_xwidth2
#define yheight2 mccspec_detector_3_exit_volume_yheight2
#define visualize mccspec_detector_3_exit_volume_visualize
#define target_index mccspec_detector_3_exit_volume_target_index
#define target_x mccspec_detector_3_exit_volume_target_x
#define target_y mccspec_detector_3_exit_volume_target_y
#define target_z mccspec_detector_3_exit_volume_target_z
#define focus_aw mccspec_detector_3_exit_volume_focus_aw
#define focus_ah mccspec_detector_3_exit_volume_focus_ah
#define focus_xw mccspec_detector_3_exit_volume_focus_xw
#define focus_xh mccspec_detector_3_exit_volume_focus_xh
#define focus_r mccspec_detector_3_exit_volume_focus_r
#define p_interact mccspec_detector_3_exit_volume_p_interact
#define mask_string mccspec_detector_3_exit_volume_mask_string
#define mask_setting mccspec_detector_3_exit_volume_mask_setting
#define number_of_activations mccspec_detector_3_exit_volume_number_of_activations
#line 204 "Union_box.comp"
// Needed for transport to the main component
struct global_geometry_element_struct global_geometry_element;

#ifndef ANY_GEOMETRY_DETECTOR_DECLARE
    #define ANY_GEOMETRY_DETECTOR_DECLARE dummy
	//struct pointer_to_global_geometry_list global_geometry_list = {0,NULL};
#endif

int loop_index,found_geometries;

double x_component;
double y_component;
double z_component;

struct Volume_struct this_box_volume;
struct box_storage this_box_storage;

#line 43705 "MACS_sample_kidney_box.c"
#undef number_of_activations
#undef mask_setting
#undef mask_string
#undef p_interact
#undef focus_r
#undef focus_xh
#undef focus_xw
#undef focus_ah
#undef focus_aw
#undef target_z
#undef target_y
#undef target_x
#undef target_index
#undef visualize
#undef yheight2
#undef xwidth2
#undef zdepth
#undef yheight
#undef xwidth
#undef priority
#undef material_string
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

/* User declarations for component 'channel_4_cave1_box1' [276]. */
#define mccompcurname  channel_4_cave1_box1
#define mccompcurtype  Union_box
#define mccompcurindex 276
#define loop_index mccchannel_4_cave1_box1_loop_index
#define this_box_volume mccchannel_4_cave1_box1_this_box_volume
#define global_geometry_element mccchannel_4_cave1_box1_global_geometry_element
#define this_box_storage mccchannel_4_cave1_box1_this_box_storage
#define material_string mccchannel_4_cave1_box1_material_string
#define priority mccchannel_4_cave1_box1_priority
#define xwidth mccchannel_4_cave1_box1_xwidth
#define yheight mccchannel_4_cave1_box1_yheight
#define zdepth mccchannel_4_cave1_box1_zdepth
#define xwidth2 mccchannel_4_cave1_box1_xwidth2
#define yheight2 mccchannel_4_cave1_box1_yheight2
#define visualize mccchannel_4_cave1_box1_visualize
#define target_index mccchannel_4_cave1_box1_target_index
#define target_x mccchannel_4_cave1_box1_target_x
#define target_y mccchannel_4_cave1_box1_target_y
#define target_z mccchannel_4_cave1_box1_target_z
#define focus_aw mccchannel_4_cave1_box1_focus_aw
#define focus_ah mccchannel_4_cave1_box1_focus_ah
#define focus_xw mccchannel_4_cave1_box1_focus_xw
#define focus_xh mccchannel_4_cave1_box1_focus_xh
#define focus_r mccchannel_4_cave1_box1_focus_r
#define p_interact mccchannel_4_cave1_box1_p_interact
#define mask_string mccchannel_4_cave1_box1_mask_string
#define mask_setting mccchannel_4_cave1_box1_mask_setting
#define number_of_activations mccchannel_4_cave1_box1_number_of_activations
#line 204 "Union_box.comp"
// Needed for transport to the main component
struct global_geometry_element_struct global_geometry_element;

#ifndef ANY_GEOMETRY_DETECTOR_DECLARE
    #define ANY_GEOMETRY_DETECTOR_DECLARE dummy
	//struct pointer_to_global_geometry_list global_geometry_list = {0,NULL};
#endif

int loop_index,found_geometries;

double x_component;
double y_component;
double z_component;

struct Volume_struct this_box_volume;
struct box_storage this_box_storage;

#line 43782 "MACS_sample_kidney_box.c"
#undef number_of_activations
#undef mask_setting
#undef mask_string
#undef p_interact
#undef focus_r
#undef focus_xh
#undef focus_xw
#undef focus_ah
#undef focus_aw
#undef target_z
#undef target_y
#undef target_x
#undef target_index
#undef visualize
#undef yheight2
#undef xwidth2
#undef zdepth
#undef yheight
#undef xwidth
#undef priority
#undef material_string
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

/* User declarations for component 'channel_4_cave1_box2' [277]. */
#define mccompcurname  channel_4_cave1_box2
#define mccompcurtype  Union_box
#define mccompcurindex 277
#define loop_index mccchannel_4_cave1_box2_loop_index
#define this_box_volume mccchannel_4_cave1_box2_this_box_volume
#define global_geometry_element mccchannel_4_cave1_box2_global_geometry_element
#define this_box_storage mccchannel_4_cave1_box2_this_box_storage
#define material_string mccchannel_4_cave1_box2_material_string
#define priority mccchannel_4_cave1_box2_priority
#define xwidth mccchannel_4_cave1_box2_xwidth
#define yheight mccchannel_4_cave1_box2_yheight
#define zdepth mccchannel_4_cave1_box2_zdepth
#define xwidth2 mccchannel_4_cave1_box2_xwidth2
#define yheight2 mccchannel_4_cave1_box2_yheight2
#define visualize mccchannel_4_cave1_box2_visualize
#define target_index mccchannel_4_cave1_box2_target_index
#define target_x mccchannel_4_cave1_box2_target_x
#define target_y mccchannel_4_cave1_box2_target_y
#define target_z mccchannel_4_cave1_box2_target_z
#define focus_aw mccchannel_4_cave1_box2_focus_aw
#define focus_ah mccchannel_4_cave1_box2_focus_ah
#define focus_xw mccchannel_4_cave1_box2_focus_xw
#define focus_xh mccchannel_4_cave1_box2_focus_xh
#define focus_r mccchannel_4_cave1_box2_focus_r
#define p_interact mccchannel_4_cave1_box2_p_interact
#define mask_string mccchannel_4_cave1_box2_mask_string
#define mask_setting mccchannel_4_cave1_box2_mask_setting
#define number_of_activations mccchannel_4_cave1_box2_number_of_activations
#line 204 "Union_box.comp"
// Needed for transport to the main component
struct global_geometry_element_struct global_geometry_element;

#ifndef ANY_GEOMETRY_DETECTOR_DECLARE
    #define ANY_GEOMETRY_DETECTOR_DECLARE dummy
	//struct pointer_to_global_geometry_list global_geometry_list = {0,NULL};
#endif

int loop_index,found_geometries;

double x_component;
double y_component;
double z_component;

struct Volume_struct this_box_volume;
struct box_storage this_box_storage;

#line 43859 "MACS_sample_kidney_box.c"
#undef number_of_activations
#undef mask_setting
#undef mask_string
#undef p_interact
#undef focus_r
#undef focus_xh
#undef focus_xw
#undef focus_ah
#undef focus_aw
#undef target_z
#undef target_y
#undef target_x
#undef target_index
#undef visualize
#undef yheight2
#undef xwidth2
#undef zdepth
#undef yheight
#undef xwidth
#undef priority
#undef material_string
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

/* User declarations for component 'channel_4_cave1_box3' [278]. */
#define mccompcurname  channel_4_cave1_box3
#define mccompcurtype  Union_box
#define mccompcurindex 278
#define loop_index mccchannel_4_cave1_box3_loop_index
#define this_box_volume mccchannel_4_cave1_box3_this_box_volume
#define global_geometry_element mccchannel_4_cave1_box3_global_geometry_element
#define this_box_storage mccchannel_4_cave1_box3_this_box_storage
#define material_string mccchannel_4_cave1_box3_material_string
#define priority mccchannel_4_cave1_box3_priority
#define xwidth mccchannel_4_cave1_box3_xwidth
#define yheight mccchannel_4_cave1_box3_yheight
#define zdepth mccchannel_4_cave1_box3_zdepth
#define xwidth2 mccchannel_4_cave1_box3_xwidth2
#define yheight2 mccchannel_4_cave1_box3_yheight2
#define visualize mccchannel_4_cave1_box3_visualize
#define target_index mccchannel_4_cave1_box3_target_index
#define target_x mccchannel_4_cave1_box3_target_x
#define target_y mccchannel_4_cave1_box3_target_y
#define target_z mccchannel_4_cave1_box3_target_z
#define focus_aw mccchannel_4_cave1_box3_focus_aw
#define focus_ah mccchannel_4_cave1_box3_focus_ah
#define focus_xw mccchannel_4_cave1_box3_focus_xw
#define focus_xh mccchannel_4_cave1_box3_focus_xh
#define focus_r mccchannel_4_cave1_box3_focus_r
#define p_interact mccchannel_4_cave1_box3_p_interact
#define mask_string mccchannel_4_cave1_box3_mask_string
#define mask_setting mccchannel_4_cave1_box3_mask_setting
#define number_of_activations mccchannel_4_cave1_box3_number_of_activations
#line 204 "Union_box.comp"
// Needed for transport to the main component
struct global_geometry_element_struct global_geometry_element;

#ifndef ANY_GEOMETRY_DETECTOR_DECLARE
    #define ANY_GEOMETRY_DETECTOR_DECLARE dummy
	//struct pointer_to_global_geometry_list global_geometry_list = {0,NULL};
#endif

int loop_index,found_geometries;

double x_component;
double y_component;
double z_component;

struct Volume_struct this_box_volume;
struct box_storage this_box_storage;

#line 43936 "MACS_sample_kidney_box.c"
#undef number_of_activations
#undef mask_setting
#undef mask_string
#undef p_interact
#undef focus_r
#undef focus_xh
#undef focus_xw
#undef focus_ah
#undef focus_aw
#undef target_z
#undef target_y
#undef target_x
#undef target_index
#undef visualize
#undef yheight2
#undef xwidth2
#undef zdepth
#undef yheight
#undef xwidth
#undef priority
#undef material_string
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

/* User declarations for component 'channel_4_cave1_cyl1' [279]. */
#define mccompcurname  channel_4_cave1_cyl1
#define mccompcurtype  Union_cylinder
#define mccompcurindex 279
#define loop_index mccchannel_4_cave1_cyl1_loop_index
#define this_cylinder_volume mccchannel_4_cave1_cyl1_this_cylinder_volume
#define global_geometry_element mccchannel_4_cave1_cyl1_global_geometry_element
#define this_cylinder_storage mccchannel_4_cave1_cyl1_this_cylinder_storage
#define material_string mccchannel_4_cave1_cyl1_material_string
#define priority mccchannel_4_cave1_cyl1_priority
#define radius mccchannel_4_cave1_cyl1_radius
#define yheight mccchannel_4_cave1_cyl1_yheight
#define visualize mccchannel_4_cave1_cyl1_visualize
#define target_index mccchannel_4_cave1_cyl1_target_index
#define target_x mccchannel_4_cave1_cyl1_target_x
#define target_y mccchannel_4_cave1_cyl1_target_y
#define target_z mccchannel_4_cave1_cyl1_target_z
#define focus_aw mccchannel_4_cave1_cyl1_focus_aw
#define focus_ah mccchannel_4_cave1_cyl1_focus_ah
#define focus_xw mccchannel_4_cave1_cyl1_focus_xw
#define focus_xh mccchannel_4_cave1_cyl1_focus_xh
#define focus_r mccchannel_4_cave1_cyl1_focus_r
#define p_interact mccchannel_4_cave1_cyl1_p_interact
#define mask_string mccchannel_4_cave1_cyl1_mask_string
#define mask_setting mccchannel_4_cave1_cyl1_mask_setting
#define number_of_activations mccchannel_4_cave1_cyl1_number_of_activations
#line 167 "Union_cylinder.comp"
// Needed for transport to the main component
struct global_geometry_element_struct global_geometry_element;

#ifndef ANY_GEOMETRY_DETECTOR_DECLARE
    #define ANY_GEOMETRY_DETECTOR_DECLARE dummy
	//struct pointer_to_global_geometry_list global_geometry_list = {0,NULL};
#endif

int dummy;
int loop_index,found_geometries;
int loop_2_index;
int material_index;

struct Volume_struct this_cylinder_volume;
struct cylinder_storage this_cylinder_storage;
#line 44008 "MACS_sample_kidney_box.c"
#undef number_of_activations
#undef mask_setting
#undef mask_string
#undef p_interact
#undef focus_r
#undef focus_xh
#undef focus_xw
#undef focus_ah
#undef focus_aw
#undef target_z
#undef target_y
#undef target_x
#undef target_index
#undef visualize
#undef yheight
#undef radius
#undef priority
#undef material_string
#undef this_cylinder_storage
#undef global_geometry_element
#undef this_cylinder_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

/* User declarations for component 'channel_4_analyzer_1_center' [280]. */
#define mccompcurname  channel_4_analyzer_1_center
#define mccompcurtype  Arm
#define mccompcurindex 280
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

/* User declarations for component 'channel_4_analyzer_1_rotated' [281]. */
#define mccompcurname  channel_4_analyzer_1_rotated
#define mccompcurtype  Arm
#define mccompcurindex 281
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

/* User declarations for component 'channel_4_analyzer_1_array_crystal_array_0' [282]. */
#define mccompcurname  channel_4_analyzer_1_array_crystal_array_0
#define mccompcurtype  Union_box
#define mccompcurindex 282
#define loop_index mccchannel_4_analyzer_1_array_crystal_array_0_loop_index
#define this_box_volume mccchannel_4_analyzer_1_array_crystal_array_0_this_box_volume
#define global_geometry_element mccchannel_4_analyzer_1_array_crystal_array_0_global_geometry_element
#define this_box_storage mccchannel_4_analyzer_1_array_crystal_array_0_this_box_storage
#define material_string mccchannel_4_analyzer_1_array_crystal_array_0_material_string
#define priority mccchannel_4_analyzer_1_array_crystal_array_0_priority
#define xwidth mccchannel_4_analyzer_1_array_crystal_array_0_xwidth
#define yheight mccchannel_4_analyzer_1_array_crystal_array_0_yheight
#define zdepth mccchannel_4_analyzer_1_array_crystal_array_0_zdepth
#define xwidth2 mccchannel_4_analyzer_1_array_crystal_array_0_xwidth2
#define yheight2 mccchannel_4_analyzer_1_array_crystal_array_0_yheight2
#define visualize mccchannel_4_analyzer_1_array_crystal_array_0_visualize
#define target_index mccchannel_4_analyzer_1_array_crystal_array_0_target_index
#define target_x mccchannel_4_analyzer_1_array_crystal_array_0_target_x
#define target_y mccchannel_4_analyzer_1_array_crystal_array_0_target_y
#define target_z mccchannel_4_analyzer_1_array_crystal_array_0_target_z
#define focus_aw mccchannel_4_analyzer_1_array_crystal_array_0_focus_aw
#define focus_ah mccchannel_4_analyzer_1_array_crystal_array_0_focus_ah
#define focus_xw mccchannel_4_analyzer_1_array_crystal_array_0_focus_xw
#define focus_xh mccchannel_4_analyzer_1_array_crystal_array_0_focus_xh
#define focus_r mccchannel_4_analyzer_1_array_crystal_array_0_focus_r
#define p_interact mccchannel_4_analyzer_1_array_crystal_array_0_p_interact
#define mask_string mccchannel_4_analyzer_1_array_crystal_array_0_mask_string
#define mask_setting mccchannel_4_analyzer_1_array_crystal_array_0_mask_setting
#define number_of_activations mccchannel_4_analyzer_1_array_crystal_array_0_number_of_activations
#line 204 "Union_box.comp"
// Needed for transport to the main component
struct global_geometry_element_struct global_geometry_element;

#ifndef ANY_GEOMETRY_DETECTOR_DECLARE
    #define ANY_GEOMETRY_DETECTOR_DECLARE dummy
	//struct pointer_to_global_geometry_list global_geometry_list = {0,NULL};
#endif

int loop_index,found_geometries;

double x_component;
double y_component;
double z_component;

struct Volume_struct this_box_volume;
struct box_storage this_box_storage;

#line 44098 "MACS_sample_kidney_box.c"
#undef number_of_activations
#undef mask_setting
#undef mask_string
#undef p_interact
#undef focus_r
#undef focus_xh
#undef focus_xw
#undef focus_ah
#undef focus_aw
#undef target_z
#undef target_y
#undef target_x
#undef target_index
#undef visualize
#undef yheight2
#undef xwidth2
#undef zdepth
#undef yheight
#undef xwidth
#undef priority
#undef material_string
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

/* User declarations for component 'channel_4_analyzer_1_array_crystal_array_1' [283]. */
#define mccompcurname  channel_4_analyzer_1_array_crystal_array_1
#define mccompcurtype  Union_box
#define mccompcurindex 283
#define loop_index mccchannel_4_analyzer_1_array_crystal_array_1_loop_index
#define this_box_volume mccchannel_4_analyzer_1_array_crystal_array_1_this_box_volume
#define global_geometry_element mccchannel_4_analyzer_1_array_crystal_array_1_global_geometry_element
#define this_box_storage mccchannel_4_analyzer_1_array_crystal_array_1_this_box_storage
#define material_string mccchannel_4_analyzer_1_array_crystal_array_1_material_string
#define priority mccchannel_4_analyzer_1_array_crystal_array_1_priority
#define xwidth mccchannel_4_analyzer_1_array_crystal_array_1_xwidth
#define yheight mccchannel_4_analyzer_1_array_crystal_array_1_yheight
#define zdepth mccchannel_4_analyzer_1_array_crystal_array_1_zdepth
#define xwidth2 mccchannel_4_analyzer_1_array_crystal_array_1_xwidth2
#define yheight2 mccchannel_4_analyzer_1_array_crystal_array_1_yheight2
#define visualize mccchannel_4_analyzer_1_array_crystal_array_1_visualize
#define target_index mccchannel_4_analyzer_1_array_crystal_array_1_target_index
#define target_x mccchannel_4_analyzer_1_array_crystal_array_1_target_x
#define target_y mccchannel_4_analyzer_1_array_crystal_array_1_target_y
#define target_z mccchannel_4_analyzer_1_array_crystal_array_1_target_z
#define focus_aw mccchannel_4_analyzer_1_array_crystal_array_1_focus_aw
#define focus_ah mccchannel_4_analyzer_1_array_crystal_array_1_focus_ah
#define focus_xw mccchannel_4_analyzer_1_array_crystal_array_1_focus_xw
#define focus_xh mccchannel_4_analyzer_1_array_crystal_array_1_focus_xh
#define focus_r mccchannel_4_analyzer_1_array_crystal_array_1_focus_r
#define p_interact mccchannel_4_analyzer_1_array_crystal_array_1_p_interact
#define mask_string mccchannel_4_analyzer_1_array_crystal_array_1_mask_string
#define mask_setting mccchannel_4_analyzer_1_array_crystal_array_1_mask_setting
#define number_of_activations mccchannel_4_analyzer_1_array_crystal_array_1_number_of_activations
#line 204 "Union_box.comp"
// Needed for transport to the main component
struct global_geometry_element_struct global_geometry_element;

#ifndef ANY_GEOMETRY_DETECTOR_DECLARE
    #define ANY_GEOMETRY_DETECTOR_DECLARE dummy
	//struct pointer_to_global_geometry_list global_geometry_list = {0,NULL};
#endif

int loop_index,found_geometries;

double x_component;
double y_component;
double z_component;

struct Volume_struct this_box_volume;
struct box_storage this_box_storage;

#line 44175 "MACS_sample_kidney_box.c"
#undef number_of_activations
#undef mask_setting
#undef mask_string
#undef p_interact
#undef focus_r
#undef focus_xh
#undef focus_xw
#undef focus_ah
#undef focus_aw
#undef target_z
#undef target_y
#undef target_x
#undef target_index
#undef visualize
#undef yheight2
#undef xwidth2
#undef zdepth
#undef yheight
#undef xwidth
#undef priority
#undef material_string
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

/* User declarations for component 'channel_4_analyzer_1_array_crystal_array_2' [284]. */
#define mccompcurname  channel_4_analyzer_1_array_crystal_array_2
#define mccompcurtype  Union_box
#define mccompcurindex 284
#define loop_index mccchannel_4_analyzer_1_array_crystal_array_2_loop_index
#define this_box_volume mccchannel_4_analyzer_1_array_crystal_array_2_this_box_volume
#define global_geometry_element mccchannel_4_analyzer_1_array_crystal_array_2_global_geometry_element
#define this_box_storage mccchannel_4_analyzer_1_array_crystal_array_2_this_box_storage
#define material_string mccchannel_4_analyzer_1_array_crystal_array_2_material_string
#define priority mccchannel_4_analyzer_1_array_crystal_array_2_priority
#define xwidth mccchannel_4_analyzer_1_array_crystal_array_2_xwidth
#define yheight mccchannel_4_analyzer_1_array_crystal_array_2_yheight
#define zdepth mccchannel_4_analyzer_1_array_crystal_array_2_zdepth
#define xwidth2 mccchannel_4_analyzer_1_array_crystal_array_2_xwidth2
#define yheight2 mccchannel_4_analyzer_1_array_crystal_array_2_yheight2
#define visualize mccchannel_4_analyzer_1_array_crystal_array_2_visualize
#define target_index mccchannel_4_analyzer_1_array_crystal_array_2_target_index
#define target_x mccchannel_4_analyzer_1_array_crystal_array_2_target_x
#define target_y mccchannel_4_analyzer_1_array_crystal_array_2_target_y
#define target_z mccchannel_4_analyzer_1_array_crystal_array_2_target_z
#define focus_aw mccchannel_4_analyzer_1_array_crystal_array_2_focus_aw
#define focus_ah mccchannel_4_analyzer_1_array_crystal_array_2_focus_ah
#define focus_xw mccchannel_4_analyzer_1_array_crystal_array_2_focus_xw
#define focus_xh mccchannel_4_analyzer_1_array_crystal_array_2_focus_xh
#define focus_r mccchannel_4_analyzer_1_array_crystal_array_2_focus_r
#define p_interact mccchannel_4_analyzer_1_array_crystal_array_2_p_interact
#define mask_string mccchannel_4_analyzer_1_array_crystal_array_2_mask_string
#define mask_setting mccchannel_4_analyzer_1_array_crystal_array_2_mask_setting
#define number_of_activations mccchannel_4_analyzer_1_array_crystal_array_2_number_of_activations
#line 204 "Union_box.comp"
// Needed for transport to the main component
struct global_geometry_element_struct global_geometry_element;

#ifndef ANY_GEOMETRY_DETECTOR_DECLARE
    #define ANY_GEOMETRY_DETECTOR_DECLARE dummy
	//struct pointer_to_global_geometry_list global_geometry_list = {0,NULL};
#endif

int loop_index,found_geometries;

double x_component;
double y_component;
double z_component;

struct Volume_struct this_box_volume;
struct box_storage this_box_storage;

#line 44252 "MACS_sample_kidney_box.c"
#undef number_of_activations
#undef mask_setting
#undef mask_string
#undef p_interact
#undef focus_r
#undef focus_xh
#undef focus_xw
#undef focus_ah
#undef focus_aw
#undef target_z
#undef target_y
#undef target_x
#undef target_index
#undef visualize
#undef yheight2
#undef xwidth2
#undef zdepth
#undef yheight
#undef xwidth
#undef priority
#undef material_string
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

/* User declarations for component 'channel_4_analyzer_1_array_crystal_array_3' [285]. */
#define mccompcurname  channel_4_analyzer_1_array_crystal_array_3
#define mccompcurtype  Union_box
#define mccompcurindex 285
#define loop_index mccchannel_4_analyzer_1_array_crystal_array_3_loop_index
#define this_box_volume mccchannel_4_analyzer_1_array_crystal_array_3_this_box_volume
#define global_geometry_element mccchannel_4_analyzer_1_array_crystal_array_3_global_geometry_element
#define this_box_storage mccchannel_4_analyzer_1_array_crystal_array_3_this_box_storage
#define material_string mccchannel_4_analyzer_1_array_crystal_array_3_material_string
#define priority mccchannel_4_analyzer_1_array_crystal_array_3_priority
#define xwidth mccchannel_4_analyzer_1_array_crystal_array_3_xwidth
#define yheight mccchannel_4_analyzer_1_array_crystal_array_3_yheight
#define zdepth mccchannel_4_analyzer_1_array_crystal_array_3_zdepth
#define xwidth2 mccchannel_4_analyzer_1_array_crystal_array_3_xwidth2
#define yheight2 mccchannel_4_analyzer_1_array_crystal_array_3_yheight2
#define visualize mccchannel_4_analyzer_1_array_crystal_array_3_visualize
#define target_index mccchannel_4_analyzer_1_array_crystal_array_3_target_index
#define target_x mccchannel_4_analyzer_1_array_crystal_array_3_target_x
#define target_y mccchannel_4_analyzer_1_array_crystal_array_3_target_y
#define target_z mccchannel_4_analyzer_1_array_crystal_array_3_target_z
#define focus_aw mccchannel_4_analyzer_1_array_crystal_array_3_focus_aw
#define focus_ah mccchannel_4_analyzer_1_array_crystal_array_3_focus_ah
#define focus_xw mccchannel_4_analyzer_1_array_crystal_array_3_focus_xw
#define focus_xh mccchannel_4_analyzer_1_array_crystal_array_3_focus_xh
#define focus_r mccchannel_4_analyzer_1_array_crystal_array_3_focus_r
#define p_interact mccchannel_4_analyzer_1_array_crystal_array_3_p_interact
#define mask_string mccchannel_4_analyzer_1_array_crystal_array_3_mask_string
#define mask_setting mccchannel_4_analyzer_1_array_crystal_array_3_mask_setting
#define number_of_activations mccchannel_4_analyzer_1_array_crystal_array_3_number_of_activations
#line 204 "Union_box.comp"
// Needed for transport to the main component
struct global_geometry_element_struct global_geometry_element;

#ifndef ANY_GEOMETRY_DETECTOR_DECLARE
    #define ANY_GEOMETRY_DETECTOR_DECLARE dummy
	//struct pointer_to_global_geometry_list global_geometry_list = {0,NULL};
#endif

int loop_index,found_geometries;

double x_component;
double y_component;
double z_component;

struct Volume_struct this_box_volume;
struct box_storage this_box_storage;

#line 44329 "MACS_sample_kidney_box.c"
#undef number_of_activations
#undef mask_setting
#undef mask_string
#undef p_interact
#undef focus_r
#undef focus_xh
#undef focus_xw
#undef focus_ah
#undef focus_aw
#undef target_z
#undef target_y
#undef target_x
#undef target_index
#undef visualize
#undef yheight2
#undef xwidth2
#undef zdepth
#undef yheight
#undef xwidth
#undef priority
#undef material_string
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

/* User declarations for component 'channel_4_analyzer_1_array_crystal_array_4' [286]. */
#define mccompcurname  channel_4_analyzer_1_array_crystal_array_4
#define mccompcurtype  Union_box
#define mccompcurindex 286
#define loop_index mccchannel_4_analyzer_1_array_crystal_array_4_loop_index
#define this_box_volume mccchannel_4_analyzer_1_array_crystal_array_4_this_box_volume
#define global_geometry_element mccchannel_4_analyzer_1_array_crystal_array_4_global_geometry_element
#define this_box_storage mccchannel_4_analyzer_1_array_crystal_array_4_this_box_storage
#define material_string mccchannel_4_analyzer_1_array_crystal_array_4_material_string
#define priority mccchannel_4_analyzer_1_array_crystal_array_4_priority
#define xwidth mccchannel_4_analyzer_1_array_crystal_array_4_xwidth
#define yheight mccchannel_4_analyzer_1_array_crystal_array_4_yheight
#define zdepth mccchannel_4_analyzer_1_array_crystal_array_4_zdepth
#define xwidth2 mccchannel_4_analyzer_1_array_crystal_array_4_xwidth2
#define yheight2 mccchannel_4_analyzer_1_array_crystal_array_4_yheight2
#define visualize mccchannel_4_analyzer_1_array_crystal_array_4_visualize
#define target_index mccchannel_4_analyzer_1_array_crystal_array_4_target_index
#define target_x mccchannel_4_analyzer_1_array_crystal_array_4_target_x
#define target_y mccchannel_4_analyzer_1_array_crystal_array_4_target_y
#define target_z mccchannel_4_analyzer_1_array_crystal_array_4_target_z
#define focus_aw mccchannel_4_analyzer_1_array_crystal_array_4_focus_aw
#define focus_ah mccchannel_4_analyzer_1_array_crystal_array_4_focus_ah
#define focus_xw mccchannel_4_analyzer_1_array_crystal_array_4_focus_xw
#define focus_xh mccchannel_4_analyzer_1_array_crystal_array_4_focus_xh
#define focus_r mccchannel_4_analyzer_1_array_crystal_array_4_focus_r
#define p_interact mccchannel_4_analyzer_1_array_crystal_array_4_p_interact
#define mask_string mccchannel_4_analyzer_1_array_crystal_array_4_mask_string
#define mask_setting mccchannel_4_analyzer_1_array_crystal_array_4_mask_setting
#define number_of_activations mccchannel_4_analyzer_1_array_crystal_array_4_number_of_activations
#line 204 "Union_box.comp"
// Needed for transport to the main component
struct global_geometry_element_struct global_geometry_element;

#ifndef ANY_GEOMETRY_DETECTOR_DECLARE
    #define ANY_GEOMETRY_DETECTOR_DECLARE dummy
	//struct pointer_to_global_geometry_list global_geometry_list = {0,NULL};
#endif

int loop_index,found_geometries;

double x_component;
double y_component;
double z_component;

struct Volume_struct this_box_volume;
struct box_storage this_box_storage;

#line 44406 "MACS_sample_kidney_box.c"
#undef number_of_activations
#undef mask_setting
#undef mask_string
#undef p_interact
#undef focus_r
#undef focus_xh
#undef focus_xw
#undef focus_ah
#undef focus_aw
#undef target_z
#undef target_y
#undef target_x
#undef target_index
#undef visualize
#undef yheight2
#undef xwidth2
#undef zdepth
#undef yheight
#undef xwidth
#undef priority
#undef material_string
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

/* User declarations for component 'channel_4_analyzer_1_array_crystal_array_5' [287]. */
#define mccompcurname  channel_4_analyzer_1_array_crystal_array_5
#define mccompcurtype  Union_box
#define mccompcurindex 287
#define loop_index mccchannel_4_analyzer_1_array_crystal_array_5_loop_index
#define this_box_volume mccchannel_4_analyzer_1_array_crystal_array_5_this_box_volume
#define global_geometry_element mccchannel_4_analyzer_1_array_crystal_array_5_global_geometry_element
#define this_box_storage mccchannel_4_analyzer_1_array_crystal_array_5_this_box_storage
#define material_string mccchannel_4_analyzer_1_array_crystal_array_5_material_string
#define priority mccchannel_4_analyzer_1_array_crystal_array_5_priority
#define xwidth mccchannel_4_analyzer_1_array_crystal_array_5_xwidth
#define yheight mccchannel_4_analyzer_1_array_crystal_array_5_yheight
#define zdepth mccchannel_4_analyzer_1_array_crystal_array_5_zdepth
#define xwidth2 mccchannel_4_analyzer_1_array_crystal_array_5_xwidth2
#define yheight2 mccchannel_4_analyzer_1_array_crystal_array_5_yheight2
#define visualize mccchannel_4_analyzer_1_array_crystal_array_5_visualize
#define target_index mccchannel_4_analyzer_1_array_crystal_array_5_target_index
#define target_x mccchannel_4_analyzer_1_array_crystal_array_5_target_x
#define target_y mccchannel_4_analyzer_1_array_crystal_array_5_target_y
#define target_z mccchannel_4_analyzer_1_array_crystal_array_5_target_z
#define focus_aw mccchannel_4_analyzer_1_array_crystal_array_5_focus_aw
#define focus_ah mccchannel_4_analyzer_1_array_crystal_array_5_focus_ah
#define focus_xw mccchannel_4_analyzer_1_array_crystal_array_5_focus_xw
#define focus_xh mccchannel_4_analyzer_1_array_crystal_array_5_focus_xh
#define focus_r mccchannel_4_analyzer_1_array_crystal_array_5_focus_r
#define p_interact mccchannel_4_analyzer_1_array_crystal_array_5_p_interact
#define mask_string mccchannel_4_analyzer_1_array_crystal_array_5_mask_string
#define mask_setting mccchannel_4_analyzer_1_array_crystal_array_5_mask_setting
#define number_of_activations mccchannel_4_analyzer_1_array_crystal_array_5_number_of_activations
#line 204 "Union_box.comp"
// Needed for transport to the main component
struct global_geometry_element_struct global_geometry_element;

#ifndef ANY_GEOMETRY_DETECTOR_DECLARE
    #define ANY_GEOMETRY_DETECTOR_DECLARE dummy
	//struct pointer_to_global_geometry_list global_geometry_list = {0,NULL};
#endif

int loop_index,found_geometries;

double x_component;
double y_component;
double z_component;

struct Volume_struct this_box_volume;
struct box_storage this_box_storage;

#line 44483 "MACS_sample_kidney_box.c"
#undef number_of_activations
#undef mask_setting
#undef mask_string
#undef p_interact
#undef focus_r
#undef focus_xh
#undef focus_xw
#undef focus_ah
#undef focus_aw
#undef target_z
#undef target_y
#undef target_x
#undef target_index
#undef visualize
#undef yheight2
#undef xwidth2
#undef zdepth
#undef yheight
#undef xwidth
#undef priority
#undef material_string
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

/* User declarations for component 'channel_4_analyzer_1_array_crystal_array_6' [288]. */
#define mccompcurname  channel_4_analyzer_1_array_crystal_array_6
#define mccompcurtype  Union_box
#define mccompcurindex 288
#define loop_index mccchannel_4_analyzer_1_array_crystal_array_6_loop_index
#define this_box_volume mccchannel_4_analyzer_1_array_crystal_array_6_this_box_volume
#define global_geometry_element mccchannel_4_analyzer_1_array_crystal_array_6_global_geometry_element
#define this_box_storage mccchannel_4_analyzer_1_array_crystal_array_6_this_box_storage
#define material_string mccchannel_4_analyzer_1_array_crystal_array_6_material_string
#define priority mccchannel_4_analyzer_1_array_crystal_array_6_priority
#define xwidth mccchannel_4_analyzer_1_array_crystal_array_6_xwidth
#define yheight mccchannel_4_analyzer_1_array_crystal_array_6_yheight
#define zdepth mccchannel_4_analyzer_1_array_crystal_array_6_zdepth
#define xwidth2 mccchannel_4_analyzer_1_array_crystal_array_6_xwidth2
#define yheight2 mccchannel_4_analyzer_1_array_crystal_array_6_yheight2
#define visualize mccchannel_4_analyzer_1_array_crystal_array_6_visualize
#define target_index mccchannel_4_analyzer_1_array_crystal_array_6_target_index
#define target_x mccchannel_4_analyzer_1_array_crystal_array_6_target_x
#define target_y mccchannel_4_analyzer_1_array_crystal_array_6_target_y
#define target_z mccchannel_4_analyzer_1_array_crystal_array_6_target_z
#define focus_aw mccchannel_4_analyzer_1_array_crystal_array_6_focus_aw
#define focus_ah mccchannel_4_analyzer_1_array_crystal_array_6_focus_ah
#define focus_xw mccchannel_4_analyzer_1_array_crystal_array_6_focus_xw
#define focus_xh mccchannel_4_analyzer_1_array_crystal_array_6_focus_xh
#define focus_r mccchannel_4_analyzer_1_array_crystal_array_6_focus_r
#define p_interact mccchannel_4_analyzer_1_array_crystal_array_6_p_interact
#define mask_string mccchannel_4_analyzer_1_array_crystal_array_6_mask_string
#define mask_setting mccchannel_4_analyzer_1_array_crystal_array_6_mask_setting
#define number_of_activations mccchannel_4_analyzer_1_array_crystal_array_6_number_of_activations
#line 204 "Union_box.comp"
// Needed for transport to the main component
struct global_geometry_element_struct global_geometry_element;

#ifndef ANY_GEOMETRY_DETECTOR_DECLARE
    #define ANY_GEOMETRY_DETECTOR_DECLARE dummy
	//struct pointer_to_global_geometry_list global_geometry_list = {0,NULL};
#endif

int loop_index,found_geometries;

double x_component;
double y_component;
double z_component;

struct Volume_struct this_box_volume;
struct box_storage this_box_storage;

#line 44560 "MACS_sample_kidney_box.c"
#undef number_of_activations
#undef mask_setting
#undef mask_string
#undef p_interact
#undef focus_r
#undef focus_xh
#undef focus_xw
#undef focus_ah
#undef focus_aw
#undef target_z
#undef target_y
#undef target_x
#undef target_index
#undef visualize
#undef yheight2
#undef xwidth2
#undef zdepth
#undef yheight
#undef xwidth
#undef priority
#undef material_string
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

/* User declarations for component 'channel_4_analyzer_1_array_crystal_array_7' [289]. */
#define mccompcurname  channel_4_analyzer_1_array_crystal_array_7
#define mccompcurtype  Union_box
#define mccompcurindex 289
#define loop_index mccchannel_4_analyzer_1_array_crystal_array_7_loop_index
#define this_box_volume mccchannel_4_analyzer_1_array_crystal_array_7_this_box_volume
#define global_geometry_element mccchannel_4_analyzer_1_array_crystal_array_7_global_geometry_element
#define this_box_storage mccchannel_4_analyzer_1_array_crystal_array_7_this_box_storage
#define material_string mccchannel_4_analyzer_1_array_crystal_array_7_material_string
#define priority mccchannel_4_analyzer_1_array_crystal_array_7_priority
#define xwidth mccchannel_4_analyzer_1_array_crystal_array_7_xwidth
#define yheight mccchannel_4_analyzer_1_array_crystal_array_7_yheight
#define zdepth mccchannel_4_analyzer_1_array_crystal_array_7_zdepth
#define xwidth2 mccchannel_4_analyzer_1_array_crystal_array_7_xwidth2
#define yheight2 mccchannel_4_analyzer_1_array_crystal_array_7_yheight2
#define visualize mccchannel_4_analyzer_1_array_crystal_array_7_visualize
#define target_index mccchannel_4_analyzer_1_array_crystal_array_7_target_index
#define target_x mccchannel_4_analyzer_1_array_crystal_array_7_target_x
#define target_y mccchannel_4_analyzer_1_array_crystal_array_7_target_y
#define target_z mccchannel_4_analyzer_1_array_crystal_array_7_target_z
#define focus_aw mccchannel_4_analyzer_1_array_crystal_array_7_focus_aw
#define focus_ah mccchannel_4_analyzer_1_array_crystal_array_7_focus_ah
#define focus_xw mccchannel_4_analyzer_1_array_crystal_array_7_focus_xw
#define focus_xh mccchannel_4_analyzer_1_array_crystal_array_7_focus_xh
#define focus_r mccchannel_4_analyzer_1_array_crystal_array_7_focus_r
#define p_interact mccchannel_4_analyzer_1_array_crystal_array_7_p_interact
#define mask_string mccchannel_4_analyzer_1_array_crystal_array_7_mask_string
#define mask_setting mccchannel_4_analyzer_1_array_crystal_array_7_mask_setting
#define number_of_activations mccchannel_4_analyzer_1_array_crystal_array_7_number_of_activations
#line 204 "Union_box.comp"
// Needed for transport to the main component
struct global_geometry_element_struct global_geometry_element;

#ifndef ANY_GEOMETRY_DETECTOR_DECLARE
    #define ANY_GEOMETRY_DETECTOR_DECLARE dummy
	//struct pointer_to_global_geometry_list global_geometry_list = {0,NULL};
#endif

int loop_index,found_geometries;

double x_component;
double y_component;
double z_component;

struct Volume_struct this_box_volume;
struct box_storage this_box_storage;

#line 44637 "MACS_sample_kidney_box.c"
#undef number_of_activations
#undef mask_setting
#undef mask_string
#undef p_interact
#undef focus_r
#undef focus_xh
#undef focus_xw
#undef focus_ah
#undef focus_aw
#undef target_z
#undef target_y
#undef target_x
#undef target_index
#undef visualize
#undef yheight2
#undef xwidth2
#undef zdepth
#undef yheight
#undef xwidth
#undef priority
#undef material_string
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

/* User declarations for component 'channel_4_analyzer_1_array_crystal_array_8' [290]. */
#define mccompcurname  channel_4_analyzer_1_array_crystal_array_8
#define mccompcurtype  Union_box
#define mccompcurindex 290
#define loop_index mccchannel_4_analyzer_1_array_crystal_array_8_loop_index
#define this_box_volume mccchannel_4_analyzer_1_array_crystal_array_8_this_box_volume
#define global_geometry_element mccchannel_4_analyzer_1_array_crystal_array_8_global_geometry_element
#define this_box_storage mccchannel_4_analyzer_1_array_crystal_array_8_this_box_storage
#define material_string mccchannel_4_analyzer_1_array_crystal_array_8_material_string
#define priority mccchannel_4_analyzer_1_array_crystal_array_8_priority
#define xwidth mccchannel_4_analyzer_1_array_crystal_array_8_xwidth
#define yheight mccchannel_4_analyzer_1_array_crystal_array_8_yheight
#define zdepth mccchannel_4_analyzer_1_array_crystal_array_8_zdepth
#define xwidth2 mccchannel_4_analyzer_1_array_crystal_array_8_xwidth2
#define yheight2 mccchannel_4_analyzer_1_array_crystal_array_8_yheight2
#define visualize mccchannel_4_analyzer_1_array_crystal_array_8_visualize
#define target_index mccchannel_4_analyzer_1_array_crystal_array_8_target_index
#define target_x mccchannel_4_analyzer_1_array_crystal_array_8_target_x
#define target_y mccchannel_4_analyzer_1_array_crystal_array_8_target_y
#define target_z mccchannel_4_analyzer_1_array_crystal_array_8_target_z
#define focus_aw mccchannel_4_analyzer_1_array_crystal_array_8_focus_aw
#define focus_ah mccchannel_4_analyzer_1_array_crystal_array_8_focus_ah
#define focus_xw mccchannel_4_analyzer_1_array_crystal_array_8_focus_xw
#define focus_xh mccchannel_4_analyzer_1_array_crystal_array_8_focus_xh
#define focus_r mccchannel_4_analyzer_1_array_crystal_array_8_focus_r
#define p_interact mccchannel_4_analyzer_1_array_crystal_array_8_p_interact
#define mask_string mccchannel_4_analyzer_1_array_crystal_array_8_mask_string
#define mask_setting mccchannel_4_analyzer_1_array_crystal_array_8_mask_setting
#define number_of_activations mccchannel_4_analyzer_1_array_crystal_array_8_number_of_activations
#line 204 "Union_box.comp"
// Needed for transport to the main component
struct global_geometry_element_struct global_geometry_element;

#ifndef ANY_GEOMETRY_DETECTOR_DECLARE
    #define ANY_GEOMETRY_DETECTOR_DECLARE dummy
	//struct pointer_to_global_geometry_list global_geometry_list = {0,NULL};
#endif

int loop_index,found_geometries;

double x_component;
double y_component;
double z_component;

struct Volume_struct this_box_volume;
struct box_storage this_box_storage;

#line 44714 "MACS_sample_kidney_box.c"
#undef number_of_activations
#undef mask_setting
#undef mask_string
#undef p_interact
#undef focus_r
#undef focus_xh
#undef focus_xw
#undef focus_ah
#undef focus_aw
#undef target_z
#undef target_y
#undef target_x
#undef target_index
#undef visualize
#undef yheight2
#undef xwidth2
#undef zdepth
#undef yheight
#undef xwidth
#undef priority
#undef material_string
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

/* User declarations for component 'channel_4_analyzer_2_center' [291]. */
#define mccompcurname  channel_4_analyzer_2_center
#define mccompcurtype  Arm
#define mccompcurindex 291
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

/* User declarations for component 'channel_4_analyzer_2_rotated' [292]. */
#define mccompcurname  channel_4_analyzer_2_rotated
#define mccompcurtype  Arm
#define mccompcurindex 292
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

/* User declarations for component 'channel_4_analyzer_2_array_crystal_array_0' [293]. */
#define mccompcurname  channel_4_analyzer_2_array_crystal_array_0
#define mccompcurtype  Union_box
#define mccompcurindex 293
#define loop_index mccchannel_4_analyzer_2_array_crystal_array_0_loop_index
#define this_box_volume mccchannel_4_analyzer_2_array_crystal_array_0_this_box_volume
#define global_geometry_element mccchannel_4_analyzer_2_array_crystal_array_0_global_geometry_element
#define this_box_storage mccchannel_4_analyzer_2_array_crystal_array_0_this_box_storage
#define material_string mccchannel_4_analyzer_2_array_crystal_array_0_material_string
#define priority mccchannel_4_analyzer_2_array_crystal_array_0_priority
#define xwidth mccchannel_4_analyzer_2_array_crystal_array_0_xwidth
#define yheight mccchannel_4_analyzer_2_array_crystal_array_0_yheight
#define zdepth mccchannel_4_analyzer_2_array_crystal_array_0_zdepth
#define xwidth2 mccchannel_4_analyzer_2_array_crystal_array_0_xwidth2
#define yheight2 mccchannel_4_analyzer_2_array_crystal_array_0_yheight2
#define visualize mccchannel_4_analyzer_2_array_crystal_array_0_visualize
#define target_index mccchannel_4_analyzer_2_array_crystal_array_0_target_index
#define target_x mccchannel_4_analyzer_2_array_crystal_array_0_target_x
#define target_y mccchannel_4_analyzer_2_array_crystal_array_0_target_y
#define target_z mccchannel_4_analyzer_2_array_crystal_array_0_target_z
#define focus_aw mccchannel_4_analyzer_2_array_crystal_array_0_focus_aw
#define focus_ah mccchannel_4_analyzer_2_array_crystal_array_0_focus_ah
#define focus_xw mccchannel_4_analyzer_2_array_crystal_array_0_focus_xw
#define focus_xh mccchannel_4_analyzer_2_array_crystal_array_0_focus_xh
#define focus_r mccchannel_4_analyzer_2_array_crystal_array_0_focus_r
#define p_interact mccchannel_4_analyzer_2_array_crystal_array_0_p_interact
#define mask_string mccchannel_4_analyzer_2_array_crystal_array_0_mask_string
#define mask_setting mccchannel_4_analyzer_2_array_crystal_array_0_mask_setting
#define number_of_activations mccchannel_4_analyzer_2_array_crystal_array_0_number_of_activations
#line 204 "Union_box.comp"
// Needed for transport to the main component
struct global_geometry_element_struct global_geometry_element;

#ifndef ANY_GEOMETRY_DETECTOR_DECLARE
    #define ANY_GEOMETRY_DETECTOR_DECLARE dummy
	//struct pointer_to_global_geometry_list global_geometry_list = {0,NULL};
#endif

int loop_index,found_geometries;

double x_component;
double y_component;
double z_component;

struct Volume_struct this_box_volume;
struct box_storage this_box_storage;

#line 44807 "MACS_sample_kidney_box.c"
#undef number_of_activations
#undef mask_setting
#undef mask_string
#undef p_interact
#undef focus_r
#undef focus_xh
#undef focus_xw
#undef focus_ah
#undef focus_aw
#undef target_z
#undef target_y
#undef target_x
#undef target_index
#undef visualize
#undef yheight2
#undef xwidth2
#undef zdepth
#undef yheight
#undef xwidth
#undef priority
#undef material_string
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

/* User declarations for component 'channel_4_analyzer_2_array_crystal_array_1' [294]. */
#define mccompcurname  channel_4_analyzer_2_array_crystal_array_1
#define mccompcurtype  Union_box
#define mccompcurindex 294
#define loop_index mccchannel_4_analyzer_2_array_crystal_array_1_loop_index
#define this_box_volume mccchannel_4_analyzer_2_array_crystal_array_1_this_box_volume
#define global_geometry_element mccchannel_4_analyzer_2_array_crystal_array_1_global_geometry_element
#define this_box_storage mccchannel_4_analyzer_2_array_crystal_array_1_this_box_storage
#define material_string mccchannel_4_analyzer_2_array_crystal_array_1_material_string
#define priority mccchannel_4_analyzer_2_array_crystal_array_1_priority
#define xwidth mccchannel_4_analyzer_2_array_crystal_array_1_xwidth
#define yheight mccchannel_4_analyzer_2_array_crystal_array_1_yheight
#define zdepth mccchannel_4_analyzer_2_array_crystal_array_1_zdepth
#define xwidth2 mccchannel_4_analyzer_2_array_crystal_array_1_xwidth2
#define yheight2 mccchannel_4_analyzer_2_array_crystal_array_1_yheight2
#define visualize mccchannel_4_analyzer_2_array_crystal_array_1_visualize
#define target_index mccchannel_4_analyzer_2_array_crystal_array_1_target_index
#define target_x mccchannel_4_analyzer_2_array_crystal_array_1_target_x
#define target_y mccchannel_4_analyzer_2_array_crystal_array_1_target_y
#define target_z mccchannel_4_analyzer_2_array_crystal_array_1_target_z
#define focus_aw mccchannel_4_analyzer_2_array_crystal_array_1_focus_aw
#define focus_ah mccchannel_4_analyzer_2_array_crystal_array_1_focus_ah
#define focus_xw mccchannel_4_analyzer_2_array_crystal_array_1_focus_xw
#define focus_xh mccchannel_4_analyzer_2_array_crystal_array_1_focus_xh
#define focus_r mccchannel_4_analyzer_2_array_crystal_array_1_focus_r
#define p_interact mccchannel_4_analyzer_2_array_crystal_array_1_p_interact
#define mask_string mccchannel_4_analyzer_2_array_crystal_array_1_mask_string
#define mask_setting mccchannel_4_analyzer_2_array_crystal_array_1_mask_setting
#define number_of_activations mccchannel_4_analyzer_2_array_crystal_array_1_number_of_activations
#line 204 "Union_box.comp"
// Needed for transport to the main component
struct global_geometry_element_struct global_geometry_element;

#ifndef ANY_GEOMETRY_DETECTOR_DECLARE
    #define ANY_GEOMETRY_DETECTOR_DECLARE dummy
	//struct pointer_to_global_geometry_list global_geometry_list = {0,NULL};
#endif

int loop_index,found_geometries;

double x_component;
double y_component;
double z_component;

struct Volume_struct this_box_volume;
struct box_storage this_box_storage;

#line 44884 "MACS_sample_kidney_box.c"
#undef number_of_activations
#undef mask_setting
#undef mask_string
#undef p_interact
#undef focus_r
#undef focus_xh
#undef focus_xw
#undef focus_ah
#undef focus_aw
#undef target_z
#undef target_y
#undef target_x
#undef target_index
#undef visualize
#undef yheight2
#undef xwidth2
#undef zdepth
#undef yheight
#undef xwidth
#undef priority
#undef material_string
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

/* User declarations for component 'channel_4_analyzer_2_array_crystal_array_2' [295]. */
#define mccompcurname  channel_4_analyzer_2_array_crystal_array_2
#define mccompcurtype  Union_box
#define mccompcurindex 295
#define loop_index mccchannel_4_analyzer_2_array_crystal_array_2_loop_index
#define this_box_volume mccchannel_4_analyzer_2_array_crystal_array_2_this_box_volume
#define global_geometry_element mccchannel_4_analyzer_2_array_crystal_array_2_global_geometry_element
#define this_box_storage mccchannel_4_analyzer_2_array_crystal_array_2_this_box_storage
#define material_string mccchannel_4_analyzer_2_array_crystal_array_2_material_string
#define priority mccchannel_4_analyzer_2_array_crystal_array_2_priority
#define xwidth mccchannel_4_analyzer_2_array_crystal_array_2_xwidth
#define yheight mccchannel_4_analyzer_2_array_crystal_array_2_yheight
#define zdepth mccchannel_4_analyzer_2_array_crystal_array_2_zdepth
#define xwidth2 mccchannel_4_analyzer_2_array_crystal_array_2_xwidth2
#define yheight2 mccchannel_4_analyzer_2_array_crystal_array_2_yheight2
#define visualize mccchannel_4_analyzer_2_array_crystal_array_2_visualize
#define target_index mccchannel_4_analyzer_2_array_crystal_array_2_target_index
#define target_x mccchannel_4_analyzer_2_array_crystal_array_2_target_x
#define target_y mccchannel_4_analyzer_2_array_crystal_array_2_target_y
#define target_z mccchannel_4_analyzer_2_array_crystal_array_2_target_z
#define focus_aw mccchannel_4_analyzer_2_array_crystal_array_2_focus_aw
#define focus_ah mccchannel_4_analyzer_2_array_crystal_array_2_focus_ah
#define focus_xw mccchannel_4_analyzer_2_array_crystal_array_2_focus_xw
#define focus_xh mccchannel_4_analyzer_2_array_crystal_array_2_focus_xh
#define focus_r mccchannel_4_analyzer_2_array_crystal_array_2_focus_r
#define p_interact mccchannel_4_analyzer_2_array_crystal_array_2_p_interact
#define mask_string mccchannel_4_analyzer_2_array_crystal_array_2_mask_string
#define mask_setting mccchannel_4_analyzer_2_array_crystal_array_2_mask_setting
#define number_of_activations mccchannel_4_analyzer_2_array_crystal_array_2_number_of_activations
#line 204 "Union_box.comp"
// Needed for transport to the main component
struct global_geometry_element_struct global_geometry_element;

#ifndef ANY_GEOMETRY_DETECTOR_DECLARE
    #define ANY_GEOMETRY_DETECTOR_DECLARE dummy
	//struct pointer_to_global_geometry_list global_geometry_list = {0,NULL};
#endif

int loop_index,found_geometries;

double x_component;
double y_component;
double z_component;

struct Volume_struct this_box_volume;
struct box_storage this_box_storage;

#line 44961 "MACS_sample_kidney_box.c"
#undef number_of_activations
#undef mask_setting
#undef mask_string
#undef p_interact
#undef focus_r
#undef focus_xh
#undef focus_xw
#undef focus_ah
#undef focus_aw
#undef target_z
#undef target_y
#undef target_x
#undef target_index
#undef visualize
#undef yheight2
#undef xwidth2
#undef zdepth
#undef yheight
#undef xwidth
#undef priority
#undef material_string
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

/* User declarations for component 'channel_4_analyzer_2_array_crystal_array_3' [296]. */
#define mccompcurname  channel_4_analyzer_2_array_crystal_array_3
#define mccompcurtype  Union_box
#define mccompcurindex 296
#define loop_index mccchannel_4_analyzer_2_array_crystal_array_3_loop_index
#define this_box_volume mccchannel_4_analyzer_2_array_crystal_array_3_this_box_volume
#define global_geometry_element mccchannel_4_analyzer_2_array_crystal_array_3_global_geometry_element
#define this_box_storage mccchannel_4_analyzer_2_array_crystal_array_3_this_box_storage
#define material_string mccchannel_4_analyzer_2_array_crystal_array_3_material_string
#define priority mccchannel_4_analyzer_2_array_crystal_array_3_priority
#define xwidth mccchannel_4_analyzer_2_array_crystal_array_3_xwidth
#define yheight mccchannel_4_analyzer_2_array_crystal_array_3_yheight
#define zdepth mccchannel_4_analyzer_2_array_crystal_array_3_zdepth
#define xwidth2 mccchannel_4_analyzer_2_array_crystal_array_3_xwidth2
#define yheight2 mccchannel_4_analyzer_2_array_crystal_array_3_yheight2
#define visualize mccchannel_4_analyzer_2_array_crystal_array_3_visualize
#define target_index mccchannel_4_analyzer_2_array_crystal_array_3_target_index
#define target_x mccchannel_4_analyzer_2_array_crystal_array_3_target_x
#define target_y mccchannel_4_analyzer_2_array_crystal_array_3_target_y
#define target_z mccchannel_4_analyzer_2_array_crystal_array_3_target_z
#define focus_aw mccchannel_4_analyzer_2_array_crystal_array_3_focus_aw
#define focus_ah mccchannel_4_analyzer_2_array_crystal_array_3_focus_ah
#define focus_xw mccchannel_4_analyzer_2_array_crystal_array_3_focus_xw
#define focus_xh mccchannel_4_analyzer_2_array_crystal_array_3_focus_xh
#define focus_r mccchannel_4_analyzer_2_array_crystal_array_3_focus_r
#define p_interact mccchannel_4_analyzer_2_array_crystal_array_3_p_interact
#define mask_string mccchannel_4_analyzer_2_array_crystal_array_3_mask_string
#define mask_setting mccchannel_4_analyzer_2_array_crystal_array_3_mask_setting
#define number_of_activations mccchannel_4_analyzer_2_array_crystal_array_3_number_of_activations
#line 204 "Union_box.comp"
// Needed for transport to the main component
struct global_geometry_element_struct global_geometry_element;

#ifndef ANY_GEOMETRY_DETECTOR_DECLARE
    #define ANY_GEOMETRY_DETECTOR_DECLARE dummy
	//struct pointer_to_global_geometry_list global_geometry_list = {0,NULL};
#endif

int loop_index,found_geometries;

double x_component;
double y_component;
double z_component;

struct Volume_struct this_box_volume;
struct box_storage this_box_storage;

#line 45038 "MACS_sample_kidney_box.c"
#undef number_of_activations
#undef mask_setting
#undef mask_string
#undef p_interact
#undef focus_r
#undef focus_xh
#undef focus_xw
#undef focus_ah
#undef focus_aw
#undef target_z
#undef target_y
#undef target_x
#undef target_index
#undef visualize
#undef yheight2
#undef xwidth2
#undef zdepth
#undef yheight
#undef xwidth
#undef priority
#undef material_string
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

/* User declarations for component 'channel_4_analyzer_2_array_crystal_array_4' [297]. */
#define mccompcurname  channel_4_analyzer_2_array_crystal_array_4
#define mccompcurtype  Union_box
#define mccompcurindex 297
#define loop_index mccchannel_4_analyzer_2_array_crystal_array_4_loop_index
#define this_box_volume mccchannel_4_analyzer_2_array_crystal_array_4_this_box_volume
#define global_geometry_element mccchannel_4_analyzer_2_array_crystal_array_4_global_geometry_element
#define this_box_storage mccchannel_4_analyzer_2_array_crystal_array_4_this_box_storage
#define material_string mccchannel_4_analyzer_2_array_crystal_array_4_material_string
#define priority mccchannel_4_analyzer_2_array_crystal_array_4_priority
#define xwidth mccchannel_4_analyzer_2_array_crystal_array_4_xwidth
#define yheight mccchannel_4_analyzer_2_array_crystal_array_4_yheight
#define zdepth mccchannel_4_analyzer_2_array_crystal_array_4_zdepth
#define xwidth2 mccchannel_4_analyzer_2_array_crystal_array_4_xwidth2
#define yheight2 mccchannel_4_analyzer_2_array_crystal_array_4_yheight2
#define visualize mccchannel_4_analyzer_2_array_crystal_array_4_visualize
#define target_index mccchannel_4_analyzer_2_array_crystal_array_4_target_index
#define target_x mccchannel_4_analyzer_2_array_crystal_array_4_target_x
#define target_y mccchannel_4_analyzer_2_array_crystal_array_4_target_y
#define target_z mccchannel_4_analyzer_2_array_crystal_array_4_target_z
#define focus_aw mccchannel_4_analyzer_2_array_crystal_array_4_focus_aw
#define focus_ah mccchannel_4_analyzer_2_array_crystal_array_4_focus_ah
#define focus_xw mccchannel_4_analyzer_2_array_crystal_array_4_focus_xw
#define focus_xh mccchannel_4_analyzer_2_array_crystal_array_4_focus_xh
#define focus_r mccchannel_4_analyzer_2_array_crystal_array_4_focus_r
#define p_interact mccchannel_4_analyzer_2_array_crystal_array_4_p_interact
#define mask_string mccchannel_4_analyzer_2_array_crystal_array_4_mask_string
#define mask_setting mccchannel_4_analyzer_2_array_crystal_array_4_mask_setting
#define number_of_activations mccchannel_4_analyzer_2_array_crystal_array_4_number_of_activations
#line 204 "Union_box.comp"
// Needed for transport to the main component
struct global_geometry_element_struct global_geometry_element;

#ifndef ANY_GEOMETRY_DETECTOR_DECLARE
    #define ANY_GEOMETRY_DETECTOR_DECLARE dummy
	//struct pointer_to_global_geometry_list global_geometry_list = {0,NULL};
#endif

int loop_index,found_geometries;

double x_component;
double y_component;
double z_component;

struct Volume_struct this_box_volume;
struct box_storage this_box_storage;

#line 45115 "MACS_sample_kidney_box.c"
#undef number_of_activations
#undef mask_setting
#undef mask_string
#undef p_interact
#undef focus_r
#undef focus_xh
#undef focus_xw
#undef focus_ah
#undef focus_aw
#undef target_z
#undef target_y
#undef target_x
#undef target_index
#undef visualize
#undef yheight2
#undef xwidth2
#undef zdepth
#undef yheight
#undef xwidth
#undef priority
#undef material_string
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

/* User declarations for component 'channel_4_analyzer_2_array_crystal_array_5' [298]. */
#define mccompcurname  channel_4_analyzer_2_array_crystal_array_5
#define mccompcurtype  Union_box
#define mccompcurindex 298
#define loop_index mccchannel_4_analyzer_2_array_crystal_array_5_loop_index
#define this_box_volume mccchannel_4_analyzer_2_array_crystal_array_5_this_box_volume
#define global_geometry_element mccchannel_4_analyzer_2_array_crystal_array_5_global_geometry_element
#define this_box_storage mccchannel_4_analyzer_2_array_crystal_array_5_this_box_storage
#define material_string mccchannel_4_analyzer_2_array_crystal_array_5_material_string
#define priority mccchannel_4_analyzer_2_array_crystal_array_5_priority
#define xwidth mccchannel_4_analyzer_2_array_crystal_array_5_xwidth
#define yheight mccchannel_4_analyzer_2_array_crystal_array_5_yheight
#define zdepth mccchannel_4_analyzer_2_array_crystal_array_5_zdepth
#define xwidth2 mccchannel_4_analyzer_2_array_crystal_array_5_xwidth2
#define yheight2 mccchannel_4_analyzer_2_array_crystal_array_5_yheight2
#define visualize mccchannel_4_analyzer_2_array_crystal_array_5_visualize
#define target_index mccchannel_4_analyzer_2_array_crystal_array_5_target_index
#define target_x mccchannel_4_analyzer_2_array_crystal_array_5_target_x
#define target_y mccchannel_4_analyzer_2_array_crystal_array_5_target_y
#define target_z mccchannel_4_analyzer_2_array_crystal_array_5_target_z
#define focus_aw mccchannel_4_analyzer_2_array_crystal_array_5_focus_aw
#define focus_ah mccchannel_4_analyzer_2_array_crystal_array_5_focus_ah
#define focus_xw mccchannel_4_analyzer_2_array_crystal_array_5_focus_xw
#define focus_xh mccchannel_4_analyzer_2_array_crystal_array_5_focus_xh
#define focus_r mccchannel_4_analyzer_2_array_crystal_array_5_focus_r
#define p_interact mccchannel_4_analyzer_2_array_crystal_array_5_p_interact
#define mask_string mccchannel_4_analyzer_2_array_crystal_array_5_mask_string
#define mask_setting mccchannel_4_analyzer_2_array_crystal_array_5_mask_setting
#define number_of_activations mccchannel_4_analyzer_2_array_crystal_array_5_number_of_activations
#line 204 "Union_box.comp"
// Needed for transport to the main component
struct global_geometry_element_struct global_geometry_element;

#ifndef ANY_GEOMETRY_DETECTOR_DECLARE
    #define ANY_GEOMETRY_DETECTOR_DECLARE dummy
	//struct pointer_to_global_geometry_list global_geometry_list = {0,NULL};
#endif

int loop_index,found_geometries;

double x_component;
double y_component;
double z_component;

struct Volume_struct this_box_volume;
struct box_storage this_box_storage;

#line 45192 "MACS_sample_kidney_box.c"
#undef number_of_activations
#undef mask_setting
#undef mask_string
#undef p_interact
#undef focus_r
#undef focus_xh
#undef focus_xw
#undef focus_ah
#undef focus_aw
#undef target_z
#undef target_y
#undef target_x
#undef target_index
#undef visualize
#undef yheight2
#undef xwidth2
#undef zdepth
#undef yheight
#undef xwidth
#undef priority
#undef material_string
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

/* User declarations for component 'channel_4_analyzer_2_array_crystal_array_6' [299]. */
#define mccompcurname  channel_4_analyzer_2_array_crystal_array_6
#define mccompcurtype  Union_box
#define mccompcurindex 299
#define loop_index mccchannel_4_analyzer_2_array_crystal_array_6_loop_index
#define this_box_volume mccchannel_4_analyzer_2_array_crystal_array_6_this_box_volume
#define global_geometry_element mccchannel_4_analyzer_2_array_crystal_array_6_global_geometry_element
#define this_box_storage mccchannel_4_analyzer_2_array_crystal_array_6_this_box_storage
#define material_string mccchannel_4_analyzer_2_array_crystal_array_6_material_string
#define priority mccchannel_4_analyzer_2_array_crystal_array_6_priority
#define xwidth mccchannel_4_analyzer_2_array_crystal_array_6_xwidth
#define yheight mccchannel_4_analyzer_2_array_crystal_array_6_yheight
#define zdepth mccchannel_4_analyzer_2_array_crystal_array_6_zdepth
#define xwidth2 mccchannel_4_analyzer_2_array_crystal_array_6_xwidth2
#define yheight2 mccchannel_4_analyzer_2_array_crystal_array_6_yheight2
#define visualize mccchannel_4_analyzer_2_array_crystal_array_6_visualize
#define target_index mccchannel_4_analyzer_2_array_crystal_array_6_target_index
#define target_x mccchannel_4_analyzer_2_array_crystal_array_6_target_x
#define target_y mccchannel_4_analyzer_2_array_crystal_array_6_target_y
#define target_z mccchannel_4_analyzer_2_array_crystal_array_6_target_z
#define focus_aw mccchannel_4_analyzer_2_array_crystal_array_6_focus_aw
#define focus_ah mccchannel_4_analyzer_2_array_crystal_array_6_focus_ah
#define focus_xw mccchannel_4_analyzer_2_array_crystal_array_6_focus_xw
#define focus_xh mccchannel_4_analyzer_2_array_crystal_array_6_focus_xh
#define focus_r mccchannel_4_analyzer_2_array_crystal_array_6_focus_r
#define p_interact mccchannel_4_analyzer_2_array_crystal_array_6_p_interact
#define mask_string mccchannel_4_analyzer_2_array_crystal_array_6_mask_string
#define mask_setting mccchannel_4_analyzer_2_array_crystal_array_6_mask_setting
#define number_of_activations mccchannel_4_analyzer_2_array_crystal_array_6_number_of_activations
#line 204 "Union_box.comp"
// Needed for transport to the main component
struct global_geometry_element_struct global_geometry_element;

#ifndef ANY_GEOMETRY_DETECTOR_DECLARE
    #define ANY_GEOMETRY_DETECTOR_DECLARE dummy
	//struct pointer_to_global_geometry_list global_geometry_list = {0,NULL};
#endif

int loop_index,found_geometries;

double x_component;
double y_component;
double z_component;

struct Volume_struct this_box_volume;
struct box_storage this_box_storage;

#line 45269 "MACS_sample_kidney_box.c"
#undef number_of_activations
#undef mask_setting
#undef mask_string
#undef p_interact
#undef focus_r
#undef focus_xh
#undef focus_xw
#undef focus_ah
#undef focus_aw
#undef target_z
#undef target_y
#undef target_x
#undef target_index
#undef visualize
#undef yheight2
#undef xwidth2
#undef zdepth
#undef yheight
#undef xwidth
#undef priority
#undef material_string
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

/* User declarations for component 'channel_4_analyzer_2_array_crystal_array_7' [300]. */
#define mccompcurname  channel_4_analyzer_2_array_crystal_array_7
#define mccompcurtype  Union_box
#define mccompcurindex 300
#define loop_index mccchannel_4_analyzer_2_array_crystal_array_7_loop_index
#define this_box_volume mccchannel_4_analyzer_2_array_crystal_array_7_this_box_volume
#define global_geometry_element mccchannel_4_analyzer_2_array_crystal_array_7_global_geometry_element
#define this_box_storage mccchannel_4_analyzer_2_array_crystal_array_7_this_box_storage
#define material_string mccchannel_4_analyzer_2_array_crystal_array_7_material_string
#define priority mccchannel_4_analyzer_2_array_crystal_array_7_priority
#define xwidth mccchannel_4_analyzer_2_array_crystal_array_7_xwidth
#define yheight mccchannel_4_analyzer_2_array_crystal_array_7_yheight
#define zdepth mccchannel_4_analyzer_2_array_crystal_array_7_zdepth
#define xwidth2 mccchannel_4_analyzer_2_array_crystal_array_7_xwidth2
#define yheight2 mccchannel_4_analyzer_2_array_crystal_array_7_yheight2
#define visualize mccchannel_4_analyzer_2_array_crystal_array_7_visualize
#define target_index mccchannel_4_analyzer_2_array_crystal_array_7_target_index
#define target_x mccchannel_4_analyzer_2_array_crystal_array_7_target_x
#define target_y mccchannel_4_analyzer_2_array_crystal_array_7_target_y
#define target_z mccchannel_4_analyzer_2_array_crystal_array_7_target_z
#define focus_aw mccchannel_4_analyzer_2_array_crystal_array_7_focus_aw
#define focus_ah mccchannel_4_analyzer_2_array_crystal_array_7_focus_ah
#define focus_xw mccchannel_4_analyzer_2_array_crystal_array_7_focus_xw
#define focus_xh mccchannel_4_analyzer_2_array_crystal_array_7_focus_xh
#define focus_r mccchannel_4_analyzer_2_array_crystal_array_7_focus_r
#define p_interact mccchannel_4_analyzer_2_array_crystal_array_7_p_interact
#define mask_string mccchannel_4_analyzer_2_array_crystal_array_7_mask_string
#define mask_setting mccchannel_4_analyzer_2_array_crystal_array_7_mask_setting
#define number_of_activations mccchannel_4_analyzer_2_array_crystal_array_7_number_of_activations
#line 204 "Union_box.comp"
// Needed for transport to the main component
struct global_geometry_element_struct global_geometry_element;

#ifndef ANY_GEOMETRY_DETECTOR_DECLARE
    #define ANY_GEOMETRY_DETECTOR_DECLARE dummy
	//struct pointer_to_global_geometry_list global_geometry_list = {0,NULL};
#endif

int loop_index,found_geometries;

double x_component;
double y_component;
double z_component;

struct Volume_struct this_box_volume;
struct box_storage this_box_storage;

#line 45346 "MACS_sample_kidney_box.c"
#undef number_of_activations
#undef mask_setting
#undef mask_string
#undef p_interact
#undef focus_r
#undef focus_xh
#undef focus_xw
#undef focus_ah
#undef focus_aw
#undef target_z
#undef target_y
#undef target_x
#undef target_index
#undef visualize
#undef yheight2
#undef xwidth2
#undef zdepth
#undef yheight
#undef xwidth
#undef priority
#undef material_string
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

/* User declarations for component 'channel_4_analyzer_2_array_crystal_array_8' [301]. */
#define mccompcurname  channel_4_analyzer_2_array_crystal_array_8
#define mccompcurtype  Union_box
#define mccompcurindex 301
#define loop_index mccchannel_4_analyzer_2_array_crystal_array_8_loop_index
#define this_box_volume mccchannel_4_analyzer_2_array_crystal_array_8_this_box_volume
#define global_geometry_element mccchannel_4_analyzer_2_array_crystal_array_8_global_geometry_element
#define this_box_storage mccchannel_4_analyzer_2_array_crystal_array_8_this_box_storage
#define material_string mccchannel_4_analyzer_2_array_crystal_array_8_material_string
#define priority mccchannel_4_analyzer_2_array_crystal_array_8_priority
#define xwidth mccchannel_4_analyzer_2_array_crystal_array_8_xwidth
#define yheight mccchannel_4_analyzer_2_array_crystal_array_8_yheight
#define zdepth mccchannel_4_analyzer_2_array_crystal_array_8_zdepth
#define xwidth2 mccchannel_4_analyzer_2_array_crystal_array_8_xwidth2
#define yheight2 mccchannel_4_analyzer_2_array_crystal_array_8_yheight2
#define visualize mccchannel_4_analyzer_2_array_crystal_array_8_visualize
#define target_index mccchannel_4_analyzer_2_array_crystal_array_8_target_index
#define target_x mccchannel_4_analyzer_2_array_crystal_array_8_target_x
#define target_y mccchannel_4_analyzer_2_array_crystal_array_8_target_y
#define target_z mccchannel_4_analyzer_2_array_crystal_array_8_target_z
#define focus_aw mccchannel_4_analyzer_2_array_crystal_array_8_focus_aw
#define focus_ah mccchannel_4_analyzer_2_array_crystal_array_8_focus_ah
#define focus_xw mccchannel_4_analyzer_2_array_crystal_array_8_focus_xw
#define focus_xh mccchannel_4_analyzer_2_array_crystal_array_8_focus_xh
#define focus_r mccchannel_4_analyzer_2_array_crystal_array_8_focus_r
#define p_interact mccchannel_4_analyzer_2_array_crystal_array_8_p_interact
#define mask_string mccchannel_4_analyzer_2_array_crystal_array_8_mask_string
#define mask_setting mccchannel_4_analyzer_2_array_crystal_array_8_mask_setting
#define number_of_activations mccchannel_4_analyzer_2_array_crystal_array_8_number_of_activations
#line 204 "Union_box.comp"
// Needed for transport to the main component
struct global_geometry_element_struct global_geometry_element;

#ifndef ANY_GEOMETRY_DETECTOR_DECLARE
    #define ANY_GEOMETRY_DETECTOR_DECLARE dummy
	//struct pointer_to_global_geometry_list global_geometry_list = {0,NULL};
#endif

int loop_index,found_geometries;

double x_component;
double y_component;
double z_component;

struct Volume_struct this_box_volume;
struct box_storage this_box_storage;

#line 45423 "MACS_sample_kidney_box.c"
#undef number_of_activations
#undef mask_setting
#undef mask_string
#undef p_interact
#undef focus_r
#undef focus_xh
#undef focus_xw
#undef focus_ah
#undef focus_aw
#undef target_z
#undef target_y
#undef target_x
#undef target_index
#undef visualize
#undef yheight2
#undef xwidth2
#undef zdepth
#undef yheight
#undef xwidth
#undef priority
#undef material_string
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

/* User declarations for component 'channel_4_cave2_cyl1' [302]. */
#define mccompcurname  channel_4_cave2_cyl1
#define mccompcurtype  Union_cylinder
#define mccompcurindex 302
#define loop_index mccchannel_4_cave2_cyl1_loop_index
#define this_cylinder_volume mccchannel_4_cave2_cyl1_this_cylinder_volume
#define global_geometry_element mccchannel_4_cave2_cyl1_global_geometry_element
#define this_cylinder_storage mccchannel_4_cave2_cyl1_this_cylinder_storage
#define material_string mccchannel_4_cave2_cyl1_material_string
#define priority mccchannel_4_cave2_cyl1_priority
#define radius mccchannel_4_cave2_cyl1_radius
#define yheight mccchannel_4_cave2_cyl1_yheight
#define visualize mccchannel_4_cave2_cyl1_visualize
#define target_index mccchannel_4_cave2_cyl1_target_index
#define target_x mccchannel_4_cave2_cyl1_target_x
#define target_y mccchannel_4_cave2_cyl1_target_y
#define target_z mccchannel_4_cave2_cyl1_target_z
#define focus_aw mccchannel_4_cave2_cyl1_focus_aw
#define focus_ah mccchannel_4_cave2_cyl1_focus_ah
#define focus_xw mccchannel_4_cave2_cyl1_focus_xw
#define focus_xh mccchannel_4_cave2_cyl1_focus_xh
#define focus_r mccchannel_4_cave2_cyl1_focus_r
#define p_interact mccchannel_4_cave2_cyl1_p_interact
#define mask_string mccchannel_4_cave2_cyl1_mask_string
#define mask_setting mccchannel_4_cave2_cyl1_mask_setting
#define number_of_activations mccchannel_4_cave2_cyl1_number_of_activations
#line 167 "Union_cylinder.comp"
// Needed for transport to the main component
struct global_geometry_element_struct global_geometry_element;

#ifndef ANY_GEOMETRY_DETECTOR_DECLARE
    #define ANY_GEOMETRY_DETECTOR_DECLARE dummy
	//struct pointer_to_global_geometry_list global_geometry_list = {0,NULL};
#endif

int dummy;
int loop_index,found_geometries;
int loop_2_index;
int material_index;

struct Volume_struct this_cylinder_volume;
struct cylinder_storage this_cylinder_storage;
#line 45495 "MACS_sample_kidney_box.c"
#undef number_of_activations
#undef mask_setting
#undef mask_string
#undef p_interact
#undef focus_r
#undef focus_xh
#undef focus_xw
#undef focus_ah
#undef focus_aw
#undef target_z
#undef target_y
#undef target_x
#undef target_index
#undef visualize
#undef yheight
#undef radius
#undef priority
#undef material_string
#undef this_cylinder_storage
#undef global_geometry_element
#undef this_cylinder_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

/* User declarations for component 'channel_4_cave2_box1' [303]. */
#define mccompcurname  channel_4_cave2_box1
#define mccompcurtype  Union_box
#define mccompcurindex 303
#define loop_index mccchannel_4_cave2_box1_loop_index
#define this_box_volume mccchannel_4_cave2_box1_this_box_volume
#define global_geometry_element mccchannel_4_cave2_box1_global_geometry_element
#define this_box_storage mccchannel_4_cave2_box1_this_box_storage
#define material_string mccchannel_4_cave2_box1_material_string
#define priority mccchannel_4_cave2_box1_priority
#define xwidth mccchannel_4_cave2_box1_xwidth
#define yheight mccchannel_4_cave2_box1_yheight
#define zdepth mccchannel_4_cave2_box1_zdepth
#define xwidth2 mccchannel_4_cave2_box1_xwidth2
#define yheight2 mccchannel_4_cave2_box1_yheight2
#define visualize mccchannel_4_cave2_box1_visualize
#define target_index mccchannel_4_cave2_box1_target_index
#define target_x mccchannel_4_cave2_box1_target_x
#define target_y mccchannel_4_cave2_box1_target_y
#define target_z mccchannel_4_cave2_box1_target_z
#define focus_aw mccchannel_4_cave2_box1_focus_aw
#define focus_ah mccchannel_4_cave2_box1_focus_ah
#define focus_xw mccchannel_4_cave2_box1_focus_xw
#define focus_xh mccchannel_4_cave2_box1_focus_xh
#define focus_r mccchannel_4_cave2_box1_focus_r
#define p_interact mccchannel_4_cave2_box1_p_interact
#define mask_string mccchannel_4_cave2_box1_mask_string
#define mask_setting mccchannel_4_cave2_box1_mask_setting
#define number_of_activations mccchannel_4_cave2_box1_number_of_activations
#line 204 "Union_box.comp"
// Needed for transport to the main component
struct global_geometry_element_struct global_geometry_element;

#ifndef ANY_GEOMETRY_DETECTOR_DECLARE
    #define ANY_GEOMETRY_DETECTOR_DECLARE dummy
	//struct pointer_to_global_geometry_list global_geometry_list = {0,NULL};
#endif

int loop_index,found_geometries;

double x_component;
double y_component;
double z_component;

struct Volume_struct this_box_volume;
struct box_storage this_box_storage;

#line 45569 "MACS_sample_kidney_box.c"
#undef number_of_activations
#undef mask_setting
#undef mask_string
#undef p_interact
#undef focus_r
#undef focus_xh
#undef focus_xw
#undef focus_ah
#undef focus_aw
#undef target_z
#undef target_y
#undef target_x
#undef target_index
#undef visualize
#undef yheight2
#undef xwidth2
#undef zdepth
#undef yheight
#undef xwidth
#undef priority
#undef material_string
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

/* User declarations for component 'channel_4_cave2_box2' [304]. */
#define mccompcurname  channel_4_cave2_box2
#define mccompcurtype  Union_box
#define mccompcurindex 304
#define loop_index mccchannel_4_cave2_box2_loop_index
#define this_box_volume mccchannel_4_cave2_box2_this_box_volume
#define global_geometry_element mccchannel_4_cave2_box2_global_geometry_element
#define this_box_storage mccchannel_4_cave2_box2_this_box_storage
#define material_string mccchannel_4_cave2_box2_material_string
#define priority mccchannel_4_cave2_box2_priority
#define xwidth mccchannel_4_cave2_box2_xwidth
#define yheight mccchannel_4_cave2_box2_yheight
#define zdepth mccchannel_4_cave2_box2_zdepth
#define xwidth2 mccchannel_4_cave2_box2_xwidth2
#define yheight2 mccchannel_4_cave2_box2_yheight2
#define visualize mccchannel_4_cave2_box2_visualize
#define target_index mccchannel_4_cave2_box2_target_index
#define target_x mccchannel_4_cave2_box2_target_x
#define target_y mccchannel_4_cave2_box2_target_y
#define target_z mccchannel_4_cave2_box2_target_z
#define focus_aw mccchannel_4_cave2_box2_focus_aw
#define focus_ah mccchannel_4_cave2_box2_focus_ah
#define focus_xw mccchannel_4_cave2_box2_focus_xw
#define focus_xh mccchannel_4_cave2_box2_focus_xh
#define focus_r mccchannel_4_cave2_box2_focus_r
#define p_interact mccchannel_4_cave2_box2_p_interact
#define mask_string mccchannel_4_cave2_box2_mask_string
#define mask_setting mccchannel_4_cave2_box2_mask_setting
#define number_of_activations mccchannel_4_cave2_box2_number_of_activations
#line 204 "Union_box.comp"
// Needed for transport to the main component
struct global_geometry_element_struct global_geometry_element;

#ifndef ANY_GEOMETRY_DETECTOR_DECLARE
    #define ANY_GEOMETRY_DETECTOR_DECLARE dummy
	//struct pointer_to_global_geometry_list global_geometry_list = {0,NULL};
#endif

int loop_index,found_geometries;

double x_component;
double y_component;
double z_component;

struct Volume_struct this_box_volume;
struct box_storage this_box_storage;

#line 45646 "MACS_sample_kidney_box.c"
#undef number_of_activations
#undef mask_setting
#undef mask_string
#undef p_interact
#undef focus_r
#undef focus_xh
#undef focus_xw
#undef focus_ah
#undef focus_aw
#undef target_z
#undef target_y
#undef target_x
#undef target_index
#undef visualize
#undef yheight2
#undef xwidth2
#undef zdepth
#undef yheight
#undef xwidth
#undef priority
#undef material_string
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

/* User declarations for component 'channel_4_cave2_box3' [305]. */
#define mccompcurname  channel_4_cave2_box3
#define mccompcurtype  Union_box
#define mccompcurindex 305
#define loop_index mccchannel_4_cave2_box3_loop_index
#define this_box_volume mccchannel_4_cave2_box3_this_box_volume
#define global_geometry_element mccchannel_4_cave2_box3_global_geometry_element
#define this_box_storage mccchannel_4_cave2_box3_this_box_storage
#define material_string mccchannel_4_cave2_box3_material_string
#define priority mccchannel_4_cave2_box3_priority
#define xwidth mccchannel_4_cave2_box3_xwidth
#define yheight mccchannel_4_cave2_box3_yheight
#define zdepth mccchannel_4_cave2_box3_zdepth
#define xwidth2 mccchannel_4_cave2_box3_xwidth2
#define yheight2 mccchannel_4_cave2_box3_yheight2
#define visualize mccchannel_4_cave2_box3_visualize
#define target_index mccchannel_4_cave2_box3_target_index
#define target_x mccchannel_4_cave2_box3_target_x
#define target_y mccchannel_4_cave2_box3_target_y
#define target_z mccchannel_4_cave2_box3_target_z
#define focus_aw mccchannel_4_cave2_box3_focus_aw
#define focus_ah mccchannel_4_cave2_box3_focus_ah
#define focus_xw mccchannel_4_cave2_box3_focus_xw
#define focus_xh mccchannel_4_cave2_box3_focus_xh
#define focus_r mccchannel_4_cave2_box3_focus_r
#define p_interact mccchannel_4_cave2_box3_p_interact
#define mask_string mccchannel_4_cave2_box3_mask_string
#define mask_setting mccchannel_4_cave2_box3_mask_setting
#define number_of_activations mccchannel_4_cave2_box3_number_of_activations
#line 204 "Union_box.comp"
// Needed for transport to the main component
struct global_geometry_element_struct global_geometry_element;

#ifndef ANY_GEOMETRY_DETECTOR_DECLARE
    #define ANY_GEOMETRY_DETECTOR_DECLARE dummy
	//struct pointer_to_global_geometry_list global_geometry_list = {0,NULL};
#endif

int loop_index,found_geometries;

double x_component;
double y_component;
double z_component;

struct Volume_struct this_box_volume;
struct box_storage this_box_storage;

#line 45723 "MACS_sample_kidney_box.c"
#undef number_of_activations
#undef mask_setting
#undef mask_string
#undef p_interact
#undef focus_r
#undef focus_xh
#undef focus_xw
#undef focus_ah
#undef focus_aw
#undef target_z
#undef target_y
#undef target_x
#undef target_index
#undef visualize
#undef yheight2
#undef xwidth2
#undef zdepth
#undef yheight
#undef xwidth
#undef priority
#undef material_string
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

/* User declarations for component 'inter_analyzer_colimator_center_4' [306]. */
#define mccompcurname  inter_analyzer_colimator_center_4
#define mccompcurtype  Arm
#define mccompcurindex 306
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

/* User declarations for component 'inter_analyzer_colimator_4_blade_0' [307]. */
#define mccompcurname  inter_analyzer_colimator_4_blade_0
#define mccompcurtype  Union_box
#define mccompcurindex 307
#define loop_index mccinter_analyzer_colimator_4_blade_0_loop_index
#define this_box_volume mccinter_analyzer_colimator_4_blade_0_this_box_volume
#define global_geometry_element mccinter_analyzer_colimator_4_blade_0_global_geometry_element
#define this_box_storage mccinter_analyzer_colimator_4_blade_0_this_box_storage
#define material_string mccinter_analyzer_colimator_4_blade_0_material_string
#define priority mccinter_analyzer_colimator_4_blade_0_priority
#define xwidth mccinter_analyzer_colimator_4_blade_0_xwidth
#define yheight mccinter_analyzer_colimator_4_blade_0_yheight
#define zdepth mccinter_analyzer_colimator_4_blade_0_zdepth
#define xwidth2 mccinter_analyzer_colimator_4_blade_0_xwidth2
#define yheight2 mccinter_analyzer_colimator_4_blade_0_yheight2
#define visualize mccinter_analyzer_colimator_4_blade_0_visualize
#define target_index mccinter_analyzer_colimator_4_blade_0_target_index
#define target_x mccinter_analyzer_colimator_4_blade_0_target_x
#define target_y mccinter_analyzer_colimator_4_blade_0_target_y
#define target_z mccinter_analyzer_colimator_4_blade_0_target_z
#define focus_aw mccinter_analyzer_colimator_4_blade_0_focus_aw
#define focus_ah mccinter_analyzer_colimator_4_blade_0_focus_ah
#define focus_xw mccinter_analyzer_colimator_4_blade_0_focus_xw
#define focus_xh mccinter_analyzer_colimator_4_blade_0_focus_xh
#define focus_r mccinter_analyzer_colimator_4_blade_0_focus_r
#define p_interact mccinter_analyzer_colimator_4_blade_0_p_interact
#define mask_string mccinter_analyzer_colimator_4_blade_0_mask_string
#define mask_setting mccinter_analyzer_colimator_4_blade_0_mask_setting
#define number_of_activations mccinter_analyzer_colimator_4_blade_0_number_of_activations
#line 204 "Union_box.comp"
// Needed for transport to the main component
struct global_geometry_element_struct global_geometry_element;

#ifndef ANY_GEOMETRY_DETECTOR_DECLARE
    #define ANY_GEOMETRY_DETECTOR_DECLARE dummy
	//struct pointer_to_global_geometry_list global_geometry_list = {0,NULL};
#endif

int loop_index,found_geometries;

double x_component;
double y_component;
double z_component;

struct Volume_struct this_box_volume;
struct box_storage this_box_storage;

#line 45808 "MACS_sample_kidney_box.c"
#undef number_of_activations
#undef mask_setting
#undef mask_string
#undef p_interact
#undef focus_r
#undef focus_xh
#undef focus_xw
#undef focus_ah
#undef focus_aw
#undef target_z
#undef target_y
#undef target_x
#undef target_index
#undef visualize
#undef yheight2
#undef xwidth2
#undef zdepth
#undef yheight
#undef xwidth
#undef priority
#undef material_string
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

/* User declarations for component 'inter_analyzer_colimator_4_blade_1' [308]. */
#define mccompcurname  inter_analyzer_colimator_4_blade_1
#define mccompcurtype  Union_box
#define mccompcurindex 308
#define loop_index mccinter_analyzer_colimator_4_blade_1_loop_index
#define this_box_volume mccinter_analyzer_colimator_4_blade_1_this_box_volume
#define global_geometry_element mccinter_analyzer_colimator_4_blade_1_global_geometry_element
#define this_box_storage mccinter_analyzer_colimator_4_blade_1_this_box_storage
#define material_string mccinter_analyzer_colimator_4_blade_1_material_string
#define priority mccinter_analyzer_colimator_4_blade_1_priority
#define xwidth mccinter_analyzer_colimator_4_blade_1_xwidth
#define yheight mccinter_analyzer_colimator_4_blade_1_yheight
#define zdepth mccinter_analyzer_colimator_4_blade_1_zdepth
#define xwidth2 mccinter_analyzer_colimator_4_blade_1_xwidth2
#define yheight2 mccinter_analyzer_colimator_4_blade_1_yheight2
#define visualize mccinter_analyzer_colimator_4_blade_1_visualize
#define target_index mccinter_analyzer_colimator_4_blade_1_target_index
#define target_x mccinter_analyzer_colimator_4_blade_1_target_x
#define target_y mccinter_analyzer_colimator_4_blade_1_target_y
#define target_z mccinter_analyzer_colimator_4_blade_1_target_z
#define focus_aw mccinter_analyzer_colimator_4_blade_1_focus_aw
#define focus_ah mccinter_analyzer_colimator_4_blade_1_focus_ah
#define focus_xw mccinter_analyzer_colimator_4_blade_1_focus_xw
#define focus_xh mccinter_analyzer_colimator_4_blade_1_focus_xh
#define focus_r mccinter_analyzer_colimator_4_blade_1_focus_r
#define p_interact mccinter_analyzer_colimator_4_blade_1_p_interact
#define mask_string mccinter_analyzer_colimator_4_blade_1_mask_string
#define mask_setting mccinter_analyzer_colimator_4_blade_1_mask_setting
#define number_of_activations mccinter_analyzer_colimator_4_blade_1_number_of_activations
#line 204 "Union_box.comp"
// Needed for transport to the main component
struct global_geometry_element_struct global_geometry_element;

#ifndef ANY_GEOMETRY_DETECTOR_DECLARE
    #define ANY_GEOMETRY_DETECTOR_DECLARE dummy
	//struct pointer_to_global_geometry_list global_geometry_list = {0,NULL};
#endif

int loop_index,found_geometries;

double x_component;
double y_component;
double z_component;

struct Volume_struct this_box_volume;
struct box_storage this_box_storage;

#line 45885 "MACS_sample_kidney_box.c"
#undef number_of_activations
#undef mask_setting
#undef mask_string
#undef p_interact
#undef focus_r
#undef focus_xh
#undef focus_xw
#undef focus_ah
#undef focus_aw
#undef target_z
#undef target_y
#undef target_x
#undef target_index
#undef visualize
#undef yheight2
#undef xwidth2
#undef zdepth
#undef yheight
#undef xwidth
#undef priority
#undef material_string
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

/* User declarations for component 'inter_analyzer_colimator_4_blade_2' [309]. */
#define mccompcurname  inter_analyzer_colimator_4_blade_2
#define mccompcurtype  Union_box
#define mccompcurindex 309
#define loop_index mccinter_analyzer_colimator_4_blade_2_loop_index
#define this_box_volume mccinter_analyzer_colimator_4_blade_2_this_box_volume
#define global_geometry_element mccinter_analyzer_colimator_4_blade_2_global_geometry_element
#define this_box_storage mccinter_analyzer_colimator_4_blade_2_this_box_storage
#define material_string mccinter_analyzer_colimator_4_blade_2_material_string
#define priority mccinter_analyzer_colimator_4_blade_2_priority
#define xwidth mccinter_analyzer_colimator_4_blade_2_xwidth
#define yheight mccinter_analyzer_colimator_4_blade_2_yheight
#define zdepth mccinter_analyzer_colimator_4_blade_2_zdepth
#define xwidth2 mccinter_analyzer_colimator_4_blade_2_xwidth2
#define yheight2 mccinter_analyzer_colimator_4_blade_2_yheight2
#define visualize mccinter_analyzer_colimator_4_blade_2_visualize
#define target_index mccinter_analyzer_colimator_4_blade_2_target_index
#define target_x mccinter_analyzer_colimator_4_blade_2_target_x
#define target_y mccinter_analyzer_colimator_4_blade_2_target_y
#define target_z mccinter_analyzer_colimator_4_blade_2_target_z
#define focus_aw mccinter_analyzer_colimator_4_blade_2_focus_aw
#define focus_ah mccinter_analyzer_colimator_4_blade_2_focus_ah
#define focus_xw mccinter_analyzer_colimator_4_blade_2_focus_xw
#define focus_xh mccinter_analyzer_colimator_4_blade_2_focus_xh
#define focus_r mccinter_analyzer_colimator_4_blade_2_focus_r
#define p_interact mccinter_analyzer_colimator_4_blade_2_p_interact
#define mask_string mccinter_analyzer_colimator_4_blade_2_mask_string
#define mask_setting mccinter_analyzer_colimator_4_blade_2_mask_setting
#define number_of_activations mccinter_analyzer_colimator_4_blade_2_number_of_activations
#line 204 "Union_box.comp"
// Needed for transport to the main component
struct global_geometry_element_struct global_geometry_element;

#ifndef ANY_GEOMETRY_DETECTOR_DECLARE
    #define ANY_GEOMETRY_DETECTOR_DECLARE dummy
	//struct pointer_to_global_geometry_list global_geometry_list = {0,NULL};
#endif

int loop_index,found_geometries;

double x_component;
double y_component;
double z_component;

struct Volume_struct this_box_volume;
struct box_storage this_box_storage;

#line 45962 "MACS_sample_kidney_box.c"
#undef number_of_activations
#undef mask_setting
#undef mask_string
#undef p_interact
#undef focus_r
#undef focus_xh
#undef focus_xw
#undef focus_ah
#undef focus_aw
#undef target_z
#undef target_y
#undef target_x
#undef target_index
#undef visualize
#undef yheight2
#undef xwidth2
#undef zdepth
#undef yheight
#undef xwidth
#undef priority
#undef material_string
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

/* User declarations for component 'inter_analyzer_colimator_4_blade_3' [310]. */
#define mccompcurname  inter_analyzer_colimator_4_blade_3
#define mccompcurtype  Union_box
#define mccompcurindex 310
#define loop_index mccinter_analyzer_colimator_4_blade_3_loop_index
#define this_box_volume mccinter_analyzer_colimator_4_blade_3_this_box_volume
#define global_geometry_element mccinter_analyzer_colimator_4_blade_3_global_geometry_element
#define this_box_storage mccinter_analyzer_colimator_4_blade_3_this_box_storage
#define material_string mccinter_analyzer_colimator_4_blade_3_material_string
#define priority mccinter_analyzer_colimator_4_blade_3_priority
#define xwidth mccinter_analyzer_colimator_4_blade_3_xwidth
#define yheight mccinter_analyzer_colimator_4_blade_3_yheight
#define zdepth mccinter_analyzer_colimator_4_blade_3_zdepth
#define xwidth2 mccinter_analyzer_colimator_4_blade_3_xwidth2
#define yheight2 mccinter_analyzer_colimator_4_blade_3_yheight2
#define visualize mccinter_analyzer_colimator_4_blade_3_visualize
#define target_index mccinter_analyzer_colimator_4_blade_3_target_index
#define target_x mccinter_analyzer_colimator_4_blade_3_target_x
#define target_y mccinter_analyzer_colimator_4_blade_3_target_y
#define target_z mccinter_analyzer_colimator_4_blade_3_target_z
#define focus_aw mccinter_analyzer_colimator_4_blade_3_focus_aw
#define focus_ah mccinter_analyzer_colimator_4_blade_3_focus_ah
#define focus_xw mccinter_analyzer_colimator_4_blade_3_focus_xw
#define focus_xh mccinter_analyzer_colimator_4_blade_3_focus_xh
#define focus_r mccinter_analyzer_colimator_4_blade_3_focus_r
#define p_interact mccinter_analyzer_colimator_4_blade_3_p_interact
#define mask_string mccinter_analyzer_colimator_4_blade_3_mask_string
#define mask_setting mccinter_analyzer_colimator_4_blade_3_mask_setting
#define number_of_activations mccinter_analyzer_colimator_4_blade_3_number_of_activations
#line 204 "Union_box.comp"
// Needed for transport to the main component
struct global_geometry_element_struct global_geometry_element;

#ifndef ANY_GEOMETRY_DETECTOR_DECLARE
    #define ANY_GEOMETRY_DETECTOR_DECLARE dummy
	//struct pointer_to_global_geometry_list global_geometry_list = {0,NULL};
#endif

int loop_index,found_geometries;

double x_component;
double y_component;
double z_component;

struct Volume_struct this_box_volume;
struct box_storage this_box_storage;

#line 46039 "MACS_sample_kidney_box.c"
#undef number_of_activations
#undef mask_setting
#undef mask_string
#undef p_interact
#undef focus_r
#undef focus_xh
#undef focus_xw
#undef focus_ah
#undef focus_aw
#undef target_z
#undef target_y
#undef target_x
#undef target_index
#undef visualize
#undef yheight2
#undef xwidth2
#undef zdepth
#undef yheight
#undef xwidth
#undef priority
#undef material_string
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

/* User declarations for component 'inter_analyzer_colimator_4_blade_4' [311]. */
#define mccompcurname  inter_analyzer_colimator_4_blade_4
#define mccompcurtype  Union_box
#define mccompcurindex 311
#define loop_index mccinter_analyzer_colimator_4_blade_4_loop_index
#define this_box_volume mccinter_analyzer_colimator_4_blade_4_this_box_volume
#define global_geometry_element mccinter_analyzer_colimator_4_blade_4_global_geometry_element
#define this_box_storage mccinter_analyzer_colimator_4_blade_4_this_box_storage
#define material_string mccinter_analyzer_colimator_4_blade_4_material_string
#define priority mccinter_analyzer_colimator_4_blade_4_priority
#define xwidth mccinter_analyzer_colimator_4_blade_4_xwidth
#define yheight mccinter_analyzer_colimator_4_blade_4_yheight
#define zdepth mccinter_analyzer_colimator_4_blade_4_zdepth
#define xwidth2 mccinter_analyzer_colimator_4_blade_4_xwidth2
#define yheight2 mccinter_analyzer_colimator_4_blade_4_yheight2
#define visualize mccinter_analyzer_colimator_4_blade_4_visualize
#define target_index mccinter_analyzer_colimator_4_blade_4_target_index
#define target_x mccinter_analyzer_colimator_4_blade_4_target_x
#define target_y mccinter_analyzer_colimator_4_blade_4_target_y
#define target_z mccinter_analyzer_colimator_4_blade_4_target_z
#define focus_aw mccinter_analyzer_colimator_4_blade_4_focus_aw
#define focus_ah mccinter_analyzer_colimator_4_blade_4_focus_ah
#define focus_xw mccinter_analyzer_colimator_4_blade_4_focus_xw
#define focus_xh mccinter_analyzer_colimator_4_blade_4_focus_xh
#define focus_r mccinter_analyzer_colimator_4_blade_4_focus_r
#define p_interact mccinter_analyzer_colimator_4_blade_4_p_interact
#define mask_string mccinter_analyzer_colimator_4_blade_4_mask_string
#define mask_setting mccinter_analyzer_colimator_4_blade_4_mask_setting
#define number_of_activations mccinter_analyzer_colimator_4_blade_4_number_of_activations
#line 204 "Union_box.comp"
// Needed for transport to the main component
struct global_geometry_element_struct global_geometry_element;

#ifndef ANY_GEOMETRY_DETECTOR_DECLARE
    #define ANY_GEOMETRY_DETECTOR_DECLARE dummy
	//struct pointer_to_global_geometry_list global_geometry_list = {0,NULL};
#endif

int loop_index,found_geometries;

double x_component;
double y_component;
double z_component;

struct Volume_struct this_box_volume;
struct box_storage this_box_storage;

#line 46116 "MACS_sample_kidney_box.c"
#undef number_of_activations
#undef mask_setting
#undef mask_string
#undef p_interact
#undef focus_r
#undef focus_xh
#undef focus_xw
#undef focus_ah
#undef focus_aw
#undef target_z
#undef target_y
#undef target_x
#undef target_index
#undef visualize
#undef yheight2
#undef xwidth2
#undef zdepth
#undef yheight
#undef xwidth
#undef priority
#undef material_string
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

/* User declarations for component 'diffraction_detector_4_exit_volume' [312]. */
#define mccompcurname  diffraction_detector_4_exit_volume
#define mccompcurtype  Union_box
#define mccompcurindex 312
#define loop_index mccdiffraction_detector_4_exit_volume_loop_index
#define this_box_volume mccdiffraction_detector_4_exit_volume_this_box_volume
#define global_geometry_element mccdiffraction_detector_4_exit_volume_global_geometry_element
#define this_box_storage mccdiffraction_detector_4_exit_volume_this_box_storage
#define material_string mccdiffraction_detector_4_exit_volume_material_string
#define priority mccdiffraction_detector_4_exit_volume_priority
#define xwidth mccdiffraction_detector_4_exit_volume_xwidth
#define yheight mccdiffraction_detector_4_exit_volume_yheight
#define zdepth mccdiffraction_detector_4_exit_volume_zdepth
#define xwidth2 mccdiffraction_detector_4_exit_volume_xwidth2
#define yheight2 mccdiffraction_detector_4_exit_volume_yheight2
#define visualize mccdiffraction_detector_4_exit_volume_visualize
#define target_index mccdiffraction_detector_4_exit_volume_target_index
#define target_x mccdiffraction_detector_4_exit_volume_target_x
#define target_y mccdiffraction_detector_4_exit_volume_target_y
#define target_z mccdiffraction_detector_4_exit_volume_target_z
#define focus_aw mccdiffraction_detector_4_exit_volume_focus_aw
#define focus_ah mccdiffraction_detector_4_exit_volume_focus_ah
#define focus_xw mccdiffraction_detector_4_exit_volume_focus_xw
#define focus_xh mccdiffraction_detector_4_exit_volume_focus_xh
#define focus_r mccdiffraction_detector_4_exit_volume_focus_r
#define p_interact mccdiffraction_detector_4_exit_volume_p_interact
#define mask_string mccdiffraction_detector_4_exit_volume_mask_string
#define mask_setting mccdiffraction_detector_4_exit_volume_mask_setting
#define number_of_activations mccdiffraction_detector_4_exit_volume_number_of_activations
#line 204 "Union_box.comp"
// Needed for transport to the main component
struct global_geometry_element_struct global_geometry_element;

#ifndef ANY_GEOMETRY_DETECTOR_DECLARE
    #define ANY_GEOMETRY_DETECTOR_DECLARE dummy
	//struct pointer_to_global_geometry_list global_geometry_list = {0,NULL};
#endif

int loop_index,found_geometries;

double x_component;
double y_component;
double z_component;

struct Volume_struct this_box_volume;
struct box_storage this_box_storage;

#line 46193 "MACS_sample_kidney_box.c"
#undef number_of_activations
#undef mask_setting
#undef mask_string
#undef p_interact
#undef focus_r
#undef focus_xh
#undef focus_xw
#undef focus_ah
#undef focus_aw
#undef target_z
#undef target_y
#undef target_x
#undef target_index
#undef visualize
#undef yheight2
#undef xwidth2
#undef zdepth
#undef yheight
#undef xwidth
#undef priority
#undef material_string
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

/* User declarations for component 'spec_detector_4_exit_volume' [313]. */
#define mccompcurname  spec_detector_4_exit_volume
#define mccompcurtype  Union_box
#define mccompcurindex 313
#define loop_index mccspec_detector_4_exit_volume_loop_index
#define this_box_volume mccspec_detector_4_exit_volume_this_box_volume
#define global_geometry_element mccspec_detector_4_exit_volume_global_geometry_element
#define this_box_storage mccspec_detector_4_exit_volume_this_box_storage
#define material_string mccspec_detector_4_exit_volume_material_string
#define priority mccspec_detector_4_exit_volume_priority
#define xwidth mccspec_detector_4_exit_volume_xwidth
#define yheight mccspec_detector_4_exit_volume_yheight
#define zdepth mccspec_detector_4_exit_volume_zdepth
#define xwidth2 mccspec_detector_4_exit_volume_xwidth2
#define yheight2 mccspec_detector_4_exit_volume_yheight2
#define visualize mccspec_detector_4_exit_volume_visualize
#define target_index mccspec_detector_4_exit_volume_target_index
#define target_x mccspec_detector_4_exit_volume_target_x
#define target_y mccspec_detector_4_exit_volume_target_y
#define target_z mccspec_detector_4_exit_volume_target_z
#define focus_aw mccspec_detector_4_exit_volume_focus_aw
#define focus_ah mccspec_detector_4_exit_volume_focus_ah
#define focus_xw mccspec_detector_4_exit_volume_focus_xw
#define focus_xh mccspec_detector_4_exit_volume_focus_xh
#define focus_r mccspec_detector_4_exit_volume_focus_r
#define p_interact mccspec_detector_4_exit_volume_p_interact
#define mask_string mccspec_detector_4_exit_volume_mask_string
#define mask_setting mccspec_detector_4_exit_volume_mask_setting
#define number_of_activations mccspec_detector_4_exit_volume_number_of_activations
#line 204 "Union_box.comp"
// Needed for transport to the main component
struct global_geometry_element_struct global_geometry_element;

#ifndef ANY_GEOMETRY_DETECTOR_DECLARE
    #define ANY_GEOMETRY_DETECTOR_DECLARE dummy
	//struct pointer_to_global_geometry_list global_geometry_list = {0,NULL};
#endif

int loop_index,found_geometries;

double x_component;
double y_component;
double z_component;

struct Volume_struct this_box_volume;
struct box_storage this_box_storage;

#line 46270 "MACS_sample_kidney_box.c"
#undef number_of_activations
#undef mask_setting
#undef mask_string
#undef p_interact
#undef focus_r
#undef focus_xh
#undef focus_xw
#undef focus_ah
#undef focus_aw
#undef target_z
#undef target_y
#undef target_x
#undef target_index
#undef visualize
#undef yheight2
#undef xwidth2
#undef zdepth
#undef yheight
#undef xwidth
#undef priority
#undef material_string
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

/* User declarations for component 'channel_5_cave1_box1' [314]. */
#define mccompcurname  channel_5_cave1_box1
#define mccompcurtype  Union_box
#define mccompcurindex 314
#define loop_index mccchannel_5_cave1_box1_loop_index
#define this_box_volume mccchannel_5_cave1_box1_this_box_volume
#define global_geometry_element mccchannel_5_cave1_box1_global_geometry_element
#define this_box_storage mccchannel_5_cave1_box1_this_box_storage
#define material_string mccchannel_5_cave1_box1_material_string
#define priority mccchannel_5_cave1_box1_priority
#define xwidth mccchannel_5_cave1_box1_xwidth
#define yheight mccchannel_5_cave1_box1_yheight
#define zdepth mccchannel_5_cave1_box1_zdepth
#define xwidth2 mccchannel_5_cave1_box1_xwidth2
#define yheight2 mccchannel_5_cave1_box1_yheight2
#define visualize mccchannel_5_cave1_box1_visualize
#define target_index mccchannel_5_cave1_box1_target_index
#define target_x mccchannel_5_cave1_box1_target_x
#define target_y mccchannel_5_cave1_box1_target_y
#define target_z mccchannel_5_cave1_box1_target_z
#define focus_aw mccchannel_5_cave1_box1_focus_aw
#define focus_ah mccchannel_5_cave1_box1_focus_ah
#define focus_xw mccchannel_5_cave1_box1_focus_xw
#define focus_xh mccchannel_5_cave1_box1_focus_xh
#define focus_r mccchannel_5_cave1_box1_focus_r
#define p_interact mccchannel_5_cave1_box1_p_interact
#define mask_string mccchannel_5_cave1_box1_mask_string
#define mask_setting mccchannel_5_cave1_box1_mask_setting
#define number_of_activations mccchannel_5_cave1_box1_number_of_activations
#line 204 "Union_box.comp"
// Needed for transport to the main component
struct global_geometry_element_struct global_geometry_element;

#ifndef ANY_GEOMETRY_DETECTOR_DECLARE
    #define ANY_GEOMETRY_DETECTOR_DECLARE dummy
	//struct pointer_to_global_geometry_list global_geometry_list = {0,NULL};
#endif

int loop_index,found_geometries;

double x_component;
double y_component;
double z_component;

struct Volume_struct this_box_volume;
struct box_storage this_box_storage;

#line 46347 "MACS_sample_kidney_box.c"
#undef number_of_activations
#undef mask_setting
#undef mask_string
#undef p_interact
#undef focus_r
#undef focus_xh
#undef focus_xw
#undef focus_ah
#undef focus_aw
#undef target_z
#undef target_y
#undef target_x
#undef target_index
#undef visualize
#undef yheight2
#undef xwidth2
#undef zdepth
#undef yheight
#undef xwidth
#undef priority
#undef material_string
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

/* User declarations for component 'channel_5_cave1_box2' [315]. */
#define mccompcurname  channel_5_cave1_box2
#define mccompcurtype  Union_box
#define mccompcurindex 315
#define loop_index mccchannel_5_cave1_box2_loop_index
#define this_box_volume mccchannel_5_cave1_box2_this_box_volume
#define global_geometry_element mccchannel_5_cave1_box2_global_geometry_element
#define this_box_storage mccchannel_5_cave1_box2_this_box_storage
#define material_string mccchannel_5_cave1_box2_material_string
#define priority mccchannel_5_cave1_box2_priority
#define xwidth mccchannel_5_cave1_box2_xwidth
#define yheight mccchannel_5_cave1_box2_yheight
#define zdepth mccchannel_5_cave1_box2_zdepth
#define xwidth2 mccchannel_5_cave1_box2_xwidth2
#define yheight2 mccchannel_5_cave1_box2_yheight2
#define visualize mccchannel_5_cave1_box2_visualize
#define target_index mccchannel_5_cave1_box2_target_index
#define target_x mccchannel_5_cave1_box2_target_x
#define target_y mccchannel_5_cave1_box2_target_y
#define target_z mccchannel_5_cave1_box2_target_z
#define focus_aw mccchannel_5_cave1_box2_focus_aw
#define focus_ah mccchannel_5_cave1_box2_focus_ah
#define focus_xw mccchannel_5_cave1_box2_focus_xw
#define focus_xh mccchannel_5_cave1_box2_focus_xh
#define focus_r mccchannel_5_cave1_box2_focus_r
#define p_interact mccchannel_5_cave1_box2_p_interact
#define mask_string mccchannel_5_cave1_box2_mask_string
#define mask_setting mccchannel_5_cave1_box2_mask_setting
#define number_of_activations mccchannel_5_cave1_box2_number_of_activations
#line 204 "Union_box.comp"
// Needed for transport to the main component
struct global_geometry_element_struct global_geometry_element;

#ifndef ANY_GEOMETRY_DETECTOR_DECLARE
    #define ANY_GEOMETRY_DETECTOR_DECLARE dummy
	//struct pointer_to_global_geometry_list global_geometry_list = {0,NULL};
#endif

int loop_index,found_geometries;

double x_component;
double y_component;
double z_component;

struct Volume_struct this_box_volume;
struct box_storage this_box_storage;

#line 46424 "MACS_sample_kidney_box.c"
#undef number_of_activations
#undef mask_setting
#undef mask_string
#undef p_interact
#undef focus_r
#undef focus_xh
#undef focus_xw
#undef focus_ah
#undef focus_aw
#undef target_z
#undef target_y
#undef target_x
#undef target_index
#undef visualize
#undef yheight2
#undef xwidth2
#undef zdepth
#undef yheight
#undef xwidth
#undef priority
#undef material_string
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

/* User declarations for component 'channel_5_cave1_box3' [316]. */
#define mccompcurname  channel_5_cave1_box3
#define mccompcurtype  Union_box
#define mccompcurindex 316
#define loop_index mccchannel_5_cave1_box3_loop_index
#define this_box_volume mccchannel_5_cave1_box3_this_box_volume
#define global_geometry_element mccchannel_5_cave1_box3_global_geometry_element
#define this_box_storage mccchannel_5_cave1_box3_this_box_storage
#define material_string mccchannel_5_cave1_box3_material_string
#define priority mccchannel_5_cave1_box3_priority
#define xwidth mccchannel_5_cave1_box3_xwidth
#define yheight mccchannel_5_cave1_box3_yheight
#define zdepth mccchannel_5_cave1_box3_zdepth
#define xwidth2 mccchannel_5_cave1_box3_xwidth2
#define yheight2 mccchannel_5_cave1_box3_yheight2
#define visualize mccchannel_5_cave1_box3_visualize
#define target_index mccchannel_5_cave1_box3_target_index
#define target_x mccchannel_5_cave1_box3_target_x
#define target_y mccchannel_5_cave1_box3_target_y
#define target_z mccchannel_5_cave1_box3_target_z
#define focus_aw mccchannel_5_cave1_box3_focus_aw
#define focus_ah mccchannel_5_cave1_box3_focus_ah
#define focus_xw mccchannel_5_cave1_box3_focus_xw
#define focus_xh mccchannel_5_cave1_box3_focus_xh
#define focus_r mccchannel_5_cave1_box3_focus_r
#define p_interact mccchannel_5_cave1_box3_p_interact
#define mask_string mccchannel_5_cave1_box3_mask_string
#define mask_setting mccchannel_5_cave1_box3_mask_setting
#define number_of_activations mccchannel_5_cave1_box3_number_of_activations
#line 204 "Union_box.comp"
// Needed for transport to the main component
struct global_geometry_element_struct global_geometry_element;

#ifndef ANY_GEOMETRY_DETECTOR_DECLARE
    #define ANY_GEOMETRY_DETECTOR_DECLARE dummy
	//struct pointer_to_global_geometry_list global_geometry_list = {0,NULL};
#endif

int loop_index,found_geometries;

double x_component;
double y_component;
double z_component;

struct Volume_struct this_box_volume;
struct box_storage this_box_storage;

#line 46501 "MACS_sample_kidney_box.c"
#undef number_of_activations
#undef mask_setting
#undef mask_string
#undef p_interact
#undef focus_r
#undef focus_xh
#undef focus_xw
#undef focus_ah
#undef focus_aw
#undef target_z
#undef target_y
#undef target_x
#undef target_index
#undef visualize
#undef yheight2
#undef xwidth2
#undef zdepth
#undef yheight
#undef xwidth
#undef priority
#undef material_string
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

/* User declarations for component 'channel_5_cave1_cyl1' [317]. */
#define mccompcurname  channel_5_cave1_cyl1
#define mccompcurtype  Union_cylinder
#define mccompcurindex 317
#define loop_index mccchannel_5_cave1_cyl1_loop_index
#define this_cylinder_volume mccchannel_5_cave1_cyl1_this_cylinder_volume
#define global_geometry_element mccchannel_5_cave1_cyl1_global_geometry_element
#define this_cylinder_storage mccchannel_5_cave1_cyl1_this_cylinder_storage
#define material_string mccchannel_5_cave1_cyl1_material_string
#define priority mccchannel_5_cave1_cyl1_priority
#define radius mccchannel_5_cave1_cyl1_radius
#define yheight mccchannel_5_cave1_cyl1_yheight
#define visualize mccchannel_5_cave1_cyl1_visualize
#define target_index mccchannel_5_cave1_cyl1_target_index
#define target_x mccchannel_5_cave1_cyl1_target_x
#define target_y mccchannel_5_cave1_cyl1_target_y
#define target_z mccchannel_5_cave1_cyl1_target_z
#define focus_aw mccchannel_5_cave1_cyl1_focus_aw
#define focus_ah mccchannel_5_cave1_cyl1_focus_ah
#define focus_xw mccchannel_5_cave1_cyl1_focus_xw
#define focus_xh mccchannel_5_cave1_cyl1_focus_xh
#define focus_r mccchannel_5_cave1_cyl1_focus_r
#define p_interact mccchannel_5_cave1_cyl1_p_interact
#define mask_string mccchannel_5_cave1_cyl1_mask_string
#define mask_setting mccchannel_5_cave1_cyl1_mask_setting
#define number_of_activations mccchannel_5_cave1_cyl1_number_of_activations
#line 167 "Union_cylinder.comp"
// Needed for transport to the main component
struct global_geometry_element_struct global_geometry_element;

#ifndef ANY_GEOMETRY_DETECTOR_DECLARE
    #define ANY_GEOMETRY_DETECTOR_DECLARE dummy
	//struct pointer_to_global_geometry_list global_geometry_list = {0,NULL};
#endif

int dummy;
int loop_index,found_geometries;
int loop_2_index;
int material_index;

struct Volume_struct this_cylinder_volume;
struct cylinder_storage this_cylinder_storage;
#line 46573 "MACS_sample_kidney_box.c"
#undef number_of_activations
#undef mask_setting
#undef mask_string
#undef p_interact
#undef focus_r
#undef focus_xh
#undef focus_xw
#undef focus_ah
#undef focus_aw
#undef target_z
#undef target_y
#undef target_x
#undef target_index
#undef visualize
#undef yheight
#undef radius
#undef priority
#undef material_string
#undef this_cylinder_storage
#undef global_geometry_element
#undef this_cylinder_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

/* User declarations for component 'channel_5_analyzer_1_center' [318]. */
#define mccompcurname  channel_5_analyzer_1_center
#define mccompcurtype  Arm
#define mccompcurindex 318
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

/* User declarations for component 'channel_5_analyzer_1_rotated' [319]. */
#define mccompcurname  channel_5_analyzer_1_rotated
#define mccompcurtype  Arm
#define mccompcurindex 319
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

/* User declarations for component 'channel_5_analyzer_1_array_crystal_array_0' [320]. */
#define mccompcurname  channel_5_analyzer_1_array_crystal_array_0
#define mccompcurtype  Union_box
#define mccompcurindex 320
#define loop_index mccchannel_5_analyzer_1_array_crystal_array_0_loop_index
#define this_box_volume mccchannel_5_analyzer_1_array_crystal_array_0_this_box_volume
#define global_geometry_element mccchannel_5_analyzer_1_array_crystal_array_0_global_geometry_element
#define this_box_storage mccchannel_5_analyzer_1_array_crystal_array_0_this_box_storage
#define material_string mccchannel_5_analyzer_1_array_crystal_array_0_material_string
#define priority mccchannel_5_analyzer_1_array_crystal_array_0_priority
#define xwidth mccchannel_5_analyzer_1_array_crystal_array_0_xwidth
#define yheight mccchannel_5_analyzer_1_array_crystal_array_0_yheight
#define zdepth mccchannel_5_analyzer_1_array_crystal_array_0_zdepth
#define xwidth2 mccchannel_5_analyzer_1_array_crystal_array_0_xwidth2
#define yheight2 mccchannel_5_analyzer_1_array_crystal_array_0_yheight2
#define visualize mccchannel_5_analyzer_1_array_crystal_array_0_visualize
#define target_index mccchannel_5_analyzer_1_array_crystal_array_0_target_index
#define target_x mccchannel_5_analyzer_1_array_crystal_array_0_target_x
#define target_y mccchannel_5_analyzer_1_array_crystal_array_0_target_y
#define target_z mccchannel_5_analyzer_1_array_crystal_array_0_target_z
#define focus_aw mccchannel_5_analyzer_1_array_crystal_array_0_focus_aw
#define focus_ah mccchannel_5_analyzer_1_array_crystal_array_0_focus_ah
#define focus_xw mccchannel_5_analyzer_1_array_crystal_array_0_focus_xw
#define focus_xh mccchannel_5_analyzer_1_array_crystal_array_0_focus_xh
#define focus_r mccchannel_5_analyzer_1_array_crystal_array_0_focus_r
#define p_interact mccchannel_5_analyzer_1_array_crystal_array_0_p_interact
#define mask_string mccchannel_5_analyzer_1_array_crystal_array_0_mask_string
#define mask_setting mccchannel_5_analyzer_1_array_crystal_array_0_mask_setting
#define number_of_activations mccchannel_5_analyzer_1_array_crystal_array_0_number_of_activations
#line 204 "Union_box.comp"
// Needed for transport to the main component
struct global_geometry_element_struct global_geometry_element;

#ifndef ANY_GEOMETRY_DETECTOR_DECLARE
    #define ANY_GEOMETRY_DETECTOR_DECLARE dummy
	//struct pointer_to_global_geometry_list global_geometry_list = {0,NULL};
#endif

int loop_index,found_geometries;

double x_component;
double y_component;
double z_component;

struct Volume_struct this_box_volume;
struct box_storage this_box_storage;

#line 46663 "MACS_sample_kidney_box.c"
#undef number_of_activations
#undef mask_setting
#undef mask_string
#undef p_interact
#undef focus_r
#undef focus_xh
#undef focus_xw
#undef focus_ah
#undef focus_aw
#undef target_z
#undef target_y
#undef target_x
#undef target_index
#undef visualize
#undef yheight2
#undef xwidth2
#undef zdepth
#undef yheight
#undef xwidth
#undef priority
#undef material_string
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

/* User declarations for component 'channel_5_analyzer_1_array_crystal_array_1' [321]. */
#define mccompcurname  channel_5_analyzer_1_array_crystal_array_1
#define mccompcurtype  Union_box
#define mccompcurindex 321
#define loop_index mccchannel_5_analyzer_1_array_crystal_array_1_loop_index
#define this_box_volume mccchannel_5_analyzer_1_array_crystal_array_1_this_box_volume
#define global_geometry_element mccchannel_5_analyzer_1_array_crystal_array_1_global_geometry_element
#define this_box_storage mccchannel_5_analyzer_1_array_crystal_array_1_this_box_storage
#define material_string mccchannel_5_analyzer_1_array_crystal_array_1_material_string
#define priority mccchannel_5_analyzer_1_array_crystal_array_1_priority
#define xwidth mccchannel_5_analyzer_1_array_crystal_array_1_xwidth
#define yheight mccchannel_5_analyzer_1_array_crystal_array_1_yheight
#define zdepth mccchannel_5_analyzer_1_array_crystal_array_1_zdepth
#define xwidth2 mccchannel_5_analyzer_1_array_crystal_array_1_xwidth2
#define yheight2 mccchannel_5_analyzer_1_array_crystal_array_1_yheight2
#define visualize mccchannel_5_analyzer_1_array_crystal_array_1_visualize
#define target_index mccchannel_5_analyzer_1_array_crystal_array_1_target_index
#define target_x mccchannel_5_analyzer_1_array_crystal_array_1_target_x
#define target_y mccchannel_5_analyzer_1_array_crystal_array_1_target_y
#define target_z mccchannel_5_analyzer_1_array_crystal_array_1_target_z
#define focus_aw mccchannel_5_analyzer_1_array_crystal_array_1_focus_aw
#define focus_ah mccchannel_5_analyzer_1_array_crystal_array_1_focus_ah
#define focus_xw mccchannel_5_analyzer_1_array_crystal_array_1_focus_xw
#define focus_xh mccchannel_5_analyzer_1_array_crystal_array_1_focus_xh
#define focus_r mccchannel_5_analyzer_1_array_crystal_array_1_focus_r
#define p_interact mccchannel_5_analyzer_1_array_crystal_array_1_p_interact
#define mask_string mccchannel_5_analyzer_1_array_crystal_array_1_mask_string
#define mask_setting mccchannel_5_analyzer_1_array_crystal_array_1_mask_setting
#define number_of_activations mccchannel_5_analyzer_1_array_crystal_array_1_number_of_activations
#line 204 "Union_box.comp"
// Needed for transport to the main component
struct global_geometry_element_struct global_geometry_element;

#ifndef ANY_GEOMETRY_DETECTOR_DECLARE
    #define ANY_GEOMETRY_DETECTOR_DECLARE dummy
	//struct pointer_to_global_geometry_list global_geometry_list = {0,NULL};
#endif

int loop_index,found_geometries;

double x_component;
double y_component;
double z_component;

struct Volume_struct this_box_volume;
struct box_storage this_box_storage;

#line 46740 "MACS_sample_kidney_box.c"
#undef number_of_activations
#undef mask_setting
#undef mask_string
#undef p_interact
#undef focus_r
#undef focus_xh
#undef focus_xw
#undef focus_ah
#undef focus_aw
#undef target_z
#undef target_y
#undef target_x
#undef target_index
#undef visualize
#undef yheight2
#undef xwidth2
#undef zdepth
#undef yheight
#undef xwidth
#undef priority
#undef material_string
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

/* User declarations for component 'channel_5_analyzer_1_array_crystal_array_2' [322]. */
#define mccompcurname  channel_5_analyzer_1_array_crystal_array_2
#define mccompcurtype  Union_box
#define mccompcurindex 322
#define loop_index mccchannel_5_analyzer_1_array_crystal_array_2_loop_index
#define this_box_volume mccchannel_5_analyzer_1_array_crystal_array_2_this_box_volume
#define global_geometry_element mccchannel_5_analyzer_1_array_crystal_array_2_global_geometry_element
#define this_box_storage mccchannel_5_analyzer_1_array_crystal_array_2_this_box_storage
#define material_string mccchannel_5_analyzer_1_array_crystal_array_2_material_string
#define priority mccchannel_5_analyzer_1_array_crystal_array_2_priority
#define xwidth mccchannel_5_analyzer_1_array_crystal_array_2_xwidth
#define yheight mccchannel_5_analyzer_1_array_crystal_array_2_yheight
#define zdepth mccchannel_5_analyzer_1_array_crystal_array_2_zdepth
#define xwidth2 mccchannel_5_analyzer_1_array_crystal_array_2_xwidth2
#define yheight2 mccchannel_5_analyzer_1_array_crystal_array_2_yheight2
#define visualize mccchannel_5_analyzer_1_array_crystal_array_2_visualize
#define target_index mccchannel_5_analyzer_1_array_crystal_array_2_target_index
#define target_x mccchannel_5_analyzer_1_array_crystal_array_2_target_x
#define target_y mccchannel_5_analyzer_1_array_crystal_array_2_target_y
#define target_z mccchannel_5_analyzer_1_array_crystal_array_2_target_z
#define focus_aw mccchannel_5_analyzer_1_array_crystal_array_2_focus_aw
#define focus_ah mccchannel_5_analyzer_1_array_crystal_array_2_focus_ah
#define focus_xw mccchannel_5_analyzer_1_array_crystal_array_2_focus_xw
#define focus_xh mccchannel_5_analyzer_1_array_crystal_array_2_focus_xh
#define focus_r mccchannel_5_analyzer_1_array_crystal_array_2_focus_r
#define p_interact mccchannel_5_analyzer_1_array_crystal_array_2_p_interact
#define mask_string mccchannel_5_analyzer_1_array_crystal_array_2_mask_string
#define mask_setting mccchannel_5_analyzer_1_array_crystal_array_2_mask_setting
#define number_of_activations mccchannel_5_analyzer_1_array_crystal_array_2_number_of_activations
#line 204 "Union_box.comp"
// Needed for transport to the main component
struct global_geometry_element_struct global_geometry_element;

#ifndef ANY_GEOMETRY_DETECTOR_DECLARE
    #define ANY_GEOMETRY_DETECTOR_DECLARE dummy
	//struct pointer_to_global_geometry_list global_geometry_list = {0,NULL};
#endif

int loop_index,found_geometries;

double x_component;
double y_component;
double z_component;

struct Volume_struct this_box_volume;
struct box_storage this_box_storage;

#line 46817 "MACS_sample_kidney_box.c"
#undef number_of_activations
#undef mask_setting
#undef mask_string
#undef p_interact
#undef focus_r
#undef focus_xh
#undef focus_xw
#undef focus_ah
#undef focus_aw
#undef target_z
#undef target_y
#undef target_x
#undef target_index
#undef visualize
#undef yheight2
#undef xwidth2
#undef zdepth
#undef yheight
#undef xwidth
#undef priority
#undef material_string
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

/* User declarations for component 'channel_5_analyzer_1_array_crystal_array_3' [323]. */
#define mccompcurname  channel_5_analyzer_1_array_crystal_array_3
#define mccompcurtype  Union_box
#define mccompcurindex 323
#define loop_index mccchannel_5_analyzer_1_array_crystal_array_3_loop_index
#define this_box_volume mccchannel_5_analyzer_1_array_crystal_array_3_this_box_volume
#define global_geometry_element mccchannel_5_analyzer_1_array_crystal_array_3_global_geometry_element
#define this_box_storage mccchannel_5_analyzer_1_array_crystal_array_3_this_box_storage
#define material_string mccchannel_5_analyzer_1_array_crystal_array_3_material_string
#define priority mccchannel_5_analyzer_1_array_crystal_array_3_priority
#define xwidth mccchannel_5_analyzer_1_array_crystal_array_3_xwidth
#define yheight mccchannel_5_analyzer_1_array_crystal_array_3_yheight
#define zdepth mccchannel_5_analyzer_1_array_crystal_array_3_zdepth
#define xwidth2 mccchannel_5_analyzer_1_array_crystal_array_3_xwidth2
#define yheight2 mccchannel_5_analyzer_1_array_crystal_array_3_yheight2
#define visualize mccchannel_5_analyzer_1_array_crystal_array_3_visualize
#define target_index mccchannel_5_analyzer_1_array_crystal_array_3_target_index
#define target_x mccchannel_5_analyzer_1_array_crystal_array_3_target_x
#define target_y mccchannel_5_analyzer_1_array_crystal_array_3_target_y
#define target_z mccchannel_5_analyzer_1_array_crystal_array_3_target_z
#define focus_aw mccchannel_5_analyzer_1_array_crystal_array_3_focus_aw
#define focus_ah mccchannel_5_analyzer_1_array_crystal_array_3_focus_ah
#define focus_xw mccchannel_5_analyzer_1_array_crystal_array_3_focus_xw
#define focus_xh mccchannel_5_analyzer_1_array_crystal_array_3_focus_xh
#define focus_r mccchannel_5_analyzer_1_array_crystal_array_3_focus_r
#define p_interact mccchannel_5_analyzer_1_array_crystal_array_3_p_interact
#define mask_string mccchannel_5_analyzer_1_array_crystal_array_3_mask_string
#define mask_setting mccchannel_5_analyzer_1_array_crystal_array_3_mask_setting
#define number_of_activations mccchannel_5_analyzer_1_array_crystal_array_3_number_of_activations
#line 204 "Union_box.comp"
// Needed for transport to the main component
struct global_geometry_element_struct global_geometry_element;

#ifndef ANY_GEOMETRY_DETECTOR_DECLARE
    #define ANY_GEOMETRY_DETECTOR_DECLARE dummy
	//struct pointer_to_global_geometry_list global_geometry_list = {0,NULL};
#endif

int loop_index,found_geometries;

double x_component;
double y_component;
double z_component;

struct Volume_struct this_box_volume;
struct box_storage this_box_storage;

#line 46894 "MACS_sample_kidney_box.c"
#undef number_of_activations
#undef mask_setting
#undef mask_string
#undef p_interact
#undef focus_r
#undef focus_xh
#undef focus_xw
#undef focus_ah
#undef focus_aw
#undef target_z
#undef target_y
#undef target_x
#undef target_index
#undef visualize
#undef yheight2
#undef xwidth2
#undef zdepth
#undef yheight
#undef xwidth
#undef priority
#undef material_string
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

/* User declarations for component 'channel_5_analyzer_1_array_crystal_array_4' [324]. */
#define mccompcurname  channel_5_analyzer_1_array_crystal_array_4
#define mccompcurtype  Union_box
#define mccompcurindex 324
#define loop_index mccchannel_5_analyzer_1_array_crystal_array_4_loop_index
#define this_box_volume mccchannel_5_analyzer_1_array_crystal_array_4_this_box_volume
#define global_geometry_element mccchannel_5_analyzer_1_array_crystal_array_4_global_geometry_element
#define this_box_storage mccchannel_5_analyzer_1_array_crystal_array_4_this_box_storage
#define material_string mccchannel_5_analyzer_1_array_crystal_array_4_material_string
#define priority mccchannel_5_analyzer_1_array_crystal_array_4_priority
#define xwidth mccchannel_5_analyzer_1_array_crystal_array_4_xwidth
#define yheight mccchannel_5_analyzer_1_array_crystal_array_4_yheight
#define zdepth mccchannel_5_analyzer_1_array_crystal_array_4_zdepth
#define xwidth2 mccchannel_5_analyzer_1_array_crystal_array_4_xwidth2
#define yheight2 mccchannel_5_analyzer_1_array_crystal_array_4_yheight2
#define visualize mccchannel_5_analyzer_1_array_crystal_array_4_visualize
#define target_index mccchannel_5_analyzer_1_array_crystal_array_4_target_index
#define target_x mccchannel_5_analyzer_1_array_crystal_array_4_target_x
#define target_y mccchannel_5_analyzer_1_array_crystal_array_4_target_y
#define target_z mccchannel_5_analyzer_1_array_crystal_array_4_target_z
#define focus_aw mccchannel_5_analyzer_1_array_crystal_array_4_focus_aw
#define focus_ah mccchannel_5_analyzer_1_array_crystal_array_4_focus_ah
#define focus_xw mccchannel_5_analyzer_1_array_crystal_array_4_focus_xw
#define focus_xh mccchannel_5_analyzer_1_array_crystal_array_4_focus_xh
#define focus_r mccchannel_5_analyzer_1_array_crystal_array_4_focus_r
#define p_interact mccchannel_5_analyzer_1_array_crystal_array_4_p_interact
#define mask_string mccchannel_5_analyzer_1_array_crystal_array_4_mask_string
#define mask_setting mccchannel_5_analyzer_1_array_crystal_array_4_mask_setting
#define number_of_activations mccchannel_5_analyzer_1_array_crystal_array_4_number_of_activations
#line 204 "Union_box.comp"
// Needed for transport to the main component
struct global_geometry_element_struct global_geometry_element;

#ifndef ANY_GEOMETRY_DETECTOR_DECLARE
    #define ANY_GEOMETRY_DETECTOR_DECLARE dummy
	//struct pointer_to_global_geometry_list global_geometry_list = {0,NULL};
#endif

int loop_index,found_geometries;

double x_component;
double y_component;
double z_component;

struct Volume_struct this_box_volume;
struct box_storage this_box_storage;

#line 46971 "MACS_sample_kidney_box.c"
#undef number_of_activations
#undef mask_setting
#undef mask_string
#undef p_interact
#undef focus_r
#undef focus_xh
#undef focus_xw
#undef focus_ah
#undef focus_aw
#undef target_z
#undef target_y
#undef target_x
#undef target_index
#undef visualize
#undef yheight2
#undef xwidth2
#undef zdepth
#undef yheight
#undef xwidth
#undef priority
#undef material_string
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

/* User declarations for component 'channel_5_analyzer_1_array_crystal_array_5' [325]. */
#define mccompcurname  channel_5_analyzer_1_array_crystal_array_5
#define mccompcurtype  Union_box
#define mccompcurindex 325
#define loop_index mccchannel_5_analyzer_1_array_crystal_array_5_loop_index
#define this_box_volume mccchannel_5_analyzer_1_array_crystal_array_5_this_box_volume
#define global_geometry_element mccchannel_5_analyzer_1_array_crystal_array_5_global_geometry_element
#define this_box_storage mccchannel_5_analyzer_1_array_crystal_array_5_this_box_storage
#define material_string mccchannel_5_analyzer_1_array_crystal_array_5_material_string
#define priority mccchannel_5_analyzer_1_array_crystal_array_5_priority
#define xwidth mccchannel_5_analyzer_1_array_crystal_array_5_xwidth
#define yheight mccchannel_5_analyzer_1_array_crystal_array_5_yheight
#define zdepth mccchannel_5_analyzer_1_array_crystal_array_5_zdepth
#define xwidth2 mccchannel_5_analyzer_1_array_crystal_array_5_xwidth2
#define yheight2 mccchannel_5_analyzer_1_array_crystal_array_5_yheight2
#define visualize mccchannel_5_analyzer_1_array_crystal_array_5_visualize
#define target_index mccchannel_5_analyzer_1_array_crystal_array_5_target_index
#define target_x mccchannel_5_analyzer_1_array_crystal_array_5_target_x
#define target_y mccchannel_5_analyzer_1_array_crystal_array_5_target_y
#define target_z mccchannel_5_analyzer_1_array_crystal_array_5_target_z
#define focus_aw mccchannel_5_analyzer_1_array_crystal_array_5_focus_aw
#define focus_ah mccchannel_5_analyzer_1_array_crystal_array_5_focus_ah
#define focus_xw mccchannel_5_analyzer_1_array_crystal_array_5_focus_xw
#define focus_xh mccchannel_5_analyzer_1_array_crystal_array_5_focus_xh
#define focus_r mccchannel_5_analyzer_1_array_crystal_array_5_focus_r
#define p_interact mccchannel_5_analyzer_1_array_crystal_array_5_p_interact
#define mask_string mccchannel_5_analyzer_1_array_crystal_array_5_mask_string
#define mask_setting mccchannel_5_analyzer_1_array_crystal_array_5_mask_setting
#define number_of_activations mccchannel_5_analyzer_1_array_crystal_array_5_number_of_activations
#line 204 "Union_box.comp"
// Needed for transport to the main component
struct global_geometry_element_struct global_geometry_element;

#ifndef ANY_GEOMETRY_DETECTOR_DECLARE
    #define ANY_GEOMETRY_DETECTOR_DECLARE dummy
	//struct pointer_to_global_geometry_list global_geometry_list = {0,NULL};
#endif

int loop_index,found_geometries;

double x_component;
double y_component;
double z_component;

struct Volume_struct this_box_volume;
struct box_storage this_box_storage;

#line 47048 "MACS_sample_kidney_box.c"
#undef number_of_activations
#undef mask_setting
#undef mask_string
#undef p_interact
#undef focus_r
#undef focus_xh
#undef focus_xw
#undef focus_ah
#undef focus_aw
#undef target_z
#undef target_y
#undef target_x
#undef target_index
#undef visualize
#undef yheight2
#undef xwidth2
#undef zdepth
#undef yheight
#undef xwidth
#undef priority
#undef material_string
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

/* User declarations for component 'channel_5_analyzer_1_array_crystal_array_6' [326]. */
#define mccompcurname  channel_5_analyzer_1_array_crystal_array_6
#define mccompcurtype  Union_box
#define mccompcurindex 326
#define loop_index mccchannel_5_analyzer_1_array_crystal_array_6_loop_index
#define this_box_volume mccchannel_5_analyzer_1_array_crystal_array_6_this_box_volume
#define global_geometry_element mccchannel_5_analyzer_1_array_crystal_array_6_global_geometry_element
#define this_box_storage mccchannel_5_analyzer_1_array_crystal_array_6_this_box_storage
#define material_string mccchannel_5_analyzer_1_array_crystal_array_6_material_string
#define priority mccchannel_5_analyzer_1_array_crystal_array_6_priority
#define xwidth mccchannel_5_analyzer_1_array_crystal_array_6_xwidth
#define yheight mccchannel_5_analyzer_1_array_crystal_array_6_yheight
#define zdepth mccchannel_5_analyzer_1_array_crystal_array_6_zdepth
#define xwidth2 mccchannel_5_analyzer_1_array_crystal_array_6_xwidth2
#define yheight2 mccchannel_5_analyzer_1_array_crystal_array_6_yheight2
#define visualize mccchannel_5_analyzer_1_array_crystal_array_6_visualize
#define target_index mccchannel_5_analyzer_1_array_crystal_array_6_target_index
#define target_x mccchannel_5_analyzer_1_array_crystal_array_6_target_x
#define target_y mccchannel_5_analyzer_1_array_crystal_array_6_target_y
#define target_z mccchannel_5_analyzer_1_array_crystal_array_6_target_z
#define focus_aw mccchannel_5_analyzer_1_array_crystal_array_6_focus_aw
#define focus_ah mccchannel_5_analyzer_1_array_crystal_array_6_focus_ah
#define focus_xw mccchannel_5_analyzer_1_array_crystal_array_6_focus_xw
#define focus_xh mccchannel_5_analyzer_1_array_crystal_array_6_focus_xh
#define focus_r mccchannel_5_analyzer_1_array_crystal_array_6_focus_r
#define p_interact mccchannel_5_analyzer_1_array_crystal_array_6_p_interact
#define mask_string mccchannel_5_analyzer_1_array_crystal_array_6_mask_string
#define mask_setting mccchannel_5_analyzer_1_array_crystal_array_6_mask_setting
#define number_of_activations mccchannel_5_analyzer_1_array_crystal_array_6_number_of_activations
#line 204 "Union_box.comp"
// Needed for transport to the main component
struct global_geometry_element_struct global_geometry_element;

#ifndef ANY_GEOMETRY_DETECTOR_DECLARE
    #define ANY_GEOMETRY_DETECTOR_DECLARE dummy
	//struct pointer_to_global_geometry_list global_geometry_list = {0,NULL};
#endif

int loop_index,found_geometries;

double x_component;
double y_component;
double z_component;

struct Volume_struct this_box_volume;
struct box_storage this_box_storage;

#line 47125 "MACS_sample_kidney_box.c"
#undef number_of_activations
#undef mask_setting
#undef mask_string
#undef p_interact
#undef focus_r
#undef focus_xh
#undef focus_xw
#undef focus_ah
#undef focus_aw
#undef target_z
#undef target_y
#undef target_x
#undef target_index
#undef visualize
#undef yheight2
#undef xwidth2
#undef zdepth
#undef yheight
#undef xwidth
#undef priority
#undef material_string
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

/* User declarations for component 'channel_5_analyzer_1_array_crystal_array_7' [327]. */
#define mccompcurname  channel_5_analyzer_1_array_crystal_array_7
#define mccompcurtype  Union_box
#define mccompcurindex 327
#define loop_index mccchannel_5_analyzer_1_array_crystal_array_7_loop_index
#define this_box_volume mccchannel_5_analyzer_1_array_crystal_array_7_this_box_volume
#define global_geometry_element mccchannel_5_analyzer_1_array_crystal_array_7_global_geometry_element
#define this_box_storage mccchannel_5_analyzer_1_array_crystal_array_7_this_box_storage
#define material_string mccchannel_5_analyzer_1_array_crystal_array_7_material_string
#define priority mccchannel_5_analyzer_1_array_crystal_array_7_priority
#define xwidth mccchannel_5_analyzer_1_array_crystal_array_7_xwidth
#define yheight mccchannel_5_analyzer_1_array_crystal_array_7_yheight
#define zdepth mccchannel_5_analyzer_1_array_crystal_array_7_zdepth
#define xwidth2 mccchannel_5_analyzer_1_array_crystal_array_7_xwidth2
#define yheight2 mccchannel_5_analyzer_1_array_crystal_array_7_yheight2
#define visualize mccchannel_5_analyzer_1_array_crystal_array_7_visualize
#define target_index mccchannel_5_analyzer_1_array_crystal_array_7_target_index
#define target_x mccchannel_5_analyzer_1_array_crystal_array_7_target_x
#define target_y mccchannel_5_analyzer_1_array_crystal_array_7_target_y
#define target_z mccchannel_5_analyzer_1_array_crystal_array_7_target_z
#define focus_aw mccchannel_5_analyzer_1_array_crystal_array_7_focus_aw
#define focus_ah mccchannel_5_analyzer_1_array_crystal_array_7_focus_ah
#define focus_xw mccchannel_5_analyzer_1_array_crystal_array_7_focus_xw
#define focus_xh mccchannel_5_analyzer_1_array_crystal_array_7_focus_xh
#define focus_r mccchannel_5_analyzer_1_array_crystal_array_7_focus_r
#define p_interact mccchannel_5_analyzer_1_array_crystal_array_7_p_interact
#define mask_string mccchannel_5_analyzer_1_array_crystal_array_7_mask_string
#define mask_setting mccchannel_5_analyzer_1_array_crystal_array_7_mask_setting
#define number_of_activations mccchannel_5_analyzer_1_array_crystal_array_7_number_of_activations
#line 204 "Union_box.comp"
// Needed for transport to the main component
struct global_geometry_element_struct global_geometry_element;

#ifndef ANY_GEOMETRY_DETECTOR_DECLARE
    #define ANY_GEOMETRY_DETECTOR_DECLARE dummy
	//struct pointer_to_global_geometry_list global_geometry_list = {0,NULL};
#endif

int loop_index,found_geometries;

double x_component;
double y_component;
double z_component;

struct Volume_struct this_box_volume;
struct box_storage this_box_storage;

#line 47202 "MACS_sample_kidney_box.c"
#undef number_of_activations
#undef mask_setting
#undef mask_string
#undef p_interact
#undef focus_r
#undef focus_xh
#undef focus_xw
#undef focus_ah
#undef focus_aw
#undef target_z
#undef target_y
#undef target_x
#undef target_index
#undef visualize
#undef yheight2
#undef xwidth2
#undef zdepth
#undef yheight
#undef xwidth
#undef priority
#undef material_string
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

/* User declarations for component 'channel_5_analyzer_1_array_crystal_array_8' [328]. */
#define mccompcurname  channel_5_analyzer_1_array_crystal_array_8
#define mccompcurtype  Union_box
#define mccompcurindex 328
#define loop_index mccchannel_5_analyzer_1_array_crystal_array_8_loop_index
#define this_box_volume mccchannel_5_analyzer_1_array_crystal_array_8_this_box_volume
#define global_geometry_element mccchannel_5_analyzer_1_array_crystal_array_8_global_geometry_element
#define this_box_storage mccchannel_5_analyzer_1_array_crystal_array_8_this_box_storage
#define material_string mccchannel_5_analyzer_1_array_crystal_array_8_material_string
#define priority mccchannel_5_analyzer_1_array_crystal_array_8_priority
#define xwidth mccchannel_5_analyzer_1_array_crystal_array_8_xwidth
#define yheight mccchannel_5_analyzer_1_array_crystal_array_8_yheight
#define zdepth mccchannel_5_analyzer_1_array_crystal_array_8_zdepth
#define xwidth2 mccchannel_5_analyzer_1_array_crystal_array_8_xwidth2
#define yheight2 mccchannel_5_analyzer_1_array_crystal_array_8_yheight2
#define visualize mccchannel_5_analyzer_1_array_crystal_array_8_visualize
#define target_index mccchannel_5_analyzer_1_array_crystal_array_8_target_index
#define target_x mccchannel_5_analyzer_1_array_crystal_array_8_target_x
#define target_y mccchannel_5_analyzer_1_array_crystal_array_8_target_y
#define target_z mccchannel_5_analyzer_1_array_crystal_array_8_target_z
#define focus_aw mccchannel_5_analyzer_1_array_crystal_array_8_focus_aw
#define focus_ah mccchannel_5_analyzer_1_array_crystal_array_8_focus_ah
#define focus_xw mccchannel_5_analyzer_1_array_crystal_array_8_focus_xw
#define focus_xh mccchannel_5_analyzer_1_array_crystal_array_8_focus_xh
#define focus_r mccchannel_5_analyzer_1_array_crystal_array_8_focus_r
#define p_interact mccchannel_5_analyzer_1_array_crystal_array_8_p_interact
#define mask_string mccchannel_5_analyzer_1_array_crystal_array_8_mask_string
#define mask_setting mccchannel_5_analyzer_1_array_crystal_array_8_mask_setting
#define number_of_activations mccchannel_5_analyzer_1_array_crystal_array_8_number_of_activations
#line 204 "Union_box.comp"
// Needed for transport to the main component
struct global_geometry_element_struct global_geometry_element;

#ifndef ANY_GEOMETRY_DETECTOR_DECLARE
    #define ANY_GEOMETRY_DETECTOR_DECLARE dummy
	//struct pointer_to_global_geometry_list global_geometry_list = {0,NULL};
#endif

int loop_index,found_geometries;

double x_component;
double y_component;
double z_component;

struct Volume_struct this_box_volume;
struct box_storage this_box_storage;

#line 47279 "MACS_sample_kidney_box.c"
#undef number_of_activations
#undef mask_setting
#undef mask_string
#undef p_interact
#undef focus_r
#undef focus_xh
#undef focus_xw
#undef focus_ah
#undef focus_aw
#undef target_z
#undef target_y
#undef target_x
#undef target_index
#undef visualize
#undef yheight2
#undef xwidth2
#undef zdepth
#undef yheight
#undef xwidth
#undef priority
#undef material_string
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

/* User declarations for component 'channel_5_analyzer_2_center' [329]. */
#define mccompcurname  channel_5_analyzer_2_center
#define mccompcurtype  Arm
#define mccompcurindex 329
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

/* User declarations for component 'channel_5_analyzer_2_rotated' [330]. */
#define mccompcurname  channel_5_analyzer_2_rotated
#define mccompcurtype  Arm
#define mccompcurindex 330
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

/* User declarations for component 'channel_5_analyzer_2_array_crystal_array_0' [331]. */
#define mccompcurname  channel_5_analyzer_2_array_crystal_array_0
#define mccompcurtype  Union_box
#define mccompcurindex 331
#define loop_index mccchannel_5_analyzer_2_array_crystal_array_0_loop_index
#define this_box_volume mccchannel_5_analyzer_2_array_crystal_array_0_this_box_volume
#define global_geometry_element mccchannel_5_analyzer_2_array_crystal_array_0_global_geometry_element
#define this_box_storage mccchannel_5_analyzer_2_array_crystal_array_0_this_box_storage
#define material_string mccchannel_5_analyzer_2_array_crystal_array_0_material_string
#define priority mccchannel_5_analyzer_2_array_crystal_array_0_priority
#define xwidth mccchannel_5_analyzer_2_array_crystal_array_0_xwidth
#define yheight mccchannel_5_analyzer_2_array_crystal_array_0_yheight
#define zdepth mccchannel_5_analyzer_2_array_crystal_array_0_zdepth
#define xwidth2 mccchannel_5_analyzer_2_array_crystal_array_0_xwidth2
#define yheight2 mccchannel_5_analyzer_2_array_crystal_array_0_yheight2
#define visualize mccchannel_5_analyzer_2_array_crystal_array_0_visualize
#define target_index mccchannel_5_analyzer_2_array_crystal_array_0_target_index
#define target_x mccchannel_5_analyzer_2_array_crystal_array_0_target_x
#define target_y mccchannel_5_analyzer_2_array_crystal_array_0_target_y
#define target_z mccchannel_5_analyzer_2_array_crystal_array_0_target_z
#define focus_aw mccchannel_5_analyzer_2_array_crystal_array_0_focus_aw
#define focus_ah mccchannel_5_analyzer_2_array_crystal_array_0_focus_ah
#define focus_xw mccchannel_5_analyzer_2_array_crystal_array_0_focus_xw
#define focus_xh mccchannel_5_analyzer_2_array_crystal_array_0_focus_xh
#define focus_r mccchannel_5_analyzer_2_array_crystal_array_0_focus_r
#define p_interact mccchannel_5_analyzer_2_array_crystal_array_0_p_interact
#define mask_string mccchannel_5_analyzer_2_array_crystal_array_0_mask_string
#define mask_setting mccchannel_5_analyzer_2_array_crystal_array_0_mask_setting
#define number_of_activations mccchannel_5_analyzer_2_array_crystal_array_0_number_of_activations
#line 204 "Union_box.comp"
// Needed for transport to the main component
struct global_geometry_element_struct global_geometry_element;

#ifndef ANY_GEOMETRY_DETECTOR_DECLARE
    #define ANY_GEOMETRY_DETECTOR_DECLARE dummy
	//struct pointer_to_global_geometry_list global_geometry_list = {0,NULL};
#endif

int loop_index,found_geometries;

double x_component;
double y_component;
double z_component;

struct Volume_struct this_box_volume;
struct box_storage this_box_storage;

#line 47372 "MACS_sample_kidney_box.c"
#undef number_of_activations
#undef mask_setting
#undef mask_string
#undef p_interact
#undef focus_r
#undef focus_xh
#undef focus_xw
#undef focus_ah
#undef focus_aw
#undef target_z
#undef target_y
#undef target_x
#undef target_index
#undef visualize
#undef yheight2
#undef xwidth2
#undef zdepth
#undef yheight
#undef xwidth
#undef priority
#undef material_string
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

/* User declarations for component 'channel_5_analyzer_2_array_crystal_array_1' [332]. */
#define mccompcurname  channel_5_analyzer_2_array_crystal_array_1
#define mccompcurtype  Union_box
#define mccompcurindex 332
#define loop_index mccchannel_5_analyzer_2_array_crystal_array_1_loop_index
#define this_box_volume mccchannel_5_analyzer_2_array_crystal_array_1_this_box_volume
#define global_geometry_element mccchannel_5_analyzer_2_array_crystal_array_1_global_geometry_element
#define this_box_storage mccchannel_5_analyzer_2_array_crystal_array_1_this_box_storage
#define material_string mccchannel_5_analyzer_2_array_crystal_array_1_material_string
#define priority mccchannel_5_analyzer_2_array_crystal_array_1_priority
#define xwidth mccchannel_5_analyzer_2_array_crystal_array_1_xwidth
#define yheight mccchannel_5_analyzer_2_array_crystal_array_1_yheight
#define zdepth mccchannel_5_analyzer_2_array_crystal_array_1_zdepth
#define xwidth2 mccchannel_5_analyzer_2_array_crystal_array_1_xwidth2
#define yheight2 mccchannel_5_analyzer_2_array_crystal_array_1_yheight2
#define visualize mccchannel_5_analyzer_2_array_crystal_array_1_visualize
#define target_index mccchannel_5_analyzer_2_array_crystal_array_1_target_index
#define target_x mccchannel_5_analyzer_2_array_crystal_array_1_target_x
#define target_y mccchannel_5_analyzer_2_array_crystal_array_1_target_y
#define target_z mccchannel_5_analyzer_2_array_crystal_array_1_target_z
#define focus_aw mccchannel_5_analyzer_2_array_crystal_array_1_focus_aw
#define focus_ah mccchannel_5_analyzer_2_array_crystal_array_1_focus_ah
#define focus_xw mccchannel_5_analyzer_2_array_crystal_array_1_focus_xw
#define focus_xh mccchannel_5_analyzer_2_array_crystal_array_1_focus_xh
#define focus_r mccchannel_5_analyzer_2_array_crystal_array_1_focus_r
#define p_interact mccchannel_5_analyzer_2_array_crystal_array_1_p_interact
#define mask_string mccchannel_5_analyzer_2_array_crystal_array_1_mask_string
#define mask_setting mccchannel_5_analyzer_2_array_crystal_array_1_mask_setting
#define number_of_activations mccchannel_5_analyzer_2_array_crystal_array_1_number_of_activations
#line 204 "Union_box.comp"
// Needed for transport to the main component
struct global_geometry_element_struct global_geometry_element;

#ifndef ANY_GEOMETRY_DETECTOR_DECLARE
    #define ANY_GEOMETRY_DETECTOR_DECLARE dummy
	//struct pointer_to_global_geometry_list global_geometry_list = {0,NULL};
#endif

int loop_index,found_geometries;

double x_component;
double y_component;
double z_component;

struct Volume_struct this_box_volume;
struct box_storage this_box_storage;

#line 47449 "MACS_sample_kidney_box.c"
#undef number_of_activations
#undef mask_setting
#undef mask_string
#undef p_interact
#undef focus_r
#undef focus_xh
#undef focus_xw
#undef focus_ah
#undef focus_aw
#undef target_z
#undef target_y
#undef target_x
#undef target_index
#undef visualize
#undef yheight2
#undef xwidth2
#undef zdepth
#undef yheight
#undef xwidth
#undef priority
#undef material_string
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

/* User declarations for component 'channel_5_analyzer_2_array_crystal_array_2' [333]. */
#define mccompcurname  channel_5_analyzer_2_array_crystal_array_2
#define mccompcurtype  Union_box
#define mccompcurindex 333
#define loop_index mccchannel_5_analyzer_2_array_crystal_array_2_loop_index
#define this_box_volume mccchannel_5_analyzer_2_array_crystal_array_2_this_box_volume
#define global_geometry_element mccchannel_5_analyzer_2_array_crystal_array_2_global_geometry_element
#define this_box_storage mccchannel_5_analyzer_2_array_crystal_array_2_this_box_storage
#define material_string mccchannel_5_analyzer_2_array_crystal_array_2_material_string
#define priority mccchannel_5_analyzer_2_array_crystal_array_2_priority
#define xwidth mccchannel_5_analyzer_2_array_crystal_array_2_xwidth
#define yheight mccchannel_5_analyzer_2_array_crystal_array_2_yheight
#define zdepth mccchannel_5_analyzer_2_array_crystal_array_2_zdepth
#define xwidth2 mccchannel_5_analyzer_2_array_crystal_array_2_xwidth2
#define yheight2 mccchannel_5_analyzer_2_array_crystal_array_2_yheight2
#define visualize mccchannel_5_analyzer_2_array_crystal_array_2_visualize
#define target_index mccchannel_5_analyzer_2_array_crystal_array_2_target_index
#define target_x mccchannel_5_analyzer_2_array_crystal_array_2_target_x
#define target_y mccchannel_5_analyzer_2_array_crystal_array_2_target_y
#define target_z mccchannel_5_analyzer_2_array_crystal_array_2_target_z
#define focus_aw mccchannel_5_analyzer_2_array_crystal_array_2_focus_aw
#define focus_ah mccchannel_5_analyzer_2_array_crystal_array_2_focus_ah
#define focus_xw mccchannel_5_analyzer_2_array_crystal_array_2_focus_xw
#define focus_xh mccchannel_5_analyzer_2_array_crystal_array_2_focus_xh
#define focus_r mccchannel_5_analyzer_2_array_crystal_array_2_focus_r
#define p_interact mccchannel_5_analyzer_2_array_crystal_array_2_p_interact
#define mask_string mccchannel_5_analyzer_2_array_crystal_array_2_mask_string
#define mask_setting mccchannel_5_analyzer_2_array_crystal_array_2_mask_setting
#define number_of_activations mccchannel_5_analyzer_2_array_crystal_array_2_number_of_activations
#line 204 "Union_box.comp"
// Needed for transport to the main component
struct global_geometry_element_struct global_geometry_element;

#ifndef ANY_GEOMETRY_DETECTOR_DECLARE
    #define ANY_GEOMETRY_DETECTOR_DECLARE dummy
	//struct pointer_to_global_geometry_list global_geometry_list = {0,NULL};
#endif

int loop_index,found_geometries;

double x_component;
double y_component;
double z_component;

struct Volume_struct this_box_volume;
struct box_storage this_box_storage;

#line 47526 "MACS_sample_kidney_box.c"
#undef number_of_activations
#undef mask_setting
#undef mask_string
#undef p_interact
#undef focus_r
#undef focus_xh
#undef focus_xw
#undef focus_ah
#undef focus_aw
#undef target_z
#undef target_y
#undef target_x
#undef target_index
#undef visualize
#undef yheight2
#undef xwidth2
#undef zdepth
#undef yheight
#undef xwidth
#undef priority
#undef material_string
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

/* User declarations for component 'channel_5_analyzer_2_array_crystal_array_3' [334]. */
#define mccompcurname  channel_5_analyzer_2_array_crystal_array_3
#define mccompcurtype  Union_box
#define mccompcurindex 334
#define loop_index mccchannel_5_analyzer_2_array_crystal_array_3_loop_index
#define this_box_volume mccchannel_5_analyzer_2_array_crystal_array_3_this_box_volume
#define global_geometry_element mccchannel_5_analyzer_2_array_crystal_array_3_global_geometry_element
#define this_box_storage mccchannel_5_analyzer_2_array_crystal_array_3_this_box_storage
#define material_string mccchannel_5_analyzer_2_array_crystal_array_3_material_string
#define priority mccchannel_5_analyzer_2_array_crystal_array_3_priority
#define xwidth mccchannel_5_analyzer_2_array_crystal_array_3_xwidth
#define yheight mccchannel_5_analyzer_2_array_crystal_array_3_yheight
#define zdepth mccchannel_5_analyzer_2_array_crystal_array_3_zdepth
#define xwidth2 mccchannel_5_analyzer_2_array_crystal_array_3_xwidth2
#define yheight2 mccchannel_5_analyzer_2_array_crystal_array_3_yheight2
#define visualize mccchannel_5_analyzer_2_array_crystal_array_3_visualize
#define target_index mccchannel_5_analyzer_2_array_crystal_array_3_target_index
#define target_x mccchannel_5_analyzer_2_array_crystal_array_3_target_x
#define target_y mccchannel_5_analyzer_2_array_crystal_array_3_target_y
#define target_z mccchannel_5_analyzer_2_array_crystal_array_3_target_z
#define focus_aw mccchannel_5_analyzer_2_array_crystal_array_3_focus_aw
#define focus_ah mccchannel_5_analyzer_2_array_crystal_array_3_focus_ah
#define focus_xw mccchannel_5_analyzer_2_array_crystal_array_3_focus_xw
#define focus_xh mccchannel_5_analyzer_2_array_crystal_array_3_focus_xh
#define focus_r mccchannel_5_analyzer_2_array_crystal_array_3_focus_r
#define p_interact mccchannel_5_analyzer_2_array_crystal_array_3_p_interact
#define mask_string mccchannel_5_analyzer_2_array_crystal_array_3_mask_string
#define mask_setting mccchannel_5_analyzer_2_array_crystal_array_3_mask_setting
#define number_of_activations mccchannel_5_analyzer_2_array_crystal_array_3_number_of_activations
#line 204 "Union_box.comp"
// Needed for transport to the main component
struct global_geometry_element_struct global_geometry_element;

#ifndef ANY_GEOMETRY_DETECTOR_DECLARE
    #define ANY_GEOMETRY_DETECTOR_DECLARE dummy
	//struct pointer_to_global_geometry_list global_geometry_list = {0,NULL};
#endif

int loop_index,found_geometries;

double x_component;
double y_component;
double z_component;

struct Volume_struct this_box_volume;
struct box_storage this_box_storage;

#line 47603 "MACS_sample_kidney_box.c"
#undef number_of_activations
#undef mask_setting
#undef mask_string
#undef p_interact
#undef focus_r
#undef focus_xh
#undef focus_xw
#undef focus_ah
#undef focus_aw
#undef target_z
#undef target_y
#undef target_x
#undef target_index
#undef visualize
#undef yheight2
#undef xwidth2
#undef zdepth
#undef yheight
#undef xwidth
#undef priority
#undef material_string
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

/* User declarations for component 'channel_5_analyzer_2_array_crystal_array_4' [335]. */
#define mccompcurname  channel_5_analyzer_2_array_crystal_array_4
#define mccompcurtype  Union_box
#define mccompcurindex 335
#define loop_index mccchannel_5_analyzer_2_array_crystal_array_4_loop_index
#define this_box_volume mccchannel_5_analyzer_2_array_crystal_array_4_this_box_volume
#define global_geometry_element mccchannel_5_analyzer_2_array_crystal_array_4_global_geometry_element
#define this_box_storage mccchannel_5_analyzer_2_array_crystal_array_4_this_box_storage
#define material_string mccchannel_5_analyzer_2_array_crystal_array_4_material_string
#define priority mccchannel_5_analyzer_2_array_crystal_array_4_priority
#define xwidth mccchannel_5_analyzer_2_array_crystal_array_4_xwidth
#define yheight mccchannel_5_analyzer_2_array_crystal_array_4_yheight
#define zdepth mccchannel_5_analyzer_2_array_crystal_array_4_zdepth
#define xwidth2 mccchannel_5_analyzer_2_array_crystal_array_4_xwidth2
#define yheight2 mccchannel_5_analyzer_2_array_crystal_array_4_yheight2
#define visualize mccchannel_5_analyzer_2_array_crystal_array_4_visualize
#define target_index mccchannel_5_analyzer_2_array_crystal_array_4_target_index
#define target_x mccchannel_5_analyzer_2_array_crystal_array_4_target_x
#define target_y mccchannel_5_analyzer_2_array_crystal_array_4_target_y
#define target_z mccchannel_5_analyzer_2_array_crystal_array_4_target_z
#define focus_aw mccchannel_5_analyzer_2_array_crystal_array_4_focus_aw
#define focus_ah mccchannel_5_analyzer_2_array_crystal_array_4_focus_ah
#define focus_xw mccchannel_5_analyzer_2_array_crystal_array_4_focus_xw
#define focus_xh mccchannel_5_analyzer_2_array_crystal_array_4_focus_xh
#define focus_r mccchannel_5_analyzer_2_array_crystal_array_4_focus_r
#define p_interact mccchannel_5_analyzer_2_array_crystal_array_4_p_interact
#define mask_string mccchannel_5_analyzer_2_array_crystal_array_4_mask_string
#define mask_setting mccchannel_5_analyzer_2_array_crystal_array_4_mask_setting
#define number_of_activations mccchannel_5_analyzer_2_array_crystal_array_4_number_of_activations
#line 204 "Union_box.comp"
// Needed for transport to the main component
struct global_geometry_element_struct global_geometry_element;

#ifndef ANY_GEOMETRY_DETECTOR_DECLARE
    #define ANY_GEOMETRY_DETECTOR_DECLARE dummy
	//struct pointer_to_global_geometry_list global_geometry_list = {0,NULL};
#endif

int loop_index,found_geometries;

double x_component;
double y_component;
double z_component;

struct Volume_struct this_box_volume;
struct box_storage this_box_storage;

#line 47680 "MACS_sample_kidney_box.c"
#undef number_of_activations
#undef mask_setting
#undef mask_string
#undef p_interact
#undef focus_r
#undef focus_xh
#undef focus_xw
#undef focus_ah
#undef focus_aw
#undef target_z
#undef target_y
#undef target_x
#undef target_index
#undef visualize
#undef yheight2
#undef xwidth2
#undef zdepth
#undef yheight
#undef xwidth
#undef priority
#undef material_string
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

/* User declarations for component 'channel_5_analyzer_2_array_crystal_array_5' [336]. */
#define mccompcurname  channel_5_analyzer_2_array_crystal_array_5
#define mccompcurtype  Union_box
#define mccompcurindex 336
#define loop_index mccchannel_5_analyzer_2_array_crystal_array_5_loop_index
#define this_box_volume mccchannel_5_analyzer_2_array_crystal_array_5_this_box_volume
#define global_geometry_element mccchannel_5_analyzer_2_array_crystal_array_5_global_geometry_element
#define this_box_storage mccchannel_5_analyzer_2_array_crystal_array_5_this_box_storage
#define material_string mccchannel_5_analyzer_2_array_crystal_array_5_material_string
#define priority mccchannel_5_analyzer_2_array_crystal_array_5_priority
#define xwidth mccchannel_5_analyzer_2_array_crystal_array_5_xwidth
#define yheight mccchannel_5_analyzer_2_array_crystal_array_5_yheight
#define zdepth mccchannel_5_analyzer_2_array_crystal_array_5_zdepth
#define xwidth2 mccchannel_5_analyzer_2_array_crystal_array_5_xwidth2
#define yheight2 mccchannel_5_analyzer_2_array_crystal_array_5_yheight2
#define visualize mccchannel_5_analyzer_2_array_crystal_array_5_visualize
#define target_index mccchannel_5_analyzer_2_array_crystal_array_5_target_index
#define target_x mccchannel_5_analyzer_2_array_crystal_array_5_target_x
#define target_y mccchannel_5_analyzer_2_array_crystal_array_5_target_y
#define target_z mccchannel_5_analyzer_2_array_crystal_array_5_target_z
#define focus_aw mccchannel_5_analyzer_2_array_crystal_array_5_focus_aw
#define focus_ah mccchannel_5_analyzer_2_array_crystal_array_5_focus_ah
#define focus_xw mccchannel_5_analyzer_2_array_crystal_array_5_focus_xw
#define focus_xh mccchannel_5_analyzer_2_array_crystal_array_5_focus_xh
#define focus_r mccchannel_5_analyzer_2_array_crystal_array_5_focus_r
#define p_interact mccchannel_5_analyzer_2_array_crystal_array_5_p_interact
#define mask_string mccchannel_5_analyzer_2_array_crystal_array_5_mask_string
#define mask_setting mccchannel_5_analyzer_2_array_crystal_array_5_mask_setting
#define number_of_activations mccchannel_5_analyzer_2_array_crystal_array_5_number_of_activations
#line 204 "Union_box.comp"
// Needed for transport to the main component
struct global_geometry_element_struct global_geometry_element;

#ifndef ANY_GEOMETRY_DETECTOR_DECLARE
    #define ANY_GEOMETRY_DETECTOR_DECLARE dummy
	//struct pointer_to_global_geometry_list global_geometry_list = {0,NULL};
#endif

int loop_index,found_geometries;

double x_component;
double y_component;
double z_component;

struct Volume_struct this_box_volume;
struct box_storage this_box_storage;

#line 47757 "MACS_sample_kidney_box.c"
#undef number_of_activations
#undef mask_setting
#undef mask_string
#undef p_interact
#undef focus_r
#undef focus_xh
#undef focus_xw
#undef focus_ah
#undef focus_aw
#undef target_z
#undef target_y
#undef target_x
#undef target_index
#undef visualize
#undef yheight2
#undef xwidth2
#undef zdepth
#undef yheight
#undef xwidth
#undef priority
#undef material_string
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

/* User declarations for component 'channel_5_analyzer_2_array_crystal_array_6' [337]. */
#define mccompcurname  channel_5_analyzer_2_array_crystal_array_6
#define mccompcurtype  Union_box
#define mccompcurindex 337
#define loop_index mccchannel_5_analyzer_2_array_crystal_array_6_loop_index
#define this_box_volume mccchannel_5_analyzer_2_array_crystal_array_6_this_box_volume
#define global_geometry_element mccchannel_5_analyzer_2_array_crystal_array_6_global_geometry_element
#define this_box_storage mccchannel_5_analyzer_2_array_crystal_array_6_this_box_storage
#define material_string mccchannel_5_analyzer_2_array_crystal_array_6_material_string
#define priority mccchannel_5_analyzer_2_array_crystal_array_6_priority
#define xwidth mccchannel_5_analyzer_2_array_crystal_array_6_xwidth
#define yheight mccchannel_5_analyzer_2_array_crystal_array_6_yheight
#define zdepth mccchannel_5_analyzer_2_array_crystal_array_6_zdepth
#define xwidth2 mccchannel_5_analyzer_2_array_crystal_array_6_xwidth2
#define yheight2 mccchannel_5_analyzer_2_array_crystal_array_6_yheight2
#define visualize mccchannel_5_analyzer_2_array_crystal_array_6_visualize
#define target_index mccchannel_5_analyzer_2_array_crystal_array_6_target_index
#define target_x mccchannel_5_analyzer_2_array_crystal_array_6_target_x
#define target_y mccchannel_5_analyzer_2_array_crystal_array_6_target_y
#define target_z mccchannel_5_analyzer_2_array_crystal_array_6_target_z
#define focus_aw mccchannel_5_analyzer_2_array_crystal_array_6_focus_aw
#define focus_ah mccchannel_5_analyzer_2_array_crystal_array_6_focus_ah
#define focus_xw mccchannel_5_analyzer_2_array_crystal_array_6_focus_xw
#define focus_xh mccchannel_5_analyzer_2_array_crystal_array_6_focus_xh
#define focus_r mccchannel_5_analyzer_2_array_crystal_array_6_focus_r
#define p_interact mccchannel_5_analyzer_2_array_crystal_array_6_p_interact
#define mask_string mccchannel_5_analyzer_2_array_crystal_array_6_mask_string
#define mask_setting mccchannel_5_analyzer_2_array_crystal_array_6_mask_setting
#define number_of_activations mccchannel_5_analyzer_2_array_crystal_array_6_number_of_activations
#line 204 "Union_box.comp"
// Needed for transport to the main component
struct global_geometry_element_struct global_geometry_element;

#ifndef ANY_GEOMETRY_DETECTOR_DECLARE
    #define ANY_GEOMETRY_DETECTOR_DECLARE dummy
	//struct pointer_to_global_geometry_list global_geometry_list = {0,NULL};
#endif

int loop_index,found_geometries;

double x_component;
double y_component;
double z_component;

struct Volume_struct this_box_volume;
struct box_storage this_box_storage;

#line 47834 "MACS_sample_kidney_box.c"
#undef number_of_activations
#undef mask_setting
#undef mask_string
#undef p_interact
#undef focus_r
#undef focus_xh
#undef focus_xw
#undef focus_ah
#undef focus_aw
#undef target_z
#undef target_y
#undef target_x
#undef target_index
#undef visualize
#undef yheight2
#undef xwidth2
#undef zdepth
#undef yheight
#undef xwidth
#undef priority
#undef material_string
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

/* User declarations for component 'channel_5_analyzer_2_array_crystal_array_7' [338]. */
#define mccompcurname  channel_5_analyzer_2_array_crystal_array_7
#define mccompcurtype  Union_box
#define mccompcurindex 338
#define loop_index mccchannel_5_analyzer_2_array_crystal_array_7_loop_index
#define this_box_volume mccchannel_5_analyzer_2_array_crystal_array_7_this_box_volume
#define global_geometry_element mccchannel_5_analyzer_2_array_crystal_array_7_global_geometry_element
#define this_box_storage mccchannel_5_analyzer_2_array_crystal_array_7_this_box_storage
#define material_string mccchannel_5_analyzer_2_array_crystal_array_7_material_string
#define priority mccchannel_5_analyzer_2_array_crystal_array_7_priority
#define xwidth mccchannel_5_analyzer_2_array_crystal_array_7_xwidth
#define yheight mccchannel_5_analyzer_2_array_crystal_array_7_yheight
#define zdepth mccchannel_5_analyzer_2_array_crystal_array_7_zdepth
#define xwidth2 mccchannel_5_analyzer_2_array_crystal_array_7_xwidth2
#define yheight2 mccchannel_5_analyzer_2_array_crystal_array_7_yheight2
#define visualize mccchannel_5_analyzer_2_array_crystal_array_7_visualize
#define target_index mccchannel_5_analyzer_2_array_crystal_array_7_target_index
#define target_x mccchannel_5_analyzer_2_array_crystal_array_7_target_x
#define target_y mccchannel_5_analyzer_2_array_crystal_array_7_target_y
#define target_z mccchannel_5_analyzer_2_array_crystal_array_7_target_z
#define focus_aw mccchannel_5_analyzer_2_array_crystal_array_7_focus_aw
#define focus_ah mccchannel_5_analyzer_2_array_crystal_array_7_focus_ah
#define focus_xw mccchannel_5_analyzer_2_array_crystal_array_7_focus_xw
#define focus_xh mccchannel_5_analyzer_2_array_crystal_array_7_focus_xh
#define focus_r mccchannel_5_analyzer_2_array_crystal_array_7_focus_r
#define p_interact mccchannel_5_analyzer_2_array_crystal_array_7_p_interact
#define mask_string mccchannel_5_analyzer_2_array_crystal_array_7_mask_string
#define mask_setting mccchannel_5_analyzer_2_array_crystal_array_7_mask_setting
#define number_of_activations mccchannel_5_analyzer_2_array_crystal_array_7_number_of_activations
#line 204 "Union_box.comp"
// Needed for transport to the main component
struct global_geometry_element_struct global_geometry_element;

#ifndef ANY_GEOMETRY_DETECTOR_DECLARE
    #define ANY_GEOMETRY_DETECTOR_DECLARE dummy
	//struct pointer_to_global_geometry_list global_geometry_list = {0,NULL};
#endif

int loop_index,found_geometries;

double x_component;
double y_component;
double z_component;

struct Volume_struct this_box_volume;
struct box_storage this_box_storage;

#line 47911 "MACS_sample_kidney_box.c"
#undef number_of_activations
#undef mask_setting
#undef mask_string
#undef p_interact
#undef focus_r
#undef focus_xh
#undef focus_xw
#undef focus_ah
#undef focus_aw
#undef target_z
#undef target_y
#undef target_x
#undef target_index
#undef visualize
#undef yheight2
#undef xwidth2
#undef zdepth
#undef yheight
#undef xwidth
#undef priority
#undef material_string
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

/* User declarations for component 'channel_5_analyzer_2_array_crystal_array_8' [339]. */
#define mccompcurname  channel_5_analyzer_2_array_crystal_array_8
#define mccompcurtype  Union_box
#define mccompcurindex 339
#define loop_index mccchannel_5_analyzer_2_array_crystal_array_8_loop_index
#define this_box_volume mccchannel_5_analyzer_2_array_crystal_array_8_this_box_volume
#define global_geometry_element mccchannel_5_analyzer_2_array_crystal_array_8_global_geometry_element
#define this_box_storage mccchannel_5_analyzer_2_array_crystal_array_8_this_box_storage
#define material_string mccchannel_5_analyzer_2_array_crystal_array_8_material_string
#define priority mccchannel_5_analyzer_2_array_crystal_array_8_priority
#define xwidth mccchannel_5_analyzer_2_array_crystal_array_8_xwidth
#define yheight mccchannel_5_analyzer_2_array_crystal_array_8_yheight
#define zdepth mccchannel_5_analyzer_2_array_crystal_array_8_zdepth
#define xwidth2 mccchannel_5_analyzer_2_array_crystal_array_8_xwidth2
#define yheight2 mccchannel_5_analyzer_2_array_crystal_array_8_yheight2
#define visualize mccchannel_5_analyzer_2_array_crystal_array_8_visualize
#define target_index mccchannel_5_analyzer_2_array_crystal_array_8_target_index
#define target_x mccchannel_5_analyzer_2_array_crystal_array_8_target_x
#define target_y mccchannel_5_analyzer_2_array_crystal_array_8_target_y
#define target_z mccchannel_5_analyzer_2_array_crystal_array_8_target_z
#define focus_aw mccchannel_5_analyzer_2_array_crystal_array_8_focus_aw
#define focus_ah mccchannel_5_analyzer_2_array_crystal_array_8_focus_ah
#define focus_xw mccchannel_5_analyzer_2_array_crystal_array_8_focus_xw
#define focus_xh mccchannel_5_analyzer_2_array_crystal_array_8_focus_xh
#define focus_r mccchannel_5_analyzer_2_array_crystal_array_8_focus_r
#define p_interact mccchannel_5_analyzer_2_array_crystal_array_8_p_interact
#define mask_string mccchannel_5_analyzer_2_array_crystal_array_8_mask_string
#define mask_setting mccchannel_5_analyzer_2_array_crystal_array_8_mask_setting
#define number_of_activations mccchannel_5_analyzer_2_array_crystal_array_8_number_of_activations
#line 204 "Union_box.comp"
// Needed for transport to the main component
struct global_geometry_element_struct global_geometry_element;

#ifndef ANY_GEOMETRY_DETECTOR_DECLARE
    #define ANY_GEOMETRY_DETECTOR_DECLARE dummy
	//struct pointer_to_global_geometry_list global_geometry_list = {0,NULL};
#endif

int loop_index,found_geometries;

double x_component;
double y_component;
double z_component;

struct Volume_struct this_box_volume;
struct box_storage this_box_storage;

#line 47988 "MACS_sample_kidney_box.c"
#undef number_of_activations
#undef mask_setting
#undef mask_string
#undef p_interact
#undef focus_r
#undef focus_xh
#undef focus_xw
#undef focus_ah
#undef focus_aw
#undef target_z
#undef target_y
#undef target_x
#undef target_index
#undef visualize
#undef yheight2
#undef xwidth2
#undef zdepth
#undef yheight
#undef xwidth
#undef priority
#undef material_string
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

/* User declarations for component 'channel_5_cave2_cyl1' [340]. */
#define mccompcurname  channel_5_cave2_cyl1
#define mccompcurtype  Union_cylinder
#define mccompcurindex 340
#define loop_index mccchannel_5_cave2_cyl1_loop_index
#define this_cylinder_volume mccchannel_5_cave2_cyl1_this_cylinder_volume
#define global_geometry_element mccchannel_5_cave2_cyl1_global_geometry_element
#define this_cylinder_storage mccchannel_5_cave2_cyl1_this_cylinder_storage
#define material_string mccchannel_5_cave2_cyl1_material_string
#define priority mccchannel_5_cave2_cyl1_priority
#define radius mccchannel_5_cave2_cyl1_radius
#define yheight mccchannel_5_cave2_cyl1_yheight
#define visualize mccchannel_5_cave2_cyl1_visualize
#define target_index mccchannel_5_cave2_cyl1_target_index
#define target_x mccchannel_5_cave2_cyl1_target_x
#define target_y mccchannel_5_cave2_cyl1_target_y
#define target_z mccchannel_5_cave2_cyl1_target_z
#define focus_aw mccchannel_5_cave2_cyl1_focus_aw
#define focus_ah mccchannel_5_cave2_cyl1_focus_ah
#define focus_xw mccchannel_5_cave2_cyl1_focus_xw
#define focus_xh mccchannel_5_cave2_cyl1_focus_xh
#define focus_r mccchannel_5_cave2_cyl1_focus_r
#define p_interact mccchannel_5_cave2_cyl1_p_interact
#define mask_string mccchannel_5_cave2_cyl1_mask_string
#define mask_setting mccchannel_5_cave2_cyl1_mask_setting
#define number_of_activations mccchannel_5_cave2_cyl1_number_of_activations
#line 167 "Union_cylinder.comp"
// Needed for transport to the main component
struct global_geometry_element_struct global_geometry_element;

#ifndef ANY_GEOMETRY_DETECTOR_DECLARE
    #define ANY_GEOMETRY_DETECTOR_DECLARE dummy
	//struct pointer_to_global_geometry_list global_geometry_list = {0,NULL};
#endif

int dummy;
int loop_index,found_geometries;
int loop_2_index;
int material_index;

struct Volume_struct this_cylinder_volume;
struct cylinder_storage this_cylinder_storage;
#line 48060 "MACS_sample_kidney_box.c"
#undef number_of_activations
#undef mask_setting
#undef mask_string
#undef p_interact
#undef focus_r
#undef focus_xh
#undef focus_xw
#undef focus_ah
#undef focus_aw
#undef target_z
#undef target_y
#undef target_x
#undef target_index
#undef visualize
#undef yheight
#undef radius
#undef priority
#undef material_string
#undef this_cylinder_storage
#undef global_geometry_element
#undef this_cylinder_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

/* User declarations for component 'channel_5_cave2_box1' [341]. */
#define mccompcurname  channel_5_cave2_box1
#define mccompcurtype  Union_box
#define mccompcurindex 341
#define loop_index mccchannel_5_cave2_box1_loop_index
#define this_box_volume mccchannel_5_cave2_box1_this_box_volume
#define global_geometry_element mccchannel_5_cave2_box1_global_geometry_element
#define this_box_storage mccchannel_5_cave2_box1_this_box_storage
#define material_string mccchannel_5_cave2_box1_material_string
#define priority mccchannel_5_cave2_box1_priority
#define xwidth mccchannel_5_cave2_box1_xwidth
#define yheight mccchannel_5_cave2_box1_yheight
#define zdepth mccchannel_5_cave2_box1_zdepth
#define xwidth2 mccchannel_5_cave2_box1_xwidth2
#define yheight2 mccchannel_5_cave2_box1_yheight2
#define visualize mccchannel_5_cave2_box1_visualize
#define target_index mccchannel_5_cave2_box1_target_index
#define target_x mccchannel_5_cave2_box1_target_x
#define target_y mccchannel_5_cave2_box1_target_y
#define target_z mccchannel_5_cave2_box1_target_z
#define focus_aw mccchannel_5_cave2_box1_focus_aw
#define focus_ah mccchannel_5_cave2_box1_focus_ah
#define focus_xw mccchannel_5_cave2_box1_focus_xw
#define focus_xh mccchannel_5_cave2_box1_focus_xh
#define focus_r mccchannel_5_cave2_box1_focus_r
#define p_interact mccchannel_5_cave2_box1_p_interact
#define mask_string mccchannel_5_cave2_box1_mask_string
#define mask_setting mccchannel_5_cave2_box1_mask_setting
#define number_of_activations mccchannel_5_cave2_box1_number_of_activations
#line 204 "Union_box.comp"
// Needed for transport to the main component
struct global_geometry_element_struct global_geometry_element;

#ifndef ANY_GEOMETRY_DETECTOR_DECLARE
    #define ANY_GEOMETRY_DETECTOR_DECLARE dummy
	//struct pointer_to_global_geometry_list global_geometry_list = {0,NULL};
#endif

int loop_index,found_geometries;

double x_component;
double y_component;
double z_component;

struct Volume_struct this_box_volume;
struct box_storage this_box_storage;

#line 48134 "MACS_sample_kidney_box.c"
#undef number_of_activations
#undef mask_setting
#undef mask_string
#undef p_interact
#undef focus_r
#undef focus_xh
#undef focus_xw
#undef focus_ah
#undef focus_aw
#undef target_z
#undef target_y
#undef target_x
#undef target_index
#undef visualize
#undef yheight2
#undef xwidth2
#undef zdepth
#undef yheight
#undef xwidth
#undef priority
#undef material_string
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

/* User declarations for component 'channel_5_cave2_box2' [342]. */
#define mccompcurname  channel_5_cave2_box2
#define mccompcurtype  Union_box
#define mccompcurindex 342
#define loop_index mccchannel_5_cave2_box2_loop_index
#define this_box_volume mccchannel_5_cave2_box2_this_box_volume
#define global_geometry_element mccchannel_5_cave2_box2_global_geometry_element
#define this_box_storage mccchannel_5_cave2_box2_this_box_storage
#define material_string mccchannel_5_cave2_box2_material_string
#define priority mccchannel_5_cave2_box2_priority
#define xwidth mccchannel_5_cave2_box2_xwidth
#define yheight mccchannel_5_cave2_box2_yheight
#define zdepth mccchannel_5_cave2_box2_zdepth
#define xwidth2 mccchannel_5_cave2_box2_xwidth2
#define yheight2 mccchannel_5_cave2_box2_yheight2
#define visualize mccchannel_5_cave2_box2_visualize
#define target_index mccchannel_5_cave2_box2_target_index
#define target_x mccchannel_5_cave2_box2_target_x
#define target_y mccchannel_5_cave2_box2_target_y
#define target_z mccchannel_5_cave2_box2_target_z
#define focus_aw mccchannel_5_cave2_box2_focus_aw
#define focus_ah mccchannel_5_cave2_box2_focus_ah
#define focus_xw mccchannel_5_cave2_box2_focus_xw
#define focus_xh mccchannel_5_cave2_box2_focus_xh
#define focus_r mccchannel_5_cave2_box2_focus_r
#define p_interact mccchannel_5_cave2_box2_p_interact
#define mask_string mccchannel_5_cave2_box2_mask_string
#define mask_setting mccchannel_5_cave2_box2_mask_setting
#define number_of_activations mccchannel_5_cave2_box2_number_of_activations
#line 204 "Union_box.comp"
// Needed for transport to the main component
struct global_geometry_element_struct global_geometry_element;

#ifndef ANY_GEOMETRY_DETECTOR_DECLARE
    #define ANY_GEOMETRY_DETECTOR_DECLARE dummy
	//struct pointer_to_global_geometry_list global_geometry_list = {0,NULL};
#endif

int loop_index,found_geometries;

double x_component;
double y_component;
double z_component;

struct Volume_struct this_box_volume;
struct box_storage this_box_storage;

#line 48211 "MACS_sample_kidney_box.c"
#undef number_of_activations
#undef mask_setting
#undef mask_string
#undef p_interact
#undef focus_r
#undef focus_xh
#undef focus_xw
#undef focus_ah
#undef focus_aw
#undef target_z
#undef target_y
#undef target_x
#undef target_index
#undef visualize
#undef yheight2
#undef xwidth2
#undef zdepth
#undef yheight
#undef xwidth
#undef priority
#undef material_string
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

/* User declarations for component 'channel_5_cave2_box3' [343]. */
#define mccompcurname  channel_5_cave2_box3
#define mccompcurtype  Union_box
#define mccompcurindex 343
#define loop_index mccchannel_5_cave2_box3_loop_index
#define this_box_volume mccchannel_5_cave2_box3_this_box_volume
#define global_geometry_element mccchannel_5_cave2_box3_global_geometry_element
#define this_box_storage mccchannel_5_cave2_box3_this_box_storage
#define material_string mccchannel_5_cave2_box3_material_string
#define priority mccchannel_5_cave2_box3_priority
#define xwidth mccchannel_5_cave2_box3_xwidth
#define yheight mccchannel_5_cave2_box3_yheight
#define zdepth mccchannel_5_cave2_box3_zdepth
#define xwidth2 mccchannel_5_cave2_box3_xwidth2
#define yheight2 mccchannel_5_cave2_box3_yheight2
#define visualize mccchannel_5_cave2_box3_visualize
#define target_index mccchannel_5_cave2_box3_target_index
#define target_x mccchannel_5_cave2_box3_target_x
#define target_y mccchannel_5_cave2_box3_target_y
#define target_z mccchannel_5_cave2_box3_target_z
#define focus_aw mccchannel_5_cave2_box3_focus_aw
#define focus_ah mccchannel_5_cave2_box3_focus_ah
#define focus_xw mccchannel_5_cave2_box3_focus_xw
#define focus_xh mccchannel_5_cave2_box3_focus_xh
#define focus_r mccchannel_5_cave2_box3_focus_r
#define p_interact mccchannel_5_cave2_box3_p_interact
#define mask_string mccchannel_5_cave2_box3_mask_string
#define mask_setting mccchannel_5_cave2_box3_mask_setting
#define number_of_activations mccchannel_5_cave2_box3_number_of_activations
#line 204 "Union_box.comp"
// Needed for transport to the main component
struct global_geometry_element_struct global_geometry_element;

#ifndef ANY_GEOMETRY_DETECTOR_DECLARE
    #define ANY_GEOMETRY_DETECTOR_DECLARE dummy
	//struct pointer_to_global_geometry_list global_geometry_list = {0,NULL};
#endif

int loop_index,found_geometries;

double x_component;
double y_component;
double z_component;

struct Volume_struct this_box_volume;
struct box_storage this_box_storage;

#line 48288 "MACS_sample_kidney_box.c"
#undef number_of_activations
#undef mask_setting
#undef mask_string
#undef p_interact
#undef focus_r
#undef focus_xh
#undef focus_xw
#undef focus_ah
#undef focus_aw
#undef target_z
#undef target_y
#undef target_x
#undef target_index
#undef visualize
#undef yheight2
#undef xwidth2
#undef zdepth
#undef yheight
#undef xwidth
#undef priority
#undef material_string
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

/* User declarations for component 'inter_analyzer_colimator_center_5' [344]. */
#define mccompcurname  inter_analyzer_colimator_center_5
#define mccompcurtype  Arm
#define mccompcurindex 344
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

/* User declarations for component 'inter_analyzer_colimator_5_blade_0' [345]. */
#define mccompcurname  inter_analyzer_colimator_5_blade_0
#define mccompcurtype  Union_box
#define mccompcurindex 345
#define loop_index mccinter_analyzer_colimator_5_blade_0_loop_index
#define this_box_volume mccinter_analyzer_colimator_5_blade_0_this_box_volume
#define global_geometry_element mccinter_analyzer_colimator_5_blade_0_global_geometry_element
#define this_box_storage mccinter_analyzer_colimator_5_blade_0_this_box_storage
#define material_string mccinter_analyzer_colimator_5_blade_0_material_string
#define priority mccinter_analyzer_colimator_5_blade_0_priority
#define xwidth mccinter_analyzer_colimator_5_blade_0_xwidth
#define yheight mccinter_analyzer_colimator_5_blade_0_yheight
#define zdepth mccinter_analyzer_colimator_5_blade_0_zdepth
#define xwidth2 mccinter_analyzer_colimator_5_blade_0_xwidth2
#define yheight2 mccinter_analyzer_colimator_5_blade_0_yheight2
#define visualize mccinter_analyzer_colimator_5_blade_0_visualize
#define target_index mccinter_analyzer_colimator_5_blade_0_target_index
#define target_x mccinter_analyzer_colimator_5_blade_0_target_x
#define target_y mccinter_analyzer_colimator_5_blade_0_target_y
#define target_z mccinter_analyzer_colimator_5_blade_0_target_z
#define focus_aw mccinter_analyzer_colimator_5_blade_0_focus_aw
#define focus_ah mccinter_analyzer_colimator_5_blade_0_focus_ah
#define focus_xw mccinter_analyzer_colimator_5_blade_0_focus_xw
#define focus_xh mccinter_analyzer_colimator_5_blade_0_focus_xh
#define focus_r mccinter_analyzer_colimator_5_blade_0_focus_r
#define p_interact mccinter_analyzer_colimator_5_blade_0_p_interact
#define mask_string mccinter_analyzer_colimator_5_blade_0_mask_string
#define mask_setting mccinter_analyzer_colimator_5_blade_0_mask_setting
#define number_of_activations mccinter_analyzer_colimator_5_blade_0_number_of_activations
#line 204 "Union_box.comp"
// Needed for transport to the main component
struct global_geometry_element_struct global_geometry_element;

#ifndef ANY_GEOMETRY_DETECTOR_DECLARE
    #define ANY_GEOMETRY_DETECTOR_DECLARE dummy
	//struct pointer_to_global_geometry_list global_geometry_list = {0,NULL};
#endif

int loop_index,found_geometries;

double x_component;
double y_component;
double z_component;

struct Volume_struct this_box_volume;
struct box_storage this_box_storage;

#line 48373 "MACS_sample_kidney_box.c"
#undef number_of_activations
#undef mask_setting
#undef mask_string
#undef p_interact
#undef focus_r
#undef focus_xh
#undef focus_xw
#undef focus_ah
#undef focus_aw
#undef target_z
#undef target_y
#undef target_x
#undef target_index
#undef visualize
#undef yheight2
#undef xwidth2
#undef zdepth
#undef yheight
#undef xwidth
#undef priority
#undef material_string
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

/* User declarations for component 'inter_analyzer_colimator_5_blade_1' [346]. */
#define mccompcurname  inter_analyzer_colimator_5_blade_1
#define mccompcurtype  Union_box
#define mccompcurindex 346
#define loop_index mccinter_analyzer_colimator_5_blade_1_loop_index
#define this_box_volume mccinter_analyzer_colimator_5_blade_1_this_box_volume
#define global_geometry_element mccinter_analyzer_colimator_5_blade_1_global_geometry_element
#define this_box_storage mccinter_analyzer_colimator_5_blade_1_this_box_storage
#define material_string mccinter_analyzer_colimator_5_blade_1_material_string
#define priority mccinter_analyzer_colimator_5_blade_1_priority
#define xwidth mccinter_analyzer_colimator_5_blade_1_xwidth
#define yheight mccinter_analyzer_colimator_5_blade_1_yheight
#define zdepth mccinter_analyzer_colimator_5_blade_1_zdepth
#define xwidth2 mccinter_analyzer_colimator_5_blade_1_xwidth2
#define yheight2 mccinter_analyzer_colimator_5_blade_1_yheight2
#define visualize mccinter_analyzer_colimator_5_blade_1_visualize
#define target_index mccinter_analyzer_colimator_5_blade_1_target_index
#define target_x mccinter_analyzer_colimator_5_blade_1_target_x
#define target_y mccinter_analyzer_colimator_5_blade_1_target_y
#define target_z mccinter_analyzer_colimator_5_blade_1_target_z
#define focus_aw mccinter_analyzer_colimator_5_blade_1_focus_aw
#define focus_ah mccinter_analyzer_colimator_5_blade_1_focus_ah
#define focus_xw mccinter_analyzer_colimator_5_blade_1_focus_xw
#define focus_xh mccinter_analyzer_colimator_5_blade_1_focus_xh
#define focus_r mccinter_analyzer_colimator_5_blade_1_focus_r
#define p_interact mccinter_analyzer_colimator_5_blade_1_p_interact
#define mask_string mccinter_analyzer_colimator_5_blade_1_mask_string
#define mask_setting mccinter_analyzer_colimator_5_blade_1_mask_setting
#define number_of_activations mccinter_analyzer_colimator_5_blade_1_number_of_activations
#line 204 "Union_box.comp"
// Needed for transport to the main component
struct global_geometry_element_struct global_geometry_element;

#ifndef ANY_GEOMETRY_DETECTOR_DECLARE
    #define ANY_GEOMETRY_DETECTOR_DECLARE dummy
	//struct pointer_to_global_geometry_list global_geometry_list = {0,NULL};
#endif

int loop_index,found_geometries;

double x_component;
double y_component;
double z_component;

struct Volume_struct this_box_volume;
struct box_storage this_box_storage;

#line 48450 "MACS_sample_kidney_box.c"
#undef number_of_activations
#undef mask_setting
#undef mask_string
#undef p_interact
#undef focus_r
#undef focus_xh
#undef focus_xw
#undef focus_ah
#undef focus_aw
#undef target_z
#undef target_y
#undef target_x
#undef target_index
#undef visualize
#undef yheight2
#undef xwidth2
#undef zdepth
#undef yheight
#undef xwidth
#undef priority
#undef material_string
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

/* User declarations for component 'inter_analyzer_colimator_5_blade_2' [347]. */
#define mccompcurname  inter_analyzer_colimator_5_blade_2
#define mccompcurtype  Union_box
#define mccompcurindex 347
#define loop_index mccinter_analyzer_colimator_5_blade_2_loop_index
#define this_box_volume mccinter_analyzer_colimator_5_blade_2_this_box_volume
#define global_geometry_element mccinter_analyzer_colimator_5_blade_2_global_geometry_element
#define this_box_storage mccinter_analyzer_colimator_5_blade_2_this_box_storage
#define material_string mccinter_analyzer_colimator_5_blade_2_material_string
#define priority mccinter_analyzer_colimator_5_blade_2_priority
#define xwidth mccinter_analyzer_colimator_5_blade_2_xwidth
#define yheight mccinter_analyzer_colimator_5_blade_2_yheight
#define zdepth mccinter_analyzer_colimator_5_blade_2_zdepth
#define xwidth2 mccinter_analyzer_colimator_5_blade_2_xwidth2
#define yheight2 mccinter_analyzer_colimator_5_blade_2_yheight2
#define visualize mccinter_analyzer_colimator_5_blade_2_visualize
#define target_index mccinter_analyzer_colimator_5_blade_2_target_index
#define target_x mccinter_analyzer_colimator_5_blade_2_target_x
#define target_y mccinter_analyzer_colimator_5_blade_2_target_y
#define target_z mccinter_analyzer_colimator_5_blade_2_target_z
#define focus_aw mccinter_analyzer_colimator_5_blade_2_focus_aw
#define focus_ah mccinter_analyzer_colimator_5_blade_2_focus_ah
#define focus_xw mccinter_analyzer_colimator_5_blade_2_focus_xw
#define focus_xh mccinter_analyzer_colimator_5_blade_2_focus_xh
#define focus_r mccinter_analyzer_colimator_5_blade_2_focus_r
#define p_interact mccinter_analyzer_colimator_5_blade_2_p_interact
#define mask_string mccinter_analyzer_colimator_5_blade_2_mask_string
#define mask_setting mccinter_analyzer_colimator_5_blade_2_mask_setting
#define number_of_activations mccinter_analyzer_colimator_5_blade_2_number_of_activations
#line 204 "Union_box.comp"
// Needed for transport to the main component
struct global_geometry_element_struct global_geometry_element;

#ifndef ANY_GEOMETRY_DETECTOR_DECLARE
    #define ANY_GEOMETRY_DETECTOR_DECLARE dummy
	//struct pointer_to_global_geometry_list global_geometry_list = {0,NULL};
#endif

int loop_index,found_geometries;

double x_component;
double y_component;
double z_component;

struct Volume_struct this_box_volume;
struct box_storage this_box_storage;

#line 48527 "MACS_sample_kidney_box.c"
#undef number_of_activations
#undef mask_setting
#undef mask_string
#undef p_interact
#undef focus_r
#undef focus_xh
#undef focus_xw
#undef focus_ah
#undef focus_aw
#undef target_z
#undef target_y
#undef target_x
#undef target_index
#undef visualize
#undef yheight2
#undef xwidth2
#undef zdepth
#undef yheight
#undef xwidth
#undef priority
#undef material_string
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

/* User declarations for component 'inter_analyzer_colimator_5_blade_3' [348]. */
#define mccompcurname  inter_analyzer_colimator_5_blade_3
#define mccompcurtype  Union_box
#define mccompcurindex 348
#define loop_index mccinter_analyzer_colimator_5_blade_3_loop_index
#define this_box_volume mccinter_analyzer_colimator_5_blade_3_this_box_volume
#define global_geometry_element mccinter_analyzer_colimator_5_blade_3_global_geometry_element
#define this_box_storage mccinter_analyzer_colimator_5_blade_3_this_box_storage
#define material_string mccinter_analyzer_colimator_5_blade_3_material_string
#define priority mccinter_analyzer_colimator_5_blade_3_priority
#define xwidth mccinter_analyzer_colimator_5_blade_3_xwidth
#define yheight mccinter_analyzer_colimator_5_blade_3_yheight
#define zdepth mccinter_analyzer_colimator_5_blade_3_zdepth
#define xwidth2 mccinter_analyzer_colimator_5_blade_3_xwidth2
#define yheight2 mccinter_analyzer_colimator_5_blade_3_yheight2
#define visualize mccinter_analyzer_colimator_5_blade_3_visualize
#define target_index mccinter_analyzer_colimator_5_blade_3_target_index
#define target_x mccinter_analyzer_colimator_5_blade_3_target_x
#define target_y mccinter_analyzer_colimator_5_blade_3_target_y
#define target_z mccinter_analyzer_colimator_5_blade_3_target_z
#define focus_aw mccinter_analyzer_colimator_5_blade_3_focus_aw
#define focus_ah mccinter_analyzer_colimator_5_blade_3_focus_ah
#define focus_xw mccinter_analyzer_colimator_5_blade_3_focus_xw
#define focus_xh mccinter_analyzer_colimator_5_blade_3_focus_xh
#define focus_r mccinter_analyzer_colimator_5_blade_3_focus_r
#define p_interact mccinter_analyzer_colimator_5_blade_3_p_interact
#define mask_string mccinter_analyzer_colimator_5_blade_3_mask_string
#define mask_setting mccinter_analyzer_colimator_5_blade_3_mask_setting
#define number_of_activations mccinter_analyzer_colimator_5_blade_3_number_of_activations
#line 204 "Union_box.comp"
// Needed for transport to the main component
struct global_geometry_element_struct global_geometry_element;

#ifndef ANY_GEOMETRY_DETECTOR_DECLARE
    #define ANY_GEOMETRY_DETECTOR_DECLARE dummy
	//struct pointer_to_global_geometry_list global_geometry_list = {0,NULL};
#endif

int loop_index,found_geometries;

double x_component;
double y_component;
double z_component;

struct Volume_struct this_box_volume;
struct box_storage this_box_storage;

#line 48604 "MACS_sample_kidney_box.c"
#undef number_of_activations
#undef mask_setting
#undef mask_string
#undef p_interact
#undef focus_r
#undef focus_xh
#undef focus_xw
#undef focus_ah
#undef focus_aw
#undef target_z
#undef target_y
#undef target_x
#undef target_index
#undef visualize
#undef yheight2
#undef xwidth2
#undef zdepth
#undef yheight
#undef xwidth
#undef priority
#undef material_string
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

/* User declarations for component 'inter_analyzer_colimator_5_blade_4' [349]. */
#define mccompcurname  inter_analyzer_colimator_5_blade_4
#define mccompcurtype  Union_box
#define mccompcurindex 349
#define loop_index mccinter_analyzer_colimator_5_blade_4_loop_index
#define this_box_volume mccinter_analyzer_colimator_5_blade_4_this_box_volume
#define global_geometry_element mccinter_analyzer_colimator_5_blade_4_global_geometry_element
#define this_box_storage mccinter_analyzer_colimator_5_blade_4_this_box_storage
#define material_string mccinter_analyzer_colimator_5_blade_4_material_string
#define priority mccinter_analyzer_colimator_5_blade_4_priority
#define xwidth mccinter_analyzer_colimator_5_blade_4_xwidth
#define yheight mccinter_analyzer_colimator_5_blade_4_yheight
#define zdepth mccinter_analyzer_colimator_5_blade_4_zdepth
#define xwidth2 mccinter_analyzer_colimator_5_blade_4_xwidth2
#define yheight2 mccinter_analyzer_colimator_5_blade_4_yheight2
#define visualize mccinter_analyzer_colimator_5_blade_4_visualize
#define target_index mccinter_analyzer_colimator_5_blade_4_target_index
#define target_x mccinter_analyzer_colimator_5_blade_4_target_x
#define target_y mccinter_analyzer_colimator_5_blade_4_target_y
#define target_z mccinter_analyzer_colimator_5_blade_4_target_z
#define focus_aw mccinter_analyzer_colimator_5_blade_4_focus_aw
#define focus_ah mccinter_analyzer_colimator_5_blade_4_focus_ah
#define focus_xw mccinter_analyzer_colimator_5_blade_4_focus_xw
#define focus_xh mccinter_analyzer_colimator_5_blade_4_focus_xh
#define focus_r mccinter_analyzer_colimator_5_blade_4_focus_r
#define p_interact mccinter_analyzer_colimator_5_blade_4_p_interact
#define mask_string mccinter_analyzer_colimator_5_blade_4_mask_string
#define mask_setting mccinter_analyzer_colimator_5_blade_4_mask_setting
#define number_of_activations mccinter_analyzer_colimator_5_blade_4_number_of_activations
#line 204 "Union_box.comp"
// Needed for transport to the main component
struct global_geometry_element_struct global_geometry_element;

#ifndef ANY_GEOMETRY_DETECTOR_DECLARE
    #define ANY_GEOMETRY_DETECTOR_DECLARE dummy
	//struct pointer_to_global_geometry_list global_geometry_list = {0,NULL};
#endif

int loop_index,found_geometries;

double x_component;
double y_component;
double z_component;

struct Volume_struct this_box_volume;
struct box_storage this_box_storage;

#line 48681 "MACS_sample_kidney_box.c"
#undef number_of_activations
#undef mask_setting
#undef mask_string
#undef p_interact
#undef focus_r
#undef focus_xh
#undef focus_xw
#undef focus_ah
#undef focus_aw
#undef target_z
#undef target_y
#undef target_x
#undef target_index
#undef visualize
#undef yheight2
#undef xwidth2
#undef zdepth
#undef yheight
#undef xwidth
#undef priority
#undef material_string
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

/* User declarations for component 'diffraction_detector_5_exit_volume' [350]. */
#define mccompcurname  diffraction_detector_5_exit_volume
#define mccompcurtype  Union_box
#define mccompcurindex 350
#define loop_index mccdiffraction_detector_5_exit_volume_loop_index
#define this_box_volume mccdiffraction_detector_5_exit_volume_this_box_volume
#define global_geometry_element mccdiffraction_detector_5_exit_volume_global_geometry_element
#define this_box_storage mccdiffraction_detector_5_exit_volume_this_box_storage
#define material_string mccdiffraction_detector_5_exit_volume_material_string
#define priority mccdiffraction_detector_5_exit_volume_priority
#define xwidth mccdiffraction_detector_5_exit_volume_xwidth
#define yheight mccdiffraction_detector_5_exit_volume_yheight
#define zdepth mccdiffraction_detector_5_exit_volume_zdepth
#define xwidth2 mccdiffraction_detector_5_exit_volume_xwidth2
#define yheight2 mccdiffraction_detector_5_exit_volume_yheight2
#define visualize mccdiffraction_detector_5_exit_volume_visualize
#define target_index mccdiffraction_detector_5_exit_volume_target_index
#define target_x mccdiffraction_detector_5_exit_volume_target_x
#define target_y mccdiffraction_detector_5_exit_volume_target_y
#define target_z mccdiffraction_detector_5_exit_volume_target_z
#define focus_aw mccdiffraction_detector_5_exit_volume_focus_aw
#define focus_ah mccdiffraction_detector_5_exit_volume_focus_ah
#define focus_xw mccdiffraction_detector_5_exit_volume_focus_xw
#define focus_xh mccdiffraction_detector_5_exit_volume_focus_xh
#define focus_r mccdiffraction_detector_5_exit_volume_focus_r
#define p_interact mccdiffraction_detector_5_exit_volume_p_interact
#define mask_string mccdiffraction_detector_5_exit_volume_mask_string
#define mask_setting mccdiffraction_detector_5_exit_volume_mask_setting
#define number_of_activations mccdiffraction_detector_5_exit_volume_number_of_activations
#line 204 "Union_box.comp"
// Needed for transport to the main component
struct global_geometry_element_struct global_geometry_element;

#ifndef ANY_GEOMETRY_DETECTOR_DECLARE
    #define ANY_GEOMETRY_DETECTOR_DECLARE dummy
	//struct pointer_to_global_geometry_list global_geometry_list = {0,NULL};
#endif

int loop_index,found_geometries;

double x_component;
double y_component;
double z_component;

struct Volume_struct this_box_volume;
struct box_storage this_box_storage;

#line 48758 "MACS_sample_kidney_box.c"
#undef number_of_activations
#undef mask_setting
#undef mask_string
#undef p_interact
#undef focus_r
#undef focus_xh
#undef focus_xw
#undef focus_ah
#undef focus_aw
#undef target_z
#undef target_y
#undef target_x
#undef target_index
#undef visualize
#undef yheight2
#undef xwidth2
#undef zdepth
#undef yheight
#undef xwidth
#undef priority
#undef material_string
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

/* User declarations for component 'spec_detector_5_exit_volume' [351]. */
#define mccompcurname  spec_detector_5_exit_volume
#define mccompcurtype  Union_box
#define mccompcurindex 351
#define loop_index mccspec_detector_5_exit_volume_loop_index
#define this_box_volume mccspec_detector_5_exit_volume_this_box_volume
#define global_geometry_element mccspec_detector_5_exit_volume_global_geometry_element
#define this_box_storage mccspec_detector_5_exit_volume_this_box_storage
#define material_string mccspec_detector_5_exit_volume_material_string
#define priority mccspec_detector_5_exit_volume_priority
#define xwidth mccspec_detector_5_exit_volume_xwidth
#define yheight mccspec_detector_5_exit_volume_yheight
#define zdepth mccspec_detector_5_exit_volume_zdepth
#define xwidth2 mccspec_detector_5_exit_volume_xwidth2
#define yheight2 mccspec_detector_5_exit_volume_yheight2
#define visualize mccspec_detector_5_exit_volume_visualize
#define target_index mccspec_detector_5_exit_volume_target_index
#define target_x mccspec_detector_5_exit_volume_target_x
#define target_y mccspec_detector_5_exit_volume_target_y
#define target_z mccspec_detector_5_exit_volume_target_z
#define focus_aw mccspec_detector_5_exit_volume_focus_aw
#define focus_ah mccspec_detector_5_exit_volume_focus_ah
#define focus_xw mccspec_detector_5_exit_volume_focus_xw
#define focus_xh mccspec_detector_5_exit_volume_focus_xh
#define focus_r mccspec_detector_5_exit_volume_focus_r
#define p_interact mccspec_detector_5_exit_volume_p_interact
#define mask_string mccspec_detector_5_exit_volume_mask_string
#define mask_setting mccspec_detector_5_exit_volume_mask_setting
#define number_of_activations mccspec_detector_5_exit_volume_number_of_activations
#line 204 "Union_box.comp"
// Needed for transport to the main component
struct global_geometry_element_struct global_geometry_element;

#ifndef ANY_GEOMETRY_DETECTOR_DECLARE
    #define ANY_GEOMETRY_DETECTOR_DECLARE dummy
	//struct pointer_to_global_geometry_list global_geometry_list = {0,NULL};
#endif

int loop_index,found_geometries;

double x_component;
double y_component;
double z_component;

struct Volume_struct this_box_volume;
struct box_storage this_box_storage;

#line 48835 "MACS_sample_kidney_box.c"
#undef number_of_activations
#undef mask_setting
#undef mask_string
#undef p_interact
#undef focus_r
#undef focus_xh
#undef focus_xw
#undef focus_ah
#undef focus_aw
#undef target_z
#undef target_y
#undef target_x
#undef target_index
#undef visualize
#undef yheight2
#undef xwidth2
#undef zdepth
#undef yheight
#undef xwidth
#undef priority
#undef material_string
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

/* User declarations for component 'channel_6_cave1_box1' [352]. */
#define mccompcurname  channel_6_cave1_box1
#define mccompcurtype  Union_box
#define mccompcurindex 352
#define loop_index mccchannel_6_cave1_box1_loop_index
#define this_box_volume mccchannel_6_cave1_box1_this_box_volume
#define global_geometry_element mccchannel_6_cave1_box1_global_geometry_element
#define this_box_storage mccchannel_6_cave1_box1_this_box_storage
#define material_string mccchannel_6_cave1_box1_material_string
#define priority mccchannel_6_cave1_box1_priority
#define xwidth mccchannel_6_cave1_box1_xwidth
#define yheight mccchannel_6_cave1_box1_yheight
#define zdepth mccchannel_6_cave1_box1_zdepth
#define xwidth2 mccchannel_6_cave1_box1_xwidth2
#define yheight2 mccchannel_6_cave1_box1_yheight2
#define visualize mccchannel_6_cave1_box1_visualize
#define target_index mccchannel_6_cave1_box1_target_index
#define target_x mccchannel_6_cave1_box1_target_x
#define target_y mccchannel_6_cave1_box1_target_y
#define target_z mccchannel_6_cave1_box1_target_z
#define focus_aw mccchannel_6_cave1_box1_focus_aw
#define focus_ah mccchannel_6_cave1_box1_focus_ah
#define focus_xw mccchannel_6_cave1_box1_focus_xw
#define focus_xh mccchannel_6_cave1_box1_focus_xh
#define focus_r mccchannel_6_cave1_box1_focus_r
#define p_interact mccchannel_6_cave1_box1_p_interact
#define mask_string mccchannel_6_cave1_box1_mask_string
#define mask_setting mccchannel_6_cave1_box1_mask_setting
#define number_of_activations mccchannel_6_cave1_box1_number_of_activations
#line 204 "Union_box.comp"
// Needed for transport to the main component
struct global_geometry_element_struct global_geometry_element;

#ifndef ANY_GEOMETRY_DETECTOR_DECLARE
    #define ANY_GEOMETRY_DETECTOR_DECLARE dummy
	//struct pointer_to_global_geometry_list global_geometry_list = {0,NULL};
#endif

int loop_index,found_geometries;

double x_component;
double y_component;
double z_component;

struct Volume_struct this_box_volume;
struct box_storage this_box_storage;

#line 48912 "MACS_sample_kidney_box.c"
#undef number_of_activations
#undef mask_setting
#undef mask_string
#undef p_interact
#undef focus_r
#undef focus_xh
#undef focus_xw
#undef focus_ah
#undef focus_aw
#undef target_z
#undef target_y
#undef target_x
#undef target_index
#undef visualize
#undef yheight2
#undef xwidth2
#undef zdepth
#undef yheight
#undef xwidth
#undef priority
#undef material_string
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

/* User declarations for component 'channel_6_cave1_box2' [353]. */
#define mccompcurname  channel_6_cave1_box2
#define mccompcurtype  Union_box
#define mccompcurindex 353
#define loop_index mccchannel_6_cave1_box2_loop_index
#define this_box_volume mccchannel_6_cave1_box2_this_box_volume
#define global_geometry_element mccchannel_6_cave1_box2_global_geometry_element
#define this_box_storage mccchannel_6_cave1_box2_this_box_storage
#define material_string mccchannel_6_cave1_box2_material_string
#define priority mccchannel_6_cave1_box2_priority
#define xwidth mccchannel_6_cave1_box2_xwidth
#define yheight mccchannel_6_cave1_box2_yheight
#define zdepth mccchannel_6_cave1_box2_zdepth
#define xwidth2 mccchannel_6_cave1_box2_xwidth2
#define yheight2 mccchannel_6_cave1_box2_yheight2
#define visualize mccchannel_6_cave1_box2_visualize
#define target_index mccchannel_6_cave1_box2_target_index
#define target_x mccchannel_6_cave1_box2_target_x
#define target_y mccchannel_6_cave1_box2_target_y
#define target_z mccchannel_6_cave1_box2_target_z
#define focus_aw mccchannel_6_cave1_box2_focus_aw
#define focus_ah mccchannel_6_cave1_box2_focus_ah
#define focus_xw mccchannel_6_cave1_box2_focus_xw
#define focus_xh mccchannel_6_cave1_box2_focus_xh
#define focus_r mccchannel_6_cave1_box2_focus_r
#define p_interact mccchannel_6_cave1_box2_p_interact
#define mask_string mccchannel_6_cave1_box2_mask_string
#define mask_setting mccchannel_6_cave1_box2_mask_setting
#define number_of_activations mccchannel_6_cave1_box2_number_of_activations
#line 204 "Union_box.comp"
// Needed for transport to the main component
struct global_geometry_element_struct global_geometry_element;

#ifndef ANY_GEOMETRY_DETECTOR_DECLARE
    #define ANY_GEOMETRY_DETECTOR_DECLARE dummy
	//struct pointer_to_global_geometry_list global_geometry_list = {0,NULL};
#endif

int loop_index,found_geometries;

double x_component;
double y_component;
double z_component;

struct Volume_struct this_box_volume;
struct box_storage this_box_storage;

#line 48989 "MACS_sample_kidney_box.c"
#undef number_of_activations
#undef mask_setting
#undef mask_string
#undef p_interact
#undef focus_r
#undef focus_xh
#undef focus_xw
#undef focus_ah
#undef focus_aw
#undef target_z
#undef target_y
#undef target_x
#undef target_index
#undef visualize
#undef yheight2
#undef xwidth2
#undef zdepth
#undef yheight
#undef xwidth
#undef priority
#undef material_string
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

/* User declarations for component 'channel_6_cave1_box3' [354]. */
#define mccompcurname  channel_6_cave1_box3
#define mccompcurtype  Union_box
#define mccompcurindex 354
#define loop_index mccchannel_6_cave1_box3_loop_index
#define this_box_volume mccchannel_6_cave1_box3_this_box_volume
#define global_geometry_element mccchannel_6_cave1_box3_global_geometry_element
#define this_box_storage mccchannel_6_cave1_box3_this_box_storage
#define material_string mccchannel_6_cave1_box3_material_string
#define priority mccchannel_6_cave1_box3_priority
#define xwidth mccchannel_6_cave1_box3_xwidth
#define yheight mccchannel_6_cave1_box3_yheight
#define zdepth mccchannel_6_cave1_box3_zdepth
#define xwidth2 mccchannel_6_cave1_box3_xwidth2
#define yheight2 mccchannel_6_cave1_box3_yheight2
#define visualize mccchannel_6_cave1_box3_visualize
#define target_index mccchannel_6_cave1_box3_target_index
#define target_x mccchannel_6_cave1_box3_target_x
#define target_y mccchannel_6_cave1_box3_target_y
#define target_z mccchannel_6_cave1_box3_target_z
#define focus_aw mccchannel_6_cave1_box3_focus_aw
#define focus_ah mccchannel_6_cave1_box3_focus_ah
#define focus_xw mccchannel_6_cave1_box3_focus_xw
#define focus_xh mccchannel_6_cave1_box3_focus_xh
#define focus_r mccchannel_6_cave1_box3_focus_r
#define p_interact mccchannel_6_cave1_box3_p_interact
#define mask_string mccchannel_6_cave1_box3_mask_string
#define mask_setting mccchannel_6_cave1_box3_mask_setting
#define number_of_activations mccchannel_6_cave1_box3_number_of_activations
#line 204 "Union_box.comp"
// Needed for transport to the main component
struct global_geometry_element_struct global_geometry_element;

#ifndef ANY_GEOMETRY_DETECTOR_DECLARE
    #define ANY_GEOMETRY_DETECTOR_DECLARE dummy
	//struct pointer_to_global_geometry_list global_geometry_list = {0,NULL};
#endif

int loop_index,found_geometries;

double x_component;
double y_component;
double z_component;

struct Volume_struct this_box_volume;
struct box_storage this_box_storage;

#line 49066 "MACS_sample_kidney_box.c"
#undef number_of_activations
#undef mask_setting
#undef mask_string
#undef p_interact
#undef focus_r
#undef focus_xh
#undef focus_xw
#undef focus_ah
#undef focus_aw
#undef target_z
#undef target_y
#undef target_x
#undef target_index
#undef visualize
#undef yheight2
#undef xwidth2
#undef zdepth
#undef yheight
#undef xwidth
#undef priority
#undef material_string
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

/* User declarations for component 'channel_6_cave1_cyl1' [355]. */
#define mccompcurname  channel_6_cave1_cyl1
#define mccompcurtype  Union_cylinder
#define mccompcurindex 355
#define loop_index mccchannel_6_cave1_cyl1_loop_index
#define this_cylinder_volume mccchannel_6_cave1_cyl1_this_cylinder_volume
#define global_geometry_element mccchannel_6_cave1_cyl1_global_geometry_element
#define this_cylinder_storage mccchannel_6_cave1_cyl1_this_cylinder_storage
#define material_string mccchannel_6_cave1_cyl1_material_string
#define priority mccchannel_6_cave1_cyl1_priority
#define radius mccchannel_6_cave1_cyl1_radius
#define yheight mccchannel_6_cave1_cyl1_yheight
#define visualize mccchannel_6_cave1_cyl1_visualize
#define target_index mccchannel_6_cave1_cyl1_target_index
#define target_x mccchannel_6_cave1_cyl1_target_x
#define target_y mccchannel_6_cave1_cyl1_target_y
#define target_z mccchannel_6_cave1_cyl1_target_z
#define focus_aw mccchannel_6_cave1_cyl1_focus_aw
#define focus_ah mccchannel_6_cave1_cyl1_focus_ah
#define focus_xw mccchannel_6_cave1_cyl1_focus_xw
#define focus_xh mccchannel_6_cave1_cyl1_focus_xh
#define focus_r mccchannel_6_cave1_cyl1_focus_r
#define p_interact mccchannel_6_cave1_cyl1_p_interact
#define mask_string mccchannel_6_cave1_cyl1_mask_string
#define mask_setting mccchannel_6_cave1_cyl1_mask_setting
#define number_of_activations mccchannel_6_cave1_cyl1_number_of_activations
#line 167 "Union_cylinder.comp"
// Needed for transport to the main component
struct global_geometry_element_struct global_geometry_element;

#ifndef ANY_GEOMETRY_DETECTOR_DECLARE
    #define ANY_GEOMETRY_DETECTOR_DECLARE dummy
	//struct pointer_to_global_geometry_list global_geometry_list = {0,NULL};
#endif

int dummy;
int loop_index,found_geometries;
int loop_2_index;
int material_index;

struct Volume_struct this_cylinder_volume;
struct cylinder_storage this_cylinder_storage;
#line 49138 "MACS_sample_kidney_box.c"
#undef number_of_activations
#undef mask_setting
#undef mask_string
#undef p_interact
#undef focus_r
#undef focus_xh
#undef focus_xw
#undef focus_ah
#undef focus_aw
#undef target_z
#undef target_y
#undef target_x
#undef target_index
#undef visualize
#undef yheight
#undef radius
#undef priority
#undef material_string
#undef this_cylinder_storage
#undef global_geometry_element
#undef this_cylinder_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

/* User declarations for component 'channel_6_analyzer_1_center' [356]. */
#define mccompcurname  channel_6_analyzer_1_center
#define mccompcurtype  Arm
#define mccompcurindex 356
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

/* User declarations for component 'channel_6_analyzer_1_rotated' [357]. */
#define mccompcurname  channel_6_analyzer_1_rotated
#define mccompcurtype  Arm
#define mccompcurindex 357
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

/* User declarations for component 'channel_6_analyzer_1_array_crystal_array_0' [358]. */
#define mccompcurname  channel_6_analyzer_1_array_crystal_array_0
#define mccompcurtype  Union_box
#define mccompcurindex 358
#define loop_index mccchannel_6_analyzer_1_array_crystal_array_0_loop_index
#define this_box_volume mccchannel_6_analyzer_1_array_crystal_array_0_this_box_volume
#define global_geometry_element mccchannel_6_analyzer_1_array_crystal_array_0_global_geometry_element
#define this_box_storage mccchannel_6_analyzer_1_array_crystal_array_0_this_box_storage
#define material_string mccchannel_6_analyzer_1_array_crystal_array_0_material_string
#define priority mccchannel_6_analyzer_1_array_crystal_array_0_priority
#define xwidth mccchannel_6_analyzer_1_array_crystal_array_0_xwidth
#define yheight mccchannel_6_analyzer_1_array_crystal_array_0_yheight
#define zdepth mccchannel_6_analyzer_1_array_crystal_array_0_zdepth
#define xwidth2 mccchannel_6_analyzer_1_array_crystal_array_0_xwidth2
#define yheight2 mccchannel_6_analyzer_1_array_crystal_array_0_yheight2
#define visualize mccchannel_6_analyzer_1_array_crystal_array_0_visualize
#define target_index mccchannel_6_analyzer_1_array_crystal_array_0_target_index
#define target_x mccchannel_6_analyzer_1_array_crystal_array_0_target_x
#define target_y mccchannel_6_analyzer_1_array_crystal_array_0_target_y
#define target_z mccchannel_6_analyzer_1_array_crystal_array_0_target_z
#define focus_aw mccchannel_6_analyzer_1_array_crystal_array_0_focus_aw
#define focus_ah mccchannel_6_analyzer_1_array_crystal_array_0_focus_ah
#define focus_xw mccchannel_6_analyzer_1_array_crystal_array_0_focus_xw
#define focus_xh mccchannel_6_analyzer_1_array_crystal_array_0_focus_xh
#define focus_r mccchannel_6_analyzer_1_array_crystal_array_0_focus_r
#define p_interact mccchannel_6_analyzer_1_array_crystal_array_0_p_interact
#define mask_string mccchannel_6_analyzer_1_array_crystal_array_0_mask_string
#define mask_setting mccchannel_6_analyzer_1_array_crystal_array_0_mask_setting
#define number_of_activations mccchannel_6_analyzer_1_array_crystal_array_0_number_of_activations
#line 204 "Union_box.comp"
// Needed for transport to the main component
struct global_geometry_element_struct global_geometry_element;

#ifndef ANY_GEOMETRY_DETECTOR_DECLARE
    #define ANY_GEOMETRY_DETECTOR_DECLARE dummy
	//struct pointer_to_global_geometry_list global_geometry_list = {0,NULL};
#endif

int loop_index,found_geometries;

double x_component;
double y_component;
double z_component;

struct Volume_struct this_box_volume;
struct box_storage this_box_storage;

#line 49228 "MACS_sample_kidney_box.c"
#undef number_of_activations
#undef mask_setting
#undef mask_string
#undef p_interact
#undef focus_r
#undef focus_xh
#undef focus_xw
#undef focus_ah
#undef focus_aw
#undef target_z
#undef target_y
#undef target_x
#undef target_index
#undef visualize
#undef yheight2
#undef xwidth2
#undef zdepth
#undef yheight
#undef xwidth
#undef priority
#undef material_string
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

/* User declarations for component 'channel_6_analyzer_1_array_crystal_array_1' [359]. */
#define mccompcurname  channel_6_analyzer_1_array_crystal_array_1
#define mccompcurtype  Union_box
#define mccompcurindex 359
#define loop_index mccchannel_6_analyzer_1_array_crystal_array_1_loop_index
#define this_box_volume mccchannel_6_analyzer_1_array_crystal_array_1_this_box_volume
#define global_geometry_element mccchannel_6_analyzer_1_array_crystal_array_1_global_geometry_element
#define this_box_storage mccchannel_6_analyzer_1_array_crystal_array_1_this_box_storage
#define material_string mccchannel_6_analyzer_1_array_crystal_array_1_material_string
#define priority mccchannel_6_analyzer_1_array_crystal_array_1_priority
#define xwidth mccchannel_6_analyzer_1_array_crystal_array_1_xwidth
#define yheight mccchannel_6_analyzer_1_array_crystal_array_1_yheight
#define zdepth mccchannel_6_analyzer_1_array_crystal_array_1_zdepth
#define xwidth2 mccchannel_6_analyzer_1_array_crystal_array_1_xwidth2
#define yheight2 mccchannel_6_analyzer_1_array_crystal_array_1_yheight2
#define visualize mccchannel_6_analyzer_1_array_crystal_array_1_visualize
#define target_index mccchannel_6_analyzer_1_array_crystal_array_1_target_index
#define target_x mccchannel_6_analyzer_1_array_crystal_array_1_target_x
#define target_y mccchannel_6_analyzer_1_array_crystal_array_1_target_y
#define target_z mccchannel_6_analyzer_1_array_crystal_array_1_target_z
#define focus_aw mccchannel_6_analyzer_1_array_crystal_array_1_focus_aw
#define focus_ah mccchannel_6_analyzer_1_array_crystal_array_1_focus_ah
#define focus_xw mccchannel_6_analyzer_1_array_crystal_array_1_focus_xw
#define focus_xh mccchannel_6_analyzer_1_array_crystal_array_1_focus_xh
#define focus_r mccchannel_6_analyzer_1_array_crystal_array_1_focus_r
#define p_interact mccchannel_6_analyzer_1_array_crystal_array_1_p_interact
#define mask_string mccchannel_6_analyzer_1_array_crystal_array_1_mask_string
#define mask_setting mccchannel_6_analyzer_1_array_crystal_array_1_mask_setting
#define number_of_activations mccchannel_6_analyzer_1_array_crystal_array_1_number_of_activations
#line 204 "Union_box.comp"
// Needed for transport to the main component
struct global_geometry_element_struct global_geometry_element;

#ifndef ANY_GEOMETRY_DETECTOR_DECLARE
    #define ANY_GEOMETRY_DETECTOR_DECLARE dummy
	//struct pointer_to_global_geometry_list global_geometry_list = {0,NULL};
#endif

int loop_index,found_geometries;

double x_component;
double y_component;
double z_component;

struct Volume_struct this_box_volume;
struct box_storage this_box_storage;

#line 49305 "MACS_sample_kidney_box.c"
#undef number_of_activations
#undef mask_setting
#undef mask_string
#undef p_interact
#undef focus_r
#undef focus_xh
#undef focus_xw
#undef focus_ah
#undef focus_aw
#undef target_z
#undef target_y
#undef target_x
#undef target_index
#undef visualize
#undef yheight2
#undef xwidth2
#undef zdepth
#undef yheight
#undef xwidth
#undef priority
#undef material_string
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

/* User declarations for component 'channel_6_analyzer_1_array_crystal_array_2' [360]. */
#define mccompcurname  channel_6_analyzer_1_array_crystal_array_2
#define mccompcurtype  Union_box
#define mccompcurindex 360
#define loop_index mccchannel_6_analyzer_1_array_crystal_array_2_loop_index
#define this_box_volume mccchannel_6_analyzer_1_array_crystal_array_2_this_box_volume
#define global_geometry_element mccchannel_6_analyzer_1_array_crystal_array_2_global_geometry_element
#define this_box_storage mccchannel_6_analyzer_1_array_crystal_array_2_this_box_storage
#define material_string mccchannel_6_analyzer_1_array_crystal_array_2_material_string
#define priority mccchannel_6_analyzer_1_array_crystal_array_2_priority
#define xwidth mccchannel_6_analyzer_1_array_crystal_array_2_xwidth
#define yheight mccchannel_6_analyzer_1_array_crystal_array_2_yheight
#define zdepth mccchannel_6_analyzer_1_array_crystal_array_2_zdepth
#define xwidth2 mccchannel_6_analyzer_1_array_crystal_array_2_xwidth2
#define yheight2 mccchannel_6_analyzer_1_array_crystal_array_2_yheight2
#define visualize mccchannel_6_analyzer_1_array_crystal_array_2_visualize
#define target_index mccchannel_6_analyzer_1_array_crystal_array_2_target_index
#define target_x mccchannel_6_analyzer_1_array_crystal_array_2_target_x
#define target_y mccchannel_6_analyzer_1_array_crystal_array_2_target_y
#define target_z mccchannel_6_analyzer_1_array_crystal_array_2_target_z
#define focus_aw mccchannel_6_analyzer_1_array_crystal_array_2_focus_aw
#define focus_ah mccchannel_6_analyzer_1_array_crystal_array_2_focus_ah
#define focus_xw mccchannel_6_analyzer_1_array_crystal_array_2_focus_xw
#define focus_xh mccchannel_6_analyzer_1_array_crystal_array_2_focus_xh
#define focus_r mccchannel_6_analyzer_1_array_crystal_array_2_focus_r
#define p_interact mccchannel_6_analyzer_1_array_crystal_array_2_p_interact
#define mask_string mccchannel_6_analyzer_1_array_crystal_array_2_mask_string
#define mask_setting mccchannel_6_analyzer_1_array_crystal_array_2_mask_setting
#define number_of_activations mccchannel_6_analyzer_1_array_crystal_array_2_number_of_activations
#line 204 "Union_box.comp"
// Needed for transport to the main component
struct global_geometry_element_struct global_geometry_element;

#ifndef ANY_GEOMETRY_DETECTOR_DECLARE
    #define ANY_GEOMETRY_DETECTOR_DECLARE dummy
	//struct pointer_to_global_geometry_list global_geometry_list = {0,NULL};
#endif

int loop_index,found_geometries;

double x_component;
double y_component;
double z_component;

struct Volume_struct this_box_volume;
struct box_storage this_box_storage;

#line 49382 "MACS_sample_kidney_box.c"
#undef number_of_activations
#undef mask_setting
#undef mask_string
#undef p_interact
#undef focus_r
#undef focus_xh
#undef focus_xw
#undef focus_ah
#undef focus_aw
#undef target_z
#undef target_y
#undef target_x
#undef target_index
#undef visualize
#undef yheight2
#undef xwidth2
#undef zdepth
#undef yheight
#undef xwidth
#undef priority
#undef material_string
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

/* User declarations for component 'channel_6_analyzer_1_array_crystal_array_3' [361]. */
#define mccompcurname  channel_6_analyzer_1_array_crystal_array_3
#define mccompcurtype  Union_box
#define mccompcurindex 361
#define loop_index mccchannel_6_analyzer_1_array_crystal_array_3_loop_index
#define this_box_volume mccchannel_6_analyzer_1_array_crystal_array_3_this_box_volume
#define global_geometry_element mccchannel_6_analyzer_1_array_crystal_array_3_global_geometry_element
#define this_box_storage mccchannel_6_analyzer_1_array_crystal_array_3_this_box_storage
#define material_string mccchannel_6_analyzer_1_array_crystal_array_3_material_string
#define priority mccchannel_6_analyzer_1_array_crystal_array_3_priority
#define xwidth mccchannel_6_analyzer_1_array_crystal_array_3_xwidth
#define yheight mccchannel_6_analyzer_1_array_crystal_array_3_yheight
#define zdepth mccchannel_6_analyzer_1_array_crystal_array_3_zdepth
#define xwidth2 mccchannel_6_analyzer_1_array_crystal_array_3_xwidth2
#define yheight2 mccchannel_6_analyzer_1_array_crystal_array_3_yheight2
#define visualize mccchannel_6_analyzer_1_array_crystal_array_3_visualize
#define target_index mccchannel_6_analyzer_1_array_crystal_array_3_target_index
#define target_x mccchannel_6_analyzer_1_array_crystal_array_3_target_x
#define target_y mccchannel_6_analyzer_1_array_crystal_array_3_target_y
#define target_z mccchannel_6_analyzer_1_array_crystal_array_3_target_z
#define focus_aw mccchannel_6_analyzer_1_array_crystal_array_3_focus_aw
#define focus_ah mccchannel_6_analyzer_1_array_crystal_array_3_focus_ah
#define focus_xw mccchannel_6_analyzer_1_array_crystal_array_3_focus_xw
#define focus_xh mccchannel_6_analyzer_1_array_crystal_array_3_focus_xh
#define focus_r mccchannel_6_analyzer_1_array_crystal_array_3_focus_r
#define p_interact mccchannel_6_analyzer_1_array_crystal_array_3_p_interact
#define mask_string mccchannel_6_analyzer_1_array_crystal_array_3_mask_string
#define mask_setting mccchannel_6_analyzer_1_array_crystal_array_3_mask_setting
#define number_of_activations mccchannel_6_analyzer_1_array_crystal_array_3_number_of_activations
#line 204 "Union_box.comp"
// Needed for transport to the main component
struct global_geometry_element_struct global_geometry_element;

#ifndef ANY_GEOMETRY_DETECTOR_DECLARE
    #define ANY_GEOMETRY_DETECTOR_DECLARE dummy
	//struct pointer_to_global_geometry_list global_geometry_list = {0,NULL};
#endif

int loop_index,found_geometries;

double x_component;
double y_component;
double z_component;

struct Volume_struct this_box_volume;
struct box_storage this_box_storage;

#line 49459 "MACS_sample_kidney_box.c"
#undef number_of_activations
#undef mask_setting
#undef mask_string
#undef p_interact
#undef focus_r
#undef focus_xh
#undef focus_xw
#undef focus_ah
#undef focus_aw
#undef target_z
#undef target_y
#undef target_x
#undef target_index
#undef visualize
#undef yheight2
#undef xwidth2
#undef zdepth
#undef yheight
#undef xwidth
#undef priority
#undef material_string
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

/* User declarations for component 'channel_6_analyzer_1_array_crystal_array_4' [362]. */
#define mccompcurname  channel_6_analyzer_1_array_crystal_array_4
#define mccompcurtype  Union_box
#define mccompcurindex 362
#define loop_index mccchannel_6_analyzer_1_array_crystal_array_4_loop_index
#define this_box_volume mccchannel_6_analyzer_1_array_crystal_array_4_this_box_volume
#define global_geometry_element mccchannel_6_analyzer_1_array_crystal_array_4_global_geometry_element
#define this_box_storage mccchannel_6_analyzer_1_array_crystal_array_4_this_box_storage
#define material_string mccchannel_6_analyzer_1_array_crystal_array_4_material_string
#define priority mccchannel_6_analyzer_1_array_crystal_array_4_priority
#define xwidth mccchannel_6_analyzer_1_array_crystal_array_4_xwidth
#define yheight mccchannel_6_analyzer_1_array_crystal_array_4_yheight
#define zdepth mccchannel_6_analyzer_1_array_crystal_array_4_zdepth
#define xwidth2 mccchannel_6_analyzer_1_array_crystal_array_4_xwidth2
#define yheight2 mccchannel_6_analyzer_1_array_crystal_array_4_yheight2
#define visualize mccchannel_6_analyzer_1_array_crystal_array_4_visualize
#define target_index mccchannel_6_analyzer_1_array_crystal_array_4_target_index
#define target_x mccchannel_6_analyzer_1_array_crystal_array_4_target_x
#define target_y mccchannel_6_analyzer_1_array_crystal_array_4_target_y
#define target_z mccchannel_6_analyzer_1_array_crystal_array_4_target_z
#define focus_aw mccchannel_6_analyzer_1_array_crystal_array_4_focus_aw
#define focus_ah mccchannel_6_analyzer_1_array_crystal_array_4_focus_ah
#define focus_xw mccchannel_6_analyzer_1_array_crystal_array_4_focus_xw
#define focus_xh mccchannel_6_analyzer_1_array_crystal_array_4_focus_xh
#define focus_r mccchannel_6_analyzer_1_array_crystal_array_4_focus_r
#define p_interact mccchannel_6_analyzer_1_array_crystal_array_4_p_interact
#define mask_string mccchannel_6_analyzer_1_array_crystal_array_4_mask_string
#define mask_setting mccchannel_6_analyzer_1_array_crystal_array_4_mask_setting
#define number_of_activations mccchannel_6_analyzer_1_array_crystal_array_4_number_of_activations
#line 204 "Union_box.comp"
// Needed for transport to the main component
struct global_geometry_element_struct global_geometry_element;

#ifndef ANY_GEOMETRY_DETECTOR_DECLARE
    #define ANY_GEOMETRY_DETECTOR_DECLARE dummy
	//struct pointer_to_global_geometry_list global_geometry_list = {0,NULL};
#endif

int loop_index,found_geometries;

double x_component;
double y_component;
double z_component;

struct Volume_struct this_box_volume;
struct box_storage this_box_storage;

#line 49536 "MACS_sample_kidney_box.c"
#undef number_of_activations
#undef mask_setting
#undef mask_string
#undef p_interact
#undef focus_r
#undef focus_xh
#undef focus_xw
#undef focus_ah
#undef focus_aw
#undef target_z
#undef target_y
#undef target_x
#undef target_index
#undef visualize
#undef yheight2
#undef xwidth2
#undef zdepth
#undef yheight
#undef xwidth
#undef priority
#undef material_string
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

/* User declarations for component 'channel_6_analyzer_1_array_crystal_array_5' [363]. */
#define mccompcurname  channel_6_analyzer_1_array_crystal_array_5
#define mccompcurtype  Union_box
#define mccompcurindex 363
#define loop_index mccchannel_6_analyzer_1_array_crystal_array_5_loop_index
#define this_box_volume mccchannel_6_analyzer_1_array_crystal_array_5_this_box_volume
#define global_geometry_element mccchannel_6_analyzer_1_array_crystal_array_5_global_geometry_element
#define this_box_storage mccchannel_6_analyzer_1_array_crystal_array_5_this_box_storage
#define material_string mccchannel_6_analyzer_1_array_crystal_array_5_material_string
#define priority mccchannel_6_analyzer_1_array_crystal_array_5_priority
#define xwidth mccchannel_6_analyzer_1_array_crystal_array_5_xwidth
#define yheight mccchannel_6_analyzer_1_array_crystal_array_5_yheight
#define zdepth mccchannel_6_analyzer_1_array_crystal_array_5_zdepth
#define xwidth2 mccchannel_6_analyzer_1_array_crystal_array_5_xwidth2
#define yheight2 mccchannel_6_analyzer_1_array_crystal_array_5_yheight2
#define visualize mccchannel_6_analyzer_1_array_crystal_array_5_visualize
#define target_index mccchannel_6_analyzer_1_array_crystal_array_5_target_index
#define target_x mccchannel_6_analyzer_1_array_crystal_array_5_target_x
#define target_y mccchannel_6_analyzer_1_array_crystal_array_5_target_y
#define target_z mccchannel_6_analyzer_1_array_crystal_array_5_target_z
#define focus_aw mccchannel_6_analyzer_1_array_crystal_array_5_focus_aw
#define focus_ah mccchannel_6_analyzer_1_array_crystal_array_5_focus_ah
#define focus_xw mccchannel_6_analyzer_1_array_crystal_array_5_focus_xw
#define focus_xh mccchannel_6_analyzer_1_array_crystal_array_5_focus_xh
#define focus_r mccchannel_6_analyzer_1_array_crystal_array_5_focus_r
#define p_interact mccchannel_6_analyzer_1_array_crystal_array_5_p_interact
#define mask_string mccchannel_6_analyzer_1_array_crystal_array_5_mask_string
#define mask_setting mccchannel_6_analyzer_1_array_crystal_array_5_mask_setting
#define number_of_activations mccchannel_6_analyzer_1_array_crystal_array_5_number_of_activations
#line 204 "Union_box.comp"
// Needed for transport to the main component
struct global_geometry_element_struct global_geometry_element;

#ifndef ANY_GEOMETRY_DETECTOR_DECLARE
    #define ANY_GEOMETRY_DETECTOR_DECLARE dummy
	//struct pointer_to_global_geometry_list global_geometry_list = {0,NULL};
#endif

int loop_index,found_geometries;

double x_component;
double y_component;
double z_component;

struct Volume_struct this_box_volume;
struct box_storage this_box_storage;

#line 49613 "MACS_sample_kidney_box.c"
#undef number_of_activations
#undef mask_setting
#undef mask_string
#undef p_interact
#undef focus_r
#undef focus_xh
#undef focus_xw
#undef focus_ah
#undef focus_aw
#undef target_z
#undef target_y
#undef target_x
#undef target_index
#undef visualize
#undef yheight2
#undef xwidth2
#undef zdepth
#undef yheight
#undef xwidth
#undef priority
#undef material_string
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

/* User declarations for component 'channel_6_analyzer_1_array_crystal_array_6' [364]. */
#define mccompcurname  channel_6_analyzer_1_array_crystal_array_6
#define mccompcurtype  Union_box
#define mccompcurindex 364
#define loop_index mccchannel_6_analyzer_1_array_crystal_array_6_loop_index
#define this_box_volume mccchannel_6_analyzer_1_array_crystal_array_6_this_box_volume
#define global_geometry_element mccchannel_6_analyzer_1_array_crystal_array_6_global_geometry_element
#define this_box_storage mccchannel_6_analyzer_1_array_crystal_array_6_this_box_storage
#define material_string mccchannel_6_analyzer_1_array_crystal_array_6_material_string
#define priority mccchannel_6_analyzer_1_array_crystal_array_6_priority
#define xwidth mccchannel_6_analyzer_1_array_crystal_array_6_xwidth
#define yheight mccchannel_6_analyzer_1_array_crystal_array_6_yheight
#define zdepth mccchannel_6_analyzer_1_array_crystal_array_6_zdepth
#define xwidth2 mccchannel_6_analyzer_1_array_crystal_array_6_xwidth2
#define yheight2 mccchannel_6_analyzer_1_array_crystal_array_6_yheight2
#define visualize mccchannel_6_analyzer_1_array_crystal_array_6_visualize
#define target_index mccchannel_6_analyzer_1_array_crystal_array_6_target_index
#define target_x mccchannel_6_analyzer_1_array_crystal_array_6_target_x
#define target_y mccchannel_6_analyzer_1_array_crystal_array_6_target_y
#define target_z mccchannel_6_analyzer_1_array_crystal_array_6_target_z
#define focus_aw mccchannel_6_analyzer_1_array_crystal_array_6_focus_aw
#define focus_ah mccchannel_6_analyzer_1_array_crystal_array_6_focus_ah
#define focus_xw mccchannel_6_analyzer_1_array_crystal_array_6_focus_xw
#define focus_xh mccchannel_6_analyzer_1_array_crystal_array_6_focus_xh
#define focus_r mccchannel_6_analyzer_1_array_crystal_array_6_focus_r
#define p_interact mccchannel_6_analyzer_1_array_crystal_array_6_p_interact
#define mask_string mccchannel_6_analyzer_1_array_crystal_array_6_mask_string
#define mask_setting mccchannel_6_analyzer_1_array_crystal_array_6_mask_setting
#define number_of_activations mccchannel_6_analyzer_1_array_crystal_array_6_number_of_activations
#line 204 "Union_box.comp"
// Needed for transport to the main component
struct global_geometry_element_struct global_geometry_element;

#ifndef ANY_GEOMETRY_DETECTOR_DECLARE
    #define ANY_GEOMETRY_DETECTOR_DECLARE dummy
	//struct pointer_to_global_geometry_list global_geometry_list = {0,NULL};
#endif

int loop_index,found_geometries;

double x_component;
double y_component;
double z_component;

struct Volume_struct this_box_volume;
struct box_storage this_box_storage;

#line 49690 "MACS_sample_kidney_box.c"
#undef number_of_activations
#undef mask_setting
#undef mask_string
#undef p_interact
#undef focus_r
#undef focus_xh
#undef focus_xw
#undef focus_ah
#undef focus_aw
#undef target_z
#undef target_y
#undef target_x
#undef target_index
#undef visualize
#undef yheight2
#undef xwidth2
#undef zdepth
#undef yheight
#undef xwidth
#undef priority
#undef material_string
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

/* User declarations for component 'channel_6_analyzer_1_array_crystal_array_7' [365]. */
#define mccompcurname  channel_6_analyzer_1_array_crystal_array_7
#define mccompcurtype  Union_box
#define mccompcurindex 365
#define loop_index mccchannel_6_analyzer_1_array_crystal_array_7_loop_index
#define this_box_volume mccchannel_6_analyzer_1_array_crystal_array_7_this_box_volume
#define global_geometry_element mccchannel_6_analyzer_1_array_crystal_array_7_global_geometry_element
#define this_box_storage mccchannel_6_analyzer_1_array_crystal_array_7_this_box_storage
#define material_string mccchannel_6_analyzer_1_array_crystal_array_7_material_string
#define priority mccchannel_6_analyzer_1_array_crystal_array_7_priority
#define xwidth mccchannel_6_analyzer_1_array_crystal_array_7_xwidth
#define yheight mccchannel_6_analyzer_1_array_crystal_array_7_yheight
#define zdepth mccchannel_6_analyzer_1_array_crystal_array_7_zdepth
#define xwidth2 mccchannel_6_analyzer_1_array_crystal_array_7_xwidth2
#define yheight2 mccchannel_6_analyzer_1_array_crystal_array_7_yheight2
#define visualize mccchannel_6_analyzer_1_array_crystal_array_7_visualize
#define target_index mccchannel_6_analyzer_1_array_crystal_array_7_target_index
#define target_x mccchannel_6_analyzer_1_array_crystal_array_7_target_x
#define target_y mccchannel_6_analyzer_1_array_crystal_array_7_target_y
#define target_z mccchannel_6_analyzer_1_array_crystal_array_7_target_z
#define focus_aw mccchannel_6_analyzer_1_array_crystal_array_7_focus_aw
#define focus_ah mccchannel_6_analyzer_1_array_crystal_array_7_focus_ah
#define focus_xw mccchannel_6_analyzer_1_array_crystal_array_7_focus_xw
#define focus_xh mccchannel_6_analyzer_1_array_crystal_array_7_focus_xh
#define focus_r mccchannel_6_analyzer_1_array_crystal_array_7_focus_r
#define p_interact mccchannel_6_analyzer_1_array_crystal_array_7_p_interact
#define mask_string mccchannel_6_analyzer_1_array_crystal_array_7_mask_string
#define mask_setting mccchannel_6_analyzer_1_array_crystal_array_7_mask_setting
#define number_of_activations mccchannel_6_analyzer_1_array_crystal_array_7_number_of_activations
#line 204 "Union_box.comp"
// Needed for transport to the main component
struct global_geometry_element_struct global_geometry_element;

#ifndef ANY_GEOMETRY_DETECTOR_DECLARE
    #define ANY_GEOMETRY_DETECTOR_DECLARE dummy
	//struct pointer_to_global_geometry_list global_geometry_list = {0,NULL};
#endif

int loop_index,found_geometries;

double x_component;
double y_component;
double z_component;

struct Volume_struct this_box_volume;
struct box_storage this_box_storage;

#line 49767 "MACS_sample_kidney_box.c"
#undef number_of_activations
#undef mask_setting
#undef mask_string
#undef p_interact
#undef focus_r
#undef focus_xh
#undef focus_xw
#undef focus_ah
#undef focus_aw
#undef target_z
#undef target_y
#undef target_x
#undef target_index
#undef visualize
#undef yheight2
#undef xwidth2
#undef zdepth
#undef yheight
#undef xwidth
#undef priority
#undef material_string
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

/* User declarations for component 'channel_6_analyzer_1_array_crystal_array_8' [366]. */
#define mccompcurname  channel_6_analyzer_1_array_crystal_array_8
#define mccompcurtype  Union_box
#define mccompcurindex 366
#define loop_index mccchannel_6_analyzer_1_array_crystal_array_8_loop_index
#define this_box_volume mccchannel_6_analyzer_1_array_crystal_array_8_this_box_volume
#define global_geometry_element mccchannel_6_analyzer_1_array_crystal_array_8_global_geometry_element
#define this_box_storage mccchannel_6_analyzer_1_array_crystal_array_8_this_box_storage
#define material_string mccchannel_6_analyzer_1_array_crystal_array_8_material_string
#define priority mccchannel_6_analyzer_1_array_crystal_array_8_priority
#define xwidth mccchannel_6_analyzer_1_array_crystal_array_8_xwidth
#define yheight mccchannel_6_analyzer_1_array_crystal_array_8_yheight
#define zdepth mccchannel_6_analyzer_1_array_crystal_array_8_zdepth
#define xwidth2 mccchannel_6_analyzer_1_array_crystal_array_8_xwidth2
#define yheight2 mccchannel_6_analyzer_1_array_crystal_array_8_yheight2
#define visualize mccchannel_6_analyzer_1_array_crystal_array_8_visualize
#define target_index mccchannel_6_analyzer_1_array_crystal_array_8_target_index
#define target_x mccchannel_6_analyzer_1_array_crystal_array_8_target_x
#define target_y mccchannel_6_analyzer_1_array_crystal_array_8_target_y
#define target_z mccchannel_6_analyzer_1_array_crystal_array_8_target_z
#define focus_aw mccchannel_6_analyzer_1_array_crystal_array_8_focus_aw
#define focus_ah mccchannel_6_analyzer_1_array_crystal_array_8_focus_ah
#define focus_xw mccchannel_6_analyzer_1_array_crystal_array_8_focus_xw
#define focus_xh mccchannel_6_analyzer_1_array_crystal_array_8_focus_xh
#define focus_r mccchannel_6_analyzer_1_array_crystal_array_8_focus_r
#define p_interact mccchannel_6_analyzer_1_array_crystal_array_8_p_interact
#define mask_string mccchannel_6_analyzer_1_array_crystal_array_8_mask_string
#define mask_setting mccchannel_6_analyzer_1_array_crystal_array_8_mask_setting
#define number_of_activations mccchannel_6_analyzer_1_array_crystal_array_8_number_of_activations
#line 204 "Union_box.comp"
// Needed for transport to the main component
struct global_geometry_element_struct global_geometry_element;

#ifndef ANY_GEOMETRY_DETECTOR_DECLARE
    #define ANY_GEOMETRY_DETECTOR_DECLARE dummy
	//struct pointer_to_global_geometry_list global_geometry_list = {0,NULL};
#endif

int loop_index,found_geometries;

double x_component;
double y_component;
double z_component;

struct Volume_struct this_box_volume;
struct box_storage this_box_storage;

#line 49844 "MACS_sample_kidney_box.c"
#undef number_of_activations
#undef mask_setting
#undef mask_string
#undef p_interact
#undef focus_r
#undef focus_xh
#undef focus_xw
#undef focus_ah
#undef focus_aw
#undef target_z
#undef target_y
#undef target_x
#undef target_index
#undef visualize
#undef yheight2
#undef xwidth2
#undef zdepth
#undef yheight
#undef xwidth
#undef priority
#undef material_string
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

/* User declarations for component 'channel_6_analyzer_2_center' [367]. */
#define mccompcurname  channel_6_analyzer_2_center
#define mccompcurtype  Arm
#define mccompcurindex 367
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

/* User declarations for component 'channel_6_analyzer_2_rotated' [368]. */
#define mccompcurname  channel_6_analyzer_2_rotated
#define mccompcurtype  Arm
#define mccompcurindex 368
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

/* User declarations for component 'channel_6_analyzer_2_array_crystal_array_0' [369]. */
#define mccompcurname  channel_6_analyzer_2_array_crystal_array_0
#define mccompcurtype  Union_box
#define mccompcurindex 369
#define loop_index mccchannel_6_analyzer_2_array_crystal_array_0_loop_index
#define this_box_volume mccchannel_6_analyzer_2_array_crystal_array_0_this_box_volume
#define global_geometry_element mccchannel_6_analyzer_2_array_crystal_array_0_global_geometry_element
#define this_box_storage mccchannel_6_analyzer_2_array_crystal_array_0_this_box_storage
#define material_string mccchannel_6_analyzer_2_array_crystal_array_0_material_string
#define priority mccchannel_6_analyzer_2_array_crystal_array_0_priority
#define xwidth mccchannel_6_analyzer_2_array_crystal_array_0_xwidth
#define yheight mccchannel_6_analyzer_2_array_crystal_array_0_yheight
#define zdepth mccchannel_6_analyzer_2_array_crystal_array_0_zdepth
#define xwidth2 mccchannel_6_analyzer_2_array_crystal_array_0_xwidth2
#define yheight2 mccchannel_6_analyzer_2_array_crystal_array_0_yheight2
#define visualize mccchannel_6_analyzer_2_array_crystal_array_0_visualize
#define target_index mccchannel_6_analyzer_2_array_crystal_array_0_target_index
#define target_x mccchannel_6_analyzer_2_array_crystal_array_0_target_x
#define target_y mccchannel_6_analyzer_2_array_crystal_array_0_target_y
#define target_z mccchannel_6_analyzer_2_array_crystal_array_0_target_z
#define focus_aw mccchannel_6_analyzer_2_array_crystal_array_0_focus_aw
#define focus_ah mccchannel_6_analyzer_2_array_crystal_array_0_focus_ah
#define focus_xw mccchannel_6_analyzer_2_array_crystal_array_0_focus_xw
#define focus_xh mccchannel_6_analyzer_2_array_crystal_array_0_focus_xh
#define focus_r mccchannel_6_analyzer_2_array_crystal_array_0_focus_r
#define p_interact mccchannel_6_analyzer_2_array_crystal_array_0_p_interact
#define mask_string mccchannel_6_analyzer_2_array_crystal_array_0_mask_string
#define mask_setting mccchannel_6_analyzer_2_array_crystal_array_0_mask_setting
#define number_of_activations mccchannel_6_analyzer_2_array_crystal_array_0_number_of_activations
#line 204 "Union_box.comp"
// Needed for transport to the main component
struct global_geometry_element_struct global_geometry_element;

#ifndef ANY_GEOMETRY_DETECTOR_DECLARE
    #define ANY_GEOMETRY_DETECTOR_DECLARE dummy
	//struct pointer_to_global_geometry_list global_geometry_list = {0,NULL};
#endif

int loop_index,found_geometries;

double x_component;
double y_component;
double z_component;

struct Volume_struct this_box_volume;
struct box_storage this_box_storage;

#line 49937 "MACS_sample_kidney_box.c"
#undef number_of_activations
#undef mask_setting
#undef mask_string
#undef p_interact
#undef focus_r
#undef focus_xh
#undef focus_xw
#undef focus_ah
#undef focus_aw
#undef target_z
#undef target_y
#undef target_x
#undef target_index
#undef visualize
#undef yheight2
#undef xwidth2
#undef zdepth
#undef yheight
#undef xwidth
#undef priority
#undef material_string
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

/* User declarations for component 'channel_6_analyzer_2_array_crystal_array_1' [370]. */
#define mccompcurname  channel_6_analyzer_2_array_crystal_array_1
#define mccompcurtype  Union_box
#define mccompcurindex 370
#define loop_index mccchannel_6_analyzer_2_array_crystal_array_1_loop_index
#define this_box_volume mccchannel_6_analyzer_2_array_crystal_array_1_this_box_volume
#define global_geometry_element mccchannel_6_analyzer_2_array_crystal_array_1_global_geometry_element
#define this_box_storage mccchannel_6_analyzer_2_array_crystal_array_1_this_box_storage
#define material_string mccchannel_6_analyzer_2_array_crystal_array_1_material_string
#define priority mccchannel_6_analyzer_2_array_crystal_array_1_priority
#define xwidth mccchannel_6_analyzer_2_array_crystal_array_1_xwidth
#define yheight mccchannel_6_analyzer_2_array_crystal_array_1_yheight
#define zdepth mccchannel_6_analyzer_2_array_crystal_array_1_zdepth
#define xwidth2 mccchannel_6_analyzer_2_array_crystal_array_1_xwidth2
#define yheight2 mccchannel_6_analyzer_2_array_crystal_array_1_yheight2
#define visualize mccchannel_6_analyzer_2_array_crystal_array_1_visualize
#define target_index mccchannel_6_analyzer_2_array_crystal_array_1_target_index
#define target_x mccchannel_6_analyzer_2_array_crystal_array_1_target_x
#define target_y mccchannel_6_analyzer_2_array_crystal_array_1_target_y
#define target_z mccchannel_6_analyzer_2_array_crystal_array_1_target_z
#define focus_aw mccchannel_6_analyzer_2_array_crystal_array_1_focus_aw
#define focus_ah mccchannel_6_analyzer_2_array_crystal_array_1_focus_ah
#define focus_xw mccchannel_6_analyzer_2_array_crystal_array_1_focus_xw
#define focus_xh mccchannel_6_analyzer_2_array_crystal_array_1_focus_xh
#define focus_r mccchannel_6_analyzer_2_array_crystal_array_1_focus_r
#define p_interact mccchannel_6_analyzer_2_array_crystal_array_1_p_interact
#define mask_string mccchannel_6_analyzer_2_array_crystal_array_1_mask_string
#define mask_setting mccchannel_6_analyzer_2_array_crystal_array_1_mask_setting
#define number_of_activations mccchannel_6_analyzer_2_array_crystal_array_1_number_of_activations
#line 204 "Union_box.comp"
// Needed for transport to the main component
struct global_geometry_element_struct global_geometry_element;

#ifndef ANY_GEOMETRY_DETECTOR_DECLARE
    #define ANY_GEOMETRY_DETECTOR_DECLARE dummy
	//struct pointer_to_global_geometry_list global_geometry_list = {0,NULL};
#endif

int loop_index,found_geometries;

double x_component;
double y_component;
double z_component;

struct Volume_struct this_box_volume;
struct box_storage this_box_storage;

#line 50014 "MACS_sample_kidney_box.c"
#undef number_of_activations
#undef mask_setting
#undef mask_string
#undef p_interact
#undef focus_r
#undef focus_xh
#undef focus_xw
#undef focus_ah
#undef focus_aw
#undef target_z
#undef target_y
#undef target_x
#undef target_index
#undef visualize
#undef yheight2
#undef xwidth2
#undef zdepth
#undef yheight
#undef xwidth
#undef priority
#undef material_string
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

/* User declarations for component 'channel_6_analyzer_2_array_crystal_array_2' [371]. */
#define mccompcurname  channel_6_analyzer_2_array_crystal_array_2
#define mccompcurtype  Union_box
#define mccompcurindex 371
#define loop_index mccchannel_6_analyzer_2_array_crystal_array_2_loop_index
#define this_box_volume mccchannel_6_analyzer_2_array_crystal_array_2_this_box_volume
#define global_geometry_element mccchannel_6_analyzer_2_array_crystal_array_2_global_geometry_element
#define this_box_storage mccchannel_6_analyzer_2_array_crystal_array_2_this_box_storage
#define material_string mccchannel_6_analyzer_2_array_crystal_array_2_material_string
#define priority mccchannel_6_analyzer_2_array_crystal_array_2_priority
#define xwidth mccchannel_6_analyzer_2_array_crystal_array_2_xwidth
#define yheight mccchannel_6_analyzer_2_array_crystal_array_2_yheight
#define zdepth mccchannel_6_analyzer_2_array_crystal_array_2_zdepth
#define xwidth2 mccchannel_6_analyzer_2_array_crystal_array_2_xwidth2
#define yheight2 mccchannel_6_analyzer_2_array_crystal_array_2_yheight2
#define visualize mccchannel_6_analyzer_2_array_crystal_array_2_visualize
#define target_index mccchannel_6_analyzer_2_array_crystal_array_2_target_index
#define target_x mccchannel_6_analyzer_2_array_crystal_array_2_target_x
#define target_y mccchannel_6_analyzer_2_array_crystal_array_2_target_y
#define target_z mccchannel_6_analyzer_2_array_crystal_array_2_target_z
#define focus_aw mccchannel_6_analyzer_2_array_crystal_array_2_focus_aw
#define focus_ah mccchannel_6_analyzer_2_array_crystal_array_2_focus_ah
#define focus_xw mccchannel_6_analyzer_2_array_crystal_array_2_focus_xw
#define focus_xh mccchannel_6_analyzer_2_array_crystal_array_2_focus_xh
#define focus_r mccchannel_6_analyzer_2_array_crystal_array_2_focus_r
#define p_interact mccchannel_6_analyzer_2_array_crystal_array_2_p_interact
#define mask_string mccchannel_6_analyzer_2_array_crystal_array_2_mask_string
#define mask_setting mccchannel_6_analyzer_2_array_crystal_array_2_mask_setting
#define number_of_activations mccchannel_6_analyzer_2_array_crystal_array_2_number_of_activations
#line 204 "Union_box.comp"
// Needed for transport to the main component
struct global_geometry_element_struct global_geometry_element;

#ifndef ANY_GEOMETRY_DETECTOR_DECLARE
    #define ANY_GEOMETRY_DETECTOR_DECLARE dummy
	//struct pointer_to_global_geometry_list global_geometry_list = {0,NULL};
#endif

int loop_index,found_geometries;

double x_component;
double y_component;
double z_component;

struct Volume_struct this_box_volume;
struct box_storage this_box_storage;

#line 50091 "MACS_sample_kidney_box.c"
#undef number_of_activations
#undef mask_setting
#undef mask_string
#undef p_interact
#undef focus_r
#undef focus_xh
#undef focus_xw
#undef focus_ah
#undef focus_aw
#undef target_z
#undef target_y
#undef target_x
#undef target_index
#undef visualize
#undef yheight2
#undef xwidth2
#undef zdepth
#undef yheight
#undef xwidth
#undef priority
#undef material_string
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

/* User declarations for component 'channel_6_analyzer_2_array_crystal_array_3' [372]. */
#define mccompcurname  channel_6_analyzer_2_array_crystal_array_3
#define mccompcurtype  Union_box
#define mccompcurindex 372
#define loop_index mccchannel_6_analyzer_2_array_crystal_array_3_loop_index
#define this_box_volume mccchannel_6_analyzer_2_array_crystal_array_3_this_box_volume
#define global_geometry_element mccchannel_6_analyzer_2_array_crystal_array_3_global_geometry_element
#define this_box_storage mccchannel_6_analyzer_2_array_crystal_array_3_this_box_storage
#define material_string mccchannel_6_analyzer_2_array_crystal_array_3_material_string
#define priority mccchannel_6_analyzer_2_array_crystal_array_3_priority
#define xwidth mccchannel_6_analyzer_2_array_crystal_array_3_xwidth
#define yheight mccchannel_6_analyzer_2_array_crystal_array_3_yheight
#define zdepth mccchannel_6_analyzer_2_array_crystal_array_3_zdepth
#define xwidth2 mccchannel_6_analyzer_2_array_crystal_array_3_xwidth2
#define yheight2 mccchannel_6_analyzer_2_array_crystal_array_3_yheight2
#define visualize mccchannel_6_analyzer_2_array_crystal_array_3_visualize
#define target_index mccchannel_6_analyzer_2_array_crystal_array_3_target_index
#define target_x mccchannel_6_analyzer_2_array_crystal_array_3_target_x
#define target_y mccchannel_6_analyzer_2_array_crystal_array_3_target_y
#define target_z mccchannel_6_analyzer_2_array_crystal_array_3_target_z
#define focus_aw mccchannel_6_analyzer_2_array_crystal_array_3_focus_aw
#define focus_ah mccchannel_6_analyzer_2_array_crystal_array_3_focus_ah
#define focus_xw mccchannel_6_analyzer_2_array_crystal_array_3_focus_xw
#define focus_xh mccchannel_6_analyzer_2_array_crystal_array_3_focus_xh
#define focus_r mccchannel_6_analyzer_2_array_crystal_array_3_focus_r
#define p_interact mccchannel_6_analyzer_2_array_crystal_array_3_p_interact
#define mask_string mccchannel_6_analyzer_2_array_crystal_array_3_mask_string
#define mask_setting mccchannel_6_analyzer_2_array_crystal_array_3_mask_setting
#define number_of_activations mccchannel_6_analyzer_2_array_crystal_array_3_number_of_activations
#line 204 "Union_box.comp"
// Needed for transport to the main component
struct global_geometry_element_struct global_geometry_element;

#ifndef ANY_GEOMETRY_DETECTOR_DECLARE
    #define ANY_GEOMETRY_DETECTOR_DECLARE dummy
	//struct pointer_to_global_geometry_list global_geometry_list = {0,NULL};
#endif

int loop_index,found_geometries;

double x_component;
double y_component;
double z_component;

struct Volume_struct this_box_volume;
struct box_storage this_box_storage;

#line 50168 "MACS_sample_kidney_box.c"
#undef number_of_activations
#undef mask_setting
#undef mask_string
#undef p_interact
#undef focus_r
#undef focus_xh
#undef focus_xw
#undef focus_ah
#undef focus_aw
#undef target_z
#undef target_y
#undef target_x
#undef target_index
#undef visualize
#undef yheight2
#undef xwidth2
#undef zdepth
#undef yheight
#undef xwidth
#undef priority
#undef material_string
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

/* User declarations for component 'channel_6_analyzer_2_array_crystal_array_4' [373]. */
#define mccompcurname  channel_6_analyzer_2_array_crystal_array_4
#define mccompcurtype  Union_box
#define mccompcurindex 373
#define loop_index mccchannel_6_analyzer_2_array_crystal_array_4_loop_index
#define this_box_volume mccchannel_6_analyzer_2_array_crystal_array_4_this_box_volume
#define global_geometry_element mccchannel_6_analyzer_2_array_crystal_array_4_global_geometry_element
#define this_box_storage mccchannel_6_analyzer_2_array_crystal_array_4_this_box_storage
#define material_string mccchannel_6_analyzer_2_array_crystal_array_4_material_string
#define priority mccchannel_6_analyzer_2_array_crystal_array_4_priority
#define xwidth mccchannel_6_analyzer_2_array_crystal_array_4_xwidth
#define yheight mccchannel_6_analyzer_2_array_crystal_array_4_yheight
#define zdepth mccchannel_6_analyzer_2_array_crystal_array_4_zdepth
#define xwidth2 mccchannel_6_analyzer_2_array_crystal_array_4_xwidth2
#define yheight2 mccchannel_6_analyzer_2_array_crystal_array_4_yheight2
#define visualize mccchannel_6_analyzer_2_array_crystal_array_4_visualize
#define target_index mccchannel_6_analyzer_2_array_crystal_array_4_target_index
#define target_x mccchannel_6_analyzer_2_array_crystal_array_4_target_x
#define target_y mccchannel_6_analyzer_2_array_crystal_array_4_target_y
#define target_z mccchannel_6_analyzer_2_array_crystal_array_4_target_z
#define focus_aw mccchannel_6_analyzer_2_array_crystal_array_4_focus_aw
#define focus_ah mccchannel_6_analyzer_2_array_crystal_array_4_focus_ah
#define focus_xw mccchannel_6_analyzer_2_array_crystal_array_4_focus_xw
#define focus_xh mccchannel_6_analyzer_2_array_crystal_array_4_focus_xh
#define focus_r mccchannel_6_analyzer_2_array_crystal_array_4_focus_r
#define p_interact mccchannel_6_analyzer_2_array_crystal_array_4_p_interact
#define mask_string mccchannel_6_analyzer_2_array_crystal_array_4_mask_string
#define mask_setting mccchannel_6_analyzer_2_array_crystal_array_4_mask_setting
#define number_of_activations mccchannel_6_analyzer_2_array_crystal_array_4_number_of_activations
#line 204 "Union_box.comp"
// Needed for transport to the main component
struct global_geometry_element_struct global_geometry_element;

#ifndef ANY_GEOMETRY_DETECTOR_DECLARE
    #define ANY_GEOMETRY_DETECTOR_DECLARE dummy
	//struct pointer_to_global_geometry_list global_geometry_list = {0,NULL};
#endif

int loop_index,found_geometries;

double x_component;
double y_component;
double z_component;

struct Volume_struct this_box_volume;
struct box_storage this_box_storage;

#line 50245 "MACS_sample_kidney_box.c"
#undef number_of_activations
#undef mask_setting
#undef mask_string
#undef p_interact
#undef focus_r
#undef focus_xh
#undef focus_xw
#undef focus_ah
#undef focus_aw
#undef target_z
#undef target_y
#undef target_x
#undef target_index
#undef visualize
#undef yheight2
#undef xwidth2
#undef zdepth
#undef yheight
#undef xwidth
#undef priority
#undef material_string
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

/* User declarations for component 'channel_6_analyzer_2_array_crystal_array_5' [374]. */
#define mccompcurname  channel_6_analyzer_2_array_crystal_array_5
#define mccompcurtype  Union_box
#define mccompcurindex 374
#define loop_index mccchannel_6_analyzer_2_array_crystal_array_5_loop_index
#define this_box_volume mccchannel_6_analyzer_2_array_crystal_array_5_this_box_volume
#define global_geometry_element mccchannel_6_analyzer_2_array_crystal_array_5_global_geometry_element
#define this_box_storage mccchannel_6_analyzer_2_array_crystal_array_5_this_box_storage
#define material_string mccchannel_6_analyzer_2_array_crystal_array_5_material_string
#define priority mccchannel_6_analyzer_2_array_crystal_array_5_priority
#define xwidth mccchannel_6_analyzer_2_array_crystal_array_5_xwidth
#define yheight mccchannel_6_analyzer_2_array_crystal_array_5_yheight
#define zdepth mccchannel_6_analyzer_2_array_crystal_array_5_zdepth
#define xwidth2 mccchannel_6_analyzer_2_array_crystal_array_5_xwidth2
#define yheight2 mccchannel_6_analyzer_2_array_crystal_array_5_yheight2
#define visualize mccchannel_6_analyzer_2_array_crystal_array_5_visualize
#define target_index mccchannel_6_analyzer_2_array_crystal_array_5_target_index
#define target_x mccchannel_6_analyzer_2_array_crystal_array_5_target_x
#define target_y mccchannel_6_analyzer_2_array_crystal_array_5_target_y
#define target_z mccchannel_6_analyzer_2_array_crystal_array_5_target_z
#define focus_aw mccchannel_6_analyzer_2_array_crystal_array_5_focus_aw
#define focus_ah mccchannel_6_analyzer_2_array_crystal_array_5_focus_ah
#define focus_xw mccchannel_6_analyzer_2_array_crystal_array_5_focus_xw
#define focus_xh mccchannel_6_analyzer_2_array_crystal_array_5_focus_xh
#define focus_r mccchannel_6_analyzer_2_array_crystal_array_5_focus_r
#define p_interact mccchannel_6_analyzer_2_array_crystal_array_5_p_interact
#define mask_string mccchannel_6_analyzer_2_array_crystal_array_5_mask_string
#define mask_setting mccchannel_6_analyzer_2_array_crystal_array_5_mask_setting
#define number_of_activations mccchannel_6_analyzer_2_array_crystal_array_5_number_of_activations
#line 204 "Union_box.comp"
// Needed for transport to the main component
struct global_geometry_element_struct global_geometry_element;

#ifndef ANY_GEOMETRY_DETECTOR_DECLARE
    #define ANY_GEOMETRY_DETECTOR_DECLARE dummy
	//struct pointer_to_global_geometry_list global_geometry_list = {0,NULL};
#endif

int loop_index,found_geometries;

double x_component;
double y_component;
double z_component;

struct Volume_struct this_box_volume;
struct box_storage this_box_storage;

#line 50322 "MACS_sample_kidney_box.c"
#undef number_of_activations
#undef mask_setting
#undef mask_string
#undef p_interact
#undef focus_r
#undef focus_xh
#undef focus_xw
#undef focus_ah
#undef focus_aw
#undef target_z
#undef target_y
#undef target_x
#undef target_index
#undef visualize
#undef yheight2
#undef xwidth2
#undef zdepth
#undef yheight
#undef xwidth
#undef priority
#undef material_string
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

/* User declarations for component 'channel_6_analyzer_2_array_crystal_array_6' [375]. */
#define mccompcurname  channel_6_analyzer_2_array_crystal_array_6
#define mccompcurtype  Union_box
#define mccompcurindex 375
#define loop_index mccchannel_6_analyzer_2_array_crystal_array_6_loop_index
#define this_box_volume mccchannel_6_analyzer_2_array_crystal_array_6_this_box_volume
#define global_geometry_element mccchannel_6_analyzer_2_array_crystal_array_6_global_geometry_element
#define this_box_storage mccchannel_6_analyzer_2_array_crystal_array_6_this_box_storage
#define material_string mccchannel_6_analyzer_2_array_crystal_array_6_material_string
#define priority mccchannel_6_analyzer_2_array_crystal_array_6_priority
#define xwidth mccchannel_6_analyzer_2_array_crystal_array_6_xwidth
#define yheight mccchannel_6_analyzer_2_array_crystal_array_6_yheight
#define zdepth mccchannel_6_analyzer_2_array_crystal_array_6_zdepth
#define xwidth2 mccchannel_6_analyzer_2_array_crystal_array_6_xwidth2
#define yheight2 mccchannel_6_analyzer_2_array_crystal_array_6_yheight2
#define visualize mccchannel_6_analyzer_2_array_crystal_array_6_visualize
#define target_index mccchannel_6_analyzer_2_array_crystal_array_6_target_index
#define target_x mccchannel_6_analyzer_2_array_crystal_array_6_target_x
#define target_y mccchannel_6_analyzer_2_array_crystal_array_6_target_y
#define target_z mccchannel_6_analyzer_2_array_crystal_array_6_target_z
#define focus_aw mccchannel_6_analyzer_2_array_crystal_array_6_focus_aw
#define focus_ah mccchannel_6_analyzer_2_array_crystal_array_6_focus_ah
#define focus_xw mccchannel_6_analyzer_2_array_crystal_array_6_focus_xw
#define focus_xh mccchannel_6_analyzer_2_array_crystal_array_6_focus_xh
#define focus_r mccchannel_6_analyzer_2_array_crystal_array_6_focus_r
#define p_interact mccchannel_6_analyzer_2_array_crystal_array_6_p_interact
#define mask_string mccchannel_6_analyzer_2_array_crystal_array_6_mask_string
#define mask_setting mccchannel_6_analyzer_2_array_crystal_array_6_mask_setting
#define number_of_activations mccchannel_6_analyzer_2_array_crystal_array_6_number_of_activations
#line 204 "Union_box.comp"
// Needed for transport to the main component
struct global_geometry_element_struct global_geometry_element;

#ifndef ANY_GEOMETRY_DETECTOR_DECLARE
    #define ANY_GEOMETRY_DETECTOR_DECLARE dummy
	//struct pointer_to_global_geometry_list global_geometry_list = {0,NULL};
#endif

int loop_index,found_geometries;

double x_component;
double y_component;
double z_component;

struct Volume_struct this_box_volume;
struct box_storage this_box_storage;

#line 50399 "MACS_sample_kidney_box.c"
#undef number_of_activations
#undef mask_setting
#undef mask_string
#undef p_interact
#undef focus_r
#undef focus_xh
#undef focus_xw
#undef focus_ah
#undef focus_aw
#undef target_z
#undef target_y
#undef target_x
#undef target_index
#undef visualize
#undef yheight2
#undef xwidth2
#undef zdepth
#undef yheight
#undef xwidth
#undef priority
#undef material_string
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

/* User declarations for component 'channel_6_analyzer_2_array_crystal_array_7' [376]. */
#define mccompcurname  channel_6_analyzer_2_array_crystal_array_7
#define mccompcurtype  Union_box
#define mccompcurindex 376
#define loop_index mccchannel_6_analyzer_2_array_crystal_array_7_loop_index
#define this_box_volume mccchannel_6_analyzer_2_array_crystal_array_7_this_box_volume
#define global_geometry_element mccchannel_6_analyzer_2_array_crystal_array_7_global_geometry_element
#define this_box_storage mccchannel_6_analyzer_2_array_crystal_array_7_this_box_storage
#define material_string mccchannel_6_analyzer_2_array_crystal_array_7_material_string
#define priority mccchannel_6_analyzer_2_array_crystal_array_7_priority
#define xwidth mccchannel_6_analyzer_2_array_crystal_array_7_xwidth
#define yheight mccchannel_6_analyzer_2_array_crystal_array_7_yheight
#define zdepth mccchannel_6_analyzer_2_array_crystal_array_7_zdepth
#define xwidth2 mccchannel_6_analyzer_2_array_crystal_array_7_xwidth2
#define yheight2 mccchannel_6_analyzer_2_array_crystal_array_7_yheight2
#define visualize mccchannel_6_analyzer_2_array_crystal_array_7_visualize
#define target_index mccchannel_6_analyzer_2_array_crystal_array_7_target_index
#define target_x mccchannel_6_analyzer_2_array_crystal_array_7_target_x
#define target_y mccchannel_6_analyzer_2_array_crystal_array_7_target_y
#define target_z mccchannel_6_analyzer_2_array_crystal_array_7_target_z
#define focus_aw mccchannel_6_analyzer_2_array_crystal_array_7_focus_aw
#define focus_ah mccchannel_6_analyzer_2_array_crystal_array_7_focus_ah
#define focus_xw mccchannel_6_analyzer_2_array_crystal_array_7_focus_xw
#define focus_xh mccchannel_6_analyzer_2_array_crystal_array_7_focus_xh
#define focus_r mccchannel_6_analyzer_2_array_crystal_array_7_focus_r
#define p_interact mccchannel_6_analyzer_2_array_crystal_array_7_p_interact
#define mask_string mccchannel_6_analyzer_2_array_crystal_array_7_mask_string
#define mask_setting mccchannel_6_analyzer_2_array_crystal_array_7_mask_setting
#define number_of_activations mccchannel_6_analyzer_2_array_crystal_array_7_number_of_activations
#line 204 "Union_box.comp"
// Needed for transport to the main component
struct global_geometry_element_struct global_geometry_element;

#ifndef ANY_GEOMETRY_DETECTOR_DECLARE
    #define ANY_GEOMETRY_DETECTOR_DECLARE dummy
	//struct pointer_to_global_geometry_list global_geometry_list = {0,NULL};
#endif

int loop_index,found_geometries;

double x_component;
double y_component;
double z_component;

struct Volume_struct this_box_volume;
struct box_storage this_box_storage;

#line 50476 "MACS_sample_kidney_box.c"
#undef number_of_activations
#undef mask_setting
#undef mask_string
#undef p_interact
#undef focus_r
#undef focus_xh
#undef focus_xw
#undef focus_ah
#undef focus_aw
#undef target_z
#undef target_y
#undef target_x
#undef target_index
#undef visualize
#undef yheight2
#undef xwidth2
#undef zdepth
#undef yheight
#undef xwidth
#undef priority
#undef material_string
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

/* User declarations for component 'channel_6_analyzer_2_array_crystal_array_8' [377]. */
#define mccompcurname  channel_6_analyzer_2_array_crystal_array_8
#define mccompcurtype  Union_box
#define mccompcurindex 377
#define loop_index mccchannel_6_analyzer_2_array_crystal_array_8_loop_index
#define this_box_volume mccchannel_6_analyzer_2_array_crystal_array_8_this_box_volume
#define global_geometry_element mccchannel_6_analyzer_2_array_crystal_array_8_global_geometry_element
#define this_box_storage mccchannel_6_analyzer_2_array_crystal_array_8_this_box_storage
#define material_string mccchannel_6_analyzer_2_array_crystal_array_8_material_string
#define priority mccchannel_6_analyzer_2_array_crystal_array_8_priority
#define xwidth mccchannel_6_analyzer_2_array_crystal_array_8_xwidth
#define yheight mccchannel_6_analyzer_2_array_crystal_array_8_yheight
#define zdepth mccchannel_6_analyzer_2_array_crystal_array_8_zdepth
#define xwidth2 mccchannel_6_analyzer_2_array_crystal_array_8_xwidth2
#define yheight2 mccchannel_6_analyzer_2_array_crystal_array_8_yheight2
#define visualize mccchannel_6_analyzer_2_array_crystal_array_8_visualize
#define target_index mccchannel_6_analyzer_2_array_crystal_array_8_target_index
#define target_x mccchannel_6_analyzer_2_array_crystal_array_8_target_x
#define target_y mccchannel_6_analyzer_2_array_crystal_array_8_target_y
#define target_z mccchannel_6_analyzer_2_array_crystal_array_8_target_z
#define focus_aw mccchannel_6_analyzer_2_array_crystal_array_8_focus_aw
#define focus_ah mccchannel_6_analyzer_2_array_crystal_array_8_focus_ah
#define focus_xw mccchannel_6_analyzer_2_array_crystal_array_8_focus_xw
#define focus_xh mccchannel_6_analyzer_2_array_crystal_array_8_focus_xh
#define focus_r mccchannel_6_analyzer_2_array_crystal_array_8_focus_r
#define p_interact mccchannel_6_analyzer_2_array_crystal_array_8_p_interact
#define mask_string mccchannel_6_analyzer_2_array_crystal_array_8_mask_string
#define mask_setting mccchannel_6_analyzer_2_array_crystal_array_8_mask_setting
#define number_of_activations mccchannel_6_analyzer_2_array_crystal_array_8_number_of_activations
#line 204 "Union_box.comp"
// Needed for transport to the main component
struct global_geometry_element_struct global_geometry_element;

#ifndef ANY_GEOMETRY_DETECTOR_DECLARE
    #define ANY_GEOMETRY_DETECTOR_DECLARE dummy
	//struct pointer_to_global_geometry_list global_geometry_list = {0,NULL};
#endif

int loop_index,found_geometries;

double x_component;
double y_component;
double z_component;

struct Volume_struct this_box_volume;
struct box_storage this_box_storage;

#line 50553 "MACS_sample_kidney_box.c"
#undef number_of_activations
#undef mask_setting
#undef mask_string
#undef p_interact
#undef focus_r
#undef focus_xh
#undef focus_xw
#undef focus_ah
#undef focus_aw
#undef target_z
#undef target_y
#undef target_x
#undef target_index
#undef visualize
#undef yheight2
#undef xwidth2
#undef zdepth
#undef yheight
#undef xwidth
#undef priority
#undef material_string
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

/* User declarations for component 'channel_6_cave2_cyl1' [378]. */
#define mccompcurname  channel_6_cave2_cyl1
#define mccompcurtype  Union_cylinder
#define mccompcurindex 378
#define loop_index mccchannel_6_cave2_cyl1_loop_index
#define this_cylinder_volume mccchannel_6_cave2_cyl1_this_cylinder_volume
#define global_geometry_element mccchannel_6_cave2_cyl1_global_geometry_element
#define this_cylinder_storage mccchannel_6_cave2_cyl1_this_cylinder_storage
#define material_string mccchannel_6_cave2_cyl1_material_string
#define priority mccchannel_6_cave2_cyl1_priority
#define radius mccchannel_6_cave2_cyl1_radius
#define yheight mccchannel_6_cave2_cyl1_yheight
#define visualize mccchannel_6_cave2_cyl1_visualize
#define target_index mccchannel_6_cave2_cyl1_target_index
#define target_x mccchannel_6_cave2_cyl1_target_x
#define target_y mccchannel_6_cave2_cyl1_target_y
#define target_z mccchannel_6_cave2_cyl1_target_z
#define focus_aw mccchannel_6_cave2_cyl1_focus_aw
#define focus_ah mccchannel_6_cave2_cyl1_focus_ah
#define focus_xw mccchannel_6_cave2_cyl1_focus_xw
#define focus_xh mccchannel_6_cave2_cyl1_focus_xh
#define focus_r mccchannel_6_cave2_cyl1_focus_r
#define p_interact mccchannel_6_cave2_cyl1_p_interact
#define mask_string mccchannel_6_cave2_cyl1_mask_string
#define mask_setting mccchannel_6_cave2_cyl1_mask_setting
#define number_of_activations mccchannel_6_cave2_cyl1_number_of_activations
#line 167 "Union_cylinder.comp"
// Needed for transport to the main component
struct global_geometry_element_struct global_geometry_element;

#ifndef ANY_GEOMETRY_DETECTOR_DECLARE
    #define ANY_GEOMETRY_DETECTOR_DECLARE dummy
	//struct pointer_to_global_geometry_list global_geometry_list = {0,NULL};
#endif

int dummy;
int loop_index,found_geometries;
int loop_2_index;
int material_index;

struct Volume_struct this_cylinder_volume;
struct cylinder_storage this_cylinder_storage;
#line 50625 "MACS_sample_kidney_box.c"
#undef number_of_activations
#undef mask_setting
#undef mask_string
#undef p_interact
#undef focus_r
#undef focus_xh
#undef focus_xw
#undef focus_ah
#undef focus_aw
#undef target_z
#undef target_y
#undef target_x
#undef target_index
#undef visualize
#undef yheight
#undef radius
#undef priority
#undef material_string
#undef this_cylinder_storage
#undef global_geometry_element
#undef this_cylinder_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

/* User declarations for component 'channel_6_cave2_box1' [379]. */
#define mccompcurname  channel_6_cave2_box1
#define mccompcurtype  Union_box
#define mccompcurindex 379
#define loop_index mccchannel_6_cave2_box1_loop_index
#define this_box_volume mccchannel_6_cave2_box1_this_box_volume
#define global_geometry_element mccchannel_6_cave2_box1_global_geometry_element
#define this_box_storage mccchannel_6_cave2_box1_this_box_storage
#define material_string mccchannel_6_cave2_box1_material_string
#define priority mccchannel_6_cave2_box1_priority
#define xwidth mccchannel_6_cave2_box1_xwidth
#define yheight mccchannel_6_cave2_box1_yheight
#define zdepth mccchannel_6_cave2_box1_zdepth
#define xwidth2 mccchannel_6_cave2_box1_xwidth2
#define yheight2 mccchannel_6_cave2_box1_yheight2
#define visualize mccchannel_6_cave2_box1_visualize
#define target_index mccchannel_6_cave2_box1_target_index
#define target_x mccchannel_6_cave2_box1_target_x
#define target_y mccchannel_6_cave2_box1_target_y
#define target_z mccchannel_6_cave2_box1_target_z
#define focus_aw mccchannel_6_cave2_box1_focus_aw
#define focus_ah mccchannel_6_cave2_box1_focus_ah
#define focus_xw mccchannel_6_cave2_box1_focus_xw
#define focus_xh mccchannel_6_cave2_box1_focus_xh
#define focus_r mccchannel_6_cave2_box1_focus_r
#define p_interact mccchannel_6_cave2_box1_p_interact
#define mask_string mccchannel_6_cave2_box1_mask_string
#define mask_setting mccchannel_6_cave2_box1_mask_setting
#define number_of_activations mccchannel_6_cave2_box1_number_of_activations
#line 204 "Union_box.comp"
// Needed for transport to the main component
struct global_geometry_element_struct global_geometry_element;

#ifndef ANY_GEOMETRY_DETECTOR_DECLARE
    #define ANY_GEOMETRY_DETECTOR_DECLARE dummy
	//struct pointer_to_global_geometry_list global_geometry_list = {0,NULL};
#endif

int loop_index,found_geometries;

double x_component;
double y_component;
double z_component;

struct Volume_struct this_box_volume;
struct box_storage this_box_storage;

#line 50699 "MACS_sample_kidney_box.c"
#undef number_of_activations
#undef mask_setting
#undef mask_string
#undef p_interact
#undef focus_r
#undef focus_xh
#undef focus_xw
#undef focus_ah
#undef focus_aw
#undef target_z
#undef target_y
#undef target_x
#undef target_index
#undef visualize
#undef yheight2
#undef xwidth2
#undef zdepth
#undef yheight
#undef xwidth
#undef priority
#undef material_string
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

/* User declarations for component 'channel_6_cave2_box2' [380]. */
#define mccompcurname  channel_6_cave2_box2
#define mccompcurtype  Union_box
#define mccompcurindex 380
#define loop_index mccchannel_6_cave2_box2_loop_index
#define this_box_volume mccchannel_6_cave2_box2_this_box_volume
#define global_geometry_element mccchannel_6_cave2_box2_global_geometry_element
#define this_box_storage mccchannel_6_cave2_box2_this_box_storage
#define material_string mccchannel_6_cave2_box2_material_string
#define priority mccchannel_6_cave2_box2_priority
#define xwidth mccchannel_6_cave2_box2_xwidth
#define yheight mccchannel_6_cave2_box2_yheight
#define zdepth mccchannel_6_cave2_box2_zdepth
#define xwidth2 mccchannel_6_cave2_box2_xwidth2
#define yheight2 mccchannel_6_cave2_box2_yheight2
#define visualize mccchannel_6_cave2_box2_visualize
#define target_index mccchannel_6_cave2_box2_target_index
#define target_x mccchannel_6_cave2_box2_target_x
#define target_y mccchannel_6_cave2_box2_target_y
#define target_z mccchannel_6_cave2_box2_target_z
#define focus_aw mccchannel_6_cave2_box2_focus_aw
#define focus_ah mccchannel_6_cave2_box2_focus_ah
#define focus_xw mccchannel_6_cave2_box2_focus_xw
#define focus_xh mccchannel_6_cave2_box2_focus_xh
#define focus_r mccchannel_6_cave2_box2_focus_r
#define p_interact mccchannel_6_cave2_box2_p_interact
#define mask_string mccchannel_6_cave2_box2_mask_string
#define mask_setting mccchannel_6_cave2_box2_mask_setting
#define number_of_activations mccchannel_6_cave2_box2_number_of_activations
#line 204 "Union_box.comp"
// Needed for transport to the main component
struct global_geometry_element_struct global_geometry_element;

#ifndef ANY_GEOMETRY_DETECTOR_DECLARE
    #define ANY_GEOMETRY_DETECTOR_DECLARE dummy
	//struct pointer_to_global_geometry_list global_geometry_list = {0,NULL};
#endif

int loop_index,found_geometries;

double x_component;
double y_component;
double z_component;

struct Volume_struct this_box_volume;
struct box_storage this_box_storage;

#line 50776 "MACS_sample_kidney_box.c"
#undef number_of_activations
#undef mask_setting
#undef mask_string
#undef p_interact
#undef focus_r
#undef focus_xh
#undef focus_xw
#undef focus_ah
#undef focus_aw
#undef target_z
#undef target_y
#undef target_x
#undef target_index
#undef visualize
#undef yheight2
#undef xwidth2
#undef zdepth
#undef yheight
#undef xwidth
#undef priority
#undef material_string
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

/* User declarations for component 'channel_6_cave2_box3' [381]. */
#define mccompcurname  channel_6_cave2_box3
#define mccompcurtype  Union_box
#define mccompcurindex 381
#define loop_index mccchannel_6_cave2_box3_loop_index
#define this_box_volume mccchannel_6_cave2_box3_this_box_volume
#define global_geometry_element mccchannel_6_cave2_box3_global_geometry_element
#define this_box_storage mccchannel_6_cave2_box3_this_box_storage
#define material_string mccchannel_6_cave2_box3_material_string
#define priority mccchannel_6_cave2_box3_priority
#define xwidth mccchannel_6_cave2_box3_xwidth
#define yheight mccchannel_6_cave2_box3_yheight
#define zdepth mccchannel_6_cave2_box3_zdepth
#define xwidth2 mccchannel_6_cave2_box3_xwidth2
#define yheight2 mccchannel_6_cave2_box3_yheight2
#define visualize mccchannel_6_cave2_box3_visualize
#define target_index mccchannel_6_cave2_box3_target_index
#define target_x mccchannel_6_cave2_box3_target_x
#define target_y mccchannel_6_cave2_box3_target_y
#define target_z mccchannel_6_cave2_box3_target_z
#define focus_aw mccchannel_6_cave2_box3_focus_aw
#define focus_ah mccchannel_6_cave2_box3_focus_ah
#define focus_xw mccchannel_6_cave2_box3_focus_xw
#define focus_xh mccchannel_6_cave2_box3_focus_xh
#define focus_r mccchannel_6_cave2_box3_focus_r
#define p_interact mccchannel_6_cave2_box3_p_interact
#define mask_string mccchannel_6_cave2_box3_mask_string
#define mask_setting mccchannel_6_cave2_box3_mask_setting
#define number_of_activations mccchannel_6_cave2_box3_number_of_activations
#line 204 "Union_box.comp"
// Needed for transport to the main component
struct global_geometry_element_struct global_geometry_element;

#ifndef ANY_GEOMETRY_DETECTOR_DECLARE
    #define ANY_GEOMETRY_DETECTOR_DECLARE dummy
	//struct pointer_to_global_geometry_list global_geometry_list = {0,NULL};
#endif

int loop_index,found_geometries;

double x_component;
double y_component;
double z_component;

struct Volume_struct this_box_volume;
struct box_storage this_box_storage;

#line 50853 "MACS_sample_kidney_box.c"
#undef number_of_activations
#undef mask_setting
#undef mask_string
#undef p_interact
#undef focus_r
#undef focus_xh
#undef focus_xw
#undef focus_ah
#undef focus_aw
#undef target_z
#undef target_y
#undef target_x
#undef target_index
#undef visualize
#undef yheight2
#undef xwidth2
#undef zdepth
#undef yheight
#undef xwidth
#undef priority
#undef material_string
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

/* User declarations for component 'inter_analyzer_colimator_center_6' [382]. */
#define mccompcurname  inter_analyzer_colimator_center_6
#define mccompcurtype  Arm
#define mccompcurindex 382
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

/* User declarations for component 'inter_analyzer_colimator_6_blade_0' [383]. */
#define mccompcurname  inter_analyzer_colimator_6_blade_0
#define mccompcurtype  Union_box
#define mccompcurindex 383
#define loop_index mccinter_analyzer_colimator_6_blade_0_loop_index
#define this_box_volume mccinter_analyzer_colimator_6_blade_0_this_box_volume
#define global_geometry_element mccinter_analyzer_colimator_6_blade_0_global_geometry_element
#define this_box_storage mccinter_analyzer_colimator_6_blade_0_this_box_storage
#define material_string mccinter_analyzer_colimator_6_blade_0_material_string
#define priority mccinter_analyzer_colimator_6_blade_0_priority
#define xwidth mccinter_analyzer_colimator_6_blade_0_xwidth
#define yheight mccinter_analyzer_colimator_6_blade_0_yheight
#define zdepth mccinter_analyzer_colimator_6_blade_0_zdepth
#define xwidth2 mccinter_analyzer_colimator_6_blade_0_xwidth2
#define yheight2 mccinter_analyzer_colimator_6_blade_0_yheight2
#define visualize mccinter_analyzer_colimator_6_blade_0_visualize
#define target_index mccinter_analyzer_colimator_6_blade_0_target_index
#define target_x mccinter_analyzer_colimator_6_blade_0_target_x
#define target_y mccinter_analyzer_colimator_6_blade_0_target_y
#define target_z mccinter_analyzer_colimator_6_blade_0_target_z
#define focus_aw mccinter_analyzer_colimator_6_blade_0_focus_aw
#define focus_ah mccinter_analyzer_colimator_6_blade_0_focus_ah
#define focus_xw mccinter_analyzer_colimator_6_blade_0_focus_xw
#define focus_xh mccinter_analyzer_colimator_6_blade_0_focus_xh
#define focus_r mccinter_analyzer_colimator_6_blade_0_focus_r
#define p_interact mccinter_analyzer_colimator_6_blade_0_p_interact
#define mask_string mccinter_analyzer_colimator_6_blade_0_mask_string
#define mask_setting mccinter_analyzer_colimator_6_blade_0_mask_setting
#define number_of_activations mccinter_analyzer_colimator_6_blade_0_number_of_activations
#line 204 "Union_box.comp"
// Needed for transport to the main component
struct global_geometry_element_struct global_geometry_element;

#ifndef ANY_GEOMETRY_DETECTOR_DECLARE
    #define ANY_GEOMETRY_DETECTOR_DECLARE dummy
	//struct pointer_to_global_geometry_list global_geometry_list = {0,NULL};
#endif

int loop_index,found_geometries;

double x_component;
double y_component;
double z_component;

struct Volume_struct this_box_volume;
struct box_storage this_box_storage;

#line 50938 "MACS_sample_kidney_box.c"
#undef number_of_activations
#undef mask_setting
#undef mask_string
#undef p_interact
#undef focus_r
#undef focus_xh
#undef focus_xw
#undef focus_ah
#undef focus_aw
#undef target_z
#undef target_y
#undef target_x
#undef target_index
#undef visualize
#undef yheight2
#undef xwidth2
#undef zdepth
#undef yheight
#undef xwidth
#undef priority
#undef material_string
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

/* User declarations for component 'inter_analyzer_colimator_6_blade_1' [384]. */
#define mccompcurname  inter_analyzer_colimator_6_blade_1
#define mccompcurtype  Union_box
#define mccompcurindex 384
#define loop_index mccinter_analyzer_colimator_6_blade_1_loop_index
#define this_box_volume mccinter_analyzer_colimator_6_blade_1_this_box_volume
#define global_geometry_element mccinter_analyzer_colimator_6_blade_1_global_geometry_element
#define this_box_storage mccinter_analyzer_colimator_6_blade_1_this_box_storage
#define material_string mccinter_analyzer_colimator_6_blade_1_material_string
#define priority mccinter_analyzer_colimator_6_blade_1_priority
#define xwidth mccinter_analyzer_colimator_6_blade_1_xwidth
#define yheight mccinter_analyzer_colimator_6_blade_1_yheight
#define zdepth mccinter_analyzer_colimator_6_blade_1_zdepth
#define xwidth2 mccinter_analyzer_colimator_6_blade_1_xwidth2
#define yheight2 mccinter_analyzer_colimator_6_blade_1_yheight2
#define visualize mccinter_analyzer_colimator_6_blade_1_visualize
#define target_index mccinter_analyzer_colimator_6_blade_1_target_index
#define target_x mccinter_analyzer_colimator_6_blade_1_target_x
#define target_y mccinter_analyzer_colimator_6_blade_1_target_y
#define target_z mccinter_analyzer_colimator_6_blade_1_target_z
#define focus_aw mccinter_analyzer_colimator_6_blade_1_focus_aw
#define focus_ah mccinter_analyzer_colimator_6_blade_1_focus_ah
#define focus_xw mccinter_analyzer_colimator_6_blade_1_focus_xw
#define focus_xh mccinter_analyzer_colimator_6_blade_1_focus_xh
#define focus_r mccinter_analyzer_colimator_6_blade_1_focus_r
#define p_interact mccinter_analyzer_colimator_6_blade_1_p_interact
#define mask_string mccinter_analyzer_colimator_6_blade_1_mask_string
#define mask_setting mccinter_analyzer_colimator_6_blade_1_mask_setting
#define number_of_activations mccinter_analyzer_colimator_6_blade_1_number_of_activations
#line 204 "Union_box.comp"
// Needed for transport to the main component
struct global_geometry_element_struct global_geometry_element;

#ifndef ANY_GEOMETRY_DETECTOR_DECLARE
    #define ANY_GEOMETRY_DETECTOR_DECLARE dummy
	//struct pointer_to_global_geometry_list global_geometry_list = {0,NULL};
#endif

int loop_index,found_geometries;

double x_component;
double y_component;
double z_component;

struct Volume_struct this_box_volume;
struct box_storage this_box_storage;

#line 51015 "MACS_sample_kidney_box.c"
#undef number_of_activations
#undef mask_setting
#undef mask_string
#undef p_interact
#undef focus_r
#undef focus_xh
#undef focus_xw
#undef focus_ah
#undef focus_aw
#undef target_z
#undef target_y
#undef target_x
#undef target_index
#undef visualize
#undef yheight2
#undef xwidth2
#undef zdepth
#undef yheight
#undef xwidth
#undef priority
#undef material_string
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

/* User declarations for component 'inter_analyzer_colimator_6_blade_2' [385]. */
#define mccompcurname  inter_analyzer_colimator_6_blade_2
#define mccompcurtype  Union_box
#define mccompcurindex 385
#define loop_index mccinter_analyzer_colimator_6_blade_2_loop_index
#define this_box_volume mccinter_analyzer_colimator_6_blade_2_this_box_volume
#define global_geometry_element mccinter_analyzer_colimator_6_blade_2_global_geometry_element
#define this_box_storage mccinter_analyzer_colimator_6_blade_2_this_box_storage
#define material_string mccinter_analyzer_colimator_6_blade_2_material_string
#define priority mccinter_analyzer_colimator_6_blade_2_priority
#define xwidth mccinter_analyzer_colimator_6_blade_2_xwidth
#define yheight mccinter_analyzer_colimator_6_blade_2_yheight
#define zdepth mccinter_analyzer_colimator_6_blade_2_zdepth
#define xwidth2 mccinter_analyzer_colimator_6_blade_2_xwidth2
#define yheight2 mccinter_analyzer_colimator_6_blade_2_yheight2
#define visualize mccinter_analyzer_colimator_6_blade_2_visualize
#define target_index mccinter_analyzer_colimator_6_blade_2_target_index
#define target_x mccinter_analyzer_colimator_6_blade_2_target_x
#define target_y mccinter_analyzer_colimator_6_blade_2_target_y
#define target_z mccinter_analyzer_colimator_6_blade_2_target_z
#define focus_aw mccinter_analyzer_colimator_6_blade_2_focus_aw
#define focus_ah mccinter_analyzer_colimator_6_blade_2_focus_ah
#define focus_xw mccinter_analyzer_colimator_6_blade_2_focus_xw
#define focus_xh mccinter_analyzer_colimator_6_blade_2_focus_xh
#define focus_r mccinter_analyzer_colimator_6_blade_2_focus_r
#define p_interact mccinter_analyzer_colimator_6_blade_2_p_interact
#define mask_string mccinter_analyzer_colimator_6_blade_2_mask_string
#define mask_setting mccinter_analyzer_colimator_6_blade_2_mask_setting
#define number_of_activations mccinter_analyzer_colimator_6_blade_2_number_of_activations
#line 204 "Union_box.comp"
// Needed for transport to the main component
struct global_geometry_element_struct global_geometry_element;

#ifndef ANY_GEOMETRY_DETECTOR_DECLARE
    #define ANY_GEOMETRY_DETECTOR_DECLARE dummy
	//struct pointer_to_global_geometry_list global_geometry_list = {0,NULL};
#endif

int loop_index,found_geometries;

double x_component;
double y_component;
double z_component;

struct Volume_struct this_box_volume;
struct box_storage this_box_storage;

#line 51092 "MACS_sample_kidney_box.c"
#undef number_of_activations
#undef mask_setting
#undef mask_string
#undef p_interact
#undef focus_r
#undef focus_xh
#undef focus_xw
#undef focus_ah
#undef focus_aw
#undef target_z
#undef target_y
#undef target_x
#undef target_index
#undef visualize
#undef yheight2
#undef xwidth2
#undef zdepth
#undef yheight
#undef xwidth
#undef priority
#undef material_string
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

/* User declarations for component 'inter_analyzer_colimator_6_blade_3' [386]. */
#define mccompcurname  inter_analyzer_colimator_6_blade_3
#define mccompcurtype  Union_box
#define mccompcurindex 386
#define loop_index mccinter_analyzer_colimator_6_blade_3_loop_index
#define this_box_volume mccinter_analyzer_colimator_6_blade_3_this_box_volume
#define global_geometry_element mccinter_analyzer_colimator_6_blade_3_global_geometry_element
#define this_box_storage mccinter_analyzer_colimator_6_blade_3_this_box_storage
#define material_string mccinter_analyzer_colimator_6_blade_3_material_string
#define priority mccinter_analyzer_colimator_6_blade_3_priority
#define xwidth mccinter_analyzer_colimator_6_blade_3_xwidth
#define yheight mccinter_analyzer_colimator_6_blade_3_yheight
#define zdepth mccinter_analyzer_colimator_6_blade_3_zdepth
#define xwidth2 mccinter_analyzer_colimator_6_blade_3_xwidth2
#define yheight2 mccinter_analyzer_colimator_6_blade_3_yheight2
#define visualize mccinter_analyzer_colimator_6_blade_3_visualize
#define target_index mccinter_analyzer_colimator_6_blade_3_target_index
#define target_x mccinter_analyzer_colimator_6_blade_3_target_x
#define target_y mccinter_analyzer_colimator_6_blade_3_target_y
#define target_z mccinter_analyzer_colimator_6_blade_3_target_z
#define focus_aw mccinter_analyzer_colimator_6_blade_3_focus_aw
#define focus_ah mccinter_analyzer_colimator_6_blade_3_focus_ah
#define focus_xw mccinter_analyzer_colimator_6_blade_3_focus_xw
#define focus_xh mccinter_analyzer_colimator_6_blade_3_focus_xh
#define focus_r mccinter_analyzer_colimator_6_blade_3_focus_r
#define p_interact mccinter_analyzer_colimator_6_blade_3_p_interact
#define mask_string mccinter_analyzer_colimator_6_blade_3_mask_string
#define mask_setting mccinter_analyzer_colimator_6_blade_3_mask_setting
#define number_of_activations mccinter_analyzer_colimator_6_blade_3_number_of_activations
#line 204 "Union_box.comp"
// Needed for transport to the main component
struct global_geometry_element_struct global_geometry_element;

#ifndef ANY_GEOMETRY_DETECTOR_DECLARE
    #define ANY_GEOMETRY_DETECTOR_DECLARE dummy
	//struct pointer_to_global_geometry_list global_geometry_list = {0,NULL};
#endif

int loop_index,found_geometries;

double x_component;
double y_component;
double z_component;

struct Volume_struct this_box_volume;
struct box_storage this_box_storage;

#line 51169 "MACS_sample_kidney_box.c"
#undef number_of_activations
#undef mask_setting
#undef mask_string
#undef p_interact
#undef focus_r
#undef focus_xh
#undef focus_xw
#undef focus_ah
#undef focus_aw
#undef target_z
#undef target_y
#undef target_x
#undef target_index
#undef visualize
#undef yheight2
#undef xwidth2
#undef zdepth
#undef yheight
#undef xwidth
#undef priority
#undef material_string
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

/* User declarations for component 'inter_analyzer_colimator_6_blade_4' [387]. */
#define mccompcurname  inter_analyzer_colimator_6_blade_4
#define mccompcurtype  Union_box
#define mccompcurindex 387
#define loop_index mccinter_analyzer_colimator_6_blade_4_loop_index
#define this_box_volume mccinter_analyzer_colimator_6_blade_4_this_box_volume
#define global_geometry_element mccinter_analyzer_colimator_6_blade_4_global_geometry_element
#define this_box_storage mccinter_analyzer_colimator_6_blade_4_this_box_storage
#define material_string mccinter_analyzer_colimator_6_blade_4_material_string
#define priority mccinter_analyzer_colimator_6_blade_4_priority
#define xwidth mccinter_analyzer_colimator_6_blade_4_xwidth
#define yheight mccinter_analyzer_colimator_6_blade_4_yheight
#define zdepth mccinter_analyzer_colimator_6_blade_4_zdepth
#define xwidth2 mccinter_analyzer_colimator_6_blade_4_xwidth2
#define yheight2 mccinter_analyzer_colimator_6_blade_4_yheight2
#define visualize mccinter_analyzer_colimator_6_blade_4_visualize
#define target_index mccinter_analyzer_colimator_6_blade_4_target_index
#define target_x mccinter_analyzer_colimator_6_blade_4_target_x
#define target_y mccinter_analyzer_colimator_6_blade_4_target_y
#define target_z mccinter_analyzer_colimator_6_blade_4_target_z
#define focus_aw mccinter_analyzer_colimator_6_blade_4_focus_aw
#define focus_ah mccinter_analyzer_colimator_6_blade_4_focus_ah
#define focus_xw mccinter_analyzer_colimator_6_blade_4_focus_xw
#define focus_xh mccinter_analyzer_colimator_6_blade_4_focus_xh
#define focus_r mccinter_analyzer_colimator_6_blade_4_focus_r
#define p_interact mccinter_analyzer_colimator_6_blade_4_p_interact
#define mask_string mccinter_analyzer_colimator_6_blade_4_mask_string
#define mask_setting mccinter_analyzer_colimator_6_blade_4_mask_setting
#define number_of_activations mccinter_analyzer_colimator_6_blade_4_number_of_activations
#line 204 "Union_box.comp"
// Needed for transport to the main component
struct global_geometry_element_struct global_geometry_element;

#ifndef ANY_GEOMETRY_DETECTOR_DECLARE
    #define ANY_GEOMETRY_DETECTOR_DECLARE dummy
	//struct pointer_to_global_geometry_list global_geometry_list = {0,NULL};
#endif

int loop_index,found_geometries;

double x_component;
double y_component;
double z_component;

struct Volume_struct this_box_volume;
struct box_storage this_box_storage;

#line 51246 "MACS_sample_kidney_box.c"
#undef number_of_activations
#undef mask_setting
#undef mask_string
#undef p_interact
#undef focus_r
#undef focus_xh
#undef focus_xw
#undef focus_ah
#undef focus_aw
#undef target_z
#undef target_y
#undef target_x
#undef target_index
#undef visualize
#undef yheight2
#undef xwidth2
#undef zdepth
#undef yheight
#undef xwidth
#undef priority
#undef material_string
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

/* User declarations for component 'diffraction_detector_6_exit_volume' [388]. */
#define mccompcurname  diffraction_detector_6_exit_volume
#define mccompcurtype  Union_box
#define mccompcurindex 388
#define loop_index mccdiffraction_detector_6_exit_volume_loop_index
#define this_box_volume mccdiffraction_detector_6_exit_volume_this_box_volume
#define global_geometry_element mccdiffraction_detector_6_exit_volume_global_geometry_element
#define this_box_storage mccdiffraction_detector_6_exit_volume_this_box_storage
#define material_string mccdiffraction_detector_6_exit_volume_material_string
#define priority mccdiffraction_detector_6_exit_volume_priority
#define xwidth mccdiffraction_detector_6_exit_volume_xwidth
#define yheight mccdiffraction_detector_6_exit_volume_yheight
#define zdepth mccdiffraction_detector_6_exit_volume_zdepth
#define xwidth2 mccdiffraction_detector_6_exit_volume_xwidth2
#define yheight2 mccdiffraction_detector_6_exit_volume_yheight2
#define visualize mccdiffraction_detector_6_exit_volume_visualize
#define target_index mccdiffraction_detector_6_exit_volume_target_index
#define target_x mccdiffraction_detector_6_exit_volume_target_x
#define target_y mccdiffraction_detector_6_exit_volume_target_y
#define target_z mccdiffraction_detector_6_exit_volume_target_z
#define focus_aw mccdiffraction_detector_6_exit_volume_focus_aw
#define focus_ah mccdiffraction_detector_6_exit_volume_focus_ah
#define focus_xw mccdiffraction_detector_6_exit_volume_focus_xw
#define focus_xh mccdiffraction_detector_6_exit_volume_focus_xh
#define focus_r mccdiffraction_detector_6_exit_volume_focus_r
#define p_interact mccdiffraction_detector_6_exit_volume_p_interact
#define mask_string mccdiffraction_detector_6_exit_volume_mask_string
#define mask_setting mccdiffraction_detector_6_exit_volume_mask_setting
#define number_of_activations mccdiffraction_detector_6_exit_volume_number_of_activations
#line 204 "Union_box.comp"
// Needed for transport to the main component
struct global_geometry_element_struct global_geometry_element;

#ifndef ANY_GEOMETRY_DETECTOR_DECLARE
    #define ANY_GEOMETRY_DETECTOR_DECLARE dummy
	//struct pointer_to_global_geometry_list global_geometry_list = {0,NULL};
#endif

int loop_index,found_geometries;

double x_component;
double y_component;
double z_component;

struct Volume_struct this_box_volume;
struct box_storage this_box_storage;

#line 51323 "MACS_sample_kidney_box.c"
#undef number_of_activations
#undef mask_setting
#undef mask_string
#undef p_interact
#undef focus_r
#undef focus_xh
#undef focus_xw
#undef focus_ah
#undef focus_aw
#undef target_z
#undef target_y
#undef target_x
#undef target_index
#undef visualize
#undef yheight2
#undef xwidth2
#undef zdepth
#undef yheight
#undef xwidth
#undef priority
#undef material_string
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

/* User declarations for component 'spec_detector_6_exit_volume' [389]. */
#define mccompcurname  spec_detector_6_exit_volume
#define mccompcurtype  Union_box
#define mccompcurindex 389
#define loop_index mccspec_detector_6_exit_volume_loop_index
#define this_box_volume mccspec_detector_6_exit_volume_this_box_volume
#define global_geometry_element mccspec_detector_6_exit_volume_global_geometry_element
#define this_box_storage mccspec_detector_6_exit_volume_this_box_storage
#define material_string mccspec_detector_6_exit_volume_material_string
#define priority mccspec_detector_6_exit_volume_priority
#define xwidth mccspec_detector_6_exit_volume_xwidth
#define yheight mccspec_detector_6_exit_volume_yheight
#define zdepth mccspec_detector_6_exit_volume_zdepth
#define xwidth2 mccspec_detector_6_exit_volume_xwidth2
#define yheight2 mccspec_detector_6_exit_volume_yheight2
#define visualize mccspec_detector_6_exit_volume_visualize
#define target_index mccspec_detector_6_exit_volume_target_index
#define target_x mccspec_detector_6_exit_volume_target_x
#define target_y mccspec_detector_6_exit_volume_target_y
#define target_z mccspec_detector_6_exit_volume_target_z
#define focus_aw mccspec_detector_6_exit_volume_focus_aw
#define focus_ah mccspec_detector_6_exit_volume_focus_ah
#define focus_xw mccspec_detector_6_exit_volume_focus_xw
#define focus_xh mccspec_detector_6_exit_volume_focus_xh
#define focus_r mccspec_detector_6_exit_volume_focus_r
#define p_interact mccspec_detector_6_exit_volume_p_interact
#define mask_string mccspec_detector_6_exit_volume_mask_string
#define mask_setting mccspec_detector_6_exit_volume_mask_setting
#define number_of_activations mccspec_detector_6_exit_volume_number_of_activations
#line 204 "Union_box.comp"
// Needed for transport to the main component
struct global_geometry_element_struct global_geometry_element;

#ifndef ANY_GEOMETRY_DETECTOR_DECLARE
    #define ANY_GEOMETRY_DETECTOR_DECLARE dummy
	//struct pointer_to_global_geometry_list global_geometry_list = {0,NULL};
#endif

int loop_index,found_geometries;

double x_component;
double y_component;
double z_component;

struct Volume_struct this_box_volume;
struct box_storage this_box_storage;

#line 51400 "MACS_sample_kidney_box.c"
#undef number_of_activations
#undef mask_setting
#undef mask_string
#undef p_interact
#undef focus_r
#undef focus_xh
#undef focus_xw
#undef focus_ah
#undef focus_aw
#undef target_z
#undef target_y
#undef target_x
#undef target_index
#undef visualize
#undef yheight2
#undef xwidth2
#undef zdepth
#undef yheight
#undef xwidth
#undef priority
#undef material_string
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

/* User declarations for component 'channel_7_cave1_box1' [390]. */
#define mccompcurname  channel_7_cave1_box1
#define mccompcurtype  Union_box
#define mccompcurindex 390
#define loop_index mccchannel_7_cave1_box1_loop_index
#define this_box_volume mccchannel_7_cave1_box1_this_box_volume
#define global_geometry_element mccchannel_7_cave1_box1_global_geometry_element
#define this_box_storage mccchannel_7_cave1_box1_this_box_storage
#define material_string mccchannel_7_cave1_box1_material_string
#define priority mccchannel_7_cave1_box1_priority
#define xwidth mccchannel_7_cave1_box1_xwidth
#define yheight mccchannel_7_cave1_box1_yheight
#define zdepth mccchannel_7_cave1_box1_zdepth
#define xwidth2 mccchannel_7_cave1_box1_xwidth2
#define yheight2 mccchannel_7_cave1_box1_yheight2
#define visualize mccchannel_7_cave1_box1_visualize
#define target_index mccchannel_7_cave1_box1_target_index
#define target_x mccchannel_7_cave1_box1_target_x
#define target_y mccchannel_7_cave1_box1_target_y
#define target_z mccchannel_7_cave1_box1_target_z
#define focus_aw mccchannel_7_cave1_box1_focus_aw
#define focus_ah mccchannel_7_cave1_box1_focus_ah
#define focus_xw mccchannel_7_cave1_box1_focus_xw
#define focus_xh mccchannel_7_cave1_box1_focus_xh
#define focus_r mccchannel_7_cave1_box1_focus_r
#define p_interact mccchannel_7_cave1_box1_p_interact
#define mask_string mccchannel_7_cave1_box1_mask_string
#define mask_setting mccchannel_7_cave1_box1_mask_setting
#define number_of_activations mccchannel_7_cave1_box1_number_of_activations
#line 204 "Union_box.comp"
// Needed for transport to the main component
struct global_geometry_element_struct global_geometry_element;

#ifndef ANY_GEOMETRY_DETECTOR_DECLARE
    #define ANY_GEOMETRY_DETECTOR_DECLARE dummy
	//struct pointer_to_global_geometry_list global_geometry_list = {0,NULL};
#endif

int loop_index,found_geometries;

double x_component;
double y_component;
double z_component;

struct Volume_struct this_box_volume;
struct box_storage this_box_storage;

#line 51477 "MACS_sample_kidney_box.c"
#undef number_of_activations
#undef mask_setting
#undef mask_string
#undef p_interact
#undef focus_r
#undef focus_xh
#undef focus_xw
#undef focus_ah
#undef focus_aw
#undef target_z
#undef target_y
#undef target_x
#undef target_index
#undef visualize
#undef yheight2
#undef xwidth2
#undef zdepth
#undef yheight
#undef xwidth
#undef priority
#undef material_string
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

/* User declarations for component 'channel_7_cave1_box2' [391]. */
#define mccompcurname  channel_7_cave1_box2
#define mccompcurtype  Union_box
#define mccompcurindex 391
#define loop_index mccchannel_7_cave1_box2_loop_index
#define this_box_volume mccchannel_7_cave1_box2_this_box_volume
#define global_geometry_element mccchannel_7_cave1_box2_global_geometry_element
#define this_box_storage mccchannel_7_cave1_box2_this_box_storage
#define material_string mccchannel_7_cave1_box2_material_string
#define priority mccchannel_7_cave1_box2_priority
#define xwidth mccchannel_7_cave1_box2_xwidth
#define yheight mccchannel_7_cave1_box2_yheight
#define zdepth mccchannel_7_cave1_box2_zdepth
#define xwidth2 mccchannel_7_cave1_box2_xwidth2
#define yheight2 mccchannel_7_cave1_box2_yheight2
#define visualize mccchannel_7_cave1_box2_visualize
#define target_index mccchannel_7_cave1_box2_target_index
#define target_x mccchannel_7_cave1_box2_target_x
#define target_y mccchannel_7_cave1_box2_target_y
#define target_z mccchannel_7_cave1_box2_target_z
#define focus_aw mccchannel_7_cave1_box2_focus_aw
#define focus_ah mccchannel_7_cave1_box2_focus_ah
#define focus_xw mccchannel_7_cave1_box2_focus_xw
#define focus_xh mccchannel_7_cave1_box2_focus_xh
#define focus_r mccchannel_7_cave1_box2_focus_r
#define p_interact mccchannel_7_cave1_box2_p_interact
#define mask_string mccchannel_7_cave1_box2_mask_string
#define mask_setting mccchannel_7_cave1_box2_mask_setting
#define number_of_activations mccchannel_7_cave1_box2_number_of_activations
#line 204 "Union_box.comp"
// Needed for transport to the main component
struct global_geometry_element_struct global_geometry_element;

#ifndef ANY_GEOMETRY_DETECTOR_DECLARE
    #define ANY_GEOMETRY_DETECTOR_DECLARE dummy
	//struct pointer_to_global_geometry_list global_geometry_list = {0,NULL};
#endif

int loop_index,found_geometries;

double x_component;
double y_component;
double z_component;

struct Volume_struct this_box_volume;
struct box_storage this_box_storage;

#line 51554 "MACS_sample_kidney_box.c"
#undef number_of_activations
#undef mask_setting
#undef mask_string
#undef p_interact
#undef focus_r
#undef focus_xh
#undef focus_xw
#undef focus_ah
#undef focus_aw
#undef target_z
#undef target_y
#undef target_x
#undef target_index
#undef visualize
#undef yheight2
#undef xwidth2
#undef zdepth
#undef yheight
#undef xwidth
#undef priority
#undef material_string
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

/* User declarations for component 'channel_7_cave1_box3' [392]. */
#define mccompcurname  channel_7_cave1_box3
#define mccompcurtype  Union_box
#define mccompcurindex 392
#define loop_index mccchannel_7_cave1_box3_loop_index
#define this_box_volume mccchannel_7_cave1_box3_this_box_volume
#define global_geometry_element mccchannel_7_cave1_box3_global_geometry_element
#define this_box_storage mccchannel_7_cave1_box3_this_box_storage
#define material_string mccchannel_7_cave1_box3_material_string
#define priority mccchannel_7_cave1_box3_priority
#define xwidth mccchannel_7_cave1_box3_xwidth
#define yheight mccchannel_7_cave1_box3_yheight
#define zdepth mccchannel_7_cave1_box3_zdepth
#define xwidth2 mccchannel_7_cave1_box3_xwidth2
#define yheight2 mccchannel_7_cave1_box3_yheight2
#define visualize mccchannel_7_cave1_box3_visualize
#define target_index mccchannel_7_cave1_box3_target_index
#define target_x mccchannel_7_cave1_box3_target_x
#define target_y mccchannel_7_cave1_box3_target_y
#define target_z mccchannel_7_cave1_box3_target_z
#define focus_aw mccchannel_7_cave1_box3_focus_aw
#define focus_ah mccchannel_7_cave1_box3_focus_ah
#define focus_xw mccchannel_7_cave1_box3_focus_xw
#define focus_xh mccchannel_7_cave1_box3_focus_xh
#define focus_r mccchannel_7_cave1_box3_focus_r
#define p_interact mccchannel_7_cave1_box3_p_interact
#define mask_string mccchannel_7_cave1_box3_mask_string
#define mask_setting mccchannel_7_cave1_box3_mask_setting
#define number_of_activations mccchannel_7_cave1_box3_number_of_activations
#line 204 "Union_box.comp"
// Needed for transport to the main component
struct global_geometry_element_struct global_geometry_element;

#ifndef ANY_GEOMETRY_DETECTOR_DECLARE
    #define ANY_GEOMETRY_DETECTOR_DECLARE dummy
	//struct pointer_to_global_geometry_list global_geometry_list = {0,NULL};
#endif

int loop_index,found_geometries;

double x_component;
double y_component;
double z_component;

struct Volume_struct this_box_volume;
struct box_storage this_box_storage;

#line 51631 "MACS_sample_kidney_box.c"
#undef number_of_activations
#undef mask_setting
#undef mask_string
#undef p_interact
#undef focus_r
#undef focus_xh
#undef focus_xw
#undef focus_ah
#undef focus_aw
#undef target_z
#undef target_y
#undef target_x
#undef target_index
#undef visualize
#undef yheight2
#undef xwidth2
#undef zdepth
#undef yheight
#undef xwidth
#undef priority
#undef material_string
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

/* User declarations for component 'channel_7_cave1_cyl1' [393]. */
#define mccompcurname  channel_7_cave1_cyl1
#define mccompcurtype  Union_cylinder
#define mccompcurindex 393
#define loop_index mccchannel_7_cave1_cyl1_loop_index
#define this_cylinder_volume mccchannel_7_cave1_cyl1_this_cylinder_volume
#define global_geometry_element mccchannel_7_cave1_cyl1_global_geometry_element
#define this_cylinder_storage mccchannel_7_cave1_cyl1_this_cylinder_storage
#define material_string mccchannel_7_cave1_cyl1_material_string
#define priority mccchannel_7_cave1_cyl1_priority
#define radius mccchannel_7_cave1_cyl1_radius
#define yheight mccchannel_7_cave1_cyl1_yheight
#define visualize mccchannel_7_cave1_cyl1_visualize
#define target_index mccchannel_7_cave1_cyl1_target_index
#define target_x mccchannel_7_cave1_cyl1_target_x
#define target_y mccchannel_7_cave1_cyl1_target_y
#define target_z mccchannel_7_cave1_cyl1_target_z
#define focus_aw mccchannel_7_cave1_cyl1_focus_aw
#define focus_ah mccchannel_7_cave1_cyl1_focus_ah
#define focus_xw mccchannel_7_cave1_cyl1_focus_xw
#define focus_xh mccchannel_7_cave1_cyl1_focus_xh
#define focus_r mccchannel_7_cave1_cyl1_focus_r
#define p_interact mccchannel_7_cave1_cyl1_p_interact
#define mask_string mccchannel_7_cave1_cyl1_mask_string
#define mask_setting mccchannel_7_cave1_cyl1_mask_setting
#define number_of_activations mccchannel_7_cave1_cyl1_number_of_activations
#line 167 "Union_cylinder.comp"
// Needed for transport to the main component
struct global_geometry_element_struct global_geometry_element;

#ifndef ANY_GEOMETRY_DETECTOR_DECLARE
    #define ANY_GEOMETRY_DETECTOR_DECLARE dummy
	//struct pointer_to_global_geometry_list global_geometry_list = {0,NULL};
#endif

int dummy;
int loop_index,found_geometries;
int loop_2_index;
int material_index;

struct Volume_struct this_cylinder_volume;
struct cylinder_storage this_cylinder_storage;
#line 51703 "MACS_sample_kidney_box.c"
#undef number_of_activations
#undef mask_setting
#undef mask_string
#undef p_interact
#undef focus_r
#undef focus_xh
#undef focus_xw
#undef focus_ah
#undef focus_aw
#undef target_z
#undef target_y
#undef target_x
#undef target_index
#undef visualize
#undef yheight
#undef radius
#undef priority
#undef material_string
#undef this_cylinder_storage
#undef global_geometry_element
#undef this_cylinder_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

/* User declarations for component 'channel_7_analyzer_1_center' [394]. */
#define mccompcurname  channel_7_analyzer_1_center
#define mccompcurtype  Arm
#define mccompcurindex 394
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

/* User declarations for component 'channel_7_analyzer_1_rotated' [395]. */
#define mccompcurname  channel_7_analyzer_1_rotated
#define mccompcurtype  Arm
#define mccompcurindex 395
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

/* User declarations for component 'channel_7_analyzer_1_array_crystal_array_0' [396]. */
#define mccompcurname  channel_7_analyzer_1_array_crystal_array_0
#define mccompcurtype  Union_box
#define mccompcurindex 396
#define loop_index mccchannel_7_analyzer_1_array_crystal_array_0_loop_index
#define this_box_volume mccchannel_7_analyzer_1_array_crystal_array_0_this_box_volume
#define global_geometry_element mccchannel_7_analyzer_1_array_crystal_array_0_global_geometry_element
#define this_box_storage mccchannel_7_analyzer_1_array_crystal_array_0_this_box_storage
#define material_string mccchannel_7_analyzer_1_array_crystal_array_0_material_string
#define priority mccchannel_7_analyzer_1_array_crystal_array_0_priority
#define xwidth mccchannel_7_analyzer_1_array_crystal_array_0_xwidth
#define yheight mccchannel_7_analyzer_1_array_crystal_array_0_yheight
#define zdepth mccchannel_7_analyzer_1_array_crystal_array_0_zdepth
#define xwidth2 mccchannel_7_analyzer_1_array_crystal_array_0_xwidth2
#define yheight2 mccchannel_7_analyzer_1_array_crystal_array_0_yheight2
#define visualize mccchannel_7_analyzer_1_array_crystal_array_0_visualize
#define target_index mccchannel_7_analyzer_1_array_crystal_array_0_target_index
#define target_x mccchannel_7_analyzer_1_array_crystal_array_0_target_x
#define target_y mccchannel_7_analyzer_1_array_crystal_array_0_target_y
#define target_z mccchannel_7_analyzer_1_array_crystal_array_0_target_z
#define focus_aw mccchannel_7_analyzer_1_array_crystal_array_0_focus_aw
#define focus_ah mccchannel_7_analyzer_1_array_crystal_array_0_focus_ah
#define focus_xw mccchannel_7_analyzer_1_array_crystal_array_0_focus_xw
#define focus_xh mccchannel_7_analyzer_1_array_crystal_array_0_focus_xh
#define focus_r mccchannel_7_analyzer_1_array_crystal_array_0_focus_r
#define p_interact mccchannel_7_analyzer_1_array_crystal_array_0_p_interact
#define mask_string mccchannel_7_analyzer_1_array_crystal_array_0_mask_string
#define mask_setting mccchannel_7_analyzer_1_array_crystal_array_0_mask_setting
#define number_of_activations mccchannel_7_analyzer_1_array_crystal_array_0_number_of_activations
#line 204 "Union_box.comp"
// Needed for transport to the main component
struct global_geometry_element_struct global_geometry_element;

#ifndef ANY_GEOMETRY_DETECTOR_DECLARE
    #define ANY_GEOMETRY_DETECTOR_DECLARE dummy
	//struct pointer_to_global_geometry_list global_geometry_list = {0,NULL};
#endif

int loop_index,found_geometries;

double x_component;
double y_component;
double z_component;

struct Volume_struct this_box_volume;
struct box_storage this_box_storage;

#line 51793 "MACS_sample_kidney_box.c"
#undef number_of_activations
#undef mask_setting
#undef mask_string
#undef p_interact
#undef focus_r
#undef focus_xh
#undef focus_xw
#undef focus_ah
#undef focus_aw
#undef target_z
#undef target_y
#undef target_x
#undef target_index
#undef visualize
#undef yheight2
#undef xwidth2
#undef zdepth
#undef yheight
#undef xwidth
#undef priority
#undef material_string
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

/* User declarations for component 'channel_7_analyzer_1_array_crystal_array_1' [397]. */
#define mccompcurname  channel_7_analyzer_1_array_crystal_array_1
#define mccompcurtype  Union_box
#define mccompcurindex 397
#define loop_index mccchannel_7_analyzer_1_array_crystal_array_1_loop_index
#define this_box_volume mccchannel_7_analyzer_1_array_crystal_array_1_this_box_volume
#define global_geometry_element mccchannel_7_analyzer_1_array_crystal_array_1_global_geometry_element
#define this_box_storage mccchannel_7_analyzer_1_array_crystal_array_1_this_box_storage
#define material_string mccchannel_7_analyzer_1_array_crystal_array_1_material_string
#define priority mccchannel_7_analyzer_1_array_crystal_array_1_priority
#define xwidth mccchannel_7_analyzer_1_array_crystal_array_1_xwidth
#define yheight mccchannel_7_analyzer_1_array_crystal_array_1_yheight
#define zdepth mccchannel_7_analyzer_1_array_crystal_array_1_zdepth
#define xwidth2 mccchannel_7_analyzer_1_array_crystal_array_1_xwidth2
#define yheight2 mccchannel_7_analyzer_1_array_crystal_array_1_yheight2
#define visualize mccchannel_7_analyzer_1_array_crystal_array_1_visualize
#define target_index mccchannel_7_analyzer_1_array_crystal_array_1_target_index
#define target_x mccchannel_7_analyzer_1_array_crystal_array_1_target_x
#define target_y mccchannel_7_analyzer_1_array_crystal_array_1_target_y
#define target_z mccchannel_7_analyzer_1_array_crystal_array_1_target_z
#define focus_aw mccchannel_7_analyzer_1_array_crystal_array_1_focus_aw
#define focus_ah mccchannel_7_analyzer_1_array_crystal_array_1_focus_ah
#define focus_xw mccchannel_7_analyzer_1_array_crystal_array_1_focus_xw
#define focus_xh mccchannel_7_analyzer_1_array_crystal_array_1_focus_xh
#define focus_r mccchannel_7_analyzer_1_array_crystal_array_1_focus_r
#define p_interact mccchannel_7_analyzer_1_array_crystal_array_1_p_interact
#define mask_string mccchannel_7_analyzer_1_array_crystal_array_1_mask_string
#define mask_setting mccchannel_7_analyzer_1_array_crystal_array_1_mask_setting
#define number_of_activations mccchannel_7_analyzer_1_array_crystal_array_1_number_of_activations
#line 204 "Union_box.comp"
// Needed for transport to the main component
struct global_geometry_element_struct global_geometry_element;

#ifndef ANY_GEOMETRY_DETECTOR_DECLARE
    #define ANY_GEOMETRY_DETECTOR_DECLARE dummy
	//struct pointer_to_global_geometry_list global_geometry_list = {0,NULL};
#endif

int loop_index,found_geometries;

double x_component;
double y_component;
double z_component;

struct Volume_struct this_box_volume;
struct box_storage this_box_storage;

#line 51870 "MACS_sample_kidney_box.c"
#undef number_of_activations
#undef mask_setting
#undef mask_string
#undef p_interact
#undef focus_r
#undef focus_xh
#undef focus_xw
#undef focus_ah
#undef focus_aw
#undef target_z
#undef target_y
#undef target_x
#undef target_index
#undef visualize
#undef yheight2
#undef xwidth2
#undef zdepth
#undef yheight
#undef xwidth
#undef priority
#undef material_string
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

/* User declarations for component 'channel_7_analyzer_1_array_crystal_array_2' [398]. */
#define mccompcurname  channel_7_analyzer_1_array_crystal_array_2
#define mccompcurtype  Union_box
#define mccompcurindex 398
#define loop_index mccchannel_7_analyzer_1_array_crystal_array_2_loop_index
#define this_box_volume mccchannel_7_analyzer_1_array_crystal_array_2_this_box_volume
#define global_geometry_element mccchannel_7_analyzer_1_array_crystal_array_2_global_geometry_element
#define this_box_storage mccchannel_7_analyzer_1_array_crystal_array_2_this_box_storage
#define material_string mccchannel_7_analyzer_1_array_crystal_array_2_material_string
#define priority mccchannel_7_analyzer_1_array_crystal_array_2_priority
#define xwidth mccchannel_7_analyzer_1_array_crystal_array_2_xwidth
#define yheight mccchannel_7_analyzer_1_array_crystal_array_2_yheight
#define zdepth mccchannel_7_analyzer_1_array_crystal_array_2_zdepth
#define xwidth2 mccchannel_7_analyzer_1_array_crystal_array_2_xwidth2
#define yheight2 mccchannel_7_analyzer_1_array_crystal_array_2_yheight2
#define visualize mccchannel_7_analyzer_1_array_crystal_array_2_visualize
#define target_index mccchannel_7_analyzer_1_array_crystal_array_2_target_index
#define target_x mccchannel_7_analyzer_1_array_crystal_array_2_target_x
#define target_y mccchannel_7_analyzer_1_array_crystal_array_2_target_y
#define target_z mccchannel_7_analyzer_1_array_crystal_array_2_target_z
#define focus_aw mccchannel_7_analyzer_1_array_crystal_array_2_focus_aw
#define focus_ah mccchannel_7_analyzer_1_array_crystal_array_2_focus_ah
#define focus_xw mccchannel_7_analyzer_1_array_crystal_array_2_focus_xw
#define focus_xh mccchannel_7_analyzer_1_array_crystal_array_2_focus_xh
#define focus_r mccchannel_7_analyzer_1_array_crystal_array_2_focus_r
#define p_interact mccchannel_7_analyzer_1_array_crystal_array_2_p_interact
#define mask_string mccchannel_7_analyzer_1_array_crystal_array_2_mask_string
#define mask_setting mccchannel_7_analyzer_1_array_crystal_array_2_mask_setting
#define number_of_activations mccchannel_7_analyzer_1_array_crystal_array_2_number_of_activations
#line 204 "Union_box.comp"
// Needed for transport to the main component
struct global_geometry_element_struct global_geometry_element;

#ifndef ANY_GEOMETRY_DETECTOR_DECLARE
    #define ANY_GEOMETRY_DETECTOR_DECLARE dummy
	//struct pointer_to_global_geometry_list global_geometry_list = {0,NULL};
#endif

int loop_index,found_geometries;

double x_component;
double y_component;
double z_component;

struct Volume_struct this_box_volume;
struct box_storage this_box_storage;

#line 51947 "MACS_sample_kidney_box.c"
#undef number_of_activations
#undef mask_setting
#undef mask_string
#undef p_interact
#undef focus_r
#undef focus_xh
#undef focus_xw
#undef focus_ah
#undef focus_aw
#undef target_z
#undef target_y
#undef target_x
#undef target_index
#undef visualize
#undef yheight2
#undef xwidth2
#undef zdepth
#undef yheight
#undef xwidth
#undef priority
#undef material_string
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

/* User declarations for component 'channel_7_analyzer_1_array_crystal_array_3' [399]. */
#define mccompcurname  channel_7_analyzer_1_array_crystal_array_3
#define mccompcurtype  Union_box
#define mccompcurindex 399
#define loop_index mccchannel_7_analyzer_1_array_crystal_array_3_loop_index
#define this_box_volume mccchannel_7_analyzer_1_array_crystal_array_3_this_box_volume
#define global_geometry_element mccchannel_7_analyzer_1_array_crystal_array_3_global_geometry_element
#define this_box_storage mccchannel_7_analyzer_1_array_crystal_array_3_this_box_storage
#define material_string mccchannel_7_analyzer_1_array_crystal_array_3_material_string
#define priority mccchannel_7_analyzer_1_array_crystal_array_3_priority
#define xwidth mccchannel_7_analyzer_1_array_crystal_array_3_xwidth
#define yheight mccchannel_7_analyzer_1_array_crystal_array_3_yheight
#define zdepth mccchannel_7_analyzer_1_array_crystal_array_3_zdepth
#define xwidth2 mccchannel_7_analyzer_1_array_crystal_array_3_xwidth2
#define yheight2 mccchannel_7_analyzer_1_array_crystal_array_3_yheight2
#define visualize mccchannel_7_analyzer_1_array_crystal_array_3_visualize
#define target_index mccchannel_7_analyzer_1_array_crystal_array_3_target_index
#define target_x mccchannel_7_analyzer_1_array_crystal_array_3_target_x
#define target_y mccchannel_7_analyzer_1_array_crystal_array_3_target_y
#define target_z mccchannel_7_analyzer_1_array_crystal_array_3_target_z
#define focus_aw mccchannel_7_analyzer_1_array_crystal_array_3_focus_aw
#define focus_ah mccchannel_7_analyzer_1_array_crystal_array_3_focus_ah
#define focus_xw mccchannel_7_analyzer_1_array_crystal_array_3_focus_xw
#define focus_xh mccchannel_7_analyzer_1_array_crystal_array_3_focus_xh
#define focus_r mccchannel_7_analyzer_1_array_crystal_array_3_focus_r
#define p_interact mccchannel_7_analyzer_1_array_crystal_array_3_p_interact
#define mask_string mccchannel_7_analyzer_1_array_crystal_array_3_mask_string
#define mask_setting mccchannel_7_analyzer_1_array_crystal_array_3_mask_setting
#define number_of_activations mccchannel_7_analyzer_1_array_crystal_array_3_number_of_activations
#line 204 "Union_box.comp"
// Needed for transport to the main component
struct global_geometry_element_struct global_geometry_element;

#ifndef ANY_GEOMETRY_DETECTOR_DECLARE
    #define ANY_GEOMETRY_DETECTOR_DECLARE dummy
	//struct pointer_to_global_geometry_list global_geometry_list = {0,NULL};
#endif

int loop_index,found_geometries;

double x_component;
double y_component;
double z_component;

struct Volume_struct this_box_volume;
struct box_storage this_box_storage;

#line 52024 "MACS_sample_kidney_box.c"
#undef number_of_activations
#undef mask_setting
#undef mask_string
#undef p_interact
#undef focus_r
#undef focus_xh
#undef focus_xw
#undef focus_ah
#undef focus_aw
#undef target_z
#undef target_y
#undef target_x
#undef target_index
#undef visualize
#undef yheight2
#undef xwidth2
#undef zdepth
#undef yheight
#undef xwidth
#undef priority
#undef material_string
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

/* User declarations for component 'channel_7_analyzer_1_array_crystal_array_4' [400]. */
#define mccompcurname  channel_7_analyzer_1_array_crystal_array_4
#define mccompcurtype  Union_box
#define mccompcurindex 400
#define loop_index mccchannel_7_analyzer_1_array_crystal_array_4_loop_index
#define this_box_volume mccchannel_7_analyzer_1_array_crystal_array_4_this_box_volume
#define global_geometry_element mccchannel_7_analyzer_1_array_crystal_array_4_global_geometry_element
#define this_box_storage mccchannel_7_analyzer_1_array_crystal_array_4_this_box_storage
#define material_string mccchannel_7_analyzer_1_array_crystal_array_4_material_string
#define priority mccchannel_7_analyzer_1_array_crystal_array_4_priority
#define xwidth mccchannel_7_analyzer_1_array_crystal_array_4_xwidth
#define yheight mccchannel_7_analyzer_1_array_crystal_array_4_yheight
#define zdepth mccchannel_7_analyzer_1_array_crystal_array_4_zdepth
#define xwidth2 mccchannel_7_analyzer_1_array_crystal_array_4_xwidth2
#define yheight2 mccchannel_7_analyzer_1_array_crystal_array_4_yheight2
#define visualize mccchannel_7_analyzer_1_array_crystal_array_4_visualize
#define target_index mccchannel_7_analyzer_1_array_crystal_array_4_target_index
#define target_x mccchannel_7_analyzer_1_array_crystal_array_4_target_x
#define target_y mccchannel_7_analyzer_1_array_crystal_array_4_target_y
#define target_z mccchannel_7_analyzer_1_array_crystal_array_4_target_z
#define focus_aw mccchannel_7_analyzer_1_array_crystal_array_4_focus_aw
#define focus_ah mccchannel_7_analyzer_1_array_crystal_array_4_focus_ah
#define focus_xw mccchannel_7_analyzer_1_array_crystal_array_4_focus_xw
#define focus_xh mccchannel_7_analyzer_1_array_crystal_array_4_focus_xh
#define focus_r mccchannel_7_analyzer_1_array_crystal_array_4_focus_r
#define p_interact mccchannel_7_analyzer_1_array_crystal_array_4_p_interact
#define mask_string mccchannel_7_analyzer_1_array_crystal_array_4_mask_string
#define mask_setting mccchannel_7_analyzer_1_array_crystal_array_4_mask_setting
#define number_of_activations mccchannel_7_analyzer_1_array_crystal_array_4_number_of_activations
#line 204 "Union_box.comp"
// Needed for transport to the main component
struct global_geometry_element_struct global_geometry_element;

#ifndef ANY_GEOMETRY_DETECTOR_DECLARE
    #define ANY_GEOMETRY_DETECTOR_DECLARE dummy
	//struct pointer_to_global_geometry_list global_geometry_list = {0,NULL};
#endif

int loop_index,found_geometries;

double x_component;
double y_component;
double z_component;

struct Volume_struct this_box_volume;
struct box_storage this_box_storage;

#line 52101 "MACS_sample_kidney_box.c"
#undef number_of_activations
#undef mask_setting
#undef mask_string
#undef p_interact
#undef focus_r
#undef focus_xh
#undef focus_xw
#undef focus_ah
#undef focus_aw
#undef target_z
#undef target_y
#undef target_x
#undef target_index
#undef visualize
#undef yheight2
#undef xwidth2
#undef zdepth
#undef yheight
#undef xwidth
#undef priority
#undef material_string
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

/* User declarations for component 'channel_7_analyzer_1_array_crystal_array_5' [401]. */
#define mccompcurname  channel_7_analyzer_1_array_crystal_array_5
#define mccompcurtype  Union_box
#define mccompcurindex 401
#define loop_index mccchannel_7_analyzer_1_array_crystal_array_5_loop_index
#define this_box_volume mccchannel_7_analyzer_1_array_crystal_array_5_this_box_volume
#define global_geometry_element mccchannel_7_analyzer_1_array_crystal_array_5_global_geometry_element
#define this_box_storage mccchannel_7_analyzer_1_array_crystal_array_5_this_box_storage
#define material_string mccchannel_7_analyzer_1_array_crystal_array_5_material_string
#define priority mccchannel_7_analyzer_1_array_crystal_array_5_priority
#define xwidth mccchannel_7_analyzer_1_array_crystal_array_5_xwidth
#define yheight mccchannel_7_analyzer_1_array_crystal_array_5_yheight
#define zdepth mccchannel_7_analyzer_1_array_crystal_array_5_zdepth
#define xwidth2 mccchannel_7_analyzer_1_array_crystal_array_5_xwidth2
#define yheight2 mccchannel_7_analyzer_1_array_crystal_array_5_yheight2
#define visualize mccchannel_7_analyzer_1_array_crystal_array_5_visualize
#define target_index mccchannel_7_analyzer_1_array_crystal_array_5_target_index
#define target_x mccchannel_7_analyzer_1_array_crystal_array_5_target_x
#define target_y mccchannel_7_analyzer_1_array_crystal_array_5_target_y
#define target_z mccchannel_7_analyzer_1_array_crystal_array_5_target_z
#define focus_aw mccchannel_7_analyzer_1_array_crystal_array_5_focus_aw
#define focus_ah mccchannel_7_analyzer_1_array_crystal_array_5_focus_ah
#define focus_xw mccchannel_7_analyzer_1_array_crystal_array_5_focus_xw
#define focus_xh mccchannel_7_analyzer_1_array_crystal_array_5_focus_xh
#define focus_r mccchannel_7_analyzer_1_array_crystal_array_5_focus_r
#define p_interact mccchannel_7_analyzer_1_array_crystal_array_5_p_interact
#define mask_string mccchannel_7_analyzer_1_array_crystal_array_5_mask_string
#define mask_setting mccchannel_7_analyzer_1_array_crystal_array_5_mask_setting
#define number_of_activations mccchannel_7_analyzer_1_array_crystal_array_5_number_of_activations
#line 204 "Union_box.comp"
// Needed for transport to the main component
struct global_geometry_element_struct global_geometry_element;

#ifndef ANY_GEOMETRY_DETECTOR_DECLARE
    #define ANY_GEOMETRY_DETECTOR_DECLARE dummy
	//struct pointer_to_global_geometry_list global_geometry_list = {0,NULL};
#endif

int loop_index,found_geometries;

double x_component;
double y_component;
double z_component;

struct Volume_struct this_box_volume;
struct box_storage this_box_storage;

#line 52178 "MACS_sample_kidney_box.c"
#undef number_of_activations
#undef mask_setting
#undef mask_string
#undef p_interact
#undef focus_r
#undef focus_xh
#undef focus_xw
#undef focus_ah
#undef focus_aw
#undef target_z
#undef target_y
#undef target_x
#undef target_index
#undef visualize
#undef yheight2
#undef xwidth2
#undef zdepth
#undef yheight
#undef xwidth
#undef priority
#undef material_string
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

/* User declarations for component 'channel_7_analyzer_1_array_crystal_array_6' [402]. */
#define mccompcurname  channel_7_analyzer_1_array_crystal_array_6
#define mccompcurtype  Union_box
#define mccompcurindex 402
#define loop_index mccchannel_7_analyzer_1_array_crystal_array_6_loop_index
#define this_box_volume mccchannel_7_analyzer_1_array_crystal_array_6_this_box_volume
#define global_geometry_element mccchannel_7_analyzer_1_array_crystal_array_6_global_geometry_element
#define this_box_storage mccchannel_7_analyzer_1_array_crystal_array_6_this_box_storage
#define material_string mccchannel_7_analyzer_1_array_crystal_array_6_material_string
#define priority mccchannel_7_analyzer_1_array_crystal_array_6_priority
#define xwidth mccchannel_7_analyzer_1_array_crystal_array_6_xwidth
#define yheight mccchannel_7_analyzer_1_array_crystal_array_6_yheight
#define zdepth mccchannel_7_analyzer_1_array_crystal_array_6_zdepth
#define xwidth2 mccchannel_7_analyzer_1_array_crystal_array_6_xwidth2
#define yheight2 mccchannel_7_analyzer_1_array_crystal_array_6_yheight2
#define visualize mccchannel_7_analyzer_1_array_crystal_array_6_visualize
#define target_index mccchannel_7_analyzer_1_array_crystal_array_6_target_index
#define target_x mccchannel_7_analyzer_1_array_crystal_array_6_target_x
#define target_y mccchannel_7_analyzer_1_array_crystal_array_6_target_y
#define target_z mccchannel_7_analyzer_1_array_crystal_array_6_target_z
#define focus_aw mccchannel_7_analyzer_1_array_crystal_array_6_focus_aw
#define focus_ah mccchannel_7_analyzer_1_array_crystal_array_6_focus_ah
#define focus_xw mccchannel_7_analyzer_1_array_crystal_array_6_focus_xw
#define focus_xh mccchannel_7_analyzer_1_array_crystal_array_6_focus_xh
#define focus_r mccchannel_7_analyzer_1_array_crystal_array_6_focus_r
#define p_interact mccchannel_7_analyzer_1_array_crystal_array_6_p_interact
#define mask_string mccchannel_7_analyzer_1_array_crystal_array_6_mask_string
#define mask_setting mccchannel_7_analyzer_1_array_crystal_array_6_mask_setting
#define number_of_activations mccchannel_7_analyzer_1_array_crystal_array_6_number_of_activations
#line 204 "Union_box.comp"
// Needed for transport to the main component
struct global_geometry_element_struct global_geometry_element;

#ifndef ANY_GEOMETRY_DETECTOR_DECLARE
    #define ANY_GEOMETRY_DETECTOR_DECLARE dummy
	//struct pointer_to_global_geometry_list global_geometry_list = {0,NULL};
#endif

int loop_index,found_geometries;

double x_component;
double y_component;
double z_component;

struct Volume_struct this_box_volume;
struct box_storage this_box_storage;

#line 52255 "MACS_sample_kidney_box.c"
#undef number_of_activations
#undef mask_setting
#undef mask_string
#undef p_interact
#undef focus_r
#undef focus_xh
#undef focus_xw
#undef focus_ah
#undef focus_aw
#undef target_z
#undef target_y
#undef target_x
#undef target_index
#undef visualize
#undef yheight2
#undef xwidth2
#undef zdepth
#undef yheight
#undef xwidth
#undef priority
#undef material_string
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

/* User declarations for component 'channel_7_analyzer_1_array_crystal_array_7' [403]. */
#define mccompcurname  channel_7_analyzer_1_array_crystal_array_7
#define mccompcurtype  Union_box
#define mccompcurindex 403
#define loop_index mccchannel_7_analyzer_1_array_crystal_array_7_loop_index
#define this_box_volume mccchannel_7_analyzer_1_array_crystal_array_7_this_box_volume
#define global_geometry_element mccchannel_7_analyzer_1_array_crystal_array_7_global_geometry_element
#define this_box_storage mccchannel_7_analyzer_1_array_crystal_array_7_this_box_storage
#define material_string mccchannel_7_analyzer_1_array_crystal_array_7_material_string
#define priority mccchannel_7_analyzer_1_array_crystal_array_7_priority
#define xwidth mccchannel_7_analyzer_1_array_crystal_array_7_xwidth
#define yheight mccchannel_7_analyzer_1_array_crystal_array_7_yheight
#define zdepth mccchannel_7_analyzer_1_array_crystal_array_7_zdepth
#define xwidth2 mccchannel_7_analyzer_1_array_crystal_array_7_xwidth2
#define yheight2 mccchannel_7_analyzer_1_array_crystal_array_7_yheight2
#define visualize mccchannel_7_analyzer_1_array_crystal_array_7_visualize
#define target_index mccchannel_7_analyzer_1_array_crystal_array_7_target_index
#define target_x mccchannel_7_analyzer_1_array_crystal_array_7_target_x
#define target_y mccchannel_7_analyzer_1_array_crystal_array_7_target_y
#define target_z mccchannel_7_analyzer_1_array_crystal_array_7_target_z
#define focus_aw mccchannel_7_analyzer_1_array_crystal_array_7_focus_aw
#define focus_ah mccchannel_7_analyzer_1_array_crystal_array_7_focus_ah
#define focus_xw mccchannel_7_analyzer_1_array_crystal_array_7_focus_xw
#define focus_xh mccchannel_7_analyzer_1_array_crystal_array_7_focus_xh
#define focus_r mccchannel_7_analyzer_1_array_crystal_array_7_focus_r
#define p_interact mccchannel_7_analyzer_1_array_crystal_array_7_p_interact
#define mask_string mccchannel_7_analyzer_1_array_crystal_array_7_mask_string
#define mask_setting mccchannel_7_analyzer_1_array_crystal_array_7_mask_setting
#define number_of_activations mccchannel_7_analyzer_1_array_crystal_array_7_number_of_activations
#line 204 "Union_box.comp"
// Needed for transport to the main component
struct global_geometry_element_struct global_geometry_element;

#ifndef ANY_GEOMETRY_DETECTOR_DECLARE
    #define ANY_GEOMETRY_DETECTOR_DECLARE dummy
	//struct pointer_to_global_geometry_list global_geometry_list = {0,NULL};
#endif

int loop_index,found_geometries;

double x_component;
double y_component;
double z_component;

struct Volume_struct this_box_volume;
struct box_storage this_box_storage;

#line 52332 "MACS_sample_kidney_box.c"
#undef number_of_activations
#undef mask_setting
#undef mask_string
#undef p_interact
#undef focus_r
#undef focus_xh
#undef focus_xw
#undef focus_ah
#undef focus_aw
#undef target_z
#undef target_y
#undef target_x
#undef target_index
#undef visualize
#undef yheight2
#undef xwidth2
#undef zdepth
#undef yheight
#undef xwidth
#undef priority
#undef material_string
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

/* User declarations for component 'channel_7_analyzer_1_array_crystal_array_8' [404]. */
#define mccompcurname  channel_7_analyzer_1_array_crystal_array_8
#define mccompcurtype  Union_box
#define mccompcurindex 404
#define loop_index mccchannel_7_analyzer_1_array_crystal_array_8_loop_index
#define this_box_volume mccchannel_7_analyzer_1_array_crystal_array_8_this_box_volume
#define global_geometry_element mccchannel_7_analyzer_1_array_crystal_array_8_global_geometry_element
#define this_box_storage mccchannel_7_analyzer_1_array_crystal_array_8_this_box_storage
#define material_string mccchannel_7_analyzer_1_array_crystal_array_8_material_string
#define priority mccchannel_7_analyzer_1_array_crystal_array_8_priority
#define xwidth mccchannel_7_analyzer_1_array_crystal_array_8_xwidth
#define yheight mccchannel_7_analyzer_1_array_crystal_array_8_yheight
#define zdepth mccchannel_7_analyzer_1_array_crystal_array_8_zdepth
#define xwidth2 mccchannel_7_analyzer_1_array_crystal_array_8_xwidth2
#define yheight2 mccchannel_7_analyzer_1_array_crystal_array_8_yheight2
#define visualize mccchannel_7_analyzer_1_array_crystal_array_8_visualize
#define target_index mccchannel_7_analyzer_1_array_crystal_array_8_target_index
#define target_x mccchannel_7_analyzer_1_array_crystal_array_8_target_x
#define target_y mccchannel_7_analyzer_1_array_crystal_array_8_target_y
#define target_z mccchannel_7_analyzer_1_array_crystal_array_8_target_z
#define focus_aw mccchannel_7_analyzer_1_array_crystal_array_8_focus_aw
#define focus_ah mccchannel_7_analyzer_1_array_crystal_array_8_focus_ah
#define focus_xw mccchannel_7_analyzer_1_array_crystal_array_8_focus_xw
#define focus_xh mccchannel_7_analyzer_1_array_crystal_array_8_focus_xh
#define focus_r mccchannel_7_analyzer_1_array_crystal_array_8_focus_r
#define p_interact mccchannel_7_analyzer_1_array_crystal_array_8_p_interact
#define mask_string mccchannel_7_analyzer_1_array_crystal_array_8_mask_string
#define mask_setting mccchannel_7_analyzer_1_array_crystal_array_8_mask_setting
#define number_of_activations mccchannel_7_analyzer_1_array_crystal_array_8_number_of_activations
#line 204 "Union_box.comp"
// Needed for transport to the main component
struct global_geometry_element_struct global_geometry_element;

#ifndef ANY_GEOMETRY_DETECTOR_DECLARE
    #define ANY_GEOMETRY_DETECTOR_DECLARE dummy
	//struct pointer_to_global_geometry_list global_geometry_list = {0,NULL};
#endif

int loop_index,found_geometries;

double x_component;
double y_component;
double z_component;

struct Volume_struct this_box_volume;
struct box_storage this_box_storage;

#line 52409 "MACS_sample_kidney_box.c"
#undef number_of_activations
#undef mask_setting
#undef mask_string
#undef p_interact
#undef focus_r
#undef focus_xh
#undef focus_xw
#undef focus_ah
#undef focus_aw
#undef target_z
#undef target_y
#undef target_x
#undef target_index
#undef visualize
#undef yheight2
#undef xwidth2
#undef zdepth
#undef yheight
#undef xwidth
#undef priority
#undef material_string
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

/* User declarations for component 'channel_7_analyzer_2_center' [405]. */
#define mccompcurname  channel_7_analyzer_2_center
#define mccompcurtype  Arm
#define mccompcurindex 405
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

/* User declarations for component 'channel_7_analyzer_2_rotated' [406]. */
#define mccompcurname  channel_7_analyzer_2_rotated
#define mccompcurtype  Arm
#define mccompcurindex 406
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

/* User declarations for component 'channel_7_analyzer_2_array_crystal_array_0' [407]. */
#define mccompcurname  channel_7_analyzer_2_array_crystal_array_0
#define mccompcurtype  Union_box
#define mccompcurindex 407
#define loop_index mccchannel_7_analyzer_2_array_crystal_array_0_loop_index
#define this_box_volume mccchannel_7_analyzer_2_array_crystal_array_0_this_box_volume
#define global_geometry_element mccchannel_7_analyzer_2_array_crystal_array_0_global_geometry_element
#define this_box_storage mccchannel_7_analyzer_2_array_crystal_array_0_this_box_storage
#define material_string mccchannel_7_analyzer_2_array_crystal_array_0_material_string
#define priority mccchannel_7_analyzer_2_array_crystal_array_0_priority
#define xwidth mccchannel_7_analyzer_2_array_crystal_array_0_xwidth
#define yheight mccchannel_7_analyzer_2_array_crystal_array_0_yheight
#define zdepth mccchannel_7_analyzer_2_array_crystal_array_0_zdepth
#define xwidth2 mccchannel_7_analyzer_2_array_crystal_array_0_xwidth2
#define yheight2 mccchannel_7_analyzer_2_array_crystal_array_0_yheight2
#define visualize mccchannel_7_analyzer_2_array_crystal_array_0_visualize
#define target_index mccchannel_7_analyzer_2_array_crystal_array_0_target_index
#define target_x mccchannel_7_analyzer_2_array_crystal_array_0_target_x
#define target_y mccchannel_7_analyzer_2_array_crystal_array_0_target_y
#define target_z mccchannel_7_analyzer_2_array_crystal_array_0_target_z
#define focus_aw mccchannel_7_analyzer_2_array_crystal_array_0_focus_aw
#define focus_ah mccchannel_7_analyzer_2_array_crystal_array_0_focus_ah
#define focus_xw mccchannel_7_analyzer_2_array_crystal_array_0_focus_xw
#define focus_xh mccchannel_7_analyzer_2_array_crystal_array_0_focus_xh
#define focus_r mccchannel_7_analyzer_2_array_crystal_array_0_focus_r
#define p_interact mccchannel_7_analyzer_2_array_crystal_array_0_p_interact
#define mask_string mccchannel_7_analyzer_2_array_crystal_array_0_mask_string
#define mask_setting mccchannel_7_analyzer_2_array_crystal_array_0_mask_setting
#define number_of_activations mccchannel_7_analyzer_2_array_crystal_array_0_number_of_activations
#line 204 "Union_box.comp"
// Needed for transport to the main component
struct global_geometry_element_struct global_geometry_element;

#ifndef ANY_GEOMETRY_DETECTOR_DECLARE
    #define ANY_GEOMETRY_DETECTOR_DECLARE dummy
	//struct pointer_to_global_geometry_list global_geometry_list = {0,NULL};
#endif

int loop_index,found_geometries;

double x_component;
double y_component;
double z_component;

struct Volume_struct this_box_volume;
struct box_storage this_box_storage;

#line 52502 "MACS_sample_kidney_box.c"
#undef number_of_activations
#undef mask_setting
#undef mask_string
#undef p_interact
#undef focus_r
#undef focus_xh
#undef focus_xw
#undef focus_ah
#undef focus_aw
#undef target_z
#undef target_y
#undef target_x
#undef target_index
#undef visualize
#undef yheight2
#undef xwidth2
#undef zdepth
#undef yheight
#undef xwidth
#undef priority
#undef material_string
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

/* User declarations for component 'channel_7_analyzer_2_array_crystal_array_1' [408]. */
#define mccompcurname  channel_7_analyzer_2_array_crystal_array_1
#define mccompcurtype  Union_box
#define mccompcurindex 408
#define loop_index mccchannel_7_analyzer_2_array_crystal_array_1_loop_index
#define this_box_volume mccchannel_7_analyzer_2_array_crystal_array_1_this_box_volume
#define global_geometry_element mccchannel_7_analyzer_2_array_crystal_array_1_global_geometry_element
#define this_box_storage mccchannel_7_analyzer_2_array_crystal_array_1_this_box_storage
#define material_string mccchannel_7_analyzer_2_array_crystal_array_1_material_string
#define priority mccchannel_7_analyzer_2_array_crystal_array_1_priority
#define xwidth mccchannel_7_analyzer_2_array_crystal_array_1_xwidth
#define yheight mccchannel_7_analyzer_2_array_crystal_array_1_yheight
#define zdepth mccchannel_7_analyzer_2_array_crystal_array_1_zdepth
#define xwidth2 mccchannel_7_analyzer_2_array_crystal_array_1_xwidth2
#define yheight2 mccchannel_7_analyzer_2_array_crystal_array_1_yheight2
#define visualize mccchannel_7_analyzer_2_array_crystal_array_1_visualize
#define target_index mccchannel_7_analyzer_2_array_crystal_array_1_target_index
#define target_x mccchannel_7_analyzer_2_array_crystal_array_1_target_x
#define target_y mccchannel_7_analyzer_2_array_crystal_array_1_target_y
#define target_z mccchannel_7_analyzer_2_array_crystal_array_1_target_z
#define focus_aw mccchannel_7_analyzer_2_array_crystal_array_1_focus_aw
#define focus_ah mccchannel_7_analyzer_2_array_crystal_array_1_focus_ah
#define focus_xw mccchannel_7_analyzer_2_array_crystal_array_1_focus_xw
#define focus_xh mccchannel_7_analyzer_2_array_crystal_array_1_focus_xh
#define focus_r mccchannel_7_analyzer_2_array_crystal_array_1_focus_r
#define p_interact mccchannel_7_analyzer_2_array_crystal_array_1_p_interact
#define mask_string mccchannel_7_analyzer_2_array_crystal_array_1_mask_string
#define mask_setting mccchannel_7_analyzer_2_array_crystal_array_1_mask_setting
#define number_of_activations mccchannel_7_analyzer_2_array_crystal_array_1_number_of_activations
#line 204 "Union_box.comp"
// Needed for transport to the main component
struct global_geometry_element_struct global_geometry_element;

#ifndef ANY_GEOMETRY_DETECTOR_DECLARE
    #define ANY_GEOMETRY_DETECTOR_DECLARE dummy
	//struct pointer_to_global_geometry_list global_geometry_list = {0,NULL};
#endif

int loop_index,found_geometries;

double x_component;
double y_component;
double z_component;

struct Volume_struct this_box_volume;
struct box_storage this_box_storage;

#line 52579 "MACS_sample_kidney_box.c"
#undef number_of_activations
#undef mask_setting
#undef mask_string
#undef p_interact
#undef focus_r
#undef focus_xh
#undef focus_xw
#undef focus_ah
#undef focus_aw
#undef target_z
#undef target_y
#undef target_x
#undef target_index
#undef visualize
#undef yheight2
#undef xwidth2
#undef zdepth
#undef yheight
#undef xwidth
#undef priority
#undef material_string
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

/* User declarations for component 'channel_7_analyzer_2_array_crystal_array_2' [409]. */
#define mccompcurname  channel_7_analyzer_2_array_crystal_array_2
#define mccompcurtype  Union_box
#define mccompcurindex 409
#define loop_index mccchannel_7_analyzer_2_array_crystal_array_2_loop_index
#define this_box_volume mccchannel_7_analyzer_2_array_crystal_array_2_this_box_volume
#define global_geometry_element mccchannel_7_analyzer_2_array_crystal_array_2_global_geometry_element
#define this_box_storage mccchannel_7_analyzer_2_array_crystal_array_2_this_box_storage
#define material_string mccchannel_7_analyzer_2_array_crystal_array_2_material_string
#define priority mccchannel_7_analyzer_2_array_crystal_array_2_priority
#define xwidth mccchannel_7_analyzer_2_array_crystal_array_2_xwidth
#define yheight mccchannel_7_analyzer_2_array_crystal_array_2_yheight
#define zdepth mccchannel_7_analyzer_2_array_crystal_array_2_zdepth
#define xwidth2 mccchannel_7_analyzer_2_array_crystal_array_2_xwidth2
#define yheight2 mccchannel_7_analyzer_2_array_crystal_array_2_yheight2
#define visualize mccchannel_7_analyzer_2_array_crystal_array_2_visualize
#define target_index mccchannel_7_analyzer_2_array_crystal_array_2_target_index
#define target_x mccchannel_7_analyzer_2_array_crystal_array_2_target_x
#define target_y mccchannel_7_analyzer_2_array_crystal_array_2_target_y
#define target_z mccchannel_7_analyzer_2_array_crystal_array_2_target_z
#define focus_aw mccchannel_7_analyzer_2_array_crystal_array_2_focus_aw
#define focus_ah mccchannel_7_analyzer_2_array_crystal_array_2_focus_ah
#define focus_xw mccchannel_7_analyzer_2_array_crystal_array_2_focus_xw
#define focus_xh mccchannel_7_analyzer_2_array_crystal_array_2_focus_xh
#define focus_r mccchannel_7_analyzer_2_array_crystal_array_2_focus_r
#define p_interact mccchannel_7_analyzer_2_array_crystal_array_2_p_interact
#define mask_string mccchannel_7_analyzer_2_array_crystal_array_2_mask_string
#define mask_setting mccchannel_7_analyzer_2_array_crystal_array_2_mask_setting
#define number_of_activations mccchannel_7_analyzer_2_array_crystal_array_2_number_of_activations
#line 204 "Union_box.comp"
// Needed for transport to the main component
struct global_geometry_element_struct global_geometry_element;

#ifndef ANY_GEOMETRY_DETECTOR_DECLARE
    #define ANY_GEOMETRY_DETECTOR_DECLARE dummy
	//struct pointer_to_global_geometry_list global_geometry_list = {0,NULL};
#endif

int loop_index,found_geometries;

double x_component;
double y_component;
double z_component;

struct Volume_struct this_box_volume;
struct box_storage this_box_storage;

#line 52656 "MACS_sample_kidney_box.c"
#undef number_of_activations
#undef mask_setting
#undef mask_string
#undef p_interact
#undef focus_r
#undef focus_xh
#undef focus_xw
#undef focus_ah
#undef focus_aw
#undef target_z
#undef target_y
#undef target_x
#undef target_index
#undef visualize
#undef yheight2
#undef xwidth2
#undef zdepth
#undef yheight
#undef xwidth
#undef priority
#undef material_string
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

/* User declarations for component 'channel_7_analyzer_2_array_crystal_array_3' [410]. */
#define mccompcurname  channel_7_analyzer_2_array_crystal_array_3
#define mccompcurtype  Union_box
#define mccompcurindex 410
#define loop_index mccchannel_7_analyzer_2_array_crystal_array_3_loop_index
#define this_box_volume mccchannel_7_analyzer_2_array_crystal_array_3_this_box_volume
#define global_geometry_element mccchannel_7_analyzer_2_array_crystal_array_3_global_geometry_element
#define this_box_storage mccchannel_7_analyzer_2_array_crystal_array_3_this_box_storage
#define material_string mccchannel_7_analyzer_2_array_crystal_array_3_material_string
#define priority mccchannel_7_analyzer_2_array_crystal_array_3_priority
#define xwidth mccchannel_7_analyzer_2_array_crystal_array_3_xwidth
#define yheight mccchannel_7_analyzer_2_array_crystal_array_3_yheight
#define zdepth mccchannel_7_analyzer_2_array_crystal_array_3_zdepth
#define xwidth2 mccchannel_7_analyzer_2_array_crystal_array_3_xwidth2
#define yheight2 mccchannel_7_analyzer_2_array_crystal_array_3_yheight2
#define visualize mccchannel_7_analyzer_2_array_crystal_array_3_visualize
#define target_index mccchannel_7_analyzer_2_array_crystal_array_3_target_index
#define target_x mccchannel_7_analyzer_2_array_crystal_array_3_target_x
#define target_y mccchannel_7_analyzer_2_array_crystal_array_3_target_y
#define target_z mccchannel_7_analyzer_2_array_crystal_array_3_target_z
#define focus_aw mccchannel_7_analyzer_2_array_crystal_array_3_focus_aw
#define focus_ah mccchannel_7_analyzer_2_array_crystal_array_3_focus_ah
#define focus_xw mccchannel_7_analyzer_2_array_crystal_array_3_focus_xw
#define focus_xh mccchannel_7_analyzer_2_array_crystal_array_3_focus_xh
#define focus_r mccchannel_7_analyzer_2_array_crystal_array_3_focus_r
#define p_interact mccchannel_7_analyzer_2_array_crystal_array_3_p_interact
#define mask_string mccchannel_7_analyzer_2_array_crystal_array_3_mask_string
#define mask_setting mccchannel_7_analyzer_2_array_crystal_array_3_mask_setting
#define number_of_activations mccchannel_7_analyzer_2_array_crystal_array_3_number_of_activations
#line 204 "Union_box.comp"
// Needed for transport to the main component
struct global_geometry_element_struct global_geometry_element;

#ifndef ANY_GEOMETRY_DETECTOR_DECLARE
    #define ANY_GEOMETRY_DETECTOR_DECLARE dummy
	//struct pointer_to_global_geometry_list global_geometry_list = {0,NULL};
#endif

int loop_index,found_geometries;

double x_component;
double y_component;
double z_component;

struct Volume_struct this_box_volume;
struct box_storage this_box_storage;

#line 52733 "MACS_sample_kidney_box.c"
#undef number_of_activations
#undef mask_setting
#undef mask_string
#undef p_interact
#undef focus_r
#undef focus_xh
#undef focus_xw
#undef focus_ah
#undef focus_aw
#undef target_z
#undef target_y
#undef target_x
#undef target_index
#undef visualize
#undef yheight2
#undef xwidth2
#undef zdepth
#undef yheight
#undef xwidth
#undef priority
#undef material_string
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

/* User declarations for component 'channel_7_analyzer_2_array_crystal_array_4' [411]. */
#define mccompcurname  channel_7_analyzer_2_array_crystal_array_4
#define mccompcurtype  Union_box
#define mccompcurindex 411
#define loop_index mccchannel_7_analyzer_2_array_crystal_array_4_loop_index
#define this_box_volume mccchannel_7_analyzer_2_array_crystal_array_4_this_box_volume
#define global_geometry_element mccchannel_7_analyzer_2_array_crystal_array_4_global_geometry_element
#define this_box_storage mccchannel_7_analyzer_2_array_crystal_array_4_this_box_storage
#define material_string mccchannel_7_analyzer_2_array_crystal_array_4_material_string
#define priority mccchannel_7_analyzer_2_array_crystal_array_4_priority
#define xwidth mccchannel_7_analyzer_2_array_crystal_array_4_xwidth
#define yheight mccchannel_7_analyzer_2_array_crystal_array_4_yheight
#define zdepth mccchannel_7_analyzer_2_array_crystal_array_4_zdepth
#define xwidth2 mccchannel_7_analyzer_2_array_crystal_array_4_xwidth2
#define yheight2 mccchannel_7_analyzer_2_array_crystal_array_4_yheight2
#define visualize mccchannel_7_analyzer_2_array_crystal_array_4_visualize
#define target_index mccchannel_7_analyzer_2_array_crystal_array_4_target_index
#define target_x mccchannel_7_analyzer_2_array_crystal_array_4_target_x
#define target_y mccchannel_7_analyzer_2_array_crystal_array_4_target_y
#define target_z mccchannel_7_analyzer_2_array_crystal_array_4_target_z
#define focus_aw mccchannel_7_analyzer_2_array_crystal_array_4_focus_aw
#define focus_ah mccchannel_7_analyzer_2_array_crystal_array_4_focus_ah
#define focus_xw mccchannel_7_analyzer_2_array_crystal_array_4_focus_xw
#define focus_xh mccchannel_7_analyzer_2_array_crystal_array_4_focus_xh
#define focus_r mccchannel_7_analyzer_2_array_crystal_array_4_focus_r
#define p_interact mccchannel_7_analyzer_2_array_crystal_array_4_p_interact
#define mask_string mccchannel_7_analyzer_2_array_crystal_array_4_mask_string
#define mask_setting mccchannel_7_analyzer_2_array_crystal_array_4_mask_setting
#define number_of_activations mccchannel_7_analyzer_2_array_crystal_array_4_number_of_activations
#line 204 "Union_box.comp"
// Needed for transport to the main component
struct global_geometry_element_struct global_geometry_element;

#ifndef ANY_GEOMETRY_DETECTOR_DECLARE
    #define ANY_GEOMETRY_DETECTOR_DECLARE dummy
	//struct pointer_to_global_geometry_list global_geometry_list = {0,NULL};
#endif

int loop_index,found_geometries;

double x_component;
double y_component;
double z_component;

struct Volume_struct this_box_volume;
struct box_storage this_box_storage;

#line 52810 "MACS_sample_kidney_box.c"
#undef number_of_activations
#undef mask_setting
#undef mask_string
#undef p_interact
#undef focus_r
#undef focus_xh
#undef focus_xw
#undef focus_ah
#undef focus_aw
#undef target_z
#undef target_y
#undef target_x
#undef target_index
#undef visualize
#undef yheight2
#undef xwidth2
#undef zdepth
#undef yheight
#undef xwidth
#undef priority
#undef material_string
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

/* User declarations for component 'channel_7_analyzer_2_array_crystal_array_5' [412]. */
#define mccompcurname  channel_7_analyzer_2_array_crystal_array_5
#define mccompcurtype  Union_box
#define mccompcurindex 412
#define loop_index mccchannel_7_analyzer_2_array_crystal_array_5_loop_index
#define this_box_volume mccchannel_7_analyzer_2_array_crystal_array_5_this_box_volume
#define global_geometry_element mccchannel_7_analyzer_2_array_crystal_array_5_global_geometry_element
#define this_box_storage mccchannel_7_analyzer_2_array_crystal_array_5_this_box_storage
#define material_string mccchannel_7_analyzer_2_array_crystal_array_5_material_string
#define priority mccchannel_7_analyzer_2_array_crystal_array_5_priority
#define xwidth mccchannel_7_analyzer_2_array_crystal_array_5_xwidth
#define yheight mccchannel_7_analyzer_2_array_crystal_array_5_yheight
#define zdepth mccchannel_7_analyzer_2_array_crystal_array_5_zdepth
#define xwidth2 mccchannel_7_analyzer_2_array_crystal_array_5_xwidth2
#define yheight2 mccchannel_7_analyzer_2_array_crystal_array_5_yheight2
#define visualize mccchannel_7_analyzer_2_array_crystal_array_5_visualize
#define target_index mccchannel_7_analyzer_2_array_crystal_array_5_target_index
#define target_x mccchannel_7_analyzer_2_array_crystal_array_5_target_x
#define target_y mccchannel_7_analyzer_2_array_crystal_array_5_target_y
#define target_z mccchannel_7_analyzer_2_array_crystal_array_5_target_z
#define focus_aw mccchannel_7_analyzer_2_array_crystal_array_5_focus_aw
#define focus_ah mccchannel_7_analyzer_2_array_crystal_array_5_focus_ah
#define focus_xw mccchannel_7_analyzer_2_array_crystal_array_5_focus_xw
#define focus_xh mccchannel_7_analyzer_2_array_crystal_array_5_focus_xh
#define focus_r mccchannel_7_analyzer_2_array_crystal_array_5_focus_r
#define p_interact mccchannel_7_analyzer_2_array_crystal_array_5_p_interact
#define mask_string mccchannel_7_analyzer_2_array_crystal_array_5_mask_string
#define mask_setting mccchannel_7_analyzer_2_array_crystal_array_5_mask_setting
#define number_of_activations mccchannel_7_analyzer_2_array_crystal_array_5_number_of_activations
#line 204 "Union_box.comp"
// Needed for transport to the main component
struct global_geometry_element_struct global_geometry_element;

#ifndef ANY_GEOMETRY_DETECTOR_DECLARE
    #define ANY_GEOMETRY_DETECTOR_DECLARE dummy
	//struct pointer_to_global_geometry_list global_geometry_list = {0,NULL};
#endif

int loop_index,found_geometries;

double x_component;
double y_component;
double z_component;

struct Volume_struct this_box_volume;
struct box_storage this_box_storage;

#line 52887 "MACS_sample_kidney_box.c"
#undef number_of_activations
#undef mask_setting
#undef mask_string
#undef p_interact
#undef focus_r
#undef focus_xh
#undef focus_xw
#undef focus_ah
#undef focus_aw
#undef target_z
#undef target_y
#undef target_x
#undef target_index
#undef visualize
#undef yheight2
#undef xwidth2
#undef zdepth
#undef yheight
#undef xwidth
#undef priority
#undef material_string
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

/* User declarations for component 'channel_7_analyzer_2_array_crystal_array_6' [413]. */
#define mccompcurname  channel_7_analyzer_2_array_crystal_array_6
#define mccompcurtype  Union_box
#define mccompcurindex 413
#define loop_index mccchannel_7_analyzer_2_array_crystal_array_6_loop_index
#define this_box_volume mccchannel_7_analyzer_2_array_crystal_array_6_this_box_volume
#define global_geometry_element mccchannel_7_analyzer_2_array_crystal_array_6_global_geometry_element
#define this_box_storage mccchannel_7_analyzer_2_array_crystal_array_6_this_box_storage
#define material_string mccchannel_7_analyzer_2_array_crystal_array_6_material_string
#define priority mccchannel_7_analyzer_2_array_crystal_array_6_priority
#define xwidth mccchannel_7_analyzer_2_array_crystal_array_6_xwidth
#define yheight mccchannel_7_analyzer_2_array_crystal_array_6_yheight
#define zdepth mccchannel_7_analyzer_2_array_crystal_array_6_zdepth
#define xwidth2 mccchannel_7_analyzer_2_array_crystal_array_6_xwidth2
#define yheight2 mccchannel_7_analyzer_2_array_crystal_array_6_yheight2
#define visualize mccchannel_7_analyzer_2_array_crystal_array_6_visualize
#define target_index mccchannel_7_analyzer_2_array_crystal_array_6_target_index
#define target_x mccchannel_7_analyzer_2_array_crystal_array_6_target_x
#define target_y mccchannel_7_analyzer_2_array_crystal_array_6_target_y
#define target_z mccchannel_7_analyzer_2_array_crystal_array_6_target_z
#define focus_aw mccchannel_7_analyzer_2_array_crystal_array_6_focus_aw
#define focus_ah mccchannel_7_analyzer_2_array_crystal_array_6_focus_ah
#define focus_xw mccchannel_7_analyzer_2_array_crystal_array_6_focus_xw
#define focus_xh mccchannel_7_analyzer_2_array_crystal_array_6_focus_xh
#define focus_r mccchannel_7_analyzer_2_array_crystal_array_6_focus_r
#define p_interact mccchannel_7_analyzer_2_array_crystal_array_6_p_interact
#define mask_string mccchannel_7_analyzer_2_array_crystal_array_6_mask_string
#define mask_setting mccchannel_7_analyzer_2_array_crystal_array_6_mask_setting
#define number_of_activations mccchannel_7_analyzer_2_array_crystal_array_6_number_of_activations
#line 204 "Union_box.comp"
// Needed for transport to the main component
struct global_geometry_element_struct global_geometry_element;

#ifndef ANY_GEOMETRY_DETECTOR_DECLARE
    #define ANY_GEOMETRY_DETECTOR_DECLARE dummy
	//struct pointer_to_global_geometry_list global_geometry_list = {0,NULL};
#endif

int loop_index,found_geometries;

double x_component;
double y_component;
double z_component;

struct Volume_struct this_box_volume;
struct box_storage this_box_storage;

#line 52964 "MACS_sample_kidney_box.c"
#undef number_of_activations
#undef mask_setting
#undef mask_string
#undef p_interact
#undef focus_r
#undef focus_xh
#undef focus_xw
#undef focus_ah
#undef focus_aw
#undef target_z
#undef target_y
#undef target_x
#undef target_index
#undef visualize
#undef yheight2
#undef xwidth2
#undef zdepth
#undef yheight
#undef xwidth
#undef priority
#undef material_string
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

/* User declarations for component 'channel_7_analyzer_2_array_crystal_array_7' [414]. */
#define mccompcurname  channel_7_analyzer_2_array_crystal_array_7
#define mccompcurtype  Union_box
#define mccompcurindex 414
#define loop_index mccchannel_7_analyzer_2_array_crystal_array_7_loop_index
#define this_box_volume mccchannel_7_analyzer_2_array_crystal_array_7_this_box_volume
#define global_geometry_element mccchannel_7_analyzer_2_array_crystal_array_7_global_geometry_element
#define this_box_storage mccchannel_7_analyzer_2_array_crystal_array_7_this_box_storage
#define material_string mccchannel_7_analyzer_2_array_crystal_array_7_material_string
#define priority mccchannel_7_analyzer_2_array_crystal_array_7_priority
#define xwidth mccchannel_7_analyzer_2_array_crystal_array_7_xwidth
#define yheight mccchannel_7_analyzer_2_array_crystal_array_7_yheight
#define zdepth mccchannel_7_analyzer_2_array_crystal_array_7_zdepth
#define xwidth2 mccchannel_7_analyzer_2_array_crystal_array_7_xwidth2
#define yheight2 mccchannel_7_analyzer_2_array_crystal_array_7_yheight2
#define visualize mccchannel_7_analyzer_2_array_crystal_array_7_visualize
#define target_index mccchannel_7_analyzer_2_array_crystal_array_7_target_index
#define target_x mccchannel_7_analyzer_2_array_crystal_array_7_target_x
#define target_y mccchannel_7_analyzer_2_array_crystal_array_7_target_y
#define target_z mccchannel_7_analyzer_2_array_crystal_array_7_target_z
#define focus_aw mccchannel_7_analyzer_2_array_crystal_array_7_focus_aw
#define focus_ah mccchannel_7_analyzer_2_array_crystal_array_7_focus_ah
#define focus_xw mccchannel_7_analyzer_2_array_crystal_array_7_focus_xw
#define focus_xh mccchannel_7_analyzer_2_array_crystal_array_7_focus_xh
#define focus_r mccchannel_7_analyzer_2_array_crystal_array_7_focus_r
#define p_interact mccchannel_7_analyzer_2_array_crystal_array_7_p_interact
#define mask_string mccchannel_7_analyzer_2_array_crystal_array_7_mask_string
#define mask_setting mccchannel_7_analyzer_2_array_crystal_array_7_mask_setting
#define number_of_activations mccchannel_7_analyzer_2_array_crystal_array_7_number_of_activations
#line 204 "Union_box.comp"
// Needed for transport to the main component
struct global_geometry_element_struct global_geometry_element;

#ifndef ANY_GEOMETRY_DETECTOR_DECLARE
    #define ANY_GEOMETRY_DETECTOR_DECLARE dummy
	//struct pointer_to_global_geometry_list global_geometry_list = {0,NULL};
#endif

int loop_index,found_geometries;

double x_component;
double y_component;
double z_component;

struct Volume_struct this_box_volume;
struct box_storage this_box_storage;

#line 53041 "MACS_sample_kidney_box.c"
#undef number_of_activations
#undef mask_setting
#undef mask_string
#undef p_interact
#undef focus_r
#undef focus_xh
#undef focus_xw
#undef focus_ah
#undef focus_aw
#undef target_z
#undef target_y
#undef target_x
#undef target_index
#undef visualize
#undef yheight2
#undef xwidth2
#undef zdepth
#undef yheight
#undef xwidth
#undef priority
#undef material_string
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

/* User declarations for component 'channel_7_analyzer_2_array_crystal_array_8' [415]. */
#define mccompcurname  channel_7_analyzer_2_array_crystal_array_8
#define mccompcurtype  Union_box
#define mccompcurindex 415
#define loop_index mccchannel_7_analyzer_2_array_crystal_array_8_loop_index
#define this_box_volume mccchannel_7_analyzer_2_array_crystal_array_8_this_box_volume
#define global_geometry_element mccchannel_7_analyzer_2_array_crystal_array_8_global_geometry_element
#define this_box_storage mccchannel_7_analyzer_2_array_crystal_array_8_this_box_storage
#define material_string mccchannel_7_analyzer_2_array_crystal_array_8_material_string
#define priority mccchannel_7_analyzer_2_array_crystal_array_8_priority
#define xwidth mccchannel_7_analyzer_2_array_crystal_array_8_xwidth
#define yheight mccchannel_7_analyzer_2_array_crystal_array_8_yheight
#define zdepth mccchannel_7_analyzer_2_array_crystal_array_8_zdepth
#define xwidth2 mccchannel_7_analyzer_2_array_crystal_array_8_xwidth2
#define yheight2 mccchannel_7_analyzer_2_array_crystal_array_8_yheight2
#define visualize mccchannel_7_analyzer_2_array_crystal_array_8_visualize
#define target_index mccchannel_7_analyzer_2_array_crystal_array_8_target_index
#define target_x mccchannel_7_analyzer_2_array_crystal_array_8_target_x
#define target_y mccchannel_7_analyzer_2_array_crystal_array_8_target_y
#define target_z mccchannel_7_analyzer_2_array_crystal_array_8_target_z
#define focus_aw mccchannel_7_analyzer_2_array_crystal_array_8_focus_aw
#define focus_ah mccchannel_7_analyzer_2_array_crystal_array_8_focus_ah
#define focus_xw mccchannel_7_analyzer_2_array_crystal_array_8_focus_xw
#define focus_xh mccchannel_7_analyzer_2_array_crystal_array_8_focus_xh
#define focus_r mccchannel_7_analyzer_2_array_crystal_array_8_focus_r
#define p_interact mccchannel_7_analyzer_2_array_crystal_array_8_p_interact
#define mask_string mccchannel_7_analyzer_2_array_crystal_array_8_mask_string
#define mask_setting mccchannel_7_analyzer_2_array_crystal_array_8_mask_setting
#define number_of_activations mccchannel_7_analyzer_2_array_crystal_array_8_number_of_activations
#line 204 "Union_box.comp"
// Needed for transport to the main component
struct global_geometry_element_struct global_geometry_element;

#ifndef ANY_GEOMETRY_DETECTOR_DECLARE
    #define ANY_GEOMETRY_DETECTOR_DECLARE dummy
	//struct pointer_to_global_geometry_list global_geometry_list = {0,NULL};
#endif

int loop_index,found_geometries;

double x_component;
double y_component;
double z_component;

struct Volume_struct this_box_volume;
struct box_storage this_box_storage;

#line 53118 "MACS_sample_kidney_box.c"
#undef number_of_activations
#undef mask_setting
#undef mask_string
#undef p_interact
#undef focus_r
#undef focus_xh
#undef focus_xw
#undef focus_ah
#undef focus_aw
#undef target_z
#undef target_y
#undef target_x
#undef target_index
#undef visualize
#undef yheight2
#undef xwidth2
#undef zdepth
#undef yheight
#undef xwidth
#undef priority
#undef material_string
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

/* User declarations for component 'channel_7_cave2_cyl1' [416]. */
#define mccompcurname  channel_7_cave2_cyl1
#define mccompcurtype  Union_cylinder
#define mccompcurindex 416
#define loop_index mccchannel_7_cave2_cyl1_loop_index
#define this_cylinder_volume mccchannel_7_cave2_cyl1_this_cylinder_volume
#define global_geometry_element mccchannel_7_cave2_cyl1_global_geometry_element
#define this_cylinder_storage mccchannel_7_cave2_cyl1_this_cylinder_storage
#define material_string mccchannel_7_cave2_cyl1_material_string
#define priority mccchannel_7_cave2_cyl1_priority
#define radius mccchannel_7_cave2_cyl1_radius
#define yheight mccchannel_7_cave2_cyl1_yheight
#define visualize mccchannel_7_cave2_cyl1_visualize
#define target_index mccchannel_7_cave2_cyl1_target_index
#define target_x mccchannel_7_cave2_cyl1_target_x
#define target_y mccchannel_7_cave2_cyl1_target_y
#define target_z mccchannel_7_cave2_cyl1_target_z
#define focus_aw mccchannel_7_cave2_cyl1_focus_aw
#define focus_ah mccchannel_7_cave2_cyl1_focus_ah
#define focus_xw mccchannel_7_cave2_cyl1_focus_xw
#define focus_xh mccchannel_7_cave2_cyl1_focus_xh
#define focus_r mccchannel_7_cave2_cyl1_focus_r
#define p_interact mccchannel_7_cave2_cyl1_p_interact
#define mask_string mccchannel_7_cave2_cyl1_mask_string
#define mask_setting mccchannel_7_cave2_cyl1_mask_setting
#define number_of_activations mccchannel_7_cave2_cyl1_number_of_activations
#line 167 "Union_cylinder.comp"
// Needed for transport to the main component
struct global_geometry_element_struct global_geometry_element;

#ifndef ANY_GEOMETRY_DETECTOR_DECLARE
    #define ANY_GEOMETRY_DETECTOR_DECLARE dummy
	//struct pointer_to_global_geometry_list global_geometry_list = {0,NULL};
#endif

int dummy;
int loop_index,found_geometries;
int loop_2_index;
int material_index;

struct Volume_struct this_cylinder_volume;
struct cylinder_storage this_cylinder_storage;
#line 53190 "MACS_sample_kidney_box.c"
#undef number_of_activations
#undef mask_setting
#undef mask_string
#undef p_interact
#undef focus_r
#undef focus_xh
#undef focus_xw
#undef focus_ah
#undef focus_aw
#undef target_z
#undef target_y
#undef target_x
#undef target_index
#undef visualize
#undef yheight
#undef radius
#undef priority
#undef material_string
#undef this_cylinder_storage
#undef global_geometry_element
#undef this_cylinder_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

/* User declarations for component 'channel_7_cave2_box1' [417]. */
#define mccompcurname  channel_7_cave2_box1
#define mccompcurtype  Union_box
#define mccompcurindex 417
#define loop_index mccchannel_7_cave2_box1_loop_index
#define this_box_volume mccchannel_7_cave2_box1_this_box_volume
#define global_geometry_element mccchannel_7_cave2_box1_global_geometry_element
#define this_box_storage mccchannel_7_cave2_box1_this_box_storage
#define material_string mccchannel_7_cave2_box1_material_string
#define priority mccchannel_7_cave2_box1_priority
#define xwidth mccchannel_7_cave2_box1_xwidth
#define yheight mccchannel_7_cave2_box1_yheight
#define zdepth mccchannel_7_cave2_box1_zdepth
#define xwidth2 mccchannel_7_cave2_box1_xwidth2
#define yheight2 mccchannel_7_cave2_box1_yheight2
#define visualize mccchannel_7_cave2_box1_visualize
#define target_index mccchannel_7_cave2_box1_target_index
#define target_x mccchannel_7_cave2_box1_target_x
#define target_y mccchannel_7_cave2_box1_target_y
#define target_z mccchannel_7_cave2_box1_target_z
#define focus_aw mccchannel_7_cave2_box1_focus_aw
#define focus_ah mccchannel_7_cave2_box1_focus_ah
#define focus_xw mccchannel_7_cave2_box1_focus_xw
#define focus_xh mccchannel_7_cave2_box1_focus_xh
#define focus_r mccchannel_7_cave2_box1_focus_r
#define p_interact mccchannel_7_cave2_box1_p_interact
#define mask_string mccchannel_7_cave2_box1_mask_string
#define mask_setting mccchannel_7_cave2_box1_mask_setting
#define number_of_activations mccchannel_7_cave2_box1_number_of_activations
#line 204 "Union_box.comp"
// Needed for transport to the main component
struct global_geometry_element_struct global_geometry_element;

#ifndef ANY_GEOMETRY_DETECTOR_DECLARE
    #define ANY_GEOMETRY_DETECTOR_DECLARE dummy
	//struct pointer_to_global_geometry_list global_geometry_list = {0,NULL};
#endif

int loop_index,found_geometries;

double x_component;
double y_component;
double z_component;

struct Volume_struct this_box_volume;
struct box_storage this_box_storage;

#line 53264 "MACS_sample_kidney_box.c"
#undef number_of_activations
#undef mask_setting
#undef mask_string
#undef p_interact
#undef focus_r
#undef focus_xh
#undef focus_xw
#undef focus_ah
#undef focus_aw
#undef target_z
#undef target_y
#undef target_x
#undef target_index
#undef visualize
#undef yheight2
#undef xwidth2
#undef zdepth
#undef yheight
#undef xwidth
#undef priority
#undef material_string
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

/* User declarations for component 'channel_7_cave2_box2' [418]. */
#define mccompcurname  channel_7_cave2_box2
#define mccompcurtype  Union_box
#define mccompcurindex 418
#define loop_index mccchannel_7_cave2_box2_loop_index
#define this_box_volume mccchannel_7_cave2_box2_this_box_volume
#define global_geometry_element mccchannel_7_cave2_box2_global_geometry_element
#define this_box_storage mccchannel_7_cave2_box2_this_box_storage
#define material_string mccchannel_7_cave2_box2_material_string
#define priority mccchannel_7_cave2_box2_priority
#define xwidth mccchannel_7_cave2_box2_xwidth
#define yheight mccchannel_7_cave2_box2_yheight
#define zdepth mccchannel_7_cave2_box2_zdepth
#define xwidth2 mccchannel_7_cave2_box2_xwidth2
#define yheight2 mccchannel_7_cave2_box2_yheight2
#define visualize mccchannel_7_cave2_box2_visualize
#define target_index mccchannel_7_cave2_box2_target_index
#define target_x mccchannel_7_cave2_box2_target_x
#define target_y mccchannel_7_cave2_box2_target_y
#define target_z mccchannel_7_cave2_box2_target_z
#define focus_aw mccchannel_7_cave2_box2_focus_aw
#define focus_ah mccchannel_7_cave2_box2_focus_ah
#define focus_xw mccchannel_7_cave2_box2_focus_xw
#define focus_xh mccchannel_7_cave2_box2_focus_xh
#define focus_r mccchannel_7_cave2_box2_focus_r
#define p_interact mccchannel_7_cave2_box2_p_interact
#define mask_string mccchannel_7_cave2_box2_mask_string
#define mask_setting mccchannel_7_cave2_box2_mask_setting
#define number_of_activations mccchannel_7_cave2_box2_number_of_activations
#line 204 "Union_box.comp"
// Needed for transport to the main component
struct global_geometry_element_struct global_geometry_element;

#ifndef ANY_GEOMETRY_DETECTOR_DECLARE
    #define ANY_GEOMETRY_DETECTOR_DECLARE dummy
	//struct pointer_to_global_geometry_list global_geometry_list = {0,NULL};
#endif

int loop_index,found_geometries;

double x_component;
double y_component;
double z_component;

struct Volume_struct this_box_volume;
struct box_storage this_box_storage;

#line 53341 "MACS_sample_kidney_box.c"
#undef number_of_activations
#undef mask_setting
#undef mask_string
#undef p_interact
#undef focus_r
#undef focus_xh
#undef focus_xw
#undef focus_ah
#undef focus_aw
#undef target_z
#undef target_y
#undef target_x
#undef target_index
#undef visualize
#undef yheight2
#undef xwidth2
#undef zdepth
#undef yheight
#undef xwidth
#undef priority
#undef material_string
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

/* User declarations for component 'channel_7_cave2_box3' [419]. */
#define mccompcurname  channel_7_cave2_box3
#define mccompcurtype  Union_box
#define mccompcurindex 419
#define loop_index mccchannel_7_cave2_box3_loop_index
#define this_box_volume mccchannel_7_cave2_box3_this_box_volume
#define global_geometry_element mccchannel_7_cave2_box3_global_geometry_element
#define this_box_storage mccchannel_7_cave2_box3_this_box_storage
#define material_string mccchannel_7_cave2_box3_material_string
#define priority mccchannel_7_cave2_box3_priority
#define xwidth mccchannel_7_cave2_box3_xwidth
#define yheight mccchannel_7_cave2_box3_yheight
#define zdepth mccchannel_7_cave2_box3_zdepth
#define xwidth2 mccchannel_7_cave2_box3_xwidth2
#define yheight2 mccchannel_7_cave2_box3_yheight2
#define visualize mccchannel_7_cave2_box3_visualize
#define target_index mccchannel_7_cave2_box3_target_index
#define target_x mccchannel_7_cave2_box3_target_x
#define target_y mccchannel_7_cave2_box3_target_y
#define target_z mccchannel_7_cave2_box3_target_z
#define focus_aw mccchannel_7_cave2_box3_focus_aw
#define focus_ah mccchannel_7_cave2_box3_focus_ah
#define focus_xw mccchannel_7_cave2_box3_focus_xw
#define focus_xh mccchannel_7_cave2_box3_focus_xh
#define focus_r mccchannel_7_cave2_box3_focus_r
#define p_interact mccchannel_7_cave2_box3_p_interact
#define mask_string mccchannel_7_cave2_box3_mask_string
#define mask_setting mccchannel_7_cave2_box3_mask_setting
#define number_of_activations mccchannel_7_cave2_box3_number_of_activations
#line 204 "Union_box.comp"
// Needed for transport to the main component
struct global_geometry_element_struct global_geometry_element;

#ifndef ANY_GEOMETRY_DETECTOR_DECLARE
    #define ANY_GEOMETRY_DETECTOR_DECLARE dummy
	//struct pointer_to_global_geometry_list global_geometry_list = {0,NULL};
#endif

int loop_index,found_geometries;

double x_component;
double y_component;
double z_component;

struct Volume_struct this_box_volume;
struct box_storage this_box_storage;

#line 53418 "MACS_sample_kidney_box.c"
#undef number_of_activations
#undef mask_setting
#undef mask_string
#undef p_interact
#undef focus_r
#undef focus_xh
#undef focus_xw
#undef focus_ah
#undef focus_aw
#undef target_z
#undef target_y
#undef target_x
#undef target_index
#undef visualize
#undef yheight2
#undef xwidth2
#undef zdepth
#undef yheight
#undef xwidth
#undef priority
#undef material_string
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

/* User declarations for component 'inter_analyzer_colimator_center_7' [420]. */
#define mccompcurname  inter_analyzer_colimator_center_7
#define mccompcurtype  Arm
#define mccompcurindex 420
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

/* User declarations for component 'inter_analyzer_colimator_7_blade_0' [421]. */
#define mccompcurname  inter_analyzer_colimator_7_blade_0
#define mccompcurtype  Union_box
#define mccompcurindex 421
#define loop_index mccinter_analyzer_colimator_7_blade_0_loop_index
#define this_box_volume mccinter_analyzer_colimator_7_blade_0_this_box_volume
#define global_geometry_element mccinter_analyzer_colimator_7_blade_0_global_geometry_element
#define this_box_storage mccinter_analyzer_colimator_7_blade_0_this_box_storage
#define material_string mccinter_analyzer_colimator_7_blade_0_material_string
#define priority mccinter_analyzer_colimator_7_blade_0_priority
#define xwidth mccinter_analyzer_colimator_7_blade_0_xwidth
#define yheight mccinter_analyzer_colimator_7_blade_0_yheight
#define zdepth mccinter_analyzer_colimator_7_blade_0_zdepth
#define xwidth2 mccinter_analyzer_colimator_7_blade_0_xwidth2
#define yheight2 mccinter_analyzer_colimator_7_blade_0_yheight2
#define visualize mccinter_analyzer_colimator_7_blade_0_visualize
#define target_index mccinter_analyzer_colimator_7_blade_0_target_index
#define target_x mccinter_analyzer_colimator_7_blade_0_target_x
#define target_y mccinter_analyzer_colimator_7_blade_0_target_y
#define target_z mccinter_analyzer_colimator_7_blade_0_target_z
#define focus_aw mccinter_analyzer_colimator_7_blade_0_focus_aw
#define focus_ah mccinter_analyzer_colimator_7_blade_0_focus_ah
#define focus_xw mccinter_analyzer_colimator_7_blade_0_focus_xw
#define focus_xh mccinter_analyzer_colimator_7_blade_0_focus_xh
#define focus_r mccinter_analyzer_colimator_7_blade_0_focus_r
#define p_interact mccinter_analyzer_colimator_7_blade_0_p_interact
#define mask_string mccinter_analyzer_colimator_7_blade_0_mask_string
#define mask_setting mccinter_analyzer_colimator_7_blade_0_mask_setting
#define number_of_activations mccinter_analyzer_colimator_7_blade_0_number_of_activations
#line 204 "Union_box.comp"
// Needed for transport to the main component
struct global_geometry_element_struct global_geometry_element;

#ifndef ANY_GEOMETRY_DETECTOR_DECLARE
    #define ANY_GEOMETRY_DETECTOR_DECLARE dummy
	//struct pointer_to_global_geometry_list global_geometry_list = {0,NULL};
#endif

int loop_index,found_geometries;

double x_component;
double y_component;
double z_component;

struct Volume_struct this_box_volume;
struct box_storage this_box_storage;

#line 53503 "MACS_sample_kidney_box.c"
#undef number_of_activations
#undef mask_setting
#undef mask_string
#undef p_interact
#undef focus_r
#undef focus_xh
#undef focus_xw
#undef focus_ah
#undef focus_aw
#undef target_z
#undef target_y
#undef target_x
#undef target_index
#undef visualize
#undef yheight2
#undef xwidth2
#undef zdepth
#undef yheight
#undef xwidth
#undef priority
#undef material_string
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

/* User declarations for component 'inter_analyzer_colimator_7_blade_1' [422]. */
#define mccompcurname  inter_analyzer_colimator_7_blade_1
#define mccompcurtype  Union_box
#define mccompcurindex 422
#define loop_index mccinter_analyzer_colimator_7_blade_1_loop_index
#define this_box_volume mccinter_analyzer_colimator_7_blade_1_this_box_volume
#define global_geometry_element mccinter_analyzer_colimator_7_blade_1_global_geometry_element
#define this_box_storage mccinter_analyzer_colimator_7_blade_1_this_box_storage
#define material_string mccinter_analyzer_colimator_7_blade_1_material_string
#define priority mccinter_analyzer_colimator_7_blade_1_priority
#define xwidth mccinter_analyzer_colimator_7_blade_1_xwidth
#define yheight mccinter_analyzer_colimator_7_blade_1_yheight
#define zdepth mccinter_analyzer_colimator_7_blade_1_zdepth
#define xwidth2 mccinter_analyzer_colimator_7_blade_1_xwidth2
#define yheight2 mccinter_analyzer_colimator_7_blade_1_yheight2
#define visualize mccinter_analyzer_colimator_7_blade_1_visualize
#define target_index mccinter_analyzer_colimator_7_blade_1_target_index
#define target_x mccinter_analyzer_colimator_7_blade_1_target_x
#define target_y mccinter_analyzer_colimator_7_blade_1_target_y
#define target_z mccinter_analyzer_colimator_7_blade_1_target_z
#define focus_aw mccinter_analyzer_colimator_7_blade_1_focus_aw
#define focus_ah mccinter_analyzer_colimator_7_blade_1_focus_ah
#define focus_xw mccinter_analyzer_colimator_7_blade_1_focus_xw
#define focus_xh mccinter_analyzer_colimator_7_blade_1_focus_xh
#define focus_r mccinter_analyzer_colimator_7_blade_1_focus_r
#define p_interact mccinter_analyzer_colimator_7_blade_1_p_interact
#define mask_string mccinter_analyzer_colimator_7_blade_1_mask_string
#define mask_setting mccinter_analyzer_colimator_7_blade_1_mask_setting
#define number_of_activations mccinter_analyzer_colimator_7_blade_1_number_of_activations
#line 204 "Union_box.comp"
// Needed for transport to the main component
struct global_geometry_element_struct global_geometry_element;

#ifndef ANY_GEOMETRY_DETECTOR_DECLARE
    #define ANY_GEOMETRY_DETECTOR_DECLARE dummy
	//struct pointer_to_global_geometry_list global_geometry_list = {0,NULL};
#endif

int loop_index,found_geometries;

double x_component;
double y_component;
double z_component;

struct Volume_struct this_box_volume;
struct box_storage this_box_storage;

#line 53580 "MACS_sample_kidney_box.c"
#undef number_of_activations
#undef mask_setting
#undef mask_string
#undef p_interact
#undef focus_r
#undef focus_xh
#undef focus_xw
#undef focus_ah
#undef focus_aw
#undef target_z
#undef target_y
#undef target_x
#undef target_index
#undef visualize
#undef yheight2
#undef xwidth2
#undef zdepth
#undef yheight
#undef xwidth
#undef priority
#undef material_string
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

/* User declarations for component 'inter_analyzer_colimator_7_blade_2' [423]. */
#define mccompcurname  inter_analyzer_colimator_7_blade_2
#define mccompcurtype  Union_box
#define mccompcurindex 423
#define loop_index mccinter_analyzer_colimator_7_blade_2_loop_index
#define this_box_volume mccinter_analyzer_colimator_7_blade_2_this_box_volume
#define global_geometry_element mccinter_analyzer_colimator_7_blade_2_global_geometry_element
#define this_box_storage mccinter_analyzer_colimator_7_blade_2_this_box_storage
#define material_string mccinter_analyzer_colimator_7_blade_2_material_string
#define priority mccinter_analyzer_colimator_7_blade_2_priority
#define xwidth mccinter_analyzer_colimator_7_blade_2_xwidth
#define yheight mccinter_analyzer_colimator_7_blade_2_yheight
#define zdepth mccinter_analyzer_colimator_7_blade_2_zdepth
#define xwidth2 mccinter_analyzer_colimator_7_blade_2_xwidth2
#define yheight2 mccinter_analyzer_colimator_7_blade_2_yheight2
#define visualize mccinter_analyzer_colimator_7_blade_2_visualize
#define target_index mccinter_analyzer_colimator_7_blade_2_target_index
#define target_x mccinter_analyzer_colimator_7_blade_2_target_x
#define target_y mccinter_analyzer_colimator_7_blade_2_target_y
#define target_z mccinter_analyzer_colimator_7_blade_2_target_z
#define focus_aw mccinter_analyzer_colimator_7_blade_2_focus_aw
#define focus_ah mccinter_analyzer_colimator_7_blade_2_focus_ah
#define focus_xw mccinter_analyzer_colimator_7_blade_2_focus_xw
#define focus_xh mccinter_analyzer_colimator_7_blade_2_focus_xh
#define focus_r mccinter_analyzer_colimator_7_blade_2_focus_r
#define p_interact mccinter_analyzer_colimator_7_blade_2_p_interact
#define mask_string mccinter_analyzer_colimator_7_blade_2_mask_string
#define mask_setting mccinter_analyzer_colimator_7_blade_2_mask_setting
#define number_of_activations mccinter_analyzer_colimator_7_blade_2_number_of_activations
#line 204 "Union_box.comp"
// Needed for transport to the main component
struct global_geometry_element_struct global_geometry_element;

#ifndef ANY_GEOMETRY_DETECTOR_DECLARE
    #define ANY_GEOMETRY_DETECTOR_DECLARE dummy
	//struct pointer_to_global_geometry_list global_geometry_list = {0,NULL};
#endif

int loop_index,found_geometries;

double x_component;
double y_component;
double z_component;

struct Volume_struct this_box_volume;
struct box_storage this_box_storage;

#line 53657 "MACS_sample_kidney_box.c"
#undef number_of_activations
#undef mask_setting
#undef mask_string
#undef p_interact
#undef focus_r
#undef focus_xh
#undef focus_xw
#undef focus_ah
#undef focus_aw
#undef target_z
#undef target_y
#undef target_x
#undef target_index
#undef visualize
#undef yheight2
#undef xwidth2
#undef zdepth
#undef yheight
#undef xwidth
#undef priority
#undef material_string
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

/* User declarations for component 'inter_analyzer_colimator_7_blade_3' [424]. */
#define mccompcurname  inter_analyzer_colimator_7_blade_3
#define mccompcurtype  Union_box
#define mccompcurindex 424
#define loop_index mccinter_analyzer_colimator_7_blade_3_loop_index
#define this_box_volume mccinter_analyzer_colimator_7_blade_3_this_box_volume
#define global_geometry_element mccinter_analyzer_colimator_7_blade_3_global_geometry_element
#define this_box_storage mccinter_analyzer_colimator_7_blade_3_this_box_storage
#define material_string mccinter_analyzer_colimator_7_blade_3_material_string
#define priority mccinter_analyzer_colimator_7_blade_3_priority
#define xwidth mccinter_analyzer_colimator_7_blade_3_xwidth
#define yheight mccinter_analyzer_colimator_7_blade_3_yheight
#define zdepth mccinter_analyzer_colimator_7_blade_3_zdepth
#define xwidth2 mccinter_analyzer_colimator_7_blade_3_xwidth2
#define yheight2 mccinter_analyzer_colimator_7_blade_3_yheight2
#define visualize mccinter_analyzer_colimator_7_blade_3_visualize
#define target_index mccinter_analyzer_colimator_7_blade_3_target_index
#define target_x mccinter_analyzer_colimator_7_blade_3_target_x
#define target_y mccinter_analyzer_colimator_7_blade_3_target_y
#define target_z mccinter_analyzer_colimator_7_blade_3_target_z
#define focus_aw mccinter_analyzer_colimator_7_blade_3_focus_aw
#define focus_ah mccinter_analyzer_colimator_7_blade_3_focus_ah
#define focus_xw mccinter_analyzer_colimator_7_blade_3_focus_xw
#define focus_xh mccinter_analyzer_colimator_7_blade_3_focus_xh
#define focus_r mccinter_analyzer_colimator_7_blade_3_focus_r
#define p_interact mccinter_analyzer_colimator_7_blade_3_p_interact
#define mask_string mccinter_analyzer_colimator_7_blade_3_mask_string
#define mask_setting mccinter_analyzer_colimator_7_blade_3_mask_setting
#define number_of_activations mccinter_analyzer_colimator_7_blade_3_number_of_activations
#line 204 "Union_box.comp"
// Needed for transport to the main component
struct global_geometry_element_struct global_geometry_element;

#ifndef ANY_GEOMETRY_DETECTOR_DECLARE
    #define ANY_GEOMETRY_DETECTOR_DECLARE dummy
	//struct pointer_to_global_geometry_list global_geometry_list = {0,NULL};
#endif

int loop_index,found_geometries;

double x_component;
double y_component;
double z_component;

struct Volume_struct this_box_volume;
struct box_storage this_box_storage;

#line 53734 "MACS_sample_kidney_box.c"
#undef number_of_activations
#undef mask_setting
#undef mask_string
#undef p_interact
#undef focus_r
#undef focus_xh
#undef focus_xw
#undef focus_ah
#undef focus_aw
#undef target_z
#undef target_y
#undef target_x
#undef target_index
#undef visualize
#undef yheight2
#undef xwidth2
#undef zdepth
#undef yheight
#undef xwidth
#undef priority
#undef material_string
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

/* User declarations for component 'inter_analyzer_colimator_7_blade_4' [425]. */
#define mccompcurname  inter_analyzer_colimator_7_blade_4
#define mccompcurtype  Union_box
#define mccompcurindex 425
#define loop_index mccinter_analyzer_colimator_7_blade_4_loop_index
#define this_box_volume mccinter_analyzer_colimator_7_blade_4_this_box_volume
#define global_geometry_element mccinter_analyzer_colimator_7_blade_4_global_geometry_element
#define this_box_storage mccinter_analyzer_colimator_7_blade_4_this_box_storage
#define material_string mccinter_analyzer_colimator_7_blade_4_material_string
#define priority mccinter_analyzer_colimator_7_blade_4_priority
#define xwidth mccinter_analyzer_colimator_7_blade_4_xwidth
#define yheight mccinter_analyzer_colimator_7_blade_4_yheight
#define zdepth mccinter_analyzer_colimator_7_blade_4_zdepth
#define xwidth2 mccinter_analyzer_colimator_7_blade_4_xwidth2
#define yheight2 mccinter_analyzer_colimator_7_blade_4_yheight2
#define visualize mccinter_analyzer_colimator_7_blade_4_visualize
#define target_index mccinter_analyzer_colimator_7_blade_4_target_index
#define target_x mccinter_analyzer_colimator_7_blade_4_target_x
#define target_y mccinter_analyzer_colimator_7_blade_4_target_y
#define target_z mccinter_analyzer_colimator_7_blade_4_target_z
#define focus_aw mccinter_analyzer_colimator_7_blade_4_focus_aw
#define focus_ah mccinter_analyzer_colimator_7_blade_4_focus_ah
#define focus_xw mccinter_analyzer_colimator_7_blade_4_focus_xw
#define focus_xh mccinter_analyzer_colimator_7_blade_4_focus_xh
#define focus_r mccinter_analyzer_colimator_7_blade_4_focus_r
#define p_interact mccinter_analyzer_colimator_7_blade_4_p_interact
#define mask_string mccinter_analyzer_colimator_7_blade_4_mask_string
#define mask_setting mccinter_analyzer_colimator_7_blade_4_mask_setting
#define number_of_activations mccinter_analyzer_colimator_7_blade_4_number_of_activations
#line 204 "Union_box.comp"
// Needed for transport to the main component
struct global_geometry_element_struct global_geometry_element;

#ifndef ANY_GEOMETRY_DETECTOR_DECLARE
    #define ANY_GEOMETRY_DETECTOR_DECLARE dummy
	//struct pointer_to_global_geometry_list global_geometry_list = {0,NULL};
#endif

int loop_index,found_geometries;

double x_component;
double y_component;
double z_component;

struct Volume_struct this_box_volume;
struct box_storage this_box_storage;

#line 53811 "MACS_sample_kidney_box.c"
#undef number_of_activations
#undef mask_setting
#undef mask_string
#undef p_interact
#undef focus_r
#undef focus_xh
#undef focus_xw
#undef focus_ah
#undef focus_aw
#undef target_z
#undef target_y
#undef target_x
#undef target_index
#undef visualize
#undef yheight2
#undef xwidth2
#undef zdepth
#undef yheight
#undef xwidth
#undef priority
#undef material_string
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

/* User declarations for component 'diffraction_detector_7_exit_volume' [426]. */
#define mccompcurname  diffraction_detector_7_exit_volume
#define mccompcurtype  Union_box
#define mccompcurindex 426
#define loop_index mccdiffraction_detector_7_exit_volume_loop_index
#define this_box_volume mccdiffraction_detector_7_exit_volume_this_box_volume
#define global_geometry_element mccdiffraction_detector_7_exit_volume_global_geometry_element
#define this_box_storage mccdiffraction_detector_7_exit_volume_this_box_storage
#define material_string mccdiffraction_detector_7_exit_volume_material_string
#define priority mccdiffraction_detector_7_exit_volume_priority
#define xwidth mccdiffraction_detector_7_exit_volume_xwidth
#define yheight mccdiffraction_detector_7_exit_volume_yheight
#define zdepth mccdiffraction_detector_7_exit_volume_zdepth
#define xwidth2 mccdiffraction_detector_7_exit_volume_xwidth2
#define yheight2 mccdiffraction_detector_7_exit_volume_yheight2
#define visualize mccdiffraction_detector_7_exit_volume_visualize
#define target_index mccdiffraction_detector_7_exit_volume_target_index
#define target_x mccdiffraction_detector_7_exit_volume_target_x
#define target_y mccdiffraction_detector_7_exit_volume_target_y
#define target_z mccdiffraction_detector_7_exit_volume_target_z
#define focus_aw mccdiffraction_detector_7_exit_volume_focus_aw
#define focus_ah mccdiffraction_detector_7_exit_volume_focus_ah
#define focus_xw mccdiffraction_detector_7_exit_volume_focus_xw
#define focus_xh mccdiffraction_detector_7_exit_volume_focus_xh
#define focus_r mccdiffraction_detector_7_exit_volume_focus_r
#define p_interact mccdiffraction_detector_7_exit_volume_p_interact
#define mask_string mccdiffraction_detector_7_exit_volume_mask_string
#define mask_setting mccdiffraction_detector_7_exit_volume_mask_setting
#define number_of_activations mccdiffraction_detector_7_exit_volume_number_of_activations
#line 204 "Union_box.comp"
// Needed for transport to the main component
struct global_geometry_element_struct global_geometry_element;

#ifndef ANY_GEOMETRY_DETECTOR_DECLARE
    #define ANY_GEOMETRY_DETECTOR_DECLARE dummy
	//struct pointer_to_global_geometry_list global_geometry_list = {0,NULL};
#endif

int loop_index,found_geometries;

double x_component;
double y_component;
double z_component;

struct Volume_struct this_box_volume;
struct box_storage this_box_storage;

#line 53888 "MACS_sample_kidney_box.c"
#undef number_of_activations
#undef mask_setting
#undef mask_string
#undef p_interact
#undef focus_r
#undef focus_xh
#undef focus_xw
#undef focus_ah
#undef focus_aw
#undef target_z
#undef target_y
#undef target_x
#undef target_index
#undef visualize
#undef yheight2
#undef xwidth2
#undef zdepth
#undef yheight
#undef xwidth
#undef priority
#undef material_string
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

/* User declarations for component 'spec_detector_7_exit_volume' [427]. */
#define mccompcurname  spec_detector_7_exit_volume
#define mccompcurtype  Union_box
#define mccompcurindex 427
#define loop_index mccspec_detector_7_exit_volume_loop_index
#define this_box_volume mccspec_detector_7_exit_volume_this_box_volume
#define global_geometry_element mccspec_detector_7_exit_volume_global_geometry_element
#define this_box_storage mccspec_detector_7_exit_volume_this_box_storage
#define material_string mccspec_detector_7_exit_volume_material_string
#define priority mccspec_detector_7_exit_volume_priority
#define xwidth mccspec_detector_7_exit_volume_xwidth
#define yheight mccspec_detector_7_exit_volume_yheight
#define zdepth mccspec_detector_7_exit_volume_zdepth
#define xwidth2 mccspec_detector_7_exit_volume_xwidth2
#define yheight2 mccspec_detector_7_exit_volume_yheight2
#define visualize mccspec_detector_7_exit_volume_visualize
#define target_index mccspec_detector_7_exit_volume_target_index
#define target_x mccspec_detector_7_exit_volume_target_x
#define target_y mccspec_detector_7_exit_volume_target_y
#define target_z mccspec_detector_7_exit_volume_target_z
#define focus_aw mccspec_detector_7_exit_volume_focus_aw
#define focus_ah mccspec_detector_7_exit_volume_focus_ah
#define focus_xw mccspec_detector_7_exit_volume_focus_xw
#define focus_xh mccspec_detector_7_exit_volume_focus_xh
#define focus_r mccspec_detector_7_exit_volume_focus_r
#define p_interact mccspec_detector_7_exit_volume_p_interact
#define mask_string mccspec_detector_7_exit_volume_mask_string
#define mask_setting mccspec_detector_7_exit_volume_mask_setting
#define number_of_activations mccspec_detector_7_exit_volume_number_of_activations
#line 204 "Union_box.comp"
// Needed for transport to the main component
struct global_geometry_element_struct global_geometry_element;

#ifndef ANY_GEOMETRY_DETECTOR_DECLARE
    #define ANY_GEOMETRY_DETECTOR_DECLARE dummy
	//struct pointer_to_global_geometry_list global_geometry_list = {0,NULL};
#endif

int loop_index,found_geometries;

double x_component;
double y_component;
double z_component;

struct Volume_struct this_box_volume;
struct box_storage this_box_storage;

#line 53965 "MACS_sample_kidney_box.c"
#undef number_of_activations
#undef mask_setting
#undef mask_string
#undef p_interact
#undef focus_r
#undef focus_xh
#undef focus_xw
#undef focus_ah
#undef focus_aw
#undef target_z
#undef target_y
#undef target_x
#undef target_index
#undef visualize
#undef yheight2
#undef xwidth2
#undef zdepth
#undef yheight
#undef xwidth
#undef priority
#undef material_string
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

/* User declarations for component 'channel_8_cave1_box1' [428]. */
#define mccompcurname  channel_8_cave1_box1
#define mccompcurtype  Union_box
#define mccompcurindex 428
#define loop_index mccchannel_8_cave1_box1_loop_index
#define this_box_volume mccchannel_8_cave1_box1_this_box_volume
#define global_geometry_element mccchannel_8_cave1_box1_global_geometry_element
#define this_box_storage mccchannel_8_cave1_box1_this_box_storage
#define material_string mccchannel_8_cave1_box1_material_string
#define priority mccchannel_8_cave1_box1_priority
#define xwidth mccchannel_8_cave1_box1_xwidth
#define yheight mccchannel_8_cave1_box1_yheight
#define zdepth mccchannel_8_cave1_box1_zdepth
#define xwidth2 mccchannel_8_cave1_box1_xwidth2
#define yheight2 mccchannel_8_cave1_box1_yheight2
#define visualize mccchannel_8_cave1_box1_visualize
#define target_index mccchannel_8_cave1_box1_target_index
#define target_x mccchannel_8_cave1_box1_target_x
#define target_y mccchannel_8_cave1_box1_target_y
#define target_z mccchannel_8_cave1_box1_target_z
#define focus_aw mccchannel_8_cave1_box1_focus_aw
#define focus_ah mccchannel_8_cave1_box1_focus_ah
#define focus_xw mccchannel_8_cave1_box1_focus_xw
#define focus_xh mccchannel_8_cave1_box1_focus_xh
#define focus_r mccchannel_8_cave1_box1_focus_r
#define p_interact mccchannel_8_cave1_box1_p_interact
#define mask_string mccchannel_8_cave1_box1_mask_string
#define mask_setting mccchannel_8_cave1_box1_mask_setting
#define number_of_activations mccchannel_8_cave1_box1_number_of_activations
#line 204 "Union_box.comp"
// Needed for transport to the main component
struct global_geometry_element_struct global_geometry_element;

#ifndef ANY_GEOMETRY_DETECTOR_DECLARE
    #define ANY_GEOMETRY_DETECTOR_DECLARE dummy
	//struct pointer_to_global_geometry_list global_geometry_list = {0,NULL};
#endif

int loop_index,found_geometries;

double x_component;
double y_component;
double z_component;

struct Volume_struct this_box_volume;
struct box_storage this_box_storage;

#line 54042 "MACS_sample_kidney_box.c"
#undef number_of_activations
#undef mask_setting
#undef mask_string
#undef p_interact
#undef focus_r
#undef focus_xh
#undef focus_xw
#undef focus_ah
#undef focus_aw
#undef target_z
#undef target_y
#undef target_x
#undef target_index
#undef visualize
#undef yheight2
#undef xwidth2
#undef zdepth
#undef yheight
#undef xwidth
#undef priority
#undef material_string
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

/* User declarations for component 'channel_8_cave1_box2' [429]. */
#define mccompcurname  channel_8_cave1_box2
#define mccompcurtype  Union_box
#define mccompcurindex 429
#define loop_index mccchannel_8_cave1_box2_loop_index
#define this_box_volume mccchannel_8_cave1_box2_this_box_volume
#define global_geometry_element mccchannel_8_cave1_box2_global_geometry_element
#define this_box_storage mccchannel_8_cave1_box2_this_box_storage
#define material_string mccchannel_8_cave1_box2_material_string
#define priority mccchannel_8_cave1_box2_priority
#define xwidth mccchannel_8_cave1_box2_xwidth
#define yheight mccchannel_8_cave1_box2_yheight
#define zdepth mccchannel_8_cave1_box2_zdepth
#define xwidth2 mccchannel_8_cave1_box2_xwidth2
#define yheight2 mccchannel_8_cave1_box2_yheight2
#define visualize mccchannel_8_cave1_box2_visualize
#define target_index mccchannel_8_cave1_box2_target_index
#define target_x mccchannel_8_cave1_box2_target_x
#define target_y mccchannel_8_cave1_box2_target_y
#define target_z mccchannel_8_cave1_box2_target_z
#define focus_aw mccchannel_8_cave1_box2_focus_aw
#define focus_ah mccchannel_8_cave1_box2_focus_ah
#define focus_xw mccchannel_8_cave1_box2_focus_xw
#define focus_xh mccchannel_8_cave1_box2_focus_xh
#define focus_r mccchannel_8_cave1_box2_focus_r
#define p_interact mccchannel_8_cave1_box2_p_interact
#define mask_string mccchannel_8_cave1_box2_mask_string
#define mask_setting mccchannel_8_cave1_box2_mask_setting
#define number_of_activations mccchannel_8_cave1_box2_number_of_activations
#line 204 "Union_box.comp"
// Needed for transport to the main component
struct global_geometry_element_struct global_geometry_element;

#ifndef ANY_GEOMETRY_DETECTOR_DECLARE
    #define ANY_GEOMETRY_DETECTOR_DECLARE dummy
	//struct pointer_to_global_geometry_list global_geometry_list = {0,NULL};
#endif

int loop_index,found_geometries;

double x_component;
double y_component;
double z_component;

struct Volume_struct this_box_volume;
struct box_storage this_box_storage;

#line 54119 "MACS_sample_kidney_box.c"
#undef number_of_activations
#undef mask_setting
#undef mask_string
#undef p_interact
#undef focus_r
#undef focus_xh
#undef focus_xw
#undef focus_ah
#undef focus_aw
#undef target_z
#undef target_y
#undef target_x
#undef target_index
#undef visualize
#undef yheight2
#undef xwidth2
#undef zdepth
#undef yheight
#undef xwidth
#undef priority
#undef material_string
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

/* User declarations for component 'channel_8_cave1_box3' [430]. */
#define mccompcurname  channel_8_cave1_box3
#define mccompcurtype  Union_box
#define mccompcurindex 430
#define loop_index mccchannel_8_cave1_box3_loop_index
#define this_box_volume mccchannel_8_cave1_box3_this_box_volume
#define global_geometry_element mccchannel_8_cave1_box3_global_geometry_element
#define this_box_storage mccchannel_8_cave1_box3_this_box_storage
#define material_string mccchannel_8_cave1_box3_material_string
#define priority mccchannel_8_cave1_box3_priority
#define xwidth mccchannel_8_cave1_box3_xwidth
#define yheight mccchannel_8_cave1_box3_yheight
#define zdepth mccchannel_8_cave1_box3_zdepth
#define xwidth2 mccchannel_8_cave1_box3_xwidth2
#define yheight2 mccchannel_8_cave1_box3_yheight2
#define visualize mccchannel_8_cave1_box3_visualize
#define target_index mccchannel_8_cave1_box3_target_index
#define target_x mccchannel_8_cave1_box3_target_x
#define target_y mccchannel_8_cave1_box3_target_y
#define target_z mccchannel_8_cave1_box3_target_z
#define focus_aw mccchannel_8_cave1_box3_focus_aw
#define focus_ah mccchannel_8_cave1_box3_focus_ah
#define focus_xw mccchannel_8_cave1_box3_focus_xw
#define focus_xh mccchannel_8_cave1_box3_focus_xh
#define focus_r mccchannel_8_cave1_box3_focus_r
#define p_interact mccchannel_8_cave1_box3_p_interact
#define mask_string mccchannel_8_cave1_box3_mask_string
#define mask_setting mccchannel_8_cave1_box3_mask_setting
#define number_of_activations mccchannel_8_cave1_box3_number_of_activations
#line 204 "Union_box.comp"
// Needed for transport to the main component
struct global_geometry_element_struct global_geometry_element;

#ifndef ANY_GEOMETRY_DETECTOR_DECLARE
    #define ANY_GEOMETRY_DETECTOR_DECLARE dummy
	//struct pointer_to_global_geometry_list global_geometry_list = {0,NULL};
#endif

int loop_index,found_geometries;

double x_component;
double y_component;
double z_component;

struct Volume_struct this_box_volume;
struct box_storage this_box_storage;

#line 54196 "MACS_sample_kidney_box.c"
#undef number_of_activations
#undef mask_setting
#undef mask_string
#undef p_interact
#undef focus_r
#undef focus_xh
#undef focus_xw
#undef focus_ah
#undef focus_aw
#undef target_z
#undef target_y
#undef target_x
#undef target_index
#undef visualize
#undef yheight2
#undef xwidth2
#undef zdepth
#undef yheight
#undef xwidth
#undef priority
#undef material_string
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

/* User declarations for component 'channel_8_cave1_cyl1' [431]. */
#define mccompcurname  channel_8_cave1_cyl1
#define mccompcurtype  Union_cylinder
#define mccompcurindex 431
#define loop_index mccchannel_8_cave1_cyl1_loop_index
#define this_cylinder_volume mccchannel_8_cave1_cyl1_this_cylinder_volume
#define global_geometry_element mccchannel_8_cave1_cyl1_global_geometry_element
#define this_cylinder_storage mccchannel_8_cave1_cyl1_this_cylinder_storage
#define material_string mccchannel_8_cave1_cyl1_material_string
#define priority mccchannel_8_cave1_cyl1_priority
#define radius mccchannel_8_cave1_cyl1_radius
#define yheight mccchannel_8_cave1_cyl1_yheight
#define visualize mccchannel_8_cave1_cyl1_visualize
#define target_index mccchannel_8_cave1_cyl1_target_index
#define target_x mccchannel_8_cave1_cyl1_target_x
#define target_y mccchannel_8_cave1_cyl1_target_y
#define target_z mccchannel_8_cave1_cyl1_target_z
#define focus_aw mccchannel_8_cave1_cyl1_focus_aw
#define focus_ah mccchannel_8_cave1_cyl1_focus_ah
#define focus_xw mccchannel_8_cave1_cyl1_focus_xw
#define focus_xh mccchannel_8_cave1_cyl1_focus_xh
#define focus_r mccchannel_8_cave1_cyl1_focus_r
#define p_interact mccchannel_8_cave1_cyl1_p_interact
#define mask_string mccchannel_8_cave1_cyl1_mask_string
#define mask_setting mccchannel_8_cave1_cyl1_mask_setting
#define number_of_activations mccchannel_8_cave1_cyl1_number_of_activations
#line 167 "Union_cylinder.comp"
// Needed for transport to the main component
struct global_geometry_element_struct global_geometry_element;

#ifndef ANY_GEOMETRY_DETECTOR_DECLARE
    #define ANY_GEOMETRY_DETECTOR_DECLARE dummy
	//struct pointer_to_global_geometry_list global_geometry_list = {0,NULL};
#endif

int dummy;
int loop_index,found_geometries;
int loop_2_index;
int material_index;

struct Volume_struct this_cylinder_volume;
struct cylinder_storage this_cylinder_storage;
#line 54268 "MACS_sample_kidney_box.c"
#undef number_of_activations
#undef mask_setting
#undef mask_string
#undef p_interact
#undef focus_r
#undef focus_xh
#undef focus_xw
#undef focus_ah
#undef focus_aw
#undef target_z
#undef target_y
#undef target_x
#undef target_index
#undef visualize
#undef yheight
#undef radius
#undef priority
#undef material_string
#undef this_cylinder_storage
#undef global_geometry_element
#undef this_cylinder_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

/* User declarations for component 'channel_8_analyzer_1_center' [432]. */
#define mccompcurname  channel_8_analyzer_1_center
#define mccompcurtype  Arm
#define mccompcurindex 432
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

/* User declarations for component 'channel_8_analyzer_1_rotated' [433]. */
#define mccompcurname  channel_8_analyzer_1_rotated
#define mccompcurtype  Arm
#define mccompcurindex 433
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

/* User declarations for component 'channel_8_analyzer_1_array_crystal_array_0' [434]. */
#define mccompcurname  channel_8_analyzer_1_array_crystal_array_0
#define mccompcurtype  Union_box
#define mccompcurindex 434
#define loop_index mccchannel_8_analyzer_1_array_crystal_array_0_loop_index
#define this_box_volume mccchannel_8_analyzer_1_array_crystal_array_0_this_box_volume
#define global_geometry_element mccchannel_8_analyzer_1_array_crystal_array_0_global_geometry_element
#define this_box_storage mccchannel_8_analyzer_1_array_crystal_array_0_this_box_storage
#define material_string mccchannel_8_analyzer_1_array_crystal_array_0_material_string
#define priority mccchannel_8_analyzer_1_array_crystal_array_0_priority
#define xwidth mccchannel_8_analyzer_1_array_crystal_array_0_xwidth
#define yheight mccchannel_8_analyzer_1_array_crystal_array_0_yheight
#define zdepth mccchannel_8_analyzer_1_array_crystal_array_0_zdepth
#define xwidth2 mccchannel_8_analyzer_1_array_crystal_array_0_xwidth2
#define yheight2 mccchannel_8_analyzer_1_array_crystal_array_0_yheight2
#define visualize mccchannel_8_analyzer_1_array_crystal_array_0_visualize
#define target_index mccchannel_8_analyzer_1_array_crystal_array_0_target_index
#define target_x mccchannel_8_analyzer_1_array_crystal_array_0_target_x
#define target_y mccchannel_8_analyzer_1_array_crystal_array_0_target_y
#define target_z mccchannel_8_analyzer_1_array_crystal_array_0_target_z
#define focus_aw mccchannel_8_analyzer_1_array_crystal_array_0_focus_aw
#define focus_ah mccchannel_8_analyzer_1_array_crystal_array_0_focus_ah
#define focus_xw mccchannel_8_analyzer_1_array_crystal_array_0_focus_xw
#define focus_xh mccchannel_8_analyzer_1_array_crystal_array_0_focus_xh
#define focus_r mccchannel_8_analyzer_1_array_crystal_array_0_focus_r
#define p_interact mccchannel_8_analyzer_1_array_crystal_array_0_p_interact
#define mask_string mccchannel_8_analyzer_1_array_crystal_array_0_mask_string
#define mask_setting mccchannel_8_analyzer_1_array_crystal_array_0_mask_setting
#define number_of_activations mccchannel_8_analyzer_1_array_crystal_array_0_number_of_activations
#line 204 "Union_box.comp"
// Needed for transport to the main component
struct global_geometry_element_struct global_geometry_element;

#ifndef ANY_GEOMETRY_DETECTOR_DECLARE
    #define ANY_GEOMETRY_DETECTOR_DECLARE dummy
	//struct pointer_to_global_geometry_list global_geometry_list = {0,NULL};
#endif

int loop_index,found_geometries;

double x_component;
double y_component;
double z_component;

struct Volume_struct this_box_volume;
struct box_storage this_box_storage;

#line 54358 "MACS_sample_kidney_box.c"
#undef number_of_activations
#undef mask_setting
#undef mask_string
#undef p_interact
#undef focus_r
#undef focus_xh
#undef focus_xw
#undef focus_ah
#undef focus_aw
#undef target_z
#undef target_y
#undef target_x
#undef target_index
#undef visualize
#undef yheight2
#undef xwidth2
#undef zdepth
#undef yheight
#undef xwidth
#undef priority
#undef material_string
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

/* User declarations for component 'channel_8_analyzer_1_array_crystal_array_1' [435]. */
#define mccompcurname  channel_8_analyzer_1_array_crystal_array_1
#define mccompcurtype  Union_box
#define mccompcurindex 435
#define loop_index mccchannel_8_analyzer_1_array_crystal_array_1_loop_index
#define this_box_volume mccchannel_8_analyzer_1_array_crystal_array_1_this_box_volume
#define global_geometry_element mccchannel_8_analyzer_1_array_crystal_array_1_global_geometry_element
#define this_box_storage mccchannel_8_analyzer_1_array_crystal_array_1_this_box_storage
#define material_string mccchannel_8_analyzer_1_array_crystal_array_1_material_string
#define priority mccchannel_8_analyzer_1_array_crystal_array_1_priority
#define xwidth mccchannel_8_analyzer_1_array_crystal_array_1_xwidth
#define yheight mccchannel_8_analyzer_1_array_crystal_array_1_yheight
#define zdepth mccchannel_8_analyzer_1_array_crystal_array_1_zdepth
#define xwidth2 mccchannel_8_analyzer_1_array_crystal_array_1_xwidth2
#define yheight2 mccchannel_8_analyzer_1_array_crystal_array_1_yheight2
#define visualize mccchannel_8_analyzer_1_array_crystal_array_1_visualize
#define target_index mccchannel_8_analyzer_1_array_crystal_array_1_target_index
#define target_x mccchannel_8_analyzer_1_array_crystal_array_1_target_x
#define target_y mccchannel_8_analyzer_1_array_crystal_array_1_target_y
#define target_z mccchannel_8_analyzer_1_array_crystal_array_1_target_z
#define focus_aw mccchannel_8_analyzer_1_array_crystal_array_1_focus_aw
#define focus_ah mccchannel_8_analyzer_1_array_crystal_array_1_focus_ah
#define focus_xw mccchannel_8_analyzer_1_array_crystal_array_1_focus_xw
#define focus_xh mccchannel_8_analyzer_1_array_crystal_array_1_focus_xh
#define focus_r mccchannel_8_analyzer_1_array_crystal_array_1_focus_r
#define p_interact mccchannel_8_analyzer_1_array_crystal_array_1_p_interact
#define mask_string mccchannel_8_analyzer_1_array_crystal_array_1_mask_string
#define mask_setting mccchannel_8_analyzer_1_array_crystal_array_1_mask_setting
#define number_of_activations mccchannel_8_analyzer_1_array_crystal_array_1_number_of_activations
#line 204 "Union_box.comp"
// Needed for transport to the main component
struct global_geometry_element_struct global_geometry_element;

#ifndef ANY_GEOMETRY_DETECTOR_DECLARE
    #define ANY_GEOMETRY_DETECTOR_DECLARE dummy
	//struct pointer_to_global_geometry_list global_geometry_list = {0,NULL};
#endif

int loop_index,found_geometries;

double x_component;
double y_component;
double z_component;

struct Volume_struct this_box_volume;
struct box_storage this_box_storage;

#line 54435 "MACS_sample_kidney_box.c"
#undef number_of_activations
#undef mask_setting
#undef mask_string
#undef p_interact
#undef focus_r
#undef focus_xh
#undef focus_xw
#undef focus_ah
#undef focus_aw
#undef target_z
#undef target_y
#undef target_x
#undef target_index
#undef visualize
#undef yheight2
#undef xwidth2
#undef zdepth
#undef yheight
#undef xwidth
#undef priority
#undef material_string
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

/* User declarations for component 'channel_8_analyzer_1_array_crystal_array_2' [436]. */
#define mccompcurname  channel_8_analyzer_1_array_crystal_array_2
#define mccompcurtype  Union_box
#define mccompcurindex 436
#define loop_index mccchannel_8_analyzer_1_array_crystal_array_2_loop_index
#define this_box_volume mccchannel_8_analyzer_1_array_crystal_array_2_this_box_volume
#define global_geometry_element mccchannel_8_analyzer_1_array_crystal_array_2_global_geometry_element
#define this_box_storage mccchannel_8_analyzer_1_array_crystal_array_2_this_box_storage
#define material_string mccchannel_8_analyzer_1_array_crystal_array_2_material_string
#define priority mccchannel_8_analyzer_1_array_crystal_array_2_priority
#define xwidth mccchannel_8_analyzer_1_array_crystal_array_2_xwidth
#define yheight mccchannel_8_analyzer_1_array_crystal_array_2_yheight
#define zdepth mccchannel_8_analyzer_1_array_crystal_array_2_zdepth
#define xwidth2 mccchannel_8_analyzer_1_array_crystal_array_2_xwidth2
#define yheight2 mccchannel_8_analyzer_1_array_crystal_array_2_yheight2
#define visualize mccchannel_8_analyzer_1_array_crystal_array_2_visualize
#define target_index mccchannel_8_analyzer_1_array_crystal_array_2_target_index
#define target_x mccchannel_8_analyzer_1_array_crystal_array_2_target_x
#define target_y mccchannel_8_analyzer_1_array_crystal_array_2_target_y
#define target_z mccchannel_8_analyzer_1_array_crystal_array_2_target_z
#define focus_aw mccchannel_8_analyzer_1_array_crystal_array_2_focus_aw
#define focus_ah mccchannel_8_analyzer_1_array_crystal_array_2_focus_ah
#define focus_xw mccchannel_8_analyzer_1_array_crystal_array_2_focus_xw
#define focus_xh mccchannel_8_analyzer_1_array_crystal_array_2_focus_xh
#define focus_r mccchannel_8_analyzer_1_array_crystal_array_2_focus_r
#define p_interact mccchannel_8_analyzer_1_array_crystal_array_2_p_interact
#define mask_string mccchannel_8_analyzer_1_array_crystal_array_2_mask_string
#define mask_setting mccchannel_8_analyzer_1_array_crystal_array_2_mask_setting
#define number_of_activations mccchannel_8_analyzer_1_array_crystal_array_2_number_of_activations
#line 204 "Union_box.comp"
// Needed for transport to the main component
struct global_geometry_element_struct global_geometry_element;

#ifndef ANY_GEOMETRY_DETECTOR_DECLARE
    #define ANY_GEOMETRY_DETECTOR_DECLARE dummy
	//struct pointer_to_global_geometry_list global_geometry_list = {0,NULL};
#endif

int loop_index,found_geometries;

double x_component;
double y_component;
double z_component;

struct Volume_struct this_box_volume;
struct box_storage this_box_storage;

#line 54512 "MACS_sample_kidney_box.c"
#undef number_of_activations
#undef mask_setting
#undef mask_string
#undef p_interact
#undef focus_r
#undef focus_xh
#undef focus_xw
#undef focus_ah
#undef focus_aw
#undef target_z
#undef target_y
#undef target_x
#undef target_index
#undef visualize
#undef yheight2
#undef xwidth2
#undef zdepth
#undef yheight
#undef xwidth
#undef priority
#undef material_string
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

/* User declarations for component 'channel_8_analyzer_1_array_crystal_array_3' [437]. */
#define mccompcurname  channel_8_analyzer_1_array_crystal_array_3
#define mccompcurtype  Union_box
#define mccompcurindex 437
#define loop_index mccchannel_8_analyzer_1_array_crystal_array_3_loop_index
#define this_box_volume mccchannel_8_analyzer_1_array_crystal_array_3_this_box_volume
#define global_geometry_element mccchannel_8_analyzer_1_array_crystal_array_3_global_geometry_element
#define this_box_storage mccchannel_8_analyzer_1_array_crystal_array_3_this_box_storage
#define material_string mccchannel_8_analyzer_1_array_crystal_array_3_material_string
#define priority mccchannel_8_analyzer_1_array_crystal_array_3_priority
#define xwidth mccchannel_8_analyzer_1_array_crystal_array_3_xwidth
#define yheight mccchannel_8_analyzer_1_array_crystal_array_3_yheight
#define zdepth mccchannel_8_analyzer_1_array_crystal_array_3_zdepth
#define xwidth2 mccchannel_8_analyzer_1_array_crystal_array_3_xwidth2
#define yheight2 mccchannel_8_analyzer_1_array_crystal_array_3_yheight2
#define visualize mccchannel_8_analyzer_1_array_crystal_array_3_visualize
#define target_index mccchannel_8_analyzer_1_array_crystal_array_3_target_index
#define target_x mccchannel_8_analyzer_1_array_crystal_array_3_target_x
#define target_y mccchannel_8_analyzer_1_array_crystal_array_3_target_y
#define target_z mccchannel_8_analyzer_1_array_crystal_array_3_target_z
#define focus_aw mccchannel_8_analyzer_1_array_crystal_array_3_focus_aw
#define focus_ah mccchannel_8_analyzer_1_array_crystal_array_3_focus_ah
#define focus_xw mccchannel_8_analyzer_1_array_crystal_array_3_focus_xw
#define focus_xh mccchannel_8_analyzer_1_array_crystal_array_3_focus_xh
#define focus_r mccchannel_8_analyzer_1_array_crystal_array_3_focus_r
#define p_interact mccchannel_8_analyzer_1_array_crystal_array_3_p_interact
#define mask_string mccchannel_8_analyzer_1_array_crystal_array_3_mask_string
#define mask_setting mccchannel_8_analyzer_1_array_crystal_array_3_mask_setting
#define number_of_activations mccchannel_8_analyzer_1_array_crystal_array_3_number_of_activations
#line 204 "Union_box.comp"
// Needed for transport to the main component
struct global_geometry_element_struct global_geometry_element;

#ifndef ANY_GEOMETRY_DETECTOR_DECLARE
    #define ANY_GEOMETRY_DETECTOR_DECLARE dummy
	//struct pointer_to_global_geometry_list global_geometry_list = {0,NULL};
#endif

int loop_index,found_geometries;

double x_component;
double y_component;
double z_component;

struct Volume_struct this_box_volume;
struct box_storage this_box_storage;

#line 54589 "MACS_sample_kidney_box.c"
#undef number_of_activations
#undef mask_setting
#undef mask_string
#undef p_interact
#undef focus_r
#undef focus_xh
#undef focus_xw
#undef focus_ah
#undef focus_aw
#undef target_z
#undef target_y
#undef target_x
#undef target_index
#undef visualize
#undef yheight2
#undef xwidth2
#undef zdepth
#undef yheight
#undef xwidth
#undef priority
#undef material_string
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

/* User declarations for component 'channel_8_analyzer_1_array_crystal_array_4' [438]. */
#define mccompcurname  channel_8_analyzer_1_array_crystal_array_4
#define mccompcurtype  Union_box
#define mccompcurindex 438
#define loop_index mccchannel_8_analyzer_1_array_crystal_array_4_loop_index
#define this_box_volume mccchannel_8_analyzer_1_array_crystal_array_4_this_box_volume
#define global_geometry_element mccchannel_8_analyzer_1_array_crystal_array_4_global_geometry_element
#define this_box_storage mccchannel_8_analyzer_1_array_crystal_array_4_this_box_storage
#define material_string mccchannel_8_analyzer_1_array_crystal_array_4_material_string
#define priority mccchannel_8_analyzer_1_array_crystal_array_4_priority
#define xwidth mccchannel_8_analyzer_1_array_crystal_array_4_xwidth
#define yheight mccchannel_8_analyzer_1_array_crystal_array_4_yheight
#define zdepth mccchannel_8_analyzer_1_array_crystal_array_4_zdepth
#define xwidth2 mccchannel_8_analyzer_1_array_crystal_array_4_xwidth2
#define yheight2 mccchannel_8_analyzer_1_array_crystal_array_4_yheight2
#define visualize mccchannel_8_analyzer_1_array_crystal_array_4_visualize
#define target_index mccchannel_8_analyzer_1_array_crystal_array_4_target_index
#define target_x mccchannel_8_analyzer_1_array_crystal_array_4_target_x
#define target_y mccchannel_8_analyzer_1_array_crystal_array_4_target_y
#define target_z mccchannel_8_analyzer_1_array_crystal_array_4_target_z
#define focus_aw mccchannel_8_analyzer_1_array_crystal_array_4_focus_aw
#define focus_ah mccchannel_8_analyzer_1_array_crystal_array_4_focus_ah
#define focus_xw mccchannel_8_analyzer_1_array_crystal_array_4_focus_xw
#define focus_xh mccchannel_8_analyzer_1_array_crystal_array_4_focus_xh
#define focus_r mccchannel_8_analyzer_1_array_crystal_array_4_focus_r
#define p_interact mccchannel_8_analyzer_1_array_crystal_array_4_p_interact
#define mask_string mccchannel_8_analyzer_1_array_crystal_array_4_mask_string
#define mask_setting mccchannel_8_analyzer_1_array_crystal_array_4_mask_setting
#define number_of_activations mccchannel_8_analyzer_1_array_crystal_array_4_number_of_activations
#line 204 "Union_box.comp"
// Needed for transport to the main component
struct global_geometry_element_struct global_geometry_element;

#ifndef ANY_GEOMETRY_DETECTOR_DECLARE
    #define ANY_GEOMETRY_DETECTOR_DECLARE dummy
	//struct pointer_to_global_geometry_list global_geometry_list = {0,NULL};
#endif

int loop_index,found_geometries;

double x_component;
double y_component;
double z_component;

struct Volume_struct this_box_volume;
struct box_storage this_box_storage;

#line 54666 "MACS_sample_kidney_box.c"
#undef number_of_activations
#undef mask_setting
#undef mask_string
#undef p_interact
#undef focus_r
#undef focus_xh
#undef focus_xw
#undef focus_ah
#undef focus_aw
#undef target_z
#undef target_y
#undef target_x
#undef target_index
#undef visualize
#undef yheight2
#undef xwidth2
#undef zdepth
#undef yheight
#undef xwidth
#undef priority
#undef material_string
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

/* User declarations for component 'channel_8_analyzer_1_array_crystal_array_5' [439]. */
#define mccompcurname  channel_8_analyzer_1_array_crystal_array_5
#define mccompcurtype  Union_box
#define mccompcurindex 439
#define loop_index mccchannel_8_analyzer_1_array_crystal_array_5_loop_index
#define this_box_volume mccchannel_8_analyzer_1_array_crystal_array_5_this_box_volume
#define global_geometry_element mccchannel_8_analyzer_1_array_crystal_array_5_global_geometry_element
#define this_box_storage mccchannel_8_analyzer_1_array_crystal_array_5_this_box_storage
#define material_string mccchannel_8_analyzer_1_array_crystal_array_5_material_string
#define priority mccchannel_8_analyzer_1_array_crystal_array_5_priority
#define xwidth mccchannel_8_analyzer_1_array_crystal_array_5_xwidth
#define yheight mccchannel_8_analyzer_1_array_crystal_array_5_yheight
#define zdepth mccchannel_8_analyzer_1_array_crystal_array_5_zdepth
#define xwidth2 mccchannel_8_analyzer_1_array_crystal_array_5_xwidth2
#define yheight2 mccchannel_8_analyzer_1_array_crystal_array_5_yheight2
#define visualize mccchannel_8_analyzer_1_array_crystal_array_5_visualize
#define target_index mccchannel_8_analyzer_1_array_crystal_array_5_target_index
#define target_x mccchannel_8_analyzer_1_array_crystal_array_5_target_x
#define target_y mccchannel_8_analyzer_1_array_crystal_array_5_target_y
#define target_z mccchannel_8_analyzer_1_array_crystal_array_5_target_z
#define focus_aw mccchannel_8_analyzer_1_array_crystal_array_5_focus_aw
#define focus_ah mccchannel_8_analyzer_1_array_crystal_array_5_focus_ah
#define focus_xw mccchannel_8_analyzer_1_array_crystal_array_5_focus_xw
#define focus_xh mccchannel_8_analyzer_1_array_crystal_array_5_focus_xh
#define focus_r mccchannel_8_analyzer_1_array_crystal_array_5_focus_r
#define p_interact mccchannel_8_analyzer_1_array_crystal_array_5_p_interact
#define mask_string mccchannel_8_analyzer_1_array_crystal_array_5_mask_string
#define mask_setting mccchannel_8_analyzer_1_array_crystal_array_5_mask_setting
#define number_of_activations mccchannel_8_analyzer_1_array_crystal_array_5_number_of_activations
#line 204 "Union_box.comp"
// Needed for transport to the main component
struct global_geometry_element_struct global_geometry_element;

#ifndef ANY_GEOMETRY_DETECTOR_DECLARE
    #define ANY_GEOMETRY_DETECTOR_DECLARE dummy
	//struct pointer_to_global_geometry_list global_geometry_list = {0,NULL};
#endif

int loop_index,found_geometries;

double x_component;
double y_component;
double z_component;

struct Volume_struct this_box_volume;
struct box_storage this_box_storage;

#line 54743 "MACS_sample_kidney_box.c"
#undef number_of_activations
#undef mask_setting
#undef mask_string
#undef p_interact
#undef focus_r
#undef focus_xh
#undef focus_xw
#undef focus_ah
#undef focus_aw
#undef target_z
#undef target_y
#undef target_x
#undef target_index
#undef visualize
#undef yheight2
#undef xwidth2
#undef zdepth
#undef yheight
#undef xwidth
#undef priority
#undef material_string
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

/* User declarations for component 'channel_8_analyzer_1_array_crystal_array_6' [440]. */
#define mccompcurname  channel_8_analyzer_1_array_crystal_array_6
#define mccompcurtype  Union_box
#define mccompcurindex 440
#define loop_index mccchannel_8_analyzer_1_array_crystal_array_6_loop_index
#define this_box_volume mccchannel_8_analyzer_1_array_crystal_array_6_this_box_volume
#define global_geometry_element mccchannel_8_analyzer_1_array_crystal_array_6_global_geometry_element
#define this_box_storage mccchannel_8_analyzer_1_array_crystal_array_6_this_box_storage
#define material_string mccchannel_8_analyzer_1_array_crystal_array_6_material_string
#define priority mccchannel_8_analyzer_1_array_crystal_array_6_priority
#define xwidth mccchannel_8_analyzer_1_array_crystal_array_6_xwidth
#define yheight mccchannel_8_analyzer_1_array_crystal_array_6_yheight
#define zdepth mccchannel_8_analyzer_1_array_crystal_array_6_zdepth
#define xwidth2 mccchannel_8_analyzer_1_array_crystal_array_6_xwidth2
#define yheight2 mccchannel_8_analyzer_1_array_crystal_array_6_yheight2
#define visualize mccchannel_8_analyzer_1_array_crystal_array_6_visualize
#define target_index mccchannel_8_analyzer_1_array_crystal_array_6_target_index
#define target_x mccchannel_8_analyzer_1_array_crystal_array_6_target_x
#define target_y mccchannel_8_analyzer_1_array_crystal_array_6_target_y
#define target_z mccchannel_8_analyzer_1_array_crystal_array_6_target_z
#define focus_aw mccchannel_8_analyzer_1_array_crystal_array_6_focus_aw
#define focus_ah mccchannel_8_analyzer_1_array_crystal_array_6_focus_ah
#define focus_xw mccchannel_8_analyzer_1_array_crystal_array_6_focus_xw
#define focus_xh mccchannel_8_analyzer_1_array_crystal_array_6_focus_xh
#define focus_r mccchannel_8_analyzer_1_array_crystal_array_6_focus_r
#define p_interact mccchannel_8_analyzer_1_array_crystal_array_6_p_interact
#define mask_string mccchannel_8_analyzer_1_array_crystal_array_6_mask_string
#define mask_setting mccchannel_8_analyzer_1_array_crystal_array_6_mask_setting
#define number_of_activations mccchannel_8_analyzer_1_array_crystal_array_6_number_of_activations
#line 204 "Union_box.comp"
// Needed for transport to the main component
struct global_geometry_element_struct global_geometry_element;

#ifndef ANY_GEOMETRY_DETECTOR_DECLARE
    #define ANY_GEOMETRY_DETECTOR_DECLARE dummy
	//struct pointer_to_global_geometry_list global_geometry_list = {0,NULL};
#endif

int loop_index,found_geometries;

double x_component;
double y_component;
double z_component;

struct Volume_struct this_box_volume;
struct box_storage this_box_storage;

#line 54820 "MACS_sample_kidney_box.c"
#undef number_of_activations
#undef mask_setting
#undef mask_string
#undef p_interact
#undef focus_r
#undef focus_xh
#undef focus_xw
#undef focus_ah
#undef focus_aw
#undef target_z
#undef target_y
#undef target_x
#undef target_index
#undef visualize
#undef yheight2
#undef xwidth2
#undef zdepth
#undef yheight
#undef xwidth
#undef priority
#undef material_string
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

/* User declarations for component 'channel_8_analyzer_1_array_crystal_array_7' [441]. */
#define mccompcurname  channel_8_analyzer_1_array_crystal_array_7
#define mccompcurtype  Union_box
#define mccompcurindex 441
#define loop_index mccchannel_8_analyzer_1_array_crystal_array_7_loop_index
#define this_box_volume mccchannel_8_analyzer_1_array_crystal_array_7_this_box_volume
#define global_geometry_element mccchannel_8_analyzer_1_array_crystal_array_7_global_geometry_element
#define this_box_storage mccchannel_8_analyzer_1_array_crystal_array_7_this_box_storage
#define material_string mccchannel_8_analyzer_1_array_crystal_array_7_material_string
#define priority mccchannel_8_analyzer_1_array_crystal_array_7_priority
#define xwidth mccchannel_8_analyzer_1_array_crystal_array_7_xwidth
#define yheight mccchannel_8_analyzer_1_array_crystal_array_7_yheight
#define zdepth mccchannel_8_analyzer_1_array_crystal_array_7_zdepth
#define xwidth2 mccchannel_8_analyzer_1_array_crystal_array_7_xwidth2
#define yheight2 mccchannel_8_analyzer_1_array_crystal_array_7_yheight2
#define visualize mccchannel_8_analyzer_1_array_crystal_array_7_visualize
#define target_index mccchannel_8_analyzer_1_array_crystal_array_7_target_index
#define target_x mccchannel_8_analyzer_1_array_crystal_array_7_target_x
#define target_y mccchannel_8_analyzer_1_array_crystal_array_7_target_y
#define target_z mccchannel_8_analyzer_1_array_crystal_array_7_target_z
#define focus_aw mccchannel_8_analyzer_1_array_crystal_array_7_focus_aw
#define focus_ah mccchannel_8_analyzer_1_array_crystal_array_7_focus_ah
#define focus_xw mccchannel_8_analyzer_1_array_crystal_array_7_focus_xw
#define focus_xh mccchannel_8_analyzer_1_array_crystal_array_7_focus_xh
#define focus_r mccchannel_8_analyzer_1_array_crystal_array_7_focus_r
#define p_interact mccchannel_8_analyzer_1_array_crystal_array_7_p_interact
#define mask_string mccchannel_8_analyzer_1_array_crystal_array_7_mask_string
#define mask_setting mccchannel_8_analyzer_1_array_crystal_array_7_mask_setting
#define number_of_activations mccchannel_8_analyzer_1_array_crystal_array_7_number_of_activations
#line 204 "Union_box.comp"
// Needed for transport to the main component
struct global_geometry_element_struct global_geometry_element;

#ifndef ANY_GEOMETRY_DETECTOR_DECLARE
    #define ANY_GEOMETRY_DETECTOR_DECLARE dummy
	//struct pointer_to_global_geometry_list global_geometry_list = {0,NULL};
#endif

int loop_index,found_geometries;

double x_component;
double y_component;
double z_component;

struct Volume_struct this_box_volume;
struct box_storage this_box_storage;

#line 54897 "MACS_sample_kidney_box.c"
#undef number_of_activations
#undef mask_setting
#undef mask_string
#undef p_interact
#undef focus_r
#undef focus_xh
#undef focus_xw
#undef focus_ah
#undef focus_aw
#undef target_z
#undef target_y
#undef target_x
#undef target_index
#undef visualize
#undef yheight2
#undef xwidth2
#undef zdepth
#undef yheight
#undef xwidth
#undef priority
#undef material_string
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

/* User declarations for component 'channel_8_analyzer_1_array_crystal_array_8' [442]. */
#define mccompcurname  channel_8_analyzer_1_array_crystal_array_8
#define mccompcurtype  Union_box
#define mccompcurindex 442
#define loop_index mccchannel_8_analyzer_1_array_crystal_array_8_loop_index
#define this_box_volume mccchannel_8_analyzer_1_array_crystal_array_8_this_box_volume
#define global_geometry_element mccchannel_8_analyzer_1_array_crystal_array_8_global_geometry_element
#define this_box_storage mccchannel_8_analyzer_1_array_crystal_array_8_this_box_storage
#define material_string mccchannel_8_analyzer_1_array_crystal_array_8_material_string
#define priority mccchannel_8_analyzer_1_array_crystal_array_8_priority
#define xwidth mccchannel_8_analyzer_1_array_crystal_array_8_xwidth
#define yheight mccchannel_8_analyzer_1_array_crystal_array_8_yheight
#define zdepth mccchannel_8_analyzer_1_array_crystal_array_8_zdepth
#define xwidth2 mccchannel_8_analyzer_1_array_crystal_array_8_xwidth2
#define yheight2 mccchannel_8_analyzer_1_array_crystal_array_8_yheight2
#define visualize mccchannel_8_analyzer_1_array_crystal_array_8_visualize
#define target_index mccchannel_8_analyzer_1_array_crystal_array_8_target_index
#define target_x mccchannel_8_analyzer_1_array_crystal_array_8_target_x
#define target_y mccchannel_8_analyzer_1_array_crystal_array_8_target_y
#define target_z mccchannel_8_analyzer_1_array_crystal_array_8_target_z
#define focus_aw mccchannel_8_analyzer_1_array_crystal_array_8_focus_aw
#define focus_ah mccchannel_8_analyzer_1_array_crystal_array_8_focus_ah
#define focus_xw mccchannel_8_analyzer_1_array_crystal_array_8_focus_xw
#define focus_xh mccchannel_8_analyzer_1_array_crystal_array_8_focus_xh
#define focus_r mccchannel_8_analyzer_1_array_crystal_array_8_focus_r
#define p_interact mccchannel_8_analyzer_1_array_crystal_array_8_p_interact
#define mask_string mccchannel_8_analyzer_1_array_crystal_array_8_mask_string
#define mask_setting mccchannel_8_analyzer_1_array_crystal_array_8_mask_setting
#define number_of_activations mccchannel_8_analyzer_1_array_crystal_array_8_number_of_activations
#line 204 "Union_box.comp"
// Needed for transport to the main component
struct global_geometry_element_struct global_geometry_element;

#ifndef ANY_GEOMETRY_DETECTOR_DECLARE
    #define ANY_GEOMETRY_DETECTOR_DECLARE dummy
	//struct pointer_to_global_geometry_list global_geometry_list = {0,NULL};
#endif

int loop_index,found_geometries;

double x_component;
double y_component;
double z_component;

struct Volume_struct this_box_volume;
struct box_storage this_box_storage;

#line 54974 "MACS_sample_kidney_box.c"
#undef number_of_activations
#undef mask_setting
#undef mask_string
#undef p_interact
#undef focus_r
#undef focus_xh
#undef focus_xw
#undef focus_ah
#undef focus_aw
#undef target_z
#undef target_y
#undef target_x
#undef target_index
#undef visualize
#undef yheight2
#undef xwidth2
#undef zdepth
#undef yheight
#undef xwidth
#undef priority
#undef material_string
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

/* User declarations for component 'channel_8_analyzer_2_center' [443]. */
#define mccompcurname  channel_8_analyzer_2_center
#define mccompcurtype  Arm
#define mccompcurindex 443
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

/* User declarations for component 'channel_8_analyzer_2_rotated' [444]. */
#define mccompcurname  channel_8_analyzer_2_rotated
#define mccompcurtype  Arm
#define mccompcurindex 444
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

/* User declarations for component 'channel_8_analyzer_2_array_crystal_array_0' [445]. */
#define mccompcurname  channel_8_analyzer_2_array_crystal_array_0
#define mccompcurtype  Union_box
#define mccompcurindex 445
#define loop_index mccchannel_8_analyzer_2_array_crystal_array_0_loop_index
#define this_box_volume mccchannel_8_analyzer_2_array_crystal_array_0_this_box_volume
#define global_geometry_element mccchannel_8_analyzer_2_array_crystal_array_0_global_geometry_element
#define this_box_storage mccchannel_8_analyzer_2_array_crystal_array_0_this_box_storage
#define material_string mccchannel_8_analyzer_2_array_crystal_array_0_material_string
#define priority mccchannel_8_analyzer_2_array_crystal_array_0_priority
#define xwidth mccchannel_8_analyzer_2_array_crystal_array_0_xwidth
#define yheight mccchannel_8_analyzer_2_array_crystal_array_0_yheight
#define zdepth mccchannel_8_analyzer_2_array_crystal_array_0_zdepth
#define xwidth2 mccchannel_8_analyzer_2_array_crystal_array_0_xwidth2
#define yheight2 mccchannel_8_analyzer_2_array_crystal_array_0_yheight2
#define visualize mccchannel_8_analyzer_2_array_crystal_array_0_visualize
#define target_index mccchannel_8_analyzer_2_array_crystal_array_0_target_index
#define target_x mccchannel_8_analyzer_2_array_crystal_array_0_target_x
#define target_y mccchannel_8_analyzer_2_array_crystal_array_0_target_y
#define target_z mccchannel_8_analyzer_2_array_crystal_array_0_target_z
#define focus_aw mccchannel_8_analyzer_2_array_crystal_array_0_focus_aw
#define focus_ah mccchannel_8_analyzer_2_array_crystal_array_0_focus_ah
#define focus_xw mccchannel_8_analyzer_2_array_crystal_array_0_focus_xw
#define focus_xh mccchannel_8_analyzer_2_array_crystal_array_0_focus_xh
#define focus_r mccchannel_8_analyzer_2_array_crystal_array_0_focus_r
#define p_interact mccchannel_8_analyzer_2_array_crystal_array_0_p_interact
#define mask_string mccchannel_8_analyzer_2_array_crystal_array_0_mask_string
#define mask_setting mccchannel_8_analyzer_2_array_crystal_array_0_mask_setting
#define number_of_activations mccchannel_8_analyzer_2_array_crystal_array_0_number_of_activations
#line 204 "Union_box.comp"
// Needed for transport to the main component
struct global_geometry_element_struct global_geometry_element;

#ifndef ANY_GEOMETRY_DETECTOR_DECLARE
    #define ANY_GEOMETRY_DETECTOR_DECLARE dummy
	//struct pointer_to_global_geometry_list global_geometry_list = {0,NULL};
#endif

int loop_index,found_geometries;

double x_component;
double y_component;
double z_component;

struct Volume_struct this_box_volume;
struct box_storage this_box_storage;

#line 55067 "MACS_sample_kidney_box.c"
#undef number_of_activations
#undef mask_setting
#undef mask_string
#undef p_interact
#undef focus_r
#undef focus_xh
#undef focus_xw
#undef focus_ah
#undef focus_aw
#undef target_z
#undef target_y
#undef target_x
#undef target_index
#undef visualize
#undef yheight2
#undef xwidth2
#undef zdepth
#undef yheight
#undef xwidth
#undef priority
#undef material_string
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

/* User declarations for component 'channel_8_analyzer_2_array_crystal_array_1' [446]. */
#define mccompcurname  channel_8_analyzer_2_array_crystal_array_1
#define mccompcurtype  Union_box
#define mccompcurindex 446
#define loop_index mccchannel_8_analyzer_2_array_crystal_array_1_loop_index
#define this_box_volume mccchannel_8_analyzer_2_array_crystal_array_1_this_box_volume
#define global_geometry_element mccchannel_8_analyzer_2_array_crystal_array_1_global_geometry_element
#define this_box_storage mccchannel_8_analyzer_2_array_crystal_array_1_this_box_storage
#define material_string mccchannel_8_analyzer_2_array_crystal_array_1_material_string
#define priority mccchannel_8_analyzer_2_array_crystal_array_1_priority
#define xwidth mccchannel_8_analyzer_2_array_crystal_array_1_xwidth
#define yheight mccchannel_8_analyzer_2_array_crystal_array_1_yheight
#define zdepth mccchannel_8_analyzer_2_array_crystal_array_1_zdepth
#define xwidth2 mccchannel_8_analyzer_2_array_crystal_array_1_xwidth2
#define yheight2 mccchannel_8_analyzer_2_array_crystal_array_1_yheight2
#define visualize mccchannel_8_analyzer_2_array_crystal_array_1_visualize
#define target_index mccchannel_8_analyzer_2_array_crystal_array_1_target_index
#define target_x mccchannel_8_analyzer_2_array_crystal_array_1_target_x
#define target_y mccchannel_8_analyzer_2_array_crystal_array_1_target_y
#define target_z mccchannel_8_analyzer_2_array_crystal_array_1_target_z
#define focus_aw mccchannel_8_analyzer_2_array_crystal_array_1_focus_aw
#define focus_ah mccchannel_8_analyzer_2_array_crystal_array_1_focus_ah
#define focus_xw mccchannel_8_analyzer_2_array_crystal_array_1_focus_xw
#define focus_xh mccchannel_8_analyzer_2_array_crystal_array_1_focus_xh
#define focus_r mccchannel_8_analyzer_2_array_crystal_array_1_focus_r
#define p_interact mccchannel_8_analyzer_2_array_crystal_array_1_p_interact
#define mask_string mccchannel_8_analyzer_2_array_crystal_array_1_mask_string
#define mask_setting mccchannel_8_analyzer_2_array_crystal_array_1_mask_setting
#define number_of_activations mccchannel_8_analyzer_2_array_crystal_array_1_number_of_activations
#line 204 "Union_box.comp"
// Needed for transport to the main component
struct global_geometry_element_struct global_geometry_element;

#ifndef ANY_GEOMETRY_DETECTOR_DECLARE
    #define ANY_GEOMETRY_DETECTOR_DECLARE dummy
	//struct pointer_to_global_geometry_list global_geometry_list = {0,NULL};
#endif

int loop_index,found_geometries;

double x_component;
double y_component;
double z_component;

struct Volume_struct this_box_volume;
struct box_storage this_box_storage;

#line 55144 "MACS_sample_kidney_box.c"
#undef number_of_activations
#undef mask_setting
#undef mask_string
#undef p_interact
#undef focus_r
#undef focus_xh
#undef focus_xw
#undef focus_ah
#undef focus_aw
#undef target_z
#undef target_y
#undef target_x
#undef target_index
#undef visualize
#undef yheight2
#undef xwidth2
#undef zdepth
#undef yheight
#undef xwidth
#undef priority
#undef material_string
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

/* User declarations for component 'channel_8_analyzer_2_array_crystal_array_2' [447]. */
#define mccompcurname  channel_8_analyzer_2_array_crystal_array_2
#define mccompcurtype  Union_box
#define mccompcurindex 447
#define loop_index mccchannel_8_analyzer_2_array_crystal_array_2_loop_index
#define this_box_volume mccchannel_8_analyzer_2_array_crystal_array_2_this_box_volume
#define global_geometry_element mccchannel_8_analyzer_2_array_crystal_array_2_global_geometry_element
#define this_box_storage mccchannel_8_analyzer_2_array_crystal_array_2_this_box_storage
#define material_string mccchannel_8_analyzer_2_array_crystal_array_2_material_string
#define priority mccchannel_8_analyzer_2_array_crystal_array_2_priority
#define xwidth mccchannel_8_analyzer_2_array_crystal_array_2_xwidth
#define yheight mccchannel_8_analyzer_2_array_crystal_array_2_yheight
#define zdepth mccchannel_8_analyzer_2_array_crystal_array_2_zdepth
#define xwidth2 mccchannel_8_analyzer_2_array_crystal_array_2_xwidth2
#define yheight2 mccchannel_8_analyzer_2_array_crystal_array_2_yheight2
#define visualize mccchannel_8_analyzer_2_array_crystal_array_2_visualize
#define target_index mccchannel_8_analyzer_2_array_crystal_array_2_target_index
#define target_x mccchannel_8_analyzer_2_array_crystal_array_2_target_x
#define target_y mccchannel_8_analyzer_2_array_crystal_array_2_target_y
#define target_z mccchannel_8_analyzer_2_array_crystal_array_2_target_z
#define focus_aw mccchannel_8_analyzer_2_array_crystal_array_2_focus_aw
#define focus_ah mccchannel_8_analyzer_2_array_crystal_array_2_focus_ah
#define focus_xw mccchannel_8_analyzer_2_array_crystal_array_2_focus_xw
#define focus_xh mccchannel_8_analyzer_2_array_crystal_array_2_focus_xh
#define focus_r mccchannel_8_analyzer_2_array_crystal_array_2_focus_r
#define p_interact mccchannel_8_analyzer_2_array_crystal_array_2_p_interact
#define mask_string mccchannel_8_analyzer_2_array_crystal_array_2_mask_string
#define mask_setting mccchannel_8_analyzer_2_array_crystal_array_2_mask_setting
#define number_of_activations mccchannel_8_analyzer_2_array_crystal_array_2_number_of_activations
#line 204 "Union_box.comp"
// Needed for transport to the main component
struct global_geometry_element_struct global_geometry_element;

#ifndef ANY_GEOMETRY_DETECTOR_DECLARE
    #define ANY_GEOMETRY_DETECTOR_DECLARE dummy
	//struct pointer_to_global_geometry_list global_geometry_list = {0,NULL};
#endif

int loop_index,found_geometries;

double x_component;
double y_component;
double z_component;

struct Volume_struct this_box_volume;
struct box_storage this_box_storage;

#line 55221 "MACS_sample_kidney_box.c"
#undef number_of_activations
#undef mask_setting
#undef mask_string
#undef p_interact
#undef focus_r
#undef focus_xh
#undef focus_xw
#undef focus_ah
#undef focus_aw
#undef target_z
#undef target_y
#undef target_x
#undef target_index
#undef visualize
#undef yheight2
#undef xwidth2
#undef zdepth
#undef yheight
#undef xwidth
#undef priority
#undef material_string
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

/* User declarations for component 'channel_8_analyzer_2_array_crystal_array_3' [448]. */
#define mccompcurname  channel_8_analyzer_2_array_crystal_array_3
#define mccompcurtype  Union_box
#define mccompcurindex 448
#define loop_index mccchannel_8_analyzer_2_array_crystal_array_3_loop_index
#define this_box_volume mccchannel_8_analyzer_2_array_crystal_array_3_this_box_volume
#define global_geometry_element mccchannel_8_analyzer_2_array_crystal_array_3_global_geometry_element
#define this_box_storage mccchannel_8_analyzer_2_array_crystal_array_3_this_box_storage
#define material_string mccchannel_8_analyzer_2_array_crystal_array_3_material_string
#define priority mccchannel_8_analyzer_2_array_crystal_array_3_priority
#define xwidth mccchannel_8_analyzer_2_array_crystal_array_3_xwidth
#define yheight mccchannel_8_analyzer_2_array_crystal_array_3_yheight
#define zdepth mccchannel_8_analyzer_2_array_crystal_array_3_zdepth
#define xwidth2 mccchannel_8_analyzer_2_array_crystal_array_3_xwidth2
#define yheight2 mccchannel_8_analyzer_2_array_crystal_array_3_yheight2
#define visualize mccchannel_8_analyzer_2_array_crystal_array_3_visualize
#define target_index mccchannel_8_analyzer_2_array_crystal_array_3_target_index
#define target_x mccchannel_8_analyzer_2_array_crystal_array_3_target_x
#define target_y mccchannel_8_analyzer_2_array_crystal_array_3_target_y
#define target_z mccchannel_8_analyzer_2_array_crystal_array_3_target_z
#define focus_aw mccchannel_8_analyzer_2_array_crystal_array_3_focus_aw
#define focus_ah mccchannel_8_analyzer_2_array_crystal_array_3_focus_ah
#define focus_xw mccchannel_8_analyzer_2_array_crystal_array_3_focus_xw
#define focus_xh mccchannel_8_analyzer_2_array_crystal_array_3_focus_xh
#define focus_r mccchannel_8_analyzer_2_array_crystal_array_3_focus_r
#define p_interact mccchannel_8_analyzer_2_array_crystal_array_3_p_interact
#define mask_string mccchannel_8_analyzer_2_array_crystal_array_3_mask_string
#define mask_setting mccchannel_8_analyzer_2_array_crystal_array_3_mask_setting
#define number_of_activations mccchannel_8_analyzer_2_array_crystal_array_3_number_of_activations
#line 204 "Union_box.comp"
// Needed for transport to the main component
struct global_geometry_element_struct global_geometry_element;

#ifndef ANY_GEOMETRY_DETECTOR_DECLARE
    #define ANY_GEOMETRY_DETECTOR_DECLARE dummy
	//struct pointer_to_global_geometry_list global_geometry_list = {0,NULL};
#endif

int loop_index,found_geometries;

double x_component;
double y_component;
double z_component;

struct Volume_struct this_box_volume;
struct box_storage this_box_storage;

#line 55298 "MACS_sample_kidney_box.c"
#undef number_of_activations
#undef mask_setting
#undef mask_string
#undef p_interact
#undef focus_r
#undef focus_xh
#undef focus_xw
#undef focus_ah
#undef focus_aw
#undef target_z
#undef target_y
#undef target_x
#undef target_index
#undef visualize
#undef yheight2
#undef xwidth2
#undef zdepth
#undef yheight
#undef xwidth
#undef priority
#undef material_string
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

/* User declarations for component 'channel_8_analyzer_2_array_crystal_array_4' [449]. */
#define mccompcurname  channel_8_analyzer_2_array_crystal_array_4
#define mccompcurtype  Union_box
#define mccompcurindex 449
#define loop_index mccchannel_8_analyzer_2_array_crystal_array_4_loop_index
#define this_box_volume mccchannel_8_analyzer_2_array_crystal_array_4_this_box_volume
#define global_geometry_element mccchannel_8_analyzer_2_array_crystal_array_4_global_geometry_element
#define this_box_storage mccchannel_8_analyzer_2_array_crystal_array_4_this_box_storage
#define material_string mccchannel_8_analyzer_2_array_crystal_array_4_material_string
#define priority mccchannel_8_analyzer_2_array_crystal_array_4_priority
#define xwidth mccchannel_8_analyzer_2_array_crystal_array_4_xwidth
#define yheight mccchannel_8_analyzer_2_array_crystal_array_4_yheight
#define zdepth mccchannel_8_analyzer_2_array_crystal_array_4_zdepth
#define xwidth2 mccchannel_8_analyzer_2_array_crystal_array_4_xwidth2
#define yheight2 mccchannel_8_analyzer_2_array_crystal_array_4_yheight2
#define visualize mccchannel_8_analyzer_2_array_crystal_array_4_visualize
#define target_index mccchannel_8_analyzer_2_array_crystal_array_4_target_index
#define target_x mccchannel_8_analyzer_2_array_crystal_array_4_target_x
#define target_y mccchannel_8_analyzer_2_array_crystal_array_4_target_y
#define target_z mccchannel_8_analyzer_2_array_crystal_array_4_target_z
#define focus_aw mccchannel_8_analyzer_2_array_crystal_array_4_focus_aw
#define focus_ah mccchannel_8_analyzer_2_array_crystal_array_4_focus_ah
#define focus_xw mccchannel_8_analyzer_2_array_crystal_array_4_focus_xw
#define focus_xh mccchannel_8_analyzer_2_array_crystal_array_4_focus_xh
#define focus_r mccchannel_8_analyzer_2_array_crystal_array_4_focus_r
#define p_interact mccchannel_8_analyzer_2_array_crystal_array_4_p_interact
#define mask_string mccchannel_8_analyzer_2_array_crystal_array_4_mask_string
#define mask_setting mccchannel_8_analyzer_2_array_crystal_array_4_mask_setting
#define number_of_activations mccchannel_8_analyzer_2_array_crystal_array_4_number_of_activations
#line 204 "Union_box.comp"
// Needed for transport to the main component
struct global_geometry_element_struct global_geometry_element;

#ifndef ANY_GEOMETRY_DETECTOR_DECLARE
    #define ANY_GEOMETRY_DETECTOR_DECLARE dummy
	//struct pointer_to_global_geometry_list global_geometry_list = {0,NULL};
#endif

int loop_index,found_geometries;

double x_component;
double y_component;
double z_component;

struct Volume_struct this_box_volume;
struct box_storage this_box_storage;

#line 55375 "MACS_sample_kidney_box.c"
#undef number_of_activations
#undef mask_setting
#undef mask_string
#undef p_interact
#undef focus_r
#undef focus_xh
#undef focus_xw
#undef focus_ah
#undef focus_aw
#undef target_z
#undef target_y
#undef target_x
#undef target_index
#undef visualize
#undef yheight2
#undef xwidth2
#undef zdepth
#undef yheight
#undef xwidth
#undef priority
#undef material_string
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

/* User declarations for component 'channel_8_analyzer_2_array_crystal_array_5' [450]. */
#define mccompcurname  channel_8_analyzer_2_array_crystal_array_5
#define mccompcurtype  Union_box
#define mccompcurindex 450
#define loop_index mccchannel_8_analyzer_2_array_crystal_array_5_loop_index
#define this_box_volume mccchannel_8_analyzer_2_array_crystal_array_5_this_box_volume
#define global_geometry_element mccchannel_8_analyzer_2_array_crystal_array_5_global_geometry_element
#define this_box_storage mccchannel_8_analyzer_2_array_crystal_array_5_this_box_storage
#define material_string mccchannel_8_analyzer_2_array_crystal_array_5_material_string
#define priority mccchannel_8_analyzer_2_array_crystal_array_5_priority
#define xwidth mccchannel_8_analyzer_2_array_crystal_array_5_xwidth
#define yheight mccchannel_8_analyzer_2_array_crystal_array_5_yheight
#define zdepth mccchannel_8_analyzer_2_array_crystal_array_5_zdepth
#define xwidth2 mccchannel_8_analyzer_2_array_crystal_array_5_xwidth2
#define yheight2 mccchannel_8_analyzer_2_array_crystal_array_5_yheight2
#define visualize mccchannel_8_analyzer_2_array_crystal_array_5_visualize
#define target_index mccchannel_8_analyzer_2_array_crystal_array_5_target_index
#define target_x mccchannel_8_analyzer_2_array_crystal_array_5_target_x
#define target_y mccchannel_8_analyzer_2_array_crystal_array_5_target_y
#define target_z mccchannel_8_analyzer_2_array_crystal_array_5_target_z
#define focus_aw mccchannel_8_analyzer_2_array_crystal_array_5_focus_aw
#define focus_ah mccchannel_8_analyzer_2_array_crystal_array_5_focus_ah
#define focus_xw mccchannel_8_analyzer_2_array_crystal_array_5_focus_xw
#define focus_xh mccchannel_8_analyzer_2_array_crystal_array_5_focus_xh
#define focus_r mccchannel_8_analyzer_2_array_crystal_array_5_focus_r
#define p_interact mccchannel_8_analyzer_2_array_crystal_array_5_p_interact
#define mask_string mccchannel_8_analyzer_2_array_crystal_array_5_mask_string
#define mask_setting mccchannel_8_analyzer_2_array_crystal_array_5_mask_setting
#define number_of_activations mccchannel_8_analyzer_2_array_crystal_array_5_number_of_activations
#line 204 "Union_box.comp"
// Needed for transport to the main component
struct global_geometry_element_struct global_geometry_element;

#ifndef ANY_GEOMETRY_DETECTOR_DECLARE
    #define ANY_GEOMETRY_DETECTOR_DECLARE dummy
	//struct pointer_to_global_geometry_list global_geometry_list = {0,NULL};
#endif

int loop_index,found_geometries;

double x_component;
double y_component;
double z_component;

struct Volume_struct this_box_volume;
struct box_storage this_box_storage;

#line 55452 "MACS_sample_kidney_box.c"
#undef number_of_activations
#undef mask_setting
#undef mask_string
#undef p_interact
#undef focus_r
#undef focus_xh
#undef focus_xw
#undef focus_ah
#undef focus_aw
#undef target_z
#undef target_y
#undef target_x
#undef target_index
#undef visualize
#undef yheight2
#undef xwidth2
#undef zdepth
#undef yheight
#undef xwidth
#undef priority
#undef material_string
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

/* User declarations for component 'channel_8_analyzer_2_array_crystal_array_6' [451]. */
#define mccompcurname  channel_8_analyzer_2_array_crystal_array_6
#define mccompcurtype  Union_box
#define mccompcurindex 451
#define loop_index mccchannel_8_analyzer_2_array_crystal_array_6_loop_index
#define this_box_volume mccchannel_8_analyzer_2_array_crystal_array_6_this_box_volume
#define global_geometry_element mccchannel_8_analyzer_2_array_crystal_array_6_global_geometry_element
#define this_box_storage mccchannel_8_analyzer_2_array_crystal_array_6_this_box_storage
#define material_string mccchannel_8_analyzer_2_array_crystal_array_6_material_string
#define priority mccchannel_8_analyzer_2_array_crystal_array_6_priority
#define xwidth mccchannel_8_analyzer_2_array_crystal_array_6_xwidth
#define yheight mccchannel_8_analyzer_2_array_crystal_array_6_yheight
#define zdepth mccchannel_8_analyzer_2_array_crystal_array_6_zdepth
#define xwidth2 mccchannel_8_analyzer_2_array_crystal_array_6_xwidth2
#define yheight2 mccchannel_8_analyzer_2_array_crystal_array_6_yheight2
#define visualize mccchannel_8_analyzer_2_array_crystal_array_6_visualize
#define target_index mccchannel_8_analyzer_2_array_crystal_array_6_target_index
#define target_x mccchannel_8_analyzer_2_array_crystal_array_6_target_x
#define target_y mccchannel_8_analyzer_2_array_crystal_array_6_target_y
#define target_z mccchannel_8_analyzer_2_array_crystal_array_6_target_z
#define focus_aw mccchannel_8_analyzer_2_array_crystal_array_6_focus_aw
#define focus_ah mccchannel_8_analyzer_2_array_crystal_array_6_focus_ah
#define focus_xw mccchannel_8_analyzer_2_array_crystal_array_6_focus_xw
#define focus_xh mccchannel_8_analyzer_2_array_crystal_array_6_focus_xh
#define focus_r mccchannel_8_analyzer_2_array_crystal_array_6_focus_r
#define p_interact mccchannel_8_analyzer_2_array_crystal_array_6_p_interact
#define mask_string mccchannel_8_analyzer_2_array_crystal_array_6_mask_string
#define mask_setting mccchannel_8_analyzer_2_array_crystal_array_6_mask_setting
#define number_of_activations mccchannel_8_analyzer_2_array_crystal_array_6_number_of_activations
#line 204 "Union_box.comp"
// Needed for transport to the main component
struct global_geometry_element_struct global_geometry_element;

#ifndef ANY_GEOMETRY_DETECTOR_DECLARE
    #define ANY_GEOMETRY_DETECTOR_DECLARE dummy
	//struct pointer_to_global_geometry_list global_geometry_list = {0,NULL};
#endif

int loop_index,found_geometries;

double x_component;
double y_component;
double z_component;

struct Volume_struct this_box_volume;
struct box_storage this_box_storage;

#line 55529 "MACS_sample_kidney_box.c"
#undef number_of_activations
#undef mask_setting
#undef mask_string
#undef p_interact
#undef focus_r
#undef focus_xh
#undef focus_xw
#undef focus_ah
#undef focus_aw
#undef target_z
#undef target_y
#undef target_x
#undef target_index
#undef visualize
#undef yheight2
#undef xwidth2
#undef zdepth
#undef yheight
#undef xwidth
#undef priority
#undef material_string
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

/* User declarations for component 'channel_8_analyzer_2_array_crystal_array_7' [452]. */
#define mccompcurname  channel_8_analyzer_2_array_crystal_array_7
#define mccompcurtype  Union_box
#define mccompcurindex 452
#define loop_index mccchannel_8_analyzer_2_array_crystal_array_7_loop_index
#define this_box_volume mccchannel_8_analyzer_2_array_crystal_array_7_this_box_volume
#define global_geometry_element mccchannel_8_analyzer_2_array_crystal_array_7_global_geometry_element
#define this_box_storage mccchannel_8_analyzer_2_array_crystal_array_7_this_box_storage
#define material_string mccchannel_8_analyzer_2_array_crystal_array_7_material_string
#define priority mccchannel_8_analyzer_2_array_crystal_array_7_priority
#define xwidth mccchannel_8_analyzer_2_array_crystal_array_7_xwidth
#define yheight mccchannel_8_analyzer_2_array_crystal_array_7_yheight
#define zdepth mccchannel_8_analyzer_2_array_crystal_array_7_zdepth
#define xwidth2 mccchannel_8_analyzer_2_array_crystal_array_7_xwidth2
#define yheight2 mccchannel_8_analyzer_2_array_crystal_array_7_yheight2
#define visualize mccchannel_8_analyzer_2_array_crystal_array_7_visualize
#define target_index mccchannel_8_analyzer_2_array_crystal_array_7_target_index
#define target_x mccchannel_8_analyzer_2_array_crystal_array_7_target_x
#define target_y mccchannel_8_analyzer_2_array_crystal_array_7_target_y
#define target_z mccchannel_8_analyzer_2_array_crystal_array_7_target_z
#define focus_aw mccchannel_8_analyzer_2_array_crystal_array_7_focus_aw
#define focus_ah mccchannel_8_analyzer_2_array_crystal_array_7_focus_ah
#define focus_xw mccchannel_8_analyzer_2_array_crystal_array_7_focus_xw
#define focus_xh mccchannel_8_analyzer_2_array_crystal_array_7_focus_xh
#define focus_r mccchannel_8_analyzer_2_array_crystal_array_7_focus_r
#define p_interact mccchannel_8_analyzer_2_array_crystal_array_7_p_interact
#define mask_string mccchannel_8_analyzer_2_array_crystal_array_7_mask_string
#define mask_setting mccchannel_8_analyzer_2_array_crystal_array_7_mask_setting
#define number_of_activations mccchannel_8_analyzer_2_array_crystal_array_7_number_of_activations
#line 204 "Union_box.comp"
// Needed for transport to the main component
struct global_geometry_element_struct global_geometry_element;

#ifndef ANY_GEOMETRY_DETECTOR_DECLARE
    #define ANY_GEOMETRY_DETECTOR_DECLARE dummy
	//struct pointer_to_global_geometry_list global_geometry_list = {0,NULL};
#endif

int loop_index,found_geometries;

double x_component;
double y_component;
double z_component;

struct Volume_struct this_box_volume;
struct box_storage this_box_storage;

#line 55606 "MACS_sample_kidney_box.c"
#undef number_of_activations
#undef mask_setting
#undef mask_string
#undef p_interact
#undef focus_r
#undef focus_xh
#undef focus_xw
#undef focus_ah
#undef focus_aw
#undef target_z
#undef target_y
#undef target_x
#undef target_index
#undef visualize
#undef yheight2
#undef xwidth2
#undef zdepth
#undef yheight
#undef xwidth
#undef priority
#undef material_string
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

/* User declarations for component 'channel_8_analyzer_2_array_crystal_array_8' [453]. */
#define mccompcurname  channel_8_analyzer_2_array_crystal_array_8
#define mccompcurtype  Union_box
#define mccompcurindex 453
#define loop_index mccchannel_8_analyzer_2_array_crystal_array_8_loop_index
#define this_box_volume mccchannel_8_analyzer_2_array_crystal_array_8_this_box_volume
#define global_geometry_element mccchannel_8_analyzer_2_array_crystal_array_8_global_geometry_element
#define this_box_storage mccchannel_8_analyzer_2_array_crystal_array_8_this_box_storage
#define material_string mccchannel_8_analyzer_2_array_crystal_array_8_material_string
#define priority mccchannel_8_analyzer_2_array_crystal_array_8_priority
#define xwidth mccchannel_8_analyzer_2_array_crystal_array_8_xwidth
#define yheight mccchannel_8_analyzer_2_array_crystal_array_8_yheight
#define zdepth mccchannel_8_analyzer_2_array_crystal_array_8_zdepth
#define xwidth2 mccchannel_8_analyzer_2_array_crystal_array_8_xwidth2
#define yheight2 mccchannel_8_analyzer_2_array_crystal_array_8_yheight2
#define visualize mccchannel_8_analyzer_2_array_crystal_array_8_visualize
#define target_index mccchannel_8_analyzer_2_array_crystal_array_8_target_index
#define target_x mccchannel_8_analyzer_2_array_crystal_array_8_target_x
#define target_y mccchannel_8_analyzer_2_array_crystal_array_8_target_y
#define target_z mccchannel_8_analyzer_2_array_crystal_array_8_target_z
#define focus_aw mccchannel_8_analyzer_2_array_crystal_array_8_focus_aw
#define focus_ah mccchannel_8_analyzer_2_array_crystal_array_8_focus_ah
#define focus_xw mccchannel_8_analyzer_2_array_crystal_array_8_focus_xw
#define focus_xh mccchannel_8_analyzer_2_array_crystal_array_8_focus_xh
#define focus_r mccchannel_8_analyzer_2_array_crystal_array_8_focus_r
#define p_interact mccchannel_8_analyzer_2_array_crystal_array_8_p_interact
#define mask_string mccchannel_8_analyzer_2_array_crystal_array_8_mask_string
#define mask_setting mccchannel_8_analyzer_2_array_crystal_array_8_mask_setting
#define number_of_activations mccchannel_8_analyzer_2_array_crystal_array_8_number_of_activations
#line 204 "Union_box.comp"
// Needed for transport to the main component
struct global_geometry_element_struct global_geometry_element;

#ifndef ANY_GEOMETRY_DETECTOR_DECLARE
    #define ANY_GEOMETRY_DETECTOR_DECLARE dummy
	//struct pointer_to_global_geometry_list global_geometry_list = {0,NULL};
#endif

int loop_index,found_geometries;

double x_component;
double y_component;
double z_component;

struct Volume_struct this_box_volume;
struct box_storage this_box_storage;

#line 55683 "MACS_sample_kidney_box.c"
#undef number_of_activations
#undef mask_setting
#undef mask_string
#undef p_interact
#undef focus_r
#undef focus_xh
#undef focus_xw
#undef focus_ah
#undef focus_aw
#undef target_z
#undef target_y
#undef target_x
#undef target_index
#undef visualize
#undef yheight2
#undef xwidth2
#undef zdepth
#undef yheight
#undef xwidth
#undef priority
#undef material_string
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

/* User declarations for component 'channel_8_cave2_cyl1' [454]. */
#define mccompcurname  channel_8_cave2_cyl1
#define mccompcurtype  Union_cylinder
#define mccompcurindex 454
#define loop_index mccchannel_8_cave2_cyl1_loop_index
#define this_cylinder_volume mccchannel_8_cave2_cyl1_this_cylinder_volume
#define global_geometry_element mccchannel_8_cave2_cyl1_global_geometry_element
#define this_cylinder_storage mccchannel_8_cave2_cyl1_this_cylinder_storage
#define material_string mccchannel_8_cave2_cyl1_material_string
#define priority mccchannel_8_cave2_cyl1_priority
#define radius mccchannel_8_cave2_cyl1_radius
#define yheight mccchannel_8_cave2_cyl1_yheight
#define visualize mccchannel_8_cave2_cyl1_visualize
#define target_index mccchannel_8_cave2_cyl1_target_index
#define target_x mccchannel_8_cave2_cyl1_target_x
#define target_y mccchannel_8_cave2_cyl1_target_y
#define target_z mccchannel_8_cave2_cyl1_target_z
#define focus_aw mccchannel_8_cave2_cyl1_focus_aw
#define focus_ah mccchannel_8_cave2_cyl1_focus_ah
#define focus_xw mccchannel_8_cave2_cyl1_focus_xw
#define focus_xh mccchannel_8_cave2_cyl1_focus_xh
#define focus_r mccchannel_8_cave2_cyl1_focus_r
#define p_interact mccchannel_8_cave2_cyl1_p_interact
#define mask_string mccchannel_8_cave2_cyl1_mask_string
#define mask_setting mccchannel_8_cave2_cyl1_mask_setting
#define number_of_activations mccchannel_8_cave2_cyl1_number_of_activations
#line 167 "Union_cylinder.comp"
// Needed for transport to the main component
struct global_geometry_element_struct global_geometry_element;

#ifndef ANY_GEOMETRY_DETECTOR_DECLARE
    #define ANY_GEOMETRY_DETECTOR_DECLARE dummy
	//struct pointer_to_global_geometry_list global_geometry_list = {0,NULL};
#endif

int dummy;
int loop_index,found_geometries;
int loop_2_index;
int material_index;

struct Volume_struct this_cylinder_volume;
struct cylinder_storage this_cylinder_storage;
#line 55755 "MACS_sample_kidney_box.c"
#undef number_of_activations
#undef mask_setting
#undef mask_string
#undef p_interact
#undef focus_r
#undef focus_xh
#undef focus_xw
#undef focus_ah
#undef focus_aw
#undef target_z
#undef target_y
#undef target_x
#undef target_index
#undef visualize
#undef yheight
#undef radius
#undef priority
#undef material_string
#undef this_cylinder_storage
#undef global_geometry_element
#undef this_cylinder_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

/* User declarations for component 'channel_8_cave2_box1' [455]. */
#define mccompcurname  channel_8_cave2_box1
#define mccompcurtype  Union_box
#define mccompcurindex 455
#define loop_index mccchannel_8_cave2_box1_loop_index
#define this_box_volume mccchannel_8_cave2_box1_this_box_volume
#define global_geometry_element mccchannel_8_cave2_box1_global_geometry_element
#define this_box_storage mccchannel_8_cave2_box1_this_box_storage
#define material_string mccchannel_8_cave2_box1_material_string
#define priority mccchannel_8_cave2_box1_priority
#define xwidth mccchannel_8_cave2_box1_xwidth
#define yheight mccchannel_8_cave2_box1_yheight
#define zdepth mccchannel_8_cave2_box1_zdepth
#define xwidth2 mccchannel_8_cave2_box1_xwidth2
#define yheight2 mccchannel_8_cave2_box1_yheight2
#define visualize mccchannel_8_cave2_box1_visualize
#define target_index mccchannel_8_cave2_box1_target_index
#define target_x mccchannel_8_cave2_box1_target_x
#define target_y mccchannel_8_cave2_box1_target_y
#define target_z mccchannel_8_cave2_box1_target_z
#define focus_aw mccchannel_8_cave2_box1_focus_aw
#define focus_ah mccchannel_8_cave2_box1_focus_ah
#define focus_xw mccchannel_8_cave2_box1_focus_xw
#define focus_xh mccchannel_8_cave2_box1_focus_xh
#define focus_r mccchannel_8_cave2_box1_focus_r
#define p_interact mccchannel_8_cave2_box1_p_interact
#define mask_string mccchannel_8_cave2_box1_mask_string
#define mask_setting mccchannel_8_cave2_box1_mask_setting
#define number_of_activations mccchannel_8_cave2_box1_number_of_activations
#line 204 "Union_box.comp"
// Needed for transport to the main component
struct global_geometry_element_struct global_geometry_element;

#ifndef ANY_GEOMETRY_DETECTOR_DECLARE
    #define ANY_GEOMETRY_DETECTOR_DECLARE dummy
	//struct pointer_to_global_geometry_list global_geometry_list = {0,NULL};
#endif

int loop_index,found_geometries;

double x_component;
double y_component;
double z_component;

struct Volume_struct this_box_volume;
struct box_storage this_box_storage;

#line 55829 "MACS_sample_kidney_box.c"
#undef number_of_activations
#undef mask_setting
#undef mask_string
#undef p_interact
#undef focus_r
#undef focus_xh
#undef focus_xw
#undef focus_ah
#undef focus_aw
#undef target_z
#undef target_y
#undef target_x
#undef target_index
#undef visualize
#undef yheight2
#undef xwidth2
#undef zdepth
#undef yheight
#undef xwidth
#undef priority
#undef material_string
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

/* User declarations for component 'channel_8_cave2_box2' [456]. */
#define mccompcurname  channel_8_cave2_box2
#define mccompcurtype  Union_box
#define mccompcurindex 456
#define loop_index mccchannel_8_cave2_box2_loop_index
#define this_box_volume mccchannel_8_cave2_box2_this_box_volume
#define global_geometry_element mccchannel_8_cave2_box2_global_geometry_element
#define this_box_storage mccchannel_8_cave2_box2_this_box_storage
#define material_string mccchannel_8_cave2_box2_material_string
#define priority mccchannel_8_cave2_box2_priority
#define xwidth mccchannel_8_cave2_box2_xwidth
#define yheight mccchannel_8_cave2_box2_yheight
#define zdepth mccchannel_8_cave2_box2_zdepth
#define xwidth2 mccchannel_8_cave2_box2_xwidth2
#define yheight2 mccchannel_8_cave2_box2_yheight2
#define visualize mccchannel_8_cave2_box2_visualize
#define target_index mccchannel_8_cave2_box2_target_index
#define target_x mccchannel_8_cave2_box2_target_x
#define target_y mccchannel_8_cave2_box2_target_y
#define target_z mccchannel_8_cave2_box2_target_z
#define focus_aw mccchannel_8_cave2_box2_focus_aw
#define focus_ah mccchannel_8_cave2_box2_focus_ah
#define focus_xw mccchannel_8_cave2_box2_focus_xw
#define focus_xh mccchannel_8_cave2_box2_focus_xh
#define focus_r mccchannel_8_cave2_box2_focus_r
#define p_interact mccchannel_8_cave2_box2_p_interact
#define mask_string mccchannel_8_cave2_box2_mask_string
#define mask_setting mccchannel_8_cave2_box2_mask_setting
#define number_of_activations mccchannel_8_cave2_box2_number_of_activations
#line 204 "Union_box.comp"
// Needed for transport to the main component
struct global_geometry_element_struct global_geometry_element;

#ifndef ANY_GEOMETRY_DETECTOR_DECLARE
    #define ANY_GEOMETRY_DETECTOR_DECLARE dummy
	//struct pointer_to_global_geometry_list global_geometry_list = {0,NULL};
#endif

int loop_index,found_geometries;

double x_component;
double y_component;
double z_component;

struct Volume_struct this_box_volume;
struct box_storage this_box_storage;

#line 55906 "MACS_sample_kidney_box.c"
#undef number_of_activations
#undef mask_setting
#undef mask_string
#undef p_interact
#undef focus_r
#undef focus_xh
#undef focus_xw
#undef focus_ah
#undef focus_aw
#undef target_z
#undef target_y
#undef target_x
#undef target_index
#undef visualize
#undef yheight2
#undef xwidth2
#undef zdepth
#undef yheight
#undef xwidth
#undef priority
#undef material_string
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

/* User declarations for component 'channel_8_cave2_box3' [457]. */
#define mccompcurname  channel_8_cave2_box3
#define mccompcurtype  Union_box
#define mccompcurindex 457
#define loop_index mccchannel_8_cave2_box3_loop_index
#define this_box_volume mccchannel_8_cave2_box3_this_box_volume
#define global_geometry_element mccchannel_8_cave2_box3_global_geometry_element
#define this_box_storage mccchannel_8_cave2_box3_this_box_storage
#define material_string mccchannel_8_cave2_box3_material_string
#define priority mccchannel_8_cave2_box3_priority
#define xwidth mccchannel_8_cave2_box3_xwidth
#define yheight mccchannel_8_cave2_box3_yheight
#define zdepth mccchannel_8_cave2_box3_zdepth
#define xwidth2 mccchannel_8_cave2_box3_xwidth2
#define yheight2 mccchannel_8_cave2_box3_yheight2
#define visualize mccchannel_8_cave2_box3_visualize
#define target_index mccchannel_8_cave2_box3_target_index
#define target_x mccchannel_8_cave2_box3_target_x
#define target_y mccchannel_8_cave2_box3_target_y
#define target_z mccchannel_8_cave2_box3_target_z
#define focus_aw mccchannel_8_cave2_box3_focus_aw
#define focus_ah mccchannel_8_cave2_box3_focus_ah
#define focus_xw mccchannel_8_cave2_box3_focus_xw
#define focus_xh mccchannel_8_cave2_box3_focus_xh
#define focus_r mccchannel_8_cave2_box3_focus_r
#define p_interact mccchannel_8_cave2_box3_p_interact
#define mask_string mccchannel_8_cave2_box3_mask_string
#define mask_setting mccchannel_8_cave2_box3_mask_setting
#define number_of_activations mccchannel_8_cave2_box3_number_of_activations
#line 204 "Union_box.comp"
// Needed for transport to the main component
struct global_geometry_element_struct global_geometry_element;

#ifndef ANY_GEOMETRY_DETECTOR_DECLARE
    #define ANY_GEOMETRY_DETECTOR_DECLARE dummy
	//struct pointer_to_global_geometry_list global_geometry_list = {0,NULL};
#endif

int loop_index,found_geometries;

double x_component;
double y_component;
double z_component;

struct Volume_struct this_box_volume;
struct box_storage this_box_storage;

#line 55983 "MACS_sample_kidney_box.c"
#undef number_of_activations
#undef mask_setting
#undef mask_string
#undef p_interact
#undef focus_r
#undef focus_xh
#undef focus_xw
#undef focus_ah
#undef focus_aw
#undef target_z
#undef target_y
#undef target_x
#undef target_index
#undef visualize
#undef yheight2
#undef xwidth2
#undef zdepth
#undef yheight
#undef xwidth
#undef priority
#undef material_string
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

/* User declarations for component 'inter_analyzer_colimator_center_8' [458]. */
#define mccompcurname  inter_analyzer_colimator_center_8
#define mccompcurtype  Arm
#define mccompcurindex 458
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

/* User declarations for component 'inter_analyzer_colimator_8_blade_0' [459]. */
#define mccompcurname  inter_analyzer_colimator_8_blade_0
#define mccompcurtype  Union_box
#define mccompcurindex 459
#define loop_index mccinter_analyzer_colimator_8_blade_0_loop_index
#define this_box_volume mccinter_analyzer_colimator_8_blade_0_this_box_volume
#define global_geometry_element mccinter_analyzer_colimator_8_blade_0_global_geometry_element
#define this_box_storage mccinter_analyzer_colimator_8_blade_0_this_box_storage
#define material_string mccinter_analyzer_colimator_8_blade_0_material_string
#define priority mccinter_analyzer_colimator_8_blade_0_priority
#define xwidth mccinter_analyzer_colimator_8_blade_0_xwidth
#define yheight mccinter_analyzer_colimator_8_blade_0_yheight
#define zdepth mccinter_analyzer_colimator_8_blade_0_zdepth
#define xwidth2 mccinter_analyzer_colimator_8_blade_0_xwidth2
#define yheight2 mccinter_analyzer_colimator_8_blade_0_yheight2
#define visualize mccinter_analyzer_colimator_8_blade_0_visualize
#define target_index mccinter_analyzer_colimator_8_blade_0_target_index
#define target_x mccinter_analyzer_colimator_8_blade_0_target_x
#define target_y mccinter_analyzer_colimator_8_blade_0_target_y
#define target_z mccinter_analyzer_colimator_8_blade_0_target_z
#define focus_aw mccinter_analyzer_colimator_8_blade_0_focus_aw
#define focus_ah mccinter_analyzer_colimator_8_blade_0_focus_ah
#define focus_xw mccinter_analyzer_colimator_8_blade_0_focus_xw
#define focus_xh mccinter_analyzer_colimator_8_blade_0_focus_xh
#define focus_r mccinter_analyzer_colimator_8_blade_0_focus_r
#define p_interact mccinter_analyzer_colimator_8_blade_0_p_interact
#define mask_string mccinter_analyzer_colimator_8_blade_0_mask_string
#define mask_setting mccinter_analyzer_colimator_8_blade_0_mask_setting
#define number_of_activations mccinter_analyzer_colimator_8_blade_0_number_of_activations
#line 204 "Union_box.comp"
// Needed for transport to the main component
struct global_geometry_element_struct global_geometry_element;

#ifndef ANY_GEOMETRY_DETECTOR_DECLARE
    #define ANY_GEOMETRY_DETECTOR_DECLARE dummy
	//struct pointer_to_global_geometry_list global_geometry_list = {0,NULL};
#endif

int loop_index,found_geometries;

double x_component;
double y_component;
double z_component;

struct Volume_struct this_box_volume;
struct box_storage this_box_storage;

#line 56068 "MACS_sample_kidney_box.c"
#undef number_of_activations
#undef mask_setting
#undef mask_string
#undef p_interact
#undef focus_r
#undef focus_xh
#undef focus_xw
#undef focus_ah
#undef focus_aw
#undef target_z
#undef target_y
#undef target_x
#undef target_index
#undef visualize
#undef yheight2
#undef xwidth2
#undef zdepth
#undef yheight
#undef xwidth
#undef priority
#undef material_string
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

/* User declarations for component 'inter_analyzer_colimator_8_blade_1' [460]. */
#define mccompcurname  inter_analyzer_colimator_8_blade_1
#define mccompcurtype  Union_box
#define mccompcurindex 460
#define loop_index mccinter_analyzer_colimator_8_blade_1_loop_index
#define this_box_volume mccinter_analyzer_colimator_8_blade_1_this_box_volume
#define global_geometry_element mccinter_analyzer_colimator_8_blade_1_global_geometry_element
#define this_box_storage mccinter_analyzer_colimator_8_blade_1_this_box_storage
#define material_string mccinter_analyzer_colimator_8_blade_1_material_string
#define priority mccinter_analyzer_colimator_8_blade_1_priority
#define xwidth mccinter_analyzer_colimator_8_blade_1_xwidth
#define yheight mccinter_analyzer_colimator_8_blade_1_yheight
#define zdepth mccinter_analyzer_colimator_8_blade_1_zdepth
#define xwidth2 mccinter_analyzer_colimator_8_blade_1_xwidth2
#define yheight2 mccinter_analyzer_colimator_8_blade_1_yheight2
#define visualize mccinter_analyzer_colimator_8_blade_1_visualize
#define target_index mccinter_analyzer_colimator_8_blade_1_target_index
#define target_x mccinter_analyzer_colimator_8_blade_1_target_x
#define target_y mccinter_analyzer_colimator_8_blade_1_target_y
#define target_z mccinter_analyzer_colimator_8_blade_1_target_z
#define focus_aw mccinter_analyzer_colimator_8_blade_1_focus_aw
#define focus_ah mccinter_analyzer_colimator_8_blade_1_focus_ah
#define focus_xw mccinter_analyzer_colimator_8_blade_1_focus_xw
#define focus_xh mccinter_analyzer_colimator_8_blade_1_focus_xh
#define focus_r mccinter_analyzer_colimator_8_blade_1_focus_r
#define p_interact mccinter_analyzer_colimator_8_blade_1_p_interact
#define mask_string mccinter_analyzer_colimator_8_blade_1_mask_string
#define mask_setting mccinter_analyzer_colimator_8_blade_1_mask_setting
#define number_of_activations mccinter_analyzer_colimator_8_blade_1_number_of_activations
#line 204 "Union_box.comp"
// Needed for transport to the main component
struct global_geometry_element_struct global_geometry_element;

#ifndef ANY_GEOMETRY_DETECTOR_DECLARE
    #define ANY_GEOMETRY_DETECTOR_DECLARE dummy
	//struct pointer_to_global_geometry_list global_geometry_list = {0,NULL};
#endif

int loop_index,found_geometries;

double x_component;
double y_component;
double z_component;

struct Volume_struct this_box_volume;
struct box_storage this_box_storage;

#line 56145 "MACS_sample_kidney_box.c"
#undef number_of_activations
#undef mask_setting
#undef mask_string
#undef p_interact
#undef focus_r
#undef focus_xh
#undef focus_xw
#undef focus_ah
#undef focus_aw
#undef target_z
#undef target_y
#undef target_x
#undef target_index
#undef visualize
#undef yheight2
#undef xwidth2
#undef zdepth
#undef yheight
#undef xwidth
#undef priority
#undef material_string
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

/* User declarations for component 'inter_analyzer_colimator_8_blade_2' [461]. */
#define mccompcurname  inter_analyzer_colimator_8_blade_2
#define mccompcurtype  Union_box
#define mccompcurindex 461
#define loop_index mccinter_analyzer_colimator_8_blade_2_loop_index
#define this_box_volume mccinter_analyzer_colimator_8_blade_2_this_box_volume
#define global_geometry_element mccinter_analyzer_colimator_8_blade_2_global_geometry_element
#define this_box_storage mccinter_analyzer_colimator_8_blade_2_this_box_storage
#define material_string mccinter_analyzer_colimator_8_blade_2_material_string
#define priority mccinter_analyzer_colimator_8_blade_2_priority
#define xwidth mccinter_analyzer_colimator_8_blade_2_xwidth
#define yheight mccinter_analyzer_colimator_8_blade_2_yheight
#define zdepth mccinter_analyzer_colimator_8_blade_2_zdepth
#define xwidth2 mccinter_analyzer_colimator_8_blade_2_xwidth2
#define yheight2 mccinter_analyzer_colimator_8_blade_2_yheight2
#define visualize mccinter_analyzer_colimator_8_blade_2_visualize
#define target_index mccinter_analyzer_colimator_8_blade_2_target_index
#define target_x mccinter_analyzer_colimator_8_blade_2_target_x
#define target_y mccinter_analyzer_colimator_8_blade_2_target_y
#define target_z mccinter_analyzer_colimator_8_blade_2_target_z
#define focus_aw mccinter_analyzer_colimator_8_blade_2_focus_aw
#define focus_ah mccinter_analyzer_colimator_8_blade_2_focus_ah
#define focus_xw mccinter_analyzer_colimator_8_blade_2_focus_xw
#define focus_xh mccinter_analyzer_colimator_8_blade_2_focus_xh
#define focus_r mccinter_analyzer_colimator_8_blade_2_focus_r
#define p_interact mccinter_analyzer_colimator_8_blade_2_p_interact
#define mask_string mccinter_analyzer_colimator_8_blade_2_mask_string
#define mask_setting mccinter_analyzer_colimator_8_blade_2_mask_setting
#define number_of_activations mccinter_analyzer_colimator_8_blade_2_number_of_activations
#line 204 "Union_box.comp"
// Needed for transport to the main component
struct global_geometry_element_struct global_geometry_element;

#ifndef ANY_GEOMETRY_DETECTOR_DECLARE
    #define ANY_GEOMETRY_DETECTOR_DECLARE dummy
	//struct pointer_to_global_geometry_list global_geometry_list = {0,NULL};
#endif

int loop_index,found_geometries;

double x_component;
double y_component;
double z_component;

struct Volume_struct this_box_volume;
struct box_storage this_box_storage;

#line 56222 "MACS_sample_kidney_box.c"
#undef number_of_activations
#undef mask_setting
#undef mask_string
#undef p_interact
#undef focus_r
#undef focus_xh
#undef focus_xw
#undef focus_ah
#undef focus_aw
#undef target_z
#undef target_y
#undef target_x
#undef target_index
#undef visualize
#undef yheight2
#undef xwidth2
#undef zdepth
#undef yheight
#undef xwidth
#undef priority
#undef material_string
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

/* User declarations for component 'inter_analyzer_colimator_8_blade_3' [462]. */
#define mccompcurname  inter_analyzer_colimator_8_blade_3
#define mccompcurtype  Union_box
#define mccompcurindex 462
#define loop_index mccinter_analyzer_colimator_8_blade_3_loop_index
#define this_box_volume mccinter_analyzer_colimator_8_blade_3_this_box_volume
#define global_geometry_element mccinter_analyzer_colimator_8_blade_3_global_geometry_element
#define this_box_storage mccinter_analyzer_colimator_8_blade_3_this_box_storage
#define material_string mccinter_analyzer_colimator_8_blade_3_material_string
#define priority mccinter_analyzer_colimator_8_blade_3_priority
#define xwidth mccinter_analyzer_colimator_8_blade_3_xwidth
#define yheight mccinter_analyzer_colimator_8_blade_3_yheight
#define zdepth mccinter_analyzer_colimator_8_blade_3_zdepth
#define xwidth2 mccinter_analyzer_colimator_8_blade_3_xwidth2
#define yheight2 mccinter_analyzer_colimator_8_blade_3_yheight2
#define visualize mccinter_analyzer_colimator_8_blade_3_visualize
#define target_index mccinter_analyzer_colimator_8_blade_3_target_index
#define target_x mccinter_analyzer_colimator_8_blade_3_target_x
#define target_y mccinter_analyzer_colimator_8_blade_3_target_y
#define target_z mccinter_analyzer_colimator_8_blade_3_target_z
#define focus_aw mccinter_analyzer_colimator_8_blade_3_focus_aw
#define focus_ah mccinter_analyzer_colimator_8_blade_3_focus_ah
#define focus_xw mccinter_analyzer_colimator_8_blade_3_focus_xw
#define focus_xh mccinter_analyzer_colimator_8_blade_3_focus_xh
#define focus_r mccinter_analyzer_colimator_8_blade_3_focus_r
#define p_interact mccinter_analyzer_colimator_8_blade_3_p_interact
#define mask_string mccinter_analyzer_colimator_8_blade_3_mask_string
#define mask_setting mccinter_analyzer_colimator_8_blade_3_mask_setting
#define number_of_activations mccinter_analyzer_colimator_8_blade_3_number_of_activations
#line 204 "Union_box.comp"
// Needed for transport to the main component
struct global_geometry_element_struct global_geometry_element;

#ifndef ANY_GEOMETRY_DETECTOR_DECLARE
    #define ANY_GEOMETRY_DETECTOR_DECLARE dummy
	//struct pointer_to_global_geometry_list global_geometry_list = {0,NULL};
#endif

int loop_index,found_geometries;

double x_component;
double y_component;
double z_component;

struct Volume_struct this_box_volume;
struct box_storage this_box_storage;

#line 56299 "MACS_sample_kidney_box.c"
#undef number_of_activations
#undef mask_setting
#undef mask_string
#undef p_interact
#undef focus_r
#undef focus_xh
#undef focus_xw
#undef focus_ah
#undef focus_aw
#undef target_z
#undef target_y
#undef target_x
#undef target_index
#undef visualize
#undef yheight2
#undef xwidth2
#undef zdepth
#undef yheight
#undef xwidth
#undef priority
#undef material_string
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

/* User declarations for component 'inter_analyzer_colimator_8_blade_4' [463]. */
#define mccompcurname  inter_analyzer_colimator_8_blade_4
#define mccompcurtype  Union_box
#define mccompcurindex 463
#define loop_index mccinter_analyzer_colimator_8_blade_4_loop_index
#define this_box_volume mccinter_analyzer_colimator_8_blade_4_this_box_volume
#define global_geometry_element mccinter_analyzer_colimator_8_blade_4_global_geometry_element
#define this_box_storage mccinter_analyzer_colimator_8_blade_4_this_box_storage
#define material_string mccinter_analyzer_colimator_8_blade_4_material_string
#define priority mccinter_analyzer_colimator_8_blade_4_priority
#define xwidth mccinter_analyzer_colimator_8_blade_4_xwidth
#define yheight mccinter_analyzer_colimator_8_blade_4_yheight
#define zdepth mccinter_analyzer_colimator_8_blade_4_zdepth
#define xwidth2 mccinter_analyzer_colimator_8_blade_4_xwidth2
#define yheight2 mccinter_analyzer_colimator_8_blade_4_yheight2
#define visualize mccinter_analyzer_colimator_8_blade_4_visualize
#define target_index mccinter_analyzer_colimator_8_blade_4_target_index
#define target_x mccinter_analyzer_colimator_8_blade_4_target_x
#define target_y mccinter_analyzer_colimator_8_blade_4_target_y
#define target_z mccinter_analyzer_colimator_8_blade_4_target_z
#define focus_aw mccinter_analyzer_colimator_8_blade_4_focus_aw
#define focus_ah mccinter_analyzer_colimator_8_blade_4_focus_ah
#define focus_xw mccinter_analyzer_colimator_8_blade_4_focus_xw
#define focus_xh mccinter_analyzer_colimator_8_blade_4_focus_xh
#define focus_r mccinter_analyzer_colimator_8_blade_4_focus_r
#define p_interact mccinter_analyzer_colimator_8_blade_4_p_interact
#define mask_string mccinter_analyzer_colimator_8_blade_4_mask_string
#define mask_setting mccinter_analyzer_colimator_8_blade_4_mask_setting
#define number_of_activations mccinter_analyzer_colimator_8_blade_4_number_of_activations
#line 204 "Union_box.comp"
// Needed for transport to the main component
struct global_geometry_element_struct global_geometry_element;

#ifndef ANY_GEOMETRY_DETECTOR_DECLARE
    #define ANY_GEOMETRY_DETECTOR_DECLARE dummy
	//struct pointer_to_global_geometry_list global_geometry_list = {0,NULL};
#endif

int loop_index,found_geometries;

double x_component;
double y_component;
double z_component;

struct Volume_struct this_box_volume;
struct box_storage this_box_storage;

#line 56376 "MACS_sample_kidney_box.c"
#undef number_of_activations
#undef mask_setting
#undef mask_string
#undef p_interact
#undef focus_r
#undef focus_xh
#undef focus_xw
#undef focus_ah
#undef focus_aw
#undef target_z
#undef target_y
#undef target_x
#undef target_index
#undef visualize
#undef yheight2
#undef xwidth2
#undef zdepth
#undef yheight
#undef xwidth
#undef priority
#undef material_string
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

/* User declarations for component 'diffraction_detector_8_exit_volume' [464]. */
#define mccompcurname  diffraction_detector_8_exit_volume
#define mccompcurtype  Union_box
#define mccompcurindex 464
#define loop_index mccdiffraction_detector_8_exit_volume_loop_index
#define this_box_volume mccdiffraction_detector_8_exit_volume_this_box_volume
#define global_geometry_element mccdiffraction_detector_8_exit_volume_global_geometry_element
#define this_box_storage mccdiffraction_detector_8_exit_volume_this_box_storage
#define material_string mccdiffraction_detector_8_exit_volume_material_string
#define priority mccdiffraction_detector_8_exit_volume_priority
#define xwidth mccdiffraction_detector_8_exit_volume_xwidth
#define yheight mccdiffraction_detector_8_exit_volume_yheight
#define zdepth mccdiffraction_detector_8_exit_volume_zdepth
#define xwidth2 mccdiffraction_detector_8_exit_volume_xwidth2
#define yheight2 mccdiffraction_detector_8_exit_volume_yheight2
#define visualize mccdiffraction_detector_8_exit_volume_visualize
#define target_index mccdiffraction_detector_8_exit_volume_target_index
#define target_x mccdiffraction_detector_8_exit_volume_target_x
#define target_y mccdiffraction_detector_8_exit_volume_target_y
#define target_z mccdiffraction_detector_8_exit_volume_target_z
#define focus_aw mccdiffraction_detector_8_exit_volume_focus_aw
#define focus_ah mccdiffraction_detector_8_exit_volume_focus_ah
#define focus_xw mccdiffraction_detector_8_exit_volume_focus_xw
#define focus_xh mccdiffraction_detector_8_exit_volume_focus_xh
#define focus_r mccdiffraction_detector_8_exit_volume_focus_r
#define p_interact mccdiffraction_detector_8_exit_volume_p_interact
#define mask_string mccdiffraction_detector_8_exit_volume_mask_string
#define mask_setting mccdiffraction_detector_8_exit_volume_mask_setting
#define number_of_activations mccdiffraction_detector_8_exit_volume_number_of_activations
#line 204 "Union_box.comp"
// Needed for transport to the main component
struct global_geometry_element_struct global_geometry_element;

#ifndef ANY_GEOMETRY_DETECTOR_DECLARE
    #define ANY_GEOMETRY_DETECTOR_DECLARE dummy
	//struct pointer_to_global_geometry_list global_geometry_list = {0,NULL};
#endif

int loop_index,found_geometries;

double x_component;
double y_component;
double z_component;

struct Volume_struct this_box_volume;
struct box_storage this_box_storage;

#line 56453 "MACS_sample_kidney_box.c"
#undef number_of_activations
#undef mask_setting
#undef mask_string
#undef p_interact
#undef focus_r
#undef focus_xh
#undef focus_xw
#undef focus_ah
#undef focus_aw
#undef target_z
#undef target_y
#undef target_x
#undef target_index
#undef visualize
#undef yheight2
#undef xwidth2
#undef zdepth
#undef yheight
#undef xwidth
#undef priority
#undef material_string
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

/* User declarations for component 'spec_detector_8_exit_volume' [465]. */
#define mccompcurname  spec_detector_8_exit_volume
#define mccompcurtype  Union_box
#define mccompcurindex 465
#define loop_index mccspec_detector_8_exit_volume_loop_index
#define this_box_volume mccspec_detector_8_exit_volume_this_box_volume
#define global_geometry_element mccspec_detector_8_exit_volume_global_geometry_element
#define this_box_storage mccspec_detector_8_exit_volume_this_box_storage
#define material_string mccspec_detector_8_exit_volume_material_string
#define priority mccspec_detector_8_exit_volume_priority
#define xwidth mccspec_detector_8_exit_volume_xwidth
#define yheight mccspec_detector_8_exit_volume_yheight
#define zdepth mccspec_detector_8_exit_volume_zdepth
#define xwidth2 mccspec_detector_8_exit_volume_xwidth2
#define yheight2 mccspec_detector_8_exit_volume_yheight2
#define visualize mccspec_detector_8_exit_volume_visualize
#define target_index mccspec_detector_8_exit_volume_target_index
#define target_x mccspec_detector_8_exit_volume_target_x
#define target_y mccspec_detector_8_exit_volume_target_y
#define target_z mccspec_detector_8_exit_volume_target_z
#define focus_aw mccspec_detector_8_exit_volume_focus_aw
#define focus_ah mccspec_detector_8_exit_volume_focus_ah
#define focus_xw mccspec_detector_8_exit_volume_focus_xw
#define focus_xh mccspec_detector_8_exit_volume_focus_xh
#define focus_r mccspec_detector_8_exit_volume_focus_r
#define p_interact mccspec_detector_8_exit_volume_p_interact
#define mask_string mccspec_detector_8_exit_volume_mask_string
#define mask_setting mccspec_detector_8_exit_volume_mask_setting
#define number_of_activations mccspec_detector_8_exit_volume_number_of_activations
#line 204 "Union_box.comp"
// Needed for transport to the main component
struct global_geometry_element_struct global_geometry_element;

#ifndef ANY_GEOMETRY_DETECTOR_DECLARE
    #define ANY_GEOMETRY_DETECTOR_DECLARE dummy
	//struct pointer_to_global_geometry_list global_geometry_list = {0,NULL};
#endif

int loop_index,found_geometries;

double x_component;
double y_component;
double z_component;

struct Volume_struct this_box_volume;
struct box_storage this_box_storage;

#line 56530 "MACS_sample_kidney_box.c"
#undef number_of_activations
#undef mask_setting
#undef mask_string
#undef p_interact
#undef focus_r
#undef focus_xh
#undef focus_xw
#undef focus_ah
#undef focus_aw
#undef target_z
#undef target_y
#undef target_x
#undef target_index
#undef visualize
#undef yheight2
#undef xwidth2
#undef zdepth
#undef yheight
#undef xwidth
#undef priority
#undef material_string
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

/* User declarations for component 'channel_9_cave1_box1' [466]. */
#define mccompcurname  channel_9_cave1_box1
#define mccompcurtype  Union_box
#define mccompcurindex 466
#define loop_index mccchannel_9_cave1_box1_loop_index
#define this_box_volume mccchannel_9_cave1_box1_this_box_volume
#define global_geometry_element mccchannel_9_cave1_box1_global_geometry_element
#define this_box_storage mccchannel_9_cave1_box1_this_box_storage
#define material_string mccchannel_9_cave1_box1_material_string
#define priority mccchannel_9_cave1_box1_priority
#define xwidth mccchannel_9_cave1_box1_xwidth
#define yheight mccchannel_9_cave1_box1_yheight
#define zdepth mccchannel_9_cave1_box1_zdepth
#define xwidth2 mccchannel_9_cave1_box1_xwidth2
#define yheight2 mccchannel_9_cave1_box1_yheight2
#define visualize mccchannel_9_cave1_box1_visualize
#define target_index mccchannel_9_cave1_box1_target_index
#define target_x mccchannel_9_cave1_box1_target_x
#define target_y mccchannel_9_cave1_box1_target_y
#define target_z mccchannel_9_cave1_box1_target_z
#define focus_aw mccchannel_9_cave1_box1_focus_aw
#define focus_ah mccchannel_9_cave1_box1_focus_ah
#define focus_xw mccchannel_9_cave1_box1_focus_xw
#define focus_xh mccchannel_9_cave1_box1_focus_xh
#define focus_r mccchannel_9_cave1_box1_focus_r
#define p_interact mccchannel_9_cave1_box1_p_interact
#define mask_string mccchannel_9_cave1_box1_mask_string
#define mask_setting mccchannel_9_cave1_box1_mask_setting
#define number_of_activations mccchannel_9_cave1_box1_number_of_activations
#line 204 "Union_box.comp"
// Needed for transport to the main component
struct global_geometry_element_struct global_geometry_element;

#ifndef ANY_GEOMETRY_DETECTOR_DECLARE
    #define ANY_GEOMETRY_DETECTOR_DECLARE dummy
	//struct pointer_to_global_geometry_list global_geometry_list = {0,NULL};
#endif

int loop_index,found_geometries;

double x_component;
double y_component;
double z_component;

struct Volume_struct this_box_volume;
struct box_storage this_box_storage;

#line 56607 "MACS_sample_kidney_box.c"
#undef number_of_activations
#undef mask_setting
#undef mask_string
#undef p_interact
#undef focus_r
#undef focus_xh
#undef focus_xw
#undef focus_ah
#undef focus_aw
#undef target_z
#undef target_y
#undef target_x
#undef target_index
#undef visualize
#undef yheight2
#undef xwidth2
#undef zdepth
#undef yheight
#undef xwidth
#undef priority
#undef material_string
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

/* User declarations for component 'channel_9_cave1_box2' [467]. */
#define mccompcurname  channel_9_cave1_box2
#define mccompcurtype  Union_box
#define mccompcurindex 467
#define loop_index mccchannel_9_cave1_box2_loop_index
#define this_box_volume mccchannel_9_cave1_box2_this_box_volume
#define global_geometry_element mccchannel_9_cave1_box2_global_geometry_element
#define this_box_storage mccchannel_9_cave1_box2_this_box_storage
#define material_string mccchannel_9_cave1_box2_material_string
#define priority mccchannel_9_cave1_box2_priority
#define xwidth mccchannel_9_cave1_box2_xwidth
#define yheight mccchannel_9_cave1_box2_yheight
#define zdepth mccchannel_9_cave1_box2_zdepth
#define xwidth2 mccchannel_9_cave1_box2_xwidth2
#define yheight2 mccchannel_9_cave1_box2_yheight2
#define visualize mccchannel_9_cave1_box2_visualize
#define target_index mccchannel_9_cave1_box2_target_index
#define target_x mccchannel_9_cave1_box2_target_x
#define target_y mccchannel_9_cave1_box2_target_y
#define target_z mccchannel_9_cave1_box2_target_z
#define focus_aw mccchannel_9_cave1_box2_focus_aw
#define focus_ah mccchannel_9_cave1_box2_focus_ah
#define focus_xw mccchannel_9_cave1_box2_focus_xw
#define focus_xh mccchannel_9_cave1_box2_focus_xh
#define focus_r mccchannel_9_cave1_box2_focus_r
#define p_interact mccchannel_9_cave1_box2_p_interact
#define mask_string mccchannel_9_cave1_box2_mask_string
#define mask_setting mccchannel_9_cave1_box2_mask_setting
#define number_of_activations mccchannel_9_cave1_box2_number_of_activations
#line 204 "Union_box.comp"
// Needed for transport to the main component
struct global_geometry_element_struct global_geometry_element;

#ifndef ANY_GEOMETRY_DETECTOR_DECLARE
    #define ANY_GEOMETRY_DETECTOR_DECLARE dummy
	//struct pointer_to_global_geometry_list global_geometry_list = {0,NULL};
#endif

int loop_index,found_geometries;

double x_component;
double y_component;
double z_component;

struct Volume_struct this_box_volume;
struct box_storage this_box_storage;

#line 56684 "MACS_sample_kidney_box.c"
#undef number_of_activations
#undef mask_setting
#undef mask_string
#undef p_interact
#undef focus_r
#undef focus_xh
#undef focus_xw
#undef focus_ah
#undef focus_aw
#undef target_z
#undef target_y
#undef target_x
#undef target_index
#undef visualize
#undef yheight2
#undef xwidth2
#undef zdepth
#undef yheight
#undef xwidth
#undef priority
#undef material_string
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

/* User declarations for component 'channel_9_cave1_box3' [468]. */
#define mccompcurname  channel_9_cave1_box3
#define mccompcurtype  Union_box
#define mccompcurindex 468
#define loop_index mccchannel_9_cave1_box3_loop_index
#define this_box_volume mccchannel_9_cave1_box3_this_box_volume
#define global_geometry_element mccchannel_9_cave1_box3_global_geometry_element
#define this_box_storage mccchannel_9_cave1_box3_this_box_storage
#define material_string mccchannel_9_cave1_box3_material_string
#define priority mccchannel_9_cave1_box3_priority
#define xwidth mccchannel_9_cave1_box3_xwidth
#define yheight mccchannel_9_cave1_box3_yheight
#define zdepth mccchannel_9_cave1_box3_zdepth
#define xwidth2 mccchannel_9_cave1_box3_xwidth2
#define yheight2 mccchannel_9_cave1_box3_yheight2
#define visualize mccchannel_9_cave1_box3_visualize
#define target_index mccchannel_9_cave1_box3_target_index
#define target_x mccchannel_9_cave1_box3_target_x
#define target_y mccchannel_9_cave1_box3_target_y
#define target_z mccchannel_9_cave1_box3_target_z
#define focus_aw mccchannel_9_cave1_box3_focus_aw
#define focus_ah mccchannel_9_cave1_box3_focus_ah
#define focus_xw mccchannel_9_cave1_box3_focus_xw
#define focus_xh mccchannel_9_cave1_box3_focus_xh
#define focus_r mccchannel_9_cave1_box3_focus_r
#define p_interact mccchannel_9_cave1_box3_p_interact
#define mask_string mccchannel_9_cave1_box3_mask_string
#define mask_setting mccchannel_9_cave1_box3_mask_setting
#define number_of_activations mccchannel_9_cave1_box3_number_of_activations
#line 204 "Union_box.comp"
// Needed for transport to the main component
struct global_geometry_element_struct global_geometry_element;

#ifndef ANY_GEOMETRY_DETECTOR_DECLARE
    #define ANY_GEOMETRY_DETECTOR_DECLARE dummy
	//struct pointer_to_global_geometry_list global_geometry_list = {0,NULL};
#endif

int loop_index,found_geometries;

double x_component;
double y_component;
double z_component;

struct Volume_struct this_box_volume;
struct box_storage this_box_storage;

#line 56761 "MACS_sample_kidney_box.c"
#undef number_of_activations
#undef mask_setting
#undef mask_string
#undef p_interact
#undef focus_r
#undef focus_xh
#undef focus_xw
#undef focus_ah
#undef focus_aw
#undef target_z
#undef target_y
#undef target_x
#undef target_index
#undef visualize
#undef yheight2
#undef xwidth2
#undef zdepth
#undef yheight
#undef xwidth
#undef priority
#undef material_string
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

/* User declarations for component 'channel_9_cave1_cyl1' [469]. */
#define mccompcurname  channel_9_cave1_cyl1
#define mccompcurtype  Union_cylinder
#define mccompcurindex 469
#define loop_index mccchannel_9_cave1_cyl1_loop_index
#define this_cylinder_volume mccchannel_9_cave1_cyl1_this_cylinder_volume
#define global_geometry_element mccchannel_9_cave1_cyl1_global_geometry_element
#define this_cylinder_storage mccchannel_9_cave1_cyl1_this_cylinder_storage
#define material_string mccchannel_9_cave1_cyl1_material_string
#define priority mccchannel_9_cave1_cyl1_priority
#define radius mccchannel_9_cave1_cyl1_radius
#define yheight mccchannel_9_cave1_cyl1_yheight
#define visualize mccchannel_9_cave1_cyl1_visualize
#define target_index mccchannel_9_cave1_cyl1_target_index
#define target_x mccchannel_9_cave1_cyl1_target_x
#define target_y mccchannel_9_cave1_cyl1_target_y
#define target_z mccchannel_9_cave1_cyl1_target_z
#define focus_aw mccchannel_9_cave1_cyl1_focus_aw
#define focus_ah mccchannel_9_cave1_cyl1_focus_ah
#define focus_xw mccchannel_9_cave1_cyl1_focus_xw
#define focus_xh mccchannel_9_cave1_cyl1_focus_xh
#define focus_r mccchannel_9_cave1_cyl1_focus_r
#define p_interact mccchannel_9_cave1_cyl1_p_interact
#define mask_string mccchannel_9_cave1_cyl1_mask_string
#define mask_setting mccchannel_9_cave1_cyl1_mask_setting
#define number_of_activations mccchannel_9_cave1_cyl1_number_of_activations
#line 167 "Union_cylinder.comp"
// Needed for transport to the main component
struct global_geometry_element_struct global_geometry_element;

#ifndef ANY_GEOMETRY_DETECTOR_DECLARE
    #define ANY_GEOMETRY_DETECTOR_DECLARE dummy
	//struct pointer_to_global_geometry_list global_geometry_list = {0,NULL};
#endif

int dummy;
int loop_index,found_geometries;
int loop_2_index;
int material_index;

struct Volume_struct this_cylinder_volume;
struct cylinder_storage this_cylinder_storage;
#line 56833 "MACS_sample_kidney_box.c"
#undef number_of_activations
#undef mask_setting
#undef mask_string
#undef p_interact
#undef focus_r
#undef focus_xh
#undef focus_xw
#undef focus_ah
#undef focus_aw
#undef target_z
#undef target_y
#undef target_x
#undef target_index
#undef visualize
#undef yheight
#undef radius
#undef priority
#undef material_string
#undef this_cylinder_storage
#undef global_geometry_element
#undef this_cylinder_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

/* User declarations for component 'channel_9_analyzer_1_center' [470]. */
#define mccompcurname  channel_9_analyzer_1_center
#define mccompcurtype  Arm
#define mccompcurindex 470
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

/* User declarations for component 'channel_9_analyzer_1_rotated' [471]. */
#define mccompcurname  channel_9_analyzer_1_rotated
#define mccompcurtype  Arm
#define mccompcurindex 471
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

/* User declarations for component 'channel_9_analyzer_1_array_crystal_array_0' [472]. */
#define mccompcurname  channel_9_analyzer_1_array_crystal_array_0
#define mccompcurtype  Union_box
#define mccompcurindex 472
#define loop_index mccchannel_9_analyzer_1_array_crystal_array_0_loop_index
#define this_box_volume mccchannel_9_analyzer_1_array_crystal_array_0_this_box_volume
#define global_geometry_element mccchannel_9_analyzer_1_array_crystal_array_0_global_geometry_element
#define this_box_storage mccchannel_9_analyzer_1_array_crystal_array_0_this_box_storage
#define material_string mccchannel_9_analyzer_1_array_crystal_array_0_material_string
#define priority mccchannel_9_analyzer_1_array_crystal_array_0_priority
#define xwidth mccchannel_9_analyzer_1_array_crystal_array_0_xwidth
#define yheight mccchannel_9_analyzer_1_array_crystal_array_0_yheight
#define zdepth mccchannel_9_analyzer_1_array_crystal_array_0_zdepth
#define xwidth2 mccchannel_9_analyzer_1_array_crystal_array_0_xwidth2
#define yheight2 mccchannel_9_analyzer_1_array_crystal_array_0_yheight2
#define visualize mccchannel_9_analyzer_1_array_crystal_array_0_visualize
#define target_index mccchannel_9_analyzer_1_array_crystal_array_0_target_index
#define target_x mccchannel_9_analyzer_1_array_crystal_array_0_target_x
#define target_y mccchannel_9_analyzer_1_array_crystal_array_0_target_y
#define target_z mccchannel_9_analyzer_1_array_crystal_array_0_target_z
#define focus_aw mccchannel_9_analyzer_1_array_crystal_array_0_focus_aw
#define focus_ah mccchannel_9_analyzer_1_array_crystal_array_0_focus_ah
#define focus_xw mccchannel_9_analyzer_1_array_crystal_array_0_focus_xw
#define focus_xh mccchannel_9_analyzer_1_array_crystal_array_0_focus_xh
#define focus_r mccchannel_9_analyzer_1_array_crystal_array_0_focus_r
#define p_interact mccchannel_9_analyzer_1_array_crystal_array_0_p_interact
#define mask_string mccchannel_9_analyzer_1_array_crystal_array_0_mask_string
#define mask_setting mccchannel_9_analyzer_1_array_crystal_array_0_mask_setting
#define number_of_activations mccchannel_9_analyzer_1_array_crystal_array_0_number_of_activations
#line 204 "Union_box.comp"
// Needed for transport to the main component
struct global_geometry_element_struct global_geometry_element;

#ifndef ANY_GEOMETRY_DETECTOR_DECLARE
    #define ANY_GEOMETRY_DETECTOR_DECLARE dummy
	//struct pointer_to_global_geometry_list global_geometry_list = {0,NULL};
#endif

int loop_index,found_geometries;

double x_component;
double y_component;
double z_component;

struct Volume_struct this_box_volume;
struct box_storage this_box_storage;

#line 56923 "MACS_sample_kidney_box.c"
#undef number_of_activations
#undef mask_setting
#undef mask_string
#undef p_interact
#undef focus_r
#undef focus_xh
#undef focus_xw
#undef focus_ah
#undef focus_aw
#undef target_z
#undef target_y
#undef target_x
#undef target_index
#undef visualize
#undef yheight2
#undef xwidth2
#undef zdepth
#undef yheight
#undef xwidth
#undef priority
#undef material_string
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

/* User declarations for component 'channel_9_analyzer_1_array_crystal_array_1' [473]. */
#define mccompcurname  channel_9_analyzer_1_array_crystal_array_1
#define mccompcurtype  Union_box
#define mccompcurindex 473
#define loop_index mccchannel_9_analyzer_1_array_crystal_array_1_loop_index
#define this_box_volume mccchannel_9_analyzer_1_array_crystal_array_1_this_box_volume
#define global_geometry_element mccchannel_9_analyzer_1_array_crystal_array_1_global_geometry_element
#define this_box_storage mccchannel_9_analyzer_1_array_crystal_array_1_this_box_storage
#define material_string mccchannel_9_analyzer_1_array_crystal_array_1_material_string
#define priority mccchannel_9_analyzer_1_array_crystal_array_1_priority
#define xwidth mccchannel_9_analyzer_1_array_crystal_array_1_xwidth
#define yheight mccchannel_9_analyzer_1_array_crystal_array_1_yheight
#define zdepth mccchannel_9_analyzer_1_array_crystal_array_1_zdepth
#define xwidth2 mccchannel_9_analyzer_1_array_crystal_array_1_xwidth2
#define yheight2 mccchannel_9_analyzer_1_array_crystal_array_1_yheight2
#define visualize mccchannel_9_analyzer_1_array_crystal_array_1_visualize
#define target_index mccchannel_9_analyzer_1_array_crystal_array_1_target_index
#define target_x mccchannel_9_analyzer_1_array_crystal_array_1_target_x
#define target_y mccchannel_9_analyzer_1_array_crystal_array_1_target_y
#define target_z mccchannel_9_analyzer_1_array_crystal_array_1_target_z
#define focus_aw mccchannel_9_analyzer_1_array_crystal_array_1_focus_aw
#define focus_ah mccchannel_9_analyzer_1_array_crystal_array_1_focus_ah
#define focus_xw mccchannel_9_analyzer_1_array_crystal_array_1_focus_xw
#define focus_xh mccchannel_9_analyzer_1_array_crystal_array_1_focus_xh
#define focus_r mccchannel_9_analyzer_1_array_crystal_array_1_focus_r
#define p_interact mccchannel_9_analyzer_1_array_crystal_array_1_p_interact
#define mask_string mccchannel_9_analyzer_1_array_crystal_array_1_mask_string
#define mask_setting mccchannel_9_analyzer_1_array_crystal_array_1_mask_setting
#define number_of_activations mccchannel_9_analyzer_1_array_crystal_array_1_number_of_activations
#line 204 "Union_box.comp"
// Needed for transport to the main component
struct global_geometry_element_struct global_geometry_element;

#ifndef ANY_GEOMETRY_DETECTOR_DECLARE
    #define ANY_GEOMETRY_DETECTOR_DECLARE dummy
	//struct pointer_to_global_geometry_list global_geometry_list = {0,NULL};
#endif

int loop_index,found_geometries;

double x_component;
double y_component;
double z_component;

struct Volume_struct this_box_volume;
struct box_storage this_box_storage;

#line 57000 "MACS_sample_kidney_box.c"
#undef number_of_activations
#undef mask_setting
#undef mask_string
#undef p_interact
#undef focus_r
#undef focus_xh
#undef focus_xw
#undef focus_ah
#undef focus_aw
#undef target_z
#undef target_y
#undef target_x
#undef target_index
#undef visualize
#undef yheight2
#undef xwidth2
#undef zdepth
#undef yheight
#undef xwidth
#undef priority
#undef material_string
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

/* User declarations for component 'channel_9_analyzer_1_array_crystal_array_2' [474]. */
#define mccompcurname  channel_9_analyzer_1_array_crystal_array_2
#define mccompcurtype  Union_box
#define mccompcurindex 474
#define loop_index mccchannel_9_analyzer_1_array_crystal_array_2_loop_index
#define this_box_volume mccchannel_9_analyzer_1_array_crystal_array_2_this_box_volume
#define global_geometry_element mccchannel_9_analyzer_1_array_crystal_array_2_global_geometry_element
#define this_box_storage mccchannel_9_analyzer_1_array_crystal_array_2_this_box_storage
#define material_string mccchannel_9_analyzer_1_array_crystal_array_2_material_string
#define priority mccchannel_9_analyzer_1_array_crystal_array_2_priority
#define xwidth mccchannel_9_analyzer_1_array_crystal_array_2_xwidth
#define yheight mccchannel_9_analyzer_1_array_crystal_array_2_yheight
#define zdepth mccchannel_9_analyzer_1_array_crystal_array_2_zdepth
#define xwidth2 mccchannel_9_analyzer_1_array_crystal_array_2_xwidth2
#define yheight2 mccchannel_9_analyzer_1_array_crystal_array_2_yheight2
#define visualize mccchannel_9_analyzer_1_array_crystal_array_2_visualize
#define target_index mccchannel_9_analyzer_1_array_crystal_array_2_target_index
#define target_x mccchannel_9_analyzer_1_array_crystal_array_2_target_x
#define target_y mccchannel_9_analyzer_1_array_crystal_array_2_target_y
#define target_z mccchannel_9_analyzer_1_array_crystal_array_2_target_z
#define focus_aw mccchannel_9_analyzer_1_array_crystal_array_2_focus_aw
#define focus_ah mccchannel_9_analyzer_1_array_crystal_array_2_focus_ah
#define focus_xw mccchannel_9_analyzer_1_array_crystal_array_2_focus_xw
#define focus_xh mccchannel_9_analyzer_1_array_crystal_array_2_focus_xh
#define focus_r mccchannel_9_analyzer_1_array_crystal_array_2_focus_r
#define p_interact mccchannel_9_analyzer_1_array_crystal_array_2_p_interact
#define mask_string mccchannel_9_analyzer_1_array_crystal_array_2_mask_string
#define mask_setting mccchannel_9_analyzer_1_array_crystal_array_2_mask_setting
#define number_of_activations mccchannel_9_analyzer_1_array_crystal_array_2_number_of_activations
#line 204 "Union_box.comp"
// Needed for transport to the main component
struct global_geometry_element_struct global_geometry_element;

#ifndef ANY_GEOMETRY_DETECTOR_DECLARE
    #define ANY_GEOMETRY_DETECTOR_DECLARE dummy
	//struct pointer_to_global_geometry_list global_geometry_list = {0,NULL};
#endif

int loop_index,found_geometries;

double x_component;
double y_component;
double z_component;

struct Volume_struct this_box_volume;
struct box_storage this_box_storage;

#line 57077 "MACS_sample_kidney_box.c"
#undef number_of_activations
#undef mask_setting
#undef mask_string
#undef p_interact
#undef focus_r
#undef focus_xh
#undef focus_xw
#undef focus_ah
#undef focus_aw
#undef target_z
#undef target_y
#undef target_x
#undef target_index
#undef visualize
#undef yheight2
#undef xwidth2
#undef zdepth
#undef yheight
#undef xwidth
#undef priority
#undef material_string
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

/* User declarations for component 'channel_9_analyzer_1_array_crystal_array_3' [475]. */
#define mccompcurname  channel_9_analyzer_1_array_crystal_array_3
#define mccompcurtype  Union_box
#define mccompcurindex 475
#define loop_index mccchannel_9_analyzer_1_array_crystal_array_3_loop_index
#define this_box_volume mccchannel_9_analyzer_1_array_crystal_array_3_this_box_volume
#define global_geometry_element mccchannel_9_analyzer_1_array_crystal_array_3_global_geometry_element
#define this_box_storage mccchannel_9_analyzer_1_array_crystal_array_3_this_box_storage
#define material_string mccchannel_9_analyzer_1_array_crystal_array_3_material_string
#define priority mccchannel_9_analyzer_1_array_crystal_array_3_priority
#define xwidth mccchannel_9_analyzer_1_array_crystal_array_3_xwidth
#define yheight mccchannel_9_analyzer_1_array_crystal_array_3_yheight
#define zdepth mccchannel_9_analyzer_1_array_crystal_array_3_zdepth
#define xwidth2 mccchannel_9_analyzer_1_array_crystal_array_3_xwidth2
#define yheight2 mccchannel_9_analyzer_1_array_crystal_array_3_yheight2
#define visualize mccchannel_9_analyzer_1_array_crystal_array_3_visualize
#define target_index mccchannel_9_analyzer_1_array_crystal_array_3_target_index
#define target_x mccchannel_9_analyzer_1_array_crystal_array_3_target_x
#define target_y mccchannel_9_analyzer_1_array_crystal_array_3_target_y
#define target_z mccchannel_9_analyzer_1_array_crystal_array_3_target_z
#define focus_aw mccchannel_9_analyzer_1_array_crystal_array_3_focus_aw
#define focus_ah mccchannel_9_analyzer_1_array_crystal_array_3_focus_ah
#define focus_xw mccchannel_9_analyzer_1_array_crystal_array_3_focus_xw
#define focus_xh mccchannel_9_analyzer_1_array_crystal_array_3_focus_xh
#define focus_r mccchannel_9_analyzer_1_array_crystal_array_3_focus_r
#define p_interact mccchannel_9_analyzer_1_array_crystal_array_3_p_interact
#define mask_string mccchannel_9_analyzer_1_array_crystal_array_3_mask_string
#define mask_setting mccchannel_9_analyzer_1_array_crystal_array_3_mask_setting
#define number_of_activations mccchannel_9_analyzer_1_array_crystal_array_3_number_of_activations
#line 204 "Union_box.comp"
// Needed for transport to the main component
struct global_geometry_element_struct global_geometry_element;

#ifndef ANY_GEOMETRY_DETECTOR_DECLARE
    #define ANY_GEOMETRY_DETECTOR_DECLARE dummy
	//struct pointer_to_global_geometry_list global_geometry_list = {0,NULL};
#endif

int loop_index,found_geometries;

double x_component;
double y_component;
double z_component;

struct Volume_struct this_box_volume;
struct box_storage this_box_storage;

#line 57154 "MACS_sample_kidney_box.c"
#undef number_of_activations
#undef mask_setting
#undef mask_string
#undef p_interact
#undef focus_r
#undef focus_xh
#undef focus_xw
#undef focus_ah
#undef focus_aw
#undef target_z
#undef target_y
#undef target_x
#undef target_index
#undef visualize
#undef yheight2
#undef xwidth2
#undef zdepth
#undef yheight
#undef xwidth
#undef priority
#undef material_string
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

/* User declarations for component 'channel_9_analyzer_1_array_crystal_array_4' [476]. */
#define mccompcurname  channel_9_analyzer_1_array_crystal_array_4
#define mccompcurtype  Union_box
#define mccompcurindex 476
#define loop_index mccchannel_9_analyzer_1_array_crystal_array_4_loop_index
#define this_box_volume mccchannel_9_analyzer_1_array_crystal_array_4_this_box_volume
#define global_geometry_element mccchannel_9_analyzer_1_array_crystal_array_4_global_geometry_element
#define this_box_storage mccchannel_9_analyzer_1_array_crystal_array_4_this_box_storage
#define material_string mccchannel_9_analyzer_1_array_crystal_array_4_material_string
#define priority mccchannel_9_analyzer_1_array_crystal_array_4_priority
#define xwidth mccchannel_9_analyzer_1_array_crystal_array_4_xwidth
#define yheight mccchannel_9_analyzer_1_array_crystal_array_4_yheight
#define zdepth mccchannel_9_analyzer_1_array_crystal_array_4_zdepth
#define xwidth2 mccchannel_9_analyzer_1_array_crystal_array_4_xwidth2
#define yheight2 mccchannel_9_analyzer_1_array_crystal_array_4_yheight2
#define visualize mccchannel_9_analyzer_1_array_crystal_array_4_visualize
#define target_index mccchannel_9_analyzer_1_array_crystal_array_4_target_index
#define target_x mccchannel_9_analyzer_1_array_crystal_array_4_target_x
#define target_y mccchannel_9_analyzer_1_array_crystal_array_4_target_y
#define target_z mccchannel_9_analyzer_1_array_crystal_array_4_target_z
#define focus_aw mccchannel_9_analyzer_1_array_crystal_array_4_focus_aw
#define focus_ah mccchannel_9_analyzer_1_array_crystal_array_4_focus_ah
#define focus_xw mccchannel_9_analyzer_1_array_crystal_array_4_focus_xw
#define focus_xh mccchannel_9_analyzer_1_array_crystal_array_4_focus_xh
#define focus_r mccchannel_9_analyzer_1_array_crystal_array_4_focus_r
#define p_interact mccchannel_9_analyzer_1_array_crystal_array_4_p_interact
#define mask_string mccchannel_9_analyzer_1_array_crystal_array_4_mask_string
#define mask_setting mccchannel_9_analyzer_1_array_crystal_array_4_mask_setting
#define number_of_activations mccchannel_9_analyzer_1_array_crystal_array_4_number_of_activations
#line 204 "Union_box.comp"
// Needed for transport to the main component
struct global_geometry_element_struct global_geometry_element;

#ifndef ANY_GEOMETRY_DETECTOR_DECLARE
    #define ANY_GEOMETRY_DETECTOR_DECLARE dummy
	//struct pointer_to_global_geometry_list global_geometry_list = {0,NULL};
#endif

int loop_index,found_geometries;

double x_component;
double y_component;
double z_component;

struct Volume_struct this_box_volume;
struct box_storage this_box_storage;

#line 57231 "MACS_sample_kidney_box.c"
#undef number_of_activations
#undef mask_setting
#undef mask_string
#undef p_interact
#undef focus_r
#undef focus_xh
#undef focus_xw
#undef focus_ah
#undef focus_aw
#undef target_z
#undef target_y
#undef target_x
#undef target_index
#undef visualize
#undef yheight2
#undef xwidth2
#undef zdepth
#undef yheight
#undef xwidth
#undef priority
#undef material_string
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

/* User declarations for component 'channel_9_analyzer_1_array_crystal_array_5' [477]. */
#define mccompcurname  channel_9_analyzer_1_array_crystal_array_5
#define mccompcurtype  Union_box
#define mccompcurindex 477
#define loop_index mccchannel_9_analyzer_1_array_crystal_array_5_loop_index
#define this_box_volume mccchannel_9_analyzer_1_array_crystal_array_5_this_box_volume
#define global_geometry_element mccchannel_9_analyzer_1_array_crystal_array_5_global_geometry_element
#define this_box_storage mccchannel_9_analyzer_1_array_crystal_array_5_this_box_storage
#define material_string mccchannel_9_analyzer_1_array_crystal_array_5_material_string
#define priority mccchannel_9_analyzer_1_array_crystal_array_5_priority
#define xwidth mccchannel_9_analyzer_1_array_crystal_array_5_xwidth
#define yheight mccchannel_9_analyzer_1_array_crystal_array_5_yheight
#define zdepth mccchannel_9_analyzer_1_array_crystal_array_5_zdepth
#define xwidth2 mccchannel_9_analyzer_1_array_crystal_array_5_xwidth2
#define yheight2 mccchannel_9_analyzer_1_array_crystal_array_5_yheight2
#define visualize mccchannel_9_analyzer_1_array_crystal_array_5_visualize
#define target_index mccchannel_9_analyzer_1_array_crystal_array_5_target_index
#define target_x mccchannel_9_analyzer_1_array_crystal_array_5_target_x
#define target_y mccchannel_9_analyzer_1_array_crystal_array_5_target_y
#define target_z mccchannel_9_analyzer_1_array_crystal_array_5_target_z
#define focus_aw mccchannel_9_analyzer_1_array_crystal_array_5_focus_aw
#define focus_ah mccchannel_9_analyzer_1_array_crystal_array_5_focus_ah
#define focus_xw mccchannel_9_analyzer_1_array_crystal_array_5_focus_xw
#define focus_xh mccchannel_9_analyzer_1_array_crystal_array_5_focus_xh
#define focus_r mccchannel_9_analyzer_1_array_crystal_array_5_focus_r
#define p_interact mccchannel_9_analyzer_1_array_crystal_array_5_p_interact
#define mask_string mccchannel_9_analyzer_1_array_crystal_array_5_mask_string
#define mask_setting mccchannel_9_analyzer_1_array_crystal_array_5_mask_setting
#define number_of_activations mccchannel_9_analyzer_1_array_crystal_array_5_number_of_activations
#line 204 "Union_box.comp"
// Needed for transport to the main component
struct global_geometry_element_struct global_geometry_element;

#ifndef ANY_GEOMETRY_DETECTOR_DECLARE
    #define ANY_GEOMETRY_DETECTOR_DECLARE dummy
	//struct pointer_to_global_geometry_list global_geometry_list = {0,NULL};
#endif

int loop_index,found_geometries;

double x_component;
double y_component;
double z_component;

struct Volume_struct this_box_volume;
struct box_storage this_box_storage;

#line 57308 "MACS_sample_kidney_box.c"
#undef number_of_activations
#undef mask_setting
#undef mask_string
#undef p_interact
#undef focus_r
#undef focus_xh
#undef focus_xw
#undef focus_ah
#undef focus_aw
#undef target_z
#undef target_y
#undef target_x
#undef target_index
#undef visualize
#undef yheight2
#undef xwidth2
#undef zdepth
#undef yheight
#undef xwidth
#undef priority
#undef material_string
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

/* User declarations for component 'channel_9_analyzer_1_array_crystal_array_6' [478]. */
#define mccompcurname  channel_9_analyzer_1_array_crystal_array_6
#define mccompcurtype  Union_box
#define mccompcurindex 478
#define loop_index mccchannel_9_analyzer_1_array_crystal_array_6_loop_index
#define this_box_volume mccchannel_9_analyzer_1_array_crystal_array_6_this_box_volume
#define global_geometry_element mccchannel_9_analyzer_1_array_crystal_array_6_global_geometry_element
#define this_box_storage mccchannel_9_analyzer_1_array_crystal_array_6_this_box_storage
#define material_string mccchannel_9_analyzer_1_array_crystal_array_6_material_string
#define priority mccchannel_9_analyzer_1_array_crystal_array_6_priority
#define xwidth mccchannel_9_analyzer_1_array_crystal_array_6_xwidth
#define yheight mccchannel_9_analyzer_1_array_crystal_array_6_yheight
#define zdepth mccchannel_9_analyzer_1_array_crystal_array_6_zdepth
#define xwidth2 mccchannel_9_analyzer_1_array_crystal_array_6_xwidth2
#define yheight2 mccchannel_9_analyzer_1_array_crystal_array_6_yheight2
#define visualize mccchannel_9_analyzer_1_array_crystal_array_6_visualize
#define target_index mccchannel_9_analyzer_1_array_crystal_array_6_target_index
#define target_x mccchannel_9_analyzer_1_array_crystal_array_6_target_x
#define target_y mccchannel_9_analyzer_1_array_crystal_array_6_target_y
#define target_z mccchannel_9_analyzer_1_array_crystal_array_6_target_z
#define focus_aw mccchannel_9_analyzer_1_array_crystal_array_6_focus_aw
#define focus_ah mccchannel_9_analyzer_1_array_crystal_array_6_focus_ah
#define focus_xw mccchannel_9_analyzer_1_array_crystal_array_6_focus_xw
#define focus_xh mccchannel_9_analyzer_1_array_crystal_array_6_focus_xh
#define focus_r mccchannel_9_analyzer_1_array_crystal_array_6_focus_r
#define p_interact mccchannel_9_analyzer_1_array_crystal_array_6_p_interact
#define mask_string mccchannel_9_analyzer_1_array_crystal_array_6_mask_string
#define mask_setting mccchannel_9_analyzer_1_array_crystal_array_6_mask_setting
#define number_of_activations mccchannel_9_analyzer_1_array_crystal_array_6_number_of_activations
#line 204 "Union_box.comp"
// Needed for transport to the main component
struct global_geometry_element_struct global_geometry_element;

#ifndef ANY_GEOMETRY_DETECTOR_DECLARE
    #define ANY_GEOMETRY_DETECTOR_DECLARE dummy
	//struct pointer_to_global_geometry_list global_geometry_list = {0,NULL};
#endif

int loop_index,found_geometries;

double x_component;
double y_component;
double z_component;

struct Volume_struct this_box_volume;
struct box_storage this_box_storage;

#line 57385 "MACS_sample_kidney_box.c"
#undef number_of_activations
#undef mask_setting
#undef mask_string
#undef p_interact
#undef focus_r
#undef focus_xh
#undef focus_xw
#undef focus_ah
#undef focus_aw
#undef target_z
#undef target_y
#undef target_x
#undef target_index
#undef visualize
#undef yheight2
#undef xwidth2
#undef zdepth
#undef yheight
#undef xwidth
#undef priority
#undef material_string
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

/* User declarations for component 'channel_9_analyzer_1_array_crystal_array_7' [479]. */
#define mccompcurname  channel_9_analyzer_1_array_crystal_array_7
#define mccompcurtype  Union_box
#define mccompcurindex 479
#define loop_index mccchannel_9_analyzer_1_array_crystal_array_7_loop_index
#define this_box_volume mccchannel_9_analyzer_1_array_crystal_array_7_this_box_volume
#define global_geometry_element mccchannel_9_analyzer_1_array_crystal_array_7_global_geometry_element
#define this_box_storage mccchannel_9_analyzer_1_array_crystal_array_7_this_box_storage
#define material_string mccchannel_9_analyzer_1_array_crystal_array_7_material_string
#define priority mccchannel_9_analyzer_1_array_crystal_array_7_priority
#define xwidth mccchannel_9_analyzer_1_array_crystal_array_7_xwidth
#define yheight mccchannel_9_analyzer_1_array_crystal_array_7_yheight
#define zdepth mccchannel_9_analyzer_1_array_crystal_array_7_zdepth
#define xwidth2 mccchannel_9_analyzer_1_array_crystal_array_7_xwidth2
#define yheight2 mccchannel_9_analyzer_1_array_crystal_array_7_yheight2
#define visualize mccchannel_9_analyzer_1_array_crystal_array_7_visualize
#define target_index mccchannel_9_analyzer_1_array_crystal_array_7_target_index
#define target_x mccchannel_9_analyzer_1_array_crystal_array_7_target_x
#define target_y mccchannel_9_analyzer_1_array_crystal_array_7_target_y
#define target_z mccchannel_9_analyzer_1_array_crystal_array_7_target_z
#define focus_aw mccchannel_9_analyzer_1_array_crystal_array_7_focus_aw
#define focus_ah mccchannel_9_analyzer_1_array_crystal_array_7_focus_ah
#define focus_xw mccchannel_9_analyzer_1_array_crystal_array_7_focus_xw
#define focus_xh mccchannel_9_analyzer_1_array_crystal_array_7_focus_xh
#define focus_r mccchannel_9_analyzer_1_array_crystal_array_7_focus_r
#define p_interact mccchannel_9_analyzer_1_array_crystal_array_7_p_interact
#define mask_string mccchannel_9_analyzer_1_array_crystal_array_7_mask_string
#define mask_setting mccchannel_9_analyzer_1_array_crystal_array_7_mask_setting
#define number_of_activations mccchannel_9_analyzer_1_array_crystal_array_7_number_of_activations
#line 204 "Union_box.comp"
// Needed for transport to the main component
struct global_geometry_element_struct global_geometry_element;

#ifndef ANY_GEOMETRY_DETECTOR_DECLARE
    #define ANY_GEOMETRY_DETECTOR_DECLARE dummy
	//struct pointer_to_global_geometry_list global_geometry_list = {0,NULL};
#endif

int loop_index,found_geometries;

double x_component;
double y_component;
double z_component;

struct Volume_struct this_box_volume;
struct box_storage this_box_storage;

#line 57462 "MACS_sample_kidney_box.c"
#undef number_of_activations
#undef mask_setting
#undef mask_string
#undef p_interact
#undef focus_r
#undef focus_xh
#undef focus_xw
#undef focus_ah
#undef focus_aw
#undef target_z
#undef target_y
#undef target_x
#undef target_index
#undef visualize
#undef yheight2
#undef xwidth2
#undef zdepth
#undef yheight
#undef xwidth
#undef priority
#undef material_string
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

/* User declarations for component 'channel_9_analyzer_1_array_crystal_array_8' [480]. */
#define mccompcurname  channel_9_analyzer_1_array_crystal_array_8
#define mccompcurtype  Union_box
#define mccompcurindex 480
#define loop_index mccchannel_9_analyzer_1_array_crystal_array_8_loop_index
#define this_box_volume mccchannel_9_analyzer_1_array_crystal_array_8_this_box_volume
#define global_geometry_element mccchannel_9_analyzer_1_array_crystal_array_8_global_geometry_element
#define this_box_storage mccchannel_9_analyzer_1_array_crystal_array_8_this_box_storage
#define material_string mccchannel_9_analyzer_1_array_crystal_array_8_material_string
#define priority mccchannel_9_analyzer_1_array_crystal_array_8_priority
#define xwidth mccchannel_9_analyzer_1_array_crystal_array_8_xwidth
#define yheight mccchannel_9_analyzer_1_array_crystal_array_8_yheight
#define zdepth mccchannel_9_analyzer_1_array_crystal_array_8_zdepth
#define xwidth2 mccchannel_9_analyzer_1_array_crystal_array_8_xwidth2
#define yheight2 mccchannel_9_analyzer_1_array_crystal_array_8_yheight2
#define visualize mccchannel_9_analyzer_1_array_crystal_array_8_visualize
#define target_index mccchannel_9_analyzer_1_array_crystal_array_8_target_index
#define target_x mccchannel_9_analyzer_1_array_crystal_array_8_target_x
#define target_y mccchannel_9_analyzer_1_array_crystal_array_8_target_y
#define target_z mccchannel_9_analyzer_1_array_crystal_array_8_target_z
#define focus_aw mccchannel_9_analyzer_1_array_crystal_array_8_focus_aw
#define focus_ah mccchannel_9_analyzer_1_array_crystal_array_8_focus_ah
#define focus_xw mccchannel_9_analyzer_1_array_crystal_array_8_focus_xw
#define focus_xh mccchannel_9_analyzer_1_array_crystal_array_8_focus_xh
#define focus_r mccchannel_9_analyzer_1_array_crystal_array_8_focus_r
#define p_interact mccchannel_9_analyzer_1_array_crystal_array_8_p_interact
#define mask_string mccchannel_9_analyzer_1_array_crystal_array_8_mask_string
#define mask_setting mccchannel_9_analyzer_1_array_crystal_array_8_mask_setting
#define number_of_activations mccchannel_9_analyzer_1_array_crystal_array_8_number_of_activations
#line 204 "Union_box.comp"
// Needed for transport to the main component
struct global_geometry_element_struct global_geometry_element;

#ifndef ANY_GEOMETRY_DETECTOR_DECLARE
    #define ANY_GEOMETRY_DETECTOR_DECLARE dummy
	//struct pointer_to_global_geometry_list global_geometry_list = {0,NULL};
#endif

int loop_index,found_geometries;

double x_component;
double y_component;
double z_component;

struct Volume_struct this_box_volume;
struct box_storage this_box_storage;

#line 57539 "MACS_sample_kidney_box.c"
#undef number_of_activations
#undef mask_setting
#undef mask_string
#undef p_interact
#undef focus_r
#undef focus_xh
#undef focus_xw
#undef focus_ah
#undef focus_aw
#undef target_z
#undef target_y
#undef target_x
#undef target_index
#undef visualize
#undef yheight2
#undef xwidth2
#undef zdepth
#undef yheight
#undef xwidth
#undef priority
#undef material_string
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

/* User declarations for component 'channel_9_analyzer_2_center' [481]. */
#define mccompcurname  channel_9_analyzer_2_center
#define mccompcurtype  Arm
#define mccompcurindex 481
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

/* User declarations for component 'channel_9_analyzer_2_rotated' [482]. */
#define mccompcurname  channel_9_analyzer_2_rotated
#define mccompcurtype  Arm
#define mccompcurindex 482
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

/* User declarations for component 'channel_9_analyzer_2_array_crystal_array_0' [483]. */
#define mccompcurname  channel_9_analyzer_2_array_crystal_array_0
#define mccompcurtype  Union_box
#define mccompcurindex 483
#define loop_index mccchannel_9_analyzer_2_array_crystal_array_0_loop_index
#define this_box_volume mccchannel_9_analyzer_2_array_crystal_array_0_this_box_volume
#define global_geometry_element mccchannel_9_analyzer_2_array_crystal_array_0_global_geometry_element
#define this_box_storage mccchannel_9_analyzer_2_array_crystal_array_0_this_box_storage
#define material_string mccchannel_9_analyzer_2_array_crystal_array_0_material_string
#define priority mccchannel_9_analyzer_2_array_crystal_array_0_priority
#define xwidth mccchannel_9_analyzer_2_array_crystal_array_0_xwidth
#define yheight mccchannel_9_analyzer_2_array_crystal_array_0_yheight
#define zdepth mccchannel_9_analyzer_2_array_crystal_array_0_zdepth
#define xwidth2 mccchannel_9_analyzer_2_array_crystal_array_0_xwidth2
#define yheight2 mccchannel_9_analyzer_2_array_crystal_array_0_yheight2
#define visualize mccchannel_9_analyzer_2_array_crystal_array_0_visualize
#define target_index mccchannel_9_analyzer_2_array_crystal_array_0_target_index
#define target_x mccchannel_9_analyzer_2_array_crystal_array_0_target_x
#define target_y mccchannel_9_analyzer_2_array_crystal_array_0_target_y
#define target_z mccchannel_9_analyzer_2_array_crystal_array_0_target_z
#define focus_aw mccchannel_9_analyzer_2_array_crystal_array_0_focus_aw
#define focus_ah mccchannel_9_analyzer_2_array_crystal_array_0_focus_ah
#define focus_xw mccchannel_9_analyzer_2_array_crystal_array_0_focus_xw
#define focus_xh mccchannel_9_analyzer_2_array_crystal_array_0_focus_xh
#define focus_r mccchannel_9_analyzer_2_array_crystal_array_0_focus_r
#define p_interact mccchannel_9_analyzer_2_array_crystal_array_0_p_interact
#define mask_string mccchannel_9_analyzer_2_array_crystal_array_0_mask_string
#define mask_setting mccchannel_9_analyzer_2_array_crystal_array_0_mask_setting
#define number_of_activations mccchannel_9_analyzer_2_array_crystal_array_0_number_of_activations
#line 204 "Union_box.comp"
// Needed for transport to the main component
struct global_geometry_element_struct global_geometry_element;

#ifndef ANY_GEOMETRY_DETECTOR_DECLARE
    #define ANY_GEOMETRY_DETECTOR_DECLARE dummy
	//struct pointer_to_global_geometry_list global_geometry_list = {0,NULL};
#endif

int loop_index,found_geometries;

double x_component;
double y_component;
double z_component;

struct Volume_struct this_box_volume;
struct box_storage this_box_storage;

#line 57632 "MACS_sample_kidney_box.c"
#undef number_of_activations
#undef mask_setting
#undef mask_string
#undef p_interact
#undef focus_r
#undef focus_xh
#undef focus_xw
#undef focus_ah
#undef focus_aw
#undef target_z
#undef target_y
#undef target_x
#undef target_index
#undef visualize
#undef yheight2
#undef xwidth2
#undef zdepth
#undef yheight
#undef xwidth
#undef priority
#undef material_string
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

/* User declarations for component 'channel_9_analyzer_2_array_crystal_array_1' [484]. */
#define mccompcurname  channel_9_analyzer_2_array_crystal_array_1
#define mccompcurtype  Union_box
#define mccompcurindex 484
#define loop_index mccchannel_9_analyzer_2_array_crystal_array_1_loop_index
#define this_box_volume mccchannel_9_analyzer_2_array_crystal_array_1_this_box_volume
#define global_geometry_element mccchannel_9_analyzer_2_array_crystal_array_1_global_geometry_element
#define this_box_storage mccchannel_9_analyzer_2_array_crystal_array_1_this_box_storage
#define material_string mccchannel_9_analyzer_2_array_crystal_array_1_material_string
#define priority mccchannel_9_analyzer_2_array_crystal_array_1_priority
#define xwidth mccchannel_9_analyzer_2_array_crystal_array_1_xwidth
#define yheight mccchannel_9_analyzer_2_array_crystal_array_1_yheight
#define zdepth mccchannel_9_analyzer_2_array_crystal_array_1_zdepth
#define xwidth2 mccchannel_9_analyzer_2_array_crystal_array_1_xwidth2
#define yheight2 mccchannel_9_analyzer_2_array_crystal_array_1_yheight2
#define visualize mccchannel_9_analyzer_2_array_crystal_array_1_visualize
#define target_index mccchannel_9_analyzer_2_array_crystal_array_1_target_index
#define target_x mccchannel_9_analyzer_2_array_crystal_array_1_target_x
#define target_y mccchannel_9_analyzer_2_array_crystal_array_1_target_y
#define target_z mccchannel_9_analyzer_2_array_crystal_array_1_target_z
#define focus_aw mccchannel_9_analyzer_2_array_crystal_array_1_focus_aw
#define focus_ah mccchannel_9_analyzer_2_array_crystal_array_1_focus_ah
#define focus_xw mccchannel_9_analyzer_2_array_crystal_array_1_focus_xw
#define focus_xh mccchannel_9_analyzer_2_array_crystal_array_1_focus_xh
#define focus_r mccchannel_9_analyzer_2_array_crystal_array_1_focus_r
#define p_interact mccchannel_9_analyzer_2_array_crystal_array_1_p_interact
#define mask_string mccchannel_9_analyzer_2_array_crystal_array_1_mask_string
#define mask_setting mccchannel_9_analyzer_2_array_crystal_array_1_mask_setting
#define number_of_activations mccchannel_9_analyzer_2_array_crystal_array_1_number_of_activations
#line 204 "Union_box.comp"
// Needed for transport to the main component
struct global_geometry_element_struct global_geometry_element;

#ifndef ANY_GEOMETRY_DETECTOR_DECLARE
    #define ANY_GEOMETRY_DETECTOR_DECLARE dummy
	//struct pointer_to_global_geometry_list global_geometry_list = {0,NULL};
#endif

int loop_index,found_geometries;

double x_component;
double y_component;
double z_component;

struct Volume_struct this_box_volume;
struct box_storage this_box_storage;

#line 57709 "MACS_sample_kidney_box.c"
#undef number_of_activations
#undef mask_setting
#undef mask_string
#undef p_interact
#undef focus_r
#undef focus_xh
#undef focus_xw
#undef focus_ah
#undef focus_aw
#undef target_z
#undef target_y
#undef target_x
#undef target_index
#undef visualize
#undef yheight2
#undef xwidth2
#undef zdepth
#undef yheight
#undef xwidth
#undef priority
#undef material_string
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

/* User declarations for component 'channel_9_analyzer_2_array_crystal_array_2' [485]. */
#define mccompcurname  channel_9_analyzer_2_array_crystal_array_2
#define mccompcurtype  Union_box
#define mccompcurindex 485
#define loop_index mccchannel_9_analyzer_2_array_crystal_array_2_loop_index
#define this_box_volume mccchannel_9_analyzer_2_array_crystal_array_2_this_box_volume
#define global_geometry_element mccchannel_9_analyzer_2_array_crystal_array_2_global_geometry_element
#define this_box_storage mccchannel_9_analyzer_2_array_crystal_array_2_this_box_storage
#define material_string mccchannel_9_analyzer_2_array_crystal_array_2_material_string
#define priority mccchannel_9_analyzer_2_array_crystal_array_2_priority
#define xwidth mccchannel_9_analyzer_2_array_crystal_array_2_xwidth
#define yheight mccchannel_9_analyzer_2_array_crystal_array_2_yheight
#define zdepth mccchannel_9_analyzer_2_array_crystal_array_2_zdepth
#define xwidth2 mccchannel_9_analyzer_2_array_crystal_array_2_xwidth2
#define yheight2 mccchannel_9_analyzer_2_array_crystal_array_2_yheight2
#define visualize mccchannel_9_analyzer_2_array_crystal_array_2_visualize
#define target_index mccchannel_9_analyzer_2_array_crystal_array_2_target_index
#define target_x mccchannel_9_analyzer_2_array_crystal_array_2_target_x
#define target_y mccchannel_9_analyzer_2_array_crystal_array_2_target_y
#define target_z mccchannel_9_analyzer_2_array_crystal_array_2_target_z
#define focus_aw mccchannel_9_analyzer_2_array_crystal_array_2_focus_aw
#define focus_ah mccchannel_9_analyzer_2_array_crystal_array_2_focus_ah
#define focus_xw mccchannel_9_analyzer_2_array_crystal_array_2_focus_xw
#define focus_xh mccchannel_9_analyzer_2_array_crystal_array_2_focus_xh
#define focus_r mccchannel_9_analyzer_2_array_crystal_array_2_focus_r
#define p_interact mccchannel_9_analyzer_2_array_crystal_array_2_p_interact
#define mask_string mccchannel_9_analyzer_2_array_crystal_array_2_mask_string
#define mask_setting mccchannel_9_analyzer_2_array_crystal_array_2_mask_setting
#define number_of_activations mccchannel_9_analyzer_2_array_crystal_array_2_number_of_activations
#line 204 "Union_box.comp"
// Needed for transport to the main component
struct global_geometry_element_struct global_geometry_element;

#ifndef ANY_GEOMETRY_DETECTOR_DECLARE
    #define ANY_GEOMETRY_DETECTOR_DECLARE dummy
	//struct pointer_to_global_geometry_list global_geometry_list = {0,NULL};
#endif

int loop_index,found_geometries;

double x_component;
double y_component;
double z_component;

struct Volume_struct this_box_volume;
struct box_storage this_box_storage;

#line 57786 "MACS_sample_kidney_box.c"
#undef number_of_activations
#undef mask_setting
#undef mask_string
#undef p_interact
#undef focus_r
#undef focus_xh
#undef focus_xw
#undef focus_ah
#undef focus_aw
#undef target_z
#undef target_y
#undef target_x
#undef target_index
#undef visualize
#undef yheight2
#undef xwidth2
#undef zdepth
#undef yheight
#undef xwidth
#undef priority
#undef material_string
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

/* User declarations for component 'channel_9_analyzer_2_array_crystal_array_3' [486]. */
#define mccompcurname  channel_9_analyzer_2_array_crystal_array_3
#define mccompcurtype  Union_box
#define mccompcurindex 486
#define loop_index mccchannel_9_analyzer_2_array_crystal_array_3_loop_index
#define this_box_volume mccchannel_9_analyzer_2_array_crystal_array_3_this_box_volume
#define global_geometry_element mccchannel_9_analyzer_2_array_crystal_array_3_global_geometry_element
#define this_box_storage mccchannel_9_analyzer_2_array_crystal_array_3_this_box_storage
#define material_string mccchannel_9_analyzer_2_array_crystal_array_3_material_string
#define priority mccchannel_9_analyzer_2_array_crystal_array_3_priority
#define xwidth mccchannel_9_analyzer_2_array_crystal_array_3_xwidth
#define yheight mccchannel_9_analyzer_2_array_crystal_array_3_yheight
#define zdepth mccchannel_9_analyzer_2_array_crystal_array_3_zdepth
#define xwidth2 mccchannel_9_analyzer_2_array_crystal_array_3_xwidth2
#define yheight2 mccchannel_9_analyzer_2_array_crystal_array_3_yheight2
#define visualize mccchannel_9_analyzer_2_array_crystal_array_3_visualize
#define target_index mccchannel_9_analyzer_2_array_crystal_array_3_target_index
#define target_x mccchannel_9_analyzer_2_array_crystal_array_3_target_x
#define target_y mccchannel_9_analyzer_2_array_crystal_array_3_target_y
#define target_z mccchannel_9_analyzer_2_array_crystal_array_3_target_z
#define focus_aw mccchannel_9_analyzer_2_array_crystal_array_3_focus_aw
#define focus_ah mccchannel_9_analyzer_2_array_crystal_array_3_focus_ah
#define focus_xw mccchannel_9_analyzer_2_array_crystal_array_3_focus_xw
#define focus_xh mccchannel_9_analyzer_2_array_crystal_array_3_focus_xh
#define focus_r mccchannel_9_analyzer_2_array_crystal_array_3_focus_r
#define p_interact mccchannel_9_analyzer_2_array_crystal_array_3_p_interact
#define mask_string mccchannel_9_analyzer_2_array_crystal_array_3_mask_string
#define mask_setting mccchannel_9_analyzer_2_array_crystal_array_3_mask_setting
#define number_of_activations mccchannel_9_analyzer_2_array_crystal_array_3_number_of_activations
#line 204 "Union_box.comp"
// Needed for transport to the main component
struct global_geometry_element_struct global_geometry_element;

#ifndef ANY_GEOMETRY_DETECTOR_DECLARE
    #define ANY_GEOMETRY_DETECTOR_DECLARE dummy
	//struct pointer_to_global_geometry_list global_geometry_list = {0,NULL};
#endif

int loop_index,found_geometries;

double x_component;
double y_component;
double z_component;

struct Volume_struct this_box_volume;
struct box_storage this_box_storage;

#line 57863 "MACS_sample_kidney_box.c"
#undef number_of_activations
#undef mask_setting
#undef mask_string
#undef p_interact
#undef focus_r
#undef focus_xh
#undef focus_xw
#undef focus_ah
#undef focus_aw
#undef target_z
#undef target_y
#undef target_x
#undef target_index
#undef visualize
#undef yheight2
#undef xwidth2
#undef zdepth
#undef yheight
#undef xwidth
#undef priority
#undef material_string
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

/* User declarations for component 'channel_9_analyzer_2_array_crystal_array_4' [487]. */
#define mccompcurname  channel_9_analyzer_2_array_crystal_array_4
#define mccompcurtype  Union_box
#define mccompcurindex 487
#define loop_index mccchannel_9_analyzer_2_array_crystal_array_4_loop_index
#define this_box_volume mccchannel_9_analyzer_2_array_crystal_array_4_this_box_volume
#define global_geometry_element mccchannel_9_analyzer_2_array_crystal_array_4_global_geometry_element
#define this_box_storage mccchannel_9_analyzer_2_array_crystal_array_4_this_box_storage
#define material_string mccchannel_9_analyzer_2_array_crystal_array_4_material_string
#define priority mccchannel_9_analyzer_2_array_crystal_array_4_priority
#define xwidth mccchannel_9_analyzer_2_array_crystal_array_4_xwidth
#define yheight mccchannel_9_analyzer_2_array_crystal_array_4_yheight
#define zdepth mccchannel_9_analyzer_2_array_crystal_array_4_zdepth
#define xwidth2 mccchannel_9_analyzer_2_array_crystal_array_4_xwidth2
#define yheight2 mccchannel_9_analyzer_2_array_crystal_array_4_yheight2
#define visualize mccchannel_9_analyzer_2_array_crystal_array_4_visualize
#define target_index mccchannel_9_analyzer_2_array_crystal_array_4_target_index
#define target_x mccchannel_9_analyzer_2_array_crystal_array_4_target_x
#define target_y mccchannel_9_analyzer_2_array_crystal_array_4_target_y
#define target_z mccchannel_9_analyzer_2_array_crystal_array_4_target_z
#define focus_aw mccchannel_9_analyzer_2_array_crystal_array_4_focus_aw
#define focus_ah mccchannel_9_analyzer_2_array_crystal_array_4_focus_ah
#define focus_xw mccchannel_9_analyzer_2_array_crystal_array_4_focus_xw
#define focus_xh mccchannel_9_analyzer_2_array_crystal_array_4_focus_xh
#define focus_r mccchannel_9_analyzer_2_array_crystal_array_4_focus_r
#define p_interact mccchannel_9_analyzer_2_array_crystal_array_4_p_interact
#define mask_string mccchannel_9_analyzer_2_array_crystal_array_4_mask_string
#define mask_setting mccchannel_9_analyzer_2_array_crystal_array_4_mask_setting
#define number_of_activations mccchannel_9_analyzer_2_array_crystal_array_4_number_of_activations
#line 204 "Union_box.comp"
// Needed for transport to the main component
struct global_geometry_element_struct global_geometry_element;

#ifndef ANY_GEOMETRY_DETECTOR_DECLARE
    #define ANY_GEOMETRY_DETECTOR_DECLARE dummy
	//struct pointer_to_global_geometry_list global_geometry_list = {0,NULL};
#endif

int loop_index,found_geometries;

double x_component;
double y_component;
double z_component;

struct Volume_struct this_box_volume;
struct box_storage this_box_storage;

#line 57940 "MACS_sample_kidney_box.c"
#undef number_of_activations
#undef mask_setting
#undef mask_string
#undef p_interact
#undef focus_r
#undef focus_xh
#undef focus_xw
#undef focus_ah
#undef focus_aw
#undef target_z
#undef target_y
#undef target_x
#undef target_index
#undef visualize
#undef yheight2
#undef xwidth2
#undef zdepth
#undef yheight
#undef xwidth
#undef priority
#undef material_string
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

/* User declarations for component 'channel_9_analyzer_2_array_crystal_array_5' [488]. */
#define mccompcurname  channel_9_analyzer_2_array_crystal_array_5
#define mccompcurtype  Union_box
#define mccompcurindex 488
#define loop_index mccchannel_9_analyzer_2_array_crystal_array_5_loop_index
#define this_box_volume mccchannel_9_analyzer_2_array_crystal_array_5_this_box_volume
#define global_geometry_element mccchannel_9_analyzer_2_array_crystal_array_5_global_geometry_element
#define this_box_storage mccchannel_9_analyzer_2_array_crystal_array_5_this_box_storage
#define material_string mccchannel_9_analyzer_2_array_crystal_array_5_material_string
#define priority mccchannel_9_analyzer_2_array_crystal_array_5_priority
#define xwidth mccchannel_9_analyzer_2_array_crystal_array_5_xwidth
#define yheight mccchannel_9_analyzer_2_array_crystal_array_5_yheight
#define zdepth mccchannel_9_analyzer_2_array_crystal_array_5_zdepth
#define xwidth2 mccchannel_9_analyzer_2_array_crystal_array_5_xwidth2
#define yheight2 mccchannel_9_analyzer_2_array_crystal_array_5_yheight2
#define visualize mccchannel_9_analyzer_2_array_crystal_array_5_visualize
#define target_index mccchannel_9_analyzer_2_array_crystal_array_5_target_index
#define target_x mccchannel_9_analyzer_2_array_crystal_array_5_target_x
#define target_y mccchannel_9_analyzer_2_array_crystal_array_5_target_y
#define target_z mccchannel_9_analyzer_2_array_crystal_array_5_target_z
#define focus_aw mccchannel_9_analyzer_2_array_crystal_array_5_focus_aw
#define focus_ah mccchannel_9_analyzer_2_array_crystal_array_5_focus_ah
#define focus_xw mccchannel_9_analyzer_2_array_crystal_array_5_focus_xw
#define focus_xh mccchannel_9_analyzer_2_array_crystal_array_5_focus_xh
#define focus_r mccchannel_9_analyzer_2_array_crystal_array_5_focus_r
#define p_interact mccchannel_9_analyzer_2_array_crystal_array_5_p_interact
#define mask_string mccchannel_9_analyzer_2_array_crystal_array_5_mask_string
#define mask_setting mccchannel_9_analyzer_2_array_crystal_array_5_mask_setting
#define number_of_activations mccchannel_9_analyzer_2_array_crystal_array_5_number_of_activations
#line 204 "Union_box.comp"
// Needed for transport to the main component
struct global_geometry_element_struct global_geometry_element;

#ifndef ANY_GEOMETRY_DETECTOR_DECLARE
    #define ANY_GEOMETRY_DETECTOR_DECLARE dummy
	//struct pointer_to_global_geometry_list global_geometry_list = {0,NULL};
#endif

int loop_index,found_geometries;

double x_component;
double y_component;
double z_component;

struct Volume_struct this_box_volume;
struct box_storage this_box_storage;

#line 58017 "MACS_sample_kidney_box.c"
#undef number_of_activations
#undef mask_setting
#undef mask_string
#undef p_interact
#undef focus_r
#undef focus_xh
#undef focus_xw
#undef focus_ah
#undef focus_aw
#undef target_z
#undef target_y
#undef target_x
#undef target_index
#undef visualize
#undef yheight2
#undef xwidth2
#undef zdepth
#undef yheight
#undef xwidth
#undef priority
#undef material_string
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

/* User declarations for component 'channel_9_analyzer_2_array_crystal_array_6' [489]. */
#define mccompcurname  channel_9_analyzer_2_array_crystal_array_6
#define mccompcurtype  Union_box
#define mccompcurindex 489
#define loop_index mccchannel_9_analyzer_2_array_crystal_array_6_loop_index
#define this_box_volume mccchannel_9_analyzer_2_array_crystal_array_6_this_box_volume
#define global_geometry_element mccchannel_9_analyzer_2_array_crystal_array_6_global_geometry_element
#define this_box_storage mccchannel_9_analyzer_2_array_crystal_array_6_this_box_storage
#define material_string mccchannel_9_analyzer_2_array_crystal_array_6_material_string
#define priority mccchannel_9_analyzer_2_array_crystal_array_6_priority
#define xwidth mccchannel_9_analyzer_2_array_crystal_array_6_xwidth
#define yheight mccchannel_9_analyzer_2_array_crystal_array_6_yheight
#define zdepth mccchannel_9_analyzer_2_array_crystal_array_6_zdepth
#define xwidth2 mccchannel_9_analyzer_2_array_crystal_array_6_xwidth2
#define yheight2 mccchannel_9_analyzer_2_array_crystal_array_6_yheight2
#define visualize mccchannel_9_analyzer_2_array_crystal_array_6_visualize
#define target_index mccchannel_9_analyzer_2_array_crystal_array_6_target_index
#define target_x mccchannel_9_analyzer_2_array_crystal_array_6_target_x
#define target_y mccchannel_9_analyzer_2_array_crystal_array_6_target_y
#define target_z mccchannel_9_analyzer_2_array_crystal_array_6_target_z
#define focus_aw mccchannel_9_analyzer_2_array_crystal_array_6_focus_aw
#define focus_ah mccchannel_9_analyzer_2_array_crystal_array_6_focus_ah
#define focus_xw mccchannel_9_analyzer_2_array_crystal_array_6_focus_xw
#define focus_xh mccchannel_9_analyzer_2_array_crystal_array_6_focus_xh
#define focus_r mccchannel_9_analyzer_2_array_crystal_array_6_focus_r
#define p_interact mccchannel_9_analyzer_2_array_crystal_array_6_p_interact
#define mask_string mccchannel_9_analyzer_2_array_crystal_array_6_mask_string
#define mask_setting mccchannel_9_analyzer_2_array_crystal_array_6_mask_setting
#define number_of_activations mccchannel_9_analyzer_2_array_crystal_array_6_number_of_activations
#line 204 "Union_box.comp"
// Needed for transport to the main component
struct global_geometry_element_struct global_geometry_element;

#ifndef ANY_GEOMETRY_DETECTOR_DECLARE
    #define ANY_GEOMETRY_DETECTOR_DECLARE dummy
	//struct pointer_to_global_geometry_list global_geometry_list = {0,NULL};
#endif

int loop_index,found_geometries;

double x_component;
double y_component;
double z_component;

struct Volume_struct this_box_volume;
struct box_storage this_box_storage;

#line 58094 "MACS_sample_kidney_box.c"
#undef number_of_activations
#undef mask_setting
#undef mask_string
#undef p_interact
#undef focus_r
#undef focus_xh
#undef focus_xw
#undef focus_ah
#undef focus_aw
#undef target_z
#undef target_y
#undef target_x
#undef target_index
#undef visualize
#undef yheight2
#undef xwidth2
#undef zdepth
#undef yheight
#undef xwidth
#undef priority
#undef material_string
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

/* User declarations for component 'channel_9_analyzer_2_array_crystal_array_7' [490]. */
#define mccompcurname  channel_9_analyzer_2_array_crystal_array_7
#define mccompcurtype  Union_box
#define mccompcurindex 490
#define loop_index mccchannel_9_analyzer_2_array_crystal_array_7_loop_index
#define this_box_volume mccchannel_9_analyzer_2_array_crystal_array_7_this_box_volume
#define global_geometry_element mccchannel_9_analyzer_2_array_crystal_array_7_global_geometry_element
#define this_box_storage mccchannel_9_analyzer_2_array_crystal_array_7_this_box_storage
#define material_string mccchannel_9_analyzer_2_array_crystal_array_7_material_string
#define priority mccchannel_9_analyzer_2_array_crystal_array_7_priority
#define xwidth mccchannel_9_analyzer_2_array_crystal_array_7_xwidth
#define yheight mccchannel_9_analyzer_2_array_crystal_array_7_yheight
#define zdepth mccchannel_9_analyzer_2_array_crystal_array_7_zdepth
#define xwidth2 mccchannel_9_analyzer_2_array_crystal_array_7_xwidth2
#define yheight2 mccchannel_9_analyzer_2_array_crystal_array_7_yheight2
#define visualize mccchannel_9_analyzer_2_array_crystal_array_7_visualize
#define target_index mccchannel_9_analyzer_2_array_crystal_array_7_target_index
#define target_x mccchannel_9_analyzer_2_array_crystal_array_7_target_x
#define target_y mccchannel_9_analyzer_2_array_crystal_array_7_target_y
#define target_z mccchannel_9_analyzer_2_array_crystal_array_7_target_z
#define focus_aw mccchannel_9_analyzer_2_array_crystal_array_7_focus_aw
#define focus_ah mccchannel_9_analyzer_2_array_crystal_array_7_focus_ah
#define focus_xw mccchannel_9_analyzer_2_array_crystal_array_7_focus_xw
#define focus_xh mccchannel_9_analyzer_2_array_crystal_array_7_focus_xh
#define focus_r mccchannel_9_analyzer_2_array_crystal_array_7_focus_r
#define p_interact mccchannel_9_analyzer_2_array_crystal_array_7_p_interact
#define mask_string mccchannel_9_analyzer_2_array_crystal_array_7_mask_string
#define mask_setting mccchannel_9_analyzer_2_array_crystal_array_7_mask_setting
#define number_of_activations mccchannel_9_analyzer_2_array_crystal_array_7_number_of_activations
#line 204 "Union_box.comp"
// Needed for transport to the main component
struct global_geometry_element_struct global_geometry_element;

#ifndef ANY_GEOMETRY_DETECTOR_DECLARE
    #define ANY_GEOMETRY_DETECTOR_DECLARE dummy
	//struct pointer_to_global_geometry_list global_geometry_list = {0,NULL};
#endif

int loop_index,found_geometries;

double x_component;
double y_component;
double z_component;

struct Volume_struct this_box_volume;
struct box_storage this_box_storage;

#line 58171 "MACS_sample_kidney_box.c"
#undef number_of_activations
#undef mask_setting
#undef mask_string
#undef p_interact
#undef focus_r
#undef focus_xh
#undef focus_xw
#undef focus_ah
#undef focus_aw
#undef target_z
#undef target_y
#undef target_x
#undef target_index
#undef visualize
#undef yheight2
#undef xwidth2
#undef zdepth
#undef yheight
#undef xwidth
#undef priority
#undef material_string
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

/* User declarations for component 'channel_9_analyzer_2_array_crystal_array_8' [491]. */
#define mccompcurname  channel_9_analyzer_2_array_crystal_array_8
#define mccompcurtype  Union_box
#define mccompcurindex 491
#define loop_index mccchannel_9_analyzer_2_array_crystal_array_8_loop_index
#define this_box_volume mccchannel_9_analyzer_2_array_crystal_array_8_this_box_volume
#define global_geometry_element mccchannel_9_analyzer_2_array_crystal_array_8_global_geometry_element
#define this_box_storage mccchannel_9_analyzer_2_array_crystal_array_8_this_box_storage
#define material_string mccchannel_9_analyzer_2_array_crystal_array_8_material_string
#define priority mccchannel_9_analyzer_2_array_crystal_array_8_priority
#define xwidth mccchannel_9_analyzer_2_array_crystal_array_8_xwidth
#define yheight mccchannel_9_analyzer_2_array_crystal_array_8_yheight
#define zdepth mccchannel_9_analyzer_2_array_crystal_array_8_zdepth
#define xwidth2 mccchannel_9_analyzer_2_array_crystal_array_8_xwidth2
#define yheight2 mccchannel_9_analyzer_2_array_crystal_array_8_yheight2
#define visualize mccchannel_9_analyzer_2_array_crystal_array_8_visualize
#define target_index mccchannel_9_analyzer_2_array_crystal_array_8_target_index
#define target_x mccchannel_9_analyzer_2_array_crystal_array_8_target_x
#define target_y mccchannel_9_analyzer_2_array_crystal_array_8_target_y
#define target_z mccchannel_9_analyzer_2_array_crystal_array_8_target_z
#define focus_aw mccchannel_9_analyzer_2_array_crystal_array_8_focus_aw
#define focus_ah mccchannel_9_analyzer_2_array_crystal_array_8_focus_ah
#define focus_xw mccchannel_9_analyzer_2_array_crystal_array_8_focus_xw
#define focus_xh mccchannel_9_analyzer_2_array_crystal_array_8_focus_xh
#define focus_r mccchannel_9_analyzer_2_array_crystal_array_8_focus_r
#define p_interact mccchannel_9_analyzer_2_array_crystal_array_8_p_interact
#define mask_string mccchannel_9_analyzer_2_array_crystal_array_8_mask_string
#define mask_setting mccchannel_9_analyzer_2_array_crystal_array_8_mask_setting
#define number_of_activations mccchannel_9_analyzer_2_array_crystal_array_8_number_of_activations
#line 204 "Union_box.comp"
// Needed for transport to the main component
struct global_geometry_element_struct global_geometry_element;

#ifndef ANY_GEOMETRY_DETECTOR_DECLARE
    #define ANY_GEOMETRY_DETECTOR_DECLARE dummy
	//struct pointer_to_global_geometry_list global_geometry_list = {0,NULL};
#endif

int loop_index,found_geometries;

double x_component;
double y_component;
double z_component;

struct Volume_struct this_box_volume;
struct box_storage this_box_storage;

#line 58248 "MACS_sample_kidney_box.c"
#undef number_of_activations
#undef mask_setting
#undef mask_string
#undef p_interact
#undef focus_r
#undef focus_xh
#undef focus_xw
#undef focus_ah
#undef focus_aw
#undef target_z
#undef target_y
#undef target_x
#undef target_index
#undef visualize
#undef yheight2
#undef xwidth2
#undef zdepth
#undef yheight
#undef xwidth
#undef priority
#undef material_string
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

/* User declarations for component 'channel_9_cave2_cyl1' [492]. */
#define mccompcurname  channel_9_cave2_cyl1
#define mccompcurtype  Union_cylinder
#define mccompcurindex 492
#define loop_index mccchannel_9_cave2_cyl1_loop_index
#define this_cylinder_volume mccchannel_9_cave2_cyl1_this_cylinder_volume
#define global_geometry_element mccchannel_9_cave2_cyl1_global_geometry_element
#define this_cylinder_storage mccchannel_9_cave2_cyl1_this_cylinder_storage
#define material_string mccchannel_9_cave2_cyl1_material_string
#define priority mccchannel_9_cave2_cyl1_priority
#define radius mccchannel_9_cave2_cyl1_radius
#define yheight mccchannel_9_cave2_cyl1_yheight
#define visualize mccchannel_9_cave2_cyl1_visualize
#define target_index mccchannel_9_cave2_cyl1_target_index
#define target_x mccchannel_9_cave2_cyl1_target_x
#define target_y mccchannel_9_cave2_cyl1_target_y
#define target_z mccchannel_9_cave2_cyl1_target_z
#define focus_aw mccchannel_9_cave2_cyl1_focus_aw
#define focus_ah mccchannel_9_cave2_cyl1_focus_ah
#define focus_xw mccchannel_9_cave2_cyl1_focus_xw
#define focus_xh mccchannel_9_cave2_cyl1_focus_xh
#define focus_r mccchannel_9_cave2_cyl1_focus_r
#define p_interact mccchannel_9_cave2_cyl1_p_interact
#define mask_string mccchannel_9_cave2_cyl1_mask_string
#define mask_setting mccchannel_9_cave2_cyl1_mask_setting
#define number_of_activations mccchannel_9_cave2_cyl1_number_of_activations
#line 167 "Union_cylinder.comp"
// Needed for transport to the main component
struct global_geometry_element_struct global_geometry_element;

#ifndef ANY_GEOMETRY_DETECTOR_DECLARE
    #define ANY_GEOMETRY_DETECTOR_DECLARE dummy
	//struct pointer_to_global_geometry_list global_geometry_list = {0,NULL};
#endif

int dummy;
int loop_index,found_geometries;
int loop_2_index;
int material_index;

struct Volume_struct this_cylinder_volume;
struct cylinder_storage this_cylinder_storage;
#line 58320 "MACS_sample_kidney_box.c"
#undef number_of_activations
#undef mask_setting
#undef mask_string
#undef p_interact
#undef focus_r
#undef focus_xh
#undef focus_xw
#undef focus_ah
#undef focus_aw
#undef target_z
#undef target_y
#undef target_x
#undef target_index
#undef visualize
#undef yheight
#undef radius
#undef priority
#undef material_string
#undef this_cylinder_storage
#undef global_geometry_element
#undef this_cylinder_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

/* User declarations for component 'channel_9_cave2_box1' [493]. */
#define mccompcurname  channel_9_cave2_box1
#define mccompcurtype  Union_box
#define mccompcurindex 493
#define loop_index mccchannel_9_cave2_box1_loop_index
#define this_box_volume mccchannel_9_cave2_box1_this_box_volume
#define global_geometry_element mccchannel_9_cave2_box1_global_geometry_element
#define this_box_storage mccchannel_9_cave2_box1_this_box_storage
#define material_string mccchannel_9_cave2_box1_material_string
#define priority mccchannel_9_cave2_box1_priority
#define xwidth mccchannel_9_cave2_box1_xwidth
#define yheight mccchannel_9_cave2_box1_yheight
#define zdepth mccchannel_9_cave2_box1_zdepth
#define xwidth2 mccchannel_9_cave2_box1_xwidth2
#define yheight2 mccchannel_9_cave2_box1_yheight2
#define visualize mccchannel_9_cave2_box1_visualize
#define target_index mccchannel_9_cave2_box1_target_index
#define target_x mccchannel_9_cave2_box1_target_x
#define target_y mccchannel_9_cave2_box1_target_y
#define target_z mccchannel_9_cave2_box1_target_z
#define focus_aw mccchannel_9_cave2_box1_focus_aw
#define focus_ah mccchannel_9_cave2_box1_focus_ah
#define focus_xw mccchannel_9_cave2_box1_focus_xw
#define focus_xh mccchannel_9_cave2_box1_focus_xh
#define focus_r mccchannel_9_cave2_box1_focus_r
#define p_interact mccchannel_9_cave2_box1_p_interact
#define mask_string mccchannel_9_cave2_box1_mask_string
#define mask_setting mccchannel_9_cave2_box1_mask_setting
#define number_of_activations mccchannel_9_cave2_box1_number_of_activations
#line 204 "Union_box.comp"
// Needed for transport to the main component
struct global_geometry_element_struct global_geometry_element;

#ifndef ANY_GEOMETRY_DETECTOR_DECLARE
    #define ANY_GEOMETRY_DETECTOR_DECLARE dummy
	//struct pointer_to_global_geometry_list global_geometry_list = {0,NULL};
#endif

int loop_index,found_geometries;

double x_component;
double y_component;
double z_component;

struct Volume_struct this_box_volume;
struct box_storage this_box_storage;

#line 58394 "MACS_sample_kidney_box.c"
#undef number_of_activations
#undef mask_setting
#undef mask_string
#undef p_interact
#undef focus_r
#undef focus_xh
#undef focus_xw
#undef focus_ah
#undef focus_aw
#undef target_z
#undef target_y
#undef target_x
#undef target_index
#undef visualize
#undef yheight2
#undef xwidth2
#undef zdepth
#undef yheight
#undef xwidth
#undef priority
#undef material_string
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

/* User declarations for component 'channel_9_cave2_box2' [494]. */
#define mccompcurname  channel_9_cave2_box2
#define mccompcurtype  Union_box
#define mccompcurindex 494
#define loop_index mccchannel_9_cave2_box2_loop_index
#define this_box_volume mccchannel_9_cave2_box2_this_box_volume
#define global_geometry_element mccchannel_9_cave2_box2_global_geometry_element
#define this_box_storage mccchannel_9_cave2_box2_this_box_storage
#define material_string mccchannel_9_cave2_box2_material_string
#define priority mccchannel_9_cave2_box2_priority
#define xwidth mccchannel_9_cave2_box2_xwidth
#define yheight mccchannel_9_cave2_box2_yheight
#define zdepth mccchannel_9_cave2_box2_zdepth
#define xwidth2 mccchannel_9_cave2_box2_xwidth2
#define yheight2 mccchannel_9_cave2_box2_yheight2
#define visualize mccchannel_9_cave2_box2_visualize
#define target_index mccchannel_9_cave2_box2_target_index
#define target_x mccchannel_9_cave2_box2_target_x
#define target_y mccchannel_9_cave2_box2_target_y
#define target_z mccchannel_9_cave2_box2_target_z
#define focus_aw mccchannel_9_cave2_box2_focus_aw
#define focus_ah mccchannel_9_cave2_box2_focus_ah
#define focus_xw mccchannel_9_cave2_box2_focus_xw
#define focus_xh mccchannel_9_cave2_box2_focus_xh
#define focus_r mccchannel_9_cave2_box2_focus_r
#define p_interact mccchannel_9_cave2_box2_p_interact
#define mask_string mccchannel_9_cave2_box2_mask_string
#define mask_setting mccchannel_9_cave2_box2_mask_setting
#define number_of_activations mccchannel_9_cave2_box2_number_of_activations
#line 204 "Union_box.comp"
// Needed for transport to the main component
struct global_geometry_element_struct global_geometry_element;

#ifndef ANY_GEOMETRY_DETECTOR_DECLARE
    #define ANY_GEOMETRY_DETECTOR_DECLARE dummy
	//struct pointer_to_global_geometry_list global_geometry_list = {0,NULL};
#endif

int loop_index,found_geometries;

double x_component;
double y_component;
double z_component;

struct Volume_struct this_box_volume;
struct box_storage this_box_storage;

#line 58471 "MACS_sample_kidney_box.c"
#undef number_of_activations
#undef mask_setting
#undef mask_string
#undef p_interact
#undef focus_r
#undef focus_xh
#undef focus_xw
#undef focus_ah
#undef focus_aw
#undef target_z
#undef target_y
#undef target_x
#undef target_index
#undef visualize
#undef yheight2
#undef xwidth2
#undef zdepth
#undef yheight
#undef xwidth
#undef priority
#undef material_string
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

/* User declarations for component 'channel_9_cave2_box3' [495]. */
#define mccompcurname  channel_9_cave2_box3
#define mccompcurtype  Union_box
#define mccompcurindex 495
#define loop_index mccchannel_9_cave2_box3_loop_index
#define this_box_volume mccchannel_9_cave2_box3_this_box_volume
#define global_geometry_element mccchannel_9_cave2_box3_global_geometry_element
#define this_box_storage mccchannel_9_cave2_box3_this_box_storage
#define material_string mccchannel_9_cave2_box3_material_string
#define priority mccchannel_9_cave2_box3_priority
#define xwidth mccchannel_9_cave2_box3_xwidth
#define yheight mccchannel_9_cave2_box3_yheight
#define zdepth mccchannel_9_cave2_box3_zdepth
#define xwidth2 mccchannel_9_cave2_box3_xwidth2
#define yheight2 mccchannel_9_cave2_box3_yheight2
#define visualize mccchannel_9_cave2_box3_visualize
#define target_index mccchannel_9_cave2_box3_target_index
#define target_x mccchannel_9_cave2_box3_target_x
#define target_y mccchannel_9_cave2_box3_target_y
#define target_z mccchannel_9_cave2_box3_target_z
#define focus_aw mccchannel_9_cave2_box3_focus_aw
#define focus_ah mccchannel_9_cave2_box3_focus_ah
#define focus_xw mccchannel_9_cave2_box3_focus_xw
#define focus_xh mccchannel_9_cave2_box3_focus_xh
#define focus_r mccchannel_9_cave2_box3_focus_r
#define p_interact mccchannel_9_cave2_box3_p_interact
#define mask_string mccchannel_9_cave2_box3_mask_string
#define mask_setting mccchannel_9_cave2_box3_mask_setting
#define number_of_activations mccchannel_9_cave2_box3_number_of_activations
#line 204 "Union_box.comp"
// Needed for transport to the main component
struct global_geometry_element_struct global_geometry_element;

#ifndef ANY_GEOMETRY_DETECTOR_DECLARE
    #define ANY_GEOMETRY_DETECTOR_DECLARE dummy
	//struct pointer_to_global_geometry_list global_geometry_list = {0,NULL};
#endif

int loop_index,found_geometries;

double x_component;
double y_component;
double z_component;

struct Volume_struct this_box_volume;
struct box_storage this_box_storage;

#line 58548 "MACS_sample_kidney_box.c"
#undef number_of_activations
#undef mask_setting
#undef mask_string
#undef p_interact
#undef focus_r
#undef focus_xh
#undef focus_xw
#undef focus_ah
#undef focus_aw
#undef target_z
#undef target_y
#undef target_x
#undef target_index
#undef visualize
#undef yheight2
#undef xwidth2
#undef zdepth
#undef yheight
#undef xwidth
#undef priority
#undef material_string
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

/* User declarations for component 'inter_analyzer_colimator_center_9' [496]. */
#define mccompcurname  inter_analyzer_colimator_center_9
#define mccompcurtype  Arm
#define mccompcurindex 496
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

/* User declarations for component 'inter_analyzer_colimator_9_blade_0' [497]. */
#define mccompcurname  inter_analyzer_colimator_9_blade_0
#define mccompcurtype  Union_box
#define mccompcurindex 497
#define loop_index mccinter_analyzer_colimator_9_blade_0_loop_index
#define this_box_volume mccinter_analyzer_colimator_9_blade_0_this_box_volume
#define global_geometry_element mccinter_analyzer_colimator_9_blade_0_global_geometry_element
#define this_box_storage mccinter_analyzer_colimator_9_blade_0_this_box_storage
#define material_string mccinter_analyzer_colimator_9_blade_0_material_string
#define priority mccinter_analyzer_colimator_9_blade_0_priority
#define xwidth mccinter_analyzer_colimator_9_blade_0_xwidth
#define yheight mccinter_analyzer_colimator_9_blade_0_yheight
#define zdepth mccinter_analyzer_colimator_9_blade_0_zdepth
#define xwidth2 mccinter_analyzer_colimator_9_blade_0_xwidth2
#define yheight2 mccinter_analyzer_colimator_9_blade_0_yheight2
#define visualize mccinter_analyzer_colimator_9_blade_0_visualize
#define target_index mccinter_analyzer_colimator_9_blade_0_target_index
#define target_x mccinter_analyzer_colimator_9_blade_0_target_x
#define target_y mccinter_analyzer_colimator_9_blade_0_target_y
#define target_z mccinter_analyzer_colimator_9_blade_0_target_z
#define focus_aw mccinter_analyzer_colimator_9_blade_0_focus_aw
#define focus_ah mccinter_analyzer_colimator_9_blade_0_focus_ah
#define focus_xw mccinter_analyzer_colimator_9_blade_0_focus_xw
#define focus_xh mccinter_analyzer_colimator_9_blade_0_focus_xh
#define focus_r mccinter_analyzer_colimator_9_blade_0_focus_r
#define p_interact mccinter_analyzer_colimator_9_blade_0_p_interact
#define mask_string mccinter_analyzer_colimator_9_blade_0_mask_string
#define mask_setting mccinter_analyzer_colimator_9_blade_0_mask_setting
#define number_of_activations mccinter_analyzer_colimator_9_blade_0_number_of_activations
#line 204 "Union_box.comp"
// Needed for transport to the main component
struct global_geometry_element_struct global_geometry_element;

#ifndef ANY_GEOMETRY_DETECTOR_DECLARE
    #define ANY_GEOMETRY_DETECTOR_DECLARE dummy
	//struct pointer_to_global_geometry_list global_geometry_list = {0,NULL};
#endif

int loop_index,found_geometries;

double x_component;
double y_component;
double z_component;

struct Volume_struct this_box_volume;
struct box_storage this_box_storage;

#line 58633 "MACS_sample_kidney_box.c"
#undef number_of_activations
#undef mask_setting
#undef mask_string
#undef p_interact
#undef focus_r
#undef focus_xh
#undef focus_xw
#undef focus_ah
#undef focus_aw
#undef target_z
#undef target_y
#undef target_x
#undef target_index
#undef visualize
#undef yheight2
#undef xwidth2
#undef zdepth
#undef yheight
#undef xwidth
#undef priority
#undef material_string
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

/* User declarations for component 'inter_analyzer_colimator_9_blade_1' [498]. */
#define mccompcurname  inter_analyzer_colimator_9_blade_1
#define mccompcurtype  Union_box
#define mccompcurindex 498
#define loop_index mccinter_analyzer_colimator_9_blade_1_loop_index
#define this_box_volume mccinter_analyzer_colimator_9_blade_1_this_box_volume
#define global_geometry_element mccinter_analyzer_colimator_9_blade_1_global_geometry_element
#define this_box_storage mccinter_analyzer_colimator_9_blade_1_this_box_storage
#define material_string mccinter_analyzer_colimator_9_blade_1_material_string
#define priority mccinter_analyzer_colimator_9_blade_1_priority
#define xwidth mccinter_analyzer_colimator_9_blade_1_xwidth
#define yheight mccinter_analyzer_colimator_9_blade_1_yheight
#define zdepth mccinter_analyzer_colimator_9_blade_1_zdepth
#define xwidth2 mccinter_analyzer_colimator_9_blade_1_xwidth2
#define yheight2 mccinter_analyzer_colimator_9_blade_1_yheight2
#define visualize mccinter_analyzer_colimator_9_blade_1_visualize
#define target_index mccinter_analyzer_colimator_9_blade_1_target_index
#define target_x mccinter_analyzer_colimator_9_blade_1_target_x
#define target_y mccinter_analyzer_colimator_9_blade_1_target_y
#define target_z mccinter_analyzer_colimator_9_blade_1_target_z
#define focus_aw mccinter_analyzer_colimator_9_blade_1_focus_aw
#define focus_ah mccinter_analyzer_colimator_9_blade_1_focus_ah
#define focus_xw mccinter_analyzer_colimator_9_blade_1_focus_xw
#define focus_xh mccinter_analyzer_colimator_9_blade_1_focus_xh
#define focus_r mccinter_analyzer_colimator_9_blade_1_focus_r
#define p_interact mccinter_analyzer_colimator_9_blade_1_p_interact
#define mask_string mccinter_analyzer_colimator_9_blade_1_mask_string
#define mask_setting mccinter_analyzer_colimator_9_blade_1_mask_setting
#define number_of_activations mccinter_analyzer_colimator_9_blade_1_number_of_activations
#line 204 "Union_box.comp"
// Needed for transport to the main component
struct global_geometry_element_struct global_geometry_element;

#ifndef ANY_GEOMETRY_DETECTOR_DECLARE
    #define ANY_GEOMETRY_DETECTOR_DECLARE dummy
	//struct pointer_to_global_geometry_list global_geometry_list = {0,NULL};
#endif

int loop_index,found_geometries;

double x_component;
double y_component;
double z_component;

struct Volume_struct this_box_volume;
struct box_storage this_box_storage;

#line 58710 "MACS_sample_kidney_box.c"
#undef number_of_activations
#undef mask_setting
#undef mask_string
#undef p_interact
#undef focus_r
#undef focus_xh
#undef focus_xw
#undef focus_ah
#undef focus_aw
#undef target_z
#undef target_y
#undef target_x
#undef target_index
#undef visualize
#undef yheight2
#undef xwidth2
#undef zdepth
#undef yheight
#undef xwidth
#undef priority
#undef material_string
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

/* User declarations for component 'inter_analyzer_colimator_9_blade_2' [499]. */
#define mccompcurname  inter_analyzer_colimator_9_blade_2
#define mccompcurtype  Union_box
#define mccompcurindex 499
#define loop_index mccinter_analyzer_colimator_9_blade_2_loop_index
#define this_box_volume mccinter_analyzer_colimator_9_blade_2_this_box_volume
#define global_geometry_element mccinter_analyzer_colimator_9_blade_2_global_geometry_element
#define this_box_storage mccinter_analyzer_colimator_9_blade_2_this_box_storage
#define material_string mccinter_analyzer_colimator_9_blade_2_material_string
#define priority mccinter_analyzer_colimator_9_blade_2_priority
#define xwidth mccinter_analyzer_colimator_9_blade_2_xwidth
#define yheight mccinter_analyzer_colimator_9_blade_2_yheight
#define zdepth mccinter_analyzer_colimator_9_blade_2_zdepth
#define xwidth2 mccinter_analyzer_colimator_9_blade_2_xwidth2
#define yheight2 mccinter_analyzer_colimator_9_blade_2_yheight2
#define visualize mccinter_analyzer_colimator_9_blade_2_visualize
#define target_index mccinter_analyzer_colimator_9_blade_2_target_index
#define target_x mccinter_analyzer_colimator_9_blade_2_target_x
#define target_y mccinter_analyzer_colimator_9_blade_2_target_y
#define target_z mccinter_analyzer_colimator_9_blade_2_target_z
#define focus_aw mccinter_analyzer_colimator_9_blade_2_focus_aw
#define focus_ah mccinter_analyzer_colimator_9_blade_2_focus_ah
#define focus_xw mccinter_analyzer_colimator_9_blade_2_focus_xw
#define focus_xh mccinter_analyzer_colimator_9_blade_2_focus_xh
#define focus_r mccinter_analyzer_colimator_9_blade_2_focus_r
#define p_interact mccinter_analyzer_colimator_9_blade_2_p_interact
#define mask_string mccinter_analyzer_colimator_9_blade_2_mask_string
#define mask_setting mccinter_analyzer_colimator_9_blade_2_mask_setting
#define number_of_activations mccinter_analyzer_colimator_9_blade_2_number_of_activations
#line 204 "Union_box.comp"
// Needed for transport to the main component
struct global_geometry_element_struct global_geometry_element;

#ifndef ANY_GEOMETRY_DETECTOR_DECLARE
    #define ANY_GEOMETRY_DETECTOR_DECLARE dummy
	//struct pointer_to_global_geometry_list global_geometry_list = {0,NULL};
#endif

int loop_index,found_geometries;

double x_component;
double y_component;
double z_component;

struct Volume_struct this_box_volume;
struct box_storage this_box_storage;

#line 58787 "MACS_sample_kidney_box.c"
#undef number_of_activations
#undef mask_setting
#undef mask_string
#undef p_interact
#undef focus_r
#undef focus_xh
#undef focus_xw
#undef focus_ah
#undef focus_aw
#undef target_z
#undef target_y
#undef target_x
#undef target_index
#undef visualize
#undef yheight2
#undef xwidth2
#undef zdepth
#undef yheight
#undef xwidth
#undef priority
#undef material_string
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

/* User declarations for component 'inter_analyzer_colimator_9_blade_3' [500]. */
#define mccompcurname  inter_analyzer_colimator_9_blade_3
#define mccompcurtype  Union_box
#define mccompcurindex 500
#define loop_index mccinter_analyzer_colimator_9_blade_3_loop_index
#define this_box_volume mccinter_analyzer_colimator_9_blade_3_this_box_volume
#define global_geometry_element mccinter_analyzer_colimator_9_blade_3_global_geometry_element
#define this_box_storage mccinter_analyzer_colimator_9_blade_3_this_box_storage
#define material_string mccinter_analyzer_colimator_9_blade_3_material_string
#define priority mccinter_analyzer_colimator_9_blade_3_priority
#define xwidth mccinter_analyzer_colimator_9_blade_3_xwidth
#define yheight mccinter_analyzer_colimator_9_blade_3_yheight
#define zdepth mccinter_analyzer_colimator_9_blade_3_zdepth
#define xwidth2 mccinter_analyzer_colimator_9_blade_3_xwidth2
#define yheight2 mccinter_analyzer_colimator_9_blade_3_yheight2
#define visualize mccinter_analyzer_colimator_9_blade_3_visualize
#define target_index mccinter_analyzer_colimator_9_blade_3_target_index
#define target_x mccinter_analyzer_colimator_9_blade_3_target_x
#define target_y mccinter_analyzer_colimator_9_blade_3_target_y
#define target_z mccinter_analyzer_colimator_9_blade_3_target_z
#define focus_aw mccinter_analyzer_colimator_9_blade_3_focus_aw
#define focus_ah mccinter_analyzer_colimator_9_blade_3_focus_ah
#define focus_xw mccinter_analyzer_colimator_9_blade_3_focus_xw
#define focus_xh mccinter_analyzer_colimator_9_blade_3_focus_xh
#define focus_r mccinter_analyzer_colimator_9_blade_3_focus_r
#define p_interact mccinter_analyzer_colimator_9_blade_3_p_interact
#define mask_string mccinter_analyzer_colimator_9_blade_3_mask_string
#define mask_setting mccinter_analyzer_colimator_9_blade_3_mask_setting
#define number_of_activations mccinter_analyzer_colimator_9_blade_3_number_of_activations
#line 204 "Union_box.comp"
// Needed for transport to the main component
struct global_geometry_element_struct global_geometry_element;

#ifndef ANY_GEOMETRY_DETECTOR_DECLARE
    #define ANY_GEOMETRY_DETECTOR_DECLARE dummy
	//struct pointer_to_global_geometry_list global_geometry_list = {0,NULL};
#endif

int loop_index,found_geometries;

double x_component;
double y_component;
double z_component;

struct Volume_struct this_box_volume;
struct box_storage this_box_storage;

#line 58864 "MACS_sample_kidney_box.c"
#undef number_of_activations
#undef mask_setting
#undef mask_string
#undef p_interact
#undef focus_r
#undef focus_xh
#undef focus_xw
#undef focus_ah
#undef focus_aw
#undef target_z
#undef target_y
#undef target_x
#undef target_index
#undef visualize
#undef yheight2
#undef xwidth2
#undef zdepth
#undef yheight
#undef xwidth
#undef priority
#undef material_string
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

/* User declarations for component 'inter_analyzer_colimator_9_blade_4' [501]. */
#define mccompcurname  inter_analyzer_colimator_9_blade_4
#define mccompcurtype  Union_box
#define mccompcurindex 501
#define loop_index mccinter_analyzer_colimator_9_blade_4_loop_index
#define this_box_volume mccinter_analyzer_colimator_9_blade_4_this_box_volume
#define global_geometry_element mccinter_analyzer_colimator_9_blade_4_global_geometry_element
#define this_box_storage mccinter_analyzer_colimator_9_blade_4_this_box_storage
#define material_string mccinter_analyzer_colimator_9_blade_4_material_string
#define priority mccinter_analyzer_colimator_9_blade_4_priority
#define xwidth mccinter_analyzer_colimator_9_blade_4_xwidth
#define yheight mccinter_analyzer_colimator_9_blade_4_yheight
#define zdepth mccinter_analyzer_colimator_9_blade_4_zdepth
#define xwidth2 mccinter_analyzer_colimator_9_blade_4_xwidth2
#define yheight2 mccinter_analyzer_colimator_9_blade_4_yheight2
#define visualize mccinter_analyzer_colimator_9_blade_4_visualize
#define target_index mccinter_analyzer_colimator_9_blade_4_target_index
#define target_x mccinter_analyzer_colimator_9_blade_4_target_x
#define target_y mccinter_analyzer_colimator_9_blade_4_target_y
#define target_z mccinter_analyzer_colimator_9_blade_4_target_z
#define focus_aw mccinter_analyzer_colimator_9_blade_4_focus_aw
#define focus_ah mccinter_analyzer_colimator_9_blade_4_focus_ah
#define focus_xw mccinter_analyzer_colimator_9_blade_4_focus_xw
#define focus_xh mccinter_analyzer_colimator_9_blade_4_focus_xh
#define focus_r mccinter_analyzer_colimator_9_blade_4_focus_r
#define p_interact mccinter_analyzer_colimator_9_blade_4_p_interact
#define mask_string mccinter_analyzer_colimator_9_blade_4_mask_string
#define mask_setting mccinter_analyzer_colimator_9_blade_4_mask_setting
#define number_of_activations mccinter_analyzer_colimator_9_blade_4_number_of_activations
#line 204 "Union_box.comp"
// Needed for transport to the main component
struct global_geometry_element_struct global_geometry_element;

#ifndef ANY_GEOMETRY_DETECTOR_DECLARE
    #define ANY_GEOMETRY_DETECTOR_DECLARE dummy
	//struct pointer_to_global_geometry_list global_geometry_list = {0,NULL};
#endif

int loop_index,found_geometries;

double x_component;
double y_component;
double z_component;

struct Volume_struct this_box_volume;
struct box_storage this_box_storage;

#line 58941 "MACS_sample_kidney_box.c"
#undef number_of_activations
#undef mask_setting
#undef mask_string
#undef p_interact
#undef focus_r
#undef focus_xh
#undef focus_xw
#undef focus_ah
#undef focus_aw
#undef target_z
#undef target_y
#undef target_x
#undef target_index
#undef visualize
#undef yheight2
#undef xwidth2
#undef zdepth
#undef yheight
#undef xwidth
#undef priority
#undef material_string
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

/* User declarations for component 'diffraction_detector_9_exit_volume' [502]. */
#define mccompcurname  diffraction_detector_9_exit_volume
#define mccompcurtype  Union_box
#define mccompcurindex 502
#define loop_index mccdiffraction_detector_9_exit_volume_loop_index
#define this_box_volume mccdiffraction_detector_9_exit_volume_this_box_volume
#define global_geometry_element mccdiffraction_detector_9_exit_volume_global_geometry_element
#define this_box_storage mccdiffraction_detector_9_exit_volume_this_box_storage
#define material_string mccdiffraction_detector_9_exit_volume_material_string
#define priority mccdiffraction_detector_9_exit_volume_priority
#define xwidth mccdiffraction_detector_9_exit_volume_xwidth
#define yheight mccdiffraction_detector_9_exit_volume_yheight
#define zdepth mccdiffraction_detector_9_exit_volume_zdepth
#define xwidth2 mccdiffraction_detector_9_exit_volume_xwidth2
#define yheight2 mccdiffraction_detector_9_exit_volume_yheight2
#define visualize mccdiffraction_detector_9_exit_volume_visualize
#define target_index mccdiffraction_detector_9_exit_volume_target_index
#define target_x mccdiffraction_detector_9_exit_volume_target_x
#define target_y mccdiffraction_detector_9_exit_volume_target_y
#define target_z mccdiffraction_detector_9_exit_volume_target_z
#define focus_aw mccdiffraction_detector_9_exit_volume_focus_aw
#define focus_ah mccdiffraction_detector_9_exit_volume_focus_ah
#define focus_xw mccdiffraction_detector_9_exit_volume_focus_xw
#define focus_xh mccdiffraction_detector_9_exit_volume_focus_xh
#define focus_r mccdiffraction_detector_9_exit_volume_focus_r
#define p_interact mccdiffraction_detector_9_exit_volume_p_interact
#define mask_string mccdiffraction_detector_9_exit_volume_mask_string
#define mask_setting mccdiffraction_detector_9_exit_volume_mask_setting
#define number_of_activations mccdiffraction_detector_9_exit_volume_number_of_activations
#line 204 "Union_box.comp"
// Needed for transport to the main component
struct global_geometry_element_struct global_geometry_element;

#ifndef ANY_GEOMETRY_DETECTOR_DECLARE
    #define ANY_GEOMETRY_DETECTOR_DECLARE dummy
	//struct pointer_to_global_geometry_list global_geometry_list = {0,NULL};
#endif

int loop_index,found_geometries;

double x_component;
double y_component;
double z_component;

struct Volume_struct this_box_volume;
struct box_storage this_box_storage;

#line 59018 "MACS_sample_kidney_box.c"
#undef number_of_activations
#undef mask_setting
#undef mask_string
#undef p_interact
#undef focus_r
#undef focus_xh
#undef focus_xw
#undef focus_ah
#undef focus_aw
#undef target_z
#undef target_y
#undef target_x
#undef target_index
#undef visualize
#undef yheight2
#undef xwidth2
#undef zdepth
#undef yheight
#undef xwidth
#undef priority
#undef material_string
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

/* User declarations for component 'spec_detector_9_exit_volume' [503]. */
#define mccompcurname  spec_detector_9_exit_volume
#define mccompcurtype  Union_box
#define mccompcurindex 503
#define loop_index mccspec_detector_9_exit_volume_loop_index
#define this_box_volume mccspec_detector_9_exit_volume_this_box_volume
#define global_geometry_element mccspec_detector_9_exit_volume_global_geometry_element
#define this_box_storage mccspec_detector_9_exit_volume_this_box_storage
#define material_string mccspec_detector_9_exit_volume_material_string
#define priority mccspec_detector_9_exit_volume_priority
#define xwidth mccspec_detector_9_exit_volume_xwidth
#define yheight mccspec_detector_9_exit_volume_yheight
#define zdepth mccspec_detector_9_exit_volume_zdepth
#define xwidth2 mccspec_detector_9_exit_volume_xwidth2
#define yheight2 mccspec_detector_9_exit_volume_yheight2
#define visualize mccspec_detector_9_exit_volume_visualize
#define target_index mccspec_detector_9_exit_volume_target_index
#define target_x mccspec_detector_9_exit_volume_target_x
#define target_y mccspec_detector_9_exit_volume_target_y
#define target_z mccspec_detector_9_exit_volume_target_z
#define focus_aw mccspec_detector_9_exit_volume_focus_aw
#define focus_ah mccspec_detector_9_exit_volume_focus_ah
#define focus_xw mccspec_detector_9_exit_volume_focus_xw
#define focus_xh mccspec_detector_9_exit_volume_focus_xh
#define focus_r mccspec_detector_9_exit_volume_focus_r
#define p_interact mccspec_detector_9_exit_volume_p_interact
#define mask_string mccspec_detector_9_exit_volume_mask_string
#define mask_setting mccspec_detector_9_exit_volume_mask_setting
#define number_of_activations mccspec_detector_9_exit_volume_number_of_activations
#line 204 "Union_box.comp"
// Needed for transport to the main component
struct global_geometry_element_struct global_geometry_element;

#ifndef ANY_GEOMETRY_DETECTOR_DECLARE
    #define ANY_GEOMETRY_DETECTOR_DECLARE dummy
	//struct pointer_to_global_geometry_list global_geometry_list = {0,NULL};
#endif

int loop_index,found_geometries;

double x_component;
double y_component;
double z_component;

struct Volume_struct this_box_volume;
struct box_storage this_box_storage;

#line 59095 "MACS_sample_kidney_box.c"
#undef number_of_activations
#undef mask_setting
#undef mask_string
#undef p_interact
#undef focus_r
#undef focus_xh
#undef focus_xw
#undef focus_ah
#undef focus_aw
#undef target_z
#undef target_y
#undef target_x
#undef target_index
#undef visualize
#undef yheight2
#undef xwidth2
#undef zdepth
#undef yheight
#undef xwidth
#undef priority
#undef material_string
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

/* User declarations for component 'channel_10_cave1_box1' [504]. */
#define mccompcurname  channel_10_cave1_box1
#define mccompcurtype  Union_box
#define mccompcurindex 504
#define loop_index mccchannel_10_cave1_box1_loop_index
#define this_box_volume mccchannel_10_cave1_box1_this_box_volume
#define global_geometry_element mccchannel_10_cave1_box1_global_geometry_element
#define this_box_storage mccchannel_10_cave1_box1_this_box_storage
#define material_string mccchannel_10_cave1_box1_material_string
#define priority mccchannel_10_cave1_box1_priority
#define xwidth mccchannel_10_cave1_box1_xwidth
#define yheight mccchannel_10_cave1_box1_yheight
#define zdepth mccchannel_10_cave1_box1_zdepth
#define xwidth2 mccchannel_10_cave1_box1_xwidth2
#define yheight2 mccchannel_10_cave1_box1_yheight2
#define visualize mccchannel_10_cave1_box1_visualize
#define target_index mccchannel_10_cave1_box1_target_index
#define target_x mccchannel_10_cave1_box1_target_x
#define target_y mccchannel_10_cave1_box1_target_y
#define target_z mccchannel_10_cave1_box1_target_z
#define focus_aw mccchannel_10_cave1_box1_focus_aw
#define focus_ah mccchannel_10_cave1_box1_focus_ah
#define focus_xw mccchannel_10_cave1_box1_focus_xw
#define focus_xh mccchannel_10_cave1_box1_focus_xh
#define focus_r mccchannel_10_cave1_box1_focus_r
#define p_interact mccchannel_10_cave1_box1_p_interact
#define mask_string mccchannel_10_cave1_box1_mask_string
#define mask_setting mccchannel_10_cave1_box1_mask_setting
#define number_of_activations mccchannel_10_cave1_box1_number_of_activations
#line 204 "Union_box.comp"
// Needed for transport to the main component
struct global_geometry_element_struct global_geometry_element;

#ifndef ANY_GEOMETRY_DETECTOR_DECLARE
    #define ANY_GEOMETRY_DETECTOR_DECLARE dummy
	//struct pointer_to_global_geometry_list global_geometry_list = {0,NULL};
#endif

int loop_index,found_geometries;

double x_component;
double y_component;
double z_component;

struct Volume_struct this_box_volume;
struct box_storage this_box_storage;

#line 59172 "MACS_sample_kidney_box.c"
#undef number_of_activations
#undef mask_setting
#undef mask_string
#undef p_interact
#undef focus_r
#undef focus_xh
#undef focus_xw
#undef focus_ah
#undef focus_aw
#undef target_z
#undef target_y
#undef target_x
#undef target_index
#undef visualize
#undef yheight2
#undef xwidth2
#undef zdepth
#undef yheight
#undef xwidth
#undef priority
#undef material_string
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

/* User declarations for component 'channel_10_cave1_box2' [505]. */
#define mccompcurname  channel_10_cave1_box2
#define mccompcurtype  Union_box
#define mccompcurindex 505
#define loop_index mccchannel_10_cave1_box2_loop_index
#define this_box_volume mccchannel_10_cave1_box2_this_box_volume
#define global_geometry_element mccchannel_10_cave1_box2_global_geometry_element
#define this_box_storage mccchannel_10_cave1_box2_this_box_storage
#define material_string mccchannel_10_cave1_box2_material_string
#define priority mccchannel_10_cave1_box2_priority
#define xwidth mccchannel_10_cave1_box2_xwidth
#define yheight mccchannel_10_cave1_box2_yheight
#define zdepth mccchannel_10_cave1_box2_zdepth
#define xwidth2 mccchannel_10_cave1_box2_xwidth2
#define yheight2 mccchannel_10_cave1_box2_yheight2
#define visualize mccchannel_10_cave1_box2_visualize
#define target_index mccchannel_10_cave1_box2_target_index
#define target_x mccchannel_10_cave1_box2_target_x
#define target_y mccchannel_10_cave1_box2_target_y
#define target_z mccchannel_10_cave1_box2_target_z
#define focus_aw mccchannel_10_cave1_box2_focus_aw
#define focus_ah mccchannel_10_cave1_box2_focus_ah
#define focus_xw mccchannel_10_cave1_box2_focus_xw
#define focus_xh mccchannel_10_cave1_box2_focus_xh
#define focus_r mccchannel_10_cave1_box2_focus_r
#define p_interact mccchannel_10_cave1_box2_p_interact
#define mask_string mccchannel_10_cave1_box2_mask_string
#define mask_setting mccchannel_10_cave1_box2_mask_setting
#define number_of_activations mccchannel_10_cave1_box2_number_of_activations
#line 204 "Union_box.comp"
// Needed for transport to the main component
struct global_geometry_element_struct global_geometry_element;

#ifndef ANY_GEOMETRY_DETECTOR_DECLARE
    #define ANY_GEOMETRY_DETECTOR_DECLARE dummy
	//struct pointer_to_global_geometry_list global_geometry_list = {0,NULL};
#endif

int loop_index,found_geometries;

double x_component;
double y_component;
double z_component;

struct Volume_struct this_box_volume;
struct box_storage this_box_storage;

#line 59249 "MACS_sample_kidney_box.c"
#undef number_of_activations
#undef mask_setting
#undef mask_string
#undef p_interact
#undef focus_r
#undef focus_xh
#undef focus_xw
#undef focus_ah
#undef focus_aw
#undef target_z
#undef target_y
#undef target_x
#undef target_index
#undef visualize
#undef yheight2
#undef xwidth2
#undef zdepth
#undef yheight
#undef xwidth
#undef priority
#undef material_string
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

/* User declarations for component 'channel_10_cave1_box3' [506]. */
#define mccompcurname  channel_10_cave1_box3
#define mccompcurtype  Union_box
#define mccompcurindex 506
#define loop_index mccchannel_10_cave1_box3_loop_index
#define this_box_volume mccchannel_10_cave1_box3_this_box_volume
#define global_geometry_element mccchannel_10_cave1_box3_global_geometry_element
#define this_box_storage mccchannel_10_cave1_box3_this_box_storage
#define material_string mccchannel_10_cave1_box3_material_string
#define priority mccchannel_10_cave1_box3_priority
#define xwidth mccchannel_10_cave1_box3_xwidth
#define yheight mccchannel_10_cave1_box3_yheight
#define zdepth mccchannel_10_cave1_box3_zdepth
#define xwidth2 mccchannel_10_cave1_box3_xwidth2
#define yheight2 mccchannel_10_cave1_box3_yheight2
#define visualize mccchannel_10_cave1_box3_visualize
#define target_index mccchannel_10_cave1_box3_target_index
#define target_x mccchannel_10_cave1_box3_target_x
#define target_y mccchannel_10_cave1_box3_target_y
#define target_z mccchannel_10_cave1_box3_target_z
#define focus_aw mccchannel_10_cave1_box3_focus_aw
#define focus_ah mccchannel_10_cave1_box3_focus_ah
#define focus_xw mccchannel_10_cave1_box3_focus_xw
#define focus_xh mccchannel_10_cave1_box3_focus_xh
#define focus_r mccchannel_10_cave1_box3_focus_r
#define p_interact mccchannel_10_cave1_box3_p_interact
#define mask_string mccchannel_10_cave1_box3_mask_string
#define mask_setting mccchannel_10_cave1_box3_mask_setting
#define number_of_activations mccchannel_10_cave1_box3_number_of_activations
#line 204 "Union_box.comp"
// Needed for transport to the main component
struct global_geometry_element_struct global_geometry_element;

#ifndef ANY_GEOMETRY_DETECTOR_DECLARE
    #define ANY_GEOMETRY_DETECTOR_DECLARE dummy
	//struct pointer_to_global_geometry_list global_geometry_list = {0,NULL};
#endif

int loop_index,found_geometries;

double x_component;
double y_component;
double z_component;

struct Volume_struct this_box_volume;
struct box_storage this_box_storage;

#line 59326 "MACS_sample_kidney_box.c"
#undef number_of_activations
#undef mask_setting
#undef mask_string
#undef p_interact
#undef focus_r
#undef focus_xh
#undef focus_xw
#undef focus_ah
#undef focus_aw
#undef target_z
#undef target_y
#undef target_x
#undef target_index
#undef visualize
#undef yheight2
#undef xwidth2
#undef zdepth
#undef yheight
#undef xwidth
#undef priority
#undef material_string
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

/* User declarations for component 'channel_10_cave1_cyl1' [507]. */
#define mccompcurname  channel_10_cave1_cyl1
#define mccompcurtype  Union_cylinder
#define mccompcurindex 507
#define loop_index mccchannel_10_cave1_cyl1_loop_index
#define this_cylinder_volume mccchannel_10_cave1_cyl1_this_cylinder_volume
#define global_geometry_element mccchannel_10_cave1_cyl1_global_geometry_element
#define this_cylinder_storage mccchannel_10_cave1_cyl1_this_cylinder_storage
#define material_string mccchannel_10_cave1_cyl1_material_string
#define priority mccchannel_10_cave1_cyl1_priority
#define radius mccchannel_10_cave1_cyl1_radius
#define yheight mccchannel_10_cave1_cyl1_yheight
#define visualize mccchannel_10_cave1_cyl1_visualize
#define target_index mccchannel_10_cave1_cyl1_target_index
#define target_x mccchannel_10_cave1_cyl1_target_x
#define target_y mccchannel_10_cave1_cyl1_target_y
#define target_z mccchannel_10_cave1_cyl1_target_z
#define focus_aw mccchannel_10_cave1_cyl1_focus_aw
#define focus_ah mccchannel_10_cave1_cyl1_focus_ah
#define focus_xw mccchannel_10_cave1_cyl1_focus_xw
#define focus_xh mccchannel_10_cave1_cyl1_focus_xh
#define focus_r mccchannel_10_cave1_cyl1_focus_r
#define p_interact mccchannel_10_cave1_cyl1_p_interact
#define mask_string mccchannel_10_cave1_cyl1_mask_string
#define mask_setting mccchannel_10_cave1_cyl1_mask_setting
#define number_of_activations mccchannel_10_cave1_cyl1_number_of_activations
#line 167 "Union_cylinder.comp"
// Needed for transport to the main component
struct global_geometry_element_struct global_geometry_element;

#ifndef ANY_GEOMETRY_DETECTOR_DECLARE
    #define ANY_GEOMETRY_DETECTOR_DECLARE dummy
	//struct pointer_to_global_geometry_list global_geometry_list = {0,NULL};
#endif

int dummy;
int loop_index,found_geometries;
int loop_2_index;
int material_index;

struct Volume_struct this_cylinder_volume;
struct cylinder_storage this_cylinder_storage;
#line 59398 "MACS_sample_kidney_box.c"
#undef number_of_activations
#undef mask_setting
#undef mask_string
#undef p_interact
#undef focus_r
#undef focus_xh
#undef focus_xw
#undef focus_ah
#undef focus_aw
#undef target_z
#undef target_y
#undef target_x
#undef target_index
#undef visualize
#undef yheight
#undef radius
#undef priority
#undef material_string
#undef this_cylinder_storage
#undef global_geometry_element
#undef this_cylinder_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

/* User declarations for component 'channel_10_analyzer_1_center' [508]. */
#define mccompcurname  channel_10_analyzer_1_center
#define mccompcurtype  Arm
#define mccompcurindex 508
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

/* User declarations for component 'channel_10_analyzer_1_rotated' [509]. */
#define mccompcurname  channel_10_analyzer_1_rotated
#define mccompcurtype  Arm
#define mccompcurindex 509
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

/* User declarations for component 'channel_10_analyzer_1_array_crystal_array_0' [510]. */
#define mccompcurname  channel_10_analyzer_1_array_crystal_array_0
#define mccompcurtype  Union_box
#define mccompcurindex 510
#define loop_index mccchannel_10_analyzer_1_array_crystal_array_0_loop_index
#define this_box_volume mccchannel_10_analyzer_1_array_crystal_array_0_this_box_volume
#define global_geometry_element mccchannel_10_analyzer_1_array_crystal_array_0_global_geometry_element
#define this_box_storage mccchannel_10_analyzer_1_array_crystal_array_0_this_box_storage
#define material_string mccchannel_10_analyzer_1_array_crystal_array_0_material_string
#define priority mccchannel_10_analyzer_1_array_crystal_array_0_priority
#define xwidth mccchannel_10_analyzer_1_array_crystal_array_0_xwidth
#define yheight mccchannel_10_analyzer_1_array_crystal_array_0_yheight
#define zdepth mccchannel_10_analyzer_1_array_crystal_array_0_zdepth
#define xwidth2 mccchannel_10_analyzer_1_array_crystal_array_0_xwidth2
#define yheight2 mccchannel_10_analyzer_1_array_crystal_array_0_yheight2
#define visualize mccchannel_10_analyzer_1_array_crystal_array_0_visualize
#define target_index mccchannel_10_analyzer_1_array_crystal_array_0_target_index
#define target_x mccchannel_10_analyzer_1_array_crystal_array_0_target_x
#define target_y mccchannel_10_analyzer_1_array_crystal_array_0_target_y
#define target_z mccchannel_10_analyzer_1_array_crystal_array_0_target_z
#define focus_aw mccchannel_10_analyzer_1_array_crystal_array_0_focus_aw
#define focus_ah mccchannel_10_analyzer_1_array_crystal_array_0_focus_ah
#define focus_xw mccchannel_10_analyzer_1_array_crystal_array_0_focus_xw
#define focus_xh mccchannel_10_analyzer_1_array_crystal_array_0_focus_xh
#define focus_r mccchannel_10_analyzer_1_array_crystal_array_0_focus_r
#define p_interact mccchannel_10_analyzer_1_array_crystal_array_0_p_interact
#define mask_string mccchannel_10_analyzer_1_array_crystal_array_0_mask_string
#define mask_setting mccchannel_10_analyzer_1_array_crystal_array_0_mask_setting
#define number_of_activations mccchannel_10_analyzer_1_array_crystal_array_0_number_of_activations
#line 204 "Union_box.comp"
// Needed for transport to the main component
struct global_geometry_element_struct global_geometry_element;

#ifndef ANY_GEOMETRY_DETECTOR_DECLARE
    #define ANY_GEOMETRY_DETECTOR_DECLARE dummy
	//struct pointer_to_global_geometry_list global_geometry_list = {0,NULL};
#endif

int loop_index,found_geometries;

double x_component;
double y_component;
double z_component;

struct Volume_struct this_box_volume;
struct box_storage this_box_storage;

#line 59488 "MACS_sample_kidney_box.c"
#undef number_of_activations
#undef mask_setting
#undef mask_string
#undef p_interact
#undef focus_r
#undef focus_xh
#undef focus_xw
#undef focus_ah
#undef focus_aw
#undef target_z
#undef target_y
#undef target_x
#undef target_index
#undef visualize
#undef yheight2
#undef xwidth2
#undef zdepth
#undef yheight
#undef xwidth
#undef priority
#undef material_string
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

/* User declarations for component 'channel_10_analyzer_1_array_crystal_array_1' [511]. */
#define mccompcurname  channel_10_analyzer_1_array_crystal_array_1
#define mccompcurtype  Union_box
#define mccompcurindex 511
#define loop_index mccchannel_10_analyzer_1_array_crystal_array_1_loop_index
#define this_box_volume mccchannel_10_analyzer_1_array_crystal_array_1_this_box_volume
#define global_geometry_element mccchannel_10_analyzer_1_array_crystal_array_1_global_geometry_element
#define this_box_storage mccchannel_10_analyzer_1_array_crystal_array_1_this_box_storage
#define material_string mccchannel_10_analyzer_1_array_crystal_array_1_material_string
#define priority mccchannel_10_analyzer_1_array_crystal_array_1_priority
#define xwidth mccchannel_10_analyzer_1_array_crystal_array_1_xwidth
#define yheight mccchannel_10_analyzer_1_array_crystal_array_1_yheight
#define zdepth mccchannel_10_analyzer_1_array_crystal_array_1_zdepth
#define xwidth2 mccchannel_10_analyzer_1_array_crystal_array_1_xwidth2
#define yheight2 mccchannel_10_analyzer_1_array_crystal_array_1_yheight2
#define visualize mccchannel_10_analyzer_1_array_crystal_array_1_visualize
#define target_index mccchannel_10_analyzer_1_array_crystal_array_1_target_index
#define target_x mccchannel_10_analyzer_1_array_crystal_array_1_target_x
#define target_y mccchannel_10_analyzer_1_array_crystal_array_1_target_y
#define target_z mccchannel_10_analyzer_1_array_crystal_array_1_target_z
#define focus_aw mccchannel_10_analyzer_1_array_crystal_array_1_focus_aw
#define focus_ah mccchannel_10_analyzer_1_array_crystal_array_1_focus_ah
#define focus_xw mccchannel_10_analyzer_1_array_crystal_array_1_focus_xw
#define focus_xh mccchannel_10_analyzer_1_array_crystal_array_1_focus_xh
#define focus_r mccchannel_10_analyzer_1_array_crystal_array_1_focus_r
#define p_interact mccchannel_10_analyzer_1_array_crystal_array_1_p_interact
#define mask_string mccchannel_10_analyzer_1_array_crystal_array_1_mask_string
#define mask_setting mccchannel_10_analyzer_1_array_crystal_array_1_mask_setting
#define number_of_activations mccchannel_10_analyzer_1_array_crystal_array_1_number_of_activations
#line 204 "Union_box.comp"
// Needed for transport to the main component
struct global_geometry_element_struct global_geometry_element;

#ifndef ANY_GEOMETRY_DETECTOR_DECLARE
    #define ANY_GEOMETRY_DETECTOR_DECLARE dummy
	//struct pointer_to_global_geometry_list global_geometry_list = {0,NULL};
#endif

int loop_index,found_geometries;

double x_component;
double y_component;
double z_component;

struct Volume_struct this_box_volume;
struct box_storage this_box_storage;

#line 59565 "MACS_sample_kidney_box.c"
#undef number_of_activations
#undef mask_setting
#undef mask_string
#undef p_interact
#undef focus_r
#undef focus_xh
#undef focus_xw
#undef focus_ah
#undef focus_aw
#undef target_z
#undef target_y
#undef target_x
#undef target_index
#undef visualize
#undef yheight2
#undef xwidth2
#undef zdepth
#undef yheight
#undef xwidth
#undef priority
#undef material_string
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

/* User declarations for component 'channel_10_analyzer_1_array_crystal_array_2' [512]. */
#define mccompcurname  channel_10_analyzer_1_array_crystal_array_2
#define mccompcurtype  Union_box
#define mccompcurindex 512
#define loop_index mccchannel_10_analyzer_1_array_crystal_array_2_loop_index
#define this_box_volume mccchannel_10_analyzer_1_array_crystal_array_2_this_box_volume
#define global_geometry_element mccchannel_10_analyzer_1_array_crystal_array_2_global_geometry_element
#define this_box_storage mccchannel_10_analyzer_1_array_crystal_array_2_this_box_storage
#define material_string mccchannel_10_analyzer_1_array_crystal_array_2_material_string
#define priority mccchannel_10_analyzer_1_array_crystal_array_2_priority
#define xwidth mccchannel_10_analyzer_1_array_crystal_array_2_xwidth
#define yheight mccchannel_10_analyzer_1_array_crystal_array_2_yheight
#define zdepth mccchannel_10_analyzer_1_array_crystal_array_2_zdepth
#define xwidth2 mccchannel_10_analyzer_1_array_crystal_array_2_xwidth2
#define yheight2 mccchannel_10_analyzer_1_array_crystal_array_2_yheight2
#define visualize mccchannel_10_analyzer_1_array_crystal_array_2_visualize
#define target_index mccchannel_10_analyzer_1_array_crystal_array_2_target_index
#define target_x mccchannel_10_analyzer_1_array_crystal_array_2_target_x
#define target_y mccchannel_10_analyzer_1_array_crystal_array_2_target_y
#define target_z mccchannel_10_analyzer_1_array_crystal_array_2_target_z
#define focus_aw mccchannel_10_analyzer_1_array_crystal_array_2_focus_aw
#define focus_ah mccchannel_10_analyzer_1_array_crystal_array_2_focus_ah
#define focus_xw mccchannel_10_analyzer_1_array_crystal_array_2_focus_xw
#define focus_xh mccchannel_10_analyzer_1_array_crystal_array_2_focus_xh
#define focus_r mccchannel_10_analyzer_1_array_crystal_array_2_focus_r
#define p_interact mccchannel_10_analyzer_1_array_crystal_array_2_p_interact
#define mask_string mccchannel_10_analyzer_1_array_crystal_array_2_mask_string
#define mask_setting mccchannel_10_analyzer_1_array_crystal_array_2_mask_setting
#define number_of_activations mccchannel_10_analyzer_1_array_crystal_array_2_number_of_activations
#line 204 "Union_box.comp"
// Needed for transport to the main component
struct global_geometry_element_struct global_geometry_element;

#ifndef ANY_GEOMETRY_DETECTOR_DECLARE
    #define ANY_GEOMETRY_DETECTOR_DECLARE dummy
	//struct pointer_to_global_geometry_list global_geometry_list = {0,NULL};
#endif

int loop_index,found_geometries;

double x_component;
double y_component;
double z_component;

struct Volume_struct this_box_volume;
struct box_storage this_box_storage;

#line 59642 "MACS_sample_kidney_box.c"
#undef number_of_activations
#undef mask_setting
#undef mask_string
#undef p_interact
#undef focus_r
#undef focus_xh
#undef focus_xw
#undef focus_ah
#undef focus_aw
#undef target_z
#undef target_y
#undef target_x
#undef target_index
#undef visualize
#undef yheight2
#undef xwidth2
#undef zdepth
#undef yheight
#undef xwidth
#undef priority
#undef material_string
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

/* User declarations for component 'channel_10_analyzer_1_array_crystal_array_3' [513]. */
#define mccompcurname  channel_10_analyzer_1_array_crystal_array_3
#define mccompcurtype  Union_box
#define mccompcurindex 513
#define loop_index mccchannel_10_analyzer_1_array_crystal_array_3_loop_index
#define this_box_volume mccchannel_10_analyzer_1_array_crystal_array_3_this_box_volume
#define global_geometry_element mccchannel_10_analyzer_1_array_crystal_array_3_global_geometry_element
#define this_box_storage mccchannel_10_analyzer_1_array_crystal_array_3_this_box_storage
#define material_string mccchannel_10_analyzer_1_array_crystal_array_3_material_string
#define priority mccchannel_10_analyzer_1_array_crystal_array_3_priority
#define xwidth mccchannel_10_analyzer_1_array_crystal_array_3_xwidth
#define yheight mccchannel_10_analyzer_1_array_crystal_array_3_yheight
#define zdepth mccchannel_10_analyzer_1_array_crystal_array_3_zdepth
#define xwidth2 mccchannel_10_analyzer_1_array_crystal_array_3_xwidth2
#define yheight2 mccchannel_10_analyzer_1_array_crystal_array_3_yheight2
#define visualize mccchannel_10_analyzer_1_array_crystal_array_3_visualize
#define target_index mccchannel_10_analyzer_1_array_crystal_array_3_target_index
#define target_x mccchannel_10_analyzer_1_array_crystal_array_3_target_x
#define target_y mccchannel_10_analyzer_1_array_crystal_array_3_target_y
#define target_z mccchannel_10_analyzer_1_array_crystal_array_3_target_z
#define focus_aw mccchannel_10_analyzer_1_array_crystal_array_3_focus_aw
#define focus_ah mccchannel_10_analyzer_1_array_crystal_array_3_focus_ah
#define focus_xw mccchannel_10_analyzer_1_array_crystal_array_3_focus_xw
#define focus_xh mccchannel_10_analyzer_1_array_crystal_array_3_focus_xh
#define focus_r mccchannel_10_analyzer_1_array_crystal_array_3_focus_r
#define p_interact mccchannel_10_analyzer_1_array_crystal_array_3_p_interact
#define mask_string mccchannel_10_analyzer_1_array_crystal_array_3_mask_string
#define mask_setting mccchannel_10_analyzer_1_array_crystal_array_3_mask_setting
#define number_of_activations mccchannel_10_analyzer_1_array_crystal_array_3_number_of_activations
#line 204 "Union_box.comp"
// Needed for transport to the main component
struct global_geometry_element_struct global_geometry_element;

#ifndef ANY_GEOMETRY_DETECTOR_DECLARE
    #define ANY_GEOMETRY_DETECTOR_DECLARE dummy
	//struct pointer_to_global_geometry_list global_geometry_list = {0,NULL};
#endif

int loop_index,found_geometries;

double x_component;
double y_component;
double z_component;

struct Volume_struct this_box_volume;
struct box_storage this_box_storage;

#line 59719 "MACS_sample_kidney_box.c"
#undef number_of_activations
#undef mask_setting
#undef mask_string
#undef p_interact
#undef focus_r
#undef focus_xh
#undef focus_xw
#undef focus_ah
#undef focus_aw
#undef target_z
#undef target_y
#undef target_x
#undef target_index
#undef visualize
#undef yheight2
#undef xwidth2
#undef zdepth
#undef yheight
#undef xwidth
#undef priority
#undef material_string
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

/* User declarations for component 'channel_10_analyzer_1_array_crystal_array_4' [514]. */
#define mccompcurname  channel_10_analyzer_1_array_crystal_array_4
#define mccompcurtype  Union_box
#define mccompcurindex 514
#define loop_index mccchannel_10_analyzer_1_array_crystal_array_4_loop_index
#define this_box_volume mccchannel_10_analyzer_1_array_crystal_array_4_this_box_volume
#define global_geometry_element mccchannel_10_analyzer_1_array_crystal_array_4_global_geometry_element
#define this_box_storage mccchannel_10_analyzer_1_array_crystal_array_4_this_box_storage
#define material_string mccchannel_10_analyzer_1_array_crystal_array_4_material_string
#define priority mccchannel_10_analyzer_1_array_crystal_array_4_priority
#define xwidth mccchannel_10_analyzer_1_array_crystal_array_4_xwidth
#define yheight mccchannel_10_analyzer_1_array_crystal_array_4_yheight
#define zdepth mccchannel_10_analyzer_1_array_crystal_array_4_zdepth
#define xwidth2 mccchannel_10_analyzer_1_array_crystal_array_4_xwidth2
#define yheight2 mccchannel_10_analyzer_1_array_crystal_array_4_yheight2
#define visualize mccchannel_10_analyzer_1_array_crystal_array_4_visualize
#define target_index mccchannel_10_analyzer_1_array_crystal_array_4_target_index
#define target_x mccchannel_10_analyzer_1_array_crystal_array_4_target_x
#define target_y mccchannel_10_analyzer_1_array_crystal_array_4_target_y
#define target_z mccchannel_10_analyzer_1_array_crystal_array_4_target_z
#define focus_aw mccchannel_10_analyzer_1_array_crystal_array_4_focus_aw
#define focus_ah mccchannel_10_analyzer_1_array_crystal_array_4_focus_ah
#define focus_xw mccchannel_10_analyzer_1_array_crystal_array_4_focus_xw
#define focus_xh mccchannel_10_analyzer_1_array_crystal_array_4_focus_xh
#define focus_r mccchannel_10_analyzer_1_array_crystal_array_4_focus_r
#define p_interact mccchannel_10_analyzer_1_array_crystal_array_4_p_interact
#define mask_string mccchannel_10_analyzer_1_array_crystal_array_4_mask_string
#define mask_setting mccchannel_10_analyzer_1_array_crystal_array_4_mask_setting
#define number_of_activations mccchannel_10_analyzer_1_array_crystal_array_4_number_of_activations
#line 204 "Union_box.comp"
// Needed for transport to the main component
struct global_geometry_element_struct global_geometry_element;

#ifndef ANY_GEOMETRY_DETECTOR_DECLARE
    #define ANY_GEOMETRY_DETECTOR_DECLARE dummy
	//struct pointer_to_global_geometry_list global_geometry_list = {0,NULL};
#endif

int loop_index,found_geometries;

double x_component;
double y_component;
double z_component;

struct Volume_struct this_box_volume;
struct box_storage this_box_storage;

#line 59796 "MACS_sample_kidney_box.c"
#undef number_of_activations
#undef mask_setting
#undef mask_string
#undef p_interact
#undef focus_r
#undef focus_xh
#undef focus_xw
#undef focus_ah
#undef focus_aw
#undef target_z
#undef target_y
#undef target_x
#undef target_index
#undef visualize
#undef yheight2
#undef xwidth2
#undef zdepth
#undef yheight
#undef xwidth
#undef priority
#undef material_string
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

/* User declarations for component 'channel_10_analyzer_1_array_crystal_array_5' [515]. */
#define mccompcurname  channel_10_analyzer_1_array_crystal_array_5
#define mccompcurtype  Union_box
#define mccompcurindex 515
#define loop_index mccchannel_10_analyzer_1_array_crystal_array_5_loop_index
#define this_box_volume mccchannel_10_analyzer_1_array_crystal_array_5_this_box_volume
#define global_geometry_element mccchannel_10_analyzer_1_array_crystal_array_5_global_geometry_element
#define this_box_storage mccchannel_10_analyzer_1_array_crystal_array_5_this_box_storage
#define material_string mccchannel_10_analyzer_1_array_crystal_array_5_material_string
#define priority mccchannel_10_analyzer_1_array_crystal_array_5_priority
#define xwidth mccchannel_10_analyzer_1_array_crystal_array_5_xwidth
#define yheight mccchannel_10_analyzer_1_array_crystal_array_5_yheight
#define zdepth mccchannel_10_analyzer_1_array_crystal_array_5_zdepth
#define xwidth2 mccchannel_10_analyzer_1_array_crystal_array_5_xwidth2
#define yheight2 mccchannel_10_analyzer_1_array_crystal_array_5_yheight2
#define visualize mccchannel_10_analyzer_1_array_crystal_array_5_visualize
#define target_index mccchannel_10_analyzer_1_array_crystal_array_5_target_index
#define target_x mccchannel_10_analyzer_1_array_crystal_array_5_target_x
#define target_y mccchannel_10_analyzer_1_array_crystal_array_5_target_y
#define target_z mccchannel_10_analyzer_1_array_crystal_array_5_target_z
#define focus_aw mccchannel_10_analyzer_1_array_crystal_array_5_focus_aw
#define focus_ah mccchannel_10_analyzer_1_array_crystal_array_5_focus_ah
#define focus_xw mccchannel_10_analyzer_1_array_crystal_array_5_focus_xw
#define focus_xh mccchannel_10_analyzer_1_array_crystal_array_5_focus_xh
#define focus_r mccchannel_10_analyzer_1_array_crystal_array_5_focus_r
#define p_interact mccchannel_10_analyzer_1_array_crystal_array_5_p_interact
#define mask_string mccchannel_10_analyzer_1_array_crystal_array_5_mask_string
#define mask_setting mccchannel_10_analyzer_1_array_crystal_array_5_mask_setting
#define number_of_activations mccchannel_10_analyzer_1_array_crystal_array_5_number_of_activations
#line 204 "Union_box.comp"
// Needed for transport to the main component
struct global_geometry_element_struct global_geometry_element;

#ifndef ANY_GEOMETRY_DETECTOR_DECLARE
    #define ANY_GEOMETRY_DETECTOR_DECLARE dummy
	//struct pointer_to_global_geometry_list global_geometry_list = {0,NULL};
#endif

int loop_index,found_geometries;

double x_component;
double y_component;
double z_component;

struct Volume_struct this_box_volume;
struct box_storage this_box_storage;

#line 59873 "MACS_sample_kidney_box.c"
#undef number_of_activations
#undef mask_setting
#undef mask_string
#undef p_interact
#undef focus_r
#undef focus_xh
#undef focus_xw
#undef focus_ah
#undef focus_aw
#undef target_z
#undef target_y
#undef target_x
#undef target_index
#undef visualize
#undef yheight2
#undef xwidth2
#undef zdepth
#undef yheight
#undef xwidth
#undef priority
#undef material_string
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

/* User declarations for component 'channel_10_analyzer_1_array_crystal_array_6' [516]. */
#define mccompcurname  channel_10_analyzer_1_array_crystal_array_6
#define mccompcurtype  Union_box
#define mccompcurindex 516
#define loop_index mccchannel_10_analyzer_1_array_crystal_array_6_loop_index
#define this_box_volume mccchannel_10_analyzer_1_array_crystal_array_6_this_box_volume
#define global_geometry_element mccchannel_10_analyzer_1_array_crystal_array_6_global_geometry_element
#define this_box_storage mccchannel_10_analyzer_1_array_crystal_array_6_this_box_storage
#define material_string mccchannel_10_analyzer_1_array_crystal_array_6_material_string
#define priority mccchannel_10_analyzer_1_array_crystal_array_6_priority
#define xwidth mccchannel_10_analyzer_1_array_crystal_array_6_xwidth
#define yheight mccchannel_10_analyzer_1_array_crystal_array_6_yheight
#define zdepth mccchannel_10_analyzer_1_array_crystal_array_6_zdepth
#define xwidth2 mccchannel_10_analyzer_1_array_crystal_array_6_xwidth2
#define yheight2 mccchannel_10_analyzer_1_array_crystal_array_6_yheight2
#define visualize mccchannel_10_analyzer_1_array_crystal_array_6_visualize
#define target_index mccchannel_10_analyzer_1_array_crystal_array_6_target_index
#define target_x mccchannel_10_analyzer_1_array_crystal_array_6_target_x
#define target_y mccchannel_10_analyzer_1_array_crystal_array_6_target_y
#define target_z mccchannel_10_analyzer_1_array_crystal_array_6_target_z
#define focus_aw mccchannel_10_analyzer_1_array_crystal_array_6_focus_aw
#define focus_ah mccchannel_10_analyzer_1_array_crystal_array_6_focus_ah
#define focus_xw mccchannel_10_analyzer_1_array_crystal_array_6_focus_xw
#define focus_xh mccchannel_10_analyzer_1_array_crystal_array_6_focus_xh
#define focus_r mccchannel_10_analyzer_1_array_crystal_array_6_focus_r
#define p_interact mccchannel_10_analyzer_1_array_crystal_array_6_p_interact
#define mask_string mccchannel_10_analyzer_1_array_crystal_array_6_mask_string
#define mask_setting mccchannel_10_analyzer_1_array_crystal_array_6_mask_setting
#define number_of_activations mccchannel_10_analyzer_1_array_crystal_array_6_number_of_activations
#line 204 "Union_box.comp"
// Needed for transport to the main component
struct global_geometry_element_struct global_geometry_element;

#ifndef ANY_GEOMETRY_DETECTOR_DECLARE
    #define ANY_GEOMETRY_DETECTOR_DECLARE dummy
	//struct pointer_to_global_geometry_list global_geometry_list = {0,NULL};
#endif

int loop_index,found_geometries;

double x_component;
double y_component;
double z_component;

struct Volume_struct this_box_volume;
struct box_storage this_box_storage;

#line 59950 "MACS_sample_kidney_box.c"
#undef number_of_activations
#undef mask_setting
#undef mask_string
#undef p_interact
#undef focus_r
#undef focus_xh
#undef focus_xw
#undef focus_ah
#undef focus_aw
#undef target_z
#undef target_y
#undef target_x
#undef target_index
#undef visualize
#undef yheight2
#undef xwidth2
#undef zdepth
#undef yheight
#undef xwidth
#undef priority
#undef material_string
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

/* User declarations for component 'channel_10_analyzer_1_array_crystal_array_7' [517]. */
#define mccompcurname  channel_10_analyzer_1_array_crystal_array_7
#define mccompcurtype  Union_box
#define mccompcurindex 517
#define loop_index mccchannel_10_analyzer_1_array_crystal_array_7_loop_index
#define this_box_volume mccchannel_10_analyzer_1_array_crystal_array_7_this_box_volume
#define global_geometry_element mccchannel_10_analyzer_1_array_crystal_array_7_global_geometry_element
#define this_box_storage mccchannel_10_analyzer_1_array_crystal_array_7_this_box_storage
#define material_string mccchannel_10_analyzer_1_array_crystal_array_7_material_string
#define priority mccchannel_10_analyzer_1_array_crystal_array_7_priority
#define xwidth mccchannel_10_analyzer_1_array_crystal_array_7_xwidth
#define yheight mccchannel_10_analyzer_1_array_crystal_array_7_yheight
#define zdepth mccchannel_10_analyzer_1_array_crystal_array_7_zdepth
#define xwidth2 mccchannel_10_analyzer_1_array_crystal_array_7_xwidth2
#define yheight2 mccchannel_10_analyzer_1_array_crystal_array_7_yheight2
#define visualize mccchannel_10_analyzer_1_array_crystal_array_7_visualize
#define target_index mccchannel_10_analyzer_1_array_crystal_array_7_target_index
#define target_x mccchannel_10_analyzer_1_array_crystal_array_7_target_x
#define target_y mccchannel_10_analyzer_1_array_crystal_array_7_target_y
#define target_z mccchannel_10_analyzer_1_array_crystal_array_7_target_z
#define focus_aw mccchannel_10_analyzer_1_array_crystal_array_7_focus_aw
#define focus_ah mccchannel_10_analyzer_1_array_crystal_array_7_focus_ah
#define focus_xw mccchannel_10_analyzer_1_array_crystal_array_7_focus_xw
#define focus_xh mccchannel_10_analyzer_1_array_crystal_array_7_focus_xh
#define focus_r mccchannel_10_analyzer_1_array_crystal_array_7_focus_r
#define p_interact mccchannel_10_analyzer_1_array_crystal_array_7_p_interact
#define mask_string mccchannel_10_analyzer_1_array_crystal_array_7_mask_string
#define mask_setting mccchannel_10_analyzer_1_array_crystal_array_7_mask_setting
#define number_of_activations mccchannel_10_analyzer_1_array_crystal_array_7_number_of_activations
#line 204 "Union_box.comp"
// Needed for transport to the main component
struct global_geometry_element_struct global_geometry_element;

#ifndef ANY_GEOMETRY_DETECTOR_DECLARE
    #define ANY_GEOMETRY_DETECTOR_DECLARE dummy
	//struct pointer_to_global_geometry_list global_geometry_list = {0,NULL};
#endif

int loop_index,found_geometries;

double x_component;
double y_component;
double z_component;

struct Volume_struct this_box_volume;
struct box_storage this_box_storage;

#line 60027 "MACS_sample_kidney_box.c"
#undef number_of_activations
#undef mask_setting
#undef mask_string
#undef p_interact
#undef focus_r
#undef focus_xh
#undef focus_xw
#undef focus_ah
#undef focus_aw
#undef target_z
#undef target_y
#undef target_x
#undef target_index
#undef visualize
#undef yheight2
#undef xwidth2
#undef zdepth
#undef yheight
#undef xwidth
#undef priority
#undef material_string
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

/* User declarations for component 'channel_10_analyzer_1_array_crystal_array_8' [518]. */
#define mccompcurname  channel_10_analyzer_1_array_crystal_array_8
#define mccompcurtype  Union_box
#define mccompcurindex 518
#define loop_index mccchannel_10_analyzer_1_array_crystal_array_8_loop_index
#define this_box_volume mccchannel_10_analyzer_1_array_crystal_array_8_this_box_volume
#define global_geometry_element mccchannel_10_analyzer_1_array_crystal_array_8_global_geometry_element
#define this_box_storage mccchannel_10_analyzer_1_array_crystal_array_8_this_box_storage
#define material_string mccchannel_10_analyzer_1_array_crystal_array_8_material_string
#define priority mccchannel_10_analyzer_1_array_crystal_array_8_priority
#define xwidth mccchannel_10_analyzer_1_array_crystal_array_8_xwidth
#define yheight mccchannel_10_analyzer_1_array_crystal_array_8_yheight
#define zdepth mccchannel_10_analyzer_1_array_crystal_array_8_zdepth
#define xwidth2 mccchannel_10_analyzer_1_array_crystal_array_8_xwidth2
#define yheight2 mccchannel_10_analyzer_1_array_crystal_array_8_yheight2
#define visualize mccchannel_10_analyzer_1_array_crystal_array_8_visualize
#define target_index mccchannel_10_analyzer_1_array_crystal_array_8_target_index
#define target_x mccchannel_10_analyzer_1_array_crystal_array_8_target_x
#define target_y mccchannel_10_analyzer_1_array_crystal_array_8_target_y
#define target_z mccchannel_10_analyzer_1_array_crystal_array_8_target_z
#define focus_aw mccchannel_10_analyzer_1_array_crystal_array_8_focus_aw
#define focus_ah mccchannel_10_analyzer_1_array_crystal_array_8_focus_ah
#define focus_xw mccchannel_10_analyzer_1_array_crystal_array_8_focus_xw
#define focus_xh mccchannel_10_analyzer_1_array_crystal_array_8_focus_xh
#define focus_r mccchannel_10_analyzer_1_array_crystal_array_8_focus_r
#define p_interact mccchannel_10_analyzer_1_array_crystal_array_8_p_interact
#define mask_string mccchannel_10_analyzer_1_array_crystal_array_8_mask_string
#define mask_setting mccchannel_10_analyzer_1_array_crystal_array_8_mask_setting
#define number_of_activations mccchannel_10_analyzer_1_array_crystal_array_8_number_of_activations
#line 204 "Union_box.comp"
// Needed for transport to the main component
struct global_geometry_element_struct global_geometry_element;

#ifndef ANY_GEOMETRY_DETECTOR_DECLARE
    #define ANY_GEOMETRY_DETECTOR_DECLARE dummy
	//struct pointer_to_global_geometry_list global_geometry_list = {0,NULL};
#endif

int loop_index,found_geometries;

double x_component;
double y_component;
double z_component;

struct Volume_struct this_box_volume;
struct box_storage this_box_storage;

#line 60104 "MACS_sample_kidney_box.c"
#undef number_of_activations
#undef mask_setting
#undef mask_string
#undef p_interact
#undef focus_r
#undef focus_xh
#undef focus_xw
#undef focus_ah
#undef focus_aw
#undef target_z
#undef target_y
#undef target_x
#undef target_index
#undef visualize
#undef yheight2
#undef xwidth2
#undef zdepth
#undef yheight
#undef xwidth
#undef priority
#undef material_string
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

/* User declarations for component 'channel_10_analyzer_2_center' [519]. */
#define mccompcurname  channel_10_analyzer_2_center
#define mccompcurtype  Arm
#define mccompcurindex 519
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

/* User declarations for component 'channel_10_analyzer_2_rotated' [520]. */
#define mccompcurname  channel_10_analyzer_2_rotated
#define mccompcurtype  Arm
#define mccompcurindex 520
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

/* User declarations for component 'channel_10_analyzer_2_array_crystal_array_0' [521]. */
#define mccompcurname  channel_10_analyzer_2_array_crystal_array_0
#define mccompcurtype  Union_box
#define mccompcurindex 521
#define loop_index mccchannel_10_analyzer_2_array_crystal_array_0_loop_index
#define this_box_volume mccchannel_10_analyzer_2_array_crystal_array_0_this_box_volume
#define global_geometry_element mccchannel_10_analyzer_2_array_crystal_array_0_global_geometry_element
#define this_box_storage mccchannel_10_analyzer_2_array_crystal_array_0_this_box_storage
#define material_string mccchannel_10_analyzer_2_array_crystal_array_0_material_string
#define priority mccchannel_10_analyzer_2_array_crystal_array_0_priority
#define xwidth mccchannel_10_analyzer_2_array_crystal_array_0_xwidth
#define yheight mccchannel_10_analyzer_2_array_crystal_array_0_yheight
#define zdepth mccchannel_10_analyzer_2_array_crystal_array_0_zdepth
#define xwidth2 mccchannel_10_analyzer_2_array_crystal_array_0_xwidth2
#define yheight2 mccchannel_10_analyzer_2_array_crystal_array_0_yheight2
#define visualize mccchannel_10_analyzer_2_array_crystal_array_0_visualize
#define target_index mccchannel_10_analyzer_2_array_crystal_array_0_target_index
#define target_x mccchannel_10_analyzer_2_array_crystal_array_0_target_x
#define target_y mccchannel_10_analyzer_2_array_crystal_array_0_target_y
#define target_z mccchannel_10_analyzer_2_array_crystal_array_0_target_z
#define focus_aw mccchannel_10_analyzer_2_array_crystal_array_0_focus_aw
#define focus_ah mccchannel_10_analyzer_2_array_crystal_array_0_focus_ah
#define focus_xw mccchannel_10_analyzer_2_array_crystal_array_0_focus_xw
#define focus_xh mccchannel_10_analyzer_2_array_crystal_array_0_focus_xh
#define focus_r mccchannel_10_analyzer_2_array_crystal_array_0_focus_r
#define p_interact mccchannel_10_analyzer_2_array_crystal_array_0_p_interact
#define mask_string mccchannel_10_analyzer_2_array_crystal_array_0_mask_string
#define mask_setting mccchannel_10_analyzer_2_array_crystal_array_0_mask_setting
#define number_of_activations mccchannel_10_analyzer_2_array_crystal_array_0_number_of_activations
#line 204 "Union_box.comp"
// Needed for transport to the main component
struct global_geometry_element_struct global_geometry_element;

#ifndef ANY_GEOMETRY_DETECTOR_DECLARE
    #define ANY_GEOMETRY_DETECTOR_DECLARE dummy
	//struct pointer_to_global_geometry_list global_geometry_list = {0,NULL};
#endif

int loop_index,found_geometries;

double x_component;
double y_component;
double z_component;

struct Volume_struct this_box_volume;
struct box_storage this_box_storage;

#line 60197 "MACS_sample_kidney_box.c"
#undef number_of_activations
#undef mask_setting
#undef mask_string
#undef p_interact
#undef focus_r
#undef focus_xh
#undef focus_xw
#undef focus_ah
#undef focus_aw
#undef target_z
#undef target_y
#undef target_x
#undef target_index
#undef visualize
#undef yheight2
#undef xwidth2
#undef zdepth
#undef yheight
#undef xwidth
#undef priority
#undef material_string
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

/* User declarations for component 'channel_10_analyzer_2_array_crystal_array_1' [522]. */
#define mccompcurname  channel_10_analyzer_2_array_crystal_array_1
#define mccompcurtype  Union_box
#define mccompcurindex 522
#define loop_index mccchannel_10_analyzer_2_array_crystal_array_1_loop_index
#define this_box_volume mccchannel_10_analyzer_2_array_crystal_array_1_this_box_volume
#define global_geometry_element mccchannel_10_analyzer_2_array_crystal_array_1_global_geometry_element
#define this_box_storage mccchannel_10_analyzer_2_array_crystal_array_1_this_box_storage
#define material_string mccchannel_10_analyzer_2_array_crystal_array_1_material_string
#define priority mccchannel_10_analyzer_2_array_crystal_array_1_priority
#define xwidth mccchannel_10_analyzer_2_array_crystal_array_1_xwidth
#define yheight mccchannel_10_analyzer_2_array_crystal_array_1_yheight
#define zdepth mccchannel_10_analyzer_2_array_crystal_array_1_zdepth
#define xwidth2 mccchannel_10_analyzer_2_array_crystal_array_1_xwidth2
#define yheight2 mccchannel_10_analyzer_2_array_crystal_array_1_yheight2
#define visualize mccchannel_10_analyzer_2_array_crystal_array_1_visualize
#define target_index mccchannel_10_analyzer_2_array_crystal_array_1_target_index
#define target_x mccchannel_10_analyzer_2_array_crystal_array_1_target_x
#define target_y mccchannel_10_analyzer_2_array_crystal_array_1_target_y
#define target_z mccchannel_10_analyzer_2_array_crystal_array_1_target_z
#define focus_aw mccchannel_10_analyzer_2_array_crystal_array_1_focus_aw
#define focus_ah mccchannel_10_analyzer_2_array_crystal_array_1_focus_ah
#define focus_xw mccchannel_10_analyzer_2_array_crystal_array_1_focus_xw
#define focus_xh mccchannel_10_analyzer_2_array_crystal_array_1_focus_xh
#define focus_r mccchannel_10_analyzer_2_array_crystal_array_1_focus_r
#define p_interact mccchannel_10_analyzer_2_array_crystal_array_1_p_interact
#define mask_string mccchannel_10_analyzer_2_array_crystal_array_1_mask_string
#define mask_setting mccchannel_10_analyzer_2_array_crystal_array_1_mask_setting
#define number_of_activations mccchannel_10_analyzer_2_array_crystal_array_1_number_of_activations
#line 204 "Union_box.comp"
// Needed for transport to the main component
struct global_geometry_element_struct global_geometry_element;

#ifndef ANY_GEOMETRY_DETECTOR_DECLARE
    #define ANY_GEOMETRY_DETECTOR_DECLARE dummy
	//struct pointer_to_global_geometry_list global_geometry_list = {0,NULL};
#endif

int loop_index,found_geometries;

double x_component;
double y_component;
double z_component;

struct Volume_struct this_box_volume;
struct box_storage this_box_storage;

#line 60274 "MACS_sample_kidney_box.c"
#undef number_of_activations
#undef mask_setting
#undef mask_string
#undef p_interact
#undef focus_r
#undef focus_xh
#undef focus_xw
#undef focus_ah
#undef focus_aw
#undef target_z
#undef target_y
#undef target_x
#undef target_index
#undef visualize
#undef yheight2
#undef xwidth2
#undef zdepth
#undef yheight
#undef xwidth
#undef priority
#undef material_string
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

/* User declarations for component 'channel_10_analyzer_2_array_crystal_array_2' [523]. */
#define mccompcurname  channel_10_analyzer_2_array_crystal_array_2
#define mccompcurtype  Union_box
#define mccompcurindex 523
#define loop_index mccchannel_10_analyzer_2_array_crystal_array_2_loop_index
#define this_box_volume mccchannel_10_analyzer_2_array_crystal_array_2_this_box_volume
#define global_geometry_element mccchannel_10_analyzer_2_array_crystal_array_2_global_geometry_element
#define this_box_storage mccchannel_10_analyzer_2_array_crystal_array_2_this_box_storage
#define material_string mccchannel_10_analyzer_2_array_crystal_array_2_material_string
#define priority mccchannel_10_analyzer_2_array_crystal_array_2_priority
#define xwidth mccchannel_10_analyzer_2_array_crystal_array_2_xwidth
#define yheight mccchannel_10_analyzer_2_array_crystal_array_2_yheight
#define zdepth mccchannel_10_analyzer_2_array_crystal_array_2_zdepth
#define xwidth2 mccchannel_10_analyzer_2_array_crystal_array_2_xwidth2
#define yheight2 mccchannel_10_analyzer_2_array_crystal_array_2_yheight2
#define visualize mccchannel_10_analyzer_2_array_crystal_array_2_visualize
#define target_index mccchannel_10_analyzer_2_array_crystal_array_2_target_index
#define target_x mccchannel_10_analyzer_2_array_crystal_array_2_target_x
#define target_y mccchannel_10_analyzer_2_array_crystal_array_2_target_y
#define target_z mccchannel_10_analyzer_2_array_crystal_array_2_target_z
#define focus_aw mccchannel_10_analyzer_2_array_crystal_array_2_focus_aw
#define focus_ah mccchannel_10_analyzer_2_array_crystal_array_2_focus_ah
#define focus_xw mccchannel_10_analyzer_2_array_crystal_array_2_focus_xw
#define focus_xh mccchannel_10_analyzer_2_array_crystal_array_2_focus_xh
#define focus_r mccchannel_10_analyzer_2_array_crystal_array_2_focus_r
#define p_interact mccchannel_10_analyzer_2_array_crystal_array_2_p_interact
#define mask_string mccchannel_10_analyzer_2_array_crystal_array_2_mask_string
#define mask_setting mccchannel_10_analyzer_2_array_crystal_array_2_mask_setting
#define number_of_activations mccchannel_10_analyzer_2_array_crystal_array_2_number_of_activations
#line 204 "Union_box.comp"
// Needed for transport to the main component
struct global_geometry_element_struct global_geometry_element;

#ifndef ANY_GEOMETRY_DETECTOR_DECLARE
    #define ANY_GEOMETRY_DETECTOR_DECLARE dummy
	//struct pointer_to_global_geometry_list global_geometry_list = {0,NULL};
#endif

int loop_index,found_geometries;

double x_component;
double y_component;
double z_component;

struct Volume_struct this_box_volume;
struct box_storage this_box_storage;

#line 60351 "MACS_sample_kidney_box.c"
#undef number_of_activations
#undef mask_setting
#undef mask_string
#undef p_interact
#undef focus_r
#undef focus_xh
#undef focus_xw
#undef focus_ah
#undef focus_aw
#undef target_z
#undef target_y
#undef target_x
#undef target_index
#undef visualize
#undef yheight2
#undef xwidth2
#undef zdepth
#undef yheight
#undef xwidth
#undef priority
#undef material_string
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

/* User declarations for component 'channel_10_analyzer_2_array_crystal_array_3' [524]. */
#define mccompcurname  channel_10_analyzer_2_array_crystal_array_3
#define mccompcurtype  Union_box
#define mccompcurindex 524
#define loop_index mccchannel_10_analyzer_2_array_crystal_array_3_loop_index
#define this_box_volume mccchannel_10_analyzer_2_array_crystal_array_3_this_box_volume
#define global_geometry_element mccchannel_10_analyzer_2_array_crystal_array_3_global_geometry_element
#define this_box_storage mccchannel_10_analyzer_2_array_crystal_array_3_this_box_storage
#define material_string mccchannel_10_analyzer_2_array_crystal_array_3_material_string
#define priority mccchannel_10_analyzer_2_array_crystal_array_3_priority
#define xwidth mccchannel_10_analyzer_2_array_crystal_array_3_xwidth
#define yheight mccchannel_10_analyzer_2_array_crystal_array_3_yheight
#define zdepth mccchannel_10_analyzer_2_array_crystal_array_3_zdepth
#define xwidth2 mccchannel_10_analyzer_2_array_crystal_array_3_xwidth2
#define yheight2 mccchannel_10_analyzer_2_array_crystal_array_3_yheight2
#define visualize mccchannel_10_analyzer_2_array_crystal_array_3_visualize
#define target_index mccchannel_10_analyzer_2_array_crystal_array_3_target_index
#define target_x mccchannel_10_analyzer_2_array_crystal_array_3_target_x
#define target_y mccchannel_10_analyzer_2_array_crystal_array_3_target_y
#define target_z mccchannel_10_analyzer_2_array_crystal_array_3_target_z
#define focus_aw mccchannel_10_analyzer_2_array_crystal_array_3_focus_aw
#define focus_ah mccchannel_10_analyzer_2_array_crystal_array_3_focus_ah
#define focus_xw mccchannel_10_analyzer_2_array_crystal_array_3_focus_xw
#define focus_xh mccchannel_10_analyzer_2_array_crystal_array_3_focus_xh
#define focus_r mccchannel_10_analyzer_2_array_crystal_array_3_focus_r
#define p_interact mccchannel_10_analyzer_2_array_crystal_array_3_p_interact
#define mask_string mccchannel_10_analyzer_2_array_crystal_array_3_mask_string
#define mask_setting mccchannel_10_analyzer_2_array_crystal_array_3_mask_setting
#define number_of_activations mccchannel_10_analyzer_2_array_crystal_array_3_number_of_activations
#line 204 "Union_box.comp"
// Needed for transport to the main component
struct global_geometry_element_struct global_geometry_element;

#ifndef ANY_GEOMETRY_DETECTOR_DECLARE
    #define ANY_GEOMETRY_DETECTOR_DECLARE dummy
	//struct pointer_to_global_geometry_list global_geometry_list = {0,NULL};
#endif

int loop_index,found_geometries;

double x_component;
double y_component;
double z_component;

struct Volume_struct this_box_volume;
struct box_storage this_box_storage;

#line 60428 "MACS_sample_kidney_box.c"
#undef number_of_activations
#undef mask_setting
#undef mask_string
#undef p_interact
#undef focus_r
#undef focus_xh
#undef focus_xw
#undef focus_ah
#undef focus_aw
#undef target_z
#undef target_y
#undef target_x
#undef target_index
#undef visualize
#undef yheight2
#undef xwidth2
#undef zdepth
#undef yheight
#undef xwidth
#undef priority
#undef material_string
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

/* User declarations for component 'channel_10_analyzer_2_array_crystal_array_4' [525]. */
#define mccompcurname  channel_10_analyzer_2_array_crystal_array_4
#define mccompcurtype  Union_box
#define mccompcurindex 525
#define loop_index mccchannel_10_analyzer_2_array_crystal_array_4_loop_index
#define this_box_volume mccchannel_10_analyzer_2_array_crystal_array_4_this_box_volume
#define global_geometry_element mccchannel_10_analyzer_2_array_crystal_array_4_global_geometry_element
#define this_box_storage mccchannel_10_analyzer_2_array_crystal_array_4_this_box_storage
#define material_string mccchannel_10_analyzer_2_array_crystal_array_4_material_string
#define priority mccchannel_10_analyzer_2_array_crystal_array_4_priority
#define xwidth mccchannel_10_analyzer_2_array_crystal_array_4_xwidth
#define yheight mccchannel_10_analyzer_2_array_crystal_array_4_yheight
#define zdepth mccchannel_10_analyzer_2_array_crystal_array_4_zdepth
#define xwidth2 mccchannel_10_analyzer_2_array_crystal_array_4_xwidth2
#define yheight2 mccchannel_10_analyzer_2_array_crystal_array_4_yheight2
#define visualize mccchannel_10_analyzer_2_array_crystal_array_4_visualize
#define target_index mccchannel_10_analyzer_2_array_crystal_array_4_target_index
#define target_x mccchannel_10_analyzer_2_array_crystal_array_4_target_x
#define target_y mccchannel_10_analyzer_2_array_crystal_array_4_target_y
#define target_z mccchannel_10_analyzer_2_array_crystal_array_4_target_z
#define focus_aw mccchannel_10_analyzer_2_array_crystal_array_4_focus_aw
#define focus_ah mccchannel_10_analyzer_2_array_crystal_array_4_focus_ah
#define focus_xw mccchannel_10_analyzer_2_array_crystal_array_4_focus_xw
#define focus_xh mccchannel_10_analyzer_2_array_crystal_array_4_focus_xh
#define focus_r mccchannel_10_analyzer_2_array_crystal_array_4_focus_r
#define p_interact mccchannel_10_analyzer_2_array_crystal_array_4_p_interact
#define mask_string mccchannel_10_analyzer_2_array_crystal_array_4_mask_string
#define mask_setting mccchannel_10_analyzer_2_array_crystal_array_4_mask_setting
#define number_of_activations mccchannel_10_analyzer_2_array_crystal_array_4_number_of_activations
#line 204 "Union_box.comp"
// Needed for transport to the main component
struct global_geometry_element_struct global_geometry_element;

#ifndef ANY_GEOMETRY_DETECTOR_DECLARE
    #define ANY_GEOMETRY_DETECTOR_DECLARE dummy
	//struct pointer_to_global_geometry_list global_geometry_list = {0,NULL};
#endif

int loop_index,found_geometries;

double x_component;
double y_component;
double z_component;

struct Volume_struct this_box_volume;
struct box_storage this_box_storage;

#line 60505 "MACS_sample_kidney_box.c"
#undef number_of_activations
#undef mask_setting
#undef mask_string
#undef p_interact
#undef focus_r
#undef focus_xh
#undef focus_xw
#undef focus_ah
#undef focus_aw
#undef target_z
#undef target_y
#undef target_x
#undef target_index
#undef visualize
#undef yheight2
#undef xwidth2
#undef zdepth
#undef yheight
#undef xwidth
#undef priority
#undef material_string
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

/* User declarations for component 'channel_10_analyzer_2_array_crystal_array_5' [526]. */
#define mccompcurname  channel_10_analyzer_2_array_crystal_array_5
#define mccompcurtype  Union_box
#define mccompcurindex 526
#define loop_index mccchannel_10_analyzer_2_array_crystal_array_5_loop_index
#define this_box_volume mccchannel_10_analyzer_2_array_crystal_array_5_this_box_volume
#define global_geometry_element mccchannel_10_analyzer_2_array_crystal_array_5_global_geometry_element
#define this_box_storage mccchannel_10_analyzer_2_array_crystal_array_5_this_box_storage
#define material_string mccchannel_10_analyzer_2_array_crystal_array_5_material_string
#define priority mccchannel_10_analyzer_2_array_crystal_array_5_priority
#define xwidth mccchannel_10_analyzer_2_array_crystal_array_5_xwidth
#define yheight mccchannel_10_analyzer_2_array_crystal_array_5_yheight
#define zdepth mccchannel_10_analyzer_2_array_crystal_array_5_zdepth
#define xwidth2 mccchannel_10_analyzer_2_array_crystal_array_5_xwidth2
#define yheight2 mccchannel_10_analyzer_2_array_crystal_array_5_yheight2
#define visualize mccchannel_10_analyzer_2_array_crystal_array_5_visualize
#define target_index mccchannel_10_analyzer_2_array_crystal_array_5_target_index
#define target_x mccchannel_10_analyzer_2_array_crystal_array_5_target_x
#define target_y mccchannel_10_analyzer_2_array_crystal_array_5_target_y
#define target_z mccchannel_10_analyzer_2_array_crystal_array_5_target_z
#define focus_aw mccchannel_10_analyzer_2_array_crystal_array_5_focus_aw
#define focus_ah mccchannel_10_analyzer_2_array_crystal_array_5_focus_ah
#define focus_xw mccchannel_10_analyzer_2_array_crystal_array_5_focus_xw
#define focus_xh mccchannel_10_analyzer_2_array_crystal_array_5_focus_xh
#define focus_r mccchannel_10_analyzer_2_array_crystal_array_5_focus_r
#define p_interact mccchannel_10_analyzer_2_array_crystal_array_5_p_interact
#define mask_string mccchannel_10_analyzer_2_array_crystal_array_5_mask_string
#define mask_setting mccchannel_10_analyzer_2_array_crystal_array_5_mask_setting
#define number_of_activations mccchannel_10_analyzer_2_array_crystal_array_5_number_of_activations
#line 204 "Union_box.comp"
// Needed for transport to the main component
struct global_geometry_element_struct global_geometry_element;

#ifndef ANY_GEOMETRY_DETECTOR_DECLARE
    #define ANY_GEOMETRY_DETECTOR_DECLARE dummy
	//struct pointer_to_global_geometry_list global_geometry_list = {0,NULL};
#endif

int loop_index,found_geometries;

double x_component;
double y_component;
double z_component;

struct Volume_struct this_box_volume;
struct box_storage this_box_storage;

#line 60582 "MACS_sample_kidney_box.c"
#undef number_of_activations
#undef mask_setting
#undef mask_string
#undef p_interact
#undef focus_r
#undef focus_xh
#undef focus_xw
#undef focus_ah
#undef focus_aw
#undef target_z
#undef target_y
#undef target_x
#undef target_index
#undef visualize
#undef yheight2
#undef xwidth2
#undef zdepth
#undef yheight
#undef xwidth
#undef priority
#undef material_string
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

/* User declarations for component 'channel_10_analyzer_2_array_crystal_array_6' [527]. */
#define mccompcurname  channel_10_analyzer_2_array_crystal_array_6
#define mccompcurtype  Union_box
#define mccompcurindex 527
#define loop_index mccchannel_10_analyzer_2_array_crystal_array_6_loop_index
#define this_box_volume mccchannel_10_analyzer_2_array_crystal_array_6_this_box_volume
#define global_geometry_element mccchannel_10_analyzer_2_array_crystal_array_6_global_geometry_element
#define this_box_storage mccchannel_10_analyzer_2_array_crystal_array_6_this_box_storage
#define material_string mccchannel_10_analyzer_2_array_crystal_array_6_material_string
#define priority mccchannel_10_analyzer_2_array_crystal_array_6_priority
#define xwidth mccchannel_10_analyzer_2_array_crystal_array_6_xwidth
#define yheight mccchannel_10_analyzer_2_array_crystal_array_6_yheight
#define zdepth mccchannel_10_analyzer_2_array_crystal_array_6_zdepth
#define xwidth2 mccchannel_10_analyzer_2_array_crystal_array_6_xwidth2
#define yheight2 mccchannel_10_analyzer_2_array_crystal_array_6_yheight2
#define visualize mccchannel_10_analyzer_2_array_crystal_array_6_visualize
#define target_index mccchannel_10_analyzer_2_array_crystal_array_6_target_index
#define target_x mccchannel_10_analyzer_2_array_crystal_array_6_target_x
#define target_y mccchannel_10_analyzer_2_array_crystal_array_6_target_y
#define target_z mccchannel_10_analyzer_2_array_crystal_array_6_target_z
#define focus_aw mccchannel_10_analyzer_2_array_crystal_array_6_focus_aw
#define focus_ah mccchannel_10_analyzer_2_array_crystal_array_6_focus_ah
#define focus_xw mccchannel_10_analyzer_2_array_crystal_array_6_focus_xw
#define focus_xh mccchannel_10_analyzer_2_array_crystal_array_6_focus_xh
#define focus_r mccchannel_10_analyzer_2_array_crystal_array_6_focus_r
#define p_interact mccchannel_10_analyzer_2_array_crystal_array_6_p_interact
#define mask_string mccchannel_10_analyzer_2_array_crystal_array_6_mask_string
#define mask_setting mccchannel_10_analyzer_2_array_crystal_array_6_mask_setting
#define number_of_activations mccchannel_10_analyzer_2_array_crystal_array_6_number_of_activations
#line 204 "Union_box.comp"
// Needed for transport to the main component
struct global_geometry_element_struct global_geometry_element;

#ifndef ANY_GEOMETRY_DETECTOR_DECLARE
    #define ANY_GEOMETRY_DETECTOR_DECLARE dummy
	//struct pointer_to_global_geometry_list global_geometry_list = {0,NULL};
#endif

int loop_index,found_geometries;

double x_component;
double y_component;
double z_component;

struct Volume_struct this_box_volume;
struct box_storage this_box_storage;

#line 60659 "MACS_sample_kidney_box.c"
#undef number_of_activations
#undef mask_setting
#undef mask_string
#undef p_interact
#undef focus_r
#undef focus_xh
#undef focus_xw
#undef focus_ah
#undef focus_aw
#undef target_z
#undef target_y
#undef target_x
#undef target_index
#undef visualize
#undef yheight2
#undef xwidth2
#undef zdepth
#undef yheight
#undef xwidth
#undef priority
#undef material_string
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

/* User declarations for component 'channel_10_analyzer_2_array_crystal_array_7' [528]. */
#define mccompcurname  channel_10_analyzer_2_array_crystal_array_7
#define mccompcurtype  Union_box
#define mccompcurindex 528
#define loop_index mccchannel_10_analyzer_2_array_crystal_array_7_loop_index
#define this_box_volume mccchannel_10_analyzer_2_array_crystal_array_7_this_box_volume
#define global_geometry_element mccchannel_10_analyzer_2_array_crystal_array_7_global_geometry_element
#define this_box_storage mccchannel_10_analyzer_2_array_crystal_array_7_this_box_storage
#define material_string mccchannel_10_analyzer_2_array_crystal_array_7_material_string
#define priority mccchannel_10_analyzer_2_array_crystal_array_7_priority
#define xwidth mccchannel_10_analyzer_2_array_crystal_array_7_xwidth
#define yheight mccchannel_10_analyzer_2_array_crystal_array_7_yheight
#define zdepth mccchannel_10_analyzer_2_array_crystal_array_7_zdepth
#define xwidth2 mccchannel_10_analyzer_2_array_crystal_array_7_xwidth2
#define yheight2 mccchannel_10_analyzer_2_array_crystal_array_7_yheight2
#define visualize mccchannel_10_analyzer_2_array_crystal_array_7_visualize
#define target_index mccchannel_10_analyzer_2_array_crystal_array_7_target_index
#define target_x mccchannel_10_analyzer_2_array_crystal_array_7_target_x
#define target_y mccchannel_10_analyzer_2_array_crystal_array_7_target_y
#define target_z mccchannel_10_analyzer_2_array_crystal_array_7_target_z
#define focus_aw mccchannel_10_analyzer_2_array_crystal_array_7_focus_aw
#define focus_ah mccchannel_10_analyzer_2_array_crystal_array_7_focus_ah
#define focus_xw mccchannel_10_analyzer_2_array_crystal_array_7_focus_xw
#define focus_xh mccchannel_10_analyzer_2_array_crystal_array_7_focus_xh
#define focus_r mccchannel_10_analyzer_2_array_crystal_array_7_focus_r
#define p_interact mccchannel_10_analyzer_2_array_crystal_array_7_p_interact
#define mask_string mccchannel_10_analyzer_2_array_crystal_array_7_mask_string
#define mask_setting mccchannel_10_analyzer_2_array_crystal_array_7_mask_setting
#define number_of_activations mccchannel_10_analyzer_2_array_crystal_array_7_number_of_activations
#line 204 "Union_box.comp"
// Needed for transport to the main component
struct global_geometry_element_struct global_geometry_element;

#ifndef ANY_GEOMETRY_DETECTOR_DECLARE
    #define ANY_GEOMETRY_DETECTOR_DECLARE dummy
	//struct pointer_to_global_geometry_list global_geometry_list = {0,NULL};
#endif

int loop_index,found_geometries;

double x_component;
double y_component;
double z_component;

struct Volume_struct this_box_volume;
struct box_storage this_box_storage;

#line 60736 "MACS_sample_kidney_box.c"
#undef number_of_activations
#undef mask_setting
#undef mask_string
#undef p_interact
#undef focus_r
#undef focus_xh
#undef focus_xw
#undef focus_ah
#undef focus_aw
#undef target_z
#undef target_y
#undef target_x
#undef target_index
#undef visualize
#undef yheight2
#undef xwidth2
#undef zdepth
#undef yheight
#undef xwidth
#undef priority
#undef material_string
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

/* User declarations for component 'channel_10_analyzer_2_array_crystal_array_8' [529]. */
#define mccompcurname  channel_10_analyzer_2_array_crystal_array_8
#define mccompcurtype  Union_box
#define mccompcurindex 529
#define loop_index mccchannel_10_analyzer_2_array_crystal_array_8_loop_index
#define this_box_volume mccchannel_10_analyzer_2_array_crystal_array_8_this_box_volume
#define global_geometry_element mccchannel_10_analyzer_2_array_crystal_array_8_global_geometry_element
#define this_box_storage mccchannel_10_analyzer_2_array_crystal_array_8_this_box_storage
#define material_string mccchannel_10_analyzer_2_array_crystal_array_8_material_string
#define priority mccchannel_10_analyzer_2_array_crystal_array_8_priority
#define xwidth mccchannel_10_analyzer_2_array_crystal_array_8_xwidth
#define yheight mccchannel_10_analyzer_2_array_crystal_array_8_yheight
#define zdepth mccchannel_10_analyzer_2_array_crystal_array_8_zdepth
#define xwidth2 mccchannel_10_analyzer_2_array_crystal_array_8_xwidth2
#define yheight2 mccchannel_10_analyzer_2_array_crystal_array_8_yheight2
#define visualize mccchannel_10_analyzer_2_array_crystal_array_8_visualize
#define target_index mccchannel_10_analyzer_2_array_crystal_array_8_target_index
#define target_x mccchannel_10_analyzer_2_array_crystal_array_8_target_x
#define target_y mccchannel_10_analyzer_2_array_crystal_array_8_target_y
#define target_z mccchannel_10_analyzer_2_array_crystal_array_8_target_z
#define focus_aw mccchannel_10_analyzer_2_array_crystal_array_8_focus_aw
#define focus_ah mccchannel_10_analyzer_2_array_crystal_array_8_focus_ah
#define focus_xw mccchannel_10_analyzer_2_array_crystal_array_8_focus_xw
#define focus_xh mccchannel_10_analyzer_2_array_crystal_array_8_focus_xh
#define focus_r mccchannel_10_analyzer_2_array_crystal_array_8_focus_r
#define p_interact mccchannel_10_analyzer_2_array_crystal_array_8_p_interact
#define mask_string mccchannel_10_analyzer_2_array_crystal_array_8_mask_string
#define mask_setting mccchannel_10_analyzer_2_array_crystal_array_8_mask_setting
#define number_of_activations mccchannel_10_analyzer_2_array_crystal_array_8_number_of_activations
#line 204 "Union_box.comp"
// Needed for transport to the main component
struct global_geometry_element_struct global_geometry_element;

#ifndef ANY_GEOMETRY_DETECTOR_DECLARE
    #define ANY_GEOMETRY_DETECTOR_DECLARE dummy
	//struct pointer_to_global_geometry_list global_geometry_list = {0,NULL};
#endif

int loop_index,found_geometries;

double x_component;
double y_component;
double z_component;

struct Volume_struct this_box_volume;
struct box_storage this_box_storage;

#line 60813 "MACS_sample_kidney_box.c"
#undef number_of_activations
#undef mask_setting
#undef mask_string
#undef p_interact
#undef focus_r
#undef focus_xh
#undef focus_xw
#undef focus_ah
#undef focus_aw
#undef target_z
#undef target_y
#undef target_x
#undef target_index
#undef visualize
#undef yheight2
#undef xwidth2
#undef zdepth
#undef yheight
#undef xwidth
#undef priority
#undef material_string
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

/* User declarations for component 'channel_10_cave2_cyl1' [530]. */
#define mccompcurname  channel_10_cave2_cyl1
#define mccompcurtype  Union_cylinder
#define mccompcurindex 530
#define loop_index mccchannel_10_cave2_cyl1_loop_index
#define this_cylinder_volume mccchannel_10_cave2_cyl1_this_cylinder_volume
#define global_geometry_element mccchannel_10_cave2_cyl1_global_geometry_element
#define this_cylinder_storage mccchannel_10_cave2_cyl1_this_cylinder_storage
#define material_string mccchannel_10_cave2_cyl1_material_string
#define priority mccchannel_10_cave2_cyl1_priority
#define radius mccchannel_10_cave2_cyl1_radius
#define yheight mccchannel_10_cave2_cyl1_yheight
#define visualize mccchannel_10_cave2_cyl1_visualize
#define target_index mccchannel_10_cave2_cyl1_target_index
#define target_x mccchannel_10_cave2_cyl1_target_x
#define target_y mccchannel_10_cave2_cyl1_target_y
#define target_z mccchannel_10_cave2_cyl1_target_z
#define focus_aw mccchannel_10_cave2_cyl1_focus_aw
#define focus_ah mccchannel_10_cave2_cyl1_focus_ah
#define focus_xw mccchannel_10_cave2_cyl1_focus_xw
#define focus_xh mccchannel_10_cave2_cyl1_focus_xh
#define focus_r mccchannel_10_cave2_cyl1_focus_r
#define p_interact mccchannel_10_cave2_cyl1_p_interact
#define mask_string mccchannel_10_cave2_cyl1_mask_string
#define mask_setting mccchannel_10_cave2_cyl1_mask_setting
#define number_of_activations mccchannel_10_cave2_cyl1_number_of_activations
#line 167 "Union_cylinder.comp"
// Needed for transport to the main component
struct global_geometry_element_struct global_geometry_element;

#ifndef ANY_GEOMETRY_DETECTOR_DECLARE
    #define ANY_GEOMETRY_DETECTOR_DECLARE dummy
	//struct pointer_to_global_geometry_list global_geometry_list = {0,NULL};
#endif

int dummy;
int loop_index,found_geometries;
int loop_2_index;
int material_index;

struct Volume_struct this_cylinder_volume;
struct cylinder_storage this_cylinder_storage;
#line 60885 "MACS_sample_kidney_box.c"
#undef number_of_activations
#undef mask_setting
#undef mask_string
#undef p_interact
#undef focus_r
#undef focus_xh
#undef focus_xw
#undef focus_ah
#undef focus_aw
#undef target_z
#undef target_y
#undef target_x
#undef target_index
#undef visualize
#undef yheight
#undef radius
#undef priority
#undef material_string
#undef this_cylinder_storage
#undef global_geometry_element
#undef this_cylinder_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

/* User declarations for component 'channel_10_cave2_box1' [531]. */
#define mccompcurname  channel_10_cave2_box1
#define mccompcurtype  Union_box
#define mccompcurindex 531
#define loop_index mccchannel_10_cave2_box1_loop_index
#define this_box_volume mccchannel_10_cave2_box1_this_box_volume
#define global_geometry_element mccchannel_10_cave2_box1_global_geometry_element
#define this_box_storage mccchannel_10_cave2_box1_this_box_storage
#define material_string mccchannel_10_cave2_box1_material_string
#define priority mccchannel_10_cave2_box1_priority
#define xwidth mccchannel_10_cave2_box1_xwidth
#define yheight mccchannel_10_cave2_box1_yheight
#define zdepth mccchannel_10_cave2_box1_zdepth
#define xwidth2 mccchannel_10_cave2_box1_xwidth2
#define yheight2 mccchannel_10_cave2_box1_yheight2
#define visualize mccchannel_10_cave2_box1_visualize
#define target_index mccchannel_10_cave2_box1_target_index
#define target_x mccchannel_10_cave2_box1_target_x
#define target_y mccchannel_10_cave2_box1_target_y
#define target_z mccchannel_10_cave2_box1_target_z
#define focus_aw mccchannel_10_cave2_box1_focus_aw
#define focus_ah mccchannel_10_cave2_box1_focus_ah
#define focus_xw mccchannel_10_cave2_box1_focus_xw
#define focus_xh mccchannel_10_cave2_box1_focus_xh
#define focus_r mccchannel_10_cave2_box1_focus_r
#define p_interact mccchannel_10_cave2_box1_p_interact
#define mask_string mccchannel_10_cave2_box1_mask_string
#define mask_setting mccchannel_10_cave2_box1_mask_setting
#define number_of_activations mccchannel_10_cave2_box1_number_of_activations
#line 204 "Union_box.comp"
// Needed for transport to the main component
struct global_geometry_element_struct global_geometry_element;

#ifndef ANY_GEOMETRY_DETECTOR_DECLARE
    #define ANY_GEOMETRY_DETECTOR_DECLARE dummy
	//struct pointer_to_global_geometry_list global_geometry_list = {0,NULL};
#endif

int loop_index,found_geometries;

double x_component;
double y_component;
double z_component;

struct Volume_struct this_box_volume;
struct box_storage this_box_storage;

#line 60959 "MACS_sample_kidney_box.c"
#undef number_of_activations
#undef mask_setting
#undef mask_string
#undef p_interact
#undef focus_r
#undef focus_xh
#undef focus_xw
#undef focus_ah
#undef focus_aw
#undef target_z
#undef target_y
#undef target_x
#undef target_index
#undef visualize
#undef yheight2
#undef xwidth2
#undef zdepth
#undef yheight
#undef xwidth
#undef priority
#undef material_string
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

/* User declarations for component 'channel_10_cave2_box2' [532]. */
#define mccompcurname  channel_10_cave2_box2
#define mccompcurtype  Union_box
#define mccompcurindex 532
#define loop_index mccchannel_10_cave2_box2_loop_index
#define this_box_volume mccchannel_10_cave2_box2_this_box_volume
#define global_geometry_element mccchannel_10_cave2_box2_global_geometry_element
#define this_box_storage mccchannel_10_cave2_box2_this_box_storage
#define material_string mccchannel_10_cave2_box2_material_string
#define priority mccchannel_10_cave2_box2_priority
#define xwidth mccchannel_10_cave2_box2_xwidth
#define yheight mccchannel_10_cave2_box2_yheight
#define zdepth mccchannel_10_cave2_box2_zdepth
#define xwidth2 mccchannel_10_cave2_box2_xwidth2
#define yheight2 mccchannel_10_cave2_box2_yheight2
#define visualize mccchannel_10_cave2_box2_visualize
#define target_index mccchannel_10_cave2_box2_target_index
#define target_x mccchannel_10_cave2_box2_target_x
#define target_y mccchannel_10_cave2_box2_target_y
#define target_z mccchannel_10_cave2_box2_target_z
#define focus_aw mccchannel_10_cave2_box2_focus_aw
#define focus_ah mccchannel_10_cave2_box2_focus_ah
#define focus_xw mccchannel_10_cave2_box2_focus_xw
#define focus_xh mccchannel_10_cave2_box2_focus_xh
#define focus_r mccchannel_10_cave2_box2_focus_r
#define p_interact mccchannel_10_cave2_box2_p_interact
#define mask_string mccchannel_10_cave2_box2_mask_string
#define mask_setting mccchannel_10_cave2_box2_mask_setting
#define number_of_activations mccchannel_10_cave2_box2_number_of_activations
#line 204 "Union_box.comp"
// Needed for transport to the main component
struct global_geometry_element_struct global_geometry_element;

#ifndef ANY_GEOMETRY_DETECTOR_DECLARE
    #define ANY_GEOMETRY_DETECTOR_DECLARE dummy
	//struct pointer_to_global_geometry_list global_geometry_list = {0,NULL};
#endif

int loop_index,found_geometries;

double x_component;
double y_component;
double z_component;

struct Volume_struct this_box_volume;
struct box_storage this_box_storage;

#line 61036 "MACS_sample_kidney_box.c"
#undef number_of_activations
#undef mask_setting
#undef mask_string
#undef p_interact
#undef focus_r
#undef focus_xh
#undef focus_xw
#undef focus_ah
#undef focus_aw
#undef target_z
#undef target_y
#undef target_x
#undef target_index
#undef visualize
#undef yheight2
#undef xwidth2
#undef zdepth
#undef yheight
#undef xwidth
#undef priority
#undef material_string
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

/* User declarations for component 'channel_10_cave2_box3' [533]. */
#define mccompcurname  channel_10_cave2_box3
#define mccompcurtype  Union_box
#define mccompcurindex 533
#define loop_index mccchannel_10_cave2_box3_loop_index
#define this_box_volume mccchannel_10_cave2_box3_this_box_volume
#define global_geometry_element mccchannel_10_cave2_box3_global_geometry_element
#define this_box_storage mccchannel_10_cave2_box3_this_box_storage
#define material_string mccchannel_10_cave2_box3_material_string
#define priority mccchannel_10_cave2_box3_priority
#define xwidth mccchannel_10_cave2_box3_xwidth
#define yheight mccchannel_10_cave2_box3_yheight
#define zdepth mccchannel_10_cave2_box3_zdepth
#define xwidth2 mccchannel_10_cave2_box3_xwidth2
#define yheight2 mccchannel_10_cave2_box3_yheight2
#define visualize mccchannel_10_cave2_box3_visualize
#define target_index mccchannel_10_cave2_box3_target_index
#define target_x mccchannel_10_cave2_box3_target_x
#define target_y mccchannel_10_cave2_box3_target_y
#define target_z mccchannel_10_cave2_box3_target_z
#define focus_aw mccchannel_10_cave2_box3_focus_aw
#define focus_ah mccchannel_10_cave2_box3_focus_ah
#define focus_xw mccchannel_10_cave2_box3_focus_xw
#define focus_xh mccchannel_10_cave2_box3_focus_xh
#define focus_r mccchannel_10_cave2_box3_focus_r
#define p_interact mccchannel_10_cave2_box3_p_interact
#define mask_string mccchannel_10_cave2_box3_mask_string
#define mask_setting mccchannel_10_cave2_box3_mask_setting
#define number_of_activations mccchannel_10_cave2_box3_number_of_activations
#line 204 "Union_box.comp"
// Needed for transport to the main component
struct global_geometry_element_struct global_geometry_element;

#ifndef ANY_GEOMETRY_DETECTOR_DECLARE
    #define ANY_GEOMETRY_DETECTOR_DECLARE dummy
	//struct pointer_to_global_geometry_list global_geometry_list = {0,NULL};
#endif

int loop_index,found_geometries;

double x_component;
double y_component;
double z_component;

struct Volume_struct this_box_volume;
struct box_storage this_box_storage;

#line 61113 "MACS_sample_kidney_box.c"
#undef number_of_activations
#undef mask_setting
#undef mask_string
#undef p_interact
#undef focus_r
#undef focus_xh
#undef focus_xw
#undef focus_ah
#undef focus_aw
#undef target_z
#undef target_y
#undef target_x
#undef target_index
#undef visualize
#undef yheight2
#undef xwidth2
#undef zdepth
#undef yheight
#undef xwidth
#undef priority
#undef material_string
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

/* User declarations for component 'inter_analyzer_colimator_center_10' [534]. */
#define mccompcurname  inter_analyzer_colimator_center_10
#define mccompcurtype  Arm
#define mccompcurindex 534
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

/* User declarations for component 'inter_analyzer_colimator_10_blade_0' [535]. */
#define mccompcurname  inter_analyzer_colimator_10_blade_0
#define mccompcurtype  Union_box
#define mccompcurindex 535
#define loop_index mccinter_analyzer_colimator_10_blade_0_loop_index
#define this_box_volume mccinter_analyzer_colimator_10_blade_0_this_box_volume
#define global_geometry_element mccinter_analyzer_colimator_10_blade_0_global_geometry_element
#define this_box_storage mccinter_analyzer_colimator_10_blade_0_this_box_storage
#define material_string mccinter_analyzer_colimator_10_blade_0_material_string
#define priority mccinter_analyzer_colimator_10_blade_0_priority
#define xwidth mccinter_analyzer_colimator_10_blade_0_xwidth
#define yheight mccinter_analyzer_colimator_10_blade_0_yheight
#define zdepth mccinter_analyzer_colimator_10_blade_0_zdepth
#define xwidth2 mccinter_analyzer_colimator_10_blade_0_xwidth2
#define yheight2 mccinter_analyzer_colimator_10_blade_0_yheight2
#define visualize mccinter_analyzer_colimator_10_blade_0_visualize
#define target_index mccinter_analyzer_colimator_10_blade_0_target_index
#define target_x mccinter_analyzer_colimator_10_blade_0_target_x
#define target_y mccinter_analyzer_colimator_10_blade_0_target_y
#define target_z mccinter_analyzer_colimator_10_blade_0_target_z
#define focus_aw mccinter_analyzer_colimator_10_blade_0_focus_aw
#define focus_ah mccinter_analyzer_colimator_10_blade_0_focus_ah
#define focus_xw mccinter_analyzer_colimator_10_blade_0_focus_xw
#define focus_xh mccinter_analyzer_colimator_10_blade_0_focus_xh
#define focus_r mccinter_analyzer_colimator_10_blade_0_focus_r
#define p_interact mccinter_analyzer_colimator_10_blade_0_p_interact
#define mask_string mccinter_analyzer_colimator_10_blade_0_mask_string
#define mask_setting mccinter_analyzer_colimator_10_blade_0_mask_setting
#define number_of_activations mccinter_analyzer_colimator_10_blade_0_number_of_activations
#line 204 "Union_box.comp"
// Needed for transport to the main component
struct global_geometry_element_struct global_geometry_element;

#ifndef ANY_GEOMETRY_DETECTOR_DECLARE
    #define ANY_GEOMETRY_DETECTOR_DECLARE dummy
	//struct pointer_to_global_geometry_list global_geometry_list = {0,NULL};
#endif

int loop_index,found_geometries;

double x_component;
double y_component;
double z_component;

struct Volume_struct this_box_volume;
struct box_storage this_box_storage;

#line 61198 "MACS_sample_kidney_box.c"
#undef number_of_activations
#undef mask_setting
#undef mask_string
#undef p_interact
#undef focus_r
#undef focus_xh
#undef focus_xw
#undef focus_ah
#undef focus_aw
#undef target_z
#undef target_y
#undef target_x
#undef target_index
#undef visualize
#undef yheight2
#undef xwidth2
#undef zdepth
#undef yheight
#undef xwidth
#undef priority
#undef material_string
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

/* User declarations for component 'inter_analyzer_colimator_10_blade_1' [536]. */
#define mccompcurname  inter_analyzer_colimator_10_blade_1
#define mccompcurtype  Union_box
#define mccompcurindex 536
#define loop_index mccinter_analyzer_colimator_10_blade_1_loop_index
#define this_box_volume mccinter_analyzer_colimator_10_blade_1_this_box_volume
#define global_geometry_element mccinter_analyzer_colimator_10_blade_1_global_geometry_element
#define this_box_storage mccinter_analyzer_colimator_10_blade_1_this_box_storage
#define material_string mccinter_analyzer_colimator_10_blade_1_material_string
#define priority mccinter_analyzer_colimator_10_blade_1_priority
#define xwidth mccinter_analyzer_colimator_10_blade_1_xwidth
#define yheight mccinter_analyzer_colimator_10_blade_1_yheight
#define zdepth mccinter_analyzer_colimator_10_blade_1_zdepth
#define xwidth2 mccinter_analyzer_colimator_10_blade_1_xwidth2
#define yheight2 mccinter_analyzer_colimator_10_blade_1_yheight2
#define visualize mccinter_analyzer_colimator_10_blade_1_visualize
#define target_index mccinter_analyzer_colimator_10_blade_1_target_index
#define target_x mccinter_analyzer_colimator_10_blade_1_target_x
#define target_y mccinter_analyzer_colimator_10_blade_1_target_y
#define target_z mccinter_analyzer_colimator_10_blade_1_target_z
#define focus_aw mccinter_analyzer_colimator_10_blade_1_focus_aw
#define focus_ah mccinter_analyzer_colimator_10_blade_1_focus_ah
#define focus_xw mccinter_analyzer_colimator_10_blade_1_focus_xw
#define focus_xh mccinter_analyzer_colimator_10_blade_1_focus_xh
#define focus_r mccinter_analyzer_colimator_10_blade_1_focus_r
#define p_interact mccinter_analyzer_colimator_10_blade_1_p_interact
#define mask_string mccinter_analyzer_colimator_10_blade_1_mask_string
#define mask_setting mccinter_analyzer_colimator_10_blade_1_mask_setting
#define number_of_activations mccinter_analyzer_colimator_10_blade_1_number_of_activations
#line 204 "Union_box.comp"
// Needed for transport to the main component
struct global_geometry_element_struct global_geometry_element;

#ifndef ANY_GEOMETRY_DETECTOR_DECLARE
    #define ANY_GEOMETRY_DETECTOR_DECLARE dummy
	//struct pointer_to_global_geometry_list global_geometry_list = {0,NULL};
#endif

int loop_index,found_geometries;

double x_component;
double y_component;
double z_component;

struct Volume_struct this_box_volume;
struct box_storage this_box_storage;

#line 61275 "MACS_sample_kidney_box.c"
#undef number_of_activations
#undef mask_setting
#undef mask_string
#undef p_interact
#undef focus_r
#undef focus_xh
#undef focus_xw
#undef focus_ah
#undef focus_aw
#undef target_z
#undef target_y
#undef target_x
#undef target_index
#undef visualize
#undef yheight2
#undef xwidth2
#undef zdepth
#undef yheight
#undef xwidth
#undef priority
#undef material_string
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

/* User declarations for component 'inter_analyzer_colimator_10_blade_2' [537]. */
#define mccompcurname  inter_analyzer_colimator_10_blade_2
#define mccompcurtype  Union_box
#define mccompcurindex 537
#define loop_index mccinter_analyzer_colimator_10_blade_2_loop_index
#define this_box_volume mccinter_analyzer_colimator_10_blade_2_this_box_volume
#define global_geometry_element mccinter_analyzer_colimator_10_blade_2_global_geometry_element
#define this_box_storage mccinter_analyzer_colimator_10_blade_2_this_box_storage
#define material_string mccinter_analyzer_colimator_10_blade_2_material_string
#define priority mccinter_analyzer_colimator_10_blade_2_priority
#define xwidth mccinter_analyzer_colimator_10_blade_2_xwidth
#define yheight mccinter_analyzer_colimator_10_blade_2_yheight
#define zdepth mccinter_analyzer_colimator_10_blade_2_zdepth
#define xwidth2 mccinter_analyzer_colimator_10_blade_2_xwidth2
#define yheight2 mccinter_analyzer_colimator_10_blade_2_yheight2
#define visualize mccinter_analyzer_colimator_10_blade_2_visualize
#define target_index mccinter_analyzer_colimator_10_blade_2_target_index
#define target_x mccinter_analyzer_colimator_10_blade_2_target_x
#define target_y mccinter_analyzer_colimator_10_blade_2_target_y
#define target_z mccinter_analyzer_colimator_10_blade_2_target_z
#define focus_aw mccinter_analyzer_colimator_10_blade_2_focus_aw
#define focus_ah mccinter_analyzer_colimator_10_blade_2_focus_ah
#define focus_xw mccinter_analyzer_colimator_10_blade_2_focus_xw
#define focus_xh mccinter_analyzer_colimator_10_blade_2_focus_xh
#define focus_r mccinter_analyzer_colimator_10_blade_2_focus_r
#define p_interact mccinter_analyzer_colimator_10_blade_2_p_interact
#define mask_string mccinter_analyzer_colimator_10_blade_2_mask_string
#define mask_setting mccinter_analyzer_colimator_10_blade_2_mask_setting
#define number_of_activations mccinter_analyzer_colimator_10_blade_2_number_of_activations
#line 204 "Union_box.comp"
// Needed for transport to the main component
struct global_geometry_element_struct global_geometry_element;

#ifndef ANY_GEOMETRY_DETECTOR_DECLARE
    #define ANY_GEOMETRY_DETECTOR_DECLARE dummy
	//struct pointer_to_global_geometry_list global_geometry_list = {0,NULL};
#endif

int loop_index,found_geometries;

double x_component;
double y_component;
double z_component;

struct Volume_struct this_box_volume;
struct box_storage this_box_storage;

#line 61352 "MACS_sample_kidney_box.c"
#undef number_of_activations
#undef mask_setting
#undef mask_string
#undef p_interact
#undef focus_r
#undef focus_xh
#undef focus_xw
#undef focus_ah
#undef focus_aw
#undef target_z
#undef target_y
#undef target_x
#undef target_index
#undef visualize
#undef yheight2
#undef xwidth2
#undef zdepth
#undef yheight
#undef xwidth
#undef priority
#undef material_string
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

/* User declarations for component 'inter_analyzer_colimator_10_blade_3' [538]. */
#define mccompcurname  inter_analyzer_colimator_10_blade_3
#define mccompcurtype  Union_box
#define mccompcurindex 538
#define loop_index mccinter_analyzer_colimator_10_blade_3_loop_index
#define this_box_volume mccinter_analyzer_colimator_10_blade_3_this_box_volume
#define global_geometry_element mccinter_analyzer_colimator_10_blade_3_global_geometry_element
#define this_box_storage mccinter_analyzer_colimator_10_blade_3_this_box_storage
#define material_string mccinter_analyzer_colimator_10_blade_3_material_string
#define priority mccinter_analyzer_colimator_10_blade_3_priority
#define xwidth mccinter_analyzer_colimator_10_blade_3_xwidth
#define yheight mccinter_analyzer_colimator_10_blade_3_yheight
#define zdepth mccinter_analyzer_colimator_10_blade_3_zdepth
#define xwidth2 mccinter_analyzer_colimator_10_blade_3_xwidth2
#define yheight2 mccinter_analyzer_colimator_10_blade_3_yheight2
#define visualize mccinter_analyzer_colimator_10_blade_3_visualize
#define target_index mccinter_analyzer_colimator_10_blade_3_target_index
#define target_x mccinter_analyzer_colimator_10_blade_3_target_x
#define target_y mccinter_analyzer_colimator_10_blade_3_target_y
#define target_z mccinter_analyzer_colimator_10_blade_3_target_z
#define focus_aw mccinter_analyzer_colimator_10_blade_3_focus_aw
#define focus_ah mccinter_analyzer_colimator_10_blade_3_focus_ah
#define focus_xw mccinter_analyzer_colimator_10_blade_3_focus_xw
#define focus_xh mccinter_analyzer_colimator_10_blade_3_focus_xh
#define focus_r mccinter_analyzer_colimator_10_blade_3_focus_r
#define p_interact mccinter_analyzer_colimator_10_blade_3_p_interact
#define mask_string mccinter_analyzer_colimator_10_blade_3_mask_string
#define mask_setting mccinter_analyzer_colimator_10_blade_3_mask_setting
#define number_of_activations mccinter_analyzer_colimator_10_blade_3_number_of_activations
#line 204 "Union_box.comp"
// Needed for transport to the main component
struct global_geometry_element_struct global_geometry_element;

#ifndef ANY_GEOMETRY_DETECTOR_DECLARE
    #define ANY_GEOMETRY_DETECTOR_DECLARE dummy
	//struct pointer_to_global_geometry_list global_geometry_list = {0,NULL};
#endif

int loop_index,found_geometries;

double x_component;
double y_component;
double z_component;

struct Volume_struct this_box_volume;
struct box_storage this_box_storage;

#line 61429 "MACS_sample_kidney_box.c"
#undef number_of_activations
#undef mask_setting
#undef mask_string
#undef p_interact
#undef focus_r
#undef focus_xh
#undef focus_xw
#undef focus_ah
#undef focus_aw
#undef target_z
#undef target_y
#undef target_x
#undef target_index
#undef visualize
#undef yheight2
#undef xwidth2
#undef zdepth
#undef yheight
#undef xwidth
#undef priority
#undef material_string
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

/* User declarations for component 'inter_analyzer_colimator_10_blade_4' [539]. */
#define mccompcurname  inter_analyzer_colimator_10_blade_4
#define mccompcurtype  Union_box
#define mccompcurindex 539
#define loop_index mccinter_analyzer_colimator_10_blade_4_loop_index
#define this_box_volume mccinter_analyzer_colimator_10_blade_4_this_box_volume
#define global_geometry_element mccinter_analyzer_colimator_10_blade_4_global_geometry_element
#define this_box_storage mccinter_analyzer_colimator_10_blade_4_this_box_storage
#define material_string mccinter_analyzer_colimator_10_blade_4_material_string
#define priority mccinter_analyzer_colimator_10_blade_4_priority
#define xwidth mccinter_analyzer_colimator_10_blade_4_xwidth
#define yheight mccinter_analyzer_colimator_10_blade_4_yheight
#define zdepth mccinter_analyzer_colimator_10_blade_4_zdepth
#define xwidth2 mccinter_analyzer_colimator_10_blade_4_xwidth2
#define yheight2 mccinter_analyzer_colimator_10_blade_4_yheight2
#define visualize mccinter_analyzer_colimator_10_blade_4_visualize
#define target_index mccinter_analyzer_colimator_10_blade_4_target_index
#define target_x mccinter_analyzer_colimator_10_blade_4_target_x
#define target_y mccinter_analyzer_colimator_10_blade_4_target_y
#define target_z mccinter_analyzer_colimator_10_blade_4_target_z
#define focus_aw mccinter_analyzer_colimator_10_blade_4_focus_aw
#define focus_ah mccinter_analyzer_colimator_10_blade_4_focus_ah
#define focus_xw mccinter_analyzer_colimator_10_blade_4_focus_xw
#define focus_xh mccinter_analyzer_colimator_10_blade_4_focus_xh
#define focus_r mccinter_analyzer_colimator_10_blade_4_focus_r
#define p_interact mccinter_analyzer_colimator_10_blade_4_p_interact
#define mask_string mccinter_analyzer_colimator_10_blade_4_mask_string
#define mask_setting mccinter_analyzer_colimator_10_blade_4_mask_setting
#define number_of_activations mccinter_analyzer_colimator_10_blade_4_number_of_activations
#line 204 "Union_box.comp"
// Needed for transport to the main component
struct global_geometry_element_struct global_geometry_element;

#ifndef ANY_GEOMETRY_DETECTOR_DECLARE
    #define ANY_GEOMETRY_DETECTOR_DECLARE dummy
	//struct pointer_to_global_geometry_list global_geometry_list = {0,NULL};
#endif

int loop_index,found_geometries;

double x_component;
double y_component;
double z_component;

struct Volume_struct this_box_volume;
struct box_storage this_box_storage;

#line 61506 "MACS_sample_kidney_box.c"
#undef number_of_activations
#undef mask_setting
#undef mask_string
#undef p_interact
#undef focus_r
#undef focus_xh
#undef focus_xw
#undef focus_ah
#undef focus_aw
#undef target_z
#undef target_y
#undef target_x
#undef target_index
#undef visualize
#undef yheight2
#undef xwidth2
#undef zdepth
#undef yheight
#undef xwidth
#undef priority
#undef material_string
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

/* User declarations for component 'diffraction_detector_10_exit_volume' [540]. */
#define mccompcurname  diffraction_detector_10_exit_volume
#define mccompcurtype  Union_box
#define mccompcurindex 540
#define loop_index mccdiffraction_detector_10_exit_volume_loop_index
#define this_box_volume mccdiffraction_detector_10_exit_volume_this_box_volume
#define global_geometry_element mccdiffraction_detector_10_exit_volume_global_geometry_element
#define this_box_storage mccdiffraction_detector_10_exit_volume_this_box_storage
#define material_string mccdiffraction_detector_10_exit_volume_material_string
#define priority mccdiffraction_detector_10_exit_volume_priority
#define xwidth mccdiffraction_detector_10_exit_volume_xwidth
#define yheight mccdiffraction_detector_10_exit_volume_yheight
#define zdepth mccdiffraction_detector_10_exit_volume_zdepth
#define xwidth2 mccdiffraction_detector_10_exit_volume_xwidth2
#define yheight2 mccdiffraction_detector_10_exit_volume_yheight2
#define visualize mccdiffraction_detector_10_exit_volume_visualize
#define target_index mccdiffraction_detector_10_exit_volume_target_index
#define target_x mccdiffraction_detector_10_exit_volume_target_x
#define target_y mccdiffraction_detector_10_exit_volume_target_y
#define target_z mccdiffraction_detector_10_exit_volume_target_z
#define focus_aw mccdiffraction_detector_10_exit_volume_focus_aw
#define focus_ah mccdiffraction_detector_10_exit_volume_focus_ah
#define focus_xw mccdiffraction_detector_10_exit_volume_focus_xw
#define focus_xh mccdiffraction_detector_10_exit_volume_focus_xh
#define focus_r mccdiffraction_detector_10_exit_volume_focus_r
#define p_interact mccdiffraction_detector_10_exit_volume_p_interact
#define mask_string mccdiffraction_detector_10_exit_volume_mask_string
#define mask_setting mccdiffraction_detector_10_exit_volume_mask_setting
#define number_of_activations mccdiffraction_detector_10_exit_volume_number_of_activations
#line 204 "Union_box.comp"
// Needed for transport to the main component
struct global_geometry_element_struct global_geometry_element;

#ifndef ANY_GEOMETRY_DETECTOR_DECLARE
    #define ANY_GEOMETRY_DETECTOR_DECLARE dummy
	//struct pointer_to_global_geometry_list global_geometry_list = {0,NULL};
#endif

int loop_index,found_geometries;

double x_component;
double y_component;
double z_component;

struct Volume_struct this_box_volume;
struct box_storage this_box_storage;

#line 61583 "MACS_sample_kidney_box.c"
#undef number_of_activations
#undef mask_setting
#undef mask_string
#undef p_interact
#undef focus_r
#undef focus_xh
#undef focus_xw
#undef focus_ah
#undef focus_aw
#undef target_z
#undef target_y
#undef target_x
#undef target_index
#undef visualize
#undef yheight2
#undef xwidth2
#undef zdepth
#undef yheight
#undef xwidth
#undef priority
#undef material_string
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

/* User declarations for component 'spec_detector_10_exit_volume' [541]. */
#define mccompcurname  spec_detector_10_exit_volume
#define mccompcurtype  Union_box
#define mccompcurindex 541
#define loop_index mccspec_detector_10_exit_volume_loop_index
#define this_box_volume mccspec_detector_10_exit_volume_this_box_volume
#define global_geometry_element mccspec_detector_10_exit_volume_global_geometry_element
#define this_box_storage mccspec_detector_10_exit_volume_this_box_storage
#define material_string mccspec_detector_10_exit_volume_material_string
#define priority mccspec_detector_10_exit_volume_priority
#define xwidth mccspec_detector_10_exit_volume_xwidth
#define yheight mccspec_detector_10_exit_volume_yheight
#define zdepth mccspec_detector_10_exit_volume_zdepth
#define xwidth2 mccspec_detector_10_exit_volume_xwidth2
#define yheight2 mccspec_detector_10_exit_volume_yheight2
#define visualize mccspec_detector_10_exit_volume_visualize
#define target_index mccspec_detector_10_exit_volume_target_index
#define target_x mccspec_detector_10_exit_volume_target_x
#define target_y mccspec_detector_10_exit_volume_target_y
#define target_z mccspec_detector_10_exit_volume_target_z
#define focus_aw mccspec_detector_10_exit_volume_focus_aw
#define focus_ah mccspec_detector_10_exit_volume_focus_ah
#define focus_xw mccspec_detector_10_exit_volume_focus_xw
#define focus_xh mccspec_detector_10_exit_volume_focus_xh
#define focus_r mccspec_detector_10_exit_volume_focus_r
#define p_interact mccspec_detector_10_exit_volume_p_interact
#define mask_string mccspec_detector_10_exit_volume_mask_string
#define mask_setting mccspec_detector_10_exit_volume_mask_setting
#define number_of_activations mccspec_detector_10_exit_volume_number_of_activations
#line 204 "Union_box.comp"
// Needed for transport to the main component
struct global_geometry_element_struct global_geometry_element;

#ifndef ANY_GEOMETRY_DETECTOR_DECLARE
    #define ANY_GEOMETRY_DETECTOR_DECLARE dummy
	//struct pointer_to_global_geometry_list global_geometry_list = {0,NULL};
#endif

int loop_index,found_geometries;

double x_component;
double y_component;
double z_component;

struct Volume_struct this_box_volume;
struct box_storage this_box_storage;

#line 61660 "MACS_sample_kidney_box.c"
#undef number_of_activations
#undef mask_setting
#undef mask_string
#undef p_interact
#undef focus_r
#undef focus_xh
#undef focus_xw
#undef focus_ah
#undef focus_aw
#undef target_z
#undef target_y
#undef target_x
#undef target_index
#undef visualize
#undef yheight2
#undef xwidth2
#undef zdepth
#undef yheight
#undef xwidth
#undef priority
#undef material_string
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

/* User declarations for component 'channel_11_cave1_box1' [542]. */
#define mccompcurname  channel_11_cave1_box1
#define mccompcurtype  Union_box
#define mccompcurindex 542
#define loop_index mccchannel_11_cave1_box1_loop_index
#define this_box_volume mccchannel_11_cave1_box1_this_box_volume
#define global_geometry_element mccchannel_11_cave1_box1_global_geometry_element
#define this_box_storage mccchannel_11_cave1_box1_this_box_storage
#define material_string mccchannel_11_cave1_box1_material_string
#define priority mccchannel_11_cave1_box1_priority
#define xwidth mccchannel_11_cave1_box1_xwidth
#define yheight mccchannel_11_cave1_box1_yheight
#define zdepth mccchannel_11_cave1_box1_zdepth
#define xwidth2 mccchannel_11_cave1_box1_xwidth2
#define yheight2 mccchannel_11_cave1_box1_yheight2
#define visualize mccchannel_11_cave1_box1_visualize
#define target_index mccchannel_11_cave1_box1_target_index
#define target_x mccchannel_11_cave1_box1_target_x
#define target_y mccchannel_11_cave1_box1_target_y
#define target_z mccchannel_11_cave1_box1_target_z
#define focus_aw mccchannel_11_cave1_box1_focus_aw
#define focus_ah mccchannel_11_cave1_box1_focus_ah
#define focus_xw mccchannel_11_cave1_box1_focus_xw
#define focus_xh mccchannel_11_cave1_box1_focus_xh
#define focus_r mccchannel_11_cave1_box1_focus_r
#define p_interact mccchannel_11_cave1_box1_p_interact
#define mask_string mccchannel_11_cave1_box1_mask_string
#define mask_setting mccchannel_11_cave1_box1_mask_setting
#define number_of_activations mccchannel_11_cave1_box1_number_of_activations
#line 204 "Union_box.comp"
// Needed for transport to the main component
struct global_geometry_element_struct global_geometry_element;

#ifndef ANY_GEOMETRY_DETECTOR_DECLARE
    #define ANY_GEOMETRY_DETECTOR_DECLARE dummy
	//struct pointer_to_global_geometry_list global_geometry_list = {0,NULL};
#endif

int loop_index,found_geometries;

double x_component;
double y_component;
double z_component;

struct Volume_struct this_box_volume;
struct box_storage this_box_storage;

#line 61737 "MACS_sample_kidney_box.c"
#undef number_of_activations
#undef mask_setting
#undef mask_string
#undef p_interact
#undef focus_r
#undef focus_xh
#undef focus_xw
#undef focus_ah
#undef focus_aw
#undef target_z
#undef target_y
#undef target_x
#undef target_index
#undef visualize
#undef yheight2
#undef xwidth2
#undef zdepth
#undef yheight
#undef xwidth
#undef priority
#undef material_string
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

/* User declarations for component 'channel_11_cave1_box2' [543]. */
#define mccompcurname  channel_11_cave1_box2
#define mccompcurtype  Union_box
#define mccompcurindex 543
#define loop_index mccchannel_11_cave1_box2_loop_index
#define this_box_volume mccchannel_11_cave1_box2_this_box_volume
#define global_geometry_element mccchannel_11_cave1_box2_global_geometry_element
#define this_box_storage mccchannel_11_cave1_box2_this_box_storage
#define material_string mccchannel_11_cave1_box2_material_string
#define priority mccchannel_11_cave1_box2_priority
#define xwidth mccchannel_11_cave1_box2_xwidth
#define yheight mccchannel_11_cave1_box2_yheight
#define zdepth mccchannel_11_cave1_box2_zdepth
#define xwidth2 mccchannel_11_cave1_box2_xwidth2
#define yheight2 mccchannel_11_cave1_box2_yheight2
#define visualize mccchannel_11_cave1_box2_visualize
#define target_index mccchannel_11_cave1_box2_target_index
#define target_x mccchannel_11_cave1_box2_target_x
#define target_y mccchannel_11_cave1_box2_target_y
#define target_z mccchannel_11_cave1_box2_target_z
#define focus_aw mccchannel_11_cave1_box2_focus_aw
#define focus_ah mccchannel_11_cave1_box2_focus_ah
#define focus_xw mccchannel_11_cave1_box2_focus_xw
#define focus_xh mccchannel_11_cave1_box2_focus_xh
#define focus_r mccchannel_11_cave1_box2_focus_r
#define p_interact mccchannel_11_cave1_box2_p_interact
#define mask_string mccchannel_11_cave1_box2_mask_string
#define mask_setting mccchannel_11_cave1_box2_mask_setting
#define number_of_activations mccchannel_11_cave1_box2_number_of_activations
#line 204 "Union_box.comp"
// Needed for transport to the main component
struct global_geometry_element_struct global_geometry_element;

#ifndef ANY_GEOMETRY_DETECTOR_DECLARE
    #define ANY_GEOMETRY_DETECTOR_DECLARE dummy
	//struct pointer_to_global_geometry_list global_geometry_list = {0,NULL};
#endif

int loop_index,found_geometries;

double x_component;
double y_component;
double z_component;

struct Volume_struct this_box_volume;
struct box_storage this_box_storage;

#line 61814 "MACS_sample_kidney_box.c"
#undef number_of_activations
#undef mask_setting
#undef mask_string
#undef p_interact
#undef focus_r
#undef focus_xh
#undef focus_xw
#undef focus_ah
#undef focus_aw
#undef target_z
#undef target_y
#undef target_x
#undef target_index
#undef visualize
#undef yheight2
#undef xwidth2
#undef zdepth
#undef yheight
#undef xwidth
#undef priority
#undef material_string
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

/* User declarations for component 'channel_11_cave1_box3' [544]. */
#define mccompcurname  channel_11_cave1_box3
#define mccompcurtype  Union_box
#define mccompcurindex 544
#define loop_index mccchannel_11_cave1_box3_loop_index
#define this_box_volume mccchannel_11_cave1_box3_this_box_volume
#define global_geometry_element mccchannel_11_cave1_box3_global_geometry_element
#define this_box_storage mccchannel_11_cave1_box3_this_box_storage
#define material_string mccchannel_11_cave1_box3_material_string
#define priority mccchannel_11_cave1_box3_priority
#define xwidth mccchannel_11_cave1_box3_xwidth
#define yheight mccchannel_11_cave1_box3_yheight
#define zdepth mccchannel_11_cave1_box3_zdepth
#define xwidth2 mccchannel_11_cave1_box3_xwidth2
#define yheight2 mccchannel_11_cave1_box3_yheight2
#define visualize mccchannel_11_cave1_box3_visualize
#define target_index mccchannel_11_cave1_box3_target_index
#define target_x mccchannel_11_cave1_box3_target_x
#define target_y mccchannel_11_cave1_box3_target_y
#define target_z mccchannel_11_cave1_box3_target_z
#define focus_aw mccchannel_11_cave1_box3_focus_aw
#define focus_ah mccchannel_11_cave1_box3_focus_ah
#define focus_xw mccchannel_11_cave1_box3_focus_xw
#define focus_xh mccchannel_11_cave1_box3_focus_xh
#define focus_r mccchannel_11_cave1_box3_focus_r
#define p_interact mccchannel_11_cave1_box3_p_interact
#define mask_string mccchannel_11_cave1_box3_mask_string
#define mask_setting mccchannel_11_cave1_box3_mask_setting
#define number_of_activations mccchannel_11_cave1_box3_number_of_activations
#line 204 "Union_box.comp"
// Needed for transport to the main component
struct global_geometry_element_struct global_geometry_element;

#ifndef ANY_GEOMETRY_DETECTOR_DECLARE
    #define ANY_GEOMETRY_DETECTOR_DECLARE dummy
	//struct pointer_to_global_geometry_list global_geometry_list = {0,NULL};
#endif

int loop_index,found_geometries;

double x_component;
double y_component;
double z_component;

struct Volume_struct this_box_volume;
struct box_storage this_box_storage;

#line 61891 "MACS_sample_kidney_box.c"
#undef number_of_activations
#undef mask_setting
#undef mask_string
#undef p_interact
#undef focus_r
#undef focus_xh
#undef focus_xw
#undef focus_ah
#undef focus_aw
#undef target_z
#undef target_y
#undef target_x
#undef target_index
#undef visualize
#undef yheight2
#undef xwidth2
#undef zdepth
#undef yheight
#undef xwidth
#undef priority
#undef material_string
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

/* User declarations for component 'channel_11_cave1_cyl1' [545]. */
#define mccompcurname  channel_11_cave1_cyl1
#define mccompcurtype  Union_cylinder
#define mccompcurindex 545
#define loop_index mccchannel_11_cave1_cyl1_loop_index
#define this_cylinder_volume mccchannel_11_cave1_cyl1_this_cylinder_volume
#define global_geometry_element mccchannel_11_cave1_cyl1_global_geometry_element
#define this_cylinder_storage mccchannel_11_cave1_cyl1_this_cylinder_storage
#define material_string mccchannel_11_cave1_cyl1_material_string
#define priority mccchannel_11_cave1_cyl1_priority
#define radius mccchannel_11_cave1_cyl1_radius
#define yheight mccchannel_11_cave1_cyl1_yheight
#define visualize mccchannel_11_cave1_cyl1_visualize
#define target_index mccchannel_11_cave1_cyl1_target_index
#define target_x mccchannel_11_cave1_cyl1_target_x
#define target_y mccchannel_11_cave1_cyl1_target_y
#define target_z mccchannel_11_cave1_cyl1_target_z
#define focus_aw mccchannel_11_cave1_cyl1_focus_aw
#define focus_ah mccchannel_11_cave1_cyl1_focus_ah
#define focus_xw mccchannel_11_cave1_cyl1_focus_xw
#define focus_xh mccchannel_11_cave1_cyl1_focus_xh
#define focus_r mccchannel_11_cave1_cyl1_focus_r
#define p_interact mccchannel_11_cave1_cyl1_p_interact
#define mask_string mccchannel_11_cave1_cyl1_mask_string
#define mask_setting mccchannel_11_cave1_cyl1_mask_setting
#define number_of_activations mccchannel_11_cave1_cyl1_number_of_activations
#line 167 "Union_cylinder.comp"
// Needed for transport to the main component
struct global_geometry_element_struct global_geometry_element;

#ifndef ANY_GEOMETRY_DETECTOR_DECLARE
    #define ANY_GEOMETRY_DETECTOR_DECLARE dummy
	//struct pointer_to_global_geometry_list global_geometry_list = {0,NULL};
#endif

int dummy;
int loop_index,found_geometries;
int loop_2_index;
int material_index;

struct Volume_struct this_cylinder_volume;
struct cylinder_storage this_cylinder_storage;
#line 61963 "MACS_sample_kidney_box.c"
#undef number_of_activations
#undef mask_setting
#undef mask_string
#undef p_interact
#undef focus_r
#undef focus_xh
#undef focus_xw
#undef focus_ah
#undef focus_aw
#undef target_z
#undef target_y
#undef target_x
#undef target_index
#undef visualize
#undef yheight
#undef radius
#undef priority
#undef material_string
#undef this_cylinder_storage
#undef global_geometry_element
#undef this_cylinder_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

/* User declarations for component 'channel_11_analyzer_1_center' [546]. */
#define mccompcurname  channel_11_analyzer_1_center
#define mccompcurtype  Arm
#define mccompcurindex 546
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

/* User declarations for component 'channel_11_analyzer_1_rotated' [547]. */
#define mccompcurname  channel_11_analyzer_1_rotated
#define mccompcurtype  Arm
#define mccompcurindex 547
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

/* User declarations for component 'channel_11_analyzer_1_array_crystal_array_0' [548]. */
#define mccompcurname  channel_11_analyzer_1_array_crystal_array_0
#define mccompcurtype  Union_box
#define mccompcurindex 548
#define loop_index mccchannel_11_analyzer_1_array_crystal_array_0_loop_index
#define this_box_volume mccchannel_11_analyzer_1_array_crystal_array_0_this_box_volume
#define global_geometry_element mccchannel_11_analyzer_1_array_crystal_array_0_global_geometry_element
#define this_box_storage mccchannel_11_analyzer_1_array_crystal_array_0_this_box_storage
#define material_string mccchannel_11_analyzer_1_array_crystal_array_0_material_string
#define priority mccchannel_11_analyzer_1_array_crystal_array_0_priority
#define xwidth mccchannel_11_analyzer_1_array_crystal_array_0_xwidth
#define yheight mccchannel_11_analyzer_1_array_crystal_array_0_yheight
#define zdepth mccchannel_11_analyzer_1_array_crystal_array_0_zdepth
#define xwidth2 mccchannel_11_analyzer_1_array_crystal_array_0_xwidth2
#define yheight2 mccchannel_11_analyzer_1_array_crystal_array_0_yheight2
#define visualize mccchannel_11_analyzer_1_array_crystal_array_0_visualize
#define target_index mccchannel_11_analyzer_1_array_crystal_array_0_target_index
#define target_x mccchannel_11_analyzer_1_array_crystal_array_0_target_x
#define target_y mccchannel_11_analyzer_1_array_crystal_array_0_target_y
#define target_z mccchannel_11_analyzer_1_array_crystal_array_0_target_z
#define focus_aw mccchannel_11_analyzer_1_array_crystal_array_0_focus_aw
#define focus_ah mccchannel_11_analyzer_1_array_crystal_array_0_focus_ah
#define focus_xw mccchannel_11_analyzer_1_array_crystal_array_0_focus_xw
#define focus_xh mccchannel_11_analyzer_1_array_crystal_array_0_focus_xh
#define focus_r mccchannel_11_analyzer_1_array_crystal_array_0_focus_r
#define p_interact mccchannel_11_analyzer_1_array_crystal_array_0_p_interact
#define mask_string mccchannel_11_analyzer_1_array_crystal_array_0_mask_string
#define mask_setting mccchannel_11_analyzer_1_array_crystal_array_0_mask_setting
#define number_of_activations mccchannel_11_analyzer_1_array_crystal_array_0_number_of_activations
#line 204 "Union_box.comp"
// Needed for transport to the main component
struct global_geometry_element_struct global_geometry_element;

#ifndef ANY_GEOMETRY_DETECTOR_DECLARE
    #define ANY_GEOMETRY_DETECTOR_DECLARE dummy
	//struct pointer_to_global_geometry_list global_geometry_list = {0,NULL};
#endif

int loop_index,found_geometries;

double x_component;
double y_component;
double z_component;

struct Volume_struct this_box_volume;
struct box_storage this_box_storage;

#line 62053 "MACS_sample_kidney_box.c"
#undef number_of_activations
#undef mask_setting
#undef mask_string
#undef p_interact
#undef focus_r
#undef focus_xh
#undef focus_xw
#undef focus_ah
#undef focus_aw
#undef target_z
#undef target_y
#undef target_x
#undef target_index
#undef visualize
#undef yheight2
#undef xwidth2
#undef zdepth
#undef yheight
#undef xwidth
#undef priority
#undef material_string
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

/* User declarations for component 'channel_11_analyzer_1_array_crystal_array_1' [549]. */
#define mccompcurname  channel_11_analyzer_1_array_crystal_array_1
#define mccompcurtype  Union_box
#define mccompcurindex 549
#define loop_index mccchannel_11_analyzer_1_array_crystal_array_1_loop_index
#define this_box_volume mccchannel_11_analyzer_1_array_crystal_array_1_this_box_volume
#define global_geometry_element mccchannel_11_analyzer_1_array_crystal_array_1_global_geometry_element
#define this_box_storage mccchannel_11_analyzer_1_array_crystal_array_1_this_box_storage
#define material_string mccchannel_11_analyzer_1_array_crystal_array_1_material_string
#define priority mccchannel_11_analyzer_1_array_crystal_array_1_priority
#define xwidth mccchannel_11_analyzer_1_array_crystal_array_1_xwidth
#define yheight mccchannel_11_analyzer_1_array_crystal_array_1_yheight
#define zdepth mccchannel_11_analyzer_1_array_crystal_array_1_zdepth
#define xwidth2 mccchannel_11_analyzer_1_array_crystal_array_1_xwidth2
#define yheight2 mccchannel_11_analyzer_1_array_crystal_array_1_yheight2
#define visualize mccchannel_11_analyzer_1_array_crystal_array_1_visualize
#define target_index mccchannel_11_analyzer_1_array_crystal_array_1_target_index
#define target_x mccchannel_11_analyzer_1_array_crystal_array_1_target_x
#define target_y mccchannel_11_analyzer_1_array_crystal_array_1_target_y
#define target_z mccchannel_11_analyzer_1_array_crystal_array_1_target_z
#define focus_aw mccchannel_11_analyzer_1_array_crystal_array_1_focus_aw
#define focus_ah mccchannel_11_analyzer_1_array_crystal_array_1_focus_ah
#define focus_xw mccchannel_11_analyzer_1_array_crystal_array_1_focus_xw
#define focus_xh mccchannel_11_analyzer_1_array_crystal_array_1_focus_xh
#define focus_r mccchannel_11_analyzer_1_array_crystal_array_1_focus_r
#define p_interact mccchannel_11_analyzer_1_array_crystal_array_1_p_interact
#define mask_string mccchannel_11_analyzer_1_array_crystal_array_1_mask_string
#define mask_setting mccchannel_11_analyzer_1_array_crystal_array_1_mask_setting
#define number_of_activations mccchannel_11_analyzer_1_array_crystal_array_1_number_of_activations
#line 204 "Union_box.comp"
// Needed for transport to the main component
struct global_geometry_element_struct global_geometry_element;

#ifndef ANY_GEOMETRY_DETECTOR_DECLARE
    #define ANY_GEOMETRY_DETECTOR_DECLARE dummy
	//struct pointer_to_global_geometry_list global_geometry_list = {0,NULL};
#endif

int loop_index,found_geometries;

double x_component;
double y_component;
double z_component;

struct Volume_struct this_box_volume;
struct box_storage this_box_storage;

#line 62130 "MACS_sample_kidney_box.c"
#undef number_of_activations
#undef mask_setting
#undef mask_string
#undef p_interact
#undef focus_r
#undef focus_xh
#undef focus_xw
#undef focus_ah
#undef focus_aw
#undef target_z
#undef target_y
#undef target_x
#undef target_index
#undef visualize
#undef yheight2
#undef xwidth2
#undef zdepth
#undef yheight
#undef xwidth
#undef priority
#undef material_string
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

/* User declarations for component 'channel_11_analyzer_1_array_crystal_array_2' [550]. */
#define mccompcurname  channel_11_analyzer_1_array_crystal_array_2
#define mccompcurtype  Union_box
#define mccompcurindex 550
#define loop_index mccchannel_11_analyzer_1_array_crystal_array_2_loop_index
#define this_box_volume mccchannel_11_analyzer_1_array_crystal_array_2_this_box_volume
#define global_geometry_element mccchannel_11_analyzer_1_array_crystal_array_2_global_geometry_element
#define this_box_storage mccchannel_11_analyzer_1_array_crystal_array_2_this_box_storage
#define material_string mccchannel_11_analyzer_1_array_crystal_array_2_material_string
#define priority mccchannel_11_analyzer_1_array_crystal_array_2_priority
#define xwidth mccchannel_11_analyzer_1_array_crystal_array_2_xwidth
#define yheight mccchannel_11_analyzer_1_array_crystal_array_2_yheight
#define zdepth mccchannel_11_analyzer_1_array_crystal_array_2_zdepth
#define xwidth2 mccchannel_11_analyzer_1_array_crystal_array_2_xwidth2
#define yheight2 mccchannel_11_analyzer_1_array_crystal_array_2_yheight2
#define visualize mccchannel_11_analyzer_1_array_crystal_array_2_visualize
#define target_index mccchannel_11_analyzer_1_array_crystal_array_2_target_index
#define target_x mccchannel_11_analyzer_1_array_crystal_array_2_target_x
#define target_y mccchannel_11_analyzer_1_array_crystal_array_2_target_y
#define target_z mccchannel_11_analyzer_1_array_crystal_array_2_target_z
#define focus_aw mccchannel_11_analyzer_1_array_crystal_array_2_focus_aw
#define focus_ah mccchannel_11_analyzer_1_array_crystal_array_2_focus_ah
#define focus_xw mccchannel_11_analyzer_1_array_crystal_array_2_focus_xw
#define focus_xh mccchannel_11_analyzer_1_array_crystal_array_2_focus_xh
#define focus_r mccchannel_11_analyzer_1_array_crystal_array_2_focus_r
#define p_interact mccchannel_11_analyzer_1_array_crystal_array_2_p_interact
#define mask_string mccchannel_11_analyzer_1_array_crystal_array_2_mask_string
#define mask_setting mccchannel_11_analyzer_1_array_crystal_array_2_mask_setting
#define number_of_activations mccchannel_11_analyzer_1_array_crystal_array_2_number_of_activations
#line 204 "Union_box.comp"
// Needed for transport to the main component
struct global_geometry_element_struct global_geometry_element;

#ifndef ANY_GEOMETRY_DETECTOR_DECLARE
    #define ANY_GEOMETRY_DETECTOR_DECLARE dummy
	//struct pointer_to_global_geometry_list global_geometry_list = {0,NULL};
#endif

int loop_index,found_geometries;

double x_component;
double y_component;
double z_component;

struct Volume_struct this_box_volume;
struct box_storage this_box_storage;

#line 62207 "MACS_sample_kidney_box.c"
#undef number_of_activations
#undef mask_setting
#undef mask_string
#undef p_interact
#undef focus_r
#undef focus_xh
#undef focus_xw
#undef focus_ah
#undef focus_aw
#undef target_z
#undef target_y
#undef target_x
#undef target_index
#undef visualize
#undef yheight2
#undef xwidth2
#undef zdepth
#undef yheight
#undef xwidth
#undef priority
#undef material_string
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

/* User declarations for component 'channel_11_analyzer_1_array_crystal_array_3' [551]. */
#define mccompcurname  channel_11_analyzer_1_array_crystal_array_3
#define mccompcurtype  Union_box
#define mccompcurindex 551
#define loop_index mccchannel_11_analyzer_1_array_crystal_array_3_loop_index
#define this_box_volume mccchannel_11_analyzer_1_array_crystal_array_3_this_box_volume
#define global_geometry_element mccchannel_11_analyzer_1_array_crystal_array_3_global_geometry_element
#define this_box_storage mccchannel_11_analyzer_1_array_crystal_array_3_this_box_storage
#define material_string mccchannel_11_analyzer_1_array_crystal_array_3_material_string
#define priority mccchannel_11_analyzer_1_array_crystal_array_3_priority
#define xwidth mccchannel_11_analyzer_1_array_crystal_array_3_xwidth
#define yheight mccchannel_11_analyzer_1_array_crystal_array_3_yheight
#define zdepth mccchannel_11_analyzer_1_array_crystal_array_3_zdepth
#define xwidth2 mccchannel_11_analyzer_1_array_crystal_array_3_xwidth2
#define yheight2 mccchannel_11_analyzer_1_array_crystal_array_3_yheight2
#define visualize mccchannel_11_analyzer_1_array_crystal_array_3_visualize
#define target_index mccchannel_11_analyzer_1_array_crystal_array_3_target_index
#define target_x mccchannel_11_analyzer_1_array_crystal_array_3_target_x
#define target_y mccchannel_11_analyzer_1_array_crystal_array_3_target_y
#define target_z mccchannel_11_analyzer_1_array_crystal_array_3_target_z
#define focus_aw mccchannel_11_analyzer_1_array_crystal_array_3_focus_aw
#define focus_ah mccchannel_11_analyzer_1_array_crystal_array_3_focus_ah
#define focus_xw mccchannel_11_analyzer_1_array_crystal_array_3_focus_xw
#define focus_xh mccchannel_11_analyzer_1_array_crystal_array_3_focus_xh
#define focus_r mccchannel_11_analyzer_1_array_crystal_array_3_focus_r
#define p_interact mccchannel_11_analyzer_1_array_crystal_array_3_p_interact
#define mask_string mccchannel_11_analyzer_1_array_crystal_array_3_mask_string
#define mask_setting mccchannel_11_analyzer_1_array_crystal_array_3_mask_setting
#define number_of_activations mccchannel_11_analyzer_1_array_crystal_array_3_number_of_activations
#line 204 "Union_box.comp"
// Needed for transport to the main component
struct global_geometry_element_struct global_geometry_element;

#ifndef ANY_GEOMETRY_DETECTOR_DECLARE
    #define ANY_GEOMETRY_DETECTOR_DECLARE dummy
	//struct pointer_to_global_geometry_list global_geometry_list = {0,NULL};
#endif

int loop_index,found_geometries;

double x_component;
double y_component;
double z_component;

struct Volume_struct this_box_volume;
struct box_storage this_box_storage;

#line 62284 "MACS_sample_kidney_box.c"
#undef number_of_activations
#undef mask_setting
#undef mask_string
#undef p_interact
#undef focus_r
#undef focus_xh
#undef focus_xw
#undef focus_ah
#undef focus_aw
#undef target_z
#undef target_y
#undef target_x
#undef target_index
#undef visualize
#undef yheight2
#undef xwidth2
#undef zdepth
#undef yheight
#undef xwidth
#undef priority
#undef material_string
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

/* User declarations for component 'channel_11_analyzer_1_array_crystal_array_4' [552]. */
#define mccompcurname  channel_11_analyzer_1_array_crystal_array_4
#define mccompcurtype  Union_box
#define mccompcurindex 552
#define loop_index mccchannel_11_analyzer_1_array_crystal_array_4_loop_index
#define this_box_volume mccchannel_11_analyzer_1_array_crystal_array_4_this_box_volume
#define global_geometry_element mccchannel_11_analyzer_1_array_crystal_array_4_global_geometry_element
#define this_box_storage mccchannel_11_analyzer_1_array_crystal_array_4_this_box_storage
#define material_string mccchannel_11_analyzer_1_array_crystal_array_4_material_string
#define priority mccchannel_11_analyzer_1_array_crystal_array_4_priority
#define xwidth mccchannel_11_analyzer_1_array_crystal_array_4_xwidth
#define yheight mccchannel_11_analyzer_1_array_crystal_array_4_yheight
#define zdepth mccchannel_11_analyzer_1_array_crystal_array_4_zdepth
#define xwidth2 mccchannel_11_analyzer_1_array_crystal_array_4_xwidth2
#define yheight2 mccchannel_11_analyzer_1_array_crystal_array_4_yheight2
#define visualize mccchannel_11_analyzer_1_array_crystal_array_4_visualize
#define target_index mccchannel_11_analyzer_1_array_crystal_array_4_target_index
#define target_x mccchannel_11_analyzer_1_array_crystal_array_4_target_x
#define target_y mccchannel_11_analyzer_1_array_crystal_array_4_target_y
#define target_z mccchannel_11_analyzer_1_array_crystal_array_4_target_z
#define focus_aw mccchannel_11_analyzer_1_array_crystal_array_4_focus_aw
#define focus_ah mccchannel_11_analyzer_1_array_crystal_array_4_focus_ah
#define focus_xw mccchannel_11_analyzer_1_array_crystal_array_4_focus_xw
#define focus_xh mccchannel_11_analyzer_1_array_crystal_array_4_focus_xh
#define focus_r mccchannel_11_analyzer_1_array_crystal_array_4_focus_r
#define p_interact mccchannel_11_analyzer_1_array_crystal_array_4_p_interact
#define mask_string mccchannel_11_analyzer_1_array_crystal_array_4_mask_string
#define mask_setting mccchannel_11_analyzer_1_array_crystal_array_4_mask_setting
#define number_of_activations mccchannel_11_analyzer_1_array_crystal_array_4_number_of_activations
#line 204 "Union_box.comp"
// Needed for transport to the main component
struct global_geometry_element_struct global_geometry_element;

#ifndef ANY_GEOMETRY_DETECTOR_DECLARE
    #define ANY_GEOMETRY_DETECTOR_DECLARE dummy
	//struct pointer_to_global_geometry_list global_geometry_list = {0,NULL};
#endif

int loop_index,found_geometries;

double x_component;
double y_component;
double z_component;

struct Volume_struct this_box_volume;
struct box_storage this_box_storage;

#line 62361 "MACS_sample_kidney_box.c"
#undef number_of_activations
#undef mask_setting
#undef mask_string
#undef p_interact
#undef focus_r
#undef focus_xh
#undef focus_xw
#undef focus_ah
#undef focus_aw
#undef target_z
#undef target_y
#undef target_x
#undef target_index
#undef visualize
#undef yheight2
#undef xwidth2
#undef zdepth
#undef yheight
#undef xwidth
#undef priority
#undef material_string
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

/* User declarations for component 'channel_11_analyzer_1_array_crystal_array_5' [553]. */
#define mccompcurname  channel_11_analyzer_1_array_crystal_array_5
#define mccompcurtype  Union_box
#define mccompcurindex 553
#define loop_index mccchannel_11_analyzer_1_array_crystal_array_5_loop_index
#define this_box_volume mccchannel_11_analyzer_1_array_crystal_array_5_this_box_volume
#define global_geometry_element mccchannel_11_analyzer_1_array_crystal_array_5_global_geometry_element
#define this_box_storage mccchannel_11_analyzer_1_array_crystal_array_5_this_box_storage
#define material_string mccchannel_11_analyzer_1_array_crystal_array_5_material_string
#define priority mccchannel_11_analyzer_1_array_crystal_array_5_priority
#define xwidth mccchannel_11_analyzer_1_array_crystal_array_5_xwidth
#define yheight mccchannel_11_analyzer_1_array_crystal_array_5_yheight
#define zdepth mccchannel_11_analyzer_1_array_crystal_array_5_zdepth
#define xwidth2 mccchannel_11_analyzer_1_array_crystal_array_5_xwidth2
#define yheight2 mccchannel_11_analyzer_1_array_crystal_array_5_yheight2
#define visualize mccchannel_11_analyzer_1_array_crystal_array_5_visualize
#define target_index mccchannel_11_analyzer_1_array_crystal_array_5_target_index
#define target_x mccchannel_11_analyzer_1_array_crystal_array_5_target_x
#define target_y mccchannel_11_analyzer_1_array_crystal_array_5_target_y
#define target_z mccchannel_11_analyzer_1_array_crystal_array_5_target_z
#define focus_aw mccchannel_11_analyzer_1_array_crystal_array_5_focus_aw
#define focus_ah mccchannel_11_analyzer_1_array_crystal_array_5_focus_ah
#define focus_xw mccchannel_11_analyzer_1_array_crystal_array_5_focus_xw
#define focus_xh mccchannel_11_analyzer_1_array_crystal_array_5_focus_xh
#define focus_r mccchannel_11_analyzer_1_array_crystal_array_5_focus_r
#define p_interact mccchannel_11_analyzer_1_array_crystal_array_5_p_interact
#define mask_string mccchannel_11_analyzer_1_array_crystal_array_5_mask_string
#define mask_setting mccchannel_11_analyzer_1_array_crystal_array_5_mask_setting
#define number_of_activations mccchannel_11_analyzer_1_array_crystal_array_5_number_of_activations
#line 204 "Union_box.comp"
// Needed for transport to the main component
struct global_geometry_element_struct global_geometry_element;

#ifndef ANY_GEOMETRY_DETECTOR_DECLARE
    #define ANY_GEOMETRY_DETECTOR_DECLARE dummy
	//struct pointer_to_global_geometry_list global_geometry_list = {0,NULL};
#endif

int loop_index,found_geometries;

double x_component;
double y_component;
double z_component;

struct Volume_struct this_box_volume;
struct box_storage this_box_storage;

#line 62438 "MACS_sample_kidney_box.c"
#undef number_of_activations
#undef mask_setting
#undef mask_string
#undef p_interact
#undef focus_r
#undef focus_xh
#undef focus_xw
#undef focus_ah
#undef focus_aw
#undef target_z
#undef target_y
#undef target_x
#undef target_index
#undef visualize
#undef yheight2
#undef xwidth2
#undef zdepth
#undef yheight
#undef xwidth
#undef priority
#undef material_string
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

/* User declarations for component 'channel_11_analyzer_1_array_crystal_array_6' [554]. */
#define mccompcurname  channel_11_analyzer_1_array_crystal_array_6
#define mccompcurtype  Union_box
#define mccompcurindex 554
#define loop_index mccchannel_11_analyzer_1_array_crystal_array_6_loop_index
#define this_box_volume mccchannel_11_analyzer_1_array_crystal_array_6_this_box_volume
#define global_geometry_element mccchannel_11_analyzer_1_array_crystal_array_6_global_geometry_element
#define this_box_storage mccchannel_11_analyzer_1_array_crystal_array_6_this_box_storage
#define material_string mccchannel_11_analyzer_1_array_crystal_array_6_material_string
#define priority mccchannel_11_analyzer_1_array_crystal_array_6_priority
#define xwidth mccchannel_11_analyzer_1_array_crystal_array_6_xwidth
#define yheight mccchannel_11_analyzer_1_array_crystal_array_6_yheight
#define zdepth mccchannel_11_analyzer_1_array_crystal_array_6_zdepth
#define xwidth2 mccchannel_11_analyzer_1_array_crystal_array_6_xwidth2
#define yheight2 mccchannel_11_analyzer_1_array_crystal_array_6_yheight2
#define visualize mccchannel_11_analyzer_1_array_crystal_array_6_visualize
#define target_index mccchannel_11_analyzer_1_array_crystal_array_6_target_index
#define target_x mccchannel_11_analyzer_1_array_crystal_array_6_target_x
#define target_y mccchannel_11_analyzer_1_array_crystal_array_6_target_y
#define target_z mccchannel_11_analyzer_1_array_crystal_array_6_target_z
#define focus_aw mccchannel_11_analyzer_1_array_crystal_array_6_focus_aw
#define focus_ah mccchannel_11_analyzer_1_array_crystal_array_6_focus_ah
#define focus_xw mccchannel_11_analyzer_1_array_crystal_array_6_focus_xw
#define focus_xh mccchannel_11_analyzer_1_array_crystal_array_6_focus_xh
#define focus_r mccchannel_11_analyzer_1_array_crystal_array_6_focus_r
#define p_interact mccchannel_11_analyzer_1_array_crystal_array_6_p_interact
#define mask_string mccchannel_11_analyzer_1_array_crystal_array_6_mask_string
#define mask_setting mccchannel_11_analyzer_1_array_crystal_array_6_mask_setting
#define number_of_activations mccchannel_11_analyzer_1_array_crystal_array_6_number_of_activations
#line 204 "Union_box.comp"
// Needed for transport to the main component
struct global_geometry_element_struct global_geometry_element;

#ifndef ANY_GEOMETRY_DETECTOR_DECLARE
    #define ANY_GEOMETRY_DETECTOR_DECLARE dummy
	//struct pointer_to_global_geometry_list global_geometry_list = {0,NULL};
#endif

int loop_index,found_geometries;

double x_component;
double y_component;
double z_component;

struct Volume_struct this_box_volume;
struct box_storage this_box_storage;

#line 62515 "MACS_sample_kidney_box.c"
#undef number_of_activations
#undef mask_setting
#undef mask_string
#undef p_interact
#undef focus_r
#undef focus_xh
#undef focus_xw
#undef focus_ah
#undef focus_aw
#undef target_z
#undef target_y
#undef target_x
#undef target_index
#undef visualize
#undef yheight2
#undef xwidth2
#undef zdepth
#undef yheight
#undef xwidth
#undef priority
#undef material_string
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

/* User declarations for component 'channel_11_analyzer_1_array_crystal_array_7' [555]. */
#define mccompcurname  channel_11_analyzer_1_array_crystal_array_7
#define mccompcurtype  Union_box
#define mccompcurindex 555
#define loop_index mccchannel_11_analyzer_1_array_crystal_array_7_loop_index
#define this_box_volume mccchannel_11_analyzer_1_array_crystal_array_7_this_box_volume
#define global_geometry_element mccchannel_11_analyzer_1_array_crystal_array_7_global_geometry_element
#define this_box_storage mccchannel_11_analyzer_1_array_crystal_array_7_this_box_storage
#define material_string mccchannel_11_analyzer_1_array_crystal_array_7_material_string
#define priority mccchannel_11_analyzer_1_array_crystal_array_7_priority
#define xwidth mccchannel_11_analyzer_1_array_crystal_array_7_xwidth
#define yheight mccchannel_11_analyzer_1_array_crystal_array_7_yheight
#define zdepth mccchannel_11_analyzer_1_array_crystal_array_7_zdepth
#define xwidth2 mccchannel_11_analyzer_1_array_crystal_array_7_xwidth2
#define yheight2 mccchannel_11_analyzer_1_array_crystal_array_7_yheight2
#define visualize mccchannel_11_analyzer_1_array_crystal_array_7_visualize
#define target_index mccchannel_11_analyzer_1_array_crystal_array_7_target_index
#define target_x mccchannel_11_analyzer_1_array_crystal_array_7_target_x
#define target_y mccchannel_11_analyzer_1_array_crystal_array_7_target_y
#define target_z mccchannel_11_analyzer_1_array_crystal_array_7_target_z
#define focus_aw mccchannel_11_analyzer_1_array_crystal_array_7_focus_aw
#define focus_ah mccchannel_11_analyzer_1_array_crystal_array_7_focus_ah
#define focus_xw mccchannel_11_analyzer_1_array_crystal_array_7_focus_xw
#define focus_xh mccchannel_11_analyzer_1_array_crystal_array_7_focus_xh
#define focus_r mccchannel_11_analyzer_1_array_crystal_array_7_focus_r
#define p_interact mccchannel_11_analyzer_1_array_crystal_array_7_p_interact
#define mask_string mccchannel_11_analyzer_1_array_crystal_array_7_mask_string
#define mask_setting mccchannel_11_analyzer_1_array_crystal_array_7_mask_setting
#define number_of_activations mccchannel_11_analyzer_1_array_crystal_array_7_number_of_activations
#line 204 "Union_box.comp"
// Needed for transport to the main component
struct global_geometry_element_struct global_geometry_element;

#ifndef ANY_GEOMETRY_DETECTOR_DECLARE
    #define ANY_GEOMETRY_DETECTOR_DECLARE dummy
	//struct pointer_to_global_geometry_list global_geometry_list = {0,NULL};
#endif

int loop_index,found_geometries;

double x_component;
double y_component;
double z_component;

struct Volume_struct this_box_volume;
struct box_storage this_box_storage;

#line 62592 "MACS_sample_kidney_box.c"
#undef number_of_activations
#undef mask_setting
#undef mask_string
#undef p_interact
#undef focus_r
#undef focus_xh
#undef focus_xw
#undef focus_ah
#undef focus_aw
#undef target_z
#undef target_y
#undef target_x
#undef target_index
#undef visualize
#undef yheight2
#undef xwidth2
#undef zdepth
#undef yheight
#undef xwidth
#undef priority
#undef material_string
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

/* User declarations for component 'channel_11_analyzer_1_array_crystal_array_8' [556]. */
#define mccompcurname  channel_11_analyzer_1_array_crystal_array_8
#define mccompcurtype  Union_box
#define mccompcurindex 556
#define loop_index mccchannel_11_analyzer_1_array_crystal_array_8_loop_index
#define this_box_volume mccchannel_11_analyzer_1_array_crystal_array_8_this_box_volume
#define global_geometry_element mccchannel_11_analyzer_1_array_crystal_array_8_global_geometry_element
#define this_box_storage mccchannel_11_analyzer_1_array_crystal_array_8_this_box_storage
#define material_string mccchannel_11_analyzer_1_array_crystal_array_8_material_string
#define priority mccchannel_11_analyzer_1_array_crystal_array_8_priority
#define xwidth mccchannel_11_analyzer_1_array_crystal_array_8_xwidth
#define yheight mccchannel_11_analyzer_1_array_crystal_array_8_yheight
#define zdepth mccchannel_11_analyzer_1_array_crystal_array_8_zdepth
#define xwidth2 mccchannel_11_analyzer_1_array_crystal_array_8_xwidth2
#define yheight2 mccchannel_11_analyzer_1_array_crystal_array_8_yheight2
#define visualize mccchannel_11_analyzer_1_array_crystal_array_8_visualize
#define target_index mccchannel_11_analyzer_1_array_crystal_array_8_target_index
#define target_x mccchannel_11_analyzer_1_array_crystal_array_8_target_x
#define target_y mccchannel_11_analyzer_1_array_crystal_array_8_target_y
#define target_z mccchannel_11_analyzer_1_array_crystal_array_8_target_z
#define focus_aw mccchannel_11_analyzer_1_array_crystal_array_8_focus_aw
#define focus_ah mccchannel_11_analyzer_1_array_crystal_array_8_focus_ah
#define focus_xw mccchannel_11_analyzer_1_array_crystal_array_8_focus_xw
#define focus_xh mccchannel_11_analyzer_1_array_crystal_array_8_focus_xh
#define focus_r mccchannel_11_analyzer_1_array_crystal_array_8_focus_r
#define p_interact mccchannel_11_analyzer_1_array_crystal_array_8_p_interact
#define mask_string mccchannel_11_analyzer_1_array_crystal_array_8_mask_string
#define mask_setting mccchannel_11_analyzer_1_array_crystal_array_8_mask_setting
#define number_of_activations mccchannel_11_analyzer_1_array_crystal_array_8_number_of_activations
#line 204 "Union_box.comp"
// Needed for transport to the main component
struct global_geometry_element_struct global_geometry_element;

#ifndef ANY_GEOMETRY_DETECTOR_DECLARE
    #define ANY_GEOMETRY_DETECTOR_DECLARE dummy
	//struct pointer_to_global_geometry_list global_geometry_list = {0,NULL};
#endif

int loop_index,found_geometries;

double x_component;
double y_component;
double z_component;

struct Volume_struct this_box_volume;
struct box_storage this_box_storage;

#line 62669 "MACS_sample_kidney_box.c"
#undef number_of_activations
#undef mask_setting
#undef mask_string
#undef p_interact
#undef focus_r
#undef focus_xh
#undef focus_xw
#undef focus_ah
#undef focus_aw
#undef target_z
#undef target_y
#undef target_x
#undef target_index
#undef visualize
#undef yheight2
#undef xwidth2
#undef zdepth
#undef yheight
#undef xwidth
#undef priority
#undef material_string
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

/* User declarations for component 'channel_11_analyzer_2_center' [557]. */
#define mccompcurname  channel_11_analyzer_2_center
#define mccompcurtype  Arm
#define mccompcurindex 557
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

/* User declarations for component 'channel_11_analyzer_2_rotated' [558]. */
#define mccompcurname  channel_11_analyzer_2_rotated
#define mccompcurtype  Arm
#define mccompcurindex 558
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

/* User declarations for component 'channel_11_analyzer_2_array_crystal_array_0' [559]. */
#define mccompcurname  channel_11_analyzer_2_array_crystal_array_0
#define mccompcurtype  Union_box
#define mccompcurindex 559
#define loop_index mccchannel_11_analyzer_2_array_crystal_array_0_loop_index
#define this_box_volume mccchannel_11_analyzer_2_array_crystal_array_0_this_box_volume
#define global_geometry_element mccchannel_11_analyzer_2_array_crystal_array_0_global_geometry_element
#define this_box_storage mccchannel_11_analyzer_2_array_crystal_array_0_this_box_storage
#define material_string mccchannel_11_analyzer_2_array_crystal_array_0_material_string
#define priority mccchannel_11_analyzer_2_array_crystal_array_0_priority
#define xwidth mccchannel_11_analyzer_2_array_crystal_array_0_xwidth
#define yheight mccchannel_11_analyzer_2_array_crystal_array_0_yheight
#define zdepth mccchannel_11_analyzer_2_array_crystal_array_0_zdepth
#define xwidth2 mccchannel_11_analyzer_2_array_crystal_array_0_xwidth2
#define yheight2 mccchannel_11_analyzer_2_array_crystal_array_0_yheight2
#define visualize mccchannel_11_analyzer_2_array_crystal_array_0_visualize
#define target_index mccchannel_11_analyzer_2_array_crystal_array_0_target_index
#define target_x mccchannel_11_analyzer_2_array_crystal_array_0_target_x
#define target_y mccchannel_11_analyzer_2_array_crystal_array_0_target_y
#define target_z mccchannel_11_analyzer_2_array_crystal_array_0_target_z
#define focus_aw mccchannel_11_analyzer_2_array_crystal_array_0_focus_aw
#define focus_ah mccchannel_11_analyzer_2_array_crystal_array_0_focus_ah
#define focus_xw mccchannel_11_analyzer_2_array_crystal_array_0_focus_xw
#define focus_xh mccchannel_11_analyzer_2_array_crystal_array_0_focus_xh
#define focus_r mccchannel_11_analyzer_2_array_crystal_array_0_focus_r
#define p_interact mccchannel_11_analyzer_2_array_crystal_array_0_p_interact
#define mask_string mccchannel_11_analyzer_2_array_crystal_array_0_mask_string
#define mask_setting mccchannel_11_analyzer_2_array_crystal_array_0_mask_setting
#define number_of_activations mccchannel_11_analyzer_2_array_crystal_array_0_number_of_activations
#line 204 "Union_box.comp"
// Needed for transport to the main component
struct global_geometry_element_struct global_geometry_element;

#ifndef ANY_GEOMETRY_DETECTOR_DECLARE
    #define ANY_GEOMETRY_DETECTOR_DECLARE dummy
	//struct pointer_to_global_geometry_list global_geometry_list = {0,NULL};
#endif

int loop_index,found_geometries;

double x_component;
double y_component;
double z_component;

struct Volume_struct this_box_volume;
struct box_storage this_box_storage;

#line 62762 "MACS_sample_kidney_box.c"
#undef number_of_activations
#undef mask_setting
#undef mask_string
#undef p_interact
#undef focus_r
#undef focus_xh
#undef focus_xw
#undef focus_ah
#undef focus_aw
#undef target_z
#undef target_y
#undef target_x
#undef target_index
#undef visualize
#undef yheight2
#undef xwidth2
#undef zdepth
#undef yheight
#undef xwidth
#undef priority
#undef material_string
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

/* User declarations for component 'channel_11_analyzer_2_array_crystal_array_1' [560]. */
#define mccompcurname  channel_11_analyzer_2_array_crystal_array_1
#define mccompcurtype  Union_box
#define mccompcurindex 560
#define loop_index mccchannel_11_analyzer_2_array_crystal_array_1_loop_index
#define this_box_volume mccchannel_11_analyzer_2_array_crystal_array_1_this_box_volume
#define global_geometry_element mccchannel_11_analyzer_2_array_crystal_array_1_global_geometry_element
#define this_box_storage mccchannel_11_analyzer_2_array_crystal_array_1_this_box_storage
#define material_string mccchannel_11_analyzer_2_array_crystal_array_1_material_string
#define priority mccchannel_11_analyzer_2_array_crystal_array_1_priority
#define xwidth mccchannel_11_analyzer_2_array_crystal_array_1_xwidth
#define yheight mccchannel_11_analyzer_2_array_crystal_array_1_yheight
#define zdepth mccchannel_11_analyzer_2_array_crystal_array_1_zdepth
#define xwidth2 mccchannel_11_analyzer_2_array_crystal_array_1_xwidth2
#define yheight2 mccchannel_11_analyzer_2_array_crystal_array_1_yheight2
#define visualize mccchannel_11_analyzer_2_array_crystal_array_1_visualize
#define target_index mccchannel_11_analyzer_2_array_crystal_array_1_target_index
#define target_x mccchannel_11_analyzer_2_array_crystal_array_1_target_x
#define target_y mccchannel_11_analyzer_2_array_crystal_array_1_target_y
#define target_z mccchannel_11_analyzer_2_array_crystal_array_1_target_z
#define focus_aw mccchannel_11_analyzer_2_array_crystal_array_1_focus_aw
#define focus_ah mccchannel_11_analyzer_2_array_crystal_array_1_focus_ah
#define focus_xw mccchannel_11_analyzer_2_array_crystal_array_1_focus_xw
#define focus_xh mccchannel_11_analyzer_2_array_crystal_array_1_focus_xh
#define focus_r mccchannel_11_analyzer_2_array_crystal_array_1_focus_r
#define p_interact mccchannel_11_analyzer_2_array_crystal_array_1_p_interact
#define mask_string mccchannel_11_analyzer_2_array_crystal_array_1_mask_string
#define mask_setting mccchannel_11_analyzer_2_array_crystal_array_1_mask_setting
#define number_of_activations mccchannel_11_analyzer_2_array_crystal_array_1_number_of_activations
#line 204 "Union_box.comp"
// Needed for transport to the main component
struct global_geometry_element_struct global_geometry_element;

#ifndef ANY_GEOMETRY_DETECTOR_DECLARE
    #define ANY_GEOMETRY_DETECTOR_DECLARE dummy
	//struct pointer_to_global_geometry_list global_geometry_list = {0,NULL};
#endif

int loop_index,found_geometries;

double x_component;
double y_component;
double z_component;

struct Volume_struct this_box_volume;
struct box_storage this_box_storage;

#line 62839 "MACS_sample_kidney_box.c"
#undef number_of_activations
#undef mask_setting
#undef mask_string
#undef p_interact
#undef focus_r
#undef focus_xh
#undef focus_xw
#undef focus_ah
#undef focus_aw
#undef target_z
#undef target_y
#undef target_x
#undef target_index
#undef visualize
#undef yheight2
#undef xwidth2
#undef zdepth
#undef yheight
#undef xwidth
#undef priority
#undef material_string
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

/* User declarations for component 'channel_11_analyzer_2_array_crystal_array_2' [561]. */
#define mccompcurname  channel_11_analyzer_2_array_crystal_array_2
#define mccompcurtype  Union_box
#define mccompcurindex 561
#define loop_index mccchannel_11_analyzer_2_array_crystal_array_2_loop_index
#define this_box_volume mccchannel_11_analyzer_2_array_crystal_array_2_this_box_volume
#define global_geometry_element mccchannel_11_analyzer_2_array_crystal_array_2_global_geometry_element
#define this_box_storage mccchannel_11_analyzer_2_array_crystal_array_2_this_box_storage
#define material_string mccchannel_11_analyzer_2_array_crystal_array_2_material_string
#define priority mccchannel_11_analyzer_2_array_crystal_array_2_priority
#define xwidth mccchannel_11_analyzer_2_array_crystal_array_2_xwidth
#define yheight mccchannel_11_analyzer_2_array_crystal_array_2_yheight
#define zdepth mccchannel_11_analyzer_2_array_crystal_array_2_zdepth
#define xwidth2 mccchannel_11_analyzer_2_array_crystal_array_2_xwidth2
#define yheight2 mccchannel_11_analyzer_2_array_crystal_array_2_yheight2
#define visualize mccchannel_11_analyzer_2_array_crystal_array_2_visualize
#define target_index mccchannel_11_analyzer_2_array_crystal_array_2_target_index
#define target_x mccchannel_11_analyzer_2_array_crystal_array_2_target_x
#define target_y mccchannel_11_analyzer_2_array_crystal_array_2_target_y
#define target_z mccchannel_11_analyzer_2_array_crystal_array_2_target_z
#define focus_aw mccchannel_11_analyzer_2_array_crystal_array_2_focus_aw
#define focus_ah mccchannel_11_analyzer_2_array_crystal_array_2_focus_ah
#define focus_xw mccchannel_11_analyzer_2_array_crystal_array_2_focus_xw
#define focus_xh mccchannel_11_analyzer_2_array_crystal_array_2_focus_xh
#define focus_r mccchannel_11_analyzer_2_array_crystal_array_2_focus_r
#define p_interact mccchannel_11_analyzer_2_array_crystal_array_2_p_interact
#define mask_string mccchannel_11_analyzer_2_array_crystal_array_2_mask_string
#define mask_setting mccchannel_11_analyzer_2_array_crystal_array_2_mask_setting
#define number_of_activations mccchannel_11_analyzer_2_array_crystal_array_2_number_of_activations
#line 204 "Union_box.comp"
// Needed for transport to the main component
struct global_geometry_element_struct global_geometry_element;

#ifndef ANY_GEOMETRY_DETECTOR_DECLARE
    #define ANY_GEOMETRY_DETECTOR_DECLARE dummy
	//struct pointer_to_global_geometry_list global_geometry_list = {0,NULL};
#endif

int loop_index,found_geometries;

double x_component;
double y_component;
double z_component;

struct Volume_struct this_box_volume;
struct box_storage this_box_storage;

#line 62916 "MACS_sample_kidney_box.c"
#undef number_of_activations
#undef mask_setting
#undef mask_string
#undef p_interact
#undef focus_r
#undef focus_xh
#undef focus_xw
#undef focus_ah
#undef focus_aw
#undef target_z
#undef target_y
#undef target_x
#undef target_index
#undef visualize
#undef yheight2
#undef xwidth2
#undef zdepth
#undef yheight
#undef xwidth
#undef priority
#undef material_string
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

/* User declarations for component 'channel_11_analyzer_2_array_crystal_array_3' [562]. */
#define mccompcurname  channel_11_analyzer_2_array_crystal_array_3
#define mccompcurtype  Union_box
#define mccompcurindex 562
#define loop_index mccchannel_11_analyzer_2_array_crystal_array_3_loop_index
#define this_box_volume mccchannel_11_analyzer_2_array_crystal_array_3_this_box_volume
#define global_geometry_element mccchannel_11_analyzer_2_array_crystal_array_3_global_geometry_element
#define this_box_storage mccchannel_11_analyzer_2_array_crystal_array_3_this_box_storage
#define material_string mccchannel_11_analyzer_2_array_crystal_array_3_material_string
#define priority mccchannel_11_analyzer_2_array_crystal_array_3_priority
#define xwidth mccchannel_11_analyzer_2_array_crystal_array_3_xwidth
#define yheight mccchannel_11_analyzer_2_array_crystal_array_3_yheight
#define zdepth mccchannel_11_analyzer_2_array_crystal_array_3_zdepth
#define xwidth2 mccchannel_11_analyzer_2_array_crystal_array_3_xwidth2
#define yheight2 mccchannel_11_analyzer_2_array_crystal_array_3_yheight2
#define visualize mccchannel_11_analyzer_2_array_crystal_array_3_visualize
#define target_index mccchannel_11_analyzer_2_array_crystal_array_3_target_index
#define target_x mccchannel_11_analyzer_2_array_crystal_array_3_target_x
#define target_y mccchannel_11_analyzer_2_array_crystal_array_3_target_y
#define target_z mccchannel_11_analyzer_2_array_crystal_array_3_target_z
#define focus_aw mccchannel_11_analyzer_2_array_crystal_array_3_focus_aw
#define focus_ah mccchannel_11_analyzer_2_array_crystal_array_3_focus_ah
#define focus_xw mccchannel_11_analyzer_2_array_crystal_array_3_focus_xw
#define focus_xh mccchannel_11_analyzer_2_array_crystal_array_3_focus_xh
#define focus_r mccchannel_11_analyzer_2_array_crystal_array_3_focus_r
#define p_interact mccchannel_11_analyzer_2_array_crystal_array_3_p_interact
#define mask_string mccchannel_11_analyzer_2_array_crystal_array_3_mask_string
#define mask_setting mccchannel_11_analyzer_2_array_crystal_array_3_mask_setting
#define number_of_activations mccchannel_11_analyzer_2_array_crystal_array_3_number_of_activations
#line 204 "Union_box.comp"
// Needed for transport to the main component
struct global_geometry_element_struct global_geometry_element;

#ifndef ANY_GEOMETRY_DETECTOR_DECLARE
    #define ANY_GEOMETRY_DETECTOR_DECLARE dummy
	//struct pointer_to_global_geometry_list global_geometry_list = {0,NULL};
#endif

int loop_index,found_geometries;

double x_component;
double y_component;
double z_component;

struct Volume_struct this_box_volume;
struct box_storage this_box_storage;

#line 62993 "MACS_sample_kidney_box.c"
#undef number_of_activations
#undef mask_setting
#undef mask_string
#undef p_interact
#undef focus_r
#undef focus_xh
#undef focus_xw
#undef focus_ah
#undef focus_aw
#undef target_z
#undef target_y
#undef target_x
#undef target_index
#undef visualize
#undef yheight2
#undef xwidth2
#undef zdepth
#undef yheight
#undef xwidth
#undef priority
#undef material_string
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

/* User declarations for component 'channel_11_analyzer_2_array_crystal_array_4' [563]. */
#define mccompcurname  channel_11_analyzer_2_array_crystal_array_4
#define mccompcurtype  Union_box
#define mccompcurindex 563
#define loop_index mccchannel_11_analyzer_2_array_crystal_array_4_loop_index
#define this_box_volume mccchannel_11_analyzer_2_array_crystal_array_4_this_box_volume
#define global_geometry_element mccchannel_11_analyzer_2_array_crystal_array_4_global_geometry_element
#define this_box_storage mccchannel_11_analyzer_2_array_crystal_array_4_this_box_storage
#define material_string mccchannel_11_analyzer_2_array_crystal_array_4_material_string
#define priority mccchannel_11_analyzer_2_array_crystal_array_4_priority
#define xwidth mccchannel_11_analyzer_2_array_crystal_array_4_xwidth
#define yheight mccchannel_11_analyzer_2_array_crystal_array_4_yheight
#define zdepth mccchannel_11_analyzer_2_array_crystal_array_4_zdepth
#define xwidth2 mccchannel_11_analyzer_2_array_crystal_array_4_xwidth2
#define yheight2 mccchannel_11_analyzer_2_array_crystal_array_4_yheight2
#define visualize mccchannel_11_analyzer_2_array_crystal_array_4_visualize
#define target_index mccchannel_11_analyzer_2_array_crystal_array_4_target_index
#define target_x mccchannel_11_analyzer_2_array_crystal_array_4_target_x
#define target_y mccchannel_11_analyzer_2_array_crystal_array_4_target_y
#define target_z mccchannel_11_analyzer_2_array_crystal_array_4_target_z
#define focus_aw mccchannel_11_analyzer_2_array_crystal_array_4_focus_aw
#define focus_ah mccchannel_11_analyzer_2_array_crystal_array_4_focus_ah
#define focus_xw mccchannel_11_analyzer_2_array_crystal_array_4_focus_xw
#define focus_xh mccchannel_11_analyzer_2_array_crystal_array_4_focus_xh
#define focus_r mccchannel_11_analyzer_2_array_crystal_array_4_focus_r
#define p_interact mccchannel_11_analyzer_2_array_crystal_array_4_p_interact
#define mask_string mccchannel_11_analyzer_2_array_crystal_array_4_mask_string
#define mask_setting mccchannel_11_analyzer_2_array_crystal_array_4_mask_setting
#define number_of_activations mccchannel_11_analyzer_2_array_crystal_array_4_number_of_activations
#line 204 "Union_box.comp"
// Needed for transport to the main component
struct global_geometry_element_struct global_geometry_element;

#ifndef ANY_GEOMETRY_DETECTOR_DECLARE
    #define ANY_GEOMETRY_DETECTOR_DECLARE dummy
	//struct pointer_to_global_geometry_list global_geometry_list = {0,NULL};
#endif

int loop_index,found_geometries;

double x_component;
double y_component;
double z_component;

struct Volume_struct this_box_volume;
struct box_storage this_box_storage;

#line 63070 "MACS_sample_kidney_box.c"
#undef number_of_activations
#undef mask_setting
#undef mask_string
#undef p_interact
#undef focus_r
#undef focus_xh
#undef focus_xw
#undef focus_ah
#undef focus_aw
#undef target_z
#undef target_y
#undef target_x
#undef target_index
#undef visualize
#undef yheight2
#undef xwidth2
#undef zdepth
#undef yheight
#undef xwidth
#undef priority
#undef material_string
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

/* User declarations for component 'channel_11_analyzer_2_array_crystal_array_5' [564]. */
#define mccompcurname  channel_11_analyzer_2_array_crystal_array_5
#define mccompcurtype  Union_box
#define mccompcurindex 564
#define loop_index mccchannel_11_analyzer_2_array_crystal_array_5_loop_index
#define this_box_volume mccchannel_11_analyzer_2_array_crystal_array_5_this_box_volume
#define global_geometry_element mccchannel_11_analyzer_2_array_crystal_array_5_global_geometry_element
#define this_box_storage mccchannel_11_analyzer_2_array_crystal_array_5_this_box_storage
#define material_string mccchannel_11_analyzer_2_array_crystal_array_5_material_string
#define priority mccchannel_11_analyzer_2_array_crystal_array_5_priority
#define xwidth mccchannel_11_analyzer_2_array_crystal_array_5_xwidth
#define yheight mccchannel_11_analyzer_2_array_crystal_array_5_yheight
#define zdepth mccchannel_11_analyzer_2_array_crystal_array_5_zdepth
#define xwidth2 mccchannel_11_analyzer_2_array_crystal_array_5_xwidth2
#define yheight2 mccchannel_11_analyzer_2_array_crystal_array_5_yheight2
#define visualize mccchannel_11_analyzer_2_array_crystal_array_5_visualize
#define target_index mccchannel_11_analyzer_2_array_crystal_array_5_target_index
#define target_x mccchannel_11_analyzer_2_array_crystal_array_5_target_x
#define target_y mccchannel_11_analyzer_2_array_crystal_array_5_target_y
#define target_z mccchannel_11_analyzer_2_array_crystal_array_5_target_z
#define focus_aw mccchannel_11_analyzer_2_array_crystal_array_5_focus_aw
#define focus_ah mccchannel_11_analyzer_2_array_crystal_array_5_focus_ah
#define focus_xw mccchannel_11_analyzer_2_array_crystal_array_5_focus_xw
#define focus_xh mccchannel_11_analyzer_2_array_crystal_array_5_focus_xh
#define focus_r mccchannel_11_analyzer_2_array_crystal_array_5_focus_r
#define p_interact mccchannel_11_analyzer_2_array_crystal_array_5_p_interact
#define mask_string mccchannel_11_analyzer_2_array_crystal_array_5_mask_string
#define mask_setting mccchannel_11_analyzer_2_array_crystal_array_5_mask_setting
#define number_of_activations mccchannel_11_analyzer_2_array_crystal_array_5_number_of_activations
#line 204 "Union_box.comp"
// Needed for transport to the main component
struct global_geometry_element_struct global_geometry_element;

#ifndef ANY_GEOMETRY_DETECTOR_DECLARE
    #define ANY_GEOMETRY_DETECTOR_DECLARE dummy
	//struct pointer_to_global_geometry_list global_geometry_list = {0,NULL};
#endif

int loop_index,found_geometries;

double x_component;
double y_component;
double z_component;

struct Volume_struct this_box_volume;
struct box_storage this_box_storage;

#line 63147 "MACS_sample_kidney_box.c"
#undef number_of_activations
#undef mask_setting
#undef mask_string
#undef p_interact
#undef focus_r
#undef focus_xh
#undef focus_xw
#undef focus_ah
#undef focus_aw
#undef target_z
#undef target_y
#undef target_x
#undef target_index
#undef visualize
#undef yheight2
#undef xwidth2
#undef zdepth
#undef yheight
#undef xwidth
#undef priority
#undef material_string
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

/* User declarations for component 'channel_11_analyzer_2_array_crystal_array_6' [565]. */
#define mccompcurname  channel_11_analyzer_2_array_crystal_array_6
#define mccompcurtype  Union_box
#define mccompcurindex 565
#define loop_index mccchannel_11_analyzer_2_array_crystal_array_6_loop_index
#define this_box_volume mccchannel_11_analyzer_2_array_crystal_array_6_this_box_volume
#define global_geometry_element mccchannel_11_analyzer_2_array_crystal_array_6_global_geometry_element
#define this_box_storage mccchannel_11_analyzer_2_array_crystal_array_6_this_box_storage
#define material_string mccchannel_11_analyzer_2_array_crystal_array_6_material_string
#define priority mccchannel_11_analyzer_2_array_crystal_array_6_priority
#define xwidth mccchannel_11_analyzer_2_array_crystal_array_6_xwidth
#define yheight mccchannel_11_analyzer_2_array_crystal_array_6_yheight
#define zdepth mccchannel_11_analyzer_2_array_crystal_array_6_zdepth
#define xwidth2 mccchannel_11_analyzer_2_array_crystal_array_6_xwidth2
#define yheight2 mccchannel_11_analyzer_2_array_crystal_array_6_yheight2
#define visualize mccchannel_11_analyzer_2_array_crystal_array_6_visualize
#define target_index mccchannel_11_analyzer_2_array_crystal_array_6_target_index
#define target_x mccchannel_11_analyzer_2_array_crystal_array_6_target_x
#define target_y mccchannel_11_analyzer_2_array_crystal_array_6_target_y
#define target_z mccchannel_11_analyzer_2_array_crystal_array_6_target_z
#define focus_aw mccchannel_11_analyzer_2_array_crystal_array_6_focus_aw
#define focus_ah mccchannel_11_analyzer_2_array_crystal_array_6_focus_ah
#define focus_xw mccchannel_11_analyzer_2_array_crystal_array_6_focus_xw
#define focus_xh mccchannel_11_analyzer_2_array_crystal_array_6_focus_xh
#define focus_r mccchannel_11_analyzer_2_array_crystal_array_6_focus_r
#define p_interact mccchannel_11_analyzer_2_array_crystal_array_6_p_interact
#define mask_string mccchannel_11_analyzer_2_array_crystal_array_6_mask_string
#define mask_setting mccchannel_11_analyzer_2_array_crystal_array_6_mask_setting
#define number_of_activations mccchannel_11_analyzer_2_array_crystal_array_6_number_of_activations
#line 204 "Union_box.comp"
// Needed for transport to the main component
struct global_geometry_element_struct global_geometry_element;

#ifndef ANY_GEOMETRY_DETECTOR_DECLARE
    #define ANY_GEOMETRY_DETECTOR_DECLARE dummy
	//struct pointer_to_global_geometry_list global_geometry_list = {0,NULL};
#endif

int loop_index,found_geometries;

double x_component;
double y_component;
double z_component;

struct Volume_struct this_box_volume;
struct box_storage this_box_storage;

#line 63224 "MACS_sample_kidney_box.c"
#undef number_of_activations
#undef mask_setting
#undef mask_string
#undef p_interact
#undef focus_r
#undef focus_xh
#undef focus_xw
#undef focus_ah
#undef focus_aw
#undef target_z
#undef target_y
#undef target_x
#undef target_index
#undef visualize
#undef yheight2
#undef xwidth2
#undef zdepth
#undef yheight
#undef xwidth
#undef priority
#undef material_string
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

/* User declarations for component 'channel_11_analyzer_2_array_crystal_array_7' [566]. */
#define mccompcurname  channel_11_analyzer_2_array_crystal_array_7
#define mccompcurtype  Union_box
#define mccompcurindex 566
#define loop_index mccchannel_11_analyzer_2_array_crystal_array_7_loop_index
#define this_box_volume mccchannel_11_analyzer_2_array_crystal_array_7_this_box_volume
#define global_geometry_element mccchannel_11_analyzer_2_array_crystal_array_7_global_geometry_element
#define this_box_storage mccchannel_11_analyzer_2_array_crystal_array_7_this_box_storage
#define material_string mccchannel_11_analyzer_2_array_crystal_array_7_material_string
#define priority mccchannel_11_analyzer_2_array_crystal_array_7_priority
#define xwidth mccchannel_11_analyzer_2_array_crystal_array_7_xwidth
#define yheight mccchannel_11_analyzer_2_array_crystal_array_7_yheight
#define zdepth mccchannel_11_analyzer_2_array_crystal_array_7_zdepth
#define xwidth2 mccchannel_11_analyzer_2_array_crystal_array_7_xwidth2
#define yheight2 mccchannel_11_analyzer_2_array_crystal_array_7_yheight2
#define visualize mccchannel_11_analyzer_2_array_crystal_array_7_visualize
#define target_index mccchannel_11_analyzer_2_array_crystal_array_7_target_index
#define target_x mccchannel_11_analyzer_2_array_crystal_array_7_target_x
#define target_y mccchannel_11_analyzer_2_array_crystal_array_7_target_y
#define target_z mccchannel_11_analyzer_2_array_crystal_array_7_target_z
#define focus_aw mccchannel_11_analyzer_2_array_crystal_array_7_focus_aw
#define focus_ah mccchannel_11_analyzer_2_array_crystal_array_7_focus_ah
#define focus_xw mccchannel_11_analyzer_2_array_crystal_array_7_focus_xw
#define focus_xh mccchannel_11_analyzer_2_array_crystal_array_7_focus_xh
#define focus_r mccchannel_11_analyzer_2_array_crystal_array_7_focus_r
#define p_interact mccchannel_11_analyzer_2_array_crystal_array_7_p_interact
#define mask_string mccchannel_11_analyzer_2_array_crystal_array_7_mask_string
#define mask_setting mccchannel_11_analyzer_2_array_crystal_array_7_mask_setting
#define number_of_activations mccchannel_11_analyzer_2_array_crystal_array_7_number_of_activations
#line 204 "Union_box.comp"
// Needed for transport to the main component
struct global_geometry_element_struct global_geometry_element;

#ifndef ANY_GEOMETRY_DETECTOR_DECLARE
    #define ANY_GEOMETRY_DETECTOR_DECLARE dummy
	//struct pointer_to_global_geometry_list global_geometry_list = {0,NULL};
#endif

int loop_index,found_geometries;

double x_component;
double y_component;
double z_component;

struct Volume_struct this_box_volume;
struct box_storage this_box_storage;

#line 63301 "MACS_sample_kidney_box.c"
#undef number_of_activations
#undef mask_setting
#undef mask_string
#undef p_interact
#undef focus_r
#undef focus_xh
#undef focus_xw
#undef focus_ah
#undef focus_aw
#undef target_z
#undef target_y
#undef target_x
#undef target_index
#undef visualize
#undef yheight2
#undef xwidth2
#undef zdepth
#undef yheight
#undef xwidth
#undef priority
#undef material_string
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

/* User declarations for component 'channel_11_analyzer_2_array_crystal_array_8' [567]. */
#define mccompcurname  channel_11_analyzer_2_array_crystal_array_8
#define mccompcurtype  Union_box
#define mccompcurindex 567
#define loop_index mccchannel_11_analyzer_2_array_crystal_array_8_loop_index
#define this_box_volume mccchannel_11_analyzer_2_array_crystal_array_8_this_box_volume
#define global_geometry_element mccchannel_11_analyzer_2_array_crystal_array_8_global_geometry_element
#define this_box_storage mccchannel_11_analyzer_2_array_crystal_array_8_this_box_storage
#define material_string mccchannel_11_analyzer_2_array_crystal_array_8_material_string
#define priority mccchannel_11_analyzer_2_array_crystal_array_8_priority
#define xwidth mccchannel_11_analyzer_2_array_crystal_array_8_xwidth
#define yheight mccchannel_11_analyzer_2_array_crystal_array_8_yheight
#define zdepth mccchannel_11_analyzer_2_array_crystal_array_8_zdepth
#define xwidth2 mccchannel_11_analyzer_2_array_crystal_array_8_xwidth2
#define yheight2 mccchannel_11_analyzer_2_array_crystal_array_8_yheight2
#define visualize mccchannel_11_analyzer_2_array_crystal_array_8_visualize
#define target_index mccchannel_11_analyzer_2_array_crystal_array_8_target_index
#define target_x mccchannel_11_analyzer_2_array_crystal_array_8_target_x
#define target_y mccchannel_11_analyzer_2_array_crystal_array_8_target_y
#define target_z mccchannel_11_analyzer_2_array_crystal_array_8_target_z
#define focus_aw mccchannel_11_analyzer_2_array_crystal_array_8_focus_aw
#define focus_ah mccchannel_11_analyzer_2_array_crystal_array_8_focus_ah
#define focus_xw mccchannel_11_analyzer_2_array_crystal_array_8_focus_xw
#define focus_xh mccchannel_11_analyzer_2_array_crystal_array_8_focus_xh
#define focus_r mccchannel_11_analyzer_2_array_crystal_array_8_focus_r
#define p_interact mccchannel_11_analyzer_2_array_crystal_array_8_p_interact
#define mask_string mccchannel_11_analyzer_2_array_crystal_array_8_mask_string
#define mask_setting mccchannel_11_analyzer_2_array_crystal_array_8_mask_setting
#define number_of_activations mccchannel_11_analyzer_2_array_crystal_array_8_number_of_activations
#line 204 "Union_box.comp"
// Needed for transport to the main component
struct global_geometry_element_struct global_geometry_element;

#ifndef ANY_GEOMETRY_DETECTOR_DECLARE
    #define ANY_GEOMETRY_DETECTOR_DECLARE dummy
	//struct pointer_to_global_geometry_list global_geometry_list = {0,NULL};
#endif

int loop_index,found_geometries;

double x_component;
double y_component;
double z_component;

struct Volume_struct this_box_volume;
struct box_storage this_box_storage;

#line 63378 "MACS_sample_kidney_box.c"
#undef number_of_activations
#undef mask_setting
#undef mask_string
#undef p_interact
#undef focus_r
#undef focus_xh
#undef focus_xw
#undef focus_ah
#undef focus_aw
#undef target_z
#undef target_y
#undef target_x
#undef target_index
#undef visualize
#undef yheight2
#undef xwidth2
#undef zdepth
#undef yheight
#undef xwidth
#undef priority
#undef material_string
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

/* User declarations for component 'channel_11_cave2_cyl1' [568]. */
#define mccompcurname  channel_11_cave2_cyl1
#define mccompcurtype  Union_cylinder
#define mccompcurindex 568
#define loop_index mccchannel_11_cave2_cyl1_loop_index
#define this_cylinder_volume mccchannel_11_cave2_cyl1_this_cylinder_volume
#define global_geometry_element mccchannel_11_cave2_cyl1_global_geometry_element
#define this_cylinder_storage mccchannel_11_cave2_cyl1_this_cylinder_storage
#define material_string mccchannel_11_cave2_cyl1_material_string
#define priority mccchannel_11_cave2_cyl1_priority
#define radius mccchannel_11_cave2_cyl1_radius
#define yheight mccchannel_11_cave2_cyl1_yheight
#define visualize mccchannel_11_cave2_cyl1_visualize
#define target_index mccchannel_11_cave2_cyl1_target_index
#define target_x mccchannel_11_cave2_cyl1_target_x
#define target_y mccchannel_11_cave2_cyl1_target_y
#define target_z mccchannel_11_cave2_cyl1_target_z
#define focus_aw mccchannel_11_cave2_cyl1_focus_aw
#define focus_ah mccchannel_11_cave2_cyl1_focus_ah
#define focus_xw mccchannel_11_cave2_cyl1_focus_xw
#define focus_xh mccchannel_11_cave2_cyl1_focus_xh
#define focus_r mccchannel_11_cave2_cyl1_focus_r
#define p_interact mccchannel_11_cave2_cyl1_p_interact
#define mask_string mccchannel_11_cave2_cyl1_mask_string
#define mask_setting mccchannel_11_cave2_cyl1_mask_setting
#define number_of_activations mccchannel_11_cave2_cyl1_number_of_activations
#line 167 "Union_cylinder.comp"
// Needed for transport to the main component
struct global_geometry_element_struct global_geometry_element;

#ifndef ANY_GEOMETRY_DETECTOR_DECLARE
    #define ANY_GEOMETRY_DETECTOR_DECLARE dummy
	//struct pointer_to_global_geometry_list global_geometry_list = {0,NULL};
#endif

int dummy;
int loop_index,found_geometries;
int loop_2_index;
int material_index;

struct Volume_struct this_cylinder_volume;
struct cylinder_storage this_cylinder_storage;
#line 63450 "MACS_sample_kidney_box.c"
#undef number_of_activations
#undef mask_setting
#undef mask_string
#undef p_interact
#undef focus_r
#undef focus_xh
#undef focus_xw
#undef focus_ah
#undef focus_aw
#undef target_z
#undef target_y
#undef target_x
#undef target_index
#undef visualize
#undef yheight
#undef radius
#undef priority
#undef material_string
#undef this_cylinder_storage
#undef global_geometry_element
#undef this_cylinder_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

/* User declarations for component 'channel_11_cave2_box1' [569]. */
#define mccompcurname  channel_11_cave2_box1
#define mccompcurtype  Union_box
#define mccompcurindex 569
#define loop_index mccchannel_11_cave2_box1_loop_index
#define this_box_volume mccchannel_11_cave2_box1_this_box_volume
#define global_geometry_element mccchannel_11_cave2_box1_global_geometry_element
#define this_box_storage mccchannel_11_cave2_box1_this_box_storage
#define material_string mccchannel_11_cave2_box1_material_string
#define priority mccchannel_11_cave2_box1_priority
#define xwidth mccchannel_11_cave2_box1_xwidth
#define yheight mccchannel_11_cave2_box1_yheight
#define zdepth mccchannel_11_cave2_box1_zdepth
#define xwidth2 mccchannel_11_cave2_box1_xwidth2
#define yheight2 mccchannel_11_cave2_box1_yheight2
#define visualize mccchannel_11_cave2_box1_visualize
#define target_index mccchannel_11_cave2_box1_target_index
#define target_x mccchannel_11_cave2_box1_target_x
#define target_y mccchannel_11_cave2_box1_target_y
#define target_z mccchannel_11_cave2_box1_target_z
#define focus_aw mccchannel_11_cave2_box1_focus_aw
#define focus_ah mccchannel_11_cave2_box1_focus_ah
#define focus_xw mccchannel_11_cave2_box1_focus_xw
#define focus_xh mccchannel_11_cave2_box1_focus_xh
#define focus_r mccchannel_11_cave2_box1_focus_r
#define p_interact mccchannel_11_cave2_box1_p_interact
#define mask_string mccchannel_11_cave2_box1_mask_string
#define mask_setting mccchannel_11_cave2_box1_mask_setting
#define number_of_activations mccchannel_11_cave2_box1_number_of_activations
#line 204 "Union_box.comp"
// Needed for transport to the main component
struct global_geometry_element_struct global_geometry_element;

#ifndef ANY_GEOMETRY_DETECTOR_DECLARE
    #define ANY_GEOMETRY_DETECTOR_DECLARE dummy
	//struct pointer_to_global_geometry_list global_geometry_list = {0,NULL};
#endif

int loop_index,found_geometries;

double x_component;
double y_component;
double z_component;

struct Volume_struct this_box_volume;
struct box_storage this_box_storage;

#line 63524 "MACS_sample_kidney_box.c"
#undef number_of_activations
#undef mask_setting
#undef mask_string
#undef p_interact
#undef focus_r
#undef focus_xh
#undef focus_xw
#undef focus_ah
#undef focus_aw
#undef target_z
#undef target_y
#undef target_x
#undef target_index
#undef visualize
#undef yheight2
#undef xwidth2
#undef zdepth
#undef yheight
#undef xwidth
#undef priority
#undef material_string
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

/* User declarations for component 'channel_11_cave2_box2' [570]. */
#define mccompcurname  channel_11_cave2_box2
#define mccompcurtype  Union_box
#define mccompcurindex 570
#define loop_index mccchannel_11_cave2_box2_loop_index
#define this_box_volume mccchannel_11_cave2_box2_this_box_volume
#define global_geometry_element mccchannel_11_cave2_box2_global_geometry_element
#define this_box_storage mccchannel_11_cave2_box2_this_box_storage
#define material_string mccchannel_11_cave2_box2_material_string
#define priority mccchannel_11_cave2_box2_priority
#define xwidth mccchannel_11_cave2_box2_xwidth
#define yheight mccchannel_11_cave2_box2_yheight
#define zdepth mccchannel_11_cave2_box2_zdepth
#define xwidth2 mccchannel_11_cave2_box2_xwidth2
#define yheight2 mccchannel_11_cave2_box2_yheight2
#define visualize mccchannel_11_cave2_box2_visualize
#define target_index mccchannel_11_cave2_box2_target_index
#define target_x mccchannel_11_cave2_box2_target_x
#define target_y mccchannel_11_cave2_box2_target_y
#define target_z mccchannel_11_cave2_box2_target_z
#define focus_aw mccchannel_11_cave2_box2_focus_aw
#define focus_ah mccchannel_11_cave2_box2_focus_ah
#define focus_xw mccchannel_11_cave2_box2_focus_xw
#define focus_xh mccchannel_11_cave2_box2_focus_xh
#define focus_r mccchannel_11_cave2_box2_focus_r
#define p_interact mccchannel_11_cave2_box2_p_interact
#define mask_string mccchannel_11_cave2_box2_mask_string
#define mask_setting mccchannel_11_cave2_box2_mask_setting
#define number_of_activations mccchannel_11_cave2_box2_number_of_activations
#line 204 "Union_box.comp"
// Needed for transport to the main component
struct global_geometry_element_struct global_geometry_element;

#ifndef ANY_GEOMETRY_DETECTOR_DECLARE
    #define ANY_GEOMETRY_DETECTOR_DECLARE dummy
	//struct pointer_to_global_geometry_list global_geometry_list = {0,NULL};
#endif

int loop_index,found_geometries;

double x_component;
double y_component;
double z_component;

struct Volume_struct this_box_volume;
struct box_storage this_box_storage;

#line 63601 "MACS_sample_kidney_box.c"
#undef number_of_activations
#undef mask_setting
#undef mask_string
#undef p_interact
#undef focus_r
#undef focus_xh
#undef focus_xw
#undef focus_ah
#undef focus_aw
#undef target_z
#undef target_y
#undef target_x
#undef target_index
#undef visualize
#undef yheight2
#undef xwidth2
#undef zdepth
#undef yheight
#undef xwidth
#undef priority
#undef material_string
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

/* User declarations for component 'channel_11_cave2_box3' [571]. */
#define mccompcurname  channel_11_cave2_box3
#define mccompcurtype  Union_box
#define mccompcurindex 571
#define loop_index mccchannel_11_cave2_box3_loop_index
#define this_box_volume mccchannel_11_cave2_box3_this_box_volume
#define global_geometry_element mccchannel_11_cave2_box3_global_geometry_element
#define this_box_storage mccchannel_11_cave2_box3_this_box_storage
#define material_string mccchannel_11_cave2_box3_material_string
#define priority mccchannel_11_cave2_box3_priority
#define xwidth mccchannel_11_cave2_box3_xwidth
#define yheight mccchannel_11_cave2_box3_yheight
#define zdepth mccchannel_11_cave2_box3_zdepth
#define xwidth2 mccchannel_11_cave2_box3_xwidth2
#define yheight2 mccchannel_11_cave2_box3_yheight2
#define visualize mccchannel_11_cave2_box3_visualize
#define target_index mccchannel_11_cave2_box3_target_index
#define target_x mccchannel_11_cave2_box3_target_x
#define target_y mccchannel_11_cave2_box3_target_y
#define target_z mccchannel_11_cave2_box3_target_z
#define focus_aw mccchannel_11_cave2_box3_focus_aw
#define focus_ah mccchannel_11_cave2_box3_focus_ah
#define focus_xw mccchannel_11_cave2_box3_focus_xw
#define focus_xh mccchannel_11_cave2_box3_focus_xh
#define focus_r mccchannel_11_cave2_box3_focus_r
#define p_interact mccchannel_11_cave2_box3_p_interact
#define mask_string mccchannel_11_cave2_box3_mask_string
#define mask_setting mccchannel_11_cave2_box3_mask_setting
#define number_of_activations mccchannel_11_cave2_box3_number_of_activations
#line 204 "Union_box.comp"
// Needed for transport to the main component
struct global_geometry_element_struct global_geometry_element;

#ifndef ANY_GEOMETRY_DETECTOR_DECLARE
    #define ANY_GEOMETRY_DETECTOR_DECLARE dummy
	//struct pointer_to_global_geometry_list global_geometry_list = {0,NULL};
#endif

int loop_index,found_geometries;

double x_component;
double y_component;
double z_component;

struct Volume_struct this_box_volume;
struct box_storage this_box_storage;

#line 63678 "MACS_sample_kidney_box.c"
#undef number_of_activations
#undef mask_setting
#undef mask_string
#undef p_interact
#undef focus_r
#undef focus_xh
#undef focus_xw
#undef focus_ah
#undef focus_aw
#undef target_z
#undef target_y
#undef target_x
#undef target_index
#undef visualize
#undef yheight2
#undef xwidth2
#undef zdepth
#undef yheight
#undef xwidth
#undef priority
#undef material_string
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

/* User declarations for component 'inter_analyzer_colimator_center_11' [572]. */
#define mccompcurname  inter_analyzer_colimator_center_11
#define mccompcurtype  Arm
#define mccompcurindex 572
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

/* User declarations for component 'inter_analyzer_colimator_11_blade_0' [573]. */
#define mccompcurname  inter_analyzer_colimator_11_blade_0
#define mccompcurtype  Union_box
#define mccompcurindex 573
#define loop_index mccinter_analyzer_colimator_11_blade_0_loop_index
#define this_box_volume mccinter_analyzer_colimator_11_blade_0_this_box_volume
#define global_geometry_element mccinter_analyzer_colimator_11_blade_0_global_geometry_element
#define this_box_storage mccinter_analyzer_colimator_11_blade_0_this_box_storage
#define material_string mccinter_analyzer_colimator_11_blade_0_material_string
#define priority mccinter_analyzer_colimator_11_blade_0_priority
#define xwidth mccinter_analyzer_colimator_11_blade_0_xwidth
#define yheight mccinter_analyzer_colimator_11_blade_0_yheight
#define zdepth mccinter_analyzer_colimator_11_blade_0_zdepth
#define xwidth2 mccinter_analyzer_colimator_11_blade_0_xwidth2
#define yheight2 mccinter_analyzer_colimator_11_blade_0_yheight2
#define visualize mccinter_analyzer_colimator_11_blade_0_visualize
#define target_index mccinter_analyzer_colimator_11_blade_0_target_index
#define target_x mccinter_analyzer_colimator_11_blade_0_target_x
#define target_y mccinter_analyzer_colimator_11_blade_0_target_y
#define target_z mccinter_analyzer_colimator_11_blade_0_target_z
#define focus_aw mccinter_analyzer_colimator_11_blade_0_focus_aw
#define focus_ah mccinter_analyzer_colimator_11_blade_0_focus_ah
#define focus_xw mccinter_analyzer_colimator_11_blade_0_focus_xw
#define focus_xh mccinter_analyzer_colimator_11_blade_0_focus_xh
#define focus_r mccinter_analyzer_colimator_11_blade_0_focus_r
#define p_interact mccinter_analyzer_colimator_11_blade_0_p_interact
#define mask_string mccinter_analyzer_colimator_11_blade_0_mask_string
#define mask_setting mccinter_analyzer_colimator_11_blade_0_mask_setting
#define number_of_activations mccinter_analyzer_colimator_11_blade_0_number_of_activations
#line 204 "Union_box.comp"
// Needed for transport to the main component
struct global_geometry_element_struct global_geometry_element;

#ifndef ANY_GEOMETRY_DETECTOR_DECLARE
    #define ANY_GEOMETRY_DETECTOR_DECLARE dummy
	//struct pointer_to_global_geometry_list global_geometry_list = {0,NULL};
#endif

int loop_index,found_geometries;

double x_component;
double y_component;
double z_component;

struct Volume_struct this_box_volume;
struct box_storage this_box_storage;

#line 63763 "MACS_sample_kidney_box.c"
#undef number_of_activations
#undef mask_setting
#undef mask_string
#undef p_interact
#undef focus_r
#undef focus_xh
#undef focus_xw
#undef focus_ah
#undef focus_aw
#undef target_z
#undef target_y
#undef target_x
#undef target_index
#undef visualize
#undef yheight2
#undef xwidth2
#undef zdepth
#undef yheight
#undef xwidth
#undef priority
#undef material_string
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

/* User declarations for component 'inter_analyzer_colimator_11_blade_1' [574]. */
#define mccompcurname  inter_analyzer_colimator_11_blade_1
#define mccompcurtype  Union_box
#define mccompcurindex 574
#define loop_index mccinter_analyzer_colimator_11_blade_1_loop_index
#define this_box_volume mccinter_analyzer_colimator_11_blade_1_this_box_volume
#define global_geometry_element mccinter_analyzer_colimator_11_blade_1_global_geometry_element
#define this_box_storage mccinter_analyzer_colimator_11_blade_1_this_box_storage
#define material_string mccinter_analyzer_colimator_11_blade_1_material_string
#define priority mccinter_analyzer_colimator_11_blade_1_priority
#define xwidth mccinter_analyzer_colimator_11_blade_1_xwidth
#define yheight mccinter_analyzer_colimator_11_blade_1_yheight
#define zdepth mccinter_analyzer_colimator_11_blade_1_zdepth
#define xwidth2 mccinter_analyzer_colimator_11_blade_1_xwidth2
#define yheight2 mccinter_analyzer_colimator_11_blade_1_yheight2
#define visualize mccinter_analyzer_colimator_11_blade_1_visualize
#define target_index mccinter_analyzer_colimator_11_blade_1_target_index
#define target_x mccinter_analyzer_colimator_11_blade_1_target_x
#define target_y mccinter_analyzer_colimator_11_blade_1_target_y
#define target_z mccinter_analyzer_colimator_11_blade_1_target_z
#define focus_aw mccinter_analyzer_colimator_11_blade_1_focus_aw
#define focus_ah mccinter_analyzer_colimator_11_blade_1_focus_ah
#define focus_xw mccinter_analyzer_colimator_11_blade_1_focus_xw
#define focus_xh mccinter_analyzer_colimator_11_blade_1_focus_xh
#define focus_r mccinter_analyzer_colimator_11_blade_1_focus_r
#define p_interact mccinter_analyzer_colimator_11_blade_1_p_interact
#define mask_string mccinter_analyzer_colimator_11_blade_1_mask_string
#define mask_setting mccinter_analyzer_colimator_11_blade_1_mask_setting
#define number_of_activations mccinter_analyzer_colimator_11_blade_1_number_of_activations
#line 204 "Union_box.comp"
// Needed for transport to the main component
struct global_geometry_element_struct global_geometry_element;

#ifndef ANY_GEOMETRY_DETECTOR_DECLARE
    #define ANY_GEOMETRY_DETECTOR_DECLARE dummy
	//struct pointer_to_global_geometry_list global_geometry_list = {0,NULL};
#endif

int loop_index,found_geometries;

double x_component;
double y_component;
double z_component;

struct Volume_struct this_box_volume;
struct box_storage this_box_storage;

#line 63840 "MACS_sample_kidney_box.c"
#undef number_of_activations
#undef mask_setting
#undef mask_string
#undef p_interact
#undef focus_r
#undef focus_xh
#undef focus_xw
#undef focus_ah
#undef focus_aw
#undef target_z
#undef target_y
#undef target_x
#undef target_index
#undef visualize
#undef yheight2
#undef xwidth2
#undef zdepth
#undef yheight
#undef xwidth
#undef priority
#undef material_string
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

/* User declarations for component 'inter_analyzer_colimator_11_blade_2' [575]. */
#define mccompcurname  inter_analyzer_colimator_11_blade_2
#define mccompcurtype  Union_box
#define mccompcurindex 575
#define loop_index mccinter_analyzer_colimator_11_blade_2_loop_index
#define this_box_volume mccinter_analyzer_colimator_11_blade_2_this_box_volume
#define global_geometry_element mccinter_analyzer_colimator_11_blade_2_global_geometry_element
#define this_box_storage mccinter_analyzer_colimator_11_blade_2_this_box_storage
#define material_string mccinter_analyzer_colimator_11_blade_2_material_string
#define priority mccinter_analyzer_colimator_11_blade_2_priority
#define xwidth mccinter_analyzer_colimator_11_blade_2_xwidth
#define yheight mccinter_analyzer_colimator_11_blade_2_yheight
#define zdepth mccinter_analyzer_colimator_11_blade_2_zdepth
#define xwidth2 mccinter_analyzer_colimator_11_blade_2_xwidth2
#define yheight2 mccinter_analyzer_colimator_11_blade_2_yheight2
#define visualize mccinter_analyzer_colimator_11_blade_2_visualize
#define target_index mccinter_analyzer_colimator_11_blade_2_target_index
#define target_x mccinter_analyzer_colimator_11_blade_2_target_x
#define target_y mccinter_analyzer_colimator_11_blade_2_target_y
#define target_z mccinter_analyzer_colimator_11_blade_2_target_z
#define focus_aw mccinter_analyzer_colimator_11_blade_2_focus_aw
#define focus_ah mccinter_analyzer_colimator_11_blade_2_focus_ah
#define focus_xw mccinter_analyzer_colimator_11_blade_2_focus_xw
#define focus_xh mccinter_analyzer_colimator_11_blade_2_focus_xh
#define focus_r mccinter_analyzer_colimator_11_blade_2_focus_r
#define p_interact mccinter_analyzer_colimator_11_blade_2_p_interact
#define mask_string mccinter_analyzer_colimator_11_blade_2_mask_string
#define mask_setting mccinter_analyzer_colimator_11_blade_2_mask_setting
#define number_of_activations mccinter_analyzer_colimator_11_blade_2_number_of_activations
#line 204 "Union_box.comp"
// Needed for transport to the main component
struct global_geometry_element_struct global_geometry_element;

#ifndef ANY_GEOMETRY_DETECTOR_DECLARE
    #define ANY_GEOMETRY_DETECTOR_DECLARE dummy
	//struct pointer_to_global_geometry_list global_geometry_list = {0,NULL};
#endif

int loop_index,found_geometries;

double x_component;
double y_component;
double z_component;

struct Volume_struct this_box_volume;
struct box_storage this_box_storage;

#line 63917 "MACS_sample_kidney_box.c"
#undef number_of_activations
#undef mask_setting
#undef mask_string
#undef p_interact
#undef focus_r
#undef focus_xh
#undef focus_xw
#undef focus_ah
#undef focus_aw
#undef target_z
#undef target_y
#undef target_x
#undef target_index
#undef visualize
#undef yheight2
#undef xwidth2
#undef zdepth
#undef yheight
#undef xwidth
#undef priority
#undef material_string
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

/* User declarations for component 'inter_analyzer_colimator_11_blade_3' [576]. */
#define mccompcurname  inter_analyzer_colimator_11_blade_3
#define mccompcurtype  Union_box
#define mccompcurindex 576
#define loop_index mccinter_analyzer_colimator_11_blade_3_loop_index
#define this_box_volume mccinter_analyzer_colimator_11_blade_3_this_box_volume
#define global_geometry_element mccinter_analyzer_colimator_11_blade_3_global_geometry_element
#define this_box_storage mccinter_analyzer_colimator_11_blade_3_this_box_storage
#define material_string mccinter_analyzer_colimator_11_blade_3_material_string
#define priority mccinter_analyzer_colimator_11_blade_3_priority
#define xwidth mccinter_analyzer_colimator_11_blade_3_xwidth
#define yheight mccinter_analyzer_colimator_11_blade_3_yheight
#define zdepth mccinter_analyzer_colimator_11_blade_3_zdepth
#define xwidth2 mccinter_analyzer_colimator_11_blade_3_xwidth2
#define yheight2 mccinter_analyzer_colimator_11_blade_3_yheight2
#define visualize mccinter_analyzer_colimator_11_blade_3_visualize
#define target_index mccinter_analyzer_colimator_11_blade_3_target_index
#define target_x mccinter_analyzer_colimator_11_blade_3_target_x
#define target_y mccinter_analyzer_colimator_11_blade_3_target_y
#define target_z mccinter_analyzer_colimator_11_blade_3_target_z
#define focus_aw mccinter_analyzer_colimator_11_blade_3_focus_aw
#define focus_ah mccinter_analyzer_colimator_11_blade_3_focus_ah
#define focus_xw mccinter_analyzer_colimator_11_blade_3_focus_xw
#define focus_xh mccinter_analyzer_colimator_11_blade_3_focus_xh
#define focus_r mccinter_analyzer_colimator_11_blade_3_focus_r
#define p_interact mccinter_analyzer_colimator_11_blade_3_p_interact
#define mask_string mccinter_analyzer_colimator_11_blade_3_mask_string
#define mask_setting mccinter_analyzer_colimator_11_blade_3_mask_setting
#define number_of_activations mccinter_analyzer_colimator_11_blade_3_number_of_activations
#line 204 "Union_box.comp"
// Needed for transport to the main component
struct global_geometry_element_struct global_geometry_element;

#ifndef ANY_GEOMETRY_DETECTOR_DECLARE
    #define ANY_GEOMETRY_DETECTOR_DECLARE dummy
	//struct pointer_to_global_geometry_list global_geometry_list = {0,NULL};
#endif

int loop_index,found_geometries;

double x_component;
double y_component;
double z_component;

struct Volume_struct this_box_volume;
struct box_storage this_box_storage;

#line 63994 "MACS_sample_kidney_box.c"
#undef number_of_activations
#undef mask_setting
#undef mask_string
#undef p_interact
#undef focus_r
#undef focus_xh
#undef focus_xw
#undef focus_ah
#undef focus_aw
#undef target_z
#undef target_y
#undef target_x
#undef target_index
#undef visualize
#undef yheight2
#undef xwidth2
#undef zdepth
#undef yheight
#undef xwidth
#undef priority
#undef material_string
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

/* User declarations for component 'inter_analyzer_colimator_11_blade_4' [577]. */
#define mccompcurname  inter_analyzer_colimator_11_blade_4
#define mccompcurtype  Union_box
#define mccompcurindex 577
#define loop_index mccinter_analyzer_colimator_11_blade_4_loop_index
#define this_box_volume mccinter_analyzer_colimator_11_blade_4_this_box_volume
#define global_geometry_element mccinter_analyzer_colimator_11_blade_4_global_geometry_element
#define this_box_storage mccinter_analyzer_colimator_11_blade_4_this_box_storage
#define material_string mccinter_analyzer_colimator_11_blade_4_material_string
#define priority mccinter_analyzer_colimator_11_blade_4_priority
#define xwidth mccinter_analyzer_colimator_11_blade_4_xwidth
#define yheight mccinter_analyzer_colimator_11_blade_4_yheight
#define zdepth mccinter_analyzer_colimator_11_blade_4_zdepth
#define xwidth2 mccinter_analyzer_colimator_11_blade_4_xwidth2
#define yheight2 mccinter_analyzer_colimator_11_blade_4_yheight2
#define visualize mccinter_analyzer_colimator_11_blade_4_visualize
#define target_index mccinter_analyzer_colimator_11_blade_4_target_index
#define target_x mccinter_analyzer_colimator_11_blade_4_target_x
#define target_y mccinter_analyzer_colimator_11_blade_4_target_y
#define target_z mccinter_analyzer_colimator_11_blade_4_target_z
#define focus_aw mccinter_analyzer_colimator_11_blade_4_focus_aw
#define focus_ah mccinter_analyzer_colimator_11_blade_4_focus_ah
#define focus_xw mccinter_analyzer_colimator_11_blade_4_focus_xw
#define focus_xh mccinter_analyzer_colimator_11_blade_4_focus_xh
#define focus_r mccinter_analyzer_colimator_11_blade_4_focus_r
#define p_interact mccinter_analyzer_colimator_11_blade_4_p_interact
#define mask_string mccinter_analyzer_colimator_11_blade_4_mask_string
#define mask_setting mccinter_analyzer_colimator_11_blade_4_mask_setting
#define number_of_activations mccinter_analyzer_colimator_11_blade_4_number_of_activations
#line 204 "Union_box.comp"
// Needed for transport to the main component
struct global_geometry_element_struct global_geometry_element;

#ifndef ANY_GEOMETRY_DETECTOR_DECLARE
    #define ANY_GEOMETRY_DETECTOR_DECLARE dummy
	//struct pointer_to_global_geometry_list global_geometry_list = {0,NULL};
#endif

int loop_index,found_geometries;

double x_component;
double y_component;
double z_component;

struct Volume_struct this_box_volume;
struct box_storage this_box_storage;

#line 64071 "MACS_sample_kidney_box.c"
#undef number_of_activations
#undef mask_setting
#undef mask_string
#undef p_interact
#undef focus_r
#undef focus_xh
#undef focus_xw
#undef focus_ah
#undef focus_aw
#undef target_z
#undef target_y
#undef target_x
#undef target_index
#undef visualize
#undef yheight2
#undef xwidth2
#undef zdepth
#undef yheight
#undef xwidth
#undef priority
#undef material_string
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

/* User declarations for component 'diffraction_detector_11_exit_volume' [578]. */
#define mccompcurname  diffraction_detector_11_exit_volume
#define mccompcurtype  Union_box
#define mccompcurindex 578
#define loop_index mccdiffraction_detector_11_exit_volume_loop_index
#define this_box_volume mccdiffraction_detector_11_exit_volume_this_box_volume
#define global_geometry_element mccdiffraction_detector_11_exit_volume_global_geometry_element
#define this_box_storage mccdiffraction_detector_11_exit_volume_this_box_storage
#define material_string mccdiffraction_detector_11_exit_volume_material_string
#define priority mccdiffraction_detector_11_exit_volume_priority
#define xwidth mccdiffraction_detector_11_exit_volume_xwidth
#define yheight mccdiffraction_detector_11_exit_volume_yheight
#define zdepth mccdiffraction_detector_11_exit_volume_zdepth
#define xwidth2 mccdiffraction_detector_11_exit_volume_xwidth2
#define yheight2 mccdiffraction_detector_11_exit_volume_yheight2
#define visualize mccdiffraction_detector_11_exit_volume_visualize
#define target_index mccdiffraction_detector_11_exit_volume_target_index
#define target_x mccdiffraction_detector_11_exit_volume_target_x
#define target_y mccdiffraction_detector_11_exit_volume_target_y
#define target_z mccdiffraction_detector_11_exit_volume_target_z
#define focus_aw mccdiffraction_detector_11_exit_volume_focus_aw
#define focus_ah mccdiffraction_detector_11_exit_volume_focus_ah
#define focus_xw mccdiffraction_detector_11_exit_volume_focus_xw
#define focus_xh mccdiffraction_detector_11_exit_volume_focus_xh
#define focus_r mccdiffraction_detector_11_exit_volume_focus_r
#define p_interact mccdiffraction_detector_11_exit_volume_p_interact
#define mask_string mccdiffraction_detector_11_exit_volume_mask_string
#define mask_setting mccdiffraction_detector_11_exit_volume_mask_setting
#define number_of_activations mccdiffraction_detector_11_exit_volume_number_of_activations
#line 204 "Union_box.comp"
// Needed for transport to the main component
struct global_geometry_element_struct global_geometry_element;

#ifndef ANY_GEOMETRY_DETECTOR_DECLARE
    #define ANY_GEOMETRY_DETECTOR_DECLARE dummy
	//struct pointer_to_global_geometry_list global_geometry_list = {0,NULL};
#endif

int loop_index,found_geometries;

double x_component;
double y_component;
double z_component;

struct Volume_struct this_box_volume;
struct box_storage this_box_storage;

#line 64148 "MACS_sample_kidney_box.c"
#undef number_of_activations
#undef mask_setting
#undef mask_string
#undef p_interact
#undef focus_r
#undef focus_xh
#undef focus_xw
#undef focus_ah
#undef focus_aw
#undef target_z
#undef target_y
#undef target_x
#undef target_index
#undef visualize
#undef yheight2
#undef xwidth2
#undef zdepth
#undef yheight
#undef xwidth
#undef priority
#undef material_string
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

/* User declarations for component 'spec_detector_11_exit_volume' [579]. */
#define mccompcurname  spec_detector_11_exit_volume
#define mccompcurtype  Union_box
#define mccompcurindex 579
#define loop_index mccspec_detector_11_exit_volume_loop_index
#define this_box_volume mccspec_detector_11_exit_volume_this_box_volume
#define global_geometry_element mccspec_detector_11_exit_volume_global_geometry_element
#define this_box_storage mccspec_detector_11_exit_volume_this_box_storage
#define material_string mccspec_detector_11_exit_volume_material_string
#define priority mccspec_detector_11_exit_volume_priority
#define xwidth mccspec_detector_11_exit_volume_xwidth
#define yheight mccspec_detector_11_exit_volume_yheight
#define zdepth mccspec_detector_11_exit_volume_zdepth
#define xwidth2 mccspec_detector_11_exit_volume_xwidth2
#define yheight2 mccspec_detector_11_exit_volume_yheight2
#define visualize mccspec_detector_11_exit_volume_visualize
#define target_index mccspec_detector_11_exit_volume_target_index
#define target_x mccspec_detector_11_exit_volume_target_x
#define target_y mccspec_detector_11_exit_volume_target_y
#define target_z mccspec_detector_11_exit_volume_target_z
#define focus_aw mccspec_detector_11_exit_volume_focus_aw
#define focus_ah mccspec_detector_11_exit_volume_focus_ah
#define focus_xw mccspec_detector_11_exit_volume_focus_xw
#define focus_xh mccspec_detector_11_exit_volume_focus_xh
#define focus_r mccspec_detector_11_exit_volume_focus_r
#define p_interact mccspec_detector_11_exit_volume_p_interact
#define mask_string mccspec_detector_11_exit_volume_mask_string
#define mask_setting mccspec_detector_11_exit_volume_mask_setting
#define number_of_activations mccspec_detector_11_exit_volume_number_of_activations
#line 204 "Union_box.comp"
// Needed for transport to the main component
struct global_geometry_element_struct global_geometry_element;

#ifndef ANY_GEOMETRY_DETECTOR_DECLARE
    #define ANY_GEOMETRY_DETECTOR_DECLARE dummy
	//struct pointer_to_global_geometry_list global_geometry_list = {0,NULL};
#endif

int loop_index,found_geometries;

double x_component;
double y_component;
double z_component;

struct Volume_struct this_box_volume;
struct box_storage this_box_storage;

#line 64225 "MACS_sample_kidney_box.c"
#undef number_of_activations
#undef mask_setting
#undef mask_string
#undef p_interact
#undef focus_r
#undef focus_xh
#undef focus_xw
#undef focus_ah
#undef focus_aw
#undef target_z
#undef target_y
#undef target_x
#undef target_index
#undef visualize
#undef yheight2
#undef xwidth2
#undef zdepth
#undef yheight
#undef xwidth
#undef priority
#undef material_string
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

/* User declarations for component 'channel_12_cave1_box1' [580]. */
#define mccompcurname  channel_12_cave1_box1
#define mccompcurtype  Union_box
#define mccompcurindex 580
#define loop_index mccchannel_12_cave1_box1_loop_index
#define this_box_volume mccchannel_12_cave1_box1_this_box_volume
#define global_geometry_element mccchannel_12_cave1_box1_global_geometry_element
#define this_box_storage mccchannel_12_cave1_box1_this_box_storage
#define material_string mccchannel_12_cave1_box1_material_string
#define priority mccchannel_12_cave1_box1_priority
#define xwidth mccchannel_12_cave1_box1_xwidth
#define yheight mccchannel_12_cave1_box1_yheight
#define zdepth mccchannel_12_cave1_box1_zdepth
#define xwidth2 mccchannel_12_cave1_box1_xwidth2
#define yheight2 mccchannel_12_cave1_box1_yheight2
#define visualize mccchannel_12_cave1_box1_visualize
#define target_index mccchannel_12_cave1_box1_target_index
#define target_x mccchannel_12_cave1_box1_target_x
#define target_y mccchannel_12_cave1_box1_target_y
#define target_z mccchannel_12_cave1_box1_target_z
#define focus_aw mccchannel_12_cave1_box1_focus_aw
#define focus_ah mccchannel_12_cave1_box1_focus_ah
#define focus_xw mccchannel_12_cave1_box1_focus_xw
#define focus_xh mccchannel_12_cave1_box1_focus_xh
#define focus_r mccchannel_12_cave1_box1_focus_r
#define p_interact mccchannel_12_cave1_box1_p_interact
#define mask_string mccchannel_12_cave1_box1_mask_string
#define mask_setting mccchannel_12_cave1_box1_mask_setting
#define number_of_activations mccchannel_12_cave1_box1_number_of_activations
#line 204 "Union_box.comp"
// Needed for transport to the main component
struct global_geometry_element_struct global_geometry_element;

#ifndef ANY_GEOMETRY_DETECTOR_DECLARE
    #define ANY_GEOMETRY_DETECTOR_DECLARE dummy
	//struct pointer_to_global_geometry_list global_geometry_list = {0,NULL};
#endif

int loop_index,found_geometries;

double x_component;
double y_component;
double z_component;

struct Volume_struct this_box_volume;
struct box_storage this_box_storage;

#line 64302 "MACS_sample_kidney_box.c"
#undef number_of_activations
#undef mask_setting
#undef mask_string
#undef p_interact
#undef focus_r
#undef focus_xh
#undef focus_xw
#undef focus_ah
#undef focus_aw
#undef target_z
#undef target_y
#undef target_x
#undef target_index
#undef visualize
#undef yheight2
#undef xwidth2
#undef zdepth
#undef yheight
#undef xwidth
#undef priority
#undef material_string
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

/* User declarations for component 'channel_12_cave1_box2' [581]. */
#define mccompcurname  channel_12_cave1_box2
#define mccompcurtype  Union_box
#define mccompcurindex 581
#define loop_index mccchannel_12_cave1_box2_loop_index
#define this_box_volume mccchannel_12_cave1_box2_this_box_volume
#define global_geometry_element mccchannel_12_cave1_box2_global_geometry_element
#define this_box_storage mccchannel_12_cave1_box2_this_box_storage
#define material_string mccchannel_12_cave1_box2_material_string
#define priority mccchannel_12_cave1_box2_priority
#define xwidth mccchannel_12_cave1_box2_xwidth
#define yheight mccchannel_12_cave1_box2_yheight
#define zdepth mccchannel_12_cave1_box2_zdepth
#define xwidth2 mccchannel_12_cave1_box2_xwidth2
#define yheight2 mccchannel_12_cave1_box2_yheight2
#define visualize mccchannel_12_cave1_box2_visualize
#define target_index mccchannel_12_cave1_box2_target_index
#define target_x mccchannel_12_cave1_box2_target_x
#define target_y mccchannel_12_cave1_box2_target_y
#define target_z mccchannel_12_cave1_box2_target_z
#define focus_aw mccchannel_12_cave1_box2_focus_aw
#define focus_ah mccchannel_12_cave1_box2_focus_ah
#define focus_xw mccchannel_12_cave1_box2_focus_xw
#define focus_xh mccchannel_12_cave1_box2_focus_xh
#define focus_r mccchannel_12_cave1_box2_focus_r
#define p_interact mccchannel_12_cave1_box2_p_interact
#define mask_string mccchannel_12_cave1_box2_mask_string
#define mask_setting mccchannel_12_cave1_box2_mask_setting
#define number_of_activations mccchannel_12_cave1_box2_number_of_activations
#line 204 "Union_box.comp"
// Needed for transport to the main component
struct global_geometry_element_struct global_geometry_element;

#ifndef ANY_GEOMETRY_DETECTOR_DECLARE
    #define ANY_GEOMETRY_DETECTOR_DECLARE dummy
	//struct pointer_to_global_geometry_list global_geometry_list = {0,NULL};
#endif

int loop_index,found_geometries;

double x_component;
double y_component;
double z_component;

struct Volume_struct this_box_volume;
struct box_storage this_box_storage;

#line 64379 "MACS_sample_kidney_box.c"
#undef number_of_activations
#undef mask_setting
#undef mask_string
#undef p_interact
#undef focus_r
#undef focus_xh
#undef focus_xw
#undef focus_ah
#undef focus_aw
#undef target_z
#undef target_y
#undef target_x
#undef target_index
#undef visualize
#undef yheight2
#undef xwidth2
#undef zdepth
#undef yheight
#undef xwidth
#undef priority
#undef material_string
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

/* User declarations for component 'channel_12_cave1_box3' [582]. */
#define mccompcurname  channel_12_cave1_box3
#define mccompcurtype  Union_box
#define mccompcurindex 582
#define loop_index mccchannel_12_cave1_box3_loop_index
#define this_box_volume mccchannel_12_cave1_box3_this_box_volume
#define global_geometry_element mccchannel_12_cave1_box3_global_geometry_element
#define this_box_storage mccchannel_12_cave1_box3_this_box_storage
#define material_string mccchannel_12_cave1_box3_material_string
#define priority mccchannel_12_cave1_box3_priority
#define xwidth mccchannel_12_cave1_box3_xwidth
#define yheight mccchannel_12_cave1_box3_yheight
#define zdepth mccchannel_12_cave1_box3_zdepth
#define xwidth2 mccchannel_12_cave1_box3_xwidth2
#define yheight2 mccchannel_12_cave1_box3_yheight2
#define visualize mccchannel_12_cave1_box3_visualize
#define target_index mccchannel_12_cave1_box3_target_index
#define target_x mccchannel_12_cave1_box3_target_x
#define target_y mccchannel_12_cave1_box3_target_y
#define target_z mccchannel_12_cave1_box3_target_z
#define focus_aw mccchannel_12_cave1_box3_focus_aw
#define focus_ah mccchannel_12_cave1_box3_focus_ah
#define focus_xw mccchannel_12_cave1_box3_focus_xw
#define focus_xh mccchannel_12_cave1_box3_focus_xh
#define focus_r mccchannel_12_cave1_box3_focus_r
#define p_interact mccchannel_12_cave1_box3_p_interact
#define mask_string mccchannel_12_cave1_box3_mask_string
#define mask_setting mccchannel_12_cave1_box3_mask_setting
#define number_of_activations mccchannel_12_cave1_box3_number_of_activations
#line 204 "Union_box.comp"
// Needed for transport to the main component
struct global_geometry_element_struct global_geometry_element;

#ifndef ANY_GEOMETRY_DETECTOR_DECLARE
    #define ANY_GEOMETRY_DETECTOR_DECLARE dummy
	//struct pointer_to_global_geometry_list global_geometry_list = {0,NULL};
#endif

int loop_index,found_geometries;

double x_component;
double y_component;
double z_component;

struct Volume_struct this_box_volume;
struct box_storage this_box_storage;

#line 64456 "MACS_sample_kidney_box.c"
#undef number_of_activations
#undef mask_setting
#undef mask_string
#undef p_interact
#undef focus_r
#undef focus_xh
#undef focus_xw
#undef focus_ah
#undef focus_aw
#undef target_z
#undef target_y
#undef target_x
#undef target_index
#undef visualize
#undef yheight2
#undef xwidth2
#undef zdepth
#undef yheight
#undef xwidth
#undef priority
#undef material_string
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

/* User declarations for component 'channel_12_cave1_cyl1' [583]. */
#define mccompcurname  channel_12_cave1_cyl1
#define mccompcurtype  Union_cylinder
#define mccompcurindex 583
#define loop_index mccchannel_12_cave1_cyl1_loop_index
#define this_cylinder_volume mccchannel_12_cave1_cyl1_this_cylinder_volume
#define global_geometry_element mccchannel_12_cave1_cyl1_global_geometry_element
#define this_cylinder_storage mccchannel_12_cave1_cyl1_this_cylinder_storage
#define material_string mccchannel_12_cave1_cyl1_material_string
#define priority mccchannel_12_cave1_cyl1_priority
#define radius mccchannel_12_cave1_cyl1_radius
#define yheight mccchannel_12_cave1_cyl1_yheight
#define visualize mccchannel_12_cave1_cyl1_visualize
#define target_index mccchannel_12_cave1_cyl1_target_index
#define target_x mccchannel_12_cave1_cyl1_target_x
#define target_y mccchannel_12_cave1_cyl1_target_y
#define target_z mccchannel_12_cave1_cyl1_target_z
#define focus_aw mccchannel_12_cave1_cyl1_focus_aw
#define focus_ah mccchannel_12_cave1_cyl1_focus_ah
#define focus_xw mccchannel_12_cave1_cyl1_focus_xw
#define focus_xh mccchannel_12_cave1_cyl1_focus_xh
#define focus_r mccchannel_12_cave1_cyl1_focus_r
#define p_interact mccchannel_12_cave1_cyl1_p_interact
#define mask_string mccchannel_12_cave1_cyl1_mask_string
#define mask_setting mccchannel_12_cave1_cyl1_mask_setting
#define number_of_activations mccchannel_12_cave1_cyl1_number_of_activations
#line 167 "Union_cylinder.comp"
// Needed for transport to the main component
struct global_geometry_element_struct global_geometry_element;

#ifndef ANY_GEOMETRY_DETECTOR_DECLARE
    #define ANY_GEOMETRY_DETECTOR_DECLARE dummy
	//struct pointer_to_global_geometry_list global_geometry_list = {0,NULL};
#endif

int dummy;
int loop_index,found_geometries;
int loop_2_index;
int material_index;

struct Volume_struct this_cylinder_volume;
struct cylinder_storage this_cylinder_storage;
#line 64528 "MACS_sample_kidney_box.c"
#undef number_of_activations
#undef mask_setting
#undef mask_string
#undef p_interact
#undef focus_r
#undef focus_xh
#undef focus_xw
#undef focus_ah
#undef focus_aw
#undef target_z
#undef target_y
#undef target_x
#undef target_index
#undef visualize
#undef yheight
#undef radius
#undef priority
#undef material_string
#undef this_cylinder_storage
#undef global_geometry_element
#undef this_cylinder_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

/* User declarations for component 'channel_12_analyzer_1_center' [584]. */
#define mccompcurname  channel_12_analyzer_1_center
#define mccompcurtype  Arm
#define mccompcurindex 584
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

/* User declarations for component 'channel_12_analyzer_1_rotated' [585]. */
#define mccompcurname  channel_12_analyzer_1_rotated
#define mccompcurtype  Arm
#define mccompcurindex 585
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

/* User declarations for component 'channel_12_analyzer_1_array_crystal_array_0' [586]. */
#define mccompcurname  channel_12_analyzer_1_array_crystal_array_0
#define mccompcurtype  Union_box
#define mccompcurindex 586
#define loop_index mccchannel_12_analyzer_1_array_crystal_array_0_loop_index
#define this_box_volume mccchannel_12_analyzer_1_array_crystal_array_0_this_box_volume
#define global_geometry_element mccchannel_12_analyzer_1_array_crystal_array_0_global_geometry_element
#define this_box_storage mccchannel_12_analyzer_1_array_crystal_array_0_this_box_storage
#define material_string mccchannel_12_analyzer_1_array_crystal_array_0_material_string
#define priority mccchannel_12_analyzer_1_array_crystal_array_0_priority
#define xwidth mccchannel_12_analyzer_1_array_crystal_array_0_xwidth
#define yheight mccchannel_12_analyzer_1_array_crystal_array_0_yheight
#define zdepth mccchannel_12_analyzer_1_array_crystal_array_0_zdepth
#define xwidth2 mccchannel_12_analyzer_1_array_crystal_array_0_xwidth2
#define yheight2 mccchannel_12_analyzer_1_array_crystal_array_0_yheight2
#define visualize mccchannel_12_analyzer_1_array_crystal_array_0_visualize
#define target_index mccchannel_12_analyzer_1_array_crystal_array_0_target_index
#define target_x mccchannel_12_analyzer_1_array_crystal_array_0_target_x
#define target_y mccchannel_12_analyzer_1_array_crystal_array_0_target_y
#define target_z mccchannel_12_analyzer_1_array_crystal_array_0_target_z
#define focus_aw mccchannel_12_analyzer_1_array_crystal_array_0_focus_aw
#define focus_ah mccchannel_12_analyzer_1_array_crystal_array_0_focus_ah
#define focus_xw mccchannel_12_analyzer_1_array_crystal_array_0_focus_xw
#define focus_xh mccchannel_12_analyzer_1_array_crystal_array_0_focus_xh
#define focus_r mccchannel_12_analyzer_1_array_crystal_array_0_focus_r
#define p_interact mccchannel_12_analyzer_1_array_crystal_array_0_p_interact
#define mask_string mccchannel_12_analyzer_1_array_crystal_array_0_mask_string
#define mask_setting mccchannel_12_analyzer_1_array_crystal_array_0_mask_setting
#define number_of_activations mccchannel_12_analyzer_1_array_crystal_array_0_number_of_activations
#line 204 "Union_box.comp"
// Needed for transport to the main component
struct global_geometry_element_struct global_geometry_element;

#ifndef ANY_GEOMETRY_DETECTOR_DECLARE
    #define ANY_GEOMETRY_DETECTOR_DECLARE dummy
	//struct pointer_to_global_geometry_list global_geometry_list = {0,NULL};
#endif

int loop_index,found_geometries;

double x_component;
double y_component;
double z_component;

struct Volume_struct this_box_volume;
struct box_storage this_box_storage;

#line 64618 "MACS_sample_kidney_box.c"
#undef number_of_activations
#undef mask_setting
#undef mask_string
#undef p_interact
#undef focus_r
#undef focus_xh
#undef focus_xw
#undef focus_ah
#undef focus_aw
#undef target_z
#undef target_y
#undef target_x
#undef target_index
#undef visualize
#undef yheight2
#undef xwidth2
#undef zdepth
#undef yheight
#undef xwidth
#undef priority
#undef material_string
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

/* User declarations for component 'channel_12_analyzer_1_array_crystal_array_1' [587]. */
#define mccompcurname  channel_12_analyzer_1_array_crystal_array_1
#define mccompcurtype  Union_box
#define mccompcurindex 587
#define loop_index mccchannel_12_analyzer_1_array_crystal_array_1_loop_index
#define this_box_volume mccchannel_12_analyzer_1_array_crystal_array_1_this_box_volume
#define global_geometry_element mccchannel_12_analyzer_1_array_crystal_array_1_global_geometry_element
#define this_box_storage mccchannel_12_analyzer_1_array_crystal_array_1_this_box_storage
#define material_string mccchannel_12_analyzer_1_array_crystal_array_1_material_string
#define priority mccchannel_12_analyzer_1_array_crystal_array_1_priority
#define xwidth mccchannel_12_analyzer_1_array_crystal_array_1_xwidth
#define yheight mccchannel_12_analyzer_1_array_crystal_array_1_yheight
#define zdepth mccchannel_12_analyzer_1_array_crystal_array_1_zdepth
#define xwidth2 mccchannel_12_analyzer_1_array_crystal_array_1_xwidth2
#define yheight2 mccchannel_12_analyzer_1_array_crystal_array_1_yheight2
#define visualize mccchannel_12_analyzer_1_array_crystal_array_1_visualize
#define target_index mccchannel_12_analyzer_1_array_crystal_array_1_target_index
#define target_x mccchannel_12_analyzer_1_array_crystal_array_1_target_x
#define target_y mccchannel_12_analyzer_1_array_crystal_array_1_target_y
#define target_z mccchannel_12_analyzer_1_array_crystal_array_1_target_z
#define focus_aw mccchannel_12_analyzer_1_array_crystal_array_1_focus_aw
#define focus_ah mccchannel_12_analyzer_1_array_crystal_array_1_focus_ah
#define focus_xw mccchannel_12_analyzer_1_array_crystal_array_1_focus_xw
#define focus_xh mccchannel_12_analyzer_1_array_crystal_array_1_focus_xh
#define focus_r mccchannel_12_analyzer_1_array_crystal_array_1_focus_r
#define p_interact mccchannel_12_analyzer_1_array_crystal_array_1_p_interact
#define mask_string mccchannel_12_analyzer_1_array_crystal_array_1_mask_string
#define mask_setting mccchannel_12_analyzer_1_array_crystal_array_1_mask_setting
#define number_of_activations mccchannel_12_analyzer_1_array_crystal_array_1_number_of_activations
#line 204 "Union_box.comp"
// Needed for transport to the main component
struct global_geometry_element_struct global_geometry_element;

#ifndef ANY_GEOMETRY_DETECTOR_DECLARE
    #define ANY_GEOMETRY_DETECTOR_DECLARE dummy
	//struct pointer_to_global_geometry_list global_geometry_list = {0,NULL};
#endif

int loop_index,found_geometries;

double x_component;
double y_component;
double z_component;

struct Volume_struct this_box_volume;
struct box_storage this_box_storage;

#line 64695 "MACS_sample_kidney_box.c"
#undef number_of_activations
#undef mask_setting
#undef mask_string
#undef p_interact
#undef focus_r
#undef focus_xh
#undef focus_xw
#undef focus_ah
#undef focus_aw
#undef target_z
#undef target_y
#undef target_x
#undef target_index
#undef visualize
#undef yheight2
#undef xwidth2
#undef zdepth
#undef yheight
#undef xwidth
#undef priority
#undef material_string
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

/* User declarations for component 'channel_12_analyzer_1_array_crystal_array_2' [588]. */
#define mccompcurname  channel_12_analyzer_1_array_crystal_array_2
#define mccompcurtype  Union_box
#define mccompcurindex 588
#define loop_index mccchannel_12_analyzer_1_array_crystal_array_2_loop_index
#define this_box_volume mccchannel_12_analyzer_1_array_crystal_array_2_this_box_volume
#define global_geometry_element mccchannel_12_analyzer_1_array_crystal_array_2_global_geometry_element
#define this_box_storage mccchannel_12_analyzer_1_array_crystal_array_2_this_box_storage
#define material_string mccchannel_12_analyzer_1_array_crystal_array_2_material_string
#define priority mccchannel_12_analyzer_1_array_crystal_array_2_priority
#define xwidth mccchannel_12_analyzer_1_array_crystal_array_2_xwidth
#define yheight mccchannel_12_analyzer_1_array_crystal_array_2_yheight
#define zdepth mccchannel_12_analyzer_1_array_crystal_array_2_zdepth
#define xwidth2 mccchannel_12_analyzer_1_array_crystal_array_2_xwidth2
#define yheight2 mccchannel_12_analyzer_1_array_crystal_array_2_yheight2
#define visualize mccchannel_12_analyzer_1_array_crystal_array_2_visualize
#define target_index mccchannel_12_analyzer_1_array_crystal_array_2_target_index
#define target_x mccchannel_12_analyzer_1_array_crystal_array_2_target_x
#define target_y mccchannel_12_analyzer_1_array_crystal_array_2_target_y
#define target_z mccchannel_12_analyzer_1_array_crystal_array_2_target_z
#define focus_aw mccchannel_12_analyzer_1_array_crystal_array_2_focus_aw
#define focus_ah mccchannel_12_analyzer_1_array_crystal_array_2_focus_ah
#define focus_xw mccchannel_12_analyzer_1_array_crystal_array_2_focus_xw
#define focus_xh mccchannel_12_analyzer_1_array_crystal_array_2_focus_xh
#define focus_r mccchannel_12_analyzer_1_array_crystal_array_2_focus_r
#define p_interact mccchannel_12_analyzer_1_array_crystal_array_2_p_interact
#define mask_string mccchannel_12_analyzer_1_array_crystal_array_2_mask_string
#define mask_setting mccchannel_12_analyzer_1_array_crystal_array_2_mask_setting
#define number_of_activations mccchannel_12_analyzer_1_array_crystal_array_2_number_of_activations
#line 204 "Union_box.comp"
// Needed for transport to the main component
struct global_geometry_element_struct global_geometry_element;

#ifndef ANY_GEOMETRY_DETECTOR_DECLARE
    #define ANY_GEOMETRY_DETECTOR_DECLARE dummy
	//struct pointer_to_global_geometry_list global_geometry_list = {0,NULL};
#endif

int loop_index,found_geometries;

double x_component;
double y_component;
double z_component;

struct Volume_struct this_box_volume;
struct box_storage this_box_storage;

#line 64772 "MACS_sample_kidney_box.c"
#undef number_of_activations
#undef mask_setting
#undef mask_string
#undef p_interact
#undef focus_r
#undef focus_xh
#undef focus_xw
#undef focus_ah
#undef focus_aw
#undef target_z
#undef target_y
#undef target_x
#undef target_index
#undef visualize
#undef yheight2
#undef xwidth2
#undef zdepth
#undef yheight
#undef xwidth
#undef priority
#undef material_string
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

/* User declarations for component 'channel_12_analyzer_1_array_crystal_array_3' [589]. */
#define mccompcurname  channel_12_analyzer_1_array_crystal_array_3
#define mccompcurtype  Union_box
#define mccompcurindex 589
#define loop_index mccchannel_12_analyzer_1_array_crystal_array_3_loop_index
#define this_box_volume mccchannel_12_analyzer_1_array_crystal_array_3_this_box_volume
#define global_geometry_element mccchannel_12_analyzer_1_array_crystal_array_3_global_geometry_element
#define this_box_storage mccchannel_12_analyzer_1_array_crystal_array_3_this_box_storage
#define material_string mccchannel_12_analyzer_1_array_crystal_array_3_material_string
#define priority mccchannel_12_analyzer_1_array_crystal_array_3_priority
#define xwidth mccchannel_12_analyzer_1_array_crystal_array_3_xwidth
#define yheight mccchannel_12_analyzer_1_array_crystal_array_3_yheight
#define zdepth mccchannel_12_analyzer_1_array_crystal_array_3_zdepth
#define xwidth2 mccchannel_12_analyzer_1_array_crystal_array_3_xwidth2
#define yheight2 mccchannel_12_analyzer_1_array_crystal_array_3_yheight2
#define visualize mccchannel_12_analyzer_1_array_crystal_array_3_visualize
#define target_index mccchannel_12_analyzer_1_array_crystal_array_3_target_index
#define target_x mccchannel_12_analyzer_1_array_crystal_array_3_target_x
#define target_y mccchannel_12_analyzer_1_array_crystal_array_3_target_y
#define target_z mccchannel_12_analyzer_1_array_crystal_array_3_target_z
#define focus_aw mccchannel_12_analyzer_1_array_crystal_array_3_focus_aw
#define focus_ah mccchannel_12_analyzer_1_array_crystal_array_3_focus_ah
#define focus_xw mccchannel_12_analyzer_1_array_crystal_array_3_focus_xw
#define focus_xh mccchannel_12_analyzer_1_array_crystal_array_3_focus_xh
#define focus_r mccchannel_12_analyzer_1_array_crystal_array_3_focus_r
#define p_interact mccchannel_12_analyzer_1_array_crystal_array_3_p_interact
#define mask_string mccchannel_12_analyzer_1_array_crystal_array_3_mask_string
#define mask_setting mccchannel_12_analyzer_1_array_crystal_array_3_mask_setting
#define number_of_activations mccchannel_12_analyzer_1_array_crystal_array_3_number_of_activations
#line 204 "Union_box.comp"
// Needed for transport to the main component
struct global_geometry_element_struct global_geometry_element;

#ifndef ANY_GEOMETRY_DETECTOR_DECLARE
    #define ANY_GEOMETRY_DETECTOR_DECLARE dummy
	//struct pointer_to_global_geometry_list global_geometry_list = {0,NULL};
#endif

int loop_index,found_geometries;

double x_component;
double y_component;
double z_component;

struct Volume_struct this_box_volume;
struct box_storage this_box_storage;

#line 64849 "MACS_sample_kidney_box.c"
#undef number_of_activations
#undef mask_setting
#undef mask_string
#undef p_interact
#undef focus_r
#undef focus_xh
#undef focus_xw
#undef focus_ah
#undef focus_aw
#undef target_z
#undef target_y
#undef target_x
#undef target_index
#undef visualize
#undef yheight2
#undef xwidth2
#undef zdepth
#undef yheight
#undef xwidth
#undef priority
#undef material_string
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

/* User declarations for component 'channel_12_analyzer_1_array_crystal_array_4' [590]. */
#define mccompcurname  channel_12_analyzer_1_array_crystal_array_4
#define mccompcurtype  Union_box
#define mccompcurindex 590
#define loop_index mccchannel_12_analyzer_1_array_crystal_array_4_loop_index
#define this_box_volume mccchannel_12_analyzer_1_array_crystal_array_4_this_box_volume
#define global_geometry_element mccchannel_12_analyzer_1_array_crystal_array_4_global_geometry_element
#define this_box_storage mccchannel_12_analyzer_1_array_crystal_array_4_this_box_storage
#define material_string mccchannel_12_analyzer_1_array_crystal_array_4_material_string
#define priority mccchannel_12_analyzer_1_array_crystal_array_4_priority
#define xwidth mccchannel_12_analyzer_1_array_crystal_array_4_xwidth
#define yheight mccchannel_12_analyzer_1_array_crystal_array_4_yheight
#define zdepth mccchannel_12_analyzer_1_array_crystal_array_4_zdepth
#define xwidth2 mccchannel_12_analyzer_1_array_crystal_array_4_xwidth2
#define yheight2 mccchannel_12_analyzer_1_array_crystal_array_4_yheight2
#define visualize mccchannel_12_analyzer_1_array_crystal_array_4_visualize
#define target_index mccchannel_12_analyzer_1_array_crystal_array_4_target_index
#define target_x mccchannel_12_analyzer_1_array_crystal_array_4_target_x
#define target_y mccchannel_12_analyzer_1_array_crystal_array_4_target_y
#define target_z mccchannel_12_analyzer_1_array_crystal_array_4_target_z
#define focus_aw mccchannel_12_analyzer_1_array_crystal_array_4_focus_aw
#define focus_ah mccchannel_12_analyzer_1_array_crystal_array_4_focus_ah
#define focus_xw mccchannel_12_analyzer_1_array_crystal_array_4_focus_xw
#define focus_xh mccchannel_12_analyzer_1_array_crystal_array_4_focus_xh
#define focus_r mccchannel_12_analyzer_1_array_crystal_array_4_focus_r
#define p_interact mccchannel_12_analyzer_1_array_crystal_array_4_p_interact
#define mask_string mccchannel_12_analyzer_1_array_crystal_array_4_mask_string
#define mask_setting mccchannel_12_analyzer_1_array_crystal_array_4_mask_setting
#define number_of_activations mccchannel_12_analyzer_1_array_crystal_array_4_number_of_activations
#line 204 "Union_box.comp"
// Needed for transport to the main component
struct global_geometry_element_struct global_geometry_element;

#ifndef ANY_GEOMETRY_DETECTOR_DECLARE
    #define ANY_GEOMETRY_DETECTOR_DECLARE dummy
	//struct pointer_to_global_geometry_list global_geometry_list = {0,NULL};
#endif

int loop_index,found_geometries;

double x_component;
double y_component;
double z_component;

struct Volume_struct this_box_volume;
struct box_storage this_box_storage;

#line 64926 "MACS_sample_kidney_box.c"
#undef number_of_activations
#undef mask_setting
#undef mask_string
#undef p_interact
#undef focus_r
#undef focus_xh
#undef focus_xw
#undef focus_ah
#undef focus_aw
#undef target_z
#undef target_y
#undef target_x
#undef target_index
#undef visualize
#undef yheight2
#undef xwidth2
#undef zdepth
#undef yheight
#undef xwidth
#undef priority
#undef material_string
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

/* User declarations for component 'channel_12_analyzer_1_array_crystal_array_5' [591]. */
#define mccompcurname  channel_12_analyzer_1_array_crystal_array_5
#define mccompcurtype  Union_box
#define mccompcurindex 591
#define loop_index mccchannel_12_analyzer_1_array_crystal_array_5_loop_index
#define this_box_volume mccchannel_12_analyzer_1_array_crystal_array_5_this_box_volume
#define global_geometry_element mccchannel_12_analyzer_1_array_crystal_array_5_global_geometry_element
#define this_box_storage mccchannel_12_analyzer_1_array_crystal_array_5_this_box_storage
#define material_string mccchannel_12_analyzer_1_array_crystal_array_5_material_string
#define priority mccchannel_12_analyzer_1_array_crystal_array_5_priority
#define xwidth mccchannel_12_analyzer_1_array_crystal_array_5_xwidth
#define yheight mccchannel_12_analyzer_1_array_crystal_array_5_yheight
#define zdepth mccchannel_12_analyzer_1_array_crystal_array_5_zdepth
#define xwidth2 mccchannel_12_analyzer_1_array_crystal_array_5_xwidth2
#define yheight2 mccchannel_12_analyzer_1_array_crystal_array_5_yheight2
#define visualize mccchannel_12_analyzer_1_array_crystal_array_5_visualize
#define target_index mccchannel_12_analyzer_1_array_crystal_array_5_target_index
#define target_x mccchannel_12_analyzer_1_array_crystal_array_5_target_x
#define target_y mccchannel_12_analyzer_1_array_crystal_array_5_target_y
#define target_z mccchannel_12_analyzer_1_array_crystal_array_5_target_z
#define focus_aw mccchannel_12_analyzer_1_array_crystal_array_5_focus_aw
#define focus_ah mccchannel_12_analyzer_1_array_crystal_array_5_focus_ah
#define focus_xw mccchannel_12_analyzer_1_array_crystal_array_5_focus_xw
#define focus_xh mccchannel_12_analyzer_1_array_crystal_array_5_focus_xh
#define focus_r mccchannel_12_analyzer_1_array_crystal_array_5_focus_r
#define p_interact mccchannel_12_analyzer_1_array_crystal_array_5_p_interact
#define mask_string mccchannel_12_analyzer_1_array_crystal_array_5_mask_string
#define mask_setting mccchannel_12_analyzer_1_array_crystal_array_5_mask_setting
#define number_of_activations mccchannel_12_analyzer_1_array_crystal_array_5_number_of_activations
#line 204 "Union_box.comp"
// Needed for transport to the main component
struct global_geometry_element_struct global_geometry_element;

#ifndef ANY_GEOMETRY_DETECTOR_DECLARE
    #define ANY_GEOMETRY_DETECTOR_DECLARE dummy
	//struct pointer_to_global_geometry_list global_geometry_list = {0,NULL};
#endif

int loop_index,found_geometries;

double x_component;
double y_component;
double z_component;

struct Volume_struct this_box_volume;
struct box_storage this_box_storage;

#line 65003 "MACS_sample_kidney_box.c"
#undef number_of_activations
#undef mask_setting
#undef mask_string
#undef p_interact
#undef focus_r
#undef focus_xh
#undef focus_xw
#undef focus_ah
#undef focus_aw
#undef target_z
#undef target_y
#undef target_x
#undef target_index
#undef visualize
#undef yheight2
#undef xwidth2
#undef zdepth
#undef yheight
#undef xwidth
#undef priority
#undef material_string
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

/* User declarations for component 'channel_12_analyzer_1_array_crystal_array_6' [592]. */
#define mccompcurname  channel_12_analyzer_1_array_crystal_array_6
#define mccompcurtype  Union_box
#define mccompcurindex 592
#define loop_index mccchannel_12_analyzer_1_array_crystal_array_6_loop_index
#define this_box_volume mccchannel_12_analyzer_1_array_crystal_array_6_this_box_volume
#define global_geometry_element mccchannel_12_analyzer_1_array_crystal_array_6_global_geometry_element
#define this_box_storage mccchannel_12_analyzer_1_array_crystal_array_6_this_box_storage
#define material_string mccchannel_12_analyzer_1_array_crystal_array_6_material_string
#define priority mccchannel_12_analyzer_1_array_crystal_array_6_priority
#define xwidth mccchannel_12_analyzer_1_array_crystal_array_6_xwidth
#define yheight mccchannel_12_analyzer_1_array_crystal_array_6_yheight
#define zdepth mccchannel_12_analyzer_1_array_crystal_array_6_zdepth
#define xwidth2 mccchannel_12_analyzer_1_array_crystal_array_6_xwidth2
#define yheight2 mccchannel_12_analyzer_1_array_crystal_array_6_yheight2
#define visualize mccchannel_12_analyzer_1_array_crystal_array_6_visualize
#define target_index mccchannel_12_analyzer_1_array_crystal_array_6_target_index
#define target_x mccchannel_12_analyzer_1_array_crystal_array_6_target_x
#define target_y mccchannel_12_analyzer_1_array_crystal_array_6_target_y
#define target_z mccchannel_12_analyzer_1_array_crystal_array_6_target_z
#define focus_aw mccchannel_12_analyzer_1_array_crystal_array_6_focus_aw
#define focus_ah mccchannel_12_analyzer_1_array_crystal_array_6_focus_ah
#define focus_xw mccchannel_12_analyzer_1_array_crystal_array_6_focus_xw
#define focus_xh mccchannel_12_analyzer_1_array_crystal_array_6_focus_xh
#define focus_r mccchannel_12_analyzer_1_array_crystal_array_6_focus_r
#define p_interact mccchannel_12_analyzer_1_array_crystal_array_6_p_interact
#define mask_string mccchannel_12_analyzer_1_array_crystal_array_6_mask_string
#define mask_setting mccchannel_12_analyzer_1_array_crystal_array_6_mask_setting
#define number_of_activations mccchannel_12_analyzer_1_array_crystal_array_6_number_of_activations
#line 204 "Union_box.comp"
// Needed for transport to the main component
struct global_geometry_element_struct global_geometry_element;

#ifndef ANY_GEOMETRY_DETECTOR_DECLARE
    #define ANY_GEOMETRY_DETECTOR_DECLARE dummy
	//struct pointer_to_global_geometry_list global_geometry_list = {0,NULL};
#endif

int loop_index,found_geometries;

double x_component;
double y_component;
double z_component;

struct Volume_struct this_box_volume;
struct box_storage this_box_storage;

#line 65080 "MACS_sample_kidney_box.c"
#undef number_of_activations
#undef mask_setting
#undef mask_string
#undef p_interact
#undef focus_r
#undef focus_xh
#undef focus_xw
#undef focus_ah
#undef focus_aw
#undef target_z
#undef target_y
#undef target_x
#undef target_index
#undef visualize
#undef yheight2
#undef xwidth2
#undef zdepth
#undef yheight
#undef xwidth
#undef priority
#undef material_string
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

/* User declarations for component 'channel_12_analyzer_1_array_crystal_array_7' [593]. */
#define mccompcurname  channel_12_analyzer_1_array_crystal_array_7
#define mccompcurtype  Union_box
#define mccompcurindex 593
#define loop_index mccchannel_12_analyzer_1_array_crystal_array_7_loop_index
#define this_box_volume mccchannel_12_analyzer_1_array_crystal_array_7_this_box_volume
#define global_geometry_element mccchannel_12_analyzer_1_array_crystal_array_7_global_geometry_element
#define this_box_storage mccchannel_12_analyzer_1_array_crystal_array_7_this_box_storage
#define material_string mccchannel_12_analyzer_1_array_crystal_array_7_material_string
#define priority mccchannel_12_analyzer_1_array_crystal_array_7_priority
#define xwidth mccchannel_12_analyzer_1_array_crystal_array_7_xwidth
#define yheight mccchannel_12_analyzer_1_array_crystal_array_7_yheight
#define zdepth mccchannel_12_analyzer_1_array_crystal_array_7_zdepth
#define xwidth2 mccchannel_12_analyzer_1_array_crystal_array_7_xwidth2
#define yheight2 mccchannel_12_analyzer_1_array_crystal_array_7_yheight2
#define visualize mccchannel_12_analyzer_1_array_crystal_array_7_visualize
#define target_index mccchannel_12_analyzer_1_array_crystal_array_7_target_index
#define target_x mccchannel_12_analyzer_1_array_crystal_array_7_target_x
#define target_y mccchannel_12_analyzer_1_array_crystal_array_7_target_y
#define target_z mccchannel_12_analyzer_1_array_crystal_array_7_target_z
#define focus_aw mccchannel_12_analyzer_1_array_crystal_array_7_focus_aw
#define focus_ah mccchannel_12_analyzer_1_array_crystal_array_7_focus_ah
#define focus_xw mccchannel_12_analyzer_1_array_crystal_array_7_focus_xw
#define focus_xh mccchannel_12_analyzer_1_array_crystal_array_7_focus_xh
#define focus_r mccchannel_12_analyzer_1_array_crystal_array_7_focus_r
#define p_interact mccchannel_12_analyzer_1_array_crystal_array_7_p_interact
#define mask_string mccchannel_12_analyzer_1_array_crystal_array_7_mask_string
#define mask_setting mccchannel_12_analyzer_1_array_crystal_array_7_mask_setting
#define number_of_activations mccchannel_12_analyzer_1_array_crystal_array_7_number_of_activations
#line 204 "Union_box.comp"
// Needed for transport to the main component
struct global_geometry_element_struct global_geometry_element;

#ifndef ANY_GEOMETRY_DETECTOR_DECLARE
    #define ANY_GEOMETRY_DETECTOR_DECLARE dummy
	//struct pointer_to_global_geometry_list global_geometry_list = {0,NULL};
#endif

int loop_index,found_geometries;

double x_component;
double y_component;
double z_component;

struct Volume_struct this_box_volume;
struct box_storage this_box_storage;

#line 65157 "MACS_sample_kidney_box.c"
#undef number_of_activations
#undef mask_setting
#undef mask_string
#undef p_interact
#undef focus_r
#undef focus_xh
#undef focus_xw
#undef focus_ah
#undef focus_aw
#undef target_z
#undef target_y
#undef target_x
#undef target_index
#undef visualize
#undef yheight2
#undef xwidth2
#undef zdepth
#undef yheight
#undef xwidth
#undef priority
#undef material_string
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

/* User declarations for component 'channel_12_analyzer_1_array_crystal_array_8' [594]. */
#define mccompcurname  channel_12_analyzer_1_array_crystal_array_8
#define mccompcurtype  Union_box
#define mccompcurindex 594
#define loop_index mccchannel_12_analyzer_1_array_crystal_array_8_loop_index
#define this_box_volume mccchannel_12_analyzer_1_array_crystal_array_8_this_box_volume
#define global_geometry_element mccchannel_12_analyzer_1_array_crystal_array_8_global_geometry_element
#define this_box_storage mccchannel_12_analyzer_1_array_crystal_array_8_this_box_storage
#define material_string mccchannel_12_analyzer_1_array_crystal_array_8_material_string
#define priority mccchannel_12_analyzer_1_array_crystal_array_8_priority
#define xwidth mccchannel_12_analyzer_1_array_crystal_array_8_xwidth
#define yheight mccchannel_12_analyzer_1_array_crystal_array_8_yheight
#define zdepth mccchannel_12_analyzer_1_array_crystal_array_8_zdepth
#define xwidth2 mccchannel_12_analyzer_1_array_crystal_array_8_xwidth2
#define yheight2 mccchannel_12_analyzer_1_array_crystal_array_8_yheight2
#define visualize mccchannel_12_analyzer_1_array_crystal_array_8_visualize
#define target_index mccchannel_12_analyzer_1_array_crystal_array_8_target_index
#define target_x mccchannel_12_analyzer_1_array_crystal_array_8_target_x
#define target_y mccchannel_12_analyzer_1_array_crystal_array_8_target_y
#define target_z mccchannel_12_analyzer_1_array_crystal_array_8_target_z
#define focus_aw mccchannel_12_analyzer_1_array_crystal_array_8_focus_aw
#define focus_ah mccchannel_12_analyzer_1_array_crystal_array_8_focus_ah
#define focus_xw mccchannel_12_analyzer_1_array_crystal_array_8_focus_xw
#define focus_xh mccchannel_12_analyzer_1_array_crystal_array_8_focus_xh
#define focus_r mccchannel_12_analyzer_1_array_crystal_array_8_focus_r
#define p_interact mccchannel_12_analyzer_1_array_crystal_array_8_p_interact
#define mask_string mccchannel_12_analyzer_1_array_crystal_array_8_mask_string
#define mask_setting mccchannel_12_analyzer_1_array_crystal_array_8_mask_setting
#define number_of_activations mccchannel_12_analyzer_1_array_crystal_array_8_number_of_activations
#line 204 "Union_box.comp"
// Needed for transport to the main component
struct global_geometry_element_struct global_geometry_element;

#ifndef ANY_GEOMETRY_DETECTOR_DECLARE
    #define ANY_GEOMETRY_DETECTOR_DECLARE dummy
	//struct pointer_to_global_geometry_list global_geometry_list = {0,NULL};
#endif

int loop_index,found_geometries;

double x_component;
double y_component;
double z_component;

struct Volume_struct this_box_volume;
struct box_storage this_box_storage;

#line 65234 "MACS_sample_kidney_box.c"
#undef number_of_activations
#undef mask_setting
#undef mask_string
#undef p_interact
#undef focus_r
#undef focus_xh
#undef focus_xw
#undef focus_ah
#undef focus_aw
#undef target_z
#undef target_y
#undef target_x
#undef target_index
#undef visualize
#undef yheight2
#undef xwidth2
#undef zdepth
#undef yheight
#undef xwidth
#undef priority
#undef material_string
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

/* User declarations for component 'channel_12_analyzer_2_center' [595]. */
#define mccompcurname  channel_12_analyzer_2_center
#define mccompcurtype  Arm
#define mccompcurindex 595
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

/* User declarations for component 'channel_12_analyzer_2_rotated' [596]. */
#define mccompcurname  channel_12_analyzer_2_rotated
#define mccompcurtype  Arm
#define mccompcurindex 596
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

/* User declarations for component 'channel_12_analyzer_2_array_crystal_array_0' [597]. */
#define mccompcurname  channel_12_analyzer_2_array_crystal_array_0
#define mccompcurtype  Union_box
#define mccompcurindex 597
#define loop_index mccchannel_12_analyzer_2_array_crystal_array_0_loop_index
#define this_box_volume mccchannel_12_analyzer_2_array_crystal_array_0_this_box_volume
#define global_geometry_element mccchannel_12_analyzer_2_array_crystal_array_0_global_geometry_element
#define this_box_storage mccchannel_12_analyzer_2_array_crystal_array_0_this_box_storage
#define material_string mccchannel_12_analyzer_2_array_crystal_array_0_material_string
#define priority mccchannel_12_analyzer_2_array_crystal_array_0_priority
#define xwidth mccchannel_12_analyzer_2_array_crystal_array_0_xwidth
#define yheight mccchannel_12_analyzer_2_array_crystal_array_0_yheight
#define zdepth mccchannel_12_analyzer_2_array_crystal_array_0_zdepth
#define xwidth2 mccchannel_12_analyzer_2_array_crystal_array_0_xwidth2
#define yheight2 mccchannel_12_analyzer_2_array_crystal_array_0_yheight2
#define visualize mccchannel_12_analyzer_2_array_crystal_array_0_visualize
#define target_index mccchannel_12_analyzer_2_array_crystal_array_0_target_index
#define target_x mccchannel_12_analyzer_2_array_crystal_array_0_target_x
#define target_y mccchannel_12_analyzer_2_array_crystal_array_0_target_y
#define target_z mccchannel_12_analyzer_2_array_crystal_array_0_target_z
#define focus_aw mccchannel_12_analyzer_2_array_crystal_array_0_focus_aw
#define focus_ah mccchannel_12_analyzer_2_array_crystal_array_0_focus_ah
#define focus_xw mccchannel_12_analyzer_2_array_crystal_array_0_focus_xw
#define focus_xh mccchannel_12_analyzer_2_array_crystal_array_0_focus_xh
#define focus_r mccchannel_12_analyzer_2_array_crystal_array_0_focus_r
#define p_interact mccchannel_12_analyzer_2_array_crystal_array_0_p_interact
#define mask_string mccchannel_12_analyzer_2_array_crystal_array_0_mask_string
#define mask_setting mccchannel_12_analyzer_2_array_crystal_array_0_mask_setting
#define number_of_activations mccchannel_12_analyzer_2_array_crystal_array_0_number_of_activations
#line 204 "Union_box.comp"
// Needed for transport to the main component
struct global_geometry_element_struct global_geometry_element;

#ifndef ANY_GEOMETRY_DETECTOR_DECLARE
    #define ANY_GEOMETRY_DETECTOR_DECLARE dummy
	//struct pointer_to_global_geometry_list global_geometry_list = {0,NULL};
#endif

int loop_index,found_geometries;

double x_component;
double y_component;
double z_component;

struct Volume_struct this_box_volume;
struct box_storage this_box_storage;

#line 65327 "MACS_sample_kidney_box.c"
#undef number_of_activations
#undef mask_setting
#undef mask_string
#undef p_interact
#undef focus_r
#undef focus_xh
#undef focus_xw
#undef focus_ah
#undef focus_aw
#undef target_z
#undef target_y
#undef target_x
#undef target_index
#undef visualize
#undef yheight2
#undef xwidth2
#undef zdepth
#undef yheight
#undef xwidth
#undef priority
#undef material_string
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

/* User declarations for component 'channel_12_analyzer_2_array_crystal_array_1' [598]. */
#define mccompcurname  channel_12_analyzer_2_array_crystal_array_1
#define mccompcurtype  Union_box
#define mccompcurindex 598
#define loop_index mccchannel_12_analyzer_2_array_crystal_array_1_loop_index
#define this_box_volume mccchannel_12_analyzer_2_array_crystal_array_1_this_box_volume
#define global_geometry_element mccchannel_12_analyzer_2_array_crystal_array_1_global_geometry_element
#define this_box_storage mccchannel_12_analyzer_2_array_crystal_array_1_this_box_storage
#define material_string mccchannel_12_analyzer_2_array_crystal_array_1_material_string
#define priority mccchannel_12_analyzer_2_array_crystal_array_1_priority
#define xwidth mccchannel_12_analyzer_2_array_crystal_array_1_xwidth
#define yheight mccchannel_12_analyzer_2_array_crystal_array_1_yheight
#define zdepth mccchannel_12_analyzer_2_array_crystal_array_1_zdepth
#define xwidth2 mccchannel_12_analyzer_2_array_crystal_array_1_xwidth2
#define yheight2 mccchannel_12_analyzer_2_array_crystal_array_1_yheight2
#define visualize mccchannel_12_analyzer_2_array_crystal_array_1_visualize
#define target_index mccchannel_12_analyzer_2_array_crystal_array_1_target_index
#define target_x mccchannel_12_analyzer_2_array_crystal_array_1_target_x
#define target_y mccchannel_12_analyzer_2_array_crystal_array_1_target_y
#define target_z mccchannel_12_analyzer_2_array_crystal_array_1_target_z
#define focus_aw mccchannel_12_analyzer_2_array_crystal_array_1_focus_aw
#define focus_ah mccchannel_12_analyzer_2_array_crystal_array_1_focus_ah
#define focus_xw mccchannel_12_analyzer_2_array_crystal_array_1_focus_xw
#define focus_xh mccchannel_12_analyzer_2_array_crystal_array_1_focus_xh
#define focus_r mccchannel_12_analyzer_2_array_crystal_array_1_focus_r
#define p_interact mccchannel_12_analyzer_2_array_crystal_array_1_p_interact
#define mask_string mccchannel_12_analyzer_2_array_crystal_array_1_mask_string
#define mask_setting mccchannel_12_analyzer_2_array_crystal_array_1_mask_setting
#define number_of_activations mccchannel_12_analyzer_2_array_crystal_array_1_number_of_activations
#line 204 "Union_box.comp"
// Needed for transport to the main component
struct global_geometry_element_struct global_geometry_element;

#ifndef ANY_GEOMETRY_DETECTOR_DECLARE
    #define ANY_GEOMETRY_DETECTOR_DECLARE dummy
	//struct pointer_to_global_geometry_list global_geometry_list = {0,NULL};
#endif

int loop_index,found_geometries;

double x_component;
double y_component;
double z_component;

struct Volume_struct this_box_volume;
struct box_storage this_box_storage;

#line 65404 "MACS_sample_kidney_box.c"
#undef number_of_activations
#undef mask_setting
#undef mask_string
#undef p_interact
#undef focus_r
#undef focus_xh
#undef focus_xw
#undef focus_ah
#undef focus_aw
#undef target_z
#undef target_y
#undef target_x
#undef target_index
#undef visualize
#undef yheight2
#undef xwidth2
#undef zdepth
#undef yheight
#undef xwidth
#undef priority
#undef material_string
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

/* User declarations for component 'channel_12_analyzer_2_array_crystal_array_2' [599]. */
#define mccompcurname  channel_12_analyzer_2_array_crystal_array_2
#define mccompcurtype  Union_box
#define mccompcurindex 599
#define loop_index mccchannel_12_analyzer_2_array_crystal_array_2_loop_index
#define this_box_volume mccchannel_12_analyzer_2_array_crystal_array_2_this_box_volume
#define global_geometry_element mccchannel_12_analyzer_2_array_crystal_array_2_global_geometry_element
#define this_box_storage mccchannel_12_analyzer_2_array_crystal_array_2_this_box_storage
#define material_string mccchannel_12_analyzer_2_array_crystal_array_2_material_string
#define priority mccchannel_12_analyzer_2_array_crystal_array_2_priority
#define xwidth mccchannel_12_analyzer_2_array_crystal_array_2_xwidth
#define yheight mccchannel_12_analyzer_2_array_crystal_array_2_yheight
#define zdepth mccchannel_12_analyzer_2_array_crystal_array_2_zdepth
#define xwidth2 mccchannel_12_analyzer_2_array_crystal_array_2_xwidth2
#define yheight2 mccchannel_12_analyzer_2_array_crystal_array_2_yheight2
#define visualize mccchannel_12_analyzer_2_array_crystal_array_2_visualize
#define target_index mccchannel_12_analyzer_2_array_crystal_array_2_target_index
#define target_x mccchannel_12_analyzer_2_array_crystal_array_2_target_x
#define target_y mccchannel_12_analyzer_2_array_crystal_array_2_target_y
#define target_z mccchannel_12_analyzer_2_array_crystal_array_2_target_z
#define focus_aw mccchannel_12_analyzer_2_array_crystal_array_2_focus_aw
#define focus_ah mccchannel_12_analyzer_2_array_crystal_array_2_focus_ah
#define focus_xw mccchannel_12_analyzer_2_array_crystal_array_2_focus_xw
#define focus_xh mccchannel_12_analyzer_2_array_crystal_array_2_focus_xh
#define focus_r mccchannel_12_analyzer_2_array_crystal_array_2_focus_r
#define p_interact mccchannel_12_analyzer_2_array_crystal_array_2_p_interact
#define mask_string mccchannel_12_analyzer_2_array_crystal_array_2_mask_string
#define mask_setting mccchannel_12_analyzer_2_array_crystal_array_2_mask_setting
#define number_of_activations mccchannel_12_analyzer_2_array_crystal_array_2_number_of_activations
#line 204 "Union_box.comp"
// Needed for transport to the main component
struct global_geometry_element_struct global_geometry_element;

#ifndef ANY_GEOMETRY_DETECTOR_DECLARE
    #define ANY_GEOMETRY_DETECTOR_DECLARE dummy
	//struct pointer_to_global_geometry_list global_geometry_list = {0,NULL};
#endif

int loop_index,found_geometries;

double x_component;
double y_component;
double z_component;

struct Volume_struct this_box_volume;
struct box_storage this_box_storage;

#line 65481 "MACS_sample_kidney_box.c"
#undef number_of_activations
#undef mask_setting
#undef mask_string
#undef p_interact
#undef focus_r
#undef focus_xh
#undef focus_xw
#undef focus_ah
#undef focus_aw
#undef target_z
#undef target_y
#undef target_x
#undef target_index
#undef visualize
#undef yheight2
#undef xwidth2
#undef zdepth
#undef yheight
#undef xwidth
#undef priority
#undef material_string
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

/* User declarations for component 'channel_12_analyzer_2_array_crystal_array_3' [600]. */
#define mccompcurname  channel_12_analyzer_2_array_crystal_array_3
#define mccompcurtype  Union_box
#define mccompcurindex 600
#define loop_index mccchannel_12_analyzer_2_array_crystal_array_3_loop_index
#define this_box_volume mccchannel_12_analyzer_2_array_crystal_array_3_this_box_volume
#define global_geometry_element mccchannel_12_analyzer_2_array_crystal_array_3_global_geometry_element
#define this_box_storage mccchannel_12_analyzer_2_array_crystal_array_3_this_box_storage
#define material_string mccchannel_12_analyzer_2_array_crystal_array_3_material_string
#define priority mccchannel_12_analyzer_2_array_crystal_array_3_priority
#define xwidth mccchannel_12_analyzer_2_array_crystal_array_3_xwidth
#define yheight mccchannel_12_analyzer_2_array_crystal_array_3_yheight
#define zdepth mccchannel_12_analyzer_2_array_crystal_array_3_zdepth
#define xwidth2 mccchannel_12_analyzer_2_array_crystal_array_3_xwidth2
#define yheight2 mccchannel_12_analyzer_2_array_crystal_array_3_yheight2
#define visualize mccchannel_12_analyzer_2_array_crystal_array_3_visualize
#define target_index mccchannel_12_analyzer_2_array_crystal_array_3_target_index
#define target_x mccchannel_12_analyzer_2_array_crystal_array_3_target_x
#define target_y mccchannel_12_analyzer_2_array_crystal_array_3_target_y
#define target_z mccchannel_12_analyzer_2_array_crystal_array_3_target_z
#define focus_aw mccchannel_12_analyzer_2_array_crystal_array_3_focus_aw
#define focus_ah mccchannel_12_analyzer_2_array_crystal_array_3_focus_ah
#define focus_xw mccchannel_12_analyzer_2_array_crystal_array_3_focus_xw
#define focus_xh mccchannel_12_analyzer_2_array_crystal_array_3_focus_xh
#define focus_r mccchannel_12_analyzer_2_array_crystal_array_3_focus_r
#define p_interact mccchannel_12_analyzer_2_array_crystal_array_3_p_interact
#define mask_string mccchannel_12_analyzer_2_array_crystal_array_3_mask_string
#define mask_setting mccchannel_12_analyzer_2_array_crystal_array_3_mask_setting
#define number_of_activations mccchannel_12_analyzer_2_array_crystal_array_3_number_of_activations
#line 204 "Union_box.comp"
// Needed for transport to the main component
struct global_geometry_element_struct global_geometry_element;

#ifndef ANY_GEOMETRY_DETECTOR_DECLARE
    #define ANY_GEOMETRY_DETECTOR_DECLARE dummy
	//struct pointer_to_global_geometry_list global_geometry_list = {0,NULL};
#endif

int loop_index,found_geometries;

double x_component;
double y_component;
double z_component;

struct Volume_struct this_box_volume;
struct box_storage this_box_storage;

#line 65558 "MACS_sample_kidney_box.c"
#undef number_of_activations
#undef mask_setting
#undef mask_string
#undef p_interact
#undef focus_r
#undef focus_xh
#undef focus_xw
#undef focus_ah
#undef focus_aw
#undef target_z
#undef target_y
#undef target_x
#undef target_index
#undef visualize
#undef yheight2
#undef xwidth2
#undef zdepth
#undef yheight
#undef xwidth
#undef priority
#undef material_string
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

/* User declarations for component 'channel_12_analyzer_2_array_crystal_array_4' [601]. */
#define mccompcurname  channel_12_analyzer_2_array_crystal_array_4
#define mccompcurtype  Union_box
#define mccompcurindex 601
#define loop_index mccchannel_12_analyzer_2_array_crystal_array_4_loop_index
#define this_box_volume mccchannel_12_analyzer_2_array_crystal_array_4_this_box_volume
#define global_geometry_element mccchannel_12_analyzer_2_array_crystal_array_4_global_geometry_element
#define this_box_storage mccchannel_12_analyzer_2_array_crystal_array_4_this_box_storage
#define material_string mccchannel_12_analyzer_2_array_crystal_array_4_material_string
#define priority mccchannel_12_analyzer_2_array_crystal_array_4_priority
#define xwidth mccchannel_12_analyzer_2_array_crystal_array_4_xwidth
#define yheight mccchannel_12_analyzer_2_array_crystal_array_4_yheight
#define zdepth mccchannel_12_analyzer_2_array_crystal_array_4_zdepth
#define xwidth2 mccchannel_12_analyzer_2_array_crystal_array_4_xwidth2
#define yheight2 mccchannel_12_analyzer_2_array_crystal_array_4_yheight2
#define visualize mccchannel_12_analyzer_2_array_crystal_array_4_visualize
#define target_index mccchannel_12_analyzer_2_array_crystal_array_4_target_index
#define target_x mccchannel_12_analyzer_2_array_crystal_array_4_target_x
#define target_y mccchannel_12_analyzer_2_array_crystal_array_4_target_y
#define target_z mccchannel_12_analyzer_2_array_crystal_array_4_target_z
#define focus_aw mccchannel_12_analyzer_2_array_crystal_array_4_focus_aw
#define focus_ah mccchannel_12_analyzer_2_array_crystal_array_4_focus_ah
#define focus_xw mccchannel_12_analyzer_2_array_crystal_array_4_focus_xw
#define focus_xh mccchannel_12_analyzer_2_array_crystal_array_4_focus_xh
#define focus_r mccchannel_12_analyzer_2_array_crystal_array_4_focus_r
#define p_interact mccchannel_12_analyzer_2_array_crystal_array_4_p_interact
#define mask_string mccchannel_12_analyzer_2_array_crystal_array_4_mask_string
#define mask_setting mccchannel_12_analyzer_2_array_crystal_array_4_mask_setting
#define number_of_activations mccchannel_12_analyzer_2_array_crystal_array_4_number_of_activations
#line 204 "Union_box.comp"
// Needed for transport to the main component
struct global_geometry_element_struct global_geometry_element;

#ifndef ANY_GEOMETRY_DETECTOR_DECLARE
    #define ANY_GEOMETRY_DETECTOR_DECLARE dummy
	//struct pointer_to_global_geometry_list global_geometry_list = {0,NULL};
#endif

int loop_index,found_geometries;

double x_component;
double y_component;
double z_component;

struct Volume_struct this_box_volume;
struct box_storage this_box_storage;

#line 65635 "MACS_sample_kidney_box.c"
#undef number_of_activations
#undef mask_setting
#undef mask_string
#undef p_interact
#undef focus_r
#undef focus_xh
#undef focus_xw
#undef focus_ah
#undef focus_aw
#undef target_z
#undef target_y
#undef target_x
#undef target_index
#undef visualize
#undef yheight2
#undef xwidth2
#undef zdepth
#undef yheight
#undef xwidth
#undef priority
#undef material_string
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

/* User declarations for component 'channel_12_analyzer_2_array_crystal_array_5' [602]. */
#define mccompcurname  channel_12_analyzer_2_array_crystal_array_5
#define mccompcurtype  Union_box
#define mccompcurindex 602
#define loop_index mccchannel_12_analyzer_2_array_crystal_array_5_loop_index
#define this_box_volume mccchannel_12_analyzer_2_array_crystal_array_5_this_box_volume
#define global_geometry_element mccchannel_12_analyzer_2_array_crystal_array_5_global_geometry_element
#define this_box_storage mccchannel_12_analyzer_2_array_crystal_array_5_this_box_storage
#define material_string mccchannel_12_analyzer_2_array_crystal_array_5_material_string
#define priority mccchannel_12_analyzer_2_array_crystal_array_5_priority
#define xwidth mccchannel_12_analyzer_2_array_crystal_array_5_xwidth
#define yheight mccchannel_12_analyzer_2_array_crystal_array_5_yheight
#define zdepth mccchannel_12_analyzer_2_array_crystal_array_5_zdepth
#define xwidth2 mccchannel_12_analyzer_2_array_crystal_array_5_xwidth2
#define yheight2 mccchannel_12_analyzer_2_array_crystal_array_5_yheight2
#define visualize mccchannel_12_analyzer_2_array_crystal_array_5_visualize
#define target_index mccchannel_12_analyzer_2_array_crystal_array_5_target_index
#define target_x mccchannel_12_analyzer_2_array_crystal_array_5_target_x
#define target_y mccchannel_12_analyzer_2_array_crystal_array_5_target_y
#define target_z mccchannel_12_analyzer_2_array_crystal_array_5_target_z
#define focus_aw mccchannel_12_analyzer_2_array_crystal_array_5_focus_aw
#define focus_ah mccchannel_12_analyzer_2_array_crystal_array_5_focus_ah
#define focus_xw mccchannel_12_analyzer_2_array_crystal_array_5_focus_xw
#define focus_xh mccchannel_12_analyzer_2_array_crystal_array_5_focus_xh
#define focus_r mccchannel_12_analyzer_2_array_crystal_array_5_focus_r
#define p_interact mccchannel_12_analyzer_2_array_crystal_array_5_p_interact
#define mask_string mccchannel_12_analyzer_2_array_crystal_array_5_mask_string
#define mask_setting mccchannel_12_analyzer_2_array_crystal_array_5_mask_setting
#define number_of_activations mccchannel_12_analyzer_2_array_crystal_array_5_number_of_activations
#line 204 "Union_box.comp"
// Needed for transport to the main component
struct global_geometry_element_struct global_geometry_element;

#ifndef ANY_GEOMETRY_DETECTOR_DECLARE
    #define ANY_GEOMETRY_DETECTOR_DECLARE dummy
	//struct pointer_to_global_geometry_list global_geometry_list = {0,NULL};
#endif

int loop_index,found_geometries;

double x_component;
double y_component;
double z_component;

struct Volume_struct this_box_volume;
struct box_storage this_box_storage;

#line 65712 "MACS_sample_kidney_box.c"
#undef number_of_activations
#undef mask_setting
#undef mask_string
#undef p_interact
#undef focus_r
#undef focus_xh
#undef focus_xw
#undef focus_ah
#undef focus_aw
#undef target_z
#undef target_y
#undef target_x
#undef target_index
#undef visualize
#undef yheight2
#undef xwidth2
#undef zdepth
#undef yheight
#undef xwidth
#undef priority
#undef material_string
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

/* User declarations for component 'channel_12_analyzer_2_array_crystal_array_6' [603]. */
#define mccompcurname  channel_12_analyzer_2_array_crystal_array_6
#define mccompcurtype  Union_box
#define mccompcurindex 603
#define loop_index mccchannel_12_analyzer_2_array_crystal_array_6_loop_index
#define this_box_volume mccchannel_12_analyzer_2_array_crystal_array_6_this_box_volume
#define global_geometry_element mccchannel_12_analyzer_2_array_crystal_array_6_global_geometry_element
#define this_box_storage mccchannel_12_analyzer_2_array_crystal_array_6_this_box_storage
#define material_string mccchannel_12_analyzer_2_array_crystal_array_6_material_string
#define priority mccchannel_12_analyzer_2_array_crystal_array_6_priority
#define xwidth mccchannel_12_analyzer_2_array_crystal_array_6_xwidth
#define yheight mccchannel_12_analyzer_2_array_crystal_array_6_yheight
#define zdepth mccchannel_12_analyzer_2_array_crystal_array_6_zdepth
#define xwidth2 mccchannel_12_analyzer_2_array_crystal_array_6_xwidth2
#define yheight2 mccchannel_12_analyzer_2_array_crystal_array_6_yheight2
#define visualize mccchannel_12_analyzer_2_array_crystal_array_6_visualize
#define target_index mccchannel_12_analyzer_2_array_crystal_array_6_target_index
#define target_x mccchannel_12_analyzer_2_array_crystal_array_6_target_x
#define target_y mccchannel_12_analyzer_2_array_crystal_array_6_target_y
#define target_z mccchannel_12_analyzer_2_array_crystal_array_6_target_z
#define focus_aw mccchannel_12_analyzer_2_array_crystal_array_6_focus_aw
#define focus_ah mccchannel_12_analyzer_2_array_crystal_array_6_focus_ah
#define focus_xw mccchannel_12_analyzer_2_array_crystal_array_6_focus_xw
#define focus_xh mccchannel_12_analyzer_2_array_crystal_array_6_focus_xh
#define focus_r mccchannel_12_analyzer_2_array_crystal_array_6_focus_r
#define p_interact mccchannel_12_analyzer_2_array_crystal_array_6_p_interact
#define mask_string mccchannel_12_analyzer_2_array_crystal_array_6_mask_string
#define mask_setting mccchannel_12_analyzer_2_array_crystal_array_6_mask_setting
#define number_of_activations mccchannel_12_analyzer_2_array_crystal_array_6_number_of_activations
#line 204 "Union_box.comp"
// Needed for transport to the main component
struct global_geometry_element_struct global_geometry_element;

#ifndef ANY_GEOMETRY_DETECTOR_DECLARE
    #define ANY_GEOMETRY_DETECTOR_DECLARE dummy
	//struct pointer_to_global_geometry_list global_geometry_list = {0,NULL};
#endif

int loop_index,found_geometries;

double x_component;
double y_component;
double z_component;

struct Volume_struct this_box_volume;
struct box_storage this_box_storage;

#line 65789 "MACS_sample_kidney_box.c"
#undef number_of_activations
#undef mask_setting
#undef mask_string
#undef p_interact
#undef focus_r
#undef focus_xh
#undef focus_xw
#undef focus_ah
#undef focus_aw
#undef target_z
#undef target_y
#undef target_x
#undef target_index
#undef visualize
#undef yheight2
#undef xwidth2
#undef zdepth
#undef yheight
#undef xwidth
#undef priority
#undef material_string
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

/* User declarations for component 'channel_12_analyzer_2_array_crystal_array_7' [604]. */
#define mccompcurname  channel_12_analyzer_2_array_crystal_array_7
#define mccompcurtype  Union_box
#define mccompcurindex 604
#define loop_index mccchannel_12_analyzer_2_array_crystal_array_7_loop_index
#define this_box_volume mccchannel_12_analyzer_2_array_crystal_array_7_this_box_volume
#define global_geometry_element mccchannel_12_analyzer_2_array_crystal_array_7_global_geometry_element
#define this_box_storage mccchannel_12_analyzer_2_array_crystal_array_7_this_box_storage
#define material_string mccchannel_12_analyzer_2_array_crystal_array_7_material_string
#define priority mccchannel_12_analyzer_2_array_crystal_array_7_priority
#define xwidth mccchannel_12_analyzer_2_array_crystal_array_7_xwidth
#define yheight mccchannel_12_analyzer_2_array_crystal_array_7_yheight
#define zdepth mccchannel_12_analyzer_2_array_crystal_array_7_zdepth
#define xwidth2 mccchannel_12_analyzer_2_array_crystal_array_7_xwidth2
#define yheight2 mccchannel_12_analyzer_2_array_crystal_array_7_yheight2
#define visualize mccchannel_12_analyzer_2_array_crystal_array_7_visualize
#define target_index mccchannel_12_analyzer_2_array_crystal_array_7_target_index
#define target_x mccchannel_12_analyzer_2_array_crystal_array_7_target_x
#define target_y mccchannel_12_analyzer_2_array_crystal_array_7_target_y
#define target_z mccchannel_12_analyzer_2_array_crystal_array_7_target_z
#define focus_aw mccchannel_12_analyzer_2_array_crystal_array_7_focus_aw
#define focus_ah mccchannel_12_analyzer_2_array_crystal_array_7_focus_ah
#define focus_xw mccchannel_12_analyzer_2_array_crystal_array_7_focus_xw
#define focus_xh mccchannel_12_analyzer_2_array_crystal_array_7_focus_xh
#define focus_r mccchannel_12_analyzer_2_array_crystal_array_7_focus_r
#define p_interact mccchannel_12_analyzer_2_array_crystal_array_7_p_interact
#define mask_string mccchannel_12_analyzer_2_array_crystal_array_7_mask_string
#define mask_setting mccchannel_12_analyzer_2_array_crystal_array_7_mask_setting
#define number_of_activations mccchannel_12_analyzer_2_array_crystal_array_7_number_of_activations
#line 204 "Union_box.comp"
// Needed for transport to the main component
struct global_geometry_element_struct global_geometry_element;

#ifndef ANY_GEOMETRY_DETECTOR_DECLARE
    #define ANY_GEOMETRY_DETECTOR_DECLARE dummy
	//struct pointer_to_global_geometry_list global_geometry_list = {0,NULL};
#endif

int loop_index,found_geometries;

double x_component;
double y_component;
double z_component;

struct Volume_struct this_box_volume;
struct box_storage this_box_storage;

#line 65866 "MACS_sample_kidney_box.c"
#undef number_of_activations
#undef mask_setting
#undef mask_string
#undef p_interact
#undef focus_r
#undef focus_xh
#undef focus_xw
#undef focus_ah
#undef focus_aw
#undef target_z
#undef target_y
#undef target_x
#undef target_index
#undef visualize
#undef yheight2
#undef xwidth2
#undef zdepth
#undef yheight
#undef xwidth
#undef priority
#undef material_string
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

/* User declarations for component 'channel_12_analyzer_2_array_crystal_array_8' [605]. */
#define mccompcurname  channel_12_analyzer_2_array_crystal_array_8
#define mccompcurtype  Union_box
#define mccompcurindex 605
#define loop_index mccchannel_12_analyzer_2_array_crystal_array_8_loop_index
#define this_box_volume mccchannel_12_analyzer_2_array_crystal_array_8_this_box_volume
#define global_geometry_element mccchannel_12_analyzer_2_array_crystal_array_8_global_geometry_element
#define this_box_storage mccchannel_12_analyzer_2_array_crystal_array_8_this_box_storage
#define material_string mccchannel_12_analyzer_2_array_crystal_array_8_material_string
#define priority mccchannel_12_analyzer_2_array_crystal_array_8_priority
#define xwidth mccchannel_12_analyzer_2_array_crystal_array_8_xwidth
#define yheight mccchannel_12_analyzer_2_array_crystal_array_8_yheight
#define zdepth mccchannel_12_analyzer_2_array_crystal_array_8_zdepth
#define xwidth2 mccchannel_12_analyzer_2_array_crystal_array_8_xwidth2
#define yheight2 mccchannel_12_analyzer_2_array_crystal_array_8_yheight2
#define visualize mccchannel_12_analyzer_2_array_crystal_array_8_visualize
#define target_index mccchannel_12_analyzer_2_array_crystal_array_8_target_index
#define target_x mccchannel_12_analyzer_2_array_crystal_array_8_target_x
#define target_y mccchannel_12_analyzer_2_array_crystal_array_8_target_y
#define target_z mccchannel_12_analyzer_2_array_crystal_array_8_target_z
#define focus_aw mccchannel_12_analyzer_2_array_crystal_array_8_focus_aw
#define focus_ah mccchannel_12_analyzer_2_array_crystal_array_8_focus_ah
#define focus_xw mccchannel_12_analyzer_2_array_crystal_array_8_focus_xw
#define focus_xh mccchannel_12_analyzer_2_array_crystal_array_8_focus_xh
#define focus_r mccchannel_12_analyzer_2_array_crystal_array_8_focus_r
#define p_interact mccchannel_12_analyzer_2_array_crystal_array_8_p_interact
#define mask_string mccchannel_12_analyzer_2_array_crystal_array_8_mask_string
#define mask_setting mccchannel_12_analyzer_2_array_crystal_array_8_mask_setting
#define number_of_activations mccchannel_12_analyzer_2_array_crystal_array_8_number_of_activations
#line 204 "Union_box.comp"
// Needed for transport to the main component
struct global_geometry_element_struct global_geometry_element;

#ifndef ANY_GEOMETRY_DETECTOR_DECLARE
    #define ANY_GEOMETRY_DETECTOR_DECLARE dummy
	//struct pointer_to_global_geometry_list global_geometry_list = {0,NULL};
#endif

int loop_index,found_geometries;

double x_component;
double y_component;
double z_component;

struct Volume_struct this_box_volume;
struct box_storage this_box_storage;

#line 65943 "MACS_sample_kidney_box.c"
#undef number_of_activations
#undef mask_setting
#undef mask_string
#undef p_interact
#undef focus_r
#undef focus_xh
#undef focus_xw
#undef focus_ah
#undef focus_aw
#undef target_z
#undef target_y
#undef target_x
#undef target_index
#undef visualize
#undef yheight2
#undef xwidth2
#undef zdepth
#undef yheight
#undef xwidth
#undef priority
#undef material_string
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

/* User declarations for component 'channel_12_cave2_cyl1' [606]. */
#define mccompcurname  channel_12_cave2_cyl1
#define mccompcurtype  Union_cylinder
#define mccompcurindex 606
#define loop_index mccchannel_12_cave2_cyl1_loop_index
#define this_cylinder_volume mccchannel_12_cave2_cyl1_this_cylinder_volume
#define global_geometry_element mccchannel_12_cave2_cyl1_global_geometry_element
#define this_cylinder_storage mccchannel_12_cave2_cyl1_this_cylinder_storage
#define material_string mccchannel_12_cave2_cyl1_material_string
#define priority mccchannel_12_cave2_cyl1_priority
#define radius mccchannel_12_cave2_cyl1_radius
#define yheight mccchannel_12_cave2_cyl1_yheight
#define visualize mccchannel_12_cave2_cyl1_visualize
#define target_index mccchannel_12_cave2_cyl1_target_index
#define target_x mccchannel_12_cave2_cyl1_target_x
#define target_y mccchannel_12_cave2_cyl1_target_y
#define target_z mccchannel_12_cave2_cyl1_target_z
#define focus_aw mccchannel_12_cave2_cyl1_focus_aw
#define focus_ah mccchannel_12_cave2_cyl1_focus_ah
#define focus_xw mccchannel_12_cave2_cyl1_focus_xw
#define focus_xh mccchannel_12_cave2_cyl1_focus_xh
#define focus_r mccchannel_12_cave2_cyl1_focus_r
#define p_interact mccchannel_12_cave2_cyl1_p_interact
#define mask_string mccchannel_12_cave2_cyl1_mask_string
#define mask_setting mccchannel_12_cave2_cyl1_mask_setting
#define number_of_activations mccchannel_12_cave2_cyl1_number_of_activations
#line 167 "Union_cylinder.comp"
// Needed for transport to the main component
struct global_geometry_element_struct global_geometry_element;

#ifndef ANY_GEOMETRY_DETECTOR_DECLARE
    #define ANY_GEOMETRY_DETECTOR_DECLARE dummy
	//struct pointer_to_global_geometry_list global_geometry_list = {0,NULL};
#endif

int dummy;
int loop_index,found_geometries;
int loop_2_index;
int material_index;

struct Volume_struct this_cylinder_volume;
struct cylinder_storage this_cylinder_storage;
#line 66015 "MACS_sample_kidney_box.c"
#undef number_of_activations
#undef mask_setting
#undef mask_string
#undef p_interact
#undef focus_r
#undef focus_xh
#undef focus_xw
#undef focus_ah
#undef focus_aw
#undef target_z
#undef target_y
#undef target_x
#undef target_index
#undef visualize
#undef yheight
#undef radius
#undef priority
#undef material_string
#undef this_cylinder_storage
#undef global_geometry_element
#undef this_cylinder_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

/* User declarations for component 'channel_12_cave2_box1' [607]. */
#define mccompcurname  channel_12_cave2_box1
#define mccompcurtype  Union_box
#define mccompcurindex 607
#define loop_index mccchannel_12_cave2_box1_loop_index
#define this_box_volume mccchannel_12_cave2_box1_this_box_volume
#define global_geometry_element mccchannel_12_cave2_box1_global_geometry_element
#define this_box_storage mccchannel_12_cave2_box1_this_box_storage
#define material_string mccchannel_12_cave2_box1_material_string
#define priority mccchannel_12_cave2_box1_priority
#define xwidth mccchannel_12_cave2_box1_xwidth
#define yheight mccchannel_12_cave2_box1_yheight
#define zdepth mccchannel_12_cave2_box1_zdepth
#define xwidth2 mccchannel_12_cave2_box1_xwidth2
#define yheight2 mccchannel_12_cave2_box1_yheight2
#define visualize mccchannel_12_cave2_box1_visualize
#define target_index mccchannel_12_cave2_box1_target_index
#define target_x mccchannel_12_cave2_box1_target_x
#define target_y mccchannel_12_cave2_box1_target_y
#define target_z mccchannel_12_cave2_box1_target_z
#define focus_aw mccchannel_12_cave2_box1_focus_aw
#define focus_ah mccchannel_12_cave2_box1_focus_ah
#define focus_xw mccchannel_12_cave2_box1_focus_xw
#define focus_xh mccchannel_12_cave2_box1_focus_xh
#define focus_r mccchannel_12_cave2_box1_focus_r
#define p_interact mccchannel_12_cave2_box1_p_interact
#define mask_string mccchannel_12_cave2_box1_mask_string
#define mask_setting mccchannel_12_cave2_box1_mask_setting
#define number_of_activations mccchannel_12_cave2_box1_number_of_activations
#line 204 "Union_box.comp"
// Needed for transport to the main component
struct global_geometry_element_struct global_geometry_element;

#ifndef ANY_GEOMETRY_DETECTOR_DECLARE
    #define ANY_GEOMETRY_DETECTOR_DECLARE dummy
	//struct pointer_to_global_geometry_list global_geometry_list = {0,NULL};
#endif

int loop_index,found_geometries;

double x_component;
double y_component;
double z_component;

struct Volume_struct this_box_volume;
struct box_storage this_box_storage;

#line 66089 "MACS_sample_kidney_box.c"
#undef number_of_activations
#undef mask_setting
#undef mask_string
#undef p_interact
#undef focus_r
#undef focus_xh
#undef focus_xw
#undef focus_ah
#undef focus_aw
#undef target_z
#undef target_y
#undef target_x
#undef target_index
#undef visualize
#undef yheight2
#undef xwidth2
#undef zdepth
#undef yheight
#undef xwidth
#undef priority
#undef material_string
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

/* User declarations for component 'channel_12_cave2_box2' [608]. */
#define mccompcurname  channel_12_cave2_box2
#define mccompcurtype  Union_box
#define mccompcurindex 608
#define loop_index mccchannel_12_cave2_box2_loop_index
#define this_box_volume mccchannel_12_cave2_box2_this_box_volume
#define global_geometry_element mccchannel_12_cave2_box2_global_geometry_element
#define this_box_storage mccchannel_12_cave2_box2_this_box_storage
#define material_string mccchannel_12_cave2_box2_material_string
#define priority mccchannel_12_cave2_box2_priority
#define xwidth mccchannel_12_cave2_box2_xwidth
#define yheight mccchannel_12_cave2_box2_yheight
#define zdepth mccchannel_12_cave2_box2_zdepth
#define xwidth2 mccchannel_12_cave2_box2_xwidth2
#define yheight2 mccchannel_12_cave2_box2_yheight2
#define visualize mccchannel_12_cave2_box2_visualize
#define target_index mccchannel_12_cave2_box2_target_index
#define target_x mccchannel_12_cave2_box2_target_x
#define target_y mccchannel_12_cave2_box2_target_y
#define target_z mccchannel_12_cave2_box2_target_z
#define focus_aw mccchannel_12_cave2_box2_focus_aw
#define focus_ah mccchannel_12_cave2_box2_focus_ah
#define focus_xw mccchannel_12_cave2_box2_focus_xw
#define focus_xh mccchannel_12_cave2_box2_focus_xh
#define focus_r mccchannel_12_cave2_box2_focus_r
#define p_interact mccchannel_12_cave2_box2_p_interact
#define mask_string mccchannel_12_cave2_box2_mask_string
#define mask_setting mccchannel_12_cave2_box2_mask_setting
#define number_of_activations mccchannel_12_cave2_box2_number_of_activations
#line 204 "Union_box.comp"
// Needed for transport to the main component
struct global_geometry_element_struct global_geometry_element;

#ifndef ANY_GEOMETRY_DETECTOR_DECLARE
    #define ANY_GEOMETRY_DETECTOR_DECLARE dummy
	//struct pointer_to_global_geometry_list global_geometry_list = {0,NULL};
#endif

int loop_index,found_geometries;

double x_component;
double y_component;
double z_component;

struct Volume_struct this_box_volume;
struct box_storage this_box_storage;

#line 66166 "MACS_sample_kidney_box.c"
#undef number_of_activations
#undef mask_setting
#undef mask_string
#undef p_interact
#undef focus_r
#undef focus_xh
#undef focus_xw
#undef focus_ah
#undef focus_aw
#undef target_z
#undef target_y
#undef target_x
#undef target_index
#undef visualize
#undef yheight2
#undef xwidth2
#undef zdepth
#undef yheight
#undef xwidth
#undef priority
#undef material_string
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

/* User declarations for component 'channel_12_cave2_box3' [609]. */
#define mccompcurname  channel_12_cave2_box3
#define mccompcurtype  Union_box
#define mccompcurindex 609
#define loop_index mccchannel_12_cave2_box3_loop_index
#define this_box_volume mccchannel_12_cave2_box3_this_box_volume
#define global_geometry_element mccchannel_12_cave2_box3_global_geometry_element
#define this_box_storage mccchannel_12_cave2_box3_this_box_storage
#define material_string mccchannel_12_cave2_box3_material_string
#define priority mccchannel_12_cave2_box3_priority
#define xwidth mccchannel_12_cave2_box3_xwidth
#define yheight mccchannel_12_cave2_box3_yheight
#define zdepth mccchannel_12_cave2_box3_zdepth
#define xwidth2 mccchannel_12_cave2_box3_xwidth2
#define yheight2 mccchannel_12_cave2_box3_yheight2
#define visualize mccchannel_12_cave2_box3_visualize
#define target_index mccchannel_12_cave2_box3_target_index
#define target_x mccchannel_12_cave2_box3_target_x
#define target_y mccchannel_12_cave2_box3_target_y
#define target_z mccchannel_12_cave2_box3_target_z
#define focus_aw mccchannel_12_cave2_box3_focus_aw
#define focus_ah mccchannel_12_cave2_box3_focus_ah
#define focus_xw mccchannel_12_cave2_box3_focus_xw
#define focus_xh mccchannel_12_cave2_box3_focus_xh
#define focus_r mccchannel_12_cave2_box3_focus_r
#define p_interact mccchannel_12_cave2_box3_p_interact
#define mask_string mccchannel_12_cave2_box3_mask_string
#define mask_setting mccchannel_12_cave2_box3_mask_setting
#define number_of_activations mccchannel_12_cave2_box3_number_of_activations
#line 204 "Union_box.comp"
// Needed for transport to the main component
struct global_geometry_element_struct global_geometry_element;

#ifndef ANY_GEOMETRY_DETECTOR_DECLARE
    #define ANY_GEOMETRY_DETECTOR_DECLARE dummy
	//struct pointer_to_global_geometry_list global_geometry_list = {0,NULL};
#endif

int loop_index,found_geometries;

double x_component;
double y_component;
double z_component;

struct Volume_struct this_box_volume;
struct box_storage this_box_storage;

#line 66243 "MACS_sample_kidney_box.c"
#undef number_of_activations
#undef mask_setting
#undef mask_string
#undef p_interact
#undef focus_r
#undef focus_xh
#undef focus_xw
#undef focus_ah
#undef focus_aw
#undef target_z
#undef target_y
#undef target_x
#undef target_index
#undef visualize
#undef yheight2
#undef xwidth2
#undef zdepth
#undef yheight
#undef xwidth
#undef priority
#undef material_string
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

/* User declarations for component 'inter_analyzer_colimator_center_12' [610]. */
#define mccompcurname  inter_analyzer_colimator_center_12
#define mccompcurtype  Arm
#define mccompcurindex 610
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

/* User declarations for component 'inter_analyzer_colimator_12_blade_0' [611]. */
#define mccompcurname  inter_analyzer_colimator_12_blade_0
#define mccompcurtype  Union_box
#define mccompcurindex 611
#define loop_index mccinter_analyzer_colimator_12_blade_0_loop_index
#define this_box_volume mccinter_analyzer_colimator_12_blade_0_this_box_volume
#define global_geometry_element mccinter_analyzer_colimator_12_blade_0_global_geometry_element
#define this_box_storage mccinter_analyzer_colimator_12_blade_0_this_box_storage
#define material_string mccinter_analyzer_colimator_12_blade_0_material_string
#define priority mccinter_analyzer_colimator_12_blade_0_priority
#define xwidth mccinter_analyzer_colimator_12_blade_0_xwidth
#define yheight mccinter_analyzer_colimator_12_blade_0_yheight
#define zdepth mccinter_analyzer_colimator_12_blade_0_zdepth
#define xwidth2 mccinter_analyzer_colimator_12_blade_0_xwidth2
#define yheight2 mccinter_analyzer_colimator_12_blade_0_yheight2
#define visualize mccinter_analyzer_colimator_12_blade_0_visualize
#define target_index mccinter_analyzer_colimator_12_blade_0_target_index
#define target_x mccinter_analyzer_colimator_12_blade_0_target_x
#define target_y mccinter_analyzer_colimator_12_blade_0_target_y
#define target_z mccinter_analyzer_colimator_12_blade_0_target_z
#define focus_aw mccinter_analyzer_colimator_12_blade_0_focus_aw
#define focus_ah mccinter_analyzer_colimator_12_blade_0_focus_ah
#define focus_xw mccinter_analyzer_colimator_12_blade_0_focus_xw
#define focus_xh mccinter_analyzer_colimator_12_blade_0_focus_xh
#define focus_r mccinter_analyzer_colimator_12_blade_0_focus_r
#define p_interact mccinter_analyzer_colimator_12_blade_0_p_interact
#define mask_string mccinter_analyzer_colimator_12_blade_0_mask_string
#define mask_setting mccinter_analyzer_colimator_12_blade_0_mask_setting
#define number_of_activations mccinter_analyzer_colimator_12_blade_0_number_of_activations
#line 204 "Union_box.comp"
// Needed for transport to the main component
struct global_geometry_element_struct global_geometry_element;

#ifndef ANY_GEOMETRY_DETECTOR_DECLARE
    #define ANY_GEOMETRY_DETECTOR_DECLARE dummy
	//struct pointer_to_global_geometry_list global_geometry_list = {0,NULL};
#endif

int loop_index,found_geometries;

double x_component;
double y_component;
double z_component;

struct Volume_struct this_box_volume;
struct box_storage this_box_storage;

#line 66328 "MACS_sample_kidney_box.c"
#undef number_of_activations
#undef mask_setting
#undef mask_string
#undef p_interact
#undef focus_r
#undef focus_xh
#undef focus_xw
#undef focus_ah
#undef focus_aw
#undef target_z
#undef target_y
#undef target_x
#undef target_index
#undef visualize
#undef yheight2
#undef xwidth2
#undef zdepth
#undef yheight
#undef xwidth
#undef priority
#undef material_string
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

/* User declarations for component 'inter_analyzer_colimator_12_blade_1' [612]. */
#define mccompcurname  inter_analyzer_colimator_12_blade_1
#define mccompcurtype  Union_box
#define mccompcurindex 612
#define loop_index mccinter_analyzer_colimator_12_blade_1_loop_index
#define this_box_volume mccinter_analyzer_colimator_12_blade_1_this_box_volume
#define global_geometry_element mccinter_analyzer_colimator_12_blade_1_global_geometry_element
#define this_box_storage mccinter_analyzer_colimator_12_blade_1_this_box_storage
#define material_string mccinter_analyzer_colimator_12_blade_1_material_string
#define priority mccinter_analyzer_colimator_12_blade_1_priority
#define xwidth mccinter_analyzer_colimator_12_blade_1_xwidth
#define yheight mccinter_analyzer_colimator_12_blade_1_yheight
#define zdepth mccinter_analyzer_colimator_12_blade_1_zdepth
#define xwidth2 mccinter_analyzer_colimator_12_blade_1_xwidth2
#define yheight2 mccinter_analyzer_colimator_12_blade_1_yheight2
#define visualize mccinter_analyzer_colimator_12_blade_1_visualize
#define target_index mccinter_analyzer_colimator_12_blade_1_target_index
#define target_x mccinter_analyzer_colimator_12_blade_1_target_x
#define target_y mccinter_analyzer_colimator_12_blade_1_target_y
#define target_z mccinter_analyzer_colimator_12_blade_1_target_z
#define focus_aw mccinter_analyzer_colimator_12_blade_1_focus_aw
#define focus_ah mccinter_analyzer_colimator_12_blade_1_focus_ah
#define focus_xw mccinter_analyzer_colimator_12_blade_1_focus_xw
#define focus_xh mccinter_analyzer_colimator_12_blade_1_focus_xh
#define focus_r mccinter_analyzer_colimator_12_blade_1_focus_r
#define p_interact mccinter_analyzer_colimator_12_blade_1_p_interact
#define mask_string mccinter_analyzer_colimator_12_blade_1_mask_string
#define mask_setting mccinter_analyzer_colimator_12_blade_1_mask_setting
#define number_of_activations mccinter_analyzer_colimator_12_blade_1_number_of_activations
#line 204 "Union_box.comp"
// Needed for transport to the main component
struct global_geometry_element_struct global_geometry_element;

#ifndef ANY_GEOMETRY_DETECTOR_DECLARE
    #define ANY_GEOMETRY_DETECTOR_DECLARE dummy
	//struct pointer_to_global_geometry_list global_geometry_list = {0,NULL};
#endif

int loop_index,found_geometries;

double x_component;
double y_component;
double z_component;

struct Volume_struct this_box_volume;
struct box_storage this_box_storage;

#line 66405 "MACS_sample_kidney_box.c"
#undef number_of_activations
#undef mask_setting
#undef mask_string
#undef p_interact
#undef focus_r
#undef focus_xh
#undef focus_xw
#undef focus_ah
#undef focus_aw
#undef target_z
#undef target_y
#undef target_x
#undef target_index
#undef visualize
#undef yheight2
#undef xwidth2
#undef zdepth
#undef yheight
#undef xwidth
#undef priority
#undef material_string
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

/* User declarations for component 'inter_analyzer_colimator_12_blade_2' [613]. */
#define mccompcurname  inter_analyzer_colimator_12_blade_2
#define mccompcurtype  Union_box
#define mccompcurindex 613
#define loop_index mccinter_analyzer_colimator_12_blade_2_loop_index
#define this_box_volume mccinter_analyzer_colimator_12_blade_2_this_box_volume
#define global_geometry_element mccinter_analyzer_colimator_12_blade_2_global_geometry_element
#define this_box_storage mccinter_analyzer_colimator_12_blade_2_this_box_storage
#define material_string mccinter_analyzer_colimator_12_blade_2_material_string
#define priority mccinter_analyzer_colimator_12_blade_2_priority
#define xwidth mccinter_analyzer_colimator_12_blade_2_xwidth
#define yheight mccinter_analyzer_colimator_12_blade_2_yheight
#define zdepth mccinter_analyzer_colimator_12_blade_2_zdepth
#define xwidth2 mccinter_analyzer_colimator_12_blade_2_xwidth2
#define yheight2 mccinter_analyzer_colimator_12_blade_2_yheight2
#define visualize mccinter_analyzer_colimator_12_blade_2_visualize
#define target_index mccinter_analyzer_colimator_12_blade_2_target_index
#define target_x mccinter_analyzer_colimator_12_blade_2_target_x
#define target_y mccinter_analyzer_colimator_12_blade_2_target_y
#define target_z mccinter_analyzer_colimator_12_blade_2_target_z
#define focus_aw mccinter_analyzer_colimator_12_blade_2_focus_aw
#define focus_ah mccinter_analyzer_colimator_12_blade_2_focus_ah
#define focus_xw mccinter_analyzer_colimator_12_blade_2_focus_xw
#define focus_xh mccinter_analyzer_colimator_12_blade_2_focus_xh
#define focus_r mccinter_analyzer_colimator_12_blade_2_focus_r
#define p_interact mccinter_analyzer_colimator_12_blade_2_p_interact
#define mask_string mccinter_analyzer_colimator_12_blade_2_mask_string
#define mask_setting mccinter_analyzer_colimator_12_blade_2_mask_setting
#define number_of_activations mccinter_analyzer_colimator_12_blade_2_number_of_activations
#line 204 "Union_box.comp"
// Needed for transport to the main component
struct global_geometry_element_struct global_geometry_element;

#ifndef ANY_GEOMETRY_DETECTOR_DECLARE
    #define ANY_GEOMETRY_DETECTOR_DECLARE dummy
	//struct pointer_to_global_geometry_list global_geometry_list = {0,NULL};
#endif

int loop_index,found_geometries;

double x_component;
double y_component;
double z_component;

struct Volume_struct this_box_volume;
struct box_storage this_box_storage;

#line 66482 "MACS_sample_kidney_box.c"
#undef number_of_activations
#undef mask_setting
#undef mask_string
#undef p_interact
#undef focus_r
#undef focus_xh
#undef focus_xw
#undef focus_ah
#undef focus_aw
#undef target_z
#undef target_y
#undef target_x
#undef target_index
#undef visualize
#undef yheight2
#undef xwidth2
#undef zdepth
#undef yheight
#undef xwidth
#undef priority
#undef material_string
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

/* User declarations for component 'inter_analyzer_colimator_12_blade_3' [614]. */
#define mccompcurname  inter_analyzer_colimator_12_blade_3
#define mccompcurtype  Union_box
#define mccompcurindex 614
#define loop_index mccinter_analyzer_colimator_12_blade_3_loop_index
#define this_box_volume mccinter_analyzer_colimator_12_blade_3_this_box_volume
#define global_geometry_element mccinter_analyzer_colimator_12_blade_3_global_geometry_element
#define this_box_storage mccinter_analyzer_colimator_12_blade_3_this_box_storage
#define material_string mccinter_analyzer_colimator_12_blade_3_material_string
#define priority mccinter_analyzer_colimator_12_blade_3_priority
#define xwidth mccinter_analyzer_colimator_12_blade_3_xwidth
#define yheight mccinter_analyzer_colimator_12_blade_3_yheight
#define zdepth mccinter_analyzer_colimator_12_blade_3_zdepth
#define xwidth2 mccinter_analyzer_colimator_12_blade_3_xwidth2
#define yheight2 mccinter_analyzer_colimator_12_blade_3_yheight2
#define visualize mccinter_analyzer_colimator_12_blade_3_visualize
#define target_index mccinter_analyzer_colimator_12_blade_3_target_index
#define target_x mccinter_analyzer_colimator_12_blade_3_target_x
#define target_y mccinter_analyzer_colimator_12_blade_3_target_y
#define target_z mccinter_analyzer_colimator_12_blade_3_target_z
#define focus_aw mccinter_analyzer_colimator_12_blade_3_focus_aw
#define focus_ah mccinter_analyzer_colimator_12_blade_3_focus_ah
#define focus_xw mccinter_analyzer_colimator_12_blade_3_focus_xw
#define focus_xh mccinter_analyzer_colimator_12_blade_3_focus_xh
#define focus_r mccinter_analyzer_colimator_12_blade_3_focus_r
#define p_interact mccinter_analyzer_colimator_12_blade_3_p_interact
#define mask_string mccinter_analyzer_colimator_12_blade_3_mask_string
#define mask_setting mccinter_analyzer_colimator_12_blade_3_mask_setting
#define number_of_activations mccinter_analyzer_colimator_12_blade_3_number_of_activations
#line 204 "Union_box.comp"
// Needed for transport to the main component
struct global_geometry_element_struct global_geometry_element;

#ifndef ANY_GEOMETRY_DETECTOR_DECLARE
    #define ANY_GEOMETRY_DETECTOR_DECLARE dummy
	//struct pointer_to_global_geometry_list global_geometry_list = {0,NULL};
#endif

int loop_index,found_geometries;

double x_component;
double y_component;
double z_component;

struct Volume_struct this_box_volume;
struct box_storage this_box_storage;

#line 66559 "MACS_sample_kidney_box.c"
#undef number_of_activations
#undef mask_setting
#undef mask_string
#undef p_interact
#undef focus_r
#undef focus_xh
#undef focus_xw
#undef focus_ah
#undef focus_aw
#undef target_z
#undef target_y
#undef target_x
#undef target_index
#undef visualize
#undef yheight2
#undef xwidth2
#undef zdepth
#undef yheight
#undef xwidth
#undef priority
#undef material_string
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

/* User declarations for component 'inter_analyzer_colimator_12_blade_4' [615]. */
#define mccompcurname  inter_analyzer_colimator_12_blade_4
#define mccompcurtype  Union_box
#define mccompcurindex 615
#define loop_index mccinter_analyzer_colimator_12_blade_4_loop_index
#define this_box_volume mccinter_analyzer_colimator_12_blade_4_this_box_volume
#define global_geometry_element mccinter_analyzer_colimator_12_blade_4_global_geometry_element
#define this_box_storage mccinter_analyzer_colimator_12_blade_4_this_box_storage
#define material_string mccinter_analyzer_colimator_12_blade_4_material_string
#define priority mccinter_analyzer_colimator_12_blade_4_priority
#define xwidth mccinter_analyzer_colimator_12_blade_4_xwidth
#define yheight mccinter_analyzer_colimator_12_blade_4_yheight
#define zdepth mccinter_analyzer_colimator_12_blade_4_zdepth
#define xwidth2 mccinter_analyzer_colimator_12_blade_4_xwidth2
#define yheight2 mccinter_analyzer_colimator_12_blade_4_yheight2
#define visualize mccinter_analyzer_colimator_12_blade_4_visualize
#define target_index mccinter_analyzer_colimator_12_blade_4_target_index
#define target_x mccinter_analyzer_colimator_12_blade_4_target_x
#define target_y mccinter_analyzer_colimator_12_blade_4_target_y
#define target_z mccinter_analyzer_colimator_12_blade_4_target_z
#define focus_aw mccinter_analyzer_colimator_12_blade_4_focus_aw
#define focus_ah mccinter_analyzer_colimator_12_blade_4_focus_ah
#define focus_xw mccinter_analyzer_colimator_12_blade_4_focus_xw
#define focus_xh mccinter_analyzer_colimator_12_blade_4_focus_xh
#define focus_r mccinter_analyzer_colimator_12_blade_4_focus_r
#define p_interact mccinter_analyzer_colimator_12_blade_4_p_interact
#define mask_string mccinter_analyzer_colimator_12_blade_4_mask_string
#define mask_setting mccinter_analyzer_colimator_12_blade_4_mask_setting
#define number_of_activations mccinter_analyzer_colimator_12_blade_4_number_of_activations
#line 204 "Union_box.comp"
// Needed for transport to the main component
struct global_geometry_element_struct global_geometry_element;

#ifndef ANY_GEOMETRY_DETECTOR_DECLARE
    #define ANY_GEOMETRY_DETECTOR_DECLARE dummy
	//struct pointer_to_global_geometry_list global_geometry_list = {0,NULL};
#endif

int loop_index,found_geometries;

double x_component;
double y_component;
double z_component;

struct Volume_struct this_box_volume;
struct box_storage this_box_storage;

#line 66636 "MACS_sample_kidney_box.c"
#undef number_of_activations
#undef mask_setting
#undef mask_string
#undef p_interact
#undef focus_r
#undef focus_xh
#undef focus_xw
#undef focus_ah
#undef focus_aw
#undef target_z
#undef target_y
#undef target_x
#undef target_index
#undef visualize
#undef yheight2
#undef xwidth2
#undef zdepth
#undef yheight
#undef xwidth
#undef priority
#undef material_string
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

/* User declarations for component 'diffraction_detector_12_exit_volume' [616]. */
#define mccompcurname  diffraction_detector_12_exit_volume
#define mccompcurtype  Union_box
#define mccompcurindex 616
#define loop_index mccdiffraction_detector_12_exit_volume_loop_index
#define this_box_volume mccdiffraction_detector_12_exit_volume_this_box_volume
#define global_geometry_element mccdiffraction_detector_12_exit_volume_global_geometry_element
#define this_box_storage mccdiffraction_detector_12_exit_volume_this_box_storage
#define material_string mccdiffraction_detector_12_exit_volume_material_string
#define priority mccdiffraction_detector_12_exit_volume_priority
#define xwidth mccdiffraction_detector_12_exit_volume_xwidth
#define yheight mccdiffraction_detector_12_exit_volume_yheight
#define zdepth mccdiffraction_detector_12_exit_volume_zdepth
#define xwidth2 mccdiffraction_detector_12_exit_volume_xwidth2
#define yheight2 mccdiffraction_detector_12_exit_volume_yheight2
#define visualize mccdiffraction_detector_12_exit_volume_visualize
#define target_index mccdiffraction_detector_12_exit_volume_target_index
#define target_x mccdiffraction_detector_12_exit_volume_target_x
#define target_y mccdiffraction_detector_12_exit_volume_target_y
#define target_z mccdiffraction_detector_12_exit_volume_target_z
#define focus_aw mccdiffraction_detector_12_exit_volume_focus_aw
#define focus_ah mccdiffraction_detector_12_exit_volume_focus_ah
#define focus_xw mccdiffraction_detector_12_exit_volume_focus_xw
#define focus_xh mccdiffraction_detector_12_exit_volume_focus_xh
#define focus_r mccdiffraction_detector_12_exit_volume_focus_r
#define p_interact mccdiffraction_detector_12_exit_volume_p_interact
#define mask_string mccdiffraction_detector_12_exit_volume_mask_string
#define mask_setting mccdiffraction_detector_12_exit_volume_mask_setting
#define number_of_activations mccdiffraction_detector_12_exit_volume_number_of_activations
#line 204 "Union_box.comp"
// Needed for transport to the main component
struct global_geometry_element_struct global_geometry_element;

#ifndef ANY_GEOMETRY_DETECTOR_DECLARE
    #define ANY_GEOMETRY_DETECTOR_DECLARE dummy
	//struct pointer_to_global_geometry_list global_geometry_list = {0,NULL};
#endif

int loop_index,found_geometries;

double x_component;
double y_component;
double z_component;

struct Volume_struct this_box_volume;
struct box_storage this_box_storage;

#line 66713 "MACS_sample_kidney_box.c"
#undef number_of_activations
#undef mask_setting
#undef mask_string
#undef p_interact
#undef focus_r
#undef focus_xh
#undef focus_xw
#undef focus_ah
#undef focus_aw
#undef target_z
#undef target_y
#undef target_x
#undef target_index
#undef visualize
#undef yheight2
#undef xwidth2
#undef zdepth
#undef yheight
#undef xwidth
#undef priority
#undef material_string
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

/* User declarations for component 'spec_detector_12_exit_volume' [617]. */
#define mccompcurname  spec_detector_12_exit_volume
#define mccompcurtype  Union_box
#define mccompcurindex 617
#define loop_index mccspec_detector_12_exit_volume_loop_index
#define this_box_volume mccspec_detector_12_exit_volume_this_box_volume
#define global_geometry_element mccspec_detector_12_exit_volume_global_geometry_element
#define this_box_storage mccspec_detector_12_exit_volume_this_box_storage
#define material_string mccspec_detector_12_exit_volume_material_string
#define priority mccspec_detector_12_exit_volume_priority
#define xwidth mccspec_detector_12_exit_volume_xwidth
#define yheight mccspec_detector_12_exit_volume_yheight
#define zdepth mccspec_detector_12_exit_volume_zdepth
#define xwidth2 mccspec_detector_12_exit_volume_xwidth2
#define yheight2 mccspec_detector_12_exit_volume_yheight2
#define visualize mccspec_detector_12_exit_volume_visualize
#define target_index mccspec_detector_12_exit_volume_target_index
#define target_x mccspec_detector_12_exit_volume_target_x
#define target_y mccspec_detector_12_exit_volume_target_y
#define target_z mccspec_detector_12_exit_volume_target_z
#define focus_aw mccspec_detector_12_exit_volume_focus_aw
#define focus_ah mccspec_detector_12_exit_volume_focus_ah
#define focus_xw mccspec_detector_12_exit_volume_focus_xw
#define focus_xh mccspec_detector_12_exit_volume_focus_xh
#define focus_r mccspec_detector_12_exit_volume_focus_r
#define p_interact mccspec_detector_12_exit_volume_p_interact
#define mask_string mccspec_detector_12_exit_volume_mask_string
#define mask_setting mccspec_detector_12_exit_volume_mask_setting
#define number_of_activations mccspec_detector_12_exit_volume_number_of_activations
#line 204 "Union_box.comp"
// Needed for transport to the main component
struct global_geometry_element_struct global_geometry_element;

#ifndef ANY_GEOMETRY_DETECTOR_DECLARE
    #define ANY_GEOMETRY_DETECTOR_DECLARE dummy
	//struct pointer_to_global_geometry_list global_geometry_list = {0,NULL};
#endif

int loop_index,found_geometries;

double x_component;
double y_component;
double z_component;

struct Volume_struct this_box_volume;
struct box_storage this_box_storage;

#line 66790 "MACS_sample_kidney_box.c"
#undef number_of_activations
#undef mask_setting
#undef mask_string
#undef p_interact
#undef focus_r
#undef focus_xh
#undef focus_xw
#undef focus_ah
#undef focus_aw
#undef target_z
#undef target_y
#undef target_x
#undef target_index
#undef visualize
#undef yheight2
#undef xwidth2
#undef zdepth
#undef yheight
#undef xwidth
#undef priority
#undef material_string
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

/* User declarations for component 'channel_13_cave1_box1' [618]. */
#define mccompcurname  channel_13_cave1_box1
#define mccompcurtype  Union_box
#define mccompcurindex 618
#define loop_index mccchannel_13_cave1_box1_loop_index
#define this_box_volume mccchannel_13_cave1_box1_this_box_volume
#define global_geometry_element mccchannel_13_cave1_box1_global_geometry_element
#define this_box_storage mccchannel_13_cave1_box1_this_box_storage
#define material_string mccchannel_13_cave1_box1_material_string
#define priority mccchannel_13_cave1_box1_priority
#define xwidth mccchannel_13_cave1_box1_xwidth
#define yheight mccchannel_13_cave1_box1_yheight
#define zdepth mccchannel_13_cave1_box1_zdepth
#define xwidth2 mccchannel_13_cave1_box1_xwidth2
#define yheight2 mccchannel_13_cave1_box1_yheight2
#define visualize mccchannel_13_cave1_box1_visualize
#define target_index mccchannel_13_cave1_box1_target_index
#define target_x mccchannel_13_cave1_box1_target_x
#define target_y mccchannel_13_cave1_box1_target_y
#define target_z mccchannel_13_cave1_box1_target_z
#define focus_aw mccchannel_13_cave1_box1_focus_aw
#define focus_ah mccchannel_13_cave1_box1_focus_ah
#define focus_xw mccchannel_13_cave1_box1_focus_xw
#define focus_xh mccchannel_13_cave1_box1_focus_xh
#define focus_r mccchannel_13_cave1_box1_focus_r
#define p_interact mccchannel_13_cave1_box1_p_interact
#define mask_string mccchannel_13_cave1_box1_mask_string
#define mask_setting mccchannel_13_cave1_box1_mask_setting
#define number_of_activations mccchannel_13_cave1_box1_number_of_activations
#line 204 "Union_box.comp"
// Needed for transport to the main component
struct global_geometry_element_struct global_geometry_element;

#ifndef ANY_GEOMETRY_DETECTOR_DECLARE
    #define ANY_GEOMETRY_DETECTOR_DECLARE dummy
	//struct pointer_to_global_geometry_list global_geometry_list = {0,NULL};
#endif

int loop_index,found_geometries;

double x_component;
double y_component;
double z_component;

struct Volume_struct this_box_volume;
struct box_storage this_box_storage;

#line 66867 "MACS_sample_kidney_box.c"
#undef number_of_activations
#undef mask_setting
#undef mask_string
#undef p_interact
#undef focus_r
#undef focus_xh
#undef focus_xw
#undef focus_ah
#undef focus_aw
#undef target_z
#undef target_y
#undef target_x
#undef target_index
#undef visualize
#undef yheight2
#undef xwidth2
#undef zdepth
#undef yheight
#undef xwidth
#undef priority
#undef material_string
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

/* User declarations for component 'channel_13_cave1_box2' [619]. */
#define mccompcurname  channel_13_cave1_box2
#define mccompcurtype  Union_box
#define mccompcurindex 619
#define loop_index mccchannel_13_cave1_box2_loop_index
#define this_box_volume mccchannel_13_cave1_box2_this_box_volume
#define global_geometry_element mccchannel_13_cave1_box2_global_geometry_element
#define this_box_storage mccchannel_13_cave1_box2_this_box_storage
#define material_string mccchannel_13_cave1_box2_material_string
#define priority mccchannel_13_cave1_box2_priority
#define xwidth mccchannel_13_cave1_box2_xwidth
#define yheight mccchannel_13_cave1_box2_yheight
#define zdepth mccchannel_13_cave1_box2_zdepth
#define xwidth2 mccchannel_13_cave1_box2_xwidth2
#define yheight2 mccchannel_13_cave1_box2_yheight2
#define visualize mccchannel_13_cave1_box2_visualize
#define target_index mccchannel_13_cave1_box2_target_index
#define target_x mccchannel_13_cave1_box2_target_x
#define target_y mccchannel_13_cave1_box2_target_y
#define target_z mccchannel_13_cave1_box2_target_z
#define focus_aw mccchannel_13_cave1_box2_focus_aw
#define focus_ah mccchannel_13_cave1_box2_focus_ah
#define focus_xw mccchannel_13_cave1_box2_focus_xw
#define focus_xh mccchannel_13_cave1_box2_focus_xh
#define focus_r mccchannel_13_cave1_box2_focus_r
#define p_interact mccchannel_13_cave1_box2_p_interact
#define mask_string mccchannel_13_cave1_box2_mask_string
#define mask_setting mccchannel_13_cave1_box2_mask_setting
#define number_of_activations mccchannel_13_cave1_box2_number_of_activations
#line 204 "Union_box.comp"
// Needed for transport to the main component
struct global_geometry_element_struct global_geometry_element;

#ifndef ANY_GEOMETRY_DETECTOR_DECLARE
    #define ANY_GEOMETRY_DETECTOR_DECLARE dummy
	//struct pointer_to_global_geometry_list global_geometry_list = {0,NULL};
#endif

int loop_index,found_geometries;

double x_component;
double y_component;
double z_component;

struct Volume_struct this_box_volume;
struct box_storage this_box_storage;

#line 66944 "MACS_sample_kidney_box.c"
#undef number_of_activations
#undef mask_setting
#undef mask_string
#undef p_interact
#undef focus_r
#undef focus_xh
#undef focus_xw
#undef focus_ah
#undef focus_aw
#undef target_z
#undef target_y
#undef target_x
#undef target_index
#undef visualize
#undef yheight2
#undef xwidth2
#undef zdepth
#undef yheight
#undef xwidth
#undef priority
#undef material_string
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

/* User declarations for component 'channel_13_cave1_box3' [620]. */
#define mccompcurname  channel_13_cave1_box3
#define mccompcurtype  Union_box
#define mccompcurindex 620
#define loop_index mccchannel_13_cave1_box3_loop_index
#define this_box_volume mccchannel_13_cave1_box3_this_box_volume
#define global_geometry_element mccchannel_13_cave1_box3_global_geometry_element
#define this_box_storage mccchannel_13_cave1_box3_this_box_storage
#define material_string mccchannel_13_cave1_box3_material_string
#define priority mccchannel_13_cave1_box3_priority
#define xwidth mccchannel_13_cave1_box3_xwidth
#define yheight mccchannel_13_cave1_box3_yheight
#define zdepth mccchannel_13_cave1_box3_zdepth
#define xwidth2 mccchannel_13_cave1_box3_xwidth2
#define yheight2 mccchannel_13_cave1_box3_yheight2
#define visualize mccchannel_13_cave1_box3_visualize
#define target_index mccchannel_13_cave1_box3_target_index
#define target_x mccchannel_13_cave1_box3_target_x
#define target_y mccchannel_13_cave1_box3_target_y
#define target_z mccchannel_13_cave1_box3_target_z
#define focus_aw mccchannel_13_cave1_box3_focus_aw
#define focus_ah mccchannel_13_cave1_box3_focus_ah
#define focus_xw mccchannel_13_cave1_box3_focus_xw
#define focus_xh mccchannel_13_cave1_box3_focus_xh
#define focus_r mccchannel_13_cave1_box3_focus_r
#define p_interact mccchannel_13_cave1_box3_p_interact
#define mask_string mccchannel_13_cave1_box3_mask_string
#define mask_setting mccchannel_13_cave1_box3_mask_setting
#define number_of_activations mccchannel_13_cave1_box3_number_of_activations
#line 204 "Union_box.comp"
// Needed for transport to the main component
struct global_geometry_element_struct global_geometry_element;

#ifndef ANY_GEOMETRY_DETECTOR_DECLARE
    #define ANY_GEOMETRY_DETECTOR_DECLARE dummy
	//struct pointer_to_global_geometry_list global_geometry_list = {0,NULL};
#endif

int loop_index,found_geometries;

double x_component;
double y_component;
double z_component;

struct Volume_struct this_box_volume;
struct box_storage this_box_storage;

#line 67021 "MACS_sample_kidney_box.c"
#undef number_of_activations
#undef mask_setting
#undef mask_string
#undef p_interact
#undef focus_r
#undef focus_xh
#undef focus_xw
#undef focus_ah
#undef focus_aw
#undef target_z
#undef target_y
#undef target_x
#undef target_index
#undef visualize
#undef yheight2
#undef xwidth2
#undef zdepth
#undef yheight
#undef xwidth
#undef priority
#undef material_string
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

/* User declarations for component 'channel_13_cave1_cyl1' [621]. */
#define mccompcurname  channel_13_cave1_cyl1
#define mccompcurtype  Union_cylinder
#define mccompcurindex 621
#define loop_index mccchannel_13_cave1_cyl1_loop_index
#define this_cylinder_volume mccchannel_13_cave1_cyl1_this_cylinder_volume
#define global_geometry_element mccchannel_13_cave1_cyl1_global_geometry_element
#define this_cylinder_storage mccchannel_13_cave1_cyl1_this_cylinder_storage
#define material_string mccchannel_13_cave1_cyl1_material_string
#define priority mccchannel_13_cave1_cyl1_priority
#define radius mccchannel_13_cave1_cyl1_radius
#define yheight mccchannel_13_cave1_cyl1_yheight
#define visualize mccchannel_13_cave1_cyl1_visualize
#define target_index mccchannel_13_cave1_cyl1_target_index
#define target_x mccchannel_13_cave1_cyl1_target_x
#define target_y mccchannel_13_cave1_cyl1_target_y
#define target_z mccchannel_13_cave1_cyl1_target_z
#define focus_aw mccchannel_13_cave1_cyl1_focus_aw
#define focus_ah mccchannel_13_cave1_cyl1_focus_ah
#define focus_xw mccchannel_13_cave1_cyl1_focus_xw
#define focus_xh mccchannel_13_cave1_cyl1_focus_xh
#define focus_r mccchannel_13_cave1_cyl1_focus_r
#define p_interact mccchannel_13_cave1_cyl1_p_interact
#define mask_string mccchannel_13_cave1_cyl1_mask_string
#define mask_setting mccchannel_13_cave1_cyl1_mask_setting
#define number_of_activations mccchannel_13_cave1_cyl1_number_of_activations
#line 167 "Union_cylinder.comp"
// Needed for transport to the main component
struct global_geometry_element_struct global_geometry_element;

#ifndef ANY_GEOMETRY_DETECTOR_DECLARE
    #define ANY_GEOMETRY_DETECTOR_DECLARE dummy
	//struct pointer_to_global_geometry_list global_geometry_list = {0,NULL};
#endif

int dummy;
int loop_index,found_geometries;
int loop_2_index;
int material_index;

struct Volume_struct this_cylinder_volume;
struct cylinder_storage this_cylinder_storage;
#line 67093 "MACS_sample_kidney_box.c"
#undef number_of_activations
#undef mask_setting
#undef mask_string
#undef p_interact
#undef focus_r
#undef focus_xh
#undef focus_xw
#undef focus_ah
#undef focus_aw
#undef target_z
#undef target_y
#undef target_x
#undef target_index
#undef visualize
#undef yheight
#undef radius
#undef priority
#undef material_string
#undef this_cylinder_storage
#undef global_geometry_element
#undef this_cylinder_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

/* User declarations for component 'channel_13_analyzer_1_center' [622]. */
#define mccompcurname  channel_13_analyzer_1_center
#define mccompcurtype  Arm
#define mccompcurindex 622
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

/* User declarations for component 'channel_13_analyzer_1_rotated' [623]. */
#define mccompcurname  channel_13_analyzer_1_rotated
#define mccompcurtype  Arm
#define mccompcurindex 623
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

/* User declarations for component 'channel_13_analyzer_1_array_crystal_array_0' [624]. */
#define mccompcurname  channel_13_analyzer_1_array_crystal_array_0
#define mccompcurtype  Union_box
#define mccompcurindex 624
#define loop_index mccchannel_13_analyzer_1_array_crystal_array_0_loop_index
#define this_box_volume mccchannel_13_analyzer_1_array_crystal_array_0_this_box_volume
#define global_geometry_element mccchannel_13_analyzer_1_array_crystal_array_0_global_geometry_element
#define this_box_storage mccchannel_13_analyzer_1_array_crystal_array_0_this_box_storage
#define material_string mccchannel_13_analyzer_1_array_crystal_array_0_material_string
#define priority mccchannel_13_analyzer_1_array_crystal_array_0_priority
#define xwidth mccchannel_13_analyzer_1_array_crystal_array_0_xwidth
#define yheight mccchannel_13_analyzer_1_array_crystal_array_0_yheight
#define zdepth mccchannel_13_analyzer_1_array_crystal_array_0_zdepth
#define xwidth2 mccchannel_13_analyzer_1_array_crystal_array_0_xwidth2
#define yheight2 mccchannel_13_analyzer_1_array_crystal_array_0_yheight2
#define visualize mccchannel_13_analyzer_1_array_crystal_array_0_visualize
#define target_index mccchannel_13_analyzer_1_array_crystal_array_0_target_index
#define target_x mccchannel_13_analyzer_1_array_crystal_array_0_target_x
#define target_y mccchannel_13_analyzer_1_array_crystal_array_0_target_y
#define target_z mccchannel_13_analyzer_1_array_crystal_array_0_target_z
#define focus_aw mccchannel_13_analyzer_1_array_crystal_array_0_focus_aw
#define focus_ah mccchannel_13_analyzer_1_array_crystal_array_0_focus_ah
#define focus_xw mccchannel_13_analyzer_1_array_crystal_array_0_focus_xw
#define focus_xh mccchannel_13_analyzer_1_array_crystal_array_0_focus_xh
#define focus_r mccchannel_13_analyzer_1_array_crystal_array_0_focus_r
#define p_interact mccchannel_13_analyzer_1_array_crystal_array_0_p_interact
#define mask_string mccchannel_13_analyzer_1_array_crystal_array_0_mask_string
#define mask_setting mccchannel_13_analyzer_1_array_crystal_array_0_mask_setting
#define number_of_activations mccchannel_13_analyzer_1_array_crystal_array_0_number_of_activations
#line 204 "Union_box.comp"
// Needed for transport to the main component
struct global_geometry_element_struct global_geometry_element;

#ifndef ANY_GEOMETRY_DETECTOR_DECLARE
    #define ANY_GEOMETRY_DETECTOR_DECLARE dummy
	//struct pointer_to_global_geometry_list global_geometry_list = {0,NULL};
#endif

int loop_index,found_geometries;

double x_component;
double y_component;
double z_component;

struct Volume_struct this_box_volume;
struct box_storage this_box_storage;

#line 67183 "MACS_sample_kidney_box.c"
#undef number_of_activations
#undef mask_setting
#undef mask_string
#undef p_interact
#undef focus_r
#undef focus_xh
#undef focus_xw
#undef focus_ah
#undef focus_aw
#undef target_z
#undef target_y
#undef target_x
#undef target_index
#undef visualize
#undef yheight2
#undef xwidth2
#undef zdepth
#undef yheight
#undef xwidth
#undef priority
#undef material_string
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

/* User declarations for component 'channel_13_analyzer_1_array_crystal_array_1' [625]. */
#define mccompcurname  channel_13_analyzer_1_array_crystal_array_1
#define mccompcurtype  Union_box
#define mccompcurindex 625
#define loop_index mccchannel_13_analyzer_1_array_crystal_array_1_loop_index
#define this_box_volume mccchannel_13_analyzer_1_array_crystal_array_1_this_box_volume
#define global_geometry_element mccchannel_13_analyzer_1_array_crystal_array_1_global_geometry_element
#define this_box_storage mccchannel_13_analyzer_1_array_crystal_array_1_this_box_storage
#define material_string mccchannel_13_analyzer_1_array_crystal_array_1_material_string
#define priority mccchannel_13_analyzer_1_array_crystal_array_1_priority
#define xwidth mccchannel_13_analyzer_1_array_crystal_array_1_xwidth
#define yheight mccchannel_13_analyzer_1_array_crystal_array_1_yheight
#define zdepth mccchannel_13_analyzer_1_array_crystal_array_1_zdepth
#define xwidth2 mccchannel_13_analyzer_1_array_crystal_array_1_xwidth2
#define yheight2 mccchannel_13_analyzer_1_array_crystal_array_1_yheight2
#define visualize mccchannel_13_analyzer_1_array_crystal_array_1_visualize
#define target_index mccchannel_13_analyzer_1_array_crystal_array_1_target_index
#define target_x mccchannel_13_analyzer_1_array_crystal_array_1_target_x
#define target_y mccchannel_13_analyzer_1_array_crystal_array_1_target_y
#define target_z mccchannel_13_analyzer_1_array_crystal_array_1_target_z
#define focus_aw mccchannel_13_analyzer_1_array_crystal_array_1_focus_aw
#define focus_ah mccchannel_13_analyzer_1_array_crystal_array_1_focus_ah
#define focus_xw mccchannel_13_analyzer_1_array_crystal_array_1_focus_xw
#define focus_xh mccchannel_13_analyzer_1_array_crystal_array_1_focus_xh
#define focus_r mccchannel_13_analyzer_1_array_crystal_array_1_focus_r
#define p_interact mccchannel_13_analyzer_1_array_crystal_array_1_p_interact
#define mask_string mccchannel_13_analyzer_1_array_crystal_array_1_mask_string
#define mask_setting mccchannel_13_analyzer_1_array_crystal_array_1_mask_setting
#define number_of_activations mccchannel_13_analyzer_1_array_crystal_array_1_number_of_activations
#line 204 "Union_box.comp"
// Needed for transport to the main component
struct global_geometry_element_struct global_geometry_element;

#ifndef ANY_GEOMETRY_DETECTOR_DECLARE
    #define ANY_GEOMETRY_DETECTOR_DECLARE dummy
	//struct pointer_to_global_geometry_list global_geometry_list = {0,NULL};
#endif

int loop_index,found_geometries;

double x_component;
double y_component;
double z_component;

struct Volume_struct this_box_volume;
struct box_storage this_box_storage;

#line 67260 "MACS_sample_kidney_box.c"
#undef number_of_activations
#undef mask_setting
#undef mask_string
#undef p_interact
#undef focus_r
#undef focus_xh
#undef focus_xw
#undef focus_ah
#undef focus_aw
#undef target_z
#undef target_y
#undef target_x
#undef target_index
#undef visualize
#undef yheight2
#undef xwidth2
#undef zdepth
#undef yheight
#undef xwidth
#undef priority
#undef material_string
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

/* User declarations for component 'channel_13_analyzer_1_array_crystal_array_2' [626]. */
#define mccompcurname  channel_13_analyzer_1_array_crystal_array_2
#define mccompcurtype  Union_box
#define mccompcurindex 626
#define loop_index mccchannel_13_analyzer_1_array_crystal_array_2_loop_index
#define this_box_volume mccchannel_13_analyzer_1_array_crystal_array_2_this_box_volume
#define global_geometry_element mccchannel_13_analyzer_1_array_crystal_array_2_global_geometry_element
#define this_box_storage mccchannel_13_analyzer_1_array_crystal_array_2_this_box_storage
#define material_string mccchannel_13_analyzer_1_array_crystal_array_2_material_string
#define priority mccchannel_13_analyzer_1_array_crystal_array_2_priority
#define xwidth mccchannel_13_analyzer_1_array_crystal_array_2_xwidth
#define yheight mccchannel_13_analyzer_1_array_crystal_array_2_yheight
#define zdepth mccchannel_13_analyzer_1_array_crystal_array_2_zdepth
#define xwidth2 mccchannel_13_analyzer_1_array_crystal_array_2_xwidth2
#define yheight2 mccchannel_13_analyzer_1_array_crystal_array_2_yheight2
#define visualize mccchannel_13_analyzer_1_array_crystal_array_2_visualize
#define target_index mccchannel_13_analyzer_1_array_crystal_array_2_target_index
#define target_x mccchannel_13_analyzer_1_array_crystal_array_2_target_x
#define target_y mccchannel_13_analyzer_1_array_crystal_array_2_target_y
#define target_z mccchannel_13_analyzer_1_array_crystal_array_2_target_z
#define focus_aw mccchannel_13_analyzer_1_array_crystal_array_2_focus_aw
#define focus_ah mccchannel_13_analyzer_1_array_crystal_array_2_focus_ah
#define focus_xw mccchannel_13_analyzer_1_array_crystal_array_2_focus_xw
#define focus_xh mccchannel_13_analyzer_1_array_crystal_array_2_focus_xh
#define focus_r mccchannel_13_analyzer_1_array_crystal_array_2_focus_r
#define p_interact mccchannel_13_analyzer_1_array_crystal_array_2_p_interact
#define mask_string mccchannel_13_analyzer_1_array_crystal_array_2_mask_string
#define mask_setting mccchannel_13_analyzer_1_array_crystal_array_2_mask_setting
#define number_of_activations mccchannel_13_analyzer_1_array_crystal_array_2_number_of_activations
#line 204 "Union_box.comp"
// Needed for transport to the main component
struct global_geometry_element_struct global_geometry_element;

#ifndef ANY_GEOMETRY_DETECTOR_DECLARE
    #define ANY_GEOMETRY_DETECTOR_DECLARE dummy
	//struct pointer_to_global_geometry_list global_geometry_list = {0,NULL};
#endif

int loop_index,found_geometries;

double x_component;
double y_component;
double z_component;

struct Volume_struct this_box_volume;
struct box_storage this_box_storage;

#line 67337 "MACS_sample_kidney_box.c"
#undef number_of_activations
#undef mask_setting
#undef mask_string
#undef p_interact
#undef focus_r
#undef focus_xh
#undef focus_xw
#undef focus_ah
#undef focus_aw
#undef target_z
#undef target_y
#undef target_x
#undef target_index
#undef visualize
#undef yheight2
#undef xwidth2
#undef zdepth
#undef yheight
#undef xwidth
#undef priority
#undef material_string
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

/* User declarations for component 'channel_13_analyzer_1_array_crystal_array_3' [627]. */
#define mccompcurname  channel_13_analyzer_1_array_crystal_array_3
#define mccompcurtype  Union_box
#define mccompcurindex 627
#define loop_index mccchannel_13_analyzer_1_array_crystal_array_3_loop_index
#define this_box_volume mccchannel_13_analyzer_1_array_crystal_array_3_this_box_volume
#define global_geometry_element mccchannel_13_analyzer_1_array_crystal_array_3_global_geometry_element
#define this_box_storage mccchannel_13_analyzer_1_array_crystal_array_3_this_box_storage
#define material_string mccchannel_13_analyzer_1_array_crystal_array_3_material_string
#define priority mccchannel_13_analyzer_1_array_crystal_array_3_priority
#define xwidth mccchannel_13_analyzer_1_array_crystal_array_3_xwidth
#define yheight mccchannel_13_analyzer_1_array_crystal_array_3_yheight
#define zdepth mccchannel_13_analyzer_1_array_crystal_array_3_zdepth
#define xwidth2 mccchannel_13_analyzer_1_array_crystal_array_3_xwidth2
#define yheight2 mccchannel_13_analyzer_1_array_crystal_array_3_yheight2
#define visualize mccchannel_13_analyzer_1_array_crystal_array_3_visualize
#define target_index mccchannel_13_analyzer_1_array_crystal_array_3_target_index
#define target_x mccchannel_13_analyzer_1_array_crystal_array_3_target_x
#define target_y mccchannel_13_analyzer_1_array_crystal_array_3_target_y
#define target_z mccchannel_13_analyzer_1_array_crystal_array_3_target_z
#define focus_aw mccchannel_13_analyzer_1_array_crystal_array_3_focus_aw
#define focus_ah mccchannel_13_analyzer_1_array_crystal_array_3_focus_ah
#define focus_xw mccchannel_13_analyzer_1_array_crystal_array_3_focus_xw
#define focus_xh mccchannel_13_analyzer_1_array_crystal_array_3_focus_xh
#define focus_r mccchannel_13_analyzer_1_array_crystal_array_3_focus_r
#define p_interact mccchannel_13_analyzer_1_array_crystal_array_3_p_interact
#define mask_string mccchannel_13_analyzer_1_array_crystal_array_3_mask_string
#define mask_setting mccchannel_13_analyzer_1_array_crystal_array_3_mask_setting
#define number_of_activations mccchannel_13_analyzer_1_array_crystal_array_3_number_of_activations
#line 204 "Union_box.comp"
// Needed for transport to the main component
struct global_geometry_element_struct global_geometry_element;

#ifndef ANY_GEOMETRY_DETECTOR_DECLARE
    #define ANY_GEOMETRY_DETECTOR_DECLARE dummy
	//struct pointer_to_global_geometry_list global_geometry_list = {0,NULL};
#endif

int loop_index,found_geometries;

double x_component;
double y_component;
double z_component;

struct Volume_struct this_box_volume;
struct box_storage this_box_storage;

#line 67414 "MACS_sample_kidney_box.c"
#undef number_of_activations
#undef mask_setting
#undef mask_string
#undef p_interact
#undef focus_r
#undef focus_xh
#undef focus_xw
#undef focus_ah
#undef focus_aw
#undef target_z
#undef target_y
#undef target_x
#undef target_index
#undef visualize
#undef yheight2
#undef xwidth2
#undef zdepth
#undef yheight
#undef xwidth
#undef priority
#undef material_string
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

/* User declarations for component 'channel_13_analyzer_1_array_crystal_array_4' [628]. */
#define mccompcurname  channel_13_analyzer_1_array_crystal_array_4
#define mccompcurtype  Union_box
#define mccompcurindex 628
#define loop_index mccchannel_13_analyzer_1_array_crystal_array_4_loop_index
#define this_box_volume mccchannel_13_analyzer_1_array_crystal_array_4_this_box_volume
#define global_geometry_element mccchannel_13_analyzer_1_array_crystal_array_4_global_geometry_element
#define this_box_storage mccchannel_13_analyzer_1_array_crystal_array_4_this_box_storage
#define material_string mccchannel_13_analyzer_1_array_crystal_array_4_material_string
#define priority mccchannel_13_analyzer_1_array_crystal_array_4_priority
#define xwidth mccchannel_13_analyzer_1_array_crystal_array_4_xwidth
#define yheight mccchannel_13_analyzer_1_array_crystal_array_4_yheight
#define zdepth mccchannel_13_analyzer_1_array_crystal_array_4_zdepth
#define xwidth2 mccchannel_13_analyzer_1_array_crystal_array_4_xwidth2
#define yheight2 mccchannel_13_analyzer_1_array_crystal_array_4_yheight2
#define visualize mccchannel_13_analyzer_1_array_crystal_array_4_visualize
#define target_index mccchannel_13_analyzer_1_array_crystal_array_4_target_index
#define target_x mccchannel_13_analyzer_1_array_crystal_array_4_target_x
#define target_y mccchannel_13_analyzer_1_array_crystal_array_4_target_y
#define target_z mccchannel_13_analyzer_1_array_crystal_array_4_target_z
#define focus_aw mccchannel_13_analyzer_1_array_crystal_array_4_focus_aw
#define focus_ah mccchannel_13_analyzer_1_array_crystal_array_4_focus_ah
#define focus_xw mccchannel_13_analyzer_1_array_crystal_array_4_focus_xw
#define focus_xh mccchannel_13_analyzer_1_array_crystal_array_4_focus_xh
#define focus_r mccchannel_13_analyzer_1_array_crystal_array_4_focus_r
#define p_interact mccchannel_13_analyzer_1_array_crystal_array_4_p_interact
#define mask_string mccchannel_13_analyzer_1_array_crystal_array_4_mask_string
#define mask_setting mccchannel_13_analyzer_1_array_crystal_array_4_mask_setting
#define number_of_activations mccchannel_13_analyzer_1_array_crystal_array_4_number_of_activations
#line 204 "Union_box.comp"
// Needed for transport to the main component
struct global_geometry_element_struct global_geometry_element;

#ifndef ANY_GEOMETRY_DETECTOR_DECLARE
    #define ANY_GEOMETRY_DETECTOR_DECLARE dummy
	//struct pointer_to_global_geometry_list global_geometry_list = {0,NULL};
#endif

int loop_index,found_geometries;

double x_component;
double y_component;
double z_component;

struct Volume_struct this_box_volume;
struct box_storage this_box_storage;

#line 67491 "MACS_sample_kidney_box.c"
#undef number_of_activations
#undef mask_setting
#undef mask_string
#undef p_interact
#undef focus_r
#undef focus_xh
#undef focus_xw
#undef focus_ah
#undef focus_aw
#undef target_z
#undef target_y
#undef target_x
#undef target_index
#undef visualize
#undef yheight2
#undef xwidth2
#undef zdepth
#undef yheight
#undef xwidth
#undef priority
#undef material_string
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

/* User declarations for component 'channel_13_analyzer_1_array_crystal_array_5' [629]. */
#define mccompcurname  channel_13_analyzer_1_array_crystal_array_5
#define mccompcurtype  Union_box
#define mccompcurindex 629
#define loop_index mccchannel_13_analyzer_1_array_crystal_array_5_loop_index
#define this_box_volume mccchannel_13_analyzer_1_array_crystal_array_5_this_box_volume
#define global_geometry_element mccchannel_13_analyzer_1_array_crystal_array_5_global_geometry_element
#define this_box_storage mccchannel_13_analyzer_1_array_crystal_array_5_this_box_storage
#define material_string mccchannel_13_analyzer_1_array_crystal_array_5_material_string
#define priority mccchannel_13_analyzer_1_array_crystal_array_5_priority
#define xwidth mccchannel_13_analyzer_1_array_crystal_array_5_xwidth
#define yheight mccchannel_13_analyzer_1_array_crystal_array_5_yheight
#define zdepth mccchannel_13_analyzer_1_array_crystal_array_5_zdepth
#define xwidth2 mccchannel_13_analyzer_1_array_crystal_array_5_xwidth2
#define yheight2 mccchannel_13_analyzer_1_array_crystal_array_5_yheight2
#define visualize mccchannel_13_analyzer_1_array_crystal_array_5_visualize
#define target_index mccchannel_13_analyzer_1_array_crystal_array_5_target_index
#define target_x mccchannel_13_analyzer_1_array_crystal_array_5_target_x
#define target_y mccchannel_13_analyzer_1_array_crystal_array_5_target_y
#define target_z mccchannel_13_analyzer_1_array_crystal_array_5_target_z
#define focus_aw mccchannel_13_analyzer_1_array_crystal_array_5_focus_aw
#define focus_ah mccchannel_13_analyzer_1_array_crystal_array_5_focus_ah
#define focus_xw mccchannel_13_analyzer_1_array_crystal_array_5_focus_xw
#define focus_xh mccchannel_13_analyzer_1_array_crystal_array_5_focus_xh
#define focus_r mccchannel_13_analyzer_1_array_crystal_array_5_focus_r
#define p_interact mccchannel_13_analyzer_1_array_crystal_array_5_p_interact
#define mask_string mccchannel_13_analyzer_1_array_crystal_array_5_mask_string
#define mask_setting mccchannel_13_analyzer_1_array_crystal_array_5_mask_setting
#define number_of_activations mccchannel_13_analyzer_1_array_crystal_array_5_number_of_activations
#line 204 "Union_box.comp"
// Needed for transport to the main component
struct global_geometry_element_struct global_geometry_element;

#ifndef ANY_GEOMETRY_DETECTOR_DECLARE
    #define ANY_GEOMETRY_DETECTOR_DECLARE dummy
	//struct pointer_to_global_geometry_list global_geometry_list = {0,NULL};
#endif

int loop_index,found_geometries;

double x_component;
double y_component;
double z_component;

struct Volume_struct this_box_volume;
struct box_storage this_box_storage;

#line 67568 "MACS_sample_kidney_box.c"
#undef number_of_activations
#undef mask_setting
#undef mask_string
#undef p_interact
#undef focus_r
#undef focus_xh
#undef focus_xw
#undef focus_ah
#undef focus_aw
#undef target_z
#undef target_y
#undef target_x
#undef target_index
#undef visualize
#undef yheight2
#undef xwidth2
#undef zdepth
#undef yheight
#undef xwidth
#undef priority
#undef material_string
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

/* User declarations for component 'channel_13_analyzer_1_array_crystal_array_6' [630]. */
#define mccompcurname  channel_13_analyzer_1_array_crystal_array_6
#define mccompcurtype  Union_box
#define mccompcurindex 630
#define loop_index mccchannel_13_analyzer_1_array_crystal_array_6_loop_index
#define this_box_volume mccchannel_13_analyzer_1_array_crystal_array_6_this_box_volume
#define global_geometry_element mccchannel_13_analyzer_1_array_crystal_array_6_global_geometry_element
#define this_box_storage mccchannel_13_analyzer_1_array_crystal_array_6_this_box_storage
#define material_string mccchannel_13_analyzer_1_array_crystal_array_6_material_string
#define priority mccchannel_13_analyzer_1_array_crystal_array_6_priority
#define xwidth mccchannel_13_analyzer_1_array_crystal_array_6_xwidth
#define yheight mccchannel_13_analyzer_1_array_crystal_array_6_yheight
#define zdepth mccchannel_13_analyzer_1_array_crystal_array_6_zdepth
#define xwidth2 mccchannel_13_analyzer_1_array_crystal_array_6_xwidth2
#define yheight2 mccchannel_13_analyzer_1_array_crystal_array_6_yheight2
#define visualize mccchannel_13_analyzer_1_array_crystal_array_6_visualize
#define target_index mccchannel_13_analyzer_1_array_crystal_array_6_target_index
#define target_x mccchannel_13_analyzer_1_array_crystal_array_6_target_x
#define target_y mccchannel_13_analyzer_1_array_crystal_array_6_target_y
#define target_z mccchannel_13_analyzer_1_array_crystal_array_6_target_z
#define focus_aw mccchannel_13_analyzer_1_array_crystal_array_6_focus_aw
#define focus_ah mccchannel_13_analyzer_1_array_crystal_array_6_focus_ah
#define focus_xw mccchannel_13_analyzer_1_array_crystal_array_6_focus_xw
#define focus_xh mccchannel_13_analyzer_1_array_crystal_array_6_focus_xh
#define focus_r mccchannel_13_analyzer_1_array_crystal_array_6_focus_r
#define p_interact mccchannel_13_analyzer_1_array_crystal_array_6_p_interact
#define mask_string mccchannel_13_analyzer_1_array_crystal_array_6_mask_string
#define mask_setting mccchannel_13_analyzer_1_array_crystal_array_6_mask_setting
#define number_of_activations mccchannel_13_analyzer_1_array_crystal_array_6_number_of_activations
#line 204 "Union_box.comp"
// Needed for transport to the main component
struct global_geometry_element_struct global_geometry_element;

#ifndef ANY_GEOMETRY_DETECTOR_DECLARE
    #define ANY_GEOMETRY_DETECTOR_DECLARE dummy
	//struct pointer_to_global_geometry_list global_geometry_list = {0,NULL};
#endif

int loop_index,found_geometries;

double x_component;
double y_component;
double z_component;

struct Volume_struct this_box_volume;
struct box_storage this_box_storage;

#line 67645 "MACS_sample_kidney_box.c"
#undef number_of_activations
#undef mask_setting
#undef mask_string
#undef p_interact
#undef focus_r
#undef focus_xh
#undef focus_xw
#undef focus_ah
#undef focus_aw
#undef target_z
#undef target_y
#undef target_x
#undef target_index
#undef visualize
#undef yheight2
#undef xwidth2
#undef zdepth
#undef yheight
#undef xwidth
#undef priority
#undef material_string
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

/* User declarations for component 'channel_13_analyzer_1_array_crystal_array_7' [631]. */
#define mccompcurname  channel_13_analyzer_1_array_crystal_array_7
#define mccompcurtype  Union_box
#define mccompcurindex 631
#define loop_index mccchannel_13_analyzer_1_array_crystal_array_7_loop_index
#define this_box_volume mccchannel_13_analyzer_1_array_crystal_array_7_this_box_volume
#define global_geometry_element mccchannel_13_analyzer_1_array_crystal_array_7_global_geometry_element
#define this_box_storage mccchannel_13_analyzer_1_array_crystal_array_7_this_box_storage
#define material_string mccchannel_13_analyzer_1_array_crystal_array_7_material_string
#define priority mccchannel_13_analyzer_1_array_crystal_array_7_priority
#define xwidth mccchannel_13_analyzer_1_array_crystal_array_7_xwidth
#define yheight mccchannel_13_analyzer_1_array_crystal_array_7_yheight
#define zdepth mccchannel_13_analyzer_1_array_crystal_array_7_zdepth
#define xwidth2 mccchannel_13_analyzer_1_array_crystal_array_7_xwidth2
#define yheight2 mccchannel_13_analyzer_1_array_crystal_array_7_yheight2
#define visualize mccchannel_13_analyzer_1_array_crystal_array_7_visualize
#define target_index mccchannel_13_analyzer_1_array_crystal_array_7_target_index
#define target_x mccchannel_13_analyzer_1_array_crystal_array_7_target_x
#define target_y mccchannel_13_analyzer_1_array_crystal_array_7_target_y
#define target_z mccchannel_13_analyzer_1_array_crystal_array_7_target_z
#define focus_aw mccchannel_13_analyzer_1_array_crystal_array_7_focus_aw
#define focus_ah mccchannel_13_analyzer_1_array_crystal_array_7_focus_ah
#define focus_xw mccchannel_13_analyzer_1_array_crystal_array_7_focus_xw
#define focus_xh mccchannel_13_analyzer_1_array_crystal_array_7_focus_xh
#define focus_r mccchannel_13_analyzer_1_array_crystal_array_7_focus_r
#define p_interact mccchannel_13_analyzer_1_array_crystal_array_7_p_interact
#define mask_string mccchannel_13_analyzer_1_array_crystal_array_7_mask_string
#define mask_setting mccchannel_13_analyzer_1_array_crystal_array_7_mask_setting
#define number_of_activations mccchannel_13_analyzer_1_array_crystal_array_7_number_of_activations
#line 204 "Union_box.comp"
// Needed for transport to the main component
struct global_geometry_element_struct global_geometry_element;

#ifndef ANY_GEOMETRY_DETECTOR_DECLARE
    #define ANY_GEOMETRY_DETECTOR_DECLARE dummy
	//struct pointer_to_global_geometry_list global_geometry_list = {0,NULL};
#endif

int loop_index,found_geometries;

double x_component;
double y_component;
double z_component;

struct Volume_struct this_box_volume;
struct box_storage this_box_storage;

#line 67722 "MACS_sample_kidney_box.c"
#undef number_of_activations
#undef mask_setting
#undef mask_string
#undef p_interact
#undef focus_r
#undef focus_xh
#undef focus_xw
#undef focus_ah
#undef focus_aw
#undef target_z
#undef target_y
#undef target_x
#undef target_index
#undef visualize
#undef yheight2
#undef xwidth2
#undef zdepth
#undef yheight
#undef xwidth
#undef priority
#undef material_string
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

/* User declarations for component 'channel_13_analyzer_1_array_crystal_array_8' [632]. */
#define mccompcurname  channel_13_analyzer_1_array_crystal_array_8
#define mccompcurtype  Union_box
#define mccompcurindex 632
#define loop_index mccchannel_13_analyzer_1_array_crystal_array_8_loop_index
#define this_box_volume mccchannel_13_analyzer_1_array_crystal_array_8_this_box_volume
#define global_geometry_element mccchannel_13_analyzer_1_array_crystal_array_8_global_geometry_element
#define this_box_storage mccchannel_13_analyzer_1_array_crystal_array_8_this_box_storage
#define material_string mccchannel_13_analyzer_1_array_crystal_array_8_material_string
#define priority mccchannel_13_analyzer_1_array_crystal_array_8_priority
#define xwidth mccchannel_13_analyzer_1_array_crystal_array_8_xwidth
#define yheight mccchannel_13_analyzer_1_array_crystal_array_8_yheight
#define zdepth mccchannel_13_analyzer_1_array_crystal_array_8_zdepth
#define xwidth2 mccchannel_13_analyzer_1_array_crystal_array_8_xwidth2
#define yheight2 mccchannel_13_analyzer_1_array_crystal_array_8_yheight2
#define visualize mccchannel_13_analyzer_1_array_crystal_array_8_visualize
#define target_index mccchannel_13_analyzer_1_array_crystal_array_8_target_index
#define target_x mccchannel_13_analyzer_1_array_crystal_array_8_target_x
#define target_y mccchannel_13_analyzer_1_array_crystal_array_8_target_y
#define target_z mccchannel_13_analyzer_1_array_crystal_array_8_target_z
#define focus_aw mccchannel_13_analyzer_1_array_crystal_array_8_focus_aw
#define focus_ah mccchannel_13_analyzer_1_array_crystal_array_8_focus_ah
#define focus_xw mccchannel_13_analyzer_1_array_crystal_array_8_focus_xw
#define focus_xh mccchannel_13_analyzer_1_array_crystal_array_8_focus_xh
#define focus_r mccchannel_13_analyzer_1_array_crystal_array_8_focus_r
#define p_interact mccchannel_13_analyzer_1_array_crystal_array_8_p_interact
#define mask_string mccchannel_13_analyzer_1_array_crystal_array_8_mask_string
#define mask_setting mccchannel_13_analyzer_1_array_crystal_array_8_mask_setting
#define number_of_activations mccchannel_13_analyzer_1_array_crystal_array_8_number_of_activations
#line 204 "Union_box.comp"
// Needed for transport to the main component
struct global_geometry_element_struct global_geometry_element;

#ifndef ANY_GEOMETRY_DETECTOR_DECLARE
    #define ANY_GEOMETRY_DETECTOR_DECLARE dummy
	//struct pointer_to_global_geometry_list global_geometry_list = {0,NULL};
#endif

int loop_index,found_geometries;

double x_component;
double y_component;
double z_component;

struct Volume_struct this_box_volume;
struct box_storage this_box_storage;

#line 67799 "MACS_sample_kidney_box.c"
#undef number_of_activations
#undef mask_setting
#undef mask_string
#undef p_interact
#undef focus_r
#undef focus_xh
#undef focus_xw
#undef focus_ah
#undef focus_aw
#undef target_z
#undef target_y
#undef target_x
#undef target_index
#undef visualize
#undef yheight2
#undef xwidth2
#undef zdepth
#undef yheight
#undef xwidth
#undef priority
#undef material_string
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

/* User declarations for component 'channel_13_analyzer_2_center' [633]. */
#define mccompcurname  channel_13_analyzer_2_center
#define mccompcurtype  Arm
#define mccompcurindex 633
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

/* User declarations for component 'channel_13_analyzer_2_rotated' [634]. */
#define mccompcurname  channel_13_analyzer_2_rotated
#define mccompcurtype  Arm
#define mccompcurindex 634
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

/* User declarations for component 'channel_13_analyzer_2_array_crystal_array_0' [635]. */
#define mccompcurname  channel_13_analyzer_2_array_crystal_array_0
#define mccompcurtype  Union_box
#define mccompcurindex 635
#define loop_index mccchannel_13_analyzer_2_array_crystal_array_0_loop_index
#define this_box_volume mccchannel_13_analyzer_2_array_crystal_array_0_this_box_volume
#define global_geometry_element mccchannel_13_analyzer_2_array_crystal_array_0_global_geometry_element
#define this_box_storage mccchannel_13_analyzer_2_array_crystal_array_0_this_box_storage
#define material_string mccchannel_13_analyzer_2_array_crystal_array_0_material_string
#define priority mccchannel_13_analyzer_2_array_crystal_array_0_priority
#define xwidth mccchannel_13_analyzer_2_array_crystal_array_0_xwidth
#define yheight mccchannel_13_analyzer_2_array_crystal_array_0_yheight
#define zdepth mccchannel_13_analyzer_2_array_crystal_array_0_zdepth
#define xwidth2 mccchannel_13_analyzer_2_array_crystal_array_0_xwidth2
#define yheight2 mccchannel_13_analyzer_2_array_crystal_array_0_yheight2
#define visualize mccchannel_13_analyzer_2_array_crystal_array_0_visualize
#define target_index mccchannel_13_analyzer_2_array_crystal_array_0_target_index
#define target_x mccchannel_13_analyzer_2_array_crystal_array_0_target_x
#define target_y mccchannel_13_analyzer_2_array_crystal_array_0_target_y
#define target_z mccchannel_13_analyzer_2_array_crystal_array_0_target_z
#define focus_aw mccchannel_13_analyzer_2_array_crystal_array_0_focus_aw
#define focus_ah mccchannel_13_analyzer_2_array_crystal_array_0_focus_ah
#define focus_xw mccchannel_13_analyzer_2_array_crystal_array_0_focus_xw
#define focus_xh mccchannel_13_analyzer_2_array_crystal_array_0_focus_xh
#define focus_r mccchannel_13_analyzer_2_array_crystal_array_0_focus_r
#define p_interact mccchannel_13_analyzer_2_array_crystal_array_0_p_interact
#define mask_string mccchannel_13_analyzer_2_array_crystal_array_0_mask_string
#define mask_setting mccchannel_13_analyzer_2_array_crystal_array_0_mask_setting
#define number_of_activations mccchannel_13_analyzer_2_array_crystal_array_0_number_of_activations
#line 204 "Union_box.comp"
// Needed for transport to the main component
struct global_geometry_element_struct global_geometry_element;

#ifndef ANY_GEOMETRY_DETECTOR_DECLARE
    #define ANY_GEOMETRY_DETECTOR_DECLARE dummy
	//struct pointer_to_global_geometry_list global_geometry_list = {0,NULL};
#endif

int loop_index,found_geometries;

double x_component;
double y_component;
double z_component;

struct Volume_struct this_box_volume;
struct box_storage this_box_storage;

#line 67892 "MACS_sample_kidney_box.c"
#undef number_of_activations
#undef mask_setting
#undef mask_string
#undef p_interact
#undef focus_r
#undef focus_xh
#undef focus_xw
#undef focus_ah
#undef focus_aw
#undef target_z
#undef target_y
#undef target_x
#undef target_index
#undef visualize
#undef yheight2
#undef xwidth2
#undef zdepth
#undef yheight
#undef xwidth
#undef priority
#undef material_string
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

/* User declarations for component 'channel_13_analyzer_2_array_crystal_array_1' [636]. */
#define mccompcurname  channel_13_analyzer_2_array_crystal_array_1
#define mccompcurtype  Union_box
#define mccompcurindex 636
#define loop_index mccchannel_13_analyzer_2_array_crystal_array_1_loop_index
#define this_box_volume mccchannel_13_analyzer_2_array_crystal_array_1_this_box_volume
#define global_geometry_element mccchannel_13_analyzer_2_array_crystal_array_1_global_geometry_element
#define this_box_storage mccchannel_13_analyzer_2_array_crystal_array_1_this_box_storage
#define material_string mccchannel_13_analyzer_2_array_crystal_array_1_material_string
#define priority mccchannel_13_analyzer_2_array_crystal_array_1_priority
#define xwidth mccchannel_13_analyzer_2_array_crystal_array_1_xwidth
#define yheight mccchannel_13_analyzer_2_array_crystal_array_1_yheight
#define zdepth mccchannel_13_analyzer_2_array_crystal_array_1_zdepth
#define xwidth2 mccchannel_13_analyzer_2_array_crystal_array_1_xwidth2
#define yheight2 mccchannel_13_analyzer_2_array_crystal_array_1_yheight2
#define visualize mccchannel_13_analyzer_2_array_crystal_array_1_visualize
#define target_index mccchannel_13_analyzer_2_array_crystal_array_1_target_index
#define target_x mccchannel_13_analyzer_2_array_crystal_array_1_target_x
#define target_y mccchannel_13_analyzer_2_array_crystal_array_1_target_y
#define target_z mccchannel_13_analyzer_2_array_crystal_array_1_target_z
#define focus_aw mccchannel_13_analyzer_2_array_crystal_array_1_focus_aw
#define focus_ah mccchannel_13_analyzer_2_array_crystal_array_1_focus_ah
#define focus_xw mccchannel_13_analyzer_2_array_crystal_array_1_focus_xw
#define focus_xh mccchannel_13_analyzer_2_array_crystal_array_1_focus_xh
#define focus_r mccchannel_13_analyzer_2_array_crystal_array_1_focus_r
#define p_interact mccchannel_13_analyzer_2_array_crystal_array_1_p_interact
#define mask_string mccchannel_13_analyzer_2_array_crystal_array_1_mask_string
#define mask_setting mccchannel_13_analyzer_2_array_crystal_array_1_mask_setting
#define number_of_activations mccchannel_13_analyzer_2_array_crystal_array_1_number_of_activations
#line 204 "Union_box.comp"
// Needed for transport to the main component
struct global_geometry_element_struct global_geometry_element;

#ifndef ANY_GEOMETRY_DETECTOR_DECLARE
    #define ANY_GEOMETRY_DETECTOR_DECLARE dummy
	//struct pointer_to_global_geometry_list global_geometry_list = {0,NULL};
#endif

int loop_index,found_geometries;

double x_component;
double y_component;
double z_component;

struct Volume_struct this_box_volume;
struct box_storage this_box_storage;

#line 67969 "MACS_sample_kidney_box.c"
#undef number_of_activations
#undef mask_setting
#undef mask_string
#undef p_interact
#undef focus_r
#undef focus_xh
#undef focus_xw
#undef focus_ah
#undef focus_aw
#undef target_z
#undef target_y
#undef target_x
#undef target_index
#undef visualize
#undef yheight2
#undef xwidth2
#undef zdepth
#undef yheight
#undef xwidth
#undef priority
#undef material_string
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

/* User declarations for component 'channel_13_analyzer_2_array_crystal_array_2' [637]. */
#define mccompcurname  channel_13_analyzer_2_array_crystal_array_2
#define mccompcurtype  Union_box
#define mccompcurindex 637
#define loop_index mccchannel_13_analyzer_2_array_crystal_array_2_loop_index
#define this_box_volume mccchannel_13_analyzer_2_array_crystal_array_2_this_box_volume
#define global_geometry_element mccchannel_13_analyzer_2_array_crystal_array_2_global_geometry_element
#define this_box_storage mccchannel_13_analyzer_2_array_crystal_array_2_this_box_storage
#define material_string mccchannel_13_analyzer_2_array_crystal_array_2_material_string
#define priority mccchannel_13_analyzer_2_array_crystal_array_2_priority
#define xwidth mccchannel_13_analyzer_2_array_crystal_array_2_xwidth
#define yheight mccchannel_13_analyzer_2_array_crystal_array_2_yheight
#define zdepth mccchannel_13_analyzer_2_array_crystal_array_2_zdepth
#define xwidth2 mccchannel_13_analyzer_2_array_crystal_array_2_xwidth2
#define yheight2 mccchannel_13_analyzer_2_array_crystal_array_2_yheight2
#define visualize mccchannel_13_analyzer_2_array_crystal_array_2_visualize
#define target_index mccchannel_13_analyzer_2_array_crystal_array_2_target_index
#define target_x mccchannel_13_analyzer_2_array_crystal_array_2_target_x
#define target_y mccchannel_13_analyzer_2_array_crystal_array_2_target_y
#define target_z mccchannel_13_analyzer_2_array_crystal_array_2_target_z
#define focus_aw mccchannel_13_analyzer_2_array_crystal_array_2_focus_aw
#define focus_ah mccchannel_13_analyzer_2_array_crystal_array_2_focus_ah
#define focus_xw mccchannel_13_analyzer_2_array_crystal_array_2_focus_xw
#define focus_xh mccchannel_13_analyzer_2_array_crystal_array_2_focus_xh
#define focus_r mccchannel_13_analyzer_2_array_crystal_array_2_focus_r
#define p_interact mccchannel_13_analyzer_2_array_crystal_array_2_p_interact
#define mask_string mccchannel_13_analyzer_2_array_crystal_array_2_mask_string
#define mask_setting mccchannel_13_analyzer_2_array_crystal_array_2_mask_setting
#define number_of_activations mccchannel_13_analyzer_2_array_crystal_array_2_number_of_activations
#line 204 "Union_box.comp"
// Needed for transport to the main component
struct global_geometry_element_struct global_geometry_element;

#ifndef ANY_GEOMETRY_DETECTOR_DECLARE
    #define ANY_GEOMETRY_DETECTOR_DECLARE dummy
	//struct pointer_to_global_geometry_list global_geometry_list = {0,NULL};
#endif

int loop_index,found_geometries;

double x_component;
double y_component;
double z_component;

struct Volume_struct this_box_volume;
struct box_storage this_box_storage;

#line 68046 "MACS_sample_kidney_box.c"
#undef number_of_activations
#undef mask_setting
#undef mask_string
#undef p_interact
#undef focus_r
#undef focus_xh
#undef focus_xw
#undef focus_ah
#undef focus_aw
#undef target_z
#undef target_y
#undef target_x
#undef target_index
#undef visualize
#undef yheight2
#undef xwidth2
#undef zdepth
#undef yheight
#undef xwidth
#undef priority
#undef material_string
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

/* User declarations for component 'channel_13_analyzer_2_array_crystal_array_3' [638]. */
#define mccompcurname  channel_13_analyzer_2_array_crystal_array_3
#define mccompcurtype  Union_box
#define mccompcurindex 638
#define loop_index mccchannel_13_analyzer_2_array_crystal_array_3_loop_index
#define this_box_volume mccchannel_13_analyzer_2_array_crystal_array_3_this_box_volume
#define global_geometry_element mccchannel_13_analyzer_2_array_crystal_array_3_global_geometry_element
#define this_box_storage mccchannel_13_analyzer_2_array_crystal_array_3_this_box_storage
#define material_string mccchannel_13_analyzer_2_array_crystal_array_3_material_string
#define priority mccchannel_13_analyzer_2_array_crystal_array_3_priority
#define xwidth mccchannel_13_analyzer_2_array_crystal_array_3_xwidth
#define yheight mccchannel_13_analyzer_2_array_crystal_array_3_yheight
#define zdepth mccchannel_13_analyzer_2_array_crystal_array_3_zdepth
#define xwidth2 mccchannel_13_analyzer_2_array_crystal_array_3_xwidth2
#define yheight2 mccchannel_13_analyzer_2_array_crystal_array_3_yheight2
#define visualize mccchannel_13_analyzer_2_array_crystal_array_3_visualize
#define target_index mccchannel_13_analyzer_2_array_crystal_array_3_target_index
#define target_x mccchannel_13_analyzer_2_array_crystal_array_3_target_x
#define target_y mccchannel_13_analyzer_2_array_crystal_array_3_target_y
#define target_z mccchannel_13_analyzer_2_array_crystal_array_3_target_z
#define focus_aw mccchannel_13_analyzer_2_array_crystal_array_3_focus_aw
#define focus_ah mccchannel_13_analyzer_2_array_crystal_array_3_focus_ah
#define focus_xw mccchannel_13_analyzer_2_array_crystal_array_3_focus_xw
#define focus_xh mccchannel_13_analyzer_2_array_crystal_array_3_focus_xh
#define focus_r mccchannel_13_analyzer_2_array_crystal_array_3_focus_r
#define p_interact mccchannel_13_analyzer_2_array_crystal_array_3_p_interact
#define mask_string mccchannel_13_analyzer_2_array_crystal_array_3_mask_string
#define mask_setting mccchannel_13_analyzer_2_array_crystal_array_3_mask_setting
#define number_of_activations mccchannel_13_analyzer_2_array_crystal_array_3_number_of_activations
#line 204 "Union_box.comp"
// Needed for transport to the main component
struct global_geometry_element_struct global_geometry_element;

#ifndef ANY_GEOMETRY_DETECTOR_DECLARE
    #define ANY_GEOMETRY_DETECTOR_DECLARE dummy
	//struct pointer_to_global_geometry_list global_geometry_list = {0,NULL};
#endif

int loop_index,found_geometries;

double x_component;
double y_component;
double z_component;

struct Volume_struct this_box_volume;
struct box_storage this_box_storage;

#line 68123 "MACS_sample_kidney_box.c"
#undef number_of_activations
#undef mask_setting
#undef mask_string
#undef p_interact
#undef focus_r
#undef focus_xh
#undef focus_xw
#undef focus_ah
#undef focus_aw
#undef target_z
#undef target_y
#undef target_x
#undef target_index
#undef visualize
#undef yheight2
#undef xwidth2
#undef zdepth
#undef yheight
#undef xwidth
#undef priority
#undef material_string
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

/* User declarations for component 'channel_13_analyzer_2_array_crystal_array_4' [639]. */
#define mccompcurname  channel_13_analyzer_2_array_crystal_array_4
#define mccompcurtype  Union_box
#define mccompcurindex 639
#define loop_index mccchannel_13_analyzer_2_array_crystal_array_4_loop_index
#define this_box_volume mccchannel_13_analyzer_2_array_crystal_array_4_this_box_volume
#define global_geometry_element mccchannel_13_analyzer_2_array_crystal_array_4_global_geometry_element
#define this_box_storage mccchannel_13_analyzer_2_array_crystal_array_4_this_box_storage
#define material_string mccchannel_13_analyzer_2_array_crystal_array_4_material_string
#define priority mccchannel_13_analyzer_2_array_crystal_array_4_priority
#define xwidth mccchannel_13_analyzer_2_array_crystal_array_4_xwidth
#define yheight mccchannel_13_analyzer_2_array_crystal_array_4_yheight
#define zdepth mccchannel_13_analyzer_2_array_crystal_array_4_zdepth
#define xwidth2 mccchannel_13_analyzer_2_array_crystal_array_4_xwidth2
#define yheight2 mccchannel_13_analyzer_2_array_crystal_array_4_yheight2
#define visualize mccchannel_13_analyzer_2_array_crystal_array_4_visualize
#define target_index mccchannel_13_analyzer_2_array_crystal_array_4_target_index
#define target_x mccchannel_13_analyzer_2_array_crystal_array_4_target_x
#define target_y mccchannel_13_analyzer_2_array_crystal_array_4_target_y
#define target_z mccchannel_13_analyzer_2_array_crystal_array_4_target_z
#define focus_aw mccchannel_13_analyzer_2_array_crystal_array_4_focus_aw
#define focus_ah mccchannel_13_analyzer_2_array_crystal_array_4_focus_ah
#define focus_xw mccchannel_13_analyzer_2_array_crystal_array_4_focus_xw
#define focus_xh mccchannel_13_analyzer_2_array_crystal_array_4_focus_xh
#define focus_r mccchannel_13_analyzer_2_array_crystal_array_4_focus_r
#define p_interact mccchannel_13_analyzer_2_array_crystal_array_4_p_interact
#define mask_string mccchannel_13_analyzer_2_array_crystal_array_4_mask_string
#define mask_setting mccchannel_13_analyzer_2_array_crystal_array_4_mask_setting
#define number_of_activations mccchannel_13_analyzer_2_array_crystal_array_4_number_of_activations
#line 204 "Union_box.comp"
// Needed for transport to the main component
struct global_geometry_element_struct global_geometry_element;

#ifndef ANY_GEOMETRY_DETECTOR_DECLARE
    #define ANY_GEOMETRY_DETECTOR_DECLARE dummy
	//struct pointer_to_global_geometry_list global_geometry_list = {0,NULL};
#endif

int loop_index,found_geometries;

double x_component;
double y_component;
double z_component;

struct Volume_struct this_box_volume;
struct box_storage this_box_storage;

#line 68200 "MACS_sample_kidney_box.c"
#undef number_of_activations
#undef mask_setting
#undef mask_string
#undef p_interact
#undef focus_r
#undef focus_xh
#undef focus_xw
#undef focus_ah
#undef focus_aw
#undef target_z
#undef target_y
#undef target_x
#undef target_index
#undef visualize
#undef yheight2
#undef xwidth2
#undef zdepth
#undef yheight
#undef xwidth
#undef priority
#undef material_string
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

/* User declarations for component 'channel_13_analyzer_2_array_crystal_array_5' [640]. */
#define mccompcurname  channel_13_analyzer_2_array_crystal_array_5
#define mccompcurtype  Union_box
#define mccompcurindex 640
#define loop_index mccchannel_13_analyzer_2_array_crystal_array_5_loop_index
#define this_box_volume mccchannel_13_analyzer_2_array_crystal_array_5_this_box_volume
#define global_geometry_element mccchannel_13_analyzer_2_array_crystal_array_5_global_geometry_element
#define this_box_storage mccchannel_13_analyzer_2_array_crystal_array_5_this_box_storage
#define material_string mccchannel_13_analyzer_2_array_crystal_array_5_material_string
#define priority mccchannel_13_analyzer_2_array_crystal_array_5_priority
#define xwidth mccchannel_13_analyzer_2_array_crystal_array_5_xwidth
#define yheight mccchannel_13_analyzer_2_array_crystal_array_5_yheight
#define zdepth mccchannel_13_analyzer_2_array_crystal_array_5_zdepth
#define xwidth2 mccchannel_13_analyzer_2_array_crystal_array_5_xwidth2
#define yheight2 mccchannel_13_analyzer_2_array_crystal_array_5_yheight2
#define visualize mccchannel_13_analyzer_2_array_crystal_array_5_visualize
#define target_index mccchannel_13_analyzer_2_array_crystal_array_5_target_index
#define target_x mccchannel_13_analyzer_2_array_crystal_array_5_target_x
#define target_y mccchannel_13_analyzer_2_array_crystal_array_5_target_y
#define target_z mccchannel_13_analyzer_2_array_crystal_array_5_target_z
#define focus_aw mccchannel_13_analyzer_2_array_crystal_array_5_focus_aw
#define focus_ah mccchannel_13_analyzer_2_array_crystal_array_5_focus_ah
#define focus_xw mccchannel_13_analyzer_2_array_crystal_array_5_focus_xw
#define focus_xh mccchannel_13_analyzer_2_array_crystal_array_5_focus_xh
#define focus_r mccchannel_13_analyzer_2_array_crystal_array_5_focus_r
#define p_interact mccchannel_13_analyzer_2_array_crystal_array_5_p_interact
#define mask_string mccchannel_13_analyzer_2_array_crystal_array_5_mask_string
#define mask_setting mccchannel_13_analyzer_2_array_crystal_array_5_mask_setting
#define number_of_activations mccchannel_13_analyzer_2_array_crystal_array_5_number_of_activations
#line 204 "Union_box.comp"
// Needed for transport to the main component
struct global_geometry_element_struct global_geometry_element;

#ifndef ANY_GEOMETRY_DETECTOR_DECLARE
    #define ANY_GEOMETRY_DETECTOR_DECLARE dummy
	//struct pointer_to_global_geometry_list global_geometry_list = {0,NULL};
#endif

int loop_index,found_geometries;

double x_component;
double y_component;
double z_component;

struct Volume_struct this_box_volume;
struct box_storage this_box_storage;

#line 68277 "MACS_sample_kidney_box.c"
#undef number_of_activations
#undef mask_setting
#undef mask_string
#undef p_interact
#undef focus_r
#undef focus_xh
#undef focus_xw
#undef focus_ah
#undef focus_aw
#undef target_z
#undef target_y
#undef target_x
#undef target_index
#undef visualize
#undef yheight2
#undef xwidth2
#undef zdepth
#undef yheight
#undef xwidth
#undef priority
#undef material_string
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

/* User declarations for component 'channel_13_analyzer_2_array_crystal_array_6' [641]. */
#define mccompcurname  channel_13_analyzer_2_array_crystal_array_6
#define mccompcurtype  Union_box
#define mccompcurindex 641
#define loop_index mccchannel_13_analyzer_2_array_crystal_array_6_loop_index
#define this_box_volume mccchannel_13_analyzer_2_array_crystal_array_6_this_box_volume
#define global_geometry_element mccchannel_13_analyzer_2_array_crystal_array_6_global_geometry_element
#define this_box_storage mccchannel_13_analyzer_2_array_crystal_array_6_this_box_storage
#define material_string mccchannel_13_analyzer_2_array_crystal_array_6_material_string
#define priority mccchannel_13_analyzer_2_array_crystal_array_6_priority
#define xwidth mccchannel_13_analyzer_2_array_crystal_array_6_xwidth
#define yheight mccchannel_13_analyzer_2_array_crystal_array_6_yheight
#define zdepth mccchannel_13_analyzer_2_array_crystal_array_6_zdepth
#define xwidth2 mccchannel_13_analyzer_2_array_crystal_array_6_xwidth2
#define yheight2 mccchannel_13_analyzer_2_array_crystal_array_6_yheight2
#define visualize mccchannel_13_analyzer_2_array_crystal_array_6_visualize
#define target_index mccchannel_13_analyzer_2_array_crystal_array_6_target_index
#define target_x mccchannel_13_analyzer_2_array_crystal_array_6_target_x
#define target_y mccchannel_13_analyzer_2_array_crystal_array_6_target_y
#define target_z mccchannel_13_analyzer_2_array_crystal_array_6_target_z
#define focus_aw mccchannel_13_analyzer_2_array_crystal_array_6_focus_aw
#define focus_ah mccchannel_13_analyzer_2_array_crystal_array_6_focus_ah
#define focus_xw mccchannel_13_analyzer_2_array_crystal_array_6_focus_xw
#define focus_xh mccchannel_13_analyzer_2_array_crystal_array_6_focus_xh
#define focus_r mccchannel_13_analyzer_2_array_crystal_array_6_focus_r
#define p_interact mccchannel_13_analyzer_2_array_crystal_array_6_p_interact
#define mask_string mccchannel_13_analyzer_2_array_crystal_array_6_mask_string
#define mask_setting mccchannel_13_analyzer_2_array_crystal_array_6_mask_setting
#define number_of_activations mccchannel_13_analyzer_2_array_crystal_array_6_number_of_activations
#line 204 "Union_box.comp"
// Needed for transport to the main component
struct global_geometry_element_struct global_geometry_element;

#ifndef ANY_GEOMETRY_DETECTOR_DECLARE
    #define ANY_GEOMETRY_DETECTOR_DECLARE dummy
	//struct pointer_to_global_geometry_list global_geometry_list = {0,NULL};
#endif

int loop_index,found_geometries;

double x_component;
double y_component;
double z_component;

struct Volume_struct this_box_volume;
struct box_storage this_box_storage;

#line 68354 "MACS_sample_kidney_box.c"
#undef number_of_activations
#undef mask_setting
#undef mask_string
#undef p_interact
#undef focus_r
#undef focus_xh
#undef focus_xw
#undef focus_ah
#undef focus_aw
#undef target_z
#undef target_y
#undef target_x
#undef target_index
#undef visualize
#undef yheight2
#undef xwidth2
#undef zdepth
#undef yheight
#undef xwidth
#undef priority
#undef material_string
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

/* User declarations for component 'channel_13_analyzer_2_array_crystal_array_7' [642]. */
#define mccompcurname  channel_13_analyzer_2_array_crystal_array_7
#define mccompcurtype  Union_box
#define mccompcurindex 642
#define loop_index mccchannel_13_analyzer_2_array_crystal_array_7_loop_index
#define this_box_volume mccchannel_13_analyzer_2_array_crystal_array_7_this_box_volume
#define global_geometry_element mccchannel_13_analyzer_2_array_crystal_array_7_global_geometry_element
#define this_box_storage mccchannel_13_analyzer_2_array_crystal_array_7_this_box_storage
#define material_string mccchannel_13_analyzer_2_array_crystal_array_7_material_string
#define priority mccchannel_13_analyzer_2_array_crystal_array_7_priority
#define xwidth mccchannel_13_analyzer_2_array_crystal_array_7_xwidth
#define yheight mccchannel_13_analyzer_2_array_crystal_array_7_yheight
#define zdepth mccchannel_13_analyzer_2_array_crystal_array_7_zdepth
#define xwidth2 mccchannel_13_analyzer_2_array_crystal_array_7_xwidth2
#define yheight2 mccchannel_13_analyzer_2_array_crystal_array_7_yheight2
#define visualize mccchannel_13_analyzer_2_array_crystal_array_7_visualize
#define target_index mccchannel_13_analyzer_2_array_crystal_array_7_target_index
#define target_x mccchannel_13_analyzer_2_array_crystal_array_7_target_x
#define target_y mccchannel_13_analyzer_2_array_crystal_array_7_target_y
#define target_z mccchannel_13_analyzer_2_array_crystal_array_7_target_z
#define focus_aw mccchannel_13_analyzer_2_array_crystal_array_7_focus_aw
#define focus_ah mccchannel_13_analyzer_2_array_crystal_array_7_focus_ah
#define focus_xw mccchannel_13_analyzer_2_array_crystal_array_7_focus_xw
#define focus_xh mccchannel_13_analyzer_2_array_crystal_array_7_focus_xh
#define focus_r mccchannel_13_analyzer_2_array_crystal_array_7_focus_r
#define p_interact mccchannel_13_analyzer_2_array_crystal_array_7_p_interact
#define mask_string mccchannel_13_analyzer_2_array_crystal_array_7_mask_string
#define mask_setting mccchannel_13_analyzer_2_array_crystal_array_7_mask_setting
#define number_of_activations mccchannel_13_analyzer_2_array_crystal_array_7_number_of_activations
#line 204 "Union_box.comp"
// Needed for transport to the main component
struct global_geometry_element_struct global_geometry_element;

#ifndef ANY_GEOMETRY_DETECTOR_DECLARE
    #define ANY_GEOMETRY_DETECTOR_DECLARE dummy
	//struct pointer_to_global_geometry_list global_geometry_list = {0,NULL};
#endif

int loop_index,found_geometries;

double x_component;
double y_component;
double z_component;

struct Volume_struct this_box_volume;
struct box_storage this_box_storage;

#line 68431 "MACS_sample_kidney_box.c"
#undef number_of_activations
#undef mask_setting
#undef mask_string
#undef p_interact
#undef focus_r
#undef focus_xh
#undef focus_xw
#undef focus_ah
#undef focus_aw
#undef target_z
#undef target_y
#undef target_x
#undef target_index
#undef visualize
#undef yheight2
#undef xwidth2
#undef zdepth
#undef yheight
#undef xwidth
#undef priority
#undef material_string
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

/* User declarations for component 'channel_13_analyzer_2_array_crystal_array_8' [643]. */
#define mccompcurname  channel_13_analyzer_2_array_crystal_array_8
#define mccompcurtype  Union_box
#define mccompcurindex 643
#define loop_index mccchannel_13_analyzer_2_array_crystal_array_8_loop_index
#define this_box_volume mccchannel_13_analyzer_2_array_crystal_array_8_this_box_volume
#define global_geometry_element mccchannel_13_analyzer_2_array_crystal_array_8_global_geometry_element
#define this_box_storage mccchannel_13_analyzer_2_array_crystal_array_8_this_box_storage
#define material_string mccchannel_13_analyzer_2_array_crystal_array_8_material_string
#define priority mccchannel_13_analyzer_2_array_crystal_array_8_priority
#define xwidth mccchannel_13_analyzer_2_array_crystal_array_8_xwidth
#define yheight mccchannel_13_analyzer_2_array_crystal_array_8_yheight
#define zdepth mccchannel_13_analyzer_2_array_crystal_array_8_zdepth
#define xwidth2 mccchannel_13_analyzer_2_array_crystal_array_8_xwidth2
#define yheight2 mccchannel_13_analyzer_2_array_crystal_array_8_yheight2
#define visualize mccchannel_13_analyzer_2_array_crystal_array_8_visualize
#define target_index mccchannel_13_analyzer_2_array_crystal_array_8_target_index
#define target_x mccchannel_13_analyzer_2_array_crystal_array_8_target_x
#define target_y mccchannel_13_analyzer_2_array_crystal_array_8_target_y
#define target_z mccchannel_13_analyzer_2_array_crystal_array_8_target_z
#define focus_aw mccchannel_13_analyzer_2_array_crystal_array_8_focus_aw
#define focus_ah mccchannel_13_analyzer_2_array_crystal_array_8_focus_ah
#define focus_xw mccchannel_13_analyzer_2_array_crystal_array_8_focus_xw
#define focus_xh mccchannel_13_analyzer_2_array_crystal_array_8_focus_xh
#define focus_r mccchannel_13_analyzer_2_array_crystal_array_8_focus_r
#define p_interact mccchannel_13_analyzer_2_array_crystal_array_8_p_interact
#define mask_string mccchannel_13_analyzer_2_array_crystal_array_8_mask_string
#define mask_setting mccchannel_13_analyzer_2_array_crystal_array_8_mask_setting
#define number_of_activations mccchannel_13_analyzer_2_array_crystal_array_8_number_of_activations
#line 204 "Union_box.comp"
// Needed for transport to the main component
struct global_geometry_element_struct global_geometry_element;

#ifndef ANY_GEOMETRY_DETECTOR_DECLARE
    #define ANY_GEOMETRY_DETECTOR_DECLARE dummy
	//struct pointer_to_global_geometry_list global_geometry_list = {0,NULL};
#endif

int loop_index,found_geometries;

double x_component;
double y_component;
double z_component;

struct Volume_struct this_box_volume;
struct box_storage this_box_storage;

#line 68508 "MACS_sample_kidney_box.c"
#undef number_of_activations
#undef mask_setting
#undef mask_string
#undef p_interact
#undef focus_r
#undef focus_xh
#undef focus_xw
#undef focus_ah
#undef focus_aw
#undef target_z
#undef target_y
#undef target_x
#undef target_index
#undef visualize
#undef yheight2
#undef xwidth2
#undef zdepth
#undef yheight
#undef xwidth
#undef priority
#undef material_string
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

/* User declarations for component 'channel_13_cave2_cyl1' [644]. */
#define mccompcurname  channel_13_cave2_cyl1
#define mccompcurtype  Union_cylinder
#define mccompcurindex 644
#define loop_index mccchannel_13_cave2_cyl1_loop_index
#define this_cylinder_volume mccchannel_13_cave2_cyl1_this_cylinder_volume
#define global_geometry_element mccchannel_13_cave2_cyl1_global_geometry_element
#define this_cylinder_storage mccchannel_13_cave2_cyl1_this_cylinder_storage
#define material_string mccchannel_13_cave2_cyl1_material_string
#define priority mccchannel_13_cave2_cyl1_priority
#define radius mccchannel_13_cave2_cyl1_radius
#define yheight mccchannel_13_cave2_cyl1_yheight
#define visualize mccchannel_13_cave2_cyl1_visualize
#define target_index mccchannel_13_cave2_cyl1_target_index
#define target_x mccchannel_13_cave2_cyl1_target_x
#define target_y mccchannel_13_cave2_cyl1_target_y
#define target_z mccchannel_13_cave2_cyl1_target_z
#define focus_aw mccchannel_13_cave2_cyl1_focus_aw
#define focus_ah mccchannel_13_cave2_cyl1_focus_ah
#define focus_xw mccchannel_13_cave2_cyl1_focus_xw
#define focus_xh mccchannel_13_cave2_cyl1_focus_xh
#define focus_r mccchannel_13_cave2_cyl1_focus_r
#define p_interact mccchannel_13_cave2_cyl1_p_interact
#define mask_string mccchannel_13_cave2_cyl1_mask_string
#define mask_setting mccchannel_13_cave2_cyl1_mask_setting
#define number_of_activations mccchannel_13_cave2_cyl1_number_of_activations
#line 167 "Union_cylinder.comp"
// Needed for transport to the main component
struct global_geometry_element_struct global_geometry_element;

#ifndef ANY_GEOMETRY_DETECTOR_DECLARE
    #define ANY_GEOMETRY_DETECTOR_DECLARE dummy
	//struct pointer_to_global_geometry_list global_geometry_list = {0,NULL};
#endif

int dummy;
int loop_index,found_geometries;
int loop_2_index;
int material_index;

struct Volume_struct this_cylinder_volume;
struct cylinder_storage this_cylinder_storage;
#line 68580 "MACS_sample_kidney_box.c"
#undef number_of_activations
#undef mask_setting
#undef mask_string
#undef p_interact
#undef focus_r
#undef focus_xh
#undef focus_xw
#undef focus_ah
#undef focus_aw
#undef target_z
#undef target_y
#undef target_x
#undef target_index
#undef visualize
#undef yheight
#undef radius
#undef priority
#undef material_string
#undef this_cylinder_storage
#undef global_geometry_element
#undef this_cylinder_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

/* User declarations for component 'channel_13_cave2_box1' [645]. */
#define mccompcurname  channel_13_cave2_box1
#define mccompcurtype  Union_box
#define mccompcurindex 645
#define loop_index mccchannel_13_cave2_box1_loop_index
#define this_box_volume mccchannel_13_cave2_box1_this_box_volume
#define global_geometry_element mccchannel_13_cave2_box1_global_geometry_element
#define this_box_storage mccchannel_13_cave2_box1_this_box_storage
#define material_string mccchannel_13_cave2_box1_material_string
#define priority mccchannel_13_cave2_box1_priority
#define xwidth mccchannel_13_cave2_box1_xwidth
#define yheight mccchannel_13_cave2_box1_yheight
#define zdepth mccchannel_13_cave2_box1_zdepth
#define xwidth2 mccchannel_13_cave2_box1_xwidth2
#define yheight2 mccchannel_13_cave2_box1_yheight2
#define visualize mccchannel_13_cave2_box1_visualize
#define target_index mccchannel_13_cave2_box1_target_index
#define target_x mccchannel_13_cave2_box1_target_x
#define target_y mccchannel_13_cave2_box1_target_y
#define target_z mccchannel_13_cave2_box1_target_z
#define focus_aw mccchannel_13_cave2_box1_focus_aw
#define focus_ah mccchannel_13_cave2_box1_focus_ah
#define focus_xw mccchannel_13_cave2_box1_focus_xw
#define focus_xh mccchannel_13_cave2_box1_focus_xh
#define focus_r mccchannel_13_cave2_box1_focus_r
#define p_interact mccchannel_13_cave2_box1_p_interact
#define mask_string mccchannel_13_cave2_box1_mask_string
#define mask_setting mccchannel_13_cave2_box1_mask_setting
#define number_of_activations mccchannel_13_cave2_box1_number_of_activations
#line 204 "Union_box.comp"
// Needed for transport to the main component
struct global_geometry_element_struct global_geometry_element;

#ifndef ANY_GEOMETRY_DETECTOR_DECLARE
    #define ANY_GEOMETRY_DETECTOR_DECLARE dummy
	//struct pointer_to_global_geometry_list global_geometry_list = {0,NULL};
#endif

int loop_index,found_geometries;

double x_component;
double y_component;
double z_component;

struct Volume_struct this_box_volume;
struct box_storage this_box_storage;

#line 68654 "MACS_sample_kidney_box.c"
#undef number_of_activations
#undef mask_setting
#undef mask_string
#undef p_interact
#undef focus_r
#undef focus_xh
#undef focus_xw
#undef focus_ah
#undef focus_aw
#undef target_z
#undef target_y
#undef target_x
#undef target_index
#undef visualize
#undef yheight2
#undef xwidth2
#undef zdepth
#undef yheight
#undef xwidth
#undef priority
#undef material_string
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

/* User declarations for component 'channel_13_cave2_box2' [646]. */
#define mccompcurname  channel_13_cave2_box2
#define mccompcurtype  Union_box
#define mccompcurindex 646
#define loop_index mccchannel_13_cave2_box2_loop_index
#define this_box_volume mccchannel_13_cave2_box2_this_box_volume
#define global_geometry_element mccchannel_13_cave2_box2_global_geometry_element
#define this_box_storage mccchannel_13_cave2_box2_this_box_storage
#define material_string mccchannel_13_cave2_box2_material_string
#define priority mccchannel_13_cave2_box2_priority
#define xwidth mccchannel_13_cave2_box2_xwidth
#define yheight mccchannel_13_cave2_box2_yheight
#define zdepth mccchannel_13_cave2_box2_zdepth
#define xwidth2 mccchannel_13_cave2_box2_xwidth2
#define yheight2 mccchannel_13_cave2_box2_yheight2
#define visualize mccchannel_13_cave2_box2_visualize
#define target_index mccchannel_13_cave2_box2_target_index
#define target_x mccchannel_13_cave2_box2_target_x
#define target_y mccchannel_13_cave2_box2_target_y
#define target_z mccchannel_13_cave2_box2_target_z
#define focus_aw mccchannel_13_cave2_box2_focus_aw
#define focus_ah mccchannel_13_cave2_box2_focus_ah
#define focus_xw mccchannel_13_cave2_box2_focus_xw
#define focus_xh mccchannel_13_cave2_box2_focus_xh
#define focus_r mccchannel_13_cave2_box2_focus_r
#define p_interact mccchannel_13_cave2_box2_p_interact
#define mask_string mccchannel_13_cave2_box2_mask_string
#define mask_setting mccchannel_13_cave2_box2_mask_setting
#define number_of_activations mccchannel_13_cave2_box2_number_of_activations
#line 204 "Union_box.comp"
// Needed for transport to the main component
struct global_geometry_element_struct global_geometry_element;

#ifndef ANY_GEOMETRY_DETECTOR_DECLARE
    #define ANY_GEOMETRY_DETECTOR_DECLARE dummy
	//struct pointer_to_global_geometry_list global_geometry_list = {0,NULL};
#endif

int loop_index,found_geometries;

double x_component;
double y_component;
double z_component;

struct Volume_struct this_box_volume;
struct box_storage this_box_storage;

#line 68731 "MACS_sample_kidney_box.c"
#undef number_of_activations
#undef mask_setting
#undef mask_string
#undef p_interact
#undef focus_r
#undef focus_xh
#undef focus_xw
#undef focus_ah
#undef focus_aw
#undef target_z
#undef target_y
#undef target_x
#undef target_index
#undef visualize
#undef yheight2
#undef xwidth2
#undef zdepth
#undef yheight
#undef xwidth
#undef priority
#undef material_string
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

/* User declarations for component 'channel_13_cave2_box3' [647]. */
#define mccompcurname  channel_13_cave2_box3
#define mccompcurtype  Union_box
#define mccompcurindex 647
#define loop_index mccchannel_13_cave2_box3_loop_index
#define this_box_volume mccchannel_13_cave2_box3_this_box_volume
#define global_geometry_element mccchannel_13_cave2_box3_global_geometry_element
#define this_box_storage mccchannel_13_cave2_box3_this_box_storage
#define material_string mccchannel_13_cave2_box3_material_string
#define priority mccchannel_13_cave2_box3_priority
#define xwidth mccchannel_13_cave2_box3_xwidth
#define yheight mccchannel_13_cave2_box3_yheight
#define zdepth mccchannel_13_cave2_box3_zdepth
#define xwidth2 mccchannel_13_cave2_box3_xwidth2
#define yheight2 mccchannel_13_cave2_box3_yheight2
#define visualize mccchannel_13_cave2_box3_visualize
#define target_index mccchannel_13_cave2_box3_target_index
#define target_x mccchannel_13_cave2_box3_target_x
#define target_y mccchannel_13_cave2_box3_target_y
#define target_z mccchannel_13_cave2_box3_target_z
#define focus_aw mccchannel_13_cave2_box3_focus_aw
#define focus_ah mccchannel_13_cave2_box3_focus_ah
#define focus_xw mccchannel_13_cave2_box3_focus_xw
#define focus_xh mccchannel_13_cave2_box3_focus_xh
#define focus_r mccchannel_13_cave2_box3_focus_r
#define p_interact mccchannel_13_cave2_box3_p_interact
#define mask_string mccchannel_13_cave2_box3_mask_string
#define mask_setting mccchannel_13_cave2_box3_mask_setting
#define number_of_activations mccchannel_13_cave2_box3_number_of_activations
#line 204 "Union_box.comp"
// Needed for transport to the main component
struct global_geometry_element_struct global_geometry_element;

#ifndef ANY_GEOMETRY_DETECTOR_DECLARE
    #define ANY_GEOMETRY_DETECTOR_DECLARE dummy
	//struct pointer_to_global_geometry_list global_geometry_list = {0,NULL};
#endif

int loop_index,found_geometries;

double x_component;
double y_component;
double z_component;

struct Volume_struct this_box_volume;
struct box_storage this_box_storage;

#line 68808 "MACS_sample_kidney_box.c"
#undef number_of_activations
#undef mask_setting
#undef mask_string
#undef p_interact
#undef focus_r
#undef focus_xh
#undef focus_xw
#undef focus_ah
#undef focus_aw
#undef target_z
#undef target_y
#undef target_x
#undef target_index
#undef visualize
#undef yheight2
#undef xwidth2
#undef zdepth
#undef yheight
#undef xwidth
#undef priority
#undef material_string
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

/* User declarations for component 'inter_analyzer_colimator_center_13' [648]. */
#define mccompcurname  inter_analyzer_colimator_center_13
#define mccompcurtype  Arm
#define mccompcurindex 648
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

/* User declarations for component 'inter_analyzer_colimator_13_blade_0' [649]. */
#define mccompcurname  inter_analyzer_colimator_13_blade_0
#define mccompcurtype  Union_box
#define mccompcurindex 649
#define loop_index mccinter_analyzer_colimator_13_blade_0_loop_index
#define this_box_volume mccinter_analyzer_colimator_13_blade_0_this_box_volume
#define global_geometry_element mccinter_analyzer_colimator_13_blade_0_global_geometry_element
#define this_box_storage mccinter_analyzer_colimator_13_blade_0_this_box_storage
#define material_string mccinter_analyzer_colimator_13_blade_0_material_string
#define priority mccinter_analyzer_colimator_13_blade_0_priority
#define xwidth mccinter_analyzer_colimator_13_blade_0_xwidth
#define yheight mccinter_analyzer_colimator_13_blade_0_yheight
#define zdepth mccinter_analyzer_colimator_13_blade_0_zdepth
#define xwidth2 mccinter_analyzer_colimator_13_blade_0_xwidth2
#define yheight2 mccinter_analyzer_colimator_13_blade_0_yheight2
#define visualize mccinter_analyzer_colimator_13_blade_0_visualize
#define target_index mccinter_analyzer_colimator_13_blade_0_target_index
#define target_x mccinter_analyzer_colimator_13_blade_0_target_x
#define target_y mccinter_analyzer_colimator_13_blade_0_target_y
#define target_z mccinter_analyzer_colimator_13_blade_0_target_z
#define focus_aw mccinter_analyzer_colimator_13_blade_0_focus_aw
#define focus_ah mccinter_analyzer_colimator_13_blade_0_focus_ah
#define focus_xw mccinter_analyzer_colimator_13_blade_0_focus_xw
#define focus_xh mccinter_analyzer_colimator_13_blade_0_focus_xh
#define focus_r mccinter_analyzer_colimator_13_blade_0_focus_r
#define p_interact mccinter_analyzer_colimator_13_blade_0_p_interact
#define mask_string mccinter_analyzer_colimator_13_blade_0_mask_string
#define mask_setting mccinter_analyzer_colimator_13_blade_0_mask_setting
#define number_of_activations mccinter_analyzer_colimator_13_blade_0_number_of_activations
#line 204 "Union_box.comp"
// Needed for transport to the main component
struct global_geometry_element_struct global_geometry_element;

#ifndef ANY_GEOMETRY_DETECTOR_DECLARE
    #define ANY_GEOMETRY_DETECTOR_DECLARE dummy
	//struct pointer_to_global_geometry_list global_geometry_list = {0,NULL};
#endif

int loop_index,found_geometries;

double x_component;
double y_component;
double z_component;

struct Volume_struct this_box_volume;
struct box_storage this_box_storage;

#line 68893 "MACS_sample_kidney_box.c"
#undef number_of_activations
#undef mask_setting
#undef mask_string
#undef p_interact
#undef focus_r
#undef focus_xh
#undef focus_xw
#undef focus_ah
#undef focus_aw
#undef target_z
#undef target_y
#undef target_x
#undef target_index
#undef visualize
#undef yheight2
#undef xwidth2
#undef zdepth
#undef yheight
#undef xwidth
#undef priority
#undef material_string
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

/* User declarations for component 'inter_analyzer_colimator_13_blade_1' [650]. */
#define mccompcurname  inter_analyzer_colimator_13_blade_1
#define mccompcurtype  Union_box
#define mccompcurindex 650
#define loop_index mccinter_analyzer_colimator_13_blade_1_loop_index
#define this_box_volume mccinter_analyzer_colimator_13_blade_1_this_box_volume
#define global_geometry_element mccinter_analyzer_colimator_13_blade_1_global_geometry_element
#define this_box_storage mccinter_analyzer_colimator_13_blade_1_this_box_storage
#define material_string mccinter_analyzer_colimator_13_blade_1_material_string
#define priority mccinter_analyzer_colimator_13_blade_1_priority
#define xwidth mccinter_analyzer_colimator_13_blade_1_xwidth
#define yheight mccinter_analyzer_colimator_13_blade_1_yheight
#define zdepth mccinter_analyzer_colimator_13_blade_1_zdepth
#define xwidth2 mccinter_analyzer_colimator_13_blade_1_xwidth2
#define yheight2 mccinter_analyzer_colimator_13_blade_1_yheight2
#define visualize mccinter_analyzer_colimator_13_blade_1_visualize
#define target_index mccinter_analyzer_colimator_13_blade_1_target_index
#define target_x mccinter_analyzer_colimator_13_blade_1_target_x
#define target_y mccinter_analyzer_colimator_13_blade_1_target_y
#define target_z mccinter_analyzer_colimator_13_blade_1_target_z
#define focus_aw mccinter_analyzer_colimator_13_blade_1_focus_aw
#define focus_ah mccinter_analyzer_colimator_13_blade_1_focus_ah
#define focus_xw mccinter_analyzer_colimator_13_blade_1_focus_xw
#define focus_xh mccinter_analyzer_colimator_13_blade_1_focus_xh
#define focus_r mccinter_analyzer_colimator_13_blade_1_focus_r
#define p_interact mccinter_analyzer_colimator_13_blade_1_p_interact
#define mask_string mccinter_analyzer_colimator_13_blade_1_mask_string
#define mask_setting mccinter_analyzer_colimator_13_blade_1_mask_setting
#define number_of_activations mccinter_analyzer_colimator_13_blade_1_number_of_activations
#line 204 "Union_box.comp"
// Needed for transport to the main component
struct global_geometry_element_struct global_geometry_element;

#ifndef ANY_GEOMETRY_DETECTOR_DECLARE
    #define ANY_GEOMETRY_DETECTOR_DECLARE dummy
	//struct pointer_to_global_geometry_list global_geometry_list = {0,NULL};
#endif

int loop_index,found_geometries;

double x_component;
double y_component;
double z_component;

struct Volume_struct this_box_volume;
struct box_storage this_box_storage;

#line 68970 "MACS_sample_kidney_box.c"
#undef number_of_activations
#undef mask_setting
#undef mask_string
#undef p_interact
#undef focus_r
#undef focus_xh
#undef focus_xw
#undef focus_ah
#undef focus_aw
#undef target_z
#undef target_y
#undef target_x
#undef target_index
#undef visualize
#undef yheight2
#undef xwidth2
#undef zdepth
#undef yheight
#undef xwidth
#undef priority
#undef material_string
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

/* User declarations for component 'inter_analyzer_colimator_13_blade_2' [651]. */
#define mccompcurname  inter_analyzer_colimator_13_blade_2
#define mccompcurtype  Union_box
#define mccompcurindex 651
#define loop_index mccinter_analyzer_colimator_13_blade_2_loop_index
#define this_box_volume mccinter_analyzer_colimator_13_blade_2_this_box_volume
#define global_geometry_element mccinter_analyzer_colimator_13_blade_2_global_geometry_element
#define this_box_storage mccinter_analyzer_colimator_13_blade_2_this_box_storage
#define material_string mccinter_analyzer_colimator_13_blade_2_material_string
#define priority mccinter_analyzer_colimator_13_blade_2_priority
#define xwidth mccinter_analyzer_colimator_13_blade_2_xwidth
#define yheight mccinter_analyzer_colimator_13_blade_2_yheight
#define zdepth mccinter_analyzer_colimator_13_blade_2_zdepth
#define xwidth2 mccinter_analyzer_colimator_13_blade_2_xwidth2
#define yheight2 mccinter_analyzer_colimator_13_blade_2_yheight2
#define visualize mccinter_analyzer_colimator_13_blade_2_visualize
#define target_index mccinter_analyzer_colimator_13_blade_2_target_index
#define target_x mccinter_analyzer_colimator_13_blade_2_target_x
#define target_y mccinter_analyzer_colimator_13_blade_2_target_y
#define target_z mccinter_analyzer_colimator_13_blade_2_target_z
#define focus_aw mccinter_analyzer_colimator_13_blade_2_focus_aw
#define focus_ah mccinter_analyzer_colimator_13_blade_2_focus_ah
#define focus_xw mccinter_analyzer_colimator_13_blade_2_focus_xw
#define focus_xh mccinter_analyzer_colimator_13_blade_2_focus_xh
#define focus_r mccinter_analyzer_colimator_13_blade_2_focus_r
#define p_interact mccinter_analyzer_colimator_13_blade_2_p_interact
#define mask_string mccinter_analyzer_colimator_13_blade_2_mask_string
#define mask_setting mccinter_analyzer_colimator_13_blade_2_mask_setting
#define number_of_activations mccinter_analyzer_colimator_13_blade_2_number_of_activations
#line 204 "Union_box.comp"
// Needed for transport to the main component
struct global_geometry_element_struct global_geometry_element;

#ifndef ANY_GEOMETRY_DETECTOR_DECLARE
    #define ANY_GEOMETRY_DETECTOR_DECLARE dummy
	//struct pointer_to_global_geometry_list global_geometry_list = {0,NULL};
#endif

int loop_index,found_geometries;

double x_component;
double y_component;
double z_component;

struct Volume_struct this_box_volume;
struct box_storage this_box_storage;

#line 69047 "MACS_sample_kidney_box.c"
#undef number_of_activations
#undef mask_setting
#undef mask_string
#undef p_interact
#undef focus_r
#undef focus_xh
#undef focus_xw
#undef focus_ah
#undef focus_aw
#undef target_z
#undef target_y
#undef target_x
#undef target_index
#undef visualize
#undef yheight2
#undef xwidth2
#undef zdepth
#undef yheight
#undef xwidth
#undef priority
#undef material_string
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

/* User declarations for component 'inter_analyzer_colimator_13_blade_3' [652]. */
#define mccompcurname  inter_analyzer_colimator_13_blade_3
#define mccompcurtype  Union_box
#define mccompcurindex 652
#define loop_index mccinter_analyzer_colimator_13_blade_3_loop_index
#define this_box_volume mccinter_analyzer_colimator_13_blade_3_this_box_volume
#define global_geometry_element mccinter_analyzer_colimator_13_blade_3_global_geometry_element
#define this_box_storage mccinter_analyzer_colimator_13_blade_3_this_box_storage
#define material_string mccinter_analyzer_colimator_13_blade_3_material_string
#define priority mccinter_analyzer_colimator_13_blade_3_priority
#define xwidth mccinter_analyzer_colimator_13_blade_3_xwidth
#define yheight mccinter_analyzer_colimator_13_blade_3_yheight
#define zdepth mccinter_analyzer_colimator_13_blade_3_zdepth
#define xwidth2 mccinter_analyzer_colimator_13_blade_3_xwidth2
#define yheight2 mccinter_analyzer_colimator_13_blade_3_yheight2
#define visualize mccinter_analyzer_colimator_13_blade_3_visualize
#define target_index mccinter_analyzer_colimator_13_blade_3_target_index
#define target_x mccinter_analyzer_colimator_13_blade_3_target_x
#define target_y mccinter_analyzer_colimator_13_blade_3_target_y
#define target_z mccinter_analyzer_colimator_13_blade_3_target_z
#define focus_aw mccinter_analyzer_colimator_13_blade_3_focus_aw
#define focus_ah mccinter_analyzer_colimator_13_blade_3_focus_ah
#define focus_xw mccinter_analyzer_colimator_13_blade_3_focus_xw
#define focus_xh mccinter_analyzer_colimator_13_blade_3_focus_xh
#define focus_r mccinter_analyzer_colimator_13_blade_3_focus_r
#define p_interact mccinter_analyzer_colimator_13_blade_3_p_interact
#define mask_string mccinter_analyzer_colimator_13_blade_3_mask_string
#define mask_setting mccinter_analyzer_colimator_13_blade_3_mask_setting
#define number_of_activations mccinter_analyzer_colimator_13_blade_3_number_of_activations
#line 204 "Union_box.comp"
// Needed for transport to the main component
struct global_geometry_element_struct global_geometry_element;

#ifndef ANY_GEOMETRY_DETECTOR_DECLARE
    #define ANY_GEOMETRY_DETECTOR_DECLARE dummy
	//struct pointer_to_global_geometry_list global_geometry_list = {0,NULL};
#endif

int loop_index,found_geometries;

double x_component;
double y_component;
double z_component;

struct Volume_struct this_box_volume;
struct box_storage this_box_storage;

#line 69124 "MACS_sample_kidney_box.c"
#undef number_of_activations
#undef mask_setting
#undef mask_string
#undef p_interact
#undef focus_r
#undef focus_xh
#undef focus_xw
#undef focus_ah
#undef focus_aw
#undef target_z
#undef target_y
#undef target_x
#undef target_index
#undef visualize
#undef yheight2
#undef xwidth2
#undef zdepth
#undef yheight
#undef xwidth
#undef priority
#undef material_string
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

/* User declarations for component 'inter_analyzer_colimator_13_blade_4' [653]. */
#define mccompcurname  inter_analyzer_colimator_13_blade_4
#define mccompcurtype  Union_box
#define mccompcurindex 653
#define loop_index mccinter_analyzer_colimator_13_blade_4_loop_index
#define this_box_volume mccinter_analyzer_colimator_13_blade_4_this_box_volume
#define global_geometry_element mccinter_analyzer_colimator_13_blade_4_global_geometry_element
#define this_box_storage mccinter_analyzer_colimator_13_blade_4_this_box_storage
#define material_string mccinter_analyzer_colimator_13_blade_4_material_string
#define priority mccinter_analyzer_colimator_13_blade_4_priority
#define xwidth mccinter_analyzer_colimator_13_blade_4_xwidth
#define yheight mccinter_analyzer_colimator_13_blade_4_yheight
#define zdepth mccinter_analyzer_colimator_13_blade_4_zdepth
#define xwidth2 mccinter_analyzer_colimator_13_blade_4_xwidth2
#define yheight2 mccinter_analyzer_colimator_13_blade_4_yheight2
#define visualize mccinter_analyzer_colimator_13_blade_4_visualize
#define target_index mccinter_analyzer_colimator_13_blade_4_target_index
#define target_x mccinter_analyzer_colimator_13_blade_4_target_x
#define target_y mccinter_analyzer_colimator_13_blade_4_target_y
#define target_z mccinter_analyzer_colimator_13_blade_4_target_z
#define focus_aw mccinter_analyzer_colimator_13_blade_4_focus_aw
#define focus_ah mccinter_analyzer_colimator_13_blade_4_focus_ah
#define focus_xw mccinter_analyzer_colimator_13_blade_4_focus_xw
#define focus_xh mccinter_analyzer_colimator_13_blade_4_focus_xh
#define focus_r mccinter_analyzer_colimator_13_blade_4_focus_r
#define p_interact mccinter_analyzer_colimator_13_blade_4_p_interact
#define mask_string mccinter_analyzer_colimator_13_blade_4_mask_string
#define mask_setting mccinter_analyzer_colimator_13_blade_4_mask_setting
#define number_of_activations mccinter_analyzer_colimator_13_blade_4_number_of_activations
#line 204 "Union_box.comp"
// Needed for transport to the main component
struct global_geometry_element_struct global_geometry_element;

#ifndef ANY_GEOMETRY_DETECTOR_DECLARE
    #define ANY_GEOMETRY_DETECTOR_DECLARE dummy
	//struct pointer_to_global_geometry_list global_geometry_list = {0,NULL};
#endif

int loop_index,found_geometries;

double x_component;
double y_component;
double z_component;

struct Volume_struct this_box_volume;
struct box_storage this_box_storage;

#line 69201 "MACS_sample_kidney_box.c"
#undef number_of_activations
#undef mask_setting
#undef mask_string
#undef p_interact
#undef focus_r
#undef focus_xh
#undef focus_xw
#undef focus_ah
#undef focus_aw
#undef target_z
#undef target_y
#undef target_x
#undef target_index
#undef visualize
#undef yheight2
#undef xwidth2
#undef zdepth
#undef yheight
#undef xwidth
#undef priority
#undef material_string
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

/* User declarations for component 'diffraction_detector_13_exit_volume' [654]. */
#define mccompcurname  diffraction_detector_13_exit_volume
#define mccompcurtype  Union_box
#define mccompcurindex 654
#define loop_index mccdiffraction_detector_13_exit_volume_loop_index
#define this_box_volume mccdiffraction_detector_13_exit_volume_this_box_volume
#define global_geometry_element mccdiffraction_detector_13_exit_volume_global_geometry_element
#define this_box_storage mccdiffraction_detector_13_exit_volume_this_box_storage
#define material_string mccdiffraction_detector_13_exit_volume_material_string
#define priority mccdiffraction_detector_13_exit_volume_priority
#define xwidth mccdiffraction_detector_13_exit_volume_xwidth
#define yheight mccdiffraction_detector_13_exit_volume_yheight
#define zdepth mccdiffraction_detector_13_exit_volume_zdepth
#define xwidth2 mccdiffraction_detector_13_exit_volume_xwidth2
#define yheight2 mccdiffraction_detector_13_exit_volume_yheight2
#define visualize mccdiffraction_detector_13_exit_volume_visualize
#define target_index mccdiffraction_detector_13_exit_volume_target_index
#define target_x mccdiffraction_detector_13_exit_volume_target_x
#define target_y mccdiffraction_detector_13_exit_volume_target_y
#define target_z mccdiffraction_detector_13_exit_volume_target_z
#define focus_aw mccdiffraction_detector_13_exit_volume_focus_aw
#define focus_ah mccdiffraction_detector_13_exit_volume_focus_ah
#define focus_xw mccdiffraction_detector_13_exit_volume_focus_xw
#define focus_xh mccdiffraction_detector_13_exit_volume_focus_xh
#define focus_r mccdiffraction_detector_13_exit_volume_focus_r
#define p_interact mccdiffraction_detector_13_exit_volume_p_interact
#define mask_string mccdiffraction_detector_13_exit_volume_mask_string
#define mask_setting mccdiffraction_detector_13_exit_volume_mask_setting
#define number_of_activations mccdiffraction_detector_13_exit_volume_number_of_activations
#line 204 "Union_box.comp"
// Needed for transport to the main component
struct global_geometry_element_struct global_geometry_element;

#ifndef ANY_GEOMETRY_DETECTOR_DECLARE
    #define ANY_GEOMETRY_DETECTOR_DECLARE dummy
	//struct pointer_to_global_geometry_list global_geometry_list = {0,NULL};
#endif

int loop_index,found_geometries;

double x_component;
double y_component;
double z_component;

struct Volume_struct this_box_volume;
struct box_storage this_box_storage;

#line 69278 "MACS_sample_kidney_box.c"
#undef number_of_activations
#undef mask_setting
#undef mask_string
#undef p_interact
#undef focus_r
#undef focus_xh
#undef focus_xw
#undef focus_ah
#undef focus_aw
#undef target_z
#undef target_y
#undef target_x
#undef target_index
#undef visualize
#undef yheight2
#undef xwidth2
#undef zdepth
#undef yheight
#undef xwidth
#undef priority
#undef material_string
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

/* User declarations for component 'spec_detector_13_exit_volume' [655]. */
#define mccompcurname  spec_detector_13_exit_volume
#define mccompcurtype  Union_box
#define mccompcurindex 655
#define loop_index mccspec_detector_13_exit_volume_loop_index
#define this_box_volume mccspec_detector_13_exit_volume_this_box_volume
#define global_geometry_element mccspec_detector_13_exit_volume_global_geometry_element
#define this_box_storage mccspec_detector_13_exit_volume_this_box_storage
#define material_string mccspec_detector_13_exit_volume_material_string
#define priority mccspec_detector_13_exit_volume_priority
#define xwidth mccspec_detector_13_exit_volume_xwidth
#define yheight mccspec_detector_13_exit_volume_yheight
#define zdepth mccspec_detector_13_exit_volume_zdepth
#define xwidth2 mccspec_detector_13_exit_volume_xwidth2
#define yheight2 mccspec_detector_13_exit_volume_yheight2
#define visualize mccspec_detector_13_exit_volume_visualize
#define target_index mccspec_detector_13_exit_volume_target_index
#define target_x mccspec_detector_13_exit_volume_target_x
#define target_y mccspec_detector_13_exit_volume_target_y
#define target_z mccspec_detector_13_exit_volume_target_z
#define focus_aw mccspec_detector_13_exit_volume_focus_aw
#define focus_ah mccspec_detector_13_exit_volume_focus_ah
#define focus_xw mccspec_detector_13_exit_volume_focus_xw
#define focus_xh mccspec_detector_13_exit_volume_focus_xh
#define focus_r mccspec_detector_13_exit_volume_focus_r
#define p_interact mccspec_detector_13_exit_volume_p_interact
#define mask_string mccspec_detector_13_exit_volume_mask_string
#define mask_setting mccspec_detector_13_exit_volume_mask_setting
#define number_of_activations mccspec_detector_13_exit_volume_number_of_activations
#line 204 "Union_box.comp"
// Needed for transport to the main component
struct global_geometry_element_struct global_geometry_element;

#ifndef ANY_GEOMETRY_DETECTOR_DECLARE
    #define ANY_GEOMETRY_DETECTOR_DECLARE dummy
	//struct pointer_to_global_geometry_list global_geometry_list = {0,NULL};
#endif

int loop_index,found_geometries;

double x_component;
double y_component;
double z_component;

struct Volume_struct this_box_volume;
struct box_storage this_box_storage;

#line 69355 "MACS_sample_kidney_box.c"
#undef number_of_activations
#undef mask_setting
#undef mask_string
#undef p_interact
#undef focus_r
#undef focus_xh
#undef focus_xw
#undef focus_ah
#undef focus_aw
#undef target_z
#undef target_y
#undef target_x
#undef target_index
#undef visualize
#undef yheight2
#undef xwidth2
#undef zdepth
#undef yheight
#undef xwidth
#undef priority
#undef material_string
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

/* User declarations for component 'channel_14_cave1_box1' [656]. */
#define mccompcurname  channel_14_cave1_box1
#define mccompcurtype  Union_box
#define mccompcurindex 656
#define loop_index mccchannel_14_cave1_box1_loop_index
#define this_box_volume mccchannel_14_cave1_box1_this_box_volume
#define global_geometry_element mccchannel_14_cave1_box1_global_geometry_element
#define this_box_storage mccchannel_14_cave1_box1_this_box_storage
#define material_string mccchannel_14_cave1_box1_material_string
#define priority mccchannel_14_cave1_box1_priority
#define xwidth mccchannel_14_cave1_box1_xwidth
#define yheight mccchannel_14_cave1_box1_yheight
#define zdepth mccchannel_14_cave1_box1_zdepth
#define xwidth2 mccchannel_14_cave1_box1_xwidth2
#define yheight2 mccchannel_14_cave1_box1_yheight2
#define visualize mccchannel_14_cave1_box1_visualize
#define target_index mccchannel_14_cave1_box1_target_index
#define target_x mccchannel_14_cave1_box1_target_x
#define target_y mccchannel_14_cave1_box1_target_y
#define target_z mccchannel_14_cave1_box1_target_z
#define focus_aw mccchannel_14_cave1_box1_focus_aw
#define focus_ah mccchannel_14_cave1_box1_focus_ah
#define focus_xw mccchannel_14_cave1_box1_focus_xw
#define focus_xh mccchannel_14_cave1_box1_focus_xh
#define focus_r mccchannel_14_cave1_box1_focus_r
#define p_interact mccchannel_14_cave1_box1_p_interact
#define mask_string mccchannel_14_cave1_box1_mask_string
#define mask_setting mccchannel_14_cave1_box1_mask_setting
#define number_of_activations mccchannel_14_cave1_box1_number_of_activations
#line 204 "Union_box.comp"
// Needed for transport to the main component
struct global_geometry_element_struct global_geometry_element;

#ifndef ANY_GEOMETRY_DETECTOR_DECLARE
    #define ANY_GEOMETRY_DETECTOR_DECLARE dummy
	//struct pointer_to_global_geometry_list global_geometry_list = {0,NULL};
#endif

int loop_index,found_geometries;

double x_component;
double y_component;
double z_component;

struct Volume_struct this_box_volume;
struct box_storage this_box_storage;

#line 69432 "MACS_sample_kidney_box.c"
#undef number_of_activations
#undef mask_setting
#undef mask_string
#undef p_interact
#undef focus_r
#undef focus_xh
#undef focus_xw
#undef focus_ah
#undef focus_aw
#undef target_z
#undef target_y
#undef target_x
#undef target_index
#undef visualize
#undef yheight2
#undef xwidth2
#undef zdepth
#undef yheight
#undef xwidth
#undef priority
#undef material_string
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

/* User declarations for component 'channel_14_cave1_box2' [657]. */
#define mccompcurname  channel_14_cave1_box2
#define mccompcurtype  Union_box
#define mccompcurindex 657
#define loop_index mccchannel_14_cave1_box2_loop_index
#define this_box_volume mccchannel_14_cave1_box2_this_box_volume
#define global_geometry_element mccchannel_14_cave1_box2_global_geometry_element
#define this_box_storage mccchannel_14_cave1_box2_this_box_storage
#define material_string mccchannel_14_cave1_box2_material_string
#define priority mccchannel_14_cave1_box2_priority
#define xwidth mccchannel_14_cave1_box2_xwidth
#define yheight mccchannel_14_cave1_box2_yheight
#define zdepth mccchannel_14_cave1_box2_zdepth
#define xwidth2 mccchannel_14_cave1_box2_xwidth2
#define yheight2 mccchannel_14_cave1_box2_yheight2
#define visualize mccchannel_14_cave1_box2_visualize
#define target_index mccchannel_14_cave1_box2_target_index
#define target_x mccchannel_14_cave1_box2_target_x
#define target_y mccchannel_14_cave1_box2_target_y
#define target_z mccchannel_14_cave1_box2_target_z
#define focus_aw mccchannel_14_cave1_box2_focus_aw
#define focus_ah mccchannel_14_cave1_box2_focus_ah
#define focus_xw mccchannel_14_cave1_box2_focus_xw
#define focus_xh mccchannel_14_cave1_box2_focus_xh
#define focus_r mccchannel_14_cave1_box2_focus_r
#define p_interact mccchannel_14_cave1_box2_p_interact
#define mask_string mccchannel_14_cave1_box2_mask_string
#define mask_setting mccchannel_14_cave1_box2_mask_setting
#define number_of_activations mccchannel_14_cave1_box2_number_of_activations
#line 204 "Union_box.comp"
// Needed for transport to the main component
struct global_geometry_element_struct global_geometry_element;

#ifndef ANY_GEOMETRY_DETECTOR_DECLARE
    #define ANY_GEOMETRY_DETECTOR_DECLARE dummy
	//struct pointer_to_global_geometry_list global_geometry_list = {0,NULL};
#endif

int loop_index,found_geometries;

double x_component;
double y_component;
double z_component;

struct Volume_struct this_box_volume;
struct box_storage this_box_storage;

#line 69509 "MACS_sample_kidney_box.c"
#undef number_of_activations
#undef mask_setting
#undef mask_string
#undef p_interact
#undef focus_r
#undef focus_xh
#undef focus_xw
#undef focus_ah
#undef focus_aw
#undef target_z
#undef target_y
#undef target_x
#undef target_index
#undef visualize
#undef yheight2
#undef xwidth2
#undef zdepth
#undef yheight
#undef xwidth
#undef priority
#undef material_string
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

/* User declarations for component 'channel_14_cave1_box3' [658]. */
#define mccompcurname  channel_14_cave1_box3
#define mccompcurtype  Union_box
#define mccompcurindex 658
#define loop_index mccchannel_14_cave1_box3_loop_index
#define this_box_volume mccchannel_14_cave1_box3_this_box_volume
#define global_geometry_element mccchannel_14_cave1_box3_global_geometry_element
#define this_box_storage mccchannel_14_cave1_box3_this_box_storage
#define material_string mccchannel_14_cave1_box3_material_string
#define priority mccchannel_14_cave1_box3_priority
#define xwidth mccchannel_14_cave1_box3_xwidth
#define yheight mccchannel_14_cave1_box3_yheight
#define zdepth mccchannel_14_cave1_box3_zdepth
#define xwidth2 mccchannel_14_cave1_box3_xwidth2
#define yheight2 mccchannel_14_cave1_box3_yheight2
#define visualize mccchannel_14_cave1_box3_visualize
#define target_index mccchannel_14_cave1_box3_target_index
#define target_x mccchannel_14_cave1_box3_target_x
#define target_y mccchannel_14_cave1_box3_target_y
#define target_z mccchannel_14_cave1_box3_target_z
#define focus_aw mccchannel_14_cave1_box3_focus_aw
#define focus_ah mccchannel_14_cave1_box3_focus_ah
#define focus_xw mccchannel_14_cave1_box3_focus_xw
#define focus_xh mccchannel_14_cave1_box3_focus_xh
#define focus_r mccchannel_14_cave1_box3_focus_r
#define p_interact mccchannel_14_cave1_box3_p_interact
#define mask_string mccchannel_14_cave1_box3_mask_string
#define mask_setting mccchannel_14_cave1_box3_mask_setting
#define number_of_activations mccchannel_14_cave1_box3_number_of_activations
#line 204 "Union_box.comp"
// Needed for transport to the main component
struct global_geometry_element_struct global_geometry_element;

#ifndef ANY_GEOMETRY_DETECTOR_DECLARE
    #define ANY_GEOMETRY_DETECTOR_DECLARE dummy
	//struct pointer_to_global_geometry_list global_geometry_list = {0,NULL};
#endif

int loop_index,found_geometries;

double x_component;
double y_component;
double z_component;

struct Volume_struct this_box_volume;
struct box_storage this_box_storage;

#line 69586 "MACS_sample_kidney_box.c"
#undef number_of_activations
#undef mask_setting
#undef mask_string
#undef p_interact
#undef focus_r
#undef focus_xh
#undef focus_xw
#undef focus_ah
#undef focus_aw
#undef target_z
#undef target_y
#undef target_x
#undef target_index
#undef visualize
#undef yheight2
#undef xwidth2
#undef zdepth
#undef yheight
#undef xwidth
#undef priority
#undef material_string
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

/* User declarations for component 'channel_14_cave1_cyl1' [659]. */
#define mccompcurname  channel_14_cave1_cyl1
#define mccompcurtype  Union_cylinder
#define mccompcurindex 659
#define loop_index mccchannel_14_cave1_cyl1_loop_index
#define this_cylinder_volume mccchannel_14_cave1_cyl1_this_cylinder_volume
#define global_geometry_element mccchannel_14_cave1_cyl1_global_geometry_element
#define this_cylinder_storage mccchannel_14_cave1_cyl1_this_cylinder_storage
#define material_string mccchannel_14_cave1_cyl1_material_string
#define priority mccchannel_14_cave1_cyl1_priority
#define radius mccchannel_14_cave1_cyl1_radius
#define yheight mccchannel_14_cave1_cyl1_yheight
#define visualize mccchannel_14_cave1_cyl1_visualize
#define target_index mccchannel_14_cave1_cyl1_target_index
#define target_x mccchannel_14_cave1_cyl1_target_x
#define target_y mccchannel_14_cave1_cyl1_target_y
#define target_z mccchannel_14_cave1_cyl1_target_z
#define focus_aw mccchannel_14_cave1_cyl1_focus_aw
#define focus_ah mccchannel_14_cave1_cyl1_focus_ah
#define focus_xw mccchannel_14_cave1_cyl1_focus_xw
#define focus_xh mccchannel_14_cave1_cyl1_focus_xh
#define focus_r mccchannel_14_cave1_cyl1_focus_r
#define p_interact mccchannel_14_cave1_cyl1_p_interact
#define mask_string mccchannel_14_cave1_cyl1_mask_string
#define mask_setting mccchannel_14_cave1_cyl1_mask_setting
#define number_of_activations mccchannel_14_cave1_cyl1_number_of_activations
#line 167 "Union_cylinder.comp"
// Needed for transport to the main component
struct global_geometry_element_struct global_geometry_element;

#ifndef ANY_GEOMETRY_DETECTOR_DECLARE
    #define ANY_GEOMETRY_DETECTOR_DECLARE dummy
	//struct pointer_to_global_geometry_list global_geometry_list = {0,NULL};
#endif

int dummy;
int loop_index,found_geometries;
int loop_2_index;
int material_index;

struct Volume_struct this_cylinder_volume;
struct cylinder_storage this_cylinder_storage;
#line 69658 "MACS_sample_kidney_box.c"
#undef number_of_activations
#undef mask_setting
#undef mask_string
#undef p_interact
#undef focus_r
#undef focus_xh
#undef focus_xw
#undef focus_ah
#undef focus_aw
#undef target_z
#undef target_y
#undef target_x
#undef target_index
#undef visualize
#undef yheight
#undef radius
#undef priority
#undef material_string
#undef this_cylinder_storage
#undef global_geometry_element
#undef this_cylinder_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

/* User declarations for component 'channel_14_analyzer_1_center' [660]. */
#define mccompcurname  channel_14_analyzer_1_center
#define mccompcurtype  Arm
#define mccompcurindex 660
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

/* User declarations for component 'channel_14_analyzer_1_rotated' [661]. */
#define mccompcurname  channel_14_analyzer_1_rotated
#define mccompcurtype  Arm
#define mccompcurindex 661
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

/* User declarations for component 'channel_14_analyzer_1_array_crystal_array_0' [662]. */
#define mccompcurname  channel_14_analyzer_1_array_crystal_array_0
#define mccompcurtype  Union_box
#define mccompcurindex 662
#define loop_index mccchannel_14_analyzer_1_array_crystal_array_0_loop_index
#define this_box_volume mccchannel_14_analyzer_1_array_crystal_array_0_this_box_volume
#define global_geometry_element mccchannel_14_analyzer_1_array_crystal_array_0_global_geometry_element
#define this_box_storage mccchannel_14_analyzer_1_array_crystal_array_0_this_box_storage
#define material_string mccchannel_14_analyzer_1_array_crystal_array_0_material_string
#define priority mccchannel_14_analyzer_1_array_crystal_array_0_priority
#define xwidth mccchannel_14_analyzer_1_array_crystal_array_0_xwidth
#define yheight mccchannel_14_analyzer_1_array_crystal_array_0_yheight
#define zdepth mccchannel_14_analyzer_1_array_crystal_array_0_zdepth
#define xwidth2 mccchannel_14_analyzer_1_array_crystal_array_0_xwidth2
#define yheight2 mccchannel_14_analyzer_1_array_crystal_array_0_yheight2
#define visualize mccchannel_14_analyzer_1_array_crystal_array_0_visualize
#define target_index mccchannel_14_analyzer_1_array_crystal_array_0_target_index
#define target_x mccchannel_14_analyzer_1_array_crystal_array_0_target_x
#define target_y mccchannel_14_analyzer_1_array_crystal_array_0_target_y
#define target_z mccchannel_14_analyzer_1_array_crystal_array_0_target_z
#define focus_aw mccchannel_14_analyzer_1_array_crystal_array_0_focus_aw
#define focus_ah mccchannel_14_analyzer_1_array_crystal_array_0_focus_ah
#define focus_xw mccchannel_14_analyzer_1_array_crystal_array_0_focus_xw
#define focus_xh mccchannel_14_analyzer_1_array_crystal_array_0_focus_xh
#define focus_r mccchannel_14_analyzer_1_array_crystal_array_0_focus_r
#define p_interact mccchannel_14_analyzer_1_array_crystal_array_0_p_interact
#define mask_string mccchannel_14_analyzer_1_array_crystal_array_0_mask_string
#define mask_setting mccchannel_14_analyzer_1_array_crystal_array_0_mask_setting
#define number_of_activations mccchannel_14_analyzer_1_array_crystal_array_0_number_of_activations
#line 204 "Union_box.comp"
// Needed for transport to the main component
struct global_geometry_element_struct global_geometry_element;

#ifndef ANY_GEOMETRY_DETECTOR_DECLARE
    #define ANY_GEOMETRY_DETECTOR_DECLARE dummy
	//struct pointer_to_global_geometry_list global_geometry_list = {0,NULL};
#endif

int loop_index,found_geometries;

double x_component;
double y_component;
double z_component;

struct Volume_struct this_box_volume;
struct box_storage this_box_storage;

#line 69748 "MACS_sample_kidney_box.c"
#undef number_of_activations
#undef mask_setting
#undef mask_string
#undef p_interact
#undef focus_r
#undef focus_xh
#undef focus_xw
#undef focus_ah
#undef focus_aw
#undef target_z
#undef target_y
#undef target_x
#undef target_index
#undef visualize
#undef yheight2
#undef xwidth2
#undef zdepth
#undef yheight
#undef xwidth
#undef priority
#undef material_string
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

/* User declarations for component 'channel_14_analyzer_1_array_crystal_array_1' [663]. */
#define mccompcurname  channel_14_analyzer_1_array_crystal_array_1
#define mccompcurtype  Union_box
#define mccompcurindex 663
#define loop_index mccchannel_14_analyzer_1_array_crystal_array_1_loop_index
#define this_box_volume mccchannel_14_analyzer_1_array_crystal_array_1_this_box_volume
#define global_geometry_element mccchannel_14_analyzer_1_array_crystal_array_1_global_geometry_element
#define this_box_storage mccchannel_14_analyzer_1_array_crystal_array_1_this_box_storage
#define material_string mccchannel_14_analyzer_1_array_crystal_array_1_material_string
#define priority mccchannel_14_analyzer_1_array_crystal_array_1_priority
#define xwidth mccchannel_14_analyzer_1_array_crystal_array_1_xwidth
#define yheight mccchannel_14_analyzer_1_array_crystal_array_1_yheight
#define zdepth mccchannel_14_analyzer_1_array_crystal_array_1_zdepth
#define xwidth2 mccchannel_14_analyzer_1_array_crystal_array_1_xwidth2
#define yheight2 mccchannel_14_analyzer_1_array_crystal_array_1_yheight2
#define visualize mccchannel_14_analyzer_1_array_crystal_array_1_visualize
#define target_index mccchannel_14_analyzer_1_array_crystal_array_1_target_index
#define target_x mccchannel_14_analyzer_1_array_crystal_array_1_target_x
#define target_y mccchannel_14_analyzer_1_array_crystal_array_1_target_y
#define target_z mccchannel_14_analyzer_1_array_crystal_array_1_target_z
#define focus_aw mccchannel_14_analyzer_1_array_crystal_array_1_focus_aw
#define focus_ah mccchannel_14_analyzer_1_array_crystal_array_1_focus_ah
#define focus_xw mccchannel_14_analyzer_1_array_crystal_array_1_focus_xw
#define focus_xh mccchannel_14_analyzer_1_array_crystal_array_1_focus_xh
#define focus_r mccchannel_14_analyzer_1_array_crystal_array_1_focus_r
#define p_interact mccchannel_14_analyzer_1_array_crystal_array_1_p_interact
#define mask_string mccchannel_14_analyzer_1_array_crystal_array_1_mask_string
#define mask_setting mccchannel_14_analyzer_1_array_crystal_array_1_mask_setting
#define number_of_activations mccchannel_14_analyzer_1_array_crystal_array_1_number_of_activations
#line 204 "Union_box.comp"
// Needed for transport to the main component
struct global_geometry_element_struct global_geometry_element;

#ifndef ANY_GEOMETRY_DETECTOR_DECLARE
    #define ANY_GEOMETRY_DETECTOR_DECLARE dummy
	//struct pointer_to_global_geometry_list global_geometry_list = {0,NULL};
#endif

int loop_index,found_geometries;

double x_component;
double y_component;
double z_component;

struct Volume_struct this_box_volume;
struct box_storage this_box_storage;

#line 69825 "MACS_sample_kidney_box.c"
#undef number_of_activations
#undef mask_setting
#undef mask_string
#undef p_interact
#undef focus_r
#undef focus_xh
#undef focus_xw
#undef focus_ah
#undef focus_aw
#undef target_z
#undef target_y
#undef target_x
#undef target_index
#undef visualize
#undef yheight2
#undef xwidth2
#undef zdepth
#undef yheight
#undef xwidth
#undef priority
#undef material_string
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

/* User declarations for component 'channel_14_analyzer_1_array_crystal_array_2' [664]. */
#define mccompcurname  channel_14_analyzer_1_array_crystal_array_2
#define mccompcurtype  Union_box
#define mccompcurindex 664
#define loop_index mccchannel_14_analyzer_1_array_crystal_array_2_loop_index
#define this_box_volume mccchannel_14_analyzer_1_array_crystal_array_2_this_box_volume
#define global_geometry_element mccchannel_14_analyzer_1_array_crystal_array_2_global_geometry_element
#define this_box_storage mccchannel_14_analyzer_1_array_crystal_array_2_this_box_storage
#define material_string mccchannel_14_analyzer_1_array_crystal_array_2_material_string
#define priority mccchannel_14_analyzer_1_array_crystal_array_2_priority
#define xwidth mccchannel_14_analyzer_1_array_crystal_array_2_xwidth
#define yheight mccchannel_14_analyzer_1_array_crystal_array_2_yheight
#define zdepth mccchannel_14_analyzer_1_array_crystal_array_2_zdepth
#define xwidth2 mccchannel_14_analyzer_1_array_crystal_array_2_xwidth2
#define yheight2 mccchannel_14_analyzer_1_array_crystal_array_2_yheight2
#define visualize mccchannel_14_analyzer_1_array_crystal_array_2_visualize
#define target_index mccchannel_14_analyzer_1_array_crystal_array_2_target_index
#define target_x mccchannel_14_analyzer_1_array_crystal_array_2_target_x
#define target_y mccchannel_14_analyzer_1_array_crystal_array_2_target_y
#define target_z mccchannel_14_analyzer_1_array_crystal_array_2_target_z
#define focus_aw mccchannel_14_analyzer_1_array_crystal_array_2_focus_aw
#define focus_ah mccchannel_14_analyzer_1_array_crystal_array_2_focus_ah
#define focus_xw mccchannel_14_analyzer_1_array_crystal_array_2_focus_xw
#define focus_xh mccchannel_14_analyzer_1_array_crystal_array_2_focus_xh
#define focus_r mccchannel_14_analyzer_1_array_crystal_array_2_focus_r
#define p_interact mccchannel_14_analyzer_1_array_crystal_array_2_p_interact
#define mask_string mccchannel_14_analyzer_1_array_crystal_array_2_mask_string
#define mask_setting mccchannel_14_analyzer_1_array_crystal_array_2_mask_setting
#define number_of_activations mccchannel_14_analyzer_1_array_crystal_array_2_number_of_activations
#line 204 "Union_box.comp"
// Needed for transport to the main component
struct global_geometry_element_struct global_geometry_element;

#ifndef ANY_GEOMETRY_DETECTOR_DECLARE
    #define ANY_GEOMETRY_DETECTOR_DECLARE dummy
	//struct pointer_to_global_geometry_list global_geometry_list = {0,NULL};
#endif

int loop_index,found_geometries;

double x_component;
double y_component;
double z_component;

struct Volume_struct this_box_volume;
struct box_storage this_box_storage;

#line 69902 "MACS_sample_kidney_box.c"
#undef number_of_activations
#undef mask_setting
#undef mask_string
#undef p_interact
#undef focus_r
#undef focus_xh
#undef focus_xw
#undef focus_ah
#undef focus_aw
#undef target_z
#undef target_y
#undef target_x
#undef target_index
#undef visualize
#undef yheight2
#undef xwidth2
#undef zdepth
#undef yheight
#undef xwidth
#undef priority
#undef material_string
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

/* User declarations for component 'channel_14_analyzer_1_array_crystal_array_3' [665]. */
#define mccompcurname  channel_14_analyzer_1_array_crystal_array_3
#define mccompcurtype  Union_box
#define mccompcurindex 665
#define loop_index mccchannel_14_analyzer_1_array_crystal_array_3_loop_index
#define this_box_volume mccchannel_14_analyzer_1_array_crystal_array_3_this_box_volume
#define global_geometry_element mccchannel_14_analyzer_1_array_crystal_array_3_global_geometry_element
#define this_box_storage mccchannel_14_analyzer_1_array_crystal_array_3_this_box_storage
#define material_string mccchannel_14_analyzer_1_array_crystal_array_3_material_string
#define priority mccchannel_14_analyzer_1_array_crystal_array_3_priority
#define xwidth mccchannel_14_analyzer_1_array_crystal_array_3_xwidth
#define yheight mccchannel_14_analyzer_1_array_crystal_array_3_yheight
#define zdepth mccchannel_14_analyzer_1_array_crystal_array_3_zdepth
#define xwidth2 mccchannel_14_analyzer_1_array_crystal_array_3_xwidth2
#define yheight2 mccchannel_14_analyzer_1_array_crystal_array_3_yheight2
#define visualize mccchannel_14_analyzer_1_array_crystal_array_3_visualize
#define target_index mccchannel_14_analyzer_1_array_crystal_array_3_target_index
#define target_x mccchannel_14_analyzer_1_array_crystal_array_3_target_x
#define target_y mccchannel_14_analyzer_1_array_crystal_array_3_target_y
#define target_z mccchannel_14_analyzer_1_array_crystal_array_3_target_z
#define focus_aw mccchannel_14_analyzer_1_array_crystal_array_3_focus_aw
#define focus_ah mccchannel_14_analyzer_1_array_crystal_array_3_focus_ah
#define focus_xw mccchannel_14_analyzer_1_array_crystal_array_3_focus_xw
#define focus_xh mccchannel_14_analyzer_1_array_crystal_array_3_focus_xh
#define focus_r mccchannel_14_analyzer_1_array_crystal_array_3_focus_r
#define p_interact mccchannel_14_analyzer_1_array_crystal_array_3_p_interact
#define mask_string mccchannel_14_analyzer_1_array_crystal_array_3_mask_string
#define mask_setting mccchannel_14_analyzer_1_array_crystal_array_3_mask_setting
#define number_of_activations mccchannel_14_analyzer_1_array_crystal_array_3_number_of_activations
#line 204 "Union_box.comp"
// Needed for transport to the main component
struct global_geometry_element_struct global_geometry_element;

#ifndef ANY_GEOMETRY_DETECTOR_DECLARE
    #define ANY_GEOMETRY_DETECTOR_DECLARE dummy
	//struct pointer_to_global_geometry_list global_geometry_list = {0,NULL};
#endif

int loop_index,found_geometries;

double x_component;
double y_component;
double z_component;

struct Volume_struct this_box_volume;
struct box_storage this_box_storage;

#line 69979 "MACS_sample_kidney_box.c"
#undef number_of_activations
#undef mask_setting
#undef mask_string
#undef p_interact
#undef focus_r
#undef focus_xh
#undef focus_xw
#undef focus_ah
#undef focus_aw
#undef target_z
#undef target_y
#undef target_x
#undef target_index
#undef visualize
#undef yheight2
#undef xwidth2
#undef zdepth
#undef yheight
#undef xwidth
#undef priority
#undef material_string
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

/* User declarations for component 'channel_14_analyzer_1_array_crystal_array_4' [666]. */
#define mccompcurname  channel_14_analyzer_1_array_crystal_array_4
#define mccompcurtype  Union_box
#define mccompcurindex 666
#define loop_index mccchannel_14_analyzer_1_array_crystal_array_4_loop_index
#define this_box_volume mccchannel_14_analyzer_1_array_crystal_array_4_this_box_volume
#define global_geometry_element mccchannel_14_analyzer_1_array_crystal_array_4_global_geometry_element
#define this_box_storage mccchannel_14_analyzer_1_array_crystal_array_4_this_box_storage
#define material_string mccchannel_14_analyzer_1_array_crystal_array_4_material_string
#define priority mccchannel_14_analyzer_1_array_crystal_array_4_priority
#define xwidth mccchannel_14_analyzer_1_array_crystal_array_4_xwidth
#define yheight mccchannel_14_analyzer_1_array_crystal_array_4_yheight
#define zdepth mccchannel_14_analyzer_1_array_crystal_array_4_zdepth
#define xwidth2 mccchannel_14_analyzer_1_array_crystal_array_4_xwidth2
#define yheight2 mccchannel_14_analyzer_1_array_crystal_array_4_yheight2
#define visualize mccchannel_14_analyzer_1_array_crystal_array_4_visualize
#define target_index mccchannel_14_analyzer_1_array_crystal_array_4_target_index
#define target_x mccchannel_14_analyzer_1_array_crystal_array_4_target_x
#define target_y mccchannel_14_analyzer_1_array_crystal_array_4_target_y
#define target_z mccchannel_14_analyzer_1_array_crystal_array_4_target_z
#define focus_aw mccchannel_14_analyzer_1_array_crystal_array_4_focus_aw
#define focus_ah mccchannel_14_analyzer_1_array_crystal_array_4_focus_ah
#define focus_xw mccchannel_14_analyzer_1_array_crystal_array_4_focus_xw
#define focus_xh mccchannel_14_analyzer_1_array_crystal_array_4_focus_xh
#define focus_r mccchannel_14_analyzer_1_array_crystal_array_4_focus_r
#define p_interact mccchannel_14_analyzer_1_array_crystal_array_4_p_interact
#define mask_string mccchannel_14_analyzer_1_array_crystal_array_4_mask_string
#define mask_setting mccchannel_14_analyzer_1_array_crystal_array_4_mask_setting
#define number_of_activations mccchannel_14_analyzer_1_array_crystal_array_4_number_of_activations
#line 204 "Union_box.comp"
// Needed for transport to the main component
struct global_geometry_element_struct global_geometry_element;

#ifndef ANY_GEOMETRY_DETECTOR_DECLARE
    #define ANY_GEOMETRY_DETECTOR_DECLARE dummy
	//struct pointer_to_global_geometry_list global_geometry_list = {0,NULL};
#endif

int loop_index,found_geometries;

double x_component;
double y_component;
double z_component;

struct Volume_struct this_box_volume;
struct box_storage this_box_storage;

#line 70056 "MACS_sample_kidney_box.c"
#undef number_of_activations
#undef mask_setting
#undef mask_string
#undef p_interact
#undef focus_r
#undef focus_xh
#undef focus_xw
#undef focus_ah
#undef focus_aw
#undef target_z
#undef target_y
#undef target_x
#undef target_index
#undef visualize
#undef yheight2
#undef xwidth2
#undef zdepth
#undef yheight
#undef xwidth
#undef priority
#undef material_string
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

/* User declarations for component 'channel_14_analyzer_1_array_crystal_array_5' [667]. */
#define mccompcurname  channel_14_analyzer_1_array_crystal_array_5
#define mccompcurtype  Union_box
#define mccompcurindex 667
#define loop_index mccchannel_14_analyzer_1_array_crystal_array_5_loop_index
#define this_box_volume mccchannel_14_analyzer_1_array_crystal_array_5_this_box_volume
#define global_geometry_element mccchannel_14_analyzer_1_array_crystal_array_5_global_geometry_element
#define this_box_storage mccchannel_14_analyzer_1_array_crystal_array_5_this_box_storage
#define material_string mccchannel_14_analyzer_1_array_crystal_array_5_material_string
#define priority mccchannel_14_analyzer_1_array_crystal_array_5_priority
#define xwidth mccchannel_14_analyzer_1_array_crystal_array_5_xwidth
#define yheight mccchannel_14_analyzer_1_array_crystal_array_5_yheight
#define zdepth mccchannel_14_analyzer_1_array_crystal_array_5_zdepth
#define xwidth2 mccchannel_14_analyzer_1_array_crystal_array_5_xwidth2
#define yheight2 mccchannel_14_analyzer_1_array_crystal_array_5_yheight2
#define visualize mccchannel_14_analyzer_1_array_crystal_array_5_visualize
#define target_index mccchannel_14_analyzer_1_array_crystal_array_5_target_index
#define target_x mccchannel_14_analyzer_1_array_crystal_array_5_target_x
#define target_y mccchannel_14_analyzer_1_array_crystal_array_5_target_y
#define target_z mccchannel_14_analyzer_1_array_crystal_array_5_target_z
#define focus_aw mccchannel_14_analyzer_1_array_crystal_array_5_focus_aw
#define focus_ah mccchannel_14_analyzer_1_array_crystal_array_5_focus_ah
#define focus_xw mccchannel_14_analyzer_1_array_crystal_array_5_focus_xw
#define focus_xh mccchannel_14_analyzer_1_array_crystal_array_5_focus_xh
#define focus_r mccchannel_14_analyzer_1_array_crystal_array_5_focus_r
#define p_interact mccchannel_14_analyzer_1_array_crystal_array_5_p_interact
#define mask_string mccchannel_14_analyzer_1_array_crystal_array_5_mask_string
#define mask_setting mccchannel_14_analyzer_1_array_crystal_array_5_mask_setting
#define number_of_activations mccchannel_14_analyzer_1_array_crystal_array_5_number_of_activations
#line 204 "Union_box.comp"
// Needed for transport to the main component
struct global_geometry_element_struct global_geometry_element;

#ifndef ANY_GEOMETRY_DETECTOR_DECLARE
    #define ANY_GEOMETRY_DETECTOR_DECLARE dummy
	//struct pointer_to_global_geometry_list global_geometry_list = {0,NULL};
#endif

int loop_index,found_geometries;

double x_component;
double y_component;
double z_component;

struct Volume_struct this_box_volume;
struct box_storage this_box_storage;

#line 70133 "MACS_sample_kidney_box.c"
#undef number_of_activations
#undef mask_setting
#undef mask_string
#undef p_interact
#undef focus_r
#undef focus_xh
#undef focus_xw
#undef focus_ah
#undef focus_aw
#undef target_z
#undef target_y
#undef target_x
#undef target_index
#undef visualize
#undef yheight2
#undef xwidth2
#undef zdepth
#undef yheight
#undef xwidth
#undef priority
#undef material_string
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

/* User declarations for component 'channel_14_analyzer_1_array_crystal_array_6' [668]. */
#define mccompcurname  channel_14_analyzer_1_array_crystal_array_6
#define mccompcurtype  Union_box
#define mccompcurindex 668
#define loop_index mccchannel_14_analyzer_1_array_crystal_array_6_loop_index
#define this_box_volume mccchannel_14_analyzer_1_array_crystal_array_6_this_box_volume
#define global_geometry_element mccchannel_14_analyzer_1_array_crystal_array_6_global_geometry_element
#define this_box_storage mccchannel_14_analyzer_1_array_crystal_array_6_this_box_storage
#define material_string mccchannel_14_analyzer_1_array_crystal_array_6_material_string
#define priority mccchannel_14_analyzer_1_array_crystal_array_6_priority
#define xwidth mccchannel_14_analyzer_1_array_crystal_array_6_xwidth
#define yheight mccchannel_14_analyzer_1_array_crystal_array_6_yheight
#define zdepth mccchannel_14_analyzer_1_array_crystal_array_6_zdepth
#define xwidth2 mccchannel_14_analyzer_1_array_crystal_array_6_xwidth2
#define yheight2 mccchannel_14_analyzer_1_array_crystal_array_6_yheight2
#define visualize mccchannel_14_analyzer_1_array_crystal_array_6_visualize
#define target_index mccchannel_14_analyzer_1_array_crystal_array_6_target_index
#define target_x mccchannel_14_analyzer_1_array_crystal_array_6_target_x
#define target_y mccchannel_14_analyzer_1_array_crystal_array_6_target_y
#define target_z mccchannel_14_analyzer_1_array_crystal_array_6_target_z
#define focus_aw mccchannel_14_analyzer_1_array_crystal_array_6_focus_aw
#define focus_ah mccchannel_14_analyzer_1_array_crystal_array_6_focus_ah
#define focus_xw mccchannel_14_analyzer_1_array_crystal_array_6_focus_xw
#define focus_xh mccchannel_14_analyzer_1_array_crystal_array_6_focus_xh
#define focus_r mccchannel_14_analyzer_1_array_crystal_array_6_focus_r
#define p_interact mccchannel_14_analyzer_1_array_crystal_array_6_p_interact
#define mask_string mccchannel_14_analyzer_1_array_crystal_array_6_mask_string
#define mask_setting mccchannel_14_analyzer_1_array_crystal_array_6_mask_setting
#define number_of_activations mccchannel_14_analyzer_1_array_crystal_array_6_number_of_activations
#line 204 "Union_box.comp"
// Needed for transport to the main component
struct global_geometry_element_struct global_geometry_element;

#ifndef ANY_GEOMETRY_DETECTOR_DECLARE
    #define ANY_GEOMETRY_DETECTOR_DECLARE dummy
	//struct pointer_to_global_geometry_list global_geometry_list = {0,NULL};
#endif

int loop_index,found_geometries;

double x_component;
double y_component;
double z_component;

struct Volume_struct this_box_volume;
struct box_storage this_box_storage;

#line 70210 "MACS_sample_kidney_box.c"
#undef number_of_activations
#undef mask_setting
#undef mask_string
#undef p_interact
#undef focus_r
#undef focus_xh
#undef focus_xw
#undef focus_ah
#undef focus_aw
#undef target_z
#undef target_y
#undef target_x
#undef target_index
#undef visualize
#undef yheight2
#undef xwidth2
#undef zdepth
#undef yheight
#undef xwidth
#undef priority
#undef material_string
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

/* User declarations for component 'channel_14_analyzer_1_array_crystal_array_7' [669]. */
#define mccompcurname  channel_14_analyzer_1_array_crystal_array_7
#define mccompcurtype  Union_box
#define mccompcurindex 669
#define loop_index mccchannel_14_analyzer_1_array_crystal_array_7_loop_index
#define this_box_volume mccchannel_14_analyzer_1_array_crystal_array_7_this_box_volume
#define global_geometry_element mccchannel_14_analyzer_1_array_crystal_array_7_global_geometry_element
#define this_box_storage mccchannel_14_analyzer_1_array_crystal_array_7_this_box_storage
#define material_string mccchannel_14_analyzer_1_array_crystal_array_7_material_string
#define priority mccchannel_14_analyzer_1_array_crystal_array_7_priority
#define xwidth mccchannel_14_analyzer_1_array_crystal_array_7_xwidth
#define yheight mccchannel_14_analyzer_1_array_crystal_array_7_yheight
#define zdepth mccchannel_14_analyzer_1_array_crystal_array_7_zdepth
#define xwidth2 mccchannel_14_analyzer_1_array_crystal_array_7_xwidth2
#define yheight2 mccchannel_14_analyzer_1_array_crystal_array_7_yheight2
#define visualize mccchannel_14_analyzer_1_array_crystal_array_7_visualize
#define target_index mccchannel_14_analyzer_1_array_crystal_array_7_target_index
#define target_x mccchannel_14_analyzer_1_array_crystal_array_7_target_x
#define target_y mccchannel_14_analyzer_1_array_crystal_array_7_target_y
#define target_z mccchannel_14_analyzer_1_array_crystal_array_7_target_z
#define focus_aw mccchannel_14_analyzer_1_array_crystal_array_7_focus_aw
#define focus_ah mccchannel_14_analyzer_1_array_crystal_array_7_focus_ah
#define focus_xw mccchannel_14_analyzer_1_array_crystal_array_7_focus_xw
#define focus_xh mccchannel_14_analyzer_1_array_crystal_array_7_focus_xh
#define focus_r mccchannel_14_analyzer_1_array_crystal_array_7_focus_r
#define p_interact mccchannel_14_analyzer_1_array_crystal_array_7_p_interact
#define mask_string mccchannel_14_analyzer_1_array_crystal_array_7_mask_string
#define mask_setting mccchannel_14_analyzer_1_array_crystal_array_7_mask_setting
#define number_of_activations mccchannel_14_analyzer_1_array_crystal_array_7_number_of_activations
#line 204 "Union_box.comp"
// Needed for transport to the main component
struct global_geometry_element_struct global_geometry_element;

#ifndef ANY_GEOMETRY_DETECTOR_DECLARE
    #define ANY_GEOMETRY_DETECTOR_DECLARE dummy
	//struct pointer_to_global_geometry_list global_geometry_list = {0,NULL};
#endif

int loop_index,found_geometries;

double x_component;
double y_component;
double z_component;

struct Volume_struct this_box_volume;
struct box_storage this_box_storage;

#line 70287 "MACS_sample_kidney_box.c"
#undef number_of_activations
#undef mask_setting
#undef mask_string
#undef p_interact
#undef focus_r
#undef focus_xh
#undef focus_xw
#undef focus_ah
#undef focus_aw
#undef target_z
#undef target_y
#undef target_x
#undef target_index
#undef visualize
#undef yheight2
#undef xwidth2
#undef zdepth
#undef yheight
#undef xwidth
#undef priority
#undef material_string
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

/* User declarations for component 'channel_14_analyzer_1_array_crystal_array_8' [670]. */
#define mccompcurname  channel_14_analyzer_1_array_crystal_array_8
#define mccompcurtype  Union_box
#define mccompcurindex 670
#define loop_index mccchannel_14_analyzer_1_array_crystal_array_8_loop_index
#define this_box_volume mccchannel_14_analyzer_1_array_crystal_array_8_this_box_volume
#define global_geometry_element mccchannel_14_analyzer_1_array_crystal_array_8_global_geometry_element
#define this_box_storage mccchannel_14_analyzer_1_array_crystal_array_8_this_box_storage
#define material_string mccchannel_14_analyzer_1_array_crystal_array_8_material_string
#define priority mccchannel_14_analyzer_1_array_crystal_array_8_priority
#define xwidth mccchannel_14_analyzer_1_array_crystal_array_8_xwidth
#define yheight mccchannel_14_analyzer_1_array_crystal_array_8_yheight
#define zdepth mccchannel_14_analyzer_1_array_crystal_array_8_zdepth
#define xwidth2 mccchannel_14_analyzer_1_array_crystal_array_8_xwidth2
#define yheight2 mccchannel_14_analyzer_1_array_crystal_array_8_yheight2
#define visualize mccchannel_14_analyzer_1_array_crystal_array_8_visualize
#define target_index mccchannel_14_analyzer_1_array_crystal_array_8_target_index
#define target_x mccchannel_14_analyzer_1_array_crystal_array_8_target_x
#define target_y mccchannel_14_analyzer_1_array_crystal_array_8_target_y
#define target_z mccchannel_14_analyzer_1_array_crystal_array_8_target_z
#define focus_aw mccchannel_14_analyzer_1_array_crystal_array_8_focus_aw
#define focus_ah mccchannel_14_analyzer_1_array_crystal_array_8_focus_ah
#define focus_xw mccchannel_14_analyzer_1_array_crystal_array_8_focus_xw
#define focus_xh mccchannel_14_analyzer_1_array_crystal_array_8_focus_xh
#define focus_r mccchannel_14_analyzer_1_array_crystal_array_8_focus_r
#define p_interact mccchannel_14_analyzer_1_array_crystal_array_8_p_interact
#define mask_string mccchannel_14_analyzer_1_array_crystal_array_8_mask_string
#define mask_setting mccchannel_14_analyzer_1_array_crystal_array_8_mask_setting
#define number_of_activations mccchannel_14_analyzer_1_array_crystal_array_8_number_of_activations
#line 204 "Union_box.comp"
// Needed for transport to the main component
struct global_geometry_element_struct global_geometry_element;

#ifndef ANY_GEOMETRY_DETECTOR_DECLARE
    #define ANY_GEOMETRY_DETECTOR_DECLARE dummy
	//struct pointer_to_global_geometry_list global_geometry_list = {0,NULL};
#endif

int loop_index,found_geometries;

double x_component;
double y_component;
double z_component;

struct Volume_struct this_box_volume;
struct box_storage this_box_storage;

#line 70364 "MACS_sample_kidney_box.c"
#undef number_of_activations
#undef mask_setting
#undef mask_string
#undef p_interact
#undef focus_r
#undef focus_xh
#undef focus_xw
#undef focus_ah
#undef focus_aw
#undef target_z
#undef target_y
#undef target_x
#undef target_index
#undef visualize
#undef yheight2
#undef xwidth2
#undef zdepth
#undef yheight
#undef xwidth
#undef priority
#undef material_string
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

/* User declarations for component 'channel_14_analyzer_2_center' [671]. */
#define mccompcurname  channel_14_analyzer_2_center
#define mccompcurtype  Arm
#define mccompcurindex 671
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

/* User declarations for component 'channel_14_analyzer_2_rotated' [672]. */
#define mccompcurname  channel_14_analyzer_2_rotated
#define mccompcurtype  Arm
#define mccompcurindex 672
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

/* User declarations for component 'channel_14_analyzer_2_array_crystal_array_0' [673]. */
#define mccompcurname  channel_14_analyzer_2_array_crystal_array_0
#define mccompcurtype  Union_box
#define mccompcurindex 673
#define loop_index mccchannel_14_analyzer_2_array_crystal_array_0_loop_index
#define this_box_volume mccchannel_14_analyzer_2_array_crystal_array_0_this_box_volume
#define global_geometry_element mccchannel_14_analyzer_2_array_crystal_array_0_global_geometry_element
#define this_box_storage mccchannel_14_analyzer_2_array_crystal_array_0_this_box_storage
#define material_string mccchannel_14_analyzer_2_array_crystal_array_0_material_string
#define priority mccchannel_14_analyzer_2_array_crystal_array_0_priority
#define xwidth mccchannel_14_analyzer_2_array_crystal_array_0_xwidth
#define yheight mccchannel_14_analyzer_2_array_crystal_array_0_yheight
#define zdepth mccchannel_14_analyzer_2_array_crystal_array_0_zdepth
#define xwidth2 mccchannel_14_analyzer_2_array_crystal_array_0_xwidth2
#define yheight2 mccchannel_14_analyzer_2_array_crystal_array_0_yheight2
#define visualize mccchannel_14_analyzer_2_array_crystal_array_0_visualize
#define target_index mccchannel_14_analyzer_2_array_crystal_array_0_target_index
#define target_x mccchannel_14_analyzer_2_array_crystal_array_0_target_x
#define target_y mccchannel_14_analyzer_2_array_crystal_array_0_target_y
#define target_z mccchannel_14_analyzer_2_array_crystal_array_0_target_z
#define focus_aw mccchannel_14_analyzer_2_array_crystal_array_0_focus_aw
#define focus_ah mccchannel_14_analyzer_2_array_crystal_array_0_focus_ah
#define focus_xw mccchannel_14_analyzer_2_array_crystal_array_0_focus_xw
#define focus_xh mccchannel_14_analyzer_2_array_crystal_array_0_focus_xh
#define focus_r mccchannel_14_analyzer_2_array_crystal_array_0_focus_r
#define p_interact mccchannel_14_analyzer_2_array_crystal_array_0_p_interact
#define mask_string mccchannel_14_analyzer_2_array_crystal_array_0_mask_string
#define mask_setting mccchannel_14_analyzer_2_array_crystal_array_0_mask_setting
#define number_of_activations mccchannel_14_analyzer_2_array_crystal_array_0_number_of_activations
#line 204 "Union_box.comp"
// Needed for transport to the main component
struct global_geometry_element_struct global_geometry_element;

#ifndef ANY_GEOMETRY_DETECTOR_DECLARE
    #define ANY_GEOMETRY_DETECTOR_DECLARE dummy
	//struct pointer_to_global_geometry_list global_geometry_list = {0,NULL};
#endif

int loop_index,found_geometries;

double x_component;
double y_component;
double z_component;

struct Volume_struct this_box_volume;
struct box_storage this_box_storage;

#line 70457 "MACS_sample_kidney_box.c"
#undef number_of_activations
#undef mask_setting
#undef mask_string
#undef p_interact
#undef focus_r
#undef focus_xh
#undef focus_xw
#undef focus_ah
#undef focus_aw
#undef target_z
#undef target_y
#undef target_x
#undef target_index
#undef visualize
#undef yheight2
#undef xwidth2
#undef zdepth
#undef yheight
#undef xwidth
#undef priority
#undef material_string
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

/* User declarations for component 'channel_14_analyzer_2_array_crystal_array_1' [674]. */
#define mccompcurname  channel_14_analyzer_2_array_crystal_array_1
#define mccompcurtype  Union_box
#define mccompcurindex 674
#define loop_index mccchannel_14_analyzer_2_array_crystal_array_1_loop_index
#define this_box_volume mccchannel_14_analyzer_2_array_crystal_array_1_this_box_volume
#define global_geometry_element mccchannel_14_analyzer_2_array_crystal_array_1_global_geometry_element
#define this_box_storage mccchannel_14_analyzer_2_array_crystal_array_1_this_box_storage
#define material_string mccchannel_14_analyzer_2_array_crystal_array_1_material_string
#define priority mccchannel_14_analyzer_2_array_crystal_array_1_priority
#define xwidth mccchannel_14_analyzer_2_array_crystal_array_1_xwidth
#define yheight mccchannel_14_analyzer_2_array_crystal_array_1_yheight
#define zdepth mccchannel_14_analyzer_2_array_crystal_array_1_zdepth
#define xwidth2 mccchannel_14_analyzer_2_array_crystal_array_1_xwidth2
#define yheight2 mccchannel_14_analyzer_2_array_crystal_array_1_yheight2
#define visualize mccchannel_14_analyzer_2_array_crystal_array_1_visualize
#define target_index mccchannel_14_analyzer_2_array_crystal_array_1_target_index
#define target_x mccchannel_14_analyzer_2_array_crystal_array_1_target_x
#define target_y mccchannel_14_analyzer_2_array_crystal_array_1_target_y
#define target_z mccchannel_14_analyzer_2_array_crystal_array_1_target_z
#define focus_aw mccchannel_14_analyzer_2_array_crystal_array_1_focus_aw
#define focus_ah mccchannel_14_analyzer_2_array_crystal_array_1_focus_ah
#define focus_xw mccchannel_14_analyzer_2_array_crystal_array_1_focus_xw
#define focus_xh mccchannel_14_analyzer_2_array_crystal_array_1_focus_xh
#define focus_r mccchannel_14_analyzer_2_array_crystal_array_1_focus_r
#define p_interact mccchannel_14_analyzer_2_array_crystal_array_1_p_interact
#define mask_string mccchannel_14_analyzer_2_array_crystal_array_1_mask_string
#define mask_setting mccchannel_14_analyzer_2_array_crystal_array_1_mask_setting
#define number_of_activations mccchannel_14_analyzer_2_array_crystal_array_1_number_of_activations
#line 204 "Union_box.comp"
// Needed for transport to the main component
struct global_geometry_element_struct global_geometry_element;

#ifndef ANY_GEOMETRY_DETECTOR_DECLARE
    #define ANY_GEOMETRY_DETECTOR_DECLARE dummy
	//struct pointer_to_global_geometry_list global_geometry_list = {0,NULL};
#endif

int loop_index,found_geometries;

double x_component;
double y_component;
double z_component;

struct Volume_struct this_box_volume;
struct box_storage this_box_storage;

#line 70534 "MACS_sample_kidney_box.c"
#undef number_of_activations
#undef mask_setting
#undef mask_string
#undef p_interact
#undef focus_r
#undef focus_xh
#undef focus_xw
#undef focus_ah
#undef focus_aw
#undef target_z
#undef target_y
#undef target_x
#undef target_index
#undef visualize
#undef yheight2
#undef xwidth2
#undef zdepth
#undef yheight
#undef xwidth
#undef priority
#undef material_string
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

/* User declarations for component 'channel_14_analyzer_2_array_crystal_array_2' [675]. */
#define mccompcurname  channel_14_analyzer_2_array_crystal_array_2
#define mccompcurtype  Union_box
#define mccompcurindex 675
#define loop_index mccchannel_14_analyzer_2_array_crystal_array_2_loop_index
#define this_box_volume mccchannel_14_analyzer_2_array_crystal_array_2_this_box_volume
#define global_geometry_element mccchannel_14_analyzer_2_array_crystal_array_2_global_geometry_element
#define this_box_storage mccchannel_14_analyzer_2_array_crystal_array_2_this_box_storage
#define material_string mccchannel_14_analyzer_2_array_crystal_array_2_material_string
#define priority mccchannel_14_analyzer_2_array_crystal_array_2_priority
#define xwidth mccchannel_14_analyzer_2_array_crystal_array_2_xwidth
#define yheight mccchannel_14_analyzer_2_array_crystal_array_2_yheight
#define zdepth mccchannel_14_analyzer_2_array_crystal_array_2_zdepth
#define xwidth2 mccchannel_14_analyzer_2_array_crystal_array_2_xwidth2
#define yheight2 mccchannel_14_analyzer_2_array_crystal_array_2_yheight2
#define visualize mccchannel_14_analyzer_2_array_crystal_array_2_visualize
#define target_index mccchannel_14_analyzer_2_array_crystal_array_2_target_index
#define target_x mccchannel_14_analyzer_2_array_crystal_array_2_target_x
#define target_y mccchannel_14_analyzer_2_array_crystal_array_2_target_y
#define target_z mccchannel_14_analyzer_2_array_crystal_array_2_target_z
#define focus_aw mccchannel_14_analyzer_2_array_crystal_array_2_focus_aw
#define focus_ah mccchannel_14_analyzer_2_array_crystal_array_2_focus_ah
#define focus_xw mccchannel_14_analyzer_2_array_crystal_array_2_focus_xw
#define focus_xh mccchannel_14_analyzer_2_array_crystal_array_2_focus_xh
#define focus_r mccchannel_14_analyzer_2_array_crystal_array_2_focus_r
#define p_interact mccchannel_14_analyzer_2_array_crystal_array_2_p_interact
#define mask_string mccchannel_14_analyzer_2_array_crystal_array_2_mask_string
#define mask_setting mccchannel_14_analyzer_2_array_crystal_array_2_mask_setting
#define number_of_activations mccchannel_14_analyzer_2_array_crystal_array_2_number_of_activations
#line 204 "Union_box.comp"
// Needed for transport to the main component
struct global_geometry_element_struct global_geometry_element;

#ifndef ANY_GEOMETRY_DETECTOR_DECLARE
    #define ANY_GEOMETRY_DETECTOR_DECLARE dummy
	//struct pointer_to_global_geometry_list global_geometry_list = {0,NULL};
#endif

int loop_index,found_geometries;

double x_component;
double y_component;
double z_component;

struct Volume_struct this_box_volume;
struct box_storage this_box_storage;

#line 70611 "MACS_sample_kidney_box.c"
#undef number_of_activations
#undef mask_setting
#undef mask_string
#undef p_interact
#undef focus_r
#undef focus_xh
#undef focus_xw
#undef focus_ah
#undef focus_aw
#undef target_z
#undef target_y
#undef target_x
#undef target_index
#undef visualize
#undef yheight2
#undef xwidth2
#undef zdepth
#undef yheight
#undef xwidth
#undef priority
#undef material_string
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

/* User declarations for component 'channel_14_analyzer_2_array_crystal_array_3' [676]. */
#define mccompcurname  channel_14_analyzer_2_array_crystal_array_3
#define mccompcurtype  Union_box
#define mccompcurindex 676
#define loop_index mccchannel_14_analyzer_2_array_crystal_array_3_loop_index
#define this_box_volume mccchannel_14_analyzer_2_array_crystal_array_3_this_box_volume
#define global_geometry_element mccchannel_14_analyzer_2_array_crystal_array_3_global_geometry_element
#define this_box_storage mccchannel_14_analyzer_2_array_crystal_array_3_this_box_storage
#define material_string mccchannel_14_analyzer_2_array_crystal_array_3_material_string
#define priority mccchannel_14_analyzer_2_array_crystal_array_3_priority
#define xwidth mccchannel_14_analyzer_2_array_crystal_array_3_xwidth
#define yheight mccchannel_14_analyzer_2_array_crystal_array_3_yheight
#define zdepth mccchannel_14_analyzer_2_array_crystal_array_3_zdepth
#define xwidth2 mccchannel_14_analyzer_2_array_crystal_array_3_xwidth2
#define yheight2 mccchannel_14_analyzer_2_array_crystal_array_3_yheight2
#define visualize mccchannel_14_analyzer_2_array_crystal_array_3_visualize
#define target_index mccchannel_14_analyzer_2_array_crystal_array_3_target_index
#define target_x mccchannel_14_analyzer_2_array_crystal_array_3_target_x
#define target_y mccchannel_14_analyzer_2_array_crystal_array_3_target_y
#define target_z mccchannel_14_analyzer_2_array_crystal_array_3_target_z
#define focus_aw mccchannel_14_analyzer_2_array_crystal_array_3_focus_aw
#define focus_ah mccchannel_14_analyzer_2_array_crystal_array_3_focus_ah
#define focus_xw mccchannel_14_analyzer_2_array_crystal_array_3_focus_xw
#define focus_xh mccchannel_14_analyzer_2_array_crystal_array_3_focus_xh
#define focus_r mccchannel_14_analyzer_2_array_crystal_array_3_focus_r
#define p_interact mccchannel_14_analyzer_2_array_crystal_array_3_p_interact
#define mask_string mccchannel_14_analyzer_2_array_crystal_array_3_mask_string
#define mask_setting mccchannel_14_analyzer_2_array_crystal_array_3_mask_setting
#define number_of_activations mccchannel_14_analyzer_2_array_crystal_array_3_number_of_activations
#line 204 "Union_box.comp"
// Needed for transport to the main component
struct global_geometry_element_struct global_geometry_element;

#ifndef ANY_GEOMETRY_DETECTOR_DECLARE
    #define ANY_GEOMETRY_DETECTOR_DECLARE dummy
	//struct pointer_to_global_geometry_list global_geometry_list = {0,NULL};
#endif

int loop_index,found_geometries;

double x_component;
double y_component;
double z_component;

struct Volume_struct this_box_volume;
struct box_storage this_box_storage;

#line 70688 "MACS_sample_kidney_box.c"
#undef number_of_activations
#undef mask_setting
#undef mask_string
#undef p_interact
#undef focus_r
#undef focus_xh
#undef focus_xw
#undef focus_ah
#undef focus_aw
#undef target_z
#undef target_y
#undef target_x
#undef target_index
#undef visualize
#undef yheight2
#undef xwidth2
#undef zdepth
#undef yheight
#undef xwidth
#undef priority
#undef material_string
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

/* User declarations for component 'channel_14_analyzer_2_array_crystal_array_4' [677]. */
#define mccompcurname  channel_14_analyzer_2_array_crystal_array_4
#define mccompcurtype  Union_box
#define mccompcurindex 677
#define loop_index mccchannel_14_analyzer_2_array_crystal_array_4_loop_index
#define this_box_volume mccchannel_14_analyzer_2_array_crystal_array_4_this_box_volume
#define global_geometry_element mccchannel_14_analyzer_2_array_crystal_array_4_global_geometry_element
#define this_box_storage mccchannel_14_analyzer_2_array_crystal_array_4_this_box_storage
#define material_string mccchannel_14_analyzer_2_array_crystal_array_4_material_string
#define priority mccchannel_14_analyzer_2_array_crystal_array_4_priority
#define xwidth mccchannel_14_analyzer_2_array_crystal_array_4_xwidth
#define yheight mccchannel_14_analyzer_2_array_crystal_array_4_yheight
#define zdepth mccchannel_14_analyzer_2_array_crystal_array_4_zdepth
#define xwidth2 mccchannel_14_analyzer_2_array_crystal_array_4_xwidth2
#define yheight2 mccchannel_14_analyzer_2_array_crystal_array_4_yheight2
#define visualize mccchannel_14_analyzer_2_array_crystal_array_4_visualize
#define target_index mccchannel_14_analyzer_2_array_crystal_array_4_target_index
#define target_x mccchannel_14_analyzer_2_array_crystal_array_4_target_x
#define target_y mccchannel_14_analyzer_2_array_crystal_array_4_target_y
#define target_z mccchannel_14_analyzer_2_array_crystal_array_4_target_z
#define focus_aw mccchannel_14_analyzer_2_array_crystal_array_4_focus_aw
#define focus_ah mccchannel_14_analyzer_2_array_crystal_array_4_focus_ah
#define focus_xw mccchannel_14_analyzer_2_array_crystal_array_4_focus_xw
#define focus_xh mccchannel_14_analyzer_2_array_crystal_array_4_focus_xh
#define focus_r mccchannel_14_analyzer_2_array_crystal_array_4_focus_r
#define p_interact mccchannel_14_analyzer_2_array_crystal_array_4_p_interact
#define mask_string mccchannel_14_analyzer_2_array_crystal_array_4_mask_string
#define mask_setting mccchannel_14_analyzer_2_array_crystal_array_4_mask_setting
#define number_of_activations mccchannel_14_analyzer_2_array_crystal_array_4_number_of_activations
#line 204 "Union_box.comp"
// Needed for transport to the main component
struct global_geometry_element_struct global_geometry_element;

#ifndef ANY_GEOMETRY_DETECTOR_DECLARE
    #define ANY_GEOMETRY_DETECTOR_DECLARE dummy
	//struct pointer_to_global_geometry_list global_geometry_list = {0,NULL};
#endif

int loop_index,found_geometries;

double x_component;
double y_component;
double z_component;

struct Volume_struct this_box_volume;
struct box_storage this_box_storage;

#line 70765 "MACS_sample_kidney_box.c"
#undef number_of_activations
#undef mask_setting
#undef mask_string
#undef p_interact
#undef focus_r
#undef focus_xh
#undef focus_xw
#undef focus_ah
#undef focus_aw
#undef target_z
#undef target_y
#undef target_x
#undef target_index
#undef visualize
#undef yheight2
#undef xwidth2
#undef zdepth
#undef yheight
#undef xwidth
#undef priority
#undef material_string
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

/* User declarations for component 'channel_14_analyzer_2_array_crystal_array_5' [678]. */
#define mccompcurname  channel_14_analyzer_2_array_crystal_array_5
#define mccompcurtype  Union_box
#define mccompcurindex 678
#define loop_index mccchannel_14_analyzer_2_array_crystal_array_5_loop_index
#define this_box_volume mccchannel_14_analyzer_2_array_crystal_array_5_this_box_volume
#define global_geometry_element mccchannel_14_analyzer_2_array_crystal_array_5_global_geometry_element
#define this_box_storage mccchannel_14_analyzer_2_array_crystal_array_5_this_box_storage
#define material_string mccchannel_14_analyzer_2_array_crystal_array_5_material_string
#define priority mccchannel_14_analyzer_2_array_crystal_array_5_priority
#define xwidth mccchannel_14_analyzer_2_array_crystal_array_5_xwidth
#define yheight mccchannel_14_analyzer_2_array_crystal_array_5_yheight
#define zdepth mccchannel_14_analyzer_2_array_crystal_array_5_zdepth
#define xwidth2 mccchannel_14_analyzer_2_array_crystal_array_5_xwidth2
#define yheight2 mccchannel_14_analyzer_2_array_crystal_array_5_yheight2
#define visualize mccchannel_14_analyzer_2_array_crystal_array_5_visualize
#define target_index mccchannel_14_analyzer_2_array_crystal_array_5_target_index
#define target_x mccchannel_14_analyzer_2_array_crystal_array_5_target_x
#define target_y mccchannel_14_analyzer_2_array_crystal_array_5_target_y
#define target_z mccchannel_14_analyzer_2_array_crystal_array_5_target_z
#define focus_aw mccchannel_14_analyzer_2_array_crystal_array_5_focus_aw
#define focus_ah mccchannel_14_analyzer_2_array_crystal_array_5_focus_ah
#define focus_xw mccchannel_14_analyzer_2_array_crystal_array_5_focus_xw
#define focus_xh mccchannel_14_analyzer_2_array_crystal_array_5_focus_xh
#define focus_r mccchannel_14_analyzer_2_array_crystal_array_5_focus_r
#define p_interact mccchannel_14_analyzer_2_array_crystal_array_5_p_interact
#define mask_string mccchannel_14_analyzer_2_array_crystal_array_5_mask_string
#define mask_setting mccchannel_14_analyzer_2_array_crystal_array_5_mask_setting
#define number_of_activations mccchannel_14_analyzer_2_array_crystal_array_5_number_of_activations
#line 204 "Union_box.comp"
// Needed for transport to the main component
struct global_geometry_element_struct global_geometry_element;

#ifndef ANY_GEOMETRY_DETECTOR_DECLARE
    #define ANY_GEOMETRY_DETECTOR_DECLARE dummy
	//struct pointer_to_global_geometry_list global_geometry_list = {0,NULL};
#endif

int loop_index,found_geometries;

double x_component;
double y_component;
double z_component;

struct Volume_struct this_box_volume;
struct box_storage this_box_storage;

#line 70842 "MACS_sample_kidney_box.c"
#undef number_of_activations
#undef mask_setting
#undef mask_string
#undef p_interact
#undef focus_r
#undef focus_xh
#undef focus_xw
#undef focus_ah
#undef focus_aw
#undef target_z
#undef target_y
#undef target_x
#undef target_index
#undef visualize
#undef yheight2
#undef xwidth2
#undef zdepth
#undef yheight
#undef xwidth
#undef priority
#undef material_string
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

/* User declarations for component 'channel_14_analyzer_2_array_crystal_array_6' [679]. */
#define mccompcurname  channel_14_analyzer_2_array_crystal_array_6
#define mccompcurtype  Union_box
#define mccompcurindex 679
#define loop_index mccchannel_14_analyzer_2_array_crystal_array_6_loop_index
#define this_box_volume mccchannel_14_analyzer_2_array_crystal_array_6_this_box_volume
#define global_geometry_element mccchannel_14_analyzer_2_array_crystal_array_6_global_geometry_element
#define this_box_storage mccchannel_14_analyzer_2_array_crystal_array_6_this_box_storage
#define material_string mccchannel_14_analyzer_2_array_crystal_array_6_material_string
#define priority mccchannel_14_analyzer_2_array_crystal_array_6_priority
#define xwidth mccchannel_14_analyzer_2_array_crystal_array_6_xwidth
#define yheight mccchannel_14_analyzer_2_array_crystal_array_6_yheight
#define zdepth mccchannel_14_analyzer_2_array_crystal_array_6_zdepth
#define xwidth2 mccchannel_14_analyzer_2_array_crystal_array_6_xwidth2
#define yheight2 mccchannel_14_analyzer_2_array_crystal_array_6_yheight2
#define visualize mccchannel_14_analyzer_2_array_crystal_array_6_visualize
#define target_index mccchannel_14_analyzer_2_array_crystal_array_6_target_index
#define target_x mccchannel_14_analyzer_2_array_crystal_array_6_target_x
#define target_y mccchannel_14_analyzer_2_array_crystal_array_6_target_y
#define target_z mccchannel_14_analyzer_2_array_crystal_array_6_target_z
#define focus_aw mccchannel_14_analyzer_2_array_crystal_array_6_focus_aw
#define focus_ah mccchannel_14_analyzer_2_array_crystal_array_6_focus_ah
#define focus_xw mccchannel_14_analyzer_2_array_crystal_array_6_focus_xw
#define focus_xh mccchannel_14_analyzer_2_array_crystal_array_6_focus_xh
#define focus_r mccchannel_14_analyzer_2_array_crystal_array_6_focus_r
#define p_interact mccchannel_14_analyzer_2_array_crystal_array_6_p_interact
#define mask_string mccchannel_14_analyzer_2_array_crystal_array_6_mask_string
#define mask_setting mccchannel_14_analyzer_2_array_crystal_array_6_mask_setting
#define number_of_activations mccchannel_14_analyzer_2_array_crystal_array_6_number_of_activations
#line 204 "Union_box.comp"
// Needed for transport to the main component
struct global_geometry_element_struct global_geometry_element;

#ifndef ANY_GEOMETRY_DETECTOR_DECLARE
    #define ANY_GEOMETRY_DETECTOR_DECLARE dummy
	//struct pointer_to_global_geometry_list global_geometry_list = {0,NULL};
#endif

int loop_index,found_geometries;

double x_component;
double y_component;
double z_component;

struct Volume_struct this_box_volume;
struct box_storage this_box_storage;

#line 70919 "MACS_sample_kidney_box.c"
#undef number_of_activations
#undef mask_setting
#undef mask_string
#undef p_interact
#undef focus_r
#undef focus_xh
#undef focus_xw
#undef focus_ah
#undef focus_aw
#undef target_z
#undef target_y
#undef target_x
#undef target_index
#undef visualize
#undef yheight2
#undef xwidth2
#undef zdepth
#undef yheight
#undef xwidth
#undef priority
#undef material_string
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

/* User declarations for component 'channel_14_analyzer_2_array_crystal_array_7' [680]. */
#define mccompcurname  channel_14_analyzer_2_array_crystal_array_7
#define mccompcurtype  Union_box
#define mccompcurindex 680
#define loop_index mccchannel_14_analyzer_2_array_crystal_array_7_loop_index
#define this_box_volume mccchannel_14_analyzer_2_array_crystal_array_7_this_box_volume
#define global_geometry_element mccchannel_14_analyzer_2_array_crystal_array_7_global_geometry_element
#define this_box_storage mccchannel_14_analyzer_2_array_crystal_array_7_this_box_storage
#define material_string mccchannel_14_analyzer_2_array_crystal_array_7_material_string
#define priority mccchannel_14_analyzer_2_array_crystal_array_7_priority
#define xwidth mccchannel_14_analyzer_2_array_crystal_array_7_xwidth
#define yheight mccchannel_14_analyzer_2_array_crystal_array_7_yheight
#define zdepth mccchannel_14_analyzer_2_array_crystal_array_7_zdepth
#define xwidth2 mccchannel_14_analyzer_2_array_crystal_array_7_xwidth2
#define yheight2 mccchannel_14_analyzer_2_array_crystal_array_7_yheight2
#define visualize mccchannel_14_analyzer_2_array_crystal_array_7_visualize
#define target_index mccchannel_14_analyzer_2_array_crystal_array_7_target_index
#define target_x mccchannel_14_analyzer_2_array_crystal_array_7_target_x
#define target_y mccchannel_14_analyzer_2_array_crystal_array_7_target_y
#define target_z mccchannel_14_analyzer_2_array_crystal_array_7_target_z
#define focus_aw mccchannel_14_analyzer_2_array_crystal_array_7_focus_aw
#define focus_ah mccchannel_14_analyzer_2_array_crystal_array_7_focus_ah
#define focus_xw mccchannel_14_analyzer_2_array_crystal_array_7_focus_xw
#define focus_xh mccchannel_14_analyzer_2_array_crystal_array_7_focus_xh
#define focus_r mccchannel_14_analyzer_2_array_crystal_array_7_focus_r
#define p_interact mccchannel_14_analyzer_2_array_crystal_array_7_p_interact
#define mask_string mccchannel_14_analyzer_2_array_crystal_array_7_mask_string
#define mask_setting mccchannel_14_analyzer_2_array_crystal_array_7_mask_setting
#define number_of_activations mccchannel_14_analyzer_2_array_crystal_array_7_number_of_activations
#line 204 "Union_box.comp"
// Needed for transport to the main component
struct global_geometry_element_struct global_geometry_element;

#ifndef ANY_GEOMETRY_DETECTOR_DECLARE
    #define ANY_GEOMETRY_DETECTOR_DECLARE dummy
	//struct pointer_to_global_geometry_list global_geometry_list = {0,NULL};
#endif

int loop_index,found_geometries;

double x_component;
double y_component;
double z_component;

struct Volume_struct this_box_volume;
struct box_storage this_box_storage;

#line 70996 "MACS_sample_kidney_box.c"
#undef number_of_activations
#undef mask_setting
#undef mask_string
#undef p_interact
#undef focus_r
#undef focus_xh
#undef focus_xw
#undef focus_ah
#undef focus_aw
#undef target_z
#undef target_y
#undef target_x
#undef target_index
#undef visualize
#undef yheight2
#undef xwidth2
#undef zdepth
#undef yheight
#undef xwidth
#undef priority
#undef material_string
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

/* User declarations for component 'channel_14_analyzer_2_array_crystal_array_8' [681]. */
#define mccompcurname  channel_14_analyzer_2_array_crystal_array_8
#define mccompcurtype  Union_box
#define mccompcurindex 681
#define loop_index mccchannel_14_analyzer_2_array_crystal_array_8_loop_index
#define this_box_volume mccchannel_14_analyzer_2_array_crystal_array_8_this_box_volume
#define global_geometry_element mccchannel_14_analyzer_2_array_crystal_array_8_global_geometry_element
#define this_box_storage mccchannel_14_analyzer_2_array_crystal_array_8_this_box_storage
#define material_string mccchannel_14_analyzer_2_array_crystal_array_8_material_string
#define priority mccchannel_14_analyzer_2_array_crystal_array_8_priority
#define xwidth mccchannel_14_analyzer_2_array_crystal_array_8_xwidth
#define yheight mccchannel_14_analyzer_2_array_crystal_array_8_yheight
#define zdepth mccchannel_14_analyzer_2_array_crystal_array_8_zdepth
#define xwidth2 mccchannel_14_analyzer_2_array_crystal_array_8_xwidth2
#define yheight2 mccchannel_14_analyzer_2_array_crystal_array_8_yheight2
#define visualize mccchannel_14_analyzer_2_array_crystal_array_8_visualize
#define target_index mccchannel_14_analyzer_2_array_crystal_array_8_target_index
#define target_x mccchannel_14_analyzer_2_array_crystal_array_8_target_x
#define target_y mccchannel_14_analyzer_2_array_crystal_array_8_target_y
#define target_z mccchannel_14_analyzer_2_array_crystal_array_8_target_z
#define focus_aw mccchannel_14_analyzer_2_array_crystal_array_8_focus_aw
#define focus_ah mccchannel_14_analyzer_2_array_crystal_array_8_focus_ah
#define focus_xw mccchannel_14_analyzer_2_array_crystal_array_8_focus_xw
#define focus_xh mccchannel_14_analyzer_2_array_crystal_array_8_focus_xh
#define focus_r mccchannel_14_analyzer_2_array_crystal_array_8_focus_r
#define p_interact mccchannel_14_analyzer_2_array_crystal_array_8_p_interact
#define mask_string mccchannel_14_analyzer_2_array_crystal_array_8_mask_string
#define mask_setting mccchannel_14_analyzer_2_array_crystal_array_8_mask_setting
#define number_of_activations mccchannel_14_analyzer_2_array_crystal_array_8_number_of_activations
#line 204 "Union_box.comp"
// Needed for transport to the main component
struct global_geometry_element_struct global_geometry_element;

#ifndef ANY_GEOMETRY_DETECTOR_DECLARE
    #define ANY_GEOMETRY_DETECTOR_DECLARE dummy
	//struct pointer_to_global_geometry_list global_geometry_list = {0,NULL};
#endif

int loop_index,found_geometries;

double x_component;
double y_component;
double z_component;

struct Volume_struct this_box_volume;
struct box_storage this_box_storage;

#line 71073 "MACS_sample_kidney_box.c"
#undef number_of_activations
#undef mask_setting
#undef mask_string
#undef p_interact
#undef focus_r
#undef focus_xh
#undef focus_xw
#undef focus_ah
#undef focus_aw
#undef target_z
#undef target_y
#undef target_x
#undef target_index
#undef visualize
#undef yheight2
#undef xwidth2
#undef zdepth
#undef yheight
#undef xwidth
#undef priority
#undef material_string
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

/* User declarations for component 'channel_14_cave2_cyl1' [682]. */
#define mccompcurname  channel_14_cave2_cyl1
#define mccompcurtype  Union_cylinder
#define mccompcurindex 682
#define loop_index mccchannel_14_cave2_cyl1_loop_index
#define this_cylinder_volume mccchannel_14_cave2_cyl1_this_cylinder_volume
#define global_geometry_element mccchannel_14_cave2_cyl1_global_geometry_element
#define this_cylinder_storage mccchannel_14_cave2_cyl1_this_cylinder_storage
#define material_string mccchannel_14_cave2_cyl1_material_string
#define priority mccchannel_14_cave2_cyl1_priority
#define radius mccchannel_14_cave2_cyl1_radius
#define yheight mccchannel_14_cave2_cyl1_yheight
#define visualize mccchannel_14_cave2_cyl1_visualize
#define target_index mccchannel_14_cave2_cyl1_target_index
#define target_x mccchannel_14_cave2_cyl1_target_x
#define target_y mccchannel_14_cave2_cyl1_target_y
#define target_z mccchannel_14_cave2_cyl1_target_z
#define focus_aw mccchannel_14_cave2_cyl1_focus_aw
#define focus_ah mccchannel_14_cave2_cyl1_focus_ah
#define focus_xw mccchannel_14_cave2_cyl1_focus_xw
#define focus_xh mccchannel_14_cave2_cyl1_focus_xh
#define focus_r mccchannel_14_cave2_cyl1_focus_r
#define p_interact mccchannel_14_cave2_cyl1_p_interact
#define mask_string mccchannel_14_cave2_cyl1_mask_string
#define mask_setting mccchannel_14_cave2_cyl1_mask_setting
#define number_of_activations mccchannel_14_cave2_cyl1_number_of_activations
#line 167 "Union_cylinder.comp"
// Needed for transport to the main component
struct global_geometry_element_struct global_geometry_element;

#ifndef ANY_GEOMETRY_DETECTOR_DECLARE
    #define ANY_GEOMETRY_DETECTOR_DECLARE dummy
	//struct pointer_to_global_geometry_list global_geometry_list = {0,NULL};
#endif

int dummy;
int loop_index,found_geometries;
int loop_2_index;
int material_index;

struct Volume_struct this_cylinder_volume;
struct cylinder_storage this_cylinder_storage;
#line 71145 "MACS_sample_kidney_box.c"
#undef number_of_activations
#undef mask_setting
#undef mask_string
#undef p_interact
#undef focus_r
#undef focus_xh
#undef focus_xw
#undef focus_ah
#undef focus_aw
#undef target_z
#undef target_y
#undef target_x
#undef target_index
#undef visualize
#undef yheight
#undef radius
#undef priority
#undef material_string
#undef this_cylinder_storage
#undef global_geometry_element
#undef this_cylinder_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

/* User declarations for component 'channel_14_cave2_box1' [683]. */
#define mccompcurname  channel_14_cave2_box1
#define mccompcurtype  Union_box
#define mccompcurindex 683
#define loop_index mccchannel_14_cave2_box1_loop_index
#define this_box_volume mccchannel_14_cave2_box1_this_box_volume
#define global_geometry_element mccchannel_14_cave2_box1_global_geometry_element
#define this_box_storage mccchannel_14_cave2_box1_this_box_storage
#define material_string mccchannel_14_cave2_box1_material_string
#define priority mccchannel_14_cave2_box1_priority
#define xwidth mccchannel_14_cave2_box1_xwidth
#define yheight mccchannel_14_cave2_box1_yheight
#define zdepth mccchannel_14_cave2_box1_zdepth
#define xwidth2 mccchannel_14_cave2_box1_xwidth2
#define yheight2 mccchannel_14_cave2_box1_yheight2
#define visualize mccchannel_14_cave2_box1_visualize
#define target_index mccchannel_14_cave2_box1_target_index
#define target_x mccchannel_14_cave2_box1_target_x
#define target_y mccchannel_14_cave2_box1_target_y
#define target_z mccchannel_14_cave2_box1_target_z
#define focus_aw mccchannel_14_cave2_box1_focus_aw
#define focus_ah mccchannel_14_cave2_box1_focus_ah
#define focus_xw mccchannel_14_cave2_box1_focus_xw
#define focus_xh mccchannel_14_cave2_box1_focus_xh
#define focus_r mccchannel_14_cave2_box1_focus_r
#define p_interact mccchannel_14_cave2_box1_p_interact
#define mask_string mccchannel_14_cave2_box1_mask_string
#define mask_setting mccchannel_14_cave2_box1_mask_setting
#define number_of_activations mccchannel_14_cave2_box1_number_of_activations
#line 204 "Union_box.comp"
// Needed for transport to the main component
struct global_geometry_element_struct global_geometry_element;

#ifndef ANY_GEOMETRY_DETECTOR_DECLARE
    #define ANY_GEOMETRY_DETECTOR_DECLARE dummy
	//struct pointer_to_global_geometry_list global_geometry_list = {0,NULL};
#endif

int loop_index,found_geometries;

double x_component;
double y_component;
double z_component;

struct Volume_struct this_box_volume;
struct box_storage this_box_storage;

#line 71219 "MACS_sample_kidney_box.c"
#undef number_of_activations
#undef mask_setting
#undef mask_string
#undef p_interact
#undef focus_r
#undef focus_xh
#undef focus_xw
#undef focus_ah
#undef focus_aw
#undef target_z
#undef target_y
#undef target_x
#undef target_index
#undef visualize
#undef yheight2
#undef xwidth2
#undef zdepth
#undef yheight
#undef xwidth
#undef priority
#undef material_string
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

/* User declarations for component 'channel_14_cave2_box2' [684]. */
#define mccompcurname  channel_14_cave2_box2
#define mccompcurtype  Union_box
#define mccompcurindex 684
#define loop_index mccchannel_14_cave2_box2_loop_index
#define this_box_volume mccchannel_14_cave2_box2_this_box_volume
#define global_geometry_element mccchannel_14_cave2_box2_global_geometry_element
#define this_box_storage mccchannel_14_cave2_box2_this_box_storage
#define material_string mccchannel_14_cave2_box2_material_string
#define priority mccchannel_14_cave2_box2_priority
#define xwidth mccchannel_14_cave2_box2_xwidth
#define yheight mccchannel_14_cave2_box2_yheight
#define zdepth mccchannel_14_cave2_box2_zdepth
#define xwidth2 mccchannel_14_cave2_box2_xwidth2
#define yheight2 mccchannel_14_cave2_box2_yheight2
#define visualize mccchannel_14_cave2_box2_visualize
#define target_index mccchannel_14_cave2_box2_target_index
#define target_x mccchannel_14_cave2_box2_target_x
#define target_y mccchannel_14_cave2_box2_target_y
#define target_z mccchannel_14_cave2_box2_target_z
#define focus_aw mccchannel_14_cave2_box2_focus_aw
#define focus_ah mccchannel_14_cave2_box2_focus_ah
#define focus_xw mccchannel_14_cave2_box2_focus_xw
#define focus_xh mccchannel_14_cave2_box2_focus_xh
#define focus_r mccchannel_14_cave2_box2_focus_r
#define p_interact mccchannel_14_cave2_box2_p_interact
#define mask_string mccchannel_14_cave2_box2_mask_string
#define mask_setting mccchannel_14_cave2_box2_mask_setting
#define number_of_activations mccchannel_14_cave2_box2_number_of_activations
#line 204 "Union_box.comp"
// Needed for transport to the main component
struct global_geometry_element_struct global_geometry_element;

#ifndef ANY_GEOMETRY_DETECTOR_DECLARE
    #define ANY_GEOMETRY_DETECTOR_DECLARE dummy
	//struct pointer_to_global_geometry_list global_geometry_list = {0,NULL};
#endif

int loop_index,found_geometries;

double x_component;
double y_component;
double z_component;

struct Volume_struct this_box_volume;
struct box_storage this_box_storage;

#line 71296 "MACS_sample_kidney_box.c"
#undef number_of_activations
#undef mask_setting
#undef mask_string
#undef p_interact
#undef focus_r
#undef focus_xh
#undef focus_xw
#undef focus_ah
#undef focus_aw
#undef target_z
#undef target_y
#undef target_x
#undef target_index
#undef visualize
#undef yheight2
#undef xwidth2
#undef zdepth
#undef yheight
#undef xwidth
#undef priority
#undef material_string
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

/* User declarations for component 'channel_14_cave2_box3' [685]. */
#define mccompcurname  channel_14_cave2_box3
#define mccompcurtype  Union_box
#define mccompcurindex 685
#define loop_index mccchannel_14_cave2_box3_loop_index
#define this_box_volume mccchannel_14_cave2_box3_this_box_volume
#define global_geometry_element mccchannel_14_cave2_box3_global_geometry_element
#define this_box_storage mccchannel_14_cave2_box3_this_box_storage
#define material_string mccchannel_14_cave2_box3_material_string
#define priority mccchannel_14_cave2_box3_priority
#define xwidth mccchannel_14_cave2_box3_xwidth
#define yheight mccchannel_14_cave2_box3_yheight
#define zdepth mccchannel_14_cave2_box3_zdepth
#define xwidth2 mccchannel_14_cave2_box3_xwidth2
#define yheight2 mccchannel_14_cave2_box3_yheight2
#define visualize mccchannel_14_cave2_box3_visualize
#define target_index mccchannel_14_cave2_box3_target_index
#define target_x mccchannel_14_cave2_box3_target_x
#define target_y mccchannel_14_cave2_box3_target_y
#define target_z mccchannel_14_cave2_box3_target_z
#define focus_aw mccchannel_14_cave2_box3_focus_aw
#define focus_ah mccchannel_14_cave2_box3_focus_ah
#define focus_xw mccchannel_14_cave2_box3_focus_xw
#define focus_xh mccchannel_14_cave2_box3_focus_xh
#define focus_r mccchannel_14_cave2_box3_focus_r
#define p_interact mccchannel_14_cave2_box3_p_interact
#define mask_string mccchannel_14_cave2_box3_mask_string
#define mask_setting mccchannel_14_cave2_box3_mask_setting
#define number_of_activations mccchannel_14_cave2_box3_number_of_activations
#line 204 "Union_box.comp"
// Needed for transport to the main component
struct global_geometry_element_struct global_geometry_element;

#ifndef ANY_GEOMETRY_DETECTOR_DECLARE
    #define ANY_GEOMETRY_DETECTOR_DECLARE dummy
	//struct pointer_to_global_geometry_list global_geometry_list = {0,NULL};
#endif

int loop_index,found_geometries;

double x_component;
double y_component;
double z_component;

struct Volume_struct this_box_volume;
struct box_storage this_box_storage;

#line 71373 "MACS_sample_kidney_box.c"
#undef number_of_activations
#undef mask_setting
#undef mask_string
#undef p_interact
#undef focus_r
#undef focus_xh
#undef focus_xw
#undef focus_ah
#undef focus_aw
#undef target_z
#undef target_y
#undef target_x
#undef target_index
#undef visualize
#undef yheight2
#undef xwidth2
#undef zdepth
#undef yheight
#undef xwidth
#undef priority
#undef material_string
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

/* User declarations for component 'inter_analyzer_colimator_center_14' [686]. */
#define mccompcurname  inter_analyzer_colimator_center_14
#define mccompcurtype  Arm
#define mccompcurindex 686
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

/* User declarations for component 'inter_analyzer_colimator_14_blade_0' [687]. */
#define mccompcurname  inter_analyzer_colimator_14_blade_0
#define mccompcurtype  Union_box
#define mccompcurindex 687
#define loop_index mccinter_analyzer_colimator_14_blade_0_loop_index
#define this_box_volume mccinter_analyzer_colimator_14_blade_0_this_box_volume
#define global_geometry_element mccinter_analyzer_colimator_14_blade_0_global_geometry_element
#define this_box_storage mccinter_analyzer_colimator_14_blade_0_this_box_storage
#define material_string mccinter_analyzer_colimator_14_blade_0_material_string
#define priority mccinter_analyzer_colimator_14_blade_0_priority
#define xwidth mccinter_analyzer_colimator_14_blade_0_xwidth
#define yheight mccinter_analyzer_colimator_14_blade_0_yheight
#define zdepth mccinter_analyzer_colimator_14_blade_0_zdepth
#define xwidth2 mccinter_analyzer_colimator_14_blade_0_xwidth2
#define yheight2 mccinter_analyzer_colimator_14_blade_0_yheight2
#define visualize mccinter_analyzer_colimator_14_blade_0_visualize
#define target_index mccinter_analyzer_colimator_14_blade_0_target_index
#define target_x mccinter_analyzer_colimator_14_blade_0_target_x
#define target_y mccinter_analyzer_colimator_14_blade_0_target_y
#define target_z mccinter_analyzer_colimator_14_blade_0_target_z
#define focus_aw mccinter_analyzer_colimator_14_blade_0_focus_aw
#define focus_ah mccinter_analyzer_colimator_14_blade_0_focus_ah
#define focus_xw mccinter_analyzer_colimator_14_blade_0_focus_xw
#define focus_xh mccinter_analyzer_colimator_14_blade_0_focus_xh
#define focus_r mccinter_analyzer_colimator_14_blade_0_focus_r
#define p_interact mccinter_analyzer_colimator_14_blade_0_p_interact
#define mask_string mccinter_analyzer_colimator_14_blade_0_mask_string
#define mask_setting mccinter_analyzer_colimator_14_blade_0_mask_setting
#define number_of_activations mccinter_analyzer_colimator_14_blade_0_number_of_activations
#line 204 "Union_box.comp"
// Needed for transport to the main component
struct global_geometry_element_struct global_geometry_element;

#ifndef ANY_GEOMETRY_DETECTOR_DECLARE
    #define ANY_GEOMETRY_DETECTOR_DECLARE dummy
	//struct pointer_to_global_geometry_list global_geometry_list = {0,NULL};
#endif

int loop_index,found_geometries;

double x_component;
double y_component;
double z_component;

struct Volume_struct this_box_volume;
struct box_storage this_box_storage;

#line 71458 "MACS_sample_kidney_box.c"
#undef number_of_activations
#undef mask_setting
#undef mask_string
#undef p_interact
#undef focus_r
#undef focus_xh
#undef focus_xw
#undef focus_ah
#undef focus_aw
#undef target_z
#undef target_y
#undef target_x
#undef target_index
#undef visualize
#undef yheight2
#undef xwidth2
#undef zdepth
#undef yheight
#undef xwidth
#undef priority
#undef material_string
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

/* User declarations for component 'inter_analyzer_colimator_14_blade_1' [688]. */
#define mccompcurname  inter_analyzer_colimator_14_blade_1
#define mccompcurtype  Union_box
#define mccompcurindex 688
#define loop_index mccinter_analyzer_colimator_14_blade_1_loop_index
#define this_box_volume mccinter_analyzer_colimator_14_blade_1_this_box_volume
#define global_geometry_element mccinter_analyzer_colimator_14_blade_1_global_geometry_element
#define this_box_storage mccinter_analyzer_colimator_14_blade_1_this_box_storage
#define material_string mccinter_analyzer_colimator_14_blade_1_material_string
#define priority mccinter_analyzer_colimator_14_blade_1_priority
#define xwidth mccinter_analyzer_colimator_14_blade_1_xwidth
#define yheight mccinter_analyzer_colimator_14_blade_1_yheight
#define zdepth mccinter_analyzer_colimator_14_blade_1_zdepth
#define xwidth2 mccinter_analyzer_colimator_14_blade_1_xwidth2
#define yheight2 mccinter_analyzer_colimator_14_blade_1_yheight2
#define visualize mccinter_analyzer_colimator_14_blade_1_visualize
#define target_index mccinter_analyzer_colimator_14_blade_1_target_index
#define target_x mccinter_analyzer_colimator_14_blade_1_target_x
#define target_y mccinter_analyzer_colimator_14_blade_1_target_y
#define target_z mccinter_analyzer_colimator_14_blade_1_target_z
#define focus_aw mccinter_analyzer_colimator_14_blade_1_focus_aw
#define focus_ah mccinter_analyzer_colimator_14_blade_1_focus_ah
#define focus_xw mccinter_analyzer_colimator_14_blade_1_focus_xw
#define focus_xh mccinter_analyzer_colimator_14_blade_1_focus_xh
#define focus_r mccinter_analyzer_colimator_14_blade_1_focus_r
#define p_interact mccinter_analyzer_colimator_14_blade_1_p_interact
#define mask_string mccinter_analyzer_colimator_14_blade_1_mask_string
#define mask_setting mccinter_analyzer_colimator_14_blade_1_mask_setting
#define number_of_activations mccinter_analyzer_colimator_14_blade_1_number_of_activations
#line 204 "Union_box.comp"
// Needed for transport to the main component
struct global_geometry_element_struct global_geometry_element;

#ifndef ANY_GEOMETRY_DETECTOR_DECLARE
    #define ANY_GEOMETRY_DETECTOR_DECLARE dummy
	//struct pointer_to_global_geometry_list global_geometry_list = {0,NULL};
#endif

int loop_index,found_geometries;

double x_component;
double y_component;
double z_component;

struct Volume_struct this_box_volume;
struct box_storage this_box_storage;

#line 71535 "MACS_sample_kidney_box.c"
#undef number_of_activations
#undef mask_setting
#undef mask_string
#undef p_interact
#undef focus_r
#undef focus_xh
#undef focus_xw
#undef focus_ah
#undef focus_aw
#undef target_z
#undef target_y
#undef target_x
#undef target_index
#undef visualize
#undef yheight2
#undef xwidth2
#undef zdepth
#undef yheight
#undef xwidth
#undef priority
#undef material_string
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

/* User declarations for component 'inter_analyzer_colimator_14_blade_2' [689]. */
#define mccompcurname  inter_analyzer_colimator_14_blade_2
#define mccompcurtype  Union_box
#define mccompcurindex 689
#define loop_index mccinter_analyzer_colimator_14_blade_2_loop_index
#define this_box_volume mccinter_analyzer_colimator_14_blade_2_this_box_volume
#define global_geometry_element mccinter_analyzer_colimator_14_blade_2_global_geometry_element
#define this_box_storage mccinter_analyzer_colimator_14_blade_2_this_box_storage
#define material_string mccinter_analyzer_colimator_14_blade_2_material_string
#define priority mccinter_analyzer_colimator_14_blade_2_priority
#define xwidth mccinter_analyzer_colimator_14_blade_2_xwidth
#define yheight mccinter_analyzer_colimator_14_blade_2_yheight
#define zdepth mccinter_analyzer_colimator_14_blade_2_zdepth
#define xwidth2 mccinter_analyzer_colimator_14_blade_2_xwidth2
#define yheight2 mccinter_analyzer_colimator_14_blade_2_yheight2
#define visualize mccinter_analyzer_colimator_14_blade_2_visualize
#define target_index mccinter_analyzer_colimator_14_blade_2_target_index
#define target_x mccinter_analyzer_colimator_14_blade_2_target_x
#define target_y mccinter_analyzer_colimator_14_blade_2_target_y
#define target_z mccinter_analyzer_colimator_14_blade_2_target_z
#define focus_aw mccinter_analyzer_colimator_14_blade_2_focus_aw
#define focus_ah mccinter_analyzer_colimator_14_blade_2_focus_ah
#define focus_xw mccinter_analyzer_colimator_14_blade_2_focus_xw
#define focus_xh mccinter_analyzer_colimator_14_blade_2_focus_xh
#define focus_r mccinter_analyzer_colimator_14_blade_2_focus_r
#define p_interact mccinter_analyzer_colimator_14_blade_2_p_interact
#define mask_string mccinter_analyzer_colimator_14_blade_2_mask_string
#define mask_setting mccinter_analyzer_colimator_14_blade_2_mask_setting
#define number_of_activations mccinter_analyzer_colimator_14_blade_2_number_of_activations
#line 204 "Union_box.comp"
// Needed for transport to the main component
struct global_geometry_element_struct global_geometry_element;

#ifndef ANY_GEOMETRY_DETECTOR_DECLARE
    #define ANY_GEOMETRY_DETECTOR_DECLARE dummy
	//struct pointer_to_global_geometry_list global_geometry_list = {0,NULL};
#endif

int loop_index,found_geometries;

double x_component;
double y_component;
double z_component;

struct Volume_struct this_box_volume;
struct box_storage this_box_storage;

#line 71612 "MACS_sample_kidney_box.c"
#undef number_of_activations
#undef mask_setting
#undef mask_string
#undef p_interact
#undef focus_r
#undef focus_xh
#undef focus_xw
#undef focus_ah
#undef focus_aw
#undef target_z
#undef target_y
#undef target_x
#undef target_index
#undef visualize
#undef yheight2
#undef xwidth2
#undef zdepth
#undef yheight
#undef xwidth
#undef priority
#undef material_string
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

/* User declarations for component 'inter_analyzer_colimator_14_blade_3' [690]. */
#define mccompcurname  inter_analyzer_colimator_14_blade_3
#define mccompcurtype  Union_box
#define mccompcurindex 690
#define loop_index mccinter_analyzer_colimator_14_blade_3_loop_index
#define this_box_volume mccinter_analyzer_colimator_14_blade_3_this_box_volume
#define global_geometry_element mccinter_analyzer_colimator_14_blade_3_global_geometry_element
#define this_box_storage mccinter_analyzer_colimator_14_blade_3_this_box_storage
#define material_string mccinter_analyzer_colimator_14_blade_3_material_string
#define priority mccinter_analyzer_colimator_14_blade_3_priority
#define xwidth mccinter_analyzer_colimator_14_blade_3_xwidth
#define yheight mccinter_analyzer_colimator_14_blade_3_yheight
#define zdepth mccinter_analyzer_colimator_14_blade_3_zdepth
#define xwidth2 mccinter_analyzer_colimator_14_blade_3_xwidth2
#define yheight2 mccinter_analyzer_colimator_14_blade_3_yheight2
#define visualize mccinter_analyzer_colimator_14_blade_3_visualize
#define target_index mccinter_analyzer_colimator_14_blade_3_target_index
#define target_x mccinter_analyzer_colimator_14_blade_3_target_x
#define target_y mccinter_analyzer_colimator_14_blade_3_target_y
#define target_z mccinter_analyzer_colimator_14_blade_3_target_z
#define focus_aw mccinter_analyzer_colimator_14_blade_3_focus_aw
#define focus_ah mccinter_analyzer_colimator_14_blade_3_focus_ah
#define focus_xw mccinter_analyzer_colimator_14_blade_3_focus_xw
#define focus_xh mccinter_analyzer_colimator_14_blade_3_focus_xh
#define focus_r mccinter_analyzer_colimator_14_blade_3_focus_r
#define p_interact mccinter_analyzer_colimator_14_blade_3_p_interact
#define mask_string mccinter_analyzer_colimator_14_blade_3_mask_string
#define mask_setting mccinter_analyzer_colimator_14_blade_3_mask_setting
#define number_of_activations mccinter_analyzer_colimator_14_blade_3_number_of_activations
#line 204 "Union_box.comp"
// Needed for transport to the main component
struct global_geometry_element_struct global_geometry_element;

#ifndef ANY_GEOMETRY_DETECTOR_DECLARE
    #define ANY_GEOMETRY_DETECTOR_DECLARE dummy
	//struct pointer_to_global_geometry_list global_geometry_list = {0,NULL};
#endif

int loop_index,found_geometries;

double x_component;
double y_component;
double z_component;

struct Volume_struct this_box_volume;
struct box_storage this_box_storage;

#line 71689 "MACS_sample_kidney_box.c"
#undef number_of_activations
#undef mask_setting
#undef mask_string
#undef p_interact
#undef focus_r
#undef focus_xh
#undef focus_xw
#undef focus_ah
#undef focus_aw
#undef target_z
#undef target_y
#undef target_x
#undef target_index
#undef visualize
#undef yheight2
#undef xwidth2
#undef zdepth
#undef yheight
#undef xwidth
#undef priority
#undef material_string
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

/* User declarations for component 'inter_analyzer_colimator_14_blade_4' [691]. */
#define mccompcurname  inter_analyzer_colimator_14_blade_4
#define mccompcurtype  Union_box
#define mccompcurindex 691
#define loop_index mccinter_analyzer_colimator_14_blade_4_loop_index
#define this_box_volume mccinter_analyzer_colimator_14_blade_4_this_box_volume
#define global_geometry_element mccinter_analyzer_colimator_14_blade_4_global_geometry_element
#define this_box_storage mccinter_analyzer_colimator_14_blade_4_this_box_storage
#define material_string mccinter_analyzer_colimator_14_blade_4_material_string
#define priority mccinter_analyzer_colimator_14_blade_4_priority
#define xwidth mccinter_analyzer_colimator_14_blade_4_xwidth
#define yheight mccinter_analyzer_colimator_14_blade_4_yheight
#define zdepth mccinter_analyzer_colimator_14_blade_4_zdepth
#define xwidth2 mccinter_analyzer_colimator_14_blade_4_xwidth2
#define yheight2 mccinter_analyzer_colimator_14_blade_4_yheight2
#define visualize mccinter_analyzer_colimator_14_blade_4_visualize
#define target_index mccinter_analyzer_colimator_14_blade_4_target_index
#define target_x mccinter_analyzer_colimator_14_blade_4_target_x
#define target_y mccinter_analyzer_colimator_14_blade_4_target_y
#define target_z mccinter_analyzer_colimator_14_blade_4_target_z
#define focus_aw mccinter_analyzer_colimator_14_blade_4_focus_aw
#define focus_ah mccinter_analyzer_colimator_14_blade_4_focus_ah
#define focus_xw mccinter_analyzer_colimator_14_blade_4_focus_xw
#define focus_xh mccinter_analyzer_colimator_14_blade_4_focus_xh
#define focus_r mccinter_analyzer_colimator_14_blade_4_focus_r
#define p_interact mccinter_analyzer_colimator_14_blade_4_p_interact
#define mask_string mccinter_analyzer_colimator_14_blade_4_mask_string
#define mask_setting mccinter_analyzer_colimator_14_blade_4_mask_setting
#define number_of_activations mccinter_analyzer_colimator_14_blade_4_number_of_activations
#line 204 "Union_box.comp"
// Needed for transport to the main component
struct global_geometry_element_struct global_geometry_element;

#ifndef ANY_GEOMETRY_DETECTOR_DECLARE
    #define ANY_GEOMETRY_DETECTOR_DECLARE dummy
	//struct pointer_to_global_geometry_list global_geometry_list = {0,NULL};
#endif

int loop_index,found_geometries;

double x_component;
double y_component;
double z_component;

struct Volume_struct this_box_volume;
struct box_storage this_box_storage;

#line 71766 "MACS_sample_kidney_box.c"
#undef number_of_activations
#undef mask_setting
#undef mask_string
#undef p_interact
#undef focus_r
#undef focus_xh
#undef focus_xw
#undef focus_ah
#undef focus_aw
#undef target_z
#undef target_y
#undef target_x
#undef target_index
#undef visualize
#undef yheight2
#undef xwidth2
#undef zdepth
#undef yheight
#undef xwidth
#undef priority
#undef material_string
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

/* User declarations for component 'diffraction_detector_14_exit_volume' [692]. */
#define mccompcurname  diffraction_detector_14_exit_volume
#define mccompcurtype  Union_box
#define mccompcurindex 692
#define loop_index mccdiffraction_detector_14_exit_volume_loop_index
#define this_box_volume mccdiffraction_detector_14_exit_volume_this_box_volume
#define global_geometry_element mccdiffraction_detector_14_exit_volume_global_geometry_element
#define this_box_storage mccdiffraction_detector_14_exit_volume_this_box_storage
#define material_string mccdiffraction_detector_14_exit_volume_material_string
#define priority mccdiffraction_detector_14_exit_volume_priority
#define xwidth mccdiffraction_detector_14_exit_volume_xwidth
#define yheight mccdiffraction_detector_14_exit_volume_yheight
#define zdepth mccdiffraction_detector_14_exit_volume_zdepth
#define xwidth2 mccdiffraction_detector_14_exit_volume_xwidth2
#define yheight2 mccdiffraction_detector_14_exit_volume_yheight2
#define visualize mccdiffraction_detector_14_exit_volume_visualize
#define target_index mccdiffraction_detector_14_exit_volume_target_index
#define target_x mccdiffraction_detector_14_exit_volume_target_x
#define target_y mccdiffraction_detector_14_exit_volume_target_y
#define target_z mccdiffraction_detector_14_exit_volume_target_z
#define focus_aw mccdiffraction_detector_14_exit_volume_focus_aw
#define focus_ah mccdiffraction_detector_14_exit_volume_focus_ah
#define focus_xw mccdiffraction_detector_14_exit_volume_focus_xw
#define focus_xh mccdiffraction_detector_14_exit_volume_focus_xh
#define focus_r mccdiffraction_detector_14_exit_volume_focus_r
#define p_interact mccdiffraction_detector_14_exit_volume_p_interact
#define mask_string mccdiffraction_detector_14_exit_volume_mask_string
#define mask_setting mccdiffraction_detector_14_exit_volume_mask_setting
#define number_of_activations mccdiffraction_detector_14_exit_volume_number_of_activations
#line 204 "Union_box.comp"
// Needed for transport to the main component
struct global_geometry_element_struct global_geometry_element;

#ifndef ANY_GEOMETRY_DETECTOR_DECLARE
    #define ANY_GEOMETRY_DETECTOR_DECLARE dummy
	//struct pointer_to_global_geometry_list global_geometry_list = {0,NULL};
#endif

int loop_index,found_geometries;

double x_component;
double y_component;
double z_component;

struct Volume_struct this_box_volume;
struct box_storage this_box_storage;

#line 71843 "MACS_sample_kidney_box.c"
#undef number_of_activations
#undef mask_setting
#undef mask_string
#undef p_interact
#undef focus_r
#undef focus_xh
#undef focus_xw
#undef focus_ah
#undef focus_aw
#undef target_z
#undef target_y
#undef target_x
#undef target_index
#undef visualize
#undef yheight2
#undef xwidth2
#undef zdepth
#undef yheight
#undef xwidth
#undef priority
#undef material_string
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

/* User declarations for component 'spec_detector_14_exit_volume' [693]. */
#define mccompcurname  spec_detector_14_exit_volume
#define mccompcurtype  Union_box
#define mccompcurindex 693
#define loop_index mccspec_detector_14_exit_volume_loop_index
#define this_box_volume mccspec_detector_14_exit_volume_this_box_volume
#define global_geometry_element mccspec_detector_14_exit_volume_global_geometry_element
#define this_box_storage mccspec_detector_14_exit_volume_this_box_storage
#define material_string mccspec_detector_14_exit_volume_material_string
#define priority mccspec_detector_14_exit_volume_priority
#define xwidth mccspec_detector_14_exit_volume_xwidth
#define yheight mccspec_detector_14_exit_volume_yheight
#define zdepth mccspec_detector_14_exit_volume_zdepth
#define xwidth2 mccspec_detector_14_exit_volume_xwidth2
#define yheight2 mccspec_detector_14_exit_volume_yheight2
#define visualize mccspec_detector_14_exit_volume_visualize
#define target_index mccspec_detector_14_exit_volume_target_index
#define target_x mccspec_detector_14_exit_volume_target_x
#define target_y mccspec_detector_14_exit_volume_target_y
#define target_z mccspec_detector_14_exit_volume_target_z
#define focus_aw mccspec_detector_14_exit_volume_focus_aw
#define focus_ah mccspec_detector_14_exit_volume_focus_ah
#define focus_xw mccspec_detector_14_exit_volume_focus_xw
#define focus_xh mccspec_detector_14_exit_volume_focus_xh
#define focus_r mccspec_detector_14_exit_volume_focus_r
#define p_interact mccspec_detector_14_exit_volume_p_interact
#define mask_string mccspec_detector_14_exit_volume_mask_string
#define mask_setting mccspec_detector_14_exit_volume_mask_setting
#define number_of_activations mccspec_detector_14_exit_volume_number_of_activations
#line 204 "Union_box.comp"
// Needed for transport to the main component
struct global_geometry_element_struct global_geometry_element;

#ifndef ANY_GEOMETRY_DETECTOR_DECLARE
    #define ANY_GEOMETRY_DETECTOR_DECLARE dummy
	//struct pointer_to_global_geometry_list global_geometry_list = {0,NULL};
#endif

int loop_index,found_geometries;

double x_component;
double y_component;
double z_component;

struct Volume_struct this_box_volume;
struct box_storage this_box_storage;

#line 71920 "MACS_sample_kidney_box.c"
#undef number_of_activations
#undef mask_setting
#undef mask_string
#undef p_interact
#undef focus_r
#undef focus_xh
#undef focus_xw
#undef focus_ah
#undef focus_aw
#undef target_z
#undef target_y
#undef target_x
#undef target_index
#undef visualize
#undef yheight2
#undef xwidth2
#undef zdepth
#undef yheight
#undef xwidth
#undef priority
#undef material_string
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

/* User declarations for component 'channel_15_cave1_box1' [694]. */
#define mccompcurname  channel_15_cave1_box1
#define mccompcurtype  Union_box
#define mccompcurindex 694
#define loop_index mccchannel_15_cave1_box1_loop_index
#define this_box_volume mccchannel_15_cave1_box1_this_box_volume
#define global_geometry_element mccchannel_15_cave1_box1_global_geometry_element
#define this_box_storage mccchannel_15_cave1_box1_this_box_storage
#define material_string mccchannel_15_cave1_box1_material_string
#define priority mccchannel_15_cave1_box1_priority
#define xwidth mccchannel_15_cave1_box1_xwidth
#define yheight mccchannel_15_cave1_box1_yheight
#define zdepth mccchannel_15_cave1_box1_zdepth
#define xwidth2 mccchannel_15_cave1_box1_xwidth2
#define yheight2 mccchannel_15_cave1_box1_yheight2
#define visualize mccchannel_15_cave1_box1_visualize
#define target_index mccchannel_15_cave1_box1_target_index
#define target_x mccchannel_15_cave1_box1_target_x
#define target_y mccchannel_15_cave1_box1_target_y
#define target_z mccchannel_15_cave1_box1_target_z
#define focus_aw mccchannel_15_cave1_box1_focus_aw
#define focus_ah mccchannel_15_cave1_box1_focus_ah
#define focus_xw mccchannel_15_cave1_box1_focus_xw
#define focus_xh mccchannel_15_cave1_box1_focus_xh
#define focus_r mccchannel_15_cave1_box1_focus_r
#define p_interact mccchannel_15_cave1_box1_p_interact
#define mask_string mccchannel_15_cave1_box1_mask_string
#define mask_setting mccchannel_15_cave1_box1_mask_setting
#define number_of_activations mccchannel_15_cave1_box1_number_of_activations
#line 204 "Union_box.comp"
// Needed for transport to the main component
struct global_geometry_element_struct global_geometry_element;

#ifndef ANY_GEOMETRY_DETECTOR_DECLARE
    #define ANY_GEOMETRY_DETECTOR_DECLARE dummy
	//struct pointer_to_global_geometry_list global_geometry_list = {0,NULL};
#endif

int loop_index,found_geometries;

double x_component;
double y_component;
double z_component;

struct Volume_struct this_box_volume;
struct box_storage this_box_storage;

#line 71997 "MACS_sample_kidney_box.c"
#undef number_of_activations
#undef mask_setting
#undef mask_string
#undef p_interact
#undef focus_r
#undef focus_xh
#undef focus_xw
#undef focus_ah
#undef focus_aw
#undef target_z
#undef target_y
#undef target_x
#undef target_index
#undef visualize
#undef yheight2
#undef xwidth2
#undef zdepth
#undef yheight
#undef xwidth
#undef priority
#undef material_string
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

/* User declarations for component 'channel_15_cave1_box2' [695]. */
#define mccompcurname  channel_15_cave1_box2
#define mccompcurtype  Union_box
#define mccompcurindex 695
#define loop_index mccchannel_15_cave1_box2_loop_index
#define this_box_volume mccchannel_15_cave1_box2_this_box_volume
#define global_geometry_element mccchannel_15_cave1_box2_global_geometry_element
#define this_box_storage mccchannel_15_cave1_box2_this_box_storage
#define material_string mccchannel_15_cave1_box2_material_string
#define priority mccchannel_15_cave1_box2_priority
#define xwidth mccchannel_15_cave1_box2_xwidth
#define yheight mccchannel_15_cave1_box2_yheight
#define zdepth mccchannel_15_cave1_box2_zdepth
#define xwidth2 mccchannel_15_cave1_box2_xwidth2
#define yheight2 mccchannel_15_cave1_box2_yheight2
#define visualize mccchannel_15_cave1_box2_visualize
#define target_index mccchannel_15_cave1_box2_target_index
#define target_x mccchannel_15_cave1_box2_target_x
#define target_y mccchannel_15_cave1_box2_target_y
#define target_z mccchannel_15_cave1_box2_target_z
#define focus_aw mccchannel_15_cave1_box2_focus_aw
#define focus_ah mccchannel_15_cave1_box2_focus_ah
#define focus_xw mccchannel_15_cave1_box2_focus_xw
#define focus_xh mccchannel_15_cave1_box2_focus_xh
#define focus_r mccchannel_15_cave1_box2_focus_r
#define p_interact mccchannel_15_cave1_box2_p_interact
#define mask_string mccchannel_15_cave1_box2_mask_string
#define mask_setting mccchannel_15_cave1_box2_mask_setting
#define number_of_activations mccchannel_15_cave1_box2_number_of_activations
#line 204 "Union_box.comp"
// Needed for transport to the main component
struct global_geometry_element_struct global_geometry_element;

#ifndef ANY_GEOMETRY_DETECTOR_DECLARE
    #define ANY_GEOMETRY_DETECTOR_DECLARE dummy
	//struct pointer_to_global_geometry_list global_geometry_list = {0,NULL};
#endif

int loop_index,found_geometries;

double x_component;
double y_component;
double z_component;

struct Volume_struct this_box_volume;
struct box_storage this_box_storage;

#line 72074 "MACS_sample_kidney_box.c"
#undef number_of_activations
#undef mask_setting
#undef mask_string
#undef p_interact
#undef focus_r
#undef focus_xh
#undef focus_xw
#undef focus_ah
#undef focus_aw
#undef target_z
#undef target_y
#undef target_x
#undef target_index
#undef visualize
#undef yheight2
#undef xwidth2
#undef zdepth
#undef yheight
#undef xwidth
#undef priority
#undef material_string
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

/* User declarations for component 'channel_15_cave1_box3' [696]. */
#define mccompcurname  channel_15_cave1_box3
#define mccompcurtype  Union_box
#define mccompcurindex 696
#define loop_index mccchannel_15_cave1_box3_loop_index
#define this_box_volume mccchannel_15_cave1_box3_this_box_volume
#define global_geometry_element mccchannel_15_cave1_box3_global_geometry_element
#define this_box_storage mccchannel_15_cave1_box3_this_box_storage
#define material_string mccchannel_15_cave1_box3_material_string
#define priority mccchannel_15_cave1_box3_priority
#define xwidth mccchannel_15_cave1_box3_xwidth
#define yheight mccchannel_15_cave1_box3_yheight
#define zdepth mccchannel_15_cave1_box3_zdepth
#define xwidth2 mccchannel_15_cave1_box3_xwidth2
#define yheight2 mccchannel_15_cave1_box3_yheight2
#define visualize mccchannel_15_cave1_box3_visualize
#define target_index mccchannel_15_cave1_box3_target_index
#define target_x mccchannel_15_cave1_box3_target_x
#define target_y mccchannel_15_cave1_box3_target_y
#define target_z mccchannel_15_cave1_box3_target_z
#define focus_aw mccchannel_15_cave1_box3_focus_aw
#define focus_ah mccchannel_15_cave1_box3_focus_ah
#define focus_xw mccchannel_15_cave1_box3_focus_xw
#define focus_xh mccchannel_15_cave1_box3_focus_xh
#define focus_r mccchannel_15_cave1_box3_focus_r
#define p_interact mccchannel_15_cave1_box3_p_interact
#define mask_string mccchannel_15_cave1_box3_mask_string
#define mask_setting mccchannel_15_cave1_box3_mask_setting
#define number_of_activations mccchannel_15_cave1_box3_number_of_activations
#line 204 "Union_box.comp"
// Needed for transport to the main component
struct global_geometry_element_struct global_geometry_element;

#ifndef ANY_GEOMETRY_DETECTOR_DECLARE
    #define ANY_GEOMETRY_DETECTOR_DECLARE dummy
	//struct pointer_to_global_geometry_list global_geometry_list = {0,NULL};
#endif

int loop_index,found_geometries;

double x_component;
double y_component;
double z_component;

struct Volume_struct this_box_volume;
struct box_storage this_box_storage;

#line 72151 "MACS_sample_kidney_box.c"
#undef number_of_activations
#undef mask_setting
#undef mask_string
#undef p_interact
#undef focus_r
#undef focus_xh
#undef focus_xw
#undef focus_ah
#undef focus_aw
#undef target_z
#undef target_y
#undef target_x
#undef target_index
#undef visualize
#undef yheight2
#undef xwidth2
#undef zdepth
#undef yheight
#undef xwidth
#undef priority
#undef material_string
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

/* User declarations for component 'channel_15_cave1_cyl1' [697]. */
#define mccompcurname  channel_15_cave1_cyl1
#define mccompcurtype  Union_cylinder
#define mccompcurindex 697
#define loop_index mccchannel_15_cave1_cyl1_loop_index
#define this_cylinder_volume mccchannel_15_cave1_cyl1_this_cylinder_volume
#define global_geometry_element mccchannel_15_cave1_cyl1_global_geometry_element
#define this_cylinder_storage mccchannel_15_cave1_cyl1_this_cylinder_storage
#define material_string mccchannel_15_cave1_cyl1_material_string
#define priority mccchannel_15_cave1_cyl1_priority
#define radius mccchannel_15_cave1_cyl1_radius
#define yheight mccchannel_15_cave1_cyl1_yheight
#define visualize mccchannel_15_cave1_cyl1_visualize
#define target_index mccchannel_15_cave1_cyl1_target_index
#define target_x mccchannel_15_cave1_cyl1_target_x
#define target_y mccchannel_15_cave1_cyl1_target_y
#define target_z mccchannel_15_cave1_cyl1_target_z
#define focus_aw mccchannel_15_cave1_cyl1_focus_aw
#define focus_ah mccchannel_15_cave1_cyl1_focus_ah
#define focus_xw mccchannel_15_cave1_cyl1_focus_xw
#define focus_xh mccchannel_15_cave1_cyl1_focus_xh
#define focus_r mccchannel_15_cave1_cyl1_focus_r
#define p_interact mccchannel_15_cave1_cyl1_p_interact
#define mask_string mccchannel_15_cave1_cyl1_mask_string
#define mask_setting mccchannel_15_cave1_cyl1_mask_setting
#define number_of_activations mccchannel_15_cave1_cyl1_number_of_activations
#line 167 "Union_cylinder.comp"
// Needed for transport to the main component
struct global_geometry_element_struct global_geometry_element;

#ifndef ANY_GEOMETRY_DETECTOR_DECLARE
    #define ANY_GEOMETRY_DETECTOR_DECLARE dummy
	//struct pointer_to_global_geometry_list global_geometry_list = {0,NULL};
#endif

int dummy;
int loop_index,found_geometries;
int loop_2_index;
int material_index;

struct Volume_struct this_cylinder_volume;
struct cylinder_storage this_cylinder_storage;
#line 72223 "MACS_sample_kidney_box.c"
#undef number_of_activations
#undef mask_setting
#undef mask_string
#undef p_interact
#undef focus_r
#undef focus_xh
#undef focus_xw
#undef focus_ah
#undef focus_aw
#undef target_z
#undef target_y
#undef target_x
#undef target_index
#undef visualize
#undef yheight
#undef radius
#undef priority
#undef material_string
#undef this_cylinder_storage
#undef global_geometry_element
#undef this_cylinder_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

/* User declarations for component 'channel_15_analyzer_1_center' [698]. */
#define mccompcurname  channel_15_analyzer_1_center
#define mccompcurtype  Arm
#define mccompcurindex 698
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

/* User declarations for component 'channel_15_analyzer_1_rotated' [699]. */
#define mccompcurname  channel_15_analyzer_1_rotated
#define mccompcurtype  Arm
#define mccompcurindex 699
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

/* User declarations for component 'channel_15_analyzer_1_array_crystal_array_0' [700]. */
#define mccompcurname  channel_15_analyzer_1_array_crystal_array_0
#define mccompcurtype  Union_box
#define mccompcurindex 700
#define loop_index mccchannel_15_analyzer_1_array_crystal_array_0_loop_index
#define this_box_volume mccchannel_15_analyzer_1_array_crystal_array_0_this_box_volume
#define global_geometry_element mccchannel_15_analyzer_1_array_crystal_array_0_global_geometry_element
#define this_box_storage mccchannel_15_analyzer_1_array_crystal_array_0_this_box_storage
#define material_string mccchannel_15_analyzer_1_array_crystal_array_0_material_string
#define priority mccchannel_15_analyzer_1_array_crystal_array_0_priority
#define xwidth mccchannel_15_analyzer_1_array_crystal_array_0_xwidth
#define yheight mccchannel_15_analyzer_1_array_crystal_array_0_yheight
#define zdepth mccchannel_15_analyzer_1_array_crystal_array_0_zdepth
#define xwidth2 mccchannel_15_analyzer_1_array_crystal_array_0_xwidth2
#define yheight2 mccchannel_15_analyzer_1_array_crystal_array_0_yheight2
#define visualize mccchannel_15_analyzer_1_array_crystal_array_0_visualize
#define target_index mccchannel_15_analyzer_1_array_crystal_array_0_target_index
#define target_x mccchannel_15_analyzer_1_array_crystal_array_0_target_x
#define target_y mccchannel_15_analyzer_1_array_crystal_array_0_target_y
#define target_z mccchannel_15_analyzer_1_array_crystal_array_0_target_z
#define focus_aw mccchannel_15_analyzer_1_array_crystal_array_0_focus_aw
#define focus_ah mccchannel_15_analyzer_1_array_crystal_array_0_focus_ah
#define focus_xw mccchannel_15_analyzer_1_array_crystal_array_0_focus_xw
#define focus_xh mccchannel_15_analyzer_1_array_crystal_array_0_focus_xh
#define focus_r mccchannel_15_analyzer_1_array_crystal_array_0_focus_r
#define p_interact mccchannel_15_analyzer_1_array_crystal_array_0_p_interact
#define mask_string mccchannel_15_analyzer_1_array_crystal_array_0_mask_string
#define mask_setting mccchannel_15_analyzer_1_array_crystal_array_0_mask_setting
#define number_of_activations mccchannel_15_analyzer_1_array_crystal_array_0_number_of_activations
#line 204 "Union_box.comp"
// Needed for transport to the main component
struct global_geometry_element_struct global_geometry_element;

#ifndef ANY_GEOMETRY_DETECTOR_DECLARE
    #define ANY_GEOMETRY_DETECTOR_DECLARE dummy
	//struct pointer_to_global_geometry_list global_geometry_list = {0,NULL};
#endif

int loop_index,found_geometries;

double x_component;
double y_component;
double z_component;

struct Volume_struct this_box_volume;
struct box_storage this_box_storage;

#line 72313 "MACS_sample_kidney_box.c"
#undef number_of_activations
#undef mask_setting
#undef mask_string
#undef p_interact
#undef focus_r
#undef focus_xh
#undef focus_xw
#undef focus_ah
#undef focus_aw
#undef target_z
#undef target_y
#undef target_x
#undef target_index
#undef visualize
#undef yheight2
#undef xwidth2
#undef zdepth
#undef yheight
#undef xwidth
#undef priority
#undef material_string
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

/* User declarations for component 'channel_15_analyzer_1_array_crystal_array_1' [701]. */
#define mccompcurname  channel_15_analyzer_1_array_crystal_array_1
#define mccompcurtype  Union_box
#define mccompcurindex 701
#define loop_index mccchannel_15_analyzer_1_array_crystal_array_1_loop_index
#define this_box_volume mccchannel_15_analyzer_1_array_crystal_array_1_this_box_volume
#define global_geometry_element mccchannel_15_analyzer_1_array_crystal_array_1_global_geometry_element
#define this_box_storage mccchannel_15_analyzer_1_array_crystal_array_1_this_box_storage
#define material_string mccchannel_15_analyzer_1_array_crystal_array_1_material_string
#define priority mccchannel_15_analyzer_1_array_crystal_array_1_priority
#define xwidth mccchannel_15_analyzer_1_array_crystal_array_1_xwidth
#define yheight mccchannel_15_analyzer_1_array_crystal_array_1_yheight
#define zdepth mccchannel_15_analyzer_1_array_crystal_array_1_zdepth
#define xwidth2 mccchannel_15_analyzer_1_array_crystal_array_1_xwidth2
#define yheight2 mccchannel_15_analyzer_1_array_crystal_array_1_yheight2
#define visualize mccchannel_15_analyzer_1_array_crystal_array_1_visualize
#define target_index mccchannel_15_analyzer_1_array_crystal_array_1_target_index
#define target_x mccchannel_15_analyzer_1_array_crystal_array_1_target_x
#define target_y mccchannel_15_analyzer_1_array_crystal_array_1_target_y
#define target_z mccchannel_15_analyzer_1_array_crystal_array_1_target_z
#define focus_aw mccchannel_15_analyzer_1_array_crystal_array_1_focus_aw
#define focus_ah mccchannel_15_analyzer_1_array_crystal_array_1_focus_ah
#define focus_xw mccchannel_15_analyzer_1_array_crystal_array_1_focus_xw
#define focus_xh mccchannel_15_analyzer_1_array_crystal_array_1_focus_xh
#define focus_r mccchannel_15_analyzer_1_array_crystal_array_1_focus_r
#define p_interact mccchannel_15_analyzer_1_array_crystal_array_1_p_interact
#define mask_string mccchannel_15_analyzer_1_array_crystal_array_1_mask_string
#define mask_setting mccchannel_15_analyzer_1_array_crystal_array_1_mask_setting
#define number_of_activations mccchannel_15_analyzer_1_array_crystal_array_1_number_of_activations
#line 204 "Union_box.comp"
// Needed for transport to the main component
struct global_geometry_element_struct global_geometry_element;

#ifndef ANY_GEOMETRY_DETECTOR_DECLARE
    #define ANY_GEOMETRY_DETECTOR_DECLARE dummy
	//struct pointer_to_global_geometry_list global_geometry_list = {0,NULL};
#endif

int loop_index,found_geometries;

double x_component;
double y_component;
double z_component;

struct Volume_struct this_box_volume;
struct box_storage this_box_storage;

#line 72390 "MACS_sample_kidney_box.c"
#undef number_of_activations
#undef mask_setting
#undef mask_string
#undef p_interact
#undef focus_r
#undef focus_xh
#undef focus_xw
#undef focus_ah
#undef focus_aw
#undef target_z
#undef target_y
#undef target_x
#undef target_index
#undef visualize
#undef yheight2
#undef xwidth2
#undef zdepth
#undef yheight
#undef xwidth
#undef priority
#undef material_string
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

/* User declarations for component 'channel_15_analyzer_1_array_crystal_array_2' [702]. */
#define mccompcurname  channel_15_analyzer_1_array_crystal_array_2
#define mccompcurtype  Union_box
#define mccompcurindex 702
#define loop_index mccchannel_15_analyzer_1_array_crystal_array_2_loop_index
#define this_box_volume mccchannel_15_analyzer_1_array_crystal_array_2_this_box_volume
#define global_geometry_element mccchannel_15_analyzer_1_array_crystal_array_2_global_geometry_element
#define this_box_storage mccchannel_15_analyzer_1_array_crystal_array_2_this_box_storage
#define material_string mccchannel_15_analyzer_1_array_crystal_array_2_material_string
#define priority mccchannel_15_analyzer_1_array_crystal_array_2_priority
#define xwidth mccchannel_15_analyzer_1_array_crystal_array_2_xwidth
#define yheight mccchannel_15_analyzer_1_array_crystal_array_2_yheight
#define zdepth mccchannel_15_analyzer_1_array_crystal_array_2_zdepth
#define xwidth2 mccchannel_15_analyzer_1_array_crystal_array_2_xwidth2
#define yheight2 mccchannel_15_analyzer_1_array_crystal_array_2_yheight2
#define visualize mccchannel_15_analyzer_1_array_crystal_array_2_visualize
#define target_index mccchannel_15_analyzer_1_array_crystal_array_2_target_index
#define target_x mccchannel_15_analyzer_1_array_crystal_array_2_target_x
#define target_y mccchannel_15_analyzer_1_array_crystal_array_2_target_y
#define target_z mccchannel_15_analyzer_1_array_crystal_array_2_target_z
#define focus_aw mccchannel_15_analyzer_1_array_crystal_array_2_focus_aw
#define focus_ah mccchannel_15_analyzer_1_array_crystal_array_2_focus_ah
#define focus_xw mccchannel_15_analyzer_1_array_crystal_array_2_focus_xw
#define focus_xh mccchannel_15_analyzer_1_array_crystal_array_2_focus_xh
#define focus_r mccchannel_15_analyzer_1_array_crystal_array_2_focus_r
#define p_interact mccchannel_15_analyzer_1_array_crystal_array_2_p_interact
#define mask_string mccchannel_15_analyzer_1_array_crystal_array_2_mask_string
#define mask_setting mccchannel_15_analyzer_1_array_crystal_array_2_mask_setting
#define number_of_activations mccchannel_15_analyzer_1_array_crystal_array_2_number_of_activations
#line 204 "Union_box.comp"
// Needed for transport to the main component
struct global_geometry_element_struct global_geometry_element;

#ifndef ANY_GEOMETRY_DETECTOR_DECLARE
    #define ANY_GEOMETRY_DETECTOR_DECLARE dummy
	//struct pointer_to_global_geometry_list global_geometry_list = {0,NULL};
#endif

int loop_index,found_geometries;

double x_component;
double y_component;
double z_component;

struct Volume_struct this_box_volume;
struct box_storage this_box_storage;

#line 72467 "MACS_sample_kidney_box.c"
#undef number_of_activations
#undef mask_setting
#undef mask_string
#undef p_interact
#undef focus_r
#undef focus_xh
#undef focus_xw
#undef focus_ah
#undef focus_aw
#undef target_z
#undef target_y
#undef target_x
#undef target_index
#undef visualize
#undef yheight2
#undef xwidth2
#undef zdepth
#undef yheight
#undef xwidth
#undef priority
#undef material_string
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

/* User declarations for component 'channel_15_analyzer_1_array_crystal_array_3' [703]. */
#define mccompcurname  channel_15_analyzer_1_array_crystal_array_3
#define mccompcurtype  Union_box
#define mccompcurindex 703
#define loop_index mccchannel_15_analyzer_1_array_crystal_array_3_loop_index
#define this_box_volume mccchannel_15_analyzer_1_array_crystal_array_3_this_box_volume
#define global_geometry_element mccchannel_15_analyzer_1_array_crystal_array_3_global_geometry_element
#define this_box_storage mccchannel_15_analyzer_1_array_crystal_array_3_this_box_storage
#define material_string mccchannel_15_analyzer_1_array_crystal_array_3_material_string
#define priority mccchannel_15_analyzer_1_array_crystal_array_3_priority
#define xwidth mccchannel_15_analyzer_1_array_crystal_array_3_xwidth
#define yheight mccchannel_15_analyzer_1_array_crystal_array_3_yheight
#define zdepth mccchannel_15_analyzer_1_array_crystal_array_3_zdepth
#define xwidth2 mccchannel_15_analyzer_1_array_crystal_array_3_xwidth2
#define yheight2 mccchannel_15_analyzer_1_array_crystal_array_3_yheight2
#define visualize mccchannel_15_analyzer_1_array_crystal_array_3_visualize
#define target_index mccchannel_15_analyzer_1_array_crystal_array_3_target_index
#define target_x mccchannel_15_analyzer_1_array_crystal_array_3_target_x
#define target_y mccchannel_15_analyzer_1_array_crystal_array_3_target_y
#define target_z mccchannel_15_analyzer_1_array_crystal_array_3_target_z
#define focus_aw mccchannel_15_analyzer_1_array_crystal_array_3_focus_aw
#define focus_ah mccchannel_15_analyzer_1_array_crystal_array_3_focus_ah
#define focus_xw mccchannel_15_analyzer_1_array_crystal_array_3_focus_xw
#define focus_xh mccchannel_15_analyzer_1_array_crystal_array_3_focus_xh
#define focus_r mccchannel_15_analyzer_1_array_crystal_array_3_focus_r
#define p_interact mccchannel_15_analyzer_1_array_crystal_array_3_p_interact
#define mask_string mccchannel_15_analyzer_1_array_crystal_array_3_mask_string
#define mask_setting mccchannel_15_analyzer_1_array_crystal_array_3_mask_setting
#define number_of_activations mccchannel_15_analyzer_1_array_crystal_array_3_number_of_activations
#line 204 "Union_box.comp"
// Needed for transport to the main component
struct global_geometry_element_struct global_geometry_element;

#ifndef ANY_GEOMETRY_DETECTOR_DECLARE
    #define ANY_GEOMETRY_DETECTOR_DECLARE dummy
	//struct pointer_to_global_geometry_list global_geometry_list = {0,NULL};
#endif

int loop_index,found_geometries;

double x_component;
double y_component;
double z_component;

struct Volume_struct this_box_volume;
struct box_storage this_box_storage;

#line 72544 "MACS_sample_kidney_box.c"
#undef number_of_activations
#undef mask_setting
#undef mask_string
#undef p_interact
#undef focus_r
#undef focus_xh
#undef focus_xw
#undef focus_ah
#undef focus_aw
#undef target_z
#undef target_y
#undef target_x
#undef target_index
#undef visualize
#undef yheight2
#undef xwidth2
#undef zdepth
#undef yheight
#undef xwidth
#undef priority
#undef material_string
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

/* User declarations for component 'channel_15_analyzer_1_array_crystal_array_4' [704]. */
#define mccompcurname  channel_15_analyzer_1_array_crystal_array_4
#define mccompcurtype  Union_box
#define mccompcurindex 704
#define loop_index mccchannel_15_analyzer_1_array_crystal_array_4_loop_index
#define this_box_volume mccchannel_15_analyzer_1_array_crystal_array_4_this_box_volume
#define global_geometry_element mccchannel_15_analyzer_1_array_crystal_array_4_global_geometry_element
#define this_box_storage mccchannel_15_analyzer_1_array_crystal_array_4_this_box_storage
#define material_string mccchannel_15_analyzer_1_array_crystal_array_4_material_string
#define priority mccchannel_15_analyzer_1_array_crystal_array_4_priority
#define xwidth mccchannel_15_analyzer_1_array_crystal_array_4_xwidth
#define yheight mccchannel_15_analyzer_1_array_crystal_array_4_yheight
#define zdepth mccchannel_15_analyzer_1_array_crystal_array_4_zdepth
#define xwidth2 mccchannel_15_analyzer_1_array_crystal_array_4_xwidth2
#define yheight2 mccchannel_15_analyzer_1_array_crystal_array_4_yheight2
#define visualize mccchannel_15_analyzer_1_array_crystal_array_4_visualize
#define target_index mccchannel_15_analyzer_1_array_crystal_array_4_target_index
#define target_x mccchannel_15_analyzer_1_array_crystal_array_4_target_x
#define target_y mccchannel_15_analyzer_1_array_crystal_array_4_target_y
#define target_z mccchannel_15_analyzer_1_array_crystal_array_4_target_z
#define focus_aw mccchannel_15_analyzer_1_array_crystal_array_4_focus_aw
#define focus_ah mccchannel_15_analyzer_1_array_crystal_array_4_focus_ah
#define focus_xw mccchannel_15_analyzer_1_array_crystal_array_4_focus_xw
#define focus_xh mccchannel_15_analyzer_1_array_crystal_array_4_focus_xh
#define focus_r mccchannel_15_analyzer_1_array_crystal_array_4_focus_r
#define p_interact mccchannel_15_analyzer_1_array_crystal_array_4_p_interact
#define mask_string mccchannel_15_analyzer_1_array_crystal_array_4_mask_string
#define mask_setting mccchannel_15_analyzer_1_array_crystal_array_4_mask_setting
#define number_of_activations mccchannel_15_analyzer_1_array_crystal_array_4_number_of_activations
#line 204 "Union_box.comp"
// Needed for transport to the main component
struct global_geometry_element_struct global_geometry_element;

#ifndef ANY_GEOMETRY_DETECTOR_DECLARE
    #define ANY_GEOMETRY_DETECTOR_DECLARE dummy
	//struct pointer_to_global_geometry_list global_geometry_list = {0,NULL};
#endif

int loop_index,found_geometries;

double x_component;
double y_component;
double z_component;

struct Volume_struct this_box_volume;
struct box_storage this_box_storage;

#line 72621 "MACS_sample_kidney_box.c"
#undef number_of_activations
#undef mask_setting
#undef mask_string
#undef p_interact
#undef focus_r
#undef focus_xh
#undef focus_xw
#undef focus_ah
#undef focus_aw
#undef target_z
#undef target_y
#undef target_x
#undef target_index
#undef visualize
#undef yheight2
#undef xwidth2
#undef zdepth
#undef yheight
#undef xwidth
#undef priority
#undef material_string
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

/* User declarations for component 'channel_15_analyzer_1_array_crystal_array_5' [705]. */
#define mccompcurname  channel_15_analyzer_1_array_crystal_array_5
#define mccompcurtype  Union_box
#define mccompcurindex 705
#define loop_index mccchannel_15_analyzer_1_array_crystal_array_5_loop_index
#define this_box_volume mccchannel_15_analyzer_1_array_crystal_array_5_this_box_volume
#define global_geometry_element mccchannel_15_analyzer_1_array_crystal_array_5_global_geometry_element
#define this_box_storage mccchannel_15_analyzer_1_array_crystal_array_5_this_box_storage
#define material_string mccchannel_15_analyzer_1_array_crystal_array_5_material_string
#define priority mccchannel_15_analyzer_1_array_crystal_array_5_priority
#define xwidth mccchannel_15_analyzer_1_array_crystal_array_5_xwidth
#define yheight mccchannel_15_analyzer_1_array_crystal_array_5_yheight
#define zdepth mccchannel_15_analyzer_1_array_crystal_array_5_zdepth
#define xwidth2 mccchannel_15_analyzer_1_array_crystal_array_5_xwidth2
#define yheight2 mccchannel_15_analyzer_1_array_crystal_array_5_yheight2
#define visualize mccchannel_15_analyzer_1_array_crystal_array_5_visualize
#define target_index mccchannel_15_analyzer_1_array_crystal_array_5_target_index
#define target_x mccchannel_15_analyzer_1_array_crystal_array_5_target_x
#define target_y mccchannel_15_analyzer_1_array_crystal_array_5_target_y
#define target_z mccchannel_15_analyzer_1_array_crystal_array_5_target_z
#define focus_aw mccchannel_15_analyzer_1_array_crystal_array_5_focus_aw
#define focus_ah mccchannel_15_analyzer_1_array_crystal_array_5_focus_ah
#define focus_xw mccchannel_15_analyzer_1_array_crystal_array_5_focus_xw
#define focus_xh mccchannel_15_analyzer_1_array_crystal_array_5_focus_xh
#define focus_r mccchannel_15_analyzer_1_array_crystal_array_5_focus_r
#define p_interact mccchannel_15_analyzer_1_array_crystal_array_5_p_interact
#define mask_string mccchannel_15_analyzer_1_array_crystal_array_5_mask_string
#define mask_setting mccchannel_15_analyzer_1_array_crystal_array_5_mask_setting
#define number_of_activations mccchannel_15_analyzer_1_array_crystal_array_5_number_of_activations
#line 204 "Union_box.comp"
// Needed for transport to the main component
struct global_geometry_element_struct global_geometry_element;

#ifndef ANY_GEOMETRY_DETECTOR_DECLARE
    #define ANY_GEOMETRY_DETECTOR_DECLARE dummy
	//struct pointer_to_global_geometry_list global_geometry_list = {0,NULL};
#endif

int loop_index,found_geometries;

double x_component;
double y_component;
double z_component;

struct Volume_struct this_box_volume;
struct box_storage this_box_storage;

#line 72698 "MACS_sample_kidney_box.c"
#undef number_of_activations
#undef mask_setting
#undef mask_string
#undef p_interact
#undef focus_r
#undef focus_xh
#undef focus_xw
#undef focus_ah
#undef focus_aw
#undef target_z
#undef target_y
#undef target_x
#undef target_index
#undef visualize
#undef yheight2
#undef xwidth2
#undef zdepth
#undef yheight
#undef xwidth
#undef priority
#undef material_string
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

/* User declarations for component 'channel_15_analyzer_1_array_crystal_array_6' [706]. */
#define mccompcurname  channel_15_analyzer_1_array_crystal_array_6
#define mccompcurtype  Union_box
#define mccompcurindex 706
#define loop_index mccchannel_15_analyzer_1_array_crystal_array_6_loop_index
#define this_box_volume mccchannel_15_analyzer_1_array_crystal_array_6_this_box_volume
#define global_geometry_element mccchannel_15_analyzer_1_array_crystal_array_6_global_geometry_element
#define this_box_storage mccchannel_15_analyzer_1_array_crystal_array_6_this_box_storage
#define material_string mccchannel_15_analyzer_1_array_crystal_array_6_material_string
#define priority mccchannel_15_analyzer_1_array_crystal_array_6_priority
#define xwidth mccchannel_15_analyzer_1_array_crystal_array_6_xwidth
#define yheight mccchannel_15_analyzer_1_array_crystal_array_6_yheight
#define zdepth mccchannel_15_analyzer_1_array_crystal_array_6_zdepth
#define xwidth2 mccchannel_15_analyzer_1_array_crystal_array_6_xwidth2
#define yheight2 mccchannel_15_analyzer_1_array_crystal_array_6_yheight2
#define visualize mccchannel_15_analyzer_1_array_crystal_array_6_visualize
#define target_index mccchannel_15_analyzer_1_array_crystal_array_6_target_index
#define target_x mccchannel_15_analyzer_1_array_crystal_array_6_target_x
#define target_y mccchannel_15_analyzer_1_array_crystal_array_6_target_y
#define target_z mccchannel_15_analyzer_1_array_crystal_array_6_target_z
#define focus_aw mccchannel_15_analyzer_1_array_crystal_array_6_focus_aw
#define focus_ah mccchannel_15_analyzer_1_array_crystal_array_6_focus_ah
#define focus_xw mccchannel_15_analyzer_1_array_crystal_array_6_focus_xw
#define focus_xh mccchannel_15_analyzer_1_array_crystal_array_6_focus_xh
#define focus_r mccchannel_15_analyzer_1_array_crystal_array_6_focus_r
#define p_interact mccchannel_15_analyzer_1_array_crystal_array_6_p_interact
#define mask_string mccchannel_15_analyzer_1_array_crystal_array_6_mask_string
#define mask_setting mccchannel_15_analyzer_1_array_crystal_array_6_mask_setting
#define number_of_activations mccchannel_15_analyzer_1_array_crystal_array_6_number_of_activations
#line 204 "Union_box.comp"
// Needed for transport to the main component
struct global_geometry_element_struct global_geometry_element;

#ifndef ANY_GEOMETRY_DETECTOR_DECLARE
    #define ANY_GEOMETRY_DETECTOR_DECLARE dummy
	//struct pointer_to_global_geometry_list global_geometry_list = {0,NULL};
#endif

int loop_index,found_geometries;

double x_component;
double y_component;
double z_component;

struct Volume_struct this_box_volume;
struct box_storage this_box_storage;

#line 72775 "MACS_sample_kidney_box.c"
#undef number_of_activations
#undef mask_setting
#undef mask_string
#undef p_interact
#undef focus_r
#undef focus_xh
#undef focus_xw
#undef focus_ah
#undef focus_aw
#undef target_z
#undef target_y
#undef target_x
#undef target_index
#undef visualize
#undef yheight2
#undef xwidth2
#undef zdepth
#undef yheight
#undef xwidth
#undef priority
#undef material_string
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

/* User declarations for component 'channel_15_analyzer_1_array_crystal_array_7' [707]. */
#define mccompcurname  channel_15_analyzer_1_array_crystal_array_7
#define mccompcurtype  Union_box
#define mccompcurindex 707
#define loop_index mccchannel_15_analyzer_1_array_crystal_array_7_loop_index
#define this_box_volume mccchannel_15_analyzer_1_array_crystal_array_7_this_box_volume
#define global_geometry_element mccchannel_15_analyzer_1_array_crystal_array_7_global_geometry_element
#define this_box_storage mccchannel_15_analyzer_1_array_crystal_array_7_this_box_storage
#define material_string mccchannel_15_analyzer_1_array_crystal_array_7_material_string
#define priority mccchannel_15_analyzer_1_array_crystal_array_7_priority
#define xwidth mccchannel_15_analyzer_1_array_crystal_array_7_xwidth
#define yheight mccchannel_15_analyzer_1_array_crystal_array_7_yheight
#define zdepth mccchannel_15_analyzer_1_array_crystal_array_7_zdepth
#define xwidth2 mccchannel_15_analyzer_1_array_crystal_array_7_xwidth2
#define yheight2 mccchannel_15_analyzer_1_array_crystal_array_7_yheight2
#define visualize mccchannel_15_analyzer_1_array_crystal_array_7_visualize
#define target_index mccchannel_15_analyzer_1_array_crystal_array_7_target_index
#define target_x mccchannel_15_analyzer_1_array_crystal_array_7_target_x
#define target_y mccchannel_15_analyzer_1_array_crystal_array_7_target_y
#define target_z mccchannel_15_analyzer_1_array_crystal_array_7_target_z
#define focus_aw mccchannel_15_analyzer_1_array_crystal_array_7_focus_aw
#define focus_ah mccchannel_15_analyzer_1_array_crystal_array_7_focus_ah
#define focus_xw mccchannel_15_analyzer_1_array_crystal_array_7_focus_xw
#define focus_xh mccchannel_15_analyzer_1_array_crystal_array_7_focus_xh
#define focus_r mccchannel_15_analyzer_1_array_crystal_array_7_focus_r
#define p_interact mccchannel_15_analyzer_1_array_crystal_array_7_p_interact
#define mask_string mccchannel_15_analyzer_1_array_crystal_array_7_mask_string
#define mask_setting mccchannel_15_analyzer_1_array_crystal_array_7_mask_setting
#define number_of_activations mccchannel_15_analyzer_1_array_crystal_array_7_number_of_activations
#line 204 "Union_box.comp"
// Needed for transport to the main component
struct global_geometry_element_struct global_geometry_element;

#ifndef ANY_GEOMETRY_DETECTOR_DECLARE
    #define ANY_GEOMETRY_DETECTOR_DECLARE dummy
	//struct pointer_to_global_geometry_list global_geometry_list = {0,NULL};
#endif

int loop_index,found_geometries;

double x_component;
double y_component;
double z_component;

struct Volume_struct this_box_volume;
struct box_storage this_box_storage;

#line 72852 "MACS_sample_kidney_box.c"
#undef number_of_activations
#undef mask_setting
#undef mask_string
#undef p_interact
#undef focus_r
#undef focus_xh
#undef focus_xw
#undef focus_ah
#undef focus_aw
#undef target_z
#undef target_y
#undef target_x
#undef target_index
#undef visualize
#undef yheight2
#undef xwidth2
#undef zdepth
#undef yheight
#undef xwidth
#undef priority
#undef material_string
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

/* User declarations for component 'channel_15_analyzer_1_array_crystal_array_8' [708]. */
#define mccompcurname  channel_15_analyzer_1_array_crystal_array_8
#define mccompcurtype  Union_box
#define mccompcurindex 708
#define loop_index mccchannel_15_analyzer_1_array_crystal_array_8_loop_index
#define this_box_volume mccchannel_15_analyzer_1_array_crystal_array_8_this_box_volume
#define global_geometry_element mccchannel_15_analyzer_1_array_crystal_array_8_global_geometry_element
#define this_box_storage mccchannel_15_analyzer_1_array_crystal_array_8_this_box_storage
#define material_string mccchannel_15_analyzer_1_array_crystal_array_8_material_string
#define priority mccchannel_15_analyzer_1_array_crystal_array_8_priority
#define xwidth mccchannel_15_analyzer_1_array_crystal_array_8_xwidth
#define yheight mccchannel_15_analyzer_1_array_crystal_array_8_yheight
#define zdepth mccchannel_15_analyzer_1_array_crystal_array_8_zdepth
#define xwidth2 mccchannel_15_analyzer_1_array_crystal_array_8_xwidth2
#define yheight2 mccchannel_15_analyzer_1_array_crystal_array_8_yheight2
#define visualize mccchannel_15_analyzer_1_array_crystal_array_8_visualize
#define target_index mccchannel_15_analyzer_1_array_crystal_array_8_target_index
#define target_x mccchannel_15_analyzer_1_array_crystal_array_8_target_x
#define target_y mccchannel_15_analyzer_1_array_crystal_array_8_target_y
#define target_z mccchannel_15_analyzer_1_array_crystal_array_8_target_z
#define focus_aw mccchannel_15_analyzer_1_array_crystal_array_8_focus_aw
#define focus_ah mccchannel_15_analyzer_1_array_crystal_array_8_focus_ah
#define focus_xw mccchannel_15_analyzer_1_array_crystal_array_8_focus_xw
#define focus_xh mccchannel_15_analyzer_1_array_crystal_array_8_focus_xh
#define focus_r mccchannel_15_analyzer_1_array_crystal_array_8_focus_r
#define p_interact mccchannel_15_analyzer_1_array_crystal_array_8_p_interact
#define mask_string mccchannel_15_analyzer_1_array_crystal_array_8_mask_string
#define mask_setting mccchannel_15_analyzer_1_array_crystal_array_8_mask_setting
#define number_of_activations mccchannel_15_analyzer_1_array_crystal_array_8_number_of_activations
#line 204 "Union_box.comp"
// Needed for transport to the main component
struct global_geometry_element_struct global_geometry_element;

#ifndef ANY_GEOMETRY_DETECTOR_DECLARE
    #define ANY_GEOMETRY_DETECTOR_DECLARE dummy
	//struct pointer_to_global_geometry_list global_geometry_list = {0,NULL};
#endif

int loop_index,found_geometries;

double x_component;
double y_component;
double z_component;

struct Volume_struct this_box_volume;
struct box_storage this_box_storage;

#line 72929 "MACS_sample_kidney_box.c"
#undef number_of_activations
#undef mask_setting
#undef mask_string
#undef p_interact
#undef focus_r
#undef focus_xh
#undef focus_xw
#undef focus_ah
#undef focus_aw
#undef target_z
#undef target_y
#undef target_x
#undef target_index
#undef visualize
#undef yheight2
#undef xwidth2
#undef zdepth
#undef yheight
#undef xwidth
#undef priority
#undef material_string
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

/* User declarations for component 'channel_15_analyzer_2_center' [709]. */
#define mccompcurname  channel_15_analyzer_2_center
#define mccompcurtype  Arm
#define mccompcurindex 709
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

/* User declarations for component 'channel_15_analyzer_2_rotated' [710]. */
#define mccompcurname  channel_15_analyzer_2_rotated
#define mccompcurtype  Arm
#define mccompcurindex 710
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

/* User declarations for component 'channel_15_analyzer_2_array_crystal_array_0' [711]. */
#define mccompcurname  channel_15_analyzer_2_array_crystal_array_0
#define mccompcurtype  Union_box
#define mccompcurindex 711
#define loop_index mccchannel_15_analyzer_2_array_crystal_array_0_loop_index
#define this_box_volume mccchannel_15_analyzer_2_array_crystal_array_0_this_box_volume
#define global_geometry_element mccchannel_15_analyzer_2_array_crystal_array_0_global_geometry_element
#define this_box_storage mccchannel_15_analyzer_2_array_crystal_array_0_this_box_storage
#define material_string mccchannel_15_analyzer_2_array_crystal_array_0_material_string
#define priority mccchannel_15_analyzer_2_array_crystal_array_0_priority
#define xwidth mccchannel_15_analyzer_2_array_crystal_array_0_xwidth
#define yheight mccchannel_15_analyzer_2_array_crystal_array_0_yheight
#define zdepth mccchannel_15_analyzer_2_array_crystal_array_0_zdepth
#define xwidth2 mccchannel_15_analyzer_2_array_crystal_array_0_xwidth2
#define yheight2 mccchannel_15_analyzer_2_array_crystal_array_0_yheight2
#define visualize mccchannel_15_analyzer_2_array_crystal_array_0_visualize
#define target_index mccchannel_15_analyzer_2_array_crystal_array_0_target_index
#define target_x mccchannel_15_analyzer_2_array_crystal_array_0_target_x
#define target_y mccchannel_15_analyzer_2_array_crystal_array_0_target_y
#define target_z mccchannel_15_analyzer_2_array_crystal_array_0_target_z
#define focus_aw mccchannel_15_analyzer_2_array_crystal_array_0_focus_aw
#define focus_ah mccchannel_15_analyzer_2_array_crystal_array_0_focus_ah
#define focus_xw mccchannel_15_analyzer_2_array_crystal_array_0_focus_xw
#define focus_xh mccchannel_15_analyzer_2_array_crystal_array_0_focus_xh
#define focus_r mccchannel_15_analyzer_2_array_crystal_array_0_focus_r
#define p_interact mccchannel_15_analyzer_2_array_crystal_array_0_p_interact
#define mask_string mccchannel_15_analyzer_2_array_crystal_array_0_mask_string
#define mask_setting mccchannel_15_analyzer_2_array_crystal_array_0_mask_setting
#define number_of_activations mccchannel_15_analyzer_2_array_crystal_array_0_number_of_activations
#line 204 "Union_box.comp"
// Needed for transport to the main component
struct global_geometry_element_struct global_geometry_element;

#ifndef ANY_GEOMETRY_DETECTOR_DECLARE
    #define ANY_GEOMETRY_DETECTOR_DECLARE dummy
	//struct pointer_to_global_geometry_list global_geometry_list = {0,NULL};
#endif

int loop_index,found_geometries;

double x_component;
double y_component;
double z_component;

struct Volume_struct this_box_volume;
struct box_storage this_box_storage;

#line 73022 "MACS_sample_kidney_box.c"
#undef number_of_activations
#undef mask_setting
#undef mask_string
#undef p_interact
#undef focus_r
#undef focus_xh
#undef focus_xw
#undef focus_ah
#undef focus_aw
#undef target_z
#undef target_y
#undef target_x
#undef target_index
#undef visualize
#undef yheight2
#undef xwidth2
#undef zdepth
#undef yheight
#undef xwidth
#undef priority
#undef material_string
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

/* User declarations for component 'channel_15_analyzer_2_array_crystal_array_1' [712]. */
#define mccompcurname  channel_15_analyzer_2_array_crystal_array_1
#define mccompcurtype  Union_box
#define mccompcurindex 712
#define loop_index mccchannel_15_analyzer_2_array_crystal_array_1_loop_index
#define this_box_volume mccchannel_15_analyzer_2_array_crystal_array_1_this_box_volume
#define global_geometry_element mccchannel_15_analyzer_2_array_crystal_array_1_global_geometry_element
#define this_box_storage mccchannel_15_analyzer_2_array_crystal_array_1_this_box_storage
#define material_string mccchannel_15_analyzer_2_array_crystal_array_1_material_string
#define priority mccchannel_15_analyzer_2_array_crystal_array_1_priority
#define xwidth mccchannel_15_analyzer_2_array_crystal_array_1_xwidth
#define yheight mccchannel_15_analyzer_2_array_crystal_array_1_yheight
#define zdepth mccchannel_15_analyzer_2_array_crystal_array_1_zdepth
#define xwidth2 mccchannel_15_analyzer_2_array_crystal_array_1_xwidth2
#define yheight2 mccchannel_15_analyzer_2_array_crystal_array_1_yheight2
#define visualize mccchannel_15_analyzer_2_array_crystal_array_1_visualize
#define target_index mccchannel_15_analyzer_2_array_crystal_array_1_target_index
#define target_x mccchannel_15_analyzer_2_array_crystal_array_1_target_x
#define target_y mccchannel_15_analyzer_2_array_crystal_array_1_target_y
#define target_z mccchannel_15_analyzer_2_array_crystal_array_1_target_z
#define focus_aw mccchannel_15_analyzer_2_array_crystal_array_1_focus_aw
#define focus_ah mccchannel_15_analyzer_2_array_crystal_array_1_focus_ah
#define focus_xw mccchannel_15_analyzer_2_array_crystal_array_1_focus_xw
#define focus_xh mccchannel_15_analyzer_2_array_crystal_array_1_focus_xh
#define focus_r mccchannel_15_analyzer_2_array_crystal_array_1_focus_r
#define p_interact mccchannel_15_analyzer_2_array_crystal_array_1_p_interact
#define mask_string mccchannel_15_analyzer_2_array_crystal_array_1_mask_string
#define mask_setting mccchannel_15_analyzer_2_array_crystal_array_1_mask_setting
#define number_of_activations mccchannel_15_analyzer_2_array_crystal_array_1_number_of_activations
#line 204 "Union_box.comp"
// Needed for transport to the main component
struct global_geometry_element_struct global_geometry_element;

#ifndef ANY_GEOMETRY_DETECTOR_DECLARE
    #define ANY_GEOMETRY_DETECTOR_DECLARE dummy
	//struct pointer_to_global_geometry_list global_geometry_list = {0,NULL};
#endif

int loop_index,found_geometries;

double x_component;
double y_component;
double z_component;

struct Volume_struct this_box_volume;
struct box_storage this_box_storage;

#line 73099 "MACS_sample_kidney_box.c"
#undef number_of_activations
#undef mask_setting
#undef mask_string
#undef p_interact
#undef focus_r
#undef focus_xh
#undef focus_xw
#undef focus_ah
#undef focus_aw
#undef target_z
#undef target_y
#undef target_x
#undef target_index
#undef visualize
#undef yheight2
#undef xwidth2
#undef zdepth
#undef yheight
#undef xwidth
#undef priority
#undef material_string
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

/* User declarations for component 'channel_15_analyzer_2_array_crystal_array_2' [713]. */
#define mccompcurname  channel_15_analyzer_2_array_crystal_array_2
#define mccompcurtype  Union_box
#define mccompcurindex 713
#define loop_index mccchannel_15_analyzer_2_array_crystal_array_2_loop_index
#define this_box_volume mccchannel_15_analyzer_2_array_crystal_array_2_this_box_volume
#define global_geometry_element mccchannel_15_analyzer_2_array_crystal_array_2_global_geometry_element
#define this_box_storage mccchannel_15_analyzer_2_array_crystal_array_2_this_box_storage
#define material_string mccchannel_15_analyzer_2_array_crystal_array_2_material_string
#define priority mccchannel_15_analyzer_2_array_crystal_array_2_priority
#define xwidth mccchannel_15_analyzer_2_array_crystal_array_2_xwidth
#define yheight mccchannel_15_analyzer_2_array_crystal_array_2_yheight
#define zdepth mccchannel_15_analyzer_2_array_crystal_array_2_zdepth
#define xwidth2 mccchannel_15_analyzer_2_array_crystal_array_2_xwidth2
#define yheight2 mccchannel_15_analyzer_2_array_crystal_array_2_yheight2
#define visualize mccchannel_15_analyzer_2_array_crystal_array_2_visualize
#define target_index mccchannel_15_analyzer_2_array_crystal_array_2_target_index
#define target_x mccchannel_15_analyzer_2_array_crystal_array_2_target_x
#define target_y mccchannel_15_analyzer_2_array_crystal_array_2_target_y
#define target_z mccchannel_15_analyzer_2_array_crystal_array_2_target_z
#define focus_aw mccchannel_15_analyzer_2_array_crystal_array_2_focus_aw
#define focus_ah mccchannel_15_analyzer_2_array_crystal_array_2_focus_ah
#define focus_xw mccchannel_15_analyzer_2_array_crystal_array_2_focus_xw
#define focus_xh mccchannel_15_analyzer_2_array_crystal_array_2_focus_xh
#define focus_r mccchannel_15_analyzer_2_array_crystal_array_2_focus_r
#define p_interact mccchannel_15_analyzer_2_array_crystal_array_2_p_interact
#define mask_string mccchannel_15_analyzer_2_array_crystal_array_2_mask_string
#define mask_setting mccchannel_15_analyzer_2_array_crystal_array_2_mask_setting
#define number_of_activations mccchannel_15_analyzer_2_array_crystal_array_2_number_of_activations
#line 204 "Union_box.comp"
// Needed for transport to the main component
struct global_geometry_element_struct global_geometry_element;

#ifndef ANY_GEOMETRY_DETECTOR_DECLARE
    #define ANY_GEOMETRY_DETECTOR_DECLARE dummy
	//struct pointer_to_global_geometry_list global_geometry_list = {0,NULL};
#endif

int loop_index,found_geometries;

double x_component;
double y_component;
double z_component;

struct Volume_struct this_box_volume;
struct box_storage this_box_storage;

#line 73176 "MACS_sample_kidney_box.c"
#undef number_of_activations
#undef mask_setting
#undef mask_string
#undef p_interact
#undef focus_r
#undef focus_xh
#undef focus_xw
#undef focus_ah
#undef focus_aw
#undef target_z
#undef target_y
#undef target_x
#undef target_index
#undef visualize
#undef yheight2
#undef xwidth2
#undef zdepth
#undef yheight
#undef xwidth
#undef priority
#undef material_string
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

/* User declarations for component 'channel_15_analyzer_2_array_crystal_array_3' [714]. */
#define mccompcurname  channel_15_analyzer_2_array_crystal_array_3
#define mccompcurtype  Union_box
#define mccompcurindex 714
#define loop_index mccchannel_15_analyzer_2_array_crystal_array_3_loop_index
#define this_box_volume mccchannel_15_analyzer_2_array_crystal_array_3_this_box_volume
#define global_geometry_element mccchannel_15_analyzer_2_array_crystal_array_3_global_geometry_element
#define this_box_storage mccchannel_15_analyzer_2_array_crystal_array_3_this_box_storage
#define material_string mccchannel_15_analyzer_2_array_crystal_array_3_material_string
#define priority mccchannel_15_analyzer_2_array_crystal_array_3_priority
#define xwidth mccchannel_15_analyzer_2_array_crystal_array_3_xwidth
#define yheight mccchannel_15_analyzer_2_array_crystal_array_3_yheight
#define zdepth mccchannel_15_analyzer_2_array_crystal_array_3_zdepth
#define xwidth2 mccchannel_15_analyzer_2_array_crystal_array_3_xwidth2
#define yheight2 mccchannel_15_analyzer_2_array_crystal_array_3_yheight2
#define visualize mccchannel_15_analyzer_2_array_crystal_array_3_visualize
#define target_index mccchannel_15_analyzer_2_array_crystal_array_3_target_index
#define target_x mccchannel_15_analyzer_2_array_crystal_array_3_target_x
#define target_y mccchannel_15_analyzer_2_array_crystal_array_3_target_y
#define target_z mccchannel_15_analyzer_2_array_crystal_array_3_target_z
#define focus_aw mccchannel_15_analyzer_2_array_crystal_array_3_focus_aw
#define focus_ah mccchannel_15_analyzer_2_array_crystal_array_3_focus_ah
#define focus_xw mccchannel_15_analyzer_2_array_crystal_array_3_focus_xw
#define focus_xh mccchannel_15_analyzer_2_array_crystal_array_3_focus_xh
#define focus_r mccchannel_15_analyzer_2_array_crystal_array_3_focus_r
#define p_interact mccchannel_15_analyzer_2_array_crystal_array_3_p_interact
#define mask_string mccchannel_15_analyzer_2_array_crystal_array_3_mask_string
#define mask_setting mccchannel_15_analyzer_2_array_crystal_array_3_mask_setting
#define number_of_activations mccchannel_15_analyzer_2_array_crystal_array_3_number_of_activations
#line 204 "Union_box.comp"
// Needed for transport to the main component
struct global_geometry_element_struct global_geometry_element;

#ifndef ANY_GEOMETRY_DETECTOR_DECLARE
    #define ANY_GEOMETRY_DETECTOR_DECLARE dummy
	//struct pointer_to_global_geometry_list global_geometry_list = {0,NULL};
#endif

int loop_index,found_geometries;

double x_component;
double y_component;
double z_component;

struct Volume_struct this_box_volume;
struct box_storage this_box_storage;

#line 73253 "MACS_sample_kidney_box.c"
#undef number_of_activations
#undef mask_setting
#undef mask_string
#undef p_interact
#undef focus_r
#undef focus_xh
#undef focus_xw
#undef focus_ah
#undef focus_aw
#undef target_z
#undef target_y
#undef target_x
#undef target_index
#undef visualize
#undef yheight2
#undef xwidth2
#undef zdepth
#undef yheight
#undef xwidth
#undef priority
#undef material_string
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

/* User declarations for component 'channel_15_analyzer_2_array_crystal_array_4' [715]. */
#define mccompcurname  channel_15_analyzer_2_array_crystal_array_4
#define mccompcurtype  Union_box
#define mccompcurindex 715
#define loop_index mccchannel_15_analyzer_2_array_crystal_array_4_loop_index
#define this_box_volume mccchannel_15_analyzer_2_array_crystal_array_4_this_box_volume
#define global_geometry_element mccchannel_15_analyzer_2_array_crystal_array_4_global_geometry_element
#define this_box_storage mccchannel_15_analyzer_2_array_crystal_array_4_this_box_storage
#define material_string mccchannel_15_analyzer_2_array_crystal_array_4_material_string
#define priority mccchannel_15_analyzer_2_array_crystal_array_4_priority
#define xwidth mccchannel_15_analyzer_2_array_crystal_array_4_xwidth
#define yheight mccchannel_15_analyzer_2_array_crystal_array_4_yheight
#define zdepth mccchannel_15_analyzer_2_array_crystal_array_4_zdepth
#define xwidth2 mccchannel_15_analyzer_2_array_crystal_array_4_xwidth2
#define yheight2 mccchannel_15_analyzer_2_array_crystal_array_4_yheight2
#define visualize mccchannel_15_analyzer_2_array_crystal_array_4_visualize
#define target_index mccchannel_15_analyzer_2_array_crystal_array_4_target_index
#define target_x mccchannel_15_analyzer_2_array_crystal_array_4_target_x
#define target_y mccchannel_15_analyzer_2_array_crystal_array_4_target_y
#define target_z mccchannel_15_analyzer_2_array_crystal_array_4_target_z
#define focus_aw mccchannel_15_analyzer_2_array_crystal_array_4_focus_aw
#define focus_ah mccchannel_15_analyzer_2_array_crystal_array_4_focus_ah
#define focus_xw mccchannel_15_analyzer_2_array_crystal_array_4_focus_xw
#define focus_xh mccchannel_15_analyzer_2_array_crystal_array_4_focus_xh
#define focus_r mccchannel_15_analyzer_2_array_crystal_array_4_focus_r
#define p_interact mccchannel_15_analyzer_2_array_crystal_array_4_p_interact
#define mask_string mccchannel_15_analyzer_2_array_crystal_array_4_mask_string
#define mask_setting mccchannel_15_analyzer_2_array_crystal_array_4_mask_setting
#define number_of_activations mccchannel_15_analyzer_2_array_crystal_array_4_number_of_activations
#line 204 "Union_box.comp"
// Needed for transport to the main component
struct global_geometry_element_struct global_geometry_element;

#ifndef ANY_GEOMETRY_DETECTOR_DECLARE
    #define ANY_GEOMETRY_DETECTOR_DECLARE dummy
	//struct pointer_to_global_geometry_list global_geometry_list = {0,NULL};
#endif

int loop_index,found_geometries;

double x_component;
double y_component;
double z_component;

struct Volume_struct this_box_volume;
struct box_storage this_box_storage;

#line 73330 "MACS_sample_kidney_box.c"
#undef number_of_activations
#undef mask_setting
#undef mask_string
#undef p_interact
#undef focus_r
#undef focus_xh
#undef focus_xw
#undef focus_ah
#undef focus_aw
#undef target_z
#undef target_y
#undef target_x
#undef target_index
#undef visualize
#undef yheight2
#undef xwidth2
#undef zdepth
#undef yheight
#undef xwidth
#undef priority
#undef material_string
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

/* User declarations for component 'channel_15_analyzer_2_array_crystal_array_5' [716]. */
#define mccompcurname  channel_15_analyzer_2_array_crystal_array_5
#define mccompcurtype  Union_box
#define mccompcurindex 716
#define loop_index mccchannel_15_analyzer_2_array_crystal_array_5_loop_index
#define this_box_volume mccchannel_15_analyzer_2_array_crystal_array_5_this_box_volume
#define global_geometry_element mccchannel_15_analyzer_2_array_crystal_array_5_global_geometry_element
#define this_box_storage mccchannel_15_analyzer_2_array_crystal_array_5_this_box_storage
#define material_string mccchannel_15_analyzer_2_array_crystal_array_5_material_string
#define priority mccchannel_15_analyzer_2_array_crystal_array_5_priority
#define xwidth mccchannel_15_analyzer_2_array_crystal_array_5_xwidth
#define yheight mccchannel_15_analyzer_2_array_crystal_array_5_yheight
#define zdepth mccchannel_15_analyzer_2_array_crystal_array_5_zdepth
#define xwidth2 mccchannel_15_analyzer_2_array_crystal_array_5_xwidth2
#define yheight2 mccchannel_15_analyzer_2_array_crystal_array_5_yheight2
#define visualize mccchannel_15_analyzer_2_array_crystal_array_5_visualize
#define target_index mccchannel_15_analyzer_2_array_crystal_array_5_target_index
#define target_x mccchannel_15_analyzer_2_array_crystal_array_5_target_x
#define target_y mccchannel_15_analyzer_2_array_crystal_array_5_target_y
#define target_z mccchannel_15_analyzer_2_array_crystal_array_5_target_z
#define focus_aw mccchannel_15_analyzer_2_array_crystal_array_5_focus_aw
#define focus_ah mccchannel_15_analyzer_2_array_crystal_array_5_focus_ah
#define focus_xw mccchannel_15_analyzer_2_array_crystal_array_5_focus_xw
#define focus_xh mccchannel_15_analyzer_2_array_crystal_array_5_focus_xh
#define focus_r mccchannel_15_analyzer_2_array_crystal_array_5_focus_r
#define p_interact mccchannel_15_analyzer_2_array_crystal_array_5_p_interact
#define mask_string mccchannel_15_analyzer_2_array_crystal_array_5_mask_string
#define mask_setting mccchannel_15_analyzer_2_array_crystal_array_5_mask_setting
#define number_of_activations mccchannel_15_analyzer_2_array_crystal_array_5_number_of_activations
#line 204 "Union_box.comp"
// Needed for transport to the main component
struct global_geometry_element_struct global_geometry_element;

#ifndef ANY_GEOMETRY_DETECTOR_DECLARE
    #define ANY_GEOMETRY_DETECTOR_DECLARE dummy
	//struct pointer_to_global_geometry_list global_geometry_list = {0,NULL};
#endif

int loop_index,found_geometries;

double x_component;
double y_component;
double z_component;

struct Volume_struct this_box_volume;
struct box_storage this_box_storage;

#line 73407 "MACS_sample_kidney_box.c"
#undef number_of_activations
#undef mask_setting
#undef mask_string
#undef p_interact
#undef focus_r
#undef focus_xh
#undef focus_xw
#undef focus_ah
#undef focus_aw
#undef target_z
#undef target_y
#undef target_x
#undef target_index
#undef visualize
#undef yheight2
#undef xwidth2
#undef zdepth
#undef yheight
#undef xwidth
#undef priority
#undef material_string
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

/* User declarations for component 'channel_15_analyzer_2_array_crystal_array_6' [717]. */
#define mccompcurname  channel_15_analyzer_2_array_crystal_array_6
#define mccompcurtype  Union_box
#define mccompcurindex 717
#define loop_index mccchannel_15_analyzer_2_array_crystal_array_6_loop_index
#define this_box_volume mccchannel_15_analyzer_2_array_crystal_array_6_this_box_volume
#define global_geometry_element mccchannel_15_analyzer_2_array_crystal_array_6_global_geometry_element
#define this_box_storage mccchannel_15_analyzer_2_array_crystal_array_6_this_box_storage
#define material_string mccchannel_15_analyzer_2_array_crystal_array_6_material_string
#define priority mccchannel_15_analyzer_2_array_crystal_array_6_priority
#define xwidth mccchannel_15_analyzer_2_array_crystal_array_6_xwidth
#define yheight mccchannel_15_analyzer_2_array_crystal_array_6_yheight
#define zdepth mccchannel_15_analyzer_2_array_crystal_array_6_zdepth
#define xwidth2 mccchannel_15_analyzer_2_array_crystal_array_6_xwidth2
#define yheight2 mccchannel_15_analyzer_2_array_crystal_array_6_yheight2
#define visualize mccchannel_15_analyzer_2_array_crystal_array_6_visualize
#define target_index mccchannel_15_analyzer_2_array_crystal_array_6_target_index
#define target_x mccchannel_15_analyzer_2_array_crystal_array_6_target_x
#define target_y mccchannel_15_analyzer_2_array_crystal_array_6_target_y
#define target_z mccchannel_15_analyzer_2_array_crystal_array_6_target_z
#define focus_aw mccchannel_15_analyzer_2_array_crystal_array_6_focus_aw
#define focus_ah mccchannel_15_analyzer_2_array_crystal_array_6_focus_ah
#define focus_xw mccchannel_15_analyzer_2_array_crystal_array_6_focus_xw
#define focus_xh mccchannel_15_analyzer_2_array_crystal_array_6_focus_xh
#define focus_r mccchannel_15_analyzer_2_array_crystal_array_6_focus_r
#define p_interact mccchannel_15_analyzer_2_array_crystal_array_6_p_interact
#define mask_string mccchannel_15_analyzer_2_array_crystal_array_6_mask_string
#define mask_setting mccchannel_15_analyzer_2_array_crystal_array_6_mask_setting
#define number_of_activations mccchannel_15_analyzer_2_array_crystal_array_6_number_of_activations
#line 204 "Union_box.comp"
// Needed for transport to the main component
struct global_geometry_element_struct global_geometry_element;

#ifndef ANY_GEOMETRY_DETECTOR_DECLARE
    #define ANY_GEOMETRY_DETECTOR_DECLARE dummy
	//struct pointer_to_global_geometry_list global_geometry_list = {0,NULL};
#endif

int loop_index,found_geometries;

double x_component;
double y_component;
double z_component;

struct Volume_struct this_box_volume;
struct box_storage this_box_storage;

#line 73484 "MACS_sample_kidney_box.c"
#undef number_of_activations
#undef mask_setting
#undef mask_string
#undef p_interact
#undef focus_r
#undef focus_xh
#undef focus_xw
#undef focus_ah
#undef focus_aw
#undef target_z
#undef target_y
#undef target_x
#undef target_index
#undef visualize
#undef yheight2
#undef xwidth2
#undef zdepth
#undef yheight
#undef xwidth
#undef priority
#undef material_string
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

/* User declarations for component 'channel_15_analyzer_2_array_crystal_array_7' [718]. */
#define mccompcurname  channel_15_analyzer_2_array_crystal_array_7
#define mccompcurtype  Union_box
#define mccompcurindex 718
#define loop_index mccchannel_15_analyzer_2_array_crystal_array_7_loop_index
#define this_box_volume mccchannel_15_analyzer_2_array_crystal_array_7_this_box_volume
#define global_geometry_element mccchannel_15_analyzer_2_array_crystal_array_7_global_geometry_element
#define this_box_storage mccchannel_15_analyzer_2_array_crystal_array_7_this_box_storage
#define material_string mccchannel_15_analyzer_2_array_crystal_array_7_material_string
#define priority mccchannel_15_analyzer_2_array_crystal_array_7_priority
#define xwidth mccchannel_15_analyzer_2_array_crystal_array_7_xwidth
#define yheight mccchannel_15_analyzer_2_array_crystal_array_7_yheight
#define zdepth mccchannel_15_analyzer_2_array_crystal_array_7_zdepth
#define xwidth2 mccchannel_15_analyzer_2_array_crystal_array_7_xwidth2
#define yheight2 mccchannel_15_analyzer_2_array_crystal_array_7_yheight2
#define visualize mccchannel_15_analyzer_2_array_crystal_array_7_visualize
#define target_index mccchannel_15_analyzer_2_array_crystal_array_7_target_index
#define target_x mccchannel_15_analyzer_2_array_crystal_array_7_target_x
#define target_y mccchannel_15_analyzer_2_array_crystal_array_7_target_y
#define target_z mccchannel_15_analyzer_2_array_crystal_array_7_target_z
#define focus_aw mccchannel_15_analyzer_2_array_crystal_array_7_focus_aw
#define focus_ah mccchannel_15_analyzer_2_array_crystal_array_7_focus_ah
#define focus_xw mccchannel_15_analyzer_2_array_crystal_array_7_focus_xw
#define focus_xh mccchannel_15_analyzer_2_array_crystal_array_7_focus_xh
#define focus_r mccchannel_15_analyzer_2_array_crystal_array_7_focus_r
#define p_interact mccchannel_15_analyzer_2_array_crystal_array_7_p_interact
#define mask_string mccchannel_15_analyzer_2_array_crystal_array_7_mask_string
#define mask_setting mccchannel_15_analyzer_2_array_crystal_array_7_mask_setting
#define number_of_activations mccchannel_15_analyzer_2_array_crystal_array_7_number_of_activations
#line 204 "Union_box.comp"
// Needed for transport to the main component
struct global_geometry_element_struct global_geometry_element;

#ifndef ANY_GEOMETRY_DETECTOR_DECLARE
    #define ANY_GEOMETRY_DETECTOR_DECLARE dummy
	//struct pointer_to_global_geometry_list global_geometry_list = {0,NULL};
#endif

int loop_index,found_geometries;

double x_component;
double y_component;
double z_component;

struct Volume_struct this_box_volume;
struct box_storage this_box_storage;

#line 73561 "MACS_sample_kidney_box.c"
#undef number_of_activations
#undef mask_setting
#undef mask_string
#undef p_interact
#undef focus_r
#undef focus_xh
#undef focus_xw
#undef focus_ah
#undef focus_aw
#undef target_z
#undef target_y
#undef target_x
#undef target_index
#undef visualize
#undef yheight2
#undef xwidth2
#undef zdepth
#undef yheight
#undef xwidth
#undef priority
#undef material_string
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

/* User declarations for component 'channel_15_analyzer_2_array_crystal_array_8' [719]. */
#define mccompcurname  channel_15_analyzer_2_array_crystal_array_8
#define mccompcurtype  Union_box
#define mccompcurindex 719
#define loop_index mccchannel_15_analyzer_2_array_crystal_array_8_loop_index
#define this_box_volume mccchannel_15_analyzer_2_array_crystal_array_8_this_box_volume
#define global_geometry_element mccchannel_15_analyzer_2_array_crystal_array_8_global_geometry_element
#define this_box_storage mccchannel_15_analyzer_2_array_crystal_array_8_this_box_storage
#define material_string mccchannel_15_analyzer_2_array_crystal_array_8_material_string
#define priority mccchannel_15_analyzer_2_array_crystal_array_8_priority
#define xwidth mccchannel_15_analyzer_2_array_crystal_array_8_xwidth
#define yheight mccchannel_15_analyzer_2_array_crystal_array_8_yheight
#define zdepth mccchannel_15_analyzer_2_array_crystal_array_8_zdepth
#define xwidth2 mccchannel_15_analyzer_2_array_crystal_array_8_xwidth2
#define yheight2 mccchannel_15_analyzer_2_array_crystal_array_8_yheight2
#define visualize mccchannel_15_analyzer_2_array_crystal_array_8_visualize
#define target_index mccchannel_15_analyzer_2_array_crystal_array_8_target_index
#define target_x mccchannel_15_analyzer_2_array_crystal_array_8_target_x
#define target_y mccchannel_15_analyzer_2_array_crystal_array_8_target_y
#define target_z mccchannel_15_analyzer_2_array_crystal_array_8_target_z
#define focus_aw mccchannel_15_analyzer_2_array_crystal_array_8_focus_aw
#define focus_ah mccchannel_15_analyzer_2_array_crystal_array_8_focus_ah
#define focus_xw mccchannel_15_analyzer_2_array_crystal_array_8_focus_xw
#define focus_xh mccchannel_15_analyzer_2_array_crystal_array_8_focus_xh
#define focus_r mccchannel_15_analyzer_2_array_crystal_array_8_focus_r
#define p_interact mccchannel_15_analyzer_2_array_crystal_array_8_p_interact
#define mask_string mccchannel_15_analyzer_2_array_crystal_array_8_mask_string
#define mask_setting mccchannel_15_analyzer_2_array_crystal_array_8_mask_setting
#define number_of_activations mccchannel_15_analyzer_2_array_crystal_array_8_number_of_activations
#line 204 "Union_box.comp"
// Needed for transport to the main component
struct global_geometry_element_struct global_geometry_element;

#ifndef ANY_GEOMETRY_DETECTOR_DECLARE
    #define ANY_GEOMETRY_DETECTOR_DECLARE dummy
	//struct pointer_to_global_geometry_list global_geometry_list = {0,NULL};
#endif

int loop_index,found_geometries;

double x_component;
double y_component;
double z_component;

struct Volume_struct this_box_volume;
struct box_storage this_box_storage;

#line 73638 "MACS_sample_kidney_box.c"
#undef number_of_activations
#undef mask_setting
#undef mask_string
#undef p_interact
#undef focus_r
#undef focus_xh
#undef focus_xw
#undef focus_ah
#undef focus_aw
#undef target_z
#undef target_y
#undef target_x
#undef target_index
#undef visualize
#undef yheight2
#undef xwidth2
#undef zdepth
#undef yheight
#undef xwidth
#undef priority
#undef material_string
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

/* User declarations for component 'channel_15_cave2_cyl1' [720]. */
#define mccompcurname  channel_15_cave2_cyl1
#define mccompcurtype  Union_cylinder
#define mccompcurindex 720
#define loop_index mccchannel_15_cave2_cyl1_loop_index
#define this_cylinder_volume mccchannel_15_cave2_cyl1_this_cylinder_volume
#define global_geometry_element mccchannel_15_cave2_cyl1_global_geometry_element
#define this_cylinder_storage mccchannel_15_cave2_cyl1_this_cylinder_storage
#define material_string mccchannel_15_cave2_cyl1_material_string
#define priority mccchannel_15_cave2_cyl1_priority
#define radius mccchannel_15_cave2_cyl1_radius
#define yheight mccchannel_15_cave2_cyl1_yheight
#define visualize mccchannel_15_cave2_cyl1_visualize
#define target_index mccchannel_15_cave2_cyl1_target_index
#define target_x mccchannel_15_cave2_cyl1_target_x
#define target_y mccchannel_15_cave2_cyl1_target_y
#define target_z mccchannel_15_cave2_cyl1_target_z
#define focus_aw mccchannel_15_cave2_cyl1_focus_aw
#define focus_ah mccchannel_15_cave2_cyl1_focus_ah
#define focus_xw mccchannel_15_cave2_cyl1_focus_xw
#define focus_xh mccchannel_15_cave2_cyl1_focus_xh
#define focus_r mccchannel_15_cave2_cyl1_focus_r
#define p_interact mccchannel_15_cave2_cyl1_p_interact
#define mask_string mccchannel_15_cave2_cyl1_mask_string
#define mask_setting mccchannel_15_cave2_cyl1_mask_setting
#define number_of_activations mccchannel_15_cave2_cyl1_number_of_activations
#line 167 "Union_cylinder.comp"
// Needed for transport to the main component
struct global_geometry_element_struct global_geometry_element;

#ifndef ANY_GEOMETRY_DETECTOR_DECLARE
    #define ANY_GEOMETRY_DETECTOR_DECLARE dummy
	//struct pointer_to_global_geometry_list global_geometry_list = {0,NULL};
#endif

int dummy;
int loop_index,found_geometries;
int loop_2_index;
int material_index;

struct Volume_struct this_cylinder_volume;
struct cylinder_storage this_cylinder_storage;
#line 73710 "MACS_sample_kidney_box.c"
#undef number_of_activations
#undef mask_setting
#undef mask_string
#undef p_interact
#undef focus_r
#undef focus_xh
#undef focus_xw
#undef focus_ah
#undef focus_aw
#undef target_z
#undef target_y
#undef target_x
#undef target_index
#undef visualize
#undef yheight
#undef radius
#undef priority
#undef material_string
#undef this_cylinder_storage
#undef global_geometry_element
#undef this_cylinder_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

/* User declarations for component 'channel_15_cave2_box1' [721]. */
#define mccompcurname  channel_15_cave2_box1
#define mccompcurtype  Union_box
#define mccompcurindex 721
#define loop_index mccchannel_15_cave2_box1_loop_index
#define this_box_volume mccchannel_15_cave2_box1_this_box_volume
#define global_geometry_element mccchannel_15_cave2_box1_global_geometry_element
#define this_box_storage mccchannel_15_cave2_box1_this_box_storage
#define material_string mccchannel_15_cave2_box1_material_string
#define priority mccchannel_15_cave2_box1_priority
#define xwidth mccchannel_15_cave2_box1_xwidth
#define yheight mccchannel_15_cave2_box1_yheight
#define zdepth mccchannel_15_cave2_box1_zdepth
#define xwidth2 mccchannel_15_cave2_box1_xwidth2
#define yheight2 mccchannel_15_cave2_box1_yheight2
#define visualize mccchannel_15_cave2_box1_visualize
#define target_index mccchannel_15_cave2_box1_target_index
#define target_x mccchannel_15_cave2_box1_target_x
#define target_y mccchannel_15_cave2_box1_target_y
#define target_z mccchannel_15_cave2_box1_target_z
#define focus_aw mccchannel_15_cave2_box1_focus_aw
#define focus_ah mccchannel_15_cave2_box1_focus_ah
#define focus_xw mccchannel_15_cave2_box1_focus_xw
#define focus_xh mccchannel_15_cave2_box1_focus_xh
#define focus_r mccchannel_15_cave2_box1_focus_r
#define p_interact mccchannel_15_cave2_box1_p_interact
#define mask_string mccchannel_15_cave2_box1_mask_string
#define mask_setting mccchannel_15_cave2_box1_mask_setting
#define number_of_activations mccchannel_15_cave2_box1_number_of_activations
#line 204 "Union_box.comp"
// Needed for transport to the main component
struct global_geometry_element_struct global_geometry_element;

#ifndef ANY_GEOMETRY_DETECTOR_DECLARE
    #define ANY_GEOMETRY_DETECTOR_DECLARE dummy
	//struct pointer_to_global_geometry_list global_geometry_list = {0,NULL};
#endif

int loop_index,found_geometries;

double x_component;
double y_component;
double z_component;

struct Volume_struct this_box_volume;
struct box_storage this_box_storage;

#line 73784 "MACS_sample_kidney_box.c"
#undef number_of_activations
#undef mask_setting
#undef mask_string
#undef p_interact
#undef focus_r
#undef focus_xh
#undef focus_xw
#undef focus_ah
#undef focus_aw
#undef target_z
#undef target_y
#undef target_x
#undef target_index
#undef visualize
#undef yheight2
#undef xwidth2
#undef zdepth
#undef yheight
#undef xwidth
#undef priority
#undef material_string
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

/* User declarations for component 'channel_15_cave2_box2' [722]. */
#define mccompcurname  channel_15_cave2_box2
#define mccompcurtype  Union_box
#define mccompcurindex 722
#define loop_index mccchannel_15_cave2_box2_loop_index
#define this_box_volume mccchannel_15_cave2_box2_this_box_volume
#define global_geometry_element mccchannel_15_cave2_box2_global_geometry_element
#define this_box_storage mccchannel_15_cave2_box2_this_box_storage
#define material_string mccchannel_15_cave2_box2_material_string
#define priority mccchannel_15_cave2_box2_priority
#define xwidth mccchannel_15_cave2_box2_xwidth
#define yheight mccchannel_15_cave2_box2_yheight
#define zdepth mccchannel_15_cave2_box2_zdepth
#define xwidth2 mccchannel_15_cave2_box2_xwidth2
#define yheight2 mccchannel_15_cave2_box2_yheight2
#define visualize mccchannel_15_cave2_box2_visualize
#define target_index mccchannel_15_cave2_box2_target_index
#define target_x mccchannel_15_cave2_box2_target_x
#define target_y mccchannel_15_cave2_box2_target_y
#define target_z mccchannel_15_cave2_box2_target_z
#define focus_aw mccchannel_15_cave2_box2_focus_aw
#define focus_ah mccchannel_15_cave2_box2_focus_ah
#define focus_xw mccchannel_15_cave2_box2_focus_xw
#define focus_xh mccchannel_15_cave2_box2_focus_xh
#define focus_r mccchannel_15_cave2_box2_focus_r
#define p_interact mccchannel_15_cave2_box2_p_interact
#define mask_string mccchannel_15_cave2_box2_mask_string
#define mask_setting mccchannel_15_cave2_box2_mask_setting
#define number_of_activations mccchannel_15_cave2_box2_number_of_activations
#line 204 "Union_box.comp"
// Needed for transport to the main component
struct global_geometry_element_struct global_geometry_element;

#ifndef ANY_GEOMETRY_DETECTOR_DECLARE
    #define ANY_GEOMETRY_DETECTOR_DECLARE dummy
	//struct pointer_to_global_geometry_list global_geometry_list = {0,NULL};
#endif

int loop_index,found_geometries;

double x_component;
double y_component;
double z_component;

struct Volume_struct this_box_volume;
struct box_storage this_box_storage;

#line 73861 "MACS_sample_kidney_box.c"
#undef number_of_activations
#undef mask_setting
#undef mask_string
#undef p_interact
#undef focus_r
#undef focus_xh
#undef focus_xw
#undef focus_ah
#undef focus_aw
#undef target_z
#undef target_y
#undef target_x
#undef target_index
#undef visualize
#undef yheight2
#undef xwidth2
#undef zdepth
#undef yheight
#undef xwidth
#undef priority
#undef material_string
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

/* User declarations for component 'channel_15_cave2_box3' [723]. */
#define mccompcurname  channel_15_cave2_box3
#define mccompcurtype  Union_box
#define mccompcurindex 723
#define loop_index mccchannel_15_cave2_box3_loop_index
#define this_box_volume mccchannel_15_cave2_box3_this_box_volume
#define global_geometry_element mccchannel_15_cave2_box3_global_geometry_element
#define this_box_storage mccchannel_15_cave2_box3_this_box_storage
#define material_string mccchannel_15_cave2_box3_material_string
#define priority mccchannel_15_cave2_box3_priority
#define xwidth mccchannel_15_cave2_box3_xwidth
#define yheight mccchannel_15_cave2_box3_yheight
#define zdepth mccchannel_15_cave2_box3_zdepth
#define xwidth2 mccchannel_15_cave2_box3_xwidth2
#define yheight2 mccchannel_15_cave2_box3_yheight2
#define visualize mccchannel_15_cave2_box3_visualize
#define target_index mccchannel_15_cave2_box3_target_index
#define target_x mccchannel_15_cave2_box3_target_x
#define target_y mccchannel_15_cave2_box3_target_y
#define target_z mccchannel_15_cave2_box3_target_z
#define focus_aw mccchannel_15_cave2_box3_focus_aw
#define focus_ah mccchannel_15_cave2_box3_focus_ah
#define focus_xw mccchannel_15_cave2_box3_focus_xw
#define focus_xh mccchannel_15_cave2_box3_focus_xh
#define focus_r mccchannel_15_cave2_box3_focus_r
#define p_interact mccchannel_15_cave2_box3_p_interact
#define mask_string mccchannel_15_cave2_box3_mask_string
#define mask_setting mccchannel_15_cave2_box3_mask_setting
#define number_of_activations mccchannel_15_cave2_box3_number_of_activations
#line 204 "Union_box.comp"
// Needed for transport to the main component
struct global_geometry_element_struct global_geometry_element;

#ifndef ANY_GEOMETRY_DETECTOR_DECLARE
    #define ANY_GEOMETRY_DETECTOR_DECLARE dummy
	//struct pointer_to_global_geometry_list global_geometry_list = {0,NULL};
#endif

int loop_index,found_geometries;

double x_component;
double y_component;
double z_component;

struct Volume_struct this_box_volume;
struct box_storage this_box_storage;

#line 73938 "MACS_sample_kidney_box.c"
#undef number_of_activations
#undef mask_setting
#undef mask_string
#undef p_interact
#undef focus_r
#undef focus_xh
#undef focus_xw
#undef focus_ah
#undef focus_aw
#undef target_z
#undef target_y
#undef target_x
#undef target_index
#undef visualize
#undef yheight2
#undef xwidth2
#undef zdepth
#undef yheight
#undef xwidth
#undef priority
#undef material_string
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

/* User declarations for component 'inter_analyzer_colimator_center_15' [724]. */
#define mccompcurname  inter_analyzer_colimator_center_15
#define mccompcurtype  Arm
#define mccompcurindex 724
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

/* User declarations for component 'inter_analyzer_colimator_15_blade_0' [725]. */
#define mccompcurname  inter_analyzer_colimator_15_blade_0
#define mccompcurtype  Union_box
#define mccompcurindex 725
#define loop_index mccinter_analyzer_colimator_15_blade_0_loop_index
#define this_box_volume mccinter_analyzer_colimator_15_blade_0_this_box_volume
#define global_geometry_element mccinter_analyzer_colimator_15_blade_0_global_geometry_element
#define this_box_storage mccinter_analyzer_colimator_15_blade_0_this_box_storage
#define material_string mccinter_analyzer_colimator_15_blade_0_material_string
#define priority mccinter_analyzer_colimator_15_blade_0_priority
#define xwidth mccinter_analyzer_colimator_15_blade_0_xwidth
#define yheight mccinter_analyzer_colimator_15_blade_0_yheight
#define zdepth mccinter_analyzer_colimator_15_blade_0_zdepth
#define xwidth2 mccinter_analyzer_colimator_15_blade_0_xwidth2
#define yheight2 mccinter_analyzer_colimator_15_blade_0_yheight2
#define visualize mccinter_analyzer_colimator_15_blade_0_visualize
#define target_index mccinter_analyzer_colimator_15_blade_0_target_index
#define target_x mccinter_analyzer_colimator_15_blade_0_target_x
#define target_y mccinter_analyzer_colimator_15_blade_0_target_y
#define target_z mccinter_analyzer_colimator_15_blade_0_target_z
#define focus_aw mccinter_analyzer_colimator_15_blade_0_focus_aw
#define focus_ah mccinter_analyzer_colimator_15_blade_0_focus_ah
#define focus_xw mccinter_analyzer_colimator_15_blade_0_focus_xw
#define focus_xh mccinter_analyzer_colimator_15_blade_0_focus_xh
#define focus_r mccinter_analyzer_colimator_15_blade_0_focus_r
#define p_interact mccinter_analyzer_colimator_15_blade_0_p_interact
#define mask_string mccinter_analyzer_colimator_15_blade_0_mask_string
#define mask_setting mccinter_analyzer_colimator_15_blade_0_mask_setting
#define number_of_activations mccinter_analyzer_colimator_15_blade_0_number_of_activations
#line 204 "Union_box.comp"
// Needed for transport to the main component
struct global_geometry_element_struct global_geometry_element;

#ifndef ANY_GEOMETRY_DETECTOR_DECLARE
    #define ANY_GEOMETRY_DETECTOR_DECLARE dummy
	//struct pointer_to_global_geometry_list global_geometry_list = {0,NULL};
#endif

int loop_index,found_geometries;

double x_component;
double y_component;
double z_component;

struct Volume_struct this_box_volume;
struct box_storage this_box_storage;

#line 74023 "MACS_sample_kidney_box.c"
#undef number_of_activations
#undef mask_setting
#undef mask_string
#undef p_interact
#undef focus_r
#undef focus_xh
#undef focus_xw
#undef focus_ah
#undef focus_aw
#undef target_z
#undef target_y
#undef target_x
#undef target_index
#undef visualize
#undef yheight2
#undef xwidth2
#undef zdepth
#undef yheight
#undef xwidth
#undef priority
#undef material_string
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

/* User declarations for component 'inter_analyzer_colimator_15_blade_1' [726]. */
#define mccompcurname  inter_analyzer_colimator_15_blade_1
#define mccompcurtype  Union_box
#define mccompcurindex 726
#define loop_index mccinter_analyzer_colimator_15_blade_1_loop_index
#define this_box_volume mccinter_analyzer_colimator_15_blade_1_this_box_volume
#define global_geometry_element mccinter_analyzer_colimator_15_blade_1_global_geometry_element
#define this_box_storage mccinter_analyzer_colimator_15_blade_1_this_box_storage
#define material_string mccinter_analyzer_colimator_15_blade_1_material_string
#define priority mccinter_analyzer_colimator_15_blade_1_priority
#define xwidth mccinter_analyzer_colimator_15_blade_1_xwidth
#define yheight mccinter_analyzer_colimator_15_blade_1_yheight
#define zdepth mccinter_analyzer_colimator_15_blade_1_zdepth
#define xwidth2 mccinter_analyzer_colimator_15_blade_1_xwidth2
#define yheight2 mccinter_analyzer_colimator_15_blade_1_yheight2
#define visualize mccinter_analyzer_colimator_15_blade_1_visualize
#define target_index mccinter_analyzer_colimator_15_blade_1_target_index
#define target_x mccinter_analyzer_colimator_15_blade_1_target_x
#define target_y mccinter_analyzer_colimator_15_blade_1_target_y
#define target_z mccinter_analyzer_colimator_15_blade_1_target_z
#define focus_aw mccinter_analyzer_colimator_15_blade_1_focus_aw
#define focus_ah mccinter_analyzer_colimator_15_blade_1_focus_ah
#define focus_xw mccinter_analyzer_colimator_15_blade_1_focus_xw
#define focus_xh mccinter_analyzer_colimator_15_blade_1_focus_xh
#define focus_r mccinter_analyzer_colimator_15_blade_1_focus_r
#define p_interact mccinter_analyzer_colimator_15_blade_1_p_interact
#define mask_string mccinter_analyzer_colimator_15_blade_1_mask_string
#define mask_setting mccinter_analyzer_colimator_15_blade_1_mask_setting
#define number_of_activations mccinter_analyzer_colimator_15_blade_1_number_of_activations
#line 204 "Union_box.comp"
// Needed for transport to the main component
struct global_geometry_element_struct global_geometry_element;

#ifndef ANY_GEOMETRY_DETECTOR_DECLARE
    #define ANY_GEOMETRY_DETECTOR_DECLARE dummy
	//struct pointer_to_global_geometry_list global_geometry_list = {0,NULL};
#endif

int loop_index,found_geometries;

double x_component;
double y_component;
double z_component;

struct Volume_struct this_box_volume;
struct box_storage this_box_storage;

#line 74100 "MACS_sample_kidney_box.c"
#undef number_of_activations
#undef mask_setting
#undef mask_string
#undef p_interact
#undef focus_r
#undef focus_xh
#undef focus_xw
#undef focus_ah
#undef focus_aw
#undef target_z
#undef target_y
#undef target_x
#undef target_index
#undef visualize
#undef yheight2
#undef xwidth2
#undef zdepth
#undef yheight
#undef xwidth
#undef priority
#undef material_string
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

/* User declarations for component 'inter_analyzer_colimator_15_blade_2' [727]. */
#define mccompcurname  inter_analyzer_colimator_15_blade_2
#define mccompcurtype  Union_box
#define mccompcurindex 727
#define loop_index mccinter_analyzer_colimator_15_blade_2_loop_index
#define this_box_volume mccinter_analyzer_colimator_15_blade_2_this_box_volume
#define global_geometry_element mccinter_analyzer_colimator_15_blade_2_global_geometry_element
#define this_box_storage mccinter_analyzer_colimator_15_blade_2_this_box_storage
#define material_string mccinter_analyzer_colimator_15_blade_2_material_string
#define priority mccinter_analyzer_colimator_15_blade_2_priority
#define xwidth mccinter_analyzer_colimator_15_blade_2_xwidth
#define yheight mccinter_analyzer_colimator_15_blade_2_yheight
#define zdepth mccinter_analyzer_colimator_15_blade_2_zdepth
#define xwidth2 mccinter_analyzer_colimator_15_blade_2_xwidth2
#define yheight2 mccinter_analyzer_colimator_15_blade_2_yheight2
#define visualize mccinter_analyzer_colimator_15_blade_2_visualize
#define target_index mccinter_analyzer_colimator_15_blade_2_target_index
#define target_x mccinter_analyzer_colimator_15_blade_2_target_x
#define target_y mccinter_analyzer_colimator_15_blade_2_target_y
#define target_z mccinter_analyzer_colimator_15_blade_2_target_z
#define focus_aw mccinter_analyzer_colimator_15_blade_2_focus_aw
#define focus_ah mccinter_analyzer_colimator_15_blade_2_focus_ah
#define focus_xw mccinter_analyzer_colimator_15_blade_2_focus_xw
#define focus_xh mccinter_analyzer_colimator_15_blade_2_focus_xh
#define focus_r mccinter_analyzer_colimator_15_blade_2_focus_r
#define p_interact mccinter_analyzer_colimator_15_blade_2_p_interact
#define mask_string mccinter_analyzer_colimator_15_blade_2_mask_string
#define mask_setting mccinter_analyzer_colimator_15_blade_2_mask_setting
#define number_of_activations mccinter_analyzer_colimator_15_blade_2_number_of_activations
#line 204 "Union_box.comp"
// Needed for transport to the main component
struct global_geometry_element_struct global_geometry_element;

#ifndef ANY_GEOMETRY_DETECTOR_DECLARE
    #define ANY_GEOMETRY_DETECTOR_DECLARE dummy
	//struct pointer_to_global_geometry_list global_geometry_list = {0,NULL};
#endif

int loop_index,found_geometries;

double x_component;
double y_component;
double z_component;

struct Volume_struct this_box_volume;
struct box_storage this_box_storage;

#line 74177 "MACS_sample_kidney_box.c"
#undef number_of_activations
#undef mask_setting
#undef mask_string
#undef p_interact
#undef focus_r
#undef focus_xh
#undef focus_xw
#undef focus_ah
#undef focus_aw
#undef target_z
#undef target_y
#undef target_x
#undef target_index
#undef visualize
#undef yheight2
#undef xwidth2
#undef zdepth
#undef yheight
#undef xwidth
#undef priority
#undef material_string
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

/* User declarations for component 'inter_analyzer_colimator_15_blade_3' [728]. */
#define mccompcurname  inter_analyzer_colimator_15_blade_3
#define mccompcurtype  Union_box
#define mccompcurindex 728
#define loop_index mccinter_analyzer_colimator_15_blade_3_loop_index
#define this_box_volume mccinter_analyzer_colimator_15_blade_3_this_box_volume
#define global_geometry_element mccinter_analyzer_colimator_15_blade_3_global_geometry_element
#define this_box_storage mccinter_analyzer_colimator_15_blade_3_this_box_storage
#define material_string mccinter_analyzer_colimator_15_blade_3_material_string
#define priority mccinter_analyzer_colimator_15_blade_3_priority
#define xwidth mccinter_analyzer_colimator_15_blade_3_xwidth
#define yheight mccinter_analyzer_colimator_15_blade_3_yheight
#define zdepth mccinter_analyzer_colimator_15_blade_3_zdepth
#define xwidth2 mccinter_analyzer_colimator_15_blade_3_xwidth2
#define yheight2 mccinter_analyzer_colimator_15_blade_3_yheight2
#define visualize mccinter_analyzer_colimator_15_blade_3_visualize
#define target_index mccinter_analyzer_colimator_15_blade_3_target_index
#define target_x mccinter_analyzer_colimator_15_blade_3_target_x
#define target_y mccinter_analyzer_colimator_15_blade_3_target_y
#define target_z mccinter_analyzer_colimator_15_blade_3_target_z
#define focus_aw mccinter_analyzer_colimator_15_blade_3_focus_aw
#define focus_ah mccinter_analyzer_colimator_15_blade_3_focus_ah
#define focus_xw mccinter_analyzer_colimator_15_blade_3_focus_xw
#define focus_xh mccinter_analyzer_colimator_15_blade_3_focus_xh
#define focus_r mccinter_analyzer_colimator_15_blade_3_focus_r
#define p_interact mccinter_analyzer_colimator_15_blade_3_p_interact
#define mask_string mccinter_analyzer_colimator_15_blade_3_mask_string
#define mask_setting mccinter_analyzer_colimator_15_blade_3_mask_setting
#define number_of_activations mccinter_analyzer_colimator_15_blade_3_number_of_activations
#line 204 "Union_box.comp"
// Needed for transport to the main component
struct global_geometry_element_struct global_geometry_element;

#ifndef ANY_GEOMETRY_DETECTOR_DECLARE
    #define ANY_GEOMETRY_DETECTOR_DECLARE dummy
	//struct pointer_to_global_geometry_list global_geometry_list = {0,NULL};
#endif

int loop_index,found_geometries;

double x_component;
double y_component;
double z_component;

struct Volume_struct this_box_volume;
struct box_storage this_box_storage;

#line 74254 "MACS_sample_kidney_box.c"
#undef number_of_activations
#undef mask_setting
#undef mask_string
#undef p_interact
#undef focus_r
#undef focus_xh
#undef focus_xw
#undef focus_ah
#undef focus_aw
#undef target_z
#undef target_y
#undef target_x
#undef target_index
#undef visualize
#undef yheight2
#undef xwidth2
#undef zdepth
#undef yheight
#undef xwidth
#undef priority
#undef material_string
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

/* User declarations for component 'inter_analyzer_colimator_15_blade_4' [729]. */
#define mccompcurname  inter_analyzer_colimator_15_blade_4
#define mccompcurtype  Union_box
#define mccompcurindex 729
#define loop_index mccinter_analyzer_colimator_15_blade_4_loop_index
#define this_box_volume mccinter_analyzer_colimator_15_blade_4_this_box_volume
#define global_geometry_element mccinter_analyzer_colimator_15_blade_4_global_geometry_element
#define this_box_storage mccinter_analyzer_colimator_15_blade_4_this_box_storage
#define material_string mccinter_analyzer_colimator_15_blade_4_material_string
#define priority mccinter_analyzer_colimator_15_blade_4_priority
#define xwidth mccinter_analyzer_colimator_15_blade_4_xwidth
#define yheight mccinter_analyzer_colimator_15_blade_4_yheight
#define zdepth mccinter_analyzer_colimator_15_blade_4_zdepth
#define xwidth2 mccinter_analyzer_colimator_15_blade_4_xwidth2
#define yheight2 mccinter_analyzer_colimator_15_blade_4_yheight2
#define visualize mccinter_analyzer_colimator_15_blade_4_visualize
#define target_index mccinter_analyzer_colimator_15_blade_4_target_index
#define target_x mccinter_analyzer_colimator_15_blade_4_target_x
#define target_y mccinter_analyzer_colimator_15_blade_4_target_y
#define target_z mccinter_analyzer_colimator_15_blade_4_target_z
#define focus_aw mccinter_analyzer_colimator_15_blade_4_focus_aw
#define focus_ah mccinter_analyzer_colimator_15_blade_4_focus_ah
#define focus_xw mccinter_analyzer_colimator_15_blade_4_focus_xw
#define focus_xh mccinter_analyzer_colimator_15_blade_4_focus_xh
#define focus_r mccinter_analyzer_colimator_15_blade_4_focus_r
#define p_interact mccinter_analyzer_colimator_15_blade_4_p_interact
#define mask_string mccinter_analyzer_colimator_15_blade_4_mask_string
#define mask_setting mccinter_analyzer_colimator_15_blade_4_mask_setting
#define number_of_activations mccinter_analyzer_colimator_15_blade_4_number_of_activations
#line 204 "Union_box.comp"
// Needed for transport to the main component
struct global_geometry_element_struct global_geometry_element;

#ifndef ANY_GEOMETRY_DETECTOR_DECLARE
    #define ANY_GEOMETRY_DETECTOR_DECLARE dummy
	//struct pointer_to_global_geometry_list global_geometry_list = {0,NULL};
#endif

int loop_index,found_geometries;

double x_component;
double y_component;
double z_component;

struct Volume_struct this_box_volume;
struct box_storage this_box_storage;

#line 74331 "MACS_sample_kidney_box.c"
#undef number_of_activations
#undef mask_setting
#undef mask_string
#undef p_interact
#undef focus_r
#undef focus_xh
#undef focus_xw
#undef focus_ah
#undef focus_aw
#undef target_z
#undef target_y
#undef target_x
#undef target_index
#undef visualize
#undef yheight2
#undef xwidth2
#undef zdepth
#undef yheight
#undef xwidth
#undef priority
#undef material_string
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

/* User declarations for component 'diffraction_detector_15_exit_volume' [730]. */
#define mccompcurname  diffraction_detector_15_exit_volume
#define mccompcurtype  Union_box
#define mccompcurindex 730
#define loop_index mccdiffraction_detector_15_exit_volume_loop_index
#define this_box_volume mccdiffraction_detector_15_exit_volume_this_box_volume
#define global_geometry_element mccdiffraction_detector_15_exit_volume_global_geometry_element
#define this_box_storage mccdiffraction_detector_15_exit_volume_this_box_storage
#define material_string mccdiffraction_detector_15_exit_volume_material_string
#define priority mccdiffraction_detector_15_exit_volume_priority
#define xwidth mccdiffraction_detector_15_exit_volume_xwidth
#define yheight mccdiffraction_detector_15_exit_volume_yheight
#define zdepth mccdiffraction_detector_15_exit_volume_zdepth
#define xwidth2 mccdiffraction_detector_15_exit_volume_xwidth2
#define yheight2 mccdiffraction_detector_15_exit_volume_yheight2
#define visualize mccdiffraction_detector_15_exit_volume_visualize
#define target_index mccdiffraction_detector_15_exit_volume_target_index
#define target_x mccdiffraction_detector_15_exit_volume_target_x
#define target_y mccdiffraction_detector_15_exit_volume_target_y
#define target_z mccdiffraction_detector_15_exit_volume_target_z
#define focus_aw mccdiffraction_detector_15_exit_volume_focus_aw
#define focus_ah mccdiffraction_detector_15_exit_volume_focus_ah
#define focus_xw mccdiffraction_detector_15_exit_volume_focus_xw
#define focus_xh mccdiffraction_detector_15_exit_volume_focus_xh
#define focus_r mccdiffraction_detector_15_exit_volume_focus_r
#define p_interact mccdiffraction_detector_15_exit_volume_p_interact
#define mask_string mccdiffraction_detector_15_exit_volume_mask_string
#define mask_setting mccdiffraction_detector_15_exit_volume_mask_setting
#define number_of_activations mccdiffraction_detector_15_exit_volume_number_of_activations
#line 204 "Union_box.comp"
// Needed for transport to the main component
struct global_geometry_element_struct global_geometry_element;

#ifndef ANY_GEOMETRY_DETECTOR_DECLARE
    #define ANY_GEOMETRY_DETECTOR_DECLARE dummy
	//struct pointer_to_global_geometry_list global_geometry_list = {0,NULL};
#endif

int loop_index,found_geometries;

double x_component;
double y_component;
double z_component;

struct Volume_struct this_box_volume;
struct box_storage this_box_storage;

#line 74408 "MACS_sample_kidney_box.c"
#undef number_of_activations
#undef mask_setting
#undef mask_string
#undef p_interact
#undef focus_r
#undef focus_xh
#undef focus_xw
#undef focus_ah
#undef focus_aw
#undef target_z
#undef target_y
#undef target_x
#undef target_index
#undef visualize
#undef yheight2
#undef xwidth2
#undef zdepth
#undef yheight
#undef xwidth
#undef priority
#undef material_string
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

/* User declarations for component 'spec_detector_15_exit_volume' [731]. */
#define mccompcurname  spec_detector_15_exit_volume
#define mccompcurtype  Union_box
#define mccompcurindex 731
#define loop_index mccspec_detector_15_exit_volume_loop_index
#define this_box_volume mccspec_detector_15_exit_volume_this_box_volume
#define global_geometry_element mccspec_detector_15_exit_volume_global_geometry_element
#define this_box_storage mccspec_detector_15_exit_volume_this_box_storage
#define material_string mccspec_detector_15_exit_volume_material_string
#define priority mccspec_detector_15_exit_volume_priority
#define xwidth mccspec_detector_15_exit_volume_xwidth
#define yheight mccspec_detector_15_exit_volume_yheight
#define zdepth mccspec_detector_15_exit_volume_zdepth
#define xwidth2 mccspec_detector_15_exit_volume_xwidth2
#define yheight2 mccspec_detector_15_exit_volume_yheight2
#define visualize mccspec_detector_15_exit_volume_visualize
#define target_index mccspec_detector_15_exit_volume_target_index
#define target_x mccspec_detector_15_exit_volume_target_x
#define target_y mccspec_detector_15_exit_volume_target_y
#define target_z mccspec_detector_15_exit_volume_target_z
#define focus_aw mccspec_detector_15_exit_volume_focus_aw
#define focus_ah mccspec_detector_15_exit_volume_focus_ah
#define focus_xw mccspec_detector_15_exit_volume_focus_xw
#define focus_xh mccspec_detector_15_exit_volume_focus_xh
#define focus_r mccspec_detector_15_exit_volume_focus_r
#define p_interact mccspec_detector_15_exit_volume_p_interact
#define mask_string mccspec_detector_15_exit_volume_mask_string
#define mask_setting mccspec_detector_15_exit_volume_mask_setting
#define number_of_activations mccspec_detector_15_exit_volume_number_of_activations
#line 204 "Union_box.comp"
// Needed for transport to the main component
struct global_geometry_element_struct global_geometry_element;

#ifndef ANY_GEOMETRY_DETECTOR_DECLARE
    #define ANY_GEOMETRY_DETECTOR_DECLARE dummy
	//struct pointer_to_global_geometry_list global_geometry_list = {0,NULL};
#endif

int loop_index,found_geometries;

double x_component;
double y_component;
double z_component;

struct Volume_struct this_box_volume;
struct box_storage this_box_storage;

#line 74485 "MACS_sample_kidney_box.c"
#undef number_of_activations
#undef mask_setting
#undef mask_string
#undef p_interact
#undef focus_r
#undef focus_xh
#undef focus_xw
#undef focus_ah
#undef focus_aw
#undef target_z
#undef target_y
#undef target_x
#undef target_index
#undef visualize
#undef yheight2
#undef xwidth2
#undef zdepth
#undef yheight
#undef xwidth
#undef priority
#undef material_string
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

/* User declarations for component 'channel_16_cave1_box1' [732]. */
#define mccompcurname  channel_16_cave1_box1
#define mccompcurtype  Union_box
#define mccompcurindex 732
#define loop_index mccchannel_16_cave1_box1_loop_index
#define this_box_volume mccchannel_16_cave1_box1_this_box_volume
#define global_geometry_element mccchannel_16_cave1_box1_global_geometry_element
#define this_box_storage mccchannel_16_cave1_box1_this_box_storage
#define material_string mccchannel_16_cave1_box1_material_string
#define priority mccchannel_16_cave1_box1_priority
#define xwidth mccchannel_16_cave1_box1_xwidth
#define yheight mccchannel_16_cave1_box1_yheight
#define zdepth mccchannel_16_cave1_box1_zdepth
#define xwidth2 mccchannel_16_cave1_box1_xwidth2
#define yheight2 mccchannel_16_cave1_box1_yheight2
#define visualize mccchannel_16_cave1_box1_visualize
#define target_index mccchannel_16_cave1_box1_target_index
#define target_x mccchannel_16_cave1_box1_target_x
#define target_y mccchannel_16_cave1_box1_target_y
#define target_z mccchannel_16_cave1_box1_target_z
#define focus_aw mccchannel_16_cave1_box1_focus_aw
#define focus_ah mccchannel_16_cave1_box1_focus_ah
#define focus_xw mccchannel_16_cave1_box1_focus_xw
#define focus_xh mccchannel_16_cave1_box1_focus_xh
#define focus_r mccchannel_16_cave1_box1_focus_r
#define p_interact mccchannel_16_cave1_box1_p_interact
#define mask_string mccchannel_16_cave1_box1_mask_string
#define mask_setting mccchannel_16_cave1_box1_mask_setting
#define number_of_activations mccchannel_16_cave1_box1_number_of_activations
#line 204 "Union_box.comp"
// Needed for transport to the main component
struct global_geometry_element_struct global_geometry_element;

#ifndef ANY_GEOMETRY_DETECTOR_DECLARE
    #define ANY_GEOMETRY_DETECTOR_DECLARE dummy
	//struct pointer_to_global_geometry_list global_geometry_list = {0,NULL};
#endif

int loop_index,found_geometries;

double x_component;
double y_component;
double z_component;

struct Volume_struct this_box_volume;
struct box_storage this_box_storage;

#line 74562 "MACS_sample_kidney_box.c"
#undef number_of_activations
#undef mask_setting
#undef mask_string
#undef p_interact
#undef focus_r
#undef focus_xh
#undef focus_xw
#undef focus_ah
#undef focus_aw
#undef target_z
#undef target_y
#undef target_x
#undef target_index
#undef visualize
#undef yheight2
#undef xwidth2
#undef zdepth
#undef yheight
#undef xwidth
#undef priority
#undef material_string
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

/* User declarations for component 'channel_16_cave1_box2' [733]. */
#define mccompcurname  channel_16_cave1_box2
#define mccompcurtype  Union_box
#define mccompcurindex 733
#define loop_index mccchannel_16_cave1_box2_loop_index
#define this_box_volume mccchannel_16_cave1_box2_this_box_volume
#define global_geometry_element mccchannel_16_cave1_box2_global_geometry_element
#define this_box_storage mccchannel_16_cave1_box2_this_box_storage
#define material_string mccchannel_16_cave1_box2_material_string
#define priority mccchannel_16_cave1_box2_priority
#define xwidth mccchannel_16_cave1_box2_xwidth
#define yheight mccchannel_16_cave1_box2_yheight
#define zdepth mccchannel_16_cave1_box2_zdepth
#define xwidth2 mccchannel_16_cave1_box2_xwidth2
#define yheight2 mccchannel_16_cave1_box2_yheight2
#define visualize mccchannel_16_cave1_box2_visualize
#define target_index mccchannel_16_cave1_box2_target_index
#define target_x mccchannel_16_cave1_box2_target_x
#define target_y mccchannel_16_cave1_box2_target_y
#define target_z mccchannel_16_cave1_box2_target_z
#define focus_aw mccchannel_16_cave1_box2_focus_aw
#define focus_ah mccchannel_16_cave1_box2_focus_ah
#define focus_xw mccchannel_16_cave1_box2_focus_xw
#define focus_xh mccchannel_16_cave1_box2_focus_xh
#define focus_r mccchannel_16_cave1_box2_focus_r
#define p_interact mccchannel_16_cave1_box2_p_interact
#define mask_string mccchannel_16_cave1_box2_mask_string
#define mask_setting mccchannel_16_cave1_box2_mask_setting
#define number_of_activations mccchannel_16_cave1_box2_number_of_activations
#line 204 "Union_box.comp"
// Needed for transport to the main component
struct global_geometry_element_struct global_geometry_element;

#ifndef ANY_GEOMETRY_DETECTOR_DECLARE
    #define ANY_GEOMETRY_DETECTOR_DECLARE dummy
	//struct pointer_to_global_geometry_list global_geometry_list = {0,NULL};
#endif

int loop_index,found_geometries;

double x_component;
double y_component;
double z_component;

struct Volume_struct this_box_volume;
struct box_storage this_box_storage;

#line 74639 "MACS_sample_kidney_box.c"
#undef number_of_activations
#undef mask_setting
#undef mask_string
#undef p_interact
#undef focus_r
#undef focus_xh
#undef focus_xw
#undef focus_ah
#undef focus_aw
#undef target_z
#undef target_y
#undef target_x
#undef target_index
#undef visualize
#undef yheight2
#undef xwidth2
#undef zdepth
#undef yheight
#undef xwidth
#undef priority
#undef material_string
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

/* User declarations for component 'channel_16_cave1_box3' [734]. */
#define mccompcurname  channel_16_cave1_box3
#define mccompcurtype  Union_box
#define mccompcurindex 734
#define loop_index mccchannel_16_cave1_box3_loop_index
#define this_box_volume mccchannel_16_cave1_box3_this_box_volume
#define global_geometry_element mccchannel_16_cave1_box3_global_geometry_element
#define this_box_storage mccchannel_16_cave1_box3_this_box_storage
#define material_string mccchannel_16_cave1_box3_material_string
#define priority mccchannel_16_cave1_box3_priority
#define xwidth mccchannel_16_cave1_box3_xwidth
#define yheight mccchannel_16_cave1_box3_yheight
#define zdepth mccchannel_16_cave1_box3_zdepth
#define xwidth2 mccchannel_16_cave1_box3_xwidth2
#define yheight2 mccchannel_16_cave1_box3_yheight2
#define visualize mccchannel_16_cave1_box3_visualize
#define target_index mccchannel_16_cave1_box3_target_index
#define target_x mccchannel_16_cave1_box3_target_x
#define target_y mccchannel_16_cave1_box3_target_y
#define target_z mccchannel_16_cave1_box3_target_z
#define focus_aw mccchannel_16_cave1_box3_focus_aw
#define focus_ah mccchannel_16_cave1_box3_focus_ah
#define focus_xw mccchannel_16_cave1_box3_focus_xw
#define focus_xh mccchannel_16_cave1_box3_focus_xh
#define focus_r mccchannel_16_cave1_box3_focus_r
#define p_interact mccchannel_16_cave1_box3_p_interact
#define mask_string mccchannel_16_cave1_box3_mask_string
#define mask_setting mccchannel_16_cave1_box3_mask_setting
#define number_of_activations mccchannel_16_cave1_box3_number_of_activations
#line 204 "Union_box.comp"
// Needed for transport to the main component
struct global_geometry_element_struct global_geometry_element;

#ifndef ANY_GEOMETRY_DETECTOR_DECLARE
    #define ANY_GEOMETRY_DETECTOR_DECLARE dummy
	//struct pointer_to_global_geometry_list global_geometry_list = {0,NULL};
#endif

int loop_index,found_geometries;

double x_component;
double y_component;
double z_component;

struct Volume_struct this_box_volume;
struct box_storage this_box_storage;

#line 74716 "MACS_sample_kidney_box.c"
#undef number_of_activations
#undef mask_setting
#undef mask_string
#undef p_interact
#undef focus_r
#undef focus_xh
#undef focus_xw
#undef focus_ah
#undef focus_aw
#undef target_z
#undef target_y
#undef target_x
#undef target_index
#undef visualize
#undef yheight2
#undef xwidth2
#undef zdepth
#undef yheight
#undef xwidth
#undef priority
#undef material_string
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

/* User declarations for component 'channel_16_cave1_cyl1' [735]. */
#define mccompcurname  channel_16_cave1_cyl1
#define mccompcurtype  Union_cylinder
#define mccompcurindex 735
#define loop_index mccchannel_16_cave1_cyl1_loop_index
#define this_cylinder_volume mccchannel_16_cave1_cyl1_this_cylinder_volume
#define global_geometry_element mccchannel_16_cave1_cyl1_global_geometry_element
#define this_cylinder_storage mccchannel_16_cave1_cyl1_this_cylinder_storage
#define material_string mccchannel_16_cave1_cyl1_material_string
#define priority mccchannel_16_cave1_cyl1_priority
#define radius mccchannel_16_cave1_cyl1_radius
#define yheight mccchannel_16_cave1_cyl1_yheight
#define visualize mccchannel_16_cave1_cyl1_visualize
#define target_index mccchannel_16_cave1_cyl1_target_index
#define target_x mccchannel_16_cave1_cyl1_target_x
#define target_y mccchannel_16_cave1_cyl1_target_y
#define target_z mccchannel_16_cave1_cyl1_target_z
#define focus_aw mccchannel_16_cave1_cyl1_focus_aw
#define focus_ah mccchannel_16_cave1_cyl1_focus_ah
#define focus_xw mccchannel_16_cave1_cyl1_focus_xw
#define focus_xh mccchannel_16_cave1_cyl1_focus_xh
#define focus_r mccchannel_16_cave1_cyl1_focus_r
#define p_interact mccchannel_16_cave1_cyl1_p_interact
#define mask_string mccchannel_16_cave1_cyl1_mask_string
#define mask_setting mccchannel_16_cave1_cyl1_mask_setting
#define number_of_activations mccchannel_16_cave1_cyl1_number_of_activations
#line 167 "Union_cylinder.comp"
// Needed for transport to the main component
struct global_geometry_element_struct global_geometry_element;

#ifndef ANY_GEOMETRY_DETECTOR_DECLARE
    #define ANY_GEOMETRY_DETECTOR_DECLARE dummy
	//struct pointer_to_global_geometry_list global_geometry_list = {0,NULL};
#endif

int dummy;
int loop_index,found_geometries;
int loop_2_index;
int material_index;

struct Volume_struct this_cylinder_volume;
struct cylinder_storage this_cylinder_storage;
#line 74788 "MACS_sample_kidney_box.c"
#undef number_of_activations
#undef mask_setting
#undef mask_string
#undef p_interact
#undef focus_r
#undef focus_xh
#undef focus_xw
#undef focus_ah
#undef focus_aw
#undef target_z
#undef target_y
#undef target_x
#undef target_index
#undef visualize
#undef yheight
#undef radius
#undef priority
#undef material_string
#undef this_cylinder_storage
#undef global_geometry_element
#undef this_cylinder_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

/* User declarations for component 'channel_16_analyzer_1_center' [736]. */
#define mccompcurname  channel_16_analyzer_1_center
#define mccompcurtype  Arm
#define mccompcurindex 736
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

/* User declarations for component 'channel_16_analyzer_1_rotated' [737]. */
#define mccompcurname  channel_16_analyzer_1_rotated
#define mccompcurtype  Arm
#define mccompcurindex 737
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

/* User declarations for component 'channel_16_analyzer_1_array_crystal_array_0' [738]. */
#define mccompcurname  channel_16_analyzer_1_array_crystal_array_0
#define mccompcurtype  Union_box
#define mccompcurindex 738
#define loop_index mccchannel_16_analyzer_1_array_crystal_array_0_loop_index
#define this_box_volume mccchannel_16_analyzer_1_array_crystal_array_0_this_box_volume
#define global_geometry_element mccchannel_16_analyzer_1_array_crystal_array_0_global_geometry_element
#define this_box_storage mccchannel_16_analyzer_1_array_crystal_array_0_this_box_storage
#define material_string mccchannel_16_analyzer_1_array_crystal_array_0_material_string
#define priority mccchannel_16_analyzer_1_array_crystal_array_0_priority
#define xwidth mccchannel_16_analyzer_1_array_crystal_array_0_xwidth
#define yheight mccchannel_16_analyzer_1_array_crystal_array_0_yheight
#define zdepth mccchannel_16_analyzer_1_array_crystal_array_0_zdepth
#define xwidth2 mccchannel_16_analyzer_1_array_crystal_array_0_xwidth2
#define yheight2 mccchannel_16_analyzer_1_array_crystal_array_0_yheight2
#define visualize mccchannel_16_analyzer_1_array_crystal_array_0_visualize
#define target_index mccchannel_16_analyzer_1_array_crystal_array_0_target_index
#define target_x mccchannel_16_analyzer_1_array_crystal_array_0_target_x
#define target_y mccchannel_16_analyzer_1_array_crystal_array_0_target_y
#define target_z mccchannel_16_analyzer_1_array_crystal_array_0_target_z
#define focus_aw mccchannel_16_analyzer_1_array_crystal_array_0_focus_aw
#define focus_ah mccchannel_16_analyzer_1_array_crystal_array_0_focus_ah
#define focus_xw mccchannel_16_analyzer_1_array_crystal_array_0_focus_xw
#define focus_xh mccchannel_16_analyzer_1_array_crystal_array_0_focus_xh
#define focus_r mccchannel_16_analyzer_1_array_crystal_array_0_focus_r
#define p_interact mccchannel_16_analyzer_1_array_crystal_array_0_p_interact
#define mask_string mccchannel_16_analyzer_1_array_crystal_array_0_mask_string
#define mask_setting mccchannel_16_analyzer_1_array_crystal_array_0_mask_setting
#define number_of_activations mccchannel_16_analyzer_1_array_crystal_array_0_number_of_activations
#line 204 "Union_box.comp"
// Needed for transport to the main component
struct global_geometry_element_struct global_geometry_element;

#ifndef ANY_GEOMETRY_DETECTOR_DECLARE
    #define ANY_GEOMETRY_DETECTOR_DECLARE dummy
	//struct pointer_to_global_geometry_list global_geometry_list = {0,NULL};
#endif

int loop_index,found_geometries;

double x_component;
double y_component;
double z_component;

struct Volume_struct this_box_volume;
struct box_storage this_box_storage;

#line 74878 "MACS_sample_kidney_box.c"
#undef number_of_activations
#undef mask_setting
#undef mask_string
#undef p_interact
#undef focus_r
#undef focus_xh
#undef focus_xw
#undef focus_ah
#undef focus_aw
#undef target_z
#undef target_y
#undef target_x
#undef target_index
#undef visualize
#undef yheight2
#undef xwidth2
#undef zdepth
#undef yheight
#undef xwidth
#undef priority
#undef material_string
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

/* User declarations for component 'channel_16_analyzer_1_array_crystal_array_1' [739]. */
#define mccompcurname  channel_16_analyzer_1_array_crystal_array_1
#define mccompcurtype  Union_box
#define mccompcurindex 739
#define loop_index mccchannel_16_analyzer_1_array_crystal_array_1_loop_index
#define this_box_volume mccchannel_16_analyzer_1_array_crystal_array_1_this_box_volume
#define global_geometry_element mccchannel_16_analyzer_1_array_crystal_array_1_global_geometry_element
#define this_box_storage mccchannel_16_analyzer_1_array_crystal_array_1_this_box_storage
#define material_string mccchannel_16_analyzer_1_array_crystal_array_1_material_string
#define priority mccchannel_16_analyzer_1_array_crystal_array_1_priority
#define xwidth mccchannel_16_analyzer_1_array_crystal_array_1_xwidth
#define yheight mccchannel_16_analyzer_1_array_crystal_array_1_yheight
#define zdepth mccchannel_16_analyzer_1_array_crystal_array_1_zdepth
#define xwidth2 mccchannel_16_analyzer_1_array_crystal_array_1_xwidth2
#define yheight2 mccchannel_16_analyzer_1_array_crystal_array_1_yheight2
#define visualize mccchannel_16_analyzer_1_array_crystal_array_1_visualize
#define target_index mccchannel_16_analyzer_1_array_crystal_array_1_target_index
#define target_x mccchannel_16_analyzer_1_array_crystal_array_1_target_x
#define target_y mccchannel_16_analyzer_1_array_crystal_array_1_target_y
#define target_z mccchannel_16_analyzer_1_array_crystal_array_1_target_z
#define focus_aw mccchannel_16_analyzer_1_array_crystal_array_1_focus_aw
#define focus_ah mccchannel_16_analyzer_1_array_crystal_array_1_focus_ah
#define focus_xw mccchannel_16_analyzer_1_array_crystal_array_1_focus_xw
#define focus_xh mccchannel_16_analyzer_1_array_crystal_array_1_focus_xh
#define focus_r mccchannel_16_analyzer_1_array_crystal_array_1_focus_r
#define p_interact mccchannel_16_analyzer_1_array_crystal_array_1_p_interact
#define mask_string mccchannel_16_analyzer_1_array_crystal_array_1_mask_string
#define mask_setting mccchannel_16_analyzer_1_array_crystal_array_1_mask_setting
#define number_of_activations mccchannel_16_analyzer_1_array_crystal_array_1_number_of_activations
#line 204 "Union_box.comp"
// Needed for transport to the main component
struct global_geometry_element_struct global_geometry_element;

#ifndef ANY_GEOMETRY_DETECTOR_DECLARE
    #define ANY_GEOMETRY_DETECTOR_DECLARE dummy
	//struct pointer_to_global_geometry_list global_geometry_list = {0,NULL};
#endif

int loop_index,found_geometries;

double x_component;
double y_component;
double z_component;

struct Volume_struct this_box_volume;
struct box_storage this_box_storage;

#line 74955 "MACS_sample_kidney_box.c"
#undef number_of_activations
#undef mask_setting
#undef mask_string
#undef p_interact
#undef focus_r
#undef focus_xh
#undef focus_xw
#undef focus_ah
#undef focus_aw
#undef target_z
#undef target_y
#undef target_x
#undef target_index
#undef visualize
#undef yheight2
#undef xwidth2
#undef zdepth
#undef yheight
#undef xwidth
#undef priority
#undef material_string
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

/* User declarations for component 'channel_16_analyzer_1_array_crystal_array_2' [740]. */
#define mccompcurname  channel_16_analyzer_1_array_crystal_array_2
#define mccompcurtype  Union_box
#define mccompcurindex 740
#define loop_index mccchannel_16_analyzer_1_array_crystal_array_2_loop_index
#define this_box_volume mccchannel_16_analyzer_1_array_crystal_array_2_this_box_volume
#define global_geometry_element mccchannel_16_analyzer_1_array_crystal_array_2_global_geometry_element
#define this_box_storage mccchannel_16_analyzer_1_array_crystal_array_2_this_box_storage
#define material_string mccchannel_16_analyzer_1_array_crystal_array_2_material_string
#define priority mccchannel_16_analyzer_1_array_crystal_array_2_priority
#define xwidth mccchannel_16_analyzer_1_array_crystal_array_2_xwidth
#define yheight mccchannel_16_analyzer_1_array_crystal_array_2_yheight
#define zdepth mccchannel_16_analyzer_1_array_crystal_array_2_zdepth
#define xwidth2 mccchannel_16_analyzer_1_array_crystal_array_2_xwidth2
#define yheight2 mccchannel_16_analyzer_1_array_crystal_array_2_yheight2
#define visualize mccchannel_16_analyzer_1_array_crystal_array_2_visualize
#define target_index mccchannel_16_analyzer_1_array_crystal_array_2_target_index
#define target_x mccchannel_16_analyzer_1_array_crystal_array_2_target_x
#define target_y mccchannel_16_analyzer_1_array_crystal_array_2_target_y
#define target_z mccchannel_16_analyzer_1_array_crystal_array_2_target_z
#define focus_aw mccchannel_16_analyzer_1_array_crystal_array_2_focus_aw
#define focus_ah mccchannel_16_analyzer_1_array_crystal_array_2_focus_ah
#define focus_xw mccchannel_16_analyzer_1_array_crystal_array_2_focus_xw
#define focus_xh mccchannel_16_analyzer_1_array_crystal_array_2_focus_xh
#define focus_r mccchannel_16_analyzer_1_array_crystal_array_2_focus_r
#define p_interact mccchannel_16_analyzer_1_array_crystal_array_2_p_interact
#define mask_string mccchannel_16_analyzer_1_array_crystal_array_2_mask_string
#define mask_setting mccchannel_16_analyzer_1_array_crystal_array_2_mask_setting
#define number_of_activations mccchannel_16_analyzer_1_array_crystal_array_2_number_of_activations
#line 204 "Union_box.comp"
// Needed for transport to the main component
struct global_geometry_element_struct global_geometry_element;

#ifndef ANY_GEOMETRY_DETECTOR_DECLARE
    #define ANY_GEOMETRY_DETECTOR_DECLARE dummy
	//struct pointer_to_global_geometry_list global_geometry_list = {0,NULL};
#endif

int loop_index,found_geometries;

double x_component;
double y_component;
double z_component;

struct Volume_struct this_box_volume;
struct box_storage this_box_storage;

#line 75032 "MACS_sample_kidney_box.c"
#undef number_of_activations
#undef mask_setting
#undef mask_string
#undef p_interact
#undef focus_r
#undef focus_xh
#undef focus_xw
#undef focus_ah
#undef focus_aw
#undef target_z
#undef target_y
#undef target_x
#undef target_index
#undef visualize
#undef yheight2
#undef xwidth2
#undef zdepth
#undef yheight
#undef xwidth
#undef priority
#undef material_string
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

/* User declarations for component 'channel_16_analyzer_1_array_crystal_array_3' [741]. */
#define mccompcurname  channel_16_analyzer_1_array_crystal_array_3
#define mccompcurtype  Union_box
#define mccompcurindex 741
#define loop_index mccchannel_16_analyzer_1_array_crystal_array_3_loop_index
#define this_box_volume mccchannel_16_analyzer_1_array_crystal_array_3_this_box_volume
#define global_geometry_element mccchannel_16_analyzer_1_array_crystal_array_3_global_geometry_element
#define this_box_storage mccchannel_16_analyzer_1_array_crystal_array_3_this_box_storage
#define material_string mccchannel_16_analyzer_1_array_crystal_array_3_material_string
#define priority mccchannel_16_analyzer_1_array_crystal_array_3_priority
#define xwidth mccchannel_16_analyzer_1_array_crystal_array_3_xwidth
#define yheight mccchannel_16_analyzer_1_array_crystal_array_3_yheight
#define zdepth mccchannel_16_analyzer_1_array_crystal_array_3_zdepth
#define xwidth2 mccchannel_16_analyzer_1_array_crystal_array_3_xwidth2
#define yheight2 mccchannel_16_analyzer_1_array_crystal_array_3_yheight2
#define visualize mccchannel_16_analyzer_1_array_crystal_array_3_visualize
#define target_index mccchannel_16_analyzer_1_array_crystal_array_3_target_index
#define target_x mccchannel_16_analyzer_1_array_crystal_array_3_target_x
#define target_y mccchannel_16_analyzer_1_array_crystal_array_3_target_y
#define target_z mccchannel_16_analyzer_1_array_crystal_array_3_target_z
#define focus_aw mccchannel_16_analyzer_1_array_crystal_array_3_focus_aw
#define focus_ah mccchannel_16_analyzer_1_array_crystal_array_3_focus_ah
#define focus_xw mccchannel_16_analyzer_1_array_crystal_array_3_focus_xw
#define focus_xh mccchannel_16_analyzer_1_array_crystal_array_3_focus_xh
#define focus_r mccchannel_16_analyzer_1_array_crystal_array_3_focus_r
#define p_interact mccchannel_16_analyzer_1_array_crystal_array_3_p_interact
#define mask_string mccchannel_16_analyzer_1_array_crystal_array_3_mask_string
#define mask_setting mccchannel_16_analyzer_1_array_crystal_array_3_mask_setting
#define number_of_activations mccchannel_16_analyzer_1_array_crystal_array_3_number_of_activations
#line 204 "Union_box.comp"
// Needed for transport to the main component
struct global_geometry_element_struct global_geometry_element;

#ifndef ANY_GEOMETRY_DETECTOR_DECLARE
    #define ANY_GEOMETRY_DETECTOR_DECLARE dummy
	//struct pointer_to_global_geometry_list global_geometry_list = {0,NULL};
#endif

int loop_index,found_geometries;

double x_component;
double y_component;
double z_component;

struct Volume_struct this_box_volume;
struct box_storage this_box_storage;

#line 75109 "MACS_sample_kidney_box.c"
#undef number_of_activations
#undef mask_setting
#undef mask_string
#undef p_interact
#undef focus_r
#undef focus_xh
#undef focus_xw
#undef focus_ah
#undef focus_aw
#undef target_z
#undef target_y
#undef target_x
#undef target_index
#undef visualize
#undef yheight2
#undef xwidth2
#undef zdepth
#undef yheight
#undef xwidth
#undef priority
#undef material_string
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

/* User declarations for component 'channel_16_analyzer_1_array_crystal_array_4' [742]. */
#define mccompcurname  channel_16_analyzer_1_array_crystal_array_4
#define mccompcurtype  Union_box
#define mccompcurindex 742
#define loop_index mccchannel_16_analyzer_1_array_crystal_array_4_loop_index
#define this_box_volume mccchannel_16_analyzer_1_array_crystal_array_4_this_box_volume
#define global_geometry_element mccchannel_16_analyzer_1_array_crystal_array_4_global_geometry_element
#define this_box_storage mccchannel_16_analyzer_1_array_crystal_array_4_this_box_storage
#define material_string mccchannel_16_analyzer_1_array_crystal_array_4_material_string
#define priority mccchannel_16_analyzer_1_array_crystal_array_4_priority
#define xwidth mccchannel_16_analyzer_1_array_crystal_array_4_xwidth
#define yheight mccchannel_16_analyzer_1_array_crystal_array_4_yheight
#define zdepth mccchannel_16_analyzer_1_array_crystal_array_4_zdepth
#define xwidth2 mccchannel_16_analyzer_1_array_crystal_array_4_xwidth2
#define yheight2 mccchannel_16_analyzer_1_array_crystal_array_4_yheight2
#define visualize mccchannel_16_analyzer_1_array_crystal_array_4_visualize
#define target_index mccchannel_16_analyzer_1_array_crystal_array_4_target_index
#define target_x mccchannel_16_analyzer_1_array_crystal_array_4_target_x
#define target_y mccchannel_16_analyzer_1_array_crystal_array_4_target_y
#define target_z mccchannel_16_analyzer_1_array_crystal_array_4_target_z
#define focus_aw mccchannel_16_analyzer_1_array_crystal_array_4_focus_aw
#define focus_ah mccchannel_16_analyzer_1_array_crystal_array_4_focus_ah
#define focus_xw mccchannel_16_analyzer_1_array_crystal_array_4_focus_xw
#define focus_xh mccchannel_16_analyzer_1_array_crystal_array_4_focus_xh
#define focus_r mccchannel_16_analyzer_1_array_crystal_array_4_focus_r
#define p_interact mccchannel_16_analyzer_1_array_crystal_array_4_p_interact
#define mask_string mccchannel_16_analyzer_1_array_crystal_array_4_mask_string
#define mask_setting mccchannel_16_analyzer_1_array_crystal_array_4_mask_setting
#define number_of_activations mccchannel_16_analyzer_1_array_crystal_array_4_number_of_activations
#line 204 "Union_box.comp"
// Needed for transport to the main component
struct global_geometry_element_struct global_geometry_element;

#ifndef ANY_GEOMETRY_DETECTOR_DECLARE
    #define ANY_GEOMETRY_DETECTOR_DECLARE dummy
	//struct pointer_to_global_geometry_list global_geometry_list = {0,NULL};
#endif

int loop_index,found_geometries;

double x_component;
double y_component;
double z_component;

struct Volume_struct this_box_volume;
struct box_storage this_box_storage;

#line 75186 "MACS_sample_kidney_box.c"
#undef number_of_activations
#undef mask_setting
#undef mask_string
#undef p_interact
#undef focus_r
#undef focus_xh
#undef focus_xw
#undef focus_ah
#undef focus_aw
#undef target_z
#undef target_y
#undef target_x
#undef target_index
#undef visualize
#undef yheight2
#undef xwidth2
#undef zdepth
#undef yheight
#undef xwidth
#undef priority
#undef material_string
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

/* User declarations for component 'channel_16_analyzer_1_array_crystal_array_5' [743]. */
#define mccompcurname  channel_16_analyzer_1_array_crystal_array_5
#define mccompcurtype  Union_box
#define mccompcurindex 743
#define loop_index mccchannel_16_analyzer_1_array_crystal_array_5_loop_index
#define this_box_volume mccchannel_16_analyzer_1_array_crystal_array_5_this_box_volume
#define global_geometry_element mccchannel_16_analyzer_1_array_crystal_array_5_global_geometry_element
#define this_box_storage mccchannel_16_analyzer_1_array_crystal_array_5_this_box_storage
#define material_string mccchannel_16_analyzer_1_array_crystal_array_5_material_string
#define priority mccchannel_16_analyzer_1_array_crystal_array_5_priority
#define xwidth mccchannel_16_analyzer_1_array_crystal_array_5_xwidth
#define yheight mccchannel_16_analyzer_1_array_crystal_array_5_yheight
#define zdepth mccchannel_16_analyzer_1_array_crystal_array_5_zdepth
#define xwidth2 mccchannel_16_analyzer_1_array_crystal_array_5_xwidth2
#define yheight2 mccchannel_16_analyzer_1_array_crystal_array_5_yheight2
#define visualize mccchannel_16_analyzer_1_array_crystal_array_5_visualize
#define target_index mccchannel_16_analyzer_1_array_crystal_array_5_target_index
#define target_x mccchannel_16_analyzer_1_array_crystal_array_5_target_x
#define target_y mccchannel_16_analyzer_1_array_crystal_array_5_target_y
#define target_z mccchannel_16_analyzer_1_array_crystal_array_5_target_z
#define focus_aw mccchannel_16_analyzer_1_array_crystal_array_5_focus_aw
#define focus_ah mccchannel_16_analyzer_1_array_crystal_array_5_focus_ah
#define focus_xw mccchannel_16_analyzer_1_array_crystal_array_5_focus_xw
#define focus_xh mccchannel_16_analyzer_1_array_crystal_array_5_focus_xh
#define focus_r mccchannel_16_analyzer_1_array_crystal_array_5_focus_r
#define p_interact mccchannel_16_analyzer_1_array_crystal_array_5_p_interact
#define mask_string mccchannel_16_analyzer_1_array_crystal_array_5_mask_string
#define mask_setting mccchannel_16_analyzer_1_array_crystal_array_5_mask_setting
#define number_of_activations mccchannel_16_analyzer_1_array_crystal_array_5_number_of_activations
#line 204 "Union_box.comp"
// Needed for transport to the main component
struct global_geometry_element_struct global_geometry_element;

#ifndef ANY_GEOMETRY_DETECTOR_DECLARE
    #define ANY_GEOMETRY_DETECTOR_DECLARE dummy
	//struct pointer_to_global_geometry_list global_geometry_list = {0,NULL};
#endif

int loop_index,found_geometries;

double x_component;
double y_component;
double z_component;

struct Volume_struct this_box_volume;
struct box_storage this_box_storage;

#line 75263 "MACS_sample_kidney_box.c"
#undef number_of_activations
#undef mask_setting
#undef mask_string
#undef p_interact
#undef focus_r
#undef focus_xh
#undef focus_xw
#undef focus_ah
#undef focus_aw
#undef target_z
#undef target_y
#undef target_x
#undef target_index
#undef visualize
#undef yheight2
#undef xwidth2
#undef zdepth
#undef yheight
#undef xwidth
#undef priority
#undef material_string
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

/* User declarations for component 'channel_16_analyzer_1_array_crystal_array_6' [744]. */
#define mccompcurname  channel_16_analyzer_1_array_crystal_array_6
#define mccompcurtype  Union_box
#define mccompcurindex 744
#define loop_index mccchannel_16_analyzer_1_array_crystal_array_6_loop_index
#define this_box_volume mccchannel_16_analyzer_1_array_crystal_array_6_this_box_volume
#define global_geometry_element mccchannel_16_analyzer_1_array_crystal_array_6_global_geometry_element
#define this_box_storage mccchannel_16_analyzer_1_array_crystal_array_6_this_box_storage
#define material_string mccchannel_16_analyzer_1_array_crystal_array_6_material_string
#define priority mccchannel_16_analyzer_1_array_crystal_array_6_priority
#define xwidth mccchannel_16_analyzer_1_array_crystal_array_6_xwidth
#define yheight mccchannel_16_analyzer_1_array_crystal_array_6_yheight
#define zdepth mccchannel_16_analyzer_1_array_crystal_array_6_zdepth
#define xwidth2 mccchannel_16_analyzer_1_array_crystal_array_6_xwidth2
#define yheight2 mccchannel_16_analyzer_1_array_crystal_array_6_yheight2
#define visualize mccchannel_16_analyzer_1_array_crystal_array_6_visualize
#define target_index mccchannel_16_analyzer_1_array_crystal_array_6_target_index
#define target_x mccchannel_16_analyzer_1_array_crystal_array_6_target_x
#define target_y mccchannel_16_analyzer_1_array_crystal_array_6_target_y
#define target_z mccchannel_16_analyzer_1_array_crystal_array_6_target_z
#define focus_aw mccchannel_16_analyzer_1_array_crystal_array_6_focus_aw
#define focus_ah mccchannel_16_analyzer_1_array_crystal_array_6_focus_ah
#define focus_xw mccchannel_16_analyzer_1_array_crystal_array_6_focus_xw
#define focus_xh mccchannel_16_analyzer_1_array_crystal_array_6_focus_xh
#define focus_r mccchannel_16_analyzer_1_array_crystal_array_6_focus_r
#define p_interact mccchannel_16_analyzer_1_array_crystal_array_6_p_interact
#define mask_string mccchannel_16_analyzer_1_array_crystal_array_6_mask_string
#define mask_setting mccchannel_16_analyzer_1_array_crystal_array_6_mask_setting
#define number_of_activations mccchannel_16_analyzer_1_array_crystal_array_6_number_of_activations
#line 204 "Union_box.comp"
// Needed for transport to the main component
struct global_geometry_element_struct global_geometry_element;

#ifndef ANY_GEOMETRY_DETECTOR_DECLARE
    #define ANY_GEOMETRY_DETECTOR_DECLARE dummy
	//struct pointer_to_global_geometry_list global_geometry_list = {0,NULL};
#endif

int loop_index,found_geometries;

double x_component;
double y_component;
double z_component;

struct Volume_struct this_box_volume;
struct box_storage this_box_storage;

#line 75340 "MACS_sample_kidney_box.c"
#undef number_of_activations
#undef mask_setting
#undef mask_string
#undef p_interact
#undef focus_r
#undef focus_xh
#undef focus_xw
#undef focus_ah
#undef focus_aw
#undef target_z
#undef target_y
#undef target_x
#undef target_index
#undef visualize
#undef yheight2
#undef xwidth2
#undef zdepth
#undef yheight
#undef xwidth
#undef priority
#undef material_string
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

/* User declarations for component 'channel_16_analyzer_1_array_crystal_array_7' [745]. */
#define mccompcurname  channel_16_analyzer_1_array_crystal_array_7
#define mccompcurtype  Union_box
#define mccompcurindex 745
#define loop_index mccchannel_16_analyzer_1_array_crystal_array_7_loop_index
#define this_box_volume mccchannel_16_analyzer_1_array_crystal_array_7_this_box_volume
#define global_geometry_element mccchannel_16_analyzer_1_array_crystal_array_7_global_geometry_element
#define this_box_storage mccchannel_16_analyzer_1_array_crystal_array_7_this_box_storage
#define material_string mccchannel_16_analyzer_1_array_crystal_array_7_material_string
#define priority mccchannel_16_analyzer_1_array_crystal_array_7_priority
#define xwidth mccchannel_16_analyzer_1_array_crystal_array_7_xwidth
#define yheight mccchannel_16_analyzer_1_array_crystal_array_7_yheight
#define zdepth mccchannel_16_analyzer_1_array_crystal_array_7_zdepth
#define xwidth2 mccchannel_16_analyzer_1_array_crystal_array_7_xwidth2
#define yheight2 mccchannel_16_analyzer_1_array_crystal_array_7_yheight2
#define visualize mccchannel_16_analyzer_1_array_crystal_array_7_visualize
#define target_index mccchannel_16_analyzer_1_array_crystal_array_7_target_index
#define target_x mccchannel_16_analyzer_1_array_crystal_array_7_target_x
#define target_y mccchannel_16_analyzer_1_array_crystal_array_7_target_y
#define target_z mccchannel_16_analyzer_1_array_crystal_array_7_target_z
#define focus_aw mccchannel_16_analyzer_1_array_crystal_array_7_focus_aw
#define focus_ah mccchannel_16_analyzer_1_array_crystal_array_7_focus_ah
#define focus_xw mccchannel_16_analyzer_1_array_crystal_array_7_focus_xw
#define focus_xh mccchannel_16_analyzer_1_array_crystal_array_7_focus_xh
#define focus_r mccchannel_16_analyzer_1_array_crystal_array_7_focus_r
#define p_interact mccchannel_16_analyzer_1_array_crystal_array_7_p_interact
#define mask_string mccchannel_16_analyzer_1_array_crystal_array_7_mask_string
#define mask_setting mccchannel_16_analyzer_1_array_crystal_array_7_mask_setting
#define number_of_activations mccchannel_16_analyzer_1_array_crystal_array_7_number_of_activations
#line 204 "Union_box.comp"
// Needed for transport to the main component
struct global_geometry_element_struct global_geometry_element;

#ifndef ANY_GEOMETRY_DETECTOR_DECLARE
    #define ANY_GEOMETRY_DETECTOR_DECLARE dummy
	//struct pointer_to_global_geometry_list global_geometry_list = {0,NULL};
#endif

int loop_index,found_geometries;

double x_component;
double y_component;
double z_component;

struct Volume_struct this_box_volume;
struct box_storage this_box_storage;

#line 75417 "MACS_sample_kidney_box.c"
#undef number_of_activations
#undef mask_setting
#undef mask_string
#undef p_interact
#undef focus_r
#undef focus_xh
#undef focus_xw
#undef focus_ah
#undef focus_aw
#undef target_z
#undef target_y
#undef target_x
#undef target_index
#undef visualize
#undef yheight2
#undef xwidth2
#undef zdepth
#undef yheight
#undef xwidth
#undef priority
#undef material_string
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

/* User declarations for component 'channel_16_analyzer_1_array_crystal_array_8' [746]. */
#define mccompcurname  channel_16_analyzer_1_array_crystal_array_8
#define mccompcurtype  Union_box
#define mccompcurindex 746
#define loop_index mccchannel_16_analyzer_1_array_crystal_array_8_loop_index
#define this_box_volume mccchannel_16_analyzer_1_array_crystal_array_8_this_box_volume
#define global_geometry_element mccchannel_16_analyzer_1_array_crystal_array_8_global_geometry_element
#define this_box_storage mccchannel_16_analyzer_1_array_crystal_array_8_this_box_storage
#define material_string mccchannel_16_analyzer_1_array_crystal_array_8_material_string
#define priority mccchannel_16_analyzer_1_array_crystal_array_8_priority
#define xwidth mccchannel_16_analyzer_1_array_crystal_array_8_xwidth
#define yheight mccchannel_16_analyzer_1_array_crystal_array_8_yheight
#define zdepth mccchannel_16_analyzer_1_array_crystal_array_8_zdepth
#define xwidth2 mccchannel_16_analyzer_1_array_crystal_array_8_xwidth2
#define yheight2 mccchannel_16_analyzer_1_array_crystal_array_8_yheight2
#define visualize mccchannel_16_analyzer_1_array_crystal_array_8_visualize
#define target_index mccchannel_16_analyzer_1_array_crystal_array_8_target_index
#define target_x mccchannel_16_analyzer_1_array_crystal_array_8_target_x
#define target_y mccchannel_16_analyzer_1_array_crystal_array_8_target_y
#define target_z mccchannel_16_analyzer_1_array_crystal_array_8_target_z
#define focus_aw mccchannel_16_analyzer_1_array_crystal_array_8_focus_aw
#define focus_ah mccchannel_16_analyzer_1_array_crystal_array_8_focus_ah
#define focus_xw mccchannel_16_analyzer_1_array_crystal_array_8_focus_xw
#define focus_xh mccchannel_16_analyzer_1_array_crystal_array_8_focus_xh
#define focus_r mccchannel_16_analyzer_1_array_crystal_array_8_focus_r
#define p_interact mccchannel_16_analyzer_1_array_crystal_array_8_p_interact
#define mask_string mccchannel_16_analyzer_1_array_crystal_array_8_mask_string
#define mask_setting mccchannel_16_analyzer_1_array_crystal_array_8_mask_setting
#define number_of_activations mccchannel_16_analyzer_1_array_crystal_array_8_number_of_activations
#line 204 "Union_box.comp"
// Needed for transport to the main component
struct global_geometry_element_struct global_geometry_element;

#ifndef ANY_GEOMETRY_DETECTOR_DECLARE
    #define ANY_GEOMETRY_DETECTOR_DECLARE dummy
	//struct pointer_to_global_geometry_list global_geometry_list = {0,NULL};
#endif

int loop_index,found_geometries;

double x_component;
double y_component;
double z_component;

struct Volume_struct this_box_volume;
struct box_storage this_box_storage;

#line 75494 "MACS_sample_kidney_box.c"
#undef number_of_activations
#undef mask_setting
#undef mask_string
#undef p_interact
#undef focus_r
#undef focus_xh
#undef focus_xw
#undef focus_ah
#undef focus_aw
#undef target_z
#undef target_y
#undef target_x
#undef target_index
#undef visualize
#undef yheight2
#undef xwidth2
#undef zdepth
#undef yheight
#undef xwidth
#undef priority
#undef material_string
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

/* User declarations for component 'channel_16_analyzer_2_center' [747]. */
#define mccompcurname  channel_16_analyzer_2_center
#define mccompcurtype  Arm
#define mccompcurindex 747
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

/* User declarations for component 'channel_16_analyzer_2_rotated' [748]. */
#define mccompcurname  channel_16_analyzer_2_rotated
#define mccompcurtype  Arm
#define mccompcurindex 748
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

/* User declarations for component 'channel_16_analyzer_2_array_crystal_array_0' [749]. */
#define mccompcurname  channel_16_analyzer_2_array_crystal_array_0
#define mccompcurtype  Union_box
#define mccompcurindex 749
#define loop_index mccchannel_16_analyzer_2_array_crystal_array_0_loop_index
#define this_box_volume mccchannel_16_analyzer_2_array_crystal_array_0_this_box_volume
#define global_geometry_element mccchannel_16_analyzer_2_array_crystal_array_0_global_geometry_element
#define this_box_storage mccchannel_16_analyzer_2_array_crystal_array_0_this_box_storage
#define material_string mccchannel_16_analyzer_2_array_crystal_array_0_material_string
#define priority mccchannel_16_analyzer_2_array_crystal_array_0_priority
#define xwidth mccchannel_16_analyzer_2_array_crystal_array_0_xwidth
#define yheight mccchannel_16_analyzer_2_array_crystal_array_0_yheight
#define zdepth mccchannel_16_analyzer_2_array_crystal_array_0_zdepth
#define xwidth2 mccchannel_16_analyzer_2_array_crystal_array_0_xwidth2
#define yheight2 mccchannel_16_analyzer_2_array_crystal_array_0_yheight2
#define visualize mccchannel_16_analyzer_2_array_crystal_array_0_visualize
#define target_index mccchannel_16_analyzer_2_array_crystal_array_0_target_index
#define target_x mccchannel_16_analyzer_2_array_crystal_array_0_target_x
#define target_y mccchannel_16_analyzer_2_array_crystal_array_0_target_y
#define target_z mccchannel_16_analyzer_2_array_crystal_array_0_target_z
#define focus_aw mccchannel_16_analyzer_2_array_crystal_array_0_focus_aw
#define focus_ah mccchannel_16_analyzer_2_array_crystal_array_0_focus_ah
#define focus_xw mccchannel_16_analyzer_2_array_crystal_array_0_focus_xw
#define focus_xh mccchannel_16_analyzer_2_array_crystal_array_0_focus_xh
#define focus_r mccchannel_16_analyzer_2_array_crystal_array_0_focus_r
#define p_interact mccchannel_16_analyzer_2_array_crystal_array_0_p_interact
#define mask_string mccchannel_16_analyzer_2_array_crystal_array_0_mask_string
#define mask_setting mccchannel_16_analyzer_2_array_crystal_array_0_mask_setting
#define number_of_activations mccchannel_16_analyzer_2_array_crystal_array_0_number_of_activations
#line 204 "Union_box.comp"
// Needed for transport to the main component
struct global_geometry_element_struct global_geometry_element;

#ifndef ANY_GEOMETRY_DETECTOR_DECLARE
    #define ANY_GEOMETRY_DETECTOR_DECLARE dummy
	//struct pointer_to_global_geometry_list global_geometry_list = {0,NULL};
#endif

int loop_index,found_geometries;

double x_component;
double y_component;
double z_component;

struct Volume_struct this_box_volume;
struct box_storage this_box_storage;

#line 75587 "MACS_sample_kidney_box.c"
#undef number_of_activations
#undef mask_setting
#undef mask_string
#undef p_interact
#undef focus_r
#undef focus_xh
#undef focus_xw
#undef focus_ah
#undef focus_aw
#undef target_z
#undef target_y
#undef target_x
#undef target_index
#undef visualize
#undef yheight2
#undef xwidth2
#undef zdepth
#undef yheight
#undef xwidth
#undef priority
#undef material_string
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

/* User declarations for component 'channel_16_analyzer_2_array_crystal_array_1' [750]. */
#define mccompcurname  channel_16_analyzer_2_array_crystal_array_1
#define mccompcurtype  Union_box
#define mccompcurindex 750
#define loop_index mccchannel_16_analyzer_2_array_crystal_array_1_loop_index
#define this_box_volume mccchannel_16_analyzer_2_array_crystal_array_1_this_box_volume
#define global_geometry_element mccchannel_16_analyzer_2_array_crystal_array_1_global_geometry_element
#define this_box_storage mccchannel_16_analyzer_2_array_crystal_array_1_this_box_storage
#define material_string mccchannel_16_analyzer_2_array_crystal_array_1_material_string
#define priority mccchannel_16_analyzer_2_array_crystal_array_1_priority
#define xwidth mccchannel_16_analyzer_2_array_crystal_array_1_xwidth
#define yheight mccchannel_16_analyzer_2_array_crystal_array_1_yheight
#define zdepth mccchannel_16_analyzer_2_array_crystal_array_1_zdepth
#define xwidth2 mccchannel_16_analyzer_2_array_crystal_array_1_xwidth2
#define yheight2 mccchannel_16_analyzer_2_array_crystal_array_1_yheight2
#define visualize mccchannel_16_analyzer_2_array_crystal_array_1_visualize
#define target_index mccchannel_16_analyzer_2_array_crystal_array_1_target_index
#define target_x mccchannel_16_analyzer_2_array_crystal_array_1_target_x
#define target_y mccchannel_16_analyzer_2_array_crystal_array_1_target_y
#define target_z mccchannel_16_analyzer_2_array_crystal_array_1_target_z
#define focus_aw mccchannel_16_analyzer_2_array_crystal_array_1_focus_aw
#define focus_ah mccchannel_16_analyzer_2_array_crystal_array_1_focus_ah
#define focus_xw mccchannel_16_analyzer_2_array_crystal_array_1_focus_xw
#define focus_xh mccchannel_16_analyzer_2_array_crystal_array_1_focus_xh
#define focus_r mccchannel_16_analyzer_2_array_crystal_array_1_focus_r
#define p_interact mccchannel_16_analyzer_2_array_crystal_array_1_p_interact
#define mask_string mccchannel_16_analyzer_2_array_crystal_array_1_mask_string
#define mask_setting mccchannel_16_analyzer_2_array_crystal_array_1_mask_setting
#define number_of_activations mccchannel_16_analyzer_2_array_crystal_array_1_number_of_activations
#line 204 "Union_box.comp"
// Needed for transport to the main component
struct global_geometry_element_struct global_geometry_element;

#ifndef ANY_GEOMETRY_DETECTOR_DECLARE
    #define ANY_GEOMETRY_DETECTOR_DECLARE dummy
	//struct pointer_to_global_geometry_list global_geometry_list = {0,NULL};
#endif

int loop_index,found_geometries;

double x_component;
double y_component;
double z_component;

struct Volume_struct this_box_volume;
struct box_storage this_box_storage;

#line 75664 "MACS_sample_kidney_box.c"
#undef number_of_activations
#undef mask_setting
#undef mask_string
#undef p_interact
#undef focus_r
#undef focus_xh
#undef focus_xw
#undef focus_ah
#undef focus_aw
#undef target_z
#undef target_y
#undef target_x
#undef target_index
#undef visualize
#undef yheight2
#undef xwidth2
#undef zdepth
#undef yheight
#undef xwidth
#undef priority
#undef material_string
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

/* User declarations for component 'channel_16_analyzer_2_array_crystal_array_2' [751]. */
#define mccompcurname  channel_16_analyzer_2_array_crystal_array_2
#define mccompcurtype  Union_box
#define mccompcurindex 751
#define loop_index mccchannel_16_analyzer_2_array_crystal_array_2_loop_index
#define this_box_volume mccchannel_16_analyzer_2_array_crystal_array_2_this_box_volume
#define global_geometry_element mccchannel_16_analyzer_2_array_crystal_array_2_global_geometry_element
#define this_box_storage mccchannel_16_analyzer_2_array_crystal_array_2_this_box_storage
#define material_string mccchannel_16_analyzer_2_array_crystal_array_2_material_string
#define priority mccchannel_16_analyzer_2_array_crystal_array_2_priority
#define xwidth mccchannel_16_analyzer_2_array_crystal_array_2_xwidth
#define yheight mccchannel_16_analyzer_2_array_crystal_array_2_yheight
#define zdepth mccchannel_16_analyzer_2_array_crystal_array_2_zdepth
#define xwidth2 mccchannel_16_analyzer_2_array_crystal_array_2_xwidth2
#define yheight2 mccchannel_16_analyzer_2_array_crystal_array_2_yheight2
#define visualize mccchannel_16_analyzer_2_array_crystal_array_2_visualize
#define target_index mccchannel_16_analyzer_2_array_crystal_array_2_target_index
#define target_x mccchannel_16_analyzer_2_array_crystal_array_2_target_x
#define target_y mccchannel_16_analyzer_2_array_crystal_array_2_target_y
#define target_z mccchannel_16_analyzer_2_array_crystal_array_2_target_z
#define focus_aw mccchannel_16_analyzer_2_array_crystal_array_2_focus_aw
#define focus_ah mccchannel_16_analyzer_2_array_crystal_array_2_focus_ah
#define focus_xw mccchannel_16_analyzer_2_array_crystal_array_2_focus_xw
#define focus_xh mccchannel_16_analyzer_2_array_crystal_array_2_focus_xh
#define focus_r mccchannel_16_analyzer_2_array_crystal_array_2_focus_r
#define p_interact mccchannel_16_analyzer_2_array_crystal_array_2_p_interact
#define mask_string mccchannel_16_analyzer_2_array_crystal_array_2_mask_string
#define mask_setting mccchannel_16_analyzer_2_array_crystal_array_2_mask_setting
#define number_of_activations mccchannel_16_analyzer_2_array_crystal_array_2_number_of_activations
#line 204 "Union_box.comp"
// Needed for transport to the main component
struct global_geometry_element_struct global_geometry_element;

#ifndef ANY_GEOMETRY_DETECTOR_DECLARE
    #define ANY_GEOMETRY_DETECTOR_DECLARE dummy
	//struct pointer_to_global_geometry_list global_geometry_list = {0,NULL};
#endif

int loop_index,found_geometries;

double x_component;
double y_component;
double z_component;

struct Volume_struct this_box_volume;
struct box_storage this_box_storage;

#line 75741 "MACS_sample_kidney_box.c"
#undef number_of_activations
#undef mask_setting
#undef mask_string
#undef p_interact
#undef focus_r
#undef focus_xh
#undef focus_xw
#undef focus_ah
#undef focus_aw
#undef target_z
#undef target_y
#undef target_x
#undef target_index
#undef visualize
#undef yheight2
#undef xwidth2
#undef zdepth
#undef yheight
#undef xwidth
#undef priority
#undef material_string
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

/* User declarations for component 'channel_16_analyzer_2_array_crystal_array_3' [752]. */
#define mccompcurname  channel_16_analyzer_2_array_crystal_array_3
#define mccompcurtype  Union_box
#define mccompcurindex 752
#define loop_index mccchannel_16_analyzer_2_array_crystal_array_3_loop_index
#define this_box_volume mccchannel_16_analyzer_2_array_crystal_array_3_this_box_volume
#define global_geometry_element mccchannel_16_analyzer_2_array_crystal_array_3_global_geometry_element
#define this_box_storage mccchannel_16_analyzer_2_array_crystal_array_3_this_box_storage
#define material_string mccchannel_16_analyzer_2_array_crystal_array_3_material_string
#define priority mccchannel_16_analyzer_2_array_crystal_array_3_priority
#define xwidth mccchannel_16_analyzer_2_array_crystal_array_3_xwidth
#define yheight mccchannel_16_analyzer_2_array_crystal_array_3_yheight
#define zdepth mccchannel_16_analyzer_2_array_crystal_array_3_zdepth
#define xwidth2 mccchannel_16_analyzer_2_array_crystal_array_3_xwidth2
#define yheight2 mccchannel_16_analyzer_2_array_crystal_array_3_yheight2
#define visualize mccchannel_16_analyzer_2_array_crystal_array_3_visualize
#define target_index mccchannel_16_analyzer_2_array_crystal_array_3_target_index
#define target_x mccchannel_16_analyzer_2_array_crystal_array_3_target_x
#define target_y mccchannel_16_analyzer_2_array_crystal_array_3_target_y
#define target_z mccchannel_16_analyzer_2_array_crystal_array_3_target_z
#define focus_aw mccchannel_16_analyzer_2_array_crystal_array_3_focus_aw
#define focus_ah mccchannel_16_analyzer_2_array_crystal_array_3_focus_ah
#define focus_xw mccchannel_16_analyzer_2_array_crystal_array_3_focus_xw
#define focus_xh mccchannel_16_analyzer_2_array_crystal_array_3_focus_xh
#define focus_r mccchannel_16_analyzer_2_array_crystal_array_3_focus_r
#define p_interact mccchannel_16_analyzer_2_array_crystal_array_3_p_interact
#define mask_string mccchannel_16_analyzer_2_array_crystal_array_3_mask_string
#define mask_setting mccchannel_16_analyzer_2_array_crystal_array_3_mask_setting
#define number_of_activations mccchannel_16_analyzer_2_array_crystal_array_3_number_of_activations
#line 204 "Union_box.comp"
// Needed for transport to the main component
struct global_geometry_element_struct global_geometry_element;

#ifndef ANY_GEOMETRY_DETECTOR_DECLARE
    #define ANY_GEOMETRY_DETECTOR_DECLARE dummy
	//struct pointer_to_global_geometry_list global_geometry_list = {0,NULL};
#endif

int loop_index,found_geometries;

double x_component;
double y_component;
double z_component;

struct Volume_struct this_box_volume;
struct box_storage this_box_storage;

#line 75818 "MACS_sample_kidney_box.c"
#undef number_of_activations
#undef mask_setting
#undef mask_string
#undef p_interact
#undef focus_r
#undef focus_xh
#undef focus_xw
#undef focus_ah
#undef focus_aw
#undef target_z
#undef target_y
#undef target_x
#undef target_index
#undef visualize
#undef yheight2
#undef xwidth2
#undef zdepth
#undef yheight
#undef xwidth
#undef priority
#undef material_string
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

/* User declarations for component 'channel_16_analyzer_2_array_crystal_array_4' [753]. */
#define mccompcurname  channel_16_analyzer_2_array_crystal_array_4
#define mccompcurtype  Union_box
#define mccompcurindex 753
#define loop_index mccchannel_16_analyzer_2_array_crystal_array_4_loop_index
#define this_box_volume mccchannel_16_analyzer_2_array_crystal_array_4_this_box_volume
#define global_geometry_element mccchannel_16_analyzer_2_array_crystal_array_4_global_geometry_element
#define this_box_storage mccchannel_16_analyzer_2_array_crystal_array_4_this_box_storage
#define material_string mccchannel_16_analyzer_2_array_crystal_array_4_material_string
#define priority mccchannel_16_analyzer_2_array_crystal_array_4_priority
#define xwidth mccchannel_16_analyzer_2_array_crystal_array_4_xwidth
#define yheight mccchannel_16_analyzer_2_array_crystal_array_4_yheight
#define zdepth mccchannel_16_analyzer_2_array_crystal_array_4_zdepth
#define xwidth2 mccchannel_16_analyzer_2_array_crystal_array_4_xwidth2
#define yheight2 mccchannel_16_analyzer_2_array_crystal_array_4_yheight2
#define visualize mccchannel_16_analyzer_2_array_crystal_array_4_visualize
#define target_index mccchannel_16_analyzer_2_array_crystal_array_4_target_index
#define target_x mccchannel_16_analyzer_2_array_crystal_array_4_target_x
#define target_y mccchannel_16_analyzer_2_array_crystal_array_4_target_y
#define target_z mccchannel_16_analyzer_2_array_crystal_array_4_target_z
#define focus_aw mccchannel_16_analyzer_2_array_crystal_array_4_focus_aw
#define focus_ah mccchannel_16_analyzer_2_array_crystal_array_4_focus_ah
#define focus_xw mccchannel_16_analyzer_2_array_crystal_array_4_focus_xw
#define focus_xh mccchannel_16_analyzer_2_array_crystal_array_4_focus_xh
#define focus_r mccchannel_16_analyzer_2_array_crystal_array_4_focus_r
#define p_interact mccchannel_16_analyzer_2_array_crystal_array_4_p_interact
#define mask_string mccchannel_16_analyzer_2_array_crystal_array_4_mask_string
#define mask_setting mccchannel_16_analyzer_2_array_crystal_array_4_mask_setting
#define number_of_activations mccchannel_16_analyzer_2_array_crystal_array_4_number_of_activations
#line 204 "Union_box.comp"
// Needed for transport to the main component
struct global_geometry_element_struct global_geometry_element;

#ifndef ANY_GEOMETRY_DETECTOR_DECLARE
    #define ANY_GEOMETRY_DETECTOR_DECLARE dummy
	//struct pointer_to_global_geometry_list global_geometry_list = {0,NULL};
#endif

int loop_index,found_geometries;

double x_component;
double y_component;
double z_component;

struct Volume_struct this_box_volume;
struct box_storage this_box_storage;

#line 75895 "MACS_sample_kidney_box.c"
#undef number_of_activations
#undef mask_setting
#undef mask_string
#undef p_interact
#undef focus_r
#undef focus_xh
#undef focus_xw
#undef focus_ah
#undef focus_aw
#undef target_z
#undef target_y
#undef target_x
#undef target_index
#undef visualize
#undef yheight2
#undef xwidth2
#undef zdepth
#undef yheight
#undef xwidth
#undef priority
#undef material_string
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

/* User declarations for component 'channel_16_analyzer_2_array_crystal_array_5' [754]. */
#define mccompcurname  channel_16_analyzer_2_array_crystal_array_5
#define mccompcurtype  Union_box
#define mccompcurindex 754
#define loop_index mccchannel_16_analyzer_2_array_crystal_array_5_loop_index
#define this_box_volume mccchannel_16_analyzer_2_array_crystal_array_5_this_box_volume
#define global_geometry_element mccchannel_16_analyzer_2_array_crystal_array_5_global_geometry_element
#define this_box_storage mccchannel_16_analyzer_2_array_crystal_array_5_this_box_storage
#define material_string mccchannel_16_analyzer_2_array_crystal_array_5_material_string
#define priority mccchannel_16_analyzer_2_array_crystal_array_5_priority
#define xwidth mccchannel_16_analyzer_2_array_crystal_array_5_xwidth
#define yheight mccchannel_16_analyzer_2_array_crystal_array_5_yheight
#define zdepth mccchannel_16_analyzer_2_array_crystal_array_5_zdepth
#define xwidth2 mccchannel_16_analyzer_2_array_crystal_array_5_xwidth2
#define yheight2 mccchannel_16_analyzer_2_array_crystal_array_5_yheight2
#define visualize mccchannel_16_analyzer_2_array_crystal_array_5_visualize
#define target_index mccchannel_16_analyzer_2_array_crystal_array_5_target_index
#define target_x mccchannel_16_analyzer_2_array_crystal_array_5_target_x
#define target_y mccchannel_16_analyzer_2_array_crystal_array_5_target_y
#define target_z mccchannel_16_analyzer_2_array_crystal_array_5_target_z
#define focus_aw mccchannel_16_analyzer_2_array_crystal_array_5_focus_aw
#define focus_ah mccchannel_16_analyzer_2_array_crystal_array_5_focus_ah
#define focus_xw mccchannel_16_analyzer_2_array_crystal_array_5_focus_xw
#define focus_xh mccchannel_16_analyzer_2_array_crystal_array_5_focus_xh
#define focus_r mccchannel_16_analyzer_2_array_crystal_array_5_focus_r
#define p_interact mccchannel_16_analyzer_2_array_crystal_array_5_p_interact
#define mask_string mccchannel_16_analyzer_2_array_crystal_array_5_mask_string
#define mask_setting mccchannel_16_analyzer_2_array_crystal_array_5_mask_setting
#define number_of_activations mccchannel_16_analyzer_2_array_crystal_array_5_number_of_activations
#line 204 "Union_box.comp"
// Needed for transport to the main component
struct global_geometry_element_struct global_geometry_element;

#ifndef ANY_GEOMETRY_DETECTOR_DECLARE
    #define ANY_GEOMETRY_DETECTOR_DECLARE dummy
	//struct pointer_to_global_geometry_list global_geometry_list = {0,NULL};
#endif

int loop_index,found_geometries;

double x_component;
double y_component;
double z_component;

struct Volume_struct this_box_volume;
struct box_storage this_box_storage;

#line 75972 "MACS_sample_kidney_box.c"
#undef number_of_activations
#undef mask_setting
#undef mask_string
#undef p_interact
#undef focus_r
#undef focus_xh
#undef focus_xw
#undef focus_ah
#undef focus_aw
#undef target_z
#undef target_y
#undef target_x
#undef target_index
#undef visualize
#undef yheight2
#undef xwidth2
#undef zdepth
#undef yheight
#undef xwidth
#undef priority
#undef material_string
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

/* User declarations for component 'channel_16_analyzer_2_array_crystal_array_6' [755]. */
#define mccompcurname  channel_16_analyzer_2_array_crystal_array_6
#define mccompcurtype  Union_box
#define mccompcurindex 755
#define loop_index mccchannel_16_analyzer_2_array_crystal_array_6_loop_index
#define this_box_volume mccchannel_16_analyzer_2_array_crystal_array_6_this_box_volume
#define global_geometry_element mccchannel_16_analyzer_2_array_crystal_array_6_global_geometry_element
#define this_box_storage mccchannel_16_analyzer_2_array_crystal_array_6_this_box_storage
#define material_string mccchannel_16_analyzer_2_array_crystal_array_6_material_string
#define priority mccchannel_16_analyzer_2_array_crystal_array_6_priority
#define xwidth mccchannel_16_analyzer_2_array_crystal_array_6_xwidth
#define yheight mccchannel_16_analyzer_2_array_crystal_array_6_yheight
#define zdepth mccchannel_16_analyzer_2_array_crystal_array_6_zdepth
#define xwidth2 mccchannel_16_analyzer_2_array_crystal_array_6_xwidth2
#define yheight2 mccchannel_16_analyzer_2_array_crystal_array_6_yheight2
#define visualize mccchannel_16_analyzer_2_array_crystal_array_6_visualize
#define target_index mccchannel_16_analyzer_2_array_crystal_array_6_target_index
#define target_x mccchannel_16_analyzer_2_array_crystal_array_6_target_x
#define target_y mccchannel_16_analyzer_2_array_crystal_array_6_target_y
#define target_z mccchannel_16_analyzer_2_array_crystal_array_6_target_z
#define focus_aw mccchannel_16_analyzer_2_array_crystal_array_6_focus_aw
#define focus_ah mccchannel_16_analyzer_2_array_crystal_array_6_focus_ah
#define focus_xw mccchannel_16_analyzer_2_array_crystal_array_6_focus_xw
#define focus_xh mccchannel_16_analyzer_2_array_crystal_array_6_focus_xh
#define focus_r mccchannel_16_analyzer_2_array_crystal_array_6_focus_r
#define p_interact mccchannel_16_analyzer_2_array_crystal_array_6_p_interact
#define mask_string mccchannel_16_analyzer_2_array_crystal_array_6_mask_string
#define mask_setting mccchannel_16_analyzer_2_array_crystal_array_6_mask_setting
#define number_of_activations mccchannel_16_analyzer_2_array_crystal_array_6_number_of_activations
#line 204 "Union_box.comp"
// Needed for transport to the main component
struct global_geometry_element_struct global_geometry_element;

#ifndef ANY_GEOMETRY_DETECTOR_DECLARE
    #define ANY_GEOMETRY_DETECTOR_DECLARE dummy
	//struct pointer_to_global_geometry_list global_geometry_list = {0,NULL};
#endif

int loop_index,found_geometries;

double x_component;
double y_component;
double z_component;

struct Volume_struct this_box_volume;
struct box_storage this_box_storage;

#line 76049 "MACS_sample_kidney_box.c"
#undef number_of_activations
#undef mask_setting
#undef mask_string
#undef p_interact
#undef focus_r
#undef focus_xh
#undef focus_xw
#undef focus_ah
#undef focus_aw
#undef target_z
#undef target_y
#undef target_x
#undef target_index
#undef visualize
#undef yheight2
#undef xwidth2
#undef zdepth
#undef yheight
#undef xwidth
#undef priority
#undef material_string
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

/* User declarations for component 'channel_16_analyzer_2_array_crystal_array_7' [756]. */
#define mccompcurname  channel_16_analyzer_2_array_crystal_array_7
#define mccompcurtype  Union_box
#define mccompcurindex 756
#define loop_index mccchannel_16_analyzer_2_array_crystal_array_7_loop_index
#define this_box_volume mccchannel_16_analyzer_2_array_crystal_array_7_this_box_volume
#define global_geometry_element mccchannel_16_analyzer_2_array_crystal_array_7_global_geometry_element
#define this_box_storage mccchannel_16_analyzer_2_array_crystal_array_7_this_box_storage
#define material_string mccchannel_16_analyzer_2_array_crystal_array_7_material_string
#define priority mccchannel_16_analyzer_2_array_crystal_array_7_priority
#define xwidth mccchannel_16_analyzer_2_array_crystal_array_7_xwidth
#define yheight mccchannel_16_analyzer_2_array_crystal_array_7_yheight
#define zdepth mccchannel_16_analyzer_2_array_crystal_array_7_zdepth
#define xwidth2 mccchannel_16_analyzer_2_array_crystal_array_7_xwidth2
#define yheight2 mccchannel_16_analyzer_2_array_crystal_array_7_yheight2
#define visualize mccchannel_16_analyzer_2_array_crystal_array_7_visualize
#define target_index mccchannel_16_analyzer_2_array_crystal_array_7_target_index
#define target_x mccchannel_16_analyzer_2_array_crystal_array_7_target_x
#define target_y mccchannel_16_analyzer_2_array_crystal_array_7_target_y
#define target_z mccchannel_16_analyzer_2_array_crystal_array_7_target_z
#define focus_aw mccchannel_16_analyzer_2_array_crystal_array_7_focus_aw
#define focus_ah mccchannel_16_analyzer_2_array_crystal_array_7_focus_ah
#define focus_xw mccchannel_16_analyzer_2_array_crystal_array_7_focus_xw
#define focus_xh mccchannel_16_analyzer_2_array_crystal_array_7_focus_xh
#define focus_r mccchannel_16_analyzer_2_array_crystal_array_7_focus_r
#define p_interact mccchannel_16_analyzer_2_array_crystal_array_7_p_interact
#define mask_string mccchannel_16_analyzer_2_array_crystal_array_7_mask_string
#define mask_setting mccchannel_16_analyzer_2_array_crystal_array_7_mask_setting
#define number_of_activations mccchannel_16_analyzer_2_array_crystal_array_7_number_of_activations
#line 204 "Union_box.comp"
// Needed for transport to the main component
struct global_geometry_element_struct global_geometry_element;

#ifndef ANY_GEOMETRY_DETECTOR_DECLARE
    #define ANY_GEOMETRY_DETECTOR_DECLARE dummy
	//struct pointer_to_global_geometry_list global_geometry_list = {0,NULL};
#endif

int loop_index,found_geometries;

double x_component;
double y_component;
double z_component;

struct Volume_struct this_box_volume;
struct box_storage this_box_storage;

#line 76126 "MACS_sample_kidney_box.c"
#undef number_of_activations
#undef mask_setting
#undef mask_string
#undef p_interact
#undef focus_r
#undef focus_xh
#undef focus_xw
#undef focus_ah
#undef focus_aw
#undef target_z
#undef target_y
#undef target_x
#undef target_index
#undef visualize
#undef yheight2
#undef xwidth2
#undef zdepth
#undef yheight
#undef xwidth
#undef priority
#undef material_string
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

/* User declarations for component 'channel_16_analyzer_2_array_crystal_array_8' [757]. */
#define mccompcurname  channel_16_analyzer_2_array_crystal_array_8
#define mccompcurtype  Union_box
#define mccompcurindex 757
#define loop_index mccchannel_16_analyzer_2_array_crystal_array_8_loop_index
#define this_box_volume mccchannel_16_analyzer_2_array_crystal_array_8_this_box_volume
#define global_geometry_element mccchannel_16_analyzer_2_array_crystal_array_8_global_geometry_element
#define this_box_storage mccchannel_16_analyzer_2_array_crystal_array_8_this_box_storage
#define material_string mccchannel_16_analyzer_2_array_crystal_array_8_material_string
#define priority mccchannel_16_analyzer_2_array_crystal_array_8_priority
#define xwidth mccchannel_16_analyzer_2_array_crystal_array_8_xwidth
#define yheight mccchannel_16_analyzer_2_array_crystal_array_8_yheight
#define zdepth mccchannel_16_analyzer_2_array_crystal_array_8_zdepth
#define xwidth2 mccchannel_16_analyzer_2_array_crystal_array_8_xwidth2
#define yheight2 mccchannel_16_analyzer_2_array_crystal_array_8_yheight2
#define visualize mccchannel_16_analyzer_2_array_crystal_array_8_visualize
#define target_index mccchannel_16_analyzer_2_array_crystal_array_8_target_index
#define target_x mccchannel_16_analyzer_2_array_crystal_array_8_target_x
#define target_y mccchannel_16_analyzer_2_array_crystal_array_8_target_y
#define target_z mccchannel_16_analyzer_2_array_crystal_array_8_target_z
#define focus_aw mccchannel_16_analyzer_2_array_crystal_array_8_focus_aw
#define focus_ah mccchannel_16_analyzer_2_array_crystal_array_8_focus_ah
#define focus_xw mccchannel_16_analyzer_2_array_crystal_array_8_focus_xw
#define focus_xh mccchannel_16_analyzer_2_array_crystal_array_8_focus_xh
#define focus_r mccchannel_16_analyzer_2_array_crystal_array_8_focus_r
#define p_interact mccchannel_16_analyzer_2_array_crystal_array_8_p_interact
#define mask_string mccchannel_16_analyzer_2_array_crystal_array_8_mask_string
#define mask_setting mccchannel_16_analyzer_2_array_crystal_array_8_mask_setting
#define number_of_activations mccchannel_16_analyzer_2_array_crystal_array_8_number_of_activations
#line 204 "Union_box.comp"
// Needed for transport to the main component
struct global_geometry_element_struct global_geometry_element;

#ifndef ANY_GEOMETRY_DETECTOR_DECLARE
    #define ANY_GEOMETRY_DETECTOR_DECLARE dummy
	//struct pointer_to_global_geometry_list global_geometry_list = {0,NULL};
#endif

int loop_index,found_geometries;

double x_component;
double y_component;
double z_component;

struct Volume_struct this_box_volume;
struct box_storage this_box_storage;

#line 76203 "MACS_sample_kidney_box.c"
#undef number_of_activations
#undef mask_setting
#undef mask_string
#undef p_interact
#undef focus_r
#undef focus_xh
#undef focus_xw
#undef focus_ah
#undef focus_aw
#undef target_z
#undef target_y
#undef target_x
#undef target_index
#undef visualize
#undef yheight2
#undef xwidth2
#undef zdepth
#undef yheight
#undef xwidth
#undef priority
#undef material_string
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

/* User declarations for component 'channel_16_cave2_cyl1' [758]. */
#define mccompcurname  channel_16_cave2_cyl1
#define mccompcurtype  Union_cylinder
#define mccompcurindex 758
#define loop_index mccchannel_16_cave2_cyl1_loop_index
#define this_cylinder_volume mccchannel_16_cave2_cyl1_this_cylinder_volume
#define global_geometry_element mccchannel_16_cave2_cyl1_global_geometry_element
#define this_cylinder_storage mccchannel_16_cave2_cyl1_this_cylinder_storage
#define material_string mccchannel_16_cave2_cyl1_material_string
#define priority mccchannel_16_cave2_cyl1_priority
#define radius mccchannel_16_cave2_cyl1_radius
#define yheight mccchannel_16_cave2_cyl1_yheight
#define visualize mccchannel_16_cave2_cyl1_visualize
#define target_index mccchannel_16_cave2_cyl1_target_index
#define target_x mccchannel_16_cave2_cyl1_target_x
#define target_y mccchannel_16_cave2_cyl1_target_y
#define target_z mccchannel_16_cave2_cyl1_target_z
#define focus_aw mccchannel_16_cave2_cyl1_focus_aw
#define focus_ah mccchannel_16_cave2_cyl1_focus_ah
#define focus_xw mccchannel_16_cave2_cyl1_focus_xw
#define focus_xh mccchannel_16_cave2_cyl1_focus_xh
#define focus_r mccchannel_16_cave2_cyl1_focus_r
#define p_interact mccchannel_16_cave2_cyl1_p_interact
#define mask_string mccchannel_16_cave2_cyl1_mask_string
#define mask_setting mccchannel_16_cave2_cyl1_mask_setting
#define number_of_activations mccchannel_16_cave2_cyl1_number_of_activations
#line 167 "Union_cylinder.comp"
// Needed for transport to the main component
struct global_geometry_element_struct global_geometry_element;

#ifndef ANY_GEOMETRY_DETECTOR_DECLARE
    #define ANY_GEOMETRY_DETECTOR_DECLARE dummy
	//struct pointer_to_global_geometry_list global_geometry_list = {0,NULL};
#endif

int dummy;
int loop_index,found_geometries;
int loop_2_index;
int material_index;

struct Volume_struct this_cylinder_volume;
struct cylinder_storage this_cylinder_storage;
#line 76275 "MACS_sample_kidney_box.c"
#undef number_of_activations
#undef mask_setting
#undef mask_string
#undef p_interact
#undef focus_r
#undef focus_xh
#undef focus_xw
#undef focus_ah
#undef focus_aw
#undef target_z
#undef target_y
#undef target_x
#undef target_index
#undef visualize
#undef yheight
#undef radius
#undef priority
#undef material_string
#undef this_cylinder_storage
#undef global_geometry_element
#undef this_cylinder_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

/* User declarations for component 'channel_16_cave2_box1' [759]. */
#define mccompcurname  channel_16_cave2_box1
#define mccompcurtype  Union_box
#define mccompcurindex 759
#define loop_index mccchannel_16_cave2_box1_loop_index
#define this_box_volume mccchannel_16_cave2_box1_this_box_volume
#define global_geometry_element mccchannel_16_cave2_box1_global_geometry_element
#define this_box_storage mccchannel_16_cave2_box1_this_box_storage
#define material_string mccchannel_16_cave2_box1_material_string
#define priority mccchannel_16_cave2_box1_priority
#define xwidth mccchannel_16_cave2_box1_xwidth
#define yheight mccchannel_16_cave2_box1_yheight
#define zdepth mccchannel_16_cave2_box1_zdepth
#define xwidth2 mccchannel_16_cave2_box1_xwidth2
#define yheight2 mccchannel_16_cave2_box1_yheight2
#define visualize mccchannel_16_cave2_box1_visualize
#define target_index mccchannel_16_cave2_box1_target_index
#define target_x mccchannel_16_cave2_box1_target_x
#define target_y mccchannel_16_cave2_box1_target_y
#define target_z mccchannel_16_cave2_box1_target_z
#define focus_aw mccchannel_16_cave2_box1_focus_aw
#define focus_ah mccchannel_16_cave2_box1_focus_ah
#define focus_xw mccchannel_16_cave2_box1_focus_xw
#define focus_xh mccchannel_16_cave2_box1_focus_xh
#define focus_r mccchannel_16_cave2_box1_focus_r
#define p_interact mccchannel_16_cave2_box1_p_interact
#define mask_string mccchannel_16_cave2_box1_mask_string
#define mask_setting mccchannel_16_cave2_box1_mask_setting
#define number_of_activations mccchannel_16_cave2_box1_number_of_activations
#line 204 "Union_box.comp"
// Needed for transport to the main component
struct global_geometry_element_struct global_geometry_element;

#ifndef ANY_GEOMETRY_DETECTOR_DECLARE
    #define ANY_GEOMETRY_DETECTOR_DECLARE dummy
	//struct pointer_to_global_geometry_list global_geometry_list = {0,NULL};
#endif

int loop_index,found_geometries;

double x_component;
double y_component;
double z_component;

struct Volume_struct this_box_volume;
struct box_storage this_box_storage;

#line 76349 "MACS_sample_kidney_box.c"
#undef number_of_activations
#undef mask_setting
#undef mask_string
#undef p_interact
#undef focus_r
#undef focus_xh
#undef focus_xw
#undef focus_ah
#undef focus_aw
#undef target_z
#undef target_y
#undef target_x
#undef target_index
#undef visualize
#undef yheight2
#undef xwidth2
#undef zdepth
#undef yheight
#undef xwidth
#undef priority
#undef material_string
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

/* User declarations for component 'channel_16_cave2_box2' [760]. */
#define mccompcurname  channel_16_cave2_box2
#define mccompcurtype  Union_box
#define mccompcurindex 760
#define loop_index mccchannel_16_cave2_box2_loop_index
#define this_box_volume mccchannel_16_cave2_box2_this_box_volume
#define global_geometry_element mccchannel_16_cave2_box2_global_geometry_element
#define this_box_storage mccchannel_16_cave2_box2_this_box_storage
#define material_string mccchannel_16_cave2_box2_material_string
#define priority mccchannel_16_cave2_box2_priority
#define xwidth mccchannel_16_cave2_box2_xwidth
#define yheight mccchannel_16_cave2_box2_yheight
#define zdepth mccchannel_16_cave2_box2_zdepth
#define xwidth2 mccchannel_16_cave2_box2_xwidth2
#define yheight2 mccchannel_16_cave2_box2_yheight2
#define visualize mccchannel_16_cave2_box2_visualize
#define target_index mccchannel_16_cave2_box2_target_index
#define target_x mccchannel_16_cave2_box2_target_x
#define target_y mccchannel_16_cave2_box2_target_y
#define target_z mccchannel_16_cave2_box2_target_z
#define focus_aw mccchannel_16_cave2_box2_focus_aw
#define focus_ah mccchannel_16_cave2_box2_focus_ah
#define focus_xw mccchannel_16_cave2_box2_focus_xw
#define focus_xh mccchannel_16_cave2_box2_focus_xh
#define focus_r mccchannel_16_cave2_box2_focus_r
#define p_interact mccchannel_16_cave2_box2_p_interact
#define mask_string mccchannel_16_cave2_box2_mask_string
#define mask_setting mccchannel_16_cave2_box2_mask_setting
#define number_of_activations mccchannel_16_cave2_box2_number_of_activations
#line 204 "Union_box.comp"
// Needed for transport to the main component
struct global_geometry_element_struct global_geometry_element;

#ifndef ANY_GEOMETRY_DETECTOR_DECLARE
    #define ANY_GEOMETRY_DETECTOR_DECLARE dummy
	//struct pointer_to_global_geometry_list global_geometry_list = {0,NULL};
#endif

int loop_index,found_geometries;

double x_component;
double y_component;
double z_component;

struct Volume_struct this_box_volume;
struct box_storage this_box_storage;

#line 76426 "MACS_sample_kidney_box.c"
#undef number_of_activations
#undef mask_setting
#undef mask_string
#undef p_interact
#undef focus_r
#undef focus_xh
#undef focus_xw
#undef focus_ah
#undef focus_aw
#undef target_z
#undef target_y
#undef target_x
#undef target_index
#undef visualize
#undef yheight2
#undef xwidth2
#undef zdepth
#undef yheight
#undef xwidth
#undef priority
#undef material_string
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

/* User declarations for component 'channel_16_cave2_box3' [761]. */
#define mccompcurname  channel_16_cave2_box3
#define mccompcurtype  Union_box
#define mccompcurindex 761
#define loop_index mccchannel_16_cave2_box3_loop_index
#define this_box_volume mccchannel_16_cave2_box3_this_box_volume
#define global_geometry_element mccchannel_16_cave2_box3_global_geometry_element
#define this_box_storage mccchannel_16_cave2_box3_this_box_storage
#define material_string mccchannel_16_cave2_box3_material_string
#define priority mccchannel_16_cave2_box3_priority
#define xwidth mccchannel_16_cave2_box3_xwidth
#define yheight mccchannel_16_cave2_box3_yheight
#define zdepth mccchannel_16_cave2_box3_zdepth
#define xwidth2 mccchannel_16_cave2_box3_xwidth2
#define yheight2 mccchannel_16_cave2_box3_yheight2
#define visualize mccchannel_16_cave2_box3_visualize
#define target_index mccchannel_16_cave2_box3_target_index
#define target_x mccchannel_16_cave2_box3_target_x
#define target_y mccchannel_16_cave2_box3_target_y
#define target_z mccchannel_16_cave2_box3_target_z
#define focus_aw mccchannel_16_cave2_box3_focus_aw
#define focus_ah mccchannel_16_cave2_box3_focus_ah
#define focus_xw mccchannel_16_cave2_box3_focus_xw
#define focus_xh mccchannel_16_cave2_box3_focus_xh
#define focus_r mccchannel_16_cave2_box3_focus_r
#define p_interact mccchannel_16_cave2_box3_p_interact
#define mask_string mccchannel_16_cave2_box3_mask_string
#define mask_setting mccchannel_16_cave2_box3_mask_setting
#define number_of_activations mccchannel_16_cave2_box3_number_of_activations
#line 204 "Union_box.comp"
// Needed for transport to the main component
struct global_geometry_element_struct global_geometry_element;

#ifndef ANY_GEOMETRY_DETECTOR_DECLARE
    #define ANY_GEOMETRY_DETECTOR_DECLARE dummy
	//struct pointer_to_global_geometry_list global_geometry_list = {0,NULL};
#endif

int loop_index,found_geometries;

double x_component;
double y_component;
double z_component;

struct Volume_struct this_box_volume;
struct box_storage this_box_storage;

#line 76503 "MACS_sample_kidney_box.c"
#undef number_of_activations
#undef mask_setting
#undef mask_string
#undef p_interact
#undef focus_r
#undef focus_xh
#undef focus_xw
#undef focus_ah
#undef focus_aw
#undef target_z
#undef target_y
#undef target_x
#undef target_index
#undef visualize
#undef yheight2
#undef xwidth2
#undef zdepth
#undef yheight
#undef xwidth
#undef priority
#undef material_string
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

/* User declarations for component 'inter_analyzer_colimator_center_16' [762]. */
#define mccompcurname  inter_analyzer_colimator_center_16
#define mccompcurtype  Arm
#define mccompcurindex 762
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

/* User declarations for component 'inter_analyzer_colimator_16_blade_0' [763]. */
#define mccompcurname  inter_analyzer_colimator_16_blade_0
#define mccompcurtype  Union_box
#define mccompcurindex 763
#define loop_index mccinter_analyzer_colimator_16_blade_0_loop_index
#define this_box_volume mccinter_analyzer_colimator_16_blade_0_this_box_volume
#define global_geometry_element mccinter_analyzer_colimator_16_blade_0_global_geometry_element
#define this_box_storage mccinter_analyzer_colimator_16_blade_0_this_box_storage
#define material_string mccinter_analyzer_colimator_16_blade_0_material_string
#define priority mccinter_analyzer_colimator_16_blade_0_priority
#define xwidth mccinter_analyzer_colimator_16_blade_0_xwidth
#define yheight mccinter_analyzer_colimator_16_blade_0_yheight
#define zdepth mccinter_analyzer_colimator_16_blade_0_zdepth
#define xwidth2 mccinter_analyzer_colimator_16_blade_0_xwidth2
#define yheight2 mccinter_analyzer_colimator_16_blade_0_yheight2
#define visualize mccinter_analyzer_colimator_16_blade_0_visualize
#define target_index mccinter_analyzer_colimator_16_blade_0_target_index
#define target_x mccinter_analyzer_colimator_16_blade_0_target_x
#define target_y mccinter_analyzer_colimator_16_blade_0_target_y
#define target_z mccinter_analyzer_colimator_16_blade_0_target_z
#define focus_aw mccinter_analyzer_colimator_16_blade_0_focus_aw
#define focus_ah mccinter_analyzer_colimator_16_blade_0_focus_ah
#define focus_xw mccinter_analyzer_colimator_16_blade_0_focus_xw
#define focus_xh mccinter_analyzer_colimator_16_blade_0_focus_xh
#define focus_r mccinter_analyzer_colimator_16_blade_0_focus_r
#define p_interact mccinter_analyzer_colimator_16_blade_0_p_interact
#define mask_string mccinter_analyzer_colimator_16_blade_0_mask_string
#define mask_setting mccinter_analyzer_colimator_16_blade_0_mask_setting
#define number_of_activations mccinter_analyzer_colimator_16_blade_0_number_of_activations
#line 204 "Union_box.comp"
// Needed for transport to the main component
struct global_geometry_element_struct global_geometry_element;

#ifndef ANY_GEOMETRY_DETECTOR_DECLARE
    #define ANY_GEOMETRY_DETECTOR_DECLARE dummy
	//struct pointer_to_global_geometry_list global_geometry_list = {0,NULL};
#endif

int loop_index,found_geometries;

double x_component;
double y_component;
double z_component;

struct Volume_struct this_box_volume;
struct box_storage this_box_storage;

#line 76588 "MACS_sample_kidney_box.c"
#undef number_of_activations
#undef mask_setting
#undef mask_string
#undef p_interact
#undef focus_r
#undef focus_xh
#undef focus_xw
#undef focus_ah
#undef focus_aw
#undef target_z
#undef target_y
#undef target_x
#undef target_index
#undef visualize
#undef yheight2
#undef xwidth2
#undef zdepth
#undef yheight
#undef xwidth
#undef priority
#undef material_string
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

/* User declarations for component 'inter_analyzer_colimator_16_blade_1' [764]. */
#define mccompcurname  inter_analyzer_colimator_16_blade_1
#define mccompcurtype  Union_box
#define mccompcurindex 764
#define loop_index mccinter_analyzer_colimator_16_blade_1_loop_index
#define this_box_volume mccinter_analyzer_colimator_16_blade_1_this_box_volume
#define global_geometry_element mccinter_analyzer_colimator_16_blade_1_global_geometry_element
#define this_box_storage mccinter_analyzer_colimator_16_blade_1_this_box_storage
#define material_string mccinter_analyzer_colimator_16_blade_1_material_string
#define priority mccinter_analyzer_colimator_16_blade_1_priority
#define xwidth mccinter_analyzer_colimator_16_blade_1_xwidth
#define yheight mccinter_analyzer_colimator_16_blade_1_yheight
#define zdepth mccinter_analyzer_colimator_16_blade_1_zdepth
#define xwidth2 mccinter_analyzer_colimator_16_blade_1_xwidth2
#define yheight2 mccinter_analyzer_colimator_16_blade_1_yheight2
#define visualize mccinter_analyzer_colimator_16_blade_1_visualize
#define target_index mccinter_analyzer_colimator_16_blade_1_target_index
#define target_x mccinter_analyzer_colimator_16_blade_1_target_x
#define target_y mccinter_analyzer_colimator_16_blade_1_target_y
#define target_z mccinter_analyzer_colimator_16_blade_1_target_z
#define focus_aw mccinter_analyzer_colimator_16_blade_1_focus_aw
#define focus_ah mccinter_analyzer_colimator_16_blade_1_focus_ah
#define focus_xw mccinter_analyzer_colimator_16_blade_1_focus_xw
#define focus_xh mccinter_analyzer_colimator_16_blade_1_focus_xh
#define focus_r mccinter_analyzer_colimator_16_blade_1_focus_r
#define p_interact mccinter_analyzer_colimator_16_blade_1_p_interact
#define mask_string mccinter_analyzer_colimator_16_blade_1_mask_string
#define mask_setting mccinter_analyzer_colimator_16_blade_1_mask_setting
#define number_of_activations mccinter_analyzer_colimator_16_blade_1_number_of_activations
#line 204 "Union_box.comp"
// Needed for transport to the main component
struct global_geometry_element_struct global_geometry_element;

#ifndef ANY_GEOMETRY_DETECTOR_DECLARE
    #define ANY_GEOMETRY_DETECTOR_DECLARE dummy
	//struct pointer_to_global_geometry_list global_geometry_list = {0,NULL};
#endif

int loop_index,found_geometries;

double x_component;
double y_component;
double z_component;

struct Volume_struct this_box_volume;
struct box_storage this_box_storage;

#line 76665 "MACS_sample_kidney_box.c"
#undef number_of_activations
#undef mask_setting
#undef mask_string
#undef p_interact
#undef focus_r
#undef focus_xh
#undef focus_xw
#undef focus_ah
#undef focus_aw
#undef target_z
#undef target_y
#undef target_x
#undef target_index
#undef visualize
#undef yheight2
#undef xwidth2
#undef zdepth
#undef yheight
#undef xwidth
#undef priority
#undef material_string
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

/* User declarations for component 'inter_analyzer_colimator_16_blade_2' [765]. */
#define mccompcurname  inter_analyzer_colimator_16_blade_2
#define mccompcurtype  Union_box
#define mccompcurindex 765
#define loop_index mccinter_analyzer_colimator_16_blade_2_loop_index
#define this_box_volume mccinter_analyzer_colimator_16_blade_2_this_box_volume
#define global_geometry_element mccinter_analyzer_colimator_16_blade_2_global_geometry_element
#define this_box_storage mccinter_analyzer_colimator_16_blade_2_this_box_storage
#define material_string mccinter_analyzer_colimator_16_blade_2_material_string
#define priority mccinter_analyzer_colimator_16_blade_2_priority
#define xwidth mccinter_analyzer_colimator_16_blade_2_xwidth
#define yheight mccinter_analyzer_colimator_16_blade_2_yheight
#define zdepth mccinter_analyzer_colimator_16_blade_2_zdepth
#define xwidth2 mccinter_analyzer_colimator_16_blade_2_xwidth2
#define yheight2 mccinter_analyzer_colimator_16_blade_2_yheight2
#define visualize mccinter_analyzer_colimator_16_blade_2_visualize
#define target_index mccinter_analyzer_colimator_16_blade_2_target_index
#define target_x mccinter_analyzer_colimator_16_blade_2_target_x
#define target_y mccinter_analyzer_colimator_16_blade_2_target_y
#define target_z mccinter_analyzer_colimator_16_blade_2_target_z
#define focus_aw mccinter_analyzer_colimator_16_blade_2_focus_aw
#define focus_ah mccinter_analyzer_colimator_16_blade_2_focus_ah
#define focus_xw mccinter_analyzer_colimator_16_blade_2_focus_xw
#define focus_xh mccinter_analyzer_colimator_16_blade_2_focus_xh
#define focus_r mccinter_analyzer_colimator_16_blade_2_focus_r
#define p_interact mccinter_analyzer_colimator_16_blade_2_p_interact
#define mask_string mccinter_analyzer_colimator_16_blade_2_mask_string
#define mask_setting mccinter_analyzer_colimator_16_blade_2_mask_setting
#define number_of_activations mccinter_analyzer_colimator_16_blade_2_number_of_activations
#line 204 "Union_box.comp"
// Needed for transport to the main component
struct global_geometry_element_struct global_geometry_element;

#ifndef ANY_GEOMETRY_DETECTOR_DECLARE
    #define ANY_GEOMETRY_DETECTOR_DECLARE dummy
	//struct pointer_to_global_geometry_list global_geometry_list = {0,NULL};
#endif

int loop_index,found_geometries;

double x_component;
double y_component;
double z_component;

struct Volume_struct this_box_volume;
struct box_storage this_box_storage;

#line 76742 "MACS_sample_kidney_box.c"
#undef number_of_activations
#undef mask_setting
#undef mask_string
#undef p_interact
#undef focus_r
#undef focus_xh
#undef focus_xw
#undef focus_ah
#undef focus_aw
#undef target_z
#undef target_y
#undef target_x
#undef target_index
#undef visualize
#undef yheight2
#undef xwidth2
#undef zdepth
#undef yheight
#undef xwidth
#undef priority
#undef material_string
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

/* User declarations for component 'inter_analyzer_colimator_16_blade_3' [766]. */
#define mccompcurname  inter_analyzer_colimator_16_blade_3
#define mccompcurtype  Union_box
#define mccompcurindex 766
#define loop_index mccinter_analyzer_colimator_16_blade_3_loop_index
#define this_box_volume mccinter_analyzer_colimator_16_blade_3_this_box_volume
#define global_geometry_element mccinter_analyzer_colimator_16_blade_3_global_geometry_element
#define this_box_storage mccinter_analyzer_colimator_16_blade_3_this_box_storage
#define material_string mccinter_analyzer_colimator_16_blade_3_material_string
#define priority mccinter_analyzer_colimator_16_blade_3_priority
#define xwidth mccinter_analyzer_colimator_16_blade_3_xwidth
#define yheight mccinter_analyzer_colimator_16_blade_3_yheight
#define zdepth mccinter_analyzer_colimator_16_blade_3_zdepth
#define xwidth2 mccinter_analyzer_colimator_16_blade_3_xwidth2
#define yheight2 mccinter_analyzer_colimator_16_blade_3_yheight2
#define visualize mccinter_analyzer_colimator_16_blade_3_visualize
#define target_index mccinter_analyzer_colimator_16_blade_3_target_index
#define target_x mccinter_analyzer_colimator_16_blade_3_target_x
#define target_y mccinter_analyzer_colimator_16_blade_3_target_y
#define target_z mccinter_analyzer_colimator_16_blade_3_target_z
#define focus_aw mccinter_analyzer_colimator_16_blade_3_focus_aw
#define focus_ah mccinter_analyzer_colimator_16_blade_3_focus_ah
#define focus_xw mccinter_analyzer_colimator_16_blade_3_focus_xw
#define focus_xh mccinter_analyzer_colimator_16_blade_3_focus_xh
#define focus_r mccinter_analyzer_colimator_16_blade_3_focus_r
#define p_interact mccinter_analyzer_colimator_16_blade_3_p_interact
#define mask_string mccinter_analyzer_colimator_16_blade_3_mask_string
#define mask_setting mccinter_analyzer_colimator_16_blade_3_mask_setting
#define number_of_activations mccinter_analyzer_colimator_16_blade_3_number_of_activations
#line 204 "Union_box.comp"
// Needed for transport to the main component
struct global_geometry_element_struct global_geometry_element;

#ifndef ANY_GEOMETRY_DETECTOR_DECLARE
    #define ANY_GEOMETRY_DETECTOR_DECLARE dummy
	//struct pointer_to_global_geometry_list global_geometry_list = {0,NULL};
#endif

int loop_index,found_geometries;

double x_component;
double y_component;
double z_component;

struct Volume_struct this_box_volume;
struct box_storage this_box_storage;

#line 76819 "MACS_sample_kidney_box.c"
#undef number_of_activations
#undef mask_setting
#undef mask_string
#undef p_interact
#undef focus_r
#undef focus_xh
#undef focus_xw
#undef focus_ah
#undef focus_aw
#undef target_z
#undef target_y
#undef target_x
#undef target_index
#undef visualize
#undef yheight2
#undef xwidth2
#undef zdepth
#undef yheight
#undef xwidth
#undef priority
#undef material_string
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

/* User declarations for component 'inter_analyzer_colimator_16_blade_4' [767]. */
#define mccompcurname  inter_analyzer_colimator_16_blade_4
#define mccompcurtype  Union_box
#define mccompcurindex 767
#define loop_index mccinter_analyzer_colimator_16_blade_4_loop_index
#define this_box_volume mccinter_analyzer_colimator_16_blade_4_this_box_volume
#define global_geometry_element mccinter_analyzer_colimator_16_blade_4_global_geometry_element
#define this_box_storage mccinter_analyzer_colimator_16_blade_4_this_box_storage
#define material_string mccinter_analyzer_colimator_16_blade_4_material_string
#define priority mccinter_analyzer_colimator_16_blade_4_priority
#define xwidth mccinter_analyzer_colimator_16_blade_4_xwidth
#define yheight mccinter_analyzer_colimator_16_blade_4_yheight
#define zdepth mccinter_analyzer_colimator_16_blade_4_zdepth
#define xwidth2 mccinter_analyzer_colimator_16_blade_4_xwidth2
#define yheight2 mccinter_analyzer_colimator_16_blade_4_yheight2
#define visualize mccinter_analyzer_colimator_16_blade_4_visualize
#define target_index mccinter_analyzer_colimator_16_blade_4_target_index
#define target_x mccinter_analyzer_colimator_16_blade_4_target_x
#define target_y mccinter_analyzer_colimator_16_blade_4_target_y
#define target_z mccinter_analyzer_colimator_16_blade_4_target_z
#define focus_aw mccinter_analyzer_colimator_16_blade_4_focus_aw
#define focus_ah mccinter_analyzer_colimator_16_blade_4_focus_ah
#define focus_xw mccinter_analyzer_colimator_16_blade_4_focus_xw
#define focus_xh mccinter_analyzer_colimator_16_blade_4_focus_xh
#define focus_r mccinter_analyzer_colimator_16_blade_4_focus_r
#define p_interact mccinter_analyzer_colimator_16_blade_4_p_interact
#define mask_string mccinter_analyzer_colimator_16_blade_4_mask_string
#define mask_setting mccinter_analyzer_colimator_16_blade_4_mask_setting
#define number_of_activations mccinter_analyzer_colimator_16_blade_4_number_of_activations
#line 204 "Union_box.comp"
// Needed for transport to the main component
struct global_geometry_element_struct global_geometry_element;

#ifndef ANY_GEOMETRY_DETECTOR_DECLARE
    #define ANY_GEOMETRY_DETECTOR_DECLARE dummy
	//struct pointer_to_global_geometry_list global_geometry_list = {0,NULL};
#endif

int loop_index,found_geometries;

double x_component;
double y_component;
double z_component;

struct Volume_struct this_box_volume;
struct box_storage this_box_storage;

#line 76896 "MACS_sample_kidney_box.c"
#undef number_of_activations
#undef mask_setting
#undef mask_string
#undef p_interact
#undef focus_r
#undef focus_xh
#undef focus_xw
#undef focus_ah
#undef focus_aw
#undef target_z
#undef target_y
#undef target_x
#undef target_index
#undef visualize
#undef yheight2
#undef xwidth2
#undef zdepth
#undef yheight
#undef xwidth
#undef priority
#undef material_string
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

/* User declarations for component 'diffraction_detector_16_exit_volume' [768]. */
#define mccompcurname  diffraction_detector_16_exit_volume
#define mccompcurtype  Union_box
#define mccompcurindex 768
#define loop_index mccdiffraction_detector_16_exit_volume_loop_index
#define this_box_volume mccdiffraction_detector_16_exit_volume_this_box_volume
#define global_geometry_element mccdiffraction_detector_16_exit_volume_global_geometry_element
#define this_box_storage mccdiffraction_detector_16_exit_volume_this_box_storage
#define material_string mccdiffraction_detector_16_exit_volume_material_string
#define priority mccdiffraction_detector_16_exit_volume_priority
#define xwidth mccdiffraction_detector_16_exit_volume_xwidth
#define yheight mccdiffraction_detector_16_exit_volume_yheight
#define zdepth mccdiffraction_detector_16_exit_volume_zdepth
#define xwidth2 mccdiffraction_detector_16_exit_volume_xwidth2
#define yheight2 mccdiffraction_detector_16_exit_volume_yheight2
#define visualize mccdiffraction_detector_16_exit_volume_visualize
#define target_index mccdiffraction_detector_16_exit_volume_target_index
#define target_x mccdiffraction_detector_16_exit_volume_target_x
#define target_y mccdiffraction_detector_16_exit_volume_target_y
#define target_z mccdiffraction_detector_16_exit_volume_target_z
#define focus_aw mccdiffraction_detector_16_exit_volume_focus_aw
#define focus_ah mccdiffraction_detector_16_exit_volume_focus_ah
#define focus_xw mccdiffraction_detector_16_exit_volume_focus_xw
#define focus_xh mccdiffraction_detector_16_exit_volume_focus_xh
#define focus_r mccdiffraction_detector_16_exit_volume_focus_r
#define p_interact mccdiffraction_detector_16_exit_volume_p_interact
#define mask_string mccdiffraction_detector_16_exit_volume_mask_string
#define mask_setting mccdiffraction_detector_16_exit_volume_mask_setting
#define number_of_activations mccdiffraction_detector_16_exit_volume_number_of_activations
#line 204 "Union_box.comp"
// Needed for transport to the main component
struct global_geometry_element_struct global_geometry_element;

#ifndef ANY_GEOMETRY_DETECTOR_DECLARE
    #define ANY_GEOMETRY_DETECTOR_DECLARE dummy
	//struct pointer_to_global_geometry_list global_geometry_list = {0,NULL};
#endif

int loop_index,found_geometries;

double x_component;
double y_component;
double z_component;

struct Volume_struct this_box_volume;
struct box_storage this_box_storage;

#line 76973 "MACS_sample_kidney_box.c"
#undef number_of_activations
#undef mask_setting
#undef mask_string
#undef p_interact
#undef focus_r
#undef focus_xh
#undef focus_xw
#undef focus_ah
#undef focus_aw
#undef target_z
#undef target_y
#undef target_x
#undef target_index
#undef visualize
#undef yheight2
#undef xwidth2
#undef zdepth
#undef yheight
#undef xwidth
#undef priority
#undef material_string
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

/* User declarations for component 'spec_detector_16_exit_volume' [769]. */
#define mccompcurname  spec_detector_16_exit_volume
#define mccompcurtype  Union_box
#define mccompcurindex 769
#define loop_index mccspec_detector_16_exit_volume_loop_index
#define this_box_volume mccspec_detector_16_exit_volume_this_box_volume
#define global_geometry_element mccspec_detector_16_exit_volume_global_geometry_element
#define this_box_storage mccspec_detector_16_exit_volume_this_box_storage
#define material_string mccspec_detector_16_exit_volume_material_string
#define priority mccspec_detector_16_exit_volume_priority
#define xwidth mccspec_detector_16_exit_volume_xwidth
#define yheight mccspec_detector_16_exit_volume_yheight
#define zdepth mccspec_detector_16_exit_volume_zdepth
#define xwidth2 mccspec_detector_16_exit_volume_xwidth2
#define yheight2 mccspec_detector_16_exit_volume_yheight2
#define visualize mccspec_detector_16_exit_volume_visualize
#define target_index mccspec_detector_16_exit_volume_target_index
#define target_x mccspec_detector_16_exit_volume_target_x
#define target_y mccspec_detector_16_exit_volume_target_y
#define target_z mccspec_detector_16_exit_volume_target_z
#define focus_aw mccspec_detector_16_exit_volume_focus_aw
#define focus_ah mccspec_detector_16_exit_volume_focus_ah
#define focus_xw mccspec_detector_16_exit_volume_focus_xw
#define focus_xh mccspec_detector_16_exit_volume_focus_xh
#define focus_r mccspec_detector_16_exit_volume_focus_r
#define p_interact mccspec_detector_16_exit_volume_p_interact
#define mask_string mccspec_detector_16_exit_volume_mask_string
#define mask_setting mccspec_detector_16_exit_volume_mask_setting
#define number_of_activations mccspec_detector_16_exit_volume_number_of_activations
#line 204 "Union_box.comp"
// Needed for transport to the main component
struct global_geometry_element_struct global_geometry_element;

#ifndef ANY_GEOMETRY_DETECTOR_DECLARE
    #define ANY_GEOMETRY_DETECTOR_DECLARE dummy
	//struct pointer_to_global_geometry_list global_geometry_list = {0,NULL};
#endif

int loop_index,found_geometries;

double x_component;
double y_component;
double z_component;

struct Volume_struct this_box_volume;
struct box_storage this_box_storage;

#line 77050 "MACS_sample_kidney_box.c"
#undef number_of_activations
#undef mask_setting
#undef mask_string
#undef p_interact
#undef focus_r
#undef focus_xh
#undef focus_xw
#undef focus_ah
#undef focus_aw
#undef target_z
#undef target_y
#undef target_x
#undef target_index
#undef visualize
#undef yheight2
#undef xwidth2
#undef zdepth
#undef yheight
#undef xwidth
#undef priority
#undef material_string
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

/* User declarations for component 'channel_17_cave1_box1' [770]. */
#define mccompcurname  channel_17_cave1_box1
#define mccompcurtype  Union_box
#define mccompcurindex 770
#define loop_index mccchannel_17_cave1_box1_loop_index
#define this_box_volume mccchannel_17_cave1_box1_this_box_volume
#define global_geometry_element mccchannel_17_cave1_box1_global_geometry_element
#define this_box_storage mccchannel_17_cave1_box1_this_box_storage
#define material_string mccchannel_17_cave1_box1_material_string
#define priority mccchannel_17_cave1_box1_priority
#define xwidth mccchannel_17_cave1_box1_xwidth
#define yheight mccchannel_17_cave1_box1_yheight
#define zdepth mccchannel_17_cave1_box1_zdepth
#define xwidth2 mccchannel_17_cave1_box1_xwidth2
#define yheight2 mccchannel_17_cave1_box1_yheight2
#define visualize mccchannel_17_cave1_box1_visualize
#define target_index mccchannel_17_cave1_box1_target_index
#define target_x mccchannel_17_cave1_box1_target_x
#define target_y mccchannel_17_cave1_box1_target_y
#define target_z mccchannel_17_cave1_box1_target_z
#define focus_aw mccchannel_17_cave1_box1_focus_aw
#define focus_ah mccchannel_17_cave1_box1_focus_ah
#define focus_xw mccchannel_17_cave1_box1_focus_xw
#define focus_xh mccchannel_17_cave1_box1_focus_xh
#define focus_r mccchannel_17_cave1_box1_focus_r
#define p_interact mccchannel_17_cave1_box1_p_interact
#define mask_string mccchannel_17_cave1_box1_mask_string
#define mask_setting mccchannel_17_cave1_box1_mask_setting
#define number_of_activations mccchannel_17_cave1_box1_number_of_activations
#line 204 "Union_box.comp"
// Needed for transport to the main component
struct global_geometry_element_struct global_geometry_element;

#ifndef ANY_GEOMETRY_DETECTOR_DECLARE
    #define ANY_GEOMETRY_DETECTOR_DECLARE dummy
	//struct pointer_to_global_geometry_list global_geometry_list = {0,NULL};
#endif

int loop_index,found_geometries;

double x_component;
double y_component;
double z_component;

struct Volume_struct this_box_volume;
struct box_storage this_box_storage;

#line 77127 "MACS_sample_kidney_box.c"
#undef number_of_activations
#undef mask_setting
#undef mask_string
#undef p_interact
#undef focus_r
#undef focus_xh
#undef focus_xw
#undef focus_ah
#undef focus_aw
#undef target_z
#undef target_y
#undef target_x
#undef target_index
#undef visualize
#undef yheight2
#undef xwidth2
#undef zdepth
#undef yheight
#undef xwidth
#undef priority
#undef material_string
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

/* User declarations for component 'channel_17_cave1_box2' [771]. */
#define mccompcurname  channel_17_cave1_box2
#define mccompcurtype  Union_box
#define mccompcurindex 771
#define loop_index mccchannel_17_cave1_box2_loop_index
#define this_box_volume mccchannel_17_cave1_box2_this_box_volume
#define global_geometry_element mccchannel_17_cave1_box2_global_geometry_element
#define this_box_storage mccchannel_17_cave1_box2_this_box_storage
#define material_string mccchannel_17_cave1_box2_material_string
#define priority mccchannel_17_cave1_box2_priority
#define xwidth mccchannel_17_cave1_box2_xwidth
#define yheight mccchannel_17_cave1_box2_yheight
#define zdepth mccchannel_17_cave1_box2_zdepth
#define xwidth2 mccchannel_17_cave1_box2_xwidth2
#define yheight2 mccchannel_17_cave1_box2_yheight2
#define visualize mccchannel_17_cave1_box2_visualize
#define target_index mccchannel_17_cave1_box2_target_index
#define target_x mccchannel_17_cave1_box2_target_x
#define target_y mccchannel_17_cave1_box2_target_y
#define target_z mccchannel_17_cave1_box2_target_z
#define focus_aw mccchannel_17_cave1_box2_focus_aw
#define focus_ah mccchannel_17_cave1_box2_focus_ah
#define focus_xw mccchannel_17_cave1_box2_focus_xw
#define focus_xh mccchannel_17_cave1_box2_focus_xh
#define focus_r mccchannel_17_cave1_box2_focus_r
#define p_interact mccchannel_17_cave1_box2_p_interact
#define mask_string mccchannel_17_cave1_box2_mask_string
#define mask_setting mccchannel_17_cave1_box2_mask_setting
#define number_of_activations mccchannel_17_cave1_box2_number_of_activations
#line 204 "Union_box.comp"
// Needed for transport to the main component
struct global_geometry_element_struct global_geometry_element;

#ifndef ANY_GEOMETRY_DETECTOR_DECLARE
    #define ANY_GEOMETRY_DETECTOR_DECLARE dummy
	//struct pointer_to_global_geometry_list global_geometry_list = {0,NULL};
#endif

int loop_index,found_geometries;

double x_component;
double y_component;
double z_component;

struct Volume_struct this_box_volume;
struct box_storage this_box_storage;

#line 77204 "MACS_sample_kidney_box.c"
#undef number_of_activations
#undef mask_setting
#undef mask_string
#undef p_interact
#undef focus_r
#undef focus_xh
#undef focus_xw
#undef focus_ah
#undef focus_aw
#undef target_z
#undef target_y
#undef target_x
#undef target_index
#undef visualize
#undef yheight2
#undef xwidth2
#undef zdepth
#undef yheight
#undef xwidth
#undef priority
#undef material_string
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

/* User declarations for component 'channel_17_cave1_box3' [772]. */
#define mccompcurname  channel_17_cave1_box3
#define mccompcurtype  Union_box
#define mccompcurindex 772
#define loop_index mccchannel_17_cave1_box3_loop_index
#define this_box_volume mccchannel_17_cave1_box3_this_box_volume
#define global_geometry_element mccchannel_17_cave1_box3_global_geometry_element
#define this_box_storage mccchannel_17_cave1_box3_this_box_storage
#define material_string mccchannel_17_cave1_box3_material_string
#define priority mccchannel_17_cave1_box3_priority
#define xwidth mccchannel_17_cave1_box3_xwidth
#define yheight mccchannel_17_cave1_box3_yheight
#define zdepth mccchannel_17_cave1_box3_zdepth
#define xwidth2 mccchannel_17_cave1_box3_xwidth2
#define yheight2 mccchannel_17_cave1_box3_yheight2
#define visualize mccchannel_17_cave1_box3_visualize
#define target_index mccchannel_17_cave1_box3_target_index
#define target_x mccchannel_17_cave1_box3_target_x
#define target_y mccchannel_17_cave1_box3_target_y
#define target_z mccchannel_17_cave1_box3_target_z
#define focus_aw mccchannel_17_cave1_box3_focus_aw
#define focus_ah mccchannel_17_cave1_box3_focus_ah
#define focus_xw mccchannel_17_cave1_box3_focus_xw
#define focus_xh mccchannel_17_cave1_box3_focus_xh
#define focus_r mccchannel_17_cave1_box3_focus_r
#define p_interact mccchannel_17_cave1_box3_p_interact
#define mask_string mccchannel_17_cave1_box3_mask_string
#define mask_setting mccchannel_17_cave1_box3_mask_setting
#define number_of_activations mccchannel_17_cave1_box3_number_of_activations
#line 204 "Union_box.comp"
// Needed for transport to the main component
struct global_geometry_element_struct global_geometry_element;

#ifndef ANY_GEOMETRY_DETECTOR_DECLARE
    #define ANY_GEOMETRY_DETECTOR_DECLARE dummy
	//struct pointer_to_global_geometry_list global_geometry_list = {0,NULL};
#endif

int loop_index,found_geometries;

double x_component;
double y_component;
double z_component;

struct Volume_struct this_box_volume;
struct box_storage this_box_storage;

#line 77281 "MACS_sample_kidney_box.c"
#undef number_of_activations
#undef mask_setting
#undef mask_string
#undef p_interact
#undef focus_r
#undef focus_xh
#undef focus_xw
#undef focus_ah
#undef focus_aw
#undef target_z
#undef target_y
#undef target_x
#undef target_index
#undef visualize
#undef yheight2
#undef xwidth2
#undef zdepth
#undef yheight
#undef xwidth
#undef priority
#undef material_string
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

/* User declarations for component 'channel_17_cave1_cyl1' [773]. */
#define mccompcurname  channel_17_cave1_cyl1
#define mccompcurtype  Union_cylinder
#define mccompcurindex 773
#define loop_index mccchannel_17_cave1_cyl1_loop_index
#define this_cylinder_volume mccchannel_17_cave1_cyl1_this_cylinder_volume
#define global_geometry_element mccchannel_17_cave1_cyl1_global_geometry_element
#define this_cylinder_storage mccchannel_17_cave1_cyl1_this_cylinder_storage
#define material_string mccchannel_17_cave1_cyl1_material_string
#define priority mccchannel_17_cave1_cyl1_priority
#define radius mccchannel_17_cave1_cyl1_radius
#define yheight mccchannel_17_cave1_cyl1_yheight
#define visualize mccchannel_17_cave1_cyl1_visualize
#define target_index mccchannel_17_cave1_cyl1_target_index
#define target_x mccchannel_17_cave1_cyl1_target_x
#define target_y mccchannel_17_cave1_cyl1_target_y
#define target_z mccchannel_17_cave1_cyl1_target_z
#define focus_aw mccchannel_17_cave1_cyl1_focus_aw
#define focus_ah mccchannel_17_cave1_cyl1_focus_ah
#define focus_xw mccchannel_17_cave1_cyl1_focus_xw
#define focus_xh mccchannel_17_cave1_cyl1_focus_xh
#define focus_r mccchannel_17_cave1_cyl1_focus_r
#define p_interact mccchannel_17_cave1_cyl1_p_interact
#define mask_string mccchannel_17_cave1_cyl1_mask_string
#define mask_setting mccchannel_17_cave1_cyl1_mask_setting
#define number_of_activations mccchannel_17_cave1_cyl1_number_of_activations
#line 167 "Union_cylinder.comp"
// Needed for transport to the main component
struct global_geometry_element_struct global_geometry_element;

#ifndef ANY_GEOMETRY_DETECTOR_DECLARE
    #define ANY_GEOMETRY_DETECTOR_DECLARE dummy
	//struct pointer_to_global_geometry_list global_geometry_list = {0,NULL};
#endif

int dummy;
int loop_index,found_geometries;
int loop_2_index;
int material_index;

struct Volume_struct this_cylinder_volume;
struct cylinder_storage this_cylinder_storage;
#line 77353 "MACS_sample_kidney_box.c"
#undef number_of_activations
#undef mask_setting
#undef mask_string
#undef p_interact
#undef focus_r
#undef focus_xh
#undef focus_xw
#undef focus_ah
#undef focus_aw
#undef target_z
#undef target_y
#undef target_x
#undef target_index
#undef visualize
#undef yheight
#undef radius
#undef priority
#undef material_string
#undef this_cylinder_storage
#undef global_geometry_element
#undef this_cylinder_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

/* User declarations for component 'channel_17_analyzer_1_center' [774]. */
#define mccompcurname  channel_17_analyzer_1_center
#define mccompcurtype  Arm
#define mccompcurindex 774
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

/* User declarations for component 'channel_17_analyzer_1_rotated' [775]. */
#define mccompcurname  channel_17_analyzer_1_rotated
#define mccompcurtype  Arm
#define mccompcurindex 775
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

/* User declarations for component 'channel_17_analyzer_1_array_crystal_array_0' [776]. */
#define mccompcurname  channel_17_analyzer_1_array_crystal_array_0
#define mccompcurtype  Union_box
#define mccompcurindex 776
#define loop_index mccchannel_17_analyzer_1_array_crystal_array_0_loop_index
#define this_box_volume mccchannel_17_analyzer_1_array_crystal_array_0_this_box_volume
#define global_geometry_element mccchannel_17_analyzer_1_array_crystal_array_0_global_geometry_element
#define this_box_storage mccchannel_17_analyzer_1_array_crystal_array_0_this_box_storage
#define material_string mccchannel_17_analyzer_1_array_crystal_array_0_material_string
#define priority mccchannel_17_analyzer_1_array_crystal_array_0_priority
#define xwidth mccchannel_17_analyzer_1_array_crystal_array_0_xwidth
#define yheight mccchannel_17_analyzer_1_array_crystal_array_0_yheight
#define zdepth mccchannel_17_analyzer_1_array_crystal_array_0_zdepth
#define xwidth2 mccchannel_17_analyzer_1_array_crystal_array_0_xwidth2
#define yheight2 mccchannel_17_analyzer_1_array_crystal_array_0_yheight2
#define visualize mccchannel_17_analyzer_1_array_crystal_array_0_visualize
#define target_index mccchannel_17_analyzer_1_array_crystal_array_0_target_index
#define target_x mccchannel_17_analyzer_1_array_crystal_array_0_target_x
#define target_y mccchannel_17_analyzer_1_array_crystal_array_0_target_y
#define target_z mccchannel_17_analyzer_1_array_crystal_array_0_target_z
#define focus_aw mccchannel_17_analyzer_1_array_crystal_array_0_focus_aw
#define focus_ah mccchannel_17_analyzer_1_array_crystal_array_0_focus_ah
#define focus_xw mccchannel_17_analyzer_1_array_crystal_array_0_focus_xw
#define focus_xh mccchannel_17_analyzer_1_array_crystal_array_0_focus_xh
#define focus_r mccchannel_17_analyzer_1_array_crystal_array_0_focus_r
#define p_interact mccchannel_17_analyzer_1_array_crystal_array_0_p_interact
#define mask_string mccchannel_17_analyzer_1_array_crystal_array_0_mask_string
#define mask_setting mccchannel_17_analyzer_1_array_crystal_array_0_mask_setting
#define number_of_activations mccchannel_17_analyzer_1_array_crystal_array_0_number_of_activations
#line 204 "Union_box.comp"
// Needed for transport to the main component
struct global_geometry_element_struct global_geometry_element;

#ifndef ANY_GEOMETRY_DETECTOR_DECLARE
    #define ANY_GEOMETRY_DETECTOR_DECLARE dummy
	//struct pointer_to_global_geometry_list global_geometry_list = {0,NULL};
#endif

int loop_index,found_geometries;

double x_component;
double y_component;
double z_component;

struct Volume_struct this_box_volume;
struct box_storage this_box_storage;

#line 77443 "MACS_sample_kidney_box.c"
#undef number_of_activations
#undef mask_setting
#undef mask_string
#undef p_interact
#undef focus_r
#undef focus_xh
#undef focus_xw
#undef focus_ah
#undef focus_aw
#undef target_z
#undef target_y
#undef target_x
#undef target_index
#undef visualize
#undef yheight2
#undef xwidth2
#undef zdepth
#undef yheight
#undef xwidth
#undef priority
#undef material_string
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

/* User declarations for component 'channel_17_analyzer_1_array_crystal_array_1' [777]. */
#define mccompcurname  channel_17_analyzer_1_array_crystal_array_1
#define mccompcurtype  Union_box
#define mccompcurindex 777
#define loop_index mccchannel_17_analyzer_1_array_crystal_array_1_loop_index
#define this_box_volume mccchannel_17_analyzer_1_array_crystal_array_1_this_box_volume
#define global_geometry_element mccchannel_17_analyzer_1_array_crystal_array_1_global_geometry_element
#define this_box_storage mccchannel_17_analyzer_1_array_crystal_array_1_this_box_storage
#define material_string mccchannel_17_analyzer_1_array_crystal_array_1_material_string
#define priority mccchannel_17_analyzer_1_array_crystal_array_1_priority
#define xwidth mccchannel_17_analyzer_1_array_crystal_array_1_xwidth
#define yheight mccchannel_17_analyzer_1_array_crystal_array_1_yheight
#define zdepth mccchannel_17_analyzer_1_array_crystal_array_1_zdepth
#define xwidth2 mccchannel_17_analyzer_1_array_crystal_array_1_xwidth2
#define yheight2 mccchannel_17_analyzer_1_array_crystal_array_1_yheight2
#define visualize mccchannel_17_analyzer_1_array_crystal_array_1_visualize
#define target_index mccchannel_17_analyzer_1_array_crystal_array_1_target_index
#define target_x mccchannel_17_analyzer_1_array_crystal_array_1_target_x
#define target_y mccchannel_17_analyzer_1_array_crystal_array_1_target_y
#define target_z mccchannel_17_analyzer_1_array_crystal_array_1_target_z
#define focus_aw mccchannel_17_analyzer_1_array_crystal_array_1_focus_aw
#define focus_ah mccchannel_17_analyzer_1_array_crystal_array_1_focus_ah
#define focus_xw mccchannel_17_analyzer_1_array_crystal_array_1_focus_xw
#define focus_xh mccchannel_17_analyzer_1_array_crystal_array_1_focus_xh
#define focus_r mccchannel_17_analyzer_1_array_crystal_array_1_focus_r
#define p_interact mccchannel_17_analyzer_1_array_crystal_array_1_p_interact
#define mask_string mccchannel_17_analyzer_1_array_crystal_array_1_mask_string
#define mask_setting mccchannel_17_analyzer_1_array_crystal_array_1_mask_setting
#define number_of_activations mccchannel_17_analyzer_1_array_crystal_array_1_number_of_activations
#line 204 "Union_box.comp"
// Needed for transport to the main component
struct global_geometry_element_struct global_geometry_element;

#ifndef ANY_GEOMETRY_DETECTOR_DECLARE
    #define ANY_GEOMETRY_DETECTOR_DECLARE dummy
	//struct pointer_to_global_geometry_list global_geometry_list = {0,NULL};
#endif

int loop_index,found_geometries;

double x_component;
double y_component;
double z_component;

struct Volume_struct this_box_volume;
struct box_storage this_box_storage;

#line 77520 "MACS_sample_kidney_box.c"
#undef number_of_activations
#undef mask_setting
#undef mask_string
#undef p_interact
#undef focus_r
#undef focus_xh
#undef focus_xw
#undef focus_ah
#undef focus_aw
#undef target_z
#undef target_y
#undef target_x
#undef target_index
#undef visualize
#undef yheight2
#undef xwidth2
#undef zdepth
#undef yheight
#undef xwidth
#undef priority
#undef material_string
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

/* User declarations for component 'channel_17_analyzer_1_array_crystal_array_2' [778]. */
#define mccompcurname  channel_17_analyzer_1_array_crystal_array_2
#define mccompcurtype  Union_box
#define mccompcurindex 778
#define loop_index mccchannel_17_analyzer_1_array_crystal_array_2_loop_index
#define this_box_volume mccchannel_17_analyzer_1_array_crystal_array_2_this_box_volume
#define global_geometry_element mccchannel_17_analyzer_1_array_crystal_array_2_global_geometry_element
#define this_box_storage mccchannel_17_analyzer_1_array_crystal_array_2_this_box_storage
#define material_string mccchannel_17_analyzer_1_array_crystal_array_2_material_string
#define priority mccchannel_17_analyzer_1_array_crystal_array_2_priority
#define xwidth mccchannel_17_analyzer_1_array_crystal_array_2_xwidth
#define yheight mccchannel_17_analyzer_1_array_crystal_array_2_yheight
#define zdepth mccchannel_17_analyzer_1_array_crystal_array_2_zdepth
#define xwidth2 mccchannel_17_analyzer_1_array_crystal_array_2_xwidth2
#define yheight2 mccchannel_17_analyzer_1_array_crystal_array_2_yheight2
#define visualize mccchannel_17_analyzer_1_array_crystal_array_2_visualize
#define target_index mccchannel_17_analyzer_1_array_crystal_array_2_target_index
#define target_x mccchannel_17_analyzer_1_array_crystal_array_2_target_x
#define target_y mccchannel_17_analyzer_1_array_crystal_array_2_target_y
#define target_z mccchannel_17_analyzer_1_array_crystal_array_2_target_z
#define focus_aw mccchannel_17_analyzer_1_array_crystal_array_2_focus_aw
#define focus_ah mccchannel_17_analyzer_1_array_crystal_array_2_focus_ah
#define focus_xw mccchannel_17_analyzer_1_array_crystal_array_2_focus_xw
#define focus_xh mccchannel_17_analyzer_1_array_crystal_array_2_focus_xh
#define focus_r mccchannel_17_analyzer_1_array_crystal_array_2_focus_r
#define p_interact mccchannel_17_analyzer_1_array_crystal_array_2_p_interact
#define mask_string mccchannel_17_analyzer_1_array_crystal_array_2_mask_string
#define mask_setting mccchannel_17_analyzer_1_array_crystal_array_2_mask_setting
#define number_of_activations mccchannel_17_analyzer_1_array_crystal_array_2_number_of_activations
#line 204 "Union_box.comp"
// Needed for transport to the main component
struct global_geometry_element_struct global_geometry_element;

#ifndef ANY_GEOMETRY_DETECTOR_DECLARE
    #define ANY_GEOMETRY_DETECTOR_DECLARE dummy
	//struct pointer_to_global_geometry_list global_geometry_list = {0,NULL};
#endif

int loop_index,found_geometries;

double x_component;
double y_component;
double z_component;

struct Volume_struct this_box_volume;
struct box_storage this_box_storage;

#line 77597 "MACS_sample_kidney_box.c"
#undef number_of_activations
#undef mask_setting
#undef mask_string
#undef p_interact
#undef focus_r
#undef focus_xh
#undef focus_xw
#undef focus_ah
#undef focus_aw
#undef target_z
#undef target_y
#undef target_x
#undef target_index
#undef visualize
#undef yheight2
#undef xwidth2
#undef zdepth
#undef yheight
#undef xwidth
#undef priority
#undef material_string
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

/* User declarations for component 'channel_17_analyzer_1_array_crystal_array_3' [779]. */
#define mccompcurname  channel_17_analyzer_1_array_crystal_array_3
#define mccompcurtype  Union_box
#define mccompcurindex 779
#define loop_index mccchannel_17_analyzer_1_array_crystal_array_3_loop_index
#define this_box_volume mccchannel_17_analyzer_1_array_crystal_array_3_this_box_volume
#define global_geometry_element mccchannel_17_analyzer_1_array_crystal_array_3_global_geometry_element
#define this_box_storage mccchannel_17_analyzer_1_array_crystal_array_3_this_box_storage
#define material_string mccchannel_17_analyzer_1_array_crystal_array_3_material_string
#define priority mccchannel_17_analyzer_1_array_crystal_array_3_priority
#define xwidth mccchannel_17_analyzer_1_array_crystal_array_3_xwidth
#define yheight mccchannel_17_analyzer_1_array_crystal_array_3_yheight
#define zdepth mccchannel_17_analyzer_1_array_crystal_array_3_zdepth
#define xwidth2 mccchannel_17_analyzer_1_array_crystal_array_3_xwidth2
#define yheight2 mccchannel_17_analyzer_1_array_crystal_array_3_yheight2
#define visualize mccchannel_17_analyzer_1_array_crystal_array_3_visualize
#define target_index mccchannel_17_analyzer_1_array_crystal_array_3_target_index
#define target_x mccchannel_17_analyzer_1_array_crystal_array_3_target_x
#define target_y mccchannel_17_analyzer_1_array_crystal_array_3_target_y
#define target_z mccchannel_17_analyzer_1_array_crystal_array_3_target_z
#define focus_aw mccchannel_17_analyzer_1_array_crystal_array_3_focus_aw
#define focus_ah mccchannel_17_analyzer_1_array_crystal_array_3_focus_ah
#define focus_xw mccchannel_17_analyzer_1_array_crystal_array_3_focus_xw
#define focus_xh mccchannel_17_analyzer_1_array_crystal_array_3_focus_xh
#define focus_r mccchannel_17_analyzer_1_array_crystal_array_3_focus_r
#define p_interact mccchannel_17_analyzer_1_array_crystal_array_3_p_interact
#define mask_string mccchannel_17_analyzer_1_array_crystal_array_3_mask_string
#define mask_setting mccchannel_17_analyzer_1_array_crystal_array_3_mask_setting
#define number_of_activations mccchannel_17_analyzer_1_array_crystal_array_3_number_of_activations
#line 204 "Union_box.comp"
// Needed for transport to the main component
struct global_geometry_element_struct global_geometry_element;

#ifndef ANY_GEOMETRY_DETECTOR_DECLARE
    #define ANY_GEOMETRY_DETECTOR_DECLARE dummy
	//struct pointer_to_global_geometry_list global_geometry_list = {0,NULL};
#endif

int loop_index,found_geometries;

double x_component;
double y_component;
double z_component;

struct Volume_struct this_box_volume;
struct box_storage this_box_storage;

#line 77674 "MACS_sample_kidney_box.c"
#undef number_of_activations
#undef mask_setting
#undef mask_string
#undef p_interact
#undef focus_r
#undef focus_xh
#undef focus_xw
#undef focus_ah
#undef focus_aw
#undef target_z
#undef target_y
#undef target_x
#undef target_index
#undef visualize
#undef yheight2
#undef xwidth2
#undef zdepth
#undef yheight
#undef xwidth
#undef priority
#undef material_string
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

/* User declarations for component 'channel_17_analyzer_1_array_crystal_array_4' [780]. */
#define mccompcurname  channel_17_analyzer_1_array_crystal_array_4
#define mccompcurtype  Union_box
#define mccompcurindex 780
#define loop_index mccchannel_17_analyzer_1_array_crystal_array_4_loop_index
#define this_box_volume mccchannel_17_analyzer_1_array_crystal_array_4_this_box_volume
#define global_geometry_element mccchannel_17_analyzer_1_array_crystal_array_4_global_geometry_element
#define this_box_storage mccchannel_17_analyzer_1_array_crystal_array_4_this_box_storage
#define material_string mccchannel_17_analyzer_1_array_crystal_array_4_material_string
#define priority mccchannel_17_analyzer_1_array_crystal_array_4_priority
#define xwidth mccchannel_17_analyzer_1_array_crystal_array_4_xwidth
#define yheight mccchannel_17_analyzer_1_array_crystal_array_4_yheight
#define zdepth mccchannel_17_analyzer_1_array_crystal_array_4_zdepth
#define xwidth2 mccchannel_17_analyzer_1_array_crystal_array_4_xwidth2
#define yheight2 mccchannel_17_analyzer_1_array_crystal_array_4_yheight2
#define visualize mccchannel_17_analyzer_1_array_crystal_array_4_visualize
#define target_index mccchannel_17_analyzer_1_array_crystal_array_4_target_index
#define target_x mccchannel_17_analyzer_1_array_crystal_array_4_target_x
#define target_y mccchannel_17_analyzer_1_array_crystal_array_4_target_y
#define target_z mccchannel_17_analyzer_1_array_crystal_array_4_target_z
#define focus_aw mccchannel_17_analyzer_1_array_crystal_array_4_focus_aw
#define focus_ah mccchannel_17_analyzer_1_array_crystal_array_4_focus_ah
#define focus_xw mccchannel_17_analyzer_1_array_crystal_array_4_focus_xw
#define focus_xh mccchannel_17_analyzer_1_array_crystal_array_4_focus_xh
#define focus_r mccchannel_17_analyzer_1_array_crystal_array_4_focus_r
#define p_interact mccchannel_17_analyzer_1_array_crystal_array_4_p_interact
#define mask_string mccchannel_17_analyzer_1_array_crystal_array_4_mask_string
#define mask_setting mccchannel_17_analyzer_1_array_crystal_array_4_mask_setting
#define number_of_activations mccchannel_17_analyzer_1_array_crystal_array_4_number_of_activations
#line 204 "Union_box.comp"
// Needed for transport to the main component
struct global_geometry_element_struct global_geometry_element;

#ifndef ANY_GEOMETRY_DETECTOR_DECLARE
    #define ANY_GEOMETRY_DETECTOR_DECLARE dummy
	//struct pointer_to_global_geometry_list global_geometry_list = {0,NULL};
#endif

int loop_index,found_geometries;

double x_component;
double y_component;
double z_component;

struct Volume_struct this_box_volume;
struct box_storage this_box_storage;

#line 77751 "MACS_sample_kidney_box.c"
#undef number_of_activations
#undef mask_setting
#undef mask_string
#undef p_interact
#undef focus_r
#undef focus_xh
#undef focus_xw
#undef focus_ah
#undef focus_aw
#undef target_z
#undef target_y
#undef target_x
#undef target_index
#undef visualize
#undef yheight2
#undef xwidth2
#undef zdepth
#undef yheight
#undef xwidth
#undef priority
#undef material_string
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

/* User declarations for component 'channel_17_analyzer_1_array_crystal_array_5' [781]. */
#define mccompcurname  channel_17_analyzer_1_array_crystal_array_5
#define mccompcurtype  Union_box
#define mccompcurindex 781
#define loop_index mccchannel_17_analyzer_1_array_crystal_array_5_loop_index
#define this_box_volume mccchannel_17_analyzer_1_array_crystal_array_5_this_box_volume
#define global_geometry_element mccchannel_17_analyzer_1_array_crystal_array_5_global_geometry_element
#define this_box_storage mccchannel_17_analyzer_1_array_crystal_array_5_this_box_storage
#define material_string mccchannel_17_analyzer_1_array_crystal_array_5_material_string
#define priority mccchannel_17_analyzer_1_array_crystal_array_5_priority
#define xwidth mccchannel_17_analyzer_1_array_crystal_array_5_xwidth
#define yheight mccchannel_17_analyzer_1_array_crystal_array_5_yheight
#define zdepth mccchannel_17_analyzer_1_array_crystal_array_5_zdepth
#define xwidth2 mccchannel_17_analyzer_1_array_crystal_array_5_xwidth2
#define yheight2 mccchannel_17_analyzer_1_array_crystal_array_5_yheight2
#define visualize mccchannel_17_analyzer_1_array_crystal_array_5_visualize
#define target_index mccchannel_17_analyzer_1_array_crystal_array_5_target_index
#define target_x mccchannel_17_analyzer_1_array_crystal_array_5_target_x
#define target_y mccchannel_17_analyzer_1_array_crystal_array_5_target_y
#define target_z mccchannel_17_analyzer_1_array_crystal_array_5_target_z
#define focus_aw mccchannel_17_analyzer_1_array_crystal_array_5_focus_aw
#define focus_ah mccchannel_17_analyzer_1_array_crystal_array_5_focus_ah
#define focus_xw mccchannel_17_analyzer_1_array_crystal_array_5_focus_xw
#define focus_xh mccchannel_17_analyzer_1_array_crystal_array_5_focus_xh
#define focus_r mccchannel_17_analyzer_1_array_crystal_array_5_focus_r
#define p_interact mccchannel_17_analyzer_1_array_crystal_array_5_p_interact
#define mask_string mccchannel_17_analyzer_1_array_crystal_array_5_mask_string
#define mask_setting mccchannel_17_analyzer_1_array_crystal_array_5_mask_setting
#define number_of_activations mccchannel_17_analyzer_1_array_crystal_array_5_number_of_activations
#line 204 "Union_box.comp"
// Needed for transport to the main component
struct global_geometry_element_struct global_geometry_element;

#ifndef ANY_GEOMETRY_DETECTOR_DECLARE
    #define ANY_GEOMETRY_DETECTOR_DECLARE dummy
	//struct pointer_to_global_geometry_list global_geometry_list = {0,NULL};
#endif

int loop_index,found_geometries;

double x_component;
double y_component;
double z_component;

struct Volume_struct this_box_volume;
struct box_storage this_box_storage;

#line 77828 "MACS_sample_kidney_box.c"
#undef number_of_activations
#undef mask_setting
#undef mask_string
#undef p_interact
#undef focus_r
#undef focus_xh
#undef focus_xw
#undef focus_ah
#undef focus_aw
#undef target_z
#undef target_y
#undef target_x
#undef target_index
#undef visualize
#undef yheight2
#undef xwidth2
#undef zdepth
#undef yheight
#undef xwidth
#undef priority
#undef material_string
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

/* User declarations for component 'channel_17_analyzer_1_array_crystal_array_6' [782]. */
#define mccompcurname  channel_17_analyzer_1_array_crystal_array_6
#define mccompcurtype  Union_box
#define mccompcurindex 782
#define loop_index mccchannel_17_analyzer_1_array_crystal_array_6_loop_index
#define this_box_volume mccchannel_17_analyzer_1_array_crystal_array_6_this_box_volume
#define global_geometry_element mccchannel_17_analyzer_1_array_crystal_array_6_global_geometry_element
#define this_box_storage mccchannel_17_analyzer_1_array_crystal_array_6_this_box_storage
#define material_string mccchannel_17_analyzer_1_array_crystal_array_6_material_string
#define priority mccchannel_17_analyzer_1_array_crystal_array_6_priority
#define xwidth mccchannel_17_analyzer_1_array_crystal_array_6_xwidth
#define yheight mccchannel_17_analyzer_1_array_crystal_array_6_yheight
#define zdepth mccchannel_17_analyzer_1_array_crystal_array_6_zdepth
#define xwidth2 mccchannel_17_analyzer_1_array_crystal_array_6_xwidth2
#define yheight2 mccchannel_17_analyzer_1_array_crystal_array_6_yheight2
#define visualize mccchannel_17_analyzer_1_array_crystal_array_6_visualize
#define target_index mccchannel_17_analyzer_1_array_crystal_array_6_target_index
#define target_x mccchannel_17_analyzer_1_array_crystal_array_6_target_x
#define target_y mccchannel_17_analyzer_1_array_crystal_array_6_target_y
#define target_z mccchannel_17_analyzer_1_array_crystal_array_6_target_z
#define focus_aw mccchannel_17_analyzer_1_array_crystal_array_6_focus_aw
#define focus_ah mccchannel_17_analyzer_1_array_crystal_array_6_focus_ah
#define focus_xw mccchannel_17_analyzer_1_array_crystal_array_6_focus_xw
#define focus_xh mccchannel_17_analyzer_1_array_crystal_array_6_focus_xh
#define focus_r mccchannel_17_analyzer_1_array_crystal_array_6_focus_r
#define p_interact mccchannel_17_analyzer_1_array_crystal_array_6_p_interact
#define mask_string mccchannel_17_analyzer_1_array_crystal_array_6_mask_string
#define mask_setting mccchannel_17_analyzer_1_array_crystal_array_6_mask_setting
#define number_of_activations mccchannel_17_analyzer_1_array_crystal_array_6_number_of_activations
#line 204 "Union_box.comp"
// Needed for transport to the main component
struct global_geometry_element_struct global_geometry_element;

#ifndef ANY_GEOMETRY_DETECTOR_DECLARE
    #define ANY_GEOMETRY_DETECTOR_DECLARE dummy
	//struct pointer_to_global_geometry_list global_geometry_list = {0,NULL};
#endif

int loop_index,found_geometries;

double x_component;
double y_component;
double z_component;

struct Volume_struct this_box_volume;
struct box_storage this_box_storage;

#line 77905 "MACS_sample_kidney_box.c"
#undef number_of_activations
#undef mask_setting
#undef mask_string
#undef p_interact
#undef focus_r
#undef focus_xh
#undef focus_xw
#undef focus_ah
#undef focus_aw
#undef target_z
#undef target_y
#undef target_x
#undef target_index
#undef visualize
#undef yheight2
#undef xwidth2
#undef zdepth
#undef yheight
#undef xwidth
#undef priority
#undef material_string
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

/* User declarations for component 'channel_17_analyzer_1_array_crystal_array_7' [783]. */
#define mccompcurname  channel_17_analyzer_1_array_crystal_array_7
#define mccompcurtype  Union_box
#define mccompcurindex 783
#define loop_index mccchannel_17_analyzer_1_array_crystal_array_7_loop_index
#define this_box_volume mccchannel_17_analyzer_1_array_crystal_array_7_this_box_volume
#define global_geometry_element mccchannel_17_analyzer_1_array_crystal_array_7_global_geometry_element
#define this_box_storage mccchannel_17_analyzer_1_array_crystal_array_7_this_box_storage
#define material_string mccchannel_17_analyzer_1_array_crystal_array_7_material_string
#define priority mccchannel_17_analyzer_1_array_crystal_array_7_priority
#define xwidth mccchannel_17_analyzer_1_array_crystal_array_7_xwidth
#define yheight mccchannel_17_analyzer_1_array_crystal_array_7_yheight
#define zdepth mccchannel_17_analyzer_1_array_crystal_array_7_zdepth
#define xwidth2 mccchannel_17_analyzer_1_array_crystal_array_7_xwidth2
#define yheight2 mccchannel_17_analyzer_1_array_crystal_array_7_yheight2
#define visualize mccchannel_17_analyzer_1_array_crystal_array_7_visualize
#define target_index mccchannel_17_analyzer_1_array_crystal_array_7_target_index
#define target_x mccchannel_17_analyzer_1_array_crystal_array_7_target_x
#define target_y mccchannel_17_analyzer_1_array_crystal_array_7_target_y
#define target_z mccchannel_17_analyzer_1_array_crystal_array_7_target_z
#define focus_aw mccchannel_17_analyzer_1_array_crystal_array_7_focus_aw
#define focus_ah mccchannel_17_analyzer_1_array_crystal_array_7_focus_ah
#define focus_xw mccchannel_17_analyzer_1_array_crystal_array_7_focus_xw
#define focus_xh mccchannel_17_analyzer_1_array_crystal_array_7_focus_xh
#define focus_r mccchannel_17_analyzer_1_array_crystal_array_7_focus_r
#define p_interact mccchannel_17_analyzer_1_array_crystal_array_7_p_interact
#define mask_string mccchannel_17_analyzer_1_array_crystal_array_7_mask_string
#define mask_setting mccchannel_17_analyzer_1_array_crystal_array_7_mask_setting
#define number_of_activations mccchannel_17_analyzer_1_array_crystal_array_7_number_of_activations
#line 204 "Union_box.comp"
// Needed for transport to the main component
struct global_geometry_element_struct global_geometry_element;

#ifndef ANY_GEOMETRY_DETECTOR_DECLARE
    #define ANY_GEOMETRY_DETECTOR_DECLARE dummy
	//struct pointer_to_global_geometry_list global_geometry_list = {0,NULL};
#endif

int loop_index,found_geometries;

double x_component;
double y_component;
double z_component;

struct Volume_struct this_box_volume;
struct box_storage this_box_storage;

#line 77982 "MACS_sample_kidney_box.c"
#undef number_of_activations
#undef mask_setting
#undef mask_string
#undef p_interact
#undef focus_r
#undef focus_xh
#undef focus_xw
#undef focus_ah
#undef focus_aw
#undef target_z
#undef target_y
#undef target_x
#undef target_index
#undef visualize
#undef yheight2
#undef xwidth2
#undef zdepth
#undef yheight
#undef xwidth
#undef priority
#undef material_string
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

/* User declarations for component 'channel_17_analyzer_1_array_crystal_array_8' [784]. */
#define mccompcurname  channel_17_analyzer_1_array_crystal_array_8
#define mccompcurtype  Union_box
#define mccompcurindex 784
#define loop_index mccchannel_17_analyzer_1_array_crystal_array_8_loop_index
#define this_box_volume mccchannel_17_analyzer_1_array_crystal_array_8_this_box_volume
#define global_geometry_element mccchannel_17_analyzer_1_array_crystal_array_8_global_geometry_element
#define this_box_storage mccchannel_17_analyzer_1_array_crystal_array_8_this_box_storage
#define material_string mccchannel_17_analyzer_1_array_crystal_array_8_material_string
#define priority mccchannel_17_analyzer_1_array_crystal_array_8_priority
#define xwidth mccchannel_17_analyzer_1_array_crystal_array_8_xwidth
#define yheight mccchannel_17_analyzer_1_array_crystal_array_8_yheight
#define zdepth mccchannel_17_analyzer_1_array_crystal_array_8_zdepth
#define xwidth2 mccchannel_17_analyzer_1_array_crystal_array_8_xwidth2
#define yheight2 mccchannel_17_analyzer_1_array_crystal_array_8_yheight2
#define visualize mccchannel_17_analyzer_1_array_crystal_array_8_visualize
#define target_index mccchannel_17_analyzer_1_array_crystal_array_8_target_index
#define target_x mccchannel_17_analyzer_1_array_crystal_array_8_target_x
#define target_y mccchannel_17_analyzer_1_array_crystal_array_8_target_y
#define target_z mccchannel_17_analyzer_1_array_crystal_array_8_target_z
#define focus_aw mccchannel_17_analyzer_1_array_crystal_array_8_focus_aw
#define focus_ah mccchannel_17_analyzer_1_array_crystal_array_8_focus_ah
#define focus_xw mccchannel_17_analyzer_1_array_crystal_array_8_focus_xw
#define focus_xh mccchannel_17_analyzer_1_array_crystal_array_8_focus_xh
#define focus_r mccchannel_17_analyzer_1_array_crystal_array_8_focus_r
#define p_interact mccchannel_17_analyzer_1_array_crystal_array_8_p_interact
#define mask_string mccchannel_17_analyzer_1_array_crystal_array_8_mask_string
#define mask_setting mccchannel_17_analyzer_1_array_crystal_array_8_mask_setting
#define number_of_activations mccchannel_17_analyzer_1_array_crystal_array_8_number_of_activations
#line 204 "Union_box.comp"
// Needed for transport to the main component
struct global_geometry_element_struct global_geometry_element;

#ifndef ANY_GEOMETRY_DETECTOR_DECLARE
    #define ANY_GEOMETRY_DETECTOR_DECLARE dummy
	//struct pointer_to_global_geometry_list global_geometry_list = {0,NULL};
#endif

int loop_index,found_geometries;

double x_component;
double y_component;
double z_component;

struct Volume_struct this_box_volume;
struct box_storage this_box_storage;

#line 78059 "MACS_sample_kidney_box.c"
#undef number_of_activations
#undef mask_setting
#undef mask_string
#undef p_interact
#undef focus_r
#undef focus_xh
#undef focus_xw
#undef focus_ah
#undef focus_aw
#undef target_z
#undef target_y
#undef target_x
#undef target_index
#undef visualize
#undef yheight2
#undef xwidth2
#undef zdepth
#undef yheight
#undef xwidth
#undef priority
#undef material_string
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

/* User declarations for component 'channel_17_analyzer_2_center' [785]. */
#define mccompcurname  channel_17_analyzer_2_center
#define mccompcurtype  Arm
#define mccompcurindex 785
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

/* User declarations for component 'channel_17_analyzer_2_rotated' [786]. */
#define mccompcurname  channel_17_analyzer_2_rotated
#define mccompcurtype  Arm
#define mccompcurindex 786
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

/* User declarations for component 'channel_17_analyzer_2_array_crystal_array_0' [787]. */
#define mccompcurname  channel_17_analyzer_2_array_crystal_array_0
#define mccompcurtype  Union_box
#define mccompcurindex 787
#define loop_index mccchannel_17_analyzer_2_array_crystal_array_0_loop_index
#define this_box_volume mccchannel_17_analyzer_2_array_crystal_array_0_this_box_volume
#define global_geometry_element mccchannel_17_analyzer_2_array_crystal_array_0_global_geometry_element
#define this_box_storage mccchannel_17_analyzer_2_array_crystal_array_0_this_box_storage
#define material_string mccchannel_17_analyzer_2_array_crystal_array_0_material_string
#define priority mccchannel_17_analyzer_2_array_crystal_array_0_priority
#define xwidth mccchannel_17_analyzer_2_array_crystal_array_0_xwidth
#define yheight mccchannel_17_analyzer_2_array_crystal_array_0_yheight
#define zdepth mccchannel_17_analyzer_2_array_crystal_array_0_zdepth
#define xwidth2 mccchannel_17_analyzer_2_array_crystal_array_0_xwidth2
#define yheight2 mccchannel_17_analyzer_2_array_crystal_array_0_yheight2
#define visualize mccchannel_17_analyzer_2_array_crystal_array_0_visualize
#define target_index mccchannel_17_analyzer_2_array_crystal_array_0_target_index
#define target_x mccchannel_17_analyzer_2_array_crystal_array_0_target_x
#define target_y mccchannel_17_analyzer_2_array_crystal_array_0_target_y
#define target_z mccchannel_17_analyzer_2_array_crystal_array_0_target_z
#define focus_aw mccchannel_17_analyzer_2_array_crystal_array_0_focus_aw
#define focus_ah mccchannel_17_analyzer_2_array_crystal_array_0_focus_ah
#define focus_xw mccchannel_17_analyzer_2_array_crystal_array_0_focus_xw
#define focus_xh mccchannel_17_analyzer_2_array_crystal_array_0_focus_xh
#define focus_r mccchannel_17_analyzer_2_array_crystal_array_0_focus_r
#define p_interact mccchannel_17_analyzer_2_array_crystal_array_0_p_interact
#define mask_string mccchannel_17_analyzer_2_array_crystal_array_0_mask_string
#define mask_setting mccchannel_17_analyzer_2_array_crystal_array_0_mask_setting
#define number_of_activations mccchannel_17_analyzer_2_array_crystal_array_0_number_of_activations
#line 204 "Union_box.comp"
// Needed for transport to the main component
struct global_geometry_element_struct global_geometry_element;

#ifndef ANY_GEOMETRY_DETECTOR_DECLARE
    #define ANY_GEOMETRY_DETECTOR_DECLARE dummy
	//struct pointer_to_global_geometry_list global_geometry_list = {0,NULL};
#endif

int loop_index,found_geometries;

double x_component;
double y_component;
double z_component;

struct Volume_struct this_box_volume;
struct box_storage this_box_storage;

#line 78152 "MACS_sample_kidney_box.c"
#undef number_of_activations
#undef mask_setting
#undef mask_string
#undef p_interact
#undef focus_r
#undef focus_xh
#undef focus_xw
#undef focus_ah
#undef focus_aw
#undef target_z
#undef target_y
#undef target_x
#undef target_index
#undef visualize
#undef yheight2
#undef xwidth2
#undef zdepth
#undef yheight
#undef xwidth
#undef priority
#undef material_string
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

/* User declarations for component 'channel_17_analyzer_2_array_crystal_array_1' [788]. */
#define mccompcurname  channel_17_analyzer_2_array_crystal_array_1
#define mccompcurtype  Union_box
#define mccompcurindex 788
#define loop_index mccchannel_17_analyzer_2_array_crystal_array_1_loop_index
#define this_box_volume mccchannel_17_analyzer_2_array_crystal_array_1_this_box_volume
#define global_geometry_element mccchannel_17_analyzer_2_array_crystal_array_1_global_geometry_element
#define this_box_storage mccchannel_17_analyzer_2_array_crystal_array_1_this_box_storage
#define material_string mccchannel_17_analyzer_2_array_crystal_array_1_material_string
#define priority mccchannel_17_analyzer_2_array_crystal_array_1_priority
#define xwidth mccchannel_17_analyzer_2_array_crystal_array_1_xwidth
#define yheight mccchannel_17_analyzer_2_array_crystal_array_1_yheight
#define zdepth mccchannel_17_analyzer_2_array_crystal_array_1_zdepth
#define xwidth2 mccchannel_17_analyzer_2_array_crystal_array_1_xwidth2
#define yheight2 mccchannel_17_analyzer_2_array_crystal_array_1_yheight2
#define visualize mccchannel_17_analyzer_2_array_crystal_array_1_visualize
#define target_index mccchannel_17_analyzer_2_array_crystal_array_1_target_index
#define target_x mccchannel_17_analyzer_2_array_crystal_array_1_target_x
#define target_y mccchannel_17_analyzer_2_array_crystal_array_1_target_y
#define target_z mccchannel_17_analyzer_2_array_crystal_array_1_target_z
#define focus_aw mccchannel_17_analyzer_2_array_crystal_array_1_focus_aw
#define focus_ah mccchannel_17_analyzer_2_array_crystal_array_1_focus_ah
#define focus_xw mccchannel_17_analyzer_2_array_crystal_array_1_focus_xw
#define focus_xh mccchannel_17_analyzer_2_array_crystal_array_1_focus_xh
#define focus_r mccchannel_17_analyzer_2_array_crystal_array_1_focus_r
#define p_interact mccchannel_17_analyzer_2_array_crystal_array_1_p_interact
#define mask_string mccchannel_17_analyzer_2_array_crystal_array_1_mask_string
#define mask_setting mccchannel_17_analyzer_2_array_crystal_array_1_mask_setting
#define number_of_activations mccchannel_17_analyzer_2_array_crystal_array_1_number_of_activations
#line 204 "Union_box.comp"
// Needed for transport to the main component
struct global_geometry_element_struct global_geometry_element;

#ifndef ANY_GEOMETRY_DETECTOR_DECLARE
    #define ANY_GEOMETRY_DETECTOR_DECLARE dummy
	//struct pointer_to_global_geometry_list global_geometry_list = {0,NULL};
#endif

int loop_index,found_geometries;

double x_component;
double y_component;
double z_component;

struct Volume_struct this_box_volume;
struct box_storage this_box_storage;

#line 78229 "MACS_sample_kidney_box.c"
#undef number_of_activations
#undef mask_setting
#undef mask_string
#undef p_interact
#undef focus_r
#undef focus_xh
#undef focus_xw
#undef focus_ah
#undef focus_aw
#undef target_z
#undef target_y
#undef target_x
#undef target_index
#undef visualize
#undef yheight2
#undef xwidth2
#undef zdepth
#undef yheight
#undef xwidth
#undef priority
#undef material_string
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

/* User declarations for component 'channel_17_analyzer_2_array_crystal_array_2' [789]. */
#define mccompcurname  channel_17_analyzer_2_array_crystal_array_2
#define mccompcurtype  Union_box
#define mccompcurindex 789
#define loop_index mccchannel_17_analyzer_2_array_crystal_array_2_loop_index
#define this_box_volume mccchannel_17_analyzer_2_array_crystal_array_2_this_box_volume
#define global_geometry_element mccchannel_17_analyzer_2_array_crystal_array_2_global_geometry_element
#define this_box_storage mccchannel_17_analyzer_2_array_crystal_array_2_this_box_storage
#define material_string mccchannel_17_analyzer_2_array_crystal_array_2_material_string
#define priority mccchannel_17_analyzer_2_array_crystal_array_2_priority
#define xwidth mccchannel_17_analyzer_2_array_crystal_array_2_xwidth
#define yheight mccchannel_17_analyzer_2_array_crystal_array_2_yheight
#define zdepth mccchannel_17_analyzer_2_array_crystal_array_2_zdepth
#define xwidth2 mccchannel_17_analyzer_2_array_crystal_array_2_xwidth2
#define yheight2 mccchannel_17_analyzer_2_array_crystal_array_2_yheight2
#define visualize mccchannel_17_analyzer_2_array_crystal_array_2_visualize
#define target_index mccchannel_17_analyzer_2_array_crystal_array_2_target_index
#define target_x mccchannel_17_analyzer_2_array_crystal_array_2_target_x
#define target_y mccchannel_17_analyzer_2_array_crystal_array_2_target_y
#define target_z mccchannel_17_analyzer_2_array_crystal_array_2_target_z
#define focus_aw mccchannel_17_analyzer_2_array_crystal_array_2_focus_aw
#define focus_ah mccchannel_17_analyzer_2_array_crystal_array_2_focus_ah
#define focus_xw mccchannel_17_analyzer_2_array_crystal_array_2_focus_xw
#define focus_xh mccchannel_17_analyzer_2_array_crystal_array_2_focus_xh
#define focus_r mccchannel_17_analyzer_2_array_crystal_array_2_focus_r
#define p_interact mccchannel_17_analyzer_2_array_crystal_array_2_p_interact
#define mask_string mccchannel_17_analyzer_2_array_crystal_array_2_mask_string
#define mask_setting mccchannel_17_analyzer_2_array_crystal_array_2_mask_setting
#define number_of_activations mccchannel_17_analyzer_2_array_crystal_array_2_number_of_activations
#line 204 "Union_box.comp"
// Needed for transport to the main component
struct global_geometry_element_struct global_geometry_element;

#ifndef ANY_GEOMETRY_DETECTOR_DECLARE
    #define ANY_GEOMETRY_DETECTOR_DECLARE dummy
	//struct pointer_to_global_geometry_list global_geometry_list = {0,NULL};
#endif

int loop_index,found_geometries;

double x_component;
double y_component;
double z_component;

struct Volume_struct this_box_volume;
struct box_storage this_box_storage;

#line 78306 "MACS_sample_kidney_box.c"
#undef number_of_activations
#undef mask_setting
#undef mask_string
#undef p_interact
#undef focus_r
#undef focus_xh
#undef focus_xw
#undef focus_ah
#undef focus_aw
#undef target_z
#undef target_y
#undef target_x
#undef target_index
#undef visualize
#undef yheight2
#undef xwidth2
#undef zdepth
#undef yheight
#undef xwidth
#undef priority
#undef material_string
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

/* User declarations for component 'channel_17_analyzer_2_array_crystal_array_3' [790]. */
#define mccompcurname  channel_17_analyzer_2_array_crystal_array_3
#define mccompcurtype  Union_box
#define mccompcurindex 790
#define loop_index mccchannel_17_analyzer_2_array_crystal_array_3_loop_index
#define this_box_volume mccchannel_17_analyzer_2_array_crystal_array_3_this_box_volume
#define global_geometry_element mccchannel_17_analyzer_2_array_crystal_array_3_global_geometry_element
#define this_box_storage mccchannel_17_analyzer_2_array_crystal_array_3_this_box_storage
#define material_string mccchannel_17_analyzer_2_array_crystal_array_3_material_string
#define priority mccchannel_17_analyzer_2_array_crystal_array_3_priority
#define xwidth mccchannel_17_analyzer_2_array_crystal_array_3_xwidth
#define yheight mccchannel_17_analyzer_2_array_crystal_array_3_yheight
#define zdepth mccchannel_17_analyzer_2_array_crystal_array_3_zdepth
#define xwidth2 mccchannel_17_analyzer_2_array_crystal_array_3_xwidth2
#define yheight2 mccchannel_17_analyzer_2_array_crystal_array_3_yheight2
#define visualize mccchannel_17_analyzer_2_array_crystal_array_3_visualize
#define target_index mccchannel_17_analyzer_2_array_crystal_array_3_target_index
#define target_x mccchannel_17_analyzer_2_array_crystal_array_3_target_x
#define target_y mccchannel_17_analyzer_2_array_crystal_array_3_target_y
#define target_z mccchannel_17_analyzer_2_array_crystal_array_3_target_z
#define focus_aw mccchannel_17_analyzer_2_array_crystal_array_3_focus_aw
#define focus_ah mccchannel_17_analyzer_2_array_crystal_array_3_focus_ah
#define focus_xw mccchannel_17_analyzer_2_array_crystal_array_3_focus_xw
#define focus_xh mccchannel_17_analyzer_2_array_crystal_array_3_focus_xh
#define focus_r mccchannel_17_analyzer_2_array_crystal_array_3_focus_r
#define p_interact mccchannel_17_analyzer_2_array_crystal_array_3_p_interact
#define mask_string mccchannel_17_analyzer_2_array_crystal_array_3_mask_string
#define mask_setting mccchannel_17_analyzer_2_array_crystal_array_3_mask_setting
#define number_of_activations mccchannel_17_analyzer_2_array_crystal_array_3_number_of_activations
#line 204 "Union_box.comp"
// Needed for transport to the main component
struct global_geometry_element_struct global_geometry_element;

#ifndef ANY_GEOMETRY_DETECTOR_DECLARE
    #define ANY_GEOMETRY_DETECTOR_DECLARE dummy
	//struct pointer_to_global_geometry_list global_geometry_list = {0,NULL};
#endif

int loop_index,found_geometries;

double x_component;
double y_component;
double z_component;

struct Volume_struct this_box_volume;
struct box_storage this_box_storage;

#line 78383 "MACS_sample_kidney_box.c"
#undef number_of_activations
#undef mask_setting
#undef mask_string
#undef p_interact
#undef focus_r
#undef focus_xh
#undef focus_xw
#undef focus_ah
#undef focus_aw
#undef target_z
#undef target_y
#undef target_x
#undef target_index
#undef visualize
#undef yheight2
#undef xwidth2
#undef zdepth
#undef yheight
#undef xwidth
#undef priority
#undef material_string
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

/* User declarations for component 'channel_17_analyzer_2_array_crystal_array_4' [791]. */
#define mccompcurname  channel_17_analyzer_2_array_crystal_array_4
#define mccompcurtype  Union_box
#define mccompcurindex 791
#define loop_index mccchannel_17_analyzer_2_array_crystal_array_4_loop_index
#define this_box_volume mccchannel_17_analyzer_2_array_crystal_array_4_this_box_volume
#define global_geometry_element mccchannel_17_analyzer_2_array_crystal_array_4_global_geometry_element
#define this_box_storage mccchannel_17_analyzer_2_array_crystal_array_4_this_box_storage
#define material_string mccchannel_17_analyzer_2_array_crystal_array_4_material_string
#define priority mccchannel_17_analyzer_2_array_crystal_array_4_priority
#define xwidth mccchannel_17_analyzer_2_array_crystal_array_4_xwidth
#define yheight mccchannel_17_analyzer_2_array_crystal_array_4_yheight
#define zdepth mccchannel_17_analyzer_2_array_crystal_array_4_zdepth
#define xwidth2 mccchannel_17_analyzer_2_array_crystal_array_4_xwidth2
#define yheight2 mccchannel_17_analyzer_2_array_crystal_array_4_yheight2
#define visualize mccchannel_17_analyzer_2_array_crystal_array_4_visualize
#define target_index mccchannel_17_analyzer_2_array_crystal_array_4_target_index
#define target_x mccchannel_17_analyzer_2_array_crystal_array_4_target_x
#define target_y mccchannel_17_analyzer_2_array_crystal_array_4_target_y
#define target_z mccchannel_17_analyzer_2_array_crystal_array_4_target_z
#define focus_aw mccchannel_17_analyzer_2_array_crystal_array_4_focus_aw
#define focus_ah mccchannel_17_analyzer_2_array_crystal_array_4_focus_ah
#define focus_xw mccchannel_17_analyzer_2_array_crystal_array_4_focus_xw
#define focus_xh mccchannel_17_analyzer_2_array_crystal_array_4_focus_xh
#define focus_r mccchannel_17_analyzer_2_array_crystal_array_4_focus_r
#define p_interact mccchannel_17_analyzer_2_array_crystal_array_4_p_interact
#define mask_string mccchannel_17_analyzer_2_array_crystal_array_4_mask_string
#define mask_setting mccchannel_17_analyzer_2_array_crystal_array_4_mask_setting
#define number_of_activations mccchannel_17_analyzer_2_array_crystal_array_4_number_of_activations
#line 204 "Union_box.comp"
// Needed for transport to the main component
struct global_geometry_element_struct global_geometry_element;

#ifndef ANY_GEOMETRY_DETECTOR_DECLARE
    #define ANY_GEOMETRY_DETECTOR_DECLARE dummy
	//struct pointer_to_global_geometry_list global_geometry_list = {0,NULL};
#endif

int loop_index,found_geometries;

double x_component;
double y_component;
double z_component;

struct Volume_struct this_box_volume;
struct box_storage this_box_storage;

#line 78460 "MACS_sample_kidney_box.c"
#undef number_of_activations
#undef mask_setting
#undef mask_string
#undef p_interact
#undef focus_r
#undef focus_xh
#undef focus_xw
#undef focus_ah
#undef focus_aw
#undef target_z
#undef target_y
#undef target_x
#undef target_index
#undef visualize
#undef yheight2
#undef xwidth2
#undef zdepth
#undef yheight
#undef xwidth
#undef priority
#undef material_string
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

/* User declarations for component 'channel_17_analyzer_2_array_crystal_array_5' [792]. */
#define mccompcurname  channel_17_analyzer_2_array_crystal_array_5
#define mccompcurtype  Union_box
#define mccompcurindex 792
#define loop_index mccchannel_17_analyzer_2_array_crystal_array_5_loop_index
#define this_box_volume mccchannel_17_analyzer_2_array_crystal_array_5_this_box_volume
#define global_geometry_element mccchannel_17_analyzer_2_array_crystal_array_5_global_geometry_element
#define this_box_storage mccchannel_17_analyzer_2_array_crystal_array_5_this_box_storage
#define material_string mccchannel_17_analyzer_2_array_crystal_array_5_material_string
#define priority mccchannel_17_analyzer_2_array_crystal_array_5_priority
#define xwidth mccchannel_17_analyzer_2_array_crystal_array_5_xwidth
#define yheight mccchannel_17_analyzer_2_array_crystal_array_5_yheight
#define zdepth mccchannel_17_analyzer_2_array_crystal_array_5_zdepth
#define xwidth2 mccchannel_17_analyzer_2_array_crystal_array_5_xwidth2
#define yheight2 mccchannel_17_analyzer_2_array_crystal_array_5_yheight2
#define visualize mccchannel_17_analyzer_2_array_crystal_array_5_visualize
#define target_index mccchannel_17_analyzer_2_array_crystal_array_5_target_index
#define target_x mccchannel_17_analyzer_2_array_crystal_array_5_target_x
#define target_y mccchannel_17_analyzer_2_array_crystal_array_5_target_y
#define target_z mccchannel_17_analyzer_2_array_crystal_array_5_target_z
#define focus_aw mccchannel_17_analyzer_2_array_crystal_array_5_focus_aw
#define focus_ah mccchannel_17_analyzer_2_array_crystal_array_5_focus_ah
#define focus_xw mccchannel_17_analyzer_2_array_crystal_array_5_focus_xw
#define focus_xh mccchannel_17_analyzer_2_array_crystal_array_5_focus_xh
#define focus_r mccchannel_17_analyzer_2_array_crystal_array_5_focus_r
#define p_interact mccchannel_17_analyzer_2_array_crystal_array_5_p_interact
#define mask_string mccchannel_17_analyzer_2_array_crystal_array_5_mask_string
#define mask_setting mccchannel_17_analyzer_2_array_crystal_array_5_mask_setting
#define number_of_activations mccchannel_17_analyzer_2_array_crystal_array_5_number_of_activations
#line 204 "Union_box.comp"
// Needed for transport to the main component
struct global_geometry_element_struct global_geometry_element;

#ifndef ANY_GEOMETRY_DETECTOR_DECLARE
    #define ANY_GEOMETRY_DETECTOR_DECLARE dummy
	//struct pointer_to_global_geometry_list global_geometry_list = {0,NULL};
#endif

int loop_index,found_geometries;

double x_component;
double y_component;
double z_component;

struct Volume_struct this_box_volume;
struct box_storage this_box_storage;

#line 78537 "MACS_sample_kidney_box.c"
#undef number_of_activations
#undef mask_setting
#undef mask_string
#undef p_interact
#undef focus_r
#undef focus_xh
#undef focus_xw
#undef focus_ah
#undef focus_aw
#undef target_z
#undef target_y
#undef target_x
#undef target_index
#undef visualize
#undef yheight2
#undef xwidth2
#undef zdepth
#undef yheight
#undef xwidth
#undef priority
#undef material_string
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

/* User declarations for component 'channel_17_analyzer_2_array_crystal_array_6' [793]. */
#define mccompcurname  channel_17_analyzer_2_array_crystal_array_6
#define mccompcurtype  Union_box
#define mccompcurindex 793
#define loop_index mccchannel_17_analyzer_2_array_crystal_array_6_loop_index
#define this_box_volume mccchannel_17_analyzer_2_array_crystal_array_6_this_box_volume
#define global_geometry_element mccchannel_17_analyzer_2_array_crystal_array_6_global_geometry_element
#define this_box_storage mccchannel_17_analyzer_2_array_crystal_array_6_this_box_storage
#define material_string mccchannel_17_analyzer_2_array_crystal_array_6_material_string
#define priority mccchannel_17_analyzer_2_array_crystal_array_6_priority
#define xwidth mccchannel_17_analyzer_2_array_crystal_array_6_xwidth
#define yheight mccchannel_17_analyzer_2_array_crystal_array_6_yheight
#define zdepth mccchannel_17_analyzer_2_array_crystal_array_6_zdepth
#define xwidth2 mccchannel_17_analyzer_2_array_crystal_array_6_xwidth2
#define yheight2 mccchannel_17_analyzer_2_array_crystal_array_6_yheight2
#define visualize mccchannel_17_analyzer_2_array_crystal_array_6_visualize
#define target_index mccchannel_17_analyzer_2_array_crystal_array_6_target_index
#define target_x mccchannel_17_analyzer_2_array_crystal_array_6_target_x
#define target_y mccchannel_17_analyzer_2_array_crystal_array_6_target_y
#define target_z mccchannel_17_analyzer_2_array_crystal_array_6_target_z
#define focus_aw mccchannel_17_analyzer_2_array_crystal_array_6_focus_aw
#define focus_ah mccchannel_17_analyzer_2_array_crystal_array_6_focus_ah
#define focus_xw mccchannel_17_analyzer_2_array_crystal_array_6_focus_xw
#define focus_xh mccchannel_17_analyzer_2_array_crystal_array_6_focus_xh
#define focus_r mccchannel_17_analyzer_2_array_crystal_array_6_focus_r
#define p_interact mccchannel_17_analyzer_2_array_crystal_array_6_p_interact
#define mask_string mccchannel_17_analyzer_2_array_crystal_array_6_mask_string
#define mask_setting mccchannel_17_analyzer_2_array_crystal_array_6_mask_setting
#define number_of_activations mccchannel_17_analyzer_2_array_crystal_array_6_number_of_activations
#line 204 "Union_box.comp"
// Needed for transport to the main component
struct global_geometry_element_struct global_geometry_element;

#ifndef ANY_GEOMETRY_DETECTOR_DECLARE
    #define ANY_GEOMETRY_DETECTOR_DECLARE dummy
	//struct pointer_to_global_geometry_list global_geometry_list = {0,NULL};
#endif

int loop_index,found_geometries;

double x_component;
double y_component;
double z_component;

struct Volume_struct this_box_volume;
struct box_storage this_box_storage;

#line 78614 "MACS_sample_kidney_box.c"
#undef number_of_activations
#undef mask_setting
#undef mask_string
#undef p_interact
#undef focus_r
#undef focus_xh
#undef focus_xw
#undef focus_ah
#undef focus_aw
#undef target_z
#undef target_y
#undef target_x
#undef target_index
#undef visualize
#undef yheight2
#undef xwidth2
#undef zdepth
#undef yheight
#undef xwidth
#undef priority
#undef material_string
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

/* User declarations for component 'channel_17_analyzer_2_array_crystal_array_7' [794]. */
#define mccompcurname  channel_17_analyzer_2_array_crystal_array_7
#define mccompcurtype  Union_box
#define mccompcurindex 794
#define loop_index mccchannel_17_analyzer_2_array_crystal_array_7_loop_index
#define this_box_volume mccchannel_17_analyzer_2_array_crystal_array_7_this_box_volume
#define global_geometry_element mccchannel_17_analyzer_2_array_crystal_array_7_global_geometry_element
#define this_box_storage mccchannel_17_analyzer_2_array_crystal_array_7_this_box_storage
#define material_string mccchannel_17_analyzer_2_array_crystal_array_7_material_string
#define priority mccchannel_17_analyzer_2_array_crystal_array_7_priority
#define xwidth mccchannel_17_analyzer_2_array_crystal_array_7_xwidth
#define yheight mccchannel_17_analyzer_2_array_crystal_array_7_yheight
#define zdepth mccchannel_17_analyzer_2_array_crystal_array_7_zdepth
#define xwidth2 mccchannel_17_analyzer_2_array_crystal_array_7_xwidth2
#define yheight2 mccchannel_17_analyzer_2_array_crystal_array_7_yheight2
#define visualize mccchannel_17_analyzer_2_array_crystal_array_7_visualize
#define target_index mccchannel_17_analyzer_2_array_crystal_array_7_target_index
#define target_x mccchannel_17_analyzer_2_array_crystal_array_7_target_x
#define target_y mccchannel_17_analyzer_2_array_crystal_array_7_target_y
#define target_z mccchannel_17_analyzer_2_array_crystal_array_7_target_z
#define focus_aw mccchannel_17_analyzer_2_array_crystal_array_7_focus_aw
#define focus_ah mccchannel_17_analyzer_2_array_crystal_array_7_focus_ah
#define focus_xw mccchannel_17_analyzer_2_array_crystal_array_7_focus_xw
#define focus_xh mccchannel_17_analyzer_2_array_crystal_array_7_focus_xh
#define focus_r mccchannel_17_analyzer_2_array_crystal_array_7_focus_r
#define p_interact mccchannel_17_analyzer_2_array_crystal_array_7_p_interact
#define mask_string mccchannel_17_analyzer_2_array_crystal_array_7_mask_string
#define mask_setting mccchannel_17_analyzer_2_array_crystal_array_7_mask_setting
#define number_of_activations mccchannel_17_analyzer_2_array_crystal_array_7_number_of_activations
#line 204 "Union_box.comp"
// Needed for transport to the main component
struct global_geometry_element_struct global_geometry_element;

#ifndef ANY_GEOMETRY_DETECTOR_DECLARE
    #define ANY_GEOMETRY_DETECTOR_DECLARE dummy
	//struct pointer_to_global_geometry_list global_geometry_list = {0,NULL};
#endif

int loop_index,found_geometries;

double x_component;
double y_component;
double z_component;

struct Volume_struct this_box_volume;
struct box_storage this_box_storage;

#line 78691 "MACS_sample_kidney_box.c"
#undef number_of_activations
#undef mask_setting
#undef mask_string
#undef p_interact
#undef focus_r
#undef focus_xh
#undef focus_xw
#undef focus_ah
#undef focus_aw
#undef target_z
#undef target_y
#undef target_x
#undef target_index
#undef visualize
#undef yheight2
#undef xwidth2
#undef zdepth
#undef yheight
#undef xwidth
#undef priority
#undef material_string
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

/* User declarations for component 'channel_17_analyzer_2_array_crystal_array_8' [795]. */
#define mccompcurname  channel_17_analyzer_2_array_crystal_array_8
#define mccompcurtype  Union_box
#define mccompcurindex 795
#define loop_index mccchannel_17_analyzer_2_array_crystal_array_8_loop_index
#define this_box_volume mccchannel_17_analyzer_2_array_crystal_array_8_this_box_volume
#define global_geometry_element mccchannel_17_analyzer_2_array_crystal_array_8_global_geometry_element
#define this_box_storage mccchannel_17_analyzer_2_array_crystal_array_8_this_box_storage
#define material_string mccchannel_17_analyzer_2_array_crystal_array_8_material_string
#define priority mccchannel_17_analyzer_2_array_crystal_array_8_priority
#define xwidth mccchannel_17_analyzer_2_array_crystal_array_8_xwidth
#define yheight mccchannel_17_analyzer_2_array_crystal_array_8_yheight
#define zdepth mccchannel_17_analyzer_2_array_crystal_array_8_zdepth
#define xwidth2 mccchannel_17_analyzer_2_array_crystal_array_8_xwidth2
#define yheight2 mccchannel_17_analyzer_2_array_crystal_array_8_yheight2
#define visualize mccchannel_17_analyzer_2_array_crystal_array_8_visualize
#define target_index mccchannel_17_analyzer_2_array_crystal_array_8_target_index
#define target_x mccchannel_17_analyzer_2_array_crystal_array_8_target_x
#define target_y mccchannel_17_analyzer_2_array_crystal_array_8_target_y
#define target_z mccchannel_17_analyzer_2_array_crystal_array_8_target_z
#define focus_aw mccchannel_17_analyzer_2_array_crystal_array_8_focus_aw
#define focus_ah mccchannel_17_analyzer_2_array_crystal_array_8_focus_ah
#define focus_xw mccchannel_17_analyzer_2_array_crystal_array_8_focus_xw
#define focus_xh mccchannel_17_analyzer_2_array_crystal_array_8_focus_xh
#define focus_r mccchannel_17_analyzer_2_array_crystal_array_8_focus_r
#define p_interact mccchannel_17_analyzer_2_array_crystal_array_8_p_interact
#define mask_string mccchannel_17_analyzer_2_array_crystal_array_8_mask_string
#define mask_setting mccchannel_17_analyzer_2_array_crystal_array_8_mask_setting
#define number_of_activations mccchannel_17_analyzer_2_array_crystal_array_8_number_of_activations
#line 204 "Union_box.comp"
// Needed for transport to the main component
struct global_geometry_element_struct global_geometry_element;

#ifndef ANY_GEOMETRY_DETECTOR_DECLARE
    #define ANY_GEOMETRY_DETECTOR_DECLARE dummy
	//struct pointer_to_global_geometry_list global_geometry_list = {0,NULL};
#endif

int loop_index,found_geometries;

double x_component;
double y_component;
double z_component;

struct Volume_struct this_box_volume;
struct box_storage this_box_storage;

#line 78768 "MACS_sample_kidney_box.c"
#undef number_of_activations
#undef mask_setting
#undef mask_string
#undef p_interact
#undef focus_r
#undef focus_xh
#undef focus_xw
#undef focus_ah
#undef focus_aw
#undef target_z
#undef target_y
#undef target_x
#undef target_index
#undef visualize
#undef yheight2
#undef xwidth2
#undef zdepth
#undef yheight
#undef xwidth
#undef priority
#undef material_string
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

/* User declarations for component 'channel_17_cave2_cyl1' [796]. */
#define mccompcurname  channel_17_cave2_cyl1
#define mccompcurtype  Union_cylinder
#define mccompcurindex 796
#define loop_index mccchannel_17_cave2_cyl1_loop_index
#define this_cylinder_volume mccchannel_17_cave2_cyl1_this_cylinder_volume
#define global_geometry_element mccchannel_17_cave2_cyl1_global_geometry_element
#define this_cylinder_storage mccchannel_17_cave2_cyl1_this_cylinder_storage
#define material_string mccchannel_17_cave2_cyl1_material_string
#define priority mccchannel_17_cave2_cyl1_priority
#define radius mccchannel_17_cave2_cyl1_radius
#define yheight mccchannel_17_cave2_cyl1_yheight
#define visualize mccchannel_17_cave2_cyl1_visualize
#define target_index mccchannel_17_cave2_cyl1_target_index
#define target_x mccchannel_17_cave2_cyl1_target_x
#define target_y mccchannel_17_cave2_cyl1_target_y
#define target_z mccchannel_17_cave2_cyl1_target_z
#define focus_aw mccchannel_17_cave2_cyl1_focus_aw
#define focus_ah mccchannel_17_cave2_cyl1_focus_ah
#define focus_xw mccchannel_17_cave2_cyl1_focus_xw
#define focus_xh mccchannel_17_cave2_cyl1_focus_xh
#define focus_r mccchannel_17_cave2_cyl1_focus_r
#define p_interact mccchannel_17_cave2_cyl1_p_interact
#define mask_string mccchannel_17_cave2_cyl1_mask_string
#define mask_setting mccchannel_17_cave2_cyl1_mask_setting
#define number_of_activations mccchannel_17_cave2_cyl1_number_of_activations
#line 167 "Union_cylinder.comp"
// Needed for transport to the main component
struct global_geometry_element_struct global_geometry_element;

#ifndef ANY_GEOMETRY_DETECTOR_DECLARE
    #define ANY_GEOMETRY_DETECTOR_DECLARE dummy
	//struct pointer_to_global_geometry_list global_geometry_list = {0,NULL};
#endif

int dummy;
int loop_index,found_geometries;
int loop_2_index;
int material_index;

struct Volume_struct this_cylinder_volume;
struct cylinder_storage this_cylinder_storage;
#line 78840 "MACS_sample_kidney_box.c"
#undef number_of_activations
#undef mask_setting
#undef mask_string
#undef p_interact
#undef focus_r
#undef focus_xh
#undef focus_xw
#undef focus_ah
#undef focus_aw
#undef target_z
#undef target_y
#undef target_x
#undef target_index
#undef visualize
#undef yheight
#undef radius
#undef priority
#undef material_string
#undef this_cylinder_storage
#undef global_geometry_element
#undef this_cylinder_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

/* User declarations for component 'channel_17_cave2_box1' [797]. */
#define mccompcurname  channel_17_cave2_box1
#define mccompcurtype  Union_box
#define mccompcurindex 797
#define loop_index mccchannel_17_cave2_box1_loop_index
#define this_box_volume mccchannel_17_cave2_box1_this_box_volume
#define global_geometry_element mccchannel_17_cave2_box1_global_geometry_element
#define this_box_storage mccchannel_17_cave2_box1_this_box_storage
#define material_string mccchannel_17_cave2_box1_material_string
#define priority mccchannel_17_cave2_box1_priority
#define xwidth mccchannel_17_cave2_box1_xwidth
#define yheight mccchannel_17_cave2_box1_yheight
#define zdepth mccchannel_17_cave2_box1_zdepth
#define xwidth2 mccchannel_17_cave2_box1_xwidth2
#define yheight2 mccchannel_17_cave2_box1_yheight2
#define visualize mccchannel_17_cave2_box1_visualize
#define target_index mccchannel_17_cave2_box1_target_index
#define target_x mccchannel_17_cave2_box1_target_x
#define target_y mccchannel_17_cave2_box1_target_y
#define target_z mccchannel_17_cave2_box1_target_z
#define focus_aw mccchannel_17_cave2_box1_focus_aw
#define focus_ah mccchannel_17_cave2_box1_focus_ah
#define focus_xw mccchannel_17_cave2_box1_focus_xw
#define focus_xh mccchannel_17_cave2_box1_focus_xh
#define focus_r mccchannel_17_cave2_box1_focus_r
#define p_interact mccchannel_17_cave2_box1_p_interact
#define mask_string mccchannel_17_cave2_box1_mask_string
#define mask_setting mccchannel_17_cave2_box1_mask_setting
#define number_of_activations mccchannel_17_cave2_box1_number_of_activations
#line 204 "Union_box.comp"
// Needed for transport to the main component
struct global_geometry_element_struct global_geometry_element;

#ifndef ANY_GEOMETRY_DETECTOR_DECLARE
    #define ANY_GEOMETRY_DETECTOR_DECLARE dummy
	//struct pointer_to_global_geometry_list global_geometry_list = {0,NULL};
#endif

int loop_index,found_geometries;

double x_component;
double y_component;
double z_component;

struct Volume_struct this_box_volume;
struct box_storage this_box_storage;

#line 78914 "MACS_sample_kidney_box.c"
#undef number_of_activations
#undef mask_setting
#undef mask_string
#undef p_interact
#undef focus_r
#undef focus_xh
#undef focus_xw
#undef focus_ah
#undef focus_aw
#undef target_z
#undef target_y
#undef target_x
#undef target_index
#undef visualize
#undef yheight2
#undef xwidth2
#undef zdepth
#undef yheight
#undef xwidth
#undef priority
#undef material_string
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

/* User declarations for component 'channel_17_cave2_box2' [798]. */
#define mccompcurname  channel_17_cave2_box2
#define mccompcurtype  Union_box
#define mccompcurindex 798
#define loop_index mccchannel_17_cave2_box2_loop_index
#define this_box_volume mccchannel_17_cave2_box2_this_box_volume
#define global_geometry_element mccchannel_17_cave2_box2_global_geometry_element
#define this_box_storage mccchannel_17_cave2_box2_this_box_storage
#define material_string mccchannel_17_cave2_box2_material_string
#define priority mccchannel_17_cave2_box2_priority
#define xwidth mccchannel_17_cave2_box2_xwidth
#define yheight mccchannel_17_cave2_box2_yheight
#define zdepth mccchannel_17_cave2_box2_zdepth
#define xwidth2 mccchannel_17_cave2_box2_xwidth2
#define yheight2 mccchannel_17_cave2_box2_yheight2
#define visualize mccchannel_17_cave2_box2_visualize
#define target_index mccchannel_17_cave2_box2_target_index
#define target_x mccchannel_17_cave2_box2_target_x
#define target_y mccchannel_17_cave2_box2_target_y
#define target_z mccchannel_17_cave2_box2_target_z
#define focus_aw mccchannel_17_cave2_box2_focus_aw
#define focus_ah mccchannel_17_cave2_box2_focus_ah
#define focus_xw mccchannel_17_cave2_box2_focus_xw
#define focus_xh mccchannel_17_cave2_box2_focus_xh
#define focus_r mccchannel_17_cave2_box2_focus_r
#define p_interact mccchannel_17_cave2_box2_p_interact
#define mask_string mccchannel_17_cave2_box2_mask_string
#define mask_setting mccchannel_17_cave2_box2_mask_setting
#define number_of_activations mccchannel_17_cave2_box2_number_of_activations
#line 204 "Union_box.comp"
// Needed for transport to the main component
struct global_geometry_element_struct global_geometry_element;

#ifndef ANY_GEOMETRY_DETECTOR_DECLARE
    #define ANY_GEOMETRY_DETECTOR_DECLARE dummy
	//struct pointer_to_global_geometry_list global_geometry_list = {0,NULL};
#endif

int loop_index,found_geometries;

double x_component;
double y_component;
double z_component;

struct Volume_struct this_box_volume;
struct box_storage this_box_storage;

#line 78991 "MACS_sample_kidney_box.c"
#undef number_of_activations
#undef mask_setting
#undef mask_string
#undef p_interact
#undef focus_r
#undef focus_xh
#undef focus_xw
#undef focus_ah
#undef focus_aw
#undef target_z
#undef target_y
#undef target_x
#undef target_index
#undef visualize
#undef yheight2
#undef xwidth2
#undef zdepth
#undef yheight
#undef xwidth
#undef priority
#undef material_string
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

/* User declarations for component 'channel_17_cave2_box3' [799]. */
#define mccompcurname  channel_17_cave2_box3
#define mccompcurtype  Union_box
#define mccompcurindex 799
#define loop_index mccchannel_17_cave2_box3_loop_index
#define this_box_volume mccchannel_17_cave2_box3_this_box_volume
#define global_geometry_element mccchannel_17_cave2_box3_global_geometry_element
#define this_box_storage mccchannel_17_cave2_box3_this_box_storage
#define material_string mccchannel_17_cave2_box3_material_string
#define priority mccchannel_17_cave2_box3_priority
#define xwidth mccchannel_17_cave2_box3_xwidth
#define yheight mccchannel_17_cave2_box3_yheight
#define zdepth mccchannel_17_cave2_box3_zdepth
#define xwidth2 mccchannel_17_cave2_box3_xwidth2
#define yheight2 mccchannel_17_cave2_box3_yheight2
#define visualize mccchannel_17_cave2_box3_visualize
#define target_index mccchannel_17_cave2_box3_target_index
#define target_x mccchannel_17_cave2_box3_target_x
#define target_y mccchannel_17_cave2_box3_target_y
#define target_z mccchannel_17_cave2_box3_target_z
#define focus_aw mccchannel_17_cave2_box3_focus_aw
#define focus_ah mccchannel_17_cave2_box3_focus_ah
#define focus_xw mccchannel_17_cave2_box3_focus_xw
#define focus_xh mccchannel_17_cave2_box3_focus_xh
#define focus_r mccchannel_17_cave2_box3_focus_r
#define p_interact mccchannel_17_cave2_box3_p_interact
#define mask_string mccchannel_17_cave2_box3_mask_string
#define mask_setting mccchannel_17_cave2_box3_mask_setting
#define number_of_activations mccchannel_17_cave2_box3_number_of_activations
#line 204 "Union_box.comp"
// Needed for transport to the main component
struct global_geometry_element_struct global_geometry_element;

#ifndef ANY_GEOMETRY_DETECTOR_DECLARE
    #define ANY_GEOMETRY_DETECTOR_DECLARE dummy
	//struct pointer_to_global_geometry_list global_geometry_list = {0,NULL};
#endif

int loop_index,found_geometries;

double x_component;
double y_component;
double z_component;

struct Volume_struct this_box_volume;
struct box_storage this_box_storage;

#line 79068 "MACS_sample_kidney_box.c"
#undef number_of_activations
#undef mask_setting
#undef mask_string
#undef p_interact
#undef focus_r
#undef focus_xh
#undef focus_xw
#undef focus_ah
#undef focus_aw
#undef target_z
#undef target_y
#undef target_x
#undef target_index
#undef visualize
#undef yheight2
#undef xwidth2
#undef zdepth
#undef yheight
#undef xwidth
#undef priority
#undef material_string
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

/* User declarations for component 'inter_analyzer_colimator_center_17' [800]. */
#define mccompcurname  inter_analyzer_colimator_center_17
#define mccompcurtype  Arm
#define mccompcurindex 800
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

/* User declarations for component 'inter_analyzer_colimator_17_blade_0' [801]. */
#define mccompcurname  inter_analyzer_colimator_17_blade_0
#define mccompcurtype  Union_box
#define mccompcurindex 801
#define loop_index mccinter_analyzer_colimator_17_blade_0_loop_index
#define this_box_volume mccinter_analyzer_colimator_17_blade_0_this_box_volume
#define global_geometry_element mccinter_analyzer_colimator_17_blade_0_global_geometry_element
#define this_box_storage mccinter_analyzer_colimator_17_blade_0_this_box_storage
#define material_string mccinter_analyzer_colimator_17_blade_0_material_string
#define priority mccinter_analyzer_colimator_17_blade_0_priority
#define xwidth mccinter_analyzer_colimator_17_blade_0_xwidth
#define yheight mccinter_analyzer_colimator_17_blade_0_yheight
#define zdepth mccinter_analyzer_colimator_17_blade_0_zdepth
#define xwidth2 mccinter_analyzer_colimator_17_blade_0_xwidth2
#define yheight2 mccinter_analyzer_colimator_17_blade_0_yheight2
#define visualize mccinter_analyzer_colimator_17_blade_0_visualize
#define target_index mccinter_analyzer_colimator_17_blade_0_target_index
#define target_x mccinter_analyzer_colimator_17_blade_0_target_x
#define target_y mccinter_analyzer_colimator_17_blade_0_target_y
#define target_z mccinter_analyzer_colimator_17_blade_0_target_z
#define focus_aw mccinter_analyzer_colimator_17_blade_0_focus_aw
#define focus_ah mccinter_analyzer_colimator_17_blade_0_focus_ah
#define focus_xw mccinter_analyzer_colimator_17_blade_0_focus_xw
#define focus_xh mccinter_analyzer_colimator_17_blade_0_focus_xh
#define focus_r mccinter_analyzer_colimator_17_blade_0_focus_r
#define p_interact mccinter_analyzer_colimator_17_blade_0_p_interact
#define mask_string mccinter_analyzer_colimator_17_blade_0_mask_string
#define mask_setting mccinter_analyzer_colimator_17_blade_0_mask_setting
#define number_of_activations mccinter_analyzer_colimator_17_blade_0_number_of_activations
#line 204 "Union_box.comp"
// Needed for transport to the main component
struct global_geometry_element_struct global_geometry_element;

#ifndef ANY_GEOMETRY_DETECTOR_DECLARE
    #define ANY_GEOMETRY_DETECTOR_DECLARE dummy
	//struct pointer_to_global_geometry_list global_geometry_list = {0,NULL};
#endif

int loop_index,found_geometries;

double x_component;
double y_component;
double z_component;

struct Volume_struct this_box_volume;
struct box_storage this_box_storage;

#line 79153 "MACS_sample_kidney_box.c"
#undef number_of_activations
#undef mask_setting
#undef mask_string
#undef p_interact
#undef focus_r
#undef focus_xh
#undef focus_xw
#undef focus_ah
#undef focus_aw
#undef target_z
#undef target_y
#undef target_x
#undef target_index
#undef visualize
#undef yheight2
#undef xwidth2
#undef zdepth
#undef yheight
#undef xwidth
#undef priority
#undef material_string
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

/* User declarations for component 'inter_analyzer_colimator_17_blade_1' [802]. */
#define mccompcurname  inter_analyzer_colimator_17_blade_1
#define mccompcurtype  Union_box
#define mccompcurindex 802
#define loop_index mccinter_analyzer_colimator_17_blade_1_loop_index
#define this_box_volume mccinter_analyzer_colimator_17_blade_1_this_box_volume
#define global_geometry_element mccinter_analyzer_colimator_17_blade_1_global_geometry_element
#define this_box_storage mccinter_analyzer_colimator_17_blade_1_this_box_storage
#define material_string mccinter_analyzer_colimator_17_blade_1_material_string
#define priority mccinter_analyzer_colimator_17_blade_1_priority
#define xwidth mccinter_analyzer_colimator_17_blade_1_xwidth
#define yheight mccinter_analyzer_colimator_17_blade_1_yheight
#define zdepth mccinter_analyzer_colimator_17_blade_1_zdepth
#define xwidth2 mccinter_analyzer_colimator_17_blade_1_xwidth2
#define yheight2 mccinter_analyzer_colimator_17_blade_1_yheight2
#define visualize mccinter_analyzer_colimator_17_blade_1_visualize
#define target_index mccinter_analyzer_colimator_17_blade_1_target_index
#define target_x mccinter_analyzer_colimator_17_blade_1_target_x
#define target_y mccinter_analyzer_colimator_17_blade_1_target_y
#define target_z mccinter_analyzer_colimator_17_blade_1_target_z
#define focus_aw mccinter_analyzer_colimator_17_blade_1_focus_aw
#define focus_ah mccinter_analyzer_colimator_17_blade_1_focus_ah
#define focus_xw mccinter_analyzer_colimator_17_blade_1_focus_xw
#define focus_xh mccinter_analyzer_colimator_17_blade_1_focus_xh
#define focus_r mccinter_analyzer_colimator_17_blade_1_focus_r
#define p_interact mccinter_analyzer_colimator_17_blade_1_p_interact
#define mask_string mccinter_analyzer_colimator_17_blade_1_mask_string
#define mask_setting mccinter_analyzer_colimator_17_blade_1_mask_setting
#define number_of_activations mccinter_analyzer_colimator_17_blade_1_number_of_activations
#line 204 "Union_box.comp"
// Needed for transport to the main component
struct global_geometry_element_struct global_geometry_element;

#ifndef ANY_GEOMETRY_DETECTOR_DECLARE
    #define ANY_GEOMETRY_DETECTOR_DECLARE dummy
	//struct pointer_to_global_geometry_list global_geometry_list = {0,NULL};
#endif

int loop_index,found_geometries;

double x_component;
double y_component;
double z_component;

struct Volume_struct this_box_volume;
struct box_storage this_box_storage;

#line 79230 "MACS_sample_kidney_box.c"
#undef number_of_activations
#undef mask_setting
#undef mask_string
#undef p_interact
#undef focus_r
#undef focus_xh
#undef focus_xw
#undef focus_ah
#undef focus_aw
#undef target_z
#undef target_y
#undef target_x
#undef target_index
#undef visualize
#undef yheight2
#undef xwidth2
#undef zdepth
#undef yheight
#undef xwidth
#undef priority
#undef material_string
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

/* User declarations for component 'inter_analyzer_colimator_17_blade_2' [803]. */
#define mccompcurname  inter_analyzer_colimator_17_blade_2
#define mccompcurtype  Union_box
#define mccompcurindex 803
#define loop_index mccinter_analyzer_colimator_17_blade_2_loop_index
#define this_box_volume mccinter_analyzer_colimator_17_blade_2_this_box_volume
#define global_geometry_element mccinter_analyzer_colimator_17_blade_2_global_geometry_element
#define this_box_storage mccinter_analyzer_colimator_17_blade_2_this_box_storage
#define material_string mccinter_analyzer_colimator_17_blade_2_material_string
#define priority mccinter_analyzer_colimator_17_blade_2_priority
#define xwidth mccinter_analyzer_colimator_17_blade_2_xwidth
#define yheight mccinter_analyzer_colimator_17_blade_2_yheight
#define zdepth mccinter_analyzer_colimator_17_blade_2_zdepth
#define xwidth2 mccinter_analyzer_colimator_17_blade_2_xwidth2
#define yheight2 mccinter_analyzer_colimator_17_blade_2_yheight2
#define visualize mccinter_analyzer_colimator_17_blade_2_visualize
#define target_index mccinter_analyzer_colimator_17_blade_2_target_index
#define target_x mccinter_analyzer_colimator_17_blade_2_target_x
#define target_y mccinter_analyzer_colimator_17_blade_2_target_y
#define target_z mccinter_analyzer_colimator_17_blade_2_target_z
#define focus_aw mccinter_analyzer_colimator_17_blade_2_focus_aw
#define focus_ah mccinter_analyzer_colimator_17_blade_2_focus_ah
#define focus_xw mccinter_analyzer_colimator_17_blade_2_focus_xw
#define focus_xh mccinter_analyzer_colimator_17_blade_2_focus_xh
#define focus_r mccinter_analyzer_colimator_17_blade_2_focus_r
#define p_interact mccinter_analyzer_colimator_17_blade_2_p_interact
#define mask_string mccinter_analyzer_colimator_17_blade_2_mask_string
#define mask_setting mccinter_analyzer_colimator_17_blade_2_mask_setting
#define number_of_activations mccinter_analyzer_colimator_17_blade_2_number_of_activations
#line 204 "Union_box.comp"
// Needed for transport to the main component
struct global_geometry_element_struct global_geometry_element;

#ifndef ANY_GEOMETRY_DETECTOR_DECLARE
    #define ANY_GEOMETRY_DETECTOR_DECLARE dummy
	//struct pointer_to_global_geometry_list global_geometry_list = {0,NULL};
#endif

int loop_index,found_geometries;

double x_component;
double y_component;
double z_component;

struct Volume_struct this_box_volume;
struct box_storage this_box_storage;

#line 79307 "MACS_sample_kidney_box.c"
#undef number_of_activations
#undef mask_setting
#undef mask_string
#undef p_interact
#undef focus_r
#undef focus_xh
#undef focus_xw
#undef focus_ah
#undef focus_aw
#undef target_z
#undef target_y
#undef target_x
#undef target_index
#undef visualize
#undef yheight2
#undef xwidth2
#undef zdepth
#undef yheight
#undef xwidth
#undef priority
#undef material_string
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

/* User declarations for component 'inter_analyzer_colimator_17_blade_3' [804]. */
#define mccompcurname  inter_analyzer_colimator_17_blade_3
#define mccompcurtype  Union_box
#define mccompcurindex 804
#define loop_index mccinter_analyzer_colimator_17_blade_3_loop_index
#define this_box_volume mccinter_analyzer_colimator_17_blade_3_this_box_volume
#define global_geometry_element mccinter_analyzer_colimator_17_blade_3_global_geometry_element
#define this_box_storage mccinter_analyzer_colimator_17_blade_3_this_box_storage
#define material_string mccinter_analyzer_colimator_17_blade_3_material_string
#define priority mccinter_analyzer_colimator_17_blade_3_priority
#define xwidth mccinter_analyzer_colimator_17_blade_3_xwidth
#define yheight mccinter_analyzer_colimator_17_blade_3_yheight
#define zdepth mccinter_analyzer_colimator_17_blade_3_zdepth
#define xwidth2 mccinter_analyzer_colimator_17_blade_3_xwidth2
#define yheight2 mccinter_analyzer_colimator_17_blade_3_yheight2
#define visualize mccinter_analyzer_colimator_17_blade_3_visualize
#define target_index mccinter_analyzer_colimator_17_blade_3_target_index
#define target_x mccinter_analyzer_colimator_17_blade_3_target_x
#define target_y mccinter_analyzer_colimator_17_blade_3_target_y
#define target_z mccinter_analyzer_colimator_17_blade_3_target_z
#define focus_aw mccinter_analyzer_colimator_17_blade_3_focus_aw
#define focus_ah mccinter_analyzer_colimator_17_blade_3_focus_ah
#define focus_xw mccinter_analyzer_colimator_17_blade_3_focus_xw
#define focus_xh mccinter_analyzer_colimator_17_blade_3_focus_xh
#define focus_r mccinter_analyzer_colimator_17_blade_3_focus_r
#define p_interact mccinter_analyzer_colimator_17_blade_3_p_interact
#define mask_string mccinter_analyzer_colimator_17_blade_3_mask_string
#define mask_setting mccinter_analyzer_colimator_17_blade_3_mask_setting
#define number_of_activations mccinter_analyzer_colimator_17_blade_3_number_of_activations
#line 204 "Union_box.comp"
// Needed for transport to the main component
struct global_geometry_element_struct global_geometry_element;

#ifndef ANY_GEOMETRY_DETECTOR_DECLARE
    #define ANY_GEOMETRY_DETECTOR_DECLARE dummy
	//struct pointer_to_global_geometry_list global_geometry_list = {0,NULL};
#endif

int loop_index,found_geometries;

double x_component;
double y_component;
double z_component;

struct Volume_struct this_box_volume;
struct box_storage this_box_storage;

#line 79384 "MACS_sample_kidney_box.c"
#undef number_of_activations
#undef mask_setting
#undef mask_string
#undef p_interact
#undef focus_r
#undef focus_xh
#undef focus_xw
#undef focus_ah
#undef focus_aw
#undef target_z
#undef target_y
#undef target_x
#undef target_index
#undef visualize
#undef yheight2
#undef xwidth2
#undef zdepth
#undef yheight
#undef xwidth
#undef priority
#undef material_string
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

/* User declarations for component 'inter_analyzer_colimator_17_blade_4' [805]. */
#define mccompcurname  inter_analyzer_colimator_17_blade_4
#define mccompcurtype  Union_box
#define mccompcurindex 805
#define loop_index mccinter_analyzer_colimator_17_blade_4_loop_index
#define this_box_volume mccinter_analyzer_colimator_17_blade_4_this_box_volume
#define global_geometry_element mccinter_analyzer_colimator_17_blade_4_global_geometry_element
#define this_box_storage mccinter_analyzer_colimator_17_blade_4_this_box_storage
#define material_string mccinter_analyzer_colimator_17_blade_4_material_string
#define priority mccinter_analyzer_colimator_17_blade_4_priority
#define xwidth mccinter_analyzer_colimator_17_blade_4_xwidth
#define yheight mccinter_analyzer_colimator_17_blade_4_yheight
#define zdepth mccinter_analyzer_colimator_17_blade_4_zdepth
#define xwidth2 mccinter_analyzer_colimator_17_blade_4_xwidth2
#define yheight2 mccinter_analyzer_colimator_17_blade_4_yheight2
#define visualize mccinter_analyzer_colimator_17_blade_4_visualize
#define target_index mccinter_analyzer_colimator_17_blade_4_target_index
#define target_x mccinter_analyzer_colimator_17_blade_4_target_x
#define target_y mccinter_analyzer_colimator_17_blade_4_target_y
#define target_z mccinter_analyzer_colimator_17_blade_4_target_z
#define focus_aw mccinter_analyzer_colimator_17_blade_4_focus_aw
#define focus_ah mccinter_analyzer_colimator_17_blade_4_focus_ah
#define focus_xw mccinter_analyzer_colimator_17_blade_4_focus_xw
#define focus_xh mccinter_analyzer_colimator_17_blade_4_focus_xh
#define focus_r mccinter_analyzer_colimator_17_blade_4_focus_r
#define p_interact mccinter_analyzer_colimator_17_blade_4_p_interact
#define mask_string mccinter_analyzer_colimator_17_blade_4_mask_string
#define mask_setting mccinter_analyzer_colimator_17_blade_4_mask_setting
#define number_of_activations mccinter_analyzer_colimator_17_blade_4_number_of_activations
#line 204 "Union_box.comp"
// Needed for transport to the main component
struct global_geometry_element_struct global_geometry_element;

#ifndef ANY_GEOMETRY_DETECTOR_DECLARE
    #define ANY_GEOMETRY_DETECTOR_DECLARE dummy
	//struct pointer_to_global_geometry_list global_geometry_list = {0,NULL};
#endif

int loop_index,found_geometries;

double x_component;
double y_component;
double z_component;

struct Volume_struct this_box_volume;
struct box_storage this_box_storage;

#line 79461 "MACS_sample_kidney_box.c"
#undef number_of_activations
#undef mask_setting
#undef mask_string
#undef p_interact
#undef focus_r
#undef focus_xh
#undef focus_xw
#undef focus_ah
#undef focus_aw
#undef target_z
#undef target_y
#undef target_x
#undef target_index
#undef visualize
#undef yheight2
#undef xwidth2
#undef zdepth
#undef yheight
#undef xwidth
#undef priority
#undef material_string
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

/* User declarations for component 'diffraction_detector_17_exit_volume' [806]. */
#define mccompcurname  diffraction_detector_17_exit_volume
#define mccompcurtype  Union_box
#define mccompcurindex 806
#define loop_index mccdiffraction_detector_17_exit_volume_loop_index
#define this_box_volume mccdiffraction_detector_17_exit_volume_this_box_volume
#define global_geometry_element mccdiffraction_detector_17_exit_volume_global_geometry_element
#define this_box_storage mccdiffraction_detector_17_exit_volume_this_box_storage
#define material_string mccdiffraction_detector_17_exit_volume_material_string
#define priority mccdiffraction_detector_17_exit_volume_priority
#define xwidth mccdiffraction_detector_17_exit_volume_xwidth
#define yheight mccdiffraction_detector_17_exit_volume_yheight
#define zdepth mccdiffraction_detector_17_exit_volume_zdepth
#define xwidth2 mccdiffraction_detector_17_exit_volume_xwidth2
#define yheight2 mccdiffraction_detector_17_exit_volume_yheight2
#define visualize mccdiffraction_detector_17_exit_volume_visualize
#define target_index mccdiffraction_detector_17_exit_volume_target_index
#define target_x mccdiffraction_detector_17_exit_volume_target_x
#define target_y mccdiffraction_detector_17_exit_volume_target_y
#define target_z mccdiffraction_detector_17_exit_volume_target_z
#define focus_aw mccdiffraction_detector_17_exit_volume_focus_aw
#define focus_ah mccdiffraction_detector_17_exit_volume_focus_ah
#define focus_xw mccdiffraction_detector_17_exit_volume_focus_xw
#define focus_xh mccdiffraction_detector_17_exit_volume_focus_xh
#define focus_r mccdiffraction_detector_17_exit_volume_focus_r
#define p_interact mccdiffraction_detector_17_exit_volume_p_interact
#define mask_string mccdiffraction_detector_17_exit_volume_mask_string
#define mask_setting mccdiffraction_detector_17_exit_volume_mask_setting
#define number_of_activations mccdiffraction_detector_17_exit_volume_number_of_activations
#line 204 "Union_box.comp"
// Needed for transport to the main component
struct global_geometry_element_struct global_geometry_element;

#ifndef ANY_GEOMETRY_DETECTOR_DECLARE
    #define ANY_GEOMETRY_DETECTOR_DECLARE dummy
	//struct pointer_to_global_geometry_list global_geometry_list = {0,NULL};
#endif

int loop_index,found_geometries;

double x_component;
double y_component;
double z_component;

struct Volume_struct this_box_volume;
struct box_storage this_box_storage;

#line 79538 "MACS_sample_kidney_box.c"
#undef number_of_activations
#undef mask_setting
#undef mask_string
#undef p_interact
#undef focus_r
#undef focus_xh
#undef focus_xw
#undef focus_ah
#undef focus_aw
#undef target_z
#undef target_y
#undef target_x
#undef target_index
#undef visualize
#undef yheight2
#undef xwidth2
#undef zdepth
#undef yheight
#undef xwidth
#undef priority
#undef material_string
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

/* User declarations for component 'spec_detector_17_exit_volume' [807]. */
#define mccompcurname  spec_detector_17_exit_volume
#define mccompcurtype  Union_box
#define mccompcurindex 807
#define loop_index mccspec_detector_17_exit_volume_loop_index
#define this_box_volume mccspec_detector_17_exit_volume_this_box_volume
#define global_geometry_element mccspec_detector_17_exit_volume_global_geometry_element
#define this_box_storage mccspec_detector_17_exit_volume_this_box_storage
#define material_string mccspec_detector_17_exit_volume_material_string
#define priority mccspec_detector_17_exit_volume_priority
#define xwidth mccspec_detector_17_exit_volume_xwidth
#define yheight mccspec_detector_17_exit_volume_yheight
#define zdepth mccspec_detector_17_exit_volume_zdepth
#define xwidth2 mccspec_detector_17_exit_volume_xwidth2
#define yheight2 mccspec_detector_17_exit_volume_yheight2
#define visualize mccspec_detector_17_exit_volume_visualize
#define target_index mccspec_detector_17_exit_volume_target_index
#define target_x mccspec_detector_17_exit_volume_target_x
#define target_y mccspec_detector_17_exit_volume_target_y
#define target_z mccspec_detector_17_exit_volume_target_z
#define focus_aw mccspec_detector_17_exit_volume_focus_aw
#define focus_ah mccspec_detector_17_exit_volume_focus_ah
#define focus_xw mccspec_detector_17_exit_volume_focus_xw
#define focus_xh mccspec_detector_17_exit_volume_focus_xh
#define focus_r mccspec_detector_17_exit_volume_focus_r
#define p_interact mccspec_detector_17_exit_volume_p_interact
#define mask_string mccspec_detector_17_exit_volume_mask_string
#define mask_setting mccspec_detector_17_exit_volume_mask_setting
#define number_of_activations mccspec_detector_17_exit_volume_number_of_activations
#line 204 "Union_box.comp"
// Needed for transport to the main component
struct global_geometry_element_struct global_geometry_element;

#ifndef ANY_GEOMETRY_DETECTOR_DECLARE
    #define ANY_GEOMETRY_DETECTOR_DECLARE dummy
	//struct pointer_to_global_geometry_list global_geometry_list = {0,NULL};
#endif

int loop_index,found_geometries;

double x_component;
double y_component;
double z_component;

struct Volume_struct this_box_volume;
struct box_storage this_box_storage;

#line 79615 "MACS_sample_kidney_box.c"
#undef number_of_activations
#undef mask_setting
#undef mask_string
#undef p_interact
#undef focus_r
#undef focus_xh
#undef focus_xw
#undef focus_ah
#undef focus_aw
#undef target_z
#undef target_y
#undef target_x
#undef target_index
#undef visualize
#undef yheight2
#undef xwidth2
#undef zdepth
#undef yheight
#undef xwidth
#undef priority
#undef material_string
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

/* User declarations for component 'channel_18_cave1_box1' [808]. */
#define mccompcurname  channel_18_cave1_box1
#define mccompcurtype  Union_box
#define mccompcurindex 808
#define loop_index mccchannel_18_cave1_box1_loop_index
#define this_box_volume mccchannel_18_cave1_box1_this_box_volume
#define global_geometry_element mccchannel_18_cave1_box1_global_geometry_element
#define this_box_storage mccchannel_18_cave1_box1_this_box_storage
#define material_string mccchannel_18_cave1_box1_material_string
#define priority mccchannel_18_cave1_box1_priority
#define xwidth mccchannel_18_cave1_box1_xwidth
#define yheight mccchannel_18_cave1_box1_yheight
#define zdepth mccchannel_18_cave1_box1_zdepth
#define xwidth2 mccchannel_18_cave1_box1_xwidth2
#define yheight2 mccchannel_18_cave1_box1_yheight2
#define visualize mccchannel_18_cave1_box1_visualize
#define target_index mccchannel_18_cave1_box1_target_index
#define target_x mccchannel_18_cave1_box1_target_x
#define target_y mccchannel_18_cave1_box1_target_y
#define target_z mccchannel_18_cave1_box1_target_z
#define focus_aw mccchannel_18_cave1_box1_focus_aw
#define focus_ah mccchannel_18_cave1_box1_focus_ah
#define focus_xw mccchannel_18_cave1_box1_focus_xw
#define focus_xh mccchannel_18_cave1_box1_focus_xh
#define focus_r mccchannel_18_cave1_box1_focus_r
#define p_interact mccchannel_18_cave1_box1_p_interact
#define mask_string mccchannel_18_cave1_box1_mask_string
#define mask_setting mccchannel_18_cave1_box1_mask_setting
#define number_of_activations mccchannel_18_cave1_box1_number_of_activations
#line 204 "Union_box.comp"
// Needed for transport to the main component
struct global_geometry_element_struct global_geometry_element;

#ifndef ANY_GEOMETRY_DETECTOR_DECLARE
    #define ANY_GEOMETRY_DETECTOR_DECLARE dummy
	//struct pointer_to_global_geometry_list global_geometry_list = {0,NULL};
#endif

int loop_index,found_geometries;

double x_component;
double y_component;
double z_component;

struct Volume_struct this_box_volume;
struct box_storage this_box_storage;

#line 79692 "MACS_sample_kidney_box.c"
#undef number_of_activations
#undef mask_setting
#undef mask_string
#undef p_interact
#undef focus_r
#undef focus_xh
#undef focus_xw
#undef focus_ah
#undef focus_aw
#undef target_z
#undef target_y
#undef target_x
#undef target_index
#undef visualize
#undef yheight2
#undef xwidth2
#undef zdepth
#undef yheight
#undef xwidth
#undef priority
#undef material_string
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

/* User declarations for component 'channel_18_cave1_box2' [809]. */
#define mccompcurname  channel_18_cave1_box2
#define mccompcurtype  Union_box
#define mccompcurindex 809
#define loop_index mccchannel_18_cave1_box2_loop_index
#define this_box_volume mccchannel_18_cave1_box2_this_box_volume
#define global_geometry_element mccchannel_18_cave1_box2_global_geometry_element
#define this_box_storage mccchannel_18_cave1_box2_this_box_storage
#define material_string mccchannel_18_cave1_box2_material_string
#define priority mccchannel_18_cave1_box2_priority
#define xwidth mccchannel_18_cave1_box2_xwidth
#define yheight mccchannel_18_cave1_box2_yheight
#define zdepth mccchannel_18_cave1_box2_zdepth
#define xwidth2 mccchannel_18_cave1_box2_xwidth2
#define yheight2 mccchannel_18_cave1_box2_yheight2
#define visualize mccchannel_18_cave1_box2_visualize
#define target_index mccchannel_18_cave1_box2_target_index
#define target_x mccchannel_18_cave1_box2_target_x
#define target_y mccchannel_18_cave1_box2_target_y
#define target_z mccchannel_18_cave1_box2_target_z
#define focus_aw mccchannel_18_cave1_box2_focus_aw
#define focus_ah mccchannel_18_cave1_box2_focus_ah
#define focus_xw mccchannel_18_cave1_box2_focus_xw
#define focus_xh mccchannel_18_cave1_box2_focus_xh
#define focus_r mccchannel_18_cave1_box2_focus_r
#define p_interact mccchannel_18_cave1_box2_p_interact
#define mask_string mccchannel_18_cave1_box2_mask_string
#define mask_setting mccchannel_18_cave1_box2_mask_setting
#define number_of_activations mccchannel_18_cave1_box2_number_of_activations
#line 204 "Union_box.comp"
// Needed for transport to the main component
struct global_geometry_element_struct global_geometry_element;

#ifndef ANY_GEOMETRY_DETECTOR_DECLARE
    #define ANY_GEOMETRY_DETECTOR_DECLARE dummy
	//struct pointer_to_global_geometry_list global_geometry_list = {0,NULL};
#endif

int loop_index,found_geometries;

double x_component;
double y_component;
double z_component;

struct Volume_struct this_box_volume;
struct box_storage this_box_storage;

#line 79769 "MACS_sample_kidney_box.c"
#undef number_of_activations
#undef mask_setting
#undef mask_string
#undef p_interact
#undef focus_r
#undef focus_xh
#undef focus_xw
#undef focus_ah
#undef focus_aw
#undef target_z
#undef target_y
#undef target_x
#undef target_index
#undef visualize
#undef yheight2
#undef xwidth2
#undef zdepth
#undef yheight
#undef xwidth
#undef priority
#undef material_string
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

/* User declarations for component 'channel_18_cave1_box3' [810]. */
#define mccompcurname  channel_18_cave1_box3
#define mccompcurtype  Union_box
#define mccompcurindex 810
#define loop_index mccchannel_18_cave1_box3_loop_index
#define this_box_volume mccchannel_18_cave1_box3_this_box_volume
#define global_geometry_element mccchannel_18_cave1_box3_global_geometry_element
#define this_box_storage mccchannel_18_cave1_box3_this_box_storage
#define material_string mccchannel_18_cave1_box3_material_string
#define priority mccchannel_18_cave1_box3_priority
#define xwidth mccchannel_18_cave1_box3_xwidth
#define yheight mccchannel_18_cave1_box3_yheight
#define zdepth mccchannel_18_cave1_box3_zdepth
#define xwidth2 mccchannel_18_cave1_box3_xwidth2
#define yheight2 mccchannel_18_cave1_box3_yheight2
#define visualize mccchannel_18_cave1_box3_visualize
#define target_index mccchannel_18_cave1_box3_target_index
#define target_x mccchannel_18_cave1_box3_target_x
#define target_y mccchannel_18_cave1_box3_target_y
#define target_z mccchannel_18_cave1_box3_target_z
#define focus_aw mccchannel_18_cave1_box3_focus_aw
#define focus_ah mccchannel_18_cave1_box3_focus_ah
#define focus_xw mccchannel_18_cave1_box3_focus_xw
#define focus_xh mccchannel_18_cave1_box3_focus_xh
#define focus_r mccchannel_18_cave1_box3_focus_r
#define p_interact mccchannel_18_cave1_box3_p_interact
#define mask_string mccchannel_18_cave1_box3_mask_string
#define mask_setting mccchannel_18_cave1_box3_mask_setting
#define number_of_activations mccchannel_18_cave1_box3_number_of_activations
#line 204 "Union_box.comp"
// Needed for transport to the main component
struct global_geometry_element_struct global_geometry_element;

#ifndef ANY_GEOMETRY_DETECTOR_DECLARE
    #define ANY_GEOMETRY_DETECTOR_DECLARE dummy
	//struct pointer_to_global_geometry_list global_geometry_list = {0,NULL};
#endif

int loop_index,found_geometries;

double x_component;
double y_component;
double z_component;

struct Volume_struct this_box_volume;
struct box_storage this_box_storage;

#line 79846 "MACS_sample_kidney_box.c"
#undef number_of_activations
#undef mask_setting
#undef mask_string
#undef p_interact
#undef focus_r
#undef focus_xh
#undef focus_xw
#undef focus_ah
#undef focus_aw
#undef target_z
#undef target_y
#undef target_x
#undef target_index
#undef visualize
#undef yheight2
#undef xwidth2
#undef zdepth
#undef yheight
#undef xwidth
#undef priority
#undef material_string
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

/* User declarations for component 'channel_18_cave1_cyl1' [811]. */
#define mccompcurname  channel_18_cave1_cyl1
#define mccompcurtype  Union_cylinder
#define mccompcurindex 811
#define loop_index mccchannel_18_cave1_cyl1_loop_index
#define this_cylinder_volume mccchannel_18_cave1_cyl1_this_cylinder_volume
#define global_geometry_element mccchannel_18_cave1_cyl1_global_geometry_element
#define this_cylinder_storage mccchannel_18_cave1_cyl1_this_cylinder_storage
#define material_string mccchannel_18_cave1_cyl1_material_string
#define priority mccchannel_18_cave1_cyl1_priority
#define radius mccchannel_18_cave1_cyl1_radius
#define yheight mccchannel_18_cave1_cyl1_yheight
#define visualize mccchannel_18_cave1_cyl1_visualize
#define target_index mccchannel_18_cave1_cyl1_target_index
#define target_x mccchannel_18_cave1_cyl1_target_x
#define target_y mccchannel_18_cave1_cyl1_target_y
#define target_z mccchannel_18_cave1_cyl1_target_z
#define focus_aw mccchannel_18_cave1_cyl1_focus_aw
#define focus_ah mccchannel_18_cave1_cyl1_focus_ah
#define focus_xw mccchannel_18_cave1_cyl1_focus_xw
#define focus_xh mccchannel_18_cave1_cyl1_focus_xh
#define focus_r mccchannel_18_cave1_cyl1_focus_r
#define p_interact mccchannel_18_cave1_cyl1_p_interact
#define mask_string mccchannel_18_cave1_cyl1_mask_string
#define mask_setting mccchannel_18_cave1_cyl1_mask_setting
#define number_of_activations mccchannel_18_cave1_cyl1_number_of_activations
#line 167 "Union_cylinder.comp"
// Needed for transport to the main component
struct global_geometry_element_struct global_geometry_element;

#ifndef ANY_GEOMETRY_DETECTOR_DECLARE
    #define ANY_GEOMETRY_DETECTOR_DECLARE dummy
	//struct pointer_to_global_geometry_list global_geometry_list = {0,NULL};
#endif

int dummy;
int loop_index,found_geometries;
int loop_2_index;
int material_index;

struct Volume_struct this_cylinder_volume;
struct cylinder_storage this_cylinder_storage;
#line 79918 "MACS_sample_kidney_box.c"
#undef number_of_activations
#undef mask_setting
#undef mask_string
#undef p_interact
#undef focus_r
#undef focus_xh
#undef focus_xw
#undef focus_ah
#undef focus_aw
#undef target_z
#undef target_y
#undef target_x
#undef target_index
#undef visualize
#undef yheight
#undef radius
#undef priority
#undef material_string
#undef this_cylinder_storage
#undef global_geometry_element
#undef this_cylinder_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

/* User declarations for component 'channel_18_analyzer_1_center' [812]. */
#define mccompcurname  channel_18_analyzer_1_center
#define mccompcurtype  Arm
#define mccompcurindex 812
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

/* User declarations for component 'channel_18_analyzer_1_rotated' [813]. */
#define mccompcurname  channel_18_analyzer_1_rotated
#define mccompcurtype  Arm
#define mccompcurindex 813
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

/* User declarations for component 'channel_18_analyzer_1_array_crystal_array_0' [814]. */
#define mccompcurname  channel_18_analyzer_1_array_crystal_array_0
#define mccompcurtype  Union_box
#define mccompcurindex 814
#define loop_index mccchannel_18_analyzer_1_array_crystal_array_0_loop_index
#define this_box_volume mccchannel_18_analyzer_1_array_crystal_array_0_this_box_volume
#define global_geometry_element mccchannel_18_analyzer_1_array_crystal_array_0_global_geometry_element
#define this_box_storage mccchannel_18_analyzer_1_array_crystal_array_0_this_box_storage
#define material_string mccchannel_18_analyzer_1_array_crystal_array_0_material_string
#define priority mccchannel_18_analyzer_1_array_crystal_array_0_priority
#define xwidth mccchannel_18_analyzer_1_array_crystal_array_0_xwidth
#define yheight mccchannel_18_analyzer_1_array_crystal_array_0_yheight
#define zdepth mccchannel_18_analyzer_1_array_crystal_array_0_zdepth
#define xwidth2 mccchannel_18_analyzer_1_array_crystal_array_0_xwidth2
#define yheight2 mccchannel_18_analyzer_1_array_crystal_array_0_yheight2
#define visualize mccchannel_18_analyzer_1_array_crystal_array_0_visualize
#define target_index mccchannel_18_analyzer_1_array_crystal_array_0_target_index
#define target_x mccchannel_18_analyzer_1_array_crystal_array_0_target_x
#define target_y mccchannel_18_analyzer_1_array_crystal_array_0_target_y
#define target_z mccchannel_18_analyzer_1_array_crystal_array_0_target_z
#define focus_aw mccchannel_18_analyzer_1_array_crystal_array_0_focus_aw
#define focus_ah mccchannel_18_analyzer_1_array_crystal_array_0_focus_ah
#define focus_xw mccchannel_18_analyzer_1_array_crystal_array_0_focus_xw
#define focus_xh mccchannel_18_analyzer_1_array_crystal_array_0_focus_xh
#define focus_r mccchannel_18_analyzer_1_array_crystal_array_0_focus_r
#define p_interact mccchannel_18_analyzer_1_array_crystal_array_0_p_interact
#define mask_string mccchannel_18_analyzer_1_array_crystal_array_0_mask_string
#define mask_setting mccchannel_18_analyzer_1_array_crystal_array_0_mask_setting
#define number_of_activations mccchannel_18_analyzer_1_array_crystal_array_0_number_of_activations
#line 204 "Union_box.comp"
// Needed for transport to the main component
struct global_geometry_element_struct global_geometry_element;

#ifndef ANY_GEOMETRY_DETECTOR_DECLARE
    #define ANY_GEOMETRY_DETECTOR_DECLARE dummy
	//struct pointer_to_global_geometry_list global_geometry_list = {0,NULL};
#endif

int loop_index,found_geometries;

double x_component;
double y_component;
double z_component;

struct Volume_struct this_box_volume;
struct box_storage this_box_storage;

#line 80008 "MACS_sample_kidney_box.c"
#undef number_of_activations
#undef mask_setting
#undef mask_string
#undef p_interact
#undef focus_r
#undef focus_xh
#undef focus_xw
#undef focus_ah
#undef focus_aw
#undef target_z
#undef target_y
#undef target_x
#undef target_index
#undef visualize
#undef yheight2
#undef xwidth2
#undef zdepth
#undef yheight
#undef xwidth
#undef priority
#undef material_string
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

/* User declarations for component 'channel_18_analyzer_1_array_crystal_array_1' [815]. */
#define mccompcurname  channel_18_analyzer_1_array_crystal_array_1
#define mccompcurtype  Union_box
#define mccompcurindex 815
#define loop_index mccchannel_18_analyzer_1_array_crystal_array_1_loop_index
#define this_box_volume mccchannel_18_analyzer_1_array_crystal_array_1_this_box_volume
#define global_geometry_element mccchannel_18_analyzer_1_array_crystal_array_1_global_geometry_element
#define this_box_storage mccchannel_18_analyzer_1_array_crystal_array_1_this_box_storage
#define material_string mccchannel_18_analyzer_1_array_crystal_array_1_material_string
#define priority mccchannel_18_analyzer_1_array_crystal_array_1_priority
#define xwidth mccchannel_18_analyzer_1_array_crystal_array_1_xwidth
#define yheight mccchannel_18_analyzer_1_array_crystal_array_1_yheight
#define zdepth mccchannel_18_analyzer_1_array_crystal_array_1_zdepth
#define xwidth2 mccchannel_18_analyzer_1_array_crystal_array_1_xwidth2
#define yheight2 mccchannel_18_analyzer_1_array_crystal_array_1_yheight2
#define visualize mccchannel_18_analyzer_1_array_crystal_array_1_visualize
#define target_index mccchannel_18_analyzer_1_array_crystal_array_1_target_index
#define target_x mccchannel_18_analyzer_1_array_crystal_array_1_target_x
#define target_y mccchannel_18_analyzer_1_array_crystal_array_1_target_y
#define target_z mccchannel_18_analyzer_1_array_crystal_array_1_target_z
#define focus_aw mccchannel_18_analyzer_1_array_crystal_array_1_focus_aw
#define focus_ah mccchannel_18_analyzer_1_array_crystal_array_1_focus_ah
#define focus_xw mccchannel_18_analyzer_1_array_crystal_array_1_focus_xw
#define focus_xh mccchannel_18_analyzer_1_array_crystal_array_1_focus_xh
#define focus_r mccchannel_18_analyzer_1_array_crystal_array_1_focus_r
#define p_interact mccchannel_18_analyzer_1_array_crystal_array_1_p_interact
#define mask_string mccchannel_18_analyzer_1_array_crystal_array_1_mask_string
#define mask_setting mccchannel_18_analyzer_1_array_crystal_array_1_mask_setting
#define number_of_activations mccchannel_18_analyzer_1_array_crystal_array_1_number_of_activations
#line 204 "Union_box.comp"
// Needed for transport to the main component
struct global_geometry_element_struct global_geometry_element;

#ifndef ANY_GEOMETRY_DETECTOR_DECLARE
    #define ANY_GEOMETRY_DETECTOR_DECLARE dummy
	//struct pointer_to_global_geometry_list global_geometry_list = {0,NULL};
#endif

int loop_index,found_geometries;

double x_component;
double y_component;
double z_component;

struct Volume_struct this_box_volume;
struct box_storage this_box_storage;

#line 80085 "MACS_sample_kidney_box.c"
#undef number_of_activations
#undef mask_setting
#undef mask_string
#undef p_interact
#undef focus_r
#undef focus_xh
#undef focus_xw
#undef focus_ah
#undef focus_aw
#undef target_z
#undef target_y
#undef target_x
#undef target_index
#undef visualize
#undef yheight2
#undef xwidth2
#undef zdepth
#undef yheight
#undef xwidth
#undef priority
#undef material_string
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

/* User declarations for component 'channel_18_analyzer_1_array_crystal_array_2' [816]. */
#define mccompcurname  channel_18_analyzer_1_array_crystal_array_2
#define mccompcurtype  Union_box
#define mccompcurindex 816
#define loop_index mccchannel_18_analyzer_1_array_crystal_array_2_loop_index
#define this_box_volume mccchannel_18_analyzer_1_array_crystal_array_2_this_box_volume
#define global_geometry_element mccchannel_18_analyzer_1_array_crystal_array_2_global_geometry_element
#define this_box_storage mccchannel_18_analyzer_1_array_crystal_array_2_this_box_storage
#define material_string mccchannel_18_analyzer_1_array_crystal_array_2_material_string
#define priority mccchannel_18_analyzer_1_array_crystal_array_2_priority
#define xwidth mccchannel_18_analyzer_1_array_crystal_array_2_xwidth
#define yheight mccchannel_18_analyzer_1_array_crystal_array_2_yheight
#define zdepth mccchannel_18_analyzer_1_array_crystal_array_2_zdepth
#define xwidth2 mccchannel_18_analyzer_1_array_crystal_array_2_xwidth2
#define yheight2 mccchannel_18_analyzer_1_array_crystal_array_2_yheight2
#define visualize mccchannel_18_analyzer_1_array_crystal_array_2_visualize
#define target_index mccchannel_18_analyzer_1_array_crystal_array_2_target_index
#define target_x mccchannel_18_analyzer_1_array_crystal_array_2_target_x
#define target_y mccchannel_18_analyzer_1_array_crystal_array_2_target_y
#define target_z mccchannel_18_analyzer_1_array_crystal_array_2_target_z
#define focus_aw mccchannel_18_analyzer_1_array_crystal_array_2_focus_aw
#define focus_ah mccchannel_18_analyzer_1_array_crystal_array_2_focus_ah
#define focus_xw mccchannel_18_analyzer_1_array_crystal_array_2_focus_xw
#define focus_xh mccchannel_18_analyzer_1_array_crystal_array_2_focus_xh
#define focus_r mccchannel_18_analyzer_1_array_crystal_array_2_focus_r
#define p_interact mccchannel_18_analyzer_1_array_crystal_array_2_p_interact
#define mask_string mccchannel_18_analyzer_1_array_crystal_array_2_mask_string
#define mask_setting mccchannel_18_analyzer_1_array_crystal_array_2_mask_setting
#define number_of_activations mccchannel_18_analyzer_1_array_crystal_array_2_number_of_activations
#line 204 "Union_box.comp"
// Needed for transport to the main component
struct global_geometry_element_struct global_geometry_element;

#ifndef ANY_GEOMETRY_DETECTOR_DECLARE
    #define ANY_GEOMETRY_DETECTOR_DECLARE dummy
	//struct pointer_to_global_geometry_list global_geometry_list = {0,NULL};
#endif

int loop_index,found_geometries;

double x_component;
double y_component;
double z_component;

struct Volume_struct this_box_volume;
struct box_storage this_box_storage;

#line 80162 "MACS_sample_kidney_box.c"
#undef number_of_activations
#undef mask_setting
#undef mask_string
#undef p_interact
#undef focus_r
#undef focus_xh
#undef focus_xw
#undef focus_ah
#undef focus_aw
#undef target_z
#undef target_y
#undef target_x
#undef target_index
#undef visualize
#undef yheight2
#undef xwidth2
#undef zdepth
#undef yheight
#undef xwidth
#undef priority
#undef material_string
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

/* User declarations for component 'channel_18_analyzer_1_array_crystal_array_3' [817]. */
#define mccompcurname  channel_18_analyzer_1_array_crystal_array_3
#define mccompcurtype  Union_box
#define mccompcurindex 817
#define loop_index mccchannel_18_analyzer_1_array_crystal_array_3_loop_index
#define this_box_volume mccchannel_18_analyzer_1_array_crystal_array_3_this_box_volume
#define global_geometry_element mccchannel_18_analyzer_1_array_crystal_array_3_global_geometry_element
#define this_box_storage mccchannel_18_analyzer_1_array_crystal_array_3_this_box_storage
#define material_string mccchannel_18_analyzer_1_array_crystal_array_3_material_string
#define priority mccchannel_18_analyzer_1_array_crystal_array_3_priority
#define xwidth mccchannel_18_analyzer_1_array_crystal_array_3_xwidth
#define yheight mccchannel_18_analyzer_1_array_crystal_array_3_yheight
#define zdepth mccchannel_18_analyzer_1_array_crystal_array_3_zdepth
#define xwidth2 mccchannel_18_analyzer_1_array_crystal_array_3_xwidth2
#define yheight2 mccchannel_18_analyzer_1_array_crystal_array_3_yheight2
#define visualize mccchannel_18_analyzer_1_array_crystal_array_3_visualize
#define target_index mccchannel_18_analyzer_1_array_crystal_array_3_target_index
#define target_x mccchannel_18_analyzer_1_array_crystal_array_3_target_x
#define target_y mccchannel_18_analyzer_1_array_crystal_array_3_target_y
#define target_z mccchannel_18_analyzer_1_array_crystal_array_3_target_z
#define focus_aw mccchannel_18_analyzer_1_array_crystal_array_3_focus_aw
#define focus_ah mccchannel_18_analyzer_1_array_crystal_array_3_focus_ah
#define focus_xw mccchannel_18_analyzer_1_array_crystal_array_3_focus_xw
#define focus_xh mccchannel_18_analyzer_1_array_crystal_array_3_focus_xh
#define focus_r mccchannel_18_analyzer_1_array_crystal_array_3_focus_r
#define p_interact mccchannel_18_analyzer_1_array_crystal_array_3_p_interact
#define mask_string mccchannel_18_analyzer_1_array_crystal_array_3_mask_string
#define mask_setting mccchannel_18_analyzer_1_array_crystal_array_3_mask_setting
#define number_of_activations mccchannel_18_analyzer_1_array_crystal_array_3_number_of_activations
#line 204 "Union_box.comp"
// Needed for transport to the main component
struct global_geometry_element_struct global_geometry_element;

#ifndef ANY_GEOMETRY_DETECTOR_DECLARE
    #define ANY_GEOMETRY_DETECTOR_DECLARE dummy
	//struct pointer_to_global_geometry_list global_geometry_list = {0,NULL};
#endif

int loop_index,found_geometries;

double x_component;
double y_component;
double z_component;

struct Volume_struct this_box_volume;
struct box_storage this_box_storage;

#line 80239 "MACS_sample_kidney_box.c"
#undef number_of_activations
#undef mask_setting
#undef mask_string
#undef p_interact
#undef focus_r
#undef focus_xh
#undef focus_xw
#undef focus_ah
#undef focus_aw
#undef target_z
#undef target_y
#undef target_x
#undef target_index
#undef visualize
#undef yheight2
#undef xwidth2
#undef zdepth
#undef yheight
#undef xwidth
#undef priority
#undef material_string
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

/* User declarations for component 'channel_18_analyzer_1_array_crystal_array_4' [818]. */
#define mccompcurname  channel_18_analyzer_1_array_crystal_array_4
#define mccompcurtype  Union_box
#define mccompcurindex 818
#define loop_index mccchannel_18_analyzer_1_array_crystal_array_4_loop_index
#define this_box_volume mccchannel_18_analyzer_1_array_crystal_array_4_this_box_volume
#define global_geometry_element mccchannel_18_analyzer_1_array_crystal_array_4_global_geometry_element
#define this_box_storage mccchannel_18_analyzer_1_array_crystal_array_4_this_box_storage
#define material_string mccchannel_18_analyzer_1_array_crystal_array_4_material_string
#define priority mccchannel_18_analyzer_1_array_crystal_array_4_priority
#define xwidth mccchannel_18_analyzer_1_array_crystal_array_4_xwidth
#define yheight mccchannel_18_analyzer_1_array_crystal_array_4_yheight
#define zdepth mccchannel_18_analyzer_1_array_crystal_array_4_zdepth
#define xwidth2 mccchannel_18_analyzer_1_array_crystal_array_4_xwidth2
#define yheight2 mccchannel_18_analyzer_1_array_crystal_array_4_yheight2
#define visualize mccchannel_18_analyzer_1_array_crystal_array_4_visualize
#define target_index mccchannel_18_analyzer_1_array_crystal_array_4_target_index
#define target_x mccchannel_18_analyzer_1_array_crystal_array_4_target_x
#define target_y mccchannel_18_analyzer_1_array_crystal_array_4_target_y
#define target_z mccchannel_18_analyzer_1_array_crystal_array_4_target_z
#define focus_aw mccchannel_18_analyzer_1_array_crystal_array_4_focus_aw
#define focus_ah mccchannel_18_analyzer_1_array_crystal_array_4_focus_ah
#define focus_xw mccchannel_18_analyzer_1_array_crystal_array_4_focus_xw
#define focus_xh mccchannel_18_analyzer_1_array_crystal_array_4_focus_xh
#define focus_r mccchannel_18_analyzer_1_array_crystal_array_4_focus_r
#define p_interact mccchannel_18_analyzer_1_array_crystal_array_4_p_interact
#define mask_string mccchannel_18_analyzer_1_array_crystal_array_4_mask_string
#define mask_setting mccchannel_18_analyzer_1_array_crystal_array_4_mask_setting
#define number_of_activations mccchannel_18_analyzer_1_array_crystal_array_4_number_of_activations
#line 204 "Union_box.comp"
// Needed for transport to the main component
struct global_geometry_element_struct global_geometry_element;

#ifndef ANY_GEOMETRY_DETECTOR_DECLARE
    #define ANY_GEOMETRY_DETECTOR_DECLARE dummy
	//struct pointer_to_global_geometry_list global_geometry_list = {0,NULL};
#endif

int loop_index,found_geometries;

double x_component;
double y_component;
double z_component;

struct Volume_struct this_box_volume;
struct box_storage this_box_storage;

#line 80316 "MACS_sample_kidney_box.c"
#undef number_of_activations
#undef mask_setting
#undef mask_string
#undef p_interact
#undef focus_r
#undef focus_xh
#undef focus_xw
#undef focus_ah
#undef focus_aw
#undef target_z
#undef target_y
#undef target_x
#undef target_index
#undef visualize
#undef yheight2
#undef xwidth2
#undef zdepth
#undef yheight
#undef xwidth
#undef priority
#undef material_string
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

/* User declarations for component 'channel_18_analyzer_1_array_crystal_array_5' [819]. */
#define mccompcurname  channel_18_analyzer_1_array_crystal_array_5
#define mccompcurtype  Union_box
#define mccompcurindex 819
#define loop_index mccchannel_18_analyzer_1_array_crystal_array_5_loop_index
#define this_box_volume mccchannel_18_analyzer_1_array_crystal_array_5_this_box_volume
#define global_geometry_element mccchannel_18_analyzer_1_array_crystal_array_5_global_geometry_element
#define this_box_storage mccchannel_18_analyzer_1_array_crystal_array_5_this_box_storage
#define material_string mccchannel_18_analyzer_1_array_crystal_array_5_material_string
#define priority mccchannel_18_analyzer_1_array_crystal_array_5_priority
#define xwidth mccchannel_18_analyzer_1_array_crystal_array_5_xwidth
#define yheight mccchannel_18_analyzer_1_array_crystal_array_5_yheight
#define zdepth mccchannel_18_analyzer_1_array_crystal_array_5_zdepth
#define xwidth2 mccchannel_18_analyzer_1_array_crystal_array_5_xwidth2
#define yheight2 mccchannel_18_analyzer_1_array_crystal_array_5_yheight2
#define visualize mccchannel_18_analyzer_1_array_crystal_array_5_visualize
#define target_index mccchannel_18_analyzer_1_array_crystal_array_5_target_index
#define target_x mccchannel_18_analyzer_1_array_crystal_array_5_target_x
#define target_y mccchannel_18_analyzer_1_array_crystal_array_5_target_y
#define target_z mccchannel_18_analyzer_1_array_crystal_array_5_target_z
#define focus_aw mccchannel_18_analyzer_1_array_crystal_array_5_focus_aw
#define focus_ah mccchannel_18_analyzer_1_array_crystal_array_5_focus_ah
#define focus_xw mccchannel_18_analyzer_1_array_crystal_array_5_focus_xw
#define focus_xh mccchannel_18_analyzer_1_array_crystal_array_5_focus_xh
#define focus_r mccchannel_18_analyzer_1_array_crystal_array_5_focus_r
#define p_interact mccchannel_18_analyzer_1_array_crystal_array_5_p_interact
#define mask_string mccchannel_18_analyzer_1_array_crystal_array_5_mask_string
#define mask_setting mccchannel_18_analyzer_1_array_crystal_array_5_mask_setting
#define number_of_activations mccchannel_18_analyzer_1_array_crystal_array_5_number_of_activations
#line 204 "Union_box.comp"
// Needed for transport to the main component
struct global_geometry_element_struct global_geometry_element;

#ifndef ANY_GEOMETRY_DETECTOR_DECLARE
    #define ANY_GEOMETRY_DETECTOR_DECLARE dummy
	//struct pointer_to_global_geometry_list global_geometry_list = {0,NULL};
#endif

int loop_index,found_geometries;

double x_component;
double y_component;
double z_component;

struct Volume_struct this_box_volume;
struct box_storage this_box_storage;

#line 80393 "MACS_sample_kidney_box.c"
#undef number_of_activations
#undef mask_setting
#undef mask_string
#undef p_interact
#undef focus_r
#undef focus_xh
#undef focus_xw
#undef focus_ah
#undef focus_aw
#undef target_z
#undef target_y
#undef target_x
#undef target_index
#undef visualize
#undef yheight2
#undef xwidth2
#undef zdepth
#undef yheight
#undef xwidth
#undef priority
#undef material_string
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

/* User declarations for component 'channel_18_analyzer_1_array_crystal_array_6' [820]. */
#define mccompcurname  channel_18_analyzer_1_array_crystal_array_6
#define mccompcurtype  Union_box
#define mccompcurindex 820
#define loop_index mccchannel_18_analyzer_1_array_crystal_array_6_loop_index
#define this_box_volume mccchannel_18_analyzer_1_array_crystal_array_6_this_box_volume
#define global_geometry_element mccchannel_18_analyzer_1_array_crystal_array_6_global_geometry_element
#define this_box_storage mccchannel_18_analyzer_1_array_crystal_array_6_this_box_storage
#define material_string mccchannel_18_analyzer_1_array_crystal_array_6_material_string
#define priority mccchannel_18_analyzer_1_array_crystal_array_6_priority
#define xwidth mccchannel_18_analyzer_1_array_crystal_array_6_xwidth
#define yheight mccchannel_18_analyzer_1_array_crystal_array_6_yheight
#define zdepth mccchannel_18_analyzer_1_array_crystal_array_6_zdepth
#define xwidth2 mccchannel_18_analyzer_1_array_crystal_array_6_xwidth2
#define yheight2 mccchannel_18_analyzer_1_array_crystal_array_6_yheight2
#define visualize mccchannel_18_analyzer_1_array_crystal_array_6_visualize
#define target_index mccchannel_18_analyzer_1_array_crystal_array_6_target_index
#define target_x mccchannel_18_analyzer_1_array_crystal_array_6_target_x
#define target_y mccchannel_18_analyzer_1_array_crystal_array_6_target_y
#define target_z mccchannel_18_analyzer_1_array_crystal_array_6_target_z
#define focus_aw mccchannel_18_analyzer_1_array_crystal_array_6_focus_aw
#define focus_ah mccchannel_18_analyzer_1_array_crystal_array_6_focus_ah
#define focus_xw mccchannel_18_analyzer_1_array_crystal_array_6_focus_xw
#define focus_xh mccchannel_18_analyzer_1_array_crystal_array_6_focus_xh
#define focus_r mccchannel_18_analyzer_1_array_crystal_array_6_focus_r
#define p_interact mccchannel_18_analyzer_1_array_crystal_array_6_p_interact
#define mask_string mccchannel_18_analyzer_1_array_crystal_array_6_mask_string
#define mask_setting mccchannel_18_analyzer_1_array_crystal_array_6_mask_setting
#define number_of_activations mccchannel_18_analyzer_1_array_crystal_array_6_number_of_activations
#line 204 "Union_box.comp"
// Needed for transport to the main component
struct global_geometry_element_struct global_geometry_element;

#ifndef ANY_GEOMETRY_DETECTOR_DECLARE
    #define ANY_GEOMETRY_DETECTOR_DECLARE dummy
	//struct pointer_to_global_geometry_list global_geometry_list = {0,NULL};
#endif

int loop_index,found_geometries;

double x_component;
double y_component;
double z_component;

struct Volume_struct this_box_volume;
struct box_storage this_box_storage;

#line 80470 "MACS_sample_kidney_box.c"
#undef number_of_activations
#undef mask_setting
#undef mask_string
#undef p_interact
#undef focus_r
#undef focus_xh
#undef focus_xw
#undef focus_ah
#undef focus_aw
#undef target_z
#undef target_y
#undef target_x
#undef target_index
#undef visualize
#undef yheight2
#undef xwidth2
#undef zdepth
#undef yheight
#undef xwidth
#undef priority
#undef material_string
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

/* User declarations for component 'channel_18_analyzer_1_array_crystal_array_7' [821]. */
#define mccompcurname  channel_18_analyzer_1_array_crystal_array_7
#define mccompcurtype  Union_box
#define mccompcurindex 821
#define loop_index mccchannel_18_analyzer_1_array_crystal_array_7_loop_index
#define this_box_volume mccchannel_18_analyzer_1_array_crystal_array_7_this_box_volume
#define global_geometry_element mccchannel_18_analyzer_1_array_crystal_array_7_global_geometry_element
#define this_box_storage mccchannel_18_analyzer_1_array_crystal_array_7_this_box_storage
#define material_string mccchannel_18_analyzer_1_array_crystal_array_7_material_string
#define priority mccchannel_18_analyzer_1_array_crystal_array_7_priority
#define xwidth mccchannel_18_analyzer_1_array_crystal_array_7_xwidth
#define yheight mccchannel_18_analyzer_1_array_crystal_array_7_yheight
#define zdepth mccchannel_18_analyzer_1_array_crystal_array_7_zdepth
#define xwidth2 mccchannel_18_analyzer_1_array_crystal_array_7_xwidth2
#define yheight2 mccchannel_18_analyzer_1_array_crystal_array_7_yheight2
#define visualize mccchannel_18_analyzer_1_array_crystal_array_7_visualize
#define target_index mccchannel_18_analyzer_1_array_crystal_array_7_target_index
#define target_x mccchannel_18_analyzer_1_array_crystal_array_7_target_x
#define target_y mccchannel_18_analyzer_1_array_crystal_array_7_target_y
#define target_z mccchannel_18_analyzer_1_array_crystal_array_7_target_z
#define focus_aw mccchannel_18_analyzer_1_array_crystal_array_7_focus_aw
#define focus_ah mccchannel_18_analyzer_1_array_crystal_array_7_focus_ah
#define focus_xw mccchannel_18_analyzer_1_array_crystal_array_7_focus_xw
#define focus_xh mccchannel_18_analyzer_1_array_crystal_array_7_focus_xh
#define focus_r mccchannel_18_analyzer_1_array_crystal_array_7_focus_r
#define p_interact mccchannel_18_analyzer_1_array_crystal_array_7_p_interact
#define mask_string mccchannel_18_analyzer_1_array_crystal_array_7_mask_string
#define mask_setting mccchannel_18_analyzer_1_array_crystal_array_7_mask_setting
#define number_of_activations mccchannel_18_analyzer_1_array_crystal_array_7_number_of_activations
#line 204 "Union_box.comp"
// Needed for transport to the main component
struct global_geometry_element_struct global_geometry_element;

#ifndef ANY_GEOMETRY_DETECTOR_DECLARE
    #define ANY_GEOMETRY_DETECTOR_DECLARE dummy
	//struct pointer_to_global_geometry_list global_geometry_list = {0,NULL};
#endif

int loop_index,found_geometries;

double x_component;
double y_component;
double z_component;

struct Volume_struct this_box_volume;
struct box_storage this_box_storage;

#line 80547 "MACS_sample_kidney_box.c"
#undef number_of_activations
#undef mask_setting
#undef mask_string
#undef p_interact
#undef focus_r
#undef focus_xh
#undef focus_xw
#undef focus_ah
#undef focus_aw
#undef target_z
#undef target_y
#undef target_x
#undef target_index
#undef visualize
#undef yheight2
#undef xwidth2
#undef zdepth
#undef yheight
#undef xwidth
#undef priority
#undef material_string
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

/* User declarations for component 'channel_18_analyzer_1_array_crystal_array_8' [822]. */
#define mccompcurname  channel_18_analyzer_1_array_crystal_array_8
#define mccompcurtype  Union_box
#define mccompcurindex 822
#define loop_index mccchannel_18_analyzer_1_array_crystal_array_8_loop_index
#define this_box_volume mccchannel_18_analyzer_1_array_crystal_array_8_this_box_volume
#define global_geometry_element mccchannel_18_analyzer_1_array_crystal_array_8_global_geometry_element
#define this_box_storage mccchannel_18_analyzer_1_array_crystal_array_8_this_box_storage
#define material_string mccchannel_18_analyzer_1_array_crystal_array_8_material_string
#define priority mccchannel_18_analyzer_1_array_crystal_array_8_priority
#define xwidth mccchannel_18_analyzer_1_array_crystal_array_8_xwidth
#define yheight mccchannel_18_analyzer_1_array_crystal_array_8_yheight
#define zdepth mccchannel_18_analyzer_1_array_crystal_array_8_zdepth
#define xwidth2 mccchannel_18_analyzer_1_array_crystal_array_8_xwidth2
#define yheight2 mccchannel_18_analyzer_1_array_crystal_array_8_yheight2
#define visualize mccchannel_18_analyzer_1_array_crystal_array_8_visualize
#define target_index mccchannel_18_analyzer_1_array_crystal_array_8_target_index
#define target_x mccchannel_18_analyzer_1_array_crystal_array_8_target_x
#define target_y mccchannel_18_analyzer_1_array_crystal_array_8_target_y
#define target_z mccchannel_18_analyzer_1_array_crystal_array_8_target_z
#define focus_aw mccchannel_18_analyzer_1_array_crystal_array_8_focus_aw
#define focus_ah mccchannel_18_analyzer_1_array_crystal_array_8_focus_ah
#define focus_xw mccchannel_18_analyzer_1_array_crystal_array_8_focus_xw
#define focus_xh mccchannel_18_analyzer_1_array_crystal_array_8_focus_xh
#define focus_r mccchannel_18_analyzer_1_array_crystal_array_8_focus_r
#define p_interact mccchannel_18_analyzer_1_array_crystal_array_8_p_interact
#define mask_string mccchannel_18_analyzer_1_array_crystal_array_8_mask_string
#define mask_setting mccchannel_18_analyzer_1_array_crystal_array_8_mask_setting
#define number_of_activations mccchannel_18_analyzer_1_array_crystal_array_8_number_of_activations
#line 204 "Union_box.comp"
// Needed for transport to the main component
struct global_geometry_element_struct global_geometry_element;

#ifndef ANY_GEOMETRY_DETECTOR_DECLARE
    #define ANY_GEOMETRY_DETECTOR_DECLARE dummy
	//struct pointer_to_global_geometry_list global_geometry_list = {0,NULL};
#endif

int loop_index,found_geometries;

double x_component;
double y_component;
double z_component;

struct Volume_struct this_box_volume;
struct box_storage this_box_storage;

#line 80624 "MACS_sample_kidney_box.c"
#undef number_of_activations
#undef mask_setting
#undef mask_string
#undef p_interact
#undef focus_r
#undef focus_xh
#undef focus_xw
#undef focus_ah
#undef focus_aw
#undef target_z
#undef target_y
#undef target_x
#undef target_index
#undef visualize
#undef yheight2
#undef xwidth2
#undef zdepth
#undef yheight
#undef xwidth
#undef priority
#undef material_string
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

/* User declarations for component 'channel_18_analyzer_2_center' [823]. */
#define mccompcurname  channel_18_analyzer_2_center
#define mccompcurtype  Arm
#define mccompcurindex 823
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

/* User declarations for component 'channel_18_analyzer_2_rotated' [824]. */
#define mccompcurname  channel_18_analyzer_2_rotated
#define mccompcurtype  Arm
#define mccompcurindex 824
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

/* User declarations for component 'channel_18_analyzer_2_array_crystal_array_0' [825]. */
#define mccompcurname  channel_18_analyzer_2_array_crystal_array_0
#define mccompcurtype  Union_box
#define mccompcurindex 825
#define loop_index mccchannel_18_analyzer_2_array_crystal_array_0_loop_index
#define this_box_volume mccchannel_18_analyzer_2_array_crystal_array_0_this_box_volume
#define global_geometry_element mccchannel_18_analyzer_2_array_crystal_array_0_global_geometry_element
#define this_box_storage mccchannel_18_analyzer_2_array_crystal_array_0_this_box_storage
#define material_string mccchannel_18_analyzer_2_array_crystal_array_0_material_string
#define priority mccchannel_18_analyzer_2_array_crystal_array_0_priority
#define xwidth mccchannel_18_analyzer_2_array_crystal_array_0_xwidth
#define yheight mccchannel_18_analyzer_2_array_crystal_array_0_yheight
#define zdepth mccchannel_18_analyzer_2_array_crystal_array_0_zdepth
#define xwidth2 mccchannel_18_analyzer_2_array_crystal_array_0_xwidth2
#define yheight2 mccchannel_18_analyzer_2_array_crystal_array_0_yheight2
#define visualize mccchannel_18_analyzer_2_array_crystal_array_0_visualize
#define target_index mccchannel_18_analyzer_2_array_crystal_array_0_target_index
#define target_x mccchannel_18_analyzer_2_array_crystal_array_0_target_x
#define target_y mccchannel_18_analyzer_2_array_crystal_array_0_target_y
#define target_z mccchannel_18_analyzer_2_array_crystal_array_0_target_z
#define focus_aw mccchannel_18_analyzer_2_array_crystal_array_0_focus_aw
#define focus_ah mccchannel_18_analyzer_2_array_crystal_array_0_focus_ah
#define focus_xw mccchannel_18_analyzer_2_array_crystal_array_0_focus_xw
#define focus_xh mccchannel_18_analyzer_2_array_crystal_array_0_focus_xh
#define focus_r mccchannel_18_analyzer_2_array_crystal_array_0_focus_r
#define p_interact mccchannel_18_analyzer_2_array_crystal_array_0_p_interact
#define mask_string mccchannel_18_analyzer_2_array_crystal_array_0_mask_string
#define mask_setting mccchannel_18_analyzer_2_array_crystal_array_0_mask_setting
#define number_of_activations mccchannel_18_analyzer_2_array_crystal_array_0_number_of_activations
#line 204 "Union_box.comp"
// Needed for transport to the main component
struct global_geometry_element_struct global_geometry_element;

#ifndef ANY_GEOMETRY_DETECTOR_DECLARE
    #define ANY_GEOMETRY_DETECTOR_DECLARE dummy
	//struct pointer_to_global_geometry_list global_geometry_list = {0,NULL};
#endif

int loop_index,found_geometries;

double x_component;
double y_component;
double z_component;

struct Volume_struct this_box_volume;
struct box_storage this_box_storage;

#line 80717 "MACS_sample_kidney_box.c"
#undef number_of_activations
#undef mask_setting
#undef mask_string
#undef p_interact
#undef focus_r
#undef focus_xh
#undef focus_xw
#undef focus_ah
#undef focus_aw
#undef target_z
#undef target_y
#undef target_x
#undef target_index
#undef visualize
#undef yheight2
#undef xwidth2
#undef zdepth
#undef yheight
#undef xwidth
#undef priority
#undef material_string
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

/* User declarations for component 'channel_18_analyzer_2_array_crystal_array_1' [826]. */
#define mccompcurname  channel_18_analyzer_2_array_crystal_array_1
#define mccompcurtype  Union_box
#define mccompcurindex 826
#define loop_index mccchannel_18_analyzer_2_array_crystal_array_1_loop_index
#define this_box_volume mccchannel_18_analyzer_2_array_crystal_array_1_this_box_volume
#define global_geometry_element mccchannel_18_analyzer_2_array_crystal_array_1_global_geometry_element
#define this_box_storage mccchannel_18_analyzer_2_array_crystal_array_1_this_box_storage
#define material_string mccchannel_18_analyzer_2_array_crystal_array_1_material_string
#define priority mccchannel_18_analyzer_2_array_crystal_array_1_priority
#define xwidth mccchannel_18_analyzer_2_array_crystal_array_1_xwidth
#define yheight mccchannel_18_analyzer_2_array_crystal_array_1_yheight
#define zdepth mccchannel_18_analyzer_2_array_crystal_array_1_zdepth
#define xwidth2 mccchannel_18_analyzer_2_array_crystal_array_1_xwidth2
#define yheight2 mccchannel_18_analyzer_2_array_crystal_array_1_yheight2
#define visualize mccchannel_18_analyzer_2_array_crystal_array_1_visualize
#define target_index mccchannel_18_analyzer_2_array_crystal_array_1_target_index
#define target_x mccchannel_18_analyzer_2_array_crystal_array_1_target_x
#define target_y mccchannel_18_analyzer_2_array_crystal_array_1_target_y
#define target_z mccchannel_18_analyzer_2_array_crystal_array_1_target_z
#define focus_aw mccchannel_18_analyzer_2_array_crystal_array_1_focus_aw
#define focus_ah mccchannel_18_analyzer_2_array_crystal_array_1_focus_ah
#define focus_xw mccchannel_18_analyzer_2_array_crystal_array_1_focus_xw
#define focus_xh mccchannel_18_analyzer_2_array_crystal_array_1_focus_xh
#define focus_r mccchannel_18_analyzer_2_array_crystal_array_1_focus_r
#define p_interact mccchannel_18_analyzer_2_array_crystal_array_1_p_interact
#define mask_string mccchannel_18_analyzer_2_array_crystal_array_1_mask_string
#define mask_setting mccchannel_18_analyzer_2_array_crystal_array_1_mask_setting
#define number_of_activations mccchannel_18_analyzer_2_array_crystal_array_1_number_of_activations
#line 204 "Union_box.comp"
// Needed for transport to the main component
struct global_geometry_element_struct global_geometry_element;

#ifndef ANY_GEOMETRY_DETECTOR_DECLARE
    #define ANY_GEOMETRY_DETECTOR_DECLARE dummy
	//struct pointer_to_global_geometry_list global_geometry_list = {0,NULL};
#endif

int loop_index,found_geometries;

double x_component;
double y_component;
double z_component;

struct Volume_struct this_box_volume;
struct box_storage this_box_storage;

#line 80794 "MACS_sample_kidney_box.c"
#undef number_of_activations
#undef mask_setting
#undef mask_string
#undef p_interact
#undef focus_r
#undef focus_xh
#undef focus_xw
#undef focus_ah
#undef focus_aw
#undef target_z
#undef target_y
#undef target_x
#undef target_index
#undef visualize
#undef yheight2
#undef xwidth2
#undef zdepth
#undef yheight
#undef xwidth
#undef priority
#undef material_string
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

/* User declarations for component 'channel_18_analyzer_2_array_crystal_array_2' [827]. */
#define mccompcurname  channel_18_analyzer_2_array_crystal_array_2
#define mccompcurtype  Union_box
#define mccompcurindex 827
#define loop_index mccchannel_18_analyzer_2_array_crystal_array_2_loop_index
#define this_box_volume mccchannel_18_analyzer_2_array_crystal_array_2_this_box_volume
#define global_geometry_element mccchannel_18_analyzer_2_array_crystal_array_2_global_geometry_element
#define this_box_storage mccchannel_18_analyzer_2_array_crystal_array_2_this_box_storage
#define material_string mccchannel_18_analyzer_2_array_crystal_array_2_material_string
#define priority mccchannel_18_analyzer_2_array_crystal_array_2_priority
#define xwidth mccchannel_18_analyzer_2_array_crystal_array_2_xwidth
#define yheight mccchannel_18_analyzer_2_array_crystal_array_2_yheight
#define zdepth mccchannel_18_analyzer_2_array_crystal_array_2_zdepth
#define xwidth2 mccchannel_18_analyzer_2_array_crystal_array_2_xwidth2
#define yheight2 mccchannel_18_analyzer_2_array_crystal_array_2_yheight2
#define visualize mccchannel_18_analyzer_2_array_crystal_array_2_visualize
#define target_index mccchannel_18_analyzer_2_array_crystal_array_2_target_index
#define target_x mccchannel_18_analyzer_2_array_crystal_array_2_target_x
#define target_y mccchannel_18_analyzer_2_array_crystal_array_2_target_y
#define target_z mccchannel_18_analyzer_2_array_crystal_array_2_target_z
#define focus_aw mccchannel_18_analyzer_2_array_crystal_array_2_focus_aw
#define focus_ah mccchannel_18_analyzer_2_array_crystal_array_2_focus_ah
#define focus_xw mccchannel_18_analyzer_2_array_crystal_array_2_focus_xw
#define focus_xh mccchannel_18_analyzer_2_array_crystal_array_2_focus_xh
#define focus_r mccchannel_18_analyzer_2_array_crystal_array_2_focus_r
#define p_interact mccchannel_18_analyzer_2_array_crystal_array_2_p_interact
#define mask_string mccchannel_18_analyzer_2_array_crystal_array_2_mask_string
#define mask_setting mccchannel_18_analyzer_2_array_crystal_array_2_mask_setting
#define number_of_activations mccchannel_18_analyzer_2_array_crystal_array_2_number_of_activations
#line 204 "Union_box.comp"
// Needed for transport to the main component
struct global_geometry_element_struct global_geometry_element;

#ifndef ANY_GEOMETRY_DETECTOR_DECLARE
    #define ANY_GEOMETRY_DETECTOR_DECLARE dummy
	//struct pointer_to_global_geometry_list global_geometry_list = {0,NULL};
#endif

int loop_index,found_geometries;

double x_component;
double y_component;
double z_component;

struct Volume_struct this_box_volume;
struct box_storage this_box_storage;

#line 80871 "MACS_sample_kidney_box.c"
#undef number_of_activations
#undef mask_setting
#undef mask_string
#undef p_interact
#undef focus_r
#undef focus_xh
#undef focus_xw
#undef focus_ah
#undef focus_aw
#undef target_z
#undef target_y
#undef target_x
#undef target_index
#undef visualize
#undef yheight2
#undef xwidth2
#undef zdepth
#undef yheight
#undef xwidth
#undef priority
#undef material_string
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

/* User declarations for component 'channel_18_analyzer_2_array_crystal_array_3' [828]. */
#define mccompcurname  channel_18_analyzer_2_array_crystal_array_3
#define mccompcurtype  Union_box
#define mccompcurindex 828
#define loop_index mccchannel_18_analyzer_2_array_crystal_array_3_loop_index
#define this_box_volume mccchannel_18_analyzer_2_array_crystal_array_3_this_box_volume
#define global_geometry_element mccchannel_18_analyzer_2_array_crystal_array_3_global_geometry_element
#define this_box_storage mccchannel_18_analyzer_2_array_crystal_array_3_this_box_storage
#define material_string mccchannel_18_analyzer_2_array_crystal_array_3_material_string
#define priority mccchannel_18_analyzer_2_array_crystal_array_3_priority
#define xwidth mccchannel_18_analyzer_2_array_crystal_array_3_xwidth
#define yheight mccchannel_18_analyzer_2_array_crystal_array_3_yheight
#define zdepth mccchannel_18_analyzer_2_array_crystal_array_3_zdepth
#define xwidth2 mccchannel_18_analyzer_2_array_crystal_array_3_xwidth2
#define yheight2 mccchannel_18_analyzer_2_array_crystal_array_3_yheight2
#define visualize mccchannel_18_analyzer_2_array_crystal_array_3_visualize
#define target_index mccchannel_18_analyzer_2_array_crystal_array_3_target_index
#define target_x mccchannel_18_analyzer_2_array_crystal_array_3_target_x
#define target_y mccchannel_18_analyzer_2_array_crystal_array_3_target_y
#define target_z mccchannel_18_analyzer_2_array_crystal_array_3_target_z
#define focus_aw mccchannel_18_analyzer_2_array_crystal_array_3_focus_aw
#define focus_ah mccchannel_18_analyzer_2_array_crystal_array_3_focus_ah
#define focus_xw mccchannel_18_analyzer_2_array_crystal_array_3_focus_xw
#define focus_xh mccchannel_18_analyzer_2_array_crystal_array_3_focus_xh
#define focus_r mccchannel_18_analyzer_2_array_crystal_array_3_focus_r
#define p_interact mccchannel_18_analyzer_2_array_crystal_array_3_p_interact
#define mask_string mccchannel_18_analyzer_2_array_crystal_array_3_mask_string
#define mask_setting mccchannel_18_analyzer_2_array_crystal_array_3_mask_setting
#define number_of_activations mccchannel_18_analyzer_2_array_crystal_array_3_number_of_activations
#line 204 "Union_box.comp"
// Needed for transport to the main component
struct global_geometry_element_struct global_geometry_element;

#ifndef ANY_GEOMETRY_DETECTOR_DECLARE
    #define ANY_GEOMETRY_DETECTOR_DECLARE dummy
	//struct pointer_to_global_geometry_list global_geometry_list = {0,NULL};
#endif

int loop_index,found_geometries;

double x_component;
double y_component;
double z_component;

struct Volume_struct this_box_volume;
struct box_storage this_box_storage;

#line 80948 "MACS_sample_kidney_box.c"
#undef number_of_activations
#undef mask_setting
#undef mask_string
#undef p_interact
#undef focus_r
#undef focus_xh
#undef focus_xw
#undef focus_ah
#undef focus_aw
#undef target_z
#undef target_y
#undef target_x
#undef target_index
#undef visualize
#undef yheight2
#undef xwidth2
#undef zdepth
#undef yheight
#undef xwidth
#undef priority
#undef material_string
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

/* User declarations for component 'channel_18_analyzer_2_array_crystal_array_4' [829]. */
#define mccompcurname  channel_18_analyzer_2_array_crystal_array_4
#define mccompcurtype  Union_box
#define mccompcurindex 829
#define loop_index mccchannel_18_analyzer_2_array_crystal_array_4_loop_index
#define this_box_volume mccchannel_18_analyzer_2_array_crystal_array_4_this_box_volume
#define global_geometry_element mccchannel_18_analyzer_2_array_crystal_array_4_global_geometry_element
#define this_box_storage mccchannel_18_analyzer_2_array_crystal_array_4_this_box_storage
#define material_string mccchannel_18_analyzer_2_array_crystal_array_4_material_string
#define priority mccchannel_18_analyzer_2_array_crystal_array_4_priority
#define xwidth mccchannel_18_analyzer_2_array_crystal_array_4_xwidth
#define yheight mccchannel_18_analyzer_2_array_crystal_array_4_yheight
#define zdepth mccchannel_18_analyzer_2_array_crystal_array_4_zdepth
#define xwidth2 mccchannel_18_analyzer_2_array_crystal_array_4_xwidth2
#define yheight2 mccchannel_18_analyzer_2_array_crystal_array_4_yheight2
#define visualize mccchannel_18_analyzer_2_array_crystal_array_4_visualize
#define target_index mccchannel_18_analyzer_2_array_crystal_array_4_target_index
#define target_x mccchannel_18_analyzer_2_array_crystal_array_4_target_x
#define target_y mccchannel_18_analyzer_2_array_crystal_array_4_target_y
#define target_z mccchannel_18_analyzer_2_array_crystal_array_4_target_z
#define focus_aw mccchannel_18_analyzer_2_array_crystal_array_4_focus_aw
#define focus_ah mccchannel_18_analyzer_2_array_crystal_array_4_focus_ah
#define focus_xw mccchannel_18_analyzer_2_array_crystal_array_4_focus_xw
#define focus_xh mccchannel_18_analyzer_2_array_crystal_array_4_focus_xh
#define focus_r mccchannel_18_analyzer_2_array_crystal_array_4_focus_r
#define p_interact mccchannel_18_analyzer_2_array_crystal_array_4_p_interact
#define mask_string mccchannel_18_analyzer_2_array_crystal_array_4_mask_string
#define mask_setting mccchannel_18_analyzer_2_array_crystal_array_4_mask_setting
#define number_of_activations mccchannel_18_analyzer_2_array_crystal_array_4_number_of_activations
#line 204 "Union_box.comp"
// Needed for transport to the main component
struct global_geometry_element_struct global_geometry_element;

#ifndef ANY_GEOMETRY_DETECTOR_DECLARE
    #define ANY_GEOMETRY_DETECTOR_DECLARE dummy
	//struct pointer_to_global_geometry_list global_geometry_list = {0,NULL};
#endif

int loop_index,found_geometries;

double x_component;
double y_component;
double z_component;

struct Volume_struct this_box_volume;
struct box_storage this_box_storage;

#line 81025 "MACS_sample_kidney_box.c"
#undef number_of_activations
#undef mask_setting
#undef mask_string
#undef p_interact
#undef focus_r
#undef focus_xh
#undef focus_xw
#undef focus_ah
#undef focus_aw
#undef target_z
#undef target_y
#undef target_x
#undef target_index
#undef visualize
#undef yheight2
#undef xwidth2
#undef zdepth
#undef yheight
#undef xwidth
#undef priority
#undef material_string
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

/* User declarations for component 'channel_18_analyzer_2_array_crystal_array_5' [830]. */
#define mccompcurname  channel_18_analyzer_2_array_crystal_array_5
#define mccompcurtype  Union_box
#define mccompcurindex 830
#define loop_index mccchannel_18_analyzer_2_array_crystal_array_5_loop_index
#define this_box_volume mccchannel_18_analyzer_2_array_crystal_array_5_this_box_volume
#define global_geometry_element mccchannel_18_analyzer_2_array_crystal_array_5_global_geometry_element
#define this_box_storage mccchannel_18_analyzer_2_array_crystal_array_5_this_box_storage
#define material_string mccchannel_18_analyzer_2_array_crystal_array_5_material_string
#define priority mccchannel_18_analyzer_2_array_crystal_array_5_priority
#define xwidth mccchannel_18_analyzer_2_array_crystal_array_5_xwidth
#define yheight mccchannel_18_analyzer_2_array_crystal_array_5_yheight
#define zdepth mccchannel_18_analyzer_2_array_crystal_array_5_zdepth
#define xwidth2 mccchannel_18_analyzer_2_array_crystal_array_5_xwidth2
#define yheight2 mccchannel_18_analyzer_2_array_crystal_array_5_yheight2
#define visualize mccchannel_18_analyzer_2_array_crystal_array_5_visualize
#define target_index mccchannel_18_analyzer_2_array_crystal_array_5_target_index
#define target_x mccchannel_18_analyzer_2_array_crystal_array_5_target_x
#define target_y mccchannel_18_analyzer_2_array_crystal_array_5_target_y
#define target_z mccchannel_18_analyzer_2_array_crystal_array_5_target_z
#define focus_aw mccchannel_18_analyzer_2_array_crystal_array_5_focus_aw
#define focus_ah mccchannel_18_analyzer_2_array_crystal_array_5_focus_ah
#define focus_xw mccchannel_18_analyzer_2_array_crystal_array_5_focus_xw
#define focus_xh mccchannel_18_analyzer_2_array_crystal_array_5_focus_xh
#define focus_r mccchannel_18_analyzer_2_array_crystal_array_5_focus_r
#define p_interact mccchannel_18_analyzer_2_array_crystal_array_5_p_interact
#define mask_string mccchannel_18_analyzer_2_array_crystal_array_5_mask_string
#define mask_setting mccchannel_18_analyzer_2_array_crystal_array_5_mask_setting
#define number_of_activations mccchannel_18_analyzer_2_array_crystal_array_5_number_of_activations
#line 204 "Union_box.comp"
// Needed for transport to the main component
struct global_geometry_element_struct global_geometry_element;

#ifndef ANY_GEOMETRY_DETECTOR_DECLARE
    #define ANY_GEOMETRY_DETECTOR_DECLARE dummy
	//struct pointer_to_global_geometry_list global_geometry_list = {0,NULL};
#endif

int loop_index,found_geometries;

double x_component;
double y_component;
double z_component;

struct Volume_struct this_box_volume;
struct box_storage this_box_storage;

#line 81102 "MACS_sample_kidney_box.c"
#undef number_of_activations
#undef mask_setting
#undef mask_string
#undef p_interact
#undef focus_r
#undef focus_xh
#undef focus_xw
#undef focus_ah
#undef focus_aw
#undef target_z
#undef target_y
#undef target_x
#undef target_index
#undef visualize
#undef yheight2
#undef xwidth2
#undef zdepth
#undef yheight
#undef xwidth
#undef priority
#undef material_string
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

/* User declarations for component 'channel_18_analyzer_2_array_crystal_array_6' [831]. */
#define mccompcurname  channel_18_analyzer_2_array_crystal_array_6
#define mccompcurtype  Union_box
#define mccompcurindex 831
#define loop_index mccchannel_18_analyzer_2_array_crystal_array_6_loop_index
#define this_box_volume mccchannel_18_analyzer_2_array_crystal_array_6_this_box_volume
#define global_geometry_element mccchannel_18_analyzer_2_array_crystal_array_6_global_geometry_element
#define this_box_storage mccchannel_18_analyzer_2_array_crystal_array_6_this_box_storage
#define material_string mccchannel_18_analyzer_2_array_crystal_array_6_material_string
#define priority mccchannel_18_analyzer_2_array_crystal_array_6_priority
#define xwidth mccchannel_18_analyzer_2_array_crystal_array_6_xwidth
#define yheight mccchannel_18_analyzer_2_array_crystal_array_6_yheight
#define zdepth mccchannel_18_analyzer_2_array_crystal_array_6_zdepth
#define xwidth2 mccchannel_18_analyzer_2_array_crystal_array_6_xwidth2
#define yheight2 mccchannel_18_analyzer_2_array_crystal_array_6_yheight2
#define visualize mccchannel_18_analyzer_2_array_crystal_array_6_visualize
#define target_index mccchannel_18_analyzer_2_array_crystal_array_6_target_index
#define target_x mccchannel_18_analyzer_2_array_crystal_array_6_target_x
#define target_y mccchannel_18_analyzer_2_array_crystal_array_6_target_y
#define target_z mccchannel_18_analyzer_2_array_crystal_array_6_target_z
#define focus_aw mccchannel_18_analyzer_2_array_crystal_array_6_focus_aw
#define focus_ah mccchannel_18_analyzer_2_array_crystal_array_6_focus_ah
#define focus_xw mccchannel_18_analyzer_2_array_crystal_array_6_focus_xw
#define focus_xh mccchannel_18_analyzer_2_array_crystal_array_6_focus_xh
#define focus_r mccchannel_18_analyzer_2_array_crystal_array_6_focus_r
#define p_interact mccchannel_18_analyzer_2_array_crystal_array_6_p_interact
#define mask_string mccchannel_18_analyzer_2_array_crystal_array_6_mask_string
#define mask_setting mccchannel_18_analyzer_2_array_crystal_array_6_mask_setting
#define number_of_activations mccchannel_18_analyzer_2_array_crystal_array_6_number_of_activations
#line 204 "Union_box.comp"
// Needed for transport to the main component
struct global_geometry_element_struct global_geometry_element;

#ifndef ANY_GEOMETRY_DETECTOR_DECLARE
    #define ANY_GEOMETRY_DETECTOR_DECLARE dummy
	//struct pointer_to_global_geometry_list global_geometry_list = {0,NULL};
#endif

int loop_index,found_geometries;

double x_component;
double y_component;
double z_component;

struct Volume_struct this_box_volume;
struct box_storage this_box_storage;

#line 81179 "MACS_sample_kidney_box.c"
#undef number_of_activations
#undef mask_setting
#undef mask_string
#undef p_interact
#undef focus_r
#undef focus_xh
#undef focus_xw
#undef focus_ah
#undef focus_aw
#undef target_z
#undef target_y
#undef target_x
#undef target_index
#undef visualize
#undef yheight2
#undef xwidth2
#undef zdepth
#undef yheight
#undef xwidth
#undef priority
#undef material_string
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

/* User declarations for component 'channel_18_analyzer_2_array_crystal_array_7' [832]. */
#define mccompcurname  channel_18_analyzer_2_array_crystal_array_7
#define mccompcurtype  Union_box
#define mccompcurindex 832
#define loop_index mccchannel_18_analyzer_2_array_crystal_array_7_loop_index
#define this_box_volume mccchannel_18_analyzer_2_array_crystal_array_7_this_box_volume
#define global_geometry_element mccchannel_18_analyzer_2_array_crystal_array_7_global_geometry_element
#define this_box_storage mccchannel_18_analyzer_2_array_crystal_array_7_this_box_storage
#define material_string mccchannel_18_analyzer_2_array_crystal_array_7_material_string
#define priority mccchannel_18_analyzer_2_array_crystal_array_7_priority
#define xwidth mccchannel_18_analyzer_2_array_crystal_array_7_xwidth
#define yheight mccchannel_18_analyzer_2_array_crystal_array_7_yheight
#define zdepth mccchannel_18_analyzer_2_array_crystal_array_7_zdepth
#define xwidth2 mccchannel_18_analyzer_2_array_crystal_array_7_xwidth2
#define yheight2 mccchannel_18_analyzer_2_array_crystal_array_7_yheight2
#define visualize mccchannel_18_analyzer_2_array_crystal_array_7_visualize
#define target_index mccchannel_18_analyzer_2_array_crystal_array_7_target_index
#define target_x mccchannel_18_analyzer_2_array_crystal_array_7_target_x
#define target_y mccchannel_18_analyzer_2_array_crystal_array_7_target_y
#define target_z mccchannel_18_analyzer_2_array_crystal_array_7_target_z
#define focus_aw mccchannel_18_analyzer_2_array_crystal_array_7_focus_aw
#define focus_ah mccchannel_18_analyzer_2_array_crystal_array_7_focus_ah
#define focus_xw mccchannel_18_analyzer_2_array_crystal_array_7_focus_xw
#define focus_xh mccchannel_18_analyzer_2_array_crystal_array_7_focus_xh
#define focus_r mccchannel_18_analyzer_2_array_crystal_array_7_focus_r
#define p_interact mccchannel_18_analyzer_2_array_crystal_array_7_p_interact
#define mask_string mccchannel_18_analyzer_2_array_crystal_array_7_mask_string
#define mask_setting mccchannel_18_analyzer_2_array_crystal_array_7_mask_setting
#define number_of_activations mccchannel_18_analyzer_2_array_crystal_array_7_number_of_activations
#line 204 "Union_box.comp"
// Needed for transport to the main component
struct global_geometry_element_struct global_geometry_element;

#ifndef ANY_GEOMETRY_DETECTOR_DECLARE
    #define ANY_GEOMETRY_DETECTOR_DECLARE dummy
	//struct pointer_to_global_geometry_list global_geometry_list = {0,NULL};
#endif

int loop_index,found_geometries;

double x_component;
double y_component;
double z_component;

struct Volume_struct this_box_volume;
struct box_storage this_box_storage;

#line 81256 "MACS_sample_kidney_box.c"
#undef number_of_activations
#undef mask_setting
#undef mask_string
#undef p_interact
#undef focus_r
#undef focus_xh
#undef focus_xw
#undef focus_ah
#undef focus_aw
#undef target_z
#undef target_y
#undef target_x
#undef target_index
#undef visualize
#undef yheight2
#undef xwidth2
#undef zdepth
#undef yheight
#undef xwidth
#undef priority
#undef material_string
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

/* User declarations for component 'channel_18_analyzer_2_array_crystal_array_8' [833]. */
#define mccompcurname  channel_18_analyzer_2_array_crystal_array_8
#define mccompcurtype  Union_box
#define mccompcurindex 833
#define loop_index mccchannel_18_analyzer_2_array_crystal_array_8_loop_index
#define this_box_volume mccchannel_18_analyzer_2_array_crystal_array_8_this_box_volume
#define global_geometry_element mccchannel_18_analyzer_2_array_crystal_array_8_global_geometry_element
#define this_box_storage mccchannel_18_analyzer_2_array_crystal_array_8_this_box_storage
#define material_string mccchannel_18_analyzer_2_array_crystal_array_8_material_string
#define priority mccchannel_18_analyzer_2_array_crystal_array_8_priority
#define xwidth mccchannel_18_analyzer_2_array_crystal_array_8_xwidth
#define yheight mccchannel_18_analyzer_2_array_crystal_array_8_yheight
#define zdepth mccchannel_18_analyzer_2_array_crystal_array_8_zdepth
#define xwidth2 mccchannel_18_analyzer_2_array_crystal_array_8_xwidth2
#define yheight2 mccchannel_18_analyzer_2_array_crystal_array_8_yheight2
#define visualize mccchannel_18_analyzer_2_array_crystal_array_8_visualize
#define target_index mccchannel_18_analyzer_2_array_crystal_array_8_target_index
#define target_x mccchannel_18_analyzer_2_array_crystal_array_8_target_x
#define target_y mccchannel_18_analyzer_2_array_crystal_array_8_target_y
#define target_z mccchannel_18_analyzer_2_array_crystal_array_8_target_z
#define focus_aw mccchannel_18_analyzer_2_array_crystal_array_8_focus_aw
#define focus_ah mccchannel_18_analyzer_2_array_crystal_array_8_focus_ah
#define focus_xw mccchannel_18_analyzer_2_array_crystal_array_8_focus_xw
#define focus_xh mccchannel_18_analyzer_2_array_crystal_array_8_focus_xh
#define focus_r mccchannel_18_analyzer_2_array_crystal_array_8_focus_r
#define p_interact mccchannel_18_analyzer_2_array_crystal_array_8_p_interact
#define mask_string mccchannel_18_analyzer_2_array_crystal_array_8_mask_string
#define mask_setting mccchannel_18_analyzer_2_array_crystal_array_8_mask_setting
#define number_of_activations mccchannel_18_analyzer_2_array_crystal_array_8_number_of_activations
#line 204 "Union_box.comp"
// Needed for transport to the main component
struct global_geometry_element_struct global_geometry_element;

#ifndef ANY_GEOMETRY_DETECTOR_DECLARE
    #define ANY_GEOMETRY_DETECTOR_DECLARE dummy
	//struct pointer_to_global_geometry_list global_geometry_list = {0,NULL};
#endif

int loop_index,found_geometries;

double x_component;
double y_component;
double z_component;

struct Volume_struct this_box_volume;
struct box_storage this_box_storage;

#line 81333 "MACS_sample_kidney_box.c"
#undef number_of_activations
#undef mask_setting
#undef mask_string
#undef p_interact
#undef focus_r
#undef focus_xh
#undef focus_xw
#undef focus_ah
#undef focus_aw
#undef target_z
#undef target_y
#undef target_x
#undef target_index
#undef visualize
#undef yheight2
#undef xwidth2
#undef zdepth
#undef yheight
#undef xwidth
#undef priority
#undef material_string
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

/* User declarations for component 'channel_18_cave2_cyl1' [834]. */
#define mccompcurname  channel_18_cave2_cyl1
#define mccompcurtype  Union_cylinder
#define mccompcurindex 834
#define loop_index mccchannel_18_cave2_cyl1_loop_index
#define this_cylinder_volume mccchannel_18_cave2_cyl1_this_cylinder_volume
#define global_geometry_element mccchannel_18_cave2_cyl1_global_geometry_element
#define this_cylinder_storage mccchannel_18_cave2_cyl1_this_cylinder_storage
#define material_string mccchannel_18_cave2_cyl1_material_string
#define priority mccchannel_18_cave2_cyl1_priority
#define radius mccchannel_18_cave2_cyl1_radius
#define yheight mccchannel_18_cave2_cyl1_yheight
#define visualize mccchannel_18_cave2_cyl1_visualize
#define target_index mccchannel_18_cave2_cyl1_target_index
#define target_x mccchannel_18_cave2_cyl1_target_x
#define target_y mccchannel_18_cave2_cyl1_target_y
#define target_z mccchannel_18_cave2_cyl1_target_z
#define focus_aw mccchannel_18_cave2_cyl1_focus_aw
#define focus_ah mccchannel_18_cave2_cyl1_focus_ah
#define focus_xw mccchannel_18_cave2_cyl1_focus_xw
#define focus_xh mccchannel_18_cave2_cyl1_focus_xh
#define focus_r mccchannel_18_cave2_cyl1_focus_r
#define p_interact mccchannel_18_cave2_cyl1_p_interact
#define mask_string mccchannel_18_cave2_cyl1_mask_string
#define mask_setting mccchannel_18_cave2_cyl1_mask_setting
#define number_of_activations mccchannel_18_cave2_cyl1_number_of_activations
#line 167 "Union_cylinder.comp"
// Needed for transport to the main component
struct global_geometry_element_struct global_geometry_element;

#ifndef ANY_GEOMETRY_DETECTOR_DECLARE
    #define ANY_GEOMETRY_DETECTOR_DECLARE dummy
	//struct pointer_to_global_geometry_list global_geometry_list = {0,NULL};
#endif

int dummy;
int loop_index,found_geometries;
int loop_2_index;
int material_index;

struct Volume_struct this_cylinder_volume;
struct cylinder_storage this_cylinder_storage;
#line 81405 "MACS_sample_kidney_box.c"
#undef number_of_activations
#undef mask_setting
#undef mask_string
#undef p_interact
#undef focus_r
#undef focus_xh
#undef focus_xw
#undef focus_ah
#undef focus_aw
#undef target_z
#undef target_y
#undef target_x
#undef target_index
#undef visualize
#undef yheight
#undef radius
#undef priority
#undef material_string
#undef this_cylinder_storage
#undef global_geometry_element
#undef this_cylinder_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

/* User declarations for component 'channel_18_cave2_box1' [835]. */
#define mccompcurname  channel_18_cave2_box1
#define mccompcurtype  Union_box
#define mccompcurindex 835
#define loop_index mccchannel_18_cave2_box1_loop_index
#define this_box_volume mccchannel_18_cave2_box1_this_box_volume
#define global_geometry_element mccchannel_18_cave2_box1_global_geometry_element
#define this_box_storage mccchannel_18_cave2_box1_this_box_storage
#define material_string mccchannel_18_cave2_box1_material_string
#define priority mccchannel_18_cave2_box1_priority
#define xwidth mccchannel_18_cave2_box1_xwidth
#define yheight mccchannel_18_cave2_box1_yheight
#define zdepth mccchannel_18_cave2_box1_zdepth
#define xwidth2 mccchannel_18_cave2_box1_xwidth2
#define yheight2 mccchannel_18_cave2_box1_yheight2
#define visualize mccchannel_18_cave2_box1_visualize
#define target_index mccchannel_18_cave2_box1_target_index
#define target_x mccchannel_18_cave2_box1_target_x
#define target_y mccchannel_18_cave2_box1_target_y
#define target_z mccchannel_18_cave2_box1_target_z
#define focus_aw mccchannel_18_cave2_box1_focus_aw
#define focus_ah mccchannel_18_cave2_box1_focus_ah
#define focus_xw mccchannel_18_cave2_box1_focus_xw
#define focus_xh mccchannel_18_cave2_box1_focus_xh
#define focus_r mccchannel_18_cave2_box1_focus_r
#define p_interact mccchannel_18_cave2_box1_p_interact
#define mask_string mccchannel_18_cave2_box1_mask_string
#define mask_setting mccchannel_18_cave2_box1_mask_setting
#define number_of_activations mccchannel_18_cave2_box1_number_of_activations
#line 204 "Union_box.comp"
// Needed for transport to the main component
struct global_geometry_element_struct global_geometry_element;

#ifndef ANY_GEOMETRY_DETECTOR_DECLARE
    #define ANY_GEOMETRY_DETECTOR_DECLARE dummy
	//struct pointer_to_global_geometry_list global_geometry_list = {0,NULL};
#endif

int loop_index,found_geometries;

double x_component;
double y_component;
double z_component;

struct Volume_struct this_box_volume;
struct box_storage this_box_storage;

#line 81479 "MACS_sample_kidney_box.c"
#undef number_of_activations
#undef mask_setting
#undef mask_string
#undef p_interact
#undef focus_r
#undef focus_xh
#undef focus_xw
#undef focus_ah
#undef focus_aw
#undef target_z
#undef target_y
#undef target_x
#undef target_index
#undef visualize
#undef yheight2
#undef xwidth2
#undef zdepth
#undef yheight
#undef xwidth
#undef priority
#undef material_string
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

/* User declarations for component 'channel_18_cave2_box2' [836]. */
#define mccompcurname  channel_18_cave2_box2
#define mccompcurtype  Union_box
#define mccompcurindex 836
#define loop_index mccchannel_18_cave2_box2_loop_index
#define this_box_volume mccchannel_18_cave2_box2_this_box_volume
#define global_geometry_element mccchannel_18_cave2_box2_global_geometry_element
#define this_box_storage mccchannel_18_cave2_box2_this_box_storage
#define material_string mccchannel_18_cave2_box2_material_string
#define priority mccchannel_18_cave2_box2_priority
#define xwidth mccchannel_18_cave2_box2_xwidth
#define yheight mccchannel_18_cave2_box2_yheight
#define zdepth mccchannel_18_cave2_box2_zdepth
#define xwidth2 mccchannel_18_cave2_box2_xwidth2
#define yheight2 mccchannel_18_cave2_box2_yheight2
#define visualize mccchannel_18_cave2_box2_visualize
#define target_index mccchannel_18_cave2_box2_target_index
#define target_x mccchannel_18_cave2_box2_target_x
#define target_y mccchannel_18_cave2_box2_target_y
#define target_z mccchannel_18_cave2_box2_target_z
#define focus_aw mccchannel_18_cave2_box2_focus_aw
#define focus_ah mccchannel_18_cave2_box2_focus_ah
#define focus_xw mccchannel_18_cave2_box2_focus_xw
#define focus_xh mccchannel_18_cave2_box2_focus_xh
#define focus_r mccchannel_18_cave2_box2_focus_r
#define p_interact mccchannel_18_cave2_box2_p_interact
#define mask_string mccchannel_18_cave2_box2_mask_string
#define mask_setting mccchannel_18_cave2_box2_mask_setting
#define number_of_activations mccchannel_18_cave2_box2_number_of_activations
#line 204 "Union_box.comp"
// Needed for transport to the main component
struct global_geometry_element_struct global_geometry_element;

#ifndef ANY_GEOMETRY_DETECTOR_DECLARE
    #define ANY_GEOMETRY_DETECTOR_DECLARE dummy
	//struct pointer_to_global_geometry_list global_geometry_list = {0,NULL};
#endif

int loop_index,found_geometries;

double x_component;
double y_component;
double z_component;

struct Volume_struct this_box_volume;
struct box_storage this_box_storage;

#line 81556 "MACS_sample_kidney_box.c"
#undef number_of_activations
#undef mask_setting
#undef mask_string
#undef p_interact
#undef focus_r
#undef focus_xh
#undef focus_xw
#undef focus_ah
#undef focus_aw
#undef target_z
#undef target_y
#undef target_x
#undef target_index
#undef visualize
#undef yheight2
#undef xwidth2
#undef zdepth
#undef yheight
#undef xwidth
#undef priority
#undef material_string
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

/* User declarations for component 'channel_18_cave2_box3' [837]. */
#define mccompcurname  channel_18_cave2_box3
#define mccompcurtype  Union_box
#define mccompcurindex 837
#define loop_index mccchannel_18_cave2_box3_loop_index
#define this_box_volume mccchannel_18_cave2_box3_this_box_volume
#define global_geometry_element mccchannel_18_cave2_box3_global_geometry_element
#define this_box_storage mccchannel_18_cave2_box3_this_box_storage
#define material_string mccchannel_18_cave2_box3_material_string
#define priority mccchannel_18_cave2_box3_priority
#define xwidth mccchannel_18_cave2_box3_xwidth
#define yheight mccchannel_18_cave2_box3_yheight
#define zdepth mccchannel_18_cave2_box3_zdepth
#define xwidth2 mccchannel_18_cave2_box3_xwidth2
#define yheight2 mccchannel_18_cave2_box3_yheight2
#define visualize mccchannel_18_cave2_box3_visualize
#define target_index mccchannel_18_cave2_box3_target_index
#define target_x mccchannel_18_cave2_box3_target_x
#define target_y mccchannel_18_cave2_box3_target_y
#define target_z mccchannel_18_cave2_box3_target_z
#define focus_aw mccchannel_18_cave2_box3_focus_aw
#define focus_ah mccchannel_18_cave2_box3_focus_ah
#define focus_xw mccchannel_18_cave2_box3_focus_xw
#define focus_xh mccchannel_18_cave2_box3_focus_xh
#define focus_r mccchannel_18_cave2_box3_focus_r
#define p_interact mccchannel_18_cave2_box3_p_interact
#define mask_string mccchannel_18_cave2_box3_mask_string
#define mask_setting mccchannel_18_cave2_box3_mask_setting
#define number_of_activations mccchannel_18_cave2_box3_number_of_activations
#line 204 "Union_box.comp"
// Needed for transport to the main component
struct global_geometry_element_struct global_geometry_element;

#ifndef ANY_GEOMETRY_DETECTOR_DECLARE
    #define ANY_GEOMETRY_DETECTOR_DECLARE dummy
	//struct pointer_to_global_geometry_list global_geometry_list = {0,NULL};
#endif

int loop_index,found_geometries;

double x_component;
double y_component;
double z_component;

struct Volume_struct this_box_volume;
struct box_storage this_box_storage;

#line 81633 "MACS_sample_kidney_box.c"
#undef number_of_activations
#undef mask_setting
#undef mask_string
#undef p_interact
#undef focus_r
#undef focus_xh
#undef focus_xw
#undef focus_ah
#undef focus_aw
#undef target_z
#undef target_y
#undef target_x
#undef target_index
#undef visualize
#undef yheight2
#undef xwidth2
#undef zdepth
#undef yheight
#undef xwidth
#undef priority
#undef material_string
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

/* User declarations for component 'inter_analyzer_colimator_center_18' [838]. */
#define mccompcurname  inter_analyzer_colimator_center_18
#define mccompcurtype  Arm
#define mccompcurindex 838
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

/* User declarations for component 'inter_analyzer_colimator_18_blade_0' [839]. */
#define mccompcurname  inter_analyzer_colimator_18_blade_0
#define mccompcurtype  Union_box
#define mccompcurindex 839
#define loop_index mccinter_analyzer_colimator_18_blade_0_loop_index
#define this_box_volume mccinter_analyzer_colimator_18_blade_0_this_box_volume
#define global_geometry_element mccinter_analyzer_colimator_18_blade_0_global_geometry_element
#define this_box_storage mccinter_analyzer_colimator_18_blade_0_this_box_storage
#define material_string mccinter_analyzer_colimator_18_blade_0_material_string
#define priority mccinter_analyzer_colimator_18_blade_0_priority
#define xwidth mccinter_analyzer_colimator_18_blade_0_xwidth
#define yheight mccinter_analyzer_colimator_18_blade_0_yheight
#define zdepth mccinter_analyzer_colimator_18_blade_0_zdepth
#define xwidth2 mccinter_analyzer_colimator_18_blade_0_xwidth2
#define yheight2 mccinter_analyzer_colimator_18_blade_0_yheight2
#define visualize mccinter_analyzer_colimator_18_blade_0_visualize
#define target_index mccinter_analyzer_colimator_18_blade_0_target_index
#define target_x mccinter_analyzer_colimator_18_blade_0_target_x
#define target_y mccinter_analyzer_colimator_18_blade_0_target_y
#define target_z mccinter_analyzer_colimator_18_blade_0_target_z
#define focus_aw mccinter_analyzer_colimator_18_blade_0_focus_aw
#define focus_ah mccinter_analyzer_colimator_18_blade_0_focus_ah
#define focus_xw mccinter_analyzer_colimator_18_blade_0_focus_xw
#define focus_xh mccinter_analyzer_colimator_18_blade_0_focus_xh
#define focus_r mccinter_analyzer_colimator_18_blade_0_focus_r
#define p_interact mccinter_analyzer_colimator_18_blade_0_p_interact
#define mask_string mccinter_analyzer_colimator_18_blade_0_mask_string
#define mask_setting mccinter_analyzer_colimator_18_blade_0_mask_setting
#define number_of_activations mccinter_analyzer_colimator_18_blade_0_number_of_activations
#line 204 "Union_box.comp"
// Needed for transport to the main component
struct global_geometry_element_struct global_geometry_element;

#ifndef ANY_GEOMETRY_DETECTOR_DECLARE
    #define ANY_GEOMETRY_DETECTOR_DECLARE dummy
	//struct pointer_to_global_geometry_list global_geometry_list = {0,NULL};
#endif

int loop_index,found_geometries;

double x_component;
double y_component;
double z_component;

struct Volume_struct this_box_volume;
struct box_storage this_box_storage;

#line 81718 "MACS_sample_kidney_box.c"
#undef number_of_activations
#undef mask_setting
#undef mask_string
#undef p_interact
#undef focus_r
#undef focus_xh
#undef focus_xw
#undef focus_ah
#undef focus_aw
#undef target_z
#undef target_y
#undef target_x
#undef target_index
#undef visualize
#undef yheight2
#undef xwidth2
#undef zdepth
#undef yheight
#undef xwidth
#undef priority
#undef material_string
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

/* User declarations for component 'inter_analyzer_colimator_18_blade_1' [840]. */
#define mccompcurname  inter_analyzer_colimator_18_blade_1
#define mccompcurtype  Union_box
#define mccompcurindex 840
#define loop_index mccinter_analyzer_colimator_18_blade_1_loop_index
#define this_box_volume mccinter_analyzer_colimator_18_blade_1_this_box_volume
#define global_geometry_element mccinter_analyzer_colimator_18_blade_1_global_geometry_element
#define this_box_storage mccinter_analyzer_colimator_18_blade_1_this_box_storage
#define material_string mccinter_analyzer_colimator_18_blade_1_material_string
#define priority mccinter_analyzer_colimator_18_blade_1_priority
#define xwidth mccinter_analyzer_colimator_18_blade_1_xwidth
#define yheight mccinter_analyzer_colimator_18_blade_1_yheight
#define zdepth mccinter_analyzer_colimator_18_blade_1_zdepth
#define xwidth2 mccinter_analyzer_colimator_18_blade_1_xwidth2
#define yheight2 mccinter_analyzer_colimator_18_blade_1_yheight2
#define visualize mccinter_analyzer_colimator_18_blade_1_visualize
#define target_index mccinter_analyzer_colimator_18_blade_1_target_index
#define target_x mccinter_analyzer_colimator_18_blade_1_target_x
#define target_y mccinter_analyzer_colimator_18_blade_1_target_y
#define target_z mccinter_analyzer_colimator_18_blade_1_target_z
#define focus_aw mccinter_analyzer_colimator_18_blade_1_focus_aw
#define focus_ah mccinter_analyzer_colimator_18_blade_1_focus_ah
#define focus_xw mccinter_analyzer_colimator_18_blade_1_focus_xw
#define focus_xh mccinter_analyzer_colimator_18_blade_1_focus_xh
#define focus_r mccinter_analyzer_colimator_18_blade_1_focus_r
#define p_interact mccinter_analyzer_colimator_18_blade_1_p_interact
#define mask_string mccinter_analyzer_colimator_18_blade_1_mask_string
#define mask_setting mccinter_analyzer_colimator_18_blade_1_mask_setting
#define number_of_activations mccinter_analyzer_colimator_18_blade_1_number_of_activations
#line 204 "Union_box.comp"
// Needed for transport to the main component
struct global_geometry_element_struct global_geometry_element;

#ifndef ANY_GEOMETRY_DETECTOR_DECLARE
    #define ANY_GEOMETRY_DETECTOR_DECLARE dummy
	//struct pointer_to_global_geometry_list global_geometry_list = {0,NULL};
#endif

int loop_index,found_geometries;

double x_component;
double y_component;
double z_component;

struct Volume_struct this_box_volume;
struct box_storage this_box_storage;

#line 81795 "MACS_sample_kidney_box.c"
#undef number_of_activations
#undef mask_setting
#undef mask_string
#undef p_interact
#undef focus_r
#undef focus_xh
#undef focus_xw
#undef focus_ah
#undef focus_aw
#undef target_z
#undef target_y
#undef target_x
#undef target_index
#undef visualize
#undef yheight2
#undef xwidth2
#undef zdepth
#undef yheight
#undef xwidth
#undef priority
#undef material_string
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

/* User declarations for component 'inter_analyzer_colimator_18_blade_2' [841]. */
#define mccompcurname  inter_analyzer_colimator_18_blade_2
#define mccompcurtype  Union_box
#define mccompcurindex 841
#define loop_index mccinter_analyzer_colimator_18_blade_2_loop_index
#define this_box_volume mccinter_analyzer_colimator_18_blade_2_this_box_volume
#define global_geometry_element mccinter_analyzer_colimator_18_blade_2_global_geometry_element
#define this_box_storage mccinter_analyzer_colimator_18_blade_2_this_box_storage
#define material_string mccinter_analyzer_colimator_18_blade_2_material_string
#define priority mccinter_analyzer_colimator_18_blade_2_priority
#define xwidth mccinter_analyzer_colimator_18_blade_2_xwidth
#define yheight mccinter_analyzer_colimator_18_blade_2_yheight
#define zdepth mccinter_analyzer_colimator_18_blade_2_zdepth
#define xwidth2 mccinter_analyzer_colimator_18_blade_2_xwidth2
#define yheight2 mccinter_analyzer_colimator_18_blade_2_yheight2
#define visualize mccinter_analyzer_colimator_18_blade_2_visualize
#define target_index mccinter_analyzer_colimator_18_blade_2_target_index
#define target_x mccinter_analyzer_colimator_18_blade_2_target_x
#define target_y mccinter_analyzer_colimator_18_blade_2_target_y
#define target_z mccinter_analyzer_colimator_18_blade_2_target_z
#define focus_aw mccinter_analyzer_colimator_18_blade_2_focus_aw
#define focus_ah mccinter_analyzer_colimator_18_blade_2_focus_ah
#define focus_xw mccinter_analyzer_colimator_18_blade_2_focus_xw
#define focus_xh mccinter_analyzer_colimator_18_blade_2_focus_xh
#define focus_r mccinter_analyzer_colimator_18_blade_2_focus_r
#define p_interact mccinter_analyzer_colimator_18_blade_2_p_interact
#define mask_string mccinter_analyzer_colimator_18_blade_2_mask_string
#define mask_setting mccinter_analyzer_colimator_18_blade_2_mask_setting
#define number_of_activations mccinter_analyzer_colimator_18_blade_2_number_of_activations
#line 204 "Union_box.comp"
// Needed for transport to the main component
struct global_geometry_element_struct global_geometry_element;

#ifndef ANY_GEOMETRY_DETECTOR_DECLARE
    #define ANY_GEOMETRY_DETECTOR_DECLARE dummy
	//struct pointer_to_global_geometry_list global_geometry_list = {0,NULL};
#endif

int loop_index,found_geometries;

double x_component;
double y_component;
double z_component;

struct Volume_struct this_box_volume;
struct box_storage this_box_storage;

#line 81872 "MACS_sample_kidney_box.c"
#undef number_of_activations
#undef mask_setting
#undef mask_string
#undef p_interact
#undef focus_r
#undef focus_xh
#undef focus_xw
#undef focus_ah
#undef focus_aw
#undef target_z
#undef target_y
#undef target_x
#undef target_index
#undef visualize
#undef yheight2
#undef xwidth2
#undef zdepth
#undef yheight
#undef xwidth
#undef priority
#undef material_string
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

/* User declarations for component 'inter_analyzer_colimator_18_blade_3' [842]. */
#define mccompcurname  inter_analyzer_colimator_18_blade_3
#define mccompcurtype  Union_box
#define mccompcurindex 842
#define loop_index mccinter_analyzer_colimator_18_blade_3_loop_index
#define this_box_volume mccinter_analyzer_colimator_18_blade_3_this_box_volume
#define global_geometry_element mccinter_analyzer_colimator_18_blade_3_global_geometry_element
#define this_box_storage mccinter_analyzer_colimator_18_blade_3_this_box_storage
#define material_string mccinter_analyzer_colimator_18_blade_3_material_string
#define priority mccinter_analyzer_colimator_18_blade_3_priority
#define xwidth mccinter_analyzer_colimator_18_blade_3_xwidth
#define yheight mccinter_analyzer_colimator_18_blade_3_yheight
#define zdepth mccinter_analyzer_colimator_18_blade_3_zdepth
#define xwidth2 mccinter_analyzer_colimator_18_blade_3_xwidth2
#define yheight2 mccinter_analyzer_colimator_18_blade_3_yheight2
#define visualize mccinter_analyzer_colimator_18_blade_3_visualize
#define target_index mccinter_analyzer_colimator_18_blade_3_target_index
#define target_x mccinter_analyzer_colimator_18_blade_3_target_x
#define target_y mccinter_analyzer_colimator_18_blade_3_target_y
#define target_z mccinter_analyzer_colimator_18_blade_3_target_z
#define focus_aw mccinter_analyzer_colimator_18_blade_3_focus_aw
#define focus_ah mccinter_analyzer_colimator_18_blade_3_focus_ah
#define focus_xw mccinter_analyzer_colimator_18_blade_3_focus_xw
#define focus_xh mccinter_analyzer_colimator_18_blade_3_focus_xh
#define focus_r mccinter_analyzer_colimator_18_blade_3_focus_r
#define p_interact mccinter_analyzer_colimator_18_blade_3_p_interact
#define mask_string mccinter_analyzer_colimator_18_blade_3_mask_string
#define mask_setting mccinter_analyzer_colimator_18_blade_3_mask_setting
#define number_of_activations mccinter_analyzer_colimator_18_blade_3_number_of_activations
#line 204 "Union_box.comp"
// Needed for transport to the main component
struct global_geometry_element_struct global_geometry_element;

#ifndef ANY_GEOMETRY_DETECTOR_DECLARE
    #define ANY_GEOMETRY_DETECTOR_DECLARE dummy
	//struct pointer_to_global_geometry_list global_geometry_list = {0,NULL};
#endif

int loop_index,found_geometries;

double x_component;
double y_component;
double z_component;

struct Volume_struct this_box_volume;
struct box_storage this_box_storage;

#line 81949 "MACS_sample_kidney_box.c"
#undef number_of_activations
#undef mask_setting
#undef mask_string
#undef p_interact
#undef focus_r
#undef focus_xh
#undef focus_xw
#undef focus_ah
#undef focus_aw
#undef target_z
#undef target_y
#undef target_x
#undef target_index
#undef visualize
#undef yheight2
#undef xwidth2
#undef zdepth
#undef yheight
#undef xwidth
#undef priority
#undef material_string
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

/* User declarations for component 'inter_analyzer_colimator_18_blade_4' [843]. */
#define mccompcurname  inter_analyzer_colimator_18_blade_4
#define mccompcurtype  Union_box
#define mccompcurindex 843
#define loop_index mccinter_analyzer_colimator_18_blade_4_loop_index
#define this_box_volume mccinter_analyzer_colimator_18_blade_4_this_box_volume
#define global_geometry_element mccinter_analyzer_colimator_18_blade_4_global_geometry_element
#define this_box_storage mccinter_analyzer_colimator_18_blade_4_this_box_storage
#define material_string mccinter_analyzer_colimator_18_blade_4_material_string
#define priority mccinter_analyzer_colimator_18_blade_4_priority
#define xwidth mccinter_analyzer_colimator_18_blade_4_xwidth
#define yheight mccinter_analyzer_colimator_18_blade_4_yheight
#define zdepth mccinter_analyzer_colimator_18_blade_4_zdepth
#define xwidth2 mccinter_analyzer_colimator_18_blade_4_xwidth2
#define yheight2 mccinter_analyzer_colimator_18_blade_4_yheight2
#define visualize mccinter_analyzer_colimator_18_blade_4_visualize
#define target_index mccinter_analyzer_colimator_18_blade_4_target_index
#define target_x mccinter_analyzer_colimator_18_blade_4_target_x
#define target_y mccinter_analyzer_colimator_18_blade_4_target_y
#define target_z mccinter_analyzer_colimator_18_blade_4_target_z
#define focus_aw mccinter_analyzer_colimator_18_blade_4_focus_aw
#define focus_ah mccinter_analyzer_colimator_18_blade_4_focus_ah
#define focus_xw mccinter_analyzer_colimator_18_blade_4_focus_xw
#define focus_xh mccinter_analyzer_colimator_18_blade_4_focus_xh
#define focus_r mccinter_analyzer_colimator_18_blade_4_focus_r
#define p_interact mccinter_analyzer_colimator_18_blade_4_p_interact
#define mask_string mccinter_analyzer_colimator_18_blade_4_mask_string
#define mask_setting mccinter_analyzer_colimator_18_blade_4_mask_setting
#define number_of_activations mccinter_analyzer_colimator_18_blade_4_number_of_activations
#line 204 "Union_box.comp"
// Needed for transport to the main component
struct global_geometry_element_struct global_geometry_element;

#ifndef ANY_GEOMETRY_DETECTOR_DECLARE
    #define ANY_GEOMETRY_DETECTOR_DECLARE dummy
	//struct pointer_to_global_geometry_list global_geometry_list = {0,NULL};
#endif

int loop_index,found_geometries;

double x_component;
double y_component;
double z_component;

struct Volume_struct this_box_volume;
struct box_storage this_box_storage;

#line 82026 "MACS_sample_kidney_box.c"
#undef number_of_activations
#undef mask_setting
#undef mask_string
#undef p_interact
#undef focus_r
#undef focus_xh
#undef focus_xw
#undef focus_ah
#undef focus_aw
#undef target_z
#undef target_y
#undef target_x
#undef target_index
#undef visualize
#undef yheight2
#undef xwidth2
#undef zdepth
#undef yheight
#undef xwidth
#undef priority
#undef material_string
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

/* User declarations for component 'diffraction_detector_18_exit_volume' [844]. */
#define mccompcurname  diffraction_detector_18_exit_volume
#define mccompcurtype  Union_box
#define mccompcurindex 844
#define loop_index mccdiffraction_detector_18_exit_volume_loop_index
#define this_box_volume mccdiffraction_detector_18_exit_volume_this_box_volume
#define global_geometry_element mccdiffraction_detector_18_exit_volume_global_geometry_element
#define this_box_storage mccdiffraction_detector_18_exit_volume_this_box_storage
#define material_string mccdiffraction_detector_18_exit_volume_material_string
#define priority mccdiffraction_detector_18_exit_volume_priority
#define xwidth mccdiffraction_detector_18_exit_volume_xwidth
#define yheight mccdiffraction_detector_18_exit_volume_yheight
#define zdepth mccdiffraction_detector_18_exit_volume_zdepth
#define xwidth2 mccdiffraction_detector_18_exit_volume_xwidth2
#define yheight2 mccdiffraction_detector_18_exit_volume_yheight2
#define visualize mccdiffraction_detector_18_exit_volume_visualize
#define target_index mccdiffraction_detector_18_exit_volume_target_index
#define target_x mccdiffraction_detector_18_exit_volume_target_x
#define target_y mccdiffraction_detector_18_exit_volume_target_y
#define target_z mccdiffraction_detector_18_exit_volume_target_z
#define focus_aw mccdiffraction_detector_18_exit_volume_focus_aw
#define focus_ah mccdiffraction_detector_18_exit_volume_focus_ah
#define focus_xw mccdiffraction_detector_18_exit_volume_focus_xw
#define focus_xh mccdiffraction_detector_18_exit_volume_focus_xh
#define focus_r mccdiffraction_detector_18_exit_volume_focus_r
#define p_interact mccdiffraction_detector_18_exit_volume_p_interact
#define mask_string mccdiffraction_detector_18_exit_volume_mask_string
#define mask_setting mccdiffraction_detector_18_exit_volume_mask_setting
#define number_of_activations mccdiffraction_detector_18_exit_volume_number_of_activations
#line 204 "Union_box.comp"
// Needed for transport to the main component
struct global_geometry_element_struct global_geometry_element;

#ifndef ANY_GEOMETRY_DETECTOR_DECLARE
    #define ANY_GEOMETRY_DETECTOR_DECLARE dummy
	//struct pointer_to_global_geometry_list global_geometry_list = {0,NULL};
#endif

int loop_index,found_geometries;

double x_component;
double y_component;
double z_component;

struct Volume_struct this_box_volume;
struct box_storage this_box_storage;

#line 82103 "MACS_sample_kidney_box.c"
#undef number_of_activations
#undef mask_setting
#undef mask_string
#undef p_interact
#undef focus_r
#undef focus_xh
#undef focus_xw
#undef focus_ah
#undef focus_aw
#undef target_z
#undef target_y
#undef target_x
#undef target_index
#undef visualize
#undef yheight2
#undef xwidth2
#undef zdepth
#undef yheight
#undef xwidth
#undef priority
#undef material_string
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

/* User declarations for component 'spec_detector_18_exit_volume' [845]. */
#define mccompcurname  spec_detector_18_exit_volume
#define mccompcurtype  Union_box
#define mccompcurindex 845
#define loop_index mccspec_detector_18_exit_volume_loop_index
#define this_box_volume mccspec_detector_18_exit_volume_this_box_volume
#define global_geometry_element mccspec_detector_18_exit_volume_global_geometry_element
#define this_box_storage mccspec_detector_18_exit_volume_this_box_storage
#define material_string mccspec_detector_18_exit_volume_material_string
#define priority mccspec_detector_18_exit_volume_priority
#define xwidth mccspec_detector_18_exit_volume_xwidth
#define yheight mccspec_detector_18_exit_volume_yheight
#define zdepth mccspec_detector_18_exit_volume_zdepth
#define xwidth2 mccspec_detector_18_exit_volume_xwidth2
#define yheight2 mccspec_detector_18_exit_volume_yheight2
#define visualize mccspec_detector_18_exit_volume_visualize
#define target_index mccspec_detector_18_exit_volume_target_index
#define target_x mccspec_detector_18_exit_volume_target_x
#define target_y mccspec_detector_18_exit_volume_target_y
#define target_z mccspec_detector_18_exit_volume_target_z
#define focus_aw mccspec_detector_18_exit_volume_focus_aw
#define focus_ah mccspec_detector_18_exit_volume_focus_ah
#define focus_xw mccspec_detector_18_exit_volume_focus_xw
#define focus_xh mccspec_detector_18_exit_volume_focus_xh
#define focus_r mccspec_detector_18_exit_volume_focus_r
#define p_interact mccspec_detector_18_exit_volume_p_interact
#define mask_string mccspec_detector_18_exit_volume_mask_string
#define mask_setting mccspec_detector_18_exit_volume_mask_setting
#define number_of_activations mccspec_detector_18_exit_volume_number_of_activations
#line 204 "Union_box.comp"
// Needed for transport to the main component
struct global_geometry_element_struct global_geometry_element;

#ifndef ANY_GEOMETRY_DETECTOR_DECLARE
    #define ANY_GEOMETRY_DETECTOR_DECLARE dummy
	//struct pointer_to_global_geometry_list global_geometry_list = {0,NULL};
#endif

int loop_index,found_geometries;

double x_component;
double y_component;
double z_component;

struct Volume_struct this_box_volume;
struct box_storage this_box_storage;

#line 82180 "MACS_sample_kidney_box.c"
#undef number_of_activations
#undef mask_setting
#undef mask_string
#undef p_interact
#undef focus_r
#undef focus_xh
#undef focus_xw
#undef focus_ah
#undef focus_aw
#undef target_z
#undef target_y
#undef target_x
#undef target_index
#undef visualize
#undef yheight2
#undef xwidth2
#undef zdepth
#undef yheight
#undef xwidth
#undef priority
#undef material_string
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

/* User declarations for component 'channel_19_cave1_box1' [846]. */
#define mccompcurname  channel_19_cave1_box1
#define mccompcurtype  Union_box
#define mccompcurindex 846
#define loop_index mccchannel_19_cave1_box1_loop_index
#define this_box_volume mccchannel_19_cave1_box1_this_box_volume
#define global_geometry_element mccchannel_19_cave1_box1_global_geometry_element
#define this_box_storage mccchannel_19_cave1_box1_this_box_storage
#define material_string mccchannel_19_cave1_box1_material_string
#define priority mccchannel_19_cave1_box1_priority
#define xwidth mccchannel_19_cave1_box1_xwidth
#define yheight mccchannel_19_cave1_box1_yheight
#define zdepth mccchannel_19_cave1_box1_zdepth
#define xwidth2 mccchannel_19_cave1_box1_xwidth2
#define yheight2 mccchannel_19_cave1_box1_yheight2
#define visualize mccchannel_19_cave1_box1_visualize
#define target_index mccchannel_19_cave1_box1_target_index
#define target_x mccchannel_19_cave1_box1_target_x
#define target_y mccchannel_19_cave1_box1_target_y
#define target_z mccchannel_19_cave1_box1_target_z
#define focus_aw mccchannel_19_cave1_box1_focus_aw
#define focus_ah mccchannel_19_cave1_box1_focus_ah
#define focus_xw mccchannel_19_cave1_box1_focus_xw
#define focus_xh mccchannel_19_cave1_box1_focus_xh
#define focus_r mccchannel_19_cave1_box1_focus_r
#define p_interact mccchannel_19_cave1_box1_p_interact
#define mask_string mccchannel_19_cave1_box1_mask_string
#define mask_setting mccchannel_19_cave1_box1_mask_setting
#define number_of_activations mccchannel_19_cave1_box1_number_of_activations
#line 204 "Union_box.comp"
// Needed for transport to the main component
struct global_geometry_element_struct global_geometry_element;

#ifndef ANY_GEOMETRY_DETECTOR_DECLARE
    #define ANY_GEOMETRY_DETECTOR_DECLARE dummy
	//struct pointer_to_global_geometry_list global_geometry_list = {0,NULL};
#endif

int loop_index,found_geometries;

double x_component;
double y_component;
double z_component;

struct Volume_struct this_box_volume;
struct box_storage this_box_storage;

#line 82257 "MACS_sample_kidney_box.c"
#undef number_of_activations
#undef mask_setting
#undef mask_string
#undef p_interact
#undef focus_r
#undef focus_xh
#undef focus_xw
#undef focus_ah
#undef focus_aw
#undef target_z
#undef target_y
#undef target_x
#undef target_index
#undef visualize
#undef yheight2
#undef xwidth2
#undef zdepth
#undef yheight
#undef xwidth
#undef priority
#undef material_string
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

/* User declarations for component 'channel_19_cave1_box2' [847]. */
#define mccompcurname  channel_19_cave1_box2
#define mccompcurtype  Union_box
#define mccompcurindex 847
#define loop_index mccchannel_19_cave1_box2_loop_index
#define this_box_volume mccchannel_19_cave1_box2_this_box_volume
#define global_geometry_element mccchannel_19_cave1_box2_global_geometry_element
#define this_box_storage mccchannel_19_cave1_box2_this_box_storage
#define material_string mccchannel_19_cave1_box2_material_string
#define priority mccchannel_19_cave1_box2_priority
#define xwidth mccchannel_19_cave1_box2_xwidth
#define yheight mccchannel_19_cave1_box2_yheight
#define zdepth mccchannel_19_cave1_box2_zdepth
#define xwidth2 mccchannel_19_cave1_box2_xwidth2
#define yheight2 mccchannel_19_cave1_box2_yheight2
#define visualize mccchannel_19_cave1_box2_visualize
#define target_index mccchannel_19_cave1_box2_target_index
#define target_x mccchannel_19_cave1_box2_target_x
#define target_y mccchannel_19_cave1_box2_target_y
#define target_z mccchannel_19_cave1_box2_target_z
#define focus_aw mccchannel_19_cave1_box2_focus_aw
#define focus_ah mccchannel_19_cave1_box2_focus_ah
#define focus_xw mccchannel_19_cave1_box2_focus_xw
#define focus_xh mccchannel_19_cave1_box2_focus_xh
#define focus_r mccchannel_19_cave1_box2_focus_r
#define p_interact mccchannel_19_cave1_box2_p_interact
#define mask_string mccchannel_19_cave1_box2_mask_string
#define mask_setting mccchannel_19_cave1_box2_mask_setting
#define number_of_activations mccchannel_19_cave1_box2_number_of_activations
#line 204 "Union_box.comp"
// Needed for transport to the main component
struct global_geometry_element_struct global_geometry_element;

#ifndef ANY_GEOMETRY_DETECTOR_DECLARE
    #define ANY_GEOMETRY_DETECTOR_DECLARE dummy
	//struct pointer_to_global_geometry_list global_geometry_list = {0,NULL};
#endif

int loop_index,found_geometries;

double x_component;
double y_component;
double z_component;

struct Volume_struct this_box_volume;
struct box_storage this_box_storage;

#line 82334 "MACS_sample_kidney_box.c"
#undef number_of_activations
#undef mask_setting
#undef mask_string
#undef p_interact
#undef focus_r
#undef focus_xh
#undef focus_xw
#undef focus_ah
#undef focus_aw
#undef target_z
#undef target_y
#undef target_x
#undef target_index
#undef visualize
#undef yheight2
#undef xwidth2
#undef zdepth
#undef yheight
#undef xwidth
#undef priority
#undef material_string
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

/* User declarations for component 'channel_19_cave1_box3' [848]. */
#define mccompcurname  channel_19_cave1_box3
#define mccompcurtype  Union_box
#define mccompcurindex 848
#define loop_index mccchannel_19_cave1_box3_loop_index
#define this_box_volume mccchannel_19_cave1_box3_this_box_volume
#define global_geometry_element mccchannel_19_cave1_box3_global_geometry_element
#define this_box_storage mccchannel_19_cave1_box3_this_box_storage
#define material_string mccchannel_19_cave1_box3_material_string
#define priority mccchannel_19_cave1_box3_priority
#define xwidth mccchannel_19_cave1_box3_xwidth
#define yheight mccchannel_19_cave1_box3_yheight
#define zdepth mccchannel_19_cave1_box3_zdepth
#define xwidth2 mccchannel_19_cave1_box3_xwidth2
#define yheight2 mccchannel_19_cave1_box3_yheight2
#define visualize mccchannel_19_cave1_box3_visualize
#define target_index mccchannel_19_cave1_box3_target_index
#define target_x mccchannel_19_cave1_box3_target_x
#define target_y mccchannel_19_cave1_box3_target_y
#define target_z mccchannel_19_cave1_box3_target_z
#define focus_aw mccchannel_19_cave1_box3_focus_aw
#define focus_ah mccchannel_19_cave1_box3_focus_ah
#define focus_xw mccchannel_19_cave1_box3_focus_xw
#define focus_xh mccchannel_19_cave1_box3_focus_xh
#define focus_r mccchannel_19_cave1_box3_focus_r
#define p_interact mccchannel_19_cave1_box3_p_interact
#define mask_string mccchannel_19_cave1_box3_mask_string
#define mask_setting mccchannel_19_cave1_box3_mask_setting
#define number_of_activations mccchannel_19_cave1_box3_number_of_activations
#line 204 "Union_box.comp"
// Needed for transport to the main component
struct global_geometry_element_struct global_geometry_element;

#ifndef ANY_GEOMETRY_DETECTOR_DECLARE
    #define ANY_GEOMETRY_DETECTOR_DECLARE dummy
	//struct pointer_to_global_geometry_list global_geometry_list = {0,NULL};
#endif

int loop_index,found_geometries;

double x_component;
double y_component;
double z_component;

struct Volume_struct this_box_volume;
struct box_storage this_box_storage;

#line 82411 "MACS_sample_kidney_box.c"
#undef number_of_activations
#undef mask_setting
#undef mask_string
#undef p_interact
#undef focus_r
#undef focus_xh
#undef focus_xw
#undef focus_ah
#undef focus_aw
#undef target_z
#undef target_y
#undef target_x
#undef target_index
#undef visualize
#undef yheight2
#undef xwidth2
#undef zdepth
#undef yheight
#undef xwidth
#undef priority
#undef material_string
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

/* User declarations for component 'channel_19_cave1_cyl1' [849]. */
#define mccompcurname  channel_19_cave1_cyl1
#define mccompcurtype  Union_cylinder
#define mccompcurindex 849
#define loop_index mccchannel_19_cave1_cyl1_loop_index
#define this_cylinder_volume mccchannel_19_cave1_cyl1_this_cylinder_volume
#define global_geometry_element mccchannel_19_cave1_cyl1_global_geometry_element
#define this_cylinder_storage mccchannel_19_cave1_cyl1_this_cylinder_storage
#define material_string mccchannel_19_cave1_cyl1_material_string
#define priority mccchannel_19_cave1_cyl1_priority
#define radius mccchannel_19_cave1_cyl1_radius
#define yheight mccchannel_19_cave1_cyl1_yheight
#define visualize mccchannel_19_cave1_cyl1_visualize
#define target_index mccchannel_19_cave1_cyl1_target_index
#define target_x mccchannel_19_cave1_cyl1_target_x
#define target_y mccchannel_19_cave1_cyl1_target_y
#define target_z mccchannel_19_cave1_cyl1_target_z
#define focus_aw mccchannel_19_cave1_cyl1_focus_aw
#define focus_ah mccchannel_19_cave1_cyl1_focus_ah
#define focus_xw mccchannel_19_cave1_cyl1_focus_xw
#define focus_xh mccchannel_19_cave1_cyl1_focus_xh
#define focus_r mccchannel_19_cave1_cyl1_focus_r
#define p_interact mccchannel_19_cave1_cyl1_p_interact
#define mask_string mccchannel_19_cave1_cyl1_mask_string
#define mask_setting mccchannel_19_cave1_cyl1_mask_setting
#define number_of_activations mccchannel_19_cave1_cyl1_number_of_activations
#line 167 "Union_cylinder.comp"
// Needed for transport to the main component
struct global_geometry_element_struct global_geometry_element;

#ifndef ANY_GEOMETRY_DETECTOR_DECLARE
    #define ANY_GEOMETRY_DETECTOR_DECLARE dummy
	//struct pointer_to_global_geometry_list global_geometry_list = {0,NULL};
#endif

int dummy;
int loop_index,found_geometries;
int loop_2_index;
int material_index;

struct Volume_struct this_cylinder_volume;
struct cylinder_storage this_cylinder_storage;
#line 82483 "MACS_sample_kidney_box.c"
#undef number_of_activations
#undef mask_setting
#undef mask_string
#undef p_interact
#undef focus_r
#undef focus_xh
#undef focus_xw
#undef focus_ah
#undef focus_aw
#undef target_z
#undef target_y
#undef target_x
#undef target_index
#undef visualize
#undef yheight
#undef radius
#undef priority
#undef material_string
#undef this_cylinder_storage
#undef global_geometry_element
#undef this_cylinder_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

/* User declarations for component 'channel_19_analyzer_1_center' [850]. */
#define mccompcurname  channel_19_analyzer_1_center
#define mccompcurtype  Arm
#define mccompcurindex 850
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

/* User declarations for component 'channel_19_analyzer_1_rotated' [851]. */
#define mccompcurname  channel_19_analyzer_1_rotated
#define mccompcurtype  Arm
#define mccompcurindex 851
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

/* User declarations for component 'channel_19_analyzer_1_array_crystal_array_0' [852]. */
#define mccompcurname  channel_19_analyzer_1_array_crystal_array_0
#define mccompcurtype  Union_box
#define mccompcurindex 852
#define loop_index mccchannel_19_analyzer_1_array_crystal_array_0_loop_index
#define this_box_volume mccchannel_19_analyzer_1_array_crystal_array_0_this_box_volume
#define global_geometry_element mccchannel_19_analyzer_1_array_crystal_array_0_global_geometry_element
#define this_box_storage mccchannel_19_analyzer_1_array_crystal_array_0_this_box_storage
#define material_string mccchannel_19_analyzer_1_array_crystal_array_0_material_string
#define priority mccchannel_19_analyzer_1_array_crystal_array_0_priority
#define xwidth mccchannel_19_analyzer_1_array_crystal_array_0_xwidth
#define yheight mccchannel_19_analyzer_1_array_crystal_array_0_yheight
#define zdepth mccchannel_19_analyzer_1_array_crystal_array_0_zdepth
#define xwidth2 mccchannel_19_analyzer_1_array_crystal_array_0_xwidth2
#define yheight2 mccchannel_19_analyzer_1_array_crystal_array_0_yheight2
#define visualize mccchannel_19_analyzer_1_array_crystal_array_0_visualize
#define target_index mccchannel_19_analyzer_1_array_crystal_array_0_target_index
#define target_x mccchannel_19_analyzer_1_array_crystal_array_0_target_x
#define target_y mccchannel_19_analyzer_1_array_crystal_array_0_target_y
#define target_z mccchannel_19_analyzer_1_array_crystal_array_0_target_z
#define focus_aw mccchannel_19_analyzer_1_array_crystal_array_0_focus_aw
#define focus_ah mccchannel_19_analyzer_1_array_crystal_array_0_focus_ah
#define focus_xw mccchannel_19_analyzer_1_array_crystal_array_0_focus_xw
#define focus_xh mccchannel_19_analyzer_1_array_crystal_array_0_focus_xh
#define focus_r mccchannel_19_analyzer_1_array_crystal_array_0_focus_r
#define p_interact mccchannel_19_analyzer_1_array_crystal_array_0_p_interact
#define mask_string mccchannel_19_analyzer_1_array_crystal_array_0_mask_string
#define mask_setting mccchannel_19_analyzer_1_array_crystal_array_0_mask_setting
#define number_of_activations mccchannel_19_analyzer_1_array_crystal_array_0_number_of_activations
#line 204 "Union_box.comp"
// Needed for transport to the main component
struct global_geometry_element_struct global_geometry_element;

#ifndef ANY_GEOMETRY_DETECTOR_DECLARE
    #define ANY_GEOMETRY_DETECTOR_DECLARE dummy
	//struct pointer_to_global_geometry_list global_geometry_list = {0,NULL};
#endif

int loop_index,found_geometries;

double x_component;
double y_component;
double z_component;

struct Volume_struct this_box_volume;
struct box_storage this_box_storage;

#line 82573 "MACS_sample_kidney_box.c"
#undef number_of_activations
#undef mask_setting
#undef mask_string
#undef p_interact
#undef focus_r
#undef focus_xh
#undef focus_xw
#undef focus_ah
#undef focus_aw
#undef target_z
#undef target_y
#undef target_x
#undef target_index
#undef visualize
#undef yheight2
#undef xwidth2
#undef zdepth
#undef yheight
#undef xwidth
#undef priority
#undef material_string
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

/* User declarations for component 'channel_19_analyzer_1_array_crystal_array_1' [853]. */
#define mccompcurname  channel_19_analyzer_1_array_crystal_array_1
#define mccompcurtype  Union_box
#define mccompcurindex 853
#define loop_index mccchannel_19_analyzer_1_array_crystal_array_1_loop_index
#define this_box_volume mccchannel_19_analyzer_1_array_crystal_array_1_this_box_volume
#define global_geometry_element mccchannel_19_analyzer_1_array_crystal_array_1_global_geometry_element
#define this_box_storage mccchannel_19_analyzer_1_array_crystal_array_1_this_box_storage
#define material_string mccchannel_19_analyzer_1_array_crystal_array_1_material_string
#define priority mccchannel_19_analyzer_1_array_crystal_array_1_priority
#define xwidth mccchannel_19_analyzer_1_array_crystal_array_1_xwidth
#define yheight mccchannel_19_analyzer_1_array_crystal_array_1_yheight
#define zdepth mccchannel_19_analyzer_1_array_crystal_array_1_zdepth
#define xwidth2 mccchannel_19_analyzer_1_array_crystal_array_1_xwidth2
#define yheight2 mccchannel_19_analyzer_1_array_crystal_array_1_yheight2
#define visualize mccchannel_19_analyzer_1_array_crystal_array_1_visualize
#define target_index mccchannel_19_analyzer_1_array_crystal_array_1_target_index
#define target_x mccchannel_19_analyzer_1_array_crystal_array_1_target_x
#define target_y mccchannel_19_analyzer_1_array_crystal_array_1_target_y
#define target_z mccchannel_19_analyzer_1_array_crystal_array_1_target_z
#define focus_aw mccchannel_19_analyzer_1_array_crystal_array_1_focus_aw
#define focus_ah mccchannel_19_analyzer_1_array_crystal_array_1_focus_ah
#define focus_xw mccchannel_19_analyzer_1_array_crystal_array_1_focus_xw
#define focus_xh mccchannel_19_analyzer_1_array_crystal_array_1_focus_xh
#define focus_r mccchannel_19_analyzer_1_array_crystal_array_1_focus_r
#define p_interact mccchannel_19_analyzer_1_array_crystal_array_1_p_interact
#define mask_string mccchannel_19_analyzer_1_array_crystal_array_1_mask_string
#define mask_setting mccchannel_19_analyzer_1_array_crystal_array_1_mask_setting
#define number_of_activations mccchannel_19_analyzer_1_array_crystal_array_1_number_of_activations
#line 204 "Union_box.comp"
// Needed for transport to the main component
struct global_geometry_element_struct global_geometry_element;

#ifndef ANY_GEOMETRY_DETECTOR_DECLARE
    #define ANY_GEOMETRY_DETECTOR_DECLARE dummy
	//struct pointer_to_global_geometry_list global_geometry_list = {0,NULL};
#endif

int loop_index,found_geometries;

double x_component;
double y_component;
double z_component;

struct Volume_struct this_box_volume;
struct box_storage this_box_storage;

#line 82650 "MACS_sample_kidney_box.c"
#undef number_of_activations
#undef mask_setting
#undef mask_string
#undef p_interact
#undef focus_r
#undef focus_xh
#undef focus_xw
#undef focus_ah
#undef focus_aw
#undef target_z
#undef target_y
#undef target_x
#undef target_index
#undef visualize
#undef yheight2
#undef xwidth2
#undef zdepth
#undef yheight
#undef xwidth
#undef priority
#undef material_string
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

/* User declarations for component 'channel_19_analyzer_1_array_crystal_array_2' [854]. */
#define mccompcurname  channel_19_analyzer_1_array_crystal_array_2
#define mccompcurtype  Union_box
#define mccompcurindex 854
#define loop_index mccchannel_19_analyzer_1_array_crystal_array_2_loop_index
#define this_box_volume mccchannel_19_analyzer_1_array_crystal_array_2_this_box_volume
#define global_geometry_element mccchannel_19_analyzer_1_array_crystal_array_2_global_geometry_element
#define this_box_storage mccchannel_19_analyzer_1_array_crystal_array_2_this_box_storage
#define material_string mccchannel_19_analyzer_1_array_crystal_array_2_material_string
#define priority mccchannel_19_analyzer_1_array_crystal_array_2_priority
#define xwidth mccchannel_19_analyzer_1_array_crystal_array_2_xwidth
#define yheight mccchannel_19_analyzer_1_array_crystal_array_2_yheight
#define zdepth mccchannel_19_analyzer_1_array_crystal_array_2_zdepth
#define xwidth2 mccchannel_19_analyzer_1_array_crystal_array_2_xwidth2
#define yheight2 mccchannel_19_analyzer_1_array_crystal_array_2_yheight2
#define visualize mccchannel_19_analyzer_1_array_crystal_array_2_visualize
#define target_index mccchannel_19_analyzer_1_array_crystal_array_2_target_index
#define target_x mccchannel_19_analyzer_1_array_crystal_array_2_target_x
#define target_y mccchannel_19_analyzer_1_array_crystal_array_2_target_y
#define target_z mccchannel_19_analyzer_1_array_crystal_array_2_target_z
#define focus_aw mccchannel_19_analyzer_1_array_crystal_array_2_focus_aw
#define focus_ah mccchannel_19_analyzer_1_array_crystal_array_2_focus_ah
#define focus_xw mccchannel_19_analyzer_1_array_crystal_array_2_focus_xw
#define focus_xh mccchannel_19_analyzer_1_array_crystal_array_2_focus_xh
#define focus_r mccchannel_19_analyzer_1_array_crystal_array_2_focus_r
#define p_interact mccchannel_19_analyzer_1_array_crystal_array_2_p_interact
#define mask_string mccchannel_19_analyzer_1_array_crystal_array_2_mask_string
#define mask_setting mccchannel_19_analyzer_1_array_crystal_array_2_mask_setting
#define number_of_activations mccchannel_19_analyzer_1_array_crystal_array_2_number_of_activations
#line 204 "Union_box.comp"
// Needed for transport to the main component
struct global_geometry_element_struct global_geometry_element;

#ifndef ANY_GEOMETRY_DETECTOR_DECLARE
    #define ANY_GEOMETRY_DETECTOR_DECLARE dummy
	//struct pointer_to_global_geometry_list global_geometry_list = {0,NULL};
#endif

int loop_index,found_geometries;

double x_component;
double y_component;
double z_component;

struct Volume_struct this_box_volume;
struct box_storage this_box_storage;

#line 82727 "MACS_sample_kidney_box.c"
#undef number_of_activations
#undef mask_setting
#undef mask_string
#undef p_interact
#undef focus_r
#undef focus_xh
#undef focus_xw
#undef focus_ah
#undef focus_aw
#undef target_z
#undef target_y
#undef target_x
#undef target_index
#undef visualize
#undef yheight2
#undef xwidth2
#undef zdepth
#undef yheight
#undef xwidth
#undef priority
#undef material_string
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

/* User declarations for component 'channel_19_analyzer_1_array_crystal_array_3' [855]. */
#define mccompcurname  channel_19_analyzer_1_array_crystal_array_3
#define mccompcurtype  Union_box
#define mccompcurindex 855
#define loop_index mccchannel_19_analyzer_1_array_crystal_array_3_loop_index
#define this_box_volume mccchannel_19_analyzer_1_array_crystal_array_3_this_box_volume
#define global_geometry_element mccchannel_19_analyzer_1_array_crystal_array_3_global_geometry_element
#define this_box_storage mccchannel_19_analyzer_1_array_crystal_array_3_this_box_storage
#define material_string mccchannel_19_analyzer_1_array_crystal_array_3_material_string
#define priority mccchannel_19_analyzer_1_array_crystal_array_3_priority
#define xwidth mccchannel_19_analyzer_1_array_crystal_array_3_xwidth
#define yheight mccchannel_19_analyzer_1_array_crystal_array_3_yheight
#define zdepth mccchannel_19_analyzer_1_array_crystal_array_3_zdepth
#define xwidth2 mccchannel_19_analyzer_1_array_crystal_array_3_xwidth2
#define yheight2 mccchannel_19_analyzer_1_array_crystal_array_3_yheight2
#define visualize mccchannel_19_analyzer_1_array_crystal_array_3_visualize
#define target_index mccchannel_19_analyzer_1_array_crystal_array_3_target_index
#define target_x mccchannel_19_analyzer_1_array_crystal_array_3_target_x
#define target_y mccchannel_19_analyzer_1_array_crystal_array_3_target_y
#define target_z mccchannel_19_analyzer_1_array_crystal_array_3_target_z
#define focus_aw mccchannel_19_analyzer_1_array_crystal_array_3_focus_aw
#define focus_ah mccchannel_19_analyzer_1_array_crystal_array_3_focus_ah
#define focus_xw mccchannel_19_analyzer_1_array_crystal_array_3_focus_xw
#define focus_xh mccchannel_19_analyzer_1_array_crystal_array_3_focus_xh
#define focus_r mccchannel_19_analyzer_1_array_crystal_array_3_focus_r
#define p_interact mccchannel_19_analyzer_1_array_crystal_array_3_p_interact
#define mask_string mccchannel_19_analyzer_1_array_crystal_array_3_mask_string
#define mask_setting mccchannel_19_analyzer_1_array_crystal_array_3_mask_setting
#define number_of_activations mccchannel_19_analyzer_1_array_crystal_array_3_number_of_activations
#line 204 "Union_box.comp"
// Needed for transport to the main component
struct global_geometry_element_struct global_geometry_element;

#ifndef ANY_GEOMETRY_DETECTOR_DECLARE
    #define ANY_GEOMETRY_DETECTOR_DECLARE dummy
	//struct pointer_to_global_geometry_list global_geometry_list = {0,NULL};
#endif

int loop_index,found_geometries;

double x_component;
double y_component;
double z_component;

struct Volume_struct this_box_volume;
struct box_storage this_box_storage;

#line 82804 "MACS_sample_kidney_box.c"
#undef number_of_activations
#undef mask_setting
#undef mask_string
#undef p_interact
#undef focus_r
#undef focus_xh
#undef focus_xw
#undef focus_ah
#undef focus_aw
#undef target_z
#undef target_y
#undef target_x
#undef target_index
#undef visualize
#undef yheight2
#undef xwidth2
#undef zdepth
#undef yheight
#undef xwidth
#undef priority
#undef material_string
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

/* User declarations for component 'channel_19_analyzer_1_array_crystal_array_4' [856]. */
#define mccompcurname  channel_19_analyzer_1_array_crystal_array_4
#define mccompcurtype  Union_box
#define mccompcurindex 856
#define loop_index mccchannel_19_analyzer_1_array_crystal_array_4_loop_index
#define this_box_volume mccchannel_19_analyzer_1_array_crystal_array_4_this_box_volume
#define global_geometry_element mccchannel_19_analyzer_1_array_crystal_array_4_global_geometry_element
#define this_box_storage mccchannel_19_analyzer_1_array_crystal_array_4_this_box_storage
#define material_string mccchannel_19_analyzer_1_array_crystal_array_4_material_string
#define priority mccchannel_19_analyzer_1_array_crystal_array_4_priority
#define xwidth mccchannel_19_analyzer_1_array_crystal_array_4_xwidth
#define yheight mccchannel_19_analyzer_1_array_crystal_array_4_yheight
#define zdepth mccchannel_19_analyzer_1_array_crystal_array_4_zdepth
#define xwidth2 mccchannel_19_analyzer_1_array_crystal_array_4_xwidth2
#define yheight2 mccchannel_19_analyzer_1_array_crystal_array_4_yheight2
#define visualize mccchannel_19_analyzer_1_array_crystal_array_4_visualize
#define target_index mccchannel_19_analyzer_1_array_crystal_array_4_target_index
#define target_x mccchannel_19_analyzer_1_array_crystal_array_4_target_x
#define target_y mccchannel_19_analyzer_1_array_crystal_array_4_target_y
#define target_z mccchannel_19_analyzer_1_array_crystal_array_4_target_z
#define focus_aw mccchannel_19_analyzer_1_array_crystal_array_4_focus_aw
#define focus_ah mccchannel_19_analyzer_1_array_crystal_array_4_focus_ah
#define focus_xw mccchannel_19_analyzer_1_array_crystal_array_4_focus_xw
#define focus_xh mccchannel_19_analyzer_1_array_crystal_array_4_focus_xh
#define focus_r mccchannel_19_analyzer_1_array_crystal_array_4_focus_r
#define p_interact mccchannel_19_analyzer_1_array_crystal_array_4_p_interact
#define mask_string mccchannel_19_analyzer_1_array_crystal_array_4_mask_string
#define mask_setting mccchannel_19_analyzer_1_array_crystal_array_4_mask_setting
#define number_of_activations mccchannel_19_analyzer_1_array_crystal_array_4_number_of_activations
#line 204 "Union_box.comp"
// Needed for transport to the main component
struct global_geometry_element_struct global_geometry_element;

#ifndef ANY_GEOMETRY_DETECTOR_DECLARE
    #define ANY_GEOMETRY_DETECTOR_DECLARE dummy
	//struct pointer_to_global_geometry_list global_geometry_list = {0,NULL};
#endif

int loop_index,found_geometries;

double x_component;
double y_component;
double z_component;

struct Volume_struct this_box_volume;
struct box_storage this_box_storage;

#line 82881 "MACS_sample_kidney_box.c"
#undef number_of_activations
#undef mask_setting
#undef mask_string
#undef p_interact
#undef focus_r
#undef focus_xh
#undef focus_xw
#undef focus_ah
#undef focus_aw
#undef target_z
#undef target_y
#undef target_x
#undef target_index
#undef visualize
#undef yheight2
#undef xwidth2
#undef zdepth
#undef yheight
#undef xwidth
#undef priority
#undef material_string
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

/* User declarations for component 'channel_19_analyzer_1_array_crystal_array_5' [857]. */
#define mccompcurname  channel_19_analyzer_1_array_crystal_array_5
#define mccompcurtype  Union_box
#define mccompcurindex 857
#define loop_index mccchannel_19_analyzer_1_array_crystal_array_5_loop_index
#define this_box_volume mccchannel_19_analyzer_1_array_crystal_array_5_this_box_volume
#define global_geometry_element mccchannel_19_analyzer_1_array_crystal_array_5_global_geometry_element
#define this_box_storage mccchannel_19_analyzer_1_array_crystal_array_5_this_box_storage
#define material_string mccchannel_19_analyzer_1_array_crystal_array_5_material_string
#define priority mccchannel_19_analyzer_1_array_crystal_array_5_priority
#define xwidth mccchannel_19_analyzer_1_array_crystal_array_5_xwidth
#define yheight mccchannel_19_analyzer_1_array_crystal_array_5_yheight
#define zdepth mccchannel_19_analyzer_1_array_crystal_array_5_zdepth
#define xwidth2 mccchannel_19_analyzer_1_array_crystal_array_5_xwidth2
#define yheight2 mccchannel_19_analyzer_1_array_crystal_array_5_yheight2
#define visualize mccchannel_19_analyzer_1_array_crystal_array_5_visualize
#define target_index mccchannel_19_analyzer_1_array_crystal_array_5_target_index
#define target_x mccchannel_19_analyzer_1_array_crystal_array_5_target_x
#define target_y mccchannel_19_analyzer_1_array_crystal_array_5_target_y
#define target_z mccchannel_19_analyzer_1_array_crystal_array_5_target_z
#define focus_aw mccchannel_19_analyzer_1_array_crystal_array_5_focus_aw
#define focus_ah mccchannel_19_analyzer_1_array_crystal_array_5_focus_ah
#define focus_xw mccchannel_19_analyzer_1_array_crystal_array_5_focus_xw
#define focus_xh mccchannel_19_analyzer_1_array_crystal_array_5_focus_xh
#define focus_r mccchannel_19_analyzer_1_array_crystal_array_5_focus_r
#define p_interact mccchannel_19_analyzer_1_array_crystal_array_5_p_interact
#define mask_string mccchannel_19_analyzer_1_array_crystal_array_5_mask_string
#define mask_setting mccchannel_19_analyzer_1_array_crystal_array_5_mask_setting
#define number_of_activations mccchannel_19_analyzer_1_array_crystal_array_5_number_of_activations
#line 204 "Union_box.comp"
// Needed for transport to the main component
struct global_geometry_element_struct global_geometry_element;

#ifndef ANY_GEOMETRY_DETECTOR_DECLARE
    #define ANY_GEOMETRY_DETECTOR_DECLARE dummy
	//struct pointer_to_global_geometry_list global_geometry_list = {0,NULL};
#endif

int loop_index,found_geometries;

double x_component;
double y_component;
double z_component;

struct Volume_struct this_box_volume;
struct box_storage this_box_storage;

#line 82958 "MACS_sample_kidney_box.c"
#undef number_of_activations
#undef mask_setting
#undef mask_string
#undef p_interact
#undef focus_r
#undef focus_xh
#undef focus_xw
#undef focus_ah
#undef focus_aw
#undef target_z
#undef target_y
#undef target_x
#undef target_index
#undef visualize
#undef yheight2
#undef xwidth2
#undef zdepth
#undef yheight
#undef xwidth
#undef priority
#undef material_string
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

/* User declarations for component 'channel_19_analyzer_1_array_crystal_array_6' [858]. */
#define mccompcurname  channel_19_analyzer_1_array_crystal_array_6
#define mccompcurtype  Union_box
#define mccompcurindex 858
#define loop_index mccchannel_19_analyzer_1_array_crystal_array_6_loop_index
#define this_box_volume mccchannel_19_analyzer_1_array_crystal_array_6_this_box_volume
#define global_geometry_element mccchannel_19_analyzer_1_array_crystal_array_6_global_geometry_element
#define this_box_storage mccchannel_19_analyzer_1_array_crystal_array_6_this_box_storage
#define material_string mccchannel_19_analyzer_1_array_crystal_array_6_material_string
#define priority mccchannel_19_analyzer_1_array_crystal_array_6_priority
#define xwidth mccchannel_19_analyzer_1_array_crystal_array_6_xwidth
#define yheight mccchannel_19_analyzer_1_array_crystal_array_6_yheight
#define zdepth mccchannel_19_analyzer_1_array_crystal_array_6_zdepth
#define xwidth2 mccchannel_19_analyzer_1_array_crystal_array_6_xwidth2
#define yheight2 mccchannel_19_analyzer_1_array_crystal_array_6_yheight2
#define visualize mccchannel_19_analyzer_1_array_crystal_array_6_visualize
#define target_index mccchannel_19_analyzer_1_array_crystal_array_6_target_index
#define target_x mccchannel_19_analyzer_1_array_crystal_array_6_target_x
#define target_y mccchannel_19_analyzer_1_array_crystal_array_6_target_y
#define target_z mccchannel_19_analyzer_1_array_crystal_array_6_target_z
#define focus_aw mccchannel_19_analyzer_1_array_crystal_array_6_focus_aw
#define focus_ah mccchannel_19_analyzer_1_array_crystal_array_6_focus_ah
#define focus_xw mccchannel_19_analyzer_1_array_crystal_array_6_focus_xw
#define focus_xh mccchannel_19_analyzer_1_array_crystal_array_6_focus_xh
#define focus_r mccchannel_19_analyzer_1_array_crystal_array_6_focus_r
#define p_interact mccchannel_19_analyzer_1_array_crystal_array_6_p_interact
#define mask_string mccchannel_19_analyzer_1_array_crystal_array_6_mask_string
#define mask_setting mccchannel_19_analyzer_1_array_crystal_array_6_mask_setting
#define number_of_activations mccchannel_19_analyzer_1_array_crystal_array_6_number_of_activations
#line 204 "Union_box.comp"
// Needed for transport to the main component
struct global_geometry_element_struct global_geometry_element;

#ifndef ANY_GEOMETRY_DETECTOR_DECLARE
    #define ANY_GEOMETRY_DETECTOR_DECLARE dummy
	//struct pointer_to_global_geometry_list global_geometry_list = {0,NULL};
#endif

int loop_index,found_geometries;

double x_component;
double y_component;
double z_component;

struct Volume_struct this_box_volume;
struct box_storage this_box_storage;

#line 83035 "MACS_sample_kidney_box.c"
#undef number_of_activations
#undef mask_setting
#undef mask_string
#undef p_interact
#undef focus_r
#undef focus_xh
#undef focus_xw
#undef focus_ah
#undef focus_aw
#undef target_z
#undef target_y
#undef target_x
#undef target_index
#undef visualize
#undef yheight2
#undef xwidth2
#undef zdepth
#undef yheight
#undef xwidth
#undef priority
#undef material_string
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

/* User declarations for component 'channel_19_analyzer_1_array_crystal_array_7' [859]. */
#define mccompcurname  channel_19_analyzer_1_array_crystal_array_7
#define mccompcurtype  Union_box
#define mccompcurindex 859
#define loop_index mccchannel_19_analyzer_1_array_crystal_array_7_loop_index
#define this_box_volume mccchannel_19_analyzer_1_array_crystal_array_7_this_box_volume
#define global_geometry_element mccchannel_19_analyzer_1_array_crystal_array_7_global_geometry_element
#define this_box_storage mccchannel_19_analyzer_1_array_crystal_array_7_this_box_storage
#define material_string mccchannel_19_analyzer_1_array_crystal_array_7_material_string
#define priority mccchannel_19_analyzer_1_array_crystal_array_7_priority
#define xwidth mccchannel_19_analyzer_1_array_crystal_array_7_xwidth
#define yheight mccchannel_19_analyzer_1_array_crystal_array_7_yheight
#define zdepth mccchannel_19_analyzer_1_array_crystal_array_7_zdepth
#define xwidth2 mccchannel_19_analyzer_1_array_crystal_array_7_xwidth2
#define yheight2 mccchannel_19_analyzer_1_array_crystal_array_7_yheight2
#define visualize mccchannel_19_analyzer_1_array_crystal_array_7_visualize
#define target_index mccchannel_19_analyzer_1_array_crystal_array_7_target_index
#define target_x mccchannel_19_analyzer_1_array_crystal_array_7_target_x
#define target_y mccchannel_19_analyzer_1_array_crystal_array_7_target_y
#define target_z mccchannel_19_analyzer_1_array_crystal_array_7_target_z
#define focus_aw mccchannel_19_analyzer_1_array_crystal_array_7_focus_aw
#define focus_ah mccchannel_19_analyzer_1_array_crystal_array_7_focus_ah
#define focus_xw mccchannel_19_analyzer_1_array_crystal_array_7_focus_xw
#define focus_xh mccchannel_19_analyzer_1_array_crystal_array_7_focus_xh
#define focus_r mccchannel_19_analyzer_1_array_crystal_array_7_focus_r
#define p_interact mccchannel_19_analyzer_1_array_crystal_array_7_p_interact
#define mask_string mccchannel_19_analyzer_1_array_crystal_array_7_mask_string
#define mask_setting mccchannel_19_analyzer_1_array_crystal_array_7_mask_setting
#define number_of_activations mccchannel_19_analyzer_1_array_crystal_array_7_number_of_activations
#line 204 "Union_box.comp"
// Needed for transport to the main component
struct global_geometry_element_struct global_geometry_element;

#ifndef ANY_GEOMETRY_DETECTOR_DECLARE
    #define ANY_GEOMETRY_DETECTOR_DECLARE dummy
	//struct pointer_to_global_geometry_list global_geometry_list = {0,NULL};
#endif

int loop_index,found_geometries;

double x_component;
double y_component;
double z_component;

struct Volume_struct this_box_volume;
struct box_storage this_box_storage;

#line 83112 "MACS_sample_kidney_box.c"
#undef number_of_activations
#undef mask_setting
#undef mask_string
#undef p_interact
#undef focus_r
#undef focus_xh
#undef focus_xw
#undef focus_ah
#undef focus_aw
#undef target_z
#undef target_y
#undef target_x
#undef target_index
#undef visualize
#undef yheight2
#undef xwidth2
#undef zdepth
#undef yheight
#undef xwidth
#undef priority
#undef material_string
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

/* User declarations for component 'channel_19_analyzer_1_array_crystal_array_8' [860]. */
#define mccompcurname  channel_19_analyzer_1_array_crystal_array_8
#define mccompcurtype  Union_box
#define mccompcurindex 860
#define loop_index mccchannel_19_analyzer_1_array_crystal_array_8_loop_index
#define this_box_volume mccchannel_19_analyzer_1_array_crystal_array_8_this_box_volume
#define global_geometry_element mccchannel_19_analyzer_1_array_crystal_array_8_global_geometry_element
#define this_box_storage mccchannel_19_analyzer_1_array_crystal_array_8_this_box_storage
#define material_string mccchannel_19_analyzer_1_array_crystal_array_8_material_string
#define priority mccchannel_19_analyzer_1_array_crystal_array_8_priority
#define xwidth mccchannel_19_analyzer_1_array_crystal_array_8_xwidth
#define yheight mccchannel_19_analyzer_1_array_crystal_array_8_yheight
#define zdepth mccchannel_19_analyzer_1_array_crystal_array_8_zdepth
#define xwidth2 mccchannel_19_analyzer_1_array_crystal_array_8_xwidth2
#define yheight2 mccchannel_19_analyzer_1_array_crystal_array_8_yheight2
#define visualize mccchannel_19_analyzer_1_array_crystal_array_8_visualize
#define target_index mccchannel_19_analyzer_1_array_crystal_array_8_target_index
#define target_x mccchannel_19_analyzer_1_array_crystal_array_8_target_x
#define target_y mccchannel_19_analyzer_1_array_crystal_array_8_target_y
#define target_z mccchannel_19_analyzer_1_array_crystal_array_8_target_z
#define focus_aw mccchannel_19_analyzer_1_array_crystal_array_8_focus_aw
#define focus_ah mccchannel_19_analyzer_1_array_crystal_array_8_focus_ah
#define focus_xw mccchannel_19_analyzer_1_array_crystal_array_8_focus_xw
#define focus_xh mccchannel_19_analyzer_1_array_crystal_array_8_focus_xh
#define focus_r mccchannel_19_analyzer_1_array_crystal_array_8_focus_r
#define p_interact mccchannel_19_analyzer_1_array_crystal_array_8_p_interact
#define mask_string mccchannel_19_analyzer_1_array_crystal_array_8_mask_string
#define mask_setting mccchannel_19_analyzer_1_array_crystal_array_8_mask_setting
#define number_of_activations mccchannel_19_analyzer_1_array_crystal_array_8_number_of_activations
#line 204 "Union_box.comp"
// Needed for transport to the main component
struct global_geometry_element_struct global_geometry_element;

#ifndef ANY_GEOMETRY_DETECTOR_DECLARE
    #define ANY_GEOMETRY_DETECTOR_DECLARE dummy
	//struct pointer_to_global_geometry_list global_geometry_list = {0,NULL};
#endif

int loop_index,found_geometries;

double x_component;
double y_component;
double z_component;

struct Volume_struct this_box_volume;
struct box_storage this_box_storage;

#line 83189 "MACS_sample_kidney_box.c"
#undef number_of_activations
#undef mask_setting
#undef mask_string
#undef p_interact
#undef focus_r
#undef focus_xh
#undef focus_xw
#undef focus_ah
#undef focus_aw
#undef target_z
#undef target_y
#undef target_x
#undef target_index
#undef visualize
#undef yheight2
#undef xwidth2
#undef zdepth
#undef yheight
#undef xwidth
#undef priority
#undef material_string
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

/* User declarations for component 'channel_19_analyzer_2_center' [861]. */
#define mccompcurname  channel_19_analyzer_2_center
#define mccompcurtype  Arm
#define mccompcurindex 861
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

/* User declarations for component 'channel_19_analyzer_2_rotated' [862]. */
#define mccompcurname  channel_19_analyzer_2_rotated
#define mccompcurtype  Arm
#define mccompcurindex 862
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

/* User declarations for component 'channel_19_analyzer_2_array_crystal_array_0' [863]. */
#define mccompcurname  channel_19_analyzer_2_array_crystal_array_0
#define mccompcurtype  Union_box
#define mccompcurindex 863
#define loop_index mccchannel_19_analyzer_2_array_crystal_array_0_loop_index
#define this_box_volume mccchannel_19_analyzer_2_array_crystal_array_0_this_box_volume
#define global_geometry_element mccchannel_19_analyzer_2_array_crystal_array_0_global_geometry_element
#define this_box_storage mccchannel_19_analyzer_2_array_crystal_array_0_this_box_storage
#define material_string mccchannel_19_analyzer_2_array_crystal_array_0_material_string
#define priority mccchannel_19_analyzer_2_array_crystal_array_0_priority
#define xwidth mccchannel_19_analyzer_2_array_crystal_array_0_xwidth
#define yheight mccchannel_19_analyzer_2_array_crystal_array_0_yheight
#define zdepth mccchannel_19_analyzer_2_array_crystal_array_0_zdepth
#define xwidth2 mccchannel_19_analyzer_2_array_crystal_array_0_xwidth2
#define yheight2 mccchannel_19_analyzer_2_array_crystal_array_0_yheight2
#define visualize mccchannel_19_analyzer_2_array_crystal_array_0_visualize
#define target_index mccchannel_19_analyzer_2_array_crystal_array_0_target_index
#define target_x mccchannel_19_analyzer_2_array_crystal_array_0_target_x
#define target_y mccchannel_19_analyzer_2_array_crystal_array_0_target_y
#define target_z mccchannel_19_analyzer_2_array_crystal_array_0_target_z
#define focus_aw mccchannel_19_analyzer_2_array_crystal_array_0_focus_aw
#define focus_ah mccchannel_19_analyzer_2_array_crystal_array_0_focus_ah
#define focus_xw mccchannel_19_analyzer_2_array_crystal_array_0_focus_xw
#define focus_xh mccchannel_19_analyzer_2_array_crystal_array_0_focus_xh
#define focus_r mccchannel_19_analyzer_2_array_crystal_array_0_focus_r
#define p_interact mccchannel_19_analyzer_2_array_crystal_array_0_p_interact
#define mask_string mccchannel_19_analyzer_2_array_crystal_array_0_mask_string
#define mask_setting mccchannel_19_analyzer_2_array_crystal_array_0_mask_setting
#define number_of_activations mccchannel_19_analyzer_2_array_crystal_array_0_number_of_activations
#line 204 "Union_box.comp"
// Needed for transport to the main component
struct global_geometry_element_struct global_geometry_element;

#ifndef ANY_GEOMETRY_DETECTOR_DECLARE
    #define ANY_GEOMETRY_DETECTOR_DECLARE dummy
	//struct pointer_to_global_geometry_list global_geometry_list = {0,NULL};
#endif

int loop_index,found_geometries;

double x_component;
double y_component;
double z_component;

struct Volume_struct this_box_volume;
struct box_storage this_box_storage;

#line 83282 "MACS_sample_kidney_box.c"
#undef number_of_activations
#undef mask_setting
#undef mask_string
#undef p_interact
#undef focus_r
#undef focus_xh
#undef focus_xw
#undef focus_ah
#undef focus_aw
#undef target_z
#undef target_y
#undef target_x
#undef target_index
#undef visualize
#undef yheight2
#undef xwidth2
#undef zdepth
#undef yheight
#undef xwidth
#undef priority
#undef material_string
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

/* User declarations for component 'channel_19_analyzer_2_array_crystal_array_1' [864]. */
#define mccompcurname  channel_19_analyzer_2_array_crystal_array_1
#define mccompcurtype  Union_box
#define mccompcurindex 864
#define loop_index mccchannel_19_analyzer_2_array_crystal_array_1_loop_index
#define this_box_volume mccchannel_19_analyzer_2_array_crystal_array_1_this_box_volume
#define global_geometry_element mccchannel_19_analyzer_2_array_crystal_array_1_global_geometry_element
#define this_box_storage mccchannel_19_analyzer_2_array_crystal_array_1_this_box_storage
#define material_string mccchannel_19_analyzer_2_array_crystal_array_1_material_string
#define priority mccchannel_19_analyzer_2_array_crystal_array_1_priority
#define xwidth mccchannel_19_analyzer_2_array_crystal_array_1_xwidth
#define yheight mccchannel_19_analyzer_2_array_crystal_array_1_yheight
#define zdepth mccchannel_19_analyzer_2_array_crystal_array_1_zdepth
#define xwidth2 mccchannel_19_analyzer_2_array_crystal_array_1_xwidth2
#define yheight2 mccchannel_19_analyzer_2_array_crystal_array_1_yheight2
#define visualize mccchannel_19_analyzer_2_array_crystal_array_1_visualize
#define target_index mccchannel_19_analyzer_2_array_crystal_array_1_target_index
#define target_x mccchannel_19_analyzer_2_array_crystal_array_1_target_x
#define target_y mccchannel_19_analyzer_2_array_crystal_array_1_target_y
#define target_z mccchannel_19_analyzer_2_array_crystal_array_1_target_z
#define focus_aw mccchannel_19_analyzer_2_array_crystal_array_1_focus_aw
#define focus_ah mccchannel_19_analyzer_2_array_crystal_array_1_focus_ah
#define focus_xw mccchannel_19_analyzer_2_array_crystal_array_1_focus_xw
#define focus_xh mccchannel_19_analyzer_2_array_crystal_array_1_focus_xh
#define focus_r mccchannel_19_analyzer_2_array_crystal_array_1_focus_r
#define p_interact mccchannel_19_analyzer_2_array_crystal_array_1_p_interact
#define mask_string mccchannel_19_analyzer_2_array_crystal_array_1_mask_string
#define mask_setting mccchannel_19_analyzer_2_array_crystal_array_1_mask_setting
#define number_of_activations mccchannel_19_analyzer_2_array_crystal_array_1_number_of_activations
#line 204 "Union_box.comp"
// Needed for transport to the main component
struct global_geometry_element_struct global_geometry_element;

#ifndef ANY_GEOMETRY_DETECTOR_DECLARE
    #define ANY_GEOMETRY_DETECTOR_DECLARE dummy
	//struct pointer_to_global_geometry_list global_geometry_list = {0,NULL};
#endif

int loop_index,found_geometries;

double x_component;
double y_component;
double z_component;

struct Volume_struct this_box_volume;
struct box_storage this_box_storage;

#line 83359 "MACS_sample_kidney_box.c"
#undef number_of_activations
#undef mask_setting
#undef mask_string
#undef p_interact
#undef focus_r
#undef focus_xh
#undef focus_xw
#undef focus_ah
#undef focus_aw
#undef target_z
#undef target_y
#undef target_x
#undef target_index
#undef visualize
#undef yheight2
#undef xwidth2
#undef zdepth
#undef yheight
#undef xwidth
#undef priority
#undef material_string
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

/* User declarations for component 'channel_19_analyzer_2_array_crystal_array_2' [865]. */
#define mccompcurname  channel_19_analyzer_2_array_crystal_array_2
#define mccompcurtype  Union_box
#define mccompcurindex 865
#define loop_index mccchannel_19_analyzer_2_array_crystal_array_2_loop_index
#define this_box_volume mccchannel_19_analyzer_2_array_crystal_array_2_this_box_volume
#define global_geometry_element mccchannel_19_analyzer_2_array_crystal_array_2_global_geometry_element
#define this_box_storage mccchannel_19_analyzer_2_array_crystal_array_2_this_box_storage
#define material_string mccchannel_19_analyzer_2_array_crystal_array_2_material_string
#define priority mccchannel_19_analyzer_2_array_crystal_array_2_priority
#define xwidth mccchannel_19_analyzer_2_array_crystal_array_2_xwidth
#define yheight mccchannel_19_analyzer_2_array_crystal_array_2_yheight
#define zdepth mccchannel_19_analyzer_2_array_crystal_array_2_zdepth
#define xwidth2 mccchannel_19_analyzer_2_array_crystal_array_2_xwidth2
#define yheight2 mccchannel_19_analyzer_2_array_crystal_array_2_yheight2
#define visualize mccchannel_19_analyzer_2_array_crystal_array_2_visualize
#define target_index mccchannel_19_analyzer_2_array_crystal_array_2_target_index
#define target_x mccchannel_19_analyzer_2_array_crystal_array_2_target_x
#define target_y mccchannel_19_analyzer_2_array_crystal_array_2_target_y
#define target_z mccchannel_19_analyzer_2_array_crystal_array_2_target_z
#define focus_aw mccchannel_19_analyzer_2_array_crystal_array_2_focus_aw
#define focus_ah mccchannel_19_analyzer_2_array_crystal_array_2_focus_ah
#define focus_xw mccchannel_19_analyzer_2_array_crystal_array_2_focus_xw
#define focus_xh mccchannel_19_analyzer_2_array_crystal_array_2_focus_xh
#define focus_r mccchannel_19_analyzer_2_array_crystal_array_2_focus_r
#define p_interact mccchannel_19_analyzer_2_array_crystal_array_2_p_interact
#define mask_string mccchannel_19_analyzer_2_array_crystal_array_2_mask_string
#define mask_setting mccchannel_19_analyzer_2_array_crystal_array_2_mask_setting
#define number_of_activations mccchannel_19_analyzer_2_array_crystal_array_2_number_of_activations
#line 204 "Union_box.comp"
// Needed for transport to the main component
struct global_geometry_element_struct global_geometry_element;

#ifndef ANY_GEOMETRY_DETECTOR_DECLARE
    #define ANY_GEOMETRY_DETECTOR_DECLARE dummy
	//struct pointer_to_global_geometry_list global_geometry_list = {0,NULL};
#endif

int loop_index,found_geometries;

double x_component;
double y_component;
double z_component;

struct Volume_struct this_box_volume;
struct box_storage this_box_storage;

#line 83436 "MACS_sample_kidney_box.c"
#undef number_of_activations
#undef mask_setting
#undef mask_string
#undef p_interact
#undef focus_r
#undef focus_xh
#undef focus_xw
#undef focus_ah
#undef focus_aw
#undef target_z
#undef target_y
#undef target_x
#undef target_index
#undef visualize
#undef yheight2
#undef xwidth2
#undef zdepth
#undef yheight
#undef xwidth
#undef priority
#undef material_string
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

/* User declarations for component 'channel_19_analyzer_2_array_crystal_array_3' [866]. */
#define mccompcurname  channel_19_analyzer_2_array_crystal_array_3
#define mccompcurtype  Union_box
#define mccompcurindex 866
#define loop_index mccchannel_19_analyzer_2_array_crystal_array_3_loop_index
#define this_box_volume mccchannel_19_analyzer_2_array_crystal_array_3_this_box_volume
#define global_geometry_element mccchannel_19_analyzer_2_array_crystal_array_3_global_geometry_element
#define this_box_storage mccchannel_19_analyzer_2_array_crystal_array_3_this_box_storage
#define material_string mccchannel_19_analyzer_2_array_crystal_array_3_material_string
#define priority mccchannel_19_analyzer_2_array_crystal_array_3_priority
#define xwidth mccchannel_19_analyzer_2_array_crystal_array_3_xwidth
#define yheight mccchannel_19_analyzer_2_array_crystal_array_3_yheight
#define zdepth mccchannel_19_analyzer_2_array_crystal_array_3_zdepth
#define xwidth2 mccchannel_19_analyzer_2_array_crystal_array_3_xwidth2
#define yheight2 mccchannel_19_analyzer_2_array_crystal_array_3_yheight2
#define visualize mccchannel_19_analyzer_2_array_crystal_array_3_visualize
#define target_index mccchannel_19_analyzer_2_array_crystal_array_3_target_index
#define target_x mccchannel_19_analyzer_2_array_crystal_array_3_target_x
#define target_y mccchannel_19_analyzer_2_array_crystal_array_3_target_y
#define target_z mccchannel_19_analyzer_2_array_crystal_array_3_target_z
#define focus_aw mccchannel_19_analyzer_2_array_crystal_array_3_focus_aw
#define focus_ah mccchannel_19_analyzer_2_array_crystal_array_3_focus_ah
#define focus_xw mccchannel_19_analyzer_2_array_crystal_array_3_focus_xw
#define focus_xh mccchannel_19_analyzer_2_array_crystal_array_3_focus_xh
#define focus_r mccchannel_19_analyzer_2_array_crystal_array_3_focus_r
#define p_interact mccchannel_19_analyzer_2_array_crystal_array_3_p_interact
#define mask_string mccchannel_19_analyzer_2_array_crystal_array_3_mask_string
#define mask_setting mccchannel_19_analyzer_2_array_crystal_array_3_mask_setting
#define number_of_activations mccchannel_19_analyzer_2_array_crystal_array_3_number_of_activations
#line 204 "Union_box.comp"
// Needed for transport to the main component
struct global_geometry_element_struct global_geometry_element;

#ifndef ANY_GEOMETRY_DETECTOR_DECLARE
    #define ANY_GEOMETRY_DETECTOR_DECLARE dummy
	//struct pointer_to_global_geometry_list global_geometry_list = {0,NULL};
#endif

int loop_index,found_geometries;

double x_component;
double y_component;
double z_component;

struct Volume_struct this_box_volume;
struct box_storage this_box_storage;

#line 83513 "MACS_sample_kidney_box.c"
#undef number_of_activations
#undef mask_setting
#undef mask_string
#undef p_interact
#undef focus_r
#undef focus_xh
#undef focus_xw
#undef focus_ah
#undef focus_aw
#undef target_z
#undef target_y
#undef target_x
#undef target_index
#undef visualize
#undef yheight2
#undef xwidth2
#undef zdepth
#undef yheight
#undef xwidth
#undef priority
#undef material_string
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

/* User declarations for component 'channel_19_analyzer_2_array_crystal_array_4' [867]. */
#define mccompcurname  channel_19_analyzer_2_array_crystal_array_4
#define mccompcurtype  Union_box
#define mccompcurindex 867
#define loop_index mccchannel_19_analyzer_2_array_crystal_array_4_loop_index
#define this_box_volume mccchannel_19_analyzer_2_array_crystal_array_4_this_box_volume
#define global_geometry_element mccchannel_19_analyzer_2_array_crystal_array_4_global_geometry_element
#define this_box_storage mccchannel_19_analyzer_2_array_crystal_array_4_this_box_storage
#define material_string mccchannel_19_analyzer_2_array_crystal_array_4_material_string
#define priority mccchannel_19_analyzer_2_array_crystal_array_4_priority
#define xwidth mccchannel_19_analyzer_2_array_crystal_array_4_xwidth
#define yheight mccchannel_19_analyzer_2_array_crystal_array_4_yheight
#define zdepth mccchannel_19_analyzer_2_array_crystal_array_4_zdepth
#define xwidth2 mccchannel_19_analyzer_2_array_crystal_array_4_xwidth2
#define yheight2 mccchannel_19_analyzer_2_array_crystal_array_4_yheight2
#define visualize mccchannel_19_analyzer_2_array_crystal_array_4_visualize
#define target_index mccchannel_19_analyzer_2_array_crystal_array_4_target_index
#define target_x mccchannel_19_analyzer_2_array_crystal_array_4_target_x
#define target_y mccchannel_19_analyzer_2_array_crystal_array_4_target_y
#define target_z mccchannel_19_analyzer_2_array_crystal_array_4_target_z
#define focus_aw mccchannel_19_analyzer_2_array_crystal_array_4_focus_aw
#define focus_ah mccchannel_19_analyzer_2_array_crystal_array_4_focus_ah
#define focus_xw mccchannel_19_analyzer_2_array_crystal_array_4_focus_xw
#define focus_xh mccchannel_19_analyzer_2_array_crystal_array_4_focus_xh
#define focus_r mccchannel_19_analyzer_2_array_crystal_array_4_focus_r
#define p_interact mccchannel_19_analyzer_2_array_crystal_array_4_p_interact
#define mask_string mccchannel_19_analyzer_2_array_crystal_array_4_mask_string
#define mask_setting mccchannel_19_analyzer_2_array_crystal_array_4_mask_setting
#define number_of_activations mccchannel_19_analyzer_2_array_crystal_array_4_number_of_activations
#line 204 "Union_box.comp"
// Needed for transport to the main component
struct global_geometry_element_struct global_geometry_element;

#ifndef ANY_GEOMETRY_DETECTOR_DECLARE
    #define ANY_GEOMETRY_DETECTOR_DECLARE dummy
	//struct pointer_to_global_geometry_list global_geometry_list = {0,NULL};
#endif

int loop_index,found_geometries;

double x_component;
double y_component;
double z_component;

struct Volume_struct this_box_volume;
struct box_storage this_box_storage;

#line 83590 "MACS_sample_kidney_box.c"
#undef number_of_activations
#undef mask_setting
#undef mask_string
#undef p_interact
#undef focus_r
#undef focus_xh
#undef focus_xw
#undef focus_ah
#undef focus_aw
#undef target_z
#undef target_y
#undef target_x
#undef target_index
#undef visualize
#undef yheight2
#undef xwidth2
#undef zdepth
#undef yheight
#undef xwidth
#undef priority
#undef material_string
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

/* User declarations for component 'channel_19_analyzer_2_array_crystal_array_5' [868]. */
#define mccompcurname  channel_19_analyzer_2_array_crystal_array_5
#define mccompcurtype  Union_box
#define mccompcurindex 868
#define loop_index mccchannel_19_analyzer_2_array_crystal_array_5_loop_index
#define this_box_volume mccchannel_19_analyzer_2_array_crystal_array_5_this_box_volume
#define global_geometry_element mccchannel_19_analyzer_2_array_crystal_array_5_global_geometry_element
#define this_box_storage mccchannel_19_analyzer_2_array_crystal_array_5_this_box_storage
#define material_string mccchannel_19_analyzer_2_array_crystal_array_5_material_string
#define priority mccchannel_19_analyzer_2_array_crystal_array_5_priority
#define xwidth mccchannel_19_analyzer_2_array_crystal_array_5_xwidth
#define yheight mccchannel_19_analyzer_2_array_crystal_array_5_yheight
#define zdepth mccchannel_19_analyzer_2_array_crystal_array_5_zdepth
#define xwidth2 mccchannel_19_analyzer_2_array_crystal_array_5_xwidth2
#define yheight2 mccchannel_19_analyzer_2_array_crystal_array_5_yheight2
#define visualize mccchannel_19_analyzer_2_array_crystal_array_5_visualize
#define target_index mccchannel_19_analyzer_2_array_crystal_array_5_target_index
#define target_x mccchannel_19_analyzer_2_array_crystal_array_5_target_x
#define target_y mccchannel_19_analyzer_2_array_crystal_array_5_target_y
#define target_z mccchannel_19_analyzer_2_array_crystal_array_5_target_z
#define focus_aw mccchannel_19_analyzer_2_array_crystal_array_5_focus_aw
#define focus_ah mccchannel_19_analyzer_2_array_crystal_array_5_focus_ah
#define focus_xw mccchannel_19_analyzer_2_array_crystal_array_5_focus_xw
#define focus_xh mccchannel_19_analyzer_2_array_crystal_array_5_focus_xh
#define focus_r mccchannel_19_analyzer_2_array_crystal_array_5_focus_r
#define p_interact mccchannel_19_analyzer_2_array_crystal_array_5_p_interact
#define mask_string mccchannel_19_analyzer_2_array_crystal_array_5_mask_string
#define mask_setting mccchannel_19_analyzer_2_array_crystal_array_5_mask_setting
#define number_of_activations mccchannel_19_analyzer_2_array_crystal_array_5_number_of_activations
#line 204 "Union_box.comp"
// Needed for transport to the main component
struct global_geometry_element_struct global_geometry_element;

#ifndef ANY_GEOMETRY_DETECTOR_DECLARE
    #define ANY_GEOMETRY_DETECTOR_DECLARE dummy
	//struct pointer_to_global_geometry_list global_geometry_list = {0,NULL};
#endif

int loop_index,found_geometries;

double x_component;
double y_component;
double z_component;

struct Volume_struct this_box_volume;
struct box_storage this_box_storage;

#line 83667 "MACS_sample_kidney_box.c"
#undef number_of_activations
#undef mask_setting
#undef mask_string
#undef p_interact
#undef focus_r
#undef focus_xh
#undef focus_xw
#undef focus_ah
#undef focus_aw
#undef target_z
#undef target_y
#undef target_x
#undef target_index
#undef visualize
#undef yheight2
#undef xwidth2
#undef zdepth
#undef yheight
#undef xwidth
#undef priority
#undef material_string
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

/* User declarations for component 'channel_19_analyzer_2_array_crystal_array_6' [869]. */
#define mccompcurname  channel_19_analyzer_2_array_crystal_array_6
#define mccompcurtype  Union_box
#define mccompcurindex 869
#define loop_index mccchannel_19_analyzer_2_array_crystal_array_6_loop_index
#define this_box_volume mccchannel_19_analyzer_2_array_crystal_array_6_this_box_volume
#define global_geometry_element mccchannel_19_analyzer_2_array_crystal_array_6_global_geometry_element
#define this_box_storage mccchannel_19_analyzer_2_array_crystal_array_6_this_box_storage
#define material_string mccchannel_19_analyzer_2_array_crystal_array_6_material_string
#define priority mccchannel_19_analyzer_2_array_crystal_array_6_priority
#define xwidth mccchannel_19_analyzer_2_array_crystal_array_6_xwidth
#define yheight mccchannel_19_analyzer_2_array_crystal_array_6_yheight
#define zdepth mccchannel_19_analyzer_2_array_crystal_array_6_zdepth
#define xwidth2 mccchannel_19_analyzer_2_array_crystal_array_6_xwidth2
#define yheight2 mccchannel_19_analyzer_2_array_crystal_array_6_yheight2
#define visualize mccchannel_19_analyzer_2_array_crystal_array_6_visualize
#define target_index mccchannel_19_analyzer_2_array_crystal_array_6_target_index
#define target_x mccchannel_19_analyzer_2_array_crystal_array_6_target_x
#define target_y mccchannel_19_analyzer_2_array_crystal_array_6_target_y
#define target_z mccchannel_19_analyzer_2_array_crystal_array_6_target_z
#define focus_aw mccchannel_19_analyzer_2_array_crystal_array_6_focus_aw
#define focus_ah mccchannel_19_analyzer_2_array_crystal_array_6_focus_ah
#define focus_xw mccchannel_19_analyzer_2_array_crystal_array_6_focus_xw
#define focus_xh mccchannel_19_analyzer_2_array_crystal_array_6_focus_xh
#define focus_r mccchannel_19_analyzer_2_array_crystal_array_6_focus_r
#define p_interact mccchannel_19_analyzer_2_array_crystal_array_6_p_interact
#define mask_string mccchannel_19_analyzer_2_array_crystal_array_6_mask_string
#define mask_setting mccchannel_19_analyzer_2_array_crystal_array_6_mask_setting
#define number_of_activations mccchannel_19_analyzer_2_array_crystal_array_6_number_of_activations
#line 204 "Union_box.comp"
// Needed for transport to the main component
struct global_geometry_element_struct global_geometry_element;

#ifndef ANY_GEOMETRY_DETECTOR_DECLARE
    #define ANY_GEOMETRY_DETECTOR_DECLARE dummy
	//struct pointer_to_global_geometry_list global_geometry_list = {0,NULL};
#endif

int loop_index,found_geometries;

double x_component;
double y_component;
double z_component;

struct Volume_struct this_box_volume;
struct box_storage this_box_storage;

#line 83744 "MACS_sample_kidney_box.c"
#undef number_of_activations
#undef mask_setting
#undef mask_string
#undef p_interact
#undef focus_r
#undef focus_xh
#undef focus_xw
#undef focus_ah
#undef focus_aw
#undef target_z
#undef target_y
#undef target_x
#undef target_index
#undef visualize
#undef yheight2
#undef xwidth2
#undef zdepth
#undef yheight
#undef xwidth
#undef priority
#undef material_string
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

/* User declarations for component 'channel_19_analyzer_2_array_crystal_array_7' [870]. */
#define mccompcurname  channel_19_analyzer_2_array_crystal_array_7
#define mccompcurtype  Union_box
#define mccompcurindex 870
#define loop_index mccchannel_19_analyzer_2_array_crystal_array_7_loop_index
#define this_box_volume mccchannel_19_analyzer_2_array_crystal_array_7_this_box_volume
#define global_geometry_element mccchannel_19_analyzer_2_array_crystal_array_7_global_geometry_element
#define this_box_storage mccchannel_19_analyzer_2_array_crystal_array_7_this_box_storage
#define material_string mccchannel_19_analyzer_2_array_crystal_array_7_material_string
#define priority mccchannel_19_analyzer_2_array_crystal_array_7_priority
#define xwidth mccchannel_19_analyzer_2_array_crystal_array_7_xwidth
#define yheight mccchannel_19_analyzer_2_array_crystal_array_7_yheight
#define zdepth mccchannel_19_analyzer_2_array_crystal_array_7_zdepth
#define xwidth2 mccchannel_19_analyzer_2_array_crystal_array_7_xwidth2
#define yheight2 mccchannel_19_analyzer_2_array_crystal_array_7_yheight2
#define visualize mccchannel_19_analyzer_2_array_crystal_array_7_visualize
#define target_index mccchannel_19_analyzer_2_array_crystal_array_7_target_index
#define target_x mccchannel_19_analyzer_2_array_crystal_array_7_target_x
#define target_y mccchannel_19_analyzer_2_array_crystal_array_7_target_y
#define target_z mccchannel_19_analyzer_2_array_crystal_array_7_target_z
#define focus_aw mccchannel_19_analyzer_2_array_crystal_array_7_focus_aw
#define focus_ah mccchannel_19_analyzer_2_array_crystal_array_7_focus_ah
#define focus_xw mccchannel_19_analyzer_2_array_crystal_array_7_focus_xw
#define focus_xh mccchannel_19_analyzer_2_array_crystal_array_7_focus_xh
#define focus_r mccchannel_19_analyzer_2_array_crystal_array_7_focus_r
#define p_interact mccchannel_19_analyzer_2_array_crystal_array_7_p_interact
#define mask_string mccchannel_19_analyzer_2_array_crystal_array_7_mask_string
#define mask_setting mccchannel_19_analyzer_2_array_crystal_array_7_mask_setting
#define number_of_activations mccchannel_19_analyzer_2_array_crystal_array_7_number_of_activations
#line 204 "Union_box.comp"
// Needed for transport to the main component
struct global_geometry_element_struct global_geometry_element;

#ifndef ANY_GEOMETRY_DETECTOR_DECLARE
    #define ANY_GEOMETRY_DETECTOR_DECLARE dummy
	//struct pointer_to_global_geometry_list global_geometry_list = {0,NULL};
#endif

int loop_index,found_geometries;

double x_component;
double y_component;
double z_component;

struct Volume_struct this_box_volume;
struct box_storage this_box_storage;

#line 83821 "MACS_sample_kidney_box.c"
#undef number_of_activations
#undef mask_setting
#undef mask_string
#undef p_interact
#undef focus_r
#undef focus_xh
#undef focus_xw
#undef focus_ah
#undef focus_aw
#undef target_z
#undef target_y
#undef target_x
#undef target_index
#undef visualize
#undef yheight2
#undef xwidth2
#undef zdepth
#undef yheight
#undef xwidth
#undef priority
#undef material_string
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

/* User declarations for component 'channel_19_analyzer_2_array_crystal_array_8' [871]. */
#define mccompcurname  channel_19_analyzer_2_array_crystal_array_8
#define mccompcurtype  Union_box
#define mccompcurindex 871
#define loop_index mccchannel_19_analyzer_2_array_crystal_array_8_loop_index
#define this_box_volume mccchannel_19_analyzer_2_array_crystal_array_8_this_box_volume
#define global_geometry_element mccchannel_19_analyzer_2_array_crystal_array_8_global_geometry_element
#define this_box_storage mccchannel_19_analyzer_2_array_crystal_array_8_this_box_storage
#define material_string mccchannel_19_analyzer_2_array_crystal_array_8_material_string
#define priority mccchannel_19_analyzer_2_array_crystal_array_8_priority
#define xwidth mccchannel_19_analyzer_2_array_crystal_array_8_xwidth
#define yheight mccchannel_19_analyzer_2_array_crystal_array_8_yheight
#define zdepth mccchannel_19_analyzer_2_array_crystal_array_8_zdepth
#define xwidth2 mccchannel_19_analyzer_2_array_crystal_array_8_xwidth2
#define yheight2 mccchannel_19_analyzer_2_array_crystal_array_8_yheight2
#define visualize mccchannel_19_analyzer_2_array_crystal_array_8_visualize
#define target_index mccchannel_19_analyzer_2_array_crystal_array_8_target_index
#define target_x mccchannel_19_analyzer_2_array_crystal_array_8_target_x
#define target_y mccchannel_19_analyzer_2_array_crystal_array_8_target_y
#define target_z mccchannel_19_analyzer_2_array_crystal_array_8_target_z
#define focus_aw mccchannel_19_analyzer_2_array_crystal_array_8_focus_aw
#define focus_ah mccchannel_19_analyzer_2_array_crystal_array_8_focus_ah
#define focus_xw mccchannel_19_analyzer_2_array_crystal_array_8_focus_xw
#define focus_xh mccchannel_19_analyzer_2_array_crystal_array_8_focus_xh
#define focus_r mccchannel_19_analyzer_2_array_crystal_array_8_focus_r
#define p_interact mccchannel_19_analyzer_2_array_crystal_array_8_p_interact
#define mask_string mccchannel_19_analyzer_2_array_crystal_array_8_mask_string
#define mask_setting mccchannel_19_analyzer_2_array_crystal_array_8_mask_setting
#define number_of_activations mccchannel_19_analyzer_2_array_crystal_array_8_number_of_activations
#line 204 "Union_box.comp"
// Needed for transport to the main component
struct global_geometry_element_struct global_geometry_element;

#ifndef ANY_GEOMETRY_DETECTOR_DECLARE
    #define ANY_GEOMETRY_DETECTOR_DECLARE dummy
	//struct pointer_to_global_geometry_list global_geometry_list = {0,NULL};
#endif

int loop_index,found_geometries;

double x_component;
double y_component;
double z_component;

struct Volume_struct this_box_volume;
struct box_storage this_box_storage;

#line 83898 "MACS_sample_kidney_box.c"
#undef number_of_activations
#undef mask_setting
#undef mask_string
#undef p_interact
#undef focus_r
#undef focus_xh
#undef focus_xw
#undef focus_ah
#undef focus_aw
#undef target_z
#undef target_y
#undef target_x
#undef target_index
#undef visualize
#undef yheight2
#undef xwidth2
#undef zdepth
#undef yheight
#undef xwidth
#undef priority
#undef material_string
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

/* User declarations for component 'channel_19_cave2_cyl1' [872]. */
#define mccompcurname  channel_19_cave2_cyl1
#define mccompcurtype  Union_cylinder
#define mccompcurindex 872
#define loop_index mccchannel_19_cave2_cyl1_loop_index
#define this_cylinder_volume mccchannel_19_cave2_cyl1_this_cylinder_volume
#define global_geometry_element mccchannel_19_cave2_cyl1_global_geometry_element
#define this_cylinder_storage mccchannel_19_cave2_cyl1_this_cylinder_storage
#define material_string mccchannel_19_cave2_cyl1_material_string
#define priority mccchannel_19_cave2_cyl1_priority
#define radius mccchannel_19_cave2_cyl1_radius
#define yheight mccchannel_19_cave2_cyl1_yheight
#define visualize mccchannel_19_cave2_cyl1_visualize
#define target_index mccchannel_19_cave2_cyl1_target_index
#define target_x mccchannel_19_cave2_cyl1_target_x
#define target_y mccchannel_19_cave2_cyl1_target_y
#define target_z mccchannel_19_cave2_cyl1_target_z
#define focus_aw mccchannel_19_cave2_cyl1_focus_aw
#define focus_ah mccchannel_19_cave2_cyl1_focus_ah
#define focus_xw mccchannel_19_cave2_cyl1_focus_xw
#define focus_xh mccchannel_19_cave2_cyl1_focus_xh
#define focus_r mccchannel_19_cave2_cyl1_focus_r
#define p_interact mccchannel_19_cave2_cyl1_p_interact
#define mask_string mccchannel_19_cave2_cyl1_mask_string
#define mask_setting mccchannel_19_cave2_cyl1_mask_setting
#define number_of_activations mccchannel_19_cave2_cyl1_number_of_activations
#line 167 "Union_cylinder.comp"
// Needed for transport to the main component
struct global_geometry_element_struct global_geometry_element;

#ifndef ANY_GEOMETRY_DETECTOR_DECLARE
    #define ANY_GEOMETRY_DETECTOR_DECLARE dummy
	//struct pointer_to_global_geometry_list global_geometry_list = {0,NULL};
#endif

int dummy;
int loop_index,found_geometries;
int loop_2_index;
int material_index;

struct Volume_struct this_cylinder_volume;
struct cylinder_storage this_cylinder_storage;
#line 83970 "MACS_sample_kidney_box.c"
#undef number_of_activations
#undef mask_setting
#undef mask_string
#undef p_interact
#undef focus_r
#undef focus_xh
#undef focus_xw
#undef focus_ah
#undef focus_aw
#undef target_z
#undef target_y
#undef target_x
#undef target_index
#undef visualize
#undef yheight
#undef radius
#undef priority
#undef material_string
#undef this_cylinder_storage
#undef global_geometry_element
#undef this_cylinder_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

/* User declarations for component 'channel_19_cave2_box1' [873]. */
#define mccompcurname  channel_19_cave2_box1
#define mccompcurtype  Union_box
#define mccompcurindex 873
#define loop_index mccchannel_19_cave2_box1_loop_index
#define this_box_volume mccchannel_19_cave2_box1_this_box_volume
#define global_geometry_element mccchannel_19_cave2_box1_global_geometry_element
#define this_box_storage mccchannel_19_cave2_box1_this_box_storage
#define material_string mccchannel_19_cave2_box1_material_string
#define priority mccchannel_19_cave2_box1_priority
#define xwidth mccchannel_19_cave2_box1_xwidth
#define yheight mccchannel_19_cave2_box1_yheight
#define zdepth mccchannel_19_cave2_box1_zdepth
#define xwidth2 mccchannel_19_cave2_box1_xwidth2
#define yheight2 mccchannel_19_cave2_box1_yheight2
#define visualize mccchannel_19_cave2_box1_visualize
#define target_index mccchannel_19_cave2_box1_target_index
#define target_x mccchannel_19_cave2_box1_target_x
#define target_y mccchannel_19_cave2_box1_target_y
#define target_z mccchannel_19_cave2_box1_target_z
#define focus_aw mccchannel_19_cave2_box1_focus_aw
#define focus_ah mccchannel_19_cave2_box1_focus_ah
#define focus_xw mccchannel_19_cave2_box1_focus_xw
#define focus_xh mccchannel_19_cave2_box1_focus_xh
#define focus_r mccchannel_19_cave2_box1_focus_r
#define p_interact mccchannel_19_cave2_box1_p_interact
#define mask_string mccchannel_19_cave2_box1_mask_string
#define mask_setting mccchannel_19_cave2_box1_mask_setting
#define number_of_activations mccchannel_19_cave2_box1_number_of_activations
#line 204 "Union_box.comp"
// Needed for transport to the main component
struct global_geometry_element_struct global_geometry_element;

#ifndef ANY_GEOMETRY_DETECTOR_DECLARE
    #define ANY_GEOMETRY_DETECTOR_DECLARE dummy
	//struct pointer_to_global_geometry_list global_geometry_list = {0,NULL};
#endif

int loop_index,found_geometries;

double x_component;
double y_component;
double z_component;

struct Volume_struct this_box_volume;
struct box_storage this_box_storage;

#line 84044 "MACS_sample_kidney_box.c"
#undef number_of_activations
#undef mask_setting
#undef mask_string
#undef p_interact
#undef focus_r
#undef focus_xh
#undef focus_xw
#undef focus_ah
#undef focus_aw
#undef target_z
#undef target_y
#undef target_x
#undef target_index
#undef visualize
#undef yheight2
#undef xwidth2
#undef zdepth
#undef yheight
#undef xwidth
#undef priority
#undef material_string
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

/* User declarations for component 'channel_19_cave2_box2' [874]. */
#define mccompcurname  channel_19_cave2_box2
#define mccompcurtype  Union_box
#define mccompcurindex 874
#define loop_index mccchannel_19_cave2_box2_loop_index
#define this_box_volume mccchannel_19_cave2_box2_this_box_volume
#define global_geometry_element mccchannel_19_cave2_box2_global_geometry_element
#define this_box_storage mccchannel_19_cave2_box2_this_box_storage
#define material_string mccchannel_19_cave2_box2_material_string
#define priority mccchannel_19_cave2_box2_priority
#define xwidth mccchannel_19_cave2_box2_xwidth
#define yheight mccchannel_19_cave2_box2_yheight
#define zdepth mccchannel_19_cave2_box2_zdepth
#define xwidth2 mccchannel_19_cave2_box2_xwidth2
#define yheight2 mccchannel_19_cave2_box2_yheight2
#define visualize mccchannel_19_cave2_box2_visualize
#define target_index mccchannel_19_cave2_box2_target_index
#define target_x mccchannel_19_cave2_box2_target_x
#define target_y mccchannel_19_cave2_box2_target_y
#define target_z mccchannel_19_cave2_box2_target_z
#define focus_aw mccchannel_19_cave2_box2_focus_aw
#define focus_ah mccchannel_19_cave2_box2_focus_ah
#define focus_xw mccchannel_19_cave2_box2_focus_xw
#define focus_xh mccchannel_19_cave2_box2_focus_xh
#define focus_r mccchannel_19_cave2_box2_focus_r
#define p_interact mccchannel_19_cave2_box2_p_interact
#define mask_string mccchannel_19_cave2_box2_mask_string
#define mask_setting mccchannel_19_cave2_box2_mask_setting
#define number_of_activations mccchannel_19_cave2_box2_number_of_activations
#line 204 "Union_box.comp"
// Needed for transport to the main component
struct global_geometry_element_struct global_geometry_element;

#ifndef ANY_GEOMETRY_DETECTOR_DECLARE
    #define ANY_GEOMETRY_DETECTOR_DECLARE dummy
	//struct pointer_to_global_geometry_list global_geometry_list = {0,NULL};
#endif

int loop_index,found_geometries;

double x_component;
double y_component;
double z_component;

struct Volume_struct this_box_volume;
struct box_storage this_box_storage;

#line 84121 "MACS_sample_kidney_box.c"
#undef number_of_activations
#undef mask_setting
#undef mask_string
#undef p_interact
#undef focus_r
#undef focus_xh
#undef focus_xw
#undef focus_ah
#undef focus_aw
#undef target_z
#undef target_y
#undef target_x
#undef target_index
#undef visualize
#undef yheight2
#undef xwidth2
#undef zdepth
#undef yheight
#undef xwidth
#undef priority
#undef material_string
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

/* User declarations for component 'channel_19_cave2_box3' [875]. */
#define mccompcurname  channel_19_cave2_box3
#define mccompcurtype  Union_box
#define mccompcurindex 875
#define loop_index mccchannel_19_cave2_box3_loop_index
#define this_box_volume mccchannel_19_cave2_box3_this_box_volume
#define global_geometry_element mccchannel_19_cave2_box3_global_geometry_element
#define this_box_storage mccchannel_19_cave2_box3_this_box_storage
#define material_string mccchannel_19_cave2_box3_material_string
#define priority mccchannel_19_cave2_box3_priority
#define xwidth mccchannel_19_cave2_box3_xwidth
#define yheight mccchannel_19_cave2_box3_yheight
#define zdepth mccchannel_19_cave2_box3_zdepth
#define xwidth2 mccchannel_19_cave2_box3_xwidth2
#define yheight2 mccchannel_19_cave2_box3_yheight2
#define visualize mccchannel_19_cave2_box3_visualize
#define target_index mccchannel_19_cave2_box3_target_index
#define target_x mccchannel_19_cave2_box3_target_x
#define target_y mccchannel_19_cave2_box3_target_y
#define target_z mccchannel_19_cave2_box3_target_z
#define focus_aw mccchannel_19_cave2_box3_focus_aw
#define focus_ah mccchannel_19_cave2_box3_focus_ah
#define focus_xw mccchannel_19_cave2_box3_focus_xw
#define focus_xh mccchannel_19_cave2_box3_focus_xh
#define focus_r mccchannel_19_cave2_box3_focus_r
#define p_interact mccchannel_19_cave2_box3_p_interact
#define mask_string mccchannel_19_cave2_box3_mask_string
#define mask_setting mccchannel_19_cave2_box3_mask_setting
#define number_of_activations mccchannel_19_cave2_box3_number_of_activations
#line 204 "Union_box.comp"
// Needed for transport to the main component
struct global_geometry_element_struct global_geometry_element;

#ifndef ANY_GEOMETRY_DETECTOR_DECLARE
    #define ANY_GEOMETRY_DETECTOR_DECLARE dummy
	//struct pointer_to_global_geometry_list global_geometry_list = {0,NULL};
#endif

int loop_index,found_geometries;

double x_component;
double y_component;
double z_component;

struct Volume_struct this_box_volume;
struct box_storage this_box_storage;

#line 84198 "MACS_sample_kidney_box.c"
#undef number_of_activations
#undef mask_setting
#undef mask_string
#undef p_interact
#undef focus_r
#undef focus_xh
#undef focus_xw
#undef focus_ah
#undef focus_aw
#undef target_z
#undef target_y
#undef target_x
#undef target_index
#undef visualize
#undef yheight2
#undef xwidth2
#undef zdepth
#undef yheight
#undef xwidth
#undef priority
#undef material_string
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

/* User declarations for component 'inter_analyzer_colimator_center_19' [876]. */
#define mccompcurname  inter_analyzer_colimator_center_19
#define mccompcurtype  Arm
#define mccompcurindex 876
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

/* User declarations for component 'inter_analyzer_colimator_19_blade_0' [877]. */
#define mccompcurname  inter_analyzer_colimator_19_blade_0
#define mccompcurtype  Union_box
#define mccompcurindex 877
#define loop_index mccinter_analyzer_colimator_19_blade_0_loop_index
#define this_box_volume mccinter_analyzer_colimator_19_blade_0_this_box_volume
#define global_geometry_element mccinter_analyzer_colimator_19_blade_0_global_geometry_element
#define this_box_storage mccinter_analyzer_colimator_19_blade_0_this_box_storage
#define material_string mccinter_analyzer_colimator_19_blade_0_material_string
#define priority mccinter_analyzer_colimator_19_blade_0_priority
#define xwidth mccinter_analyzer_colimator_19_blade_0_xwidth
#define yheight mccinter_analyzer_colimator_19_blade_0_yheight
#define zdepth mccinter_analyzer_colimator_19_blade_0_zdepth
#define xwidth2 mccinter_analyzer_colimator_19_blade_0_xwidth2
#define yheight2 mccinter_analyzer_colimator_19_blade_0_yheight2
#define visualize mccinter_analyzer_colimator_19_blade_0_visualize
#define target_index mccinter_analyzer_colimator_19_blade_0_target_index
#define target_x mccinter_analyzer_colimator_19_blade_0_target_x
#define target_y mccinter_analyzer_colimator_19_blade_0_target_y
#define target_z mccinter_analyzer_colimator_19_blade_0_target_z
#define focus_aw mccinter_analyzer_colimator_19_blade_0_focus_aw
#define focus_ah mccinter_analyzer_colimator_19_blade_0_focus_ah
#define focus_xw mccinter_analyzer_colimator_19_blade_0_focus_xw
#define focus_xh mccinter_analyzer_colimator_19_blade_0_focus_xh
#define focus_r mccinter_analyzer_colimator_19_blade_0_focus_r
#define p_interact mccinter_analyzer_colimator_19_blade_0_p_interact
#define mask_string mccinter_analyzer_colimator_19_blade_0_mask_string
#define mask_setting mccinter_analyzer_colimator_19_blade_0_mask_setting
#define number_of_activations mccinter_analyzer_colimator_19_blade_0_number_of_activations
#line 204 "Union_box.comp"
// Needed for transport to the main component
struct global_geometry_element_struct global_geometry_element;

#ifndef ANY_GEOMETRY_DETECTOR_DECLARE
    #define ANY_GEOMETRY_DETECTOR_DECLARE dummy
	//struct pointer_to_global_geometry_list global_geometry_list = {0,NULL};
#endif

int loop_index,found_geometries;

double x_component;
double y_component;
double z_component;

struct Volume_struct this_box_volume;
struct box_storage this_box_storage;

#line 84283 "MACS_sample_kidney_box.c"
#undef number_of_activations
#undef mask_setting
#undef mask_string
#undef p_interact
#undef focus_r
#undef focus_xh
#undef focus_xw
#undef focus_ah
#undef focus_aw
#undef target_z
#undef target_y
#undef target_x
#undef target_index
#undef visualize
#undef yheight2
#undef xwidth2
#undef zdepth
#undef yheight
#undef xwidth
#undef priority
#undef material_string
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

/* User declarations for component 'inter_analyzer_colimator_19_blade_1' [878]. */
#define mccompcurname  inter_analyzer_colimator_19_blade_1
#define mccompcurtype  Union_box
#define mccompcurindex 878
#define loop_index mccinter_analyzer_colimator_19_blade_1_loop_index
#define this_box_volume mccinter_analyzer_colimator_19_blade_1_this_box_volume
#define global_geometry_element mccinter_analyzer_colimator_19_blade_1_global_geometry_element
#define this_box_storage mccinter_analyzer_colimator_19_blade_1_this_box_storage
#define material_string mccinter_analyzer_colimator_19_blade_1_material_string
#define priority mccinter_analyzer_colimator_19_blade_1_priority
#define xwidth mccinter_analyzer_colimator_19_blade_1_xwidth
#define yheight mccinter_analyzer_colimator_19_blade_1_yheight
#define zdepth mccinter_analyzer_colimator_19_blade_1_zdepth
#define xwidth2 mccinter_analyzer_colimator_19_blade_1_xwidth2
#define yheight2 mccinter_analyzer_colimator_19_blade_1_yheight2
#define visualize mccinter_analyzer_colimator_19_blade_1_visualize
#define target_index mccinter_analyzer_colimator_19_blade_1_target_index
#define target_x mccinter_analyzer_colimator_19_blade_1_target_x
#define target_y mccinter_analyzer_colimator_19_blade_1_target_y
#define target_z mccinter_analyzer_colimator_19_blade_1_target_z
#define focus_aw mccinter_analyzer_colimator_19_blade_1_focus_aw
#define focus_ah mccinter_analyzer_colimator_19_blade_1_focus_ah
#define focus_xw mccinter_analyzer_colimator_19_blade_1_focus_xw
#define focus_xh mccinter_analyzer_colimator_19_blade_1_focus_xh
#define focus_r mccinter_analyzer_colimator_19_blade_1_focus_r
#define p_interact mccinter_analyzer_colimator_19_blade_1_p_interact
#define mask_string mccinter_analyzer_colimator_19_blade_1_mask_string
#define mask_setting mccinter_analyzer_colimator_19_blade_1_mask_setting
#define number_of_activations mccinter_analyzer_colimator_19_blade_1_number_of_activations
#line 204 "Union_box.comp"
// Needed for transport to the main component
struct global_geometry_element_struct global_geometry_element;

#ifndef ANY_GEOMETRY_DETECTOR_DECLARE
    #define ANY_GEOMETRY_DETECTOR_DECLARE dummy
	//struct pointer_to_global_geometry_list global_geometry_list = {0,NULL};
#endif

int loop_index,found_geometries;

double x_component;
double y_component;
double z_component;

struct Volume_struct this_box_volume;
struct box_storage this_box_storage;

#line 84360 "MACS_sample_kidney_box.c"
#undef number_of_activations
#undef mask_setting
#undef mask_string
#undef p_interact
#undef focus_r
#undef focus_xh
#undef focus_xw
#undef focus_ah
#undef focus_aw
#undef target_z
#undef target_y
#undef target_x
#undef target_index
#undef visualize
#undef yheight2
#undef xwidth2
#undef zdepth
#undef yheight
#undef xwidth
#undef priority
#undef material_string
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

/* User declarations for component 'inter_analyzer_colimator_19_blade_2' [879]. */
#define mccompcurname  inter_analyzer_colimator_19_blade_2
#define mccompcurtype  Union_box
#define mccompcurindex 879
#define loop_index mccinter_analyzer_colimator_19_blade_2_loop_index
#define this_box_volume mccinter_analyzer_colimator_19_blade_2_this_box_volume
#define global_geometry_element mccinter_analyzer_colimator_19_blade_2_global_geometry_element
#define this_box_storage mccinter_analyzer_colimator_19_blade_2_this_box_storage
#define material_string mccinter_analyzer_colimator_19_blade_2_material_string
#define priority mccinter_analyzer_colimator_19_blade_2_priority
#define xwidth mccinter_analyzer_colimator_19_blade_2_xwidth
#define yheight mccinter_analyzer_colimator_19_blade_2_yheight
#define zdepth mccinter_analyzer_colimator_19_blade_2_zdepth
#define xwidth2 mccinter_analyzer_colimator_19_blade_2_xwidth2
#define yheight2 mccinter_analyzer_colimator_19_blade_2_yheight2
#define visualize mccinter_analyzer_colimator_19_blade_2_visualize
#define target_index mccinter_analyzer_colimator_19_blade_2_target_index
#define target_x mccinter_analyzer_colimator_19_blade_2_target_x
#define target_y mccinter_analyzer_colimator_19_blade_2_target_y
#define target_z mccinter_analyzer_colimator_19_blade_2_target_z
#define focus_aw mccinter_analyzer_colimator_19_blade_2_focus_aw
#define focus_ah mccinter_analyzer_colimator_19_blade_2_focus_ah
#define focus_xw mccinter_analyzer_colimator_19_blade_2_focus_xw
#define focus_xh mccinter_analyzer_colimator_19_blade_2_focus_xh
#define focus_r mccinter_analyzer_colimator_19_blade_2_focus_r
#define p_interact mccinter_analyzer_colimator_19_blade_2_p_interact
#define mask_string mccinter_analyzer_colimator_19_blade_2_mask_string
#define mask_setting mccinter_analyzer_colimator_19_blade_2_mask_setting
#define number_of_activations mccinter_analyzer_colimator_19_blade_2_number_of_activations
#line 204 "Union_box.comp"
// Needed for transport to the main component
struct global_geometry_element_struct global_geometry_element;

#ifndef ANY_GEOMETRY_DETECTOR_DECLARE
    #define ANY_GEOMETRY_DETECTOR_DECLARE dummy
	//struct pointer_to_global_geometry_list global_geometry_list = {0,NULL};
#endif

int loop_index,found_geometries;

double x_component;
double y_component;
double z_component;

struct Volume_struct this_box_volume;
struct box_storage this_box_storage;

#line 84437 "MACS_sample_kidney_box.c"
#undef number_of_activations
#undef mask_setting
#undef mask_string
#undef p_interact
#undef focus_r
#undef focus_xh
#undef focus_xw
#undef focus_ah
#undef focus_aw
#undef target_z
#undef target_y
#undef target_x
#undef target_index
#undef visualize
#undef yheight2
#undef xwidth2
#undef zdepth
#undef yheight
#undef xwidth
#undef priority
#undef material_string
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

/* User declarations for component 'inter_analyzer_colimator_19_blade_3' [880]. */
#define mccompcurname  inter_analyzer_colimator_19_blade_3
#define mccompcurtype  Union_box
#define mccompcurindex 880
#define loop_index mccinter_analyzer_colimator_19_blade_3_loop_index
#define this_box_volume mccinter_analyzer_colimator_19_blade_3_this_box_volume
#define global_geometry_element mccinter_analyzer_colimator_19_blade_3_global_geometry_element
#define this_box_storage mccinter_analyzer_colimator_19_blade_3_this_box_storage
#define material_string mccinter_analyzer_colimator_19_blade_3_material_string
#define priority mccinter_analyzer_colimator_19_blade_3_priority
#define xwidth mccinter_analyzer_colimator_19_blade_3_xwidth
#define yheight mccinter_analyzer_colimator_19_blade_3_yheight
#define zdepth mccinter_analyzer_colimator_19_blade_3_zdepth
#define xwidth2 mccinter_analyzer_colimator_19_blade_3_xwidth2
#define yheight2 mccinter_analyzer_colimator_19_blade_3_yheight2
#define visualize mccinter_analyzer_colimator_19_blade_3_visualize
#define target_index mccinter_analyzer_colimator_19_blade_3_target_index
#define target_x mccinter_analyzer_colimator_19_blade_3_target_x
#define target_y mccinter_analyzer_colimator_19_blade_3_target_y
#define target_z mccinter_analyzer_colimator_19_blade_3_target_z
#define focus_aw mccinter_analyzer_colimator_19_blade_3_focus_aw
#define focus_ah mccinter_analyzer_colimator_19_blade_3_focus_ah
#define focus_xw mccinter_analyzer_colimator_19_blade_3_focus_xw
#define focus_xh mccinter_analyzer_colimator_19_blade_3_focus_xh
#define focus_r mccinter_analyzer_colimator_19_blade_3_focus_r
#define p_interact mccinter_analyzer_colimator_19_blade_3_p_interact
#define mask_string mccinter_analyzer_colimator_19_blade_3_mask_string
#define mask_setting mccinter_analyzer_colimator_19_blade_3_mask_setting
#define number_of_activations mccinter_analyzer_colimator_19_blade_3_number_of_activations
#line 204 "Union_box.comp"
// Needed for transport to the main component
struct global_geometry_element_struct global_geometry_element;

#ifndef ANY_GEOMETRY_DETECTOR_DECLARE
    #define ANY_GEOMETRY_DETECTOR_DECLARE dummy
	//struct pointer_to_global_geometry_list global_geometry_list = {0,NULL};
#endif

int loop_index,found_geometries;

double x_component;
double y_component;
double z_component;

struct Volume_struct this_box_volume;
struct box_storage this_box_storage;

#line 84514 "MACS_sample_kidney_box.c"
#undef number_of_activations
#undef mask_setting
#undef mask_string
#undef p_interact
#undef focus_r
#undef focus_xh
#undef focus_xw
#undef focus_ah
#undef focus_aw
#undef target_z
#undef target_y
#undef target_x
#undef target_index
#undef visualize
#undef yheight2
#undef xwidth2
#undef zdepth
#undef yheight
#undef xwidth
#undef priority
#undef material_string
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

/* User declarations for component 'inter_analyzer_colimator_19_blade_4' [881]. */
#define mccompcurname  inter_analyzer_colimator_19_blade_4
#define mccompcurtype  Union_box
#define mccompcurindex 881
#define loop_index mccinter_analyzer_colimator_19_blade_4_loop_index
#define this_box_volume mccinter_analyzer_colimator_19_blade_4_this_box_volume
#define global_geometry_element mccinter_analyzer_colimator_19_blade_4_global_geometry_element
#define this_box_storage mccinter_analyzer_colimator_19_blade_4_this_box_storage
#define material_string mccinter_analyzer_colimator_19_blade_4_material_string
#define priority mccinter_analyzer_colimator_19_blade_4_priority
#define xwidth mccinter_analyzer_colimator_19_blade_4_xwidth
#define yheight mccinter_analyzer_colimator_19_blade_4_yheight
#define zdepth mccinter_analyzer_colimator_19_blade_4_zdepth
#define xwidth2 mccinter_analyzer_colimator_19_blade_4_xwidth2
#define yheight2 mccinter_analyzer_colimator_19_blade_4_yheight2
#define visualize mccinter_analyzer_colimator_19_blade_4_visualize
#define target_index mccinter_analyzer_colimator_19_blade_4_target_index
#define target_x mccinter_analyzer_colimator_19_blade_4_target_x
#define target_y mccinter_analyzer_colimator_19_blade_4_target_y
#define target_z mccinter_analyzer_colimator_19_blade_4_target_z
#define focus_aw mccinter_analyzer_colimator_19_blade_4_focus_aw
#define focus_ah mccinter_analyzer_colimator_19_blade_4_focus_ah
#define focus_xw mccinter_analyzer_colimator_19_blade_4_focus_xw
#define focus_xh mccinter_analyzer_colimator_19_blade_4_focus_xh
#define focus_r mccinter_analyzer_colimator_19_blade_4_focus_r
#define p_interact mccinter_analyzer_colimator_19_blade_4_p_interact
#define mask_string mccinter_analyzer_colimator_19_blade_4_mask_string
#define mask_setting mccinter_analyzer_colimator_19_blade_4_mask_setting
#define number_of_activations mccinter_analyzer_colimator_19_blade_4_number_of_activations
#line 204 "Union_box.comp"
// Needed for transport to the main component
struct global_geometry_element_struct global_geometry_element;

#ifndef ANY_GEOMETRY_DETECTOR_DECLARE
    #define ANY_GEOMETRY_DETECTOR_DECLARE dummy
	//struct pointer_to_global_geometry_list global_geometry_list = {0,NULL};
#endif

int loop_index,found_geometries;

double x_component;
double y_component;
double z_component;

struct Volume_struct this_box_volume;
struct box_storage this_box_storage;

#line 84591 "MACS_sample_kidney_box.c"
#undef number_of_activations
#undef mask_setting
#undef mask_string
#undef p_interact
#undef focus_r
#undef focus_xh
#undef focus_xw
#undef focus_ah
#undef focus_aw
#undef target_z
#undef target_y
#undef target_x
#undef target_index
#undef visualize
#undef yheight2
#undef xwidth2
#undef zdepth
#undef yheight
#undef xwidth
#undef priority
#undef material_string
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

/* User declarations for component 'diffraction_detector_19_exit_volume' [882]. */
#define mccompcurname  diffraction_detector_19_exit_volume
#define mccompcurtype  Union_box
#define mccompcurindex 882
#define loop_index mccdiffraction_detector_19_exit_volume_loop_index
#define this_box_volume mccdiffraction_detector_19_exit_volume_this_box_volume
#define global_geometry_element mccdiffraction_detector_19_exit_volume_global_geometry_element
#define this_box_storage mccdiffraction_detector_19_exit_volume_this_box_storage
#define material_string mccdiffraction_detector_19_exit_volume_material_string
#define priority mccdiffraction_detector_19_exit_volume_priority
#define xwidth mccdiffraction_detector_19_exit_volume_xwidth
#define yheight mccdiffraction_detector_19_exit_volume_yheight
#define zdepth mccdiffraction_detector_19_exit_volume_zdepth
#define xwidth2 mccdiffraction_detector_19_exit_volume_xwidth2
#define yheight2 mccdiffraction_detector_19_exit_volume_yheight2
#define visualize mccdiffraction_detector_19_exit_volume_visualize
#define target_index mccdiffraction_detector_19_exit_volume_target_index
#define target_x mccdiffraction_detector_19_exit_volume_target_x
#define target_y mccdiffraction_detector_19_exit_volume_target_y
#define target_z mccdiffraction_detector_19_exit_volume_target_z
#define focus_aw mccdiffraction_detector_19_exit_volume_focus_aw
#define focus_ah mccdiffraction_detector_19_exit_volume_focus_ah
#define focus_xw mccdiffraction_detector_19_exit_volume_focus_xw
#define focus_xh mccdiffraction_detector_19_exit_volume_focus_xh
#define focus_r mccdiffraction_detector_19_exit_volume_focus_r
#define p_interact mccdiffraction_detector_19_exit_volume_p_interact
#define mask_string mccdiffraction_detector_19_exit_volume_mask_string
#define mask_setting mccdiffraction_detector_19_exit_volume_mask_setting
#define number_of_activations mccdiffraction_detector_19_exit_volume_number_of_activations
#line 204 "Union_box.comp"
// Needed for transport to the main component
struct global_geometry_element_struct global_geometry_element;

#ifndef ANY_GEOMETRY_DETECTOR_DECLARE
    #define ANY_GEOMETRY_DETECTOR_DECLARE dummy
	//struct pointer_to_global_geometry_list global_geometry_list = {0,NULL};
#endif

int loop_index,found_geometries;

double x_component;
double y_component;
double z_component;

struct Volume_struct this_box_volume;
struct box_storage this_box_storage;

#line 84668 "MACS_sample_kidney_box.c"
#undef number_of_activations
#undef mask_setting
#undef mask_string
#undef p_interact
#undef focus_r
#undef focus_xh
#undef focus_xw
#undef focus_ah
#undef focus_aw
#undef target_z
#undef target_y
#undef target_x
#undef target_index
#undef visualize
#undef yheight2
#undef xwidth2
#undef zdepth
#undef yheight
#undef xwidth
#undef priority
#undef material_string
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

/* User declarations for component 'spec_detector_19_exit_volume' [883]. */
#define mccompcurname  spec_detector_19_exit_volume
#define mccompcurtype  Union_box
#define mccompcurindex 883
#define loop_index mccspec_detector_19_exit_volume_loop_index
#define this_box_volume mccspec_detector_19_exit_volume_this_box_volume
#define global_geometry_element mccspec_detector_19_exit_volume_global_geometry_element
#define this_box_storage mccspec_detector_19_exit_volume_this_box_storage
#define material_string mccspec_detector_19_exit_volume_material_string
#define priority mccspec_detector_19_exit_volume_priority
#define xwidth mccspec_detector_19_exit_volume_xwidth
#define yheight mccspec_detector_19_exit_volume_yheight
#define zdepth mccspec_detector_19_exit_volume_zdepth
#define xwidth2 mccspec_detector_19_exit_volume_xwidth2
#define yheight2 mccspec_detector_19_exit_volume_yheight2
#define visualize mccspec_detector_19_exit_volume_visualize
#define target_index mccspec_detector_19_exit_volume_target_index
#define target_x mccspec_detector_19_exit_volume_target_x
#define target_y mccspec_detector_19_exit_volume_target_y
#define target_z mccspec_detector_19_exit_volume_target_z
#define focus_aw mccspec_detector_19_exit_volume_focus_aw
#define focus_ah mccspec_detector_19_exit_volume_focus_ah
#define focus_xw mccspec_detector_19_exit_volume_focus_xw
#define focus_xh mccspec_detector_19_exit_volume_focus_xh
#define focus_r mccspec_detector_19_exit_volume_focus_r
#define p_interact mccspec_detector_19_exit_volume_p_interact
#define mask_string mccspec_detector_19_exit_volume_mask_string
#define mask_setting mccspec_detector_19_exit_volume_mask_setting
#define number_of_activations mccspec_detector_19_exit_volume_number_of_activations
#line 204 "Union_box.comp"
// Needed for transport to the main component
struct global_geometry_element_struct global_geometry_element;

#ifndef ANY_GEOMETRY_DETECTOR_DECLARE
    #define ANY_GEOMETRY_DETECTOR_DECLARE dummy
	//struct pointer_to_global_geometry_list global_geometry_list = {0,NULL};
#endif

int loop_index,found_geometries;

double x_component;
double y_component;
double z_component;

struct Volume_struct this_box_volume;
struct box_storage this_box_storage;

#line 84745 "MACS_sample_kidney_box.c"
#undef number_of_activations
#undef mask_setting
#undef mask_string
#undef p_interact
#undef focus_r
#undef focus_xh
#undef focus_xw
#undef focus_ah
#undef focus_aw
#undef target_z
#undef target_y
#undef target_x
#undef target_index
#undef visualize
#undef yheight2
#undef xwidth2
#undef zdepth
#undef yheight
#undef xwidth
#undef priority
#undef material_string
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

/* User declarations for component 'kidney_union_master' [884]. */
#define mccompcurname  kidney_union_master
#define mccompcurtype  Union_master
#define mccompcurindex 884
#define verbal mcckidney_union_master_verbal
#define list_verbal mcckidney_union_master_list_verbal
#define trace_verbal mcckidney_union_master_trace_verbal
#define finally_verbal mcckidney_union_master_finally_verbal
#define starting_volume_warning mcckidney_union_master_starting_volume_warning
#define global_master_element mcckidney_union_master_global_master_element
#define this_global_master_index mcckidney_union_master_this_global_master_index
#define previous_master_index mcckidney_union_master_previous_master_index
#define geometry_list_index mcckidney_union_master_geometry_list_index
#define intersection_time_table mcckidney_union_master_intersection_time_table
#define Volumes mcckidney_union_master_Volumes
#define Geometries mcckidney_union_master_Geometries
#define starting_lists mcckidney_union_master_starting_lists
#define r mcckidney_union_master_r
#define r_start mcckidney_union_master_r_start
#define v mcckidney_union_master_v
#define error_msg mcckidney_union_master_error_msg
#define component_error_msg mcckidney_union_master_component_error_msg
#define string_output mcckidney_union_master_string_output
#define number_of_volumes mcckidney_union_master_number_of_volumes
#define volume_index mcckidney_union_master_volume_index
#define process_index mcckidney_union_master_process_index
#define solutions mcckidney_union_master_solutions
#define max_number_of_processes mcckidney_union_master_max_number_of_processes
#define limit mcckidney_union_master_limit
#define solution mcckidney_union_master_solution
#define min_solution mcckidney_union_master_min_solution
#define min_volume mcckidney_union_master_min_volume
#define time_found mcckidney_union_master_time_found
#define intersection_time mcckidney_union_master_intersection_time
#define min_intersection_time mcckidney_union_master_min_intersection_time
#define process mcckidney_union_master_process
#define process_start mcckidney_union_master_process_start
#define my_trace mcckidney_union_master_my_trace
#define p_my_trace mcckidney_union_master_p_my_trace
#define my_trace_fraction_control mcckidney_union_master_my_trace_fraction_control
#define k mcckidney_union_master_k
#define k_new mcckidney_union_master_k_new
#define k_old mcckidney_union_master_k_old
#define v_length mcckidney_union_master_v_length
#define my_sum mcckidney_union_master_my_sum
#define my_sum_plus_abs mcckidney_union_master_my_sum_plus_abs
#define culmative_probability mcckidney_union_master_culmative_probability
#define mc_prop mcckidney_union_master_mc_prop
#define time_to_scattering mcckidney_union_master_time_to_scattering
#define length_to_scattering mcckidney_union_master_length_to_scattering
#define length_to_boundery mcckidney_union_master_length_to_boundery
#define time_to_boundery mcckidney_union_master_time_to_boundery
#define selected_process mcckidney_union_master_selected_process
#define scattering_event mcckidney_union_master_scattering_event
#define time_propagated_without_scattering mcckidney_union_master_time_propagated_without_scattering
#define a_next_volume_found mcckidney_union_master_a_next_volume_found
#define next_volume mcckidney_union_master_next_volume
#define next_volume_priority mcckidney_union_master_next_volume_priority
#define done mcckidney_union_master_done
#define current_volume mcckidney_union_master_current_volume
#define number_of_solutions mcckidney_union_master_number_of_solutions
#define number_of_solutions_static mcckidney_union_master_number_of_solutions_static
#define check mcckidney_union_master_check
#define start mcckidney_union_master_start
#define intersection_with_children mcckidney_union_master_intersection_with_children
#define geometry_output mcckidney_union_master_geometry_output
#define tree_next_volume mcckidney_union_master_tree_next_volume
#define pre_allocated1 mcckidney_union_master_pre_allocated1
#define pre_allocated2 mcckidney_union_master_pre_allocated2
#define pre_allocated3 mcckidney_union_master_pre_allocated3
#define ray_position mcckidney_union_master_ray_position
#define ray_velocity mcckidney_union_master_ray_velocity
#define ray_velocity_final mcckidney_union_master_ray_velocity_final
#define volume_0_found mcckidney_union_master_volume_0_found
#define scattered_flag mcckidney_union_master_scattered_flag
#define scattered_flag_VP mcckidney_union_master_scattered_flag_VP
#define master_transposed_rotation_matrix mcckidney_union_master_master_transposed_rotation_matrix
#define temp_rotation_matrix mcckidney_union_master_temp_rotation_matrix
#define non_rotated_position mcckidney_union_master_non_rotated_position
#define rotated_position mcckidney_union_master_rotated_position
#define enable_tagging mcckidney_union_master_enable_tagging
#define stop_tagging_ray mcckidney_union_master_stop_tagging_ray
#define stop_creating_nodes mcckidney_union_master_stop_creating_nodes
#define enable_tagging_check mcckidney_union_master_enable_tagging_check
#define master_tagging_node_list mcckidney_union_master_master_tagging_node_list
#define current_tagging_node mcckidney_union_master_current_tagging_node
#define tagging_leaf_counter mcckidney_union_master_tagging_leaf_counter
#define number_of_scattering_events mcckidney_union_master_number_of_scattering_events
#define real_transmission_probability mcckidney_union_master_real_transmission_probability
#define mc_transmission_probability mcckidney_union_master_mc_transmission_probability
#define number_of_masks mcckidney_union_master_number_of_masks
#define number_of_masked_volumes mcckidney_union_master_number_of_masked_volumes
#define need_to_run_within_which_volume mcckidney_union_master_need_to_run_within_which_volume
#define mask_index_main mcckidney_union_master_mask_index_main
#define mask_iterate mcckidney_union_master_mask_iterate
#define mask_status_list mcckidney_union_master_mask_status_list
#define current_mask_intersect_list_status mcckidney_union_master_current_mask_intersect_list_status
#define mask_volume_index_list mcckidney_union_master_mask_volume_index_list
#define geometry_component_index_list mcckidney_union_master_geometry_component_index_list
#define Volume_copies_allocated mcckidney_union_master_Volume_copies_allocated
#define p_old mcckidney_union_master_p_old
#define this_logger mcckidney_union_master_this_logger
#define conditional_status mcckidney_union_master_conditional_status
#define tagging_conditional_list mcckidney_union_master_tagging_conditional_list
#define free_tagging_conditioanl_list mcckidney_union_master_free_tagging_conditioanl_list
#define logger_conditional_extend_array mcckidney_union_master_logger_conditional_extend_array
#define tagging_conditional_extend mcckidney_union_master_tagging_conditional_extend
#define max_conditional_extend_index mcckidney_union_master_max_conditional_extend_index
#define safty_distance mcckidney_union_master_safty_distance
#define safty_distance2 mcckidney_union_master_safty_distance2
#define number_of_processes_array mcckidney_union_master_number_of_processes_array
#define temporary_focus_data mcckidney_union_master_temporary_focus_data
#define focus_data_index mcckidney_union_master_focus_data_index
#define allow_inside_start mcckidney_union_master_allow_inside_start
#define history_limit mcckidney_union_master_history_limit
#define enable_conditionals mcckidney_union_master_enable_conditionals
#define inherit_number_of_scattering_events mcckidney_union_master_inherit_number_of_scattering_events
#line 68 "Union_master.comp"
  // Settings that can be moved to input.
  int verbal = 1;
  int list_verbal = 1;
  int finally_verbal = 0;
  
  // Performance intensive, and should be done in precompiler
  int trace_verbal = 0;
  int enable_tagging = 0;

  // It is possible to surpress warnings on starting volume by setting this to 1
  int starting_volume_warning = 0;
  
  // New precompiler settings
  //#define Union_trace_verbal_setting
  //#define Union_enable_tagging_setting

  // Declare the global variables (not to be in output parameters)
  struct global_master_element_struct global_master_element;
  int this_global_master_index;
  
  #ifndef MASTER_DETECTOR
	//struct pointer_to_global_master_list global_master_list = {0,NULL};
	#define MASTER_DETECTOR dummy
  #endif
  
  // variables used for assigning global information to local variables
  int previous_master_index,geometry_list_index;

  // The main structures used in this component
  struct intersection_time_table_struct intersection_time_table;
  struct Volume_struct **Volumes;
  struct geometry_struct **Geometries;
  struct Volume_struct **Volume_copies;
  struct starting_lists_struct starting_lists;
  
  // garbage collection for volume_copies
  struct pointer_to_1d_int_list Volume_copies_allocated;

  // Vectors in old format (still used by intersect function, will go to Coords in future)
  double r[3],r_start[3],v[3];

  // Error handling
  int error_msg, component_error_msg=0;
  
  // For verbal output
  char string_output[128];
  
  // Variables for ray-tracing algorithm
  int number_of_volumes, volume_index, process_index;
  int iterate,solutions,max_number_of_processes,limit;
  int solution,min_solution,min_volume,time_found;
  double intersection_time,min_intersection_time;
  
  struct scattering_process_struct *process,*process_start;
  double *my_trace,*p_my_trace,*my_trace_fraction_control;
  double k[3],k_new[3],k_old[3],k_rotated[3];
  double v_length,my_sum,my_sum_plus_abs,culmative_probability,mc_prop,time_to_scattering;
  double length_to_scattering,length_to_boundery,length_to_boundery_fp,time_to_boundery;
  int selected_process,scattering_event;
  double time_propagated_without_scattering;
  
  int a_next_volume_found,next_volume;
  double next_volume_priority;
  
  int done,current_volume,ray_sucseeded;
  int *number_of_solutions;
  int number_of_solutions_static;
  int *check,*start;
  int intersection_with_children,geometry_output;
  
  // For within_which_volume
  int tree_next_volume;
  int *pre_allocated1,*pre_allocated2,*pre_allocated3;
  Coords ray_position,ray_velocity,ray_velocity_rotated,ray_velocity_final,wavevector,wavevector_rotated;
  int volume_0_found=0;
  
  int *scattered_flag;
  int **scattered_flag_VP;
  
  // For coordinate transformations
  Rotation master_transposed_rotation_matrix;
  Rotation temp_rotation_matrix;
  Rotation temp_transpose_rotation_matrix;
  Coords non_rotated_position;
  Coords rotated_position;
  int non_isotropic_found;
  
  // For tagging
  struct list_of_tagging_tree_node_pointers master_tagging_node_list;
  struct tagging_tree_node_struct *current_tagging_node;
  
  int tagging_leaf_counter=0,stop_tagging_ray,stop_creating_nodes;
  int number_of_scattering_events;
  
  // For geometry p interact
  double real_transmission_probability,mc_transmission_probability;
  
  // Process p interact
  int number_of_process_interacts_set,index_of_lacking_process;
  double total_process_interact;
  
  // Volume nr -> component index
  struct pointer_to_1d_int_list geometry_component_index_list;
  
  // Masks
  struct pointer_to_1d_int_list mask_volume_index_list;
  int number_of_masks=0;
  int number_of_masked_volumes=0;
  struct pointer_to_1d_int_list mask_status_list;
  struct pointer_to_1d_int_list current_mask_intersect_list_status;
  int mask_index_main,mask_iterate;
  int *mask_start,*mask_check;
  int need_to_run_within_which_volume;
  
  // Loggers
  //struct logger_with_data_struct loggers_with_data_array;
  int *number_of_processes_array;
  double p_old;
  int log_index,conditional_status;
  struct logger_struct *this_logger;
  //  union detector_pointer_union detector_pointer;
  
  // Conditionals
  struct conditional_list_struct *tagging_conditional_list;
  int *logger_conditional_extend_array;
  int max_conditional_extend_index;
  int tagging_conditional_extend;
  int free_tagging_conditioanl_list;
  
  // Reliability control
  // Safty distance is needed to avoid having ray positions closer to a wall than the precision of intersection functions
  double safty_distance,safty_distance2;
  
  // Focusing
  struct focus_data_struct temporary_focus_data;
  int focus_data_index;
  
#line 85030 "MACS_sample_kidney_box.c"
#undef inherit_number_of_scattering_events
#undef enable_conditionals
#undef history_limit
#undef allow_inside_start
#undef focus_data_index
#undef temporary_focus_data
#undef number_of_processes_array
#undef safty_distance2
#undef safty_distance
#undef max_conditional_extend_index
#undef tagging_conditional_extend
#undef logger_conditional_extend_array
#undef free_tagging_conditioanl_list
#undef tagging_conditional_list
#undef conditional_status
#undef this_logger
#undef p_old
#undef Volume_copies_allocated
#undef geometry_component_index_list
#undef mask_volume_index_list
#undef current_mask_intersect_list_status
#undef mask_status_list
#undef mask_iterate
#undef mask_index_main
#undef need_to_run_within_which_volume
#undef number_of_masked_volumes
#undef number_of_masks
#undef mc_transmission_probability
#undef real_transmission_probability
#undef number_of_scattering_events
#undef tagging_leaf_counter
#undef current_tagging_node
#undef master_tagging_node_list
#undef enable_tagging_check
#undef stop_creating_nodes
#undef stop_tagging_ray
#undef enable_tagging
#undef rotated_position
#undef non_rotated_position
#undef temp_rotation_matrix
#undef master_transposed_rotation_matrix
#undef scattered_flag_VP
#undef scattered_flag
#undef volume_0_found
#undef ray_velocity_final
#undef ray_velocity
#undef ray_position
#undef pre_allocated3
#undef pre_allocated2
#undef pre_allocated1
#undef tree_next_volume
#undef geometry_output
#undef intersection_with_children
#undef start
#undef check
#undef number_of_solutions_static
#undef number_of_solutions
#undef current_volume
#undef done
#undef next_volume_priority
#undef next_volume
#undef a_next_volume_found
#undef time_propagated_without_scattering
#undef scattering_event
#undef selected_process
#undef time_to_boundery
#undef length_to_boundery
#undef length_to_scattering
#undef time_to_scattering
#undef mc_prop
#undef culmative_probability
#undef my_sum_plus_abs
#undef my_sum
#undef v_length
#undef k_old
#undef k_new
#undef k
#undef my_trace_fraction_control
#undef p_my_trace
#undef my_trace
#undef process_start
#undef process
#undef min_intersection_time
#undef intersection_time
#undef time_found
#undef min_volume
#undef min_solution
#undef solution
#undef limit
#undef max_number_of_processes
#undef solutions
#undef process_index
#undef volume_index
#undef number_of_volumes
#undef string_output
#undef component_error_msg
#undef error_msg
#undef v
#undef r_start
#undef r
#undef starting_lists
#undef Geometries
#undef Volumes
#undef intersection_time_table
#undef geometry_list_index
#undef previous_master_index
#undef this_global_master_index
#undef global_master_element
#undef starting_volume_warning
#undef finally_verbal
#undef trace_verbal
#undef list_verbal
#undef verbal
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

/* User declarations for component 'diffraction_detector_0' [885]. */
#define mccompcurname  diffraction_detector_0
#define mccompcurtype  PSD_monitor
#define mccompcurindex 885
#define PSD_N mccdiffraction_detector_0_PSD_N
#define PSD_p mccdiffraction_detector_0_PSD_p
#define PSD_p2 mccdiffraction_detector_0_PSD_p2
#define nx mccdiffraction_detector_0_nx
#define ny mccdiffraction_detector_0_ny
#define filename mccdiffraction_detector_0_filename
#define xmin mccdiffraction_detector_0_xmin
#define xmax mccdiffraction_detector_0_xmax
#define ymin mccdiffraction_detector_0_ymin
#define ymax mccdiffraction_detector_0_ymax
#define xwidth mccdiffraction_detector_0_xwidth
#define yheight mccdiffraction_detector_0_yheight
#define restore_neutron mccdiffraction_detector_0_restore_neutron
#line 62 "/usr/share/mcstas/2.7/monitors/PSD_monitor.comp"
  DArray2d PSD_N;
  DArray2d PSD_p;
  DArray2d PSD_p2;
#line 85169 "MACS_sample_kidney_box.c"
#undef restore_neutron
#undef yheight
#undef xwidth
#undef ymax
#undef ymin
#undef xmax
#undef xmin
#undef filename
#undef ny
#undef nx
#undef PSD_p2
#undef PSD_p
#undef PSD_N
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

/* User declarations for component 'spec_detector_0' [886]. */
#define mccompcurname  spec_detector_0
#define mccompcurtype  PSD_monitor
#define mccompcurindex 886
#define PSD_N mccspec_detector_0_PSD_N
#define PSD_p mccspec_detector_0_PSD_p
#define PSD_p2 mccspec_detector_0_PSD_p2
#define nx mccspec_detector_0_nx
#define ny mccspec_detector_0_ny
#define filename mccspec_detector_0_filename
#define xmin mccspec_detector_0_xmin
#define xmax mccspec_detector_0_xmax
#define ymin mccspec_detector_0_ymin
#define ymax mccspec_detector_0_ymax
#define xwidth mccspec_detector_0_xwidth
#define yheight mccspec_detector_0_yheight
#define restore_neutron mccspec_detector_0_restore_neutron
#line 62 "/usr/share/mcstas/2.7/monitors/PSD_monitor.comp"
  DArray2d PSD_N;
  DArray2d PSD_p;
  DArray2d PSD_p2;
#line 85208 "MACS_sample_kidney_box.c"
#undef restore_neutron
#undef yheight
#undef xwidth
#undef ymax
#undef ymin
#undef xmax
#undef xmin
#undef filename
#undef ny
#undef nx
#undef PSD_p2
#undef PSD_p
#undef PSD_N
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

/* User declarations for component 'diffraction_detector_1' [887]. */
#define mccompcurname  diffraction_detector_1
#define mccompcurtype  PSD_monitor
#define mccompcurindex 887
#define PSD_N mccdiffraction_detector_1_PSD_N
#define PSD_p mccdiffraction_detector_1_PSD_p
#define PSD_p2 mccdiffraction_detector_1_PSD_p2
#define nx mccdiffraction_detector_1_nx
#define ny mccdiffraction_detector_1_ny
#define filename mccdiffraction_detector_1_filename
#define xmin mccdiffraction_detector_1_xmin
#define xmax mccdiffraction_detector_1_xmax
#define ymin mccdiffraction_detector_1_ymin
#define ymax mccdiffraction_detector_1_ymax
#define xwidth mccdiffraction_detector_1_xwidth
#define yheight mccdiffraction_detector_1_yheight
#define restore_neutron mccdiffraction_detector_1_restore_neutron
#line 62 "/usr/share/mcstas/2.7/monitors/PSD_monitor.comp"
  DArray2d PSD_N;
  DArray2d PSD_p;
  DArray2d PSD_p2;
#line 85247 "MACS_sample_kidney_box.c"
#undef restore_neutron
#undef yheight
#undef xwidth
#undef ymax
#undef ymin
#undef xmax
#undef xmin
#undef filename
#undef ny
#undef nx
#undef PSD_p2
#undef PSD_p
#undef PSD_N
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

/* User declarations for component 'spec_detector_1' [888]. */
#define mccompcurname  spec_detector_1
#define mccompcurtype  PSD_monitor
#define mccompcurindex 888
#define PSD_N mccspec_detector_1_PSD_N
#define PSD_p mccspec_detector_1_PSD_p
#define PSD_p2 mccspec_detector_1_PSD_p2
#define nx mccspec_detector_1_nx
#define ny mccspec_detector_1_ny
#define filename mccspec_detector_1_filename
#define xmin mccspec_detector_1_xmin
#define xmax mccspec_detector_1_xmax
#define ymin mccspec_detector_1_ymin
#define ymax mccspec_detector_1_ymax
#define xwidth mccspec_detector_1_xwidth
#define yheight mccspec_detector_1_yheight
#define restore_neutron mccspec_detector_1_restore_neutron
#line 62 "/usr/share/mcstas/2.7/monitors/PSD_monitor.comp"
  DArray2d PSD_N;
  DArray2d PSD_p;
  DArray2d PSD_p2;
#line 85286 "MACS_sample_kidney_box.c"
#undef restore_neutron
#undef yheight
#undef xwidth
#undef ymax
#undef ymin
#undef xmax
#undef xmin
#undef filename
#undef ny
#undef nx
#undef PSD_p2
#undef PSD_p
#undef PSD_N
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

/* User declarations for component 'diffraction_detector_2' [889]. */
#define mccompcurname  diffraction_detector_2
#define mccompcurtype  PSD_monitor
#define mccompcurindex 889
#define PSD_N mccdiffraction_detector_2_PSD_N
#define PSD_p mccdiffraction_detector_2_PSD_p
#define PSD_p2 mccdiffraction_detector_2_PSD_p2
#define nx mccdiffraction_detector_2_nx
#define ny mccdiffraction_detector_2_ny
#define filename mccdiffraction_detector_2_filename
#define xmin mccdiffraction_detector_2_xmin
#define xmax mccdiffraction_detector_2_xmax
#define ymin mccdiffraction_detector_2_ymin
#define ymax mccdiffraction_detector_2_ymax
#define xwidth mccdiffraction_detector_2_xwidth
#define yheight mccdiffraction_detector_2_yheight
#define restore_neutron mccdiffraction_detector_2_restore_neutron
#line 62 "/usr/share/mcstas/2.7/monitors/PSD_monitor.comp"
  DArray2d PSD_N;
  DArray2d PSD_p;
  DArray2d PSD_p2;
#line 85325 "MACS_sample_kidney_box.c"
#undef restore_neutron
#undef yheight
#undef xwidth
#undef ymax
#undef ymin
#undef xmax
#undef xmin
#undef filename
#undef ny
#undef nx
#undef PSD_p2
#undef PSD_p
#undef PSD_N
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

/* User declarations for component 'spec_detector_2' [890]. */
#define mccompcurname  spec_detector_2
#define mccompcurtype  PSD_monitor
#define mccompcurindex 890
#define PSD_N mccspec_detector_2_PSD_N
#define PSD_p mccspec_detector_2_PSD_p
#define PSD_p2 mccspec_detector_2_PSD_p2
#define nx mccspec_detector_2_nx
#define ny mccspec_detector_2_ny
#define filename mccspec_detector_2_filename
#define xmin mccspec_detector_2_xmin
#define xmax mccspec_detector_2_xmax
#define ymin mccspec_detector_2_ymin
#define ymax mccspec_detector_2_ymax
#define xwidth mccspec_detector_2_xwidth
#define yheight mccspec_detector_2_yheight
#define restore_neutron mccspec_detector_2_restore_neutron
#line 62 "/usr/share/mcstas/2.7/monitors/PSD_monitor.comp"
  DArray2d PSD_N;
  DArray2d PSD_p;
  DArray2d PSD_p2;
#line 85364 "MACS_sample_kidney_box.c"
#undef restore_neutron
#undef yheight
#undef xwidth
#undef ymax
#undef ymin
#undef xmax
#undef xmin
#undef filename
#undef ny
#undef nx
#undef PSD_p2
#undef PSD_p
#undef PSD_N
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

/* User declarations for component 'diffraction_detector_3' [891]. */
#define mccompcurname  diffraction_detector_3
#define mccompcurtype  PSD_monitor
#define mccompcurindex 891
#define PSD_N mccdiffraction_detector_3_PSD_N
#define PSD_p mccdiffraction_detector_3_PSD_p
#define PSD_p2 mccdiffraction_detector_3_PSD_p2
#define nx mccdiffraction_detector_3_nx
#define ny mccdiffraction_detector_3_ny
#define filename mccdiffraction_detector_3_filename
#define xmin mccdiffraction_detector_3_xmin
#define xmax mccdiffraction_detector_3_xmax
#define ymin mccdiffraction_detector_3_ymin
#define ymax mccdiffraction_detector_3_ymax
#define xwidth mccdiffraction_detector_3_xwidth
#define yheight mccdiffraction_detector_3_yheight
#define restore_neutron mccdiffraction_detector_3_restore_neutron
#line 62 "/usr/share/mcstas/2.7/monitors/PSD_monitor.comp"
  DArray2d PSD_N;
  DArray2d PSD_p;
  DArray2d PSD_p2;
#line 85403 "MACS_sample_kidney_box.c"
#undef restore_neutron
#undef yheight
#undef xwidth
#undef ymax
#undef ymin
#undef xmax
#undef xmin
#undef filename
#undef ny
#undef nx
#undef PSD_p2
#undef PSD_p
#undef PSD_N
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

/* User declarations for component 'spec_detector_3' [892]. */
#define mccompcurname  spec_detector_3
#define mccompcurtype  PSD_monitor
#define mccompcurindex 892
#define PSD_N mccspec_detector_3_PSD_N
#define PSD_p mccspec_detector_3_PSD_p
#define PSD_p2 mccspec_detector_3_PSD_p2
#define nx mccspec_detector_3_nx
#define ny mccspec_detector_3_ny
#define filename mccspec_detector_3_filename
#define xmin mccspec_detector_3_xmin
#define xmax mccspec_detector_3_xmax
#define ymin mccspec_detector_3_ymin
#define ymax mccspec_detector_3_ymax
#define xwidth mccspec_detector_3_xwidth
#define yheight mccspec_detector_3_yheight
#define restore_neutron mccspec_detector_3_restore_neutron
#line 62 "/usr/share/mcstas/2.7/monitors/PSD_monitor.comp"
  DArray2d PSD_N;
  DArray2d PSD_p;
  DArray2d PSD_p2;
#line 85442 "MACS_sample_kidney_box.c"
#undef restore_neutron
#undef yheight
#undef xwidth
#undef ymax
#undef ymin
#undef xmax
#undef xmin
#undef filename
#undef ny
#undef nx
#undef PSD_p2
#undef PSD_p
#undef PSD_N
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

/* User declarations for component 'diffraction_detector_4' [893]. */
#define mccompcurname  diffraction_detector_4
#define mccompcurtype  PSD_monitor
#define mccompcurindex 893
#define PSD_N mccdiffraction_detector_4_PSD_N
#define PSD_p mccdiffraction_detector_4_PSD_p
#define PSD_p2 mccdiffraction_detector_4_PSD_p2
#define nx mccdiffraction_detector_4_nx
#define ny mccdiffraction_detector_4_ny
#define filename mccdiffraction_detector_4_filename
#define xmin mccdiffraction_detector_4_xmin
#define xmax mccdiffraction_detector_4_xmax
#define ymin mccdiffraction_detector_4_ymin
#define ymax mccdiffraction_detector_4_ymax
#define xwidth mccdiffraction_detector_4_xwidth
#define yheight mccdiffraction_detector_4_yheight
#define restore_neutron mccdiffraction_detector_4_restore_neutron
#line 62 "/usr/share/mcstas/2.7/monitors/PSD_monitor.comp"
  DArray2d PSD_N;
  DArray2d PSD_p;
  DArray2d PSD_p2;
#line 85481 "MACS_sample_kidney_box.c"
#undef restore_neutron
#undef yheight
#undef xwidth
#undef ymax
#undef ymin
#undef xmax
#undef xmin
#undef filename
#undef ny
#undef nx
#undef PSD_p2
#undef PSD_p
#undef PSD_N
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

/* User declarations for component 'spec_detector_4' [894]. */
#define mccompcurname  spec_detector_4
#define mccompcurtype  PSD_monitor
#define mccompcurindex 894
#define PSD_N mccspec_detector_4_PSD_N
#define PSD_p mccspec_detector_4_PSD_p
#define PSD_p2 mccspec_detector_4_PSD_p2
#define nx mccspec_detector_4_nx
#define ny mccspec_detector_4_ny
#define filename mccspec_detector_4_filename
#define xmin mccspec_detector_4_xmin
#define xmax mccspec_detector_4_xmax
#define ymin mccspec_detector_4_ymin
#define ymax mccspec_detector_4_ymax
#define xwidth mccspec_detector_4_xwidth
#define yheight mccspec_detector_4_yheight
#define restore_neutron mccspec_detector_4_restore_neutron
#line 62 "/usr/share/mcstas/2.7/monitors/PSD_monitor.comp"
  DArray2d PSD_N;
  DArray2d PSD_p;
  DArray2d PSD_p2;
#line 85520 "MACS_sample_kidney_box.c"
#undef restore_neutron
#undef yheight
#undef xwidth
#undef ymax
#undef ymin
#undef xmax
#undef xmin
#undef filename
#undef ny
#undef nx
#undef PSD_p2
#undef PSD_p
#undef PSD_N
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

/* User declarations for component 'diffraction_detector_5' [895]. */
#define mccompcurname  diffraction_detector_5
#define mccompcurtype  PSD_monitor
#define mccompcurindex 895
#define PSD_N mccdiffraction_detector_5_PSD_N
#define PSD_p mccdiffraction_detector_5_PSD_p
#define PSD_p2 mccdiffraction_detector_5_PSD_p2
#define nx mccdiffraction_detector_5_nx
#define ny mccdiffraction_detector_5_ny
#define filename mccdiffraction_detector_5_filename
#define xmin mccdiffraction_detector_5_xmin
#define xmax mccdiffraction_detector_5_xmax
#define ymin mccdiffraction_detector_5_ymin
#define ymax mccdiffraction_detector_5_ymax
#define xwidth mccdiffraction_detector_5_xwidth
#define yheight mccdiffraction_detector_5_yheight
#define restore_neutron mccdiffraction_detector_5_restore_neutron
#line 62 "/usr/share/mcstas/2.7/monitors/PSD_monitor.comp"
  DArray2d PSD_N;
  DArray2d PSD_p;
  DArray2d PSD_p2;
#line 85559 "MACS_sample_kidney_box.c"
#undef restore_neutron
#undef yheight
#undef xwidth
#undef ymax
#undef ymin
#undef xmax
#undef xmin
#undef filename
#undef ny
#undef nx
#undef PSD_p2
#undef PSD_p
#undef PSD_N
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

/* User declarations for component 'spec_detector_5' [896]. */
#define mccompcurname  spec_detector_5
#define mccompcurtype  PSD_monitor
#define mccompcurindex 896
#define PSD_N mccspec_detector_5_PSD_N
#define PSD_p mccspec_detector_5_PSD_p
#define PSD_p2 mccspec_detector_5_PSD_p2
#define nx mccspec_detector_5_nx
#define ny mccspec_detector_5_ny
#define filename mccspec_detector_5_filename
#define xmin mccspec_detector_5_xmin
#define xmax mccspec_detector_5_xmax
#define ymin mccspec_detector_5_ymin
#define ymax mccspec_detector_5_ymax
#define xwidth mccspec_detector_5_xwidth
#define yheight mccspec_detector_5_yheight
#define restore_neutron mccspec_detector_5_restore_neutron
#line 62 "/usr/share/mcstas/2.7/monitors/PSD_monitor.comp"
  DArray2d PSD_N;
  DArray2d PSD_p;
  DArray2d PSD_p2;
#line 85598 "MACS_sample_kidney_box.c"
#undef restore_neutron
#undef yheight
#undef xwidth
#undef ymax
#undef ymin
#undef xmax
#undef xmin
#undef filename
#undef ny
#undef nx
#undef PSD_p2
#undef PSD_p
#undef PSD_N
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

/* User declarations for component 'diffraction_detector_6' [897]. */
#define mccompcurname  diffraction_detector_6
#define mccompcurtype  PSD_monitor
#define mccompcurindex 897
#define PSD_N mccdiffraction_detector_6_PSD_N
#define PSD_p mccdiffraction_detector_6_PSD_p
#define PSD_p2 mccdiffraction_detector_6_PSD_p2
#define nx mccdiffraction_detector_6_nx
#define ny mccdiffraction_detector_6_ny
#define filename mccdiffraction_detector_6_filename
#define xmin mccdiffraction_detector_6_xmin
#define xmax mccdiffraction_detector_6_xmax
#define ymin mccdiffraction_detector_6_ymin
#define ymax mccdiffraction_detector_6_ymax
#define xwidth mccdiffraction_detector_6_xwidth
#define yheight mccdiffraction_detector_6_yheight
#define restore_neutron mccdiffraction_detector_6_restore_neutron
#line 62 "/usr/share/mcstas/2.7/monitors/PSD_monitor.comp"
  DArray2d PSD_N;
  DArray2d PSD_p;
  DArray2d PSD_p2;
#line 85637 "MACS_sample_kidney_box.c"
#undef restore_neutron
#undef yheight
#undef xwidth
#undef ymax
#undef ymin
#undef xmax
#undef xmin
#undef filename
#undef ny
#undef nx
#undef PSD_p2
#undef PSD_p
#undef PSD_N
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

/* User declarations for component 'spec_detector_6' [898]. */
#define mccompcurname  spec_detector_6
#define mccompcurtype  PSD_monitor
#define mccompcurindex 898
#define PSD_N mccspec_detector_6_PSD_N
#define PSD_p mccspec_detector_6_PSD_p
#define PSD_p2 mccspec_detector_6_PSD_p2
#define nx mccspec_detector_6_nx
#define ny mccspec_detector_6_ny
#define filename mccspec_detector_6_filename
#define xmin mccspec_detector_6_xmin
#define xmax mccspec_detector_6_xmax
#define ymin mccspec_detector_6_ymin
#define ymax mccspec_detector_6_ymax
#define xwidth mccspec_detector_6_xwidth
#define yheight mccspec_detector_6_yheight
#define restore_neutron mccspec_detector_6_restore_neutron
#line 62 "/usr/share/mcstas/2.7/monitors/PSD_monitor.comp"
  DArray2d PSD_N;
  DArray2d PSD_p;
  DArray2d PSD_p2;
#line 85676 "MACS_sample_kidney_box.c"
#undef restore_neutron
#undef yheight
#undef xwidth
#undef ymax
#undef ymin
#undef xmax
#undef xmin
#undef filename
#undef ny
#undef nx
#undef PSD_p2
#undef PSD_p
#undef PSD_N
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

/* User declarations for component 'diffraction_detector_7' [899]. */
#define mccompcurname  diffraction_detector_7
#define mccompcurtype  PSD_monitor
#define mccompcurindex 899
#define PSD_N mccdiffraction_detector_7_PSD_N
#define PSD_p mccdiffraction_detector_7_PSD_p
#define PSD_p2 mccdiffraction_detector_7_PSD_p2
#define nx mccdiffraction_detector_7_nx
#define ny mccdiffraction_detector_7_ny
#define filename mccdiffraction_detector_7_filename
#define xmin mccdiffraction_detector_7_xmin
#define xmax mccdiffraction_detector_7_xmax
#define ymin mccdiffraction_detector_7_ymin
#define ymax mccdiffraction_detector_7_ymax
#define xwidth mccdiffraction_detector_7_xwidth
#define yheight mccdiffraction_detector_7_yheight
#define restore_neutron mccdiffraction_detector_7_restore_neutron
#line 62 "/usr/share/mcstas/2.7/monitors/PSD_monitor.comp"
  DArray2d PSD_N;
  DArray2d PSD_p;
  DArray2d PSD_p2;
#line 85715 "MACS_sample_kidney_box.c"
#undef restore_neutron
#undef yheight
#undef xwidth
#undef ymax
#undef ymin
#undef xmax
#undef xmin
#undef filename
#undef ny
#undef nx
#undef PSD_p2
#undef PSD_p
#undef PSD_N
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

/* User declarations for component 'spec_detector_7' [900]. */
#define mccompcurname  spec_detector_7
#define mccompcurtype  PSD_monitor
#define mccompcurindex 900
#define PSD_N mccspec_detector_7_PSD_N
#define PSD_p mccspec_detector_7_PSD_p
#define PSD_p2 mccspec_detector_7_PSD_p2
#define nx mccspec_detector_7_nx
#define ny mccspec_detector_7_ny
#define filename mccspec_detector_7_filename
#define xmin mccspec_detector_7_xmin
#define xmax mccspec_detector_7_xmax
#define ymin mccspec_detector_7_ymin
#define ymax mccspec_detector_7_ymax
#define xwidth mccspec_detector_7_xwidth
#define yheight mccspec_detector_7_yheight
#define restore_neutron mccspec_detector_7_restore_neutron
#line 62 "/usr/share/mcstas/2.7/monitors/PSD_monitor.comp"
  DArray2d PSD_N;
  DArray2d PSD_p;
  DArray2d PSD_p2;
#line 85754 "MACS_sample_kidney_box.c"
#undef restore_neutron
#undef yheight
#undef xwidth
#undef ymax
#undef ymin
#undef xmax
#undef xmin
#undef filename
#undef ny
#undef nx
#undef PSD_p2
#undef PSD_p
#undef PSD_N
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

/* User declarations for component 'diffraction_detector_8' [901]. */
#define mccompcurname  diffraction_detector_8
#define mccompcurtype  PSD_monitor
#define mccompcurindex 901
#define PSD_N mccdiffraction_detector_8_PSD_N
#define PSD_p mccdiffraction_detector_8_PSD_p
#define PSD_p2 mccdiffraction_detector_8_PSD_p2
#define nx mccdiffraction_detector_8_nx
#define ny mccdiffraction_detector_8_ny
#define filename mccdiffraction_detector_8_filename
#define xmin mccdiffraction_detector_8_xmin
#define xmax mccdiffraction_detector_8_xmax
#define ymin mccdiffraction_detector_8_ymin
#define ymax mccdiffraction_detector_8_ymax
#define xwidth mccdiffraction_detector_8_xwidth
#define yheight mccdiffraction_detector_8_yheight
#define restore_neutron mccdiffraction_detector_8_restore_neutron
#line 62 "/usr/share/mcstas/2.7/monitors/PSD_monitor.comp"
  DArray2d PSD_N;
  DArray2d PSD_p;
  DArray2d PSD_p2;
#line 85793 "MACS_sample_kidney_box.c"
#undef restore_neutron
#undef yheight
#undef xwidth
#undef ymax
#undef ymin
#undef xmax
#undef xmin
#undef filename
#undef ny
#undef nx
#undef PSD_p2
#undef PSD_p
#undef PSD_N
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

/* User declarations for component 'spec_detector_8' [902]. */
#define mccompcurname  spec_detector_8
#define mccompcurtype  PSD_monitor
#define mccompcurindex 902
#define PSD_N mccspec_detector_8_PSD_N
#define PSD_p mccspec_detector_8_PSD_p
#define PSD_p2 mccspec_detector_8_PSD_p2
#define nx mccspec_detector_8_nx
#define ny mccspec_detector_8_ny
#define filename mccspec_detector_8_filename
#define xmin mccspec_detector_8_xmin
#define xmax mccspec_detector_8_xmax
#define ymin mccspec_detector_8_ymin
#define ymax mccspec_detector_8_ymax
#define xwidth mccspec_detector_8_xwidth
#define yheight mccspec_detector_8_yheight
#define restore_neutron mccspec_detector_8_restore_neutron
#line 62 "/usr/share/mcstas/2.7/monitors/PSD_monitor.comp"
  DArray2d PSD_N;
  DArray2d PSD_p;
  DArray2d PSD_p2;
#line 85832 "MACS_sample_kidney_box.c"
#undef restore_neutron
#undef yheight
#undef xwidth
#undef ymax
#undef ymin
#undef xmax
#undef xmin
#undef filename
#undef ny
#undef nx
#undef PSD_p2
#undef PSD_p
#undef PSD_N
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

/* User declarations for component 'diffraction_detector_9' [903]. */
#define mccompcurname  diffraction_detector_9
#define mccompcurtype  PSD_monitor
#define mccompcurindex 903
#define PSD_N mccdiffraction_detector_9_PSD_N
#define PSD_p mccdiffraction_detector_9_PSD_p
#define PSD_p2 mccdiffraction_detector_9_PSD_p2
#define nx mccdiffraction_detector_9_nx
#define ny mccdiffraction_detector_9_ny
#define filename mccdiffraction_detector_9_filename
#define xmin mccdiffraction_detector_9_xmin
#define xmax mccdiffraction_detector_9_xmax
#define ymin mccdiffraction_detector_9_ymin
#define ymax mccdiffraction_detector_9_ymax
#define xwidth mccdiffraction_detector_9_xwidth
#define yheight mccdiffraction_detector_9_yheight
#define restore_neutron mccdiffraction_detector_9_restore_neutron
#line 62 "/usr/share/mcstas/2.7/monitors/PSD_monitor.comp"
  DArray2d PSD_N;
  DArray2d PSD_p;
  DArray2d PSD_p2;
#line 85871 "MACS_sample_kidney_box.c"
#undef restore_neutron
#undef yheight
#undef xwidth
#undef ymax
#undef ymin
#undef xmax
#undef xmin
#undef filename
#undef ny
#undef nx
#undef PSD_p2
#undef PSD_p
#undef PSD_N
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

/* User declarations for component 'spec_detector_9' [904]. */
#define mccompcurname  spec_detector_9
#define mccompcurtype  PSD_monitor
#define mccompcurindex 904
#define PSD_N mccspec_detector_9_PSD_N
#define PSD_p mccspec_detector_9_PSD_p
#define PSD_p2 mccspec_detector_9_PSD_p2
#define nx mccspec_detector_9_nx
#define ny mccspec_detector_9_ny
#define filename mccspec_detector_9_filename
#define xmin mccspec_detector_9_xmin
#define xmax mccspec_detector_9_xmax
#define ymin mccspec_detector_9_ymin
#define ymax mccspec_detector_9_ymax
#define xwidth mccspec_detector_9_xwidth
#define yheight mccspec_detector_9_yheight
#define restore_neutron mccspec_detector_9_restore_neutron
#line 62 "/usr/share/mcstas/2.7/monitors/PSD_monitor.comp"
  DArray2d PSD_N;
  DArray2d PSD_p;
  DArray2d PSD_p2;
#line 85910 "MACS_sample_kidney_box.c"
#undef restore_neutron
#undef yheight
#undef xwidth
#undef ymax
#undef ymin
#undef xmax
#undef xmin
#undef filename
#undef ny
#undef nx
#undef PSD_p2
#undef PSD_p
#undef PSD_N
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

/* User declarations for component 'diffraction_detector_10' [905]. */
#define mccompcurname  diffraction_detector_10
#define mccompcurtype  PSD_monitor
#define mccompcurindex 905
#define PSD_N mccdiffraction_detector_10_PSD_N
#define PSD_p mccdiffraction_detector_10_PSD_p
#define PSD_p2 mccdiffraction_detector_10_PSD_p2
#define nx mccdiffraction_detector_10_nx
#define ny mccdiffraction_detector_10_ny
#define filename mccdiffraction_detector_10_filename
#define xmin mccdiffraction_detector_10_xmin
#define xmax mccdiffraction_detector_10_xmax
#define ymin mccdiffraction_detector_10_ymin
#define ymax mccdiffraction_detector_10_ymax
#define xwidth mccdiffraction_detector_10_xwidth
#define yheight mccdiffraction_detector_10_yheight
#define restore_neutron mccdiffraction_detector_10_restore_neutron
#line 62 "/usr/share/mcstas/2.7/monitors/PSD_monitor.comp"
  DArray2d PSD_N;
  DArray2d PSD_p;
  DArray2d PSD_p2;
#line 85949 "MACS_sample_kidney_box.c"
#undef restore_neutron
#undef yheight
#undef xwidth
#undef ymax
#undef ymin
#undef xmax
#undef xmin
#undef filename
#undef ny
#undef nx
#undef PSD_p2
#undef PSD_p
#undef PSD_N
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

/* User declarations for component 'spec_detector_10' [906]. */
#define mccompcurname  spec_detector_10
#define mccompcurtype  PSD_monitor
#define mccompcurindex 906
#define PSD_N mccspec_detector_10_PSD_N
#define PSD_p mccspec_detector_10_PSD_p
#define PSD_p2 mccspec_detector_10_PSD_p2
#define nx mccspec_detector_10_nx
#define ny mccspec_detector_10_ny
#define filename mccspec_detector_10_filename
#define xmin mccspec_detector_10_xmin
#define xmax mccspec_detector_10_xmax
#define ymin mccspec_detector_10_ymin
#define ymax mccspec_detector_10_ymax
#define xwidth mccspec_detector_10_xwidth
#define yheight mccspec_detector_10_yheight
#define restore_neutron mccspec_detector_10_restore_neutron
#line 62 "/usr/share/mcstas/2.7/monitors/PSD_monitor.comp"
  DArray2d PSD_N;
  DArray2d PSD_p;
  DArray2d PSD_p2;
#line 85988 "MACS_sample_kidney_box.c"
#undef restore_neutron
#undef yheight
#undef xwidth
#undef ymax
#undef ymin
#undef xmax
#undef xmin
#undef filename
#undef ny
#undef nx
#undef PSD_p2
#undef PSD_p
#undef PSD_N
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

/* User declarations for component 'diffraction_detector_11' [907]. */
#define mccompcurname  diffraction_detector_11
#define mccompcurtype  PSD_monitor
#define mccompcurindex 907
#define PSD_N mccdiffraction_detector_11_PSD_N
#define PSD_p mccdiffraction_detector_11_PSD_p
#define PSD_p2 mccdiffraction_detector_11_PSD_p2
#define nx mccdiffraction_detector_11_nx
#define ny mccdiffraction_detector_11_ny
#define filename mccdiffraction_detector_11_filename
#define xmin mccdiffraction_detector_11_xmin
#define xmax mccdiffraction_detector_11_xmax
#define ymin mccdiffraction_detector_11_ymin
#define ymax mccdiffraction_detector_11_ymax
#define xwidth mccdiffraction_detector_11_xwidth
#define yheight mccdiffraction_detector_11_yheight
#define restore_neutron mccdiffraction_detector_11_restore_neutron
#line 62 "/usr/share/mcstas/2.7/monitors/PSD_monitor.comp"
  DArray2d PSD_N;
  DArray2d PSD_p;
  DArray2d PSD_p2;
#line 86027 "MACS_sample_kidney_box.c"
#undef restore_neutron
#undef yheight
#undef xwidth
#undef ymax
#undef ymin
#undef xmax
#undef xmin
#undef filename
#undef ny
#undef nx
#undef PSD_p2
#undef PSD_p
#undef PSD_N
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

/* User declarations for component 'spec_detector_11' [908]. */
#define mccompcurname  spec_detector_11
#define mccompcurtype  PSD_monitor
#define mccompcurindex 908
#define PSD_N mccspec_detector_11_PSD_N
#define PSD_p mccspec_detector_11_PSD_p
#define PSD_p2 mccspec_detector_11_PSD_p2
#define nx mccspec_detector_11_nx
#define ny mccspec_detector_11_ny
#define filename mccspec_detector_11_filename
#define xmin mccspec_detector_11_xmin
#define xmax mccspec_detector_11_xmax
#define ymin mccspec_detector_11_ymin
#define ymax mccspec_detector_11_ymax
#define xwidth mccspec_detector_11_xwidth
#define yheight mccspec_detector_11_yheight
#define restore_neutron mccspec_detector_11_restore_neutron
#line 62 "/usr/share/mcstas/2.7/monitors/PSD_monitor.comp"
  DArray2d PSD_N;
  DArray2d PSD_p;
  DArray2d PSD_p2;
#line 86066 "MACS_sample_kidney_box.c"
#undef restore_neutron
#undef yheight
#undef xwidth
#undef ymax
#undef ymin
#undef xmax
#undef xmin
#undef filename
#undef ny
#undef nx
#undef PSD_p2
#undef PSD_p
#undef PSD_N
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

/* User declarations for component 'diffraction_detector_12' [909]. */
#define mccompcurname  diffraction_detector_12
#define mccompcurtype  PSD_monitor
#define mccompcurindex 909
#define PSD_N mccdiffraction_detector_12_PSD_N
#define PSD_p mccdiffraction_detector_12_PSD_p
#define PSD_p2 mccdiffraction_detector_12_PSD_p2
#define nx mccdiffraction_detector_12_nx
#define ny mccdiffraction_detector_12_ny
#define filename mccdiffraction_detector_12_filename
#define xmin mccdiffraction_detector_12_xmin
#define xmax mccdiffraction_detector_12_xmax
#define ymin mccdiffraction_detector_12_ymin
#define ymax mccdiffraction_detector_12_ymax
#define xwidth mccdiffraction_detector_12_xwidth
#define yheight mccdiffraction_detector_12_yheight
#define restore_neutron mccdiffraction_detector_12_restore_neutron
#line 62 "/usr/share/mcstas/2.7/monitors/PSD_monitor.comp"
  DArray2d PSD_N;
  DArray2d PSD_p;
  DArray2d PSD_p2;
#line 86105 "MACS_sample_kidney_box.c"
#undef restore_neutron
#undef yheight
#undef xwidth
#undef ymax
#undef ymin
#undef xmax
#undef xmin
#undef filename
#undef ny
#undef nx
#undef PSD_p2
#undef PSD_p
#undef PSD_N
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

/* User declarations for component 'spec_detector_12' [910]. */
#define mccompcurname  spec_detector_12
#define mccompcurtype  PSD_monitor
#define mccompcurindex 910
#define PSD_N mccspec_detector_12_PSD_N
#define PSD_p mccspec_detector_12_PSD_p
#define PSD_p2 mccspec_detector_12_PSD_p2
#define nx mccspec_detector_12_nx
#define ny mccspec_detector_12_ny
#define filename mccspec_detector_12_filename
#define xmin mccspec_detector_12_xmin
#define xmax mccspec_detector_12_xmax
#define ymin mccspec_detector_12_ymin
#define ymax mccspec_detector_12_ymax
#define xwidth mccspec_detector_12_xwidth
#define yheight mccspec_detector_12_yheight
#define restore_neutron mccspec_detector_12_restore_neutron
#line 62 "/usr/share/mcstas/2.7/monitors/PSD_monitor.comp"
  DArray2d PSD_N;
  DArray2d PSD_p;
  DArray2d PSD_p2;
#line 86144 "MACS_sample_kidney_box.c"
#undef restore_neutron
#undef yheight
#undef xwidth
#undef ymax
#undef ymin
#undef xmax
#undef xmin
#undef filename
#undef ny
#undef nx
#undef PSD_p2
#undef PSD_p
#undef PSD_N
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

/* User declarations for component 'diffraction_detector_13' [911]. */
#define mccompcurname  diffraction_detector_13
#define mccompcurtype  PSD_monitor
#define mccompcurindex 911
#define PSD_N mccdiffraction_detector_13_PSD_N
#define PSD_p mccdiffraction_detector_13_PSD_p
#define PSD_p2 mccdiffraction_detector_13_PSD_p2
#define nx mccdiffraction_detector_13_nx
#define ny mccdiffraction_detector_13_ny
#define filename mccdiffraction_detector_13_filename
#define xmin mccdiffraction_detector_13_xmin
#define xmax mccdiffraction_detector_13_xmax
#define ymin mccdiffraction_detector_13_ymin
#define ymax mccdiffraction_detector_13_ymax
#define xwidth mccdiffraction_detector_13_xwidth
#define yheight mccdiffraction_detector_13_yheight
#define restore_neutron mccdiffraction_detector_13_restore_neutron
#line 62 "/usr/share/mcstas/2.7/monitors/PSD_monitor.comp"
  DArray2d PSD_N;
  DArray2d PSD_p;
  DArray2d PSD_p2;
#line 86183 "MACS_sample_kidney_box.c"
#undef restore_neutron
#undef yheight
#undef xwidth
#undef ymax
#undef ymin
#undef xmax
#undef xmin
#undef filename
#undef ny
#undef nx
#undef PSD_p2
#undef PSD_p
#undef PSD_N
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

/* User declarations for component 'spec_detector_13' [912]. */
#define mccompcurname  spec_detector_13
#define mccompcurtype  PSD_monitor
#define mccompcurindex 912
#define PSD_N mccspec_detector_13_PSD_N
#define PSD_p mccspec_detector_13_PSD_p
#define PSD_p2 mccspec_detector_13_PSD_p2
#define nx mccspec_detector_13_nx
#define ny mccspec_detector_13_ny
#define filename mccspec_detector_13_filename
#define xmin mccspec_detector_13_xmin
#define xmax mccspec_detector_13_xmax
#define ymin mccspec_detector_13_ymin
#define ymax mccspec_detector_13_ymax
#define xwidth mccspec_detector_13_xwidth
#define yheight mccspec_detector_13_yheight
#define restore_neutron mccspec_detector_13_restore_neutron
#line 62 "/usr/share/mcstas/2.7/monitors/PSD_monitor.comp"
  DArray2d PSD_N;
  DArray2d PSD_p;
  DArray2d PSD_p2;
#line 86222 "MACS_sample_kidney_box.c"
#undef restore_neutron
#undef yheight
#undef xwidth
#undef ymax
#undef ymin
#undef xmax
#undef xmin
#undef filename
#undef ny
#undef nx
#undef PSD_p2
#undef PSD_p
#undef PSD_N
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

/* User declarations for component 'diffraction_detector_14' [913]. */
#define mccompcurname  diffraction_detector_14
#define mccompcurtype  PSD_monitor
#define mccompcurindex 913
#define PSD_N mccdiffraction_detector_14_PSD_N
#define PSD_p mccdiffraction_detector_14_PSD_p
#define PSD_p2 mccdiffraction_detector_14_PSD_p2
#define nx mccdiffraction_detector_14_nx
#define ny mccdiffraction_detector_14_ny
#define filename mccdiffraction_detector_14_filename
#define xmin mccdiffraction_detector_14_xmin
#define xmax mccdiffraction_detector_14_xmax
#define ymin mccdiffraction_detector_14_ymin
#define ymax mccdiffraction_detector_14_ymax
#define xwidth mccdiffraction_detector_14_xwidth
#define yheight mccdiffraction_detector_14_yheight
#define restore_neutron mccdiffraction_detector_14_restore_neutron
#line 62 "/usr/share/mcstas/2.7/monitors/PSD_monitor.comp"
  DArray2d PSD_N;
  DArray2d PSD_p;
  DArray2d PSD_p2;
#line 86261 "MACS_sample_kidney_box.c"
#undef restore_neutron
#undef yheight
#undef xwidth
#undef ymax
#undef ymin
#undef xmax
#undef xmin
#undef filename
#undef ny
#undef nx
#undef PSD_p2
#undef PSD_p
#undef PSD_N
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

/* User declarations for component 'spec_detector_14' [914]. */
#define mccompcurname  spec_detector_14
#define mccompcurtype  PSD_monitor
#define mccompcurindex 914
#define PSD_N mccspec_detector_14_PSD_N
#define PSD_p mccspec_detector_14_PSD_p
#define PSD_p2 mccspec_detector_14_PSD_p2
#define nx mccspec_detector_14_nx
#define ny mccspec_detector_14_ny
#define filename mccspec_detector_14_filename
#define xmin mccspec_detector_14_xmin
#define xmax mccspec_detector_14_xmax
#define ymin mccspec_detector_14_ymin
#define ymax mccspec_detector_14_ymax
#define xwidth mccspec_detector_14_xwidth
#define yheight mccspec_detector_14_yheight
#define restore_neutron mccspec_detector_14_restore_neutron
#line 62 "/usr/share/mcstas/2.7/monitors/PSD_monitor.comp"
  DArray2d PSD_N;
  DArray2d PSD_p;
  DArray2d PSD_p2;
#line 86300 "MACS_sample_kidney_box.c"
#undef restore_neutron
#undef yheight
#undef xwidth
#undef ymax
#undef ymin
#undef xmax
#undef xmin
#undef filename
#undef ny
#undef nx
#undef PSD_p2
#undef PSD_p
#undef PSD_N
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

/* User declarations for component 'diffraction_detector_15' [915]. */
#define mccompcurname  diffraction_detector_15
#define mccompcurtype  PSD_monitor
#define mccompcurindex 915
#define PSD_N mccdiffraction_detector_15_PSD_N
#define PSD_p mccdiffraction_detector_15_PSD_p
#define PSD_p2 mccdiffraction_detector_15_PSD_p2
#define nx mccdiffraction_detector_15_nx
#define ny mccdiffraction_detector_15_ny
#define filename mccdiffraction_detector_15_filename
#define xmin mccdiffraction_detector_15_xmin
#define xmax mccdiffraction_detector_15_xmax
#define ymin mccdiffraction_detector_15_ymin
#define ymax mccdiffraction_detector_15_ymax
#define xwidth mccdiffraction_detector_15_xwidth
#define yheight mccdiffraction_detector_15_yheight
#define restore_neutron mccdiffraction_detector_15_restore_neutron
#line 62 "/usr/share/mcstas/2.7/monitors/PSD_monitor.comp"
  DArray2d PSD_N;
  DArray2d PSD_p;
  DArray2d PSD_p2;
#line 86339 "MACS_sample_kidney_box.c"
#undef restore_neutron
#undef yheight
#undef xwidth
#undef ymax
#undef ymin
#undef xmax
#undef xmin
#undef filename
#undef ny
#undef nx
#undef PSD_p2
#undef PSD_p
#undef PSD_N
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

/* User declarations for component 'spec_detector_15' [916]. */
#define mccompcurname  spec_detector_15
#define mccompcurtype  PSD_monitor
#define mccompcurindex 916
#define PSD_N mccspec_detector_15_PSD_N
#define PSD_p mccspec_detector_15_PSD_p
#define PSD_p2 mccspec_detector_15_PSD_p2
#define nx mccspec_detector_15_nx
#define ny mccspec_detector_15_ny
#define filename mccspec_detector_15_filename
#define xmin mccspec_detector_15_xmin
#define xmax mccspec_detector_15_xmax
#define ymin mccspec_detector_15_ymin
#define ymax mccspec_detector_15_ymax
#define xwidth mccspec_detector_15_xwidth
#define yheight mccspec_detector_15_yheight
#define restore_neutron mccspec_detector_15_restore_neutron
#line 62 "/usr/share/mcstas/2.7/monitors/PSD_monitor.comp"
  DArray2d PSD_N;
  DArray2d PSD_p;
  DArray2d PSD_p2;
#line 86378 "MACS_sample_kidney_box.c"
#undef restore_neutron
#undef yheight
#undef xwidth
#undef ymax
#undef ymin
#undef xmax
#undef xmin
#undef filename
#undef ny
#undef nx
#undef PSD_p2
#undef PSD_p
#undef PSD_N
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

/* User declarations for component 'diffraction_detector_16' [917]. */
#define mccompcurname  diffraction_detector_16
#define mccompcurtype  PSD_monitor
#define mccompcurindex 917
#define PSD_N mccdiffraction_detector_16_PSD_N
#define PSD_p mccdiffraction_detector_16_PSD_p
#define PSD_p2 mccdiffraction_detector_16_PSD_p2
#define nx mccdiffraction_detector_16_nx
#define ny mccdiffraction_detector_16_ny
#define filename mccdiffraction_detector_16_filename
#define xmin mccdiffraction_detector_16_xmin
#define xmax mccdiffraction_detector_16_xmax
#define ymin mccdiffraction_detector_16_ymin
#define ymax mccdiffraction_detector_16_ymax
#define xwidth mccdiffraction_detector_16_xwidth
#define yheight mccdiffraction_detector_16_yheight
#define restore_neutron mccdiffraction_detector_16_restore_neutron
#line 62 "/usr/share/mcstas/2.7/monitors/PSD_monitor.comp"
  DArray2d PSD_N;
  DArray2d PSD_p;
  DArray2d PSD_p2;
#line 86417 "MACS_sample_kidney_box.c"
#undef restore_neutron
#undef yheight
#undef xwidth
#undef ymax
#undef ymin
#undef xmax
#undef xmin
#undef filename
#undef ny
#undef nx
#undef PSD_p2
#undef PSD_p
#undef PSD_N
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

/* User declarations for component 'spec_detector_16' [918]. */
#define mccompcurname  spec_detector_16
#define mccompcurtype  PSD_monitor
#define mccompcurindex 918
#define PSD_N mccspec_detector_16_PSD_N
#define PSD_p mccspec_detector_16_PSD_p
#define PSD_p2 mccspec_detector_16_PSD_p2
#define nx mccspec_detector_16_nx
#define ny mccspec_detector_16_ny
#define filename mccspec_detector_16_filename
#define xmin mccspec_detector_16_xmin
#define xmax mccspec_detector_16_xmax
#define ymin mccspec_detector_16_ymin
#define ymax mccspec_detector_16_ymax
#define xwidth mccspec_detector_16_xwidth
#define yheight mccspec_detector_16_yheight
#define restore_neutron mccspec_detector_16_restore_neutron
#line 62 "/usr/share/mcstas/2.7/monitors/PSD_monitor.comp"
  DArray2d PSD_N;
  DArray2d PSD_p;
  DArray2d PSD_p2;
#line 86456 "MACS_sample_kidney_box.c"
#undef restore_neutron
#undef yheight
#undef xwidth
#undef ymax
#undef ymin
#undef xmax
#undef xmin
#undef filename
#undef ny
#undef nx
#undef PSD_p2
#undef PSD_p
#undef PSD_N
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

/* User declarations for component 'diffraction_detector_17' [919]. */
#define mccompcurname  diffraction_detector_17
#define mccompcurtype  PSD_monitor
#define mccompcurindex 919
#define PSD_N mccdiffraction_detector_17_PSD_N
#define PSD_p mccdiffraction_detector_17_PSD_p
#define PSD_p2 mccdiffraction_detector_17_PSD_p2
#define nx mccdiffraction_detector_17_nx
#define ny mccdiffraction_detector_17_ny
#define filename mccdiffraction_detector_17_filename
#define xmin mccdiffraction_detector_17_xmin
#define xmax mccdiffraction_detector_17_xmax
#define ymin mccdiffraction_detector_17_ymin
#define ymax mccdiffraction_detector_17_ymax
#define xwidth mccdiffraction_detector_17_xwidth
#define yheight mccdiffraction_detector_17_yheight
#define restore_neutron mccdiffraction_detector_17_restore_neutron
#line 62 "/usr/share/mcstas/2.7/monitors/PSD_monitor.comp"
  DArray2d PSD_N;
  DArray2d PSD_p;
  DArray2d PSD_p2;
#line 86495 "MACS_sample_kidney_box.c"
#undef restore_neutron
#undef yheight
#undef xwidth
#undef ymax
#undef ymin
#undef xmax
#undef xmin
#undef filename
#undef ny
#undef nx
#undef PSD_p2
#undef PSD_p
#undef PSD_N
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

/* User declarations for component 'spec_detector_17' [920]. */
#define mccompcurname  spec_detector_17
#define mccompcurtype  PSD_monitor
#define mccompcurindex 920
#define PSD_N mccspec_detector_17_PSD_N
#define PSD_p mccspec_detector_17_PSD_p
#define PSD_p2 mccspec_detector_17_PSD_p2
#define nx mccspec_detector_17_nx
#define ny mccspec_detector_17_ny
#define filename mccspec_detector_17_filename
#define xmin mccspec_detector_17_xmin
#define xmax mccspec_detector_17_xmax
#define ymin mccspec_detector_17_ymin
#define ymax mccspec_detector_17_ymax
#define xwidth mccspec_detector_17_xwidth
#define yheight mccspec_detector_17_yheight
#define restore_neutron mccspec_detector_17_restore_neutron
#line 62 "/usr/share/mcstas/2.7/monitors/PSD_monitor.comp"
  DArray2d PSD_N;
  DArray2d PSD_p;
  DArray2d PSD_p2;
#line 86534 "MACS_sample_kidney_box.c"
#undef restore_neutron
#undef yheight
#undef xwidth
#undef ymax
#undef ymin
#undef xmax
#undef xmin
#undef filename
#undef ny
#undef nx
#undef PSD_p2
#undef PSD_p
#undef PSD_N
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

/* User declarations for component 'diffraction_detector_18' [921]. */
#define mccompcurname  diffraction_detector_18
#define mccompcurtype  PSD_monitor
#define mccompcurindex 921
#define PSD_N mccdiffraction_detector_18_PSD_N
#define PSD_p mccdiffraction_detector_18_PSD_p
#define PSD_p2 mccdiffraction_detector_18_PSD_p2
#define nx mccdiffraction_detector_18_nx
#define ny mccdiffraction_detector_18_ny
#define filename mccdiffraction_detector_18_filename
#define xmin mccdiffraction_detector_18_xmin
#define xmax mccdiffraction_detector_18_xmax
#define ymin mccdiffraction_detector_18_ymin
#define ymax mccdiffraction_detector_18_ymax
#define xwidth mccdiffraction_detector_18_xwidth
#define yheight mccdiffraction_detector_18_yheight
#define restore_neutron mccdiffraction_detector_18_restore_neutron
#line 62 "/usr/share/mcstas/2.7/monitors/PSD_monitor.comp"
  DArray2d PSD_N;
  DArray2d PSD_p;
  DArray2d PSD_p2;
#line 86573 "MACS_sample_kidney_box.c"
#undef restore_neutron
#undef yheight
#undef xwidth
#undef ymax
#undef ymin
#undef xmax
#undef xmin
#undef filename
#undef ny
#undef nx
#undef PSD_p2
#undef PSD_p
#undef PSD_N
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

/* User declarations for component 'spec_detector_18' [922]. */
#define mccompcurname  spec_detector_18
#define mccompcurtype  PSD_monitor
#define mccompcurindex 922
#define PSD_N mccspec_detector_18_PSD_N
#define PSD_p mccspec_detector_18_PSD_p
#define PSD_p2 mccspec_detector_18_PSD_p2
#define nx mccspec_detector_18_nx
#define ny mccspec_detector_18_ny
#define filename mccspec_detector_18_filename
#define xmin mccspec_detector_18_xmin
#define xmax mccspec_detector_18_xmax
#define ymin mccspec_detector_18_ymin
#define ymax mccspec_detector_18_ymax
#define xwidth mccspec_detector_18_xwidth
#define yheight mccspec_detector_18_yheight
#define restore_neutron mccspec_detector_18_restore_neutron
#line 62 "/usr/share/mcstas/2.7/monitors/PSD_monitor.comp"
  DArray2d PSD_N;
  DArray2d PSD_p;
  DArray2d PSD_p2;
#line 86612 "MACS_sample_kidney_box.c"
#undef restore_neutron
#undef yheight
#undef xwidth
#undef ymax
#undef ymin
#undef xmax
#undef xmin
#undef filename
#undef ny
#undef nx
#undef PSD_p2
#undef PSD_p
#undef PSD_N
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

/* User declarations for component 'diffraction_detector_19' [923]. */
#define mccompcurname  diffraction_detector_19
#define mccompcurtype  PSD_monitor
#define mccompcurindex 923
#define PSD_N mccdiffraction_detector_19_PSD_N
#define PSD_p mccdiffraction_detector_19_PSD_p
#define PSD_p2 mccdiffraction_detector_19_PSD_p2
#define nx mccdiffraction_detector_19_nx
#define ny mccdiffraction_detector_19_ny
#define filename mccdiffraction_detector_19_filename
#define xmin mccdiffraction_detector_19_xmin
#define xmax mccdiffraction_detector_19_xmax
#define ymin mccdiffraction_detector_19_ymin
#define ymax mccdiffraction_detector_19_ymax
#define xwidth mccdiffraction_detector_19_xwidth
#define yheight mccdiffraction_detector_19_yheight
#define restore_neutron mccdiffraction_detector_19_restore_neutron
#line 62 "/usr/share/mcstas/2.7/monitors/PSD_monitor.comp"
  DArray2d PSD_N;
  DArray2d PSD_p;
  DArray2d PSD_p2;
#line 86651 "MACS_sample_kidney_box.c"
#undef restore_neutron
#undef yheight
#undef xwidth
#undef ymax
#undef ymin
#undef xmax
#undef xmin
#undef filename
#undef ny
#undef nx
#undef PSD_p2
#undef PSD_p
#undef PSD_N
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

/* User declarations for component 'spec_detector_19' [924]. */
#define mccompcurname  spec_detector_19
#define mccompcurtype  PSD_monitor
#define mccompcurindex 924
#define PSD_N mccspec_detector_19_PSD_N
#define PSD_p mccspec_detector_19_PSD_p
#define PSD_p2 mccspec_detector_19_PSD_p2
#define nx mccspec_detector_19_nx
#define ny mccspec_detector_19_ny
#define filename mccspec_detector_19_filename
#define xmin mccspec_detector_19_xmin
#define xmax mccspec_detector_19_xmax
#define ymin mccspec_detector_19_ymin
#define ymax mccspec_detector_19_ymax
#define xwidth mccspec_detector_19_xwidth
#define yheight mccspec_detector_19_yheight
#define restore_neutron mccspec_detector_19_restore_neutron
#line 62 "/usr/share/mcstas/2.7/monitors/PSD_monitor.comp"
  DArray2d PSD_N;
  DArray2d PSD_p;
  DArray2d PSD_p2;
#line 86690 "MACS_sample_kidney_box.c"
#undef restore_neutron
#undef yheight
#undef xwidth
#undef ymax
#undef ymin
#undef xmax
#undef xmin
#undef filename
#undef ny
#undef nx
#undef PSD_p2
#undef PSD_p
#undef PSD_N
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

/* User declarations for component 'spec_detector_history_0' [925]. */
#define mccompcurname  spec_detector_history_0
#define mccompcurtype  extend_monitor
#define mccompcurindex 925
#define nb mccspec_detector_history_0_nb
#define C_N mccspec_detector_history_0_C_N
#define C_p mccspec_detector_history_0_C_p
#define C_p2 mccspec_detector_history_0_C_p2
#define filename mccspec_detector_history_0_filename
#define xmin mccspec_detector_history_0_xmin
#define xmax mccspec_detector_history_0_xmax
#define ymin mccspec_detector_history_0_ymin
#define ymax mccspec_detector_history_0_ymax
#define xwidth mccspec_detector_history_0_xwidth
#define yheight mccspec_detector_history_0_yheight
#define restore_neutron mccspec_detector_history_0_restore_neutron
#line 57 "extend_monitor.comp"
    double C_N[nb];
    double C_p[nb];
    double C_p2[nb];
#line 86728 "MACS_sample_kidney_box.c"
#undef restore_neutron
#undef yheight
#undef xwidth
#undef ymax
#undef ymin
#undef xmax
#undef xmin
#undef filename
#undef C_p2
#undef C_p
#undef C_N
#undef nb
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

/* User declarations for component 'spec_detector_history_1' [926]. */
#define mccompcurname  spec_detector_history_1
#define mccompcurtype  extend_monitor
#define mccompcurindex 926
#define nb mccspec_detector_history_1_nb
#define C_N mccspec_detector_history_1_C_N
#define C_p mccspec_detector_history_1_C_p
#define C_p2 mccspec_detector_history_1_C_p2
#define filename mccspec_detector_history_1_filename
#define xmin mccspec_detector_history_1_xmin
#define xmax mccspec_detector_history_1_xmax
#define ymin mccspec_detector_history_1_ymin
#define ymax mccspec_detector_history_1_ymax
#define xwidth mccspec_detector_history_1_xwidth
#define yheight mccspec_detector_history_1_yheight
#define restore_neutron mccspec_detector_history_1_restore_neutron
#line 57 "extend_monitor.comp"
    double C_N[nb];
    double C_p[nb];
    double C_p2[nb];
#line 86765 "MACS_sample_kidney_box.c"
#undef restore_neutron
#undef yheight
#undef xwidth
#undef ymax
#undef ymin
#undef xmax
#undef xmin
#undef filename
#undef C_p2
#undef C_p
#undef C_N
#undef nb
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

/* User declarations for component 'spec_detector_history_2' [927]. */
#define mccompcurname  spec_detector_history_2
#define mccompcurtype  extend_monitor
#define mccompcurindex 927
#define nb mccspec_detector_history_2_nb
#define C_N mccspec_detector_history_2_C_N
#define C_p mccspec_detector_history_2_C_p
#define C_p2 mccspec_detector_history_2_C_p2
#define filename mccspec_detector_history_2_filename
#define xmin mccspec_detector_history_2_xmin
#define xmax mccspec_detector_history_2_xmax
#define ymin mccspec_detector_history_2_ymin
#define ymax mccspec_detector_history_2_ymax
#define xwidth mccspec_detector_history_2_xwidth
#define yheight mccspec_detector_history_2_yheight
#define restore_neutron mccspec_detector_history_2_restore_neutron
#line 57 "extend_monitor.comp"
    double C_N[nb];
    double C_p[nb];
    double C_p2[nb];
#line 86802 "MACS_sample_kidney_box.c"
#undef restore_neutron
#undef yheight
#undef xwidth
#undef ymax
#undef ymin
#undef xmax
#undef xmin
#undef filename
#undef C_p2
#undef C_p
#undef C_N
#undef nb
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

/* User declarations for component 'spec_detector_history_3' [928]. */
#define mccompcurname  spec_detector_history_3
#define mccompcurtype  extend_monitor
#define mccompcurindex 928
#define nb mccspec_detector_history_3_nb
#define C_N mccspec_detector_history_3_C_N
#define C_p mccspec_detector_history_3_C_p
#define C_p2 mccspec_detector_history_3_C_p2
#define filename mccspec_detector_history_3_filename
#define xmin mccspec_detector_history_3_xmin
#define xmax mccspec_detector_history_3_xmax
#define ymin mccspec_detector_history_3_ymin
#define ymax mccspec_detector_history_3_ymax
#define xwidth mccspec_detector_history_3_xwidth
#define yheight mccspec_detector_history_3_yheight
#define restore_neutron mccspec_detector_history_3_restore_neutron
#line 57 "extend_monitor.comp"
    double C_N[nb];
    double C_p[nb];
    double C_p2[nb];
#line 86839 "MACS_sample_kidney_box.c"
#undef restore_neutron
#undef yheight
#undef xwidth
#undef ymax
#undef ymin
#undef xmax
#undef xmin
#undef filename
#undef C_p2
#undef C_p
#undef C_N
#undef nb
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

/* User declarations for component 'spec_detector_history_4' [929]. */
#define mccompcurname  spec_detector_history_4
#define mccompcurtype  extend_monitor
#define mccompcurindex 929
#define nb mccspec_detector_history_4_nb
#define C_N mccspec_detector_history_4_C_N
#define C_p mccspec_detector_history_4_C_p
#define C_p2 mccspec_detector_history_4_C_p2
#define filename mccspec_detector_history_4_filename
#define xmin mccspec_detector_history_4_xmin
#define xmax mccspec_detector_history_4_xmax
#define ymin mccspec_detector_history_4_ymin
#define ymax mccspec_detector_history_4_ymax
#define xwidth mccspec_detector_history_4_xwidth
#define yheight mccspec_detector_history_4_yheight
#define restore_neutron mccspec_detector_history_4_restore_neutron
#line 57 "extend_monitor.comp"
    double C_N[nb];
    double C_p[nb];
    double C_p2[nb];
#line 86876 "MACS_sample_kidney_box.c"
#undef restore_neutron
#undef yheight
#undef xwidth
#undef ymax
#undef ymin
#undef xmax
#undef xmin
#undef filename
#undef C_p2
#undef C_p
#undef C_N
#undef nb
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

/* User declarations for component 'spec_detector_history_5' [930]. */
#define mccompcurname  spec_detector_history_5
#define mccompcurtype  extend_monitor
#define mccompcurindex 930
#define nb mccspec_detector_history_5_nb
#define C_N mccspec_detector_history_5_C_N
#define C_p mccspec_detector_history_5_C_p
#define C_p2 mccspec_detector_history_5_C_p2
#define filename mccspec_detector_history_5_filename
#define xmin mccspec_detector_history_5_xmin
#define xmax mccspec_detector_history_5_xmax
#define ymin mccspec_detector_history_5_ymin
#define ymax mccspec_detector_history_5_ymax
#define xwidth mccspec_detector_history_5_xwidth
#define yheight mccspec_detector_history_5_yheight
#define restore_neutron mccspec_detector_history_5_restore_neutron
#line 57 "extend_monitor.comp"
    double C_N[nb];
    double C_p[nb];
    double C_p2[nb];
#line 86913 "MACS_sample_kidney_box.c"
#undef restore_neutron
#undef yheight
#undef xwidth
#undef ymax
#undef ymin
#undef xmax
#undef xmin
#undef filename
#undef C_p2
#undef C_p
#undef C_N
#undef nb
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

/* User declarations for component 'spec_detector_history_6' [931]. */
#define mccompcurname  spec_detector_history_6
#define mccompcurtype  extend_monitor
#define mccompcurindex 931
#define nb mccspec_detector_history_6_nb
#define C_N mccspec_detector_history_6_C_N
#define C_p mccspec_detector_history_6_C_p
#define C_p2 mccspec_detector_history_6_C_p2
#define filename mccspec_detector_history_6_filename
#define xmin mccspec_detector_history_6_xmin
#define xmax mccspec_detector_history_6_xmax
#define ymin mccspec_detector_history_6_ymin
#define ymax mccspec_detector_history_6_ymax
#define xwidth mccspec_detector_history_6_xwidth
#define yheight mccspec_detector_history_6_yheight
#define restore_neutron mccspec_detector_history_6_restore_neutron
#line 57 "extend_monitor.comp"
    double C_N[nb];
    double C_p[nb];
    double C_p2[nb];
#line 86950 "MACS_sample_kidney_box.c"
#undef restore_neutron
#undef yheight
#undef xwidth
#undef ymax
#undef ymin
#undef xmax
#undef xmin
#undef filename
#undef C_p2
#undef C_p
#undef C_N
#undef nb
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

/* User declarations for component 'spec_detector_history_7' [932]. */
#define mccompcurname  spec_detector_history_7
#define mccompcurtype  extend_monitor
#define mccompcurindex 932
#define nb mccspec_detector_history_7_nb
#define C_N mccspec_detector_history_7_C_N
#define C_p mccspec_detector_history_7_C_p
#define C_p2 mccspec_detector_history_7_C_p2
#define filename mccspec_detector_history_7_filename
#define xmin mccspec_detector_history_7_xmin
#define xmax mccspec_detector_history_7_xmax
#define ymin mccspec_detector_history_7_ymin
#define ymax mccspec_detector_history_7_ymax
#define xwidth mccspec_detector_history_7_xwidth
#define yheight mccspec_detector_history_7_yheight
#define restore_neutron mccspec_detector_history_7_restore_neutron
#line 57 "extend_monitor.comp"
    double C_N[nb];
    double C_p[nb];
    double C_p2[nb];
#line 86987 "MACS_sample_kidney_box.c"
#undef restore_neutron
#undef yheight
#undef xwidth
#undef ymax
#undef ymin
#undef xmax
#undef xmin
#undef filename
#undef C_p2
#undef C_p
#undef C_N
#undef nb
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

/* User declarations for component 'spec_detector_history_8' [933]. */
#define mccompcurname  spec_detector_history_8
#define mccompcurtype  extend_monitor
#define mccompcurindex 933
#define nb mccspec_detector_history_8_nb
#define C_N mccspec_detector_history_8_C_N
#define C_p mccspec_detector_history_8_C_p
#define C_p2 mccspec_detector_history_8_C_p2
#define filename mccspec_detector_history_8_filename
#define xmin mccspec_detector_history_8_xmin
#define xmax mccspec_detector_history_8_xmax
#define ymin mccspec_detector_history_8_ymin
#define ymax mccspec_detector_history_8_ymax
#define xwidth mccspec_detector_history_8_xwidth
#define yheight mccspec_detector_history_8_yheight
#define restore_neutron mccspec_detector_history_8_restore_neutron
#line 57 "extend_monitor.comp"
    double C_N[nb];
    double C_p[nb];
    double C_p2[nb];
#line 87024 "MACS_sample_kidney_box.c"
#undef restore_neutron
#undef yheight
#undef xwidth
#undef ymax
#undef ymin
#undef xmax
#undef xmin
#undef filename
#undef C_p2
#undef C_p
#undef C_N
#undef nb
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

/* User declarations for component 'spec_detector_history_9' [934]. */
#define mccompcurname  spec_detector_history_9
#define mccompcurtype  extend_monitor
#define mccompcurindex 934
#define nb mccspec_detector_history_9_nb
#define C_N mccspec_detector_history_9_C_N
#define C_p mccspec_detector_history_9_C_p
#define C_p2 mccspec_detector_history_9_C_p2
#define filename mccspec_detector_history_9_filename
#define xmin mccspec_detector_history_9_xmin
#define xmax mccspec_detector_history_9_xmax
#define ymin mccspec_detector_history_9_ymin
#define ymax mccspec_detector_history_9_ymax
#define xwidth mccspec_detector_history_9_xwidth
#define yheight mccspec_detector_history_9_yheight
#define restore_neutron mccspec_detector_history_9_restore_neutron
#line 57 "extend_monitor.comp"
    double C_N[nb];
    double C_p[nb];
    double C_p2[nb];
#line 87061 "MACS_sample_kidney_box.c"
#undef restore_neutron
#undef yheight
#undef xwidth
#undef ymax
#undef ymin
#undef xmax
#undef xmin
#undef filename
#undef C_p2
#undef C_p
#undef C_N
#undef nb
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

/* User declarations for component 'spec_detector_history_10' [935]. */
#define mccompcurname  spec_detector_history_10
#define mccompcurtype  extend_monitor
#define mccompcurindex 935
#define nb mccspec_detector_history_10_nb
#define C_N mccspec_detector_history_10_C_N
#define C_p mccspec_detector_history_10_C_p
#define C_p2 mccspec_detector_history_10_C_p2
#define filename mccspec_detector_history_10_filename
#define xmin mccspec_detector_history_10_xmin
#define xmax mccspec_detector_history_10_xmax
#define ymin mccspec_detector_history_10_ymin
#define ymax mccspec_detector_history_10_ymax
#define xwidth mccspec_detector_history_10_xwidth
#define yheight mccspec_detector_history_10_yheight
#define restore_neutron mccspec_detector_history_10_restore_neutron
#line 57 "extend_monitor.comp"
    double C_N[nb];
    double C_p[nb];
    double C_p2[nb];
#line 87098 "MACS_sample_kidney_box.c"
#undef restore_neutron
#undef yheight
#undef xwidth
#undef ymax
#undef ymin
#undef xmax
#undef xmin
#undef filename
#undef C_p2
#undef C_p
#undef C_N
#undef nb
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

/* User declarations for component 'spec_detector_history_11' [936]. */
#define mccompcurname  spec_detector_history_11
#define mccompcurtype  extend_monitor
#define mccompcurindex 936
#define nb mccspec_detector_history_11_nb
#define C_N mccspec_detector_history_11_C_N
#define C_p mccspec_detector_history_11_C_p
#define C_p2 mccspec_detector_history_11_C_p2
#define filename mccspec_detector_history_11_filename
#define xmin mccspec_detector_history_11_xmin
#define xmax mccspec_detector_history_11_xmax
#define ymin mccspec_detector_history_11_ymin
#define ymax mccspec_detector_history_11_ymax
#define xwidth mccspec_detector_history_11_xwidth
#define yheight mccspec_detector_history_11_yheight
#define restore_neutron mccspec_detector_history_11_restore_neutron
#line 57 "extend_monitor.comp"
    double C_N[nb];
    double C_p[nb];
    double C_p2[nb];
#line 87135 "MACS_sample_kidney_box.c"
#undef restore_neutron
#undef yheight
#undef xwidth
#undef ymax
#undef ymin
#undef xmax
#undef xmin
#undef filename
#undef C_p2
#undef C_p
#undef C_N
#undef nb
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

/* User declarations for component 'spec_detector_history_12' [937]. */
#define mccompcurname  spec_detector_history_12
#define mccompcurtype  extend_monitor
#define mccompcurindex 937
#define nb mccspec_detector_history_12_nb
#define C_N mccspec_detector_history_12_C_N
#define C_p mccspec_detector_history_12_C_p
#define C_p2 mccspec_detector_history_12_C_p2
#define filename mccspec_detector_history_12_filename
#define xmin mccspec_detector_history_12_xmin
#define xmax mccspec_detector_history_12_xmax
#define ymin mccspec_detector_history_12_ymin
#define ymax mccspec_detector_history_12_ymax
#define xwidth mccspec_detector_history_12_xwidth
#define yheight mccspec_detector_history_12_yheight
#define restore_neutron mccspec_detector_history_12_restore_neutron
#line 57 "extend_monitor.comp"
    double C_N[nb];
    double C_p[nb];
    double C_p2[nb];
#line 87172 "MACS_sample_kidney_box.c"
#undef restore_neutron
#undef yheight
#undef xwidth
#undef ymax
#undef ymin
#undef xmax
#undef xmin
#undef filename
#undef C_p2
#undef C_p
#undef C_N
#undef nb
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

/* User declarations for component 'spec_detector_history_13' [938]. */
#define mccompcurname  spec_detector_history_13
#define mccompcurtype  extend_monitor
#define mccompcurindex 938
#define nb mccspec_detector_history_13_nb
#define C_N mccspec_detector_history_13_C_N
#define C_p mccspec_detector_history_13_C_p
#define C_p2 mccspec_detector_history_13_C_p2
#define filename mccspec_detector_history_13_filename
#define xmin mccspec_detector_history_13_xmin
#define xmax mccspec_detector_history_13_xmax
#define ymin mccspec_detector_history_13_ymin
#define ymax mccspec_detector_history_13_ymax
#define xwidth mccspec_detector_history_13_xwidth
#define yheight mccspec_detector_history_13_yheight
#define restore_neutron mccspec_detector_history_13_restore_neutron
#line 57 "extend_monitor.comp"
    double C_N[nb];
    double C_p[nb];
    double C_p2[nb];
#line 87209 "MACS_sample_kidney_box.c"
#undef restore_neutron
#undef yheight
#undef xwidth
#undef ymax
#undef ymin
#undef xmax
#undef xmin
#undef filename
#undef C_p2
#undef C_p
#undef C_N
#undef nb
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

/* User declarations for component 'spec_detector_history_14' [939]. */
#define mccompcurname  spec_detector_history_14
#define mccompcurtype  extend_monitor
#define mccompcurindex 939
#define nb mccspec_detector_history_14_nb
#define C_N mccspec_detector_history_14_C_N
#define C_p mccspec_detector_history_14_C_p
#define C_p2 mccspec_detector_history_14_C_p2
#define filename mccspec_detector_history_14_filename
#define xmin mccspec_detector_history_14_xmin
#define xmax mccspec_detector_history_14_xmax
#define ymin mccspec_detector_history_14_ymin
#define ymax mccspec_detector_history_14_ymax
#define xwidth mccspec_detector_history_14_xwidth
#define yheight mccspec_detector_history_14_yheight
#define restore_neutron mccspec_detector_history_14_restore_neutron
#line 57 "extend_monitor.comp"
    double C_N[nb];
    double C_p[nb];
    double C_p2[nb];
#line 87246 "MACS_sample_kidney_box.c"
#undef restore_neutron
#undef yheight
#undef xwidth
#undef ymax
#undef ymin
#undef xmax
#undef xmin
#undef filename
#undef C_p2
#undef C_p
#undef C_N
#undef nb
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

/* User declarations for component 'spec_detector_history_15' [940]. */
#define mccompcurname  spec_detector_history_15
#define mccompcurtype  extend_monitor
#define mccompcurindex 940
#define nb mccspec_detector_history_15_nb
#define C_N mccspec_detector_history_15_C_N
#define C_p mccspec_detector_history_15_C_p
#define C_p2 mccspec_detector_history_15_C_p2
#define filename mccspec_detector_history_15_filename
#define xmin mccspec_detector_history_15_xmin
#define xmax mccspec_detector_history_15_xmax
#define ymin mccspec_detector_history_15_ymin
#define ymax mccspec_detector_history_15_ymax
#define xwidth mccspec_detector_history_15_xwidth
#define yheight mccspec_detector_history_15_yheight
#define restore_neutron mccspec_detector_history_15_restore_neutron
#line 57 "extend_monitor.comp"
    double C_N[nb];
    double C_p[nb];
    double C_p2[nb];
#line 87283 "MACS_sample_kidney_box.c"
#undef restore_neutron
#undef yheight
#undef xwidth
#undef ymax
#undef ymin
#undef xmax
#undef xmin
#undef filename
#undef C_p2
#undef C_p
#undef C_N
#undef nb
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

/* User declarations for component 'spec_detector_history_16' [941]. */
#define mccompcurname  spec_detector_history_16
#define mccompcurtype  extend_monitor
#define mccompcurindex 941
#define nb mccspec_detector_history_16_nb
#define C_N mccspec_detector_history_16_C_N
#define C_p mccspec_detector_history_16_C_p
#define C_p2 mccspec_detector_history_16_C_p2
#define filename mccspec_detector_history_16_filename
#define xmin mccspec_detector_history_16_xmin
#define xmax mccspec_detector_history_16_xmax
#define ymin mccspec_detector_history_16_ymin
#define ymax mccspec_detector_history_16_ymax
#define xwidth mccspec_detector_history_16_xwidth
#define yheight mccspec_detector_history_16_yheight
#define restore_neutron mccspec_detector_history_16_restore_neutron
#line 57 "extend_monitor.comp"
    double C_N[nb];
    double C_p[nb];
    double C_p2[nb];
#line 87320 "MACS_sample_kidney_box.c"
#undef restore_neutron
#undef yheight
#undef xwidth
#undef ymax
#undef ymin
#undef xmax
#undef xmin
#undef filename
#undef C_p2
#undef C_p
#undef C_N
#undef nb
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

/* User declarations for component 'spec_detector_history_17' [942]. */
#define mccompcurname  spec_detector_history_17
#define mccompcurtype  extend_monitor
#define mccompcurindex 942
#define nb mccspec_detector_history_17_nb
#define C_N mccspec_detector_history_17_C_N
#define C_p mccspec_detector_history_17_C_p
#define C_p2 mccspec_detector_history_17_C_p2
#define filename mccspec_detector_history_17_filename
#define xmin mccspec_detector_history_17_xmin
#define xmax mccspec_detector_history_17_xmax
#define ymin mccspec_detector_history_17_ymin
#define ymax mccspec_detector_history_17_ymax
#define xwidth mccspec_detector_history_17_xwidth
#define yheight mccspec_detector_history_17_yheight
#define restore_neutron mccspec_detector_history_17_restore_neutron
#line 57 "extend_monitor.comp"
    double C_N[nb];
    double C_p[nb];
    double C_p2[nb];
#line 87357 "MACS_sample_kidney_box.c"
#undef restore_neutron
#undef yheight
#undef xwidth
#undef ymax
#undef ymin
#undef xmax
#undef xmin
#undef filename
#undef C_p2
#undef C_p
#undef C_N
#undef nb
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

/* User declarations for component 'spec_detector_history_18' [943]. */
#define mccompcurname  spec_detector_history_18
#define mccompcurtype  extend_monitor
#define mccompcurindex 943
#define nb mccspec_detector_history_18_nb
#define C_N mccspec_detector_history_18_C_N
#define C_p mccspec_detector_history_18_C_p
#define C_p2 mccspec_detector_history_18_C_p2
#define filename mccspec_detector_history_18_filename
#define xmin mccspec_detector_history_18_xmin
#define xmax mccspec_detector_history_18_xmax
#define ymin mccspec_detector_history_18_ymin
#define ymax mccspec_detector_history_18_ymax
#define xwidth mccspec_detector_history_18_xwidth
#define yheight mccspec_detector_history_18_yheight
#define restore_neutron mccspec_detector_history_18_restore_neutron
#line 57 "extend_monitor.comp"
    double C_N[nb];
    double C_p[nb];
    double C_p2[nb];
#line 87394 "MACS_sample_kidney_box.c"
#undef restore_neutron
#undef yheight
#undef xwidth
#undef ymax
#undef ymin
#undef xmax
#undef xmin
#undef filename
#undef C_p2
#undef C_p
#undef C_N
#undef nb
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

/* User declarations for component 'spec_detector_history_19' [944]. */
#define mccompcurname  spec_detector_history_19
#define mccompcurtype  extend_monitor
#define mccompcurindex 944
#define nb mccspec_detector_history_19_nb
#define C_N mccspec_detector_history_19_C_N
#define C_p mccspec_detector_history_19_C_p
#define C_p2 mccspec_detector_history_19_C_p2
#define filename mccspec_detector_history_19_filename
#define xmin mccspec_detector_history_19_xmin
#define xmax mccspec_detector_history_19_xmax
#define ymin mccspec_detector_history_19_ymin
#define ymax mccspec_detector_history_19_ymax
#define xwidth mccspec_detector_history_19_xwidth
#define yheight mccspec_detector_history_19_yheight
#define restore_neutron mccspec_detector_history_19_restore_neutron
#line 57 "extend_monitor.comp"
    double C_N[nb];
    double C_p[nb];
    double C_p2[nb];
#line 87431 "MACS_sample_kidney_box.c"
#undef restore_neutron
#undef yheight
#undef xwidth
#undef ymax
#undef ymin
#undef xmax
#undef xmin
#undef filename
#undef C_p2
#undef C_p
#undef C_N
#undef nb
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

Coords mcposaAl_incoherent, mcposrAl_incoherent;
Rotation mcrotaAl_incoherent, mcrotrAl_incoherent;
Coords mcposaAl_powder, mcposrAl_powder;
Rotation mcrotaAl_powder, mcrotrAl_powder;
Coords mcposaAl, mcposrAl;
Rotation mcrotaAl, mcrotrAl;
Coords mcposaTiO2_incoherent, mcposrTiO2_incoherent;
Rotation mcrotaTiO2_incoherent, mcrotrTiO2_incoherent;
Coords mcposaTiO2_single_crystal, mcposrTiO2_single_crystal;
Rotation mcrotaTiO2_single_crystal, mcrotrTiO2_single_crystal;
Coords mcposaTiO2, mcposrTiO2;
Rotation mcrotaTiO2, mcrotrTiO2;
Coords mcposaTiO2_poly_incoherent, mcposrTiO2_poly_incoherent;
Rotation mcrotaTiO2_poly_incoherent, mcrotrTiO2_poly_incoherent;
Coords mcposaTiO2_poly, mcposrTiO2_poly;
Rotation mcrotaTiO2_poly, mcrotrTiO2_poly;
Coords mcposaAl_incoherent_B, mcposrAl_incoherent_B;
Rotation mcrotaAl_incoherent_B, mcrotrAl_incoherent_B;
Coords mcposaAl_powder_B, mcposrAl_powder_B;
Rotation mcrotaAl_powder_B, mcrotrAl_powder_B;
Coords mcposaAl_B, mcposrAl_B;
Rotation mcrotaAl_B, mcrotrAl_B;
Coords mcposaArm0, mcposrArm0;
Rotation mcrotaArm0, mcrotrArm0;
Coords mcposaGuide_end, mcposrGuide_end;
Rotation mcrotaGuide_end, mcrotrGuide_end;
Coords mcposamain_slit, mcposrmain_slit;
Rotation mcrotamain_slit, mcrotrmain_slit;
Coords mcposatarget, mcposrtarget;
Rotation mcrotatarget, mcrotrtarget;
Coords mcposacryostat_center, mcposrcryostat_center;
Rotation mcrotacryostat_center, mcrotrcryostat_center;
Coords mcposadrum_center, mcposrdrum_center;
Rotation mcrotadrum_center, mcrotrdrum_center;
Coords mcposacrystal_assembly, mcposrcrystal_assembly;
Rotation mcrotacrystal_assembly, mcrotrcrystal_assembly;
Coords mcposacrystal_axis, mcposrcrystal_axis;
Rotation mcrotacrystal_axis, mcrotrcrystal_axis;
Coords mcposasample, mcposrsample;
Rotation mcrotasample, mcrotrsample;
Coords mcposasample_plate, mcposrsample_plate;
Rotation mcrotasample_plate, mcrotrsample_plate;
Coords mcposasample_plate_rod, mcposrsample_plate_rod;
Rotation mcrotasample_plate_rod, mcrotrsample_plate_rod;
Coords mcposasample_base, mcposrsample_base;
Rotation mcrotasample_base, mcrotrsample_base;
Coords mcposasample_base_gap, mcposrsample_base_gap;
Rotation mcrotasample_base_gap, mcrotrsample_base_gap;
Coords mcposacryostat_mountin_plate, mcposrcryostat_mountin_plate;
Rotation mcrotacryostat_mountin_plate, mcrotrcryostat_mountin_plate;
Coords mcposacryostat_drum_walls, mcposrcryostat_drum_walls;
Rotation mcrotacryostat_drum_walls, mcrotrcryostat_drum_walls;
Coords mcposacryostat_drum_vacuum, mcposrcryostat_drum_vacuum;
Rotation mcrotacryostat_drum_vacuum, mcrotrcryostat_drum_vacuum;
Coords mcposaouter_cryostat_wall, mcposrouter_cryostat_wall;
Rotation mcrotaouter_cryostat_wall, mcrotrouter_cryostat_wall;
Coords mcposaouter_cryostat_vacuum, mcposrouter_cryostat_vacuum;
Rotation mcrotaouter_cryostat_vacuum, mcrotrouter_cryostat_vacuum;
Coords mcposainner_cryostat_wall, mcposrinner_cryostat_wall;
Rotation mcrotainner_cryostat_wall, mcrotrinner_cryostat_wall;
Coords mcposainner_cryostat_vacuum, mcposrinner_cryostat_vacuum;
Rotation mcrotainner_cryostat_vacuum, mcrotrinner_cryostat_vacuum;
Coords mcposasample_stick_walls, mcposrsample_stick_walls;
Rotation mcrotasample_stick_walls, mcrotrsample_stick_walls;
Coords mcposasample_stick_vacuum, mcposrsample_stick_vacuum;
Rotation mcrotasample_stick_vacuum, mcrotrsample_stick_vacuum;
Coords mcposasample_rod_bottom, mcposrsample_rod_bottom;
Rotation mcrotasample_rod_bottom, mcrotrsample_rod_bottom;
Coords mcposasample_rod, mcposrsample_rod;
Rotation mcrotasample_rod, mcrotrsample_rod;
Coords mcposasample_rod_collar_1, mcposrsample_rod_collar_1;
Rotation mcrotasample_rod_collar_1, mcrotrsample_rod_collar_1;
Coords mcposasample_rod_collar_2, mcposrsample_rod_collar_2;
Rotation mcrotasample_rod_collar_2, mcrotrsample_rod_collar_2;
Coords mcposasample_rod_collar_3, mcposrsample_rod_collar_3;
Rotation mcrotasample_rod_collar_3, mcrotrsample_rod_collar_3;
Coords mcposasample_rod_collar_4, mcposrsample_rod_collar_4;
Rotation mcrotasample_rod_collar_4, mcrotrsample_rod_collar_4;
Coords mcposasample_rod_collar_1_vacuum, mcposrsample_rod_collar_1_vacuum;
Rotation mcrotasample_rod_collar_1_vacuum, mcrotrsample_rod_collar_1_vacuum;
Coords mcposasample_rod_collar_2_vacuum, mcposrsample_rod_collar_2_vacuum;
Rotation mcrotasample_rod_collar_2_vacuum, mcrotrsample_rod_collar_2_vacuum;
Coords mcposasample_rod_collar_3_vacuum, mcposrsample_rod_collar_3_vacuum;
Rotation mcrotasample_rod_collar_3_vacuum, mcrotrsample_rod_collar_3_vacuum;
Coords mcposasample_rod_collar_4_vacuum, mcposrsample_rod_collar_4_vacuum;
Rotation mcrotasample_rod_collar_4_vacuum, mcrotrsample_rod_collar_4_vacuum;
Coords mcposaresolution_sample_exit, mcposrresolution_sample_exit;
Rotation mcrotaresolution_sample_exit, mcrotrresolution_sample_exit;
Coords mcposasample_cryostat, mcposrsample_cryostat;
Rotation mcrotasample_cryostat, mcrotrsample_cryostat;
Coords mcposaResolution_sample, mcposrResolution_sample;
Rotation mcrotaResolution_sample, mcrotrResolution_sample;
Coords mcposapost_sample_beamstop, mcposrpost_sample_beamstop;
Rotation mcrotapost_sample_beamstop, mcrotrpost_sample_beamstop;
Coords mcposakidney_master, mcposrkidney_master;
Rotation mcrotakidney_master, mcrotrkidney_master;
Coords mcposakidney_channel_0, mcposrkidney_channel_0;
Rotation mcrotakidney_channel_0, mcrotrkidney_channel_0;
Coords mcposakidney_channel_1, mcposrkidney_channel_1;
Rotation mcrotakidney_channel_1, mcrotrkidney_channel_1;
Coords mcposakidney_channel_2, mcposrkidney_channel_2;
Rotation mcrotakidney_channel_2, mcrotrkidney_channel_2;
Coords mcposakidney_channel_3, mcposrkidney_channel_3;
Rotation mcrotakidney_channel_3, mcrotrkidney_channel_3;
Coords mcposakidney_channel_4, mcposrkidney_channel_4;
Rotation mcrotakidney_channel_4, mcrotrkidney_channel_4;
Coords mcposakidney_channel_5, mcposrkidney_channel_5;
Rotation mcrotakidney_channel_5, mcrotrkidney_channel_5;
Coords mcposakidney_channel_6, mcposrkidney_channel_6;
Rotation mcrotakidney_channel_6, mcrotrkidney_channel_6;
Coords mcposakidney_channel_7, mcposrkidney_channel_7;
Rotation mcrotakidney_channel_7, mcrotrkidney_channel_7;
Coords mcposakidney_channel_8, mcposrkidney_channel_8;
Rotation mcrotakidney_channel_8, mcrotrkidney_channel_8;
Coords mcposakidney_channel_9, mcposrkidney_channel_9;
Rotation mcrotakidney_channel_9, mcrotrkidney_channel_9;
Coords mcposakidney_channel_10, mcposrkidney_channel_10;
Rotation mcrotakidney_channel_10, mcrotrkidney_channel_10;
Coords mcposakidney_channel_11, mcposrkidney_channel_11;
Rotation mcrotakidney_channel_11, mcrotrkidney_channel_11;
Coords mcposakidney_channel_12, mcposrkidney_channel_12;
Rotation mcrotakidney_channel_12, mcrotrkidney_channel_12;
Coords mcposakidney_channel_13, mcposrkidney_channel_13;
Rotation mcrotakidney_channel_13, mcrotrkidney_channel_13;
Coords mcposakidney_channel_14, mcposrkidney_channel_14;
Rotation mcrotakidney_channel_14, mcrotrkidney_channel_14;
Coords mcposakidney_channel_15, mcposrkidney_channel_15;
Rotation mcrotakidney_channel_15, mcrotrkidney_channel_15;
Coords mcposakidney_channel_16, mcposrkidney_channel_16;
Rotation mcrotakidney_channel_16, mcrotrkidney_channel_16;
Coords mcposakidney_channel_17, mcposrkidney_channel_17;
Rotation mcrotakidney_channel_17, mcrotrkidney_channel_17;
Coords mcposakidney_channel_18, mcposrkidney_channel_18;
Rotation mcrotakidney_channel_18, mcrotrkidney_channel_18;
Coords mcposakidney_channel_19, mcposrkidney_channel_19;
Rotation mcrotakidney_channel_19, mcrotrkidney_channel_19;
Coords mcposachannel_0_filter, mcposrchannel_0_filter;
Rotation mcrotachannel_0_filter, mcrotrchannel_0_filter;
Coords mcposachannel_1_filter, mcposrchannel_1_filter;
Rotation mcrotachannel_1_filter, mcrotrchannel_1_filter;
Coords mcposachannel_2_filter, mcposrchannel_2_filter;
Rotation mcrotachannel_2_filter, mcrotrchannel_2_filter;
Coords mcposachannel_3_filter, mcposrchannel_3_filter;
Rotation mcrotachannel_3_filter, mcrotrchannel_3_filter;
Coords mcposachannel_4_filter, mcposrchannel_4_filter;
Rotation mcrotachannel_4_filter, mcrotrchannel_4_filter;
Coords mcposachannel_5_filter, mcposrchannel_5_filter;
Rotation mcrotachannel_5_filter, mcrotrchannel_5_filter;
Coords mcposachannel_6_filter, mcposrchannel_6_filter;
Rotation mcrotachannel_6_filter, mcrotrchannel_6_filter;
Coords mcposachannel_7_filter, mcposrchannel_7_filter;
Rotation mcrotachannel_7_filter, mcrotrchannel_7_filter;
Coords mcposachannel_8_filter, mcposrchannel_8_filter;
Rotation mcrotachannel_8_filter, mcrotrchannel_8_filter;
Coords mcposachannel_9_filter, mcposrchannel_9_filter;
Rotation mcrotachannel_9_filter, mcrotrchannel_9_filter;
Coords mcposachannel_10_filter, mcposrchannel_10_filter;
Rotation mcrotachannel_10_filter, mcrotrchannel_10_filter;
Coords mcposachannel_11_filter, mcposrchannel_11_filter;
Rotation mcrotachannel_11_filter, mcrotrchannel_11_filter;
Coords mcposachannel_12_filter, mcposrchannel_12_filter;
Rotation mcrotachannel_12_filter, mcrotrchannel_12_filter;
Coords mcposachannel_13_filter, mcposrchannel_13_filter;
Rotation mcrotachannel_13_filter, mcrotrchannel_13_filter;
Coords mcposachannel_14_filter, mcposrchannel_14_filter;
Rotation mcrotachannel_14_filter, mcrotrchannel_14_filter;
Coords mcposachannel_15_filter, mcposrchannel_15_filter;
Rotation mcrotachannel_15_filter, mcrotrchannel_15_filter;
Coords mcposachannel_16_filter, mcposrchannel_16_filter;
Rotation mcrotachannel_16_filter, mcrotrchannel_16_filter;
Coords mcposachannel_17_filter, mcposrchannel_17_filter;
Rotation mcrotachannel_17_filter, mcrotrchannel_17_filter;
Coords mcposachannel_18_filter, mcposrchannel_18_filter;
Rotation mcrotachannel_18_filter, mcrotrchannel_18_filter;
Coords mcposachannel_19_filter, mcposrchannel_19_filter;
Rotation mcrotachannel_19_filter, mcrotrchannel_19_filter;
Coords mcposachannel_selector, mcposrchannel_selector;
Rotation mcrotachannel_selector, mcrotrchannel_selector;
Coords mcposachannel_0_colimator, mcposrchannel_0_colimator;
Rotation mcrotachannel_0_colimator, mcrotrchannel_0_colimator;
Coords mcposachannel_1_colimator, mcposrchannel_1_colimator;
Rotation mcrotachannel_1_colimator, mcrotrchannel_1_colimator;
Coords mcposachannel_2_colimator, mcposrchannel_2_colimator;
Rotation mcrotachannel_2_colimator, mcrotrchannel_2_colimator;
Coords mcposachannel_3_colimator, mcposrchannel_3_colimator;
Rotation mcrotachannel_3_colimator, mcrotrchannel_3_colimator;
Coords mcposachannel_4_colimator, mcposrchannel_4_colimator;
Rotation mcrotachannel_4_colimator, mcrotrchannel_4_colimator;
Coords mcposachannel_5_colimator, mcposrchannel_5_colimator;
Rotation mcrotachannel_5_colimator, mcrotrchannel_5_colimator;
Coords mcposachannel_6_colimator, mcposrchannel_6_colimator;
Rotation mcrotachannel_6_colimator, mcrotrchannel_6_colimator;
Coords mcposachannel_7_colimator, mcposrchannel_7_colimator;
Rotation mcrotachannel_7_colimator, mcrotrchannel_7_colimator;
Coords mcposachannel_8_colimator, mcposrchannel_8_colimator;
Rotation mcrotachannel_8_colimator, mcrotrchannel_8_colimator;
Coords mcposachannel_9_colimator, mcposrchannel_9_colimator;
Rotation mcrotachannel_9_colimator, mcrotrchannel_9_colimator;
Coords mcposachannel_10_colimator, mcposrchannel_10_colimator;
Rotation mcrotachannel_10_colimator, mcrotrchannel_10_colimator;
Coords mcposachannel_11_colimator, mcposrchannel_11_colimator;
Rotation mcrotachannel_11_colimator, mcrotrchannel_11_colimator;
Coords mcposachannel_12_colimator, mcposrchannel_12_colimator;
Rotation mcrotachannel_12_colimator, mcrotrchannel_12_colimator;
Coords mcposachannel_13_colimator, mcposrchannel_13_colimator;
Rotation mcrotachannel_13_colimator, mcrotrchannel_13_colimator;
Coords mcposachannel_14_colimator, mcposrchannel_14_colimator;
Rotation mcrotachannel_14_colimator, mcrotrchannel_14_colimator;
Coords mcposachannel_15_colimator, mcposrchannel_15_colimator;
Rotation mcrotachannel_15_colimator, mcrotrchannel_15_colimator;
Coords mcposachannel_16_colimator, mcposrchannel_16_colimator;
Rotation mcrotachannel_16_colimator, mcrotrchannel_16_colimator;
Coords mcposachannel_17_colimator, mcposrchannel_17_colimator;
Rotation mcrotachannel_17_colimator, mcrotrchannel_17_colimator;
Coords mcposachannel_18_colimator, mcposrchannel_18_colimator;
Rotation mcrotachannel_18_colimator, mcrotrchannel_18_colimator;
Coords mcposachannel_19_colimator, mcposrchannel_19_colimator;
Rotation mcrotachannel_19_colimator, mcrotrchannel_19_colimator;
Coords mcposaboron_plastic_incoherent, mcposrboron_plastic_incoherent;
Rotation mcrotaboron_plastic_incoherent, mcrotrboron_plastic_incoherent;
Coords mcposaboron_plastic, mcposrboron_plastic;
Rotation mcrotaboron_plastic, mcrotrboron_plastic;
Coords mcposaboron_plastic_enriched_incoherent, mcposrboron_plastic_enriched_incoherent;
Rotation mcrotaboron_plastic_enriched_incoherent, mcrotrboron_plastic_enriched_incoherent;
Coords mcposaboron_plastic_enriched, mcposrboron_plastic_enriched;
Rotation mcrotaboron_plastic_enriched, mcrotrboron_plastic_enriched;
Coords mcposaCollimator_gad, mcposrCollimator_gad;
Rotation mcrotaCollimator_gad, mcrotrCollimator_gad;
Coords mcposaIncoherent_PG_analyzer, mcposrIncoherent_PG_analyzer;
Rotation mcrotaIncoherent_PG_analyzer, mcrotrIncoherent_PG_analyzer;
Coords mcposaSingle_crystal_PG_analyzer, mcposrSingle_crystal_PG_analyzer;
Rotation mcrotaSingle_crystal_PG_analyzer, mcrotrSingle_crystal_PG_analyzer;
Coords mcposaPG_analyzer, mcposrPG_analyzer;
Rotation mcrotaPG_analyzer, mcrotrPG_analyzer;
Coords mcposakidney_hull, mcposrkidney_hull;
Rotation mcrotakidney_hull, mcrotrkidney_hull;
Coords mcposakidney_hull_cut, mcposrkidney_hull_cut;
Rotation mcrotakidney_hull_cut, mcrotrkidney_hull_cut;
Coords mcposakidney_hull_box_cut_arm1, mcposrkidney_hull_box_cut_arm1;
Rotation mcrotakidney_hull_box_cut_arm1, mcrotrkidney_hull_box_cut_arm1;
Coords mcposakidney_hull_box_cut1, mcposrkidney_hull_box_cut1;
Rotation mcrotakidney_hull_box_cut1, mcrotrkidney_hull_box_cut1;
Coords mcposakidney_hull_box_cut_arm2, mcposrkidney_hull_box_cut_arm2;
Rotation mcrotakidney_hull_box_cut_arm2, mcrotrkidney_hull_box_cut_arm2;
Coords mcposakidney_hull_box_cut2, mcposrkidney_hull_box_cut2;
Rotation mcrotakidney_hull_box_cut2, mcrotrkidney_hull_box_cut2;
Coords mcposachannel_0_cave1_box1, mcposrchannel_0_cave1_box1;
Rotation mcrotachannel_0_cave1_box1, mcrotrchannel_0_cave1_box1;
Coords mcposachannel_0_cave1_box2, mcposrchannel_0_cave1_box2;
Rotation mcrotachannel_0_cave1_box2, mcrotrchannel_0_cave1_box2;
Coords mcposachannel_0_cave1_box3, mcposrchannel_0_cave1_box3;
Rotation mcrotachannel_0_cave1_box3, mcrotrchannel_0_cave1_box3;
Coords mcposachannel_0_cave1_cyl1, mcposrchannel_0_cave1_cyl1;
Rotation mcrotachannel_0_cave1_cyl1, mcrotrchannel_0_cave1_cyl1;
Coords mcposachannel_0_analyzer_1_center, mcposrchannel_0_analyzer_1_center;
Rotation mcrotachannel_0_analyzer_1_center, mcrotrchannel_0_analyzer_1_center;
Coords mcposachannel_0_analyzer_1_rotated, mcposrchannel_0_analyzer_1_rotated;
Rotation mcrotachannel_0_analyzer_1_rotated, mcrotrchannel_0_analyzer_1_rotated;
Coords mcposachannel_0_analyzer_1_array_crystal_array_0, mcposrchannel_0_analyzer_1_array_crystal_array_0;
Rotation mcrotachannel_0_analyzer_1_array_crystal_array_0, mcrotrchannel_0_analyzer_1_array_crystal_array_0;
Coords mcposachannel_0_analyzer_1_array_crystal_array_1, mcposrchannel_0_analyzer_1_array_crystal_array_1;
Rotation mcrotachannel_0_analyzer_1_array_crystal_array_1, mcrotrchannel_0_analyzer_1_array_crystal_array_1;
Coords mcposachannel_0_analyzer_1_array_crystal_array_2, mcposrchannel_0_analyzer_1_array_crystal_array_2;
Rotation mcrotachannel_0_analyzer_1_array_crystal_array_2, mcrotrchannel_0_analyzer_1_array_crystal_array_2;
Coords mcposachannel_0_analyzer_1_array_crystal_array_3, mcposrchannel_0_analyzer_1_array_crystal_array_3;
Rotation mcrotachannel_0_analyzer_1_array_crystal_array_3, mcrotrchannel_0_analyzer_1_array_crystal_array_3;
Coords mcposachannel_0_analyzer_1_array_crystal_array_4, mcposrchannel_0_analyzer_1_array_crystal_array_4;
Rotation mcrotachannel_0_analyzer_1_array_crystal_array_4, mcrotrchannel_0_analyzer_1_array_crystal_array_4;
Coords mcposachannel_0_analyzer_1_array_crystal_array_5, mcposrchannel_0_analyzer_1_array_crystal_array_5;
Rotation mcrotachannel_0_analyzer_1_array_crystal_array_5, mcrotrchannel_0_analyzer_1_array_crystal_array_5;
Coords mcposachannel_0_analyzer_1_array_crystal_array_6, mcposrchannel_0_analyzer_1_array_crystal_array_6;
Rotation mcrotachannel_0_analyzer_1_array_crystal_array_6, mcrotrchannel_0_analyzer_1_array_crystal_array_6;
Coords mcposachannel_0_analyzer_1_array_crystal_array_7, mcposrchannel_0_analyzer_1_array_crystal_array_7;
Rotation mcrotachannel_0_analyzer_1_array_crystal_array_7, mcrotrchannel_0_analyzer_1_array_crystal_array_7;
Coords mcposachannel_0_analyzer_1_array_crystal_array_8, mcposrchannel_0_analyzer_1_array_crystal_array_8;
Rotation mcrotachannel_0_analyzer_1_array_crystal_array_8, mcrotrchannel_0_analyzer_1_array_crystal_array_8;
Coords mcposachannel_0_analyzer_2_center, mcposrchannel_0_analyzer_2_center;
Rotation mcrotachannel_0_analyzer_2_center, mcrotrchannel_0_analyzer_2_center;
Coords mcposachannel_0_analyzer_2_rotated, mcposrchannel_0_analyzer_2_rotated;
Rotation mcrotachannel_0_analyzer_2_rotated, mcrotrchannel_0_analyzer_2_rotated;
Coords mcposachannel_0_analyzer_2_array_crystal_array_0, mcposrchannel_0_analyzer_2_array_crystal_array_0;
Rotation mcrotachannel_0_analyzer_2_array_crystal_array_0, mcrotrchannel_0_analyzer_2_array_crystal_array_0;
Coords mcposachannel_0_analyzer_2_array_crystal_array_1, mcposrchannel_0_analyzer_2_array_crystal_array_1;
Rotation mcrotachannel_0_analyzer_2_array_crystal_array_1, mcrotrchannel_0_analyzer_2_array_crystal_array_1;
Coords mcposachannel_0_analyzer_2_array_crystal_array_2, mcposrchannel_0_analyzer_2_array_crystal_array_2;
Rotation mcrotachannel_0_analyzer_2_array_crystal_array_2, mcrotrchannel_0_analyzer_2_array_crystal_array_2;
Coords mcposachannel_0_analyzer_2_array_crystal_array_3, mcposrchannel_0_analyzer_2_array_crystal_array_3;
Rotation mcrotachannel_0_analyzer_2_array_crystal_array_3, mcrotrchannel_0_analyzer_2_array_crystal_array_3;
Coords mcposachannel_0_analyzer_2_array_crystal_array_4, mcposrchannel_0_analyzer_2_array_crystal_array_4;
Rotation mcrotachannel_0_analyzer_2_array_crystal_array_4, mcrotrchannel_0_analyzer_2_array_crystal_array_4;
Coords mcposachannel_0_analyzer_2_array_crystal_array_5, mcposrchannel_0_analyzer_2_array_crystal_array_5;
Rotation mcrotachannel_0_analyzer_2_array_crystal_array_5, mcrotrchannel_0_analyzer_2_array_crystal_array_5;
Coords mcposachannel_0_analyzer_2_array_crystal_array_6, mcposrchannel_0_analyzer_2_array_crystal_array_6;
Rotation mcrotachannel_0_analyzer_2_array_crystal_array_6, mcrotrchannel_0_analyzer_2_array_crystal_array_6;
Coords mcposachannel_0_analyzer_2_array_crystal_array_7, mcposrchannel_0_analyzer_2_array_crystal_array_7;
Rotation mcrotachannel_0_analyzer_2_array_crystal_array_7, mcrotrchannel_0_analyzer_2_array_crystal_array_7;
Coords mcposachannel_0_analyzer_2_array_crystal_array_8, mcposrchannel_0_analyzer_2_array_crystal_array_8;
Rotation mcrotachannel_0_analyzer_2_array_crystal_array_8, mcrotrchannel_0_analyzer_2_array_crystal_array_8;
Coords mcposachannel_0_cave2_cyl1, mcposrchannel_0_cave2_cyl1;
Rotation mcrotachannel_0_cave2_cyl1, mcrotrchannel_0_cave2_cyl1;
Coords mcposachannel_0_cave2_box1, mcposrchannel_0_cave2_box1;
Rotation mcrotachannel_0_cave2_box1, mcrotrchannel_0_cave2_box1;
Coords mcposachannel_0_cave2_box2, mcposrchannel_0_cave2_box2;
Rotation mcrotachannel_0_cave2_box2, mcrotrchannel_0_cave2_box2;
Coords mcposachannel_0_cave2_box3, mcposrchannel_0_cave2_box3;
Rotation mcrotachannel_0_cave2_box3, mcrotrchannel_0_cave2_box3;
Coords mcposainter_analyzer_colimator_center_0, mcposrinter_analyzer_colimator_center_0;
Rotation mcrotainter_analyzer_colimator_center_0, mcrotrinter_analyzer_colimator_center_0;
Coords mcposainter_analyzer_colimator_0_blade_0, mcposrinter_analyzer_colimator_0_blade_0;
Rotation mcrotainter_analyzer_colimator_0_blade_0, mcrotrinter_analyzer_colimator_0_blade_0;
Coords mcposainter_analyzer_colimator_0_blade_1, mcposrinter_analyzer_colimator_0_blade_1;
Rotation mcrotainter_analyzer_colimator_0_blade_1, mcrotrinter_analyzer_colimator_0_blade_1;
Coords mcposainter_analyzer_colimator_0_blade_2, mcposrinter_analyzer_colimator_0_blade_2;
Rotation mcrotainter_analyzer_colimator_0_blade_2, mcrotrinter_analyzer_colimator_0_blade_2;
Coords mcposainter_analyzer_colimator_0_blade_3, mcposrinter_analyzer_colimator_0_blade_3;
Rotation mcrotainter_analyzer_colimator_0_blade_3, mcrotrinter_analyzer_colimator_0_blade_3;
Coords mcposainter_analyzer_colimator_0_blade_4, mcposrinter_analyzer_colimator_0_blade_4;
Rotation mcrotainter_analyzer_colimator_0_blade_4, mcrotrinter_analyzer_colimator_0_blade_4;
Coords mcposadiffraction_detector_0_exit_volume, mcposrdiffraction_detector_0_exit_volume;
Rotation mcrotadiffraction_detector_0_exit_volume, mcrotrdiffraction_detector_0_exit_volume;
Coords mcposaspec_detector_0_exit_volume, mcposrspec_detector_0_exit_volume;
Rotation mcrotaspec_detector_0_exit_volume, mcrotrspec_detector_0_exit_volume;
Coords mcposachannel_1_cave1_box1, mcposrchannel_1_cave1_box1;
Rotation mcrotachannel_1_cave1_box1, mcrotrchannel_1_cave1_box1;
Coords mcposachannel_1_cave1_box2, mcposrchannel_1_cave1_box2;
Rotation mcrotachannel_1_cave1_box2, mcrotrchannel_1_cave1_box2;
Coords mcposachannel_1_cave1_box3, mcposrchannel_1_cave1_box3;
Rotation mcrotachannel_1_cave1_box3, mcrotrchannel_1_cave1_box3;
Coords mcposachannel_1_cave1_cyl1, mcposrchannel_1_cave1_cyl1;
Rotation mcrotachannel_1_cave1_cyl1, mcrotrchannel_1_cave1_cyl1;
Coords mcposachannel_1_analyzer_1_center, mcposrchannel_1_analyzer_1_center;
Rotation mcrotachannel_1_analyzer_1_center, mcrotrchannel_1_analyzer_1_center;
Coords mcposachannel_1_analyzer_1_rotated, mcposrchannel_1_analyzer_1_rotated;
Rotation mcrotachannel_1_analyzer_1_rotated, mcrotrchannel_1_analyzer_1_rotated;
Coords mcposachannel_1_analyzer_1_array_crystal_array_0, mcposrchannel_1_analyzer_1_array_crystal_array_0;
Rotation mcrotachannel_1_analyzer_1_array_crystal_array_0, mcrotrchannel_1_analyzer_1_array_crystal_array_0;
Coords mcposachannel_1_analyzer_1_array_crystal_array_1, mcposrchannel_1_analyzer_1_array_crystal_array_1;
Rotation mcrotachannel_1_analyzer_1_array_crystal_array_1, mcrotrchannel_1_analyzer_1_array_crystal_array_1;
Coords mcposachannel_1_analyzer_1_array_crystal_array_2, mcposrchannel_1_analyzer_1_array_crystal_array_2;
Rotation mcrotachannel_1_analyzer_1_array_crystal_array_2, mcrotrchannel_1_analyzer_1_array_crystal_array_2;
Coords mcposachannel_1_analyzer_1_array_crystal_array_3, mcposrchannel_1_analyzer_1_array_crystal_array_3;
Rotation mcrotachannel_1_analyzer_1_array_crystal_array_3, mcrotrchannel_1_analyzer_1_array_crystal_array_3;
Coords mcposachannel_1_analyzer_1_array_crystal_array_4, mcposrchannel_1_analyzer_1_array_crystal_array_4;
Rotation mcrotachannel_1_analyzer_1_array_crystal_array_4, mcrotrchannel_1_analyzer_1_array_crystal_array_4;
Coords mcposachannel_1_analyzer_1_array_crystal_array_5, mcposrchannel_1_analyzer_1_array_crystal_array_5;
Rotation mcrotachannel_1_analyzer_1_array_crystal_array_5, mcrotrchannel_1_analyzer_1_array_crystal_array_5;
Coords mcposachannel_1_analyzer_1_array_crystal_array_6, mcposrchannel_1_analyzer_1_array_crystal_array_6;
Rotation mcrotachannel_1_analyzer_1_array_crystal_array_6, mcrotrchannel_1_analyzer_1_array_crystal_array_6;
Coords mcposachannel_1_analyzer_1_array_crystal_array_7, mcposrchannel_1_analyzer_1_array_crystal_array_7;
Rotation mcrotachannel_1_analyzer_1_array_crystal_array_7, mcrotrchannel_1_analyzer_1_array_crystal_array_7;
Coords mcposachannel_1_analyzer_1_array_crystal_array_8, mcposrchannel_1_analyzer_1_array_crystal_array_8;
Rotation mcrotachannel_1_analyzer_1_array_crystal_array_8, mcrotrchannel_1_analyzer_1_array_crystal_array_8;
Coords mcposachannel_1_analyzer_2_center, mcposrchannel_1_analyzer_2_center;
Rotation mcrotachannel_1_analyzer_2_center, mcrotrchannel_1_analyzer_2_center;
Coords mcposachannel_1_analyzer_2_rotated, mcposrchannel_1_analyzer_2_rotated;
Rotation mcrotachannel_1_analyzer_2_rotated, mcrotrchannel_1_analyzer_2_rotated;
Coords mcposachannel_1_analyzer_2_array_crystal_array_0, mcposrchannel_1_analyzer_2_array_crystal_array_0;
Rotation mcrotachannel_1_analyzer_2_array_crystal_array_0, mcrotrchannel_1_analyzer_2_array_crystal_array_0;
Coords mcposachannel_1_analyzer_2_array_crystal_array_1, mcposrchannel_1_analyzer_2_array_crystal_array_1;
Rotation mcrotachannel_1_analyzer_2_array_crystal_array_1, mcrotrchannel_1_analyzer_2_array_crystal_array_1;
Coords mcposachannel_1_analyzer_2_array_crystal_array_2, mcposrchannel_1_analyzer_2_array_crystal_array_2;
Rotation mcrotachannel_1_analyzer_2_array_crystal_array_2, mcrotrchannel_1_analyzer_2_array_crystal_array_2;
Coords mcposachannel_1_analyzer_2_array_crystal_array_3, mcposrchannel_1_analyzer_2_array_crystal_array_3;
Rotation mcrotachannel_1_analyzer_2_array_crystal_array_3, mcrotrchannel_1_analyzer_2_array_crystal_array_3;
Coords mcposachannel_1_analyzer_2_array_crystal_array_4, mcposrchannel_1_analyzer_2_array_crystal_array_4;
Rotation mcrotachannel_1_analyzer_2_array_crystal_array_4, mcrotrchannel_1_analyzer_2_array_crystal_array_4;
Coords mcposachannel_1_analyzer_2_array_crystal_array_5, mcposrchannel_1_analyzer_2_array_crystal_array_5;
Rotation mcrotachannel_1_analyzer_2_array_crystal_array_5, mcrotrchannel_1_analyzer_2_array_crystal_array_5;
Coords mcposachannel_1_analyzer_2_array_crystal_array_6, mcposrchannel_1_analyzer_2_array_crystal_array_6;
Rotation mcrotachannel_1_analyzer_2_array_crystal_array_6, mcrotrchannel_1_analyzer_2_array_crystal_array_6;
Coords mcposachannel_1_analyzer_2_array_crystal_array_7, mcposrchannel_1_analyzer_2_array_crystal_array_7;
Rotation mcrotachannel_1_analyzer_2_array_crystal_array_7, mcrotrchannel_1_analyzer_2_array_crystal_array_7;
Coords mcposachannel_1_analyzer_2_array_crystal_array_8, mcposrchannel_1_analyzer_2_array_crystal_array_8;
Rotation mcrotachannel_1_analyzer_2_array_crystal_array_8, mcrotrchannel_1_analyzer_2_array_crystal_array_8;
Coords mcposachannel_1_cave2_cyl1, mcposrchannel_1_cave2_cyl1;
Rotation mcrotachannel_1_cave2_cyl1, mcrotrchannel_1_cave2_cyl1;
Coords mcposachannel_1_cave2_box1, mcposrchannel_1_cave2_box1;
Rotation mcrotachannel_1_cave2_box1, mcrotrchannel_1_cave2_box1;
Coords mcposachannel_1_cave2_box2, mcposrchannel_1_cave2_box2;
Rotation mcrotachannel_1_cave2_box2, mcrotrchannel_1_cave2_box2;
Coords mcposachannel_1_cave2_box3, mcposrchannel_1_cave2_box3;
Rotation mcrotachannel_1_cave2_box3, mcrotrchannel_1_cave2_box3;
Coords mcposainter_analyzer_colimator_center_1, mcposrinter_analyzer_colimator_center_1;
Rotation mcrotainter_analyzer_colimator_center_1, mcrotrinter_analyzer_colimator_center_1;
Coords mcposainter_analyzer_colimator_1_blade_0, mcposrinter_analyzer_colimator_1_blade_0;
Rotation mcrotainter_analyzer_colimator_1_blade_0, mcrotrinter_analyzer_colimator_1_blade_0;
Coords mcposainter_analyzer_colimator_1_blade_1, mcposrinter_analyzer_colimator_1_blade_1;
Rotation mcrotainter_analyzer_colimator_1_blade_1, mcrotrinter_analyzer_colimator_1_blade_1;
Coords mcposainter_analyzer_colimator_1_blade_2, mcposrinter_analyzer_colimator_1_blade_2;
Rotation mcrotainter_analyzer_colimator_1_blade_2, mcrotrinter_analyzer_colimator_1_blade_2;
Coords mcposainter_analyzer_colimator_1_blade_3, mcposrinter_analyzer_colimator_1_blade_3;
Rotation mcrotainter_analyzer_colimator_1_blade_3, mcrotrinter_analyzer_colimator_1_blade_3;
Coords mcposainter_analyzer_colimator_1_blade_4, mcposrinter_analyzer_colimator_1_blade_4;
Rotation mcrotainter_analyzer_colimator_1_blade_4, mcrotrinter_analyzer_colimator_1_blade_4;
Coords mcposadiffraction_detector_1_exit_volume, mcposrdiffraction_detector_1_exit_volume;
Rotation mcrotadiffraction_detector_1_exit_volume, mcrotrdiffraction_detector_1_exit_volume;
Coords mcposaspec_detector_1_exit_volume, mcposrspec_detector_1_exit_volume;
Rotation mcrotaspec_detector_1_exit_volume, mcrotrspec_detector_1_exit_volume;
Coords mcposachannel_2_cave1_box1, mcposrchannel_2_cave1_box1;
Rotation mcrotachannel_2_cave1_box1, mcrotrchannel_2_cave1_box1;
Coords mcposachannel_2_cave1_box2, mcposrchannel_2_cave1_box2;
Rotation mcrotachannel_2_cave1_box2, mcrotrchannel_2_cave1_box2;
Coords mcposachannel_2_cave1_box3, mcposrchannel_2_cave1_box3;
Rotation mcrotachannel_2_cave1_box3, mcrotrchannel_2_cave1_box3;
Coords mcposachannel_2_cave1_cyl1, mcposrchannel_2_cave1_cyl1;
Rotation mcrotachannel_2_cave1_cyl1, mcrotrchannel_2_cave1_cyl1;
Coords mcposachannel_2_analyzer_1_center, mcposrchannel_2_analyzer_1_center;
Rotation mcrotachannel_2_analyzer_1_center, mcrotrchannel_2_analyzer_1_center;
Coords mcposachannel_2_analyzer_1_rotated, mcposrchannel_2_analyzer_1_rotated;
Rotation mcrotachannel_2_analyzer_1_rotated, mcrotrchannel_2_analyzer_1_rotated;
Coords mcposachannel_2_analyzer_1_array_crystal_array_0, mcposrchannel_2_analyzer_1_array_crystal_array_0;
Rotation mcrotachannel_2_analyzer_1_array_crystal_array_0, mcrotrchannel_2_analyzer_1_array_crystal_array_0;
Coords mcposachannel_2_analyzer_1_array_crystal_array_1, mcposrchannel_2_analyzer_1_array_crystal_array_1;
Rotation mcrotachannel_2_analyzer_1_array_crystal_array_1, mcrotrchannel_2_analyzer_1_array_crystal_array_1;
Coords mcposachannel_2_analyzer_1_array_crystal_array_2, mcposrchannel_2_analyzer_1_array_crystal_array_2;
Rotation mcrotachannel_2_analyzer_1_array_crystal_array_2, mcrotrchannel_2_analyzer_1_array_crystal_array_2;
Coords mcposachannel_2_analyzer_1_array_crystal_array_3, mcposrchannel_2_analyzer_1_array_crystal_array_3;
Rotation mcrotachannel_2_analyzer_1_array_crystal_array_3, mcrotrchannel_2_analyzer_1_array_crystal_array_3;
Coords mcposachannel_2_analyzer_1_array_crystal_array_4, mcposrchannel_2_analyzer_1_array_crystal_array_4;
Rotation mcrotachannel_2_analyzer_1_array_crystal_array_4, mcrotrchannel_2_analyzer_1_array_crystal_array_4;
Coords mcposachannel_2_analyzer_1_array_crystal_array_5, mcposrchannel_2_analyzer_1_array_crystal_array_5;
Rotation mcrotachannel_2_analyzer_1_array_crystal_array_5, mcrotrchannel_2_analyzer_1_array_crystal_array_5;
Coords mcposachannel_2_analyzer_1_array_crystal_array_6, mcposrchannel_2_analyzer_1_array_crystal_array_6;
Rotation mcrotachannel_2_analyzer_1_array_crystal_array_6, mcrotrchannel_2_analyzer_1_array_crystal_array_6;
Coords mcposachannel_2_analyzer_1_array_crystal_array_7, mcposrchannel_2_analyzer_1_array_crystal_array_7;
Rotation mcrotachannel_2_analyzer_1_array_crystal_array_7, mcrotrchannel_2_analyzer_1_array_crystal_array_7;
Coords mcposachannel_2_analyzer_1_array_crystal_array_8, mcposrchannel_2_analyzer_1_array_crystal_array_8;
Rotation mcrotachannel_2_analyzer_1_array_crystal_array_8, mcrotrchannel_2_analyzer_1_array_crystal_array_8;
Coords mcposachannel_2_analyzer_2_center, mcposrchannel_2_analyzer_2_center;
Rotation mcrotachannel_2_analyzer_2_center, mcrotrchannel_2_analyzer_2_center;
Coords mcposachannel_2_analyzer_2_rotated, mcposrchannel_2_analyzer_2_rotated;
Rotation mcrotachannel_2_analyzer_2_rotated, mcrotrchannel_2_analyzer_2_rotated;
Coords mcposachannel_2_analyzer_2_array_crystal_array_0, mcposrchannel_2_analyzer_2_array_crystal_array_0;
Rotation mcrotachannel_2_analyzer_2_array_crystal_array_0, mcrotrchannel_2_analyzer_2_array_crystal_array_0;
Coords mcposachannel_2_analyzer_2_array_crystal_array_1, mcposrchannel_2_analyzer_2_array_crystal_array_1;
Rotation mcrotachannel_2_analyzer_2_array_crystal_array_1, mcrotrchannel_2_analyzer_2_array_crystal_array_1;
Coords mcposachannel_2_analyzer_2_array_crystal_array_2, mcposrchannel_2_analyzer_2_array_crystal_array_2;
Rotation mcrotachannel_2_analyzer_2_array_crystal_array_2, mcrotrchannel_2_analyzer_2_array_crystal_array_2;
Coords mcposachannel_2_analyzer_2_array_crystal_array_3, mcposrchannel_2_analyzer_2_array_crystal_array_3;
Rotation mcrotachannel_2_analyzer_2_array_crystal_array_3, mcrotrchannel_2_analyzer_2_array_crystal_array_3;
Coords mcposachannel_2_analyzer_2_array_crystal_array_4, mcposrchannel_2_analyzer_2_array_crystal_array_4;
Rotation mcrotachannel_2_analyzer_2_array_crystal_array_4, mcrotrchannel_2_analyzer_2_array_crystal_array_4;
Coords mcposachannel_2_analyzer_2_array_crystal_array_5, mcposrchannel_2_analyzer_2_array_crystal_array_5;
Rotation mcrotachannel_2_analyzer_2_array_crystal_array_5, mcrotrchannel_2_analyzer_2_array_crystal_array_5;
Coords mcposachannel_2_analyzer_2_array_crystal_array_6, mcposrchannel_2_analyzer_2_array_crystal_array_6;
Rotation mcrotachannel_2_analyzer_2_array_crystal_array_6, mcrotrchannel_2_analyzer_2_array_crystal_array_6;
Coords mcposachannel_2_analyzer_2_array_crystal_array_7, mcposrchannel_2_analyzer_2_array_crystal_array_7;
Rotation mcrotachannel_2_analyzer_2_array_crystal_array_7, mcrotrchannel_2_analyzer_2_array_crystal_array_7;
Coords mcposachannel_2_analyzer_2_array_crystal_array_8, mcposrchannel_2_analyzer_2_array_crystal_array_8;
Rotation mcrotachannel_2_analyzer_2_array_crystal_array_8, mcrotrchannel_2_analyzer_2_array_crystal_array_8;
Coords mcposachannel_2_cave2_cyl1, mcposrchannel_2_cave2_cyl1;
Rotation mcrotachannel_2_cave2_cyl1, mcrotrchannel_2_cave2_cyl1;
Coords mcposachannel_2_cave2_box1, mcposrchannel_2_cave2_box1;
Rotation mcrotachannel_2_cave2_box1, mcrotrchannel_2_cave2_box1;
Coords mcposachannel_2_cave2_box2, mcposrchannel_2_cave2_box2;
Rotation mcrotachannel_2_cave2_box2, mcrotrchannel_2_cave2_box2;
Coords mcposachannel_2_cave2_box3, mcposrchannel_2_cave2_box3;
Rotation mcrotachannel_2_cave2_box3, mcrotrchannel_2_cave2_box3;
Coords mcposainter_analyzer_colimator_center_2, mcposrinter_analyzer_colimator_center_2;
Rotation mcrotainter_analyzer_colimator_center_2, mcrotrinter_analyzer_colimator_center_2;
Coords mcposainter_analyzer_colimator_2_blade_0, mcposrinter_analyzer_colimator_2_blade_0;
Rotation mcrotainter_analyzer_colimator_2_blade_0, mcrotrinter_analyzer_colimator_2_blade_0;
Coords mcposainter_analyzer_colimator_2_blade_1, mcposrinter_analyzer_colimator_2_blade_1;
Rotation mcrotainter_analyzer_colimator_2_blade_1, mcrotrinter_analyzer_colimator_2_blade_1;
Coords mcposainter_analyzer_colimator_2_blade_2, mcposrinter_analyzer_colimator_2_blade_2;
Rotation mcrotainter_analyzer_colimator_2_blade_2, mcrotrinter_analyzer_colimator_2_blade_2;
Coords mcposainter_analyzer_colimator_2_blade_3, mcposrinter_analyzer_colimator_2_blade_3;
Rotation mcrotainter_analyzer_colimator_2_blade_3, mcrotrinter_analyzer_colimator_2_blade_3;
Coords mcposainter_analyzer_colimator_2_blade_4, mcposrinter_analyzer_colimator_2_blade_4;
Rotation mcrotainter_analyzer_colimator_2_blade_4, mcrotrinter_analyzer_colimator_2_blade_4;
Coords mcposadiffraction_detector_2_exit_volume, mcposrdiffraction_detector_2_exit_volume;
Rotation mcrotadiffraction_detector_2_exit_volume, mcrotrdiffraction_detector_2_exit_volume;
Coords mcposaspec_detector_2_exit_volume, mcposrspec_detector_2_exit_volume;
Rotation mcrotaspec_detector_2_exit_volume, mcrotrspec_detector_2_exit_volume;
Coords mcposachannel_3_cave1_box1, mcposrchannel_3_cave1_box1;
Rotation mcrotachannel_3_cave1_box1, mcrotrchannel_3_cave1_box1;
Coords mcposachannel_3_cave1_box2, mcposrchannel_3_cave1_box2;
Rotation mcrotachannel_3_cave1_box2, mcrotrchannel_3_cave1_box2;
Coords mcposachannel_3_cave1_box3, mcposrchannel_3_cave1_box3;
Rotation mcrotachannel_3_cave1_box3, mcrotrchannel_3_cave1_box3;
Coords mcposachannel_3_cave1_cyl1, mcposrchannel_3_cave1_cyl1;
Rotation mcrotachannel_3_cave1_cyl1, mcrotrchannel_3_cave1_cyl1;
Coords mcposachannel_3_analyzer_1_center, mcposrchannel_3_analyzer_1_center;
Rotation mcrotachannel_3_analyzer_1_center, mcrotrchannel_3_analyzer_1_center;
Coords mcposachannel_3_analyzer_1_rotated, mcposrchannel_3_analyzer_1_rotated;
Rotation mcrotachannel_3_analyzer_1_rotated, mcrotrchannel_3_analyzer_1_rotated;
Coords mcposachannel_3_analyzer_1_array_crystal_array_0, mcposrchannel_3_analyzer_1_array_crystal_array_0;
Rotation mcrotachannel_3_analyzer_1_array_crystal_array_0, mcrotrchannel_3_analyzer_1_array_crystal_array_0;
Coords mcposachannel_3_analyzer_1_array_crystal_array_1, mcposrchannel_3_analyzer_1_array_crystal_array_1;
Rotation mcrotachannel_3_analyzer_1_array_crystal_array_1, mcrotrchannel_3_analyzer_1_array_crystal_array_1;
Coords mcposachannel_3_analyzer_1_array_crystal_array_2, mcposrchannel_3_analyzer_1_array_crystal_array_2;
Rotation mcrotachannel_3_analyzer_1_array_crystal_array_2, mcrotrchannel_3_analyzer_1_array_crystal_array_2;
Coords mcposachannel_3_analyzer_1_array_crystal_array_3, mcposrchannel_3_analyzer_1_array_crystal_array_3;
Rotation mcrotachannel_3_analyzer_1_array_crystal_array_3, mcrotrchannel_3_analyzer_1_array_crystal_array_3;
Coords mcposachannel_3_analyzer_1_array_crystal_array_4, mcposrchannel_3_analyzer_1_array_crystal_array_4;
Rotation mcrotachannel_3_analyzer_1_array_crystal_array_4, mcrotrchannel_3_analyzer_1_array_crystal_array_4;
Coords mcposachannel_3_analyzer_1_array_crystal_array_5, mcposrchannel_3_analyzer_1_array_crystal_array_5;
Rotation mcrotachannel_3_analyzer_1_array_crystal_array_5, mcrotrchannel_3_analyzer_1_array_crystal_array_5;
Coords mcposachannel_3_analyzer_1_array_crystal_array_6, mcposrchannel_3_analyzer_1_array_crystal_array_6;
Rotation mcrotachannel_3_analyzer_1_array_crystal_array_6, mcrotrchannel_3_analyzer_1_array_crystal_array_6;
Coords mcposachannel_3_analyzer_1_array_crystal_array_7, mcposrchannel_3_analyzer_1_array_crystal_array_7;
Rotation mcrotachannel_3_analyzer_1_array_crystal_array_7, mcrotrchannel_3_analyzer_1_array_crystal_array_7;
Coords mcposachannel_3_analyzer_1_array_crystal_array_8, mcposrchannel_3_analyzer_1_array_crystal_array_8;
Rotation mcrotachannel_3_analyzer_1_array_crystal_array_8, mcrotrchannel_3_analyzer_1_array_crystal_array_8;
Coords mcposachannel_3_analyzer_2_center, mcposrchannel_3_analyzer_2_center;
Rotation mcrotachannel_3_analyzer_2_center, mcrotrchannel_3_analyzer_2_center;
Coords mcposachannel_3_analyzer_2_rotated, mcposrchannel_3_analyzer_2_rotated;
Rotation mcrotachannel_3_analyzer_2_rotated, mcrotrchannel_3_analyzer_2_rotated;
Coords mcposachannel_3_analyzer_2_array_crystal_array_0, mcposrchannel_3_analyzer_2_array_crystal_array_0;
Rotation mcrotachannel_3_analyzer_2_array_crystal_array_0, mcrotrchannel_3_analyzer_2_array_crystal_array_0;
Coords mcposachannel_3_analyzer_2_array_crystal_array_1, mcposrchannel_3_analyzer_2_array_crystal_array_1;
Rotation mcrotachannel_3_analyzer_2_array_crystal_array_1, mcrotrchannel_3_analyzer_2_array_crystal_array_1;
Coords mcposachannel_3_analyzer_2_array_crystal_array_2, mcposrchannel_3_analyzer_2_array_crystal_array_2;
Rotation mcrotachannel_3_analyzer_2_array_crystal_array_2, mcrotrchannel_3_analyzer_2_array_crystal_array_2;
Coords mcposachannel_3_analyzer_2_array_crystal_array_3, mcposrchannel_3_analyzer_2_array_crystal_array_3;
Rotation mcrotachannel_3_analyzer_2_array_crystal_array_3, mcrotrchannel_3_analyzer_2_array_crystal_array_3;
Coords mcposachannel_3_analyzer_2_array_crystal_array_4, mcposrchannel_3_analyzer_2_array_crystal_array_4;
Rotation mcrotachannel_3_analyzer_2_array_crystal_array_4, mcrotrchannel_3_analyzer_2_array_crystal_array_4;
Coords mcposachannel_3_analyzer_2_array_crystal_array_5, mcposrchannel_3_analyzer_2_array_crystal_array_5;
Rotation mcrotachannel_3_analyzer_2_array_crystal_array_5, mcrotrchannel_3_analyzer_2_array_crystal_array_5;
Coords mcposachannel_3_analyzer_2_array_crystal_array_6, mcposrchannel_3_analyzer_2_array_crystal_array_6;
Rotation mcrotachannel_3_analyzer_2_array_crystal_array_6, mcrotrchannel_3_analyzer_2_array_crystal_array_6;
Coords mcposachannel_3_analyzer_2_array_crystal_array_7, mcposrchannel_3_analyzer_2_array_crystal_array_7;
Rotation mcrotachannel_3_analyzer_2_array_crystal_array_7, mcrotrchannel_3_analyzer_2_array_crystal_array_7;
Coords mcposachannel_3_analyzer_2_array_crystal_array_8, mcposrchannel_3_analyzer_2_array_crystal_array_8;
Rotation mcrotachannel_3_analyzer_2_array_crystal_array_8, mcrotrchannel_3_analyzer_2_array_crystal_array_8;
Coords mcposachannel_3_cave2_cyl1, mcposrchannel_3_cave2_cyl1;
Rotation mcrotachannel_3_cave2_cyl1, mcrotrchannel_3_cave2_cyl1;
Coords mcposachannel_3_cave2_box1, mcposrchannel_3_cave2_box1;
Rotation mcrotachannel_3_cave2_box1, mcrotrchannel_3_cave2_box1;
Coords mcposachannel_3_cave2_box2, mcposrchannel_3_cave2_box2;
Rotation mcrotachannel_3_cave2_box2, mcrotrchannel_3_cave2_box2;
Coords mcposachannel_3_cave2_box3, mcposrchannel_3_cave2_box3;
Rotation mcrotachannel_3_cave2_box3, mcrotrchannel_3_cave2_box3;
Coords mcposainter_analyzer_colimator_center_3, mcposrinter_analyzer_colimator_center_3;
Rotation mcrotainter_analyzer_colimator_center_3, mcrotrinter_analyzer_colimator_center_3;
Coords mcposainter_analyzer_colimator_3_blade_0, mcposrinter_analyzer_colimator_3_blade_0;
Rotation mcrotainter_analyzer_colimator_3_blade_0, mcrotrinter_analyzer_colimator_3_blade_0;
Coords mcposainter_analyzer_colimator_3_blade_1, mcposrinter_analyzer_colimator_3_blade_1;
Rotation mcrotainter_analyzer_colimator_3_blade_1, mcrotrinter_analyzer_colimator_3_blade_1;
Coords mcposainter_analyzer_colimator_3_blade_2, mcposrinter_analyzer_colimator_3_blade_2;
Rotation mcrotainter_analyzer_colimator_3_blade_2, mcrotrinter_analyzer_colimator_3_blade_2;
Coords mcposainter_analyzer_colimator_3_blade_3, mcposrinter_analyzer_colimator_3_blade_3;
Rotation mcrotainter_analyzer_colimator_3_blade_3, mcrotrinter_analyzer_colimator_3_blade_3;
Coords mcposainter_analyzer_colimator_3_blade_4, mcposrinter_analyzer_colimator_3_blade_4;
Rotation mcrotainter_analyzer_colimator_3_blade_4, mcrotrinter_analyzer_colimator_3_blade_4;
Coords mcposadiffraction_detector_3_exit_volume, mcposrdiffraction_detector_3_exit_volume;
Rotation mcrotadiffraction_detector_3_exit_volume, mcrotrdiffraction_detector_3_exit_volume;
Coords mcposaspec_detector_3_exit_volume, mcposrspec_detector_3_exit_volume;
Rotation mcrotaspec_detector_3_exit_volume, mcrotrspec_detector_3_exit_volume;
Coords mcposachannel_4_cave1_box1, mcposrchannel_4_cave1_box1;
Rotation mcrotachannel_4_cave1_box1, mcrotrchannel_4_cave1_box1;
Coords mcposachannel_4_cave1_box2, mcposrchannel_4_cave1_box2;
Rotation mcrotachannel_4_cave1_box2, mcrotrchannel_4_cave1_box2;
Coords mcposachannel_4_cave1_box3, mcposrchannel_4_cave1_box3;
Rotation mcrotachannel_4_cave1_box3, mcrotrchannel_4_cave1_box3;
Coords mcposachannel_4_cave1_cyl1, mcposrchannel_4_cave1_cyl1;
Rotation mcrotachannel_4_cave1_cyl1, mcrotrchannel_4_cave1_cyl1;
Coords mcposachannel_4_analyzer_1_center, mcposrchannel_4_analyzer_1_center;
Rotation mcrotachannel_4_analyzer_1_center, mcrotrchannel_4_analyzer_1_center;
Coords mcposachannel_4_analyzer_1_rotated, mcposrchannel_4_analyzer_1_rotated;
Rotation mcrotachannel_4_analyzer_1_rotated, mcrotrchannel_4_analyzer_1_rotated;
Coords mcposachannel_4_analyzer_1_array_crystal_array_0, mcposrchannel_4_analyzer_1_array_crystal_array_0;
Rotation mcrotachannel_4_analyzer_1_array_crystal_array_0, mcrotrchannel_4_analyzer_1_array_crystal_array_0;
Coords mcposachannel_4_analyzer_1_array_crystal_array_1, mcposrchannel_4_analyzer_1_array_crystal_array_1;
Rotation mcrotachannel_4_analyzer_1_array_crystal_array_1, mcrotrchannel_4_analyzer_1_array_crystal_array_1;
Coords mcposachannel_4_analyzer_1_array_crystal_array_2, mcposrchannel_4_analyzer_1_array_crystal_array_2;
Rotation mcrotachannel_4_analyzer_1_array_crystal_array_2, mcrotrchannel_4_analyzer_1_array_crystal_array_2;
Coords mcposachannel_4_analyzer_1_array_crystal_array_3, mcposrchannel_4_analyzer_1_array_crystal_array_3;
Rotation mcrotachannel_4_analyzer_1_array_crystal_array_3, mcrotrchannel_4_analyzer_1_array_crystal_array_3;
Coords mcposachannel_4_analyzer_1_array_crystal_array_4, mcposrchannel_4_analyzer_1_array_crystal_array_4;
Rotation mcrotachannel_4_analyzer_1_array_crystal_array_4, mcrotrchannel_4_analyzer_1_array_crystal_array_4;
Coords mcposachannel_4_analyzer_1_array_crystal_array_5, mcposrchannel_4_analyzer_1_array_crystal_array_5;
Rotation mcrotachannel_4_analyzer_1_array_crystal_array_5, mcrotrchannel_4_analyzer_1_array_crystal_array_5;
Coords mcposachannel_4_analyzer_1_array_crystal_array_6, mcposrchannel_4_analyzer_1_array_crystal_array_6;
Rotation mcrotachannel_4_analyzer_1_array_crystal_array_6, mcrotrchannel_4_analyzer_1_array_crystal_array_6;
Coords mcposachannel_4_analyzer_1_array_crystal_array_7, mcposrchannel_4_analyzer_1_array_crystal_array_7;
Rotation mcrotachannel_4_analyzer_1_array_crystal_array_7, mcrotrchannel_4_analyzer_1_array_crystal_array_7;
Coords mcposachannel_4_analyzer_1_array_crystal_array_8, mcposrchannel_4_analyzer_1_array_crystal_array_8;
Rotation mcrotachannel_4_analyzer_1_array_crystal_array_8, mcrotrchannel_4_analyzer_1_array_crystal_array_8;
Coords mcposachannel_4_analyzer_2_center, mcposrchannel_4_analyzer_2_center;
Rotation mcrotachannel_4_analyzer_2_center, mcrotrchannel_4_analyzer_2_center;
Coords mcposachannel_4_analyzer_2_rotated, mcposrchannel_4_analyzer_2_rotated;
Rotation mcrotachannel_4_analyzer_2_rotated, mcrotrchannel_4_analyzer_2_rotated;
Coords mcposachannel_4_analyzer_2_array_crystal_array_0, mcposrchannel_4_analyzer_2_array_crystal_array_0;
Rotation mcrotachannel_4_analyzer_2_array_crystal_array_0, mcrotrchannel_4_analyzer_2_array_crystal_array_0;
Coords mcposachannel_4_analyzer_2_array_crystal_array_1, mcposrchannel_4_analyzer_2_array_crystal_array_1;
Rotation mcrotachannel_4_analyzer_2_array_crystal_array_1, mcrotrchannel_4_analyzer_2_array_crystal_array_1;
Coords mcposachannel_4_analyzer_2_array_crystal_array_2, mcposrchannel_4_analyzer_2_array_crystal_array_2;
Rotation mcrotachannel_4_analyzer_2_array_crystal_array_2, mcrotrchannel_4_analyzer_2_array_crystal_array_2;
Coords mcposachannel_4_analyzer_2_array_crystal_array_3, mcposrchannel_4_analyzer_2_array_crystal_array_3;
Rotation mcrotachannel_4_analyzer_2_array_crystal_array_3, mcrotrchannel_4_analyzer_2_array_crystal_array_3;
Coords mcposachannel_4_analyzer_2_array_crystal_array_4, mcposrchannel_4_analyzer_2_array_crystal_array_4;
Rotation mcrotachannel_4_analyzer_2_array_crystal_array_4, mcrotrchannel_4_analyzer_2_array_crystal_array_4;
Coords mcposachannel_4_analyzer_2_array_crystal_array_5, mcposrchannel_4_analyzer_2_array_crystal_array_5;
Rotation mcrotachannel_4_analyzer_2_array_crystal_array_5, mcrotrchannel_4_analyzer_2_array_crystal_array_5;
Coords mcposachannel_4_analyzer_2_array_crystal_array_6, mcposrchannel_4_analyzer_2_array_crystal_array_6;
Rotation mcrotachannel_4_analyzer_2_array_crystal_array_6, mcrotrchannel_4_analyzer_2_array_crystal_array_6;
Coords mcposachannel_4_analyzer_2_array_crystal_array_7, mcposrchannel_4_analyzer_2_array_crystal_array_7;
Rotation mcrotachannel_4_analyzer_2_array_crystal_array_7, mcrotrchannel_4_analyzer_2_array_crystal_array_7;
Coords mcposachannel_4_analyzer_2_array_crystal_array_8, mcposrchannel_4_analyzer_2_array_crystal_array_8;
Rotation mcrotachannel_4_analyzer_2_array_crystal_array_8, mcrotrchannel_4_analyzer_2_array_crystal_array_8;
Coords mcposachannel_4_cave2_cyl1, mcposrchannel_4_cave2_cyl1;
Rotation mcrotachannel_4_cave2_cyl1, mcrotrchannel_4_cave2_cyl1;
Coords mcposachannel_4_cave2_box1, mcposrchannel_4_cave2_box1;
Rotation mcrotachannel_4_cave2_box1, mcrotrchannel_4_cave2_box1;
Coords mcposachannel_4_cave2_box2, mcposrchannel_4_cave2_box2;
Rotation mcrotachannel_4_cave2_box2, mcrotrchannel_4_cave2_box2;
Coords mcposachannel_4_cave2_box3, mcposrchannel_4_cave2_box3;
Rotation mcrotachannel_4_cave2_box3, mcrotrchannel_4_cave2_box3;
Coords mcposainter_analyzer_colimator_center_4, mcposrinter_analyzer_colimator_center_4;
Rotation mcrotainter_analyzer_colimator_center_4, mcrotrinter_analyzer_colimator_center_4;
Coords mcposainter_analyzer_colimator_4_blade_0, mcposrinter_analyzer_colimator_4_blade_0;
Rotation mcrotainter_analyzer_colimator_4_blade_0, mcrotrinter_analyzer_colimator_4_blade_0;
Coords mcposainter_analyzer_colimator_4_blade_1, mcposrinter_analyzer_colimator_4_blade_1;
Rotation mcrotainter_analyzer_colimator_4_blade_1, mcrotrinter_analyzer_colimator_4_blade_1;
Coords mcposainter_analyzer_colimator_4_blade_2, mcposrinter_analyzer_colimator_4_blade_2;
Rotation mcrotainter_analyzer_colimator_4_blade_2, mcrotrinter_analyzer_colimator_4_blade_2;
Coords mcposainter_analyzer_colimator_4_blade_3, mcposrinter_analyzer_colimator_4_blade_3;
Rotation mcrotainter_analyzer_colimator_4_blade_3, mcrotrinter_analyzer_colimator_4_blade_3;
Coords mcposainter_analyzer_colimator_4_blade_4, mcposrinter_analyzer_colimator_4_blade_4;
Rotation mcrotainter_analyzer_colimator_4_blade_4, mcrotrinter_analyzer_colimator_4_blade_4;
Coords mcposadiffraction_detector_4_exit_volume, mcposrdiffraction_detector_4_exit_volume;
Rotation mcrotadiffraction_detector_4_exit_volume, mcrotrdiffraction_detector_4_exit_volume;
Coords mcposaspec_detector_4_exit_volume, mcposrspec_detector_4_exit_volume;
Rotation mcrotaspec_detector_4_exit_volume, mcrotrspec_detector_4_exit_volume;
Coords mcposachannel_5_cave1_box1, mcposrchannel_5_cave1_box1;
Rotation mcrotachannel_5_cave1_box1, mcrotrchannel_5_cave1_box1;
Coords mcposachannel_5_cave1_box2, mcposrchannel_5_cave1_box2;
Rotation mcrotachannel_5_cave1_box2, mcrotrchannel_5_cave1_box2;
Coords mcposachannel_5_cave1_box3, mcposrchannel_5_cave1_box3;
Rotation mcrotachannel_5_cave1_box3, mcrotrchannel_5_cave1_box3;
Coords mcposachannel_5_cave1_cyl1, mcposrchannel_5_cave1_cyl1;
Rotation mcrotachannel_5_cave1_cyl1, mcrotrchannel_5_cave1_cyl1;
Coords mcposachannel_5_analyzer_1_center, mcposrchannel_5_analyzer_1_center;
Rotation mcrotachannel_5_analyzer_1_center, mcrotrchannel_5_analyzer_1_center;
Coords mcposachannel_5_analyzer_1_rotated, mcposrchannel_5_analyzer_1_rotated;
Rotation mcrotachannel_5_analyzer_1_rotated, mcrotrchannel_5_analyzer_1_rotated;
Coords mcposachannel_5_analyzer_1_array_crystal_array_0, mcposrchannel_5_analyzer_1_array_crystal_array_0;
Rotation mcrotachannel_5_analyzer_1_array_crystal_array_0, mcrotrchannel_5_analyzer_1_array_crystal_array_0;
Coords mcposachannel_5_analyzer_1_array_crystal_array_1, mcposrchannel_5_analyzer_1_array_crystal_array_1;
Rotation mcrotachannel_5_analyzer_1_array_crystal_array_1, mcrotrchannel_5_analyzer_1_array_crystal_array_1;
Coords mcposachannel_5_analyzer_1_array_crystal_array_2, mcposrchannel_5_analyzer_1_array_crystal_array_2;
Rotation mcrotachannel_5_analyzer_1_array_crystal_array_2, mcrotrchannel_5_analyzer_1_array_crystal_array_2;
Coords mcposachannel_5_analyzer_1_array_crystal_array_3, mcposrchannel_5_analyzer_1_array_crystal_array_3;
Rotation mcrotachannel_5_analyzer_1_array_crystal_array_3, mcrotrchannel_5_analyzer_1_array_crystal_array_3;
Coords mcposachannel_5_analyzer_1_array_crystal_array_4, mcposrchannel_5_analyzer_1_array_crystal_array_4;
Rotation mcrotachannel_5_analyzer_1_array_crystal_array_4, mcrotrchannel_5_analyzer_1_array_crystal_array_4;
Coords mcposachannel_5_analyzer_1_array_crystal_array_5, mcposrchannel_5_analyzer_1_array_crystal_array_5;
Rotation mcrotachannel_5_analyzer_1_array_crystal_array_5, mcrotrchannel_5_analyzer_1_array_crystal_array_5;
Coords mcposachannel_5_analyzer_1_array_crystal_array_6, mcposrchannel_5_analyzer_1_array_crystal_array_6;
Rotation mcrotachannel_5_analyzer_1_array_crystal_array_6, mcrotrchannel_5_analyzer_1_array_crystal_array_6;
Coords mcposachannel_5_analyzer_1_array_crystal_array_7, mcposrchannel_5_analyzer_1_array_crystal_array_7;
Rotation mcrotachannel_5_analyzer_1_array_crystal_array_7, mcrotrchannel_5_analyzer_1_array_crystal_array_7;
Coords mcposachannel_5_analyzer_1_array_crystal_array_8, mcposrchannel_5_analyzer_1_array_crystal_array_8;
Rotation mcrotachannel_5_analyzer_1_array_crystal_array_8, mcrotrchannel_5_analyzer_1_array_crystal_array_8;
Coords mcposachannel_5_analyzer_2_center, mcposrchannel_5_analyzer_2_center;
Rotation mcrotachannel_5_analyzer_2_center, mcrotrchannel_5_analyzer_2_center;
Coords mcposachannel_5_analyzer_2_rotated, mcposrchannel_5_analyzer_2_rotated;
Rotation mcrotachannel_5_analyzer_2_rotated, mcrotrchannel_5_analyzer_2_rotated;
Coords mcposachannel_5_analyzer_2_array_crystal_array_0, mcposrchannel_5_analyzer_2_array_crystal_array_0;
Rotation mcrotachannel_5_analyzer_2_array_crystal_array_0, mcrotrchannel_5_analyzer_2_array_crystal_array_0;
Coords mcposachannel_5_analyzer_2_array_crystal_array_1, mcposrchannel_5_analyzer_2_array_crystal_array_1;
Rotation mcrotachannel_5_analyzer_2_array_crystal_array_1, mcrotrchannel_5_analyzer_2_array_crystal_array_1;
Coords mcposachannel_5_analyzer_2_array_crystal_array_2, mcposrchannel_5_analyzer_2_array_crystal_array_2;
Rotation mcrotachannel_5_analyzer_2_array_crystal_array_2, mcrotrchannel_5_analyzer_2_array_crystal_array_2;
Coords mcposachannel_5_analyzer_2_array_crystal_array_3, mcposrchannel_5_analyzer_2_array_crystal_array_3;
Rotation mcrotachannel_5_analyzer_2_array_crystal_array_3, mcrotrchannel_5_analyzer_2_array_crystal_array_3;
Coords mcposachannel_5_analyzer_2_array_crystal_array_4, mcposrchannel_5_analyzer_2_array_crystal_array_4;
Rotation mcrotachannel_5_analyzer_2_array_crystal_array_4, mcrotrchannel_5_analyzer_2_array_crystal_array_4;
Coords mcposachannel_5_analyzer_2_array_crystal_array_5, mcposrchannel_5_analyzer_2_array_crystal_array_5;
Rotation mcrotachannel_5_analyzer_2_array_crystal_array_5, mcrotrchannel_5_analyzer_2_array_crystal_array_5;
Coords mcposachannel_5_analyzer_2_array_crystal_array_6, mcposrchannel_5_analyzer_2_array_crystal_array_6;
Rotation mcrotachannel_5_analyzer_2_array_crystal_array_6, mcrotrchannel_5_analyzer_2_array_crystal_array_6;
Coords mcposachannel_5_analyzer_2_array_crystal_array_7, mcposrchannel_5_analyzer_2_array_crystal_array_7;
Rotation mcrotachannel_5_analyzer_2_array_crystal_array_7, mcrotrchannel_5_analyzer_2_array_crystal_array_7;
Coords mcposachannel_5_analyzer_2_array_crystal_array_8, mcposrchannel_5_analyzer_2_array_crystal_array_8;
Rotation mcrotachannel_5_analyzer_2_array_crystal_array_8, mcrotrchannel_5_analyzer_2_array_crystal_array_8;
Coords mcposachannel_5_cave2_cyl1, mcposrchannel_5_cave2_cyl1;
Rotation mcrotachannel_5_cave2_cyl1, mcrotrchannel_5_cave2_cyl1;
Coords mcposachannel_5_cave2_box1, mcposrchannel_5_cave2_box1;
Rotation mcrotachannel_5_cave2_box1, mcrotrchannel_5_cave2_box1;
Coords mcposachannel_5_cave2_box2, mcposrchannel_5_cave2_box2;
Rotation mcrotachannel_5_cave2_box2, mcrotrchannel_5_cave2_box2;
Coords mcposachannel_5_cave2_box3, mcposrchannel_5_cave2_box3;
Rotation mcrotachannel_5_cave2_box3, mcrotrchannel_5_cave2_box3;
Coords mcposainter_analyzer_colimator_center_5, mcposrinter_analyzer_colimator_center_5;
Rotation mcrotainter_analyzer_colimator_center_5, mcrotrinter_analyzer_colimator_center_5;
Coords mcposainter_analyzer_colimator_5_blade_0, mcposrinter_analyzer_colimator_5_blade_0;
Rotation mcrotainter_analyzer_colimator_5_blade_0, mcrotrinter_analyzer_colimator_5_blade_0;
Coords mcposainter_analyzer_colimator_5_blade_1, mcposrinter_analyzer_colimator_5_blade_1;
Rotation mcrotainter_analyzer_colimator_5_blade_1, mcrotrinter_analyzer_colimator_5_blade_1;
Coords mcposainter_analyzer_colimator_5_blade_2, mcposrinter_analyzer_colimator_5_blade_2;
Rotation mcrotainter_analyzer_colimator_5_blade_2, mcrotrinter_analyzer_colimator_5_blade_2;
Coords mcposainter_analyzer_colimator_5_blade_3, mcposrinter_analyzer_colimator_5_blade_3;
Rotation mcrotainter_analyzer_colimator_5_blade_3, mcrotrinter_analyzer_colimator_5_blade_3;
Coords mcposainter_analyzer_colimator_5_blade_4, mcposrinter_analyzer_colimator_5_blade_4;
Rotation mcrotainter_analyzer_colimator_5_blade_4, mcrotrinter_analyzer_colimator_5_blade_4;
Coords mcposadiffraction_detector_5_exit_volume, mcposrdiffraction_detector_5_exit_volume;
Rotation mcrotadiffraction_detector_5_exit_volume, mcrotrdiffraction_detector_5_exit_volume;
Coords mcposaspec_detector_5_exit_volume, mcposrspec_detector_5_exit_volume;
Rotation mcrotaspec_detector_5_exit_volume, mcrotrspec_detector_5_exit_volume;
Coords mcposachannel_6_cave1_box1, mcposrchannel_6_cave1_box1;
Rotation mcrotachannel_6_cave1_box1, mcrotrchannel_6_cave1_box1;
Coords mcposachannel_6_cave1_box2, mcposrchannel_6_cave1_box2;
Rotation mcrotachannel_6_cave1_box2, mcrotrchannel_6_cave1_box2;
Coords mcposachannel_6_cave1_box3, mcposrchannel_6_cave1_box3;
Rotation mcrotachannel_6_cave1_box3, mcrotrchannel_6_cave1_box3;
Coords mcposachannel_6_cave1_cyl1, mcposrchannel_6_cave1_cyl1;
Rotation mcrotachannel_6_cave1_cyl1, mcrotrchannel_6_cave1_cyl1;
Coords mcposachannel_6_analyzer_1_center, mcposrchannel_6_analyzer_1_center;
Rotation mcrotachannel_6_analyzer_1_center, mcrotrchannel_6_analyzer_1_center;
Coords mcposachannel_6_analyzer_1_rotated, mcposrchannel_6_analyzer_1_rotated;
Rotation mcrotachannel_6_analyzer_1_rotated, mcrotrchannel_6_analyzer_1_rotated;
Coords mcposachannel_6_analyzer_1_array_crystal_array_0, mcposrchannel_6_analyzer_1_array_crystal_array_0;
Rotation mcrotachannel_6_analyzer_1_array_crystal_array_0, mcrotrchannel_6_analyzer_1_array_crystal_array_0;
Coords mcposachannel_6_analyzer_1_array_crystal_array_1, mcposrchannel_6_analyzer_1_array_crystal_array_1;
Rotation mcrotachannel_6_analyzer_1_array_crystal_array_1, mcrotrchannel_6_analyzer_1_array_crystal_array_1;
Coords mcposachannel_6_analyzer_1_array_crystal_array_2, mcposrchannel_6_analyzer_1_array_crystal_array_2;
Rotation mcrotachannel_6_analyzer_1_array_crystal_array_2, mcrotrchannel_6_analyzer_1_array_crystal_array_2;
Coords mcposachannel_6_analyzer_1_array_crystal_array_3, mcposrchannel_6_analyzer_1_array_crystal_array_3;
Rotation mcrotachannel_6_analyzer_1_array_crystal_array_3, mcrotrchannel_6_analyzer_1_array_crystal_array_3;
Coords mcposachannel_6_analyzer_1_array_crystal_array_4, mcposrchannel_6_analyzer_1_array_crystal_array_4;
Rotation mcrotachannel_6_analyzer_1_array_crystal_array_4, mcrotrchannel_6_analyzer_1_array_crystal_array_4;
Coords mcposachannel_6_analyzer_1_array_crystal_array_5, mcposrchannel_6_analyzer_1_array_crystal_array_5;
Rotation mcrotachannel_6_analyzer_1_array_crystal_array_5, mcrotrchannel_6_analyzer_1_array_crystal_array_5;
Coords mcposachannel_6_analyzer_1_array_crystal_array_6, mcposrchannel_6_analyzer_1_array_crystal_array_6;
Rotation mcrotachannel_6_analyzer_1_array_crystal_array_6, mcrotrchannel_6_analyzer_1_array_crystal_array_6;
Coords mcposachannel_6_analyzer_1_array_crystal_array_7, mcposrchannel_6_analyzer_1_array_crystal_array_7;
Rotation mcrotachannel_6_analyzer_1_array_crystal_array_7, mcrotrchannel_6_analyzer_1_array_crystal_array_7;
Coords mcposachannel_6_analyzer_1_array_crystal_array_8, mcposrchannel_6_analyzer_1_array_crystal_array_8;
Rotation mcrotachannel_6_analyzer_1_array_crystal_array_8, mcrotrchannel_6_analyzer_1_array_crystal_array_8;
Coords mcposachannel_6_analyzer_2_center, mcposrchannel_6_analyzer_2_center;
Rotation mcrotachannel_6_analyzer_2_center, mcrotrchannel_6_analyzer_2_center;
Coords mcposachannel_6_analyzer_2_rotated, mcposrchannel_6_analyzer_2_rotated;
Rotation mcrotachannel_6_analyzer_2_rotated, mcrotrchannel_6_analyzer_2_rotated;
Coords mcposachannel_6_analyzer_2_array_crystal_array_0, mcposrchannel_6_analyzer_2_array_crystal_array_0;
Rotation mcrotachannel_6_analyzer_2_array_crystal_array_0, mcrotrchannel_6_analyzer_2_array_crystal_array_0;
Coords mcposachannel_6_analyzer_2_array_crystal_array_1, mcposrchannel_6_analyzer_2_array_crystal_array_1;
Rotation mcrotachannel_6_analyzer_2_array_crystal_array_1, mcrotrchannel_6_analyzer_2_array_crystal_array_1;
Coords mcposachannel_6_analyzer_2_array_crystal_array_2, mcposrchannel_6_analyzer_2_array_crystal_array_2;
Rotation mcrotachannel_6_analyzer_2_array_crystal_array_2, mcrotrchannel_6_analyzer_2_array_crystal_array_2;
Coords mcposachannel_6_analyzer_2_array_crystal_array_3, mcposrchannel_6_analyzer_2_array_crystal_array_3;
Rotation mcrotachannel_6_analyzer_2_array_crystal_array_3, mcrotrchannel_6_analyzer_2_array_crystal_array_3;
Coords mcposachannel_6_analyzer_2_array_crystal_array_4, mcposrchannel_6_analyzer_2_array_crystal_array_4;
Rotation mcrotachannel_6_analyzer_2_array_crystal_array_4, mcrotrchannel_6_analyzer_2_array_crystal_array_4;
Coords mcposachannel_6_analyzer_2_array_crystal_array_5, mcposrchannel_6_analyzer_2_array_crystal_array_5;
Rotation mcrotachannel_6_analyzer_2_array_crystal_array_5, mcrotrchannel_6_analyzer_2_array_crystal_array_5;
Coords mcposachannel_6_analyzer_2_array_crystal_array_6, mcposrchannel_6_analyzer_2_array_crystal_array_6;
Rotation mcrotachannel_6_analyzer_2_array_crystal_array_6, mcrotrchannel_6_analyzer_2_array_crystal_array_6;
Coords mcposachannel_6_analyzer_2_array_crystal_array_7, mcposrchannel_6_analyzer_2_array_crystal_array_7;
Rotation mcrotachannel_6_analyzer_2_array_crystal_array_7, mcrotrchannel_6_analyzer_2_array_crystal_array_7;
Coords mcposachannel_6_analyzer_2_array_crystal_array_8, mcposrchannel_6_analyzer_2_array_crystal_array_8;
Rotation mcrotachannel_6_analyzer_2_array_crystal_array_8, mcrotrchannel_6_analyzer_2_array_crystal_array_8;
Coords mcposachannel_6_cave2_cyl1, mcposrchannel_6_cave2_cyl1;
Rotation mcrotachannel_6_cave2_cyl1, mcrotrchannel_6_cave2_cyl1;
Coords mcposachannel_6_cave2_box1, mcposrchannel_6_cave2_box1;
Rotation mcrotachannel_6_cave2_box1, mcrotrchannel_6_cave2_box1;
Coords mcposachannel_6_cave2_box2, mcposrchannel_6_cave2_box2;
Rotation mcrotachannel_6_cave2_box2, mcrotrchannel_6_cave2_box2;
Coords mcposachannel_6_cave2_box3, mcposrchannel_6_cave2_box3;
Rotation mcrotachannel_6_cave2_box3, mcrotrchannel_6_cave2_box3;
Coords mcposainter_analyzer_colimator_center_6, mcposrinter_analyzer_colimator_center_6;
Rotation mcrotainter_analyzer_colimator_center_6, mcrotrinter_analyzer_colimator_center_6;
Coords mcposainter_analyzer_colimator_6_blade_0, mcposrinter_analyzer_colimator_6_blade_0;
Rotation mcrotainter_analyzer_colimator_6_blade_0, mcrotrinter_analyzer_colimator_6_blade_0;
Coords mcposainter_analyzer_colimator_6_blade_1, mcposrinter_analyzer_colimator_6_blade_1;
Rotation mcrotainter_analyzer_colimator_6_blade_1, mcrotrinter_analyzer_colimator_6_blade_1;
Coords mcposainter_analyzer_colimator_6_blade_2, mcposrinter_analyzer_colimator_6_blade_2;
Rotation mcrotainter_analyzer_colimator_6_blade_2, mcrotrinter_analyzer_colimator_6_blade_2;
Coords mcposainter_analyzer_colimator_6_blade_3, mcposrinter_analyzer_colimator_6_blade_3;
Rotation mcrotainter_analyzer_colimator_6_blade_3, mcrotrinter_analyzer_colimator_6_blade_3;
Coords mcposainter_analyzer_colimator_6_blade_4, mcposrinter_analyzer_colimator_6_blade_4;
Rotation mcrotainter_analyzer_colimator_6_blade_4, mcrotrinter_analyzer_colimator_6_blade_4;
Coords mcposadiffraction_detector_6_exit_volume, mcposrdiffraction_detector_6_exit_volume;
Rotation mcrotadiffraction_detector_6_exit_volume, mcrotrdiffraction_detector_6_exit_volume;
Coords mcposaspec_detector_6_exit_volume, mcposrspec_detector_6_exit_volume;
Rotation mcrotaspec_detector_6_exit_volume, mcrotrspec_detector_6_exit_volume;
Coords mcposachannel_7_cave1_box1, mcposrchannel_7_cave1_box1;
Rotation mcrotachannel_7_cave1_box1, mcrotrchannel_7_cave1_box1;
Coords mcposachannel_7_cave1_box2, mcposrchannel_7_cave1_box2;
Rotation mcrotachannel_7_cave1_box2, mcrotrchannel_7_cave1_box2;
Coords mcposachannel_7_cave1_box3, mcposrchannel_7_cave1_box3;
Rotation mcrotachannel_7_cave1_box3, mcrotrchannel_7_cave1_box3;
Coords mcposachannel_7_cave1_cyl1, mcposrchannel_7_cave1_cyl1;
Rotation mcrotachannel_7_cave1_cyl1, mcrotrchannel_7_cave1_cyl1;
Coords mcposachannel_7_analyzer_1_center, mcposrchannel_7_analyzer_1_center;
Rotation mcrotachannel_7_analyzer_1_center, mcrotrchannel_7_analyzer_1_center;
Coords mcposachannel_7_analyzer_1_rotated, mcposrchannel_7_analyzer_1_rotated;
Rotation mcrotachannel_7_analyzer_1_rotated, mcrotrchannel_7_analyzer_1_rotated;
Coords mcposachannel_7_analyzer_1_array_crystal_array_0, mcposrchannel_7_analyzer_1_array_crystal_array_0;
Rotation mcrotachannel_7_analyzer_1_array_crystal_array_0, mcrotrchannel_7_analyzer_1_array_crystal_array_0;
Coords mcposachannel_7_analyzer_1_array_crystal_array_1, mcposrchannel_7_analyzer_1_array_crystal_array_1;
Rotation mcrotachannel_7_analyzer_1_array_crystal_array_1, mcrotrchannel_7_analyzer_1_array_crystal_array_1;
Coords mcposachannel_7_analyzer_1_array_crystal_array_2, mcposrchannel_7_analyzer_1_array_crystal_array_2;
Rotation mcrotachannel_7_analyzer_1_array_crystal_array_2, mcrotrchannel_7_analyzer_1_array_crystal_array_2;
Coords mcposachannel_7_analyzer_1_array_crystal_array_3, mcposrchannel_7_analyzer_1_array_crystal_array_3;
Rotation mcrotachannel_7_analyzer_1_array_crystal_array_3, mcrotrchannel_7_analyzer_1_array_crystal_array_3;
Coords mcposachannel_7_analyzer_1_array_crystal_array_4, mcposrchannel_7_analyzer_1_array_crystal_array_4;
Rotation mcrotachannel_7_analyzer_1_array_crystal_array_4, mcrotrchannel_7_analyzer_1_array_crystal_array_4;
Coords mcposachannel_7_analyzer_1_array_crystal_array_5, mcposrchannel_7_analyzer_1_array_crystal_array_5;
Rotation mcrotachannel_7_analyzer_1_array_crystal_array_5, mcrotrchannel_7_analyzer_1_array_crystal_array_5;
Coords mcposachannel_7_analyzer_1_array_crystal_array_6, mcposrchannel_7_analyzer_1_array_crystal_array_6;
Rotation mcrotachannel_7_analyzer_1_array_crystal_array_6, mcrotrchannel_7_analyzer_1_array_crystal_array_6;
Coords mcposachannel_7_analyzer_1_array_crystal_array_7, mcposrchannel_7_analyzer_1_array_crystal_array_7;
Rotation mcrotachannel_7_analyzer_1_array_crystal_array_7, mcrotrchannel_7_analyzer_1_array_crystal_array_7;
Coords mcposachannel_7_analyzer_1_array_crystal_array_8, mcposrchannel_7_analyzer_1_array_crystal_array_8;
Rotation mcrotachannel_7_analyzer_1_array_crystal_array_8, mcrotrchannel_7_analyzer_1_array_crystal_array_8;
Coords mcposachannel_7_analyzer_2_center, mcposrchannel_7_analyzer_2_center;
Rotation mcrotachannel_7_analyzer_2_center, mcrotrchannel_7_analyzer_2_center;
Coords mcposachannel_7_analyzer_2_rotated, mcposrchannel_7_analyzer_2_rotated;
Rotation mcrotachannel_7_analyzer_2_rotated, mcrotrchannel_7_analyzer_2_rotated;
Coords mcposachannel_7_analyzer_2_array_crystal_array_0, mcposrchannel_7_analyzer_2_array_crystal_array_0;
Rotation mcrotachannel_7_analyzer_2_array_crystal_array_0, mcrotrchannel_7_analyzer_2_array_crystal_array_0;
Coords mcposachannel_7_analyzer_2_array_crystal_array_1, mcposrchannel_7_analyzer_2_array_crystal_array_1;
Rotation mcrotachannel_7_analyzer_2_array_crystal_array_1, mcrotrchannel_7_analyzer_2_array_crystal_array_1;
Coords mcposachannel_7_analyzer_2_array_crystal_array_2, mcposrchannel_7_analyzer_2_array_crystal_array_2;
Rotation mcrotachannel_7_analyzer_2_array_crystal_array_2, mcrotrchannel_7_analyzer_2_array_crystal_array_2;
Coords mcposachannel_7_analyzer_2_array_crystal_array_3, mcposrchannel_7_analyzer_2_array_crystal_array_3;
Rotation mcrotachannel_7_analyzer_2_array_crystal_array_3, mcrotrchannel_7_analyzer_2_array_crystal_array_3;
Coords mcposachannel_7_analyzer_2_array_crystal_array_4, mcposrchannel_7_analyzer_2_array_crystal_array_4;
Rotation mcrotachannel_7_analyzer_2_array_crystal_array_4, mcrotrchannel_7_analyzer_2_array_crystal_array_4;
Coords mcposachannel_7_analyzer_2_array_crystal_array_5, mcposrchannel_7_analyzer_2_array_crystal_array_5;
Rotation mcrotachannel_7_analyzer_2_array_crystal_array_5, mcrotrchannel_7_analyzer_2_array_crystal_array_5;
Coords mcposachannel_7_analyzer_2_array_crystal_array_6, mcposrchannel_7_analyzer_2_array_crystal_array_6;
Rotation mcrotachannel_7_analyzer_2_array_crystal_array_6, mcrotrchannel_7_analyzer_2_array_crystal_array_6;
Coords mcposachannel_7_analyzer_2_array_crystal_array_7, mcposrchannel_7_analyzer_2_array_crystal_array_7;
Rotation mcrotachannel_7_analyzer_2_array_crystal_array_7, mcrotrchannel_7_analyzer_2_array_crystal_array_7;
Coords mcposachannel_7_analyzer_2_array_crystal_array_8, mcposrchannel_7_analyzer_2_array_crystal_array_8;
Rotation mcrotachannel_7_analyzer_2_array_crystal_array_8, mcrotrchannel_7_analyzer_2_array_crystal_array_8;
Coords mcposachannel_7_cave2_cyl1, mcposrchannel_7_cave2_cyl1;
Rotation mcrotachannel_7_cave2_cyl1, mcrotrchannel_7_cave2_cyl1;
Coords mcposachannel_7_cave2_box1, mcposrchannel_7_cave2_box1;
Rotation mcrotachannel_7_cave2_box1, mcrotrchannel_7_cave2_box1;
Coords mcposachannel_7_cave2_box2, mcposrchannel_7_cave2_box2;
Rotation mcrotachannel_7_cave2_box2, mcrotrchannel_7_cave2_box2;
Coords mcposachannel_7_cave2_box3, mcposrchannel_7_cave2_box3;
Rotation mcrotachannel_7_cave2_box3, mcrotrchannel_7_cave2_box3;
Coords mcposainter_analyzer_colimator_center_7, mcposrinter_analyzer_colimator_center_7;
Rotation mcrotainter_analyzer_colimator_center_7, mcrotrinter_analyzer_colimator_center_7;
Coords mcposainter_analyzer_colimator_7_blade_0, mcposrinter_analyzer_colimator_7_blade_0;
Rotation mcrotainter_analyzer_colimator_7_blade_0, mcrotrinter_analyzer_colimator_7_blade_0;
Coords mcposainter_analyzer_colimator_7_blade_1, mcposrinter_analyzer_colimator_7_blade_1;
Rotation mcrotainter_analyzer_colimator_7_blade_1, mcrotrinter_analyzer_colimator_7_blade_1;
Coords mcposainter_analyzer_colimator_7_blade_2, mcposrinter_analyzer_colimator_7_blade_2;
Rotation mcrotainter_analyzer_colimator_7_blade_2, mcrotrinter_analyzer_colimator_7_blade_2;
Coords mcposainter_analyzer_colimator_7_blade_3, mcposrinter_analyzer_colimator_7_blade_3;
Rotation mcrotainter_analyzer_colimator_7_blade_3, mcrotrinter_analyzer_colimator_7_blade_3;
Coords mcposainter_analyzer_colimator_7_blade_4, mcposrinter_analyzer_colimator_7_blade_4;
Rotation mcrotainter_analyzer_colimator_7_blade_4, mcrotrinter_analyzer_colimator_7_blade_4;
Coords mcposadiffraction_detector_7_exit_volume, mcposrdiffraction_detector_7_exit_volume;
Rotation mcrotadiffraction_detector_7_exit_volume, mcrotrdiffraction_detector_7_exit_volume;
Coords mcposaspec_detector_7_exit_volume, mcposrspec_detector_7_exit_volume;
Rotation mcrotaspec_detector_7_exit_volume, mcrotrspec_detector_7_exit_volume;
Coords mcposachannel_8_cave1_box1, mcposrchannel_8_cave1_box1;
Rotation mcrotachannel_8_cave1_box1, mcrotrchannel_8_cave1_box1;
Coords mcposachannel_8_cave1_box2, mcposrchannel_8_cave1_box2;
Rotation mcrotachannel_8_cave1_box2, mcrotrchannel_8_cave1_box2;
Coords mcposachannel_8_cave1_box3, mcposrchannel_8_cave1_box3;
Rotation mcrotachannel_8_cave1_box3, mcrotrchannel_8_cave1_box3;
Coords mcposachannel_8_cave1_cyl1, mcposrchannel_8_cave1_cyl1;
Rotation mcrotachannel_8_cave1_cyl1, mcrotrchannel_8_cave1_cyl1;
Coords mcposachannel_8_analyzer_1_center, mcposrchannel_8_analyzer_1_center;
Rotation mcrotachannel_8_analyzer_1_center, mcrotrchannel_8_analyzer_1_center;
Coords mcposachannel_8_analyzer_1_rotated, mcposrchannel_8_analyzer_1_rotated;
Rotation mcrotachannel_8_analyzer_1_rotated, mcrotrchannel_8_analyzer_1_rotated;
Coords mcposachannel_8_analyzer_1_array_crystal_array_0, mcposrchannel_8_analyzer_1_array_crystal_array_0;
Rotation mcrotachannel_8_analyzer_1_array_crystal_array_0, mcrotrchannel_8_analyzer_1_array_crystal_array_0;
Coords mcposachannel_8_analyzer_1_array_crystal_array_1, mcposrchannel_8_analyzer_1_array_crystal_array_1;
Rotation mcrotachannel_8_analyzer_1_array_crystal_array_1, mcrotrchannel_8_analyzer_1_array_crystal_array_1;
Coords mcposachannel_8_analyzer_1_array_crystal_array_2, mcposrchannel_8_analyzer_1_array_crystal_array_2;
Rotation mcrotachannel_8_analyzer_1_array_crystal_array_2, mcrotrchannel_8_analyzer_1_array_crystal_array_2;
Coords mcposachannel_8_analyzer_1_array_crystal_array_3, mcposrchannel_8_analyzer_1_array_crystal_array_3;
Rotation mcrotachannel_8_analyzer_1_array_crystal_array_3, mcrotrchannel_8_analyzer_1_array_crystal_array_3;
Coords mcposachannel_8_analyzer_1_array_crystal_array_4, mcposrchannel_8_analyzer_1_array_crystal_array_4;
Rotation mcrotachannel_8_analyzer_1_array_crystal_array_4, mcrotrchannel_8_analyzer_1_array_crystal_array_4;
Coords mcposachannel_8_analyzer_1_array_crystal_array_5, mcposrchannel_8_analyzer_1_array_crystal_array_5;
Rotation mcrotachannel_8_analyzer_1_array_crystal_array_5, mcrotrchannel_8_analyzer_1_array_crystal_array_5;
Coords mcposachannel_8_analyzer_1_array_crystal_array_6, mcposrchannel_8_analyzer_1_array_crystal_array_6;
Rotation mcrotachannel_8_analyzer_1_array_crystal_array_6, mcrotrchannel_8_analyzer_1_array_crystal_array_6;
Coords mcposachannel_8_analyzer_1_array_crystal_array_7, mcposrchannel_8_analyzer_1_array_crystal_array_7;
Rotation mcrotachannel_8_analyzer_1_array_crystal_array_7, mcrotrchannel_8_analyzer_1_array_crystal_array_7;
Coords mcposachannel_8_analyzer_1_array_crystal_array_8, mcposrchannel_8_analyzer_1_array_crystal_array_8;
Rotation mcrotachannel_8_analyzer_1_array_crystal_array_8, mcrotrchannel_8_analyzer_1_array_crystal_array_8;
Coords mcposachannel_8_analyzer_2_center, mcposrchannel_8_analyzer_2_center;
Rotation mcrotachannel_8_analyzer_2_center, mcrotrchannel_8_analyzer_2_center;
Coords mcposachannel_8_analyzer_2_rotated, mcposrchannel_8_analyzer_2_rotated;
Rotation mcrotachannel_8_analyzer_2_rotated, mcrotrchannel_8_analyzer_2_rotated;
Coords mcposachannel_8_analyzer_2_array_crystal_array_0, mcposrchannel_8_analyzer_2_array_crystal_array_0;
Rotation mcrotachannel_8_analyzer_2_array_crystal_array_0, mcrotrchannel_8_analyzer_2_array_crystal_array_0;
Coords mcposachannel_8_analyzer_2_array_crystal_array_1, mcposrchannel_8_analyzer_2_array_crystal_array_1;
Rotation mcrotachannel_8_analyzer_2_array_crystal_array_1, mcrotrchannel_8_analyzer_2_array_crystal_array_1;
Coords mcposachannel_8_analyzer_2_array_crystal_array_2, mcposrchannel_8_analyzer_2_array_crystal_array_2;
Rotation mcrotachannel_8_analyzer_2_array_crystal_array_2, mcrotrchannel_8_analyzer_2_array_crystal_array_2;
Coords mcposachannel_8_analyzer_2_array_crystal_array_3, mcposrchannel_8_analyzer_2_array_crystal_array_3;
Rotation mcrotachannel_8_analyzer_2_array_crystal_array_3, mcrotrchannel_8_analyzer_2_array_crystal_array_3;
Coords mcposachannel_8_analyzer_2_array_crystal_array_4, mcposrchannel_8_analyzer_2_array_crystal_array_4;
Rotation mcrotachannel_8_analyzer_2_array_crystal_array_4, mcrotrchannel_8_analyzer_2_array_crystal_array_4;
Coords mcposachannel_8_analyzer_2_array_crystal_array_5, mcposrchannel_8_analyzer_2_array_crystal_array_5;
Rotation mcrotachannel_8_analyzer_2_array_crystal_array_5, mcrotrchannel_8_analyzer_2_array_crystal_array_5;
Coords mcposachannel_8_analyzer_2_array_crystal_array_6, mcposrchannel_8_analyzer_2_array_crystal_array_6;
Rotation mcrotachannel_8_analyzer_2_array_crystal_array_6, mcrotrchannel_8_analyzer_2_array_crystal_array_6;
Coords mcposachannel_8_analyzer_2_array_crystal_array_7, mcposrchannel_8_analyzer_2_array_crystal_array_7;
Rotation mcrotachannel_8_analyzer_2_array_crystal_array_7, mcrotrchannel_8_analyzer_2_array_crystal_array_7;
Coords mcposachannel_8_analyzer_2_array_crystal_array_8, mcposrchannel_8_analyzer_2_array_crystal_array_8;
Rotation mcrotachannel_8_analyzer_2_array_crystal_array_8, mcrotrchannel_8_analyzer_2_array_crystal_array_8;
Coords mcposachannel_8_cave2_cyl1, mcposrchannel_8_cave2_cyl1;
Rotation mcrotachannel_8_cave2_cyl1, mcrotrchannel_8_cave2_cyl1;
Coords mcposachannel_8_cave2_box1, mcposrchannel_8_cave2_box1;
Rotation mcrotachannel_8_cave2_box1, mcrotrchannel_8_cave2_box1;
Coords mcposachannel_8_cave2_box2, mcposrchannel_8_cave2_box2;
Rotation mcrotachannel_8_cave2_box2, mcrotrchannel_8_cave2_box2;
Coords mcposachannel_8_cave2_box3, mcposrchannel_8_cave2_box3;
Rotation mcrotachannel_8_cave2_box3, mcrotrchannel_8_cave2_box3;
Coords mcposainter_analyzer_colimator_center_8, mcposrinter_analyzer_colimator_center_8;
Rotation mcrotainter_analyzer_colimator_center_8, mcrotrinter_analyzer_colimator_center_8;
Coords mcposainter_analyzer_colimator_8_blade_0, mcposrinter_analyzer_colimator_8_blade_0;
Rotation mcrotainter_analyzer_colimator_8_blade_0, mcrotrinter_analyzer_colimator_8_blade_0;
Coords mcposainter_analyzer_colimator_8_blade_1, mcposrinter_analyzer_colimator_8_blade_1;
Rotation mcrotainter_analyzer_colimator_8_blade_1, mcrotrinter_analyzer_colimator_8_blade_1;
Coords mcposainter_analyzer_colimator_8_blade_2, mcposrinter_analyzer_colimator_8_blade_2;
Rotation mcrotainter_analyzer_colimator_8_blade_2, mcrotrinter_analyzer_colimator_8_blade_2;
Coords mcposainter_analyzer_colimator_8_blade_3, mcposrinter_analyzer_colimator_8_blade_3;
Rotation mcrotainter_analyzer_colimator_8_blade_3, mcrotrinter_analyzer_colimator_8_blade_3;
Coords mcposainter_analyzer_colimator_8_blade_4, mcposrinter_analyzer_colimator_8_blade_4;
Rotation mcrotainter_analyzer_colimator_8_blade_4, mcrotrinter_analyzer_colimator_8_blade_4;
Coords mcposadiffraction_detector_8_exit_volume, mcposrdiffraction_detector_8_exit_volume;
Rotation mcrotadiffraction_detector_8_exit_volume, mcrotrdiffraction_detector_8_exit_volume;
Coords mcposaspec_detector_8_exit_volume, mcposrspec_detector_8_exit_volume;
Rotation mcrotaspec_detector_8_exit_volume, mcrotrspec_detector_8_exit_volume;
Coords mcposachannel_9_cave1_box1, mcposrchannel_9_cave1_box1;
Rotation mcrotachannel_9_cave1_box1, mcrotrchannel_9_cave1_box1;
Coords mcposachannel_9_cave1_box2, mcposrchannel_9_cave1_box2;
Rotation mcrotachannel_9_cave1_box2, mcrotrchannel_9_cave1_box2;
Coords mcposachannel_9_cave1_box3, mcposrchannel_9_cave1_box3;
Rotation mcrotachannel_9_cave1_box3, mcrotrchannel_9_cave1_box3;
Coords mcposachannel_9_cave1_cyl1, mcposrchannel_9_cave1_cyl1;
Rotation mcrotachannel_9_cave1_cyl1, mcrotrchannel_9_cave1_cyl1;
Coords mcposachannel_9_analyzer_1_center, mcposrchannel_9_analyzer_1_center;
Rotation mcrotachannel_9_analyzer_1_center, mcrotrchannel_9_analyzer_1_center;
Coords mcposachannel_9_analyzer_1_rotated, mcposrchannel_9_analyzer_1_rotated;
Rotation mcrotachannel_9_analyzer_1_rotated, mcrotrchannel_9_analyzer_1_rotated;
Coords mcposachannel_9_analyzer_1_array_crystal_array_0, mcposrchannel_9_analyzer_1_array_crystal_array_0;
Rotation mcrotachannel_9_analyzer_1_array_crystal_array_0, mcrotrchannel_9_analyzer_1_array_crystal_array_0;
Coords mcposachannel_9_analyzer_1_array_crystal_array_1, mcposrchannel_9_analyzer_1_array_crystal_array_1;
Rotation mcrotachannel_9_analyzer_1_array_crystal_array_1, mcrotrchannel_9_analyzer_1_array_crystal_array_1;
Coords mcposachannel_9_analyzer_1_array_crystal_array_2, mcposrchannel_9_analyzer_1_array_crystal_array_2;
Rotation mcrotachannel_9_analyzer_1_array_crystal_array_2, mcrotrchannel_9_analyzer_1_array_crystal_array_2;
Coords mcposachannel_9_analyzer_1_array_crystal_array_3, mcposrchannel_9_analyzer_1_array_crystal_array_3;
Rotation mcrotachannel_9_analyzer_1_array_crystal_array_3, mcrotrchannel_9_analyzer_1_array_crystal_array_3;
Coords mcposachannel_9_analyzer_1_array_crystal_array_4, mcposrchannel_9_analyzer_1_array_crystal_array_4;
Rotation mcrotachannel_9_analyzer_1_array_crystal_array_4, mcrotrchannel_9_analyzer_1_array_crystal_array_4;
Coords mcposachannel_9_analyzer_1_array_crystal_array_5, mcposrchannel_9_analyzer_1_array_crystal_array_5;
Rotation mcrotachannel_9_analyzer_1_array_crystal_array_5, mcrotrchannel_9_analyzer_1_array_crystal_array_5;
Coords mcposachannel_9_analyzer_1_array_crystal_array_6, mcposrchannel_9_analyzer_1_array_crystal_array_6;
Rotation mcrotachannel_9_analyzer_1_array_crystal_array_6, mcrotrchannel_9_analyzer_1_array_crystal_array_6;
Coords mcposachannel_9_analyzer_1_array_crystal_array_7, mcposrchannel_9_analyzer_1_array_crystal_array_7;
Rotation mcrotachannel_9_analyzer_1_array_crystal_array_7, mcrotrchannel_9_analyzer_1_array_crystal_array_7;
Coords mcposachannel_9_analyzer_1_array_crystal_array_8, mcposrchannel_9_analyzer_1_array_crystal_array_8;
Rotation mcrotachannel_9_analyzer_1_array_crystal_array_8, mcrotrchannel_9_analyzer_1_array_crystal_array_8;
Coords mcposachannel_9_analyzer_2_center, mcposrchannel_9_analyzer_2_center;
Rotation mcrotachannel_9_analyzer_2_center, mcrotrchannel_9_analyzer_2_center;
Coords mcposachannel_9_analyzer_2_rotated, mcposrchannel_9_analyzer_2_rotated;
Rotation mcrotachannel_9_analyzer_2_rotated, mcrotrchannel_9_analyzer_2_rotated;
Coords mcposachannel_9_analyzer_2_array_crystal_array_0, mcposrchannel_9_analyzer_2_array_crystal_array_0;
Rotation mcrotachannel_9_analyzer_2_array_crystal_array_0, mcrotrchannel_9_analyzer_2_array_crystal_array_0;
Coords mcposachannel_9_analyzer_2_array_crystal_array_1, mcposrchannel_9_analyzer_2_array_crystal_array_1;
Rotation mcrotachannel_9_analyzer_2_array_crystal_array_1, mcrotrchannel_9_analyzer_2_array_crystal_array_1;
Coords mcposachannel_9_analyzer_2_array_crystal_array_2, mcposrchannel_9_analyzer_2_array_crystal_array_2;
Rotation mcrotachannel_9_analyzer_2_array_crystal_array_2, mcrotrchannel_9_analyzer_2_array_crystal_array_2;
Coords mcposachannel_9_analyzer_2_array_crystal_array_3, mcposrchannel_9_analyzer_2_array_crystal_array_3;
Rotation mcrotachannel_9_analyzer_2_array_crystal_array_3, mcrotrchannel_9_analyzer_2_array_crystal_array_3;
Coords mcposachannel_9_analyzer_2_array_crystal_array_4, mcposrchannel_9_analyzer_2_array_crystal_array_4;
Rotation mcrotachannel_9_analyzer_2_array_crystal_array_4, mcrotrchannel_9_analyzer_2_array_crystal_array_4;
Coords mcposachannel_9_analyzer_2_array_crystal_array_5, mcposrchannel_9_analyzer_2_array_crystal_array_5;
Rotation mcrotachannel_9_analyzer_2_array_crystal_array_5, mcrotrchannel_9_analyzer_2_array_crystal_array_5;
Coords mcposachannel_9_analyzer_2_array_crystal_array_6, mcposrchannel_9_analyzer_2_array_crystal_array_6;
Rotation mcrotachannel_9_analyzer_2_array_crystal_array_6, mcrotrchannel_9_analyzer_2_array_crystal_array_6;
Coords mcposachannel_9_analyzer_2_array_crystal_array_7, mcposrchannel_9_analyzer_2_array_crystal_array_7;
Rotation mcrotachannel_9_analyzer_2_array_crystal_array_7, mcrotrchannel_9_analyzer_2_array_crystal_array_7;
Coords mcposachannel_9_analyzer_2_array_crystal_array_8, mcposrchannel_9_analyzer_2_array_crystal_array_8;
Rotation mcrotachannel_9_analyzer_2_array_crystal_array_8, mcrotrchannel_9_analyzer_2_array_crystal_array_8;
Coords mcposachannel_9_cave2_cyl1, mcposrchannel_9_cave2_cyl1;
Rotation mcrotachannel_9_cave2_cyl1, mcrotrchannel_9_cave2_cyl1;
Coords mcposachannel_9_cave2_box1, mcposrchannel_9_cave2_box1;
Rotation mcrotachannel_9_cave2_box1, mcrotrchannel_9_cave2_box1;
Coords mcposachannel_9_cave2_box2, mcposrchannel_9_cave2_box2;
Rotation mcrotachannel_9_cave2_box2, mcrotrchannel_9_cave2_box2;
Coords mcposachannel_9_cave2_box3, mcposrchannel_9_cave2_box3;
Rotation mcrotachannel_9_cave2_box3, mcrotrchannel_9_cave2_box3;
Coords mcposainter_analyzer_colimator_center_9, mcposrinter_analyzer_colimator_center_9;
Rotation mcrotainter_analyzer_colimator_center_9, mcrotrinter_analyzer_colimator_center_9;
Coords mcposainter_analyzer_colimator_9_blade_0, mcposrinter_analyzer_colimator_9_blade_0;
Rotation mcrotainter_analyzer_colimator_9_blade_0, mcrotrinter_analyzer_colimator_9_blade_0;
Coords mcposainter_analyzer_colimator_9_blade_1, mcposrinter_analyzer_colimator_9_blade_1;
Rotation mcrotainter_analyzer_colimator_9_blade_1, mcrotrinter_analyzer_colimator_9_blade_1;
Coords mcposainter_analyzer_colimator_9_blade_2, mcposrinter_analyzer_colimator_9_blade_2;
Rotation mcrotainter_analyzer_colimator_9_blade_2, mcrotrinter_analyzer_colimator_9_blade_2;
Coords mcposainter_analyzer_colimator_9_blade_3, mcposrinter_analyzer_colimator_9_blade_3;
Rotation mcrotainter_analyzer_colimator_9_blade_3, mcrotrinter_analyzer_colimator_9_blade_3;
Coords mcposainter_analyzer_colimator_9_blade_4, mcposrinter_analyzer_colimator_9_blade_4;
Rotation mcrotainter_analyzer_colimator_9_blade_4, mcrotrinter_analyzer_colimator_9_blade_4;
Coords mcposadiffraction_detector_9_exit_volume, mcposrdiffraction_detector_9_exit_volume;
Rotation mcrotadiffraction_detector_9_exit_volume, mcrotrdiffraction_detector_9_exit_volume;
Coords mcposaspec_detector_9_exit_volume, mcposrspec_detector_9_exit_volume;
Rotation mcrotaspec_detector_9_exit_volume, mcrotrspec_detector_9_exit_volume;
Coords mcposachannel_10_cave1_box1, mcposrchannel_10_cave1_box1;
Rotation mcrotachannel_10_cave1_box1, mcrotrchannel_10_cave1_box1;
Coords mcposachannel_10_cave1_box2, mcposrchannel_10_cave1_box2;
Rotation mcrotachannel_10_cave1_box2, mcrotrchannel_10_cave1_box2;
Coords mcposachannel_10_cave1_box3, mcposrchannel_10_cave1_box3;
Rotation mcrotachannel_10_cave1_box3, mcrotrchannel_10_cave1_box3;
Coords mcposachannel_10_cave1_cyl1, mcposrchannel_10_cave1_cyl1;
Rotation mcrotachannel_10_cave1_cyl1, mcrotrchannel_10_cave1_cyl1;
Coords mcposachannel_10_analyzer_1_center, mcposrchannel_10_analyzer_1_center;
Rotation mcrotachannel_10_analyzer_1_center, mcrotrchannel_10_analyzer_1_center;
Coords mcposachannel_10_analyzer_1_rotated, mcposrchannel_10_analyzer_1_rotated;
Rotation mcrotachannel_10_analyzer_1_rotated, mcrotrchannel_10_analyzer_1_rotated;
Coords mcposachannel_10_analyzer_1_array_crystal_array_0, mcposrchannel_10_analyzer_1_array_crystal_array_0;
Rotation mcrotachannel_10_analyzer_1_array_crystal_array_0, mcrotrchannel_10_analyzer_1_array_crystal_array_0;
Coords mcposachannel_10_analyzer_1_array_crystal_array_1, mcposrchannel_10_analyzer_1_array_crystal_array_1;
Rotation mcrotachannel_10_analyzer_1_array_crystal_array_1, mcrotrchannel_10_analyzer_1_array_crystal_array_1;
Coords mcposachannel_10_analyzer_1_array_crystal_array_2, mcposrchannel_10_analyzer_1_array_crystal_array_2;
Rotation mcrotachannel_10_analyzer_1_array_crystal_array_2, mcrotrchannel_10_analyzer_1_array_crystal_array_2;
Coords mcposachannel_10_analyzer_1_array_crystal_array_3, mcposrchannel_10_analyzer_1_array_crystal_array_3;
Rotation mcrotachannel_10_analyzer_1_array_crystal_array_3, mcrotrchannel_10_analyzer_1_array_crystal_array_3;
Coords mcposachannel_10_analyzer_1_array_crystal_array_4, mcposrchannel_10_analyzer_1_array_crystal_array_4;
Rotation mcrotachannel_10_analyzer_1_array_crystal_array_4, mcrotrchannel_10_analyzer_1_array_crystal_array_4;
Coords mcposachannel_10_analyzer_1_array_crystal_array_5, mcposrchannel_10_analyzer_1_array_crystal_array_5;
Rotation mcrotachannel_10_analyzer_1_array_crystal_array_5, mcrotrchannel_10_analyzer_1_array_crystal_array_5;
Coords mcposachannel_10_analyzer_1_array_crystal_array_6, mcposrchannel_10_analyzer_1_array_crystal_array_6;
Rotation mcrotachannel_10_analyzer_1_array_crystal_array_6, mcrotrchannel_10_analyzer_1_array_crystal_array_6;
Coords mcposachannel_10_analyzer_1_array_crystal_array_7, mcposrchannel_10_analyzer_1_array_crystal_array_7;
Rotation mcrotachannel_10_analyzer_1_array_crystal_array_7, mcrotrchannel_10_analyzer_1_array_crystal_array_7;
Coords mcposachannel_10_analyzer_1_array_crystal_array_8, mcposrchannel_10_analyzer_1_array_crystal_array_8;
Rotation mcrotachannel_10_analyzer_1_array_crystal_array_8, mcrotrchannel_10_analyzer_1_array_crystal_array_8;
Coords mcposachannel_10_analyzer_2_center, mcposrchannel_10_analyzer_2_center;
Rotation mcrotachannel_10_analyzer_2_center, mcrotrchannel_10_analyzer_2_center;
Coords mcposachannel_10_analyzer_2_rotated, mcposrchannel_10_analyzer_2_rotated;
Rotation mcrotachannel_10_analyzer_2_rotated, mcrotrchannel_10_analyzer_2_rotated;
Coords mcposachannel_10_analyzer_2_array_crystal_array_0, mcposrchannel_10_analyzer_2_array_crystal_array_0;
Rotation mcrotachannel_10_analyzer_2_array_crystal_array_0, mcrotrchannel_10_analyzer_2_array_crystal_array_0;
Coords mcposachannel_10_analyzer_2_array_crystal_array_1, mcposrchannel_10_analyzer_2_array_crystal_array_1;
Rotation mcrotachannel_10_analyzer_2_array_crystal_array_1, mcrotrchannel_10_analyzer_2_array_crystal_array_1;
Coords mcposachannel_10_analyzer_2_array_crystal_array_2, mcposrchannel_10_analyzer_2_array_crystal_array_2;
Rotation mcrotachannel_10_analyzer_2_array_crystal_array_2, mcrotrchannel_10_analyzer_2_array_crystal_array_2;
Coords mcposachannel_10_analyzer_2_array_crystal_array_3, mcposrchannel_10_analyzer_2_array_crystal_array_3;
Rotation mcrotachannel_10_analyzer_2_array_crystal_array_3, mcrotrchannel_10_analyzer_2_array_crystal_array_3;
Coords mcposachannel_10_analyzer_2_array_crystal_array_4, mcposrchannel_10_analyzer_2_array_crystal_array_4;
Rotation mcrotachannel_10_analyzer_2_array_crystal_array_4, mcrotrchannel_10_analyzer_2_array_crystal_array_4;
Coords mcposachannel_10_analyzer_2_array_crystal_array_5, mcposrchannel_10_analyzer_2_array_crystal_array_5;
Rotation mcrotachannel_10_analyzer_2_array_crystal_array_5, mcrotrchannel_10_analyzer_2_array_crystal_array_5;
Coords mcposachannel_10_analyzer_2_array_crystal_array_6, mcposrchannel_10_analyzer_2_array_crystal_array_6;
Rotation mcrotachannel_10_analyzer_2_array_crystal_array_6, mcrotrchannel_10_analyzer_2_array_crystal_array_6;
Coords mcposachannel_10_analyzer_2_array_crystal_array_7, mcposrchannel_10_analyzer_2_array_crystal_array_7;
Rotation mcrotachannel_10_analyzer_2_array_crystal_array_7, mcrotrchannel_10_analyzer_2_array_crystal_array_7;
Coords mcposachannel_10_analyzer_2_array_crystal_array_8, mcposrchannel_10_analyzer_2_array_crystal_array_8;
Rotation mcrotachannel_10_analyzer_2_array_crystal_array_8, mcrotrchannel_10_analyzer_2_array_crystal_array_8;
Coords mcposachannel_10_cave2_cyl1, mcposrchannel_10_cave2_cyl1;
Rotation mcrotachannel_10_cave2_cyl1, mcrotrchannel_10_cave2_cyl1;
Coords mcposachannel_10_cave2_box1, mcposrchannel_10_cave2_box1;
Rotation mcrotachannel_10_cave2_box1, mcrotrchannel_10_cave2_box1;
Coords mcposachannel_10_cave2_box2, mcposrchannel_10_cave2_box2;
Rotation mcrotachannel_10_cave2_box2, mcrotrchannel_10_cave2_box2;
Coords mcposachannel_10_cave2_box3, mcposrchannel_10_cave2_box3;
Rotation mcrotachannel_10_cave2_box3, mcrotrchannel_10_cave2_box3;
Coords mcposainter_analyzer_colimator_center_10, mcposrinter_analyzer_colimator_center_10;
Rotation mcrotainter_analyzer_colimator_center_10, mcrotrinter_analyzer_colimator_center_10;
Coords mcposainter_analyzer_colimator_10_blade_0, mcposrinter_analyzer_colimator_10_blade_0;
Rotation mcrotainter_analyzer_colimator_10_blade_0, mcrotrinter_analyzer_colimator_10_blade_0;
Coords mcposainter_analyzer_colimator_10_blade_1, mcposrinter_analyzer_colimator_10_blade_1;
Rotation mcrotainter_analyzer_colimator_10_blade_1, mcrotrinter_analyzer_colimator_10_blade_1;
Coords mcposainter_analyzer_colimator_10_blade_2, mcposrinter_analyzer_colimator_10_blade_2;
Rotation mcrotainter_analyzer_colimator_10_blade_2, mcrotrinter_analyzer_colimator_10_blade_2;
Coords mcposainter_analyzer_colimator_10_blade_3, mcposrinter_analyzer_colimator_10_blade_3;
Rotation mcrotainter_analyzer_colimator_10_blade_3, mcrotrinter_analyzer_colimator_10_blade_3;
Coords mcposainter_analyzer_colimator_10_blade_4, mcposrinter_analyzer_colimator_10_blade_4;
Rotation mcrotainter_analyzer_colimator_10_blade_4, mcrotrinter_analyzer_colimator_10_blade_4;
Coords mcposadiffraction_detector_10_exit_volume, mcposrdiffraction_detector_10_exit_volume;
Rotation mcrotadiffraction_detector_10_exit_volume, mcrotrdiffraction_detector_10_exit_volume;
Coords mcposaspec_detector_10_exit_volume, mcposrspec_detector_10_exit_volume;
Rotation mcrotaspec_detector_10_exit_volume, mcrotrspec_detector_10_exit_volume;
Coords mcposachannel_11_cave1_box1, mcposrchannel_11_cave1_box1;
Rotation mcrotachannel_11_cave1_box1, mcrotrchannel_11_cave1_box1;
Coords mcposachannel_11_cave1_box2, mcposrchannel_11_cave1_box2;
Rotation mcrotachannel_11_cave1_box2, mcrotrchannel_11_cave1_box2;
Coords mcposachannel_11_cave1_box3, mcposrchannel_11_cave1_box3;
Rotation mcrotachannel_11_cave1_box3, mcrotrchannel_11_cave1_box3;
Coords mcposachannel_11_cave1_cyl1, mcposrchannel_11_cave1_cyl1;
Rotation mcrotachannel_11_cave1_cyl1, mcrotrchannel_11_cave1_cyl1;
Coords mcposachannel_11_analyzer_1_center, mcposrchannel_11_analyzer_1_center;
Rotation mcrotachannel_11_analyzer_1_center, mcrotrchannel_11_analyzer_1_center;
Coords mcposachannel_11_analyzer_1_rotated, mcposrchannel_11_analyzer_1_rotated;
Rotation mcrotachannel_11_analyzer_1_rotated, mcrotrchannel_11_analyzer_1_rotated;
Coords mcposachannel_11_analyzer_1_array_crystal_array_0, mcposrchannel_11_analyzer_1_array_crystal_array_0;
Rotation mcrotachannel_11_analyzer_1_array_crystal_array_0, mcrotrchannel_11_analyzer_1_array_crystal_array_0;
Coords mcposachannel_11_analyzer_1_array_crystal_array_1, mcposrchannel_11_analyzer_1_array_crystal_array_1;
Rotation mcrotachannel_11_analyzer_1_array_crystal_array_1, mcrotrchannel_11_analyzer_1_array_crystal_array_1;
Coords mcposachannel_11_analyzer_1_array_crystal_array_2, mcposrchannel_11_analyzer_1_array_crystal_array_2;
Rotation mcrotachannel_11_analyzer_1_array_crystal_array_2, mcrotrchannel_11_analyzer_1_array_crystal_array_2;
Coords mcposachannel_11_analyzer_1_array_crystal_array_3, mcposrchannel_11_analyzer_1_array_crystal_array_3;
Rotation mcrotachannel_11_analyzer_1_array_crystal_array_3, mcrotrchannel_11_analyzer_1_array_crystal_array_3;
Coords mcposachannel_11_analyzer_1_array_crystal_array_4, mcposrchannel_11_analyzer_1_array_crystal_array_4;
Rotation mcrotachannel_11_analyzer_1_array_crystal_array_4, mcrotrchannel_11_analyzer_1_array_crystal_array_4;
Coords mcposachannel_11_analyzer_1_array_crystal_array_5, mcposrchannel_11_analyzer_1_array_crystal_array_5;
Rotation mcrotachannel_11_analyzer_1_array_crystal_array_5, mcrotrchannel_11_analyzer_1_array_crystal_array_5;
Coords mcposachannel_11_analyzer_1_array_crystal_array_6, mcposrchannel_11_analyzer_1_array_crystal_array_6;
Rotation mcrotachannel_11_analyzer_1_array_crystal_array_6, mcrotrchannel_11_analyzer_1_array_crystal_array_6;
Coords mcposachannel_11_analyzer_1_array_crystal_array_7, mcposrchannel_11_analyzer_1_array_crystal_array_7;
Rotation mcrotachannel_11_analyzer_1_array_crystal_array_7, mcrotrchannel_11_analyzer_1_array_crystal_array_7;
Coords mcposachannel_11_analyzer_1_array_crystal_array_8, mcposrchannel_11_analyzer_1_array_crystal_array_8;
Rotation mcrotachannel_11_analyzer_1_array_crystal_array_8, mcrotrchannel_11_analyzer_1_array_crystal_array_8;
Coords mcposachannel_11_analyzer_2_center, mcposrchannel_11_analyzer_2_center;
Rotation mcrotachannel_11_analyzer_2_center, mcrotrchannel_11_analyzer_2_center;
Coords mcposachannel_11_analyzer_2_rotated, mcposrchannel_11_analyzer_2_rotated;
Rotation mcrotachannel_11_analyzer_2_rotated, mcrotrchannel_11_analyzer_2_rotated;
Coords mcposachannel_11_analyzer_2_array_crystal_array_0, mcposrchannel_11_analyzer_2_array_crystal_array_0;
Rotation mcrotachannel_11_analyzer_2_array_crystal_array_0, mcrotrchannel_11_analyzer_2_array_crystal_array_0;
Coords mcposachannel_11_analyzer_2_array_crystal_array_1, mcposrchannel_11_analyzer_2_array_crystal_array_1;
Rotation mcrotachannel_11_analyzer_2_array_crystal_array_1, mcrotrchannel_11_analyzer_2_array_crystal_array_1;
Coords mcposachannel_11_analyzer_2_array_crystal_array_2, mcposrchannel_11_analyzer_2_array_crystal_array_2;
Rotation mcrotachannel_11_analyzer_2_array_crystal_array_2, mcrotrchannel_11_analyzer_2_array_crystal_array_2;
Coords mcposachannel_11_analyzer_2_array_crystal_array_3, mcposrchannel_11_analyzer_2_array_crystal_array_3;
Rotation mcrotachannel_11_analyzer_2_array_crystal_array_3, mcrotrchannel_11_analyzer_2_array_crystal_array_3;
Coords mcposachannel_11_analyzer_2_array_crystal_array_4, mcposrchannel_11_analyzer_2_array_crystal_array_4;
Rotation mcrotachannel_11_analyzer_2_array_crystal_array_4, mcrotrchannel_11_analyzer_2_array_crystal_array_4;
Coords mcposachannel_11_analyzer_2_array_crystal_array_5, mcposrchannel_11_analyzer_2_array_crystal_array_5;
Rotation mcrotachannel_11_analyzer_2_array_crystal_array_5, mcrotrchannel_11_analyzer_2_array_crystal_array_5;
Coords mcposachannel_11_analyzer_2_array_crystal_array_6, mcposrchannel_11_analyzer_2_array_crystal_array_6;
Rotation mcrotachannel_11_analyzer_2_array_crystal_array_6, mcrotrchannel_11_analyzer_2_array_crystal_array_6;
Coords mcposachannel_11_analyzer_2_array_crystal_array_7, mcposrchannel_11_analyzer_2_array_crystal_array_7;
Rotation mcrotachannel_11_analyzer_2_array_crystal_array_7, mcrotrchannel_11_analyzer_2_array_crystal_array_7;
Coords mcposachannel_11_analyzer_2_array_crystal_array_8, mcposrchannel_11_analyzer_2_array_crystal_array_8;
Rotation mcrotachannel_11_analyzer_2_array_crystal_array_8, mcrotrchannel_11_analyzer_2_array_crystal_array_8;
Coords mcposachannel_11_cave2_cyl1, mcposrchannel_11_cave2_cyl1;
Rotation mcrotachannel_11_cave2_cyl1, mcrotrchannel_11_cave2_cyl1;
Coords mcposachannel_11_cave2_box1, mcposrchannel_11_cave2_box1;
Rotation mcrotachannel_11_cave2_box1, mcrotrchannel_11_cave2_box1;
Coords mcposachannel_11_cave2_box2, mcposrchannel_11_cave2_box2;
Rotation mcrotachannel_11_cave2_box2, mcrotrchannel_11_cave2_box2;
Coords mcposachannel_11_cave2_box3, mcposrchannel_11_cave2_box3;
Rotation mcrotachannel_11_cave2_box3, mcrotrchannel_11_cave2_box3;
Coords mcposainter_analyzer_colimator_center_11, mcposrinter_analyzer_colimator_center_11;
Rotation mcrotainter_analyzer_colimator_center_11, mcrotrinter_analyzer_colimator_center_11;
Coords mcposainter_analyzer_colimator_11_blade_0, mcposrinter_analyzer_colimator_11_blade_0;
Rotation mcrotainter_analyzer_colimator_11_blade_0, mcrotrinter_analyzer_colimator_11_blade_0;
Coords mcposainter_analyzer_colimator_11_blade_1, mcposrinter_analyzer_colimator_11_blade_1;
Rotation mcrotainter_analyzer_colimator_11_blade_1, mcrotrinter_analyzer_colimator_11_blade_1;
Coords mcposainter_analyzer_colimator_11_blade_2, mcposrinter_analyzer_colimator_11_blade_2;
Rotation mcrotainter_analyzer_colimator_11_blade_2, mcrotrinter_analyzer_colimator_11_blade_2;
Coords mcposainter_analyzer_colimator_11_blade_3, mcposrinter_analyzer_colimator_11_blade_3;
Rotation mcrotainter_analyzer_colimator_11_blade_3, mcrotrinter_analyzer_colimator_11_blade_3;
Coords mcposainter_analyzer_colimator_11_blade_4, mcposrinter_analyzer_colimator_11_blade_4;
Rotation mcrotainter_analyzer_colimator_11_blade_4, mcrotrinter_analyzer_colimator_11_blade_4;
Coords mcposadiffraction_detector_11_exit_volume, mcposrdiffraction_detector_11_exit_volume;
Rotation mcrotadiffraction_detector_11_exit_volume, mcrotrdiffraction_detector_11_exit_volume;
Coords mcposaspec_detector_11_exit_volume, mcposrspec_detector_11_exit_volume;
Rotation mcrotaspec_detector_11_exit_volume, mcrotrspec_detector_11_exit_volume;
Coords mcposachannel_12_cave1_box1, mcposrchannel_12_cave1_box1;
Rotation mcrotachannel_12_cave1_box1, mcrotrchannel_12_cave1_box1;
Coords mcposachannel_12_cave1_box2, mcposrchannel_12_cave1_box2;
Rotation mcrotachannel_12_cave1_box2, mcrotrchannel_12_cave1_box2;
Coords mcposachannel_12_cave1_box3, mcposrchannel_12_cave1_box3;
Rotation mcrotachannel_12_cave1_box3, mcrotrchannel_12_cave1_box3;
Coords mcposachannel_12_cave1_cyl1, mcposrchannel_12_cave1_cyl1;
Rotation mcrotachannel_12_cave1_cyl1, mcrotrchannel_12_cave1_cyl1;
Coords mcposachannel_12_analyzer_1_center, mcposrchannel_12_analyzer_1_center;
Rotation mcrotachannel_12_analyzer_1_center, mcrotrchannel_12_analyzer_1_center;
Coords mcposachannel_12_analyzer_1_rotated, mcposrchannel_12_analyzer_1_rotated;
Rotation mcrotachannel_12_analyzer_1_rotated, mcrotrchannel_12_analyzer_1_rotated;
Coords mcposachannel_12_analyzer_1_array_crystal_array_0, mcposrchannel_12_analyzer_1_array_crystal_array_0;
Rotation mcrotachannel_12_analyzer_1_array_crystal_array_0, mcrotrchannel_12_analyzer_1_array_crystal_array_0;
Coords mcposachannel_12_analyzer_1_array_crystal_array_1, mcposrchannel_12_analyzer_1_array_crystal_array_1;
Rotation mcrotachannel_12_analyzer_1_array_crystal_array_1, mcrotrchannel_12_analyzer_1_array_crystal_array_1;
Coords mcposachannel_12_analyzer_1_array_crystal_array_2, mcposrchannel_12_analyzer_1_array_crystal_array_2;
Rotation mcrotachannel_12_analyzer_1_array_crystal_array_2, mcrotrchannel_12_analyzer_1_array_crystal_array_2;
Coords mcposachannel_12_analyzer_1_array_crystal_array_3, mcposrchannel_12_analyzer_1_array_crystal_array_3;
Rotation mcrotachannel_12_analyzer_1_array_crystal_array_3, mcrotrchannel_12_analyzer_1_array_crystal_array_3;
Coords mcposachannel_12_analyzer_1_array_crystal_array_4, mcposrchannel_12_analyzer_1_array_crystal_array_4;
Rotation mcrotachannel_12_analyzer_1_array_crystal_array_4, mcrotrchannel_12_analyzer_1_array_crystal_array_4;
Coords mcposachannel_12_analyzer_1_array_crystal_array_5, mcposrchannel_12_analyzer_1_array_crystal_array_5;
Rotation mcrotachannel_12_analyzer_1_array_crystal_array_5, mcrotrchannel_12_analyzer_1_array_crystal_array_5;
Coords mcposachannel_12_analyzer_1_array_crystal_array_6, mcposrchannel_12_analyzer_1_array_crystal_array_6;
Rotation mcrotachannel_12_analyzer_1_array_crystal_array_6, mcrotrchannel_12_analyzer_1_array_crystal_array_6;
Coords mcposachannel_12_analyzer_1_array_crystal_array_7, mcposrchannel_12_analyzer_1_array_crystal_array_7;
Rotation mcrotachannel_12_analyzer_1_array_crystal_array_7, mcrotrchannel_12_analyzer_1_array_crystal_array_7;
Coords mcposachannel_12_analyzer_1_array_crystal_array_8, mcposrchannel_12_analyzer_1_array_crystal_array_8;
Rotation mcrotachannel_12_analyzer_1_array_crystal_array_8, mcrotrchannel_12_analyzer_1_array_crystal_array_8;
Coords mcposachannel_12_analyzer_2_center, mcposrchannel_12_analyzer_2_center;
Rotation mcrotachannel_12_analyzer_2_center, mcrotrchannel_12_analyzer_2_center;
Coords mcposachannel_12_analyzer_2_rotated, mcposrchannel_12_analyzer_2_rotated;
Rotation mcrotachannel_12_analyzer_2_rotated, mcrotrchannel_12_analyzer_2_rotated;
Coords mcposachannel_12_analyzer_2_array_crystal_array_0, mcposrchannel_12_analyzer_2_array_crystal_array_0;
Rotation mcrotachannel_12_analyzer_2_array_crystal_array_0, mcrotrchannel_12_analyzer_2_array_crystal_array_0;
Coords mcposachannel_12_analyzer_2_array_crystal_array_1, mcposrchannel_12_analyzer_2_array_crystal_array_1;
Rotation mcrotachannel_12_analyzer_2_array_crystal_array_1, mcrotrchannel_12_analyzer_2_array_crystal_array_1;
Coords mcposachannel_12_analyzer_2_array_crystal_array_2, mcposrchannel_12_analyzer_2_array_crystal_array_2;
Rotation mcrotachannel_12_analyzer_2_array_crystal_array_2, mcrotrchannel_12_analyzer_2_array_crystal_array_2;
Coords mcposachannel_12_analyzer_2_array_crystal_array_3, mcposrchannel_12_analyzer_2_array_crystal_array_3;
Rotation mcrotachannel_12_analyzer_2_array_crystal_array_3, mcrotrchannel_12_analyzer_2_array_crystal_array_3;
Coords mcposachannel_12_analyzer_2_array_crystal_array_4, mcposrchannel_12_analyzer_2_array_crystal_array_4;
Rotation mcrotachannel_12_analyzer_2_array_crystal_array_4, mcrotrchannel_12_analyzer_2_array_crystal_array_4;
Coords mcposachannel_12_analyzer_2_array_crystal_array_5, mcposrchannel_12_analyzer_2_array_crystal_array_5;
Rotation mcrotachannel_12_analyzer_2_array_crystal_array_5, mcrotrchannel_12_analyzer_2_array_crystal_array_5;
Coords mcposachannel_12_analyzer_2_array_crystal_array_6, mcposrchannel_12_analyzer_2_array_crystal_array_6;
Rotation mcrotachannel_12_analyzer_2_array_crystal_array_6, mcrotrchannel_12_analyzer_2_array_crystal_array_6;
Coords mcposachannel_12_analyzer_2_array_crystal_array_7, mcposrchannel_12_analyzer_2_array_crystal_array_7;
Rotation mcrotachannel_12_analyzer_2_array_crystal_array_7, mcrotrchannel_12_analyzer_2_array_crystal_array_7;
Coords mcposachannel_12_analyzer_2_array_crystal_array_8, mcposrchannel_12_analyzer_2_array_crystal_array_8;
Rotation mcrotachannel_12_analyzer_2_array_crystal_array_8, mcrotrchannel_12_analyzer_2_array_crystal_array_8;
Coords mcposachannel_12_cave2_cyl1, mcposrchannel_12_cave2_cyl1;
Rotation mcrotachannel_12_cave2_cyl1, mcrotrchannel_12_cave2_cyl1;
Coords mcposachannel_12_cave2_box1, mcposrchannel_12_cave2_box1;
Rotation mcrotachannel_12_cave2_box1, mcrotrchannel_12_cave2_box1;
Coords mcposachannel_12_cave2_box2, mcposrchannel_12_cave2_box2;
Rotation mcrotachannel_12_cave2_box2, mcrotrchannel_12_cave2_box2;
Coords mcposachannel_12_cave2_box3, mcposrchannel_12_cave2_box3;
Rotation mcrotachannel_12_cave2_box3, mcrotrchannel_12_cave2_box3;
Coords mcposainter_analyzer_colimator_center_12, mcposrinter_analyzer_colimator_center_12;
Rotation mcrotainter_analyzer_colimator_center_12, mcrotrinter_analyzer_colimator_center_12;
Coords mcposainter_analyzer_colimator_12_blade_0, mcposrinter_analyzer_colimator_12_blade_0;
Rotation mcrotainter_analyzer_colimator_12_blade_0, mcrotrinter_analyzer_colimator_12_blade_0;
Coords mcposainter_analyzer_colimator_12_blade_1, mcposrinter_analyzer_colimator_12_blade_1;
Rotation mcrotainter_analyzer_colimator_12_blade_1, mcrotrinter_analyzer_colimator_12_blade_1;
Coords mcposainter_analyzer_colimator_12_blade_2, mcposrinter_analyzer_colimator_12_blade_2;
Rotation mcrotainter_analyzer_colimator_12_blade_2, mcrotrinter_analyzer_colimator_12_blade_2;
Coords mcposainter_analyzer_colimator_12_blade_3, mcposrinter_analyzer_colimator_12_blade_3;
Rotation mcrotainter_analyzer_colimator_12_blade_3, mcrotrinter_analyzer_colimator_12_blade_3;
Coords mcposainter_analyzer_colimator_12_blade_4, mcposrinter_analyzer_colimator_12_blade_4;
Rotation mcrotainter_analyzer_colimator_12_blade_4, mcrotrinter_analyzer_colimator_12_blade_4;
Coords mcposadiffraction_detector_12_exit_volume, mcposrdiffraction_detector_12_exit_volume;
Rotation mcrotadiffraction_detector_12_exit_volume, mcrotrdiffraction_detector_12_exit_volume;
Coords mcposaspec_detector_12_exit_volume, mcposrspec_detector_12_exit_volume;
Rotation mcrotaspec_detector_12_exit_volume, mcrotrspec_detector_12_exit_volume;
Coords mcposachannel_13_cave1_box1, mcposrchannel_13_cave1_box1;
Rotation mcrotachannel_13_cave1_box1, mcrotrchannel_13_cave1_box1;
Coords mcposachannel_13_cave1_box2, mcposrchannel_13_cave1_box2;
Rotation mcrotachannel_13_cave1_box2, mcrotrchannel_13_cave1_box2;
Coords mcposachannel_13_cave1_box3, mcposrchannel_13_cave1_box3;
Rotation mcrotachannel_13_cave1_box3, mcrotrchannel_13_cave1_box3;
Coords mcposachannel_13_cave1_cyl1, mcposrchannel_13_cave1_cyl1;
Rotation mcrotachannel_13_cave1_cyl1, mcrotrchannel_13_cave1_cyl1;
Coords mcposachannel_13_analyzer_1_center, mcposrchannel_13_analyzer_1_center;
Rotation mcrotachannel_13_analyzer_1_center, mcrotrchannel_13_analyzer_1_center;
Coords mcposachannel_13_analyzer_1_rotated, mcposrchannel_13_analyzer_1_rotated;
Rotation mcrotachannel_13_analyzer_1_rotated, mcrotrchannel_13_analyzer_1_rotated;
Coords mcposachannel_13_analyzer_1_array_crystal_array_0, mcposrchannel_13_analyzer_1_array_crystal_array_0;
Rotation mcrotachannel_13_analyzer_1_array_crystal_array_0, mcrotrchannel_13_analyzer_1_array_crystal_array_0;
Coords mcposachannel_13_analyzer_1_array_crystal_array_1, mcposrchannel_13_analyzer_1_array_crystal_array_1;
Rotation mcrotachannel_13_analyzer_1_array_crystal_array_1, mcrotrchannel_13_analyzer_1_array_crystal_array_1;
Coords mcposachannel_13_analyzer_1_array_crystal_array_2, mcposrchannel_13_analyzer_1_array_crystal_array_2;
Rotation mcrotachannel_13_analyzer_1_array_crystal_array_2, mcrotrchannel_13_analyzer_1_array_crystal_array_2;
Coords mcposachannel_13_analyzer_1_array_crystal_array_3, mcposrchannel_13_analyzer_1_array_crystal_array_3;
Rotation mcrotachannel_13_analyzer_1_array_crystal_array_3, mcrotrchannel_13_analyzer_1_array_crystal_array_3;
Coords mcposachannel_13_analyzer_1_array_crystal_array_4, mcposrchannel_13_analyzer_1_array_crystal_array_4;
Rotation mcrotachannel_13_analyzer_1_array_crystal_array_4, mcrotrchannel_13_analyzer_1_array_crystal_array_4;
Coords mcposachannel_13_analyzer_1_array_crystal_array_5, mcposrchannel_13_analyzer_1_array_crystal_array_5;
Rotation mcrotachannel_13_analyzer_1_array_crystal_array_5, mcrotrchannel_13_analyzer_1_array_crystal_array_5;
Coords mcposachannel_13_analyzer_1_array_crystal_array_6, mcposrchannel_13_analyzer_1_array_crystal_array_6;
Rotation mcrotachannel_13_analyzer_1_array_crystal_array_6, mcrotrchannel_13_analyzer_1_array_crystal_array_6;
Coords mcposachannel_13_analyzer_1_array_crystal_array_7, mcposrchannel_13_analyzer_1_array_crystal_array_7;
Rotation mcrotachannel_13_analyzer_1_array_crystal_array_7, mcrotrchannel_13_analyzer_1_array_crystal_array_7;
Coords mcposachannel_13_analyzer_1_array_crystal_array_8, mcposrchannel_13_analyzer_1_array_crystal_array_8;
Rotation mcrotachannel_13_analyzer_1_array_crystal_array_8, mcrotrchannel_13_analyzer_1_array_crystal_array_8;
Coords mcposachannel_13_analyzer_2_center, mcposrchannel_13_analyzer_2_center;
Rotation mcrotachannel_13_analyzer_2_center, mcrotrchannel_13_analyzer_2_center;
Coords mcposachannel_13_analyzer_2_rotated, mcposrchannel_13_analyzer_2_rotated;
Rotation mcrotachannel_13_analyzer_2_rotated, mcrotrchannel_13_analyzer_2_rotated;
Coords mcposachannel_13_analyzer_2_array_crystal_array_0, mcposrchannel_13_analyzer_2_array_crystal_array_0;
Rotation mcrotachannel_13_analyzer_2_array_crystal_array_0, mcrotrchannel_13_analyzer_2_array_crystal_array_0;
Coords mcposachannel_13_analyzer_2_array_crystal_array_1, mcposrchannel_13_analyzer_2_array_crystal_array_1;
Rotation mcrotachannel_13_analyzer_2_array_crystal_array_1, mcrotrchannel_13_analyzer_2_array_crystal_array_1;
Coords mcposachannel_13_analyzer_2_array_crystal_array_2, mcposrchannel_13_analyzer_2_array_crystal_array_2;
Rotation mcrotachannel_13_analyzer_2_array_crystal_array_2, mcrotrchannel_13_analyzer_2_array_crystal_array_2;
Coords mcposachannel_13_analyzer_2_array_crystal_array_3, mcposrchannel_13_analyzer_2_array_crystal_array_3;
Rotation mcrotachannel_13_analyzer_2_array_crystal_array_3, mcrotrchannel_13_analyzer_2_array_crystal_array_3;
Coords mcposachannel_13_analyzer_2_array_crystal_array_4, mcposrchannel_13_analyzer_2_array_crystal_array_4;
Rotation mcrotachannel_13_analyzer_2_array_crystal_array_4, mcrotrchannel_13_analyzer_2_array_crystal_array_4;
Coords mcposachannel_13_analyzer_2_array_crystal_array_5, mcposrchannel_13_analyzer_2_array_crystal_array_5;
Rotation mcrotachannel_13_analyzer_2_array_crystal_array_5, mcrotrchannel_13_analyzer_2_array_crystal_array_5;
Coords mcposachannel_13_analyzer_2_array_crystal_array_6, mcposrchannel_13_analyzer_2_array_crystal_array_6;
Rotation mcrotachannel_13_analyzer_2_array_crystal_array_6, mcrotrchannel_13_analyzer_2_array_crystal_array_6;
Coords mcposachannel_13_analyzer_2_array_crystal_array_7, mcposrchannel_13_analyzer_2_array_crystal_array_7;
Rotation mcrotachannel_13_analyzer_2_array_crystal_array_7, mcrotrchannel_13_analyzer_2_array_crystal_array_7;
Coords mcposachannel_13_analyzer_2_array_crystal_array_8, mcposrchannel_13_analyzer_2_array_crystal_array_8;
Rotation mcrotachannel_13_analyzer_2_array_crystal_array_8, mcrotrchannel_13_analyzer_2_array_crystal_array_8;
Coords mcposachannel_13_cave2_cyl1, mcposrchannel_13_cave2_cyl1;
Rotation mcrotachannel_13_cave2_cyl1, mcrotrchannel_13_cave2_cyl1;
Coords mcposachannel_13_cave2_box1, mcposrchannel_13_cave2_box1;
Rotation mcrotachannel_13_cave2_box1, mcrotrchannel_13_cave2_box1;
Coords mcposachannel_13_cave2_box2, mcposrchannel_13_cave2_box2;
Rotation mcrotachannel_13_cave2_box2, mcrotrchannel_13_cave2_box2;
Coords mcposachannel_13_cave2_box3, mcposrchannel_13_cave2_box3;
Rotation mcrotachannel_13_cave2_box3, mcrotrchannel_13_cave2_box3;
Coords mcposainter_analyzer_colimator_center_13, mcposrinter_analyzer_colimator_center_13;
Rotation mcrotainter_analyzer_colimator_center_13, mcrotrinter_analyzer_colimator_center_13;
Coords mcposainter_analyzer_colimator_13_blade_0, mcposrinter_analyzer_colimator_13_blade_0;
Rotation mcrotainter_analyzer_colimator_13_blade_0, mcrotrinter_analyzer_colimator_13_blade_0;
Coords mcposainter_analyzer_colimator_13_blade_1, mcposrinter_analyzer_colimator_13_blade_1;
Rotation mcrotainter_analyzer_colimator_13_blade_1, mcrotrinter_analyzer_colimator_13_blade_1;
Coords mcposainter_analyzer_colimator_13_blade_2, mcposrinter_analyzer_colimator_13_blade_2;
Rotation mcrotainter_analyzer_colimator_13_blade_2, mcrotrinter_analyzer_colimator_13_blade_2;
Coords mcposainter_analyzer_colimator_13_blade_3, mcposrinter_analyzer_colimator_13_blade_3;
Rotation mcrotainter_analyzer_colimator_13_blade_3, mcrotrinter_analyzer_colimator_13_blade_3;
Coords mcposainter_analyzer_colimator_13_blade_4, mcposrinter_analyzer_colimator_13_blade_4;
Rotation mcrotainter_analyzer_colimator_13_blade_4, mcrotrinter_analyzer_colimator_13_blade_4;
Coords mcposadiffraction_detector_13_exit_volume, mcposrdiffraction_detector_13_exit_volume;
Rotation mcrotadiffraction_detector_13_exit_volume, mcrotrdiffraction_detector_13_exit_volume;
Coords mcposaspec_detector_13_exit_volume, mcposrspec_detector_13_exit_volume;
Rotation mcrotaspec_detector_13_exit_volume, mcrotrspec_detector_13_exit_volume;
Coords mcposachannel_14_cave1_box1, mcposrchannel_14_cave1_box1;
Rotation mcrotachannel_14_cave1_box1, mcrotrchannel_14_cave1_box1;
Coords mcposachannel_14_cave1_box2, mcposrchannel_14_cave1_box2;
Rotation mcrotachannel_14_cave1_box2, mcrotrchannel_14_cave1_box2;
Coords mcposachannel_14_cave1_box3, mcposrchannel_14_cave1_box3;
Rotation mcrotachannel_14_cave1_box3, mcrotrchannel_14_cave1_box3;
Coords mcposachannel_14_cave1_cyl1, mcposrchannel_14_cave1_cyl1;
Rotation mcrotachannel_14_cave1_cyl1, mcrotrchannel_14_cave1_cyl1;
Coords mcposachannel_14_analyzer_1_center, mcposrchannel_14_analyzer_1_center;
Rotation mcrotachannel_14_analyzer_1_center, mcrotrchannel_14_analyzer_1_center;
Coords mcposachannel_14_analyzer_1_rotated, mcposrchannel_14_analyzer_1_rotated;
Rotation mcrotachannel_14_analyzer_1_rotated, mcrotrchannel_14_analyzer_1_rotated;
Coords mcposachannel_14_analyzer_1_array_crystal_array_0, mcposrchannel_14_analyzer_1_array_crystal_array_0;
Rotation mcrotachannel_14_analyzer_1_array_crystal_array_0, mcrotrchannel_14_analyzer_1_array_crystal_array_0;
Coords mcposachannel_14_analyzer_1_array_crystal_array_1, mcposrchannel_14_analyzer_1_array_crystal_array_1;
Rotation mcrotachannel_14_analyzer_1_array_crystal_array_1, mcrotrchannel_14_analyzer_1_array_crystal_array_1;
Coords mcposachannel_14_analyzer_1_array_crystal_array_2, mcposrchannel_14_analyzer_1_array_crystal_array_2;
Rotation mcrotachannel_14_analyzer_1_array_crystal_array_2, mcrotrchannel_14_analyzer_1_array_crystal_array_2;
Coords mcposachannel_14_analyzer_1_array_crystal_array_3, mcposrchannel_14_analyzer_1_array_crystal_array_3;
Rotation mcrotachannel_14_analyzer_1_array_crystal_array_3, mcrotrchannel_14_analyzer_1_array_crystal_array_3;
Coords mcposachannel_14_analyzer_1_array_crystal_array_4, mcposrchannel_14_analyzer_1_array_crystal_array_4;
Rotation mcrotachannel_14_analyzer_1_array_crystal_array_4, mcrotrchannel_14_analyzer_1_array_crystal_array_4;
Coords mcposachannel_14_analyzer_1_array_crystal_array_5, mcposrchannel_14_analyzer_1_array_crystal_array_5;
Rotation mcrotachannel_14_analyzer_1_array_crystal_array_5, mcrotrchannel_14_analyzer_1_array_crystal_array_5;
Coords mcposachannel_14_analyzer_1_array_crystal_array_6, mcposrchannel_14_analyzer_1_array_crystal_array_6;
Rotation mcrotachannel_14_analyzer_1_array_crystal_array_6, mcrotrchannel_14_analyzer_1_array_crystal_array_6;
Coords mcposachannel_14_analyzer_1_array_crystal_array_7, mcposrchannel_14_analyzer_1_array_crystal_array_7;
Rotation mcrotachannel_14_analyzer_1_array_crystal_array_7, mcrotrchannel_14_analyzer_1_array_crystal_array_7;
Coords mcposachannel_14_analyzer_1_array_crystal_array_8, mcposrchannel_14_analyzer_1_array_crystal_array_8;
Rotation mcrotachannel_14_analyzer_1_array_crystal_array_8, mcrotrchannel_14_analyzer_1_array_crystal_array_8;
Coords mcposachannel_14_analyzer_2_center, mcposrchannel_14_analyzer_2_center;
Rotation mcrotachannel_14_analyzer_2_center, mcrotrchannel_14_analyzer_2_center;
Coords mcposachannel_14_analyzer_2_rotated, mcposrchannel_14_analyzer_2_rotated;
Rotation mcrotachannel_14_analyzer_2_rotated, mcrotrchannel_14_analyzer_2_rotated;
Coords mcposachannel_14_analyzer_2_array_crystal_array_0, mcposrchannel_14_analyzer_2_array_crystal_array_0;
Rotation mcrotachannel_14_analyzer_2_array_crystal_array_0, mcrotrchannel_14_analyzer_2_array_crystal_array_0;
Coords mcposachannel_14_analyzer_2_array_crystal_array_1, mcposrchannel_14_analyzer_2_array_crystal_array_1;
Rotation mcrotachannel_14_analyzer_2_array_crystal_array_1, mcrotrchannel_14_analyzer_2_array_crystal_array_1;
Coords mcposachannel_14_analyzer_2_array_crystal_array_2, mcposrchannel_14_analyzer_2_array_crystal_array_2;
Rotation mcrotachannel_14_analyzer_2_array_crystal_array_2, mcrotrchannel_14_analyzer_2_array_crystal_array_2;
Coords mcposachannel_14_analyzer_2_array_crystal_array_3, mcposrchannel_14_analyzer_2_array_crystal_array_3;
Rotation mcrotachannel_14_analyzer_2_array_crystal_array_3, mcrotrchannel_14_analyzer_2_array_crystal_array_3;
Coords mcposachannel_14_analyzer_2_array_crystal_array_4, mcposrchannel_14_analyzer_2_array_crystal_array_4;
Rotation mcrotachannel_14_analyzer_2_array_crystal_array_4, mcrotrchannel_14_analyzer_2_array_crystal_array_4;
Coords mcposachannel_14_analyzer_2_array_crystal_array_5, mcposrchannel_14_analyzer_2_array_crystal_array_5;
Rotation mcrotachannel_14_analyzer_2_array_crystal_array_5, mcrotrchannel_14_analyzer_2_array_crystal_array_5;
Coords mcposachannel_14_analyzer_2_array_crystal_array_6, mcposrchannel_14_analyzer_2_array_crystal_array_6;
Rotation mcrotachannel_14_analyzer_2_array_crystal_array_6, mcrotrchannel_14_analyzer_2_array_crystal_array_6;
Coords mcposachannel_14_analyzer_2_array_crystal_array_7, mcposrchannel_14_analyzer_2_array_crystal_array_7;
Rotation mcrotachannel_14_analyzer_2_array_crystal_array_7, mcrotrchannel_14_analyzer_2_array_crystal_array_7;
Coords mcposachannel_14_analyzer_2_array_crystal_array_8, mcposrchannel_14_analyzer_2_array_crystal_array_8;
Rotation mcrotachannel_14_analyzer_2_array_crystal_array_8, mcrotrchannel_14_analyzer_2_array_crystal_array_8;
Coords mcposachannel_14_cave2_cyl1, mcposrchannel_14_cave2_cyl1;
Rotation mcrotachannel_14_cave2_cyl1, mcrotrchannel_14_cave2_cyl1;
Coords mcposachannel_14_cave2_box1, mcposrchannel_14_cave2_box1;
Rotation mcrotachannel_14_cave2_box1, mcrotrchannel_14_cave2_box1;
Coords mcposachannel_14_cave2_box2, mcposrchannel_14_cave2_box2;
Rotation mcrotachannel_14_cave2_box2, mcrotrchannel_14_cave2_box2;
Coords mcposachannel_14_cave2_box3, mcposrchannel_14_cave2_box3;
Rotation mcrotachannel_14_cave2_box3, mcrotrchannel_14_cave2_box3;
Coords mcposainter_analyzer_colimator_center_14, mcposrinter_analyzer_colimator_center_14;
Rotation mcrotainter_analyzer_colimator_center_14, mcrotrinter_analyzer_colimator_center_14;
Coords mcposainter_analyzer_colimator_14_blade_0, mcposrinter_analyzer_colimator_14_blade_0;
Rotation mcrotainter_analyzer_colimator_14_blade_0, mcrotrinter_analyzer_colimator_14_blade_0;
Coords mcposainter_analyzer_colimator_14_blade_1, mcposrinter_analyzer_colimator_14_blade_1;
Rotation mcrotainter_analyzer_colimator_14_blade_1, mcrotrinter_analyzer_colimator_14_blade_1;
Coords mcposainter_analyzer_colimator_14_blade_2, mcposrinter_analyzer_colimator_14_blade_2;
Rotation mcrotainter_analyzer_colimator_14_blade_2, mcrotrinter_analyzer_colimator_14_blade_2;
Coords mcposainter_analyzer_colimator_14_blade_3, mcposrinter_analyzer_colimator_14_blade_3;
Rotation mcrotainter_analyzer_colimator_14_blade_3, mcrotrinter_analyzer_colimator_14_blade_3;
Coords mcposainter_analyzer_colimator_14_blade_4, mcposrinter_analyzer_colimator_14_blade_4;
Rotation mcrotainter_analyzer_colimator_14_blade_4, mcrotrinter_analyzer_colimator_14_blade_4;
Coords mcposadiffraction_detector_14_exit_volume, mcposrdiffraction_detector_14_exit_volume;
Rotation mcrotadiffraction_detector_14_exit_volume, mcrotrdiffraction_detector_14_exit_volume;
Coords mcposaspec_detector_14_exit_volume, mcposrspec_detector_14_exit_volume;
Rotation mcrotaspec_detector_14_exit_volume, mcrotrspec_detector_14_exit_volume;
Coords mcposachannel_15_cave1_box1, mcposrchannel_15_cave1_box1;
Rotation mcrotachannel_15_cave1_box1, mcrotrchannel_15_cave1_box1;
Coords mcposachannel_15_cave1_box2, mcposrchannel_15_cave1_box2;
Rotation mcrotachannel_15_cave1_box2, mcrotrchannel_15_cave1_box2;
Coords mcposachannel_15_cave1_box3, mcposrchannel_15_cave1_box3;
Rotation mcrotachannel_15_cave1_box3, mcrotrchannel_15_cave1_box3;
Coords mcposachannel_15_cave1_cyl1, mcposrchannel_15_cave1_cyl1;
Rotation mcrotachannel_15_cave1_cyl1, mcrotrchannel_15_cave1_cyl1;
Coords mcposachannel_15_analyzer_1_center, mcposrchannel_15_analyzer_1_center;
Rotation mcrotachannel_15_analyzer_1_center, mcrotrchannel_15_analyzer_1_center;
Coords mcposachannel_15_analyzer_1_rotated, mcposrchannel_15_analyzer_1_rotated;
Rotation mcrotachannel_15_analyzer_1_rotated, mcrotrchannel_15_analyzer_1_rotated;
Coords mcposachannel_15_analyzer_1_array_crystal_array_0, mcposrchannel_15_analyzer_1_array_crystal_array_0;
Rotation mcrotachannel_15_analyzer_1_array_crystal_array_0, mcrotrchannel_15_analyzer_1_array_crystal_array_0;
Coords mcposachannel_15_analyzer_1_array_crystal_array_1, mcposrchannel_15_analyzer_1_array_crystal_array_1;
Rotation mcrotachannel_15_analyzer_1_array_crystal_array_1, mcrotrchannel_15_analyzer_1_array_crystal_array_1;
Coords mcposachannel_15_analyzer_1_array_crystal_array_2, mcposrchannel_15_analyzer_1_array_crystal_array_2;
Rotation mcrotachannel_15_analyzer_1_array_crystal_array_2, mcrotrchannel_15_analyzer_1_array_crystal_array_2;
Coords mcposachannel_15_analyzer_1_array_crystal_array_3, mcposrchannel_15_analyzer_1_array_crystal_array_3;
Rotation mcrotachannel_15_analyzer_1_array_crystal_array_3, mcrotrchannel_15_analyzer_1_array_crystal_array_3;
Coords mcposachannel_15_analyzer_1_array_crystal_array_4, mcposrchannel_15_analyzer_1_array_crystal_array_4;
Rotation mcrotachannel_15_analyzer_1_array_crystal_array_4, mcrotrchannel_15_analyzer_1_array_crystal_array_4;
Coords mcposachannel_15_analyzer_1_array_crystal_array_5, mcposrchannel_15_analyzer_1_array_crystal_array_5;
Rotation mcrotachannel_15_analyzer_1_array_crystal_array_5, mcrotrchannel_15_analyzer_1_array_crystal_array_5;
Coords mcposachannel_15_analyzer_1_array_crystal_array_6, mcposrchannel_15_analyzer_1_array_crystal_array_6;
Rotation mcrotachannel_15_analyzer_1_array_crystal_array_6, mcrotrchannel_15_analyzer_1_array_crystal_array_6;
Coords mcposachannel_15_analyzer_1_array_crystal_array_7, mcposrchannel_15_analyzer_1_array_crystal_array_7;
Rotation mcrotachannel_15_analyzer_1_array_crystal_array_7, mcrotrchannel_15_analyzer_1_array_crystal_array_7;
Coords mcposachannel_15_analyzer_1_array_crystal_array_8, mcposrchannel_15_analyzer_1_array_crystal_array_8;
Rotation mcrotachannel_15_analyzer_1_array_crystal_array_8, mcrotrchannel_15_analyzer_1_array_crystal_array_8;
Coords mcposachannel_15_analyzer_2_center, mcposrchannel_15_analyzer_2_center;
Rotation mcrotachannel_15_analyzer_2_center, mcrotrchannel_15_analyzer_2_center;
Coords mcposachannel_15_analyzer_2_rotated, mcposrchannel_15_analyzer_2_rotated;
Rotation mcrotachannel_15_analyzer_2_rotated, mcrotrchannel_15_analyzer_2_rotated;
Coords mcposachannel_15_analyzer_2_array_crystal_array_0, mcposrchannel_15_analyzer_2_array_crystal_array_0;
Rotation mcrotachannel_15_analyzer_2_array_crystal_array_0, mcrotrchannel_15_analyzer_2_array_crystal_array_0;
Coords mcposachannel_15_analyzer_2_array_crystal_array_1, mcposrchannel_15_analyzer_2_array_crystal_array_1;
Rotation mcrotachannel_15_analyzer_2_array_crystal_array_1, mcrotrchannel_15_analyzer_2_array_crystal_array_1;
Coords mcposachannel_15_analyzer_2_array_crystal_array_2, mcposrchannel_15_analyzer_2_array_crystal_array_2;
Rotation mcrotachannel_15_analyzer_2_array_crystal_array_2, mcrotrchannel_15_analyzer_2_array_crystal_array_2;
Coords mcposachannel_15_analyzer_2_array_crystal_array_3, mcposrchannel_15_analyzer_2_array_crystal_array_3;
Rotation mcrotachannel_15_analyzer_2_array_crystal_array_3, mcrotrchannel_15_analyzer_2_array_crystal_array_3;
Coords mcposachannel_15_analyzer_2_array_crystal_array_4, mcposrchannel_15_analyzer_2_array_crystal_array_4;
Rotation mcrotachannel_15_analyzer_2_array_crystal_array_4, mcrotrchannel_15_analyzer_2_array_crystal_array_4;
Coords mcposachannel_15_analyzer_2_array_crystal_array_5, mcposrchannel_15_analyzer_2_array_crystal_array_5;
Rotation mcrotachannel_15_analyzer_2_array_crystal_array_5, mcrotrchannel_15_analyzer_2_array_crystal_array_5;
Coords mcposachannel_15_analyzer_2_array_crystal_array_6, mcposrchannel_15_analyzer_2_array_crystal_array_6;
Rotation mcrotachannel_15_analyzer_2_array_crystal_array_6, mcrotrchannel_15_analyzer_2_array_crystal_array_6;
Coords mcposachannel_15_analyzer_2_array_crystal_array_7, mcposrchannel_15_analyzer_2_array_crystal_array_7;
Rotation mcrotachannel_15_analyzer_2_array_crystal_array_7, mcrotrchannel_15_analyzer_2_array_crystal_array_7;
Coords mcposachannel_15_analyzer_2_array_crystal_array_8, mcposrchannel_15_analyzer_2_array_crystal_array_8;
Rotation mcrotachannel_15_analyzer_2_array_crystal_array_8, mcrotrchannel_15_analyzer_2_array_crystal_array_8;
Coords mcposachannel_15_cave2_cyl1, mcposrchannel_15_cave2_cyl1;
Rotation mcrotachannel_15_cave2_cyl1, mcrotrchannel_15_cave2_cyl1;
Coords mcposachannel_15_cave2_box1, mcposrchannel_15_cave2_box1;
Rotation mcrotachannel_15_cave2_box1, mcrotrchannel_15_cave2_box1;
Coords mcposachannel_15_cave2_box2, mcposrchannel_15_cave2_box2;
Rotation mcrotachannel_15_cave2_box2, mcrotrchannel_15_cave2_box2;
Coords mcposachannel_15_cave2_box3, mcposrchannel_15_cave2_box3;
Rotation mcrotachannel_15_cave2_box3, mcrotrchannel_15_cave2_box3;
Coords mcposainter_analyzer_colimator_center_15, mcposrinter_analyzer_colimator_center_15;
Rotation mcrotainter_analyzer_colimator_center_15, mcrotrinter_analyzer_colimator_center_15;
Coords mcposainter_analyzer_colimator_15_blade_0, mcposrinter_analyzer_colimator_15_blade_0;
Rotation mcrotainter_analyzer_colimator_15_blade_0, mcrotrinter_analyzer_colimator_15_blade_0;
Coords mcposainter_analyzer_colimator_15_blade_1, mcposrinter_analyzer_colimator_15_blade_1;
Rotation mcrotainter_analyzer_colimator_15_blade_1, mcrotrinter_analyzer_colimator_15_blade_1;
Coords mcposainter_analyzer_colimator_15_blade_2, mcposrinter_analyzer_colimator_15_blade_2;
Rotation mcrotainter_analyzer_colimator_15_blade_2, mcrotrinter_analyzer_colimator_15_blade_2;
Coords mcposainter_analyzer_colimator_15_blade_3, mcposrinter_analyzer_colimator_15_blade_3;
Rotation mcrotainter_analyzer_colimator_15_blade_3, mcrotrinter_analyzer_colimator_15_blade_3;
Coords mcposainter_analyzer_colimator_15_blade_4, mcposrinter_analyzer_colimator_15_blade_4;
Rotation mcrotainter_analyzer_colimator_15_blade_4, mcrotrinter_analyzer_colimator_15_blade_4;
Coords mcposadiffraction_detector_15_exit_volume, mcposrdiffraction_detector_15_exit_volume;
Rotation mcrotadiffraction_detector_15_exit_volume, mcrotrdiffraction_detector_15_exit_volume;
Coords mcposaspec_detector_15_exit_volume, mcposrspec_detector_15_exit_volume;
Rotation mcrotaspec_detector_15_exit_volume, mcrotrspec_detector_15_exit_volume;
Coords mcposachannel_16_cave1_box1, mcposrchannel_16_cave1_box1;
Rotation mcrotachannel_16_cave1_box1, mcrotrchannel_16_cave1_box1;
Coords mcposachannel_16_cave1_box2, mcposrchannel_16_cave1_box2;
Rotation mcrotachannel_16_cave1_box2, mcrotrchannel_16_cave1_box2;
Coords mcposachannel_16_cave1_box3, mcposrchannel_16_cave1_box3;
Rotation mcrotachannel_16_cave1_box3, mcrotrchannel_16_cave1_box3;
Coords mcposachannel_16_cave1_cyl1, mcposrchannel_16_cave1_cyl1;
Rotation mcrotachannel_16_cave1_cyl1, mcrotrchannel_16_cave1_cyl1;
Coords mcposachannel_16_analyzer_1_center, mcposrchannel_16_analyzer_1_center;
Rotation mcrotachannel_16_analyzer_1_center, mcrotrchannel_16_analyzer_1_center;
Coords mcposachannel_16_analyzer_1_rotated, mcposrchannel_16_analyzer_1_rotated;
Rotation mcrotachannel_16_analyzer_1_rotated, mcrotrchannel_16_analyzer_1_rotated;
Coords mcposachannel_16_analyzer_1_array_crystal_array_0, mcposrchannel_16_analyzer_1_array_crystal_array_0;
Rotation mcrotachannel_16_analyzer_1_array_crystal_array_0, mcrotrchannel_16_analyzer_1_array_crystal_array_0;
Coords mcposachannel_16_analyzer_1_array_crystal_array_1, mcposrchannel_16_analyzer_1_array_crystal_array_1;
Rotation mcrotachannel_16_analyzer_1_array_crystal_array_1, mcrotrchannel_16_analyzer_1_array_crystal_array_1;
Coords mcposachannel_16_analyzer_1_array_crystal_array_2, mcposrchannel_16_analyzer_1_array_crystal_array_2;
Rotation mcrotachannel_16_analyzer_1_array_crystal_array_2, mcrotrchannel_16_analyzer_1_array_crystal_array_2;
Coords mcposachannel_16_analyzer_1_array_crystal_array_3, mcposrchannel_16_analyzer_1_array_crystal_array_3;
Rotation mcrotachannel_16_analyzer_1_array_crystal_array_3, mcrotrchannel_16_analyzer_1_array_crystal_array_3;
Coords mcposachannel_16_analyzer_1_array_crystal_array_4, mcposrchannel_16_analyzer_1_array_crystal_array_4;
Rotation mcrotachannel_16_analyzer_1_array_crystal_array_4, mcrotrchannel_16_analyzer_1_array_crystal_array_4;
Coords mcposachannel_16_analyzer_1_array_crystal_array_5, mcposrchannel_16_analyzer_1_array_crystal_array_5;
Rotation mcrotachannel_16_analyzer_1_array_crystal_array_5, mcrotrchannel_16_analyzer_1_array_crystal_array_5;
Coords mcposachannel_16_analyzer_1_array_crystal_array_6, mcposrchannel_16_analyzer_1_array_crystal_array_6;
Rotation mcrotachannel_16_analyzer_1_array_crystal_array_6, mcrotrchannel_16_analyzer_1_array_crystal_array_6;
Coords mcposachannel_16_analyzer_1_array_crystal_array_7, mcposrchannel_16_analyzer_1_array_crystal_array_7;
Rotation mcrotachannel_16_analyzer_1_array_crystal_array_7, mcrotrchannel_16_analyzer_1_array_crystal_array_7;
Coords mcposachannel_16_analyzer_1_array_crystal_array_8, mcposrchannel_16_analyzer_1_array_crystal_array_8;
Rotation mcrotachannel_16_analyzer_1_array_crystal_array_8, mcrotrchannel_16_analyzer_1_array_crystal_array_8;
Coords mcposachannel_16_analyzer_2_center, mcposrchannel_16_analyzer_2_center;
Rotation mcrotachannel_16_analyzer_2_center, mcrotrchannel_16_analyzer_2_center;
Coords mcposachannel_16_analyzer_2_rotated, mcposrchannel_16_analyzer_2_rotated;
Rotation mcrotachannel_16_analyzer_2_rotated, mcrotrchannel_16_analyzer_2_rotated;
Coords mcposachannel_16_analyzer_2_array_crystal_array_0, mcposrchannel_16_analyzer_2_array_crystal_array_0;
Rotation mcrotachannel_16_analyzer_2_array_crystal_array_0, mcrotrchannel_16_analyzer_2_array_crystal_array_0;
Coords mcposachannel_16_analyzer_2_array_crystal_array_1, mcposrchannel_16_analyzer_2_array_crystal_array_1;
Rotation mcrotachannel_16_analyzer_2_array_crystal_array_1, mcrotrchannel_16_analyzer_2_array_crystal_array_1;
Coords mcposachannel_16_analyzer_2_array_crystal_array_2, mcposrchannel_16_analyzer_2_array_crystal_array_2;
Rotation mcrotachannel_16_analyzer_2_array_crystal_array_2, mcrotrchannel_16_analyzer_2_array_crystal_array_2;
Coords mcposachannel_16_analyzer_2_array_crystal_array_3, mcposrchannel_16_analyzer_2_array_crystal_array_3;
Rotation mcrotachannel_16_analyzer_2_array_crystal_array_3, mcrotrchannel_16_analyzer_2_array_crystal_array_3;
Coords mcposachannel_16_analyzer_2_array_crystal_array_4, mcposrchannel_16_analyzer_2_array_crystal_array_4;
Rotation mcrotachannel_16_analyzer_2_array_crystal_array_4, mcrotrchannel_16_analyzer_2_array_crystal_array_4;
Coords mcposachannel_16_analyzer_2_array_crystal_array_5, mcposrchannel_16_analyzer_2_array_crystal_array_5;
Rotation mcrotachannel_16_analyzer_2_array_crystal_array_5, mcrotrchannel_16_analyzer_2_array_crystal_array_5;
Coords mcposachannel_16_analyzer_2_array_crystal_array_6, mcposrchannel_16_analyzer_2_array_crystal_array_6;
Rotation mcrotachannel_16_analyzer_2_array_crystal_array_6, mcrotrchannel_16_analyzer_2_array_crystal_array_6;
Coords mcposachannel_16_analyzer_2_array_crystal_array_7, mcposrchannel_16_analyzer_2_array_crystal_array_7;
Rotation mcrotachannel_16_analyzer_2_array_crystal_array_7, mcrotrchannel_16_analyzer_2_array_crystal_array_7;
Coords mcposachannel_16_analyzer_2_array_crystal_array_8, mcposrchannel_16_analyzer_2_array_crystal_array_8;
Rotation mcrotachannel_16_analyzer_2_array_crystal_array_8, mcrotrchannel_16_analyzer_2_array_crystal_array_8;
Coords mcposachannel_16_cave2_cyl1, mcposrchannel_16_cave2_cyl1;
Rotation mcrotachannel_16_cave2_cyl1, mcrotrchannel_16_cave2_cyl1;
Coords mcposachannel_16_cave2_box1, mcposrchannel_16_cave2_box1;
Rotation mcrotachannel_16_cave2_box1, mcrotrchannel_16_cave2_box1;
Coords mcposachannel_16_cave2_box2, mcposrchannel_16_cave2_box2;
Rotation mcrotachannel_16_cave2_box2, mcrotrchannel_16_cave2_box2;
Coords mcposachannel_16_cave2_box3, mcposrchannel_16_cave2_box3;
Rotation mcrotachannel_16_cave2_box3, mcrotrchannel_16_cave2_box3;
Coords mcposainter_analyzer_colimator_center_16, mcposrinter_analyzer_colimator_center_16;
Rotation mcrotainter_analyzer_colimator_center_16, mcrotrinter_analyzer_colimator_center_16;
Coords mcposainter_analyzer_colimator_16_blade_0, mcposrinter_analyzer_colimator_16_blade_0;
Rotation mcrotainter_analyzer_colimator_16_blade_0, mcrotrinter_analyzer_colimator_16_blade_0;
Coords mcposainter_analyzer_colimator_16_blade_1, mcposrinter_analyzer_colimator_16_blade_1;
Rotation mcrotainter_analyzer_colimator_16_blade_1, mcrotrinter_analyzer_colimator_16_blade_1;
Coords mcposainter_analyzer_colimator_16_blade_2, mcposrinter_analyzer_colimator_16_blade_2;
Rotation mcrotainter_analyzer_colimator_16_blade_2, mcrotrinter_analyzer_colimator_16_blade_2;
Coords mcposainter_analyzer_colimator_16_blade_3, mcposrinter_analyzer_colimator_16_blade_3;
Rotation mcrotainter_analyzer_colimator_16_blade_3, mcrotrinter_analyzer_colimator_16_blade_3;
Coords mcposainter_analyzer_colimator_16_blade_4, mcposrinter_analyzer_colimator_16_blade_4;
Rotation mcrotainter_analyzer_colimator_16_blade_4, mcrotrinter_analyzer_colimator_16_blade_4;
Coords mcposadiffraction_detector_16_exit_volume, mcposrdiffraction_detector_16_exit_volume;
Rotation mcrotadiffraction_detector_16_exit_volume, mcrotrdiffraction_detector_16_exit_volume;
Coords mcposaspec_detector_16_exit_volume, mcposrspec_detector_16_exit_volume;
Rotation mcrotaspec_detector_16_exit_volume, mcrotrspec_detector_16_exit_volume;
Coords mcposachannel_17_cave1_box1, mcposrchannel_17_cave1_box1;
Rotation mcrotachannel_17_cave1_box1, mcrotrchannel_17_cave1_box1;
Coords mcposachannel_17_cave1_box2, mcposrchannel_17_cave1_box2;
Rotation mcrotachannel_17_cave1_box2, mcrotrchannel_17_cave1_box2;
Coords mcposachannel_17_cave1_box3, mcposrchannel_17_cave1_box3;
Rotation mcrotachannel_17_cave1_box3, mcrotrchannel_17_cave1_box3;
Coords mcposachannel_17_cave1_cyl1, mcposrchannel_17_cave1_cyl1;
Rotation mcrotachannel_17_cave1_cyl1, mcrotrchannel_17_cave1_cyl1;
Coords mcposachannel_17_analyzer_1_center, mcposrchannel_17_analyzer_1_center;
Rotation mcrotachannel_17_analyzer_1_center, mcrotrchannel_17_analyzer_1_center;
Coords mcposachannel_17_analyzer_1_rotated, mcposrchannel_17_analyzer_1_rotated;
Rotation mcrotachannel_17_analyzer_1_rotated, mcrotrchannel_17_analyzer_1_rotated;
Coords mcposachannel_17_analyzer_1_array_crystal_array_0, mcposrchannel_17_analyzer_1_array_crystal_array_0;
Rotation mcrotachannel_17_analyzer_1_array_crystal_array_0, mcrotrchannel_17_analyzer_1_array_crystal_array_0;
Coords mcposachannel_17_analyzer_1_array_crystal_array_1, mcposrchannel_17_analyzer_1_array_crystal_array_1;
Rotation mcrotachannel_17_analyzer_1_array_crystal_array_1, mcrotrchannel_17_analyzer_1_array_crystal_array_1;
Coords mcposachannel_17_analyzer_1_array_crystal_array_2, mcposrchannel_17_analyzer_1_array_crystal_array_2;
Rotation mcrotachannel_17_analyzer_1_array_crystal_array_2, mcrotrchannel_17_analyzer_1_array_crystal_array_2;
Coords mcposachannel_17_analyzer_1_array_crystal_array_3, mcposrchannel_17_analyzer_1_array_crystal_array_3;
Rotation mcrotachannel_17_analyzer_1_array_crystal_array_3, mcrotrchannel_17_analyzer_1_array_crystal_array_3;
Coords mcposachannel_17_analyzer_1_array_crystal_array_4, mcposrchannel_17_analyzer_1_array_crystal_array_4;
Rotation mcrotachannel_17_analyzer_1_array_crystal_array_4, mcrotrchannel_17_analyzer_1_array_crystal_array_4;
Coords mcposachannel_17_analyzer_1_array_crystal_array_5, mcposrchannel_17_analyzer_1_array_crystal_array_5;
Rotation mcrotachannel_17_analyzer_1_array_crystal_array_5, mcrotrchannel_17_analyzer_1_array_crystal_array_5;
Coords mcposachannel_17_analyzer_1_array_crystal_array_6, mcposrchannel_17_analyzer_1_array_crystal_array_6;
Rotation mcrotachannel_17_analyzer_1_array_crystal_array_6, mcrotrchannel_17_analyzer_1_array_crystal_array_6;
Coords mcposachannel_17_analyzer_1_array_crystal_array_7, mcposrchannel_17_analyzer_1_array_crystal_array_7;
Rotation mcrotachannel_17_analyzer_1_array_crystal_array_7, mcrotrchannel_17_analyzer_1_array_crystal_array_7;
Coords mcposachannel_17_analyzer_1_array_crystal_array_8, mcposrchannel_17_analyzer_1_array_crystal_array_8;
Rotation mcrotachannel_17_analyzer_1_array_crystal_array_8, mcrotrchannel_17_analyzer_1_array_crystal_array_8;
Coords mcposachannel_17_analyzer_2_center, mcposrchannel_17_analyzer_2_center;
Rotation mcrotachannel_17_analyzer_2_center, mcrotrchannel_17_analyzer_2_center;
Coords mcposachannel_17_analyzer_2_rotated, mcposrchannel_17_analyzer_2_rotated;
Rotation mcrotachannel_17_analyzer_2_rotated, mcrotrchannel_17_analyzer_2_rotated;
Coords mcposachannel_17_analyzer_2_array_crystal_array_0, mcposrchannel_17_analyzer_2_array_crystal_array_0;
Rotation mcrotachannel_17_analyzer_2_array_crystal_array_0, mcrotrchannel_17_analyzer_2_array_crystal_array_0;
Coords mcposachannel_17_analyzer_2_array_crystal_array_1, mcposrchannel_17_analyzer_2_array_crystal_array_1;
Rotation mcrotachannel_17_analyzer_2_array_crystal_array_1, mcrotrchannel_17_analyzer_2_array_crystal_array_1;
Coords mcposachannel_17_analyzer_2_array_crystal_array_2, mcposrchannel_17_analyzer_2_array_crystal_array_2;
Rotation mcrotachannel_17_analyzer_2_array_crystal_array_2, mcrotrchannel_17_analyzer_2_array_crystal_array_2;
Coords mcposachannel_17_analyzer_2_array_crystal_array_3, mcposrchannel_17_analyzer_2_array_crystal_array_3;
Rotation mcrotachannel_17_analyzer_2_array_crystal_array_3, mcrotrchannel_17_analyzer_2_array_crystal_array_3;
Coords mcposachannel_17_analyzer_2_array_crystal_array_4, mcposrchannel_17_analyzer_2_array_crystal_array_4;
Rotation mcrotachannel_17_analyzer_2_array_crystal_array_4, mcrotrchannel_17_analyzer_2_array_crystal_array_4;
Coords mcposachannel_17_analyzer_2_array_crystal_array_5, mcposrchannel_17_analyzer_2_array_crystal_array_5;
Rotation mcrotachannel_17_analyzer_2_array_crystal_array_5, mcrotrchannel_17_analyzer_2_array_crystal_array_5;
Coords mcposachannel_17_analyzer_2_array_crystal_array_6, mcposrchannel_17_analyzer_2_array_crystal_array_6;
Rotation mcrotachannel_17_analyzer_2_array_crystal_array_6, mcrotrchannel_17_analyzer_2_array_crystal_array_6;
Coords mcposachannel_17_analyzer_2_array_crystal_array_7, mcposrchannel_17_analyzer_2_array_crystal_array_7;
Rotation mcrotachannel_17_analyzer_2_array_crystal_array_7, mcrotrchannel_17_analyzer_2_array_crystal_array_7;
Coords mcposachannel_17_analyzer_2_array_crystal_array_8, mcposrchannel_17_analyzer_2_array_crystal_array_8;
Rotation mcrotachannel_17_analyzer_2_array_crystal_array_8, mcrotrchannel_17_analyzer_2_array_crystal_array_8;
Coords mcposachannel_17_cave2_cyl1, mcposrchannel_17_cave2_cyl1;
Rotation mcrotachannel_17_cave2_cyl1, mcrotrchannel_17_cave2_cyl1;
Coords mcposachannel_17_cave2_box1, mcposrchannel_17_cave2_box1;
Rotation mcrotachannel_17_cave2_box1, mcrotrchannel_17_cave2_box1;
Coords mcposachannel_17_cave2_box2, mcposrchannel_17_cave2_box2;
Rotation mcrotachannel_17_cave2_box2, mcrotrchannel_17_cave2_box2;
Coords mcposachannel_17_cave2_box3, mcposrchannel_17_cave2_box3;
Rotation mcrotachannel_17_cave2_box3, mcrotrchannel_17_cave2_box3;
Coords mcposainter_analyzer_colimator_center_17, mcposrinter_analyzer_colimator_center_17;
Rotation mcrotainter_analyzer_colimator_center_17, mcrotrinter_analyzer_colimator_center_17;
Coords mcposainter_analyzer_colimator_17_blade_0, mcposrinter_analyzer_colimator_17_blade_0;
Rotation mcrotainter_analyzer_colimator_17_blade_0, mcrotrinter_analyzer_colimator_17_blade_0;
Coords mcposainter_analyzer_colimator_17_blade_1, mcposrinter_analyzer_colimator_17_blade_1;
Rotation mcrotainter_analyzer_colimator_17_blade_1, mcrotrinter_analyzer_colimator_17_blade_1;
Coords mcposainter_analyzer_colimator_17_blade_2, mcposrinter_analyzer_colimator_17_blade_2;
Rotation mcrotainter_analyzer_colimator_17_blade_2, mcrotrinter_analyzer_colimator_17_blade_2;
Coords mcposainter_analyzer_colimator_17_blade_3, mcposrinter_analyzer_colimator_17_blade_3;
Rotation mcrotainter_analyzer_colimator_17_blade_3, mcrotrinter_analyzer_colimator_17_blade_3;
Coords mcposainter_analyzer_colimator_17_blade_4, mcposrinter_analyzer_colimator_17_blade_4;
Rotation mcrotainter_analyzer_colimator_17_blade_4, mcrotrinter_analyzer_colimator_17_blade_4;
Coords mcposadiffraction_detector_17_exit_volume, mcposrdiffraction_detector_17_exit_volume;
Rotation mcrotadiffraction_detector_17_exit_volume, mcrotrdiffraction_detector_17_exit_volume;
Coords mcposaspec_detector_17_exit_volume, mcposrspec_detector_17_exit_volume;
Rotation mcrotaspec_detector_17_exit_volume, mcrotrspec_detector_17_exit_volume;
Coords mcposachannel_18_cave1_box1, mcposrchannel_18_cave1_box1;
Rotation mcrotachannel_18_cave1_box1, mcrotrchannel_18_cave1_box1;
Coords mcposachannel_18_cave1_box2, mcposrchannel_18_cave1_box2;
Rotation mcrotachannel_18_cave1_box2, mcrotrchannel_18_cave1_box2;
Coords mcposachannel_18_cave1_box3, mcposrchannel_18_cave1_box3;
Rotation mcrotachannel_18_cave1_box3, mcrotrchannel_18_cave1_box3;
Coords mcposachannel_18_cave1_cyl1, mcposrchannel_18_cave1_cyl1;
Rotation mcrotachannel_18_cave1_cyl1, mcrotrchannel_18_cave1_cyl1;
Coords mcposachannel_18_analyzer_1_center, mcposrchannel_18_analyzer_1_center;
Rotation mcrotachannel_18_analyzer_1_center, mcrotrchannel_18_analyzer_1_center;
Coords mcposachannel_18_analyzer_1_rotated, mcposrchannel_18_analyzer_1_rotated;
Rotation mcrotachannel_18_analyzer_1_rotated, mcrotrchannel_18_analyzer_1_rotated;
Coords mcposachannel_18_analyzer_1_array_crystal_array_0, mcposrchannel_18_analyzer_1_array_crystal_array_0;
Rotation mcrotachannel_18_analyzer_1_array_crystal_array_0, mcrotrchannel_18_analyzer_1_array_crystal_array_0;
Coords mcposachannel_18_analyzer_1_array_crystal_array_1, mcposrchannel_18_analyzer_1_array_crystal_array_1;
Rotation mcrotachannel_18_analyzer_1_array_crystal_array_1, mcrotrchannel_18_analyzer_1_array_crystal_array_1;
Coords mcposachannel_18_analyzer_1_array_crystal_array_2, mcposrchannel_18_analyzer_1_array_crystal_array_2;
Rotation mcrotachannel_18_analyzer_1_array_crystal_array_2, mcrotrchannel_18_analyzer_1_array_crystal_array_2;
Coords mcposachannel_18_analyzer_1_array_crystal_array_3, mcposrchannel_18_analyzer_1_array_crystal_array_3;
Rotation mcrotachannel_18_analyzer_1_array_crystal_array_3, mcrotrchannel_18_analyzer_1_array_crystal_array_3;
Coords mcposachannel_18_analyzer_1_array_crystal_array_4, mcposrchannel_18_analyzer_1_array_crystal_array_4;
Rotation mcrotachannel_18_analyzer_1_array_crystal_array_4, mcrotrchannel_18_analyzer_1_array_crystal_array_4;
Coords mcposachannel_18_analyzer_1_array_crystal_array_5, mcposrchannel_18_analyzer_1_array_crystal_array_5;
Rotation mcrotachannel_18_analyzer_1_array_crystal_array_5, mcrotrchannel_18_analyzer_1_array_crystal_array_5;
Coords mcposachannel_18_analyzer_1_array_crystal_array_6, mcposrchannel_18_analyzer_1_array_crystal_array_6;
Rotation mcrotachannel_18_analyzer_1_array_crystal_array_6, mcrotrchannel_18_analyzer_1_array_crystal_array_6;
Coords mcposachannel_18_analyzer_1_array_crystal_array_7, mcposrchannel_18_analyzer_1_array_crystal_array_7;
Rotation mcrotachannel_18_analyzer_1_array_crystal_array_7, mcrotrchannel_18_analyzer_1_array_crystal_array_7;
Coords mcposachannel_18_analyzer_1_array_crystal_array_8, mcposrchannel_18_analyzer_1_array_crystal_array_8;
Rotation mcrotachannel_18_analyzer_1_array_crystal_array_8, mcrotrchannel_18_analyzer_1_array_crystal_array_8;
Coords mcposachannel_18_analyzer_2_center, mcposrchannel_18_analyzer_2_center;
Rotation mcrotachannel_18_analyzer_2_center, mcrotrchannel_18_analyzer_2_center;
Coords mcposachannel_18_analyzer_2_rotated, mcposrchannel_18_analyzer_2_rotated;
Rotation mcrotachannel_18_analyzer_2_rotated, mcrotrchannel_18_analyzer_2_rotated;
Coords mcposachannel_18_analyzer_2_array_crystal_array_0, mcposrchannel_18_analyzer_2_array_crystal_array_0;
Rotation mcrotachannel_18_analyzer_2_array_crystal_array_0, mcrotrchannel_18_analyzer_2_array_crystal_array_0;
Coords mcposachannel_18_analyzer_2_array_crystal_array_1, mcposrchannel_18_analyzer_2_array_crystal_array_1;
Rotation mcrotachannel_18_analyzer_2_array_crystal_array_1, mcrotrchannel_18_analyzer_2_array_crystal_array_1;
Coords mcposachannel_18_analyzer_2_array_crystal_array_2, mcposrchannel_18_analyzer_2_array_crystal_array_2;
Rotation mcrotachannel_18_analyzer_2_array_crystal_array_2, mcrotrchannel_18_analyzer_2_array_crystal_array_2;
Coords mcposachannel_18_analyzer_2_array_crystal_array_3, mcposrchannel_18_analyzer_2_array_crystal_array_3;
Rotation mcrotachannel_18_analyzer_2_array_crystal_array_3, mcrotrchannel_18_analyzer_2_array_crystal_array_3;
Coords mcposachannel_18_analyzer_2_array_crystal_array_4, mcposrchannel_18_analyzer_2_array_crystal_array_4;
Rotation mcrotachannel_18_analyzer_2_array_crystal_array_4, mcrotrchannel_18_analyzer_2_array_crystal_array_4;
Coords mcposachannel_18_analyzer_2_array_crystal_array_5, mcposrchannel_18_analyzer_2_array_crystal_array_5;
Rotation mcrotachannel_18_analyzer_2_array_crystal_array_5, mcrotrchannel_18_analyzer_2_array_crystal_array_5;
Coords mcposachannel_18_analyzer_2_array_crystal_array_6, mcposrchannel_18_analyzer_2_array_crystal_array_6;
Rotation mcrotachannel_18_analyzer_2_array_crystal_array_6, mcrotrchannel_18_analyzer_2_array_crystal_array_6;
Coords mcposachannel_18_analyzer_2_array_crystal_array_7, mcposrchannel_18_analyzer_2_array_crystal_array_7;
Rotation mcrotachannel_18_analyzer_2_array_crystal_array_7, mcrotrchannel_18_analyzer_2_array_crystal_array_7;
Coords mcposachannel_18_analyzer_2_array_crystal_array_8, mcposrchannel_18_analyzer_2_array_crystal_array_8;
Rotation mcrotachannel_18_analyzer_2_array_crystal_array_8, mcrotrchannel_18_analyzer_2_array_crystal_array_8;
Coords mcposachannel_18_cave2_cyl1, mcposrchannel_18_cave2_cyl1;
Rotation mcrotachannel_18_cave2_cyl1, mcrotrchannel_18_cave2_cyl1;
Coords mcposachannel_18_cave2_box1, mcposrchannel_18_cave2_box1;
Rotation mcrotachannel_18_cave2_box1, mcrotrchannel_18_cave2_box1;
Coords mcposachannel_18_cave2_box2, mcposrchannel_18_cave2_box2;
Rotation mcrotachannel_18_cave2_box2, mcrotrchannel_18_cave2_box2;
Coords mcposachannel_18_cave2_box3, mcposrchannel_18_cave2_box3;
Rotation mcrotachannel_18_cave2_box3, mcrotrchannel_18_cave2_box3;
Coords mcposainter_analyzer_colimator_center_18, mcposrinter_analyzer_colimator_center_18;
Rotation mcrotainter_analyzer_colimator_center_18, mcrotrinter_analyzer_colimator_center_18;
Coords mcposainter_analyzer_colimator_18_blade_0, mcposrinter_analyzer_colimator_18_blade_0;
Rotation mcrotainter_analyzer_colimator_18_blade_0, mcrotrinter_analyzer_colimator_18_blade_0;
Coords mcposainter_analyzer_colimator_18_blade_1, mcposrinter_analyzer_colimator_18_blade_1;
Rotation mcrotainter_analyzer_colimator_18_blade_1, mcrotrinter_analyzer_colimator_18_blade_1;
Coords mcposainter_analyzer_colimator_18_blade_2, mcposrinter_analyzer_colimator_18_blade_2;
Rotation mcrotainter_analyzer_colimator_18_blade_2, mcrotrinter_analyzer_colimator_18_blade_2;
Coords mcposainter_analyzer_colimator_18_blade_3, mcposrinter_analyzer_colimator_18_blade_3;
Rotation mcrotainter_analyzer_colimator_18_blade_3, mcrotrinter_analyzer_colimator_18_blade_3;
Coords mcposainter_analyzer_colimator_18_blade_4, mcposrinter_analyzer_colimator_18_blade_4;
Rotation mcrotainter_analyzer_colimator_18_blade_4, mcrotrinter_analyzer_colimator_18_blade_4;
Coords mcposadiffraction_detector_18_exit_volume, mcposrdiffraction_detector_18_exit_volume;
Rotation mcrotadiffraction_detector_18_exit_volume, mcrotrdiffraction_detector_18_exit_volume;
Coords mcposaspec_detector_18_exit_volume, mcposrspec_detector_18_exit_volume;
Rotation mcrotaspec_detector_18_exit_volume, mcrotrspec_detector_18_exit_volume;
Coords mcposachannel_19_cave1_box1, mcposrchannel_19_cave1_box1;
Rotation mcrotachannel_19_cave1_box1, mcrotrchannel_19_cave1_box1;
Coords mcposachannel_19_cave1_box2, mcposrchannel_19_cave1_box2;
Rotation mcrotachannel_19_cave1_box2, mcrotrchannel_19_cave1_box2;
Coords mcposachannel_19_cave1_box3, mcposrchannel_19_cave1_box3;
Rotation mcrotachannel_19_cave1_box3, mcrotrchannel_19_cave1_box3;
Coords mcposachannel_19_cave1_cyl1, mcposrchannel_19_cave1_cyl1;
Rotation mcrotachannel_19_cave1_cyl1, mcrotrchannel_19_cave1_cyl1;
Coords mcposachannel_19_analyzer_1_center, mcposrchannel_19_analyzer_1_center;
Rotation mcrotachannel_19_analyzer_1_center, mcrotrchannel_19_analyzer_1_center;
Coords mcposachannel_19_analyzer_1_rotated, mcposrchannel_19_analyzer_1_rotated;
Rotation mcrotachannel_19_analyzer_1_rotated, mcrotrchannel_19_analyzer_1_rotated;
Coords mcposachannel_19_analyzer_1_array_crystal_array_0, mcposrchannel_19_analyzer_1_array_crystal_array_0;
Rotation mcrotachannel_19_analyzer_1_array_crystal_array_0, mcrotrchannel_19_analyzer_1_array_crystal_array_0;
Coords mcposachannel_19_analyzer_1_array_crystal_array_1, mcposrchannel_19_analyzer_1_array_crystal_array_1;
Rotation mcrotachannel_19_analyzer_1_array_crystal_array_1, mcrotrchannel_19_analyzer_1_array_crystal_array_1;
Coords mcposachannel_19_analyzer_1_array_crystal_array_2, mcposrchannel_19_analyzer_1_array_crystal_array_2;
Rotation mcrotachannel_19_analyzer_1_array_crystal_array_2, mcrotrchannel_19_analyzer_1_array_crystal_array_2;
Coords mcposachannel_19_analyzer_1_array_crystal_array_3, mcposrchannel_19_analyzer_1_array_crystal_array_3;
Rotation mcrotachannel_19_analyzer_1_array_crystal_array_3, mcrotrchannel_19_analyzer_1_array_crystal_array_3;
Coords mcposachannel_19_analyzer_1_array_crystal_array_4, mcposrchannel_19_analyzer_1_array_crystal_array_4;
Rotation mcrotachannel_19_analyzer_1_array_crystal_array_4, mcrotrchannel_19_analyzer_1_array_crystal_array_4;
Coords mcposachannel_19_analyzer_1_array_crystal_array_5, mcposrchannel_19_analyzer_1_array_crystal_array_5;
Rotation mcrotachannel_19_analyzer_1_array_crystal_array_5, mcrotrchannel_19_analyzer_1_array_crystal_array_5;
Coords mcposachannel_19_analyzer_1_array_crystal_array_6, mcposrchannel_19_analyzer_1_array_crystal_array_6;
Rotation mcrotachannel_19_analyzer_1_array_crystal_array_6, mcrotrchannel_19_analyzer_1_array_crystal_array_6;
Coords mcposachannel_19_analyzer_1_array_crystal_array_7, mcposrchannel_19_analyzer_1_array_crystal_array_7;
Rotation mcrotachannel_19_analyzer_1_array_crystal_array_7, mcrotrchannel_19_analyzer_1_array_crystal_array_7;
Coords mcposachannel_19_analyzer_1_array_crystal_array_8, mcposrchannel_19_analyzer_1_array_crystal_array_8;
Rotation mcrotachannel_19_analyzer_1_array_crystal_array_8, mcrotrchannel_19_analyzer_1_array_crystal_array_8;
Coords mcposachannel_19_analyzer_2_center, mcposrchannel_19_analyzer_2_center;
Rotation mcrotachannel_19_analyzer_2_center, mcrotrchannel_19_analyzer_2_center;
Coords mcposachannel_19_analyzer_2_rotated, mcposrchannel_19_analyzer_2_rotated;
Rotation mcrotachannel_19_analyzer_2_rotated, mcrotrchannel_19_analyzer_2_rotated;
Coords mcposachannel_19_analyzer_2_array_crystal_array_0, mcposrchannel_19_analyzer_2_array_crystal_array_0;
Rotation mcrotachannel_19_analyzer_2_array_crystal_array_0, mcrotrchannel_19_analyzer_2_array_crystal_array_0;
Coords mcposachannel_19_analyzer_2_array_crystal_array_1, mcposrchannel_19_analyzer_2_array_crystal_array_1;
Rotation mcrotachannel_19_analyzer_2_array_crystal_array_1, mcrotrchannel_19_analyzer_2_array_crystal_array_1;
Coords mcposachannel_19_analyzer_2_array_crystal_array_2, mcposrchannel_19_analyzer_2_array_crystal_array_2;
Rotation mcrotachannel_19_analyzer_2_array_crystal_array_2, mcrotrchannel_19_analyzer_2_array_crystal_array_2;
Coords mcposachannel_19_analyzer_2_array_crystal_array_3, mcposrchannel_19_analyzer_2_array_crystal_array_3;
Rotation mcrotachannel_19_analyzer_2_array_crystal_array_3, mcrotrchannel_19_analyzer_2_array_crystal_array_3;
Coords mcposachannel_19_analyzer_2_array_crystal_array_4, mcposrchannel_19_analyzer_2_array_crystal_array_4;
Rotation mcrotachannel_19_analyzer_2_array_crystal_array_4, mcrotrchannel_19_analyzer_2_array_crystal_array_4;
Coords mcposachannel_19_analyzer_2_array_crystal_array_5, mcposrchannel_19_analyzer_2_array_crystal_array_5;
Rotation mcrotachannel_19_analyzer_2_array_crystal_array_5, mcrotrchannel_19_analyzer_2_array_crystal_array_5;
Coords mcposachannel_19_analyzer_2_array_crystal_array_6, mcposrchannel_19_analyzer_2_array_crystal_array_6;
Rotation mcrotachannel_19_analyzer_2_array_crystal_array_6, mcrotrchannel_19_analyzer_2_array_crystal_array_6;
Coords mcposachannel_19_analyzer_2_array_crystal_array_7, mcposrchannel_19_analyzer_2_array_crystal_array_7;
Rotation mcrotachannel_19_analyzer_2_array_crystal_array_7, mcrotrchannel_19_analyzer_2_array_crystal_array_7;
Coords mcposachannel_19_analyzer_2_array_crystal_array_8, mcposrchannel_19_analyzer_2_array_crystal_array_8;
Rotation mcrotachannel_19_analyzer_2_array_crystal_array_8, mcrotrchannel_19_analyzer_2_array_crystal_array_8;
Coords mcposachannel_19_cave2_cyl1, mcposrchannel_19_cave2_cyl1;
Rotation mcrotachannel_19_cave2_cyl1, mcrotrchannel_19_cave2_cyl1;
Coords mcposachannel_19_cave2_box1, mcposrchannel_19_cave2_box1;
Rotation mcrotachannel_19_cave2_box1, mcrotrchannel_19_cave2_box1;
Coords mcposachannel_19_cave2_box2, mcposrchannel_19_cave2_box2;
Rotation mcrotachannel_19_cave2_box2, mcrotrchannel_19_cave2_box2;
Coords mcposachannel_19_cave2_box3, mcposrchannel_19_cave2_box3;
Rotation mcrotachannel_19_cave2_box3, mcrotrchannel_19_cave2_box3;
Coords mcposainter_analyzer_colimator_center_19, mcposrinter_analyzer_colimator_center_19;
Rotation mcrotainter_analyzer_colimator_center_19, mcrotrinter_analyzer_colimator_center_19;
Coords mcposainter_analyzer_colimator_19_blade_0, mcposrinter_analyzer_colimator_19_blade_0;
Rotation mcrotainter_analyzer_colimator_19_blade_0, mcrotrinter_analyzer_colimator_19_blade_0;
Coords mcposainter_analyzer_colimator_19_blade_1, mcposrinter_analyzer_colimator_19_blade_1;
Rotation mcrotainter_analyzer_colimator_19_blade_1, mcrotrinter_analyzer_colimator_19_blade_1;
Coords mcposainter_analyzer_colimator_19_blade_2, mcposrinter_analyzer_colimator_19_blade_2;
Rotation mcrotainter_analyzer_colimator_19_blade_2, mcrotrinter_analyzer_colimator_19_blade_2;
Coords mcposainter_analyzer_colimator_19_blade_3, mcposrinter_analyzer_colimator_19_blade_3;
Rotation mcrotainter_analyzer_colimator_19_blade_3, mcrotrinter_analyzer_colimator_19_blade_3;
Coords mcposainter_analyzer_colimator_19_blade_4, mcposrinter_analyzer_colimator_19_blade_4;
Rotation mcrotainter_analyzer_colimator_19_blade_4, mcrotrinter_analyzer_colimator_19_blade_4;
Coords mcposadiffraction_detector_19_exit_volume, mcposrdiffraction_detector_19_exit_volume;
Rotation mcrotadiffraction_detector_19_exit_volume, mcrotrdiffraction_detector_19_exit_volume;
Coords mcposaspec_detector_19_exit_volume, mcposrspec_detector_19_exit_volume;
Rotation mcrotaspec_detector_19_exit_volume, mcrotrspec_detector_19_exit_volume;
Coords mcposakidney_union_master, mcposrkidney_union_master;
Rotation mcrotakidney_union_master, mcrotrkidney_union_master;
Coords mcposadiffraction_detector_0, mcposrdiffraction_detector_0;
Rotation mcrotadiffraction_detector_0, mcrotrdiffraction_detector_0;
Coords mcposaspec_detector_0, mcposrspec_detector_0;
Rotation mcrotaspec_detector_0, mcrotrspec_detector_0;
Coords mcposadiffraction_detector_1, mcposrdiffraction_detector_1;
Rotation mcrotadiffraction_detector_1, mcrotrdiffraction_detector_1;
Coords mcposaspec_detector_1, mcposrspec_detector_1;
Rotation mcrotaspec_detector_1, mcrotrspec_detector_1;
Coords mcposadiffraction_detector_2, mcposrdiffraction_detector_2;
Rotation mcrotadiffraction_detector_2, mcrotrdiffraction_detector_2;
Coords mcposaspec_detector_2, mcposrspec_detector_2;
Rotation mcrotaspec_detector_2, mcrotrspec_detector_2;
Coords mcposadiffraction_detector_3, mcposrdiffraction_detector_3;
Rotation mcrotadiffraction_detector_3, mcrotrdiffraction_detector_3;
Coords mcposaspec_detector_3, mcposrspec_detector_3;
Rotation mcrotaspec_detector_3, mcrotrspec_detector_3;
Coords mcposadiffraction_detector_4, mcposrdiffraction_detector_4;
Rotation mcrotadiffraction_detector_4, mcrotrdiffraction_detector_4;
Coords mcposaspec_detector_4, mcposrspec_detector_4;
Rotation mcrotaspec_detector_4, mcrotrspec_detector_4;
Coords mcposadiffraction_detector_5, mcposrdiffraction_detector_5;
Rotation mcrotadiffraction_detector_5, mcrotrdiffraction_detector_5;
Coords mcposaspec_detector_5, mcposrspec_detector_5;
Rotation mcrotaspec_detector_5, mcrotrspec_detector_5;
Coords mcposadiffraction_detector_6, mcposrdiffraction_detector_6;
Rotation mcrotadiffraction_detector_6, mcrotrdiffraction_detector_6;
Coords mcposaspec_detector_6, mcposrspec_detector_6;
Rotation mcrotaspec_detector_6, mcrotrspec_detector_6;
Coords mcposadiffraction_detector_7, mcposrdiffraction_detector_7;
Rotation mcrotadiffraction_detector_7, mcrotrdiffraction_detector_7;
Coords mcposaspec_detector_7, mcposrspec_detector_7;
Rotation mcrotaspec_detector_7, mcrotrspec_detector_7;
Coords mcposadiffraction_detector_8, mcposrdiffraction_detector_8;
Rotation mcrotadiffraction_detector_8, mcrotrdiffraction_detector_8;
Coords mcposaspec_detector_8, mcposrspec_detector_8;
Rotation mcrotaspec_detector_8, mcrotrspec_detector_8;
Coords mcposadiffraction_detector_9, mcposrdiffraction_detector_9;
Rotation mcrotadiffraction_detector_9, mcrotrdiffraction_detector_9;
Coords mcposaspec_detector_9, mcposrspec_detector_9;
Rotation mcrotaspec_detector_9, mcrotrspec_detector_9;
Coords mcposadiffraction_detector_10, mcposrdiffraction_detector_10;
Rotation mcrotadiffraction_detector_10, mcrotrdiffraction_detector_10;
Coords mcposaspec_detector_10, mcposrspec_detector_10;
Rotation mcrotaspec_detector_10, mcrotrspec_detector_10;
Coords mcposadiffraction_detector_11, mcposrdiffraction_detector_11;
Rotation mcrotadiffraction_detector_11, mcrotrdiffraction_detector_11;
Coords mcposaspec_detector_11, mcposrspec_detector_11;
Rotation mcrotaspec_detector_11, mcrotrspec_detector_11;
Coords mcposadiffraction_detector_12, mcposrdiffraction_detector_12;
Rotation mcrotadiffraction_detector_12, mcrotrdiffraction_detector_12;
Coords mcposaspec_detector_12, mcposrspec_detector_12;
Rotation mcrotaspec_detector_12, mcrotrspec_detector_12;
Coords mcposadiffraction_detector_13, mcposrdiffraction_detector_13;
Rotation mcrotadiffraction_detector_13, mcrotrdiffraction_detector_13;
Coords mcposaspec_detector_13, mcposrspec_detector_13;
Rotation mcrotaspec_detector_13, mcrotrspec_detector_13;
Coords mcposadiffraction_detector_14, mcposrdiffraction_detector_14;
Rotation mcrotadiffraction_detector_14, mcrotrdiffraction_detector_14;
Coords mcposaspec_detector_14, mcposrspec_detector_14;
Rotation mcrotaspec_detector_14, mcrotrspec_detector_14;
Coords mcposadiffraction_detector_15, mcposrdiffraction_detector_15;
Rotation mcrotadiffraction_detector_15, mcrotrdiffraction_detector_15;
Coords mcposaspec_detector_15, mcposrspec_detector_15;
Rotation mcrotaspec_detector_15, mcrotrspec_detector_15;
Coords mcposadiffraction_detector_16, mcposrdiffraction_detector_16;
Rotation mcrotadiffraction_detector_16, mcrotrdiffraction_detector_16;
Coords mcposaspec_detector_16, mcposrspec_detector_16;
Rotation mcrotaspec_detector_16, mcrotrspec_detector_16;
Coords mcposadiffraction_detector_17, mcposrdiffraction_detector_17;
Rotation mcrotadiffraction_detector_17, mcrotrdiffraction_detector_17;
Coords mcposaspec_detector_17, mcposrspec_detector_17;
Rotation mcrotaspec_detector_17, mcrotrspec_detector_17;
Coords mcposadiffraction_detector_18, mcposrdiffraction_detector_18;
Rotation mcrotadiffraction_detector_18, mcrotrdiffraction_detector_18;
Coords mcposaspec_detector_18, mcposrspec_detector_18;
Rotation mcrotaspec_detector_18, mcrotrspec_detector_18;
Coords mcposadiffraction_detector_19, mcposrdiffraction_detector_19;
Rotation mcrotadiffraction_detector_19, mcrotrdiffraction_detector_19;
Coords mcposaspec_detector_19, mcposrspec_detector_19;
Rotation mcrotaspec_detector_19, mcrotrspec_detector_19;
Coords mcposaspec_detector_history_0, mcposrspec_detector_history_0;
Rotation mcrotaspec_detector_history_0, mcrotrspec_detector_history_0;
Coords mcposaspec_detector_history_1, mcposrspec_detector_history_1;
Rotation mcrotaspec_detector_history_1, mcrotrspec_detector_history_1;
Coords mcposaspec_detector_history_2, mcposrspec_detector_history_2;
Rotation mcrotaspec_detector_history_2, mcrotrspec_detector_history_2;
Coords mcposaspec_detector_history_3, mcposrspec_detector_history_3;
Rotation mcrotaspec_detector_history_3, mcrotrspec_detector_history_3;
Coords mcposaspec_detector_history_4, mcposrspec_detector_history_4;
Rotation mcrotaspec_detector_history_4, mcrotrspec_detector_history_4;
Coords mcposaspec_detector_history_5, mcposrspec_detector_history_5;
Rotation mcrotaspec_detector_history_5, mcrotrspec_detector_history_5;
Coords mcposaspec_detector_history_6, mcposrspec_detector_history_6;
Rotation mcrotaspec_detector_history_6, mcrotrspec_detector_history_6;
Coords mcposaspec_detector_history_7, mcposrspec_detector_history_7;
Rotation mcrotaspec_detector_history_7, mcrotrspec_detector_history_7;
Coords mcposaspec_detector_history_8, mcposrspec_detector_history_8;
Rotation mcrotaspec_detector_history_8, mcrotrspec_detector_history_8;
Coords mcposaspec_detector_history_9, mcposrspec_detector_history_9;
Rotation mcrotaspec_detector_history_9, mcrotrspec_detector_history_9;
Coords mcposaspec_detector_history_10, mcposrspec_detector_history_10;
Rotation mcrotaspec_detector_history_10, mcrotrspec_detector_history_10;
Coords mcposaspec_detector_history_11, mcposrspec_detector_history_11;
Rotation mcrotaspec_detector_history_11, mcrotrspec_detector_history_11;
Coords mcposaspec_detector_history_12, mcposrspec_detector_history_12;
Rotation mcrotaspec_detector_history_12, mcrotrspec_detector_history_12;
Coords mcposaspec_detector_history_13, mcposrspec_detector_history_13;
Rotation mcrotaspec_detector_history_13, mcrotrspec_detector_history_13;
Coords mcposaspec_detector_history_14, mcposrspec_detector_history_14;
Rotation mcrotaspec_detector_history_14, mcrotrspec_detector_history_14;
Coords mcposaspec_detector_history_15, mcposrspec_detector_history_15;
Rotation mcrotaspec_detector_history_15, mcrotrspec_detector_history_15;
Coords mcposaspec_detector_history_16, mcposrspec_detector_history_16;
Rotation mcrotaspec_detector_history_16, mcrotrspec_detector_history_16;
Coords mcposaspec_detector_history_17, mcposrspec_detector_history_17;
Rotation mcrotaspec_detector_history_17, mcrotrspec_detector_history_17;
Coords mcposaspec_detector_history_18, mcposrspec_detector_history_18;
Rotation mcrotaspec_detector_history_18, mcrotrspec_detector_history_18;
Coords mcposaspec_detector_history_19, mcposrspec_detector_history_19;
Rotation mcrotaspec_detector_history_19, mcrotrspec_detector_history_19;

MCNUM mcnx, mcny, mcnz, mcnvx, mcnvy, mcnvz, mcnt, mcnsx, mcnsy, mcnsz, mcnp;

/* end declare */

void mcinit(void) {
#define mccompcurname  dmtas
#define mccompcurtype  INSTRUMENT
#define mccompcurindex 0
#define mcposadmtas coords_set(0,0,0)
#define A3_angle mcipA3_angle
#define kidney_angle mcipkidney_angle
#define EM mcipEM
#define EF_all mcipEF_all
#define HF mcipHF
#define VF mcipVF
#define sample_diameter_d mcipsample_diameter_d
#define beta_1 mcipbeta_1
#define beta_2 mcipbeta_2
#define CPF mcipCPF
#define MPL mcipMPL
#define MPD mcipMPD
#define APE_h mcipAPE_h
#define APE_v mcipAPE_v
#define misalign_mono_deg mcipmisalign_mono_deg
#define DIRDEV mcipDIRDEV
#define DIVSOU mcipDIVSOU
#define L0_delta mcipL0_delta
#define L1_delta mcipL1_delta
#define mon_t mcipmon_t
#define mon_e mcipmon_e
#define monrot_delta mcipmonrot_delta
#define slit_h mcipslit_h
#define slit_v mcipslit_v
#define resolution_mode mcipresolution_mode
#define res_radius mcipres_radius
#define res_height mcipres_height
#define repeat_count mciprepeat_count
#define E0_resolution mcipE0_resolution
#define dE_resolution mcipdE_resolution
#line 224 "MACS_sample_kidney_box.instr"
{

  for (flag_index=0;flag_index<MAX_VOLUME_HISTORY_LENGTH;flag_index++) scattering_history_sample_master[flag_index] = 0;


  dmtas_sou_E0  = EM;
  dmtas_sou_dE  = 2*(1.79*exp(EM/20.07902)-1.9);
  apeh=APE_h;
  apev=APE_v;
  diverg=DIVSOU;
  slv_xmin=-0.181;
  slv_xmax=0.181;
  slv_ymin= -apev/2.;
  slv_ymax= apev/2.;
  slh_xmin=-apeh/2.;
  slh_xmax=apeh/2.;
  slh_ymin= -0.181;
  slh_ymax= 0.181; 

// The values below are initialization of from the MACS_mcstas_python package
/*
  //Now define the sample parameters here; These lines are written in later, but should look like this.
/* BEGIN INSERT BLOCK
*/ 
   samp_ax = 3.25276; //can be calculated from lattice params and u v matrix 
   samp_ay = -3.25276; 
   samp_az = -0.0; 
   samp_bx = 3.25276; 
   samp_by = 3.25276; 
   samp_bz = -0.0; 
   samp_cx = 0.0; 
   samp_cy = 0.0; 
   samp_cz = 2.9288; 
   samp_abs_xc = 12.18076; 
   samp_mosaic = 30.0; 
   samp_delta_d = 0.0005; 
   samp_inc_xc = 2.8716; 
   samp_cell_vol = 62.74; 
   samp_xwidth = 0.0043; 
   samp_ywidth = 0.0033; 
   samp_zwidth = 0.0013; 
   crystal_axis_xrot = 60.0; 
   crystal_axis_yrot = 0.0 ; 
   crystal_axis_zrot = 0.0; 
/*
/* END INSERT BLOCK
*/

  plate_distance=samp_ywidth/2.0;
  lambda=9.045/sqrt(EM);

  //%include "splint.c"
  //%include "monochromator.c"
// Start of initialize for generated monochromator

// Monochromator geometry
mono_theta = asin(mono_q/2./sqrt(EM/2.0717));

// distance from source to monochromator to calculate the focal point
dist_mono_L0	  = MPL-MPD/tan(2.*mono_theta) + L0_delta;
dist_mono_L0_pos = MPL-MPD/tan(2.*mono_theta);

// distance from monochromator to sample
dist_mono_L1     = 0.9+MPD/sin(2.*mono_theta) + L1_delta;
dist_mono_L1_pos = 0.9+MPD/sin(2.*mono_theta);

R_at_reference =2.*dist_mono_L0*dist_mono_L1/(dist_mono_L0+dist_mono_L1);
hight_at_reference =sin(asin((mono_crystal_width+0.001)/2./R_at_reference)*mono_number_of_rows)*R_at_reference*2.;

if (VF == 1) {
  mono_Radius_of_curvature = 2.*dist_mono_L0*dist_mono_L1*sin(mono_theta)/(dist_mono_L0+dist_mono_L1);
} else {
  mono_Radius_of_curvature = 300;
}

mono_total_height = sin(asin((mono_crystal_width+0.001)/2./mono_Radius_of_curvature)*mono_number_of_rows)*mono_Radius_of_curvature*2.;

mono_phi = atan2(sin(2.*mono_theta),cos(2.*mono_theta)+dist_mono_L1/dist_mono_L0);

for (mono_iterate=0;mono_iterate<21;mono_iterate++) {
  if (HF == 1)
    mono_psi[mono_iterate] =-(atan2(sin(mono_phi),cos(mono_phi)+mono_column_displacements[mono_iterate]/dist_mono_L0)-mono_theta)*RAD2DEG;
  else {
    mono_psi[mono_iterate] = 0;
    mono_phi = mono_theta;
  }
}

// Monochromator reflectivity and mosaicity
mono_mosaicity_eta_rad = mono_mosaicity_eta_min/60*DEG2RAD;
mono_g = 1/(2*sqrt(PI)*mono_mosaicity_eta_rad);
mono_Ff=4*mono_b_c;
mono_Vc = sqrt(3)*2.464*2.464*6.711/2;
mono_Qc = lambda*lambda*lambda*mono_Ff*mono_Ff/(mono_Vc*mono_Vc*sin(2*mono_theta));
mono_t = mono_crystal_thickness/sin(mono_theta);
mono_xx = sqrt(2)*mono_g*mono_Qc*mono_t;
mono_r0 = mono_xx/(mono_xx+1);
mono_mosaicity_rad = mono_mosaicity_eta_rad*sqrt(8*log(2+sqrt(2)*mono_g*mono_Qc*mono_crystal_thickness));
mono_mosaicity_min = mono_mosaicity_rad*RAD2DEG*60;
mono_array0_effective_radius_of_curvature = mono_array0_crystal_depth+mono_Radius_of_curvature;
mono_array0_theta_max = asin(mono_total_height/sqrt((2*mono_Radius_of_curvature + 2*mono_array0_crystal_depth)*(2*mono_Radius_of_curvature + 2*mono_array0_crystal_depth) + mono_array0_crystal_height*mono_array0_crystal_height) - atan(mono_array0_crystal_height/(2*mono_Radius_of_curvature + 2*mono_array0_crystal_depth)));
mono_array0_delta_theta = (2*mono_array0_theta_max) / ((double) mono_array0_number_of_crystals - 1);
for (mono_array0_iterate=0;mono_array0_iterate<17;mono_array0_iterate++)
    mono_array0_theta[mono_array0_iterate] = mono_array0_delta_theta * (double) mono_array0_iterate - mono_array0_theta_max;
mono_array0_arch_inner_radius = mono_Radius_of_curvature+mono_array0_crystal_depth+mono_array0_support_arch_spacing;
mono_array0_arch_outer_radius = mono_array0_arch_inner_radius + mono_array0_support_arch_thickness;
mono_array0_mask_depth = mono_Radius_of_curvature * (1-cos(mono_array0_theta_max + 2*mono_array0_delta_theta));
mono_array1_effective_radius_of_curvature = mono_array1_crystal_depth+mono_Radius_of_curvature;
mono_array1_theta_max = asin(mono_total_height/sqrt((2*mono_Radius_of_curvature + 2*mono_array1_crystal_depth)*(2*mono_Radius_of_curvature + 2*mono_array1_crystal_depth) + mono_array1_crystal_height*mono_array1_crystal_height) - atan(mono_array1_crystal_height/(2*mono_Radius_of_curvature + 2*mono_array1_crystal_depth)));
mono_array1_delta_theta = (2*mono_array1_theta_max) / ((double) mono_array1_number_of_crystals - 1);
for (mono_array1_iterate=0;mono_array1_iterate<17;mono_array1_iterate++)
    mono_array1_theta[mono_array1_iterate] = mono_array1_delta_theta * (double) mono_array1_iterate - mono_array1_theta_max;
mono_array1_arch_inner_radius = mono_Radius_of_curvature+mono_array1_crystal_depth+mono_array1_support_arch_spacing;
mono_array1_arch_outer_radius = mono_array1_arch_inner_radius + mono_array1_support_arch_thickness;
mono_array1_mask_depth = mono_Radius_of_curvature * (1-cos(mono_array1_theta_max + 2*mono_array1_delta_theta));
mono_array2_effective_radius_of_curvature = mono_array2_crystal_depth+mono_Radius_of_curvature;
mono_array2_theta_max = asin(mono_total_height/sqrt((2*mono_Radius_of_curvature + 2*mono_array2_crystal_depth)*(2*mono_Radius_of_curvature + 2*mono_array2_crystal_depth) + mono_array2_crystal_height*mono_array2_crystal_height) - atan(mono_array2_crystal_height/(2*mono_Radius_of_curvature + 2*mono_array2_crystal_depth)));
mono_array2_delta_theta = (2*mono_array2_theta_max) / ((double) mono_array2_number_of_crystals - 1);
for (mono_array2_iterate=0;mono_array2_iterate<17;mono_array2_iterate++)
    mono_array2_theta[mono_array2_iterate] = mono_array2_delta_theta * (double) mono_array2_iterate - mono_array2_theta_max;
mono_array2_arch_inner_radius = mono_Radius_of_curvature+mono_array2_crystal_depth+mono_array2_support_arch_spacing;
mono_array2_arch_outer_radius = mono_array2_arch_inner_radius + mono_array2_support_arch_thickness;
mono_array2_mask_depth = mono_Radius_of_curvature * (1-cos(mono_array2_theta_max + 2*mono_array2_delta_theta));
mono_array3_effective_radius_of_curvature = mono_array3_crystal_depth+mono_Radius_of_curvature;
mono_array3_theta_max = asin(mono_total_height/sqrt((2*mono_Radius_of_curvature + 2*mono_array3_crystal_depth)*(2*mono_Radius_of_curvature + 2*mono_array3_crystal_depth) + mono_array3_crystal_height*mono_array3_crystal_height) - atan(mono_array3_crystal_height/(2*mono_Radius_of_curvature + 2*mono_array3_crystal_depth)));
mono_array3_delta_theta = (2*mono_array3_theta_max) / ((double) mono_array3_number_of_crystals - 1);
for (mono_array3_iterate=0;mono_array3_iterate<17;mono_array3_iterate++)
    mono_array3_theta[mono_array3_iterate] = mono_array3_delta_theta * (double) mono_array3_iterate - mono_array3_theta_max;
mono_array3_arch_inner_radius = mono_Radius_of_curvature+mono_array3_crystal_depth+mono_array3_support_arch_spacing;
mono_array3_arch_outer_radius = mono_array3_arch_inner_radius + mono_array3_support_arch_thickness;
mono_array3_mask_depth = mono_Radius_of_curvature * (1-cos(mono_array3_theta_max + 2*mono_array3_delta_theta));
mono_array4_effective_radius_of_curvature = mono_array4_crystal_depth+mono_Radius_of_curvature;
mono_array4_theta_max = asin(mono_total_height/sqrt((2*mono_Radius_of_curvature + 2*mono_array4_crystal_depth)*(2*mono_Radius_of_curvature + 2*mono_array4_crystal_depth) + mono_array4_crystal_height*mono_array4_crystal_height) - atan(mono_array4_crystal_height/(2*mono_Radius_of_curvature + 2*mono_array4_crystal_depth)));
mono_array4_delta_theta = (2*mono_array4_theta_max) / ((double) mono_array4_number_of_crystals - 1);
for (mono_array4_iterate=0;mono_array4_iterate<17;mono_array4_iterate++)
    mono_array4_theta[mono_array4_iterate] = mono_array4_delta_theta * (double) mono_array4_iterate - mono_array4_theta_max;
mono_array4_arch_inner_radius = mono_Radius_of_curvature+mono_array4_crystal_depth+mono_array4_support_arch_spacing;
mono_array4_arch_outer_radius = mono_array4_arch_inner_radius + mono_array4_support_arch_thickness;
mono_array4_mask_depth = mono_Radius_of_curvature * (1-cos(mono_array4_theta_max + 2*mono_array4_delta_theta));
mono_array5_effective_radius_of_curvature = mono_array5_crystal_depth+mono_Radius_of_curvature;
mono_array5_theta_max = asin(mono_total_height/sqrt((2*mono_Radius_of_curvature + 2*mono_array5_crystal_depth)*(2*mono_Radius_of_curvature + 2*mono_array5_crystal_depth) + mono_array5_crystal_height*mono_array5_crystal_height) - atan(mono_array5_crystal_height/(2*mono_Radius_of_curvature + 2*mono_array5_crystal_depth)));
mono_array5_delta_theta = (2*mono_array5_theta_max) / ((double) mono_array5_number_of_crystals - 1);
for (mono_array5_iterate=0;mono_array5_iterate<17;mono_array5_iterate++)
    mono_array5_theta[mono_array5_iterate] = mono_array5_delta_theta * (double) mono_array5_iterate - mono_array5_theta_max;
mono_array5_arch_inner_radius = mono_Radius_of_curvature+mono_array5_crystal_depth+mono_array5_support_arch_spacing;
mono_array5_arch_outer_radius = mono_array5_arch_inner_radius + mono_array5_support_arch_thickness;
mono_array5_mask_depth = mono_Radius_of_curvature * (1-cos(mono_array5_theta_max + 2*mono_array5_delta_theta));
mono_array6_effective_radius_of_curvature = mono_array6_crystal_depth+mono_Radius_of_curvature;
mono_array6_theta_max = asin(mono_total_height/sqrt((2*mono_Radius_of_curvature + 2*mono_array6_crystal_depth)*(2*mono_Radius_of_curvature + 2*mono_array6_crystal_depth) + mono_array6_crystal_height*mono_array6_crystal_height) - atan(mono_array6_crystal_height/(2*mono_Radius_of_curvature + 2*mono_array6_crystal_depth)));
mono_array6_delta_theta = (2*mono_array6_theta_max) / ((double) mono_array6_number_of_crystals - 1);
for (mono_array6_iterate=0;mono_array6_iterate<17;mono_array6_iterate++)
    mono_array6_theta[mono_array6_iterate] = mono_array6_delta_theta * (double) mono_array6_iterate - mono_array6_theta_max;
mono_array6_arch_inner_radius = mono_Radius_of_curvature+mono_array6_crystal_depth+mono_array6_support_arch_spacing;
mono_array6_arch_outer_radius = mono_array6_arch_inner_radius + mono_array6_support_arch_thickness;
mono_array6_mask_depth = mono_Radius_of_curvature * (1-cos(mono_array6_theta_max + 2*mono_array6_delta_theta));
mono_array7_effective_radius_of_curvature = mono_array7_crystal_depth+mono_Radius_of_curvature;
mono_array7_theta_max = asin(mono_total_height/sqrt((2*mono_Radius_of_curvature + 2*mono_array7_crystal_depth)*(2*mono_Radius_of_curvature + 2*mono_array7_crystal_depth) + mono_array7_crystal_height*mono_array7_crystal_height) - atan(mono_array7_crystal_height/(2*mono_Radius_of_curvature + 2*mono_array7_crystal_depth)));
mono_array7_delta_theta = (2*mono_array7_theta_max) / ((double) mono_array7_number_of_crystals - 1);
for (mono_array7_iterate=0;mono_array7_iterate<17;mono_array7_iterate++)
    mono_array7_theta[mono_array7_iterate] = mono_array7_delta_theta * (double) mono_array7_iterate - mono_array7_theta_max;
mono_array7_arch_inner_radius = mono_Radius_of_curvature+mono_array7_crystal_depth+mono_array7_support_arch_spacing;
mono_array7_arch_outer_radius = mono_array7_arch_inner_radius + mono_array7_support_arch_thickness;
mono_array7_mask_depth = mono_Radius_of_curvature * (1-cos(mono_array7_theta_max + 2*mono_array7_delta_theta));
mono_array8_effective_radius_of_curvature = mono_array8_crystal_depth+mono_Radius_of_curvature;
mono_array8_theta_max = asin(mono_total_height/sqrt((2*mono_Radius_of_curvature + 2*mono_array8_crystal_depth)*(2*mono_Radius_of_curvature + 2*mono_array8_crystal_depth) + mono_array8_crystal_height*mono_array8_crystal_height) - atan(mono_array8_crystal_height/(2*mono_Radius_of_curvature + 2*mono_array8_crystal_depth)));
mono_array8_delta_theta = (2*mono_array8_theta_max) / ((double) mono_array8_number_of_crystals - 1);
for (mono_array8_iterate=0;mono_array8_iterate<17;mono_array8_iterate++)
    mono_array8_theta[mono_array8_iterate] = mono_array8_delta_theta * (double) mono_array8_iterate - mono_array8_theta_max;
mono_array8_arch_inner_radius = mono_Radius_of_curvature+mono_array8_crystal_depth+mono_array8_support_arch_spacing;
mono_array8_arch_outer_radius = mono_array8_arch_inner_radius + mono_array8_support_arch_thickness;
mono_array8_mask_depth = mono_Radius_of_curvature * (1-cos(mono_array8_theta_max + 2*mono_array8_delta_theta));
mono_array9_effective_radius_of_curvature = mono_array9_crystal_depth+mono_Radius_of_curvature;
mono_array9_theta_max = asin(mono_total_height/sqrt((2*mono_Radius_of_curvature + 2*mono_array9_crystal_depth)*(2*mono_Radius_of_curvature + 2*mono_array9_crystal_depth) + mono_array9_crystal_height*mono_array9_crystal_height) - atan(mono_array9_crystal_height/(2*mono_Radius_of_curvature + 2*mono_array9_crystal_depth)));
mono_array9_delta_theta = (2*mono_array9_theta_max) / ((double) mono_array9_number_of_crystals - 1);
for (mono_array9_iterate=0;mono_array9_iterate<17;mono_array9_iterate++)
    mono_array9_theta[mono_array9_iterate] = mono_array9_delta_theta * (double) mono_array9_iterate - mono_array9_theta_max;
mono_array9_arch_inner_radius = mono_Radius_of_curvature+mono_array9_crystal_depth+mono_array9_support_arch_spacing;
mono_array9_arch_outer_radius = mono_array9_arch_inner_radius + mono_array9_support_arch_thickness;
mono_array9_mask_depth = mono_Radius_of_curvature * (1-cos(mono_array9_theta_max + 2*mono_array9_delta_theta));
mono_array10_effective_radius_of_curvature = mono_array10_crystal_depth+mono_Radius_of_curvature;
mono_array10_theta_max = asin(mono_total_height/sqrt((2*mono_Radius_of_curvature + 2*mono_array10_crystal_depth)*(2*mono_Radius_of_curvature + 2*mono_array10_crystal_depth) + mono_array10_crystal_height*mono_array10_crystal_height) - atan(mono_array10_crystal_height/(2*mono_Radius_of_curvature + 2*mono_array10_crystal_depth)));
mono_array10_delta_theta = (2*mono_array10_theta_max) / ((double) mono_array10_number_of_crystals - 1);
for (mono_array10_iterate=0;mono_array10_iterate<17;mono_array10_iterate++)
    mono_array10_theta[mono_array10_iterate] = mono_array10_delta_theta * (double) mono_array10_iterate - mono_array10_theta_max;
mono_array10_arch_inner_radius = mono_Radius_of_curvature+mono_array10_crystal_depth+mono_array10_support_arch_spacing;
mono_array10_arch_outer_radius = mono_array10_arch_inner_radius + mono_array10_support_arch_thickness;
mono_array10_mask_depth = mono_Radius_of_curvature * (1-cos(mono_array10_theta_max + 2*mono_array10_delta_theta));
mono_array11_effective_radius_of_curvature = mono_array11_crystal_depth+mono_Radius_of_curvature;
mono_array11_theta_max = asin(mono_total_height/sqrt((2*mono_Radius_of_curvature + 2*mono_array11_crystal_depth)*(2*mono_Radius_of_curvature + 2*mono_array11_crystal_depth) + mono_array11_crystal_height*mono_array11_crystal_height) - atan(mono_array11_crystal_height/(2*mono_Radius_of_curvature + 2*mono_array11_crystal_depth)));
mono_array11_delta_theta = (2*mono_array11_theta_max) / ((double) mono_array11_number_of_crystals - 1);
for (mono_array11_iterate=0;mono_array11_iterate<17;mono_array11_iterate++)
    mono_array11_theta[mono_array11_iterate] = mono_array11_delta_theta * (double) mono_array11_iterate - mono_array11_theta_max;
mono_array11_arch_inner_radius = mono_Radius_of_curvature+mono_array11_crystal_depth+mono_array11_support_arch_spacing;
mono_array11_arch_outer_radius = mono_array11_arch_inner_radius + mono_array11_support_arch_thickness;
mono_array11_mask_depth = mono_Radius_of_curvature * (1-cos(mono_array11_theta_max + 2*mono_array11_delta_theta));
mono_array12_effective_radius_of_curvature = mono_array12_crystal_depth+mono_Radius_of_curvature;
mono_array12_theta_max = asin(mono_total_height/sqrt((2*mono_Radius_of_curvature + 2*mono_array12_crystal_depth)*(2*mono_Radius_of_curvature + 2*mono_array12_crystal_depth) + mono_array12_crystal_height*mono_array12_crystal_height) - atan(mono_array12_crystal_height/(2*mono_Radius_of_curvature + 2*mono_array12_crystal_depth)));
mono_array12_delta_theta = (2*mono_array12_theta_max) / ((double) mono_array12_number_of_crystals - 1);
for (mono_array12_iterate=0;mono_array12_iterate<17;mono_array12_iterate++)
    mono_array12_theta[mono_array12_iterate] = mono_array12_delta_theta * (double) mono_array12_iterate - mono_array12_theta_max;
mono_array12_arch_inner_radius = mono_Radius_of_curvature+mono_array12_crystal_depth+mono_array12_support_arch_spacing;
mono_array12_arch_outer_radius = mono_array12_arch_inner_radius + mono_array12_support_arch_thickness;
mono_array12_mask_depth = mono_Radius_of_curvature * (1-cos(mono_array12_theta_max + 2*mono_array12_delta_theta));
mono_array13_effective_radius_of_curvature = mono_array13_crystal_depth+mono_Radius_of_curvature;
mono_array13_theta_max = asin(mono_total_height/sqrt((2*mono_Radius_of_curvature + 2*mono_array13_crystal_depth)*(2*mono_Radius_of_curvature + 2*mono_array13_crystal_depth) + mono_array13_crystal_height*mono_array13_crystal_height) - atan(mono_array13_crystal_height/(2*mono_Radius_of_curvature + 2*mono_array13_crystal_depth)));
mono_array13_delta_theta = (2*mono_array13_theta_max) / ((double) mono_array13_number_of_crystals - 1);
for (mono_array13_iterate=0;mono_array13_iterate<17;mono_array13_iterate++)
    mono_array13_theta[mono_array13_iterate] = mono_array13_delta_theta * (double) mono_array13_iterate - mono_array13_theta_max;
mono_array13_arch_inner_radius = mono_Radius_of_curvature+mono_array13_crystal_depth+mono_array13_support_arch_spacing;
mono_array13_arch_outer_radius = mono_array13_arch_inner_radius + mono_array13_support_arch_thickness;
mono_array13_mask_depth = mono_Radius_of_curvature * (1-cos(mono_array13_theta_max + 2*mono_array13_delta_theta));
mono_array14_effective_radius_of_curvature = mono_array14_crystal_depth+mono_Radius_of_curvature;
mono_array14_theta_max = asin(mono_total_height/sqrt((2*mono_Radius_of_curvature + 2*mono_array14_crystal_depth)*(2*mono_Radius_of_curvature + 2*mono_array14_crystal_depth) + mono_array14_crystal_height*mono_array14_crystal_height) - atan(mono_array14_crystal_height/(2*mono_Radius_of_curvature + 2*mono_array14_crystal_depth)));
mono_array14_delta_theta = (2*mono_array14_theta_max) / ((double) mono_array14_number_of_crystals - 1);
for (mono_array14_iterate=0;mono_array14_iterate<17;mono_array14_iterate++)
    mono_array14_theta[mono_array14_iterate] = mono_array14_delta_theta * (double) mono_array14_iterate - mono_array14_theta_max;
mono_array14_arch_inner_radius = mono_Radius_of_curvature+mono_array14_crystal_depth+mono_array14_support_arch_spacing;
mono_array14_arch_outer_radius = mono_array14_arch_inner_radius + mono_array14_support_arch_thickness;
mono_array14_mask_depth = mono_Radius_of_curvature * (1-cos(mono_array14_theta_max + 2*mono_array14_delta_theta));
mono_array15_effective_radius_of_curvature = mono_array15_crystal_depth+mono_Radius_of_curvature;
mono_array15_theta_max = asin(mono_total_height/sqrt((2*mono_Radius_of_curvature + 2*mono_array15_crystal_depth)*(2*mono_Radius_of_curvature + 2*mono_array15_crystal_depth) + mono_array15_crystal_height*mono_array15_crystal_height) - atan(mono_array15_crystal_height/(2*mono_Radius_of_curvature + 2*mono_array15_crystal_depth)));
mono_array15_delta_theta = (2*mono_array15_theta_max) / ((double) mono_array15_number_of_crystals - 1);
for (mono_array15_iterate=0;mono_array15_iterate<17;mono_array15_iterate++)
    mono_array15_theta[mono_array15_iterate] = mono_array15_delta_theta * (double) mono_array15_iterate - mono_array15_theta_max;
mono_array15_arch_inner_radius = mono_Radius_of_curvature+mono_array15_crystal_depth+mono_array15_support_arch_spacing;
mono_array15_arch_outer_radius = mono_array15_arch_inner_radius + mono_array15_support_arch_thickness;
mono_array15_mask_depth = mono_Radius_of_curvature * (1-cos(mono_array15_theta_max + 2*mono_array15_delta_theta));
mono_array16_effective_radius_of_curvature = mono_array16_crystal_depth+mono_Radius_of_curvature;
mono_array16_theta_max = asin(mono_total_height/sqrt((2*mono_Radius_of_curvature + 2*mono_array16_crystal_depth)*(2*mono_Radius_of_curvature + 2*mono_array16_crystal_depth) + mono_array16_crystal_height*mono_array16_crystal_height) - atan(mono_array16_crystal_height/(2*mono_Radius_of_curvature + 2*mono_array16_crystal_depth)));
mono_array16_delta_theta = (2*mono_array16_theta_max) / ((double) mono_array16_number_of_crystals - 1);
for (mono_array16_iterate=0;mono_array16_iterate<17;mono_array16_iterate++)
    mono_array16_theta[mono_array16_iterate] = mono_array16_delta_theta * (double) mono_array16_iterate - mono_array16_theta_max;
mono_array16_arch_inner_radius = mono_Radius_of_curvature+mono_array16_crystal_depth+mono_array16_support_arch_spacing;
mono_array16_arch_outer_radius = mono_array16_arch_inner_radius + mono_array16_support_arch_thickness;
mono_array16_mask_depth = mono_Radius_of_curvature * (1-cos(mono_array16_theta_max + 2*mono_array16_delta_theta));
mono_array17_effective_radius_of_curvature = mono_array17_crystal_depth+mono_Radius_of_curvature;
mono_array17_theta_max = asin(mono_total_height/sqrt((2*mono_Radius_of_curvature + 2*mono_array17_crystal_depth)*(2*mono_Radius_of_curvature + 2*mono_array17_crystal_depth) + mono_array17_crystal_height*mono_array17_crystal_height) - atan(mono_array17_crystal_height/(2*mono_Radius_of_curvature + 2*mono_array17_crystal_depth)));
mono_array17_delta_theta = (2*mono_array17_theta_max) / ((double) mono_array17_number_of_crystals - 1);
for (mono_array17_iterate=0;mono_array17_iterate<17;mono_array17_iterate++)
    mono_array17_theta[mono_array17_iterate] = mono_array17_delta_theta * (double) mono_array17_iterate - mono_array17_theta_max;
mono_array17_arch_inner_radius = mono_Radius_of_curvature+mono_array17_crystal_depth+mono_array17_support_arch_spacing;
mono_array17_arch_outer_radius = mono_array17_arch_inner_radius + mono_array17_support_arch_thickness;
mono_array17_mask_depth = mono_Radius_of_curvature * (1-cos(mono_array17_theta_max + 2*mono_array17_delta_theta));
mono_array18_effective_radius_of_curvature = mono_array18_crystal_depth+mono_Radius_of_curvature;
mono_array18_theta_max = asin(mono_total_height/sqrt((2*mono_Radius_of_curvature + 2*mono_array18_crystal_depth)*(2*mono_Radius_of_curvature + 2*mono_array18_crystal_depth) + mono_array18_crystal_height*mono_array18_crystal_height) - atan(mono_array18_crystal_height/(2*mono_Radius_of_curvature + 2*mono_array18_crystal_depth)));
mono_array18_delta_theta = (2*mono_array18_theta_max) / ((double) mono_array18_number_of_crystals - 1);
for (mono_array18_iterate=0;mono_array18_iterate<17;mono_array18_iterate++)
    mono_array18_theta[mono_array18_iterate] = mono_array18_delta_theta * (double) mono_array18_iterate - mono_array18_theta_max;
mono_array18_arch_inner_radius = mono_Radius_of_curvature+mono_array18_crystal_depth+mono_array18_support_arch_spacing;
mono_array18_arch_outer_radius = mono_array18_arch_inner_radius + mono_array18_support_arch_thickness;
mono_array18_mask_depth = mono_Radius_of_curvature * (1-cos(mono_array18_theta_max + 2*mono_array18_delta_theta));
mono_array19_effective_radius_of_curvature = mono_array19_crystal_depth+mono_Radius_of_curvature;
mono_array19_theta_max = asin(mono_total_height/sqrt((2*mono_Radius_of_curvature + 2*mono_array19_crystal_depth)*(2*mono_Radius_of_curvature + 2*mono_array19_crystal_depth) + mono_array19_crystal_height*mono_array19_crystal_height) - atan(mono_array19_crystal_height/(2*mono_Radius_of_curvature + 2*mono_array19_crystal_depth)));
mono_array19_delta_theta = (2*mono_array19_theta_max) / ((double) mono_array19_number_of_crystals - 1);
for (mono_array19_iterate=0;mono_array19_iterate<17;mono_array19_iterate++)
    mono_array19_theta[mono_array19_iterate] = mono_array19_delta_theta * (double) mono_array19_iterate - mono_array19_theta_max;
mono_array19_arch_inner_radius = mono_Radius_of_curvature+mono_array19_crystal_depth+mono_array19_support_arch_spacing;
mono_array19_arch_outer_radius = mono_array19_arch_inner_radius + mono_array19_support_arch_thickness;
mono_array19_mask_depth = mono_Radius_of_curvature * (1-cos(mono_array19_theta_max + 2*mono_array19_delta_theta));
mono_array20_effective_radius_of_curvature = mono_array20_crystal_depth+mono_Radius_of_curvature;
mono_array20_theta_max = asin(mono_total_height/sqrt((2*mono_Radius_of_curvature + 2*mono_array20_crystal_depth)*(2*mono_Radius_of_curvature + 2*mono_array20_crystal_depth) + mono_array20_crystal_height*mono_array20_crystal_height) - atan(mono_array20_crystal_height/(2*mono_Radius_of_curvature + 2*mono_array20_crystal_depth)));
mono_array20_delta_theta = (2*mono_array20_theta_max) / ((double) mono_array20_number_of_crystals - 1);
for (mono_array20_iterate=0;mono_array20_iterate<17;mono_array20_iterate++)
    mono_array20_theta[mono_array20_iterate] = mono_array20_delta_theta * (double) mono_array20_iterate - mono_array20_theta_max;
mono_array20_arch_inner_radius = mono_Radius_of_curvature+mono_array20_crystal_depth+mono_array20_support_arch_spacing;
mono_array20_arch_outer_radius = mono_array20_arch_inner_radius + mono_array20_support_arch_thickness;
mono_array20_mask_depth = mono_Radius_of_curvature * (1-cos(mono_array20_theta_max + 2*mono_array20_delta_theta));

  
  dist_slit1  =MPD/sin(2.*mono_theta)-0.43;
      /*distance from monochromator to slit1*/
  dist_slit2  =MPD/sin(2.*mono_theta)+0.65;
      /*distance from monochromator to slit2*/

  angle_of_ver =mono_theta+mono_psi[10]*DEG2RAD;
  len_of_ver =0.22*sin(angle_of_ver)*2;

  tan_ver =dist_mono_L1_pos/((hight_at_reference-0.04)/2);

  tan_hor =(MPD/sin(2.*mono_theta)-0.22*cos(angle_of_ver)+0.65)/((len_of_ver-0.02)/2);

  //printf("mos=%f\n",dmtas_mon_mos);
  /*printf("dtheta=%f\n",dmtas_mon_mos);*/

/* printf("tan_ver=%f,tan_hor=%f\n",tan_ver,tan_hor);*/
  
  dmtas_guide_h1=hight_at_reference-(MPD-0.43)/tan_ver*2;
  dmtas_guide_h2=hight_at_reference-(MPD+0.65)/tan_ver*2;

  dmtas_guide_w1=len_of_ver-(MPD/sin(2.*mono_theta)-0.22*cos(angle_of_ver)-0.43)/tan_hor*2;
  dmtas_guide_w2=len_of_ver-(MPD/sin(2.*mono_theta)-0.22*cos(angle_of_ver)+0.65)/tan_hor*2;

/*  printf("dmtas_guide_h1=%f,dmtas_guide_h2=%f,dmtas_guide_w1=%f,dmtas_guide_w2=%f\n",dmtas_guide_h1,dmtas_guide_h2,dmtas_guide_w1,dmtas_guide_w2);*/
  dmtas_guide_len=1.080;
  mono_phi  =mono_phi*RAD2DEG;
  mono_theta  =mono_theta*RAD2DEG;
  xmax_det  =dmtas_det_w/2.;
  xmin_det  =-xmax_det;
  ymax_det  =dmtas_det_h/2.;
  ymin_det  =-ymax_det;
 
  emin=EM-1;
  emax=EM+1;


// Start of initialize for generated kidney
kidney_cave1_start_target_dist = kidney_hull_inner_radius-0.001;
kidney_cave1_box1_center_to_target = kidney_hull_inner_radius+0.5*(0.23989-0.02);
kidney_cave1_box2_center_to_target = kidney_hull_inner_radius+0.30609;
kidney_cave1_box3_center_to_target = kidney_hull_inner_radius+0.38819-0.001-0.01163*0.125;
kidney_cave1_cyl1_center_to_target = kidney_hull_inner_radius+0.40609-0.01163;
kidney_cave2_box1_width2 = kidney_cave2_box1_width1 + 2*kidney_cave2_box1_depth*sin((106.4-90)*DEG2RAD);
kidney_cave2_box1_center_to_spec_detector_z = -0.29044 - 0.5*kidney_cave2_box1_width1*sin(kidney_cave2_box1_y_rotation*DEG2RAD) + 0.5*kidney_cave2_box1_depth*cos(kidney_cave2_box1_y_rotation*DEG2RAD);
kidney_cave2_box1_center_to_spec_detector_x = -0.031 + 0.5*kidney_cave2_box1_width1*cos(kidney_cave2_box1_y_rotation*DEG2RAD) +  0.5*kidney_cave2_box1_depth*sin(kidney_cave2_box1_y_rotation*DEG2RAD);
delta_analyzer_2theta = (analyzer_2theta_max - analyzer_2theta_min)/19;
for (kidney_iterate=0;kidney_iterate<20;kidney_iterate++) {
  analyzer_theta[kidney_iterate] = RAD2DEG*asin(1.87325/2./sqrt(EF_all/2.0717));
  analyzer_2theta[kidney_iterate] = 2.0*analyzer_theta[kidney_iterate];
}
diffraction_detector_to_sample=kidney_cave1_cyl1_center_to_target;
spec_detector_to_analyzer_2_center = sqrt(spec_detector_to_sample*spec_detector_to_sample-analyzer_seperation*analyzer_seperation)-analyzer_1_center_to_sample;
spec_detector_to_analyzer_2_center = spec_detector_to_sample-analyzer_1_center_to_sample;
channel_0_analyzer_1_array_effective_radius_of_curvature = channel_0_analyzer_1_array_crystal_depth+channel_0_analyzer_1_array_radius_of_curvature;
channel_0_analyzer_1_array_theta_max = asin(channel_0_analyzer_1_array_total_height/sqrt((2*channel_0_analyzer_1_array_radius_of_curvature + 2*channel_0_analyzer_1_array_crystal_depth)*(2*channel_0_analyzer_1_array_radius_of_curvature + 2*channel_0_analyzer_1_array_crystal_depth) + channel_0_analyzer_1_array_crystal_height*channel_0_analyzer_1_array_crystal_height) - atan(channel_0_analyzer_1_array_crystal_height/(2*channel_0_analyzer_1_array_radius_of_curvature + 2*channel_0_analyzer_1_array_crystal_depth)));
channel_0_analyzer_1_array_delta_theta = (2*channel_0_analyzer_1_array_theta_max) / ((double) channel_0_analyzer_1_array_number_of_crystals - 1);
for (channel_0_analyzer_1_array_iterate=0;channel_0_analyzer_1_array_iterate<9;channel_0_analyzer_1_array_iterate++)
    channel_0_analyzer_1_array_theta[channel_0_analyzer_1_array_iterate] = channel_0_analyzer_1_array_delta_theta * (double) channel_0_analyzer_1_array_iterate - channel_0_analyzer_1_array_theta_max;
channel_0_analyzer_2_array_effective_radius_of_curvature = channel_0_analyzer_2_array_crystal_depth+channel_0_analyzer_2_array_radius_of_curvature;
channel_0_analyzer_2_array_theta_max = asin(channel_0_analyzer_2_array_total_height/sqrt((2*channel_0_analyzer_2_array_radius_of_curvature + 2*channel_0_analyzer_2_array_crystal_depth)*(2*channel_0_analyzer_2_array_radius_of_curvature + 2*channel_0_analyzer_2_array_crystal_depth) + channel_0_analyzer_2_array_crystal_height*channel_0_analyzer_2_array_crystal_height) - atan(channel_0_analyzer_2_array_crystal_height/(2*channel_0_analyzer_2_array_radius_of_curvature + 2*channel_0_analyzer_2_array_crystal_depth)));
channel_0_analyzer_2_array_delta_theta = (2*channel_0_analyzer_2_array_theta_max) / ((double) channel_0_analyzer_2_array_number_of_crystals - 1);
for (channel_0_analyzer_2_array_iterate=0;channel_0_analyzer_2_array_iterate<9;channel_0_analyzer_2_array_iterate++)
    channel_0_analyzer_2_array_theta[channel_0_analyzer_2_array_iterate] = channel_0_analyzer_2_array_delta_theta * (double) channel_0_analyzer_2_array_iterate - channel_0_analyzer_2_array_theta_max;
channel_1_analyzer_1_array_effective_radius_of_curvature = channel_1_analyzer_1_array_crystal_depth+channel_1_analyzer_1_array_radius_of_curvature;
channel_1_analyzer_1_array_theta_max = asin(channel_1_analyzer_1_array_total_height/sqrt((2*channel_1_analyzer_1_array_radius_of_curvature + 2*channel_1_analyzer_1_array_crystal_depth)*(2*channel_1_analyzer_1_array_radius_of_curvature + 2*channel_1_analyzer_1_array_crystal_depth) + channel_1_analyzer_1_array_crystal_height*channel_1_analyzer_1_array_crystal_height) - atan(channel_1_analyzer_1_array_crystal_height/(2*channel_1_analyzer_1_array_radius_of_curvature + 2*channel_1_analyzer_1_array_crystal_depth)));
channel_1_analyzer_1_array_delta_theta = (2*channel_1_analyzer_1_array_theta_max) / ((double) channel_1_analyzer_1_array_number_of_crystals - 1);
for (channel_1_analyzer_1_array_iterate=0;channel_1_analyzer_1_array_iterate<9;channel_1_analyzer_1_array_iterate++)
    channel_1_analyzer_1_array_theta[channel_1_analyzer_1_array_iterate] = channel_1_analyzer_1_array_delta_theta * (double) channel_1_analyzer_1_array_iterate - channel_1_analyzer_1_array_theta_max;
channel_1_analyzer_2_array_effective_radius_of_curvature = channel_1_analyzer_2_array_crystal_depth+channel_1_analyzer_2_array_radius_of_curvature;
channel_1_analyzer_2_array_theta_max = asin(channel_1_analyzer_2_array_total_height/sqrt((2*channel_1_analyzer_2_array_radius_of_curvature + 2*channel_1_analyzer_2_array_crystal_depth)*(2*channel_1_analyzer_2_array_radius_of_curvature + 2*channel_1_analyzer_2_array_crystal_depth) + channel_1_analyzer_2_array_crystal_height*channel_1_analyzer_2_array_crystal_height) - atan(channel_1_analyzer_2_array_crystal_height/(2*channel_1_analyzer_2_array_radius_of_curvature + 2*channel_1_analyzer_2_array_crystal_depth)));
channel_1_analyzer_2_array_delta_theta = (2*channel_1_analyzer_2_array_theta_max) / ((double) channel_1_analyzer_2_array_number_of_crystals - 1);
for (channel_1_analyzer_2_array_iterate=0;channel_1_analyzer_2_array_iterate<9;channel_1_analyzer_2_array_iterate++)
    channel_1_analyzer_2_array_theta[channel_1_analyzer_2_array_iterate] = channel_1_analyzer_2_array_delta_theta * (double) channel_1_analyzer_2_array_iterate - channel_1_analyzer_2_array_theta_max;
channel_2_analyzer_1_array_effective_radius_of_curvature = channel_2_analyzer_1_array_crystal_depth+channel_2_analyzer_1_array_radius_of_curvature;
channel_2_analyzer_1_array_theta_max = asin(channel_2_analyzer_1_array_total_height/sqrt((2*channel_2_analyzer_1_array_radius_of_curvature + 2*channel_2_analyzer_1_array_crystal_depth)*(2*channel_2_analyzer_1_array_radius_of_curvature + 2*channel_2_analyzer_1_array_crystal_depth) + channel_2_analyzer_1_array_crystal_height*channel_2_analyzer_1_array_crystal_height) - atan(channel_2_analyzer_1_array_crystal_height/(2*channel_2_analyzer_1_array_radius_of_curvature + 2*channel_2_analyzer_1_array_crystal_depth)));
channel_2_analyzer_1_array_delta_theta = (2*channel_2_analyzer_1_array_theta_max) / ((double) channel_2_analyzer_1_array_number_of_crystals - 1);
for (channel_2_analyzer_1_array_iterate=0;channel_2_analyzer_1_array_iterate<9;channel_2_analyzer_1_array_iterate++)
    channel_2_analyzer_1_array_theta[channel_2_analyzer_1_array_iterate] = channel_2_analyzer_1_array_delta_theta * (double) channel_2_analyzer_1_array_iterate - channel_2_analyzer_1_array_theta_max;
channel_2_analyzer_2_array_effective_radius_of_curvature = channel_2_analyzer_2_array_crystal_depth+channel_2_analyzer_2_array_radius_of_curvature;
channel_2_analyzer_2_array_theta_max = asin(channel_2_analyzer_2_array_total_height/sqrt((2*channel_2_analyzer_2_array_radius_of_curvature + 2*channel_2_analyzer_2_array_crystal_depth)*(2*channel_2_analyzer_2_array_radius_of_curvature + 2*channel_2_analyzer_2_array_crystal_depth) + channel_2_analyzer_2_array_crystal_height*channel_2_analyzer_2_array_crystal_height) - atan(channel_2_analyzer_2_array_crystal_height/(2*channel_2_analyzer_2_array_radius_of_curvature + 2*channel_2_analyzer_2_array_crystal_depth)));
channel_2_analyzer_2_array_delta_theta = (2*channel_2_analyzer_2_array_theta_max) / ((double) channel_2_analyzer_2_array_number_of_crystals - 1);
for (channel_2_analyzer_2_array_iterate=0;channel_2_analyzer_2_array_iterate<9;channel_2_analyzer_2_array_iterate++)
    channel_2_analyzer_2_array_theta[channel_2_analyzer_2_array_iterate] = channel_2_analyzer_2_array_delta_theta * (double) channel_2_analyzer_2_array_iterate - channel_2_analyzer_2_array_theta_max;
channel_3_analyzer_1_array_effective_radius_of_curvature = channel_3_analyzer_1_array_crystal_depth+channel_3_analyzer_1_array_radius_of_curvature;
channel_3_analyzer_1_array_theta_max = asin(channel_3_analyzer_1_array_total_height/sqrt((2*channel_3_analyzer_1_array_radius_of_curvature + 2*channel_3_analyzer_1_array_crystal_depth)*(2*channel_3_analyzer_1_array_radius_of_curvature + 2*channel_3_analyzer_1_array_crystal_depth) + channel_3_analyzer_1_array_crystal_height*channel_3_analyzer_1_array_crystal_height) - atan(channel_3_analyzer_1_array_crystal_height/(2*channel_3_analyzer_1_array_radius_of_curvature + 2*channel_3_analyzer_1_array_crystal_depth)));
channel_3_analyzer_1_array_delta_theta = (2*channel_3_analyzer_1_array_theta_max) / ((double) channel_3_analyzer_1_array_number_of_crystals - 1);
for (channel_3_analyzer_1_array_iterate=0;channel_3_analyzer_1_array_iterate<9;channel_3_analyzer_1_array_iterate++)
    channel_3_analyzer_1_array_theta[channel_3_analyzer_1_array_iterate] = channel_3_analyzer_1_array_delta_theta * (double) channel_3_analyzer_1_array_iterate - channel_3_analyzer_1_array_theta_max;
channel_3_analyzer_2_array_effective_radius_of_curvature = channel_3_analyzer_2_array_crystal_depth+channel_3_analyzer_2_array_radius_of_curvature;
channel_3_analyzer_2_array_theta_max = asin(channel_3_analyzer_2_array_total_height/sqrt((2*channel_3_analyzer_2_array_radius_of_curvature + 2*channel_3_analyzer_2_array_crystal_depth)*(2*channel_3_analyzer_2_array_radius_of_curvature + 2*channel_3_analyzer_2_array_crystal_depth) + channel_3_analyzer_2_array_crystal_height*channel_3_analyzer_2_array_crystal_height) - atan(channel_3_analyzer_2_array_crystal_height/(2*channel_3_analyzer_2_array_radius_of_curvature + 2*channel_3_analyzer_2_array_crystal_depth)));
channel_3_analyzer_2_array_delta_theta = (2*channel_3_analyzer_2_array_theta_max) / ((double) channel_3_analyzer_2_array_number_of_crystals - 1);
for (channel_3_analyzer_2_array_iterate=0;channel_3_analyzer_2_array_iterate<9;channel_3_analyzer_2_array_iterate++)
    channel_3_analyzer_2_array_theta[channel_3_analyzer_2_array_iterate] = channel_3_analyzer_2_array_delta_theta * (double) channel_3_analyzer_2_array_iterate - channel_3_analyzer_2_array_theta_max;
channel_4_analyzer_1_array_effective_radius_of_curvature = channel_4_analyzer_1_array_crystal_depth+channel_4_analyzer_1_array_radius_of_curvature;
channel_4_analyzer_1_array_theta_max = asin(channel_4_analyzer_1_array_total_height/sqrt((2*channel_4_analyzer_1_array_radius_of_curvature + 2*channel_4_analyzer_1_array_crystal_depth)*(2*channel_4_analyzer_1_array_radius_of_curvature + 2*channel_4_analyzer_1_array_crystal_depth) + channel_4_analyzer_1_array_crystal_height*channel_4_analyzer_1_array_crystal_height) - atan(channel_4_analyzer_1_array_crystal_height/(2*channel_4_analyzer_1_array_radius_of_curvature + 2*channel_4_analyzer_1_array_crystal_depth)));
channel_4_analyzer_1_array_delta_theta = (2*channel_4_analyzer_1_array_theta_max) / ((double) channel_4_analyzer_1_array_number_of_crystals - 1);
for (channel_4_analyzer_1_array_iterate=0;channel_4_analyzer_1_array_iterate<9;channel_4_analyzer_1_array_iterate++)
    channel_4_analyzer_1_array_theta[channel_4_analyzer_1_array_iterate] = channel_4_analyzer_1_array_delta_theta * (double) channel_4_analyzer_1_array_iterate - channel_4_analyzer_1_array_theta_max;
channel_4_analyzer_2_array_effective_radius_of_curvature = channel_4_analyzer_2_array_crystal_depth+channel_4_analyzer_2_array_radius_of_curvature;
channel_4_analyzer_2_array_theta_max = asin(channel_4_analyzer_2_array_total_height/sqrt((2*channel_4_analyzer_2_array_radius_of_curvature + 2*channel_4_analyzer_2_array_crystal_depth)*(2*channel_4_analyzer_2_array_radius_of_curvature + 2*channel_4_analyzer_2_array_crystal_depth) + channel_4_analyzer_2_array_crystal_height*channel_4_analyzer_2_array_crystal_height) - atan(channel_4_analyzer_2_array_crystal_height/(2*channel_4_analyzer_2_array_radius_of_curvature + 2*channel_4_analyzer_2_array_crystal_depth)));
channel_4_analyzer_2_array_delta_theta = (2*channel_4_analyzer_2_array_theta_max) / ((double) channel_4_analyzer_2_array_number_of_crystals - 1);
for (channel_4_analyzer_2_array_iterate=0;channel_4_analyzer_2_array_iterate<9;channel_4_analyzer_2_array_iterate++)
    channel_4_analyzer_2_array_theta[channel_4_analyzer_2_array_iterate] = channel_4_analyzer_2_array_delta_theta * (double) channel_4_analyzer_2_array_iterate - channel_4_analyzer_2_array_theta_max;
channel_5_analyzer_1_array_effective_radius_of_curvature = channel_5_analyzer_1_array_crystal_depth+channel_5_analyzer_1_array_radius_of_curvature;
channel_5_analyzer_1_array_theta_max = asin(channel_5_analyzer_1_array_total_height/sqrt((2*channel_5_analyzer_1_array_radius_of_curvature + 2*channel_5_analyzer_1_array_crystal_depth)*(2*channel_5_analyzer_1_array_radius_of_curvature + 2*channel_5_analyzer_1_array_crystal_depth) + channel_5_analyzer_1_array_crystal_height*channel_5_analyzer_1_array_crystal_height) - atan(channel_5_analyzer_1_array_crystal_height/(2*channel_5_analyzer_1_array_radius_of_curvature + 2*channel_5_analyzer_1_array_crystal_depth)));
channel_5_analyzer_1_array_delta_theta = (2*channel_5_analyzer_1_array_theta_max) / ((double) channel_5_analyzer_1_array_number_of_crystals - 1);
for (channel_5_analyzer_1_array_iterate=0;channel_5_analyzer_1_array_iterate<9;channel_5_analyzer_1_array_iterate++)
    channel_5_analyzer_1_array_theta[channel_5_analyzer_1_array_iterate] = channel_5_analyzer_1_array_delta_theta * (double) channel_5_analyzer_1_array_iterate - channel_5_analyzer_1_array_theta_max;
channel_5_analyzer_2_array_effective_radius_of_curvature = channel_5_analyzer_2_array_crystal_depth+channel_5_analyzer_2_array_radius_of_curvature;
channel_5_analyzer_2_array_theta_max = asin(channel_5_analyzer_2_array_total_height/sqrt((2*channel_5_analyzer_2_array_radius_of_curvature + 2*channel_5_analyzer_2_array_crystal_depth)*(2*channel_5_analyzer_2_array_radius_of_curvature + 2*channel_5_analyzer_2_array_crystal_depth) + channel_5_analyzer_2_array_crystal_height*channel_5_analyzer_2_array_crystal_height) - atan(channel_5_analyzer_2_array_crystal_height/(2*channel_5_analyzer_2_array_radius_of_curvature + 2*channel_5_analyzer_2_array_crystal_depth)));
channel_5_analyzer_2_array_delta_theta = (2*channel_5_analyzer_2_array_theta_max) / ((double) channel_5_analyzer_2_array_number_of_crystals - 1);
for (channel_5_analyzer_2_array_iterate=0;channel_5_analyzer_2_array_iterate<9;channel_5_analyzer_2_array_iterate++)
    channel_5_analyzer_2_array_theta[channel_5_analyzer_2_array_iterate] = channel_5_analyzer_2_array_delta_theta * (double) channel_5_analyzer_2_array_iterate - channel_5_analyzer_2_array_theta_max;
channel_6_analyzer_1_array_effective_radius_of_curvature = channel_6_analyzer_1_array_crystal_depth+channel_6_analyzer_1_array_radius_of_curvature;
channel_6_analyzer_1_array_theta_max = asin(channel_6_analyzer_1_array_total_height/sqrt((2*channel_6_analyzer_1_array_radius_of_curvature + 2*channel_6_analyzer_1_array_crystal_depth)*(2*channel_6_analyzer_1_array_radius_of_curvature + 2*channel_6_analyzer_1_array_crystal_depth) + channel_6_analyzer_1_array_crystal_height*channel_6_analyzer_1_array_crystal_height) - atan(channel_6_analyzer_1_array_crystal_height/(2*channel_6_analyzer_1_array_radius_of_curvature + 2*channel_6_analyzer_1_array_crystal_depth)));
channel_6_analyzer_1_array_delta_theta = (2*channel_6_analyzer_1_array_theta_max) / ((double) channel_6_analyzer_1_array_number_of_crystals - 1);
for (channel_6_analyzer_1_array_iterate=0;channel_6_analyzer_1_array_iterate<9;channel_6_analyzer_1_array_iterate++)
    channel_6_analyzer_1_array_theta[channel_6_analyzer_1_array_iterate] = channel_6_analyzer_1_array_delta_theta * (double) channel_6_analyzer_1_array_iterate - channel_6_analyzer_1_array_theta_max;
channel_6_analyzer_2_array_effective_radius_of_curvature = channel_6_analyzer_2_array_crystal_depth+channel_6_analyzer_2_array_radius_of_curvature;
channel_6_analyzer_2_array_theta_max = asin(channel_6_analyzer_2_array_total_height/sqrt((2*channel_6_analyzer_2_array_radius_of_curvature + 2*channel_6_analyzer_2_array_crystal_depth)*(2*channel_6_analyzer_2_array_radius_of_curvature + 2*channel_6_analyzer_2_array_crystal_depth) + channel_6_analyzer_2_array_crystal_height*channel_6_analyzer_2_array_crystal_height) - atan(channel_6_analyzer_2_array_crystal_height/(2*channel_6_analyzer_2_array_radius_of_curvature + 2*channel_6_analyzer_2_array_crystal_depth)));
channel_6_analyzer_2_array_delta_theta = (2*channel_6_analyzer_2_array_theta_max) / ((double) channel_6_analyzer_2_array_number_of_crystals - 1);
for (channel_6_analyzer_2_array_iterate=0;channel_6_analyzer_2_array_iterate<9;channel_6_analyzer_2_array_iterate++)
    channel_6_analyzer_2_array_theta[channel_6_analyzer_2_array_iterate] = channel_6_analyzer_2_array_delta_theta * (double) channel_6_analyzer_2_array_iterate - channel_6_analyzer_2_array_theta_max;
channel_7_analyzer_1_array_effective_radius_of_curvature = channel_7_analyzer_1_array_crystal_depth+channel_7_analyzer_1_array_radius_of_curvature;
channel_7_analyzer_1_array_theta_max = asin(channel_7_analyzer_1_array_total_height/sqrt((2*channel_7_analyzer_1_array_radius_of_curvature + 2*channel_7_analyzer_1_array_crystal_depth)*(2*channel_7_analyzer_1_array_radius_of_curvature + 2*channel_7_analyzer_1_array_crystal_depth) + channel_7_analyzer_1_array_crystal_height*channel_7_analyzer_1_array_crystal_height) - atan(channel_7_analyzer_1_array_crystal_height/(2*channel_7_analyzer_1_array_radius_of_curvature + 2*channel_7_analyzer_1_array_crystal_depth)));
channel_7_analyzer_1_array_delta_theta = (2*channel_7_analyzer_1_array_theta_max) / ((double) channel_7_analyzer_1_array_number_of_crystals - 1);
for (channel_7_analyzer_1_array_iterate=0;channel_7_analyzer_1_array_iterate<9;channel_7_analyzer_1_array_iterate++)
    channel_7_analyzer_1_array_theta[channel_7_analyzer_1_array_iterate] = channel_7_analyzer_1_array_delta_theta * (double) channel_7_analyzer_1_array_iterate - channel_7_analyzer_1_array_theta_max;
channel_7_analyzer_2_array_effective_radius_of_curvature = channel_7_analyzer_2_array_crystal_depth+channel_7_analyzer_2_array_radius_of_curvature;
channel_7_analyzer_2_array_theta_max = asin(channel_7_analyzer_2_array_total_height/sqrt((2*channel_7_analyzer_2_array_radius_of_curvature + 2*channel_7_analyzer_2_array_crystal_depth)*(2*channel_7_analyzer_2_array_radius_of_curvature + 2*channel_7_analyzer_2_array_crystal_depth) + channel_7_analyzer_2_array_crystal_height*channel_7_analyzer_2_array_crystal_height) - atan(channel_7_analyzer_2_array_crystal_height/(2*channel_7_analyzer_2_array_radius_of_curvature + 2*channel_7_analyzer_2_array_crystal_depth)));
channel_7_analyzer_2_array_delta_theta = (2*channel_7_analyzer_2_array_theta_max) / ((double) channel_7_analyzer_2_array_number_of_crystals - 1);
for (channel_7_analyzer_2_array_iterate=0;channel_7_analyzer_2_array_iterate<9;channel_7_analyzer_2_array_iterate++)
    channel_7_analyzer_2_array_theta[channel_7_analyzer_2_array_iterate] = channel_7_analyzer_2_array_delta_theta * (double) channel_7_analyzer_2_array_iterate - channel_7_analyzer_2_array_theta_max;
channel_8_analyzer_1_array_effective_radius_of_curvature = channel_8_analyzer_1_array_crystal_depth+channel_8_analyzer_1_array_radius_of_curvature;
channel_8_analyzer_1_array_theta_max = asin(channel_8_analyzer_1_array_total_height/sqrt((2*channel_8_analyzer_1_array_radius_of_curvature + 2*channel_8_analyzer_1_array_crystal_depth)*(2*channel_8_analyzer_1_array_radius_of_curvature + 2*channel_8_analyzer_1_array_crystal_depth) + channel_8_analyzer_1_array_crystal_height*channel_8_analyzer_1_array_crystal_height) - atan(channel_8_analyzer_1_array_crystal_height/(2*channel_8_analyzer_1_array_radius_of_curvature + 2*channel_8_analyzer_1_array_crystal_depth)));
channel_8_analyzer_1_array_delta_theta = (2*channel_8_analyzer_1_array_theta_max) / ((double) channel_8_analyzer_1_array_number_of_crystals - 1);
for (channel_8_analyzer_1_array_iterate=0;channel_8_analyzer_1_array_iterate<9;channel_8_analyzer_1_array_iterate++)
    channel_8_analyzer_1_array_theta[channel_8_analyzer_1_array_iterate] = channel_8_analyzer_1_array_delta_theta * (double) channel_8_analyzer_1_array_iterate - channel_8_analyzer_1_array_theta_max;
channel_8_analyzer_2_array_effective_radius_of_curvature = channel_8_analyzer_2_array_crystal_depth+channel_8_analyzer_2_array_radius_of_curvature;
channel_8_analyzer_2_array_theta_max = asin(channel_8_analyzer_2_array_total_height/sqrt((2*channel_8_analyzer_2_array_radius_of_curvature + 2*channel_8_analyzer_2_array_crystal_depth)*(2*channel_8_analyzer_2_array_radius_of_curvature + 2*channel_8_analyzer_2_array_crystal_depth) + channel_8_analyzer_2_array_crystal_height*channel_8_analyzer_2_array_crystal_height) - atan(channel_8_analyzer_2_array_crystal_height/(2*channel_8_analyzer_2_array_radius_of_curvature + 2*channel_8_analyzer_2_array_crystal_depth)));
channel_8_analyzer_2_array_delta_theta = (2*channel_8_analyzer_2_array_theta_max) / ((double) channel_8_analyzer_2_array_number_of_crystals - 1);
for (channel_8_analyzer_2_array_iterate=0;channel_8_analyzer_2_array_iterate<9;channel_8_analyzer_2_array_iterate++)
    channel_8_analyzer_2_array_theta[channel_8_analyzer_2_array_iterate] = channel_8_analyzer_2_array_delta_theta * (double) channel_8_analyzer_2_array_iterate - channel_8_analyzer_2_array_theta_max;
channel_9_analyzer_1_array_effective_radius_of_curvature = channel_9_analyzer_1_array_crystal_depth+channel_9_analyzer_1_array_radius_of_curvature;
channel_9_analyzer_1_array_theta_max = asin(channel_9_analyzer_1_array_total_height/sqrt((2*channel_9_analyzer_1_array_radius_of_curvature + 2*channel_9_analyzer_1_array_crystal_depth)*(2*channel_9_analyzer_1_array_radius_of_curvature + 2*channel_9_analyzer_1_array_crystal_depth) + channel_9_analyzer_1_array_crystal_height*channel_9_analyzer_1_array_crystal_height) - atan(channel_9_analyzer_1_array_crystal_height/(2*channel_9_analyzer_1_array_radius_of_curvature + 2*channel_9_analyzer_1_array_crystal_depth)));
channel_9_analyzer_1_array_delta_theta = (2*channel_9_analyzer_1_array_theta_max) / ((double) channel_9_analyzer_1_array_number_of_crystals - 1);
for (channel_9_analyzer_1_array_iterate=0;channel_9_analyzer_1_array_iterate<9;channel_9_analyzer_1_array_iterate++)
    channel_9_analyzer_1_array_theta[channel_9_analyzer_1_array_iterate] = channel_9_analyzer_1_array_delta_theta * (double) channel_9_analyzer_1_array_iterate - channel_9_analyzer_1_array_theta_max;
channel_9_analyzer_2_array_effective_radius_of_curvature = channel_9_analyzer_2_array_crystal_depth+channel_9_analyzer_2_array_radius_of_curvature;
channel_9_analyzer_2_array_theta_max = asin(channel_9_analyzer_2_array_total_height/sqrt((2*channel_9_analyzer_2_array_radius_of_curvature + 2*channel_9_analyzer_2_array_crystal_depth)*(2*channel_9_analyzer_2_array_radius_of_curvature + 2*channel_9_analyzer_2_array_crystal_depth) + channel_9_analyzer_2_array_crystal_height*channel_9_analyzer_2_array_crystal_height) - atan(channel_9_analyzer_2_array_crystal_height/(2*channel_9_analyzer_2_array_radius_of_curvature + 2*channel_9_analyzer_2_array_crystal_depth)));
channel_9_analyzer_2_array_delta_theta = (2*channel_9_analyzer_2_array_theta_max) / ((double) channel_9_analyzer_2_array_number_of_crystals - 1);
for (channel_9_analyzer_2_array_iterate=0;channel_9_analyzer_2_array_iterate<9;channel_9_analyzer_2_array_iterate++)
    channel_9_analyzer_2_array_theta[channel_9_analyzer_2_array_iterate] = channel_9_analyzer_2_array_delta_theta * (double) channel_9_analyzer_2_array_iterate - channel_9_analyzer_2_array_theta_max;
channel_10_analyzer_1_array_effective_radius_of_curvature = channel_10_analyzer_1_array_crystal_depth+channel_10_analyzer_1_array_radius_of_curvature;
channel_10_analyzer_1_array_theta_max = asin(channel_10_analyzer_1_array_total_height/sqrt((2*channel_10_analyzer_1_array_radius_of_curvature + 2*channel_10_analyzer_1_array_crystal_depth)*(2*channel_10_analyzer_1_array_radius_of_curvature + 2*channel_10_analyzer_1_array_crystal_depth) + channel_10_analyzer_1_array_crystal_height*channel_10_analyzer_1_array_crystal_height) - atan(channel_10_analyzer_1_array_crystal_height/(2*channel_10_analyzer_1_array_radius_of_curvature + 2*channel_10_analyzer_1_array_crystal_depth)));
channel_10_analyzer_1_array_delta_theta = (2*channel_10_analyzer_1_array_theta_max) / ((double) channel_10_analyzer_1_array_number_of_crystals - 1);
for (channel_10_analyzer_1_array_iterate=0;channel_10_analyzer_1_array_iterate<9;channel_10_analyzer_1_array_iterate++)
    channel_10_analyzer_1_array_theta[channel_10_analyzer_1_array_iterate] = channel_10_analyzer_1_array_delta_theta * (double) channel_10_analyzer_1_array_iterate - channel_10_analyzer_1_array_theta_max;
channel_10_analyzer_2_array_effective_radius_of_curvature = channel_10_analyzer_2_array_crystal_depth+channel_10_analyzer_2_array_radius_of_curvature;
channel_10_analyzer_2_array_theta_max = asin(channel_10_analyzer_2_array_total_height/sqrt((2*channel_10_analyzer_2_array_radius_of_curvature + 2*channel_10_analyzer_2_array_crystal_depth)*(2*channel_10_analyzer_2_array_radius_of_curvature + 2*channel_10_analyzer_2_array_crystal_depth) + channel_10_analyzer_2_array_crystal_height*channel_10_analyzer_2_array_crystal_height) - atan(channel_10_analyzer_2_array_crystal_height/(2*channel_10_analyzer_2_array_radius_of_curvature + 2*channel_10_analyzer_2_array_crystal_depth)));
channel_10_analyzer_2_array_delta_theta = (2*channel_10_analyzer_2_array_theta_max) / ((double) channel_10_analyzer_2_array_number_of_crystals - 1);
for (channel_10_analyzer_2_array_iterate=0;channel_10_analyzer_2_array_iterate<9;channel_10_analyzer_2_array_iterate++)
    channel_10_analyzer_2_array_theta[channel_10_analyzer_2_array_iterate] = channel_10_analyzer_2_array_delta_theta * (double) channel_10_analyzer_2_array_iterate - channel_10_analyzer_2_array_theta_max;
channel_11_analyzer_1_array_effective_radius_of_curvature = channel_11_analyzer_1_array_crystal_depth+channel_11_analyzer_1_array_radius_of_curvature;
channel_11_analyzer_1_array_theta_max = asin(channel_11_analyzer_1_array_total_height/sqrt((2*channel_11_analyzer_1_array_radius_of_curvature + 2*channel_11_analyzer_1_array_crystal_depth)*(2*channel_11_analyzer_1_array_radius_of_curvature + 2*channel_11_analyzer_1_array_crystal_depth) + channel_11_analyzer_1_array_crystal_height*channel_11_analyzer_1_array_crystal_height) - atan(channel_11_analyzer_1_array_crystal_height/(2*channel_11_analyzer_1_array_radius_of_curvature + 2*channel_11_analyzer_1_array_crystal_depth)));
channel_11_analyzer_1_array_delta_theta = (2*channel_11_analyzer_1_array_theta_max) / ((double) channel_11_analyzer_1_array_number_of_crystals - 1);
for (channel_11_analyzer_1_array_iterate=0;channel_11_analyzer_1_array_iterate<9;channel_11_analyzer_1_array_iterate++)
    channel_11_analyzer_1_array_theta[channel_11_analyzer_1_array_iterate] = channel_11_analyzer_1_array_delta_theta * (double) channel_11_analyzer_1_array_iterate - channel_11_analyzer_1_array_theta_max;
channel_11_analyzer_2_array_effective_radius_of_curvature = channel_11_analyzer_2_array_crystal_depth+channel_11_analyzer_2_array_radius_of_curvature;
channel_11_analyzer_2_array_theta_max = asin(channel_11_analyzer_2_array_total_height/sqrt((2*channel_11_analyzer_2_array_radius_of_curvature + 2*channel_11_analyzer_2_array_crystal_depth)*(2*channel_11_analyzer_2_array_radius_of_curvature + 2*channel_11_analyzer_2_array_crystal_depth) + channel_11_analyzer_2_array_crystal_height*channel_11_analyzer_2_array_crystal_height) - atan(channel_11_analyzer_2_array_crystal_height/(2*channel_11_analyzer_2_array_radius_of_curvature + 2*channel_11_analyzer_2_array_crystal_depth)));
channel_11_analyzer_2_array_delta_theta = (2*channel_11_analyzer_2_array_theta_max) / ((double) channel_11_analyzer_2_array_number_of_crystals - 1);
for (channel_11_analyzer_2_array_iterate=0;channel_11_analyzer_2_array_iterate<9;channel_11_analyzer_2_array_iterate++)
    channel_11_analyzer_2_array_theta[channel_11_analyzer_2_array_iterate] = channel_11_analyzer_2_array_delta_theta * (double) channel_11_analyzer_2_array_iterate - channel_11_analyzer_2_array_theta_max;
channel_12_analyzer_1_array_effective_radius_of_curvature = channel_12_analyzer_1_array_crystal_depth+channel_12_analyzer_1_array_radius_of_curvature;
channel_12_analyzer_1_array_theta_max = asin(channel_12_analyzer_1_array_total_height/sqrt((2*channel_12_analyzer_1_array_radius_of_curvature + 2*channel_12_analyzer_1_array_crystal_depth)*(2*channel_12_analyzer_1_array_radius_of_curvature + 2*channel_12_analyzer_1_array_crystal_depth) + channel_12_analyzer_1_array_crystal_height*channel_12_analyzer_1_array_crystal_height) - atan(channel_12_analyzer_1_array_crystal_height/(2*channel_12_analyzer_1_array_radius_of_curvature + 2*channel_12_analyzer_1_array_crystal_depth)));
channel_12_analyzer_1_array_delta_theta = (2*channel_12_analyzer_1_array_theta_max) / ((double) channel_12_analyzer_1_array_number_of_crystals - 1);
for (channel_12_analyzer_1_array_iterate=0;channel_12_analyzer_1_array_iterate<9;channel_12_analyzer_1_array_iterate++)
    channel_12_analyzer_1_array_theta[channel_12_analyzer_1_array_iterate] = channel_12_analyzer_1_array_delta_theta * (double) channel_12_analyzer_1_array_iterate - channel_12_analyzer_1_array_theta_max;
channel_12_analyzer_2_array_effective_radius_of_curvature = channel_12_analyzer_2_array_crystal_depth+channel_12_analyzer_2_array_radius_of_curvature;
channel_12_analyzer_2_array_theta_max = asin(channel_12_analyzer_2_array_total_height/sqrt((2*channel_12_analyzer_2_array_radius_of_curvature + 2*channel_12_analyzer_2_array_crystal_depth)*(2*channel_12_analyzer_2_array_radius_of_curvature + 2*channel_12_analyzer_2_array_crystal_depth) + channel_12_analyzer_2_array_crystal_height*channel_12_analyzer_2_array_crystal_height) - atan(channel_12_analyzer_2_array_crystal_height/(2*channel_12_analyzer_2_array_radius_of_curvature + 2*channel_12_analyzer_2_array_crystal_depth)));
channel_12_analyzer_2_array_delta_theta = (2*channel_12_analyzer_2_array_theta_max) / ((double) channel_12_analyzer_2_array_number_of_crystals - 1);
for (channel_12_analyzer_2_array_iterate=0;channel_12_analyzer_2_array_iterate<9;channel_12_analyzer_2_array_iterate++)
    channel_12_analyzer_2_array_theta[channel_12_analyzer_2_array_iterate] = channel_12_analyzer_2_array_delta_theta * (double) channel_12_analyzer_2_array_iterate - channel_12_analyzer_2_array_theta_max;
channel_13_analyzer_1_array_effective_radius_of_curvature = channel_13_analyzer_1_array_crystal_depth+channel_13_analyzer_1_array_radius_of_curvature;
channel_13_analyzer_1_array_theta_max = asin(channel_13_analyzer_1_array_total_height/sqrt((2*channel_13_analyzer_1_array_radius_of_curvature + 2*channel_13_analyzer_1_array_crystal_depth)*(2*channel_13_analyzer_1_array_radius_of_curvature + 2*channel_13_analyzer_1_array_crystal_depth) + channel_13_analyzer_1_array_crystal_height*channel_13_analyzer_1_array_crystal_height) - atan(channel_13_analyzer_1_array_crystal_height/(2*channel_13_analyzer_1_array_radius_of_curvature + 2*channel_13_analyzer_1_array_crystal_depth)));
channel_13_analyzer_1_array_delta_theta = (2*channel_13_analyzer_1_array_theta_max) / ((double) channel_13_analyzer_1_array_number_of_crystals - 1);
for (channel_13_analyzer_1_array_iterate=0;channel_13_analyzer_1_array_iterate<9;channel_13_analyzer_1_array_iterate++)
    channel_13_analyzer_1_array_theta[channel_13_analyzer_1_array_iterate] = channel_13_analyzer_1_array_delta_theta * (double) channel_13_analyzer_1_array_iterate - channel_13_analyzer_1_array_theta_max;
channel_13_analyzer_2_array_effective_radius_of_curvature = channel_13_analyzer_2_array_crystal_depth+channel_13_analyzer_2_array_radius_of_curvature;
channel_13_analyzer_2_array_theta_max = asin(channel_13_analyzer_2_array_total_height/sqrt((2*channel_13_analyzer_2_array_radius_of_curvature + 2*channel_13_analyzer_2_array_crystal_depth)*(2*channel_13_analyzer_2_array_radius_of_curvature + 2*channel_13_analyzer_2_array_crystal_depth) + channel_13_analyzer_2_array_crystal_height*channel_13_analyzer_2_array_crystal_height) - atan(channel_13_analyzer_2_array_crystal_height/(2*channel_13_analyzer_2_array_radius_of_curvature + 2*channel_13_analyzer_2_array_crystal_depth)));
channel_13_analyzer_2_array_delta_theta = (2*channel_13_analyzer_2_array_theta_max) / ((double) channel_13_analyzer_2_array_number_of_crystals - 1);
for (channel_13_analyzer_2_array_iterate=0;channel_13_analyzer_2_array_iterate<9;channel_13_analyzer_2_array_iterate++)
    channel_13_analyzer_2_array_theta[channel_13_analyzer_2_array_iterate] = channel_13_analyzer_2_array_delta_theta * (double) channel_13_analyzer_2_array_iterate - channel_13_analyzer_2_array_theta_max;
channel_14_analyzer_1_array_effective_radius_of_curvature = channel_14_analyzer_1_array_crystal_depth+channel_14_analyzer_1_array_radius_of_curvature;
channel_14_analyzer_1_array_theta_max = asin(channel_14_analyzer_1_array_total_height/sqrt((2*channel_14_analyzer_1_array_radius_of_curvature + 2*channel_14_analyzer_1_array_crystal_depth)*(2*channel_14_analyzer_1_array_radius_of_curvature + 2*channel_14_analyzer_1_array_crystal_depth) + channel_14_analyzer_1_array_crystal_height*channel_14_analyzer_1_array_crystal_height) - atan(channel_14_analyzer_1_array_crystal_height/(2*channel_14_analyzer_1_array_radius_of_curvature + 2*channel_14_analyzer_1_array_crystal_depth)));
channel_14_analyzer_1_array_delta_theta = (2*channel_14_analyzer_1_array_theta_max) / ((double) channel_14_analyzer_1_array_number_of_crystals - 1);
for (channel_14_analyzer_1_array_iterate=0;channel_14_analyzer_1_array_iterate<9;channel_14_analyzer_1_array_iterate++)
    channel_14_analyzer_1_array_theta[channel_14_analyzer_1_array_iterate] = channel_14_analyzer_1_array_delta_theta * (double) channel_14_analyzer_1_array_iterate - channel_14_analyzer_1_array_theta_max;
channel_14_analyzer_2_array_effective_radius_of_curvature = channel_14_analyzer_2_array_crystal_depth+channel_14_analyzer_2_array_radius_of_curvature;
channel_14_analyzer_2_array_theta_max = asin(channel_14_analyzer_2_array_total_height/sqrt((2*channel_14_analyzer_2_array_radius_of_curvature + 2*channel_14_analyzer_2_array_crystal_depth)*(2*channel_14_analyzer_2_array_radius_of_curvature + 2*channel_14_analyzer_2_array_crystal_depth) + channel_14_analyzer_2_array_crystal_height*channel_14_analyzer_2_array_crystal_height) - atan(channel_14_analyzer_2_array_crystal_height/(2*channel_14_analyzer_2_array_radius_of_curvature + 2*channel_14_analyzer_2_array_crystal_depth)));
channel_14_analyzer_2_array_delta_theta = (2*channel_14_analyzer_2_array_theta_max) / ((double) channel_14_analyzer_2_array_number_of_crystals - 1);
for (channel_14_analyzer_2_array_iterate=0;channel_14_analyzer_2_array_iterate<9;channel_14_analyzer_2_array_iterate++)
    channel_14_analyzer_2_array_theta[channel_14_analyzer_2_array_iterate] = channel_14_analyzer_2_array_delta_theta * (double) channel_14_analyzer_2_array_iterate - channel_14_analyzer_2_array_theta_max;
channel_15_analyzer_1_array_effective_radius_of_curvature = channel_15_analyzer_1_array_crystal_depth+channel_15_analyzer_1_array_radius_of_curvature;
channel_15_analyzer_1_array_theta_max = asin(channel_15_analyzer_1_array_total_height/sqrt((2*channel_15_analyzer_1_array_radius_of_curvature + 2*channel_15_analyzer_1_array_crystal_depth)*(2*channel_15_analyzer_1_array_radius_of_curvature + 2*channel_15_analyzer_1_array_crystal_depth) + channel_15_analyzer_1_array_crystal_height*channel_15_analyzer_1_array_crystal_height) - atan(channel_15_analyzer_1_array_crystal_height/(2*channel_15_analyzer_1_array_radius_of_curvature + 2*channel_15_analyzer_1_array_crystal_depth)));
channel_15_analyzer_1_array_delta_theta = (2*channel_15_analyzer_1_array_theta_max) / ((double) channel_15_analyzer_1_array_number_of_crystals - 1);
for (channel_15_analyzer_1_array_iterate=0;channel_15_analyzer_1_array_iterate<9;channel_15_analyzer_1_array_iterate++)
    channel_15_analyzer_1_array_theta[channel_15_analyzer_1_array_iterate] = channel_15_analyzer_1_array_delta_theta * (double) channel_15_analyzer_1_array_iterate - channel_15_analyzer_1_array_theta_max;
channel_15_analyzer_2_array_effective_radius_of_curvature = channel_15_analyzer_2_array_crystal_depth+channel_15_analyzer_2_array_radius_of_curvature;
channel_15_analyzer_2_array_theta_max = asin(channel_15_analyzer_2_array_total_height/sqrt((2*channel_15_analyzer_2_array_radius_of_curvature + 2*channel_15_analyzer_2_array_crystal_depth)*(2*channel_15_analyzer_2_array_radius_of_curvature + 2*channel_15_analyzer_2_array_crystal_depth) + channel_15_analyzer_2_array_crystal_height*channel_15_analyzer_2_array_crystal_height) - atan(channel_15_analyzer_2_array_crystal_height/(2*channel_15_analyzer_2_array_radius_of_curvature + 2*channel_15_analyzer_2_array_crystal_depth)));
channel_15_analyzer_2_array_delta_theta = (2*channel_15_analyzer_2_array_theta_max) / ((double) channel_15_analyzer_2_array_number_of_crystals - 1);
for (channel_15_analyzer_2_array_iterate=0;channel_15_analyzer_2_array_iterate<9;channel_15_analyzer_2_array_iterate++)
    channel_15_analyzer_2_array_theta[channel_15_analyzer_2_array_iterate] = channel_15_analyzer_2_array_delta_theta * (double) channel_15_analyzer_2_array_iterate - channel_15_analyzer_2_array_theta_max;
channel_16_analyzer_1_array_effective_radius_of_curvature = channel_16_analyzer_1_array_crystal_depth+channel_16_analyzer_1_array_radius_of_curvature;
channel_16_analyzer_1_array_theta_max = asin(channel_16_analyzer_1_array_total_height/sqrt((2*channel_16_analyzer_1_array_radius_of_curvature + 2*channel_16_analyzer_1_array_crystal_depth)*(2*channel_16_analyzer_1_array_radius_of_curvature + 2*channel_16_analyzer_1_array_crystal_depth) + channel_16_analyzer_1_array_crystal_height*channel_16_analyzer_1_array_crystal_height) - atan(channel_16_analyzer_1_array_crystal_height/(2*channel_16_analyzer_1_array_radius_of_curvature + 2*channel_16_analyzer_1_array_crystal_depth)));
channel_16_analyzer_1_array_delta_theta = (2*channel_16_analyzer_1_array_theta_max) / ((double) channel_16_analyzer_1_array_number_of_crystals - 1);
for (channel_16_analyzer_1_array_iterate=0;channel_16_analyzer_1_array_iterate<9;channel_16_analyzer_1_array_iterate++)
    channel_16_analyzer_1_array_theta[channel_16_analyzer_1_array_iterate] = channel_16_analyzer_1_array_delta_theta * (double) channel_16_analyzer_1_array_iterate - channel_16_analyzer_1_array_theta_max;
channel_16_analyzer_2_array_effective_radius_of_curvature = channel_16_analyzer_2_array_crystal_depth+channel_16_analyzer_2_array_radius_of_curvature;
channel_16_analyzer_2_array_theta_max = asin(channel_16_analyzer_2_array_total_height/sqrt((2*channel_16_analyzer_2_array_radius_of_curvature + 2*channel_16_analyzer_2_array_crystal_depth)*(2*channel_16_analyzer_2_array_radius_of_curvature + 2*channel_16_analyzer_2_array_crystal_depth) + channel_16_analyzer_2_array_crystal_height*channel_16_analyzer_2_array_crystal_height) - atan(channel_16_analyzer_2_array_crystal_height/(2*channel_16_analyzer_2_array_radius_of_curvature + 2*channel_16_analyzer_2_array_crystal_depth)));
channel_16_analyzer_2_array_delta_theta = (2*channel_16_analyzer_2_array_theta_max) / ((double) channel_16_analyzer_2_array_number_of_crystals - 1);
for (channel_16_analyzer_2_array_iterate=0;channel_16_analyzer_2_array_iterate<9;channel_16_analyzer_2_array_iterate++)
    channel_16_analyzer_2_array_theta[channel_16_analyzer_2_array_iterate] = channel_16_analyzer_2_array_delta_theta * (double) channel_16_analyzer_2_array_iterate - channel_16_analyzer_2_array_theta_max;
channel_17_analyzer_1_array_effective_radius_of_curvature = channel_17_analyzer_1_array_crystal_depth+channel_17_analyzer_1_array_radius_of_curvature;
channel_17_analyzer_1_array_theta_max = asin(channel_17_analyzer_1_array_total_height/sqrt((2*channel_17_analyzer_1_array_radius_of_curvature + 2*channel_17_analyzer_1_array_crystal_depth)*(2*channel_17_analyzer_1_array_radius_of_curvature + 2*channel_17_analyzer_1_array_crystal_depth) + channel_17_analyzer_1_array_crystal_height*channel_17_analyzer_1_array_crystal_height) - atan(channel_17_analyzer_1_array_crystal_height/(2*channel_17_analyzer_1_array_radius_of_curvature + 2*channel_17_analyzer_1_array_crystal_depth)));
channel_17_analyzer_1_array_delta_theta = (2*channel_17_analyzer_1_array_theta_max) / ((double) channel_17_analyzer_1_array_number_of_crystals - 1);
for (channel_17_analyzer_1_array_iterate=0;channel_17_analyzer_1_array_iterate<9;channel_17_analyzer_1_array_iterate++)
    channel_17_analyzer_1_array_theta[channel_17_analyzer_1_array_iterate] = channel_17_analyzer_1_array_delta_theta * (double) channel_17_analyzer_1_array_iterate - channel_17_analyzer_1_array_theta_max;
channel_17_analyzer_2_array_effective_radius_of_curvature = channel_17_analyzer_2_array_crystal_depth+channel_17_analyzer_2_array_radius_of_curvature;
channel_17_analyzer_2_array_theta_max = asin(channel_17_analyzer_2_array_total_height/sqrt((2*channel_17_analyzer_2_array_radius_of_curvature + 2*channel_17_analyzer_2_array_crystal_depth)*(2*channel_17_analyzer_2_array_radius_of_curvature + 2*channel_17_analyzer_2_array_crystal_depth) + channel_17_analyzer_2_array_crystal_height*channel_17_analyzer_2_array_crystal_height) - atan(channel_17_analyzer_2_array_crystal_height/(2*channel_17_analyzer_2_array_radius_of_curvature + 2*channel_17_analyzer_2_array_crystal_depth)));
channel_17_analyzer_2_array_delta_theta = (2*channel_17_analyzer_2_array_theta_max) / ((double) channel_17_analyzer_2_array_number_of_crystals - 1);
for (channel_17_analyzer_2_array_iterate=0;channel_17_analyzer_2_array_iterate<9;channel_17_analyzer_2_array_iterate++)
    channel_17_analyzer_2_array_theta[channel_17_analyzer_2_array_iterate] = channel_17_analyzer_2_array_delta_theta * (double) channel_17_analyzer_2_array_iterate - channel_17_analyzer_2_array_theta_max;
channel_18_analyzer_1_array_effective_radius_of_curvature = channel_18_analyzer_1_array_crystal_depth+channel_18_analyzer_1_array_radius_of_curvature;
channel_18_analyzer_1_array_theta_max = asin(channel_18_analyzer_1_array_total_height/sqrt((2*channel_18_analyzer_1_array_radius_of_curvature + 2*channel_18_analyzer_1_array_crystal_depth)*(2*channel_18_analyzer_1_array_radius_of_curvature + 2*channel_18_analyzer_1_array_crystal_depth) + channel_18_analyzer_1_array_crystal_height*channel_18_analyzer_1_array_crystal_height) - atan(channel_18_analyzer_1_array_crystal_height/(2*channel_18_analyzer_1_array_radius_of_curvature + 2*channel_18_analyzer_1_array_crystal_depth)));
channel_18_analyzer_1_array_delta_theta = (2*channel_18_analyzer_1_array_theta_max) / ((double) channel_18_analyzer_1_array_number_of_crystals - 1);
for (channel_18_analyzer_1_array_iterate=0;channel_18_analyzer_1_array_iterate<9;channel_18_analyzer_1_array_iterate++)
    channel_18_analyzer_1_array_theta[channel_18_analyzer_1_array_iterate] = channel_18_analyzer_1_array_delta_theta * (double) channel_18_analyzer_1_array_iterate - channel_18_analyzer_1_array_theta_max;
channel_18_analyzer_2_array_effective_radius_of_curvature = channel_18_analyzer_2_array_crystal_depth+channel_18_analyzer_2_array_radius_of_curvature;
channel_18_analyzer_2_array_theta_max = asin(channel_18_analyzer_2_array_total_height/sqrt((2*channel_18_analyzer_2_array_radius_of_curvature + 2*channel_18_analyzer_2_array_crystal_depth)*(2*channel_18_analyzer_2_array_radius_of_curvature + 2*channel_18_analyzer_2_array_crystal_depth) + channel_18_analyzer_2_array_crystal_height*channel_18_analyzer_2_array_crystal_height) - atan(channel_18_analyzer_2_array_crystal_height/(2*channel_18_analyzer_2_array_radius_of_curvature + 2*channel_18_analyzer_2_array_crystal_depth)));
channel_18_analyzer_2_array_delta_theta = (2*channel_18_analyzer_2_array_theta_max) / ((double) channel_18_analyzer_2_array_number_of_crystals - 1);
for (channel_18_analyzer_2_array_iterate=0;channel_18_analyzer_2_array_iterate<9;channel_18_analyzer_2_array_iterate++)
    channel_18_analyzer_2_array_theta[channel_18_analyzer_2_array_iterate] = channel_18_analyzer_2_array_delta_theta * (double) channel_18_analyzer_2_array_iterate - channel_18_analyzer_2_array_theta_max;
channel_19_analyzer_1_array_effective_radius_of_curvature = channel_19_analyzer_1_array_crystal_depth+channel_19_analyzer_1_array_radius_of_curvature;
channel_19_analyzer_1_array_theta_max = asin(channel_19_analyzer_1_array_total_height/sqrt((2*channel_19_analyzer_1_array_radius_of_curvature + 2*channel_19_analyzer_1_array_crystal_depth)*(2*channel_19_analyzer_1_array_radius_of_curvature + 2*channel_19_analyzer_1_array_crystal_depth) + channel_19_analyzer_1_array_crystal_height*channel_19_analyzer_1_array_crystal_height) - atan(channel_19_analyzer_1_array_crystal_height/(2*channel_19_analyzer_1_array_radius_of_curvature + 2*channel_19_analyzer_1_array_crystal_depth)));
channel_19_analyzer_1_array_delta_theta = (2*channel_19_analyzer_1_array_theta_max) / ((double) channel_19_analyzer_1_array_number_of_crystals - 1);
for (channel_19_analyzer_1_array_iterate=0;channel_19_analyzer_1_array_iterate<9;channel_19_analyzer_1_array_iterate++)
    channel_19_analyzer_1_array_theta[channel_19_analyzer_1_array_iterate] = channel_19_analyzer_1_array_delta_theta * (double) channel_19_analyzer_1_array_iterate - channel_19_analyzer_1_array_theta_max;
channel_19_analyzer_2_array_effective_radius_of_curvature = channel_19_analyzer_2_array_crystal_depth+channel_19_analyzer_2_array_radius_of_curvature;
channel_19_analyzer_2_array_theta_max = asin(channel_19_analyzer_2_array_total_height/sqrt((2*channel_19_analyzer_2_array_radius_of_curvature + 2*channel_19_analyzer_2_array_crystal_depth)*(2*channel_19_analyzer_2_array_radius_of_curvature + 2*channel_19_analyzer_2_array_crystal_depth) + channel_19_analyzer_2_array_crystal_height*channel_19_analyzer_2_array_crystal_height) - atan(channel_19_analyzer_2_array_crystal_height/(2*channel_19_analyzer_2_array_radius_of_curvature + 2*channel_19_analyzer_2_array_crystal_depth)));
channel_19_analyzer_2_array_delta_theta = (2*channel_19_analyzer_2_array_theta_max) / ((double) channel_19_analyzer_2_array_number_of_crystals - 1);
for (channel_19_analyzer_2_array_iterate=0;channel_19_analyzer_2_array_iterate<9;channel_19_analyzer_2_array_iterate++)
    channel_19_analyzer_2_array_theta[channel_19_analyzer_2_array_iterate] = channel_19_analyzer_2_array_delta_theta * (double) channel_19_analyzer_2_array_iterate - channel_19_analyzer_2_array_theta_max;

  
  
/**** Virtual output/input ****/
sprintf(virtual_file_name,"E%.2fmeV_HF%d_VF%d_Sample%.3f_b1_%.2f_b2_%.2f_mono_mis%.2f_CPF%.2f_MPL%.2f_MPD%.2f_dL0_%.3f_dL1_%.3f_APE_h%.3f_APE_v%.3f.dat", EM, HF, VF,sample_diameter_d, beta_1, beta_2, misalign_mono_deg, CPF, MPL, MPD, L0_delta, L1_delta, APE_h, APE_v);

/* Analyzator calculations */

/*
sample_analyzator_channel_distance = 0.45;
detector_analyzator_center_distance = 0.1;

analyzator_1_radius = sample_analyzator_distance;
analyzator_2_radius = sample_analyzator_distance;
analyzator_depth = 0.04;
analyzator_r0 = dmtas_mon_r0;
number_of_analyzator_blades=9;

analyzator_horizontal_mosaic = dmtas_mon_mos;
analyzator_vertical_mosaic = dmtas_mon_mos;
analyzator_dirdev = dmtas_mon_dirdev;
analyzator_q = dmtas_mon_q;
analyzator_transverse_distance=0.07;
*/

/*
for (iterate=0;iterate<20;iterate++) {
EF[iterate] = EF_all;
//analyzator_theta[iterate] = RAD2DEG*asin(analyzator_q*sqrt(HBAR*HBAR/(8*EF[iterate]*1.602E-22*MNEUTRON)));
analyzator_theta[iterate] = asin(analyzator_q/2.0/sqrt(EF[iterate]/2.0717));
    
 if (analyzator_theta[iterate] > 45) {
 delta_analyzator_position[iterate] = 0.5*analyzator_transverse_distance/tan(2*analyzator_theta[iterate]);
 } else {
 delta_analyzator_position[iterate] = -0.5*analyzator_transverse_distance/tan((180-2*analyzator_theta[iterate]));
 }
 distance_between_analyzators[iterate] = 2*sqrt(0.25*analyzator_transverse_distance*analyzator_transverse_distance+delta_analyzator_position[iterate]*delta_analyzator_position[iterate]);
 
analyzator_theta[iterate] = RAD2DEG*analyzator_theta[iterate];
printf("analyzator_theta[%d] = %f\n",iterate,analyzator_theta[iterate]);
printf("delta_analyzator_position[%d] = %f\n",iterate,delta_analyzator_position[iterate]);
}
*/

stick_displacement = 0;

// Resolution mode

if (resolution_mode == 1) {
  number_of_activations_sample = 0;
  number_of_activations_normal = 2;
  number_of_activations_exit = 1;
} else {
  number_of_activations_sample = 1;
  number_of_activations_normal = 1;
  number_of_activations_exit = 0;
}

if (E0_resolution == 0)
  E0_resolution = EF_all;


}
#line 89962 "MACS_sample_kidney_box.c"
#undef dE_resolution
#undef E0_resolution
#undef repeat_count
#undef res_height
#undef res_radius
#undef resolution_mode
#undef slit_v
#undef slit_h
#undef monrot_delta
#undef mon_e
#undef mon_t
#undef L1_delta
#undef L0_delta
#undef DIVSOU
#undef DIRDEV
#undef misalign_mono_deg
#undef APE_v
#undef APE_h
#undef MPD
#undef MPL
#undef CPF
#undef beta_2
#undef beta_1
#undef sample_diameter_d
#undef VF
#undef HF
#undef EF_all
#undef EM
#undef kidney_angle
#undef A3_angle
#undef mcposadmtas
#undef mccompcurindex
#undef mccompcurtype
#undef mccompcurname
  /* Computation of coordinate transformations. */
  {
    Coords mctc1, mctc2, mcLastComp;
    Rotation mctr1;
    double mcAccumulatedILength = 0;
    /* Initialize "last" component origin as (0,0,0) */
    mcLastComp = coords_set(0,0,0);

    mcDEBUG_INSTR()
  /* Component initializations. */
    /* Component Al_incoherent. */
  /* Setting parameters for component Al_incoherent. */
  SIG_MESSAGE("Al_incoherent (Init:SetPar)");
#line 381 "MACS_sample_kidney_box.instr"
  mccAl_incoherent_sigma = 4.0 * 0.0082;
#line 55 "MACS_sample_kidney_box.instr"
  mccAl_incoherent_f_QE = 0;
#line 55 "MACS_sample_kidney_box.instr"
  mccAl_incoherent_gamma = 0;
#line 381 "MACS_sample_kidney_box.instr"
  mccAl_incoherent_packing_factor = 1;
#line 381 "MACS_sample_kidney_box.instr"
  mccAl_incoherent_unit_cell_volume = 66.4;
#line 55 "MACS_sample_kidney_box.instr"
  mccAl_incoherent_interact_fraction = -1;
#line 90022 "MACS_sample_kidney_box.c"

  SIG_MESSAGE("Al_incoherent (Init:Place/Rotate)");
  rot_set_rotation(mcrotaAl_incoherent,
    (0.0)*DEG2RAD,
    (0.0)*DEG2RAD,
    (0.0)*DEG2RAD);
#line 90029 "MACS_sample_kidney_box.c"
  rot_copy(mcrotrAl_incoherent, mcrotaAl_incoherent);
  mcposaAl_incoherent = coords_set(
#line 382 "MACS_sample_kidney_box.instr"
    0,
#line 382 "MACS_sample_kidney_box.instr"
    0,
#line 382 "MACS_sample_kidney_box.instr"
    0);
#line 90038 "MACS_sample_kidney_box.c"
  mctc1 = coords_neg(mcposaAl_incoherent);
  mcposrAl_incoherent = rot_apply(mcrotaAl_incoherent, mctc1);
  mcDEBUG_COMPONENT("Al_incoherent", mcposaAl_incoherent, mcrotaAl_incoherent)
  mccomp_posa[1] = mcposaAl_incoherent;
  mccomp_posr[1] = mcposrAl_incoherent;
  mcNCounter[1]  = mcPCounter[1] = mcP2Counter[1] = 0;
  mcAbsorbProp[1]= 0;
    /* Component Al_powder. */
  /* Setting parameters for component Al_powder. */
  SIG_MESSAGE("Al_powder (Init:SetPar)");
#line 384 "MACS_sample_kidney_box.instr"
  if("Al.laz") strncpy(mccAl_powder_reflections, "Al.laz" ? "Al.laz" : "", 16384); else mccAl_powder_reflections[0]='\0';
#line 384 "MACS_sample_kidney_box.instr"
  mccAl_powder_packing_factor = 1;
#line 50 "MACS_sample_kidney_box.instr"
  mccAl_powder_Vc = 0;
#line 50 "MACS_sample_kidney_box.instr"
  mccAl_powder_delta_d_d = 0;
#line 50 "MACS_sample_kidney_box.instr"
  mccAl_powder_DW = 0;
#line 50 "MACS_sample_kidney_box.instr"
  mccAl_powder_nb_atoms = 1;
#line 50 "MACS_sample_kidney_box.instr"
  mccAl_powder_d_phi = 0;
#line 50 "MACS_sample_kidney_box.instr"
  mccAl_powder_density = 0;
#line 50 "MACS_sample_kidney_box.instr"
  mccAl_powder_weight = 0;
#line 50 "MACS_sample_kidney_box.instr"
  mccAl_powder_barns = 1;
#line 50 "MACS_sample_kidney_box.instr"
  mccAl_powder_Strain = 0;
#line 50 "MACS_sample_kidney_box.instr"
  mccAl_powder_interact_fraction = -1;
#line 90073 "MACS_sample_kidney_box.c"

  SIG_MESSAGE("Al_powder (Init:Place/Rotate)");
  rot_set_rotation(mcrotaAl_powder,
    (0.0)*DEG2RAD,
    (0.0)*DEG2RAD,
    (0.0)*DEG2RAD);
#line 90080 "MACS_sample_kidney_box.c"
  rot_transpose(mcrotaAl_incoherent, mctr1);
  rot_mul(mcrotaAl_powder, mctr1, mcrotrAl_powder);
  mcposaAl_powder = coords_set(
#line 385 "MACS_sample_kidney_box.instr"
    0,
#line 385 "MACS_sample_kidney_box.instr"
    0,
#line 385 "MACS_sample_kidney_box.instr"
    0);
#line 90090 "MACS_sample_kidney_box.c"
  mctc1 = coords_sub(mcposaAl_incoherent, mcposaAl_powder);
  mcposrAl_powder = rot_apply(mcrotaAl_powder, mctc1);
  mcDEBUG_COMPONENT("Al_powder", mcposaAl_powder, mcrotaAl_powder)
  mccomp_posa[2] = mcposaAl_powder;
  mccomp_posr[2] = mcposrAl_powder;
  mcNCounter[2]  = mcPCounter[2] = mcP2Counter[2] = 0;
  mcAbsorbProp[2]= 0;
    /* Component Al. */
  /* Setting parameters for component Al. */
  SIG_MESSAGE("Al (Init:SetPar)");
#line 50 "MACS_sample_kidney_box.instr"
  if("NULL") strncpy(mccAl_process_string, "NULL" ? "NULL" : "", 16384); else mccAl_process_string[0]='\0';
#line 387 "MACS_sample_kidney_box.instr"
  mccAl_my_absorption = 100 * 4 * 0.231 / 66.4;
#line 50 "MACS_sample_kidney_box.instr"
  mccAl_absorber = 0;
#line 90107 "MACS_sample_kidney_box.c"

  SIG_MESSAGE("Al (Init:Place/Rotate)");
  rot_set_rotation(mcrotaAl,
    (0.0)*DEG2RAD,
    (0.0)*DEG2RAD,
    (0.0)*DEG2RAD);
#line 90114 "MACS_sample_kidney_box.c"
  rot_transpose(mcrotaAl_powder, mctr1);
  rot_mul(mcrotaAl, mctr1, mcrotrAl);
  mcposaAl = coords_set(
#line 388 "MACS_sample_kidney_box.instr"
    0,
#line 388 "MACS_sample_kidney_box.instr"
    0,
#line 388 "MACS_sample_kidney_box.instr"
    0);
#line 90124 "MACS_sample_kidney_box.c"
  mctc1 = coords_sub(mcposaAl_powder, mcposaAl);
  mcposrAl = rot_apply(mcrotaAl, mctc1);
  mcDEBUG_COMPONENT("Al", mcposaAl, mcrotaAl)
  mccomp_posa[3] = mcposaAl;
  mccomp_posr[3] = mcposrAl;
  mcNCounter[3]  = mcPCounter[3] = mcP2Counter[3] = 0;
  mcAbsorbProp[3]= 0;
    /* Component TiO2_incoherent. */
  /* Setting parameters for component TiO2_incoherent. */
  SIG_MESSAGE("TiO2_incoherent (Init:SetPar)");
#line 390 "MACS_sample_kidney_box.instr"
  mccTiO2_incoherent_sigma = 2.8716;
#line 55 "MACS_sample_kidney_box.instr"
  mccTiO2_incoherent_f_QE = 0;
#line 55 "MACS_sample_kidney_box.instr"
  mccTiO2_incoherent_gamma = 0;
#line 390 "MACS_sample_kidney_box.instr"
  mccTiO2_incoherent_packing_factor = 1;
#line 390 "MACS_sample_kidney_box.instr"
  mccTiO2_incoherent_unit_cell_volume = 62.74;
#line 390 "MACS_sample_kidney_box.instr"
  mccTiO2_incoherent_interact_fraction = 0.8;
#line 90147 "MACS_sample_kidney_box.c"

  SIG_MESSAGE("TiO2_incoherent (Init:Place/Rotate)");
  rot_set_rotation(mcrotaTiO2_incoherent,
#line 392 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 392 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 392 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD);
#line 90157 "MACS_sample_kidney_box.c"
  rot_transpose(mcrotaAl, mctr1);
  rot_mul(mcrotaTiO2_incoherent, mctr1, mcrotrTiO2_incoherent);
  mcposaTiO2_incoherent = coords_set(
#line 391 "MACS_sample_kidney_box.instr"
    0,
#line 391 "MACS_sample_kidney_box.instr"
    0,
#line 391 "MACS_sample_kidney_box.instr"
    0);
#line 90167 "MACS_sample_kidney_box.c"
  mctc1 = coords_sub(mcposaAl, mcposaTiO2_incoherent);
  mcposrTiO2_incoherent = rot_apply(mcrotaTiO2_incoherent, mctc1);
  mcDEBUG_COMPONENT("TiO2_incoherent", mcposaTiO2_incoherent, mcrotaTiO2_incoherent)
  mccomp_posa[4] = mcposaTiO2_incoherent;
  mccomp_posr[4] = mcposrTiO2_incoherent;
  mcNCounter[4]  = mcPCounter[4] = mcP2Counter[4] = 0;
  mcAbsorbProp[4]= 0;
    /* Component TiO2_single_crystal. */
  /* Setting parameters for component TiO2_single_crystal. */
  SIG_MESSAGE("TiO2_single_crystal (Init:SetPar)");
#line 409 "MACS_sample_kidney_box.instr"
  if("TiO2.lau") strncpy(mccTiO2_single_crystal_reflections, "TiO2.lau" ? "TiO2.lau" : "", 16384); else mccTiO2_single_crystal_reflections[0]='\0';
#line 405 "MACS_sample_kidney_box.instr"
  mccTiO2_single_crystal_delta_d_d = 0.0005;
#line 405 "MACS_sample_kidney_box.instr"
  mccTiO2_single_crystal_mosaic = 30.0;
#line 53 "MACS_sample_kidney_box.instr"
  mccTiO2_single_crystal_mosaic_a = -1;
#line 53 "MACS_sample_kidney_box.instr"
  mccTiO2_single_crystal_mosaic_b = -1;
#line 53 "MACS_sample_kidney_box.instr"
  mccTiO2_single_crystal_mosaic_c = -1;
#line 54 "MACS_sample_kidney_box.instr"
  mccTiO2_single_crystal_recip_cell = 0;
#line 409 "MACS_sample_kidney_box.instr"
  mccTiO2_single_crystal_barns = 1;
#line 406 "MACS_sample_kidney_box.instr"
  mccTiO2_single_crystal_ax = 3.25276;
#line 406 "MACS_sample_kidney_box.instr"
  mccTiO2_single_crystal_ay = -3.25276;
#line 406 "MACS_sample_kidney_box.instr"
  mccTiO2_single_crystal_az = -0.0;
#line 407 "MACS_sample_kidney_box.instr"
  mccTiO2_single_crystal_bx = 3.25276;
#line 407 "MACS_sample_kidney_box.instr"
  mccTiO2_single_crystal_by = 3.25276;
#line 407 "MACS_sample_kidney_box.instr"
  mccTiO2_single_crystal_bz = -0.0;
#line 408 "MACS_sample_kidney_box.instr"
  mccTiO2_single_crystal_cx = 0.0;
#line 408 "MACS_sample_kidney_box.instr"
  mccTiO2_single_crystal_cy = 0.0;
#line 408 "MACS_sample_kidney_box.instr"
  mccTiO2_single_crystal_cz = 2.9288;
#line 59 "MACS_sample_kidney_box.instr"
  mccTiO2_single_crystal_aa = 0;
#line 59 "MACS_sample_kidney_box.instr"
  mccTiO2_single_crystal_bb = 0;
#line 59 "MACS_sample_kidney_box.instr"
  mccTiO2_single_crystal_cc = 0;
#line 59 "MACS_sample_kidney_box.instr"
  mccTiO2_single_crystal_order = 0;
#line 59 "MACS_sample_kidney_box.instr"
  mccTiO2_single_crystal_RX = 0;
#line 59 "MACS_sample_kidney_box.instr"
  mccTiO2_single_crystal_RY = 0;
#line 59 "MACS_sample_kidney_box.instr"
  mccTiO2_single_crystal_RZ = 0;
#line 410 "MACS_sample_kidney_box.instr"
  mccTiO2_single_crystal_powder = 0;
#line 410 "MACS_sample_kidney_box.instr"
  mccTiO2_single_crystal_PG = 0;
#line 410 "MACS_sample_kidney_box.instr"
  mccTiO2_single_crystal_interact_fraction = 0.8;
#line 410 "MACS_sample_kidney_box.instr"
  mccTiO2_single_crystal_packing_factor = 1;
#line 90234 "MACS_sample_kidney_box.c"

  SIG_MESSAGE("TiO2_single_crystal (Init:Place/Rotate)");
  rot_set_rotation(mcrotaTiO2_single_crystal,
#line 412 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 412 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 412 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD);
#line 90244 "MACS_sample_kidney_box.c"
  rot_transpose(mcrotaTiO2_incoherent, mctr1);
  rot_mul(mcrotaTiO2_single_crystal, mctr1, mcrotrTiO2_single_crystal);
  mcposaTiO2_single_crystal = coords_set(
#line 411 "MACS_sample_kidney_box.instr"
    0,
#line 411 "MACS_sample_kidney_box.instr"
    0,
#line 411 "MACS_sample_kidney_box.instr"
    0);
#line 90254 "MACS_sample_kidney_box.c"
  mctc1 = coords_sub(mcposaTiO2_incoherent, mcposaTiO2_single_crystal);
  mcposrTiO2_single_crystal = rot_apply(mcrotaTiO2_single_crystal, mctc1);
  mcDEBUG_COMPONENT("TiO2_single_crystal", mcposaTiO2_single_crystal, mcrotaTiO2_single_crystal)
  mccomp_posa[5] = mcposaTiO2_single_crystal;
  mccomp_posr[5] = mcposrTiO2_single_crystal;
  mcNCounter[5]  = mcPCounter[5] = mcP2Counter[5] = 0;
  mcAbsorbProp[5]= 0;
    /* Component TiO2. */
  /* Setting parameters for component TiO2. */
  SIG_MESSAGE("TiO2 (Init:SetPar)");
#line 415 "MACS_sample_kidney_box.instr"
  if("TiO2_incoherent,TiO2_single_crystal") strncpy(mccTiO2_process_string, "TiO2_incoherent,TiO2_single_crystal" ? "TiO2_incoherent,TiO2_single_crystal" : "", 16384); else mccTiO2_process_string[0]='\0';
#line 414 "MACS_sample_kidney_box.instr"
  mccTiO2_my_absorption = 12.18076;
#line 50 "MACS_sample_kidney_box.instr"
  mccTiO2_absorber = 0;
#line 90271 "MACS_sample_kidney_box.c"

  SIG_MESSAGE("TiO2 (Init:Place/Rotate)");
  rot_set_rotation(mcrotaTiO2,
#line 417 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 417 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 417 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD);
#line 90281 "MACS_sample_kidney_box.c"
  rot_transpose(mcrotaTiO2_single_crystal, mctr1);
  rot_mul(mcrotaTiO2, mctr1, mcrotrTiO2);
  mcposaTiO2 = coords_set(
#line 416 "MACS_sample_kidney_box.instr"
    0,
#line 416 "MACS_sample_kidney_box.instr"
    0,
#line 416 "MACS_sample_kidney_box.instr"
    0);
#line 90291 "MACS_sample_kidney_box.c"
  mctc1 = coords_sub(mcposaTiO2_single_crystal, mcposaTiO2);
  mcposrTiO2 = rot_apply(mcrotaTiO2, mctc1);
  mcDEBUG_COMPONENT("TiO2", mcposaTiO2, mcrotaTiO2)
  mccomp_posa[6] = mcposaTiO2;
  mccomp_posr[6] = mcposrTiO2;
  mcNCounter[6]  = mcPCounter[6] = mcP2Counter[6] = 0;
  mcAbsorbProp[6]= 0;
    /* Component TiO2_poly_incoherent. */
  /* Setting parameters for component TiO2_poly_incoherent. */
  SIG_MESSAGE("TiO2_poly_incoherent (Init:SetPar)");
#line 419 "MACS_sample_kidney_box.instr"
  mccTiO2_poly_incoherent_sigma = 2.8716;
#line 55 "MACS_sample_kidney_box.instr"
  mccTiO2_poly_incoherent_f_QE = 0;
#line 55 "MACS_sample_kidney_box.instr"
  mccTiO2_poly_incoherent_gamma = 0;
#line 419 "MACS_sample_kidney_box.instr"
  mccTiO2_poly_incoherent_packing_factor = 1;
#line 419 "MACS_sample_kidney_box.instr"
  mccTiO2_poly_incoherent_unit_cell_volume = 62.74;
#line 419 "MACS_sample_kidney_box.instr"
  mccTiO2_poly_incoherent_interact_fraction = -1;
#line 90314 "MACS_sample_kidney_box.c"

  SIG_MESSAGE("TiO2_poly_incoherent (Init:Place/Rotate)");
  rot_set_rotation(mcrotaTiO2_poly_incoherent,
#line 421 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 421 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 421 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD);
#line 90324 "MACS_sample_kidney_box.c"
  rot_transpose(mcrotaTiO2, mctr1);
  rot_mul(mcrotaTiO2_poly_incoherent, mctr1, mcrotrTiO2_poly_incoherent);
  mcposaTiO2_poly_incoherent = coords_set(
#line 420 "MACS_sample_kidney_box.instr"
    0,
#line 420 "MACS_sample_kidney_box.instr"
    0,
#line 420 "MACS_sample_kidney_box.instr"
    0);
#line 90334 "MACS_sample_kidney_box.c"
  mctc1 = coords_sub(mcposaTiO2, mcposaTiO2_poly_incoherent);
  mcposrTiO2_poly_incoherent = rot_apply(mcrotaTiO2_poly_incoherent, mctc1);
  mcDEBUG_COMPONENT("TiO2_poly_incoherent", mcposaTiO2_poly_incoherent, mcrotaTiO2_poly_incoherent)
  mccomp_posa[7] = mcposaTiO2_poly_incoherent;
  mccomp_posr[7] = mcposrTiO2_poly_incoherent;
  mcNCounter[7]  = mcPCounter[7] = mcP2Counter[7] = 0;
  mcAbsorbProp[7]= 0;
    /* Component TiO2_poly. */
  /* Setting parameters for component TiO2_poly. */
  SIG_MESSAGE("TiO2_poly (Init:SetPar)");
#line 428 "MACS_sample_kidney_box.instr"
  if("TiO2_poly_incoherent") strncpy(mccTiO2_poly_process_string, "TiO2_poly_incoherent" ? "TiO2_poly_incoherent" : "", 16384); else mccTiO2_poly_process_string[0]='\0';
#line 426 "MACS_sample_kidney_box.instr"
  mccTiO2_poly_my_absorption = 12.18076;
#line 50 "MACS_sample_kidney_box.instr"
  mccTiO2_poly_absorber = 0;
#line 90351 "MACS_sample_kidney_box.c"

  SIG_MESSAGE("TiO2_poly (Init:Place/Rotate)");
  rot_set_rotation(mcrotaTiO2_poly,
#line 430 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 430 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 430 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD);
#line 90361 "MACS_sample_kidney_box.c"
  rot_transpose(mcrotaTiO2_poly_incoherent, mctr1);
  rot_mul(mcrotaTiO2_poly, mctr1, mcrotrTiO2_poly);
  mcposaTiO2_poly = coords_set(
#line 429 "MACS_sample_kidney_box.instr"
    0,
#line 429 "MACS_sample_kidney_box.instr"
    0,
#line 429 "MACS_sample_kidney_box.instr"
    0);
#line 90371 "MACS_sample_kidney_box.c"
  mctc1 = coords_sub(mcposaTiO2_poly_incoherent, mcposaTiO2_poly);
  mcposrTiO2_poly = rot_apply(mcrotaTiO2_poly, mctc1);
  mcDEBUG_COMPONENT("TiO2_poly", mcposaTiO2_poly, mcrotaTiO2_poly)
  mccomp_posa[8] = mcposaTiO2_poly;
  mccomp_posr[8] = mcposrTiO2_poly;
  mcNCounter[8]  = mcPCounter[8] = mcP2Counter[8] = 0;
  mcAbsorbProp[8]= 0;
    /* Component Al_incoherent_B. */
  /* Setting parameters for component Al_incoherent_B. */
  SIG_MESSAGE("Al_incoherent_B (Init:SetPar)");
#line 433 "MACS_sample_kidney_box.instr"
  mccAl_incoherent_B_sigma = 4 * 0.0082;
#line 55 "MACS_sample_kidney_box.instr"
  mccAl_incoherent_B_f_QE = 0;
#line 55 "MACS_sample_kidney_box.instr"
  mccAl_incoherent_B_gamma = 0;
#line 433 "MACS_sample_kidney_box.instr"
  mccAl_incoherent_B_packing_factor = 1;
#line 433 "MACS_sample_kidney_box.instr"
  mccAl_incoherent_B_unit_cell_volume = 66.4;
#line 55 "MACS_sample_kidney_box.instr"
  mccAl_incoherent_B_interact_fraction = -1;
#line 90394 "MACS_sample_kidney_box.c"

  SIG_MESSAGE("Al_incoherent_B (Init:Place/Rotate)");
  rot_set_rotation(mcrotaAl_incoherent_B,
    (0.0)*DEG2RAD,
    (0.0)*DEG2RAD,
    (0.0)*DEG2RAD);
#line 90401 "MACS_sample_kidney_box.c"
  rot_transpose(mcrotaTiO2_poly, mctr1);
  rot_mul(mcrotaAl_incoherent_B, mctr1, mcrotrAl_incoherent_B);
  mcposaAl_incoherent_B = coords_set(
#line 434 "MACS_sample_kidney_box.instr"
    0,
#line 434 "MACS_sample_kidney_box.instr"
    0,
#line 434 "MACS_sample_kidney_box.instr"
    0);
#line 90411 "MACS_sample_kidney_box.c"
  mctc1 = coords_sub(mcposaTiO2_poly, mcposaAl_incoherent_B);
  mcposrAl_incoherent_B = rot_apply(mcrotaAl_incoherent_B, mctc1);
  mcDEBUG_COMPONENT("Al_incoherent_B", mcposaAl_incoherent_B, mcrotaAl_incoherent_B)
  mccomp_posa[9] = mcposaAl_incoherent_B;
  mccomp_posr[9] = mcposrAl_incoherent_B;
  mcNCounter[9]  = mcPCounter[9] = mcP2Counter[9] = 0;
  mcAbsorbProp[9]= 0;
    /* Component Al_powder_B. */
  /* Setting parameters for component Al_powder_B. */
  SIG_MESSAGE("Al_powder_B (Init:SetPar)");
#line 436 "MACS_sample_kidney_box.instr"
  if("Al.laz") strncpy(mccAl_powder_B_reflections, "Al.laz" ? "Al.laz" : "", 16384); else mccAl_powder_B_reflections[0]='\0';
#line 50 "MACS_sample_kidney_box.instr"
  mccAl_powder_B_packing_factor = 1;
#line 50 "MACS_sample_kidney_box.instr"
  mccAl_powder_B_Vc = 0;
#line 50 "MACS_sample_kidney_box.instr"
  mccAl_powder_B_delta_d_d = 0;
#line 50 "MACS_sample_kidney_box.instr"
  mccAl_powder_B_DW = 0;
#line 50 "MACS_sample_kidney_box.instr"
  mccAl_powder_B_nb_atoms = 1;
#line 50 "MACS_sample_kidney_box.instr"
  mccAl_powder_B_d_phi = 0;
#line 50 "MACS_sample_kidney_box.instr"
  mccAl_powder_B_density = 0;
#line 50 "MACS_sample_kidney_box.instr"
  mccAl_powder_B_weight = 0;
#line 50 "MACS_sample_kidney_box.instr"
  mccAl_powder_B_barns = 1;
#line 50 "MACS_sample_kidney_box.instr"
  mccAl_powder_B_Strain = 0;
#line 50 "MACS_sample_kidney_box.instr"
  mccAl_powder_B_interact_fraction = -1;
#line 90446 "MACS_sample_kidney_box.c"

  SIG_MESSAGE("Al_powder_B (Init:Place/Rotate)");
  rot_set_rotation(mcrotaAl_powder_B,
    (0.0)*DEG2RAD,
    (0.0)*DEG2RAD,
    (0.0)*DEG2RAD);
#line 90453 "MACS_sample_kidney_box.c"
  rot_transpose(mcrotaAl_incoherent_B, mctr1);
  rot_mul(mcrotaAl_powder_B, mctr1, mcrotrAl_powder_B);
  mcposaAl_powder_B = coords_set(
#line 437 "MACS_sample_kidney_box.instr"
    0,
#line 437 "MACS_sample_kidney_box.instr"
    0,
#line 437 "MACS_sample_kidney_box.instr"
    0);
#line 90463 "MACS_sample_kidney_box.c"
  mctc1 = coords_sub(mcposaAl_incoherent_B, mcposaAl_powder_B);
  mcposrAl_powder_B = rot_apply(mcrotaAl_powder_B, mctc1);
  mcDEBUG_COMPONENT("Al_powder_B", mcposaAl_powder_B, mcrotaAl_powder_B)
  mccomp_posa[10] = mcposaAl_powder_B;
  mccomp_posr[10] = mcposrAl_powder_B;
  mcNCounter[10]  = mcPCounter[10] = mcP2Counter[10] = 0;
  mcAbsorbProp[10]= 0;
    /* Component Al_B. */
  /* Setting parameters for component Al_B. */
  SIG_MESSAGE("Al_B (Init:SetPar)");
#line 441 "MACS_sample_kidney_box.instr"
  if("Al_incoherent_B,Al_powder_B") strncpy(mccAl_B_process_string, "Al_incoherent_B,Al_powder_B" ? "Al_incoherent_B,Al_powder_B" : "", 16384); else mccAl_B_process_string[0]='\0';
#line 441 "MACS_sample_kidney_box.instr"
  mccAl_B_my_absorption = 100 * ( 4 * 0.231 * 0.955 + 4 * 767 * 0.045 ) / 66.4;
#line 50 "MACS_sample_kidney_box.instr"
  mccAl_B_absorber = 0;
#line 90480 "MACS_sample_kidney_box.c"

  SIG_MESSAGE("Al_B (Init:Place/Rotate)");
  rot_set_rotation(mcrotaAl_B,
    (0.0)*DEG2RAD,
    (0.0)*DEG2RAD,
    (0.0)*DEG2RAD);
#line 90487 "MACS_sample_kidney_box.c"
  rot_transpose(mcrotaAl_powder_B, mctr1);
  rot_mul(mcrotaAl_B, mctr1, mcrotrAl_B);
  mcposaAl_B = coords_set(
#line 442 "MACS_sample_kidney_box.instr"
    0,
#line 442 "MACS_sample_kidney_box.instr"
    0,
#line 442 "MACS_sample_kidney_box.instr"
    0);
#line 90497 "MACS_sample_kidney_box.c"
  mctc1 = coords_sub(mcposaAl_powder_B, mcposaAl_B);
  mcposrAl_B = rot_apply(mcrotaAl_B, mctc1);
  mcDEBUG_COMPONENT("Al_B", mcposaAl_B, mcrotaAl_B)
  mccomp_posa[11] = mcposaAl_B;
  mccomp_posr[11] = mcposrAl_B;
  mcNCounter[11]  = mcPCounter[11] = mcP2Counter[11] = 0;
  mcAbsorbProp[11]= 0;
    /* Component Arm0. */
  /* Setting parameters for component Arm0. */
  SIG_MESSAGE("Arm0 (Init:SetPar)");
#line 39 "MACS_sample_kidney_box.instr"
  if("NULL") strncpy(mccArm0_profile, "NULL" ? "NULL" : "", 16384); else mccArm0_profile[0]='\0';
#line 39 "MACS_sample_kidney_box.instr"
  mccArm0_percent = 10;
#line 39 "MACS_sample_kidney_box.instr"
  mccArm0_flag_save = 0;
#line 39 "MACS_sample_kidney_box.instr"
  mccArm0_minutes = 0;
#line 90516 "MACS_sample_kidney_box.c"

  SIG_MESSAGE("Arm0 (Init:Place/Rotate)");
  rot_set_rotation(mcrotaArm0,
    (0.0)*DEG2RAD,
    (0.0)*DEG2RAD,
    (0.0)*DEG2RAD);
#line 90523 "MACS_sample_kidney_box.c"
  rot_transpose(mcrotaAl_B, mctr1);
  rot_mul(mcrotaArm0, mctr1, mcrotrArm0);
  mcposaArm0 = coords_set(
#line 445 "MACS_sample_kidney_box.instr"
    0,
#line 445 "MACS_sample_kidney_box.instr"
    0,
#line 445 "MACS_sample_kidney_box.instr"
    0);
#line 90533 "MACS_sample_kidney_box.c"
  mctc1 = coords_sub(mcposaAl_B, mcposaArm0);
  mcposrArm0 = rot_apply(mcrotaArm0, mctc1);
  mcDEBUG_COMPONENT("Arm0", mcposaArm0, mcrotaArm0)
  mccomp_posa[12] = mcposaArm0;
  mccomp_posr[12] = mcposrArm0;
  mcNCounter[12]  = mcPCounter[12] = mcP2Counter[12] = 0;
  mcAbsorbProp[12]= 0;
    /* Component Guide_end. */
  /* Setting parameters for component Guide_end. */
  SIG_MESSAGE("Guide_end (Init:SetPar)");
#line 451 "MACS_sample_kidney_box.instr"
  if(virtual_file_name) strncpy(mccGuide_end_filename, virtual_file_name ? virtual_file_name : "", 16384); else mccGuide_end_filename[0]='\0';
#line 64 "MACS_sample_kidney_box.instr"
  mccGuide_end_verbose = 0;
#line 451 "MACS_sample_kidney_box.instr"
  mccGuide_end_repeat_count = mciprepeat_count;
#line 64 "MACS_sample_kidney_box.instr"
  mccGuide_end_smooth = 1;
#line 64 "MACS_sample_kidney_box.instr"
  mccGuide_end_display = 0;
#line 90554 "MACS_sample_kidney_box.c"

  SIG_MESSAGE("Guide_end (Init:Place/Rotate)");
  rot_set_rotation(mcrotaGuide_end,
#line 453 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 453 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 453 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD);
#line 90564 "MACS_sample_kidney_box.c"
  rot_transpose(mcrotaArm0, mctr1);
  rot_mul(mcrotaGuide_end, mctr1, mcrotrGuide_end);
  mcposaGuide_end = coords_set(
#line 452 "MACS_sample_kidney_box.instr"
    0,
#line 452 "MACS_sample_kidney_box.instr"
    0,
#line 452 "MACS_sample_kidney_box.instr"
    0);
#line 90574 "MACS_sample_kidney_box.c"
  mctc1 = coords_sub(mcposaArm0, mcposaGuide_end);
  mcposrGuide_end = rot_apply(mcrotaGuide_end, mctc1);
  mcDEBUG_COMPONENT("Guide_end", mcposaGuide_end, mcrotaGuide_end)
  mccomp_posa[13] = mcposaGuide_end;
  mccomp_posr[13] = mcposrGuide_end;
  mcNCounter[13]  = mcPCounter[13] = mcP2Counter[13] = 0;
  mcAbsorbProp[13]= 0;
    /* Component main_slit. */
  /* Setting parameters for component main_slit. */
  SIG_MESSAGE("main_slit (Init:SetPar)");
#line 46 "MACS_sample_kidney_box.instr"
  mccmain_slit_xmin = 0;
#line 46 "MACS_sample_kidney_box.instr"
  mccmain_slit_xmax = 0;
#line 46 "MACS_sample_kidney_box.instr"
  mccmain_slit_ymin = 0;
#line 46 "MACS_sample_kidney_box.instr"
  mccmain_slit_ymax = 0;
#line 46 "MACS_sample_kidney_box.instr"
  mccmain_slit_radius = 0;
#line 464 "MACS_sample_kidney_box.instr"
  mccmain_slit_xwidth = mcipslit_h;
#line 464 "MACS_sample_kidney_box.instr"
  mccmain_slit_yheight = mcipslit_v;
#line 90599 "MACS_sample_kidney_box.c"

  SIG_MESSAGE("main_slit (Init:Place/Rotate)");
  rot_set_rotation(mctr1,
#line 466 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 466 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 466 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD);
#line 90609 "MACS_sample_kidney_box.c"
  rot_mul(mctr1, mcrotaGuide_end, mcrotamain_slit);
  rot_transpose(mcrotaGuide_end, mctr1);
  rot_mul(mcrotamain_slit, mctr1, mcrotrmain_slit);
  mctc1 = coords_set(
#line 465 "MACS_sample_kidney_box.instr"
    0,
#line 465 "MACS_sample_kidney_box.instr"
    0,
#line 465 "MACS_sample_kidney_box.instr"
    dist_mono_L1_pos - dist_slit1 - dmtas_guide_len - 0.01 - 0.227);
#line 90620 "MACS_sample_kidney_box.c"
  rot_transpose(mcrotaGuide_end, mctr1);
  mctc2 = rot_apply(mctr1, mctc1);
  mcposamain_slit = coords_add(mcposaGuide_end, mctc2);
  mctc1 = coords_sub(mcposaGuide_end, mcposamain_slit);
  mcposrmain_slit = rot_apply(mcrotamain_slit, mctc1);
  mcDEBUG_COMPONENT("main_slit", mcposamain_slit, mcrotamain_slit)
  mccomp_posa[14] = mcposamain_slit;
  mccomp_posr[14] = mcposrmain_slit;
  mcNCounter[14]  = mcPCounter[14] = mcP2Counter[14] = 0;
  mcAbsorbProp[14]= 0;
    /* Component target. */
  /* Setting parameters for component target. */
  SIG_MESSAGE("target (Init:SetPar)");

  SIG_MESSAGE("target (Init:Place/Rotate)");
  rot_set_rotation(mctr1,
#line 470 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 470 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 470 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD);
#line 90643 "MACS_sample_kidney_box.c"
  rot_mul(mctr1, mcrotaGuide_end, mcrotatarget);
  rot_transpose(mcrotamain_slit, mctr1);
  rot_mul(mcrotatarget, mctr1, mcrotrtarget);
  mctc1 = coords_set(
#line 469 "MACS_sample_kidney_box.instr"
    0,
#line 469 "MACS_sample_kidney_box.instr"
    0,
#line 469 "MACS_sample_kidney_box.instr"
    dist_mono_L1_pos - dist_slit1 - dmtas_guide_len - 0.01);
#line 90654 "MACS_sample_kidney_box.c"
  rot_transpose(mcrotaGuide_end, mctr1);
  mctc2 = rot_apply(mctr1, mctc1);
  mcposatarget = coords_add(mcposaGuide_end, mctc2);
  mctc1 = coords_sub(mcposamain_slit, mcposatarget);
  mcposrtarget = rot_apply(mcrotatarget, mctc1);
  mcDEBUG_COMPONENT("target", mcposatarget, mcrotatarget)
  mccomp_posa[15] = mcposatarget;
  mccomp_posr[15] = mcposrtarget;
  mcNCounter[15]  = mcPCounter[15] = mcP2Counter[15] = 0;
  mcAbsorbProp[15]= 0;
    /* Component cryostat_center. */
  /* Setting parameters for component cryostat_center. */
  SIG_MESSAGE("cryostat_center (Init:SetPar)");

  SIG_MESSAGE("cryostat_center (Init:Place/Rotate)");
  rot_set_rotation(mctr1,
#line 495 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 495 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 495 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD);
#line 90677 "MACS_sample_kidney_box.c"
  rot_mul(mctr1, mcrotatarget, mcrotacryostat_center);
  rot_transpose(mcrotatarget, mctr1);
  rot_mul(mcrotacryostat_center, mctr1, mcrotrcryostat_center);
  mctc1 = coords_set(
#line 494 "MACS_sample_kidney_box.instr"
    0.008,
#line 494 "MACS_sample_kidney_box.instr"
    0,
#line 494 "MACS_sample_kidney_box.instr"
    0.0015);
#line 90688 "MACS_sample_kidney_box.c"
  rot_transpose(mcrotatarget, mctr1);
  mctc2 = rot_apply(mctr1, mctc1);
  mcposacryostat_center = coords_add(mcposatarget, mctc2);
  mctc1 = coords_sub(mcposatarget, mcposacryostat_center);
  mcposrcryostat_center = rot_apply(mcrotacryostat_center, mctc1);
  mcDEBUG_COMPONENT("cryostat_center", mcposacryostat_center, mcrotacryostat_center)
  mccomp_posa[16] = mcposacryostat_center;
  mccomp_posr[16] = mcposrcryostat_center;
  mcNCounter[16]  = mcPCounter[16] = mcP2Counter[16] = 0;
  mcAbsorbProp[16]= 0;
    /* Component drum_center. */
  /* Setting parameters for component drum_center. */
  SIG_MESSAGE("drum_center (Init:SetPar)");

  SIG_MESSAGE("drum_center (Init:Place/Rotate)");
  rot_set_rotation(mctr1,
#line 499 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 499 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 499 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD);
#line 90711 "MACS_sample_kidney_box.c"
  rot_mul(mctr1, mcrotacryostat_center, mcrotadrum_center);
  rot_transpose(mcrotacryostat_center, mctr1);
  rot_mul(mcrotadrum_center, mctr1, mcrotrdrum_center);
  mctc1 = coords_set(
#line 498 "MACS_sample_kidney_box.instr"
    0,
#line 498 "MACS_sample_kidney_box.instr"
    0.603,
#line 498 "MACS_sample_kidney_box.instr"
    0);
#line 90722 "MACS_sample_kidney_box.c"
  rot_transpose(mcrotacryostat_center, mctr1);
  mctc2 = rot_apply(mctr1, mctc1);
  mcposadrum_center = coords_add(mcposacryostat_center, mctc2);
  mctc1 = coords_sub(mcposacryostat_center, mcposadrum_center);
  mcposrdrum_center = rot_apply(mcrotadrum_center, mctc1);
  mcDEBUG_COMPONENT("drum_center", mcposadrum_center, mcrotadrum_center)
  mccomp_posa[17] = mcposadrum_center;
  mccomp_posr[17] = mcposrdrum_center;
  mcNCounter[17]  = mcPCounter[17] = mcP2Counter[17] = 0;
  mcAbsorbProp[17]= 0;
    /* Component crystal_assembly. */
  /* Setting parameters for component crystal_assembly. */
  SIG_MESSAGE("crystal_assembly (Init:SetPar)");

  SIG_MESSAGE("crystal_assembly (Init:Place/Rotate)");
  rot_set_rotation(mctr1,
#line 503 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 503 "MACS_sample_kidney_box.instr"
    (mcipA3_angle)*DEG2RAD,
#line 503 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD);
#line 90745 "MACS_sample_kidney_box.c"
  rot_mul(mctr1, mcrotatarget, mcrotacrystal_assembly);
  rot_transpose(mcrotadrum_center, mctr1);
  rot_mul(mcrotacrystal_assembly, mctr1, mcrotrcrystal_assembly);
  mctc1 = coords_set(
#line 502 "MACS_sample_kidney_box.instr"
    0,
#line 502 "MACS_sample_kidney_box.instr"
    0,
#line 502 "MACS_sample_kidney_box.instr"
    0);
#line 90756 "MACS_sample_kidney_box.c"
  rot_transpose(mcrotatarget, mctr1);
  mctc2 = rot_apply(mctr1, mctc1);
  mcposacrystal_assembly = coords_add(mcposatarget, mctc2);
  mctc1 = coords_sub(mcposadrum_center, mcposacrystal_assembly);
  mcposrcrystal_assembly = rot_apply(mcrotacrystal_assembly, mctc1);
  mcDEBUG_COMPONENT("crystal_assembly", mcposacrystal_assembly, mcrotacrystal_assembly)
  mccomp_posa[18] = mcposacrystal_assembly;
  mccomp_posr[18] = mcposrcrystal_assembly;
  mcNCounter[18]  = mcPCounter[18] = mcP2Counter[18] = 0;
  mcAbsorbProp[18]= 0;
    /* Component crystal_axis. */
  /* Setting parameters for component crystal_axis. */
  SIG_MESSAGE("crystal_axis (Init:SetPar)");

  SIG_MESSAGE("crystal_axis (Init:Place/Rotate)");
  rot_set_rotation(mctr1,
#line 507 "MACS_sample_kidney_box.instr"
    (60.0)*DEG2RAD,
#line 507 "MACS_sample_kidney_box.instr"
    (0.0)*DEG2RAD,
#line 507 "MACS_sample_kidney_box.instr"
    (0.0)*DEG2RAD);
#line 90779 "MACS_sample_kidney_box.c"
  rot_mul(mctr1, mcrotacrystal_assembly, mcrotacrystal_axis);
  rot_transpose(mcrotacrystal_assembly, mctr1);
  rot_mul(mcrotacrystal_axis, mctr1, mcrotrcrystal_axis);
  mctc1 = coords_set(
#line 506 "MACS_sample_kidney_box.instr"
    0,
#line 506 "MACS_sample_kidney_box.instr"
    0,
#line 506 "MACS_sample_kidney_box.instr"
    0);
#line 90790 "MACS_sample_kidney_box.c"
  rot_transpose(mcrotacrystal_assembly, mctr1);
  mctc2 = rot_apply(mctr1, mctc1);
  mcposacrystal_axis = coords_add(mcposacrystal_assembly, mctc2);
  mctc1 = coords_sub(mcposacrystal_assembly, mcposacrystal_axis);
  mcposrcrystal_axis = rot_apply(mcrotacrystal_axis, mctc1);
  mcDEBUG_COMPONENT("crystal_axis", mcposacrystal_axis, mcrotacrystal_axis)
  mccomp_posa[19] = mcposacrystal_axis;
  mccomp_posr[19] = mcposrcrystal_axis;
  mcNCounter[19]  = mcPCounter[19] = mcP2Counter[19] = 0;
  mcAbsorbProp[19]= 0;
    /* Component sample. */
  /* Setting parameters for component sample. */
  SIG_MESSAGE("sample (Init:SetPar)");
#line 512 "MACS_sample_kidney_box.instr"
  if("TiO2") strncpy(mccsample_material_string, "TiO2" ? "TiO2" : "", 16384); else mccsample_material_string[0]='\0';
#line 512 "MACS_sample_kidney_box.instr"
  mccsample_priority = 100;
#line 512 "MACS_sample_kidney_box.instr"
  mccsample_xwidth = 0.00215;
#line 512 "MACS_sample_kidney_box.instr"
  mccsample_yheight = 0.00165;
#line 512 "MACS_sample_kidney_box.instr"
  mccsample_zdepth = 0.00065;
#line 71 "MACS_sample_kidney_box.instr"
  mccsample_xwidth2 = -1;
#line 71 "MACS_sample_kidney_box.instr"
  mccsample_yheight2 = -1;
#line 71 "MACS_sample_kidney_box.instr"
  mccsample_visualize = 1;
#line 71 "MACS_sample_kidney_box.instr"
  mccsample_target_index = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccsample_target_x = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccsample_target_y = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccsample_target_z = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccsample_focus_aw = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccsample_focus_ah = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccsample_focus_xw = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccsample_focus_xh = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccsample_focus_r = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccsample_p_interact = 0;
#line 71 "MACS_sample_kidney_box.instr"
  if(0) strncpy(mccsample_mask_string, 0 ? 0 : "", 16384); else mccsample_mask_string[0]='\0';
#line 71 "MACS_sample_kidney_box.instr"
  if(0) strncpy(mccsample_mask_setting, 0 ? 0 : "", 16384); else mccsample_mask_setting[0]='\0';
#line 71 "MACS_sample_kidney_box.instr"
  mccsample_number_of_activations = 1;
#line 90846 "MACS_sample_kidney_box.c"

  SIG_MESSAGE("sample (Init:Place/Rotate)");
  rot_set_rotation(mctr1,
#line 514 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 514 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 514 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD);
#line 90856 "MACS_sample_kidney_box.c"
  rot_mul(mctr1, mcrotacrystal_axis, mcrotasample);
  rot_transpose(mcrotacrystal_axis, mctr1);
  rot_mul(mcrotasample, mctr1, mcrotrsample);
  mctc1 = coords_set(
#line 513 "MACS_sample_kidney_box.instr"
    0,
#line 513 "MACS_sample_kidney_box.instr"
    0,
#line 513 "MACS_sample_kidney_box.instr"
    0);
#line 90867 "MACS_sample_kidney_box.c"
  rot_transpose(mcrotacrystal_assembly, mctr1);
  mctc2 = rot_apply(mctr1, mctc1);
  mcposasample = coords_add(mcposacrystal_assembly, mctc2);
  mctc1 = coords_sub(mcposacrystal_axis, mcposasample);
  mcposrsample = rot_apply(mcrotasample, mctc1);
  mcDEBUG_COMPONENT("sample", mcposasample, mcrotasample)
  mccomp_posa[20] = mcposasample;
  mccomp_posr[20] = mcposrsample;
  mcNCounter[20]  = mcPCounter[20] = mcP2Counter[20] = 0;
  mcAbsorbProp[20]= 0;
    /* Component sample_plate. */
  /* Setting parameters for component sample_plate. */
  SIG_MESSAGE("sample_plate (Init:SetPar)");
#line 518 "MACS_sample_kidney_box.instr"
  if("Al") strncpy(mccsample_plate_material_string, "Al" ? "Al" : "", 16384); else mccsample_plate_material_string[0]='\0';
#line 517 "MACS_sample_kidney_box.instr"
  mccsample_plate_priority = 2;
#line 517 "MACS_sample_kidney_box.instr"
  mccsample_plate_radius = 0.006;
#line 517 "MACS_sample_kidney_box.instr"
  mccsample_plate_yheight = 0.002;
#line 67 "MACS_sample_kidney_box.instr"
  mccsample_plate_visualize = 1;
#line 67 "MACS_sample_kidney_box.instr"
  mccsample_plate_target_index = 0;
#line 67 "MACS_sample_kidney_box.instr"
  mccsample_plate_target_x = 0;
#line 67 "MACS_sample_kidney_box.instr"
  mccsample_plate_target_y = 0;
#line 67 "MACS_sample_kidney_box.instr"
  mccsample_plate_target_z = 0;
#line 67 "MACS_sample_kidney_box.instr"
  mccsample_plate_focus_aw = 0;
#line 67 "MACS_sample_kidney_box.instr"
  mccsample_plate_focus_ah = 0;
#line 67 "MACS_sample_kidney_box.instr"
  mccsample_plate_focus_xw = 0;
#line 67 "MACS_sample_kidney_box.instr"
  mccsample_plate_focus_xh = 0;
#line 67 "MACS_sample_kidney_box.instr"
  mccsample_plate_focus_r = 0;
#line 67 "MACS_sample_kidney_box.instr"
  mccsample_plate_p_interact = 0;
#line 67 "MACS_sample_kidney_box.instr"
  if(0) strncpy(mccsample_plate_mask_string, 0 ? 0 : "", 16384); else mccsample_plate_mask_string[0]='\0';
#line 67 "MACS_sample_kidney_box.instr"
  if(0) strncpy(mccsample_plate_mask_setting, 0 ? 0 : "", 16384); else mccsample_plate_mask_setting[0]='\0';
#line 67 "MACS_sample_kidney_box.instr"
  mccsample_plate_number_of_activations = 1;
#line 90917 "MACS_sample_kidney_box.c"

  SIG_MESSAGE("sample_plate (Init:Place/Rotate)");
  rot_set_rotation(mctr1,
#line 520 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 520 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 520 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD);
#line 90927 "MACS_sample_kidney_box.c"
  rot_mul(mctr1, mcrotacrystal_axis, mcrotasample_plate);
  rot_transpose(mcrotasample, mctr1);
  rot_mul(mcrotasample_plate, mctr1, mcrotrsample_plate);
  mctc1 = coords_set(
#line 519 "MACS_sample_kidney_box.instr"
    0,
#line 519 "MACS_sample_kidney_box.instr"
    plate_distance,
#line 519 "MACS_sample_kidney_box.instr"
    0);
#line 90938 "MACS_sample_kidney_box.c"
  rot_transpose(mcrotatarget, mctr1);
  mctc2 = rot_apply(mctr1, mctc1);
  mcposasample_plate = coords_add(mcposatarget, mctc2);
  mctc1 = coords_sub(mcposasample, mcposasample_plate);
  mcposrsample_plate = rot_apply(mcrotasample_plate, mctc1);
  mcDEBUG_COMPONENT("sample_plate", mcposasample_plate, mcrotasample_plate)
  mccomp_posa[21] = mcposasample_plate;
  mccomp_posr[21] = mcposrsample_plate;
  mcNCounter[21]  = mcPCounter[21] = mcP2Counter[21] = 0;
  mcAbsorbProp[21]= 0;
    /* Component sample_plate_rod. */
  /* Setting parameters for component sample_plate_rod. */
  SIG_MESSAGE("sample_plate_rod (Init:SetPar)");
#line 522 "MACS_sample_kidney_box.instr"
  if("Al") strncpy(mccsample_plate_rod_material_string, "Al" ? "Al" : "", 16384); else mccsample_plate_rod_material_string[0]='\0';
#line 522 "MACS_sample_kidney_box.instr"
  mccsample_plate_rod_priority = 3;
#line 522 "MACS_sample_kidney_box.instr"
  mccsample_plate_rod_radius = 0.00125;
#line 522 "MACS_sample_kidney_box.instr"
  mccsample_plate_rod_yheight = 0.0633;
#line 67 "MACS_sample_kidney_box.instr"
  mccsample_plate_rod_visualize = 1;
#line 67 "MACS_sample_kidney_box.instr"
  mccsample_plate_rod_target_index = 0;
#line 67 "MACS_sample_kidney_box.instr"
  mccsample_plate_rod_target_x = 0;
#line 67 "MACS_sample_kidney_box.instr"
  mccsample_plate_rod_target_y = 0;
#line 67 "MACS_sample_kidney_box.instr"
  mccsample_plate_rod_target_z = 0;
#line 67 "MACS_sample_kidney_box.instr"
  mccsample_plate_rod_focus_aw = 0;
#line 67 "MACS_sample_kidney_box.instr"
  mccsample_plate_rod_focus_ah = 0;
#line 67 "MACS_sample_kidney_box.instr"
  mccsample_plate_rod_focus_xw = 0;
#line 67 "MACS_sample_kidney_box.instr"
  mccsample_plate_rod_focus_xh = 0;
#line 67 "MACS_sample_kidney_box.instr"
  mccsample_plate_rod_focus_r = 0;
#line 67 "MACS_sample_kidney_box.instr"
  mccsample_plate_rod_p_interact = 0;
#line 67 "MACS_sample_kidney_box.instr"
  if(0) strncpy(mccsample_plate_rod_mask_string, 0 ? 0 : "", 16384); else mccsample_plate_rod_mask_string[0]='\0';
#line 67 "MACS_sample_kidney_box.instr"
  if(0) strncpy(mccsample_plate_rod_mask_setting, 0 ? 0 : "", 16384); else mccsample_plate_rod_mask_setting[0]='\0';
#line 67 "MACS_sample_kidney_box.instr"
  mccsample_plate_rod_number_of_activations = 1;
#line 90988 "MACS_sample_kidney_box.c"

  SIG_MESSAGE("sample_plate_rod (Init:Place/Rotate)");
  rot_set_rotation(mctr1,
#line 524 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 524 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 524 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD);
#line 90998 "MACS_sample_kidney_box.c"
  rot_mul(mctr1, mcrotatarget, mcrotasample_plate_rod);
  rot_transpose(mcrotasample_plate, mctr1);
  rot_mul(mcrotasample_plate_rod, mctr1, mcrotrsample_plate_rod);
  mctc1 = coords_set(
#line 523 "MACS_sample_kidney_box.instr"
    0,
#line 523 "MACS_sample_kidney_box.instr"
    2.0 * plate_distance + 0.0315,
#line 523 "MACS_sample_kidney_box.instr"
    0);
#line 91009 "MACS_sample_kidney_box.c"
  rot_transpose(mcrotatarget, mctr1);
  mctc2 = rot_apply(mctr1, mctc1);
  mcposasample_plate_rod = coords_add(mcposatarget, mctc2);
  mctc1 = coords_sub(mcposasample_plate, mcposasample_plate_rod);
  mcposrsample_plate_rod = rot_apply(mcrotasample_plate_rod, mctc1);
  mcDEBUG_COMPONENT("sample_plate_rod", mcposasample_plate_rod, mcrotasample_plate_rod)
  mccomp_posa[22] = mcposasample_plate_rod;
  mccomp_posr[22] = mcposrsample_plate_rod;
  mcNCounter[22]  = mcPCounter[22] = mcP2Counter[22] = 0;
  mcAbsorbProp[22]= 0;
    /* Component sample_base. */
  /* Setting parameters for component sample_base. */
  SIG_MESSAGE("sample_base (Init:SetPar)");
#line 526 "MACS_sample_kidney_box.instr"
  if("Al") strncpy(mccsample_base_material_string, "Al" ? "Al" : "", 16384); else mccsample_base_material_string[0]='\0';
#line 526 "MACS_sample_kidney_box.instr"
  mccsample_base_priority = 4;
#line 526 "MACS_sample_kidney_box.instr"
  mccsample_base_radius = 0.0065;
#line 526 "MACS_sample_kidney_box.instr"
  mccsample_base_yheight = 0.013;
#line 67 "MACS_sample_kidney_box.instr"
  mccsample_base_visualize = 1;
#line 67 "MACS_sample_kidney_box.instr"
  mccsample_base_target_index = 0;
#line 67 "MACS_sample_kidney_box.instr"
  mccsample_base_target_x = 0;
#line 67 "MACS_sample_kidney_box.instr"
  mccsample_base_target_y = 0;
#line 67 "MACS_sample_kidney_box.instr"
  mccsample_base_target_z = 0;
#line 67 "MACS_sample_kidney_box.instr"
  mccsample_base_focus_aw = 0;
#line 67 "MACS_sample_kidney_box.instr"
  mccsample_base_focus_ah = 0;
#line 67 "MACS_sample_kidney_box.instr"
  mccsample_base_focus_xw = 0;
#line 67 "MACS_sample_kidney_box.instr"
  mccsample_base_focus_xh = 0;
#line 67 "MACS_sample_kidney_box.instr"
  mccsample_base_focus_r = 0;
#line 67 "MACS_sample_kidney_box.instr"
  mccsample_base_p_interact = 0;
#line 67 "MACS_sample_kidney_box.instr"
  if(0) strncpy(mccsample_base_mask_string, 0 ? 0 : "", 16384); else mccsample_base_mask_string[0]='\0';
#line 67 "MACS_sample_kidney_box.instr"
  if(0) strncpy(mccsample_base_mask_setting, 0 ? 0 : "", 16384); else mccsample_base_mask_setting[0]='\0';
#line 67 "MACS_sample_kidney_box.instr"
  mccsample_base_number_of_activations = 1;
#line 91059 "MACS_sample_kidney_box.c"

  SIG_MESSAGE("sample_base (Init:Place/Rotate)");
  rot_set_rotation(mctr1,
#line 528 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 528 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 528 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD);
#line 91069 "MACS_sample_kidney_box.c"
  rot_mul(mctr1, mcrotatarget, mcrotasample_base);
  rot_transpose(mcrotasample_plate_rod, mctr1);
  rot_mul(mcrotasample_base, mctr1, mcrotrsample_base);
  mctc1 = coords_set(
#line 527 "MACS_sample_kidney_box.instr"
    0,
#line 527 "MACS_sample_kidney_box.instr"
    0.0628,
#line 527 "MACS_sample_kidney_box.instr"
    0);
#line 91080 "MACS_sample_kidney_box.c"
  rot_transpose(mcrotatarget, mctr1);
  mctc2 = rot_apply(mctr1, mctc1);
  mcposasample_base = coords_add(mcposatarget, mctc2);
  mctc1 = coords_sub(mcposasample_plate_rod, mcposasample_base);
  mcposrsample_base = rot_apply(mcrotasample_base, mctc1);
  mcDEBUG_COMPONENT("sample_base", mcposasample_base, mcrotasample_base)
  mccomp_posa[23] = mcposasample_base;
  mccomp_posr[23] = mcposrsample_base;
  mcNCounter[23]  = mcPCounter[23] = mcP2Counter[23] = 0;
  mcAbsorbProp[23]= 0;
    /* Component sample_base_gap. */
  /* Setting parameters for component sample_base_gap. */
  SIG_MESSAGE("sample_base_gap (Init:SetPar)");
#line 530 "MACS_sample_kidney_box.instr"
  if("Vacuum") strncpy(mccsample_base_gap_material_string, "Vacuum" ? "Vacuum" : "", 16384); else mccsample_base_gap_material_string[0]='\0';
#line 530 "MACS_sample_kidney_box.instr"
  mccsample_base_gap_priority = 5;
#line 530 "MACS_sample_kidney_box.instr"
  mccsample_base_gap_radius = 0.004;
#line 530 "MACS_sample_kidney_box.instr"
  mccsample_base_gap_yheight = 0.009;
#line 67 "MACS_sample_kidney_box.instr"
  mccsample_base_gap_visualize = 1;
#line 67 "MACS_sample_kidney_box.instr"
  mccsample_base_gap_target_index = 0;
#line 67 "MACS_sample_kidney_box.instr"
  mccsample_base_gap_target_x = 0;
#line 67 "MACS_sample_kidney_box.instr"
  mccsample_base_gap_target_y = 0;
#line 67 "MACS_sample_kidney_box.instr"
  mccsample_base_gap_target_z = 0;
#line 67 "MACS_sample_kidney_box.instr"
  mccsample_base_gap_focus_aw = 0;
#line 67 "MACS_sample_kidney_box.instr"
  mccsample_base_gap_focus_ah = 0;
#line 67 "MACS_sample_kidney_box.instr"
  mccsample_base_gap_focus_xw = 0;
#line 67 "MACS_sample_kidney_box.instr"
  mccsample_base_gap_focus_xh = 0;
#line 67 "MACS_sample_kidney_box.instr"
  mccsample_base_gap_focus_r = 0;
#line 67 "MACS_sample_kidney_box.instr"
  mccsample_base_gap_p_interact = 0;
#line 67 "MACS_sample_kidney_box.instr"
  if(0) strncpy(mccsample_base_gap_mask_string, 0 ? 0 : "", 16384); else mccsample_base_gap_mask_string[0]='\0';
#line 67 "MACS_sample_kidney_box.instr"
  if(0) strncpy(mccsample_base_gap_mask_setting, 0 ? 0 : "", 16384); else mccsample_base_gap_mask_setting[0]='\0';
#line 67 "MACS_sample_kidney_box.instr"
  mccsample_base_gap_number_of_activations = 1;
#line 91130 "MACS_sample_kidney_box.c"

  SIG_MESSAGE("sample_base_gap (Init:Place/Rotate)");
  rot_set_rotation(mctr1,
#line 532 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 532 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 532 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD);
#line 91140 "MACS_sample_kidney_box.c"
  rot_mul(mctr1, mcrotatarget, mcrotasample_base_gap);
  rot_transpose(mcrotasample_base, mctr1);
  rot_mul(mcrotasample_base_gap, mctr1, mcrotrsample_base_gap);
  mctc1 = coords_set(
#line 531 "MACS_sample_kidney_box.instr"
    0,
#line 531 "MACS_sample_kidney_box.instr"
    0.0668,
#line 531 "MACS_sample_kidney_box.instr"
    0);
#line 91151 "MACS_sample_kidney_box.c"
  rot_transpose(mcrotatarget, mctr1);
  mctc2 = rot_apply(mctr1, mctc1);
  mcposasample_base_gap = coords_add(mcposatarget, mctc2);
  mctc1 = coords_sub(mcposasample_base, mcposasample_base_gap);
  mcposrsample_base_gap = rot_apply(mcrotasample_base_gap, mctc1);
  mcDEBUG_COMPONENT("sample_base_gap", mcposasample_base_gap, mcrotasample_base_gap)
  mccomp_posa[24] = mcposasample_base_gap;
  mccomp_posr[24] = mcposrsample_base_gap;
  mcNCounter[24]  = mcPCounter[24] = mcP2Counter[24] = 0;
  mcAbsorbProp[24]= 0;
    /* Component cryostat_mountin_plate. */
  /* Setting parameters for component cryostat_mountin_plate. */
  SIG_MESSAGE("cryostat_mountin_plate (Init:SetPar)");
#line 536 "MACS_sample_kidney_box.instr"
  if("Al") strncpy(mcccryostat_mountin_plate_material_string, "Al" ? "Al" : "", 16384); else mcccryostat_mountin_plate_material_string[0]='\0';
#line 536 "MACS_sample_kidney_box.instr"
  mcccryostat_mountin_plate_priority = 7;
#line 536 "MACS_sample_kidney_box.instr"
  mcccryostat_mountin_plate_radius = 0.215;
#line 536 "MACS_sample_kidney_box.instr"
  mcccryostat_mountin_plate_yheight = 0.01;
#line 67 "MACS_sample_kidney_box.instr"
  mcccryostat_mountin_plate_visualize = 1;
#line 67 "MACS_sample_kidney_box.instr"
  mcccryostat_mountin_plate_target_index = 0;
#line 67 "MACS_sample_kidney_box.instr"
  mcccryostat_mountin_plate_target_x = 0;
#line 67 "MACS_sample_kidney_box.instr"
  mcccryostat_mountin_plate_target_y = 0;
#line 67 "MACS_sample_kidney_box.instr"
  mcccryostat_mountin_plate_target_z = 0;
#line 67 "MACS_sample_kidney_box.instr"
  mcccryostat_mountin_plate_focus_aw = 0;
#line 67 "MACS_sample_kidney_box.instr"
  mcccryostat_mountin_plate_focus_ah = 0;
#line 67 "MACS_sample_kidney_box.instr"
  mcccryostat_mountin_plate_focus_xw = 0;
#line 67 "MACS_sample_kidney_box.instr"
  mcccryostat_mountin_plate_focus_xh = 0;
#line 67 "MACS_sample_kidney_box.instr"
  mcccryostat_mountin_plate_focus_r = 0;
#line 67 "MACS_sample_kidney_box.instr"
  mcccryostat_mountin_plate_p_interact = 0;
#line 67 "MACS_sample_kidney_box.instr"
  if(0) strncpy(mcccryostat_mountin_plate_mask_string, 0 ? 0 : "", 16384); else mcccryostat_mountin_plate_mask_string[0]='\0';
#line 67 "MACS_sample_kidney_box.instr"
  if(0) strncpy(mcccryostat_mountin_plate_mask_setting, 0 ? 0 : "", 16384); else mcccryostat_mountin_plate_mask_setting[0]='\0';
#line 536 "MACS_sample_kidney_box.instr"
  mcccryostat_mountin_plate_number_of_activations = number_of_activations_normal;
#line 91201 "MACS_sample_kidney_box.c"

  SIG_MESSAGE("cryostat_mountin_plate (Init:Place/Rotate)");
  rot_set_rotation(mctr1,
#line 538 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 538 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 538 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD);
#line 91211 "MACS_sample_kidney_box.c"
  rot_mul(mctr1, mcrotacryostat_center, mcrotacryostat_mountin_plate);
  rot_transpose(mcrotasample_base_gap, mctr1);
  rot_mul(mcrotacryostat_mountin_plate, mctr1, mcrotrcryostat_mountin_plate);
  mctc1 = coords_set(
#line 537 "MACS_sample_kidney_box.instr"
    0,
#line 537 "MACS_sample_kidney_box.instr"
    -0.147,
#line 537 "MACS_sample_kidney_box.instr"
    0);
#line 91222 "MACS_sample_kidney_box.c"
  rot_transpose(mcrotacryostat_center, mctr1);
  mctc2 = rot_apply(mctr1, mctc1);
  mcposacryostat_mountin_plate = coords_add(mcposacryostat_center, mctc2);
  mctc1 = coords_sub(mcposasample_base_gap, mcposacryostat_mountin_plate);
  mcposrcryostat_mountin_plate = rot_apply(mcrotacryostat_mountin_plate, mctc1);
  mcDEBUG_COMPONENT("cryostat_mountin_plate", mcposacryostat_mountin_plate, mcrotacryostat_mountin_plate)
  mccomp_posa[25] = mcposacryostat_mountin_plate;
  mccomp_posr[25] = mcposrcryostat_mountin_plate;
  mcNCounter[25]  = mcPCounter[25] = mcP2Counter[25] = 0;
  mcAbsorbProp[25]= 0;
    /* Component cryostat_drum_walls. */
  /* Setting parameters for component cryostat_drum_walls. */
  SIG_MESSAGE("cryostat_drum_walls (Init:SetPar)");
#line 543 "MACS_sample_kidney_box.instr"
  if("Al") strncpy(mcccryostat_drum_walls_material_string, "Al" ? "Al" : "", 16384); else mcccryostat_drum_walls_material_string[0]='\0';
#line 543 "MACS_sample_kidney_box.instr"
  mcccryostat_drum_walls_priority = 8;
#line 543 "MACS_sample_kidney_box.instr"
  mcccryostat_drum_walls_radius = 0.1975;
#line 543 "MACS_sample_kidney_box.instr"
  mcccryostat_drum_walls_yheight = 0.800;
#line 67 "MACS_sample_kidney_box.instr"
  mcccryostat_drum_walls_visualize = 1;
#line 67 "MACS_sample_kidney_box.instr"
  mcccryostat_drum_walls_target_index = 0;
#line 67 "MACS_sample_kidney_box.instr"
  mcccryostat_drum_walls_target_x = 0;
#line 67 "MACS_sample_kidney_box.instr"
  mcccryostat_drum_walls_target_y = 0;
#line 67 "MACS_sample_kidney_box.instr"
  mcccryostat_drum_walls_target_z = 0;
#line 67 "MACS_sample_kidney_box.instr"
  mcccryostat_drum_walls_focus_aw = 0;
#line 67 "MACS_sample_kidney_box.instr"
  mcccryostat_drum_walls_focus_ah = 0;
#line 67 "MACS_sample_kidney_box.instr"
  mcccryostat_drum_walls_focus_xw = 0;
#line 67 "MACS_sample_kidney_box.instr"
  mcccryostat_drum_walls_focus_xh = 0;
#line 67 "MACS_sample_kidney_box.instr"
  mcccryostat_drum_walls_focus_r = 0;
#line 67 "MACS_sample_kidney_box.instr"
  mcccryostat_drum_walls_p_interact = 0;
#line 67 "MACS_sample_kidney_box.instr"
  if(0) strncpy(mcccryostat_drum_walls_mask_string, 0 ? 0 : "", 16384); else mcccryostat_drum_walls_mask_string[0]='\0';
#line 67 "MACS_sample_kidney_box.instr"
  if(0) strncpy(mcccryostat_drum_walls_mask_setting, 0 ? 0 : "", 16384); else mcccryostat_drum_walls_mask_setting[0]='\0';
#line 543 "MACS_sample_kidney_box.instr"
  mcccryostat_drum_walls_number_of_activations = number_of_activations_normal;
#line 91272 "MACS_sample_kidney_box.c"

  SIG_MESSAGE("cryostat_drum_walls (Init:Place/Rotate)");
  rot_set_rotation(mctr1,
#line 545 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 545 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 545 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD);
#line 91282 "MACS_sample_kidney_box.c"
  rot_mul(mctr1, mcrotadrum_center, mcrotacryostat_drum_walls);
  rot_transpose(mcrotacryostat_mountin_plate, mctr1);
  rot_mul(mcrotacryostat_drum_walls, mctr1, mcrotrcryostat_drum_walls);
  mctc1 = coords_set(
#line 544 "MACS_sample_kidney_box.instr"
    0,
#line 544 "MACS_sample_kidney_box.instr"
    0,
#line 544 "MACS_sample_kidney_box.instr"
    0);
#line 91293 "MACS_sample_kidney_box.c"
  rot_transpose(mcrotadrum_center, mctr1);
  mctc2 = rot_apply(mctr1, mctc1);
  mcposacryostat_drum_walls = coords_add(mcposadrum_center, mctc2);
  mctc1 = coords_sub(mcposacryostat_mountin_plate, mcposacryostat_drum_walls);
  mcposrcryostat_drum_walls = rot_apply(mcrotacryostat_drum_walls, mctc1);
  mcDEBUG_COMPONENT("cryostat_drum_walls", mcposacryostat_drum_walls, mcrotacryostat_drum_walls)
  mccomp_posa[26] = mcposacryostat_drum_walls;
  mccomp_posr[26] = mcposrcryostat_drum_walls;
  mcNCounter[26]  = mcPCounter[26] = mcP2Counter[26] = 0;
  mcAbsorbProp[26]= 0;
    /* Component cryostat_drum_vacuum. */
  /* Setting parameters for component cryostat_drum_vacuum. */
  SIG_MESSAGE("cryostat_drum_vacuum (Init:SetPar)");
#line 548 "MACS_sample_kidney_box.instr"
  if("Vacuum") strncpy(mcccryostat_drum_vacuum_material_string, "Vacuum" ? "Vacuum" : "", 16384); else mcccryostat_drum_vacuum_material_string[0]='\0';
#line 548 "MACS_sample_kidney_box.instr"
  mcccryostat_drum_vacuum_priority = 9;
#line 548 "MACS_sample_kidney_box.instr"
  mcccryostat_drum_vacuum_radius = 0.19;
#line 548 "MACS_sample_kidney_box.instr"
  mcccryostat_drum_vacuum_yheight = 0.790;
#line 67 "MACS_sample_kidney_box.instr"
  mcccryostat_drum_vacuum_visualize = 1;
#line 67 "MACS_sample_kidney_box.instr"
  mcccryostat_drum_vacuum_target_index = 0;
#line 67 "MACS_sample_kidney_box.instr"
  mcccryostat_drum_vacuum_target_x = 0;
#line 67 "MACS_sample_kidney_box.instr"
  mcccryostat_drum_vacuum_target_y = 0;
#line 67 "MACS_sample_kidney_box.instr"
  mcccryostat_drum_vacuum_target_z = 0;
#line 67 "MACS_sample_kidney_box.instr"
  mcccryostat_drum_vacuum_focus_aw = 0;
#line 67 "MACS_sample_kidney_box.instr"
  mcccryostat_drum_vacuum_focus_ah = 0;
#line 67 "MACS_sample_kidney_box.instr"
  mcccryostat_drum_vacuum_focus_xw = 0;
#line 67 "MACS_sample_kidney_box.instr"
  mcccryostat_drum_vacuum_focus_xh = 0;
#line 67 "MACS_sample_kidney_box.instr"
  mcccryostat_drum_vacuum_focus_r = 0;
#line 67 "MACS_sample_kidney_box.instr"
  mcccryostat_drum_vacuum_p_interact = 0;
#line 67 "MACS_sample_kidney_box.instr"
  if(0) strncpy(mcccryostat_drum_vacuum_mask_string, 0 ? 0 : "", 16384); else mcccryostat_drum_vacuum_mask_string[0]='\0';
#line 67 "MACS_sample_kidney_box.instr"
  if(0) strncpy(mcccryostat_drum_vacuum_mask_setting, 0 ? 0 : "", 16384); else mcccryostat_drum_vacuum_mask_setting[0]='\0';
#line 548 "MACS_sample_kidney_box.instr"
  mcccryostat_drum_vacuum_number_of_activations = number_of_activations_normal;
#line 91343 "MACS_sample_kidney_box.c"

  SIG_MESSAGE("cryostat_drum_vacuum (Init:Place/Rotate)");
  rot_set_rotation(mctr1,
#line 550 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 550 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 550 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD);
#line 91353 "MACS_sample_kidney_box.c"
  rot_mul(mctr1, mcrotadrum_center, mcrotacryostat_drum_vacuum);
  rot_transpose(mcrotacryostat_drum_walls, mctr1);
  rot_mul(mcrotacryostat_drum_vacuum, mctr1, mcrotrcryostat_drum_vacuum);
  mctc1 = coords_set(
#line 549 "MACS_sample_kidney_box.instr"
    0,
#line 549 "MACS_sample_kidney_box.instr"
    0,
#line 549 "MACS_sample_kidney_box.instr"
    0);
#line 91364 "MACS_sample_kidney_box.c"
  rot_transpose(mcrotadrum_center, mctr1);
  mctc2 = rot_apply(mctr1, mctc1);
  mcposacryostat_drum_vacuum = coords_add(mcposadrum_center, mctc2);
  mctc1 = coords_sub(mcposacryostat_drum_walls, mcposacryostat_drum_vacuum);
  mcposrcryostat_drum_vacuum = rot_apply(mcrotacryostat_drum_vacuum, mctc1);
  mcDEBUG_COMPONENT("cryostat_drum_vacuum", mcposacryostat_drum_vacuum, mcrotacryostat_drum_vacuum)
  mccomp_posa[27] = mcposacryostat_drum_vacuum;
  mccomp_posr[27] = mcposrcryostat_drum_vacuum;
  mcNCounter[27]  = mcPCounter[27] = mcP2Counter[27] = 0;
  mcAbsorbProp[27]= 0;
    /* Component outer_cryostat_wall. */
  /* Setting parameters for component outer_cryostat_wall. */
  SIG_MESSAGE("outer_cryostat_wall (Init:SetPar)");
#line 553 "MACS_sample_kidney_box.instr"
  if("Al") strncpy(mccouter_cryostat_wall_material_string, "Al" ? "Al" : "", 16384); else mccouter_cryostat_wall_material_string[0]='\0';
#line 553 "MACS_sample_kidney_box.instr"
  mccouter_cryostat_wall_priority = 10;
#line 553 "MACS_sample_kidney_box.instr"
  mccouter_cryostat_wall_radius = 0.180;
#line 553 "MACS_sample_kidney_box.instr"
  mccouter_cryostat_wall_yheight = 0.355;
#line 67 "MACS_sample_kidney_box.instr"
  mccouter_cryostat_wall_visualize = 1;
#line 67 "MACS_sample_kidney_box.instr"
  mccouter_cryostat_wall_target_index = 0;
#line 67 "MACS_sample_kidney_box.instr"
  mccouter_cryostat_wall_target_x = 0;
#line 67 "MACS_sample_kidney_box.instr"
  mccouter_cryostat_wall_target_y = 0;
#line 67 "MACS_sample_kidney_box.instr"
  mccouter_cryostat_wall_target_z = 0;
#line 67 "MACS_sample_kidney_box.instr"
  mccouter_cryostat_wall_focus_aw = 0;
#line 67 "MACS_sample_kidney_box.instr"
  mccouter_cryostat_wall_focus_ah = 0;
#line 67 "MACS_sample_kidney_box.instr"
  mccouter_cryostat_wall_focus_xw = 0;
#line 67 "MACS_sample_kidney_box.instr"
  mccouter_cryostat_wall_focus_xh = 0;
#line 67 "MACS_sample_kidney_box.instr"
  mccouter_cryostat_wall_focus_r = 0;
#line 553 "MACS_sample_kidney_box.instr"
  mccouter_cryostat_wall_p_interact = 0.20;
#line 67 "MACS_sample_kidney_box.instr"
  if(0) strncpy(mccouter_cryostat_wall_mask_string, 0 ? 0 : "", 16384); else mccouter_cryostat_wall_mask_string[0]='\0';
#line 67 "MACS_sample_kidney_box.instr"
  if(0) strncpy(mccouter_cryostat_wall_mask_setting, 0 ? 0 : "", 16384); else mccouter_cryostat_wall_mask_setting[0]='\0';
#line 553 "MACS_sample_kidney_box.instr"
  mccouter_cryostat_wall_number_of_activations = number_of_activations_normal;
#line 91414 "MACS_sample_kidney_box.c"

  SIG_MESSAGE("outer_cryostat_wall (Init:Place/Rotate)");
  rot_set_rotation(mctr1,
#line 555 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 555 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 555 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD);
#line 91424 "MACS_sample_kidney_box.c"
  rot_mul(mctr1, mcrotacryostat_center, mcrotaouter_cryostat_wall);
  rot_transpose(mcrotacryostat_drum_vacuum, mctr1);
  rot_mul(mcrotaouter_cryostat_wall, mctr1, mcrotrouter_cryostat_wall);
  mctc1 = coords_set(
#line 554 "MACS_sample_kidney_box.instr"
    0,
#line 554 "MACS_sample_kidney_box.instr"
    0.032,
#line 554 "MACS_sample_kidney_box.instr"
    0);
#line 91435 "MACS_sample_kidney_box.c"
  rot_transpose(mcrotacryostat_center, mctr1);
  mctc2 = rot_apply(mctr1, mctc1);
  mcposaouter_cryostat_wall = coords_add(mcposacryostat_center, mctc2);
  mctc1 = coords_sub(mcposacryostat_drum_vacuum, mcposaouter_cryostat_wall);
  mcposrouter_cryostat_wall = rot_apply(mcrotaouter_cryostat_wall, mctc1);
  mcDEBUG_COMPONENT("outer_cryostat_wall", mcposaouter_cryostat_wall, mcrotaouter_cryostat_wall)
  mccomp_posa[28] = mcposaouter_cryostat_wall;
  mccomp_posr[28] = mcposrouter_cryostat_wall;
  mcNCounter[28]  = mcPCounter[28] = mcP2Counter[28] = 0;
  mcAbsorbProp[28]= 0;
    /* Component outer_cryostat_vacuum. */
  /* Setting parameters for component outer_cryostat_vacuum. */
  SIG_MESSAGE("outer_cryostat_vacuum (Init:SetPar)");
#line 558 "MACS_sample_kidney_box.instr"
  if("Vacuum") strncpy(mccouter_cryostat_vacuum_material_string, "Vacuum" ? "Vacuum" : "", 16384); else mccouter_cryostat_vacuum_material_string[0]='\0';
#line 558 "MACS_sample_kidney_box.instr"
  mccouter_cryostat_vacuum_priority = 11;
#line 558 "MACS_sample_kidney_box.instr"
  mccouter_cryostat_vacuum_radius = 0.178;
#line 558 "MACS_sample_kidney_box.instr"
  mccouter_cryostat_vacuum_yheight = 0.355;
#line 67 "MACS_sample_kidney_box.instr"
  mccouter_cryostat_vacuum_visualize = 1;
#line 67 "MACS_sample_kidney_box.instr"
  mccouter_cryostat_vacuum_target_index = 0;
#line 67 "MACS_sample_kidney_box.instr"
  mccouter_cryostat_vacuum_target_x = 0;
#line 67 "MACS_sample_kidney_box.instr"
  mccouter_cryostat_vacuum_target_y = 0;
#line 67 "MACS_sample_kidney_box.instr"
  mccouter_cryostat_vacuum_target_z = 0;
#line 67 "MACS_sample_kidney_box.instr"
  mccouter_cryostat_vacuum_focus_aw = 0;
#line 67 "MACS_sample_kidney_box.instr"
  mccouter_cryostat_vacuum_focus_ah = 0;
#line 67 "MACS_sample_kidney_box.instr"
  mccouter_cryostat_vacuum_focus_xw = 0;
#line 67 "MACS_sample_kidney_box.instr"
  mccouter_cryostat_vacuum_focus_xh = 0;
#line 67 "MACS_sample_kidney_box.instr"
  mccouter_cryostat_vacuum_focus_r = 0;
#line 67 "MACS_sample_kidney_box.instr"
  mccouter_cryostat_vacuum_p_interact = 0;
#line 67 "MACS_sample_kidney_box.instr"
  if(0) strncpy(mccouter_cryostat_vacuum_mask_string, 0 ? 0 : "", 16384); else mccouter_cryostat_vacuum_mask_string[0]='\0';
#line 67 "MACS_sample_kidney_box.instr"
  if(0) strncpy(mccouter_cryostat_vacuum_mask_setting, 0 ? 0 : "", 16384); else mccouter_cryostat_vacuum_mask_setting[0]='\0';
#line 558 "MACS_sample_kidney_box.instr"
  mccouter_cryostat_vacuum_number_of_activations = number_of_activations_normal;
#line 91485 "MACS_sample_kidney_box.c"

  SIG_MESSAGE("outer_cryostat_vacuum (Init:Place/Rotate)");
  rot_set_rotation(mctr1,
#line 560 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 560 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 560 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD);
#line 91495 "MACS_sample_kidney_box.c"
  rot_mul(mctr1, mcrotacryostat_center, mcrotaouter_cryostat_vacuum);
  rot_transpose(mcrotaouter_cryostat_wall, mctr1);
  rot_mul(mcrotaouter_cryostat_vacuum, mctr1, mcrotrouter_cryostat_vacuum);
  mctc1 = coords_set(
#line 559 "MACS_sample_kidney_box.instr"
    0,
#line 559 "MACS_sample_kidney_box.instr"
    0.037,
#line 559 "MACS_sample_kidney_box.instr"
    0);
#line 91506 "MACS_sample_kidney_box.c"
  rot_transpose(mcrotacryostat_center, mctr1);
  mctc2 = rot_apply(mctr1, mctc1);
  mcposaouter_cryostat_vacuum = coords_add(mcposacryostat_center, mctc2);
  mctc1 = coords_sub(mcposaouter_cryostat_wall, mcposaouter_cryostat_vacuum);
  mcposrouter_cryostat_vacuum = rot_apply(mcrotaouter_cryostat_vacuum, mctc1);
  mcDEBUG_COMPONENT("outer_cryostat_vacuum", mcposaouter_cryostat_vacuum, mcrotaouter_cryostat_vacuum)
  mccomp_posa[29] = mcposaouter_cryostat_vacuum;
  mccomp_posr[29] = mcposrouter_cryostat_vacuum;
  mcNCounter[29]  = mcPCounter[29] = mcP2Counter[29] = 0;
  mcAbsorbProp[29]= 0;
    /* Component inner_cryostat_wall. */
  /* Setting parameters for component inner_cryostat_wall. */
  SIG_MESSAGE("inner_cryostat_wall (Init:SetPar)");
#line 563 "MACS_sample_kidney_box.instr"
  if("Al") strncpy(mccinner_cryostat_wall_material_string, "Al" ? "Al" : "", 16384); else mccinner_cryostat_wall_material_string[0]='\0';
#line 563 "MACS_sample_kidney_box.instr"
  mccinner_cryostat_wall_priority = 12;
#line 563 "MACS_sample_kidney_box.instr"
  mccinner_cryostat_wall_radius = 0.052;
#line 563 "MACS_sample_kidney_box.instr"
  mccinner_cryostat_wall_yheight = 0.16;
#line 67 "MACS_sample_kidney_box.instr"
  mccinner_cryostat_wall_visualize = 1;
#line 67 "MACS_sample_kidney_box.instr"
  mccinner_cryostat_wall_target_index = 0;
#line 67 "MACS_sample_kidney_box.instr"
  mccinner_cryostat_wall_target_x = 0;
#line 67 "MACS_sample_kidney_box.instr"
  mccinner_cryostat_wall_target_y = 0;
#line 67 "MACS_sample_kidney_box.instr"
  mccinner_cryostat_wall_target_z = 0;
#line 67 "MACS_sample_kidney_box.instr"
  mccinner_cryostat_wall_focus_aw = 0;
#line 67 "MACS_sample_kidney_box.instr"
  mccinner_cryostat_wall_focus_ah = 0;
#line 67 "MACS_sample_kidney_box.instr"
  mccinner_cryostat_wall_focus_xw = 0;
#line 67 "MACS_sample_kidney_box.instr"
  mccinner_cryostat_wall_focus_xh = 0;
#line 67 "MACS_sample_kidney_box.instr"
  mccinner_cryostat_wall_focus_r = 0;
#line 563 "MACS_sample_kidney_box.instr"
  mccinner_cryostat_wall_p_interact = 0.20;
#line 67 "MACS_sample_kidney_box.instr"
  if(0) strncpy(mccinner_cryostat_wall_mask_string, 0 ? 0 : "", 16384); else mccinner_cryostat_wall_mask_string[0]='\0';
#line 67 "MACS_sample_kidney_box.instr"
  if(0) strncpy(mccinner_cryostat_wall_mask_setting, 0 ? 0 : "", 16384); else mccinner_cryostat_wall_mask_setting[0]='\0';
#line 563 "MACS_sample_kidney_box.instr"
  mccinner_cryostat_wall_number_of_activations = number_of_activations_normal;
#line 91556 "MACS_sample_kidney_box.c"

  SIG_MESSAGE("inner_cryostat_wall (Init:Place/Rotate)");
  rot_set_rotation(mctr1,
#line 565 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 565 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 565 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD);
#line 91566 "MACS_sample_kidney_box.c"
  rot_mul(mctr1, mcrotacryostat_center, mcrotainner_cryostat_wall);
  rot_transpose(mcrotaouter_cryostat_vacuum, mctr1);
  rot_mul(mcrotainner_cryostat_wall, mctr1, mcrotrinner_cryostat_wall);
  mctc1 = coords_set(
#line 564 "MACS_sample_kidney_box.instr"
    0,
#line 564 "MACS_sample_kidney_box.instr"
    0.01,
#line 564 "MACS_sample_kidney_box.instr"
    0);
#line 91577 "MACS_sample_kidney_box.c"
  rot_transpose(mcrotacryostat_center, mctr1);
  mctc2 = rot_apply(mctr1, mctc1);
  mcposainner_cryostat_wall = coords_add(mcposacryostat_center, mctc2);
  mctc1 = coords_sub(mcposaouter_cryostat_vacuum, mcposainner_cryostat_wall);
  mcposrinner_cryostat_wall = rot_apply(mcrotainner_cryostat_wall, mctc1);
  mcDEBUG_COMPONENT("inner_cryostat_wall", mcposainner_cryostat_wall, mcrotainner_cryostat_wall)
  mccomp_posa[30] = mcposainner_cryostat_wall;
  mccomp_posr[30] = mcposrinner_cryostat_wall;
  mcNCounter[30]  = mcPCounter[30] = mcP2Counter[30] = 0;
  mcAbsorbProp[30]= 0;
    /* Component inner_cryostat_vacuum. */
  /* Setting parameters for component inner_cryostat_vacuum. */
  SIG_MESSAGE("inner_cryostat_vacuum (Init:SetPar)");
#line 568 "MACS_sample_kidney_box.instr"
  if("Vacuum") strncpy(mccinner_cryostat_vacuum_material_string, "Vacuum" ? "Vacuum" : "", 16384); else mccinner_cryostat_vacuum_material_string[0]='\0';
#line 568 "MACS_sample_kidney_box.instr"
  mccinner_cryostat_vacuum_priority = 13;
#line 568 "MACS_sample_kidney_box.instr"
  mccinner_cryostat_vacuum_radius = 0.05;
#line 568 "MACS_sample_kidney_box.instr"
  mccinner_cryostat_vacuum_yheight = 0.15;
#line 67 "MACS_sample_kidney_box.instr"
  mccinner_cryostat_vacuum_visualize = 1;
#line 67 "MACS_sample_kidney_box.instr"
  mccinner_cryostat_vacuum_target_index = 0;
#line 67 "MACS_sample_kidney_box.instr"
  mccinner_cryostat_vacuum_target_x = 0;
#line 67 "MACS_sample_kidney_box.instr"
  mccinner_cryostat_vacuum_target_y = 0;
#line 67 "MACS_sample_kidney_box.instr"
  mccinner_cryostat_vacuum_target_z = 0;
#line 67 "MACS_sample_kidney_box.instr"
  mccinner_cryostat_vacuum_focus_aw = 0;
#line 67 "MACS_sample_kidney_box.instr"
  mccinner_cryostat_vacuum_focus_ah = 0;
#line 67 "MACS_sample_kidney_box.instr"
  mccinner_cryostat_vacuum_focus_xw = 0;
#line 67 "MACS_sample_kidney_box.instr"
  mccinner_cryostat_vacuum_focus_xh = 0;
#line 67 "MACS_sample_kidney_box.instr"
  mccinner_cryostat_vacuum_focus_r = 0;
#line 67 "MACS_sample_kidney_box.instr"
  mccinner_cryostat_vacuum_p_interact = 0;
#line 67 "MACS_sample_kidney_box.instr"
  if(0) strncpy(mccinner_cryostat_vacuum_mask_string, 0 ? 0 : "", 16384); else mccinner_cryostat_vacuum_mask_string[0]='\0';
#line 67 "MACS_sample_kidney_box.instr"
  if(0) strncpy(mccinner_cryostat_vacuum_mask_setting, 0 ? 0 : "", 16384); else mccinner_cryostat_vacuum_mask_setting[0]='\0';
#line 568 "MACS_sample_kidney_box.instr"
  mccinner_cryostat_vacuum_number_of_activations = number_of_activations_normal;
#line 91627 "MACS_sample_kidney_box.c"

  SIG_MESSAGE("inner_cryostat_vacuum (Init:Place/Rotate)");
  rot_set_rotation(mctr1,
#line 570 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 570 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 570 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD);
#line 91637 "MACS_sample_kidney_box.c"
  rot_mul(mctr1, mcrotacryostat_center, mcrotainner_cryostat_vacuum);
  rot_transpose(mcrotainner_cryostat_wall, mctr1);
  rot_mul(mcrotainner_cryostat_vacuum, mctr1, mcrotrinner_cryostat_vacuum);
  mctc1 = coords_set(
#line 569 "MACS_sample_kidney_box.instr"
    0,
#line 569 "MACS_sample_kidney_box.instr"
    0.01,
#line 569 "MACS_sample_kidney_box.instr"
    0);
#line 91648 "MACS_sample_kidney_box.c"
  rot_transpose(mcrotacryostat_center, mctr1);
  mctc2 = rot_apply(mctr1, mctc1);
  mcposainner_cryostat_vacuum = coords_add(mcposacryostat_center, mctc2);
  mctc1 = coords_sub(mcposainner_cryostat_wall, mcposainner_cryostat_vacuum);
  mcposrinner_cryostat_vacuum = rot_apply(mcrotainner_cryostat_vacuum, mctc1);
  mcDEBUG_COMPONENT("inner_cryostat_vacuum", mcposainner_cryostat_vacuum, mcrotainner_cryostat_vacuum)
  mccomp_posa[31] = mcposainner_cryostat_vacuum;
  mccomp_posr[31] = mcposrinner_cryostat_vacuum;
  mcNCounter[31]  = mcPCounter[31] = mcP2Counter[31] = 0;
  mcAbsorbProp[31]= 0;
    /* Component sample_stick_walls. */
  /* Setting parameters for component sample_stick_walls. */
  SIG_MESSAGE("sample_stick_walls (Init:SetPar)");
#line 573 "MACS_sample_kidney_box.instr"
  if("Al") strncpy(mccsample_stick_walls_material_string, "Al" ? "Al" : "", 16384); else mccsample_stick_walls_material_string[0]='\0';
#line 573 "MACS_sample_kidney_box.instr"
  mccsample_stick_walls_priority = 14;
#line 573 "MACS_sample_kidney_box.instr"
  mccsample_stick_walls_radius = 0.04;
#line 573 "MACS_sample_kidney_box.instr"
  mccsample_stick_walls_yheight = 0.935;
#line 67 "MACS_sample_kidney_box.instr"
  mccsample_stick_walls_visualize = 1;
#line 67 "MACS_sample_kidney_box.instr"
  mccsample_stick_walls_target_index = 0;
#line 67 "MACS_sample_kidney_box.instr"
  mccsample_stick_walls_target_x = 0;
#line 67 "MACS_sample_kidney_box.instr"
  mccsample_stick_walls_target_y = 0;
#line 67 "MACS_sample_kidney_box.instr"
  mccsample_stick_walls_target_z = 0;
#line 67 "MACS_sample_kidney_box.instr"
  mccsample_stick_walls_focus_aw = 0;
#line 67 "MACS_sample_kidney_box.instr"
  mccsample_stick_walls_focus_ah = 0;
#line 67 "MACS_sample_kidney_box.instr"
  mccsample_stick_walls_focus_xw = 0;
#line 67 "MACS_sample_kidney_box.instr"
  mccsample_stick_walls_focus_xh = 0;
#line 67 "MACS_sample_kidney_box.instr"
  mccsample_stick_walls_focus_r = 0;
#line 67 "MACS_sample_kidney_box.instr"
  mccsample_stick_walls_p_interact = 0;
#line 67 "MACS_sample_kidney_box.instr"
  if(0) strncpy(mccsample_stick_walls_mask_string, 0 ? 0 : "", 16384); else mccsample_stick_walls_mask_string[0]='\0';
#line 67 "MACS_sample_kidney_box.instr"
  if(0) strncpy(mccsample_stick_walls_mask_setting, 0 ? 0 : "", 16384); else mccsample_stick_walls_mask_setting[0]='\0';
#line 573 "MACS_sample_kidney_box.instr"
  mccsample_stick_walls_number_of_activations = number_of_activations_normal;
#line 91698 "MACS_sample_kidney_box.c"

  SIG_MESSAGE("sample_stick_walls (Init:Place/Rotate)");
  rot_set_rotation(mctr1,
#line 575 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 575 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 575 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD);
#line 91708 "MACS_sample_kidney_box.c"
  rot_mul(mctr1, mcrotacryostat_center, mcrotasample_stick_walls);
  rot_transpose(mcrotainner_cryostat_vacuum, mctr1);
  rot_mul(mcrotasample_stick_walls, mctr1, mcrotrsample_stick_walls);
  mctc1 = coords_set(
#line 574 "MACS_sample_kidney_box.instr"
    0,
#line 574 "MACS_sample_kidney_box.instr"
    0.555,
#line 574 "MACS_sample_kidney_box.instr"
    0);
#line 91719 "MACS_sample_kidney_box.c"
  rot_transpose(mcrotacryostat_center, mctr1);
  mctc2 = rot_apply(mctr1, mctc1);
  mcposasample_stick_walls = coords_add(mcposacryostat_center, mctc2);
  mctc1 = coords_sub(mcposainner_cryostat_vacuum, mcposasample_stick_walls);
  mcposrsample_stick_walls = rot_apply(mcrotasample_stick_walls, mctc1);
  mcDEBUG_COMPONENT("sample_stick_walls", mcposasample_stick_walls, mcrotasample_stick_walls)
  mccomp_posa[32] = mcposasample_stick_walls;
  mccomp_posr[32] = mcposrsample_stick_walls;
  mcNCounter[32]  = mcPCounter[32] = mcP2Counter[32] = 0;
  mcAbsorbProp[32]= 0;
    /* Component sample_stick_vacuum. */
  /* Setting parameters for component sample_stick_vacuum. */
  SIG_MESSAGE("sample_stick_vacuum (Init:SetPar)");
#line 578 "MACS_sample_kidney_box.instr"
  if("Vacuum") strncpy(mccsample_stick_vacuum_material_string, "Vacuum" ? "Vacuum" : "", 16384); else mccsample_stick_vacuum_material_string[0]='\0';
#line 578 "MACS_sample_kidney_box.instr"
  mccsample_stick_vacuum_priority = 15;
#line 578 "MACS_sample_kidney_box.instr"
  mccsample_stick_vacuum_radius = 0.035;
#line 578 "MACS_sample_kidney_box.instr"
  mccsample_stick_vacuum_yheight = 0.94;
#line 67 "MACS_sample_kidney_box.instr"
  mccsample_stick_vacuum_visualize = 1;
#line 67 "MACS_sample_kidney_box.instr"
  mccsample_stick_vacuum_target_index = 0;
#line 67 "MACS_sample_kidney_box.instr"
  mccsample_stick_vacuum_target_x = 0;
#line 67 "MACS_sample_kidney_box.instr"
  mccsample_stick_vacuum_target_y = 0;
#line 67 "MACS_sample_kidney_box.instr"
  mccsample_stick_vacuum_target_z = 0;
#line 67 "MACS_sample_kidney_box.instr"
  mccsample_stick_vacuum_focus_aw = 0;
#line 67 "MACS_sample_kidney_box.instr"
  mccsample_stick_vacuum_focus_ah = 0;
#line 67 "MACS_sample_kidney_box.instr"
  mccsample_stick_vacuum_focus_xw = 0;
#line 67 "MACS_sample_kidney_box.instr"
  mccsample_stick_vacuum_focus_xh = 0;
#line 67 "MACS_sample_kidney_box.instr"
  mccsample_stick_vacuum_focus_r = 0;
#line 67 "MACS_sample_kidney_box.instr"
  mccsample_stick_vacuum_p_interact = 0;
#line 67 "MACS_sample_kidney_box.instr"
  if(0) strncpy(mccsample_stick_vacuum_mask_string, 0 ? 0 : "", 16384); else mccsample_stick_vacuum_mask_string[0]='\0';
#line 67 "MACS_sample_kidney_box.instr"
  if(0) strncpy(mccsample_stick_vacuum_mask_setting, 0 ? 0 : "", 16384); else mccsample_stick_vacuum_mask_setting[0]='\0';
#line 578 "MACS_sample_kidney_box.instr"
  mccsample_stick_vacuum_number_of_activations = number_of_activations_normal;
#line 91769 "MACS_sample_kidney_box.c"

  SIG_MESSAGE("sample_stick_vacuum (Init:Place/Rotate)");
  rot_set_rotation(mctr1,
#line 580 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 580 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 580 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD);
#line 91779 "MACS_sample_kidney_box.c"
  rot_mul(mctr1, mcrotacryostat_center, mcrotasample_stick_vacuum);
  rot_transpose(mcrotasample_stick_walls, mctr1);
  rot_mul(mcrotasample_stick_vacuum, mctr1, mcrotrsample_stick_vacuum);
  mctc1 = coords_set(
#line 579 "MACS_sample_kidney_box.instr"
    0,
#line 579 "MACS_sample_kidney_box.instr"
    0.55,
#line 579 "MACS_sample_kidney_box.instr"
    0);
#line 91790 "MACS_sample_kidney_box.c"
  rot_transpose(mcrotacryostat_center, mctr1);
  mctc2 = rot_apply(mctr1, mctc1);
  mcposasample_stick_vacuum = coords_add(mcposacryostat_center, mctc2);
  mctc1 = coords_sub(mcposasample_stick_walls, mcposasample_stick_vacuum);
  mcposrsample_stick_vacuum = rot_apply(mcrotasample_stick_vacuum, mctc1);
  mcDEBUG_COMPONENT("sample_stick_vacuum", mcposasample_stick_vacuum, mcrotasample_stick_vacuum)
  mccomp_posa[33] = mcposasample_stick_vacuum;
  mccomp_posr[33] = mcposrsample_stick_vacuum;
  mcNCounter[33]  = mcPCounter[33] = mcP2Counter[33] = 0;
  mcAbsorbProp[33]= 0;
    /* Component sample_rod_bottom. */
  /* Setting parameters for component sample_rod_bottom. */
  SIG_MESSAGE("sample_rod_bottom (Init:SetPar)");

  SIG_MESSAGE("sample_rod_bottom (Init:Place/Rotate)");
  rot_set_rotation(mctr1,
#line 585 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 585 "MACS_sample_kidney_box.instr"
    (85)*DEG2RAD,
#line 585 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD);
#line 91813 "MACS_sample_kidney_box.c"
  rot_mul(mctr1, mcrotacryostat_center, mcrotasample_rod_bottom);
  rot_transpose(mcrotasample_stick_vacuum, mctr1);
  rot_mul(mcrotasample_rod_bottom, mctr1, mcrotrsample_rod_bottom);
  mctc1 = coords_set(
#line 584 "MACS_sample_kidney_box.instr"
    0,
#line 584 "MACS_sample_kidney_box.instr"
    0.06 + stick_displacement,
#line 584 "MACS_sample_kidney_box.instr"
    0);
#line 91824 "MACS_sample_kidney_box.c"
  rot_transpose(mcrotacryostat_center, mctr1);
  mctc2 = rot_apply(mctr1, mctc1);
  mcposasample_rod_bottom = coords_add(mcposacryostat_center, mctc2);
  mctc1 = coords_sub(mcposasample_stick_vacuum, mcposasample_rod_bottom);
  mcposrsample_rod_bottom = rot_apply(mcrotasample_rod_bottom, mctc1);
  mcDEBUG_COMPONENT("sample_rod_bottom", mcposasample_rod_bottom, mcrotasample_rod_bottom)
  mccomp_posa[34] = mcposasample_rod_bottom;
  mccomp_posr[34] = mcposrsample_rod_bottom;
  mcNCounter[34]  = mcPCounter[34] = mcP2Counter[34] = 0;
  mcAbsorbProp[34]= 0;
    /* Component sample_rod. */
  /* Setting parameters for component sample_rod. */
  SIG_MESSAGE("sample_rod (Init:SetPar)");
#line 588 "MACS_sample_kidney_box.instr"
  if("Al") strncpy(mccsample_rod_material_string, "Al" ? "Al" : "", 16384); else mccsample_rod_material_string[0]='\0';
#line 588 "MACS_sample_kidney_box.instr"
  mccsample_rod_priority = 25;
#line 588 "MACS_sample_kidney_box.instr"
  mccsample_rod_radius = 0.0075;
#line 588 "MACS_sample_kidney_box.instr"
  mccsample_rod_yheight = 1;
#line 67 "MACS_sample_kidney_box.instr"
  mccsample_rod_visualize = 1;
#line 67 "MACS_sample_kidney_box.instr"
  mccsample_rod_target_index = 0;
#line 67 "MACS_sample_kidney_box.instr"
  mccsample_rod_target_x = 0;
#line 67 "MACS_sample_kidney_box.instr"
  mccsample_rod_target_y = 0;
#line 67 "MACS_sample_kidney_box.instr"
  mccsample_rod_target_z = 0;
#line 67 "MACS_sample_kidney_box.instr"
  mccsample_rod_focus_aw = 0;
#line 67 "MACS_sample_kidney_box.instr"
  mccsample_rod_focus_ah = 0;
#line 67 "MACS_sample_kidney_box.instr"
  mccsample_rod_focus_xw = 0;
#line 67 "MACS_sample_kidney_box.instr"
  mccsample_rod_focus_xh = 0;
#line 67 "MACS_sample_kidney_box.instr"
  mccsample_rod_focus_r = 0;
#line 67 "MACS_sample_kidney_box.instr"
  mccsample_rod_p_interact = 0;
#line 67 "MACS_sample_kidney_box.instr"
  if(0) strncpy(mccsample_rod_mask_string, 0 ? 0 : "", 16384); else mccsample_rod_mask_string[0]='\0';
#line 67 "MACS_sample_kidney_box.instr"
  if(0) strncpy(mccsample_rod_mask_setting, 0 ? 0 : "", 16384); else mccsample_rod_mask_setting[0]='\0';
#line 588 "MACS_sample_kidney_box.instr"
  mccsample_rod_number_of_activations = number_of_activations_normal;
#line 91874 "MACS_sample_kidney_box.c"

  SIG_MESSAGE("sample_rod (Init:Place/Rotate)");
  rot_set_rotation(mctr1,
#line 590 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 590 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 590 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD);
#line 91884 "MACS_sample_kidney_box.c"
  rot_mul(mctr1, mcrotasample_rod_bottom, mcrotasample_rod);
  rot_transpose(mcrotasample_rod_bottom, mctr1);
  rot_mul(mcrotasample_rod, mctr1, mcrotrsample_rod);
  mctc1 = coords_set(
#line 589 "MACS_sample_kidney_box.instr"
    0,
#line 589 "MACS_sample_kidney_box.instr"
    0.5,
#line 589 "MACS_sample_kidney_box.instr"
    0);
#line 91895 "MACS_sample_kidney_box.c"
  rot_transpose(mcrotasample_rod_bottom, mctr1);
  mctc2 = rot_apply(mctr1, mctc1);
  mcposasample_rod = coords_add(mcposasample_rod_bottom, mctc2);
  mctc1 = coords_sub(mcposasample_rod_bottom, mcposasample_rod);
  mcposrsample_rod = rot_apply(mcrotasample_rod, mctc1);
  mcDEBUG_COMPONENT("sample_rod", mcposasample_rod, mcrotasample_rod)
  mccomp_posa[35] = mcposasample_rod;
  mccomp_posr[35] = mcposrsample_rod;
  mcNCounter[35]  = mcPCounter[35] = mcP2Counter[35] = 0;
  mcAbsorbProp[35]= 0;
    /* Component sample_rod_collar_1. */
  /* Setting parameters for component sample_rod_collar_1. */
  SIG_MESSAGE("sample_rod_collar_1 (Init:SetPar)");
#line 593 "MACS_sample_kidney_box.instr"
  if("Al") strncpy(mccsample_rod_collar_1_material_string, "Al" ? "Al" : "", 16384); else mccsample_rod_collar_1_material_string[0]='\0';
#line 593 "MACS_sample_kidney_box.instr"
  mccsample_rod_collar_1_priority = 17;
#line 593 "MACS_sample_kidney_box.instr"
  mccsample_rod_collar_1_radius = 0.034;
#line 593 "MACS_sample_kidney_box.instr"
  mccsample_rod_collar_1_yheight = 0.02;
#line 67 "MACS_sample_kidney_box.instr"
  mccsample_rod_collar_1_visualize = 1;
#line 67 "MACS_sample_kidney_box.instr"
  mccsample_rod_collar_1_target_index = 0;
#line 67 "MACS_sample_kidney_box.instr"
  mccsample_rod_collar_1_target_x = 0;
#line 67 "MACS_sample_kidney_box.instr"
  mccsample_rod_collar_1_target_y = 0;
#line 67 "MACS_sample_kidney_box.instr"
  mccsample_rod_collar_1_target_z = 0;
#line 67 "MACS_sample_kidney_box.instr"
  mccsample_rod_collar_1_focus_aw = 0;
#line 67 "MACS_sample_kidney_box.instr"
  mccsample_rod_collar_1_focus_ah = 0;
#line 67 "MACS_sample_kidney_box.instr"
  mccsample_rod_collar_1_focus_xw = 0;
#line 67 "MACS_sample_kidney_box.instr"
  mccsample_rod_collar_1_focus_xh = 0;
#line 67 "MACS_sample_kidney_box.instr"
  mccsample_rod_collar_1_focus_r = 0;
#line 67 "MACS_sample_kidney_box.instr"
  mccsample_rod_collar_1_p_interact = 0;
#line 67 "MACS_sample_kidney_box.instr"
  if(0) strncpy(mccsample_rod_collar_1_mask_string, 0 ? 0 : "", 16384); else mccsample_rod_collar_1_mask_string[0]='\0';
#line 67 "MACS_sample_kidney_box.instr"
  if(0) strncpy(mccsample_rod_collar_1_mask_setting, 0 ? 0 : "", 16384); else mccsample_rod_collar_1_mask_setting[0]='\0';
#line 593 "MACS_sample_kidney_box.instr"
  mccsample_rod_collar_1_number_of_activations = number_of_activations_normal;
#line 91945 "MACS_sample_kidney_box.c"

  SIG_MESSAGE("sample_rod_collar_1 (Init:Place/Rotate)");
  rot_set_rotation(mctr1,
#line 595 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 595 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 595 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD);
#line 91955 "MACS_sample_kidney_box.c"
  rot_mul(mctr1, mcrotasample_rod_bottom, mcrotasample_rod_collar_1);
  rot_transpose(mcrotasample_rod, mctr1);
  rot_mul(mcrotasample_rod_collar_1, mctr1, mcrotrsample_rod_collar_1);
  mctc1 = coords_set(
#line 594 "MACS_sample_kidney_box.instr"
    0,
#line 594 "MACS_sample_kidney_box.instr"
    0.048,
#line 594 "MACS_sample_kidney_box.instr"
    0);
#line 91966 "MACS_sample_kidney_box.c"
  rot_transpose(mcrotasample_rod_bottom, mctr1);
  mctc2 = rot_apply(mctr1, mctc1);
  mcposasample_rod_collar_1 = coords_add(mcposasample_rod_bottom, mctc2);
  mctc1 = coords_sub(mcposasample_rod, mcposasample_rod_collar_1);
  mcposrsample_rod_collar_1 = rot_apply(mcrotasample_rod_collar_1, mctc1);
  mcDEBUG_COMPONENT("sample_rod_collar_1", mcposasample_rod_collar_1, mcrotasample_rod_collar_1)
  mccomp_posa[36] = mcposasample_rod_collar_1;
  mccomp_posr[36] = mcposrsample_rod_collar_1;
  mcNCounter[36]  = mcPCounter[36] = mcP2Counter[36] = 0;
  mcAbsorbProp[36]= 0;
    /* Component sample_rod_collar_2. */
  /* Setting parameters for component sample_rod_collar_2. */
  SIG_MESSAGE("sample_rod_collar_2 (Init:SetPar)");
#line 598 "MACS_sample_kidney_box.instr"
  if("Al") strncpy(mccsample_rod_collar_2_material_string, "Al" ? "Al" : "", 16384); else mccsample_rod_collar_2_material_string[0]='\0';
#line 598 "MACS_sample_kidney_box.instr"
  mccsample_rod_collar_2_priority = 18;
#line 598 "MACS_sample_kidney_box.instr"
  mccsample_rod_collar_2_radius = 0.034;
#line 598 "MACS_sample_kidney_box.instr"
  mccsample_rod_collar_2_yheight = 0.02;
#line 67 "MACS_sample_kidney_box.instr"
  mccsample_rod_collar_2_visualize = 1;
#line 67 "MACS_sample_kidney_box.instr"
  mccsample_rod_collar_2_target_index = 0;
#line 67 "MACS_sample_kidney_box.instr"
  mccsample_rod_collar_2_target_x = 0;
#line 67 "MACS_sample_kidney_box.instr"
  mccsample_rod_collar_2_target_y = 0;
#line 67 "MACS_sample_kidney_box.instr"
  mccsample_rod_collar_2_target_z = 0;
#line 67 "MACS_sample_kidney_box.instr"
  mccsample_rod_collar_2_focus_aw = 0;
#line 67 "MACS_sample_kidney_box.instr"
  mccsample_rod_collar_2_focus_ah = 0;
#line 67 "MACS_sample_kidney_box.instr"
  mccsample_rod_collar_2_focus_xw = 0;
#line 67 "MACS_sample_kidney_box.instr"
  mccsample_rod_collar_2_focus_xh = 0;
#line 67 "MACS_sample_kidney_box.instr"
  mccsample_rod_collar_2_focus_r = 0;
#line 67 "MACS_sample_kidney_box.instr"
  mccsample_rod_collar_2_p_interact = 0;
#line 67 "MACS_sample_kidney_box.instr"
  if(0) strncpy(mccsample_rod_collar_2_mask_string, 0 ? 0 : "", 16384); else mccsample_rod_collar_2_mask_string[0]='\0';
#line 67 "MACS_sample_kidney_box.instr"
  if(0) strncpy(mccsample_rod_collar_2_mask_setting, 0 ? 0 : "", 16384); else mccsample_rod_collar_2_mask_setting[0]='\0';
#line 598 "MACS_sample_kidney_box.instr"
  mccsample_rod_collar_2_number_of_activations = number_of_activations_normal;
#line 92016 "MACS_sample_kidney_box.c"

  SIG_MESSAGE("sample_rod_collar_2 (Init:Place/Rotate)");
  rot_set_rotation(mctr1,
#line 600 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 600 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 600 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD);
#line 92026 "MACS_sample_kidney_box.c"
  rot_mul(mctr1, mcrotasample_rod_bottom, mcrotasample_rod_collar_2);
  rot_transpose(mcrotasample_rod_collar_1, mctr1);
  rot_mul(mcrotasample_rod_collar_2, mctr1, mcrotrsample_rod_collar_2);
  mctc1 = coords_set(
#line 599 "MACS_sample_kidney_box.instr"
    0,
#line 599 "MACS_sample_kidney_box.instr"
    0.14,
#line 599 "MACS_sample_kidney_box.instr"
    0);
#line 92037 "MACS_sample_kidney_box.c"
  rot_transpose(mcrotasample_rod_bottom, mctr1);
  mctc2 = rot_apply(mctr1, mctc1);
  mcposasample_rod_collar_2 = coords_add(mcposasample_rod_bottom, mctc2);
  mctc1 = coords_sub(mcposasample_rod_collar_1, mcposasample_rod_collar_2);
  mcposrsample_rod_collar_2 = rot_apply(mcrotasample_rod_collar_2, mctc1);
  mcDEBUG_COMPONENT("sample_rod_collar_2", mcposasample_rod_collar_2, mcrotasample_rod_collar_2)
  mccomp_posa[37] = mcposasample_rod_collar_2;
  mccomp_posr[37] = mcposrsample_rod_collar_2;
  mcNCounter[37]  = mcPCounter[37] = mcP2Counter[37] = 0;
  mcAbsorbProp[37]= 0;
    /* Component sample_rod_collar_3. */
  /* Setting parameters for component sample_rod_collar_3. */
  SIG_MESSAGE("sample_rod_collar_3 (Init:SetPar)");
#line 603 "MACS_sample_kidney_box.instr"
  if("Al") strncpy(mccsample_rod_collar_3_material_string, "Al" ? "Al" : "", 16384); else mccsample_rod_collar_3_material_string[0]='\0';
#line 603 "MACS_sample_kidney_box.instr"
  mccsample_rod_collar_3_priority = 19;
#line 603 "MACS_sample_kidney_box.instr"
  mccsample_rod_collar_3_radius = 0.034;
#line 603 "MACS_sample_kidney_box.instr"
  mccsample_rod_collar_3_yheight = 0.02;
#line 67 "MACS_sample_kidney_box.instr"
  mccsample_rod_collar_3_visualize = 1;
#line 67 "MACS_sample_kidney_box.instr"
  mccsample_rod_collar_3_target_index = 0;
#line 67 "MACS_sample_kidney_box.instr"
  mccsample_rod_collar_3_target_x = 0;
#line 67 "MACS_sample_kidney_box.instr"
  mccsample_rod_collar_3_target_y = 0;
#line 67 "MACS_sample_kidney_box.instr"
  mccsample_rod_collar_3_target_z = 0;
#line 67 "MACS_sample_kidney_box.instr"
  mccsample_rod_collar_3_focus_aw = 0;
#line 67 "MACS_sample_kidney_box.instr"
  mccsample_rod_collar_3_focus_ah = 0;
#line 67 "MACS_sample_kidney_box.instr"
  mccsample_rod_collar_3_focus_xw = 0;
#line 67 "MACS_sample_kidney_box.instr"
  mccsample_rod_collar_3_focus_xh = 0;
#line 67 "MACS_sample_kidney_box.instr"
  mccsample_rod_collar_3_focus_r = 0;
#line 67 "MACS_sample_kidney_box.instr"
  mccsample_rod_collar_3_p_interact = 0;
#line 67 "MACS_sample_kidney_box.instr"
  if(0) strncpy(mccsample_rod_collar_3_mask_string, 0 ? 0 : "", 16384); else mccsample_rod_collar_3_mask_string[0]='\0';
#line 67 "MACS_sample_kidney_box.instr"
  if(0) strncpy(mccsample_rod_collar_3_mask_setting, 0 ? 0 : "", 16384); else mccsample_rod_collar_3_mask_setting[0]='\0';
#line 603 "MACS_sample_kidney_box.instr"
  mccsample_rod_collar_3_number_of_activations = number_of_activations_normal;
#line 92087 "MACS_sample_kidney_box.c"

  SIG_MESSAGE("sample_rod_collar_3 (Init:Place/Rotate)");
  rot_set_rotation(mctr1,
#line 605 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 605 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 605 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD);
#line 92097 "MACS_sample_kidney_box.c"
  rot_mul(mctr1, mcrotasample_rod_bottom, mcrotasample_rod_collar_3);
  rot_transpose(mcrotasample_rod_collar_2, mctr1);
  rot_mul(mcrotasample_rod_collar_3, mctr1, mcrotrsample_rod_collar_3);
  mctc1 = coords_set(
#line 604 "MACS_sample_kidney_box.instr"
    0,
#line 604 "MACS_sample_kidney_box.instr"
    0.34,
#line 604 "MACS_sample_kidney_box.instr"
    0);
#line 92108 "MACS_sample_kidney_box.c"
  rot_transpose(mcrotasample_rod_bottom, mctr1);
  mctc2 = rot_apply(mctr1, mctc1);
  mcposasample_rod_collar_3 = coords_add(mcposasample_rod_bottom, mctc2);
  mctc1 = coords_sub(mcposasample_rod_collar_2, mcposasample_rod_collar_3);
  mcposrsample_rod_collar_3 = rot_apply(mcrotasample_rod_collar_3, mctc1);
  mcDEBUG_COMPONENT("sample_rod_collar_3", mcposasample_rod_collar_3, mcrotasample_rod_collar_3)
  mccomp_posa[38] = mcposasample_rod_collar_3;
  mccomp_posr[38] = mcposrsample_rod_collar_3;
  mcNCounter[38]  = mcPCounter[38] = mcP2Counter[38] = 0;
  mcAbsorbProp[38]= 0;
    /* Component sample_rod_collar_4. */
  /* Setting parameters for component sample_rod_collar_4. */
  SIG_MESSAGE("sample_rod_collar_4 (Init:SetPar)");
#line 608 "MACS_sample_kidney_box.instr"
  if("Al") strncpy(mccsample_rod_collar_4_material_string, "Al" ? "Al" : "", 16384); else mccsample_rod_collar_4_material_string[0]='\0';
#line 608 "MACS_sample_kidney_box.instr"
  mccsample_rod_collar_4_priority = 20;
#line 608 "MACS_sample_kidney_box.instr"
  mccsample_rod_collar_4_radius = 0.034;
#line 608 "MACS_sample_kidney_box.instr"
  mccsample_rod_collar_4_yheight = 0.02;
#line 67 "MACS_sample_kidney_box.instr"
  mccsample_rod_collar_4_visualize = 1;
#line 67 "MACS_sample_kidney_box.instr"
  mccsample_rod_collar_4_target_index = 0;
#line 67 "MACS_sample_kidney_box.instr"
  mccsample_rod_collar_4_target_x = 0;
#line 67 "MACS_sample_kidney_box.instr"
  mccsample_rod_collar_4_target_y = 0;
#line 67 "MACS_sample_kidney_box.instr"
  mccsample_rod_collar_4_target_z = 0;
#line 67 "MACS_sample_kidney_box.instr"
  mccsample_rod_collar_4_focus_aw = 0;
#line 67 "MACS_sample_kidney_box.instr"
  mccsample_rod_collar_4_focus_ah = 0;
#line 67 "MACS_sample_kidney_box.instr"
  mccsample_rod_collar_4_focus_xw = 0;
#line 67 "MACS_sample_kidney_box.instr"
  mccsample_rod_collar_4_focus_xh = 0;
#line 67 "MACS_sample_kidney_box.instr"
  mccsample_rod_collar_4_focus_r = 0;
#line 67 "MACS_sample_kidney_box.instr"
  mccsample_rod_collar_4_p_interact = 0;
#line 67 "MACS_sample_kidney_box.instr"
  if(0) strncpy(mccsample_rod_collar_4_mask_string, 0 ? 0 : "", 16384); else mccsample_rod_collar_4_mask_string[0]='\0';
#line 67 "MACS_sample_kidney_box.instr"
  if(0) strncpy(mccsample_rod_collar_4_mask_setting, 0 ? 0 : "", 16384); else mccsample_rod_collar_4_mask_setting[0]='\0';
#line 608 "MACS_sample_kidney_box.instr"
  mccsample_rod_collar_4_number_of_activations = number_of_activations_normal;
#line 92158 "MACS_sample_kidney_box.c"

  SIG_MESSAGE("sample_rod_collar_4 (Init:Place/Rotate)");
  rot_set_rotation(mctr1,
#line 610 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 610 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 610 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD);
#line 92168 "MACS_sample_kidney_box.c"
  rot_mul(mctr1, mcrotasample_rod_bottom, mcrotasample_rod_collar_4);
  rot_transpose(mcrotasample_rod_collar_3, mctr1);
  rot_mul(mcrotasample_rod_collar_4, mctr1, mcrotrsample_rod_collar_4);
  mctc1 = coords_set(
#line 609 "MACS_sample_kidney_box.instr"
    0,
#line 609 "MACS_sample_kidney_box.instr"
    0.635,
#line 609 "MACS_sample_kidney_box.instr"
    0);
#line 92179 "MACS_sample_kidney_box.c"
  rot_transpose(mcrotasample_rod_bottom, mctr1);
  mctc2 = rot_apply(mctr1, mctc1);
  mcposasample_rod_collar_4 = coords_add(mcposasample_rod_bottom, mctc2);
  mctc1 = coords_sub(mcposasample_rod_collar_3, mcposasample_rod_collar_4);
  mcposrsample_rod_collar_4 = rot_apply(mcrotasample_rod_collar_4, mctc1);
  mcDEBUG_COMPONENT("sample_rod_collar_4", mcposasample_rod_collar_4, mcrotasample_rod_collar_4)
  mccomp_posa[39] = mcposasample_rod_collar_4;
  mccomp_posr[39] = mcposrsample_rod_collar_4;
  mcNCounter[39]  = mcPCounter[39] = mcP2Counter[39] = 0;
  mcAbsorbProp[39]= 0;
    /* Component sample_rod_collar_1_vacuum. */
  /* Setting parameters for component sample_rod_collar_1_vacuum. */
  SIG_MESSAGE("sample_rod_collar_1_vacuum (Init:SetPar)");
#line 613 "MACS_sample_kidney_box.instr"
  if("Vacuum") strncpy(mccsample_rod_collar_1_vacuum_material_string, "Vacuum" ? "Vacuum" : "", 16384); else mccsample_rod_collar_1_vacuum_material_string[0]='\0';
#line 613 "MACS_sample_kidney_box.instr"
  mccsample_rod_collar_1_vacuum_priority = 21;
#line 613 "MACS_sample_kidney_box.instr"
  mccsample_rod_collar_1_vacuum_radius = 0.03;
#line 613 "MACS_sample_kidney_box.instr"
  mccsample_rod_collar_1_vacuum_yheight = 0.016;
#line 67 "MACS_sample_kidney_box.instr"
  mccsample_rod_collar_1_vacuum_visualize = 1;
#line 67 "MACS_sample_kidney_box.instr"
  mccsample_rod_collar_1_vacuum_target_index = 0;
#line 67 "MACS_sample_kidney_box.instr"
  mccsample_rod_collar_1_vacuum_target_x = 0;
#line 67 "MACS_sample_kidney_box.instr"
  mccsample_rod_collar_1_vacuum_target_y = 0;
#line 67 "MACS_sample_kidney_box.instr"
  mccsample_rod_collar_1_vacuum_target_z = 0;
#line 67 "MACS_sample_kidney_box.instr"
  mccsample_rod_collar_1_vacuum_focus_aw = 0;
#line 67 "MACS_sample_kidney_box.instr"
  mccsample_rod_collar_1_vacuum_focus_ah = 0;
#line 67 "MACS_sample_kidney_box.instr"
  mccsample_rod_collar_1_vacuum_focus_xw = 0;
#line 67 "MACS_sample_kidney_box.instr"
  mccsample_rod_collar_1_vacuum_focus_xh = 0;
#line 67 "MACS_sample_kidney_box.instr"
  mccsample_rod_collar_1_vacuum_focus_r = 0;
#line 67 "MACS_sample_kidney_box.instr"
  mccsample_rod_collar_1_vacuum_p_interact = 0;
#line 67 "MACS_sample_kidney_box.instr"
  if(0) strncpy(mccsample_rod_collar_1_vacuum_mask_string, 0 ? 0 : "", 16384); else mccsample_rod_collar_1_vacuum_mask_string[0]='\0';
#line 67 "MACS_sample_kidney_box.instr"
  if(0) strncpy(mccsample_rod_collar_1_vacuum_mask_setting, 0 ? 0 : "", 16384); else mccsample_rod_collar_1_vacuum_mask_setting[0]='\0';
#line 613 "MACS_sample_kidney_box.instr"
  mccsample_rod_collar_1_vacuum_number_of_activations = number_of_activations_normal;
#line 92229 "MACS_sample_kidney_box.c"

  SIG_MESSAGE("sample_rod_collar_1_vacuum (Init:Place/Rotate)");
  rot_set_rotation(mctr1,
#line 615 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 615 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 615 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD);
#line 92239 "MACS_sample_kidney_box.c"
  rot_mul(mctr1, mcrotasample_rod_bottom, mcrotasample_rod_collar_1_vacuum);
  rot_transpose(mcrotasample_rod_collar_4, mctr1);
  rot_mul(mcrotasample_rod_collar_1_vacuum, mctr1, mcrotrsample_rod_collar_1_vacuum);
  mctc1 = coords_set(
#line 614 "MACS_sample_kidney_box.instr"
    0,
#line 614 "MACS_sample_kidney_box.instr"
    0.048 -0.005,
#line 614 "MACS_sample_kidney_box.instr"
    0);
#line 92250 "MACS_sample_kidney_box.c"
  rot_transpose(mcrotasample_rod_bottom, mctr1);
  mctc2 = rot_apply(mctr1, mctc1);
  mcposasample_rod_collar_1_vacuum = coords_add(mcposasample_rod_bottom, mctc2);
  mctc1 = coords_sub(mcposasample_rod_collar_4, mcposasample_rod_collar_1_vacuum);
  mcposrsample_rod_collar_1_vacuum = rot_apply(mcrotasample_rod_collar_1_vacuum, mctc1);
  mcDEBUG_COMPONENT("sample_rod_collar_1_vacuum", mcposasample_rod_collar_1_vacuum, mcrotasample_rod_collar_1_vacuum)
  mccomp_posa[40] = mcposasample_rod_collar_1_vacuum;
  mccomp_posr[40] = mcposrsample_rod_collar_1_vacuum;
  mcNCounter[40]  = mcPCounter[40] = mcP2Counter[40] = 0;
  mcAbsorbProp[40]= 0;
    /* Component sample_rod_collar_2_vacuum. */
  /* Setting parameters for component sample_rod_collar_2_vacuum. */
  SIG_MESSAGE("sample_rod_collar_2_vacuum (Init:SetPar)");
#line 618 "MACS_sample_kidney_box.instr"
  if("Vacuum") strncpy(mccsample_rod_collar_2_vacuum_material_string, "Vacuum" ? "Vacuum" : "", 16384); else mccsample_rod_collar_2_vacuum_material_string[0]='\0';
#line 618 "MACS_sample_kidney_box.instr"
  mccsample_rod_collar_2_vacuum_priority = 22;
#line 618 "MACS_sample_kidney_box.instr"
  mccsample_rod_collar_2_vacuum_radius = 0.03;
#line 618 "MACS_sample_kidney_box.instr"
  mccsample_rod_collar_2_vacuum_yheight = 0.016;
#line 67 "MACS_sample_kidney_box.instr"
  mccsample_rod_collar_2_vacuum_visualize = 1;
#line 67 "MACS_sample_kidney_box.instr"
  mccsample_rod_collar_2_vacuum_target_index = 0;
#line 67 "MACS_sample_kidney_box.instr"
  mccsample_rod_collar_2_vacuum_target_x = 0;
#line 67 "MACS_sample_kidney_box.instr"
  mccsample_rod_collar_2_vacuum_target_y = 0;
#line 67 "MACS_sample_kidney_box.instr"
  mccsample_rod_collar_2_vacuum_target_z = 0;
#line 67 "MACS_sample_kidney_box.instr"
  mccsample_rod_collar_2_vacuum_focus_aw = 0;
#line 67 "MACS_sample_kidney_box.instr"
  mccsample_rod_collar_2_vacuum_focus_ah = 0;
#line 67 "MACS_sample_kidney_box.instr"
  mccsample_rod_collar_2_vacuum_focus_xw = 0;
#line 67 "MACS_sample_kidney_box.instr"
  mccsample_rod_collar_2_vacuum_focus_xh = 0;
#line 67 "MACS_sample_kidney_box.instr"
  mccsample_rod_collar_2_vacuum_focus_r = 0;
#line 67 "MACS_sample_kidney_box.instr"
  mccsample_rod_collar_2_vacuum_p_interact = 0;
#line 67 "MACS_sample_kidney_box.instr"
  if(0) strncpy(mccsample_rod_collar_2_vacuum_mask_string, 0 ? 0 : "", 16384); else mccsample_rod_collar_2_vacuum_mask_string[0]='\0';
#line 67 "MACS_sample_kidney_box.instr"
  if(0) strncpy(mccsample_rod_collar_2_vacuum_mask_setting, 0 ? 0 : "", 16384); else mccsample_rod_collar_2_vacuum_mask_setting[0]='\0';
#line 618 "MACS_sample_kidney_box.instr"
  mccsample_rod_collar_2_vacuum_number_of_activations = number_of_activations_normal;
#line 92300 "MACS_sample_kidney_box.c"

  SIG_MESSAGE("sample_rod_collar_2_vacuum (Init:Place/Rotate)");
  rot_set_rotation(mctr1,
#line 620 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 620 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 620 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD);
#line 92310 "MACS_sample_kidney_box.c"
  rot_mul(mctr1, mcrotasample_rod_bottom, mcrotasample_rod_collar_2_vacuum);
  rot_transpose(mcrotasample_rod_collar_1_vacuum, mctr1);
  rot_mul(mcrotasample_rod_collar_2_vacuum, mctr1, mcrotrsample_rod_collar_2_vacuum);
  mctc1 = coords_set(
#line 619 "MACS_sample_kidney_box.instr"
    0,
#line 619 "MACS_sample_kidney_box.instr"
    0.14 -0.005,
#line 619 "MACS_sample_kidney_box.instr"
    0);
#line 92321 "MACS_sample_kidney_box.c"
  rot_transpose(mcrotasample_rod_bottom, mctr1);
  mctc2 = rot_apply(mctr1, mctc1);
  mcposasample_rod_collar_2_vacuum = coords_add(mcposasample_rod_bottom, mctc2);
  mctc1 = coords_sub(mcposasample_rod_collar_1_vacuum, mcposasample_rod_collar_2_vacuum);
  mcposrsample_rod_collar_2_vacuum = rot_apply(mcrotasample_rod_collar_2_vacuum, mctc1);
  mcDEBUG_COMPONENT("sample_rod_collar_2_vacuum", mcposasample_rod_collar_2_vacuum, mcrotasample_rod_collar_2_vacuum)
  mccomp_posa[41] = mcposasample_rod_collar_2_vacuum;
  mccomp_posr[41] = mcposrsample_rod_collar_2_vacuum;
  mcNCounter[41]  = mcPCounter[41] = mcP2Counter[41] = 0;
  mcAbsorbProp[41]= 0;
    /* Component sample_rod_collar_3_vacuum. */
  /* Setting parameters for component sample_rod_collar_3_vacuum. */
  SIG_MESSAGE("sample_rod_collar_3_vacuum (Init:SetPar)");
#line 623 "MACS_sample_kidney_box.instr"
  if("Vacuum") strncpy(mccsample_rod_collar_3_vacuum_material_string, "Vacuum" ? "Vacuum" : "", 16384); else mccsample_rod_collar_3_vacuum_material_string[0]='\0';
#line 623 "MACS_sample_kidney_box.instr"
  mccsample_rod_collar_3_vacuum_priority = 23;
#line 623 "MACS_sample_kidney_box.instr"
  mccsample_rod_collar_3_vacuum_radius = 0.03;
#line 623 "MACS_sample_kidney_box.instr"
  mccsample_rod_collar_3_vacuum_yheight = 0.016;
#line 67 "MACS_sample_kidney_box.instr"
  mccsample_rod_collar_3_vacuum_visualize = 1;
#line 67 "MACS_sample_kidney_box.instr"
  mccsample_rod_collar_3_vacuum_target_index = 0;
#line 67 "MACS_sample_kidney_box.instr"
  mccsample_rod_collar_3_vacuum_target_x = 0;
#line 67 "MACS_sample_kidney_box.instr"
  mccsample_rod_collar_3_vacuum_target_y = 0;
#line 67 "MACS_sample_kidney_box.instr"
  mccsample_rod_collar_3_vacuum_target_z = 0;
#line 67 "MACS_sample_kidney_box.instr"
  mccsample_rod_collar_3_vacuum_focus_aw = 0;
#line 67 "MACS_sample_kidney_box.instr"
  mccsample_rod_collar_3_vacuum_focus_ah = 0;
#line 67 "MACS_sample_kidney_box.instr"
  mccsample_rod_collar_3_vacuum_focus_xw = 0;
#line 67 "MACS_sample_kidney_box.instr"
  mccsample_rod_collar_3_vacuum_focus_xh = 0;
#line 67 "MACS_sample_kidney_box.instr"
  mccsample_rod_collar_3_vacuum_focus_r = 0;
#line 67 "MACS_sample_kidney_box.instr"
  mccsample_rod_collar_3_vacuum_p_interact = 0;
#line 67 "MACS_sample_kidney_box.instr"
  if(0) strncpy(mccsample_rod_collar_3_vacuum_mask_string, 0 ? 0 : "", 16384); else mccsample_rod_collar_3_vacuum_mask_string[0]='\0';
#line 67 "MACS_sample_kidney_box.instr"
  if(0) strncpy(mccsample_rod_collar_3_vacuum_mask_setting, 0 ? 0 : "", 16384); else mccsample_rod_collar_3_vacuum_mask_setting[0]='\0';
#line 623 "MACS_sample_kidney_box.instr"
  mccsample_rod_collar_3_vacuum_number_of_activations = number_of_activations_normal;
#line 92371 "MACS_sample_kidney_box.c"

  SIG_MESSAGE("sample_rod_collar_3_vacuum (Init:Place/Rotate)");
  rot_set_rotation(mctr1,
#line 625 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 625 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 625 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD);
#line 92381 "MACS_sample_kidney_box.c"
  rot_mul(mctr1, mcrotasample_rod_bottom, mcrotasample_rod_collar_3_vacuum);
  rot_transpose(mcrotasample_rod_collar_2_vacuum, mctr1);
  rot_mul(mcrotasample_rod_collar_3_vacuum, mctr1, mcrotrsample_rod_collar_3_vacuum);
  mctc1 = coords_set(
#line 624 "MACS_sample_kidney_box.instr"
    0,
#line 624 "MACS_sample_kidney_box.instr"
    0.34 -0.005,
#line 624 "MACS_sample_kidney_box.instr"
    0);
#line 92392 "MACS_sample_kidney_box.c"
  rot_transpose(mcrotasample_rod_bottom, mctr1);
  mctc2 = rot_apply(mctr1, mctc1);
  mcposasample_rod_collar_3_vacuum = coords_add(mcposasample_rod_bottom, mctc2);
  mctc1 = coords_sub(mcposasample_rod_collar_2_vacuum, mcposasample_rod_collar_3_vacuum);
  mcposrsample_rod_collar_3_vacuum = rot_apply(mcrotasample_rod_collar_3_vacuum, mctc1);
  mcDEBUG_COMPONENT("sample_rod_collar_3_vacuum", mcposasample_rod_collar_3_vacuum, mcrotasample_rod_collar_3_vacuum)
  mccomp_posa[42] = mcposasample_rod_collar_3_vacuum;
  mccomp_posr[42] = mcposrsample_rod_collar_3_vacuum;
  mcNCounter[42]  = mcPCounter[42] = mcP2Counter[42] = 0;
  mcAbsorbProp[42]= 0;
    /* Component sample_rod_collar_4_vacuum. */
  /* Setting parameters for component sample_rod_collar_4_vacuum. */
  SIG_MESSAGE("sample_rod_collar_4_vacuum (Init:SetPar)");
#line 628 "MACS_sample_kidney_box.instr"
  if("Vacuum") strncpy(mccsample_rod_collar_4_vacuum_material_string, "Vacuum" ? "Vacuum" : "", 16384); else mccsample_rod_collar_4_vacuum_material_string[0]='\0';
#line 628 "MACS_sample_kidney_box.instr"
  mccsample_rod_collar_4_vacuum_priority = 24;
#line 628 "MACS_sample_kidney_box.instr"
  mccsample_rod_collar_4_vacuum_radius = 0.03;
#line 628 "MACS_sample_kidney_box.instr"
  mccsample_rod_collar_4_vacuum_yheight = 0.016;
#line 67 "MACS_sample_kidney_box.instr"
  mccsample_rod_collar_4_vacuum_visualize = 1;
#line 67 "MACS_sample_kidney_box.instr"
  mccsample_rod_collar_4_vacuum_target_index = 0;
#line 67 "MACS_sample_kidney_box.instr"
  mccsample_rod_collar_4_vacuum_target_x = 0;
#line 67 "MACS_sample_kidney_box.instr"
  mccsample_rod_collar_4_vacuum_target_y = 0;
#line 67 "MACS_sample_kidney_box.instr"
  mccsample_rod_collar_4_vacuum_target_z = 0;
#line 67 "MACS_sample_kidney_box.instr"
  mccsample_rod_collar_4_vacuum_focus_aw = 0;
#line 67 "MACS_sample_kidney_box.instr"
  mccsample_rod_collar_4_vacuum_focus_ah = 0;
#line 67 "MACS_sample_kidney_box.instr"
  mccsample_rod_collar_4_vacuum_focus_xw = 0;
#line 67 "MACS_sample_kidney_box.instr"
  mccsample_rod_collar_4_vacuum_focus_xh = 0;
#line 67 "MACS_sample_kidney_box.instr"
  mccsample_rod_collar_4_vacuum_focus_r = 0;
#line 67 "MACS_sample_kidney_box.instr"
  mccsample_rod_collar_4_vacuum_p_interact = 0;
#line 67 "MACS_sample_kidney_box.instr"
  if(0) strncpy(mccsample_rod_collar_4_vacuum_mask_string, 0 ? 0 : "", 16384); else mccsample_rod_collar_4_vacuum_mask_string[0]='\0';
#line 67 "MACS_sample_kidney_box.instr"
  if(0) strncpy(mccsample_rod_collar_4_vacuum_mask_setting, 0 ? 0 : "", 16384); else mccsample_rod_collar_4_vacuum_mask_setting[0]='\0';
#line 628 "MACS_sample_kidney_box.instr"
  mccsample_rod_collar_4_vacuum_number_of_activations = number_of_activations_normal;
#line 92442 "MACS_sample_kidney_box.c"

  SIG_MESSAGE("sample_rod_collar_4_vacuum (Init:Place/Rotate)");
  rot_set_rotation(mctr1,
#line 630 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 630 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 630 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD);
#line 92452 "MACS_sample_kidney_box.c"
  rot_mul(mctr1, mcrotasample_rod_bottom, mcrotasample_rod_collar_4_vacuum);
  rot_transpose(mcrotasample_rod_collar_3_vacuum, mctr1);
  rot_mul(mcrotasample_rod_collar_4_vacuum, mctr1, mcrotrsample_rod_collar_4_vacuum);
  mctc1 = coords_set(
#line 629 "MACS_sample_kidney_box.instr"
    0,
#line 629 "MACS_sample_kidney_box.instr"
    0.635 -0.005,
#line 629 "MACS_sample_kidney_box.instr"
    0);
#line 92463 "MACS_sample_kidney_box.c"
  rot_transpose(mcrotasample_rod_bottom, mctr1);
  mctc2 = rot_apply(mctr1, mctc1);
  mcposasample_rod_collar_4_vacuum = coords_add(mcposasample_rod_bottom, mctc2);
  mctc1 = coords_sub(mcposasample_rod_collar_3_vacuum, mcposasample_rod_collar_4_vacuum);
  mcposrsample_rod_collar_4_vacuum = rot_apply(mcrotasample_rod_collar_4_vacuum, mctc1);
  mcDEBUG_COMPONENT("sample_rod_collar_4_vacuum", mcposasample_rod_collar_4_vacuum, mcrotasample_rod_collar_4_vacuum)
  mccomp_posa[43] = mcposasample_rod_collar_4_vacuum;
  mccomp_posr[43] = mcposrsample_rod_collar_4_vacuum;
  mcNCounter[43]  = mcPCounter[43] = mcP2Counter[43] = 0;
  mcAbsorbProp[43]= 0;
    /* Component resolution_sample_exit. */
  /* Setting parameters for component resolution_sample_exit. */
  SIG_MESSAGE("resolution_sample_exit (Init:SetPar)");
#line 636 "MACS_sample_kidney_box.instr"
  if("Exit") strncpy(mccresolution_sample_exit_material_string, "Exit" ? "Exit" : "", 16384); else mccresolution_sample_exit_material_string[0]='\0';
#line 635 "MACS_sample_kidney_box.instr"
  mccresolution_sample_exit_priority = 51;
#line 635 "MACS_sample_kidney_box.instr"
  mccresolution_sample_exit_radius = 1.01 * mcipres_radius;
#line 635 "MACS_sample_kidney_box.instr"
  mccresolution_sample_exit_yheight = 1.01 * mcipres_height;
#line 67 "MACS_sample_kidney_box.instr"
  mccresolution_sample_exit_visualize = 1;
#line 67 "MACS_sample_kidney_box.instr"
  mccresolution_sample_exit_target_index = 0;
#line 67 "MACS_sample_kidney_box.instr"
  mccresolution_sample_exit_target_x = 0;
#line 67 "MACS_sample_kidney_box.instr"
  mccresolution_sample_exit_target_y = 0;
#line 67 "MACS_sample_kidney_box.instr"
  mccresolution_sample_exit_target_z = 0;
#line 67 "MACS_sample_kidney_box.instr"
  mccresolution_sample_exit_focus_aw = 0;
#line 67 "MACS_sample_kidney_box.instr"
  mccresolution_sample_exit_focus_ah = 0;
#line 67 "MACS_sample_kidney_box.instr"
  mccresolution_sample_exit_focus_xw = 0;
#line 67 "MACS_sample_kidney_box.instr"
  mccresolution_sample_exit_focus_xh = 0;
#line 67 "MACS_sample_kidney_box.instr"
  mccresolution_sample_exit_focus_r = 0;
#line 67 "MACS_sample_kidney_box.instr"
  mccresolution_sample_exit_p_interact = 0;
#line 67 "MACS_sample_kidney_box.instr"
  if(0) strncpy(mccresolution_sample_exit_mask_string, 0 ? 0 : "", 16384); else mccresolution_sample_exit_mask_string[0]='\0';
#line 67 "MACS_sample_kidney_box.instr"
  if(0) strncpy(mccresolution_sample_exit_mask_setting, 0 ? 0 : "", 16384); else mccresolution_sample_exit_mask_setting[0]='\0';
#line 636 "MACS_sample_kidney_box.instr"
  mccresolution_sample_exit_number_of_activations = number_of_activations_exit;
#line 92513 "MACS_sample_kidney_box.c"

  SIG_MESSAGE("resolution_sample_exit (Init:Place/Rotate)");
  rot_set_rotation(mctr1,
#line 638 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 638 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 638 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD);
#line 92523 "MACS_sample_kidney_box.c"
  rot_mul(mctr1, mcrotatarget, mcrotaresolution_sample_exit);
  rot_transpose(mcrotasample_rod_collar_4_vacuum, mctr1);
  rot_mul(mcrotaresolution_sample_exit, mctr1, mcrotrresolution_sample_exit);
  mctc1 = coords_set(
#line 637 "MACS_sample_kidney_box.instr"
    0,
#line 637 "MACS_sample_kidney_box.instr"
    0,
#line 637 "MACS_sample_kidney_box.instr"
    0);
#line 92534 "MACS_sample_kidney_box.c"
  rot_transpose(mcrotatarget, mctr1);
  mctc2 = rot_apply(mctr1, mctc1);
  mcposaresolution_sample_exit = coords_add(mcposatarget, mctc2);
  mctc1 = coords_sub(mcposasample_rod_collar_4_vacuum, mcposaresolution_sample_exit);
  mcposrresolution_sample_exit = rot_apply(mcrotaresolution_sample_exit, mctc1);
  mcDEBUG_COMPONENT("resolution_sample_exit", mcposaresolution_sample_exit, mcrotaresolution_sample_exit)
  mccomp_posa[44] = mcposaresolution_sample_exit;
  mccomp_posr[44] = mcposrresolution_sample_exit;
  mcNCounter[44]  = mcPCounter[44] = mcP2Counter[44] = 0;
  mcAbsorbProp[44]= 0;
    /* Component sample_cryostat. */
  /* Setting parameters for component sample_cryostat. */
  SIG_MESSAGE("sample_cryostat (Init:SetPar)");
#line 45 "MACS_sample_kidney_box.instr"
  mccsample_cryostat_allow_inside_start = 0;
#line 45 "MACS_sample_kidney_box.instr"
  mccsample_cryostat_history_limit = 300000;
#line 727 "MACS_sample_kidney_box.instr"
  mccsample_cryostat_enable_conditionals = 0;
#line 45 "MACS_sample_kidney_box.instr"
  mccsample_cryostat_inherit_number_of_scattering_events = 0;
#line 92556 "MACS_sample_kidney_box.c"

  SIG_MESSAGE("sample_cryostat (Init:Place/Rotate)");
  rot_set_rotation(mctr1,
    (0.0)*DEG2RAD,
    (0.0)*DEG2RAD,
    (0.0)*DEG2RAD);
#line 92563 "MACS_sample_kidney_box.c"
  rot_mul(mctr1, mcrotatarget, mcrotasample_cryostat);
  rot_transpose(mcrotaresolution_sample_exit, mctr1);
  rot_mul(mcrotasample_cryostat, mctr1, mcrotrsample_cryostat);
  mctc1 = coords_set(
#line 728 "MACS_sample_kidney_box.instr"
    0,
#line 728 "MACS_sample_kidney_box.instr"
    0,
#line 728 "MACS_sample_kidney_box.instr"
    0);
#line 92574 "MACS_sample_kidney_box.c"
  rot_transpose(mcrotatarget, mctr1);
  mctc2 = rot_apply(mctr1, mctc1);
  mcposasample_cryostat = coords_add(mcposatarget, mctc2);
  mctc1 = coords_sub(mcposaresolution_sample_exit, mcposasample_cryostat);
  mcposrsample_cryostat = rot_apply(mcrotasample_cryostat, mctc1);
  mcDEBUG_COMPONENT("sample_cryostat", mcposasample_cryostat, mcrotasample_cryostat)
  mccomp_posa[45] = mcposasample_cryostat;
  mccomp_posr[45] = mcposrsample_cryostat;
  mcNCounter[45]  = mcPCounter[45] = mcP2Counter[45] = 0;
  mcAbsorbProp[45]= 0;
    /* Component Resolution_sample. */
  /* Setting parameters for component Resolution_sample. */
  SIG_MESSAGE("Resolution_sample (Init:SetPar)");
#line 742 "MACS_sample_kidney_box.instr"
  mccResolution_sample_thickness = 0.008;
#line 742 "MACS_sample_kidney_box.instr"
  mccResolution_sample_radius = mcipres_radius;
#line 64 "MACS_sample_kidney_box.instr"
  mccResolution_sample_focus_r = 0.05;
#line 742 "MACS_sample_kidney_box.instr"
  mccResolution_sample_E0 = mcipE0_resolution;
#line 742 "MACS_sample_kidney_box.instr"
  mccResolution_sample_dE = mcipdE_resolution;
#line 743 "MACS_sample_kidney_box.instr"
  mccResolution_sample_target_x = sin ( DEG2RAD * mcipkidney_angle );
#line 743 "MACS_sample_kidney_box.instr"
  mccResolution_sample_target_y = 0;
#line 743 "MACS_sample_kidney_box.instr"
  mccResolution_sample_target_z = cos ( DEG2RAD * mcipkidney_angle );
#line 65 "MACS_sample_kidney_box.instr"
  mccResolution_sample_focus_xw = 0;
#line 65 "MACS_sample_kidney_box.instr"
  mccResolution_sample_focus_yh = 0;
#line 743 "MACS_sample_kidney_box.instr"
  mccResolution_sample_focus_aw = 155;
#line 743 "MACS_sample_kidney_box.instr"
  mccResolution_sample_focus_ah = 10;
#line 66 "MACS_sample_kidney_box.instr"
  mccResolution_sample_xwidth = 0;
#line 742 "MACS_sample_kidney_box.instr"
  mccResolution_sample_yheight = mcipres_height;
#line 66 "MACS_sample_kidney_box.instr"
  mccResolution_sample_zdepth = 0;
#line 66 "MACS_sample_kidney_box.instr"
  mccResolution_sample_target_index = 0;
#line 92620 "MACS_sample_kidney_box.c"

  SIG_MESSAGE("Resolution_sample (Init:Place/Rotate)");
  rot_set_rotation(mctr1,
    (0.0)*DEG2RAD,
    (0.0)*DEG2RAD,
    (0.0)*DEG2RAD);
#line 92627 "MACS_sample_kidney_box.c"
  rot_mul(mctr1, mcrotatarget, mcrotaResolution_sample);
  rot_transpose(mcrotasample_cryostat, mctr1);
  rot_mul(mcrotaResolution_sample, mctr1, mcrotrResolution_sample);
  mctc1 = coords_set(
#line 745 "MACS_sample_kidney_box.instr"
    0,
#line 745 "MACS_sample_kidney_box.instr"
    0,
#line 745 "MACS_sample_kidney_box.instr"
    0);
#line 92638 "MACS_sample_kidney_box.c"
  rot_transpose(mcrotatarget, mctr1);
  mctc2 = rot_apply(mctr1, mctc1);
  mcposaResolution_sample = coords_add(mcposatarget, mctc2);
  mctc1 = coords_sub(mcposasample_cryostat, mcposaResolution_sample);
  mcposrResolution_sample = rot_apply(mcrotaResolution_sample, mctc1);
  mcDEBUG_COMPONENT("Resolution_sample", mcposaResolution_sample, mcrotaResolution_sample)
  mccomp_posa[46] = mcposaResolution_sample;
  mccomp_posr[46] = mcposrResolution_sample;
  mcNCounter[46]  = mcPCounter[46] = mcP2Counter[46] = 0;
  mcAbsorbProp[46]= 0;
    /* Component post_sample_beamstop. */
  /* Setting parameters for component post_sample_beamstop. */
  SIG_MESSAGE("post_sample_beamstop (Init:SetPar)");
#line 44 "MACS_sample_kidney_box.instr"
  mccpost_sample_beamstop_xmin = -0.05;
#line 44 "MACS_sample_kidney_box.instr"
  mccpost_sample_beamstop_xmax = 0.05;
#line 44 "MACS_sample_kidney_box.instr"
  mccpost_sample_beamstop_ymin = -0.05;
#line 44 "MACS_sample_kidney_box.instr"
  mccpost_sample_beamstop_ymax = 0.05;
#line 784 "MACS_sample_kidney_box.instr"
  mccpost_sample_beamstop_xwidth = 0.04;
#line 784 "MACS_sample_kidney_box.instr"
  mccpost_sample_beamstop_yheight = 0.15;
#line 45 "MACS_sample_kidney_box.instr"
  mccpost_sample_beamstop_radius = 0;
#line 92666 "MACS_sample_kidney_box.c"

  SIG_MESSAGE("post_sample_beamstop (Init:Place/Rotate)");
  rot_set_rotation(mctr1,
#line 786 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 786 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 786 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD);
#line 92676 "MACS_sample_kidney_box.c"
  rot_mul(mctr1, mcrotatarget, mcrotapost_sample_beamstop);
  rot_transpose(mcrotaResolution_sample, mctr1);
  rot_mul(mcrotapost_sample_beamstop, mctr1, mcrotrpost_sample_beamstop);
  mctc1 = coords_set(
#line 785 "MACS_sample_kidney_box.instr"
    0,
#line 785 "MACS_sample_kidney_box.instr"
    0,
#line 785 "MACS_sample_kidney_box.instr"
    0.22);
#line 92687 "MACS_sample_kidney_box.c"
  rot_transpose(mcrotatarget, mctr1);
  mctc2 = rot_apply(mctr1, mctc1);
  mcposapost_sample_beamstop = coords_add(mcposatarget, mctc2);
  mctc1 = coords_sub(mcposaResolution_sample, mcposapost_sample_beamstop);
  mcposrpost_sample_beamstop = rot_apply(mcrotapost_sample_beamstop, mctc1);
  mcDEBUG_COMPONENT("post_sample_beamstop", mcposapost_sample_beamstop, mcrotapost_sample_beamstop)
  mccomp_posa[47] = mcposapost_sample_beamstop;
  mccomp_posr[47] = mcposrpost_sample_beamstop;
  mcNCounter[47]  = mcPCounter[47] = mcP2Counter[47] = 0;
  mcAbsorbProp[47]= 0;
    /* Component kidney_master. */
  /* Setting parameters for component kidney_master. */
  SIG_MESSAGE("kidney_master (Init:SetPar)");

  SIG_MESSAGE("kidney_master (Init:Place/Rotate)");
  rot_set_rotation(mctr1,
#line 4 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 4 "MACS_sample_kidney_box.instr"
    (mcipkidney_angle)*DEG2RAD,
#line 4 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD);
#line 92710 "MACS_sample_kidney_box.c"
  rot_mul(mctr1, mcrotatarget, mcrotakidney_master);
  rot_transpose(mcrotapost_sample_beamstop, mctr1);
  rot_mul(mcrotakidney_master, mctr1, mcrotrkidney_master);
  mctc1 = coords_set(
#line 3 "MACS_sample_kidney_box.instr"
    0,
#line 3 "MACS_sample_kidney_box.instr"
    0,
#line 3 "MACS_sample_kidney_box.instr"
    0);
#line 92721 "MACS_sample_kidney_box.c"
  rot_transpose(mcrotatarget, mctr1);
  mctc2 = rot_apply(mctr1, mctc1);
  mcposakidney_master = coords_add(mcposatarget, mctc2);
  mctc1 = coords_sub(mcposapost_sample_beamstop, mcposakidney_master);
  mcposrkidney_master = rot_apply(mcrotakidney_master, mctc1);
  mcDEBUG_COMPONENT("kidney_master", mcposakidney_master, mcrotakidney_master)
  mccomp_posa[48] = mcposakidney_master;
  mccomp_posr[48] = mcposrkidney_master;
  mcNCounter[48]  = mcPCounter[48] = mcP2Counter[48] = 0;
  mcAbsorbProp[48]= 0;
    /* Component kidney_channel_0. */
  /* Setting parameters for component kidney_channel_0. */
  SIG_MESSAGE("kidney_channel_0 (Init:SetPar)");

  SIG_MESSAGE("kidney_channel_0 (Init:Place/Rotate)");
  rot_set_rotation(mctr1,
#line 12 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 12 "MACS_sample_kidney_box.instr"
    (-76)*DEG2RAD,
#line 12 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD);
#line 92744 "MACS_sample_kidney_box.c"
  rot_mul(mctr1, mcrotakidney_master, mcrotakidney_channel_0);
  rot_transpose(mcrotakidney_master, mctr1);
  rot_mul(mcrotakidney_channel_0, mctr1, mcrotrkidney_channel_0);
  mctc1 = coords_set(
#line 11 "MACS_sample_kidney_box.instr"
    0,
#line 11 "MACS_sample_kidney_box.instr"
    0,
#line 11 "MACS_sample_kidney_box.instr"
    0);
#line 92755 "MACS_sample_kidney_box.c"
  rot_transpose(mcrotakidney_master, mctr1);
  mctc2 = rot_apply(mctr1, mctc1);
  mcposakidney_channel_0 = coords_add(mcposakidney_master, mctc2);
  mctc1 = coords_sub(mcposakidney_master, mcposakidney_channel_0);
  mcposrkidney_channel_0 = rot_apply(mcrotakidney_channel_0, mctc1);
  mcDEBUG_COMPONENT("kidney_channel_0", mcposakidney_channel_0, mcrotakidney_channel_0)
  mccomp_posa[49] = mcposakidney_channel_0;
  mccomp_posr[49] = mcposrkidney_channel_0;
  mcNCounter[49]  = mcPCounter[49] = mcP2Counter[49] = 0;
  mcAbsorbProp[49]= 0;
    /* Component kidney_channel_1. */
  /* Setting parameters for component kidney_channel_1. */
  SIG_MESSAGE("kidney_channel_1 (Init:SetPar)");

  SIG_MESSAGE("kidney_channel_1 (Init:Place/Rotate)");
  rot_set_rotation(mctr1,
#line 16 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 16 "MACS_sample_kidney_box.instr"
    (-68)*DEG2RAD,
#line 16 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD);
#line 92778 "MACS_sample_kidney_box.c"
  rot_mul(mctr1, mcrotakidney_master, mcrotakidney_channel_1);
  rot_transpose(mcrotakidney_channel_0, mctr1);
  rot_mul(mcrotakidney_channel_1, mctr1, mcrotrkidney_channel_1);
  mctc1 = coords_set(
#line 15 "MACS_sample_kidney_box.instr"
    0,
#line 15 "MACS_sample_kidney_box.instr"
    0,
#line 15 "MACS_sample_kidney_box.instr"
    0);
#line 92789 "MACS_sample_kidney_box.c"
  rot_transpose(mcrotakidney_master, mctr1);
  mctc2 = rot_apply(mctr1, mctc1);
  mcposakidney_channel_1 = coords_add(mcposakidney_master, mctc2);
  mctc1 = coords_sub(mcposakidney_channel_0, mcposakidney_channel_1);
  mcposrkidney_channel_1 = rot_apply(mcrotakidney_channel_1, mctc1);
  mcDEBUG_COMPONENT("kidney_channel_1", mcposakidney_channel_1, mcrotakidney_channel_1)
  mccomp_posa[50] = mcposakidney_channel_1;
  mccomp_posr[50] = mcposrkidney_channel_1;
  mcNCounter[50]  = mcPCounter[50] = mcP2Counter[50] = 0;
  mcAbsorbProp[50]= 0;
    /* Component kidney_channel_2. */
  /* Setting parameters for component kidney_channel_2. */
  SIG_MESSAGE("kidney_channel_2 (Init:SetPar)");

  SIG_MESSAGE("kidney_channel_2 (Init:Place/Rotate)");
  rot_set_rotation(mctr1,
#line 20 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 20 "MACS_sample_kidney_box.instr"
    (-60)*DEG2RAD,
#line 20 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD);
#line 92812 "MACS_sample_kidney_box.c"
  rot_mul(mctr1, mcrotakidney_master, mcrotakidney_channel_2);
  rot_transpose(mcrotakidney_channel_1, mctr1);
  rot_mul(mcrotakidney_channel_2, mctr1, mcrotrkidney_channel_2);
  mctc1 = coords_set(
#line 19 "MACS_sample_kidney_box.instr"
    0,
#line 19 "MACS_sample_kidney_box.instr"
    0,
#line 19 "MACS_sample_kidney_box.instr"
    0);
#line 92823 "MACS_sample_kidney_box.c"
  rot_transpose(mcrotakidney_master, mctr1);
  mctc2 = rot_apply(mctr1, mctc1);
  mcposakidney_channel_2 = coords_add(mcposakidney_master, mctc2);
  mctc1 = coords_sub(mcposakidney_channel_1, mcposakidney_channel_2);
  mcposrkidney_channel_2 = rot_apply(mcrotakidney_channel_2, mctc1);
  mcDEBUG_COMPONENT("kidney_channel_2", mcposakidney_channel_2, mcrotakidney_channel_2)
  mccomp_posa[51] = mcposakidney_channel_2;
  mccomp_posr[51] = mcposrkidney_channel_2;
  mcNCounter[51]  = mcPCounter[51] = mcP2Counter[51] = 0;
  mcAbsorbProp[51]= 0;
    /* Component kidney_channel_3. */
  /* Setting parameters for component kidney_channel_3. */
  SIG_MESSAGE("kidney_channel_3 (Init:SetPar)");

  SIG_MESSAGE("kidney_channel_3 (Init:Place/Rotate)");
  rot_set_rotation(mctr1,
#line 24 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 24 "MACS_sample_kidney_box.instr"
    (-52)*DEG2RAD,
#line 24 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD);
#line 92846 "MACS_sample_kidney_box.c"
  rot_mul(mctr1, mcrotakidney_master, mcrotakidney_channel_3);
  rot_transpose(mcrotakidney_channel_2, mctr1);
  rot_mul(mcrotakidney_channel_3, mctr1, mcrotrkidney_channel_3);
  mctc1 = coords_set(
#line 23 "MACS_sample_kidney_box.instr"
    0,
#line 23 "MACS_sample_kidney_box.instr"
    0,
#line 23 "MACS_sample_kidney_box.instr"
    0);
#line 92857 "MACS_sample_kidney_box.c"
  rot_transpose(mcrotakidney_master, mctr1);
  mctc2 = rot_apply(mctr1, mctc1);
  mcposakidney_channel_3 = coords_add(mcposakidney_master, mctc2);
  mctc1 = coords_sub(mcposakidney_channel_2, mcposakidney_channel_3);
  mcposrkidney_channel_3 = rot_apply(mcrotakidney_channel_3, mctc1);
  mcDEBUG_COMPONENT("kidney_channel_3", mcposakidney_channel_3, mcrotakidney_channel_3)
  mccomp_posa[52] = mcposakidney_channel_3;
  mccomp_posr[52] = mcposrkidney_channel_3;
  mcNCounter[52]  = mcPCounter[52] = mcP2Counter[52] = 0;
  mcAbsorbProp[52]= 0;
    /* Component kidney_channel_4. */
  /* Setting parameters for component kidney_channel_4. */
  SIG_MESSAGE("kidney_channel_4 (Init:SetPar)");

  SIG_MESSAGE("kidney_channel_4 (Init:Place/Rotate)");
  rot_set_rotation(mctr1,
#line 28 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 28 "MACS_sample_kidney_box.instr"
    (-44)*DEG2RAD,
#line 28 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD);
#line 92880 "MACS_sample_kidney_box.c"
  rot_mul(mctr1, mcrotakidney_master, mcrotakidney_channel_4);
  rot_transpose(mcrotakidney_channel_3, mctr1);
  rot_mul(mcrotakidney_channel_4, mctr1, mcrotrkidney_channel_4);
  mctc1 = coords_set(
#line 27 "MACS_sample_kidney_box.instr"
    0,
#line 27 "MACS_sample_kidney_box.instr"
    0,
#line 27 "MACS_sample_kidney_box.instr"
    0);
#line 92891 "MACS_sample_kidney_box.c"
  rot_transpose(mcrotakidney_master, mctr1);
  mctc2 = rot_apply(mctr1, mctc1);
  mcposakidney_channel_4 = coords_add(mcposakidney_master, mctc2);
  mctc1 = coords_sub(mcposakidney_channel_3, mcposakidney_channel_4);
  mcposrkidney_channel_4 = rot_apply(mcrotakidney_channel_4, mctc1);
  mcDEBUG_COMPONENT("kidney_channel_4", mcposakidney_channel_4, mcrotakidney_channel_4)
  mccomp_posa[53] = mcposakidney_channel_4;
  mccomp_posr[53] = mcposrkidney_channel_4;
  mcNCounter[53]  = mcPCounter[53] = mcP2Counter[53] = 0;
  mcAbsorbProp[53]= 0;
    /* Component kidney_channel_5. */
  /* Setting parameters for component kidney_channel_5. */
  SIG_MESSAGE("kidney_channel_5 (Init:SetPar)");

  SIG_MESSAGE("kidney_channel_5 (Init:Place/Rotate)");
  rot_set_rotation(mctr1,
#line 32 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 32 "MACS_sample_kidney_box.instr"
    (-36)*DEG2RAD,
#line 32 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD);
#line 92914 "MACS_sample_kidney_box.c"
  rot_mul(mctr1, mcrotakidney_master, mcrotakidney_channel_5);
  rot_transpose(mcrotakidney_channel_4, mctr1);
  rot_mul(mcrotakidney_channel_5, mctr1, mcrotrkidney_channel_5);
  mctc1 = coords_set(
#line 31 "MACS_sample_kidney_box.instr"
    0,
#line 31 "MACS_sample_kidney_box.instr"
    0,
#line 31 "MACS_sample_kidney_box.instr"
    0);
#line 92925 "MACS_sample_kidney_box.c"
  rot_transpose(mcrotakidney_master, mctr1);
  mctc2 = rot_apply(mctr1, mctc1);
  mcposakidney_channel_5 = coords_add(mcposakidney_master, mctc2);
  mctc1 = coords_sub(mcposakidney_channel_4, mcposakidney_channel_5);
  mcposrkidney_channel_5 = rot_apply(mcrotakidney_channel_5, mctc1);
  mcDEBUG_COMPONENT("kidney_channel_5", mcposakidney_channel_5, mcrotakidney_channel_5)
  mccomp_posa[54] = mcposakidney_channel_5;
  mccomp_posr[54] = mcposrkidney_channel_5;
  mcNCounter[54]  = mcPCounter[54] = mcP2Counter[54] = 0;
  mcAbsorbProp[54]= 0;
    /* Component kidney_channel_6. */
  /* Setting parameters for component kidney_channel_6. */
  SIG_MESSAGE("kidney_channel_6 (Init:SetPar)");

  SIG_MESSAGE("kidney_channel_6 (Init:Place/Rotate)");
  rot_set_rotation(mctr1,
#line 36 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 36 "MACS_sample_kidney_box.instr"
    (-28)*DEG2RAD,
#line 36 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD);
#line 92948 "MACS_sample_kidney_box.c"
  rot_mul(mctr1, mcrotakidney_master, mcrotakidney_channel_6);
  rot_transpose(mcrotakidney_channel_5, mctr1);
  rot_mul(mcrotakidney_channel_6, mctr1, mcrotrkidney_channel_6);
  mctc1 = coords_set(
#line 35 "MACS_sample_kidney_box.instr"
    0,
#line 35 "MACS_sample_kidney_box.instr"
    0,
#line 35 "MACS_sample_kidney_box.instr"
    0);
#line 92959 "MACS_sample_kidney_box.c"
  rot_transpose(mcrotakidney_master, mctr1);
  mctc2 = rot_apply(mctr1, mctc1);
  mcposakidney_channel_6 = coords_add(mcposakidney_master, mctc2);
  mctc1 = coords_sub(mcposakidney_channel_5, mcposakidney_channel_6);
  mcposrkidney_channel_6 = rot_apply(mcrotakidney_channel_6, mctc1);
  mcDEBUG_COMPONENT("kidney_channel_6", mcposakidney_channel_6, mcrotakidney_channel_6)
  mccomp_posa[55] = mcposakidney_channel_6;
  mccomp_posr[55] = mcposrkidney_channel_6;
  mcNCounter[55]  = mcPCounter[55] = mcP2Counter[55] = 0;
  mcAbsorbProp[55]= 0;
    /* Component kidney_channel_7. */
  /* Setting parameters for component kidney_channel_7. */
  SIG_MESSAGE("kidney_channel_7 (Init:SetPar)");

  SIG_MESSAGE("kidney_channel_7 (Init:Place/Rotate)");
  rot_set_rotation(mctr1,
#line 40 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 40 "MACS_sample_kidney_box.instr"
    (-20)*DEG2RAD,
#line 40 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD);
#line 92982 "MACS_sample_kidney_box.c"
  rot_mul(mctr1, mcrotakidney_master, mcrotakidney_channel_7);
  rot_transpose(mcrotakidney_channel_6, mctr1);
  rot_mul(mcrotakidney_channel_7, mctr1, mcrotrkidney_channel_7);
  mctc1 = coords_set(
#line 39 "MACS_sample_kidney_box.instr"
    0,
#line 39 "MACS_sample_kidney_box.instr"
    0,
#line 39 "MACS_sample_kidney_box.instr"
    0);
#line 92993 "MACS_sample_kidney_box.c"
  rot_transpose(mcrotakidney_master, mctr1);
  mctc2 = rot_apply(mctr1, mctc1);
  mcposakidney_channel_7 = coords_add(mcposakidney_master, mctc2);
  mctc1 = coords_sub(mcposakidney_channel_6, mcposakidney_channel_7);
  mcposrkidney_channel_7 = rot_apply(mcrotakidney_channel_7, mctc1);
  mcDEBUG_COMPONENT("kidney_channel_7", mcposakidney_channel_7, mcrotakidney_channel_7)
  mccomp_posa[56] = mcposakidney_channel_7;
  mccomp_posr[56] = mcposrkidney_channel_7;
  mcNCounter[56]  = mcPCounter[56] = mcP2Counter[56] = 0;
  mcAbsorbProp[56]= 0;
    /* Component kidney_channel_8. */
  /* Setting parameters for component kidney_channel_8. */
  SIG_MESSAGE("kidney_channel_8 (Init:SetPar)");

  SIG_MESSAGE("kidney_channel_8 (Init:Place/Rotate)");
  rot_set_rotation(mctr1,
#line 44 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 44 "MACS_sample_kidney_box.instr"
    (-12)*DEG2RAD,
#line 44 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD);
#line 93016 "MACS_sample_kidney_box.c"
  rot_mul(mctr1, mcrotakidney_master, mcrotakidney_channel_8);
  rot_transpose(mcrotakidney_channel_7, mctr1);
  rot_mul(mcrotakidney_channel_8, mctr1, mcrotrkidney_channel_8);
  mctc1 = coords_set(
#line 43 "MACS_sample_kidney_box.instr"
    0,
#line 43 "MACS_sample_kidney_box.instr"
    0,
#line 43 "MACS_sample_kidney_box.instr"
    0);
#line 93027 "MACS_sample_kidney_box.c"
  rot_transpose(mcrotakidney_master, mctr1);
  mctc2 = rot_apply(mctr1, mctc1);
  mcposakidney_channel_8 = coords_add(mcposakidney_master, mctc2);
  mctc1 = coords_sub(mcposakidney_channel_7, mcposakidney_channel_8);
  mcposrkidney_channel_8 = rot_apply(mcrotakidney_channel_8, mctc1);
  mcDEBUG_COMPONENT("kidney_channel_8", mcposakidney_channel_8, mcrotakidney_channel_8)
  mccomp_posa[57] = mcposakidney_channel_8;
  mccomp_posr[57] = mcposrkidney_channel_8;
  mcNCounter[57]  = mcPCounter[57] = mcP2Counter[57] = 0;
  mcAbsorbProp[57]= 0;
    /* Component kidney_channel_9. */
  /* Setting parameters for component kidney_channel_9. */
  SIG_MESSAGE("kidney_channel_9 (Init:SetPar)");

  SIG_MESSAGE("kidney_channel_9 (Init:Place/Rotate)");
  rot_set_rotation(mctr1,
#line 48 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 48 "MACS_sample_kidney_box.instr"
    (-4)*DEG2RAD,
#line 48 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD);
#line 93050 "MACS_sample_kidney_box.c"
  rot_mul(mctr1, mcrotakidney_master, mcrotakidney_channel_9);
  rot_transpose(mcrotakidney_channel_8, mctr1);
  rot_mul(mcrotakidney_channel_9, mctr1, mcrotrkidney_channel_9);
  mctc1 = coords_set(
#line 47 "MACS_sample_kidney_box.instr"
    0,
#line 47 "MACS_sample_kidney_box.instr"
    0,
#line 47 "MACS_sample_kidney_box.instr"
    0);
#line 93061 "MACS_sample_kidney_box.c"
  rot_transpose(mcrotakidney_master, mctr1);
  mctc2 = rot_apply(mctr1, mctc1);
  mcposakidney_channel_9 = coords_add(mcposakidney_master, mctc2);
  mctc1 = coords_sub(mcposakidney_channel_8, mcposakidney_channel_9);
  mcposrkidney_channel_9 = rot_apply(mcrotakidney_channel_9, mctc1);
  mcDEBUG_COMPONENT("kidney_channel_9", mcposakidney_channel_9, mcrotakidney_channel_9)
  mccomp_posa[58] = mcposakidney_channel_9;
  mccomp_posr[58] = mcposrkidney_channel_9;
  mcNCounter[58]  = mcPCounter[58] = mcP2Counter[58] = 0;
  mcAbsorbProp[58]= 0;
    /* Component kidney_channel_10. */
  /* Setting parameters for component kidney_channel_10. */
  SIG_MESSAGE("kidney_channel_10 (Init:SetPar)");

  SIG_MESSAGE("kidney_channel_10 (Init:Place/Rotate)");
  rot_set_rotation(mctr1,
#line 52 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 52 "MACS_sample_kidney_box.instr"
    (4)*DEG2RAD,
#line 52 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD);
#line 93084 "MACS_sample_kidney_box.c"
  rot_mul(mctr1, mcrotakidney_master, mcrotakidney_channel_10);
  rot_transpose(mcrotakidney_channel_9, mctr1);
  rot_mul(mcrotakidney_channel_10, mctr1, mcrotrkidney_channel_10);
  mctc1 = coords_set(
#line 51 "MACS_sample_kidney_box.instr"
    0,
#line 51 "MACS_sample_kidney_box.instr"
    0,
#line 51 "MACS_sample_kidney_box.instr"
    0);
#line 93095 "MACS_sample_kidney_box.c"
  rot_transpose(mcrotakidney_master, mctr1);
  mctc2 = rot_apply(mctr1, mctc1);
  mcposakidney_channel_10 = coords_add(mcposakidney_master, mctc2);
  mctc1 = coords_sub(mcposakidney_channel_9, mcposakidney_channel_10);
  mcposrkidney_channel_10 = rot_apply(mcrotakidney_channel_10, mctc1);
  mcDEBUG_COMPONENT("kidney_channel_10", mcposakidney_channel_10, mcrotakidney_channel_10)
  mccomp_posa[59] = mcposakidney_channel_10;
  mccomp_posr[59] = mcposrkidney_channel_10;
  mcNCounter[59]  = mcPCounter[59] = mcP2Counter[59] = 0;
  mcAbsorbProp[59]= 0;
    /* Component kidney_channel_11. */
  /* Setting parameters for component kidney_channel_11. */
  SIG_MESSAGE("kidney_channel_11 (Init:SetPar)");

  SIG_MESSAGE("kidney_channel_11 (Init:Place/Rotate)");
  rot_set_rotation(mctr1,
#line 56 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 56 "MACS_sample_kidney_box.instr"
    (12)*DEG2RAD,
#line 56 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD);
#line 93118 "MACS_sample_kidney_box.c"
  rot_mul(mctr1, mcrotakidney_master, mcrotakidney_channel_11);
  rot_transpose(mcrotakidney_channel_10, mctr1);
  rot_mul(mcrotakidney_channel_11, mctr1, mcrotrkidney_channel_11);
  mctc1 = coords_set(
#line 55 "MACS_sample_kidney_box.instr"
    0,
#line 55 "MACS_sample_kidney_box.instr"
    0,
#line 55 "MACS_sample_kidney_box.instr"
    0);
#line 93129 "MACS_sample_kidney_box.c"
  rot_transpose(mcrotakidney_master, mctr1);
  mctc2 = rot_apply(mctr1, mctc1);
  mcposakidney_channel_11 = coords_add(mcposakidney_master, mctc2);
  mctc1 = coords_sub(mcposakidney_channel_10, mcposakidney_channel_11);
  mcposrkidney_channel_11 = rot_apply(mcrotakidney_channel_11, mctc1);
  mcDEBUG_COMPONENT("kidney_channel_11", mcposakidney_channel_11, mcrotakidney_channel_11)
  mccomp_posa[60] = mcposakidney_channel_11;
  mccomp_posr[60] = mcposrkidney_channel_11;
  mcNCounter[60]  = mcPCounter[60] = mcP2Counter[60] = 0;
  mcAbsorbProp[60]= 0;
    /* Component kidney_channel_12. */
  /* Setting parameters for component kidney_channel_12. */
  SIG_MESSAGE("kidney_channel_12 (Init:SetPar)");

  SIG_MESSAGE("kidney_channel_12 (Init:Place/Rotate)");
  rot_set_rotation(mctr1,
#line 60 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 60 "MACS_sample_kidney_box.instr"
    (20)*DEG2RAD,
#line 60 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD);
#line 93152 "MACS_sample_kidney_box.c"
  rot_mul(mctr1, mcrotakidney_master, mcrotakidney_channel_12);
  rot_transpose(mcrotakidney_channel_11, mctr1);
  rot_mul(mcrotakidney_channel_12, mctr1, mcrotrkidney_channel_12);
  mctc1 = coords_set(
#line 59 "MACS_sample_kidney_box.instr"
    0,
#line 59 "MACS_sample_kidney_box.instr"
    0,
#line 59 "MACS_sample_kidney_box.instr"
    0);
#line 93163 "MACS_sample_kidney_box.c"
  rot_transpose(mcrotakidney_master, mctr1);
  mctc2 = rot_apply(mctr1, mctc1);
  mcposakidney_channel_12 = coords_add(mcposakidney_master, mctc2);
  mctc1 = coords_sub(mcposakidney_channel_11, mcposakidney_channel_12);
  mcposrkidney_channel_12 = rot_apply(mcrotakidney_channel_12, mctc1);
  mcDEBUG_COMPONENT("kidney_channel_12", mcposakidney_channel_12, mcrotakidney_channel_12)
  mccomp_posa[61] = mcposakidney_channel_12;
  mccomp_posr[61] = mcposrkidney_channel_12;
  mcNCounter[61]  = mcPCounter[61] = mcP2Counter[61] = 0;
  mcAbsorbProp[61]= 0;
    /* Component kidney_channel_13. */
  /* Setting parameters for component kidney_channel_13. */
  SIG_MESSAGE("kidney_channel_13 (Init:SetPar)");

  SIG_MESSAGE("kidney_channel_13 (Init:Place/Rotate)");
  rot_set_rotation(mctr1,
#line 64 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 64 "MACS_sample_kidney_box.instr"
    (28)*DEG2RAD,
#line 64 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD);
#line 93186 "MACS_sample_kidney_box.c"
  rot_mul(mctr1, mcrotakidney_master, mcrotakidney_channel_13);
  rot_transpose(mcrotakidney_channel_12, mctr1);
  rot_mul(mcrotakidney_channel_13, mctr1, mcrotrkidney_channel_13);
  mctc1 = coords_set(
#line 63 "MACS_sample_kidney_box.instr"
    0,
#line 63 "MACS_sample_kidney_box.instr"
    0,
#line 63 "MACS_sample_kidney_box.instr"
    0);
#line 93197 "MACS_sample_kidney_box.c"
  rot_transpose(mcrotakidney_master, mctr1);
  mctc2 = rot_apply(mctr1, mctc1);
  mcposakidney_channel_13 = coords_add(mcposakidney_master, mctc2);
  mctc1 = coords_sub(mcposakidney_channel_12, mcposakidney_channel_13);
  mcposrkidney_channel_13 = rot_apply(mcrotakidney_channel_13, mctc1);
  mcDEBUG_COMPONENT("kidney_channel_13", mcposakidney_channel_13, mcrotakidney_channel_13)
  mccomp_posa[62] = mcposakidney_channel_13;
  mccomp_posr[62] = mcposrkidney_channel_13;
  mcNCounter[62]  = mcPCounter[62] = mcP2Counter[62] = 0;
  mcAbsorbProp[62]= 0;
    /* Component kidney_channel_14. */
  /* Setting parameters for component kidney_channel_14. */
  SIG_MESSAGE("kidney_channel_14 (Init:SetPar)");

  SIG_MESSAGE("kidney_channel_14 (Init:Place/Rotate)");
  rot_set_rotation(mctr1,
#line 68 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 68 "MACS_sample_kidney_box.instr"
    (36)*DEG2RAD,
#line 68 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD);
#line 93220 "MACS_sample_kidney_box.c"
  rot_mul(mctr1, mcrotakidney_master, mcrotakidney_channel_14);
  rot_transpose(mcrotakidney_channel_13, mctr1);
  rot_mul(mcrotakidney_channel_14, mctr1, mcrotrkidney_channel_14);
  mctc1 = coords_set(
#line 67 "MACS_sample_kidney_box.instr"
    0,
#line 67 "MACS_sample_kidney_box.instr"
    0,
#line 67 "MACS_sample_kidney_box.instr"
    0);
#line 93231 "MACS_sample_kidney_box.c"
  rot_transpose(mcrotakidney_master, mctr1);
  mctc2 = rot_apply(mctr1, mctc1);
  mcposakidney_channel_14 = coords_add(mcposakidney_master, mctc2);
  mctc1 = coords_sub(mcposakidney_channel_13, mcposakidney_channel_14);
  mcposrkidney_channel_14 = rot_apply(mcrotakidney_channel_14, mctc1);
  mcDEBUG_COMPONENT("kidney_channel_14", mcposakidney_channel_14, mcrotakidney_channel_14)
  mccomp_posa[63] = mcposakidney_channel_14;
  mccomp_posr[63] = mcposrkidney_channel_14;
  mcNCounter[63]  = mcPCounter[63] = mcP2Counter[63] = 0;
  mcAbsorbProp[63]= 0;
    /* Component kidney_channel_15. */
  /* Setting parameters for component kidney_channel_15. */
  SIG_MESSAGE("kidney_channel_15 (Init:SetPar)");

  SIG_MESSAGE("kidney_channel_15 (Init:Place/Rotate)");
  rot_set_rotation(mctr1,
#line 72 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 72 "MACS_sample_kidney_box.instr"
    (44)*DEG2RAD,
#line 72 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD);
#line 93254 "MACS_sample_kidney_box.c"
  rot_mul(mctr1, mcrotakidney_master, mcrotakidney_channel_15);
  rot_transpose(mcrotakidney_channel_14, mctr1);
  rot_mul(mcrotakidney_channel_15, mctr1, mcrotrkidney_channel_15);
  mctc1 = coords_set(
#line 71 "MACS_sample_kidney_box.instr"
    0,
#line 71 "MACS_sample_kidney_box.instr"
    0,
#line 71 "MACS_sample_kidney_box.instr"
    0);
#line 93265 "MACS_sample_kidney_box.c"
  rot_transpose(mcrotakidney_master, mctr1);
  mctc2 = rot_apply(mctr1, mctc1);
  mcposakidney_channel_15 = coords_add(mcposakidney_master, mctc2);
  mctc1 = coords_sub(mcposakidney_channel_14, mcposakidney_channel_15);
  mcposrkidney_channel_15 = rot_apply(mcrotakidney_channel_15, mctc1);
  mcDEBUG_COMPONENT("kidney_channel_15", mcposakidney_channel_15, mcrotakidney_channel_15)
  mccomp_posa[64] = mcposakidney_channel_15;
  mccomp_posr[64] = mcposrkidney_channel_15;
  mcNCounter[64]  = mcPCounter[64] = mcP2Counter[64] = 0;
  mcAbsorbProp[64]= 0;
    /* Component kidney_channel_16. */
  /* Setting parameters for component kidney_channel_16. */
  SIG_MESSAGE("kidney_channel_16 (Init:SetPar)");

  SIG_MESSAGE("kidney_channel_16 (Init:Place/Rotate)");
  rot_set_rotation(mctr1,
#line 76 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 76 "MACS_sample_kidney_box.instr"
    (52)*DEG2RAD,
#line 76 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD);
#line 93288 "MACS_sample_kidney_box.c"
  rot_mul(mctr1, mcrotakidney_master, mcrotakidney_channel_16);
  rot_transpose(mcrotakidney_channel_15, mctr1);
  rot_mul(mcrotakidney_channel_16, mctr1, mcrotrkidney_channel_16);
  mctc1 = coords_set(
#line 75 "MACS_sample_kidney_box.instr"
    0,
#line 75 "MACS_sample_kidney_box.instr"
    0,
#line 75 "MACS_sample_kidney_box.instr"
    0);
#line 93299 "MACS_sample_kidney_box.c"
  rot_transpose(mcrotakidney_master, mctr1);
  mctc2 = rot_apply(mctr1, mctc1);
  mcposakidney_channel_16 = coords_add(mcposakidney_master, mctc2);
  mctc1 = coords_sub(mcposakidney_channel_15, mcposakidney_channel_16);
  mcposrkidney_channel_16 = rot_apply(mcrotakidney_channel_16, mctc1);
  mcDEBUG_COMPONENT("kidney_channel_16", mcposakidney_channel_16, mcrotakidney_channel_16)
  mccomp_posa[65] = mcposakidney_channel_16;
  mccomp_posr[65] = mcposrkidney_channel_16;
  mcNCounter[65]  = mcPCounter[65] = mcP2Counter[65] = 0;
  mcAbsorbProp[65]= 0;
    /* Component kidney_channel_17. */
  /* Setting parameters for component kidney_channel_17. */
  SIG_MESSAGE("kidney_channel_17 (Init:SetPar)");

  SIG_MESSAGE("kidney_channel_17 (Init:Place/Rotate)");
  rot_set_rotation(mctr1,
#line 80 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 80 "MACS_sample_kidney_box.instr"
    (60)*DEG2RAD,
#line 80 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD);
#line 93322 "MACS_sample_kidney_box.c"
  rot_mul(mctr1, mcrotakidney_master, mcrotakidney_channel_17);
  rot_transpose(mcrotakidney_channel_16, mctr1);
  rot_mul(mcrotakidney_channel_17, mctr1, mcrotrkidney_channel_17);
  mctc1 = coords_set(
#line 79 "MACS_sample_kidney_box.instr"
    0,
#line 79 "MACS_sample_kidney_box.instr"
    0,
#line 79 "MACS_sample_kidney_box.instr"
    0);
#line 93333 "MACS_sample_kidney_box.c"
  rot_transpose(mcrotakidney_master, mctr1);
  mctc2 = rot_apply(mctr1, mctc1);
  mcposakidney_channel_17 = coords_add(mcposakidney_master, mctc2);
  mctc1 = coords_sub(mcposakidney_channel_16, mcposakidney_channel_17);
  mcposrkidney_channel_17 = rot_apply(mcrotakidney_channel_17, mctc1);
  mcDEBUG_COMPONENT("kidney_channel_17", mcposakidney_channel_17, mcrotakidney_channel_17)
  mccomp_posa[66] = mcposakidney_channel_17;
  mccomp_posr[66] = mcposrkidney_channel_17;
  mcNCounter[66]  = mcPCounter[66] = mcP2Counter[66] = 0;
  mcAbsorbProp[66]= 0;
    /* Component kidney_channel_18. */
  /* Setting parameters for component kidney_channel_18. */
  SIG_MESSAGE("kidney_channel_18 (Init:SetPar)");

  SIG_MESSAGE("kidney_channel_18 (Init:Place/Rotate)");
  rot_set_rotation(mctr1,
#line 84 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 84 "MACS_sample_kidney_box.instr"
    (68)*DEG2RAD,
#line 84 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD);
#line 93356 "MACS_sample_kidney_box.c"
  rot_mul(mctr1, mcrotakidney_master, mcrotakidney_channel_18);
  rot_transpose(mcrotakidney_channel_17, mctr1);
  rot_mul(mcrotakidney_channel_18, mctr1, mcrotrkidney_channel_18);
  mctc1 = coords_set(
#line 83 "MACS_sample_kidney_box.instr"
    0,
#line 83 "MACS_sample_kidney_box.instr"
    0,
#line 83 "MACS_sample_kidney_box.instr"
    0);
#line 93367 "MACS_sample_kidney_box.c"
  rot_transpose(mcrotakidney_master, mctr1);
  mctc2 = rot_apply(mctr1, mctc1);
  mcposakidney_channel_18 = coords_add(mcposakidney_master, mctc2);
  mctc1 = coords_sub(mcposakidney_channel_17, mcposakidney_channel_18);
  mcposrkidney_channel_18 = rot_apply(mcrotakidney_channel_18, mctc1);
  mcDEBUG_COMPONENT("kidney_channel_18", mcposakidney_channel_18, mcrotakidney_channel_18)
  mccomp_posa[67] = mcposakidney_channel_18;
  mccomp_posr[67] = mcposrkidney_channel_18;
  mcNCounter[67]  = mcPCounter[67] = mcP2Counter[67] = 0;
  mcAbsorbProp[67]= 0;
    /* Component kidney_channel_19. */
  /* Setting parameters for component kidney_channel_19. */
  SIG_MESSAGE("kidney_channel_19 (Init:SetPar)");

  SIG_MESSAGE("kidney_channel_19 (Init:Place/Rotate)");
  rot_set_rotation(mctr1,
#line 88 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 88 "MACS_sample_kidney_box.instr"
    (76)*DEG2RAD,
#line 88 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD);
#line 93390 "MACS_sample_kidney_box.c"
  rot_mul(mctr1, mcrotakidney_master, mcrotakidney_channel_19);
  rot_transpose(mcrotakidney_channel_18, mctr1);
  rot_mul(mcrotakidney_channel_19, mctr1, mcrotrkidney_channel_19);
  mctc1 = coords_set(
#line 87 "MACS_sample_kidney_box.instr"
    0,
#line 87 "MACS_sample_kidney_box.instr"
    0,
#line 87 "MACS_sample_kidney_box.instr"
    0);
#line 93401 "MACS_sample_kidney_box.c"
  rot_transpose(mcrotakidney_master, mctr1);
  mctc2 = rot_apply(mctr1, mctc1);
  mcposakidney_channel_19 = coords_add(mcposakidney_master, mctc2);
  mctc1 = coords_sub(mcposakidney_channel_18, mcposakidney_channel_19);
  mcposrkidney_channel_19 = rot_apply(mcrotakidney_channel_19, mctc1);
  mcDEBUG_COMPONENT("kidney_channel_19", mcposakidney_channel_19, mcrotakidney_channel_19)
  mccomp_posa[68] = mcposakidney_channel_19;
  mccomp_posr[68] = mcposrkidney_channel_19;
  mcNCounter[68]  = mcPCounter[68] = mcP2Counter[68] = 0;
  mcAbsorbProp[68]= 0;
    /* Component channel_0_filter. */
  /* Setting parameters for component channel_0_filter. */
  SIG_MESSAGE("channel_0_filter (Init:SetPar)");
#line 46 "MACS_sample_kidney_box.instr"
  mccchannel_0_filter_xmin = 0;
#line 46 "MACS_sample_kidney_box.instr"
  mccchannel_0_filter_xmax = 0;
#line 46 "MACS_sample_kidney_box.instr"
  mccchannel_0_filter_ymin = 0;
#line 46 "MACS_sample_kidney_box.instr"
  mccchannel_0_filter_ymax = 0;
#line 46 "MACS_sample_kidney_box.instr"
  mccchannel_0_filter_radius = 0;
#line 91 "MACS_sample_kidney_box.instr"
  mccchannel_0_filter_xwidth = filter_width;
#line 91 "MACS_sample_kidney_box.instr"
  mccchannel_0_filter_yheight = filter_height;
#line 93429 "MACS_sample_kidney_box.c"

  SIG_MESSAGE("channel_0_filter (Init:Place/Rotate)");
  rot_set_rotation(mctr1,
#line 93 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 93 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 93 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD);
#line 93439 "MACS_sample_kidney_box.c"
  rot_mul(mctr1, mcrotakidney_channel_0, mcrotachannel_0_filter);
  rot_transpose(mcrotakidney_channel_19, mctr1);
  rot_mul(mcrotachannel_0_filter, mctr1, mcrotrchannel_0_filter);
  mctc1 = coords_set(
#line 92 "MACS_sample_kidney_box.instr"
    0,
#line 92 "MACS_sample_kidney_box.instr"
    0,
#line 92 "MACS_sample_kidney_box.instr"
    target_filter_dist);
#line 93450 "MACS_sample_kidney_box.c"
  rot_transpose(mcrotakidney_channel_0, mctr1);
  mctc2 = rot_apply(mctr1, mctc1);
  mcposachannel_0_filter = coords_add(mcposakidney_channel_0, mctc2);
  mctc1 = coords_sub(mcposakidney_channel_19, mcposachannel_0_filter);
  mcposrchannel_0_filter = rot_apply(mcrotachannel_0_filter, mctc1);
  mcDEBUG_COMPONENT("channel_0_filter", mcposachannel_0_filter, mcrotachannel_0_filter)
  mccomp_posa[69] = mcposachannel_0_filter;
  mccomp_posr[69] = mcposrchannel_0_filter;
  mcNCounter[69]  = mcPCounter[69] = mcP2Counter[69] = 0;
  mcAbsorbProp[69]= 0;
    /* Component channel_1_filter. */
  /* Setting parameters for component channel_1_filter. */
  SIG_MESSAGE("channel_1_filter (Init:SetPar)");
#line 46 "MACS_sample_kidney_box.instr"
  mccchannel_1_filter_xmin = 0;
#line 46 "MACS_sample_kidney_box.instr"
  mccchannel_1_filter_xmax = 0;
#line 46 "MACS_sample_kidney_box.instr"
  mccchannel_1_filter_ymin = 0;
#line 46 "MACS_sample_kidney_box.instr"
  mccchannel_1_filter_ymax = 0;
#line 46 "MACS_sample_kidney_box.instr"
  mccchannel_1_filter_radius = 0;
#line 101 "MACS_sample_kidney_box.instr"
  mccchannel_1_filter_xwidth = filter_width;
#line 101 "MACS_sample_kidney_box.instr"
  mccchannel_1_filter_yheight = filter_height;
#line 93478 "MACS_sample_kidney_box.c"

  SIG_MESSAGE("channel_1_filter (Init:Place/Rotate)");
  rot_set_rotation(mctr1,
#line 103 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 103 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 103 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD);
#line 93488 "MACS_sample_kidney_box.c"
  rot_mul(mctr1, mcrotakidney_channel_1, mcrotachannel_1_filter);
  rot_transpose(mcrotachannel_0_filter, mctr1);
  rot_mul(mcrotachannel_1_filter, mctr1, mcrotrchannel_1_filter);
  mctc1 = coords_set(
#line 102 "MACS_sample_kidney_box.instr"
    0,
#line 102 "MACS_sample_kidney_box.instr"
    0,
#line 102 "MACS_sample_kidney_box.instr"
    target_filter_dist);
#line 93499 "MACS_sample_kidney_box.c"
  rot_transpose(mcrotakidney_channel_1, mctr1);
  mctc2 = rot_apply(mctr1, mctc1);
  mcposachannel_1_filter = coords_add(mcposakidney_channel_1, mctc2);
  mctc1 = coords_sub(mcposachannel_0_filter, mcposachannel_1_filter);
  mcposrchannel_1_filter = rot_apply(mcrotachannel_1_filter, mctc1);
  mcDEBUG_COMPONENT("channel_1_filter", mcposachannel_1_filter, mcrotachannel_1_filter)
  mccomp_posa[70] = mcposachannel_1_filter;
  mccomp_posr[70] = mcposrchannel_1_filter;
  mcNCounter[70]  = mcPCounter[70] = mcP2Counter[70] = 0;
  mcAbsorbProp[70]= 0;
    /* Component channel_2_filter. */
  /* Setting parameters for component channel_2_filter. */
  SIG_MESSAGE("channel_2_filter (Init:SetPar)");
#line 46 "MACS_sample_kidney_box.instr"
  mccchannel_2_filter_xmin = 0;
#line 46 "MACS_sample_kidney_box.instr"
  mccchannel_2_filter_xmax = 0;
#line 46 "MACS_sample_kidney_box.instr"
  mccchannel_2_filter_ymin = 0;
#line 46 "MACS_sample_kidney_box.instr"
  mccchannel_2_filter_ymax = 0;
#line 46 "MACS_sample_kidney_box.instr"
  mccchannel_2_filter_radius = 0;
#line 109 "MACS_sample_kidney_box.instr"
  mccchannel_2_filter_xwidth = filter_width;
#line 109 "MACS_sample_kidney_box.instr"
  mccchannel_2_filter_yheight = filter_height;
#line 93527 "MACS_sample_kidney_box.c"

  SIG_MESSAGE("channel_2_filter (Init:Place/Rotate)");
  rot_set_rotation(mctr1,
#line 111 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 111 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 111 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD);
#line 93537 "MACS_sample_kidney_box.c"
  rot_mul(mctr1, mcrotakidney_channel_2, mcrotachannel_2_filter);
  rot_transpose(mcrotachannel_1_filter, mctr1);
  rot_mul(mcrotachannel_2_filter, mctr1, mcrotrchannel_2_filter);
  mctc1 = coords_set(
#line 110 "MACS_sample_kidney_box.instr"
    0,
#line 110 "MACS_sample_kidney_box.instr"
    0,
#line 110 "MACS_sample_kidney_box.instr"
    target_filter_dist);
#line 93548 "MACS_sample_kidney_box.c"
  rot_transpose(mcrotakidney_channel_2, mctr1);
  mctc2 = rot_apply(mctr1, mctc1);
  mcposachannel_2_filter = coords_add(mcposakidney_channel_2, mctc2);
  mctc1 = coords_sub(mcposachannel_1_filter, mcposachannel_2_filter);
  mcposrchannel_2_filter = rot_apply(mcrotachannel_2_filter, mctc1);
  mcDEBUG_COMPONENT("channel_2_filter", mcposachannel_2_filter, mcrotachannel_2_filter)
  mccomp_posa[71] = mcposachannel_2_filter;
  mccomp_posr[71] = mcposrchannel_2_filter;
  mcNCounter[71]  = mcPCounter[71] = mcP2Counter[71] = 0;
  mcAbsorbProp[71]= 0;
    /* Component channel_3_filter. */
  /* Setting parameters for component channel_3_filter. */
  SIG_MESSAGE("channel_3_filter (Init:SetPar)");
#line 46 "MACS_sample_kidney_box.instr"
  mccchannel_3_filter_xmin = 0;
#line 46 "MACS_sample_kidney_box.instr"
  mccchannel_3_filter_xmax = 0;
#line 46 "MACS_sample_kidney_box.instr"
  mccchannel_3_filter_ymin = 0;
#line 46 "MACS_sample_kidney_box.instr"
  mccchannel_3_filter_ymax = 0;
#line 46 "MACS_sample_kidney_box.instr"
  mccchannel_3_filter_radius = 0;
#line 117 "MACS_sample_kidney_box.instr"
  mccchannel_3_filter_xwidth = filter_width;
#line 117 "MACS_sample_kidney_box.instr"
  mccchannel_3_filter_yheight = filter_height;
#line 93576 "MACS_sample_kidney_box.c"

  SIG_MESSAGE("channel_3_filter (Init:Place/Rotate)");
  rot_set_rotation(mctr1,
#line 119 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 119 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 119 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD);
#line 93586 "MACS_sample_kidney_box.c"
  rot_mul(mctr1, mcrotakidney_channel_3, mcrotachannel_3_filter);
  rot_transpose(mcrotachannel_2_filter, mctr1);
  rot_mul(mcrotachannel_3_filter, mctr1, mcrotrchannel_3_filter);
  mctc1 = coords_set(
#line 118 "MACS_sample_kidney_box.instr"
    0,
#line 118 "MACS_sample_kidney_box.instr"
    0,
#line 118 "MACS_sample_kidney_box.instr"
    target_filter_dist);
#line 93597 "MACS_sample_kidney_box.c"
  rot_transpose(mcrotakidney_channel_3, mctr1);
  mctc2 = rot_apply(mctr1, mctc1);
  mcposachannel_3_filter = coords_add(mcposakidney_channel_3, mctc2);
  mctc1 = coords_sub(mcposachannel_2_filter, mcposachannel_3_filter);
  mcposrchannel_3_filter = rot_apply(mcrotachannel_3_filter, mctc1);
  mcDEBUG_COMPONENT("channel_3_filter", mcposachannel_3_filter, mcrotachannel_3_filter)
  mccomp_posa[72] = mcposachannel_3_filter;
  mccomp_posr[72] = mcposrchannel_3_filter;
  mcNCounter[72]  = mcPCounter[72] = mcP2Counter[72] = 0;
  mcAbsorbProp[72]= 0;
    /* Component channel_4_filter. */
  /* Setting parameters for component channel_4_filter. */
  SIG_MESSAGE("channel_4_filter (Init:SetPar)");
#line 46 "MACS_sample_kidney_box.instr"
  mccchannel_4_filter_xmin = 0;
#line 46 "MACS_sample_kidney_box.instr"
  mccchannel_4_filter_xmax = 0;
#line 46 "MACS_sample_kidney_box.instr"
  mccchannel_4_filter_ymin = 0;
#line 46 "MACS_sample_kidney_box.instr"
  mccchannel_4_filter_ymax = 0;
#line 46 "MACS_sample_kidney_box.instr"
  mccchannel_4_filter_radius = 0;
#line 125 "MACS_sample_kidney_box.instr"
  mccchannel_4_filter_xwidth = filter_width;
#line 125 "MACS_sample_kidney_box.instr"
  mccchannel_4_filter_yheight = filter_height;
#line 93625 "MACS_sample_kidney_box.c"

  SIG_MESSAGE("channel_4_filter (Init:Place/Rotate)");
  rot_set_rotation(mctr1,
#line 127 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 127 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 127 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD);
#line 93635 "MACS_sample_kidney_box.c"
  rot_mul(mctr1, mcrotakidney_channel_4, mcrotachannel_4_filter);
  rot_transpose(mcrotachannel_3_filter, mctr1);
  rot_mul(mcrotachannel_4_filter, mctr1, mcrotrchannel_4_filter);
  mctc1 = coords_set(
#line 126 "MACS_sample_kidney_box.instr"
    0,
#line 126 "MACS_sample_kidney_box.instr"
    0,
#line 126 "MACS_sample_kidney_box.instr"
    target_filter_dist);
#line 93646 "MACS_sample_kidney_box.c"
  rot_transpose(mcrotakidney_channel_4, mctr1);
  mctc2 = rot_apply(mctr1, mctc1);
  mcposachannel_4_filter = coords_add(mcposakidney_channel_4, mctc2);
  mctc1 = coords_sub(mcposachannel_3_filter, mcposachannel_4_filter);
  mcposrchannel_4_filter = rot_apply(mcrotachannel_4_filter, mctc1);
  mcDEBUG_COMPONENT("channel_4_filter", mcposachannel_4_filter, mcrotachannel_4_filter)
  mccomp_posa[73] = mcposachannel_4_filter;
  mccomp_posr[73] = mcposrchannel_4_filter;
  mcNCounter[73]  = mcPCounter[73] = mcP2Counter[73] = 0;
  mcAbsorbProp[73]= 0;
    /* Component channel_5_filter. */
  /* Setting parameters for component channel_5_filter. */
  SIG_MESSAGE("channel_5_filter (Init:SetPar)");
#line 46 "MACS_sample_kidney_box.instr"
  mccchannel_5_filter_xmin = 0;
#line 46 "MACS_sample_kidney_box.instr"
  mccchannel_5_filter_xmax = 0;
#line 46 "MACS_sample_kidney_box.instr"
  mccchannel_5_filter_ymin = 0;
#line 46 "MACS_sample_kidney_box.instr"
  mccchannel_5_filter_ymax = 0;
#line 46 "MACS_sample_kidney_box.instr"
  mccchannel_5_filter_radius = 0;
#line 133 "MACS_sample_kidney_box.instr"
  mccchannel_5_filter_xwidth = filter_width;
#line 133 "MACS_sample_kidney_box.instr"
  mccchannel_5_filter_yheight = filter_height;
#line 93674 "MACS_sample_kidney_box.c"

  SIG_MESSAGE("channel_5_filter (Init:Place/Rotate)");
  rot_set_rotation(mctr1,
#line 135 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 135 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 135 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD);
#line 93684 "MACS_sample_kidney_box.c"
  rot_mul(mctr1, mcrotakidney_channel_5, mcrotachannel_5_filter);
  rot_transpose(mcrotachannel_4_filter, mctr1);
  rot_mul(mcrotachannel_5_filter, mctr1, mcrotrchannel_5_filter);
  mctc1 = coords_set(
#line 134 "MACS_sample_kidney_box.instr"
    0,
#line 134 "MACS_sample_kidney_box.instr"
    0,
#line 134 "MACS_sample_kidney_box.instr"
    target_filter_dist);
#line 93695 "MACS_sample_kidney_box.c"
  rot_transpose(mcrotakidney_channel_5, mctr1);
  mctc2 = rot_apply(mctr1, mctc1);
  mcposachannel_5_filter = coords_add(mcposakidney_channel_5, mctc2);
  mctc1 = coords_sub(mcposachannel_4_filter, mcposachannel_5_filter);
  mcposrchannel_5_filter = rot_apply(mcrotachannel_5_filter, mctc1);
  mcDEBUG_COMPONENT("channel_5_filter", mcposachannel_5_filter, mcrotachannel_5_filter)
  mccomp_posa[74] = mcposachannel_5_filter;
  mccomp_posr[74] = mcposrchannel_5_filter;
  mcNCounter[74]  = mcPCounter[74] = mcP2Counter[74] = 0;
  mcAbsorbProp[74]= 0;
    /* Component channel_6_filter. */
  /* Setting parameters for component channel_6_filter. */
  SIG_MESSAGE("channel_6_filter (Init:SetPar)");
#line 46 "MACS_sample_kidney_box.instr"
  mccchannel_6_filter_xmin = 0;
#line 46 "MACS_sample_kidney_box.instr"
  mccchannel_6_filter_xmax = 0;
#line 46 "MACS_sample_kidney_box.instr"
  mccchannel_6_filter_ymin = 0;
#line 46 "MACS_sample_kidney_box.instr"
  mccchannel_6_filter_ymax = 0;
#line 46 "MACS_sample_kidney_box.instr"
  mccchannel_6_filter_radius = 0;
#line 142 "MACS_sample_kidney_box.instr"
  mccchannel_6_filter_xwidth = filter_width;
#line 142 "MACS_sample_kidney_box.instr"
  mccchannel_6_filter_yheight = filter_height;
#line 93723 "MACS_sample_kidney_box.c"

  SIG_MESSAGE("channel_6_filter (Init:Place/Rotate)");
  rot_set_rotation(mctr1,
#line 144 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 144 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 144 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD);
#line 93733 "MACS_sample_kidney_box.c"
  rot_mul(mctr1, mcrotakidney_channel_6, mcrotachannel_6_filter);
  rot_transpose(mcrotachannel_5_filter, mctr1);
  rot_mul(mcrotachannel_6_filter, mctr1, mcrotrchannel_6_filter);
  mctc1 = coords_set(
#line 143 "MACS_sample_kidney_box.instr"
    0,
#line 143 "MACS_sample_kidney_box.instr"
    0,
#line 143 "MACS_sample_kidney_box.instr"
    target_filter_dist);
#line 93744 "MACS_sample_kidney_box.c"
  rot_transpose(mcrotakidney_channel_6, mctr1);
  mctc2 = rot_apply(mctr1, mctc1);
  mcposachannel_6_filter = coords_add(mcposakidney_channel_6, mctc2);
  mctc1 = coords_sub(mcposachannel_5_filter, mcposachannel_6_filter);
  mcposrchannel_6_filter = rot_apply(mcrotachannel_6_filter, mctc1);
  mcDEBUG_COMPONENT("channel_6_filter", mcposachannel_6_filter, mcrotachannel_6_filter)
  mccomp_posa[75] = mcposachannel_6_filter;
  mccomp_posr[75] = mcposrchannel_6_filter;
  mcNCounter[75]  = mcPCounter[75] = mcP2Counter[75] = 0;
  mcAbsorbProp[75]= 0;
    /* Component channel_7_filter. */
  /* Setting parameters for component channel_7_filter. */
  SIG_MESSAGE("channel_7_filter (Init:SetPar)");
#line 46 "MACS_sample_kidney_box.instr"
  mccchannel_7_filter_xmin = 0;
#line 46 "MACS_sample_kidney_box.instr"
  mccchannel_7_filter_xmax = 0;
#line 46 "MACS_sample_kidney_box.instr"
  mccchannel_7_filter_ymin = 0;
#line 46 "MACS_sample_kidney_box.instr"
  mccchannel_7_filter_ymax = 0;
#line 46 "MACS_sample_kidney_box.instr"
  mccchannel_7_filter_radius = 0;
#line 151 "MACS_sample_kidney_box.instr"
  mccchannel_7_filter_xwidth = filter_width;
#line 151 "MACS_sample_kidney_box.instr"
  mccchannel_7_filter_yheight = filter_height;
#line 93772 "MACS_sample_kidney_box.c"

  SIG_MESSAGE("channel_7_filter (Init:Place/Rotate)");
  rot_set_rotation(mctr1,
#line 153 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 153 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 153 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD);
#line 93782 "MACS_sample_kidney_box.c"
  rot_mul(mctr1, mcrotakidney_channel_7, mcrotachannel_7_filter);
  rot_transpose(mcrotachannel_6_filter, mctr1);
  rot_mul(mcrotachannel_7_filter, mctr1, mcrotrchannel_7_filter);
  mctc1 = coords_set(
#line 152 "MACS_sample_kidney_box.instr"
    0,
#line 152 "MACS_sample_kidney_box.instr"
    0,
#line 152 "MACS_sample_kidney_box.instr"
    target_filter_dist);
#line 93793 "MACS_sample_kidney_box.c"
  rot_transpose(mcrotakidney_channel_7, mctr1);
  mctc2 = rot_apply(mctr1, mctc1);
  mcposachannel_7_filter = coords_add(mcposakidney_channel_7, mctc2);
  mctc1 = coords_sub(mcposachannel_6_filter, mcposachannel_7_filter);
  mcposrchannel_7_filter = rot_apply(mcrotachannel_7_filter, mctc1);
  mcDEBUG_COMPONENT("channel_7_filter", mcposachannel_7_filter, mcrotachannel_7_filter)
  mccomp_posa[76] = mcposachannel_7_filter;
  mccomp_posr[76] = mcposrchannel_7_filter;
  mcNCounter[76]  = mcPCounter[76] = mcP2Counter[76] = 0;
  mcAbsorbProp[76]= 0;
    /* Component channel_8_filter. */
  /* Setting parameters for component channel_8_filter. */
  SIG_MESSAGE("channel_8_filter (Init:SetPar)");
#line 46 "MACS_sample_kidney_box.instr"
  mccchannel_8_filter_xmin = 0;
#line 46 "MACS_sample_kidney_box.instr"
  mccchannel_8_filter_xmax = 0;
#line 46 "MACS_sample_kidney_box.instr"
  mccchannel_8_filter_ymin = 0;
#line 46 "MACS_sample_kidney_box.instr"
  mccchannel_8_filter_ymax = 0;
#line 46 "MACS_sample_kidney_box.instr"
  mccchannel_8_filter_radius = 0;
#line 160 "MACS_sample_kidney_box.instr"
  mccchannel_8_filter_xwidth = filter_width;
#line 160 "MACS_sample_kidney_box.instr"
  mccchannel_8_filter_yheight = filter_height;
#line 93821 "MACS_sample_kidney_box.c"

  SIG_MESSAGE("channel_8_filter (Init:Place/Rotate)");
  rot_set_rotation(mctr1,
#line 162 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 162 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 162 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD);
#line 93831 "MACS_sample_kidney_box.c"
  rot_mul(mctr1, mcrotakidney_channel_8, mcrotachannel_8_filter);
  rot_transpose(mcrotachannel_7_filter, mctr1);
  rot_mul(mcrotachannel_8_filter, mctr1, mcrotrchannel_8_filter);
  mctc1 = coords_set(
#line 161 "MACS_sample_kidney_box.instr"
    0,
#line 161 "MACS_sample_kidney_box.instr"
    0,
#line 161 "MACS_sample_kidney_box.instr"
    target_filter_dist);
#line 93842 "MACS_sample_kidney_box.c"
  rot_transpose(mcrotakidney_channel_8, mctr1);
  mctc2 = rot_apply(mctr1, mctc1);
  mcposachannel_8_filter = coords_add(mcposakidney_channel_8, mctc2);
  mctc1 = coords_sub(mcposachannel_7_filter, mcposachannel_8_filter);
  mcposrchannel_8_filter = rot_apply(mcrotachannel_8_filter, mctc1);
  mcDEBUG_COMPONENT("channel_8_filter", mcposachannel_8_filter, mcrotachannel_8_filter)
  mccomp_posa[77] = mcposachannel_8_filter;
  mccomp_posr[77] = mcposrchannel_8_filter;
  mcNCounter[77]  = mcPCounter[77] = mcP2Counter[77] = 0;
  mcAbsorbProp[77]= 0;
    /* Component channel_9_filter. */
  /* Setting parameters for component channel_9_filter. */
  SIG_MESSAGE("channel_9_filter (Init:SetPar)");
#line 46 "MACS_sample_kidney_box.instr"
  mccchannel_9_filter_xmin = 0;
#line 46 "MACS_sample_kidney_box.instr"
  mccchannel_9_filter_xmax = 0;
#line 46 "MACS_sample_kidney_box.instr"
  mccchannel_9_filter_ymin = 0;
#line 46 "MACS_sample_kidney_box.instr"
  mccchannel_9_filter_ymax = 0;
#line 46 "MACS_sample_kidney_box.instr"
  mccchannel_9_filter_radius = 0;
#line 169 "MACS_sample_kidney_box.instr"
  mccchannel_9_filter_xwidth = filter_width;
#line 169 "MACS_sample_kidney_box.instr"
  mccchannel_9_filter_yheight = filter_height;
#line 93870 "MACS_sample_kidney_box.c"

  SIG_MESSAGE("channel_9_filter (Init:Place/Rotate)");
  rot_set_rotation(mctr1,
#line 171 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 171 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 171 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD);
#line 93880 "MACS_sample_kidney_box.c"
  rot_mul(mctr1, mcrotakidney_channel_9, mcrotachannel_9_filter);
  rot_transpose(mcrotachannel_8_filter, mctr1);
  rot_mul(mcrotachannel_9_filter, mctr1, mcrotrchannel_9_filter);
  mctc1 = coords_set(
#line 170 "MACS_sample_kidney_box.instr"
    0,
#line 170 "MACS_sample_kidney_box.instr"
    0,
#line 170 "MACS_sample_kidney_box.instr"
    target_filter_dist);
#line 93891 "MACS_sample_kidney_box.c"
  rot_transpose(mcrotakidney_channel_9, mctr1);
  mctc2 = rot_apply(mctr1, mctc1);
  mcposachannel_9_filter = coords_add(mcposakidney_channel_9, mctc2);
  mctc1 = coords_sub(mcposachannel_8_filter, mcposachannel_9_filter);
  mcposrchannel_9_filter = rot_apply(mcrotachannel_9_filter, mctc1);
  mcDEBUG_COMPONENT("channel_9_filter", mcposachannel_9_filter, mcrotachannel_9_filter)
  mccomp_posa[78] = mcposachannel_9_filter;
  mccomp_posr[78] = mcposrchannel_9_filter;
  mcNCounter[78]  = mcPCounter[78] = mcP2Counter[78] = 0;
  mcAbsorbProp[78]= 0;
    /* Component channel_10_filter. */
  /* Setting parameters for component channel_10_filter. */
  SIG_MESSAGE("channel_10_filter (Init:SetPar)");
#line 46 "MACS_sample_kidney_box.instr"
  mccchannel_10_filter_xmin = 0;
#line 46 "MACS_sample_kidney_box.instr"
  mccchannel_10_filter_xmax = 0;
#line 46 "MACS_sample_kidney_box.instr"
  mccchannel_10_filter_ymin = 0;
#line 46 "MACS_sample_kidney_box.instr"
  mccchannel_10_filter_ymax = 0;
#line 46 "MACS_sample_kidney_box.instr"
  mccchannel_10_filter_radius = 0;
#line 178 "MACS_sample_kidney_box.instr"
  mccchannel_10_filter_xwidth = filter_width;
#line 178 "MACS_sample_kidney_box.instr"
  mccchannel_10_filter_yheight = filter_height;
#line 93919 "MACS_sample_kidney_box.c"

  SIG_MESSAGE("channel_10_filter (Init:Place/Rotate)");
  rot_set_rotation(mctr1,
#line 180 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 180 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 180 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD);
#line 93929 "MACS_sample_kidney_box.c"
  rot_mul(mctr1, mcrotakidney_channel_10, mcrotachannel_10_filter);
  rot_transpose(mcrotachannel_9_filter, mctr1);
  rot_mul(mcrotachannel_10_filter, mctr1, mcrotrchannel_10_filter);
  mctc1 = coords_set(
#line 179 "MACS_sample_kidney_box.instr"
    0,
#line 179 "MACS_sample_kidney_box.instr"
    0,
#line 179 "MACS_sample_kidney_box.instr"
    target_filter_dist);
#line 93940 "MACS_sample_kidney_box.c"
  rot_transpose(mcrotakidney_channel_10, mctr1);
  mctc2 = rot_apply(mctr1, mctc1);
  mcposachannel_10_filter = coords_add(mcposakidney_channel_10, mctc2);
  mctc1 = coords_sub(mcposachannel_9_filter, mcposachannel_10_filter);
  mcposrchannel_10_filter = rot_apply(mcrotachannel_10_filter, mctc1);
  mcDEBUG_COMPONENT("channel_10_filter", mcposachannel_10_filter, mcrotachannel_10_filter)
  mccomp_posa[79] = mcposachannel_10_filter;
  mccomp_posr[79] = mcposrchannel_10_filter;
  mcNCounter[79]  = mcPCounter[79] = mcP2Counter[79] = 0;
  mcAbsorbProp[79]= 0;
    /* Component channel_11_filter. */
  /* Setting parameters for component channel_11_filter. */
  SIG_MESSAGE("channel_11_filter (Init:SetPar)");
#line 46 "MACS_sample_kidney_box.instr"
  mccchannel_11_filter_xmin = 0;
#line 46 "MACS_sample_kidney_box.instr"
  mccchannel_11_filter_xmax = 0;
#line 46 "MACS_sample_kidney_box.instr"
  mccchannel_11_filter_ymin = 0;
#line 46 "MACS_sample_kidney_box.instr"
  mccchannel_11_filter_ymax = 0;
#line 46 "MACS_sample_kidney_box.instr"
  mccchannel_11_filter_radius = 0;
#line 187 "MACS_sample_kidney_box.instr"
  mccchannel_11_filter_xwidth = filter_width;
#line 187 "MACS_sample_kidney_box.instr"
  mccchannel_11_filter_yheight = filter_height;
#line 93968 "MACS_sample_kidney_box.c"

  SIG_MESSAGE("channel_11_filter (Init:Place/Rotate)");
  rot_set_rotation(mctr1,
#line 189 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 189 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 189 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD);
#line 93978 "MACS_sample_kidney_box.c"
  rot_mul(mctr1, mcrotakidney_channel_11, mcrotachannel_11_filter);
  rot_transpose(mcrotachannel_10_filter, mctr1);
  rot_mul(mcrotachannel_11_filter, mctr1, mcrotrchannel_11_filter);
  mctc1 = coords_set(
#line 188 "MACS_sample_kidney_box.instr"
    0,
#line 188 "MACS_sample_kidney_box.instr"
    0,
#line 188 "MACS_sample_kidney_box.instr"
    target_filter_dist);
#line 93989 "MACS_sample_kidney_box.c"
  rot_transpose(mcrotakidney_channel_11, mctr1);
  mctc2 = rot_apply(mctr1, mctc1);
  mcposachannel_11_filter = coords_add(mcposakidney_channel_11, mctc2);
  mctc1 = coords_sub(mcposachannel_10_filter, mcposachannel_11_filter);
  mcposrchannel_11_filter = rot_apply(mcrotachannel_11_filter, mctc1);
  mcDEBUG_COMPONENT("channel_11_filter", mcposachannel_11_filter, mcrotachannel_11_filter)
  mccomp_posa[80] = mcposachannel_11_filter;
  mccomp_posr[80] = mcposrchannel_11_filter;
  mcNCounter[80]  = mcPCounter[80] = mcP2Counter[80] = 0;
  mcAbsorbProp[80]= 0;
    /* Component channel_12_filter. */
  /* Setting parameters for component channel_12_filter. */
  SIG_MESSAGE("channel_12_filter (Init:SetPar)");
#line 46 "MACS_sample_kidney_box.instr"
  mccchannel_12_filter_xmin = 0;
#line 46 "MACS_sample_kidney_box.instr"
  mccchannel_12_filter_xmax = 0;
#line 46 "MACS_sample_kidney_box.instr"
  mccchannel_12_filter_ymin = 0;
#line 46 "MACS_sample_kidney_box.instr"
  mccchannel_12_filter_ymax = 0;
#line 46 "MACS_sample_kidney_box.instr"
  mccchannel_12_filter_radius = 0;
#line 196 "MACS_sample_kidney_box.instr"
  mccchannel_12_filter_xwidth = filter_width;
#line 196 "MACS_sample_kidney_box.instr"
  mccchannel_12_filter_yheight = filter_height;
#line 94017 "MACS_sample_kidney_box.c"

  SIG_MESSAGE("channel_12_filter (Init:Place/Rotate)");
  rot_set_rotation(mctr1,
#line 198 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 198 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 198 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD);
#line 94027 "MACS_sample_kidney_box.c"
  rot_mul(mctr1, mcrotakidney_channel_12, mcrotachannel_12_filter);
  rot_transpose(mcrotachannel_11_filter, mctr1);
  rot_mul(mcrotachannel_12_filter, mctr1, mcrotrchannel_12_filter);
  mctc1 = coords_set(
#line 197 "MACS_sample_kidney_box.instr"
    0,
#line 197 "MACS_sample_kidney_box.instr"
    0,
#line 197 "MACS_sample_kidney_box.instr"
    target_filter_dist);
#line 94038 "MACS_sample_kidney_box.c"
  rot_transpose(mcrotakidney_channel_12, mctr1);
  mctc2 = rot_apply(mctr1, mctc1);
  mcposachannel_12_filter = coords_add(mcposakidney_channel_12, mctc2);
  mctc1 = coords_sub(mcposachannel_11_filter, mcposachannel_12_filter);
  mcposrchannel_12_filter = rot_apply(mcrotachannel_12_filter, mctc1);
  mcDEBUG_COMPONENT("channel_12_filter", mcposachannel_12_filter, mcrotachannel_12_filter)
  mccomp_posa[81] = mcposachannel_12_filter;
  mccomp_posr[81] = mcposrchannel_12_filter;
  mcNCounter[81]  = mcPCounter[81] = mcP2Counter[81] = 0;
  mcAbsorbProp[81]= 0;
    /* Component channel_13_filter. */
  /* Setting parameters for component channel_13_filter. */
  SIG_MESSAGE("channel_13_filter (Init:SetPar)");
#line 46 "MACS_sample_kidney_box.instr"
  mccchannel_13_filter_xmin = 0;
#line 46 "MACS_sample_kidney_box.instr"
  mccchannel_13_filter_xmax = 0;
#line 46 "MACS_sample_kidney_box.instr"
  mccchannel_13_filter_ymin = 0;
#line 46 "MACS_sample_kidney_box.instr"
  mccchannel_13_filter_ymax = 0;
#line 46 "MACS_sample_kidney_box.instr"
  mccchannel_13_filter_radius = 0;
#line 205 "MACS_sample_kidney_box.instr"
  mccchannel_13_filter_xwidth = filter_width;
#line 205 "MACS_sample_kidney_box.instr"
  mccchannel_13_filter_yheight = filter_height;
#line 94066 "MACS_sample_kidney_box.c"

  SIG_MESSAGE("channel_13_filter (Init:Place/Rotate)");
  rot_set_rotation(mctr1,
#line 207 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 207 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 207 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD);
#line 94076 "MACS_sample_kidney_box.c"
  rot_mul(mctr1, mcrotakidney_channel_13, mcrotachannel_13_filter);
  rot_transpose(mcrotachannel_12_filter, mctr1);
  rot_mul(mcrotachannel_13_filter, mctr1, mcrotrchannel_13_filter);
  mctc1 = coords_set(
#line 206 "MACS_sample_kidney_box.instr"
    0,
#line 206 "MACS_sample_kidney_box.instr"
    0,
#line 206 "MACS_sample_kidney_box.instr"
    target_filter_dist);
#line 94087 "MACS_sample_kidney_box.c"
  rot_transpose(mcrotakidney_channel_13, mctr1);
  mctc2 = rot_apply(mctr1, mctc1);
  mcposachannel_13_filter = coords_add(mcposakidney_channel_13, mctc2);
  mctc1 = coords_sub(mcposachannel_12_filter, mcposachannel_13_filter);
  mcposrchannel_13_filter = rot_apply(mcrotachannel_13_filter, mctc1);
  mcDEBUG_COMPONENT("channel_13_filter", mcposachannel_13_filter, mcrotachannel_13_filter)
  mccomp_posa[82] = mcposachannel_13_filter;
  mccomp_posr[82] = mcposrchannel_13_filter;
  mcNCounter[82]  = mcPCounter[82] = mcP2Counter[82] = 0;
  mcAbsorbProp[82]= 0;
    /* Component channel_14_filter. */
  /* Setting parameters for component channel_14_filter. */
  SIG_MESSAGE("channel_14_filter (Init:SetPar)");
#line 46 "MACS_sample_kidney_box.instr"
  mccchannel_14_filter_xmin = 0;
#line 46 "MACS_sample_kidney_box.instr"
  mccchannel_14_filter_xmax = 0;
#line 46 "MACS_sample_kidney_box.instr"
  mccchannel_14_filter_ymin = 0;
#line 46 "MACS_sample_kidney_box.instr"
  mccchannel_14_filter_ymax = 0;
#line 46 "MACS_sample_kidney_box.instr"
  mccchannel_14_filter_radius = 0;
#line 214 "MACS_sample_kidney_box.instr"
  mccchannel_14_filter_xwidth = filter_width;
#line 214 "MACS_sample_kidney_box.instr"
  mccchannel_14_filter_yheight = filter_height;
#line 94115 "MACS_sample_kidney_box.c"

  SIG_MESSAGE("channel_14_filter (Init:Place/Rotate)");
  rot_set_rotation(mctr1,
#line 216 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 216 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 216 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD);
#line 94125 "MACS_sample_kidney_box.c"
  rot_mul(mctr1, mcrotakidney_channel_14, mcrotachannel_14_filter);
  rot_transpose(mcrotachannel_13_filter, mctr1);
  rot_mul(mcrotachannel_14_filter, mctr1, mcrotrchannel_14_filter);
  mctc1 = coords_set(
#line 215 "MACS_sample_kidney_box.instr"
    0,
#line 215 "MACS_sample_kidney_box.instr"
    0,
#line 215 "MACS_sample_kidney_box.instr"
    target_filter_dist);
#line 94136 "MACS_sample_kidney_box.c"
  rot_transpose(mcrotakidney_channel_14, mctr1);
  mctc2 = rot_apply(mctr1, mctc1);
  mcposachannel_14_filter = coords_add(mcposakidney_channel_14, mctc2);
  mctc1 = coords_sub(mcposachannel_13_filter, mcposachannel_14_filter);
  mcposrchannel_14_filter = rot_apply(mcrotachannel_14_filter, mctc1);
  mcDEBUG_COMPONENT("channel_14_filter", mcposachannel_14_filter, mcrotachannel_14_filter)
  mccomp_posa[83] = mcposachannel_14_filter;
  mccomp_posr[83] = mcposrchannel_14_filter;
  mcNCounter[83]  = mcPCounter[83] = mcP2Counter[83] = 0;
  mcAbsorbProp[83]= 0;
    /* Component channel_15_filter. */
  /* Setting parameters for component channel_15_filter. */
  SIG_MESSAGE("channel_15_filter (Init:SetPar)");
#line 46 "MACS_sample_kidney_box.instr"
  mccchannel_15_filter_xmin = 0;
#line 46 "MACS_sample_kidney_box.instr"
  mccchannel_15_filter_xmax = 0;
#line 46 "MACS_sample_kidney_box.instr"
  mccchannel_15_filter_ymin = 0;
#line 46 "MACS_sample_kidney_box.instr"
  mccchannel_15_filter_ymax = 0;
#line 46 "MACS_sample_kidney_box.instr"
  mccchannel_15_filter_radius = 0;
#line 223 "MACS_sample_kidney_box.instr"
  mccchannel_15_filter_xwidth = filter_width;
#line 223 "MACS_sample_kidney_box.instr"
  mccchannel_15_filter_yheight = filter_height;
#line 94164 "MACS_sample_kidney_box.c"

  SIG_MESSAGE("channel_15_filter (Init:Place/Rotate)");
  rot_set_rotation(mctr1,
#line 225 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 225 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 225 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD);
#line 94174 "MACS_sample_kidney_box.c"
  rot_mul(mctr1, mcrotakidney_channel_15, mcrotachannel_15_filter);
  rot_transpose(mcrotachannel_14_filter, mctr1);
  rot_mul(mcrotachannel_15_filter, mctr1, mcrotrchannel_15_filter);
  mctc1 = coords_set(
#line 224 "MACS_sample_kidney_box.instr"
    0,
#line 224 "MACS_sample_kidney_box.instr"
    0,
#line 224 "MACS_sample_kidney_box.instr"
    target_filter_dist);
#line 94185 "MACS_sample_kidney_box.c"
  rot_transpose(mcrotakidney_channel_15, mctr1);
  mctc2 = rot_apply(mctr1, mctc1);
  mcposachannel_15_filter = coords_add(mcposakidney_channel_15, mctc2);
  mctc1 = coords_sub(mcposachannel_14_filter, mcposachannel_15_filter);
  mcposrchannel_15_filter = rot_apply(mcrotachannel_15_filter, mctc1);
  mcDEBUG_COMPONENT("channel_15_filter", mcposachannel_15_filter, mcrotachannel_15_filter)
  mccomp_posa[84] = mcposachannel_15_filter;
  mccomp_posr[84] = mcposrchannel_15_filter;
  mcNCounter[84]  = mcPCounter[84] = mcP2Counter[84] = 0;
  mcAbsorbProp[84]= 0;
    /* Component channel_16_filter. */
  /* Setting parameters for component channel_16_filter. */
  SIG_MESSAGE("channel_16_filter (Init:SetPar)");
#line 46 "MACS_sample_kidney_box.instr"
  mccchannel_16_filter_xmin = 0;
#line 46 "MACS_sample_kidney_box.instr"
  mccchannel_16_filter_xmax = 0;
#line 46 "MACS_sample_kidney_box.instr"
  mccchannel_16_filter_ymin = 0;
#line 46 "MACS_sample_kidney_box.instr"
  mccchannel_16_filter_ymax = 0;
#line 46 "MACS_sample_kidney_box.instr"
  mccchannel_16_filter_radius = 0;
#line 232 "MACS_sample_kidney_box.instr"
  mccchannel_16_filter_xwidth = filter_width;
#line 232 "MACS_sample_kidney_box.instr"
  mccchannel_16_filter_yheight = filter_height;
#line 94213 "MACS_sample_kidney_box.c"

  SIG_MESSAGE("channel_16_filter (Init:Place/Rotate)");
  rot_set_rotation(mctr1,
#line 234 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 234 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 234 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD);
#line 94223 "MACS_sample_kidney_box.c"
  rot_mul(mctr1, mcrotakidney_channel_16, mcrotachannel_16_filter);
  rot_transpose(mcrotachannel_15_filter, mctr1);
  rot_mul(mcrotachannel_16_filter, mctr1, mcrotrchannel_16_filter);
  mctc1 = coords_set(
#line 233 "MACS_sample_kidney_box.instr"
    0,
#line 233 "MACS_sample_kidney_box.instr"
    0,
#line 233 "MACS_sample_kidney_box.instr"
    target_filter_dist);
#line 94234 "MACS_sample_kidney_box.c"
  rot_transpose(mcrotakidney_channel_16, mctr1);
  mctc2 = rot_apply(mctr1, mctc1);
  mcposachannel_16_filter = coords_add(mcposakidney_channel_16, mctc2);
  mctc1 = coords_sub(mcposachannel_15_filter, mcposachannel_16_filter);
  mcposrchannel_16_filter = rot_apply(mcrotachannel_16_filter, mctc1);
  mcDEBUG_COMPONENT("channel_16_filter", mcposachannel_16_filter, mcrotachannel_16_filter)
  mccomp_posa[85] = mcposachannel_16_filter;
  mccomp_posr[85] = mcposrchannel_16_filter;
  mcNCounter[85]  = mcPCounter[85] = mcP2Counter[85] = 0;
  mcAbsorbProp[85]= 0;
    /* Component channel_17_filter. */
  /* Setting parameters for component channel_17_filter. */
  SIG_MESSAGE("channel_17_filter (Init:SetPar)");
#line 46 "MACS_sample_kidney_box.instr"
  mccchannel_17_filter_xmin = 0;
#line 46 "MACS_sample_kidney_box.instr"
  mccchannel_17_filter_xmax = 0;
#line 46 "MACS_sample_kidney_box.instr"
  mccchannel_17_filter_ymin = 0;
#line 46 "MACS_sample_kidney_box.instr"
  mccchannel_17_filter_ymax = 0;
#line 46 "MACS_sample_kidney_box.instr"
  mccchannel_17_filter_radius = 0;
#line 241 "MACS_sample_kidney_box.instr"
  mccchannel_17_filter_xwidth = filter_width;
#line 241 "MACS_sample_kidney_box.instr"
  mccchannel_17_filter_yheight = filter_height;
#line 94262 "MACS_sample_kidney_box.c"

  SIG_MESSAGE("channel_17_filter (Init:Place/Rotate)");
  rot_set_rotation(mctr1,
#line 243 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 243 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 243 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD);
#line 94272 "MACS_sample_kidney_box.c"
  rot_mul(mctr1, mcrotakidney_channel_17, mcrotachannel_17_filter);
  rot_transpose(mcrotachannel_16_filter, mctr1);
  rot_mul(mcrotachannel_17_filter, mctr1, mcrotrchannel_17_filter);
  mctc1 = coords_set(
#line 242 "MACS_sample_kidney_box.instr"
    0,
#line 242 "MACS_sample_kidney_box.instr"
    0,
#line 242 "MACS_sample_kidney_box.instr"
    target_filter_dist);
#line 94283 "MACS_sample_kidney_box.c"
  rot_transpose(mcrotakidney_channel_17, mctr1);
  mctc2 = rot_apply(mctr1, mctc1);
  mcposachannel_17_filter = coords_add(mcposakidney_channel_17, mctc2);
  mctc1 = coords_sub(mcposachannel_16_filter, mcposachannel_17_filter);
  mcposrchannel_17_filter = rot_apply(mcrotachannel_17_filter, mctc1);
  mcDEBUG_COMPONENT("channel_17_filter", mcposachannel_17_filter, mcrotachannel_17_filter)
  mccomp_posa[86] = mcposachannel_17_filter;
  mccomp_posr[86] = mcposrchannel_17_filter;
  mcNCounter[86]  = mcPCounter[86] = mcP2Counter[86] = 0;
  mcAbsorbProp[86]= 0;
    /* Component channel_18_filter. */
  /* Setting parameters for component channel_18_filter. */
  SIG_MESSAGE("channel_18_filter (Init:SetPar)");
#line 46 "MACS_sample_kidney_box.instr"
  mccchannel_18_filter_xmin = 0;
#line 46 "MACS_sample_kidney_box.instr"
  mccchannel_18_filter_xmax = 0;
#line 46 "MACS_sample_kidney_box.instr"
  mccchannel_18_filter_ymin = 0;
#line 46 "MACS_sample_kidney_box.instr"
  mccchannel_18_filter_ymax = 0;
#line 46 "MACS_sample_kidney_box.instr"
  mccchannel_18_filter_radius = 0;
#line 250 "MACS_sample_kidney_box.instr"
  mccchannel_18_filter_xwidth = filter_width;
#line 250 "MACS_sample_kidney_box.instr"
  mccchannel_18_filter_yheight = filter_height;
#line 94311 "MACS_sample_kidney_box.c"

  SIG_MESSAGE("channel_18_filter (Init:Place/Rotate)");
  rot_set_rotation(mctr1,
#line 252 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 252 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 252 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD);
#line 94321 "MACS_sample_kidney_box.c"
  rot_mul(mctr1, mcrotakidney_channel_18, mcrotachannel_18_filter);
  rot_transpose(mcrotachannel_17_filter, mctr1);
  rot_mul(mcrotachannel_18_filter, mctr1, mcrotrchannel_18_filter);
  mctc1 = coords_set(
#line 251 "MACS_sample_kidney_box.instr"
    0,
#line 251 "MACS_sample_kidney_box.instr"
    0,
#line 251 "MACS_sample_kidney_box.instr"
    target_filter_dist);
#line 94332 "MACS_sample_kidney_box.c"
  rot_transpose(mcrotakidney_channel_18, mctr1);
  mctc2 = rot_apply(mctr1, mctc1);
  mcposachannel_18_filter = coords_add(mcposakidney_channel_18, mctc2);
  mctc1 = coords_sub(mcposachannel_17_filter, mcposachannel_18_filter);
  mcposrchannel_18_filter = rot_apply(mcrotachannel_18_filter, mctc1);
  mcDEBUG_COMPONENT("channel_18_filter", mcposachannel_18_filter, mcrotachannel_18_filter)
  mccomp_posa[87] = mcposachannel_18_filter;
  mccomp_posr[87] = mcposrchannel_18_filter;
  mcNCounter[87]  = mcPCounter[87] = mcP2Counter[87] = 0;
  mcAbsorbProp[87]= 0;
    /* Component channel_19_filter. */
  /* Setting parameters for component channel_19_filter. */
  SIG_MESSAGE("channel_19_filter (Init:SetPar)");
#line 46 "MACS_sample_kidney_box.instr"
  mccchannel_19_filter_xmin = 0;
#line 46 "MACS_sample_kidney_box.instr"
  mccchannel_19_filter_xmax = 0;
#line 46 "MACS_sample_kidney_box.instr"
  mccchannel_19_filter_ymin = 0;
#line 46 "MACS_sample_kidney_box.instr"
  mccchannel_19_filter_ymax = 0;
#line 46 "MACS_sample_kidney_box.instr"
  mccchannel_19_filter_radius = 0;
#line 259 "MACS_sample_kidney_box.instr"
  mccchannel_19_filter_xwidth = filter_width;
#line 259 "MACS_sample_kidney_box.instr"
  mccchannel_19_filter_yheight = filter_height;
#line 94360 "MACS_sample_kidney_box.c"

  SIG_MESSAGE("channel_19_filter (Init:Place/Rotate)");
  rot_set_rotation(mctr1,
#line 261 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 261 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 261 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD);
#line 94370 "MACS_sample_kidney_box.c"
  rot_mul(mctr1, mcrotakidney_channel_19, mcrotachannel_19_filter);
  rot_transpose(mcrotachannel_18_filter, mctr1);
  rot_mul(mcrotachannel_19_filter, mctr1, mcrotrchannel_19_filter);
  mctc1 = coords_set(
#line 260 "MACS_sample_kidney_box.instr"
    0,
#line 260 "MACS_sample_kidney_box.instr"
    0,
#line 260 "MACS_sample_kidney_box.instr"
    target_filter_dist);
#line 94381 "MACS_sample_kidney_box.c"
  rot_transpose(mcrotakidney_channel_19, mctr1);
  mctc2 = rot_apply(mctr1, mctc1);
  mcposachannel_19_filter = coords_add(mcposakidney_channel_19, mctc2);
  mctc1 = coords_sub(mcposachannel_18_filter, mcposachannel_19_filter);
  mcposrchannel_19_filter = rot_apply(mcrotachannel_19_filter, mctc1);
  mcDEBUG_COMPONENT("channel_19_filter", mcposachannel_19_filter, mcrotachannel_19_filter)
  mccomp_posa[88] = mcposachannel_19_filter;
  mccomp_posr[88] = mcposrchannel_19_filter;
  mcNCounter[88]  = mcPCounter[88] = mcP2Counter[88] = 0;
  mcAbsorbProp[88]= 0;
    /* Component channel_selector. */
  /* Setting parameters for component channel_selector. */
  SIG_MESSAGE("channel_selector (Init:SetPar)");

  SIG_MESSAGE("channel_selector (Init:Place/Rotate)");
  rot_set_rotation(mctr1,
#line 271 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 271 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 271 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD);
#line 94404 "MACS_sample_kidney_box.c"
  rot_mul(mctr1, mcrotakidney_master, mcrotachannel_selector);
  rot_transpose(mcrotachannel_19_filter, mctr1);
  rot_mul(mcrotachannel_selector, mctr1, mcrotrchannel_selector);
  mctc1 = coords_set(
#line 270 "MACS_sample_kidney_box.instr"
    0,
#line 270 "MACS_sample_kidney_box.instr"
    0,
#line 270 "MACS_sample_kidney_box.instr"
    0);
#line 94415 "MACS_sample_kidney_box.c"
  rot_transpose(mcrotakidney_master, mctr1);
  mctc2 = rot_apply(mctr1, mctc1);
  mcposachannel_selector = coords_add(mcposakidney_master, mctc2);
  mctc1 = coords_sub(mcposachannel_19_filter, mcposachannel_selector);
  mcposrchannel_selector = rot_apply(mcrotachannel_selector, mctc1);
  mcDEBUG_COMPONENT("channel_selector", mcposachannel_selector, mcrotachannel_selector)
  mccomp_posa[89] = mcposachannel_selector;
  mccomp_posr[89] = mcposrchannel_selector;
  mcNCounter[89]  = mcPCounter[89] = mcP2Counter[89] = 0;
  mcAbsorbProp[89]= 0;
    /* Component channel_0_colimator. */
  /* Setting parameters for component channel_0_colimator. */
  SIG_MESSAGE("channel_0_colimator (Init:SetPar)");
#line 46 "MACS_sample_kidney_box.instr"
  mccchannel_0_colimator_xmin = -0.02;
#line 46 "MACS_sample_kidney_box.instr"
  mccchannel_0_colimator_xmax = 0.02;
#line 46 "MACS_sample_kidney_box.instr"
  mccchannel_0_colimator_ymin = -0.05;
#line 46 "MACS_sample_kidney_box.instr"
  mccchannel_0_colimator_ymax = 0.05;
#line 278 "MACS_sample_kidney_box.instr"
  mccchannel_0_colimator_xwidth = channel_colimator_width;
#line 278 "MACS_sample_kidney_box.instr"
  mccchannel_0_colimator_yheight = channel_colimator_height;
#line 279 "MACS_sample_kidney_box.instr"
  mccchannel_0_colimator_length = channel_colimator_length;
#line 279 "MACS_sample_kidney_box.instr"
  mccchannel_0_colimator_divergence = channel_colimator_divergence_arcmin;
#line 279 "MACS_sample_kidney_box.instr"
  mccchannel_0_colimator_transmission = channel_colimator_transmission;
#line 46 "MACS_sample_kidney_box.instr"
  mccchannel_0_colimator_divergenceV = 0;
#line 94449 "MACS_sample_kidney_box.c"

  SIG_MESSAGE("channel_0_colimator (Init:Place/Rotate)");
  rot_set_rotation(mctr1,
#line 282 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 282 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 282 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD);
#line 94459 "MACS_sample_kidney_box.c"
  rot_mul(mctr1, mcrotakidney_channel_0, mcrotachannel_0_colimator);
  rot_transpose(mcrotachannel_selector, mctr1);
  rot_mul(mcrotachannel_0_colimator, mctr1, mcrotrchannel_0_colimator);
  mctc1 = coords_set(
#line 281 "MACS_sample_kidney_box.instr"
    0,
#line 281 "MACS_sample_kidney_box.instr"
    0,
#line 281 "MACS_sample_kidney_box.instr"
    channel_colimator_target_dist);
#line 94470 "MACS_sample_kidney_box.c"
  rot_transpose(mcrotakidney_channel_0, mctr1);
  mctc2 = rot_apply(mctr1, mctc1);
  mcposachannel_0_colimator = coords_add(mcposakidney_channel_0, mctc2);
  mctc1 = coords_sub(mcposachannel_selector, mcposachannel_0_colimator);
  mcposrchannel_0_colimator = rot_apply(mcrotachannel_0_colimator, mctc1);
  mcDEBUG_COMPONENT("channel_0_colimator", mcposachannel_0_colimator, mcrotachannel_0_colimator)
  mccomp_posa[90] = mcposachannel_0_colimator;
  mccomp_posr[90] = mcposrchannel_0_colimator;
  mcNCounter[90]  = mcPCounter[90] = mcP2Counter[90] = 0;
  mcAbsorbProp[90]= 0;
    /* Component channel_1_colimator. */
  /* Setting parameters for component channel_1_colimator. */
  SIG_MESSAGE("channel_1_colimator (Init:SetPar)");
#line 46 "MACS_sample_kidney_box.instr"
  mccchannel_1_colimator_xmin = -0.02;
#line 46 "MACS_sample_kidney_box.instr"
  mccchannel_1_colimator_xmax = 0.02;
#line 46 "MACS_sample_kidney_box.instr"
  mccchannel_1_colimator_ymin = -0.05;
#line 46 "MACS_sample_kidney_box.instr"
  mccchannel_1_colimator_ymax = 0.05;
#line 284 "MACS_sample_kidney_box.instr"
  mccchannel_1_colimator_xwidth = channel_colimator_width;
#line 284 "MACS_sample_kidney_box.instr"
  mccchannel_1_colimator_yheight = channel_colimator_height;
#line 285 "MACS_sample_kidney_box.instr"
  mccchannel_1_colimator_length = channel_colimator_length;
#line 285 "MACS_sample_kidney_box.instr"
  mccchannel_1_colimator_divergence = channel_colimator_divergence_arcmin;
#line 285 "MACS_sample_kidney_box.instr"
  mccchannel_1_colimator_transmission = channel_colimator_transmission;
#line 46 "MACS_sample_kidney_box.instr"
  mccchannel_1_colimator_divergenceV = 0;
#line 94504 "MACS_sample_kidney_box.c"

  SIG_MESSAGE("channel_1_colimator (Init:Place/Rotate)");
  rot_set_rotation(mctr1,
#line 288 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 288 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 288 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD);
#line 94514 "MACS_sample_kidney_box.c"
  rot_mul(mctr1, mcrotakidney_channel_1, mcrotachannel_1_colimator);
  rot_transpose(mcrotachannel_0_colimator, mctr1);
  rot_mul(mcrotachannel_1_colimator, mctr1, mcrotrchannel_1_colimator);
  mctc1 = coords_set(
#line 287 "MACS_sample_kidney_box.instr"
    0,
#line 287 "MACS_sample_kidney_box.instr"
    0,
#line 287 "MACS_sample_kidney_box.instr"
    channel_colimator_target_dist);
#line 94525 "MACS_sample_kidney_box.c"
  rot_transpose(mcrotakidney_channel_1, mctr1);
  mctc2 = rot_apply(mctr1, mctc1);
  mcposachannel_1_colimator = coords_add(mcposakidney_channel_1, mctc2);
  mctc1 = coords_sub(mcposachannel_0_colimator, mcposachannel_1_colimator);
  mcposrchannel_1_colimator = rot_apply(mcrotachannel_1_colimator, mctc1);
  mcDEBUG_COMPONENT("channel_1_colimator", mcposachannel_1_colimator, mcrotachannel_1_colimator)
  mccomp_posa[91] = mcposachannel_1_colimator;
  mccomp_posr[91] = mcposrchannel_1_colimator;
  mcNCounter[91]  = mcPCounter[91] = mcP2Counter[91] = 0;
  mcAbsorbProp[91]= 0;
    /* Component channel_2_colimator. */
  /* Setting parameters for component channel_2_colimator. */
  SIG_MESSAGE("channel_2_colimator (Init:SetPar)");
#line 46 "MACS_sample_kidney_box.instr"
  mccchannel_2_colimator_xmin = -0.02;
#line 46 "MACS_sample_kidney_box.instr"
  mccchannel_2_colimator_xmax = 0.02;
#line 46 "MACS_sample_kidney_box.instr"
  mccchannel_2_colimator_ymin = -0.05;
#line 46 "MACS_sample_kidney_box.instr"
  mccchannel_2_colimator_ymax = 0.05;
#line 290 "MACS_sample_kidney_box.instr"
  mccchannel_2_colimator_xwidth = channel_colimator_width;
#line 290 "MACS_sample_kidney_box.instr"
  mccchannel_2_colimator_yheight = channel_colimator_height;
#line 291 "MACS_sample_kidney_box.instr"
  mccchannel_2_colimator_length = channel_colimator_length;
#line 291 "MACS_sample_kidney_box.instr"
  mccchannel_2_colimator_divergence = channel_colimator_divergence_arcmin;
#line 291 "MACS_sample_kidney_box.instr"
  mccchannel_2_colimator_transmission = channel_colimator_transmission;
#line 46 "MACS_sample_kidney_box.instr"
  mccchannel_2_colimator_divergenceV = 0;
#line 94559 "MACS_sample_kidney_box.c"

  SIG_MESSAGE("channel_2_colimator (Init:Place/Rotate)");
  rot_set_rotation(mctr1,
#line 294 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 294 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 294 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD);
#line 94569 "MACS_sample_kidney_box.c"
  rot_mul(mctr1, mcrotakidney_channel_2, mcrotachannel_2_colimator);
  rot_transpose(mcrotachannel_1_colimator, mctr1);
  rot_mul(mcrotachannel_2_colimator, mctr1, mcrotrchannel_2_colimator);
  mctc1 = coords_set(
#line 293 "MACS_sample_kidney_box.instr"
    0,
#line 293 "MACS_sample_kidney_box.instr"
    0,
#line 293 "MACS_sample_kidney_box.instr"
    channel_colimator_target_dist);
#line 94580 "MACS_sample_kidney_box.c"
  rot_transpose(mcrotakidney_channel_2, mctr1);
  mctc2 = rot_apply(mctr1, mctc1);
  mcposachannel_2_colimator = coords_add(mcposakidney_channel_2, mctc2);
  mctc1 = coords_sub(mcposachannel_1_colimator, mcposachannel_2_colimator);
  mcposrchannel_2_colimator = rot_apply(mcrotachannel_2_colimator, mctc1);
  mcDEBUG_COMPONENT("channel_2_colimator", mcposachannel_2_colimator, mcrotachannel_2_colimator)
  mccomp_posa[92] = mcposachannel_2_colimator;
  mccomp_posr[92] = mcposrchannel_2_colimator;
  mcNCounter[92]  = mcPCounter[92] = mcP2Counter[92] = 0;
  mcAbsorbProp[92]= 0;
    /* Component channel_3_colimator. */
  /* Setting parameters for component channel_3_colimator. */
  SIG_MESSAGE("channel_3_colimator (Init:SetPar)");
#line 46 "MACS_sample_kidney_box.instr"
  mccchannel_3_colimator_xmin = -0.02;
#line 46 "MACS_sample_kidney_box.instr"
  mccchannel_3_colimator_xmax = 0.02;
#line 46 "MACS_sample_kidney_box.instr"
  mccchannel_3_colimator_ymin = -0.05;
#line 46 "MACS_sample_kidney_box.instr"
  mccchannel_3_colimator_ymax = 0.05;
#line 296 "MACS_sample_kidney_box.instr"
  mccchannel_3_colimator_xwidth = channel_colimator_width;
#line 296 "MACS_sample_kidney_box.instr"
  mccchannel_3_colimator_yheight = channel_colimator_height;
#line 297 "MACS_sample_kidney_box.instr"
  mccchannel_3_colimator_length = channel_colimator_length;
#line 297 "MACS_sample_kidney_box.instr"
  mccchannel_3_colimator_divergence = channel_colimator_divergence_arcmin;
#line 297 "MACS_sample_kidney_box.instr"
  mccchannel_3_colimator_transmission = channel_colimator_transmission;
#line 46 "MACS_sample_kidney_box.instr"
  mccchannel_3_colimator_divergenceV = 0;
#line 94614 "MACS_sample_kidney_box.c"

  SIG_MESSAGE("channel_3_colimator (Init:Place/Rotate)");
  rot_set_rotation(mctr1,
#line 300 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 300 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 300 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD);
#line 94624 "MACS_sample_kidney_box.c"
  rot_mul(mctr1, mcrotakidney_channel_3, mcrotachannel_3_colimator);
  rot_transpose(mcrotachannel_2_colimator, mctr1);
  rot_mul(mcrotachannel_3_colimator, mctr1, mcrotrchannel_3_colimator);
  mctc1 = coords_set(
#line 299 "MACS_sample_kidney_box.instr"
    0,
#line 299 "MACS_sample_kidney_box.instr"
    0,
#line 299 "MACS_sample_kidney_box.instr"
    channel_colimator_target_dist);
#line 94635 "MACS_sample_kidney_box.c"
  rot_transpose(mcrotakidney_channel_3, mctr1);
  mctc2 = rot_apply(mctr1, mctc1);
  mcposachannel_3_colimator = coords_add(mcposakidney_channel_3, mctc2);
  mctc1 = coords_sub(mcposachannel_2_colimator, mcposachannel_3_colimator);
  mcposrchannel_3_colimator = rot_apply(mcrotachannel_3_colimator, mctc1);
  mcDEBUG_COMPONENT("channel_3_colimator", mcposachannel_3_colimator, mcrotachannel_3_colimator)
  mccomp_posa[93] = mcposachannel_3_colimator;
  mccomp_posr[93] = mcposrchannel_3_colimator;
  mcNCounter[93]  = mcPCounter[93] = mcP2Counter[93] = 0;
  mcAbsorbProp[93]= 0;
    /* Component channel_4_colimator. */
  /* Setting parameters for component channel_4_colimator. */
  SIG_MESSAGE("channel_4_colimator (Init:SetPar)");
#line 46 "MACS_sample_kidney_box.instr"
  mccchannel_4_colimator_xmin = -0.02;
#line 46 "MACS_sample_kidney_box.instr"
  mccchannel_4_colimator_xmax = 0.02;
#line 46 "MACS_sample_kidney_box.instr"
  mccchannel_4_colimator_ymin = -0.05;
#line 46 "MACS_sample_kidney_box.instr"
  mccchannel_4_colimator_ymax = 0.05;
#line 302 "MACS_sample_kidney_box.instr"
  mccchannel_4_colimator_xwidth = channel_colimator_width;
#line 302 "MACS_sample_kidney_box.instr"
  mccchannel_4_colimator_yheight = channel_colimator_height;
#line 303 "MACS_sample_kidney_box.instr"
  mccchannel_4_colimator_length = channel_colimator_length;
#line 303 "MACS_sample_kidney_box.instr"
  mccchannel_4_colimator_divergence = channel_colimator_divergence_arcmin;
#line 303 "MACS_sample_kidney_box.instr"
  mccchannel_4_colimator_transmission = channel_colimator_transmission;
#line 46 "MACS_sample_kidney_box.instr"
  mccchannel_4_colimator_divergenceV = 0;
#line 94669 "MACS_sample_kidney_box.c"

  SIG_MESSAGE("channel_4_colimator (Init:Place/Rotate)");
  rot_set_rotation(mctr1,
#line 306 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 306 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 306 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD);
#line 94679 "MACS_sample_kidney_box.c"
  rot_mul(mctr1, mcrotakidney_channel_4, mcrotachannel_4_colimator);
  rot_transpose(mcrotachannel_3_colimator, mctr1);
  rot_mul(mcrotachannel_4_colimator, mctr1, mcrotrchannel_4_colimator);
  mctc1 = coords_set(
#line 305 "MACS_sample_kidney_box.instr"
    0,
#line 305 "MACS_sample_kidney_box.instr"
    0,
#line 305 "MACS_sample_kidney_box.instr"
    channel_colimator_target_dist);
#line 94690 "MACS_sample_kidney_box.c"
  rot_transpose(mcrotakidney_channel_4, mctr1);
  mctc2 = rot_apply(mctr1, mctc1);
  mcposachannel_4_colimator = coords_add(mcposakidney_channel_4, mctc2);
  mctc1 = coords_sub(mcposachannel_3_colimator, mcposachannel_4_colimator);
  mcposrchannel_4_colimator = rot_apply(mcrotachannel_4_colimator, mctc1);
  mcDEBUG_COMPONENT("channel_4_colimator", mcposachannel_4_colimator, mcrotachannel_4_colimator)
  mccomp_posa[94] = mcposachannel_4_colimator;
  mccomp_posr[94] = mcposrchannel_4_colimator;
  mcNCounter[94]  = mcPCounter[94] = mcP2Counter[94] = 0;
  mcAbsorbProp[94]= 0;
    /* Component channel_5_colimator. */
  /* Setting parameters for component channel_5_colimator. */
  SIG_MESSAGE("channel_5_colimator (Init:SetPar)");
#line 46 "MACS_sample_kidney_box.instr"
  mccchannel_5_colimator_xmin = -0.02;
#line 46 "MACS_sample_kidney_box.instr"
  mccchannel_5_colimator_xmax = 0.02;
#line 46 "MACS_sample_kidney_box.instr"
  mccchannel_5_colimator_ymin = -0.05;
#line 46 "MACS_sample_kidney_box.instr"
  mccchannel_5_colimator_ymax = 0.05;
#line 308 "MACS_sample_kidney_box.instr"
  mccchannel_5_colimator_xwidth = channel_colimator_width;
#line 308 "MACS_sample_kidney_box.instr"
  mccchannel_5_colimator_yheight = channel_colimator_height;
#line 309 "MACS_sample_kidney_box.instr"
  mccchannel_5_colimator_length = channel_colimator_length;
#line 309 "MACS_sample_kidney_box.instr"
  mccchannel_5_colimator_divergence = channel_colimator_divergence_arcmin;
#line 309 "MACS_sample_kidney_box.instr"
  mccchannel_5_colimator_transmission = channel_colimator_transmission;
#line 46 "MACS_sample_kidney_box.instr"
  mccchannel_5_colimator_divergenceV = 0;
#line 94724 "MACS_sample_kidney_box.c"

  SIG_MESSAGE("channel_5_colimator (Init:Place/Rotate)");
  rot_set_rotation(mctr1,
#line 312 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 312 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 312 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD);
#line 94734 "MACS_sample_kidney_box.c"
  rot_mul(mctr1, mcrotakidney_channel_5, mcrotachannel_5_colimator);
  rot_transpose(mcrotachannel_4_colimator, mctr1);
  rot_mul(mcrotachannel_5_colimator, mctr1, mcrotrchannel_5_colimator);
  mctc1 = coords_set(
#line 311 "MACS_sample_kidney_box.instr"
    0,
#line 311 "MACS_sample_kidney_box.instr"
    0,
#line 311 "MACS_sample_kidney_box.instr"
    channel_colimator_target_dist);
#line 94745 "MACS_sample_kidney_box.c"
  rot_transpose(mcrotakidney_channel_5, mctr1);
  mctc2 = rot_apply(mctr1, mctc1);
  mcposachannel_5_colimator = coords_add(mcposakidney_channel_5, mctc2);
  mctc1 = coords_sub(mcposachannel_4_colimator, mcposachannel_5_colimator);
  mcposrchannel_5_colimator = rot_apply(mcrotachannel_5_colimator, mctc1);
  mcDEBUG_COMPONENT("channel_5_colimator", mcposachannel_5_colimator, mcrotachannel_5_colimator)
  mccomp_posa[95] = mcposachannel_5_colimator;
  mccomp_posr[95] = mcposrchannel_5_colimator;
  mcNCounter[95]  = mcPCounter[95] = mcP2Counter[95] = 0;
  mcAbsorbProp[95]= 0;
    /* Component channel_6_colimator. */
  /* Setting parameters for component channel_6_colimator. */
  SIG_MESSAGE("channel_6_colimator (Init:SetPar)");
#line 46 "MACS_sample_kidney_box.instr"
  mccchannel_6_colimator_xmin = -0.02;
#line 46 "MACS_sample_kidney_box.instr"
  mccchannel_6_colimator_xmax = 0.02;
#line 46 "MACS_sample_kidney_box.instr"
  mccchannel_6_colimator_ymin = -0.05;
#line 46 "MACS_sample_kidney_box.instr"
  mccchannel_6_colimator_ymax = 0.05;
#line 314 "MACS_sample_kidney_box.instr"
  mccchannel_6_colimator_xwidth = channel_colimator_width;
#line 314 "MACS_sample_kidney_box.instr"
  mccchannel_6_colimator_yheight = channel_colimator_height;
#line 315 "MACS_sample_kidney_box.instr"
  mccchannel_6_colimator_length = channel_colimator_length;
#line 315 "MACS_sample_kidney_box.instr"
  mccchannel_6_colimator_divergence = channel_colimator_divergence_arcmin;
#line 315 "MACS_sample_kidney_box.instr"
  mccchannel_6_colimator_transmission = channel_colimator_transmission;
#line 46 "MACS_sample_kidney_box.instr"
  mccchannel_6_colimator_divergenceV = 0;
#line 94779 "MACS_sample_kidney_box.c"

  SIG_MESSAGE("channel_6_colimator (Init:Place/Rotate)");
  rot_set_rotation(mctr1,
#line 318 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 318 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 318 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD);
#line 94789 "MACS_sample_kidney_box.c"
  rot_mul(mctr1, mcrotakidney_channel_6, mcrotachannel_6_colimator);
  rot_transpose(mcrotachannel_5_colimator, mctr1);
  rot_mul(mcrotachannel_6_colimator, mctr1, mcrotrchannel_6_colimator);
  mctc1 = coords_set(
#line 317 "MACS_sample_kidney_box.instr"
    0,
#line 317 "MACS_sample_kidney_box.instr"
    0,
#line 317 "MACS_sample_kidney_box.instr"
    channel_colimator_target_dist);
#line 94800 "MACS_sample_kidney_box.c"
  rot_transpose(mcrotakidney_channel_6, mctr1);
  mctc2 = rot_apply(mctr1, mctc1);
  mcposachannel_6_colimator = coords_add(mcposakidney_channel_6, mctc2);
  mctc1 = coords_sub(mcposachannel_5_colimator, mcposachannel_6_colimator);
  mcposrchannel_6_colimator = rot_apply(mcrotachannel_6_colimator, mctc1);
  mcDEBUG_COMPONENT("channel_6_colimator", mcposachannel_6_colimator, mcrotachannel_6_colimator)
  mccomp_posa[96] = mcposachannel_6_colimator;
  mccomp_posr[96] = mcposrchannel_6_colimator;
  mcNCounter[96]  = mcPCounter[96] = mcP2Counter[96] = 0;
  mcAbsorbProp[96]= 0;
    /* Component channel_7_colimator. */
  /* Setting parameters for component channel_7_colimator. */
  SIG_MESSAGE("channel_7_colimator (Init:SetPar)");
#line 46 "MACS_sample_kidney_box.instr"
  mccchannel_7_colimator_xmin = -0.02;
#line 46 "MACS_sample_kidney_box.instr"
  mccchannel_7_colimator_xmax = 0.02;
#line 46 "MACS_sample_kidney_box.instr"
  mccchannel_7_colimator_ymin = -0.05;
#line 46 "MACS_sample_kidney_box.instr"
  mccchannel_7_colimator_ymax = 0.05;
#line 320 "MACS_sample_kidney_box.instr"
  mccchannel_7_colimator_xwidth = channel_colimator_width;
#line 320 "MACS_sample_kidney_box.instr"
  mccchannel_7_colimator_yheight = channel_colimator_height;
#line 321 "MACS_sample_kidney_box.instr"
  mccchannel_7_colimator_length = channel_colimator_length;
#line 321 "MACS_sample_kidney_box.instr"
  mccchannel_7_colimator_divergence = channel_colimator_divergence_arcmin;
#line 321 "MACS_sample_kidney_box.instr"
  mccchannel_7_colimator_transmission = channel_colimator_transmission;
#line 46 "MACS_sample_kidney_box.instr"
  mccchannel_7_colimator_divergenceV = 0;
#line 94834 "MACS_sample_kidney_box.c"

  SIG_MESSAGE("channel_7_colimator (Init:Place/Rotate)");
  rot_set_rotation(mctr1,
#line 324 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 324 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 324 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD);
#line 94844 "MACS_sample_kidney_box.c"
  rot_mul(mctr1, mcrotakidney_channel_7, mcrotachannel_7_colimator);
  rot_transpose(mcrotachannel_6_colimator, mctr1);
  rot_mul(mcrotachannel_7_colimator, mctr1, mcrotrchannel_7_colimator);
  mctc1 = coords_set(
#line 323 "MACS_sample_kidney_box.instr"
    0,
#line 323 "MACS_sample_kidney_box.instr"
    0,
#line 323 "MACS_sample_kidney_box.instr"
    channel_colimator_target_dist);
#line 94855 "MACS_sample_kidney_box.c"
  rot_transpose(mcrotakidney_channel_7, mctr1);
  mctc2 = rot_apply(mctr1, mctc1);
  mcposachannel_7_colimator = coords_add(mcposakidney_channel_7, mctc2);
  mctc1 = coords_sub(mcposachannel_6_colimator, mcposachannel_7_colimator);
  mcposrchannel_7_colimator = rot_apply(mcrotachannel_7_colimator, mctc1);
  mcDEBUG_COMPONENT("channel_7_colimator", mcposachannel_7_colimator, mcrotachannel_7_colimator)
  mccomp_posa[97] = mcposachannel_7_colimator;
  mccomp_posr[97] = mcposrchannel_7_colimator;
  mcNCounter[97]  = mcPCounter[97] = mcP2Counter[97] = 0;
  mcAbsorbProp[97]= 0;
    /* Component channel_8_colimator. */
  /* Setting parameters for component channel_8_colimator. */
  SIG_MESSAGE("channel_8_colimator (Init:SetPar)");
#line 46 "MACS_sample_kidney_box.instr"
  mccchannel_8_colimator_xmin = -0.02;
#line 46 "MACS_sample_kidney_box.instr"
  mccchannel_8_colimator_xmax = 0.02;
#line 46 "MACS_sample_kidney_box.instr"
  mccchannel_8_colimator_ymin = -0.05;
#line 46 "MACS_sample_kidney_box.instr"
  mccchannel_8_colimator_ymax = 0.05;
#line 326 "MACS_sample_kidney_box.instr"
  mccchannel_8_colimator_xwidth = channel_colimator_width;
#line 326 "MACS_sample_kidney_box.instr"
  mccchannel_8_colimator_yheight = channel_colimator_height;
#line 327 "MACS_sample_kidney_box.instr"
  mccchannel_8_colimator_length = channel_colimator_length;
#line 327 "MACS_sample_kidney_box.instr"
  mccchannel_8_colimator_divergence = channel_colimator_divergence_arcmin;
#line 327 "MACS_sample_kidney_box.instr"
  mccchannel_8_colimator_transmission = channel_colimator_transmission;
#line 46 "MACS_sample_kidney_box.instr"
  mccchannel_8_colimator_divergenceV = 0;
#line 94889 "MACS_sample_kidney_box.c"

  SIG_MESSAGE("channel_8_colimator (Init:Place/Rotate)");
  rot_set_rotation(mctr1,
#line 330 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 330 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 330 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD);
#line 94899 "MACS_sample_kidney_box.c"
  rot_mul(mctr1, mcrotakidney_channel_8, mcrotachannel_8_colimator);
  rot_transpose(mcrotachannel_7_colimator, mctr1);
  rot_mul(mcrotachannel_8_colimator, mctr1, mcrotrchannel_8_colimator);
  mctc1 = coords_set(
#line 329 "MACS_sample_kidney_box.instr"
    0,
#line 329 "MACS_sample_kidney_box.instr"
    0,
#line 329 "MACS_sample_kidney_box.instr"
    channel_colimator_target_dist);
#line 94910 "MACS_sample_kidney_box.c"
  rot_transpose(mcrotakidney_channel_8, mctr1);
  mctc2 = rot_apply(mctr1, mctc1);
  mcposachannel_8_colimator = coords_add(mcposakidney_channel_8, mctc2);
  mctc1 = coords_sub(mcposachannel_7_colimator, mcposachannel_8_colimator);
  mcposrchannel_8_colimator = rot_apply(mcrotachannel_8_colimator, mctc1);
  mcDEBUG_COMPONENT("channel_8_colimator", mcposachannel_8_colimator, mcrotachannel_8_colimator)
  mccomp_posa[98] = mcposachannel_8_colimator;
  mccomp_posr[98] = mcposrchannel_8_colimator;
  mcNCounter[98]  = mcPCounter[98] = mcP2Counter[98] = 0;
  mcAbsorbProp[98]= 0;
    /* Component channel_9_colimator. */
  /* Setting parameters for component channel_9_colimator. */
  SIG_MESSAGE("channel_9_colimator (Init:SetPar)");
#line 46 "MACS_sample_kidney_box.instr"
  mccchannel_9_colimator_xmin = -0.02;
#line 46 "MACS_sample_kidney_box.instr"
  mccchannel_9_colimator_xmax = 0.02;
#line 46 "MACS_sample_kidney_box.instr"
  mccchannel_9_colimator_ymin = -0.05;
#line 46 "MACS_sample_kidney_box.instr"
  mccchannel_9_colimator_ymax = 0.05;
#line 332 "MACS_sample_kidney_box.instr"
  mccchannel_9_colimator_xwidth = channel_colimator_width;
#line 332 "MACS_sample_kidney_box.instr"
  mccchannel_9_colimator_yheight = channel_colimator_height;
#line 333 "MACS_sample_kidney_box.instr"
  mccchannel_9_colimator_length = channel_colimator_length;
#line 333 "MACS_sample_kidney_box.instr"
  mccchannel_9_colimator_divergence = channel_colimator_divergence_arcmin;
#line 333 "MACS_sample_kidney_box.instr"
  mccchannel_9_colimator_transmission = channel_colimator_transmission;
#line 46 "MACS_sample_kidney_box.instr"
  mccchannel_9_colimator_divergenceV = 0;
#line 94944 "MACS_sample_kidney_box.c"

  SIG_MESSAGE("channel_9_colimator (Init:Place/Rotate)");
  rot_set_rotation(mctr1,
#line 336 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 336 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 336 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD);
#line 94954 "MACS_sample_kidney_box.c"
  rot_mul(mctr1, mcrotakidney_channel_9, mcrotachannel_9_colimator);
  rot_transpose(mcrotachannel_8_colimator, mctr1);
  rot_mul(mcrotachannel_9_colimator, mctr1, mcrotrchannel_9_colimator);
  mctc1 = coords_set(
#line 335 "MACS_sample_kidney_box.instr"
    0,
#line 335 "MACS_sample_kidney_box.instr"
    0,
#line 335 "MACS_sample_kidney_box.instr"
    channel_colimator_target_dist);
#line 94965 "MACS_sample_kidney_box.c"
  rot_transpose(mcrotakidney_channel_9, mctr1);
  mctc2 = rot_apply(mctr1, mctc1);
  mcposachannel_9_colimator = coords_add(mcposakidney_channel_9, mctc2);
  mctc1 = coords_sub(mcposachannel_8_colimator, mcposachannel_9_colimator);
  mcposrchannel_9_colimator = rot_apply(mcrotachannel_9_colimator, mctc1);
  mcDEBUG_COMPONENT("channel_9_colimator", mcposachannel_9_colimator, mcrotachannel_9_colimator)
  mccomp_posa[99] = mcposachannel_9_colimator;
  mccomp_posr[99] = mcposrchannel_9_colimator;
  mcNCounter[99]  = mcPCounter[99] = mcP2Counter[99] = 0;
  mcAbsorbProp[99]= 0;
    /* Component channel_10_colimator. */
  /* Setting parameters for component channel_10_colimator. */
  SIG_MESSAGE("channel_10_colimator (Init:SetPar)");
#line 46 "MACS_sample_kidney_box.instr"
  mccchannel_10_colimator_xmin = -0.02;
#line 46 "MACS_sample_kidney_box.instr"
  mccchannel_10_colimator_xmax = 0.02;
#line 46 "MACS_sample_kidney_box.instr"
  mccchannel_10_colimator_ymin = -0.05;
#line 46 "MACS_sample_kidney_box.instr"
  mccchannel_10_colimator_ymax = 0.05;
#line 338 "MACS_sample_kidney_box.instr"
  mccchannel_10_colimator_xwidth = channel_colimator_width;
#line 338 "MACS_sample_kidney_box.instr"
  mccchannel_10_colimator_yheight = channel_colimator_height;
#line 339 "MACS_sample_kidney_box.instr"
  mccchannel_10_colimator_length = channel_colimator_length;
#line 339 "MACS_sample_kidney_box.instr"
  mccchannel_10_colimator_divergence = channel_colimator_divergence_arcmin;
#line 339 "MACS_sample_kidney_box.instr"
  mccchannel_10_colimator_transmission = channel_colimator_transmission;
#line 46 "MACS_sample_kidney_box.instr"
  mccchannel_10_colimator_divergenceV = 0;
#line 94999 "MACS_sample_kidney_box.c"

  SIG_MESSAGE("channel_10_colimator (Init:Place/Rotate)");
  rot_set_rotation(mctr1,
#line 342 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 342 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 342 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD);
#line 95009 "MACS_sample_kidney_box.c"
  rot_mul(mctr1, mcrotakidney_channel_10, mcrotachannel_10_colimator);
  rot_transpose(mcrotachannel_9_colimator, mctr1);
  rot_mul(mcrotachannel_10_colimator, mctr1, mcrotrchannel_10_colimator);
  mctc1 = coords_set(
#line 341 "MACS_sample_kidney_box.instr"
    0,
#line 341 "MACS_sample_kidney_box.instr"
    0,
#line 341 "MACS_sample_kidney_box.instr"
    channel_colimator_target_dist);
#line 95020 "MACS_sample_kidney_box.c"
  rot_transpose(mcrotakidney_channel_10, mctr1);
  mctc2 = rot_apply(mctr1, mctc1);
  mcposachannel_10_colimator = coords_add(mcposakidney_channel_10, mctc2);
  mctc1 = coords_sub(mcposachannel_9_colimator, mcposachannel_10_colimator);
  mcposrchannel_10_colimator = rot_apply(mcrotachannel_10_colimator, mctc1);
  mcDEBUG_COMPONENT("channel_10_colimator", mcposachannel_10_colimator, mcrotachannel_10_colimator)
  mccomp_posa[100] = mcposachannel_10_colimator;
  mccomp_posr[100] = mcposrchannel_10_colimator;
  mcNCounter[100]  = mcPCounter[100] = mcP2Counter[100] = 0;
  mcAbsorbProp[100]= 0;
    /* Component channel_11_colimator. */
  /* Setting parameters for component channel_11_colimator. */
  SIG_MESSAGE("channel_11_colimator (Init:SetPar)");
#line 46 "MACS_sample_kidney_box.instr"
  mccchannel_11_colimator_xmin = -0.02;
#line 46 "MACS_sample_kidney_box.instr"
  mccchannel_11_colimator_xmax = 0.02;
#line 46 "MACS_sample_kidney_box.instr"
  mccchannel_11_colimator_ymin = -0.05;
#line 46 "MACS_sample_kidney_box.instr"
  mccchannel_11_colimator_ymax = 0.05;
#line 344 "MACS_sample_kidney_box.instr"
  mccchannel_11_colimator_xwidth = channel_colimator_width;
#line 344 "MACS_sample_kidney_box.instr"
  mccchannel_11_colimator_yheight = channel_colimator_height;
#line 345 "MACS_sample_kidney_box.instr"
  mccchannel_11_colimator_length = channel_colimator_length;
#line 345 "MACS_sample_kidney_box.instr"
  mccchannel_11_colimator_divergence = channel_colimator_divergence_arcmin;
#line 345 "MACS_sample_kidney_box.instr"
  mccchannel_11_colimator_transmission = channel_colimator_transmission;
#line 46 "MACS_sample_kidney_box.instr"
  mccchannel_11_colimator_divergenceV = 0;
#line 95054 "MACS_sample_kidney_box.c"

  SIG_MESSAGE("channel_11_colimator (Init:Place/Rotate)");
  rot_set_rotation(mctr1,
#line 348 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 348 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 348 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD);
#line 95064 "MACS_sample_kidney_box.c"
  rot_mul(mctr1, mcrotakidney_channel_11, mcrotachannel_11_colimator);
  rot_transpose(mcrotachannel_10_colimator, mctr1);
  rot_mul(mcrotachannel_11_colimator, mctr1, mcrotrchannel_11_colimator);
  mctc1 = coords_set(
#line 347 "MACS_sample_kidney_box.instr"
    0,
#line 347 "MACS_sample_kidney_box.instr"
    0,
#line 347 "MACS_sample_kidney_box.instr"
    channel_colimator_target_dist);
#line 95075 "MACS_sample_kidney_box.c"
  rot_transpose(mcrotakidney_channel_11, mctr1);
  mctc2 = rot_apply(mctr1, mctc1);
  mcposachannel_11_colimator = coords_add(mcposakidney_channel_11, mctc2);
  mctc1 = coords_sub(mcposachannel_10_colimator, mcposachannel_11_colimator);
  mcposrchannel_11_colimator = rot_apply(mcrotachannel_11_colimator, mctc1);
  mcDEBUG_COMPONENT("channel_11_colimator", mcposachannel_11_colimator, mcrotachannel_11_colimator)
  mccomp_posa[101] = mcposachannel_11_colimator;
  mccomp_posr[101] = mcposrchannel_11_colimator;
  mcNCounter[101]  = mcPCounter[101] = mcP2Counter[101] = 0;
  mcAbsorbProp[101]= 0;
    /* Component channel_12_colimator. */
  /* Setting parameters for component channel_12_colimator. */
  SIG_MESSAGE("channel_12_colimator (Init:SetPar)");
#line 46 "MACS_sample_kidney_box.instr"
  mccchannel_12_colimator_xmin = -0.02;
#line 46 "MACS_sample_kidney_box.instr"
  mccchannel_12_colimator_xmax = 0.02;
#line 46 "MACS_sample_kidney_box.instr"
  mccchannel_12_colimator_ymin = -0.05;
#line 46 "MACS_sample_kidney_box.instr"
  mccchannel_12_colimator_ymax = 0.05;
#line 350 "MACS_sample_kidney_box.instr"
  mccchannel_12_colimator_xwidth = channel_colimator_width;
#line 350 "MACS_sample_kidney_box.instr"
  mccchannel_12_colimator_yheight = channel_colimator_height;
#line 351 "MACS_sample_kidney_box.instr"
  mccchannel_12_colimator_length = channel_colimator_length;
#line 351 "MACS_sample_kidney_box.instr"
  mccchannel_12_colimator_divergence = channel_colimator_divergence_arcmin;
#line 351 "MACS_sample_kidney_box.instr"
  mccchannel_12_colimator_transmission = channel_colimator_transmission;
#line 46 "MACS_sample_kidney_box.instr"
  mccchannel_12_colimator_divergenceV = 0;
#line 95109 "MACS_sample_kidney_box.c"

  SIG_MESSAGE("channel_12_colimator (Init:Place/Rotate)");
  rot_set_rotation(mctr1,
#line 354 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 354 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 354 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD);
#line 95119 "MACS_sample_kidney_box.c"
  rot_mul(mctr1, mcrotakidney_channel_12, mcrotachannel_12_colimator);
  rot_transpose(mcrotachannel_11_colimator, mctr1);
  rot_mul(mcrotachannel_12_colimator, mctr1, mcrotrchannel_12_colimator);
  mctc1 = coords_set(
#line 353 "MACS_sample_kidney_box.instr"
    0,
#line 353 "MACS_sample_kidney_box.instr"
    0,
#line 353 "MACS_sample_kidney_box.instr"
    channel_colimator_target_dist);
#line 95130 "MACS_sample_kidney_box.c"
  rot_transpose(mcrotakidney_channel_12, mctr1);
  mctc2 = rot_apply(mctr1, mctc1);
  mcposachannel_12_colimator = coords_add(mcposakidney_channel_12, mctc2);
  mctc1 = coords_sub(mcposachannel_11_colimator, mcposachannel_12_colimator);
  mcposrchannel_12_colimator = rot_apply(mcrotachannel_12_colimator, mctc1);
  mcDEBUG_COMPONENT("channel_12_colimator", mcposachannel_12_colimator, mcrotachannel_12_colimator)
  mccomp_posa[102] = mcposachannel_12_colimator;
  mccomp_posr[102] = mcposrchannel_12_colimator;
  mcNCounter[102]  = mcPCounter[102] = mcP2Counter[102] = 0;
  mcAbsorbProp[102]= 0;
    /* Component channel_13_colimator. */
  /* Setting parameters for component channel_13_colimator. */
  SIG_MESSAGE("channel_13_colimator (Init:SetPar)");
#line 46 "MACS_sample_kidney_box.instr"
  mccchannel_13_colimator_xmin = -0.02;
#line 46 "MACS_sample_kidney_box.instr"
  mccchannel_13_colimator_xmax = 0.02;
#line 46 "MACS_sample_kidney_box.instr"
  mccchannel_13_colimator_ymin = -0.05;
#line 46 "MACS_sample_kidney_box.instr"
  mccchannel_13_colimator_ymax = 0.05;
#line 356 "MACS_sample_kidney_box.instr"
  mccchannel_13_colimator_xwidth = channel_colimator_width;
#line 356 "MACS_sample_kidney_box.instr"
  mccchannel_13_colimator_yheight = channel_colimator_height;
#line 357 "MACS_sample_kidney_box.instr"
  mccchannel_13_colimator_length = channel_colimator_length;
#line 357 "MACS_sample_kidney_box.instr"
  mccchannel_13_colimator_divergence = channel_colimator_divergence_arcmin;
#line 357 "MACS_sample_kidney_box.instr"
  mccchannel_13_colimator_transmission = channel_colimator_transmission;
#line 46 "MACS_sample_kidney_box.instr"
  mccchannel_13_colimator_divergenceV = 0;
#line 95164 "MACS_sample_kidney_box.c"

  SIG_MESSAGE("channel_13_colimator (Init:Place/Rotate)");
  rot_set_rotation(mctr1,
#line 360 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 360 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 360 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD);
#line 95174 "MACS_sample_kidney_box.c"
  rot_mul(mctr1, mcrotakidney_channel_13, mcrotachannel_13_colimator);
  rot_transpose(mcrotachannel_12_colimator, mctr1);
  rot_mul(mcrotachannel_13_colimator, mctr1, mcrotrchannel_13_colimator);
  mctc1 = coords_set(
#line 359 "MACS_sample_kidney_box.instr"
    0,
#line 359 "MACS_sample_kidney_box.instr"
    0,
#line 359 "MACS_sample_kidney_box.instr"
    channel_colimator_target_dist);
#line 95185 "MACS_sample_kidney_box.c"
  rot_transpose(mcrotakidney_channel_13, mctr1);
  mctc2 = rot_apply(mctr1, mctc1);
  mcposachannel_13_colimator = coords_add(mcposakidney_channel_13, mctc2);
  mctc1 = coords_sub(mcposachannel_12_colimator, mcposachannel_13_colimator);
  mcposrchannel_13_colimator = rot_apply(mcrotachannel_13_colimator, mctc1);
  mcDEBUG_COMPONENT("channel_13_colimator", mcposachannel_13_colimator, mcrotachannel_13_colimator)
  mccomp_posa[103] = mcposachannel_13_colimator;
  mccomp_posr[103] = mcposrchannel_13_colimator;
  mcNCounter[103]  = mcPCounter[103] = mcP2Counter[103] = 0;
  mcAbsorbProp[103]= 0;
    /* Component channel_14_colimator. */
  /* Setting parameters for component channel_14_colimator. */
  SIG_MESSAGE("channel_14_colimator (Init:SetPar)");
#line 46 "MACS_sample_kidney_box.instr"
  mccchannel_14_colimator_xmin = -0.02;
#line 46 "MACS_sample_kidney_box.instr"
  mccchannel_14_colimator_xmax = 0.02;
#line 46 "MACS_sample_kidney_box.instr"
  mccchannel_14_colimator_ymin = -0.05;
#line 46 "MACS_sample_kidney_box.instr"
  mccchannel_14_colimator_ymax = 0.05;
#line 362 "MACS_sample_kidney_box.instr"
  mccchannel_14_colimator_xwidth = channel_colimator_width;
#line 362 "MACS_sample_kidney_box.instr"
  mccchannel_14_colimator_yheight = channel_colimator_height;
#line 363 "MACS_sample_kidney_box.instr"
  mccchannel_14_colimator_length = channel_colimator_length;
#line 363 "MACS_sample_kidney_box.instr"
  mccchannel_14_colimator_divergence = channel_colimator_divergence_arcmin;
#line 363 "MACS_sample_kidney_box.instr"
  mccchannel_14_colimator_transmission = channel_colimator_transmission;
#line 46 "MACS_sample_kidney_box.instr"
  mccchannel_14_colimator_divergenceV = 0;
#line 95219 "MACS_sample_kidney_box.c"

  SIG_MESSAGE("channel_14_colimator (Init:Place/Rotate)");
  rot_set_rotation(mctr1,
#line 366 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 366 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 366 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD);
#line 95229 "MACS_sample_kidney_box.c"
  rot_mul(mctr1, mcrotakidney_channel_14, mcrotachannel_14_colimator);
  rot_transpose(mcrotachannel_13_colimator, mctr1);
  rot_mul(mcrotachannel_14_colimator, mctr1, mcrotrchannel_14_colimator);
  mctc1 = coords_set(
#line 365 "MACS_sample_kidney_box.instr"
    0,
#line 365 "MACS_sample_kidney_box.instr"
    0,
#line 365 "MACS_sample_kidney_box.instr"
    channel_colimator_target_dist);
#line 95240 "MACS_sample_kidney_box.c"
  rot_transpose(mcrotakidney_channel_14, mctr1);
  mctc2 = rot_apply(mctr1, mctc1);
  mcposachannel_14_colimator = coords_add(mcposakidney_channel_14, mctc2);
  mctc1 = coords_sub(mcposachannel_13_colimator, mcposachannel_14_colimator);
  mcposrchannel_14_colimator = rot_apply(mcrotachannel_14_colimator, mctc1);
  mcDEBUG_COMPONENT("channel_14_colimator", mcposachannel_14_colimator, mcrotachannel_14_colimator)
  mccomp_posa[104] = mcposachannel_14_colimator;
  mccomp_posr[104] = mcposrchannel_14_colimator;
  mcNCounter[104]  = mcPCounter[104] = mcP2Counter[104] = 0;
  mcAbsorbProp[104]= 0;
    /* Component channel_15_colimator. */
  /* Setting parameters for component channel_15_colimator. */
  SIG_MESSAGE("channel_15_colimator (Init:SetPar)");
#line 46 "MACS_sample_kidney_box.instr"
  mccchannel_15_colimator_xmin = -0.02;
#line 46 "MACS_sample_kidney_box.instr"
  mccchannel_15_colimator_xmax = 0.02;
#line 46 "MACS_sample_kidney_box.instr"
  mccchannel_15_colimator_ymin = -0.05;
#line 46 "MACS_sample_kidney_box.instr"
  mccchannel_15_colimator_ymax = 0.05;
#line 368 "MACS_sample_kidney_box.instr"
  mccchannel_15_colimator_xwidth = channel_colimator_width;
#line 368 "MACS_sample_kidney_box.instr"
  mccchannel_15_colimator_yheight = channel_colimator_height;
#line 369 "MACS_sample_kidney_box.instr"
  mccchannel_15_colimator_length = channel_colimator_length;
#line 369 "MACS_sample_kidney_box.instr"
  mccchannel_15_colimator_divergence = channel_colimator_divergence_arcmin;
#line 369 "MACS_sample_kidney_box.instr"
  mccchannel_15_colimator_transmission = channel_colimator_transmission;
#line 46 "MACS_sample_kidney_box.instr"
  mccchannel_15_colimator_divergenceV = 0;
#line 95274 "MACS_sample_kidney_box.c"

  SIG_MESSAGE("channel_15_colimator (Init:Place/Rotate)");
  rot_set_rotation(mctr1,
#line 372 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 372 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 372 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD);
#line 95284 "MACS_sample_kidney_box.c"
  rot_mul(mctr1, mcrotakidney_channel_15, mcrotachannel_15_colimator);
  rot_transpose(mcrotachannel_14_colimator, mctr1);
  rot_mul(mcrotachannel_15_colimator, mctr1, mcrotrchannel_15_colimator);
  mctc1 = coords_set(
#line 371 "MACS_sample_kidney_box.instr"
    0,
#line 371 "MACS_sample_kidney_box.instr"
    0,
#line 371 "MACS_sample_kidney_box.instr"
    channel_colimator_target_dist);
#line 95295 "MACS_sample_kidney_box.c"
  rot_transpose(mcrotakidney_channel_15, mctr1);
  mctc2 = rot_apply(mctr1, mctc1);
  mcposachannel_15_colimator = coords_add(mcposakidney_channel_15, mctc2);
  mctc1 = coords_sub(mcposachannel_14_colimator, mcposachannel_15_colimator);
  mcposrchannel_15_colimator = rot_apply(mcrotachannel_15_colimator, mctc1);
  mcDEBUG_COMPONENT("channel_15_colimator", mcposachannel_15_colimator, mcrotachannel_15_colimator)
  mccomp_posa[105] = mcposachannel_15_colimator;
  mccomp_posr[105] = mcposrchannel_15_colimator;
  mcNCounter[105]  = mcPCounter[105] = mcP2Counter[105] = 0;
  mcAbsorbProp[105]= 0;
    /* Component channel_16_colimator. */
  /* Setting parameters for component channel_16_colimator. */
  SIG_MESSAGE("channel_16_colimator (Init:SetPar)");
#line 46 "MACS_sample_kidney_box.instr"
  mccchannel_16_colimator_xmin = -0.02;
#line 46 "MACS_sample_kidney_box.instr"
  mccchannel_16_colimator_xmax = 0.02;
#line 46 "MACS_sample_kidney_box.instr"
  mccchannel_16_colimator_ymin = -0.05;
#line 46 "MACS_sample_kidney_box.instr"
  mccchannel_16_colimator_ymax = 0.05;
#line 374 "MACS_sample_kidney_box.instr"
  mccchannel_16_colimator_xwidth = channel_colimator_width;
#line 374 "MACS_sample_kidney_box.instr"
  mccchannel_16_colimator_yheight = channel_colimator_height;
#line 375 "MACS_sample_kidney_box.instr"
  mccchannel_16_colimator_length = channel_colimator_length;
#line 375 "MACS_sample_kidney_box.instr"
  mccchannel_16_colimator_divergence = channel_colimator_divergence_arcmin;
#line 375 "MACS_sample_kidney_box.instr"
  mccchannel_16_colimator_transmission = channel_colimator_transmission;
#line 46 "MACS_sample_kidney_box.instr"
  mccchannel_16_colimator_divergenceV = 0;
#line 95329 "MACS_sample_kidney_box.c"

  SIG_MESSAGE("channel_16_colimator (Init:Place/Rotate)");
  rot_set_rotation(mctr1,
#line 378 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 378 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 378 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD);
#line 95339 "MACS_sample_kidney_box.c"
  rot_mul(mctr1, mcrotakidney_channel_16, mcrotachannel_16_colimator);
  rot_transpose(mcrotachannel_15_colimator, mctr1);
  rot_mul(mcrotachannel_16_colimator, mctr1, mcrotrchannel_16_colimator);
  mctc1 = coords_set(
#line 377 "MACS_sample_kidney_box.instr"
    0,
#line 377 "MACS_sample_kidney_box.instr"
    0,
#line 377 "MACS_sample_kidney_box.instr"
    channel_colimator_target_dist);
#line 95350 "MACS_sample_kidney_box.c"
  rot_transpose(mcrotakidney_channel_16, mctr1);
  mctc2 = rot_apply(mctr1, mctc1);
  mcposachannel_16_colimator = coords_add(mcposakidney_channel_16, mctc2);
  mctc1 = coords_sub(mcposachannel_15_colimator, mcposachannel_16_colimator);
  mcposrchannel_16_colimator = rot_apply(mcrotachannel_16_colimator, mctc1);
  mcDEBUG_COMPONENT("channel_16_colimator", mcposachannel_16_colimator, mcrotachannel_16_colimator)
  mccomp_posa[106] = mcposachannel_16_colimator;
  mccomp_posr[106] = mcposrchannel_16_colimator;
  mcNCounter[106]  = mcPCounter[106] = mcP2Counter[106] = 0;
  mcAbsorbProp[106]= 0;
    /* Component channel_17_colimator. */
  /* Setting parameters for component channel_17_colimator. */
  SIG_MESSAGE("channel_17_colimator (Init:SetPar)");
#line 46 "MACS_sample_kidney_box.instr"
  mccchannel_17_colimator_xmin = -0.02;
#line 46 "MACS_sample_kidney_box.instr"
  mccchannel_17_colimator_xmax = 0.02;
#line 46 "MACS_sample_kidney_box.instr"
  mccchannel_17_colimator_ymin = -0.05;
#line 46 "MACS_sample_kidney_box.instr"
  mccchannel_17_colimator_ymax = 0.05;
#line 380 "MACS_sample_kidney_box.instr"
  mccchannel_17_colimator_xwidth = channel_colimator_width;
#line 380 "MACS_sample_kidney_box.instr"
  mccchannel_17_colimator_yheight = channel_colimator_height;
#line 381 "MACS_sample_kidney_box.instr"
  mccchannel_17_colimator_length = channel_colimator_length;
#line 381 "MACS_sample_kidney_box.instr"
  mccchannel_17_colimator_divergence = channel_colimator_divergence_arcmin;
#line 381 "MACS_sample_kidney_box.instr"
  mccchannel_17_colimator_transmission = channel_colimator_transmission;
#line 46 "MACS_sample_kidney_box.instr"
  mccchannel_17_colimator_divergenceV = 0;
#line 95384 "MACS_sample_kidney_box.c"

  SIG_MESSAGE("channel_17_colimator (Init:Place/Rotate)");
  rot_set_rotation(mctr1,
#line 384 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 384 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 384 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD);
#line 95394 "MACS_sample_kidney_box.c"
  rot_mul(mctr1, mcrotakidney_channel_17, mcrotachannel_17_colimator);
  rot_transpose(mcrotachannel_16_colimator, mctr1);
  rot_mul(mcrotachannel_17_colimator, mctr1, mcrotrchannel_17_colimator);
  mctc1 = coords_set(
#line 383 "MACS_sample_kidney_box.instr"
    0,
#line 383 "MACS_sample_kidney_box.instr"
    0,
#line 383 "MACS_sample_kidney_box.instr"
    channel_colimator_target_dist);
#line 95405 "MACS_sample_kidney_box.c"
  rot_transpose(mcrotakidney_channel_17, mctr1);
  mctc2 = rot_apply(mctr1, mctc1);
  mcposachannel_17_colimator = coords_add(mcposakidney_channel_17, mctc2);
  mctc1 = coords_sub(mcposachannel_16_colimator, mcposachannel_17_colimator);
  mcposrchannel_17_colimator = rot_apply(mcrotachannel_17_colimator, mctc1);
  mcDEBUG_COMPONENT("channel_17_colimator", mcposachannel_17_colimator, mcrotachannel_17_colimator)
  mccomp_posa[107] = mcposachannel_17_colimator;
  mccomp_posr[107] = mcposrchannel_17_colimator;
  mcNCounter[107]  = mcPCounter[107] = mcP2Counter[107] = 0;
  mcAbsorbProp[107]= 0;
    /* Component channel_18_colimator. */
  /* Setting parameters for component channel_18_colimator. */
  SIG_MESSAGE("channel_18_colimator (Init:SetPar)");
#line 46 "MACS_sample_kidney_box.instr"
  mccchannel_18_colimator_xmin = -0.02;
#line 46 "MACS_sample_kidney_box.instr"
  mccchannel_18_colimator_xmax = 0.02;
#line 46 "MACS_sample_kidney_box.instr"
  mccchannel_18_colimator_ymin = -0.05;
#line 46 "MACS_sample_kidney_box.instr"
  mccchannel_18_colimator_ymax = 0.05;
#line 386 "MACS_sample_kidney_box.instr"
  mccchannel_18_colimator_xwidth = channel_colimator_width;
#line 386 "MACS_sample_kidney_box.instr"
  mccchannel_18_colimator_yheight = channel_colimator_height;
#line 387 "MACS_sample_kidney_box.instr"
  mccchannel_18_colimator_length = channel_colimator_length;
#line 387 "MACS_sample_kidney_box.instr"
  mccchannel_18_colimator_divergence = channel_colimator_divergence_arcmin;
#line 387 "MACS_sample_kidney_box.instr"
  mccchannel_18_colimator_transmission = channel_colimator_transmission;
#line 46 "MACS_sample_kidney_box.instr"
  mccchannel_18_colimator_divergenceV = 0;
#line 95439 "MACS_sample_kidney_box.c"

  SIG_MESSAGE("channel_18_colimator (Init:Place/Rotate)");
  rot_set_rotation(mctr1,
#line 390 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 390 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 390 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD);
#line 95449 "MACS_sample_kidney_box.c"
  rot_mul(mctr1, mcrotakidney_channel_18, mcrotachannel_18_colimator);
  rot_transpose(mcrotachannel_17_colimator, mctr1);
  rot_mul(mcrotachannel_18_colimator, mctr1, mcrotrchannel_18_colimator);
  mctc1 = coords_set(
#line 389 "MACS_sample_kidney_box.instr"
    0,
#line 389 "MACS_sample_kidney_box.instr"
    0,
#line 389 "MACS_sample_kidney_box.instr"
    channel_colimator_target_dist);
#line 95460 "MACS_sample_kidney_box.c"
  rot_transpose(mcrotakidney_channel_18, mctr1);
  mctc2 = rot_apply(mctr1, mctc1);
  mcposachannel_18_colimator = coords_add(mcposakidney_channel_18, mctc2);
  mctc1 = coords_sub(mcposachannel_17_colimator, mcposachannel_18_colimator);
  mcposrchannel_18_colimator = rot_apply(mcrotachannel_18_colimator, mctc1);
  mcDEBUG_COMPONENT("channel_18_colimator", mcposachannel_18_colimator, mcrotachannel_18_colimator)
  mccomp_posa[108] = mcposachannel_18_colimator;
  mccomp_posr[108] = mcposrchannel_18_colimator;
  mcNCounter[108]  = mcPCounter[108] = mcP2Counter[108] = 0;
  mcAbsorbProp[108]= 0;
    /* Component channel_19_colimator. */
  /* Setting parameters for component channel_19_colimator. */
  SIG_MESSAGE("channel_19_colimator (Init:SetPar)");
#line 46 "MACS_sample_kidney_box.instr"
  mccchannel_19_colimator_xmin = -0.02;
#line 46 "MACS_sample_kidney_box.instr"
  mccchannel_19_colimator_xmax = 0.02;
#line 46 "MACS_sample_kidney_box.instr"
  mccchannel_19_colimator_ymin = -0.05;
#line 46 "MACS_sample_kidney_box.instr"
  mccchannel_19_colimator_ymax = 0.05;
#line 392 "MACS_sample_kidney_box.instr"
  mccchannel_19_colimator_xwidth = channel_colimator_width;
#line 392 "MACS_sample_kidney_box.instr"
  mccchannel_19_colimator_yheight = channel_colimator_height;
#line 393 "MACS_sample_kidney_box.instr"
  mccchannel_19_colimator_length = channel_colimator_length;
#line 393 "MACS_sample_kidney_box.instr"
  mccchannel_19_colimator_divergence = channel_colimator_divergence_arcmin;
#line 393 "MACS_sample_kidney_box.instr"
  mccchannel_19_colimator_transmission = channel_colimator_transmission;
#line 46 "MACS_sample_kidney_box.instr"
  mccchannel_19_colimator_divergenceV = 0;
#line 95494 "MACS_sample_kidney_box.c"

  SIG_MESSAGE("channel_19_colimator (Init:Place/Rotate)");
  rot_set_rotation(mctr1,
#line 396 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 396 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 396 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD);
#line 95504 "MACS_sample_kidney_box.c"
  rot_mul(mctr1, mcrotakidney_channel_19, mcrotachannel_19_colimator);
  rot_transpose(mcrotachannel_18_colimator, mctr1);
  rot_mul(mcrotachannel_19_colimator, mctr1, mcrotrchannel_19_colimator);
  mctc1 = coords_set(
#line 395 "MACS_sample_kidney_box.instr"
    0,
#line 395 "MACS_sample_kidney_box.instr"
    0,
#line 395 "MACS_sample_kidney_box.instr"
    channel_colimator_target_dist);
#line 95515 "MACS_sample_kidney_box.c"
  rot_transpose(mcrotakidney_channel_19, mctr1);
  mctc2 = rot_apply(mctr1, mctc1);
  mcposachannel_19_colimator = coords_add(mcposakidney_channel_19, mctc2);
  mctc1 = coords_sub(mcposachannel_18_colimator, mcposachannel_19_colimator);
  mcposrchannel_19_colimator = rot_apply(mcrotachannel_19_colimator, mctc1);
  mcDEBUG_COMPONENT("channel_19_colimator", mcposachannel_19_colimator, mcrotachannel_19_colimator)
  mccomp_posa[109] = mcposachannel_19_colimator;
  mccomp_posr[109] = mcposrchannel_19_colimator;
  mcNCounter[109]  = mcPCounter[109] = mcP2Counter[109] = 0;
  mcAbsorbProp[109]= 0;
    /* Component boron_plastic_incoherent. */
  /* Setting parameters for component boron_plastic_incoherent. */
  SIG_MESSAGE("boron_plastic_incoherent (Init:SetPar)");
#line 401 "MACS_sample_kidney_box.instr"
  mccboron_plastic_incoherent_sigma = 1.80;
#line 55 "MACS_sample_kidney_box.instr"
  mccboron_plastic_incoherent_f_QE = 0;
#line 55 "MACS_sample_kidney_box.instr"
  mccboron_plastic_incoherent_gamma = 0;
#line 401 "MACS_sample_kidney_box.instr"
  mccboron_plastic_incoherent_packing_factor = 1;
#line 401 "MACS_sample_kidney_box.instr"
  mccboron_plastic_incoherent_unit_cell_volume = 1;
#line 401 "MACS_sample_kidney_box.instr"
  mccboron_plastic_incoherent_interact_fraction = -1;
#line 95541 "MACS_sample_kidney_box.c"

  SIG_MESSAGE("boron_plastic_incoherent (Init:Place/Rotate)");
  rot_set_rotation(mcrotaboron_plastic_incoherent,
    (0.0)*DEG2RAD,
    (0.0)*DEG2RAD,
    (0.0)*DEG2RAD);
#line 95548 "MACS_sample_kidney_box.c"
  rot_transpose(mcrotachannel_19_colimator, mctr1);
  rot_mul(mcrotaboron_plastic_incoherent, mctr1, mcrotrboron_plastic_incoherent);
  mcposaboron_plastic_incoherent = coords_set(
#line 402 "MACS_sample_kidney_box.instr"
    0,
#line 402 "MACS_sample_kidney_box.instr"
    0,
#line 402 "MACS_sample_kidney_box.instr"
    0);
#line 95558 "MACS_sample_kidney_box.c"
  mctc1 = coords_sub(mcposachannel_19_colimator, mcposaboron_plastic_incoherent);
  mcposrboron_plastic_incoherent = rot_apply(mcrotaboron_plastic_incoherent, mctc1);
  mcDEBUG_COMPONENT("boron_plastic_incoherent", mcposaboron_plastic_incoherent, mcrotaboron_plastic_incoherent)
  mccomp_posa[110] = mcposaboron_plastic_incoherent;
  mccomp_posr[110] = mcposrboron_plastic_incoherent;
  mcNCounter[110]  = mcPCounter[110] = mcP2Counter[110] = 0;
  mcAbsorbProp[110]= 0;
    /* Component boron_plastic. */
  /* Setting parameters for component boron_plastic. */
  SIG_MESSAGE("boron_plastic (Init:SetPar)");
#line 405 "MACS_sample_kidney_box.instr"
  if("boron_plastic_incoherent") strncpy(mccboron_plastic_process_string, "boron_plastic_incoherent" ? "boron_plastic_incoherent" : "", 16384); else mccboron_plastic_process_string[0]='\0';
#line 404 "MACS_sample_kidney_box.instr"
  mccboron_plastic_my_absorption = 3495;
#line 50 "MACS_sample_kidney_box.instr"
  mccboron_plastic_absorber = 0;
#line 95575 "MACS_sample_kidney_box.c"

  SIG_MESSAGE("boron_plastic (Init:Place/Rotate)");
  rot_set_rotation(mcrotaboron_plastic,
    (0.0)*DEG2RAD,
    (0.0)*DEG2RAD,
    (0.0)*DEG2RAD);
#line 95582 "MACS_sample_kidney_box.c"
  rot_transpose(mcrotaboron_plastic_incoherent, mctr1);
  rot_mul(mcrotaboron_plastic, mctr1, mcrotrboron_plastic);
  mcposaboron_plastic = coords_set(
#line 406 "MACS_sample_kidney_box.instr"
    0,
#line 406 "MACS_sample_kidney_box.instr"
    0,
#line 406 "MACS_sample_kidney_box.instr"
    0);
#line 95592 "MACS_sample_kidney_box.c"
  mctc1 = coords_sub(mcposaboron_plastic_incoherent, mcposaboron_plastic);
  mcposrboron_plastic = rot_apply(mcrotaboron_plastic, mctc1);
  mcDEBUG_COMPONENT("boron_plastic", mcposaboron_plastic, mcrotaboron_plastic)
  mccomp_posa[111] = mcposaboron_plastic;
  mccomp_posr[111] = mcposrboron_plastic;
  mcNCounter[111]  = mcPCounter[111] = mcP2Counter[111] = 0;
  mcAbsorbProp[111]= 0;
    /* Component boron_plastic_enriched_incoherent. */
  /* Setting parameters for component boron_plastic_enriched_incoherent. */
  SIG_MESSAGE("boron_plastic_enriched_incoherent (Init:SetPar)");
#line 409 "MACS_sample_kidney_box.instr"
  mccboron_plastic_enriched_incoherent_sigma = 1.82;
#line 55 "MACS_sample_kidney_box.instr"
  mccboron_plastic_enriched_incoherent_f_QE = 0;
#line 55 "MACS_sample_kidney_box.instr"
  mccboron_plastic_enriched_incoherent_gamma = 0;
#line 409 "MACS_sample_kidney_box.instr"
  mccboron_plastic_enriched_incoherent_packing_factor = 1;
#line 409 "MACS_sample_kidney_box.instr"
  mccboron_plastic_enriched_incoherent_unit_cell_volume = 1;
#line 409 "MACS_sample_kidney_box.instr"
  mccboron_plastic_enriched_incoherent_interact_fraction = -1;
#line 95615 "MACS_sample_kidney_box.c"

  SIG_MESSAGE("boron_plastic_enriched_incoherent (Init:Place/Rotate)");
  rot_set_rotation(mcrotaboron_plastic_enriched_incoherent,
    (0.0)*DEG2RAD,
    (0.0)*DEG2RAD,
    (0.0)*DEG2RAD);
#line 95622 "MACS_sample_kidney_box.c"
  rot_transpose(mcrotaboron_plastic, mctr1);
  rot_mul(mcrotaboron_plastic_enriched_incoherent, mctr1, mcrotrboron_plastic_enriched_incoherent);
  mcposaboron_plastic_enriched_incoherent = coords_set(
#line 410 "MACS_sample_kidney_box.instr"
    0,
#line 410 "MACS_sample_kidney_box.instr"
    0,
#line 410 "MACS_sample_kidney_box.instr"
    0);
#line 95632 "MACS_sample_kidney_box.c"
  mctc1 = coords_sub(mcposaboron_plastic, mcposaboron_plastic_enriched_incoherent);
  mcposrboron_plastic_enriched_incoherent = rot_apply(mcrotaboron_plastic_enriched_incoherent, mctc1);
  mcDEBUG_COMPONENT("boron_plastic_enriched_incoherent", mcposaboron_plastic_enriched_incoherent, mcrotaboron_plastic_enriched_incoherent)
  mccomp_posa[112] = mcposaboron_plastic_enriched_incoherent;
  mccomp_posr[112] = mcposrboron_plastic_enriched_incoherent;
  mcNCounter[112]  = mcPCounter[112] = mcP2Counter[112] = 0;
  mcAbsorbProp[112]= 0;
    /* Component boron_plastic_enriched. */
  /* Setting parameters for component boron_plastic_enriched. */
  SIG_MESSAGE("boron_plastic_enriched (Init:SetPar)");
#line 413 "MACS_sample_kidney_box.instr"
  if("boron_plastic_enriched_incoherent") strncpy(mccboron_plastic_enriched_process_string, "boron_plastic_enriched_incoherent" ? "boron_plastic_enriched_incoherent" : "", 16384); else mccboron_plastic_enriched_process_string[0]='\0';
#line 412 "MACS_sample_kidney_box.instr"
  mccboron_plastic_enriched_my_absorption = 8071;
#line 50 "MACS_sample_kidney_box.instr"
  mccboron_plastic_enriched_absorber = 0;
#line 95649 "MACS_sample_kidney_box.c"

  SIG_MESSAGE("boron_plastic_enriched (Init:Place/Rotate)");
  rot_set_rotation(mcrotaboron_plastic_enriched,
    (0.0)*DEG2RAD,
    (0.0)*DEG2RAD,
    (0.0)*DEG2RAD);
#line 95656 "MACS_sample_kidney_box.c"
  rot_transpose(mcrotaboron_plastic_enriched_incoherent, mctr1);
  rot_mul(mcrotaboron_plastic_enriched, mctr1, mcrotrboron_plastic_enriched);
  mcposaboron_plastic_enriched = coords_set(
#line 414 "MACS_sample_kidney_box.instr"
    0,
#line 414 "MACS_sample_kidney_box.instr"
    0,
#line 414 "MACS_sample_kidney_box.instr"
    0);
#line 95666 "MACS_sample_kidney_box.c"
  mctc1 = coords_sub(mcposaboron_plastic_enriched_incoherent, mcposaboron_plastic_enriched);
  mcposrboron_plastic_enriched = rot_apply(mcrotaboron_plastic_enriched, mctc1);
  mcDEBUG_COMPONENT("boron_plastic_enriched", mcposaboron_plastic_enriched, mcrotaboron_plastic_enriched)
  mccomp_posa[113] = mcposaboron_plastic_enriched;
  mccomp_posr[113] = mcposrboron_plastic_enriched;
  mcNCounter[113]  = mcPCounter[113] = mcP2Counter[113] = 0;
  mcAbsorbProp[113]= 0;
    /* Component Collimator_gad. */
  /* Setting parameters for component Collimator_gad. */
  SIG_MESSAGE("Collimator_gad (Init:SetPar)");
#line 417 "MACS_sample_kidney_box.instr"
  if("") strncpy(mccCollimator_gad_process_string, "" ? "" : "", 16384); else mccCollimator_gad_process_string[0]='\0';
#line 416 "MACS_sample_kidney_box.instr"
  mccCollimator_gad_my_absorption = 1000.0 * 4 / 35.29 * 100;
#line 416 "MACS_sample_kidney_box.instr"
  mccCollimator_gad_absorber = 1;
#line 95683 "MACS_sample_kidney_box.c"

  SIG_MESSAGE("Collimator_gad (Init:Place/Rotate)");
  rot_set_rotation(mcrotaCollimator_gad,
    (0.0)*DEG2RAD,
    (0.0)*DEG2RAD,
    (0.0)*DEG2RAD);
#line 95690 "MACS_sample_kidney_box.c"
  rot_transpose(mcrotaboron_plastic_enriched, mctr1);
  rot_mul(mcrotaCollimator_gad, mctr1, mcrotrCollimator_gad);
  mcposaCollimator_gad = coords_set(
#line 418 "MACS_sample_kidney_box.instr"
    0,
#line 418 "MACS_sample_kidney_box.instr"
    0,
#line 418 "MACS_sample_kidney_box.instr"
    0);
#line 95700 "MACS_sample_kidney_box.c"
  mctc1 = coords_sub(mcposaboron_plastic_enriched, mcposaCollimator_gad);
  mcposrCollimator_gad = rot_apply(mcrotaCollimator_gad, mctc1);
  mcDEBUG_COMPONENT("Collimator_gad", mcposaCollimator_gad, mcrotaCollimator_gad)
  mccomp_posa[114] = mcposaCollimator_gad;
  mccomp_posr[114] = mcposrCollimator_gad;
  mcNCounter[114]  = mcPCounter[114] = mcP2Counter[114] = 0;
  mcAbsorbProp[114]= 0;
    /* Component Incoherent_PG_analyzer. */
  /* Setting parameters for component Incoherent_PG_analyzer. */
  SIG_MESSAGE("Incoherent_PG_analyzer (Init:SetPar)");
#line 421 "MACS_sample_kidney_box.instr"
  mccIncoherent_PG_analyzer_sigma = 4 * 0.001;
#line 55 "MACS_sample_kidney_box.instr"
  mccIncoherent_PG_analyzer_f_QE = 0;
#line 55 "MACS_sample_kidney_box.instr"
  mccIncoherent_PG_analyzer_gamma = 0;
#line 421 "MACS_sample_kidney_box.instr"
  mccIncoherent_PG_analyzer_packing_factor = 1;
#line 421 "MACS_sample_kidney_box.instr"
  mccIncoherent_PG_analyzer_unit_cell_volume = 35.29;
#line 421 "MACS_sample_kidney_box.instr"
  mccIncoherent_PG_analyzer_interact_fraction = -1;
#line 95723 "MACS_sample_kidney_box.c"

  SIG_MESSAGE("Incoherent_PG_analyzer (Init:Place/Rotate)");
  rot_set_rotation(mcrotaIncoherent_PG_analyzer,
    (0.0)*DEG2RAD,
    (0.0)*DEG2RAD,
    (0.0)*DEG2RAD);
#line 95730 "MACS_sample_kidney_box.c"
  rot_transpose(mcrotaCollimator_gad, mctr1);
  rot_mul(mcrotaIncoherent_PG_analyzer, mctr1, mcrotrIncoherent_PG_analyzer);
  mcposaIncoherent_PG_analyzer = coords_set(
#line 422 "MACS_sample_kidney_box.instr"
    0,
#line 422 "MACS_sample_kidney_box.instr"
    0,
#line 422 "MACS_sample_kidney_box.instr"
    0);
#line 95740 "MACS_sample_kidney_box.c"
  mctc1 = coords_sub(mcposaCollimator_gad, mcposaIncoherent_PG_analyzer);
  mcposrIncoherent_PG_analyzer = rot_apply(mcrotaIncoherent_PG_analyzer, mctc1);
  mcDEBUG_COMPONENT("Incoherent_PG_analyzer", mcposaIncoherent_PG_analyzer, mcrotaIncoherent_PG_analyzer)
  mccomp_posa[115] = mcposaIncoherent_PG_analyzer;
  mccomp_posr[115] = mcposrIncoherent_PG_analyzer;
  mcNCounter[115]  = mcPCounter[115] = mcP2Counter[115] = 0;
  mcAbsorbProp[115]= 0;
    /* Component Single_crystal_PG_analyzer. */
  /* Setting parameters for component Single_crystal_PG_analyzer. */
  SIG_MESSAGE("Single_crystal_PG_analyzer (Init:SetPar)");
#line 425 "MACS_sample_kidney_box.instr"
  if("C_graphite.lau") strncpy(mccSingle_crystal_PG_analyzer_reflections, "C_graphite.lau" ? "C_graphite.lau" : "", 16384); else mccSingle_crystal_PG_analyzer_reflections[0]='\0';
#line 52 "MACS_sample_kidney_box.instr"
  mccSingle_crystal_PG_analyzer_delta_d_d = 1e-4;
#line 425 "MACS_sample_kidney_box.instr"
  mccSingle_crystal_PG_analyzer_mosaic = 50;
#line 53 "MACS_sample_kidney_box.instr"
  mccSingle_crystal_PG_analyzer_mosaic_a = -1;
#line 53 "MACS_sample_kidney_box.instr"
  mccSingle_crystal_PG_analyzer_mosaic_b = -1;
#line 53 "MACS_sample_kidney_box.instr"
  mccSingle_crystal_PG_analyzer_mosaic_c = -1;
#line 54 "MACS_sample_kidney_box.instr"
  mccSingle_crystal_PG_analyzer_recip_cell = 0;
#line 429 "MACS_sample_kidney_box.instr"
  mccSingle_crystal_PG_analyzer_barns = 0;
#line 426 "MACS_sample_kidney_box.instr"
  mccSingle_crystal_PG_analyzer_ax = 0;
#line 426 "MACS_sample_kidney_box.instr"
  mccSingle_crystal_PG_analyzer_ay = 2.14;
#line 426 "MACS_sample_kidney_box.instr"
  mccSingle_crystal_PG_analyzer_az = -1.24;
#line 427 "MACS_sample_kidney_box.instr"
  mccSingle_crystal_PG_analyzer_bx = 0;
#line 427 "MACS_sample_kidney_box.instr"
  mccSingle_crystal_PG_analyzer_by = 0;
#line 427 "MACS_sample_kidney_box.instr"
  mccSingle_crystal_PG_analyzer_bz = 2.47;
#line 428 "MACS_sample_kidney_box.instr"
  mccSingle_crystal_PG_analyzer_cx = 6.71;
#line 428 "MACS_sample_kidney_box.instr"
  mccSingle_crystal_PG_analyzer_cy = 0;
#line 428 "MACS_sample_kidney_box.instr"
  mccSingle_crystal_PG_analyzer_cz = 0;
#line 59 "MACS_sample_kidney_box.instr"
  mccSingle_crystal_PG_analyzer_aa = 0;
#line 59 "MACS_sample_kidney_box.instr"
  mccSingle_crystal_PG_analyzer_bb = 0;
#line 59 "MACS_sample_kidney_box.instr"
  mccSingle_crystal_PG_analyzer_cc = 0;
#line 59 "MACS_sample_kidney_box.instr"
  mccSingle_crystal_PG_analyzer_order = 0;
#line 59 "MACS_sample_kidney_box.instr"
  mccSingle_crystal_PG_analyzer_RX = 0;
#line 59 "MACS_sample_kidney_box.instr"
  mccSingle_crystal_PG_analyzer_RY = 0;
#line 59 "MACS_sample_kidney_box.instr"
  mccSingle_crystal_PG_analyzer_RZ = 0;
#line 59 "MACS_sample_kidney_box.instr"
  mccSingle_crystal_PG_analyzer_powder = 0;
#line 59 "MACS_sample_kidney_box.instr"
  mccSingle_crystal_PG_analyzer_PG = 0;
#line 60 "MACS_sample_kidney_box.instr"
  mccSingle_crystal_PG_analyzer_interact_fraction = -1;
#line 429 "MACS_sample_kidney_box.instr"
  mccSingle_crystal_PG_analyzer_packing_factor = 1;
#line 95807 "MACS_sample_kidney_box.c"

  SIG_MESSAGE("Single_crystal_PG_analyzer (Init:Place/Rotate)");
  rot_set_rotation(mcrotaSingle_crystal_PG_analyzer,
#line 431 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 431 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 431 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD);
#line 95817 "MACS_sample_kidney_box.c"
  rot_transpose(mcrotaIncoherent_PG_analyzer, mctr1);
  rot_mul(mcrotaSingle_crystal_PG_analyzer, mctr1, mcrotrSingle_crystal_PG_analyzer);
  mcposaSingle_crystal_PG_analyzer = coords_set(
#line 430 "MACS_sample_kidney_box.instr"
    0,
#line 430 "MACS_sample_kidney_box.instr"
    0,
#line 430 "MACS_sample_kidney_box.instr"
    0);
#line 95827 "MACS_sample_kidney_box.c"
  mctc1 = coords_sub(mcposaIncoherent_PG_analyzer, mcposaSingle_crystal_PG_analyzer);
  mcposrSingle_crystal_PG_analyzer = rot_apply(mcrotaSingle_crystal_PG_analyzer, mctc1);
  mcDEBUG_COMPONENT("Single_crystal_PG_analyzer", mcposaSingle_crystal_PG_analyzer, mcrotaSingle_crystal_PG_analyzer)
  mccomp_posa[116] = mcposaSingle_crystal_PG_analyzer;
  mccomp_posr[116] = mcposrSingle_crystal_PG_analyzer;
  mcNCounter[116]  = mcPCounter[116] = mcP2Counter[116] = 0;
  mcAbsorbProp[116]= 0;
    /* Component PG_analyzer. */
  /* Setting parameters for component PG_analyzer. */
  SIG_MESSAGE("PG_analyzer (Init:SetPar)");
#line 434 "MACS_sample_kidney_box.instr"
  if("Single_crystal_PG_analyzer,Incoherent_PG_analyzer") strncpy(mccPG_analyzer_process_string, "Single_crystal_PG_analyzer,Incoherent_PG_analyzer" ? "Single_crystal_PG_analyzer,Incoherent_PG_analyzer" : "", 16384); else mccPG_analyzer_process_string[0]='\0';
#line 433 "MACS_sample_kidney_box.instr"
  mccPG_analyzer_my_absorption = 0.0035 * 4 / 35.29 * 100;
#line 50 "MACS_sample_kidney_box.instr"
  mccPG_analyzer_absorber = 0;
#line 95844 "MACS_sample_kidney_box.c"

  SIG_MESSAGE("PG_analyzer (Init:Place/Rotate)");
  rot_set_rotation(mcrotaPG_analyzer,
    (0.0)*DEG2RAD,
    (0.0)*DEG2RAD,
    (0.0)*DEG2RAD);
#line 95851 "MACS_sample_kidney_box.c"
  rot_transpose(mcrotaSingle_crystal_PG_analyzer, mctr1);
  rot_mul(mcrotaPG_analyzer, mctr1, mcrotrPG_analyzer);
  mcposaPG_analyzer = coords_set(
#line 435 "MACS_sample_kidney_box.instr"
    0,
#line 435 "MACS_sample_kidney_box.instr"
    0,
#line 435 "MACS_sample_kidney_box.instr"
    0);
#line 95861 "MACS_sample_kidney_box.c"
  mctc1 = coords_sub(mcposaSingle_crystal_PG_analyzer, mcposaPG_analyzer);
  mcposrPG_analyzer = rot_apply(mcrotaPG_analyzer, mctc1);
  mcDEBUG_COMPONENT("PG_analyzer", mcposaPG_analyzer, mcrotaPG_analyzer)
  mccomp_posa[117] = mcposaPG_analyzer;
  mccomp_posr[117] = mcposrPG_analyzer;
  mcNCounter[117]  = mcPCounter[117] = mcP2Counter[117] = 0;
  mcAbsorbProp[117]= 0;
    /* Component kidney_hull. */
  /* Setting parameters for component kidney_hull. */
  SIG_MESSAGE("kidney_hull (Init:SetPar)");
#line 437 "MACS_sample_kidney_box.instr"
  if("boron_plastic") strncpy(mcckidney_hull_material_string, "boron_plastic" ? "boron_plastic" : "", 16384); else mcckidney_hull_material_string[0]='\0';
#line 437 "MACS_sample_kidney_box.instr"
  mcckidney_hull_priority = 100;
#line 436 "MACS_sample_kidney_box.instr"
  mcckidney_hull_radius = kidney_hull_radius;
#line 436 "MACS_sample_kidney_box.instr"
  mcckidney_hull_yheight = kidney_hull_height;
#line 67 "MACS_sample_kidney_box.instr"
  mcckidney_hull_visualize = 1;
#line 67 "MACS_sample_kidney_box.instr"
  mcckidney_hull_target_index = 0;
#line 67 "MACS_sample_kidney_box.instr"
  mcckidney_hull_target_x = 0;
#line 67 "MACS_sample_kidney_box.instr"
  mcckidney_hull_target_y = 0;
#line 67 "MACS_sample_kidney_box.instr"
  mcckidney_hull_target_z = 0;
#line 67 "MACS_sample_kidney_box.instr"
  mcckidney_hull_focus_aw = 0;
#line 67 "MACS_sample_kidney_box.instr"
  mcckidney_hull_focus_ah = 0;
#line 67 "MACS_sample_kidney_box.instr"
  mcckidney_hull_focus_xw = 0;
#line 67 "MACS_sample_kidney_box.instr"
  mcckidney_hull_focus_xh = 0;
#line 67 "MACS_sample_kidney_box.instr"
  mcckidney_hull_focus_r = 0;
#line 437 "MACS_sample_kidney_box.instr"
  mcckidney_hull_p_interact = 0.3;
#line 67 "MACS_sample_kidney_box.instr"
  if(0) strncpy(mcckidney_hull_mask_string, 0 ? 0 : "", 16384); else mcckidney_hull_mask_string[0]='\0';
#line 67 "MACS_sample_kidney_box.instr"
  if(0) strncpy(mcckidney_hull_mask_setting, 0 ? 0 : "", 16384); else mcckidney_hull_mask_setting[0]='\0';
#line 67 "MACS_sample_kidney_box.instr"
  mcckidney_hull_number_of_activations = 1;
#line 95908 "MACS_sample_kidney_box.c"

  SIG_MESSAGE("kidney_hull (Init:Place/Rotate)");
  rot_set_rotation(mctr1,
#line 439 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 439 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 439 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD);
#line 95918 "MACS_sample_kidney_box.c"
  rot_mul(mctr1, mcrotakidney_master, mcrotakidney_hull);
  rot_transpose(mcrotaPG_analyzer, mctr1);
  rot_mul(mcrotakidney_hull, mctr1, mcrotrkidney_hull);
  mctc1 = coords_set(
#line 438 "MACS_sample_kidney_box.instr"
    0,
#line 438 "MACS_sample_kidney_box.instr"
    0,
#line 438 "MACS_sample_kidney_box.instr"
    0);
#line 95929 "MACS_sample_kidney_box.c"
  rot_transpose(mcrotakidney_master, mctr1);
  mctc2 = rot_apply(mctr1, mctc1);
  mcposakidney_hull = coords_add(mcposakidney_master, mctc2);
  mctc1 = coords_sub(mcposaPG_analyzer, mcposakidney_hull);
  mcposrkidney_hull = rot_apply(mcrotakidney_hull, mctc1);
  mcDEBUG_COMPONENT("kidney_hull", mcposakidney_hull, mcrotakidney_hull)
  mccomp_posa[118] = mcposakidney_hull;
  mccomp_posr[118] = mcposrkidney_hull;
  mcNCounter[118]  = mcPCounter[118] = mcP2Counter[118] = 0;
  mcAbsorbProp[118]= 0;
    /* Component kidney_hull_cut. */
  /* Setting parameters for component kidney_hull_cut. */
  SIG_MESSAGE("kidney_hull_cut (Init:SetPar)");
#line 442 "MACS_sample_kidney_box.instr"
  if("Vacuum") strncpy(mcckidney_hull_cut_material_string, "Vacuum" ? "Vacuum" : "", 16384); else mcckidney_hull_cut_material_string[0]='\0';
#line 442 "MACS_sample_kidney_box.instr"
  mcckidney_hull_cut_priority = 100.5;
#line 441 "MACS_sample_kidney_box.instr"
  mcckidney_hull_cut_radius = kidney_hull_inner_radius;
#line 441 "MACS_sample_kidney_box.instr"
  mcckidney_hull_cut_yheight = 1.002 * kidney_hull_height;
#line 67 "MACS_sample_kidney_box.instr"
  mcckidney_hull_cut_visualize = 1;
#line 67 "MACS_sample_kidney_box.instr"
  mcckidney_hull_cut_target_index = 0;
#line 67 "MACS_sample_kidney_box.instr"
  mcckidney_hull_cut_target_x = 0;
#line 67 "MACS_sample_kidney_box.instr"
  mcckidney_hull_cut_target_y = 0;
#line 67 "MACS_sample_kidney_box.instr"
  mcckidney_hull_cut_target_z = 0;
#line 67 "MACS_sample_kidney_box.instr"
  mcckidney_hull_cut_focus_aw = 0;
#line 67 "MACS_sample_kidney_box.instr"
  mcckidney_hull_cut_focus_ah = 0;
#line 67 "MACS_sample_kidney_box.instr"
  mcckidney_hull_cut_focus_xw = 0;
#line 67 "MACS_sample_kidney_box.instr"
  mcckidney_hull_cut_focus_xh = 0;
#line 67 "MACS_sample_kidney_box.instr"
  mcckidney_hull_cut_focus_r = 0;
#line 67 "MACS_sample_kidney_box.instr"
  mcckidney_hull_cut_p_interact = 0;
#line 67 "MACS_sample_kidney_box.instr"
  if(0) strncpy(mcckidney_hull_cut_mask_string, 0 ? 0 : "", 16384); else mcckidney_hull_cut_mask_string[0]='\0';
#line 67 "MACS_sample_kidney_box.instr"
  if(0) strncpy(mcckidney_hull_cut_mask_setting, 0 ? 0 : "", 16384); else mcckidney_hull_cut_mask_setting[0]='\0';
#line 67 "MACS_sample_kidney_box.instr"
  mcckidney_hull_cut_number_of_activations = 1;
#line 95979 "MACS_sample_kidney_box.c"

  SIG_MESSAGE("kidney_hull_cut (Init:Place/Rotate)");
  rot_set_rotation(mctr1,
#line 444 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 444 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 444 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD);
#line 95989 "MACS_sample_kidney_box.c"
  rot_mul(mctr1, mcrotakidney_master, mcrotakidney_hull_cut);
  rot_transpose(mcrotakidney_hull, mctr1);
  rot_mul(mcrotakidney_hull_cut, mctr1, mcrotrkidney_hull_cut);
  mctc1 = coords_set(
#line 443 "MACS_sample_kidney_box.instr"
    0,
#line 443 "MACS_sample_kidney_box.instr"
    0,
#line 443 "MACS_sample_kidney_box.instr"
    0);
#line 96000 "MACS_sample_kidney_box.c"
  rot_transpose(mcrotakidney_master, mctr1);
  mctc2 = rot_apply(mctr1, mctc1);
  mcposakidney_hull_cut = coords_add(mcposakidney_master, mctc2);
  mctc1 = coords_sub(mcposakidney_hull, mcposakidney_hull_cut);
  mcposrkidney_hull_cut = rot_apply(mcrotakidney_hull_cut, mctc1);
  mcDEBUG_COMPONENT("kidney_hull_cut", mcposakidney_hull_cut, mcrotakidney_hull_cut)
  mccomp_posa[119] = mcposakidney_hull_cut;
  mccomp_posr[119] = mcposrkidney_hull_cut;
  mcNCounter[119]  = mcPCounter[119] = mcP2Counter[119] = 0;
  mcAbsorbProp[119]= 0;
    /* Component kidney_hull_box_cut_arm1. */
  /* Setting parameters for component kidney_hull_box_cut_arm1. */
  SIG_MESSAGE("kidney_hull_box_cut_arm1 (Init:SetPar)");

  SIG_MESSAGE("kidney_hull_box_cut_arm1 (Init:Place/Rotate)");
  rot_set_rotation(mctr1,
#line 448 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 448 "MACS_sample_kidney_box.instr"
    (0.5 * kidney_cylinder_angle + 90)*DEG2RAD,
#line 448 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD);
#line 96023 "MACS_sample_kidney_box.c"
  rot_mul(mctr1, mcrotakidney_master, mcrotakidney_hull_box_cut_arm1);
  rot_transpose(mcrotakidney_hull_cut, mctr1);
  rot_mul(mcrotakidney_hull_box_cut_arm1, mctr1, mcrotrkidney_hull_box_cut_arm1);
  mctc1 = coords_set(
#line 447 "MACS_sample_kidney_box.instr"
    0,
#line 447 "MACS_sample_kidney_box.instr"
    0,
#line 447 "MACS_sample_kidney_box.instr"
    0);
#line 96034 "MACS_sample_kidney_box.c"
  rot_transpose(mcrotakidney_master, mctr1);
  mctc2 = rot_apply(mctr1, mctc1);
  mcposakidney_hull_box_cut_arm1 = coords_add(mcposakidney_master, mctc2);
  mctc1 = coords_sub(mcposakidney_hull_cut, mcposakidney_hull_box_cut_arm1);
  mcposrkidney_hull_box_cut_arm1 = rot_apply(mcrotakidney_hull_box_cut_arm1, mctc1);
  mcDEBUG_COMPONENT("kidney_hull_box_cut_arm1", mcposakidney_hull_box_cut_arm1, mcrotakidney_hull_box_cut_arm1)
  mccomp_posa[120] = mcposakidney_hull_box_cut_arm1;
  mccomp_posr[120] = mcposrkidney_hull_box_cut_arm1;
  mcNCounter[120]  = mcPCounter[120] = mcP2Counter[120] = 0;
  mcAbsorbProp[120]= 0;
    /* Component kidney_hull_box_cut1. */
  /* Setting parameters for component kidney_hull_box_cut1. */
  SIG_MESSAGE("kidney_hull_box_cut1 (Init:SetPar)");
#line 451 "MACS_sample_kidney_box.instr"
  if("Vacuum") strncpy(mcckidney_hull_box_cut1_material_string, "Vacuum" ? "Vacuum" : "", 16384); else mcckidney_hull_box_cut1_material_string[0]='\0';
#line 451 "MACS_sample_kidney_box.instr"
  mcckidney_hull_box_cut1_priority = 101;
#line 450 "MACS_sample_kidney_box.instr"
  mcckidney_hull_box_cut1_xwidth = 2.1 * kidney_hull_radius;
#line 450 "MACS_sample_kidney_box.instr"
  mcckidney_hull_box_cut1_yheight = 1.003 * kidney_hull_height;
#line 450 "MACS_sample_kidney_box.instr"
  mcckidney_hull_box_cut1_zdepth = 1.2 * kidney_hull_radius;
#line 71 "MACS_sample_kidney_box.instr"
  mcckidney_hull_box_cut1_xwidth2 = -1;
#line 71 "MACS_sample_kidney_box.instr"
  mcckidney_hull_box_cut1_yheight2 = -1;
#line 451 "MACS_sample_kidney_box.instr"
  mcckidney_hull_box_cut1_visualize = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mcckidney_hull_box_cut1_target_index = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mcckidney_hull_box_cut1_target_x = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mcckidney_hull_box_cut1_target_y = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mcckidney_hull_box_cut1_target_z = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mcckidney_hull_box_cut1_focus_aw = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mcckidney_hull_box_cut1_focus_ah = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mcckidney_hull_box_cut1_focus_xw = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mcckidney_hull_box_cut1_focus_xh = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mcckidney_hull_box_cut1_focus_r = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mcckidney_hull_box_cut1_p_interact = 0;
#line 71 "MACS_sample_kidney_box.instr"
  if(0) strncpy(mcckidney_hull_box_cut1_mask_string, 0 ? 0 : "", 16384); else mcckidney_hull_box_cut1_mask_string[0]='\0';
#line 71 "MACS_sample_kidney_box.instr"
  if(0) strncpy(mcckidney_hull_box_cut1_mask_setting, 0 ? 0 : "", 16384); else mcckidney_hull_box_cut1_mask_setting[0]='\0';
#line 71 "MACS_sample_kidney_box.instr"
  mcckidney_hull_box_cut1_number_of_activations = 1;
#line 96090 "MACS_sample_kidney_box.c"

  SIG_MESSAGE("kidney_hull_box_cut1 (Init:Place/Rotate)");
  rot_set_rotation(mctr1,
#line 453 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 453 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 453 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD);
#line 96100 "MACS_sample_kidney_box.c"
  rot_mul(mctr1, mcrotakidney_hull_box_cut_arm1, mcrotakidney_hull_box_cut1);
  rot_transpose(mcrotakidney_hull_box_cut_arm1, mctr1);
  rot_mul(mcrotakidney_hull_box_cut1, mctr1, mcrotrkidney_hull_box_cut1);
  mctc1 = coords_set(
#line 452 "MACS_sample_kidney_box.instr"
    0,
#line 452 "MACS_sample_kidney_box.instr"
    0,
#line 452 "MACS_sample_kidney_box.instr"
    0.6 * kidney_hull_radius);
#line 96111 "MACS_sample_kidney_box.c"
  rot_transpose(mcrotakidney_hull_box_cut_arm1, mctr1);
  mctc2 = rot_apply(mctr1, mctc1);
  mcposakidney_hull_box_cut1 = coords_add(mcposakidney_hull_box_cut_arm1, mctc2);
  mctc1 = coords_sub(mcposakidney_hull_box_cut_arm1, mcposakidney_hull_box_cut1);
  mcposrkidney_hull_box_cut1 = rot_apply(mcrotakidney_hull_box_cut1, mctc1);
  mcDEBUG_COMPONENT("kidney_hull_box_cut1", mcposakidney_hull_box_cut1, mcrotakidney_hull_box_cut1)
  mccomp_posa[121] = mcposakidney_hull_box_cut1;
  mccomp_posr[121] = mcposrkidney_hull_box_cut1;
  mcNCounter[121]  = mcPCounter[121] = mcP2Counter[121] = 0;
  mcAbsorbProp[121]= 0;
    /* Component kidney_hull_box_cut_arm2. */
  /* Setting parameters for component kidney_hull_box_cut_arm2. */
  SIG_MESSAGE("kidney_hull_box_cut_arm2 (Init:SetPar)");

  SIG_MESSAGE("kidney_hull_box_cut_arm2 (Init:Place/Rotate)");
  rot_set_rotation(mctr1,
#line 457 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 457 "MACS_sample_kidney_box.instr"
    (-0.5 * kidney_cylinder_angle -90)*DEG2RAD,
#line 457 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD);
#line 96134 "MACS_sample_kidney_box.c"
  rot_mul(mctr1, mcrotakidney_master, mcrotakidney_hull_box_cut_arm2);
  rot_transpose(mcrotakidney_hull_box_cut1, mctr1);
  rot_mul(mcrotakidney_hull_box_cut_arm2, mctr1, mcrotrkidney_hull_box_cut_arm2);
  mctc1 = coords_set(
#line 456 "MACS_sample_kidney_box.instr"
    0,
#line 456 "MACS_sample_kidney_box.instr"
    0,
#line 456 "MACS_sample_kidney_box.instr"
    0);
#line 96145 "MACS_sample_kidney_box.c"
  rot_transpose(mcrotakidney_master, mctr1);
  mctc2 = rot_apply(mctr1, mctc1);
  mcposakidney_hull_box_cut_arm2 = coords_add(mcposakidney_master, mctc2);
  mctc1 = coords_sub(mcposakidney_hull_box_cut1, mcposakidney_hull_box_cut_arm2);
  mcposrkidney_hull_box_cut_arm2 = rot_apply(mcrotakidney_hull_box_cut_arm2, mctc1);
  mcDEBUG_COMPONENT("kidney_hull_box_cut_arm2", mcposakidney_hull_box_cut_arm2, mcrotakidney_hull_box_cut_arm2)
  mccomp_posa[122] = mcposakidney_hull_box_cut_arm2;
  mccomp_posr[122] = mcposrkidney_hull_box_cut_arm2;
  mcNCounter[122]  = mcPCounter[122] = mcP2Counter[122] = 0;
  mcAbsorbProp[122]= 0;
    /* Component kidney_hull_box_cut2. */
  /* Setting parameters for component kidney_hull_box_cut2. */
  SIG_MESSAGE("kidney_hull_box_cut2 (Init:SetPar)");
#line 460 "MACS_sample_kidney_box.instr"
  if("Vacuum") strncpy(mcckidney_hull_box_cut2_material_string, "Vacuum" ? "Vacuum" : "", 16384); else mcckidney_hull_box_cut2_material_string[0]='\0';
#line 460 "MACS_sample_kidney_box.instr"
  mcckidney_hull_box_cut2_priority = 102;
#line 459 "MACS_sample_kidney_box.instr"
  mcckidney_hull_box_cut2_xwidth = 2.1 * kidney_hull_radius;
#line 459 "MACS_sample_kidney_box.instr"
  mcckidney_hull_box_cut2_yheight = 1.004 * kidney_hull_height;
#line 459 "MACS_sample_kidney_box.instr"
  mcckidney_hull_box_cut2_zdepth = 1.2 * kidney_hull_radius;
#line 71 "MACS_sample_kidney_box.instr"
  mcckidney_hull_box_cut2_xwidth2 = -1;
#line 71 "MACS_sample_kidney_box.instr"
  mcckidney_hull_box_cut2_yheight2 = -1;
#line 460 "MACS_sample_kidney_box.instr"
  mcckidney_hull_box_cut2_visualize = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mcckidney_hull_box_cut2_target_index = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mcckidney_hull_box_cut2_target_x = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mcckidney_hull_box_cut2_target_y = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mcckidney_hull_box_cut2_target_z = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mcckidney_hull_box_cut2_focus_aw = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mcckidney_hull_box_cut2_focus_ah = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mcckidney_hull_box_cut2_focus_xw = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mcckidney_hull_box_cut2_focus_xh = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mcckidney_hull_box_cut2_focus_r = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mcckidney_hull_box_cut2_p_interact = 0;
#line 71 "MACS_sample_kidney_box.instr"
  if(0) strncpy(mcckidney_hull_box_cut2_mask_string, 0 ? 0 : "", 16384); else mcckidney_hull_box_cut2_mask_string[0]='\0';
#line 71 "MACS_sample_kidney_box.instr"
  if(0) strncpy(mcckidney_hull_box_cut2_mask_setting, 0 ? 0 : "", 16384); else mcckidney_hull_box_cut2_mask_setting[0]='\0';
#line 71 "MACS_sample_kidney_box.instr"
  mcckidney_hull_box_cut2_number_of_activations = 1;
#line 96201 "MACS_sample_kidney_box.c"

  SIG_MESSAGE("kidney_hull_box_cut2 (Init:Place/Rotate)");
  rot_set_rotation(mctr1,
#line 462 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 462 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 462 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD);
#line 96211 "MACS_sample_kidney_box.c"
  rot_mul(mctr1, mcrotakidney_hull_box_cut_arm2, mcrotakidney_hull_box_cut2);
  rot_transpose(mcrotakidney_hull_box_cut_arm2, mctr1);
  rot_mul(mcrotakidney_hull_box_cut2, mctr1, mcrotrkidney_hull_box_cut2);
  mctc1 = coords_set(
#line 461 "MACS_sample_kidney_box.instr"
    0,
#line 461 "MACS_sample_kidney_box.instr"
    0,
#line 461 "MACS_sample_kidney_box.instr"
    0.6 * kidney_hull_radius);
#line 96222 "MACS_sample_kidney_box.c"
  rot_transpose(mcrotakidney_hull_box_cut_arm2, mctr1);
  mctc2 = rot_apply(mctr1, mctc1);
  mcposakidney_hull_box_cut2 = coords_add(mcposakidney_hull_box_cut_arm2, mctc2);
  mctc1 = coords_sub(mcposakidney_hull_box_cut_arm2, mcposakidney_hull_box_cut2);
  mcposrkidney_hull_box_cut2 = rot_apply(mcrotakidney_hull_box_cut2, mctc1);
  mcDEBUG_COMPONENT("kidney_hull_box_cut2", mcposakidney_hull_box_cut2, mcrotakidney_hull_box_cut2)
  mccomp_posa[123] = mcposakidney_hull_box_cut2;
  mccomp_posr[123] = mcposrkidney_hull_box_cut2;
  mcNCounter[123]  = mcPCounter[123] = mcP2Counter[123] = 0;
  mcAbsorbProp[123]= 0;
    /* Component channel_0_cave1_box1. */
  /* Setting parameters for component channel_0_cave1_box1. */
  SIG_MESSAGE("channel_0_cave1_box1 (Init:SetPar)");
#line 467 "MACS_sample_kidney_box.instr"
  if("Vacuum") strncpy(mccchannel_0_cave1_box1_material_string, "Vacuum" ? "Vacuum" : "", 16384); else mccchannel_0_cave1_box1_material_string[0]='\0';
#line 467 "MACS_sample_kidney_box.instr"
  mccchannel_0_cave1_box1_priority = 200;
#line 465 "MACS_sample_kidney_box.instr"
  mccchannel_0_cave1_box1_xwidth = kidney_cave1_box1_width1;
#line 465 "MACS_sample_kidney_box.instr"
  mccchannel_0_cave1_box1_yheight = kidney_cave1_box1_height1;
#line 465 "MACS_sample_kidney_box.instr"
  mccchannel_0_cave1_box1_zdepth = kidney_cave1_box1_depth;
#line 466 "MACS_sample_kidney_box.instr"
  mccchannel_0_cave1_box1_xwidth2 = kidney_cave1_box1_width2;
#line 466 "MACS_sample_kidney_box.instr"
  mccchannel_0_cave1_box1_yheight2 = kidney_cave1_box1_height2;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_0_cave1_box1_visualize = 1;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_0_cave1_box1_target_index = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_0_cave1_box1_target_x = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_0_cave1_box1_target_y = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_0_cave1_box1_target_z = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_0_cave1_box1_focus_aw = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_0_cave1_box1_focus_ah = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_0_cave1_box1_focus_xw = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_0_cave1_box1_focus_xh = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_0_cave1_box1_focus_r = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_0_cave1_box1_p_interact = 0;
#line 71 "MACS_sample_kidney_box.instr"
  if(0) strncpy(mccchannel_0_cave1_box1_mask_string, 0 ? 0 : "", 16384); else mccchannel_0_cave1_box1_mask_string[0]='\0';
#line 71 "MACS_sample_kidney_box.instr"
  if(0) strncpy(mccchannel_0_cave1_box1_mask_setting, 0 ? 0 : "", 16384); else mccchannel_0_cave1_box1_mask_setting[0]='\0';
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_0_cave1_box1_number_of_activations = 1;
#line 96278 "MACS_sample_kidney_box.c"

  SIG_MESSAGE("channel_0_cave1_box1 (Init:Place/Rotate)");
  rot_set_rotation(mctr1,
#line 469 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 469 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 469 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD);
#line 96288 "MACS_sample_kidney_box.c"
  rot_mul(mctr1, mcrotakidney_channel_0, mcrotachannel_0_cave1_box1);
  rot_transpose(mcrotakidney_hull_box_cut2, mctr1);
  rot_mul(mcrotachannel_0_cave1_box1, mctr1, mcrotrchannel_0_cave1_box1);
  mctc1 = coords_set(
#line 468 "MACS_sample_kidney_box.instr"
    0,
#line 468 "MACS_sample_kidney_box.instr"
    0,
#line 468 "MACS_sample_kidney_box.instr"
    kidney_cave1_box1_center_to_target);
#line 96299 "MACS_sample_kidney_box.c"
  rot_transpose(mcrotakidney_channel_0, mctr1);
  mctc2 = rot_apply(mctr1, mctc1);
  mcposachannel_0_cave1_box1 = coords_add(mcposakidney_channel_0, mctc2);
  mctc1 = coords_sub(mcposakidney_hull_box_cut2, mcposachannel_0_cave1_box1);
  mcposrchannel_0_cave1_box1 = rot_apply(mcrotachannel_0_cave1_box1, mctc1);
  mcDEBUG_COMPONENT("channel_0_cave1_box1", mcposachannel_0_cave1_box1, mcrotachannel_0_cave1_box1)
  mccomp_posa[124] = mcposachannel_0_cave1_box1;
  mccomp_posr[124] = mcposrchannel_0_cave1_box1;
  mcNCounter[124]  = mcPCounter[124] = mcP2Counter[124] = 0;
  mcAbsorbProp[124]= 0;
    /* Component channel_0_cave1_box2. */
  /* Setting parameters for component channel_0_cave1_box2. */
  SIG_MESSAGE("channel_0_cave1_box2 (Init:SetPar)");
#line 474 "MACS_sample_kidney_box.instr"
  if("Vacuum") strncpy(mccchannel_0_cave1_box2_material_string, "Vacuum" ? "Vacuum" : "", 16384); else mccchannel_0_cave1_box2_material_string[0]='\0';
#line 474 "MACS_sample_kidney_box.instr"
  mccchannel_0_cave1_box2_priority = 205;
#line 472 "MACS_sample_kidney_box.instr"
  mccchannel_0_cave1_box2_xwidth = kidney_cave1_box2_width1;
#line 472 "MACS_sample_kidney_box.instr"
  mccchannel_0_cave1_box2_yheight = kidney_cave1_box2_height1;
#line 472 "MACS_sample_kidney_box.instr"
  mccchannel_0_cave1_box2_zdepth = kidney_cave1_box2_depth;
#line 473 "MACS_sample_kidney_box.instr"
  mccchannel_0_cave1_box2_xwidth2 = kidney_cave1_box2_width2;
#line 473 "MACS_sample_kidney_box.instr"
  mccchannel_0_cave1_box2_yheight2 = kidney_cave1_box2_height2;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_0_cave1_box2_visualize = 1;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_0_cave1_box2_target_index = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_0_cave1_box2_target_x = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_0_cave1_box2_target_y = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_0_cave1_box2_target_z = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_0_cave1_box2_focus_aw = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_0_cave1_box2_focus_ah = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_0_cave1_box2_focus_xw = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_0_cave1_box2_focus_xh = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_0_cave1_box2_focus_r = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_0_cave1_box2_p_interact = 0;
#line 71 "MACS_sample_kidney_box.instr"
  if(0) strncpy(mccchannel_0_cave1_box2_mask_string, 0 ? 0 : "", 16384); else mccchannel_0_cave1_box2_mask_string[0]='\0';
#line 71 "MACS_sample_kidney_box.instr"
  if(0) strncpy(mccchannel_0_cave1_box2_mask_setting, 0 ? 0 : "", 16384); else mccchannel_0_cave1_box2_mask_setting[0]='\0';
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_0_cave1_box2_number_of_activations = 1;
#line 96355 "MACS_sample_kidney_box.c"

  SIG_MESSAGE("channel_0_cave1_box2 (Init:Place/Rotate)");
  rot_set_rotation(mctr1,
#line 476 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 476 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 476 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD);
#line 96365 "MACS_sample_kidney_box.c"
  rot_mul(mctr1, mcrotakidney_channel_0, mcrotachannel_0_cave1_box2);
  rot_transpose(mcrotachannel_0_cave1_box1, mctr1);
  rot_mul(mcrotachannel_0_cave1_box2, mctr1, mcrotrchannel_0_cave1_box2);
  mctc1 = coords_set(
#line 475 "MACS_sample_kidney_box.instr"
    kidney_cave1_box2_x_offset,
#line 475 "MACS_sample_kidney_box.instr"
    0,
#line 475 "MACS_sample_kidney_box.instr"
    kidney_cave1_box2_center_to_target);
#line 96376 "MACS_sample_kidney_box.c"
  rot_transpose(mcrotakidney_channel_0, mctr1);
  mctc2 = rot_apply(mctr1, mctc1);
  mcposachannel_0_cave1_box2 = coords_add(mcposakidney_channel_0, mctc2);
  mctc1 = coords_sub(mcposachannel_0_cave1_box1, mcposachannel_0_cave1_box2);
  mcposrchannel_0_cave1_box2 = rot_apply(mcrotachannel_0_cave1_box2, mctc1);
  mcDEBUG_COMPONENT("channel_0_cave1_box2", mcposachannel_0_cave1_box2, mcrotachannel_0_cave1_box2)
  mccomp_posa[125] = mcposachannel_0_cave1_box2;
  mccomp_posr[125] = mcposrchannel_0_cave1_box2;
  mcNCounter[125]  = mcPCounter[125] = mcP2Counter[125] = 0;
  mcAbsorbProp[125]= 0;
    /* Component channel_0_cave1_box3. */
  /* Setting parameters for component channel_0_cave1_box3. */
  SIG_MESSAGE("channel_0_cave1_box3 (Init:SetPar)");
#line 481 "MACS_sample_kidney_box.instr"
  if("Vacuum") strncpy(mccchannel_0_cave1_box3_material_string, "Vacuum" ? "Vacuum" : "", 16384); else mccchannel_0_cave1_box3_material_string[0]='\0';
#line 481 "MACS_sample_kidney_box.instr"
  mccchannel_0_cave1_box3_priority = 202;
#line 479 "MACS_sample_kidney_box.instr"
  mccchannel_0_cave1_box3_xwidth = kidney_cave1_box3_width1;
#line 479 "MACS_sample_kidney_box.instr"
  mccchannel_0_cave1_box3_yheight = kidney_cave1_box3_height1;
#line 479 "MACS_sample_kidney_box.instr"
  mccchannel_0_cave1_box3_zdepth = kidney_cave1_box3_depth;
#line 480 "MACS_sample_kidney_box.instr"
  mccchannel_0_cave1_box3_xwidth2 = kidney_cave1_box3_width2;
#line 480 "MACS_sample_kidney_box.instr"
  mccchannel_0_cave1_box3_yheight2 = kidney_cave1_box3_height2;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_0_cave1_box3_visualize = 1;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_0_cave1_box3_target_index = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_0_cave1_box3_target_x = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_0_cave1_box3_target_y = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_0_cave1_box3_target_z = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_0_cave1_box3_focus_aw = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_0_cave1_box3_focus_ah = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_0_cave1_box3_focus_xw = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_0_cave1_box3_focus_xh = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_0_cave1_box3_focus_r = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_0_cave1_box3_p_interact = 0;
#line 71 "MACS_sample_kidney_box.instr"
  if(0) strncpy(mccchannel_0_cave1_box3_mask_string, 0 ? 0 : "", 16384); else mccchannel_0_cave1_box3_mask_string[0]='\0';
#line 71 "MACS_sample_kidney_box.instr"
  if(0) strncpy(mccchannel_0_cave1_box3_mask_setting, 0 ? 0 : "", 16384); else mccchannel_0_cave1_box3_mask_setting[0]='\0';
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_0_cave1_box3_number_of_activations = 1;
#line 96432 "MACS_sample_kidney_box.c"

  SIG_MESSAGE("channel_0_cave1_box3 (Init:Place/Rotate)");
  rot_set_rotation(mctr1,
#line 483 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 483 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 483 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD);
#line 96442 "MACS_sample_kidney_box.c"
  rot_mul(mctr1, mcrotakidney_channel_0, mcrotachannel_0_cave1_box3);
  rot_transpose(mcrotachannel_0_cave1_box2, mctr1);
  rot_mul(mcrotachannel_0_cave1_box3, mctr1, mcrotrchannel_0_cave1_box3);
  mctc1 = coords_set(
#line 482 "MACS_sample_kidney_box.instr"
    0,
#line 482 "MACS_sample_kidney_box.instr"
    0,
#line 482 "MACS_sample_kidney_box.instr"
    kidney_cave1_box3_center_to_target);
#line 96453 "MACS_sample_kidney_box.c"
  rot_transpose(mcrotakidney_channel_0, mctr1);
  mctc2 = rot_apply(mctr1, mctc1);
  mcposachannel_0_cave1_box3 = coords_add(mcposakidney_channel_0, mctc2);
  mctc1 = coords_sub(mcposachannel_0_cave1_box2, mcposachannel_0_cave1_box3);
  mcposrchannel_0_cave1_box3 = rot_apply(mcrotachannel_0_cave1_box3, mctc1);
  mcDEBUG_COMPONENT("channel_0_cave1_box3", mcposachannel_0_cave1_box3, mcrotachannel_0_cave1_box3)
  mccomp_posa[126] = mcposachannel_0_cave1_box3;
  mccomp_posr[126] = mcposrchannel_0_cave1_box3;
  mcNCounter[126]  = mcPCounter[126] = mcP2Counter[126] = 0;
  mcAbsorbProp[126]= 0;
    /* Component channel_0_cave1_cyl1. */
  /* Setting parameters for component channel_0_cave1_cyl1. */
  SIG_MESSAGE("channel_0_cave1_cyl1 (Init:SetPar)");
#line 487 "MACS_sample_kidney_box.instr"
  if("Vacuum") strncpy(mccchannel_0_cave1_cyl1_material_string, "Vacuum" ? "Vacuum" : "", 16384); else mccchannel_0_cave1_cyl1_material_string[0]='\0';
#line 487 "MACS_sample_kidney_box.instr"
  mccchannel_0_cave1_cyl1_priority = 203;
#line 486 "MACS_sample_kidney_box.instr"
  mccchannel_0_cave1_cyl1_radius = kidney_cave1_cyl1_radius;
#line 486 "MACS_sample_kidney_box.instr"
  mccchannel_0_cave1_cyl1_yheight = kidney_cave1_cyl1_height;
#line 67 "MACS_sample_kidney_box.instr"
  mccchannel_0_cave1_cyl1_visualize = 1;
#line 67 "MACS_sample_kidney_box.instr"
  mccchannel_0_cave1_cyl1_target_index = 0;
#line 67 "MACS_sample_kidney_box.instr"
  mccchannel_0_cave1_cyl1_target_x = 0;
#line 67 "MACS_sample_kidney_box.instr"
  mccchannel_0_cave1_cyl1_target_y = 0;
#line 67 "MACS_sample_kidney_box.instr"
  mccchannel_0_cave1_cyl1_target_z = 0;
#line 67 "MACS_sample_kidney_box.instr"
  mccchannel_0_cave1_cyl1_focus_aw = 0;
#line 67 "MACS_sample_kidney_box.instr"
  mccchannel_0_cave1_cyl1_focus_ah = 0;
#line 67 "MACS_sample_kidney_box.instr"
  mccchannel_0_cave1_cyl1_focus_xw = 0;
#line 67 "MACS_sample_kidney_box.instr"
  mccchannel_0_cave1_cyl1_focus_xh = 0;
#line 67 "MACS_sample_kidney_box.instr"
  mccchannel_0_cave1_cyl1_focus_r = 0;
#line 67 "MACS_sample_kidney_box.instr"
  mccchannel_0_cave1_cyl1_p_interact = 0;
#line 67 "MACS_sample_kidney_box.instr"
  if(0) strncpy(mccchannel_0_cave1_cyl1_mask_string, 0 ? 0 : "", 16384); else mccchannel_0_cave1_cyl1_mask_string[0]='\0';
#line 67 "MACS_sample_kidney_box.instr"
  if(0) strncpy(mccchannel_0_cave1_cyl1_mask_setting, 0 ? 0 : "", 16384); else mccchannel_0_cave1_cyl1_mask_setting[0]='\0';
#line 67 "MACS_sample_kidney_box.instr"
  mccchannel_0_cave1_cyl1_number_of_activations = 1;
#line 96503 "MACS_sample_kidney_box.c"

  SIG_MESSAGE("channel_0_cave1_cyl1 (Init:Place/Rotate)");
  rot_set_rotation(mctr1,
#line 489 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 489 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 489 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD);
#line 96513 "MACS_sample_kidney_box.c"
  rot_mul(mctr1, mcrotakidney_channel_0, mcrotachannel_0_cave1_cyl1);
  rot_transpose(mcrotachannel_0_cave1_box3, mctr1);
  rot_mul(mcrotachannel_0_cave1_cyl1, mctr1, mcrotrchannel_0_cave1_cyl1);
  mctc1 = coords_set(
#line 488 "MACS_sample_kidney_box.instr"
    0,
#line 488 "MACS_sample_kidney_box.instr"
    0,
#line 488 "MACS_sample_kidney_box.instr"
    kidney_cave1_cyl1_center_to_target);
#line 96524 "MACS_sample_kidney_box.c"
  rot_transpose(mcrotakidney_channel_0, mctr1);
  mctc2 = rot_apply(mctr1, mctc1);
  mcposachannel_0_cave1_cyl1 = coords_add(mcposakidney_channel_0, mctc2);
  mctc1 = coords_sub(mcposachannel_0_cave1_box3, mcposachannel_0_cave1_cyl1);
  mcposrchannel_0_cave1_cyl1 = rot_apply(mcrotachannel_0_cave1_cyl1, mctc1);
  mcDEBUG_COMPONENT("channel_0_cave1_cyl1", mcposachannel_0_cave1_cyl1, mcrotachannel_0_cave1_cyl1)
  mccomp_posa[127] = mcposachannel_0_cave1_cyl1;
  mccomp_posr[127] = mcposrchannel_0_cave1_cyl1;
  mcNCounter[127]  = mcPCounter[127] = mcP2Counter[127] = 0;
  mcAbsorbProp[127]= 0;
    /* Component channel_0_analyzer_1_center. */
  /* Setting parameters for component channel_0_analyzer_1_center. */
  SIG_MESSAGE("channel_0_analyzer_1_center (Init:SetPar)");

  SIG_MESSAGE("channel_0_analyzer_1_center (Init:Place/Rotate)");
  rot_set_rotation(mctr1,
    (0.0)*DEG2RAD,
    (0.0)*DEG2RAD,
    (0.0)*DEG2RAD);
#line 96544 "MACS_sample_kidney_box.c"
  rot_mul(mctr1, mcrotakidney_channel_0, mcrotachannel_0_analyzer_1_center);
  rot_transpose(mcrotachannel_0_cave1_cyl1, mctr1);
  rot_mul(mcrotachannel_0_analyzer_1_center, mctr1, mcrotrchannel_0_analyzer_1_center);
  mctc1 = coords_set(
#line 493 "MACS_sample_kidney_box.instr"
    0,
#line 493 "MACS_sample_kidney_box.instr"
    0,
#line 493 "MACS_sample_kidney_box.instr"
    analyzer_1_center_to_sample);
#line 96555 "MACS_sample_kidney_box.c"
  rot_transpose(mcrotakidney_channel_0, mctr1);
  mctc2 = rot_apply(mctr1, mctc1);
  mcposachannel_0_analyzer_1_center = coords_add(mcposakidney_channel_0, mctc2);
  mctc1 = coords_sub(mcposachannel_0_cave1_cyl1, mcposachannel_0_analyzer_1_center);
  mcposrchannel_0_analyzer_1_center = rot_apply(mcrotachannel_0_analyzer_1_center, mctc1);
  mcDEBUG_COMPONENT("channel_0_analyzer_1_center", mcposachannel_0_analyzer_1_center, mcrotachannel_0_analyzer_1_center)
  mccomp_posa[128] = mcposachannel_0_analyzer_1_center;
  mccomp_posr[128] = mcposrchannel_0_analyzer_1_center;
  mcNCounter[128]  = mcPCounter[128] = mcP2Counter[128] = 0;
  mcAbsorbProp[128]= 0;
    /* Component channel_0_analyzer_1_rotated. */
  /* Setting parameters for component channel_0_analyzer_1_rotated. */
  SIG_MESSAGE("channel_0_analyzer_1_rotated (Init:SetPar)");

  SIG_MESSAGE("channel_0_analyzer_1_rotated (Init:Place/Rotate)");
  rot_set_rotation(mctr1,
#line 497 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 497 "MACS_sample_kidney_box.instr"
    (180 - analyzer_theta [ 0 ])*DEG2RAD,
#line 497 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD);
#line 96578 "MACS_sample_kidney_box.c"
  rot_mul(mctr1, mcrotachannel_0_analyzer_1_center, mcrotachannel_0_analyzer_1_rotated);
  rot_transpose(mcrotachannel_0_analyzer_1_center, mctr1);
  rot_mul(mcrotachannel_0_analyzer_1_rotated, mctr1, mcrotrchannel_0_analyzer_1_rotated);
  mctc1 = coords_set(
#line 496 "MACS_sample_kidney_box.instr"
    0,
#line 496 "MACS_sample_kidney_box.instr"
    0,
#line 496 "MACS_sample_kidney_box.instr"
    -0.5 * analyzer_seperation / tan ( analyzer_2theta [ 0 ] * DEG2RAD ));
#line 96589 "MACS_sample_kidney_box.c"
  rot_transpose(mcrotachannel_0_analyzer_1_center, mctr1);
  mctc2 = rot_apply(mctr1, mctc1);
  mcposachannel_0_analyzer_1_rotated = coords_add(mcposachannel_0_analyzer_1_center, mctc2);
  mctc1 = coords_sub(mcposachannel_0_analyzer_1_center, mcposachannel_0_analyzer_1_rotated);
  mcposrchannel_0_analyzer_1_rotated = rot_apply(mcrotachannel_0_analyzer_1_rotated, mctc1);
  mcDEBUG_COMPONENT("channel_0_analyzer_1_rotated", mcposachannel_0_analyzer_1_rotated, mcrotachannel_0_analyzer_1_rotated)
  mccomp_posa[129] = mcposachannel_0_analyzer_1_rotated;
  mccomp_posr[129] = mcposrchannel_0_analyzer_1_rotated;
  mcNCounter[129]  = mcPCounter[129] = mcP2Counter[129] = 0;
  mcAbsorbProp[129]= 0;
    /* Component channel_0_analyzer_1_array_crystal_array_0. */
  /* Setting parameters for component channel_0_analyzer_1_array_crystal_array_0. */
  SIG_MESSAGE("channel_0_analyzer_1_array_crystal_array_0 (Init:SetPar)");
#line 501 "MACS_sample_kidney_box.instr"
  if("PG_analyzer") strncpy(mccchannel_0_analyzer_1_array_crystal_array_0_material_string, "PG_analyzer" ? "PG_analyzer" : "", 16384); else mccchannel_0_analyzer_1_array_crystal_array_0_material_string[0]='\0';
#line 501 "MACS_sample_kidney_box.instr"
  mccchannel_0_analyzer_1_array_crystal_array_0_priority = 220.0;
#line 500 "MACS_sample_kidney_box.instr"
  mccchannel_0_analyzer_1_array_crystal_array_0_xwidth = channel_0_analyzer_1_array_crystal_depth;
#line 500 "MACS_sample_kidney_box.instr"
  mccchannel_0_analyzer_1_array_crystal_array_0_yheight = channel_0_analyzer_1_array_crystal_height;
#line 500 "MACS_sample_kidney_box.instr"
  mccchannel_0_analyzer_1_array_crystal_array_0_zdepth = channel_0_analyzer_1_array_crystal_width;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_0_analyzer_1_array_crystal_array_0_xwidth2 = -1;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_0_analyzer_1_array_crystal_array_0_yheight2 = -1;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_0_analyzer_1_array_crystal_array_0_visualize = 1;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_0_analyzer_1_array_crystal_array_0_target_index = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_0_analyzer_1_array_crystal_array_0_target_x = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_0_analyzer_1_array_crystal_array_0_target_y = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_0_analyzer_1_array_crystal_array_0_target_z = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_0_analyzer_1_array_crystal_array_0_focus_aw = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_0_analyzer_1_array_crystal_array_0_focus_ah = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_0_analyzer_1_array_crystal_array_0_focus_xw = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_0_analyzer_1_array_crystal_array_0_focus_xh = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_0_analyzer_1_array_crystal_array_0_focus_r = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_0_analyzer_1_array_crystal_array_0_p_interact = 0;
#line 71 "MACS_sample_kidney_box.instr"
  if(0) strncpy(mccchannel_0_analyzer_1_array_crystal_array_0_mask_string, 0 ? 0 : "", 16384); else mccchannel_0_analyzer_1_array_crystal_array_0_mask_string[0]='\0';
#line 71 "MACS_sample_kidney_box.instr"
  if(0) strncpy(mccchannel_0_analyzer_1_array_crystal_array_0_mask_setting, 0 ? 0 : "", 16384); else mccchannel_0_analyzer_1_array_crystal_array_0_mask_setting[0]='\0';
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_0_analyzer_1_array_crystal_array_0_number_of_activations = 1;
#line 96645 "MACS_sample_kidney_box.c"

  SIG_MESSAGE("channel_0_analyzer_1_array_crystal_array_0 (Init:Place/Rotate)");
  rot_set_rotation(mctr1,
#line 503 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 503 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 503 "MACS_sample_kidney_box.instr"
    (0 - RAD2DEG * channel_0_analyzer_1_array_theta [ 0 ])*DEG2RAD);
#line 96655 "MACS_sample_kidney_box.c"
  rot_mul(mctr1, mcrotachannel_0_analyzer_1_rotated, mcrotachannel_0_analyzer_1_array_crystal_array_0);
  rot_transpose(mcrotachannel_0_analyzer_1_rotated, mctr1);
  rot_mul(mcrotachannel_0_analyzer_1_array_crystal_array_0, mctr1, mcrotrchannel_0_analyzer_1_array_crystal_array_0);
  mctc1 = coords_set(
#line 502 "MACS_sample_kidney_box.instr"
    0 + channel_0_analyzer_1_array_effective_radius_of_curvature * ( 1 - cos ( channel_0_analyzer_1_array_theta [ 0 ] ) ),
#line 502 "MACS_sample_kidney_box.instr"
    0 + channel_0_analyzer_1_array_effective_radius_of_curvature * sin ( channel_0_analyzer_1_array_theta [ 0 ] ),
#line 502 "MACS_sample_kidney_box.instr"
    0);
#line 96666 "MACS_sample_kidney_box.c"
  rot_transpose(mcrotachannel_0_analyzer_1_rotated, mctr1);
  mctc2 = rot_apply(mctr1, mctc1);
  mcposachannel_0_analyzer_1_array_crystal_array_0 = coords_add(mcposachannel_0_analyzer_1_rotated, mctc2);
  mctc1 = coords_sub(mcposachannel_0_analyzer_1_rotated, mcposachannel_0_analyzer_1_array_crystal_array_0);
  mcposrchannel_0_analyzer_1_array_crystal_array_0 = rot_apply(mcrotachannel_0_analyzer_1_array_crystal_array_0, mctc1);
  mcDEBUG_COMPONENT("channel_0_analyzer_1_array_crystal_array_0", mcposachannel_0_analyzer_1_array_crystal_array_0, mcrotachannel_0_analyzer_1_array_crystal_array_0)
  mccomp_posa[130] = mcposachannel_0_analyzer_1_array_crystal_array_0;
  mccomp_posr[130] = mcposrchannel_0_analyzer_1_array_crystal_array_0;
  mcNCounter[130]  = mcPCounter[130] = mcP2Counter[130] = 0;
  mcAbsorbProp[130]= 0;
    /* Component channel_0_analyzer_1_array_crystal_array_1. */
  /* Setting parameters for component channel_0_analyzer_1_array_crystal_array_1. */
  SIG_MESSAGE("channel_0_analyzer_1_array_crystal_array_1 (Init:SetPar)");
#line 507 "MACS_sample_kidney_box.instr"
  if("PG_analyzer") strncpy(mccchannel_0_analyzer_1_array_crystal_array_1_material_string, "PG_analyzer" ? "PG_analyzer" : "", 16384); else mccchannel_0_analyzer_1_array_crystal_array_1_material_string[0]='\0';
#line 507 "MACS_sample_kidney_box.instr"
  mccchannel_0_analyzer_1_array_crystal_array_1_priority = 220.1;
#line 506 "MACS_sample_kidney_box.instr"
  mccchannel_0_analyzer_1_array_crystal_array_1_xwidth = channel_0_analyzer_1_array_crystal_depth;
#line 506 "MACS_sample_kidney_box.instr"
  mccchannel_0_analyzer_1_array_crystal_array_1_yheight = channel_0_analyzer_1_array_crystal_height;
#line 506 "MACS_sample_kidney_box.instr"
  mccchannel_0_analyzer_1_array_crystal_array_1_zdepth = channel_0_analyzer_1_array_crystal_width;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_0_analyzer_1_array_crystal_array_1_xwidth2 = -1;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_0_analyzer_1_array_crystal_array_1_yheight2 = -1;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_0_analyzer_1_array_crystal_array_1_visualize = 1;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_0_analyzer_1_array_crystal_array_1_target_index = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_0_analyzer_1_array_crystal_array_1_target_x = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_0_analyzer_1_array_crystal_array_1_target_y = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_0_analyzer_1_array_crystal_array_1_target_z = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_0_analyzer_1_array_crystal_array_1_focus_aw = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_0_analyzer_1_array_crystal_array_1_focus_ah = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_0_analyzer_1_array_crystal_array_1_focus_xw = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_0_analyzer_1_array_crystal_array_1_focus_xh = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_0_analyzer_1_array_crystal_array_1_focus_r = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_0_analyzer_1_array_crystal_array_1_p_interact = 0;
#line 71 "MACS_sample_kidney_box.instr"
  if(0) strncpy(mccchannel_0_analyzer_1_array_crystal_array_1_mask_string, 0 ? 0 : "", 16384); else mccchannel_0_analyzer_1_array_crystal_array_1_mask_string[0]='\0';
#line 71 "MACS_sample_kidney_box.instr"
  if(0) strncpy(mccchannel_0_analyzer_1_array_crystal_array_1_mask_setting, 0 ? 0 : "", 16384); else mccchannel_0_analyzer_1_array_crystal_array_1_mask_setting[0]='\0';
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_0_analyzer_1_array_crystal_array_1_number_of_activations = 1;
#line 96722 "MACS_sample_kidney_box.c"

  SIG_MESSAGE("channel_0_analyzer_1_array_crystal_array_1 (Init:Place/Rotate)");
  rot_set_rotation(mctr1,
#line 509 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 509 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 509 "MACS_sample_kidney_box.instr"
    (0 - RAD2DEG * channel_0_analyzer_1_array_theta [ 1 ])*DEG2RAD);
#line 96732 "MACS_sample_kidney_box.c"
  rot_mul(mctr1, mcrotachannel_0_analyzer_1_rotated, mcrotachannel_0_analyzer_1_array_crystal_array_1);
  rot_transpose(mcrotachannel_0_analyzer_1_array_crystal_array_0, mctr1);
  rot_mul(mcrotachannel_0_analyzer_1_array_crystal_array_1, mctr1, mcrotrchannel_0_analyzer_1_array_crystal_array_1);
  mctc1 = coords_set(
#line 508 "MACS_sample_kidney_box.instr"
    0 + channel_0_analyzer_1_array_effective_radius_of_curvature * ( 1 - cos ( channel_0_analyzer_1_array_theta [ 1 ] ) ),
#line 508 "MACS_sample_kidney_box.instr"
    0 + channel_0_analyzer_1_array_effective_radius_of_curvature * sin ( channel_0_analyzer_1_array_theta [ 1 ] ),
#line 508 "MACS_sample_kidney_box.instr"
    0);
#line 96743 "MACS_sample_kidney_box.c"
  rot_transpose(mcrotachannel_0_analyzer_1_rotated, mctr1);
  mctc2 = rot_apply(mctr1, mctc1);
  mcposachannel_0_analyzer_1_array_crystal_array_1 = coords_add(mcposachannel_0_analyzer_1_rotated, mctc2);
  mctc1 = coords_sub(mcposachannel_0_analyzer_1_array_crystal_array_0, mcposachannel_0_analyzer_1_array_crystal_array_1);
  mcposrchannel_0_analyzer_1_array_crystal_array_1 = rot_apply(mcrotachannel_0_analyzer_1_array_crystal_array_1, mctc1);
  mcDEBUG_COMPONENT("channel_0_analyzer_1_array_crystal_array_1", mcposachannel_0_analyzer_1_array_crystal_array_1, mcrotachannel_0_analyzer_1_array_crystal_array_1)
  mccomp_posa[131] = mcposachannel_0_analyzer_1_array_crystal_array_1;
  mccomp_posr[131] = mcposrchannel_0_analyzer_1_array_crystal_array_1;
  mcNCounter[131]  = mcPCounter[131] = mcP2Counter[131] = 0;
  mcAbsorbProp[131]= 0;
    /* Component channel_0_analyzer_1_array_crystal_array_2. */
  /* Setting parameters for component channel_0_analyzer_1_array_crystal_array_2. */
  SIG_MESSAGE("channel_0_analyzer_1_array_crystal_array_2 (Init:SetPar)");
#line 513 "MACS_sample_kidney_box.instr"
  if("PG_analyzer") strncpy(mccchannel_0_analyzer_1_array_crystal_array_2_material_string, "PG_analyzer" ? "PG_analyzer" : "", 16384); else mccchannel_0_analyzer_1_array_crystal_array_2_material_string[0]='\0';
#line 513 "MACS_sample_kidney_box.instr"
  mccchannel_0_analyzer_1_array_crystal_array_2_priority = 220.2;
#line 512 "MACS_sample_kidney_box.instr"
  mccchannel_0_analyzer_1_array_crystal_array_2_xwidth = channel_0_analyzer_1_array_crystal_depth;
#line 512 "MACS_sample_kidney_box.instr"
  mccchannel_0_analyzer_1_array_crystal_array_2_yheight = channel_0_analyzer_1_array_crystal_height;
#line 512 "MACS_sample_kidney_box.instr"
  mccchannel_0_analyzer_1_array_crystal_array_2_zdepth = channel_0_analyzer_1_array_crystal_width;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_0_analyzer_1_array_crystal_array_2_xwidth2 = -1;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_0_analyzer_1_array_crystal_array_2_yheight2 = -1;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_0_analyzer_1_array_crystal_array_2_visualize = 1;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_0_analyzer_1_array_crystal_array_2_target_index = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_0_analyzer_1_array_crystal_array_2_target_x = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_0_analyzer_1_array_crystal_array_2_target_y = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_0_analyzer_1_array_crystal_array_2_target_z = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_0_analyzer_1_array_crystal_array_2_focus_aw = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_0_analyzer_1_array_crystal_array_2_focus_ah = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_0_analyzer_1_array_crystal_array_2_focus_xw = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_0_analyzer_1_array_crystal_array_2_focus_xh = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_0_analyzer_1_array_crystal_array_2_focus_r = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_0_analyzer_1_array_crystal_array_2_p_interact = 0;
#line 71 "MACS_sample_kidney_box.instr"
  if(0) strncpy(mccchannel_0_analyzer_1_array_crystal_array_2_mask_string, 0 ? 0 : "", 16384); else mccchannel_0_analyzer_1_array_crystal_array_2_mask_string[0]='\0';
#line 71 "MACS_sample_kidney_box.instr"
  if(0) strncpy(mccchannel_0_analyzer_1_array_crystal_array_2_mask_setting, 0 ? 0 : "", 16384); else mccchannel_0_analyzer_1_array_crystal_array_2_mask_setting[0]='\0';
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_0_analyzer_1_array_crystal_array_2_number_of_activations = 1;
#line 96799 "MACS_sample_kidney_box.c"

  SIG_MESSAGE("channel_0_analyzer_1_array_crystal_array_2 (Init:Place/Rotate)");
  rot_set_rotation(mctr1,
#line 515 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 515 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 515 "MACS_sample_kidney_box.instr"
    (0 - RAD2DEG * channel_0_analyzer_1_array_theta [ 2 ])*DEG2RAD);
#line 96809 "MACS_sample_kidney_box.c"
  rot_mul(mctr1, mcrotachannel_0_analyzer_1_rotated, mcrotachannel_0_analyzer_1_array_crystal_array_2);
  rot_transpose(mcrotachannel_0_analyzer_1_array_crystal_array_1, mctr1);
  rot_mul(mcrotachannel_0_analyzer_1_array_crystal_array_2, mctr1, mcrotrchannel_0_analyzer_1_array_crystal_array_2);
  mctc1 = coords_set(
#line 514 "MACS_sample_kidney_box.instr"
    0 + channel_0_analyzer_1_array_effective_radius_of_curvature * ( 1 - cos ( channel_0_analyzer_1_array_theta [ 2 ] ) ),
#line 514 "MACS_sample_kidney_box.instr"
    0 + channel_0_analyzer_1_array_effective_radius_of_curvature * sin ( channel_0_analyzer_1_array_theta [ 2 ] ),
#line 514 "MACS_sample_kidney_box.instr"
    0);
#line 96820 "MACS_sample_kidney_box.c"
  rot_transpose(mcrotachannel_0_analyzer_1_rotated, mctr1);
  mctc2 = rot_apply(mctr1, mctc1);
  mcposachannel_0_analyzer_1_array_crystal_array_2 = coords_add(mcposachannel_0_analyzer_1_rotated, mctc2);
  mctc1 = coords_sub(mcposachannel_0_analyzer_1_array_crystal_array_1, mcposachannel_0_analyzer_1_array_crystal_array_2);
  mcposrchannel_0_analyzer_1_array_crystal_array_2 = rot_apply(mcrotachannel_0_analyzer_1_array_crystal_array_2, mctc1);
  mcDEBUG_COMPONENT("channel_0_analyzer_1_array_crystal_array_2", mcposachannel_0_analyzer_1_array_crystal_array_2, mcrotachannel_0_analyzer_1_array_crystal_array_2)
  mccomp_posa[132] = mcposachannel_0_analyzer_1_array_crystal_array_2;
  mccomp_posr[132] = mcposrchannel_0_analyzer_1_array_crystal_array_2;
  mcNCounter[132]  = mcPCounter[132] = mcP2Counter[132] = 0;
  mcAbsorbProp[132]= 0;
    /* Component channel_0_analyzer_1_array_crystal_array_3. */
  /* Setting parameters for component channel_0_analyzer_1_array_crystal_array_3. */
  SIG_MESSAGE("channel_0_analyzer_1_array_crystal_array_3 (Init:SetPar)");
#line 519 "MACS_sample_kidney_box.instr"
  if("PG_analyzer") strncpy(mccchannel_0_analyzer_1_array_crystal_array_3_material_string, "PG_analyzer" ? "PG_analyzer" : "", 16384); else mccchannel_0_analyzer_1_array_crystal_array_3_material_string[0]='\0';
#line 519 "MACS_sample_kidney_box.instr"
  mccchannel_0_analyzer_1_array_crystal_array_3_priority = 220.3;
#line 518 "MACS_sample_kidney_box.instr"
  mccchannel_0_analyzer_1_array_crystal_array_3_xwidth = channel_0_analyzer_1_array_crystal_depth;
#line 518 "MACS_sample_kidney_box.instr"
  mccchannel_0_analyzer_1_array_crystal_array_3_yheight = channel_0_analyzer_1_array_crystal_height;
#line 518 "MACS_sample_kidney_box.instr"
  mccchannel_0_analyzer_1_array_crystal_array_3_zdepth = channel_0_analyzer_1_array_crystal_width;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_0_analyzer_1_array_crystal_array_3_xwidth2 = -1;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_0_analyzer_1_array_crystal_array_3_yheight2 = -1;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_0_analyzer_1_array_crystal_array_3_visualize = 1;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_0_analyzer_1_array_crystal_array_3_target_index = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_0_analyzer_1_array_crystal_array_3_target_x = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_0_analyzer_1_array_crystal_array_3_target_y = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_0_analyzer_1_array_crystal_array_3_target_z = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_0_analyzer_1_array_crystal_array_3_focus_aw = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_0_analyzer_1_array_crystal_array_3_focus_ah = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_0_analyzer_1_array_crystal_array_3_focus_xw = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_0_analyzer_1_array_crystal_array_3_focus_xh = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_0_analyzer_1_array_crystal_array_3_focus_r = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_0_analyzer_1_array_crystal_array_3_p_interact = 0;
#line 71 "MACS_sample_kidney_box.instr"
  if(0) strncpy(mccchannel_0_analyzer_1_array_crystal_array_3_mask_string, 0 ? 0 : "", 16384); else mccchannel_0_analyzer_1_array_crystal_array_3_mask_string[0]='\0';
#line 71 "MACS_sample_kidney_box.instr"
  if(0) strncpy(mccchannel_0_analyzer_1_array_crystal_array_3_mask_setting, 0 ? 0 : "", 16384); else mccchannel_0_analyzer_1_array_crystal_array_3_mask_setting[0]='\0';
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_0_analyzer_1_array_crystal_array_3_number_of_activations = 1;
#line 96876 "MACS_sample_kidney_box.c"

  SIG_MESSAGE("channel_0_analyzer_1_array_crystal_array_3 (Init:Place/Rotate)");
  rot_set_rotation(mctr1,
#line 521 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 521 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 521 "MACS_sample_kidney_box.instr"
    (0 - RAD2DEG * channel_0_analyzer_1_array_theta [ 3 ])*DEG2RAD);
#line 96886 "MACS_sample_kidney_box.c"
  rot_mul(mctr1, mcrotachannel_0_analyzer_1_rotated, mcrotachannel_0_analyzer_1_array_crystal_array_3);
  rot_transpose(mcrotachannel_0_analyzer_1_array_crystal_array_2, mctr1);
  rot_mul(mcrotachannel_0_analyzer_1_array_crystal_array_3, mctr1, mcrotrchannel_0_analyzer_1_array_crystal_array_3);
  mctc1 = coords_set(
#line 520 "MACS_sample_kidney_box.instr"
    0 + channel_0_analyzer_1_array_effective_radius_of_curvature * ( 1 - cos ( channel_0_analyzer_1_array_theta [ 3 ] ) ),
#line 520 "MACS_sample_kidney_box.instr"
    0 + channel_0_analyzer_1_array_effective_radius_of_curvature * sin ( channel_0_analyzer_1_array_theta [ 3 ] ),
#line 520 "MACS_sample_kidney_box.instr"
    0);
#line 96897 "MACS_sample_kidney_box.c"
  rot_transpose(mcrotachannel_0_analyzer_1_rotated, mctr1);
  mctc2 = rot_apply(mctr1, mctc1);
  mcposachannel_0_analyzer_1_array_crystal_array_3 = coords_add(mcposachannel_0_analyzer_1_rotated, mctc2);
  mctc1 = coords_sub(mcposachannel_0_analyzer_1_array_crystal_array_2, mcposachannel_0_analyzer_1_array_crystal_array_3);
  mcposrchannel_0_analyzer_1_array_crystal_array_3 = rot_apply(mcrotachannel_0_analyzer_1_array_crystal_array_3, mctc1);
  mcDEBUG_COMPONENT("channel_0_analyzer_1_array_crystal_array_3", mcposachannel_0_analyzer_1_array_crystal_array_3, mcrotachannel_0_analyzer_1_array_crystal_array_3)
  mccomp_posa[133] = mcposachannel_0_analyzer_1_array_crystal_array_3;
  mccomp_posr[133] = mcposrchannel_0_analyzer_1_array_crystal_array_3;
  mcNCounter[133]  = mcPCounter[133] = mcP2Counter[133] = 0;
  mcAbsorbProp[133]= 0;
    /* Component channel_0_analyzer_1_array_crystal_array_4. */
  /* Setting parameters for component channel_0_analyzer_1_array_crystal_array_4. */
  SIG_MESSAGE("channel_0_analyzer_1_array_crystal_array_4 (Init:SetPar)");
#line 525 "MACS_sample_kidney_box.instr"
  if("PG_analyzer") strncpy(mccchannel_0_analyzer_1_array_crystal_array_4_material_string, "PG_analyzer" ? "PG_analyzer" : "", 16384); else mccchannel_0_analyzer_1_array_crystal_array_4_material_string[0]='\0';
#line 525 "MACS_sample_kidney_box.instr"
  mccchannel_0_analyzer_1_array_crystal_array_4_priority = 220.4;
#line 524 "MACS_sample_kidney_box.instr"
  mccchannel_0_analyzer_1_array_crystal_array_4_xwidth = channel_0_analyzer_1_array_crystal_depth;
#line 524 "MACS_sample_kidney_box.instr"
  mccchannel_0_analyzer_1_array_crystal_array_4_yheight = channel_0_analyzer_1_array_crystal_height;
#line 524 "MACS_sample_kidney_box.instr"
  mccchannel_0_analyzer_1_array_crystal_array_4_zdepth = channel_0_analyzer_1_array_crystal_width;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_0_analyzer_1_array_crystal_array_4_xwidth2 = -1;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_0_analyzer_1_array_crystal_array_4_yheight2 = -1;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_0_analyzer_1_array_crystal_array_4_visualize = 1;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_0_analyzer_1_array_crystal_array_4_target_index = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_0_analyzer_1_array_crystal_array_4_target_x = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_0_analyzer_1_array_crystal_array_4_target_y = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_0_analyzer_1_array_crystal_array_4_target_z = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_0_analyzer_1_array_crystal_array_4_focus_aw = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_0_analyzer_1_array_crystal_array_4_focus_ah = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_0_analyzer_1_array_crystal_array_4_focus_xw = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_0_analyzer_1_array_crystal_array_4_focus_xh = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_0_analyzer_1_array_crystal_array_4_focus_r = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_0_analyzer_1_array_crystal_array_4_p_interact = 0;
#line 71 "MACS_sample_kidney_box.instr"
  if(0) strncpy(mccchannel_0_analyzer_1_array_crystal_array_4_mask_string, 0 ? 0 : "", 16384); else mccchannel_0_analyzer_1_array_crystal_array_4_mask_string[0]='\0';
#line 71 "MACS_sample_kidney_box.instr"
  if(0) strncpy(mccchannel_0_analyzer_1_array_crystal_array_4_mask_setting, 0 ? 0 : "", 16384); else mccchannel_0_analyzer_1_array_crystal_array_4_mask_setting[0]='\0';
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_0_analyzer_1_array_crystal_array_4_number_of_activations = 1;
#line 96953 "MACS_sample_kidney_box.c"

  SIG_MESSAGE("channel_0_analyzer_1_array_crystal_array_4 (Init:Place/Rotate)");
  rot_set_rotation(mctr1,
#line 527 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 527 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 527 "MACS_sample_kidney_box.instr"
    (0 - RAD2DEG * channel_0_analyzer_1_array_theta [ 4 ])*DEG2RAD);
#line 96963 "MACS_sample_kidney_box.c"
  rot_mul(mctr1, mcrotachannel_0_analyzer_1_rotated, mcrotachannel_0_analyzer_1_array_crystal_array_4);
  rot_transpose(mcrotachannel_0_analyzer_1_array_crystal_array_3, mctr1);
  rot_mul(mcrotachannel_0_analyzer_1_array_crystal_array_4, mctr1, mcrotrchannel_0_analyzer_1_array_crystal_array_4);
  mctc1 = coords_set(
#line 526 "MACS_sample_kidney_box.instr"
    0 + channel_0_analyzer_1_array_effective_radius_of_curvature * ( 1 - cos ( channel_0_analyzer_1_array_theta [ 4 ] ) ),
#line 526 "MACS_sample_kidney_box.instr"
    0 + channel_0_analyzer_1_array_effective_radius_of_curvature * sin ( channel_0_analyzer_1_array_theta [ 4 ] ),
#line 526 "MACS_sample_kidney_box.instr"
    0);
#line 96974 "MACS_sample_kidney_box.c"
  rot_transpose(mcrotachannel_0_analyzer_1_rotated, mctr1);
  mctc2 = rot_apply(mctr1, mctc1);
  mcposachannel_0_analyzer_1_array_crystal_array_4 = coords_add(mcposachannel_0_analyzer_1_rotated, mctc2);
  mctc1 = coords_sub(mcposachannel_0_analyzer_1_array_crystal_array_3, mcposachannel_0_analyzer_1_array_crystal_array_4);
  mcposrchannel_0_analyzer_1_array_crystal_array_4 = rot_apply(mcrotachannel_0_analyzer_1_array_crystal_array_4, mctc1);
  mcDEBUG_COMPONENT("channel_0_analyzer_1_array_crystal_array_4", mcposachannel_0_analyzer_1_array_crystal_array_4, mcrotachannel_0_analyzer_1_array_crystal_array_4)
  mccomp_posa[134] = mcposachannel_0_analyzer_1_array_crystal_array_4;
  mccomp_posr[134] = mcposrchannel_0_analyzer_1_array_crystal_array_4;
  mcNCounter[134]  = mcPCounter[134] = mcP2Counter[134] = 0;
  mcAbsorbProp[134]= 0;
    /* Component channel_0_analyzer_1_array_crystal_array_5. */
  /* Setting parameters for component channel_0_analyzer_1_array_crystal_array_5. */
  SIG_MESSAGE("channel_0_analyzer_1_array_crystal_array_5 (Init:SetPar)");
#line 531 "MACS_sample_kidney_box.instr"
  if("PG_analyzer") strncpy(mccchannel_0_analyzer_1_array_crystal_array_5_material_string, "PG_analyzer" ? "PG_analyzer" : "", 16384); else mccchannel_0_analyzer_1_array_crystal_array_5_material_string[0]='\0';
#line 531 "MACS_sample_kidney_box.instr"
  mccchannel_0_analyzer_1_array_crystal_array_5_priority = 220.5;
#line 530 "MACS_sample_kidney_box.instr"
  mccchannel_0_analyzer_1_array_crystal_array_5_xwidth = channel_0_analyzer_1_array_crystal_depth;
#line 530 "MACS_sample_kidney_box.instr"
  mccchannel_0_analyzer_1_array_crystal_array_5_yheight = channel_0_analyzer_1_array_crystal_height;
#line 530 "MACS_sample_kidney_box.instr"
  mccchannel_0_analyzer_1_array_crystal_array_5_zdepth = channel_0_analyzer_1_array_crystal_width;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_0_analyzer_1_array_crystal_array_5_xwidth2 = -1;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_0_analyzer_1_array_crystal_array_5_yheight2 = -1;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_0_analyzer_1_array_crystal_array_5_visualize = 1;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_0_analyzer_1_array_crystal_array_5_target_index = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_0_analyzer_1_array_crystal_array_5_target_x = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_0_analyzer_1_array_crystal_array_5_target_y = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_0_analyzer_1_array_crystal_array_5_target_z = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_0_analyzer_1_array_crystal_array_5_focus_aw = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_0_analyzer_1_array_crystal_array_5_focus_ah = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_0_analyzer_1_array_crystal_array_5_focus_xw = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_0_analyzer_1_array_crystal_array_5_focus_xh = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_0_analyzer_1_array_crystal_array_5_focus_r = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_0_analyzer_1_array_crystal_array_5_p_interact = 0;
#line 71 "MACS_sample_kidney_box.instr"
  if(0) strncpy(mccchannel_0_analyzer_1_array_crystal_array_5_mask_string, 0 ? 0 : "", 16384); else mccchannel_0_analyzer_1_array_crystal_array_5_mask_string[0]='\0';
#line 71 "MACS_sample_kidney_box.instr"
  if(0) strncpy(mccchannel_0_analyzer_1_array_crystal_array_5_mask_setting, 0 ? 0 : "", 16384); else mccchannel_0_analyzer_1_array_crystal_array_5_mask_setting[0]='\0';
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_0_analyzer_1_array_crystal_array_5_number_of_activations = 1;
#line 97030 "MACS_sample_kidney_box.c"

  SIG_MESSAGE("channel_0_analyzer_1_array_crystal_array_5 (Init:Place/Rotate)");
  rot_set_rotation(mctr1,
#line 533 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 533 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 533 "MACS_sample_kidney_box.instr"
    (0 - RAD2DEG * channel_0_analyzer_1_array_theta [ 5 ])*DEG2RAD);
#line 97040 "MACS_sample_kidney_box.c"
  rot_mul(mctr1, mcrotachannel_0_analyzer_1_rotated, mcrotachannel_0_analyzer_1_array_crystal_array_5);
  rot_transpose(mcrotachannel_0_analyzer_1_array_crystal_array_4, mctr1);
  rot_mul(mcrotachannel_0_analyzer_1_array_crystal_array_5, mctr1, mcrotrchannel_0_analyzer_1_array_crystal_array_5);
  mctc1 = coords_set(
#line 532 "MACS_sample_kidney_box.instr"
    0 + channel_0_analyzer_1_array_effective_radius_of_curvature * ( 1 - cos ( channel_0_analyzer_1_array_theta [ 5 ] ) ),
#line 532 "MACS_sample_kidney_box.instr"
    0 + channel_0_analyzer_1_array_effective_radius_of_curvature * sin ( channel_0_analyzer_1_array_theta [ 5 ] ),
#line 532 "MACS_sample_kidney_box.instr"
    0);
#line 97051 "MACS_sample_kidney_box.c"
  rot_transpose(mcrotachannel_0_analyzer_1_rotated, mctr1);
  mctc2 = rot_apply(mctr1, mctc1);
  mcposachannel_0_analyzer_1_array_crystal_array_5 = coords_add(mcposachannel_0_analyzer_1_rotated, mctc2);
  mctc1 = coords_sub(mcposachannel_0_analyzer_1_array_crystal_array_4, mcposachannel_0_analyzer_1_array_crystal_array_5);
  mcposrchannel_0_analyzer_1_array_crystal_array_5 = rot_apply(mcrotachannel_0_analyzer_1_array_crystal_array_5, mctc1);
  mcDEBUG_COMPONENT("channel_0_analyzer_1_array_crystal_array_5", mcposachannel_0_analyzer_1_array_crystal_array_5, mcrotachannel_0_analyzer_1_array_crystal_array_5)
  mccomp_posa[135] = mcposachannel_0_analyzer_1_array_crystal_array_5;
  mccomp_posr[135] = mcposrchannel_0_analyzer_1_array_crystal_array_5;
  mcNCounter[135]  = mcPCounter[135] = mcP2Counter[135] = 0;
  mcAbsorbProp[135]= 0;
    /* Component channel_0_analyzer_1_array_crystal_array_6. */
  /* Setting parameters for component channel_0_analyzer_1_array_crystal_array_6. */
  SIG_MESSAGE("channel_0_analyzer_1_array_crystal_array_6 (Init:SetPar)");
#line 537 "MACS_sample_kidney_box.instr"
  if("PG_analyzer") strncpy(mccchannel_0_analyzer_1_array_crystal_array_6_material_string, "PG_analyzer" ? "PG_analyzer" : "", 16384); else mccchannel_0_analyzer_1_array_crystal_array_6_material_string[0]='\0';
#line 537 "MACS_sample_kidney_box.instr"
  mccchannel_0_analyzer_1_array_crystal_array_6_priority = 220.6;
#line 536 "MACS_sample_kidney_box.instr"
  mccchannel_0_analyzer_1_array_crystal_array_6_xwidth = channel_0_analyzer_1_array_crystal_depth;
#line 536 "MACS_sample_kidney_box.instr"
  mccchannel_0_analyzer_1_array_crystal_array_6_yheight = channel_0_analyzer_1_array_crystal_height;
#line 536 "MACS_sample_kidney_box.instr"
  mccchannel_0_analyzer_1_array_crystal_array_6_zdepth = channel_0_analyzer_1_array_crystal_width;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_0_analyzer_1_array_crystal_array_6_xwidth2 = -1;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_0_analyzer_1_array_crystal_array_6_yheight2 = -1;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_0_analyzer_1_array_crystal_array_6_visualize = 1;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_0_analyzer_1_array_crystal_array_6_target_index = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_0_analyzer_1_array_crystal_array_6_target_x = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_0_analyzer_1_array_crystal_array_6_target_y = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_0_analyzer_1_array_crystal_array_6_target_z = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_0_analyzer_1_array_crystal_array_6_focus_aw = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_0_analyzer_1_array_crystal_array_6_focus_ah = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_0_analyzer_1_array_crystal_array_6_focus_xw = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_0_analyzer_1_array_crystal_array_6_focus_xh = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_0_analyzer_1_array_crystal_array_6_focus_r = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_0_analyzer_1_array_crystal_array_6_p_interact = 0;
#line 71 "MACS_sample_kidney_box.instr"
  if(0) strncpy(mccchannel_0_analyzer_1_array_crystal_array_6_mask_string, 0 ? 0 : "", 16384); else mccchannel_0_analyzer_1_array_crystal_array_6_mask_string[0]='\0';
#line 71 "MACS_sample_kidney_box.instr"
  if(0) strncpy(mccchannel_0_analyzer_1_array_crystal_array_6_mask_setting, 0 ? 0 : "", 16384); else mccchannel_0_analyzer_1_array_crystal_array_6_mask_setting[0]='\0';
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_0_analyzer_1_array_crystal_array_6_number_of_activations = 1;
#line 97107 "MACS_sample_kidney_box.c"

  SIG_MESSAGE("channel_0_analyzer_1_array_crystal_array_6 (Init:Place/Rotate)");
  rot_set_rotation(mctr1,
#line 539 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 539 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 539 "MACS_sample_kidney_box.instr"
    (0 - RAD2DEG * channel_0_analyzer_1_array_theta [ 6 ])*DEG2RAD);
#line 97117 "MACS_sample_kidney_box.c"
  rot_mul(mctr1, mcrotachannel_0_analyzer_1_rotated, mcrotachannel_0_analyzer_1_array_crystal_array_6);
  rot_transpose(mcrotachannel_0_analyzer_1_array_crystal_array_5, mctr1);
  rot_mul(mcrotachannel_0_analyzer_1_array_crystal_array_6, mctr1, mcrotrchannel_0_analyzer_1_array_crystal_array_6);
  mctc1 = coords_set(
#line 538 "MACS_sample_kidney_box.instr"
    0 + channel_0_analyzer_1_array_effective_radius_of_curvature * ( 1 - cos ( channel_0_analyzer_1_array_theta [ 6 ] ) ),
#line 538 "MACS_sample_kidney_box.instr"
    0 + channel_0_analyzer_1_array_effective_radius_of_curvature * sin ( channel_0_analyzer_1_array_theta [ 6 ] ),
#line 538 "MACS_sample_kidney_box.instr"
    0);
#line 97128 "MACS_sample_kidney_box.c"
  rot_transpose(mcrotachannel_0_analyzer_1_rotated, mctr1);
  mctc2 = rot_apply(mctr1, mctc1);
  mcposachannel_0_analyzer_1_array_crystal_array_6 = coords_add(mcposachannel_0_analyzer_1_rotated, mctc2);
  mctc1 = coords_sub(mcposachannel_0_analyzer_1_array_crystal_array_5, mcposachannel_0_analyzer_1_array_crystal_array_6);
  mcposrchannel_0_analyzer_1_array_crystal_array_6 = rot_apply(mcrotachannel_0_analyzer_1_array_crystal_array_6, mctc1);
  mcDEBUG_COMPONENT("channel_0_analyzer_1_array_crystal_array_6", mcposachannel_0_analyzer_1_array_crystal_array_6, mcrotachannel_0_analyzer_1_array_crystal_array_6)
  mccomp_posa[136] = mcposachannel_0_analyzer_1_array_crystal_array_6;
  mccomp_posr[136] = mcposrchannel_0_analyzer_1_array_crystal_array_6;
  mcNCounter[136]  = mcPCounter[136] = mcP2Counter[136] = 0;
  mcAbsorbProp[136]= 0;
    /* Component channel_0_analyzer_1_array_crystal_array_7. */
  /* Setting parameters for component channel_0_analyzer_1_array_crystal_array_7. */
  SIG_MESSAGE("channel_0_analyzer_1_array_crystal_array_7 (Init:SetPar)");
#line 543 "MACS_sample_kidney_box.instr"
  if("PG_analyzer") strncpy(mccchannel_0_analyzer_1_array_crystal_array_7_material_string, "PG_analyzer" ? "PG_analyzer" : "", 16384); else mccchannel_0_analyzer_1_array_crystal_array_7_material_string[0]='\0';
#line 543 "MACS_sample_kidney_box.instr"
  mccchannel_0_analyzer_1_array_crystal_array_7_priority = 220.7;
#line 542 "MACS_sample_kidney_box.instr"
  mccchannel_0_analyzer_1_array_crystal_array_7_xwidth = channel_0_analyzer_1_array_crystal_depth;
#line 542 "MACS_sample_kidney_box.instr"
  mccchannel_0_analyzer_1_array_crystal_array_7_yheight = channel_0_analyzer_1_array_crystal_height;
#line 542 "MACS_sample_kidney_box.instr"
  mccchannel_0_analyzer_1_array_crystal_array_7_zdepth = channel_0_analyzer_1_array_crystal_width;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_0_analyzer_1_array_crystal_array_7_xwidth2 = -1;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_0_analyzer_1_array_crystal_array_7_yheight2 = -1;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_0_analyzer_1_array_crystal_array_7_visualize = 1;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_0_analyzer_1_array_crystal_array_7_target_index = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_0_analyzer_1_array_crystal_array_7_target_x = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_0_analyzer_1_array_crystal_array_7_target_y = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_0_analyzer_1_array_crystal_array_7_target_z = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_0_analyzer_1_array_crystal_array_7_focus_aw = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_0_analyzer_1_array_crystal_array_7_focus_ah = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_0_analyzer_1_array_crystal_array_7_focus_xw = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_0_analyzer_1_array_crystal_array_7_focus_xh = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_0_analyzer_1_array_crystal_array_7_focus_r = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_0_analyzer_1_array_crystal_array_7_p_interact = 0;
#line 71 "MACS_sample_kidney_box.instr"
  if(0) strncpy(mccchannel_0_analyzer_1_array_crystal_array_7_mask_string, 0 ? 0 : "", 16384); else mccchannel_0_analyzer_1_array_crystal_array_7_mask_string[0]='\0';
#line 71 "MACS_sample_kidney_box.instr"
  if(0) strncpy(mccchannel_0_analyzer_1_array_crystal_array_7_mask_setting, 0 ? 0 : "", 16384); else mccchannel_0_analyzer_1_array_crystal_array_7_mask_setting[0]='\0';
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_0_analyzer_1_array_crystal_array_7_number_of_activations = 1;
#line 97184 "MACS_sample_kidney_box.c"

  SIG_MESSAGE("channel_0_analyzer_1_array_crystal_array_7 (Init:Place/Rotate)");
  rot_set_rotation(mctr1,
#line 545 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 545 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 545 "MACS_sample_kidney_box.instr"
    (0 - RAD2DEG * channel_0_analyzer_1_array_theta [ 7 ])*DEG2RAD);
#line 97194 "MACS_sample_kidney_box.c"
  rot_mul(mctr1, mcrotachannel_0_analyzer_1_rotated, mcrotachannel_0_analyzer_1_array_crystal_array_7);
  rot_transpose(mcrotachannel_0_analyzer_1_array_crystal_array_6, mctr1);
  rot_mul(mcrotachannel_0_analyzer_1_array_crystal_array_7, mctr1, mcrotrchannel_0_analyzer_1_array_crystal_array_7);
  mctc1 = coords_set(
#line 544 "MACS_sample_kidney_box.instr"
    0 + channel_0_analyzer_1_array_effective_radius_of_curvature * ( 1 - cos ( channel_0_analyzer_1_array_theta [ 7 ] ) ),
#line 544 "MACS_sample_kidney_box.instr"
    0 + channel_0_analyzer_1_array_effective_radius_of_curvature * sin ( channel_0_analyzer_1_array_theta [ 7 ] ),
#line 544 "MACS_sample_kidney_box.instr"
    0);
#line 97205 "MACS_sample_kidney_box.c"
  rot_transpose(mcrotachannel_0_analyzer_1_rotated, mctr1);
  mctc2 = rot_apply(mctr1, mctc1);
  mcposachannel_0_analyzer_1_array_crystal_array_7 = coords_add(mcposachannel_0_analyzer_1_rotated, mctc2);
  mctc1 = coords_sub(mcposachannel_0_analyzer_1_array_crystal_array_6, mcposachannel_0_analyzer_1_array_crystal_array_7);
  mcposrchannel_0_analyzer_1_array_crystal_array_7 = rot_apply(mcrotachannel_0_analyzer_1_array_crystal_array_7, mctc1);
  mcDEBUG_COMPONENT("channel_0_analyzer_1_array_crystal_array_7", mcposachannel_0_analyzer_1_array_crystal_array_7, mcrotachannel_0_analyzer_1_array_crystal_array_7)
  mccomp_posa[137] = mcposachannel_0_analyzer_1_array_crystal_array_7;
  mccomp_posr[137] = mcposrchannel_0_analyzer_1_array_crystal_array_7;
  mcNCounter[137]  = mcPCounter[137] = mcP2Counter[137] = 0;
  mcAbsorbProp[137]= 0;
    /* Component channel_0_analyzer_1_array_crystal_array_8. */
  /* Setting parameters for component channel_0_analyzer_1_array_crystal_array_8. */
  SIG_MESSAGE("channel_0_analyzer_1_array_crystal_array_8 (Init:SetPar)");
#line 549 "MACS_sample_kidney_box.instr"
  if("PG_analyzer") strncpy(mccchannel_0_analyzer_1_array_crystal_array_8_material_string, "PG_analyzer" ? "PG_analyzer" : "", 16384); else mccchannel_0_analyzer_1_array_crystal_array_8_material_string[0]='\0';
#line 549 "MACS_sample_kidney_box.instr"
  mccchannel_0_analyzer_1_array_crystal_array_8_priority = 220.8;
#line 548 "MACS_sample_kidney_box.instr"
  mccchannel_0_analyzer_1_array_crystal_array_8_xwidth = channel_0_analyzer_1_array_crystal_depth;
#line 548 "MACS_sample_kidney_box.instr"
  mccchannel_0_analyzer_1_array_crystal_array_8_yheight = channel_0_analyzer_1_array_crystal_height;
#line 548 "MACS_sample_kidney_box.instr"
  mccchannel_0_analyzer_1_array_crystal_array_8_zdepth = channel_0_analyzer_1_array_crystal_width;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_0_analyzer_1_array_crystal_array_8_xwidth2 = -1;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_0_analyzer_1_array_crystal_array_8_yheight2 = -1;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_0_analyzer_1_array_crystal_array_8_visualize = 1;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_0_analyzer_1_array_crystal_array_8_target_index = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_0_analyzer_1_array_crystal_array_8_target_x = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_0_analyzer_1_array_crystal_array_8_target_y = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_0_analyzer_1_array_crystal_array_8_target_z = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_0_analyzer_1_array_crystal_array_8_focus_aw = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_0_analyzer_1_array_crystal_array_8_focus_ah = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_0_analyzer_1_array_crystal_array_8_focus_xw = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_0_analyzer_1_array_crystal_array_8_focus_xh = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_0_analyzer_1_array_crystal_array_8_focus_r = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_0_analyzer_1_array_crystal_array_8_p_interact = 0;
#line 71 "MACS_sample_kidney_box.instr"
  if(0) strncpy(mccchannel_0_analyzer_1_array_crystal_array_8_mask_string, 0 ? 0 : "", 16384); else mccchannel_0_analyzer_1_array_crystal_array_8_mask_string[0]='\0';
#line 71 "MACS_sample_kidney_box.instr"
  if(0) strncpy(mccchannel_0_analyzer_1_array_crystal_array_8_mask_setting, 0 ? 0 : "", 16384); else mccchannel_0_analyzer_1_array_crystal_array_8_mask_setting[0]='\0';
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_0_analyzer_1_array_crystal_array_8_number_of_activations = 1;
#line 97261 "MACS_sample_kidney_box.c"

  SIG_MESSAGE("channel_0_analyzer_1_array_crystal_array_8 (Init:Place/Rotate)");
  rot_set_rotation(mctr1,
#line 551 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 551 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 551 "MACS_sample_kidney_box.instr"
    (0 - RAD2DEG * channel_0_analyzer_1_array_theta [ 8 ])*DEG2RAD);
#line 97271 "MACS_sample_kidney_box.c"
  rot_mul(mctr1, mcrotachannel_0_analyzer_1_rotated, mcrotachannel_0_analyzer_1_array_crystal_array_8);
  rot_transpose(mcrotachannel_0_analyzer_1_array_crystal_array_7, mctr1);
  rot_mul(mcrotachannel_0_analyzer_1_array_crystal_array_8, mctr1, mcrotrchannel_0_analyzer_1_array_crystal_array_8);
  mctc1 = coords_set(
#line 550 "MACS_sample_kidney_box.instr"
    0 + channel_0_analyzer_1_array_effective_radius_of_curvature * ( 1 - cos ( channel_0_analyzer_1_array_theta [ 8 ] ) ),
#line 550 "MACS_sample_kidney_box.instr"
    0 + channel_0_analyzer_1_array_effective_radius_of_curvature * sin ( channel_0_analyzer_1_array_theta [ 8 ] ),
#line 550 "MACS_sample_kidney_box.instr"
    0);
#line 97282 "MACS_sample_kidney_box.c"
  rot_transpose(mcrotachannel_0_analyzer_1_rotated, mctr1);
  mctc2 = rot_apply(mctr1, mctc1);
  mcposachannel_0_analyzer_1_array_crystal_array_8 = coords_add(mcposachannel_0_analyzer_1_rotated, mctc2);
  mctc1 = coords_sub(mcposachannel_0_analyzer_1_array_crystal_array_7, mcposachannel_0_analyzer_1_array_crystal_array_8);
  mcposrchannel_0_analyzer_1_array_crystal_array_8 = rot_apply(mcrotachannel_0_analyzer_1_array_crystal_array_8, mctc1);
  mcDEBUG_COMPONENT("channel_0_analyzer_1_array_crystal_array_8", mcposachannel_0_analyzer_1_array_crystal_array_8, mcrotachannel_0_analyzer_1_array_crystal_array_8)
  mccomp_posa[138] = mcposachannel_0_analyzer_1_array_crystal_array_8;
  mccomp_posr[138] = mcposrchannel_0_analyzer_1_array_crystal_array_8;
  mcNCounter[138]  = mcPCounter[138] = mcP2Counter[138] = 0;
  mcAbsorbProp[138]= 0;
    /* Component channel_0_analyzer_2_center. */
  /* Setting parameters for component channel_0_analyzer_2_center. */
  SIG_MESSAGE("channel_0_analyzer_2_center (Init:SetPar)");

  SIG_MESSAGE("channel_0_analyzer_2_center (Init:Place/Rotate)");
  rot_set_rotation(mctr1,
    (0.0)*DEG2RAD,
    (0.0)*DEG2RAD,
    (0.0)*DEG2RAD);
#line 97302 "MACS_sample_kidney_box.c"
  rot_mul(mctr1, mcrotachannel_0_analyzer_1_center, mcrotachannel_0_analyzer_2_center);
  rot_transpose(mcrotachannel_0_analyzer_1_array_crystal_array_8, mctr1);
  rot_mul(mcrotachannel_0_analyzer_2_center, mctr1, mcrotrchannel_0_analyzer_2_center);
  mctc1 = coords_set(
#line 555 "MACS_sample_kidney_box.instr"
    - analyzer_seperation,
#line 555 "MACS_sample_kidney_box.instr"
    0,
#line 555 "MACS_sample_kidney_box.instr"
    0);
#line 97313 "MACS_sample_kidney_box.c"
  rot_transpose(mcrotachannel_0_analyzer_1_center, mctr1);
  mctc2 = rot_apply(mctr1, mctc1);
  mcposachannel_0_analyzer_2_center = coords_add(mcposachannel_0_analyzer_1_center, mctc2);
  mctc1 = coords_sub(mcposachannel_0_analyzer_1_array_crystal_array_8, mcposachannel_0_analyzer_2_center);
  mcposrchannel_0_analyzer_2_center = rot_apply(mcrotachannel_0_analyzer_2_center, mctc1);
  mcDEBUG_COMPONENT("channel_0_analyzer_2_center", mcposachannel_0_analyzer_2_center, mcrotachannel_0_analyzer_2_center)
  mccomp_posa[139] = mcposachannel_0_analyzer_2_center;
  mccomp_posr[139] = mcposrchannel_0_analyzer_2_center;
  mcNCounter[139]  = mcPCounter[139] = mcP2Counter[139] = 0;
  mcAbsorbProp[139]= 0;
    /* Component channel_0_analyzer_2_rotated. */
  /* Setting parameters for component channel_0_analyzer_2_rotated. */
  SIG_MESSAGE("channel_0_analyzer_2_rotated (Init:SetPar)");

  SIG_MESSAGE("channel_0_analyzer_2_rotated (Init:Place/Rotate)");
  rot_set_rotation(mctr1,
#line 559 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 559 "MACS_sample_kidney_box.instr"
    (- analyzer_theta [ 0 ])*DEG2RAD,
#line 559 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD);
#line 97336 "MACS_sample_kidney_box.c"
  rot_mul(mctr1, mcrotachannel_0_analyzer_2_center, mcrotachannel_0_analyzer_2_rotated);
  rot_transpose(mcrotachannel_0_analyzer_2_center, mctr1);
  rot_mul(mcrotachannel_0_analyzer_2_rotated, mctr1, mcrotrchannel_0_analyzer_2_rotated);
  mctc1 = coords_set(
#line 558 "MACS_sample_kidney_box.instr"
    0,
#line 558 "MACS_sample_kidney_box.instr"
    0,
#line 558 "MACS_sample_kidney_box.instr"
    0.5 * analyzer_seperation / tan ( analyzer_2theta [ 0 ] * DEG2RAD ));
#line 97347 "MACS_sample_kidney_box.c"
  rot_transpose(mcrotachannel_0_analyzer_2_center, mctr1);
  mctc2 = rot_apply(mctr1, mctc1);
  mcposachannel_0_analyzer_2_rotated = coords_add(mcposachannel_0_analyzer_2_center, mctc2);
  mctc1 = coords_sub(mcposachannel_0_analyzer_2_center, mcposachannel_0_analyzer_2_rotated);
  mcposrchannel_0_analyzer_2_rotated = rot_apply(mcrotachannel_0_analyzer_2_rotated, mctc1);
  mcDEBUG_COMPONENT("channel_0_analyzer_2_rotated", mcposachannel_0_analyzer_2_rotated, mcrotachannel_0_analyzer_2_rotated)
  mccomp_posa[140] = mcposachannel_0_analyzer_2_rotated;
  mccomp_posr[140] = mcposrchannel_0_analyzer_2_rotated;
  mcNCounter[140]  = mcPCounter[140] = mcP2Counter[140] = 0;
  mcAbsorbProp[140]= 0;
    /* Component channel_0_analyzer_2_array_crystal_array_0. */
  /* Setting parameters for component channel_0_analyzer_2_array_crystal_array_0. */
  SIG_MESSAGE("channel_0_analyzer_2_array_crystal_array_0 (Init:SetPar)");
#line 563 "MACS_sample_kidney_box.instr"
  if("PG_analyzer") strncpy(mccchannel_0_analyzer_2_array_crystal_array_0_material_string, "PG_analyzer" ? "PG_analyzer" : "", 16384); else mccchannel_0_analyzer_2_array_crystal_array_0_material_string[0]='\0';
#line 563 "MACS_sample_kidney_box.instr"
  mccchannel_0_analyzer_2_array_crystal_array_0_priority = 221.0;
#line 562 "MACS_sample_kidney_box.instr"
  mccchannel_0_analyzer_2_array_crystal_array_0_xwidth = channel_0_analyzer_2_array_crystal_depth;
#line 562 "MACS_sample_kidney_box.instr"
  mccchannel_0_analyzer_2_array_crystal_array_0_yheight = channel_0_analyzer_2_array_crystal_height;
#line 562 "MACS_sample_kidney_box.instr"
  mccchannel_0_analyzer_2_array_crystal_array_0_zdepth = channel_0_analyzer_2_array_crystal_width;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_0_analyzer_2_array_crystal_array_0_xwidth2 = -1;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_0_analyzer_2_array_crystal_array_0_yheight2 = -1;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_0_analyzer_2_array_crystal_array_0_visualize = 1;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_0_analyzer_2_array_crystal_array_0_target_index = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_0_analyzer_2_array_crystal_array_0_target_x = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_0_analyzer_2_array_crystal_array_0_target_y = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_0_analyzer_2_array_crystal_array_0_target_z = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_0_analyzer_2_array_crystal_array_0_focus_aw = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_0_analyzer_2_array_crystal_array_0_focus_ah = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_0_analyzer_2_array_crystal_array_0_focus_xw = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_0_analyzer_2_array_crystal_array_0_focus_xh = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_0_analyzer_2_array_crystal_array_0_focus_r = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_0_analyzer_2_array_crystal_array_0_p_interact = 0;
#line 71 "MACS_sample_kidney_box.instr"
  if(0) strncpy(mccchannel_0_analyzer_2_array_crystal_array_0_mask_string, 0 ? 0 : "", 16384); else mccchannel_0_analyzer_2_array_crystal_array_0_mask_string[0]='\0';
#line 71 "MACS_sample_kidney_box.instr"
  if(0) strncpy(mccchannel_0_analyzer_2_array_crystal_array_0_mask_setting, 0 ? 0 : "", 16384); else mccchannel_0_analyzer_2_array_crystal_array_0_mask_setting[0]='\0';
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_0_analyzer_2_array_crystal_array_0_number_of_activations = 1;
#line 97403 "MACS_sample_kidney_box.c"

  SIG_MESSAGE("channel_0_analyzer_2_array_crystal_array_0 (Init:Place/Rotate)");
  rot_set_rotation(mctr1,
#line 565 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 565 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 565 "MACS_sample_kidney_box.instr"
    (0 - RAD2DEG * channel_0_analyzer_2_array_theta [ 0 ])*DEG2RAD);
#line 97413 "MACS_sample_kidney_box.c"
  rot_mul(mctr1, mcrotachannel_0_analyzer_2_rotated, mcrotachannel_0_analyzer_2_array_crystal_array_0);
  rot_transpose(mcrotachannel_0_analyzer_2_rotated, mctr1);
  rot_mul(mcrotachannel_0_analyzer_2_array_crystal_array_0, mctr1, mcrotrchannel_0_analyzer_2_array_crystal_array_0);
  mctc1 = coords_set(
#line 564 "MACS_sample_kidney_box.instr"
    0 + channel_0_analyzer_2_array_effective_radius_of_curvature * ( 1 - cos ( channel_0_analyzer_2_array_theta [ 0 ] ) ),
#line 564 "MACS_sample_kidney_box.instr"
    0 + channel_0_analyzer_2_array_effective_radius_of_curvature * sin ( channel_0_analyzer_2_array_theta [ 0 ] ),
#line 564 "MACS_sample_kidney_box.instr"
    0);
#line 97424 "MACS_sample_kidney_box.c"
  rot_transpose(mcrotachannel_0_analyzer_2_rotated, mctr1);
  mctc2 = rot_apply(mctr1, mctc1);
  mcposachannel_0_analyzer_2_array_crystal_array_0 = coords_add(mcposachannel_0_analyzer_2_rotated, mctc2);
  mctc1 = coords_sub(mcposachannel_0_analyzer_2_rotated, mcposachannel_0_analyzer_2_array_crystal_array_0);
  mcposrchannel_0_analyzer_2_array_crystal_array_0 = rot_apply(mcrotachannel_0_analyzer_2_array_crystal_array_0, mctc1);
  mcDEBUG_COMPONENT("channel_0_analyzer_2_array_crystal_array_0", mcposachannel_0_analyzer_2_array_crystal_array_0, mcrotachannel_0_analyzer_2_array_crystal_array_0)
  mccomp_posa[141] = mcposachannel_0_analyzer_2_array_crystal_array_0;
  mccomp_posr[141] = mcposrchannel_0_analyzer_2_array_crystal_array_0;
  mcNCounter[141]  = mcPCounter[141] = mcP2Counter[141] = 0;
  mcAbsorbProp[141]= 0;
    /* Component channel_0_analyzer_2_array_crystal_array_1. */
  /* Setting parameters for component channel_0_analyzer_2_array_crystal_array_1. */
  SIG_MESSAGE("channel_0_analyzer_2_array_crystal_array_1 (Init:SetPar)");
#line 569 "MACS_sample_kidney_box.instr"
  if("PG_analyzer") strncpy(mccchannel_0_analyzer_2_array_crystal_array_1_material_string, "PG_analyzer" ? "PG_analyzer" : "", 16384); else mccchannel_0_analyzer_2_array_crystal_array_1_material_string[0]='\0';
#line 569 "MACS_sample_kidney_box.instr"
  mccchannel_0_analyzer_2_array_crystal_array_1_priority = 221.1;
#line 568 "MACS_sample_kidney_box.instr"
  mccchannel_0_analyzer_2_array_crystal_array_1_xwidth = channel_0_analyzer_2_array_crystal_depth;
#line 568 "MACS_sample_kidney_box.instr"
  mccchannel_0_analyzer_2_array_crystal_array_1_yheight = channel_0_analyzer_2_array_crystal_height;
#line 568 "MACS_sample_kidney_box.instr"
  mccchannel_0_analyzer_2_array_crystal_array_1_zdepth = channel_0_analyzer_2_array_crystal_width;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_0_analyzer_2_array_crystal_array_1_xwidth2 = -1;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_0_analyzer_2_array_crystal_array_1_yheight2 = -1;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_0_analyzer_2_array_crystal_array_1_visualize = 1;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_0_analyzer_2_array_crystal_array_1_target_index = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_0_analyzer_2_array_crystal_array_1_target_x = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_0_analyzer_2_array_crystal_array_1_target_y = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_0_analyzer_2_array_crystal_array_1_target_z = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_0_analyzer_2_array_crystal_array_1_focus_aw = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_0_analyzer_2_array_crystal_array_1_focus_ah = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_0_analyzer_2_array_crystal_array_1_focus_xw = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_0_analyzer_2_array_crystal_array_1_focus_xh = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_0_analyzer_2_array_crystal_array_1_focus_r = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_0_analyzer_2_array_crystal_array_1_p_interact = 0;
#line 71 "MACS_sample_kidney_box.instr"
  if(0) strncpy(mccchannel_0_analyzer_2_array_crystal_array_1_mask_string, 0 ? 0 : "", 16384); else mccchannel_0_analyzer_2_array_crystal_array_1_mask_string[0]='\0';
#line 71 "MACS_sample_kidney_box.instr"
  if(0) strncpy(mccchannel_0_analyzer_2_array_crystal_array_1_mask_setting, 0 ? 0 : "", 16384); else mccchannel_0_analyzer_2_array_crystal_array_1_mask_setting[0]='\0';
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_0_analyzer_2_array_crystal_array_1_number_of_activations = 1;
#line 97480 "MACS_sample_kidney_box.c"

  SIG_MESSAGE("channel_0_analyzer_2_array_crystal_array_1 (Init:Place/Rotate)");
  rot_set_rotation(mctr1,
#line 571 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 571 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 571 "MACS_sample_kidney_box.instr"
    (0 - RAD2DEG * channel_0_analyzer_2_array_theta [ 1 ])*DEG2RAD);
#line 97490 "MACS_sample_kidney_box.c"
  rot_mul(mctr1, mcrotachannel_0_analyzer_2_rotated, mcrotachannel_0_analyzer_2_array_crystal_array_1);
  rot_transpose(mcrotachannel_0_analyzer_2_array_crystal_array_0, mctr1);
  rot_mul(mcrotachannel_0_analyzer_2_array_crystal_array_1, mctr1, mcrotrchannel_0_analyzer_2_array_crystal_array_1);
  mctc1 = coords_set(
#line 570 "MACS_sample_kidney_box.instr"
    0 + channel_0_analyzer_2_array_effective_radius_of_curvature * ( 1 - cos ( channel_0_analyzer_2_array_theta [ 1 ] ) ),
#line 570 "MACS_sample_kidney_box.instr"
    0 + channel_0_analyzer_2_array_effective_radius_of_curvature * sin ( channel_0_analyzer_2_array_theta [ 1 ] ),
#line 570 "MACS_sample_kidney_box.instr"
    0);
#line 97501 "MACS_sample_kidney_box.c"
  rot_transpose(mcrotachannel_0_analyzer_2_rotated, mctr1);
  mctc2 = rot_apply(mctr1, mctc1);
  mcposachannel_0_analyzer_2_array_crystal_array_1 = coords_add(mcposachannel_0_analyzer_2_rotated, mctc2);
  mctc1 = coords_sub(mcposachannel_0_analyzer_2_array_crystal_array_0, mcposachannel_0_analyzer_2_array_crystal_array_1);
  mcposrchannel_0_analyzer_2_array_crystal_array_1 = rot_apply(mcrotachannel_0_analyzer_2_array_crystal_array_1, mctc1);
  mcDEBUG_COMPONENT("channel_0_analyzer_2_array_crystal_array_1", mcposachannel_0_analyzer_2_array_crystal_array_1, mcrotachannel_0_analyzer_2_array_crystal_array_1)
  mccomp_posa[142] = mcposachannel_0_analyzer_2_array_crystal_array_1;
  mccomp_posr[142] = mcposrchannel_0_analyzer_2_array_crystal_array_1;
  mcNCounter[142]  = mcPCounter[142] = mcP2Counter[142] = 0;
  mcAbsorbProp[142]= 0;
    /* Component channel_0_analyzer_2_array_crystal_array_2. */
  /* Setting parameters for component channel_0_analyzer_2_array_crystal_array_2. */
  SIG_MESSAGE("channel_0_analyzer_2_array_crystal_array_2 (Init:SetPar)");
#line 575 "MACS_sample_kidney_box.instr"
  if("PG_analyzer") strncpy(mccchannel_0_analyzer_2_array_crystal_array_2_material_string, "PG_analyzer" ? "PG_analyzer" : "", 16384); else mccchannel_0_analyzer_2_array_crystal_array_2_material_string[0]='\0';
#line 575 "MACS_sample_kidney_box.instr"
  mccchannel_0_analyzer_2_array_crystal_array_2_priority = 221.2;
#line 574 "MACS_sample_kidney_box.instr"
  mccchannel_0_analyzer_2_array_crystal_array_2_xwidth = channel_0_analyzer_2_array_crystal_depth;
#line 574 "MACS_sample_kidney_box.instr"
  mccchannel_0_analyzer_2_array_crystal_array_2_yheight = channel_0_analyzer_2_array_crystal_height;
#line 574 "MACS_sample_kidney_box.instr"
  mccchannel_0_analyzer_2_array_crystal_array_2_zdepth = channel_0_analyzer_2_array_crystal_width;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_0_analyzer_2_array_crystal_array_2_xwidth2 = -1;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_0_analyzer_2_array_crystal_array_2_yheight2 = -1;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_0_analyzer_2_array_crystal_array_2_visualize = 1;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_0_analyzer_2_array_crystal_array_2_target_index = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_0_analyzer_2_array_crystal_array_2_target_x = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_0_analyzer_2_array_crystal_array_2_target_y = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_0_analyzer_2_array_crystal_array_2_target_z = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_0_analyzer_2_array_crystal_array_2_focus_aw = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_0_analyzer_2_array_crystal_array_2_focus_ah = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_0_analyzer_2_array_crystal_array_2_focus_xw = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_0_analyzer_2_array_crystal_array_2_focus_xh = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_0_analyzer_2_array_crystal_array_2_focus_r = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_0_analyzer_2_array_crystal_array_2_p_interact = 0;
#line 71 "MACS_sample_kidney_box.instr"
  if(0) strncpy(mccchannel_0_analyzer_2_array_crystal_array_2_mask_string, 0 ? 0 : "", 16384); else mccchannel_0_analyzer_2_array_crystal_array_2_mask_string[0]='\0';
#line 71 "MACS_sample_kidney_box.instr"
  if(0) strncpy(mccchannel_0_analyzer_2_array_crystal_array_2_mask_setting, 0 ? 0 : "", 16384); else mccchannel_0_analyzer_2_array_crystal_array_2_mask_setting[0]='\0';
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_0_analyzer_2_array_crystal_array_2_number_of_activations = 1;
#line 97557 "MACS_sample_kidney_box.c"

  SIG_MESSAGE("channel_0_analyzer_2_array_crystal_array_2 (Init:Place/Rotate)");
  rot_set_rotation(mctr1,
#line 577 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 577 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 577 "MACS_sample_kidney_box.instr"
    (0 - RAD2DEG * channel_0_analyzer_2_array_theta [ 2 ])*DEG2RAD);
#line 97567 "MACS_sample_kidney_box.c"
  rot_mul(mctr1, mcrotachannel_0_analyzer_2_rotated, mcrotachannel_0_analyzer_2_array_crystal_array_2);
  rot_transpose(mcrotachannel_0_analyzer_2_array_crystal_array_1, mctr1);
  rot_mul(mcrotachannel_0_analyzer_2_array_crystal_array_2, mctr1, mcrotrchannel_0_analyzer_2_array_crystal_array_2);
  mctc1 = coords_set(
#line 576 "MACS_sample_kidney_box.instr"
    0 + channel_0_analyzer_2_array_effective_radius_of_curvature * ( 1 - cos ( channel_0_analyzer_2_array_theta [ 2 ] ) ),
#line 576 "MACS_sample_kidney_box.instr"
    0 + channel_0_analyzer_2_array_effective_radius_of_curvature * sin ( channel_0_analyzer_2_array_theta [ 2 ] ),
#line 576 "MACS_sample_kidney_box.instr"
    0);
#line 97578 "MACS_sample_kidney_box.c"
  rot_transpose(mcrotachannel_0_analyzer_2_rotated, mctr1);
  mctc2 = rot_apply(mctr1, mctc1);
  mcposachannel_0_analyzer_2_array_crystal_array_2 = coords_add(mcposachannel_0_analyzer_2_rotated, mctc2);
  mctc1 = coords_sub(mcposachannel_0_analyzer_2_array_crystal_array_1, mcposachannel_0_analyzer_2_array_crystal_array_2);
  mcposrchannel_0_analyzer_2_array_crystal_array_2 = rot_apply(mcrotachannel_0_analyzer_2_array_crystal_array_2, mctc1);
  mcDEBUG_COMPONENT("channel_0_analyzer_2_array_crystal_array_2", mcposachannel_0_analyzer_2_array_crystal_array_2, mcrotachannel_0_analyzer_2_array_crystal_array_2)
  mccomp_posa[143] = mcposachannel_0_analyzer_2_array_crystal_array_2;
  mccomp_posr[143] = mcposrchannel_0_analyzer_2_array_crystal_array_2;
  mcNCounter[143]  = mcPCounter[143] = mcP2Counter[143] = 0;
  mcAbsorbProp[143]= 0;
    /* Component channel_0_analyzer_2_array_crystal_array_3. */
  /* Setting parameters for component channel_0_analyzer_2_array_crystal_array_3. */
  SIG_MESSAGE("channel_0_analyzer_2_array_crystal_array_3 (Init:SetPar)");
#line 581 "MACS_sample_kidney_box.instr"
  if("PG_analyzer") strncpy(mccchannel_0_analyzer_2_array_crystal_array_3_material_string, "PG_analyzer" ? "PG_analyzer" : "", 16384); else mccchannel_0_analyzer_2_array_crystal_array_3_material_string[0]='\0';
#line 581 "MACS_sample_kidney_box.instr"
  mccchannel_0_analyzer_2_array_crystal_array_3_priority = 221.3;
#line 580 "MACS_sample_kidney_box.instr"
  mccchannel_0_analyzer_2_array_crystal_array_3_xwidth = channel_0_analyzer_2_array_crystal_depth;
#line 580 "MACS_sample_kidney_box.instr"
  mccchannel_0_analyzer_2_array_crystal_array_3_yheight = channel_0_analyzer_2_array_crystal_height;
#line 580 "MACS_sample_kidney_box.instr"
  mccchannel_0_analyzer_2_array_crystal_array_3_zdepth = channel_0_analyzer_2_array_crystal_width;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_0_analyzer_2_array_crystal_array_3_xwidth2 = -1;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_0_analyzer_2_array_crystal_array_3_yheight2 = -1;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_0_analyzer_2_array_crystal_array_3_visualize = 1;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_0_analyzer_2_array_crystal_array_3_target_index = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_0_analyzer_2_array_crystal_array_3_target_x = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_0_analyzer_2_array_crystal_array_3_target_y = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_0_analyzer_2_array_crystal_array_3_target_z = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_0_analyzer_2_array_crystal_array_3_focus_aw = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_0_analyzer_2_array_crystal_array_3_focus_ah = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_0_analyzer_2_array_crystal_array_3_focus_xw = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_0_analyzer_2_array_crystal_array_3_focus_xh = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_0_analyzer_2_array_crystal_array_3_focus_r = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_0_analyzer_2_array_crystal_array_3_p_interact = 0;
#line 71 "MACS_sample_kidney_box.instr"
  if(0) strncpy(mccchannel_0_analyzer_2_array_crystal_array_3_mask_string, 0 ? 0 : "", 16384); else mccchannel_0_analyzer_2_array_crystal_array_3_mask_string[0]='\0';
#line 71 "MACS_sample_kidney_box.instr"
  if(0) strncpy(mccchannel_0_analyzer_2_array_crystal_array_3_mask_setting, 0 ? 0 : "", 16384); else mccchannel_0_analyzer_2_array_crystal_array_3_mask_setting[0]='\0';
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_0_analyzer_2_array_crystal_array_3_number_of_activations = 1;
#line 97634 "MACS_sample_kidney_box.c"

  SIG_MESSAGE("channel_0_analyzer_2_array_crystal_array_3 (Init:Place/Rotate)");
  rot_set_rotation(mctr1,
#line 583 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 583 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 583 "MACS_sample_kidney_box.instr"
    (0 - RAD2DEG * channel_0_analyzer_2_array_theta [ 3 ])*DEG2RAD);
#line 97644 "MACS_sample_kidney_box.c"
  rot_mul(mctr1, mcrotachannel_0_analyzer_2_rotated, mcrotachannel_0_analyzer_2_array_crystal_array_3);
  rot_transpose(mcrotachannel_0_analyzer_2_array_crystal_array_2, mctr1);
  rot_mul(mcrotachannel_0_analyzer_2_array_crystal_array_3, mctr1, mcrotrchannel_0_analyzer_2_array_crystal_array_3);
  mctc1 = coords_set(
#line 582 "MACS_sample_kidney_box.instr"
    0 + channel_0_analyzer_2_array_effective_radius_of_curvature * ( 1 - cos ( channel_0_analyzer_2_array_theta [ 3 ] ) ),
#line 582 "MACS_sample_kidney_box.instr"
    0 + channel_0_analyzer_2_array_effective_radius_of_curvature * sin ( channel_0_analyzer_2_array_theta [ 3 ] ),
#line 582 "MACS_sample_kidney_box.instr"
    0);
#line 97655 "MACS_sample_kidney_box.c"
  rot_transpose(mcrotachannel_0_analyzer_2_rotated, mctr1);
  mctc2 = rot_apply(mctr1, mctc1);
  mcposachannel_0_analyzer_2_array_crystal_array_3 = coords_add(mcposachannel_0_analyzer_2_rotated, mctc2);
  mctc1 = coords_sub(mcposachannel_0_analyzer_2_array_crystal_array_2, mcposachannel_0_analyzer_2_array_crystal_array_3);
  mcposrchannel_0_analyzer_2_array_crystal_array_3 = rot_apply(mcrotachannel_0_analyzer_2_array_crystal_array_3, mctc1);
  mcDEBUG_COMPONENT("channel_0_analyzer_2_array_crystal_array_3", mcposachannel_0_analyzer_2_array_crystal_array_3, mcrotachannel_0_analyzer_2_array_crystal_array_3)
  mccomp_posa[144] = mcposachannel_0_analyzer_2_array_crystal_array_3;
  mccomp_posr[144] = mcposrchannel_0_analyzer_2_array_crystal_array_3;
  mcNCounter[144]  = mcPCounter[144] = mcP2Counter[144] = 0;
  mcAbsorbProp[144]= 0;
    /* Component channel_0_analyzer_2_array_crystal_array_4. */
  /* Setting parameters for component channel_0_analyzer_2_array_crystal_array_4. */
  SIG_MESSAGE("channel_0_analyzer_2_array_crystal_array_4 (Init:SetPar)");
#line 587 "MACS_sample_kidney_box.instr"
  if("PG_analyzer") strncpy(mccchannel_0_analyzer_2_array_crystal_array_4_material_string, "PG_analyzer" ? "PG_analyzer" : "", 16384); else mccchannel_0_analyzer_2_array_crystal_array_4_material_string[0]='\0';
#line 587 "MACS_sample_kidney_box.instr"
  mccchannel_0_analyzer_2_array_crystal_array_4_priority = 221.4;
#line 586 "MACS_sample_kidney_box.instr"
  mccchannel_0_analyzer_2_array_crystal_array_4_xwidth = channel_0_analyzer_2_array_crystal_depth;
#line 586 "MACS_sample_kidney_box.instr"
  mccchannel_0_analyzer_2_array_crystal_array_4_yheight = channel_0_analyzer_2_array_crystal_height;
#line 586 "MACS_sample_kidney_box.instr"
  mccchannel_0_analyzer_2_array_crystal_array_4_zdepth = channel_0_analyzer_2_array_crystal_width;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_0_analyzer_2_array_crystal_array_4_xwidth2 = -1;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_0_analyzer_2_array_crystal_array_4_yheight2 = -1;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_0_analyzer_2_array_crystal_array_4_visualize = 1;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_0_analyzer_2_array_crystal_array_4_target_index = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_0_analyzer_2_array_crystal_array_4_target_x = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_0_analyzer_2_array_crystal_array_4_target_y = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_0_analyzer_2_array_crystal_array_4_target_z = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_0_analyzer_2_array_crystal_array_4_focus_aw = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_0_analyzer_2_array_crystal_array_4_focus_ah = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_0_analyzer_2_array_crystal_array_4_focus_xw = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_0_analyzer_2_array_crystal_array_4_focus_xh = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_0_analyzer_2_array_crystal_array_4_focus_r = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_0_analyzer_2_array_crystal_array_4_p_interact = 0;
#line 71 "MACS_sample_kidney_box.instr"
  if(0) strncpy(mccchannel_0_analyzer_2_array_crystal_array_4_mask_string, 0 ? 0 : "", 16384); else mccchannel_0_analyzer_2_array_crystal_array_4_mask_string[0]='\0';
#line 71 "MACS_sample_kidney_box.instr"
  if(0) strncpy(mccchannel_0_analyzer_2_array_crystal_array_4_mask_setting, 0 ? 0 : "", 16384); else mccchannel_0_analyzer_2_array_crystal_array_4_mask_setting[0]='\0';
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_0_analyzer_2_array_crystal_array_4_number_of_activations = 1;
#line 97711 "MACS_sample_kidney_box.c"

  SIG_MESSAGE("channel_0_analyzer_2_array_crystal_array_4 (Init:Place/Rotate)");
  rot_set_rotation(mctr1,
#line 589 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 589 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 589 "MACS_sample_kidney_box.instr"
    (0 - RAD2DEG * channel_0_analyzer_2_array_theta [ 4 ])*DEG2RAD);
#line 97721 "MACS_sample_kidney_box.c"
  rot_mul(mctr1, mcrotachannel_0_analyzer_2_rotated, mcrotachannel_0_analyzer_2_array_crystal_array_4);
  rot_transpose(mcrotachannel_0_analyzer_2_array_crystal_array_3, mctr1);
  rot_mul(mcrotachannel_0_analyzer_2_array_crystal_array_4, mctr1, mcrotrchannel_0_analyzer_2_array_crystal_array_4);
  mctc1 = coords_set(
#line 588 "MACS_sample_kidney_box.instr"
    0 + channel_0_analyzer_2_array_effective_radius_of_curvature * ( 1 - cos ( channel_0_analyzer_2_array_theta [ 4 ] ) ),
#line 588 "MACS_sample_kidney_box.instr"
    0 + channel_0_analyzer_2_array_effective_radius_of_curvature * sin ( channel_0_analyzer_2_array_theta [ 4 ] ),
#line 588 "MACS_sample_kidney_box.instr"
    0);
#line 97732 "MACS_sample_kidney_box.c"
  rot_transpose(mcrotachannel_0_analyzer_2_rotated, mctr1);
  mctc2 = rot_apply(mctr1, mctc1);
  mcposachannel_0_analyzer_2_array_crystal_array_4 = coords_add(mcposachannel_0_analyzer_2_rotated, mctc2);
  mctc1 = coords_sub(mcposachannel_0_analyzer_2_array_crystal_array_3, mcposachannel_0_analyzer_2_array_crystal_array_4);
  mcposrchannel_0_analyzer_2_array_crystal_array_4 = rot_apply(mcrotachannel_0_analyzer_2_array_crystal_array_4, mctc1);
  mcDEBUG_COMPONENT("channel_0_analyzer_2_array_crystal_array_4", mcposachannel_0_analyzer_2_array_crystal_array_4, mcrotachannel_0_analyzer_2_array_crystal_array_4)
  mccomp_posa[145] = mcposachannel_0_analyzer_2_array_crystal_array_4;
  mccomp_posr[145] = mcposrchannel_0_analyzer_2_array_crystal_array_4;
  mcNCounter[145]  = mcPCounter[145] = mcP2Counter[145] = 0;
  mcAbsorbProp[145]= 0;
    /* Component channel_0_analyzer_2_array_crystal_array_5. */
  /* Setting parameters for component channel_0_analyzer_2_array_crystal_array_5. */
  SIG_MESSAGE("channel_0_analyzer_2_array_crystal_array_5 (Init:SetPar)");
#line 593 "MACS_sample_kidney_box.instr"
  if("PG_analyzer") strncpy(mccchannel_0_analyzer_2_array_crystal_array_5_material_string, "PG_analyzer" ? "PG_analyzer" : "", 16384); else mccchannel_0_analyzer_2_array_crystal_array_5_material_string[0]='\0';
#line 593 "MACS_sample_kidney_box.instr"
  mccchannel_0_analyzer_2_array_crystal_array_5_priority = 221.5;
#line 592 "MACS_sample_kidney_box.instr"
  mccchannel_0_analyzer_2_array_crystal_array_5_xwidth = channel_0_analyzer_2_array_crystal_depth;
#line 592 "MACS_sample_kidney_box.instr"
  mccchannel_0_analyzer_2_array_crystal_array_5_yheight = channel_0_analyzer_2_array_crystal_height;
#line 592 "MACS_sample_kidney_box.instr"
  mccchannel_0_analyzer_2_array_crystal_array_5_zdepth = channel_0_analyzer_2_array_crystal_width;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_0_analyzer_2_array_crystal_array_5_xwidth2 = -1;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_0_analyzer_2_array_crystal_array_5_yheight2 = -1;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_0_analyzer_2_array_crystal_array_5_visualize = 1;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_0_analyzer_2_array_crystal_array_5_target_index = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_0_analyzer_2_array_crystal_array_5_target_x = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_0_analyzer_2_array_crystal_array_5_target_y = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_0_analyzer_2_array_crystal_array_5_target_z = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_0_analyzer_2_array_crystal_array_5_focus_aw = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_0_analyzer_2_array_crystal_array_5_focus_ah = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_0_analyzer_2_array_crystal_array_5_focus_xw = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_0_analyzer_2_array_crystal_array_5_focus_xh = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_0_analyzer_2_array_crystal_array_5_focus_r = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_0_analyzer_2_array_crystal_array_5_p_interact = 0;
#line 71 "MACS_sample_kidney_box.instr"
  if(0) strncpy(mccchannel_0_analyzer_2_array_crystal_array_5_mask_string, 0 ? 0 : "", 16384); else mccchannel_0_analyzer_2_array_crystal_array_5_mask_string[0]='\0';
#line 71 "MACS_sample_kidney_box.instr"
  if(0) strncpy(mccchannel_0_analyzer_2_array_crystal_array_5_mask_setting, 0 ? 0 : "", 16384); else mccchannel_0_analyzer_2_array_crystal_array_5_mask_setting[0]='\0';
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_0_analyzer_2_array_crystal_array_5_number_of_activations = 1;
#line 97788 "MACS_sample_kidney_box.c"

  SIG_MESSAGE("channel_0_analyzer_2_array_crystal_array_5 (Init:Place/Rotate)");
  rot_set_rotation(mctr1,
#line 595 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 595 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 595 "MACS_sample_kidney_box.instr"
    (0 - RAD2DEG * channel_0_analyzer_2_array_theta [ 5 ])*DEG2RAD);
#line 97798 "MACS_sample_kidney_box.c"
  rot_mul(mctr1, mcrotachannel_0_analyzer_2_rotated, mcrotachannel_0_analyzer_2_array_crystal_array_5);
  rot_transpose(mcrotachannel_0_analyzer_2_array_crystal_array_4, mctr1);
  rot_mul(mcrotachannel_0_analyzer_2_array_crystal_array_5, mctr1, mcrotrchannel_0_analyzer_2_array_crystal_array_5);
  mctc1 = coords_set(
#line 594 "MACS_sample_kidney_box.instr"
    0 + channel_0_analyzer_2_array_effective_radius_of_curvature * ( 1 - cos ( channel_0_analyzer_2_array_theta [ 5 ] ) ),
#line 594 "MACS_sample_kidney_box.instr"
    0 + channel_0_analyzer_2_array_effective_radius_of_curvature * sin ( channel_0_analyzer_2_array_theta [ 5 ] ),
#line 594 "MACS_sample_kidney_box.instr"
    0);
#line 97809 "MACS_sample_kidney_box.c"
  rot_transpose(mcrotachannel_0_analyzer_2_rotated, mctr1);
  mctc2 = rot_apply(mctr1, mctc1);
  mcposachannel_0_analyzer_2_array_crystal_array_5 = coords_add(mcposachannel_0_analyzer_2_rotated, mctc2);
  mctc1 = coords_sub(mcposachannel_0_analyzer_2_array_crystal_array_4, mcposachannel_0_analyzer_2_array_crystal_array_5);
  mcposrchannel_0_analyzer_2_array_crystal_array_5 = rot_apply(mcrotachannel_0_analyzer_2_array_crystal_array_5, mctc1);
  mcDEBUG_COMPONENT("channel_0_analyzer_2_array_crystal_array_5", mcposachannel_0_analyzer_2_array_crystal_array_5, mcrotachannel_0_analyzer_2_array_crystal_array_5)
  mccomp_posa[146] = mcposachannel_0_analyzer_2_array_crystal_array_5;
  mccomp_posr[146] = mcposrchannel_0_analyzer_2_array_crystal_array_5;
  mcNCounter[146]  = mcPCounter[146] = mcP2Counter[146] = 0;
  mcAbsorbProp[146]= 0;
    /* Component channel_0_analyzer_2_array_crystal_array_6. */
  /* Setting parameters for component channel_0_analyzer_2_array_crystal_array_6. */
  SIG_MESSAGE("channel_0_analyzer_2_array_crystal_array_6 (Init:SetPar)");
#line 599 "MACS_sample_kidney_box.instr"
  if("PG_analyzer") strncpy(mccchannel_0_analyzer_2_array_crystal_array_6_material_string, "PG_analyzer" ? "PG_analyzer" : "", 16384); else mccchannel_0_analyzer_2_array_crystal_array_6_material_string[0]='\0';
#line 599 "MACS_sample_kidney_box.instr"
  mccchannel_0_analyzer_2_array_crystal_array_6_priority = 221.6;
#line 598 "MACS_sample_kidney_box.instr"
  mccchannel_0_analyzer_2_array_crystal_array_6_xwidth = channel_0_analyzer_2_array_crystal_depth;
#line 598 "MACS_sample_kidney_box.instr"
  mccchannel_0_analyzer_2_array_crystal_array_6_yheight = channel_0_analyzer_2_array_crystal_height;
#line 598 "MACS_sample_kidney_box.instr"
  mccchannel_0_analyzer_2_array_crystal_array_6_zdepth = channel_0_analyzer_2_array_crystal_width;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_0_analyzer_2_array_crystal_array_6_xwidth2 = -1;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_0_analyzer_2_array_crystal_array_6_yheight2 = -1;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_0_analyzer_2_array_crystal_array_6_visualize = 1;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_0_analyzer_2_array_crystal_array_6_target_index = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_0_analyzer_2_array_crystal_array_6_target_x = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_0_analyzer_2_array_crystal_array_6_target_y = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_0_analyzer_2_array_crystal_array_6_target_z = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_0_analyzer_2_array_crystal_array_6_focus_aw = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_0_analyzer_2_array_crystal_array_6_focus_ah = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_0_analyzer_2_array_crystal_array_6_focus_xw = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_0_analyzer_2_array_crystal_array_6_focus_xh = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_0_analyzer_2_array_crystal_array_6_focus_r = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_0_analyzer_2_array_crystal_array_6_p_interact = 0;
#line 71 "MACS_sample_kidney_box.instr"
  if(0) strncpy(mccchannel_0_analyzer_2_array_crystal_array_6_mask_string, 0 ? 0 : "", 16384); else mccchannel_0_analyzer_2_array_crystal_array_6_mask_string[0]='\0';
#line 71 "MACS_sample_kidney_box.instr"
  if(0) strncpy(mccchannel_0_analyzer_2_array_crystal_array_6_mask_setting, 0 ? 0 : "", 16384); else mccchannel_0_analyzer_2_array_crystal_array_6_mask_setting[0]='\0';
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_0_analyzer_2_array_crystal_array_6_number_of_activations = 1;
#line 97865 "MACS_sample_kidney_box.c"

  SIG_MESSAGE("channel_0_analyzer_2_array_crystal_array_6 (Init:Place/Rotate)");
  rot_set_rotation(mctr1,
#line 601 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 601 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 601 "MACS_sample_kidney_box.instr"
    (0 - RAD2DEG * channel_0_analyzer_2_array_theta [ 6 ])*DEG2RAD);
#line 97875 "MACS_sample_kidney_box.c"
  rot_mul(mctr1, mcrotachannel_0_analyzer_2_rotated, mcrotachannel_0_analyzer_2_array_crystal_array_6);
  rot_transpose(mcrotachannel_0_analyzer_2_array_crystal_array_5, mctr1);
  rot_mul(mcrotachannel_0_analyzer_2_array_crystal_array_6, mctr1, mcrotrchannel_0_analyzer_2_array_crystal_array_6);
  mctc1 = coords_set(
#line 600 "MACS_sample_kidney_box.instr"
    0 + channel_0_analyzer_2_array_effective_radius_of_curvature * ( 1 - cos ( channel_0_analyzer_2_array_theta [ 6 ] ) ),
#line 600 "MACS_sample_kidney_box.instr"
    0 + channel_0_analyzer_2_array_effective_radius_of_curvature * sin ( channel_0_analyzer_2_array_theta [ 6 ] ),
#line 600 "MACS_sample_kidney_box.instr"
    0);
#line 97886 "MACS_sample_kidney_box.c"
  rot_transpose(mcrotachannel_0_analyzer_2_rotated, mctr1);
  mctc2 = rot_apply(mctr1, mctc1);
  mcposachannel_0_analyzer_2_array_crystal_array_6 = coords_add(mcposachannel_0_analyzer_2_rotated, mctc2);
  mctc1 = coords_sub(mcposachannel_0_analyzer_2_array_crystal_array_5, mcposachannel_0_analyzer_2_array_crystal_array_6);
  mcposrchannel_0_analyzer_2_array_crystal_array_6 = rot_apply(mcrotachannel_0_analyzer_2_array_crystal_array_6, mctc1);
  mcDEBUG_COMPONENT("channel_0_analyzer_2_array_crystal_array_6", mcposachannel_0_analyzer_2_array_crystal_array_6, mcrotachannel_0_analyzer_2_array_crystal_array_6)
  mccomp_posa[147] = mcposachannel_0_analyzer_2_array_crystal_array_6;
  mccomp_posr[147] = mcposrchannel_0_analyzer_2_array_crystal_array_6;
  mcNCounter[147]  = mcPCounter[147] = mcP2Counter[147] = 0;
  mcAbsorbProp[147]= 0;
    /* Component channel_0_analyzer_2_array_crystal_array_7. */
  /* Setting parameters for component channel_0_analyzer_2_array_crystal_array_7. */
  SIG_MESSAGE("channel_0_analyzer_2_array_crystal_array_7 (Init:SetPar)");
#line 605 "MACS_sample_kidney_box.instr"
  if("PG_analyzer") strncpy(mccchannel_0_analyzer_2_array_crystal_array_7_material_string, "PG_analyzer" ? "PG_analyzer" : "", 16384); else mccchannel_0_analyzer_2_array_crystal_array_7_material_string[0]='\0';
#line 605 "MACS_sample_kidney_box.instr"
  mccchannel_0_analyzer_2_array_crystal_array_7_priority = 221.7;
#line 604 "MACS_sample_kidney_box.instr"
  mccchannel_0_analyzer_2_array_crystal_array_7_xwidth = channel_0_analyzer_2_array_crystal_depth;
#line 604 "MACS_sample_kidney_box.instr"
  mccchannel_0_analyzer_2_array_crystal_array_7_yheight = channel_0_analyzer_2_array_crystal_height;
#line 604 "MACS_sample_kidney_box.instr"
  mccchannel_0_analyzer_2_array_crystal_array_7_zdepth = channel_0_analyzer_2_array_crystal_width;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_0_analyzer_2_array_crystal_array_7_xwidth2 = -1;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_0_analyzer_2_array_crystal_array_7_yheight2 = -1;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_0_analyzer_2_array_crystal_array_7_visualize = 1;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_0_analyzer_2_array_crystal_array_7_target_index = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_0_analyzer_2_array_crystal_array_7_target_x = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_0_analyzer_2_array_crystal_array_7_target_y = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_0_analyzer_2_array_crystal_array_7_target_z = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_0_analyzer_2_array_crystal_array_7_focus_aw = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_0_analyzer_2_array_crystal_array_7_focus_ah = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_0_analyzer_2_array_crystal_array_7_focus_xw = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_0_analyzer_2_array_crystal_array_7_focus_xh = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_0_analyzer_2_array_crystal_array_7_focus_r = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_0_analyzer_2_array_crystal_array_7_p_interact = 0;
#line 71 "MACS_sample_kidney_box.instr"
  if(0) strncpy(mccchannel_0_analyzer_2_array_crystal_array_7_mask_string, 0 ? 0 : "", 16384); else mccchannel_0_analyzer_2_array_crystal_array_7_mask_string[0]='\0';
#line 71 "MACS_sample_kidney_box.instr"
  if(0) strncpy(mccchannel_0_analyzer_2_array_crystal_array_7_mask_setting, 0 ? 0 : "", 16384); else mccchannel_0_analyzer_2_array_crystal_array_7_mask_setting[0]='\0';
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_0_analyzer_2_array_crystal_array_7_number_of_activations = 1;
#line 97942 "MACS_sample_kidney_box.c"

  SIG_MESSAGE("channel_0_analyzer_2_array_crystal_array_7 (Init:Place/Rotate)");
  rot_set_rotation(mctr1,
#line 607 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 607 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 607 "MACS_sample_kidney_box.instr"
    (0 - RAD2DEG * channel_0_analyzer_2_array_theta [ 7 ])*DEG2RAD);
#line 97952 "MACS_sample_kidney_box.c"
  rot_mul(mctr1, mcrotachannel_0_analyzer_2_rotated, mcrotachannel_0_analyzer_2_array_crystal_array_7);
  rot_transpose(mcrotachannel_0_analyzer_2_array_crystal_array_6, mctr1);
  rot_mul(mcrotachannel_0_analyzer_2_array_crystal_array_7, mctr1, mcrotrchannel_0_analyzer_2_array_crystal_array_7);
  mctc1 = coords_set(
#line 606 "MACS_sample_kidney_box.instr"
    0 + channel_0_analyzer_2_array_effective_radius_of_curvature * ( 1 - cos ( channel_0_analyzer_2_array_theta [ 7 ] ) ),
#line 606 "MACS_sample_kidney_box.instr"
    0 + channel_0_analyzer_2_array_effective_radius_of_curvature * sin ( channel_0_analyzer_2_array_theta [ 7 ] ),
#line 606 "MACS_sample_kidney_box.instr"
    0);
#line 97963 "MACS_sample_kidney_box.c"
  rot_transpose(mcrotachannel_0_analyzer_2_rotated, mctr1);
  mctc2 = rot_apply(mctr1, mctc1);
  mcposachannel_0_analyzer_2_array_crystal_array_7 = coords_add(mcposachannel_0_analyzer_2_rotated, mctc2);
  mctc1 = coords_sub(mcposachannel_0_analyzer_2_array_crystal_array_6, mcposachannel_0_analyzer_2_array_crystal_array_7);
  mcposrchannel_0_analyzer_2_array_crystal_array_7 = rot_apply(mcrotachannel_0_analyzer_2_array_crystal_array_7, mctc1);
  mcDEBUG_COMPONENT("channel_0_analyzer_2_array_crystal_array_7", mcposachannel_0_analyzer_2_array_crystal_array_7, mcrotachannel_0_analyzer_2_array_crystal_array_7)
  mccomp_posa[148] = mcposachannel_0_analyzer_2_array_crystal_array_7;
  mccomp_posr[148] = mcposrchannel_0_analyzer_2_array_crystal_array_7;
  mcNCounter[148]  = mcPCounter[148] = mcP2Counter[148] = 0;
  mcAbsorbProp[148]= 0;
    /* Component channel_0_analyzer_2_array_crystal_array_8. */
  /* Setting parameters for component channel_0_analyzer_2_array_crystal_array_8. */
  SIG_MESSAGE("channel_0_analyzer_2_array_crystal_array_8 (Init:SetPar)");
#line 611 "MACS_sample_kidney_box.instr"
  if("PG_analyzer") strncpy(mccchannel_0_analyzer_2_array_crystal_array_8_material_string, "PG_analyzer" ? "PG_analyzer" : "", 16384); else mccchannel_0_analyzer_2_array_crystal_array_8_material_string[0]='\0';
#line 611 "MACS_sample_kidney_box.instr"
  mccchannel_0_analyzer_2_array_crystal_array_8_priority = 221.8;
#line 610 "MACS_sample_kidney_box.instr"
  mccchannel_0_analyzer_2_array_crystal_array_8_xwidth = channel_0_analyzer_2_array_crystal_depth;
#line 610 "MACS_sample_kidney_box.instr"
  mccchannel_0_analyzer_2_array_crystal_array_8_yheight = channel_0_analyzer_2_array_crystal_height;
#line 610 "MACS_sample_kidney_box.instr"
  mccchannel_0_analyzer_2_array_crystal_array_8_zdepth = channel_0_analyzer_2_array_crystal_width;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_0_analyzer_2_array_crystal_array_8_xwidth2 = -1;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_0_analyzer_2_array_crystal_array_8_yheight2 = -1;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_0_analyzer_2_array_crystal_array_8_visualize = 1;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_0_analyzer_2_array_crystal_array_8_target_index = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_0_analyzer_2_array_crystal_array_8_target_x = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_0_analyzer_2_array_crystal_array_8_target_y = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_0_analyzer_2_array_crystal_array_8_target_z = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_0_analyzer_2_array_crystal_array_8_focus_aw = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_0_analyzer_2_array_crystal_array_8_focus_ah = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_0_analyzer_2_array_crystal_array_8_focus_xw = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_0_analyzer_2_array_crystal_array_8_focus_xh = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_0_analyzer_2_array_crystal_array_8_focus_r = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_0_analyzer_2_array_crystal_array_8_p_interact = 0;
#line 71 "MACS_sample_kidney_box.instr"
  if(0) strncpy(mccchannel_0_analyzer_2_array_crystal_array_8_mask_string, 0 ? 0 : "", 16384); else mccchannel_0_analyzer_2_array_crystal_array_8_mask_string[0]='\0';
#line 71 "MACS_sample_kidney_box.instr"
  if(0) strncpy(mccchannel_0_analyzer_2_array_crystal_array_8_mask_setting, 0 ? 0 : "", 16384); else mccchannel_0_analyzer_2_array_crystal_array_8_mask_setting[0]='\0';
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_0_analyzer_2_array_crystal_array_8_number_of_activations = 1;
#line 98019 "MACS_sample_kidney_box.c"

  SIG_MESSAGE("channel_0_analyzer_2_array_crystal_array_8 (Init:Place/Rotate)");
  rot_set_rotation(mctr1,
#line 613 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 613 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 613 "MACS_sample_kidney_box.instr"
    (0 - RAD2DEG * channel_0_analyzer_2_array_theta [ 8 ])*DEG2RAD);
#line 98029 "MACS_sample_kidney_box.c"
  rot_mul(mctr1, mcrotachannel_0_analyzer_2_rotated, mcrotachannel_0_analyzer_2_array_crystal_array_8);
  rot_transpose(mcrotachannel_0_analyzer_2_array_crystal_array_7, mctr1);
  rot_mul(mcrotachannel_0_analyzer_2_array_crystal_array_8, mctr1, mcrotrchannel_0_analyzer_2_array_crystal_array_8);
  mctc1 = coords_set(
#line 612 "MACS_sample_kidney_box.instr"
    0 + channel_0_analyzer_2_array_effective_radius_of_curvature * ( 1 - cos ( channel_0_analyzer_2_array_theta [ 8 ] ) ),
#line 612 "MACS_sample_kidney_box.instr"
    0 + channel_0_analyzer_2_array_effective_radius_of_curvature * sin ( channel_0_analyzer_2_array_theta [ 8 ] ),
#line 612 "MACS_sample_kidney_box.instr"
    0);
#line 98040 "MACS_sample_kidney_box.c"
  rot_transpose(mcrotachannel_0_analyzer_2_rotated, mctr1);
  mctc2 = rot_apply(mctr1, mctc1);
  mcposachannel_0_analyzer_2_array_crystal_array_8 = coords_add(mcposachannel_0_analyzer_2_rotated, mctc2);
  mctc1 = coords_sub(mcposachannel_0_analyzer_2_array_crystal_array_7, mcposachannel_0_analyzer_2_array_crystal_array_8);
  mcposrchannel_0_analyzer_2_array_crystal_array_8 = rot_apply(mcrotachannel_0_analyzer_2_array_crystal_array_8, mctc1);
  mcDEBUG_COMPONENT("channel_0_analyzer_2_array_crystal_array_8", mcposachannel_0_analyzer_2_array_crystal_array_8, mcrotachannel_0_analyzer_2_array_crystal_array_8)
  mccomp_posa[149] = mcposachannel_0_analyzer_2_array_crystal_array_8;
  mccomp_posr[149] = mcposrchannel_0_analyzer_2_array_crystal_array_8;
  mcNCounter[149]  = mcPCounter[149] = mcP2Counter[149] = 0;
  mcAbsorbProp[149]= 0;
    /* Component channel_0_cave2_cyl1. */
  /* Setting parameters for component channel_0_cave2_cyl1. */
  SIG_MESSAGE("channel_0_cave2_cyl1 (Init:SetPar)");
#line 618 "MACS_sample_kidney_box.instr"
  if("Vacuum") strncpy(mccchannel_0_cave2_cyl1_material_string, "Vacuum" ? "Vacuum" : "", 16384); else mccchannel_0_cave2_cyl1_material_string[0]='\0';
#line 618 "MACS_sample_kidney_box.instr"
  mccchannel_0_cave2_cyl1_priority = 207.5;
#line 617 "MACS_sample_kidney_box.instr"
  mccchannel_0_cave2_cyl1_radius = kidney_cave2_cyl1_radius;
#line 617 "MACS_sample_kidney_box.instr"
  mccchannel_0_cave2_cyl1_yheight = kidney_cave2_cyl1_height;
#line 67 "MACS_sample_kidney_box.instr"
  mccchannel_0_cave2_cyl1_visualize = 1;
#line 67 "MACS_sample_kidney_box.instr"
  mccchannel_0_cave2_cyl1_target_index = 0;
#line 67 "MACS_sample_kidney_box.instr"
  mccchannel_0_cave2_cyl1_target_x = 0;
#line 67 "MACS_sample_kidney_box.instr"
  mccchannel_0_cave2_cyl1_target_y = 0;
#line 67 "MACS_sample_kidney_box.instr"
  mccchannel_0_cave2_cyl1_target_z = 0;
#line 67 "MACS_sample_kidney_box.instr"
  mccchannel_0_cave2_cyl1_focus_aw = 0;
#line 67 "MACS_sample_kidney_box.instr"
  mccchannel_0_cave2_cyl1_focus_ah = 0;
#line 67 "MACS_sample_kidney_box.instr"
  mccchannel_0_cave2_cyl1_focus_xw = 0;
#line 67 "MACS_sample_kidney_box.instr"
  mccchannel_0_cave2_cyl1_focus_xh = 0;
#line 67 "MACS_sample_kidney_box.instr"
  mccchannel_0_cave2_cyl1_focus_r = 0;
#line 67 "MACS_sample_kidney_box.instr"
  mccchannel_0_cave2_cyl1_p_interact = 0;
#line 67 "MACS_sample_kidney_box.instr"
  if(0) strncpy(mccchannel_0_cave2_cyl1_mask_string, 0 ? 0 : "", 16384); else mccchannel_0_cave2_cyl1_mask_string[0]='\0';
#line 67 "MACS_sample_kidney_box.instr"
  if(0) strncpy(mccchannel_0_cave2_cyl1_mask_setting, 0 ? 0 : "", 16384); else mccchannel_0_cave2_cyl1_mask_setting[0]='\0';
#line 67 "MACS_sample_kidney_box.instr"
  mccchannel_0_cave2_cyl1_number_of_activations = 1;
#line 98090 "MACS_sample_kidney_box.c"

  SIG_MESSAGE("channel_0_cave2_cyl1 (Init:Place/Rotate)");
  rot_set_rotation(mctr1,
#line 620 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 620 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 620 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD);
#line 98100 "MACS_sample_kidney_box.c"
  rot_mul(mctr1, mcrotachannel_0_analyzer_2_center, mcrotachannel_0_cave2_cyl1);
  rot_transpose(mcrotachannel_0_analyzer_2_array_crystal_array_8, mctr1);
  rot_mul(mcrotachannel_0_cave2_cyl1, mctr1, mcrotrchannel_0_cave2_cyl1);
  mctc1 = coords_set(
#line 619 "MACS_sample_kidney_box.instr"
    0,
#line 619 "MACS_sample_kidney_box.instr"
    0,
#line 619 "MACS_sample_kidney_box.instr"
    spec_detector_to_analyzer_2_center);
#line 98111 "MACS_sample_kidney_box.c"
  rot_transpose(mcrotachannel_0_analyzer_2_center, mctr1);
  mctc2 = rot_apply(mctr1, mctc1);
  mcposachannel_0_cave2_cyl1 = coords_add(mcposachannel_0_analyzer_2_center, mctc2);
  mctc1 = coords_sub(mcposachannel_0_analyzer_2_array_crystal_array_8, mcposachannel_0_cave2_cyl1);
  mcposrchannel_0_cave2_cyl1 = rot_apply(mcrotachannel_0_cave2_cyl1, mctc1);
  mcDEBUG_COMPONENT("channel_0_cave2_cyl1", mcposachannel_0_cave2_cyl1, mcrotachannel_0_cave2_cyl1)
  mccomp_posa[150] = mcposachannel_0_cave2_cyl1;
  mccomp_posr[150] = mcposrchannel_0_cave2_cyl1;
  mcNCounter[150]  = mcPCounter[150] = mcP2Counter[150] = 0;
  mcAbsorbProp[150]= 0;
    /* Component channel_0_cave2_box1. */
  /* Setting parameters for component channel_0_cave2_box1. */
  SIG_MESSAGE("channel_0_cave2_box1 (Init:SetPar)");
#line 625 "MACS_sample_kidney_box.instr"
  if("Vacuum") strncpy(mccchannel_0_cave2_box1_material_string, "Vacuum" ? "Vacuum" : "", 16384); else mccchannel_0_cave2_box1_material_string[0]='\0';
#line 625 "MACS_sample_kidney_box.instr"
  mccchannel_0_cave2_box1_priority = 201;
#line 623 "MACS_sample_kidney_box.instr"
  mccchannel_0_cave2_box1_xwidth = kidney_cave2_box1_width1;
#line 623 "MACS_sample_kidney_box.instr"
  mccchannel_0_cave2_box1_yheight = kidney_cave2_box1_height1;
#line 623 "MACS_sample_kidney_box.instr"
  mccchannel_0_cave2_box1_zdepth = kidney_cave2_box1_depth;
#line 624 "MACS_sample_kidney_box.instr"
  mccchannel_0_cave2_box1_xwidth2 = kidney_cave2_box1_width2;
#line 624 "MACS_sample_kidney_box.instr"
  mccchannel_0_cave2_box1_yheight2 = kidney_cave2_box1_height2;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_0_cave2_box1_visualize = 1;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_0_cave2_box1_target_index = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_0_cave2_box1_target_x = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_0_cave2_box1_target_y = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_0_cave2_box1_target_z = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_0_cave2_box1_focus_aw = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_0_cave2_box1_focus_ah = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_0_cave2_box1_focus_xw = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_0_cave2_box1_focus_xh = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_0_cave2_box1_focus_r = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_0_cave2_box1_p_interact = 0;
#line 71 "MACS_sample_kidney_box.instr"
  if(0) strncpy(mccchannel_0_cave2_box1_mask_string, 0 ? 0 : "", 16384); else mccchannel_0_cave2_box1_mask_string[0]='\0';
#line 71 "MACS_sample_kidney_box.instr"
  if(0) strncpy(mccchannel_0_cave2_box1_mask_setting, 0 ? 0 : "", 16384); else mccchannel_0_cave2_box1_mask_setting[0]='\0';
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_0_cave2_box1_number_of_activations = 1;
#line 98167 "MACS_sample_kidney_box.c"

  SIG_MESSAGE("channel_0_cave2_box1 (Init:Place/Rotate)");
  rot_set_rotation(mctr1,
#line 627 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 627 "MACS_sample_kidney_box.instr"
    (kidney_cave2_box1_y_rotation)*DEG2RAD,
#line 627 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD);
#line 98177 "MACS_sample_kidney_box.c"
  rot_mul(mctr1, mcrotachannel_0_cave2_cyl1, mcrotachannel_0_cave2_box1);
  rot_transpose(mcrotachannel_0_cave2_cyl1, mctr1);
  rot_mul(mcrotachannel_0_cave2_box1, mctr1, mcrotrchannel_0_cave2_box1);
  mctc1 = coords_set(
#line 626 "MACS_sample_kidney_box.instr"
    kidney_cave2_box1_center_to_spec_detector_x,
#line 626 "MACS_sample_kidney_box.instr"
    0,
#line 626 "MACS_sample_kidney_box.instr"
    kidney_cave2_box1_center_to_spec_detector_z);
#line 98188 "MACS_sample_kidney_box.c"
  rot_transpose(mcrotachannel_0_cave2_cyl1, mctr1);
  mctc2 = rot_apply(mctr1, mctc1);
  mcposachannel_0_cave2_box1 = coords_add(mcposachannel_0_cave2_cyl1, mctc2);
  mctc1 = coords_sub(mcposachannel_0_cave2_cyl1, mcposachannel_0_cave2_box1);
  mcposrchannel_0_cave2_box1 = rot_apply(mcrotachannel_0_cave2_box1, mctc1);
  mcDEBUG_COMPONENT("channel_0_cave2_box1", mcposachannel_0_cave2_box1, mcrotachannel_0_cave2_box1)
  mccomp_posa[151] = mcposachannel_0_cave2_box1;
  mccomp_posr[151] = mcposrchannel_0_cave2_box1;
  mcNCounter[151]  = mcPCounter[151] = mcP2Counter[151] = 0;
  mcAbsorbProp[151]= 0;
    /* Component channel_0_cave2_box2. */
  /* Setting parameters for component channel_0_cave2_box2. */
  SIG_MESSAGE("channel_0_cave2_box2 (Init:SetPar)");
#line 632 "MACS_sample_kidney_box.instr"
  if("Vacuum") strncpy(mccchannel_0_cave2_box2_material_string, "Vacuum" ? "Vacuum" : "", 16384); else mccchannel_0_cave2_box2_material_string[0]='\0';
#line 632 "MACS_sample_kidney_box.instr"
  mccchannel_0_cave2_box2_priority = 206;
#line 630 "MACS_sample_kidney_box.instr"
  mccchannel_0_cave2_box2_xwidth = kidney_cave2_box2_width1;
#line 630 "MACS_sample_kidney_box.instr"
  mccchannel_0_cave2_box2_yheight = kidney_cave2_box2_height1;
#line 630 "MACS_sample_kidney_box.instr"
  mccchannel_0_cave2_box2_zdepth = kidney_cave2_box2_depth;
#line 631 "MACS_sample_kidney_box.instr"
  mccchannel_0_cave2_box2_xwidth2 = kidney_cave2_box2_width2;
#line 631 "MACS_sample_kidney_box.instr"
  mccchannel_0_cave2_box2_yheight2 = kidney_cave2_box2_height2;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_0_cave2_box2_visualize = 1;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_0_cave2_box2_target_index = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_0_cave2_box2_target_x = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_0_cave2_box2_target_y = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_0_cave2_box2_target_z = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_0_cave2_box2_focus_aw = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_0_cave2_box2_focus_ah = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_0_cave2_box2_focus_xw = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_0_cave2_box2_focus_xh = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_0_cave2_box2_focus_r = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_0_cave2_box2_p_interact = 0;
#line 71 "MACS_sample_kidney_box.instr"
  if(0) strncpy(mccchannel_0_cave2_box2_mask_string, 0 ? 0 : "", 16384); else mccchannel_0_cave2_box2_mask_string[0]='\0';
#line 71 "MACS_sample_kidney_box.instr"
  if(0) strncpy(mccchannel_0_cave2_box2_mask_setting, 0 ? 0 : "", 16384); else mccchannel_0_cave2_box2_mask_setting[0]='\0';
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_0_cave2_box2_number_of_activations = 1;
#line 98244 "MACS_sample_kidney_box.c"

  SIG_MESSAGE("channel_0_cave2_box2 (Init:Place/Rotate)");
  rot_set_rotation(mctr1,
#line 634 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 634 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 634 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD);
#line 98254 "MACS_sample_kidney_box.c"
  rot_mul(mctr1, mcrotachannel_0_cave2_cyl1, mcrotachannel_0_cave2_box2);
  rot_transpose(mcrotachannel_0_cave2_box1, mctr1);
  rot_mul(mcrotachannel_0_cave2_box2, mctr1, mcrotrchannel_0_cave2_box2);
  mctc1 = coords_set(
#line 633 "MACS_sample_kidney_box.instr"
    0,
#line 633 "MACS_sample_kidney_box.instr"
    0,
#line 633 "MACS_sample_kidney_box.instr"
    kidney_cave2_box2_center_to_detector);
#line 98265 "MACS_sample_kidney_box.c"
  rot_transpose(mcrotachannel_0_cave2_cyl1, mctr1);
  mctc2 = rot_apply(mctr1, mctc1);
  mcposachannel_0_cave2_box2 = coords_add(mcposachannel_0_cave2_cyl1, mctc2);
  mctc1 = coords_sub(mcposachannel_0_cave2_box1, mcposachannel_0_cave2_box2);
  mcposrchannel_0_cave2_box2 = rot_apply(mcrotachannel_0_cave2_box2, mctc1);
  mcDEBUG_COMPONENT("channel_0_cave2_box2", mcposachannel_0_cave2_box2, mcrotachannel_0_cave2_box2)
  mccomp_posa[152] = mcposachannel_0_cave2_box2;
  mccomp_posr[152] = mcposrchannel_0_cave2_box2;
  mcNCounter[152]  = mcPCounter[152] = mcP2Counter[152] = 0;
  mcAbsorbProp[152]= 0;
    /* Component channel_0_cave2_box3. */
  /* Setting parameters for component channel_0_cave2_box3. */
  SIG_MESSAGE("channel_0_cave2_box3 (Init:SetPar)");
#line 639 "MACS_sample_kidney_box.instr"
  if("Vacuum") strncpy(mccchannel_0_cave2_box3_material_string, "Vacuum" ? "Vacuum" : "", 16384); else mccchannel_0_cave2_box3_material_string[0]='\0';
#line 639 "MACS_sample_kidney_box.instr"
  mccchannel_0_cave2_box3_priority = 207;
#line 637 "MACS_sample_kidney_box.instr"
  mccchannel_0_cave2_box3_xwidth = kidney_cave2_box3_width1;
#line 637 "MACS_sample_kidney_box.instr"
  mccchannel_0_cave2_box3_yheight = kidney_cave2_box3_height1;
#line 637 "MACS_sample_kidney_box.instr"
  mccchannel_0_cave2_box3_zdepth = kidney_cave2_box3_depth;
#line 638 "MACS_sample_kidney_box.instr"
  mccchannel_0_cave2_box3_xwidth2 = kidney_cave2_box3_width2;
#line 638 "MACS_sample_kidney_box.instr"
  mccchannel_0_cave2_box3_yheight2 = kidney_cave2_box3_height2;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_0_cave2_box3_visualize = 1;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_0_cave2_box3_target_index = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_0_cave2_box3_target_x = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_0_cave2_box3_target_y = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_0_cave2_box3_target_z = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_0_cave2_box3_focus_aw = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_0_cave2_box3_focus_ah = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_0_cave2_box3_focus_xw = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_0_cave2_box3_focus_xh = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_0_cave2_box3_focus_r = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_0_cave2_box3_p_interact = 0;
#line 71 "MACS_sample_kidney_box.instr"
  if(0) strncpy(mccchannel_0_cave2_box3_mask_string, 0 ? 0 : "", 16384); else mccchannel_0_cave2_box3_mask_string[0]='\0';
#line 71 "MACS_sample_kidney_box.instr"
  if(0) strncpy(mccchannel_0_cave2_box3_mask_setting, 0 ? 0 : "", 16384); else mccchannel_0_cave2_box3_mask_setting[0]='\0';
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_0_cave2_box3_number_of_activations = 1;
#line 98321 "MACS_sample_kidney_box.c"

  SIG_MESSAGE("channel_0_cave2_box3 (Init:Place/Rotate)");
  rot_set_rotation(mctr1,
#line 641 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 641 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 641 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD);
#line 98331 "MACS_sample_kidney_box.c"
  rot_mul(mctr1, mcrotachannel_0_cave2_cyl1, mcrotachannel_0_cave2_box3);
  rot_transpose(mcrotachannel_0_cave2_box2, mctr1);
  rot_mul(mcrotachannel_0_cave2_box3, mctr1, mcrotrchannel_0_cave2_box3);
  mctc1 = coords_set(
#line 640 "MACS_sample_kidney_box.instr"
    0,
#line 640 "MACS_sample_kidney_box.instr"
    0,
#line 640 "MACS_sample_kidney_box.instr"
    kidney_cave2_box3_center_to_detector);
#line 98342 "MACS_sample_kidney_box.c"
  rot_transpose(mcrotachannel_0_cave2_cyl1, mctr1);
  mctc2 = rot_apply(mctr1, mctc1);
  mcposachannel_0_cave2_box3 = coords_add(mcposachannel_0_cave2_cyl1, mctc2);
  mctc1 = coords_sub(mcposachannel_0_cave2_box2, mcposachannel_0_cave2_box3);
  mcposrchannel_0_cave2_box3 = rot_apply(mcrotachannel_0_cave2_box3, mctc1);
  mcDEBUG_COMPONENT("channel_0_cave2_box3", mcposachannel_0_cave2_box3, mcrotachannel_0_cave2_box3)
  mccomp_posa[153] = mcposachannel_0_cave2_box3;
  mccomp_posr[153] = mcposrchannel_0_cave2_box3;
  mcNCounter[153]  = mcPCounter[153] = mcP2Counter[153] = 0;
  mcAbsorbProp[153]= 0;
    /* Component inter_analyzer_colimator_center_0. */
  /* Setting parameters for component inter_analyzer_colimator_center_0. */
  SIG_MESSAGE("inter_analyzer_colimator_center_0 (Init:SetPar)");

  SIG_MESSAGE("inter_analyzer_colimator_center_0 (Init:Place/Rotate)");
  rot_set_rotation(mctr1,
#line 645 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 645 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 645 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD);
#line 98365 "MACS_sample_kidney_box.c"
  rot_mul(mctr1, mcrotachannel_0_analyzer_1_center, mcrotainter_analyzer_colimator_center_0);
  rot_transpose(mcrotachannel_0_cave2_box3, mctr1);
  rot_mul(mcrotainter_analyzer_colimator_center_0, mctr1, mcrotrinter_analyzer_colimator_center_0);
  mctc1 = coords_set(
#line 644 "MACS_sample_kidney_box.instr"
    -0.5 * analyzer_seperation,
#line 644 "MACS_sample_kidney_box.instr"
    0,
#line 644 "MACS_sample_kidney_box.instr"
    0);
#line 98376 "MACS_sample_kidney_box.c"
  rot_transpose(mcrotachannel_0_analyzer_1_center, mctr1);
  mctc2 = rot_apply(mctr1, mctc1);
  mcposainter_analyzer_colimator_center_0 = coords_add(mcposachannel_0_analyzer_1_center, mctc2);
  mctc1 = coords_sub(mcposachannel_0_cave2_box3, mcposainter_analyzer_colimator_center_0);
  mcposrinter_analyzer_colimator_center_0 = rot_apply(mcrotainter_analyzer_colimator_center_0, mctc1);
  mcDEBUG_COMPONENT("inter_analyzer_colimator_center_0", mcposainter_analyzer_colimator_center_0, mcrotainter_analyzer_colimator_center_0)
  mccomp_posa[154] = mcposainter_analyzer_colimator_center_0;
  mccomp_posr[154] = mcposrinter_analyzer_colimator_center_0;
  mcNCounter[154]  = mcPCounter[154] = mcP2Counter[154] = 0;
  mcAbsorbProp[154]= 0;
    /* Component inter_analyzer_colimator_0_blade_0. */
  /* Setting parameters for component inter_analyzer_colimator_0_blade_0. */
  SIG_MESSAGE("inter_analyzer_colimator_0_blade_0 (Init:SetPar)");
#line 649 "MACS_sample_kidney_box.instr"
  if("Collimator_gad") strncpy(mccinter_analyzer_colimator_0_blade_0_material_string, "Collimator_gad" ? "Collimator_gad" : "", 16384); else mccinter_analyzer_colimator_0_blade_0_material_string[0]='\0';
#line 649 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_0_blade_0_priority = 225;
#line 648 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_0_blade_0_xwidth = inter_analyzer_colimator_width;
#line 648 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_0_blade_0_yheight = inter_analyzer_colimator_height;
#line 648 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_0_blade_0_zdepth = inter_analyzer_colimator_depth;
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_0_blade_0_xwidth2 = -1;
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_0_blade_0_yheight2 = -1;
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_0_blade_0_visualize = 1;
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_0_blade_0_target_index = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_0_blade_0_target_x = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_0_blade_0_target_y = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_0_blade_0_target_z = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_0_blade_0_focus_aw = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_0_blade_0_focus_ah = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_0_blade_0_focus_xw = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_0_blade_0_focus_xh = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_0_blade_0_focus_r = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_0_blade_0_p_interact = 0;
#line 71 "MACS_sample_kidney_box.instr"
  if(0) strncpy(mccinter_analyzer_colimator_0_blade_0_mask_string, 0 ? 0 : "", 16384); else mccinter_analyzer_colimator_0_blade_0_mask_string[0]='\0';
#line 71 "MACS_sample_kidney_box.instr"
  if(0) strncpy(mccinter_analyzer_colimator_0_blade_0_mask_setting, 0 ? 0 : "", 16384); else mccinter_analyzer_colimator_0_blade_0_mask_setting[0]='\0';
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_0_blade_0_number_of_activations = 1;
#line 98432 "MACS_sample_kidney_box.c"

  SIG_MESSAGE("inter_analyzer_colimator_0_blade_0 (Init:Place/Rotate)");
  rot_set_rotation(mctr1,
#line 651 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 651 "MACS_sample_kidney_box.instr"
    (- analyzer_2theta [ 0 ])*DEG2RAD,
#line 651 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD);
#line 98442 "MACS_sample_kidney_box.c"
  rot_mul(mctr1, mcrotainter_analyzer_colimator_center_0, mcrotainter_analyzer_colimator_0_blade_0);
  rot_transpose(mcrotainter_analyzer_colimator_center_0, mctr1);
  rot_mul(mcrotainter_analyzer_colimator_0_blade_0, mctr1, mcrotrinter_analyzer_colimator_0_blade_0);
  mctc1 = coords_set(
#line 650 "MACS_sample_kidney_box.instr"
    0,
#line 650 "MACS_sample_kidney_box.instr"
    0,
#line 650 "MACS_sample_kidney_box.instr"
    inter_analyzer_colimator_start_pos - 0 * inter_analyzer_colimator_seperation);
#line 98453 "MACS_sample_kidney_box.c"
  rot_transpose(mcrotainter_analyzer_colimator_center_0, mctr1);
  mctc2 = rot_apply(mctr1, mctc1);
  mcposainter_analyzer_colimator_0_blade_0 = coords_add(mcposainter_analyzer_colimator_center_0, mctc2);
  mctc1 = coords_sub(mcposainter_analyzer_colimator_center_0, mcposainter_analyzer_colimator_0_blade_0);
  mcposrinter_analyzer_colimator_0_blade_0 = rot_apply(mcrotainter_analyzer_colimator_0_blade_0, mctc1);
  mcDEBUG_COMPONENT("inter_analyzer_colimator_0_blade_0", mcposainter_analyzer_colimator_0_blade_0, mcrotainter_analyzer_colimator_0_blade_0)
  mccomp_posa[155] = mcposainter_analyzer_colimator_0_blade_0;
  mccomp_posr[155] = mcposrinter_analyzer_colimator_0_blade_0;
  mcNCounter[155]  = mcPCounter[155] = mcP2Counter[155] = 0;
  mcAbsorbProp[155]= 0;
    /* Component inter_analyzer_colimator_0_blade_1. */
  /* Setting parameters for component inter_analyzer_colimator_0_blade_1. */
  SIG_MESSAGE("inter_analyzer_colimator_0_blade_1 (Init:SetPar)");
#line 655 "MACS_sample_kidney_box.instr"
  if("Collimator_gad") strncpy(mccinter_analyzer_colimator_0_blade_1_material_string, "Collimator_gad" ? "Collimator_gad" : "", 16384); else mccinter_analyzer_colimator_0_blade_1_material_string[0]='\0';
#line 655 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_0_blade_1_priority = 226;
#line 654 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_0_blade_1_xwidth = inter_analyzer_colimator_width;
#line 654 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_0_blade_1_yheight = inter_analyzer_colimator_height;
#line 654 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_0_blade_1_zdepth = inter_analyzer_colimator_depth;
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_0_blade_1_xwidth2 = -1;
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_0_blade_1_yheight2 = -1;
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_0_blade_1_visualize = 1;
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_0_blade_1_target_index = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_0_blade_1_target_x = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_0_blade_1_target_y = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_0_blade_1_target_z = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_0_blade_1_focus_aw = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_0_blade_1_focus_ah = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_0_blade_1_focus_xw = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_0_blade_1_focus_xh = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_0_blade_1_focus_r = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_0_blade_1_p_interact = 0;
#line 71 "MACS_sample_kidney_box.instr"
  if(0) strncpy(mccinter_analyzer_colimator_0_blade_1_mask_string, 0 ? 0 : "", 16384); else mccinter_analyzer_colimator_0_blade_1_mask_string[0]='\0';
#line 71 "MACS_sample_kidney_box.instr"
  if(0) strncpy(mccinter_analyzer_colimator_0_blade_1_mask_setting, 0 ? 0 : "", 16384); else mccinter_analyzer_colimator_0_blade_1_mask_setting[0]='\0';
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_0_blade_1_number_of_activations = 1;
#line 98509 "MACS_sample_kidney_box.c"

  SIG_MESSAGE("inter_analyzer_colimator_0_blade_1 (Init:Place/Rotate)");
  rot_set_rotation(mctr1,
#line 657 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 657 "MACS_sample_kidney_box.instr"
    (- analyzer_2theta [ 0 ])*DEG2RAD,
#line 657 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD);
#line 98519 "MACS_sample_kidney_box.c"
  rot_mul(mctr1, mcrotainter_analyzer_colimator_center_0, mcrotainter_analyzer_colimator_0_blade_1);
  rot_transpose(mcrotainter_analyzer_colimator_0_blade_0, mctr1);
  rot_mul(mcrotainter_analyzer_colimator_0_blade_1, mctr1, mcrotrinter_analyzer_colimator_0_blade_1);
  mctc1 = coords_set(
#line 656 "MACS_sample_kidney_box.instr"
    0,
#line 656 "MACS_sample_kidney_box.instr"
    0,
#line 656 "MACS_sample_kidney_box.instr"
    inter_analyzer_colimator_start_pos - 1 * inter_analyzer_colimator_seperation);
#line 98530 "MACS_sample_kidney_box.c"
  rot_transpose(mcrotainter_analyzer_colimator_center_0, mctr1);
  mctc2 = rot_apply(mctr1, mctc1);
  mcposainter_analyzer_colimator_0_blade_1 = coords_add(mcposainter_analyzer_colimator_center_0, mctc2);
  mctc1 = coords_sub(mcposainter_analyzer_colimator_0_blade_0, mcposainter_analyzer_colimator_0_blade_1);
  mcposrinter_analyzer_colimator_0_blade_1 = rot_apply(mcrotainter_analyzer_colimator_0_blade_1, mctc1);
  mcDEBUG_COMPONENT("inter_analyzer_colimator_0_blade_1", mcposainter_analyzer_colimator_0_blade_1, mcrotainter_analyzer_colimator_0_blade_1)
  mccomp_posa[156] = mcposainter_analyzer_colimator_0_blade_1;
  mccomp_posr[156] = mcposrinter_analyzer_colimator_0_blade_1;
  mcNCounter[156]  = mcPCounter[156] = mcP2Counter[156] = 0;
  mcAbsorbProp[156]= 0;
    /* Component inter_analyzer_colimator_0_blade_2. */
  /* Setting parameters for component inter_analyzer_colimator_0_blade_2. */
  SIG_MESSAGE("inter_analyzer_colimator_0_blade_2 (Init:SetPar)");
#line 661 "MACS_sample_kidney_box.instr"
  if("Collimator_gad") strncpy(mccinter_analyzer_colimator_0_blade_2_material_string, "Collimator_gad" ? "Collimator_gad" : "", 16384); else mccinter_analyzer_colimator_0_blade_2_material_string[0]='\0';
#line 661 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_0_blade_2_priority = 227;
#line 660 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_0_blade_2_xwidth = inter_analyzer_colimator_width;
#line 660 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_0_blade_2_yheight = inter_analyzer_colimator_height;
#line 660 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_0_blade_2_zdepth = inter_analyzer_colimator_depth;
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_0_blade_2_xwidth2 = -1;
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_0_blade_2_yheight2 = -1;
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_0_blade_2_visualize = 1;
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_0_blade_2_target_index = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_0_blade_2_target_x = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_0_blade_2_target_y = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_0_blade_2_target_z = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_0_blade_2_focus_aw = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_0_blade_2_focus_ah = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_0_blade_2_focus_xw = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_0_blade_2_focus_xh = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_0_blade_2_focus_r = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_0_blade_2_p_interact = 0;
#line 71 "MACS_sample_kidney_box.instr"
  if(0) strncpy(mccinter_analyzer_colimator_0_blade_2_mask_string, 0 ? 0 : "", 16384); else mccinter_analyzer_colimator_0_blade_2_mask_string[0]='\0';
#line 71 "MACS_sample_kidney_box.instr"
  if(0) strncpy(mccinter_analyzer_colimator_0_blade_2_mask_setting, 0 ? 0 : "", 16384); else mccinter_analyzer_colimator_0_blade_2_mask_setting[0]='\0';
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_0_blade_2_number_of_activations = 1;
#line 98586 "MACS_sample_kidney_box.c"

  SIG_MESSAGE("inter_analyzer_colimator_0_blade_2 (Init:Place/Rotate)");
  rot_set_rotation(mctr1,
#line 663 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 663 "MACS_sample_kidney_box.instr"
    (- analyzer_2theta [ 0 ])*DEG2RAD,
#line 663 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD);
#line 98596 "MACS_sample_kidney_box.c"
  rot_mul(mctr1, mcrotainter_analyzer_colimator_center_0, mcrotainter_analyzer_colimator_0_blade_2);
  rot_transpose(mcrotainter_analyzer_colimator_0_blade_1, mctr1);
  rot_mul(mcrotainter_analyzer_colimator_0_blade_2, mctr1, mcrotrinter_analyzer_colimator_0_blade_2);
  mctc1 = coords_set(
#line 662 "MACS_sample_kidney_box.instr"
    0,
#line 662 "MACS_sample_kidney_box.instr"
    0,
#line 662 "MACS_sample_kidney_box.instr"
    inter_analyzer_colimator_start_pos - 2 * inter_analyzer_colimator_seperation);
#line 98607 "MACS_sample_kidney_box.c"
  rot_transpose(mcrotainter_analyzer_colimator_center_0, mctr1);
  mctc2 = rot_apply(mctr1, mctc1);
  mcposainter_analyzer_colimator_0_blade_2 = coords_add(mcposainter_analyzer_colimator_center_0, mctc2);
  mctc1 = coords_sub(mcposainter_analyzer_colimator_0_blade_1, mcposainter_analyzer_colimator_0_blade_2);
  mcposrinter_analyzer_colimator_0_blade_2 = rot_apply(mcrotainter_analyzer_colimator_0_blade_2, mctc1);
  mcDEBUG_COMPONENT("inter_analyzer_colimator_0_blade_2", mcposainter_analyzer_colimator_0_blade_2, mcrotainter_analyzer_colimator_0_blade_2)
  mccomp_posa[157] = mcposainter_analyzer_colimator_0_blade_2;
  mccomp_posr[157] = mcposrinter_analyzer_colimator_0_blade_2;
  mcNCounter[157]  = mcPCounter[157] = mcP2Counter[157] = 0;
  mcAbsorbProp[157]= 0;
    /* Component inter_analyzer_colimator_0_blade_3. */
  /* Setting parameters for component inter_analyzer_colimator_0_blade_3. */
  SIG_MESSAGE("inter_analyzer_colimator_0_blade_3 (Init:SetPar)");
#line 667 "MACS_sample_kidney_box.instr"
  if("Collimator_gad") strncpy(mccinter_analyzer_colimator_0_blade_3_material_string, "Collimator_gad" ? "Collimator_gad" : "", 16384); else mccinter_analyzer_colimator_0_blade_3_material_string[0]='\0';
#line 667 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_0_blade_3_priority = 228;
#line 666 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_0_blade_3_xwidth = inter_analyzer_colimator_width;
#line 666 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_0_blade_3_yheight = inter_analyzer_colimator_height;
#line 666 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_0_blade_3_zdepth = inter_analyzer_colimator_depth;
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_0_blade_3_xwidth2 = -1;
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_0_blade_3_yheight2 = -1;
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_0_blade_3_visualize = 1;
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_0_blade_3_target_index = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_0_blade_3_target_x = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_0_blade_3_target_y = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_0_blade_3_target_z = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_0_blade_3_focus_aw = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_0_blade_3_focus_ah = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_0_blade_3_focus_xw = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_0_blade_3_focus_xh = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_0_blade_3_focus_r = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_0_blade_3_p_interact = 0;
#line 71 "MACS_sample_kidney_box.instr"
  if(0) strncpy(mccinter_analyzer_colimator_0_blade_3_mask_string, 0 ? 0 : "", 16384); else mccinter_analyzer_colimator_0_blade_3_mask_string[0]='\0';
#line 71 "MACS_sample_kidney_box.instr"
  if(0) strncpy(mccinter_analyzer_colimator_0_blade_3_mask_setting, 0 ? 0 : "", 16384); else mccinter_analyzer_colimator_0_blade_3_mask_setting[0]='\0';
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_0_blade_3_number_of_activations = 1;
#line 98663 "MACS_sample_kidney_box.c"

  SIG_MESSAGE("inter_analyzer_colimator_0_blade_3 (Init:Place/Rotate)");
  rot_set_rotation(mctr1,
#line 669 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 669 "MACS_sample_kidney_box.instr"
    (- analyzer_2theta [ 0 ])*DEG2RAD,
#line 669 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD);
#line 98673 "MACS_sample_kidney_box.c"
  rot_mul(mctr1, mcrotainter_analyzer_colimator_center_0, mcrotainter_analyzer_colimator_0_blade_3);
  rot_transpose(mcrotainter_analyzer_colimator_0_blade_2, mctr1);
  rot_mul(mcrotainter_analyzer_colimator_0_blade_3, mctr1, mcrotrinter_analyzer_colimator_0_blade_3);
  mctc1 = coords_set(
#line 668 "MACS_sample_kidney_box.instr"
    0,
#line 668 "MACS_sample_kidney_box.instr"
    0,
#line 668 "MACS_sample_kidney_box.instr"
    inter_analyzer_colimator_start_pos - 3 * inter_analyzer_colimator_seperation);
#line 98684 "MACS_sample_kidney_box.c"
  rot_transpose(mcrotainter_analyzer_colimator_center_0, mctr1);
  mctc2 = rot_apply(mctr1, mctc1);
  mcposainter_analyzer_colimator_0_blade_3 = coords_add(mcposainter_analyzer_colimator_center_0, mctc2);
  mctc1 = coords_sub(mcposainter_analyzer_colimator_0_blade_2, mcposainter_analyzer_colimator_0_blade_3);
  mcposrinter_analyzer_colimator_0_blade_3 = rot_apply(mcrotainter_analyzer_colimator_0_blade_3, mctc1);
  mcDEBUG_COMPONENT("inter_analyzer_colimator_0_blade_3", mcposainter_analyzer_colimator_0_blade_3, mcrotainter_analyzer_colimator_0_blade_3)
  mccomp_posa[158] = mcposainter_analyzer_colimator_0_blade_3;
  mccomp_posr[158] = mcposrinter_analyzer_colimator_0_blade_3;
  mcNCounter[158]  = mcPCounter[158] = mcP2Counter[158] = 0;
  mcAbsorbProp[158]= 0;
    /* Component inter_analyzer_colimator_0_blade_4. */
  /* Setting parameters for component inter_analyzer_colimator_0_blade_4. */
  SIG_MESSAGE("inter_analyzer_colimator_0_blade_4 (Init:SetPar)");
#line 673 "MACS_sample_kidney_box.instr"
  if("Collimator_gad") strncpy(mccinter_analyzer_colimator_0_blade_4_material_string, "Collimator_gad" ? "Collimator_gad" : "", 16384); else mccinter_analyzer_colimator_0_blade_4_material_string[0]='\0';
#line 673 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_0_blade_4_priority = 229;
#line 672 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_0_blade_4_xwidth = inter_analyzer_colimator_width;
#line 672 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_0_blade_4_yheight = inter_analyzer_colimator_height;
#line 672 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_0_blade_4_zdepth = inter_analyzer_colimator_depth;
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_0_blade_4_xwidth2 = -1;
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_0_blade_4_yheight2 = -1;
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_0_blade_4_visualize = 1;
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_0_blade_4_target_index = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_0_blade_4_target_x = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_0_blade_4_target_y = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_0_blade_4_target_z = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_0_blade_4_focus_aw = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_0_blade_4_focus_ah = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_0_blade_4_focus_xw = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_0_blade_4_focus_xh = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_0_blade_4_focus_r = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_0_blade_4_p_interact = 0;
#line 71 "MACS_sample_kidney_box.instr"
  if(0) strncpy(mccinter_analyzer_colimator_0_blade_4_mask_string, 0 ? 0 : "", 16384); else mccinter_analyzer_colimator_0_blade_4_mask_string[0]='\0';
#line 71 "MACS_sample_kidney_box.instr"
  if(0) strncpy(mccinter_analyzer_colimator_0_blade_4_mask_setting, 0 ? 0 : "", 16384); else mccinter_analyzer_colimator_0_blade_4_mask_setting[0]='\0';
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_0_blade_4_number_of_activations = 1;
#line 98740 "MACS_sample_kidney_box.c"

  SIG_MESSAGE("inter_analyzer_colimator_0_blade_4 (Init:Place/Rotate)");
  rot_set_rotation(mctr1,
#line 675 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 675 "MACS_sample_kidney_box.instr"
    (- analyzer_2theta [ 0 ])*DEG2RAD,
#line 675 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD);
#line 98750 "MACS_sample_kidney_box.c"
  rot_mul(mctr1, mcrotainter_analyzer_colimator_center_0, mcrotainter_analyzer_colimator_0_blade_4);
  rot_transpose(mcrotainter_analyzer_colimator_0_blade_3, mctr1);
  rot_mul(mcrotainter_analyzer_colimator_0_blade_4, mctr1, mcrotrinter_analyzer_colimator_0_blade_4);
  mctc1 = coords_set(
#line 674 "MACS_sample_kidney_box.instr"
    0,
#line 674 "MACS_sample_kidney_box.instr"
    0,
#line 674 "MACS_sample_kidney_box.instr"
    inter_analyzer_colimator_start_pos - 4 * inter_analyzer_colimator_seperation);
#line 98761 "MACS_sample_kidney_box.c"
  rot_transpose(mcrotainter_analyzer_colimator_center_0, mctr1);
  mctc2 = rot_apply(mctr1, mctc1);
  mcposainter_analyzer_colimator_0_blade_4 = coords_add(mcposainter_analyzer_colimator_center_0, mctc2);
  mctc1 = coords_sub(mcposainter_analyzer_colimator_0_blade_3, mcposainter_analyzer_colimator_0_blade_4);
  mcposrinter_analyzer_colimator_0_blade_4 = rot_apply(mcrotainter_analyzer_colimator_0_blade_4, mctc1);
  mcDEBUG_COMPONENT("inter_analyzer_colimator_0_blade_4", mcposainter_analyzer_colimator_0_blade_4, mcrotainter_analyzer_colimator_0_blade_4)
  mccomp_posa[159] = mcposainter_analyzer_colimator_0_blade_4;
  mccomp_posr[159] = mcposrinter_analyzer_colimator_0_blade_4;
  mcNCounter[159]  = mcPCounter[159] = mcP2Counter[159] = 0;
  mcAbsorbProp[159]= 0;
    /* Component diffraction_detector_0_exit_volume. */
  /* Setting parameters for component diffraction_detector_0_exit_volume. */
  SIG_MESSAGE("diffraction_detector_0_exit_volume (Init:SetPar)");
#line 679 "MACS_sample_kidney_box.instr"
  if("Exit") strncpy(mccdiffraction_detector_0_exit_volume_material_string, "Exit" ? "Exit" : "", 16384); else mccdiffraction_detector_0_exit_volume_material_string[0]='\0';
#line 679 "MACS_sample_kidney_box.instr"
  mccdiffraction_detector_0_exit_volume_priority = 231;
#line 678 "MACS_sample_kidney_box.instr"
  mccdiffraction_detector_0_exit_volume_xwidth = 2.01 * detector_radius;
#line 678 "MACS_sample_kidney_box.instr"
  mccdiffraction_detector_0_exit_volume_yheight = 1.01 * detector_height;
#line 678 "MACS_sample_kidney_box.instr"
  mccdiffraction_detector_0_exit_volume_zdepth = 0.001;
#line 71 "MACS_sample_kidney_box.instr"
  mccdiffraction_detector_0_exit_volume_xwidth2 = -1;
#line 71 "MACS_sample_kidney_box.instr"
  mccdiffraction_detector_0_exit_volume_yheight2 = -1;
#line 71 "MACS_sample_kidney_box.instr"
  mccdiffraction_detector_0_exit_volume_visualize = 1;
#line 71 "MACS_sample_kidney_box.instr"
  mccdiffraction_detector_0_exit_volume_target_index = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccdiffraction_detector_0_exit_volume_target_x = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccdiffraction_detector_0_exit_volume_target_y = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccdiffraction_detector_0_exit_volume_target_z = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccdiffraction_detector_0_exit_volume_focus_aw = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccdiffraction_detector_0_exit_volume_focus_ah = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccdiffraction_detector_0_exit_volume_focus_xw = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccdiffraction_detector_0_exit_volume_focus_xh = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccdiffraction_detector_0_exit_volume_focus_r = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccdiffraction_detector_0_exit_volume_p_interact = 0;
#line 71 "MACS_sample_kidney_box.instr"
  if(0) strncpy(mccdiffraction_detector_0_exit_volume_mask_string, 0 ? 0 : "", 16384); else mccdiffraction_detector_0_exit_volume_mask_string[0]='\0';
#line 71 "MACS_sample_kidney_box.instr"
  if(0) strncpy(mccdiffraction_detector_0_exit_volume_mask_setting, 0 ? 0 : "", 16384); else mccdiffraction_detector_0_exit_volume_mask_setting[0]='\0';
#line 71 "MACS_sample_kidney_box.instr"
  mccdiffraction_detector_0_exit_volume_number_of_activations = 1;
#line 98817 "MACS_sample_kidney_box.c"

  SIG_MESSAGE("diffraction_detector_0_exit_volume (Init:Place/Rotate)");
  rot_set_rotation(mctr1,
#line 681 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 681 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 681 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD);
#line 98827 "MACS_sample_kidney_box.c"
  rot_mul(mctr1, mcrotakidney_channel_0, mcrotadiffraction_detector_0_exit_volume);
  rot_transpose(mcrotainter_analyzer_colimator_0_blade_4, mctr1);
  rot_mul(mcrotadiffraction_detector_0_exit_volume, mctr1, mcrotrdiffraction_detector_0_exit_volume);
  mctc1 = coords_set(
#line 680 "MACS_sample_kidney_box.instr"
    0,
#line 680 "MACS_sample_kidney_box.instr"
    0,
#line 680 "MACS_sample_kidney_box.instr"
    0);
#line 98838 "MACS_sample_kidney_box.c"
  rot_transpose(mcrotachannel_0_cave1_cyl1, mctr1);
  mctc2 = rot_apply(mctr1, mctc1);
  mcposadiffraction_detector_0_exit_volume = coords_add(mcposachannel_0_cave1_cyl1, mctc2);
  mctc1 = coords_sub(mcposainter_analyzer_colimator_0_blade_4, mcposadiffraction_detector_0_exit_volume);
  mcposrdiffraction_detector_0_exit_volume = rot_apply(mcrotadiffraction_detector_0_exit_volume, mctc1);
  mcDEBUG_COMPONENT("diffraction_detector_0_exit_volume", mcposadiffraction_detector_0_exit_volume, mcrotadiffraction_detector_0_exit_volume)
  mccomp_posa[160] = mcposadiffraction_detector_0_exit_volume;
  mccomp_posr[160] = mcposrdiffraction_detector_0_exit_volume;
  mcNCounter[160]  = mcPCounter[160] = mcP2Counter[160] = 0;
  mcAbsorbProp[160]= 0;
    /* Component spec_detector_0_exit_volume. */
  /* Setting parameters for component spec_detector_0_exit_volume. */
  SIG_MESSAGE("spec_detector_0_exit_volume (Init:SetPar)");
#line 685 "MACS_sample_kidney_box.instr"
  if("Exit") strncpy(mccspec_detector_0_exit_volume_material_string, "Exit" ? "Exit" : "", 16384); else mccspec_detector_0_exit_volume_material_string[0]='\0';
#line 685 "MACS_sample_kidney_box.instr"
  mccspec_detector_0_exit_volume_priority = 232;
#line 684 "MACS_sample_kidney_box.instr"
  mccspec_detector_0_exit_volume_xwidth = 2.01 * detector_radius;
#line 684 "MACS_sample_kidney_box.instr"
  mccspec_detector_0_exit_volume_yheight = 1.01 * detector_height;
#line 684 "MACS_sample_kidney_box.instr"
  mccspec_detector_0_exit_volume_zdepth = 0.001;
#line 71 "MACS_sample_kidney_box.instr"
  mccspec_detector_0_exit_volume_xwidth2 = -1;
#line 71 "MACS_sample_kidney_box.instr"
  mccspec_detector_0_exit_volume_yheight2 = -1;
#line 71 "MACS_sample_kidney_box.instr"
  mccspec_detector_0_exit_volume_visualize = 1;
#line 71 "MACS_sample_kidney_box.instr"
  mccspec_detector_0_exit_volume_target_index = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccspec_detector_0_exit_volume_target_x = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccspec_detector_0_exit_volume_target_y = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccspec_detector_0_exit_volume_target_z = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccspec_detector_0_exit_volume_focus_aw = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccspec_detector_0_exit_volume_focus_ah = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccspec_detector_0_exit_volume_focus_xw = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccspec_detector_0_exit_volume_focus_xh = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccspec_detector_0_exit_volume_focus_r = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccspec_detector_0_exit_volume_p_interact = 0;
#line 71 "MACS_sample_kidney_box.instr"
  if(0) strncpy(mccspec_detector_0_exit_volume_mask_string, 0 ? 0 : "", 16384); else mccspec_detector_0_exit_volume_mask_string[0]='\0';
#line 71 "MACS_sample_kidney_box.instr"
  if(0) strncpy(mccspec_detector_0_exit_volume_mask_setting, 0 ? 0 : "", 16384); else mccspec_detector_0_exit_volume_mask_setting[0]='\0';
#line 71 "MACS_sample_kidney_box.instr"
  mccspec_detector_0_exit_volume_number_of_activations = 1;
#line 98894 "MACS_sample_kidney_box.c"

  SIG_MESSAGE("spec_detector_0_exit_volume (Init:Place/Rotate)");
  rot_set_rotation(mctr1,
#line 687 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 687 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 687 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD);
#line 98904 "MACS_sample_kidney_box.c"
  rot_mul(mctr1, mcrotachannel_0_analyzer_2_center, mcrotaspec_detector_0_exit_volume);
  rot_transpose(mcrotadiffraction_detector_0_exit_volume, mctr1);
  rot_mul(mcrotaspec_detector_0_exit_volume, mctr1, mcrotrspec_detector_0_exit_volume);
  mctc1 = coords_set(
#line 686 "MACS_sample_kidney_box.instr"
    0,
#line 686 "MACS_sample_kidney_box.instr"
    0,
#line 686 "MACS_sample_kidney_box.instr"
    0);
#line 98915 "MACS_sample_kidney_box.c"
  rot_transpose(mcrotachannel_0_cave2_cyl1, mctr1);
  mctc2 = rot_apply(mctr1, mctc1);
  mcposaspec_detector_0_exit_volume = coords_add(mcposachannel_0_cave2_cyl1, mctc2);
  mctc1 = coords_sub(mcposadiffraction_detector_0_exit_volume, mcposaspec_detector_0_exit_volume);
  mcposrspec_detector_0_exit_volume = rot_apply(mcrotaspec_detector_0_exit_volume, mctc1);
  mcDEBUG_COMPONENT("spec_detector_0_exit_volume", mcposaspec_detector_0_exit_volume, mcrotaspec_detector_0_exit_volume)
  mccomp_posa[161] = mcposaspec_detector_0_exit_volume;
  mccomp_posr[161] = mcposrspec_detector_0_exit_volume;
  mcNCounter[161]  = mcPCounter[161] = mcP2Counter[161] = 0;
  mcAbsorbProp[161]= 0;
    /* Component channel_1_cave1_box1. */
  /* Setting parameters for component channel_1_cave1_box1. */
  SIG_MESSAGE("channel_1_cave1_box1 (Init:SetPar)");
#line 692 "MACS_sample_kidney_box.instr"
  if("Vacuum") strncpy(mccchannel_1_cave1_box1_material_string, "Vacuum" ? "Vacuum" : "", 16384); else mccchannel_1_cave1_box1_material_string[0]='\0';
#line 692 "MACS_sample_kidney_box.instr"
  mccchannel_1_cave1_box1_priority = 300;
#line 690 "MACS_sample_kidney_box.instr"
  mccchannel_1_cave1_box1_xwidth = kidney_cave1_box1_width1;
#line 690 "MACS_sample_kidney_box.instr"
  mccchannel_1_cave1_box1_yheight = kidney_cave1_box1_height1;
#line 690 "MACS_sample_kidney_box.instr"
  mccchannel_1_cave1_box1_zdepth = kidney_cave1_box1_depth;
#line 691 "MACS_sample_kidney_box.instr"
  mccchannel_1_cave1_box1_xwidth2 = kidney_cave1_box1_width2;
#line 691 "MACS_sample_kidney_box.instr"
  mccchannel_1_cave1_box1_yheight2 = kidney_cave1_box1_height2;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_1_cave1_box1_visualize = 1;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_1_cave1_box1_target_index = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_1_cave1_box1_target_x = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_1_cave1_box1_target_y = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_1_cave1_box1_target_z = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_1_cave1_box1_focus_aw = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_1_cave1_box1_focus_ah = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_1_cave1_box1_focus_xw = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_1_cave1_box1_focus_xh = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_1_cave1_box1_focus_r = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_1_cave1_box1_p_interact = 0;
#line 71 "MACS_sample_kidney_box.instr"
  if(0) strncpy(mccchannel_1_cave1_box1_mask_string, 0 ? 0 : "", 16384); else mccchannel_1_cave1_box1_mask_string[0]='\0';
#line 71 "MACS_sample_kidney_box.instr"
  if(0) strncpy(mccchannel_1_cave1_box1_mask_setting, 0 ? 0 : "", 16384); else mccchannel_1_cave1_box1_mask_setting[0]='\0';
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_1_cave1_box1_number_of_activations = 1;
#line 98971 "MACS_sample_kidney_box.c"

  SIG_MESSAGE("channel_1_cave1_box1 (Init:Place/Rotate)");
  rot_set_rotation(mctr1,
#line 694 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 694 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 694 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD);
#line 98981 "MACS_sample_kidney_box.c"
  rot_mul(mctr1, mcrotakidney_channel_1, mcrotachannel_1_cave1_box1);
  rot_transpose(mcrotaspec_detector_0_exit_volume, mctr1);
  rot_mul(mcrotachannel_1_cave1_box1, mctr1, mcrotrchannel_1_cave1_box1);
  mctc1 = coords_set(
#line 693 "MACS_sample_kidney_box.instr"
    0,
#line 693 "MACS_sample_kidney_box.instr"
    0,
#line 693 "MACS_sample_kidney_box.instr"
    kidney_cave1_box1_center_to_target);
#line 98992 "MACS_sample_kidney_box.c"
  rot_transpose(mcrotakidney_channel_1, mctr1);
  mctc2 = rot_apply(mctr1, mctc1);
  mcposachannel_1_cave1_box1 = coords_add(mcposakidney_channel_1, mctc2);
  mctc1 = coords_sub(mcposaspec_detector_0_exit_volume, mcposachannel_1_cave1_box1);
  mcposrchannel_1_cave1_box1 = rot_apply(mcrotachannel_1_cave1_box1, mctc1);
  mcDEBUG_COMPONENT("channel_1_cave1_box1", mcposachannel_1_cave1_box1, mcrotachannel_1_cave1_box1)
  mccomp_posa[162] = mcposachannel_1_cave1_box1;
  mccomp_posr[162] = mcposrchannel_1_cave1_box1;
  mcNCounter[162]  = mcPCounter[162] = mcP2Counter[162] = 0;
  mcAbsorbProp[162]= 0;
    /* Component channel_1_cave1_box2. */
  /* Setting parameters for component channel_1_cave1_box2. */
  SIG_MESSAGE("channel_1_cave1_box2 (Init:SetPar)");
#line 699 "MACS_sample_kidney_box.instr"
  if("Vacuum") strncpy(mccchannel_1_cave1_box2_material_string, "Vacuum" ? "Vacuum" : "", 16384); else mccchannel_1_cave1_box2_material_string[0]='\0';
#line 699 "MACS_sample_kidney_box.instr"
  mccchannel_1_cave1_box2_priority = 305;
#line 697 "MACS_sample_kidney_box.instr"
  mccchannel_1_cave1_box2_xwidth = kidney_cave1_box2_width1;
#line 697 "MACS_sample_kidney_box.instr"
  mccchannel_1_cave1_box2_yheight = kidney_cave1_box2_height1;
#line 697 "MACS_sample_kidney_box.instr"
  mccchannel_1_cave1_box2_zdepth = kidney_cave1_box2_depth;
#line 698 "MACS_sample_kidney_box.instr"
  mccchannel_1_cave1_box2_xwidth2 = kidney_cave1_box2_width2;
#line 698 "MACS_sample_kidney_box.instr"
  mccchannel_1_cave1_box2_yheight2 = kidney_cave1_box2_height2;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_1_cave1_box2_visualize = 1;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_1_cave1_box2_target_index = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_1_cave1_box2_target_x = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_1_cave1_box2_target_y = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_1_cave1_box2_target_z = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_1_cave1_box2_focus_aw = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_1_cave1_box2_focus_ah = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_1_cave1_box2_focus_xw = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_1_cave1_box2_focus_xh = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_1_cave1_box2_focus_r = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_1_cave1_box2_p_interact = 0;
#line 71 "MACS_sample_kidney_box.instr"
  if(0) strncpy(mccchannel_1_cave1_box2_mask_string, 0 ? 0 : "", 16384); else mccchannel_1_cave1_box2_mask_string[0]='\0';
#line 71 "MACS_sample_kidney_box.instr"
  if(0) strncpy(mccchannel_1_cave1_box2_mask_setting, 0 ? 0 : "", 16384); else mccchannel_1_cave1_box2_mask_setting[0]='\0';
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_1_cave1_box2_number_of_activations = 1;
#line 99048 "MACS_sample_kidney_box.c"

  SIG_MESSAGE("channel_1_cave1_box2 (Init:Place/Rotate)");
  rot_set_rotation(mctr1,
#line 701 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 701 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 701 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD);
#line 99058 "MACS_sample_kidney_box.c"
  rot_mul(mctr1, mcrotakidney_channel_1, mcrotachannel_1_cave1_box2);
  rot_transpose(mcrotachannel_1_cave1_box1, mctr1);
  rot_mul(mcrotachannel_1_cave1_box2, mctr1, mcrotrchannel_1_cave1_box2);
  mctc1 = coords_set(
#line 700 "MACS_sample_kidney_box.instr"
    kidney_cave1_box2_x_offset,
#line 700 "MACS_sample_kidney_box.instr"
    0,
#line 700 "MACS_sample_kidney_box.instr"
    kidney_cave1_box2_center_to_target);
#line 99069 "MACS_sample_kidney_box.c"
  rot_transpose(mcrotakidney_channel_1, mctr1);
  mctc2 = rot_apply(mctr1, mctc1);
  mcposachannel_1_cave1_box2 = coords_add(mcposakidney_channel_1, mctc2);
  mctc1 = coords_sub(mcposachannel_1_cave1_box1, mcposachannel_1_cave1_box2);
  mcposrchannel_1_cave1_box2 = rot_apply(mcrotachannel_1_cave1_box2, mctc1);
  mcDEBUG_COMPONENT("channel_1_cave1_box2", mcposachannel_1_cave1_box2, mcrotachannel_1_cave1_box2)
  mccomp_posa[163] = mcposachannel_1_cave1_box2;
  mccomp_posr[163] = mcposrchannel_1_cave1_box2;
  mcNCounter[163]  = mcPCounter[163] = mcP2Counter[163] = 0;
  mcAbsorbProp[163]= 0;
    /* Component channel_1_cave1_box3. */
  /* Setting parameters for component channel_1_cave1_box3. */
  SIG_MESSAGE("channel_1_cave1_box3 (Init:SetPar)");
#line 706 "MACS_sample_kidney_box.instr"
  if("Vacuum") strncpy(mccchannel_1_cave1_box3_material_string, "Vacuum" ? "Vacuum" : "", 16384); else mccchannel_1_cave1_box3_material_string[0]='\0';
#line 706 "MACS_sample_kidney_box.instr"
  mccchannel_1_cave1_box3_priority = 302;
#line 704 "MACS_sample_kidney_box.instr"
  mccchannel_1_cave1_box3_xwidth = kidney_cave1_box3_width1;
#line 704 "MACS_sample_kidney_box.instr"
  mccchannel_1_cave1_box3_yheight = kidney_cave1_box3_height1;
#line 704 "MACS_sample_kidney_box.instr"
  mccchannel_1_cave1_box3_zdepth = kidney_cave1_box3_depth;
#line 705 "MACS_sample_kidney_box.instr"
  mccchannel_1_cave1_box3_xwidth2 = kidney_cave1_box3_width2;
#line 705 "MACS_sample_kidney_box.instr"
  mccchannel_1_cave1_box3_yheight2 = kidney_cave1_box3_height2;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_1_cave1_box3_visualize = 1;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_1_cave1_box3_target_index = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_1_cave1_box3_target_x = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_1_cave1_box3_target_y = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_1_cave1_box3_target_z = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_1_cave1_box3_focus_aw = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_1_cave1_box3_focus_ah = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_1_cave1_box3_focus_xw = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_1_cave1_box3_focus_xh = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_1_cave1_box3_focus_r = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_1_cave1_box3_p_interact = 0;
#line 71 "MACS_sample_kidney_box.instr"
  if(0) strncpy(mccchannel_1_cave1_box3_mask_string, 0 ? 0 : "", 16384); else mccchannel_1_cave1_box3_mask_string[0]='\0';
#line 71 "MACS_sample_kidney_box.instr"
  if(0) strncpy(mccchannel_1_cave1_box3_mask_setting, 0 ? 0 : "", 16384); else mccchannel_1_cave1_box3_mask_setting[0]='\0';
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_1_cave1_box3_number_of_activations = 1;
#line 99125 "MACS_sample_kidney_box.c"

  SIG_MESSAGE("channel_1_cave1_box3 (Init:Place/Rotate)");
  rot_set_rotation(mctr1,
#line 708 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 708 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 708 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD);
#line 99135 "MACS_sample_kidney_box.c"
  rot_mul(mctr1, mcrotakidney_channel_1, mcrotachannel_1_cave1_box3);
  rot_transpose(mcrotachannel_1_cave1_box2, mctr1);
  rot_mul(mcrotachannel_1_cave1_box3, mctr1, mcrotrchannel_1_cave1_box3);
  mctc1 = coords_set(
#line 707 "MACS_sample_kidney_box.instr"
    0,
#line 707 "MACS_sample_kidney_box.instr"
    0,
#line 707 "MACS_sample_kidney_box.instr"
    kidney_cave1_box3_center_to_target);
#line 99146 "MACS_sample_kidney_box.c"
  rot_transpose(mcrotakidney_channel_1, mctr1);
  mctc2 = rot_apply(mctr1, mctc1);
  mcposachannel_1_cave1_box3 = coords_add(mcposakidney_channel_1, mctc2);
  mctc1 = coords_sub(mcposachannel_1_cave1_box2, mcposachannel_1_cave1_box3);
  mcposrchannel_1_cave1_box3 = rot_apply(mcrotachannel_1_cave1_box3, mctc1);
  mcDEBUG_COMPONENT("channel_1_cave1_box3", mcposachannel_1_cave1_box3, mcrotachannel_1_cave1_box3)
  mccomp_posa[164] = mcposachannel_1_cave1_box3;
  mccomp_posr[164] = mcposrchannel_1_cave1_box3;
  mcNCounter[164]  = mcPCounter[164] = mcP2Counter[164] = 0;
  mcAbsorbProp[164]= 0;
    /* Component channel_1_cave1_cyl1. */
  /* Setting parameters for component channel_1_cave1_cyl1. */
  SIG_MESSAGE("channel_1_cave1_cyl1 (Init:SetPar)");
#line 712 "MACS_sample_kidney_box.instr"
  if("Vacuum") strncpy(mccchannel_1_cave1_cyl1_material_string, "Vacuum" ? "Vacuum" : "", 16384); else mccchannel_1_cave1_cyl1_material_string[0]='\0';
#line 712 "MACS_sample_kidney_box.instr"
  mccchannel_1_cave1_cyl1_priority = 303;
#line 711 "MACS_sample_kidney_box.instr"
  mccchannel_1_cave1_cyl1_radius = kidney_cave1_cyl1_radius;
#line 711 "MACS_sample_kidney_box.instr"
  mccchannel_1_cave1_cyl1_yheight = kidney_cave1_cyl1_height;
#line 67 "MACS_sample_kidney_box.instr"
  mccchannel_1_cave1_cyl1_visualize = 1;
#line 67 "MACS_sample_kidney_box.instr"
  mccchannel_1_cave1_cyl1_target_index = 0;
#line 67 "MACS_sample_kidney_box.instr"
  mccchannel_1_cave1_cyl1_target_x = 0;
#line 67 "MACS_sample_kidney_box.instr"
  mccchannel_1_cave1_cyl1_target_y = 0;
#line 67 "MACS_sample_kidney_box.instr"
  mccchannel_1_cave1_cyl1_target_z = 0;
#line 67 "MACS_sample_kidney_box.instr"
  mccchannel_1_cave1_cyl1_focus_aw = 0;
#line 67 "MACS_sample_kidney_box.instr"
  mccchannel_1_cave1_cyl1_focus_ah = 0;
#line 67 "MACS_sample_kidney_box.instr"
  mccchannel_1_cave1_cyl1_focus_xw = 0;
#line 67 "MACS_sample_kidney_box.instr"
  mccchannel_1_cave1_cyl1_focus_xh = 0;
#line 67 "MACS_sample_kidney_box.instr"
  mccchannel_1_cave1_cyl1_focus_r = 0;
#line 67 "MACS_sample_kidney_box.instr"
  mccchannel_1_cave1_cyl1_p_interact = 0;
#line 67 "MACS_sample_kidney_box.instr"
  if(0) strncpy(mccchannel_1_cave1_cyl1_mask_string, 0 ? 0 : "", 16384); else mccchannel_1_cave1_cyl1_mask_string[0]='\0';
#line 67 "MACS_sample_kidney_box.instr"
  if(0) strncpy(mccchannel_1_cave1_cyl1_mask_setting, 0 ? 0 : "", 16384); else mccchannel_1_cave1_cyl1_mask_setting[0]='\0';
#line 67 "MACS_sample_kidney_box.instr"
  mccchannel_1_cave1_cyl1_number_of_activations = 1;
#line 99196 "MACS_sample_kidney_box.c"

  SIG_MESSAGE("channel_1_cave1_cyl1 (Init:Place/Rotate)");
  rot_set_rotation(mctr1,
#line 714 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 714 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 714 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD);
#line 99206 "MACS_sample_kidney_box.c"
  rot_mul(mctr1, mcrotakidney_channel_1, mcrotachannel_1_cave1_cyl1);
  rot_transpose(mcrotachannel_1_cave1_box3, mctr1);
  rot_mul(mcrotachannel_1_cave1_cyl1, mctr1, mcrotrchannel_1_cave1_cyl1);
  mctc1 = coords_set(
#line 713 "MACS_sample_kidney_box.instr"
    0,
#line 713 "MACS_sample_kidney_box.instr"
    0,
#line 713 "MACS_sample_kidney_box.instr"
    kidney_cave1_cyl1_center_to_target);
#line 99217 "MACS_sample_kidney_box.c"
  rot_transpose(mcrotakidney_channel_1, mctr1);
  mctc2 = rot_apply(mctr1, mctc1);
  mcposachannel_1_cave1_cyl1 = coords_add(mcposakidney_channel_1, mctc2);
  mctc1 = coords_sub(mcposachannel_1_cave1_box3, mcposachannel_1_cave1_cyl1);
  mcposrchannel_1_cave1_cyl1 = rot_apply(mcrotachannel_1_cave1_cyl1, mctc1);
  mcDEBUG_COMPONENT("channel_1_cave1_cyl1", mcposachannel_1_cave1_cyl1, mcrotachannel_1_cave1_cyl1)
  mccomp_posa[165] = mcposachannel_1_cave1_cyl1;
  mccomp_posr[165] = mcposrchannel_1_cave1_cyl1;
  mcNCounter[165]  = mcPCounter[165] = mcP2Counter[165] = 0;
  mcAbsorbProp[165]= 0;
    /* Component channel_1_analyzer_1_center. */
  /* Setting parameters for component channel_1_analyzer_1_center. */
  SIG_MESSAGE("channel_1_analyzer_1_center (Init:SetPar)");

  SIG_MESSAGE("channel_1_analyzer_1_center (Init:Place/Rotate)");
  rot_set_rotation(mctr1,
    (0.0)*DEG2RAD,
    (0.0)*DEG2RAD,
    (0.0)*DEG2RAD);
#line 99237 "MACS_sample_kidney_box.c"
  rot_mul(mctr1, mcrotakidney_channel_1, mcrotachannel_1_analyzer_1_center);
  rot_transpose(mcrotachannel_1_cave1_cyl1, mctr1);
  rot_mul(mcrotachannel_1_analyzer_1_center, mctr1, mcrotrchannel_1_analyzer_1_center);
  mctc1 = coords_set(
#line 718 "MACS_sample_kidney_box.instr"
    0,
#line 718 "MACS_sample_kidney_box.instr"
    0,
#line 718 "MACS_sample_kidney_box.instr"
    analyzer_1_center_to_sample);
#line 99248 "MACS_sample_kidney_box.c"
  rot_transpose(mcrotakidney_channel_1, mctr1);
  mctc2 = rot_apply(mctr1, mctc1);
  mcposachannel_1_analyzer_1_center = coords_add(mcposakidney_channel_1, mctc2);
  mctc1 = coords_sub(mcposachannel_1_cave1_cyl1, mcposachannel_1_analyzer_1_center);
  mcposrchannel_1_analyzer_1_center = rot_apply(mcrotachannel_1_analyzer_1_center, mctc1);
  mcDEBUG_COMPONENT("channel_1_analyzer_1_center", mcposachannel_1_analyzer_1_center, mcrotachannel_1_analyzer_1_center)
  mccomp_posa[166] = mcposachannel_1_analyzer_1_center;
  mccomp_posr[166] = mcposrchannel_1_analyzer_1_center;
  mcNCounter[166]  = mcPCounter[166] = mcP2Counter[166] = 0;
  mcAbsorbProp[166]= 0;
    /* Component channel_1_analyzer_1_rotated. */
  /* Setting parameters for component channel_1_analyzer_1_rotated. */
  SIG_MESSAGE("channel_1_analyzer_1_rotated (Init:SetPar)");

  SIG_MESSAGE("channel_1_analyzer_1_rotated (Init:Place/Rotate)");
  rot_set_rotation(mctr1,
#line 722 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 722 "MACS_sample_kidney_box.instr"
    (180 - analyzer_theta [ 1 ])*DEG2RAD,
#line 722 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD);
#line 99271 "MACS_sample_kidney_box.c"
  rot_mul(mctr1, mcrotachannel_1_analyzer_1_center, mcrotachannel_1_analyzer_1_rotated);
  rot_transpose(mcrotachannel_1_analyzer_1_center, mctr1);
  rot_mul(mcrotachannel_1_analyzer_1_rotated, mctr1, mcrotrchannel_1_analyzer_1_rotated);
  mctc1 = coords_set(
#line 721 "MACS_sample_kidney_box.instr"
    0,
#line 721 "MACS_sample_kidney_box.instr"
    0,
#line 721 "MACS_sample_kidney_box.instr"
    -0.5 * analyzer_seperation / tan ( analyzer_2theta [ 1 ] * DEG2RAD ));
#line 99282 "MACS_sample_kidney_box.c"
  rot_transpose(mcrotachannel_1_analyzer_1_center, mctr1);
  mctc2 = rot_apply(mctr1, mctc1);
  mcposachannel_1_analyzer_1_rotated = coords_add(mcposachannel_1_analyzer_1_center, mctc2);
  mctc1 = coords_sub(mcposachannel_1_analyzer_1_center, mcposachannel_1_analyzer_1_rotated);
  mcposrchannel_1_analyzer_1_rotated = rot_apply(mcrotachannel_1_analyzer_1_rotated, mctc1);
  mcDEBUG_COMPONENT("channel_1_analyzer_1_rotated", mcposachannel_1_analyzer_1_rotated, mcrotachannel_1_analyzer_1_rotated)
  mccomp_posa[167] = mcposachannel_1_analyzer_1_rotated;
  mccomp_posr[167] = mcposrchannel_1_analyzer_1_rotated;
  mcNCounter[167]  = mcPCounter[167] = mcP2Counter[167] = 0;
  mcAbsorbProp[167]= 0;
    /* Component channel_1_analyzer_1_array_crystal_array_0. */
  /* Setting parameters for component channel_1_analyzer_1_array_crystal_array_0. */
  SIG_MESSAGE("channel_1_analyzer_1_array_crystal_array_0 (Init:SetPar)");
#line 726 "MACS_sample_kidney_box.instr"
  if("PG_analyzer") strncpy(mccchannel_1_analyzer_1_array_crystal_array_0_material_string, "PG_analyzer" ? "PG_analyzer" : "", 16384); else mccchannel_1_analyzer_1_array_crystal_array_0_material_string[0]='\0';
#line 726 "MACS_sample_kidney_box.instr"
  mccchannel_1_analyzer_1_array_crystal_array_0_priority = 320.0;
#line 725 "MACS_sample_kidney_box.instr"
  mccchannel_1_analyzer_1_array_crystal_array_0_xwidth = channel_1_analyzer_1_array_crystal_depth;
#line 725 "MACS_sample_kidney_box.instr"
  mccchannel_1_analyzer_1_array_crystal_array_0_yheight = channel_1_analyzer_1_array_crystal_height;
#line 725 "MACS_sample_kidney_box.instr"
  mccchannel_1_analyzer_1_array_crystal_array_0_zdepth = channel_1_analyzer_1_array_crystal_width;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_1_analyzer_1_array_crystal_array_0_xwidth2 = -1;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_1_analyzer_1_array_crystal_array_0_yheight2 = -1;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_1_analyzer_1_array_crystal_array_0_visualize = 1;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_1_analyzer_1_array_crystal_array_0_target_index = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_1_analyzer_1_array_crystal_array_0_target_x = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_1_analyzer_1_array_crystal_array_0_target_y = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_1_analyzer_1_array_crystal_array_0_target_z = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_1_analyzer_1_array_crystal_array_0_focus_aw = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_1_analyzer_1_array_crystal_array_0_focus_ah = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_1_analyzer_1_array_crystal_array_0_focus_xw = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_1_analyzer_1_array_crystal_array_0_focus_xh = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_1_analyzer_1_array_crystal_array_0_focus_r = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_1_analyzer_1_array_crystal_array_0_p_interact = 0;
#line 71 "MACS_sample_kidney_box.instr"
  if(0) strncpy(mccchannel_1_analyzer_1_array_crystal_array_0_mask_string, 0 ? 0 : "", 16384); else mccchannel_1_analyzer_1_array_crystal_array_0_mask_string[0]='\0';
#line 71 "MACS_sample_kidney_box.instr"
  if(0) strncpy(mccchannel_1_analyzer_1_array_crystal_array_0_mask_setting, 0 ? 0 : "", 16384); else mccchannel_1_analyzer_1_array_crystal_array_0_mask_setting[0]='\0';
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_1_analyzer_1_array_crystal_array_0_number_of_activations = 1;
#line 99338 "MACS_sample_kidney_box.c"

  SIG_MESSAGE("channel_1_analyzer_1_array_crystal_array_0 (Init:Place/Rotate)");
  rot_set_rotation(mctr1,
#line 728 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 728 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 728 "MACS_sample_kidney_box.instr"
    (0 - RAD2DEG * channel_1_analyzer_1_array_theta [ 0 ])*DEG2RAD);
#line 99348 "MACS_sample_kidney_box.c"
  rot_mul(mctr1, mcrotachannel_1_analyzer_1_rotated, mcrotachannel_1_analyzer_1_array_crystal_array_0);
  rot_transpose(mcrotachannel_1_analyzer_1_rotated, mctr1);
  rot_mul(mcrotachannel_1_analyzer_1_array_crystal_array_0, mctr1, mcrotrchannel_1_analyzer_1_array_crystal_array_0);
  mctc1 = coords_set(
#line 727 "MACS_sample_kidney_box.instr"
    0 + channel_1_analyzer_1_array_effective_radius_of_curvature * ( 1 - cos ( channel_1_analyzer_1_array_theta [ 0 ] ) ),
#line 727 "MACS_sample_kidney_box.instr"
    0 + channel_1_analyzer_1_array_effective_radius_of_curvature * sin ( channel_1_analyzer_1_array_theta [ 0 ] ),
#line 727 "MACS_sample_kidney_box.instr"
    0);
#line 99359 "MACS_sample_kidney_box.c"
  rot_transpose(mcrotachannel_1_analyzer_1_rotated, mctr1);
  mctc2 = rot_apply(mctr1, mctc1);
  mcposachannel_1_analyzer_1_array_crystal_array_0 = coords_add(mcposachannel_1_analyzer_1_rotated, mctc2);
  mctc1 = coords_sub(mcposachannel_1_analyzer_1_rotated, mcposachannel_1_analyzer_1_array_crystal_array_0);
  mcposrchannel_1_analyzer_1_array_crystal_array_0 = rot_apply(mcrotachannel_1_analyzer_1_array_crystal_array_0, mctc1);
  mcDEBUG_COMPONENT("channel_1_analyzer_1_array_crystal_array_0", mcposachannel_1_analyzer_1_array_crystal_array_0, mcrotachannel_1_analyzer_1_array_crystal_array_0)
  mccomp_posa[168] = mcposachannel_1_analyzer_1_array_crystal_array_0;
  mccomp_posr[168] = mcposrchannel_1_analyzer_1_array_crystal_array_0;
  mcNCounter[168]  = mcPCounter[168] = mcP2Counter[168] = 0;
  mcAbsorbProp[168]= 0;
    /* Component channel_1_analyzer_1_array_crystal_array_1. */
  /* Setting parameters for component channel_1_analyzer_1_array_crystal_array_1. */
  SIG_MESSAGE("channel_1_analyzer_1_array_crystal_array_1 (Init:SetPar)");
#line 732 "MACS_sample_kidney_box.instr"
  if("PG_analyzer") strncpy(mccchannel_1_analyzer_1_array_crystal_array_1_material_string, "PG_analyzer" ? "PG_analyzer" : "", 16384); else mccchannel_1_analyzer_1_array_crystal_array_1_material_string[0]='\0';
#line 732 "MACS_sample_kidney_box.instr"
  mccchannel_1_analyzer_1_array_crystal_array_1_priority = 320.1;
#line 731 "MACS_sample_kidney_box.instr"
  mccchannel_1_analyzer_1_array_crystal_array_1_xwidth = channel_1_analyzer_1_array_crystal_depth;
#line 731 "MACS_sample_kidney_box.instr"
  mccchannel_1_analyzer_1_array_crystal_array_1_yheight = channel_1_analyzer_1_array_crystal_height;
#line 731 "MACS_sample_kidney_box.instr"
  mccchannel_1_analyzer_1_array_crystal_array_1_zdepth = channel_1_analyzer_1_array_crystal_width;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_1_analyzer_1_array_crystal_array_1_xwidth2 = -1;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_1_analyzer_1_array_crystal_array_1_yheight2 = -1;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_1_analyzer_1_array_crystal_array_1_visualize = 1;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_1_analyzer_1_array_crystal_array_1_target_index = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_1_analyzer_1_array_crystal_array_1_target_x = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_1_analyzer_1_array_crystal_array_1_target_y = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_1_analyzer_1_array_crystal_array_1_target_z = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_1_analyzer_1_array_crystal_array_1_focus_aw = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_1_analyzer_1_array_crystal_array_1_focus_ah = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_1_analyzer_1_array_crystal_array_1_focus_xw = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_1_analyzer_1_array_crystal_array_1_focus_xh = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_1_analyzer_1_array_crystal_array_1_focus_r = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_1_analyzer_1_array_crystal_array_1_p_interact = 0;
#line 71 "MACS_sample_kidney_box.instr"
  if(0) strncpy(mccchannel_1_analyzer_1_array_crystal_array_1_mask_string, 0 ? 0 : "", 16384); else mccchannel_1_analyzer_1_array_crystal_array_1_mask_string[0]='\0';
#line 71 "MACS_sample_kidney_box.instr"
  if(0) strncpy(mccchannel_1_analyzer_1_array_crystal_array_1_mask_setting, 0 ? 0 : "", 16384); else mccchannel_1_analyzer_1_array_crystal_array_1_mask_setting[0]='\0';
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_1_analyzer_1_array_crystal_array_1_number_of_activations = 1;
#line 99415 "MACS_sample_kidney_box.c"

  SIG_MESSAGE("channel_1_analyzer_1_array_crystal_array_1 (Init:Place/Rotate)");
  rot_set_rotation(mctr1,
#line 734 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 734 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 734 "MACS_sample_kidney_box.instr"
    (0 - RAD2DEG * channel_1_analyzer_1_array_theta [ 1 ])*DEG2RAD);
#line 99425 "MACS_sample_kidney_box.c"
  rot_mul(mctr1, mcrotachannel_1_analyzer_1_rotated, mcrotachannel_1_analyzer_1_array_crystal_array_1);
  rot_transpose(mcrotachannel_1_analyzer_1_array_crystal_array_0, mctr1);
  rot_mul(mcrotachannel_1_analyzer_1_array_crystal_array_1, mctr1, mcrotrchannel_1_analyzer_1_array_crystal_array_1);
  mctc1 = coords_set(
#line 733 "MACS_sample_kidney_box.instr"
    0 + channel_1_analyzer_1_array_effective_radius_of_curvature * ( 1 - cos ( channel_1_analyzer_1_array_theta [ 1 ] ) ),
#line 733 "MACS_sample_kidney_box.instr"
    0 + channel_1_analyzer_1_array_effective_radius_of_curvature * sin ( channel_1_analyzer_1_array_theta [ 1 ] ),
#line 733 "MACS_sample_kidney_box.instr"
    0);
#line 99436 "MACS_sample_kidney_box.c"
  rot_transpose(mcrotachannel_1_analyzer_1_rotated, mctr1);
  mctc2 = rot_apply(mctr1, mctc1);
  mcposachannel_1_analyzer_1_array_crystal_array_1 = coords_add(mcposachannel_1_analyzer_1_rotated, mctc2);
  mctc1 = coords_sub(mcposachannel_1_analyzer_1_array_crystal_array_0, mcposachannel_1_analyzer_1_array_crystal_array_1);
  mcposrchannel_1_analyzer_1_array_crystal_array_1 = rot_apply(mcrotachannel_1_analyzer_1_array_crystal_array_1, mctc1);
  mcDEBUG_COMPONENT("channel_1_analyzer_1_array_crystal_array_1", mcposachannel_1_analyzer_1_array_crystal_array_1, mcrotachannel_1_analyzer_1_array_crystal_array_1)
  mccomp_posa[169] = mcposachannel_1_analyzer_1_array_crystal_array_1;
  mccomp_posr[169] = mcposrchannel_1_analyzer_1_array_crystal_array_1;
  mcNCounter[169]  = mcPCounter[169] = mcP2Counter[169] = 0;
  mcAbsorbProp[169]= 0;
    /* Component channel_1_analyzer_1_array_crystal_array_2. */
  /* Setting parameters for component channel_1_analyzer_1_array_crystal_array_2. */
  SIG_MESSAGE("channel_1_analyzer_1_array_crystal_array_2 (Init:SetPar)");
#line 738 "MACS_sample_kidney_box.instr"
  if("PG_analyzer") strncpy(mccchannel_1_analyzer_1_array_crystal_array_2_material_string, "PG_analyzer" ? "PG_analyzer" : "", 16384); else mccchannel_1_analyzer_1_array_crystal_array_2_material_string[0]='\0';
#line 738 "MACS_sample_kidney_box.instr"
  mccchannel_1_analyzer_1_array_crystal_array_2_priority = 320.2;
#line 737 "MACS_sample_kidney_box.instr"
  mccchannel_1_analyzer_1_array_crystal_array_2_xwidth = channel_1_analyzer_1_array_crystal_depth;
#line 737 "MACS_sample_kidney_box.instr"
  mccchannel_1_analyzer_1_array_crystal_array_2_yheight = channel_1_analyzer_1_array_crystal_height;
#line 737 "MACS_sample_kidney_box.instr"
  mccchannel_1_analyzer_1_array_crystal_array_2_zdepth = channel_1_analyzer_1_array_crystal_width;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_1_analyzer_1_array_crystal_array_2_xwidth2 = -1;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_1_analyzer_1_array_crystal_array_2_yheight2 = -1;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_1_analyzer_1_array_crystal_array_2_visualize = 1;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_1_analyzer_1_array_crystal_array_2_target_index = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_1_analyzer_1_array_crystal_array_2_target_x = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_1_analyzer_1_array_crystal_array_2_target_y = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_1_analyzer_1_array_crystal_array_2_target_z = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_1_analyzer_1_array_crystal_array_2_focus_aw = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_1_analyzer_1_array_crystal_array_2_focus_ah = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_1_analyzer_1_array_crystal_array_2_focus_xw = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_1_analyzer_1_array_crystal_array_2_focus_xh = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_1_analyzer_1_array_crystal_array_2_focus_r = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_1_analyzer_1_array_crystal_array_2_p_interact = 0;
#line 71 "MACS_sample_kidney_box.instr"
  if(0) strncpy(mccchannel_1_analyzer_1_array_crystal_array_2_mask_string, 0 ? 0 : "", 16384); else mccchannel_1_analyzer_1_array_crystal_array_2_mask_string[0]='\0';
#line 71 "MACS_sample_kidney_box.instr"
  if(0) strncpy(mccchannel_1_analyzer_1_array_crystal_array_2_mask_setting, 0 ? 0 : "", 16384); else mccchannel_1_analyzer_1_array_crystal_array_2_mask_setting[0]='\0';
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_1_analyzer_1_array_crystal_array_2_number_of_activations = 1;
#line 99492 "MACS_sample_kidney_box.c"

  SIG_MESSAGE("channel_1_analyzer_1_array_crystal_array_2 (Init:Place/Rotate)");
  rot_set_rotation(mctr1,
#line 740 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 740 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 740 "MACS_sample_kidney_box.instr"
    (0 - RAD2DEG * channel_1_analyzer_1_array_theta [ 2 ])*DEG2RAD);
#line 99502 "MACS_sample_kidney_box.c"
  rot_mul(mctr1, mcrotachannel_1_analyzer_1_rotated, mcrotachannel_1_analyzer_1_array_crystal_array_2);
  rot_transpose(mcrotachannel_1_analyzer_1_array_crystal_array_1, mctr1);
  rot_mul(mcrotachannel_1_analyzer_1_array_crystal_array_2, mctr1, mcrotrchannel_1_analyzer_1_array_crystal_array_2);
  mctc1 = coords_set(
#line 739 "MACS_sample_kidney_box.instr"
    0 + channel_1_analyzer_1_array_effective_radius_of_curvature * ( 1 - cos ( channel_1_analyzer_1_array_theta [ 2 ] ) ),
#line 739 "MACS_sample_kidney_box.instr"
    0 + channel_1_analyzer_1_array_effective_radius_of_curvature * sin ( channel_1_analyzer_1_array_theta [ 2 ] ),
#line 739 "MACS_sample_kidney_box.instr"
    0);
#line 99513 "MACS_sample_kidney_box.c"
  rot_transpose(mcrotachannel_1_analyzer_1_rotated, mctr1);
  mctc2 = rot_apply(mctr1, mctc1);
  mcposachannel_1_analyzer_1_array_crystal_array_2 = coords_add(mcposachannel_1_analyzer_1_rotated, mctc2);
  mctc1 = coords_sub(mcposachannel_1_analyzer_1_array_crystal_array_1, mcposachannel_1_analyzer_1_array_crystal_array_2);
  mcposrchannel_1_analyzer_1_array_crystal_array_2 = rot_apply(mcrotachannel_1_analyzer_1_array_crystal_array_2, mctc1);
  mcDEBUG_COMPONENT("channel_1_analyzer_1_array_crystal_array_2", mcposachannel_1_analyzer_1_array_crystal_array_2, mcrotachannel_1_analyzer_1_array_crystal_array_2)
  mccomp_posa[170] = mcposachannel_1_analyzer_1_array_crystal_array_2;
  mccomp_posr[170] = mcposrchannel_1_analyzer_1_array_crystal_array_2;
  mcNCounter[170]  = mcPCounter[170] = mcP2Counter[170] = 0;
  mcAbsorbProp[170]= 0;
    /* Component channel_1_analyzer_1_array_crystal_array_3. */
  /* Setting parameters for component channel_1_analyzer_1_array_crystal_array_3. */
  SIG_MESSAGE("channel_1_analyzer_1_array_crystal_array_3 (Init:SetPar)");
#line 744 "MACS_sample_kidney_box.instr"
  if("PG_analyzer") strncpy(mccchannel_1_analyzer_1_array_crystal_array_3_material_string, "PG_analyzer" ? "PG_analyzer" : "", 16384); else mccchannel_1_analyzer_1_array_crystal_array_3_material_string[0]='\0';
#line 744 "MACS_sample_kidney_box.instr"
  mccchannel_1_analyzer_1_array_crystal_array_3_priority = 320.3;
#line 743 "MACS_sample_kidney_box.instr"
  mccchannel_1_analyzer_1_array_crystal_array_3_xwidth = channel_1_analyzer_1_array_crystal_depth;
#line 743 "MACS_sample_kidney_box.instr"
  mccchannel_1_analyzer_1_array_crystal_array_3_yheight = channel_1_analyzer_1_array_crystal_height;
#line 743 "MACS_sample_kidney_box.instr"
  mccchannel_1_analyzer_1_array_crystal_array_3_zdepth = channel_1_analyzer_1_array_crystal_width;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_1_analyzer_1_array_crystal_array_3_xwidth2 = -1;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_1_analyzer_1_array_crystal_array_3_yheight2 = -1;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_1_analyzer_1_array_crystal_array_3_visualize = 1;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_1_analyzer_1_array_crystal_array_3_target_index = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_1_analyzer_1_array_crystal_array_3_target_x = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_1_analyzer_1_array_crystal_array_3_target_y = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_1_analyzer_1_array_crystal_array_3_target_z = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_1_analyzer_1_array_crystal_array_3_focus_aw = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_1_analyzer_1_array_crystal_array_3_focus_ah = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_1_analyzer_1_array_crystal_array_3_focus_xw = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_1_analyzer_1_array_crystal_array_3_focus_xh = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_1_analyzer_1_array_crystal_array_3_focus_r = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_1_analyzer_1_array_crystal_array_3_p_interact = 0;
#line 71 "MACS_sample_kidney_box.instr"
  if(0) strncpy(mccchannel_1_analyzer_1_array_crystal_array_3_mask_string, 0 ? 0 : "", 16384); else mccchannel_1_analyzer_1_array_crystal_array_3_mask_string[0]='\0';
#line 71 "MACS_sample_kidney_box.instr"
  if(0) strncpy(mccchannel_1_analyzer_1_array_crystal_array_3_mask_setting, 0 ? 0 : "", 16384); else mccchannel_1_analyzer_1_array_crystal_array_3_mask_setting[0]='\0';
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_1_analyzer_1_array_crystal_array_3_number_of_activations = 1;
#line 99569 "MACS_sample_kidney_box.c"

  SIG_MESSAGE("channel_1_analyzer_1_array_crystal_array_3 (Init:Place/Rotate)");
  rot_set_rotation(mctr1,
#line 746 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 746 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 746 "MACS_sample_kidney_box.instr"
    (0 - RAD2DEG * channel_1_analyzer_1_array_theta [ 3 ])*DEG2RAD);
#line 99579 "MACS_sample_kidney_box.c"
  rot_mul(mctr1, mcrotachannel_1_analyzer_1_rotated, mcrotachannel_1_analyzer_1_array_crystal_array_3);
  rot_transpose(mcrotachannel_1_analyzer_1_array_crystal_array_2, mctr1);
  rot_mul(mcrotachannel_1_analyzer_1_array_crystal_array_3, mctr1, mcrotrchannel_1_analyzer_1_array_crystal_array_3);
  mctc1 = coords_set(
#line 745 "MACS_sample_kidney_box.instr"
    0 + channel_1_analyzer_1_array_effective_radius_of_curvature * ( 1 - cos ( channel_1_analyzer_1_array_theta [ 3 ] ) ),
#line 745 "MACS_sample_kidney_box.instr"
    0 + channel_1_analyzer_1_array_effective_radius_of_curvature * sin ( channel_1_analyzer_1_array_theta [ 3 ] ),
#line 745 "MACS_sample_kidney_box.instr"
    0);
#line 99590 "MACS_sample_kidney_box.c"
  rot_transpose(mcrotachannel_1_analyzer_1_rotated, mctr1);
  mctc2 = rot_apply(mctr1, mctc1);
  mcposachannel_1_analyzer_1_array_crystal_array_3 = coords_add(mcposachannel_1_analyzer_1_rotated, mctc2);
  mctc1 = coords_sub(mcposachannel_1_analyzer_1_array_crystal_array_2, mcposachannel_1_analyzer_1_array_crystal_array_3);
  mcposrchannel_1_analyzer_1_array_crystal_array_3 = rot_apply(mcrotachannel_1_analyzer_1_array_crystal_array_3, mctc1);
  mcDEBUG_COMPONENT("channel_1_analyzer_1_array_crystal_array_3", mcposachannel_1_analyzer_1_array_crystal_array_3, mcrotachannel_1_analyzer_1_array_crystal_array_3)
  mccomp_posa[171] = mcposachannel_1_analyzer_1_array_crystal_array_3;
  mccomp_posr[171] = mcposrchannel_1_analyzer_1_array_crystal_array_3;
  mcNCounter[171]  = mcPCounter[171] = mcP2Counter[171] = 0;
  mcAbsorbProp[171]= 0;
    /* Component channel_1_analyzer_1_array_crystal_array_4. */
  /* Setting parameters for component channel_1_analyzer_1_array_crystal_array_4. */
  SIG_MESSAGE("channel_1_analyzer_1_array_crystal_array_4 (Init:SetPar)");
#line 750 "MACS_sample_kidney_box.instr"
  if("PG_analyzer") strncpy(mccchannel_1_analyzer_1_array_crystal_array_4_material_string, "PG_analyzer" ? "PG_analyzer" : "", 16384); else mccchannel_1_analyzer_1_array_crystal_array_4_material_string[0]='\0';
#line 750 "MACS_sample_kidney_box.instr"
  mccchannel_1_analyzer_1_array_crystal_array_4_priority = 320.4;
#line 749 "MACS_sample_kidney_box.instr"
  mccchannel_1_analyzer_1_array_crystal_array_4_xwidth = channel_1_analyzer_1_array_crystal_depth;
#line 749 "MACS_sample_kidney_box.instr"
  mccchannel_1_analyzer_1_array_crystal_array_4_yheight = channel_1_analyzer_1_array_crystal_height;
#line 749 "MACS_sample_kidney_box.instr"
  mccchannel_1_analyzer_1_array_crystal_array_4_zdepth = channel_1_analyzer_1_array_crystal_width;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_1_analyzer_1_array_crystal_array_4_xwidth2 = -1;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_1_analyzer_1_array_crystal_array_4_yheight2 = -1;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_1_analyzer_1_array_crystal_array_4_visualize = 1;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_1_analyzer_1_array_crystal_array_4_target_index = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_1_analyzer_1_array_crystal_array_4_target_x = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_1_analyzer_1_array_crystal_array_4_target_y = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_1_analyzer_1_array_crystal_array_4_target_z = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_1_analyzer_1_array_crystal_array_4_focus_aw = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_1_analyzer_1_array_crystal_array_4_focus_ah = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_1_analyzer_1_array_crystal_array_4_focus_xw = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_1_analyzer_1_array_crystal_array_4_focus_xh = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_1_analyzer_1_array_crystal_array_4_focus_r = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_1_analyzer_1_array_crystal_array_4_p_interact = 0;
#line 71 "MACS_sample_kidney_box.instr"
  if(0) strncpy(mccchannel_1_analyzer_1_array_crystal_array_4_mask_string, 0 ? 0 : "", 16384); else mccchannel_1_analyzer_1_array_crystal_array_4_mask_string[0]='\0';
#line 71 "MACS_sample_kidney_box.instr"
  if(0) strncpy(mccchannel_1_analyzer_1_array_crystal_array_4_mask_setting, 0 ? 0 : "", 16384); else mccchannel_1_analyzer_1_array_crystal_array_4_mask_setting[0]='\0';
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_1_analyzer_1_array_crystal_array_4_number_of_activations = 1;
#line 99646 "MACS_sample_kidney_box.c"

  SIG_MESSAGE("channel_1_analyzer_1_array_crystal_array_4 (Init:Place/Rotate)");
  rot_set_rotation(mctr1,
#line 752 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 752 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 752 "MACS_sample_kidney_box.instr"
    (0 - RAD2DEG * channel_1_analyzer_1_array_theta [ 4 ])*DEG2RAD);
#line 99656 "MACS_sample_kidney_box.c"
  rot_mul(mctr1, mcrotachannel_1_analyzer_1_rotated, mcrotachannel_1_analyzer_1_array_crystal_array_4);
  rot_transpose(mcrotachannel_1_analyzer_1_array_crystal_array_3, mctr1);
  rot_mul(mcrotachannel_1_analyzer_1_array_crystal_array_4, mctr1, mcrotrchannel_1_analyzer_1_array_crystal_array_4);
  mctc1 = coords_set(
#line 751 "MACS_sample_kidney_box.instr"
    0 + channel_1_analyzer_1_array_effective_radius_of_curvature * ( 1 - cos ( channel_1_analyzer_1_array_theta [ 4 ] ) ),
#line 751 "MACS_sample_kidney_box.instr"
    0 + channel_1_analyzer_1_array_effective_radius_of_curvature * sin ( channel_1_analyzer_1_array_theta [ 4 ] ),
#line 751 "MACS_sample_kidney_box.instr"
    0);
#line 99667 "MACS_sample_kidney_box.c"
  rot_transpose(mcrotachannel_1_analyzer_1_rotated, mctr1);
  mctc2 = rot_apply(mctr1, mctc1);
  mcposachannel_1_analyzer_1_array_crystal_array_4 = coords_add(mcposachannel_1_analyzer_1_rotated, mctc2);
  mctc1 = coords_sub(mcposachannel_1_analyzer_1_array_crystal_array_3, mcposachannel_1_analyzer_1_array_crystal_array_4);
  mcposrchannel_1_analyzer_1_array_crystal_array_4 = rot_apply(mcrotachannel_1_analyzer_1_array_crystal_array_4, mctc1);
  mcDEBUG_COMPONENT("channel_1_analyzer_1_array_crystal_array_4", mcposachannel_1_analyzer_1_array_crystal_array_4, mcrotachannel_1_analyzer_1_array_crystal_array_4)
  mccomp_posa[172] = mcposachannel_1_analyzer_1_array_crystal_array_4;
  mccomp_posr[172] = mcposrchannel_1_analyzer_1_array_crystal_array_4;
  mcNCounter[172]  = mcPCounter[172] = mcP2Counter[172] = 0;
  mcAbsorbProp[172]= 0;
    /* Component channel_1_analyzer_1_array_crystal_array_5. */
  /* Setting parameters for component channel_1_analyzer_1_array_crystal_array_5. */
  SIG_MESSAGE("channel_1_analyzer_1_array_crystal_array_5 (Init:SetPar)");
#line 756 "MACS_sample_kidney_box.instr"
  if("PG_analyzer") strncpy(mccchannel_1_analyzer_1_array_crystal_array_5_material_string, "PG_analyzer" ? "PG_analyzer" : "", 16384); else mccchannel_1_analyzer_1_array_crystal_array_5_material_string[0]='\0';
#line 756 "MACS_sample_kidney_box.instr"
  mccchannel_1_analyzer_1_array_crystal_array_5_priority = 320.5;
#line 755 "MACS_sample_kidney_box.instr"
  mccchannel_1_analyzer_1_array_crystal_array_5_xwidth = channel_1_analyzer_1_array_crystal_depth;
#line 755 "MACS_sample_kidney_box.instr"
  mccchannel_1_analyzer_1_array_crystal_array_5_yheight = channel_1_analyzer_1_array_crystal_height;
#line 755 "MACS_sample_kidney_box.instr"
  mccchannel_1_analyzer_1_array_crystal_array_5_zdepth = channel_1_analyzer_1_array_crystal_width;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_1_analyzer_1_array_crystal_array_5_xwidth2 = -1;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_1_analyzer_1_array_crystal_array_5_yheight2 = -1;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_1_analyzer_1_array_crystal_array_5_visualize = 1;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_1_analyzer_1_array_crystal_array_5_target_index = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_1_analyzer_1_array_crystal_array_5_target_x = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_1_analyzer_1_array_crystal_array_5_target_y = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_1_analyzer_1_array_crystal_array_5_target_z = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_1_analyzer_1_array_crystal_array_5_focus_aw = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_1_analyzer_1_array_crystal_array_5_focus_ah = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_1_analyzer_1_array_crystal_array_5_focus_xw = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_1_analyzer_1_array_crystal_array_5_focus_xh = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_1_analyzer_1_array_crystal_array_5_focus_r = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_1_analyzer_1_array_crystal_array_5_p_interact = 0;
#line 71 "MACS_sample_kidney_box.instr"
  if(0) strncpy(mccchannel_1_analyzer_1_array_crystal_array_5_mask_string, 0 ? 0 : "", 16384); else mccchannel_1_analyzer_1_array_crystal_array_5_mask_string[0]='\0';
#line 71 "MACS_sample_kidney_box.instr"
  if(0) strncpy(mccchannel_1_analyzer_1_array_crystal_array_5_mask_setting, 0 ? 0 : "", 16384); else mccchannel_1_analyzer_1_array_crystal_array_5_mask_setting[0]='\0';
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_1_analyzer_1_array_crystal_array_5_number_of_activations = 1;
#line 99723 "MACS_sample_kidney_box.c"

  SIG_MESSAGE("channel_1_analyzer_1_array_crystal_array_5 (Init:Place/Rotate)");
  rot_set_rotation(mctr1,
#line 758 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 758 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 758 "MACS_sample_kidney_box.instr"
    (0 - RAD2DEG * channel_1_analyzer_1_array_theta [ 5 ])*DEG2RAD);
#line 99733 "MACS_sample_kidney_box.c"
  rot_mul(mctr1, mcrotachannel_1_analyzer_1_rotated, mcrotachannel_1_analyzer_1_array_crystal_array_5);
  rot_transpose(mcrotachannel_1_analyzer_1_array_crystal_array_4, mctr1);
  rot_mul(mcrotachannel_1_analyzer_1_array_crystal_array_5, mctr1, mcrotrchannel_1_analyzer_1_array_crystal_array_5);
  mctc1 = coords_set(
#line 757 "MACS_sample_kidney_box.instr"
    0 + channel_1_analyzer_1_array_effective_radius_of_curvature * ( 1 - cos ( channel_1_analyzer_1_array_theta [ 5 ] ) ),
#line 757 "MACS_sample_kidney_box.instr"
    0 + channel_1_analyzer_1_array_effective_radius_of_curvature * sin ( channel_1_analyzer_1_array_theta [ 5 ] ),
#line 757 "MACS_sample_kidney_box.instr"
    0);
#line 99744 "MACS_sample_kidney_box.c"
  rot_transpose(mcrotachannel_1_analyzer_1_rotated, mctr1);
  mctc2 = rot_apply(mctr1, mctc1);
  mcposachannel_1_analyzer_1_array_crystal_array_5 = coords_add(mcposachannel_1_analyzer_1_rotated, mctc2);
  mctc1 = coords_sub(mcposachannel_1_analyzer_1_array_crystal_array_4, mcposachannel_1_analyzer_1_array_crystal_array_5);
  mcposrchannel_1_analyzer_1_array_crystal_array_5 = rot_apply(mcrotachannel_1_analyzer_1_array_crystal_array_5, mctc1);
  mcDEBUG_COMPONENT("channel_1_analyzer_1_array_crystal_array_5", mcposachannel_1_analyzer_1_array_crystal_array_5, mcrotachannel_1_analyzer_1_array_crystal_array_5)
  mccomp_posa[173] = mcposachannel_1_analyzer_1_array_crystal_array_5;
  mccomp_posr[173] = mcposrchannel_1_analyzer_1_array_crystal_array_5;
  mcNCounter[173]  = mcPCounter[173] = mcP2Counter[173] = 0;
  mcAbsorbProp[173]= 0;
    /* Component channel_1_analyzer_1_array_crystal_array_6. */
  /* Setting parameters for component channel_1_analyzer_1_array_crystal_array_6. */
  SIG_MESSAGE("channel_1_analyzer_1_array_crystal_array_6 (Init:SetPar)");
#line 762 "MACS_sample_kidney_box.instr"
  if("PG_analyzer") strncpy(mccchannel_1_analyzer_1_array_crystal_array_6_material_string, "PG_analyzer" ? "PG_analyzer" : "", 16384); else mccchannel_1_analyzer_1_array_crystal_array_6_material_string[0]='\0';
#line 762 "MACS_sample_kidney_box.instr"
  mccchannel_1_analyzer_1_array_crystal_array_6_priority = 320.6;
#line 761 "MACS_sample_kidney_box.instr"
  mccchannel_1_analyzer_1_array_crystal_array_6_xwidth = channel_1_analyzer_1_array_crystal_depth;
#line 761 "MACS_sample_kidney_box.instr"
  mccchannel_1_analyzer_1_array_crystal_array_6_yheight = channel_1_analyzer_1_array_crystal_height;
#line 761 "MACS_sample_kidney_box.instr"
  mccchannel_1_analyzer_1_array_crystal_array_6_zdepth = channel_1_analyzer_1_array_crystal_width;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_1_analyzer_1_array_crystal_array_6_xwidth2 = -1;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_1_analyzer_1_array_crystal_array_6_yheight2 = -1;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_1_analyzer_1_array_crystal_array_6_visualize = 1;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_1_analyzer_1_array_crystal_array_6_target_index = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_1_analyzer_1_array_crystal_array_6_target_x = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_1_analyzer_1_array_crystal_array_6_target_y = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_1_analyzer_1_array_crystal_array_6_target_z = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_1_analyzer_1_array_crystal_array_6_focus_aw = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_1_analyzer_1_array_crystal_array_6_focus_ah = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_1_analyzer_1_array_crystal_array_6_focus_xw = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_1_analyzer_1_array_crystal_array_6_focus_xh = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_1_analyzer_1_array_crystal_array_6_focus_r = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_1_analyzer_1_array_crystal_array_6_p_interact = 0;
#line 71 "MACS_sample_kidney_box.instr"
  if(0) strncpy(mccchannel_1_analyzer_1_array_crystal_array_6_mask_string, 0 ? 0 : "", 16384); else mccchannel_1_analyzer_1_array_crystal_array_6_mask_string[0]='\0';
#line 71 "MACS_sample_kidney_box.instr"
  if(0) strncpy(mccchannel_1_analyzer_1_array_crystal_array_6_mask_setting, 0 ? 0 : "", 16384); else mccchannel_1_analyzer_1_array_crystal_array_6_mask_setting[0]='\0';
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_1_analyzer_1_array_crystal_array_6_number_of_activations = 1;
#line 99800 "MACS_sample_kidney_box.c"

  SIG_MESSAGE("channel_1_analyzer_1_array_crystal_array_6 (Init:Place/Rotate)");
  rot_set_rotation(mctr1,
#line 764 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 764 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 764 "MACS_sample_kidney_box.instr"
    (0 - RAD2DEG * channel_1_analyzer_1_array_theta [ 6 ])*DEG2RAD);
#line 99810 "MACS_sample_kidney_box.c"
  rot_mul(mctr1, mcrotachannel_1_analyzer_1_rotated, mcrotachannel_1_analyzer_1_array_crystal_array_6);
  rot_transpose(mcrotachannel_1_analyzer_1_array_crystal_array_5, mctr1);
  rot_mul(mcrotachannel_1_analyzer_1_array_crystal_array_6, mctr1, mcrotrchannel_1_analyzer_1_array_crystal_array_6);
  mctc1 = coords_set(
#line 763 "MACS_sample_kidney_box.instr"
    0 + channel_1_analyzer_1_array_effective_radius_of_curvature * ( 1 - cos ( channel_1_analyzer_1_array_theta [ 6 ] ) ),
#line 763 "MACS_sample_kidney_box.instr"
    0 + channel_1_analyzer_1_array_effective_radius_of_curvature * sin ( channel_1_analyzer_1_array_theta [ 6 ] ),
#line 763 "MACS_sample_kidney_box.instr"
    0);
#line 99821 "MACS_sample_kidney_box.c"
  rot_transpose(mcrotachannel_1_analyzer_1_rotated, mctr1);
  mctc2 = rot_apply(mctr1, mctc1);
  mcposachannel_1_analyzer_1_array_crystal_array_6 = coords_add(mcposachannel_1_analyzer_1_rotated, mctc2);
  mctc1 = coords_sub(mcposachannel_1_analyzer_1_array_crystal_array_5, mcposachannel_1_analyzer_1_array_crystal_array_6);
  mcposrchannel_1_analyzer_1_array_crystal_array_6 = rot_apply(mcrotachannel_1_analyzer_1_array_crystal_array_6, mctc1);
  mcDEBUG_COMPONENT("channel_1_analyzer_1_array_crystal_array_6", mcposachannel_1_analyzer_1_array_crystal_array_6, mcrotachannel_1_analyzer_1_array_crystal_array_6)
  mccomp_posa[174] = mcposachannel_1_analyzer_1_array_crystal_array_6;
  mccomp_posr[174] = mcposrchannel_1_analyzer_1_array_crystal_array_6;
  mcNCounter[174]  = mcPCounter[174] = mcP2Counter[174] = 0;
  mcAbsorbProp[174]= 0;
    /* Component channel_1_analyzer_1_array_crystal_array_7. */
  /* Setting parameters for component channel_1_analyzer_1_array_crystal_array_7. */
  SIG_MESSAGE("channel_1_analyzer_1_array_crystal_array_7 (Init:SetPar)");
#line 768 "MACS_sample_kidney_box.instr"
  if("PG_analyzer") strncpy(mccchannel_1_analyzer_1_array_crystal_array_7_material_string, "PG_analyzer" ? "PG_analyzer" : "", 16384); else mccchannel_1_analyzer_1_array_crystal_array_7_material_string[0]='\0';
#line 768 "MACS_sample_kidney_box.instr"
  mccchannel_1_analyzer_1_array_crystal_array_7_priority = 320.7;
#line 767 "MACS_sample_kidney_box.instr"
  mccchannel_1_analyzer_1_array_crystal_array_7_xwidth = channel_1_analyzer_1_array_crystal_depth;
#line 767 "MACS_sample_kidney_box.instr"
  mccchannel_1_analyzer_1_array_crystal_array_7_yheight = channel_1_analyzer_1_array_crystal_height;
#line 767 "MACS_sample_kidney_box.instr"
  mccchannel_1_analyzer_1_array_crystal_array_7_zdepth = channel_1_analyzer_1_array_crystal_width;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_1_analyzer_1_array_crystal_array_7_xwidth2 = -1;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_1_analyzer_1_array_crystal_array_7_yheight2 = -1;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_1_analyzer_1_array_crystal_array_7_visualize = 1;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_1_analyzer_1_array_crystal_array_7_target_index = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_1_analyzer_1_array_crystal_array_7_target_x = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_1_analyzer_1_array_crystal_array_7_target_y = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_1_analyzer_1_array_crystal_array_7_target_z = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_1_analyzer_1_array_crystal_array_7_focus_aw = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_1_analyzer_1_array_crystal_array_7_focus_ah = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_1_analyzer_1_array_crystal_array_7_focus_xw = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_1_analyzer_1_array_crystal_array_7_focus_xh = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_1_analyzer_1_array_crystal_array_7_focus_r = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_1_analyzer_1_array_crystal_array_7_p_interact = 0;
#line 71 "MACS_sample_kidney_box.instr"
  if(0) strncpy(mccchannel_1_analyzer_1_array_crystal_array_7_mask_string, 0 ? 0 : "", 16384); else mccchannel_1_analyzer_1_array_crystal_array_7_mask_string[0]='\0';
#line 71 "MACS_sample_kidney_box.instr"
  if(0) strncpy(mccchannel_1_analyzer_1_array_crystal_array_7_mask_setting, 0 ? 0 : "", 16384); else mccchannel_1_analyzer_1_array_crystal_array_7_mask_setting[0]='\0';
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_1_analyzer_1_array_crystal_array_7_number_of_activations = 1;
#line 99877 "MACS_sample_kidney_box.c"

  SIG_MESSAGE("channel_1_analyzer_1_array_crystal_array_7 (Init:Place/Rotate)");
  rot_set_rotation(mctr1,
#line 770 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 770 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 770 "MACS_sample_kidney_box.instr"
    (0 - RAD2DEG * channel_1_analyzer_1_array_theta [ 7 ])*DEG2RAD);
#line 99887 "MACS_sample_kidney_box.c"
  rot_mul(mctr1, mcrotachannel_1_analyzer_1_rotated, mcrotachannel_1_analyzer_1_array_crystal_array_7);
  rot_transpose(mcrotachannel_1_analyzer_1_array_crystal_array_6, mctr1);
  rot_mul(mcrotachannel_1_analyzer_1_array_crystal_array_7, mctr1, mcrotrchannel_1_analyzer_1_array_crystal_array_7);
  mctc1 = coords_set(
#line 769 "MACS_sample_kidney_box.instr"
    0 + channel_1_analyzer_1_array_effective_radius_of_curvature * ( 1 - cos ( channel_1_analyzer_1_array_theta [ 7 ] ) ),
#line 769 "MACS_sample_kidney_box.instr"
    0 + channel_1_analyzer_1_array_effective_radius_of_curvature * sin ( channel_1_analyzer_1_array_theta [ 7 ] ),
#line 769 "MACS_sample_kidney_box.instr"
    0);
#line 99898 "MACS_sample_kidney_box.c"
  rot_transpose(mcrotachannel_1_analyzer_1_rotated, mctr1);
  mctc2 = rot_apply(mctr1, mctc1);
  mcposachannel_1_analyzer_1_array_crystal_array_7 = coords_add(mcposachannel_1_analyzer_1_rotated, mctc2);
  mctc1 = coords_sub(mcposachannel_1_analyzer_1_array_crystal_array_6, mcposachannel_1_analyzer_1_array_crystal_array_7);
  mcposrchannel_1_analyzer_1_array_crystal_array_7 = rot_apply(mcrotachannel_1_analyzer_1_array_crystal_array_7, mctc1);
  mcDEBUG_COMPONENT("channel_1_analyzer_1_array_crystal_array_7", mcposachannel_1_analyzer_1_array_crystal_array_7, mcrotachannel_1_analyzer_1_array_crystal_array_7)
  mccomp_posa[175] = mcposachannel_1_analyzer_1_array_crystal_array_7;
  mccomp_posr[175] = mcposrchannel_1_analyzer_1_array_crystal_array_7;
  mcNCounter[175]  = mcPCounter[175] = mcP2Counter[175] = 0;
  mcAbsorbProp[175]= 0;
    /* Component channel_1_analyzer_1_array_crystal_array_8. */
  /* Setting parameters for component channel_1_analyzer_1_array_crystal_array_8. */
  SIG_MESSAGE("channel_1_analyzer_1_array_crystal_array_8 (Init:SetPar)");
#line 774 "MACS_sample_kidney_box.instr"
  if("PG_analyzer") strncpy(mccchannel_1_analyzer_1_array_crystal_array_8_material_string, "PG_analyzer" ? "PG_analyzer" : "", 16384); else mccchannel_1_analyzer_1_array_crystal_array_8_material_string[0]='\0';
#line 774 "MACS_sample_kidney_box.instr"
  mccchannel_1_analyzer_1_array_crystal_array_8_priority = 320.8;
#line 773 "MACS_sample_kidney_box.instr"
  mccchannel_1_analyzer_1_array_crystal_array_8_xwidth = channel_1_analyzer_1_array_crystal_depth;
#line 773 "MACS_sample_kidney_box.instr"
  mccchannel_1_analyzer_1_array_crystal_array_8_yheight = channel_1_analyzer_1_array_crystal_height;
#line 773 "MACS_sample_kidney_box.instr"
  mccchannel_1_analyzer_1_array_crystal_array_8_zdepth = channel_1_analyzer_1_array_crystal_width;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_1_analyzer_1_array_crystal_array_8_xwidth2 = -1;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_1_analyzer_1_array_crystal_array_8_yheight2 = -1;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_1_analyzer_1_array_crystal_array_8_visualize = 1;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_1_analyzer_1_array_crystal_array_8_target_index = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_1_analyzer_1_array_crystal_array_8_target_x = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_1_analyzer_1_array_crystal_array_8_target_y = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_1_analyzer_1_array_crystal_array_8_target_z = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_1_analyzer_1_array_crystal_array_8_focus_aw = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_1_analyzer_1_array_crystal_array_8_focus_ah = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_1_analyzer_1_array_crystal_array_8_focus_xw = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_1_analyzer_1_array_crystal_array_8_focus_xh = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_1_analyzer_1_array_crystal_array_8_focus_r = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_1_analyzer_1_array_crystal_array_8_p_interact = 0;
#line 71 "MACS_sample_kidney_box.instr"
  if(0) strncpy(mccchannel_1_analyzer_1_array_crystal_array_8_mask_string, 0 ? 0 : "", 16384); else mccchannel_1_analyzer_1_array_crystal_array_8_mask_string[0]='\0';
#line 71 "MACS_sample_kidney_box.instr"
  if(0) strncpy(mccchannel_1_analyzer_1_array_crystal_array_8_mask_setting, 0 ? 0 : "", 16384); else mccchannel_1_analyzer_1_array_crystal_array_8_mask_setting[0]='\0';
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_1_analyzer_1_array_crystal_array_8_number_of_activations = 1;
#line 99954 "MACS_sample_kidney_box.c"

  SIG_MESSAGE("channel_1_analyzer_1_array_crystal_array_8 (Init:Place/Rotate)");
  rot_set_rotation(mctr1,
#line 776 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 776 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 776 "MACS_sample_kidney_box.instr"
    (0 - RAD2DEG * channel_1_analyzer_1_array_theta [ 8 ])*DEG2RAD);
#line 99964 "MACS_sample_kidney_box.c"
  rot_mul(mctr1, mcrotachannel_1_analyzer_1_rotated, mcrotachannel_1_analyzer_1_array_crystal_array_8);
  rot_transpose(mcrotachannel_1_analyzer_1_array_crystal_array_7, mctr1);
  rot_mul(mcrotachannel_1_analyzer_1_array_crystal_array_8, mctr1, mcrotrchannel_1_analyzer_1_array_crystal_array_8);
  mctc1 = coords_set(
#line 775 "MACS_sample_kidney_box.instr"
    0 + channel_1_analyzer_1_array_effective_radius_of_curvature * ( 1 - cos ( channel_1_analyzer_1_array_theta [ 8 ] ) ),
#line 775 "MACS_sample_kidney_box.instr"
    0 + channel_1_analyzer_1_array_effective_radius_of_curvature * sin ( channel_1_analyzer_1_array_theta [ 8 ] ),
#line 775 "MACS_sample_kidney_box.instr"
    0);
#line 99975 "MACS_sample_kidney_box.c"
  rot_transpose(mcrotachannel_1_analyzer_1_rotated, mctr1);
  mctc2 = rot_apply(mctr1, mctc1);
  mcposachannel_1_analyzer_1_array_crystal_array_8 = coords_add(mcposachannel_1_analyzer_1_rotated, mctc2);
  mctc1 = coords_sub(mcposachannel_1_analyzer_1_array_crystal_array_7, mcposachannel_1_analyzer_1_array_crystal_array_8);
  mcposrchannel_1_analyzer_1_array_crystal_array_8 = rot_apply(mcrotachannel_1_analyzer_1_array_crystal_array_8, mctc1);
  mcDEBUG_COMPONENT("channel_1_analyzer_1_array_crystal_array_8", mcposachannel_1_analyzer_1_array_crystal_array_8, mcrotachannel_1_analyzer_1_array_crystal_array_8)
  mccomp_posa[176] = mcposachannel_1_analyzer_1_array_crystal_array_8;
  mccomp_posr[176] = mcposrchannel_1_analyzer_1_array_crystal_array_8;
  mcNCounter[176]  = mcPCounter[176] = mcP2Counter[176] = 0;
  mcAbsorbProp[176]= 0;
    /* Component channel_1_analyzer_2_center. */
  /* Setting parameters for component channel_1_analyzer_2_center. */
  SIG_MESSAGE("channel_1_analyzer_2_center (Init:SetPar)");

  SIG_MESSAGE("channel_1_analyzer_2_center (Init:Place/Rotate)");
  rot_set_rotation(mctr1,
    (0.0)*DEG2RAD,
    (0.0)*DEG2RAD,
    (0.0)*DEG2RAD);
#line 99995 "MACS_sample_kidney_box.c"
  rot_mul(mctr1, mcrotachannel_1_analyzer_1_center, mcrotachannel_1_analyzer_2_center);
  rot_transpose(mcrotachannel_1_analyzer_1_array_crystal_array_8, mctr1);
  rot_mul(mcrotachannel_1_analyzer_2_center, mctr1, mcrotrchannel_1_analyzer_2_center);
  mctc1 = coords_set(
#line 780 "MACS_sample_kidney_box.instr"
    - analyzer_seperation,
#line 780 "MACS_sample_kidney_box.instr"
    0,
#line 780 "MACS_sample_kidney_box.instr"
    0);
#line 100006 "MACS_sample_kidney_box.c"
  rot_transpose(mcrotachannel_1_analyzer_1_center, mctr1);
  mctc2 = rot_apply(mctr1, mctc1);
  mcposachannel_1_analyzer_2_center = coords_add(mcposachannel_1_analyzer_1_center, mctc2);
  mctc1 = coords_sub(mcposachannel_1_analyzer_1_array_crystal_array_8, mcposachannel_1_analyzer_2_center);
  mcposrchannel_1_analyzer_2_center = rot_apply(mcrotachannel_1_analyzer_2_center, mctc1);
  mcDEBUG_COMPONENT("channel_1_analyzer_2_center", mcposachannel_1_analyzer_2_center, mcrotachannel_1_analyzer_2_center)
  mccomp_posa[177] = mcposachannel_1_analyzer_2_center;
  mccomp_posr[177] = mcposrchannel_1_analyzer_2_center;
  mcNCounter[177]  = mcPCounter[177] = mcP2Counter[177] = 0;
  mcAbsorbProp[177]= 0;
    /* Component channel_1_analyzer_2_rotated. */
  /* Setting parameters for component channel_1_analyzer_2_rotated. */
  SIG_MESSAGE("channel_1_analyzer_2_rotated (Init:SetPar)");

  SIG_MESSAGE("channel_1_analyzer_2_rotated (Init:Place/Rotate)");
  rot_set_rotation(mctr1,
#line 784 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 784 "MACS_sample_kidney_box.instr"
    (- analyzer_theta [ 1 ])*DEG2RAD,
#line 784 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD);
#line 100029 "MACS_sample_kidney_box.c"
  rot_mul(mctr1, mcrotachannel_1_analyzer_2_center, mcrotachannel_1_analyzer_2_rotated);
  rot_transpose(mcrotachannel_1_analyzer_2_center, mctr1);
  rot_mul(mcrotachannel_1_analyzer_2_rotated, mctr1, mcrotrchannel_1_analyzer_2_rotated);
  mctc1 = coords_set(
#line 783 "MACS_sample_kidney_box.instr"
    0,
#line 783 "MACS_sample_kidney_box.instr"
    0,
#line 783 "MACS_sample_kidney_box.instr"
    0.5 * analyzer_seperation / tan ( analyzer_2theta [ 1 ] * DEG2RAD ));
#line 100040 "MACS_sample_kidney_box.c"
  rot_transpose(mcrotachannel_1_analyzer_2_center, mctr1);
  mctc2 = rot_apply(mctr1, mctc1);
  mcposachannel_1_analyzer_2_rotated = coords_add(mcposachannel_1_analyzer_2_center, mctc2);
  mctc1 = coords_sub(mcposachannel_1_analyzer_2_center, mcposachannel_1_analyzer_2_rotated);
  mcposrchannel_1_analyzer_2_rotated = rot_apply(mcrotachannel_1_analyzer_2_rotated, mctc1);
  mcDEBUG_COMPONENT("channel_1_analyzer_2_rotated", mcposachannel_1_analyzer_2_rotated, mcrotachannel_1_analyzer_2_rotated)
  mccomp_posa[178] = mcposachannel_1_analyzer_2_rotated;
  mccomp_posr[178] = mcposrchannel_1_analyzer_2_rotated;
  mcNCounter[178]  = mcPCounter[178] = mcP2Counter[178] = 0;
  mcAbsorbProp[178]= 0;
    /* Component channel_1_analyzer_2_array_crystal_array_0. */
  /* Setting parameters for component channel_1_analyzer_2_array_crystal_array_0. */
  SIG_MESSAGE("channel_1_analyzer_2_array_crystal_array_0 (Init:SetPar)");
#line 788 "MACS_sample_kidney_box.instr"
  if("PG_analyzer") strncpy(mccchannel_1_analyzer_2_array_crystal_array_0_material_string, "PG_analyzer" ? "PG_analyzer" : "", 16384); else mccchannel_1_analyzer_2_array_crystal_array_0_material_string[0]='\0';
#line 788 "MACS_sample_kidney_box.instr"
  mccchannel_1_analyzer_2_array_crystal_array_0_priority = 321.0;
#line 787 "MACS_sample_kidney_box.instr"
  mccchannel_1_analyzer_2_array_crystal_array_0_xwidth = channel_1_analyzer_2_array_crystal_depth;
#line 787 "MACS_sample_kidney_box.instr"
  mccchannel_1_analyzer_2_array_crystal_array_0_yheight = channel_1_analyzer_2_array_crystal_height;
#line 787 "MACS_sample_kidney_box.instr"
  mccchannel_1_analyzer_2_array_crystal_array_0_zdepth = channel_1_analyzer_2_array_crystal_width;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_1_analyzer_2_array_crystal_array_0_xwidth2 = -1;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_1_analyzer_2_array_crystal_array_0_yheight2 = -1;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_1_analyzer_2_array_crystal_array_0_visualize = 1;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_1_analyzer_2_array_crystal_array_0_target_index = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_1_analyzer_2_array_crystal_array_0_target_x = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_1_analyzer_2_array_crystal_array_0_target_y = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_1_analyzer_2_array_crystal_array_0_target_z = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_1_analyzer_2_array_crystal_array_0_focus_aw = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_1_analyzer_2_array_crystal_array_0_focus_ah = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_1_analyzer_2_array_crystal_array_0_focus_xw = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_1_analyzer_2_array_crystal_array_0_focus_xh = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_1_analyzer_2_array_crystal_array_0_focus_r = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_1_analyzer_2_array_crystal_array_0_p_interact = 0;
#line 71 "MACS_sample_kidney_box.instr"
  if(0) strncpy(mccchannel_1_analyzer_2_array_crystal_array_0_mask_string, 0 ? 0 : "", 16384); else mccchannel_1_analyzer_2_array_crystal_array_0_mask_string[0]='\0';
#line 71 "MACS_sample_kidney_box.instr"
  if(0) strncpy(mccchannel_1_analyzer_2_array_crystal_array_0_mask_setting, 0 ? 0 : "", 16384); else mccchannel_1_analyzer_2_array_crystal_array_0_mask_setting[0]='\0';
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_1_analyzer_2_array_crystal_array_0_number_of_activations = 1;
#line 100096 "MACS_sample_kidney_box.c"

  SIG_MESSAGE("channel_1_analyzer_2_array_crystal_array_0 (Init:Place/Rotate)");
  rot_set_rotation(mctr1,
#line 790 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 790 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 790 "MACS_sample_kidney_box.instr"
    (0 - RAD2DEG * channel_1_analyzer_2_array_theta [ 0 ])*DEG2RAD);
#line 100106 "MACS_sample_kidney_box.c"
  rot_mul(mctr1, mcrotachannel_1_analyzer_2_rotated, mcrotachannel_1_analyzer_2_array_crystal_array_0);
  rot_transpose(mcrotachannel_1_analyzer_2_rotated, mctr1);
  rot_mul(mcrotachannel_1_analyzer_2_array_crystal_array_0, mctr1, mcrotrchannel_1_analyzer_2_array_crystal_array_0);
  mctc1 = coords_set(
#line 789 "MACS_sample_kidney_box.instr"
    0 + channel_1_analyzer_2_array_effective_radius_of_curvature * ( 1 - cos ( channel_1_analyzer_2_array_theta [ 0 ] ) ),
#line 789 "MACS_sample_kidney_box.instr"
    0 + channel_1_analyzer_2_array_effective_radius_of_curvature * sin ( channel_1_analyzer_2_array_theta [ 0 ] ),
#line 789 "MACS_sample_kidney_box.instr"
    0);
#line 100117 "MACS_sample_kidney_box.c"
  rot_transpose(mcrotachannel_1_analyzer_2_rotated, mctr1);
  mctc2 = rot_apply(mctr1, mctc1);
  mcposachannel_1_analyzer_2_array_crystal_array_0 = coords_add(mcposachannel_1_analyzer_2_rotated, mctc2);
  mctc1 = coords_sub(mcposachannel_1_analyzer_2_rotated, mcposachannel_1_analyzer_2_array_crystal_array_0);
  mcposrchannel_1_analyzer_2_array_crystal_array_0 = rot_apply(mcrotachannel_1_analyzer_2_array_crystal_array_0, mctc1);
  mcDEBUG_COMPONENT("channel_1_analyzer_2_array_crystal_array_0", mcposachannel_1_analyzer_2_array_crystal_array_0, mcrotachannel_1_analyzer_2_array_crystal_array_0)
  mccomp_posa[179] = mcposachannel_1_analyzer_2_array_crystal_array_0;
  mccomp_posr[179] = mcposrchannel_1_analyzer_2_array_crystal_array_0;
  mcNCounter[179]  = mcPCounter[179] = mcP2Counter[179] = 0;
  mcAbsorbProp[179]= 0;
    /* Component channel_1_analyzer_2_array_crystal_array_1. */
  /* Setting parameters for component channel_1_analyzer_2_array_crystal_array_1. */
  SIG_MESSAGE("channel_1_analyzer_2_array_crystal_array_1 (Init:SetPar)");
#line 794 "MACS_sample_kidney_box.instr"
  if("PG_analyzer") strncpy(mccchannel_1_analyzer_2_array_crystal_array_1_material_string, "PG_analyzer" ? "PG_analyzer" : "", 16384); else mccchannel_1_analyzer_2_array_crystal_array_1_material_string[0]='\0';
#line 794 "MACS_sample_kidney_box.instr"
  mccchannel_1_analyzer_2_array_crystal_array_1_priority = 321.1;
#line 793 "MACS_sample_kidney_box.instr"
  mccchannel_1_analyzer_2_array_crystal_array_1_xwidth = channel_1_analyzer_2_array_crystal_depth;
#line 793 "MACS_sample_kidney_box.instr"
  mccchannel_1_analyzer_2_array_crystal_array_1_yheight = channel_1_analyzer_2_array_crystal_height;
#line 793 "MACS_sample_kidney_box.instr"
  mccchannel_1_analyzer_2_array_crystal_array_1_zdepth = channel_1_analyzer_2_array_crystal_width;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_1_analyzer_2_array_crystal_array_1_xwidth2 = -1;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_1_analyzer_2_array_crystal_array_1_yheight2 = -1;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_1_analyzer_2_array_crystal_array_1_visualize = 1;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_1_analyzer_2_array_crystal_array_1_target_index = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_1_analyzer_2_array_crystal_array_1_target_x = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_1_analyzer_2_array_crystal_array_1_target_y = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_1_analyzer_2_array_crystal_array_1_target_z = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_1_analyzer_2_array_crystal_array_1_focus_aw = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_1_analyzer_2_array_crystal_array_1_focus_ah = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_1_analyzer_2_array_crystal_array_1_focus_xw = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_1_analyzer_2_array_crystal_array_1_focus_xh = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_1_analyzer_2_array_crystal_array_1_focus_r = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_1_analyzer_2_array_crystal_array_1_p_interact = 0;
#line 71 "MACS_sample_kidney_box.instr"
  if(0) strncpy(mccchannel_1_analyzer_2_array_crystal_array_1_mask_string, 0 ? 0 : "", 16384); else mccchannel_1_analyzer_2_array_crystal_array_1_mask_string[0]='\0';
#line 71 "MACS_sample_kidney_box.instr"
  if(0) strncpy(mccchannel_1_analyzer_2_array_crystal_array_1_mask_setting, 0 ? 0 : "", 16384); else mccchannel_1_analyzer_2_array_crystal_array_1_mask_setting[0]='\0';
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_1_analyzer_2_array_crystal_array_1_number_of_activations = 1;
#line 100173 "MACS_sample_kidney_box.c"

  SIG_MESSAGE("channel_1_analyzer_2_array_crystal_array_1 (Init:Place/Rotate)");
  rot_set_rotation(mctr1,
#line 796 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 796 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 796 "MACS_sample_kidney_box.instr"
    (0 - RAD2DEG * channel_1_analyzer_2_array_theta [ 1 ])*DEG2RAD);
#line 100183 "MACS_sample_kidney_box.c"
  rot_mul(mctr1, mcrotachannel_1_analyzer_2_rotated, mcrotachannel_1_analyzer_2_array_crystal_array_1);
  rot_transpose(mcrotachannel_1_analyzer_2_array_crystal_array_0, mctr1);
  rot_mul(mcrotachannel_1_analyzer_2_array_crystal_array_1, mctr1, mcrotrchannel_1_analyzer_2_array_crystal_array_1);
  mctc1 = coords_set(
#line 795 "MACS_sample_kidney_box.instr"
    0 + channel_1_analyzer_2_array_effective_radius_of_curvature * ( 1 - cos ( channel_1_analyzer_2_array_theta [ 1 ] ) ),
#line 795 "MACS_sample_kidney_box.instr"
    0 + channel_1_analyzer_2_array_effective_radius_of_curvature * sin ( channel_1_analyzer_2_array_theta [ 1 ] ),
#line 795 "MACS_sample_kidney_box.instr"
    0);
#line 100194 "MACS_sample_kidney_box.c"
  rot_transpose(mcrotachannel_1_analyzer_2_rotated, mctr1);
  mctc2 = rot_apply(mctr1, mctc1);
  mcposachannel_1_analyzer_2_array_crystal_array_1 = coords_add(mcposachannel_1_analyzer_2_rotated, mctc2);
  mctc1 = coords_sub(mcposachannel_1_analyzer_2_array_crystal_array_0, mcposachannel_1_analyzer_2_array_crystal_array_1);
  mcposrchannel_1_analyzer_2_array_crystal_array_1 = rot_apply(mcrotachannel_1_analyzer_2_array_crystal_array_1, mctc1);
  mcDEBUG_COMPONENT("channel_1_analyzer_2_array_crystal_array_1", mcposachannel_1_analyzer_2_array_crystal_array_1, mcrotachannel_1_analyzer_2_array_crystal_array_1)
  mccomp_posa[180] = mcposachannel_1_analyzer_2_array_crystal_array_1;
  mccomp_posr[180] = mcposrchannel_1_analyzer_2_array_crystal_array_1;
  mcNCounter[180]  = mcPCounter[180] = mcP2Counter[180] = 0;
  mcAbsorbProp[180]= 0;
    /* Component channel_1_analyzer_2_array_crystal_array_2. */
  /* Setting parameters for component channel_1_analyzer_2_array_crystal_array_2. */
  SIG_MESSAGE("channel_1_analyzer_2_array_crystal_array_2 (Init:SetPar)");
#line 800 "MACS_sample_kidney_box.instr"
  if("PG_analyzer") strncpy(mccchannel_1_analyzer_2_array_crystal_array_2_material_string, "PG_analyzer" ? "PG_analyzer" : "", 16384); else mccchannel_1_analyzer_2_array_crystal_array_2_material_string[0]='\0';
#line 800 "MACS_sample_kidney_box.instr"
  mccchannel_1_analyzer_2_array_crystal_array_2_priority = 321.2;
#line 799 "MACS_sample_kidney_box.instr"
  mccchannel_1_analyzer_2_array_crystal_array_2_xwidth = channel_1_analyzer_2_array_crystal_depth;
#line 799 "MACS_sample_kidney_box.instr"
  mccchannel_1_analyzer_2_array_crystal_array_2_yheight = channel_1_analyzer_2_array_crystal_height;
#line 799 "MACS_sample_kidney_box.instr"
  mccchannel_1_analyzer_2_array_crystal_array_2_zdepth = channel_1_analyzer_2_array_crystal_width;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_1_analyzer_2_array_crystal_array_2_xwidth2 = -1;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_1_analyzer_2_array_crystal_array_2_yheight2 = -1;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_1_analyzer_2_array_crystal_array_2_visualize = 1;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_1_analyzer_2_array_crystal_array_2_target_index = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_1_analyzer_2_array_crystal_array_2_target_x = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_1_analyzer_2_array_crystal_array_2_target_y = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_1_analyzer_2_array_crystal_array_2_target_z = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_1_analyzer_2_array_crystal_array_2_focus_aw = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_1_analyzer_2_array_crystal_array_2_focus_ah = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_1_analyzer_2_array_crystal_array_2_focus_xw = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_1_analyzer_2_array_crystal_array_2_focus_xh = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_1_analyzer_2_array_crystal_array_2_focus_r = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_1_analyzer_2_array_crystal_array_2_p_interact = 0;
#line 71 "MACS_sample_kidney_box.instr"
  if(0) strncpy(mccchannel_1_analyzer_2_array_crystal_array_2_mask_string, 0 ? 0 : "", 16384); else mccchannel_1_analyzer_2_array_crystal_array_2_mask_string[0]='\0';
#line 71 "MACS_sample_kidney_box.instr"
  if(0) strncpy(mccchannel_1_analyzer_2_array_crystal_array_2_mask_setting, 0 ? 0 : "", 16384); else mccchannel_1_analyzer_2_array_crystal_array_2_mask_setting[0]='\0';
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_1_analyzer_2_array_crystal_array_2_number_of_activations = 1;
#line 100250 "MACS_sample_kidney_box.c"

  SIG_MESSAGE("channel_1_analyzer_2_array_crystal_array_2 (Init:Place/Rotate)");
  rot_set_rotation(mctr1,
#line 802 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 802 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 802 "MACS_sample_kidney_box.instr"
    (0 - RAD2DEG * channel_1_analyzer_2_array_theta [ 2 ])*DEG2RAD);
#line 100260 "MACS_sample_kidney_box.c"
  rot_mul(mctr1, mcrotachannel_1_analyzer_2_rotated, mcrotachannel_1_analyzer_2_array_crystal_array_2);
  rot_transpose(mcrotachannel_1_analyzer_2_array_crystal_array_1, mctr1);
  rot_mul(mcrotachannel_1_analyzer_2_array_crystal_array_2, mctr1, mcrotrchannel_1_analyzer_2_array_crystal_array_2);
  mctc1 = coords_set(
#line 801 "MACS_sample_kidney_box.instr"
    0 + channel_1_analyzer_2_array_effective_radius_of_curvature * ( 1 - cos ( channel_1_analyzer_2_array_theta [ 2 ] ) ),
#line 801 "MACS_sample_kidney_box.instr"
    0 + channel_1_analyzer_2_array_effective_radius_of_curvature * sin ( channel_1_analyzer_2_array_theta [ 2 ] ),
#line 801 "MACS_sample_kidney_box.instr"
    0);
#line 100271 "MACS_sample_kidney_box.c"
  rot_transpose(mcrotachannel_1_analyzer_2_rotated, mctr1);
  mctc2 = rot_apply(mctr1, mctc1);
  mcposachannel_1_analyzer_2_array_crystal_array_2 = coords_add(mcposachannel_1_analyzer_2_rotated, mctc2);
  mctc1 = coords_sub(mcposachannel_1_analyzer_2_array_crystal_array_1, mcposachannel_1_analyzer_2_array_crystal_array_2);
  mcposrchannel_1_analyzer_2_array_crystal_array_2 = rot_apply(mcrotachannel_1_analyzer_2_array_crystal_array_2, mctc1);
  mcDEBUG_COMPONENT("channel_1_analyzer_2_array_crystal_array_2", mcposachannel_1_analyzer_2_array_crystal_array_2, mcrotachannel_1_analyzer_2_array_crystal_array_2)
  mccomp_posa[181] = mcposachannel_1_analyzer_2_array_crystal_array_2;
  mccomp_posr[181] = mcposrchannel_1_analyzer_2_array_crystal_array_2;
  mcNCounter[181]  = mcPCounter[181] = mcP2Counter[181] = 0;
  mcAbsorbProp[181]= 0;
    /* Component channel_1_analyzer_2_array_crystal_array_3. */
  /* Setting parameters for component channel_1_analyzer_2_array_crystal_array_3. */
  SIG_MESSAGE("channel_1_analyzer_2_array_crystal_array_3 (Init:SetPar)");
#line 806 "MACS_sample_kidney_box.instr"
  if("PG_analyzer") strncpy(mccchannel_1_analyzer_2_array_crystal_array_3_material_string, "PG_analyzer" ? "PG_analyzer" : "", 16384); else mccchannel_1_analyzer_2_array_crystal_array_3_material_string[0]='\0';
#line 806 "MACS_sample_kidney_box.instr"
  mccchannel_1_analyzer_2_array_crystal_array_3_priority = 321.3;
#line 805 "MACS_sample_kidney_box.instr"
  mccchannel_1_analyzer_2_array_crystal_array_3_xwidth = channel_1_analyzer_2_array_crystal_depth;
#line 805 "MACS_sample_kidney_box.instr"
  mccchannel_1_analyzer_2_array_crystal_array_3_yheight = channel_1_analyzer_2_array_crystal_height;
#line 805 "MACS_sample_kidney_box.instr"
  mccchannel_1_analyzer_2_array_crystal_array_3_zdepth = channel_1_analyzer_2_array_crystal_width;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_1_analyzer_2_array_crystal_array_3_xwidth2 = -1;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_1_analyzer_2_array_crystal_array_3_yheight2 = -1;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_1_analyzer_2_array_crystal_array_3_visualize = 1;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_1_analyzer_2_array_crystal_array_3_target_index = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_1_analyzer_2_array_crystal_array_3_target_x = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_1_analyzer_2_array_crystal_array_3_target_y = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_1_analyzer_2_array_crystal_array_3_target_z = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_1_analyzer_2_array_crystal_array_3_focus_aw = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_1_analyzer_2_array_crystal_array_3_focus_ah = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_1_analyzer_2_array_crystal_array_3_focus_xw = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_1_analyzer_2_array_crystal_array_3_focus_xh = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_1_analyzer_2_array_crystal_array_3_focus_r = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_1_analyzer_2_array_crystal_array_3_p_interact = 0;
#line 71 "MACS_sample_kidney_box.instr"
  if(0) strncpy(mccchannel_1_analyzer_2_array_crystal_array_3_mask_string, 0 ? 0 : "", 16384); else mccchannel_1_analyzer_2_array_crystal_array_3_mask_string[0]='\0';
#line 71 "MACS_sample_kidney_box.instr"
  if(0) strncpy(mccchannel_1_analyzer_2_array_crystal_array_3_mask_setting, 0 ? 0 : "", 16384); else mccchannel_1_analyzer_2_array_crystal_array_3_mask_setting[0]='\0';
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_1_analyzer_2_array_crystal_array_3_number_of_activations = 1;
#line 100327 "MACS_sample_kidney_box.c"

  SIG_MESSAGE("channel_1_analyzer_2_array_crystal_array_3 (Init:Place/Rotate)");
  rot_set_rotation(mctr1,
#line 808 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 808 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 808 "MACS_sample_kidney_box.instr"
    (0 - RAD2DEG * channel_1_analyzer_2_array_theta [ 3 ])*DEG2RAD);
#line 100337 "MACS_sample_kidney_box.c"
  rot_mul(mctr1, mcrotachannel_1_analyzer_2_rotated, mcrotachannel_1_analyzer_2_array_crystal_array_3);
  rot_transpose(mcrotachannel_1_analyzer_2_array_crystal_array_2, mctr1);
  rot_mul(mcrotachannel_1_analyzer_2_array_crystal_array_3, mctr1, mcrotrchannel_1_analyzer_2_array_crystal_array_3);
  mctc1 = coords_set(
#line 807 "MACS_sample_kidney_box.instr"
    0 + channel_1_analyzer_2_array_effective_radius_of_curvature * ( 1 - cos ( channel_1_analyzer_2_array_theta [ 3 ] ) ),
#line 807 "MACS_sample_kidney_box.instr"
    0 + channel_1_analyzer_2_array_effective_radius_of_curvature * sin ( channel_1_analyzer_2_array_theta [ 3 ] ),
#line 807 "MACS_sample_kidney_box.instr"
    0);
#line 100348 "MACS_sample_kidney_box.c"
  rot_transpose(mcrotachannel_1_analyzer_2_rotated, mctr1);
  mctc2 = rot_apply(mctr1, mctc1);
  mcposachannel_1_analyzer_2_array_crystal_array_3 = coords_add(mcposachannel_1_analyzer_2_rotated, mctc2);
  mctc1 = coords_sub(mcposachannel_1_analyzer_2_array_crystal_array_2, mcposachannel_1_analyzer_2_array_crystal_array_3);
  mcposrchannel_1_analyzer_2_array_crystal_array_3 = rot_apply(mcrotachannel_1_analyzer_2_array_crystal_array_3, mctc1);
  mcDEBUG_COMPONENT("channel_1_analyzer_2_array_crystal_array_3", mcposachannel_1_analyzer_2_array_crystal_array_3, mcrotachannel_1_analyzer_2_array_crystal_array_3)
  mccomp_posa[182] = mcposachannel_1_analyzer_2_array_crystal_array_3;
  mccomp_posr[182] = mcposrchannel_1_analyzer_2_array_crystal_array_3;
  mcNCounter[182]  = mcPCounter[182] = mcP2Counter[182] = 0;
  mcAbsorbProp[182]= 0;
    /* Component channel_1_analyzer_2_array_crystal_array_4. */
  /* Setting parameters for component channel_1_analyzer_2_array_crystal_array_4. */
  SIG_MESSAGE("channel_1_analyzer_2_array_crystal_array_4 (Init:SetPar)");
#line 812 "MACS_sample_kidney_box.instr"
  if("PG_analyzer") strncpy(mccchannel_1_analyzer_2_array_crystal_array_4_material_string, "PG_analyzer" ? "PG_analyzer" : "", 16384); else mccchannel_1_analyzer_2_array_crystal_array_4_material_string[0]='\0';
#line 812 "MACS_sample_kidney_box.instr"
  mccchannel_1_analyzer_2_array_crystal_array_4_priority = 321.4;
#line 811 "MACS_sample_kidney_box.instr"
  mccchannel_1_analyzer_2_array_crystal_array_4_xwidth = channel_1_analyzer_2_array_crystal_depth;
#line 811 "MACS_sample_kidney_box.instr"
  mccchannel_1_analyzer_2_array_crystal_array_4_yheight = channel_1_analyzer_2_array_crystal_height;
#line 811 "MACS_sample_kidney_box.instr"
  mccchannel_1_analyzer_2_array_crystal_array_4_zdepth = channel_1_analyzer_2_array_crystal_width;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_1_analyzer_2_array_crystal_array_4_xwidth2 = -1;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_1_analyzer_2_array_crystal_array_4_yheight2 = -1;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_1_analyzer_2_array_crystal_array_4_visualize = 1;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_1_analyzer_2_array_crystal_array_4_target_index = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_1_analyzer_2_array_crystal_array_4_target_x = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_1_analyzer_2_array_crystal_array_4_target_y = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_1_analyzer_2_array_crystal_array_4_target_z = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_1_analyzer_2_array_crystal_array_4_focus_aw = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_1_analyzer_2_array_crystal_array_4_focus_ah = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_1_analyzer_2_array_crystal_array_4_focus_xw = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_1_analyzer_2_array_crystal_array_4_focus_xh = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_1_analyzer_2_array_crystal_array_4_focus_r = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_1_analyzer_2_array_crystal_array_4_p_interact = 0;
#line 71 "MACS_sample_kidney_box.instr"
  if(0) strncpy(mccchannel_1_analyzer_2_array_crystal_array_4_mask_string, 0 ? 0 : "", 16384); else mccchannel_1_analyzer_2_array_crystal_array_4_mask_string[0]='\0';
#line 71 "MACS_sample_kidney_box.instr"
  if(0) strncpy(mccchannel_1_analyzer_2_array_crystal_array_4_mask_setting, 0 ? 0 : "", 16384); else mccchannel_1_analyzer_2_array_crystal_array_4_mask_setting[0]='\0';
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_1_analyzer_2_array_crystal_array_4_number_of_activations = 1;
#line 100404 "MACS_sample_kidney_box.c"

  SIG_MESSAGE("channel_1_analyzer_2_array_crystal_array_4 (Init:Place/Rotate)");
  rot_set_rotation(mctr1,
#line 814 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 814 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 814 "MACS_sample_kidney_box.instr"
    (0 - RAD2DEG * channel_1_analyzer_2_array_theta [ 4 ])*DEG2RAD);
#line 100414 "MACS_sample_kidney_box.c"
  rot_mul(mctr1, mcrotachannel_1_analyzer_2_rotated, mcrotachannel_1_analyzer_2_array_crystal_array_4);
  rot_transpose(mcrotachannel_1_analyzer_2_array_crystal_array_3, mctr1);
  rot_mul(mcrotachannel_1_analyzer_2_array_crystal_array_4, mctr1, mcrotrchannel_1_analyzer_2_array_crystal_array_4);
  mctc1 = coords_set(
#line 813 "MACS_sample_kidney_box.instr"
    0 + channel_1_analyzer_2_array_effective_radius_of_curvature * ( 1 - cos ( channel_1_analyzer_2_array_theta [ 4 ] ) ),
#line 813 "MACS_sample_kidney_box.instr"
    0 + channel_1_analyzer_2_array_effective_radius_of_curvature * sin ( channel_1_analyzer_2_array_theta [ 4 ] ),
#line 813 "MACS_sample_kidney_box.instr"
    0);
#line 100425 "MACS_sample_kidney_box.c"
  rot_transpose(mcrotachannel_1_analyzer_2_rotated, mctr1);
  mctc2 = rot_apply(mctr1, mctc1);
  mcposachannel_1_analyzer_2_array_crystal_array_4 = coords_add(mcposachannel_1_analyzer_2_rotated, mctc2);
  mctc1 = coords_sub(mcposachannel_1_analyzer_2_array_crystal_array_3, mcposachannel_1_analyzer_2_array_crystal_array_4);
  mcposrchannel_1_analyzer_2_array_crystal_array_4 = rot_apply(mcrotachannel_1_analyzer_2_array_crystal_array_4, mctc1);
  mcDEBUG_COMPONENT("channel_1_analyzer_2_array_crystal_array_4", mcposachannel_1_analyzer_2_array_crystal_array_4, mcrotachannel_1_analyzer_2_array_crystal_array_4)
  mccomp_posa[183] = mcposachannel_1_analyzer_2_array_crystal_array_4;
  mccomp_posr[183] = mcposrchannel_1_analyzer_2_array_crystal_array_4;
  mcNCounter[183]  = mcPCounter[183] = mcP2Counter[183] = 0;
  mcAbsorbProp[183]= 0;
    /* Component channel_1_analyzer_2_array_crystal_array_5. */
  /* Setting parameters for component channel_1_analyzer_2_array_crystal_array_5. */
  SIG_MESSAGE("channel_1_analyzer_2_array_crystal_array_5 (Init:SetPar)");
#line 818 "MACS_sample_kidney_box.instr"
  if("PG_analyzer") strncpy(mccchannel_1_analyzer_2_array_crystal_array_5_material_string, "PG_analyzer" ? "PG_analyzer" : "", 16384); else mccchannel_1_analyzer_2_array_crystal_array_5_material_string[0]='\0';
#line 818 "MACS_sample_kidney_box.instr"
  mccchannel_1_analyzer_2_array_crystal_array_5_priority = 321.5;
#line 817 "MACS_sample_kidney_box.instr"
  mccchannel_1_analyzer_2_array_crystal_array_5_xwidth = channel_1_analyzer_2_array_crystal_depth;
#line 817 "MACS_sample_kidney_box.instr"
  mccchannel_1_analyzer_2_array_crystal_array_5_yheight = channel_1_analyzer_2_array_crystal_height;
#line 817 "MACS_sample_kidney_box.instr"
  mccchannel_1_analyzer_2_array_crystal_array_5_zdepth = channel_1_analyzer_2_array_crystal_width;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_1_analyzer_2_array_crystal_array_5_xwidth2 = -1;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_1_analyzer_2_array_crystal_array_5_yheight2 = -1;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_1_analyzer_2_array_crystal_array_5_visualize = 1;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_1_analyzer_2_array_crystal_array_5_target_index = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_1_analyzer_2_array_crystal_array_5_target_x = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_1_analyzer_2_array_crystal_array_5_target_y = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_1_analyzer_2_array_crystal_array_5_target_z = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_1_analyzer_2_array_crystal_array_5_focus_aw = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_1_analyzer_2_array_crystal_array_5_focus_ah = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_1_analyzer_2_array_crystal_array_5_focus_xw = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_1_analyzer_2_array_crystal_array_5_focus_xh = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_1_analyzer_2_array_crystal_array_5_focus_r = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_1_analyzer_2_array_crystal_array_5_p_interact = 0;
#line 71 "MACS_sample_kidney_box.instr"
  if(0) strncpy(mccchannel_1_analyzer_2_array_crystal_array_5_mask_string, 0 ? 0 : "", 16384); else mccchannel_1_analyzer_2_array_crystal_array_5_mask_string[0]='\0';
#line 71 "MACS_sample_kidney_box.instr"
  if(0) strncpy(mccchannel_1_analyzer_2_array_crystal_array_5_mask_setting, 0 ? 0 : "", 16384); else mccchannel_1_analyzer_2_array_crystal_array_5_mask_setting[0]='\0';
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_1_analyzer_2_array_crystal_array_5_number_of_activations = 1;
#line 100481 "MACS_sample_kidney_box.c"

  SIG_MESSAGE("channel_1_analyzer_2_array_crystal_array_5 (Init:Place/Rotate)");
  rot_set_rotation(mctr1,
#line 820 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 820 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 820 "MACS_sample_kidney_box.instr"
    (0 - RAD2DEG * channel_1_analyzer_2_array_theta [ 5 ])*DEG2RAD);
#line 100491 "MACS_sample_kidney_box.c"
  rot_mul(mctr1, mcrotachannel_1_analyzer_2_rotated, mcrotachannel_1_analyzer_2_array_crystal_array_5);
  rot_transpose(mcrotachannel_1_analyzer_2_array_crystal_array_4, mctr1);
  rot_mul(mcrotachannel_1_analyzer_2_array_crystal_array_5, mctr1, mcrotrchannel_1_analyzer_2_array_crystal_array_5);
  mctc1 = coords_set(
#line 819 "MACS_sample_kidney_box.instr"
    0 + channel_1_analyzer_2_array_effective_radius_of_curvature * ( 1 - cos ( channel_1_analyzer_2_array_theta [ 5 ] ) ),
#line 819 "MACS_sample_kidney_box.instr"
    0 + channel_1_analyzer_2_array_effective_radius_of_curvature * sin ( channel_1_analyzer_2_array_theta [ 5 ] ),
#line 819 "MACS_sample_kidney_box.instr"
    0);
#line 100502 "MACS_sample_kidney_box.c"
  rot_transpose(mcrotachannel_1_analyzer_2_rotated, mctr1);
  mctc2 = rot_apply(mctr1, mctc1);
  mcposachannel_1_analyzer_2_array_crystal_array_5 = coords_add(mcposachannel_1_analyzer_2_rotated, mctc2);
  mctc1 = coords_sub(mcposachannel_1_analyzer_2_array_crystal_array_4, mcposachannel_1_analyzer_2_array_crystal_array_5);
  mcposrchannel_1_analyzer_2_array_crystal_array_5 = rot_apply(mcrotachannel_1_analyzer_2_array_crystal_array_5, mctc1);
  mcDEBUG_COMPONENT("channel_1_analyzer_2_array_crystal_array_5", mcposachannel_1_analyzer_2_array_crystal_array_5, mcrotachannel_1_analyzer_2_array_crystal_array_5)
  mccomp_posa[184] = mcposachannel_1_analyzer_2_array_crystal_array_5;
  mccomp_posr[184] = mcposrchannel_1_analyzer_2_array_crystal_array_5;
  mcNCounter[184]  = mcPCounter[184] = mcP2Counter[184] = 0;
  mcAbsorbProp[184]= 0;
    /* Component channel_1_analyzer_2_array_crystal_array_6. */
  /* Setting parameters for component channel_1_analyzer_2_array_crystal_array_6. */
  SIG_MESSAGE("channel_1_analyzer_2_array_crystal_array_6 (Init:SetPar)");
#line 824 "MACS_sample_kidney_box.instr"
  if("PG_analyzer") strncpy(mccchannel_1_analyzer_2_array_crystal_array_6_material_string, "PG_analyzer" ? "PG_analyzer" : "", 16384); else mccchannel_1_analyzer_2_array_crystal_array_6_material_string[0]='\0';
#line 824 "MACS_sample_kidney_box.instr"
  mccchannel_1_analyzer_2_array_crystal_array_6_priority = 321.6;
#line 823 "MACS_sample_kidney_box.instr"
  mccchannel_1_analyzer_2_array_crystal_array_6_xwidth = channel_1_analyzer_2_array_crystal_depth;
#line 823 "MACS_sample_kidney_box.instr"
  mccchannel_1_analyzer_2_array_crystal_array_6_yheight = channel_1_analyzer_2_array_crystal_height;
#line 823 "MACS_sample_kidney_box.instr"
  mccchannel_1_analyzer_2_array_crystal_array_6_zdepth = channel_1_analyzer_2_array_crystal_width;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_1_analyzer_2_array_crystal_array_6_xwidth2 = -1;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_1_analyzer_2_array_crystal_array_6_yheight2 = -1;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_1_analyzer_2_array_crystal_array_6_visualize = 1;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_1_analyzer_2_array_crystal_array_6_target_index = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_1_analyzer_2_array_crystal_array_6_target_x = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_1_analyzer_2_array_crystal_array_6_target_y = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_1_analyzer_2_array_crystal_array_6_target_z = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_1_analyzer_2_array_crystal_array_6_focus_aw = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_1_analyzer_2_array_crystal_array_6_focus_ah = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_1_analyzer_2_array_crystal_array_6_focus_xw = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_1_analyzer_2_array_crystal_array_6_focus_xh = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_1_analyzer_2_array_crystal_array_6_focus_r = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_1_analyzer_2_array_crystal_array_6_p_interact = 0;
#line 71 "MACS_sample_kidney_box.instr"
  if(0) strncpy(mccchannel_1_analyzer_2_array_crystal_array_6_mask_string, 0 ? 0 : "", 16384); else mccchannel_1_analyzer_2_array_crystal_array_6_mask_string[0]='\0';
#line 71 "MACS_sample_kidney_box.instr"
  if(0) strncpy(mccchannel_1_analyzer_2_array_crystal_array_6_mask_setting, 0 ? 0 : "", 16384); else mccchannel_1_analyzer_2_array_crystal_array_6_mask_setting[0]='\0';
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_1_analyzer_2_array_crystal_array_6_number_of_activations = 1;
#line 100558 "MACS_sample_kidney_box.c"

  SIG_MESSAGE("channel_1_analyzer_2_array_crystal_array_6 (Init:Place/Rotate)");
  rot_set_rotation(mctr1,
#line 826 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 826 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 826 "MACS_sample_kidney_box.instr"
    (0 - RAD2DEG * channel_1_analyzer_2_array_theta [ 6 ])*DEG2RAD);
#line 100568 "MACS_sample_kidney_box.c"
  rot_mul(mctr1, mcrotachannel_1_analyzer_2_rotated, mcrotachannel_1_analyzer_2_array_crystal_array_6);
  rot_transpose(mcrotachannel_1_analyzer_2_array_crystal_array_5, mctr1);
  rot_mul(mcrotachannel_1_analyzer_2_array_crystal_array_6, mctr1, mcrotrchannel_1_analyzer_2_array_crystal_array_6);
  mctc1 = coords_set(
#line 825 "MACS_sample_kidney_box.instr"
    0 + channel_1_analyzer_2_array_effective_radius_of_curvature * ( 1 - cos ( channel_1_analyzer_2_array_theta [ 6 ] ) ),
#line 825 "MACS_sample_kidney_box.instr"
    0 + channel_1_analyzer_2_array_effective_radius_of_curvature * sin ( channel_1_analyzer_2_array_theta [ 6 ] ),
#line 825 "MACS_sample_kidney_box.instr"
    0);
#line 100579 "MACS_sample_kidney_box.c"
  rot_transpose(mcrotachannel_1_analyzer_2_rotated, mctr1);
  mctc2 = rot_apply(mctr1, mctc1);
  mcposachannel_1_analyzer_2_array_crystal_array_6 = coords_add(mcposachannel_1_analyzer_2_rotated, mctc2);
  mctc1 = coords_sub(mcposachannel_1_analyzer_2_array_crystal_array_5, mcposachannel_1_analyzer_2_array_crystal_array_6);
  mcposrchannel_1_analyzer_2_array_crystal_array_6 = rot_apply(mcrotachannel_1_analyzer_2_array_crystal_array_6, mctc1);
  mcDEBUG_COMPONENT("channel_1_analyzer_2_array_crystal_array_6", mcposachannel_1_analyzer_2_array_crystal_array_6, mcrotachannel_1_analyzer_2_array_crystal_array_6)
  mccomp_posa[185] = mcposachannel_1_analyzer_2_array_crystal_array_6;
  mccomp_posr[185] = mcposrchannel_1_analyzer_2_array_crystal_array_6;
  mcNCounter[185]  = mcPCounter[185] = mcP2Counter[185] = 0;
  mcAbsorbProp[185]= 0;
    /* Component channel_1_analyzer_2_array_crystal_array_7. */
  /* Setting parameters for component channel_1_analyzer_2_array_crystal_array_7. */
  SIG_MESSAGE("channel_1_analyzer_2_array_crystal_array_7 (Init:SetPar)");
#line 830 "MACS_sample_kidney_box.instr"
  if("PG_analyzer") strncpy(mccchannel_1_analyzer_2_array_crystal_array_7_material_string, "PG_analyzer" ? "PG_analyzer" : "", 16384); else mccchannel_1_analyzer_2_array_crystal_array_7_material_string[0]='\0';
#line 830 "MACS_sample_kidney_box.instr"
  mccchannel_1_analyzer_2_array_crystal_array_7_priority = 321.7;
#line 829 "MACS_sample_kidney_box.instr"
  mccchannel_1_analyzer_2_array_crystal_array_7_xwidth = channel_1_analyzer_2_array_crystal_depth;
#line 829 "MACS_sample_kidney_box.instr"
  mccchannel_1_analyzer_2_array_crystal_array_7_yheight = channel_1_analyzer_2_array_crystal_height;
#line 829 "MACS_sample_kidney_box.instr"
  mccchannel_1_analyzer_2_array_crystal_array_7_zdepth = channel_1_analyzer_2_array_crystal_width;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_1_analyzer_2_array_crystal_array_7_xwidth2 = -1;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_1_analyzer_2_array_crystal_array_7_yheight2 = -1;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_1_analyzer_2_array_crystal_array_7_visualize = 1;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_1_analyzer_2_array_crystal_array_7_target_index = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_1_analyzer_2_array_crystal_array_7_target_x = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_1_analyzer_2_array_crystal_array_7_target_y = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_1_analyzer_2_array_crystal_array_7_target_z = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_1_analyzer_2_array_crystal_array_7_focus_aw = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_1_analyzer_2_array_crystal_array_7_focus_ah = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_1_analyzer_2_array_crystal_array_7_focus_xw = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_1_analyzer_2_array_crystal_array_7_focus_xh = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_1_analyzer_2_array_crystal_array_7_focus_r = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_1_analyzer_2_array_crystal_array_7_p_interact = 0;
#line 71 "MACS_sample_kidney_box.instr"
  if(0) strncpy(mccchannel_1_analyzer_2_array_crystal_array_7_mask_string, 0 ? 0 : "", 16384); else mccchannel_1_analyzer_2_array_crystal_array_7_mask_string[0]='\0';
#line 71 "MACS_sample_kidney_box.instr"
  if(0) strncpy(mccchannel_1_analyzer_2_array_crystal_array_7_mask_setting, 0 ? 0 : "", 16384); else mccchannel_1_analyzer_2_array_crystal_array_7_mask_setting[0]='\0';
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_1_analyzer_2_array_crystal_array_7_number_of_activations = 1;
#line 100635 "MACS_sample_kidney_box.c"

  SIG_MESSAGE("channel_1_analyzer_2_array_crystal_array_7 (Init:Place/Rotate)");
  rot_set_rotation(mctr1,
#line 832 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 832 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 832 "MACS_sample_kidney_box.instr"
    (0 - RAD2DEG * channel_1_analyzer_2_array_theta [ 7 ])*DEG2RAD);
#line 100645 "MACS_sample_kidney_box.c"
  rot_mul(mctr1, mcrotachannel_1_analyzer_2_rotated, mcrotachannel_1_analyzer_2_array_crystal_array_7);
  rot_transpose(mcrotachannel_1_analyzer_2_array_crystal_array_6, mctr1);
  rot_mul(mcrotachannel_1_analyzer_2_array_crystal_array_7, mctr1, mcrotrchannel_1_analyzer_2_array_crystal_array_7);
  mctc1 = coords_set(
#line 831 "MACS_sample_kidney_box.instr"
    0 + channel_1_analyzer_2_array_effective_radius_of_curvature * ( 1 - cos ( channel_1_analyzer_2_array_theta [ 7 ] ) ),
#line 831 "MACS_sample_kidney_box.instr"
    0 + channel_1_analyzer_2_array_effective_radius_of_curvature * sin ( channel_1_analyzer_2_array_theta [ 7 ] ),
#line 831 "MACS_sample_kidney_box.instr"
    0);
#line 100656 "MACS_sample_kidney_box.c"
  rot_transpose(mcrotachannel_1_analyzer_2_rotated, mctr1);
  mctc2 = rot_apply(mctr1, mctc1);
  mcposachannel_1_analyzer_2_array_crystal_array_7 = coords_add(mcposachannel_1_analyzer_2_rotated, mctc2);
  mctc1 = coords_sub(mcposachannel_1_analyzer_2_array_crystal_array_6, mcposachannel_1_analyzer_2_array_crystal_array_7);
  mcposrchannel_1_analyzer_2_array_crystal_array_7 = rot_apply(mcrotachannel_1_analyzer_2_array_crystal_array_7, mctc1);
  mcDEBUG_COMPONENT("channel_1_analyzer_2_array_crystal_array_7", mcposachannel_1_analyzer_2_array_crystal_array_7, mcrotachannel_1_analyzer_2_array_crystal_array_7)
  mccomp_posa[186] = mcposachannel_1_analyzer_2_array_crystal_array_7;
  mccomp_posr[186] = mcposrchannel_1_analyzer_2_array_crystal_array_7;
  mcNCounter[186]  = mcPCounter[186] = mcP2Counter[186] = 0;
  mcAbsorbProp[186]= 0;
    /* Component channel_1_analyzer_2_array_crystal_array_8. */
  /* Setting parameters for component channel_1_analyzer_2_array_crystal_array_8. */
  SIG_MESSAGE("channel_1_analyzer_2_array_crystal_array_8 (Init:SetPar)");
#line 836 "MACS_sample_kidney_box.instr"
  if("PG_analyzer") strncpy(mccchannel_1_analyzer_2_array_crystal_array_8_material_string, "PG_analyzer" ? "PG_analyzer" : "", 16384); else mccchannel_1_analyzer_2_array_crystal_array_8_material_string[0]='\0';
#line 836 "MACS_sample_kidney_box.instr"
  mccchannel_1_analyzer_2_array_crystal_array_8_priority = 321.8;
#line 835 "MACS_sample_kidney_box.instr"
  mccchannel_1_analyzer_2_array_crystal_array_8_xwidth = channel_1_analyzer_2_array_crystal_depth;
#line 835 "MACS_sample_kidney_box.instr"
  mccchannel_1_analyzer_2_array_crystal_array_8_yheight = channel_1_analyzer_2_array_crystal_height;
#line 835 "MACS_sample_kidney_box.instr"
  mccchannel_1_analyzer_2_array_crystal_array_8_zdepth = channel_1_analyzer_2_array_crystal_width;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_1_analyzer_2_array_crystal_array_8_xwidth2 = -1;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_1_analyzer_2_array_crystal_array_8_yheight2 = -1;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_1_analyzer_2_array_crystal_array_8_visualize = 1;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_1_analyzer_2_array_crystal_array_8_target_index = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_1_analyzer_2_array_crystal_array_8_target_x = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_1_analyzer_2_array_crystal_array_8_target_y = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_1_analyzer_2_array_crystal_array_8_target_z = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_1_analyzer_2_array_crystal_array_8_focus_aw = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_1_analyzer_2_array_crystal_array_8_focus_ah = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_1_analyzer_2_array_crystal_array_8_focus_xw = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_1_analyzer_2_array_crystal_array_8_focus_xh = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_1_analyzer_2_array_crystal_array_8_focus_r = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_1_analyzer_2_array_crystal_array_8_p_interact = 0;
#line 71 "MACS_sample_kidney_box.instr"
  if(0) strncpy(mccchannel_1_analyzer_2_array_crystal_array_8_mask_string, 0 ? 0 : "", 16384); else mccchannel_1_analyzer_2_array_crystal_array_8_mask_string[0]='\0';
#line 71 "MACS_sample_kidney_box.instr"
  if(0) strncpy(mccchannel_1_analyzer_2_array_crystal_array_8_mask_setting, 0 ? 0 : "", 16384); else mccchannel_1_analyzer_2_array_crystal_array_8_mask_setting[0]='\0';
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_1_analyzer_2_array_crystal_array_8_number_of_activations = 1;
#line 100712 "MACS_sample_kidney_box.c"

  SIG_MESSAGE("channel_1_analyzer_2_array_crystal_array_8 (Init:Place/Rotate)");
  rot_set_rotation(mctr1,
#line 838 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 838 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 838 "MACS_sample_kidney_box.instr"
    (0 - RAD2DEG * channel_1_analyzer_2_array_theta [ 8 ])*DEG2RAD);
#line 100722 "MACS_sample_kidney_box.c"
  rot_mul(mctr1, mcrotachannel_1_analyzer_2_rotated, mcrotachannel_1_analyzer_2_array_crystal_array_8);
  rot_transpose(mcrotachannel_1_analyzer_2_array_crystal_array_7, mctr1);
  rot_mul(mcrotachannel_1_analyzer_2_array_crystal_array_8, mctr1, mcrotrchannel_1_analyzer_2_array_crystal_array_8);
  mctc1 = coords_set(
#line 837 "MACS_sample_kidney_box.instr"
    0 + channel_1_analyzer_2_array_effective_radius_of_curvature * ( 1 - cos ( channel_1_analyzer_2_array_theta [ 8 ] ) ),
#line 837 "MACS_sample_kidney_box.instr"
    0 + channel_1_analyzer_2_array_effective_radius_of_curvature * sin ( channel_1_analyzer_2_array_theta [ 8 ] ),
#line 837 "MACS_sample_kidney_box.instr"
    0);
#line 100733 "MACS_sample_kidney_box.c"
  rot_transpose(mcrotachannel_1_analyzer_2_rotated, mctr1);
  mctc2 = rot_apply(mctr1, mctc1);
  mcposachannel_1_analyzer_2_array_crystal_array_8 = coords_add(mcposachannel_1_analyzer_2_rotated, mctc2);
  mctc1 = coords_sub(mcposachannel_1_analyzer_2_array_crystal_array_7, mcposachannel_1_analyzer_2_array_crystal_array_8);
  mcposrchannel_1_analyzer_2_array_crystal_array_8 = rot_apply(mcrotachannel_1_analyzer_2_array_crystal_array_8, mctc1);
  mcDEBUG_COMPONENT("channel_1_analyzer_2_array_crystal_array_8", mcposachannel_1_analyzer_2_array_crystal_array_8, mcrotachannel_1_analyzer_2_array_crystal_array_8)
  mccomp_posa[187] = mcposachannel_1_analyzer_2_array_crystal_array_8;
  mccomp_posr[187] = mcposrchannel_1_analyzer_2_array_crystal_array_8;
  mcNCounter[187]  = mcPCounter[187] = mcP2Counter[187] = 0;
  mcAbsorbProp[187]= 0;
    /* Component channel_1_cave2_cyl1. */
  /* Setting parameters for component channel_1_cave2_cyl1. */
  SIG_MESSAGE("channel_1_cave2_cyl1 (Init:SetPar)");
#line 843 "MACS_sample_kidney_box.instr"
  if("Vacuum") strncpy(mccchannel_1_cave2_cyl1_material_string, "Vacuum" ? "Vacuum" : "", 16384); else mccchannel_1_cave2_cyl1_material_string[0]='\0';
#line 843 "MACS_sample_kidney_box.instr"
  mccchannel_1_cave2_cyl1_priority = 307.5;
#line 842 "MACS_sample_kidney_box.instr"
  mccchannel_1_cave2_cyl1_radius = kidney_cave2_cyl1_radius;
#line 842 "MACS_sample_kidney_box.instr"
  mccchannel_1_cave2_cyl1_yheight = kidney_cave2_cyl1_height;
#line 67 "MACS_sample_kidney_box.instr"
  mccchannel_1_cave2_cyl1_visualize = 1;
#line 67 "MACS_sample_kidney_box.instr"
  mccchannel_1_cave2_cyl1_target_index = 0;
#line 67 "MACS_sample_kidney_box.instr"
  mccchannel_1_cave2_cyl1_target_x = 0;
#line 67 "MACS_sample_kidney_box.instr"
  mccchannel_1_cave2_cyl1_target_y = 0;
#line 67 "MACS_sample_kidney_box.instr"
  mccchannel_1_cave2_cyl1_target_z = 0;
#line 67 "MACS_sample_kidney_box.instr"
  mccchannel_1_cave2_cyl1_focus_aw = 0;
#line 67 "MACS_sample_kidney_box.instr"
  mccchannel_1_cave2_cyl1_focus_ah = 0;
#line 67 "MACS_sample_kidney_box.instr"
  mccchannel_1_cave2_cyl1_focus_xw = 0;
#line 67 "MACS_sample_kidney_box.instr"
  mccchannel_1_cave2_cyl1_focus_xh = 0;
#line 67 "MACS_sample_kidney_box.instr"
  mccchannel_1_cave2_cyl1_focus_r = 0;
#line 67 "MACS_sample_kidney_box.instr"
  mccchannel_1_cave2_cyl1_p_interact = 0;
#line 67 "MACS_sample_kidney_box.instr"
  if(0) strncpy(mccchannel_1_cave2_cyl1_mask_string, 0 ? 0 : "", 16384); else mccchannel_1_cave2_cyl1_mask_string[0]='\0';
#line 67 "MACS_sample_kidney_box.instr"
  if(0) strncpy(mccchannel_1_cave2_cyl1_mask_setting, 0 ? 0 : "", 16384); else mccchannel_1_cave2_cyl1_mask_setting[0]='\0';
#line 67 "MACS_sample_kidney_box.instr"
  mccchannel_1_cave2_cyl1_number_of_activations = 1;
#line 100783 "MACS_sample_kidney_box.c"

  SIG_MESSAGE("channel_1_cave2_cyl1 (Init:Place/Rotate)");
  rot_set_rotation(mctr1,
#line 845 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 845 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 845 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD);
#line 100793 "MACS_sample_kidney_box.c"
  rot_mul(mctr1, mcrotachannel_1_analyzer_2_center, mcrotachannel_1_cave2_cyl1);
  rot_transpose(mcrotachannel_1_analyzer_2_array_crystal_array_8, mctr1);
  rot_mul(mcrotachannel_1_cave2_cyl1, mctr1, mcrotrchannel_1_cave2_cyl1);
  mctc1 = coords_set(
#line 844 "MACS_sample_kidney_box.instr"
    0,
#line 844 "MACS_sample_kidney_box.instr"
    0,
#line 844 "MACS_sample_kidney_box.instr"
    spec_detector_to_analyzer_2_center);
#line 100804 "MACS_sample_kidney_box.c"
  rot_transpose(mcrotachannel_1_analyzer_2_center, mctr1);
  mctc2 = rot_apply(mctr1, mctc1);
  mcposachannel_1_cave2_cyl1 = coords_add(mcposachannel_1_analyzer_2_center, mctc2);
  mctc1 = coords_sub(mcposachannel_1_analyzer_2_array_crystal_array_8, mcposachannel_1_cave2_cyl1);
  mcposrchannel_1_cave2_cyl1 = rot_apply(mcrotachannel_1_cave2_cyl1, mctc1);
  mcDEBUG_COMPONENT("channel_1_cave2_cyl1", mcposachannel_1_cave2_cyl1, mcrotachannel_1_cave2_cyl1)
  mccomp_posa[188] = mcposachannel_1_cave2_cyl1;
  mccomp_posr[188] = mcposrchannel_1_cave2_cyl1;
  mcNCounter[188]  = mcPCounter[188] = mcP2Counter[188] = 0;
  mcAbsorbProp[188]= 0;
    /* Component channel_1_cave2_box1. */
  /* Setting parameters for component channel_1_cave2_box1. */
  SIG_MESSAGE("channel_1_cave2_box1 (Init:SetPar)");
#line 850 "MACS_sample_kidney_box.instr"
  if("Vacuum") strncpy(mccchannel_1_cave2_box1_material_string, "Vacuum" ? "Vacuum" : "", 16384); else mccchannel_1_cave2_box1_material_string[0]='\0';
#line 850 "MACS_sample_kidney_box.instr"
  mccchannel_1_cave2_box1_priority = 301;
#line 848 "MACS_sample_kidney_box.instr"
  mccchannel_1_cave2_box1_xwidth = kidney_cave2_box1_width1;
#line 848 "MACS_sample_kidney_box.instr"
  mccchannel_1_cave2_box1_yheight = kidney_cave2_box1_height1;
#line 848 "MACS_sample_kidney_box.instr"
  mccchannel_1_cave2_box1_zdepth = kidney_cave2_box1_depth;
#line 849 "MACS_sample_kidney_box.instr"
  mccchannel_1_cave2_box1_xwidth2 = kidney_cave2_box1_width2;
#line 849 "MACS_sample_kidney_box.instr"
  mccchannel_1_cave2_box1_yheight2 = kidney_cave2_box1_height2;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_1_cave2_box1_visualize = 1;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_1_cave2_box1_target_index = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_1_cave2_box1_target_x = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_1_cave2_box1_target_y = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_1_cave2_box1_target_z = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_1_cave2_box1_focus_aw = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_1_cave2_box1_focus_ah = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_1_cave2_box1_focus_xw = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_1_cave2_box1_focus_xh = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_1_cave2_box1_focus_r = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_1_cave2_box1_p_interact = 0;
#line 71 "MACS_sample_kidney_box.instr"
  if(0) strncpy(mccchannel_1_cave2_box1_mask_string, 0 ? 0 : "", 16384); else mccchannel_1_cave2_box1_mask_string[0]='\0';
#line 71 "MACS_sample_kidney_box.instr"
  if(0) strncpy(mccchannel_1_cave2_box1_mask_setting, 0 ? 0 : "", 16384); else mccchannel_1_cave2_box1_mask_setting[0]='\0';
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_1_cave2_box1_number_of_activations = 1;
#line 100860 "MACS_sample_kidney_box.c"

  SIG_MESSAGE("channel_1_cave2_box1 (Init:Place/Rotate)");
  rot_set_rotation(mctr1,
#line 852 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 852 "MACS_sample_kidney_box.instr"
    (kidney_cave2_box1_y_rotation)*DEG2RAD,
#line 852 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD);
#line 100870 "MACS_sample_kidney_box.c"
  rot_mul(mctr1, mcrotachannel_1_cave2_cyl1, mcrotachannel_1_cave2_box1);
  rot_transpose(mcrotachannel_1_cave2_cyl1, mctr1);
  rot_mul(mcrotachannel_1_cave2_box1, mctr1, mcrotrchannel_1_cave2_box1);
  mctc1 = coords_set(
#line 851 "MACS_sample_kidney_box.instr"
    kidney_cave2_box1_center_to_spec_detector_x,
#line 851 "MACS_sample_kidney_box.instr"
    0,
#line 851 "MACS_sample_kidney_box.instr"
    kidney_cave2_box1_center_to_spec_detector_z);
#line 100881 "MACS_sample_kidney_box.c"
  rot_transpose(mcrotachannel_1_cave2_cyl1, mctr1);
  mctc2 = rot_apply(mctr1, mctc1);
  mcposachannel_1_cave2_box1 = coords_add(mcposachannel_1_cave2_cyl1, mctc2);
  mctc1 = coords_sub(mcposachannel_1_cave2_cyl1, mcposachannel_1_cave2_box1);
  mcposrchannel_1_cave2_box1 = rot_apply(mcrotachannel_1_cave2_box1, mctc1);
  mcDEBUG_COMPONENT("channel_1_cave2_box1", mcposachannel_1_cave2_box1, mcrotachannel_1_cave2_box1)
  mccomp_posa[189] = mcposachannel_1_cave2_box1;
  mccomp_posr[189] = mcposrchannel_1_cave2_box1;
  mcNCounter[189]  = mcPCounter[189] = mcP2Counter[189] = 0;
  mcAbsorbProp[189]= 0;
    /* Component channel_1_cave2_box2. */
  /* Setting parameters for component channel_1_cave2_box2. */
  SIG_MESSAGE("channel_1_cave2_box2 (Init:SetPar)");
#line 857 "MACS_sample_kidney_box.instr"
  if("Vacuum") strncpy(mccchannel_1_cave2_box2_material_string, "Vacuum" ? "Vacuum" : "", 16384); else mccchannel_1_cave2_box2_material_string[0]='\0';
#line 857 "MACS_sample_kidney_box.instr"
  mccchannel_1_cave2_box2_priority = 306;
#line 855 "MACS_sample_kidney_box.instr"
  mccchannel_1_cave2_box2_xwidth = kidney_cave2_box2_width1;
#line 855 "MACS_sample_kidney_box.instr"
  mccchannel_1_cave2_box2_yheight = kidney_cave2_box2_height1;
#line 855 "MACS_sample_kidney_box.instr"
  mccchannel_1_cave2_box2_zdepth = kidney_cave2_box2_depth;
#line 856 "MACS_sample_kidney_box.instr"
  mccchannel_1_cave2_box2_xwidth2 = kidney_cave2_box2_width2;
#line 856 "MACS_sample_kidney_box.instr"
  mccchannel_1_cave2_box2_yheight2 = kidney_cave2_box2_height2;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_1_cave2_box2_visualize = 1;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_1_cave2_box2_target_index = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_1_cave2_box2_target_x = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_1_cave2_box2_target_y = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_1_cave2_box2_target_z = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_1_cave2_box2_focus_aw = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_1_cave2_box2_focus_ah = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_1_cave2_box2_focus_xw = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_1_cave2_box2_focus_xh = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_1_cave2_box2_focus_r = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_1_cave2_box2_p_interact = 0;
#line 71 "MACS_sample_kidney_box.instr"
  if(0) strncpy(mccchannel_1_cave2_box2_mask_string, 0 ? 0 : "", 16384); else mccchannel_1_cave2_box2_mask_string[0]='\0';
#line 71 "MACS_sample_kidney_box.instr"
  if(0) strncpy(mccchannel_1_cave2_box2_mask_setting, 0 ? 0 : "", 16384); else mccchannel_1_cave2_box2_mask_setting[0]='\0';
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_1_cave2_box2_number_of_activations = 1;
#line 100937 "MACS_sample_kidney_box.c"

  SIG_MESSAGE("channel_1_cave2_box2 (Init:Place/Rotate)");
  rot_set_rotation(mctr1,
#line 859 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 859 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 859 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD);
#line 100947 "MACS_sample_kidney_box.c"
  rot_mul(mctr1, mcrotachannel_1_cave2_cyl1, mcrotachannel_1_cave2_box2);
  rot_transpose(mcrotachannel_1_cave2_box1, mctr1);
  rot_mul(mcrotachannel_1_cave2_box2, mctr1, mcrotrchannel_1_cave2_box2);
  mctc1 = coords_set(
#line 858 "MACS_sample_kidney_box.instr"
    0,
#line 858 "MACS_sample_kidney_box.instr"
    0,
#line 858 "MACS_sample_kidney_box.instr"
    kidney_cave2_box2_center_to_detector);
#line 100958 "MACS_sample_kidney_box.c"
  rot_transpose(mcrotachannel_1_cave2_cyl1, mctr1);
  mctc2 = rot_apply(mctr1, mctc1);
  mcposachannel_1_cave2_box2 = coords_add(mcposachannel_1_cave2_cyl1, mctc2);
  mctc1 = coords_sub(mcposachannel_1_cave2_box1, mcposachannel_1_cave2_box2);
  mcposrchannel_1_cave2_box2 = rot_apply(mcrotachannel_1_cave2_box2, mctc1);
  mcDEBUG_COMPONENT("channel_1_cave2_box2", mcposachannel_1_cave2_box2, mcrotachannel_1_cave2_box2)
  mccomp_posa[190] = mcposachannel_1_cave2_box2;
  mccomp_posr[190] = mcposrchannel_1_cave2_box2;
  mcNCounter[190]  = mcPCounter[190] = mcP2Counter[190] = 0;
  mcAbsorbProp[190]= 0;
    /* Component channel_1_cave2_box3. */
  /* Setting parameters for component channel_1_cave2_box3. */
  SIG_MESSAGE("channel_1_cave2_box3 (Init:SetPar)");
#line 864 "MACS_sample_kidney_box.instr"
  if("Vacuum") strncpy(mccchannel_1_cave2_box3_material_string, "Vacuum" ? "Vacuum" : "", 16384); else mccchannel_1_cave2_box3_material_string[0]='\0';
#line 864 "MACS_sample_kidney_box.instr"
  mccchannel_1_cave2_box3_priority = 307;
#line 862 "MACS_sample_kidney_box.instr"
  mccchannel_1_cave2_box3_xwidth = kidney_cave2_box3_width1;
#line 862 "MACS_sample_kidney_box.instr"
  mccchannel_1_cave2_box3_yheight = kidney_cave2_box3_height1;
#line 862 "MACS_sample_kidney_box.instr"
  mccchannel_1_cave2_box3_zdepth = kidney_cave2_box3_depth;
#line 863 "MACS_sample_kidney_box.instr"
  mccchannel_1_cave2_box3_xwidth2 = kidney_cave2_box3_width2;
#line 863 "MACS_sample_kidney_box.instr"
  mccchannel_1_cave2_box3_yheight2 = kidney_cave2_box3_height2;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_1_cave2_box3_visualize = 1;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_1_cave2_box3_target_index = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_1_cave2_box3_target_x = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_1_cave2_box3_target_y = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_1_cave2_box3_target_z = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_1_cave2_box3_focus_aw = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_1_cave2_box3_focus_ah = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_1_cave2_box3_focus_xw = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_1_cave2_box3_focus_xh = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_1_cave2_box3_focus_r = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_1_cave2_box3_p_interact = 0;
#line 71 "MACS_sample_kidney_box.instr"
  if(0) strncpy(mccchannel_1_cave2_box3_mask_string, 0 ? 0 : "", 16384); else mccchannel_1_cave2_box3_mask_string[0]='\0';
#line 71 "MACS_sample_kidney_box.instr"
  if(0) strncpy(mccchannel_1_cave2_box3_mask_setting, 0 ? 0 : "", 16384); else mccchannel_1_cave2_box3_mask_setting[0]='\0';
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_1_cave2_box3_number_of_activations = 1;
#line 101014 "MACS_sample_kidney_box.c"

  SIG_MESSAGE("channel_1_cave2_box3 (Init:Place/Rotate)");
  rot_set_rotation(mctr1,
#line 866 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 866 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 866 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD);
#line 101024 "MACS_sample_kidney_box.c"
  rot_mul(mctr1, mcrotachannel_1_cave2_cyl1, mcrotachannel_1_cave2_box3);
  rot_transpose(mcrotachannel_1_cave2_box2, mctr1);
  rot_mul(mcrotachannel_1_cave2_box3, mctr1, mcrotrchannel_1_cave2_box3);
  mctc1 = coords_set(
#line 865 "MACS_sample_kidney_box.instr"
    0,
#line 865 "MACS_sample_kidney_box.instr"
    0,
#line 865 "MACS_sample_kidney_box.instr"
    kidney_cave2_box3_center_to_detector);
#line 101035 "MACS_sample_kidney_box.c"
  rot_transpose(mcrotachannel_1_cave2_cyl1, mctr1);
  mctc2 = rot_apply(mctr1, mctc1);
  mcposachannel_1_cave2_box3 = coords_add(mcposachannel_1_cave2_cyl1, mctc2);
  mctc1 = coords_sub(mcposachannel_1_cave2_box2, mcposachannel_1_cave2_box3);
  mcposrchannel_1_cave2_box3 = rot_apply(mcrotachannel_1_cave2_box3, mctc1);
  mcDEBUG_COMPONENT("channel_1_cave2_box3", mcposachannel_1_cave2_box3, mcrotachannel_1_cave2_box3)
  mccomp_posa[191] = mcposachannel_1_cave2_box3;
  mccomp_posr[191] = mcposrchannel_1_cave2_box3;
  mcNCounter[191]  = mcPCounter[191] = mcP2Counter[191] = 0;
  mcAbsorbProp[191]= 0;
    /* Component inter_analyzer_colimator_center_1. */
  /* Setting parameters for component inter_analyzer_colimator_center_1. */
  SIG_MESSAGE("inter_analyzer_colimator_center_1 (Init:SetPar)");

  SIG_MESSAGE("inter_analyzer_colimator_center_1 (Init:Place/Rotate)");
  rot_set_rotation(mctr1,
#line 870 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 870 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 870 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD);
#line 101058 "MACS_sample_kidney_box.c"
  rot_mul(mctr1, mcrotachannel_1_analyzer_1_center, mcrotainter_analyzer_colimator_center_1);
  rot_transpose(mcrotachannel_1_cave2_box3, mctr1);
  rot_mul(mcrotainter_analyzer_colimator_center_1, mctr1, mcrotrinter_analyzer_colimator_center_1);
  mctc1 = coords_set(
#line 869 "MACS_sample_kidney_box.instr"
    -0.5 * analyzer_seperation,
#line 869 "MACS_sample_kidney_box.instr"
    0,
#line 869 "MACS_sample_kidney_box.instr"
    0);
#line 101069 "MACS_sample_kidney_box.c"
  rot_transpose(mcrotachannel_1_analyzer_1_center, mctr1);
  mctc2 = rot_apply(mctr1, mctc1);
  mcposainter_analyzer_colimator_center_1 = coords_add(mcposachannel_1_analyzer_1_center, mctc2);
  mctc1 = coords_sub(mcposachannel_1_cave2_box3, mcposainter_analyzer_colimator_center_1);
  mcposrinter_analyzer_colimator_center_1 = rot_apply(mcrotainter_analyzer_colimator_center_1, mctc1);
  mcDEBUG_COMPONENT("inter_analyzer_colimator_center_1", mcposainter_analyzer_colimator_center_1, mcrotainter_analyzer_colimator_center_1)
  mccomp_posa[192] = mcposainter_analyzer_colimator_center_1;
  mccomp_posr[192] = mcposrinter_analyzer_colimator_center_1;
  mcNCounter[192]  = mcPCounter[192] = mcP2Counter[192] = 0;
  mcAbsorbProp[192]= 0;
    /* Component inter_analyzer_colimator_1_blade_0. */
  /* Setting parameters for component inter_analyzer_colimator_1_blade_0. */
  SIG_MESSAGE("inter_analyzer_colimator_1_blade_0 (Init:SetPar)");
#line 874 "MACS_sample_kidney_box.instr"
  if("Collimator_gad") strncpy(mccinter_analyzer_colimator_1_blade_0_material_string, "Collimator_gad" ? "Collimator_gad" : "", 16384); else mccinter_analyzer_colimator_1_blade_0_material_string[0]='\0';
#line 874 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_1_blade_0_priority = 325;
#line 873 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_1_blade_0_xwidth = inter_analyzer_colimator_width;
#line 873 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_1_blade_0_yheight = inter_analyzer_colimator_height;
#line 873 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_1_blade_0_zdepth = inter_analyzer_colimator_depth;
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_1_blade_0_xwidth2 = -1;
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_1_blade_0_yheight2 = -1;
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_1_blade_0_visualize = 1;
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_1_blade_0_target_index = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_1_blade_0_target_x = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_1_blade_0_target_y = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_1_blade_0_target_z = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_1_blade_0_focus_aw = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_1_blade_0_focus_ah = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_1_blade_0_focus_xw = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_1_blade_0_focus_xh = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_1_blade_0_focus_r = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_1_blade_0_p_interact = 0;
#line 71 "MACS_sample_kidney_box.instr"
  if(0) strncpy(mccinter_analyzer_colimator_1_blade_0_mask_string, 0 ? 0 : "", 16384); else mccinter_analyzer_colimator_1_blade_0_mask_string[0]='\0';
#line 71 "MACS_sample_kidney_box.instr"
  if(0) strncpy(mccinter_analyzer_colimator_1_blade_0_mask_setting, 0 ? 0 : "", 16384); else mccinter_analyzer_colimator_1_blade_0_mask_setting[0]='\0';
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_1_blade_0_number_of_activations = 1;
#line 101125 "MACS_sample_kidney_box.c"

  SIG_MESSAGE("inter_analyzer_colimator_1_blade_0 (Init:Place/Rotate)");
  rot_set_rotation(mctr1,
#line 876 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 876 "MACS_sample_kidney_box.instr"
    (- analyzer_2theta [ 1 ])*DEG2RAD,
#line 876 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD);
#line 101135 "MACS_sample_kidney_box.c"
  rot_mul(mctr1, mcrotainter_analyzer_colimator_center_1, mcrotainter_analyzer_colimator_1_blade_0);
  rot_transpose(mcrotainter_analyzer_colimator_center_1, mctr1);
  rot_mul(mcrotainter_analyzer_colimator_1_blade_0, mctr1, mcrotrinter_analyzer_colimator_1_blade_0);
  mctc1 = coords_set(
#line 875 "MACS_sample_kidney_box.instr"
    0,
#line 875 "MACS_sample_kidney_box.instr"
    0,
#line 875 "MACS_sample_kidney_box.instr"
    inter_analyzer_colimator_start_pos - 0 * inter_analyzer_colimator_seperation);
#line 101146 "MACS_sample_kidney_box.c"
  rot_transpose(mcrotainter_analyzer_colimator_center_1, mctr1);
  mctc2 = rot_apply(mctr1, mctc1);
  mcposainter_analyzer_colimator_1_blade_0 = coords_add(mcposainter_analyzer_colimator_center_1, mctc2);
  mctc1 = coords_sub(mcposainter_analyzer_colimator_center_1, mcposainter_analyzer_colimator_1_blade_0);
  mcposrinter_analyzer_colimator_1_blade_0 = rot_apply(mcrotainter_analyzer_colimator_1_blade_0, mctc1);
  mcDEBUG_COMPONENT("inter_analyzer_colimator_1_blade_0", mcposainter_analyzer_colimator_1_blade_0, mcrotainter_analyzer_colimator_1_blade_0)
  mccomp_posa[193] = mcposainter_analyzer_colimator_1_blade_0;
  mccomp_posr[193] = mcposrinter_analyzer_colimator_1_blade_0;
  mcNCounter[193]  = mcPCounter[193] = mcP2Counter[193] = 0;
  mcAbsorbProp[193]= 0;
    /* Component inter_analyzer_colimator_1_blade_1. */
  /* Setting parameters for component inter_analyzer_colimator_1_blade_1. */
  SIG_MESSAGE("inter_analyzer_colimator_1_blade_1 (Init:SetPar)");
#line 880 "MACS_sample_kidney_box.instr"
  if("Collimator_gad") strncpy(mccinter_analyzer_colimator_1_blade_1_material_string, "Collimator_gad" ? "Collimator_gad" : "", 16384); else mccinter_analyzer_colimator_1_blade_1_material_string[0]='\0';
#line 880 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_1_blade_1_priority = 326;
#line 879 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_1_blade_1_xwidth = inter_analyzer_colimator_width;
#line 879 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_1_blade_1_yheight = inter_analyzer_colimator_height;
#line 879 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_1_blade_1_zdepth = inter_analyzer_colimator_depth;
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_1_blade_1_xwidth2 = -1;
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_1_blade_1_yheight2 = -1;
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_1_blade_1_visualize = 1;
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_1_blade_1_target_index = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_1_blade_1_target_x = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_1_blade_1_target_y = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_1_blade_1_target_z = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_1_blade_1_focus_aw = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_1_blade_1_focus_ah = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_1_blade_1_focus_xw = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_1_blade_1_focus_xh = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_1_blade_1_focus_r = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_1_blade_1_p_interact = 0;
#line 71 "MACS_sample_kidney_box.instr"
  if(0) strncpy(mccinter_analyzer_colimator_1_blade_1_mask_string, 0 ? 0 : "", 16384); else mccinter_analyzer_colimator_1_blade_1_mask_string[0]='\0';
#line 71 "MACS_sample_kidney_box.instr"
  if(0) strncpy(mccinter_analyzer_colimator_1_blade_1_mask_setting, 0 ? 0 : "", 16384); else mccinter_analyzer_colimator_1_blade_1_mask_setting[0]='\0';
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_1_blade_1_number_of_activations = 1;
#line 101202 "MACS_sample_kidney_box.c"

  SIG_MESSAGE("inter_analyzer_colimator_1_blade_1 (Init:Place/Rotate)");
  rot_set_rotation(mctr1,
#line 882 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 882 "MACS_sample_kidney_box.instr"
    (- analyzer_2theta [ 1 ])*DEG2RAD,
#line 882 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD);
#line 101212 "MACS_sample_kidney_box.c"
  rot_mul(mctr1, mcrotainter_analyzer_colimator_center_1, mcrotainter_analyzer_colimator_1_blade_1);
  rot_transpose(mcrotainter_analyzer_colimator_1_blade_0, mctr1);
  rot_mul(mcrotainter_analyzer_colimator_1_blade_1, mctr1, mcrotrinter_analyzer_colimator_1_blade_1);
  mctc1 = coords_set(
#line 881 "MACS_sample_kidney_box.instr"
    0,
#line 881 "MACS_sample_kidney_box.instr"
    0,
#line 881 "MACS_sample_kidney_box.instr"
    inter_analyzer_colimator_start_pos - 1 * inter_analyzer_colimator_seperation);
#line 101223 "MACS_sample_kidney_box.c"
  rot_transpose(mcrotainter_analyzer_colimator_center_1, mctr1);
  mctc2 = rot_apply(mctr1, mctc1);
  mcposainter_analyzer_colimator_1_blade_1 = coords_add(mcposainter_analyzer_colimator_center_1, mctc2);
  mctc1 = coords_sub(mcposainter_analyzer_colimator_1_blade_0, mcposainter_analyzer_colimator_1_blade_1);
  mcposrinter_analyzer_colimator_1_blade_1 = rot_apply(mcrotainter_analyzer_colimator_1_blade_1, mctc1);
  mcDEBUG_COMPONENT("inter_analyzer_colimator_1_blade_1", mcposainter_analyzer_colimator_1_blade_1, mcrotainter_analyzer_colimator_1_blade_1)
  mccomp_posa[194] = mcposainter_analyzer_colimator_1_blade_1;
  mccomp_posr[194] = mcposrinter_analyzer_colimator_1_blade_1;
  mcNCounter[194]  = mcPCounter[194] = mcP2Counter[194] = 0;
  mcAbsorbProp[194]= 0;
    /* Component inter_analyzer_colimator_1_blade_2. */
  /* Setting parameters for component inter_analyzer_colimator_1_blade_2. */
  SIG_MESSAGE("inter_analyzer_colimator_1_blade_2 (Init:SetPar)");
#line 886 "MACS_sample_kidney_box.instr"
  if("Collimator_gad") strncpy(mccinter_analyzer_colimator_1_blade_2_material_string, "Collimator_gad" ? "Collimator_gad" : "", 16384); else mccinter_analyzer_colimator_1_blade_2_material_string[0]='\0';
#line 886 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_1_blade_2_priority = 327;
#line 885 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_1_blade_2_xwidth = inter_analyzer_colimator_width;
#line 885 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_1_blade_2_yheight = inter_analyzer_colimator_height;
#line 885 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_1_blade_2_zdepth = inter_analyzer_colimator_depth;
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_1_blade_2_xwidth2 = -1;
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_1_blade_2_yheight2 = -1;
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_1_blade_2_visualize = 1;
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_1_blade_2_target_index = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_1_blade_2_target_x = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_1_blade_2_target_y = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_1_blade_2_target_z = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_1_blade_2_focus_aw = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_1_blade_2_focus_ah = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_1_blade_2_focus_xw = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_1_blade_2_focus_xh = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_1_blade_2_focus_r = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_1_blade_2_p_interact = 0;
#line 71 "MACS_sample_kidney_box.instr"
  if(0) strncpy(mccinter_analyzer_colimator_1_blade_2_mask_string, 0 ? 0 : "", 16384); else mccinter_analyzer_colimator_1_blade_2_mask_string[0]='\0';
#line 71 "MACS_sample_kidney_box.instr"
  if(0) strncpy(mccinter_analyzer_colimator_1_blade_2_mask_setting, 0 ? 0 : "", 16384); else mccinter_analyzer_colimator_1_blade_2_mask_setting[0]='\0';
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_1_blade_2_number_of_activations = 1;
#line 101279 "MACS_sample_kidney_box.c"

  SIG_MESSAGE("inter_analyzer_colimator_1_blade_2 (Init:Place/Rotate)");
  rot_set_rotation(mctr1,
#line 888 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 888 "MACS_sample_kidney_box.instr"
    (- analyzer_2theta [ 1 ])*DEG2RAD,
#line 888 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD);
#line 101289 "MACS_sample_kidney_box.c"
  rot_mul(mctr1, mcrotainter_analyzer_colimator_center_1, mcrotainter_analyzer_colimator_1_blade_2);
  rot_transpose(mcrotainter_analyzer_colimator_1_blade_1, mctr1);
  rot_mul(mcrotainter_analyzer_colimator_1_blade_2, mctr1, mcrotrinter_analyzer_colimator_1_blade_2);
  mctc1 = coords_set(
#line 887 "MACS_sample_kidney_box.instr"
    0,
#line 887 "MACS_sample_kidney_box.instr"
    0,
#line 887 "MACS_sample_kidney_box.instr"
    inter_analyzer_colimator_start_pos - 2 * inter_analyzer_colimator_seperation);
#line 101300 "MACS_sample_kidney_box.c"
  rot_transpose(mcrotainter_analyzer_colimator_center_1, mctr1);
  mctc2 = rot_apply(mctr1, mctc1);
  mcposainter_analyzer_colimator_1_blade_2 = coords_add(mcposainter_analyzer_colimator_center_1, mctc2);
  mctc1 = coords_sub(mcposainter_analyzer_colimator_1_blade_1, mcposainter_analyzer_colimator_1_blade_2);
  mcposrinter_analyzer_colimator_1_blade_2 = rot_apply(mcrotainter_analyzer_colimator_1_blade_2, mctc1);
  mcDEBUG_COMPONENT("inter_analyzer_colimator_1_blade_2", mcposainter_analyzer_colimator_1_blade_2, mcrotainter_analyzer_colimator_1_blade_2)
  mccomp_posa[195] = mcposainter_analyzer_colimator_1_blade_2;
  mccomp_posr[195] = mcposrinter_analyzer_colimator_1_blade_2;
  mcNCounter[195]  = mcPCounter[195] = mcP2Counter[195] = 0;
  mcAbsorbProp[195]= 0;
    /* Component inter_analyzer_colimator_1_blade_3. */
  /* Setting parameters for component inter_analyzer_colimator_1_blade_3. */
  SIG_MESSAGE("inter_analyzer_colimator_1_blade_3 (Init:SetPar)");
#line 892 "MACS_sample_kidney_box.instr"
  if("Collimator_gad") strncpy(mccinter_analyzer_colimator_1_blade_3_material_string, "Collimator_gad" ? "Collimator_gad" : "", 16384); else mccinter_analyzer_colimator_1_blade_3_material_string[0]='\0';
#line 892 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_1_blade_3_priority = 328;
#line 891 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_1_blade_3_xwidth = inter_analyzer_colimator_width;
#line 891 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_1_blade_3_yheight = inter_analyzer_colimator_height;
#line 891 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_1_blade_3_zdepth = inter_analyzer_colimator_depth;
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_1_blade_3_xwidth2 = -1;
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_1_blade_3_yheight2 = -1;
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_1_blade_3_visualize = 1;
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_1_blade_3_target_index = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_1_blade_3_target_x = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_1_blade_3_target_y = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_1_blade_3_target_z = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_1_blade_3_focus_aw = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_1_blade_3_focus_ah = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_1_blade_3_focus_xw = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_1_blade_3_focus_xh = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_1_blade_3_focus_r = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_1_blade_3_p_interact = 0;
#line 71 "MACS_sample_kidney_box.instr"
  if(0) strncpy(mccinter_analyzer_colimator_1_blade_3_mask_string, 0 ? 0 : "", 16384); else mccinter_analyzer_colimator_1_blade_3_mask_string[0]='\0';
#line 71 "MACS_sample_kidney_box.instr"
  if(0) strncpy(mccinter_analyzer_colimator_1_blade_3_mask_setting, 0 ? 0 : "", 16384); else mccinter_analyzer_colimator_1_blade_3_mask_setting[0]='\0';
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_1_blade_3_number_of_activations = 1;
#line 101356 "MACS_sample_kidney_box.c"

  SIG_MESSAGE("inter_analyzer_colimator_1_blade_3 (Init:Place/Rotate)");
  rot_set_rotation(mctr1,
#line 894 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 894 "MACS_sample_kidney_box.instr"
    (- analyzer_2theta [ 1 ])*DEG2RAD,
#line 894 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD);
#line 101366 "MACS_sample_kidney_box.c"
  rot_mul(mctr1, mcrotainter_analyzer_colimator_center_1, mcrotainter_analyzer_colimator_1_blade_3);
  rot_transpose(mcrotainter_analyzer_colimator_1_blade_2, mctr1);
  rot_mul(mcrotainter_analyzer_colimator_1_blade_3, mctr1, mcrotrinter_analyzer_colimator_1_blade_3);
  mctc1 = coords_set(
#line 893 "MACS_sample_kidney_box.instr"
    0,
#line 893 "MACS_sample_kidney_box.instr"
    0,
#line 893 "MACS_sample_kidney_box.instr"
    inter_analyzer_colimator_start_pos - 3 * inter_analyzer_colimator_seperation);
#line 101377 "MACS_sample_kidney_box.c"
  rot_transpose(mcrotainter_analyzer_colimator_center_1, mctr1);
  mctc2 = rot_apply(mctr1, mctc1);
  mcposainter_analyzer_colimator_1_blade_3 = coords_add(mcposainter_analyzer_colimator_center_1, mctc2);
  mctc1 = coords_sub(mcposainter_analyzer_colimator_1_blade_2, mcposainter_analyzer_colimator_1_blade_3);
  mcposrinter_analyzer_colimator_1_blade_3 = rot_apply(mcrotainter_analyzer_colimator_1_blade_3, mctc1);
  mcDEBUG_COMPONENT("inter_analyzer_colimator_1_blade_3", mcposainter_analyzer_colimator_1_blade_3, mcrotainter_analyzer_colimator_1_blade_3)
  mccomp_posa[196] = mcposainter_analyzer_colimator_1_blade_3;
  mccomp_posr[196] = mcposrinter_analyzer_colimator_1_blade_3;
  mcNCounter[196]  = mcPCounter[196] = mcP2Counter[196] = 0;
  mcAbsorbProp[196]= 0;
    /* Component inter_analyzer_colimator_1_blade_4. */
  /* Setting parameters for component inter_analyzer_colimator_1_blade_4. */
  SIG_MESSAGE("inter_analyzer_colimator_1_blade_4 (Init:SetPar)");
#line 898 "MACS_sample_kidney_box.instr"
  if("Collimator_gad") strncpy(mccinter_analyzer_colimator_1_blade_4_material_string, "Collimator_gad" ? "Collimator_gad" : "", 16384); else mccinter_analyzer_colimator_1_blade_4_material_string[0]='\0';
#line 898 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_1_blade_4_priority = 329;
#line 897 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_1_blade_4_xwidth = inter_analyzer_colimator_width;
#line 897 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_1_blade_4_yheight = inter_analyzer_colimator_height;
#line 897 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_1_blade_4_zdepth = inter_analyzer_colimator_depth;
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_1_blade_4_xwidth2 = -1;
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_1_blade_4_yheight2 = -1;
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_1_blade_4_visualize = 1;
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_1_blade_4_target_index = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_1_blade_4_target_x = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_1_blade_4_target_y = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_1_blade_4_target_z = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_1_blade_4_focus_aw = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_1_blade_4_focus_ah = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_1_blade_4_focus_xw = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_1_blade_4_focus_xh = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_1_blade_4_focus_r = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_1_blade_4_p_interact = 0;
#line 71 "MACS_sample_kidney_box.instr"
  if(0) strncpy(mccinter_analyzer_colimator_1_blade_4_mask_string, 0 ? 0 : "", 16384); else mccinter_analyzer_colimator_1_blade_4_mask_string[0]='\0';
#line 71 "MACS_sample_kidney_box.instr"
  if(0) strncpy(mccinter_analyzer_colimator_1_blade_4_mask_setting, 0 ? 0 : "", 16384); else mccinter_analyzer_colimator_1_blade_4_mask_setting[0]='\0';
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_1_blade_4_number_of_activations = 1;
#line 101433 "MACS_sample_kidney_box.c"

  SIG_MESSAGE("inter_analyzer_colimator_1_blade_4 (Init:Place/Rotate)");
  rot_set_rotation(mctr1,
#line 900 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 900 "MACS_sample_kidney_box.instr"
    (- analyzer_2theta [ 1 ])*DEG2RAD,
#line 900 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD);
#line 101443 "MACS_sample_kidney_box.c"
  rot_mul(mctr1, mcrotainter_analyzer_colimator_center_1, mcrotainter_analyzer_colimator_1_blade_4);
  rot_transpose(mcrotainter_analyzer_colimator_1_blade_3, mctr1);
  rot_mul(mcrotainter_analyzer_colimator_1_blade_4, mctr1, mcrotrinter_analyzer_colimator_1_blade_4);
  mctc1 = coords_set(
#line 899 "MACS_sample_kidney_box.instr"
    0,
#line 899 "MACS_sample_kidney_box.instr"
    0,
#line 899 "MACS_sample_kidney_box.instr"
    inter_analyzer_colimator_start_pos - 4 * inter_analyzer_colimator_seperation);
#line 101454 "MACS_sample_kidney_box.c"
  rot_transpose(mcrotainter_analyzer_colimator_center_1, mctr1);
  mctc2 = rot_apply(mctr1, mctc1);
  mcposainter_analyzer_colimator_1_blade_4 = coords_add(mcposainter_analyzer_colimator_center_1, mctc2);
  mctc1 = coords_sub(mcposainter_analyzer_colimator_1_blade_3, mcposainter_analyzer_colimator_1_blade_4);
  mcposrinter_analyzer_colimator_1_blade_4 = rot_apply(mcrotainter_analyzer_colimator_1_blade_4, mctc1);
  mcDEBUG_COMPONENT("inter_analyzer_colimator_1_blade_4", mcposainter_analyzer_colimator_1_blade_4, mcrotainter_analyzer_colimator_1_blade_4)
  mccomp_posa[197] = mcposainter_analyzer_colimator_1_blade_4;
  mccomp_posr[197] = mcposrinter_analyzer_colimator_1_blade_4;
  mcNCounter[197]  = mcPCounter[197] = mcP2Counter[197] = 0;
  mcAbsorbProp[197]= 0;
    /* Component diffraction_detector_1_exit_volume. */
  /* Setting parameters for component diffraction_detector_1_exit_volume. */
  SIG_MESSAGE("diffraction_detector_1_exit_volume (Init:SetPar)");
#line 904 "MACS_sample_kidney_box.instr"
  if("Exit") strncpy(mccdiffraction_detector_1_exit_volume_material_string, "Exit" ? "Exit" : "", 16384); else mccdiffraction_detector_1_exit_volume_material_string[0]='\0';
#line 904 "MACS_sample_kidney_box.instr"
  mccdiffraction_detector_1_exit_volume_priority = 331;
#line 903 "MACS_sample_kidney_box.instr"
  mccdiffraction_detector_1_exit_volume_xwidth = 2.01 * detector_radius;
#line 903 "MACS_sample_kidney_box.instr"
  mccdiffraction_detector_1_exit_volume_yheight = 1.01 * detector_height;
#line 903 "MACS_sample_kidney_box.instr"
  mccdiffraction_detector_1_exit_volume_zdepth = 0.001;
#line 71 "MACS_sample_kidney_box.instr"
  mccdiffraction_detector_1_exit_volume_xwidth2 = -1;
#line 71 "MACS_sample_kidney_box.instr"
  mccdiffraction_detector_1_exit_volume_yheight2 = -1;
#line 71 "MACS_sample_kidney_box.instr"
  mccdiffraction_detector_1_exit_volume_visualize = 1;
#line 71 "MACS_sample_kidney_box.instr"
  mccdiffraction_detector_1_exit_volume_target_index = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccdiffraction_detector_1_exit_volume_target_x = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccdiffraction_detector_1_exit_volume_target_y = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccdiffraction_detector_1_exit_volume_target_z = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccdiffraction_detector_1_exit_volume_focus_aw = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccdiffraction_detector_1_exit_volume_focus_ah = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccdiffraction_detector_1_exit_volume_focus_xw = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccdiffraction_detector_1_exit_volume_focus_xh = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccdiffraction_detector_1_exit_volume_focus_r = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccdiffraction_detector_1_exit_volume_p_interact = 0;
#line 71 "MACS_sample_kidney_box.instr"
  if(0) strncpy(mccdiffraction_detector_1_exit_volume_mask_string, 0 ? 0 : "", 16384); else mccdiffraction_detector_1_exit_volume_mask_string[0]='\0';
#line 71 "MACS_sample_kidney_box.instr"
  if(0) strncpy(mccdiffraction_detector_1_exit_volume_mask_setting, 0 ? 0 : "", 16384); else mccdiffraction_detector_1_exit_volume_mask_setting[0]='\0';
#line 71 "MACS_sample_kidney_box.instr"
  mccdiffraction_detector_1_exit_volume_number_of_activations = 1;
#line 101510 "MACS_sample_kidney_box.c"

  SIG_MESSAGE("diffraction_detector_1_exit_volume (Init:Place/Rotate)");
  rot_set_rotation(mctr1,
#line 906 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 906 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 906 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD);
#line 101520 "MACS_sample_kidney_box.c"
  rot_mul(mctr1, mcrotakidney_channel_1, mcrotadiffraction_detector_1_exit_volume);
  rot_transpose(mcrotainter_analyzer_colimator_1_blade_4, mctr1);
  rot_mul(mcrotadiffraction_detector_1_exit_volume, mctr1, mcrotrdiffraction_detector_1_exit_volume);
  mctc1 = coords_set(
#line 905 "MACS_sample_kidney_box.instr"
    0,
#line 905 "MACS_sample_kidney_box.instr"
    0,
#line 905 "MACS_sample_kidney_box.instr"
    0);
#line 101531 "MACS_sample_kidney_box.c"
  rot_transpose(mcrotachannel_1_cave1_cyl1, mctr1);
  mctc2 = rot_apply(mctr1, mctc1);
  mcposadiffraction_detector_1_exit_volume = coords_add(mcposachannel_1_cave1_cyl1, mctc2);
  mctc1 = coords_sub(mcposainter_analyzer_colimator_1_blade_4, mcposadiffraction_detector_1_exit_volume);
  mcposrdiffraction_detector_1_exit_volume = rot_apply(mcrotadiffraction_detector_1_exit_volume, mctc1);
  mcDEBUG_COMPONENT("diffraction_detector_1_exit_volume", mcposadiffraction_detector_1_exit_volume, mcrotadiffraction_detector_1_exit_volume)
  mccomp_posa[198] = mcposadiffraction_detector_1_exit_volume;
  mccomp_posr[198] = mcposrdiffraction_detector_1_exit_volume;
  mcNCounter[198]  = mcPCounter[198] = mcP2Counter[198] = 0;
  mcAbsorbProp[198]= 0;
    /* Component spec_detector_1_exit_volume. */
  /* Setting parameters for component spec_detector_1_exit_volume. */
  SIG_MESSAGE("spec_detector_1_exit_volume (Init:SetPar)");
#line 910 "MACS_sample_kidney_box.instr"
  if("Exit") strncpy(mccspec_detector_1_exit_volume_material_string, "Exit" ? "Exit" : "", 16384); else mccspec_detector_1_exit_volume_material_string[0]='\0';
#line 910 "MACS_sample_kidney_box.instr"
  mccspec_detector_1_exit_volume_priority = 332;
#line 909 "MACS_sample_kidney_box.instr"
  mccspec_detector_1_exit_volume_xwidth = 2.01 * detector_radius;
#line 909 "MACS_sample_kidney_box.instr"
  mccspec_detector_1_exit_volume_yheight = 1.01 * detector_height;
#line 909 "MACS_sample_kidney_box.instr"
  mccspec_detector_1_exit_volume_zdepth = 0.001;
#line 71 "MACS_sample_kidney_box.instr"
  mccspec_detector_1_exit_volume_xwidth2 = -1;
#line 71 "MACS_sample_kidney_box.instr"
  mccspec_detector_1_exit_volume_yheight2 = -1;
#line 71 "MACS_sample_kidney_box.instr"
  mccspec_detector_1_exit_volume_visualize = 1;
#line 71 "MACS_sample_kidney_box.instr"
  mccspec_detector_1_exit_volume_target_index = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccspec_detector_1_exit_volume_target_x = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccspec_detector_1_exit_volume_target_y = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccspec_detector_1_exit_volume_target_z = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccspec_detector_1_exit_volume_focus_aw = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccspec_detector_1_exit_volume_focus_ah = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccspec_detector_1_exit_volume_focus_xw = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccspec_detector_1_exit_volume_focus_xh = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccspec_detector_1_exit_volume_focus_r = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccspec_detector_1_exit_volume_p_interact = 0;
#line 71 "MACS_sample_kidney_box.instr"
  if(0) strncpy(mccspec_detector_1_exit_volume_mask_string, 0 ? 0 : "", 16384); else mccspec_detector_1_exit_volume_mask_string[0]='\0';
#line 71 "MACS_sample_kidney_box.instr"
  if(0) strncpy(mccspec_detector_1_exit_volume_mask_setting, 0 ? 0 : "", 16384); else mccspec_detector_1_exit_volume_mask_setting[0]='\0';
#line 71 "MACS_sample_kidney_box.instr"
  mccspec_detector_1_exit_volume_number_of_activations = 1;
#line 101587 "MACS_sample_kidney_box.c"

  SIG_MESSAGE("spec_detector_1_exit_volume (Init:Place/Rotate)");
  rot_set_rotation(mctr1,
#line 912 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 912 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 912 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD);
#line 101597 "MACS_sample_kidney_box.c"
  rot_mul(mctr1, mcrotachannel_1_analyzer_2_center, mcrotaspec_detector_1_exit_volume);
  rot_transpose(mcrotadiffraction_detector_1_exit_volume, mctr1);
  rot_mul(mcrotaspec_detector_1_exit_volume, mctr1, mcrotrspec_detector_1_exit_volume);
  mctc1 = coords_set(
#line 911 "MACS_sample_kidney_box.instr"
    0,
#line 911 "MACS_sample_kidney_box.instr"
    0,
#line 911 "MACS_sample_kidney_box.instr"
    0);
#line 101608 "MACS_sample_kidney_box.c"
  rot_transpose(mcrotachannel_1_cave2_cyl1, mctr1);
  mctc2 = rot_apply(mctr1, mctc1);
  mcposaspec_detector_1_exit_volume = coords_add(mcposachannel_1_cave2_cyl1, mctc2);
  mctc1 = coords_sub(mcposadiffraction_detector_1_exit_volume, mcposaspec_detector_1_exit_volume);
  mcposrspec_detector_1_exit_volume = rot_apply(mcrotaspec_detector_1_exit_volume, mctc1);
  mcDEBUG_COMPONENT("spec_detector_1_exit_volume", mcposaspec_detector_1_exit_volume, mcrotaspec_detector_1_exit_volume)
  mccomp_posa[199] = mcposaspec_detector_1_exit_volume;
  mccomp_posr[199] = mcposrspec_detector_1_exit_volume;
  mcNCounter[199]  = mcPCounter[199] = mcP2Counter[199] = 0;
  mcAbsorbProp[199]= 0;
    /* Component channel_2_cave1_box1. */
  /* Setting parameters for component channel_2_cave1_box1. */
  SIG_MESSAGE("channel_2_cave1_box1 (Init:SetPar)");
#line 917 "MACS_sample_kidney_box.instr"
  if("Vacuum") strncpy(mccchannel_2_cave1_box1_material_string, "Vacuum" ? "Vacuum" : "", 16384); else mccchannel_2_cave1_box1_material_string[0]='\0';
#line 917 "MACS_sample_kidney_box.instr"
  mccchannel_2_cave1_box1_priority = 400;
#line 915 "MACS_sample_kidney_box.instr"
  mccchannel_2_cave1_box1_xwidth = kidney_cave1_box1_width1;
#line 915 "MACS_sample_kidney_box.instr"
  mccchannel_2_cave1_box1_yheight = kidney_cave1_box1_height1;
#line 915 "MACS_sample_kidney_box.instr"
  mccchannel_2_cave1_box1_zdepth = kidney_cave1_box1_depth;
#line 916 "MACS_sample_kidney_box.instr"
  mccchannel_2_cave1_box1_xwidth2 = kidney_cave1_box1_width2;
#line 916 "MACS_sample_kidney_box.instr"
  mccchannel_2_cave1_box1_yheight2 = kidney_cave1_box1_height2;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_2_cave1_box1_visualize = 1;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_2_cave1_box1_target_index = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_2_cave1_box1_target_x = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_2_cave1_box1_target_y = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_2_cave1_box1_target_z = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_2_cave1_box1_focus_aw = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_2_cave1_box1_focus_ah = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_2_cave1_box1_focus_xw = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_2_cave1_box1_focus_xh = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_2_cave1_box1_focus_r = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_2_cave1_box1_p_interact = 0;
#line 71 "MACS_sample_kidney_box.instr"
  if(0) strncpy(mccchannel_2_cave1_box1_mask_string, 0 ? 0 : "", 16384); else mccchannel_2_cave1_box1_mask_string[0]='\0';
#line 71 "MACS_sample_kidney_box.instr"
  if(0) strncpy(mccchannel_2_cave1_box1_mask_setting, 0 ? 0 : "", 16384); else mccchannel_2_cave1_box1_mask_setting[0]='\0';
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_2_cave1_box1_number_of_activations = 1;
#line 101664 "MACS_sample_kidney_box.c"

  SIG_MESSAGE("channel_2_cave1_box1 (Init:Place/Rotate)");
  rot_set_rotation(mctr1,
#line 919 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 919 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 919 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD);
#line 101674 "MACS_sample_kidney_box.c"
  rot_mul(mctr1, mcrotakidney_channel_2, mcrotachannel_2_cave1_box1);
  rot_transpose(mcrotaspec_detector_1_exit_volume, mctr1);
  rot_mul(mcrotachannel_2_cave1_box1, mctr1, mcrotrchannel_2_cave1_box1);
  mctc1 = coords_set(
#line 918 "MACS_sample_kidney_box.instr"
    0,
#line 918 "MACS_sample_kidney_box.instr"
    0,
#line 918 "MACS_sample_kidney_box.instr"
    kidney_cave1_box1_center_to_target);
#line 101685 "MACS_sample_kidney_box.c"
  rot_transpose(mcrotakidney_channel_2, mctr1);
  mctc2 = rot_apply(mctr1, mctc1);
  mcposachannel_2_cave1_box1 = coords_add(mcposakidney_channel_2, mctc2);
  mctc1 = coords_sub(mcposaspec_detector_1_exit_volume, mcposachannel_2_cave1_box1);
  mcposrchannel_2_cave1_box1 = rot_apply(mcrotachannel_2_cave1_box1, mctc1);
  mcDEBUG_COMPONENT("channel_2_cave1_box1", mcposachannel_2_cave1_box1, mcrotachannel_2_cave1_box1)
  mccomp_posa[200] = mcposachannel_2_cave1_box1;
  mccomp_posr[200] = mcposrchannel_2_cave1_box1;
  mcNCounter[200]  = mcPCounter[200] = mcP2Counter[200] = 0;
  mcAbsorbProp[200]= 0;
    /* Component channel_2_cave1_box2. */
  /* Setting parameters for component channel_2_cave1_box2. */
  SIG_MESSAGE("channel_2_cave1_box2 (Init:SetPar)");
#line 924 "MACS_sample_kidney_box.instr"
  if("Vacuum") strncpy(mccchannel_2_cave1_box2_material_string, "Vacuum" ? "Vacuum" : "", 16384); else mccchannel_2_cave1_box2_material_string[0]='\0';
#line 924 "MACS_sample_kidney_box.instr"
  mccchannel_2_cave1_box2_priority = 405;
#line 922 "MACS_sample_kidney_box.instr"
  mccchannel_2_cave1_box2_xwidth = kidney_cave1_box2_width1;
#line 922 "MACS_sample_kidney_box.instr"
  mccchannel_2_cave1_box2_yheight = kidney_cave1_box2_height1;
#line 922 "MACS_sample_kidney_box.instr"
  mccchannel_2_cave1_box2_zdepth = kidney_cave1_box2_depth;
#line 923 "MACS_sample_kidney_box.instr"
  mccchannel_2_cave1_box2_xwidth2 = kidney_cave1_box2_width2;
#line 923 "MACS_sample_kidney_box.instr"
  mccchannel_2_cave1_box2_yheight2 = kidney_cave1_box2_height2;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_2_cave1_box2_visualize = 1;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_2_cave1_box2_target_index = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_2_cave1_box2_target_x = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_2_cave1_box2_target_y = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_2_cave1_box2_target_z = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_2_cave1_box2_focus_aw = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_2_cave1_box2_focus_ah = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_2_cave1_box2_focus_xw = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_2_cave1_box2_focus_xh = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_2_cave1_box2_focus_r = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_2_cave1_box2_p_interact = 0;
#line 71 "MACS_sample_kidney_box.instr"
  if(0) strncpy(mccchannel_2_cave1_box2_mask_string, 0 ? 0 : "", 16384); else mccchannel_2_cave1_box2_mask_string[0]='\0';
#line 71 "MACS_sample_kidney_box.instr"
  if(0) strncpy(mccchannel_2_cave1_box2_mask_setting, 0 ? 0 : "", 16384); else mccchannel_2_cave1_box2_mask_setting[0]='\0';
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_2_cave1_box2_number_of_activations = 1;
#line 101741 "MACS_sample_kidney_box.c"

  SIG_MESSAGE("channel_2_cave1_box2 (Init:Place/Rotate)");
  rot_set_rotation(mctr1,
#line 926 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 926 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 926 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD);
#line 101751 "MACS_sample_kidney_box.c"
  rot_mul(mctr1, mcrotakidney_channel_2, mcrotachannel_2_cave1_box2);
  rot_transpose(mcrotachannel_2_cave1_box1, mctr1);
  rot_mul(mcrotachannel_2_cave1_box2, mctr1, mcrotrchannel_2_cave1_box2);
  mctc1 = coords_set(
#line 925 "MACS_sample_kidney_box.instr"
    kidney_cave1_box2_x_offset,
#line 925 "MACS_sample_kidney_box.instr"
    0,
#line 925 "MACS_sample_kidney_box.instr"
    kidney_cave1_box2_center_to_target);
#line 101762 "MACS_sample_kidney_box.c"
  rot_transpose(mcrotakidney_channel_2, mctr1);
  mctc2 = rot_apply(mctr1, mctc1);
  mcposachannel_2_cave1_box2 = coords_add(mcposakidney_channel_2, mctc2);
  mctc1 = coords_sub(mcposachannel_2_cave1_box1, mcposachannel_2_cave1_box2);
  mcposrchannel_2_cave1_box2 = rot_apply(mcrotachannel_2_cave1_box2, mctc1);
  mcDEBUG_COMPONENT("channel_2_cave1_box2", mcposachannel_2_cave1_box2, mcrotachannel_2_cave1_box2)
  mccomp_posa[201] = mcposachannel_2_cave1_box2;
  mccomp_posr[201] = mcposrchannel_2_cave1_box2;
  mcNCounter[201]  = mcPCounter[201] = mcP2Counter[201] = 0;
  mcAbsorbProp[201]= 0;
    /* Component channel_2_cave1_box3. */
  /* Setting parameters for component channel_2_cave1_box3. */
  SIG_MESSAGE("channel_2_cave1_box3 (Init:SetPar)");
#line 931 "MACS_sample_kidney_box.instr"
  if("Vacuum") strncpy(mccchannel_2_cave1_box3_material_string, "Vacuum" ? "Vacuum" : "", 16384); else mccchannel_2_cave1_box3_material_string[0]='\0';
#line 931 "MACS_sample_kidney_box.instr"
  mccchannel_2_cave1_box3_priority = 402;
#line 929 "MACS_sample_kidney_box.instr"
  mccchannel_2_cave1_box3_xwidth = kidney_cave1_box3_width1;
#line 929 "MACS_sample_kidney_box.instr"
  mccchannel_2_cave1_box3_yheight = kidney_cave1_box3_height1;
#line 929 "MACS_sample_kidney_box.instr"
  mccchannel_2_cave1_box3_zdepth = kidney_cave1_box3_depth;
#line 930 "MACS_sample_kidney_box.instr"
  mccchannel_2_cave1_box3_xwidth2 = kidney_cave1_box3_width2;
#line 930 "MACS_sample_kidney_box.instr"
  mccchannel_2_cave1_box3_yheight2 = kidney_cave1_box3_height2;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_2_cave1_box3_visualize = 1;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_2_cave1_box3_target_index = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_2_cave1_box3_target_x = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_2_cave1_box3_target_y = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_2_cave1_box3_target_z = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_2_cave1_box3_focus_aw = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_2_cave1_box3_focus_ah = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_2_cave1_box3_focus_xw = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_2_cave1_box3_focus_xh = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_2_cave1_box3_focus_r = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_2_cave1_box3_p_interact = 0;
#line 71 "MACS_sample_kidney_box.instr"
  if(0) strncpy(mccchannel_2_cave1_box3_mask_string, 0 ? 0 : "", 16384); else mccchannel_2_cave1_box3_mask_string[0]='\0';
#line 71 "MACS_sample_kidney_box.instr"
  if(0) strncpy(mccchannel_2_cave1_box3_mask_setting, 0 ? 0 : "", 16384); else mccchannel_2_cave1_box3_mask_setting[0]='\0';
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_2_cave1_box3_number_of_activations = 1;
#line 101818 "MACS_sample_kidney_box.c"

  SIG_MESSAGE("channel_2_cave1_box3 (Init:Place/Rotate)");
  rot_set_rotation(mctr1,
#line 933 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 933 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 933 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD);
#line 101828 "MACS_sample_kidney_box.c"
  rot_mul(mctr1, mcrotakidney_channel_2, mcrotachannel_2_cave1_box3);
  rot_transpose(mcrotachannel_2_cave1_box2, mctr1);
  rot_mul(mcrotachannel_2_cave1_box3, mctr1, mcrotrchannel_2_cave1_box3);
  mctc1 = coords_set(
#line 932 "MACS_sample_kidney_box.instr"
    0,
#line 932 "MACS_sample_kidney_box.instr"
    0,
#line 932 "MACS_sample_kidney_box.instr"
    kidney_cave1_box3_center_to_target);
#line 101839 "MACS_sample_kidney_box.c"
  rot_transpose(mcrotakidney_channel_2, mctr1);
  mctc2 = rot_apply(mctr1, mctc1);
  mcposachannel_2_cave1_box3 = coords_add(mcposakidney_channel_2, mctc2);
  mctc1 = coords_sub(mcposachannel_2_cave1_box2, mcposachannel_2_cave1_box3);
  mcposrchannel_2_cave1_box3 = rot_apply(mcrotachannel_2_cave1_box3, mctc1);
  mcDEBUG_COMPONENT("channel_2_cave1_box3", mcposachannel_2_cave1_box3, mcrotachannel_2_cave1_box3)
  mccomp_posa[202] = mcposachannel_2_cave1_box3;
  mccomp_posr[202] = mcposrchannel_2_cave1_box3;
  mcNCounter[202]  = mcPCounter[202] = mcP2Counter[202] = 0;
  mcAbsorbProp[202]= 0;
    /* Component channel_2_cave1_cyl1. */
  /* Setting parameters for component channel_2_cave1_cyl1. */
  SIG_MESSAGE("channel_2_cave1_cyl1 (Init:SetPar)");
#line 937 "MACS_sample_kidney_box.instr"
  if("Vacuum") strncpy(mccchannel_2_cave1_cyl1_material_string, "Vacuum" ? "Vacuum" : "", 16384); else mccchannel_2_cave1_cyl1_material_string[0]='\0';
#line 937 "MACS_sample_kidney_box.instr"
  mccchannel_2_cave1_cyl1_priority = 403;
#line 936 "MACS_sample_kidney_box.instr"
  mccchannel_2_cave1_cyl1_radius = kidney_cave1_cyl1_radius;
#line 936 "MACS_sample_kidney_box.instr"
  mccchannel_2_cave1_cyl1_yheight = kidney_cave1_cyl1_height;
#line 67 "MACS_sample_kidney_box.instr"
  mccchannel_2_cave1_cyl1_visualize = 1;
#line 67 "MACS_sample_kidney_box.instr"
  mccchannel_2_cave1_cyl1_target_index = 0;
#line 67 "MACS_sample_kidney_box.instr"
  mccchannel_2_cave1_cyl1_target_x = 0;
#line 67 "MACS_sample_kidney_box.instr"
  mccchannel_2_cave1_cyl1_target_y = 0;
#line 67 "MACS_sample_kidney_box.instr"
  mccchannel_2_cave1_cyl1_target_z = 0;
#line 67 "MACS_sample_kidney_box.instr"
  mccchannel_2_cave1_cyl1_focus_aw = 0;
#line 67 "MACS_sample_kidney_box.instr"
  mccchannel_2_cave1_cyl1_focus_ah = 0;
#line 67 "MACS_sample_kidney_box.instr"
  mccchannel_2_cave1_cyl1_focus_xw = 0;
#line 67 "MACS_sample_kidney_box.instr"
  mccchannel_2_cave1_cyl1_focus_xh = 0;
#line 67 "MACS_sample_kidney_box.instr"
  mccchannel_2_cave1_cyl1_focus_r = 0;
#line 67 "MACS_sample_kidney_box.instr"
  mccchannel_2_cave1_cyl1_p_interact = 0;
#line 67 "MACS_sample_kidney_box.instr"
  if(0) strncpy(mccchannel_2_cave1_cyl1_mask_string, 0 ? 0 : "", 16384); else mccchannel_2_cave1_cyl1_mask_string[0]='\0';
#line 67 "MACS_sample_kidney_box.instr"
  if(0) strncpy(mccchannel_2_cave1_cyl1_mask_setting, 0 ? 0 : "", 16384); else mccchannel_2_cave1_cyl1_mask_setting[0]='\0';
#line 67 "MACS_sample_kidney_box.instr"
  mccchannel_2_cave1_cyl1_number_of_activations = 1;
#line 101889 "MACS_sample_kidney_box.c"

  SIG_MESSAGE("channel_2_cave1_cyl1 (Init:Place/Rotate)");
  rot_set_rotation(mctr1,
#line 939 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 939 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 939 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD);
#line 101899 "MACS_sample_kidney_box.c"
  rot_mul(mctr1, mcrotakidney_channel_2, mcrotachannel_2_cave1_cyl1);
  rot_transpose(mcrotachannel_2_cave1_box3, mctr1);
  rot_mul(mcrotachannel_2_cave1_cyl1, mctr1, mcrotrchannel_2_cave1_cyl1);
  mctc1 = coords_set(
#line 938 "MACS_sample_kidney_box.instr"
    0,
#line 938 "MACS_sample_kidney_box.instr"
    0,
#line 938 "MACS_sample_kidney_box.instr"
    kidney_cave1_cyl1_center_to_target);
#line 101910 "MACS_sample_kidney_box.c"
  rot_transpose(mcrotakidney_channel_2, mctr1);
  mctc2 = rot_apply(mctr1, mctc1);
  mcposachannel_2_cave1_cyl1 = coords_add(mcposakidney_channel_2, mctc2);
  mctc1 = coords_sub(mcposachannel_2_cave1_box3, mcposachannel_2_cave1_cyl1);
  mcposrchannel_2_cave1_cyl1 = rot_apply(mcrotachannel_2_cave1_cyl1, mctc1);
  mcDEBUG_COMPONENT("channel_2_cave1_cyl1", mcposachannel_2_cave1_cyl1, mcrotachannel_2_cave1_cyl1)
  mccomp_posa[203] = mcposachannel_2_cave1_cyl1;
  mccomp_posr[203] = mcposrchannel_2_cave1_cyl1;
  mcNCounter[203]  = mcPCounter[203] = mcP2Counter[203] = 0;
  mcAbsorbProp[203]= 0;
    /* Component channel_2_analyzer_1_center. */
  /* Setting parameters for component channel_2_analyzer_1_center. */
  SIG_MESSAGE("channel_2_analyzer_1_center (Init:SetPar)");

  SIG_MESSAGE("channel_2_analyzer_1_center (Init:Place/Rotate)");
  rot_set_rotation(mctr1,
    (0.0)*DEG2RAD,
    (0.0)*DEG2RAD,
    (0.0)*DEG2RAD);
#line 101930 "MACS_sample_kidney_box.c"
  rot_mul(mctr1, mcrotakidney_channel_2, mcrotachannel_2_analyzer_1_center);
  rot_transpose(mcrotachannel_2_cave1_cyl1, mctr1);
  rot_mul(mcrotachannel_2_analyzer_1_center, mctr1, mcrotrchannel_2_analyzer_1_center);
  mctc1 = coords_set(
#line 943 "MACS_sample_kidney_box.instr"
    0,
#line 943 "MACS_sample_kidney_box.instr"
    0,
#line 943 "MACS_sample_kidney_box.instr"
    analyzer_1_center_to_sample);
#line 101941 "MACS_sample_kidney_box.c"
  rot_transpose(mcrotakidney_channel_2, mctr1);
  mctc2 = rot_apply(mctr1, mctc1);
  mcposachannel_2_analyzer_1_center = coords_add(mcposakidney_channel_2, mctc2);
  mctc1 = coords_sub(mcposachannel_2_cave1_cyl1, mcposachannel_2_analyzer_1_center);
  mcposrchannel_2_analyzer_1_center = rot_apply(mcrotachannel_2_analyzer_1_center, mctc1);
  mcDEBUG_COMPONENT("channel_2_analyzer_1_center", mcposachannel_2_analyzer_1_center, mcrotachannel_2_analyzer_1_center)
  mccomp_posa[204] = mcposachannel_2_analyzer_1_center;
  mccomp_posr[204] = mcposrchannel_2_analyzer_1_center;
  mcNCounter[204]  = mcPCounter[204] = mcP2Counter[204] = 0;
  mcAbsorbProp[204]= 0;
    /* Component channel_2_analyzer_1_rotated. */
  /* Setting parameters for component channel_2_analyzer_1_rotated. */
  SIG_MESSAGE("channel_2_analyzer_1_rotated (Init:SetPar)");

  SIG_MESSAGE("channel_2_analyzer_1_rotated (Init:Place/Rotate)");
  rot_set_rotation(mctr1,
#line 947 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 947 "MACS_sample_kidney_box.instr"
    (180 - analyzer_theta [ 2 ])*DEG2RAD,
#line 947 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD);
#line 101964 "MACS_sample_kidney_box.c"
  rot_mul(mctr1, mcrotachannel_2_analyzer_1_center, mcrotachannel_2_analyzer_1_rotated);
  rot_transpose(mcrotachannel_2_analyzer_1_center, mctr1);
  rot_mul(mcrotachannel_2_analyzer_1_rotated, mctr1, mcrotrchannel_2_analyzer_1_rotated);
  mctc1 = coords_set(
#line 946 "MACS_sample_kidney_box.instr"
    0,
#line 946 "MACS_sample_kidney_box.instr"
    0,
#line 946 "MACS_sample_kidney_box.instr"
    -0.5 * analyzer_seperation / tan ( analyzer_2theta [ 2 ] * DEG2RAD ));
#line 101975 "MACS_sample_kidney_box.c"
  rot_transpose(mcrotachannel_2_analyzer_1_center, mctr1);
  mctc2 = rot_apply(mctr1, mctc1);
  mcposachannel_2_analyzer_1_rotated = coords_add(mcposachannel_2_analyzer_1_center, mctc2);
  mctc1 = coords_sub(mcposachannel_2_analyzer_1_center, mcposachannel_2_analyzer_1_rotated);
  mcposrchannel_2_analyzer_1_rotated = rot_apply(mcrotachannel_2_analyzer_1_rotated, mctc1);
  mcDEBUG_COMPONENT("channel_2_analyzer_1_rotated", mcposachannel_2_analyzer_1_rotated, mcrotachannel_2_analyzer_1_rotated)
  mccomp_posa[205] = mcposachannel_2_analyzer_1_rotated;
  mccomp_posr[205] = mcposrchannel_2_analyzer_1_rotated;
  mcNCounter[205]  = mcPCounter[205] = mcP2Counter[205] = 0;
  mcAbsorbProp[205]= 0;
    /* Component channel_2_analyzer_1_array_crystal_array_0. */
  /* Setting parameters for component channel_2_analyzer_1_array_crystal_array_0. */
  SIG_MESSAGE("channel_2_analyzer_1_array_crystal_array_0 (Init:SetPar)");
#line 951 "MACS_sample_kidney_box.instr"
  if("PG_analyzer") strncpy(mccchannel_2_analyzer_1_array_crystal_array_0_material_string, "PG_analyzer" ? "PG_analyzer" : "", 16384); else mccchannel_2_analyzer_1_array_crystal_array_0_material_string[0]='\0';
#line 951 "MACS_sample_kidney_box.instr"
  mccchannel_2_analyzer_1_array_crystal_array_0_priority = 420.0;
#line 950 "MACS_sample_kidney_box.instr"
  mccchannel_2_analyzer_1_array_crystal_array_0_xwidth = channel_2_analyzer_1_array_crystal_depth;
#line 950 "MACS_sample_kidney_box.instr"
  mccchannel_2_analyzer_1_array_crystal_array_0_yheight = channel_2_analyzer_1_array_crystal_height;
#line 950 "MACS_sample_kidney_box.instr"
  mccchannel_2_analyzer_1_array_crystal_array_0_zdepth = channel_2_analyzer_1_array_crystal_width;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_2_analyzer_1_array_crystal_array_0_xwidth2 = -1;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_2_analyzer_1_array_crystal_array_0_yheight2 = -1;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_2_analyzer_1_array_crystal_array_0_visualize = 1;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_2_analyzer_1_array_crystal_array_0_target_index = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_2_analyzer_1_array_crystal_array_0_target_x = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_2_analyzer_1_array_crystal_array_0_target_y = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_2_analyzer_1_array_crystal_array_0_target_z = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_2_analyzer_1_array_crystal_array_0_focus_aw = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_2_analyzer_1_array_crystal_array_0_focus_ah = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_2_analyzer_1_array_crystal_array_0_focus_xw = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_2_analyzer_1_array_crystal_array_0_focus_xh = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_2_analyzer_1_array_crystal_array_0_focus_r = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_2_analyzer_1_array_crystal_array_0_p_interact = 0;
#line 71 "MACS_sample_kidney_box.instr"
  if(0) strncpy(mccchannel_2_analyzer_1_array_crystal_array_0_mask_string, 0 ? 0 : "", 16384); else mccchannel_2_analyzer_1_array_crystal_array_0_mask_string[0]='\0';
#line 71 "MACS_sample_kidney_box.instr"
  if(0) strncpy(mccchannel_2_analyzer_1_array_crystal_array_0_mask_setting, 0 ? 0 : "", 16384); else mccchannel_2_analyzer_1_array_crystal_array_0_mask_setting[0]='\0';
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_2_analyzer_1_array_crystal_array_0_number_of_activations = 1;
#line 102031 "MACS_sample_kidney_box.c"

  SIG_MESSAGE("channel_2_analyzer_1_array_crystal_array_0 (Init:Place/Rotate)");
  rot_set_rotation(mctr1,
#line 953 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 953 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 953 "MACS_sample_kidney_box.instr"
    (0 - RAD2DEG * channel_2_analyzer_1_array_theta [ 0 ])*DEG2RAD);
#line 102041 "MACS_sample_kidney_box.c"
  rot_mul(mctr1, mcrotachannel_2_analyzer_1_rotated, mcrotachannel_2_analyzer_1_array_crystal_array_0);
  rot_transpose(mcrotachannel_2_analyzer_1_rotated, mctr1);
  rot_mul(mcrotachannel_2_analyzer_1_array_crystal_array_0, mctr1, mcrotrchannel_2_analyzer_1_array_crystal_array_0);
  mctc1 = coords_set(
#line 952 "MACS_sample_kidney_box.instr"
    0 + channel_2_analyzer_1_array_effective_radius_of_curvature * ( 1 - cos ( channel_2_analyzer_1_array_theta [ 0 ] ) ),
#line 952 "MACS_sample_kidney_box.instr"
    0 + channel_2_analyzer_1_array_effective_radius_of_curvature * sin ( channel_2_analyzer_1_array_theta [ 0 ] ),
#line 952 "MACS_sample_kidney_box.instr"
    0);
#line 102052 "MACS_sample_kidney_box.c"
  rot_transpose(mcrotachannel_2_analyzer_1_rotated, mctr1);
  mctc2 = rot_apply(mctr1, mctc1);
  mcposachannel_2_analyzer_1_array_crystal_array_0 = coords_add(mcposachannel_2_analyzer_1_rotated, mctc2);
  mctc1 = coords_sub(mcposachannel_2_analyzer_1_rotated, mcposachannel_2_analyzer_1_array_crystal_array_0);
  mcposrchannel_2_analyzer_1_array_crystal_array_0 = rot_apply(mcrotachannel_2_analyzer_1_array_crystal_array_0, mctc1);
  mcDEBUG_COMPONENT("channel_2_analyzer_1_array_crystal_array_0", mcposachannel_2_analyzer_1_array_crystal_array_0, mcrotachannel_2_analyzer_1_array_crystal_array_0)
  mccomp_posa[206] = mcposachannel_2_analyzer_1_array_crystal_array_0;
  mccomp_posr[206] = mcposrchannel_2_analyzer_1_array_crystal_array_0;
  mcNCounter[206]  = mcPCounter[206] = mcP2Counter[206] = 0;
  mcAbsorbProp[206]= 0;
    /* Component channel_2_analyzer_1_array_crystal_array_1. */
  /* Setting parameters for component channel_2_analyzer_1_array_crystal_array_1. */
  SIG_MESSAGE("channel_2_analyzer_1_array_crystal_array_1 (Init:SetPar)");
#line 957 "MACS_sample_kidney_box.instr"
  if("PG_analyzer") strncpy(mccchannel_2_analyzer_1_array_crystal_array_1_material_string, "PG_analyzer" ? "PG_analyzer" : "", 16384); else mccchannel_2_analyzer_1_array_crystal_array_1_material_string[0]='\0';
#line 957 "MACS_sample_kidney_box.instr"
  mccchannel_2_analyzer_1_array_crystal_array_1_priority = 420.1;
#line 956 "MACS_sample_kidney_box.instr"
  mccchannel_2_analyzer_1_array_crystal_array_1_xwidth = channel_2_analyzer_1_array_crystal_depth;
#line 956 "MACS_sample_kidney_box.instr"
  mccchannel_2_analyzer_1_array_crystal_array_1_yheight = channel_2_analyzer_1_array_crystal_height;
#line 956 "MACS_sample_kidney_box.instr"
  mccchannel_2_analyzer_1_array_crystal_array_1_zdepth = channel_2_analyzer_1_array_crystal_width;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_2_analyzer_1_array_crystal_array_1_xwidth2 = -1;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_2_analyzer_1_array_crystal_array_1_yheight2 = -1;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_2_analyzer_1_array_crystal_array_1_visualize = 1;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_2_analyzer_1_array_crystal_array_1_target_index = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_2_analyzer_1_array_crystal_array_1_target_x = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_2_analyzer_1_array_crystal_array_1_target_y = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_2_analyzer_1_array_crystal_array_1_target_z = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_2_analyzer_1_array_crystal_array_1_focus_aw = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_2_analyzer_1_array_crystal_array_1_focus_ah = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_2_analyzer_1_array_crystal_array_1_focus_xw = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_2_analyzer_1_array_crystal_array_1_focus_xh = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_2_analyzer_1_array_crystal_array_1_focus_r = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_2_analyzer_1_array_crystal_array_1_p_interact = 0;
#line 71 "MACS_sample_kidney_box.instr"
  if(0) strncpy(mccchannel_2_analyzer_1_array_crystal_array_1_mask_string, 0 ? 0 : "", 16384); else mccchannel_2_analyzer_1_array_crystal_array_1_mask_string[0]='\0';
#line 71 "MACS_sample_kidney_box.instr"
  if(0) strncpy(mccchannel_2_analyzer_1_array_crystal_array_1_mask_setting, 0 ? 0 : "", 16384); else mccchannel_2_analyzer_1_array_crystal_array_1_mask_setting[0]='\0';
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_2_analyzer_1_array_crystal_array_1_number_of_activations = 1;
#line 102108 "MACS_sample_kidney_box.c"

  SIG_MESSAGE("channel_2_analyzer_1_array_crystal_array_1 (Init:Place/Rotate)");
  rot_set_rotation(mctr1,
#line 959 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 959 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 959 "MACS_sample_kidney_box.instr"
    (0 - RAD2DEG * channel_2_analyzer_1_array_theta [ 1 ])*DEG2RAD);
#line 102118 "MACS_sample_kidney_box.c"
  rot_mul(mctr1, mcrotachannel_2_analyzer_1_rotated, mcrotachannel_2_analyzer_1_array_crystal_array_1);
  rot_transpose(mcrotachannel_2_analyzer_1_array_crystal_array_0, mctr1);
  rot_mul(mcrotachannel_2_analyzer_1_array_crystal_array_1, mctr1, mcrotrchannel_2_analyzer_1_array_crystal_array_1);
  mctc1 = coords_set(
#line 958 "MACS_sample_kidney_box.instr"
    0 + channel_2_analyzer_1_array_effective_radius_of_curvature * ( 1 - cos ( channel_2_analyzer_1_array_theta [ 1 ] ) ),
#line 958 "MACS_sample_kidney_box.instr"
    0 + channel_2_analyzer_1_array_effective_radius_of_curvature * sin ( channel_2_analyzer_1_array_theta [ 1 ] ),
#line 958 "MACS_sample_kidney_box.instr"
    0);
#line 102129 "MACS_sample_kidney_box.c"
  rot_transpose(mcrotachannel_2_analyzer_1_rotated, mctr1);
  mctc2 = rot_apply(mctr1, mctc1);
  mcposachannel_2_analyzer_1_array_crystal_array_1 = coords_add(mcposachannel_2_analyzer_1_rotated, mctc2);
  mctc1 = coords_sub(mcposachannel_2_analyzer_1_array_crystal_array_0, mcposachannel_2_analyzer_1_array_crystal_array_1);
  mcposrchannel_2_analyzer_1_array_crystal_array_1 = rot_apply(mcrotachannel_2_analyzer_1_array_crystal_array_1, mctc1);
  mcDEBUG_COMPONENT("channel_2_analyzer_1_array_crystal_array_1", mcposachannel_2_analyzer_1_array_crystal_array_1, mcrotachannel_2_analyzer_1_array_crystal_array_1)
  mccomp_posa[207] = mcposachannel_2_analyzer_1_array_crystal_array_1;
  mccomp_posr[207] = mcposrchannel_2_analyzer_1_array_crystal_array_1;
  mcNCounter[207]  = mcPCounter[207] = mcP2Counter[207] = 0;
  mcAbsorbProp[207]= 0;
    /* Component channel_2_analyzer_1_array_crystal_array_2. */
  /* Setting parameters for component channel_2_analyzer_1_array_crystal_array_2. */
  SIG_MESSAGE("channel_2_analyzer_1_array_crystal_array_2 (Init:SetPar)");
#line 963 "MACS_sample_kidney_box.instr"
  if("PG_analyzer") strncpy(mccchannel_2_analyzer_1_array_crystal_array_2_material_string, "PG_analyzer" ? "PG_analyzer" : "", 16384); else mccchannel_2_analyzer_1_array_crystal_array_2_material_string[0]='\0';
#line 963 "MACS_sample_kidney_box.instr"
  mccchannel_2_analyzer_1_array_crystal_array_2_priority = 420.2;
#line 962 "MACS_sample_kidney_box.instr"
  mccchannel_2_analyzer_1_array_crystal_array_2_xwidth = channel_2_analyzer_1_array_crystal_depth;
#line 962 "MACS_sample_kidney_box.instr"
  mccchannel_2_analyzer_1_array_crystal_array_2_yheight = channel_2_analyzer_1_array_crystal_height;
#line 962 "MACS_sample_kidney_box.instr"
  mccchannel_2_analyzer_1_array_crystal_array_2_zdepth = channel_2_analyzer_1_array_crystal_width;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_2_analyzer_1_array_crystal_array_2_xwidth2 = -1;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_2_analyzer_1_array_crystal_array_2_yheight2 = -1;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_2_analyzer_1_array_crystal_array_2_visualize = 1;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_2_analyzer_1_array_crystal_array_2_target_index = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_2_analyzer_1_array_crystal_array_2_target_x = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_2_analyzer_1_array_crystal_array_2_target_y = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_2_analyzer_1_array_crystal_array_2_target_z = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_2_analyzer_1_array_crystal_array_2_focus_aw = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_2_analyzer_1_array_crystal_array_2_focus_ah = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_2_analyzer_1_array_crystal_array_2_focus_xw = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_2_analyzer_1_array_crystal_array_2_focus_xh = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_2_analyzer_1_array_crystal_array_2_focus_r = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_2_analyzer_1_array_crystal_array_2_p_interact = 0;
#line 71 "MACS_sample_kidney_box.instr"
  if(0) strncpy(mccchannel_2_analyzer_1_array_crystal_array_2_mask_string, 0 ? 0 : "", 16384); else mccchannel_2_analyzer_1_array_crystal_array_2_mask_string[0]='\0';
#line 71 "MACS_sample_kidney_box.instr"
  if(0) strncpy(mccchannel_2_analyzer_1_array_crystal_array_2_mask_setting, 0 ? 0 : "", 16384); else mccchannel_2_analyzer_1_array_crystal_array_2_mask_setting[0]='\0';
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_2_analyzer_1_array_crystal_array_2_number_of_activations = 1;
#line 102185 "MACS_sample_kidney_box.c"

  SIG_MESSAGE("channel_2_analyzer_1_array_crystal_array_2 (Init:Place/Rotate)");
  rot_set_rotation(mctr1,
#line 965 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 965 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 965 "MACS_sample_kidney_box.instr"
    (0 - RAD2DEG * channel_2_analyzer_1_array_theta [ 2 ])*DEG2RAD);
#line 102195 "MACS_sample_kidney_box.c"
  rot_mul(mctr1, mcrotachannel_2_analyzer_1_rotated, mcrotachannel_2_analyzer_1_array_crystal_array_2);
  rot_transpose(mcrotachannel_2_analyzer_1_array_crystal_array_1, mctr1);
  rot_mul(mcrotachannel_2_analyzer_1_array_crystal_array_2, mctr1, mcrotrchannel_2_analyzer_1_array_crystal_array_2);
  mctc1 = coords_set(
#line 964 "MACS_sample_kidney_box.instr"
    0 + channel_2_analyzer_1_array_effective_radius_of_curvature * ( 1 - cos ( channel_2_analyzer_1_array_theta [ 2 ] ) ),
#line 964 "MACS_sample_kidney_box.instr"
    0 + channel_2_analyzer_1_array_effective_radius_of_curvature * sin ( channel_2_analyzer_1_array_theta [ 2 ] ),
#line 964 "MACS_sample_kidney_box.instr"
    0);
#line 102206 "MACS_sample_kidney_box.c"
  rot_transpose(mcrotachannel_2_analyzer_1_rotated, mctr1);
  mctc2 = rot_apply(mctr1, mctc1);
  mcposachannel_2_analyzer_1_array_crystal_array_2 = coords_add(mcposachannel_2_analyzer_1_rotated, mctc2);
  mctc1 = coords_sub(mcposachannel_2_analyzer_1_array_crystal_array_1, mcposachannel_2_analyzer_1_array_crystal_array_2);
  mcposrchannel_2_analyzer_1_array_crystal_array_2 = rot_apply(mcrotachannel_2_analyzer_1_array_crystal_array_2, mctc1);
  mcDEBUG_COMPONENT("channel_2_analyzer_1_array_crystal_array_2", mcposachannel_2_analyzer_1_array_crystal_array_2, mcrotachannel_2_analyzer_1_array_crystal_array_2)
  mccomp_posa[208] = mcposachannel_2_analyzer_1_array_crystal_array_2;
  mccomp_posr[208] = mcposrchannel_2_analyzer_1_array_crystal_array_2;
  mcNCounter[208]  = mcPCounter[208] = mcP2Counter[208] = 0;
  mcAbsorbProp[208]= 0;
    /* Component channel_2_analyzer_1_array_crystal_array_3. */
  /* Setting parameters for component channel_2_analyzer_1_array_crystal_array_3. */
  SIG_MESSAGE("channel_2_analyzer_1_array_crystal_array_3 (Init:SetPar)");
#line 969 "MACS_sample_kidney_box.instr"
  if("PG_analyzer") strncpy(mccchannel_2_analyzer_1_array_crystal_array_3_material_string, "PG_analyzer" ? "PG_analyzer" : "", 16384); else mccchannel_2_analyzer_1_array_crystal_array_3_material_string[0]='\0';
#line 969 "MACS_sample_kidney_box.instr"
  mccchannel_2_analyzer_1_array_crystal_array_3_priority = 420.3;
#line 968 "MACS_sample_kidney_box.instr"
  mccchannel_2_analyzer_1_array_crystal_array_3_xwidth = channel_2_analyzer_1_array_crystal_depth;
#line 968 "MACS_sample_kidney_box.instr"
  mccchannel_2_analyzer_1_array_crystal_array_3_yheight = channel_2_analyzer_1_array_crystal_height;
#line 968 "MACS_sample_kidney_box.instr"
  mccchannel_2_analyzer_1_array_crystal_array_3_zdepth = channel_2_analyzer_1_array_crystal_width;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_2_analyzer_1_array_crystal_array_3_xwidth2 = -1;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_2_analyzer_1_array_crystal_array_3_yheight2 = -1;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_2_analyzer_1_array_crystal_array_3_visualize = 1;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_2_analyzer_1_array_crystal_array_3_target_index = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_2_analyzer_1_array_crystal_array_3_target_x = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_2_analyzer_1_array_crystal_array_3_target_y = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_2_analyzer_1_array_crystal_array_3_target_z = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_2_analyzer_1_array_crystal_array_3_focus_aw = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_2_analyzer_1_array_crystal_array_3_focus_ah = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_2_analyzer_1_array_crystal_array_3_focus_xw = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_2_analyzer_1_array_crystal_array_3_focus_xh = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_2_analyzer_1_array_crystal_array_3_focus_r = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_2_analyzer_1_array_crystal_array_3_p_interact = 0;
#line 71 "MACS_sample_kidney_box.instr"
  if(0) strncpy(mccchannel_2_analyzer_1_array_crystal_array_3_mask_string, 0 ? 0 : "", 16384); else mccchannel_2_analyzer_1_array_crystal_array_3_mask_string[0]='\0';
#line 71 "MACS_sample_kidney_box.instr"
  if(0) strncpy(mccchannel_2_analyzer_1_array_crystal_array_3_mask_setting, 0 ? 0 : "", 16384); else mccchannel_2_analyzer_1_array_crystal_array_3_mask_setting[0]='\0';
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_2_analyzer_1_array_crystal_array_3_number_of_activations = 1;
#line 102262 "MACS_sample_kidney_box.c"

  SIG_MESSAGE("channel_2_analyzer_1_array_crystal_array_3 (Init:Place/Rotate)");
  rot_set_rotation(mctr1,
#line 971 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 971 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 971 "MACS_sample_kidney_box.instr"
    (0 - RAD2DEG * channel_2_analyzer_1_array_theta [ 3 ])*DEG2RAD);
#line 102272 "MACS_sample_kidney_box.c"
  rot_mul(mctr1, mcrotachannel_2_analyzer_1_rotated, mcrotachannel_2_analyzer_1_array_crystal_array_3);
  rot_transpose(mcrotachannel_2_analyzer_1_array_crystal_array_2, mctr1);
  rot_mul(mcrotachannel_2_analyzer_1_array_crystal_array_3, mctr1, mcrotrchannel_2_analyzer_1_array_crystal_array_3);
  mctc1 = coords_set(
#line 970 "MACS_sample_kidney_box.instr"
    0 + channel_2_analyzer_1_array_effective_radius_of_curvature * ( 1 - cos ( channel_2_analyzer_1_array_theta [ 3 ] ) ),
#line 970 "MACS_sample_kidney_box.instr"
    0 + channel_2_analyzer_1_array_effective_radius_of_curvature * sin ( channel_2_analyzer_1_array_theta [ 3 ] ),
#line 970 "MACS_sample_kidney_box.instr"
    0);
#line 102283 "MACS_sample_kidney_box.c"
  rot_transpose(mcrotachannel_2_analyzer_1_rotated, mctr1);
  mctc2 = rot_apply(mctr1, mctc1);
  mcposachannel_2_analyzer_1_array_crystal_array_3 = coords_add(mcposachannel_2_analyzer_1_rotated, mctc2);
  mctc1 = coords_sub(mcposachannel_2_analyzer_1_array_crystal_array_2, mcposachannel_2_analyzer_1_array_crystal_array_3);
  mcposrchannel_2_analyzer_1_array_crystal_array_3 = rot_apply(mcrotachannel_2_analyzer_1_array_crystal_array_3, mctc1);
  mcDEBUG_COMPONENT("channel_2_analyzer_1_array_crystal_array_3", mcposachannel_2_analyzer_1_array_crystal_array_3, mcrotachannel_2_analyzer_1_array_crystal_array_3)
  mccomp_posa[209] = mcposachannel_2_analyzer_1_array_crystal_array_3;
  mccomp_posr[209] = mcposrchannel_2_analyzer_1_array_crystal_array_3;
  mcNCounter[209]  = mcPCounter[209] = mcP2Counter[209] = 0;
  mcAbsorbProp[209]= 0;
    /* Component channel_2_analyzer_1_array_crystal_array_4. */
  /* Setting parameters for component channel_2_analyzer_1_array_crystal_array_4. */
  SIG_MESSAGE("channel_2_analyzer_1_array_crystal_array_4 (Init:SetPar)");
#line 975 "MACS_sample_kidney_box.instr"
  if("PG_analyzer") strncpy(mccchannel_2_analyzer_1_array_crystal_array_4_material_string, "PG_analyzer" ? "PG_analyzer" : "", 16384); else mccchannel_2_analyzer_1_array_crystal_array_4_material_string[0]='\0';
#line 975 "MACS_sample_kidney_box.instr"
  mccchannel_2_analyzer_1_array_crystal_array_4_priority = 420.4;
#line 974 "MACS_sample_kidney_box.instr"
  mccchannel_2_analyzer_1_array_crystal_array_4_xwidth = channel_2_analyzer_1_array_crystal_depth;
#line 974 "MACS_sample_kidney_box.instr"
  mccchannel_2_analyzer_1_array_crystal_array_4_yheight = channel_2_analyzer_1_array_crystal_height;
#line 974 "MACS_sample_kidney_box.instr"
  mccchannel_2_analyzer_1_array_crystal_array_4_zdepth = channel_2_analyzer_1_array_crystal_width;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_2_analyzer_1_array_crystal_array_4_xwidth2 = -1;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_2_analyzer_1_array_crystal_array_4_yheight2 = -1;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_2_analyzer_1_array_crystal_array_4_visualize = 1;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_2_analyzer_1_array_crystal_array_4_target_index = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_2_analyzer_1_array_crystal_array_4_target_x = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_2_analyzer_1_array_crystal_array_4_target_y = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_2_analyzer_1_array_crystal_array_4_target_z = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_2_analyzer_1_array_crystal_array_4_focus_aw = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_2_analyzer_1_array_crystal_array_4_focus_ah = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_2_analyzer_1_array_crystal_array_4_focus_xw = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_2_analyzer_1_array_crystal_array_4_focus_xh = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_2_analyzer_1_array_crystal_array_4_focus_r = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_2_analyzer_1_array_crystal_array_4_p_interact = 0;
#line 71 "MACS_sample_kidney_box.instr"
  if(0) strncpy(mccchannel_2_analyzer_1_array_crystal_array_4_mask_string, 0 ? 0 : "", 16384); else mccchannel_2_analyzer_1_array_crystal_array_4_mask_string[0]='\0';
#line 71 "MACS_sample_kidney_box.instr"
  if(0) strncpy(mccchannel_2_analyzer_1_array_crystal_array_4_mask_setting, 0 ? 0 : "", 16384); else mccchannel_2_analyzer_1_array_crystal_array_4_mask_setting[0]='\0';
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_2_analyzer_1_array_crystal_array_4_number_of_activations = 1;
#line 102339 "MACS_sample_kidney_box.c"

  SIG_MESSAGE("channel_2_analyzer_1_array_crystal_array_4 (Init:Place/Rotate)");
  rot_set_rotation(mctr1,
#line 977 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 977 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 977 "MACS_sample_kidney_box.instr"
    (0 - RAD2DEG * channel_2_analyzer_1_array_theta [ 4 ])*DEG2RAD);
#line 102349 "MACS_sample_kidney_box.c"
  rot_mul(mctr1, mcrotachannel_2_analyzer_1_rotated, mcrotachannel_2_analyzer_1_array_crystal_array_4);
  rot_transpose(mcrotachannel_2_analyzer_1_array_crystal_array_3, mctr1);
  rot_mul(mcrotachannel_2_analyzer_1_array_crystal_array_4, mctr1, mcrotrchannel_2_analyzer_1_array_crystal_array_4);
  mctc1 = coords_set(
#line 976 "MACS_sample_kidney_box.instr"
    0 + channel_2_analyzer_1_array_effective_radius_of_curvature * ( 1 - cos ( channel_2_analyzer_1_array_theta [ 4 ] ) ),
#line 976 "MACS_sample_kidney_box.instr"
    0 + channel_2_analyzer_1_array_effective_radius_of_curvature * sin ( channel_2_analyzer_1_array_theta [ 4 ] ),
#line 976 "MACS_sample_kidney_box.instr"
    0);
#line 102360 "MACS_sample_kidney_box.c"
  rot_transpose(mcrotachannel_2_analyzer_1_rotated, mctr1);
  mctc2 = rot_apply(mctr1, mctc1);
  mcposachannel_2_analyzer_1_array_crystal_array_4 = coords_add(mcposachannel_2_analyzer_1_rotated, mctc2);
  mctc1 = coords_sub(mcposachannel_2_analyzer_1_array_crystal_array_3, mcposachannel_2_analyzer_1_array_crystal_array_4);
  mcposrchannel_2_analyzer_1_array_crystal_array_4 = rot_apply(mcrotachannel_2_analyzer_1_array_crystal_array_4, mctc1);
  mcDEBUG_COMPONENT("channel_2_analyzer_1_array_crystal_array_4", mcposachannel_2_analyzer_1_array_crystal_array_4, mcrotachannel_2_analyzer_1_array_crystal_array_4)
  mccomp_posa[210] = mcposachannel_2_analyzer_1_array_crystal_array_4;
  mccomp_posr[210] = mcposrchannel_2_analyzer_1_array_crystal_array_4;
  mcNCounter[210]  = mcPCounter[210] = mcP2Counter[210] = 0;
  mcAbsorbProp[210]= 0;
    /* Component channel_2_analyzer_1_array_crystal_array_5. */
  /* Setting parameters for component channel_2_analyzer_1_array_crystal_array_5. */
  SIG_MESSAGE("channel_2_analyzer_1_array_crystal_array_5 (Init:SetPar)");
#line 981 "MACS_sample_kidney_box.instr"
  if("PG_analyzer") strncpy(mccchannel_2_analyzer_1_array_crystal_array_5_material_string, "PG_analyzer" ? "PG_analyzer" : "", 16384); else mccchannel_2_analyzer_1_array_crystal_array_5_material_string[0]='\0';
#line 981 "MACS_sample_kidney_box.instr"
  mccchannel_2_analyzer_1_array_crystal_array_5_priority = 420.5;
#line 980 "MACS_sample_kidney_box.instr"
  mccchannel_2_analyzer_1_array_crystal_array_5_xwidth = channel_2_analyzer_1_array_crystal_depth;
#line 980 "MACS_sample_kidney_box.instr"
  mccchannel_2_analyzer_1_array_crystal_array_5_yheight = channel_2_analyzer_1_array_crystal_height;
#line 980 "MACS_sample_kidney_box.instr"
  mccchannel_2_analyzer_1_array_crystal_array_5_zdepth = channel_2_analyzer_1_array_crystal_width;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_2_analyzer_1_array_crystal_array_5_xwidth2 = -1;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_2_analyzer_1_array_crystal_array_5_yheight2 = -1;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_2_analyzer_1_array_crystal_array_5_visualize = 1;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_2_analyzer_1_array_crystal_array_5_target_index = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_2_analyzer_1_array_crystal_array_5_target_x = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_2_analyzer_1_array_crystal_array_5_target_y = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_2_analyzer_1_array_crystal_array_5_target_z = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_2_analyzer_1_array_crystal_array_5_focus_aw = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_2_analyzer_1_array_crystal_array_5_focus_ah = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_2_analyzer_1_array_crystal_array_5_focus_xw = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_2_analyzer_1_array_crystal_array_5_focus_xh = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_2_analyzer_1_array_crystal_array_5_focus_r = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_2_analyzer_1_array_crystal_array_5_p_interact = 0;
#line 71 "MACS_sample_kidney_box.instr"
  if(0) strncpy(mccchannel_2_analyzer_1_array_crystal_array_5_mask_string, 0 ? 0 : "", 16384); else mccchannel_2_analyzer_1_array_crystal_array_5_mask_string[0]='\0';
#line 71 "MACS_sample_kidney_box.instr"
  if(0) strncpy(mccchannel_2_analyzer_1_array_crystal_array_5_mask_setting, 0 ? 0 : "", 16384); else mccchannel_2_analyzer_1_array_crystal_array_5_mask_setting[0]='\0';
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_2_analyzer_1_array_crystal_array_5_number_of_activations = 1;
#line 102416 "MACS_sample_kidney_box.c"

  SIG_MESSAGE("channel_2_analyzer_1_array_crystal_array_5 (Init:Place/Rotate)");
  rot_set_rotation(mctr1,
#line 983 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 983 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 983 "MACS_sample_kidney_box.instr"
    (0 - RAD2DEG * channel_2_analyzer_1_array_theta [ 5 ])*DEG2RAD);
#line 102426 "MACS_sample_kidney_box.c"
  rot_mul(mctr1, mcrotachannel_2_analyzer_1_rotated, mcrotachannel_2_analyzer_1_array_crystal_array_5);
  rot_transpose(mcrotachannel_2_analyzer_1_array_crystal_array_4, mctr1);
  rot_mul(mcrotachannel_2_analyzer_1_array_crystal_array_5, mctr1, mcrotrchannel_2_analyzer_1_array_crystal_array_5);
  mctc1 = coords_set(
#line 982 "MACS_sample_kidney_box.instr"
    0 + channel_2_analyzer_1_array_effective_radius_of_curvature * ( 1 - cos ( channel_2_analyzer_1_array_theta [ 5 ] ) ),
#line 982 "MACS_sample_kidney_box.instr"
    0 + channel_2_analyzer_1_array_effective_radius_of_curvature * sin ( channel_2_analyzer_1_array_theta [ 5 ] ),
#line 982 "MACS_sample_kidney_box.instr"
    0);
#line 102437 "MACS_sample_kidney_box.c"
  rot_transpose(mcrotachannel_2_analyzer_1_rotated, mctr1);
  mctc2 = rot_apply(mctr1, mctc1);
  mcposachannel_2_analyzer_1_array_crystal_array_5 = coords_add(mcposachannel_2_analyzer_1_rotated, mctc2);
  mctc1 = coords_sub(mcposachannel_2_analyzer_1_array_crystal_array_4, mcposachannel_2_analyzer_1_array_crystal_array_5);
  mcposrchannel_2_analyzer_1_array_crystal_array_5 = rot_apply(mcrotachannel_2_analyzer_1_array_crystal_array_5, mctc1);
  mcDEBUG_COMPONENT("channel_2_analyzer_1_array_crystal_array_5", mcposachannel_2_analyzer_1_array_crystal_array_5, mcrotachannel_2_analyzer_1_array_crystal_array_5)
  mccomp_posa[211] = mcposachannel_2_analyzer_1_array_crystal_array_5;
  mccomp_posr[211] = mcposrchannel_2_analyzer_1_array_crystal_array_5;
  mcNCounter[211]  = mcPCounter[211] = mcP2Counter[211] = 0;
  mcAbsorbProp[211]= 0;
    /* Component channel_2_analyzer_1_array_crystal_array_6. */
  /* Setting parameters for component channel_2_analyzer_1_array_crystal_array_6. */
  SIG_MESSAGE("channel_2_analyzer_1_array_crystal_array_6 (Init:SetPar)");
#line 987 "MACS_sample_kidney_box.instr"
  if("PG_analyzer") strncpy(mccchannel_2_analyzer_1_array_crystal_array_6_material_string, "PG_analyzer" ? "PG_analyzer" : "", 16384); else mccchannel_2_analyzer_1_array_crystal_array_6_material_string[0]='\0';
#line 987 "MACS_sample_kidney_box.instr"
  mccchannel_2_analyzer_1_array_crystal_array_6_priority = 420.6;
#line 986 "MACS_sample_kidney_box.instr"
  mccchannel_2_analyzer_1_array_crystal_array_6_xwidth = channel_2_analyzer_1_array_crystal_depth;
#line 986 "MACS_sample_kidney_box.instr"
  mccchannel_2_analyzer_1_array_crystal_array_6_yheight = channel_2_analyzer_1_array_crystal_height;
#line 986 "MACS_sample_kidney_box.instr"
  mccchannel_2_analyzer_1_array_crystal_array_6_zdepth = channel_2_analyzer_1_array_crystal_width;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_2_analyzer_1_array_crystal_array_6_xwidth2 = -1;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_2_analyzer_1_array_crystal_array_6_yheight2 = -1;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_2_analyzer_1_array_crystal_array_6_visualize = 1;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_2_analyzer_1_array_crystal_array_6_target_index = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_2_analyzer_1_array_crystal_array_6_target_x = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_2_analyzer_1_array_crystal_array_6_target_y = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_2_analyzer_1_array_crystal_array_6_target_z = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_2_analyzer_1_array_crystal_array_6_focus_aw = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_2_analyzer_1_array_crystal_array_6_focus_ah = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_2_analyzer_1_array_crystal_array_6_focus_xw = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_2_analyzer_1_array_crystal_array_6_focus_xh = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_2_analyzer_1_array_crystal_array_6_focus_r = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_2_analyzer_1_array_crystal_array_6_p_interact = 0;
#line 71 "MACS_sample_kidney_box.instr"
  if(0) strncpy(mccchannel_2_analyzer_1_array_crystal_array_6_mask_string, 0 ? 0 : "", 16384); else mccchannel_2_analyzer_1_array_crystal_array_6_mask_string[0]='\0';
#line 71 "MACS_sample_kidney_box.instr"
  if(0) strncpy(mccchannel_2_analyzer_1_array_crystal_array_6_mask_setting, 0 ? 0 : "", 16384); else mccchannel_2_analyzer_1_array_crystal_array_6_mask_setting[0]='\0';
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_2_analyzer_1_array_crystal_array_6_number_of_activations = 1;
#line 102493 "MACS_sample_kidney_box.c"

  SIG_MESSAGE("channel_2_analyzer_1_array_crystal_array_6 (Init:Place/Rotate)");
  rot_set_rotation(mctr1,
#line 989 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 989 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 989 "MACS_sample_kidney_box.instr"
    (0 - RAD2DEG * channel_2_analyzer_1_array_theta [ 6 ])*DEG2RAD);
#line 102503 "MACS_sample_kidney_box.c"
  rot_mul(mctr1, mcrotachannel_2_analyzer_1_rotated, mcrotachannel_2_analyzer_1_array_crystal_array_6);
  rot_transpose(mcrotachannel_2_analyzer_1_array_crystal_array_5, mctr1);
  rot_mul(mcrotachannel_2_analyzer_1_array_crystal_array_6, mctr1, mcrotrchannel_2_analyzer_1_array_crystal_array_6);
  mctc1 = coords_set(
#line 988 "MACS_sample_kidney_box.instr"
    0 + channel_2_analyzer_1_array_effective_radius_of_curvature * ( 1 - cos ( channel_2_analyzer_1_array_theta [ 6 ] ) ),
#line 988 "MACS_sample_kidney_box.instr"
    0 + channel_2_analyzer_1_array_effective_radius_of_curvature * sin ( channel_2_analyzer_1_array_theta [ 6 ] ),
#line 988 "MACS_sample_kidney_box.instr"
    0);
#line 102514 "MACS_sample_kidney_box.c"
  rot_transpose(mcrotachannel_2_analyzer_1_rotated, mctr1);
  mctc2 = rot_apply(mctr1, mctc1);
  mcposachannel_2_analyzer_1_array_crystal_array_6 = coords_add(mcposachannel_2_analyzer_1_rotated, mctc2);
  mctc1 = coords_sub(mcposachannel_2_analyzer_1_array_crystal_array_5, mcposachannel_2_analyzer_1_array_crystal_array_6);
  mcposrchannel_2_analyzer_1_array_crystal_array_6 = rot_apply(mcrotachannel_2_analyzer_1_array_crystal_array_6, mctc1);
  mcDEBUG_COMPONENT("channel_2_analyzer_1_array_crystal_array_6", mcposachannel_2_analyzer_1_array_crystal_array_6, mcrotachannel_2_analyzer_1_array_crystal_array_6)
  mccomp_posa[212] = mcposachannel_2_analyzer_1_array_crystal_array_6;
  mccomp_posr[212] = mcposrchannel_2_analyzer_1_array_crystal_array_6;
  mcNCounter[212]  = mcPCounter[212] = mcP2Counter[212] = 0;
  mcAbsorbProp[212]= 0;
    /* Component channel_2_analyzer_1_array_crystal_array_7. */
  /* Setting parameters for component channel_2_analyzer_1_array_crystal_array_7. */
  SIG_MESSAGE("channel_2_analyzer_1_array_crystal_array_7 (Init:SetPar)");
#line 993 "MACS_sample_kidney_box.instr"
  if("PG_analyzer") strncpy(mccchannel_2_analyzer_1_array_crystal_array_7_material_string, "PG_analyzer" ? "PG_analyzer" : "", 16384); else mccchannel_2_analyzer_1_array_crystal_array_7_material_string[0]='\0';
#line 993 "MACS_sample_kidney_box.instr"
  mccchannel_2_analyzer_1_array_crystal_array_7_priority = 420.7;
#line 992 "MACS_sample_kidney_box.instr"
  mccchannel_2_analyzer_1_array_crystal_array_7_xwidth = channel_2_analyzer_1_array_crystal_depth;
#line 992 "MACS_sample_kidney_box.instr"
  mccchannel_2_analyzer_1_array_crystal_array_7_yheight = channel_2_analyzer_1_array_crystal_height;
#line 992 "MACS_sample_kidney_box.instr"
  mccchannel_2_analyzer_1_array_crystal_array_7_zdepth = channel_2_analyzer_1_array_crystal_width;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_2_analyzer_1_array_crystal_array_7_xwidth2 = -1;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_2_analyzer_1_array_crystal_array_7_yheight2 = -1;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_2_analyzer_1_array_crystal_array_7_visualize = 1;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_2_analyzer_1_array_crystal_array_7_target_index = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_2_analyzer_1_array_crystal_array_7_target_x = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_2_analyzer_1_array_crystal_array_7_target_y = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_2_analyzer_1_array_crystal_array_7_target_z = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_2_analyzer_1_array_crystal_array_7_focus_aw = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_2_analyzer_1_array_crystal_array_7_focus_ah = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_2_analyzer_1_array_crystal_array_7_focus_xw = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_2_analyzer_1_array_crystal_array_7_focus_xh = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_2_analyzer_1_array_crystal_array_7_focus_r = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_2_analyzer_1_array_crystal_array_7_p_interact = 0;
#line 71 "MACS_sample_kidney_box.instr"
  if(0) strncpy(mccchannel_2_analyzer_1_array_crystal_array_7_mask_string, 0 ? 0 : "", 16384); else mccchannel_2_analyzer_1_array_crystal_array_7_mask_string[0]='\0';
#line 71 "MACS_sample_kidney_box.instr"
  if(0) strncpy(mccchannel_2_analyzer_1_array_crystal_array_7_mask_setting, 0 ? 0 : "", 16384); else mccchannel_2_analyzer_1_array_crystal_array_7_mask_setting[0]='\0';
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_2_analyzer_1_array_crystal_array_7_number_of_activations = 1;
#line 102570 "MACS_sample_kidney_box.c"

  SIG_MESSAGE("channel_2_analyzer_1_array_crystal_array_7 (Init:Place/Rotate)");
  rot_set_rotation(mctr1,
#line 995 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 995 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 995 "MACS_sample_kidney_box.instr"
    (0 - RAD2DEG * channel_2_analyzer_1_array_theta [ 7 ])*DEG2RAD);
#line 102580 "MACS_sample_kidney_box.c"
  rot_mul(mctr1, mcrotachannel_2_analyzer_1_rotated, mcrotachannel_2_analyzer_1_array_crystal_array_7);
  rot_transpose(mcrotachannel_2_analyzer_1_array_crystal_array_6, mctr1);
  rot_mul(mcrotachannel_2_analyzer_1_array_crystal_array_7, mctr1, mcrotrchannel_2_analyzer_1_array_crystal_array_7);
  mctc1 = coords_set(
#line 994 "MACS_sample_kidney_box.instr"
    0 + channel_2_analyzer_1_array_effective_radius_of_curvature * ( 1 - cos ( channel_2_analyzer_1_array_theta [ 7 ] ) ),
#line 994 "MACS_sample_kidney_box.instr"
    0 + channel_2_analyzer_1_array_effective_radius_of_curvature * sin ( channel_2_analyzer_1_array_theta [ 7 ] ),
#line 994 "MACS_sample_kidney_box.instr"
    0);
#line 102591 "MACS_sample_kidney_box.c"
  rot_transpose(mcrotachannel_2_analyzer_1_rotated, mctr1);
  mctc2 = rot_apply(mctr1, mctc1);
  mcposachannel_2_analyzer_1_array_crystal_array_7 = coords_add(mcposachannel_2_analyzer_1_rotated, mctc2);
  mctc1 = coords_sub(mcposachannel_2_analyzer_1_array_crystal_array_6, mcposachannel_2_analyzer_1_array_crystal_array_7);
  mcposrchannel_2_analyzer_1_array_crystal_array_7 = rot_apply(mcrotachannel_2_analyzer_1_array_crystal_array_7, mctc1);
  mcDEBUG_COMPONENT("channel_2_analyzer_1_array_crystal_array_7", mcposachannel_2_analyzer_1_array_crystal_array_7, mcrotachannel_2_analyzer_1_array_crystal_array_7)
  mccomp_posa[213] = mcposachannel_2_analyzer_1_array_crystal_array_7;
  mccomp_posr[213] = mcposrchannel_2_analyzer_1_array_crystal_array_7;
  mcNCounter[213]  = mcPCounter[213] = mcP2Counter[213] = 0;
  mcAbsorbProp[213]= 0;
    /* Component channel_2_analyzer_1_array_crystal_array_8. */
  /* Setting parameters for component channel_2_analyzer_1_array_crystal_array_8. */
  SIG_MESSAGE("channel_2_analyzer_1_array_crystal_array_8 (Init:SetPar)");
#line 999 "MACS_sample_kidney_box.instr"
  if("PG_analyzer") strncpy(mccchannel_2_analyzer_1_array_crystal_array_8_material_string, "PG_analyzer" ? "PG_analyzer" : "", 16384); else mccchannel_2_analyzer_1_array_crystal_array_8_material_string[0]='\0';
#line 999 "MACS_sample_kidney_box.instr"
  mccchannel_2_analyzer_1_array_crystal_array_8_priority = 420.8;
#line 998 "MACS_sample_kidney_box.instr"
  mccchannel_2_analyzer_1_array_crystal_array_8_xwidth = channel_2_analyzer_1_array_crystal_depth;
#line 998 "MACS_sample_kidney_box.instr"
  mccchannel_2_analyzer_1_array_crystal_array_8_yheight = channel_2_analyzer_1_array_crystal_height;
#line 998 "MACS_sample_kidney_box.instr"
  mccchannel_2_analyzer_1_array_crystal_array_8_zdepth = channel_2_analyzer_1_array_crystal_width;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_2_analyzer_1_array_crystal_array_8_xwidth2 = -1;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_2_analyzer_1_array_crystal_array_8_yheight2 = -1;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_2_analyzer_1_array_crystal_array_8_visualize = 1;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_2_analyzer_1_array_crystal_array_8_target_index = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_2_analyzer_1_array_crystal_array_8_target_x = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_2_analyzer_1_array_crystal_array_8_target_y = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_2_analyzer_1_array_crystal_array_8_target_z = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_2_analyzer_1_array_crystal_array_8_focus_aw = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_2_analyzer_1_array_crystal_array_8_focus_ah = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_2_analyzer_1_array_crystal_array_8_focus_xw = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_2_analyzer_1_array_crystal_array_8_focus_xh = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_2_analyzer_1_array_crystal_array_8_focus_r = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_2_analyzer_1_array_crystal_array_8_p_interact = 0;
#line 71 "MACS_sample_kidney_box.instr"
  if(0) strncpy(mccchannel_2_analyzer_1_array_crystal_array_8_mask_string, 0 ? 0 : "", 16384); else mccchannel_2_analyzer_1_array_crystal_array_8_mask_string[0]='\0';
#line 71 "MACS_sample_kidney_box.instr"
  if(0) strncpy(mccchannel_2_analyzer_1_array_crystal_array_8_mask_setting, 0 ? 0 : "", 16384); else mccchannel_2_analyzer_1_array_crystal_array_8_mask_setting[0]='\0';
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_2_analyzer_1_array_crystal_array_8_number_of_activations = 1;
#line 102647 "MACS_sample_kidney_box.c"

  SIG_MESSAGE("channel_2_analyzer_1_array_crystal_array_8 (Init:Place/Rotate)");
  rot_set_rotation(mctr1,
#line 1001 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 1001 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 1001 "MACS_sample_kidney_box.instr"
    (0 - RAD2DEG * channel_2_analyzer_1_array_theta [ 8 ])*DEG2RAD);
#line 102657 "MACS_sample_kidney_box.c"
  rot_mul(mctr1, mcrotachannel_2_analyzer_1_rotated, mcrotachannel_2_analyzer_1_array_crystal_array_8);
  rot_transpose(mcrotachannel_2_analyzer_1_array_crystal_array_7, mctr1);
  rot_mul(mcrotachannel_2_analyzer_1_array_crystal_array_8, mctr1, mcrotrchannel_2_analyzer_1_array_crystal_array_8);
  mctc1 = coords_set(
#line 1000 "MACS_sample_kidney_box.instr"
    0 + channel_2_analyzer_1_array_effective_radius_of_curvature * ( 1 - cos ( channel_2_analyzer_1_array_theta [ 8 ] ) ),
#line 1000 "MACS_sample_kidney_box.instr"
    0 + channel_2_analyzer_1_array_effective_radius_of_curvature * sin ( channel_2_analyzer_1_array_theta [ 8 ] ),
#line 1000 "MACS_sample_kidney_box.instr"
    0);
#line 102668 "MACS_sample_kidney_box.c"
  rot_transpose(mcrotachannel_2_analyzer_1_rotated, mctr1);
  mctc2 = rot_apply(mctr1, mctc1);
  mcposachannel_2_analyzer_1_array_crystal_array_8 = coords_add(mcposachannel_2_analyzer_1_rotated, mctc2);
  mctc1 = coords_sub(mcposachannel_2_analyzer_1_array_crystal_array_7, mcposachannel_2_analyzer_1_array_crystal_array_8);
  mcposrchannel_2_analyzer_1_array_crystal_array_8 = rot_apply(mcrotachannel_2_analyzer_1_array_crystal_array_8, mctc1);
  mcDEBUG_COMPONENT("channel_2_analyzer_1_array_crystal_array_8", mcposachannel_2_analyzer_1_array_crystal_array_8, mcrotachannel_2_analyzer_1_array_crystal_array_8)
  mccomp_posa[214] = mcposachannel_2_analyzer_1_array_crystal_array_8;
  mccomp_posr[214] = mcposrchannel_2_analyzer_1_array_crystal_array_8;
  mcNCounter[214]  = mcPCounter[214] = mcP2Counter[214] = 0;
  mcAbsorbProp[214]= 0;
    /* Component channel_2_analyzer_2_center. */
  /* Setting parameters for component channel_2_analyzer_2_center. */
  SIG_MESSAGE("channel_2_analyzer_2_center (Init:SetPar)");

  SIG_MESSAGE("channel_2_analyzer_2_center (Init:Place/Rotate)");
  rot_set_rotation(mctr1,
    (0.0)*DEG2RAD,
    (0.0)*DEG2RAD,
    (0.0)*DEG2RAD);
#line 102688 "MACS_sample_kidney_box.c"
  rot_mul(mctr1, mcrotachannel_2_analyzer_1_center, mcrotachannel_2_analyzer_2_center);
  rot_transpose(mcrotachannel_2_analyzer_1_array_crystal_array_8, mctr1);
  rot_mul(mcrotachannel_2_analyzer_2_center, mctr1, mcrotrchannel_2_analyzer_2_center);
  mctc1 = coords_set(
#line 1005 "MACS_sample_kidney_box.instr"
    - analyzer_seperation,
#line 1005 "MACS_sample_kidney_box.instr"
    0,
#line 1005 "MACS_sample_kidney_box.instr"
    0);
#line 102699 "MACS_sample_kidney_box.c"
  rot_transpose(mcrotachannel_2_analyzer_1_center, mctr1);
  mctc2 = rot_apply(mctr1, mctc1);
  mcposachannel_2_analyzer_2_center = coords_add(mcposachannel_2_analyzer_1_center, mctc2);
  mctc1 = coords_sub(mcposachannel_2_analyzer_1_array_crystal_array_8, mcposachannel_2_analyzer_2_center);
  mcposrchannel_2_analyzer_2_center = rot_apply(mcrotachannel_2_analyzer_2_center, mctc1);
  mcDEBUG_COMPONENT("channel_2_analyzer_2_center", mcposachannel_2_analyzer_2_center, mcrotachannel_2_analyzer_2_center)
  mccomp_posa[215] = mcposachannel_2_analyzer_2_center;
  mccomp_posr[215] = mcposrchannel_2_analyzer_2_center;
  mcNCounter[215]  = mcPCounter[215] = mcP2Counter[215] = 0;
  mcAbsorbProp[215]= 0;
    /* Component channel_2_analyzer_2_rotated. */
  /* Setting parameters for component channel_2_analyzer_2_rotated. */
  SIG_MESSAGE("channel_2_analyzer_2_rotated (Init:SetPar)");

  SIG_MESSAGE("channel_2_analyzer_2_rotated (Init:Place/Rotate)");
  rot_set_rotation(mctr1,
#line 1009 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 1009 "MACS_sample_kidney_box.instr"
    (- analyzer_theta [ 2 ])*DEG2RAD,
#line 1009 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD);
#line 102722 "MACS_sample_kidney_box.c"
  rot_mul(mctr1, mcrotachannel_2_analyzer_2_center, mcrotachannel_2_analyzer_2_rotated);
  rot_transpose(mcrotachannel_2_analyzer_2_center, mctr1);
  rot_mul(mcrotachannel_2_analyzer_2_rotated, mctr1, mcrotrchannel_2_analyzer_2_rotated);
  mctc1 = coords_set(
#line 1008 "MACS_sample_kidney_box.instr"
    0,
#line 1008 "MACS_sample_kidney_box.instr"
    0,
#line 1008 "MACS_sample_kidney_box.instr"
    0.5 * analyzer_seperation / tan ( analyzer_2theta [ 2 ] * DEG2RAD ));
#line 102733 "MACS_sample_kidney_box.c"
  rot_transpose(mcrotachannel_2_analyzer_2_center, mctr1);
  mctc2 = rot_apply(mctr1, mctc1);
  mcposachannel_2_analyzer_2_rotated = coords_add(mcposachannel_2_analyzer_2_center, mctc2);
  mctc1 = coords_sub(mcposachannel_2_analyzer_2_center, mcposachannel_2_analyzer_2_rotated);
  mcposrchannel_2_analyzer_2_rotated = rot_apply(mcrotachannel_2_analyzer_2_rotated, mctc1);
  mcDEBUG_COMPONENT("channel_2_analyzer_2_rotated", mcposachannel_2_analyzer_2_rotated, mcrotachannel_2_analyzer_2_rotated)
  mccomp_posa[216] = mcposachannel_2_analyzer_2_rotated;
  mccomp_posr[216] = mcposrchannel_2_analyzer_2_rotated;
  mcNCounter[216]  = mcPCounter[216] = mcP2Counter[216] = 0;
  mcAbsorbProp[216]= 0;
    /* Component channel_2_analyzer_2_array_crystal_array_0. */
  /* Setting parameters for component channel_2_analyzer_2_array_crystal_array_0. */
  SIG_MESSAGE("channel_2_analyzer_2_array_crystal_array_0 (Init:SetPar)");
#line 1013 "MACS_sample_kidney_box.instr"
  if("PG_analyzer") strncpy(mccchannel_2_analyzer_2_array_crystal_array_0_material_string, "PG_analyzer" ? "PG_analyzer" : "", 16384); else mccchannel_2_analyzer_2_array_crystal_array_0_material_string[0]='\0';
#line 1013 "MACS_sample_kidney_box.instr"
  mccchannel_2_analyzer_2_array_crystal_array_0_priority = 421.0;
#line 1012 "MACS_sample_kidney_box.instr"
  mccchannel_2_analyzer_2_array_crystal_array_0_xwidth = channel_2_analyzer_2_array_crystal_depth;
#line 1012 "MACS_sample_kidney_box.instr"
  mccchannel_2_analyzer_2_array_crystal_array_0_yheight = channel_2_analyzer_2_array_crystal_height;
#line 1012 "MACS_sample_kidney_box.instr"
  mccchannel_2_analyzer_2_array_crystal_array_0_zdepth = channel_2_analyzer_2_array_crystal_width;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_2_analyzer_2_array_crystal_array_0_xwidth2 = -1;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_2_analyzer_2_array_crystal_array_0_yheight2 = -1;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_2_analyzer_2_array_crystal_array_0_visualize = 1;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_2_analyzer_2_array_crystal_array_0_target_index = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_2_analyzer_2_array_crystal_array_0_target_x = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_2_analyzer_2_array_crystal_array_0_target_y = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_2_analyzer_2_array_crystal_array_0_target_z = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_2_analyzer_2_array_crystal_array_0_focus_aw = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_2_analyzer_2_array_crystal_array_0_focus_ah = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_2_analyzer_2_array_crystal_array_0_focus_xw = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_2_analyzer_2_array_crystal_array_0_focus_xh = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_2_analyzer_2_array_crystal_array_0_focus_r = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_2_analyzer_2_array_crystal_array_0_p_interact = 0;
#line 71 "MACS_sample_kidney_box.instr"
  if(0) strncpy(mccchannel_2_analyzer_2_array_crystal_array_0_mask_string, 0 ? 0 : "", 16384); else mccchannel_2_analyzer_2_array_crystal_array_0_mask_string[0]='\0';
#line 71 "MACS_sample_kidney_box.instr"
  if(0) strncpy(mccchannel_2_analyzer_2_array_crystal_array_0_mask_setting, 0 ? 0 : "", 16384); else mccchannel_2_analyzer_2_array_crystal_array_0_mask_setting[0]='\0';
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_2_analyzer_2_array_crystal_array_0_number_of_activations = 1;
#line 102789 "MACS_sample_kidney_box.c"

  SIG_MESSAGE("channel_2_analyzer_2_array_crystal_array_0 (Init:Place/Rotate)");
  rot_set_rotation(mctr1,
#line 1015 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 1015 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 1015 "MACS_sample_kidney_box.instr"
    (0 - RAD2DEG * channel_2_analyzer_2_array_theta [ 0 ])*DEG2RAD);
#line 102799 "MACS_sample_kidney_box.c"
  rot_mul(mctr1, mcrotachannel_2_analyzer_2_rotated, mcrotachannel_2_analyzer_2_array_crystal_array_0);
  rot_transpose(mcrotachannel_2_analyzer_2_rotated, mctr1);
  rot_mul(mcrotachannel_2_analyzer_2_array_crystal_array_0, mctr1, mcrotrchannel_2_analyzer_2_array_crystal_array_0);
  mctc1 = coords_set(
#line 1014 "MACS_sample_kidney_box.instr"
    0 + channel_2_analyzer_2_array_effective_radius_of_curvature * ( 1 - cos ( channel_2_analyzer_2_array_theta [ 0 ] ) ),
#line 1014 "MACS_sample_kidney_box.instr"
    0 + channel_2_analyzer_2_array_effective_radius_of_curvature * sin ( channel_2_analyzer_2_array_theta [ 0 ] ),
#line 1014 "MACS_sample_kidney_box.instr"
    0);
#line 102810 "MACS_sample_kidney_box.c"
  rot_transpose(mcrotachannel_2_analyzer_2_rotated, mctr1);
  mctc2 = rot_apply(mctr1, mctc1);
  mcposachannel_2_analyzer_2_array_crystal_array_0 = coords_add(mcposachannel_2_analyzer_2_rotated, mctc2);
  mctc1 = coords_sub(mcposachannel_2_analyzer_2_rotated, mcposachannel_2_analyzer_2_array_crystal_array_0);
  mcposrchannel_2_analyzer_2_array_crystal_array_0 = rot_apply(mcrotachannel_2_analyzer_2_array_crystal_array_0, mctc1);
  mcDEBUG_COMPONENT("channel_2_analyzer_2_array_crystal_array_0", mcposachannel_2_analyzer_2_array_crystal_array_0, mcrotachannel_2_analyzer_2_array_crystal_array_0)
  mccomp_posa[217] = mcposachannel_2_analyzer_2_array_crystal_array_0;
  mccomp_posr[217] = mcposrchannel_2_analyzer_2_array_crystal_array_0;
  mcNCounter[217]  = mcPCounter[217] = mcP2Counter[217] = 0;
  mcAbsorbProp[217]= 0;
    /* Component channel_2_analyzer_2_array_crystal_array_1. */
  /* Setting parameters for component channel_2_analyzer_2_array_crystal_array_1. */
  SIG_MESSAGE("channel_2_analyzer_2_array_crystal_array_1 (Init:SetPar)");
#line 1019 "MACS_sample_kidney_box.instr"
  if("PG_analyzer") strncpy(mccchannel_2_analyzer_2_array_crystal_array_1_material_string, "PG_analyzer" ? "PG_analyzer" : "", 16384); else mccchannel_2_analyzer_2_array_crystal_array_1_material_string[0]='\0';
#line 1019 "MACS_sample_kidney_box.instr"
  mccchannel_2_analyzer_2_array_crystal_array_1_priority = 421.1;
#line 1018 "MACS_sample_kidney_box.instr"
  mccchannel_2_analyzer_2_array_crystal_array_1_xwidth = channel_2_analyzer_2_array_crystal_depth;
#line 1018 "MACS_sample_kidney_box.instr"
  mccchannel_2_analyzer_2_array_crystal_array_1_yheight = channel_2_analyzer_2_array_crystal_height;
#line 1018 "MACS_sample_kidney_box.instr"
  mccchannel_2_analyzer_2_array_crystal_array_1_zdepth = channel_2_analyzer_2_array_crystal_width;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_2_analyzer_2_array_crystal_array_1_xwidth2 = -1;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_2_analyzer_2_array_crystal_array_1_yheight2 = -1;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_2_analyzer_2_array_crystal_array_1_visualize = 1;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_2_analyzer_2_array_crystal_array_1_target_index = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_2_analyzer_2_array_crystal_array_1_target_x = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_2_analyzer_2_array_crystal_array_1_target_y = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_2_analyzer_2_array_crystal_array_1_target_z = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_2_analyzer_2_array_crystal_array_1_focus_aw = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_2_analyzer_2_array_crystal_array_1_focus_ah = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_2_analyzer_2_array_crystal_array_1_focus_xw = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_2_analyzer_2_array_crystal_array_1_focus_xh = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_2_analyzer_2_array_crystal_array_1_focus_r = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_2_analyzer_2_array_crystal_array_1_p_interact = 0;
#line 71 "MACS_sample_kidney_box.instr"
  if(0) strncpy(mccchannel_2_analyzer_2_array_crystal_array_1_mask_string, 0 ? 0 : "", 16384); else mccchannel_2_analyzer_2_array_crystal_array_1_mask_string[0]='\0';
#line 71 "MACS_sample_kidney_box.instr"
  if(0) strncpy(mccchannel_2_analyzer_2_array_crystal_array_1_mask_setting, 0 ? 0 : "", 16384); else mccchannel_2_analyzer_2_array_crystal_array_1_mask_setting[0]='\0';
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_2_analyzer_2_array_crystal_array_1_number_of_activations = 1;
#line 102866 "MACS_sample_kidney_box.c"

  SIG_MESSAGE("channel_2_analyzer_2_array_crystal_array_1 (Init:Place/Rotate)");
  rot_set_rotation(mctr1,
#line 1021 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 1021 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 1021 "MACS_sample_kidney_box.instr"
    (0 - RAD2DEG * channel_2_analyzer_2_array_theta [ 1 ])*DEG2RAD);
#line 102876 "MACS_sample_kidney_box.c"
  rot_mul(mctr1, mcrotachannel_2_analyzer_2_rotated, mcrotachannel_2_analyzer_2_array_crystal_array_1);
  rot_transpose(mcrotachannel_2_analyzer_2_array_crystal_array_0, mctr1);
  rot_mul(mcrotachannel_2_analyzer_2_array_crystal_array_1, mctr1, mcrotrchannel_2_analyzer_2_array_crystal_array_1);
  mctc1 = coords_set(
#line 1020 "MACS_sample_kidney_box.instr"
    0 + channel_2_analyzer_2_array_effective_radius_of_curvature * ( 1 - cos ( channel_2_analyzer_2_array_theta [ 1 ] ) ),
#line 1020 "MACS_sample_kidney_box.instr"
    0 + channel_2_analyzer_2_array_effective_radius_of_curvature * sin ( channel_2_analyzer_2_array_theta [ 1 ] ),
#line 1020 "MACS_sample_kidney_box.instr"
    0);
#line 102887 "MACS_sample_kidney_box.c"
  rot_transpose(mcrotachannel_2_analyzer_2_rotated, mctr1);
  mctc2 = rot_apply(mctr1, mctc1);
  mcposachannel_2_analyzer_2_array_crystal_array_1 = coords_add(mcposachannel_2_analyzer_2_rotated, mctc2);
  mctc1 = coords_sub(mcposachannel_2_analyzer_2_array_crystal_array_0, mcposachannel_2_analyzer_2_array_crystal_array_1);
  mcposrchannel_2_analyzer_2_array_crystal_array_1 = rot_apply(mcrotachannel_2_analyzer_2_array_crystal_array_1, mctc1);
  mcDEBUG_COMPONENT("channel_2_analyzer_2_array_crystal_array_1", mcposachannel_2_analyzer_2_array_crystal_array_1, mcrotachannel_2_analyzer_2_array_crystal_array_1)
  mccomp_posa[218] = mcposachannel_2_analyzer_2_array_crystal_array_1;
  mccomp_posr[218] = mcposrchannel_2_analyzer_2_array_crystal_array_1;
  mcNCounter[218]  = mcPCounter[218] = mcP2Counter[218] = 0;
  mcAbsorbProp[218]= 0;
    /* Component channel_2_analyzer_2_array_crystal_array_2. */
  /* Setting parameters for component channel_2_analyzer_2_array_crystal_array_2. */
  SIG_MESSAGE("channel_2_analyzer_2_array_crystal_array_2 (Init:SetPar)");
#line 1025 "MACS_sample_kidney_box.instr"
  if("PG_analyzer") strncpy(mccchannel_2_analyzer_2_array_crystal_array_2_material_string, "PG_analyzer" ? "PG_analyzer" : "", 16384); else mccchannel_2_analyzer_2_array_crystal_array_2_material_string[0]='\0';
#line 1025 "MACS_sample_kidney_box.instr"
  mccchannel_2_analyzer_2_array_crystal_array_2_priority = 421.2;
#line 1024 "MACS_sample_kidney_box.instr"
  mccchannel_2_analyzer_2_array_crystal_array_2_xwidth = channel_2_analyzer_2_array_crystal_depth;
#line 1024 "MACS_sample_kidney_box.instr"
  mccchannel_2_analyzer_2_array_crystal_array_2_yheight = channel_2_analyzer_2_array_crystal_height;
#line 1024 "MACS_sample_kidney_box.instr"
  mccchannel_2_analyzer_2_array_crystal_array_2_zdepth = channel_2_analyzer_2_array_crystal_width;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_2_analyzer_2_array_crystal_array_2_xwidth2 = -1;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_2_analyzer_2_array_crystal_array_2_yheight2 = -1;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_2_analyzer_2_array_crystal_array_2_visualize = 1;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_2_analyzer_2_array_crystal_array_2_target_index = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_2_analyzer_2_array_crystal_array_2_target_x = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_2_analyzer_2_array_crystal_array_2_target_y = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_2_analyzer_2_array_crystal_array_2_target_z = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_2_analyzer_2_array_crystal_array_2_focus_aw = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_2_analyzer_2_array_crystal_array_2_focus_ah = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_2_analyzer_2_array_crystal_array_2_focus_xw = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_2_analyzer_2_array_crystal_array_2_focus_xh = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_2_analyzer_2_array_crystal_array_2_focus_r = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_2_analyzer_2_array_crystal_array_2_p_interact = 0;
#line 71 "MACS_sample_kidney_box.instr"
  if(0) strncpy(mccchannel_2_analyzer_2_array_crystal_array_2_mask_string, 0 ? 0 : "", 16384); else mccchannel_2_analyzer_2_array_crystal_array_2_mask_string[0]='\0';
#line 71 "MACS_sample_kidney_box.instr"
  if(0) strncpy(mccchannel_2_analyzer_2_array_crystal_array_2_mask_setting, 0 ? 0 : "", 16384); else mccchannel_2_analyzer_2_array_crystal_array_2_mask_setting[0]='\0';
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_2_analyzer_2_array_crystal_array_2_number_of_activations = 1;
#line 102943 "MACS_sample_kidney_box.c"

  SIG_MESSAGE("channel_2_analyzer_2_array_crystal_array_2 (Init:Place/Rotate)");
  rot_set_rotation(mctr1,
#line 1027 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 1027 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 1027 "MACS_sample_kidney_box.instr"
    (0 - RAD2DEG * channel_2_analyzer_2_array_theta [ 2 ])*DEG2RAD);
#line 102953 "MACS_sample_kidney_box.c"
  rot_mul(mctr1, mcrotachannel_2_analyzer_2_rotated, mcrotachannel_2_analyzer_2_array_crystal_array_2);
  rot_transpose(mcrotachannel_2_analyzer_2_array_crystal_array_1, mctr1);
  rot_mul(mcrotachannel_2_analyzer_2_array_crystal_array_2, mctr1, mcrotrchannel_2_analyzer_2_array_crystal_array_2);
  mctc1 = coords_set(
#line 1026 "MACS_sample_kidney_box.instr"
    0 + channel_2_analyzer_2_array_effective_radius_of_curvature * ( 1 - cos ( channel_2_analyzer_2_array_theta [ 2 ] ) ),
#line 1026 "MACS_sample_kidney_box.instr"
    0 + channel_2_analyzer_2_array_effective_radius_of_curvature * sin ( channel_2_analyzer_2_array_theta [ 2 ] ),
#line 1026 "MACS_sample_kidney_box.instr"
    0);
#line 102964 "MACS_sample_kidney_box.c"
  rot_transpose(mcrotachannel_2_analyzer_2_rotated, mctr1);
  mctc2 = rot_apply(mctr1, mctc1);
  mcposachannel_2_analyzer_2_array_crystal_array_2 = coords_add(mcposachannel_2_analyzer_2_rotated, mctc2);
  mctc1 = coords_sub(mcposachannel_2_analyzer_2_array_crystal_array_1, mcposachannel_2_analyzer_2_array_crystal_array_2);
  mcposrchannel_2_analyzer_2_array_crystal_array_2 = rot_apply(mcrotachannel_2_analyzer_2_array_crystal_array_2, mctc1);
  mcDEBUG_COMPONENT("channel_2_analyzer_2_array_crystal_array_2", mcposachannel_2_analyzer_2_array_crystal_array_2, mcrotachannel_2_analyzer_2_array_crystal_array_2)
  mccomp_posa[219] = mcposachannel_2_analyzer_2_array_crystal_array_2;
  mccomp_posr[219] = mcposrchannel_2_analyzer_2_array_crystal_array_2;
  mcNCounter[219]  = mcPCounter[219] = mcP2Counter[219] = 0;
  mcAbsorbProp[219]= 0;
    /* Component channel_2_analyzer_2_array_crystal_array_3. */
  /* Setting parameters for component channel_2_analyzer_2_array_crystal_array_3. */
  SIG_MESSAGE("channel_2_analyzer_2_array_crystal_array_3 (Init:SetPar)");
#line 1031 "MACS_sample_kidney_box.instr"
  if("PG_analyzer") strncpy(mccchannel_2_analyzer_2_array_crystal_array_3_material_string, "PG_analyzer" ? "PG_analyzer" : "", 16384); else mccchannel_2_analyzer_2_array_crystal_array_3_material_string[0]='\0';
#line 1031 "MACS_sample_kidney_box.instr"
  mccchannel_2_analyzer_2_array_crystal_array_3_priority = 421.3;
#line 1030 "MACS_sample_kidney_box.instr"
  mccchannel_2_analyzer_2_array_crystal_array_3_xwidth = channel_2_analyzer_2_array_crystal_depth;
#line 1030 "MACS_sample_kidney_box.instr"
  mccchannel_2_analyzer_2_array_crystal_array_3_yheight = channel_2_analyzer_2_array_crystal_height;
#line 1030 "MACS_sample_kidney_box.instr"
  mccchannel_2_analyzer_2_array_crystal_array_3_zdepth = channel_2_analyzer_2_array_crystal_width;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_2_analyzer_2_array_crystal_array_3_xwidth2 = -1;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_2_analyzer_2_array_crystal_array_3_yheight2 = -1;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_2_analyzer_2_array_crystal_array_3_visualize = 1;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_2_analyzer_2_array_crystal_array_3_target_index = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_2_analyzer_2_array_crystal_array_3_target_x = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_2_analyzer_2_array_crystal_array_3_target_y = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_2_analyzer_2_array_crystal_array_3_target_z = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_2_analyzer_2_array_crystal_array_3_focus_aw = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_2_analyzer_2_array_crystal_array_3_focus_ah = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_2_analyzer_2_array_crystal_array_3_focus_xw = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_2_analyzer_2_array_crystal_array_3_focus_xh = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_2_analyzer_2_array_crystal_array_3_focus_r = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_2_analyzer_2_array_crystal_array_3_p_interact = 0;
#line 71 "MACS_sample_kidney_box.instr"
  if(0) strncpy(mccchannel_2_analyzer_2_array_crystal_array_3_mask_string, 0 ? 0 : "", 16384); else mccchannel_2_analyzer_2_array_crystal_array_3_mask_string[0]='\0';
#line 71 "MACS_sample_kidney_box.instr"
  if(0) strncpy(mccchannel_2_analyzer_2_array_crystal_array_3_mask_setting, 0 ? 0 : "", 16384); else mccchannel_2_analyzer_2_array_crystal_array_3_mask_setting[0]='\0';
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_2_analyzer_2_array_crystal_array_3_number_of_activations = 1;
#line 103020 "MACS_sample_kidney_box.c"

  SIG_MESSAGE("channel_2_analyzer_2_array_crystal_array_3 (Init:Place/Rotate)");
  rot_set_rotation(mctr1,
#line 1033 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 1033 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 1033 "MACS_sample_kidney_box.instr"
    (0 - RAD2DEG * channel_2_analyzer_2_array_theta [ 3 ])*DEG2RAD);
#line 103030 "MACS_sample_kidney_box.c"
  rot_mul(mctr1, mcrotachannel_2_analyzer_2_rotated, mcrotachannel_2_analyzer_2_array_crystal_array_3);
  rot_transpose(mcrotachannel_2_analyzer_2_array_crystal_array_2, mctr1);
  rot_mul(mcrotachannel_2_analyzer_2_array_crystal_array_3, mctr1, mcrotrchannel_2_analyzer_2_array_crystal_array_3);
  mctc1 = coords_set(
#line 1032 "MACS_sample_kidney_box.instr"
    0 + channel_2_analyzer_2_array_effective_radius_of_curvature * ( 1 - cos ( channel_2_analyzer_2_array_theta [ 3 ] ) ),
#line 1032 "MACS_sample_kidney_box.instr"
    0 + channel_2_analyzer_2_array_effective_radius_of_curvature * sin ( channel_2_analyzer_2_array_theta [ 3 ] ),
#line 1032 "MACS_sample_kidney_box.instr"
    0);
#line 103041 "MACS_sample_kidney_box.c"
  rot_transpose(mcrotachannel_2_analyzer_2_rotated, mctr1);
  mctc2 = rot_apply(mctr1, mctc1);
  mcposachannel_2_analyzer_2_array_crystal_array_3 = coords_add(mcposachannel_2_analyzer_2_rotated, mctc2);
  mctc1 = coords_sub(mcposachannel_2_analyzer_2_array_crystal_array_2, mcposachannel_2_analyzer_2_array_crystal_array_3);
  mcposrchannel_2_analyzer_2_array_crystal_array_3 = rot_apply(mcrotachannel_2_analyzer_2_array_crystal_array_3, mctc1);
  mcDEBUG_COMPONENT("channel_2_analyzer_2_array_crystal_array_3", mcposachannel_2_analyzer_2_array_crystal_array_3, mcrotachannel_2_analyzer_2_array_crystal_array_3)
  mccomp_posa[220] = mcposachannel_2_analyzer_2_array_crystal_array_3;
  mccomp_posr[220] = mcposrchannel_2_analyzer_2_array_crystal_array_3;
  mcNCounter[220]  = mcPCounter[220] = mcP2Counter[220] = 0;
  mcAbsorbProp[220]= 0;
    /* Component channel_2_analyzer_2_array_crystal_array_4. */
  /* Setting parameters for component channel_2_analyzer_2_array_crystal_array_4. */
  SIG_MESSAGE("channel_2_analyzer_2_array_crystal_array_4 (Init:SetPar)");
#line 1037 "MACS_sample_kidney_box.instr"
  if("PG_analyzer") strncpy(mccchannel_2_analyzer_2_array_crystal_array_4_material_string, "PG_analyzer" ? "PG_analyzer" : "", 16384); else mccchannel_2_analyzer_2_array_crystal_array_4_material_string[0]='\0';
#line 1037 "MACS_sample_kidney_box.instr"
  mccchannel_2_analyzer_2_array_crystal_array_4_priority = 421.4;
#line 1036 "MACS_sample_kidney_box.instr"
  mccchannel_2_analyzer_2_array_crystal_array_4_xwidth = channel_2_analyzer_2_array_crystal_depth;
#line 1036 "MACS_sample_kidney_box.instr"
  mccchannel_2_analyzer_2_array_crystal_array_4_yheight = channel_2_analyzer_2_array_crystal_height;
#line 1036 "MACS_sample_kidney_box.instr"
  mccchannel_2_analyzer_2_array_crystal_array_4_zdepth = channel_2_analyzer_2_array_crystal_width;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_2_analyzer_2_array_crystal_array_4_xwidth2 = -1;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_2_analyzer_2_array_crystal_array_4_yheight2 = -1;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_2_analyzer_2_array_crystal_array_4_visualize = 1;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_2_analyzer_2_array_crystal_array_4_target_index = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_2_analyzer_2_array_crystal_array_4_target_x = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_2_analyzer_2_array_crystal_array_4_target_y = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_2_analyzer_2_array_crystal_array_4_target_z = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_2_analyzer_2_array_crystal_array_4_focus_aw = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_2_analyzer_2_array_crystal_array_4_focus_ah = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_2_analyzer_2_array_crystal_array_4_focus_xw = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_2_analyzer_2_array_crystal_array_4_focus_xh = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_2_analyzer_2_array_crystal_array_4_focus_r = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_2_analyzer_2_array_crystal_array_4_p_interact = 0;
#line 71 "MACS_sample_kidney_box.instr"
  if(0) strncpy(mccchannel_2_analyzer_2_array_crystal_array_4_mask_string, 0 ? 0 : "", 16384); else mccchannel_2_analyzer_2_array_crystal_array_4_mask_string[0]='\0';
#line 71 "MACS_sample_kidney_box.instr"
  if(0) strncpy(mccchannel_2_analyzer_2_array_crystal_array_4_mask_setting, 0 ? 0 : "", 16384); else mccchannel_2_analyzer_2_array_crystal_array_4_mask_setting[0]='\0';
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_2_analyzer_2_array_crystal_array_4_number_of_activations = 1;
#line 103097 "MACS_sample_kidney_box.c"

  SIG_MESSAGE("channel_2_analyzer_2_array_crystal_array_4 (Init:Place/Rotate)");
  rot_set_rotation(mctr1,
#line 1039 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 1039 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 1039 "MACS_sample_kidney_box.instr"
    (0 - RAD2DEG * channel_2_analyzer_2_array_theta [ 4 ])*DEG2RAD);
#line 103107 "MACS_sample_kidney_box.c"
  rot_mul(mctr1, mcrotachannel_2_analyzer_2_rotated, mcrotachannel_2_analyzer_2_array_crystal_array_4);
  rot_transpose(mcrotachannel_2_analyzer_2_array_crystal_array_3, mctr1);
  rot_mul(mcrotachannel_2_analyzer_2_array_crystal_array_4, mctr1, mcrotrchannel_2_analyzer_2_array_crystal_array_4);
  mctc1 = coords_set(
#line 1038 "MACS_sample_kidney_box.instr"
    0 + channel_2_analyzer_2_array_effective_radius_of_curvature * ( 1 - cos ( channel_2_analyzer_2_array_theta [ 4 ] ) ),
#line 1038 "MACS_sample_kidney_box.instr"
    0 + channel_2_analyzer_2_array_effective_radius_of_curvature * sin ( channel_2_analyzer_2_array_theta [ 4 ] ),
#line 1038 "MACS_sample_kidney_box.instr"
    0);
#line 103118 "MACS_sample_kidney_box.c"
  rot_transpose(mcrotachannel_2_analyzer_2_rotated, mctr1);
  mctc2 = rot_apply(mctr1, mctc1);
  mcposachannel_2_analyzer_2_array_crystal_array_4 = coords_add(mcposachannel_2_analyzer_2_rotated, mctc2);
  mctc1 = coords_sub(mcposachannel_2_analyzer_2_array_crystal_array_3, mcposachannel_2_analyzer_2_array_crystal_array_4);
  mcposrchannel_2_analyzer_2_array_crystal_array_4 = rot_apply(mcrotachannel_2_analyzer_2_array_crystal_array_4, mctc1);
  mcDEBUG_COMPONENT("channel_2_analyzer_2_array_crystal_array_4", mcposachannel_2_analyzer_2_array_crystal_array_4, mcrotachannel_2_analyzer_2_array_crystal_array_4)
  mccomp_posa[221] = mcposachannel_2_analyzer_2_array_crystal_array_4;
  mccomp_posr[221] = mcposrchannel_2_analyzer_2_array_crystal_array_4;
  mcNCounter[221]  = mcPCounter[221] = mcP2Counter[221] = 0;
  mcAbsorbProp[221]= 0;
    /* Component channel_2_analyzer_2_array_crystal_array_5. */
  /* Setting parameters for component channel_2_analyzer_2_array_crystal_array_5. */
  SIG_MESSAGE("channel_2_analyzer_2_array_crystal_array_5 (Init:SetPar)");
#line 1043 "MACS_sample_kidney_box.instr"
  if("PG_analyzer") strncpy(mccchannel_2_analyzer_2_array_crystal_array_5_material_string, "PG_analyzer" ? "PG_analyzer" : "", 16384); else mccchannel_2_analyzer_2_array_crystal_array_5_material_string[0]='\0';
#line 1043 "MACS_sample_kidney_box.instr"
  mccchannel_2_analyzer_2_array_crystal_array_5_priority = 421.5;
#line 1042 "MACS_sample_kidney_box.instr"
  mccchannel_2_analyzer_2_array_crystal_array_5_xwidth = channel_2_analyzer_2_array_crystal_depth;
#line 1042 "MACS_sample_kidney_box.instr"
  mccchannel_2_analyzer_2_array_crystal_array_5_yheight = channel_2_analyzer_2_array_crystal_height;
#line 1042 "MACS_sample_kidney_box.instr"
  mccchannel_2_analyzer_2_array_crystal_array_5_zdepth = channel_2_analyzer_2_array_crystal_width;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_2_analyzer_2_array_crystal_array_5_xwidth2 = -1;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_2_analyzer_2_array_crystal_array_5_yheight2 = -1;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_2_analyzer_2_array_crystal_array_5_visualize = 1;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_2_analyzer_2_array_crystal_array_5_target_index = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_2_analyzer_2_array_crystal_array_5_target_x = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_2_analyzer_2_array_crystal_array_5_target_y = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_2_analyzer_2_array_crystal_array_5_target_z = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_2_analyzer_2_array_crystal_array_5_focus_aw = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_2_analyzer_2_array_crystal_array_5_focus_ah = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_2_analyzer_2_array_crystal_array_5_focus_xw = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_2_analyzer_2_array_crystal_array_5_focus_xh = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_2_analyzer_2_array_crystal_array_5_focus_r = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_2_analyzer_2_array_crystal_array_5_p_interact = 0;
#line 71 "MACS_sample_kidney_box.instr"
  if(0) strncpy(mccchannel_2_analyzer_2_array_crystal_array_5_mask_string, 0 ? 0 : "", 16384); else mccchannel_2_analyzer_2_array_crystal_array_5_mask_string[0]='\0';
#line 71 "MACS_sample_kidney_box.instr"
  if(0) strncpy(mccchannel_2_analyzer_2_array_crystal_array_5_mask_setting, 0 ? 0 : "", 16384); else mccchannel_2_analyzer_2_array_crystal_array_5_mask_setting[0]='\0';
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_2_analyzer_2_array_crystal_array_5_number_of_activations = 1;
#line 103174 "MACS_sample_kidney_box.c"

  SIG_MESSAGE("channel_2_analyzer_2_array_crystal_array_5 (Init:Place/Rotate)");
  rot_set_rotation(mctr1,
#line 1045 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 1045 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 1045 "MACS_sample_kidney_box.instr"
    (0 - RAD2DEG * channel_2_analyzer_2_array_theta [ 5 ])*DEG2RAD);
#line 103184 "MACS_sample_kidney_box.c"
  rot_mul(mctr1, mcrotachannel_2_analyzer_2_rotated, mcrotachannel_2_analyzer_2_array_crystal_array_5);
  rot_transpose(mcrotachannel_2_analyzer_2_array_crystal_array_4, mctr1);
  rot_mul(mcrotachannel_2_analyzer_2_array_crystal_array_5, mctr1, mcrotrchannel_2_analyzer_2_array_crystal_array_5);
  mctc1 = coords_set(
#line 1044 "MACS_sample_kidney_box.instr"
    0 + channel_2_analyzer_2_array_effective_radius_of_curvature * ( 1 - cos ( channel_2_analyzer_2_array_theta [ 5 ] ) ),
#line 1044 "MACS_sample_kidney_box.instr"
    0 + channel_2_analyzer_2_array_effective_radius_of_curvature * sin ( channel_2_analyzer_2_array_theta [ 5 ] ),
#line 1044 "MACS_sample_kidney_box.instr"
    0);
#line 103195 "MACS_sample_kidney_box.c"
  rot_transpose(mcrotachannel_2_analyzer_2_rotated, mctr1);
  mctc2 = rot_apply(mctr1, mctc1);
  mcposachannel_2_analyzer_2_array_crystal_array_5 = coords_add(mcposachannel_2_analyzer_2_rotated, mctc2);
  mctc1 = coords_sub(mcposachannel_2_analyzer_2_array_crystal_array_4, mcposachannel_2_analyzer_2_array_crystal_array_5);
  mcposrchannel_2_analyzer_2_array_crystal_array_5 = rot_apply(mcrotachannel_2_analyzer_2_array_crystal_array_5, mctc1);
  mcDEBUG_COMPONENT("channel_2_analyzer_2_array_crystal_array_5", mcposachannel_2_analyzer_2_array_crystal_array_5, mcrotachannel_2_analyzer_2_array_crystal_array_5)
  mccomp_posa[222] = mcposachannel_2_analyzer_2_array_crystal_array_5;
  mccomp_posr[222] = mcposrchannel_2_analyzer_2_array_crystal_array_5;
  mcNCounter[222]  = mcPCounter[222] = mcP2Counter[222] = 0;
  mcAbsorbProp[222]= 0;
    /* Component channel_2_analyzer_2_array_crystal_array_6. */
  /* Setting parameters for component channel_2_analyzer_2_array_crystal_array_6. */
  SIG_MESSAGE("channel_2_analyzer_2_array_crystal_array_6 (Init:SetPar)");
#line 1049 "MACS_sample_kidney_box.instr"
  if("PG_analyzer") strncpy(mccchannel_2_analyzer_2_array_crystal_array_6_material_string, "PG_analyzer" ? "PG_analyzer" : "", 16384); else mccchannel_2_analyzer_2_array_crystal_array_6_material_string[0]='\0';
#line 1049 "MACS_sample_kidney_box.instr"
  mccchannel_2_analyzer_2_array_crystal_array_6_priority = 421.6;
#line 1048 "MACS_sample_kidney_box.instr"
  mccchannel_2_analyzer_2_array_crystal_array_6_xwidth = channel_2_analyzer_2_array_crystal_depth;
#line 1048 "MACS_sample_kidney_box.instr"
  mccchannel_2_analyzer_2_array_crystal_array_6_yheight = channel_2_analyzer_2_array_crystal_height;
#line 1048 "MACS_sample_kidney_box.instr"
  mccchannel_2_analyzer_2_array_crystal_array_6_zdepth = channel_2_analyzer_2_array_crystal_width;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_2_analyzer_2_array_crystal_array_6_xwidth2 = -1;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_2_analyzer_2_array_crystal_array_6_yheight2 = -1;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_2_analyzer_2_array_crystal_array_6_visualize = 1;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_2_analyzer_2_array_crystal_array_6_target_index = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_2_analyzer_2_array_crystal_array_6_target_x = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_2_analyzer_2_array_crystal_array_6_target_y = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_2_analyzer_2_array_crystal_array_6_target_z = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_2_analyzer_2_array_crystal_array_6_focus_aw = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_2_analyzer_2_array_crystal_array_6_focus_ah = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_2_analyzer_2_array_crystal_array_6_focus_xw = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_2_analyzer_2_array_crystal_array_6_focus_xh = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_2_analyzer_2_array_crystal_array_6_focus_r = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_2_analyzer_2_array_crystal_array_6_p_interact = 0;
#line 71 "MACS_sample_kidney_box.instr"
  if(0) strncpy(mccchannel_2_analyzer_2_array_crystal_array_6_mask_string, 0 ? 0 : "", 16384); else mccchannel_2_analyzer_2_array_crystal_array_6_mask_string[0]='\0';
#line 71 "MACS_sample_kidney_box.instr"
  if(0) strncpy(mccchannel_2_analyzer_2_array_crystal_array_6_mask_setting, 0 ? 0 : "", 16384); else mccchannel_2_analyzer_2_array_crystal_array_6_mask_setting[0]='\0';
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_2_analyzer_2_array_crystal_array_6_number_of_activations = 1;
#line 103251 "MACS_sample_kidney_box.c"

  SIG_MESSAGE("channel_2_analyzer_2_array_crystal_array_6 (Init:Place/Rotate)");
  rot_set_rotation(mctr1,
#line 1051 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 1051 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 1051 "MACS_sample_kidney_box.instr"
    (0 - RAD2DEG * channel_2_analyzer_2_array_theta [ 6 ])*DEG2RAD);
#line 103261 "MACS_sample_kidney_box.c"
  rot_mul(mctr1, mcrotachannel_2_analyzer_2_rotated, mcrotachannel_2_analyzer_2_array_crystal_array_6);
  rot_transpose(mcrotachannel_2_analyzer_2_array_crystal_array_5, mctr1);
  rot_mul(mcrotachannel_2_analyzer_2_array_crystal_array_6, mctr1, mcrotrchannel_2_analyzer_2_array_crystal_array_6);
  mctc1 = coords_set(
#line 1050 "MACS_sample_kidney_box.instr"
    0 + channel_2_analyzer_2_array_effective_radius_of_curvature * ( 1 - cos ( channel_2_analyzer_2_array_theta [ 6 ] ) ),
#line 1050 "MACS_sample_kidney_box.instr"
    0 + channel_2_analyzer_2_array_effective_radius_of_curvature * sin ( channel_2_analyzer_2_array_theta [ 6 ] ),
#line 1050 "MACS_sample_kidney_box.instr"
    0);
#line 103272 "MACS_sample_kidney_box.c"
  rot_transpose(mcrotachannel_2_analyzer_2_rotated, mctr1);
  mctc2 = rot_apply(mctr1, mctc1);
  mcposachannel_2_analyzer_2_array_crystal_array_6 = coords_add(mcposachannel_2_analyzer_2_rotated, mctc2);
  mctc1 = coords_sub(mcposachannel_2_analyzer_2_array_crystal_array_5, mcposachannel_2_analyzer_2_array_crystal_array_6);
  mcposrchannel_2_analyzer_2_array_crystal_array_6 = rot_apply(mcrotachannel_2_analyzer_2_array_crystal_array_6, mctc1);
  mcDEBUG_COMPONENT("channel_2_analyzer_2_array_crystal_array_6", mcposachannel_2_analyzer_2_array_crystal_array_6, mcrotachannel_2_analyzer_2_array_crystal_array_6)
  mccomp_posa[223] = mcposachannel_2_analyzer_2_array_crystal_array_6;
  mccomp_posr[223] = mcposrchannel_2_analyzer_2_array_crystal_array_6;
  mcNCounter[223]  = mcPCounter[223] = mcP2Counter[223] = 0;
  mcAbsorbProp[223]= 0;
    /* Component channel_2_analyzer_2_array_crystal_array_7. */
  /* Setting parameters for component channel_2_analyzer_2_array_crystal_array_7. */
  SIG_MESSAGE("channel_2_analyzer_2_array_crystal_array_7 (Init:SetPar)");
#line 1055 "MACS_sample_kidney_box.instr"
  if("PG_analyzer") strncpy(mccchannel_2_analyzer_2_array_crystal_array_7_material_string, "PG_analyzer" ? "PG_analyzer" : "", 16384); else mccchannel_2_analyzer_2_array_crystal_array_7_material_string[0]='\0';
#line 1055 "MACS_sample_kidney_box.instr"
  mccchannel_2_analyzer_2_array_crystal_array_7_priority = 421.7;
#line 1054 "MACS_sample_kidney_box.instr"
  mccchannel_2_analyzer_2_array_crystal_array_7_xwidth = channel_2_analyzer_2_array_crystal_depth;
#line 1054 "MACS_sample_kidney_box.instr"
  mccchannel_2_analyzer_2_array_crystal_array_7_yheight = channel_2_analyzer_2_array_crystal_height;
#line 1054 "MACS_sample_kidney_box.instr"
  mccchannel_2_analyzer_2_array_crystal_array_7_zdepth = channel_2_analyzer_2_array_crystal_width;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_2_analyzer_2_array_crystal_array_7_xwidth2 = -1;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_2_analyzer_2_array_crystal_array_7_yheight2 = -1;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_2_analyzer_2_array_crystal_array_7_visualize = 1;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_2_analyzer_2_array_crystal_array_7_target_index = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_2_analyzer_2_array_crystal_array_7_target_x = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_2_analyzer_2_array_crystal_array_7_target_y = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_2_analyzer_2_array_crystal_array_7_target_z = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_2_analyzer_2_array_crystal_array_7_focus_aw = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_2_analyzer_2_array_crystal_array_7_focus_ah = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_2_analyzer_2_array_crystal_array_7_focus_xw = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_2_analyzer_2_array_crystal_array_7_focus_xh = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_2_analyzer_2_array_crystal_array_7_focus_r = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_2_analyzer_2_array_crystal_array_7_p_interact = 0;
#line 71 "MACS_sample_kidney_box.instr"
  if(0) strncpy(mccchannel_2_analyzer_2_array_crystal_array_7_mask_string, 0 ? 0 : "", 16384); else mccchannel_2_analyzer_2_array_crystal_array_7_mask_string[0]='\0';
#line 71 "MACS_sample_kidney_box.instr"
  if(0) strncpy(mccchannel_2_analyzer_2_array_crystal_array_7_mask_setting, 0 ? 0 : "", 16384); else mccchannel_2_analyzer_2_array_crystal_array_7_mask_setting[0]='\0';
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_2_analyzer_2_array_crystal_array_7_number_of_activations = 1;
#line 103328 "MACS_sample_kidney_box.c"

  SIG_MESSAGE("channel_2_analyzer_2_array_crystal_array_7 (Init:Place/Rotate)");
  rot_set_rotation(mctr1,
#line 1057 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 1057 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 1057 "MACS_sample_kidney_box.instr"
    (0 - RAD2DEG * channel_2_analyzer_2_array_theta [ 7 ])*DEG2RAD);
#line 103338 "MACS_sample_kidney_box.c"
  rot_mul(mctr1, mcrotachannel_2_analyzer_2_rotated, mcrotachannel_2_analyzer_2_array_crystal_array_7);
  rot_transpose(mcrotachannel_2_analyzer_2_array_crystal_array_6, mctr1);
  rot_mul(mcrotachannel_2_analyzer_2_array_crystal_array_7, mctr1, mcrotrchannel_2_analyzer_2_array_crystal_array_7);
  mctc1 = coords_set(
#line 1056 "MACS_sample_kidney_box.instr"
    0 + channel_2_analyzer_2_array_effective_radius_of_curvature * ( 1 - cos ( channel_2_analyzer_2_array_theta [ 7 ] ) ),
#line 1056 "MACS_sample_kidney_box.instr"
    0 + channel_2_analyzer_2_array_effective_radius_of_curvature * sin ( channel_2_analyzer_2_array_theta [ 7 ] ),
#line 1056 "MACS_sample_kidney_box.instr"
    0);
#line 103349 "MACS_sample_kidney_box.c"
  rot_transpose(mcrotachannel_2_analyzer_2_rotated, mctr1);
  mctc2 = rot_apply(mctr1, mctc1);
  mcposachannel_2_analyzer_2_array_crystal_array_7 = coords_add(mcposachannel_2_analyzer_2_rotated, mctc2);
  mctc1 = coords_sub(mcposachannel_2_analyzer_2_array_crystal_array_6, mcposachannel_2_analyzer_2_array_crystal_array_7);
  mcposrchannel_2_analyzer_2_array_crystal_array_7 = rot_apply(mcrotachannel_2_analyzer_2_array_crystal_array_7, mctc1);
  mcDEBUG_COMPONENT("channel_2_analyzer_2_array_crystal_array_7", mcposachannel_2_analyzer_2_array_crystal_array_7, mcrotachannel_2_analyzer_2_array_crystal_array_7)
  mccomp_posa[224] = mcposachannel_2_analyzer_2_array_crystal_array_7;
  mccomp_posr[224] = mcposrchannel_2_analyzer_2_array_crystal_array_7;
  mcNCounter[224]  = mcPCounter[224] = mcP2Counter[224] = 0;
  mcAbsorbProp[224]= 0;
    /* Component channel_2_analyzer_2_array_crystal_array_8. */
  /* Setting parameters for component channel_2_analyzer_2_array_crystal_array_8. */
  SIG_MESSAGE("channel_2_analyzer_2_array_crystal_array_8 (Init:SetPar)");
#line 1061 "MACS_sample_kidney_box.instr"
  if("PG_analyzer") strncpy(mccchannel_2_analyzer_2_array_crystal_array_8_material_string, "PG_analyzer" ? "PG_analyzer" : "", 16384); else mccchannel_2_analyzer_2_array_crystal_array_8_material_string[0]='\0';
#line 1061 "MACS_sample_kidney_box.instr"
  mccchannel_2_analyzer_2_array_crystal_array_8_priority = 421.8;
#line 1060 "MACS_sample_kidney_box.instr"
  mccchannel_2_analyzer_2_array_crystal_array_8_xwidth = channel_2_analyzer_2_array_crystal_depth;
#line 1060 "MACS_sample_kidney_box.instr"
  mccchannel_2_analyzer_2_array_crystal_array_8_yheight = channel_2_analyzer_2_array_crystal_height;
#line 1060 "MACS_sample_kidney_box.instr"
  mccchannel_2_analyzer_2_array_crystal_array_8_zdepth = channel_2_analyzer_2_array_crystal_width;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_2_analyzer_2_array_crystal_array_8_xwidth2 = -1;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_2_analyzer_2_array_crystal_array_8_yheight2 = -1;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_2_analyzer_2_array_crystal_array_8_visualize = 1;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_2_analyzer_2_array_crystal_array_8_target_index = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_2_analyzer_2_array_crystal_array_8_target_x = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_2_analyzer_2_array_crystal_array_8_target_y = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_2_analyzer_2_array_crystal_array_8_target_z = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_2_analyzer_2_array_crystal_array_8_focus_aw = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_2_analyzer_2_array_crystal_array_8_focus_ah = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_2_analyzer_2_array_crystal_array_8_focus_xw = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_2_analyzer_2_array_crystal_array_8_focus_xh = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_2_analyzer_2_array_crystal_array_8_focus_r = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_2_analyzer_2_array_crystal_array_8_p_interact = 0;
#line 71 "MACS_sample_kidney_box.instr"
  if(0) strncpy(mccchannel_2_analyzer_2_array_crystal_array_8_mask_string, 0 ? 0 : "", 16384); else mccchannel_2_analyzer_2_array_crystal_array_8_mask_string[0]='\0';
#line 71 "MACS_sample_kidney_box.instr"
  if(0) strncpy(mccchannel_2_analyzer_2_array_crystal_array_8_mask_setting, 0 ? 0 : "", 16384); else mccchannel_2_analyzer_2_array_crystal_array_8_mask_setting[0]='\0';
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_2_analyzer_2_array_crystal_array_8_number_of_activations = 1;
#line 103405 "MACS_sample_kidney_box.c"

  SIG_MESSAGE("channel_2_analyzer_2_array_crystal_array_8 (Init:Place/Rotate)");
  rot_set_rotation(mctr1,
#line 1063 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 1063 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 1063 "MACS_sample_kidney_box.instr"
    (0 - RAD2DEG * channel_2_analyzer_2_array_theta [ 8 ])*DEG2RAD);
#line 103415 "MACS_sample_kidney_box.c"
  rot_mul(mctr1, mcrotachannel_2_analyzer_2_rotated, mcrotachannel_2_analyzer_2_array_crystal_array_8);
  rot_transpose(mcrotachannel_2_analyzer_2_array_crystal_array_7, mctr1);
  rot_mul(mcrotachannel_2_analyzer_2_array_crystal_array_8, mctr1, mcrotrchannel_2_analyzer_2_array_crystal_array_8);
  mctc1 = coords_set(
#line 1062 "MACS_sample_kidney_box.instr"
    0 + channel_2_analyzer_2_array_effective_radius_of_curvature * ( 1 - cos ( channel_2_analyzer_2_array_theta [ 8 ] ) ),
#line 1062 "MACS_sample_kidney_box.instr"
    0 + channel_2_analyzer_2_array_effective_radius_of_curvature * sin ( channel_2_analyzer_2_array_theta [ 8 ] ),
#line 1062 "MACS_sample_kidney_box.instr"
    0);
#line 103426 "MACS_sample_kidney_box.c"
  rot_transpose(mcrotachannel_2_analyzer_2_rotated, mctr1);
  mctc2 = rot_apply(mctr1, mctc1);
  mcposachannel_2_analyzer_2_array_crystal_array_8 = coords_add(mcposachannel_2_analyzer_2_rotated, mctc2);
  mctc1 = coords_sub(mcposachannel_2_analyzer_2_array_crystal_array_7, mcposachannel_2_analyzer_2_array_crystal_array_8);
  mcposrchannel_2_analyzer_2_array_crystal_array_8 = rot_apply(mcrotachannel_2_analyzer_2_array_crystal_array_8, mctc1);
  mcDEBUG_COMPONENT("channel_2_analyzer_2_array_crystal_array_8", mcposachannel_2_analyzer_2_array_crystal_array_8, mcrotachannel_2_analyzer_2_array_crystal_array_8)
  mccomp_posa[225] = mcposachannel_2_analyzer_2_array_crystal_array_8;
  mccomp_posr[225] = mcposrchannel_2_analyzer_2_array_crystal_array_8;
  mcNCounter[225]  = mcPCounter[225] = mcP2Counter[225] = 0;
  mcAbsorbProp[225]= 0;
    /* Component channel_2_cave2_cyl1. */
  /* Setting parameters for component channel_2_cave2_cyl1. */
  SIG_MESSAGE("channel_2_cave2_cyl1 (Init:SetPar)");
#line 1068 "MACS_sample_kidney_box.instr"
  if("Vacuum") strncpy(mccchannel_2_cave2_cyl1_material_string, "Vacuum" ? "Vacuum" : "", 16384); else mccchannel_2_cave2_cyl1_material_string[0]='\0';
#line 1068 "MACS_sample_kidney_box.instr"
  mccchannel_2_cave2_cyl1_priority = 407.5;
#line 1067 "MACS_sample_kidney_box.instr"
  mccchannel_2_cave2_cyl1_radius = kidney_cave2_cyl1_radius;
#line 1067 "MACS_sample_kidney_box.instr"
  mccchannel_2_cave2_cyl1_yheight = kidney_cave2_cyl1_height;
#line 67 "MACS_sample_kidney_box.instr"
  mccchannel_2_cave2_cyl1_visualize = 1;
#line 67 "MACS_sample_kidney_box.instr"
  mccchannel_2_cave2_cyl1_target_index = 0;
#line 67 "MACS_sample_kidney_box.instr"
  mccchannel_2_cave2_cyl1_target_x = 0;
#line 67 "MACS_sample_kidney_box.instr"
  mccchannel_2_cave2_cyl1_target_y = 0;
#line 67 "MACS_sample_kidney_box.instr"
  mccchannel_2_cave2_cyl1_target_z = 0;
#line 67 "MACS_sample_kidney_box.instr"
  mccchannel_2_cave2_cyl1_focus_aw = 0;
#line 67 "MACS_sample_kidney_box.instr"
  mccchannel_2_cave2_cyl1_focus_ah = 0;
#line 67 "MACS_sample_kidney_box.instr"
  mccchannel_2_cave2_cyl1_focus_xw = 0;
#line 67 "MACS_sample_kidney_box.instr"
  mccchannel_2_cave2_cyl1_focus_xh = 0;
#line 67 "MACS_sample_kidney_box.instr"
  mccchannel_2_cave2_cyl1_focus_r = 0;
#line 67 "MACS_sample_kidney_box.instr"
  mccchannel_2_cave2_cyl1_p_interact = 0;
#line 67 "MACS_sample_kidney_box.instr"
  if(0) strncpy(mccchannel_2_cave2_cyl1_mask_string, 0 ? 0 : "", 16384); else mccchannel_2_cave2_cyl1_mask_string[0]='\0';
#line 67 "MACS_sample_kidney_box.instr"
  if(0) strncpy(mccchannel_2_cave2_cyl1_mask_setting, 0 ? 0 : "", 16384); else mccchannel_2_cave2_cyl1_mask_setting[0]='\0';
#line 67 "MACS_sample_kidney_box.instr"
  mccchannel_2_cave2_cyl1_number_of_activations = 1;
#line 103476 "MACS_sample_kidney_box.c"

  SIG_MESSAGE("channel_2_cave2_cyl1 (Init:Place/Rotate)");
  rot_set_rotation(mctr1,
#line 1070 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 1070 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 1070 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD);
#line 103486 "MACS_sample_kidney_box.c"
  rot_mul(mctr1, mcrotachannel_2_analyzer_2_center, mcrotachannel_2_cave2_cyl1);
  rot_transpose(mcrotachannel_2_analyzer_2_array_crystal_array_8, mctr1);
  rot_mul(mcrotachannel_2_cave2_cyl1, mctr1, mcrotrchannel_2_cave2_cyl1);
  mctc1 = coords_set(
#line 1069 "MACS_sample_kidney_box.instr"
    0,
#line 1069 "MACS_sample_kidney_box.instr"
    0,
#line 1069 "MACS_sample_kidney_box.instr"
    spec_detector_to_analyzer_2_center);
#line 103497 "MACS_sample_kidney_box.c"
  rot_transpose(mcrotachannel_2_analyzer_2_center, mctr1);
  mctc2 = rot_apply(mctr1, mctc1);
  mcposachannel_2_cave2_cyl1 = coords_add(mcposachannel_2_analyzer_2_center, mctc2);
  mctc1 = coords_sub(mcposachannel_2_analyzer_2_array_crystal_array_8, mcposachannel_2_cave2_cyl1);
  mcposrchannel_2_cave2_cyl1 = rot_apply(mcrotachannel_2_cave2_cyl1, mctc1);
  mcDEBUG_COMPONENT("channel_2_cave2_cyl1", mcposachannel_2_cave2_cyl1, mcrotachannel_2_cave2_cyl1)
  mccomp_posa[226] = mcposachannel_2_cave2_cyl1;
  mccomp_posr[226] = mcposrchannel_2_cave2_cyl1;
  mcNCounter[226]  = mcPCounter[226] = mcP2Counter[226] = 0;
  mcAbsorbProp[226]= 0;
    /* Component channel_2_cave2_box1. */
  /* Setting parameters for component channel_2_cave2_box1. */
  SIG_MESSAGE("channel_2_cave2_box1 (Init:SetPar)");
#line 1075 "MACS_sample_kidney_box.instr"
  if("Vacuum") strncpy(mccchannel_2_cave2_box1_material_string, "Vacuum" ? "Vacuum" : "", 16384); else mccchannel_2_cave2_box1_material_string[0]='\0';
#line 1075 "MACS_sample_kidney_box.instr"
  mccchannel_2_cave2_box1_priority = 401;
#line 1073 "MACS_sample_kidney_box.instr"
  mccchannel_2_cave2_box1_xwidth = kidney_cave2_box1_width1;
#line 1073 "MACS_sample_kidney_box.instr"
  mccchannel_2_cave2_box1_yheight = kidney_cave2_box1_height1;
#line 1073 "MACS_sample_kidney_box.instr"
  mccchannel_2_cave2_box1_zdepth = kidney_cave2_box1_depth;
#line 1074 "MACS_sample_kidney_box.instr"
  mccchannel_2_cave2_box1_xwidth2 = kidney_cave2_box1_width2;
#line 1074 "MACS_sample_kidney_box.instr"
  mccchannel_2_cave2_box1_yheight2 = kidney_cave2_box1_height2;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_2_cave2_box1_visualize = 1;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_2_cave2_box1_target_index = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_2_cave2_box1_target_x = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_2_cave2_box1_target_y = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_2_cave2_box1_target_z = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_2_cave2_box1_focus_aw = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_2_cave2_box1_focus_ah = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_2_cave2_box1_focus_xw = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_2_cave2_box1_focus_xh = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_2_cave2_box1_focus_r = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_2_cave2_box1_p_interact = 0;
#line 71 "MACS_sample_kidney_box.instr"
  if(0) strncpy(mccchannel_2_cave2_box1_mask_string, 0 ? 0 : "", 16384); else mccchannel_2_cave2_box1_mask_string[0]='\0';
#line 71 "MACS_sample_kidney_box.instr"
  if(0) strncpy(mccchannel_2_cave2_box1_mask_setting, 0 ? 0 : "", 16384); else mccchannel_2_cave2_box1_mask_setting[0]='\0';
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_2_cave2_box1_number_of_activations = 1;
#line 103553 "MACS_sample_kidney_box.c"

  SIG_MESSAGE("channel_2_cave2_box1 (Init:Place/Rotate)");
  rot_set_rotation(mctr1,
#line 1077 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 1077 "MACS_sample_kidney_box.instr"
    (kidney_cave2_box1_y_rotation)*DEG2RAD,
#line 1077 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD);
#line 103563 "MACS_sample_kidney_box.c"
  rot_mul(mctr1, mcrotachannel_2_cave2_cyl1, mcrotachannel_2_cave2_box1);
  rot_transpose(mcrotachannel_2_cave2_cyl1, mctr1);
  rot_mul(mcrotachannel_2_cave2_box1, mctr1, mcrotrchannel_2_cave2_box1);
  mctc1 = coords_set(
#line 1076 "MACS_sample_kidney_box.instr"
    kidney_cave2_box1_center_to_spec_detector_x,
#line 1076 "MACS_sample_kidney_box.instr"
    0,
#line 1076 "MACS_sample_kidney_box.instr"
    kidney_cave2_box1_center_to_spec_detector_z);
#line 103574 "MACS_sample_kidney_box.c"
  rot_transpose(mcrotachannel_2_cave2_cyl1, mctr1);
  mctc2 = rot_apply(mctr1, mctc1);
  mcposachannel_2_cave2_box1 = coords_add(mcposachannel_2_cave2_cyl1, mctc2);
  mctc1 = coords_sub(mcposachannel_2_cave2_cyl1, mcposachannel_2_cave2_box1);
  mcposrchannel_2_cave2_box1 = rot_apply(mcrotachannel_2_cave2_box1, mctc1);
  mcDEBUG_COMPONENT("channel_2_cave2_box1", mcposachannel_2_cave2_box1, mcrotachannel_2_cave2_box1)
  mccomp_posa[227] = mcposachannel_2_cave2_box1;
  mccomp_posr[227] = mcposrchannel_2_cave2_box1;
  mcNCounter[227]  = mcPCounter[227] = mcP2Counter[227] = 0;
  mcAbsorbProp[227]= 0;
    /* Component channel_2_cave2_box2. */
  /* Setting parameters for component channel_2_cave2_box2. */
  SIG_MESSAGE("channel_2_cave2_box2 (Init:SetPar)");
#line 1082 "MACS_sample_kidney_box.instr"
  if("Vacuum") strncpy(mccchannel_2_cave2_box2_material_string, "Vacuum" ? "Vacuum" : "", 16384); else mccchannel_2_cave2_box2_material_string[0]='\0';
#line 1082 "MACS_sample_kidney_box.instr"
  mccchannel_2_cave2_box2_priority = 406;
#line 1080 "MACS_sample_kidney_box.instr"
  mccchannel_2_cave2_box2_xwidth = kidney_cave2_box2_width1;
#line 1080 "MACS_sample_kidney_box.instr"
  mccchannel_2_cave2_box2_yheight = kidney_cave2_box2_height1;
#line 1080 "MACS_sample_kidney_box.instr"
  mccchannel_2_cave2_box2_zdepth = kidney_cave2_box2_depth;
#line 1081 "MACS_sample_kidney_box.instr"
  mccchannel_2_cave2_box2_xwidth2 = kidney_cave2_box2_width2;
#line 1081 "MACS_sample_kidney_box.instr"
  mccchannel_2_cave2_box2_yheight2 = kidney_cave2_box2_height2;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_2_cave2_box2_visualize = 1;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_2_cave2_box2_target_index = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_2_cave2_box2_target_x = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_2_cave2_box2_target_y = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_2_cave2_box2_target_z = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_2_cave2_box2_focus_aw = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_2_cave2_box2_focus_ah = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_2_cave2_box2_focus_xw = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_2_cave2_box2_focus_xh = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_2_cave2_box2_focus_r = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_2_cave2_box2_p_interact = 0;
#line 71 "MACS_sample_kidney_box.instr"
  if(0) strncpy(mccchannel_2_cave2_box2_mask_string, 0 ? 0 : "", 16384); else mccchannel_2_cave2_box2_mask_string[0]='\0';
#line 71 "MACS_sample_kidney_box.instr"
  if(0) strncpy(mccchannel_2_cave2_box2_mask_setting, 0 ? 0 : "", 16384); else mccchannel_2_cave2_box2_mask_setting[0]='\0';
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_2_cave2_box2_number_of_activations = 1;
#line 103630 "MACS_sample_kidney_box.c"

  SIG_MESSAGE("channel_2_cave2_box2 (Init:Place/Rotate)");
  rot_set_rotation(mctr1,
#line 1084 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 1084 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 1084 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD);
#line 103640 "MACS_sample_kidney_box.c"
  rot_mul(mctr1, mcrotachannel_2_cave2_cyl1, mcrotachannel_2_cave2_box2);
  rot_transpose(mcrotachannel_2_cave2_box1, mctr1);
  rot_mul(mcrotachannel_2_cave2_box2, mctr1, mcrotrchannel_2_cave2_box2);
  mctc1 = coords_set(
#line 1083 "MACS_sample_kidney_box.instr"
    0,
#line 1083 "MACS_sample_kidney_box.instr"
    0,
#line 1083 "MACS_sample_kidney_box.instr"
    kidney_cave2_box2_center_to_detector);
#line 103651 "MACS_sample_kidney_box.c"
  rot_transpose(mcrotachannel_2_cave2_cyl1, mctr1);
  mctc2 = rot_apply(mctr1, mctc1);
  mcposachannel_2_cave2_box2 = coords_add(mcposachannel_2_cave2_cyl1, mctc2);
  mctc1 = coords_sub(mcposachannel_2_cave2_box1, mcposachannel_2_cave2_box2);
  mcposrchannel_2_cave2_box2 = rot_apply(mcrotachannel_2_cave2_box2, mctc1);
  mcDEBUG_COMPONENT("channel_2_cave2_box2", mcposachannel_2_cave2_box2, mcrotachannel_2_cave2_box2)
  mccomp_posa[228] = mcposachannel_2_cave2_box2;
  mccomp_posr[228] = mcposrchannel_2_cave2_box2;
  mcNCounter[228]  = mcPCounter[228] = mcP2Counter[228] = 0;
  mcAbsorbProp[228]= 0;
    /* Component channel_2_cave2_box3. */
  /* Setting parameters for component channel_2_cave2_box3. */
  SIG_MESSAGE("channel_2_cave2_box3 (Init:SetPar)");
#line 1089 "MACS_sample_kidney_box.instr"
  if("Vacuum") strncpy(mccchannel_2_cave2_box3_material_string, "Vacuum" ? "Vacuum" : "", 16384); else mccchannel_2_cave2_box3_material_string[0]='\0';
#line 1089 "MACS_sample_kidney_box.instr"
  mccchannel_2_cave2_box3_priority = 407;
#line 1087 "MACS_sample_kidney_box.instr"
  mccchannel_2_cave2_box3_xwidth = kidney_cave2_box3_width1;
#line 1087 "MACS_sample_kidney_box.instr"
  mccchannel_2_cave2_box3_yheight = kidney_cave2_box3_height1;
#line 1087 "MACS_sample_kidney_box.instr"
  mccchannel_2_cave2_box3_zdepth = kidney_cave2_box3_depth;
#line 1088 "MACS_sample_kidney_box.instr"
  mccchannel_2_cave2_box3_xwidth2 = kidney_cave2_box3_width2;
#line 1088 "MACS_sample_kidney_box.instr"
  mccchannel_2_cave2_box3_yheight2 = kidney_cave2_box3_height2;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_2_cave2_box3_visualize = 1;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_2_cave2_box3_target_index = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_2_cave2_box3_target_x = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_2_cave2_box3_target_y = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_2_cave2_box3_target_z = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_2_cave2_box3_focus_aw = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_2_cave2_box3_focus_ah = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_2_cave2_box3_focus_xw = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_2_cave2_box3_focus_xh = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_2_cave2_box3_focus_r = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_2_cave2_box3_p_interact = 0;
#line 71 "MACS_sample_kidney_box.instr"
  if(0) strncpy(mccchannel_2_cave2_box3_mask_string, 0 ? 0 : "", 16384); else mccchannel_2_cave2_box3_mask_string[0]='\0';
#line 71 "MACS_sample_kidney_box.instr"
  if(0) strncpy(mccchannel_2_cave2_box3_mask_setting, 0 ? 0 : "", 16384); else mccchannel_2_cave2_box3_mask_setting[0]='\0';
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_2_cave2_box3_number_of_activations = 1;
#line 103707 "MACS_sample_kidney_box.c"

  SIG_MESSAGE("channel_2_cave2_box3 (Init:Place/Rotate)");
  rot_set_rotation(mctr1,
#line 1091 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 1091 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 1091 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD);
#line 103717 "MACS_sample_kidney_box.c"
  rot_mul(mctr1, mcrotachannel_2_cave2_cyl1, mcrotachannel_2_cave2_box3);
  rot_transpose(mcrotachannel_2_cave2_box2, mctr1);
  rot_mul(mcrotachannel_2_cave2_box3, mctr1, mcrotrchannel_2_cave2_box3);
  mctc1 = coords_set(
#line 1090 "MACS_sample_kidney_box.instr"
    0,
#line 1090 "MACS_sample_kidney_box.instr"
    0,
#line 1090 "MACS_sample_kidney_box.instr"
    kidney_cave2_box3_center_to_detector);
#line 103728 "MACS_sample_kidney_box.c"
  rot_transpose(mcrotachannel_2_cave2_cyl1, mctr1);
  mctc2 = rot_apply(mctr1, mctc1);
  mcposachannel_2_cave2_box3 = coords_add(mcposachannel_2_cave2_cyl1, mctc2);
  mctc1 = coords_sub(mcposachannel_2_cave2_box2, mcposachannel_2_cave2_box3);
  mcposrchannel_2_cave2_box3 = rot_apply(mcrotachannel_2_cave2_box3, mctc1);
  mcDEBUG_COMPONENT("channel_2_cave2_box3", mcposachannel_2_cave2_box3, mcrotachannel_2_cave2_box3)
  mccomp_posa[229] = mcposachannel_2_cave2_box3;
  mccomp_posr[229] = mcposrchannel_2_cave2_box3;
  mcNCounter[229]  = mcPCounter[229] = mcP2Counter[229] = 0;
  mcAbsorbProp[229]= 0;
    /* Component inter_analyzer_colimator_center_2. */
  /* Setting parameters for component inter_analyzer_colimator_center_2. */
  SIG_MESSAGE("inter_analyzer_colimator_center_2 (Init:SetPar)");

  SIG_MESSAGE("inter_analyzer_colimator_center_2 (Init:Place/Rotate)");
  rot_set_rotation(mctr1,
#line 1095 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 1095 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 1095 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD);
#line 103751 "MACS_sample_kidney_box.c"
  rot_mul(mctr1, mcrotachannel_2_analyzer_1_center, mcrotainter_analyzer_colimator_center_2);
  rot_transpose(mcrotachannel_2_cave2_box3, mctr1);
  rot_mul(mcrotainter_analyzer_colimator_center_2, mctr1, mcrotrinter_analyzer_colimator_center_2);
  mctc1 = coords_set(
#line 1094 "MACS_sample_kidney_box.instr"
    -0.5 * analyzer_seperation,
#line 1094 "MACS_sample_kidney_box.instr"
    0,
#line 1094 "MACS_sample_kidney_box.instr"
    0);
#line 103762 "MACS_sample_kidney_box.c"
  rot_transpose(mcrotachannel_2_analyzer_1_center, mctr1);
  mctc2 = rot_apply(mctr1, mctc1);
  mcposainter_analyzer_colimator_center_2 = coords_add(mcposachannel_2_analyzer_1_center, mctc2);
  mctc1 = coords_sub(mcposachannel_2_cave2_box3, mcposainter_analyzer_colimator_center_2);
  mcposrinter_analyzer_colimator_center_2 = rot_apply(mcrotainter_analyzer_colimator_center_2, mctc1);
  mcDEBUG_COMPONENT("inter_analyzer_colimator_center_2", mcposainter_analyzer_colimator_center_2, mcrotainter_analyzer_colimator_center_2)
  mccomp_posa[230] = mcposainter_analyzer_colimator_center_2;
  mccomp_posr[230] = mcposrinter_analyzer_colimator_center_2;
  mcNCounter[230]  = mcPCounter[230] = mcP2Counter[230] = 0;
  mcAbsorbProp[230]= 0;
    /* Component inter_analyzer_colimator_2_blade_0. */
  /* Setting parameters for component inter_analyzer_colimator_2_blade_0. */
  SIG_MESSAGE("inter_analyzer_colimator_2_blade_0 (Init:SetPar)");
#line 1099 "MACS_sample_kidney_box.instr"
  if("Collimator_gad") strncpy(mccinter_analyzer_colimator_2_blade_0_material_string, "Collimator_gad" ? "Collimator_gad" : "", 16384); else mccinter_analyzer_colimator_2_blade_0_material_string[0]='\0';
#line 1099 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_2_blade_0_priority = 425;
#line 1098 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_2_blade_0_xwidth = inter_analyzer_colimator_width;
#line 1098 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_2_blade_0_yheight = inter_analyzer_colimator_height;
#line 1098 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_2_blade_0_zdepth = inter_analyzer_colimator_depth;
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_2_blade_0_xwidth2 = -1;
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_2_blade_0_yheight2 = -1;
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_2_blade_0_visualize = 1;
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_2_blade_0_target_index = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_2_blade_0_target_x = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_2_blade_0_target_y = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_2_blade_0_target_z = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_2_blade_0_focus_aw = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_2_blade_0_focus_ah = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_2_blade_0_focus_xw = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_2_blade_0_focus_xh = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_2_blade_0_focus_r = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_2_blade_0_p_interact = 0;
#line 71 "MACS_sample_kidney_box.instr"
  if(0) strncpy(mccinter_analyzer_colimator_2_blade_0_mask_string, 0 ? 0 : "", 16384); else mccinter_analyzer_colimator_2_blade_0_mask_string[0]='\0';
#line 71 "MACS_sample_kidney_box.instr"
  if(0) strncpy(mccinter_analyzer_colimator_2_blade_0_mask_setting, 0 ? 0 : "", 16384); else mccinter_analyzer_colimator_2_blade_0_mask_setting[0]='\0';
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_2_blade_0_number_of_activations = 1;
#line 103818 "MACS_sample_kidney_box.c"

  SIG_MESSAGE("inter_analyzer_colimator_2_blade_0 (Init:Place/Rotate)");
  rot_set_rotation(mctr1,
#line 1101 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 1101 "MACS_sample_kidney_box.instr"
    (- analyzer_2theta [ 2 ])*DEG2RAD,
#line 1101 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD);
#line 103828 "MACS_sample_kidney_box.c"
  rot_mul(mctr1, mcrotainter_analyzer_colimator_center_2, mcrotainter_analyzer_colimator_2_blade_0);
  rot_transpose(mcrotainter_analyzer_colimator_center_2, mctr1);
  rot_mul(mcrotainter_analyzer_colimator_2_blade_0, mctr1, mcrotrinter_analyzer_colimator_2_blade_0);
  mctc1 = coords_set(
#line 1100 "MACS_sample_kidney_box.instr"
    0,
#line 1100 "MACS_sample_kidney_box.instr"
    0,
#line 1100 "MACS_sample_kidney_box.instr"
    inter_analyzer_colimator_start_pos - 0 * inter_analyzer_colimator_seperation);
#line 103839 "MACS_sample_kidney_box.c"
  rot_transpose(mcrotainter_analyzer_colimator_center_2, mctr1);
  mctc2 = rot_apply(mctr1, mctc1);
  mcposainter_analyzer_colimator_2_blade_0 = coords_add(mcposainter_analyzer_colimator_center_2, mctc2);
  mctc1 = coords_sub(mcposainter_analyzer_colimator_center_2, mcposainter_analyzer_colimator_2_blade_0);
  mcposrinter_analyzer_colimator_2_blade_0 = rot_apply(mcrotainter_analyzer_colimator_2_blade_0, mctc1);
  mcDEBUG_COMPONENT("inter_analyzer_colimator_2_blade_0", mcposainter_analyzer_colimator_2_blade_0, mcrotainter_analyzer_colimator_2_blade_0)
  mccomp_posa[231] = mcposainter_analyzer_colimator_2_blade_0;
  mccomp_posr[231] = mcposrinter_analyzer_colimator_2_blade_0;
  mcNCounter[231]  = mcPCounter[231] = mcP2Counter[231] = 0;
  mcAbsorbProp[231]= 0;
    /* Component inter_analyzer_colimator_2_blade_1. */
  /* Setting parameters for component inter_analyzer_colimator_2_blade_1. */
  SIG_MESSAGE("inter_analyzer_colimator_2_blade_1 (Init:SetPar)");
#line 1105 "MACS_sample_kidney_box.instr"
  if("Collimator_gad") strncpy(mccinter_analyzer_colimator_2_blade_1_material_string, "Collimator_gad" ? "Collimator_gad" : "", 16384); else mccinter_analyzer_colimator_2_blade_1_material_string[0]='\0';
#line 1105 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_2_blade_1_priority = 426;
#line 1104 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_2_blade_1_xwidth = inter_analyzer_colimator_width;
#line 1104 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_2_blade_1_yheight = inter_analyzer_colimator_height;
#line 1104 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_2_blade_1_zdepth = inter_analyzer_colimator_depth;
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_2_blade_1_xwidth2 = -1;
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_2_blade_1_yheight2 = -1;
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_2_blade_1_visualize = 1;
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_2_blade_1_target_index = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_2_blade_1_target_x = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_2_blade_1_target_y = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_2_blade_1_target_z = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_2_blade_1_focus_aw = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_2_blade_1_focus_ah = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_2_blade_1_focus_xw = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_2_blade_1_focus_xh = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_2_blade_1_focus_r = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_2_blade_1_p_interact = 0;
#line 71 "MACS_sample_kidney_box.instr"
  if(0) strncpy(mccinter_analyzer_colimator_2_blade_1_mask_string, 0 ? 0 : "", 16384); else mccinter_analyzer_colimator_2_blade_1_mask_string[0]='\0';
#line 71 "MACS_sample_kidney_box.instr"
  if(0) strncpy(mccinter_analyzer_colimator_2_blade_1_mask_setting, 0 ? 0 : "", 16384); else mccinter_analyzer_colimator_2_blade_1_mask_setting[0]='\0';
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_2_blade_1_number_of_activations = 1;
#line 103895 "MACS_sample_kidney_box.c"

  SIG_MESSAGE("inter_analyzer_colimator_2_blade_1 (Init:Place/Rotate)");
  rot_set_rotation(mctr1,
#line 1107 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 1107 "MACS_sample_kidney_box.instr"
    (- analyzer_2theta [ 2 ])*DEG2RAD,
#line 1107 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD);
#line 103905 "MACS_sample_kidney_box.c"
  rot_mul(mctr1, mcrotainter_analyzer_colimator_center_2, mcrotainter_analyzer_colimator_2_blade_1);
  rot_transpose(mcrotainter_analyzer_colimator_2_blade_0, mctr1);
  rot_mul(mcrotainter_analyzer_colimator_2_blade_1, mctr1, mcrotrinter_analyzer_colimator_2_blade_1);
  mctc1 = coords_set(
#line 1106 "MACS_sample_kidney_box.instr"
    0,
#line 1106 "MACS_sample_kidney_box.instr"
    0,
#line 1106 "MACS_sample_kidney_box.instr"
    inter_analyzer_colimator_start_pos - 1 * inter_analyzer_colimator_seperation);
#line 103916 "MACS_sample_kidney_box.c"
  rot_transpose(mcrotainter_analyzer_colimator_center_2, mctr1);
  mctc2 = rot_apply(mctr1, mctc1);
  mcposainter_analyzer_colimator_2_blade_1 = coords_add(mcposainter_analyzer_colimator_center_2, mctc2);
  mctc1 = coords_sub(mcposainter_analyzer_colimator_2_blade_0, mcposainter_analyzer_colimator_2_blade_1);
  mcposrinter_analyzer_colimator_2_blade_1 = rot_apply(mcrotainter_analyzer_colimator_2_blade_1, mctc1);
  mcDEBUG_COMPONENT("inter_analyzer_colimator_2_blade_1", mcposainter_analyzer_colimator_2_blade_1, mcrotainter_analyzer_colimator_2_blade_1)
  mccomp_posa[232] = mcposainter_analyzer_colimator_2_blade_1;
  mccomp_posr[232] = mcposrinter_analyzer_colimator_2_blade_1;
  mcNCounter[232]  = mcPCounter[232] = mcP2Counter[232] = 0;
  mcAbsorbProp[232]= 0;
    /* Component inter_analyzer_colimator_2_blade_2. */
  /* Setting parameters for component inter_analyzer_colimator_2_blade_2. */
  SIG_MESSAGE("inter_analyzer_colimator_2_blade_2 (Init:SetPar)");
#line 1111 "MACS_sample_kidney_box.instr"
  if("Collimator_gad") strncpy(mccinter_analyzer_colimator_2_blade_2_material_string, "Collimator_gad" ? "Collimator_gad" : "", 16384); else mccinter_analyzer_colimator_2_blade_2_material_string[0]='\0';
#line 1111 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_2_blade_2_priority = 427;
#line 1110 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_2_blade_2_xwidth = inter_analyzer_colimator_width;
#line 1110 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_2_blade_2_yheight = inter_analyzer_colimator_height;
#line 1110 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_2_blade_2_zdepth = inter_analyzer_colimator_depth;
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_2_blade_2_xwidth2 = -1;
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_2_blade_2_yheight2 = -1;
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_2_blade_2_visualize = 1;
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_2_blade_2_target_index = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_2_blade_2_target_x = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_2_blade_2_target_y = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_2_blade_2_target_z = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_2_blade_2_focus_aw = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_2_blade_2_focus_ah = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_2_blade_2_focus_xw = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_2_blade_2_focus_xh = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_2_blade_2_focus_r = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_2_blade_2_p_interact = 0;
#line 71 "MACS_sample_kidney_box.instr"
  if(0) strncpy(mccinter_analyzer_colimator_2_blade_2_mask_string, 0 ? 0 : "", 16384); else mccinter_analyzer_colimator_2_blade_2_mask_string[0]='\0';
#line 71 "MACS_sample_kidney_box.instr"
  if(0) strncpy(mccinter_analyzer_colimator_2_blade_2_mask_setting, 0 ? 0 : "", 16384); else mccinter_analyzer_colimator_2_blade_2_mask_setting[0]='\0';
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_2_blade_2_number_of_activations = 1;
#line 103972 "MACS_sample_kidney_box.c"

  SIG_MESSAGE("inter_analyzer_colimator_2_blade_2 (Init:Place/Rotate)");
  rot_set_rotation(mctr1,
#line 1113 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 1113 "MACS_sample_kidney_box.instr"
    (- analyzer_2theta [ 2 ])*DEG2RAD,
#line 1113 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD);
#line 103982 "MACS_sample_kidney_box.c"
  rot_mul(mctr1, mcrotainter_analyzer_colimator_center_2, mcrotainter_analyzer_colimator_2_blade_2);
  rot_transpose(mcrotainter_analyzer_colimator_2_blade_1, mctr1);
  rot_mul(mcrotainter_analyzer_colimator_2_blade_2, mctr1, mcrotrinter_analyzer_colimator_2_blade_2);
  mctc1 = coords_set(
#line 1112 "MACS_sample_kidney_box.instr"
    0,
#line 1112 "MACS_sample_kidney_box.instr"
    0,
#line 1112 "MACS_sample_kidney_box.instr"
    inter_analyzer_colimator_start_pos - 2 * inter_analyzer_colimator_seperation);
#line 103993 "MACS_sample_kidney_box.c"
  rot_transpose(mcrotainter_analyzer_colimator_center_2, mctr1);
  mctc2 = rot_apply(mctr1, mctc1);
  mcposainter_analyzer_colimator_2_blade_2 = coords_add(mcposainter_analyzer_colimator_center_2, mctc2);
  mctc1 = coords_sub(mcposainter_analyzer_colimator_2_blade_1, mcposainter_analyzer_colimator_2_blade_2);
  mcposrinter_analyzer_colimator_2_blade_2 = rot_apply(mcrotainter_analyzer_colimator_2_blade_2, mctc1);
  mcDEBUG_COMPONENT("inter_analyzer_colimator_2_blade_2", mcposainter_analyzer_colimator_2_blade_2, mcrotainter_analyzer_colimator_2_blade_2)
  mccomp_posa[233] = mcposainter_analyzer_colimator_2_blade_2;
  mccomp_posr[233] = mcposrinter_analyzer_colimator_2_blade_2;
  mcNCounter[233]  = mcPCounter[233] = mcP2Counter[233] = 0;
  mcAbsorbProp[233]= 0;
    /* Component inter_analyzer_colimator_2_blade_3. */
  /* Setting parameters for component inter_analyzer_colimator_2_blade_3. */
  SIG_MESSAGE("inter_analyzer_colimator_2_blade_3 (Init:SetPar)");
#line 1117 "MACS_sample_kidney_box.instr"
  if("Collimator_gad") strncpy(mccinter_analyzer_colimator_2_blade_3_material_string, "Collimator_gad" ? "Collimator_gad" : "", 16384); else mccinter_analyzer_colimator_2_blade_3_material_string[0]='\0';
#line 1117 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_2_blade_3_priority = 428;
#line 1116 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_2_blade_3_xwidth = inter_analyzer_colimator_width;
#line 1116 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_2_blade_3_yheight = inter_analyzer_colimator_height;
#line 1116 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_2_blade_3_zdepth = inter_analyzer_colimator_depth;
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_2_blade_3_xwidth2 = -1;
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_2_blade_3_yheight2 = -1;
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_2_blade_3_visualize = 1;
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_2_blade_3_target_index = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_2_blade_3_target_x = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_2_blade_3_target_y = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_2_blade_3_target_z = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_2_blade_3_focus_aw = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_2_blade_3_focus_ah = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_2_blade_3_focus_xw = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_2_blade_3_focus_xh = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_2_blade_3_focus_r = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_2_blade_3_p_interact = 0;
#line 71 "MACS_sample_kidney_box.instr"
  if(0) strncpy(mccinter_analyzer_colimator_2_blade_3_mask_string, 0 ? 0 : "", 16384); else mccinter_analyzer_colimator_2_blade_3_mask_string[0]='\0';
#line 71 "MACS_sample_kidney_box.instr"
  if(0) strncpy(mccinter_analyzer_colimator_2_blade_3_mask_setting, 0 ? 0 : "", 16384); else mccinter_analyzer_colimator_2_blade_3_mask_setting[0]='\0';
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_2_blade_3_number_of_activations = 1;
#line 104049 "MACS_sample_kidney_box.c"

  SIG_MESSAGE("inter_analyzer_colimator_2_blade_3 (Init:Place/Rotate)");
  rot_set_rotation(mctr1,
#line 1119 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 1119 "MACS_sample_kidney_box.instr"
    (- analyzer_2theta [ 2 ])*DEG2RAD,
#line 1119 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD);
#line 104059 "MACS_sample_kidney_box.c"
  rot_mul(mctr1, mcrotainter_analyzer_colimator_center_2, mcrotainter_analyzer_colimator_2_blade_3);
  rot_transpose(mcrotainter_analyzer_colimator_2_blade_2, mctr1);
  rot_mul(mcrotainter_analyzer_colimator_2_blade_3, mctr1, mcrotrinter_analyzer_colimator_2_blade_3);
  mctc1 = coords_set(
#line 1118 "MACS_sample_kidney_box.instr"
    0,
#line 1118 "MACS_sample_kidney_box.instr"
    0,
#line 1118 "MACS_sample_kidney_box.instr"
    inter_analyzer_colimator_start_pos - 3 * inter_analyzer_colimator_seperation);
#line 104070 "MACS_sample_kidney_box.c"
  rot_transpose(mcrotainter_analyzer_colimator_center_2, mctr1);
  mctc2 = rot_apply(mctr1, mctc1);
  mcposainter_analyzer_colimator_2_blade_3 = coords_add(mcposainter_analyzer_colimator_center_2, mctc2);
  mctc1 = coords_sub(mcposainter_analyzer_colimator_2_blade_2, mcposainter_analyzer_colimator_2_blade_3);
  mcposrinter_analyzer_colimator_2_blade_3 = rot_apply(mcrotainter_analyzer_colimator_2_blade_3, mctc1);
  mcDEBUG_COMPONENT("inter_analyzer_colimator_2_blade_3", mcposainter_analyzer_colimator_2_blade_3, mcrotainter_analyzer_colimator_2_blade_3)
  mccomp_posa[234] = mcposainter_analyzer_colimator_2_blade_3;
  mccomp_posr[234] = mcposrinter_analyzer_colimator_2_blade_3;
  mcNCounter[234]  = mcPCounter[234] = mcP2Counter[234] = 0;
  mcAbsorbProp[234]= 0;
    /* Component inter_analyzer_colimator_2_blade_4. */
  /* Setting parameters for component inter_analyzer_colimator_2_blade_4. */
  SIG_MESSAGE("inter_analyzer_colimator_2_blade_4 (Init:SetPar)");
#line 1123 "MACS_sample_kidney_box.instr"
  if("Collimator_gad") strncpy(mccinter_analyzer_colimator_2_blade_4_material_string, "Collimator_gad" ? "Collimator_gad" : "", 16384); else mccinter_analyzer_colimator_2_blade_4_material_string[0]='\0';
#line 1123 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_2_blade_4_priority = 429;
#line 1122 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_2_blade_4_xwidth = inter_analyzer_colimator_width;
#line 1122 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_2_blade_4_yheight = inter_analyzer_colimator_height;
#line 1122 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_2_blade_4_zdepth = inter_analyzer_colimator_depth;
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_2_blade_4_xwidth2 = -1;
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_2_blade_4_yheight2 = -1;
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_2_blade_4_visualize = 1;
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_2_blade_4_target_index = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_2_blade_4_target_x = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_2_blade_4_target_y = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_2_blade_4_target_z = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_2_blade_4_focus_aw = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_2_blade_4_focus_ah = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_2_blade_4_focus_xw = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_2_blade_4_focus_xh = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_2_blade_4_focus_r = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_2_blade_4_p_interact = 0;
#line 71 "MACS_sample_kidney_box.instr"
  if(0) strncpy(mccinter_analyzer_colimator_2_blade_4_mask_string, 0 ? 0 : "", 16384); else mccinter_analyzer_colimator_2_blade_4_mask_string[0]='\0';
#line 71 "MACS_sample_kidney_box.instr"
  if(0) strncpy(mccinter_analyzer_colimator_2_blade_4_mask_setting, 0 ? 0 : "", 16384); else mccinter_analyzer_colimator_2_blade_4_mask_setting[0]='\0';
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_2_blade_4_number_of_activations = 1;
#line 104126 "MACS_sample_kidney_box.c"

  SIG_MESSAGE("inter_analyzer_colimator_2_blade_4 (Init:Place/Rotate)");
  rot_set_rotation(mctr1,
#line 1125 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 1125 "MACS_sample_kidney_box.instr"
    (- analyzer_2theta [ 2 ])*DEG2RAD,
#line 1125 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD);
#line 104136 "MACS_sample_kidney_box.c"
  rot_mul(mctr1, mcrotainter_analyzer_colimator_center_2, mcrotainter_analyzer_colimator_2_blade_4);
  rot_transpose(mcrotainter_analyzer_colimator_2_blade_3, mctr1);
  rot_mul(mcrotainter_analyzer_colimator_2_blade_4, mctr1, mcrotrinter_analyzer_colimator_2_blade_4);
  mctc1 = coords_set(
#line 1124 "MACS_sample_kidney_box.instr"
    0,
#line 1124 "MACS_sample_kidney_box.instr"
    0,
#line 1124 "MACS_sample_kidney_box.instr"
    inter_analyzer_colimator_start_pos - 4 * inter_analyzer_colimator_seperation);
#line 104147 "MACS_sample_kidney_box.c"
  rot_transpose(mcrotainter_analyzer_colimator_center_2, mctr1);
  mctc2 = rot_apply(mctr1, mctc1);
  mcposainter_analyzer_colimator_2_blade_4 = coords_add(mcposainter_analyzer_colimator_center_2, mctc2);
  mctc1 = coords_sub(mcposainter_analyzer_colimator_2_blade_3, mcposainter_analyzer_colimator_2_blade_4);
  mcposrinter_analyzer_colimator_2_blade_4 = rot_apply(mcrotainter_analyzer_colimator_2_blade_4, mctc1);
  mcDEBUG_COMPONENT("inter_analyzer_colimator_2_blade_4", mcposainter_analyzer_colimator_2_blade_4, mcrotainter_analyzer_colimator_2_blade_4)
  mccomp_posa[235] = mcposainter_analyzer_colimator_2_blade_4;
  mccomp_posr[235] = mcposrinter_analyzer_colimator_2_blade_4;
  mcNCounter[235]  = mcPCounter[235] = mcP2Counter[235] = 0;
  mcAbsorbProp[235]= 0;
    /* Component diffraction_detector_2_exit_volume. */
  /* Setting parameters for component diffraction_detector_2_exit_volume. */
  SIG_MESSAGE("diffraction_detector_2_exit_volume (Init:SetPar)");
#line 1129 "MACS_sample_kidney_box.instr"
  if("Exit") strncpy(mccdiffraction_detector_2_exit_volume_material_string, "Exit" ? "Exit" : "", 16384); else mccdiffraction_detector_2_exit_volume_material_string[0]='\0';
#line 1129 "MACS_sample_kidney_box.instr"
  mccdiffraction_detector_2_exit_volume_priority = 431;
#line 1128 "MACS_sample_kidney_box.instr"
  mccdiffraction_detector_2_exit_volume_xwidth = 2.01 * detector_radius;
#line 1128 "MACS_sample_kidney_box.instr"
  mccdiffraction_detector_2_exit_volume_yheight = 1.01 * detector_height;
#line 1128 "MACS_sample_kidney_box.instr"
  mccdiffraction_detector_2_exit_volume_zdepth = 0.001;
#line 71 "MACS_sample_kidney_box.instr"
  mccdiffraction_detector_2_exit_volume_xwidth2 = -1;
#line 71 "MACS_sample_kidney_box.instr"
  mccdiffraction_detector_2_exit_volume_yheight2 = -1;
#line 71 "MACS_sample_kidney_box.instr"
  mccdiffraction_detector_2_exit_volume_visualize = 1;
#line 71 "MACS_sample_kidney_box.instr"
  mccdiffraction_detector_2_exit_volume_target_index = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccdiffraction_detector_2_exit_volume_target_x = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccdiffraction_detector_2_exit_volume_target_y = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccdiffraction_detector_2_exit_volume_target_z = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccdiffraction_detector_2_exit_volume_focus_aw = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccdiffraction_detector_2_exit_volume_focus_ah = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccdiffraction_detector_2_exit_volume_focus_xw = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccdiffraction_detector_2_exit_volume_focus_xh = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccdiffraction_detector_2_exit_volume_focus_r = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccdiffraction_detector_2_exit_volume_p_interact = 0;
#line 71 "MACS_sample_kidney_box.instr"
  if(0) strncpy(mccdiffraction_detector_2_exit_volume_mask_string, 0 ? 0 : "", 16384); else mccdiffraction_detector_2_exit_volume_mask_string[0]='\0';
#line 71 "MACS_sample_kidney_box.instr"
  if(0) strncpy(mccdiffraction_detector_2_exit_volume_mask_setting, 0 ? 0 : "", 16384); else mccdiffraction_detector_2_exit_volume_mask_setting[0]='\0';
#line 71 "MACS_sample_kidney_box.instr"
  mccdiffraction_detector_2_exit_volume_number_of_activations = 1;
#line 104203 "MACS_sample_kidney_box.c"

  SIG_MESSAGE("diffraction_detector_2_exit_volume (Init:Place/Rotate)");
  rot_set_rotation(mctr1,
#line 1131 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 1131 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 1131 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD);
#line 104213 "MACS_sample_kidney_box.c"
  rot_mul(mctr1, mcrotakidney_channel_2, mcrotadiffraction_detector_2_exit_volume);
  rot_transpose(mcrotainter_analyzer_colimator_2_blade_4, mctr1);
  rot_mul(mcrotadiffraction_detector_2_exit_volume, mctr1, mcrotrdiffraction_detector_2_exit_volume);
  mctc1 = coords_set(
#line 1130 "MACS_sample_kidney_box.instr"
    0,
#line 1130 "MACS_sample_kidney_box.instr"
    0,
#line 1130 "MACS_sample_kidney_box.instr"
    0);
#line 104224 "MACS_sample_kidney_box.c"
  rot_transpose(mcrotachannel_2_cave1_cyl1, mctr1);
  mctc2 = rot_apply(mctr1, mctc1);
  mcposadiffraction_detector_2_exit_volume = coords_add(mcposachannel_2_cave1_cyl1, mctc2);
  mctc1 = coords_sub(mcposainter_analyzer_colimator_2_blade_4, mcposadiffraction_detector_2_exit_volume);
  mcposrdiffraction_detector_2_exit_volume = rot_apply(mcrotadiffraction_detector_2_exit_volume, mctc1);
  mcDEBUG_COMPONENT("diffraction_detector_2_exit_volume", mcposadiffraction_detector_2_exit_volume, mcrotadiffraction_detector_2_exit_volume)
  mccomp_posa[236] = mcposadiffraction_detector_2_exit_volume;
  mccomp_posr[236] = mcposrdiffraction_detector_2_exit_volume;
  mcNCounter[236]  = mcPCounter[236] = mcP2Counter[236] = 0;
  mcAbsorbProp[236]= 0;
    /* Component spec_detector_2_exit_volume. */
  /* Setting parameters for component spec_detector_2_exit_volume. */
  SIG_MESSAGE("spec_detector_2_exit_volume (Init:SetPar)");
#line 1135 "MACS_sample_kidney_box.instr"
  if("Exit") strncpy(mccspec_detector_2_exit_volume_material_string, "Exit" ? "Exit" : "", 16384); else mccspec_detector_2_exit_volume_material_string[0]='\0';
#line 1135 "MACS_sample_kidney_box.instr"
  mccspec_detector_2_exit_volume_priority = 432;
#line 1134 "MACS_sample_kidney_box.instr"
  mccspec_detector_2_exit_volume_xwidth = 2.01 * detector_radius;
#line 1134 "MACS_sample_kidney_box.instr"
  mccspec_detector_2_exit_volume_yheight = 1.01 * detector_height;
#line 1134 "MACS_sample_kidney_box.instr"
  mccspec_detector_2_exit_volume_zdepth = 0.001;
#line 71 "MACS_sample_kidney_box.instr"
  mccspec_detector_2_exit_volume_xwidth2 = -1;
#line 71 "MACS_sample_kidney_box.instr"
  mccspec_detector_2_exit_volume_yheight2 = -1;
#line 71 "MACS_sample_kidney_box.instr"
  mccspec_detector_2_exit_volume_visualize = 1;
#line 71 "MACS_sample_kidney_box.instr"
  mccspec_detector_2_exit_volume_target_index = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccspec_detector_2_exit_volume_target_x = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccspec_detector_2_exit_volume_target_y = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccspec_detector_2_exit_volume_target_z = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccspec_detector_2_exit_volume_focus_aw = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccspec_detector_2_exit_volume_focus_ah = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccspec_detector_2_exit_volume_focus_xw = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccspec_detector_2_exit_volume_focus_xh = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccspec_detector_2_exit_volume_focus_r = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccspec_detector_2_exit_volume_p_interact = 0;
#line 71 "MACS_sample_kidney_box.instr"
  if(0) strncpy(mccspec_detector_2_exit_volume_mask_string, 0 ? 0 : "", 16384); else mccspec_detector_2_exit_volume_mask_string[0]='\0';
#line 71 "MACS_sample_kidney_box.instr"
  if(0) strncpy(mccspec_detector_2_exit_volume_mask_setting, 0 ? 0 : "", 16384); else mccspec_detector_2_exit_volume_mask_setting[0]='\0';
#line 71 "MACS_sample_kidney_box.instr"
  mccspec_detector_2_exit_volume_number_of_activations = 1;
#line 104280 "MACS_sample_kidney_box.c"

  SIG_MESSAGE("spec_detector_2_exit_volume (Init:Place/Rotate)");
  rot_set_rotation(mctr1,
#line 1137 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 1137 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 1137 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD);
#line 104290 "MACS_sample_kidney_box.c"
  rot_mul(mctr1, mcrotachannel_2_analyzer_2_center, mcrotaspec_detector_2_exit_volume);
  rot_transpose(mcrotadiffraction_detector_2_exit_volume, mctr1);
  rot_mul(mcrotaspec_detector_2_exit_volume, mctr1, mcrotrspec_detector_2_exit_volume);
  mctc1 = coords_set(
#line 1136 "MACS_sample_kidney_box.instr"
    0,
#line 1136 "MACS_sample_kidney_box.instr"
    0,
#line 1136 "MACS_sample_kidney_box.instr"
    0);
#line 104301 "MACS_sample_kidney_box.c"
  rot_transpose(mcrotachannel_2_cave2_cyl1, mctr1);
  mctc2 = rot_apply(mctr1, mctc1);
  mcposaspec_detector_2_exit_volume = coords_add(mcposachannel_2_cave2_cyl1, mctc2);
  mctc1 = coords_sub(mcposadiffraction_detector_2_exit_volume, mcposaspec_detector_2_exit_volume);
  mcposrspec_detector_2_exit_volume = rot_apply(mcrotaspec_detector_2_exit_volume, mctc1);
  mcDEBUG_COMPONENT("spec_detector_2_exit_volume", mcposaspec_detector_2_exit_volume, mcrotaspec_detector_2_exit_volume)
  mccomp_posa[237] = mcposaspec_detector_2_exit_volume;
  mccomp_posr[237] = mcposrspec_detector_2_exit_volume;
  mcNCounter[237]  = mcPCounter[237] = mcP2Counter[237] = 0;
  mcAbsorbProp[237]= 0;
    /* Component channel_3_cave1_box1. */
  /* Setting parameters for component channel_3_cave1_box1. */
  SIG_MESSAGE("channel_3_cave1_box1 (Init:SetPar)");
#line 1142 "MACS_sample_kidney_box.instr"
  if("Vacuum") strncpy(mccchannel_3_cave1_box1_material_string, "Vacuum" ? "Vacuum" : "", 16384); else mccchannel_3_cave1_box1_material_string[0]='\0';
#line 1142 "MACS_sample_kidney_box.instr"
  mccchannel_3_cave1_box1_priority = 500;
#line 1140 "MACS_sample_kidney_box.instr"
  mccchannel_3_cave1_box1_xwidth = kidney_cave1_box1_width1;
#line 1140 "MACS_sample_kidney_box.instr"
  mccchannel_3_cave1_box1_yheight = kidney_cave1_box1_height1;
#line 1140 "MACS_sample_kidney_box.instr"
  mccchannel_3_cave1_box1_zdepth = kidney_cave1_box1_depth;
#line 1141 "MACS_sample_kidney_box.instr"
  mccchannel_3_cave1_box1_xwidth2 = kidney_cave1_box1_width2;
#line 1141 "MACS_sample_kidney_box.instr"
  mccchannel_3_cave1_box1_yheight2 = kidney_cave1_box1_height2;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_3_cave1_box1_visualize = 1;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_3_cave1_box1_target_index = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_3_cave1_box1_target_x = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_3_cave1_box1_target_y = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_3_cave1_box1_target_z = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_3_cave1_box1_focus_aw = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_3_cave1_box1_focus_ah = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_3_cave1_box1_focus_xw = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_3_cave1_box1_focus_xh = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_3_cave1_box1_focus_r = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_3_cave1_box1_p_interact = 0;
#line 71 "MACS_sample_kidney_box.instr"
  if(0) strncpy(mccchannel_3_cave1_box1_mask_string, 0 ? 0 : "", 16384); else mccchannel_3_cave1_box1_mask_string[0]='\0';
#line 71 "MACS_sample_kidney_box.instr"
  if(0) strncpy(mccchannel_3_cave1_box1_mask_setting, 0 ? 0 : "", 16384); else mccchannel_3_cave1_box1_mask_setting[0]='\0';
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_3_cave1_box1_number_of_activations = 1;
#line 104357 "MACS_sample_kidney_box.c"

  SIG_MESSAGE("channel_3_cave1_box1 (Init:Place/Rotate)");
  rot_set_rotation(mctr1,
#line 1144 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 1144 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 1144 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD);
#line 104367 "MACS_sample_kidney_box.c"
  rot_mul(mctr1, mcrotakidney_channel_3, mcrotachannel_3_cave1_box1);
  rot_transpose(mcrotaspec_detector_2_exit_volume, mctr1);
  rot_mul(mcrotachannel_3_cave1_box1, mctr1, mcrotrchannel_3_cave1_box1);
  mctc1 = coords_set(
#line 1143 "MACS_sample_kidney_box.instr"
    0,
#line 1143 "MACS_sample_kidney_box.instr"
    0,
#line 1143 "MACS_sample_kidney_box.instr"
    kidney_cave1_box1_center_to_target);
#line 104378 "MACS_sample_kidney_box.c"
  rot_transpose(mcrotakidney_channel_3, mctr1);
  mctc2 = rot_apply(mctr1, mctc1);
  mcposachannel_3_cave1_box1 = coords_add(mcposakidney_channel_3, mctc2);
  mctc1 = coords_sub(mcposaspec_detector_2_exit_volume, mcposachannel_3_cave1_box1);
  mcposrchannel_3_cave1_box1 = rot_apply(mcrotachannel_3_cave1_box1, mctc1);
  mcDEBUG_COMPONENT("channel_3_cave1_box1", mcposachannel_3_cave1_box1, mcrotachannel_3_cave1_box1)
  mccomp_posa[238] = mcposachannel_3_cave1_box1;
  mccomp_posr[238] = mcposrchannel_3_cave1_box1;
  mcNCounter[238]  = mcPCounter[238] = mcP2Counter[238] = 0;
  mcAbsorbProp[238]= 0;
    /* Component channel_3_cave1_box2. */
  /* Setting parameters for component channel_3_cave1_box2. */
  SIG_MESSAGE("channel_3_cave1_box2 (Init:SetPar)");
#line 1149 "MACS_sample_kidney_box.instr"
  if("Vacuum") strncpy(mccchannel_3_cave1_box2_material_string, "Vacuum" ? "Vacuum" : "", 16384); else mccchannel_3_cave1_box2_material_string[0]='\0';
#line 1149 "MACS_sample_kidney_box.instr"
  mccchannel_3_cave1_box2_priority = 505;
#line 1147 "MACS_sample_kidney_box.instr"
  mccchannel_3_cave1_box2_xwidth = kidney_cave1_box2_width1;
#line 1147 "MACS_sample_kidney_box.instr"
  mccchannel_3_cave1_box2_yheight = kidney_cave1_box2_height1;
#line 1147 "MACS_sample_kidney_box.instr"
  mccchannel_3_cave1_box2_zdepth = kidney_cave1_box2_depth;
#line 1148 "MACS_sample_kidney_box.instr"
  mccchannel_3_cave1_box2_xwidth2 = kidney_cave1_box2_width2;
#line 1148 "MACS_sample_kidney_box.instr"
  mccchannel_3_cave1_box2_yheight2 = kidney_cave1_box2_height2;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_3_cave1_box2_visualize = 1;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_3_cave1_box2_target_index = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_3_cave1_box2_target_x = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_3_cave1_box2_target_y = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_3_cave1_box2_target_z = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_3_cave1_box2_focus_aw = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_3_cave1_box2_focus_ah = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_3_cave1_box2_focus_xw = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_3_cave1_box2_focus_xh = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_3_cave1_box2_focus_r = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_3_cave1_box2_p_interact = 0;
#line 71 "MACS_sample_kidney_box.instr"
  if(0) strncpy(mccchannel_3_cave1_box2_mask_string, 0 ? 0 : "", 16384); else mccchannel_3_cave1_box2_mask_string[0]='\0';
#line 71 "MACS_sample_kidney_box.instr"
  if(0) strncpy(mccchannel_3_cave1_box2_mask_setting, 0 ? 0 : "", 16384); else mccchannel_3_cave1_box2_mask_setting[0]='\0';
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_3_cave1_box2_number_of_activations = 1;
#line 104434 "MACS_sample_kidney_box.c"

  SIG_MESSAGE("channel_3_cave1_box2 (Init:Place/Rotate)");
  rot_set_rotation(mctr1,
#line 1151 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 1151 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 1151 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD);
#line 104444 "MACS_sample_kidney_box.c"
  rot_mul(mctr1, mcrotakidney_channel_3, mcrotachannel_3_cave1_box2);
  rot_transpose(mcrotachannel_3_cave1_box1, mctr1);
  rot_mul(mcrotachannel_3_cave1_box2, mctr1, mcrotrchannel_3_cave1_box2);
  mctc1 = coords_set(
#line 1150 "MACS_sample_kidney_box.instr"
    kidney_cave1_box2_x_offset,
#line 1150 "MACS_sample_kidney_box.instr"
    0,
#line 1150 "MACS_sample_kidney_box.instr"
    kidney_cave1_box2_center_to_target);
#line 104455 "MACS_sample_kidney_box.c"
  rot_transpose(mcrotakidney_channel_3, mctr1);
  mctc2 = rot_apply(mctr1, mctc1);
  mcposachannel_3_cave1_box2 = coords_add(mcposakidney_channel_3, mctc2);
  mctc1 = coords_sub(mcposachannel_3_cave1_box1, mcposachannel_3_cave1_box2);
  mcposrchannel_3_cave1_box2 = rot_apply(mcrotachannel_3_cave1_box2, mctc1);
  mcDEBUG_COMPONENT("channel_3_cave1_box2", mcposachannel_3_cave1_box2, mcrotachannel_3_cave1_box2)
  mccomp_posa[239] = mcposachannel_3_cave1_box2;
  mccomp_posr[239] = mcposrchannel_3_cave1_box2;
  mcNCounter[239]  = mcPCounter[239] = mcP2Counter[239] = 0;
  mcAbsorbProp[239]= 0;
    /* Component channel_3_cave1_box3. */
  /* Setting parameters for component channel_3_cave1_box3. */
  SIG_MESSAGE("channel_3_cave1_box3 (Init:SetPar)");
#line 1156 "MACS_sample_kidney_box.instr"
  if("Vacuum") strncpy(mccchannel_3_cave1_box3_material_string, "Vacuum" ? "Vacuum" : "", 16384); else mccchannel_3_cave1_box3_material_string[0]='\0';
#line 1156 "MACS_sample_kidney_box.instr"
  mccchannel_3_cave1_box3_priority = 502;
#line 1154 "MACS_sample_kidney_box.instr"
  mccchannel_3_cave1_box3_xwidth = kidney_cave1_box3_width1;
#line 1154 "MACS_sample_kidney_box.instr"
  mccchannel_3_cave1_box3_yheight = kidney_cave1_box3_height1;
#line 1154 "MACS_sample_kidney_box.instr"
  mccchannel_3_cave1_box3_zdepth = kidney_cave1_box3_depth;
#line 1155 "MACS_sample_kidney_box.instr"
  mccchannel_3_cave1_box3_xwidth2 = kidney_cave1_box3_width2;
#line 1155 "MACS_sample_kidney_box.instr"
  mccchannel_3_cave1_box3_yheight2 = kidney_cave1_box3_height2;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_3_cave1_box3_visualize = 1;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_3_cave1_box3_target_index = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_3_cave1_box3_target_x = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_3_cave1_box3_target_y = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_3_cave1_box3_target_z = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_3_cave1_box3_focus_aw = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_3_cave1_box3_focus_ah = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_3_cave1_box3_focus_xw = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_3_cave1_box3_focus_xh = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_3_cave1_box3_focus_r = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_3_cave1_box3_p_interact = 0;
#line 71 "MACS_sample_kidney_box.instr"
  if(0) strncpy(mccchannel_3_cave1_box3_mask_string, 0 ? 0 : "", 16384); else mccchannel_3_cave1_box3_mask_string[0]='\0';
#line 71 "MACS_sample_kidney_box.instr"
  if(0) strncpy(mccchannel_3_cave1_box3_mask_setting, 0 ? 0 : "", 16384); else mccchannel_3_cave1_box3_mask_setting[0]='\0';
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_3_cave1_box3_number_of_activations = 1;
#line 104511 "MACS_sample_kidney_box.c"

  SIG_MESSAGE("channel_3_cave1_box3 (Init:Place/Rotate)");
  rot_set_rotation(mctr1,
#line 1158 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 1158 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 1158 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD);
#line 104521 "MACS_sample_kidney_box.c"
  rot_mul(mctr1, mcrotakidney_channel_3, mcrotachannel_3_cave1_box3);
  rot_transpose(mcrotachannel_3_cave1_box2, mctr1);
  rot_mul(mcrotachannel_3_cave1_box3, mctr1, mcrotrchannel_3_cave1_box3);
  mctc1 = coords_set(
#line 1157 "MACS_sample_kidney_box.instr"
    0,
#line 1157 "MACS_sample_kidney_box.instr"
    0,
#line 1157 "MACS_sample_kidney_box.instr"
    kidney_cave1_box3_center_to_target);
#line 104532 "MACS_sample_kidney_box.c"
  rot_transpose(mcrotakidney_channel_3, mctr1);
  mctc2 = rot_apply(mctr1, mctc1);
  mcposachannel_3_cave1_box3 = coords_add(mcposakidney_channel_3, mctc2);
  mctc1 = coords_sub(mcposachannel_3_cave1_box2, mcposachannel_3_cave1_box3);
  mcposrchannel_3_cave1_box3 = rot_apply(mcrotachannel_3_cave1_box3, mctc1);
  mcDEBUG_COMPONENT("channel_3_cave1_box3", mcposachannel_3_cave1_box3, mcrotachannel_3_cave1_box3)
  mccomp_posa[240] = mcposachannel_3_cave1_box3;
  mccomp_posr[240] = mcposrchannel_3_cave1_box3;
  mcNCounter[240]  = mcPCounter[240] = mcP2Counter[240] = 0;
  mcAbsorbProp[240]= 0;
    /* Component channel_3_cave1_cyl1. */
  /* Setting parameters for component channel_3_cave1_cyl1. */
  SIG_MESSAGE("channel_3_cave1_cyl1 (Init:SetPar)");
#line 1162 "MACS_sample_kidney_box.instr"
  if("Vacuum") strncpy(mccchannel_3_cave1_cyl1_material_string, "Vacuum" ? "Vacuum" : "", 16384); else mccchannel_3_cave1_cyl1_material_string[0]='\0';
#line 1162 "MACS_sample_kidney_box.instr"
  mccchannel_3_cave1_cyl1_priority = 503;
#line 1161 "MACS_sample_kidney_box.instr"
  mccchannel_3_cave1_cyl1_radius = kidney_cave1_cyl1_radius;
#line 1161 "MACS_sample_kidney_box.instr"
  mccchannel_3_cave1_cyl1_yheight = kidney_cave1_cyl1_height;
#line 67 "MACS_sample_kidney_box.instr"
  mccchannel_3_cave1_cyl1_visualize = 1;
#line 67 "MACS_sample_kidney_box.instr"
  mccchannel_3_cave1_cyl1_target_index = 0;
#line 67 "MACS_sample_kidney_box.instr"
  mccchannel_3_cave1_cyl1_target_x = 0;
#line 67 "MACS_sample_kidney_box.instr"
  mccchannel_3_cave1_cyl1_target_y = 0;
#line 67 "MACS_sample_kidney_box.instr"
  mccchannel_3_cave1_cyl1_target_z = 0;
#line 67 "MACS_sample_kidney_box.instr"
  mccchannel_3_cave1_cyl1_focus_aw = 0;
#line 67 "MACS_sample_kidney_box.instr"
  mccchannel_3_cave1_cyl1_focus_ah = 0;
#line 67 "MACS_sample_kidney_box.instr"
  mccchannel_3_cave1_cyl1_focus_xw = 0;
#line 67 "MACS_sample_kidney_box.instr"
  mccchannel_3_cave1_cyl1_focus_xh = 0;
#line 67 "MACS_sample_kidney_box.instr"
  mccchannel_3_cave1_cyl1_focus_r = 0;
#line 67 "MACS_sample_kidney_box.instr"
  mccchannel_3_cave1_cyl1_p_interact = 0;
#line 67 "MACS_sample_kidney_box.instr"
  if(0) strncpy(mccchannel_3_cave1_cyl1_mask_string, 0 ? 0 : "", 16384); else mccchannel_3_cave1_cyl1_mask_string[0]='\0';
#line 67 "MACS_sample_kidney_box.instr"
  if(0) strncpy(mccchannel_3_cave1_cyl1_mask_setting, 0 ? 0 : "", 16384); else mccchannel_3_cave1_cyl1_mask_setting[0]='\0';
#line 67 "MACS_sample_kidney_box.instr"
  mccchannel_3_cave1_cyl1_number_of_activations = 1;
#line 104582 "MACS_sample_kidney_box.c"

  SIG_MESSAGE("channel_3_cave1_cyl1 (Init:Place/Rotate)");
  rot_set_rotation(mctr1,
#line 1164 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 1164 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 1164 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD);
#line 104592 "MACS_sample_kidney_box.c"
  rot_mul(mctr1, mcrotakidney_channel_3, mcrotachannel_3_cave1_cyl1);
  rot_transpose(mcrotachannel_3_cave1_box3, mctr1);
  rot_mul(mcrotachannel_3_cave1_cyl1, mctr1, mcrotrchannel_3_cave1_cyl1);
  mctc1 = coords_set(
#line 1163 "MACS_sample_kidney_box.instr"
    0,
#line 1163 "MACS_sample_kidney_box.instr"
    0,
#line 1163 "MACS_sample_kidney_box.instr"
    kidney_cave1_cyl1_center_to_target);
#line 104603 "MACS_sample_kidney_box.c"
  rot_transpose(mcrotakidney_channel_3, mctr1);
  mctc2 = rot_apply(mctr1, mctc1);
  mcposachannel_3_cave1_cyl1 = coords_add(mcposakidney_channel_3, mctc2);
  mctc1 = coords_sub(mcposachannel_3_cave1_box3, mcposachannel_3_cave1_cyl1);
  mcposrchannel_3_cave1_cyl1 = rot_apply(mcrotachannel_3_cave1_cyl1, mctc1);
  mcDEBUG_COMPONENT("channel_3_cave1_cyl1", mcposachannel_3_cave1_cyl1, mcrotachannel_3_cave1_cyl1)
  mccomp_posa[241] = mcposachannel_3_cave1_cyl1;
  mccomp_posr[241] = mcposrchannel_3_cave1_cyl1;
  mcNCounter[241]  = mcPCounter[241] = mcP2Counter[241] = 0;
  mcAbsorbProp[241]= 0;
    /* Component channel_3_analyzer_1_center. */
  /* Setting parameters for component channel_3_analyzer_1_center. */
  SIG_MESSAGE("channel_3_analyzer_1_center (Init:SetPar)");

  SIG_MESSAGE("channel_3_analyzer_1_center (Init:Place/Rotate)");
  rot_set_rotation(mctr1,
    (0.0)*DEG2RAD,
    (0.0)*DEG2RAD,
    (0.0)*DEG2RAD);
#line 104623 "MACS_sample_kidney_box.c"
  rot_mul(mctr1, mcrotakidney_channel_3, mcrotachannel_3_analyzer_1_center);
  rot_transpose(mcrotachannel_3_cave1_cyl1, mctr1);
  rot_mul(mcrotachannel_3_analyzer_1_center, mctr1, mcrotrchannel_3_analyzer_1_center);
  mctc1 = coords_set(
#line 1168 "MACS_sample_kidney_box.instr"
    0,
#line 1168 "MACS_sample_kidney_box.instr"
    0,
#line 1168 "MACS_sample_kidney_box.instr"
    analyzer_1_center_to_sample);
#line 104634 "MACS_sample_kidney_box.c"
  rot_transpose(mcrotakidney_channel_3, mctr1);
  mctc2 = rot_apply(mctr1, mctc1);
  mcposachannel_3_analyzer_1_center = coords_add(mcposakidney_channel_3, mctc2);
  mctc1 = coords_sub(mcposachannel_3_cave1_cyl1, mcposachannel_3_analyzer_1_center);
  mcposrchannel_3_analyzer_1_center = rot_apply(mcrotachannel_3_analyzer_1_center, mctc1);
  mcDEBUG_COMPONENT("channel_3_analyzer_1_center", mcposachannel_3_analyzer_1_center, mcrotachannel_3_analyzer_1_center)
  mccomp_posa[242] = mcposachannel_3_analyzer_1_center;
  mccomp_posr[242] = mcposrchannel_3_analyzer_1_center;
  mcNCounter[242]  = mcPCounter[242] = mcP2Counter[242] = 0;
  mcAbsorbProp[242]= 0;
    /* Component channel_3_analyzer_1_rotated. */
  /* Setting parameters for component channel_3_analyzer_1_rotated. */
  SIG_MESSAGE("channel_3_analyzer_1_rotated (Init:SetPar)");

  SIG_MESSAGE("channel_3_analyzer_1_rotated (Init:Place/Rotate)");
  rot_set_rotation(mctr1,
#line 1172 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 1172 "MACS_sample_kidney_box.instr"
    (180 - analyzer_theta [ 3 ])*DEG2RAD,
#line 1172 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD);
#line 104657 "MACS_sample_kidney_box.c"
  rot_mul(mctr1, mcrotachannel_3_analyzer_1_center, mcrotachannel_3_analyzer_1_rotated);
  rot_transpose(mcrotachannel_3_analyzer_1_center, mctr1);
  rot_mul(mcrotachannel_3_analyzer_1_rotated, mctr1, mcrotrchannel_3_analyzer_1_rotated);
  mctc1 = coords_set(
#line 1171 "MACS_sample_kidney_box.instr"
    0,
#line 1171 "MACS_sample_kidney_box.instr"
    0,
#line 1171 "MACS_sample_kidney_box.instr"
    -0.5 * analyzer_seperation / tan ( analyzer_2theta [ 3 ] * DEG2RAD ));
#line 104668 "MACS_sample_kidney_box.c"
  rot_transpose(mcrotachannel_3_analyzer_1_center, mctr1);
  mctc2 = rot_apply(mctr1, mctc1);
  mcposachannel_3_analyzer_1_rotated = coords_add(mcposachannel_3_analyzer_1_center, mctc2);
  mctc1 = coords_sub(mcposachannel_3_analyzer_1_center, mcposachannel_3_analyzer_1_rotated);
  mcposrchannel_3_analyzer_1_rotated = rot_apply(mcrotachannel_3_analyzer_1_rotated, mctc1);
  mcDEBUG_COMPONENT("channel_3_analyzer_1_rotated", mcposachannel_3_analyzer_1_rotated, mcrotachannel_3_analyzer_1_rotated)
  mccomp_posa[243] = mcposachannel_3_analyzer_1_rotated;
  mccomp_posr[243] = mcposrchannel_3_analyzer_1_rotated;
  mcNCounter[243]  = mcPCounter[243] = mcP2Counter[243] = 0;
  mcAbsorbProp[243]= 0;
    /* Component channel_3_analyzer_1_array_crystal_array_0. */
  /* Setting parameters for component channel_3_analyzer_1_array_crystal_array_0. */
  SIG_MESSAGE("channel_3_analyzer_1_array_crystal_array_0 (Init:SetPar)");
#line 1176 "MACS_sample_kidney_box.instr"
  if("PG_analyzer") strncpy(mccchannel_3_analyzer_1_array_crystal_array_0_material_string, "PG_analyzer" ? "PG_analyzer" : "", 16384); else mccchannel_3_analyzer_1_array_crystal_array_0_material_string[0]='\0';
#line 1176 "MACS_sample_kidney_box.instr"
  mccchannel_3_analyzer_1_array_crystal_array_0_priority = 520.0;
#line 1175 "MACS_sample_kidney_box.instr"
  mccchannel_3_analyzer_1_array_crystal_array_0_xwidth = channel_3_analyzer_1_array_crystal_depth;
#line 1175 "MACS_sample_kidney_box.instr"
  mccchannel_3_analyzer_1_array_crystal_array_0_yheight = channel_3_analyzer_1_array_crystal_height;
#line 1175 "MACS_sample_kidney_box.instr"
  mccchannel_3_analyzer_1_array_crystal_array_0_zdepth = channel_3_analyzer_1_array_crystal_width;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_3_analyzer_1_array_crystal_array_0_xwidth2 = -1;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_3_analyzer_1_array_crystal_array_0_yheight2 = -1;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_3_analyzer_1_array_crystal_array_0_visualize = 1;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_3_analyzer_1_array_crystal_array_0_target_index = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_3_analyzer_1_array_crystal_array_0_target_x = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_3_analyzer_1_array_crystal_array_0_target_y = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_3_analyzer_1_array_crystal_array_0_target_z = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_3_analyzer_1_array_crystal_array_0_focus_aw = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_3_analyzer_1_array_crystal_array_0_focus_ah = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_3_analyzer_1_array_crystal_array_0_focus_xw = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_3_analyzer_1_array_crystal_array_0_focus_xh = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_3_analyzer_1_array_crystal_array_0_focus_r = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_3_analyzer_1_array_crystal_array_0_p_interact = 0;
#line 71 "MACS_sample_kidney_box.instr"
  if(0) strncpy(mccchannel_3_analyzer_1_array_crystal_array_0_mask_string, 0 ? 0 : "", 16384); else mccchannel_3_analyzer_1_array_crystal_array_0_mask_string[0]='\0';
#line 71 "MACS_sample_kidney_box.instr"
  if(0) strncpy(mccchannel_3_analyzer_1_array_crystal_array_0_mask_setting, 0 ? 0 : "", 16384); else mccchannel_3_analyzer_1_array_crystal_array_0_mask_setting[0]='\0';
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_3_analyzer_1_array_crystal_array_0_number_of_activations = 1;
#line 104724 "MACS_sample_kidney_box.c"

  SIG_MESSAGE("channel_3_analyzer_1_array_crystal_array_0 (Init:Place/Rotate)");
  rot_set_rotation(mctr1,
#line 1178 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 1178 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 1178 "MACS_sample_kidney_box.instr"
    (0 - RAD2DEG * channel_3_analyzer_1_array_theta [ 0 ])*DEG2RAD);
#line 104734 "MACS_sample_kidney_box.c"
  rot_mul(mctr1, mcrotachannel_3_analyzer_1_rotated, mcrotachannel_3_analyzer_1_array_crystal_array_0);
  rot_transpose(mcrotachannel_3_analyzer_1_rotated, mctr1);
  rot_mul(mcrotachannel_3_analyzer_1_array_crystal_array_0, mctr1, mcrotrchannel_3_analyzer_1_array_crystal_array_0);
  mctc1 = coords_set(
#line 1177 "MACS_sample_kidney_box.instr"
    0 + channel_3_analyzer_1_array_effective_radius_of_curvature * ( 1 - cos ( channel_3_analyzer_1_array_theta [ 0 ] ) ),
#line 1177 "MACS_sample_kidney_box.instr"
    0 + channel_3_analyzer_1_array_effective_radius_of_curvature * sin ( channel_3_analyzer_1_array_theta [ 0 ] ),
#line 1177 "MACS_sample_kidney_box.instr"
    0);
#line 104745 "MACS_sample_kidney_box.c"
  rot_transpose(mcrotachannel_3_analyzer_1_rotated, mctr1);
  mctc2 = rot_apply(mctr1, mctc1);
  mcposachannel_3_analyzer_1_array_crystal_array_0 = coords_add(mcposachannel_3_analyzer_1_rotated, mctc2);
  mctc1 = coords_sub(mcposachannel_3_analyzer_1_rotated, mcposachannel_3_analyzer_1_array_crystal_array_0);
  mcposrchannel_3_analyzer_1_array_crystal_array_0 = rot_apply(mcrotachannel_3_analyzer_1_array_crystal_array_0, mctc1);
  mcDEBUG_COMPONENT("channel_3_analyzer_1_array_crystal_array_0", mcposachannel_3_analyzer_1_array_crystal_array_0, mcrotachannel_3_analyzer_1_array_crystal_array_0)
  mccomp_posa[244] = mcposachannel_3_analyzer_1_array_crystal_array_0;
  mccomp_posr[244] = mcposrchannel_3_analyzer_1_array_crystal_array_0;
  mcNCounter[244]  = mcPCounter[244] = mcP2Counter[244] = 0;
  mcAbsorbProp[244]= 0;
    /* Component channel_3_analyzer_1_array_crystal_array_1. */
  /* Setting parameters for component channel_3_analyzer_1_array_crystal_array_1. */
  SIG_MESSAGE("channel_3_analyzer_1_array_crystal_array_1 (Init:SetPar)");
#line 1182 "MACS_sample_kidney_box.instr"
  if("PG_analyzer") strncpy(mccchannel_3_analyzer_1_array_crystal_array_1_material_string, "PG_analyzer" ? "PG_analyzer" : "", 16384); else mccchannel_3_analyzer_1_array_crystal_array_1_material_string[0]='\0';
#line 1182 "MACS_sample_kidney_box.instr"
  mccchannel_3_analyzer_1_array_crystal_array_1_priority = 520.1;
#line 1181 "MACS_sample_kidney_box.instr"
  mccchannel_3_analyzer_1_array_crystal_array_1_xwidth = channel_3_analyzer_1_array_crystal_depth;
#line 1181 "MACS_sample_kidney_box.instr"
  mccchannel_3_analyzer_1_array_crystal_array_1_yheight = channel_3_analyzer_1_array_crystal_height;
#line 1181 "MACS_sample_kidney_box.instr"
  mccchannel_3_analyzer_1_array_crystal_array_1_zdepth = channel_3_analyzer_1_array_crystal_width;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_3_analyzer_1_array_crystal_array_1_xwidth2 = -1;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_3_analyzer_1_array_crystal_array_1_yheight2 = -1;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_3_analyzer_1_array_crystal_array_1_visualize = 1;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_3_analyzer_1_array_crystal_array_1_target_index = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_3_analyzer_1_array_crystal_array_1_target_x = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_3_analyzer_1_array_crystal_array_1_target_y = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_3_analyzer_1_array_crystal_array_1_target_z = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_3_analyzer_1_array_crystal_array_1_focus_aw = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_3_analyzer_1_array_crystal_array_1_focus_ah = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_3_analyzer_1_array_crystal_array_1_focus_xw = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_3_analyzer_1_array_crystal_array_1_focus_xh = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_3_analyzer_1_array_crystal_array_1_focus_r = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_3_analyzer_1_array_crystal_array_1_p_interact = 0;
#line 71 "MACS_sample_kidney_box.instr"
  if(0) strncpy(mccchannel_3_analyzer_1_array_crystal_array_1_mask_string, 0 ? 0 : "", 16384); else mccchannel_3_analyzer_1_array_crystal_array_1_mask_string[0]='\0';
#line 71 "MACS_sample_kidney_box.instr"
  if(0) strncpy(mccchannel_3_analyzer_1_array_crystal_array_1_mask_setting, 0 ? 0 : "", 16384); else mccchannel_3_analyzer_1_array_crystal_array_1_mask_setting[0]='\0';
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_3_analyzer_1_array_crystal_array_1_number_of_activations = 1;
#line 104801 "MACS_sample_kidney_box.c"

  SIG_MESSAGE("channel_3_analyzer_1_array_crystal_array_1 (Init:Place/Rotate)");
  rot_set_rotation(mctr1,
#line 1184 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 1184 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 1184 "MACS_sample_kidney_box.instr"
    (0 - RAD2DEG * channel_3_analyzer_1_array_theta [ 1 ])*DEG2RAD);
#line 104811 "MACS_sample_kidney_box.c"
  rot_mul(mctr1, mcrotachannel_3_analyzer_1_rotated, mcrotachannel_3_analyzer_1_array_crystal_array_1);
  rot_transpose(mcrotachannel_3_analyzer_1_array_crystal_array_0, mctr1);
  rot_mul(mcrotachannel_3_analyzer_1_array_crystal_array_1, mctr1, mcrotrchannel_3_analyzer_1_array_crystal_array_1);
  mctc1 = coords_set(
#line 1183 "MACS_sample_kidney_box.instr"
    0 + channel_3_analyzer_1_array_effective_radius_of_curvature * ( 1 - cos ( channel_3_analyzer_1_array_theta [ 1 ] ) ),
#line 1183 "MACS_sample_kidney_box.instr"
    0 + channel_3_analyzer_1_array_effective_radius_of_curvature * sin ( channel_3_analyzer_1_array_theta [ 1 ] ),
#line 1183 "MACS_sample_kidney_box.instr"
    0);
#line 104822 "MACS_sample_kidney_box.c"
  rot_transpose(mcrotachannel_3_analyzer_1_rotated, mctr1);
  mctc2 = rot_apply(mctr1, mctc1);
  mcposachannel_3_analyzer_1_array_crystal_array_1 = coords_add(mcposachannel_3_analyzer_1_rotated, mctc2);
  mctc1 = coords_sub(mcposachannel_3_analyzer_1_array_crystal_array_0, mcposachannel_3_analyzer_1_array_crystal_array_1);
  mcposrchannel_3_analyzer_1_array_crystal_array_1 = rot_apply(mcrotachannel_3_analyzer_1_array_crystal_array_1, mctc1);
  mcDEBUG_COMPONENT("channel_3_analyzer_1_array_crystal_array_1", mcposachannel_3_analyzer_1_array_crystal_array_1, mcrotachannel_3_analyzer_1_array_crystal_array_1)
  mccomp_posa[245] = mcposachannel_3_analyzer_1_array_crystal_array_1;
  mccomp_posr[245] = mcposrchannel_3_analyzer_1_array_crystal_array_1;
  mcNCounter[245]  = mcPCounter[245] = mcP2Counter[245] = 0;
  mcAbsorbProp[245]= 0;
    /* Component channel_3_analyzer_1_array_crystal_array_2. */
  /* Setting parameters for component channel_3_analyzer_1_array_crystal_array_2. */
  SIG_MESSAGE("channel_3_analyzer_1_array_crystal_array_2 (Init:SetPar)");
#line 1188 "MACS_sample_kidney_box.instr"
  if("PG_analyzer") strncpy(mccchannel_3_analyzer_1_array_crystal_array_2_material_string, "PG_analyzer" ? "PG_analyzer" : "", 16384); else mccchannel_3_analyzer_1_array_crystal_array_2_material_string[0]='\0';
#line 1188 "MACS_sample_kidney_box.instr"
  mccchannel_3_analyzer_1_array_crystal_array_2_priority = 520.2;
#line 1187 "MACS_sample_kidney_box.instr"
  mccchannel_3_analyzer_1_array_crystal_array_2_xwidth = channel_3_analyzer_1_array_crystal_depth;
#line 1187 "MACS_sample_kidney_box.instr"
  mccchannel_3_analyzer_1_array_crystal_array_2_yheight = channel_3_analyzer_1_array_crystal_height;
#line 1187 "MACS_sample_kidney_box.instr"
  mccchannel_3_analyzer_1_array_crystal_array_2_zdepth = channel_3_analyzer_1_array_crystal_width;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_3_analyzer_1_array_crystal_array_2_xwidth2 = -1;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_3_analyzer_1_array_crystal_array_2_yheight2 = -1;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_3_analyzer_1_array_crystal_array_2_visualize = 1;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_3_analyzer_1_array_crystal_array_2_target_index = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_3_analyzer_1_array_crystal_array_2_target_x = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_3_analyzer_1_array_crystal_array_2_target_y = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_3_analyzer_1_array_crystal_array_2_target_z = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_3_analyzer_1_array_crystal_array_2_focus_aw = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_3_analyzer_1_array_crystal_array_2_focus_ah = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_3_analyzer_1_array_crystal_array_2_focus_xw = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_3_analyzer_1_array_crystal_array_2_focus_xh = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_3_analyzer_1_array_crystal_array_2_focus_r = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_3_analyzer_1_array_crystal_array_2_p_interact = 0;
#line 71 "MACS_sample_kidney_box.instr"
  if(0) strncpy(mccchannel_3_analyzer_1_array_crystal_array_2_mask_string, 0 ? 0 : "", 16384); else mccchannel_3_analyzer_1_array_crystal_array_2_mask_string[0]='\0';
#line 71 "MACS_sample_kidney_box.instr"
  if(0) strncpy(mccchannel_3_analyzer_1_array_crystal_array_2_mask_setting, 0 ? 0 : "", 16384); else mccchannel_3_analyzer_1_array_crystal_array_2_mask_setting[0]='\0';
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_3_analyzer_1_array_crystal_array_2_number_of_activations = 1;
#line 104878 "MACS_sample_kidney_box.c"

  SIG_MESSAGE("channel_3_analyzer_1_array_crystal_array_2 (Init:Place/Rotate)");
  rot_set_rotation(mctr1,
#line 1190 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 1190 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 1190 "MACS_sample_kidney_box.instr"
    (0 - RAD2DEG * channel_3_analyzer_1_array_theta [ 2 ])*DEG2RAD);
#line 104888 "MACS_sample_kidney_box.c"
  rot_mul(mctr1, mcrotachannel_3_analyzer_1_rotated, mcrotachannel_3_analyzer_1_array_crystal_array_2);
  rot_transpose(mcrotachannel_3_analyzer_1_array_crystal_array_1, mctr1);
  rot_mul(mcrotachannel_3_analyzer_1_array_crystal_array_2, mctr1, mcrotrchannel_3_analyzer_1_array_crystal_array_2);
  mctc1 = coords_set(
#line 1189 "MACS_sample_kidney_box.instr"
    0 + channel_3_analyzer_1_array_effective_radius_of_curvature * ( 1 - cos ( channel_3_analyzer_1_array_theta [ 2 ] ) ),
#line 1189 "MACS_sample_kidney_box.instr"
    0 + channel_3_analyzer_1_array_effective_radius_of_curvature * sin ( channel_3_analyzer_1_array_theta [ 2 ] ),
#line 1189 "MACS_sample_kidney_box.instr"
    0);
#line 104899 "MACS_sample_kidney_box.c"
  rot_transpose(mcrotachannel_3_analyzer_1_rotated, mctr1);
  mctc2 = rot_apply(mctr1, mctc1);
  mcposachannel_3_analyzer_1_array_crystal_array_2 = coords_add(mcposachannel_3_analyzer_1_rotated, mctc2);
  mctc1 = coords_sub(mcposachannel_3_analyzer_1_array_crystal_array_1, mcposachannel_3_analyzer_1_array_crystal_array_2);
  mcposrchannel_3_analyzer_1_array_crystal_array_2 = rot_apply(mcrotachannel_3_analyzer_1_array_crystal_array_2, mctc1);
  mcDEBUG_COMPONENT("channel_3_analyzer_1_array_crystal_array_2", mcposachannel_3_analyzer_1_array_crystal_array_2, mcrotachannel_3_analyzer_1_array_crystal_array_2)
  mccomp_posa[246] = mcposachannel_3_analyzer_1_array_crystal_array_2;
  mccomp_posr[246] = mcposrchannel_3_analyzer_1_array_crystal_array_2;
  mcNCounter[246]  = mcPCounter[246] = mcP2Counter[246] = 0;
  mcAbsorbProp[246]= 0;
    /* Component channel_3_analyzer_1_array_crystal_array_3. */
  /* Setting parameters for component channel_3_analyzer_1_array_crystal_array_3. */
  SIG_MESSAGE("channel_3_analyzer_1_array_crystal_array_3 (Init:SetPar)");
#line 1194 "MACS_sample_kidney_box.instr"
  if("PG_analyzer") strncpy(mccchannel_3_analyzer_1_array_crystal_array_3_material_string, "PG_analyzer" ? "PG_analyzer" : "", 16384); else mccchannel_3_analyzer_1_array_crystal_array_3_material_string[0]='\0';
#line 1194 "MACS_sample_kidney_box.instr"
  mccchannel_3_analyzer_1_array_crystal_array_3_priority = 520.3;
#line 1193 "MACS_sample_kidney_box.instr"
  mccchannel_3_analyzer_1_array_crystal_array_3_xwidth = channel_3_analyzer_1_array_crystal_depth;
#line 1193 "MACS_sample_kidney_box.instr"
  mccchannel_3_analyzer_1_array_crystal_array_3_yheight = channel_3_analyzer_1_array_crystal_height;
#line 1193 "MACS_sample_kidney_box.instr"
  mccchannel_3_analyzer_1_array_crystal_array_3_zdepth = channel_3_analyzer_1_array_crystal_width;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_3_analyzer_1_array_crystal_array_3_xwidth2 = -1;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_3_analyzer_1_array_crystal_array_3_yheight2 = -1;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_3_analyzer_1_array_crystal_array_3_visualize = 1;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_3_analyzer_1_array_crystal_array_3_target_index = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_3_analyzer_1_array_crystal_array_3_target_x = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_3_analyzer_1_array_crystal_array_3_target_y = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_3_analyzer_1_array_crystal_array_3_target_z = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_3_analyzer_1_array_crystal_array_3_focus_aw = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_3_analyzer_1_array_crystal_array_3_focus_ah = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_3_analyzer_1_array_crystal_array_3_focus_xw = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_3_analyzer_1_array_crystal_array_3_focus_xh = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_3_analyzer_1_array_crystal_array_3_focus_r = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_3_analyzer_1_array_crystal_array_3_p_interact = 0;
#line 71 "MACS_sample_kidney_box.instr"
  if(0) strncpy(mccchannel_3_analyzer_1_array_crystal_array_3_mask_string, 0 ? 0 : "", 16384); else mccchannel_3_analyzer_1_array_crystal_array_3_mask_string[0]='\0';
#line 71 "MACS_sample_kidney_box.instr"
  if(0) strncpy(mccchannel_3_analyzer_1_array_crystal_array_3_mask_setting, 0 ? 0 : "", 16384); else mccchannel_3_analyzer_1_array_crystal_array_3_mask_setting[0]='\0';
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_3_analyzer_1_array_crystal_array_3_number_of_activations = 1;
#line 104955 "MACS_sample_kidney_box.c"

  SIG_MESSAGE("channel_3_analyzer_1_array_crystal_array_3 (Init:Place/Rotate)");
  rot_set_rotation(mctr1,
#line 1196 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 1196 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 1196 "MACS_sample_kidney_box.instr"
    (0 - RAD2DEG * channel_3_analyzer_1_array_theta [ 3 ])*DEG2RAD);
#line 104965 "MACS_sample_kidney_box.c"
  rot_mul(mctr1, mcrotachannel_3_analyzer_1_rotated, mcrotachannel_3_analyzer_1_array_crystal_array_3);
  rot_transpose(mcrotachannel_3_analyzer_1_array_crystal_array_2, mctr1);
  rot_mul(mcrotachannel_3_analyzer_1_array_crystal_array_3, mctr1, mcrotrchannel_3_analyzer_1_array_crystal_array_3);
  mctc1 = coords_set(
#line 1195 "MACS_sample_kidney_box.instr"
    0 + channel_3_analyzer_1_array_effective_radius_of_curvature * ( 1 - cos ( channel_3_analyzer_1_array_theta [ 3 ] ) ),
#line 1195 "MACS_sample_kidney_box.instr"
    0 + channel_3_analyzer_1_array_effective_radius_of_curvature * sin ( channel_3_analyzer_1_array_theta [ 3 ] ),
#line 1195 "MACS_sample_kidney_box.instr"
    0);
#line 104976 "MACS_sample_kidney_box.c"
  rot_transpose(mcrotachannel_3_analyzer_1_rotated, mctr1);
  mctc2 = rot_apply(mctr1, mctc1);
  mcposachannel_3_analyzer_1_array_crystal_array_3 = coords_add(mcposachannel_3_analyzer_1_rotated, mctc2);
  mctc1 = coords_sub(mcposachannel_3_analyzer_1_array_crystal_array_2, mcposachannel_3_analyzer_1_array_crystal_array_3);
  mcposrchannel_3_analyzer_1_array_crystal_array_3 = rot_apply(mcrotachannel_3_analyzer_1_array_crystal_array_3, mctc1);
  mcDEBUG_COMPONENT("channel_3_analyzer_1_array_crystal_array_3", mcposachannel_3_analyzer_1_array_crystal_array_3, mcrotachannel_3_analyzer_1_array_crystal_array_3)
  mccomp_posa[247] = mcposachannel_3_analyzer_1_array_crystal_array_3;
  mccomp_posr[247] = mcposrchannel_3_analyzer_1_array_crystal_array_3;
  mcNCounter[247]  = mcPCounter[247] = mcP2Counter[247] = 0;
  mcAbsorbProp[247]= 0;
    /* Component channel_3_analyzer_1_array_crystal_array_4. */
  /* Setting parameters for component channel_3_analyzer_1_array_crystal_array_4. */
  SIG_MESSAGE("channel_3_analyzer_1_array_crystal_array_4 (Init:SetPar)");
#line 1200 "MACS_sample_kidney_box.instr"
  if("PG_analyzer") strncpy(mccchannel_3_analyzer_1_array_crystal_array_4_material_string, "PG_analyzer" ? "PG_analyzer" : "", 16384); else mccchannel_3_analyzer_1_array_crystal_array_4_material_string[0]='\0';
#line 1200 "MACS_sample_kidney_box.instr"
  mccchannel_3_analyzer_1_array_crystal_array_4_priority = 520.4;
#line 1199 "MACS_sample_kidney_box.instr"
  mccchannel_3_analyzer_1_array_crystal_array_4_xwidth = channel_3_analyzer_1_array_crystal_depth;
#line 1199 "MACS_sample_kidney_box.instr"
  mccchannel_3_analyzer_1_array_crystal_array_4_yheight = channel_3_analyzer_1_array_crystal_height;
#line 1199 "MACS_sample_kidney_box.instr"
  mccchannel_3_analyzer_1_array_crystal_array_4_zdepth = channel_3_analyzer_1_array_crystal_width;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_3_analyzer_1_array_crystal_array_4_xwidth2 = -1;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_3_analyzer_1_array_crystal_array_4_yheight2 = -1;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_3_analyzer_1_array_crystal_array_4_visualize = 1;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_3_analyzer_1_array_crystal_array_4_target_index = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_3_analyzer_1_array_crystal_array_4_target_x = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_3_analyzer_1_array_crystal_array_4_target_y = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_3_analyzer_1_array_crystal_array_4_target_z = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_3_analyzer_1_array_crystal_array_4_focus_aw = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_3_analyzer_1_array_crystal_array_4_focus_ah = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_3_analyzer_1_array_crystal_array_4_focus_xw = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_3_analyzer_1_array_crystal_array_4_focus_xh = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_3_analyzer_1_array_crystal_array_4_focus_r = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_3_analyzer_1_array_crystal_array_4_p_interact = 0;
#line 71 "MACS_sample_kidney_box.instr"
  if(0) strncpy(mccchannel_3_analyzer_1_array_crystal_array_4_mask_string, 0 ? 0 : "", 16384); else mccchannel_3_analyzer_1_array_crystal_array_4_mask_string[0]='\0';
#line 71 "MACS_sample_kidney_box.instr"
  if(0) strncpy(mccchannel_3_analyzer_1_array_crystal_array_4_mask_setting, 0 ? 0 : "", 16384); else mccchannel_3_analyzer_1_array_crystal_array_4_mask_setting[0]='\0';
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_3_analyzer_1_array_crystal_array_4_number_of_activations = 1;
#line 105032 "MACS_sample_kidney_box.c"

  SIG_MESSAGE("channel_3_analyzer_1_array_crystal_array_4 (Init:Place/Rotate)");
  rot_set_rotation(mctr1,
#line 1202 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 1202 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 1202 "MACS_sample_kidney_box.instr"
    (0 - RAD2DEG * channel_3_analyzer_1_array_theta [ 4 ])*DEG2RAD);
#line 105042 "MACS_sample_kidney_box.c"
  rot_mul(mctr1, mcrotachannel_3_analyzer_1_rotated, mcrotachannel_3_analyzer_1_array_crystal_array_4);
  rot_transpose(mcrotachannel_3_analyzer_1_array_crystal_array_3, mctr1);
  rot_mul(mcrotachannel_3_analyzer_1_array_crystal_array_4, mctr1, mcrotrchannel_3_analyzer_1_array_crystal_array_4);
  mctc1 = coords_set(
#line 1201 "MACS_sample_kidney_box.instr"
    0 + channel_3_analyzer_1_array_effective_radius_of_curvature * ( 1 - cos ( channel_3_analyzer_1_array_theta [ 4 ] ) ),
#line 1201 "MACS_sample_kidney_box.instr"
    0 + channel_3_analyzer_1_array_effective_radius_of_curvature * sin ( channel_3_analyzer_1_array_theta [ 4 ] ),
#line 1201 "MACS_sample_kidney_box.instr"
    0);
#line 105053 "MACS_sample_kidney_box.c"
  rot_transpose(mcrotachannel_3_analyzer_1_rotated, mctr1);
  mctc2 = rot_apply(mctr1, mctc1);
  mcposachannel_3_analyzer_1_array_crystal_array_4 = coords_add(mcposachannel_3_analyzer_1_rotated, mctc2);
  mctc1 = coords_sub(mcposachannel_3_analyzer_1_array_crystal_array_3, mcposachannel_3_analyzer_1_array_crystal_array_4);
  mcposrchannel_3_analyzer_1_array_crystal_array_4 = rot_apply(mcrotachannel_3_analyzer_1_array_crystal_array_4, mctc1);
  mcDEBUG_COMPONENT("channel_3_analyzer_1_array_crystal_array_4", mcposachannel_3_analyzer_1_array_crystal_array_4, mcrotachannel_3_analyzer_1_array_crystal_array_4)
  mccomp_posa[248] = mcposachannel_3_analyzer_1_array_crystal_array_4;
  mccomp_posr[248] = mcposrchannel_3_analyzer_1_array_crystal_array_4;
  mcNCounter[248]  = mcPCounter[248] = mcP2Counter[248] = 0;
  mcAbsorbProp[248]= 0;
    /* Component channel_3_analyzer_1_array_crystal_array_5. */
  /* Setting parameters for component channel_3_analyzer_1_array_crystal_array_5. */
  SIG_MESSAGE("channel_3_analyzer_1_array_crystal_array_5 (Init:SetPar)");
#line 1206 "MACS_sample_kidney_box.instr"
  if("PG_analyzer") strncpy(mccchannel_3_analyzer_1_array_crystal_array_5_material_string, "PG_analyzer" ? "PG_analyzer" : "", 16384); else mccchannel_3_analyzer_1_array_crystal_array_5_material_string[0]='\0';
#line 1206 "MACS_sample_kidney_box.instr"
  mccchannel_3_analyzer_1_array_crystal_array_5_priority = 520.5;
#line 1205 "MACS_sample_kidney_box.instr"
  mccchannel_3_analyzer_1_array_crystal_array_5_xwidth = channel_3_analyzer_1_array_crystal_depth;
#line 1205 "MACS_sample_kidney_box.instr"
  mccchannel_3_analyzer_1_array_crystal_array_5_yheight = channel_3_analyzer_1_array_crystal_height;
#line 1205 "MACS_sample_kidney_box.instr"
  mccchannel_3_analyzer_1_array_crystal_array_5_zdepth = channel_3_analyzer_1_array_crystal_width;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_3_analyzer_1_array_crystal_array_5_xwidth2 = -1;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_3_analyzer_1_array_crystal_array_5_yheight2 = -1;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_3_analyzer_1_array_crystal_array_5_visualize = 1;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_3_analyzer_1_array_crystal_array_5_target_index = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_3_analyzer_1_array_crystal_array_5_target_x = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_3_analyzer_1_array_crystal_array_5_target_y = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_3_analyzer_1_array_crystal_array_5_target_z = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_3_analyzer_1_array_crystal_array_5_focus_aw = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_3_analyzer_1_array_crystal_array_5_focus_ah = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_3_analyzer_1_array_crystal_array_5_focus_xw = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_3_analyzer_1_array_crystal_array_5_focus_xh = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_3_analyzer_1_array_crystal_array_5_focus_r = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_3_analyzer_1_array_crystal_array_5_p_interact = 0;
#line 71 "MACS_sample_kidney_box.instr"
  if(0) strncpy(mccchannel_3_analyzer_1_array_crystal_array_5_mask_string, 0 ? 0 : "", 16384); else mccchannel_3_analyzer_1_array_crystal_array_5_mask_string[0]='\0';
#line 71 "MACS_sample_kidney_box.instr"
  if(0) strncpy(mccchannel_3_analyzer_1_array_crystal_array_5_mask_setting, 0 ? 0 : "", 16384); else mccchannel_3_analyzer_1_array_crystal_array_5_mask_setting[0]='\0';
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_3_analyzer_1_array_crystal_array_5_number_of_activations = 1;
#line 105109 "MACS_sample_kidney_box.c"

  SIG_MESSAGE("channel_3_analyzer_1_array_crystal_array_5 (Init:Place/Rotate)");
  rot_set_rotation(mctr1,
#line 1208 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 1208 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 1208 "MACS_sample_kidney_box.instr"
    (0 - RAD2DEG * channel_3_analyzer_1_array_theta [ 5 ])*DEG2RAD);
#line 105119 "MACS_sample_kidney_box.c"
  rot_mul(mctr1, mcrotachannel_3_analyzer_1_rotated, mcrotachannel_3_analyzer_1_array_crystal_array_5);
  rot_transpose(mcrotachannel_3_analyzer_1_array_crystal_array_4, mctr1);
  rot_mul(mcrotachannel_3_analyzer_1_array_crystal_array_5, mctr1, mcrotrchannel_3_analyzer_1_array_crystal_array_5);
  mctc1 = coords_set(
#line 1207 "MACS_sample_kidney_box.instr"
    0 + channel_3_analyzer_1_array_effective_radius_of_curvature * ( 1 - cos ( channel_3_analyzer_1_array_theta [ 5 ] ) ),
#line 1207 "MACS_sample_kidney_box.instr"
    0 + channel_3_analyzer_1_array_effective_radius_of_curvature * sin ( channel_3_analyzer_1_array_theta [ 5 ] ),
#line 1207 "MACS_sample_kidney_box.instr"
    0);
#line 105130 "MACS_sample_kidney_box.c"
  rot_transpose(mcrotachannel_3_analyzer_1_rotated, mctr1);
  mctc2 = rot_apply(mctr1, mctc1);
  mcposachannel_3_analyzer_1_array_crystal_array_5 = coords_add(mcposachannel_3_analyzer_1_rotated, mctc2);
  mctc1 = coords_sub(mcposachannel_3_analyzer_1_array_crystal_array_4, mcposachannel_3_analyzer_1_array_crystal_array_5);
  mcposrchannel_3_analyzer_1_array_crystal_array_5 = rot_apply(mcrotachannel_3_analyzer_1_array_crystal_array_5, mctc1);
  mcDEBUG_COMPONENT("channel_3_analyzer_1_array_crystal_array_5", mcposachannel_3_analyzer_1_array_crystal_array_5, mcrotachannel_3_analyzer_1_array_crystal_array_5)
  mccomp_posa[249] = mcposachannel_3_analyzer_1_array_crystal_array_5;
  mccomp_posr[249] = mcposrchannel_3_analyzer_1_array_crystal_array_5;
  mcNCounter[249]  = mcPCounter[249] = mcP2Counter[249] = 0;
  mcAbsorbProp[249]= 0;
    /* Component channel_3_analyzer_1_array_crystal_array_6. */
  /* Setting parameters for component channel_3_analyzer_1_array_crystal_array_6. */
  SIG_MESSAGE("channel_3_analyzer_1_array_crystal_array_6 (Init:SetPar)");
#line 1212 "MACS_sample_kidney_box.instr"
  if("PG_analyzer") strncpy(mccchannel_3_analyzer_1_array_crystal_array_6_material_string, "PG_analyzer" ? "PG_analyzer" : "", 16384); else mccchannel_3_analyzer_1_array_crystal_array_6_material_string[0]='\0';
#line 1212 "MACS_sample_kidney_box.instr"
  mccchannel_3_analyzer_1_array_crystal_array_6_priority = 520.6;
#line 1211 "MACS_sample_kidney_box.instr"
  mccchannel_3_analyzer_1_array_crystal_array_6_xwidth = channel_3_analyzer_1_array_crystal_depth;
#line 1211 "MACS_sample_kidney_box.instr"
  mccchannel_3_analyzer_1_array_crystal_array_6_yheight = channel_3_analyzer_1_array_crystal_height;
#line 1211 "MACS_sample_kidney_box.instr"
  mccchannel_3_analyzer_1_array_crystal_array_6_zdepth = channel_3_analyzer_1_array_crystal_width;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_3_analyzer_1_array_crystal_array_6_xwidth2 = -1;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_3_analyzer_1_array_crystal_array_6_yheight2 = -1;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_3_analyzer_1_array_crystal_array_6_visualize = 1;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_3_analyzer_1_array_crystal_array_6_target_index = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_3_analyzer_1_array_crystal_array_6_target_x = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_3_analyzer_1_array_crystal_array_6_target_y = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_3_analyzer_1_array_crystal_array_6_target_z = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_3_analyzer_1_array_crystal_array_6_focus_aw = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_3_analyzer_1_array_crystal_array_6_focus_ah = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_3_analyzer_1_array_crystal_array_6_focus_xw = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_3_analyzer_1_array_crystal_array_6_focus_xh = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_3_analyzer_1_array_crystal_array_6_focus_r = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_3_analyzer_1_array_crystal_array_6_p_interact = 0;
#line 71 "MACS_sample_kidney_box.instr"
  if(0) strncpy(mccchannel_3_analyzer_1_array_crystal_array_6_mask_string, 0 ? 0 : "", 16384); else mccchannel_3_analyzer_1_array_crystal_array_6_mask_string[0]='\0';
#line 71 "MACS_sample_kidney_box.instr"
  if(0) strncpy(mccchannel_3_analyzer_1_array_crystal_array_6_mask_setting, 0 ? 0 : "", 16384); else mccchannel_3_analyzer_1_array_crystal_array_6_mask_setting[0]='\0';
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_3_analyzer_1_array_crystal_array_6_number_of_activations = 1;
#line 105186 "MACS_sample_kidney_box.c"

  SIG_MESSAGE("channel_3_analyzer_1_array_crystal_array_6 (Init:Place/Rotate)");
  rot_set_rotation(mctr1,
#line 1214 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 1214 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 1214 "MACS_sample_kidney_box.instr"
    (0 - RAD2DEG * channel_3_analyzer_1_array_theta [ 6 ])*DEG2RAD);
#line 105196 "MACS_sample_kidney_box.c"
  rot_mul(mctr1, mcrotachannel_3_analyzer_1_rotated, mcrotachannel_3_analyzer_1_array_crystal_array_6);
  rot_transpose(mcrotachannel_3_analyzer_1_array_crystal_array_5, mctr1);
  rot_mul(mcrotachannel_3_analyzer_1_array_crystal_array_6, mctr1, mcrotrchannel_3_analyzer_1_array_crystal_array_6);
  mctc1 = coords_set(
#line 1213 "MACS_sample_kidney_box.instr"
    0 + channel_3_analyzer_1_array_effective_radius_of_curvature * ( 1 - cos ( channel_3_analyzer_1_array_theta [ 6 ] ) ),
#line 1213 "MACS_sample_kidney_box.instr"
    0 + channel_3_analyzer_1_array_effective_radius_of_curvature * sin ( channel_3_analyzer_1_array_theta [ 6 ] ),
#line 1213 "MACS_sample_kidney_box.instr"
    0);
#line 105207 "MACS_sample_kidney_box.c"
  rot_transpose(mcrotachannel_3_analyzer_1_rotated, mctr1);
  mctc2 = rot_apply(mctr1, mctc1);
  mcposachannel_3_analyzer_1_array_crystal_array_6 = coords_add(mcposachannel_3_analyzer_1_rotated, mctc2);
  mctc1 = coords_sub(mcposachannel_3_analyzer_1_array_crystal_array_5, mcposachannel_3_analyzer_1_array_crystal_array_6);
  mcposrchannel_3_analyzer_1_array_crystal_array_6 = rot_apply(mcrotachannel_3_analyzer_1_array_crystal_array_6, mctc1);
  mcDEBUG_COMPONENT("channel_3_analyzer_1_array_crystal_array_6", mcposachannel_3_analyzer_1_array_crystal_array_6, mcrotachannel_3_analyzer_1_array_crystal_array_6)
  mccomp_posa[250] = mcposachannel_3_analyzer_1_array_crystal_array_6;
  mccomp_posr[250] = mcposrchannel_3_analyzer_1_array_crystal_array_6;
  mcNCounter[250]  = mcPCounter[250] = mcP2Counter[250] = 0;
  mcAbsorbProp[250]= 0;
    /* Component channel_3_analyzer_1_array_crystal_array_7. */
  /* Setting parameters for component channel_3_analyzer_1_array_crystal_array_7. */
  SIG_MESSAGE("channel_3_analyzer_1_array_crystal_array_7 (Init:SetPar)");
#line 1218 "MACS_sample_kidney_box.instr"
  if("PG_analyzer") strncpy(mccchannel_3_analyzer_1_array_crystal_array_7_material_string, "PG_analyzer" ? "PG_analyzer" : "", 16384); else mccchannel_3_analyzer_1_array_crystal_array_7_material_string[0]='\0';
#line 1218 "MACS_sample_kidney_box.instr"
  mccchannel_3_analyzer_1_array_crystal_array_7_priority = 520.7;
#line 1217 "MACS_sample_kidney_box.instr"
  mccchannel_3_analyzer_1_array_crystal_array_7_xwidth = channel_3_analyzer_1_array_crystal_depth;
#line 1217 "MACS_sample_kidney_box.instr"
  mccchannel_3_analyzer_1_array_crystal_array_7_yheight = channel_3_analyzer_1_array_crystal_height;
#line 1217 "MACS_sample_kidney_box.instr"
  mccchannel_3_analyzer_1_array_crystal_array_7_zdepth = channel_3_analyzer_1_array_crystal_width;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_3_analyzer_1_array_crystal_array_7_xwidth2 = -1;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_3_analyzer_1_array_crystal_array_7_yheight2 = -1;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_3_analyzer_1_array_crystal_array_7_visualize = 1;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_3_analyzer_1_array_crystal_array_7_target_index = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_3_analyzer_1_array_crystal_array_7_target_x = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_3_analyzer_1_array_crystal_array_7_target_y = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_3_analyzer_1_array_crystal_array_7_target_z = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_3_analyzer_1_array_crystal_array_7_focus_aw = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_3_analyzer_1_array_crystal_array_7_focus_ah = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_3_analyzer_1_array_crystal_array_7_focus_xw = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_3_analyzer_1_array_crystal_array_7_focus_xh = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_3_analyzer_1_array_crystal_array_7_focus_r = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_3_analyzer_1_array_crystal_array_7_p_interact = 0;
#line 71 "MACS_sample_kidney_box.instr"
  if(0) strncpy(mccchannel_3_analyzer_1_array_crystal_array_7_mask_string, 0 ? 0 : "", 16384); else mccchannel_3_analyzer_1_array_crystal_array_7_mask_string[0]='\0';
#line 71 "MACS_sample_kidney_box.instr"
  if(0) strncpy(mccchannel_3_analyzer_1_array_crystal_array_7_mask_setting, 0 ? 0 : "", 16384); else mccchannel_3_analyzer_1_array_crystal_array_7_mask_setting[0]='\0';
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_3_analyzer_1_array_crystal_array_7_number_of_activations = 1;
#line 105263 "MACS_sample_kidney_box.c"

  SIG_MESSAGE("channel_3_analyzer_1_array_crystal_array_7 (Init:Place/Rotate)");
  rot_set_rotation(mctr1,
#line 1220 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 1220 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 1220 "MACS_sample_kidney_box.instr"
    (0 - RAD2DEG * channel_3_analyzer_1_array_theta [ 7 ])*DEG2RAD);
#line 105273 "MACS_sample_kidney_box.c"
  rot_mul(mctr1, mcrotachannel_3_analyzer_1_rotated, mcrotachannel_3_analyzer_1_array_crystal_array_7);
  rot_transpose(mcrotachannel_3_analyzer_1_array_crystal_array_6, mctr1);
  rot_mul(mcrotachannel_3_analyzer_1_array_crystal_array_7, mctr1, mcrotrchannel_3_analyzer_1_array_crystal_array_7);
  mctc1 = coords_set(
#line 1219 "MACS_sample_kidney_box.instr"
    0 + channel_3_analyzer_1_array_effective_radius_of_curvature * ( 1 - cos ( channel_3_analyzer_1_array_theta [ 7 ] ) ),
#line 1219 "MACS_sample_kidney_box.instr"
    0 + channel_3_analyzer_1_array_effective_radius_of_curvature * sin ( channel_3_analyzer_1_array_theta [ 7 ] ),
#line 1219 "MACS_sample_kidney_box.instr"
    0);
#line 105284 "MACS_sample_kidney_box.c"
  rot_transpose(mcrotachannel_3_analyzer_1_rotated, mctr1);
  mctc2 = rot_apply(mctr1, mctc1);
  mcposachannel_3_analyzer_1_array_crystal_array_7 = coords_add(mcposachannel_3_analyzer_1_rotated, mctc2);
  mctc1 = coords_sub(mcposachannel_3_analyzer_1_array_crystal_array_6, mcposachannel_3_analyzer_1_array_crystal_array_7);
  mcposrchannel_3_analyzer_1_array_crystal_array_7 = rot_apply(mcrotachannel_3_analyzer_1_array_crystal_array_7, mctc1);
  mcDEBUG_COMPONENT("channel_3_analyzer_1_array_crystal_array_7", mcposachannel_3_analyzer_1_array_crystal_array_7, mcrotachannel_3_analyzer_1_array_crystal_array_7)
  mccomp_posa[251] = mcposachannel_3_analyzer_1_array_crystal_array_7;
  mccomp_posr[251] = mcposrchannel_3_analyzer_1_array_crystal_array_7;
  mcNCounter[251]  = mcPCounter[251] = mcP2Counter[251] = 0;
  mcAbsorbProp[251]= 0;
    /* Component channel_3_analyzer_1_array_crystal_array_8. */
  /* Setting parameters for component channel_3_analyzer_1_array_crystal_array_8. */
  SIG_MESSAGE("channel_3_analyzer_1_array_crystal_array_8 (Init:SetPar)");
#line 1224 "MACS_sample_kidney_box.instr"
  if("PG_analyzer") strncpy(mccchannel_3_analyzer_1_array_crystal_array_8_material_string, "PG_analyzer" ? "PG_analyzer" : "", 16384); else mccchannel_3_analyzer_1_array_crystal_array_8_material_string[0]='\0';
#line 1224 "MACS_sample_kidney_box.instr"
  mccchannel_3_analyzer_1_array_crystal_array_8_priority = 520.8;
#line 1223 "MACS_sample_kidney_box.instr"
  mccchannel_3_analyzer_1_array_crystal_array_8_xwidth = channel_3_analyzer_1_array_crystal_depth;
#line 1223 "MACS_sample_kidney_box.instr"
  mccchannel_3_analyzer_1_array_crystal_array_8_yheight = channel_3_analyzer_1_array_crystal_height;
#line 1223 "MACS_sample_kidney_box.instr"
  mccchannel_3_analyzer_1_array_crystal_array_8_zdepth = channel_3_analyzer_1_array_crystal_width;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_3_analyzer_1_array_crystal_array_8_xwidth2 = -1;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_3_analyzer_1_array_crystal_array_8_yheight2 = -1;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_3_analyzer_1_array_crystal_array_8_visualize = 1;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_3_analyzer_1_array_crystal_array_8_target_index = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_3_analyzer_1_array_crystal_array_8_target_x = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_3_analyzer_1_array_crystal_array_8_target_y = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_3_analyzer_1_array_crystal_array_8_target_z = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_3_analyzer_1_array_crystal_array_8_focus_aw = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_3_analyzer_1_array_crystal_array_8_focus_ah = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_3_analyzer_1_array_crystal_array_8_focus_xw = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_3_analyzer_1_array_crystal_array_8_focus_xh = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_3_analyzer_1_array_crystal_array_8_focus_r = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_3_analyzer_1_array_crystal_array_8_p_interact = 0;
#line 71 "MACS_sample_kidney_box.instr"
  if(0) strncpy(mccchannel_3_analyzer_1_array_crystal_array_8_mask_string, 0 ? 0 : "", 16384); else mccchannel_3_analyzer_1_array_crystal_array_8_mask_string[0]='\0';
#line 71 "MACS_sample_kidney_box.instr"
  if(0) strncpy(mccchannel_3_analyzer_1_array_crystal_array_8_mask_setting, 0 ? 0 : "", 16384); else mccchannel_3_analyzer_1_array_crystal_array_8_mask_setting[0]='\0';
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_3_analyzer_1_array_crystal_array_8_number_of_activations = 1;
#line 105340 "MACS_sample_kidney_box.c"

  SIG_MESSAGE("channel_3_analyzer_1_array_crystal_array_8 (Init:Place/Rotate)");
  rot_set_rotation(mctr1,
#line 1226 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 1226 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 1226 "MACS_sample_kidney_box.instr"
    (0 - RAD2DEG * channel_3_analyzer_1_array_theta [ 8 ])*DEG2RAD);
#line 105350 "MACS_sample_kidney_box.c"
  rot_mul(mctr1, mcrotachannel_3_analyzer_1_rotated, mcrotachannel_3_analyzer_1_array_crystal_array_8);
  rot_transpose(mcrotachannel_3_analyzer_1_array_crystal_array_7, mctr1);
  rot_mul(mcrotachannel_3_analyzer_1_array_crystal_array_8, mctr1, mcrotrchannel_3_analyzer_1_array_crystal_array_8);
  mctc1 = coords_set(
#line 1225 "MACS_sample_kidney_box.instr"
    0 + channel_3_analyzer_1_array_effective_radius_of_curvature * ( 1 - cos ( channel_3_analyzer_1_array_theta [ 8 ] ) ),
#line 1225 "MACS_sample_kidney_box.instr"
    0 + channel_3_analyzer_1_array_effective_radius_of_curvature * sin ( channel_3_analyzer_1_array_theta [ 8 ] ),
#line 1225 "MACS_sample_kidney_box.instr"
    0);
#line 105361 "MACS_sample_kidney_box.c"
  rot_transpose(mcrotachannel_3_analyzer_1_rotated, mctr1);
  mctc2 = rot_apply(mctr1, mctc1);
  mcposachannel_3_analyzer_1_array_crystal_array_8 = coords_add(mcposachannel_3_analyzer_1_rotated, mctc2);
  mctc1 = coords_sub(mcposachannel_3_analyzer_1_array_crystal_array_7, mcposachannel_3_analyzer_1_array_crystal_array_8);
  mcposrchannel_3_analyzer_1_array_crystal_array_8 = rot_apply(mcrotachannel_3_analyzer_1_array_crystal_array_8, mctc1);
  mcDEBUG_COMPONENT("channel_3_analyzer_1_array_crystal_array_8", mcposachannel_3_analyzer_1_array_crystal_array_8, mcrotachannel_3_analyzer_1_array_crystal_array_8)
  mccomp_posa[252] = mcposachannel_3_analyzer_1_array_crystal_array_8;
  mccomp_posr[252] = mcposrchannel_3_analyzer_1_array_crystal_array_8;
  mcNCounter[252]  = mcPCounter[252] = mcP2Counter[252] = 0;
  mcAbsorbProp[252]= 0;
    /* Component channel_3_analyzer_2_center. */
  /* Setting parameters for component channel_3_analyzer_2_center. */
  SIG_MESSAGE("channel_3_analyzer_2_center (Init:SetPar)");

  SIG_MESSAGE("channel_3_analyzer_2_center (Init:Place/Rotate)");
  rot_set_rotation(mctr1,
    (0.0)*DEG2RAD,
    (0.0)*DEG2RAD,
    (0.0)*DEG2RAD);
#line 105381 "MACS_sample_kidney_box.c"
  rot_mul(mctr1, mcrotachannel_3_analyzer_1_center, mcrotachannel_3_analyzer_2_center);
  rot_transpose(mcrotachannel_3_analyzer_1_array_crystal_array_8, mctr1);
  rot_mul(mcrotachannel_3_analyzer_2_center, mctr1, mcrotrchannel_3_analyzer_2_center);
  mctc1 = coords_set(
#line 1230 "MACS_sample_kidney_box.instr"
    - analyzer_seperation,
#line 1230 "MACS_sample_kidney_box.instr"
    0,
#line 1230 "MACS_sample_kidney_box.instr"
    0);
#line 105392 "MACS_sample_kidney_box.c"
  rot_transpose(mcrotachannel_3_analyzer_1_center, mctr1);
  mctc2 = rot_apply(mctr1, mctc1);
  mcposachannel_3_analyzer_2_center = coords_add(mcposachannel_3_analyzer_1_center, mctc2);
  mctc1 = coords_sub(mcposachannel_3_analyzer_1_array_crystal_array_8, mcposachannel_3_analyzer_2_center);
  mcposrchannel_3_analyzer_2_center = rot_apply(mcrotachannel_3_analyzer_2_center, mctc1);
  mcDEBUG_COMPONENT("channel_3_analyzer_2_center", mcposachannel_3_analyzer_2_center, mcrotachannel_3_analyzer_2_center)
  mccomp_posa[253] = mcposachannel_3_analyzer_2_center;
  mccomp_posr[253] = mcposrchannel_3_analyzer_2_center;
  mcNCounter[253]  = mcPCounter[253] = mcP2Counter[253] = 0;
  mcAbsorbProp[253]= 0;
    /* Component channel_3_analyzer_2_rotated. */
  /* Setting parameters for component channel_3_analyzer_2_rotated. */
  SIG_MESSAGE("channel_3_analyzer_2_rotated (Init:SetPar)");

  SIG_MESSAGE("channel_3_analyzer_2_rotated (Init:Place/Rotate)");
  rot_set_rotation(mctr1,
#line 1234 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 1234 "MACS_sample_kidney_box.instr"
    (- analyzer_theta [ 3 ])*DEG2RAD,
#line 1234 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD);
#line 105415 "MACS_sample_kidney_box.c"
  rot_mul(mctr1, mcrotachannel_3_analyzer_2_center, mcrotachannel_3_analyzer_2_rotated);
  rot_transpose(mcrotachannel_3_analyzer_2_center, mctr1);
  rot_mul(mcrotachannel_3_analyzer_2_rotated, mctr1, mcrotrchannel_3_analyzer_2_rotated);
  mctc1 = coords_set(
#line 1233 "MACS_sample_kidney_box.instr"
    0,
#line 1233 "MACS_sample_kidney_box.instr"
    0,
#line 1233 "MACS_sample_kidney_box.instr"
    0.5 * analyzer_seperation / tan ( analyzer_2theta [ 3 ] * DEG2RAD ));
#line 105426 "MACS_sample_kidney_box.c"
  rot_transpose(mcrotachannel_3_analyzer_2_center, mctr1);
  mctc2 = rot_apply(mctr1, mctc1);
  mcposachannel_3_analyzer_2_rotated = coords_add(mcposachannel_3_analyzer_2_center, mctc2);
  mctc1 = coords_sub(mcposachannel_3_analyzer_2_center, mcposachannel_3_analyzer_2_rotated);
  mcposrchannel_3_analyzer_2_rotated = rot_apply(mcrotachannel_3_analyzer_2_rotated, mctc1);
  mcDEBUG_COMPONENT("channel_3_analyzer_2_rotated", mcposachannel_3_analyzer_2_rotated, mcrotachannel_3_analyzer_2_rotated)
  mccomp_posa[254] = mcposachannel_3_analyzer_2_rotated;
  mccomp_posr[254] = mcposrchannel_3_analyzer_2_rotated;
  mcNCounter[254]  = mcPCounter[254] = mcP2Counter[254] = 0;
  mcAbsorbProp[254]= 0;
    /* Component channel_3_analyzer_2_array_crystal_array_0. */
  /* Setting parameters for component channel_3_analyzer_2_array_crystal_array_0. */
  SIG_MESSAGE("channel_3_analyzer_2_array_crystal_array_0 (Init:SetPar)");
#line 1238 "MACS_sample_kidney_box.instr"
  if("PG_analyzer") strncpy(mccchannel_3_analyzer_2_array_crystal_array_0_material_string, "PG_analyzer" ? "PG_analyzer" : "", 16384); else mccchannel_3_analyzer_2_array_crystal_array_0_material_string[0]='\0';
#line 1238 "MACS_sample_kidney_box.instr"
  mccchannel_3_analyzer_2_array_crystal_array_0_priority = 521.0;
#line 1237 "MACS_sample_kidney_box.instr"
  mccchannel_3_analyzer_2_array_crystal_array_0_xwidth = channel_3_analyzer_2_array_crystal_depth;
#line 1237 "MACS_sample_kidney_box.instr"
  mccchannel_3_analyzer_2_array_crystal_array_0_yheight = channel_3_analyzer_2_array_crystal_height;
#line 1237 "MACS_sample_kidney_box.instr"
  mccchannel_3_analyzer_2_array_crystal_array_0_zdepth = channel_3_analyzer_2_array_crystal_width;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_3_analyzer_2_array_crystal_array_0_xwidth2 = -1;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_3_analyzer_2_array_crystal_array_0_yheight2 = -1;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_3_analyzer_2_array_crystal_array_0_visualize = 1;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_3_analyzer_2_array_crystal_array_0_target_index = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_3_analyzer_2_array_crystal_array_0_target_x = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_3_analyzer_2_array_crystal_array_0_target_y = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_3_analyzer_2_array_crystal_array_0_target_z = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_3_analyzer_2_array_crystal_array_0_focus_aw = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_3_analyzer_2_array_crystal_array_0_focus_ah = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_3_analyzer_2_array_crystal_array_0_focus_xw = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_3_analyzer_2_array_crystal_array_0_focus_xh = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_3_analyzer_2_array_crystal_array_0_focus_r = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_3_analyzer_2_array_crystal_array_0_p_interact = 0;
#line 71 "MACS_sample_kidney_box.instr"
  if(0) strncpy(mccchannel_3_analyzer_2_array_crystal_array_0_mask_string, 0 ? 0 : "", 16384); else mccchannel_3_analyzer_2_array_crystal_array_0_mask_string[0]='\0';
#line 71 "MACS_sample_kidney_box.instr"
  if(0) strncpy(mccchannel_3_analyzer_2_array_crystal_array_0_mask_setting, 0 ? 0 : "", 16384); else mccchannel_3_analyzer_2_array_crystal_array_0_mask_setting[0]='\0';
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_3_analyzer_2_array_crystal_array_0_number_of_activations = 1;
#line 105482 "MACS_sample_kidney_box.c"

  SIG_MESSAGE("channel_3_analyzer_2_array_crystal_array_0 (Init:Place/Rotate)");
  rot_set_rotation(mctr1,
#line 1240 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 1240 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 1240 "MACS_sample_kidney_box.instr"
    (0 - RAD2DEG * channel_3_analyzer_2_array_theta [ 0 ])*DEG2RAD);
#line 105492 "MACS_sample_kidney_box.c"
  rot_mul(mctr1, mcrotachannel_3_analyzer_2_rotated, mcrotachannel_3_analyzer_2_array_crystal_array_0);
  rot_transpose(mcrotachannel_3_analyzer_2_rotated, mctr1);
  rot_mul(mcrotachannel_3_analyzer_2_array_crystal_array_0, mctr1, mcrotrchannel_3_analyzer_2_array_crystal_array_0);
  mctc1 = coords_set(
#line 1239 "MACS_sample_kidney_box.instr"
    0 + channel_3_analyzer_2_array_effective_radius_of_curvature * ( 1 - cos ( channel_3_analyzer_2_array_theta [ 0 ] ) ),
#line 1239 "MACS_sample_kidney_box.instr"
    0 + channel_3_analyzer_2_array_effective_radius_of_curvature * sin ( channel_3_analyzer_2_array_theta [ 0 ] ),
#line 1239 "MACS_sample_kidney_box.instr"
    0);
#line 105503 "MACS_sample_kidney_box.c"
  rot_transpose(mcrotachannel_3_analyzer_2_rotated, mctr1);
  mctc2 = rot_apply(mctr1, mctc1);
  mcposachannel_3_analyzer_2_array_crystal_array_0 = coords_add(mcposachannel_3_analyzer_2_rotated, mctc2);
  mctc1 = coords_sub(mcposachannel_3_analyzer_2_rotated, mcposachannel_3_analyzer_2_array_crystal_array_0);
  mcposrchannel_3_analyzer_2_array_crystal_array_0 = rot_apply(mcrotachannel_3_analyzer_2_array_crystal_array_0, mctc1);
  mcDEBUG_COMPONENT("channel_3_analyzer_2_array_crystal_array_0", mcposachannel_3_analyzer_2_array_crystal_array_0, mcrotachannel_3_analyzer_2_array_crystal_array_0)
  mccomp_posa[255] = mcposachannel_3_analyzer_2_array_crystal_array_0;
  mccomp_posr[255] = mcposrchannel_3_analyzer_2_array_crystal_array_0;
  mcNCounter[255]  = mcPCounter[255] = mcP2Counter[255] = 0;
  mcAbsorbProp[255]= 0;
    /* Component channel_3_analyzer_2_array_crystal_array_1. */
  /* Setting parameters for component channel_3_analyzer_2_array_crystal_array_1. */
  SIG_MESSAGE("channel_3_analyzer_2_array_crystal_array_1 (Init:SetPar)");
#line 1244 "MACS_sample_kidney_box.instr"
  if("PG_analyzer") strncpy(mccchannel_3_analyzer_2_array_crystal_array_1_material_string, "PG_analyzer" ? "PG_analyzer" : "", 16384); else mccchannel_3_analyzer_2_array_crystal_array_1_material_string[0]='\0';
#line 1244 "MACS_sample_kidney_box.instr"
  mccchannel_3_analyzer_2_array_crystal_array_1_priority = 521.1;
#line 1243 "MACS_sample_kidney_box.instr"
  mccchannel_3_analyzer_2_array_crystal_array_1_xwidth = channel_3_analyzer_2_array_crystal_depth;
#line 1243 "MACS_sample_kidney_box.instr"
  mccchannel_3_analyzer_2_array_crystal_array_1_yheight = channel_3_analyzer_2_array_crystal_height;
#line 1243 "MACS_sample_kidney_box.instr"
  mccchannel_3_analyzer_2_array_crystal_array_1_zdepth = channel_3_analyzer_2_array_crystal_width;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_3_analyzer_2_array_crystal_array_1_xwidth2 = -1;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_3_analyzer_2_array_crystal_array_1_yheight2 = -1;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_3_analyzer_2_array_crystal_array_1_visualize = 1;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_3_analyzer_2_array_crystal_array_1_target_index = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_3_analyzer_2_array_crystal_array_1_target_x = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_3_analyzer_2_array_crystal_array_1_target_y = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_3_analyzer_2_array_crystal_array_1_target_z = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_3_analyzer_2_array_crystal_array_1_focus_aw = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_3_analyzer_2_array_crystal_array_1_focus_ah = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_3_analyzer_2_array_crystal_array_1_focus_xw = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_3_analyzer_2_array_crystal_array_1_focus_xh = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_3_analyzer_2_array_crystal_array_1_focus_r = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_3_analyzer_2_array_crystal_array_1_p_interact = 0;
#line 71 "MACS_sample_kidney_box.instr"
  if(0) strncpy(mccchannel_3_analyzer_2_array_crystal_array_1_mask_string, 0 ? 0 : "", 16384); else mccchannel_3_analyzer_2_array_crystal_array_1_mask_string[0]='\0';
#line 71 "MACS_sample_kidney_box.instr"
  if(0) strncpy(mccchannel_3_analyzer_2_array_crystal_array_1_mask_setting, 0 ? 0 : "", 16384); else mccchannel_3_analyzer_2_array_crystal_array_1_mask_setting[0]='\0';
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_3_analyzer_2_array_crystal_array_1_number_of_activations = 1;
#line 105559 "MACS_sample_kidney_box.c"

  SIG_MESSAGE("channel_3_analyzer_2_array_crystal_array_1 (Init:Place/Rotate)");
  rot_set_rotation(mctr1,
#line 1246 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 1246 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 1246 "MACS_sample_kidney_box.instr"
    (0 - RAD2DEG * channel_3_analyzer_2_array_theta [ 1 ])*DEG2RAD);
#line 105569 "MACS_sample_kidney_box.c"
  rot_mul(mctr1, mcrotachannel_3_analyzer_2_rotated, mcrotachannel_3_analyzer_2_array_crystal_array_1);
  rot_transpose(mcrotachannel_3_analyzer_2_array_crystal_array_0, mctr1);
  rot_mul(mcrotachannel_3_analyzer_2_array_crystal_array_1, mctr1, mcrotrchannel_3_analyzer_2_array_crystal_array_1);
  mctc1 = coords_set(
#line 1245 "MACS_sample_kidney_box.instr"
    0 + channel_3_analyzer_2_array_effective_radius_of_curvature * ( 1 - cos ( channel_3_analyzer_2_array_theta [ 1 ] ) ),
#line 1245 "MACS_sample_kidney_box.instr"
    0 + channel_3_analyzer_2_array_effective_radius_of_curvature * sin ( channel_3_analyzer_2_array_theta [ 1 ] ),
#line 1245 "MACS_sample_kidney_box.instr"
    0);
#line 105580 "MACS_sample_kidney_box.c"
  rot_transpose(mcrotachannel_3_analyzer_2_rotated, mctr1);
  mctc2 = rot_apply(mctr1, mctc1);
  mcposachannel_3_analyzer_2_array_crystal_array_1 = coords_add(mcposachannel_3_analyzer_2_rotated, mctc2);
  mctc1 = coords_sub(mcposachannel_3_analyzer_2_array_crystal_array_0, mcposachannel_3_analyzer_2_array_crystal_array_1);
  mcposrchannel_3_analyzer_2_array_crystal_array_1 = rot_apply(mcrotachannel_3_analyzer_2_array_crystal_array_1, mctc1);
  mcDEBUG_COMPONENT("channel_3_analyzer_2_array_crystal_array_1", mcposachannel_3_analyzer_2_array_crystal_array_1, mcrotachannel_3_analyzer_2_array_crystal_array_1)
  mccomp_posa[256] = mcposachannel_3_analyzer_2_array_crystal_array_1;
  mccomp_posr[256] = mcposrchannel_3_analyzer_2_array_crystal_array_1;
  mcNCounter[256]  = mcPCounter[256] = mcP2Counter[256] = 0;
  mcAbsorbProp[256]= 0;
    /* Component channel_3_analyzer_2_array_crystal_array_2. */
  /* Setting parameters for component channel_3_analyzer_2_array_crystal_array_2. */
  SIG_MESSAGE("channel_3_analyzer_2_array_crystal_array_2 (Init:SetPar)");
#line 1250 "MACS_sample_kidney_box.instr"
  if("PG_analyzer") strncpy(mccchannel_3_analyzer_2_array_crystal_array_2_material_string, "PG_analyzer" ? "PG_analyzer" : "", 16384); else mccchannel_3_analyzer_2_array_crystal_array_2_material_string[0]='\0';
#line 1250 "MACS_sample_kidney_box.instr"
  mccchannel_3_analyzer_2_array_crystal_array_2_priority = 521.2;
#line 1249 "MACS_sample_kidney_box.instr"
  mccchannel_3_analyzer_2_array_crystal_array_2_xwidth = channel_3_analyzer_2_array_crystal_depth;
#line 1249 "MACS_sample_kidney_box.instr"
  mccchannel_3_analyzer_2_array_crystal_array_2_yheight = channel_3_analyzer_2_array_crystal_height;
#line 1249 "MACS_sample_kidney_box.instr"
  mccchannel_3_analyzer_2_array_crystal_array_2_zdepth = channel_3_analyzer_2_array_crystal_width;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_3_analyzer_2_array_crystal_array_2_xwidth2 = -1;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_3_analyzer_2_array_crystal_array_2_yheight2 = -1;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_3_analyzer_2_array_crystal_array_2_visualize = 1;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_3_analyzer_2_array_crystal_array_2_target_index = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_3_analyzer_2_array_crystal_array_2_target_x = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_3_analyzer_2_array_crystal_array_2_target_y = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_3_analyzer_2_array_crystal_array_2_target_z = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_3_analyzer_2_array_crystal_array_2_focus_aw = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_3_analyzer_2_array_crystal_array_2_focus_ah = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_3_analyzer_2_array_crystal_array_2_focus_xw = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_3_analyzer_2_array_crystal_array_2_focus_xh = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_3_analyzer_2_array_crystal_array_2_focus_r = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_3_analyzer_2_array_crystal_array_2_p_interact = 0;
#line 71 "MACS_sample_kidney_box.instr"
  if(0) strncpy(mccchannel_3_analyzer_2_array_crystal_array_2_mask_string, 0 ? 0 : "", 16384); else mccchannel_3_analyzer_2_array_crystal_array_2_mask_string[0]='\0';
#line 71 "MACS_sample_kidney_box.instr"
  if(0) strncpy(mccchannel_3_analyzer_2_array_crystal_array_2_mask_setting, 0 ? 0 : "", 16384); else mccchannel_3_analyzer_2_array_crystal_array_2_mask_setting[0]='\0';
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_3_analyzer_2_array_crystal_array_2_number_of_activations = 1;
#line 105636 "MACS_sample_kidney_box.c"

  SIG_MESSAGE("channel_3_analyzer_2_array_crystal_array_2 (Init:Place/Rotate)");
  rot_set_rotation(mctr1,
#line 1252 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 1252 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 1252 "MACS_sample_kidney_box.instr"
    (0 - RAD2DEG * channel_3_analyzer_2_array_theta [ 2 ])*DEG2RAD);
#line 105646 "MACS_sample_kidney_box.c"
  rot_mul(mctr1, mcrotachannel_3_analyzer_2_rotated, mcrotachannel_3_analyzer_2_array_crystal_array_2);
  rot_transpose(mcrotachannel_3_analyzer_2_array_crystal_array_1, mctr1);
  rot_mul(mcrotachannel_3_analyzer_2_array_crystal_array_2, mctr1, mcrotrchannel_3_analyzer_2_array_crystal_array_2);
  mctc1 = coords_set(
#line 1251 "MACS_sample_kidney_box.instr"
    0 + channel_3_analyzer_2_array_effective_radius_of_curvature * ( 1 - cos ( channel_3_analyzer_2_array_theta [ 2 ] ) ),
#line 1251 "MACS_sample_kidney_box.instr"
    0 + channel_3_analyzer_2_array_effective_radius_of_curvature * sin ( channel_3_analyzer_2_array_theta [ 2 ] ),
#line 1251 "MACS_sample_kidney_box.instr"
    0);
#line 105657 "MACS_sample_kidney_box.c"
  rot_transpose(mcrotachannel_3_analyzer_2_rotated, mctr1);
  mctc2 = rot_apply(mctr1, mctc1);
  mcposachannel_3_analyzer_2_array_crystal_array_2 = coords_add(mcposachannel_3_analyzer_2_rotated, mctc2);
  mctc1 = coords_sub(mcposachannel_3_analyzer_2_array_crystal_array_1, mcposachannel_3_analyzer_2_array_crystal_array_2);
  mcposrchannel_3_analyzer_2_array_crystal_array_2 = rot_apply(mcrotachannel_3_analyzer_2_array_crystal_array_2, mctc1);
  mcDEBUG_COMPONENT("channel_3_analyzer_2_array_crystal_array_2", mcposachannel_3_analyzer_2_array_crystal_array_2, mcrotachannel_3_analyzer_2_array_crystal_array_2)
  mccomp_posa[257] = mcposachannel_3_analyzer_2_array_crystal_array_2;
  mccomp_posr[257] = mcposrchannel_3_analyzer_2_array_crystal_array_2;
  mcNCounter[257]  = mcPCounter[257] = mcP2Counter[257] = 0;
  mcAbsorbProp[257]= 0;
    /* Component channel_3_analyzer_2_array_crystal_array_3. */
  /* Setting parameters for component channel_3_analyzer_2_array_crystal_array_3. */
  SIG_MESSAGE("channel_3_analyzer_2_array_crystal_array_3 (Init:SetPar)");
#line 1256 "MACS_sample_kidney_box.instr"
  if("PG_analyzer") strncpy(mccchannel_3_analyzer_2_array_crystal_array_3_material_string, "PG_analyzer" ? "PG_analyzer" : "", 16384); else mccchannel_3_analyzer_2_array_crystal_array_3_material_string[0]='\0';
#line 1256 "MACS_sample_kidney_box.instr"
  mccchannel_3_analyzer_2_array_crystal_array_3_priority = 521.3;
#line 1255 "MACS_sample_kidney_box.instr"
  mccchannel_3_analyzer_2_array_crystal_array_3_xwidth = channel_3_analyzer_2_array_crystal_depth;
#line 1255 "MACS_sample_kidney_box.instr"
  mccchannel_3_analyzer_2_array_crystal_array_3_yheight = channel_3_analyzer_2_array_crystal_height;
#line 1255 "MACS_sample_kidney_box.instr"
  mccchannel_3_analyzer_2_array_crystal_array_3_zdepth = channel_3_analyzer_2_array_crystal_width;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_3_analyzer_2_array_crystal_array_3_xwidth2 = -1;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_3_analyzer_2_array_crystal_array_3_yheight2 = -1;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_3_analyzer_2_array_crystal_array_3_visualize = 1;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_3_analyzer_2_array_crystal_array_3_target_index = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_3_analyzer_2_array_crystal_array_3_target_x = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_3_analyzer_2_array_crystal_array_3_target_y = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_3_analyzer_2_array_crystal_array_3_target_z = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_3_analyzer_2_array_crystal_array_3_focus_aw = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_3_analyzer_2_array_crystal_array_3_focus_ah = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_3_analyzer_2_array_crystal_array_3_focus_xw = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_3_analyzer_2_array_crystal_array_3_focus_xh = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_3_analyzer_2_array_crystal_array_3_focus_r = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_3_analyzer_2_array_crystal_array_3_p_interact = 0;
#line 71 "MACS_sample_kidney_box.instr"
  if(0) strncpy(mccchannel_3_analyzer_2_array_crystal_array_3_mask_string, 0 ? 0 : "", 16384); else mccchannel_3_analyzer_2_array_crystal_array_3_mask_string[0]='\0';
#line 71 "MACS_sample_kidney_box.instr"
  if(0) strncpy(mccchannel_3_analyzer_2_array_crystal_array_3_mask_setting, 0 ? 0 : "", 16384); else mccchannel_3_analyzer_2_array_crystal_array_3_mask_setting[0]='\0';
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_3_analyzer_2_array_crystal_array_3_number_of_activations = 1;
#line 105713 "MACS_sample_kidney_box.c"

  SIG_MESSAGE("channel_3_analyzer_2_array_crystal_array_3 (Init:Place/Rotate)");
  rot_set_rotation(mctr1,
#line 1258 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 1258 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 1258 "MACS_sample_kidney_box.instr"
    (0 - RAD2DEG * channel_3_analyzer_2_array_theta [ 3 ])*DEG2RAD);
#line 105723 "MACS_sample_kidney_box.c"
  rot_mul(mctr1, mcrotachannel_3_analyzer_2_rotated, mcrotachannel_3_analyzer_2_array_crystal_array_3);
  rot_transpose(mcrotachannel_3_analyzer_2_array_crystal_array_2, mctr1);
  rot_mul(mcrotachannel_3_analyzer_2_array_crystal_array_3, mctr1, mcrotrchannel_3_analyzer_2_array_crystal_array_3);
  mctc1 = coords_set(
#line 1257 "MACS_sample_kidney_box.instr"
    0 + channel_3_analyzer_2_array_effective_radius_of_curvature * ( 1 - cos ( channel_3_analyzer_2_array_theta [ 3 ] ) ),
#line 1257 "MACS_sample_kidney_box.instr"
    0 + channel_3_analyzer_2_array_effective_radius_of_curvature * sin ( channel_3_analyzer_2_array_theta [ 3 ] ),
#line 1257 "MACS_sample_kidney_box.instr"
    0);
#line 105734 "MACS_sample_kidney_box.c"
  rot_transpose(mcrotachannel_3_analyzer_2_rotated, mctr1);
  mctc2 = rot_apply(mctr1, mctc1);
  mcposachannel_3_analyzer_2_array_crystal_array_3 = coords_add(mcposachannel_3_analyzer_2_rotated, mctc2);
  mctc1 = coords_sub(mcposachannel_3_analyzer_2_array_crystal_array_2, mcposachannel_3_analyzer_2_array_crystal_array_3);
  mcposrchannel_3_analyzer_2_array_crystal_array_3 = rot_apply(mcrotachannel_3_analyzer_2_array_crystal_array_3, mctc1);
  mcDEBUG_COMPONENT("channel_3_analyzer_2_array_crystal_array_3", mcposachannel_3_analyzer_2_array_crystal_array_3, mcrotachannel_3_analyzer_2_array_crystal_array_3)
  mccomp_posa[258] = mcposachannel_3_analyzer_2_array_crystal_array_3;
  mccomp_posr[258] = mcposrchannel_3_analyzer_2_array_crystal_array_3;
  mcNCounter[258]  = mcPCounter[258] = mcP2Counter[258] = 0;
  mcAbsorbProp[258]= 0;
    /* Component channel_3_analyzer_2_array_crystal_array_4. */
  /* Setting parameters for component channel_3_analyzer_2_array_crystal_array_4. */
  SIG_MESSAGE("channel_3_analyzer_2_array_crystal_array_4 (Init:SetPar)");
#line 1262 "MACS_sample_kidney_box.instr"
  if("PG_analyzer") strncpy(mccchannel_3_analyzer_2_array_crystal_array_4_material_string, "PG_analyzer" ? "PG_analyzer" : "", 16384); else mccchannel_3_analyzer_2_array_crystal_array_4_material_string[0]='\0';
#line 1262 "MACS_sample_kidney_box.instr"
  mccchannel_3_analyzer_2_array_crystal_array_4_priority = 521.4;
#line 1261 "MACS_sample_kidney_box.instr"
  mccchannel_3_analyzer_2_array_crystal_array_4_xwidth = channel_3_analyzer_2_array_crystal_depth;
#line 1261 "MACS_sample_kidney_box.instr"
  mccchannel_3_analyzer_2_array_crystal_array_4_yheight = channel_3_analyzer_2_array_crystal_height;
#line 1261 "MACS_sample_kidney_box.instr"
  mccchannel_3_analyzer_2_array_crystal_array_4_zdepth = channel_3_analyzer_2_array_crystal_width;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_3_analyzer_2_array_crystal_array_4_xwidth2 = -1;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_3_analyzer_2_array_crystal_array_4_yheight2 = -1;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_3_analyzer_2_array_crystal_array_4_visualize = 1;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_3_analyzer_2_array_crystal_array_4_target_index = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_3_analyzer_2_array_crystal_array_4_target_x = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_3_analyzer_2_array_crystal_array_4_target_y = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_3_analyzer_2_array_crystal_array_4_target_z = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_3_analyzer_2_array_crystal_array_4_focus_aw = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_3_analyzer_2_array_crystal_array_4_focus_ah = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_3_analyzer_2_array_crystal_array_4_focus_xw = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_3_analyzer_2_array_crystal_array_4_focus_xh = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_3_analyzer_2_array_crystal_array_4_focus_r = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_3_analyzer_2_array_crystal_array_4_p_interact = 0;
#line 71 "MACS_sample_kidney_box.instr"
  if(0) strncpy(mccchannel_3_analyzer_2_array_crystal_array_4_mask_string, 0 ? 0 : "", 16384); else mccchannel_3_analyzer_2_array_crystal_array_4_mask_string[0]='\0';
#line 71 "MACS_sample_kidney_box.instr"
  if(0) strncpy(mccchannel_3_analyzer_2_array_crystal_array_4_mask_setting, 0 ? 0 : "", 16384); else mccchannel_3_analyzer_2_array_crystal_array_4_mask_setting[0]='\0';
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_3_analyzer_2_array_crystal_array_4_number_of_activations = 1;
#line 105790 "MACS_sample_kidney_box.c"

  SIG_MESSAGE("channel_3_analyzer_2_array_crystal_array_4 (Init:Place/Rotate)");
  rot_set_rotation(mctr1,
#line 1264 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 1264 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 1264 "MACS_sample_kidney_box.instr"
    (0 - RAD2DEG * channel_3_analyzer_2_array_theta [ 4 ])*DEG2RAD);
#line 105800 "MACS_sample_kidney_box.c"
  rot_mul(mctr1, mcrotachannel_3_analyzer_2_rotated, mcrotachannel_3_analyzer_2_array_crystal_array_4);
  rot_transpose(mcrotachannel_3_analyzer_2_array_crystal_array_3, mctr1);
  rot_mul(mcrotachannel_3_analyzer_2_array_crystal_array_4, mctr1, mcrotrchannel_3_analyzer_2_array_crystal_array_4);
  mctc1 = coords_set(
#line 1263 "MACS_sample_kidney_box.instr"
    0 + channel_3_analyzer_2_array_effective_radius_of_curvature * ( 1 - cos ( channel_3_analyzer_2_array_theta [ 4 ] ) ),
#line 1263 "MACS_sample_kidney_box.instr"
    0 + channel_3_analyzer_2_array_effective_radius_of_curvature * sin ( channel_3_analyzer_2_array_theta [ 4 ] ),
#line 1263 "MACS_sample_kidney_box.instr"
    0);
#line 105811 "MACS_sample_kidney_box.c"
  rot_transpose(mcrotachannel_3_analyzer_2_rotated, mctr1);
  mctc2 = rot_apply(mctr1, mctc1);
  mcposachannel_3_analyzer_2_array_crystal_array_4 = coords_add(mcposachannel_3_analyzer_2_rotated, mctc2);
  mctc1 = coords_sub(mcposachannel_3_analyzer_2_array_crystal_array_3, mcposachannel_3_analyzer_2_array_crystal_array_4);
  mcposrchannel_3_analyzer_2_array_crystal_array_4 = rot_apply(mcrotachannel_3_analyzer_2_array_crystal_array_4, mctc1);
  mcDEBUG_COMPONENT("channel_3_analyzer_2_array_crystal_array_4", mcposachannel_3_analyzer_2_array_crystal_array_4, mcrotachannel_3_analyzer_2_array_crystal_array_4)
  mccomp_posa[259] = mcposachannel_3_analyzer_2_array_crystal_array_4;
  mccomp_posr[259] = mcposrchannel_3_analyzer_2_array_crystal_array_4;
  mcNCounter[259]  = mcPCounter[259] = mcP2Counter[259] = 0;
  mcAbsorbProp[259]= 0;
    /* Component channel_3_analyzer_2_array_crystal_array_5. */
  /* Setting parameters for component channel_3_analyzer_2_array_crystal_array_5. */
  SIG_MESSAGE("channel_3_analyzer_2_array_crystal_array_5 (Init:SetPar)");
#line 1268 "MACS_sample_kidney_box.instr"
  if("PG_analyzer") strncpy(mccchannel_3_analyzer_2_array_crystal_array_5_material_string, "PG_analyzer" ? "PG_analyzer" : "", 16384); else mccchannel_3_analyzer_2_array_crystal_array_5_material_string[0]='\0';
#line 1268 "MACS_sample_kidney_box.instr"
  mccchannel_3_analyzer_2_array_crystal_array_5_priority = 521.5;
#line 1267 "MACS_sample_kidney_box.instr"
  mccchannel_3_analyzer_2_array_crystal_array_5_xwidth = channel_3_analyzer_2_array_crystal_depth;
#line 1267 "MACS_sample_kidney_box.instr"
  mccchannel_3_analyzer_2_array_crystal_array_5_yheight = channel_3_analyzer_2_array_crystal_height;
#line 1267 "MACS_sample_kidney_box.instr"
  mccchannel_3_analyzer_2_array_crystal_array_5_zdepth = channel_3_analyzer_2_array_crystal_width;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_3_analyzer_2_array_crystal_array_5_xwidth2 = -1;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_3_analyzer_2_array_crystal_array_5_yheight2 = -1;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_3_analyzer_2_array_crystal_array_5_visualize = 1;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_3_analyzer_2_array_crystal_array_5_target_index = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_3_analyzer_2_array_crystal_array_5_target_x = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_3_analyzer_2_array_crystal_array_5_target_y = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_3_analyzer_2_array_crystal_array_5_target_z = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_3_analyzer_2_array_crystal_array_5_focus_aw = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_3_analyzer_2_array_crystal_array_5_focus_ah = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_3_analyzer_2_array_crystal_array_5_focus_xw = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_3_analyzer_2_array_crystal_array_5_focus_xh = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_3_analyzer_2_array_crystal_array_5_focus_r = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_3_analyzer_2_array_crystal_array_5_p_interact = 0;
#line 71 "MACS_sample_kidney_box.instr"
  if(0) strncpy(mccchannel_3_analyzer_2_array_crystal_array_5_mask_string, 0 ? 0 : "", 16384); else mccchannel_3_analyzer_2_array_crystal_array_5_mask_string[0]='\0';
#line 71 "MACS_sample_kidney_box.instr"
  if(0) strncpy(mccchannel_3_analyzer_2_array_crystal_array_5_mask_setting, 0 ? 0 : "", 16384); else mccchannel_3_analyzer_2_array_crystal_array_5_mask_setting[0]='\0';
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_3_analyzer_2_array_crystal_array_5_number_of_activations = 1;
#line 105867 "MACS_sample_kidney_box.c"

  SIG_MESSAGE("channel_3_analyzer_2_array_crystal_array_5 (Init:Place/Rotate)");
  rot_set_rotation(mctr1,
#line 1270 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 1270 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 1270 "MACS_sample_kidney_box.instr"
    (0 - RAD2DEG * channel_3_analyzer_2_array_theta [ 5 ])*DEG2RAD);
#line 105877 "MACS_sample_kidney_box.c"
  rot_mul(mctr1, mcrotachannel_3_analyzer_2_rotated, mcrotachannel_3_analyzer_2_array_crystal_array_5);
  rot_transpose(mcrotachannel_3_analyzer_2_array_crystal_array_4, mctr1);
  rot_mul(mcrotachannel_3_analyzer_2_array_crystal_array_5, mctr1, mcrotrchannel_3_analyzer_2_array_crystal_array_5);
  mctc1 = coords_set(
#line 1269 "MACS_sample_kidney_box.instr"
    0 + channel_3_analyzer_2_array_effective_radius_of_curvature * ( 1 - cos ( channel_3_analyzer_2_array_theta [ 5 ] ) ),
#line 1269 "MACS_sample_kidney_box.instr"
    0 + channel_3_analyzer_2_array_effective_radius_of_curvature * sin ( channel_3_analyzer_2_array_theta [ 5 ] ),
#line 1269 "MACS_sample_kidney_box.instr"
    0);
#line 105888 "MACS_sample_kidney_box.c"
  rot_transpose(mcrotachannel_3_analyzer_2_rotated, mctr1);
  mctc2 = rot_apply(mctr1, mctc1);
  mcposachannel_3_analyzer_2_array_crystal_array_5 = coords_add(mcposachannel_3_analyzer_2_rotated, mctc2);
  mctc1 = coords_sub(mcposachannel_3_analyzer_2_array_crystal_array_4, mcposachannel_3_analyzer_2_array_crystal_array_5);
  mcposrchannel_3_analyzer_2_array_crystal_array_5 = rot_apply(mcrotachannel_3_analyzer_2_array_crystal_array_5, mctc1);
  mcDEBUG_COMPONENT("channel_3_analyzer_2_array_crystal_array_5", mcposachannel_3_analyzer_2_array_crystal_array_5, mcrotachannel_3_analyzer_2_array_crystal_array_5)
  mccomp_posa[260] = mcposachannel_3_analyzer_2_array_crystal_array_5;
  mccomp_posr[260] = mcposrchannel_3_analyzer_2_array_crystal_array_5;
  mcNCounter[260]  = mcPCounter[260] = mcP2Counter[260] = 0;
  mcAbsorbProp[260]= 0;
    /* Component channel_3_analyzer_2_array_crystal_array_6. */
  /* Setting parameters for component channel_3_analyzer_2_array_crystal_array_6. */
  SIG_MESSAGE("channel_3_analyzer_2_array_crystal_array_6 (Init:SetPar)");
#line 1274 "MACS_sample_kidney_box.instr"
  if("PG_analyzer") strncpy(mccchannel_3_analyzer_2_array_crystal_array_6_material_string, "PG_analyzer" ? "PG_analyzer" : "", 16384); else mccchannel_3_analyzer_2_array_crystal_array_6_material_string[0]='\0';
#line 1274 "MACS_sample_kidney_box.instr"
  mccchannel_3_analyzer_2_array_crystal_array_6_priority = 521.6;
#line 1273 "MACS_sample_kidney_box.instr"
  mccchannel_3_analyzer_2_array_crystal_array_6_xwidth = channel_3_analyzer_2_array_crystal_depth;
#line 1273 "MACS_sample_kidney_box.instr"
  mccchannel_3_analyzer_2_array_crystal_array_6_yheight = channel_3_analyzer_2_array_crystal_height;
#line 1273 "MACS_sample_kidney_box.instr"
  mccchannel_3_analyzer_2_array_crystal_array_6_zdepth = channel_3_analyzer_2_array_crystal_width;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_3_analyzer_2_array_crystal_array_6_xwidth2 = -1;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_3_analyzer_2_array_crystal_array_6_yheight2 = -1;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_3_analyzer_2_array_crystal_array_6_visualize = 1;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_3_analyzer_2_array_crystal_array_6_target_index = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_3_analyzer_2_array_crystal_array_6_target_x = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_3_analyzer_2_array_crystal_array_6_target_y = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_3_analyzer_2_array_crystal_array_6_target_z = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_3_analyzer_2_array_crystal_array_6_focus_aw = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_3_analyzer_2_array_crystal_array_6_focus_ah = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_3_analyzer_2_array_crystal_array_6_focus_xw = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_3_analyzer_2_array_crystal_array_6_focus_xh = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_3_analyzer_2_array_crystal_array_6_focus_r = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_3_analyzer_2_array_crystal_array_6_p_interact = 0;
#line 71 "MACS_sample_kidney_box.instr"
  if(0) strncpy(mccchannel_3_analyzer_2_array_crystal_array_6_mask_string, 0 ? 0 : "", 16384); else mccchannel_3_analyzer_2_array_crystal_array_6_mask_string[0]='\0';
#line 71 "MACS_sample_kidney_box.instr"
  if(0) strncpy(mccchannel_3_analyzer_2_array_crystal_array_6_mask_setting, 0 ? 0 : "", 16384); else mccchannel_3_analyzer_2_array_crystal_array_6_mask_setting[0]='\0';
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_3_analyzer_2_array_crystal_array_6_number_of_activations = 1;
#line 105944 "MACS_sample_kidney_box.c"

  SIG_MESSAGE("channel_3_analyzer_2_array_crystal_array_6 (Init:Place/Rotate)");
  rot_set_rotation(mctr1,
#line 1276 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 1276 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 1276 "MACS_sample_kidney_box.instr"
    (0 - RAD2DEG * channel_3_analyzer_2_array_theta [ 6 ])*DEG2RAD);
#line 105954 "MACS_sample_kidney_box.c"
  rot_mul(mctr1, mcrotachannel_3_analyzer_2_rotated, mcrotachannel_3_analyzer_2_array_crystal_array_6);
  rot_transpose(mcrotachannel_3_analyzer_2_array_crystal_array_5, mctr1);
  rot_mul(mcrotachannel_3_analyzer_2_array_crystal_array_6, mctr1, mcrotrchannel_3_analyzer_2_array_crystal_array_6);
  mctc1 = coords_set(
#line 1275 "MACS_sample_kidney_box.instr"
    0 + channel_3_analyzer_2_array_effective_radius_of_curvature * ( 1 - cos ( channel_3_analyzer_2_array_theta [ 6 ] ) ),
#line 1275 "MACS_sample_kidney_box.instr"
    0 + channel_3_analyzer_2_array_effective_radius_of_curvature * sin ( channel_3_analyzer_2_array_theta [ 6 ] ),
#line 1275 "MACS_sample_kidney_box.instr"
    0);
#line 105965 "MACS_sample_kidney_box.c"
  rot_transpose(mcrotachannel_3_analyzer_2_rotated, mctr1);
  mctc2 = rot_apply(mctr1, mctc1);
  mcposachannel_3_analyzer_2_array_crystal_array_6 = coords_add(mcposachannel_3_analyzer_2_rotated, mctc2);
  mctc1 = coords_sub(mcposachannel_3_analyzer_2_array_crystal_array_5, mcposachannel_3_analyzer_2_array_crystal_array_6);
  mcposrchannel_3_analyzer_2_array_crystal_array_6 = rot_apply(mcrotachannel_3_analyzer_2_array_crystal_array_6, mctc1);
  mcDEBUG_COMPONENT("channel_3_analyzer_2_array_crystal_array_6", mcposachannel_3_analyzer_2_array_crystal_array_6, mcrotachannel_3_analyzer_2_array_crystal_array_6)
  mccomp_posa[261] = mcposachannel_3_analyzer_2_array_crystal_array_6;
  mccomp_posr[261] = mcposrchannel_3_analyzer_2_array_crystal_array_6;
  mcNCounter[261]  = mcPCounter[261] = mcP2Counter[261] = 0;
  mcAbsorbProp[261]= 0;
    /* Component channel_3_analyzer_2_array_crystal_array_7. */
  /* Setting parameters for component channel_3_analyzer_2_array_crystal_array_7. */
  SIG_MESSAGE("channel_3_analyzer_2_array_crystal_array_7 (Init:SetPar)");
#line 1280 "MACS_sample_kidney_box.instr"
  if("PG_analyzer") strncpy(mccchannel_3_analyzer_2_array_crystal_array_7_material_string, "PG_analyzer" ? "PG_analyzer" : "", 16384); else mccchannel_3_analyzer_2_array_crystal_array_7_material_string[0]='\0';
#line 1280 "MACS_sample_kidney_box.instr"
  mccchannel_3_analyzer_2_array_crystal_array_7_priority = 521.7;
#line 1279 "MACS_sample_kidney_box.instr"
  mccchannel_3_analyzer_2_array_crystal_array_7_xwidth = channel_3_analyzer_2_array_crystal_depth;
#line 1279 "MACS_sample_kidney_box.instr"
  mccchannel_3_analyzer_2_array_crystal_array_7_yheight = channel_3_analyzer_2_array_crystal_height;
#line 1279 "MACS_sample_kidney_box.instr"
  mccchannel_3_analyzer_2_array_crystal_array_7_zdepth = channel_3_analyzer_2_array_crystal_width;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_3_analyzer_2_array_crystal_array_7_xwidth2 = -1;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_3_analyzer_2_array_crystal_array_7_yheight2 = -1;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_3_analyzer_2_array_crystal_array_7_visualize = 1;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_3_analyzer_2_array_crystal_array_7_target_index = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_3_analyzer_2_array_crystal_array_7_target_x = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_3_analyzer_2_array_crystal_array_7_target_y = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_3_analyzer_2_array_crystal_array_7_target_z = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_3_analyzer_2_array_crystal_array_7_focus_aw = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_3_analyzer_2_array_crystal_array_7_focus_ah = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_3_analyzer_2_array_crystal_array_7_focus_xw = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_3_analyzer_2_array_crystal_array_7_focus_xh = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_3_analyzer_2_array_crystal_array_7_focus_r = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_3_analyzer_2_array_crystal_array_7_p_interact = 0;
#line 71 "MACS_sample_kidney_box.instr"
  if(0) strncpy(mccchannel_3_analyzer_2_array_crystal_array_7_mask_string, 0 ? 0 : "", 16384); else mccchannel_3_analyzer_2_array_crystal_array_7_mask_string[0]='\0';
#line 71 "MACS_sample_kidney_box.instr"
  if(0) strncpy(mccchannel_3_analyzer_2_array_crystal_array_7_mask_setting, 0 ? 0 : "", 16384); else mccchannel_3_analyzer_2_array_crystal_array_7_mask_setting[0]='\0';
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_3_analyzer_2_array_crystal_array_7_number_of_activations = 1;
#line 106021 "MACS_sample_kidney_box.c"

  SIG_MESSAGE("channel_3_analyzer_2_array_crystal_array_7 (Init:Place/Rotate)");
  rot_set_rotation(mctr1,
#line 1282 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 1282 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 1282 "MACS_sample_kidney_box.instr"
    (0 - RAD2DEG * channel_3_analyzer_2_array_theta [ 7 ])*DEG2RAD);
#line 106031 "MACS_sample_kidney_box.c"
  rot_mul(mctr1, mcrotachannel_3_analyzer_2_rotated, mcrotachannel_3_analyzer_2_array_crystal_array_7);
  rot_transpose(mcrotachannel_3_analyzer_2_array_crystal_array_6, mctr1);
  rot_mul(mcrotachannel_3_analyzer_2_array_crystal_array_7, mctr1, mcrotrchannel_3_analyzer_2_array_crystal_array_7);
  mctc1 = coords_set(
#line 1281 "MACS_sample_kidney_box.instr"
    0 + channel_3_analyzer_2_array_effective_radius_of_curvature * ( 1 - cos ( channel_3_analyzer_2_array_theta [ 7 ] ) ),
#line 1281 "MACS_sample_kidney_box.instr"
    0 + channel_3_analyzer_2_array_effective_radius_of_curvature * sin ( channel_3_analyzer_2_array_theta [ 7 ] ),
#line 1281 "MACS_sample_kidney_box.instr"
    0);
#line 106042 "MACS_sample_kidney_box.c"
  rot_transpose(mcrotachannel_3_analyzer_2_rotated, mctr1);
  mctc2 = rot_apply(mctr1, mctc1);
  mcposachannel_3_analyzer_2_array_crystal_array_7 = coords_add(mcposachannel_3_analyzer_2_rotated, mctc2);
  mctc1 = coords_sub(mcposachannel_3_analyzer_2_array_crystal_array_6, mcposachannel_3_analyzer_2_array_crystal_array_7);
  mcposrchannel_3_analyzer_2_array_crystal_array_7 = rot_apply(mcrotachannel_3_analyzer_2_array_crystal_array_7, mctc1);
  mcDEBUG_COMPONENT("channel_3_analyzer_2_array_crystal_array_7", mcposachannel_3_analyzer_2_array_crystal_array_7, mcrotachannel_3_analyzer_2_array_crystal_array_7)
  mccomp_posa[262] = mcposachannel_3_analyzer_2_array_crystal_array_7;
  mccomp_posr[262] = mcposrchannel_3_analyzer_2_array_crystal_array_7;
  mcNCounter[262]  = mcPCounter[262] = mcP2Counter[262] = 0;
  mcAbsorbProp[262]= 0;
    /* Component channel_3_analyzer_2_array_crystal_array_8. */
  /* Setting parameters for component channel_3_analyzer_2_array_crystal_array_8. */
  SIG_MESSAGE("channel_3_analyzer_2_array_crystal_array_8 (Init:SetPar)");
#line 1286 "MACS_sample_kidney_box.instr"
  if("PG_analyzer") strncpy(mccchannel_3_analyzer_2_array_crystal_array_8_material_string, "PG_analyzer" ? "PG_analyzer" : "", 16384); else mccchannel_3_analyzer_2_array_crystal_array_8_material_string[0]='\0';
#line 1286 "MACS_sample_kidney_box.instr"
  mccchannel_3_analyzer_2_array_crystal_array_8_priority = 521.8;
#line 1285 "MACS_sample_kidney_box.instr"
  mccchannel_3_analyzer_2_array_crystal_array_8_xwidth = channel_3_analyzer_2_array_crystal_depth;
#line 1285 "MACS_sample_kidney_box.instr"
  mccchannel_3_analyzer_2_array_crystal_array_8_yheight = channel_3_analyzer_2_array_crystal_height;
#line 1285 "MACS_sample_kidney_box.instr"
  mccchannel_3_analyzer_2_array_crystal_array_8_zdepth = channel_3_analyzer_2_array_crystal_width;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_3_analyzer_2_array_crystal_array_8_xwidth2 = -1;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_3_analyzer_2_array_crystal_array_8_yheight2 = -1;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_3_analyzer_2_array_crystal_array_8_visualize = 1;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_3_analyzer_2_array_crystal_array_8_target_index = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_3_analyzer_2_array_crystal_array_8_target_x = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_3_analyzer_2_array_crystal_array_8_target_y = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_3_analyzer_2_array_crystal_array_8_target_z = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_3_analyzer_2_array_crystal_array_8_focus_aw = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_3_analyzer_2_array_crystal_array_8_focus_ah = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_3_analyzer_2_array_crystal_array_8_focus_xw = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_3_analyzer_2_array_crystal_array_8_focus_xh = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_3_analyzer_2_array_crystal_array_8_focus_r = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_3_analyzer_2_array_crystal_array_8_p_interact = 0;
#line 71 "MACS_sample_kidney_box.instr"
  if(0) strncpy(mccchannel_3_analyzer_2_array_crystal_array_8_mask_string, 0 ? 0 : "", 16384); else mccchannel_3_analyzer_2_array_crystal_array_8_mask_string[0]='\0';
#line 71 "MACS_sample_kidney_box.instr"
  if(0) strncpy(mccchannel_3_analyzer_2_array_crystal_array_8_mask_setting, 0 ? 0 : "", 16384); else mccchannel_3_analyzer_2_array_crystal_array_8_mask_setting[0]='\0';
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_3_analyzer_2_array_crystal_array_8_number_of_activations = 1;
#line 106098 "MACS_sample_kidney_box.c"

  SIG_MESSAGE("channel_3_analyzer_2_array_crystal_array_8 (Init:Place/Rotate)");
  rot_set_rotation(mctr1,
#line 1288 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 1288 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 1288 "MACS_sample_kidney_box.instr"
    (0 - RAD2DEG * channel_3_analyzer_2_array_theta [ 8 ])*DEG2RAD);
#line 106108 "MACS_sample_kidney_box.c"
  rot_mul(mctr1, mcrotachannel_3_analyzer_2_rotated, mcrotachannel_3_analyzer_2_array_crystal_array_8);
  rot_transpose(mcrotachannel_3_analyzer_2_array_crystal_array_7, mctr1);
  rot_mul(mcrotachannel_3_analyzer_2_array_crystal_array_8, mctr1, mcrotrchannel_3_analyzer_2_array_crystal_array_8);
  mctc1 = coords_set(
#line 1287 "MACS_sample_kidney_box.instr"
    0 + channel_3_analyzer_2_array_effective_radius_of_curvature * ( 1 - cos ( channel_3_analyzer_2_array_theta [ 8 ] ) ),
#line 1287 "MACS_sample_kidney_box.instr"
    0 + channel_3_analyzer_2_array_effective_radius_of_curvature * sin ( channel_3_analyzer_2_array_theta [ 8 ] ),
#line 1287 "MACS_sample_kidney_box.instr"
    0);
#line 106119 "MACS_sample_kidney_box.c"
  rot_transpose(mcrotachannel_3_analyzer_2_rotated, mctr1);
  mctc2 = rot_apply(mctr1, mctc1);
  mcposachannel_3_analyzer_2_array_crystal_array_8 = coords_add(mcposachannel_3_analyzer_2_rotated, mctc2);
  mctc1 = coords_sub(mcposachannel_3_analyzer_2_array_crystal_array_7, mcposachannel_3_analyzer_2_array_crystal_array_8);
  mcposrchannel_3_analyzer_2_array_crystal_array_8 = rot_apply(mcrotachannel_3_analyzer_2_array_crystal_array_8, mctc1);
  mcDEBUG_COMPONENT("channel_3_analyzer_2_array_crystal_array_8", mcposachannel_3_analyzer_2_array_crystal_array_8, mcrotachannel_3_analyzer_2_array_crystal_array_8)
  mccomp_posa[263] = mcposachannel_3_analyzer_2_array_crystal_array_8;
  mccomp_posr[263] = mcposrchannel_3_analyzer_2_array_crystal_array_8;
  mcNCounter[263]  = mcPCounter[263] = mcP2Counter[263] = 0;
  mcAbsorbProp[263]= 0;
    /* Component channel_3_cave2_cyl1. */
  /* Setting parameters for component channel_3_cave2_cyl1. */
  SIG_MESSAGE("channel_3_cave2_cyl1 (Init:SetPar)");
#line 1293 "MACS_sample_kidney_box.instr"
  if("Vacuum") strncpy(mccchannel_3_cave2_cyl1_material_string, "Vacuum" ? "Vacuum" : "", 16384); else mccchannel_3_cave2_cyl1_material_string[0]='\0';
#line 1293 "MACS_sample_kidney_box.instr"
  mccchannel_3_cave2_cyl1_priority = 507.5;
#line 1292 "MACS_sample_kidney_box.instr"
  mccchannel_3_cave2_cyl1_radius = kidney_cave2_cyl1_radius;
#line 1292 "MACS_sample_kidney_box.instr"
  mccchannel_3_cave2_cyl1_yheight = kidney_cave2_cyl1_height;
#line 67 "MACS_sample_kidney_box.instr"
  mccchannel_3_cave2_cyl1_visualize = 1;
#line 67 "MACS_sample_kidney_box.instr"
  mccchannel_3_cave2_cyl1_target_index = 0;
#line 67 "MACS_sample_kidney_box.instr"
  mccchannel_3_cave2_cyl1_target_x = 0;
#line 67 "MACS_sample_kidney_box.instr"
  mccchannel_3_cave2_cyl1_target_y = 0;
#line 67 "MACS_sample_kidney_box.instr"
  mccchannel_3_cave2_cyl1_target_z = 0;
#line 67 "MACS_sample_kidney_box.instr"
  mccchannel_3_cave2_cyl1_focus_aw = 0;
#line 67 "MACS_sample_kidney_box.instr"
  mccchannel_3_cave2_cyl1_focus_ah = 0;
#line 67 "MACS_sample_kidney_box.instr"
  mccchannel_3_cave2_cyl1_focus_xw = 0;
#line 67 "MACS_sample_kidney_box.instr"
  mccchannel_3_cave2_cyl1_focus_xh = 0;
#line 67 "MACS_sample_kidney_box.instr"
  mccchannel_3_cave2_cyl1_focus_r = 0;
#line 67 "MACS_sample_kidney_box.instr"
  mccchannel_3_cave2_cyl1_p_interact = 0;
#line 67 "MACS_sample_kidney_box.instr"
  if(0) strncpy(mccchannel_3_cave2_cyl1_mask_string, 0 ? 0 : "", 16384); else mccchannel_3_cave2_cyl1_mask_string[0]='\0';
#line 67 "MACS_sample_kidney_box.instr"
  if(0) strncpy(mccchannel_3_cave2_cyl1_mask_setting, 0 ? 0 : "", 16384); else mccchannel_3_cave2_cyl1_mask_setting[0]='\0';
#line 67 "MACS_sample_kidney_box.instr"
  mccchannel_3_cave2_cyl1_number_of_activations = 1;
#line 106169 "MACS_sample_kidney_box.c"

  SIG_MESSAGE("channel_3_cave2_cyl1 (Init:Place/Rotate)");
  rot_set_rotation(mctr1,
#line 1295 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 1295 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 1295 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD);
#line 106179 "MACS_sample_kidney_box.c"
  rot_mul(mctr1, mcrotachannel_3_analyzer_2_center, mcrotachannel_3_cave2_cyl1);
  rot_transpose(mcrotachannel_3_analyzer_2_array_crystal_array_8, mctr1);
  rot_mul(mcrotachannel_3_cave2_cyl1, mctr1, mcrotrchannel_3_cave2_cyl1);
  mctc1 = coords_set(
#line 1294 "MACS_sample_kidney_box.instr"
    0,
#line 1294 "MACS_sample_kidney_box.instr"
    0,
#line 1294 "MACS_sample_kidney_box.instr"
    spec_detector_to_analyzer_2_center);
#line 106190 "MACS_sample_kidney_box.c"
  rot_transpose(mcrotachannel_3_analyzer_2_center, mctr1);
  mctc2 = rot_apply(mctr1, mctc1);
  mcposachannel_3_cave2_cyl1 = coords_add(mcposachannel_3_analyzer_2_center, mctc2);
  mctc1 = coords_sub(mcposachannel_3_analyzer_2_array_crystal_array_8, mcposachannel_3_cave2_cyl1);
  mcposrchannel_3_cave2_cyl1 = rot_apply(mcrotachannel_3_cave2_cyl1, mctc1);
  mcDEBUG_COMPONENT("channel_3_cave2_cyl1", mcposachannel_3_cave2_cyl1, mcrotachannel_3_cave2_cyl1)
  mccomp_posa[264] = mcposachannel_3_cave2_cyl1;
  mccomp_posr[264] = mcposrchannel_3_cave2_cyl1;
  mcNCounter[264]  = mcPCounter[264] = mcP2Counter[264] = 0;
  mcAbsorbProp[264]= 0;
    /* Component channel_3_cave2_box1. */
  /* Setting parameters for component channel_3_cave2_box1. */
  SIG_MESSAGE("channel_3_cave2_box1 (Init:SetPar)");
#line 1300 "MACS_sample_kidney_box.instr"
  if("Vacuum") strncpy(mccchannel_3_cave2_box1_material_string, "Vacuum" ? "Vacuum" : "", 16384); else mccchannel_3_cave2_box1_material_string[0]='\0';
#line 1300 "MACS_sample_kidney_box.instr"
  mccchannel_3_cave2_box1_priority = 501;
#line 1298 "MACS_sample_kidney_box.instr"
  mccchannel_3_cave2_box1_xwidth = kidney_cave2_box1_width1;
#line 1298 "MACS_sample_kidney_box.instr"
  mccchannel_3_cave2_box1_yheight = kidney_cave2_box1_height1;
#line 1298 "MACS_sample_kidney_box.instr"
  mccchannel_3_cave2_box1_zdepth = kidney_cave2_box1_depth;
#line 1299 "MACS_sample_kidney_box.instr"
  mccchannel_3_cave2_box1_xwidth2 = kidney_cave2_box1_width2;
#line 1299 "MACS_sample_kidney_box.instr"
  mccchannel_3_cave2_box1_yheight2 = kidney_cave2_box1_height2;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_3_cave2_box1_visualize = 1;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_3_cave2_box1_target_index = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_3_cave2_box1_target_x = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_3_cave2_box1_target_y = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_3_cave2_box1_target_z = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_3_cave2_box1_focus_aw = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_3_cave2_box1_focus_ah = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_3_cave2_box1_focus_xw = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_3_cave2_box1_focus_xh = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_3_cave2_box1_focus_r = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_3_cave2_box1_p_interact = 0;
#line 71 "MACS_sample_kidney_box.instr"
  if(0) strncpy(mccchannel_3_cave2_box1_mask_string, 0 ? 0 : "", 16384); else mccchannel_3_cave2_box1_mask_string[0]='\0';
#line 71 "MACS_sample_kidney_box.instr"
  if(0) strncpy(mccchannel_3_cave2_box1_mask_setting, 0 ? 0 : "", 16384); else mccchannel_3_cave2_box1_mask_setting[0]='\0';
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_3_cave2_box1_number_of_activations = 1;
#line 106246 "MACS_sample_kidney_box.c"

  SIG_MESSAGE("channel_3_cave2_box1 (Init:Place/Rotate)");
  rot_set_rotation(mctr1,
#line 1302 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 1302 "MACS_sample_kidney_box.instr"
    (kidney_cave2_box1_y_rotation)*DEG2RAD,
#line 1302 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD);
#line 106256 "MACS_sample_kidney_box.c"
  rot_mul(mctr1, mcrotachannel_3_cave2_cyl1, mcrotachannel_3_cave2_box1);
  rot_transpose(mcrotachannel_3_cave2_cyl1, mctr1);
  rot_mul(mcrotachannel_3_cave2_box1, mctr1, mcrotrchannel_3_cave2_box1);
  mctc1 = coords_set(
#line 1301 "MACS_sample_kidney_box.instr"
    kidney_cave2_box1_center_to_spec_detector_x,
#line 1301 "MACS_sample_kidney_box.instr"
    0,
#line 1301 "MACS_sample_kidney_box.instr"
    kidney_cave2_box1_center_to_spec_detector_z);
#line 106267 "MACS_sample_kidney_box.c"
  rot_transpose(mcrotachannel_3_cave2_cyl1, mctr1);
  mctc2 = rot_apply(mctr1, mctc1);
  mcposachannel_3_cave2_box1 = coords_add(mcposachannel_3_cave2_cyl1, mctc2);
  mctc1 = coords_sub(mcposachannel_3_cave2_cyl1, mcposachannel_3_cave2_box1);
  mcposrchannel_3_cave2_box1 = rot_apply(mcrotachannel_3_cave2_box1, mctc1);
  mcDEBUG_COMPONENT("channel_3_cave2_box1", mcposachannel_3_cave2_box1, mcrotachannel_3_cave2_box1)
  mccomp_posa[265] = mcposachannel_3_cave2_box1;
  mccomp_posr[265] = mcposrchannel_3_cave2_box1;
  mcNCounter[265]  = mcPCounter[265] = mcP2Counter[265] = 0;
  mcAbsorbProp[265]= 0;
    /* Component channel_3_cave2_box2. */
  /* Setting parameters for component channel_3_cave2_box2. */
  SIG_MESSAGE("channel_3_cave2_box2 (Init:SetPar)");
#line 1307 "MACS_sample_kidney_box.instr"
  if("Vacuum") strncpy(mccchannel_3_cave2_box2_material_string, "Vacuum" ? "Vacuum" : "", 16384); else mccchannel_3_cave2_box2_material_string[0]='\0';
#line 1307 "MACS_sample_kidney_box.instr"
  mccchannel_3_cave2_box2_priority = 506;
#line 1305 "MACS_sample_kidney_box.instr"
  mccchannel_3_cave2_box2_xwidth = kidney_cave2_box2_width1;
#line 1305 "MACS_sample_kidney_box.instr"
  mccchannel_3_cave2_box2_yheight = kidney_cave2_box2_height1;
#line 1305 "MACS_sample_kidney_box.instr"
  mccchannel_3_cave2_box2_zdepth = kidney_cave2_box2_depth;
#line 1306 "MACS_sample_kidney_box.instr"
  mccchannel_3_cave2_box2_xwidth2 = kidney_cave2_box2_width2;
#line 1306 "MACS_sample_kidney_box.instr"
  mccchannel_3_cave2_box2_yheight2 = kidney_cave2_box2_height2;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_3_cave2_box2_visualize = 1;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_3_cave2_box2_target_index = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_3_cave2_box2_target_x = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_3_cave2_box2_target_y = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_3_cave2_box2_target_z = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_3_cave2_box2_focus_aw = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_3_cave2_box2_focus_ah = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_3_cave2_box2_focus_xw = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_3_cave2_box2_focus_xh = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_3_cave2_box2_focus_r = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_3_cave2_box2_p_interact = 0;
#line 71 "MACS_sample_kidney_box.instr"
  if(0) strncpy(mccchannel_3_cave2_box2_mask_string, 0 ? 0 : "", 16384); else mccchannel_3_cave2_box2_mask_string[0]='\0';
#line 71 "MACS_sample_kidney_box.instr"
  if(0) strncpy(mccchannel_3_cave2_box2_mask_setting, 0 ? 0 : "", 16384); else mccchannel_3_cave2_box2_mask_setting[0]='\0';
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_3_cave2_box2_number_of_activations = 1;
#line 106323 "MACS_sample_kidney_box.c"

  SIG_MESSAGE("channel_3_cave2_box2 (Init:Place/Rotate)");
  rot_set_rotation(mctr1,
#line 1309 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 1309 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 1309 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD);
#line 106333 "MACS_sample_kidney_box.c"
  rot_mul(mctr1, mcrotachannel_3_cave2_cyl1, mcrotachannel_3_cave2_box2);
  rot_transpose(mcrotachannel_3_cave2_box1, mctr1);
  rot_mul(mcrotachannel_3_cave2_box2, mctr1, mcrotrchannel_3_cave2_box2);
  mctc1 = coords_set(
#line 1308 "MACS_sample_kidney_box.instr"
    0,
#line 1308 "MACS_sample_kidney_box.instr"
    0,
#line 1308 "MACS_sample_kidney_box.instr"
    kidney_cave2_box2_center_to_detector);
#line 106344 "MACS_sample_kidney_box.c"
  rot_transpose(mcrotachannel_3_cave2_cyl1, mctr1);
  mctc2 = rot_apply(mctr1, mctc1);
  mcposachannel_3_cave2_box2 = coords_add(mcposachannel_3_cave2_cyl1, mctc2);
  mctc1 = coords_sub(mcposachannel_3_cave2_box1, mcposachannel_3_cave2_box2);
  mcposrchannel_3_cave2_box2 = rot_apply(mcrotachannel_3_cave2_box2, mctc1);
  mcDEBUG_COMPONENT("channel_3_cave2_box2", mcposachannel_3_cave2_box2, mcrotachannel_3_cave2_box2)
  mccomp_posa[266] = mcposachannel_3_cave2_box2;
  mccomp_posr[266] = mcposrchannel_3_cave2_box2;
  mcNCounter[266]  = mcPCounter[266] = mcP2Counter[266] = 0;
  mcAbsorbProp[266]= 0;
    /* Component channel_3_cave2_box3. */
  /* Setting parameters for component channel_3_cave2_box3. */
  SIG_MESSAGE("channel_3_cave2_box3 (Init:SetPar)");
#line 1314 "MACS_sample_kidney_box.instr"
  if("Vacuum") strncpy(mccchannel_3_cave2_box3_material_string, "Vacuum" ? "Vacuum" : "", 16384); else mccchannel_3_cave2_box3_material_string[0]='\0';
#line 1314 "MACS_sample_kidney_box.instr"
  mccchannel_3_cave2_box3_priority = 507;
#line 1312 "MACS_sample_kidney_box.instr"
  mccchannel_3_cave2_box3_xwidth = kidney_cave2_box3_width1;
#line 1312 "MACS_sample_kidney_box.instr"
  mccchannel_3_cave2_box3_yheight = kidney_cave2_box3_height1;
#line 1312 "MACS_sample_kidney_box.instr"
  mccchannel_3_cave2_box3_zdepth = kidney_cave2_box3_depth;
#line 1313 "MACS_sample_kidney_box.instr"
  mccchannel_3_cave2_box3_xwidth2 = kidney_cave2_box3_width2;
#line 1313 "MACS_sample_kidney_box.instr"
  mccchannel_3_cave2_box3_yheight2 = kidney_cave2_box3_height2;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_3_cave2_box3_visualize = 1;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_3_cave2_box3_target_index = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_3_cave2_box3_target_x = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_3_cave2_box3_target_y = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_3_cave2_box3_target_z = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_3_cave2_box3_focus_aw = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_3_cave2_box3_focus_ah = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_3_cave2_box3_focus_xw = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_3_cave2_box3_focus_xh = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_3_cave2_box3_focus_r = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_3_cave2_box3_p_interact = 0;
#line 71 "MACS_sample_kidney_box.instr"
  if(0) strncpy(mccchannel_3_cave2_box3_mask_string, 0 ? 0 : "", 16384); else mccchannel_3_cave2_box3_mask_string[0]='\0';
#line 71 "MACS_sample_kidney_box.instr"
  if(0) strncpy(mccchannel_3_cave2_box3_mask_setting, 0 ? 0 : "", 16384); else mccchannel_3_cave2_box3_mask_setting[0]='\0';
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_3_cave2_box3_number_of_activations = 1;
#line 106400 "MACS_sample_kidney_box.c"

  SIG_MESSAGE("channel_3_cave2_box3 (Init:Place/Rotate)");
  rot_set_rotation(mctr1,
#line 1316 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 1316 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 1316 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD);
#line 106410 "MACS_sample_kidney_box.c"
  rot_mul(mctr1, mcrotachannel_3_cave2_cyl1, mcrotachannel_3_cave2_box3);
  rot_transpose(mcrotachannel_3_cave2_box2, mctr1);
  rot_mul(mcrotachannel_3_cave2_box3, mctr1, mcrotrchannel_3_cave2_box3);
  mctc1 = coords_set(
#line 1315 "MACS_sample_kidney_box.instr"
    0,
#line 1315 "MACS_sample_kidney_box.instr"
    0,
#line 1315 "MACS_sample_kidney_box.instr"
    kidney_cave2_box3_center_to_detector);
#line 106421 "MACS_sample_kidney_box.c"
  rot_transpose(mcrotachannel_3_cave2_cyl1, mctr1);
  mctc2 = rot_apply(mctr1, mctc1);
  mcposachannel_3_cave2_box3 = coords_add(mcposachannel_3_cave2_cyl1, mctc2);
  mctc1 = coords_sub(mcposachannel_3_cave2_box2, mcposachannel_3_cave2_box3);
  mcposrchannel_3_cave2_box3 = rot_apply(mcrotachannel_3_cave2_box3, mctc1);
  mcDEBUG_COMPONENT("channel_3_cave2_box3", mcposachannel_3_cave2_box3, mcrotachannel_3_cave2_box3)
  mccomp_posa[267] = mcposachannel_3_cave2_box3;
  mccomp_posr[267] = mcposrchannel_3_cave2_box3;
  mcNCounter[267]  = mcPCounter[267] = mcP2Counter[267] = 0;
  mcAbsorbProp[267]= 0;
    /* Component inter_analyzer_colimator_center_3. */
  /* Setting parameters for component inter_analyzer_colimator_center_3. */
  SIG_MESSAGE("inter_analyzer_colimator_center_3 (Init:SetPar)");

  SIG_MESSAGE("inter_analyzer_colimator_center_3 (Init:Place/Rotate)");
  rot_set_rotation(mctr1,
#line 1320 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 1320 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 1320 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD);
#line 106444 "MACS_sample_kidney_box.c"
  rot_mul(mctr1, mcrotachannel_3_analyzer_1_center, mcrotainter_analyzer_colimator_center_3);
  rot_transpose(mcrotachannel_3_cave2_box3, mctr1);
  rot_mul(mcrotainter_analyzer_colimator_center_3, mctr1, mcrotrinter_analyzer_colimator_center_3);
  mctc1 = coords_set(
#line 1319 "MACS_sample_kidney_box.instr"
    -0.5 * analyzer_seperation,
#line 1319 "MACS_sample_kidney_box.instr"
    0,
#line 1319 "MACS_sample_kidney_box.instr"
    0);
#line 106455 "MACS_sample_kidney_box.c"
  rot_transpose(mcrotachannel_3_analyzer_1_center, mctr1);
  mctc2 = rot_apply(mctr1, mctc1);
  mcposainter_analyzer_colimator_center_3 = coords_add(mcposachannel_3_analyzer_1_center, mctc2);
  mctc1 = coords_sub(mcposachannel_3_cave2_box3, mcposainter_analyzer_colimator_center_3);
  mcposrinter_analyzer_colimator_center_3 = rot_apply(mcrotainter_analyzer_colimator_center_3, mctc1);
  mcDEBUG_COMPONENT("inter_analyzer_colimator_center_3", mcposainter_analyzer_colimator_center_3, mcrotainter_analyzer_colimator_center_3)
  mccomp_posa[268] = mcposainter_analyzer_colimator_center_3;
  mccomp_posr[268] = mcposrinter_analyzer_colimator_center_3;
  mcNCounter[268]  = mcPCounter[268] = mcP2Counter[268] = 0;
  mcAbsorbProp[268]= 0;
    /* Component inter_analyzer_colimator_3_blade_0. */
  /* Setting parameters for component inter_analyzer_colimator_3_blade_0. */
  SIG_MESSAGE("inter_analyzer_colimator_3_blade_0 (Init:SetPar)");
#line 1324 "MACS_sample_kidney_box.instr"
  if("Collimator_gad") strncpy(mccinter_analyzer_colimator_3_blade_0_material_string, "Collimator_gad" ? "Collimator_gad" : "", 16384); else mccinter_analyzer_colimator_3_blade_0_material_string[0]='\0';
#line 1324 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_3_blade_0_priority = 525;
#line 1323 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_3_blade_0_xwidth = inter_analyzer_colimator_width;
#line 1323 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_3_blade_0_yheight = inter_analyzer_colimator_height;
#line 1323 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_3_blade_0_zdepth = inter_analyzer_colimator_depth;
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_3_blade_0_xwidth2 = -1;
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_3_blade_0_yheight2 = -1;
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_3_blade_0_visualize = 1;
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_3_blade_0_target_index = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_3_blade_0_target_x = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_3_blade_0_target_y = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_3_blade_0_target_z = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_3_blade_0_focus_aw = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_3_blade_0_focus_ah = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_3_blade_0_focus_xw = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_3_blade_0_focus_xh = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_3_blade_0_focus_r = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_3_blade_0_p_interact = 0;
#line 71 "MACS_sample_kidney_box.instr"
  if(0) strncpy(mccinter_analyzer_colimator_3_blade_0_mask_string, 0 ? 0 : "", 16384); else mccinter_analyzer_colimator_3_blade_0_mask_string[0]='\0';
#line 71 "MACS_sample_kidney_box.instr"
  if(0) strncpy(mccinter_analyzer_colimator_3_blade_0_mask_setting, 0 ? 0 : "", 16384); else mccinter_analyzer_colimator_3_blade_0_mask_setting[0]='\0';
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_3_blade_0_number_of_activations = 1;
#line 106511 "MACS_sample_kidney_box.c"

  SIG_MESSAGE("inter_analyzer_colimator_3_blade_0 (Init:Place/Rotate)");
  rot_set_rotation(mctr1,
#line 1326 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 1326 "MACS_sample_kidney_box.instr"
    (- analyzer_2theta [ 3 ])*DEG2RAD,
#line 1326 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD);
#line 106521 "MACS_sample_kidney_box.c"
  rot_mul(mctr1, mcrotainter_analyzer_colimator_center_3, mcrotainter_analyzer_colimator_3_blade_0);
  rot_transpose(mcrotainter_analyzer_colimator_center_3, mctr1);
  rot_mul(mcrotainter_analyzer_colimator_3_blade_0, mctr1, mcrotrinter_analyzer_colimator_3_blade_0);
  mctc1 = coords_set(
#line 1325 "MACS_sample_kidney_box.instr"
    0,
#line 1325 "MACS_sample_kidney_box.instr"
    0,
#line 1325 "MACS_sample_kidney_box.instr"
    inter_analyzer_colimator_start_pos - 0 * inter_analyzer_colimator_seperation);
#line 106532 "MACS_sample_kidney_box.c"
  rot_transpose(mcrotainter_analyzer_colimator_center_3, mctr1);
  mctc2 = rot_apply(mctr1, mctc1);
  mcposainter_analyzer_colimator_3_blade_0 = coords_add(mcposainter_analyzer_colimator_center_3, mctc2);
  mctc1 = coords_sub(mcposainter_analyzer_colimator_center_3, mcposainter_analyzer_colimator_3_blade_0);
  mcposrinter_analyzer_colimator_3_blade_0 = rot_apply(mcrotainter_analyzer_colimator_3_blade_0, mctc1);
  mcDEBUG_COMPONENT("inter_analyzer_colimator_3_blade_0", mcposainter_analyzer_colimator_3_blade_0, mcrotainter_analyzer_colimator_3_blade_0)
  mccomp_posa[269] = mcposainter_analyzer_colimator_3_blade_0;
  mccomp_posr[269] = mcposrinter_analyzer_colimator_3_blade_0;
  mcNCounter[269]  = mcPCounter[269] = mcP2Counter[269] = 0;
  mcAbsorbProp[269]= 0;
    /* Component inter_analyzer_colimator_3_blade_1. */
  /* Setting parameters for component inter_analyzer_colimator_3_blade_1. */
  SIG_MESSAGE("inter_analyzer_colimator_3_blade_1 (Init:SetPar)");
#line 1330 "MACS_sample_kidney_box.instr"
  if("Collimator_gad") strncpy(mccinter_analyzer_colimator_3_blade_1_material_string, "Collimator_gad" ? "Collimator_gad" : "", 16384); else mccinter_analyzer_colimator_3_blade_1_material_string[0]='\0';
#line 1330 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_3_blade_1_priority = 526;
#line 1329 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_3_blade_1_xwidth = inter_analyzer_colimator_width;
#line 1329 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_3_blade_1_yheight = inter_analyzer_colimator_height;
#line 1329 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_3_blade_1_zdepth = inter_analyzer_colimator_depth;
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_3_blade_1_xwidth2 = -1;
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_3_blade_1_yheight2 = -1;
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_3_blade_1_visualize = 1;
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_3_blade_1_target_index = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_3_blade_1_target_x = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_3_blade_1_target_y = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_3_blade_1_target_z = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_3_blade_1_focus_aw = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_3_blade_1_focus_ah = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_3_blade_1_focus_xw = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_3_blade_1_focus_xh = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_3_blade_1_focus_r = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_3_blade_1_p_interact = 0;
#line 71 "MACS_sample_kidney_box.instr"
  if(0) strncpy(mccinter_analyzer_colimator_3_blade_1_mask_string, 0 ? 0 : "", 16384); else mccinter_analyzer_colimator_3_blade_1_mask_string[0]='\0';
#line 71 "MACS_sample_kidney_box.instr"
  if(0) strncpy(mccinter_analyzer_colimator_3_blade_1_mask_setting, 0 ? 0 : "", 16384); else mccinter_analyzer_colimator_3_blade_1_mask_setting[0]='\0';
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_3_blade_1_number_of_activations = 1;
#line 106588 "MACS_sample_kidney_box.c"

  SIG_MESSAGE("inter_analyzer_colimator_3_blade_1 (Init:Place/Rotate)");
  rot_set_rotation(mctr1,
#line 1332 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 1332 "MACS_sample_kidney_box.instr"
    (- analyzer_2theta [ 3 ])*DEG2RAD,
#line 1332 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD);
#line 106598 "MACS_sample_kidney_box.c"
  rot_mul(mctr1, mcrotainter_analyzer_colimator_center_3, mcrotainter_analyzer_colimator_3_blade_1);
  rot_transpose(mcrotainter_analyzer_colimator_3_blade_0, mctr1);
  rot_mul(mcrotainter_analyzer_colimator_3_blade_1, mctr1, mcrotrinter_analyzer_colimator_3_blade_1);
  mctc1 = coords_set(
#line 1331 "MACS_sample_kidney_box.instr"
    0,
#line 1331 "MACS_sample_kidney_box.instr"
    0,
#line 1331 "MACS_sample_kidney_box.instr"
    inter_analyzer_colimator_start_pos - 1 * inter_analyzer_colimator_seperation);
#line 106609 "MACS_sample_kidney_box.c"
  rot_transpose(mcrotainter_analyzer_colimator_center_3, mctr1);
  mctc2 = rot_apply(mctr1, mctc1);
  mcposainter_analyzer_colimator_3_blade_1 = coords_add(mcposainter_analyzer_colimator_center_3, mctc2);
  mctc1 = coords_sub(mcposainter_analyzer_colimator_3_blade_0, mcposainter_analyzer_colimator_3_blade_1);
  mcposrinter_analyzer_colimator_3_blade_1 = rot_apply(mcrotainter_analyzer_colimator_3_blade_1, mctc1);
  mcDEBUG_COMPONENT("inter_analyzer_colimator_3_blade_1", mcposainter_analyzer_colimator_3_blade_1, mcrotainter_analyzer_colimator_3_blade_1)
  mccomp_posa[270] = mcposainter_analyzer_colimator_3_blade_1;
  mccomp_posr[270] = mcposrinter_analyzer_colimator_3_blade_1;
  mcNCounter[270]  = mcPCounter[270] = mcP2Counter[270] = 0;
  mcAbsorbProp[270]= 0;
    /* Component inter_analyzer_colimator_3_blade_2. */
  /* Setting parameters for component inter_analyzer_colimator_3_blade_2. */
  SIG_MESSAGE("inter_analyzer_colimator_3_blade_2 (Init:SetPar)");
#line 1336 "MACS_sample_kidney_box.instr"
  if("Collimator_gad") strncpy(mccinter_analyzer_colimator_3_blade_2_material_string, "Collimator_gad" ? "Collimator_gad" : "", 16384); else mccinter_analyzer_colimator_3_blade_2_material_string[0]='\0';
#line 1336 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_3_blade_2_priority = 527;
#line 1335 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_3_blade_2_xwidth = inter_analyzer_colimator_width;
#line 1335 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_3_blade_2_yheight = inter_analyzer_colimator_height;
#line 1335 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_3_blade_2_zdepth = inter_analyzer_colimator_depth;
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_3_blade_2_xwidth2 = -1;
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_3_blade_2_yheight2 = -1;
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_3_blade_2_visualize = 1;
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_3_blade_2_target_index = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_3_blade_2_target_x = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_3_blade_2_target_y = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_3_blade_2_target_z = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_3_blade_2_focus_aw = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_3_blade_2_focus_ah = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_3_blade_2_focus_xw = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_3_blade_2_focus_xh = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_3_blade_2_focus_r = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_3_blade_2_p_interact = 0;
#line 71 "MACS_sample_kidney_box.instr"
  if(0) strncpy(mccinter_analyzer_colimator_3_blade_2_mask_string, 0 ? 0 : "", 16384); else mccinter_analyzer_colimator_3_blade_2_mask_string[0]='\0';
#line 71 "MACS_sample_kidney_box.instr"
  if(0) strncpy(mccinter_analyzer_colimator_3_blade_2_mask_setting, 0 ? 0 : "", 16384); else mccinter_analyzer_colimator_3_blade_2_mask_setting[0]='\0';
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_3_blade_2_number_of_activations = 1;
#line 106665 "MACS_sample_kidney_box.c"

  SIG_MESSAGE("inter_analyzer_colimator_3_blade_2 (Init:Place/Rotate)");
  rot_set_rotation(mctr1,
#line 1338 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 1338 "MACS_sample_kidney_box.instr"
    (- analyzer_2theta [ 3 ])*DEG2RAD,
#line 1338 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD);
#line 106675 "MACS_sample_kidney_box.c"
  rot_mul(mctr1, mcrotainter_analyzer_colimator_center_3, mcrotainter_analyzer_colimator_3_blade_2);
  rot_transpose(mcrotainter_analyzer_colimator_3_blade_1, mctr1);
  rot_mul(mcrotainter_analyzer_colimator_3_blade_2, mctr1, mcrotrinter_analyzer_colimator_3_blade_2);
  mctc1 = coords_set(
#line 1337 "MACS_sample_kidney_box.instr"
    0,
#line 1337 "MACS_sample_kidney_box.instr"
    0,
#line 1337 "MACS_sample_kidney_box.instr"
    inter_analyzer_colimator_start_pos - 2 * inter_analyzer_colimator_seperation);
#line 106686 "MACS_sample_kidney_box.c"
  rot_transpose(mcrotainter_analyzer_colimator_center_3, mctr1);
  mctc2 = rot_apply(mctr1, mctc1);
  mcposainter_analyzer_colimator_3_blade_2 = coords_add(mcposainter_analyzer_colimator_center_3, mctc2);
  mctc1 = coords_sub(mcposainter_analyzer_colimator_3_blade_1, mcposainter_analyzer_colimator_3_blade_2);
  mcposrinter_analyzer_colimator_3_blade_2 = rot_apply(mcrotainter_analyzer_colimator_3_blade_2, mctc1);
  mcDEBUG_COMPONENT("inter_analyzer_colimator_3_blade_2", mcposainter_analyzer_colimator_3_blade_2, mcrotainter_analyzer_colimator_3_blade_2)
  mccomp_posa[271] = mcposainter_analyzer_colimator_3_blade_2;
  mccomp_posr[271] = mcposrinter_analyzer_colimator_3_blade_2;
  mcNCounter[271]  = mcPCounter[271] = mcP2Counter[271] = 0;
  mcAbsorbProp[271]= 0;
    /* Component inter_analyzer_colimator_3_blade_3. */
  /* Setting parameters for component inter_analyzer_colimator_3_blade_3. */
  SIG_MESSAGE("inter_analyzer_colimator_3_blade_3 (Init:SetPar)");
#line 1342 "MACS_sample_kidney_box.instr"
  if("Collimator_gad") strncpy(mccinter_analyzer_colimator_3_blade_3_material_string, "Collimator_gad" ? "Collimator_gad" : "", 16384); else mccinter_analyzer_colimator_3_blade_3_material_string[0]='\0';
#line 1342 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_3_blade_3_priority = 528;
#line 1341 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_3_blade_3_xwidth = inter_analyzer_colimator_width;
#line 1341 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_3_blade_3_yheight = inter_analyzer_colimator_height;
#line 1341 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_3_blade_3_zdepth = inter_analyzer_colimator_depth;
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_3_blade_3_xwidth2 = -1;
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_3_blade_3_yheight2 = -1;
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_3_blade_3_visualize = 1;
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_3_blade_3_target_index = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_3_blade_3_target_x = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_3_blade_3_target_y = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_3_blade_3_target_z = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_3_blade_3_focus_aw = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_3_blade_3_focus_ah = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_3_blade_3_focus_xw = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_3_blade_3_focus_xh = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_3_blade_3_focus_r = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_3_blade_3_p_interact = 0;
#line 71 "MACS_sample_kidney_box.instr"
  if(0) strncpy(mccinter_analyzer_colimator_3_blade_3_mask_string, 0 ? 0 : "", 16384); else mccinter_analyzer_colimator_3_blade_3_mask_string[0]='\0';
#line 71 "MACS_sample_kidney_box.instr"
  if(0) strncpy(mccinter_analyzer_colimator_3_blade_3_mask_setting, 0 ? 0 : "", 16384); else mccinter_analyzer_colimator_3_blade_3_mask_setting[0]='\0';
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_3_blade_3_number_of_activations = 1;
#line 106742 "MACS_sample_kidney_box.c"

  SIG_MESSAGE("inter_analyzer_colimator_3_blade_3 (Init:Place/Rotate)");
  rot_set_rotation(mctr1,
#line 1344 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 1344 "MACS_sample_kidney_box.instr"
    (- analyzer_2theta [ 3 ])*DEG2RAD,
#line 1344 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD);
#line 106752 "MACS_sample_kidney_box.c"
  rot_mul(mctr1, mcrotainter_analyzer_colimator_center_3, mcrotainter_analyzer_colimator_3_blade_3);
  rot_transpose(mcrotainter_analyzer_colimator_3_blade_2, mctr1);
  rot_mul(mcrotainter_analyzer_colimator_3_blade_3, mctr1, mcrotrinter_analyzer_colimator_3_blade_3);
  mctc1 = coords_set(
#line 1343 "MACS_sample_kidney_box.instr"
    0,
#line 1343 "MACS_sample_kidney_box.instr"
    0,
#line 1343 "MACS_sample_kidney_box.instr"
    inter_analyzer_colimator_start_pos - 3 * inter_analyzer_colimator_seperation);
#line 106763 "MACS_sample_kidney_box.c"
  rot_transpose(mcrotainter_analyzer_colimator_center_3, mctr1);
  mctc2 = rot_apply(mctr1, mctc1);
  mcposainter_analyzer_colimator_3_blade_3 = coords_add(mcposainter_analyzer_colimator_center_3, mctc2);
  mctc1 = coords_sub(mcposainter_analyzer_colimator_3_blade_2, mcposainter_analyzer_colimator_3_blade_3);
  mcposrinter_analyzer_colimator_3_blade_3 = rot_apply(mcrotainter_analyzer_colimator_3_blade_3, mctc1);
  mcDEBUG_COMPONENT("inter_analyzer_colimator_3_blade_3", mcposainter_analyzer_colimator_3_blade_3, mcrotainter_analyzer_colimator_3_blade_3)
  mccomp_posa[272] = mcposainter_analyzer_colimator_3_blade_3;
  mccomp_posr[272] = mcposrinter_analyzer_colimator_3_blade_3;
  mcNCounter[272]  = mcPCounter[272] = mcP2Counter[272] = 0;
  mcAbsorbProp[272]= 0;
    /* Component inter_analyzer_colimator_3_blade_4. */
  /* Setting parameters for component inter_analyzer_colimator_3_blade_4. */
  SIG_MESSAGE("inter_analyzer_colimator_3_blade_4 (Init:SetPar)");
#line 1348 "MACS_sample_kidney_box.instr"
  if("Collimator_gad") strncpy(mccinter_analyzer_colimator_3_blade_4_material_string, "Collimator_gad" ? "Collimator_gad" : "", 16384); else mccinter_analyzer_colimator_3_blade_4_material_string[0]='\0';
#line 1348 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_3_blade_4_priority = 529;
#line 1347 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_3_blade_4_xwidth = inter_analyzer_colimator_width;
#line 1347 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_3_blade_4_yheight = inter_analyzer_colimator_height;
#line 1347 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_3_blade_4_zdepth = inter_analyzer_colimator_depth;
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_3_blade_4_xwidth2 = -1;
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_3_blade_4_yheight2 = -1;
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_3_blade_4_visualize = 1;
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_3_blade_4_target_index = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_3_blade_4_target_x = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_3_blade_4_target_y = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_3_blade_4_target_z = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_3_blade_4_focus_aw = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_3_blade_4_focus_ah = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_3_blade_4_focus_xw = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_3_blade_4_focus_xh = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_3_blade_4_focus_r = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_3_blade_4_p_interact = 0;
#line 71 "MACS_sample_kidney_box.instr"
  if(0) strncpy(mccinter_analyzer_colimator_3_blade_4_mask_string, 0 ? 0 : "", 16384); else mccinter_analyzer_colimator_3_blade_4_mask_string[0]='\0';
#line 71 "MACS_sample_kidney_box.instr"
  if(0) strncpy(mccinter_analyzer_colimator_3_blade_4_mask_setting, 0 ? 0 : "", 16384); else mccinter_analyzer_colimator_3_blade_4_mask_setting[0]='\0';
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_3_blade_4_number_of_activations = 1;
#line 106819 "MACS_sample_kidney_box.c"

  SIG_MESSAGE("inter_analyzer_colimator_3_blade_4 (Init:Place/Rotate)");
  rot_set_rotation(mctr1,
#line 1350 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 1350 "MACS_sample_kidney_box.instr"
    (- analyzer_2theta [ 3 ])*DEG2RAD,
#line 1350 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD);
#line 106829 "MACS_sample_kidney_box.c"
  rot_mul(mctr1, mcrotainter_analyzer_colimator_center_3, mcrotainter_analyzer_colimator_3_blade_4);
  rot_transpose(mcrotainter_analyzer_colimator_3_blade_3, mctr1);
  rot_mul(mcrotainter_analyzer_colimator_3_blade_4, mctr1, mcrotrinter_analyzer_colimator_3_blade_4);
  mctc1 = coords_set(
#line 1349 "MACS_sample_kidney_box.instr"
    0,
#line 1349 "MACS_sample_kidney_box.instr"
    0,
#line 1349 "MACS_sample_kidney_box.instr"
    inter_analyzer_colimator_start_pos - 4 * inter_analyzer_colimator_seperation);
#line 106840 "MACS_sample_kidney_box.c"
  rot_transpose(mcrotainter_analyzer_colimator_center_3, mctr1);
  mctc2 = rot_apply(mctr1, mctc1);
  mcposainter_analyzer_colimator_3_blade_4 = coords_add(mcposainter_analyzer_colimator_center_3, mctc2);
  mctc1 = coords_sub(mcposainter_analyzer_colimator_3_blade_3, mcposainter_analyzer_colimator_3_blade_4);
  mcposrinter_analyzer_colimator_3_blade_4 = rot_apply(mcrotainter_analyzer_colimator_3_blade_4, mctc1);
  mcDEBUG_COMPONENT("inter_analyzer_colimator_3_blade_4", mcposainter_analyzer_colimator_3_blade_4, mcrotainter_analyzer_colimator_3_blade_4)
  mccomp_posa[273] = mcposainter_analyzer_colimator_3_blade_4;
  mccomp_posr[273] = mcposrinter_analyzer_colimator_3_blade_4;
  mcNCounter[273]  = mcPCounter[273] = mcP2Counter[273] = 0;
  mcAbsorbProp[273]= 0;
    /* Component diffraction_detector_3_exit_volume. */
  /* Setting parameters for component diffraction_detector_3_exit_volume. */
  SIG_MESSAGE("diffraction_detector_3_exit_volume (Init:SetPar)");
#line 1354 "MACS_sample_kidney_box.instr"
  if("Exit") strncpy(mccdiffraction_detector_3_exit_volume_material_string, "Exit" ? "Exit" : "", 16384); else mccdiffraction_detector_3_exit_volume_material_string[0]='\0';
#line 1354 "MACS_sample_kidney_box.instr"
  mccdiffraction_detector_3_exit_volume_priority = 531;
#line 1353 "MACS_sample_kidney_box.instr"
  mccdiffraction_detector_3_exit_volume_xwidth = 2.01 * detector_radius;
#line 1353 "MACS_sample_kidney_box.instr"
  mccdiffraction_detector_3_exit_volume_yheight = 1.01 * detector_height;
#line 1353 "MACS_sample_kidney_box.instr"
  mccdiffraction_detector_3_exit_volume_zdepth = 0.001;
#line 71 "MACS_sample_kidney_box.instr"
  mccdiffraction_detector_3_exit_volume_xwidth2 = -1;
#line 71 "MACS_sample_kidney_box.instr"
  mccdiffraction_detector_3_exit_volume_yheight2 = -1;
#line 71 "MACS_sample_kidney_box.instr"
  mccdiffraction_detector_3_exit_volume_visualize = 1;
#line 71 "MACS_sample_kidney_box.instr"
  mccdiffraction_detector_3_exit_volume_target_index = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccdiffraction_detector_3_exit_volume_target_x = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccdiffraction_detector_3_exit_volume_target_y = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccdiffraction_detector_3_exit_volume_target_z = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccdiffraction_detector_3_exit_volume_focus_aw = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccdiffraction_detector_3_exit_volume_focus_ah = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccdiffraction_detector_3_exit_volume_focus_xw = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccdiffraction_detector_3_exit_volume_focus_xh = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccdiffraction_detector_3_exit_volume_focus_r = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccdiffraction_detector_3_exit_volume_p_interact = 0;
#line 71 "MACS_sample_kidney_box.instr"
  if(0) strncpy(mccdiffraction_detector_3_exit_volume_mask_string, 0 ? 0 : "", 16384); else mccdiffraction_detector_3_exit_volume_mask_string[0]='\0';
#line 71 "MACS_sample_kidney_box.instr"
  if(0) strncpy(mccdiffraction_detector_3_exit_volume_mask_setting, 0 ? 0 : "", 16384); else mccdiffraction_detector_3_exit_volume_mask_setting[0]='\0';
#line 71 "MACS_sample_kidney_box.instr"
  mccdiffraction_detector_3_exit_volume_number_of_activations = 1;
#line 106896 "MACS_sample_kidney_box.c"

  SIG_MESSAGE("diffraction_detector_3_exit_volume (Init:Place/Rotate)");
  rot_set_rotation(mctr1,
#line 1356 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 1356 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 1356 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD);
#line 106906 "MACS_sample_kidney_box.c"
  rot_mul(mctr1, mcrotakidney_channel_3, mcrotadiffraction_detector_3_exit_volume);
  rot_transpose(mcrotainter_analyzer_colimator_3_blade_4, mctr1);
  rot_mul(mcrotadiffraction_detector_3_exit_volume, mctr1, mcrotrdiffraction_detector_3_exit_volume);
  mctc1 = coords_set(
#line 1355 "MACS_sample_kidney_box.instr"
    0,
#line 1355 "MACS_sample_kidney_box.instr"
    0,
#line 1355 "MACS_sample_kidney_box.instr"
    0);
#line 106917 "MACS_sample_kidney_box.c"
  rot_transpose(mcrotachannel_3_cave1_cyl1, mctr1);
  mctc2 = rot_apply(mctr1, mctc1);
  mcposadiffraction_detector_3_exit_volume = coords_add(mcposachannel_3_cave1_cyl1, mctc2);
  mctc1 = coords_sub(mcposainter_analyzer_colimator_3_blade_4, mcposadiffraction_detector_3_exit_volume);
  mcposrdiffraction_detector_3_exit_volume = rot_apply(mcrotadiffraction_detector_3_exit_volume, mctc1);
  mcDEBUG_COMPONENT("diffraction_detector_3_exit_volume", mcposadiffraction_detector_3_exit_volume, mcrotadiffraction_detector_3_exit_volume)
  mccomp_posa[274] = mcposadiffraction_detector_3_exit_volume;
  mccomp_posr[274] = mcposrdiffraction_detector_3_exit_volume;
  mcNCounter[274]  = mcPCounter[274] = mcP2Counter[274] = 0;
  mcAbsorbProp[274]= 0;
    /* Component spec_detector_3_exit_volume. */
  /* Setting parameters for component spec_detector_3_exit_volume. */
  SIG_MESSAGE("spec_detector_3_exit_volume (Init:SetPar)");
#line 1360 "MACS_sample_kidney_box.instr"
  if("Exit") strncpy(mccspec_detector_3_exit_volume_material_string, "Exit" ? "Exit" : "", 16384); else mccspec_detector_3_exit_volume_material_string[0]='\0';
#line 1360 "MACS_sample_kidney_box.instr"
  mccspec_detector_3_exit_volume_priority = 532;
#line 1359 "MACS_sample_kidney_box.instr"
  mccspec_detector_3_exit_volume_xwidth = 2.01 * detector_radius;
#line 1359 "MACS_sample_kidney_box.instr"
  mccspec_detector_3_exit_volume_yheight = 1.01 * detector_height;
#line 1359 "MACS_sample_kidney_box.instr"
  mccspec_detector_3_exit_volume_zdepth = 0.001;
#line 71 "MACS_sample_kidney_box.instr"
  mccspec_detector_3_exit_volume_xwidth2 = -1;
#line 71 "MACS_sample_kidney_box.instr"
  mccspec_detector_3_exit_volume_yheight2 = -1;
#line 71 "MACS_sample_kidney_box.instr"
  mccspec_detector_3_exit_volume_visualize = 1;
#line 71 "MACS_sample_kidney_box.instr"
  mccspec_detector_3_exit_volume_target_index = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccspec_detector_3_exit_volume_target_x = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccspec_detector_3_exit_volume_target_y = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccspec_detector_3_exit_volume_target_z = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccspec_detector_3_exit_volume_focus_aw = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccspec_detector_3_exit_volume_focus_ah = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccspec_detector_3_exit_volume_focus_xw = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccspec_detector_3_exit_volume_focus_xh = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccspec_detector_3_exit_volume_focus_r = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccspec_detector_3_exit_volume_p_interact = 0;
#line 71 "MACS_sample_kidney_box.instr"
  if(0) strncpy(mccspec_detector_3_exit_volume_mask_string, 0 ? 0 : "", 16384); else mccspec_detector_3_exit_volume_mask_string[0]='\0';
#line 71 "MACS_sample_kidney_box.instr"
  if(0) strncpy(mccspec_detector_3_exit_volume_mask_setting, 0 ? 0 : "", 16384); else mccspec_detector_3_exit_volume_mask_setting[0]='\0';
#line 71 "MACS_sample_kidney_box.instr"
  mccspec_detector_3_exit_volume_number_of_activations = 1;
#line 106973 "MACS_sample_kidney_box.c"

  SIG_MESSAGE("spec_detector_3_exit_volume (Init:Place/Rotate)");
  rot_set_rotation(mctr1,
#line 1362 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 1362 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 1362 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD);
#line 106983 "MACS_sample_kidney_box.c"
  rot_mul(mctr1, mcrotachannel_3_analyzer_2_center, mcrotaspec_detector_3_exit_volume);
  rot_transpose(mcrotadiffraction_detector_3_exit_volume, mctr1);
  rot_mul(mcrotaspec_detector_3_exit_volume, mctr1, mcrotrspec_detector_3_exit_volume);
  mctc1 = coords_set(
#line 1361 "MACS_sample_kidney_box.instr"
    0,
#line 1361 "MACS_sample_kidney_box.instr"
    0,
#line 1361 "MACS_sample_kidney_box.instr"
    0);
#line 106994 "MACS_sample_kidney_box.c"
  rot_transpose(mcrotachannel_3_cave2_cyl1, mctr1);
  mctc2 = rot_apply(mctr1, mctc1);
  mcposaspec_detector_3_exit_volume = coords_add(mcposachannel_3_cave2_cyl1, mctc2);
  mctc1 = coords_sub(mcposadiffraction_detector_3_exit_volume, mcposaspec_detector_3_exit_volume);
  mcposrspec_detector_3_exit_volume = rot_apply(mcrotaspec_detector_3_exit_volume, mctc1);
  mcDEBUG_COMPONENT("spec_detector_3_exit_volume", mcposaspec_detector_3_exit_volume, mcrotaspec_detector_3_exit_volume)
  mccomp_posa[275] = mcposaspec_detector_3_exit_volume;
  mccomp_posr[275] = mcposrspec_detector_3_exit_volume;
  mcNCounter[275]  = mcPCounter[275] = mcP2Counter[275] = 0;
  mcAbsorbProp[275]= 0;
    /* Component channel_4_cave1_box1. */
  /* Setting parameters for component channel_4_cave1_box1. */
  SIG_MESSAGE("channel_4_cave1_box1 (Init:SetPar)");
#line 1367 "MACS_sample_kidney_box.instr"
  if("Vacuum") strncpy(mccchannel_4_cave1_box1_material_string, "Vacuum" ? "Vacuum" : "", 16384); else mccchannel_4_cave1_box1_material_string[0]='\0';
#line 1367 "MACS_sample_kidney_box.instr"
  mccchannel_4_cave1_box1_priority = 600;
#line 1365 "MACS_sample_kidney_box.instr"
  mccchannel_4_cave1_box1_xwidth = kidney_cave1_box1_width1;
#line 1365 "MACS_sample_kidney_box.instr"
  mccchannel_4_cave1_box1_yheight = kidney_cave1_box1_height1;
#line 1365 "MACS_sample_kidney_box.instr"
  mccchannel_4_cave1_box1_zdepth = kidney_cave1_box1_depth;
#line 1366 "MACS_sample_kidney_box.instr"
  mccchannel_4_cave1_box1_xwidth2 = kidney_cave1_box1_width2;
#line 1366 "MACS_sample_kidney_box.instr"
  mccchannel_4_cave1_box1_yheight2 = kidney_cave1_box1_height2;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_4_cave1_box1_visualize = 1;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_4_cave1_box1_target_index = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_4_cave1_box1_target_x = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_4_cave1_box1_target_y = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_4_cave1_box1_target_z = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_4_cave1_box1_focus_aw = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_4_cave1_box1_focus_ah = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_4_cave1_box1_focus_xw = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_4_cave1_box1_focus_xh = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_4_cave1_box1_focus_r = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_4_cave1_box1_p_interact = 0;
#line 71 "MACS_sample_kidney_box.instr"
  if(0) strncpy(mccchannel_4_cave1_box1_mask_string, 0 ? 0 : "", 16384); else mccchannel_4_cave1_box1_mask_string[0]='\0';
#line 71 "MACS_sample_kidney_box.instr"
  if(0) strncpy(mccchannel_4_cave1_box1_mask_setting, 0 ? 0 : "", 16384); else mccchannel_4_cave1_box1_mask_setting[0]='\0';
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_4_cave1_box1_number_of_activations = 1;
#line 107050 "MACS_sample_kidney_box.c"

  SIG_MESSAGE("channel_4_cave1_box1 (Init:Place/Rotate)");
  rot_set_rotation(mctr1,
#line 1369 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 1369 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 1369 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD);
#line 107060 "MACS_sample_kidney_box.c"
  rot_mul(mctr1, mcrotakidney_channel_4, mcrotachannel_4_cave1_box1);
  rot_transpose(mcrotaspec_detector_3_exit_volume, mctr1);
  rot_mul(mcrotachannel_4_cave1_box1, mctr1, mcrotrchannel_4_cave1_box1);
  mctc1 = coords_set(
#line 1368 "MACS_sample_kidney_box.instr"
    0,
#line 1368 "MACS_sample_kidney_box.instr"
    0,
#line 1368 "MACS_sample_kidney_box.instr"
    kidney_cave1_box1_center_to_target);
#line 107071 "MACS_sample_kidney_box.c"
  rot_transpose(mcrotakidney_channel_4, mctr1);
  mctc2 = rot_apply(mctr1, mctc1);
  mcposachannel_4_cave1_box1 = coords_add(mcposakidney_channel_4, mctc2);
  mctc1 = coords_sub(mcposaspec_detector_3_exit_volume, mcposachannel_4_cave1_box1);
  mcposrchannel_4_cave1_box1 = rot_apply(mcrotachannel_4_cave1_box1, mctc1);
  mcDEBUG_COMPONENT("channel_4_cave1_box1", mcposachannel_4_cave1_box1, mcrotachannel_4_cave1_box1)
  mccomp_posa[276] = mcposachannel_4_cave1_box1;
  mccomp_posr[276] = mcposrchannel_4_cave1_box1;
  mcNCounter[276]  = mcPCounter[276] = mcP2Counter[276] = 0;
  mcAbsorbProp[276]= 0;
    /* Component channel_4_cave1_box2. */
  /* Setting parameters for component channel_4_cave1_box2. */
  SIG_MESSAGE("channel_4_cave1_box2 (Init:SetPar)");
#line 1374 "MACS_sample_kidney_box.instr"
  if("Vacuum") strncpy(mccchannel_4_cave1_box2_material_string, "Vacuum" ? "Vacuum" : "", 16384); else mccchannel_4_cave1_box2_material_string[0]='\0';
#line 1374 "MACS_sample_kidney_box.instr"
  mccchannel_4_cave1_box2_priority = 605;
#line 1372 "MACS_sample_kidney_box.instr"
  mccchannel_4_cave1_box2_xwidth = kidney_cave1_box2_width1;
#line 1372 "MACS_sample_kidney_box.instr"
  mccchannel_4_cave1_box2_yheight = kidney_cave1_box2_height1;
#line 1372 "MACS_sample_kidney_box.instr"
  mccchannel_4_cave1_box2_zdepth = kidney_cave1_box2_depth;
#line 1373 "MACS_sample_kidney_box.instr"
  mccchannel_4_cave1_box2_xwidth2 = kidney_cave1_box2_width2;
#line 1373 "MACS_sample_kidney_box.instr"
  mccchannel_4_cave1_box2_yheight2 = kidney_cave1_box2_height2;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_4_cave1_box2_visualize = 1;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_4_cave1_box2_target_index = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_4_cave1_box2_target_x = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_4_cave1_box2_target_y = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_4_cave1_box2_target_z = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_4_cave1_box2_focus_aw = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_4_cave1_box2_focus_ah = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_4_cave1_box2_focus_xw = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_4_cave1_box2_focus_xh = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_4_cave1_box2_focus_r = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_4_cave1_box2_p_interact = 0;
#line 71 "MACS_sample_kidney_box.instr"
  if(0) strncpy(mccchannel_4_cave1_box2_mask_string, 0 ? 0 : "", 16384); else mccchannel_4_cave1_box2_mask_string[0]='\0';
#line 71 "MACS_sample_kidney_box.instr"
  if(0) strncpy(mccchannel_4_cave1_box2_mask_setting, 0 ? 0 : "", 16384); else mccchannel_4_cave1_box2_mask_setting[0]='\0';
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_4_cave1_box2_number_of_activations = 1;
#line 107127 "MACS_sample_kidney_box.c"

  SIG_MESSAGE("channel_4_cave1_box2 (Init:Place/Rotate)");
  rot_set_rotation(mctr1,
#line 1376 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 1376 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 1376 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD);
#line 107137 "MACS_sample_kidney_box.c"
  rot_mul(mctr1, mcrotakidney_channel_4, mcrotachannel_4_cave1_box2);
  rot_transpose(mcrotachannel_4_cave1_box1, mctr1);
  rot_mul(mcrotachannel_4_cave1_box2, mctr1, mcrotrchannel_4_cave1_box2);
  mctc1 = coords_set(
#line 1375 "MACS_sample_kidney_box.instr"
    kidney_cave1_box2_x_offset,
#line 1375 "MACS_sample_kidney_box.instr"
    0,
#line 1375 "MACS_sample_kidney_box.instr"
    kidney_cave1_box2_center_to_target);
#line 107148 "MACS_sample_kidney_box.c"
  rot_transpose(mcrotakidney_channel_4, mctr1);
  mctc2 = rot_apply(mctr1, mctc1);
  mcposachannel_4_cave1_box2 = coords_add(mcposakidney_channel_4, mctc2);
  mctc1 = coords_sub(mcposachannel_4_cave1_box1, mcposachannel_4_cave1_box2);
  mcposrchannel_4_cave1_box2 = rot_apply(mcrotachannel_4_cave1_box2, mctc1);
  mcDEBUG_COMPONENT("channel_4_cave1_box2", mcposachannel_4_cave1_box2, mcrotachannel_4_cave1_box2)
  mccomp_posa[277] = mcposachannel_4_cave1_box2;
  mccomp_posr[277] = mcposrchannel_4_cave1_box2;
  mcNCounter[277]  = mcPCounter[277] = mcP2Counter[277] = 0;
  mcAbsorbProp[277]= 0;
    /* Component channel_4_cave1_box3. */
  /* Setting parameters for component channel_4_cave1_box3. */
  SIG_MESSAGE("channel_4_cave1_box3 (Init:SetPar)");
#line 1381 "MACS_sample_kidney_box.instr"
  if("Vacuum") strncpy(mccchannel_4_cave1_box3_material_string, "Vacuum" ? "Vacuum" : "", 16384); else mccchannel_4_cave1_box3_material_string[0]='\0';
#line 1381 "MACS_sample_kidney_box.instr"
  mccchannel_4_cave1_box3_priority = 602;
#line 1379 "MACS_sample_kidney_box.instr"
  mccchannel_4_cave1_box3_xwidth = kidney_cave1_box3_width1;
#line 1379 "MACS_sample_kidney_box.instr"
  mccchannel_4_cave1_box3_yheight = kidney_cave1_box3_height1;
#line 1379 "MACS_sample_kidney_box.instr"
  mccchannel_4_cave1_box3_zdepth = kidney_cave1_box3_depth;
#line 1380 "MACS_sample_kidney_box.instr"
  mccchannel_4_cave1_box3_xwidth2 = kidney_cave1_box3_width2;
#line 1380 "MACS_sample_kidney_box.instr"
  mccchannel_4_cave1_box3_yheight2 = kidney_cave1_box3_height2;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_4_cave1_box3_visualize = 1;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_4_cave1_box3_target_index = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_4_cave1_box3_target_x = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_4_cave1_box3_target_y = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_4_cave1_box3_target_z = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_4_cave1_box3_focus_aw = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_4_cave1_box3_focus_ah = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_4_cave1_box3_focus_xw = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_4_cave1_box3_focus_xh = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_4_cave1_box3_focus_r = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_4_cave1_box3_p_interact = 0;
#line 71 "MACS_sample_kidney_box.instr"
  if(0) strncpy(mccchannel_4_cave1_box3_mask_string, 0 ? 0 : "", 16384); else mccchannel_4_cave1_box3_mask_string[0]='\0';
#line 71 "MACS_sample_kidney_box.instr"
  if(0) strncpy(mccchannel_4_cave1_box3_mask_setting, 0 ? 0 : "", 16384); else mccchannel_4_cave1_box3_mask_setting[0]='\0';
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_4_cave1_box3_number_of_activations = 1;
#line 107204 "MACS_sample_kidney_box.c"

  SIG_MESSAGE("channel_4_cave1_box3 (Init:Place/Rotate)");
  rot_set_rotation(mctr1,
#line 1383 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 1383 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 1383 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD);
#line 107214 "MACS_sample_kidney_box.c"
  rot_mul(mctr1, mcrotakidney_channel_4, mcrotachannel_4_cave1_box3);
  rot_transpose(mcrotachannel_4_cave1_box2, mctr1);
  rot_mul(mcrotachannel_4_cave1_box3, mctr1, mcrotrchannel_4_cave1_box3);
  mctc1 = coords_set(
#line 1382 "MACS_sample_kidney_box.instr"
    0,
#line 1382 "MACS_sample_kidney_box.instr"
    0,
#line 1382 "MACS_sample_kidney_box.instr"
    kidney_cave1_box3_center_to_target);
#line 107225 "MACS_sample_kidney_box.c"
  rot_transpose(mcrotakidney_channel_4, mctr1);
  mctc2 = rot_apply(mctr1, mctc1);
  mcposachannel_4_cave1_box3 = coords_add(mcposakidney_channel_4, mctc2);
  mctc1 = coords_sub(mcposachannel_4_cave1_box2, mcposachannel_4_cave1_box3);
  mcposrchannel_4_cave1_box3 = rot_apply(mcrotachannel_4_cave1_box3, mctc1);
  mcDEBUG_COMPONENT("channel_4_cave1_box3", mcposachannel_4_cave1_box3, mcrotachannel_4_cave1_box3)
  mccomp_posa[278] = mcposachannel_4_cave1_box3;
  mccomp_posr[278] = mcposrchannel_4_cave1_box3;
  mcNCounter[278]  = mcPCounter[278] = mcP2Counter[278] = 0;
  mcAbsorbProp[278]= 0;
    /* Component channel_4_cave1_cyl1. */
  /* Setting parameters for component channel_4_cave1_cyl1. */
  SIG_MESSAGE("channel_4_cave1_cyl1 (Init:SetPar)");
#line 1387 "MACS_sample_kidney_box.instr"
  if("Vacuum") strncpy(mccchannel_4_cave1_cyl1_material_string, "Vacuum" ? "Vacuum" : "", 16384); else mccchannel_4_cave1_cyl1_material_string[0]='\0';
#line 1387 "MACS_sample_kidney_box.instr"
  mccchannel_4_cave1_cyl1_priority = 603;
#line 1386 "MACS_sample_kidney_box.instr"
  mccchannel_4_cave1_cyl1_radius = kidney_cave1_cyl1_radius;
#line 1386 "MACS_sample_kidney_box.instr"
  mccchannel_4_cave1_cyl1_yheight = kidney_cave1_cyl1_height;
#line 67 "MACS_sample_kidney_box.instr"
  mccchannel_4_cave1_cyl1_visualize = 1;
#line 67 "MACS_sample_kidney_box.instr"
  mccchannel_4_cave1_cyl1_target_index = 0;
#line 67 "MACS_sample_kidney_box.instr"
  mccchannel_4_cave1_cyl1_target_x = 0;
#line 67 "MACS_sample_kidney_box.instr"
  mccchannel_4_cave1_cyl1_target_y = 0;
#line 67 "MACS_sample_kidney_box.instr"
  mccchannel_4_cave1_cyl1_target_z = 0;
#line 67 "MACS_sample_kidney_box.instr"
  mccchannel_4_cave1_cyl1_focus_aw = 0;
#line 67 "MACS_sample_kidney_box.instr"
  mccchannel_4_cave1_cyl1_focus_ah = 0;
#line 67 "MACS_sample_kidney_box.instr"
  mccchannel_4_cave1_cyl1_focus_xw = 0;
#line 67 "MACS_sample_kidney_box.instr"
  mccchannel_4_cave1_cyl1_focus_xh = 0;
#line 67 "MACS_sample_kidney_box.instr"
  mccchannel_4_cave1_cyl1_focus_r = 0;
#line 67 "MACS_sample_kidney_box.instr"
  mccchannel_4_cave1_cyl1_p_interact = 0;
#line 67 "MACS_sample_kidney_box.instr"
  if(0) strncpy(mccchannel_4_cave1_cyl1_mask_string, 0 ? 0 : "", 16384); else mccchannel_4_cave1_cyl1_mask_string[0]='\0';
#line 67 "MACS_sample_kidney_box.instr"
  if(0) strncpy(mccchannel_4_cave1_cyl1_mask_setting, 0 ? 0 : "", 16384); else mccchannel_4_cave1_cyl1_mask_setting[0]='\0';
#line 67 "MACS_sample_kidney_box.instr"
  mccchannel_4_cave1_cyl1_number_of_activations = 1;
#line 107275 "MACS_sample_kidney_box.c"

  SIG_MESSAGE("channel_4_cave1_cyl1 (Init:Place/Rotate)");
  rot_set_rotation(mctr1,
#line 1389 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 1389 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 1389 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD);
#line 107285 "MACS_sample_kidney_box.c"
  rot_mul(mctr1, mcrotakidney_channel_4, mcrotachannel_4_cave1_cyl1);
  rot_transpose(mcrotachannel_4_cave1_box3, mctr1);
  rot_mul(mcrotachannel_4_cave1_cyl1, mctr1, mcrotrchannel_4_cave1_cyl1);
  mctc1 = coords_set(
#line 1388 "MACS_sample_kidney_box.instr"
    0,
#line 1388 "MACS_sample_kidney_box.instr"
    0,
#line 1388 "MACS_sample_kidney_box.instr"
    kidney_cave1_cyl1_center_to_target);
#line 107296 "MACS_sample_kidney_box.c"
  rot_transpose(mcrotakidney_channel_4, mctr1);
  mctc2 = rot_apply(mctr1, mctc1);
  mcposachannel_4_cave1_cyl1 = coords_add(mcposakidney_channel_4, mctc2);
  mctc1 = coords_sub(mcposachannel_4_cave1_box3, mcposachannel_4_cave1_cyl1);
  mcposrchannel_4_cave1_cyl1 = rot_apply(mcrotachannel_4_cave1_cyl1, mctc1);
  mcDEBUG_COMPONENT("channel_4_cave1_cyl1", mcposachannel_4_cave1_cyl1, mcrotachannel_4_cave1_cyl1)
  mccomp_posa[279] = mcposachannel_4_cave1_cyl1;
  mccomp_posr[279] = mcposrchannel_4_cave1_cyl1;
  mcNCounter[279]  = mcPCounter[279] = mcP2Counter[279] = 0;
  mcAbsorbProp[279]= 0;
    /* Component channel_4_analyzer_1_center. */
  /* Setting parameters for component channel_4_analyzer_1_center. */
  SIG_MESSAGE("channel_4_analyzer_1_center (Init:SetPar)");

  SIG_MESSAGE("channel_4_analyzer_1_center (Init:Place/Rotate)");
  rot_set_rotation(mctr1,
    (0.0)*DEG2RAD,
    (0.0)*DEG2RAD,
    (0.0)*DEG2RAD);
#line 107316 "MACS_sample_kidney_box.c"
  rot_mul(mctr1, mcrotakidney_channel_4, mcrotachannel_4_analyzer_1_center);
  rot_transpose(mcrotachannel_4_cave1_cyl1, mctr1);
  rot_mul(mcrotachannel_4_analyzer_1_center, mctr1, mcrotrchannel_4_analyzer_1_center);
  mctc1 = coords_set(
#line 1393 "MACS_sample_kidney_box.instr"
    0,
#line 1393 "MACS_sample_kidney_box.instr"
    0,
#line 1393 "MACS_sample_kidney_box.instr"
    analyzer_1_center_to_sample);
#line 107327 "MACS_sample_kidney_box.c"
  rot_transpose(mcrotakidney_channel_4, mctr1);
  mctc2 = rot_apply(mctr1, mctc1);
  mcposachannel_4_analyzer_1_center = coords_add(mcposakidney_channel_4, mctc2);
  mctc1 = coords_sub(mcposachannel_4_cave1_cyl1, mcposachannel_4_analyzer_1_center);
  mcposrchannel_4_analyzer_1_center = rot_apply(mcrotachannel_4_analyzer_1_center, mctc1);
  mcDEBUG_COMPONENT("channel_4_analyzer_1_center", mcposachannel_4_analyzer_1_center, mcrotachannel_4_analyzer_1_center)
  mccomp_posa[280] = mcposachannel_4_analyzer_1_center;
  mccomp_posr[280] = mcposrchannel_4_analyzer_1_center;
  mcNCounter[280]  = mcPCounter[280] = mcP2Counter[280] = 0;
  mcAbsorbProp[280]= 0;
    /* Component channel_4_analyzer_1_rotated. */
  /* Setting parameters for component channel_4_analyzer_1_rotated. */
  SIG_MESSAGE("channel_4_analyzer_1_rotated (Init:SetPar)");

  SIG_MESSAGE("channel_4_analyzer_1_rotated (Init:Place/Rotate)");
  rot_set_rotation(mctr1,
#line 1397 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 1397 "MACS_sample_kidney_box.instr"
    (180 - analyzer_theta [ 4 ])*DEG2RAD,
#line 1397 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD);
#line 107350 "MACS_sample_kidney_box.c"
  rot_mul(mctr1, mcrotachannel_4_analyzer_1_center, mcrotachannel_4_analyzer_1_rotated);
  rot_transpose(mcrotachannel_4_analyzer_1_center, mctr1);
  rot_mul(mcrotachannel_4_analyzer_1_rotated, mctr1, mcrotrchannel_4_analyzer_1_rotated);
  mctc1 = coords_set(
#line 1396 "MACS_sample_kidney_box.instr"
    0,
#line 1396 "MACS_sample_kidney_box.instr"
    0,
#line 1396 "MACS_sample_kidney_box.instr"
    -0.5 * analyzer_seperation / tan ( analyzer_2theta [ 4 ] * DEG2RAD ));
#line 107361 "MACS_sample_kidney_box.c"
  rot_transpose(mcrotachannel_4_analyzer_1_center, mctr1);
  mctc2 = rot_apply(mctr1, mctc1);
  mcposachannel_4_analyzer_1_rotated = coords_add(mcposachannel_4_analyzer_1_center, mctc2);
  mctc1 = coords_sub(mcposachannel_4_analyzer_1_center, mcposachannel_4_analyzer_1_rotated);
  mcposrchannel_4_analyzer_1_rotated = rot_apply(mcrotachannel_4_analyzer_1_rotated, mctc1);
  mcDEBUG_COMPONENT("channel_4_analyzer_1_rotated", mcposachannel_4_analyzer_1_rotated, mcrotachannel_4_analyzer_1_rotated)
  mccomp_posa[281] = mcposachannel_4_analyzer_1_rotated;
  mccomp_posr[281] = mcposrchannel_4_analyzer_1_rotated;
  mcNCounter[281]  = mcPCounter[281] = mcP2Counter[281] = 0;
  mcAbsorbProp[281]= 0;
    /* Component channel_4_analyzer_1_array_crystal_array_0. */
  /* Setting parameters for component channel_4_analyzer_1_array_crystal_array_0. */
  SIG_MESSAGE("channel_4_analyzer_1_array_crystal_array_0 (Init:SetPar)");
#line 1401 "MACS_sample_kidney_box.instr"
  if("PG_analyzer") strncpy(mccchannel_4_analyzer_1_array_crystal_array_0_material_string, "PG_analyzer" ? "PG_analyzer" : "", 16384); else mccchannel_4_analyzer_1_array_crystal_array_0_material_string[0]='\0';
#line 1401 "MACS_sample_kidney_box.instr"
  mccchannel_4_analyzer_1_array_crystal_array_0_priority = 620.0;
#line 1400 "MACS_sample_kidney_box.instr"
  mccchannel_4_analyzer_1_array_crystal_array_0_xwidth = channel_4_analyzer_1_array_crystal_depth;
#line 1400 "MACS_sample_kidney_box.instr"
  mccchannel_4_analyzer_1_array_crystal_array_0_yheight = channel_4_analyzer_1_array_crystal_height;
#line 1400 "MACS_sample_kidney_box.instr"
  mccchannel_4_analyzer_1_array_crystal_array_0_zdepth = channel_4_analyzer_1_array_crystal_width;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_4_analyzer_1_array_crystal_array_0_xwidth2 = -1;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_4_analyzer_1_array_crystal_array_0_yheight2 = -1;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_4_analyzer_1_array_crystal_array_0_visualize = 1;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_4_analyzer_1_array_crystal_array_0_target_index = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_4_analyzer_1_array_crystal_array_0_target_x = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_4_analyzer_1_array_crystal_array_0_target_y = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_4_analyzer_1_array_crystal_array_0_target_z = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_4_analyzer_1_array_crystal_array_0_focus_aw = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_4_analyzer_1_array_crystal_array_0_focus_ah = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_4_analyzer_1_array_crystal_array_0_focus_xw = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_4_analyzer_1_array_crystal_array_0_focus_xh = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_4_analyzer_1_array_crystal_array_0_focus_r = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_4_analyzer_1_array_crystal_array_0_p_interact = 0;
#line 71 "MACS_sample_kidney_box.instr"
  if(0) strncpy(mccchannel_4_analyzer_1_array_crystal_array_0_mask_string, 0 ? 0 : "", 16384); else mccchannel_4_analyzer_1_array_crystal_array_0_mask_string[0]='\0';
#line 71 "MACS_sample_kidney_box.instr"
  if(0) strncpy(mccchannel_4_analyzer_1_array_crystal_array_0_mask_setting, 0 ? 0 : "", 16384); else mccchannel_4_analyzer_1_array_crystal_array_0_mask_setting[0]='\0';
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_4_analyzer_1_array_crystal_array_0_number_of_activations = 1;
#line 107417 "MACS_sample_kidney_box.c"

  SIG_MESSAGE("channel_4_analyzer_1_array_crystal_array_0 (Init:Place/Rotate)");
  rot_set_rotation(mctr1,
#line 1403 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 1403 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 1403 "MACS_sample_kidney_box.instr"
    (0 - RAD2DEG * channel_4_analyzer_1_array_theta [ 0 ])*DEG2RAD);
#line 107427 "MACS_sample_kidney_box.c"
  rot_mul(mctr1, mcrotachannel_4_analyzer_1_rotated, mcrotachannel_4_analyzer_1_array_crystal_array_0);
  rot_transpose(mcrotachannel_4_analyzer_1_rotated, mctr1);
  rot_mul(mcrotachannel_4_analyzer_1_array_crystal_array_0, mctr1, mcrotrchannel_4_analyzer_1_array_crystal_array_0);
  mctc1 = coords_set(
#line 1402 "MACS_sample_kidney_box.instr"
    0 + channel_4_analyzer_1_array_effective_radius_of_curvature * ( 1 - cos ( channel_4_analyzer_1_array_theta [ 0 ] ) ),
#line 1402 "MACS_sample_kidney_box.instr"
    0 + channel_4_analyzer_1_array_effective_radius_of_curvature * sin ( channel_4_analyzer_1_array_theta [ 0 ] ),
#line 1402 "MACS_sample_kidney_box.instr"
    0);
#line 107438 "MACS_sample_kidney_box.c"
  rot_transpose(mcrotachannel_4_analyzer_1_rotated, mctr1);
  mctc2 = rot_apply(mctr1, mctc1);
  mcposachannel_4_analyzer_1_array_crystal_array_0 = coords_add(mcposachannel_4_analyzer_1_rotated, mctc2);
  mctc1 = coords_sub(mcposachannel_4_analyzer_1_rotated, mcposachannel_4_analyzer_1_array_crystal_array_0);
  mcposrchannel_4_analyzer_1_array_crystal_array_0 = rot_apply(mcrotachannel_4_analyzer_1_array_crystal_array_0, mctc1);
  mcDEBUG_COMPONENT("channel_4_analyzer_1_array_crystal_array_0", mcposachannel_4_analyzer_1_array_crystal_array_0, mcrotachannel_4_analyzer_1_array_crystal_array_0)
  mccomp_posa[282] = mcposachannel_4_analyzer_1_array_crystal_array_0;
  mccomp_posr[282] = mcposrchannel_4_analyzer_1_array_crystal_array_0;
  mcNCounter[282]  = mcPCounter[282] = mcP2Counter[282] = 0;
  mcAbsorbProp[282]= 0;
    /* Component channel_4_analyzer_1_array_crystal_array_1. */
  /* Setting parameters for component channel_4_analyzer_1_array_crystal_array_1. */
  SIG_MESSAGE("channel_4_analyzer_1_array_crystal_array_1 (Init:SetPar)");
#line 1407 "MACS_sample_kidney_box.instr"
  if("PG_analyzer") strncpy(mccchannel_4_analyzer_1_array_crystal_array_1_material_string, "PG_analyzer" ? "PG_analyzer" : "", 16384); else mccchannel_4_analyzer_1_array_crystal_array_1_material_string[0]='\0';
#line 1407 "MACS_sample_kidney_box.instr"
  mccchannel_4_analyzer_1_array_crystal_array_1_priority = 620.1;
#line 1406 "MACS_sample_kidney_box.instr"
  mccchannel_4_analyzer_1_array_crystal_array_1_xwidth = channel_4_analyzer_1_array_crystal_depth;
#line 1406 "MACS_sample_kidney_box.instr"
  mccchannel_4_analyzer_1_array_crystal_array_1_yheight = channel_4_analyzer_1_array_crystal_height;
#line 1406 "MACS_sample_kidney_box.instr"
  mccchannel_4_analyzer_1_array_crystal_array_1_zdepth = channel_4_analyzer_1_array_crystal_width;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_4_analyzer_1_array_crystal_array_1_xwidth2 = -1;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_4_analyzer_1_array_crystal_array_1_yheight2 = -1;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_4_analyzer_1_array_crystal_array_1_visualize = 1;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_4_analyzer_1_array_crystal_array_1_target_index = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_4_analyzer_1_array_crystal_array_1_target_x = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_4_analyzer_1_array_crystal_array_1_target_y = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_4_analyzer_1_array_crystal_array_1_target_z = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_4_analyzer_1_array_crystal_array_1_focus_aw = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_4_analyzer_1_array_crystal_array_1_focus_ah = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_4_analyzer_1_array_crystal_array_1_focus_xw = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_4_analyzer_1_array_crystal_array_1_focus_xh = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_4_analyzer_1_array_crystal_array_1_focus_r = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_4_analyzer_1_array_crystal_array_1_p_interact = 0;
#line 71 "MACS_sample_kidney_box.instr"
  if(0) strncpy(mccchannel_4_analyzer_1_array_crystal_array_1_mask_string, 0 ? 0 : "", 16384); else mccchannel_4_analyzer_1_array_crystal_array_1_mask_string[0]='\0';
#line 71 "MACS_sample_kidney_box.instr"
  if(0) strncpy(mccchannel_4_analyzer_1_array_crystal_array_1_mask_setting, 0 ? 0 : "", 16384); else mccchannel_4_analyzer_1_array_crystal_array_1_mask_setting[0]='\0';
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_4_analyzer_1_array_crystal_array_1_number_of_activations = 1;
#line 107494 "MACS_sample_kidney_box.c"

  SIG_MESSAGE("channel_4_analyzer_1_array_crystal_array_1 (Init:Place/Rotate)");
  rot_set_rotation(mctr1,
#line 1409 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 1409 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 1409 "MACS_sample_kidney_box.instr"
    (0 - RAD2DEG * channel_4_analyzer_1_array_theta [ 1 ])*DEG2RAD);
#line 107504 "MACS_sample_kidney_box.c"
  rot_mul(mctr1, mcrotachannel_4_analyzer_1_rotated, mcrotachannel_4_analyzer_1_array_crystal_array_1);
  rot_transpose(mcrotachannel_4_analyzer_1_array_crystal_array_0, mctr1);
  rot_mul(mcrotachannel_4_analyzer_1_array_crystal_array_1, mctr1, mcrotrchannel_4_analyzer_1_array_crystal_array_1);
  mctc1 = coords_set(
#line 1408 "MACS_sample_kidney_box.instr"
    0 + channel_4_analyzer_1_array_effective_radius_of_curvature * ( 1 - cos ( channel_4_analyzer_1_array_theta [ 1 ] ) ),
#line 1408 "MACS_sample_kidney_box.instr"
    0 + channel_4_analyzer_1_array_effective_radius_of_curvature * sin ( channel_4_analyzer_1_array_theta [ 1 ] ),
#line 1408 "MACS_sample_kidney_box.instr"
    0);
#line 107515 "MACS_sample_kidney_box.c"
  rot_transpose(mcrotachannel_4_analyzer_1_rotated, mctr1);
  mctc2 = rot_apply(mctr1, mctc1);
  mcposachannel_4_analyzer_1_array_crystal_array_1 = coords_add(mcposachannel_4_analyzer_1_rotated, mctc2);
  mctc1 = coords_sub(mcposachannel_4_analyzer_1_array_crystal_array_0, mcposachannel_4_analyzer_1_array_crystal_array_1);
  mcposrchannel_4_analyzer_1_array_crystal_array_1 = rot_apply(mcrotachannel_4_analyzer_1_array_crystal_array_1, mctc1);
  mcDEBUG_COMPONENT("channel_4_analyzer_1_array_crystal_array_1", mcposachannel_4_analyzer_1_array_crystal_array_1, mcrotachannel_4_analyzer_1_array_crystal_array_1)
  mccomp_posa[283] = mcposachannel_4_analyzer_1_array_crystal_array_1;
  mccomp_posr[283] = mcposrchannel_4_analyzer_1_array_crystal_array_1;
  mcNCounter[283]  = mcPCounter[283] = mcP2Counter[283] = 0;
  mcAbsorbProp[283]= 0;
    /* Component channel_4_analyzer_1_array_crystal_array_2. */
  /* Setting parameters for component channel_4_analyzer_1_array_crystal_array_2. */
  SIG_MESSAGE("channel_4_analyzer_1_array_crystal_array_2 (Init:SetPar)");
#line 1413 "MACS_sample_kidney_box.instr"
  if("PG_analyzer") strncpy(mccchannel_4_analyzer_1_array_crystal_array_2_material_string, "PG_analyzer" ? "PG_analyzer" : "", 16384); else mccchannel_4_analyzer_1_array_crystal_array_2_material_string[0]='\0';
#line 1413 "MACS_sample_kidney_box.instr"
  mccchannel_4_analyzer_1_array_crystal_array_2_priority = 620.2;
#line 1412 "MACS_sample_kidney_box.instr"
  mccchannel_4_analyzer_1_array_crystal_array_2_xwidth = channel_4_analyzer_1_array_crystal_depth;
#line 1412 "MACS_sample_kidney_box.instr"
  mccchannel_4_analyzer_1_array_crystal_array_2_yheight = channel_4_analyzer_1_array_crystal_height;
#line 1412 "MACS_sample_kidney_box.instr"
  mccchannel_4_analyzer_1_array_crystal_array_2_zdepth = channel_4_analyzer_1_array_crystal_width;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_4_analyzer_1_array_crystal_array_2_xwidth2 = -1;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_4_analyzer_1_array_crystal_array_2_yheight2 = -1;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_4_analyzer_1_array_crystal_array_2_visualize = 1;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_4_analyzer_1_array_crystal_array_2_target_index = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_4_analyzer_1_array_crystal_array_2_target_x = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_4_analyzer_1_array_crystal_array_2_target_y = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_4_analyzer_1_array_crystal_array_2_target_z = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_4_analyzer_1_array_crystal_array_2_focus_aw = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_4_analyzer_1_array_crystal_array_2_focus_ah = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_4_analyzer_1_array_crystal_array_2_focus_xw = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_4_analyzer_1_array_crystal_array_2_focus_xh = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_4_analyzer_1_array_crystal_array_2_focus_r = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_4_analyzer_1_array_crystal_array_2_p_interact = 0;
#line 71 "MACS_sample_kidney_box.instr"
  if(0) strncpy(mccchannel_4_analyzer_1_array_crystal_array_2_mask_string, 0 ? 0 : "", 16384); else mccchannel_4_analyzer_1_array_crystal_array_2_mask_string[0]='\0';
#line 71 "MACS_sample_kidney_box.instr"
  if(0) strncpy(mccchannel_4_analyzer_1_array_crystal_array_2_mask_setting, 0 ? 0 : "", 16384); else mccchannel_4_analyzer_1_array_crystal_array_2_mask_setting[0]='\0';
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_4_analyzer_1_array_crystal_array_2_number_of_activations = 1;
#line 107571 "MACS_sample_kidney_box.c"

  SIG_MESSAGE("channel_4_analyzer_1_array_crystal_array_2 (Init:Place/Rotate)");
  rot_set_rotation(mctr1,
#line 1415 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 1415 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 1415 "MACS_sample_kidney_box.instr"
    (0 - RAD2DEG * channel_4_analyzer_1_array_theta [ 2 ])*DEG2RAD);
#line 107581 "MACS_sample_kidney_box.c"
  rot_mul(mctr1, mcrotachannel_4_analyzer_1_rotated, mcrotachannel_4_analyzer_1_array_crystal_array_2);
  rot_transpose(mcrotachannel_4_analyzer_1_array_crystal_array_1, mctr1);
  rot_mul(mcrotachannel_4_analyzer_1_array_crystal_array_2, mctr1, mcrotrchannel_4_analyzer_1_array_crystal_array_2);
  mctc1 = coords_set(
#line 1414 "MACS_sample_kidney_box.instr"
    0 + channel_4_analyzer_1_array_effective_radius_of_curvature * ( 1 - cos ( channel_4_analyzer_1_array_theta [ 2 ] ) ),
#line 1414 "MACS_sample_kidney_box.instr"
    0 + channel_4_analyzer_1_array_effective_radius_of_curvature * sin ( channel_4_analyzer_1_array_theta [ 2 ] ),
#line 1414 "MACS_sample_kidney_box.instr"
    0);
#line 107592 "MACS_sample_kidney_box.c"
  rot_transpose(mcrotachannel_4_analyzer_1_rotated, mctr1);
  mctc2 = rot_apply(mctr1, mctc1);
  mcposachannel_4_analyzer_1_array_crystal_array_2 = coords_add(mcposachannel_4_analyzer_1_rotated, mctc2);
  mctc1 = coords_sub(mcposachannel_4_analyzer_1_array_crystal_array_1, mcposachannel_4_analyzer_1_array_crystal_array_2);
  mcposrchannel_4_analyzer_1_array_crystal_array_2 = rot_apply(mcrotachannel_4_analyzer_1_array_crystal_array_2, mctc1);
  mcDEBUG_COMPONENT("channel_4_analyzer_1_array_crystal_array_2", mcposachannel_4_analyzer_1_array_crystal_array_2, mcrotachannel_4_analyzer_1_array_crystal_array_2)
  mccomp_posa[284] = mcposachannel_4_analyzer_1_array_crystal_array_2;
  mccomp_posr[284] = mcposrchannel_4_analyzer_1_array_crystal_array_2;
  mcNCounter[284]  = mcPCounter[284] = mcP2Counter[284] = 0;
  mcAbsorbProp[284]= 0;
    /* Component channel_4_analyzer_1_array_crystal_array_3. */
  /* Setting parameters for component channel_4_analyzer_1_array_crystal_array_3. */
  SIG_MESSAGE("channel_4_analyzer_1_array_crystal_array_3 (Init:SetPar)");
#line 1419 "MACS_sample_kidney_box.instr"
  if("PG_analyzer") strncpy(mccchannel_4_analyzer_1_array_crystal_array_3_material_string, "PG_analyzer" ? "PG_analyzer" : "", 16384); else mccchannel_4_analyzer_1_array_crystal_array_3_material_string[0]='\0';
#line 1419 "MACS_sample_kidney_box.instr"
  mccchannel_4_analyzer_1_array_crystal_array_3_priority = 620.3;
#line 1418 "MACS_sample_kidney_box.instr"
  mccchannel_4_analyzer_1_array_crystal_array_3_xwidth = channel_4_analyzer_1_array_crystal_depth;
#line 1418 "MACS_sample_kidney_box.instr"
  mccchannel_4_analyzer_1_array_crystal_array_3_yheight = channel_4_analyzer_1_array_crystal_height;
#line 1418 "MACS_sample_kidney_box.instr"
  mccchannel_4_analyzer_1_array_crystal_array_3_zdepth = channel_4_analyzer_1_array_crystal_width;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_4_analyzer_1_array_crystal_array_3_xwidth2 = -1;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_4_analyzer_1_array_crystal_array_3_yheight2 = -1;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_4_analyzer_1_array_crystal_array_3_visualize = 1;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_4_analyzer_1_array_crystal_array_3_target_index = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_4_analyzer_1_array_crystal_array_3_target_x = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_4_analyzer_1_array_crystal_array_3_target_y = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_4_analyzer_1_array_crystal_array_3_target_z = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_4_analyzer_1_array_crystal_array_3_focus_aw = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_4_analyzer_1_array_crystal_array_3_focus_ah = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_4_analyzer_1_array_crystal_array_3_focus_xw = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_4_analyzer_1_array_crystal_array_3_focus_xh = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_4_analyzer_1_array_crystal_array_3_focus_r = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_4_analyzer_1_array_crystal_array_3_p_interact = 0;
#line 71 "MACS_sample_kidney_box.instr"
  if(0) strncpy(mccchannel_4_analyzer_1_array_crystal_array_3_mask_string, 0 ? 0 : "", 16384); else mccchannel_4_analyzer_1_array_crystal_array_3_mask_string[0]='\0';
#line 71 "MACS_sample_kidney_box.instr"
  if(0) strncpy(mccchannel_4_analyzer_1_array_crystal_array_3_mask_setting, 0 ? 0 : "", 16384); else mccchannel_4_analyzer_1_array_crystal_array_3_mask_setting[0]='\0';
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_4_analyzer_1_array_crystal_array_3_number_of_activations = 1;
#line 107648 "MACS_sample_kidney_box.c"

  SIG_MESSAGE("channel_4_analyzer_1_array_crystal_array_3 (Init:Place/Rotate)");
  rot_set_rotation(mctr1,
#line 1421 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 1421 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 1421 "MACS_sample_kidney_box.instr"
    (0 - RAD2DEG * channel_4_analyzer_1_array_theta [ 3 ])*DEG2RAD);
#line 107658 "MACS_sample_kidney_box.c"
  rot_mul(mctr1, mcrotachannel_4_analyzer_1_rotated, mcrotachannel_4_analyzer_1_array_crystal_array_3);
  rot_transpose(mcrotachannel_4_analyzer_1_array_crystal_array_2, mctr1);
  rot_mul(mcrotachannel_4_analyzer_1_array_crystal_array_3, mctr1, mcrotrchannel_4_analyzer_1_array_crystal_array_3);
  mctc1 = coords_set(
#line 1420 "MACS_sample_kidney_box.instr"
    0 + channel_4_analyzer_1_array_effective_radius_of_curvature * ( 1 - cos ( channel_4_analyzer_1_array_theta [ 3 ] ) ),
#line 1420 "MACS_sample_kidney_box.instr"
    0 + channel_4_analyzer_1_array_effective_radius_of_curvature * sin ( channel_4_analyzer_1_array_theta [ 3 ] ),
#line 1420 "MACS_sample_kidney_box.instr"
    0);
#line 107669 "MACS_sample_kidney_box.c"
  rot_transpose(mcrotachannel_4_analyzer_1_rotated, mctr1);
  mctc2 = rot_apply(mctr1, mctc1);
  mcposachannel_4_analyzer_1_array_crystal_array_3 = coords_add(mcposachannel_4_analyzer_1_rotated, mctc2);
  mctc1 = coords_sub(mcposachannel_4_analyzer_1_array_crystal_array_2, mcposachannel_4_analyzer_1_array_crystal_array_3);
  mcposrchannel_4_analyzer_1_array_crystal_array_3 = rot_apply(mcrotachannel_4_analyzer_1_array_crystal_array_3, mctc1);
  mcDEBUG_COMPONENT("channel_4_analyzer_1_array_crystal_array_3", mcposachannel_4_analyzer_1_array_crystal_array_3, mcrotachannel_4_analyzer_1_array_crystal_array_3)
  mccomp_posa[285] = mcposachannel_4_analyzer_1_array_crystal_array_3;
  mccomp_posr[285] = mcposrchannel_4_analyzer_1_array_crystal_array_3;
  mcNCounter[285]  = mcPCounter[285] = mcP2Counter[285] = 0;
  mcAbsorbProp[285]= 0;
    /* Component channel_4_analyzer_1_array_crystal_array_4. */
  /* Setting parameters for component channel_4_analyzer_1_array_crystal_array_4. */
  SIG_MESSAGE("channel_4_analyzer_1_array_crystal_array_4 (Init:SetPar)");
#line 1425 "MACS_sample_kidney_box.instr"
  if("PG_analyzer") strncpy(mccchannel_4_analyzer_1_array_crystal_array_4_material_string, "PG_analyzer" ? "PG_analyzer" : "", 16384); else mccchannel_4_analyzer_1_array_crystal_array_4_material_string[0]='\0';
#line 1425 "MACS_sample_kidney_box.instr"
  mccchannel_4_analyzer_1_array_crystal_array_4_priority = 620.4;
#line 1424 "MACS_sample_kidney_box.instr"
  mccchannel_4_analyzer_1_array_crystal_array_4_xwidth = channel_4_analyzer_1_array_crystal_depth;
#line 1424 "MACS_sample_kidney_box.instr"
  mccchannel_4_analyzer_1_array_crystal_array_4_yheight = channel_4_analyzer_1_array_crystal_height;
#line 1424 "MACS_sample_kidney_box.instr"
  mccchannel_4_analyzer_1_array_crystal_array_4_zdepth = channel_4_analyzer_1_array_crystal_width;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_4_analyzer_1_array_crystal_array_4_xwidth2 = -1;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_4_analyzer_1_array_crystal_array_4_yheight2 = -1;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_4_analyzer_1_array_crystal_array_4_visualize = 1;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_4_analyzer_1_array_crystal_array_4_target_index = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_4_analyzer_1_array_crystal_array_4_target_x = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_4_analyzer_1_array_crystal_array_4_target_y = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_4_analyzer_1_array_crystal_array_4_target_z = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_4_analyzer_1_array_crystal_array_4_focus_aw = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_4_analyzer_1_array_crystal_array_4_focus_ah = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_4_analyzer_1_array_crystal_array_4_focus_xw = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_4_analyzer_1_array_crystal_array_4_focus_xh = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_4_analyzer_1_array_crystal_array_4_focus_r = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_4_analyzer_1_array_crystal_array_4_p_interact = 0;
#line 71 "MACS_sample_kidney_box.instr"
  if(0) strncpy(mccchannel_4_analyzer_1_array_crystal_array_4_mask_string, 0 ? 0 : "", 16384); else mccchannel_4_analyzer_1_array_crystal_array_4_mask_string[0]='\0';
#line 71 "MACS_sample_kidney_box.instr"
  if(0) strncpy(mccchannel_4_analyzer_1_array_crystal_array_4_mask_setting, 0 ? 0 : "", 16384); else mccchannel_4_analyzer_1_array_crystal_array_4_mask_setting[0]='\0';
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_4_analyzer_1_array_crystal_array_4_number_of_activations = 1;
#line 107725 "MACS_sample_kidney_box.c"

  SIG_MESSAGE("channel_4_analyzer_1_array_crystal_array_4 (Init:Place/Rotate)");
  rot_set_rotation(mctr1,
#line 1427 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 1427 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 1427 "MACS_sample_kidney_box.instr"
    (0 - RAD2DEG * channel_4_analyzer_1_array_theta [ 4 ])*DEG2RAD);
#line 107735 "MACS_sample_kidney_box.c"
  rot_mul(mctr1, mcrotachannel_4_analyzer_1_rotated, mcrotachannel_4_analyzer_1_array_crystal_array_4);
  rot_transpose(mcrotachannel_4_analyzer_1_array_crystal_array_3, mctr1);
  rot_mul(mcrotachannel_4_analyzer_1_array_crystal_array_4, mctr1, mcrotrchannel_4_analyzer_1_array_crystal_array_4);
  mctc1 = coords_set(
#line 1426 "MACS_sample_kidney_box.instr"
    0 + channel_4_analyzer_1_array_effective_radius_of_curvature * ( 1 - cos ( channel_4_analyzer_1_array_theta [ 4 ] ) ),
#line 1426 "MACS_sample_kidney_box.instr"
    0 + channel_4_analyzer_1_array_effective_radius_of_curvature * sin ( channel_4_analyzer_1_array_theta [ 4 ] ),
#line 1426 "MACS_sample_kidney_box.instr"
    0);
#line 107746 "MACS_sample_kidney_box.c"
  rot_transpose(mcrotachannel_4_analyzer_1_rotated, mctr1);
  mctc2 = rot_apply(mctr1, mctc1);
  mcposachannel_4_analyzer_1_array_crystal_array_4 = coords_add(mcposachannel_4_analyzer_1_rotated, mctc2);
  mctc1 = coords_sub(mcposachannel_4_analyzer_1_array_crystal_array_3, mcposachannel_4_analyzer_1_array_crystal_array_4);
  mcposrchannel_4_analyzer_1_array_crystal_array_4 = rot_apply(mcrotachannel_4_analyzer_1_array_crystal_array_4, mctc1);
  mcDEBUG_COMPONENT("channel_4_analyzer_1_array_crystal_array_4", mcposachannel_4_analyzer_1_array_crystal_array_4, mcrotachannel_4_analyzer_1_array_crystal_array_4)
  mccomp_posa[286] = mcposachannel_4_analyzer_1_array_crystal_array_4;
  mccomp_posr[286] = mcposrchannel_4_analyzer_1_array_crystal_array_4;
  mcNCounter[286]  = mcPCounter[286] = mcP2Counter[286] = 0;
  mcAbsorbProp[286]= 0;
    /* Component channel_4_analyzer_1_array_crystal_array_5. */
  /* Setting parameters for component channel_4_analyzer_1_array_crystal_array_5. */
  SIG_MESSAGE("channel_4_analyzer_1_array_crystal_array_5 (Init:SetPar)");
#line 1431 "MACS_sample_kidney_box.instr"
  if("PG_analyzer") strncpy(mccchannel_4_analyzer_1_array_crystal_array_5_material_string, "PG_analyzer" ? "PG_analyzer" : "", 16384); else mccchannel_4_analyzer_1_array_crystal_array_5_material_string[0]='\0';
#line 1431 "MACS_sample_kidney_box.instr"
  mccchannel_4_analyzer_1_array_crystal_array_5_priority = 620.5;
#line 1430 "MACS_sample_kidney_box.instr"
  mccchannel_4_analyzer_1_array_crystal_array_5_xwidth = channel_4_analyzer_1_array_crystal_depth;
#line 1430 "MACS_sample_kidney_box.instr"
  mccchannel_4_analyzer_1_array_crystal_array_5_yheight = channel_4_analyzer_1_array_crystal_height;
#line 1430 "MACS_sample_kidney_box.instr"
  mccchannel_4_analyzer_1_array_crystal_array_5_zdepth = channel_4_analyzer_1_array_crystal_width;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_4_analyzer_1_array_crystal_array_5_xwidth2 = -1;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_4_analyzer_1_array_crystal_array_5_yheight2 = -1;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_4_analyzer_1_array_crystal_array_5_visualize = 1;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_4_analyzer_1_array_crystal_array_5_target_index = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_4_analyzer_1_array_crystal_array_5_target_x = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_4_analyzer_1_array_crystal_array_5_target_y = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_4_analyzer_1_array_crystal_array_5_target_z = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_4_analyzer_1_array_crystal_array_5_focus_aw = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_4_analyzer_1_array_crystal_array_5_focus_ah = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_4_analyzer_1_array_crystal_array_5_focus_xw = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_4_analyzer_1_array_crystal_array_5_focus_xh = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_4_analyzer_1_array_crystal_array_5_focus_r = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_4_analyzer_1_array_crystal_array_5_p_interact = 0;
#line 71 "MACS_sample_kidney_box.instr"
  if(0) strncpy(mccchannel_4_analyzer_1_array_crystal_array_5_mask_string, 0 ? 0 : "", 16384); else mccchannel_4_analyzer_1_array_crystal_array_5_mask_string[0]='\0';
#line 71 "MACS_sample_kidney_box.instr"
  if(0) strncpy(mccchannel_4_analyzer_1_array_crystal_array_5_mask_setting, 0 ? 0 : "", 16384); else mccchannel_4_analyzer_1_array_crystal_array_5_mask_setting[0]='\0';
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_4_analyzer_1_array_crystal_array_5_number_of_activations = 1;
#line 107802 "MACS_sample_kidney_box.c"

  SIG_MESSAGE("channel_4_analyzer_1_array_crystal_array_5 (Init:Place/Rotate)");
  rot_set_rotation(mctr1,
#line 1433 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 1433 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 1433 "MACS_sample_kidney_box.instr"
    (0 - RAD2DEG * channel_4_analyzer_1_array_theta [ 5 ])*DEG2RAD);
#line 107812 "MACS_sample_kidney_box.c"
  rot_mul(mctr1, mcrotachannel_4_analyzer_1_rotated, mcrotachannel_4_analyzer_1_array_crystal_array_5);
  rot_transpose(mcrotachannel_4_analyzer_1_array_crystal_array_4, mctr1);
  rot_mul(mcrotachannel_4_analyzer_1_array_crystal_array_5, mctr1, mcrotrchannel_4_analyzer_1_array_crystal_array_5);
  mctc1 = coords_set(
#line 1432 "MACS_sample_kidney_box.instr"
    0 + channel_4_analyzer_1_array_effective_radius_of_curvature * ( 1 - cos ( channel_4_analyzer_1_array_theta [ 5 ] ) ),
#line 1432 "MACS_sample_kidney_box.instr"
    0 + channel_4_analyzer_1_array_effective_radius_of_curvature * sin ( channel_4_analyzer_1_array_theta [ 5 ] ),
#line 1432 "MACS_sample_kidney_box.instr"
    0);
#line 107823 "MACS_sample_kidney_box.c"
  rot_transpose(mcrotachannel_4_analyzer_1_rotated, mctr1);
  mctc2 = rot_apply(mctr1, mctc1);
  mcposachannel_4_analyzer_1_array_crystal_array_5 = coords_add(mcposachannel_4_analyzer_1_rotated, mctc2);
  mctc1 = coords_sub(mcposachannel_4_analyzer_1_array_crystal_array_4, mcposachannel_4_analyzer_1_array_crystal_array_5);
  mcposrchannel_4_analyzer_1_array_crystal_array_5 = rot_apply(mcrotachannel_4_analyzer_1_array_crystal_array_5, mctc1);
  mcDEBUG_COMPONENT("channel_4_analyzer_1_array_crystal_array_5", mcposachannel_4_analyzer_1_array_crystal_array_5, mcrotachannel_4_analyzer_1_array_crystal_array_5)
  mccomp_posa[287] = mcposachannel_4_analyzer_1_array_crystal_array_5;
  mccomp_posr[287] = mcposrchannel_4_analyzer_1_array_crystal_array_5;
  mcNCounter[287]  = mcPCounter[287] = mcP2Counter[287] = 0;
  mcAbsorbProp[287]= 0;
    /* Component channel_4_analyzer_1_array_crystal_array_6. */
  /* Setting parameters for component channel_4_analyzer_1_array_crystal_array_6. */
  SIG_MESSAGE("channel_4_analyzer_1_array_crystal_array_6 (Init:SetPar)");
#line 1437 "MACS_sample_kidney_box.instr"
  if("PG_analyzer") strncpy(mccchannel_4_analyzer_1_array_crystal_array_6_material_string, "PG_analyzer" ? "PG_analyzer" : "", 16384); else mccchannel_4_analyzer_1_array_crystal_array_6_material_string[0]='\0';
#line 1437 "MACS_sample_kidney_box.instr"
  mccchannel_4_analyzer_1_array_crystal_array_6_priority = 620.6;
#line 1436 "MACS_sample_kidney_box.instr"
  mccchannel_4_analyzer_1_array_crystal_array_6_xwidth = channel_4_analyzer_1_array_crystal_depth;
#line 1436 "MACS_sample_kidney_box.instr"
  mccchannel_4_analyzer_1_array_crystal_array_6_yheight = channel_4_analyzer_1_array_crystal_height;
#line 1436 "MACS_sample_kidney_box.instr"
  mccchannel_4_analyzer_1_array_crystal_array_6_zdepth = channel_4_analyzer_1_array_crystal_width;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_4_analyzer_1_array_crystal_array_6_xwidth2 = -1;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_4_analyzer_1_array_crystal_array_6_yheight2 = -1;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_4_analyzer_1_array_crystal_array_6_visualize = 1;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_4_analyzer_1_array_crystal_array_6_target_index = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_4_analyzer_1_array_crystal_array_6_target_x = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_4_analyzer_1_array_crystal_array_6_target_y = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_4_analyzer_1_array_crystal_array_6_target_z = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_4_analyzer_1_array_crystal_array_6_focus_aw = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_4_analyzer_1_array_crystal_array_6_focus_ah = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_4_analyzer_1_array_crystal_array_6_focus_xw = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_4_analyzer_1_array_crystal_array_6_focus_xh = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_4_analyzer_1_array_crystal_array_6_focus_r = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_4_analyzer_1_array_crystal_array_6_p_interact = 0;
#line 71 "MACS_sample_kidney_box.instr"
  if(0) strncpy(mccchannel_4_analyzer_1_array_crystal_array_6_mask_string, 0 ? 0 : "", 16384); else mccchannel_4_analyzer_1_array_crystal_array_6_mask_string[0]='\0';
#line 71 "MACS_sample_kidney_box.instr"
  if(0) strncpy(mccchannel_4_analyzer_1_array_crystal_array_6_mask_setting, 0 ? 0 : "", 16384); else mccchannel_4_analyzer_1_array_crystal_array_6_mask_setting[0]='\0';
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_4_analyzer_1_array_crystal_array_6_number_of_activations = 1;
#line 107879 "MACS_sample_kidney_box.c"

  SIG_MESSAGE("channel_4_analyzer_1_array_crystal_array_6 (Init:Place/Rotate)");
  rot_set_rotation(mctr1,
#line 1439 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 1439 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 1439 "MACS_sample_kidney_box.instr"
    (0 - RAD2DEG * channel_4_analyzer_1_array_theta [ 6 ])*DEG2RAD);
#line 107889 "MACS_sample_kidney_box.c"
  rot_mul(mctr1, mcrotachannel_4_analyzer_1_rotated, mcrotachannel_4_analyzer_1_array_crystal_array_6);
  rot_transpose(mcrotachannel_4_analyzer_1_array_crystal_array_5, mctr1);
  rot_mul(mcrotachannel_4_analyzer_1_array_crystal_array_6, mctr1, mcrotrchannel_4_analyzer_1_array_crystal_array_6);
  mctc1 = coords_set(
#line 1438 "MACS_sample_kidney_box.instr"
    0 + channel_4_analyzer_1_array_effective_radius_of_curvature * ( 1 - cos ( channel_4_analyzer_1_array_theta [ 6 ] ) ),
#line 1438 "MACS_sample_kidney_box.instr"
    0 + channel_4_analyzer_1_array_effective_radius_of_curvature * sin ( channel_4_analyzer_1_array_theta [ 6 ] ),
#line 1438 "MACS_sample_kidney_box.instr"
    0);
#line 107900 "MACS_sample_kidney_box.c"
  rot_transpose(mcrotachannel_4_analyzer_1_rotated, mctr1);
  mctc2 = rot_apply(mctr1, mctc1);
  mcposachannel_4_analyzer_1_array_crystal_array_6 = coords_add(mcposachannel_4_analyzer_1_rotated, mctc2);
  mctc1 = coords_sub(mcposachannel_4_analyzer_1_array_crystal_array_5, mcposachannel_4_analyzer_1_array_crystal_array_6);
  mcposrchannel_4_analyzer_1_array_crystal_array_6 = rot_apply(mcrotachannel_4_analyzer_1_array_crystal_array_6, mctc1);
  mcDEBUG_COMPONENT("channel_4_analyzer_1_array_crystal_array_6", mcposachannel_4_analyzer_1_array_crystal_array_6, mcrotachannel_4_analyzer_1_array_crystal_array_6)
  mccomp_posa[288] = mcposachannel_4_analyzer_1_array_crystal_array_6;
  mccomp_posr[288] = mcposrchannel_4_analyzer_1_array_crystal_array_6;
  mcNCounter[288]  = mcPCounter[288] = mcP2Counter[288] = 0;
  mcAbsorbProp[288]= 0;
    /* Component channel_4_analyzer_1_array_crystal_array_7. */
  /* Setting parameters for component channel_4_analyzer_1_array_crystal_array_7. */
  SIG_MESSAGE("channel_4_analyzer_1_array_crystal_array_7 (Init:SetPar)");
#line 1443 "MACS_sample_kidney_box.instr"
  if("PG_analyzer") strncpy(mccchannel_4_analyzer_1_array_crystal_array_7_material_string, "PG_analyzer" ? "PG_analyzer" : "", 16384); else mccchannel_4_analyzer_1_array_crystal_array_7_material_string[0]='\0';
#line 1443 "MACS_sample_kidney_box.instr"
  mccchannel_4_analyzer_1_array_crystal_array_7_priority = 620.7;
#line 1442 "MACS_sample_kidney_box.instr"
  mccchannel_4_analyzer_1_array_crystal_array_7_xwidth = channel_4_analyzer_1_array_crystal_depth;
#line 1442 "MACS_sample_kidney_box.instr"
  mccchannel_4_analyzer_1_array_crystal_array_7_yheight = channel_4_analyzer_1_array_crystal_height;
#line 1442 "MACS_sample_kidney_box.instr"
  mccchannel_4_analyzer_1_array_crystal_array_7_zdepth = channel_4_analyzer_1_array_crystal_width;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_4_analyzer_1_array_crystal_array_7_xwidth2 = -1;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_4_analyzer_1_array_crystal_array_7_yheight2 = -1;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_4_analyzer_1_array_crystal_array_7_visualize = 1;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_4_analyzer_1_array_crystal_array_7_target_index = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_4_analyzer_1_array_crystal_array_7_target_x = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_4_analyzer_1_array_crystal_array_7_target_y = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_4_analyzer_1_array_crystal_array_7_target_z = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_4_analyzer_1_array_crystal_array_7_focus_aw = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_4_analyzer_1_array_crystal_array_7_focus_ah = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_4_analyzer_1_array_crystal_array_7_focus_xw = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_4_analyzer_1_array_crystal_array_7_focus_xh = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_4_analyzer_1_array_crystal_array_7_focus_r = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_4_analyzer_1_array_crystal_array_7_p_interact = 0;
#line 71 "MACS_sample_kidney_box.instr"
  if(0) strncpy(mccchannel_4_analyzer_1_array_crystal_array_7_mask_string, 0 ? 0 : "", 16384); else mccchannel_4_analyzer_1_array_crystal_array_7_mask_string[0]='\0';
#line 71 "MACS_sample_kidney_box.instr"
  if(0) strncpy(mccchannel_4_analyzer_1_array_crystal_array_7_mask_setting, 0 ? 0 : "", 16384); else mccchannel_4_analyzer_1_array_crystal_array_7_mask_setting[0]='\0';
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_4_analyzer_1_array_crystal_array_7_number_of_activations = 1;
#line 107956 "MACS_sample_kidney_box.c"

  SIG_MESSAGE("channel_4_analyzer_1_array_crystal_array_7 (Init:Place/Rotate)");
  rot_set_rotation(mctr1,
#line 1445 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 1445 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 1445 "MACS_sample_kidney_box.instr"
    (0 - RAD2DEG * channel_4_analyzer_1_array_theta [ 7 ])*DEG2RAD);
#line 107966 "MACS_sample_kidney_box.c"
  rot_mul(mctr1, mcrotachannel_4_analyzer_1_rotated, mcrotachannel_4_analyzer_1_array_crystal_array_7);
  rot_transpose(mcrotachannel_4_analyzer_1_array_crystal_array_6, mctr1);
  rot_mul(mcrotachannel_4_analyzer_1_array_crystal_array_7, mctr1, mcrotrchannel_4_analyzer_1_array_crystal_array_7);
  mctc1 = coords_set(
#line 1444 "MACS_sample_kidney_box.instr"
    0 + channel_4_analyzer_1_array_effective_radius_of_curvature * ( 1 - cos ( channel_4_analyzer_1_array_theta [ 7 ] ) ),
#line 1444 "MACS_sample_kidney_box.instr"
    0 + channel_4_analyzer_1_array_effective_radius_of_curvature * sin ( channel_4_analyzer_1_array_theta [ 7 ] ),
#line 1444 "MACS_sample_kidney_box.instr"
    0);
#line 107977 "MACS_sample_kidney_box.c"
  rot_transpose(mcrotachannel_4_analyzer_1_rotated, mctr1);
  mctc2 = rot_apply(mctr1, mctc1);
  mcposachannel_4_analyzer_1_array_crystal_array_7 = coords_add(mcposachannel_4_analyzer_1_rotated, mctc2);
  mctc1 = coords_sub(mcposachannel_4_analyzer_1_array_crystal_array_6, mcposachannel_4_analyzer_1_array_crystal_array_7);
  mcposrchannel_4_analyzer_1_array_crystal_array_7 = rot_apply(mcrotachannel_4_analyzer_1_array_crystal_array_7, mctc1);
  mcDEBUG_COMPONENT("channel_4_analyzer_1_array_crystal_array_7", mcposachannel_4_analyzer_1_array_crystal_array_7, mcrotachannel_4_analyzer_1_array_crystal_array_7)
  mccomp_posa[289] = mcposachannel_4_analyzer_1_array_crystal_array_7;
  mccomp_posr[289] = mcposrchannel_4_analyzer_1_array_crystal_array_7;
  mcNCounter[289]  = mcPCounter[289] = mcP2Counter[289] = 0;
  mcAbsorbProp[289]= 0;
    /* Component channel_4_analyzer_1_array_crystal_array_8. */
  /* Setting parameters for component channel_4_analyzer_1_array_crystal_array_8. */
  SIG_MESSAGE("channel_4_analyzer_1_array_crystal_array_8 (Init:SetPar)");
#line 1449 "MACS_sample_kidney_box.instr"
  if("PG_analyzer") strncpy(mccchannel_4_analyzer_1_array_crystal_array_8_material_string, "PG_analyzer" ? "PG_analyzer" : "", 16384); else mccchannel_4_analyzer_1_array_crystal_array_8_material_string[0]='\0';
#line 1449 "MACS_sample_kidney_box.instr"
  mccchannel_4_analyzer_1_array_crystal_array_8_priority = 620.8;
#line 1448 "MACS_sample_kidney_box.instr"
  mccchannel_4_analyzer_1_array_crystal_array_8_xwidth = channel_4_analyzer_1_array_crystal_depth;
#line 1448 "MACS_sample_kidney_box.instr"
  mccchannel_4_analyzer_1_array_crystal_array_8_yheight = channel_4_analyzer_1_array_crystal_height;
#line 1448 "MACS_sample_kidney_box.instr"
  mccchannel_4_analyzer_1_array_crystal_array_8_zdepth = channel_4_analyzer_1_array_crystal_width;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_4_analyzer_1_array_crystal_array_8_xwidth2 = -1;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_4_analyzer_1_array_crystal_array_8_yheight2 = -1;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_4_analyzer_1_array_crystal_array_8_visualize = 1;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_4_analyzer_1_array_crystal_array_8_target_index = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_4_analyzer_1_array_crystal_array_8_target_x = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_4_analyzer_1_array_crystal_array_8_target_y = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_4_analyzer_1_array_crystal_array_8_target_z = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_4_analyzer_1_array_crystal_array_8_focus_aw = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_4_analyzer_1_array_crystal_array_8_focus_ah = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_4_analyzer_1_array_crystal_array_8_focus_xw = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_4_analyzer_1_array_crystal_array_8_focus_xh = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_4_analyzer_1_array_crystal_array_8_focus_r = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_4_analyzer_1_array_crystal_array_8_p_interact = 0;
#line 71 "MACS_sample_kidney_box.instr"
  if(0) strncpy(mccchannel_4_analyzer_1_array_crystal_array_8_mask_string, 0 ? 0 : "", 16384); else mccchannel_4_analyzer_1_array_crystal_array_8_mask_string[0]='\0';
#line 71 "MACS_sample_kidney_box.instr"
  if(0) strncpy(mccchannel_4_analyzer_1_array_crystal_array_8_mask_setting, 0 ? 0 : "", 16384); else mccchannel_4_analyzer_1_array_crystal_array_8_mask_setting[0]='\0';
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_4_analyzer_1_array_crystal_array_8_number_of_activations = 1;
#line 108033 "MACS_sample_kidney_box.c"

  SIG_MESSAGE("channel_4_analyzer_1_array_crystal_array_8 (Init:Place/Rotate)");
  rot_set_rotation(mctr1,
#line 1451 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 1451 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 1451 "MACS_sample_kidney_box.instr"
    (0 - RAD2DEG * channel_4_analyzer_1_array_theta [ 8 ])*DEG2RAD);
#line 108043 "MACS_sample_kidney_box.c"
  rot_mul(mctr1, mcrotachannel_4_analyzer_1_rotated, mcrotachannel_4_analyzer_1_array_crystal_array_8);
  rot_transpose(mcrotachannel_4_analyzer_1_array_crystal_array_7, mctr1);
  rot_mul(mcrotachannel_4_analyzer_1_array_crystal_array_8, mctr1, mcrotrchannel_4_analyzer_1_array_crystal_array_8);
  mctc1 = coords_set(
#line 1450 "MACS_sample_kidney_box.instr"
    0 + channel_4_analyzer_1_array_effective_radius_of_curvature * ( 1 - cos ( channel_4_analyzer_1_array_theta [ 8 ] ) ),
#line 1450 "MACS_sample_kidney_box.instr"
    0 + channel_4_analyzer_1_array_effective_radius_of_curvature * sin ( channel_4_analyzer_1_array_theta [ 8 ] ),
#line 1450 "MACS_sample_kidney_box.instr"
    0);
#line 108054 "MACS_sample_kidney_box.c"
  rot_transpose(mcrotachannel_4_analyzer_1_rotated, mctr1);
  mctc2 = rot_apply(mctr1, mctc1);
  mcposachannel_4_analyzer_1_array_crystal_array_8 = coords_add(mcposachannel_4_analyzer_1_rotated, mctc2);
  mctc1 = coords_sub(mcposachannel_4_analyzer_1_array_crystal_array_7, mcposachannel_4_analyzer_1_array_crystal_array_8);
  mcposrchannel_4_analyzer_1_array_crystal_array_8 = rot_apply(mcrotachannel_4_analyzer_1_array_crystal_array_8, mctc1);
  mcDEBUG_COMPONENT("channel_4_analyzer_1_array_crystal_array_8", mcposachannel_4_analyzer_1_array_crystal_array_8, mcrotachannel_4_analyzer_1_array_crystal_array_8)
  mccomp_posa[290] = mcposachannel_4_analyzer_1_array_crystal_array_8;
  mccomp_posr[290] = mcposrchannel_4_analyzer_1_array_crystal_array_8;
  mcNCounter[290]  = mcPCounter[290] = mcP2Counter[290] = 0;
  mcAbsorbProp[290]= 0;
    /* Component channel_4_analyzer_2_center. */
  /* Setting parameters for component channel_4_analyzer_2_center. */
  SIG_MESSAGE("channel_4_analyzer_2_center (Init:SetPar)");

  SIG_MESSAGE("channel_4_analyzer_2_center (Init:Place/Rotate)");
  rot_set_rotation(mctr1,
    (0.0)*DEG2RAD,
    (0.0)*DEG2RAD,
    (0.0)*DEG2RAD);
#line 108074 "MACS_sample_kidney_box.c"
  rot_mul(mctr1, mcrotachannel_4_analyzer_1_center, mcrotachannel_4_analyzer_2_center);
  rot_transpose(mcrotachannel_4_analyzer_1_array_crystal_array_8, mctr1);
  rot_mul(mcrotachannel_4_analyzer_2_center, mctr1, mcrotrchannel_4_analyzer_2_center);
  mctc1 = coords_set(
#line 1455 "MACS_sample_kidney_box.instr"
    - analyzer_seperation,
#line 1455 "MACS_sample_kidney_box.instr"
    0,
#line 1455 "MACS_sample_kidney_box.instr"
    0);
#line 108085 "MACS_sample_kidney_box.c"
  rot_transpose(mcrotachannel_4_analyzer_1_center, mctr1);
  mctc2 = rot_apply(mctr1, mctc1);
  mcposachannel_4_analyzer_2_center = coords_add(mcposachannel_4_analyzer_1_center, mctc2);
  mctc1 = coords_sub(mcposachannel_4_analyzer_1_array_crystal_array_8, mcposachannel_4_analyzer_2_center);
  mcposrchannel_4_analyzer_2_center = rot_apply(mcrotachannel_4_analyzer_2_center, mctc1);
  mcDEBUG_COMPONENT("channel_4_analyzer_2_center", mcposachannel_4_analyzer_2_center, mcrotachannel_4_analyzer_2_center)
  mccomp_posa[291] = mcposachannel_4_analyzer_2_center;
  mccomp_posr[291] = mcposrchannel_4_analyzer_2_center;
  mcNCounter[291]  = mcPCounter[291] = mcP2Counter[291] = 0;
  mcAbsorbProp[291]= 0;
    /* Component channel_4_analyzer_2_rotated. */
  /* Setting parameters for component channel_4_analyzer_2_rotated. */
  SIG_MESSAGE("channel_4_analyzer_2_rotated (Init:SetPar)");

  SIG_MESSAGE("channel_4_analyzer_2_rotated (Init:Place/Rotate)");
  rot_set_rotation(mctr1,
#line 1459 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 1459 "MACS_sample_kidney_box.instr"
    (- analyzer_theta [ 4 ])*DEG2RAD,
#line 1459 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD);
#line 108108 "MACS_sample_kidney_box.c"
  rot_mul(mctr1, mcrotachannel_4_analyzer_2_center, mcrotachannel_4_analyzer_2_rotated);
  rot_transpose(mcrotachannel_4_analyzer_2_center, mctr1);
  rot_mul(mcrotachannel_4_analyzer_2_rotated, mctr1, mcrotrchannel_4_analyzer_2_rotated);
  mctc1 = coords_set(
#line 1458 "MACS_sample_kidney_box.instr"
    0,
#line 1458 "MACS_sample_kidney_box.instr"
    0,
#line 1458 "MACS_sample_kidney_box.instr"
    0.5 * analyzer_seperation / tan ( analyzer_2theta [ 4 ] * DEG2RAD ));
#line 108119 "MACS_sample_kidney_box.c"
  rot_transpose(mcrotachannel_4_analyzer_2_center, mctr1);
  mctc2 = rot_apply(mctr1, mctc1);
  mcposachannel_4_analyzer_2_rotated = coords_add(mcposachannel_4_analyzer_2_center, mctc2);
  mctc1 = coords_sub(mcposachannel_4_analyzer_2_center, mcposachannel_4_analyzer_2_rotated);
  mcposrchannel_4_analyzer_2_rotated = rot_apply(mcrotachannel_4_analyzer_2_rotated, mctc1);
  mcDEBUG_COMPONENT("channel_4_analyzer_2_rotated", mcposachannel_4_analyzer_2_rotated, mcrotachannel_4_analyzer_2_rotated)
  mccomp_posa[292] = mcposachannel_4_analyzer_2_rotated;
  mccomp_posr[292] = mcposrchannel_4_analyzer_2_rotated;
  mcNCounter[292]  = mcPCounter[292] = mcP2Counter[292] = 0;
  mcAbsorbProp[292]= 0;
    /* Component channel_4_analyzer_2_array_crystal_array_0. */
  /* Setting parameters for component channel_4_analyzer_2_array_crystal_array_0. */
  SIG_MESSAGE("channel_4_analyzer_2_array_crystal_array_0 (Init:SetPar)");
#line 1463 "MACS_sample_kidney_box.instr"
  if("PG_analyzer") strncpy(mccchannel_4_analyzer_2_array_crystal_array_0_material_string, "PG_analyzer" ? "PG_analyzer" : "", 16384); else mccchannel_4_analyzer_2_array_crystal_array_0_material_string[0]='\0';
#line 1463 "MACS_sample_kidney_box.instr"
  mccchannel_4_analyzer_2_array_crystal_array_0_priority = 621.0;
#line 1462 "MACS_sample_kidney_box.instr"
  mccchannel_4_analyzer_2_array_crystal_array_0_xwidth = channel_4_analyzer_2_array_crystal_depth;
#line 1462 "MACS_sample_kidney_box.instr"
  mccchannel_4_analyzer_2_array_crystal_array_0_yheight = channel_4_analyzer_2_array_crystal_height;
#line 1462 "MACS_sample_kidney_box.instr"
  mccchannel_4_analyzer_2_array_crystal_array_0_zdepth = channel_4_analyzer_2_array_crystal_width;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_4_analyzer_2_array_crystal_array_0_xwidth2 = -1;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_4_analyzer_2_array_crystal_array_0_yheight2 = -1;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_4_analyzer_2_array_crystal_array_0_visualize = 1;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_4_analyzer_2_array_crystal_array_0_target_index = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_4_analyzer_2_array_crystal_array_0_target_x = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_4_analyzer_2_array_crystal_array_0_target_y = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_4_analyzer_2_array_crystal_array_0_target_z = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_4_analyzer_2_array_crystal_array_0_focus_aw = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_4_analyzer_2_array_crystal_array_0_focus_ah = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_4_analyzer_2_array_crystal_array_0_focus_xw = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_4_analyzer_2_array_crystal_array_0_focus_xh = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_4_analyzer_2_array_crystal_array_0_focus_r = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_4_analyzer_2_array_crystal_array_0_p_interact = 0;
#line 71 "MACS_sample_kidney_box.instr"
  if(0) strncpy(mccchannel_4_analyzer_2_array_crystal_array_0_mask_string, 0 ? 0 : "", 16384); else mccchannel_4_analyzer_2_array_crystal_array_0_mask_string[0]='\0';
#line 71 "MACS_sample_kidney_box.instr"
  if(0) strncpy(mccchannel_4_analyzer_2_array_crystal_array_0_mask_setting, 0 ? 0 : "", 16384); else mccchannel_4_analyzer_2_array_crystal_array_0_mask_setting[0]='\0';
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_4_analyzer_2_array_crystal_array_0_number_of_activations = 1;
#line 108175 "MACS_sample_kidney_box.c"

  SIG_MESSAGE("channel_4_analyzer_2_array_crystal_array_0 (Init:Place/Rotate)");
  rot_set_rotation(mctr1,
#line 1465 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 1465 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 1465 "MACS_sample_kidney_box.instr"
    (0 - RAD2DEG * channel_4_analyzer_2_array_theta [ 0 ])*DEG2RAD);
#line 108185 "MACS_sample_kidney_box.c"
  rot_mul(mctr1, mcrotachannel_4_analyzer_2_rotated, mcrotachannel_4_analyzer_2_array_crystal_array_0);
  rot_transpose(mcrotachannel_4_analyzer_2_rotated, mctr1);
  rot_mul(mcrotachannel_4_analyzer_2_array_crystal_array_0, mctr1, mcrotrchannel_4_analyzer_2_array_crystal_array_0);
  mctc1 = coords_set(
#line 1464 "MACS_sample_kidney_box.instr"
    0 + channel_4_analyzer_2_array_effective_radius_of_curvature * ( 1 - cos ( channel_4_analyzer_2_array_theta [ 0 ] ) ),
#line 1464 "MACS_sample_kidney_box.instr"
    0 + channel_4_analyzer_2_array_effective_radius_of_curvature * sin ( channel_4_analyzer_2_array_theta [ 0 ] ),
#line 1464 "MACS_sample_kidney_box.instr"
    0);
#line 108196 "MACS_sample_kidney_box.c"
  rot_transpose(mcrotachannel_4_analyzer_2_rotated, mctr1);
  mctc2 = rot_apply(mctr1, mctc1);
  mcposachannel_4_analyzer_2_array_crystal_array_0 = coords_add(mcposachannel_4_analyzer_2_rotated, mctc2);
  mctc1 = coords_sub(mcposachannel_4_analyzer_2_rotated, mcposachannel_4_analyzer_2_array_crystal_array_0);
  mcposrchannel_4_analyzer_2_array_crystal_array_0 = rot_apply(mcrotachannel_4_analyzer_2_array_crystal_array_0, mctc1);
  mcDEBUG_COMPONENT("channel_4_analyzer_2_array_crystal_array_0", mcposachannel_4_analyzer_2_array_crystal_array_0, mcrotachannel_4_analyzer_2_array_crystal_array_0)
  mccomp_posa[293] = mcposachannel_4_analyzer_2_array_crystal_array_0;
  mccomp_posr[293] = mcposrchannel_4_analyzer_2_array_crystal_array_0;
  mcNCounter[293]  = mcPCounter[293] = mcP2Counter[293] = 0;
  mcAbsorbProp[293]= 0;
    /* Component channel_4_analyzer_2_array_crystal_array_1. */
  /* Setting parameters for component channel_4_analyzer_2_array_crystal_array_1. */
  SIG_MESSAGE("channel_4_analyzer_2_array_crystal_array_1 (Init:SetPar)");
#line 1469 "MACS_sample_kidney_box.instr"
  if("PG_analyzer") strncpy(mccchannel_4_analyzer_2_array_crystal_array_1_material_string, "PG_analyzer" ? "PG_analyzer" : "", 16384); else mccchannel_4_analyzer_2_array_crystal_array_1_material_string[0]='\0';
#line 1469 "MACS_sample_kidney_box.instr"
  mccchannel_4_analyzer_2_array_crystal_array_1_priority = 621.1;
#line 1468 "MACS_sample_kidney_box.instr"
  mccchannel_4_analyzer_2_array_crystal_array_1_xwidth = channel_4_analyzer_2_array_crystal_depth;
#line 1468 "MACS_sample_kidney_box.instr"
  mccchannel_4_analyzer_2_array_crystal_array_1_yheight = channel_4_analyzer_2_array_crystal_height;
#line 1468 "MACS_sample_kidney_box.instr"
  mccchannel_4_analyzer_2_array_crystal_array_1_zdepth = channel_4_analyzer_2_array_crystal_width;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_4_analyzer_2_array_crystal_array_1_xwidth2 = -1;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_4_analyzer_2_array_crystal_array_1_yheight2 = -1;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_4_analyzer_2_array_crystal_array_1_visualize = 1;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_4_analyzer_2_array_crystal_array_1_target_index = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_4_analyzer_2_array_crystal_array_1_target_x = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_4_analyzer_2_array_crystal_array_1_target_y = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_4_analyzer_2_array_crystal_array_1_target_z = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_4_analyzer_2_array_crystal_array_1_focus_aw = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_4_analyzer_2_array_crystal_array_1_focus_ah = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_4_analyzer_2_array_crystal_array_1_focus_xw = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_4_analyzer_2_array_crystal_array_1_focus_xh = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_4_analyzer_2_array_crystal_array_1_focus_r = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_4_analyzer_2_array_crystal_array_1_p_interact = 0;
#line 71 "MACS_sample_kidney_box.instr"
  if(0) strncpy(mccchannel_4_analyzer_2_array_crystal_array_1_mask_string, 0 ? 0 : "", 16384); else mccchannel_4_analyzer_2_array_crystal_array_1_mask_string[0]='\0';
#line 71 "MACS_sample_kidney_box.instr"
  if(0) strncpy(mccchannel_4_analyzer_2_array_crystal_array_1_mask_setting, 0 ? 0 : "", 16384); else mccchannel_4_analyzer_2_array_crystal_array_1_mask_setting[0]='\0';
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_4_analyzer_2_array_crystal_array_1_number_of_activations = 1;
#line 108252 "MACS_sample_kidney_box.c"

  SIG_MESSAGE("channel_4_analyzer_2_array_crystal_array_1 (Init:Place/Rotate)");
  rot_set_rotation(mctr1,
#line 1471 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 1471 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 1471 "MACS_sample_kidney_box.instr"
    (0 - RAD2DEG * channel_4_analyzer_2_array_theta [ 1 ])*DEG2RAD);
#line 108262 "MACS_sample_kidney_box.c"
  rot_mul(mctr1, mcrotachannel_4_analyzer_2_rotated, mcrotachannel_4_analyzer_2_array_crystal_array_1);
  rot_transpose(mcrotachannel_4_analyzer_2_array_crystal_array_0, mctr1);
  rot_mul(mcrotachannel_4_analyzer_2_array_crystal_array_1, mctr1, mcrotrchannel_4_analyzer_2_array_crystal_array_1);
  mctc1 = coords_set(
#line 1470 "MACS_sample_kidney_box.instr"
    0 + channel_4_analyzer_2_array_effective_radius_of_curvature * ( 1 - cos ( channel_4_analyzer_2_array_theta [ 1 ] ) ),
#line 1470 "MACS_sample_kidney_box.instr"
    0 + channel_4_analyzer_2_array_effective_radius_of_curvature * sin ( channel_4_analyzer_2_array_theta [ 1 ] ),
#line 1470 "MACS_sample_kidney_box.instr"
    0);
#line 108273 "MACS_sample_kidney_box.c"
  rot_transpose(mcrotachannel_4_analyzer_2_rotated, mctr1);
  mctc2 = rot_apply(mctr1, mctc1);
  mcposachannel_4_analyzer_2_array_crystal_array_1 = coords_add(mcposachannel_4_analyzer_2_rotated, mctc2);
  mctc1 = coords_sub(mcposachannel_4_analyzer_2_array_crystal_array_0, mcposachannel_4_analyzer_2_array_crystal_array_1);
  mcposrchannel_4_analyzer_2_array_crystal_array_1 = rot_apply(mcrotachannel_4_analyzer_2_array_crystal_array_1, mctc1);
  mcDEBUG_COMPONENT("channel_4_analyzer_2_array_crystal_array_1", mcposachannel_4_analyzer_2_array_crystal_array_1, mcrotachannel_4_analyzer_2_array_crystal_array_1)
  mccomp_posa[294] = mcposachannel_4_analyzer_2_array_crystal_array_1;
  mccomp_posr[294] = mcposrchannel_4_analyzer_2_array_crystal_array_1;
  mcNCounter[294]  = mcPCounter[294] = mcP2Counter[294] = 0;
  mcAbsorbProp[294]= 0;
    /* Component channel_4_analyzer_2_array_crystal_array_2. */
  /* Setting parameters for component channel_4_analyzer_2_array_crystal_array_2. */
  SIG_MESSAGE("channel_4_analyzer_2_array_crystal_array_2 (Init:SetPar)");
#line 1475 "MACS_sample_kidney_box.instr"
  if("PG_analyzer") strncpy(mccchannel_4_analyzer_2_array_crystal_array_2_material_string, "PG_analyzer" ? "PG_analyzer" : "", 16384); else mccchannel_4_analyzer_2_array_crystal_array_2_material_string[0]='\0';
#line 1475 "MACS_sample_kidney_box.instr"
  mccchannel_4_analyzer_2_array_crystal_array_2_priority = 621.2;
#line 1474 "MACS_sample_kidney_box.instr"
  mccchannel_4_analyzer_2_array_crystal_array_2_xwidth = channel_4_analyzer_2_array_crystal_depth;
#line 1474 "MACS_sample_kidney_box.instr"
  mccchannel_4_analyzer_2_array_crystal_array_2_yheight = channel_4_analyzer_2_array_crystal_height;
#line 1474 "MACS_sample_kidney_box.instr"
  mccchannel_4_analyzer_2_array_crystal_array_2_zdepth = channel_4_analyzer_2_array_crystal_width;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_4_analyzer_2_array_crystal_array_2_xwidth2 = -1;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_4_analyzer_2_array_crystal_array_2_yheight2 = -1;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_4_analyzer_2_array_crystal_array_2_visualize = 1;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_4_analyzer_2_array_crystal_array_2_target_index = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_4_analyzer_2_array_crystal_array_2_target_x = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_4_analyzer_2_array_crystal_array_2_target_y = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_4_analyzer_2_array_crystal_array_2_target_z = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_4_analyzer_2_array_crystal_array_2_focus_aw = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_4_analyzer_2_array_crystal_array_2_focus_ah = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_4_analyzer_2_array_crystal_array_2_focus_xw = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_4_analyzer_2_array_crystal_array_2_focus_xh = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_4_analyzer_2_array_crystal_array_2_focus_r = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_4_analyzer_2_array_crystal_array_2_p_interact = 0;
#line 71 "MACS_sample_kidney_box.instr"
  if(0) strncpy(mccchannel_4_analyzer_2_array_crystal_array_2_mask_string, 0 ? 0 : "", 16384); else mccchannel_4_analyzer_2_array_crystal_array_2_mask_string[0]='\0';
#line 71 "MACS_sample_kidney_box.instr"
  if(0) strncpy(mccchannel_4_analyzer_2_array_crystal_array_2_mask_setting, 0 ? 0 : "", 16384); else mccchannel_4_analyzer_2_array_crystal_array_2_mask_setting[0]='\0';
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_4_analyzer_2_array_crystal_array_2_number_of_activations = 1;
#line 108329 "MACS_sample_kidney_box.c"

  SIG_MESSAGE("channel_4_analyzer_2_array_crystal_array_2 (Init:Place/Rotate)");
  rot_set_rotation(mctr1,
#line 1477 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 1477 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 1477 "MACS_sample_kidney_box.instr"
    (0 - RAD2DEG * channel_4_analyzer_2_array_theta [ 2 ])*DEG2RAD);
#line 108339 "MACS_sample_kidney_box.c"
  rot_mul(mctr1, mcrotachannel_4_analyzer_2_rotated, mcrotachannel_4_analyzer_2_array_crystal_array_2);
  rot_transpose(mcrotachannel_4_analyzer_2_array_crystal_array_1, mctr1);
  rot_mul(mcrotachannel_4_analyzer_2_array_crystal_array_2, mctr1, mcrotrchannel_4_analyzer_2_array_crystal_array_2);
  mctc1 = coords_set(
#line 1476 "MACS_sample_kidney_box.instr"
    0 + channel_4_analyzer_2_array_effective_radius_of_curvature * ( 1 - cos ( channel_4_analyzer_2_array_theta [ 2 ] ) ),
#line 1476 "MACS_sample_kidney_box.instr"
    0 + channel_4_analyzer_2_array_effective_radius_of_curvature * sin ( channel_4_analyzer_2_array_theta [ 2 ] ),
#line 1476 "MACS_sample_kidney_box.instr"
    0);
#line 108350 "MACS_sample_kidney_box.c"
  rot_transpose(mcrotachannel_4_analyzer_2_rotated, mctr1);
  mctc2 = rot_apply(mctr1, mctc1);
  mcposachannel_4_analyzer_2_array_crystal_array_2 = coords_add(mcposachannel_4_analyzer_2_rotated, mctc2);
  mctc1 = coords_sub(mcposachannel_4_analyzer_2_array_crystal_array_1, mcposachannel_4_analyzer_2_array_crystal_array_2);
  mcposrchannel_4_analyzer_2_array_crystal_array_2 = rot_apply(mcrotachannel_4_analyzer_2_array_crystal_array_2, mctc1);
  mcDEBUG_COMPONENT("channel_4_analyzer_2_array_crystal_array_2", mcposachannel_4_analyzer_2_array_crystal_array_2, mcrotachannel_4_analyzer_2_array_crystal_array_2)
  mccomp_posa[295] = mcposachannel_4_analyzer_2_array_crystal_array_2;
  mccomp_posr[295] = mcposrchannel_4_analyzer_2_array_crystal_array_2;
  mcNCounter[295]  = mcPCounter[295] = mcP2Counter[295] = 0;
  mcAbsorbProp[295]= 0;
    /* Component channel_4_analyzer_2_array_crystal_array_3. */
  /* Setting parameters for component channel_4_analyzer_2_array_crystal_array_3. */
  SIG_MESSAGE("channel_4_analyzer_2_array_crystal_array_3 (Init:SetPar)");
#line 1481 "MACS_sample_kidney_box.instr"
  if("PG_analyzer") strncpy(mccchannel_4_analyzer_2_array_crystal_array_3_material_string, "PG_analyzer" ? "PG_analyzer" : "", 16384); else mccchannel_4_analyzer_2_array_crystal_array_3_material_string[0]='\0';
#line 1481 "MACS_sample_kidney_box.instr"
  mccchannel_4_analyzer_2_array_crystal_array_3_priority = 621.3;
#line 1480 "MACS_sample_kidney_box.instr"
  mccchannel_4_analyzer_2_array_crystal_array_3_xwidth = channel_4_analyzer_2_array_crystal_depth;
#line 1480 "MACS_sample_kidney_box.instr"
  mccchannel_4_analyzer_2_array_crystal_array_3_yheight = channel_4_analyzer_2_array_crystal_height;
#line 1480 "MACS_sample_kidney_box.instr"
  mccchannel_4_analyzer_2_array_crystal_array_3_zdepth = channel_4_analyzer_2_array_crystal_width;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_4_analyzer_2_array_crystal_array_3_xwidth2 = -1;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_4_analyzer_2_array_crystal_array_3_yheight2 = -1;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_4_analyzer_2_array_crystal_array_3_visualize = 1;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_4_analyzer_2_array_crystal_array_3_target_index = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_4_analyzer_2_array_crystal_array_3_target_x = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_4_analyzer_2_array_crystal_array_3_target_y = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_4_analyzer_2_array_crystal_array_3_target_z = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_4_analyzer_2_array_crystal_array_3_focus_aw = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_4_analyzer_2_array_crystal_array_3_focus_ah = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_4_analyzer_2_array_crystal_array_3_focus_xw = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_4_analyzer_2_array_crystal_array_3_focus_xh = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_4_analyzer_2_array_crystal_array_3_focus_r = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_4_analyzer_2_array_crystal_array_3_p_interact = 0;
#line 71 "MACS_sample_kidney_box.instr"
  if(0) strncpy(mccchannel_4_analyzer_2_array_crystal_array_3_mask_string, 0 ? 0 : "", 16384); else mccchannel_4_analyzer_2_array_crystal_array_3_mask_string[0]='\0';
#line 71 "MACS_sample_kidney_box.instr"
  if(0) strncpy(mccchannel_4_analyzer_2_array_crystal_array_3_mask_setting, 0 ? 0 : "", 16384); else mccchannel_4_analyzer_2_array_crystal_array_3_mask_setting[0]='\0';
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_4_analyzer_2_array_crystal_array_3_number_of_activations = 1;
#line 108406 "MACS_sample_kidney_box.c"

  SIG_MESSAGE("channel_4_analyzer_2_array_crystal_array_3 (Init:Place/Rotate)");
  rot_set_rotation(mctr1,
#line 1483 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 1483 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 1483 "MACS_sample_kidney_box.instr"
    (0 - RAD2DEG * channel_4_analyzer_2_array_theta [ 3 ])*DEG2RAD);
#line 108416 "MACS_sample_kidney_box.c"
  rot_mul(mctr1, mcrotachannel_4_analyzer_2_rotated, mcrotachannel_4_analyzer_2_array_crystal_array_3);
  rot_transpose(mcrotachannel_4_analyzer_2_array_crystal_array_2, mctr1);
  rot_mul(mcrotachannel_4_analyzer_2_array_crystal_array_3, mctr1, mcrotrchannel_4_analyzer_2_array_crystal_array_3);
  mctc1 = coords_set(
#line 1482 "MACS_sample_kidney_box.instr"
    0 + channel_4_analyzer_2_array_effective_radius_of_curvature * ( 1 - cos ( channel_4_analyzer_2_array_theta [ 3 ] ) ),
#line 1482 "MACS_sample_kidney_box.instr"
    0 + channel_4_analyzer_2_array_effective_radius_of_curvature * sin ( channel_4_analyzer_2_array_theta [ 3 ] ),
#line 1482 "MACS_sample_kidney_box.instr"
    0);
#line 108427 "MACS_sample_kidney_box.c"
  rot_transpose(mcrotachannel_4_analyzer_2_rotated, mctr1);
  mctc2 = rot_apply(mctr1, mctc1);
  mcposachannel_4_analyzer_2_array_crystal_array_3 = coords_add(mcposachannel_4_analyzer_2_rotated, mctc2);
  mctc1 = coords_sub(mcposachannel_4_analyzer_2_array_crystal_array_2, mcposachannel_4_analyzer_2_array_crystal_array_3);
  mcposrchannel_4_analyzer_2_array_crystal_array_3 = rot_apply(mcrotachannel_4_analyzer_2_array_crystal_array_3, mctc1);
  mcDEBUG_COMPONENT("channel_4_analyzer_2_array_crystal_array_3", mcposachannel_4_analyzer_2_array_crystal_array_3, mcrotachannel_4_analyzer_2_array_crystal_array_3)
  mccomp_posa[296] = mcposachannel_4_analyzer_2_array_crystal_array_3;
  mccomp_posr[296] = mcposrchannel_4_analyzer_2_array_crystal_array_3;
  mcNCounter[296]  = mcPCounter[296] = mcP2Counter[296] = 0;
  mcAbsorbProp[296]= 0;
    /* Component channel_4_analyzer_2_array_crystal_array_4. */
  /* Setting parameters for component channel_4_analyzer_2_array_crystal_array_4. */
  SIG_MESSAGE("channel_4_analyzer_2_array_crystal_array_4 (Init:SetPar)");
#line 1487 "MACS_sample_kidney_box.instr"
  if("PG_analyzer") strncpy(mccchannel_4_analyzer_2_array_crystal_array_4_material_string, "PG_analyzer" ? "PG_analyzer" : "", 16384); else mccchannel_4_analyzer_2_array_crystal_array_4_material_string[0]='\0';
#line 1487 "MACS_sample_kidney_box.instr"
  mccchannel_4_analyzer_2_array_crystal_array_4_priority = 621.4;
#line 1486 "MACS_sample_kidney_box.instr"
  mccchannel_4_analyzer_2_array_crystal_array_4_xwidth = channel_4_analyzer_2_array_crystal_depth;
#line 1486 "MACS_sample_kidney_box.instr"
  mccchannel_4_analyzer_2_array_crystal_array_4_yheight = channel_4_analyzer_2_array_crystal_height;
#line 1486 "MACS_sample_kidney_box.instr"
  mccchannel_4_analyzer_2_array_crystal_array_4_zdepth = channel_4_analyzer_2_array_crystal_width;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_4_analyzer_2_array_crystal_array_4_xwidth2 = -1;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_4_analyzer_2_array_crystal_array_4_yheight2 = -1;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_4_analyzer_2_array_crystal_array_4_visualize = 1;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_4_analyzer_2_array_crystal_array_4_target_index = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_4_analyzer_2_array_crystal_array_4_target_x = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_4_analyzer_2_array_crystal_array_4_target_y = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_4_analyzer_2_array_crystal_array_4_target_z = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_4_analyzer_2_array_crystal_array_4_focus_aw = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_4_analyzer_2_array_crystal_array_4_focus_ah = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_4_analyzer_2_array_crystal_array_4_focus_xw = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_4_analyzer_2_array_crystal_array_4_focus_xh = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_4_analyzer_2_array_crystal_array_4_focus_r = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_4_analyzer_2_array_crystal_array_4_p_interact = 0;
#line 71 "MACS_sample_kidney_box.instr"
  if(0) strncpy(mccchannel_4_analyzer_2_array_crystal_array_4_mask_string, 0 ? 0 : "", 16384); else mccchannel_4_analyzer_2_array_crystal_array_4_mask_string[0]='\0';
#line 71 "MACS_sample_kidney_box.instr"
  if(0) strncpy(mccchannel_4_analyzer_2_array_crystal_array_4_mask_setting, 0 ? 0 : "", 16384); else mccchannel_4_analyzer_2_array_crystal_array_4_mask_setting[0]='\0';
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_4_analyzer_2_array_crystal_array_4_number_of_activations = 1;
#line 108483 "MACS_sample_kidney_box.c"

  SIG_MESSAGE("channel_4_analyzer_2_array_crystal_array_4 (Init:Place/Rotate)");
  rot_set_rotation(mctr1,
#line 1489 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 1489 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 1489 "MACS_sample_kidney_box.instr"
    (0 - RAD2DEG * channel_4_analyzer_2_array_theta [ 4 ])*DEG2RAD);
#line 108493 "MACS_sample_kidney_box.c"
  rot_mul(mctr1, mcrotachannel_4_analyzer_2_rotated, mcrotachannel_4_analyzer_2_array_crystal_array_4);
  rot_transpose(mcrotachannel_4_analyzer_2_array_crystal_array_3, mctr1);
  rot_mul(mcrotachannel_4_analyzer_2_array_crystal_array_4, mctr1, mcrotrchannel_4_analyzer_2_array_crystal_array_4);
  mctc1 = coords_set(
#line 1488 "MACS_sample_kidney_box.instr"
    0 + channel_4_analyzer_2_array_effective_radius_of_curvature * ( 1 - cos ( channel_4_analyzer_2_array_theta [ 4 ] ) ),
#line 1488 "MACS_sample_kidney_box.instr"
    0 + channel_4_analyzer_2_array_effective_radius_of_curvature * sin ( channel_4_analyzer_2_array_theta [ 4 ] ),
#line 1488 "MACS_sample_kidney_box.instr"
    0);
#line 108504 "MACS_sample_kidney_box.c"
  rot_transpose(mcrotachannel_4_analyzer_2_rotated, mctr1);
  mctc2 = rot_apply(mctr1, mctc1);
  mcposachannel_4_analyzer_2_array_crystal_array_4 = coords_add(mcposachannel_4_analyzer_2_rotated, mctc2);
  mctc1 = coords_sub(mcposachannel_4_analyzer_2_array_crystal_array_3, mcposachannel_4_analyzer_2_array_crystal_array_4);
  mcposrchannel_4_analyzer_2_array_crystal_array_4 = rot_apply(mcrotachannel_4_analyzer_2_array_crystal_array_4, mctc1);
  mcDEBUG_COMPONENT("channel_4_analyzer_2_array_crystal_array_4", mcposachannel_4_analyzer_2_array_crystal_array_4, mcrotachannel_4_analyzer_2_array_crystal_array_4)
  mccomp_posa[297] = mcposachannel_4_analyzer_2_array_crystal_array_4;
  mccomp_posr[297] = mcposrchannel_4_analyzer_2_array_crystal_array_4;
  mcNCounter[297]  = mcPCounter[297] = mcP2Counter[297] = 0;
  mcAbsorbProp[297]= 0;
    /* Component channel_4_analyzer_2_array_crystal_array_5. */
  /* Setting parameters for component channel_4_analyzer_2_array_crystal_array_5. */
  SIG_MESSAGE("channel_4_analyzer_2_array_crystal_array_5 (Init:SetPar)");
#line 1493 "MACS_sample_kidney_box.instr"
  if("PG_analyzer") strncpy(mccchannel_4_analyzer_2_array_crystal_array_5_material_string, "PG_analyzer" ? "PG_analyzer" : "", 16384); else mccchannel_4_analyzer_2_array_crystal_array_5_material_string[0]='\0';
#line 1493 "MACS_sample_kidney_box.instr"
  mccchannel_4_analyzer_2_array_crystal_array_5_priority = 621.5;
#line 1492 "MACS_sample_kidney_box.instr"
  mccchannel_4_analyzer_2_array_crystal_array_5_xwidth = channel_4_analyzer_2_array_crystal_depth;
#line 1492 "MACS_sample_kidney_box.instr"
  mccchannel_4_analyzer_2_array_crystal_array_5_yheight = channel_4_analyzer_2_array_crystal_height;
#line 1492 "MACS_sample_kidney_box.instr"
  mccchannel_4_analyzer_2_array_crystal_array_5_zdepth = channel_4_analyzer_2_array_crystal_width;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_4_analyzer_2_array_crystal_array_5_xwidth2 = -1;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_4_analyzer_2_array_crystal_array_5_yheight2 = -1;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_4_analyzer_2_array_crystal_array_5_visualize = 1;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_4_analyzer_2_array_crystal_array_5_target_index = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_4_analyzer_2_array_crystal_array_5_target_x = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_4_analyzer_2_array_crystal_array_5_target_y = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_4_analyzer_2_array_crystal_array_5_target_z = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_4_analyzer_2_array_crystal_array_5_focus_aw = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_4_analyzer_2_array_crystal_array_5_focus_ah = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_4_analyzer_2_array_crystal_array_5_focus_xw = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_4_analyzer_2_array_crystal_array_5_focus_xh = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_4_analyzer_2_array_crystal_array_5_focus_r = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_4_analyzer_2_array_crystal_array_5_p_interact = 0;
#line 71 "MACS_sample_kidney_box.instr"
  if(0) strncpy(mccchannel_4_analyzer_2_array_crystal_array_5_mask_string, 0 ? 0 : "", 16384); else mccchannel_4_analyzer_2_array_crystal_array_5_mask_string[0]='\0';
#line 71 "MACS_sample_kidney_box.instr"
  if(0) strncpy(mccchannel_4_analyzer_2_array_crystal_array_5_mask_setting, 0 ? 0 : "", 16384); else mccchannel_4_analyzer_2_array_crystal_array_5_mask_setting[0]='\0';
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_4_analyzer_2_array_crystal_array_5_number_of_activations = 1;
#line 108560 "MACS_sample_kidney_box.c"

  SIG_MESSAGE("channel_4_analyzer_2_array_crystal_array_5 (Init:Place/Rotate)");
  rot_set_rotation(mctr1,
#line 1495 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 1495 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 1495 "MACS_sample_kidney_box.instr"
    (0 - RAD2DEG * channel_4_analyzer_2_array_theta [ 5 ])*DEG2RAD);
#line 108570 "MACS_sample_kidney_box.c"
  rot_mul(mctr1, mcrotachannel_4_analyzer_2_rotated, mcrotachannel_4_analyzer_2_array_crystal_array_5);
  rot_transpose(mcrotachannel_4_analyzer_2_array_crystal_array_4, mctr1);
  rot_mul(mcrotachannel_4_analyzer_2_array_crystal_array_5, mctr1, mcrotrchannel_4_analyzer_2_array_crystal_array_5);
  mctc1 = coords_set(
#line 1494 "MACS_sample_kidney_box.instr"
    0 + channel_4_analyzer_2_array_effective_radius_of_curvature * ( 1 - cos ( channel_4_analyzer_2_array_theta [ 5 ] ) ),
#line 1494 "MACS_sample_kidney_box.instr"
    0 + channel_4_analyzer_2_array_effective_radius_of_curvature * sin ( channel_4_analyzer_2_array_theta [ 5 ] ),
#line 1494 "MACS_sample_kidney_box.instr"
    0);
#line 108581 "MACS_sample_kidney_box.c"
  rot_transpose(mcrotachannel_4_analyzer_2_rotated, mctr1);
  mctc2 = rot_apply(mctr1, mctc1);
  mcposachannel_4_analyzer_2_array_crystal_array_5 = coords_add(mcposachannel_4_analyzer_2_rotated, mctc2);
  mctc1 = coords_sub(mcposachannel_4_analyzer_2_array_crystal_array_4, mcposachannel_4_analyzer_2_array_crystal_array_5);
  mcposrchannel_4_analyzer_2_array_crystal_array_5 = rot_apply(mcrotachannel_4_analyzer_2_array_crystal_array_5, mctc1);
  mcDEBUG_COMPONENT("channel_4_analyzer_2_array_crystal_array_5", mcposachannel_4_analyzer_2_array_crystal_array_5, mcrotachannel_4_analyzer_2_array_crystal_array_5)
  mccomp_posa[298] = mcposachannel_4_analyzer_2_array_crystal_array_5;
  mccomp_posr[298] = mcposrchannel_4_analyzer_2_array_crystal_array_5;
  mcNCounter[298]  = mcPCounter[298] = mcP2Counter[298] = 0;
  mcAbsorbProp[298]= 0;
    /* Component channel_4_analyzer_2_array_crystal_array_6. */
  /* Setting parameters for component channel_4_analyzer_2_array_crystal_array_6. */
  SIG_MESSAGE("channel_4_analyzer_2_array_crystal_array_6 (Init:SetPar)");
#line 1499 "MACS_sample_kidney_box.instr"
  if("PG_analyzer") strncpy(mccchannel_4_analyzer_2_array_crystal_array_6_material_string, "PG_analyzer" ? "PG_analyzer" : "", 16384); else mccchannel_4_analyzer_2_array_crystal_array_6_material_string[0]='\0';
#line 1499 "MACS_sample_kidney_box.instr"
  mccchannel_4_analyzer_2_array_crystal_array_6_priority = 621.6;
#line 1498 "MACS_sample_kidney_box.instr"
  mccchannel_4_analyzer_2_array_crystal_array_6_xwidth = channel_4_analyzer_2_array_crystal_depth;
#line 1498 "MACS_sample_kidney_box.instr"
  mccchannel_4_analyzer_2_array_crystal_array_6_yheight = channel_4_analyzer_2_array_crystal_height;
#line 1498 "MACS_sample_kidney_box.instr"
  mccchannel_4_analyzer_2_array_crystal_array_6_zdepth = channel_4_analyzer_2_array_crystal_width;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_4_analyzer_2_array_crystal_array_6_xwidth2 = -1;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_4_analyzer_2_array_crystal_array_6_yheight2 = -1;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_4_analyzer_2_array_crystal_array_6_visualize = 1;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_4_analyzer_2_array_crystal_array_6_target_index = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_4_analyzer_2_array_crystal_array_6_target_x = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_4_analyzer_2_array_crystal_array_6_target_y = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_4_analyzer_2_array_crystal_array_6_target_z = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_4_analyzer_2_array_crystal_array_6_focus_aw = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_4_analyzer_2_array_crystal_array_6_focus_ah = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_4_analyzer_2_array_crystal_array_6_focus_xw = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_4_analyzer_2_array_crystal_array_6_focus_xh = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_4_analyzer_2_array_crystal_array_6_focus_r = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_4_analyzer_2_array_crystal_array_6_p_interact = 0;
#line 71 "MACS_sample_kidney_box.instr"
  if(0) strncpy(mccchannel_4_analyzer_2_array_crystal_array_6_mask_string, 0 ? 0 : "", 16384); else mccchannel_4_analyzer_2_array_crystal_array_6_mask_string[0]='\0';
#line 71 "MACS_sample_kidney_box.instr"
  if(0) strncpy(mccchannel_4_analyzer_2_array_crystal_array_6_mask_setting, 0 ? 0 : "", 16384); else mccchannel_4_analyzer_2_array_crystal_array_6_mask_setting[0]='\0';
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_4_analyzer_2_array_crystal_array_6_number_of_activations = 1;
#line 108637 "MACS_sample_kidney_box.c"

  SIG_MESSAGE("channel_4_analyzer_2_array_crystal_array_6 (Init:Place/Rotate)");
  rot_set_rotation(mctr1,
#line 1501 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 1501 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 1501 "MACS_sample_kidney_box.instr"
    (0 - RAD2DEG * channel_4_analyzer_2_array_theta [ 6 ])*DEG2RAD);
#line 108647 "MACS_sample_kidney_box.c"
  rot_mul(mctr1, mcrotachannel_4_analyzer_2_rotated, mcrotachannel_4_analyzer_2_array_crystal_array_6);
  rot_transpose(mcrotachannel_4_analyzer_2_array_crystal_array_5, mctr1);
  rot_mul(mcrotachannel_4_analyzer_2_array_crystal_array_6, mctr1, mcrotrchannel_4_analyzer_2_array_crystal_array_6);
  mctc1 = coords_set(
#line 1500 "MACS_sample_kidney_box.instr"
    0 + channel_4_analyzer_2_array_effective_radius_of_curvature * ( 1 - cos ( channel_4_analyzer_2_array_theta [ 6 ] ) ),
#line 1500 "MACS_sample_kidney_box.instr"
    0 + channel_4_analyzer_2_array_effective_radius_of_curvature * sin ( channel_4_analyzer_2_array_theta [ 6 ] ),
#line 1500 "MACS_sample_kidney_box.instr"
    0);
#line 108658 "MACS_sample_kidney_box.c"
  rot_transpose(mcrotachannel_4_analyzer_2_rotated, mctr1);
  mctc2 = rot_apply(mctr1, mctc1);
  mcposachannel_4_analyzer_2_array_crystal_array_6 = coords_add(mcposachannel_4_analyzer_2_rotated, mctc2);
  mctc1 = coords_sub(mcposachannel_4_analyzer_2_array_crystal_array_5, mcposachannel_4_analyzer_2_array_crystal_array_6);
  mcposrchannel_4_analyzer_2_array_crystal_array_6 = rot_apply(mcrotachannel_4_analyzer_2_array_crystal_array_6, mctc1);
  mcDEBUG_COMPONENT("channel_4_analyzer_2_array_crystal_array_6", mcposachannel_4_analyzer_2_array_crystal_array_6, mcrotachannel_4_analyzer_2_array_crystal_array_6)
  mccomp_posa[299] = mcposachannel_4_analyzer_2_array_crystal_array_6;
  mccomp_posr[299] = mcposrchannel_4_analyzer_2_array_crystal_array_6;
  mcNCounter[299]  = mcPCounter[299] = mcP2Counter[299] = 0;
  mcAbsorbProp[299]= 0;
    /* Component channel_4_analyzer_2_array_crystal_array_7. */
  /* Setting parameters for component channel_4_analyzer_2_array_crystal_array_7. */
  SIG_MESSAGE("channel_4_analyzer_2_array_crystal_array_7 (Init:SetPar)");
#line 1505 "MACS_sample_kidney_box.instr"
  if("PG_analyzer") strncpy(mccchannel_4_analyzer_2_array_crystal_array_7_material_string, "PG_analyzer" ? "PG_analyzer" : "", 16384); else mccchannel_4_analyzer_2_array_crystal_array_7_material_string[0]='\0';
#line 1505 "MACS_sample_kidney_box.instr"
  mccchannel_4_analyzer_2_array_crystal_array_7_priority = 621.7;
#line 1504 "MACS_sample_kidney_box.instr"
  mccchannel_4_analyzer_2_array_crystal_array_7_xwidth = channel_4_analyzer_2_array_crystal_depth;
#line 1504 "MACS_sample_kidney_box.instr"
  mccchannel_4_analyzer_2_array_crystal_array_7_yheight = channel_4_analyzer_2_array_crystal_height;
#line 1504 "MACS_sample_kidney_box.instr"
  mccchannel_4_analyzer_2_array_crystal_array_7_zdepth = channel_4_analyzer_2_array_crystal_width;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_4_analyzer_2_array_crystal_array_7_xwidth2 = -1;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_4_analyzer_2_array_crystal_array_7_yheight2 = -1;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_4_analyzer_2_array_crystal_array_7_visualize = 1;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_4_analyzer_2_array_crystal_array_7_target_index = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_4_analyzer_2_array_crystal_array_7_target_x = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_4_analyzer_2_array_crystal_array_7_target_y = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_4_analyzer_2_array_crystal_array_7_target_z = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_4_analyzer_2_array_crystal_array_7_focus_aw = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_4_analyzer_2_array_crystal_array_7_focus_ah = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_4_analyzer_2_array_crystal_array_7_focus_xw = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_4_analyzer_2_array_crystal_array_7_focus_xh = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_4_analyzer_2_array_crystal_array_7_focus_r = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_4_analyzer_2_array_crystal_array_7_p_interact = 0;
#line 71 "MACS_sample_kidney_box.instr"
  if(0) strncpy(mccchannel_4_analyzer_2_array_crystal_array_7_mask_string, 0 ? 0 : "", 16384); else mccchannel_4_analyzer_2_array_crystal_array_7_mask_string[0]='\0';
#line 71 "MACS_sample_kidney_box.instr"
  if(0) strncpy(mccchannel_4_analyzer_2_array_crystal_array_7_mask_setting, 0 ? 0 : "", 16384); else mccchannel_4_analyzer_2_array_crystal_array_7_mask_setting[0]='\0';
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_4_analyzer_2_array_crystal_array_7_number_of_activations = 1;
#line 108714 "MACS_sample_kidney_box.c"

  SIG_MESSAGE("channel_4_analyzer_2_array_crystal_array_7 (Init:Place/Rotate)");
  rot_set_rotation(mctr1,
#line 1507 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 1507 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 1507 "MACS_sample_kidney_box.instr"
    (0 - RAD2DEG * channel_4_analyzer_2_array_theta [ 7 ])*DEG2RAD);
#line 108724 "MACS_sample_kidney_box.c"
  rot_mul(mctr1, mcrotachannel_4_analyzer_2_rotated, mcrotachannel_4_analyzer_2_array_crystal_array_7);
  rot_transpose(mcrotachannel_4_analyzer_2_array_crystal_array_6, mctr1);
  rot_mul(mcrotachannel_4_analyzer_2_array_crystal_array_7, mctr1, mcrotrchannel_4_analyzer_2_array_crystal_array_7);
  mctc1 = coords_set(
#line 1506 "MACS_sample_kidney_box.instr"
    0 + channel_4_analyzer_2_array_effective_radius_of_curvature * ( 1 - cos ( channel_4_analyzer_2_array_theta [ 7 ] ) ),
#line 1506 "MACS_sample_kidney_box.instr"
    0 + channel_4_analyzer_2_array_effective_radius_of_curvature * sin ( channel_4_analyzer_2_array_theta [ 7 ] ),
#line 1506 "MACS_sample_kidney_box.instr"
    0);
#line 108735 "MACS_sample_kidney_box.c"
  rot_transpose(mcrotachannel_4_analyzer_2_rotated, mctr1);
  mctc2 = rot_apply(mctr1, mctc1);
  mcposachannel_4_analyzer_2_array_crystal_array_7 = coords_add(mcposachannel_4_analyzer_2_rotated, mctc2);
  mctc1 = coords_sub(mcposachannel_4_analyzer_2_array_crystal_array_6, mcposachannel_4_analyzer_2_array_crystal_array_7);
  mcposrchannel_4_analyzer_2_array_crystal_array_7 = rot_apply(mcrotachannel_4_analyzer_2_array_crystal_array_7, mctc1);
  mcDEBUG_COMPONENT("channel_4_analyzer_2_array_crystal_array_7", mcposachannel_4_analyzer_2_array_crystal_array_7, mcrotachannel_4_analyzer_2_array_crystal_array_7)
  mccomp_posa[300] = mcposachannel_4_analyzer_2_array_crystal_array_7;
  mccomp_posr[300] = mcposrchannel_4_analyzer_2_array_crystal_array_7;
  mcNCounter[300]  = mcPCounter[300] = mcP2Counter[300] = 0;
  mcAbsorbProp[300]= 0;
    /* Component channel_4_analyzer_2_array_crystal_array_8. */
  /* Setting parameters for component channel_4_analyzer_2_array_crystal_array_8. */
  SIG_MESSAGE("channel_4_analyzer_2_array_crystal_array_8 (Init:SetPar)");
#line 1511 "MACS_sample_kidney_box.instr"
  if("PG_analyzer") strncpy(mccchannel_4_analyzer_2_array_crystal_array_8_material_string, "PG_analyzer" ? "PG_analyzer" : "", 16384); else mccchannel_4_analyzer_2_array_crystal_array_8_material_string[0]='\0';
#line 1511 "MACS_sample_kidney_box.instr"
  mccchannel_4_analyzer_2_array_crystal_array_8_priority = 621.8;
#line 1510 "MACS_sample_kidney_box.instr"
  mccchannel_4_analyzer_2_array_crystal_array_8_xwidth = channel_4_analyzer_2_array_crystal_depth;
#line 1510 "MACS_sample_kidney_box.instr"
  mccchannel_4_analyzer_2_array_crystal_array_8_yheight = channel_4_analyzer_2_array_crystal_height;
#line 1510 "MACS_sample_kidney_box.instr"
  mccchannel_4_analyzer_2_array_crystal_array_8_zdepth = channel_4_analyzer_2_array_crystal_width;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_4_analyzer_2_array_crystal_array_8_xwidth2 = -1;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_4_analyzer_2_array_crystal_array_8_yheight2 = -1;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_4_analyzer_2_array_crystal_array_8_visualize = 1;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_4_analyzer_2_array_crystal_array_8_target_index = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_4_analyzer_2_array_crystal_array_8_target_x = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_4_analyzer_2_array_crystal_array_8_target_y = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_4_analyzer_2_array_crystal_array_8_target_z = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_4_analyzer_2_array_crystal_array_8_focus_aw = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_4_analyzer_2_array_crystal_array_8_focus_ah = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_4_analyzer_2_array_crystal_array_8_focus_xw = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_4_analyzer_2_array_crystal_array_8_focus_xh = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_4_analyzer_2_array_crystal_array_8_focus_r = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_4_analyzer_2_array_crystal_array_8_p_interact = 0;
#line 71 "MACS_sample_kidney_box.instr"
  if(0) strncpy(mccchannel_4_analyzer_2_array_crystal_array_8_mask_string, 0 ? 0 : "", 16384); else mccchannel_4_analyzer_2_array_crystal_array_8_mask_string[0]='\0';
#line 71 "MACS_sample_kidney_box.instr"
  if(0) strncpy(mccchannel_4_analyzer_2_array_crystal_array_8_mask_setting, 0 ? 0 : "", 16384); else mccchannel_4_analyzer_2_array_crystal_array_8_mask_setting[0]='\0';
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_4_analyzer_2_array_crystal_array_8_number_of_activations = 1;
#line 108791 "MACS_sample_kidney_box.c"

  SIG_MESSAGE("channel_4_analyzer_2_array_crystal_array_8 (Init:Place/Rotate)");
  rot_set_rotation(mctr1,
#line 1513 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 1513 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 1513 "MACS_sample_kidney_box.instr"
    (0 - RAD2DEG * channel_4_analyzer_2_array_theta [ 8 ])*DEG2RAD);
#line 108801 "MACS_sample_kidney_box.c"
  rot_mul(mctr1, mcrotachannel_4_analyzer_2_rotated, mcrotachannel_4_analyzer_2_array_crystal_array_8);
  rot_transpose(mcrotachannel_4_analyzer_2_array_crystal_array_7, mctr1);
  rot_mul(mcrotachannel_4_analyzer_2_array_crystal_array_8, mctr1, mcrotrchannel_4_analyzer_2_array_crystal_array_8);
  mctc1 = coords_set(
#line 1512 "MACS_sample_kidney_box.instr"
    0 + channel_4_analyzer_2_array_effective_radius_of_curvature * ( 1 - cos ( channel_4_analyzer_2_array_theta [ 8 ] ) ),
#line 1512 "MACS_sample_kidney_box.instr"
    0 + channel_4_analyzer_2_array_effective_radius_of_curvature * sin ( channel_4_analyzer_2_array_theta [ 8 ] ),
#line 1512 "MACS_sample_kidney_box.instr"
    0);
#line 108812 "MACS_sample_kidney_box.c"
  rot_transpose(mcrotachannel_4_analyzer_2_rotated, mctr1);
  mctc2 = rot_apply(mctr1, mctc1);
  mcposachannel_4_analyzer_2_array_crystal_array_8 = coords_add(mcposachannel_4_analyzer_2_rotated, mctc2);
  mctc1 = coords_sub(mcposachannel_4_analyzer_2_array_crystal_array_7, mcposachannel_4_analyzer_2_array_crystal_array_8);
  mcposrchannel_4_analyzer_2_array_crystal_array_8 = rot_apply(mcrotachannel_4_analyzer_2_array_crystal_array_8, mctc1);
  mcDEBUG_COMPONENT("channel_4_analyzer_2_array_crystal_array_8", mcposachannel_4_analyzer_2_array_crystal_array_8, mcrotachannel_4_analyzer_2_array_crystal_array_8)
  mccomp_posa[301] = mcposachannel_4_analyzer_2_array_crystal_array_8;
  mccomp_posr[301] = mcposrchannel_4_analyzer_2_array_crystal_array_8;
  mcNCounter[301]  = mcPCounter[301] = mcP2Counter[301] = 0;
  mcAbsorbProp[301]= 0;
    /* Component channel_4_cave2_cyl1. */
  /* Setting parameters for component channel_4_cave2_cyl1. */
  SIG_MESSAGE("channel_4_cave2_cyl1 (Init:SetPar)");
#line 1518 "MACS_sample_kidney_box.instr"
  if("Vacuum") strncpy(mccchannel_4_cave2_cyl1_material_string, "Vacuum" ? "Vacuum" : "", 16384); else mccchannel_4_cave2_cyl1_material_string[0]='\0';
#line 1518 "MACS_sample_kidney_box.instr"
  mccchannel_4_cave2_cyl1_priority = 607.5;
#line 1517 "MACS_sample_kidney_box.instr"
  mccchannel_4_cave2_cyl1_radius = kidney_cave2_cyl1_radius;
#line 1517 "MACS_sample_kidney_box.instr"
  mccchannel_4_cave2_cyl1_yheight = kidney_cave2_cyl1_height;
#line 67 "MACS_sample_kidney_box.instr"
  mccchannel_4_cave2_cyl1_visualize = 1;
#line 67 "MACS_sample_kidney_box.instr"
  mccchannel_4_cave2_cyl1_target_index = 0;
#line 67 "MACS_sample_kidney_box.instr"
  mccchannel_4_cave2_cyl1_target_x = 0;
#line 67 "MACS_sample_kidney_box.instr"
  mccchannel_4_cave2_cyl1_target_y = 0;
#line 67 "MACS_sample_kidney_box.instr"
  mccchannel_4_cave2_cyl1_target_z = 0;
#line 67 "MACS_sample_kidney_box.instr"
  mccchannel_4_cave2_cyl1_focus_aw = 0;
#line 67 "MACS_sample_kidney_box.instr"
  mccchannel_4_cave2_cyl1_focus_ah = 0;
#line 67 "MACS_sample_kidney_box.instr"
  mccchannel_4_cave2_cyl1_focus_xw = 0;
#line 67 "MACS_sample_kidney_box.instr"
  mccchannel_4_cave2_cyl1_focus_xh = 0;
#line 67 "MACS_sample_kidney_box.instr"
  mccchannel_4_cave2_cyl1_focus_r = 0;
#line 67 "MACS_sample_kidney_box.instr"
  mccchannel_4_cave2_cyl1_p_interact = 0;
#line 67 "MACS_sample_kidney_box.instr"
  if(0) strncpy(mccchannel_4_cave2_cyl1_mask_string, 0 ? 0 : "", 16384); else mccchannel_4_cave2_cyl1_mask_string[0]='\0';
#line 67 "MACS_sample_kidney_box.instr"
  if(0) strncpy(mccchannel_4_cave2_cyl1_mask_setting, 0 ? 0 : "", 16384); else mccchannel_4_cave2_cyl1_mask_setting[0]='\0';
#line 67 "MACS_sample_kidney_box.instr"
  mccchannel_4_cave2_cyl1_number_of_activations = 1;
#line 108862 "MACS_sample_kidney_box.c"

  SIG_MESSAGE("channel_4_cave2_cyl1 (Init:Place/Rotate)");
  rot_set_rotation(mctr1,
#line 1520 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 1520 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 1520 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD);
#line 108872 "MACS_sample_kidney_box.c"
  rot_mul(mctr1, mcrotachannel_4_analyzer_2_center, mcrotachannel_4_cave2_cyl1);
  rot_transpose(mcrotachannel_4_analyzer_2_array_crystal_array_8, mctr1);
  rot_mul(mcrotachannel_4_cave2_cyl1, mctr1, mcrotrchannel_4_cave2_cyl1);
  mctc1 = coords_set(
#line 1519 "MACS_sample_kidney_box.instr"
    0,
#line 1519 "MACS_sample_kidney_box.instr"
    0,
#line 1519 "MACS_sample_kidney_box.instr"
    spec_detector_to_analyzer_2_center);
#line 108883 "MACS_sample_kidney_box.c"
  rot_transpose(mcrotachannel_4_analyzer_2_center, mctr1);
  mctc2 = rot_apply(mctr1, mctc1);
  mcposachannel_4_cave2_cyl1 = coords_add(mcposachannel_4_analyzer_2_center, mctc2);
  mctc1 = coords_sub(mcposachannel_4_analyzer_2_array_crystal_array_8, mcposachannel_4_cave2_cyl1);
  mcposrchannel_4_cave2_cyl1 = rot_apply(mcrotachannel_4_cave2_cyl1, mctc1);
  mcDEBUG_COMPONENT("channel_4_cave2_cyl1", mcposachannel_4_cave2_cyl1, mcrotachannel_4_cave2_cyl1)
  mccomp_posa[302] = mcposachannel_4_cave2_cyl1;
  mccomp_posr[302] = mcposrchannel_4_cave2_cyl1;
  mcNCounter[302]  = mcPCounter[302] = mcP2Counter[302] = 0;
  mcAbsorbProp[302]= 0;
    /* Component channel_4_cave2_box1. */
  /* Setting parameters for component channel_4_cave2_box1. */
  SIG_MESSAGE("channel_4_cave2_box1 (Init:SetPar)");
#line 1525 "MACS_sample_kidney_box.instr"
  if("Vacuum") strncpy(mccchannel_4_cave2_box1_material_string, "Vacuum" ? "Vacuum" : "", 16384); else mccchannel_4_cave2_box1_material_string[0]='\0';
#line 1525 "MACS_sample_kidney_box.instr"
  mccchannel_4_cave2_box1_priority = 601;
#line 1523 "MACS_sample_kidney_box.instr"
  mccchannel_4_cave2_box1_xwidth = kidney_cave2_box1_width1;
#line 1523 "MACS_sample_kidney_box.instr"
  mccchannel_4_cave2_box1_yheight = kidney_cave2_box1_height1;
#line 1523 "MACS_sample_kidney_box.instr"
  mccchannel_4_cave2_box1_zdepth = kidney_cave2_box1_depth;
#line 1524 "MACS_sample_kidney_box.instr"
  mccchannel_4_cave2_box1_xwidth2 = kidney_cave2_box1_width2;
#line 1524 "MACS_sample_kidney_box.instr"
  mccchannel_4_cave2_box1_yheight2 = kidney_cave2_box1_height2;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_4_cave2_box1_visualize = 1;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_4_cave2_box1_target_index = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_4_cave2_box1_target_x = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_4_cave2_box1_target_y = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_4_cave2_box1_target_z = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_4_cave2_box1_focus_aw = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_4_cave2_box1_focus_ah = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_4_cave2_box1_focus_xw = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_4_cave2_box1_focus_xh = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_4_cave2_box1_focus_r = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_4_cave2_box1_p_interact = 0;
#line 71 "MACS_sample_kidney_box.instr"
  if(0) strncpy(mccchannel_4_cave2_box1_mask_string, 0 ? 0 : "", 16384); else mccchannel_4_cave2_box1_mask_string[0]='\0';
#line 71 "MACS_sample_kidney_box.instr"
  if(0) strncpy(mccchannel_4_cave2_box1_mask_setting, 0 ? 0 : "", 16384); else mccchannel_4_cave2_box1_mask_setting[0]='\0';
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_4_cave2_box1_number_of_activations = 1;
#line 108939 "MACS_sample_kidney_box.c"

  SIG_MESSAGE("channel_4_cave2_box1 (Init:Place/Rotate)");
  rot_set_rotation(mctr1,
#line 1527 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 1527 "MACS_sample_kidney_box.instr"
    (kidney_cave2_box1_y_rotation)*DEG2RAD,
#line 1527 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD);
#line 108949 "MACS_sample_kidney_box.c"
  rot_mul(mctr1, mcrotachannel_4_cave2_cyl1, mcrotachannel_4_cave2_box1);
  rot_transpose(mcrotachannel_4_cave2_cyl1, mctr1);
  rot_mul(mcrotachannel_4_cave2_box1, mctr1, mcrotrchannel_4_cave2_box1);
  mctc1 = coords_set(
#line 1526 "MACS_sample_kidney_box.instr"
    kidney_cave2_box1_center_to_spec_detector_x,
#line 1526 "MACS_sample_kidney_box.instr"
    0,
#line 1526 "MACS_sample_kidney_box.instr"
    kidney_cave2_box1_center_to_spec_detector_z);
#line 108960 "MACS_sample_kidney_box.c"
  rot_transpose(mcrotachannel_4_cave2_cyl1, mctr1);
  mctc2 = rot_apply(mctr1, mctc1);
  mcposachannel_4_cave2_box1 = coords_add(mcposachannel_4_cave2_cyl1, mctc2);
  mctc1 = coords_sub(mcposachannel_4_cave2_cyl1, mcposachannel_4_cave2_box1);
  mcposrchannel_4_cave2_box1 = rot_apply(mcrotachannel_4_cave2_box1, mctc1);
  mcDEBUG_COMPONENT("channel_4_cave2_box1", mcposachannel_4_cave2_box1, mcrotachannel_4_cave2_box1)
  mccomp_posa[303] = mcposachannel_4_cave2_box1;
  mccomp_posr[303] = mcposrchannel_4_cave2_box1;
  mcNCounter[303]  = mcPCounter[303] = mcP2Counter[303] = 0;
  mcAbsorbProp[303]= 0;
    /* Component channel_4_cave2_box2. */
  /* Setting parameters for component channel_4_cave2_box2. */
  SIG_MESSAGE("channel_4_cave2_box2 (Init:SetPar)");
#line 1532 "MACS_sample_kidney_box.instr"
  if("Vacuum") strncpy(mccchannel_4_cave2_box2_material_string, "Vacuum" ? "Vacuum" : "", 16384); else mccchannel_4_cave2_box2_material_string[0]='\0';
#line 1532 "MACS_sample_kidney_box.instr"
  mccchannel_4_cave2_box2_priority = 606;
#line 1530 "MACS_sample_kidney_box.instr"
  mccchannel_4_cave2_box2_xwidth = kidney_cave2_box2_width1;
#line 1530 "MACS_sample_kidney_box.instr"
  mccchannel_4_cave2_box2_yheight = kidney_cave2_box2_height1;
#line 1530 "MACS_sample_kidney_box.instr"
  mccchannel_4_cave2_box2_zdepth = kidney_cave2_box2_depth;
#line 1531 "MACS_sample_kidney_box.instr"
  mccchannel_4_cave2_box2_xwidth2 = kidney_cave2_box2_width2;
#line 1531 "MACS_sample_kidney_box.instr"
  mccchannel_4_cave2_box2_yheight2 = kidney_cave2_box2_height2;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_4_cave2_box2_visualize = 1;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_4_cave2_box2_target_index = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_4_cave2_box2_target_x = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_4_cave2_box2_target_y = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_4_cave2_box2_target_z = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_4_cave2_box2_focus_aw = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_4_cave2_box2_focus_ah = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_4_cave2_box2_focus_xw = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_4_cave2_box2_focus_xh = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_4_cave2_box2_focus_r = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_4_cave2_box2_p_interact = 0;
#line 71 "MACS_sample_kidney_box.instr"
  if(0) strncpy(mccchannel_4_cave2_box2_mask_string, 0 ? 0 : "", 16384); else mccchannel_4_cave2_box2_mask_string[0]='\0';
#line 71 "MACS_sample_kidney_box.instr"
  if(0) strncpy(mccchannel_4_cave2_box2_mask_setting, 0 ? 0 : "", 16384); else mccchannel_4_cave2_box2_mask_setting[0]='\0';
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_4_cave2_box2_number_of_activations = 1;
#line 109016 "MACS_sample_kidney_box.c"

  SIG_MESSAGE("channel_4_cave2_box2 (Init:Place/Rotate)");
  rot_set_rotation(mctr1,
#line 1534 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 1534 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 1534 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD);
#line 109026 "MACS_sample_kidney_box.c"
  rot_mul(mctr1, mcrotachannel_4_cave2_cyl1, mcrotachannel_4_cave2_box2);
  rot_transpose(mcrotachannel_4_cave2_box1, mctr1);
  rot_mul(mcrotachannel_4_cave2_box2, mctr1, mcrotrchannel_4_cave2_box2);
  mctc1 = coords_set(
#line 1533 "MACS_sample_kidney_box.instr"
    0,
#line 1533 "MACS_sample_kidney_box.instr"
    0,
#line 1533 "MACS_sample_kidney_box.instr"
    kidney_cave2_box2_center_to_detector);
#line 109037 "MACS_sample_kidney_box.c"
  rot_transpose(mcrotachannel_4_cave2_cyl1, mctr1);
  mctc2 = rot_apply(mctr1, mctc1);
  mcposachannel_4_cave2_box2 = coords_add(mcposachannel_4_cave2_cyl1, mctc2);
  mctc1 = coords_sub(mcposachannel_4_cave2_box1, mcposachannel_4_cave2_box2);
  mcposrchannel_4_cave2_box2 = rot_apply(mcrotachannel_4_cave2_box2, mctc1);
  mcDEBUG_COMPONENT("channel_4_cave2_box2", mcposachannel_4_cave2_box2, mcrotachannel_4_cave2_box2)
  mccomp_posa[304] = mcposachannel_4_cave2_box2;
  mccomp_posr[304] = mcposrchannel_4_cave2_box2;
  mcNCounter[304]  = mcPCounter[304] = mcP2Counter[304] = 0;
  mcAbsorbProp[304]= 0;
    /* Component channel_4_cave2_box3. */
  /* Setting parameters for component channel_4_cave2_box3. */
  SIG_MESSAGE("channel_4_cave2_box3 (Init:SetPar)");
#line 1539 "MACS_sample_kidney_box.instr"
  if("Vacuum") strncpy(mccchannel_4_cave2_box3_material_string, "Vacuum" ? "Vacuum" : "", 16384); else mccchannel_4_cave2_box3_material_string[0]='\0';
#line 1539 "MACS_sample_kidney_box.instr"
  mccchannel_4_cave2_box3_priority = 607;
#line 1537 "MACS_sample_kidney_box.instr"
  mccchannel_4_cave2_box3_xwidth = kidney_cave2_box3_width1;
#line 1537 "MACS_sample_kidney_box.instr"
  mccchannel_4_cave2_box3_yheight = kidney_cave2_box3_height1;
#line 1537 "MACS_sample_kidney_box.instr"
  mccchannel_4_cave2_box3_zdepth = kidney_cave2_box3_depth;
#line 1538 "MACS_sample_kidney_box.instr"
  mccchannel_4_cave2_box3_xwidth2 = kidney_cave2_box3_width2;
#line 1538 "MACS_sample_kidney_box.instr"
  mccchannel_4_cave2_box3_yheight2 = kidney_cave2_box3_height2;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_4_cave2_box3_visualize = 1;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_4_cave2_box3_target_index = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_4_cave2_box3_target_x = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_4_cave2_box3_target_y = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_4_cave2_box3_target_z = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_4_cave2_box3_focus_aw = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_4_cave2_box3_focus_ah = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_4_cave2_box3_focus_xw = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_4_cave2_box3_focus_xh = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_4_cave2_box3_focus_r = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_4_cave2_box3_p_interact = 0;
#line 71 "MACS_sample_kidney_box.instr"
  if(0) strncpy(mccchannel_4_cave2_box3_mask_string, 0 ? 0 : "", 16384); else mccchannel_4_cave2_box3_mask_string[0]='\0';
#line 71 "MACS_sample_kidney_box.instr"
  if(0) strncpy(mccchannel_4_cave2_box3_mask_setting, 0 ? 0 : "", 16384); else mccchannel_4_cave2_box3_mask_setting[0]='\0';
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_4_cave2_box3_number_of_activations = 1;
#line 109093 "MACS_sample_kidney_box.c"

  SIG_MESSAGE("channel_4_cave2_box3 (Init:Place/Rotate)");
  rot_set_rotation(mctr1,
#line 1541 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 1541 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 1541 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD);
#line 109103 "MACS_sample_kidney_box.c"
  rot_mul(mctr1, mcrotachannel_4_cave2_cyl1, mcrotachannel_4_cave2_box3);
  rot_transpose(mcrotachannel_4_cave2_box2, mctr1);
  rot_mul(mcrotachannel_4_cave2_box3, mctr1, mcrotrchannel_4_cave2_box3);
  mctc1 = coords_set(
#line 1540 "MACS_sample_kidney_box.instr"
    0,
#line 1540 "MACS_sample_kidney_box.instr"
    0,
#line 1540 "MACS_sample_kidney_box.instr"
    kidney_cave2_box3_center_to_detector);
#line 109114 "MACS_sample_kidney_box.c"
  rot_transpose(mcrotachannel_4_cave2_cyl1, mctr1);
  mctc2 = rot_apply(mctr1, mctc1);
  mcposachannel_4_cave2_box3 = coords_add(mcposachannel_4_cave2_cyl1, mctc2);
  mctc1 = coords_sub(mcposachannel_4_cave2_box2, mcposachannel_4_cave2_box3);
  mcposrchannel_4_cave2_box3 = rot_apply(mcrotachannel_4_cave2_box3, mctc1);
  mcDEBUG_COMPONENT("channel_4_cave2_box3", mcposachannel_4_cave2_box3, mcrotachannel_4_cave2_box3)
  mccomp_posa[305] = mcposachannel_4_cave2_box3;
  mccomp_posr[305] = mcposrchannel_4_cave2_box3;
  mcNCounter[305]  = mcPCounter[305] = mcP2Counter[305] = 0;
  mcAbsorbProp[305]= 0;
    /* Component inter_analyzer_colimator_center_4. */
  /* Setting parameters for component inter_analyzer_colimator_center_4. */
  SIG_MESSAGE("inter_analyzer_colimator_center_4 (Init:SetPar)");

  SIG_MESSAGE("inter_analyzer_colimator_center_4 (Init:Place/Rotate)");
  rot_set_rotation(mctr1,
#line 1545 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 1545 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 1545 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD);
#line 109137 "MACS_sample_kidney_box.c"
  rot_mul(mctr1, mcrotachannel_4_analyzer_1_center, mcrotainter_analyzer_colimator_center_4);
  rot_transpose(mcrotachannel_4_cave2_box3, mctr1);
  rot_mul(mcrotainter_analyzer_colimator_center_4, mctr1, mcrotrinter_analyzer_colimator_center_4);
  mctc1 = coords_set(
#line 1544 "MACS_sample_kidney_box.instr"
    -0.5 * analyzer_seperation,
#line 1544 "MACS_sample_kidney_box.instr"
    0,
#line 1544 "MACS_sample_kidney_box.instr"
    0);
#line 109148 "MACS_sample_kidney_box.c"
  rot_transpose(mcrotachannel_4_analyzer_1_center, mctr1);
  mctc2 = rot_apply(mctr1, mctc1);
  mcposainter_analyzer_colimator_center_4 = coords_add(mcposachannel_4_analyzer_1_center, mctc2);
  mctc1 = coords_sub(mcposachannel_4_cave2_box3, mcposainter_analyzer_colimator_center_4);
  mcposrinter_analyzer_colimator_center_4 = rot_apply(mcrotainter_analyzer_colimator_center_4, mctc1);
  mcDEBUG_COMPONENT("inter_analyzer_colimator_center_4", mcposainter_analyzer_colimator_center_4, mcrotainter_analyzer_colimator_center_4)
  mccomp_posa[306] = mcposainter_analyzer_colimator_center_4;
  mccomp_posr[306] = mcposrinter_analyzer_colimator_center_4;
  mcNCounter[306]  = mcPCounter[306] = mcP2Counter[306] = 0;
  mcAbsorbProp[306]= 0;
    /* Component inter_analyzer_colimator_4_blade_0. */
  /* Setting parameters for component inter_analyzer_colimator_4_blade_0. */
  SIG_MESSAGE("inter_analyzer_colimator_4_blade_0 (Init:SetPar)");
#line 1549 "MACS_sample_kidney_box.instr"
  if("Collimator_gad") strncpy(mccinter_analyzer_colimator_4_blade_0_material_string, "Collimator_gad" ? "Collimator_gad" : "", 16384); else mccinter_analyzer_colimator_4_blade_0_material_string[0]='\0';
#line 1549 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_4_blade_0_priority = 625;
#line 1548 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_4_blade_0_xwidth = inter_analyzer_colimator_width;
#line 1548 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_4_blade_0_yheight = inter_analyzer_colimator_height;
#line 1548 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_4_blade_0_zdepth = inter_analyzer_colimator_depth;
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_4_blade_0_xwidth2 = -1;
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_4_blade_0_yheight2 = -1;
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_4_blade_0_visualize = 1;
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_4_blade_0_target_index = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_4_blade_0_target_x = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_4_blade_0_target_y = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_4_blade_0_target_z = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_4_blade_0_focus_aw = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_4_blade_0_focus_ah = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_4_blade_0_focus_xw = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_4_blade_0_focus_xh = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_4_blade_0_focus_r = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_4_blade_0_p_interact = 0;
#line 71 "MACS_sample_kidney_box.instr"
  if(0) strncpy(mccinter_analyzer_colimator_4_blade_0_mask_string, 0 ? 0 : "", 16384); else mccinter_analyzer_colimator_4_blade_0_mask_string[0]='\0';
#line 71 "MACS_sample_kidney_box.instr"
  if(0) strncpy(mccinter_analyzer_colimator_4_blade_0_mask_setting, 0 ? 0 : "", 16384); else mccinter_analyzer_colimator_4_blade_0_mask_setting[0]='\0';
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_4_blade_0_number_of_activations = 1;
#line 109204 "MACS_sample_kidney_box.c"

  SIG_MESSAGE("inter_analyzer_colimator_4_blade_0 (Init:Place/Rotate)");
  rot_set_rotation(mctr1,
#line 1551 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 1551 "MACS_sample_kidney_box.instr"
    (- analyzer_2theta [ 4 ])*DEG2RAD,
#line 1551 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD);
#line 109214 "MACS_sample_kidney_box.c"
  rot_mul(mctr1, mcrotainter_analyzer_colimator_center_4, mcrotainter_analyzer_colimator_4_blade_0);
  rot_transpose(mcrotainter_analyzer_colimator_center_4, mctr1);
  rot_mul(mcrotainter_analyzer_colimator_4_blade_0, mctr1, mcrotrinter_analyzer_colimator_4_blade_0);
  mctc1 = coords_set(
#line 1550 "MACS_sample_kidney_box.instr"
    0,
#line 1550 "MACS_sample_kidney_box.instr"
    0,
#line 1550 "MACS_sample_kidney_box.instr"
    inter_analyzer_colimator_start_pos - 0 * inter_analyzer_colimator_seperation);
#line 109225 "MACS_sample_kidney_box.c"
  rot_transpose(mcrotainter_analyzer_colimator_center_4, mctr1);
  mctc2 = rot_apply(mctr1, mctc1);
  mcposainter_analyzer_colimator_4_blade_0 = coords_add(mcposainter_analyzer_colimator_center_4, mctc2);
  mctc1 = coords_sub(mcposainter_analyzer_colimator_center_4, mcposainter_analyzer_colimator_4_blade_0);
  mcposrinter_analyzer_colimator_4_blade_0 = rot_apply(mcrotainter_analyzer_colimator_4_blade_0, mctc1);
  mcDEBUG_COMPONENT("inter_analyzer_colimator_4_blade_0", mcposainter_analyzer_colimator_4_blade_0, mcrotainter_analyzer_colimator_4_blade_0)
  mccomp_posa[307] = mcposainter_analyzer_colimator_4_blade_0;
  mccomp_posr[307] = mcposrinter_analyzer_colimator_4_blade_0;
  mcNCounter[307]  = mcPCounter[307] = mcP2Counter[307] = 0;
  mcAbsorbProp[307]= 0;
    /* Component inter_analyzer_colimator_4_blade_1. */
  /* Setting parameters for component inter_analyzer_colimator_4_blade_1. */
  SIG_MESSAGE("inter_analyzer_colimator_4_blade_1 (Init:SetPar)");
#line 1555 "MACS_sample_kidney_box.instr"
  if("Collimator_gad") strncpy(mccinter_analyzer_colimator_4_blade_1_material_string, "Collimator_gad" ? "Collimator_gad" : "", 16384); else mccinter_analyzer_colimator_4_blade_1_material_string[0]='\0';
#line 1555 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_4_blade_1_priority = 626;
#line 1554 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_4_blade_1_xwidth = inter_analyzer_colimator_width;
#line 1554 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_4_blade_1_yheight = inter_analyzer_colimator_height;
#line 1554 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_4_blade_1_zdepth = inter_analyzer_colimator_depth;
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_4_blade_1_xwidth2 = -1;
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_4_blade_1_yheight2 = -1;
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_4_blade_1_visualize = 1;
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_4_blade_1_target_index = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_4_blade_1_target_x = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_4_blade_1_target_y = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_4_blade_1_target_z = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_4_blade_1_focus_aw = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_4_blade_1_focus_ah = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_4_blade_1_focus_xw = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_4_blade_1_focus_xh = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_4_blade_1_focus_r = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_4_blade_1_p_interact = 0;
#line 71 "MACS_sample_kidney_box.instr"
  if(0) strncpy(mccinter_analyzer_colimator_4_blade_1_mask_string, 0 ? 0 : "", 16384); else mccinter_analyzer_colimator_4_blade_1_mask_string[0]='\0';
#line 71 "MACS_sample_kidney_box.instr"
  if(0) strncpy(mccinter_analyzer_colimator_4_blade_1_mask_setting, 0 ? 0 : "", 16384); else mccinter_analyzer_colimator_4_blade_1_mask_setting[0]='\0';
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_4_blade_1_number_of_activations = 1;
#line 109281 "MACS_sample_kidney_box.c"

  SIG_MESSAGE("inter_analyzer_colimator_4_blade_1 (Init:Place/Rotate)");
  rot_set_rotation(mctr1,
#line 1557 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 1557 "MACS_sample_kidney_box.instr"
    (- analyzer_2theta [ 4 ])*DEG2RAD,
#line 1557 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD);
#line 109291 "MACS_sample_kidney_box.c"
  rot_mul(mctr1, mcrotainter_analyzer_colimator_center_4, mcrotainter_analyzer_colimator_4_blade_1);
  rot_transpose(mcrotainter_analyzer_colimator_4_blade_0, mctr1);
  rot_mul(mcrotainter_analyzer_colimator_4_blade_1, mctr1, mcrotrinter_analyzer_colimator_4_blade_1);
  mctc1 = coords_set(
#line 1556 "MACS_sample_kidney_box.instr"
    0,
#line 1556 "MACS_sample_kidney_box.instr"
    0,
#line 1556 "MACS_sample_kidney_box.instr"
    inter_analyzer_colimator_start_pos - 1 * inter_analyzer_colimator_seperation);
#line 109302 "MACS_sample_kidney_box.c"
  rot_transpose(mcrotainter_analyzer_colimator_center_4, mctr1);
  mctc2 = rot_apply(mctr1, mctc1);
  mcposainter_analyzer_colimator_4_blade_1 = coords_add(mcposainter_analyzer_colimator_center_4, mctc2);
  mctc1 = coords_sub(mcposainter_analyzer_colimator_4_blade_0, mcposainter_analyzer_colimator_4_blade_1);
  mcposrinter_analyzer_colimator_4_blade_1 = rot_apply(mcrotainter_analyzer_colimator_4_blade_1, mctc1);
  mcDEBUG_COMPONENT("inter_analyzer_colimator_4_blade_1", mcposainter_analyzer_colimator_4_blade_1, mcrotainter_analyzer_colimator_4_blade_1)
  mccomp_posa[308] = mcposainter_analyzer_colimator_4_blade_1;
  mccomp_posr[308] = mcposrinter_analyzer_colimator_4_blade_1;
  mcNCounter[308]  = mcPCounter[308] = mcP2Counter[308] = 0;
  mcAbsorbProp[308]= 0;
    /* Component inter_analyzer_colimator_4_blade_2. */
  /* Setting parameters for component inter_analyzer_colimator_4_blade_2. */
  SIG_MESSAGE("inter_analyzer_colimator_4_blade_2 (Init:SetPar)");
#line 1561 "MACS_sample_kidney_box.instr"
  if("Collimator_gad") strncpy(mccinter_analyzer_colimator_4_blade_2_material_string, "Collimator_gad" ? "Collimator_gad" : "", 16384); else mccinter_analyzer_colimator_4_blade_2_material_string[0]='\0';
#line 1561 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_4_blade_2_priority = 627;
#line 1560 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_4_blade_2_xwidth = inter_analyzer_colimator_width;
#line 1560 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_4_blade_2_yheight = inter_analyzer_colimator_height;
#line 1560 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_4_blade_2_zdepth = inter_analyzer_colimator_depth;
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_4_blade_2_xwidth2 = -1;
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_4_blade_2_yheight2 = -1;
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_4_blade_2_visualize = 1;
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_4_blade_2_target_index = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_4_blade_2_target_x = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_4_blade_2_target_y = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_4_blade_2_target_z = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_4_blade_2_focus_aw = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_4_blade_2_focus_ah = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_4_blade_2_focus_xw = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_4_blade_2_focus_xh = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_4_blade_2_focus_r = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_4_blade_2_p_interact = 0;
#line 71 "MACS_sample_kidney_box.instr"
  if(0) strncpy(mccinter_analyzer_colimator_4_blade_2_mask_string, 0 ? 0 : "", 16384); else mccinter_analyzer_colimator_4_blade_2_mask_string[0]='\0';
#line 71 "MACS_sample_kidney_box.instr"
  if(0) strncpy(mccinter_analyzer_colimator_4_blade_2_mask_setting, 0 ? 0 : "", 16384); else mccinter_analyzer_colimator_4_blade_2_mask_setting[0]='\0';
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_4_blade_2_number_of_activations = 1;
#line 109358 "MACS_sample_kidney_box.c"

  SIG_MESSAGE("inter_analyzer_colimator_4_blade_2 (Init:Place/Rotate)");
  rot_set_rotation(mctr1,
#line 1563 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 1563 "MACS_sample_kidney_box.instr"
    (- analyzer_2theta [ 4 ])*DEG2RAD,
#line 1563 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD);
#line 109368 "MACS_sample_kidney_box.c"
  rot_mul(mctr1, mcrotainter_analyzer_colimator_center_4, mcrotainter_analyzer_colimator_4_blade_2);
  rot_transpose(mcrotainter_analyzer_colimator_4_blade_1, mctr1);
  rot_mul(mcrotainter_analyzer_colimator_4_blade_2, mctr1, mcrotrinter_analyzer_colimator_4_blade_2);
  mctc1 = coords_set(
#line 1562 "MACS_sample_kidney_box.instr"
    0,
#line 1562 "MACS_sample_kidney_box.instr"
    0,
#line 1562 "MACS_sample_kidney_box.instr"
    inter_analyzer_colimator_start_pos - 2 * inter_analyzer_colimator_seperation);
#line 109379 "MACS_sample_kidney_box.c"
  rot_transpose(mcrotainter_analyzer_colimator_center_4, mctr1);
  mctc2 = rot_apply(mctr1, mctc1);
  mcposainter_analyzer_colimator_4_blade_2 = coords_add(mcposainter_analyzer_colimator_center_4, mctc2);
  mctc1 = coords_sub(mcposainter_analyzer_colimator_4_blade_1, mcposainter_analyzer_colimator_4_blade_2);
  mcposrinter_analyzer_colimator_4_blade_2 = rot_apply(mcrotainter_analyzer_colimator_4_blade_2, mctc1);
  mcDEBUG_COMPONENT("inter_analyzer_colimator_4_blade_2", mcposainter_analyzer_colimator_4_blade_2, mcrotainter_analyzer_colimator_4_blade_2)
  mccomp_posa[309] = mcposainter_analyzer_colimator_4_blade_2;
  mccomp_posr[309] = mcposrinter_analyzer_colimator_4_blade_2;
  mcNCounter[309]  = mcPCounter[309] = mcP2Counter[309] = 0;
  mcAbsorbProp[309]= 0;
    /* Component inter_analyzer_colimator_4_blade_3. */
  /* Setting parameters for component inter_analyzer_colimator_4_blade_3. */
  SIG_MESSAGE("inter_analyzer_colimator_4_blade_3 (Init:SetPar)");
#line 1567 "MACS_sample_kidney_box.instr"
  if("Collimator_gad") strncpy(mccinter_analyzer_colimator_4_blade_3_material_string, "Collimator_gad" ? "Collimator_gad" : "", 16384); else mccinter_analyzer_colimator_4_blade_3_material_string[0]='\0';
#line 1567 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_4_blade_3_priority = 628;
#line 1566 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_4_blade_3_xwidth = inter_analyzer_colimator_width;
#line 1566 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_4_blade_3_yheight = inter_analyzer_colimator_height;
#line 1566 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_4_blade_3_zdepth = inter_analyzer_colimator_depth;
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_4_blade_3_xwidth2 = -1;
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_4_blade_3_yheight2 = -1;
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_4_blade_3_visualize = 1;
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_4_blade_3_target_index = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_4_blade_3_target_x = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_4_blade_3_target_y = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_4_blade_3_target_z = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_4_blade_3_focus_aw = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_4_blade_3_focus_ah = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_4_blade_3_focus_xw = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_4_blade_3_focus_xh = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_4_blade_3_focus_r = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_4_blade_3_p_interact = 0;
#line 71 "MACS_sample_kidney_box.instr"
  if(0) strncpy(mccinter_analyzer_colimator_4_blade_3_mask_string, 0 ? 0 : "", 16384); else mccinter_analyzer_colimator_4_blade_3_mask_string[0]='\0';
#line 71 "MACS_sample_kidney_box.instr"
  if(0) strncpy(mccinter_analyzer_colimator_4_blade_3_mask_setting, 0 ? 0 : "", 16384); else mccinter_analyzer_colimator_4_blade_3_mask_setting[0]='\0';
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_4_blade_3_number_of_activations = 1;
#line 109435 "MACS_sample_kidney_box.c"

  SIG_MESSAGE("inter_analyzer_colimator_4_blade_3 (Init:Place/Rotate)");
  rot_set_rotation(mctr1,
#line 1569 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 1569 "MACS_sample_kidney_box.instr"
    (- analyzer_2theta [ 4 ])*DEG2RAD,
#line 1569 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD);
#line 109445 "MACS_sample_kidney_box.c"
  rot_mul(mctr1, mcrotainter_analyzer_colimator_center_4, mcrotainter_analyzer_colimator_4_blade_3);
  rot_transpose(mcrotainter_analyzer_colimator_4_blade_2, mctr1);
  rot_mul(mcrotainter_analyzer_colimator_4_blade_3, mctr1, mcrotrinter_analyzer_colimator_4_blade_3);
  mctc1 = coords_set(
#line 1568 "MACS_sample_kidney_box.instr"
    0,
#line 1568 "MACS_sample_kidney_box.instr"
    0,
#line 1568 "MACS_sample_kidney_box.instr"
    inter_analyzer_colimator_start_pos - 3 * inter_analyzer_colimator_seperation);
#line 109456 "MACS_sample_kidney_box.c"
  rot_transpose(mcrotainter_analyzer_colimator_center_4, mctr1);
  mctc2 = rot_apply(mctr1, mctc1);
  mcposainter_analyzer_colimator_4_blade_3 = coords_add(mcposainter_analyzer_colimator_center_4, mctc2);
  mctc1 = coords_sub(mcposainter_analyzer_colimator_4_blade_2, mcposainter_analyzer_colimator_4_blade_3);
  mcposrinter_analyzer_colimator_4_blade_3 = rot_apply(mcrotainter_analyzer_colimator_4_blade_3, mctc1);
  mcDEBUG_COMPONENT("inter_analyzer_colimator_4_blade_3", mcposainter_analyzer_colimator_4_blade_3, mcrotainter_analyzer_colimator_4_blade_3)
  mccomp_posa[310] = mcposainter_analyzer_colimator_4_blade_3;
  mccomp_posr[310] = mcposrinter_analyzer_colimator_4_blade_3;
  mcNCounter[310]  = mcPCounter[310] = mcP2Counter[310] = 0;
  mcAbsorbProp[310]= 0;
    /* Component inter_analyzer_colimator_4_blade_4. */
  /* Setting parameters for component inter_analyzer_colimator_4_blade_4. */
  SIG_MESSAGE("inter_analyzer_colimator_4_blade_4 (Init:SetPar)");
#line 1573 "MACS_sample_kidney_box.instr"
  if("Collimator_gad") strncpy(mccinter_analyzer_colimator_4_blade_4_material_string, "Collimator_gad" ? "Collimator_gad" : "", 16384); else mccinter_analyzer_colimator_4_blade_4_material_string[0]='\0';
#line 1573 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_4_blade_4_priority = 629;
#line 1572 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_4_blade_4_xwidth = inter_analyzer_colimator_width;
#line 1572 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_4_blade_4_yheight = inter_analyzer_colimator_height;
#line 1572 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_4_blade_4_zdepth = inter_analyzer_colimator_depth;
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_4_blade_4_xwidth2 = -1;
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_4_blade_4_yheight2 = -1;
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_4_blade_4_visualize = 1;
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_4_blade_4_target_index = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_4_blade_4_target_x = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_4_blade_4_target_y = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_4_blade_4_target_z = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_4_blade_4_focus_aw = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_4_blade_4_focus_ah = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_4_blade_4_focus_xw = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_4_blade_4_focus_xh = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_4_blade_4_focus_r = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_4_blade_4_p_interact = 0;
#line 71 "MACS_sample_kidney_box.instr"
  if(0) strncpy(mccinter_analyzer_colimator_4_blade_4_mask_string, 0 ? 0 : "", 16384); else mccinter_analyzer_colimator_4_blade_4_mask_string[0]='\0';
#line 71 "MACS_sample_kidney_box.instr"
  if(0) strncpy(mccinter_analyzer_colimator_4_blade_4_mask_setting, 0 ? 0 : "", 16384); else mccinter_analyzer_colimator_4_blade_4_mask_setting[0]='\0';
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_4_blade_4_number_of_activations = 1;
#line 109512 "MACS_sample_kidney_box.c"

  SIG_MESSAGE("inter_analyzer_colimator_4_blade_4 (Init:Place/Rotate)");
  rot_set_rotation(mctr1,
#line 1575 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 1575 "MACS_sample_kidney_box.instr"
    (- analyzer_2theta [ 4 ])*DEG2RAD,
#line 1575 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD);
#line 109522 "MACS_sample_kidney_box.c"
  rot_mul(mctr1, mcrotainter_analyzer_colimator_center_4, mcrotainter_analyzer_colimator_4_blade_4);
  rot_transpose(mcrotainter_analyzer_colimator_4_blade_3, mctr1);
  rot_mul(mcrotainter_analyzer_colimator_4_blade_4, mctr1, mcrotrinter_analyzer_colimator_4_blade_4);
  mctc1 = coords_set(
#line 1574 "MACS_sample_kidney_box.instr"
    0,
#line 1574 "MACS_sample_kidney_box.instr"
    0,
#line 1574 "MACS_sample_kidney_box.instr"
    inter_analyzer_colimator_start_pos - 4 * inter_analyzer_colimator_seperation);
#line 109533 "MACS_sample_kidney_box.c"
  rot_transpose(mcrotainter_analyzer_colimator_center_4, mctr1);
  mctc2 = rot_apply(mctr1, mctc1);
  mcposainter_analyzer_colimator_4_blade_4 = coords_add(mcposainter_analyzer_colimator_center_4, mctc2);
  mctc1 = coords_sub(mcposainter_analyzer_colimator_4_blade_3, mcposainter_analyzer_colimator_4_blade_4);
  mcposrinter_analyzer_colimator_4_blade_4 = rot_apply(mcrotainter_analyzer_colimator_4_blade_4, mctc1);
  mcDEBUG_COMPONENT("inter_analyzer_colimator_4_blade_4", mcposainter_analyzer_colimator_4_blade_4, mcrotainter_analyzer_colimator_4_blade_4)
  mccomp_posa[311] = mcposainter_analyzer_colimator_4_blade_4;
  mccomp_posr[311] = mcposrinter_analyzer_colimator_4_blade_4;
  mcNCounter[311]  = mcPCounter[311] = mcP2Counter[311] = 0;
  mcAbsorbProp[311]= 0;
    /* Component diffraction_detector_4_exit_volume. */
  /* Setting parameters for component diffraction_detector_4_exit_volume. */
  SIG_MESSAGE("diffraction_detector_4_exit_volume (Init:SetPar)");
#line 1579 "MACS_sample_kidney_box.instr"
  if("Exit") strncpy(mccdiffraction_detector_4_exit_volume_material_string, "Exit" ? "Exit" : "", 16384); else mccdiffraction_detector_4_exit_volume_material_string[0]='\0';
#line 1579 "MACS_sample_kidney_box.instr"
  mccdiffraction_detector_4_exit_volume_priority = 631;
#line 1578 "MACS_sample_kidney_box.instr"
  mccdiffraction_detector_4_exit_volume_xwidth = 2.01 * detector_radius;
#line 1578 "MACS_sample_kidney_box.instr"
  mccdiffraction_detector_4_exit_volume_yheight = 1.01 * detector_height;
#line 1578 "MACS_sample_kidney_box.instr"
  mccdiffraction_detector_4_exit_volume_zdepth = 0.001;
#line 71 "MACS_sample_kidney_box.instr"
  mccdiffraction_detector_4_exit_volume_xwidth2 = -1;
#line 71 "MACS_sample_kidney_box.instr"
  mccdiffraction_detector_4_exit_volume_yheight2 = -1;
#line 71 "MACS_sample_kidney_box.instr"
  mccdiffraction_detector_4_exit_volume_visualize = 1;
#line 71 "MACS_sample_kidney_box.instr"
  mccdiffraction_detector_4_exit_volume_target_index = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccdiffraction_detector_4_exit_volume_target_x = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccdiffraction_detector_4_exit_volume_target_y = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccdiffraction_detector_4_exit_volume_target_z = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccdiffraction_detector_4_exit_volume_focus_aw = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccdiffraction_detector_4_exit_volume_focus_ah = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccdiffraction_detector_4_exit_volume_focus_xw = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccdiffraction_detector_4_exit_volume_focus_xh = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccdiffraction_detector_4_exit_volume_focus_r = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccdiffraction_detector_4_exit_volume_p_interact = 0;
#line 71 "MACS_sample_kidney_box.instr"
  if(0) strncpy(mccdiffraction_detector_4_exit_volume_mask_string, 0 ? 0 : "", 16384); else mccdiffraction_detector_4_exit_volume_mask_string[0]='\0';
#line 71 "MACS_sample_kidney_box.instr"
  if(0) strncpy(mccdiffraction_detector_4_exit_volume_mask_setting, 0 ? 0 : "", 16384); else mccdiffraction_detector_4_exit_volume_mask_setting[0]='\0';
#line 71 "MACS_sample_kidney_box.instr"
  mccdiffraction_detector_4_exit_volume_number_of_activations = 1;
#line 109589 "MACS_sample_kidney_box.c"

  SIG_MESSAGE("diffraction_detector_4_exit_volume (Init:Place/Rotate)");
  rot_set_rotation(mctr1,
#line 1581 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 1581 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 1581 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD);
#line 109599 "MACS_sample_kidney_box.c"
  rot_mul(mctr1, mcrotakidney_channel_4, mcrotadiffraction_detector_4_exit_volume);
  rot_transpose(mcrotainter_analyzer_colimator_4_blade_4, mctr1);
  rot_mul(mcrotadiffraction_detector_4_exit_volume, mctr1, mcrotrdiffraction_detector_4_exit_volume);
  mctc1 = coords_set(
#line 1580 "MACS_sample_kidney_box.instr"
    0,
#line 1580 "MACS_sample_kidney_box.instr"
    0,
#line 1580 "MACS_sample_kidney_box.instr"
    0);
#line 109610 "MACS_sample_kidney_box.c"
  rot_transpose(mcrotachannel_4_cave1_cyl1, mctr1);
  mctc2 = rot_apply(mctr1, mctc1);
  mcposadiffraction_detector_4_exit_volume = coords_add(mcposachannel_4_cave1_cyl1, mctc2);
  mctc1 = coords_sub(mcposainter_analyzer_colimator_4_blade_4, mcposadiffraction_detector_4_exit_volume);
  mcposrdiffraction_detector_4_exit_volume = rot_apply(mcrotadiffraction_detector_4_exit_volume, mctc1);
  mcDEBUG_COMPONENT("diffraction_detector_4_exit_volume", mcposadiffraction_detector_4_exit_volume, mcrotadiffraction_detector_4_exit_volume)
  mccomp_posa[312] = mcposadiffraction_detector_4_exit_volume;
  mccomp_posr[312] = mcposrdiffraction_detector_4_exit_volume;
  mcNCounter[312]  = mcPCounter[312] = mcP2Counter[312] = 0;
  mcAbsorbProp[312]= 0;
    /* Component spec_detector_4_exit_volume. */
  /* Setting parameters for component spec_detector_4_exit_volume. */
  SIG_MESSAGE("spec_detector_4_exit_volume (Init:SetPar)");
#line 1585 "MACS_sample_kidney_box.instr"
  if("Exit") strncpy(mccspec_detector_4_exit_volume_material_string, "Exit" ? "Exit" : "", 16384); else mccspec_detector_4_exit_volume_material_string[0]='\0';
#line 1585 "MACS_sample_kidney_box.instr"
  mccspec_detector_4_exit_volume_priority = 632;
#line 1584 "MACS_sample_kidney_box.instr"
  mccspec_detector_4_exit_volume_xwidth = 2.01 * detector_radius;
#line 1584 "MACS_sample_kidney_box.instr"
  mccspec_detector_4_exit_volume_yheight = 1.01 * detector_height;
#line 1584 "MACS_sample_kidney_box.instr"
  mccspec_detector_4_exit_volume_zdepth = 0.001;
#line 71 "MACS_sample_kidney_box.instr"
  mccspec_detector_4_exit_volume_xwidth2 = -1;
#line 71 "MACS_sample_kidney_box.instr"
  mccspec_detector_4_exit_volume_yheight2 = -1;
#line 71 "MACS_sample_kidney_box.instr"
  mccspec_detector_4_exit_volume_visualize = 1;
#line 71 "MACS_sample_kidney_box.instr"
  mccspec_detector_4_exit_volume_target_index = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccspec_detector_4_exit_volume_target_x = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccspec_detector_4_exit_volume_target_y = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccspec_detector_4_exit_volume_target_z = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccspec_detector_4_exit_volume_focus_aw = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccspec_detector_4_exit_volume_focus_ah = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccspec_detector_4_exit_volume_focus_xw = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccspec_detector_4_exit_volume_focus_xh = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccspec_detector_4_exit_volume_focus_r = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccspec_detector_4_exit_volume_p_interact = 0;
#line 71 "MACS_sample_kidney_box.instr"
  if(0) strncpy(mccspec_detector_4_exit_volume_mask_string, 0 ? 0 : "", 16384); else mccspec_detector_4_exit_volume_mask_string[0]='\0';
#line 71 "MACS_sample_kidney_box.instr"
  if(0) strncpy(mccspec_detector_4_exit_volume_mask_setting, 0 ? 0 : "", 16384); else mccspec_detector_4_exit_volume_mask_setting[0]='\0';
#line 71 "MACS_sample_kidney_box.instr"
  mccspec_detector_4_exit_volume_number_of_activations = 1;
#line 109666 "MACS_sample_kidney_box.c"

  SIG_MESSAGE("spec_detector_4_exit_volume (Init:Place/Rotate)");
  rot_set_rotation(mctr1,
#line 1587 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 1587 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 1587 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD);
#line 109676 "MACS_sample_kidney_box.c"
  rot_mul(mctr1, mcrotachannel_4_analyzer_2_center, mcrotaspec_detector_4_exit_volume);
  rot_transpose(mcrotadiffraction_detector_4_exit_volume, mctr1);
  rot_mul(mcrotaspec_detector_4_exit_volume, mctr1, mcrotrspec_detector_4_exit_volume);
  mctc1 = coords_set(
#line 1586 "MACS_sample_kidney_box.instr"
    0,
#line 1586 "MACS_sample_kidney_box.instr"
    0,
#line 1586 "MACS_sample_kidney_box.instr"
    0);
#line 109687 "MACS_sample_kidney_box.c"
  rot_transpose(mcrotachannel_4_cave2_cyl1, mctr1);
  mctc2 = rot_apply(mctr1, mctc1);
  mcposaspec_detector_4_exit_volume = coords_add(mcposachannel_4_cave2_cyl1, mctc2);
  mctc1 = coords_sub(mcposadiffraction_detector_4_exit_volume, mcposaspec_detector_4_exit_volume);
  mcposrspec_detector_4_exit_volume = rot_apply(mcrotaspec_detector_4_exit_volume, mctc1);
  mcDEBUG_COMPONENT("spec_detector_4_exit_volume", mcposaspec_detector_4_exit_volume, mcrotaspec_detector_4_exit_volume)
  mccomp_posa[313] = mcposaspec_detector_4_exit_volume;
  mccomp_posr[313] = mcposrspec_detector_4_exit_volume;
  mcNCounter[313]  = mcPCounter[313] = mcP2Counter[313] = 0;
  mcAbsorbProp[313]= 0;
    /* Component channel_5_cave1_box1. */
  /* Setting parameters for component channel_5_cave1_box1. */
  SIG_MESSAGE("channel_5_cave1_box1 (Init:SetPar)");
#line 1592 "MACS_sample_kidney_box.instr"
  if("Vacuum") strncpy(mccchannel_5_cave1_box1_material_string, "Vacuum" ? "Vacuum" : "", 16384); else mccchannel_5_cave1_box1_material_string[0]='\0';
#line 1592 "MACS_sample_kidney_box.instr"
  mccchannel_5_cave1_box1_priority = 700;
#line 1590 "MACS_sample_kidney_box.instr"
  mccchannel_5_cave1_box1_xwidth = kidney_cave1_box1_width1;
#line 1590 "MACS_sample_kidney_box.instr"
  mccchannel_5_cave1_box1_yheight = kidney_cave1_box1_height1;
#line 1590 "MACS_sample_kidney_box.instr"
  mccchannel_5_cave1_box1_zdepth = kidney_cave1_box1_depth;
#line 1591 "MACS_sample_kidney_box.instr"
  mccchannel_5_cave1_box1_xwidth2 = kidney_cave1_box1_width2;
#line 1591 "MACS_sample_kidney_box.instr"
  mccchannel_5_cave1_box1_yheight2 = kidney_cave1_box1_height2;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_5_cave1_box1_visualize = 1;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_5_cave1_box1_target_index = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_5_cave1_box1_target_x = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_5_cave1_box1_target_y = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_5_cave1_box1_target_z = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_5_cave1_box1_focus_aw = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_5_cave1_box1_focus_ah = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_5_cave1_box1_focus_xw = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_5_cave1_box1_focus_xh = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_5_cave1_box1_focus_r = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_5_cave1_box1_p_interact = 0;
#line 71 "MACS_sample_kidney_box.instr"
  if(0) strncpy(mccchannel_5_cave1_box1_mask_string, 0 ? 0 : "", 16384); else mccchannel_5_cave1_box1_mask_string[0]='\0';
#line 71 "MACS_sample_kidney_box.instr"
  if(0) strncpy(mccchannel_5_cave1_box1_mask_setting, 0 ? 0 : "", 16384); else mccchannel_5_cave1_box1_mask_setting[0]='\0';
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_5_cave1_box1_number_of_activations = 1;
#line 109743 "MACS_sample_kidney_box.c"

  SIG_MESSAGE("channel_5_cave1_box1 (Init:Place/Rotate)");
  rot_set_rotation(mctr1,
#line 1594 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 1594 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 1594 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD);
#line 109753 "MACS_sample_kidney_box.c"
  rot_mul(mctr1, mcrotakidney_channel_5, mcrotachannel_5_cave1_box1);
  rot_transpose(mcrotaspec_detector_4_exit_volume, mctr1);
  rot_mul(mcrotachannel_5_cave1_box1, mctr1, mcrotrchannel_5_cave1_box1);
  mctc1 = coords_set(
#line 1593 "MACS_sample_kidney_box.instr"
    0,
#line 1593 "MACS_sample_kidney_box.instr"
    0,
#line 1593 "MACS_sample_kidney_box.instr"
    kidney_cave1_box1_center_to_target);
#line 109764 "MACS_sample_kidney_box.c"
  rot_transpose(mcrotakidney_channel_5, mctr1);
  mctc2 = rot_apply(mctr1, mctc1);
  mcposachannel_5_cave1_box1 = coords_add(mcposakidney_channel_5, mctc2);
  mctc1 = coords_sub(mcposaspec_detector_4_exit_volume, mcposachannel_5_cave1_box1);
  mcposrchannel_5_cave1_box1 = rot_apply(mcrotachannel_5_cave1_box1, mctc1);
  mcDEBUG_COMPONENT("channel_5_cave1_box1", mcposachannel_5_cave1_box1, mcrotachannel_5_cave1_box1)
  mccomp_posa[314] = mcposachannel_5_cave1_box1;
  mccomp_posr[314] = mcposrchannel_5_cave1_box1;
  mcNCounter[314]  = mcPCounter[314] = mcP2Counter[314] = 0;
  mcAbsorbProp[314]= 0;
    /* Component channel_5_cave1_box2. */
  /* Setting parameters for component channel_5_cave1_box2. */
  SIG_MESSAGE("channel_5_cave1_box2 (Init:SetPar)");
#line 1599 "MACS_sample_kidney_box.instr"
  if("Vacuum") strncpy(mccchannel_5_cave1_box2_material_string, "Vacuum" ? "Vacuum" : "", 16384); else mccchannel_5_cave1_box2_material_string[0]='\0';
#line 1599 "MACS_sample_kidney_box.instr"
  mccchannel_5_cave1_box2_priority = 705;
#line 1597 "MACS_sample_kidney_box.instr"
  mccchannel_5_cave1_box2_xwidth = kidney_cave1_box2_width1;
#line 1597 "MACS_sample_kidney_box.instr"
  mccchannel_5_cave1_box2_yheight = kidney_cave1_box2_height1;
#line 1597 "MACS_sample_kidney_box.instr"
  mccchannel_5_cave1_box2_zdepth = kidney_cave1_box2_depth;
#line 1598 "MACS_sample_kidney_box.instr"
  mccchannel_5_cave1_box2_xwidth2 = kidney_cave1_box2_width2;
#line 1598 "MACS_sample_kidney_box.instr"
  mccchannel_5_cave1_box2_yheight2 = kidney_cave1_box2_height2;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_5_cave1_box2_visualize = 1;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_5_cave1_box2_target_index = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_5_cave1_box2_target_x = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_5_cave1_box2_target_y = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_5_cave1_box2_target_z = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_5_cave1_box2_focus_aw = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_5_cave1_box2_focus_ah = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_5_cave1_box2_focus_xw = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_5_cave1_box2_focus_xh = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_5_cave1_box2_focus_r = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_5_cave1_box2_p_interact = 0;
#line 71 "MACS_sample_kidney_box.instr"
  if(0) strncpy(mccchannel_5_cave1_box2_mask_string, 0 ? 0 : "", 16384); else mccchannel_5_cave1_box2_mask_string[0]='\0';
#line 71 "MACS_sample_kidney_box.instr"
  if(0) strncpy(mccchannel_5_cave1_box2_mask_setting, 0 ? 0 : "", 16384); else mccchannel_5_cave1_box2_mask_setting[0]='\0';
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_5_cave1_box2_number_of_activations = 1;
#line 109820 "MACS_sample_kidney_box.c"

  SIG_MESSAGE("channel_5_cave1_box2 (Init:Place/Rotate)");
  rot_set_rotation(mctr1,
#line 1601 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 1601 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 1601 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD);
#line 109830 "MACS_sample_kidney_box.c"
  rot_mul(mctr1, mcrotakidney_channel_5, mcrotachannel_5_cave1_box2);
  rot_transpose(mcrotachannel_5_cave1_box1, mctr1);
  rot_mul(mcrotachannel_5_cave1_box2, mctr1, mcrotrchannel_5_cave1_box2);
  mctc1 = coords_set(
#line 1600 "MACS_sample_kidney_box.instr"
    kidney_cave1_box2_x_offset,
#line 1600 "MACS_sample_kidney_box.instr"
    0,
#line 1600 "MACS_sample_kidney_box.instr"
    kidney_cave1_box2_center_to_target);
#line 109841 "MACS_sample_kidney_box.c"
  rot_transpose(mcrotakidney_channel_5, mctr1);
  mctc2 = rot_apply(mctr1, mctc1);
  mcposachannel_5_cave1_box2 = coords_add(mcposakidney_channel_5, mctc2);
  mctc1 = coords_sub(mcposachannel_5_cave1_box1, mcposachannel_5_cave1_box2);
  mcposrchannel_5_cave1_box2 = rot_apply(mcrotachannel_5_cave1_box2, mctc1);
  mcDEBUG_COMPONENT("channel_5_cave1_box2", mcposachannel_5_cave1_box2, mcrotachannel_5_cave1_box2)
  mccomp_posa[315] = mcposachannel_5_cave1_box2;
  mccomp_posr[315] = mcposrchannel_5_cave1_box2;
  mcNCounter[315]  = mcPCounter[315] = mcP2Counter[315] = 0;
  mcAbsorbProp[315]= 0;
    /* Component channel_5_cave1_box3. */
  /* Setting parameters for component channel_5_cave1_box3. */
  SIG_MESSAGE("channel_5_cave1_box3 (Init:SetPar)");
#line 1606 "MACS_sample_kidney_box.instr"
  if("Vacuum") strncpy(mccchannel_5_cave1_box3_material_string, "Vacuum" ? "Vacuum" : "", 16384); else mccchannel_5_cave1_box3_material_string[0]='\0';
#line 1606 "MACS_sample_kidney_box.instr"
  mccchannel_5_cave1_box3_priority = 702;
#line 1604 "MACS_sample_kidney_box.instr"
  mccchannel_5_cave1_box3_xwidth = kidney_cave1_box3_width1;
#line 1604 "MACS_sample_kidney_box.instr"
  mccchannel_5_cave1_box3_yheight = kidney_cave1_box3_height1;
#line 1604 "MACS_sample_kidney_box.instr"
  mccchannel_5_cave1_box3_zdepth = kidney_cave1_box3_depth;
#line 1605 "MACS_sample_kidney_box.instr"
  mccchannel_5_cave1_box3_xwidth2 = kidney_cave1_box3_width2;
#line 1605 "MACS_sample_kidney_box.instr"
  mccchannel_5_cave1_box3_yheight2 = kidney_cave1_box3_height2;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_5_cave1_box3_visualize = 1;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_5_cave1_box3_target_index = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_5_cave1_box3_target_x = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_5_cave1_box3_target_y = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_5_cave1_box3_target_z = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_5_cave1_box3_focus_aw = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_5_cave1_box3_focus_ah = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_5_cave1_box3_focus_xw = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_5_cave1_box3_focus_xh = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_5_cave1_box3_focus_r = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_5_cave1_box3_p_interact = 0;
#line 71 "MACS_sample_kidney_box.instr"
  if(0) strncpy(mccchannel_5_cave1_box3_mask_string, 0 ? 0 : "", 16384); else mccchannel_5_cave1_box3_mask_string[0]='\0';
#line 71 "MACS_sample_kidney_box.instr"
  if(0) strncpy(mccchannel_5_cave1_box3_mask_setting, 0 ? 0 : "", 16384); else mccchannel_5_cave1_box3_mask_setting[0]='\0';
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_5_cave1_box3_number_of_activations = 1;
#line 109897 "MACS_sample_kidney_box.c"

  SIG_MESSAGE("channel_5_cave1_box3 (Init:Place/Rotate)");
  rot_set_rotation(mctr1,
#line 1608 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 1608 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 1608 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD);
#line 109907 "MACS_sample_kidney_box.c"
  rot_mul(mctr1, mcrotakidney_channel_5, mcrotachannel_5_cave1_box3);
  rot_transpose(mcrotachannel_5_cave1_box2, mctr1);
  rot_mul(mcrotachannel_5_cave1_box3, mctr1, mcrotrchannel_5_cave1_box3);
  mctc1 = coords_set(
#line 1607 "MACS_sample_kidney_box.instr"
    0,
#line 1607 "MACS_sample_kidney_box.instr"
    0,
#line 1607 "MACS_sample_kidney_box.instr"
    kidney_cave1_box3_center_to_target);
#line 109918 "MACS_sample_kidney_box.c"
  rot_transpose(mcrotakidney_channel_5, mctr1);
  mctc2 = rot_apply(mctr1, mctc1);
  mcposachannel_5_cave1_box3 = coords_add(mcposakidney_channel_5, mctc2);
  mctc1 = coords_sub(mcposachannel_5_cave1_box2, mcposachannel_5_cave1_box3);
  mcposrchannel_5_cave1_box3 = rot_apply(mcrotachannel_5_cave1_box3, mctc1);
  mcDEBUG_COMPONENT("channel_5_cave1_box3", mcposachannel_5_cave1_box3, mcrotachannel_5_cave1_box3)
  mccomp_posa[316] = mcposachannel_5_cave1_box3;
  mccomp_posr[316] = mcposrchannel_5_cave1_box3;
  mcNCounter[316]  = mcPCounter[316] = mcP2Counter[316] = 0;
  mcAbsorbProp[316]= 0;
    /* Component channel_5_cave1_cyl1. */
  /* Setting parameters for component channel_5_cave1_cyl1. */
  SIG_MESSAGE("channel_5_cave1_cyl1 (Init:SetPar)");
#line 1612 "MACS_sample_kidney_box.instr"
  if("Vacuum") strncpy(mccchannel_5_cave1_cyl1_material_string, "Vacuum" ? "Vacuum" : "", 16384); else mccchannel_5_cave1_cyl1_material_string[0]='\0';
#line 1612 "MACS_sample_kidney_box.instr"
  mccchannel_5_cave1_cyl1_priority = 703;
#line 1611 "MACS_sample_kidney_box.instr"
  mccchannel_5_cave1_cyl1_radius = kidney_cave1_cyl1_radius;
#line 1611 "MACS_sample_kidney_box.instr"
  mccchannel_5_cave1_cyl1_yheight = kidney_cave1_cyl1_height;
#line 67 "MACS_sample_kidney_box.instr"
  mccchannel_5_cave1_cyl1_visualize = 1;
#line 67 "MACS_sample_kidney_box.instr"
  mccchannel_5_cave1_cyl1_target_index = 0;
#line 67 "MACS_sample_kidney_box.instr"
  mccchannel_5_cave1_cyl1_target_x = 0;
#line 67 "MACS_sample_kidney_box.instr"
  mccchannel_5_cave1_cyl1_target_y = 0;
#line 67 "MACS_sample_kidney_box.instr"
  mccchannel_5_cave1_cyl1_target_z = 0;
#line 67 "MACS_sample_kidney_box.instr"
  mccchannel_5_cave1_cyl1_focus_aw = 0;
#line 67 "MACS_sample_kidney_box.instr"
  mccchannel_5_cave1_cyl1_focus_ah = 0;
#line 67 "MACS_sample_kidney_box.instr"
  mccchannel_5_cave1_cyl1_focus_xw = 0;
#line 67 "MACS_sample_kidney_box.instr"
  mccchannel_5_cave1_cyl1_focus_xh = 0;
#line 67 "MACS_sample_kidney_box.instr"
  mccchannel_5_cave1_cyl1_focus_r = 0;
#line 67 "MACS_sample_kidney_box.instr"
  mccchannel_5_cave1_cyl1_p_interact = 0;
#line 67 "MACS_sample_kidney_box.instr"
  if(0) strncpy(mccchannel_5_cave1_cyl1_mask_string, 0 ? 0 : "", 16384); else mccchannel_5_cave1_cyl1_mask_string[0]='\0';
#line 67 "MACS_sample_kidney_box.instr"
  if(0) strncpy(mccchannel_5_cave1_cyl1_mask_setting, 0 ? 0 : "", 16384); else mccchannel_5_cave1_cyl1_mask_setting[0]='\0';
#line 67 "MACS_sample_kidney_box.instr"
  mccchannel_5_cave1_cyl1_number_of_activations = 1;
#line 109968 "MACS_sample_kidney_box.c"

  SIG_MESSAGE("channel_5_cave1_cyl1 (Init:Place/Rotate)");
  rot_set_rotation(mctr1,
#line 1614 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 1614 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 1614 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD);
#line 109978 "MACS_sample_kidney_box.c"
  rot_mul(mctr1, mcrotakidney_channel_5, mcrotachannel_5_cave1_cyl1);
  rot_transpose(mcrotachannel_5_cave1_box3, mctr1);
  rot_mul(mcrotachannel_5_cave1_cyl1, mctr1, mcrotrchannel_5_cave1_cyl1);
  mctc1 = coords_set(
#line 1613 "MACS_sample_kidney_box.instr"
    0,
#line 1613 "MACS_sample_kidney_box.instr"
    0,
#line 1613 "MACS_sample_kidney_box.instr"
    kidney_cave1_cyl1_center_to_target);
#line 109989 "MACS_sample_kidney_box.c"
  rot_transpose(mcrotakidney_channel_5, mctr1);
  mctc2 = rot_apply(mctr1, mctc1);
  mcposachannel_5_cave1_cyl1 = coords_add(mcposakidney_channel_5, mctc2);
  mctc1 = coords_sub(mcposachannel_5_cave1_box3, mcposachannel_5_cave1_cyl1);
  mcposrchannel_5_cave1_cyl1 = rot_apply(mcrotachannel_5_cave1_cyl1, mctc1);
  mcDEBUG_COMPONENT("channel_5_cave1_cyl1", mcposachannel_5_cave1_cyl1, mcrotachannel_5_cave1_cyl1)
  mccomp_posa[317] = mcposachannel_5_cave1_cyl1;
  mccomp_posr[317] = mcposrchannel_5_cave1_cyl1;
  mcNCounter[317]  = mcPCounter[317] = mcP2Counter[317] = 0;
  mcAbsorbProp[317]= 0;
    /* Component channel_5_analyzer_1_center. */
  /* Setting parameters for component channel_5_analyzer_1_center. */
  SIG_MESSAGE("channel_5_analyzer_1_center (Init:SetPar)");

  SIG_MESSAGE("channel_5_analyzer_1_center (Init:Place/Rotate)");
  rot_set_rotation(mctr1,
    (0.0)*DEG2RAD,
    (0.0)*DEG2RAD,
    (0.0)*DEG2RAD);
#line 110009 "MACS_sample_kidney_box.c"
  rot_mul(mctr1, mcrotakidney_channel_5, mcrotachannel_5_analyzer_1_center);
  rot_transpose(mcrotachannel_5_cave1_cyl1, mctr1);
  rot_mul(mcrotachannel_5_analyzer_1_center, mctr1, mcrotrchannel_5_analyzer_1_center);
  mctc1 = coords_set(
#line 1618 "MACS_sample_kidney_box.instr"
    0,
#line 1618 "MACS_sample_kidney_box.instr"
    0,
#line 1618 "MACS_sample_kidney_box.instr"
    analyzer_1_center_to_sample);
#line 110020 "MACS_sample_kidney_box.c"
  rot_transpose(mcrotakidney_channel_5, mctr1);
  mctc2 = rot_apply(mctr1, mctc1);
  mcposachannel_5_analyzer_1_center = coords_add(mcposakidney_channel_5, mctc2);
  mctc1 = coords_sub(mcposachannel_5_cave1_cyl1, mcposachannel_5_analyzer_1_center);
  mcposrchannel_5_analyzer_1_center = rot_apply(mcrotachannel_5_analyzer_1_center, mctc1);
  mcDEBUG_COMPONENT("channel_5_analyzer_1_center", mcposachannel_5_analyzer_1_center, mcrotachannel_5_analyzer_1_center)
  mccomp_posa[318] = mcposachannel_5_analyzer_1_center;
  mccomp_posr[318] = mcposrchannel_5_analyzer_1_center;
  mcNCounter[318]  = mcPCounter[318] = mcP2Counter[318] = 0;
  mcAbsorbProp[318]= 0;
    /* Component channel_5_analyzer_1_rotated. */
  /* Setting parameters for component channel_5_analyzer_1_rotated. */
  SIG_MESSAGE("channel_5_analyzer_1_rotated (Init:SetPar)");

  SIG_MESSAGE("channel_5_analyzer_1_rotated (Init:Place/Rotate)");
  rot_set_rotation(mctr1,
#line 1622 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 1622 "MACS_sample_kidney_box.instr"
    (180 - analyzer_theta [ 5 ])*DEG2RAD,
#line 1622 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD);
#line 110043 "MACS_sample_kidney_box.c"
  rot_mul(mctr1, mcrotachannel_5_analyzer_1_center, mcrotachannel_5_analyzer_1_rotated);
  rot_transpose(mcrotachannel_5_analyzer_1_center, mctr1);
  rot_mul(mcrotachannel_5_analyzer_1_rotated, mctr1, mcrotrchannel_5_analyzer_1_rotated);
  mctc1 = coords_set(
#line 1621 "MACS_sample_kidney_box.instr"
    0,
#line 1621 "MACS_sample_kidney_box.instr"
    0,
#line 1621 "MACS_sample_kidney_box.instr"
    -0.5 * analyzer_seperation / tan ( analyzer_2theta [ 5 ] * DEG2RAD ));
#line 110054 "MACS_sample_kidney_box.c"
  rot_transpose(mcrotachannel_5_analyzer_1_center, mctr1);
  mctc2 = rot_apply(mctr1, mctc1);
  mcposachannel_5_analyzer_1_rotated = coords_add(mcposachannel_5_analyzer_1_center, mctc2);
  mctc1 = coords_sub(mcposachannel_5_analyzer_1_center, mcposachannel_5_analyzer_1_rotated);
  mcposrchannel_5_analyzer_1_rotated = rot_apply(mcrotachannel_5_analyzer_1_rotated, mctc1);
  mcDEBUG_COMPONENT("channel_5_analyzer_1_rotated", mcposachannel_5_analyzer_1_rotated, mcrotachannel_5_analyzer_1_rotated)
  mccomp_posa[319] = mcposachannel_5_analyzer_1_rotated;
  mccomp_posr[319] = mcposrchannel_5_analyzer_1_rotated;
  mcNCounter[319]  = mcPCounter[319] = mcP2Counter[319] = 0;
  mcAbsorbProp[319]= 0;
    /* Component channel_5_analyzer_1_array_crystal_array_0. */
  /* Setting parameters for component channel_5_analyzer_1_array_crystal_array_0. */
  SIG_MESSAGE("channel_5_analyzer_1_array_crystal_array_0 (Init:SetPar)");
#line 1626 "MACS_sample_kidney_box.instr"
  if("PG_analyzer") strncpy(mccchannel_5_analyzer_1_array_crystal_array_0_material_string, "PG_analyzer" ? "PG_analyzer" : "", 16384); else mccchannel_5_analyzer_1_array_crystal_array_0_material_string[0]='\0';
#line 1626 "MACS_sample_kidney_box.instr"
  mccchannel_5_analyzer_1_array_crystal_array_0_priority = 720.0;
#line 1625 "MACS_sample_kidney_box.instr"
  mccchannel_5_analyzer_1_array_crystal_array_0_xwidth = channel_5_analyzer_1_array_crystal_depth;
#line 1625 "MACS_sample_kidney_box.instr"
  mccchannel_5_analyzer_1_array_crystal_array_0_yheight = channel_5_analyzer_1_array_crystal_height;
#line 1625 "MACS_sample_kidney_box.instr"
  mccchannel_5_analyzer_1_array_crystal_array_0_zdepth = channel_5_analyzer_1_array_crystal_width;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_5_analyzer_1_array_crystal_array_0_xwidth2 = -1;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_5_analyzer_1_array_crystal_array_0_yheight2 = -1;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_5_analyzer_1_array_crystal_array_0_visualize = 1;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_5_analyzer_1_array_crystal_array_0_target_index = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_5_analyzer_1_array_crystal_array_0_target_x = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_5_analyzer_1_array_crystal_array_0_target_y = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_5_analyzer_1_array_crystal_array_0_target_z = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_5_analyzer_1_array_crystal_array_0_focus_aw = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_5_analyzer_1_array_crystal_array_0_focus_ah = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_5_analyzer_1_array_crystal_array_0_focus_xw = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_5_analyzer_1_array_crystal_array_0_focus_xh = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_5_analyzer_1_array_crystal_array_0_focus_r = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_5_analyzer_1_array_crystal_array_0_p_interact = 0;
#line 71 "MACS_sample_kidney_box.instr"
  if(0) strncpy(mccchannel_5_analyzer_1_array_crystal_array_0_mask_string, 0 ? 0 : "", 16384); else mccchannel_5_analyzer_1_array_crystal_array_0_mask_string[0]='\0';
#line 71 "MACS_sample_kidney_box.instr"
  if(0) strncpy(mccchannel_5_analyzer_1_array_crystal_array_0_mask_setting, 0 ? 0 : "", 16384); else mccchannel_5_analyzer_1_array_crystal_array_0_mask_setting[0]='\0';
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_5_analyzer_1_array_crystal_array_0_number_of_activations = 1;
#line 110110 "MACS_sample_kidney_box.c"

  SIG_MESSAGE("channel_5_analyzer_1_array_crystal_array_0 (Init:Place/Rotate)");
  rot_set_rotation(mctr1,
#line 1628 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 1628 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 1628 "MACS_sample_kidney_box.instr"
    (0 - RAD2DEG * channel_5_analyzer_1_array_theta [ 0 ])*DEG2RAD);
#line 110120 "MACS_sample_kidney_box.c"
  rot_mul(mctr1, mcrotachannel_5_analyzer_1_rotated, mcrotachannel_5_analyzer_1_array_crystal_array_0);
  rot_transpose(mcrotachannel_5_analyzer_1_rotated, mctr1);
  rot_mul(mcrotachannel_5_analyzer_1_array_crystal_array_0, mctr1, mcrotrchannel_5_analyzer_1_array_crystal_array_0);
  mctc1 = coords_set(
#line 1627 "MACS_sample_kidney_box.instr"
    0 + channel_5_analyzer_1_array_effective_radius_of_curvature * ( 1 - cos ( channel_5_analyzer_1_array_theta [ 0 ] ) ),
#line 1627 "MACS_sample_kidney_box.instr"
    0 + channel_5_analyzer_1_array_effective_radius_of_curvature * sin ( channel_5_analyzer_1_array_theta [ 0 ] ),
#line 1627 "MACS_sample_kidney_box.instr"
    0);
#line 110131 "MACS_sample_kidney_box.c"
  rot_transpose(mcrotachannel_5_analyzer_1_rotated, mctr1);
  mctc2 = rot_apply(mctr1, mctc1);
  mcposachannel_5_analyzer_1_array_crystal_array_0 = coords_add(mcposachannel_5_analyzer_1_rotated, mctc2);
  mctc1 = coords_sub(mcposachannel_5_analyzer_1_rotated, mcposachannel_5_analyzer_1_array_crystal_array_0);
  mcposrchannel_5_analyzer_1_array_crystal_array_0 = rot_apply(mcrotachannel_5_analyzer_1_array_crystal_array_0, mctc1);
  mcDEBUG_COMPONENT("channel_5_analyzer_1_array_crystal_array_0", mcposachannel_5_analyzer_1_array_crystal_array_0, mcrotachannel_5_analyzer_1_array_crystal_array_0)
  mccomp_posa[320] = mcposachannel_5_analyzer_1_array_crystal_array_0;
  mccomp_posr[320] = mcposrchannel_5_analyzer_1_array_crystal_array_0;
  mcNCounter[320]  = mcPCounter[320] = mcP2Counter[320] = 0;
  mcAbsorbProp[320]= 0;
    /* Component channel_5_analyzer_1_array_crystal_array_1. */
  /* Setting parameters for component channel_5_analyzer_1_array_crystal_array_1. */
  SIG_MESSAGE("channel_5_analyzer_1_array_crystal_array_1 (Init:SetPar)");
#line 1632 "MACS_sample_kidney_box.instr"
  if("PG_analyzer") strncpy(mccchannel_5_analyzer_1_array_crystal_array_1_material_string, "PG_analyzer" ? "PG_analyzer" : "", 16384); else mccchannel_5_analyzer_1_array_crystal_array_1_material_string[0]='\0';
#line 1632 "MACS_sample_kidney_box.instr"
  mccchannel_5_analyzer_1_array_crystal_array_1_priority = 720.1;
#line 1631 "MACS_sample_kidney_box.instr"
  mccchannel_5_analyzer_1_array_crystal_array_1_xwidth = channel_5_analyzer_1_array_crystal_depth;
#line 1631 "MACS_sample_kidney_box.instr"
  mccchannel_5_analyzer_1_array_crystal_array_1_yheight = channel_5_analyzer_1_array_crystal_height;
#line 1631 "MACS_sample_kidney_box.instr"
  mccchannel_5_analyzer_1_array_crystal_array_1_zdepth = channel_5_analyzer_1_array_crystal_width;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_5_analyzer_1_array_crystal_array_1_xwidth2 = -1;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_5_analyzer_1_array_crystal_array_1_yheight2 = -1;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_5_analyzer_1_array_crystal_array_1_visualize = 1;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_5_analyzer_1_array_crystal_array_1_target_index = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_5_analyzer_1_array_crystal_array_1_target_x = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_5_analyzer_1_array_crystal_array_1_target_y = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_5_analyzer_1_array_crystal_array_1_target_z = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_5_analyzer_1_array_crystal_array_1_focus_aw = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_5_analyzer_1_array_crystal_array_1_focus_ah = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_5_analyzer_1_array_crystal_array_1_focus_xw = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_5_analyzer_1_array_crystal_array_1_focus_xh = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_5_analyzer_1_array_crystal_array_1_focus_r = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_5_analyzer_1_array_crystal_array_1_p_interact = 0;
#line 71 "MACS_sample_kidney_box.instr"
  if(0) strncpy(mccchannel_5_analyzer_1_array_crystal_array_1_mask_string, 0 ? 0 : "", 16384); else mccchannel_5_analyzer_1_array_crystal_array_1_mask_string[0]='\0';
#line 71 "MACS_sample_kidney_box.instr"
  if(0) strncpy(mccchannel_5_analyzer_1_array_crystal_array_1_mask_setting, 0 ? 0 : "", 16384); else mccchannel_5_analyzer_1_array_crystal_array_1_mask_setting[0]='\0';
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_5_analyzer_1_array_crystal_array_1_number_of_activations = 1;
#line 110187 "MACS_sample_kidney_box.c"

  SIG_MESSAGE("channel_5_analyzer_1_array_crystal_array_1 (Init:Place/Rotate)");
  rot_set_rotation(mctr1,
#line 1634 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 1634 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 1634 "MACS_sample_kidney_box.instr"
    (0 - RAD2DEG * channel_5_analyzer_1_array_theta [ 1 ])*DEG2RAD);
#line 110197 "MACS_sample_kidney_box.c"
  rot_mul(mctr1, mcrotachannel_5_analyzer_1_rotated, mcrotachannel_5_analyzer_1_array_crystal_array_1);
  rot_transpose(mcrotachannel_5_analyzer_1_array_crystal_array_0, mctr1);
  rot_mul(mcrotachannel_5_analyzer_1_array_crystal_array_1, mctr1, mcrotrchannel_5_analyzer_1_array_crystal_array_1);
  mctc1 = coords_set(
#line 1633 "MACS_sample_kidney_box.instr"
    0 + channel_5_analyzer_1_array_effective_radius_of_curvature * ( 1 - cos ( channel_5_analyzer_1_array_theta [ 1 ] ) ),
#line 1633 "MACS_sample_kidney_box.instr"
    0 + channel_5_analyzer_1_array_effective_radius_of_curvature * sin ( channel_5_analyzer_1_array_theta [ 1 ] ),
#line 1633 "MACS_sample_kidney_box.instr"
    0);
#line 110208 "MACS_sample_kidney_box.c"
  rot_transpose(mcrotachannel_5_analyzer_1_rotated, mctr1);
  mctc2 = rot_apply(mctr1, mctc1);
  mcposachannel_5_analyzer_1_array_crystal_array_1 = coords_add(mcposachannel_5_analyzer_1_rotated, mctc2);
  mctc1 = coords_sub(mcposachannel_5_analyzer_1_array_crystal_array_0, mcposachannel_5_analyzer_1_array_crystal_array_1);
  mcposrchannel_5_analyzer_1_array_crystal_array_1 = rot_apply(mcrotachannel_5_analyzer_1_array_crystal_array_1, mctc1);
  mcDEBUG_COMPONENT("channel_5_analyzer_1_array_crystal_array_1", mcposachannel_5_analyzer_1_array_crystal_array_1, mcrotachannel_5_analyzer_1_array_crystal_array_1)
  mccomp_posa[321] = mcposachannel_5_analyzer_1_array_crystal_array_1;
  mccomp_posr[321] = mcposrchannel_5_analyzer_1_array_crystal_array_1;
  mcNCounter[321]  = mcPCounter[321] = mcP2Counter[321] = 0;
  mcAbsorbProp[321]= 0;
    /* Component channel_5_analyzer_1_array_crystal_array_2. */
  /* Setting parameters for component channel_5_analyzer_1_array_crystal_array_2. */
  SIG_MESSAGE("channel_5_analyzer_1_array_crystal_array_2 (Init:SetPar)");
#line 1638 "MACS_sample_kidney_box.instr"
  if("PG_analyzer") strncpy(mccchannel_5_analyzer_1_array_crystal_array_2_material_string, "PG_analyzer" ? "PG_analyzer" : "", 16384); else mccchannel_5_analyzer_1_array_crystal_array_2_material_string[0]='\0';
#line 1638 "MACS_sample_kidney_box.instr"
  mccchannel_5_analyzer_1_array_crystal_array_2_priority = 720.2;
#line 1637 "MACS_sample_kidney_box.instr"
  mccchannel_5_analyzer_1_array_crystal_array_2_xwidth = channel_5_analyzer_1_array_crystal_depth;
#line 1637 "MACS_sample_kidney_box.instr"
  mccchannel_5_analyzer_1_array_crystal_array_2_yheight = channel_5_analyzer_1_array_crystal_height;
#line 1637 "MACS_sample_kidney_box.instr"
  mccchannel_5_analyzer_1_array_crystal_array_2_zdepth = channel_5_analyzer_1_array_crystal_width;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_5_analyzer_1_array_crystal_array_2_xwidth2 = -1;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_5_analyzer_1_array_crystal_array_2_yheight2 = -1;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_5_analyzer_1_array_crystal_array_2_visualize = 1;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_5_analyzer_1_array_crystal_array_2_target_index = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_5_analyzer_1_array_crystal_array_2_target_x = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_5_analyzer_1_array_crystal_array_2_target_y = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_5_analyzer_1_array_crystal_array_2_target_z = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_5_analyzer_1_array_crystal_array_2_focus_aw = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_5_analyzer_1_array_crystal_array_2_focus_ah = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_5_analyzer_1_array_crystal_array_2_focus_xw = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_5_analyzer_1_array_crystal_array_2_focus_xh = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_5_analyzer_1_array_crystal_array_2_focus_r = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_5_analyzer_1_array_crystal_array_2_p_interact = 0;
#line 71 "MACS_sample_kidney_box.instr"
  if(0) strncpy(mccchannel_5_analyzer_1_array_crystal_array_2_mask_string, 0 ? 0 : "", 16384); else mccchannel_5_analyzer_1_array_crystal_array_2_mask_string[0]='\0';
#line 71 "MACS_sample_kidney_box.instr"
  if(0) strncpy(mccchannel_5_analyzer_1_array_crystal_array_2_mask_setting, 0 ? 0 : "", 16384); else mccchannel_5_analyzer_1_array_crystal_array_2_mask_setting[0]='\0';
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_5_analyzer_1_array_crystal_array_2_number_of_activations = 1;
#line 110264 "MACS_sample_kidney_box.c"

  SIG_MESSAGE("channel_5_analyzer_1_array_crystal_array_2 (Init:Place/Rotate)");
  rot_set_rotation(mctr1,
#line 1640 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 1640 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 1640 "MACS_sample_kidney_box.instr"
    (0 - RAD2DEG * channel_5_analyzer_1_array_theta [ 2 ])*DEG2RAD);
#line 110274 "MACS_sample_kidney_box.c"
  rot_mul(mctr1, mcrotachannel_5_analyzer_1_rotated, mcrotachannel_5_analyzer_1_array_crystal_array_2);
  rot_transpose(mcrotachannel_5_analyzer_1_array_crystal_array_1, mctr1);
  rot_mul(mcrotachannel_5_analyzer_1_array_crystal_array_2, mctr1, mcrotrchannel_5_analyzer_1_array_crystal_array_2);
  mctc1 = coords_set(
#line 1639 "MACS_sample_kidney_box.instr"
    0 + channel_5_analyzer_1_array_effective_radius_of_curvature * ( 1 - cos ( channel_5_analyzer_1_array_theta [ 2 ] ) ),
#line 1639 "MACS_sample_kidney_box.instr"
    0 + channel_5_analyzer_1_array_effective_radius_of_curvature * sin ( channel_5_analyzer_1_array_theta [ 2 ] ),
#line 1639 "MACS_sample_kidney_box.instr"
    0);
#line 110285 "MACS_sample_kidney_box.c"
  rot_transpose(mcrotachannel_5_analyzer_1_rotated, mctr1);
  mctc2 = rot_apply(mctr1, mctc1);
  mcposachannel_5_analyzer_1_array_crystal_array_2 = coords_add(mcposachannel_5_analyzer_1_rotated, mctc2);
  mctc1 = coords_sub(mcposachannel_5_analyzer_1_array_crystal_array_1, mcposachannel_5_analyzer_1_array_crystal_array_2);
  mcposrchannel_5_analyzer_1_array_crystal_array_2 = rot_apply(mcrotachannel_5_analyzer_1_array_crystal_array_2, mctc1);
  mcDEBUG_COMPONENT("channel_5_analyzer_1_array_crystal_array_2", mcposachannel_5_analyzer_1_array_crystal_array_2, mcrotachannel_5_analyzer_1_array_crystal_array_2)
  mccomp_posa[322] = mcposachannel_5_analyzer_1_array_crystal_array_2;
  mccomp_posr[322] = mcposrchannel_5_analyzer_1_array_crystal_array_2;
  mcNCounter[322]  = mcPCounter[322] = mcP2Counter[322] = 0;
  mcAbsorbProp[322]= 0;
    /* Component channel_5_analyzer_1_array_crystal_array_3. */
  /* Setting parameters for component channel_5_analyzer_1_array_crystal_array_3. */
  SIG_MESSAGE("channel_5_analyzer_1_array_crystal_array_3 (Init:SetPar)");
#line 1644 "MACS_sample_kidney_box.instr"
  if("PG_analyzer") strncpy(mccchannel_5_analyzer_1_array_crystal_array_3_material_string, "PG_analyzer" ? "PG_analyzer" : "", 16384); else mccchannel_5_analyzer_1_array_crystal_array_3_material_string[0]='\0';
#line 1644 "MACS_sample_kidney_box.instr"
  mccchannel_5_analyzer_1_array_crystal_array_3_priority = 720.3;
#line 1643 "MACS_sample_kidney_box.instr"
  mccchannel_5_analyzer_1_array_crystal_array_3_xwidth = channel_5_analyzer_1_array_crystal_depth;
#line 1643 "MACS_sample_kidney_box.instr"
  mccchannel_5_analyzer_1_array_crystal_array_3_yheight = channel_5_analyzer_1_array_crystal_height;
#line 1643 "MACS_sample_kidney_box.instr"
  mccchannel_5_analyzer_1_array_crystal_array_3_zdepth = channel_5_analyzer_1_array_crystal_width;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_5_analyzer_1_array_crystal_array_3_xwidth2 = -1;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_5_analyzer_1_array_crystal_array_3_yheight2 = -1;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_5_analyzer_1_array_crystal_array_3_visualize = 1;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_5_analyzer_1_array_crystal_array_3_target_index = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_5_analyzer_1_array_crystal_array_3_target_x = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_5_analyzer_1_array_crystal_array_3_target_y = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_5_analyzer_1_array_crystal_array_3_target_z = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_5_analyzer_1_array_crystal_array_3_focus_aw = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_5_analyzer_1_array_crystal_array_3_focus_ah = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_5_analyzer_1_array_crystal_array_3_focus_xw = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_5_analyzer_1_array_crystal_array_3_focus_xh = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_5_analyzer_1_array_crystal_array_3_focus_r = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_5_analyzer_1_array_crystal_array_3_p_interact = 0;
#line 71 "MACS_sample_kidney_box.instr"
  if(0) strncpy(mccchannel_5_analyzer_1_array_crystal_array_3_mask_string, 0 ? 0 : "", 16384); else mccchannel_5_analyzer_1_array_crystal_array_3_mask_string[0]='\0';
#line 71 "MACS_sample_kidney_box.instr"
  if(0) strncpy(mccchannel_5_analyzer_1_array_crystal_array_3_mask_setting, 0 ? 0 : "", 16384); else mccchannel_5_analyzer_1_array_crystal_array_3_mask_setting[0]='\0';
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_5_analyzer_1_array_crystal_array_3_number_of_activations = 1;
#line 110341 "MACS_sample_kidney_box.c"

  SIG_MESSAGE("channel_5_analyzer_1_array_crystal_array_3 (Init:Place/Rotate)");
  rot_set_rotation(mctr1,
#line 1646 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 1646 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 1646 "MACS_sample_kidney_box.instr"
    (0 - RAD2DEG * channel_5_analyzer_1_array_theta [ 3 ])*DEG2RAD);
#line 110351 "MACS_sample_kidney_box.c"
  rot_mul(mctr1, mcrotachannel_5_analyzer_1_rotated, mcrotachannel_5_analyzer_1_array_crystal_array_3);
  rot_transpose(mcrotachannel_5_analyzer_1_array_crystal_array_2, mctr1);
  rot_mul(mcrotachannel_5_analyzer_1_array_crystal_array_3, mctr1, mcrotrchannel_5_analyzer_1_array_crystal_array_3);
  mctc1 = coords_set(
#line 1645 "MACS_sample_kidney_box.instr"
    0 + channel_5_analyzer_1_array_effective_radius_of_curvature * ( 1 - cos ( channel_5_analyzer_1_array_theta [ 3 ] ) ),
#line 1645 "MACS_sample_kidney_box.instr"
    0 + channel_5_analyzer_1_array_effective_radius_of_curvature * sin ( channel_5_analyzer_1_array_theta [ 3 ] ),
#line 1645 "MACS_sample_kidney_box.instr"
    0);
#line 110362 "MACS_sample_kidney_box.c"
  rot_transpose(mcrotachannel_5_analyzer_1_rotated, mctr1);
  mctc2 = rot_apply(mctr1, mctc1);
  mcposachannel_5_analyzer_1_array_crystal_array_3 = coords_add(mcposachannel_5_analyzer_1_rotated, mctc2);
  mctc1 = coords_sub(mcposachannel_5_analyzer_1_array_crystal_array_2, mcposachannel_5_analyzer_1_array_crystal_array_3);
  mcposrchannel_5_analyzer_1_array_crystal_array_3 = rot_apply(mcrotachannel_5_analyzer_1_array_crystal_array_3, mctc1);
  mcDEBUG_COMPONENT("channel_5_analyzer_1_array_crystal_array_3", mcposachannel_5_analyzer_1_array_crystal_array_3, mcrotachannel_5_analyzer_1_array_crystal_array_3)
  mccomp_posa[323] = mcposachannel_5_analyzer_1_array_crystal_array_3;
  mccomp_posr[323] = mcposrchannel_5_analyzer_1_array_crystal_array_3;
  mcNCounter[323]  = mcPCounter[323] = mcP2Counter[323] = 0;
  mcAbsorbProp[323]= 0;
    /* Component channel_5_analyzer_1_array_crystal_array_4. */
  /* Setting parameters for component channel_5_analyzer_1_array_crystal_array_4. */
  SIG_MESSAGE("channel_5_analyzer_1_array_crystal_array_4 (Init:SetPar)");
#line 1650 "MACS_sample_kidney_box.instr"
  if("PG_analyzer") strncpy(mccchannel_5_analyzer_1_array_crystal_array_4_material_string, "PG_analyzer" ? "PG_analyzer" : "", 16384); else mccchannel_5_analyzer_1_array_crystal_array_4_material_string[0]='\0';
#line 1650 "MACS_sample_kidney_box.instr"
  mccchannel_5_analyzer_1_array_crystal_array_4_priority = 720.4;
#line 1649 "MACS_sample_kidney_box.instr"
  mccchannel_5_analyzer_1_array_crystal_array_4_xwidth = channel_5_analyzer_1_array_crystal_depth;
#line 1649 "MACS_sample_kidney_box.instr"
  mccchannel_5_analyzer_1_array_crystal_array_4_yheight = channel_5_analyzer_1_array_crystal_height;
#line 1649 "MACS_sample_kidney_box.instr"
  mccchannel_5_analyzer_1_array_crystal_array_4_zdepth = channel_5_analyzer_1_array_crystal_width;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_5_analyzer_1_array_crystal_array_4_xwidth2 = -1;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_5_analyzer_1_array_crystal_array_4_yheight2 = -1;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_5_analyzer_1_array_crystal_array_4_visualize = 1;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_5_analyzer_1_array_crystal_array_4_target_index = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_5_analyzer_1_array_crystal_array_4_target_x = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_5_analyzer_1_array_crystal_array_4_target_y = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_5_analyzer_1_array_crystal_array_4_target_z = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_5_analyzer_1_array_crystal_array_4_focus_aw = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_5_analyzer_1_array_crystal_array_4_focus_ah = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_5_analyzer_1_array_crystal_array_4_focus_xw = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_5_analyzer_1_array_crystal_array_4_focus_xh = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_5_analyzer_1_array_crystal_array_4_focus_r = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_5_analyzer_1_array_crystal_array_4_p_interact = 0;
#line 71 "MACS_sample_kidney_box.instr"
  if(0) strncpy(mccchannel_5_analyzer_1_array_crystal_array_4_mask_string, 0 ? 0 : "", 16384); else mccchannel_5_analyzer_1_array_crystal_array_4_mask_string[0]='\0';
#line 71 "MACS_sample_kidney_box.instr"
  if(0) strncpy(mccchannel_5_analyzer_1_array_crystal_array_4_mask_setting, 0 ? 0 : "", 16384); else mccchannel_5_analyzer_1_array_crystal_array_4_mask_setting[0]='\0';
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_5_analyzer_1_array_crystal_array_4_number_of_activations = 1;
#line 110418 "MACS_sample_kidney_box.c"

  SIG_MESSAGE("channel_5_analyzer_1_array_crystal_array_4 (Init:Place/Rotate)");
  rot_set_rotation(mctr1,
#line 1652 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 1652 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 1652 "MACS_sample_kidney_box.instr"
    (0 - RAD2DEG * channel_5_analyzer_1_array_theta [ 4 ])*DEG2RAD);
#line 110428 "MACS_sample_kidney_box.c"
  rot_mul(mctr1, mcrotachannel_5_analyzer_1_rotated, mcrotachannel_5_analyzer_1_array_crystal_array_4);
  rot_transpose(mcrotachannel_5_analyzer_1_array_crystal_array_3, mctr1);
  rot_mul(mcrotachannel_5_analyzer_1_array_crystal_array_4, mctr1, mcrotrchannel_5_analyzer_1_array_crystal_array_4);
  mctc1 = coords_set(
#line 1651 "MACS_sample_kidney_box.instr"
    0 + channel_5_analyzer_1_array_effective_radius_of_curvature * ( 1 - cos ( channel_5_analyzer_1_array_theta [ 4 ] ) ),
#line 1651 "MACS_sample_kidney_box.instr"
    0 + channel_5_analyzer_1_array_effective_radius_of_curvature * sin ( channel_5_analyzer_1_array_theta [ 4 ] ),
#line 1651 "MACS_sample_kidney_box.instr"
    0);
#line 110439 "MACS_sample_kidney_box.c"
  rot_transpose(mcrotachannel_5_analyzer_1_rotated, mctr1);
  mctc2 = rot_apply(mctr1, mctc1);
  mcposachannel_5_analyzer_1_array_crystal_array_4 = coords_add(mcposachannel_5_analyzer_1_rotated, mctc2);
  mctc1 = coords_sub(mcposachannel_5_analyzer_1_array_crystal_array_3, mcposachannel_5_analyzer_1_array_crystal_array_4);
  mcposrchannel_5_analyzer_1_array_crystal_array_4 = rot_apply(mcrotachannel_5_analyzer_1_array_crystal_array_4, mctc1);
  mcDEBUG_COMPONENT("channel_5_analyzer_1_array_crystal_array_4", mcposachannel_5_analyzer_1_array_crystal_array_4, mcrotachannel_5_analyzer_1_array_crystal_array_4)
  mccomp_posa[324] = mcposachannel_5_analyzer_1_array_crystal_array_4;
  mccomp_posr[324] = mcposrchannel_5_analyzer_1_array_crystal_array_4;
  mcNCounter[324]  = mcPCounter[324] = mcP2Counter[324] = 0;
  mcAbsorbProp[324]= 0;
    /* Component channel_5_analyzer_1_array_crystal_array_5. */
  /* Setting parameters for component channel_5_analyzer_1_array_crystal_array_5. */
  SIG_MESSAGE("channel_5_analyzer_1_array_crystal_array_5 (Init:SetPar)");
#line 1656 "MACS_sample_kidney_box.instr"
  if("PG_analyzer") strncpy(mccchannel_5_analyzer_1_array_crystal_array_5_material_string, "PG_analyzer" ? "PG_analyzer" : "", 16384); else mccchannel_5_analyzer_1_array_crystal_array_5_material_string[0]='\0';
#line 1656 "MACS_sample_kidney_box.instr"
  mccchannel_5_analyzer_1_array_crystal_array_5_priority = 720.5;
#line 1655 "MACS_sample_kidney_box.instr"
  mccchannel_5_analyzer_1_array_crystal_array_5_xwidth = channel_5_analyzer_1_array_crystal_depth;
#line 1655 "MACS_sample_kidney_box.instr"
  mccchannel_5_analyzer_1_array_crystal_array_5_yheight = channel_5_analyzer_1_array_crystal_height;
#line 1655 "MACS_sample_kidney_box.instr"
  mccchannel_5_analyzer_1_array_crystal_array_5_zdepth = channel_5_analyzer_1_array_crystal_width;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_5_analyzer_1_array_crystal_array_5_xwidth2 = -1;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_5_analyzer_1_array_crystal_array_5_yheight2 = -1;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_5_analyzer_1_array_crystal_array_5_visualize = 1;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_5_analyzer_1_array_crystal_array_5_target_index = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_5_analyzer_1_array_crystal_array_5_target_x = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_5_analyzer_1_array_crystal_array_5_target_y = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_5_analyzer_1_array_crystal_array_5_target_z = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_5_analyzer_1_array_crystal_array_5_focus_aw = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_5_analyzer_1_array_crystal_array_5_focus_ah = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_5_analyzer_1_array_crystal_array_5_focus_xw = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_5_analyzer_1_array_crystal_array_5_focus_xh = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_5_analyzer_1_array_crystal_array_5_focus_r = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_5_analyzer_1_array_crystal_array_5_p_interact = 0;
#line 71 "MACS_sample_kidney_box.instr"
  if(0) strncpy(mccchannel_5_analyzer_1_array_crystal_array_5_mask_string, 0 ? 0 : "", 16384); else mccchannel_5_analyzer_1_array_crystal_array_5_mask_string[0]='\0';
#line 71 "MACS_sample_kidney_box.instr"
  if(0) strncpy(mccchannel_5_analyzer_1_array_crystal_array_5_mask_setting, 0 ? 0 : "", 16384); else mccchannel_5_analyzer_1_array_crystal_array_5_mask_setting[0]='\0';
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_5_analyzer_1_array_crystal_array_5_number_of_activations = 1;
#line 110495 "MACS_sample_kidney_box.c"

  SIG_MESSAGE("channel_5_analyzer_1_array_crystal_array_5 (Init:Place/Rotate)");
  rot_set_rotation(mctr1,
#line 1658 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 1658 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 1658 "MACS_sample_kidney_box.instr"
    (0 - RAD2DEG * channel_5_analyzer_1_array_theta [ 5 ])*DEG2RAD);
#line 110505 "MACS_sample_kidney_box.c"
  rot_mul(mctr1, mcrotachannel_5_analyzer_1_rotated, mcrotachannel_5_analyzer_1_array_crystal_array_5);
  rot_transpose(mcrotachannel_5_analyzer_1_array_crystal_array_4, mctr1);
  rot_mul(mcrotachannel_5_analyzer_1_array_crystal_array_5, mctr1, mcrotrchannel_5_analyzer_1_array_crystal_array_5);
  mctc1 = coords_set(
#line 1657 "MACS_sample_kidney_box.instr"
    0 + channel_5_analyzer_1_array_effective_radius_of_curvature * ( 1 - cos ( channel_5_analyzer_1_array_theta [ 5 ] ) ),
#line 1657 "MACS_sample_kidney_box.instr"
    0 + channel_5_analyzer_1_array_effective_radius_of_curvature * sin ( channel_5_analyzer_1_array_theta [ 5 ] ),
#line 1657 "MACS_sample_kidney_box.instr"
    0);
#line 110516 "MACS_sample_kidney_box.c"
  rot_transpose(mcrotachannel_5_analyzer_1_rotated, mctr1);
  mctc2 = rot_apply(mctr1, mctc1);
  mcposachannel_5_analyzer_1_array_crystal_array_5 = coords_add(mcposachannel_5_analyzer_1_rotated, mctc2);
  mctc1 = coords_sub(mcposachannel_5_analyzer_1_array_crystal_array_4, mcposachannel_5_analyzer_1_array_crystal_array_5);
  mcposrchannel_5_analyzer_1_array_crystal_array_5 = rot_apply(mcrotachannel_5_analyzer_1_array_crystal_array_5, mctc1);
  mcDEBUG_COMPONENT("channel_5_analyzer_1_array_crystal_array_5", mcposachannel_5_analyzer_1_array_crystal_array_5, mcrotachannel_5_analyzer_1_array_crystal_array_5)
  mccomp_posa[325] = mcposachannel_5_analyzer_1_array_crystal_array_5;
  mccomp_posr[325] = mcposrchannel_5_analyzer_1_array_crystal_array_5;
  mcNCounter[325]  = mcPCounter[325] = mcP2Counter[325] = 0;
  mcAbsorbProp[325]= 0;
    /* Component channel_5_analyzer_1_array_crystal_array_6. */
  /* Setting parameters for component channel_5_analyzer_1_array_crystal_array_6. */
  SIG_MESSAGE("channel_5_analyzer_1_array_crystal_array_6 (Init:SetPar)");
#line 1662 "MACS_sample_kidney_box.instr"
  if("PG_analyzer") strncpy(mccchannel_5_analyzer_1_array_crystal_array_6_material_string, "PG_analyzer" ? "PG_analyzer" : "", 16384); else mccchannel_5_analyzer_1_array_crystal_array_6_material_string[0]='\0';
#line 1662 "MACS_sample_kidney_box.instr"
  mccchannel_5_analyzer_1_array_crystal_array_6_priority = 720.6;
#line 1661 "MACS_sample_kidney_box.instr"
  mccchannel_5_analyzer_1_array_crystal_array_6_xwidth = channel_5_analyzer_1_array_crystal_depth;
#line 1661 "MACS_sample_kidney_box.instr"
  mccchannel_5_analyzer_1_array_crystal_array_6_yheight = channel_5_analyzer_1_array_crystal_height;
#line 1661 "MACS_sample_kidney_box.instr"
  mccchannel_5_analyzer_1_array_crystal_array_6_zdepth = channel_5_analyzer_1_array_crystal_width;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_5_analyzer_1_array_crystal_array_6_xwidth2 = -1;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_5_analyzer_1_array_crystal_array_6_yheight2 = -1;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_5_analyzer_1_array_crystal_array_6_visualize = 1;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_5_analyzer_1_array_crystal_array_6_target_index = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_5_analyzer_1_array_crystal_array_6_target_x = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_5_analyzer_1_array_crystal_array_6_target_y = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_5_analyzer_1_array_crystal_array_6_target_z = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_5_analyzer_1_array_crystal_array_6_focus_aw = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_5_analyzer_1_array_crystal_array_6_focus_ah = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_5_analyzer_1_array_crystal_array_6_focus_xw = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_5_analyzer_1_array_crystal_array_6_focus_xh = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_5_analyzer_1_array_crystal_array_6_focus_r = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_5_analyzer_1_array_crystal_array_6_p_interact = 0;
#line 71 "MACS_sample_kidney_box.instr"
  if(0) strncpy(mccchannel_5_analyzer_1_array_crystal_array_6_mask_string, 0 ? 0 : "", 16384); else mccchannel_5_analyzer_1_array_crystal_array_6_mask_string[0]='\0';
#line 71 "MACS_sample_kidney_box.instr"
  if(0) strncpy(mccchannel_5_analyzer_1_array_crystal_array_6_mask_setting, 0 ? 0 : "", 16384); else mccchannel_5_analyzer_1_array_crystal_array_6_mask_setting[0]='\0';
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_5_analyzer_1_array_crystal_array_6_number_of_activations = 1;
#line 110572 "MACS_sample_kidney_box.c"

  SIG_MESSAGE("channel_5_analyzer_1_array_crystal_array_6 (Init:Place/Rotate)");
  rot_set_rotation(mctr1,
#line 1664 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 1664 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 1664 "MACS_sample_kidney_box.instr"
    (0 - RAD2DEG * channel_5_analyzer_1_array_theta [ 6 ])*DEG2RAD);
#line 110582 "MACS_sample_kidney_box.c"
  rot_mul(mctr1, mcrotachannel_5_analyzer_1_rotated, mcrotachannel_5_analyzer_1_array_crystal_array_6);
  rot_transpose(mcrotachannel_5_analyzer_1_array_crystal_array_5, mctr1);
  rot_mul(mcrotachannel_5_analyzer_1_array_crystal_array_6, mctr1, mcrotrchannel_5_analyzer_1_array_crystal_array_6);
  mctc1 = coords_set(
#line 1663 "MACS_sample_kidney_box.instr"
    0 + channel_5_analyzer_1_array_effective_radius_of_curvature * ( 1 - cos ( channel_5_analyzer_1_array_theta [ 6 ] ) ),
#line 1663 "MACS_sample_kidney_box.instr"
    0 + channel_5_analyzer_1_array_effective_radius_of_curvature * sin ( channel_5_analyzer_1_array_theta [ 6 ] ),
#line 1663 "MACS_sample_kidney_box.instr"
    0);
#line 110593 "MACS_sample_kidney_box.c"
  rot_transpose(mcrotachannel_5_analyzer_1_rotated, mctr1);
  mctc2 = rot_apply(mctr1, mctc1);
  mcposachannel_5_analyzer_1_array_crystal_array_6 = coords_add(mcposachannel_5_analyzer_1_rotated, mctc2);
  mctc1 = coords_sub(mcposachannel_5_analyzer_1_array_crystal_array_5, mcposachannel_5_analyzer_1_array_crystal_array_6);
  mcposrchannel_5_analyzer_1_array_crystal_array_6 = rot_apply(mcrotachannel_5_analyzer_1_array_crystal_array_6, mctc1);
  mcDEBUG_COMPONENT("channel_5_analyzer_1_array_crystal_array_6", mcposachannel_5_analyzer_1_array_crystal_array_6, mcrotachannel_5_analyzer_1_array_crystal_array_6)
  mccomp_posa[326] = mcposachannel_5_analyzer_1_array_crystal_array_6;
  mccomp_posr[326] = mcposrchannel_5_analyzer_1_array_crystal_array_6;
  mcNCounter[326]  = mcPCounter[326] = mcP2Counter[326] = 0;
  mcAbsorbProp[326]= 0;
    /* Component channel_5_analyzer_1_array_crystal_array_7. */
  /* Setting parameters for component channel_5_analyzer_1_array_crystal_array_7. */
  SIG_MESSAGE("channel_5_analyzer_1_array_crystal_array_7 (Init:SetPar)");
#line 1668 "MACS_sample_kidney_box.instr"
  if("PG_analyzer") strncpy(mccchannel_5_analyzer_1_array_crystal_array_7_material_string, "PG_analyzer" ? "PG_analyzer" : "", 16384); else mccchannel_5_analyzer_1_array_crystal_array_7_material_string[0]='\0';
#line 1668 "MACS_sample_kidney_box.instr"
  mccchannel_5_analyzer_1_array_crystal_array_7_priority = 720.7;
#line 1667 "MACS_sample_kidney_box.instr"
  mccchannel_5_analyzer_1_array_crystal_array_7_xwidth = channel_5_analyzer_1_array_crystal_depth;
#line 1667 "MACS_sample_kidney_box.instr"
  mccchannel_5_analyzer_1_array_crystal_array_7_yheight = channel_5_analyzer_1_array_crystal_height;
#line 1667 "MACS_sample_kidney_box.instr"
  mccchannel_5_analyzer_1_array_crystal_array_7_zdepth = channel_5_analyzer_1_array_crystal_width;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_5_analyzer_1_array_crystal_array_7_xwidth2 = -1;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_5_analyzer_1_array_crystal_array_7_yheight2 = -1;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_5_analyzer_1_array_crystal_array_7_visualize = 1;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_5_analyzer_1_array_crystal_array_7_target_index = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_5_analyzer_1_array_crystal_array_7_target_x = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_5_analyzer_1_array_crystal_array_7_target_y = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_5_analyzer_1_array_crystal_array_7_target_z = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_5_analyzer_1_array_crystal_array_7_focus_aw = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_5_analyzer_1_array_crystal_array_7_focus_ah = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_5_analyzer_1_array_crystal_array_7_focus_xw = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_5_analyzer_1_array_crystal_array_7_focus_xh = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_5_analyzer_1_array_crystal_array_7_focus_r = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_5_analyzer_1_array_crystal_array_7_p_interact = 0;
#line 71 "MACS_sample_kidney_box.instr"
  if(0) strncpy(mccchannel_5_analyzer_1_array_crystal_array_7_mask_string, 0 ? 0 : "", 16384); else mccchannel_5_analyzer_1_array_crystal_array_7_mask_string[0]='\0';
#line 71 "MACS_sample_kidney_box.instr"
  if(0) strncpy(mccchannel_5_analyzer_1_array_crystal_array_7_mask_setting, 0 ? 0 : "", 16384); else mccchannel_5_analyzer_1_array_crystal_array_7_mask_setting[0]='\0';
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_5_analyzer_1_array_crystal_array_7_number_of_activations = 1;
#line 110649 "MACS_sample_kidney_box.c"

  SIG_MESSAGE("channel_5_analyzer_1_array_crystal_array_7 (Init:Place/Rotate)");
  rot_set_rotation(mctr1,
#line 1670 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 1670 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 1670 "MACS_sample_kidney_box.instr"
    (0 - RAD2DEG * channel_5_analyzer_1_array_theta [ 7 ])*DEG2RAD);
#line 110659 "MACS_sample_kidney_box.c"
  rot_mul(mctr1, mcrotachannel_5_analyzer_1_rotated, mcrotachannel_5_analyzer_1_array_crystal_array_7);
  rot_transpose(mcrotachannel_5_analyzer_1_array_crystal_array_6, mctr1);
  rot_mul(mcrotachannel_5_analyzer_1_array_crystal_array_7, mctr1, mcrotrchannel_5_analyzer_1_array_crystal_array_7);
  mctc1 = coords_set(
#line 1669 "MACS_sample_kidney_box.instr"
    0 + channel_5_analyzer_1_array_effective_radius_of_curvature * ( 1 - cos ( channel_5_analyzer_1_array_theta [ 7 ] ) ),
#line 1669 "MACS_sample_kidney_box.instr"
    0 + channel_5_analyzer_1_array_effective_radius_of_curvature * sin ( channel_5_analyzer_1_array_theta [ 7 ] ),
#line 1669 "MACS_sample_kidney_box.instr"
    0);
#line 110670 "MACS_sample_kidney_box.c"
  rot_transpose(mcrotachannel_5_analyzer_1_rotated, mctr1);
  mctc2 = rot_apply(mctr1, mctc1);
  mcposachannel_5_analyzer_1_array_crystal_array_7 = coords_add(mcposachannel_5_analyzer_1_rotated, mctc2);
  mctc1 = coords_sub(mcposachannel_5_analyzer_1_array_crystal_array_6, mcposachannel_5_analyzer_1_array_crystal_array_7);
  mcposrchannel_5_analyzer_1_array_crystal_array_7 = rot_apply(mcrotachannel_5_analyzer_1_array_crystal_array_7, mctc1);
  mcDEBUG_COMPONENT("channel_5_analyzer_1_array_crystal_array_7", mcposachannel_5_analyzer_1_array_crystal_array_7, mcrotachannel_5_analyzer_1_array_crystal_array_7)
  mccomp_posa[327] = mcposachannel_5_analyzer_1_array_crystal_array_7;
  mccomp_posr[327] = mcposrchannel_5_analyzer_1_array_crystal_array_7;
  mcNCounter[327]  = mcPCounter[327] = mcP2Counter[327] = 0;
  mcAbsorbProp[327]= 0;
    /* Component channel_5_analyzer_1_array_crystal_array_8. */
  /* Setting parameters for component channel_5_analyzer_1_array_crystal_array_8. */
  SIG_MESSAGE("channel_5_analyzer_1_array_crystal_array_8 (Init:SetPar)");
#line 1674 "MACS_sample_kidney_box.instr"
  if("PG_analyzer") strncpy(mccchannel_5_analyzer_1_array_crystal_array_8_material_string, "PG_analyzer" ? "PG_analyzer" : "", 16384); else mccchannel_5_analyzer_1_array_crystal_array_8_material_string[0]='\0';
#line 1674 "MACS_sample_kidney_box.instr"
  mccchannel_5_analyzer_1_array_crystal_array_8_priority = 720.8;
#line 1673 "MACS_sample_kidney_box.instr"
  mccchannel_5_analyzer_1_array_crystal_array_8_xwidth = channel_5_analyzer_1_array_crystal_depth;
#line 1673 "MACS_sample_kidney_box.instr"
  mccchannel_5_analyzer_1_array_crystal_array_8_yheight = channel_5_analyzer_1_array_crystal_height;
#line 1673 "MACS_sample_kidney_box.instr"
  mccchannel_5_analyzer_1_array_crystal_array_8_zdepth = channel_5_analyzer_1_array_crystal_width;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_5_analyzer_1_array_crystal_array_8_xwidth2 = -1;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_5_analyzer_1_array_crystal_array_8_yheight2 = -1;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_5_analyzer_1_array_crystal_array_8_visualize = 1;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_5_analyzer_1_array_crystal_array_8_target_index = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_5_analyzer_1_array_crystal_array_8_target_x = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_5_analyzer_1_array_crystal_array_8_target_y = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_5_analyzer_1_array_crystal_array_8_target_z = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_5_analyzer_1_array_crystal_array_8_focus_aw = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_5_analyzer_1_array_crystal_array_8_focus_ah = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_5_analyzer_1_array_crystal_array_8_focus_xw = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_5_analyzer_1_array_crystal_array_8_focus_xh = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_5_analyzer_1_array_crystal_array_8_focus_r = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_5_analyzer_1_array_crystal_array_8_p_interact = 0;
#line 71 "MACS_sample_kidney_box.instr"
  if(0) strncpy(mccchannel_5_analyzer_1_array_crystal_array_8_mask_string, 0 ? 0 : "", 16384); else mccchannel_5_analyzer_1_array_crystal_array_8_mask_string[0]='\0';
#line 71 "MACS_sample_kidney_box.instr"
  if(0) strncpy(mccchannel_5_analyzer_1_array_crystal_array_8_mask_setting, 0 ? 0 : "", 16384); else mccchannel_5_analyzer_1_array_crystal_array_8_mask_setting[0]='\0';
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_5_analyzer_1_array_crystal_array_8_number_of_activations = 1;
#line 110726 "MACS_sample_kidney_box.c"

  SIG_MESSAGE("channel_5_analyzer_1_array_crystal_array_8 (Init:Place/Rotate)");
  rot_set_rotation(mctr1,
#line 1676 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 1676 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 1676 "MACS_sample_kidney_box.instr"
    (0 - RAD2DEG * channel_5_analyzer_1_array_theta [ 8 ])*DEG2RAD);
#line 110736 "MACS_sample_kidney_box.c"
  rot_mul(mctr1, mcrotachannel_5_analyzer_1_rotated, mcrotachannel_5_analyzer_1_array_crystal_array_8);
  rot_transpose(mcrotachannel_5_analyzer_1_array_crystal_array_7, mctr1);
  rot_mul(mcrotachannel_5_analyzer_1_array_crystal_array_8, mctr1, mcrotrchannel_5_analyzer_1_array_crystal_array_8);
  mctc1 = coords_set(
#line 1675 "MACS_sample_kidney_box.instr"
    0 + channel_5_analyzer_1_array_effective_radius_of_curvature * ( 1 - cos ( channel_5_analyzer_1_array_theta [ 8 ] ) ),
#line 1675 "MACS_sample_kidney_box.instr"
    0 + channel_5_analyzer_1_array_effective_radius_of_curvature * sin ( channel_5_analyzer_1_array_theta [ 8 ] ),
#line 1675 "MACS_sample_kidney_box.instr"
    0);
#line 110747 "MACS_sample_kidney_box.c"
  rot_transpose(mcrotachannel_5_analyzer_1_rotated, mctr1);
  mctc2 = rot_apply(mctr1, mctc1);
  mcposachannel_5_analyzer_1_array_crystal_array_8 = coords_add(mcposachannel_5_analyzer_1_rotated, mctc2);
  mctc1 = coords_sub(mcposachannel_5_analyzer_1_array_crystal_array_7, mcposachannel_5_analyzer_1_array_crystal_array_8);
  mcposrchannel_5_analyzer_1_array_crystal_array_8 = rot_apply(mcrotachannel_5_analyzer_1_array_crystal_array_8, mctc1);
  mcDEBUG_COMPONENT("channel_5_analyzer_1_array_crystal_array_8", mcposachannel_5_analyzer_1_array_crystal_array_8, mcrotachannel_5_analyzer_1_array_crystal_array_8)
  mccomp_posa[328] = mcposachannel_5_analyzer_1_array_crystal_array_8;
  mccomp_posr[328] = mcposrchannel_5_analyzer_1_array_crystal_array_8;
  mcNCounter[328]  = mcPCounter[328] = mcP2Counter[328] = 0;
  mcAbsorbProp[328]= 0;
    /* Component channel_5_analyzer_2_center. */
  /* Setting parameters for component channel_5_analyzer_2_center. */
  SIG_MESSAGE("channel_5_analyzer_2_center (Init:SetPar)");

  SIG_MESSAGE("channel_5_analyzer_2_center (Init:Place/Rotate)");
  rot_set_rotation(mctr1,
    (0.0)*DEG2RAD,
    (0.0)*DEG2RAD,
    (0.0)*DEG2RAD);
#line 110767 "MACS_sample_kidney_box.c"
  rot_mul(mctr1, mcrotachannel_5_analyzer_1_center, mcrotachannel_5_analyzer_2_center);
  rot_transpose(mcrotachannel_5_analyzer_1_array_crystal_array_8, mctr1);
  rot_mul(mcrotachannel_5_analyzer_2_center, mctr1, mcrotrchannel_5_analyzer_2_center);
  mctc1 = coords_set(
#line 1680 "MACS_sample_kidney_box.instr"
    - analyzer_seperation,
#line 1680 "MACS_sample_kidney_box.instr"
    0,
#line 1680 "MACS_sample_kidney_box.instr"
    0);
#line 110778 "MACS_sample_kidney_box.c"
  rot_transpose(mcrotachannel_5_analyzer_1_center, mctr1);
  mctc2 = rot_apply(mctr1, mctc1);
  mcposachannel_5_analyzer_2_center = coords_add(mcposachannel_5_analyzer_1_center, mctc2);
  mctc1 = coords_sub(mcposachannel_5_analyzer_1_array_crystal_array_8, mcposachannel_5_analyzer_2_center);
  mcposrchannel_5_analyzer_2_center = rot_apply(mcrotachannel_5_analyzer_2_center, mctc1);
  mcDEBUG_COMPONENT("channel_5_analyzer_2_center", mcposachannel_5_analyzer_2_center, mcrotachannel_5_analyzer_2_center)
  mccomp_posa[329] = mcposachannel_5_analyzer_2_center;
  mccomp_posr[329] = mcposrchannel_5_analyzer_2_center;
  mcNCounter[329]  = mcPCounter[329] = mcP2Counter[329] = 0;
  mcAbsorbProp[329]= 0;
    /* Component channel_5_analyzer_2_rotated. */
  /* Setting parameters for component channel_5_analyzer_2_rotated. */
  SIG_MESSAGE("channel_5_analyzer_2_rotated (Init:SetPar)");

  SIG_MESSAGE("channel_5_analyzer_2_rotated (Init:Place/Rotate)");
  rot_set_rotation(mctr1,
#line 1684 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 1684 "MACS_sample_kidney_box.instr"
    (- analyzer_theta [ 5 ])*DEG2RAD,
#line 1684 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD);
#line 110801 "MACS_sample_kidney_box.c"
  rot_mul(mctr1, mcrotachannel_5_analyzer_2_center, mcrotachannel_5_analyzer_2_rotated);
  rot_transpose(mcrotachannel_5_analyzer_2_center, mctr1);
  rot_mul(mcrotachannel_5_analyzer_2_rotated, mctr1, mcrotrchannel_5_analyzer_2_rotated);
  mctc1 = coords_set(
#line 1683 "MACS_sample_kidney_box.instr"
    0,
#line 1683 "MACS_sample_kidney_box.instr"
    0,
#line 1683 "MACS_sample_kidney_box.instr"
    0.5 * analyzer_seperation / tan ( analyzer_2theta [ 5 ] * DEG2RAD ));
#line 110812 "MACS_sample_kidney_box.c"
  rot_transpose(mcrotachannel_5_analyzer_2_center, mctr1);
  mctc2 = rot_apply(mctr1, mctc1);
  mcposachannel_5_analyzer_2_rotated = coords_add(mcposachannel_5_analyzer_2_center, mctc2);
  mctc1 = coords_sub(mcposachannel_5_analyzer_2_center, mcposachannel_5_analyzer_2_rotated);
  mcposrchannel_5_analyzer_2_rotated = rot_apply(mcrotachannel_5_analyzer_2_rotated, mctc1);
  mcDEBUG_COMPONENT("channel_5_analyzer_2_rotated", mcposachannel_5_analyzer_2_rotated, mcrotachannel_5_analyzer_2_rotated)
  mccomp_posa[330] = mcposachannel_5_analyzer_2_rotated;
  mccomp_posr[330] = mcposrchannel_5_analyzer_2_rotated;
  mcNCounter[330]  = mcPCounter[330] = mcP2Counter[330] = 0;
  mcAbsorbProp[330]= 0;
    /* Component channel_5_analyzer_2_array_crystal_array_0. */
  /* Setting parameters for component channel_5_analyzer_2_array_crystal_array_0. */
  SIG_MESSAGE("channel_5_analyzer_2_array_crystal_array_0 (Init:SetPar)");
#line 1688 "MACS_sample_kidney_box.instr"
  if("PG_analyzer") strncpy(mccchannel_5_analyzer_2_array_crystal_array_0_material_string, "PG_analyzer" ? "PG_analyzer" : "", 16384); else mccchannel_5_analyzer_2_array_crystal_array_0_material_string[0]='\0';
#line 1688 "MACS_sample_kidney_box.instr"
  mccchannel_5_analyzer_2_array_crystal_array_0_priority = 721.0;
#line 1687 "MACS_sample_kidney_box.instr"
  mccchannel_5_analyzer_2_array_crystal_array_0_xwidth = channel_5_analyzer_2_array_crystal_depth;
#line 1687 "MACS_sample_kidney_box.instr"
  mccchannel_5_analyzer_2_array_crystal_array_0_yheight = channel_5_analyzer_2_array_crystal_height;
#line 1687 "MACS_sample_kidney_box.instr"
  mccchannel_5_analyzer_2_array_crystal_array_0_zdepth = channel_5_analyzer_2_array_crystal_width;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_5_analyzer_2_array_crystal_array_0_xwidth2 = -1;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_5_analyzer_2_array_crystal_array_0_yheight2 = -1;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_5_analyzer_2_array_crystal_array_0_visualize = 1;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_5_analyzer_2_array_crystal_array_0_target_index = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_5_analyzer_2_array_crystal_array_0_target_x = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_5_analyzer_2_array_crystal_array_0_target_y = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_5_analyzer_2_array_crystal_array_0_target_z = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_5_analyzer_2_array_crystal_array_0_focus_aw = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_5_analyzer_2_array_crystal_array_0_focus_ah = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_5_analyzer_2_array_crystal_array_0_focus_xw = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_5_analyzer_2_array_crystal_array_0_focus_xh = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_5_analyzer_2_array_crystal_array_0_focus_r = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_5_analyzer_2_array_crystal_array_0_p_interact = 0;
#line 71 "MACS_sample_kidney_box.instr"
  if(0) strncpy(mccchannel_5_analyzer_2_array_crystal_array_0_mask_string, 0 ? 0 : "", 16384); else mccchannel_5_analyzer_2_array_crystal_array_0_mask_string[0]='\0';
#line 71 "MACS_sample_kidney_box.instr"
  if(0) strncpy(mccchannel_5_analyzer_2_array_crystal_array_0_mask_setting, 0 ? 0 : "", 16384); else mccchannel_5_analyzer_2_array_crystal_array_0_mask_setting[0]='\0';
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_5_analyzer_2_array_crystal_array_0_number_of_activations = 1;
#line 110868 "MACS_sample_kidney_box.c"

  SIG_MESSAGE("channel_5_analyzer_2_array_crystal_array_0 (Init:Place/Rotate)");
  rot_set_rotation(mctr1,
#line 1690 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 1690 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 1690 "MACS_sample_kidney_box.instr"
    (0 - RAD2DEG * channel_5_analyzer_2_array_theta [ 0 ])*DEG2RAD);
#line 110878 "MACS_sample_kidney_box.c"
  rot_mul(mctr1, mcrotachannel_5_analyzer_2_rotated, mcrotachannel_5_analyzer_2_array_crystal_array_0);
  rot_transpose(mcrotachannel_5_analyzer_2_rotated, mctr1);
  rot_mul(mcrotachannel_5_analyzer_2_array_crystal_array_0, mctr1, mcrotrchannel_5_analyzer_2_array_crystal_array_0);
  mctc1 = coords_set(
#line 1689 "MACS_sample_kidney_box.instr"
    0 + channel_5_analyzer_2_array_effective_radius_of_curvature * ( 1 - cos ( channel_5_analyzer_2_array_theta [ 0 ] ) ),
#line 1689 "MACS_sample_kidney_box.instr"
    0 + channel_5_analyzer_2_array_effective_radius_of_curvature * sin ( channel_5_analyzer_2_array_theta [ 0 ] ),
#line 1689 "MACS_sample_kidney_box.instr"
    0);
#line 110889 "MACS_sample_kidney_box.c"
  rot_transpose(mcrotachannel_5_analyzer_2_rotated, mctr1);
  mctc2 = rot_apply(mctr1, mctc1);
  mcposachannel_5_analyzer_2_array_crystal_array_0 = coords_add(mcposachannel_5_analyzer_2_rotated, mctc2);
  mctc1 = coords_sub(mcposachannel_5_analyzer_2_rotated, mcposachannel_5_analyzer_2_array_crystal_array_0);
  mcposrchannel_5_analyzer_2_array_crystal_array_0 = rot_apply(mcrotachannel_5_analyzer_2_array_crystal_array_0, mctc1);
  mcDEBUG_COMPONENT("channel_5_analyzer_2_array_crystal_array_0", mcposachannel_5_analyzer_2_array_crystal_array_0, mcrotachannel_5_analyzer_2_array_crystal_array_0)
  mccomp_posa[331] = mcposachannel_5_analyzer_2_array_crystal_array_0;
  mccomp_posr[331] = mcposrchannel_5_analyzer_2_array_crystal_array_0;
  mcNCounter[331]  = mcPCounter[331] = mcP2Counter[331] = 0;
  mcAbsorbProp[331]= 0;
    /* Component channel_5_analyzer_2_array_crystal_array_1. */
  /* Setting parameters for component channel_5_analyzer_2_array_crystal_array_1. */
  SIG_MESSAGE("channel_5_analyzer_2_array_crystal_array_1 (Init:SetPar)");
#line 1694 "MACS_sample_kidney_box.instr"
  if("PG_analyzer") strncpy(mccchannel_5_analyzer_2_array_crystal_array_1_material_string, "PG_analyzer" ? "PG_analyzer" : "", 16384); else mccchannel_5_analyzer_2_array_crystal_array_1_material_string[0]='\0';
#line 1694 "MACS_sample_kidney_box.instr"
  mccchannel_5_analyzer_2_array_crystal_array_1_priority = 721.1;
#line 1693 "MACS_sample_kidney_box.instr"
  mccchannel_5_analyzer_2_array_crystal_array_1_xwidth = channel_5_analyzer_2_array_crystal_depth;
#line 1693 "MACS_sample_kidney_box.instr"
  mccchannel_5_analyzer_2_array_crystal_array_1_yheight = channel_5_analyzer_2_array_crystal_height;
#line 1693 "MACS_sample_kidney_box.instr"
  mccchannel_5_analyzer_2_array_crystal_array_1_zdepth = channel_5_analyzer_2_array_crystal_width;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_5_analyzer_2_array_crystal_array_1_xwidth2 = -1;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_5_analyzer_2_array_crystal_array_1_yheight2 = -1;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_5_analyzer_2_array_crystal_array_1_visualize = 1;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_5_analyzer_2_array_crystal_array_1_target_index = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_5_analyzer_2_array_crystal_array_1_target_x = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_5_analyzer_2_array_crystal_array_1_target_y = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_5_analyzer_2_array_crystal_array_1_target_z = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_5_analyzer_2_array_crystal_array_1_focus_aw = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_5_analyzer_2_array_crystal_array_1_focus_ah = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_5_analyzer_2_array_crystal_array_1_focus_xw = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_5_analyzer_2_array_crystal_array_1_focus_xh = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_5_analyzer_2_array_crystal_array_1_focus_r = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_5_analyzer_2_array_crystal_array_1_p_interact = 0;
#line 71 "MACS_sample_kidney_box.instr"
  if(0) strncpy(mccchannel_5_analyzer_2_array_crystal_array_1_mask_string, 0 ? 0 : "", 16384); else mccchannel_5_analyzer_2_array_crystal_array_1_mask_string[0]='\0';
#line 71 "MACS_sample_kidney_box.instr"
  if(0) strncpy(mccchannel_5_analyzer_2_array_crystal_array_1_mask_setting, 0 ? 0 : "", 16384); else mccchannel_5_analyzer_2_array_crystal_array_1_mask_setting[0]='\0';
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_5_analyzer_2_array_crystal_array_1_number_of_activations = 1;
#line 110945 "MACS_sample_kidney_box.c"

  SIG_MESSAGE("channel_5_analyzer_2_array_crystal_array_1 (Init:Place/Rotate)");
  rot_set_rotation(mctr1,
#line 1696 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 1696 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 1696 "MACS_sample_kidney_box.instr"
    (0 - RAD2DEG * channel_5_analyzer_2_array_theta [ 1 ])*DEG2RAD);
#line 110955 "MACS_sample_kidney_box.c"
  rot_mul(mctr1, mcrotachannel_5_analyzer_2_rotated, mcrotachannel_5_analyzer_2_array_crystal_array_1);
  rot_transpose(mcrotachannel_5_analyzer_2_array_crystal_array_0, mctr1);
  rot_mul(mcrotachannel_5_analyzer_2_array_crystal_array_1, mctr1, mcrotrchannel_5_analyzer_2_array_crystal_array_1);
  mctc1 = coords_set(
#line 1695 "MACS_sample_kidney_box.instr"
    0 + channel_5_analyzer_2_array_effective_radius_of_curvature * ( 1 - cos ( channel_5_analyzer_2_array_theta [ 1 ] ) ),
#line 1695 "MACS_sample_kidney_box.instr"
    0 + channel_5_analyzer_2_array_effective_radius_of_curvature * sin ( channel_5_analyzer_2_array_theta [ 1 ] ),
#line 1695 "MACS_sample_kidney_box.instr"
    0);
#line 110966 "MACS_sample_kidney_box.c"
  rot_transpose(mcrotachannel_5_analyzer_2_rotated, mctr1);
  mctc2 = rot_apply(mctr1, mctc1);
  mcposachannel_5_analyzer_2_array_crystal_array_1 = coords_add(mcposachannel_5_analyzer_2_rotated, mctc2);
  mctc1 = coords_sub(mcposachannel_5_analyzer_2_array_crystal_array_0, mcposachannel_5_analyzer_2_array_crystal_array_1);
  mcposrchannel_5_analyzer_2_array_crystal_array_1 = rot_apply(mcrotachannel_5_analyzer_2_array_crystal_array_1, mctc1);
  mcDEBUG_COMPONENT("channel_5_analyzer_2_array_crystal_array_1", mcposachannel_5_analyzer_2_array_crystal_array_1, mcrotachannel_5_analyzer_2_array_crystal_array_1)
  mccomp_posa[332] = mcposachannel_5_analyzer_2_array_crystal_array_1;
  mccomp_posr[332] = mcposrchannel_5_analyzer_2_array_crystal_array_1;
  mcNCounter[332]  = mcPCounter[332] = mcP2Counter[332] = 0;
  mcAbsorbProp[332]= 0;
    /* Component channel_5_analyzer_2_array_crystal_array_2. */
  /* Setting parameters for component channel_5_analyzer_2_array_crystal_array_2. */
  SIG_MESSAGE("channel_5_analyzer_2_array_crystal_array_2 (Init:SetPar)");
#line 1700 "MACS_sample_kidney_box.instr"
  if("PG_analyzer") strncpy(mccchannel_5_analyzer_2_array_crystal_array_2_material_string, "PG_analyzer" ? "PG_analyzer" : "", 16384); else mccchannel_5_analyzer_2_array_crystal_array_2_material_string[0]='\0';
#line 1700 "MACS_sample_kidney_box.instr"
  mccchannel_5_analyzer_2_array_crystal_array_2_priority = 721.2;
#line 1699 "MACS_sample_kidney_box.instr"
  mccchannel_5_analyzer_2_array_crystal_array_2_xwidth = channel_5_analyzer_2_array_crystal_depth;
#line 1699 "MACS_sample_kidney_box.instr"
  mccchannel_5_analyzer_2_array_crystal_array_2_yheight = channel_5_analyzer_2_array_crystal_height;
#line 1699 "MACS_sample_kidney_box.instr"
  mccchannel_5_analyzer_2_array_crystal_array_2_zdepth = channel_5_analyzer_2_array_crystal_width;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_5_analyzer_2_array_crystal_array_2_xwidth2 = -1;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_5_analyzer_2_array_crystal_array_2_yheight2 = -1;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_5_analyzer_2_array_crystal_array_2_visualize = 1;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_5_analyzer_2_array_crystal_array_2_target_index = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_5_analyzer_2_array_crystal_array_2_target_x = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_5_analyzer_2_array_crystal_array_2_target_y = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_5_analyzer_2_array_crystal_array_2_target_z = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_5_analyzer_2_array_crystal_array_2_focus_aw = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_5_analyzer_2_array_crystal_array_2_focus_ah = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_5_analyzer_2_array_crystal_array_2_focus_xw = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_5_analyzer_2_array_crystal_array_2_focus_xh = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_5_analyzer_2_array_crystal_array_2_focus_r = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_5_analyzer_2_array_crystal_array_2_p_interact = 0;
#line 71 "MACS_sample_kidney_box.instr"
  if(0) strncpy(mccchannel_5_analyzer_2_array_crystal_array_2_mask_string, 0 ? 0 : "", 16384); else mccchannel_5_analyzer_2_array_crystal_array_2_mask_string[0]='\0';
#line 71 "MACS_sample_kidney_box.instr"
  if(0) strncpy(mccchannel_5_analyzer_2_array_crystal_array_2_mask_setting, 0 ? 0 : "", 16384); else mccchannel_5_analyzer_2_array_crystal_array_2_mask_setting[0]='\0';
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_5_analyzer_2_array_crystal_array_2_number_of_activations = 1;
#line 111022 "MACS_sample_kidney_box.c"

  SIG_MESSAGE("channel_5_analyzer_2_array_crystal_array_2 (Init:Place/Rotate)");
  rot_set_rotation(mctr1,
#line 1702 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 1702 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 1702 "MACS_sample_kidney_box.instr"
    (0 - RAD2DEG * channel_5_analyzer_2_array_theta [ 2 ])*DEG2RAD);
#line 111032 "MACS_sample_kidney_box.c"
  rot_mul(mctr1, mcrotachannel_5_analyzer_2_rotated, mcrotachannel_5_analyzer_2_array_crystal_array_2);
  rot_transpose(mcrotachannel_5_analyzer_2_array_crystal_array_1, mctr1);
  rot_mul(mcrotachannel_5_analyzer_2_array_crystal_array_2, mctr1, mcrotrchannel_5_analyzer_2_array_crystal_array_2);
  mctc1 = coords_set(
#line 1701 "MACS_sample_kidney_box.instr"
    0 + channel_5_analyzer_2_array_effective_radius_of_curvature * ( 1 - cos ( channel_5_analyzer_2_array_theta [ 2 ] ) ),
#line 1701 "MACS_sample_kidney_box.instr"
    0 + channel_5_analyzer_2_array_effective_radius_of_curvature * sin ( channel_5_analyzer_2_array_theta [ 2 ] ),
#line 1701 "MACS_sample_kidney_box.instr"
    0);
#line 111043 "MACS_sample_kidney_box.c"
  rot_transpose(mcrotachannel_5_analyzer_2_rotated, mctr1);
  mctc2 = rot_apply(mctr1, mctc1);
  mcposachannel_5_analyzer_2_array_crystal_array_2 = coords_add(mcposachannel_5_analyzer_2_rotated, mctc2);
  mctc1 = coords_sub(mcposachannel_5_analyzer_2_array_crystal_array_1, mcposachannel_5_analyzer_2_array_crystal_array_2);
  mcposrchannel_5_analyzer_2_array_crystal_array_2 = rot_apply(mcrotachannel_5_analyzer_2_array_crystal_array_2, mctc1);
  mcDEBUG_COMPONENT("channel_5_analyzer_2_array_crystal_array_2", mcposachannel_5_analyzer_2_array_crystal_array_2, mcrotachannel_5_analyzer_2_array_crystal_array_2)
  mccomp_posa[333] = mcposachannel_5_analyzer_2_array_crystal_array_2;
  mccomp_posr[333] = mcposrchannel_5_analyzer_2_array_crystal_array_2;
  mcNCounter[333]  = mcPCounter[333] = mcP2Counter[333] = 0;
  mcAbsorbProp[333]= 0;
    /* Component channel_5_analyzer_2_array_crystal_array_3. */
  /* Setting parameters for component channel_5_analyzer_2_array_crystal_array_3. */
  SIG_MESSAGE("channel_5_analyzer_2_array_crystal_array_3 (Init:SetPar)");
#line 1706 "MACS_sample_kidney_box.instr"
  if("PG_analyzer") strncpy(mccchannel_5_analyzer_2_array_crystal_array_3_material_string, "PG_analyzer" ? "PG_analyzer" : "", 16384); else mccchannel_5_analyzer_2_array_crystal_array_3_material_string[0]='\0';
#line 1706 "MACS_sample_kidney_box.instr"
  mccchannel_5_analyzer_2_array_crystal_array_3_priority = 721.3;
#line 1705 "MACS_sample_kidney_box.instr"
  mccchannel_5_analyzer_2_array_crystal_array_3_xwidth = channel_5_analyzer_2_array_crystal_depth;
#line 1705 "MACS_sample_kidney_box.instr"
  mccchannel_5_analyzer_2_array_crystal_array_3_yheight = channel_5_analyzer_2_array_crystal_height;
#line 1705 "MACS_sample_kidney_box.instr"
  mccchannel_5_analyzer_2_array_crystal_array_3_zdepth = channel_5_analyzer_2_array_crystal_width;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_5_analyzer_2_array_crystal_array_3_xwidth2 = -1;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_5_analyzer_2_array_crystal_array_3_yheight2 = -1;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_5_analyzer_2_array_crystal_array_3_visualize = 1;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_5_analyzer_2_array_crystal_array_3_target_index = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_5_analyzer_2_array_crystal_array_3_target_x = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_5_analyzer_2_array_crystal_array_3_target_y = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_5_analyzer_2_array_crystal_array_3_target_z = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_5_analyzer_2_array_crystal_array_3_focus_aw = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_5_analyzer_2_array_crystal_array_3_focus_ah = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_5_analyzer_2_array_crystal_array_3_focus_xw = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_5_analyzer_2_array_crystal_array_3_focus_xh = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_5_analyzer_2_array_crystal_array_3_focus_r = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_5_analyzer_2_array_crystal_array_3_p_interact = 0;
#line 71 "MACS_sample_kidney_box.instr"
  if(0) strncpy(mccchannel_5_analyzer_2_array_crystal_array_3_mask_string, 0 ? 0 : "", 16384); else mccchannel_5_analyzer_2_array_crystal_array_3_mask_string[0]='\0';
#line 71 "MACS_sample_kidney_box.instr"
  if(0) strncpy(mccchannel_5_analyzer_2_array_crystal_array_3_mask_setting, 0 ? 0 : "", 16384); else mccchannel_5_analyzer_2_array_crystal_array_3_mask_setting[0]='\0';
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_5_analyzer_2_array_crystal_array_3_number_of_activations = 1;
#line 111099 "MACS_sample_kidney_box.c"

  SIG_MESSAGE("channel_5_analyzer_2_array_crystal_array_3 (Init:Place/Rotate)");
  rot_set_rotation(mctr1,
#line 1708 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 1708 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 1708 "MACS_sample_kidney_box.instr"
    (0 - RAD2DEG * channel_5_analyzer_2_array_theta [ 3 ])*DEG2RAD);
#line 111109 "MACS_sample_kidney_box.c"
  rot_mul(mctr1, mcrotachannel_5_analyzer_2_rotated, mcrotachannel_5_analyzer_2_array_crystal_array_3);
  rot_transpose(mcrotachannel_5_analyzer_2_array_crystal_array_2, mctr1);
  rot_mul(mcrotachannel_5_analyzer_2_array_crystal_array_3, mctr1, mcrotrchannel_5_analyzer_2_array_crystal_array_3);
  mctc1 = coords_set(
#line 1707 "MACS_sample_kidney_box.instr"
    0 + channel_5_analyzer_2_array_effective_radius_of_curvature * ( 1 - cos ( channel_5_analyzer_2_array_theta [ 3 ] ) ),
#line 1707 "MACS_sample_kidney_box.instr"
    0 + channel_5_analyzer_2_array_effective_radius_of_curvature * sin ( channel_5_analyzer_2_array_theta [ 3 ] ),
#line 1707 "MACS_sample_kidney_box.instr"
    0);
#line 111120 "MACS_sample_kidney_box.c"
  rot_transpose(mcrotachannel_5_analyzer_2_rotated, mctr1);
  mctc2 = rot_apply(mctr1, mctc1);
  mcposachannel_5_analyzer_2_array_crystal_array_3 = coords_add(mcposachannel_5_analyzer_2_rotated, mctc2);
  mctc1 = coords_sub(mcposachannel_5_analyzer_2_array_crystal_array_2, mcposachannel_5_analyzer_2_array_crystal_array_3);
  mcposrchannel_5_analyzer_2_array_crystal_array_3 = rot_apply(mcrotachannel_5_analyzer_2_array_crystal_array_3, mctc1);
  mcDEBUG_COMPONENT("channel_5_analyzer_2_array_crystal_array_3", mcposachannel_5_analyzer_2_array_crystal_array_3, mcrotachannel_5_analyzer_2_array_crystal_array_3)
  mccomp_posa[334] = mcposachannel_5_analyzer_2_array_crystal_array_3;
  mccomp_posr[334] = mcposrchannel_5_analyzer_2_array_crystal_array_3;
  mcNCounter[334]  = mcPCounter[334] = mcP2Counter[334] = 0;
  mcAbsorbProp[334]= 0;
    /* Component channel_5_analyzer_2_array_crystal_array_4. */
  /* Setting parameters for component channel_5_analyzer_2_array_crystal_array_4. */
  SIG_MESSAGE("channel_5_analyzer_2_array_crystal_array_4 (Init:SetPar)");
#line 1712 "MACS_sample_kidney_box.instr"
  if("PG_analyzer") strncpy(mccchannel_5_analyzer_2_array_crystal_array_4_material_string, "PG_analyzer" ? "PG_analyzer" : "", 16384); else mccchannel_5_analyzer_2_array_crystal_array_4_material_string[0]='\0';
#line 1712 "MACS_sample_kidney_box.instr"
  mccchannel_5_analyzer_2_array_crystal_array_4_priority = 721.4;
#line 1711 "MACS_sample_kidney_box.instr"
  mccchannel_5_analyzer_2_array_crystal_array_4_xwidth = channel_5_analyzer_2_array_crystal_depth;
#line 1711 "MACS_sample_kidney_box.instr"
  mccchannel_5_analyzer_2_array_crystal_array_4_yheight = channel_5_analyzer_2_array_crystal_height;
#line 1711 "MACS_sample_kidney_box.instr"
  mccchannel_5_analyzer_2_array_crystal_array_4_zdepth = channel_5_analyzer_2_array_crystal_width;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_5_analyzer_2_array_crystal_array_4_xwidth2 = -1;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_5_analyzer_2_array_crystal_array_4_yheight2 = -1;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_5_analyzer_2_array_crystal_array_4_visualize = 1;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_5_analyzer_2_array_crystal_array_4_target_index = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_5_analyzer_2_array_crystal_array_4_target_x = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_5_analyzer_2_array_crystal_array_4_target_y = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_5_analyzer_2_array_crystal_array_4_target_z = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_5_analyzer_2_array_crystal_array_4_focus_aw = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_5_analyzer_2_array_crystal_array_4_focus_ah = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_5_analyzer_2_array_crystal_array_4_focus_xw = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_5_analyzer_2_array_crystal_array_4_focus_xh = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_5_analyzer_2_array_crystal_array_4_focus_r = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_5_analyzer_2_array_crystal_array_4_p_interact = 0;
#line 71 "MACS_sample_kidney_box.instr"
  if(0) strncpy(mccchannel_5_analyzer_2_array_crystal_array_4_mask_string, 0 ? 0 : "", 16384); else mccchannel_5_analyzer_2_array_crystal_array_4_mask_string[0]='\0';
#line 71 "MACS_sample_kidney_box.instr"
  if(0) strncpy(mccchannel_5_analyzer_2_array_crystal_array_4_mask_setting, 0 ? 0 : "", 16384); else mccchannel_5_analyzer_2_array_crystal_array_4_mask_setting[0]='\0';
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_5_analyzer_2_array_crystal_array_4_number_of_activations = 1;
#line 111176 "MACS_sample_kidney_box.c"

  SIG_MESSAGE("channel_5_analyzer_2_array_crystal_array_4 (Init:Place/Rotate)");
  rot_set_rotation(mctr1,
#line 1714 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 1714 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 1714 "MACS_sample_kidney_box.instr"
    (0 - RAD2DEG * channel_5_analyzer_2_array_theta [ 4 ])*DEG2RAD);
#line 111186 "MACS_sample_kidney_box.c"
  rot_mul(mctr1, mcrotachannel_5_analyzer_2_rotated, mcrotachannel_5_analyzer_2_array_crystal_array_4);
  rot_transpose(mcrotachannel_5_analyzer_2_array_crystal_array_3, mctr1);
  rot_mul(mcrotachannel_5_analyzer_2_array_crystal_array_4, mctr1, mcrotrchannel_5_analyzer_2_array_crystal_array_4);
  mctc1 = coords_set(
#line 1713 "MACS_sample_kidney_box.instr"
    0 + channel_5_analyzer_2_array_effective_radius_of_curvature * ( 1 - cos ( channel_5_analyzer_2_array_theta [ 4 ] ) ),
#line 1713 "MACS_sample_kidney_box.instr"
    0 + channel_5_analyzer_2_array_effective_radius_of_curvature * sin ( channel_5_analyzer_2_array_theta [ 4 ] ),
#line 1713 "MACS_sample_kidney_box.instr"
    0);
#line 111197 "MACS_sample_kidney_box.c"
  rot_transpose(mcrotachannel_5_analyzer_2_rotated, mctr1);
  mctc2 = rot_apply(mctr1, mctc1);
  mcposachannel_5_analyzer_2_array_crystal_array_4 = coords_add(mcposachannel_5_analyzer_2_rotated, mctc2);
  mctc1 = coords_sub(mcposachannel_5_analyzer_2_array_crystal_array_3, mcposachannel_5_analyzer_2_array_crystal_array_4);
  mcposrchannel_5_analyzer_2_array_crystal_array_4 = rot_apply(mcrotachannel_5_analyzer_2_array_crystal_array_4, mctc1);
  mcDEBUG_COMPONENT("channel_5_analyzer_2_array_crystal_array_4", mcposachannel_5_analyzer_2_array_crystal_array_4, mcrotachannel_5_analyzer_2_array_crystal_array_4)
  mccomp_posa[335] = mcposachannel_5_analyzer_2_array_crystal_array_4;
  mccomp_posr[335] = mcposrchannel_5_analyzer_2_array_crystal_array_4;
  mcNCounter[335]  = mcPCounter[335] = mcP2Counter[335] = 0;
  mcAbsorbProp[335]= 0;
    /* Component channel_5_analyzer_2_array_crystal_array_5. */
  /* Setting parameters for component channel_5_analyzer_2_array_crystal_array_5. */
  SIG_MESSAGE("channel_5_analyzer_2_array_crystal_array_5 (Init:SetPar)");
#line 1718 "MACS_sample_kidney_box.instr"
  if("PG_analyzer") strncpy(mccchannel_5_analyzer_2_array_crystal_array_5_material_string, "PG_analyzer" ? "PG_analyzer" : "", 16384); else mccchannel_5_analyzer_2_array_crystal_array_5_material_string[0]='\0';
#line 1718 "MACS_sample_kidney_box.instr"
  mccchannel_5_analyzer_2_array_crystal_array_5_priority = 721.5;
#line 1717 "MACS_sample_kidney_box.instr"
  mccchannel_5_analyzer_2_array_crystal_array_5_xwidth = channel_5_analyzer_2_array_crystal_depth;
#line 1717 "MACS_sample_kidney_box.instr"
  mccchannel_5_analyzer_2_array_crystal_array_5_yheight = channel_5_analyzer_2_array_crystal_height;
#line 1717 "MACS_sample_kidney_box.instr"
  mccchannel_5_analyzer_2_array_crystal_array_5_zdepth = channel_5_analyzer_2_array_crystal_width;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_5_analyzer_2_array_crystal_array_5_xwidth2 = -1;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_5_analyzer_2_array_crystal_array_5_yheight2 = -1;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_5_analyzer_2_array_crystal_array_5_visualize = 1;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_5_analyzer_2_array_crystal_array_5_target_index = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_5_analyzer_2_array_crystal_array_5_target_x = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_5_analyzer_2_array_crystal_array_5_target_y = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_5_analyzer_2_array_crystal_array_5_target_z = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_5_analyzer_2_array_crystal_array_5_focus_aw = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_5_analyzer_2_array_crystal_array_5_focus_ah = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_5_analyzer_2_array_crystal_array_5_focus_xw = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_5_analyzer_2_array_crystal_array_5_focus_xh = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_5_analyzer_2_array_crystal_array_5_focus_r = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_5_analyzer_2_array_crystal_array_5_p_interact = 0;
#line 71 "MACS_sample_kidney_box.instr"
  if(0) strncpy(mccchannel_5_analyzer_2_array_crystal_array_5_mask_string, 0 ? 0 : "", 16384); else mccchannel_5_analyzer_2_array_crystal_array_5_mask_string[0]='\0';
#line 71 "MACS_sample_kidney_box.instr"
  if(0) strncpy(mccchannel_5_analyzer_2_array_crystal_array_5_mask_setting, 0 ? 0 : "", 16384); else mccchannel_5_analyzer_2_array_crystal_array_5_mask_setting[0]='\0';
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_5_analyzer_2_array_crystal_array_5_number_of_activations = 1;
#line 111253 "MACS_sample_kidney_box.c"

  SIG_MESSAGE("channel_5_analyzer_2_array_crystal_array_5 (Init:Place/Rotate)");
  rot_set_rotation(mctr1,
#line 1720 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 1720 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 1720 "MACS_sample_kidney_box.instr"
    (0 - RAD2DEG * channel_5_analyzer_2_array_theta [ 5 ])*DEG2RAD);
#line 111263 "MACS_sample_kidney_box.c"
  rot_mul(mctr1, mcrotachannel_5_analyzer_2_rotated, mcrotachannel_5_analyzer_2_array_crystal_array_5);
  rot_transpose(mcrotachannel_5_analyzer_2_array_crystal_array_4, mctr1);
  rot_mul(mcrotachannel_5_analyzer_2_array_crystal_array_5, mctr1, mcrotrchannel_5_analyzer_2_array_crystal_array_5);
  mctc1 = coords_set(
#line 1719 "MACS_sample_kidney_box.instr"
    0 + channel_5_analyzer_2_array_effective_radius_of_curvature * ( 1 - cos ( channel_5_analyzer_2_array_theta [ 5 ] ) ),
#line 1719 "MACS_sample_kidney_box.instr"
    0 + channel_5_analyzer_2_array_effective_radius_of_curvature * sin ( channel_5_analyzer_2_array_theta [ 5 ] ),
#line 1719 "MACS_sample_kidney_box.instr"
    0);
#line 111274 "MACS_sample_kidney_box.c"
  rot_transpose(mcrotachannel_5_analyzer_2_rotated, mctr1);
  mctc2 = rot_apply(mctr1, mctc1);
  mcposachannel_5_analyzer_2_array_crystal_array_5 = coords_add(mcposachannel_5_analyzer_2_rotated, mctc2);
  mctc1 = coords_sub(mcposachannel_5_analyzer_2_array_crystal_array_4, mcposachannel_5_analyzer_2_array_crystal_array_5);
  mcposrchannel_5_analyzer_2_array_crystal_array_5 = rot_apply(mcrotachannel_5_analyzer_2_array_crystal_array_5, mctc1);
  mcDEBUG_COMPONENT("channel_5_analyzer_2_array_crystal_array_5", mcposachannel_5_analyzer_2_array_crystal_array_5, mcrotachannel_5_analyzer_2_array_crystal_array_5)
  mccomp_posa[336] = mcposachannel_5_analyzer_2_array_crystal_array_5;
  mccomp_posr[336] = mcposrchannel_5_analyzer_2_array_crystal_array_5;
  mcNCounter[336]  = mcPCounter[336] = mcP2Counter[336] = 0;
  mcAbsorbProp[336]= 0;
    /* Component channel_5_analyzer_2_array_crystal_array_6. */
  /* Setting parameters for component channel_5_analyzer_2_array_crystal_array_6. */
  SIG_MESSAGE("channel_5_analyzer_2_array_crystal_array_6 (Init:SetPar)");
#line 1724 "MACS_sample_kidney_box.instr"
  if("PG_analyzer") strncpy(mccchannel_5_analyzer_2_array_crystal_array_6_material_string, "PG_analyzer" ? "PG_analyzer" : "", 16384); else mccchannel_5_analyzer_2_array_crystal_array_6_material_string[0]='\0';
#line 1724 "MACS_sample_kidney_box.instr"
  mccchannel_5_analyzer_2_array_crystal_array_6_priority = 721.6;
#line 1723 "MACS_sample_kidney_box.instr"
  mccchannel_5_analyzer_2_array_crystal_array_6_xwidth = channel_5_analyzer_2_array_crystal_depth;
#line 1723 "MACS_sample_kidney_box.instr"
  mccchannel_5_analyzer_2_array_crystal_array_6_yheight = channel_5_analyzer_2_array_crystal_height;
#line 1723 "MACS_sample_kidney_box.instr"
  mccchannel_5_analyzer_2_array_crystal_array_6_zdepth = channel_5_analyzer_2_array_crystal_width;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_5_analyzer_2_array_crystal_array_6_xwidth2 = -1;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_5_analyzer_2_array_crystal_array_6_yheight2 = -1;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_5_analyzer_2_array_crystal_array_6_visualize = 1;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_5_analyzer_2_array_crystal_array_6_target_index = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_5_analyzer_2_array_crystal_array_6_target_x = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_5_analyzer_2_array_crystal_array_6_target_y = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_5_analyzer_2_array_crystal_array_6_target_z = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_5_analyzer_2_array_crystal_array_6_focus_aw = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_5_analyzer_2_array_crystal_array_6_focus_ah = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_5_analyzer_2_array_crystal_array_6_focus_xw = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_5_analyzer_2_array_crystal_array_6_focus_xh = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_5_analyzer_2_array_crystal_array_6_focus_r = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_5_analyzer_2_array_crystal_array_6_p_interact = 0;
#line 71 "MACS_sample_kidney_box.instr"
  if(0) strncpy(mccchannel_5_analyzer_2_array_crystal_array_6_mask_string, 0 ? 0 : "", 16384); else mccchannel_5_analyzer_2_array_crystal_array_6_mask_string[0]='\0';
#line 71 "MACS_sample_kidney_box.instr"
  if(0) strncpy(mccchannel_5_analyzer_2_array_crystal_array_6_mask_setting, 0 ? 0 : "", 16384); else mccchannel_5_analyzer_2_array_crystal_array_6_mask_setting[0]='\0';
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_5_analyzer_2_array_crystal_array_6_number_of_activations = 1;
#line 111330 "MACS_sample_kidney_box.c"

  SIG_MESSAGE("channel_5_analyzer_2_array_crystal_array_6 (Init:Place/Rotate)");
  rot_set_rotation(mctr1,
#line 1726 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 1726 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 1726 "MACS_sample_kidney_box.instr"
    (0 - RAD2DEG * channel_5_analyzer_2_array_theta [ 6 ])*DEG2RAD);
#line 111340 "MACS_sample_kidney_box.c"
  rot_mul(mctr1, mcrotachannel_5_analyzer_2_rotated, mcrotachannel_5_analyzer_2_array_crystal_array_6);
  rot_transpose(mcrotachannel_5_analyzer_2_array_crystal_array_5, mctr1);
  rot_mul(mcrotachannel_5_analyzer_2_array_crystal_array_6, mctr1, mcrotrchannel_5_analyzer_2_array_crystal_array_6);
  mctc1 = coords_set(
#line 1725 "MACS_sample_kidney_box.instr"
    0 + channel_5_analyzer_2_array_effective_radius_of_curvature * ( 1 - cos ( channel_5_analyzer_2_array_theta [ 6 ] ) ),
#line 1725 "MACS_sample_kidney_box.instr"
    0 + channel_5_analyzer_2_array_effective_radius_of_curvature * sin ( channel_5_analyzer_2_array_theta [ 6 ] ),
#line 1725 "MACS_sample_kidney_box.instr"
    0);
#line 111351 "MACS_sample_kidney_box.c"
  rot_transpose(mcrotachannel_5_analyzer_2_rotated, mctr1);
  mctc2 = rot_apply(mctr1, mctc1);
  mcposachannel_5_analyzer_2_array_crystal_array_6 = coords_add(mcposachannel_5_analyzer_2_rotated, mctc2);
  mctc1 = coords_sub(mcposachannel_5_analyzer_2_array_crystal_array_5, mcposachannel_5_analyzer_2_array_crystal_array_6);
  mcposrchannel_5_analyzer_2_array_crystal_array_6 = rot_apply(mcrotachannel_5_analyzer_2_array_crystal_array_6, mctc1);
  mcDEBUG_COMPONENT("channel_5_analyzer_2_array_crystal_array_6", mcposachannel_5_analyzer_2_array_crystal_array_6, mcrotachannel_5_analyzer_2_array_crystal_array_6)
  mccomp_posa[337] = mcposachannel_5_analyzer_2_array_crystal_array_6;
  mccomp_posr[337] = mcposrchannel_5_analyzer_2_array_crystal_array_6;
  mcNCounter[337]  = mcPCounter[337] = mcP2Counter[337] = 0;
  mcAbsorbProp[337]= 0;
    /* Component channel_5_analyzer_2_array_crystal_array_7. */
  /* Setting parameters for component channel_5_analyzer_2_array_crystal_array_7. */
  SIG_MESSAGE("channel_5_analyzer_2_array_crystal_array_7 (Init:SetPar)");
#line 1730 "MACS_sample_kidney_box.instr"
  if("PG_analyzer") strncpy(mccchannel_5_analyzer_2_array_crystal_array_7_material_string, "PG_analyzer" ? "PG_analyzer" : "", 16384); else mccchannel_5_analyzer_2_array_crystal_array_7_material_string[0]='\0';
#line 1730 "MACS_sample_kidney_box.instr"
  mccchannel_5_analyzer_2_array_crystal_array_7_priority = 721.7;
#line 1729 "MACS_sample_kidney_box.instr"
  mccchannel_5_analyzer_2_array_crystal_array_7_xwidth = channel_5_analyzer_2_array_crystal_depth;
#line 1729 "MACS_sample_kidney_box.instr"
  mccchannel_5_analyzer_2_array_crystal_array_7_yheight = channel_5_analyzer_2_array_crystal_height;
#line 1729 "MACS_sample_kidney_box.instr"
  mccchannel_5_analyzer_2_array_crystal_array_7_zdepth = channel_5_analyzer_2_array_crystal_width;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_5_analyzer_2_array_crystal_array_7_xwidth2 = -1;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_5_analyzer_2_array_crystal_array_7_yheight2 = -1;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_5_analyzer_2_array_crystal_array_7_visualize = 1;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_5_analyzer_2_array_crystal_array_7_target_index = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_5_analyzer_2_array_crystal_array_7_target_x = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_5_analyzer_2_array_crystal_array_7_target_y = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_5_analyzer_2_array_crystal_array_7_target_z = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_5_analyzer_2_array_crystal_array_7_focus_aw = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_5_analyzer_2_array_crystal_array_7_focus_ah = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_5_analyzer_2_array_crystal_array_7_focus_xw = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_5_analyzer_2_array_crystal_array_7_focus_xh = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_5_analyzer_2_array_crystal_array_7_focus_r = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_5_analyzer_2_array_crystal_array_7_p_interact = 0;
#line 71 "MACS_sample_kidney_box.instr"
  if(0) strncpy(mccchannel_5_analyzer_2_array_crystal_array_7_mask_string, 0 ? 0 : "", 16384); else mccchannel_5_analyzer_2_array_crystal_array_7_mask_string[0]='\0';
#line 71 "MACS_sample_kidney_box.instr"
  if(0) strncpy(mccchannel_5_analyzer_2_array_crystal_array_7_mask_setting, 0 ? 0 : "", 16384); else mccchannel_5_analyzer_2_array_crystal_array_7_mask_setting[0]='\0';
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_5_analyzer_2_array_crystal_array_7_number_of_activations = 1;
#line 111407 "MACS_sample_kidney_box.c"

  SIG_MESSAGE("channel_5_analyzer_2_array_crystal_array_7 (Init:Place/Rotate)");
  rot_set_rotation(mctr1,
#line 1732 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 1732 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 1732 "MACS_sample_kidney_box.instr"
    (0 - RAD2DEG * channel_5_analyzer_2_array_theta [ 7 ])*DEG2RAD);
#line 111417 "MACS_sample_kidney_box.c"
  rot_mul(mctr1, mcrotachannel_5_analyzer_2_rotated, mcrotachannel_5_analyzer_2_array_crystal_array_7);
  rot_transpose(mcrotachannel_5_analyzer_2_array_crystal_array_6, mctr1);
  rot_mul(mcrotachannel_5_analyzer_2_array_crystal_array_7, mctr1, mcrotrchannel_5_analyzer_2_array_crystal_array_7);
  mctc1 = coords_set(
#line 1731 "MACS_sample_kidney_box.instr"
    0 + channel_5_analyzer_2_array_effective_radius_of_curvature * ( 1 - cos ( channel_5_analyzer_2_array_theta [ 7 ] ) ),
#line 1731 "MACS_sample_kidney_box.instr"
    0 + channel_5_analyzer_2_array_effective_radius_of_curvature * sin ( channel_5_analyzer_2_array_theta [ 7 ] ),
#line 1731 "MACS_sample_kidney_box.instr"
    0);
#line 111428 "MACS_sample_kidney_box.c"
  rot_transpose(mcrotachannel_5_analyzer_2_rotated, mctr1);
  mctc2 = rot_apply(mctr1, mctc1);
  mcposachannel_5_analyzer_2_array_crystal_array_7 = coords_add(mcposachannel_5_analyzer_2_rotated, mctc2);
  mctc1 = coords_sub(mcposachannel_5_analyzer_2_array_crystal_array_6, mcposachannel_5_analyzer_2_array_crystal_array_7);
  mcposrchannel_5_analyzer_2_array_crystal_array_7 = rot_apply(mcrotachannel_5_analyzer_2_array_crystal_array_7, mctc1);
  mcDEBUG_COMPONENT("channel_5_analyzer_2_array_crystal_array_7", mcposachannel_5_analyzer_2_array_crystal_array_7, mcrotachannel_5_analyzer_2_array_crystal_array_7)
  mccomp_posa[338] = mcposachannel_5_analyzer_2_array_crystal_array_7;
  mccomp_posr[338] = mcposrchannel_5_analyzer_2_array_crystal_array_7;
  mcNCounter[338]  = mcPCounter[338] = mcP2Counter[338] = 0;
  mcAbsorbProp[338]= 0;
    /* Component channel_5_analyzer_2_array_crystal_array_8. */
  /* Setting parameters for component channel_5_analyzer_2_array_crystal_array_8. */
  SIG_MESSAGE("channel_5_analyzer_2_array_crystal_array_8 (Init:SetPar)");
#line 1736 "MACS_sample_kidney_box.instr"
  if("PG_analyzer") strncpy(mccchannel_5_analyzer_2_array_crystal_array_8_material_string, "PG_analyzer" ? "PG_analyzer" : "", 16384); else mccchannel_5_analyzer_2_array_crystal_array_8_material_string[0]='\0';
#line 1736 "MACS_sample_kidney_box.instr"
  mccchannel_5_analyzer_2_array_crystal_array_8_priority = 721.8;
#line 1735 "MACS_sample_kidney_box.instr"
  mccchannel_5_analyzer_2_array_crystal_array_8_xwidth = channel_5_analyzer_2_array_crystal_depth;
#line 1735 "MACS_sample_kidney_box.instr"
  mccchannel_5_analyzer_2_array_crystal_array_8_yheight = channel_5_analyzer_2_array_crystal_height;
#line 1735 "MACS_sample_kidney_box.instr"
  mccchannel_5_analyzer_2_array_crystal_array_8_zdepth = channel_5_analyzer_2_array_crystal_width;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_5_analyzer_2_array_crystal_array_8_xwidth2 = -1;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_5_analyzer_2_array_crystal_array_8_yheight2 = -1;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_5_analyzer_2_array_crystal_array_8_visualize = 1;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_5_analyzer_2_array_crystal_array_8_target_index = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_5_analyzer_2_array_crystal_array_8_target_x = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_5_analyzer_2_array_crystal_array_8_target_y = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_5_analyzer_2_array_crystal_array_8_target_z = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_5_analyzer_2_array_crystal_array_8_focus_aw = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_5_analyzer_2_array_crystal_array_8_focus_ah = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_5_analyzer_2_array_crystal_array_8_focus_xw = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_5_analyzer_2_array_crystal_array_8_focus_xh = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_5_analyzer_2_array_crystal_array_8_focus_r = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_5_analyzer_2_array_crystal_array_8_p_interact = 0;
#line 71 "MACS_sample_kidney_box.instr"
  if(0) strncpy(mccchannel_5_analyzer_2_array_crystal_array_8_mask_string, 0 ? 0 : "", 16384); else mccchannel_5_analyzer_2_array_crystal_array_8_mask_string[0]='\0';
#line 71 "MACS_sample_kidney_box.instr"
  if(0) strncpy(mccchannel_5_analyzer_2_array_crystal_array_8_mask_setting, 0 ? 0 : "", 16384); else mccchannel_5_analyzer_2_array_crystal_array_8_mask_setting[0]='\0';
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_5_analyzer_2_array_crystal_array_8_number_of_activations = 1;
#line 111484 "MACS_sample_kidney_box.c"

  SIG_MESSAGE("channel_5_analyzer_2_array_crystal_array_8 (Init:Place/Rotate)");
  rot_set_rotation(mctr1,
#line 1738 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 1738 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 1738 "MACS_sample_kidney_box.instr"
    (0 - RAD2DEG * channel_5_analyzer_2_array_theta [ 8 ])*DEG2RAD);
#line 111494 "MACS_sample_kidney_box.c"
  rot_mul(mctr1, mcrotachannel_5_analyzer_2_rotated, mcrotachannel_5_analyzer_2_array_crystal_array_8);
  rot_transpose(mcrotachannel_5_analyzer_2_array_crystal_array_7, mctr1);
  rot_mul(mcrotachannel_5_analyzer_2_array_crystal_array_8, mctr1, mcrotrchannel_5_analyzer_2_array_crystal_array_8);
  mctc1 = coords_set(
#line 1737 "MACS_sample_kidney_box.instr"
    0 + channel_5_analyzer_2_array_effective_radius_of_curvature * ( 1 - cos ( channel_5_analyzer_2_array_theta [ 8 ] ) ),
#line 1737 "MACS_sample_kidney_box.instr"
    0 + channel_5_analyzer_2_array_effective_radius_of_curvature * sin ( channel_5_analyzer_2_array_theta [ 8 ] ),
#line 1737 "MACS_sample_kidney_box.instr"
    0);
#line 111505 "MACS_sample_kidney_box.c"
  rot_transpose(mcrotachannel_5_analyzer_2_rotated, mctr1);
  mctc2 = rot_apply(mctr1, mctc1);
  mcposachannel_5_analyzer_2_array_crystal_array_8 = coords_add(mcposachannel_5_analyzer_2_rotated, mctc2);
  mctc1 = coords_sub(mcposachannel_5_analyzer_2_array_crystal_array_7, mcposachannel_5_analyzer_2_array_crystal_array_8);
  mcposrchannel_5_analyzer_2_array_crystal_array_8 = rot_apply(mcrotachannel_5_analyzer_2_array_crystal_array_8, mctc1);
  mcDEBUG_COMPONENT("channel_5_analyzer_2_array_crystal_array_8", mcposachannel_5_analyzer_2_array_crystal_array_8, mcrotachannel_5_analyzer_2_array_crystal_array_8)
  mccomp_posa[339] = mcposachannel_5_analyzer_2_array_crystal_array_8;
  mccomp_posr[339] = mcposrchannel_5_analyzer_2_array_crystal_array_8;
  mcNCounter[339]  = mcPCounter[339] = mcP2Counter[339] = 0;
  mcAbsorbProp[339]= 0;
    /* Component channel_5_cave2_cyl1. */
  /* Setting parameters for component channel_5_cave2_cyl1. */
  SIG_MESSAGE("channel_5_cave2_cyl1 (Init:SetPar)");
#line 1743 "MACS_sample_kidney_box.instr"
  if("Vacuum") strncpy(mccchannel_5_cave2_cyl1_material_string, "Vacuum" ? "Vacuum" : "", 16384); else mccchannel_5_cave2_cyl1_material_string[0]='\0';
#line 1743 "MACS_sample_kidney_box.instr"
  mccchannel_5_cave2_cyl1_priority = 707.5;
#line 1742 "MACS_sample_kidney_box.instr"
  mccchannel_5_cave2_cyl1_radius = kidney_cave2_cyl1_radius;
#line 1742 "MACS_sample_kidney_box.instr"
  mccchannel_5_cave2_cyl1_yheight = kidney_cave2_cyl1_height;
#line 67 "MACS_sample_kidney_box.instr"
  mccchannel_5_cave2_cyl1_visualize = 1;
#line 67 "MACS_sample_kidney_box.instr"
  mccchannel_5_cave2_cyl1_target_index = 0;
#line 67 "MACS_sample_kidney_box.instr"
  mccchannel_5_cave2_cyl1_target_x = 0;
#line 67 "MACS_sample_kidney_box.instr"
  mccchannel_5_cave2_cyl1_target_y = 0;
#line 67 "MACS_sample_kidney_box.instr"
  mccchannel_5_cave2_cyl1_target_z = 0;
#line 67 "MACS_sample_kidney_box.instr"
  mccchannel_5_cave2_cyl1_focus_aw = 0;
#line 67 "MACS_sample_kidney_box.instr"
  mccchannel_5_cave2_cyl1_focus_ah = 0;
#line 67 "MACS_sample_kidney_box.instr"
  mccchannel_5_cave2_cyl1_focus_xw = 0;
#line 67 "MACS_sample_kidney_box.instr"
  mccchannel_5_cave2_cyl1_focus_xh = 0;
#line 67 "MACS_sample_kidney_box.instr"
  mccchannel_5_cave2_cyl1_focus_r = 0;
#line 67 "MACS_sample_kidney_box.instr"
  mccchannel_5_cave2_cyl1_p_interact = 0;
#line 67 "MACS_sample_kidney_box.instr"
  if(0) strncpy(mccchannel_5_cave2_cyl1_mask_string, 0 ? 0 : "", 16384); else mccchannel_5_cave2_cyl1_mask_string[0]='\0';
#line 67 "MACS_sample_kidney_box.instr"
  if(0) strncpy(mccchannel_5_cave2_cyl1_mask_setting, 0 ? 0 : "", 16384); else mccchannel_5_cave2_cyl1_mask_setting[0]='\0';
#line 67 "MACS_sample_kidney_box.instr"
  mccchannel_5_cave2_cyl1_number_of_activations = 1;
#line 111555 "MACS_sample_kidney_box.c"

  SIG_MESSAGE("channel_5_cave2_cyl1 (Init:Place/Rotate)");
  rot_set_rotation(mctr1,
#line 1745 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 1745 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 1745 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD);
#line 111565 "MACS_sample_kidney_box.c"
  rot_mul(mctr1, mcrotachannel_5_analyzer_2_center, mcrotachannel_5_cave2_cyl1);
  rot_transpose(mcrotachannel_5_analyzer_2_array_crystal_array_8, mctr1);
  rot_mul(mcrotachannel_5_cave2_cyl1, mctr1, mcrotrchannel_5_cave2_cyl1);
  mctc1 = coords_set(
#line 1744 "MACS_sample_kidney_box.instr"
    0,
#line 1744 "MACS_sample_kidney_box.instr"
    0,
#line 1744 "MACS_sample_kidney_box.instr"
    spec_detector_to_analyzer_2_center);
#line 111576 "MACS_sample_kidney_box.c"
  rot_transpose(mcrotachannel_5_analyzer_2_center, mctr1);
  mctc2 = rot_apply(mctr1, mctc1);
  mcposachannel_5_cave2_cyl1 = coords_add(mcposachannel_5_analyzer_2_center, mctc2);
  mctc1 = coords_sub(mcposachannel_5_analyzer_2_array_crystal_array_8, mcposachannel_5_cave2_cyl1);
  mcposrchannel_5_cave2_cyl1 = rot_apply(mcrotachannel_5_cave2_cyl1, mctc1);
  mcDEBUG_COMPONENT("channel_5_cave2_cyl1", mcposachannel_5_cave2_cyl1, mcrotachannel_5_cave2_cyl1)
  mccomp_posa[340] = mcposachannel_5_cave2_cyl1;
  mccomp_posr[340] = mcposrchannel_5_cave2_cyl1;
  mcNCounter[340]  = mcPCounter[340] = mcP2Counter[340] = 0;
  mcAbsorbProp[340]= 0;
    /* Component channel_5_cave2_box1. */
  /* Setting parameters for component channel_5_cave2_box1. */
  SIG_MESSAGE("channel_5_cave2_box1 (Init:SetPar)");
#line 1750 "MACS_sample_kidney_box.instr"
  if("Vacuum") strncpy(mccchannel_5_cave2_box1_material_string, "Vacuum" ? "Vacuum" : "", 16384); else mccchannel_5_cave2_box1_material_string[0]='\0';
#line 1750 "MACS_sample_kidney_box.instr"
  mccchannel_5_cave2_box1_priority = 701;
#line 1748 "MACS_sample_kidney_box.instr"
  mccchannel_5_cave2_box1_xwidth = kidney_cave2_box1_width1;
#line 1748 "MACS_sample_kidney_box.instr"
  mccchannel_5_cave2_box1_yheight = kidney_cave2_box1_height1;
#line 1748 "MACS_sample_kidney_box.instr"
  mccchannel_5_cave2_box1_zdepth = kidney_cave2_box1_depth;
#line 1749 "MACS_sample_kidney_box.instr"
  mccchannel_5_cave2_box1_xwidth2 = kidney_cave2_box1_width2;
#line 1749 "MACS_sample_kidney_box.instr"
  mccchannel_5_cave2_box1_yheight2 = kidney_cave2_box1_height2;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_5_cave2_box1_visualize = 1;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_5_cave2_box1_target_index = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_5_cave2_box1_target_x = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_5_cave2_box1_target_y = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_5_cave2_box1_target_z = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_5_cave2_box1_focus_aw = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_5_cave2_box1_focus_ah = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_5_cave2_box1_focus_xw = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_5_cave2_box1_focus_xh = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_5_cave2_box1_focus_r = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_5_cave2_box1_p_interact = 0;
#line 71 "MACS_sample_kidney_box.instr"
  if(0) strncpy(mccchannel_5_cave2_box1_mask_string, 0 ? 0 : "", 16384); else mccchannel_5_cave2_box1_mask_string[0]='\0';
#line 71 "MACS_sample_kidney_box.instr"
  if(0) strncpy(mccchannel_5_cave2_box1_mask_setting, 0 ? 0 : "", 16384); else mccchannel_5_cave2_box1_mask_setting[0]='\0';
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_5_cave2_box1_number_of_activations = 1;
#line 111632 "MACS_sample_kidney_box.c"

  SIG_MESSAGE("channel_5_cave2_box1 (Init:Place/Rotate)");
  rot_set_rotation(mctr1,
#line 1752 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 1752 "MACS_sample_kidney_box.instr"
    (kidney_cave2_box1_y_rotation)*DEG2RAD,
#line 1752 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD);
#line 111642 "MACS_sample_kidney_box.c"
  rot_mul(mctr1, mcrotachannel_5_cave2_cyl1, mcrotachannel_5_cave2_box1);
  rot_transpose(mcrotachannel_5_cave2_cyl1, mctr1);
  rot_mul(mcrotachannel_5_cave2_box1, mctr1, mcrotrchannel_5_cave2_box1);
  mctc1 = coords_set(
#line 1751 "MACS_sample_kidney_box.instr"
    kidney_cave2_box1_center_to_spec_detector_x,
#line 1751 "MACS_sample_kidney_box.instr"
    0,
#line 1751 "MACS_sample_kidney_box.instr"
    kidney_cave2_box1_center_to_spec_detector_z);
#line 111653 "MACS_sample_kidney_box.c"
  rot_transpose(mcrotachannel_5_cave2_cyl1, mctr1);
  mctc2 = rot_apply(mctr1, mctc1);
  mcposachannel_5_cave2_box1 = coords_add(mcposachannel_5_cave2_cyl1, mctc2);
  mctc1 = coords_sub(mcposachannel_5_cave2_cyl1, mcposachannel_5_cave2_box1);
  mcposrchannel_5_cave2_box1 = rot_apply(mcrotachannel_5_cave2_box1, mctc1);
  mcDEBUG_COMPONENT("channel_5_cave2_box1", mcposachannel_5_cave2_box1, mcrotachannel_5_cave2_box1)
  mccomp_posa[341] = mcposachannel_5_cave2_box1;
  mccomp_posr[341] = mcposrchannel_5_cave2_box1;
  mcNCounter[341]  = mcPCounter[341] = mcP2Counter[341] = 0;
  mcAbsorbProp[341]= 0;
    /* Component channel_5_cave2_box2. */
  /* Setting parameters for component channel_5_cave2_box2. */
  SIG_MESSAGE("channel_5_cave2_box2 (Init:SetPar)");
#line 1757 "MACS_sample_kidney_box.instr"
  if("Vacuum") strncpy(mccchannel_5_cave2_box2_material_string, "Vacuum" ? "Vacuum" : "", 16384); else mccchannel_5_cave2_box2_material_string[0]='\0';
#line 1757 "MACS_sample_kidney_box.instr"
  mccchannel_5_cave2_box2_priority = 706;
#line 1755 "MACS_sample_kidney_box.instr"
  mccchannel_5_cave2_box2_xwidth = kidney_cave2_box2_width1;
#line 1755 "MACS_sample_kidney_box.instr"
  mccchannel_5_cave2_box2_yheight = kidney_cave2_box2_height1;
#line 1755 "MACS_sample_kidney_box.instr"
  mccchannel_5_cave2_box2_zdepth = kidney_cave2_box2_depth;
#line 1756 "MACS_sample_kidney_box.instr"
  mccchannel_5_cave2_box2_xwidth2 = kidney_cave2_box2_width2;
#line 1756 "MACS_sample_kidney_box.instr"
  mccchannel_5_cave2_box2_yheight2 = kidney_cave2_box2_height2;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_5_cave2_box2_visualize = 1;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_5_cave2_box2_target_index = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_5_cave2_box2_target_x = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_5_cave2_box2_target_y = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_5_cave2_box2_target_z = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_5_cave2_box2_focus_aw = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_5_cave2_box2_focus_ah = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_5_cave2_box2_focus_xw = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_5_cave2_box2_focus_xh = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_5_cave2_box2_focus_r = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_5_cave2_box2_p_interact = 0;
#line 71 "MACS_sample_kidney_box.instr"
  if(0) strncpy(mccchannel_5_cave2_box2_mask_string, 0 ? 0 : "", 16384); else mccchannel_5_cave2_box2_mask_string[0]='\0';
#line 71 "MACS_sample_kidney_box.instr"
  if(0) strncpy(mccchannel_5_cave2_box2_mask_setting, 0 ? 0 : "", 16384); else mccchannel_5_cave2_box2_mask_setting[0]='\0';
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_5_cave2_box2_number_of_activations = 1;
#line 111709 "MACS_sample_kidney_box.c"

  SIG_MESSAGE("channel_5_cave2_box2 (Init:Place/Rotate)");
  rot_set_rotation(mctr1,
#line 1759 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 1759 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 1759 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD);
#line 111719 "MACS_sample_kidney_box.c"
  rot_mul(mctr1, mcrotachannel_5_cave2_cyl1, mcrotachannel_5_cave2_box2);
  rot_transpose(mcrotachannel_5_cave2_box1, mctr1);
  rot_mul(mcrotachannel_5_cave2_box2, mctr1, mcrotrchannel_5_cave2_box2);
  mctc1 = coords_set(
#line 1758 "MACS_sample_kidney_box.instr"
    0,
#line 1758 "MACS_sample_kidney_box.instr"
    0,
#line 1758 "MACS_sample_kidney_box.instr"
    kidney_cave2_box2_center_to_detector);
#line 111730 "MACS_sample_kidney_box.c"
  rot_transpose(mcrotachannel_5_cave2_cyl1, mctr1);
  mctc2 = rot_apply(mctr1, mctc1);
  mcposachannel_5_cave2_box2 = coords_add(mcposachannel_5_cave2_cyl1, mctc2);
  mctc1 = coords_sub(mcposachannel_5_cave2_box1, mcposachannel_5_cave2_box2);
  mcposrchannel_5_cave2_box2 = rot_apply(mcrotachannel_5_cave2_box2, mctc1);
  mcDEBUG_COMPONENT("channel_5_cave2_box2", mcposachannel_5_cave2_box2, mcrotachannel_5_cave2_box2)
  mccomp_posa[342] = mcposachannel_5_cave2_box2;
  mccomp_posr[342] = mcposrchannel_5_cave2_box2;
  mcNCounter[342]  = mcPCounter[342] = mcP2Counter[342] = 0;
  mcAbsorbProp[342]= 0;
    /* Component channel_5_cave2_box3. */
  /* Setting parameters for component channel_5_cave2_box3. */
  SIG_MESSAGE("channel_5_cave2_box3 (Init:SetPar)");
#line 1764 "MACS_sample_kidney_box.instr"
  if("Vacuum") strncpy(mccchannel_5_cave2_box3_material_string, "Vacuum" ? "Vacuum" : "", 16384); else mccchannel_5_cave2_box3_material_string[0]='\0';
#line 1764 "MACS_sample_kidney_box.instr"
  mccchannel_5_cave2_box3_priority = 707;
#line 1762 "MACS_sample_kidney_box.instr"
  mccchannel_5_cave2_box3_xwidth = kidney_cave2_box3_width1;
#line 1762 "MACS_sample_kidney_box.instr"
  mccchannel_5_cave2_box3_yheight = kidney_cave2_box3_height1;
#line 1762 "MACS_sample_kidney_box.instr"
  mccchannel_5_cave2_box3_zdepth = kidney_cave2_box3_depth;
#line 1763 "MACS_sample_kidney_box.instr"
  mccchannel_5_cave2_box3_xwidth2 = kidney_cave2_box3_width2;
#line 1763 "MACS_sample_kidney_box.instr"
  mccchannel_5_cave2_box3_yheight2 = kidney_cave2_box3_height2;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_5_cave2_box3_visualize = 1;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_5_cave2_box3_target_index = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_5_cave2_box3_target_x = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_5_cave2_box3_target_y = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_5_cave2_box3_target_z = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_5_cave2_box3_focus_aw = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_5_cave2_box3_focus_ah = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_5_cave2_box3_focus_xw = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_5_cave2_box3_focus_xh = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_5_cave2_box3_focus_r = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_5_cave2_box3_p_interact = 0;
#line 71 "MACS_sample_kidney_box.instr"
  if(0) strncpy(mccchannel_5_cave2_box3_mask_string, 0 ? 0 : "", 16384); else mccchannel_5_cave2_box3_mask_string[0]='\0';
#line 71 "MACS_sample_kidney_box.instr"
  if(0) strncpy(mccchannel_5_cave2_box3_mask_setting, 0 ? 0 : "", 16384); else mccchannel_5_cave2_box3_mask_setting[0]='\0';
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_5_cave2_box3_number_of_activations = 1;
#line 111786 "MACS_sample_kidney_box.c"

  SIG_MESSAGE("channel_5_cave2_box3 (Init:Place/Rotate)");
  rot_set_rotation(mctr1,
#line 1766 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 1766 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 1766 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD);
#line 111796 "MACS_sample_kidney_box.c"
  rot_mul(mctr1, mcrotachannel_5_cave2_cyl1, mcrotachannel_5_cave2_box3);
  rot_transpose(mcrotachannel_5_cave2_box2, mctr1);
  rot_mul(mcrotachannel_5_cave2_box3, mctr1, mcrotrchannel_5_cave2_box3);
  mctc1 = coords_set(
#line 1765 "MACS_sample_kidney_box.instr"
    0,
#line 1765 "MACS_sample_kidney_box.instr"
    0,
#line 1765 "MACS_sample_kidney_box.instr"
    kidney_cave2_box3_center_to_detector);
#line 111807 "MACS_sample_kidney_box.c"
  rot_transpose(mcrotachannel_5_cave2_cyl1, mctr1);
  mctc2 = rot_apply(mctr1, mctc1);
  mcposachannel_5_cave2_box3 = coords_add(mcposachannel_5_cave2_cyl1, mctc2);
  mctc1 = coords_sub(mcposachannel_5_cave2_box2, mcposachannel_5_cave2_box3);
  mcposrchannel_5_cave2_box3 = rot_apply(mcrotachannel_5_cave2_box3, mctc1);
  mcDEBUG_COMPONENT("channel_5_cave2_box3", mcposachannel_5_cave2_box3, mcrotachannel_5_cave2_box3)
  mccomp_posa[343] = mcposachannel_5_cave2_box3;
  mccomp_posr[343] = mcposrchannel_5_cave2_box3;
  mcNCounter[343]  = mcPCounter[343] = mcP2Counter[343] = 0;
  mcAbsorbProp[343]= 0;
    /* Component inter_analyzer_colimator_center_5. */
  /* Setting parameters for component inter_analyzer_colimator_center_5. */
  SIG_MESSAGE("inter_analyzer_colimator_center_5 (Init:SetPar)");

  SIG_MESSAGE("inter_analyzer_colimator_center_5 (Init:Place/Rotate)");
  rot_set_rotation(mctr1,
#line 1770 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 1770 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 1770 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD);
#line 111830 "MACS_sample_kidney_box.c"
  rot_mul(mctr1, mcrotachannel_5_analyzer_1_center, mcrotainter_analyzer_colimator_center_5);
  rot_transpose(mcrotachannel_5_cave2_box3, mctr1);
  rot_mul(mcrotainter_analyzer_colimator_center_5, mctr1, mcrotrinter_analyzer_colimator_center_5);
  mctc1 = coords_set(
#line 1769 "MACS_sample_kidney_box.instr"
    -0.5 * analyzer_seperation,
#line 1769 "MACS_sample_kidney_box.instr"
    0,
#line 1769 "MACS_sample_kidney_box.instr"
    0);
#line 111841 "MACS_sample_kidney_box.c"
  rot_transpose(mcrotachannel_5_analyzer_1_center, mctr1);
  mctc2 = rot_apply(mctr1, mctc1);
  mcposainter_analyzer_colimator_center_5 = coords_add(mcposachannel_5_analyzer_1_center, mctc2);
  mctc1 = coords_sub(mcposachannel_5_cave2_box3, mcposainter_analyzer_colimator_center_5);
  mcposrinter_analyzer_colimator_center_5 = rot_apply(mcrotainter_analyzer_colimator_center_5, mctc1);
  mcDEBUG_COMPONENT("inter_analyzer_colimator_center_5", mcposainter_analyzer_colimator_center_5, mcrotainter_analyzer_colimator_center_5)
  mccomp_posa[344] = mcposainter_analyzer_colimator_center_5;
  mccomp_posr[344] = mcposrinter_analyzer_colimator_center_5;
  mcNCounter[344]  = mcPCounter[344] = mcP2Counter[344] = 0;
  mcAbsorbProp[344]= 0;
    /* Component inter_analyzer_colimator_5_blade_0. */
  /* Setting parameters for component inter_analyzer_colimator_5_blade_0. */
  SIG_MESSAGE("inter_analyzer_colimator_5_blade_0 (Init:SetPar)");
#line 1774 "MACS_sample_kidney_box.instr"
  if("Collimator_gad") strncpy(mccinter_analyzer_colimator_5_blade_0_material_string, "Collimator_gad" ? "Collimator_gad" : "", 16384); else mccinter_analyzer_colimator_5_blade_0_material_string[0]='\0';
#line 1774 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_5_blade_0_priority = 725;
#line 1773 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_5_blade_0_xwidth = inter_analyzer_colimator_width;
#line 1773 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_5_blade_0_yheight = inter_analyzer_colimator_height;
#line 1773 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_5_blade_0_zdepth = inter_analyzer_colimator_depth;
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_5_blade_0_xwidth2 = -1;
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_5_blade_0_yheight2 = -1;
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_5_blade_0_visualize = 1;
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_5_blade_0_target_index = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_5_blade_0_target_x = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_5_blade_0_target_y = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_5_blade_0_target_z = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_5_blade_0_focus_aw = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_5_blade_0_focus_ah = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_5_blade_0_focus_xw = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_5_blade_0_focus_xh = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_5_blade_0_focus_r = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_5_blade_0_p_interact = 0;
#line 71 "MACS_sample_kidney_box.instr"
  if(0) strncpy(mccinter_analyzer_colimator_5_blade_0_mask_string, 0 ? 0 : "", 16384); else mccinter_analyzer_colimator_5_blade_0_mask_string[0]='\0';
#line 71 "MACS_sample_kidney_box.instr"
  if(0) strncpy(mccinter_analyzer_colimator_5_blade_0_mask_setting, 0 ? 0 : "", 16384); else mccinter_analyzer_colimator_5_blade_0_mask_setting[0]='\0';
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_5_blade_0_number_of_activations = 1;
#line 111897 "MACS_sample_kidney_box.c"

  SIG_MESSAGE("inter_analyzer_colimator_5_blade_0 (Init:Place/Rotate)");
  rot_set_rotation(mctr1,
#line 1776 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 1776 "MACS_sample_kidney_box.instr"
    (- analyzer_2theta [ 5 ])*DEG2RAD,
#line 1776 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD);
#line 111907 "MACS_sample_kidney_box.c"
  rot_mul(mctr1, mcrotainter_analyzer_colimator_center_5, mcrotainter_analyzer_colimator_5_blade_0);
  rot_transpose(mcrotainter_analyzer_colimator_center_5, mctr1);
  rot_mul(mcrotainter_analyzer_colimator_5_blade_0, mctr1, mcrotrinter_analyzer_colimator_5_blade_0);
  mctc1 = coords_set(
#line 1775 "MACS_sample_kidney_box.instr"
    0,
#line 1775 "MACS_sample_kidney_box.instr"
    0,
#line 1775 "MACS_sample_kidney_box.instr"
    inter_analyzer_colimator_start_pos - 0 * inter_analyzer_colimator_seperation);
#line 111918 "MACS_sample_kidney_box.c"
  rot_transpose(mcrotainter_analyzer_colimator_center_5, mctr1);
  mctc2 = rot_apply(mctr1, mctc1);
  mcposainter_analyzer_colimator_5_blade_0 = coords_add(mcposainter_analyzer_colimator_center_5, mctc2);
  mctc1 = coords_sub(mcposainter_analyzer_colimator_center_5, mcposainter_analyzer_colimator_5_blade_0);
  mcposrinter_analyzer_colimator_5_blade_0 = rot_apply(mcrotainter_analyzer_colimator_5_blade_0, mctc1);
  mcDEBUG_COMPONENT("inter_analyzer_colimator_5_blade_0", mcposainter_analyzer_colimator_5_blade_0, mcrotainter_analyzer_colimator_5_blade_0)
  mccomp_posa[345] = mcposainter_analyzer_colimator_5_blade_0;
  mccomp_posr[345] = mcposrinter_analyzer_colimator_5_blade_0;
  mcNCounter[345]  = mcPCounter[345] = mcP2Counter[345] = 0;
  mcAbsorbProp[345]= 0;
    /* Component inter_analyzer_colimator_5_blade_1. */
  /* Setting parameters for component inter_analyzer_colimator_5_blade_1. */
  SIG_MESSAGE("inter_analyzer_colimator_5_blade_1 (Init:SetPar)");
#line 1780 "MACS_sample_kidney_box.instr"
  if("Collimator_gad") strncpy(mccinter_analyzer_colimator_5_blade_1_material_string, "Collimator_gad" ? "Collimator_gad" : "", 16384); else mccinter_analyzer_colimator_5_blade_1_material_string[0]='\0';
#line 1780 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_5_blade_1_priority = 726;
#line 1779 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_5_blade_1_xwidth = inter_analyzer_colimator_width;
#line 1779 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_5_blade_1_yheight = inter_analyzer_colimator_height;
#line 1779 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_5_blade_1_zdepth = inter_analyzer_colimator_depth;
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_5_blade_1_xwidth2 = -1;
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_5_blade_1_yheight2 = -1;
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_5_blade_1_visualize = 1;
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_5_blade_1_target_index = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_5_blade_1_target_x = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_5_blade_1_target_y = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_5_blade_1_target_z = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_5_blade_1_focus_aw = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_5_blade_1_focus_ah = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_5_blade_1_focus_xw = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_5_blade_1_focus_xh = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_5_blade_1_focus_r = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_5_blade_1_p_interact = 0;
#line 71 "MACS_sample_kidney_box.instr"
  if(0) strncpy(mccinter_analyzer_colimator_5_blade_1_mask_string, 0 ? 0 : "", 16384); else mccinter_analyzer_colimator_5_blade_1_mask_string[0]='\0';
#line 71 "MACS_sample_kidney_box.instr"
  if(0) strncpy(mccinter_analyzer_colimator_5_blade_1_mask_setting, 0 ? 0 : "", 16384); else mccinter_analyzer_colimator_5_blade_1_mask_setting[0]='\0';
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_5_blade_1_number_of_activations = 1;
#line 111974 "MACS_sample_kidney_box.c"

  SIG_MESSAGE("inter_analyzer_colimator_5_blade_1 (Init:Place/Rotate)");
  rot_set_rotation(mctr1,
#line 1782 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 1782 "MACS_sample_kidney_box.instr"
    (- analyzer_2theta [ 5 ])*DEG2RAD,
#line 1782 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD);
#line 111984 "MACS_sample_kidney_box.c"
  rot_mul(mctr1, mcrotainter_analyzer_colimator_center_5, mcrotainter_analyzer_colimator_5_blade_1);
  rot_transpose(mcrotainter_analyzer_colimator_5_blade_0, mctr1);
  rot_mul(mcrotainter_analyzer_colimator_5_blade_1, mctr1, mcrotrinter_analyzer_colimator_5_blade_1);
  mctc1 = coords_set(
#line 1781 "MACS_sample_kidney_box.instr"
    0,
#line 1781 "MACS_sample_kidney_box.instr"
    0,
#line 1781 "MACS_sample_kidney_box.instr"
    inter_analyzer_colimator_start_pos - 1 * inter_analyzer_colimator_seperation);
#line 111995 "MACS_sample_kidney_box.c"
  rot_transpose(mcrotainter_analyzer_colimator_center_5, mctr1);
  mctc2 = rot_apply(mctr1, mctc1);
  mcposainter_analyzer_colimator_5_blade_1 = coords_add(mcposainter_analyzer_colimator_center_5, mctc2);
  mctc1 = coords_sub(mcposainter_analyzer_colimator_5_blade_0, mcposainter_analyzer_colimator_5_blade_1);
  mcposrinter_analyzer_colimator_5_blade_1 = rot_apply(mcrotainter_analyzer_colimator_5_blade_1, mctc1);
  mcDEBUG_COMPONENT("inter_analyzer_colimator_5_blade_1", mcposainter_analyzer_colimator_5_blade_1, mcrotainter_analyzer_colimator_5_blade_1)
  mccomp_posa[346] = mcposainter_analyzer_colimator_5_blade_1;
  mccomp_posr[346] = mcposrinter_analyzer_colimator_5_blade_1;
  mcNCounter[346]  = mcPCounter[346] = mcP2Counter[346] = 0;
  mcAbsorbProp[346]= 0;
    /* Component inter_analyzer_colimator_5_blade_2. */
  /* Setting parameters for component inter_analyzer_colimator_5_blade_2. */
  SIG_MESSAGE("inter_analyzer_colimator_5_blade_2 (Init:SetPar)");
#line 1786 "MACS_sample_kidney_box.instr"
  if("Collimator_gad") strncpy(mccinter_analyzer_colimator_5_blade_2_material_string, "Collimator_gad" ? "Collimator_gad" : "", 16384); else mccinter_analyzer_colimator_5_blade_2_material_string[0]='\0';
#line 1786 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_5_blade_2_priority = 727;
#line 1785 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_5_blade_2_xwidth = inter_analyzer_colimator_width;
#line 1785 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_5_blade_2_yheight = inter_analyzer_colimator_height;
#line 1785 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_5_blade_2_zdepth = inter_analyzer_colimator_depth;
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_5_blade_2_xwidth2 = -1;
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_5_blade_2_yheight2 = -1;
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_5_blade_2_visualize = 1;
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_5_blade_2_target_index = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_5_blade_2_target_x = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_5_blade_2_target_y = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_5_blade_2_target_z = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_5_blade_2_focus_aw = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_5_blade_2_focus_ah = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_5_blade_2_focus_xw = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_5_blade_2_focus_xh = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_5_blade_2_focus_r = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_5_blade_2_p_interact = 0;
#line 71 "MACS_sample_kidney_box.instr"
  if(0) strncpy(mccinter_analyzer_colimator_5_blade_2_mask_string, 0 ? 0 : "", 16384); else mccinter_analyzer_colimator_5_blade_2_mask_string[0]='\0';
#line 71 "MACS_sample_kidney_box.instr"
  if(0) strncpy(mccinter_analyzer_colimator_5_blade_2_mask_setting, 0 ? 0 : "", 16384); else mccinter_analyzer_colimator_5_blade_2_mask_setting[0]='\0';
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_5_blade_2_number_of_activations = 1;
#line 112051 "MACS_sample_kidney_box.c"

  SIG_MESSAGE("inter_analyzer_colimator_5_blade_2 (Init:Place/Rotate)");
  rot_set_rotation(mctr1,
#line 1788 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 1788 "MACS_sample_kidney_box.instr"
    (- analyzer_2theta [ 5 ])*DEG2RAD,
#line 1788 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD);
#line 112061 "MACS_sample_kidney_box.c"
  rot_mul(mctr1, mcrotainter_analyzer_colimator_center_5, mcrotainter_analyzer_colimator_5_blade_2);
  rot_transpose(mcrotainter_analyzer_colimator_5_blade_1, mctr1);
  rot_mul(mcrotainter_analyzer_colimator_5_blade_2, mctr1, mcrotrinter_analyzer_colimator_5_blade_2);
  mctc1 = coords_set(
#line 1787 "MACS_sample_kidney_box.instr"
    0,
#line 1787 "MACS_sample_kidney_box.instr"
    0,
#line 1787 "MACS_sample_kidney_box.instr"
    inter_analyzer_colimator_start_pos - 2 * inter_analyzer_colimator_seperation);
#line 112072 "MACS_sample_kidney_box.c"
  rot_transpose(mcrotainter_analyzer_colimator_center_5, mctr1);
  mctc2 = rot_apply(mctr1, mctc1);
  mcposainter_analyzer_colimator_5_blade_2 = coords_add(mcposainter_analyzer_colimator_center_5, mctc2);
  mctc1 = coords_sub(mcposainter_analyzer_colimator_5_blade_1, mcposainter_analyzer_colimator_5_blade_2);
  mcposrinter_analyzer_colimator_5_blade_2 = rot_apply(mcrotainter_analyzer_colimator_5_blade_2, mctc1);
  mcDEBUG_COMPONENT("inter_analyzer_colimator_5_blade_2", mcposainter_analyzer_colimator_5_blade_2, mcrotainter_analyzer_colimator_5_blade_2)
  mccomp_posa[347] = mcposainter_analyzer_colimator_5_blade_2;
  mccomp_posr[347] = mcposrinter_analyzer_colimator_5_blade_2;
  mcNCounter[347]  = mcPCounter[347] = mcP2Counter[347] = 0;
  mcAbsorbProp[347]= 0;
    /* Component inter_analyzer_colimator_5_blade_3. */
  /* Setting parameters for component inter_analyzer_colimator_5_blade_3. */
  SIG_MESSAGE("inter_analyzer_colimator_5_blade_3 (Init:SetPar)");
#line 1792 "MACS_sample_kidney_box.instr"
  if("Collimator_gad") strncpy(mccinter_analyzer_colimator_5_blade_3_material_string, "Collimator_gad" ? "Collimator_gad" : "", 16384); else mccinter_analyzer_colimator_5_blade_3_material_string[0]='\0';
#line 1792 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_5_blade_3_priority = 728;
#line 1791 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_5_blade_3_xwidth = inter_analyzer_colimator_width;
#line 1791 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_5_blade_3_yheight = inter_analyzer_colimator_height;
#line 1791 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_5_blade_3_zdepth = inter_analyzer_colimator_depth;
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_5_blade_3_xwidth2 = -1;
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_5_blade_3_yheight2 = -1;
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_5_blade_3_visualize = 1;
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_5_blade_3_target_index = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_5_blade_3_target_x = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_5_blade_3_target_y = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_5_blade_3_target_z = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_5_blade_3_focus_aw = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_5_blade_3_focus_ah = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_5_blade_3_focus_xw = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_5_blade_3_focus_xh = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_5_blade_3_focus_r = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_5_blade_3_p_interact = 0;
#line 71 "MACS_sample_kidney_box.instr"
  if(0) strncpy(mccinter_analyzer_colimator_5_blade_3_mask_string, 0 ? 0 : "", 16384); else mccinter_analyzer_colimator_5_blade_3_mask_string[0]='\0';
#line 71 "MACS_sample_kidney_box.instr"
  if(0) strncpy(mccinter_analyzer_colimator_5_blade_3_mask_setting, 0 ? 0 : "", 16384); else mccinter_analyzer_colimator_5_blade_3_mask_setting[0]='\0';
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_5_blade_3_number_of_activations = 1;
#line 112128 "MACS_sample_kidney_box.c"

  SIG_MESSAGE("inter_analyzer_colimator_5_blade_3 (Init:Place/Rotate)");
  rot_set_rotation(mctr1,
#line 1794 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 1794 "MACS_sample_kidney_box.instr"
    (- analyzer_2theta [ 5 ])*DEG2RAD,
#line 1794 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD);
#line 112138 "MACS_sample_kidney_box.c"
  rot_mul(mctr1, mcrotainter_analyzer_colimator_center_5, mcrotainter_analyzer_colimator_5_blade_3);
  rot_transpose(mcrotainter_analyzer_colimator_5_blade_2, mctr1);
  rot_mul(mcrotainter_analyzer_colimator_5_blade_3, mctr1, mcrotrinter_analyzer_colimator_5_blade_3);
  mctc1 = coords_set(
#line 1793 "MACS_sample_kidney_box.instr"
    0,
#line 1793 "MACS_sample_kidney_box.instr"
    0,
#line 1793 "MACS_sample_kidney_box.instr"
    inter_analyzer_colimator_start_pos - 3 * inter_analyzer_colimator_seperation);
#line 112149 "MACS_sample_kidney_box.c"
  rot_transpose(mcrotainter_analyzer_colimator_center_5, mctr1);
  mctc2 = rot_apply(mctr1, mctc1);
  mcposainter_analyzer_colimator_5_blade_3 = coords_add(mcposainter_analyzer_colimator_center_5, mctc2);
  mctc1 = coords_sub(mcposainter_analyzer_colimator_5_blade_2, mcposainter_analyzer_colimator_5_blade_3);
  mcposrinter_analyzer_colimator_5_blade_3 = rot_apply(mcrotainter_analyzer_colimator_5_blade_3, mctc1);
  mcDEBUG_COMPONENT("inter_analyzer_colimator_5_blade_3", mcposainter_analyzer_colimator_5_blade_3, mcrotainter_analyzer_colimator_5_blade_3)
  mccomp_posa[348] = mcposainter_analyzer_colimator_5_blade_3;
  mccomp_posr[348] = mcposrinter_analyzer_colimator_5_blade_3;
  mcNCounter[348]  = mcPCounter[348] = mcP2Counter[348] = 0;
  mcAbsorbProp[348]= 0;
    /* Component inter_analyzer_colimator_5_blade_4. */
  /* Setting parameters for component inter_analyzer_colimator_5_blade_4. */
  SIG_MESSAGE("inter_analyzer_colimator_5_blade_4 (Init:SetPar)");
#line 1798 "MACS_sample_kidney_box.instr"
  if("Collimator_gad") strncpy(mccinter_analyzer_colimator_5_blade_4_material_string, "Collimator_gad" ? "Collimator_gad" : "", 16384); else mccinter_analyzer_colimator_5_blade_4_material_string[0]='\0';
#line 1798 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_5_blade_4_priority = 729;
#line 1797 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_5_blade_4_xwidth = inter_analyzer_colimator_width;
#line 1797 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_5_blade_4_yheight = inter_analyzer_colimator_height;
#line 1797 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_5_blade_4_zdepth = inter_analyzer_colimator_depth;
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_5_blade_4_xwidth2 = -1;
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_5_blade_4_yheight2 = -1;
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_5_blade_4_visualize = 1;
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_5_blade_4_target_index = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_5_blade_4_target_x = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_5_blade_4_target_y = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_5_blade_4_target_z = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_5_blade_4_focus_aw = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_5_blade_4_focus_ah = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_5_blade_4_focus_xw = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_5_blade_4_focus_xh = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_5_blade_4_focus_r = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_5_blade_4_p_interact = 0;
#line 71 "MACS_sample_kidney_box.instr"
  if(0) strncpy(mccinter_analyzer_colimator_5_blade_4_mask_string, 0 ? 0 : "", 16384); else mccinter_analyzer_colimator_5_blade_4_mask_string[0]='\0';
#line 71 "MACS_sample_kidney_box.instr"
  if(0) strncpy(mccinter_analyzer_colimator_5_blade_4_mask_setting, 0 ? 0 : "", 16384); else mccinter_analyzer_colimator_5_blade_4_mask_setting[0]='\0';
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_5_blade_4_number_of_activations = 1;
#line 112205 "MACS_sample_kidney_box.c"

  SIG_MESSAGE("inter_analyzer_colimator_5_blade_4 (Init:Place/Rotate)");
  rot_set_rotation(mctr1,
#line 1800 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 1800 "MACS_sample_kidney_box.instr"
    (- analyzer_2theta [ 5 ])*DEG2RAD,
#line 1800 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD);
#line 112215 "MACS_sample_kidney_box.c"
  rot_mul(mctr1, mcrotainter_analyzer_colimator_center_5, mcrotainter_analyzer_colimator_5_blade_4);
  rot_transpose(mcrotainter_analyzer_colimator_5_blade_3, mctr1);
  rot_mul(mcrotainter_analyzer_colimator_5_blade_4, mctr1, mcrotrinter_analyzer_colimator_5_blade_4);
  mctc1 = coords_set(
#line 1799 "MACS_sample_kidney_box.instr"
    0,
#line 1799 "MACS_sample_kidney_box.instr"
    0,
#line 1799 "MACS_sample_kidney_box.instr"
    inter_analyzer_colimator_start_pos - 4 * inter_analyzer_colimator_seperation);
#line 112226 "MACS_sample_kidney_box.c"
  rot_transpose(mcrotainter_analyzer_colimator_center_5, mctr1);
  mctc2 = rot_apply(mctr1, mctc1);
  mcposainter_analyzer_colimator_5_blade_4 = coords_add(mcposainter_analyzer_colimator_center_5, mctc2);
  mctc1 = coords_sub(mcposainter_analyzer_colimator_5_blade_3, mcposainter_analyzer_colimator_5_blade_4);
  mcposrinter_analyzer_colimator_5_blade_4 = rot_apply(mcrotainter_analyzer_colimator_5_blade_4, mctc1);
  mcDEBUG_COMPONENT("inter_analyzer_colimator_5_blade_4", mcposainter_analyzer_colimator_5_blade_4, mcrotainter_analyzer_colimator_5_blade_4)
  mccomp_posa[349] = mcposainter_analyzer_colimator_5_blade_4;
  mccomp_posr[349] = mcposrinter_analyzer_colimator_5_blade_4;
  mcNCounter[349]  = mcPCounter[349] = mcP2Counter[349] = 0;
  mcAbsorbProp[349]= 0;
    /* Component diffraction_detector_5_exit_volume. */
  /* Setting parameters for component diffraction_detector_5_exit_volume. */
  SIG_MESSAGE("diffraction_detector_5_exit_volume (Init:SetPar)");
#line 1804 "MACS_sample_kidney_box.instr"
  if("Exit") strncpy(mccdiffraction_detector_5_exit_volume_material_string, "Exit" ? "Exit" : "", 16384); else mccdiffraction_detector_5_exit_volume_material_string[0]='\0';
#line 1804 "MACS_sample_kidney_box.instr"
  mccdiffraction_detector_5_exit_volume_priority = 731;
#line 1803 "MACS_sample_kidney_box.instr"
  mccdiffraction_detector_5_exit_volume_xwidth = 2.01 * detector_radius;
#line 1803 "MACS_sample_kidney_box.instr"
  mccdiffraction_detector_5_exit_volume_yheight = 1.01 * detector_height;
#line 1803 "MACS_sample_kidney_box.instr"
  mccdiffraction_detector_5_exit_volume_zdepth = 0.001;
#line 71 "MACS_sample_kidney_box.instr"
  mccdiffraction_detector_5_exit_volume_xwidth2 = -1;
#line 71 "MACS_sample_kidney_box.instr"
  mccdiffraction_detector_5_exit_volume_yheight2 = -1;
#line 71 "MACS_sample_kidney_box.instr"
  mccdiffraction_detector_5_exit_volume_visualize = 1;
#line 71 "MACS_sample_kidney_box.instr"
  mccdiffraction_detector_5_exit_volume_target_index = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccdiffraction_detector_5_exit_volume_target_x = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccdiffraction_detector_5_exit_volume_target_y = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccdiffraction_detector_5_exit_volume_target_z = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccdiffraction_detector_5_exit_volume_focus_aw = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccdiffraction_detector_5_exit_volume_focus_ah = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccdiffraction_detector_5_exit_volume_focus_xw = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccdiffraction_detector_5_exit_volume_focus_xh = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccdiffraction_detector_5_exit_volume_focus_r = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccdiffraction_detector_5_exit_volume_p_interact = 0;
#line 71 "MACS_sample_kidney_box.instr"
  if(0) strncpy(mccdiffraction_detector_5_exit_volume_mask_string, 0 ? 0 : "", 16384); else mccdiffraction_detector_5_exit_volume_mask_string[0]='\0';
#line 71 "MACS_sample_kidney_box.instr"
  if(0) strncpy(mccdiffraction_detector_5_exit_volume_mask_setting, 0 ? 0 : "", 16384); else mccdiffraction_detector_5_exit_volume_mask_setting[0]='\0';
#line 71 "MACS_sample_kidney_box.instr"
  mccdiffraction_detector_5_exit_volume_number_of_activations = 1;
#line 112282 "MACS_sample_kidney_box.c"

  SIG_MESSAGE("diffraction_detector_5_exit_volume (Init:Place/Rotate)");
  rot_set_rotation(mctr1,
#line 1806 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 1806 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 1806 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD);
#line 112292 "MACS_sample_kidney_box.c"
  rot_mul(mctr1, mcrotakidney_channel_5, mcrotadiffraction_detector_5_exit_volume);
  rot_transpose(mcrotainter_analyzer_colimator_5_blade_4, mctr1);
  rot_mul(mcrotadiffraction_detector_5_exit_volume, mctr1, mcrotrdiffraction_detector_5_exit_volume);
  mctc1 = coords_set(
#line 1805 "MACS_sample_kidney_box.instr"
    0,
#line 1805 "MACS_sample_kidney_box.instr"
    0,
#line 1805 "MACS_sample_kidney_box.instr"
    0);
#line 112303 "MACS_sample_kidney_box.c"
  rot_transpose(mcrotachannel_5_cave1_cyl1, mctr1);
  mctc2 = rot_apply(mctr1, mctc1);
  mcposadiffraction_detector_5_exit_volume = coords_add(mcposachannel_5_cave1_cyl1, mctc2);
  mctc1 = coords_sub(mcposainter_analyzer_colimator_5_blade_4, mcposadiffraction_detector_5_exit_volume);
  mcposrdiffraction_detector_5_exit_volume = rot_apply(mcrotadiffraction_detector_5_exit_volume, mctc1);
  mcDEBUG_COMPONENT("diffraction_detector_5_exit_volume", mcposadiffraction_detector_5_exit_volume, mcrotadiffraction_detector_5_exit_volume)
  mccomp_posa[350] = mcposadiffraction_detector_5_exit_volume;
  mccomp_posr[350] = mcposrdiffraction_detector_5_exit_volume;
  mcNCounter[350]  = mcPCounter[350] = mcP2Counter[350] = 0;
  mcAbsorbProp[350]= 0;
    /* Component spec_detector_5_exit_volume. */
  /* Setting parameters for component spec_detector_5_exit_volume. */
  SIG_MESSAGE("spec_detector_5_exit_volume (Init:SetPar)");
#line 1810 "MACS_sample_kidney_box.instr"
  if("Exit") strncpy(mccspec_detector_5_exit_volume_material_string, "Exit" ? "Exit" : "", 16384); else mccspec_detector_5_exit_volume_material_string[0]='\0';
#line 1810 "MACS_sample_kidney_box.instr"
  mccspec_detector_5_exit_volume_priority = 732;
#line 1809 "MACS_sample_kidney_box.instr"
  mccspec_detector_5_exit_volume_xwidth = 2.01 * detector_radius;
#line 1809 "MACS_sample_kidney_box.instr"
  mccspec_detector_5_exit_volume_yheight = 1.01 * detector_height;
#line 1809 "MACS_sample_kidney_box.instr"
  mccspec_detector_5_exit_volume_zdepth = 0.001;
#line 71 "MACS_sample_kidney_box.instr"
  mccspec_detector_5_exit_volume_xwidth2 = -1;
#line 71 "MACS_sample_kidney_box.instr"
  mccspec_detector_5_exit_volume_yheight2 = -1;
#line 71 "MACS_sample_kidney_box.instr"
  mccspec_detector_5_exit_volume_visualize = 1;
#line 71 "MACS_sample_kidney_box.instr"
  mccspec_detector_5_exit_volume_target_index = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccspec_detector_5_exit_volume_target_x = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccspec_detector_5_exit_volume_target_y = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccspec_detector_5_exit_volume_target_z = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccspec_detector_5_exit_volume_focus_aw = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccspec_detector_5_exit_volume_focus_ah = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccspec_detector_5_exit_volume_focus_xw = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccspec_detector_5_exit_volume_focus_xh = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccspec_detector_5_exit_volume_focus_r = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccspec_detector_5_exit_volume_p_interact = 0;
#line 71 "MACS_sample_kidney_box.instr"
  if(0) strncpy(mccspec_detector_5_exit_volume_mask_string, 0 ? 0 : "", 16384); else mccspec_detector_5_exit_volume_mask_string[0]='\0';
#line 71 "MACS_sample_kidney_box.instr"
  if(0) strncpy(mccspec_detector_5_exit_volume_mask_setting, 0 ? 0 : "", 16384); else mccspec_detector_5_exit_volume_mask_setting[0]='\0';
#line 71 "MACS_sample_kidney_box.instr"
  mccspec_detector_5_exit_volume_number_of_activations = 1;
#line 112359 "MACS_sample_kidney_box.c"

  SIG_MESSAGE("spec_detector_5_exit_volume (Init:Place/Rotate)");
  rot_set_rotation(mctr1,
#line 1812 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 1812 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 1812 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD);
#line 112369 "MACS_sample_kidney_box.c"
  rot_mul(mctr1, mcrotachannel_5_analyzer_2_center, mcrotaspec_detector_5_exit_volume);
  rot_transpose(mcrotadiffraction_detector_5_exit_volume, mctr1);
  rot_mul(mcrotaspec_detector_5_exit_volume, mctr1, mcrotrspec_detector_5_exit_volume);
  mctc1 = coords_set(
#line 1811 "MACS_sample_kidney_box.instr"
    0,
#line 1811 "MACS_sample_kidney_box.instr"
    0,
#line 1811 "MACS_sample_kidney_box.instr"
    0);
#line 112380 "MACS_sample_kidney_box.c"
  rot_transpose(mcrotachannel_5_cave2_cyl1, mctr1);
  mctc2 = rot_apply(mctr1, mctc1);
  mcposaspec_detector_5_exit_volume = coords_add(mcposachannel_5_cave2_cyl1, mctc2);
  mctc1 = coords_sub(mcposadiffraction_detector_5_exit_volume, mcposaspec_detector_5_exit_volume);
  mcposrspec_detector_5_exit_volume = rot_apply(mcrotaspec_detector_5_exit_volume, mctc1);
  mcDEBUG_COMPONENT("spec_detector_5_exit_volume", mcposaspec_detector_5_exit_volume, mcrotaspec_detector_5_exit_volume)
  mccomp_posa[351] = mcposaspec_detector_5_exit_volume;
  mccomp_posr[351] = mcposrspec_detector_5_exit_volume;
  mcNCounter[351]  = mcPCounter[351] = mcP2Counter[351] = 0;
  mcAbsorbProp[351]= 0;
    /* Component channel_6_cave1_box1. */
  /* Setting parameters for component channel_6_cave1_box1. */
  SIG_MESSAGE("channel_6_cave1_box1 (Init:SetPar)");
#line 1817 "MACS_sample_kidney_box.instr"
  if("Vacuum") strncpy(mccchannel_6_cave1_box1_material_string, "Vacuum" ? "Vacuum" : "", 16384); else mccchannel_6_cave1_box1_material_string[0]='\0';
#line 1817 "MACS_sample_kidney_box.instr"
  mccchannel_6_cave1_box1_priority = 800;
#line 1815 "MACS_sample_kidney_box.instr"
  mccchannel_6_cave1_box1_xwidth = kidney_cave1_box1_width1;
#line 1815 "MACS_sample_kidney_box.instr"
  mccchannel_6_cave1_box1_yheight = kidney_cave1_box1_height1;
#line 1815 "MACS_sample_kidney_box.instr"
  mccchannel_6_cave1_box1_zdepth = kidney_cave1_box1_depth;
#line 1816 "MACS_sample_kidney_box.instr"
  mccchannel_6_cave1_box1_xwidth2 = kidney_cave1_box1_width2;
#line 1816 "MACS_sample_kidney_box.instr"
  mccchannel_6_cave1_box1_yheight2 = kidney_cave1_box1_height2;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_6_cave1_box1_visualize = 1;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_6_cave1_box1_target_index = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_6_cave1_box1_target_x = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_6_cave1_box1_target_y = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_6_cave1_box1_target_z = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_6_cave1_box1_focus_aw = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_6_cave1_box1_focus_ah = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_6_cave1_box1_focus_xw = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_6_cave1_box1_focus_xh = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_6_cave1_box1_focus_r = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_6_cave1_box1_p_interact = 0;
#line 71 "MACS_sample_kidney_box.instr"
  if(0) strncpy(mccchannel_6_cave1_box1_mask_string, 0 ? 0 : "", 16384); else mccchannel_6_cave1_box1_mask_string[0]='\0';
#line 71 "MACS_sample_kidney_box.instr"
  if(0) strncpy(mccchannel_6_cave1_box1_mask_setting, 0 ? 0 : "", 16384); else mccchannel_6_cave1_box1_mask_setting[0]='\0';
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_6_cave1_box1_number_of_activations = 1;
#line 112436 "MACS_sample_kidney_box.c"

  SIG_MESSAGE("channel_6_cave1_box1 (Init:Place/Rotate)");
  rot_set_rotation(mctr1,
#line 1819 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 1819 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 1819 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD);
#line 112446 "MACS_sample_kidney_box.c"
  rot_mul(mctr1, mcrotakidney_channel_6, mcrotachannel_6_cave1_box1);
  rot_transpose(mcrotaspec_detector_5_exit_volume, mctr1);
  rot_mul(mcrotachannel_6_cave1_box1, mctr1, mcrotrchannel_6_cave1_box1);
  mctc1 = coords_set(
#line 1818 "MACS_sample_kidney_box.instr"
    0,
#line 1818 "MACS_sample_kidney_box.instr"
    0,
#line 1818 "MACS_sample_kidney_box.instr"
    kidney_cave1_box1_center_to_target);
#line 112457 "MACS_sample_kidney_box.c"
  rot_transpose(mcrotakidney_channel_6, mctr1);
  mctc2 = rot_apply(mctr1, mctc1);
  mcposachannel_6_cave1_box1 = coords_add(mcposakidney_channel_6, mctc2);
  mctc1 = coords_sub(mcposaspec_detector_5_exit_volume, mcposachannel_6_cave1_box1);
  mcposrchannel_6_cave1_box1 = rot_apply(mcrotachannel_6_cave1_box1, mctc1);
  mcDEBUG_COMPONENT("channel_6_cave1_box1", mcposachannel_6_cave1_box1, mcrotachannel_6_cave1_box1)
  mccomp_posa[352] = mcposachannel_6_cave1_box1;
  mccomp_posr[352] = mcposrchannel_6_cave1_box1;
  mcNCounter[352]  = mcPCounter[352] = mcP2Counter[352] = 0;
  mcAbsorbProp[352]= 0;
    /* Component channel_6_cave1_box2. */
  /* Setting parameters for component channel_6_cave1_box2. */
  SIG_MESSAGE("channel_6_cave1_box2 (Init:SetPar)");
#line 1824 "MACS_sample_kidney_box.instr"
  if("Vacuum") strncpy(mccchannel_6_cave1_box2_material_string, "Vacuum" ? "Vacuum" : "", 16384); else mccchannel_6_cave1_box2_material_string[0]='\0';
#line 1824 "MACS_sample_kidney_box.instr"
  mccchannel_6_cave1_box2_priority = 805;
#line 1822 "MACS_sample_kidney_box.instr"
  mccchannel_6_cave1_box2_xwidth = kidney_cave1_box2_width1;
#line 1822 "MACS_sample_kidney_box.instr"
  mccchannel_6_cave1_box2_yheight = kidney_cave1_box2_height1;
#line 1822 "MACS_sample_kidney_box.instr"
  mccchannel_6_cave1_box2_zdepth = kidney_cave1_box2_depth;
#line 1823 "MACS_sample_kidney_box.instr"
  mccchannel_6_cave1_box2_xwidth2 = kidney_cave1_box2_width2;
#line 1823 "MACS_sample_kidney_box.instr"
  mccchannel_6_cave1_box2_yheight2 = kidney_cave1_box2_height2;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_6_cave1_box2_visualize = 1;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_6_cave1_box2_target_index = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_6_cave1_box2_target_x = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_6_cave1_box2_target_y = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_6_cave1_box2_target_z = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_6_cave1_box2_focus_aw = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_6_cave1_box2_focus_ah = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_6_cave1_box2_focus_xw = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_6_cave1_box2_focus_xh = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_6_cave1_box2_focus_r = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_6_cave1_box2_p_interact = 0;
#line 71 "MACS_sample_kidney_box.instr"
  if(0) strncpy(mccchannel_6_cave1_box2_mask_string, 0 ? 0 : "", 16384); else mccchannel_6_cave1_box2_mask_string[0]='\0';
#line 71 "MACS_sample_kidney_box.instr"
  if(0) strncpy(mccchannel_6_cave1_box2_mask_setting, 0 ? 0 : "", 16384); else mccchannel_6_cave1_box2_mask_setting[0]='\0';
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_6_cave1_box2_number_of_activations = 1;
#line 112513 "MACS_sample_kidney_box.c"

  SIG_MESSAGE("channel_6_cave1_box2 (Init:Place/Rotate)");
  rot_set_rotation(mctr1,
#line 1826 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 1826 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 1826 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD);
#line 112523 "MACS_sample_kidney_box.c"
  rot_mul(mctr1, mcrotakidney_channel_6, mcrotachannel_6_cave1_box2);
  rot_transpose(mcrotachannel_6_cave1_box1, mctr1);
  rot_mul(mcrotachannel_6_cave1_box2, mctr1, mcrotrchannel_6_cave1_box2);
  mctc1 = coords_set(
#line 1825 "MACS_sample_kidney_box.instr"
    kidney_cave1_box2_x_offset,
#line 1825 "MACS_sample_kidney_box.instr"
    0,
#line 1825 "MACS_sample_kidney_box.instr"
    kidney_cave1_box2_center_to_target);
#line 112534 "MACS_sample_kidney_box.c"
  rot_transpose(mcrotakidney_channel_6, mctr1);
  mctc2 = rot_apply(mctr1, mctc1);
  mcposachannel_6_cave1_box2 = coords_add(mcposakidney_channel_6, mctc2);
  mctc1 = coords_sub(mcposachannel_6_cave1_box1, mcposachannel_6_cave1_box2);
  mcposrchannel_6_cave1_box2 = rot_apply(mcrotachannel_6_cave1_box2, mctc1);
  mcDEBUG_COMPONENT("channel_6_cave1_box2", mcposachannel_6_cave1_box2, mcrotachannel_6_cave1_box2)
  mccomp_posa[353] = mcposachannel_6_cave1_box2;
  mccomp_posr[353] = mcposrchannel_6_cave1_box2;
  mcNCounter[353]  = mcPCounter[353] = mcP2Counter[353] = 0;
  mcAbsorbProp[353]= 0;
    /* Component channel_6_cave1_box3. */
  /* Setting parameters for component channel_6_cave1_box3. */
  SIG_MESSAGE("channel_6_cave1_box3 (Init:SetPar)");
#line 1831 "MACS_sample_kidney_box.instr"
  if("Vacuum") strncpy(mccchannel_6_cave1_box3_material_string, "Vacuum" ? "Vacuum" : "", 16384); else mccchannel_6_cave1_box3_material_string[0]='\0';
#line 1831 "MACS_sample_kidney_box.instr"
  mccchannel_6_cave1_box3_priority = 802;
#line 1829 "MACS_sample_kidney_box.instr"
  mccchannel_6_cave1_box3_xwidth = kidney_cave1_box3_width1;
#line 1829 "MACS_sample_kidney_box.instr"
  mccchannel_6_cave1_box3_yheight = kidney_cave1_box3_height1;
#line 1829 "MACS_sample_kidney_box.instr"
  mccchannel_6_cave1_box3_zdepth = kidney_cave1_box3_depth;
#line 1830 "MACS_sample_kidney_box.instr"
  mccchannel_6_cave1_box3_xwidth2 = kidney_cave1_box3_width2;
#line 1830 "MACS_sample_kidney_box.instr"
  mccchannel_6_cave1_box3_yheight2 = kidney_cave1_box3_height2;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_6_cave1_box3_visualize = 1;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_6_cave1_box3_target_index = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_6_cave1_box3_target_x = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_6_cave1_box3_target_y = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_6_cave1_box3_target_z = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_6_cave1_box3_focus_aw = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_6_cave1_box3_focus_ah = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_6_cave1_box3_focus_xw = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_6_cave1_box3_focus_xh = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_6_cave1_box3_focus_r = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_6_cave1_box3_p_interact = 0;
#line 71 "MACS_sample_kidney_box.instr"
  if(0) strncpy(mccchannel_6_cave1_box3_mask_string, 0 ? 0 : "", 16384); else mccchannel_6_cave1_box3_mask_string[0]='\0';
#line 71 "MACS_sample_kidney_box.instr"
  if(0) strncpy(mccchannel_6_cave1_box3_mask_setting, 0 ? 0 : "", 16384); else mccchannel_6_cave1_box3_mask_setting[0]='\0';
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_6_cave1_box3_number_of_activations = 1;
#line 112590 "MACS_sample_kidney_box.c"

  SIG_MESSAGE("channel_6_cave1_box3 (Init:Place/Rotate)");
  rot_set_rotation(mctr1,
#line 1833 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 1833 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 1833 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD);
#line 112600 "MACS_sample_kidney_box.c"
  rot_mul(mctr1, mcrotakidney_channel_6, mcrotachannel_6_cave1_box3);
  rot_transpose(mcrotachannel_6_cave1_box2, mctr1);
  rot_mul(mcrotachannel_6_cave1_box3, mctr1, mcrotrchannel_6_cave1_box3);
  mctc1 = coords_set(
#line 1832 "MACS_sample_kidney_box.instr"
    0,
#line 1832 "MACS_sample_kidney_box.instr"
    0,
#line 1832 "MACS_sample_kidney_box.instr"
    kidney_cave1_box3_center_to_target);
#line 112611 "MACS_sample_kidney_box.c"
  rot_transpose(mcrotakidney_channel_6, mctr1);
  mctc2 = rot_apply(mctr1, mctc1);
  mcposachannel_6_cave1_box3 = coords_add(mcposakidney_channel_6, mctc2);
  mctc1 = coords_sub(mcposachannel_6_cave1_box2, mcposachannel_6_cave1_box3);
  mcposrchannel_6_cave1_box3 = rot_apply(mcrotachannel_6_cave1_box3, mctc1);
  mcDEBUG_COMPONENT("channel_6_cave1_box3", mcposachannel_6_cave1_box3, mcrotachannel_6_cave1_box3)
  mccomp_posa[354] = mcposachannel_6_cave1_box3;
  mccomp_posr[354] = mcposrchannel_6_cave1_box3;
  mcNCounter[354]  = mcPCounter[354] = mcP2Counter[354] = 0;
  mcAbsorbProp[354]= 0;
    /* Component channel_6_cave1_cyl1. */
  /* Setting parameters for component channel_6_cave1_cyl1. */
  SIG_MESSAGE("channel_6_cave1_cyl1 (Init:SetPar)");
#line 1837 "MACS_sample_kidney_box.instr"
  if("Vacuum") strncpy(mccchannel_6_cave1_cyl1_material_string, "Vacuum" ? "Vacuum" : "", 16384); else mccchannel_6_cave1_cyl1_material_string[0]='\0';
#line 1837 "MACS_sample_kidney_box.instr"
  mccchannel_6_cave1_cyl1_priority = 803;
#line 1836 "MACS_sample_kidney_box.instr"
  mccchannel_6_cave1_cyl1_radius = kidney_cave1_cyl1_radius;
#line 1836 "MACS_sample_kidney_box.instr"
  mccchannel_6_cave1_cyl1_yheight = kidney_cave1_cyl1_height;
#line 67 "MACS_sample_kidney_box.instr"
  mccchannel_6_cave1_cyl1_visualize = 1;
#line 67 "MACS_sample_kidney_box.instr"
  mccchannel_6_cave1_cyl1_target_index = 0;
#line 67 "MACS_sample_kidney_box.instr"
  mccchannel_6_cave1_cyl1_target_x = 0;
#line 67 "MACS_sample_kidney_box.instr"
  mccchannel_6_cave1_cyl1_target_y = 0;
#line 67 "MACS_sample_kidney_box.instr"
  mccchannel_6_cave1_cyl1_target_z = 0;
#line 67 "MACS_sample_kidney_box.instr"
  mccchannel_6_cave1_cyl1_focus_aw = 0;
#line 67 "MACS_sample_kidney_box.instr"
  mccchannel_6_cave1_cyl1_focus_ah = 0;
#line 67 "MACS_sample_kidney_box.instr"
  mccchannel_6_cave1_cyl1_focus_xw = 0;
#line 67 "MACS_sample_kidney_box.instr"
  mccchannel_6_cave1_cyl1_focus_xh = 0;
#line 67 "MACS_sample_kidney_box.instr"
  mccchannel_6_cave1_cyl1_focus_r = 0;
#line 67 "MACS_sample_kidney_box.instr"
  mccchannel_6_cave1_cyl1_p_interact = 0;
#line 67 "MACS_sample_kidney_box.instr"
  if(0) strncpy(mccchannel_6_cave1_cyl1_mask_string, 0 ? 0 : "", 16384); else mccchannel_6_cave1_cyl1_mask_string[0]='\0';
#line 67 "MACS_sample_kidney_box.instr"
  if(0) strncpy(mccchannel_6_cave1_cyl1_mask_setting, 0 ? 0 : "", 16384); else mccchannel_6_cave1_cyl1_mask_setting[0]='\0';
#line 67 "MACS_sample_kidney_box.instr"
  mccchannel_6_cave1_cyl1_number_of_activations = 1;
#line 112661 "MACS_sample_kidney_box.c"

  SIG_MESSAGE("channel_6_cave1_cyl1 (Init:Place/Rotate)");
  rot_set_rotation(mctr1,
#line 1839 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 1839 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 1839 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD);
#line 112671 "MACS_sample_kidney_box.c"
  rot_mul(mctr1, mcrotakidney_channel_6, mcrotachannel_6_cave1_cyl1);
  rot_transpose(mcrotachannel_6_cave1_box3, mctr1);
  rot_mul(mcrotachannel_6_cave1_cyl1, mctr1, mcrotrchannel_6_cave1_cyl1);
  mctc1 = coords_set(
#line 1838 "MACS_sample_kidney_box.instr"
    0,
#line 1838 "MACS_sample_kidney_box.instr"
    0,
#line 1838 "MACS_sample_kidney_box.instr"
    kidney_cave1_cyl1_center_to_target);
#line 112682 "MACS_sample_kidney_box.c"
  rot_transpose(mcrotakidney_channel_6, mctr1);
  mctc2 = rot_apply(mctr1, mctc1);
  mcposachannel_6_cave1_cyl1 = coords_add(mcposakidney_channel_6, mctc2);
  mctc1 = coords_sub(mcposachannel_6_cave1_box3, mcposachannel_6_cave1_cyl1);
  mcposrchannel_6_cave1_cyl1 = rot_apply(mcrotachannel_6_cave1_cyl1, mctc1);
  mcDEBUG_COMPONENT("channel_6_cave1_cyl1", mcposachannel_6_cave1_cyl1, mcrotachannel_6_cave1_cyl1)
  mccomp_posa[355] = mcposachannel_6_cave1_cyl1;
  mccomp_posr[355] = mcposrchannel_6_cave1_cyl1;
  mcNCounter[355]  = mcPCounter[355] = mcP2Counter[355] = 0;
  mcAbsorbProp[355]= 0;
    /* Component channel_6_analyzer_1_center. */
  /* Setting parameters for component channel_6_analyzer_1_center. */
  SIG_MESSAGE("channel_6_analyzer_1_center (Init:SetPar)");

  SIG_MESSAGE("channel_6_analyzer_1_center (Init:Place/Rotate)");
  rot_set_rotation(mctr1,
    (0.0)*DEG2RAD,
    (0.0)*DEG2RAD,
    (0.0)*DEG2RAD);
#line 112702 "MACS_sample_kidney_box.c"
  rot_mul(mctr1, mcrotakidney_channel_6, mcrotachannel_6_analyzer_1_center);
  rot_transpose(mcrotachannel_6_cave1_cyl1, mctr1);
  rot_mul(mcrotachannel_6_analyzer_1_center, mctr1, mcrotrchannel_6_analyzer_1_center);
  mctc1 = coords_set(
#line 1843 "MACS_sample_kidney_box.instr"
    0,
#line 1843 "MACS_sample_kidney_box.instr"
    0,
#line 1843 "MACS_sample_kidney_box.instr"
    analyzer_1_center_to_sample);
#line 112713 "MACS_sample_kidney_box.c"
  rot_transpose(mcrotakidney_channel_6, mctr1);
  mctc2 = rot_apply(mctr1, mctc1);
  mcposachannel_6_analyzer_1_center = coords_add(mcposakidney_channel_6, mctc2);
  mctc1 = coords_sub(mcposachannel_6_cave1_cyl1, mcposachannel_6_analyzer_1_center);
  mcposrchannel_6_analyzer_1_center = rot_apply(mcrotachannel_6_analyzer_1_center, mctc1);
  mcDEBUG_COMPONENT("channel_6_analyzer_1_center", mcposachannel_6_analyzer_1_center, mcrotachannel_6_analyzer_1_center)
  mccomp_posa[356] = mcposachannel_6_analyzer_1_center;
  mccomp_posr[356] = mcposrchannel_6_analyzer_1_center;
  mcNCounter[356]  = mcPCounter[356] = mcP2Counter[356] = 0;
  mcAbsorbProp[356]= 0;
    /* Component channel_6_analyzer_1_rotated. */
  /* Setting parameters for component channel_6_analyzer_1_rotated. */
  SIG_MESSAGE("channel_6_analyzer_1_rotated (Init:SetPar)");

  SIG_MESSAGE("channel_6_analyzer_1_rotated (Init:Place/Rotate)");
  rot_set_rotation(mctr1,
#line 1847 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 1847 "MACS_sample_kidney_box.instr"
    (180 - analyzer_theta [ 6 ])*DEG2RAD,
#line 1847 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD);
#line 112736 "MACS_sample_kidney_box.c"
  rot_mul(mctr1, mcrotachannel_6_analyzer_1_center, mcrotachannel_6_analyzer_1_rotated);
  rot_transpose(mcrotachannel_6_analyzer_1_center, mctr1);
  rot_mul(mcrotachannel_6_analyzer_1_rotated, mctr1, mcrotrchannel_6_analyzer_1_rotated);
  mctc1 = coords_set(
#line 1846 "MACS_sample_kidney_box.instr"
    0,
#line 1846 "MACS_sample_kidney_box.instr"
    0,
#line 1846 "MACS_sample_kidney_box.instr"
    -0.5 * analyzer_seperation / tan ( analyzer_2theta [ 6 ] * DEG2RAD ));
#line 112747 "MACS_sample_kidney_box.c"
  rot_transpose(mcrotachannel_6_analyzer_1_center, mctr1);
  mctc2 = rot_apply(mctr1, mctc1);
  mcposachannel_6_analyzer_1_rotated = coords_add(mcposachannel_6_analyzer_1_center, mctc2);
  mctc1 = coords_sub(mcposachannel_6_analyzer_1_center, mcposachannel_6_analyzer_1_rotated);
  mcposrchannel_6_analyzer_1_rotated = rot_apply(mcrotachannel_6_analyzer_1_rotated, mctc1);
  mcDEBUG_COMPONENT("channel_6_analyzer_1_rotated", mcposachannel_6_analyzer_1_rotated, mcrotachannel_6_analyzer_1_rotated)
  mccomp_posa[357] = mcposachannel_6_analyzer_1_rotated;
  mccomp_posr[357] = mcposrchannel_6_analyzer_1_rotated;
  mcNCounter[357]  = mcPCounter[357] = mcP2Counter[357] = 0;
  mcAbsorbProp[357]= 0;
    /* Component channel_6_analyzer_1_array_crystal_array_0. */
  /* Setting parameters for component channel_6_analyzer_1_array_crystal_array_0. */
  SIG_MESSAGE("channel_6_analyzer_1_array_crystal_array_0 (Init:SetPar)");
#line 1851 "MACS_sample_kidney_box.instr"
  if("PG_analyzer") strncpy(mccchannel_6_analyzer_1_array_crystal_array_0_material_string, "PG_analyzer" ? "PG_analyzer" : "", 16384); else mccchannel_6_analyzer_1_array_crystal_array_0_material_string[0]='\0';
#line 1851 "MACS_sample_kidney_box.instr"
  mccchannel_6_analyzer_1_array_crystal_array_0_priority = 820.0;
#line 1850 "MACS_sample_kidney_box.instr"
  mccchannel_6_analyzer_1_array_crystal_array_0_xwidth = channel_6_analyzer_1_array_crystal_depth;
#line 1850 "MACS_sample_kidney_box.instr"
  mccchannel_6_analyzer_1_array_crystal_array_0_yheight = channel_6_analyzer_1_array_crystal_height;
#line 1850 "MACS_sample_kidney_box.instr"
  mccchannel_6_analyzer_1_array_crystal_array_0_zdepth = channel_6_analyzer_1_array_crystal_width;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_6_analyzer_1_array_crystal_array_0_xwidth2 = -1;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_6_analyzer_1_array_crystal_array_0_yheight2 = -1;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_6_analyzer_1_array_crystal_array_0_visualize = 1;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_6_analyzer_1_array_crystal_array_0_target_index = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_6_analyzer_1_array_crystal_array_0_target_x = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_6_analyzer_1_array_crystal_array_0_target_y = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_6_analyzer_1_array_crystal_array_0_target_z = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_6_analyzer_1_array_crystal_array_0_focus_aw = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_6_analyzer_1_array_crystal_array_0_focus_ah = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_6_analyzer_1_array_crystal_array_0_focus_xw = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_6_analyzer_1_array_crystal_array_0_focus_xh = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_6_analyzer_1_array_crystal_array_0_focus_r = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_6_analyzer_1_array_crystal_array_0_p_interact = 0;
#line 71 "MACS_sample_kidney_box.instr"
  if(0) strncpy(mccchannel_6_analyzer_1_array_crystal_array_0_mask_string, 0 ? 0 : "", 16384); else mccchannel_6_analyzer_1_array_crystal_array_0_mask_string[0]='\0';
#line 71 "MACS_sample_kidney_box.instr"
  if(0) strncpy(mccchannel_6_analyzer_1_array_crystal_array_0_mask_setting, 0 ? 0 : "", 16384); else mccchannel_6_analyzer_1_array_crystal_array_0_mask_setting[0]='\0';
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_6_analyzer_1_array_crystal_array_0_number_of_activations = 1;
#line 112803 "MACS_sample_kidney_box.c"

  SIG_MESSAGE("channel_6_analyzer_1_array_crystal_array_0 (Init:Place/Rotate)");
  rot_set_rotation(mctr1,
#line 1853 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 1853 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 1853 "MACS_sample_kidney_box.instr"
    (0 - RAD2DEG * channel_6_analyzer_1_array_theta [ 0 ])*DEG2RAD);
#line 112813 "MACS_sample_kidney_box.c"
  rot_mul(mctr1, mcrotachannel_6_analyzer_1_rotated, mcrotachannel_6_analyzer_1_array_crystal_array_0);
  rot_transpose(mcrotachannel_6_analyzer_1_rotated, mctr1);
  rot_mul(mcrotachannel_6_analyzer_1_array_crystal_array_0, mctr1, mcrotrchannel_6_analyzer_1_array_crystal_array_0);
  mctc1 = coords_set(
#line 1852 "MACS_sample_kidney_box.instr"
    0 + channel_6_analyzer_1_array_effective_radius_of_curvature * ( 1 - cos ( channel_6_analyzer_1_array_theta [ 0 ] ) ),
#line 1852 "MACS_sample_kidney_box.instr"
    0 + channel_6_analyzer_1_array_effective_radius_of_curvature * sin ( channel_6_analyzer_1_array_theta [ 0 ] ),
#line 1852 "MACS_sample_kidney_box.instr"
    0);
#line 112824 "MACS_sample_kidney_box.c"
  rot_transpose(mcrotachannel_6_analyzer_1_rotated, mctr1);
  mctc2 = rot_apply(mctr1, mctc1);
  mcposachannel_6_analyzer_1_array_crystal_array_0 = coords_add(mcposachannel_6_analyzer_1_rotated, mctc2);
  mctc1 = coords_sub(mcposachannel_6_analyzer_1_rotated, mcposachannel_6_analyzer_1_array_crystal_array_0);
  mcposrchannel_6_analyzer_1_array_crystal_array_0 = rot_apply(mcrotachannel_6_analyzer_1_array_crystal_array_0, mctc1);
  mcDEBUG_COMPONENT("channel_6_analyzer_1_array_crystal_array_0", mcposachannel_6_analyzer_1_array_crystal_array_0, mcrotachannel_6_analyzer_1_array_crystal_array_0)
  mccomp_posa[358] = mcposachannel_6_analyzer_1_array_crystal_array_0;
  mccomp_posr[358] = mcposrchannel_6_analyzer_1_array_crystal_array_0;
  mcNCounter[358]  = mcPCounter[358] = mcP2Counter[358] = 0;
  mcAbsorbProp[358]= 0;
    /* Component channel_6_analyzer_1_array_crystal_array_1. */
  /* Setting parameters for component channel_6_analyzer_1_array_crystal_array_1. */
  SIG_MESSAGE("channel_6_analyzer_1_array_crystal_array_1 (Init:SetPar)");
#line 1857 "MACS_sample_kidney_box.instr"
  if("PG_analyzer") strncpy(mccchannel_6_analyzer_1_array_crystal_array_1_material_string, "PG_analyzer" ? "PG_analyzer" : "", 16384); else mccchannel_6_analyzer_1_array_crystal_array_1_material_string[0]='\0';
#line 1857 "MACS_sample_kidney_box.instr"
  mccchannel_6_analyzer_1_array_crystal_array_1_priority = 820.1;
#line 1856 "MACS_sample_kidney_box.instr"
  mccchannel_6_analyzer_1_array_crystal_array_1_xwidth = channel_6_analyzer_1_array_crystal_depth;
#line 1856 "MACS_sample_kidney_box.instr"
  mccchannel_6_analyzer_1_array_crystal_array_1_yheight = channel_6_analyzer_1_array_crystal_height;
#line 1856 "MACS_sample_kidney_box.instr"
  mccchannel_6_analyzer_1_array_crystal_array_1_zdepth = channel_6_analyzer_1_array_crystal_width;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_6_analyzer_1_array_crystal_array_1_xwidth2 = -1;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_6_analyzer_1_array_crystal_array_1_yheight2 = -1;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_6_analyzer_1_array_crystal_array_1_visualize = 1;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_6_analyzer_1_array_crystal_array_1_target_index = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_6_analyzer_1_array_crystal_array_1_target_x = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_6_analyzer_1_array_crystal_array_1_target_y = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_6_analyzer_1_array_crystal_array_1_target_z = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_6_analyzer_1_array_crystal_array_1_focus_aw = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_6_analyzer_1_array_crystal_array_1_focus_ah = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_6_analyzer_1_array_crystal_array_1_focus_xw = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_6_analyzer_1_array_crystal_array_1_focus_xh = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_6_analyzer_1_array_crystal_array_1_focus_r = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_6_analyzer_1_array_crystal_array_1_p_interact = 0;
#line 71 "MACS_sample_kidney_box.instr"
  if(0) strncpy(mccchannel_6_analyzer_1_array_crystal_array_1_mask_string, 0 ? 0 : "", 16384); else mccchannel_6_analyzer_1_array_crystal_array_1_mask_string[0]='\0';
#line 71 "MACS_sample_kidney_box.instr"
  if(0) strncpy(mccchannel_6_analyzer_1_array_crystal_array_1_mask_setting, 0 ? 0 : "", 16384); else mccchannel_6_analyzer_1_array_crystal_array_1_mask_setting[0]='\0';
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_6_analyzer_1_array_crystal_array_1_number_of_activations = 1;
#line 112880 "MACS_sample_kidney_box.c"

  SIG_MESSAGE("channel_6_analyzer_1_array_crystal_array_1 (Init:Place/Rotate)");
  rot_set_rotation(mctr1,
#line 1859 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 1859 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 1859 "MACS_sample_kidney_box.instr"
    (0 - RAD2DEG * channel_6_analyzer_1_array_theta [ 1 ])*DEG2RAD);
#line 112890 "MACS_sample_kidney_box.c"
  rot_mul(mctr1, mcrotachannel_6_analyzer_1_rotated, mcrotachannel_6_analyzer_1_array_crystal_array_1);
  rot_transpose(mcrotachannel_6_analyzer_1_array_crystal_array_0, mctr1);
  rot_mul(mcrotachannel_6_analyzer_1_array_crystal_array_1, mctr1, mcrotrchannel_6_analyzer_1_array_crystal_array_1);
  mctc1 = coords_set(
#line 1858 "MACS_sample_kidney_box.instr"
    0 + channel_6_analyzer_1_array_effective_radius_of_curvature * ( 1 - cos ( channel_6_analyzer_1_array_theta [ 1 ] ) ),
#line 1858 "MACS_sample_kidney_box.instr"
    0 + channel_6_analyzer_1_array_effective_radius_of_curvature * sin ( channel_6_analyzer_1_array_theta [ 1 ] ),
#line 1858 "MACS_sample_kidney_box.instr"
    0);
#line 112901 "MACS_sample_kidney_box.c"
  rot_transpose(mcrotachannel_6_analyzer_1_rotated, mctr1);
  mctc2 = rot_apply(mctr1, mctc1);
  mcposachannel_6_analyzer_1_array_crystal_array_1 = coords_add(mcposachannel_6_analyzer_1_rotated, mctc2);
  mctc1 = coords_sub(mcposachannel_6_analyzer_1_array_crystal_array_0, mcposachannel_6_analyzer_1_array_crystal_array_1);
  mcposrchannel_6_analyzer_1_array_crystal_array_1 = rot_apply(mcrotachannel_6_analyzer_1_array_crystal_array_1, mctc1);
  mcDEBUG_COMPONENT("channel_6_analyzer_1_array_crystal_array_1", mcposachannel_6_analyzer_1_array_crystal_array_1, mcrotachannel_6_analyzer_1_array_crystal_array_1)
  mccomp_posa[359] = mcposachannel_6_analyzer_1_array_crystal_array_1;
  mccomp_posr[359] = mcposrchannel_6_analyzer_1_array_crystal_array_1;
  mcNCounter[359]  = mcPCounter[359] = mcP2Counter[359] = 0;
  mcAbsorbProp[359]= 0;
    /* Component channel_6_analyzer_1_array_crystal_array_2. */
  /* Setting parameters for component channel_6_analyzer_1_array_crystal_array_2. */
  SIG_MESSAGE("channel_6_analyzer_1_array_crystal_array_2 (Init:SetPar)");
#line 1863 "MACS_sample_kidney_box.instr"
  if("PG_analyzer") strncpy(mccchannel_6_analyzer_1_array_crystal_array_2_material_string, "PG_analyzer" ? "PG_analyzer" : "", 16384); else mccchannel_6_analyzer_1_array_crystal_array_2_material_string[0]='\0';
#line 1863 "MACS_sample_kidney_box.instr"
  mccchannel_6_analyzer_1_array_crystal_array_2_priority = 820.2;
#line 1862 "MACS_sample_kidney_box.instr"
  mccchannel_6_analyzer_1_array_crystal_array_2_xwidth = channel_6_analyzer_1_array_crystal_depth;
#line 1862 "MACS_sample_kidney_box.instr"
  mccchannel_6_analyzer_1_array_crystal_array_2_yheight = channel_6_analyzer_1_array_crystal_height;
#line 1862 "MACS_sample_kidney_box.instr"
  mccchannel_6_analyzer_1_array_crystal_array_2_zdepth = channel_6_analyzer_1_array_crystal_width;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_6_analyzer_1_array_crystal_array_2_xwidth2 = -1;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_6_analyzer_1_array_crystal_array_2_yheight2 = -1;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_6_analyzer_1_array_crystal_array_2_visualize = 1;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_6_analyzer_1_array_crystal_array_2_target_index = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_6_analyzer_1_array_crystal_array_2_target_x = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_6_analyzer_1_array_crystal_array_2_target_y = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_6_analyzer_1_array_crystal_array_2_target_z = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_6_analyzer_1_array_crystal_array_2_focus_aw = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_6_analyzer_1_array_crystal_array_2_focus_ah = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_6_analyzer_1_array_crystal_array_2_focus_xw = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_6_analyzer_1_array_crystal_array_2_focus_xh = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_6_analyzer_1_array_crystal_array_2_focus_r = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_6_analyzer_1_array_crystal_array_2_p_interact = 0;
#line 71 "MACS_sample_kidney_box.instr"
  if(0) strncpy(mccchannel_6_analyzer_1_array_crystal_array_2_mask_string, 0 ? 0 : "", 16384); else mccchannel_6_analyzer_1_array_crystal_array_2_mask_string[0]='\0';
#line 71 "MACS_sample_kidney_box.instr"
  if(0) strncpy(mccchannel_6_analyzer_1_array_crystal_array_2_mask_setting, 0 ? 0 : "", 16384); else mccchannel_6_analyzer_1_array_crystal_array_2_mask_setting[0]='\0';
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_6_analyzer_1_array_crystal_array_2_number_of_activations = 1;
#line 112957 "MACS_sample_kidney_box.c"

  SIG_MESSAGE("channel_6_analyzer_1_array_crystal_array_2 (Init:Place/Rotate)");
  rot_set_rotation(mctr1,
#line 1865 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 1865 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 1865 "MACS_sample_kidney_box.instr"
    (0 - RAD2DEG * channel_6_analyzer_1_array_theta [ 2 ])*DEG2RAD);
#line 112967 "MACS_sample_kidney_box.c"
  rot_mul(mctr1, mcrotachannel_6_analyzer_1_rotated, mcrotachannel_6_analyzer_1_array_crystal_array_2);
  rot_transpose(mcrotachannel_6_analyzer_1_array_crystal_array_1, mctr1);
  rot_mul(mcrotachannel_6_analyzer_1_array_crystal_array_2, mctr1, mcrotrchannel_6_analyzer_1_array_crystal_array_2);
  mctc1 = coords_set(
#line 1864 "MACS_sample_kidney_box.instr"
    0 + channel_6_analyzer_1_array_effective_radius_of_curvature * ( 1 - cos ( channel_6_analyzer_1_array_theta [ 2 ] ) ),
#line 1864 "MACS_sample_kidney_box.instr"
    0 + channel_6_analyzer_1_array_effective_radius_of_curvature * sin ( channel_6_analyzer_1_array_theta [ 2 ] ),
#line 1864 "MACS_sample_kidney_box.instr"
    0);
#line 112978 "MACS_sample_kidney_box.c"
  rot_transpose(mcrotachannel_6_analyzer_1_rotated, mctr1);
  mctc2 = rot_apply(mctr1, mctc1);
  mcposachannel_6_analyzer_1_array_crystal_array_2 = coords_add(mcposachannel_6_analyzer_1_rotated, mctc2);
  mctc1 = coords_sub(mcposachannel_6_analyzer_1_array_crystal_array_1, mcposachannel_6_analyzer_1_array_crystal_array_2);
  mcposrchannel_6_analyzer_1_array_crystal_array_2 = rot_apply(mcrotachannel_6_analyzer_1_array_crystal_array_2, mctc1);
  mcDEBUG_COMPONENT("channel_6_analyzer_1_array_crystal_array_2", mcposachannel_6_analyzer_1_array_crystal_array_2, mcrotachannel_6_analyzer_1_array_crystal_array_2)
  mccomp_posa[360] = mcposachannel_6_analyzer_1_array_crystal_array_2;
  mccomp_posr[360] = mcposrchannel_6_analyzer_1_array_crystal_array_2;
  mcNCounter[360]  = mcPCounter[360] = mcP2Counter[360] = 0;
  mcAbsorbProp[360]= 0;
    /* Component channel_6_analyzer_1_array_crystal_array_3. */
  /* Setting parameters for component channel_6_analyzer_1_array_crystal_array_3. */
  SIG_MESSAGE("channel_6_analyzer_1_array_crystal_array_3 (Init:SetPar)");
#line 1869 "MACS_sample_kidney_box.instr"
  if("PG_analyzer") strncpy(mccchannel_6_analyzer_1_array_crystal_array_3_material_string, "PG_analyzer" ? "PG_analyzer" : "", 16384); else mccchannel_6_analyzer_1_array_crystal_array_3_material_string[0]='\0';
#line 1869 "MACS_sample_kidney_box.instr"
  mccchannel_6_analyzer_1_array_crystal_array_3_priority = 820.3;
#line 1868 "MACS_sample_kidney_box.instr"
  mccchannel_6_analyzer_1_array_crystal_array_3_xwidth = channel_6_analyzer_1_array_crystal_depth;
#line 1868 "MACS_sample_kidney_box.instr"
  mccchannel_6_analyzer_1_array_crystal_array_3_yheight = channel_6_analyzer_1_array_crystal_height;
#line 1868 "MACS_sample_kidney_box.instr"
  mccchannel_6_analyzer_1_array_crystal_array_3_zdepth = channel_6_analyzer_1_array_crystal_width;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_6_analyzer_1_array_crystal_array_3_xwidth2 = -1;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_6_analyzer_1_array_crystal_array_3_yheight2 = -1;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_6_analyzer_1_array_crystal_array_3_visualize = 1;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_6_analyzer_1_array_crystal_array_3_target_index = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_6_analyzer_1_array_crystal_array_3_target_x = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_6_analyzer_1_array_crystal_array_3_target_y = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_6_analyzer_1_array_crystal_array_3_target_z = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_6_analyzer_1_array_crystal_array_3_focus_aw = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_6_analyzer_1_array_crystal_array_3_focus_ah = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_6_analyzer_1_array_crystal_array_3_focus_xw = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_6_analyzer_1_array_crystal_array_3_focus_xh = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_6_analyzer_1_array_crystal_array_3_focus_r = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_6_analyzer_1_array_crystal_array_3_p_interact = 0;
#line 71 "MACS_sample_kidney_box.instr"
  if(0) strncpy(mccchannel_6_analyzer_1_array_crystal_array_3_mask_string, 0 ? 0 : "", 16384); else mccchannel_6_analyzer_1_array_crystal_array_3_mask_string[0]='\0';
#line 71 "MACS_sample_kidney_box.instr"
  if(0) strncpy(mccchannel_6_analyzer_1_array_crystal_array_3_mask_setting, 0 ? 0 : "", 16384); else mccchannel_6_analyzer_1_array_crystal_array_3_mask_setting[0]='\0';
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_6_analyzer_1_array_crystal_array_3_number_of_activations = 1;
#line 113034 "MACS_sample_kidney_box.c"

  SIG_MESSAGE("channel_6_analyzer_1_array_crystal_array_3 (Init:Place/Rotate)");
  rot_set_rotation(mctr1,
#line 1871 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 1871 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 1871 "MACS_sample_kidney_box.instr"
    (0 - RAD2DEG * channel_6_analyzer_1_array_theta [ 3 ])*DEG2RAD);
#line 113044 "MACS_sample_kidney_box.c"
  rot_mul(mctr1, mcrotachannel_6_analyzer_1_rotated, mcrotachannel_6_analyzer_1_array_crystal_array_3);
  rot_transpose(mcrotachannel_6_analyzer_1_array_crystal_array_2, mctr1);
  rot_mul(mcrotachannel_6_analyzer_1_array_crystal_array_3, mctr1, mcrotrchannel_6_analyzer_1_array_crystal_array_3);
  mctc1 = coords_set(
#line 1870 "MACS_sample_kidney_box.instr"
    0 + channel_6_analyzer_1_array_effective_radius_of_curvature * ( 1 - cos ( channel_6_analyzer_1_array_theta [ 3 ] ) ),
#line 1870 "MACS_sample_kidney_box.instr"
    0 + channel_6_analyzer_1_array_effective_radius_of_curvature * sin ( channel_6_analyzer_1_array_theta [ 3 ] ),
#line 1870 "MACS_sample_kidney_box.instr"
    0);
#line 113055 "MACS_sample_kidney_box.c"
  rot_transpose(mcrotachannel_6_analyzer_1_rotated, mctr1);
  mctc2 = rot_apply(mctr1, mctc1);
  mcposachannel_6_analyzer_1_array_crystal_array_3 = coords_add(mcposachannel_6_analyzer_1_rotated, mctc2);
  mctc1 = coords_sub(mcposachannel_6_analyzer_1_array_crystal_array_2, mcposachannel_6_analyzer_1_array_crystal_array_3);
  mcposrchannel_6_analyzer_1_array_crystal_array_3 = rot_apply(mcrotachannel_6_analyzer_1_array_crystal_array_3, mctc1);
  mcDEBUG_COMPONENT("channel_6_analyzer_1_array_crystal_array_3", mcposachannel_6_analyzer_1_array_crystal_array_3, mcrotachannel_6_analyzer_1_array_crystal_array_3)
  mccomp_posa[361] = mcposachannel_6_analyzer_1_array_crystal_array_3;
  mccomp_posr[361] = mcposrchannel_6_analyzer_1_array_crystal_array_3;
  mcNCounter[361]  = mcPCounter[361] = mcP2Counter[361] = 0;
  mcAbsorbProp[361]= 0;
    /* Component channel_6_analyzer_1_array_crystal_array_4. */
  /* Setting parameters for component channel_6_analyzer_1_array_crystal_array_4. */
  SIG_MESSAGE("channel_6_analyzer_1_array_crystal_array_4 (Init:SetPar)");
#line 1875 "MACS_sample_kidney_box.instr"
  if("PG_analyzer") strncpy(mccchannel_6_analyzer_1_array_crystal_array_4_material_string, "PG_analyzer" ? "PG_analyzer" : "", 16384); else mccchannel_6_analyzer_1_array_crystal_array_4_material_string[0]='\0';
#line 1875 "MACS_sample_kidney_box.instr"
  mccchannel_6_analyzer_1_array_crystal_array_4_priority = 820.4;
#line 1874 "MACS_sample_kidney_box.instr"
  mccchannel_6_analyzer_1_array_crystal_array_4_xwidth = channel_6_analyzer_1_array_crystal_depth;
#line 1874 "MACS_sample_kidney_box.instr"
  mccchannel_6_analyzer_1_array_crystal_array_4_yheight = channel_6_analyzer_1_array_crystal_height;
#line 1874 "MACS_sample_kidney_box.instr"
  mccchannel_6_analyzer_1_array_crystal_array_4_zdepth = channel_6_analyzer_1_array_crystal_width;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_6_analyzer_1_array_crystal_array_4_xwidth2 = -1;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_6_analyzer_1_array_crystal_array_4_yheight2 = -1;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_6_analyzer_1_array_crystal_array_4_visualize = 1;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_6_analyzer_1_array_crystal_array_4_target_index = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_6_analyzer_1_array_crystal_array_4_target_x = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_6_analyzer_1_array_crystal_array_4_target_y = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_6_analyzer_1_array_crystal_array_4_target_z = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_6_analyzer_1_array_crystal_array_4_focus_aw = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_6_analyzer_1_array_crystal_array_4_focus_ah = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_6_analyzer_1_array_crystal_array_4_focus_xw = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_6_analyzer_1_array_crystal_array_4_focus_xh = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_6_analyzer_1_array_crystal_array_4_focus_r = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_6_analyzer_1_array_crystal_array_4_p_interact = 0;
#line 71 "MACS_sample_kidney_box.instr"
  if(0) strncpy(mccchannel_6_analyzer_1_array_crystal_array_4_mask_string, 0 ? 0 : "", 16384); else mccchannel_6_analyzer_1_array_crystal_array_4_mask_string[0]='\0';
#line 71 "MACS_sample_kidney_box.instr"
  if(0) strncpy(mccchannel_6_analyzer_1_array_crystal_array_4_mask_setting, 0 ? 0 : "", 16384); else mccchannel_6_analyzer_1_array_crystal_array_4_mask_setting[0]='\0';
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_6_analyzer_1_array_crystal_array_4_number_of_activations = 1;
#line 113111 "MACS_sample_kidney_box.c"

  SIG_MESSAGE("channel_6_analyzer_1_array_crystal_array_4 (Init:Place/Rotate)");
  rot_set_rotation(mctr1,
#line 1877 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 1877 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 1877 "MACS_sample_kidney_box.instr"
    (0 - RAD2DEG * channel_6_analyzer_1_array_theta [ 4 ])*DEG2RAD);
#line 113121 "MACS_sample_kidney_box.c"
  rot_mul(mctr1, mcrotachannel_6_analyzer_1_rotated, mcrotachannel_6_analyzer_1_array_crystal_array_4);
  rot_transpose(mcrotachannel_6_analyzer_1_array_crystal_array_3, mctr1);
  rot_mul(mcrotachannel_6_analyzer_1_array_crystal_array_4, mctr1, mcrotrchannel_6_analyzer_1_array_crystal_array_4);
  mctc1 = coords_set(
#line 1876 "MACS_sample_kidney_box.instr"
    0 + channel_6_analyzer_1_array_effective_radius_of_curvature * ( 1 - cos ( channel_6_analyzer_1_array_theta [ 4 ] ) ),
#line 1876 "MACS_sample_kidney_box.instr"
    0 + channel_6_analyzer_1_array_effective_radius_of_curvature * sin ( channel_6_analyzer_1_array_theta [ 4 ] ),
#line 1876 "MACS_sample_kidney_box.instr"
    0);
#line 113132 "MACS_sample_kidney_box.c"
  rot_transpose(mcrotachannel_6_analyzer_1_rotated, mctr1);
  mctc2 = rot_apply(mctr1, mctc1);
  mcposachannel_6_analyzer_1_array_crystal_array_4 = coords_add(mcposachannel_6_analyzer_1_rotated, mctc2);
  mctc1 = coords_sub(mcposachannel_6_analyzer_1_array_crystal_array_3, mcposachannel_6_analyzer_1_array_crystal_array_4);
  mcposrchannel_6_analyzer_1_array_crystal_array_4 = rot_apply(mcrotachannel_6_analyzer_1_array_crystal_array_4, mctc1);
  mcDEBUG_COMPONENT("channel_6_analyzer_1_array_crystal_array_4", mcposachannel_6_analyzer_1_array_crystal_array_4, mcrotachannel_6_analyzer_1_array_crystal_array_4)
  mccomp_posa[362] = mcposachannel_6_analyzer_1_array_crystal_array_4;
  mccomp_posr[362] = mcposrchannel_6_analyzer_1_array_crystal_array_4;
  mcNCounter[362]  = mcPCounter[362] = mcP2Counter[362] = 0;
  mcAbsorbProp[362]= 0;
    /* Component channel_6_analyzer_1_array_crystal_array_5. */
  /* Setting parameters for component channel_6_analyzer_1_array_crystal_array_5. */
  SIG_MESSAGE("channel_6_analyzer_1_array_crystal_array_5 (Init:SetPar)");
#line 1881 "MACS_sample_kidney_box.instr"
  if("PG_analyzer") strncpy(mccchannel_6_analyzer_1_array_crystal_array_5_material_string, "PG_analyzer" ? "PG_analyzer" : "", 16384); else mccchannel_6_analyzer_1_array_crystal_array_5_material_string[0]='\0';
#line 1881 "MACS_sample_kidney_box.instr"
  mccchannel_6_analyzer_1_array_crystal_array_5_priority = 820.5;
#line 1880 "MACS_sample_kidney_box.instr"
  mccchannel_6_analyzer_1_array_crystal_array_5_xwidth = channel_6_analyzer_1_array_crystal_depth;
#line 1880 "MACS_sample_kidney_box.instr"
  mccchannel_6_analyzer_1_array_crystal_array_5_yheight = channel_6_analyzer_1_array_crystal_height;
#line 1880 "MACS_sample_kidney_box.instr"
  mccchannel_6_analyzer_1_array_crystal_array_5_zdepth = channel_6_analyzer_1_array_crystal_width;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_6_analyzer_1_array_crystal_array_5_xwidth2 = -1;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_6_analyzer_1_array_crystal_array_5_yheight2 = -1;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_6_analyzer_1_array_crystal_array_5_visualize = 1;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_6_analyzer_1_array_crystal_array_5_target_index = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_6_analyzer_1_array_crystal_array_5_target_x = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_6_analyzer_1_array_crystal_array_5_target_y = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_6_analyzer_1_array_crystal_array_5_target_z = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_6_analyzer_1_array_crystal_array_5_focus_aw = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_6_analyzer_1_array_crystal_array_5_focus_ah = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_6_analyzer_1_array_crystal_array_5_focus_xw = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_6_analyzer_1_array_crystal_array_5_focus_xh = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_6_analyzer_1_array_crystal_array_5_focus_r = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_6_analyzer_1_array_crystal_array_5_p_interact = 0;
#line 71 "MACS_sample_kidney_box.instr"
  if(0) strncpy(mccchannel_6_analyzer_1_array_crystal_array_5_mask_string, 0 ? 0 : "", 16384); else mccchannel_6_analyzer_1_array_crystal_array_5_mask_string[0]='\0';
#line 71 "MACS_sample_kidney_box.instr"
  if(0) strncpy(mccchannel_6_analyzer_1_array_crystal_array_5_mask_setting, 0 ? 0 : "", 16384); else mccchannel_6_analyzer_1_array_crystal_array_5_mask_setting[0]='\0';
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_6_analyzer_1_array_crystal_array_5_number_of_activations = 1;
#line 113188 "MACS_sample_kidney_box.c"

  SIG_MESSAGE("channel_6_analyzer_1_array_crystal_array_5 (Init:Place/Rotate)");
  rot_set_rotation(mctr1,
#line 1883 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 1883 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 1883 "MACS_sample_kidney_box.instr"
    (0 - RAD2DEG * channel_6_analyzer_1_array_theta [ 5 ])*DEG2RAD);
#line 113198 "MACS_sample_kidney_box.c"
  rot_mul(mctr1, mcrotachannel_6_analyzer_1_rotated, mcrotachannel_6_analyzer_1_array_crystal_array_5);
  rot_transpose(mcrotachannel_6_analyzer_1_array_crystal_array_4, mctr1);
  rot_mul(mcrotachannel_6_analyzer_1_array_crystal_array_5, mctr1, mcrotrchannel_6_analyzer_1_array_crystal_array_5);
  mctc1 = coords_set(
#line 1882 "MACS_sample_kidney_box.instr"
    0 + channel_6_analyzer_1_array_effective_radius_of_curvature * ( 1 - cos ( channel_6_analyzer_1_array_theta [ 5 ] ) ),
#line 1882 "MACS_sample_kidney_box.instr"
    0 + channel_6_analyzer_1_array_effective_radius_of_curvature * sin ( channel_6_analyzer_1_array_theta [ 5 ] ),
#line 1882 "MACS_sample_kidney_box.instr"
    0);
#line 113209 "MACS_sample_kidney_box.c"
  rot_transpose(mcrotachannel_6_analyzer_1_rotated, mctr1);
  mctc2 = rot_apply(mctr1, mctc1);
  mcposachannel_6_analyzer_1_array_crystal_array_5 = coords_add(mcposachannel_6_analyzer_1_rotated, mctc2);
  mctc1 = coords_sub(mcposachannel_6_analyzer_1_array_crystal_array_4, mcposachannel_6_analyzer_1_array_crystal_array_5);
  mcposrchannel_6_analyzer_1_array_crystal_array_5 = rot_apply(mcrotachannel_6_analyzer_1_array_crystal_array_5, mctc1);
  mcDEBUG_COMPONENT("channel_6_analyzer_1_array_crystal_array_5", mcposachannel_6_analyzer_1_array_crystal_array_5, mcrotachannel_6_analyzer_1_array_crystal_array_5)
  mccomp_posa[363] = mcposachannel_6_analyzer_1_array_crystal_array_5;
  mccomp_posr[363] = mcposrchannel_6_analyzer_1_array_crystal_array_5;
  mcNCounter[363]  = mcPCounter[363] = mcP2Counter[363] = 0;
  mcAbsorbProp[363]= 0;
    /* Component channel_6_analyzer_1_array_crystal_array_6. */
  /* Setting parameters for component channel_6_analyzer_1_array_crystal_array_6. */
  SIG_MESSAGE("channel_6_analyzer_1_array_crystal_array_6 (Init:SetPar)");
#line 1887 "MACS_sample_kidney_box.instr"
  if("PG_analyzer") strncpy(mccchannel_6_analyzer_1_array_crystal_array_6_material_string, "PG_analyzer" ? "PG_analyzer" : "", 16384); else mccchannel_6_analyzer_1_array_crystal_array_6_material_string[0]='\0';
#line 1887 "MACS_sample_kidney_box.instr"
  mccchannel_6_analyzer_1_array_crystal_array_6_priority = 820.6;
#line 1886 "MACS_sample_kidney_box.instr"
  mccchannel_6_analyzer_1_array_crystal_array_6_xwidth = channel_6_analyzer_1_array_crystal_depth;
#line 1886 "MACS_sample_kidney_box.instr"
  mccchannel_6_analyzer_1_array_crystal_array_6_yheight = channel_6_analyzer_1_array_crystal_height;
#line 1886 "MACS_sample_kidney_box.instr"
  mccchannel_6_analyzer_1_array_crystal_array_6_zdepth = channel_6_analyzer_1_array_crystal_width;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_6_analyzer_1_array_crystal_array_6_xwidth2 = -1;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_6_analyzer_1_array_crystal_array_6_yheight2 = -1;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_6_analyzer_1_array_crystal_array_6_visualize = 1;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_6_analyzer_1_array_crystal_array_6_target_index = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_6_analyzer_1_array_crystal_array_6_target_x = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_6_analyzer_1_array_crystal_array_6_target_y = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_6_analyzer_1_array_crystal_array_6_target_z = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_6_analyzer_1_array_crystal_array_6_focus_aw = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_6_analyzer_1_array_crystal_array_6_focus_ah = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_6_analyzer_1_array_crystal_array_6_focus_xw = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_6_analyzer_1_array_crystal_array_6_focus_xh = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_6_analyzer_1_array_crystal_array_6_focus_r = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_6_analyzer_1_array_crystal_array_6_p_interact = 0;
#line 71 "MACS_sample_kidney_box.instr"
  if(0) strncpy(mccchannel_6_analyzer_1_array_crystal_array_6_mask_string, 0 ? 0 : "", 16384); else mccchannel_6_analyzer_1_array_crystal_array_6_mask_string[0]='\0';
#line 71 "MACS_sample_kidney_box.instr"
  if(0) strncpy(mccchannel_6_analyzer_1_array_crystal_array_6_mask_setting, 0 ? 0 : "", 16384); else mccchannel_6_analyzer_1_array_crystal_array_6_mask_setting[0]='\0';
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_6_analyzer_1_array_crystal_array_6_number_of_activations = 1;
#line 113265 "MACS_sample_kidney_box.c"

  SIG_MESSAGE("channel_6_analyzer_1_array_crystal_array_6 (Init:Place/Rotate)");
  rot_set_rotation(mctr1,
#line 1889 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 1889 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 1889 "MACS_sample_kidney_box.instr"
    (0 - RAD2DEG * channel_6_analyzer_1_array_theta [ 6 ])*DEG2RAD);
#line 113275 "MACS_sample_kidney_box.c"
  rot_mul(mctr1, mcrotachannel_6_analyzer_1_rotated, mcrotachannel_6_analyzer_1_array_crystal_array_6);
  rot_transpose(mcrotachannel_6_analyzer_1_array_crystal_array_5, mctr1);
  rot_mul(mcrotachannel_6_analyzer_1_array_crystal_array_6, mctr1, mcrotrchannel_6_analyzer_1_array_crystal_array_6);
  mctc1 = coords_set(
#line 1888 "MACS_sample_kidney_box.instr"
    0 + channel_6_analyzer_1_array_effective_radius_of_curvature * ( 1 - cos ( channel_6_analyzer_1_array_theta [ 6 ] ) ),
#line 1888 "MACS_sample_kidney_box.instr"
    0 + channel_6_analyzer_1_array_effective_radius_of_curvature * sin ( channel_6_analyzer_1_array_theta [ 6 ] ),
#line 1888 "MACS_sample_kidney_box.instr"
    0);
#line 113286 "MACS_sample_kidney_box.c"
  rot_transpose(mcrotachannel_6_analyzer_1_rotated, mctr1);
  mctc2 = rot_apply(mctr1, mctc1);
  mcposachannel_6_analyzer_1_array_crystal_array_6 = coords_add(mcposachannel_6_analyzer_1_rotated, mctc2);
  mctc1 = coords_sub(mcposachannel_6_analyzer_1_array_crystal_array_5, mcposachannel_6_analyzer_1_array_crystal_array_6);
  mcposrchannel_6_analyzer_1_array_crystal_array_6 = rot_apply(mcrotachannel_6_analyzer_1_array_crystal_array_6, mctc1);
  mcDEBUG_COMPONENT("channel_6_analyzer_1_array_crystal_array_6", mcposachannel_6_analyzer_1_array_crystal_array_6, mcrotachannel_6_analyzer_1_array_crystal_array_6)
  mccomp_posa[364] = mcposachannel_6_analyzer_1_array_crystal_array_6;
  mccomp_posr[364] = mcposrchannel_6_analyzer_1_array_crystal_array_6;
  mcNCounter[364]  = mcPCounter[364] = mcP2Counter[364] = 0;
  mcAbsorbProp[364]= 0;
    /* Component channel_6_analyzer_1_array_crystal_array_7. */
  /* Setting parameters for component channel_6_analyzer_1_array_crystal_array_7. */
  SIG_MESSAGE("channel_6_analyzer_1_array_crystal_array_7 (Init:SetPar)");
#line 1893 "MACS_sample_kidney_box.instr"
  if("PG_analyzer") strncpy(mccchannel_6_analyzer_1_array_crystal_array_7_material_string, "PG_analyzer" ? "PG_analyzer" : "", 16384); else mccchannel_6_analyzer_1_array_crystal_array_7_material_string[0]='\0';
#line 1893 "MACS_sample_kidney_box.instr"
  mccchannel_6_analyzer_1_array_crystal_array_7_priority = 820.7;
#line 1892 "MACS_sample_kidney_box.instr"
  mccchannel_6_analyzer_1_array_crystal_array_7_xwidth = channel_6_analyzer_1_array_crystal_depth;
#line 1892 "MACS_sample_kidney_box.instr"
  mccchannel_6_analyzer_1_array_crystal_array_7_yheight = channel_6_analyzer_1_array_crystal_height;
#line 1892 "MACS_sample_kidney_box.instr"
  mccchannel_6_analyzer_1_array_crystal_array_7_zdepth = channel_6_analyzer_1_array_crystal_width;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_6_analyzer_1_array_crystal_array_7_xwidth2 = -1;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_6_analyzer_1_array_crystal_array_7_yheight2 = -1;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_6_analyzer_1_array_crystal_array_7_visualize = 1;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_6_analyzer_1_array_crystal_array_7_target_index = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_6_analyzer_1_array_crystal_array_7_target_x = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_6_analyzer_1_array_crystal_array_7_target_y = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_6_analyzer_1_array_crystal_array_7_target_z = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_6_analyzer_1_array_crystal_array_7_focus_aw = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_6_analyzer_1_array_crystal_array_7_focus_ah = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_6_analyzer_1_array_crystal_array_7_focus_xw = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_6_analyzer_1_array_crystal_array_7_focus_xh = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_6_analyzer_1_array_crystal_array_7_focus_r = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_6_analyzer_1_array_crystal_array_7_p_interact = 0;
#line 71 "MACS_sample_kidney_box.instr"
  if(0) strncpy(mccchannel_6_analyzer_1_array_crystal_array_7_mask_string, 0 ? 0 : "", 16384); else mccchannel_6_analyzer_1_array_crystal_array_7_mask_string[0]='\0';
#line 71 "MACS_sample_kidney_box.instr"
  if(0) strncpy(mccchannel_6_analyzer_1_array_crystal_array_7_mask_setting, 0 ? 0 : "", 16384); else mccchannel_6_analyzer_1_array_crystal_array_7_mask_setting[0]='\0';
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_6_analyzer_1_array_crystal_array_7_number_of_activations = 1;
#line 113342 "MACS_sample_kidney_box.c"

  SIG_MESSAGE("channel_6_analyzer_1_array_crystal_array_7 (Init:Place/Rotate)");
  rot_set_rotation(mctr1,
#line 1895 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 1895 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 1895 "MACS_sample_kidney_box.instr"
    (0 - RAD2DEG * channel_6_analyzer_1_array_theta [ 7 ])*DEG2RAD);
#line 113352 "MACS_sample_kidney_box.c"
  rot_mul(mctr1, mcrotachannel_6_analyzer_1_rotated, mcrotachannel_6_analyzer_1_array_crystal_array_7);
  rot_transpose(mcrotachannel_6_analyzer_1_array_crystal_array_6, mctr1);
  rot_mul(mcrotachannel_6_analyzer_1_array_crystal_array_7, mctr1, mcrotrchannel_6_analyzer_1_array_crystal_array_7);
  mctc1 = coords_set(
#line 1894 "MACS_sample_kidney_box.instr"
    0 + channel_6_analyzer_1_array_effective_radius_of_curvature * ( 1 - cos ( channel_6_analyzer_1_array_theta [ 7 ] ) ),
#line 1894 "MACS_sample_kidney_box.instr"
    0 + channel_6_analyzer_1_array_effective_radius_of_curvature * sin ( channel_6_analyzer_1_array_theta [ 7 ] ),
#line 1894 "MACS_sample_kidney_box.instr"
    0);
#line 113363 "MACS_sample_kidney_box.c"
  rot_transpose(mcrotachannel_6_analyzer_1_rotated, mctr1);
  mctc2 = rot_apply(mctr1, mctc1);
  mcposachannel_6_analyzer_1_array_crystal_array_7 = coords_add(mcposachannel_6_analyzer_1_rotated, mctc2);
  mctc1 = coords_sub(mcposachannel_6_analyzer_1_array_crystal_array_6, mcposachannel_6_analyzer_1_array_crystal_array_7);
  mcposrchannel_6_analyzer_1_array_crystal_array_7 = rot_apply(mcrotachannel_6_analyzer_1_array_crystal_array_7, mctc1);
  mcDEBUG_COMPONENT("channel_6_analyzer_1_array_crystal_array_7", mcposachannel_6_analyzer_1_array_crystal_array_7, mcrotachannel_6_analyzer_1_array_crystal_array_7)
  mccomp_posa[365] = mcposachannel_6_analyzer_1_array_crystal_array_7;
  mccomp_posr[365] = mcposrchannel_6_analyzer_1_array_crystal_array_7;
  mcNCounter[365]  = mcPCounter[365] = mcP2Counter[365] = 0;
  mcAbsorbProp[365]= 0;
    /* Component channel_6_analyzer_1_array_crystal_array_8. */
  /* Setting parameters for component channel_6_analyzer_1_array_crystal_array_8. */
  SIG_MESSAGE("channel_6_analyzer_1_array_crystal_array_8 (Init:SetPar)");
#line 1899 "MACS_sample_kidney_box.instr"
  if("PG_analyzer") strncpy(mccchannel_6_analyzer_1_array_crystal_array_8_material_string, "PG_analyzer" ? "PG_analyzer" : "", 16384); else mccchannel_6_analyzer_1_array_crystal_array_8_material_string[0]='\0';
#line 1899 "MACS_sample_kidney_box.instr"
  mccchannel_6_analyzer_1_array_crystal_array_8_priority = 820.8;
#line 1898 "MACS_sample_kidney_box.instr"
  mccchannel_6_analyzer_1_array_crystal_array_8_xwidth = channel_6_analyzer_1_array_crystal_depth;
#line 1898 "MACS_sample_kidney_box.instr"
  mccchannel_6_analyzer_1_array_crystal_array_8_yheight = channel_6_analyzer_1_array_crystal_height;
#line 1898 "MACS_sample_kidney_box.instr"
  mccchannel_6_analyzer_1_array_crystal_array_8_zdepth = channel_6_analyzer_1_array_crystal_width;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_6_analyzer_1_array_crystal_array_8_xwidth2 = -1;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_6_analyzer_1_array_crystal_array_8_yheight2 = -1;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_6_analyzer_1_array_crystal_array_8_visualize = 1;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_6_analyzer_1_array_crystal_array_8_target_index = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_6_analyzer_1_array_crystal_array_8_target_x = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_6_analyzer_1_array_crystal_array_8_target_y = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_6_analyzer_1_array_crystal_array_8_target_z = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_6_analyzer_1_array_crystal_array_8_focus_aw = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_6_analyzer_1_array_crystal_array_8_focus_ah = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_6_analyzer_1_array_crystal_array_8_focus_xw = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_6_analyzer_1_array_crystal_array_8_focus_xh = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_6_analyzer_1_array_crystal_array_8_focus_r = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_6_analyzer_1_array_crystal_array_8_p_interact = 0;
#line 71 "MACS_sample_kidney_box.instr"
  if(0) strncpy(mccchannel_6_analyzer_1_array_crystal_array_8_mask_string, 0 ? 0 : "", 16384); else mccchannel_6_analyzer_1_array_crystal_array_8_mask_string[0]='\0';
#line 71 "MACS_sample_kidney_box.instr"
  if(0) strncpy(mccchannel_6_analyzer_1_array_crystal_array_8_mask_setting, 0 ? 0 : "", 16384); else mccchannel_6_analyzer_1_array_crystal_array_8_mask_setting[0]='\0';
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_6_analyzer_1_array_crystal_array_8_number_of_activations = 1;
#line 113419 "MACS_sample_kidney_box.c"

  SIG_MESSAGE("channel_6_analyzer_1_array_crystal_array_8 (Init:Place/Rotate)");
  rot_set_rotation(mctr1,
#line 1901 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 1901 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 1901 "MACS_sample_kidney_box.instr"
    (0 - RAD2DEG * channel_6_analyzer_1_array_theta [ 8 ])*DEG2RAD);
#line 113429 "MACS_sample_kidney_box.c"
  rot_mul(mctr1, mcrotachannel_6_analyzer_1_rotated, mcrotachannel_6_analyzer_1_array_crystal_array_8);
  rot_transpose(mcrotachannel_6_analyzer_1_array_crystal_array_7, mctr1);
  rot_mul(mcrotachannel_6_analyzer_1_array_crystal_array_8, mctr1, mcrotrchannel_6_analyzer_1_array_crystal_array_8);
  mctc1 = coords_set(
#line 1900 "MACS_sample_kidney_box.instr"
    0 + channel_6_analyzer_1_array_effective_radius_of_curvature * ( 1 - cos ( channel_6_analyzer_1_array_theta [ 8 ] ) ),
#line 1900 "MACS_sample_kidney_box.instr"
    0 + channel_6_analyzer_1_array_effective_radius_of_curvature * sin ( channel_6_analyzer_1_array_theta [ 8 ] ),
#line 1900 "MACS_sample_kidney_box.instr"
    0);
#line 113440 "MACS_sample_kidney_box.c"
  rot_transpose(mcrotachannel_6_analyzer_1_rotated, mctr1);
  mctc2 = rot_apply(mctr1, mctc1);
  mcposachannel_6_analyzer_1_array_crystal_array_8 = coords_add(mcposachannel_6_analyzer_1_rotated, mctc2);
  mctc1 = coords_sub(mcposachannel_6_analyzer_1_array_crystal_array_7, mcposachannel_6_analyzer_1_array_crystal_array_8);
  mcposrchannel_6_analyzer_1_array_crystal_array_8 = rot_apply(mcrotachannel_6_analyzer_1_array_crystal_array_8, mctc1);
  mcDEBUG_COMPONENT("channel_6_analyzer_1_array_crystal_array_8", mcposachannel_6_analyzer_1_array_crystal_array_8, mcrotachannel_6_analyzer_1_array_crystal_array_8)
  mccomp_posa[366] = mcposachannel_6_analyzer_1_array_crystal_array_8;
  mccomp_posr[366] = mcposrchannel_6_analyzer_1_array_crystal_array_8;
  mcNCounter[366]  = mcPCounter[366] = mcP2Counter[366] = 0;
  mcAbsorbProp[366]= 0;
    /* Component channel_6_analyzer_2_center. */
  /* Setting parameters for component channel_6_analyzer_2_center. */
  SIG_MESSAGE("channel_6_analyzer_2_center (Init:SetPar)");

  SIG_MESSAGE("channel_6_analyzer_2_center (Init:Place/Rotate)");
  rot_set_rotation(mctr1,
    (0.0)*DEG2RAD,
    (0.0)*DEG2RAD,
    (0.0)*DEG2RAD);
#line 113460 "MACS_sample_kidney_box.c"
  rot_mul(mctr1, mcrotachannel_6_analyzer_1_center, mcrotachannel_6_analyzer_2_center);
  rot_transpose(mcrotachannel_6_analyzer_1_array_crystal_array_8, mctr1);
  rot_mul(mcrotachannel_6_analyzer_2_center, mctr1, mcrotrchannel_6_analyzer_2_center);
  mctc1 = coords_set(
#line 1905 "MACS_sample_kidney_box.instr"
    - analyzer_seperation,
#line 1905 "MACS_sample_kidney_box.instr"
    0,
#line 1905 "MACS_sample_kidney_box.instr"
    0);
#line 113471 "MACS_sample_kidney_box.c"
  rot_transpose(mcrotachannel_6_analyzer_1_center, mctr1);
  mctc2 = rot_apply(mctr1, mctc1);
  mcposachannel_6_analyzer_2_center = coords_add(mcposachannel_6_analyzer_1_center, mctc2);
  mctc1 = coords_sub(mcposachannel_6_analyzer_1_array_crystal_array_8, mcposachannel_6_analyzer_2_center);
  mcposrchannel_6_analyzer_2_center = rot_apply(mcrotachannel_6_analyzer_2_center, mctc1);
  mcDEBUG_COMPONENT("channel_6_analyzer_2_center", mcposachannel_6_analyzer_2_center, mcrotachannel_6_analyzer_2_center)
  mccomp_posa[367] = mcposachannel_6_analyzer_2_center;
  mccomp_posr[367] = mcposrchannel_6_analyzer_2_center;
  mcNCounter[367]  = mcPCounter[367] = mcP2Counter[367] = 0;
  mcAbsorbProp[367]= 0;
    /* Component channel_6_analyzer_2_rotated. */
  /* Setting parameters for component channel_6_analyzer_2_rotated. */
  SIG_MESSAGE("channel_6_analyzer_2_rotated (Init:SetPar)");

  SIG_MESSAGE("channel_6_analyzer_2_rotated (Init:Place/Rotate)");
  rot_set_rotation(mctr1,
#line 1909 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 1909 "MACS_sample_kidney_box.instr"
    (- analyzer_theta [ 6 ])*DEG2RAD,
#line 1909 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD);
#line 113494 "MACS_sample_kidney_box.c"
  rot_mul(mctr1, mcrotachannel_6_analyzer_2_center, mcrotachannel_6_analyzer_2_rotated);
  rot_transpose(mcrotachannel_6_analyzer_2_center, mctr1);
  rot_mul(mcrotachannel_6_analyzer_2_rotated, mctr1, mcrotrchannel_6_analyzer_2_rotated);
  mctc1 = coords_set(
#line 1908 "MACS_sample_kidney_box.instr"
    0,
#line 1908 "MACS_sample_kidney_box.instr"
    0,
#line 1908 "MACS_sample_kidney_box.instr"
    0.5 * analyzer_seperation / tan ( analyzer_2theta [ 6 ] * DEG2RAD ));
#line 113505 "MACS_sample_kidney_box.c"
  rot_transpose(mcrotachannel_6_analyzer_2_center, mctr1);
  mctc2 = rot_apply(mctr1, mctc1);
  mcposachannel_6_analyzer_2_rotated = coords_add(mcposachannel_6_analyzer_2_center, mctc2);
  mctc1 = coords_sub(mcposachannel_6_analyzer_2_center, mcposachannel_6_analyzer_2_rotated);
  mcposrchannel_6_analyzer_2_rotated = rot_apply(mcrotachannel_6_analyzer_2_rotated, mctc1);
  mcDEBUG_COMPONENT("channel_6_analyzer_2_rotated", mcposachannel_6_analyzer_2_rotated, mcrotachannel_6_analyzer_2_rotated)
  mccomp_posa[368] = mcposachannel_6_analyzer_2_rotated;
  mccomp_posr[368] = mcposrchannel_6_analyzer_2_rotated;
  mcNCounter[368]  = mcPCounter[368] = mcP2Counter[368] = 0;
  mcAbsorbProp[368]= 0;
    /* Component channel_6_analyzer_2_array_crystal_array_0. */
  /* Setting parameters for component channel_6_analyzer_2_array_crystal_array_0. */
  SIG_MESSAGE("channel_6_analyzer_2_array_crystal_array_0 (Init:SetPar)");
#line 1913 "MACS_sample_kidney_box.instr"
  if("PG_analyzer") strncpy(mccchannel_6_analyzer_2_array_crystal_array_0_material_string, "PG_analyzer" ? "PG_analyzer" : "", 16384); else mccchannel_6_analyzer_2_array_crystal_array_0_material_string[0]='\0';
#line 1913 "MACS_sample_kidney_box.instr"
  mccchannel_6_analyzer_2_array_crystal_array_0_priority = 821.0;
#line 1912 "MACS_sample_kidney_box.instr"
  mccchannel_6_analyzer_2_array_crystal_array_0_xwidth = channel_6_analyzer_2_array_crystal_depth;
#line 1912 "MACS_sample_kidney_box.instr"
  mccchannel_6_analyzer_2_array_crystal_array_0_yheight = channel_6_analyzer_2_array_crystal_height;
#line 1912 "MACS_sample_kidney_box.instr"
  mccchannel_6_analyzer_2_array_crystal_array_0_zdepth = channel_6_analyzer_2_array_crystal_width;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_6_analyzer_2_array_crystal_array_0_xwidth2 = -1;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_6_analyzer_2_array_crystal_array_0_yheight2 = -1;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_6_analyzer_2_array_crystal_array_0_visualize = 1;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_6_analyzer_2_array_crystal_array_0_target_index = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_6_analyzer_2_array_crystal_array_0_target_x = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_6_analyzer_2_array_crystal_array_0_target_y = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_6_analyzer_2_array_crystal_array_0_target_z = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_6_analyzer_2_array_crystal_array_0_focus_aw = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_6_analyzer_2_array_crystal_array_0_focus_ah = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_6_analyzer_2_array_crystal_array_0_focus_xw = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_6_analyzer_2_array_crystal_array_0_focus_xh = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_6_analyzer_2_array_crystal_array_0_focus_r = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_6_analyzer_2_array_crystal_array_0_p_interact = 0;
#line 71 "MACS_sample_kidney_box.instr"
  if(0) strncpy(mccchannel_6_analyzer_2_array_crystal_array_0_mask_string, 0 ? 0 : "", 16384); else mccchannel_6_analyzer_2_array_crystal_array_0_mask_string[0]='\0';
#line 71 "MACS_sample_kidney_box.instr"
  if(0) strncpy(mccchannel_6_analyzer_2_array_crystal_array_0_mask_setting, 0 ? 0 : "", 16384); else mccchannel_6_analyzer_2_array_crystal_array_0_mask_setting[0]='\0';
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_6_analyzer_2_array_crystal_array_0_number_of_activations = 1;
#line 113561 "MACS_sample_kidney_box.c"

  SIG_MESSAGE("channel_6_analyzer_2_array_crystal_array_0 (Init:Place/Rotate)");
  rot_set_rotation(mctr1,
#line 1915 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 1915 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 1915 "MACS_sample_kidney_box.instr"
    (0 - RAD2DEG * channel_6_analyzer_2_array_theta [ 0 ])*DEG2RAD);
#line 113571 "MACS_sample_kidney_box.c"
  rot_mul(mctr1, mcrotachannel_6_analyzer_2_rotated, mcrotachannel_6_analyzer_2_array_crystal_array_0);
  rot_transpose(mcrotachannel_6_analyzer_2_rotated, mctr1);
  rot_mul(mcrotachannel_6_analyzer_2_array_crystal_array_0, mctr1, mcrotrchannel_6_analyzer_2_array_crystal_array_0);
  mctc1 = coords_set(
#line 1914 "MACS_sample_kidney_box.instr"
    0 + channel_6_analyzer_2_array_effective_radius_of_curvature * ( 1 - cos ( channel_6_analyzer_2_array_theta [ 0 ] ) ),
#line 1914 "MACS_sample_kidney_box.instr"
    0 + channel_6_analyzer_2_array_effective_radius_of_curvature * sin ( channel_6_analyzer_2_array_theta [ 0 ] ),
#line 1914 "MACS_sample_kidney_box.instr"
    0);
#line 113582 "MACS_sample_kidney_box.c"
  rot_transpose(mcrotachannel_6_analyzer_2_rotated, mctr1);
  mctc2 = rot_apply(mctr1, mctc1);
  mcposachannel_6_analyzer_2_array_crystal_array_0 = coords_add(mcposachannel_6_analyzer_2_rotated, mctc2);
  mctc1 = coords_sub(mcposachannel_6_analyzer_2_rotated, mcposachannel_6_analyzer_2_array_crystal_array_0);
  mcposrchannel_6_analyzer_2_array_crystal_array_0 = rot_apply(mcrotachannel_6_analyzer_2_array_crystal_array_0, mctc1);
  mcDEBUG_COMPONENT("channel_6_analyzer_2_array_crystal_array_0", mcposachannel_6_analyzer_2_array_crystal_array_0, mcrotachannel_6_analyzer_2_array_crystal_array_0)
  mccomp_posa[369] = mcposachannel_6_analyzer_2_array_crystal_array_0;
  mccomp_posr[369] = mcposrchannel_6_analyzer_2_array_crystal_array_0;
  mcNCounter[369]  = mcPCounter[369] = mcP2Counter[369] = 0;
  mcAbsorbProp[369]= 0;
    /* Component channel_6_analyzer_2_array_crystal_array_1. */
  /* Setting parameters for component channel_6_analyzer_2_array_crystal_array_1. */
  SIG_MESSAGE("channel_6_analyzer_2_array_crystal_array_1 (Init:SetPar)");
#line 1919 "MACS_sample_kidney_box.instr"
  if("PG_analyzer") strncpy(mccchannel_6_analyzer_2_array_crystal_array_1_material_string, "PG_analyzer" ? "PG_analyzer" : "", 16384); else mccchannel_6_analyzer_2_array_crystal_array_1_material_string[0]='\0';
#line 1919 "MACS_sample_kidney_box.instr"
  mccchannel_6_analyzer_2_array_crystal_array_1_priority = 821.1;
#line 1918 "MACS_sample_kidney_box.instr"
  mccchannel_6_analyzer_2_array_crystal_array_1_xwidth = channel_6_analyzer_2_array_crystal_depth;
#line 1918 "MACS_sample_kidney_box.instr"
  mccchannel_6_analyzer_2_array_crystal_array_1_yheight = channel_6_analyzer_2_array_crystal_height;
#line 1918 "MACS_sample_kidney_box.instr"
  mccchannel_6_analyzer_2_array_crystal_array_1_zdepth = channel_6_analyzer_2_array_crystal_width;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_6_analyzer_2_array_crystal_array_1_xwidth2 = -1;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_6_analyzer_2_array_crystal_array_1_yheight2 = -1;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_6_analyzer_2_array_crystal_array_1_visualize = 1;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_6_analyzer_2_array_crystal_array_1_target_index = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_6_analyzer_2_array_crystal_array_1_target_x = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_6_analyzer_2_array_crystal_array_1_target_y = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_6_analyzer_2_array_crystal_array_1_target_z = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_6_analyzer_2_array_crystal_array_1_focus_aw = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_6_analyzer_2_array_crystal_array_1_focus_ah = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_6_analyzer_2_array_crystal_array_1_focus_xw = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_6_analyzer_2_array_crystal_array_1_focus_xh = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_6_analyzer_2_array_crystal_array_1_focus_r = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_6_analyzer_2_array_crystal_array_1_p_interact = 0;
#line 71 "MACS_sample_kidney_box.instr"
  if(0) strncpy(mccchannel_6_analyzer_2_array_crystal_array_1_mask_string, 0 ? 0 : "", 16384); else mccchannel_6_analyzer_2_array_crystal_array_1_mask_string[0]='\0';
#line 71 "MACS_sample_kidney_box.instr"
  if(0) strncpy(mccchannel_6_analyzer_2_array_crystal_array_1_mask_setting, 0 ? 0 : "", 16384); else mccchannel_6_analyzer_2_array_crystal_array_1_mask_setting[0]='\0';
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_6_analyzer_2_array_crystal_array_1_number_of_activations = 1;
#line 113638 "MACS_sample_kidney_box.c"

  SIG_MESSAGE("channel_6_analyzer_2_array_crystal_array_1 (Init:Place/Rotate)");
  rot_set_rotation(mctr1,
#line 1921 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 1921 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 1921 "MACS_sample_kidney_box.instr"
    (0 - RAD2DEG * channel_6_analyzer_2_array_theta [ 1 ])*DEG2RAD);
#line 113648 "MACS_sample_kidney_box.c"
  rot_mul(mctr1, mcrotachannel_6_analyzer_2_rotated, mcrotachannel_6_analyzer_2_array_crystal_array_1);
  rot_transpose(mcrotachannel_6_analyzer_2_array_crystal_array_0, mctr1);
  rot_mul(mcrotachannel_6_analyzer_2_array_crystal_array_1, mctr1, mcrotrchannel_6_analyzer_2_array_crystal_array_1);
  mctc1 = coords_set(
#line 1920 "MACS_sample_kidney_box.instr"
    0 + channel_6_analyzer_2_array_effective_radius_of_curvature * ( 1 - cos ( channel_6_analyzer_2_array_theta [ 1 ] ) ),
#line 1920 "MACS_sample_kidney_box.instr"
    0 + channel_6_analyzer_2_array_effective_radius_of_curvature * sin ( channel_6_analyzer_2_array_theta [ 1 ] ),
#line 1920 "MACS_sample_kidney_box.instr"
    0);
#line 113659 "MACS_sample_kidney_box.c"
  rot_transpose(mcrotachannel_6_analyzer_2_rotated, mctr1);
  mctc2 = rot_apply(mctr1, mctc1);
  mcposachannel_6_analyzer_2_array_crystal_array_1 = coords_add(mcposachannel_6_analyzer_2_rotated, mctc2);
  mctc1 = coords_sub(mcposachannel_6_analyzer_2_array_crystal_array_0, mcposachannel_6_analyzer_2_array_crystal_array_1);
  mcposrchannel_6_analyzer_2_array_crystal_array_1 = rot_apply(mcrotachannel_6_analyzer_2_array_crystal_array_1, mctc1);
  mcDEBUG_COMPONENT("channel_6_analyzer_2_array_crystal_array_1", mcposachannel_6_analyzer_2_array_crystal_array_1, mcrotachannel_6_analyzer_2_array_crystal_array_1)
  mccomp_posa[370] = mcposachannel_6_analyzer_2_array_crystal_array_1;
  mccomp_posr[370] = mcposrchannel_6_analyzer_2_array_crystal_array_1;
  mcNCounter[370]  = mcPCounter[370] = mcP2Counter[370] = 0;
  mcAbsorbProp[370]= 0;
    /* Component channel_6_analyzer_2_array_crystal_array_2. */
  /* Setting parameters for component channel_6_analyzer_2_array_crystal_array_2. */
  SIG_MESSAGE("channel_6_analyzer_2_array_crystal_array_2 (Init:SetPar)");
#line 1925 "MACS_sample_kidney_box.instr"
  if("PG_analyzer") strncpy(mccchannel_6_analyzer_2_array_crystal_array_2_material_string, "PG_analyzer" ? "PG_analyzer" : "", 16384); else mccchannel_6_analyzer_2_array_crystal_array_2_material_string[0]='\0';
#line 1925 "MACS_sample_kidney_box.instr"
  mccchannel_6_analyzer_2_array_crystal_array_2_priority = 821.2;
#line 1924 "MACS_sample_kidney_box.instr"
  mccchannel_6_analyzer_2_array_crystal_array_2_xwidth = channel_6_analyzer_2_array_crystal_depth;
#line 1924 "MACS_sample_kidney_box.instr"
  mccchannel_6_analyzer_2_array_crystal_array_2_yheight = channel_6_analyzer_2_array_crystal_height;
#line 1924 "MACS_sample_kidney_box.instr"
  mccchannel_6_analyzer_2_array_crystal_array_2_zdepth = channel_6_analyzer_2_array_crystal_width;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_6_analyzer_2_array_crystal_array_2_xwidth2 = -1;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_6_analyzer_2_array_crystal_array_2_yheight2 = -1;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_6_analyzer_2_array_crystal_array_2_visualize = 1;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_6_analyzer_2_array_crystal_array_2_target_index = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_6_analyzer_2_array_crystal_array_2_target_x = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_6_analyzer_2_array_crystal_array_2_target_y = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_6_analyzer_2_array_crystal_array_2_target_z = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_6_analyzer_2_array_crystal_array_2_focus_aw = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_6_analyzer_2_array_crystal_array_2_focus_ah = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_6_analyzer_2_array_crystal_array_2_focus_xw = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_6_analyzer_2_array_crystal_array_2_focus_xh = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_6_analyzer_2_array_crystal_array_2_focus_r = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_6_analyzer_2_array_crystal_array_2_p_interact = 0;
#line 71 "MACS_sample_kidney_box.instr"
  if(0) strncpy(mccchannel_6_analyzer_2_array_crystal_array_2_mask_string, 0 ? 0 : "", 16384); else mccchannel_6_analyzer_2_array_crystal_array_2_mask_string[0]='\0';
#line 71 "MACS_sample_kidney_box.instr"
  if(0) strncpy(mccchannel_6_analyzer_2_array_crystal_array_2_mask_setting, 0 ? 0 : "", 16384); else mccchannel_6_analyzer_2_array_crystal_array_2_mask_setting[0]='\0';
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_6_analyzer_2_array_crystal_array_2_number_of_activations = 1;
#line 113715 "MACS_sample_kidney_box.c"

  SIG_MESSAGE("channel_6_analyzer_2_array_crystal_array_2 (Init:Place/Rotate)");
  rot_set_rotation(mctr1,
#line 1927 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 1927 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 1927 "MACS_sample_kidney_box.instr"
    (0 - RAD2DEG * channel_6_analyzer_2_array_theta [ 2 ])*DEG2RAD);
#line 113725 "MACS_sample_kidney_box.c"
  rot_mul(mctr1, mcrotachannel_6_analyzer_2_rotated, mcrotachannel_6_analyzer_2_array_crystal_array_2);
  rot_transpose(mcrotachannel_6_analyzer_2_array_crystal_array_1, mctr1);
  rot_mul(mcrotachannel_6_analyzer_2_array_crystal_array_2, mctr1, mcrotrchannel_6_analyzer_2_array_crystal_array_2);
  mctc1 = coords_set(
#line 1926 "MACS_sample_kidney_box.instr"
    0 + channel_6_analyzer_2_array_effective_radius_of_curvature * ( 1 - cos ( channel_6_analyzer_2_array_theta [ 2 ] ) ),
#line 1926 "MACS_sample_kidney_box.instr"
    0 + channel_6_analyzer_2_array_effective_radius_of_curvature * sin ( channel_6_analyzer_2_array_theta [ 2 ] ),
#line 1926 "MACS_sample_kidney_box.instr"
    0);
#line 113736 "MACS_sample_kidney_box.c"
  rot_transpose(mcrotachannel_6_analyzer_2_rotated, mctr1);
  mctc2 = rot_apply(mctr1, mctc1);
  mcposachannel_6_analyzer_2_array_crystal_array_2 = coords_add(mcposachannel_6_analyzer_2_rotated, mctc2);
  mctc1 = coords_sub(mcposachannel_6_analyzer_2_array_crystal_array_1, mcposachannel_6_analyzer_2_array_crystal_array_2);
  mcposrchannel_6_analyzer_2_array_crystal_array_2 = rot_apply(mcrotachannel_6_analyzer_2_array_crystal_array_2, mctc1);
  mcDEBUG_COMPONENT("channel_6_analyzer_2_array_crystal_array_2", mcposachannel_6_analyzer_2_array_crystal_array_2, mcrotachannel_6_analyzer_2_array_crystal_array_2)
  mccomp_posa[371] = mcposachannel_6_analyzer_2_array_crystal_array_2;
  mccomp_posr[371] = mcposrchannel_6_analyzer_2_array_crystal_array_2;
  mcNCounter[371]  = mcPCounter[371] = mcP2Counter[371] = 0;
  mcAbsorbProp[371]= 0;
    /* Component channel_6_analyzer_2_array_crystal_array_3. */
  /* Setting parameters for component channel_6_analyzer_2_array_crystal_array_3. */
  SIG_MESSAGE("channel_6_analyzer_2_array_crystal_array_3 (Init:SetPar)");
#line 1931 "MACS_sample_kidney_box.instr"
  if("PG_analyzer") strncpy(mccchannel_6_analyzer_2_array_crystal_array_3_material_string, "PG_analyzer" ? "PG_analyzer" : "", 16384); else mccchannel_6_analyzer_2_array_crystal_array_3_material_string[0]='\0';
#line 1931 "MACS_sample_kidney_box.instr"
  mccchannel_6_analyzer_2_array_crystal_array_3_priority = 821.3;
#line 1930 "MACS_sample_kidney_box.instr"
  mccchannel_6_analyzer_2_array_crystal_array_3_xwidth = channel_6_analyzer_2_array_crystal_depth;
#line 1930 "MACS_sample_kidney_box.instr"
  mccchannel_6_analyzer_2_array_crystal_array_3_yheight = channel_6_analyzer_2_array_crystal_height;
#line 1930 "MACS_sample_kidney_box.instr"
  mccchannel_6_analyzer_2_array_crystal_array_3_zdepth = channel_6_analyzer_2_array_crystal_width;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_6_analyzer_2_array_crystal_array_3_xwidth2 = -1;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_6_analyzer_2_array_crystal_array_3_yheight2 = -1;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_6_analyzer_2_array_crystal_array_3_visualize = 1;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_6_analyzer_2_array_crystal_array_3_target_index = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_6_analyzer_2_array_crystal_array_3_target_x = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_6_analyzer_2_array_crystal_array_3_target_y = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_6_analyzer_2_array_crystal_array_3_target_z = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_6_analyzer_2_array_crystal_array_3_focus_aw = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_6_analyzer_2_array_crystal_array_3_focus_ah = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_6_analyzer_2_array_crystal_array_3_focus_xw = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_6_analyzer_2_array_crystal_array_3_focus_xh = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_6_analyzer_2_array_crystal_array_3_focus_r = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_6_analyzer_2_array_crystal_array_3_p_interact = 0;
#line 71 "MACS_sample_kidney_box.instr"
  if(0) strncpy(mccchannel_6_analyzer_2_array_crystal_array_3_mask_string, 0 ? 0 : "", 16384); else mccchannel_6_analyzer_2_array_crystal_array_3_mask_string[0]='\0';
#line 71 "MACS_sample_kidney_box.instr"
  if(0) strncpy(mccchannel_6_analyzer_2_array_crystal_array_3_mask_setting, 0 ? 0 : "", 16384); else mccchannel_6_analyzer_2_array_crystal_array_3_mask_setting[0]='\0';
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_6_analyzer_2_array_crystal_array_3_number_of_activations = 1;
#line 113792 "MACS_sample_kidney_box.c"

  SIG_MESSAGE("channel_6_analyzer_2_array_crystal_array_3 (Init:Place/Rotate)");
  rot_set_rotation(mctr1,
#line 1933 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 1933 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 1933 "MACS_sample_kidney_box.instr"
    (0 - RAD2DEG * channel_6_analyzer_2_array_theta [ 3 ])*DEG2RAD);
#line 113802 "MACS_sample_kidney_box.c"
  rot_mul(mctr1, mcrotachannel_6_analyzer_2_rotated, mcrotachannel_6_analyzer_2_array_crystal_array_3);
  rot_transpose(mcrotachannel_6_analyzer_2_array_crystal_array_2, mctr1);
  rot_mul(mcrotachannel_6_analyzer_2_array_crystal_array_3, mctr1, mcrotrchannel_6_analyzer_2_array_crystal_array_3);
  mctc1 = coords_set(
#line 1932 "MACS_sample_kidney_box.instr"
    0 + channel_6_analyzer_2_array_effective_radius_of_curvature * ( 1 - cos ( channel_6_analyzer_2_array_theta [ 3 ] ) ),
#line 1932 "MACS_sample_kidney_box.instr"
    0 + channel_6_analyzer_2_array_effective_radius_of_curvature * sin ( channel_6_analyzer_2_array_theta [ 3 ] ),
#line 1932 "MACS_sample_kidney_box.instr"
    0);
#line 113813 "MACS_sample_kidney_box.c"
  rot_transpose(mcrotachannel_6_analyzer_2_rotated, mctr1);
  mctc2 = rot_apply(mctr1, mctc1);
  mcposachannel_6_analyzer_2_array_crystal_array_3 = coords_add(mcposachannel_6_analyzer_2_rotated, mctc2);
  mctc1 = coords_sub(mcposachannel_6_analyzer_2_array_crystal_array_2, mcposachannel_6_analyzer_2_array_crystal_array_3);
  mcposrchannel_6_analyzer_2_array_crystal_array_3 = rot_apply(mcrotachannel_6_analyzer_2_array_crystal_array_3, mctc1);
  mcDEBUG_COMPONENT("channel_6_analyzer_2_array_crystal_array_3", mcposachannel_6_analyzer_2_array_crystal_array_3, mcrotachannel_6_analyzer_2_array_crystal_array_3)
  mccomp_posa[372] = mcposachannel_6_analyzer_2_array_crystal_array_3;
  mccomp_posr[372] = mcposrchannel_6_analyzer_2_array_crystal_array_3;
  mcNCounter[372]  = mcPCounter[372] = mcP2Counter[372] = 0;
  mcAbsorbProp[372]= 0;
    /* Component channel_6_analyzer_2_array_crystal_array_4. */
  /* Setting parameters for component channel_6_analyzer_2_array_crystal_array_4. */
  SIG_MESSAGE("channel_6_analyzer_2_array_crystal_array_4 (Init:SetPar)");
#line 1937 "MACS_sample_kidney_box.instr"
  if("PG_analyzer") strncpy(mccchannel_6_analyzer_2_array_crystal_array_4_material_string, "PG_analyzer" ? "PG_analyzer" : "", 16384); else mccchannel_6_analyzer_2_array_crystal_array_4_material_string[0]='\0';
#line 1937 "MACS_sample_kidney_box.instr"
  mccchannel_6_analyzer_2_array_crystal_array_4_priority = 821.4;
#line 1936 "MACS_sample_kidney_box.instr"
  mccchannel_6_analyzer_2_array_crystal_array_4_xwidth = channel_6_analyzer_2_array_crystal_depth;
#line 1936 "MACS_sample_kidney_box.instr"
  mccchannel_6_analyzer_2_array_crystal_array_4_yheight = channel_6_analyzer_2_array_crystal_height;
#line 1936 "MACS_sample_kidney_box.instr"
  mccchannel_6_analyzer_2_array_crystal_array_4_zdepth = channel_6_analyzer_2_array_crystal_width;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_6_analyzer_2_array_crystal_array_4_xwidth2 = -1;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_6_analyzer_2_array_crystal_array_4_yheight2 = -1;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_6_analyzer_2_array_crystal_array_4_visualize = 1;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_6_analyzer_2_array_crystal_array_4_target_index = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_6_analyzer_2_array_crystal_array_4_target_x = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_6_analyzer_2_array_crystal_array_4_target_y = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_6_analyzer_2_array_crystal_array_4_target_z = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_6_analyzer_2_array_crystal_array_4_focus_aw = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_6_analyzer_2_array_crystal_array_4_focus_ah = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_6_analyzer_2_array_crystal_array_4_focus_xw = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_6_analyzer_2_array_crystal_array_4_focus_xh = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_6_analyzer_2_array_crystal_array_4_focus_r = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_6_analyzer_2_array_crystal_array_4_p_interact = 0;
#line 71 "MACS_sample_kidney_box.instr"
  if(0) strncpy(mccchannel_6_analyzer_2_array_crystal_array_4_mask_string, 0 ? 0 : "", 16384); else mccchannel_6_analyzer_2_array_crystal_array_4_mask_string[0]='\0';
#line 71 "MACS_sample_kidney_box.instr"
  if(0) strncpy(mccchannel_6_analyzer_2_array_crystal_array_4_mask_setting, 0 ? 0 : "", 16384); else mccchannel_6_analyzer_2_array_crystal_array_4_mask_setting[0]='\0';
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_6_analyzer_2_array_crystal_array_4_number_of_activations = 1;
#line 113869 "MACS_sample_kidney_box.c"

  SIG_MESSAGE("channel_6_analyzer_2_array_crystal_array_4 (Init:Place/Rotate)");
  rot_set_rotation(mctr1,
#line 1939 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 1939 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 1939 "MACS_sample_kidney_box.instr"
    (0 - RAD2DEG * channel_6_analyzer_2_array_theta [ 4 ])*DEG2RAD);
#line 113879 "MACS_sample_kidney_box.c"
  rot_mul(mctr1, mcrotachannel_6_analyzer_2_rotated, mcrotachannel_6_analyzer_2_array_crystal_array_4);
  rot_transpose(mcrotachannel_6_analyzer_2_array_crystal_array_3, mctr1);
  rot_mul(mcrotachannel_6_analyzer_2_array_crystal_array_4, mctr1, mcrotrchannel_6_analyzer_2_array_crystal_array_4);
  mctc1 = coords_set(
#line 1938 "MACS_sample_kidney_box.instr"
    0 + channel_6_analyzer_2_array_effective_radius_of_curvature * ( 1 - cos ( channel_6_analyzer_2_array_theta [ 4 ] ) ),
#line 1938 "MACS_sample_kidney_box.instr"
    0 + channel_6_analyzer_2_array_effective_radius_of_curvature * sin ( channel_6_analyzer_2_array_theta [ 4 ] ),
#line 1938 "MACS_sample_kidney_box.instr"
    0);
#line 113890 "MACS_sample_kidney_box.c"
  rot_transpose(mcrotachannel_6_analyzer_2_rotated, mctr1);
  mctc2 = rot_apply(mctr1, mctc1);
  mcposachannel_6_analyzer_2_array_crystal_array_4 = coords_add(mcposachannel_6_analyzer_2_rotated, mctc2);
  mctc1 = coords_sub(mcposachannel_6_analyzer_2_array_crystal_array_3, mcposachannel_6_analyzer_2_array_crystal_array_4);
  mcposrchannel_6_analyzer_2_array_crystal_array_4 = rot_apply(mcrotachannel_6_analyzer_2_array_crystal_array_4, mctc1);
  mcDEBUG_COMPONENT("channel_6_analyzer_2_array_crystal_array_4", mcposachannel_6_analyzer_2_array_crystal_array_4, mcrotachannel_6_analyzer_2_array_crystal_array_4)
  mccomp_posa[373] = mcposachannel_6_analyzer_2_array_crystal_array_4;
  mccomp_posr[373] = mcposrchannel_6_analyzer_2_array_crystal_array_4;
  mcNCounter[373]  = mcPCounter[373] = mcP2Counter[373] = 0;
  mcAbsorbProp[373]= 0;
    /* Component channel_6_analyzer_2_array_crystal_array_5. */
  /* Setting parameters for component channel_6_analyzer_2_array_crystal_array_5. */
  SIG_MESSAGE("channel_6_analyzer_2_array_crystal_array_5 (Init:SetPar)");
#line 1943 "MACS_sample_kidney_box.instr"
  if("PG_analyzer") strncpy(mccchannel_6_analyzer_2_array_crystal_array_5_material_string, "PG_analyzer" ? "PG_analyzer" : "", 16384); else mccchannel_6_analyzer_2_array_crystal_array_5_material_string[0]='\0';
#line 1943 "MACS_sample_kidney_box.instr"
  mccchannel_6_analyzer_2_array_crystal_array_5_priority = 821.5;
#line 1942 "MACS_sample_kidney_box.instr"
  mccchannel_6_analyzer_2_array_crystal_array_5_xwidth = channel_6_analyzer_2_array_crystal_depth;
#line 1942 "MACS_sample_kidney_box.instr"
  mccchannel_6_analyzer_2_array_crystal_array_5_yheight = channel_6_analyzer_2_array_crystal_height;
#line 1942 "MACS_sample_kidney_box.instr"
  mccchannel_6_analyzer_2_array_crystal_array_5_zdepth = channel_6_analyzer_2_array_crystal_width;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_6_analyzer_2_array_crystal_array_5_xwidth2 = -1;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_6_analyzer_2_array_crystal_array_5_yheight2 = -1;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_6_analyzer_2_array_crystal_array_5_visualize = 1;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_6_analyzer_2_array_crystal_array_5_target_index = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_6_analyzer_2_array_crystal_array_5_target_x = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_6_analyzer_2_array_crystal_array_5_target_y = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_6_analyzer_2_array_crystal_array_5_target_z = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_6_analyzer_2_array_crystal_array_5_focus_aw = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_6_analyzer_2_array_crystal_array_5_focus_ah = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_6_analyzer_2_array_crystal_array_5_focus_xw = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_6_analyzer_2_array_crystal_array_5_focus_xh = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_6_analyzer_2_array_crystal_array_5_focus_r = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_6_analyzer_2_array_crystal_array_5_p_interact = 0;
#line 71 "MACS_sample_kidney_box.instr"
  if(0) strncpy(mccchannel_6_analyzer_2_array_crystal_array_5_mask_string, 0 ? 0 : "", 16384); else mccchannel_6_analyzer_2_array_crystal_array_5_mask_string[0]='\0';
#line 71 "MACS_sample_kidney_box.instr"
  if(0) strncpy(mccchannel_6_analyzer_2_array_crystal_array_5_mask_setting, 0 ? 0 : "", 16384); else mccchannel_6_analyzer_2_array_crystal_array_5_mask_setting[0]='\0';
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_6_analyzer_2_array_crystal_array_5_number_of_activations = 1;
#line 113946 "MACS_sample_kidney_box.c"

  SIG_MESSAGE("channel_6_analyzer_2_array_crystal_array_5 (Init:Place/Rotate)");
  rot_set_rotation(mctr1,
#line 1945 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 1945 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 1945 "MACS_sample_kidney_box.instr"
    (0 - RAD2DEG * channel_6_analyzer_2_array_theta [ 5 ])*DEG2RAD);
#line 113956 "MACS_sample_kidney_box.c"
  rot_mul(mctr1, mcrotachannel_6_analyzer_2_rotated, mcrotachannel_6_analyzer_2_array_crystal_array_5);
  rot_transpose(mcrotachannel_6_analyzer_2_array_crystal_array_4, mctr1);
  rot_mul(mcrotachannel_6_analyzer_2_array_crystal_array_5, mctr1, mcrotrchannel_6_analyzer_2_array_crystal_array_5);
  mctc1 = coords_set(
#line 1944 "MACS_sample_kidney_box.instr"
    0 + channel_6_analyzer_2_array_effective_radius_of_curvature * ( 1 - cos ( channel_6_analyzer_2_array_theta [ 5 ] ) ),
#line 1944 "MACS_sample_kidney_box.instr"
    0 + channel_6_analyzer_2_array_effective_radius_of_curvature * sin ( channel_6_analyzer_2_array_theta [ 5 ] ),
#line 1944 "MACS_sample_kidney_box.instr"
    0);
#line 113967 "MACS_sample_kidney_box.c"
  rot_transpose(mcrotachannel_6_analyzer_2_rotated, mctr1);
  mctc2 = rot_apply(mctr1, mctc1);
  mcposachannel_6_analyzer_2_array_crystal_array_5 = coords_add(mcposachannel_6_analyzer_2_rotated, mctc2);
  mctc1 = coords_sub(mcposachannel_6_analyzer_2_array_crystal_array_4, mcposachannel_6_analyzer_2_array_crystal_array_5);
  mcposrchannel_6_analyzer_2_array_crystal_array_5 = rot_apply(mcrotachannel_6_analyzer_2_array_crystal_array_5, mctc1);
  mcDEBUG_COMPONENT("channel_6_analyzer_2_array_crystal_array_5", mcposachannel_6_analyzer_2_array_crystal_array_5, mcrotachannel_6_analyzer_2_array_crystal_array_5)
  mccomp_posa[374] = mcposachannel_6_analyzer_2_array_crystal_array_5;
  mccomp_posr[374] = mcposrchannel_6_analyzer_2_array_crystal_array_5;
  mcNCounter[374]  = mcPCounter[374] = mcP2Counter[374] = 0;
  mcAbsorbProp[374]= 0;
    /* Component channel_6_analyzer_2_array_crystal_array_6. */
  /* Setting parameters for component channel_6_analyzer_2_array_crystal_array_6. */
  SIG_MESSAGE("channel_6_analyzer_2_array_crystal_array_6 (Init:SetPar)");
#line 1949 "MACS_sample_kidney_box.instr"
  if("PG_analyzer") strncpy(mccchannel_6_analyzer_2_array_crystal_array_6_material_string, "PG_analyzer" ? "PG_analyzer" : "", 16384); else mccchannel_6_analyzer_2_array_crystal_array_6_material_string[0]='\0';
#line 1949 "MACS_sample_kidney_box.instr"
  mccchannel_6_analyzer_2_array_crystal_array_6_priority = 821.6;
#line 1948 "MACS_sample_kidney_box.instr"
  mccchannel_6_analyzer_2_array_crystal_array_6_xwidth = channel_6_analyzer_2_array_crystal_depth;
#line 1948 "MACS_sample_kidney_box.instr"
  mccchannel_6_analyzer_2_array_crystal_array_6_yheight = channel_6_analyzer_2_array_crystal_height;
#line 1948 "MACS_sample_kidney_box.instr"
  mccchannel_6_analyzer_2_array_crystal_array_6_zdepth = channel_6_analyzer_2_array_crystal_width;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_6_analyzer_2_array_crystal_array_6_xwidth2 = -1;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_6_analyzer_2_array_crystal_array_6_yheight2 = -1;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_6_analyzer_2_array_crystal_array_6_visualize = 1;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_6_analyzer_2_array_crystal_array_6_target_index = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_6_analyzer_2_array_crystal_array_6_target_x = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_6_analyzer_2_array_crystal_array_6_target_y = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_6_analyzer_2_array_crystal_array_6_target_z = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_6_analyzer_2_array_crystal_array_6_focus_aw = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_6_analyzer_2_array_crystal_array_6_focus_ah = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_6_analyzer_2_array_crystal_array_6_focus_xw = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_6_analyzer_2_array_crystal_array_6_focus_xh = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_6_analyzer_2_array_crystal_array_6_focus_r = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_6_analyzer_2_array_crystal_array_6_p_interact = 0;
#line 71 "MACS_sample_kidney_box.instr"
  if(0) strncpy(mccchannel_6_analyzer_2_array_crystal_array_6_mask_string, 0 ? 0 : "", 16384); else mccchannel_6_analyzer_2_array_crystal_array_6_mask_string[0]='\0';
#line 71 "MACS_sample_kidney_box.instr"
  if(0) strncpy(mccchannel_6_analyzer_2_array_crystal_array_6_mask_setting, 0 ? 0 : "", 16384); else mccchannel_6_analyzer_2_array_crystal_array_6_mask_setting[0]='\0';
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_6_analyzer_2_array_crystal_array_6_number_of_activations = 1;
#line 114023 "MACS_sample_kidney_box.c"

  SIG_MESSAGE("channel_6_analyzer_2_array_crystal_array_6 (Init:Place/Rotate)");
  rot_set_rotation(mctr1,
#line 1951 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 1951 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 1951 "MACS_sample_kidney_box.instr"
    (0 - RAD2DEG * channel_6_analyzer_2_array_theta [ 6 ])*DEG2RAD);
#line 114033 "MACS_sample_kidney_box.c"
  rot_mul(mctr1, mcrotachannel_6_analyzer_2_rotated, mcrotachannel_6_analyzer_2_array_crystal_array_6);
  rot_transpose(mcrotachannel_6_analyzer_2_array_crystal_array_5, mctr1);
  rot_mul(mcrotachannel_6_analyzer_2_array_crystal_array_6, mctr1, mcrotrchannel_6_analyzer_2_array_crystal_array_6);
  mctc1 = coords_set(
#line 1950 "MACS_sample_kidney_box.instr"
    0 + channel_6_analyzer_2_array_effective_radius_of_curvature * ( 1 - cos ( channel_6_analyzer_2_array_theta [ 6 ] ) ),
#line 1950 "MACS_sample_kidney_box.instr"
    0 + channel_6_analyzer_2_array_effective_radius_of_curvature * sin ( channel_6_analyzer_2_array_theta [ 6 ] ),
#line 1950 "MACS_sample_kidney_box.instr"
    0);
#line 114044 "MACS_sample_kidney_box.c"
  rot_transpose(mcrotachannel_6_analyzer_2_rotated, mctr1);
  mctc2 = rot_apply(mctr1, mctc1);
  mcposachannel_6_analyzer_2_array_crystal_array_6 = coords_add(mcposachannel_6_analyzer_2_rotated, mctc2);
  mctc1 = coords_sub(mcposachannel_6_analyzer_2_array_crystal_array_5, mcposachannel_6_analyzer_2_array_crystal_array_6);
  mcposrchannel_6_analyzer_2_array_crystal_array_6 = rot_apply(mcrotachannel_6_analyzer_2_array_crystal_array_6, mctc1);
  mcDEBUG_COMPONENT("channel_6_analyzer_2_array_crystal_array_6", mcposachannel_6_analyzer_2_array_crystal_array_6, mcrotachannel_6_analyzer_2_array_crystal_array_6)
  mccomp_posa[375] = mcposachannel_6_analyzer_2_array_crystal_array_6;
  mccomp_posr[375] = mcposrchannel_6_analyzer_2_array_crystal_array_6;
  mcNCounter[375]  = mcPCounter[375] = mcP2Counter[375] = 0;
  mcAbsorbProp[375]= 0;
    /* Component channel_6_analyzer_2_array_crystal_array_7. */
  /* Setting parameters for component channel_6_analyzer_2_array_crystal_array_7. */
  SIG_MESSAGE("channel_6_analyzer_2_array_crystal_array_7 (Init:SetPar)");
#line 1955 "MACS_sample_kidney_box.instr"
  if("PG_analyzer") strncpy(mccchannel_6_analyzer_2_array_crystal_array_7_material_string, "PG_analyzer" ? "PG_analyzer" : "", 16384); else mccchannel_6_analyzer_2_array_crystal_array_7_material_string[0]='\0';
#line 1955 "MACS_sample_kidney_box.instr"
  mccchannel_6_analyzer_2_array_crystal_array_7_priority = 821.7;
#line 1954 "MACS_sample_kidney_box.instr"
  mccchannel_6_analyzer_2_array_crystal_array_7_xwidth = channel_6_analyzer_2_array_crystal_depth;
#line 1954 "MACS_sample_kidney_box.instr"
  mccchannel_6_analyzer_2_array_crystal_array_7_yheight = channel_6_analyzer_2_array_crystal_height;
#line 1954 "MACS_sample_kidney_box.instr"
  mccchannel_6_analyzer_2_array_crystal_array_7_zdepth = channel_6_analyzer_2_array_crystal_width;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_6_analyzer_2_array_crystal_array_7_xwidth2 = -1;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_6_analyzer_2_array_crystal_array_7_yheight2 = -1;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_6_analyzer_2_array_crystal_array_7_visualize = 1;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_6_analyzer_2_array_crystal_array_7_target_index = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_6_analyzer_2_array_crystal_array_7_target_x = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_6_analyzer_2_array_crystal_array_7_target_y = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_6_analyzer_2_array_crystal_array_7_target_z = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_6_analyzer_2_array_crystal_array_7_focus_aw = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_6_analyzer_2_array_crystal_array_7_focus_ah = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_6_analyzer_2_array_crystal_array_7_focus_xw = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_6_analyzer_2_array_crystal_array_7_focus_xh = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_6_analyzer_2_array_crystal_array_7_focus_r = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_6_analyzer_2_array_crystal_array_7_p_interact = 0;
#line 71 "MACS_sample_kidney_box.instr"
  if(0) strncpy(mccchannel_6_analyzer_2_array_crystal_array_7_mask_string, 0 ? 0 : "", 16384); else mccchannel_6_analyzer_2_array_crystal_array_7_mask_string[0]='\0';
#line 71 "MACS_sample_kidney_box.instr"
  if(0) strncpy(mccchannel_6_analyzer_2_array_crystal_array_7_mask_setting, 0 ? 0 : "", 16384); else mccchannel_6_analyzer_2_array_crystal_array_7_mask_setting[0]='\0';
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_6_analyzer_2_array_crystal_array_7_number_of_activations = 1;
#line 114100 "MACS_sample_kidney_box.c"

  SIG_MESSAGE("channel_6_analyzer_2_array_crystal_array_7 (Init:Place/Rotate)");
  rot_set_rotation(mctr1,
#line 1957 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 1957 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 1957 "MACS_sample_kidney_box.instr"
    (0 - RAD2DEG * channel_6_analyzer_2_array_theta [ 7 ])*DEG2RAD);
#line 114110 "MACS_sample_kidney_box.c"
  rot_mul(mctr1, mcrotachannel_6_analyzer_2_rotated, mcrotachannel_6_analyzer_2_array_crystal_array_7);
  rot_transpose(mcrotachannel_6_analyzer_2_array_crystal_array_6, mctr1);
  rot_mul(mcrotachannel_6_analyzer_2_array_crystal_array_7, mctr1, mcrotrchannel_6_analyzer_2_array_crystal_array_7);
  mctc1 = coords_set(
#line 1956 "MACS_sample_kidney_box.instr"
    0 + channel_6_analyzer_2_array_effective_radius_of_curvature * ( 1 - cos ( channel_6_analyzer_2_array_theta [ 7 ] ) ),
#line 1956 "MACS_sample_kidney_box.instr"
    0 + channel_6_analyzer_2_array_effective_radius_of_curvature * sin ( channel_6_analyzer_2_array_theta [ 7 ] ),
#line 1956 "MACS_sample_kidney_box.instr"
    0);
#line 114121 "MACS_sample_kidney_box.c"
  rot_transpose(mcrotachannel_6_analyzer_2_rotated, mctr1);
  mctc2 = rot_apply(mctr1, mctc1);
  mcposachannel_6_analyzer_2_array_crystal_array_7 = coords_add(mcposachannel_6_analyzer_2_rotated, mctc2);
  mctc1 = coords_sub(mcposachannel_6_analyzer_2_array_crystal_array_6, mcposachannel_6_analyzer_2_array_crystal_array_7);
  mcposrchannel_6_analyzer_2_array_crystal_array_7 = rot_apply(mcrotachannel_6_analyzer_2_array_crystal_array_7, mctc1);
  mcDEBUG_COMPONENT("channel_6_analyzer_2_array_crystal_array_7", mcposachannel_6_analyzer_2_array_crystal_array_7, mcrotachannel_6_analyzer_2_array_crystal_array_7)
  mccomp_posa[376] = mcposachannel_6_analyzer_2_array_crystal_array_7;
  mccomp_posr[376] = mcposrchannel_6_analyzer_2_array_crystal_array_7;
  mcNCounter[376]  = mcPCounter[376] = mcP2Counter[376] = 0;
  mcAbsorbProp[376]= 0;
    /* Component channel_6_analyzer_2_array_crystal_array_8. */
  /* Setting parameters for component channel_6_analyzer_2_array_crystal_array_8. */
  SIG_MESSAGE("channel_6_analyzer_2_array_crystal_array_8 (Init:SetPar)");
#line 1961 "MACS_sample_kidney_box.instr"
  if("PG_analyzer") strncpy(mccchannel_6_analyzer_2_array_crystal_array_8_material_string, "PG_analyzer" ? "PG_analyzer" : "", 16384); else mccchannel_6_analyzer_2_array_crystal_array_8_material_string[0]='\0';
#line 1961 "MACS_sample_kidney_box.instr"
  mccchannel_6_analyzer_2_array_crystal_array_8_priority = 821.8;
#line 1960 "MACS_sample_kidney_box.instr"
  mccchannel_6_analyzer_2_array_crystal_array_8_xwidth = channel_6_analyzer_2_array_crystal_depth;
#line 1960 "MACS_sample_kidney_box.instr"
  mccchannel_6_analyzer_2_array_crystal_array_8_yheight = channel_6_analyzer_2_array_crystal_height;
#line 1960 "MACS_sample_kidney_box.instr"
  mccchannel_6_analyzer_2_array_crystal_array_8_zdepth = channel_6_analyzer_2_array_crystal_width;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_6_analyzer_2_array_crystal_array_8_xwidth2 = -1;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_6_analyzer_2_array_crystal_array_8_yheight2 = -1;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_6_analyzer_2_array_crystal_array_8_visualize = 1;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_6_analyzer_2_array_crystal_array_8_target_index = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_6_analyzer_2_array_crystal_array_8_target_x = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_6_analyzer_2_array_crystal_array_8_target_y = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_6_analyzer_2_array_crystal_array_8_target_z = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_6_analyzer_2_array_crystal_array_8_focus_aw = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_6_analyzer_2_array_crystal_array_8_focus_ah = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_6_analyzer_2_array_crystal_array_8_focus_xw = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_6_analyzer_2_array_crystal_array_8_focus_xh = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_6_analyzer_2_array_crystal_array_8_focus_r = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_6_analyzer_2_array_crystal_array_8_p_interact = 0;
#line 71 "MACS_sample_kidney_box.instr"
  if(0) strncpy(mccchannel_6_analyzer_2_array_crystal_array_8_mask_string, 0 ? 0 : "", 16384); else mccchannel_6_analyzer_2_array_crystal_array_8_mask_string[0]='\0';
#line 71 "MACS_sample_kidney_box.instr"
  if(0) strncpy(mccchannel_6_analyzer_2_array_crystal_array_8_mask_setting, 0 ? 0 : "", 16384); else mccchannel_6_analyzer_2_array_crystal_array_8_mask_setting[0]='\0';
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_6_analyzer_2_array_crystal_array_8_number_of_activations = 1;
#line 114177 "MACS_sample_kidney_box.c"

  SIG_MESSAGE("channel_6_analyzer_2_array_crystal_array_8 (Init:Place/Rotate)");
  rot_set_rotation(mctr1,
#line 1963 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 1963 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 1963 "MACS_sample_kidney_box.instr"
    (0 - RAD2DEG * channel_6_analyzer_2_array_theta [ 8 ])*DEG2RAD);
#line 114187 "MACS_sample_kidney_box.c"
  rot_mul(mctr1, mcrotachannel_6_analyzer_2_rotated, mcrotachannel_6_analyzer_2_array_crystal_array_8);
  rot_transpose(mcrotachannel_6_analyzer_2_array_crystal_array_7, mctr1);
  rot_mul(mcrotachannel_6_analyzer_2_array_crystal_array_8, mctr1, mcrotrchannel_6_analyzer_2_array_crystal_array_8);
  mctc1 = coords_set(
#line 1962 "MACS_sample_kidney_box.instr"
    0 + channel_6_analyzer_2_array_effective_radius_of_curvature * ( 1 - cos ( channel_6_analyzer_2_array_theta [ 8 ] ) ),
#line 1962 "MACS_sample_kidney_box.instr"
    0 + channel_6_analyzer_2_array_effective_radius_of_curvature * sin ( channel_6_analyzer_2_array_theta [ 8 ] ),
#line 1962 "MACS_sample_kidney_box.instr"
    0);
#line 114198 "MACS_sample_kidney_box.c"
  rot_transpose(mcrotachannel_6_analyzer_2_rotated, mctr1);
  mctc2 = rot_apply(mctr1, mctc1);
  mcposachannel_6_analyzer_2_array_crystal_array_8 = coords_add(mcposachannel_6_analyzer_2_rotated, mctc2);
  mctc1 = coords_sub(mcposachannel_6_analyzer_2_array_crystal_array_7, mcposachannel_6_analyzer_2_array_crystal_array_8);
  mcposrchannel_6_analyzer_2_array_crystal_array_8 = rot_apply(mcrotachannel_6_analyzer_2_array_crystal_array_8, mctc1);
  mcDEBUG_COMPONENT("channel_6_analyzer_2_array_crystal_array_8", mcposachannel_6_analyzer_2_array_crystal_array_8, mcrotachannel_6_analyzer_2_array_crystal_array_8)
  mccomp_posa[377] = mcposachannel_6_analyzer_2_array_crystal_array_8;
  mccomp_posr[377] = mcposrchannel_6_analyzer_2_array_crystal_array_8;
  mcNCounter[377]  = mcPCounter[377] = mcP2Counter[377] = 0;
  mcAbsorbProp[377]= 0;
    /* Component channel_6_cave2_cyl1. */
  /* Setting parameters for component channel_6_cave2_cyl1. */
  SIG_MESSAGE("channel_6_cave2_cyl1 (Init:SetPar)");
#line 1968 "MACS_sample_kidney_box.instr"
  if("Vacuum") strncpy(mccchannel_6_cave2_cyl1_material_string, "Vacuum" ? "Vacuum" : "", 16384); else mccchannel_6_cave2_cyl1_material_string[0]='\0';
#line 1968 "MACS_sample_kidney_box.instr"
  mccchannel_6_cave2_cyl1_priority = 807.5;
#line 1967 "MACS_sample_kidney_box.instr"
  mccchannel_6_cave2_cyl1_radius = kidney_cave2_cyl1_radius;
#line 1967 "MACS_sample_kidney_box.instr"
  mccchannel_6_cave2_cyl1_yheight = kidney_cave2_cyl1_height;
#line 67 "MACS_sample_kidney_box.instr"
  mccchannel_6_cave2_cyl1_visualize = 1;
#line 67 "MACS_sample_kidney_box.instr"
  mccchannel_6_cave2_cyl1_target_index = 0;
#line 67 "MACS_sample_kidney_box.instr"
  mccchannel_6_cave2_cyl1_target_x = 0;
#line 67 "MACS_sample_kidney_box.instr"
  mccchannel_6_cave2_cyl1_target_y = 0;
#line 67 "MACS_sample_kidney_box.instr"
  mccchannel_6_cave2_cyl1_target_z = 0;
#line 67 "MACS_sample_kidney_box.instr"
  mccchannel_6_cave2_cyl1_focus_aw = 0;
#line 67 "MACS_sample_kidney_box.instr"
  mccchannel_6_cave2_cyl1_focus_ah = 0;
#line 67 "MACS_sample_kidney_box.instr"
  mccchannel_6_cave2_cyl1_focus_xw = 0;
#line 67 "MACS_sample_kidney_box.instr"
  mccchannel_6_cave2_cyl1_focus_xh = 0;
#line 67 "MACS_sample_kidney_box.instr"
  mccchannel_6_cave2_cyl1_focus_r = 0;
#line 67 "MACS_sample_kidney_box.instr"
  mccchannel_6_cave2_cyl1_p_interact = 0;
#line 67 "MACS_sample_kidney_box.instr"
  if(0) strncpy(mccchannel_6_cave2_cyl1_mask_string, 0 ? 0 : "", 16384); else mccchannel_6_cave2_cyl1_mask_string[0]='\0';
#line 67 "MACS_sample_kidney_box.instr"
  if(0) strncpy(mccchannel_6_cave2_cyl1_mask_setting, 0 ? 0 : "", 16384); else mccchannel_6_cave2_cyl1_mask_setting[0]='\0';
#line 67 "MACS_sample_kidney_box.instr"
  mccchannel_6_cave2_cyl1_number_of_activations = 1;
#line 114248 "MACS_sample_kidney_box.c"

  SIG_MESSAGE("channel_6_cave2_cyl1 (Init:Place/Rotate)");
  rot_set_rotation(mctr1,
#line 1970 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 1970 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 1970 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD);
#line 114258 "MACS_sample_kidney_box.c"
  rot_mul(mctr1, mcrotachannel_6_analyzer_2_center, mcrotachannel_6_cave2_cyl1);
  rot_transpose(mcrotachannel_6_analyzer_2_array_crystal_array_8, mctr1);
  rot_mul(mcrotachannel_6_cave2_cyl1, mctr1, mcrotrchannel_6_cave2_cyl1);
  mctc1 = coords_set(
#line 1969 "MACS_sample_kidney_box.instr"
    0,
#line 1969 "MACS_sample_kidney_box.instr"
    0,
#line 1969 "MACS_sample_kidney_box.instr"
    spec_detector_to_analyzer_2_center);
#line 114269 "MACS_sample_kidney_box.c"
  rot_transpose(mcrotachannel_6_analyzer_2_center, mctr1);
  mctc2 = rot_apply(mctr1, mctc1);
  mcposachannel_6_cave2_cyl1 = coords_add(mcposachannel_6_analyzer_2_center, mctc2);
  mctc1 = coords_sub(mcposachannel_6_analyzer_2_array_crystal_array_8, mcposachannel_6_cave2_cyl1);
  mcposrchannel_6_cave2_cyl1 = rot_apply(mcrotachannel_6_cave2_cyl1, mctc1);
  mcDEBUG_COMPONENT("channel_6_cave2_cyl1", mcposachannel_6_cave2_cyl1, mcrotachannel_6_cave2_cyl1)
  mccomp_posa[378] = mcposachannel_6_cave2_cyl1;
  mccomp_posr[378] = mcposrchannel_6_cave2_cyl1;
  mcNCounter[378]  = mcPCounter[378] = mcP2Counter[378] = 0;
  mcAbsorbProp[378]= 0;
    /* Component channel_6_cave2_box1. */
  /* Setting parameters for component channel_6_cave2_box1. */
  SIG_MESSAGE("channel_6_cave2_box1 (Init:SetPar)");
#line 1975 "MACS_sample_kidney_box.instr"
  if("Vacuum") strncpy(mccchannel_6_cave2_box1_material_string, "Vacuum" ? "Vacuum" : "", 16384); else mccchannel_6_cave2_box1_material_string[0]='\0';
#line 1975 "MACS_sample_kidney_box.instr"
  mccchannel_6_cave2_box1_priority = 801;
#line 1973 "MACS_sample_kidney_box.instr"
  mccchannel_6_cave2_box1_xwidth = kidney_cave2_box1_width1;
#line 1973 "MACS_sample_kidney_box.instr"
  mccchannel_6_cave2_box1_yheight = kidney_cave2_box1_height1;
#line 1973 "MACS_sample_kidney_box.instr"
  mccchannel_6_cave2_box1_zdepth = kidney_cave2_box1_depth;
#line 1974 "MACS_sample_kidney_box.instr"
  mccchannel_6_cave2_box1_xwidth2 = kidney_cave2_box1_width2;
#line 1974 "MACS_sample_kidney_box.instr"
  mccchannel_6_cave2_box1_yheight2 = kidney_cave2_box1_height2;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_6_cave2_box1_visualize = 1;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_6_cave2_box1_target_index = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_6_cave2_box1_target_x = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_6_cave2_box1_target_y = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_6_cave2_box1_target_z = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_6_cave2_box1_focus_aw = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_6_cave2_box1_focus_ah = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_6_cave2_box1_focus_xw = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_6_cave2_box1_focus_xh = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_6_cave2_box1_focus_r = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_6_cave2_box1_p_interact = 0;
#line 71 "MACS_sample_kidney_box.instr"
  if(0) strncpy(mccchannel_6_cave2_box1_mask_string, 0 ? 0 : "", 16384); else mccchannel_6_cave2_box1_mask_string[0]='\0';
#line 71 "MACS_sample_kidney_box.instr"
  if(0) strncpy(mccchannel_6_cave2_box1_mask_setting, 0 ? 0 : "", 16384); else mccchannel_6_cave2_box1_mask_setting[0]='\0';
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_6_cave2_box1_number_of_activations = 1;
#line 114325 "MACS_sample_kidney_box.c"

  SIG_MESSAGE("channel_6_cave2_box1 (Init:Place/Rotate)");
  rot_set_rotation(mctr1,
#line 1977 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 1977 "MACS_sample_kidney_box.instr"
    (kidney_cave2_box1_y_rotation)*DEG2RAD,
#line 1977 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD);
#line 114335 "MACS_sample_kidney_box.c"
  rot_mul(mctr1, mcrotachannel_6_cave2_cyl1, mcrotachannel_6_cave2_box1);
  rot_transpose(mcrotachannel_6_cave2_cyl1, mctr1);
  rot_mul(mcrotachannel_6_cave2_box1, mctr1, mcrotrchannel_6_cave2_box1);
  mctc1 = coords_set(
#line 1976 "MACS_sample_kidney_box.instr"
    kidney_cave2_box1_center_to_spec_detector_x,
#line 1976 "MACS_sample_kidney_box.instr"
    0,
#line 1976 "MACS_sample_kidney_box.instr"
    kidney_cave2_box1_center_to_spec_detector_z);
#line 114346 "MACS_sample_kidney_box.c"
  rot_transpose(mcrotachannel_6_cave2_cyl1, mctr1);
  mctc2 = rot_apply(mctr1, mctc1);
  mcposachannel_6_cave2_box1 = coords_add(mcposachannel_6_cave2_cyl1, mctc2);
  mctc1 = coords_sub(mcposachannel_6_cave2_cyl1, mcposachannel_6_cave2_box1);
  mcposrchannel_6_cave2_box1 = rot_apply(mcrotachannel_6_cave2_box1, mctc1);
  mcDEBUG_COMPONENT("channel_6_cave2_box1", mcposachannel_6_cave2_box1, mcrotachannel_6_cave2_box1)
  mccomp_posa[379] = mcposachannel_6_cave2_box1;
  mccomp_posr[379] = mcposrchannel_6_cave2_box1;
  mcNCounter[379]  = mcPCounter[379] = mcP2Counter[379] = 0;
  mcAbsorbProp[379]= 0;
    /* Component channel_6_cave2_box2. */
  /* Setting parameters for component channel_6_cave2_box2. */
  SIG_MESSAGE("channel_6_cave2_box2 (Init:SetPar)");
#line 1982 "MACS_sample_kidney_box.instr"
  if("Vacuum") strncpy(mccchannel_6_cave2_box2_material_string, "Vacuum" ? "Vacuum" : "", 16384); else mccchannel_6_cave2_box2_material_string[0]='\0';
#line 1982 "MACS_sample_kidney_box.instr"
  mccchannel_6_cave2_box2_priority = 806;
#line 1980 "MACS_sample_kidney_box.instr"
  mccchannel_6_cave2_box2_xwidth = kidney_cave2_box2_width1;
#line 1980 "MACS_sample_kidney_box.instr"
  mccchannel_6_cave2_box2_yheight = kidney_cave2_box2_height1;
#line 1980 "MACS_sample_kidney_box.instr"
  mccchannel_6_cave2_box2_zdepth = kidney_cave2_box2_depth;
#line 1981 "MACS_sample_kidney_box.instr"
  mccchannel_6_cave2_box2_xwidth2 = kidney_cave2_box2_width2;
#line 1981 "MACS_sample_kidney_box.instr"
  mccchannel_6_cave2_box2_yheight2 = kidney_cave2_box2_height2;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_6_cave2_box2_visualize = 1;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_6_cave2_box2_target_index = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_6_cave2_box2_target_x = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_6_cave2_box2_target_y = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_6_cave2_box2_target_z = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_6_cave2_box2_focus_aw = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_6_cave2_box2_focus_ah = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_6_cave2_box2_focus_xw = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_6_cave2_box2_focus_xh = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_6_cave2_box2_focus_r = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_6_cave2_box2_p_interact = 0;
#line 71 "MACS_sample_kidney_box.instr"
  if(0) strncpy(mccchannel_6_cave2_box2_mask_string, 0 ? 0 : "", 16384); else mccchannel_6_cave2_box2_mask_string[0]='\0';
#line 71 "MACS_sample_kidney_box.instr"
  if(0) strncpy(mccchannel_6_cave2_box2_mask_setting, 0 ? 0 : "", 16384); else mccchannel_6_cave2_box2_mask_setting[0]='\0';
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_6_cave2_box2_number_of_activations = 1;
#line 114402 "MACS_sample_kidney_box.c"

  SIG_MESSAGE("channel_6_cave2_box2 (Init:Place/Rotate)");
  rot_set_rotation(mctr1,
#line 1984 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 1984 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 1984 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD);
#line 114412 "MACS_sample_kidney_box.c"
  rot_mul(mctr1, mcrotachannel_6_cave2_cyl1, mcrotachannel_6_cave2_box2);
  rot_transpose(mcrotachannel_6_cave2_box1, mctr1);
  rot_mul(mcrotachannel_6_cave2_box2, mctr1, mcrotrchannel_6_cave2_box2);
  mctc1 = coords_set(
#line 1983 "MACS_sample_kidney_box.instr"
    0,
#line 1983 "MACS_sample_kidney_box.instr"
    0,
#line 1983 "MACS_sample_kidney_box.instr"
    kidney_cave2_box2_center_to_detector);
#line 114423 "MACS_sample_kidney_box.c"
  rot_transpose(mcrotachannel_6_cave2_cyl1, mctr1);
  mctc2 = rot_apply(mctr1, mctc1);
  mcposachannel_6_cave2_box2 = coords_add(mcposachannel_6_cave2_cyl1, mctc2);
  mctc1 = coords_sub(mcposachannel_6_cave2_box1, mcposachannel_6_cave2_box2);
  mcposrchannel_6_cave2_box2 = rot_apply(mcrotachannel_6_cave2_box2, mctc1);
  mcDEBUG_COMPONENT("channel_6_cave2_box2", mcposachannel_6_cave2_box2, mcrotachannel_6_cave2_box2)
  mccomp_posa[380] = mcposachannel_6_cave2_box2;
  mccomp_posr[380] = mcposrchannel_6_cave2_box2;
  mcNCounter[380]  = mcPCounter[380] = mcP2Counter[380] = 0;
  mcAbsorbProp[380]= 0;
    /* Component channel_6_cave2_box3. */
  /* Setting parameters for component channel_6_cave2_box3. */
  SIG_MESSAGE("channel_6_cave2_box3 (Init:SetPar)");
#line 1989 "MACS_sample_kidney_box.instr"
  if("Vacuum") strncpy(mccchannel_6_cave2_box3_material_string, "Vacuum" ? "Vacuum" : "", 16384); else mccchannel_6_cave2_box3_material_string[0]='\0';
#line 1989 "MACS_sample_kidney_box.instr"
  mccchannel_6_cave2_box3_priority = 807;
#line 1987 "MACS_sample_kidney_box.instr"
  mccchannel_6_cave2_box3_xwidth = kidney_cave2_box3_width1;
#line 1987 "MACS_sample_kidney_box.instr"
  mccchannel_6_cave2_box3_yheight = kidney_cave2_box3_height1;
#line 1987 "MACS_sample_kidney_box.instr"
  mccchannel_6_cave2_box3_zdepth = kidney_cave2_box3_depth;
#line 1988 "MACS_sample_kidney_box.instr"
  mccchannel_6_cave2_box3_xwidth2 = kidney_cave2_box3_width2;
#line 1988 "MACS_sample_kidney_box.instr"
  mccchannel_6_cave2_box3_yheight2 = kidney_cave2_box3_height2;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_6_cave2_box3_visualize = 1;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_6_cave2_box3_target_index = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_6_cave2_box3_target_x = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_6_cave2_box3_target_y = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_6_cave2_box3_target_z = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_6_cave2_box3_focus_aw = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_6_cave2_box3_focus_ah = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_6_cave2_box3_focus_xw = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_6_cave2_box3_focus_xh = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_6_cave2_box3_focus_r = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_6_cave2_box3_p_interact = 0;
#line 71 "MACS_sample_kidney_box.instr"
  if(0) strncpy(mccchannel_6_cave2_box3_mask_string, 0 ? 0 : "", 16384); else mccchannel_6_cave2_box3_mask_string[0]='\0';
#line 71 "MACS_sample_kidney_box.instr"
  if(0) strncpy(mccchannel_6_cave2_box3_mask_setting, 0 ? 0 : "", 16384); else mccchannel_6_cave2_box3_mask_setting[0]='\0';
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_6_cave2_box3_number_of_activations = 1;
#line 114479 "MACS_sample_kidney_box.c"

  SIG_MESSAGE("channel_6_cave2_box3 (Init:Place/Rotate)");
  rot_set_rotation(mctr1,
#line 1991 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 1991 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 1991 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD);
#line 114489 "MACS_sample_kidney_box.c"
  rot_mul(mctr1, mcrotachannel_6_cave2_cyl1, mcrotachannel_6_cave2_box3);
  rot_transpose(mcrotachannel_6_cave2_box2, mctr1);
  rot_mul(mcrotachannel_6_cave2_box3, mctr1, mcrotrchannel_6_cave2_box3);
  mctc1 = coords_set(
#line 1990 "MACS_sample_kidney_box.instr"
    0,
#line 1990 "MACS_sample_kidney_box.instr"
    0,
#line 1990 "MACS_sample_kidney_box.instr"
    kidney_cave2_box3_center_to_detector);
#line 114500 "MACS_sample_kidney_box.c"
  rot_transpose(mcrotachannel_6_cave2_cyl1, mctr1);
  mctc2 = rot_apply(mctr1, mctc1);
  mcposachannel_6_cave2_box3 = coords_add(mcposachannel_6_cave2_cyl1, mctc2);
  mctc1 = coords_sub(mcposachannel_6_cave2_box2, mcposachannel_6_cave2_box3);
  mcposrchannel_6_cave2_box3 = rot_apply(mcrotachannel_6_cave2_box3, mctc1);
  mcDEBUG_COMPONENT("channel_6_cave2_box3", mcposachannel_6_cave2_box3, mcrotachannel_6_cave2_box3)
  mccomp_posa[381] = mcposachannel_6_cave2_box3;
  mccomp_posr[381] = mcposrchannel_6_cave2_box3;
  mcNCounter[381]  = mcPCounter[381] = mcP2Counter[381] = 0;
  mcAbsorbProp[381]= 0;
    /* Component inter_analyzer_colimator_center_6. */
  /* Setting parameters for component inter_analyzer_colimator_center_6. */
  SIG_MESSAGE("inter_analyzer_colimator_center_6 (Init:SetPar)");

  SIG_MESSAGE("inter_analyzer_colimator_center_6 (Init:Place/Rotate)");
  rot_set_rotation(mctr1,
#line 1995 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 1995 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 1995 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD);
#line 114523 "MACS_sample_kidney_box.c"
  rot_mul(mctr1, mcrotachannel_6_analyzer_1_center, mcrotainter_analyzer_colimator_center_6);
  rot_transpose(mcrotachannel_6_cave2_box3, mctr1);
  rot_mul(mcrotainter_analyzer_colimator_center_6, mctr1, mcrotrinter_analyzer_colimator_center_6);
  mctc1 = coords_set(
#line 1994 "MACS_sample_kidney_box.instr"
    -0.5 * analyzer_seperation,
#line 1994 "MACS_sample_kidney_box.instr"
    0,
#line 1994 "MACS_sample_kidney_box.instr"
    0);
#line 114534 "MACS_sample_kidney_box.c"
  rot_transpose(mcrotachannel_6_analyzer_1_center, mctr1);
  mctc2 = rot_apply(mctr1, mctc1);
  mcposainter_analyzer_colimator_center_6 = coords_add(mcposachannel_6_analyzer_1_center, mctc2);
  mctc1 = coords_sub(mcposachannel_6_cave2_box3, mcposainter_analyzer_colimator_center_6);
  mcposrinter_analyzer_colimator_center_6 = rot_apply(mcrotainter_analyzer_colimator_center_6, mctc1);
  mcDEBUG_COMPONENT("inter_analyzer_colimator_center_6", mcposainter_analyzer_colimator_center_6, mcrotainter_analyzer_colimator_center_6)
  mccomp_posa[382] = mcposainter_analyzer_colimator_center_6;
  mccomp_posr[382] = mcposrinter_analyzer_colimator_center_6;
  mcNCounter[382]  = mcPCounter[382] = mcP2Counter[382] = 0;
  mcAbsorbProp[382]= 0;
    /* Component inter_analyzer_colimator_6_blade_0. */
  /* Setting parameters for component inter_analyzer_colimator_6_blade_0. */
  SIG_MESSAGE("inter_analyzer_colimator_6_blade_0 (Init:SetPar)");
#line 1999 "MACS_sample_kidney_box.instr"
  if("Collimator_gad") strncpy(mccinter_analyzer_colimator_6_blade_0_material_string, "Collimator_gad" ? "Collimator_gad" : "", 16384); else mccinter_analyzer_colimator_6_blade_0_material_string[0]='\0';
#line 1999 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_6_blade_0_priority = 825;
#line 1998 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_6_blade_0_xwidth = inter_analyzer_colimator_width;
#line 1998 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_6_blade_0_yheight = inter_analyzer_colimator_height;
#line 1998 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_6_blade_0_zdepth = inter_analyzer_colimator_depth;
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_6_blade_0_xwidth2 = -1;
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_6_blade_0_yheight2 = -1;
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_6_blade_0_visualize = 1;
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_6_blade_0_target_index = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_6_blade_0_target_x = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_6_blade_0_target_y = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_6_blade_0_target_z = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_6_blade_0_focus_aw = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_6_blade_0_focus_ah = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_6_blade_0_focus_xw = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_6_blade_0_focus_xh = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_6_blade_0_focus_r = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_6_blade_0_p_interact = 0;
#line 71 "MACS_sample_kidney_box.instr"
  if(0) strncpy(mccinter_analyzer_colimator_6_blade_0_mask_string, 0 ? 0 : "", 16384); else mccinter_analyzer_colimator_6_blade_0_mask_string[0]='\0';
#line 71 "MACS_sample_kidney_box.instr"
  if(0) strncpy(mccinter_analyzer_colimator_6_blade_0_mask_setting, 0 ? 0 : "", 16384); else mccinter_analyzer_colimator_6_blade_0_mask_setting[0]='\0';
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_6_blade_0_number_of_activations = 1;
#line 114590 "MACS_sample_kidney_box.c"

  SIG_MESSAGE("inter_analyzer_colimator_6_blade_0 (Init:Place/Rotate)");
  rot_set_rotation(mctr1,
#line 2001 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 2001 "MACS_sample_kidney_box.instr"
    (- analyzer_2theta [ 6 ])*DEG2RAD,
#line 2001 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD);
#line 114600 "MACS_sample_kidney_box.c"
  rot_mul(mctr1, mcrotainter_analyzer_colimator_center_6, mcrotainter_analyzer_colimator_6_blade_0);
  rot_transpose(mcrotainter_analyzer_colimator_center_6, mctr1);
  rot_mul(mcrotainter_analyzer_colimator_6_blade_0, mctr1, mcrotrinter_analyzer_colimator_6_blade_0);
  mctc1 = coords_set(
#line 2000 "MACS_sample_kidney_box.instr"
    0,
#line 2000 "MACS_sample_kidney_box.instr"
    0,
#line 2000 "MACS_sample_kidney_box.instr"
    inter_analyzer_colimator_start_pos - 0 * inter_analyzer_colimator_seperation);
#line 114611 "MACS_sample_kidney_box.c"
  rot_transpose(mcrotainter_analyzer_colimator_center_6, mctr1);
  mctc2 = rot_apply(mctr1, mctc1);
  mcposainter_analyzer_colimator_6_blade_0 = coords_add(mcposainter_analyzer_colimator_center_6, mctc2);
  mctc1 = coords_sub(mcposainter_analyzer_colimator_center_6, mcposainter_analyzer_colimator_6_blade_0);
  mcposrinter_analyzer_colimator_6_blade_0 = rot_apply(mcrotainter_analyzer_colimator_6_blade_0, mctc1);
  mcDEBUG_COMPONENT("inter_analyzer_colimator_6_blade_0", mcposainter_analyzer_colimator_6_blade_0, mcrotainter_analyzer_colimator_6_blade_0)
  mccomp_posa[383] = mcposainter_analyzer_colimator_6_blade_0;
  mccomp_posr[383] = mcposrinter_analyzer_colimator_6_blade_0;
  mcNCounter[383]  = mcPCounter[383] = mcP2Counter[383] = 0;
  mcAbsorbProp[383]= 0;
    /* Component inter_analyzer_colimator_6_blade_1. */
  /* Setting parameters for component inter_analyzer_colimator_6_blade_1. */
  SIG_MESSAGE("inter_analyzer_colimator_6_blade_1 (Init:SetPar)");
#line 2005 "MACS_sample_kidney_box.instr"
  if("Collimator_gad") strncpy(mccinter_analyzer_colimator_6_blade_1_material_string, "Collimator_gad" ? "Collimator_gad" : "", 16384); else mccinter_analyzer_colimator_6_blade_1_material_string[0]='\0';
#line 2005 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_6_blade_1_priority = 826;
#line 2004 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_6_blade_1_xwidth = inter_analyzer_colimator_width;
#line 2004 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_6_blade_1_yheight = inter_analyzer_colimator_height;
#line 2004 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_6_blade_1_zdepth = inter_analyzer_colimator_depth;
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_6_blade_1_xwidth2 = -1;
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_6_blade_1_yheight2 = -1;
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_6_blade_1_visualize = 1;
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_6_blade_1_target_index = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_6_blade_1_target_x = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_6_blade_1_target_y = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_6_blade_1_target_z = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_6_blade_1_focus_aw = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_6_blade_1_focus_ah = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_6_blade_1_focus_xw = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_6_blade_1_focus_xh = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_6_blade_1_focus_r = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_6_blade_1_p_interact = 0;
#line 71 "MACS_sample_kidney_box.instr"
  if(0) strncpy(mccinter_analyzer_colimator_6_blade_1_mask_string, 0 ? 0 : "", 16384); else mccinter_analyzer_colimator_6_blade_1_mask_string[0]='\0';
#line 71 "MACS_sample_kidney_box.instr"
  if(0) strncpy(mccinter_analyzer_colimator_6_blade_1_mask_setting, 0 ? 0 : "", 16384); else mccinter_analyzer_colimator_6_blade_1_mask_setting[0]='\0';
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_6_blade_1_number_of_activations = 1;
#line 114667 "MACS_sample_kidney_box.c"

  SIG_MESSAGE("inter_analyzer_colimator_6_blade_1 (Init:Place/Rotate)");
  rot_set_rotation(mctr1,
#line 2007 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 2007 "MACS_sample_kidney_box.instr"
    (- analyzer_2theta [ 6 ])*DEG2RAD,
#line 2007 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD);
#line 114677 "MACS_sample_kidney_box.c"
  rot_mul(mctr1, mcrotainter_analyzer_colimator_center_6, mcrotainter_analyzer_colimator_6_blade_1);
  rot_transpose(mcrotainter_analyzer_colimator_6_blade_0, mctr1);
  rot_mul(mcrotainter_analyzer_colimator_6_blade_1, mctr1, mcrotrinter_analyzer_colimator_6_blade_1);
  mctc1 = coords_set(
#line 2006 "MACS_sample_kidney_box.instr"
    0,
#line 2006 "MACS_sample_kidney_box.instr"
    0,
#line 2006 "MACS_sample_kidney_box.instr"
    inter_analyzer_colimator_start_pos - 1 * inter_analyzer_colimator_seperation);
#line 114688 "MACS_sample_kidney_box.c"
  rot_transpose(mcrotainter_analyzer_colimator_center_6, mctr1);
  mctc2 = rot_apply(mctr1, mctc1);
  mcposainter_analyzer_colimator_6_blade_1 = coords_add(mcposainter_analyzer_colimator_center_6, mctc2);
  mctc1 = coords_sub(mcposainter_analyzer_colimator_6_blade_0, mcposainter_analyzer_colimator_6_blade_1);
  mcposrinter_analyzer_colimator_6_blade_1 = rot_apply(mcrotainter_analyzer_colimator_6_blade_1, mctc1);
  mcDEBUG_COMPONENT("inter_analyzer_colimator_6_blade_1", mcposainter_analyzer_colimator_6_blade_1, mcrotainter_analyzer_colimator_6_blade_1)
  mccomp_posa[384] = mcposainter_analyzer_colimator_6_blade_1;
  mccomp_posr[384] = mcposrinter_analyzer_colimator_6_blade_1;
  mcNCounter[384]  = mcPCounter[384] = mcP2Counter[384] = 0;
  mcAbsorbProp[384]= 0;
    /* Component inter_analyzer_colimator_6_blade_2. */
  /* Setting parameters for component inter_analyzer_colimator_6_blade_2. */
  SIG_MESSAGE("inter_analyzer_colimator_6_blade_2 (Init:SetPar)");
#line 2011 "MACS_sample_kidney_box.instr"
  if("Collimator_gad") strncpy(mccinter_analyzer_colimator_6_blade_2_material_string, "Collimator_gad" ? "Collimator_gad" : "", 16384); else mccinter_analyzer_colimator_6_blade_2_material_string[0]='\0';
#line 2011 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_6_blade_2_priority = 827;
#line 2010 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_6_blade_2_xwidth = inter_analyzer_colimator_width;
#line 2010 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_6_blade_2_yheight = inter_analyzer_colimator_height;
#line 2010 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_6_blade_2_zdepth = inter_analyzer_colimator_depth;
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_6_blade_2_xwidth2 = -1;
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_6_blade_2_yheight2 = -1;
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_6_blade_2_visualize = 1;
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_6_blade_2_target_index = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_6_blade_2_target_x = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_6_blade_2_target_y = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_6_blade_2_target_z = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_6_blade_2_focus_aw = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_6_blade_2_focus_ah = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_6_blade_2_focus_xw = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_6_blade_2_focus_xh = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_6_blade_2_focus_r = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_6_blade_2_p_interact = 0;
#line 71 "MACS_sample_kidney_box.instr"
  if(0) strncpy(mccinter_analyzer_colimator_6_blade_2_mask_string, 0 ? 0 : "", 16384); else mccinter_analyzer_colimator_6_blade_2_mask_string[0]='\0';
#line 71 "MACS_sample_kidney_box.instr"
  if(0) strncpy(mccinter_analyzer_colimator_6_blade_2_mask_setting, 0 ? 0 : "", 16384); else mccinter_analyzer_colimator_6_blade_2_mask_setting[0]='\0';
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_6_blade_2_number_of_activations = 1;
#line 114744 "MACS_sample_kidney_box.c"

  SIG_MESSAGE("inter_analyzer_colimator_6_blade_2 (Init:Place/Rotate)");
  rot_set_rotation(mctr1,
#line 2013 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 2013 "MACS_sample_kidney_box.instr"
    (- analyzer_2theta [ 6 ])*DEG2RAD,
#line 2013 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD);
#line 114754 "MACS_sample_kidney_box.c"
  rot_mul(mctr1, mcrotainter_analyzer_colimator_center_6, mcrotainter_analyzer_colimator_6_blade_2);
  rot_transpose(mcrotainter_analyzer_colimator_6_blade_1, mctr1);
  rot_mul(mcrotainter_analyzer_colimator_6_blade_2, mctr1, mcrotrinter_analyzer_colimator_6_blade_2);
  mctc1 = coords_set(
#line 2012 "MACS_sample_kidney_box.instr"
    0,
#line 2012 "MACS_sample_kidney_box.instr"
    0,
#line 2012 "MACS_sample_kidney_box.instr"
    inter_analyzer_colimator_start_pos - 2 * inter_analyzer_colimator_seperation);
#line 114765 "MACS_sample_kidney_box.c"
  rot_transpose(mcrotainter_analyzer_colimator_center_6, mctr1);
  mctc2 = rot_apply(mctr1, mctc1);
  mcposainter_analyzer_colimator_6_blade_2 = coords_add(mcposainter_analyzer_colimator_center_6, mctc2);
  mctc1 = coords_sub(mcposainter_analyzer_colimator_6_blade_1, mcposainter_analyzer_colimator_6_blade_2);
  mcposrinter_analyzer_colimator_6_blade_2 = rot_apply(mcrotainter_analyzer_colimator_6_blade_2, mctc1);
  mcDEBUG_COMPONENT("inter_analyzer_colimator_6_blade_2", mcposainter_analyzer_colimator_6_blade_2, mcrotainter_analyzer_colimator_6_blade_2)
  mccomp_posa[385] = mcposainter_analyzer_colimator_6_blade_2;
  mccomp_posr[385] = mcposrinter_analyzer_colimator_6_blade_2;
  mcNCounter[385]  = mcPCounter[385] = mcP2Counter[385] = 0;
  mcAbsorbProp[385]= 0;
    /* Component inter_analyzer_colimator_6_blade_3. */
  /* Setting parameters for component inter_analyzer_colimator_6_blade_3. */
  SIG_MESSAGE("inter_analyzer_colimator_6_blade_3 (Init:SetPar)");
#line 2017 "MACS_sample_kidney_box.instr"
  if("Collimator_gad") strncpy(mccinter_analyzer_colimator_6_blade_3_material_string, "Collimator_gad" ? "Collimator_gad" : "", 16384); else mccinter_analyzer_colimator_6_blade_3_material_string[0]='\0';
#line 2017 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_6_blade_3_priority = 828;
#line 2016 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_6_blade_3_xwidth = inter_analyzer_colimator_width;
#line 2016 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_6_blade_3_yheight = inter_analyzer_colimator_height;
#line 2016 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_6_blade_3_zdepth = inter_analyzer_colimator_depth;
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_6_blade_3_xwidth2 = -1;
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_6_blade_3_yheight2 = -1;
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_6_blade_3_visualize = 1;
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_6_blade_3_target_index = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_6_blade_3_target_x = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_6_blade_3_target_y = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_6_blade_3_target_z = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_6_blade_3_focus_aw = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_6_blade_3_focus_ah = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_6_blade_3_focus_xw = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_6_blade_3_focus_xh = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_6_blade_3_focus_r = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_6_blade_3_p_interact = 0;
#line 71 "MACS_sample_kidney_box.instr"
  if(0) strncpy(mccinter_analyzer_colimator_6_blade_3_mask_string, 0 ? 0 : "", 16384); else mccinter_analyzer_colimator_6_blade_3_mask_string[0]='\0';
#line 71 "MACS_sample_kidney_box.instr"
  if(0) strncpy(mccinter_analyzer_colimator_6_blade_3_mask_setting, 0 ? 0 : "", 16384); else mccinter_analyzer_colimator_6_blade_3_mask_setting[0]='\0';
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_6_blade_3_number_of_activations = 1;
#line 114821 "MACS_sample_kidney_box.c"

  SIG_MESSAGE("inter_analyzer_colimator_6_blade_3 (Init:Place/Rotate)");
  rot_set_rotation(mctr1,
#line 2019 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 2019 "MACS_sample_kidney_box.instr"
    (- analyzer_2theta [ 6 ])*DEG2RAD,
#line 2019 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD);
#line 114831 "MACS_sample_kidney_box.c"
  rot_mul(mctr1, mcrotainter_analyzer_colimator_center_6, mcrotainter_analyzer_colimator_6_blade_3);
  rot_transpose(mcrotainter_analyzer_colimator_6_blade_2, mctr1);
  rot_mul(mcrotainter_analyzer_colimator_6_blade_3, mctr1, mcrotrinter_analyzer_colimator_6_blade_3);
  mctc1 = coords_set(
#line 2018 "MACS_sample_kidney_box.instr"
    0,
#line 2018 "MACS_sample_kidney_box.instr"
    0,
#line 2018 "MACS_sample_kidney_box.instr"
    inter_analyzer_colimator_start_pos - 3 * inter_analyzer_colimator_seperation);
#line 114842 "MACS_sample_kidney_box.c"
  rot_transpose(mcrotainter_analyzer_colimator_center_6, mctr1);
  mctc2 = rot_apply(mctr1, mctc1);
  mcposainter_analyzer_colimator_6_blade_3 = coords_add(mcposainter_analyzer_colimator_center_6, mctc2);
  mctc1 = coords_sub(mcposainter_analyzer_colimator_6_blade_2, mcposainter_analyzer_colimator_6_blade_3);
  mcposrinter_analyzer_colimator_6_blade_3 = rot_apply(mcrotainter_analyzer_colimator_6_blade_3, mctc1);
  mcDEBUG_COMPONENT("inter_analyzer_colimator_6_blade_3", mcposainter_analyzer_colimator_6_blade_3, mcrotainter_analyzer_colimator_6_blade_3)
  mccomp_posa[386] = mcposainter_analyzer_colimator_6_blade_3;
  mccomp_posr[386] = mcposrinter_analyzer_colimator_6_blade_3;
  mcNCounter[386]  = mcPCounter[386] = mcP2Counter[386] = 0;
  mcAbsorbProp[386]= 0;
    /* Component inter_analyzer_colimator_6_blade_4. */
  /* Setting parameters for component inter_analyzer_colimator_6_blade_4. */
  SIG_MESSAGE("inter_analyzer_colimator_6_blade_4 (Init:SetPar)");
#line 2023 "MACS_sample_kidney_box.instr"
  if("Collimator_gad") strncpy(mccinter_analyzer_colimator_6_blade_4_material_string, "Collimator_gad" ? "Collimator_gad" : "", 16384); else mccinter_analyzer_colimator_6_blade_4_material_string[0]='\0';
#line 2023 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_6_blade_4_priority = 829;
#line 2022 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_6_blade_4_xwidth = inter_analyzer_colimator_width;
#line 2022 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_6_blade_4_yheight = inter_analyzer_colimator_height;
#line 2022 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_6_blade_4_zdepth = inter_analyzer_colimator_depth;
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_6_blade_4_xwidth2 = -1;
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_6_blade_4_yheight2 = -1;
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_6_blade_4_visualize = 1;
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_6_blade_4_target_index = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_6_blade_4_target_x = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_6_blade_4_target_y = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_6_blade_4_target_z = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_6_blade_4_focus_aw = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_6_blade_4_focus_ah = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_6_blade_4_focus_xw = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_6_blade_4_focus_xh = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_6_blade_4_focus_r = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_6_blade_4_p_interact = 0;
#line 71 "MACS_sample_kidney_box.instr"
  if(0) strncpy(mccinter_analyzer_colimator_6_blade_4_mask_string, 0 ? 0 : "", 16384); else mccinter_analyzer_colimator_6_blade_4_mask_string[0]='\0';
#line 71 "MACS_sample_kidney_box.instr"
  if(0) strncpy(mccinter_analyzer_colimator_6_blade_4_mask_setting, 0 ? 0 : "", 16384); else mccinter_analyzer_colimator_6_blade_4_mask_setting[0]='\0';
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_6_blade_4_number_of_activations = 1;
#line 114898 "MACS_sample_kidney_box.c"

  SIG_MESSAGE("inter_analyzer_colimator_6_blade_4 (Init:Place/Rotate)");
  rot_set_rotation(mctr1,
#line 2025 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 2025 "MACS_sample_kidney_box.instr"
    (- analyzer_2theta [ 6 ])*DEG2RAD,
#line 2025 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD);
#line 114908 "MACS_sample_kidney_box.c"
  rot_mul(mctr1, mcrotainter_analyzer_colimator_center_6, mcrotainter_analyzer_colimator_6_blade_4);
  rot_transpose(mcrotainter_analyzer_colimator_6_blade_3, mctr1);
  rot_mul(mcrotainter_analyzer_colimator_6_blade_4, mctr1, mcrotrinter_analyzer_colimator_6_blade_4);
  mctc1 = coords_set(
#line 2024 "MACS_sample_kidney_box.instr"
    0,
#line 2024 "MACS_sample_kidney_box.instr"
    0,
#line 2024 "MACS_sample_kidney_box.instr"
    inter_analyzer_colimator_start_pos - 4 * inter_analyzer_colimator_seperation);
#line 114919 "MACS_sample_kidney_box.c"
  rot_transpose(mcrotainter_analyzer_colimator_center_6, mctr1);
  mctc2 = rot_apply(mctr1, mctc1);
  mcposainter_analyzer_colimator_6_blade_4 = coords_add(mcposainter_analyzer_colimator_center_6, mctc2);
  mctc1 = coords_sub(mcposainter_analyzer_colimator_6_blade_3, mcposainter_analyzer_colimator_6_blade_4);
  mcposrinter_analyzer_colimator_6_blade_4 = rot_apply(mcrotainter_analyzer_colimator_6_blade_4, mctc1);
  mcDEBUG_COMPONENT("inter_analyzer_colimator_6_blade_4", mcposainter_analyzer_colimator_6_blade_4, mcrotainter_analyzer_colimator_6_blade_4)
  mccomp_posa[387] = mcposainter_analyzer_colimator_6_blade_4;
  mccomp_posr[387] = mcposrinter_analyzer_colimator_6_blade_4;
  mcNCounter[387]  = mcPCounter[387] = mcP2Counter[387] = 0;
  mcAbsorbProp[387]= 0;
    /* Component diffraction_detector_6_exit_volume. */
  /* Setting parameters for component diffraction_detector_6_exit_volume. */
  SIG_MESSAGE("diffraction_detector_6_exit_volume (Init:SetPar)");
#line 2029 "MACS_sample_kidney_box.instr"
  if("Exit") strncpy(mccdiffraction_detector_6_exit_volume_material_string, "Exit" ? "Exit" : "", 16384); else mccdiffraction_detector_6_exit_volume_material_string[0]='\0';
#line 2029 "MACS_sample_kidney_box.instr"
  mccdiffraction_detector_6_exit_volume_priority = 831;
#line 2028 "MACS_sample_kidney_box.instr"
  mccdiffraction_detector_6_exit_volume_xwidth = 2.01 * detector_radius;
#line 2028 "MACS_sample_kidney_box.instr"
  mccdiffraction_detector_6_exit_volume_yheight = 1.01 * detector_height;
#line 2028 "MACS_sample_kidney_box.instr"
  mccdiffraction_detector_6_exit_volume_zdepth = 0.001;
#line 71 "MACS_sample_kidney_box.instr"
  mccdiffraction_detector_6_exit_volume_xwidth2 = -1;
#line 71 "MACS_sample_kidney_box.instr"
  mccdiffraction_detector_6_exit_volume_yheight2 = -1;
#line 71 "MACS_sample_kidney_box.instr"
  mccdiffraction_detector_6_exit_volume_visualize = 1;
#line 71 "MACS_sample_kidney_box.instr"
  mccdiffraction_detector_6_exit_volume_target_index = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccdiffraction_detector_6_exit_volume_target_x = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccdiffraction_detector_6_exit_volume_target_y = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccdiffraction_detector_6_exit_volume_target_z = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccdiffraction_detector_6_exit_volume_focus_aw = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccdiffraction_detector_6_exit_volume_focus_ah = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccdiffraction_detector_6_exit_volume_focus_xw = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccdiffraction_detector_6_exit_volume_focus_xh = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccdiffraction_detector_6_exit_volume_focus_r = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccdiffraction_detector_6_exit_volume_p_interact = 0;
#line 71 "MACS_sample_kidney_box.instr"
  if(0) strncpy(mccdiffraction_detector_6_exit_volume_mask_string, 0 ? 0 : "", 16384); else mccdiffraction_detector_6_exit_volume_mask_string[0]='\0';
#line 71 "MACS_sample_kidney_box.instr"
  if(0) strncpy(mccdiffraction_detector_6_exit_volume_mask_setting, 0 ? 0 : "", 16384); else mccdiffraction_detector_6_exit_volume_mask_setting[0]='\0';
#line 71 "MACS_sample_kidney_box.instr"
  mccdiffraction_detector_6_exit_volume_number_of_activations = 1;
#line 114975 "MACS_sample_kidney_box.c"

  SIG_MESSAGE("diffraction_detector_6_exit_volume (Init:Place/Rotate)");
  rot_set_rotation(mctr1,
#line 2031 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 2031 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 2031 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD);
#line 114985 "MACS_sample_kidney_box.c"
  rot_mul(mctr1, mcrotakidney_channel_6, mcrotadiffraction_detector_6_exit_volume);
  rot_transpose(mcrotainter_analyzer_colimator_6_blade_4, mctr1);
  rot_mul(mcrotadiffraction_detector_6_exit_volume, mctr1, mcrotrdiffraction_detector_6_exit_volume);
  mctc1 = coords_set(
#line 2030 "MACS_sample_kidney_box.instr"
    0,
#line 2030 "MACS_sample_kidney_box.instr"
    0,
#line 2030 "MACS_sample_kidney_box.instr"
    0);
#line 114996 "MACS_sample_kidney_box.c"
  rot_transpose(mcrotachannel_6_cave1_cyl1, mctr1);
  mctc2 = rot_apply(mctr1, mctc1);
  mcposadiffraction_detector_6_exit_volume = coords_add(mcposachannel_6_cave1_cyl1, mctc2);
  mctc1 = coords_sub(mcposainter_analyzer_colimator_6_blade_4, mcposadiffraction_detector_6_exit_volume);
  mcposrdiffraction_detector_6_exit_volume = rot_apply(mcrotadiffraction_detector_6_exit_volume, mctc1);
  mcDEBUG_COMPONENT("diffraction_detector_6_exit_volume", mcposadiffraction_detector_6_exit_volume, mcrotadiffraction_detector_6_exit_volume)
  mccomp_posa[388] = mcposadiffraction_detector_6_exit_volume;
  mccomp_posr[388] = mcposrdiffraction_detector_6_exit_volume;
  mcNCounter[388]  = mcPCounter[388] = mcP2Counter[388] = 0;
  mcAbsorbProp[388]= 0;
    /* Component spec_detector_6_exit_volume. */
  /* Setting parameters for component spec_detector_6_exit_volume. */
  SIG_MESSAGE("spec_detector_6_exit_volume (Init:SetPar)");
#line 2035 "MACS_sample_kidney_box.instr"
  if("Exit") strncpy(mccspec_detector_6_exit_volume_material_string, "Exit" ? "Exit" : "", 16384); else mccspec_detector_6_exit_volume_material_string[0]='\0';
#line 2035 "MACS_sample_kidney_box.instr"
  mccspec_detector_6_exit_volume_priority = 832;
#line 2034 "MACS_sample_kidney_box.instr"
  mccspec_detector_6_exit_volume_xwidth = 2.01 * detector_radius;
#line 2034 "MACS_sample_kidney_box.instr"
  mccspec_detector_6_exit_volume_yheight = 1.01 * detector_height;
#line 2034 "MACS_sample_kidney_box.instr"
  mccspec_detector_6_exit_volume_zdepth = 0.001;
#line 71 "MACS_sample_kidney_box.instr"
  mccspec_detector_6_exit_volume_xwidth2 = -1;
#line 71 "MACS_sample_kidney_box.instr"
  mccspec_detector_6_exit_volume_yheight2 = -1;
#line 71 "MACS_sample_kidney_box.instr"
  mccspec_detector_6_exit_volume_visualize = 1;
#line 71 "MACS_sample_kidney_box.instr"
  mccspec_detector_6_exit_volume_target_index = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccspec_detector_6_exit_volume_target_x = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccspec_detector_6_exit_volume_target_y = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccspec_detector_6_exit_volume_target_z = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccspec_detector_6_exit_volume_focus_aw = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccspec_detector_6_exit_volume_focus_ah = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccspec_detector_6_exit_volume_focus_xw = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccspec_detector_6_exit_volume_focus_xh = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccspec_detector_6_exit_volume_focus_r = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccspec_detector_6_exit_volume_p_interact = 0;
#line 71 "MACS_sample_kidney_box.instr"
  if(0) strncpy(mccspec_detector_6_exit_volume_mask_string, 0 ? 0 : "", 16384); else mccspec_detector_6_exit_volume_mask_string[0]='\0';
#line 71 "MACS_sample_kidney_box.instr"
  if(0) strncpy(mccspec_detector_6_exit_volume_mask_setting, 0 ? 0 : "", 16384); else mccspec_detector_6_exit_volume_mask_setting[0]='\0';
#line 71 "MACS_sample_kidney_box.instr"
  mccspec_detector_6_exit_volume_number_of_activations = 1;
#line 115052 "MACS_sample_kidney_box.c"

  SIG_MESSAGE("spec_detector_6_exit_volume (Init:Place/Rotate)");
  rot_set_rotation(mctr1,
#line 2037 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 2037 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 2037 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD);
#line 115062 "MACS_sample_kidney_box.c"
  rot_mul(mctr1, mcrotachannel_6_analyzer_2_center, mcrotaspec_detector_6_exit_volume);
  rot_transpose(mcrotadiffraction_detector_6_exit_volume, mctr1);
  rot_mul(mcrotaspec_detector_6_exit_volume, mctr1, mcrotrspec_detector_6_exit_volume);
  mctc1 = coords_set(
#line 2036 "MACS_sample_kidney_box.instr"
    0,
#line 2036 "MACS_sample_kidney_box.instr"
    0,
#line 2036 "MACS_sample_kidney_box.instr"
    0);
#line 115073 "MACS_sample_kidney_box.c"
  rot_transpose(mcrotachannel_6_cave2_cyl1, mctr1);
  mctc2 = rot_apply(mctr1, mctc1);
  mcposaspec_detector_6_exit_volume = coords_add(mcposachannel_6_cave2_cyl1, mctc2);
  mctc1 = coords_sub(mcposadiffraction_detector_6_exit_volume, mcposaspec_detector_6_exit_volume);
  mcposrspec_detector_6_exit_volume = rot_apply(mcrotaspec_detector_6_exit_volume, mctc1);
  mcDEBUG_COMPONENT("spec_detector_6_exit_volume", mcposaspec_detector_6_exit_volume, mcrotaspec_detector_6_exit_volume)
  mccomp_posa[389] = mcposaspec_detector_6_exit_volume;
  mccomp_posr[389] = mcposrspec_detector_6_exit_volume;
  mcNCounter[389]  = mcPCounter[389] = mcP2Counter[389] = 0;
  mcAbsorbProp[389]= 0;
    /* Component channel_7_cave1_box1. */
  /* Setting parameters for component channel_7_cave1_box1. */
  SIG_MESSAGE("channel_7_cave1_box1 (Init:SetPar)");
#line 2042 "MACS_sample_kidney_box.instr"
  if("Vacuum") strncpy(mccchannel_7_cave1_box1_material_string, "Vacuum" ? "Vacuum" : "", 16384); else mccchannel_7_cave1_box1_material_string[0]='\0';
#line 2042 "MACS_sample_kidney_box.instr"
  mccchannel_7_cave1_box1_priority = 900;
#line 2040 "MACS_sample_kidney_box.instr"
  mccchannel_7_cave1_box1_xwidth = kidney_cave1_box1_width1;
#line 2040 "MACS_sample_kidney_box.instr"
  mccchannel_7_cave1_box1_yheight = kidney_cave1_box1_height1;
#line 2040 "MACS_sample_kidney_box.instr"
  mccchannel_7_cave1_box1_zdepth = kidney_cave1_box1_depth;
#line 2041 "MACS_sample_kidney_box.instr"
  mccchannel_7_cave1_box1_xwidth2 = kidney_cave1_box1_width2;
#line 2041 "MACS_sample_kidney_box.instr"
  mccchannel_7_cave1_box1_yheight2 = kidney_cave1_box1_height2;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_7_cave1_box1_visualize = 1;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_7_cave1_box1_target_index = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_7_cave1_box1_target_x = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_7_cave1_box1_target_y = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_7_cave1_box1_target_z = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_7_cave1_box1_focus_aw = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_7_cave1_box1_focus_ah = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_7_cave1_box1_focus_xw = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_7_cave1_box1_focus_xh = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_7_cave1_box1_focus_r = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_7_cave1_box1_p_interact = 0;
#line 71 "MACS_sample_kidney_box.instr"
  if(0) strncpy(mccchannel_7_cave1_box1_mask_string, 0 ? 0 : "", 16384); else mccchannel_7_cave1_box1_mask_string[0]='\0';
#line 71 "MACS_sample_kidney_box.instr"
  if(0) strncpy(mccchannel_7_cave1_box1_mask_setting, 0 ? 0 : "", 16384); else mccchannel_7_cave1_box1_mask_setting[0]='\0';
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_7_cave1_box1_number_of_activations = 1;
#line 115129 "MACS_sample_kidney_box.c"

  SIG_MESSAGE("channel_7_cave1_box1 (Init:Place/Rotate)");
  rot_set_rotation(mctr1,
#line 2044 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 2044 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 2044 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD);
#line 115139 "MACS_sample_kidney_box.c"
  rot_mul(mctr1, mcrotakidney_channel_7, mcrotachannel_7_cave1_box1);
  rot_transpose(mcrotaspec_detector_6_exit_volume, mctr1);
  rot_mul(mcrotachannel_7_cave1_box1, mctr1, mcrotrchannel_7_cave1_box1);
  mctc1 = coords_set(
#line 2043 "MACS_sample_kidney_box.instr"
    0,
#line 2043 "MACS_sample_kidney_box.instr"
    0,
#line 2043 "MACS_sample_kidney_box.instr"
    kidney_cave1_box1_center_to_target);
#line 115150 "MACS_sample_kidney_box.c"
  rot_transpose(mcrotakidney_channel_7, mctr1);
  mctc2 = rot_apply(mctr1, mctc1);
  mcposachannel_7_cave1_box1 = coords_add(mcposakidney_channel_7, mctc2);
  mctc1 = coords_sub(mcposaspec_detector_6_exit_volume, mcposachannel_7_cave1_box1);
  mcposrchannel_7_cave1_box1 = rot_apply(mcrotachannel_7_cave1_box1, mctc1);
  mcDEBUG_COMPONENT("channel_7_cave1_box1", mcposachannel_7_cave1_box1, mcrotachannel_7_cave1_box1)
  mccomp_posa[390] = mcposachannel_7_cave1_box1;
  mccomp_posr[390] = mcposrchannel_7_cave1_box1;
  mcNCounter[390]  = mcPCounter[390] = mcP2Counter[390] = 0;
  mcAbsorbProp[390]= 0;
    /* Component channel_7_cave1_box2. */
  /* Setting parameters for component channel_7_cave1_box2. */
  SIG_MESSAGE("channel_7_cave1_box2 (Init:SetPar)");
#line 2049 "MACS_sample_kidney_box.instr"
  if("Vacuum") strncpy(mccchannel_7_cave1_box2_material_string, "Vacuum" ? "Vacuum" : "", 16384); else mccchannel_7_cave1_box2_material_string[0]='\0';
#line 2049 "MACS_sample_kidney_box.instr"
  mccchannel_7_cave1_box2_priority = 905;
#line 2047 "MACS_sample_kidney_box.instr"
  mccchannel_7_cave1_box2_xwidth = kidney_cave1_box2_width1;
#line 2047 "MACS_sample_kidney_box.instr"
  mccchannel_7_cave1_box2_yheight = kidney_cave1_box2_height1;
#line 2047 "MACS_sample_kidney_box.instr"
  mccchannel_7_cave1_box2_zdepth = kidney_cave1_box2_depth;
#line 2048 "MACS_sample_kidney_box.instr"
  mccchannel_7_cave1_box2_xwidth2 = kidney_cave1_box2_width2;
#line 2048 "MACS_sample_kidney_box.instr"
  mccchannel_7_cave1_box2_yheight2 = kidney_cave1_box2_height2;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_7_cave1_box2_visualize = 1;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_7_cave1_box2_target_index = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_7_cave1_box2_target_x = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_7_cave1_box2_target_y = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_7_cave1_box2_target_z = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_7_cave1_box2_focus_aw = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_7_cave1_box2_focus_ah = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_7_cave1_box2_focus_xw = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_7_cave1_box2_focus_xh = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_7_cave1_box2_focus_r = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_7_cave1_box2_p_interact = 0;
#line 71 "MACS_sample_kidney_box.instr"
  if(0) strncpy(mccchannel_7_cave1_box2_mask_string, 0 ? 0 : "", 16384); else mccchannel_7_cave1_box2_mask_string[0]='\0';
#line 71 "MACS_sample_kidney_box.instr"
  if(0) strncpy(mccchannel_7_cave1_box2_mask_setting, 0 ? 0 : "", 16384); else mccchannel_7_cave1_box2_mask_setting[0]='\0';
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_7_cave1_box2_number_of_activations = 1;
#line 115206 "MACS_sample_kidney_box.c"

  SIG_MESSAGE("channel_7_cave1_box2 (Init:Place/Rotate)");
  rot_set_rotation(mctr1,
#line 2051 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 2051 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 2051 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD);
#line 115216 "MACS_sample_kidney_box.c"
  rot_mul(mctr1, mcrotakidney_channel_7, mcrotachannel_7_cave1_box2);
  rot_transpose(mcrotachannel_7_cave1_box1, mctr1);
  rot_mul(mcrotachannel_7_cave1_box2, mctr1, mcrotrchannel_7_cave1_box2);
  mctc1 = coords_set(
#line 2050 "MACS_sample_kidney_box.instr"
    kidney_cave1_box2_x_offset,
#line 2050 "MACS_sample_kidney_box.instr"
    0,
#line 2050 "MACS_sample_kidney_box.instr"
    kidney_cave1_box2_center_to_target);
#line 115227 "MACS_sample_kidney_box.c"
  rot_transpose(mcrotakidney_channel_7, mctr1);
  mctc2 = rot_apply(mctr1, mctc1);
  mcposachannel_7_cave1_box2 = coords_add(mcposakidney_channel_7, mctc2);
  mctc1 = coords_sub(mcposachannel_7_cave1_box1, mcposachannel_7_cave1_box2);
  mcposrchannel_7_cave1_box2 = rot_apply(mcrotachannel_7_cave1_box2, mctc1);
  mcDEBUG_COMPONENT("channel_7_cave1_box2", mcposachannel_7_cave1_box2, mcrotachannel_7_cave1_box2)
  mccomp_posa[391] = mcposachannel_7_cave1_box2;
  mccomp_posr[391] = mcposrchannel_7_cave1_box2;
  mcNCounter[391]  = mcPCounter[391] = mcP2Counter[391] = 0;
  mcAbsorbProp[391]= 0;
    /* Component channel_7_cave1_box3. */
  /* Setting parameters for component channel_7_cave1_box3. */
  SIG_MESSAGE("channel_7_cave1_box3 (Init:SetPar)");
#line 2056 "MACS_sample_kidney_box.instr"
  if("Vacuum") strncpy(mccchannel_7_cave1_box3_material_string, "Vacuum" ? "Vacuum" : "", 16384); else mccchannel_7_cave1_box3_material_string[0]='\0';
#line 2056 "MACS_sample_kidney_box.instr"
  mccchannel_7_cave1_box3_priority = 902;
#line 2054 "MACS_sample_kidney_box.instr"
  mccchannel_7_cave1_box3_xwidth = kidney_cave1_box3_width1;
#line 2054 "MACS_sample_kidney_box.instr"
  mccchannel_7_cave1_box3_yheight = kidney_cave1_box3_height1;
#line 2054 "MACS_sample_kidney_box.instr"
  mccchannel_7_cave1_box3_zdepth = kidney_cave1_box3_depth;
#line 2055 "MACS_sample_kidney_box.instr"
  mccchannel_7_cave1_box3_xwidth2 = kidney_cave1_box3_width2;
#line 2055 "MACS_sample_kidney_box.instr"
  mccchannel_7_cave1_box3_yheight2 = kidney_cave1_box3_height2;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_7_cave1_box3_visualize = 1;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_7_cave1_box3_target_index = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_7_cave1_box3_target_x = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_7_cave1_box3_target_y = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_7_cave1_box3_target_z = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_7_cave1_box3_focus_aw = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_7_cave1_box3_focus_ah = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_7_cave1_box3_focus_xw = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_7_cave1_box3_focus_xh = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_7_cave1_box3_focus_r = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_7_cave1_box3_p_interact = 0;
#line 71 "MACS_sample_kidney_box.instr"
  if(0) strncpy(mccchannel_7_cave1_box3_mask_string, 0 ? 0 : "", 16384); else mccchannel_7_cave1_box3_mask_string[0]='\0';
#line 71 "MACS_sample_kidney_box.instr"
  if(0) strncpy(mccchannel_7_cave1_box3_mask_setting, 0 ? 0 : "", 16384); else mccchannel_7_cave1_box3_mask_setting[0]='\0';
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_7_cave1_box3_number_of_activations = 1;
#line 115283 "MACS_sample_kidney_box.c"

  SIG_MESSAGE("channel_7_cave1_box3 (Init:Place/Rotate)");
  rot_set_rotation(mctr1,
#line 2058 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 2058 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 2058 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD);
#line 115293 "MACS_sample_kidney_box.c"
  rot_mul(mctr1, mcrotakidney_channel_7, mcrotachannel_7_cave1_box3);
  rot_transpose(mcrotachannel_7_cave1_box2, mctr1);
  rot_mul(mcrotachannel_7_cave1_box3, mctr1, mcrotrchannel_7_cave1_box3);
  mctc1 = coords_set(
#line 2057 "MACS_sample_kidney_box.instr"
    0,
#line 2057 "MACS_sample_kidney_box.instr"
    0,
#line 2057 "MACS_sample_kidney_box.instr"
    kidney_cave1_box3_center_to_target);
#line 115304 "MACS_sample_kidney_box.c"
  rot_transpose(mcrotakidney_channel_7, mctr1);
  mctc2 = rot_apply(mctr1, mctc1);
  mcposachannel_7_cave1_box3 = coords_add(mcposakidney_channel_7, mctc2);
  mctc1 = coords_sub(mcposachannel_7_cave1_box2, mcposachannel_7_cave1_box3);
  mcposrchannel_7_cave1_box3 = rot_apply(mcrotachannel_7_cave1_box3, mctc1);
  mcDEBUG_COMPONENT("channel_7_cave1_box3", mcposachannel_7_cave1_box3, mcrotachannel_7_cave1_box3)
  mccomp_posa[392] = mcposachannel_7_cave1_box3;
  mccomp_posr[392] = mcposrchannel_7_cave1_box3;
  mcNCounter[392]  = mcPCounter[392] = mcP2Counter[392] = 0;
  mcAbsorbProp[392]= 0;
    /* Component channel_7_cave1_cyl1. */
  /* Setting parameters for component channel_7_cave1_cyl1. */
  SIG_MESSAGE("channel_7_cave1_cyl1 (Init:SetPar)");
#line 2062 "MACS_sample_kidney_box.instr"
  if("Vacuum") strncpy(mccchannel_7_cave1_cyl1_material_string, "Vacuum" ? "Vacuum" : "", 16384); else mccchannel_7_cave1_cyl1_material_string[0]='\0';
#line 2062 "MACS_sample_kidney_box.instr"
  mccchannel_7_cave1_cyl1_priority = 903;
#line 2061 "MACS_sample_kidney_box.instr"
  mccchannel_7_cave1_cyl1_radius = kidney_cave1_cyl1_radius;
#line 2061 "MACS_sample_kidney_box.instr"
  mccchannel_7_cave1_cyl1_yheight = kidney_cave1_cyl1_height;
#line 67 "MACS_sample_kidney_box.instr"
  mccchannel_7_cave1_cyl1_visualize = 1;
#line 67 "MACS_sample_kidney_box.instr"
  mccchannel_7_cave1_cyl1_target_index = 0;
#line 67 "MACS_sample_kidney_box.instr"
  mccchannel_7_cave1_cyl1_target_x = 0;
#line 67 "MACS_sample_kidney_box.instr"
  mccchannel_7_cave1_cyl1_target_y = 0;
#line 67 "MACS_sample_kidney_box.instr"
  mccchannel_7_cave1_cyl1_target_z = 0;
#line 67 "MACS_sample_kidney_box.instr"
  mccchannel_7_cave1_cyl1_focus_aw = 0;
#line 67 "MACS_sample_kidney_box.instr"
  mccchannel_7_cave1_cyl1_focus_ah = 0;
#line 67 "MACS_sample_kidney_box.instr"
  mccchannel_7_cave1_cyl1_focus_xw = 0;
#line 67 "MACS_sample_kidney_box.instr"
  mccchannel_7_cave1_cyl1_focus_xh = 0;
#line 67 "MACS_sample_kidney_box.instr"
  mccchannel_7_cave1_cyl1_focus_r = 0;
#line 67 "MACS_sample_kidney_box.instr"
  mccchannel_7_cave1_cyl1_p_interact = 0;
#line 67 "MACS_sample_kidney_box.instr"
  if(0) strncpy(mccchannel_7_cave1_cyl1_mask_string, 0 ? 0 : "", 16384); else mccchannel_7_cave1_cyl1_mask_string[0]='\0';
#line 67 "MACS_sample_kidney_box.instr"
  if(0) strncpy(mccchannel_7_cave1_cyl1_mask_setting, 0 ? 0 : "", 16384); else mccchannel_7_cave1_cyl1_mask_setting[0]='\0';
#line 67 "MACS_sample_kidney_box.instr"
  mccchannel_7_cave1_cyl1_number_of_activations = 1;
#line 115354 "MACS_sample_kidney_box.c"

  SIG_MESSAGE("channel_7_cave1_cyl1 (Init:Place/Rotate)");
  rot_set_rotation(mctr1,
#line 2064 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 2064 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 2064 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD);
#line 115364 "MACS_sample_kidney_box.c"
  rot_mul(mctr1, mcrotakidney_channel_7, mcrotachannel_7_cave1_cyl1);
  rot_transpose(mcrotachannel_7_cave1_box3, mctr1);
  rot_mul(mcrotachannel_7_cave1_cyl1, mctr1, mcrotrchannel_7_cave1_cyl1);
  mctc1 = coords_set(
#line 2063 "MACS_sample_kidney_box.instr"
    0,
#line 2063 "MACS_sample_kidney_box.instr"
    0,
#line 2063 "MACS_sample_kidney_box.instr"
    kidney_cave1_cyl1_center_to_target);
#line 115375 "MACS_sample_kidney_box.c"
  rot_transpose(mcrotakidney_channel_7, mctr1);
  mctc2 = rot_apply(mctr1, mctc1);
  mcposachannel_7_cave1_cyl1 = coords_add(mcposakidney_channel_7, mctc2);
  mctc1 = coords_sub(mcposachannel_7_cave1_box3, mcposachannel_7_cave1_cyl1);
  mcposrchannel_7_cave1_cyl1 = rot_apply(mcrotachannel_7_cave1_cyl1, mctc1);
  mcDEBUG_COMPONENT("channel_7_cave1_cyl1", mcposachannel_7_cave1_cyl1, mcrotachannel_7_cave1_cyl1)
  mccomp_posa[393] = mcposachannel_7_cave1_cyl1;
  mccomp_posr[393] = mcposrchannel_7_cave1_cyl1;
  mcNCounter[393]  = mcPCounter[393] = mcP2Counter[393] = 0;
  mcAbsorbProp[393]= 0;
    /* Component channel_7_analyzer_1_center. */
  /* Setting parameters for component channel_7_analyzer_1_center. */
  SIG_MESSAGE("channel_7_analyzer_1_center (Init:SetPar)");

  SIG_MESSAGE("channel_7_analyzer_1_center (Init:Place/Rotate)");
  rot_set_rotation(mctr1,
    (0.0)*DEG2RAD,
    (0.0)*DEG2RAD,
    (0.0)*DEG2RAD);
#line 115395 "MACS_sample_kidney_box.c"
  rot_mul(mctr1, mcrotakidney_channel_7, mcrotachannel_7_analyzer_1_center);
  rot_transpose(mcrotachannel_7_cave1_cyl1, mctr1);
  rot_mul(mcrotachannel_7_analyzer_1_center, mctr1, mcrotrchannel_7_analyzer_1_center);
  mctc1 = coords_set(
#line 2068 "MACS_sample_kidney_box.instr"
    0,
#line 2068 "MACS_sample_kidney_box.instr"
    0,
#line 2068 "MACS_sample_kidney_box.instr"
    analyzer_1_center_to_sample);
#line 115406 "MACS_sample_kidney_box.c"
  rot_transpose(mcrotakidney_channel_7, mctr1);
  mctc2 = rot_apply(mctr1, mctc1);
  mcposachannel_7_analyzer_1_center = coords_add(mcposakidney_channel_7, mctc2);
  mctc1 = coords_sub(mcposachannel_7_cave1_cyl1, mcposachannel_7_analyzer_1_center);
  mcposrchannel_7_analyzer_1_center = rot_apply(mcrotachannel_7_analyzer_1_center, mctc1);
  mcDEBUG_COMPONENT("channel_7_analyzer_1_center", mcposachannel_7_analyzer_1_center, mcrotachannel_7_analyzer_1_center)
  mccomp_posa[394] = mcposachannel_7_analyzer_1_center;
  mccomp_posr[394] = mcposrchannel_7_analyzer_1_center;
  mcNCounter[394]  = mcPCounter[394] = mcP2Counter[394] = 0;
  mcAbsorbProp[394]= 0;
    /* Component channel_7_analyzer_1_rotated. */
  /* Setting parameters for component channel_7_analyzer_1_rotated. */
  SIG_MESSAGE("channel_7_analyzer_1_rotated (Init:SetPar)");

  SIG_MESSAGE("channel_7_analyzer_1_rotated (Init:Place/Rotate)");
  rot_set_rotation(mctr1,
#line 2072 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 2072 "MACS_sample_kidney_box.instr"
    (180 - analyzer_theta [ 7 ])*DEG2RAD,
#line 2072 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD);
#line 115429 "MACS_sample_kidney_box.c"
  rot_mul(mctr1, mcrotachannel_7_analyzer_1_center, mcrotachannel_7_analyzer_1_rotated);
  rot_transpose(mcrotachannel_7_analyzer_1_center, mctr1);
  rot_mul(mcrotachannel_7_analyzer_1_rotated, mctr1, mcrotrchannel_7_analyzer_1_rotated);
  mctc1 = coords_set(
#line 2071 "MACS_sample_kidney_box.instr"
    0,
#line 2071 "MACS_sample_kidney_box.instr"
    0,
#line 2071 "MACS_sample_kidney_box.instr"
    -0.5 * analyzer_seperation / tan ( analyzer_2theta [ 7 ] * DEG2RAD ));
#line 115440 "MACS_sample_kidney_box.c"
  rot_transpose(mcrotachannel_7_analyzer_1_center, mctr1);
  mctc2 = rot_apply(mctr1, mctc1);
  mcposachannel_7_analyzer_1_rotated = coords_add(mcposachannel_7_analyzer_1_center, mctc2);
  mctc1 = coords_sub(mcposachannel_7_analyzer_1_center, mcposachannel_7_analyzer_1_rotated);
  mcposrchannel_7_analyzer_1_rotated = rot_apply(mcrotachannel_7_analyzer_1_rotated, mctc1);
  mcDEBUG_COMPONENT("channel_7_analyzer_1_rotated", mcposachannel_7_analyzer_1_rotated, mcrotachannel_7_analyzer_1_rotated)
  mccomp_posa[395] = mcposachannel_7_analyzer_1_rotated;
  mccomp_posr[395] = mcposrchannel_7_analyzer_1_rotated;
  mcNCounter[395]  = mcPCounter[395] = mcP2Counter[395] = 0;
  mcAbsorbProp[395]= 0;
    /* Component channel_7_analyzer_1_array_crystal_array_0. */
  /* Setting parameters for component channel_7_analyzer_1_array_crystal_array_0. */
  SIG_MESSAGE("channel_7_analyzer_1_array_crystal_array_0 (Init:SetPar)");
#line 2076 "MACS_sample_kidney_box.instr"
  if("PG_analyzer") strncpy(mccchannel_7_analyzer_1_array_crystal_array_0_material_string, "PG_analyzer" ? "PG_analyzer" : "", 16384); else mccchannel_7_analyzer_1_array_crystal_array_0_material_string[0]='\0';
#line 2076 "MACS_sample_kidney_box.instr"
  mccchannel_7_analyzer_1_array_crystal_array_0_priority = 920.0;
#line 2075 "MACS_sample_kidney_box.instr"
  mccchannel_7_analyzer_1_array_crystal_array_0_xwidth = channel_7_analyzer_1_array_crystal_depth;
#line 2075 "MACS_sample_kidney_box.instr"
  mccchannel_7_analyzer_1_array_crystal_array_0_yheight = channel_7_analyzer_1_array_crystal_height;
#line 2075 "MACS_sample_kidney_box.instr"
  mccchannel_7_analyzer_1_array_crystal_array_0_zdepth = channel_7_analyzer_1_array_crystal_width;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_7_analyzer_1_array_crystal_array_0_xwidth2 = -1;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_7_analyzer_1_array_crystal_array_0_yheight2 = -1;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_7_analyzer_1_array_crystal_array_0_visualize = 1;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_7_analyzer_1_array_crystal_array_0_target_index = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_7_analyzer_1_array_crystal_array_0_target_x = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_7_analyzer_1_array_crystal_array_0_target_y = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_7_analyzer_1_array_crystal_array_0_target_z = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_7_analyzer_1_array_crystal_array_0_focus_aw = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_7_analyzer_1_array_crystal_array_0_focus_ah = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_7_analyzer_1_array_crystal_array_0_focus_xw = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_7_analyzer_1_array_crystal_array_0_focus_xh = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_7_analyzer_1_array_crystal_array_0_focus_r = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_7_analyzer_1_array_crystal_array_0_p_interact = 0;
#line 71 "MACS_sample_kidney_box.instr"
  if(0) strncpy(mccchannel_7_analyzer_1_array_crystal_array_0_mask_string, 0 ? 0 : "", 16384); else mccchannel_7_analyzer_1_array_crystal_array_0_mask_string[0]='\0';
#line 71 "MACS_sample_kidney_box.instr"
  if(0) strncpy(mccchannel_7_analyzer_1_array_crystal_array_0_mask_setting, 0 ? 0 : "", 16384); else mccchannel_7_analyzer_1_array_crystal_array_0_mask_setting[0]='\0';
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_7_analyzer_1_array_crystal_array_0_number_of_activations = 1;
#line 115496 "MACS_sample_kidney_box.c"

  SIG_MESSAGE("channel_7_analyzer_1_array_crystal_array_0 (Init:Place/Rotate)");
  rot_set_rotation(mctr1,
#line 2078 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 2078 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 2078 "MACS_sample_kidney_box.instr"
    (0 - RAD2DEG * channel_7_analyzer_1_array_theta [ 0 ])*DEG2RAD);
#line 115506 "MACS_sample_kidney_box.c"
  rot_mul(mctr1, mcrotachannel_7_analyzer_1_rotated, mcrotachannel_7_analyzer_1_array_crystal_array_0);
  rot_transpose(mcrotachannel_7_analyzer_1_rotated, mctr1);
  rot_mul(mcrotachannel_7_analyzer_1_array_crystal_array_0, mctr1, mcrotrchannel_7_analyzer_1_array_crystal_array_0);
  mctc1 = coords_set(
#line 2077 "MACS_sample_kidney_box.instr"
    0 + channel_7_analyzer_1_array_effective_radius_of_curvature * ( 1 - cos ( channel_7_analyzer_1_array_theta [ 0 ] ) ),
#line 2077 "MACS_sample_kidney_box.instr"
    0 + channel_7_analyzer_1_array_effective_radius_of_curvature * sin ( channel_7_analyzer_1_array_theta [ 0 ] ),
#line 2077 "MACS_sample_kidney_box.instr"
    0);
#line 115517 "MACS_sample_kidney_box.c"
  rot_transpose(mcrotachannel_7_analyzer_1_rotated, mctr1);
  mctc2 = rot_apply(mctr1, mctc1);
  mcposachannel_7_analyzer_1_array_crystal_array_0 = coords_add(mcposachannel_7_analyzer_1_rotated, mctc2);
  mctc1 = coords_sub(mcposachannel_7_analyzer_1_rotated, mcposachannel_7_analyzer_1_array_crystal_array_0);
  mcposrchannel_7_analyzer_1_array_crystal_array_0 = rot_apply(mcrotachannel_7_analyzer_1_array_crystal_array_0, mctc1);
  mcDEBUG_COMPONENT("channel_7_analyzer_1_array_crystal_array_0", mcposachannel_7_analyzer_1_array_crystal_array_0, mcrotachannel_7_analyzer_1_array_crystal_array_0)
  mccomp_posa[396] = mcposachannel_7_analyzer_1_array_crystal_array_0;
  mccomp_posr[396] = mcposrchannel_7_analyzer_1_array_crystal_array_0;
  mcNCounter[396]  = mcPCounter[396] = mcP2Counter[396] = 0;
  mcAbsorbProp[396]= 0;
    /* Component channel_7_analyzer_1_array_crystal_array_1. */
  /* Setting parameters for component channel_7_analyzer_1_array_crystal_array_1. */
  SIG_MESSAGE("channel_7_analyzer_1_array_crystal_array_1 (Init:SetPar)");
#line 2082 "MACS_sample_kidney_box.instr"
  if("PG_analyzer") strncpy(mccchannel_7_analyzer_1_array_crystal_array_1_material_string, "PG_analyzer" ? "PG_analyzer" : "", 16384); else mccchannel_7_analyzer_1_array_crystal_array_1_material_string[0]='\0';
#line 2082 "MACS_sample_kidney_box.instr"
  mccchannel_7_analyzer_1_array_crystal_array_1_priority = 920.1;
#line 2081 "MACS_sample_kidney_box.instr"
  mccchannel_7_analyzer_1_array_crystal_array_1_xwidth = channel_7_analyzer_1_array_crystal_depth;
#line 2081 "MACS_sample_kidney_box.instr"
  mccchannel_7_analyzer_1_array_crystal_array_1_yheight = channel_7_analyzer_1_array_crystal_height;
#line 2081 "MACS_sample_kidney_box.instr"
  mccchannel_7_analyzer_1_array_crystal_array_1_zdepth = channel_7_analyzer_1_array_crystal_width;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_7_analyzer_1_array_crystal_array_1_xwidth2 = -1;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_7_analyzer_1_array_crystal_array_1_yheight2 = -1;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_7_analyzer_1_array_crystal_array_1_visualize = 1;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_7_analyzer_1_array_crystal_array_1_target_index = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_7_analyzer_1_array_crystal_array_1_target_x = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_7_analyzer_1_array_crystal_array_1_target_y = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_7_analyzer_1_array_crystal_array_1_target_z = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_7_analyzer_1_array_crystal_array_1_focus_aw = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_7_analyzer_1_array_crystal_array_1_focus_ah = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_7_analyzer_1_array_crystal_array_1_focus_xw = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_7_analyzer_1_array_crystal_array_1_focus_xh = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_7_analyzer_1_array_crystal_array_1_focus_r = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_7_analyzer_1_array_crystal_array_1_p_interact = 0;
#line 71 "MACS_sample_kidney_box.instr"
  if(0) strncpy(mccchannel_7_analyzer_1_array_crystal_array_1_mask_string, 0 ? 0 : "", 16384); else mccchannel_7_analyzer_1_array_crystal_array_1_mask_string[0]='\0';
#line 71 "MACS_sample_kidney_box.instr"
  if(0) strncpy(mccchannel_7_analyzer_1_array_crystal_array_1_mask_setting, 0 ? 0 : "", 16384); else mccchannel_7_analyzer_1_array_crystal_array_1_mask_setting[0]='\0';
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_7_analyzer_1_array_crystal_array_1_number_of_activations = 1;
#line 115573 "MACS_sample_kidney_box.c"

  SIG_MESSAGE("channel_7_analyzer_1_array_crystal_array_1 (Init:Place/Rotate)");
  rot_set_rotation(mctr1,
#line 2084 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 2084 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 2084 "MACS_sample_kidney_box.instr"
    (0 - RAD2DEG * channel_7_analyzer_1_array_theta [ 1 ])*DEG2RAD);
#line 115583 "MACS_sample_kidney_box.c"
  rot_mul(mctr1, mcrotachannel_7_analyzer_1_rotated, mcrotachannel_7_analyzer_1_array_crystal_array_1);
  rot_transpose(mcrotachannel_7_analyzer_1_array_crystal_array_0, mctr1);
  rot_mul(mcrotachannel_7_analyzer_1_array_crystal_array_1, mctr1, mcrotrchannel_7_analyzer_1_array_crystal_array_1);
  mctc1 = coords_set(
#line 2083 "MACS_sample_kidney_box.instr"
    0 + channel_7_analyzer_1_array_effective_radius_of_curvature * ( 1 - cos ( channel_7_analyzer_1_array_theta [ 1 ] ) ),
#line 2083 "MACS_sample_kidney_box.instr"
    0 + channel_7_analyzer_1_array_effective_radius_of_curvature * sin ( channel_7_analyzer_1_array_theta [ 1 ] ),
#line 2083 "MACS_sample_kidney_box.instr"
    0);
#line 115594 "MACS_sample_kidney_box.c"
  rot_transpose(mcrotachannel_7_analyzer_1_rotated, mctr1);
  mctc2 = rot_apply(mctr1, mctc1);
  mcposachannel_7_analyzer_1_array_crystal_array_1 = coords_add(mcposachannel_7_analyzer_1_rotated, mctc2);
  mctc1 = coords_sub(mcposachannel_7_analyzer_1_array_crystal_array_0, mcposachannel_7_analyzer_1_array_crystal_array_1);
  mcposrchannel_7_analyzer_1_array_crystal_array_1 = rot_apply(mcrotachannel_7_analyzer_1_array_crystal_array_1, mctc1);
  mcDEBUG_COMPONENT("channel_7_analyzer_1_array_crystal_array_1", mcposachannel_7_analyzer_1_array_crystal_array_1, mcrotachannel_7_analyzer_1_array_crystal_array_1)
  mccomp_posa[397] = mcposachannel_7_analyzer_1_array_crystal_array_1;
  mccomp_posr[397] = mcposrchannel_7_analyzer_1_array_crystal_array_1;
  mcNCounter[397]  = mcPCounter[397] = mcP2Counter[397] = 0;
  mcAbsorbProp[397]= 0;
    /* Component channel_7_analyzer_1_array_crystal_array_2. */
  /* Setting parameters for component channel_7_analyzer_1_array_crystal_array_2. */
  SIG_MESSAGE("channel_7_analyzer_1_array_crystal_array_2 (Init:SetPar)");
#line 2088 "MACS_sample_kidney_box.instr"
  if("PG_analyzer") strncpy(mccchannel_7_analyzer_1_array_crystal_array_2_material_string, "PG_analyzer" ? "PG_analyzer" : "", 16384); else mccchannel_7_analyzer_1_array_crystal_array_2_material_string[0]='\0';
#line 2088 "MACS_sample_kidney_box.instr"
  mccchannel_7_analyzer_1_array_crystal_array_2_priority = 920.2;
#line 2087 "MACS_sample_kidney_box.instr"
  mccchannel_7_analyzer_1_array_crystal_array_2_xwidth = channel_7_analyzer_1_array_crystal_depth;
#line 2087 "MACS_sample_kidney_box.instr"
  mccchannel_7_analyzer_1_array_crystal_array_2_yheight = channel_7_analyzer_1_array_crystal_height;
#line 2087 "MACS_sample_kidney_box.instr"
  mccchannel_7_analyzer_1_array_crystal_array_2_zdepth = channel_7_analyzer_1_array_crystal_width;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_7_analyzer_1_array_crystal_array_2_xwidth2 = -1;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_7_analyzer_1_array_crystal_array_2_yheight2 = -1;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_7_analyzer_1_array_crystal_array_2_visualize = 1;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_7_analyzer_1_array_crystal_array_2_target_index = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_7_analyzer_1_array_crystal_array_2_target_x = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_7_analyzer_1_array_crystal_array_2_target_y = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_7_analyzer_1_array_crystal_array_2_target_z = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_7_analyzer_1_array_crystal_array_2_focus_aw = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_7_analyzer_1_array_crystal_array_2_focus_ah = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_7_analyzer_1_array_crystal_array_2_focus_xw = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_7_analyzer_1_array_crystal_array_2_focus_xh = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_7_analyzer_1_array_crystal_array_2_focus_r = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_7_analyzer_1_array_crystal_array_2_p_interact = 0;
#line 71 "MACS_sample_kidney_box.instr"
  if(0) strncpy(mccchannel_7_analyzer_1_array_crystal_array_2_mask_string, 0 ? 0 : "", 16384); else mccchannel_7_analyzer_1_array_crystal_array_2_mask_string[0]='\0';
#line 71 "MACS_sample_kidney_box.instr"
  if(0) strncpy(mccchannel_7_analyzer_1_array_crystal_array_2_mask_setting, 0 ? 0 : "", 16384); else mccchannel_7_analyzer_1_array_crystal_array_2_mask_setting[0]='\0';
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_7_analyzer_1_array_crystal_array_2_number_of_activations = 1;
#line 115650 "MACS_sample_kidney_box.c"

  SIG_MESSAGE("channel_7_analyzer_1_array_crystal_array_2 (Init:Place/Rotate)");
  rot_set_rotation(mctr1,
#line 2090 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 2090 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 2090 "MACS_sample_kidney_box.instr"
    (0 - RAD2DEG * channel_7_analyzer_1_array_theta [ 2 ])*DEG2RAD);
#line 115660 "MACS_sample_kidney_box.c"
  rot_mul(mctr1, mcrotachannel_7_analyzer_1_rotated, mcrotachannel_7_analyzer_1_array_crystal_array_2);
  rot_transpose(mcrotachannel_7_analyzer_1_array_crystal_array_1, mctr1);
  rot_mul(mcrotachannel_7_analyzer_1_array_crystal_array_2, mctr1, mcrotrchannel_7_analyzer_1_array_crystal_array_2);
  mctc1 = coords_set(
#line 2089 "MACS_sample_kidney_box.instr"
    0 + channel_7_analyzer_1_array_effective_radius_of_curvature * ( 1 - cos ( channel_7_analyzer_1_array_theta [ 2 ] ) ),
#line 2089 "MACS_sample_kidney_box.instr"
    0 + channel_7_analyzer_1_array_effective_radius_of_curvature * sin ( channel_7_analyzer_1_array_theta [ 2 ] ),
#line 2089 "MACS_sample_kidney_box.instr"
    0);
#line 115671 "MACS_sample_kidney_box.c"
  rot_transpose(mcrotachannel_7_analyzer_1_rotated, mctr1);
  mctc2 = rot_apply(mctr1, mctc1);
  mcposachannel_7_analyzer_1_array_crystal_array_2 = coords_add(mcposachannel_7_analyzer_1_rotated, mctc2);
  mctc1 = coords_sub(mcposachannel_7_analyzer_1_array_crystal_array_1, mcposachannel_7_analyzer_1_array_crystal_array_2);
  mcposrchannel_7_analyzer_1_array_crystal_array_2 = rot_apply(mcrotachannel_7_analyzer_1_array_crystal_array_2, mctc1);
  mcDEBUG_COMPONENT("channel_7_analyzer_1_array_crystal_array_2", mcposachannel_7_analyzer_1_array_crystal_array_2, mcrotachannel_7_analyzer_1_array_crystal_array_2)
  mccomp_posa[398] = mcposachannel_7_analyzer_1_array_crystal_array_2;
  mccomp_posr[398] = mcposrchannel_7_analyzer_1_array_crystal_array_2;
  mcNCounter[398]  = mcPCounter[398] = mcP2Counter[398] = 0;
  mcAbsorbProp[398]= 0;
    /* Component channel_7_analyzer_1_array_crystal_array_3. */
  /* Setting parameters for component channel_7_analyzer_1_array_crystal_array_3. */
  SIG_MESSAGE("channel_7_analyzer_1_array_crystal_array_3 (Init:SetPar)");
#line 2094 "MACS_sample_kidney_box.instr"
  if("PG_analyzer") strncpy(mccchannel_7_analyzer_1_array_crystal_array_3_material_string, "PG_analyzer" ? "PG_analyzer" : "", 16384); else mccchannel_7_analyzer_1_array_crystal_array_3_material_string[0]='\0';
#line 2094 "MACS_sample_kidney_box.instr"
  mccchannel_7_analyzer_1_array_crystal_array_3_priority = 920.3;
#line 2093 "MACS_sample_kidney_box.instr"
  mccchannel_7_analyzer_1_array_crystal_array_3_xwidth = channel_7_analyzer_1_array_crystal_depth;
#line 2093 "MACS_sample_kidney_box.instr"
  mccchannel_7_analyzer_1_array_crystal_array_3_yheight = channel_7_analyzer_1_array_crystal_height;
#line 2093 "MACS_sample_kidney_box.instr"
  mccchannel_7_analyzer_1_array_crystal_array_3_zdepth = channel_7_analyzer_1_array_crystal_width;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_7_analyzer_1_array_crystal_array_3_xwidth2 = -1;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_7_analyzer_1_array_crystal_array_3_yheight2 = -1;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_7_analyzer_1_array_crystal_array_3_visualize = 1;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_7_analyzer_1_array_crystal_array_3_target_index = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_7_analyzer_1_array_crystal_array_3_target_x = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_7_analyzer_1_array_crystal_array_3_target_y = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_7_analyzer_1_array_crystal_array_3_target_z = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_7_analyzer_1_array_crystal_array_3_focus_aw = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_7_analyzer_1_array_crystal_array_3_focus_ah = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_7_analyzer_1_array_crystal_array_3_focus_xw = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_7_analyzer_1_array_crystal_array_3_focus_xh = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_7_analyzer_1_array_crystal_array_3_focus_r = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_7_analyzer_1_array_crystal_array_3_p_interact = 0;
#line 71 "MACS_sample_kidney_box.instr"
  if(0) strncpy(mccchannel_7_analyzer_1_array_crystal_array_3_mask_string, 0 ? 0 : "", 16384); else mccchannel_7_analyzer_1_array_crystal_array_3_mask_string[0]='\0';
#line 71 "MACS_sample_kidney_box.instr"
  if(0) strncpy(mccchannel_7_analyzer_1_array_crystal_array_3_mask_setting, 0 ? 0 : "", 16384); else mccchannel_7_analyzer_1_array_crystal_array_3_mask_setting[0]='\0';
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_7_analyzer_1_array_crystal_array_3_number_of_activations = 1;
#line 115727 "MACS_sample_kidney_box.c"

  SIG_MESSAGE("channel_7_analyzer_1_array_crystal_array_3 (Init:Place/Rotate)");
  rot_set_rotation(mctr1,
#line 2096 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 2096 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 2096 "MACS_sample_kidney_box.instr"
    (0 - RAD2DEG * channel_7_analyzer_1_array_theta [ 3 ])*DEG2RAD);
#line 115737 "MACS_sample_kidney_box.c"
  rot_mul(mctr1, mcrotachannel_7_analyzer_1_rotated, mcrotachannel_7_analyzer_1_array_crystal_array_3);
  rot_transpose(mcrotachannel_7_analyzer_1_array_crystal_array_2, mctr1);
  rot_mul(mcrotachannel_7_analyzer_1_array_crystal_array_3, mctr1, mcrotrchannel_7_analyzer_1_array_crystal_array_3);
  mctc1 = coords_set(
#line 2095 "MACS_sample_kidney_box.instr"
    0 + channel_7_analyzer_1_array_effective_radius_of_curvature * ( 1 - cos ( channel_7_analyzer_1_array_theta [ 3 ] ) ),
#line 2095 "MACS_sample_kidney_box.instr"
    0 + channel_7_analyzer_1_array_effective_radius_of_curvature * sin ( channel_7_analyzer_1_array_theta [ 3 ] ),
#line 2095 "MACS_sample_kidney_box.instr"
    0);
#line 115748 "MACS_sample_kidney_box.c"
  rot_transpose(mcrotachannel_7_analyzer_1_rotated, mctr1);
  mctc2 = rot_apply(mctr1, mctc1);
  mcposachannel_7_analyzer_1_array_crystal_array_3 = coords_add(mcposachannel_7_analyzer_1_rotated, mctc2);
  mctc1 = coords_sub(mcposachannel_7_analyzer_1_array_crystal_array_2, mcposachannel_7_analyzer_1_array_crystal_array_3);
  mcposrchannel_7_analyzer_1_array_crystal_array_3 = rot_apply(mcrotachannel_7_analyzer_1_array_crystal_array_3, mctc1);
  mcDEBUG_COMPONENT("channel_7_analyzer_1_array_crystal_array_3", mcposachannel_7_analyzer_1_array_crystal_array_3, mcrotachannel_7_analyzer_1_array_crystal_array_3)
  mccomp_posa[399] = mcposachannel_7_analyzer_1_array_crystal_array_3;
  mccomp_posr[399] = mcposrchannel_7_analyzer_1_array_crystal_array_3;
  mcNCounter[399]  = mcPCounter[399] = mcP2Counter[399] = 0;
  mcAbsorbProp[399]= 0;
    /* Component channel_7_analyzer_1_array_crystal_array_4. */
  /* Setting parameters for component channel_7_analyzer_1_array_crystal_array_4. */
  SIG_MESSAGE("channel_7_analyzer_1_array_crystal_array_4 (Init:SetPar)");
#line 2100 "MACS_sample_kidney_box.instr"
  if("PG_analyzer") strncpy(mccchannel_7_analyzer_1_array_crystal_array_4_material_string, "PG_analyzer" ? "PG_analyzer" : "", 16384); else mccchannel_7_analyzer_1_array_crystal_array_4_material_string[0]='\0';
#line 2100 "MACS_sample_kidney_box.instr"
  mccchannel_7_analyzer_1_array_crystal_array_4_priority = 920.4;
#line 2099 "MACS_sample_kidney_box.instr"
  mccchannel_7_analyzer_1_array_crystal_array_4_xwidth = channel_7_analyzer_1_array_crystal_depth;
#line 2099 "MACS_sample_kidney_box.instr"
  mccchannel_7_analyzer_1_array_crystal_array_4_yheight = channel_7_analyzer_1_array_crystal_height;
#line 2099 "MACS_sample_kidney_box.instr"
  mccchannel_7_analyzer_1_array_crystal_array_4_zdepth = channel_7_analyzer_1_array_crystal_width;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_7_analyzer_1_array_crystal_array_4_xwidth2 = -1;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_7_analyzer_1_array_crystal_array_4_yheight2 = -1;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_7_analyzer_1_array_crystal_array_4_visualize = 1;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_7_analyzer_1_array_crystal_array_4_target_index = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_7_analyzer_1_array_crystal_array_4_target_x = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_7_analyzer_1_array_crystal_array_4_target_y = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_7_analyzer_1_array_crystal_array_4_target_z = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_7_analyzer_1_array_crystal_array_4_focus_aw = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_7_analyzer_1_array_crystal_array_4_focus_ah = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_7_analyzer_1_array_crystal_array_4_focus_xw = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_7_analyzer_1_array_crystal_array_4_focus_xh = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_7_analyzer_1_array_crystal_array_4_focus_r = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_7_analyzer_1_array_crystal_array_4_p_interact = 0;
#line 71 "MACS_sample_kidney_box.instr"
  if(0) strncpy(mccchannel_7_analyzer_1_array_crystal_array_4_mask_string, 0 ? 0 : "", 16384); else mccchannel_7_analyzer_1_array_crystal_array_4_mask_string[0]='\0';
#line 71 "MACS_sample_kidney_box.instr"
  if(0) strncpy(mccchannel_7_analyzer_1_array_crystal_array_4_mask_setting, 0 ? 0 : "", 16384); else mccchannel_7_analyzer_1_array_crystal_array_4_mask_setting[0]='\0';
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_7_analyzer_1_array_crystal_array_4_number_of_activations = 1;
#line 115804 "MACS_sample_kidney_box.c"

  SIG_MESSAGE("channel_7_analyzer_1_array_crystal_array_4 (Init:Place/Rotate)");
  rot_set_rotation(mctr1,
#line 2102 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 2102 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 2102 "MACS_sample_kidney_box.instr"
    (0 - RAD2DEG * channel_7_analyzer_1_array_theta [ 4 ])*DEG2RAD);
#line 115814 "MACS_sample_kidney_box.c"
  rot_mul(mctr1, mcrotachannel_7_analyzer_1_rotated, mcrotachannel_7_analyzer_1_array_crystal_array_4);
  rot_transpose(mcrotachannel_7_analyzer_1_array_crystal_array_3, mctr1);
  rot_mul(mcrotachannel_7_analyzer_1_array_crystal_array_4, mctr1, mcrotrchannel_7_analyzer_1_array_crystal_array_4);
  mctc1 = coords_set(
#line 2101 "MACS_sample_kidney_box.instr"
    0 + channel_7_analyzer_1_array_effective_radius_of_curvature * ( 1 - cos ( channel_7_analyzer_1_array_theta [ 4 ] ) ),
#line 2101 "MACS_sample_kidney_box.instr"
    0 + channel_7_analyzer_1_array_effective_radius_of_curvature * sin ( channel_7_analyzer_1_array_theta [ 4 ] ),
#line 2101 "MACS_sample_kidney_box.instr"
    0);
#line 115825 "MACS_sample_kidney_box.c"
  rot_transpose(mcrotachannel_7_analyzer_1_rotated, mctr1);
  mctc2 = rot_apply(mctr1, mctc1);
  mcposachannel_7_analyzer_1_array_crystal_array_4 = coords_add(mcposachannel_7_analyzer_1_rotated, mctc2);
  mctc1 = coords_sub(mcposachannel_7_analyzer_1_array_crystal_array_3, mcposachannel_7_analyzer_1_array_crystal_array_4);
  mcposrchannel_7_analyzer_1_array_crystal_array_4 = rot_apply(mcrotachannel_7_analyzer_1_array_crystal_array_4, mctc1);
  mcDEBUG_COMPONENT("channel_7_analyzer_1_array_crystal_array_4", mcposachannel_7_analyzer_1_array_crystal_array_4, mcrotachannel_7_analyzer_1_array_crystal_array_4)
  mccomp_posa[400] = mcposachannel_7_analyzer_1_array_crystal_array_4;
  mccomp_posr[400] = mcposrchannel_7_analyzer_1_array_crystal_array_4;
  mcNCounter[400]  = mcPCounter[400] = mcP2Counter[400] = 0;
  mcAbsorbProp[400]= 0;
    /* Component channel_7_analyzer_1_array_crystal_array_5. */
  /* Setting parameters for component channel_7_analyzer_1_array_crystal_array_5. */
  SIG_MESSAGE("channel_7_analyzer_1_array_crystal_array_5 (Init:SetPar)");
#line 2106 "MACS_sample_kidney_box.instr"
  if("PG_analyzer") strncpy(mccchannel_7_analyzer_1_array_crystal_array_5_material_string, "PG_analyzer" ? "PG_analyzer" : "", 16384); else mccchannel_7_analyzer_1_array_crystal_array_5_material_string[0]='\0';
#line 2106 "MACS_sample_kidney_box.instr"
  mccchannel_7_analyzer_1_array_crystal_array_5_priority = 920.5;
#line 2105 "MACS_sample_kidney_box.instr"
  mccchannel_7_analyzer_1_array_crystal_array_5_xwidth = channel_7_analyzer_1_array_crystal_depth;
#line 2105 "MACS_sample_kidney_box.instr"
  mccchannel_7_analyzer_1_array_crystal_array_5_yheight = channel_7_analyzer_1_array_crystal_height;
#line 2105 "MACS_sample_kidney_box.instr"
  mccchannel_7_analyzer_1_array_crystal_array_5_zdepth = channel_7_analyzer_1_array_crystal_width;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_7_analyzer_1_array_crystal_array_5_xwidth2 = -1;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_7_analyzer_1_array_crystal_array_5_yheight2 = -1;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_7_analyzer_1_array_crystal_array_5_visualize = 1;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_7_analyzer_1_array_crystal_array_5_target_index = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_7_analyzer_1_array_crystal_array_5_target_x = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_7_analyzer_1_array_crystal_array_5_target_y = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_7_analyzer_1_array_crystal_array_5_target_z = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_7_analyzer_1_array_crystal_array_5_focus_aw = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_7_analyzer_1_array_crystal_array_5_focus_ah = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_7_analyzer_1_array_crystal_array_5_focus_xw = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_7_analyzer_1_array_crystal_array_5_focus_xh = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_7_analyzer_1_array_crystal_array_5_focus_r = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_7_analyzer_1_array_crystal_array_5_p_interact = 0;
#line 71 "MACS_sample_kidney_box.instr"
  if(0) strncpy(mccchannel_7_analyzer_1_array_crystal_array_5_mask_string, 0 ? 0 : "", 16384); else mccchannel_7_analyzer_1_array_crystal_array_5_mask_string[0]='\0';
#line 71 "MACS_sample_kidney_box.instr"
  if(0) strncpy(mccchannel_7_analyzer_1_array_crystal_array_5_mask_setting, 0 ? 0 : "", 16384); else mccchannel_7_analyzer_1_array_crystal_array_5_mask_setting[0]='\0';
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_7_analyzer_1_array_crystal_array_5_number_of_activations = 1;
#line 115881 "MACS_sample_kidney_box.c"

  SIG_MESSAGE("channel_7_analyzer_1_array_crystal_array_5 (Init:Place/Rotate)");
  rot_set_rotation(mctr1,
#line 2108 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 2108 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 2108 "MACS_sample_kidney_box.instr"
    (0 - RAD2DEG * channel_7_analyzer_1_array_theta [ 5 ])*DEG2RAD);
#line 115891 "MACS_sample_kidney_box.c"
  rot_mul(mctr1, mcrotachannel_7_analyzer_1_rotated, mcrotachannel_7_analyzer_1_array_crystal_array_5);
  rot_transpose(mcrotachannel_7_analyzer_1_array_crystal_array_4, mctr1);
  rot_mul(mcrotachannel_7_analyzer_1_array_crystal_array_5, mctr1, mcrotrchannel_7_analyzer_1_array_crystal_array_5);
  mctc1 = coords_set(
#line 2107 "MACS_sample_kidney_box.instr"
    0 + channel_7_analyzer_1_array_effective_radius_of_curvature * ( 1 - cos ( channel_7_analyzer_1_array_theta [ 5 ] ) ),
#line 2107 "MACS_sample_kidney_box.instr"
    0 + channel_7_analyzer_1_array_effective_radius_of_curvature * sin ( channel_7_analyzer_1_array_theta [ 5 ] ),
#line 2107 "MACS_sample_kidney_box.instr"
    0);
#line 115902 "MACS_sample_kidney_box.c"
  rot_transpose(mcrotachannel_7_analyzer_1_rotated, mctr1);
  mctc2 = rot_apply(mctr1, mctc1);
  mcposachannel_7_analyzer_1_array_crystal_array_5 = coords_add(mcposachannel_7_analyzer_1_rotated, mctc2);
  mctc1 = coords_sub(mcposachannel_7_analyzer_1_array_crystal_array_4, mcposachannel_7_analyzer_1_array_crystal_array_5);
  mcposrchannel_7_analyzer_1_array_crystal_array_5 = rot_apply(mcrotachannel_7_analyzer_1_array_crystal_array_5, mctc1);
  mcDEBUG_COMPONENT("channel_7_analyzer_1_array_crystal_array_5", mcposachannel_7_analyzer_1_array_crystal_array_5, mcrotachannel_7_analyzer_1_array_crystal_array_5)
  mccomp_posa[401] = mcposachannel_7_analyzer_1_array_crystal_array_5;
  mccomp_posr[401] = mcposrchannel_7_analyzer_1_array_crystal_array_5;
  mcNCounter[401]  = mcPCounter[401] = mcP2Counter[401] = 0;
  mcAbsorbProp[401]= 0;
    /* Component channel_7_analyzer_1_array_crystal_array_6. */
  /* Setting parameters for component channel_7_analyzer_1_array_crystal_array_6. */
  SIG_MESSAGE("channel_7_analyzer_1_array_crystal_array_6 (Init:SetPar)");
#line 2112 "MACS_sample_kidney_box.instr"
  if("PG_analyzer") strncpy(mccchannel_7_analyzer_1_array_crystal_array_6_material_string, "PG_analyzer" ? "PG_analyzer" : "", 16384); else mccchannel_7_analyzer_1_array_crystal_array_6_material_string[0]='\0';
#line 2112 "MACS_sample_kidney_box.instr"
  mccchannel_7_analyzer_1_array_crystal_array_6_priority = 920.6;
#line 2111 "MACS_sample_kidney_box.instr"
  mccchannel_7_analyzer_1_array_crystal_array_6_xwidth = channel_7_analyzer_1_array_crystal_depth;
#line 2111 "MACS_sample_kidney_box.instr"
  mccchannel_7_analyzer_1_array_crystal_array_6_yheight = channel_7_analyzer_1_array_crystal_height;
#line 2111 "MACS_sample_kidney_box.instr"
  mccchannel_7_analyzer_1_array_crystal_array_6_zdepth = channel_7_analyzer_1_array_crystal_width;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_7_analyzer_1_array_crystal_array_6_xwidth2 = -1;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_7_analyzer_1_array_crystal_array_6_yheight2 = -1;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_7_analyzer_1_array_crystal_array_6_visualize = 1;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_7_analyzer_1_array_crystal_array_6_target_index = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_7_analyzer_1_array_crystal_array_6_target_x = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_7_analyzer_1_array_crystal_array_6_target_y = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_7_analyzer_1_array_crystal_array_6_target_z = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_7_analyzer_1_array_crystal_array_6_focus_aw = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_7_analyzer_1_array_crystal_array_6_focus_ah = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_7_analyzer_1_array_crystal_array_6_focus_xw = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_7_analyzer_1_array_crystal_array_6_focus_xh = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_7_analyzer_1_array_crystal_array_6_focus_r = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_7_analyzer_1_array_crystal_array_6_p_interact = 0;
#line 71 "MACS_sample_kidney_box.instr"
  if(0) strncpy(mccchannel_7_analyzer_1_array_crystal_array_6_mask_string, 0 ? 0 : "", 16384); else mccchannel_7_analyzer_1_array_crystal_array_6_mask_string[0]='\0';
#line 71 "MACS_sample_kidney_box.instr"
  if(0) strncpy(mccchannel_7_analyzer_1_array_crystal_array_6_mask_setting, 0 ? 0 : "", 16384); else mccchannel_7_analyzer_1_array_crystal_array_6_mask_setting[0]='\0';
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_7_analyzer_1_array_crystal_array_6_number_of_activations = 1;
#line 115958 "MACS_sample_kidney_box.c"

  SIG_MESSAGE("channel_7_analyzer_1_array_crystal_array_6 (Init:Place/Rotate)");
  rot_set_rotation(mctr1,
#line 2114 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 2114 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 2114 "MACS_sample_kidney_box.instr"
    (0 - RAD2DEG * channel_7_analyzer_1_array_theta [ 6 ])*DEG2RAD);
#line 115968 "MACS_sample_kidney_box.c"
  rot_mul(mctr1, mcrotachannel_7_analyzer_1_rotated, mcrotachannel_7_analyzer_1_array_crystal_array_6);
  rot_transpose(mcrotachannel_7_analyzer_1_array_crystal_array_5, mctr1);
  rot_mul(mcrotachannel_7_analyzer_1_array_crystal_array_6, mctr1, mcrotrchannel_7_analyzer_1_array_crystal_array_6);
  mctc1 = coords_set(
#line 2113 "MACS_sample_kidney_box.instr"
    0 + channel_7_analyzer_1_array_effective_radius_of_curvature * ( 1 - cos ( channel_7_analyzer_1_array_theta [ 6 ] ) ),
#line 2113 "MACS_sample_kidney_box.instr"
    0 + channel_7_analyzer_1_array_effective_radius_of_curvature * sin ( channel_7_analyzer_1_array_theta [ 6 ] ),
#line 2113 "MACS_sample_kidney_box.instr"
    0);
#line 115979 "MACS_sample_kidney_box.c"
  rot_transpose(mcrotachannel_7_analyzer_1_rotated, mctr1);
  mctc2 = rot_apply(mctr1, mctc1);
  mcposachannel_7_analyzer_1_array_crystal_array_6 = coords_add(mcposachannel_7_analyzer_1_rotated, mctc2);
  mctc1 = coords_sub(mcposachannel_7_analyzer_1_array_crystal_array_5, mcposachannel_7_analyzer_1_array_crystal_array_6);
  mcposrchannel_7_analyzer_1_array_crystal_array_6 = rot_apply(mcrotachannel_7_analyzer_1_array_crystal_array_6, mctc1);
  mcDEBUG_COMPONENT("channel_7_analyzer_1_array_crystal_array_6", mcposachannel_7_analyzer_1_array_crystal_array_6, mcrotachannel_7_analyzer_1_array_crystal_array_6)
  mccomp_posa[402] = mcposachannel_7_analyzer_1_array_crystal_array_6;
  mccomp_posr[402] = mcposrchannel_7_analyzer_1_array_crystal_array_6;
  mcNCounter[402]  = mcPCounter[402] = mcP2Counter[402] = 0;
  mcAbsorbProp[402]= 0;
    /* Component channel_7_analyzer_1_array_crystal_array_7. */
  /* Setting parameters for component channel_7_analyzer_1_array_crystal_array_7. */
  SIG_MESSAGE("channel_7_analyzer_1_array_crystal_array_7 (Init:SetPar)");
#line 2118 "MACS_sample_kidney_box.instr"
  if("PG_analyzer") strncpy(mccchannel_7_analyzer_1_array_crystal_array_7_material_string, "PG_analyzer" ? "PG_analyzer" : "", 16384); else mccchannel_7_analyzer_1_array_crystal_array_7_material_string[0]='\0';
#line 2118 "MACS_sample_kidney_box.instr"
  mccchannel_7_analyzer_1_array_crystal_array_7_priority = 920.7;
#line 2117 "MACS_sample_kidney_box.instr"
  mccchannel_7_analyzer_1_array_crystal_array_7_xwidth = channel_7_analyzer_1_array_crystal_depth;
#line 2117 "MACS_sample_kidney_box.instr"
  mccchannel_7_analyzer_1_array_crystal_array_7_yheight = channel_7_analyzer_1_array_crystal_height;
#line 2117 "MACS_sample_kidney_box.instr"
  mccchannel_7_analyzer_1_array_crystal_array_7_zdepth = channel_7_analyzer_1_array_crystal_width;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_7_analyzer_1_array_crystal_array_7_xwidth2 = -1;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_7_analyzer_1_array_crystal_array_7_yheight2 = -1;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_7_analyzer_1_array_crystal_array_7_visualize = 1;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_7_analyzer_1_array_crystal_array_7_target_index = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_7_analyzer_1_array_crystal_array_7_target_x = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_7_analyzer_1_array_crystal_array_7_target_y = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_7_analyzer_1_array_crystal_array_7_target_z = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_7_analyzer_1_array_crystal_array_7_focus_aw = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_7_analyzer_1_array_crystal_array_7_focus_ah = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_7_analyzer_1_array_crystal_array_7_focus_xw = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_7_analyzer_1_array_crystal_array_7_focus_xh = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_7_analyzer_1_array_crystal_array_7_focus_r = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_7_analyzer_1_array_crystal_array_7_p_interact = 0;
#line 71 "MACS_sample_kidney_box.instr"
  if(0) strncpy(mccchannel_7_analyzer_1_array_crystal_array_7_mask_string, 0 ? 0 : "", 16384); else mccchannel_7_analyzer_1_array_crystal_array_7_mask_string[0]='\0';
#line 71 "MACS_sample_kidney_box.instr"
  if(0) strncpy(mccchannel_7_analyzer_1_array_crystal_array_7_mask_setting, 0 ? 0 : "", 16384); else mccchannel_7_analyzer_1_array_crystal_array_7_mask_setting[0]='\0';
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_7_analyzer_1_array_crystal_array_7_number_of_activations = 1;
#line 116035 "MACS_sample_kidney_box.c"

  SIG_MESSAGE("channel_7_analyzer_1_array_crystal_array_7 (Init:Place/Rotate)");
  rot_set_rotation(mctr1,
#line 2120 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 2120 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 2120 "MACS_sample_kidney_box.instr"
    (0 - RAD2DEG * channel_7_analyzer_1_array_theta [ 7 ])*DEG2RAD);
#line 116045 "MACS_sample_kidney_box.c"
  rot_mul(mctr1, mcrotachannel_7_analyzer_1_rotated, mcrotachannel_7_analyzer_1_array_crystal_array_7);
  rot_transpose(mcrotachannel_7_analyzer_1_array_crystal_array_6, mctr1);
  rot_mul(mcrotachannel_7_analyzer_1_array_crystal_array_7, mctr1, mcrotrchannel_7_analyzer_1_array_crystal_array_7);
  mctc1 = coords_set(
#line 2119 "MACS_sample_kidney_box.instr"
    0 + channel_7_analyzer_1_array_effective_radius_of_curvature * ( 1 - cos ( channel_7_analyzer_1_array_theta [ 7 ] ) ),
#line 2119 "MACS_sample_kidney_box.instr"
    0 + channel_7_analyzer_1_array_effective_radius_of_curvature * sin ( channel_7_analyzer_1_array_theta [ 7 ] ),
#line 2119 "MACS_sample_kidney_box.instr"
    0);
#line 116056 "MACS_sample_kidney_box.c"
  rot_transpose(mcrotachannel_7_analyzer_1_rotated, mctr1);
  mctc2 = rot_apply(mctr1, mctc1);
  mcposachannel_7_analyzer_1_array_crystal_array_7 = coords_add(mcposachannel_7_analyzer_1_rotated, mctc2);
  mctc1 = coords_sub(mcposachannel_7_analyzer_1_array_crystal_array_6, mcposachannel_7_analyzer_1_array_crystal_array_7);
  mcposrchannel_7_analyzer_1_array_crystal_array_7 = rot_apply(mcrotachannel_7_analyzer_1_array_crystal_array_7, mctc1);
  mcDEBUG_COMPONENT("channel_7_analyzer_1_array_crystal_array_7", mcposachannel_7_analyzer_1_array_crystal_array_7, mcrotachannel_7_analyzer_1_array_crystal_array_7)
  mccomp_posa[403] = mcposachannel_7_analyzer_1_array_crystal_array_7;
  mccomp_posr[403] = mcposrchannel_7_analyzer_1_array_crystal_array_7;
  mcNCounter[403]  = mcPCounter[403] = mcP2Counter[403] = 0;
  mcAbsorbProp[403]= 0;
    /* Component channel_7_analyzer_1_array_crystal_array_8. */
  /* Setting parameters for component channel_7_analyzer_1_array_crystal_array_8. */
  SIG_MESSAGE("channel_7_analyzer_1_array_crystal_array_8 (Init:SetPar)");
#line 2124 "MACS_sample_kidney_box.instr"
  if("PG_analyzer") strncpy(mccchannel_7_analyzer_1_array_crystal_array_8_material_string, "PG_analyzer" ? "PG_analyzer" : "", 16384); else mccchannel_7_analyzer_1_array_crystal_array_8_material_string[0]='\0';
#line 2124 "MACS_sample_kidney_box.instr"
  mccchannel_7_analyzer_1_array_crystal_array_8_priority = 920.8;
#line 2123 "MACS_sample_kidney_box.instr"
  mccchannel_7_analyzer_1_array_crystal_array_8_xwidth = channel_7_analyzer_1_array_crystal_depth;
#line 2123 "MACS_sample_kidney_box.instr"
  mccchannel_7_analyzer_1_array_crystal_array_8_yheight = channel_7_analyzer_1_array_crystal_height;
#line 2123 "MACS_sample_kidney_box.instr"
  mccchannel_7_analyzer_1_array_crystal_array_8_zdepth = channel_7_analyzer_1_array_crystal_width;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_7_analyzer_1_array_crystal_array_8_xwidth2 = -1;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_7_analyzer_1_array_crystal_array_8_yheight2 = -1;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_7_analyzer_1_array_crystal_array_8_visualize = 1;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_7_analyzer_1_array_crystal_array_8_target_index = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_7_analyzer_1_array_crystal_array_8_target_x = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_7_analyzer_1_array_crystal_array_8_target_y = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_7_analyzer_1_array_crystal_array_8_target_z = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_7_analyzer_1_array_crystal_array_8_focus_aw = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_7_analyzer_1_array_crystal_array_8_focus_ah = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_7_analyzer_1_array_crystal_array_8_focus_xw = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_7_analyzer_1_array_crystal_array_8_focus_xh = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_7_analyzer_1_array_crystal_array_8_focus_r = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_7_analyzer_1_array_crystal_array_8_p_interact = 0;
#line 71 "MACS_sample_kidney_box.instr"
  if(0) strncpy(mccchannel_7_analyzer_1_array_crystal_array_8_mask_string, 0 ? 0 : "", 16384); else mccchannel_7_analyzer_1_array_crystal_array_8_mask_string[0]='\0';
#line 71 "MACS_sample_kidney_box.instr"
  if(0) strncpy(mccchannel_7_analyzer_1_array_crystal_array_8_mask_setting, 0 ? 0 : "", 16384); else mccchannel_7_analyzer_1_array_crystal_array_8_mask_setting[0]='\0';
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_7_analyzer_1_array_crystal_array_8_number_of_activations = 1;
#line 116112 "MACS_sample_kidney_box.c"

  SIG_MESSAGE("channel_7_analyzer_1_array_crystal_array_8 (Init:Place/Rotate)");
  rot_set_rotation(mctr1,
#line 2126 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 2126 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 2126 "MACS_sample_kidney_box.instr"
    (0 - RAD2DEG * channel_7_analyzer_1_array_theta [ 8 ])*DEG2RAD);
#line 116122 "MACS_sample_kidney_box.c"
  rot_mul(mctr1, mcrotachannel_7_analyzer_1_rotated, mcrotachannel_7_analyzer_1_array_crystal_array_8);
  rot_transpose(mcrotachannel_7_analyzer_1_array_crystal_array_7, mctr1);
  rot_mul(mcrotachannel_7_analyzer_1_array_crystal_array_8, mctr1, mcrotrchannel_7_analyzer_1_array_crystal_array_8);
  mctc1 = coords_set(
#line 2125 "MACS_sample_kidney_box.instr"
    0 + channel_7_analyzer_1_array_effective_radius_of_curvature * ( 1 - cos ( channel_7_analyzer_1_array_theta [ 8 ] ) ),
#line 2125 "MACS_sample_kidney_box.instr"
    0 + channel_7_analyzer_1_array_effective_radius_of_curvature * sin ( channel_7_analyzer_1_array_theta [ 8 ] ),
#line 2125 "MACS_sample_kidney_box.instr"
    0);
#line 116133 "MACS_sample_kidney_box.c"
  rot_transpose(mcrotachannel_7_analyzer_1_rotated, mctr1);
  mctc2 = rot_apply(mctr1, mctc1);
  mcposachannel_7_analyzer_1_array_crystal_array_8 = coords_add(mcposachannel_7_analyzer_1_rotated, mctc2);
  mctc1 = coords_sub(mcposachannel_7_analyzer_1_array_crystal_array_7, mcposachannel_7_analyzer_1_array_crystal_array_8);
  mcposrchannel_7_analyzer_1_array_crystal_array_8 = rot_apply(mcrotachannel_7_analyzer_1_array_crystal_array_8, mctc1);
  mcDEBUG_COMPONENT("channel_7_analyzer_1_array_crystal_array_8", mcposachannel_7_analyzer_1_array_crystal_array_8, mcrotachannel_7_analyzer_1_array_crystal_array_8)
  mccomp_posa[404] = mcposachannel_7_analyzer_1_array_crystal_array_8;
  mccomp_posr[404] = mcposrchannel_7_analyzer_1_array_crystal_array_8;
  mcNCounter[404]  = mcPCounter[404] = mcP2Counter[404] = 0;
  mcAbsorbProp[404]= 0;
    /* Component channel_7_analyzer_2_center. */
  /* Setting parameters for component channel_7_analyzer_2_center. */
  SIG_MESSAGE("channel_7_analyzer_2_center (Init:SetPar)");

  SIG_MESSAGE("channel_7_analyzer_2_center (Init:Place/Rotate)");
  rot_set_rotation(mctr1,
    (0.0)*DEG2RAD,
    (0.0)*DEG2RAD,
    (0.0)*DEG2RAD);
#line 116153 "MACS_sample_kidney_box.c"
  rot_mul(mctr1, mcrotachannel_7_analyzer_1_center, mcrotachannel_7_analyzer_2_center);
  rot_transpose(mcrotachannel_7_analyzer_1_array_crystal_array_8, mctr1);
  rot_mul(mcrotachannel_7_analyzer_2_center, mctr1, mcrotrchannel_7_analyzer_2_center);
  mctc1 = coords_set(
#line 2130 "MACS_sample_kidney_box.instr"
    - analyzer_seperation,
#line 2130 "MACS_sample_kidney_box.instr"
    0,
#line 2130 "MACS_sample_kidney_box.instr"
    0);
#line 116164 "MACS_sample_kidney_box.c"
  rot_transpose(mcrotachannel_7_analyzer_1_center, mctr1);
  mctc2 = rot_apply(mctr1, mctc1);
  mcposachannel_7_analyzer_2_center = coords_add(mcposachannel_7_analyzer_1_center, mctc2);
  mctc1 = coords_sub(mcposachannel_7_analyzer_1_array_crystal_array_8, mcposachannel_7_analyzer_2_center);
  mcposrchannel_7_analyzer_2_center = rot_apply(mcrotachannel_7_analyzer_2_center, mctc1);
  mcDEBUG_COMPONENT("channel_7_analyzer_2_center", mcposachannel_7_analyzer_2_center, mcrotachannel_7_analyzer_2_center)
  mccomp_posa[405] = mcposachannel_7_analyzer_2_center;
  mccomp_posr[405] = mcposrchannel_7_analyzer_2_center;
  mcNCounter[405]  = mcPCounter[405] = mcP2Counter[405] = 0;
  mcAbsorbProp[405]= 0;
    /* Component channel_7_analyzer_2_rotated. */
  /* Setting parameters for component channel_7_analyzer_2_rotated. */
  SIG_MESSAGE("channel_7_analyzer_2_rotated (Init:SetPar)");

  SIG_MESSAGE("channel_7_analyzer_2_rotated (Init:Place/Rotate)");
  rot_set_rotation(mctr1,
#line 2134 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 2134 "MACS_sample_kidney_box.instr"
    (- analyzer_theta [ 7 ])*DEG2RAD,
#line 2134 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD);
#line 116187 "MACS_sample_kidney_box.c"
  rot_mul(mctr1, mcrotachannel_7_analyzer_2_center, mcrotachannel_7_analyzer_2_rotated);
  rot_transpose(mcrotachannel_7_analyzer_2_center, mctr1);
  rot_mul(mcrotachannel_7_analyzer_2_rotated, mctr1, mcrotrchannel_7_analyzer_2_rotated);
  mctc1 = coords_set(
#line 2133 "MACS_sample_kidney_box.instr"
    0,
#line 2133 "MACS_sample_kidney_box.instr"
    0,
#line 2133 "MACS_sample_kidney_box.instr"
    0.5 * analyzer_seperation / tan ( analyzer_2theta [ 7 ] * DEG2RAD ));
#line 116198 "MACS_sample_kidney_box.c"
  rot_transpose(mcrotachannel_7_analyzer_2_center, mctr1);
  mctc2 = rot_apply(mctr1, mctc1);
  mcposachannel_7_analyzer_2_rotated = coords_add(mcposachannel_7_analyzer_2_center, mctc2);
  mctc1 = coords_sub(mcposachannel_7_analyzer_2_center, mcposachannel_7_analyzer_2_rotated);
  mcposrchannel_7_analyzer_2_rotated = rot_apply(mcrotachannel_7_analyzer_2_rotated, mctc1);
  mcDEBUG_COMPONENT("channel_7_analyzer_2_rotated", mcposachannel_7_analyzer_2_rotated, mcrotachannel_7_analyzer_2_rotated)
  mccomp_posa[406] = mcposachannel_7_analyzer_2_rotated;
  mccomp_posr[406] = mcposrchannel_7_analyzer_2_rotated;
  mcNCounter[406]  = mcPCounter[406] = mcP2Counter[406] = 0;
  mcAbsorbProp[406]= 0;
    /* Component channel_7_analyzer_2_array_crystal_array_0. */
  /* Setting parameters for component channel_7_analyzer_2_array_crystal_array_0. */
  SIG_MESSAGE("channel_7_analyzer_2_array_crystal_array_0 (Init:SetPar)");
#line 2138 "MACS_sample_kidney_box.instr"
  if("PG_analyzer") strncpy(mccchannel_7_analyzer_2_array_crystal_array_0_material_string, "PG_analyzer" ? "PG_analyzer" : "", 16384); else mccchannel_7_analyzer_2_array_crystal_array_0_material_string[0]='\0';
#line 2138 "MACS_sample_kidney_box.instr"
  mccchannel_7_analyzer_2_array_crystal_array_0_priority = 921.0;
#line 2137 "MACS_sample_kidney_box.instr"
  mccchannel_7_analyzer_2_array_crystal_array_0_xwidth = channel_7_analyzer_2_array_crystal_depth;
#line 2137 "MACS_sample_kidney_box.instr"
  mccchannel_7_analyzer_2_array_crystal_array_0_yheight = channel_7_analyzer_2_array_crystal_height;
#line 2137 "MACS_sample_kidney_box.instr"
  mccchannel_7_analyzer_2_array_crystal_array_0_zdepth = channel_7_analyzer_2_array_crystal_width;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_7_analyzer_2_array_crystal_array_0_xwidth2 = -1;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_7_analyzer_2_array_crystal_array_0_yheight2 = -1;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_7_analyzer_2_array_crystal_array_0_visualize = 1;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_7_analyzer_2_array_crystal_array_0_target_index = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_7_analyzer_2_array_crystal_array_0_target_x = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_7_analyzer_2_array_crystal_array_0_target_y = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_7_analyzer_2_array_crystal_array_0_target_z = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_7_analyzer_2_array_crystal_array_0_focus_aw = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_7_analyzer_2_array_crystal_array_0_focus_ah = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_7_analyzer_2_array_crystal_array_0_focus_xw = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_7_analyzer_2_array_crystal_array_0_focus_xh = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_7_analyzer_2_array_crystal_array_0_focus_r = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_7_analyzer_2_array_crystal_array_0_p_interact = 0;
#line 71 "MACS_sample_kidney_box.instr"
  if(0) strncpy(mccchannel_7_analyzer_2_array_crystal_array_0_mask_string, 0 ? 0 : "", 16384); else mccchannel_7_analyzer_2_array_crystal_array_0_mask_string[0]='\0';
#line 71 "MACS_sample_kidney_box.instr"
  if(0) strncpy(mccchannel_7_analyzer_2_array_crystal_array_0_mask_setting, 0 ? 0 : "", 16384); else mccchannel_7_analyzer_2_array_crystal_array_0_mask_setting[0]='\0';
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_7_analyzer_2_array_crystal_array_0_number_of_activations = 1;
#line 116254 "MACS_sample_kidney_box.c"

  SIG_MESSAGE("channel_7_analyzer_2_array_crystal_array_0 (Init:Place/Rotate)");
  rot_set_rotation(mctr1,
#line 2140 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 2140 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 2140 "MACS_sample_kidney_box.instr"
    (0 - RAD2DEG * channel_7_analyzer_2_array_theta [ 0 ])*DEG2RAD);
#line 116264 "MACS_sample_kidney_box.c"
  rot_mul(mctr1, mcrotachannel_7_analyzer_2_rotated, mcrotachannel_7_analyzer_2_array_crystal_array_0);
  rot_transpose(mcrotachannel_7_analyzer_2_rotated, mctr1);
  rot_mul(mcrotachannel_7_analyzer_2_array_crystal_array_0, mctr1, mcrotrchannel_7_analyzer_2_array_crystal_array_0);
  mctc1 = coords_set(
#line 2139 "MACS_sample_kidney_box.instr"
    0 + channel_7_analyzer_2_array_effective_radius_of_curvature * ( 1 - cos ( channel_7_analyzer_2_array_theta [ 0 ] ) ),
#line 2139 "MACS_sample_kidney_box.instr"
    0 + channel_7_analyzer_2_array_effective_radius_of_curvature * sin ( channel_7_analyzer_2_array_theta [ 0 ] ),
#line 2139 "MACS_sample_kidney_box.instr"
    0);
#line 116275 "MACS_sample_kidney_box.c"
  rot_transpose(mcrotachannel_7_analyzer_2_rotated, mctr1);
  mctc2 = rot_apply(mctr1, mctc1);
  mcposachannel_7_analyzer_2_array_crystal_array_0 = coords_add(mcposachannel_7_analyzer_2_rotated, mctc2);
  mctc1 = coords_sub(mcposachannel_7_analyzer_2_rotated, mcposachannel_7_analyzer_2_array_crystal_array_0);
  mcposrchannel_7_analyzer_2_array_crystal_array_0 = rot_apply(mcrotachannel_7_analyzer_2_array_crystal_array_0, mctc1);
  mcDEBUG_COMPONENT("channel_7_analyzer_2_array_crystal_array_0", mcposachannel_7_analyzer_2_array_crystal_array_0, mcrotachannel_7_analyzer_2_array_crystal_array_0)
  mccomp_posa[407] = mcposachannel_7_analyzer_2_array_crystal_array_0;
  mccomp_posr[407] = mcposrchannel_7_analyzer_2_array_crystal_array_0;
  mcNCounter[407]  = mcPCounter[407] = mcP2Counter[407] = 0;
  mcAbsorbProp[407]= 0;
    /* Component channel_7_analyzer_2_array_crystal_array_1. */
  /* Setting parameters for component channel_7_analyzer_2_array_crystal_array_1. */
  SIG_MESSAGE("channel_7_analyzer_2_array_crystal_array_1 (Init:SetPar)");
#line 2144 "MACS_sample_kidney_box.instr"
  if("PG_analyzer") strncpy(mccchannel_7_analyzer_2_array_crystal_array_1_material_string, "PG_analyzer" ? "PG_analyzer" : "", 16384); else mccchannel_7_analyzer_2_array_crystal_array_1_material_string[0]='\0';
#line 2144 "MACS_sample_kidney_box.instr"
  mccchannel_7_analyzer_2_array_crystal_array_1_priority = 921.1;
#line 2143 "MACS_sample_kidney_box.instr"
  mccchannel_7_analyzer_2_array_crystal_array_1_xwidth = channel_7_analyzer_2_array_crystal_depth;
#line 2143 "MACS_sample_kidney_box.instr"
  mccchannel_7_analyzer_2_array_crystal_array_1_yheight = channel_7_analyzer_2_array_crystal_height;
#line 2143 "MACS_sample_kidney_box.instr"
  mccchannel_7_analyzer_2_array_crystal_array_1_zdepth = channel_7_analyzer_2_array_crystal_width;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_7_analyzer_2_array_crystal_array_1_xwidth2 = -1;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_7_analyzer_2_array_crystal_array_1_yheight2 = -1;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_7_analyzer_2_array_crystal_array_1_visualize = 1;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_7_analyzer_2_array_crystal_array_1_target_index = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_7_analyzer_2_array_crystal_array_1_target_x = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_7_analyzer_2_array_crystal_array_1_target_y = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_7_analyzer_2_array_crystal_array_1_target_z = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_7_analyzer_2_array_crystal_array_1_focus_aw = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_7_analyzer_2_array_crystal_array_1_focus_ah = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_7_analyzer_2_array_crystal_array_1_focus_xw = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_7_analyzer_2_array_crystal_array_1_focus_xh = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_7_analyzer_2_array_crystal_array_1_focus_r = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_7_analyzer_2_array_crystal_array_1_p_interact = 0;
#line 71 "MACS_sample_kidney_box.instr"
  if(0) strncpy(mccchannel_7_analyzer_2_array_crystal_array_1_mask_string, 0 ? 0 : "", 16384); else mccchannel_7_analyzer_2_array_crystal_array_1_mask_string[0]='\0';
#line 71 "MACS_sample_kidney_box.instr"
  if(0) strncpy(mccchannel_7_analyzer_2_array_crystal_array_1_mask_setting, 0 ? 0 : "", 16384); else mccchannel_7_analyzer_2_array_crystal_array_1_mask_setting[0]='\0';
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_7_analyzer_2_array_crystal_array_1_number_of_activations = 1;
#line 116331 "MACS_sample_kidney_box.c"

  SIG_MESSAGE("channel_7_analyzer_2_array_crystal_array_1 (Init:Place/Rotate)");
  rot_set_rotation(mctr1,
#line 2146 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 2146 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 2146 "MACS_sample_kidney_box.instr"
    (0 - RAD2DEG * channel_7_analyzer_2_array_theta [ 1 ])*DEG2RAD);
#line 116341 "MACS_sample_kidney_box.c"
  rot_mul(mctr1, mcrotachannel_7_analyzer_2_rotated, mcrotachannel_7_analyzer_2_array_crystal_array_1);
  rot_transpose(mcrotachannel_7_analyzer_2_array_crystal_array_0, mctr1);
  rot_mul(mcrotachannel_7_analyzer_2_array_crystal_array_1, mctr1, mcrotrchannel_7_analyzer_2_array_crystal_array_1);
  mctc1 = coords_set(
#line 2145 "MACS_sample_kidney_box.instr"
    0 + channel_7_analyzer_2_array_effective_radius_of_curvature * ( 1 - cos ( channel_7_analyzer_2_array_theta [ 1 ] ) ),
#line 2145 "MACS_sample_kidney_box.instr"
    0 + channel_7_analyzer_2_array_effective_radius_of_curvature * sin ( channel_7_analyzer_2_array_theta [ 1 ] ),
#line 2145 "MACS_sample_kidney_box.instr"
    0);
#line 116352 "MACS_sample_kidney_box.c"
  rot_transpose(mcrotachannel_7_analyzer_2_rotated, mctr1);
  mctc2 = rot_apply(mctr1, mctc1);
  mcposachannel_7_analyzer_2_array_crystal_array_1 = coords_add(mcposachannel_7_analyzer_2_rotated, mctc2);
  mctc1 = coords_sub(mcposachannel_7_analyzer_2_array_crystal_array_0, mcposachannel_7_analyzer_2_array_crystal_array_1);
  mcposrchannel_7_analyzer_2_array_crystal_array_1 = rot_apply(mcrotachannel_7_analyzer_2_array_crystal_array_1, mctc1);
  mcDEBUG_COMPONENT("channel_7_analyzer_2_array_crystal_array_1", mcposachannel_7_analyzer_2_array_crystal_array_1, mcrotachannel_7_analyzer_2_array_crystal_array_1)
  mccomp_posa[408] = mcposachannel_7_analyzer_2_array_crystal_array_1;
  mccomp_posr[408] = mcposrchannel_7_analyzer_2_array_crystal_array_1;
  mcNCounter[408]  = mcPCounter[408] = mcP2Counter[408] = 0;
  mcAbsorbProp[408]= 0;
    /* Component channel_7_analyzer_2_array_crystal_array_2. */
  /* Setting parameters for component channel_7_analyzer_2_array_crystal_array_2. */
  SIG_MESSAGE("channel_7_analyzer_2_array_crystal_array_2 (Init:SetPar)");
#line 2150 "MACS_sample_kidney_box.instr"
  if("PG_analyzer") strncpy(mccchannel_7_analyzer_2_array_crystal_array_2_material_string, "PG_analyzer" ? "PG_analyzer" : "", 16384); else mccchannel_7_analyzer_2_array_crystal_array_2_material_string[0]='\0';
#line 2150 "MACS_sample_kidney_box.instr"
  mccchannel_7_analyzer_2_array_crystal_array_2_priority = 921.2;
#line 2149 "MACS_sample_kidney_box.instr"
  mccchannel_7_analyzer_2_array_crystal_array_2_xwidth = channel_7_analyzer_2_array_crystal_depth;
#line 2149 "MACS_sample_kidney_box.instr"
  mccchannel_7_analyzer_2_array_crystal_array_2_yheight = channel_7_analyzer_2_array_crystal_height;
#line 2149 "MACS_sample_kidney_box.instr"
  mccchannel_7_analyzer_2_array_crystal_array_2_zdepth = channel_7_analyzer_2_array_crystal_width;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_7_analyzer_2_array_crystal_array_2_xwidth2 = -1;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_7_analyzer_2_array_crystal_array_2_yheight2 = -1;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_7_analyzer_2_array_crystal_array_2_visualize = 1;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_7_analyzer_2_array_crystal_array_2_target_index = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_7_analyzer_2_array_crystal_array_2_target_x = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_7_analyzer_2_array_crystal_array_2_target_y = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_7_analyzer_2_array_crystal_array_2_target_z = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_7_analyzer_2_array_crystal_array_2_focus_aw = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_7_analyzer_2_array_crystal_array_2_focus_ah = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_7_analyzer_2_array_crystal_array_2_focus_xw = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_7_analyzer_2_array_crystal_array_2_focus_xh = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_7_analyzer_2_array_crystal_array_2_focus_r = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_7_analyzer_2_array_crystal_array_2_p_interact = 0;
#line 71 "MACS_sample_kidney_box.instr"
  if(0) strncpy(mccchannel_7_analyzer_2_array_crystal_array_2_mask_string, 0 ? 0 : "", 16384); else mccchannel_7_analyzer_2_array_crystal_array_2_mask_string[0]='\0';
#line 71 "MACS_sample_kidney_box.instr"
  if(0) strncpy(mccchannel_7_analyzer_2_array_crystal_array_2_mask_setting, 0 ? 0 : "", 16384); else mccchannel_7_analyzer_2_array_crystal_array_2_mask_setting[0]='\0';
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_7_analyzer_2_array_crystal_array_2_number_of_activations = 1;
#line 116408 "MACS_sample_kidney_box.c"

  SIG_MESSAGE("channel_7_analyzer_2_array_crystal_array_2 (Init:Place/Rotate)");
  rot_set_rotation(mctr1,
#line 2152 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 2152 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 2152 "MACS_sample_kidney_box.instr"
    (0 - RAD2DEG * channel_7_analyzer_2_array_theta [ 2 ])*DEG2RAD);
#line 116418 "MACS_sample_kidney_box.c"
  rot_mul(mctr1, mcrotachannel_7_analyzer_2_rotated, mcrotachannel_7_analyzer_2_array_crystal_array_2);
  rot_transpose(mcrotachannel_7_analyzer_2_array_crystal_array_1, mctr1);
  rot_mul(mcrotachannel_7_analyzer_2_array_crystal_array_2, mctr1, mcrotrchannel_7_analyzer_2_array_crystal_array_2);
  mctc1 = coords_set(
#line 2151 "MACS_sample_kidney_box.instr"
    0 + channel_7_analyzer_2_array_effective_radius_of_curvature * ( 1 - cos ( channel_7_analyzer_2_array_theta [ 2 ] ) ),
#line 2151 "MACS_sample_kidney_box.instr"
    0 + channel_7_analyzer_2_array_effective_radius_of_curvature * sin ( channel_7_analyzer_2_array_theta [ 2 ] ),
#line 2151 "MACS_sample_kidney_box.instr"
    0);
#line 116429 "MACS_sample_kidney_box.c"
  rot_transpose(mcrotachannel_7_analyzer_2_rotated, mctr1);
  mctc2 = rot_apply(mctr1, mctc1);
  mcposachannel_7_analyzer_2_array_crystal_array_2 = coords_add(mcposachannel_7_analyzer_2_rotated, mctc2);
  mctc1 = coords_sub(mcposachannel_7_analyzer_2_array_crystal_array_1, mcposachannel_7_analyzer_2_array_crystal_array_2);
  mcposrchannel_7_analyzer_2_array_crystal_array_2 = rot_apply(mcrotachannel_7_analyzer_2_array_crystal_array_2, mctc1);
  mcDEBUG_COMPONENT("channel_7_analyzer_2_array_crystal_array_2", mcposachannel_7_analyzer_2_array_crystal_array_2, mcrotachannel_7_analyzer_2_array_crystal_array_2)
  mccomp_posa[409] = mcposachannel_7_analyzer_2_array_crystal_array_2;
  mccomp_posr[409] = mcposrchannel_7_analyzer_2_array_crystal_array_2;
  mcNCounter[409]  = mcPCounter[409] = mcP2Counter[409] = 0;
  mcAbsorbProp[409]= 0;
    /* Component channel_7_analyzer_2_array_crystal_array_3. */
  /* Setting parameters for component channel_7_analyzer_2_array_crystal_array_3. */
  SIG_MESSAGE("channel_7_analyzer_2_array_crystal_array_3 (Init:SetPar)");
#line 2156 "MACS_sample_kidney_box.instr"
  if("PG_analyzer") strncpy(mccchannel_7_analyzer_2_array_crystal_array_3_material_string, "PG_analyzer" ? "PG_analyzer" : "", 16384); else mccchannel_7_analyzer_2_array_crystal_array_3_material_string[0]='\0';
#line 2156 "MACS_sample_kidney_box.instr"
  mccchannel_7_analyzer_2_array_crystal_array_3_priority = 921.3;
#line 2155 "MACS_sample_kidney_box.instr"
  mccchannel_7_analyzer_2_array_crystal_array_3_xwidth = channel_7_analyzer_2_array_crystal_depth;
#line 2155 "MACS_sample_kidney_box.instr"
  mccchannel_7_analyzer_2_array_crystal_array_3_yheight = channel_7_analyzer_2_array_crystal_height;
#line 2155 "MACS_sample_kidney_box.instr"
  mccchannel_7_analyzer_2_array_crystal_array_3_zdepth = channel_7_analyzer_2_array_crystal_width;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_7_analyzer_2_array_crystal_array_3_xwidth2 = -1;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_7_analyzer_2_array_crystal_array_3_yheight2 = -1;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_7_analyzer_2_array_crystal_array_3_visualize = 1;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_7_analyzer_2_array_crystal_array_3_target_index = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_7_analyzer_2_array_crystal_array_3_target_x = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_7_analyzer_2_array_crystal_array_3_target_y = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_7_analyzer_2_array_crystal_array_3_target_z = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_7_analyzer_2_array_crystal_array_3_focus_aw = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_7_analyzer_2_array_crystal_array_3_focus_ah = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_7_analyzer_2_array_crystal_array_3_focus_xw = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_7_analyzer_2_array_crystal_array_3_focus_xh = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_7_analyzer_2_array_crystal_array_3_focus_r = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_7_analyzer_2_array_crystal_array_3_p_interact = 0;
#line 71 "MACS_sample_kidney_box.instr"
  if(0) strncpy(mccchannel_7_analyzer_2_array_crystal_array_3_mask_string, 0 ? 0 : "", 16384); else mccchannel_7_analyzer_2_array_crystal_array_3_mask_string[0]='\0';
#line 71 "MACS_sample_kidney_box.instr"
  if(0) strncpy(mccchannel_7_analyzer_2_array_crystal_array_3_mask_setting, 0 ? 0 : "", 16384); else mccchannel_7_analyzer_2_array_crystal_array_3_mask_setting[0]='\0';
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_7_analyzer_2_array_crystal_array_3_number_of_activations = 1;
#line 116485 "MACS_sample_kidney_box.c"

  SIG_MESSAGE("channel_7_analyzer_2_array_crystal_array_3 (Init:Place/Rotate)");
  rot_set_rotation(mctr1,
#line 2158 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 2158 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 2158 "MACS_sample_kidney_box.instr"
    (0 - RAD2DEG * channel_7_analyzer_2_array_theta [ 3 ])*DEG2RAD);
#line 116495 "MACS_sample_kidney_box.c"
  rot_mul(mctr1, mcrotachannel_7_analyzer_2_rotated, mcrotachannel_7_analyzer_2_array_crystal_array_3);
  rot_transpose(mcrotachannel_7_analyzer_2_array_crystal_array_2, mctr1);
  rot_mul(mcrotachannel_7_analyzer_2_array_crystal_array_3, mctr1, mcrotrchannel_7_analyzer_2_array_crystal_array_3);
  mctc1 = coords_set(
#line 2157 "MACS_sample_kidney_box.instr"
    0 + channel_7_analyzer_2_array_effective_radius_of_curvature * ( 1 - cos ( channel_7_analyzer_2_array_theta [ 3 ] ) ),
#line 2157 "MACS_sample_kidney_box.instr"
    0 + channel_7_analyzer_2_array_effective_radius_of_curvature * sin ( channel_7_analyzer_2_array_theta [ 3 ] ),
#line 2157 "MACS_sample_kidney_box.instr"
    0);
#line 116506 "MACS_sample_kidney_box.c"
  rot_transpose(mcrotachannel_7_analyzer_2_rotated, mctr1);
  mctc2 = rot_apply(mctr1, mctc1);
  mcposachannel_7_analyzer_2_array_crystal_array_3 = coords_add(mcposachannel_7_analyzer_2_rotated, mctc2);
  mctc1 = coords_sub(mcposachannel_7_analyzer_2_array_crystal_array_2, mcposachannel_7_analyzer_2_array_crystal_array_3);
  mcposrchannel_7_analyzer_2_array_crystal_array_3 = rot_apply(mcrotachannel_7_analyzer_2_array_crystal_array_3, mctc1);
  mcDEBUG_COMPONENT("channel_7_analyzer_2_array_crystal_array_3", mcposachannel_7_analyzer_2_array_crystal_array_3, mcrotachannel_7_analyzer_2_array_crystal_array_3)
  mccomp_posa[410] = mcposachannel_7_analyzer_2_array_crystal_array_3;
  mccomp_posr[410] = mcposrchannel_7_analyzer_2_array_crystal_array_3;
  mcNCounter[410]  = mcPCounter[410] = mcP2Counter[410] = 0;
  mcAbsorbProp[410]= 0;
    /* Component channel_7_analyzer_2_array_crystal_array_4. */
  /* Setting parameters for component channel_7_analyzer_2_array_crystal_array_4. */
  SIG_MESSAGE("channel_7_analyzer_2_array_crystal_array_4 (Init:SetPar)");
#line 2162 "MACS_sample_kidney_box.instr"
  if("PG_analyzer") strncpy(mccchannel_7_analyzer_2_array_crystal_array_4_material_string, "PG_analyzer" ? "PG_analyzer" : "", 16384); else mccchannel_7_analyzer_2_array_crystal_array_4_material_string[0]='\0';
#line 2162 "MACS_sample_kidney_box.instr"
  mccchannel_7_analyzer_2_array_crystal_array_4_priority = 921.4;
#line 2161 "MACS_sample_kidney_box.instr"
  mccchannel_7_analyzer_2_array_crystal_array_4_xwidth = channel_7_analyzer_2_array_crystal_depth;
#line 2161 "MACS_sample_kidney_box.instr"
  mccchannel_7_analyzer_2_array_crystal_array_4_yheight = channel_7_analyzer_2_array_crystal_height;
#line 2161 "MACS_sample_kidney_box.instr"
  mccchannel_7_analyzer_2_array_crystal_array_4_zdepth = channel_7_analyzer_2_array_crystal_width;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_7_analyzer_2_array_crystal_array_4_xwidth2 = -1;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_7_analyzer_2_array_crystal_array_4_yheight2 = -1;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_7_analyzer_2_array_crystal_array_4_visualize = 1;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_7_analyzer_2_array_crystal_array_4_target_index = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_7_analyzer_2_array_crystal_array_4_target_x = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_7_analyzer_2_array_crystal_array_4_target_y = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_7_analyzer_2_array_crystal_array_4_target_z = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_7_analyzer_2_array_crystal_array_4_focus_aw = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_7_analyzer_2_array_crystal_array_4_focus_ah = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_7_analyzer_2_array_crystal_array_4_focus_xw = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_7_analyzer_2_array_crystal_array_4_focus_xh = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_7_analyzer_2_array_crystal_array_4_focus_r = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_7_analyzer_2_array_crystal_array_4_p_interact = 0;
#line 71 "MACS_sample_kidney_box.instr"
  if(0) strncpy(mccchannel_7_analyzer_2_array_crystal_array_4_mask_string, 0 ? 0 : "", 16384); else mccchannel_7_analyzer_2_array_crystal_array_4_mask_string[0]='\0';
#line 71 "MACS_sample_kidney_box.instr"
  if(0) strncpy(mccchannel_7_analyzer_2_array_crystal_array_4_mask_setting, 0 ? 0 : "", 16384); else mccchannel_7_analyzer_2_array_crystal_array_4_mask_setting[0]='\0';
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_7_analyzer_2_array_crystal_array_4_number_of_activations = 1;
#line 116562 "MACS_sample_kidney_box.c"

  SIG_MESSAGE("channel_7_analyzer_2_array_crystal_array_4 (Init:Place/Rotate)");
  rot_set_rotation(mctr1,
#line 2164 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 2164 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 2164 "MACS_sample_kidney_box.instr"
    (0 - RAD2DEG * channel_7_analyzer_2_array_theta [ 4 ])*DEG2RAD);
#line 116572 "MACS_sample_kidney_box.c"
  rot_mul(mctr1, mcrotachannel_7_analyzer_2_rotated, mcrotachannel_7_analyzer_2_array_crystal_array_4);
  rot_transpose(mcrotachannel_7_analyzer_2_array_crystal_array_3, mctr1);
  rot_mul(mcrotachannel_7_analyzer_2_array_crystal_array_4, mctr1, mcrotrchannel_7_analyzer_2_array_crystal_array_4);
  mctc1 = coords_set(
#line 2163 "MACS_sample_kidney_box.instr"
    0 + channel_7_analyzer_2_array_effective_radius_of_curvature * ( 1 - cos ( channel_7_analyzer_2_array_theta [ 4 ] ) ),
#line 2163 "MACS_sample_kidney_box.instr"
    0 + channel_7_analyzer_2_array_effective_radius_of_curvature * sin ( channel_7_analyzer_2_array_theta [ 4 ] ),
#line 2163 "MACS_sample_kidney_box.instr"
    0);
#line 116583 "MACS_sample_kidney_box.c"
  rot_transpose(mcrotachannel_7_analyzer_2_rotated, mctr1);
  mctc2 = rot_apply(mctr1, mctc1);
  mcposachannel_7_analyzer_2_array_crystal_array_4 = coords_add(mcposachannel_7_analyzer_2_rotated, mctc2);
  mctc1 = coords_sub(mcposachannel_7_analyzer_2_array_crystal_array_3, mcposachannel_7_analyzer_2_array_crystal_array_4);
  mcposrchannel_7_analyzer_2_array_crystal_array_4 = rot_apply(mcrotachannel_7_analyzer_2_array_crystal_array_4, mctc1);
  mcDEBUG_COMPONENT("channel_7_analyzer_2_array_crystal_array_4", mcposachannel_7_analyzer_2_array_crystal_array_4, mcrotachannel_7_analyzer_2_array_crystal_array_4)
  mccomp_posa[411] = mcposachannel_7_analyzer_2_array_crystal_array_4;
  mccomp_posr[411] = mcposrchannel_7_analyzer_2_array_crystal_array_4;
  mcNCounter[411]  = mcPCounter[411] = mcP2Counter[411] = 0;
  mcAbsorbProp[411]= 0;
    /* Component channel_7_analyzer_2_array_crystal_array_5. */
  /* Setting parameters for component channel_7_analyzer_2_array_crystal_array_5. */
  SIG_MESSAGE("channel_7_analyzer_2_array_crystal_array_5 (Init:SetPar)");
#line 2168 "MACS_sample_kidney_box.instr"
  if("PG_analyzer") strncpy(mccchannel_7_analyzer_2_array_crystal_array_5_material_string, "PG_analyzer" ? "PG_analyzer" : "", 16384); else mccchannel_7_analyzer_2_array_crystal_array_5_material_string[0]='\0';
#line 2168 "MACS_sample_kidney_box.instr"
  mccchannel_7_analyzer_2_array_crystal_array_5_priority = 921.5;
#line 2167 "MACS_sample_kidney_box.instr"
  mccchannel_7_analyzer_2_array_crystal_array_5_xwidth = channel_7_analyzer_2_array_crystal_depth;
#line 2167 "MACS_sample_kidney_box.instr"
  mccchannel_7_analyzer_2_array_crystal_array_5_yheight = channel_7_analyzer_2_array_crystal_height;
#line 2167 "MACS_sample_kidney_box.instr"
  mccchannel_7_analyzer_2_array_crystal_array_5_zdepth = channel_7_analyzer_2_array_crystal_width;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_7_analyzer_2_array_crystal_array_5_xwidth2 = -1;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_7_analyzer_2_array_crystal_array_5_yheight2 = -1;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_7_analyzer_2_array_crystal_array_5_visualize = 1;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_7_analyzer_2_array_crystal_array_5_target_index = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_7_analyzer_2_array_crystal_array_5_target_x = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_7_analyzer_2_array_crystal_array_5_target_y = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_7_analyzer_2_array_crystal_array_5_target_z = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_7_analyzer_2_array_crystal_array_5_focus_aw = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_7_analyzer_2_array_crystal_array_5_focus_ah = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_7_analyzer_2_array_crystal_array_5_focus_xw = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_7_analyzer_2_array_crystal_array_5_focus_xh = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_7_analyzer_2_array_crystal_array_5_focus_r = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_7_analyzer_2_array_crystal_array_5_p_interact = 0;
#line 71 "MACS_sample_kidney_box.instr"
  if(0) strncpy(mccchannel_7_analyzer_2_array_crystal_array_5_mask_string, 0 ? 0 : "", 16384); else mccchannel_7_analyzer_2_array_crystal_array_5_mask_string[0]='\0';
#line 71 "MACS_sample_kidney_box.instr"
  if(0) strncpy(mccchannel_7_analyzer_2_array_crystal_array_5_mask_setting, 0 ? 0 : "", 16384); else mccchannel_7_analyzer_2_array_crystal_array_5_mask_setting[0]='\0';
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_7_analyzer_2_array_crystal_array_5_number_of_activations = 1;
#line 116639 "MACS_sample_kidney_box.c"

  SIG_MESSAGE("channel_7_analyzer_2_array_crystal_array_5 (Init:Place/Rotate)");
  rot_set_rotation(mctr1,
#line 2170 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 2170 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 2170 "MACS_sample_kidney_box.instr"
    (0 - RAD2DEG * channel_7_analyzer_2_array_theta [ 5 ])*DEG2RAD);
#line 116649 "MACS_sample_kidney_box.c"
  rot_mul(mctr1, mcrotachannel_7_analyzer_2_rotated, mcrotachannel_7_analyzer_2_array_crystal_array_5);
  rot_transpose(mcrotachannel_7_analyzer_2_array_crystal_array_4, mctr1);
  rot_mul(mcrotachannel_7_analyzer_2_array_crystal_array_5, mctr1, mcrotrchannel_7_analyzer_2_array_crystal_array_5);
  mctc1 = coords_set(
#line 2169 "MACS_sample_kidney_box.instr"
    0 + channel_7_analyzer_2_array_effective_radius_of_curvature * ( 1 - cos ( channel_7_analyzer_2_array_theta [ 5 ] ) ),
#line 2169 "MACS_sample_kidney_box.instr"
    0 + channel_7_analyzer_2_array_effective_radius_of_curvature * sin ( channel_7_analyzer_2_array_theta [ 5 ] ),
#line 2169 "MACS_sample_kidney_box.instr"
    0);
#line 116660 "MACS_sample_kidney_box.c"
  rot_transpose(mcrotachannel_7_analyzer_2_rotated, mctr1);
  mctc2 = rot_apply(mctr1, mctc1);
  mcposachannel_7_analyzer_2_array_crystal_array_5 = coords_add(mcposachannel_7_analyzer_2_rotated, mctc2);
  mctc1 = coords_sub(mcposachannel_7_analyzer_2_array_crystal_array_4, mcposachannel_7_analyzer_2_array_crystal_array_5);
  mcposrchannel_7_analyzer_2_array_crystal_array_5 = rot_apply(mcrotachannel_7_analyzer_2_array_crystal_array_5, mctc1);
  mcDEBUG_COMPONENT("channel_7_analyzer_2_array_crystal_array_5", mcposachannel_7_analyzer_2_array_crystal_array_5, mcrotachannel_7_analyzer_2_array_crystal_array_5)
  mccomp_posa[412] = mcposachannel_7_analyzer_2_array_crystal_array_5;
  mccomp_posr[412] = mcposrchannel_7_analyzer_2_array_crystal_array_5;
  mcNCounter[412]  = mcPCounter[412] = mcP2Counter[412] = 0;
  mcAbsorbProp[412]= 0;
    /* Component channel_7_analyzer_2_array_crystal_array_6. */
  /* Setting parameters for component channel_7_analyzer_2_array_crystal_array_6. */
  SIG_MESSAGE("channel_7_analyzer_2_array_crystal_array_6 (Init:SetPar)");
#line 2174 "MACS_sample_kidney_box.instr"
  if("PG_analyzer") strncpy(mccchannel_7_analyzer_2_array_crystal_array_6_material_string, "PG_analyzer" ? "PG_analyzer" : "", 16384); else mccchannel_7_analyzer_2_array_crystal_array_6_material_string[0]='\0';
#line 2174 "MACS_sample_kidney_box.instr"
  mccchannel_7_analyzer_2_array_crystal_array_6_priority = 921.6;
#line 2173 "MACS_sample_kidney_box.instr"
  mccchannel_7_analyzer_2_array_crystal_array_6_xwidth = channel_7_analyzer_2_array_crystal_depth;
#line 2173 "MACS_sample_kidney_box.instr"
  mccchannel_7_analyzer_2_array_crystal_array_6_yheight = channel_7_analyzer_2_array_crystal_height;
#line 2173 "MACS_sample_kidney_box.instr"
  mccchannel_7_analyzer_2_array_crystal_array_6_zdepth = channel_7_analyzer_2_array_crystal_width;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_7_analyzer_2_array_crystal_array_6_xwidth2 = -1;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_7_analyzer_2_array_crystal_array_6_yheight2 = -1;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_7_analyzer_2_array_crystal_array_6_visualize = 1;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_7_analyzer_2_array_crystal_array_6_target_index = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_7_analyzer_2_array_crystal_array_6_target_x = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_7_analyzer_2_array_crystal_array_6_target_y = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_7_analyzer_2_array_crystal_array_6_target_z = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_7_analyzer_2_array_crystal_array_6_focus_aw = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_7_analyzer_2_array_crystal_array_6_focus_ah = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_7_analyzer_2_array_crystal_array_6_focus_xw = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_7_analyzer_2_array_crystal_array_6_focus_xh = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_7_analyzer_2_array_crystal_array_6_focus_r = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_7_analyzer_2_array_crystal_array_6_p_interact = 0;
#line 71 "MACS_sample_kidney_box.instr"
  if(0) strncpy(mccchannel_7_analyzer_2_array_crystal_array_6_mask_string, 0 ? 0 : "", 16384); else mccchannel_7_analyzer_2_array_crystal_array_6_mask_string[0]='\0';
#line 71 "MACS_sample_kidney_box.instr"
  if(0) strncpy(mccchannel_7_analyzer_2_array_crystal_array_6_mask_setting, 0 ? 0 : "", 16384); else mccchannel_7_analyzer_2_array_crystal_array_6_mask_setting[0]='\0';
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_7_analyzer_2_array_crystal_array_6_number_of_activations = 1;
#line 116716 "MACS_sample_kidney_box.c"

  SIG_MESSAGE("channel_7_analyzer_2_array_crystal_array_6 (Init:Place/Rotate)");
  rot_set_rotation(mctr1,
#line 2176 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 2176 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 2176 "MACS_sample_kidney_box.instr"
    (0 - RAD2DEG * channel_7_analyzer_2_array_theta [ 6 ])*DEG2RAD);
#line 116726 "MACS_sample_kidney_box.c"
  rot_mul(mctr1, mcrotachannel_7_analyzer_2_rotated, mcrotachannel_7_analyzer_2_array_crystal_array_6);
  rot_transpose(mcrotachannel_7_analyzer_2_array_crystal_array_5, mctr1);
  rot_mul(mcrotachannel_7_analyzer_2_array_crystal_array_6, mctr1, mcrotrchannel_7_analyzer_2_array_crystal_array_6);
  mctc1 = coords_set(
#line 2175 "MACS_sample_kidney_box.instr"
    0 + channel_7_analyzer_2_array_effective_radius_of_curvature * ( 1 - cos ( channel_7_analyzer_2_array_theta [ 6 ] ) ),
#line 2175 "MACS_sample_kidney_box.instr"
    0 + channel_7_analyzer_2_array_effective_radius_of_curvature * sin ( channel_7_analyzer_2_array_theta [ 6 ] ),
#line 2175 "MACS_sample_kidney_box.instr"
    0);
#line 116737 "MACS_sample_kidney_box.c"
  rot_transpose(mcrotachannel_7_analyzer_2_rotated, mctr1);
  mctc2 = rot_apply(mctr1, mctc1);
  mcposachannel_7_analyzer_2_array_crystal_array_6 = coords_add(mcposachannel_7_analyzer_2_rotated, mctc2);
  mctc1 = coords_sub(mcposachannel_7_analyzer_2_array_crystal_array_5, mcposachannel_7_analyzer_2_array_crystal_array_6);
  mcposrchannel_7_analyzer_2_array_crystal_array_6 = rot_apply(mcrotachannel_7_analyzer_2_array_crystal_array_6, mctc1);
  mcDEBUG_COMPONENT("channel_7_analyzer_2_array_crystal_array_6", mcposachannel_7_analyzer_2_array_crystal_array_6, mcrotachannel_7_analyzer_2_array_crystal_array_6)
  mccomp_posa[413] = mcposachannel_7_analyzer_2_array_crystal_array_6;
  mccomp_posr[413] = mcposrchannel_7_analyzer_2_array_crystal_array_6;
  mcNCounter[413]  = mcPCounter[413] = mcP2Counter[413] = 0;
  mcAbsorbProp[413]= 0;
    /* Component channel_7_analyzer_2_array_crystal_array_7. */
  /* Setting parameters for component channel_7_analyzer_2_array_crystal_array_7. */
  SIG_MESSAGE("channel_7_analyzer_2_array_crystal_array_7 (Init:SetPar)");
#line 2180 "MACS_sample_kidney_box.instr"
  if("PG_analyzer") strncpy(mccchannel_7_analyzer_2_array_crystal_array_7_material_string, "PG_analyzer" ? "PG_analyzer" : "", 16384); else mccchannel_7_analyzer_2_array_crystal_array_7_material_string[0]='\0';
#line 2180 "MACS_sample_kidney_box.instr"
  mccchannel_7_analyzer_2_array_crystal_array_7_priority = 921.7;
#line 2179 "MACS_sample_kidney_box.instr"
  mccchannel_7_analyzer_2_array_crystal_array_7_xwidth = channel_7_analyzer_2_array_crystal_depth;
#line 2179 "MACS_sample_kidney_box.instr"
  mccchannel_7_analyzer_2_array_crystal_array_7_yheight = channel_7_analyzer_2_array_crystal_height;
#line 2179 "MACS_sample_kidney_box.instr"
  mccchannel_7_analyzer_2_array_crystal_array_7_zdepth = channel_7_analyzer_2_array_crystal_width;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_7_analyzer_2_array_crystal_array_7_xwidth2 = -1;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_7_analyzer_2_array_crystal_array_7_yheight2 = -1;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_7_analyzer_2_array_crystal_array_7_visualize = 1;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_7_analyzer_2_array_crystal_array_7_target_index = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_7_analyzer_2_array_crystal_array_7_target_x = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_7_analyzer_2_array_crystal_array_7_target_y = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_7_analyzer_2_array_crystal_array_7_target_z = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_7_analyzer_2_array_crystal_array_7_focus_aw = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_7_analyzer_2_array_crystal_array_7_focus_ah = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_7_analyzer_2_array_crystal_array_7_focus_xw = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_7_analyzer_2_array_crystal_array_7_focus_xh = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_7_analyzer_2_array_crystal_array_7_focus_r = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_7_analyzer_2_array_crystal_array_7_p_interact = 0;
#line 71 "MACS_sample_kidney_box.instr"
  if(0) strncpy(mccchannel_7_analyzer_2_array_crystal_array_7_mask_string, 0 ? 0 : "", 16384); else mccchannel_7_analyzer_2_array_crystal_array_7_mask_string[0]='\0';
#line 71 "MACS_sample_kidney_box.instr"
  if(0) strncpy(mccchannel_7_analyzer_2_array_crystal_array_7_mask_setting, 0 ? 0 : "", 16384); else mccchannel_7_analyzer_2_array_crystal_array_7_mask_setting[0]='\0';
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_7_analyzer_2_array_crystal_array_7_number_of_activations = 1;
#line 116793 "MACS_sample_kidney_box.c"

  SIG_MESSAGE("channel_7_analyzer_2_array_crystal_array_7 (Init:Place/Rotate)");
  rot_set_rotation(mctr1,
#line 2182 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 2182 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 2182 "MACS_sample_kidney_box.instr"
    (0 - RAD2DEG * channel_7_analyzer_2_array_theta [ 7 ])*DEG2RAD);
#line 116803 "MACS_sample_kidney_box.c"
  rot_mul(mctr1, mcrotachannel_7_analyzer_2_rotated, mcrotachannel_7_analyzer_2_array_crystal_array_7);
  rot_transpose(mcrotachannel_7_analyzer_2_array_crystal_array_6, mctr1);
  rot_mul(mcrotachannel_7_analyzer_2_array_crystal_array_7, mctr1, mcrotrchannel_7_analyzer_2_array_crystal_array_7);
  mctc1 = coords_set(
#line 2181 "MACS_sample_kidney_box.instr"
    0 + channel_7_analyzer_2_array_effective_radius_of_curvature * ( 1 - cos ( channel_7_analyzer_2_array_theta [ 7 ] ) ),
#line 2181 "MACS_sample_kidney_box.instr"
    0 + channel_7_analyzer_2_array_effective_radius_of_curvature * sin ( channel_7_analyzer_2_array_theta [ 7 ] ),
#line 2181 "MACS_sample_kidney_box.instr"
    0);
#line 116814 "MACS_sample_kidney_box.c"
  rot_transpose(mcrotachannel_7_analyzer_2_rotated, mctr1);
  mctc2 = rot_apply(mctr1, mctc1);
  mcposachannel_7_analyzer_2_array_crystal_array_7 = coords_add(mcposachannel_7_analyzer_2_rotated, mctc2);
  mctc1 = coords_sub(mcposachannel_7_analyzer_2_array_crystal_array_6, mcposachannel_7_analyzer_2_array_crystal_array_7);
  mcposrchannel_7_analyzer_2_array_crystal_array_7 = rot_apply(mcrotachannel_7_analyzer_2_array_crystal_array_7, mctc1);
  mcDEBUG_COMPONENT("channel_7_analyzer_2_array_crystal_array_7", mcposachannel_7_analyzer_2_array_crystal_array_7, mcrotachannel_7_analyzer_2_array_crystal_array_7)
  mccomp_posa[414] = mcposachannel_7_analyzer_2_array_crystal_array_7;
  mccomp_posr[414] = mcposrchannel_7_analyzer_2_array_crystal_array_7;
  mcNCounter[414]  = mcPCounter[414] = mcP2Counter[414] = 0;
  mcAbsorbProp[414]= 0;
    /* Component channel_7_analyzer_2_array_crystal_array_8. */
  /* Setting parameters for component channel_7_analyzer_2_array_crystal_array_8. */
  SIG_MESSAGE("channel_7_analyzer_2_array_crystal_array_8 (Init:SetPar)");
#line 2186 "MACS_sample_kidney_box.instr"
  if("PG_analyzer") strncpy(mccchannel_7_analyzer_2_array_crystal_array_8_material_string, "PG_analyzer" ? "PG_analyzer" : "", 16384); else mccchannel_7_analyzer_2_array_crystal_array_8_material_string[0]='\0';
#line 2186 "MACS_sample_kidney_box.instr"
  mccchannel_7_analyzer_2_array_crystal_array_8_priority = 921.8;
#line 2185 "MACS_sample_kidney_box.instr"
  mccchannel_7_analyzer_2_array_crystal_array_8_xwidth = channel_7_analyzer_2_array_crystal_depth;
#line 2185 "MACS_sample_kidney_box.instr"
  mccchannel_7_analyzer_2_array_crystal_array_8_yheight = channel_7_analyzer_2_array_crystal_height;
#line 2185 "MACS_sample_kidney_box.instr"
  mccchannel_7_analyzer_2_array_crystal_array_8_zdepth = channel_7_analyzer_2_array_crystal_width;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_7_analyzer_2_array_crystal_array_8_xwidth2 = -1;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_7_analyzer_2_array_crystal_array_8_yheight2 = -1;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_7_analyzer_2_array_crystal_array_8_visualize = 1;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_7_analyzer_2_array_crystal_array_8_target_index = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_7_analyzer_2_array_crystal_array_8_target_x = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_7_analyzer_2_array_crystal_array_8_target_y = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_7_analyzer_2_array_crystal_array_8_target_z = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_7_analyzer_2_array_crystal_array_8_focus_aw = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_7_analyzer_2_array_crystal_array_8_focus_ah = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_7_analyzer_2_array_crystal_array_8_focus_xw = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_7_analyzer_2_array_crystal_array_8_focus_xh = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_7_analyzer_2_array_crystal_array_8_focus_r = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_7_analyzer_2_array_crystal_array_8_p_interact = 0;
#line 71 "MACS_sample_kidney_box.instr"
  if(0) strncpy(mccchannel_7_analyzer_2_array_crystal_array_8_mask_string, 0 ? 0 : "", 16384); else mccchannel_7_analyzer_2_array_crystal_array_8_mask_string[0]='\0';
#line 71 "MACS_sample_kidney_box.instr"
  if(0) strncpy(mccchannel_7_analyzer_2_array_crystal_array_8_mask_setting, 0 ? 0 : "", 16384); else mccchannel_7_analyzer_2_array_crystal_array_8_mask_setting[0]='\0';
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_7_analyzer_2_array_crystal_array_8_number_of_activations = 1;
#line 116870 "MACS_sample_kidney_box.c"

  SIG_MESSAGE("channel_7_analyzer_2_array_crystal_array_8 (Init:Place/Rotate)");
  rot_set_rotation(mctr1,
#line 2188 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 2188 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 2188 "MACS_sample_kidney_box.instr"
    (0 - RAD2DEG * channel_7_analyzer_2_array_theta [ 8 ])*DEG2RAD);
#line 116880 "MACS_sample_kidney_box.c"
  rot_mul(mctr1, mcrotachannel_7_analyzer_2_rotated, mcrotachannel_7_analyzer_2_array_crystal_array_8);
  rot_transpose(mcrotachannel_7_analyzer_2_array_crystal_array_7, mctr1);
  rot_mul(mcrotachannel_7_analyzer_2_array_crystal_array_8, mctr1, mcrotrchannel_7_analyzer_2_array_crystal_array_8);
  mctc1 = coords_set(
#line 2187 "MACS_sample_kidney_box.instr"
    0 + channel_7_analyzer_2_array_effective_radius_of_curvature * ( 1 - cos ( channel_7_analyzer_2_array_theta [ 8 ] ) ),
#line 2187 "MACS_sample_kidney_box.instr"
    0 + channel_7_analyzer_2_array_effective_radius_of_curvature * sin ( channel_7_analyzer_2_array_theta [ 8 ] ),
#line 2187 "MACS_sample_kidney_box.instr"
    0);
#line 116891 "MACS_sample_kidney_box.c"
  rot_transpose(mcrotachannel_7_analyzer_2_rotated, mctr1);
  mctc2 = rot_apply(mctr1, mctc1);
  mcposachannel_7_analyzer_2_array_crystal_array_8 = coords_add(mcposachannel_7_analyzer_2_rotated, mctc2);
  mctc1 = coords_sub(mcposachannel_7_analyzer_2_array_crystal_array_7, mcposachannel_7_analyzer_2_array_crystal_array_8);
  mcposrchannel_7_analyzer_2_array_crystal_array_8 = rot_apply(mcrotachannel_7_analyzer_2_array_crystal_array_8, mctc1);
  mcDEBUG_COMPONENT("channel_7_analyzer_2_array_crystal_array_8", mcposachannel_7_analyzer_2_array_crystal_array_8, mcrotachannel_7_analyzer_2_array_crystal_array_8)
  mccomp_posa[415] = mcposachannel_7_analyzer_2_array_crystal_array_8;
  mccomp_posr[415] = mcposrchannel_7_analyzer_2_array_crystal_array_8;
  mcNCounter[415]  = mcPCounter[415] = mcP2Counter[415] = 0;
  mcAbsorbProp[415]= 0;
    /* Component channel_7_cave2_cyl1. */
  /* Setting parameters for component channel_7_cave2_cyl1. */
  SIG_MESSAGE("channel_7_cave2_cyl1 (Init:SetPar)");
#line 2193 "MACS_sample_kidney_box.instr"
  if("Vacuum") strncpy(mccchannel_7_cave2_cyl1_material_string, "Vacuum" ? "Vacuum" : "", 16384); else mccchannel_7_cave2_cyl1_material_string[0]='\0';
#line 2193 "MACS_sample_kidney_box.instr"
  mccchannel_7_cave2_cyl1_priority = 907.5;
#line 2192 "MACS_sample_kidney_box.instr"
  mccchannel_7_cave2_cyl1_radius = kidney_cave2_cyl1_radius;
#line 2192 "MACS_sample_kidney_box.instr"
  mccchannel_7_cave2_cyl1_yheight = kidney_cave2_cyl1_height;
#line 67 "MACS_sample_kidney_box.instr"
  mccchannel_7_cave2_cyl1_visualize = 1;
#line 67 "MACS_sample_kidney_box.instr"
  mccchannel_7_cave2_cyl1_target_index = 0;
#line 67 "MACS_sample_kidney_box.instr"
  mccchannel_7_cave2_cyl1_target_x = 0;
#line 67 "MACS_sample_kidney_box.instr"
  mccchannel_7_cave2_cyl1_target_y = 0;
#line 67 "MACS_sample_kidney_box.instr"
  mccchannel_7_cave2_cyl1_target_z = 0;
#line 67 "MACS_sample_kidney_box.instr"
  mccchannel_7_cave2_cyl1_focus_aw = 0;
#line 67 "MACS_sample_kidney_box.instr"
  mccchannel_7_cave2_cyl1_focus_ah = 0;
#line 67 "MACS_sample_kidney_box.instr"
  mccchannel_7_cave2_cyl1_focus_xw = 0;
#line 67 "MACS_sample_kidney_box.instr"
  mccchannel_7_cave2_cyl1_focus_xh = 0;
#line 67 "MACS_sample_kidney_box.instr"
  mccchannel_7_cave2_cyl1_focus_r = 0;
#line 67 "MACS_sample_kidney_box.instr"
  mccchannel_7_cave2_cyl1_p_interact = 0;
#line 67 "MACS_sample_kidney_box.instr"
  if(0) strncpy(mccchannel_7_cave2_cyl1_mask_string, 0 ? 0 : "", 16384); else mccchannel_7_cave2_cyl1_mask_string[0]='\0';
#line 67 "MACS_sample_kidney_box.instr"
  if(0) strncpy(mccchannel_7_cave2_cyl1_mask_setting, 0 ? 0 : "", 16384); else mccchannel_7_cave2_cyl1_mask_setting[0]='\0';
#line 67 "MACS_sample_kidney_box.instr"
  mccchannel_7_cave2_cyl1_number_of_activations = 1;
#line 116941 "MACS_sample_kidney_box.c"

  SIG_MESSAGE("channel_7_cave2_cyl1 (Init:Place/Rotate)");
  rot_set_rotation(mctr1,
#line 2195 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 2195 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 2195 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD);
#line 116951 "MACS_sample_kidney_box.c"
  rot_mul(mctr1, mcrotachannel_7_analyzer_2_center, mcrotachannel_7_cave2_cyl1);
  rot_transpose(mcrotachannel_7_analyzer_2_array_crystal_array_8, mctr1);
  rot_mul(mcrotachannel_7_cave2_cyl1, mctr1, mcrotrchannel_7_cave2_cyl1);
  mctc1 = coords_set(
#line 2194 "MACS_sample_kidney_box.instr"
    0,
#line 2194 "MACS_sample_kidney_box.instr"
    0,
#line 2194 "MACS_sample_kidney_box.instr"
    spec_detector_to_analyzer_2_center);
#line 116962 "MACS_sample_kidney_box.c"
  rot_transpose(mcrotachannel_7_analyzer_2_center, mctr1);
  mctc2 = rot_apply(mctr1, mctc1);
  mcposachannel_7_cave2_cyl1 = coords_add(mcposachannel_7_analyzer_2_center, mctc2);
  mctc1 = coords_sub(mcposachannel_7_analyzer_2_array_crystal_array_8, mcposachannel_7_cave2_cyl1);
  mcposrchannel_7_cave2_cyl1 = rot_apply(mcrotachannel_7_cave2_cyl1, mctc1);
  mcDEBUG_COMPONENT("channel_7_cave2_cyl1", mcposachannel_7_cave2_cyl1, mcrotachannel_7_cave2_cyl1)
  mccomp_posa[416] = mcposachannel_7_cave2_cyl1;
  mccomp_posr[416] = mcposrchannel_7_cave2_cyl1;
  mcNCounter[416]  = mcPCounter[416] = mcP2Counter[416] = 0;
  mcAbsorbProp[416]= 0;
    /* Component channel_7_cave2_box1. */
  /* Setting parameters for component channel_7_cave2_box1. */
  SIG_MESSAGE("channel_7_cave2_box1 (Init:SetPar)");
#line 2200 "MACS_sample_kidney_box.instr"
  if("Vacuum") strncpy(mccchannel_7_cave2_box1_material_string, "Vacuum" ? "Vacuum" : "", 16384); else mccchannel_7_cave2_box1_material_string[0]='\0';
#line 2200 "MACS_sample_kidney_box.instr"
  mccchannel_7_cave2_box1_priority = 901;
#line 2198 "MACS_sample_kidney_box.instr"
  mccchannel_7_cave2_box1_xwidth = kidney_cave2_box1_width1;
#line 2198 "MACS_sample_kidney_box.instr"
  mccchannel_7_cave2_box1_yheight = kidney_cave2_box1_height1;
#line 2198 "MACS_sample_kidney_box.instr"
  mccchannel_7_cave2_box1_zdepth = kidney_cave2_box1_depth;
#line 2199 "MACS_sample_kidney_box.instr"
  mccchannel_7_cave2_box1_xwidth2 = kidney_cave2_box1_width2;
#line 2199 "MACS_sample_kidney_box.instr"
  mccchannel_7_cave2_box1_yheight2 = kidney_cave2_box1_height2;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_7_cave2_box1_visualize = 1;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_7_cave2_box1_target_index = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_7_cave2_box1_target_x = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_7_cave2_box1_target_y = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_7_cave2_box1_target_z = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_7_cave2_box1_focus_aw = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_7_cave2_box1_focus_ah = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_7_cave2_box1_focus_xw = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_7_cave2_box1_focus_xh = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_7_cave2_box1_focus_r = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_7_cave2_box1_p_interact = 0;
#line 71 "MACS_sample_kidney_box.instr"
  if(0) strncpy(mccchannel_7_cave2_box1_mask_string, 0 ? 0 : "", 16384); else mccchannel_7_cave2_box1_mask_string[0]='\0';
#line 71 "MACS_sample_kidney_box.instr"
  if(0) strncpy(mccchannel_7_cave2_box1_mask_setting, 0 ? 0 : "", 16384); else mccchannel_7_cave2_box1_mask_setting[0]='\0';
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_7_cave2_box1_number_of_activations = 1;
#line 117018 "MACS_sample_kidney_box.c"

  SIG_MESSAGE("channel_7_cave2_box1 (Init:Place/Rotate)");
  rot_set_rotation(mctr1,
#line 2202 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 2202 "MACS_sample_kidney_box.instr"
    (kidney_cave2_box1_y_rotation)*DEG2RAD,
#line 2202 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD);
#line 117028 "MACS_sample_kidney_box.c"
  rot_mul(mctr1, mcrotachannel_7_cave2_cyl1, mcrotachannel_7_cave2_box1);
  rot_transpose(mcrotachannel_7_cave2_cyl1, mctr1);
  rot_mul(mcrotachannel_7_cave2_box1, mctr1, mcrotrchannel_7_cave2_box1);
  mctc1 = coords_set(
#line 2201 "MACS_sample_kidney_box.instr"
    kidney_cave2_box1_center_to_spec_detector_x,
#line 2201 "MACS_sample_kidney_box.instr"
    0,
#line 2201 "MACS_sample_kidney_box.instr"
    kidney_cave2_box1_center_to_spec_detector_z);
#line 117039 "MACS_sample_kidney_box.c"
  rot_transpose(mcrotachannel_7_cave2_cyl1, mctr1);
  mctc2 = rot_apply(mctr1, mctc1);
  mcposachannel_7_cave2_box1 = coords_add(mcposachannel_7_cave2_cyl1, mctc2);
  mctc1 = coords_sub(mcposachannel_7_cave2_cyl1, mcposachannel_7_cave2_box1);
  mcposrchannel_7_cave2_box1 = rot_apply(mcrotachannel_7_cave2_box1, mctc1);
  mcDEBUG_COMPONENT("channel_7_cave2_box1", mcposachannel_7_cave2_box1, mcrotachannel_7_cave2_box1)
  mccomp_posa[417] = mcposachannel_7_cave2_box1;
  mccomp_posr[417] = mcposrchannel_7_cave2_box1;
  mcNCounter[417]  = mcPCounter[417] = mcP2Counter[417] = 0;
  mcAbsorbProp[417]= 0;
    /* Component channel_7_cave2_box2. */
  /* Setting parameters for component channel_7_cave2_box2. */
  SIG_MESSAGE("channel_7_cave2_box2 (Init:SetPar)");
#line 2207 "MACS_sample_kidney_box.instr"
  if("Vacuum") strncpy(mccchannel_7_cave2_box2_material_string, "Vacuum" ? "Vacuum" : "", 16384); else mccchannel_7_cave2_box2_material_string[0]='\0';
#line 2207 "MACS_sample_kidney_box.instr"
  mccchannel_7_cave2_box2_priority = 906;
#line 2205 "MACS_sample_kidney_box.instr"
  mccchannel_7_cave2_box2_xwidth = kidney_cave2_box2_width1;
#line 2205 "MACS_sample_kidney_box.instr"
  mccchannel_7_cave2_box2_yheight = kidney_cave2_box2_height1;
#line 2205 "MACS_sample_kidney_box.instr"
  mccchannel_7_cave2_box2_zdepth = kidney_cave2_box2_depth;
#line 2206 "MACS_sample_kidney_box.instr"
  mccchannel_7_cave2_box2_xwidth2 = kidney_cave2_box2_width2;
#line 2206 "MACS_sample_kidney_box.instr"
  mccchannel_7_cave2_box2_yheight2 = kidney_cave2_box2_height2;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_7_cave2_box2_visualize = 1;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_7_cave2_box2_target_index = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_7_cave2_box2_target_x = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_7_cave2_box2_target_y = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_7_cave2_box2_target_z = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_7_cave2_box2_focus_aw = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_7_cave2_box2_focus_ah = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_7_cave2_box2_focus_xw = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_7_cave2_box2_focus_xh = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_7_cave2_box2_focus_r = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_7_cave2_box2_p_interact = 0;
#line 71 "MACS_sample_kidney_box.instr"
  if(0) strncpy(mccchannel_7_cave2_box2_mask_string, 0 ? 0 : "", 16384); else mccchannel_7_cave2_box2_mask_string[0]='\0';
#line 71 "MACS_sample_kidney_box.instr"
  if(0) strncpy(mccchannel_7_cave2_box2_mask_setting, 0 ? 0 : "", 16384); else mccchannel_7_cave2_box2_mask_setting[0]='\0';
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_7_cave2_box2_number_of_activations = 1;
#line 117095 "MACS_sample_kidney_box.c"

  SIG_MESSAGE("channel_7_cave2_box2 (Init:Place/Rotate)");
  rot_set_rotation(mctr1,
#line 2209 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 2209 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 2209 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD);
#line 117105 "MACS_sample_kidney_box.c"
  rot_mul(mctr1, mcrotachannel_7_cave2_cyl1, mcrotachannel_7_cave2_box2);
  rot_transpose(mcrotachannel_7_cave2_box1, mctr1);
  rot_mul(mcrotachannel_7_cave2_box2, mctr1, mcrotrchannel_7_cave2_box2);
  mctc1 = coords_set(
#line 2208 "MACS_sample_kidney_box.instr"
    0,
#line 2208 "MACS_sample_kidney_box.instr"
    0,
#line 2208 "MACS_sample_kidney_box.instr"
    kidney_cave2_box2_center_to_detector);
#line 117116 "MACS_sample_kidney_box.c"
  rot_transpose(mcrotachannel_7_cave2_cyl1, mctr1);
  mctc2 = rot_apply(mctr1, mctc1);
  mcposachannel_7_cave2_box2 = coords_add(mcposachannel_7_cave2_cyl1, mctc2);
  mctc1 = coords_sub(mcposachannel_7_cave2_box1, mcposachannel_7_cave2_box2);
  mcposrchannel_7_cave2_box2 = rot_apply(mcrotachannel_7_cave2_box2, mctc1);
  mcDEBUG_COMPONENT("channel_7_cave2_box2", mcposachannel_7_cave2_box2, mcrotachannel_7_cave2_box2)
  mccomp_posa[418] = mcposachannel_7_cave2_box2;
  mccomp_posr[418] = mcposrchannel_7_cave2_box2;
  mcNCounter[418]  = mcPCounter[418] = mcP2Counter[418] = 0;
  mcAbsorbProp[418]= 0;
    /* Component channel_7_cave2_box3. */
  /* Setting parameters for component channel_7_cave2_box3. */
  SIG_MESSAGE("channel_7_cave2_box3 (Init:SetPar)");
#line 2214 "MACS_sample_kidney_box.instr"
  if("Vacuum") strncpy(mccchannel_7_cave2_box3_material_string, "Vacuum" ? "Vacuum" : "", 16384); else mccchannel_7_cave2_box3_material_string[0]='\0';
#line 2214 "MACS_sample_kidney_box.instr"
  mccchannel_7_cave2_box3_priority = 907;
#line 2212 "MACS_sample_kidney_box.instr"
  mccchannel_7_cave2_box3_xwidth = kidney_cave2_box3_width1;
#line 2212 "MACS_sample_kidney_box.instr"
  mccchannel_7_cave2_box3_yheight = kidney_cave2_box3_height1;
#line 2212 "MACS_sample_kidney_box.instr"
  mccchannel_7_cave2_box3_zdepth = kidney_cave2_box3_depth;
#line 2213 "MACS_sample_kidney_box.instr"
  mccchannel_7_cave2_box3_xwidth2 = kidney_cave2_box3_width2;
#line 2213 "MACS_sample_kidney_box.instr"
  mccchannel_7_cave2_box3_yheight2 = kidney_cave2_box3_height2;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_7_cave2_box3_visualize = 1;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_7_cave2_box3_target_index = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_7_cave2_box3_target_x = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_7_cave2_box3_target_y = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_7_cave2_box3_target_z = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_7_cave2_box3_focus_aw = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_7_cave2_box3_focus_ah = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_7_cave2_box3_focus_xw = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_7_cave2_box3_focus_xh = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_7_cave2_box3_focus_r = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_7_cave2_box3_p_interact = 0;
#line 71 "MACS_sample_kidney_box.instr"
  if(0) strncpy(mccchannel_7_cave2_box3_mask_string, 0 ? 0 : "", 16384); else mccchannel_7_cave2_box3_mask_string[0]='\0';
#line 71 "MACS_sample_kidney_box.instr"
  if(0) strncpy(mccchannel_7_cave2_box3_mask_setting, 0 ? 0 : "", 16384); else mccchannel_7_cave2_box3_mask_setting[0]='\0';
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_7_cave2_box3_number_of_activations = 1;
#line 117172 "MACS_sample_kidney_box.c"

  SIG_MESSAGE("channel_7_cave2_box3 (Init:Place/Rotate)");
  rot_set_rotation(mctr1,
#line 2216 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 2216 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 2216 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD);
#line 117182 "MACS_sample_kidney_box.c"
  rot_mul(mctr1, mcrotachannel_7_cave2_cyl1, mcrotachannel_7_cave2_box3);
  rot_transpose(mcrotachannel_7_cave2_box2, mctr1);
  rot_mul(mcrotachannel_7_cave2_box3, mctr1, mcrotrchannel_7_cave2_box3);
  mctc1 = coords_set(
#line 2215 "MACS_sample_kidney_box.instr"
    0,
#line 2215 "MACS_sample_kidney_box.instr"
    0,
#line 2215 "MACS_sample_kidney_box.instr"
    kidney_cave2_box3_center_to_detector);
#line 117193 "MACS_sample_kidney_box.c"
  rot_transpose(mcrotachannel_7_cave2_cyl1, mctr1);
  mctc2 = rot_apply(mctr1, mctc1);
  mcposachannel_7_cave2_box3 = coords_add(mcposachannel_7_cave2_cyl1, mctc2);
  mctc1 = coords_sub(mcposachannel_7_cave2_box2, mcposachannel_7_cave2_box3);
  mcposrchannel_7_cave2_box3 = rot_apply(mcrotachannel_7_cave2_box3, mctc1);
  mcDEBUG_COMPONENT("channel_7_cave2_box3", mcposachannel_7_cave2_box3, mcrotachannel_7_cave2_box3)
  mccomp_posa[419] = mcposachannel_7_cave2_box3;
  mccomp_posr[419] = mcposrchannel_7_cave2_box3;
  mcNCounter[419]  = mcPCounter[419] = mcP2Counter[419] = 0;
  mcAbsorbProp[419]= 0;
    /* Component inter_analyzer_colimator_center_7. */
  /* Setting parameters for component inter_analyzer_colimator_center_7. */
  SIG_MESSAGE("inter_analyzer_colimator_center_7 (Init:SetPar)");

  SIG_MESSAGE("inter_analyzer_colimator_center_7 (Init:Place/Rotate)");
  rot_set_rotation(mctr1,
#line 2220 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 2220 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 2220 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD);
#line 117216 "MACS_sample_kidney_box.c"
  rot_mul(mctr1, mcrotachannel_7_analyzer_1_center, mcrotainter_analyzer_colimator_center_7);
  rot_transpose(mcrotachannel_7_cave2_box3, mctr1);
  rot_mul(mcrotainter_analyzer_colimator_center_7, mctr1, mcrotrinter_analyzer_colimator_center_7);
  mctc1 = coords_set(
#line 2219 "MACS_sample_kidney_box.instr"
    -0.5 * analyzer_seperation,
#line 2219 "MACS_sample_kidney_box.instr"
    0,
#line 2219 "MACS_sample_kidney_box.instr"
    0);
#line 117227 "MACS_sample_kidney_box.c"
  rot_transpose(mcrotachannel_7_analyzer_1_center, mctr1);
  mctc2 = rot_apply(mctr1, mctc1);
  mcposainter_analyzer_colimator_center_7 = coords_add(mcposachannel_7_analyzer_1_center, mctc2);
  mctc1 = coords_sub(mcposachannel_7_cave2_box3, mcposainter_analyzer_colimator_center_7);
  mcposrinter_analyzer_colimator_center_7 = rot_apply(mcrotainter_analyzer_colimator_center_7, mctc1);
  mcDEBUG_COMPONENT("inter_analyzer_colimator_center_7", mcposainter_analyzer_colimator_center_7, mcrotainter_analyzer_colimator_center_7)
  mccomp_posa[420] = mcposainter_analyzer_colimator_center_7;
  mccomp_posr[420] = mcposrinter_analyzer_colimator_center_7;
  mcNCounter[420]  = mcPCounter[420] = mcP2Counter[420] = 0;
  mcAbsorbProp[420]= 0;
    /* Component inter_analyzer_colimator_7_blade_0. */
  /* Setting parameters for component inter_analyzer_colimator_7_blade_0. */
  SIG_MESSAGE("inter_analyzer_colimator_7_blade_0 (Init:SetPar)");
#line 2224 "MACS_sample_kidney_box.instr"
  if("Collimator_gad") strncpy(mccinter_analyzer_colimator_7_blade_0_material_string, "Collimator_gad" ? "Collimator_gad" : "", 16384); else mccinter_analyzer_colimator_7_blade_0_material_string[0]='\0';
#line 2224 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_7_blade_0_priority = 925;
#line 2223 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_7_blade_0_xwidth = inter_analyzer_colimator_width;
#line 2223 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_7_blade_0_yheight = inter_analyzer_colimator_height;
#line 2223 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_7_blade_0_zdepth = inter_analyzer_colimator_depth;
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_7_blade_0_xwidth2 = -1;
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_7_blade_0_yheight2 = -1;
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_7_blade_0_visualize = 1;
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_7_blade_0_target_index = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_7_blade_0_target_x = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_7_blade_0_target_y = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_7_blade_0_target_z = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_7_blade_0_focus_aw = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_7_blade_0_focus_ah = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_7_blade_0_focus_xw = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_7_blade_0_focus_xh = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_7_blade_0_focus_r = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_7_blade_0_p_interact = 0;
#line 71 "MACS_sample_kidney_box.instr"
  if(0) strncpy(mccinter_analyzer_colimator_7_blade_0_mask_string, 0 ? 0 : "", 16384); else mccinter_analyzer_colimator_7_blade_0_mask_string[0]='\0';
#line 71 "MACS_sample_kidney_box.instr"
  if(0) strncpy(mccinter_analyzer_colimator_7_blade_0_mask_setting, 0 ? 0 : "", 16384); else mccinter_analyzer_colimator_7_blade_0_mask_setting[0]='\0';
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_7_blade_0_number_of_activations = 1;
#line 117283 "MACS_sample_kidney_box.c"

  SIG_MESSAGE("inter_analyzer_colimator_7_blade_0 (Init:Place/Rotate)");
  rot_set_rotation(mctr1,
#line 2226 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 2226 "MACS_sample_kidney_box.instr"
    (- analyzer_2theta [ 7 ])*DEG2RAD,
#line 2226 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD);
#line 117293 "MACS_sample_kidney_box.c"
  rot_mul(mctr1, mcrotainter_analyzer_colimator_center_7, mcrotainter_analyzer_colimator_7_blade_0);
  rot_transpose(mcrotainter_analyzer_colimator_center_7, mctr1);
  rot_mul(mcrotainter_analyzer_colimator_7_blade_0, mctr1, mcrotrinter_analyzer_colimator_7_blade_0);
  mctc1 = coords_set(
#line 2225 "MACS_sample_kidney_box.instr"
    0,
#line 2225 "MACS_sample_kidney_box.instr"
    0,
#line 2225 "MACS_sample_kidney_box.instr"
    inter_analyzer_colimator_start_pos - 0 * inter_analyzer_colimator_seperation);
#line 117304 "MACS_sample_kidney_box.c"
  rot_transpose(mcrotainter_analyzer_colimator_center_7, mctr1);
  mctc2 = rot_apply(mctr1, mctc1);
  mcposainter_analyzer_colimator_7_blade_0 = coords_add(mcposainter_analyzer_colimator_center_7, mctc2);
  mctc1 = coords_sub(mcposainter_analyzer_colimator_center_7, mcposainter_analyzer_colimator_7_blade_0);
  mcposrinter_analyzer_colimator_7_blade_0 = rot_apply(mcrotainter_analyzer_colimator_7_blade_0, mctc1);
  mcDEBUG_COMPONENT("inter_analyzer_colimator_7_blade_0", mcposainter_analyzer_colimator_7_blade_0, mcrotainter_analyzer_colimator_7_blade_0)
  mccomp_posa[421] = mcposainter_analyzer_colimator_7_blade_0;
  mccomp_posr[421] = mcposrinter_analyzer_colimator_7_blade_0;
  mcNCounter[421]  = mcPCounter[421] = mcP2Counter[421] = 0;
  mcAbsorbProp[421]= 0;
    /* Component inter_analyzer_colimator_7_blade_1. */
  /* Setting parameters for component inter_analyzer_colimator_7_blade_1. */
  SIG_MESSAGE("inter_analyzer_colimator_7_blade_1 (Init:SetPar)");
#line 2230 "MACS_sample_kidney_box.instr"
  if("Collimator_gad") strncpy(mccinter_analyzer_colimator_7_blade_1_material_string, "Collimator_gad" ? "Collimator_gad" : "", 16384); else mccinter_analyzer_colimator_7_blade_1_material_string[0]='\0';
#line 2230 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_7_blade_1_priority = 926;
#line 2229 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_7_blade_1_xwidth = inter_analyzer_colimator_width;
#line 2229 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_7_blade_1_yheight = inter_analyzer_colimator_height;
#line 2229 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_7_blade_1_zdepth = inter_analyzer_colimator_depth;
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_7_blade_1_xwidth2 = -1;
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_7_blade_1_yheight2 = -1;
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_7_blade_1_visualize = 1;
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_7_blade_1_target_index = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_7_blade_1_target_x = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_7_blade_1_target_y = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_7_blade_1_target_z = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_7_blade_1_focus_aw = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_7_blade_1_focus_ah = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_7_blade_1_focus_xw = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_7_blade_1_focus_xh = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_7_blade_1_focus_r = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_7_blade_1_p_interact = 0;
#line 71 "MACS_sample_kidney_box.instr"
  if(0) strncpy(mccinter_analyzer_colimator_7_blade_1_mask_string, 0 ? 0 : "", 16384); else mccinter_analyzer_colimator_7_blade_1_mask_string[0]='\0';
#line 71 "MACS_sample_kidney_box.instr"
  if(0) strncpy(mccinter_analyzer_colimator_7_blade_1_mask_setting, 0 ? 0 : "", 16384); else mccinter_analyzer_colimator_7_blade_1_mask_setting[0]='\0';
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_7_blade_1_number_of_activations = 1;
#line 117360 "MACS_sample_kidney_box.c"

  SIG_MESSAGE("inter_analyzer_colimator_7_blade_1 (Init:Place/Rotate)");
  rot_set_rotation(mctr1,
#line 2232 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 2232 "MACS_sample_kidney_box.instr"
    (- analyzer_2theta [ 7 ])*DEG2RAD,
#line 2232 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD);
#line 117370 "MACS_sample_kidney_box.c"
  rot_mul(mctr1, mcrotainter_analyzer_colimator_center_7, mcrotainter_analyzer_colimator_7_blade_1);
  rot_transpose(mcrotainter_analyzer_colimator_7_blade_0, mctr1);
  rot_mul(mcrotainter_analyzer_colimator_7_blade_1, mctr1, mcrotrinter_analyzer_colimator_7_blade_1);
  mctc1 = coords_set(
#line 2231 "MACS_sample_kidney_box.instr"
    0,
#line 2231 "MACS_sample_kidney_box.instr"
    0,
#line 2231 "MACS_sample_kidney_box.instr"
    inter_analyzer_colimator_start_pos - 1 * inter_analyzer_colimator_seperation);
#line 117381 "MACS_sample_kidney_box.c"
  rot_transpose(mcrotainter_analyzer_colimator_center_7, mctr1);
  mctc2 = rot_apply(mctr1, mctc1);
  mcposainter_analyzer_colimator_7_blade_1 = coords_add(mcposainter_analyzer_colimator_center_7, mctc2);
  mctc1 = coords_sub(mcposainter_analyzer_colimator_7_blade_0, mcposainter_analyzer_colimator_7_blade_1);
  mcposrinter_analyzer_colimator_7_blade_1 = rot_apply(mcrotainter_analyzer_colimator_7_blade_1, mctc1);
  mcDEBUG_COMPONENT("inter_analyzer_colimator_7_blade_1", mcposainter_analyzer_colimator_7_blade_1, mcrotainter_analyzer_colimator_7_blade_1)
  mccomp_posa[422] = mcposainter_analyzer_colimator_7_blade_1;
  mccomp_posr[422] = mcposrinter_analyzer_colimator_7_blade_1;
  mcNCounter[422]  = mcPCounter[422] = mcP2Counter[422] = 0;
  mcAbsorbProp[422]= 0;
    /* Component inter_analyzer_colimator_7_blade_2. */
  /* Setting parameters for component inter_analyzer_colimator_7_blade_2. */
  SIG_MESSAGE("inter_analyzer_colimator_7_blade_2 (Init:SetPar)");
#line 2236 "MACS_sample_kidney_box.instr"
  if("Collimator_gad") strncpy(mccinter_analyzer_colimator_7_blade_2_material_string, "Collimator_gad" ? "Collimator_gad" : "", 16384); else mccinter_analyzer_colimator_7_blade_2_material_string[0]='\0';
#line 2236 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_7_blade_2_priority = 927;
#line 2235 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_7_blade_2_xwidth = inter_analyzer_colimator_width;
#line 2235 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_7_blade_2_yheight = inter_analyzer_colimator_height;
#line 2235 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_7_blade_2_zdepth = inter_analyzer_colimator_depth;
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_7_blade_2_xwidth2 = -1;
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_7_blade_2_yheight2 = -1;
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_7_blade_2_visualize = 1;
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_7_blade_2_target_index = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_7_blade_2_target_x = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_7_blade_2_target_y = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_7_blade_2_target_z = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_7_blade_2_focus_aw = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_7_blade_2_focus_ah = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_7_blade_2_focus_xw = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_7_blade_2_focus_xh = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_7_blade_2_focus_r = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_7_blade_2_p_interact = 0;
#line 71 "MACS_sample_kidney_box.instr"
  if(0) strncpy(mccinter_analyzer_colimator_7_blade_2_mask_string, 0 ? 0 : "", 16384); else mccinter_analyzer_colimator_7_blade_2_mask_string[0]='\0';
#line 71 "MACS_sample_kidney_box.instr"
  if(0) strncpy(mccinter_analyzer_colimator_7_blade_2_mask_setting, 0 ? 0 : "", 16384); else mccinter_analyzer_colimator_7_blade_2_mask_setting[0]='\0';
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_7_blade_2_number_of_activations = 1;
#line 117437 "MACS_sample_kidney_box.c"

  SIG_MESSAGE("inter_analyzer_colimator_7_blade_2 (Init:Place/Rotate)");
  rot_set_rotation(mctr1,
#line 2238 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 2238 "MACS_sample_kidney_box.instr"
    (- analyzer_2theta [ 7 ])*DEG2RAD,
#line 2238 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD);
#line 117447 "MACS_sample_kidney_box.c"
  rot_mul(mctr1, mcrotainter_analyzer_colimator_center_7, mcrotainter_analyzer_colimator_7_blade_2);
  rot_transpose(mcrotainter_analyzer_colimator_7_blade_1, mctr1);
  rot_mul(mcrotainter_analyzer_colimator_7_blade_2, mctr1, mcrotrinter_analyzer_colimator_7_blade_2);
  mctc1 = coords_set(
#line 2237 "MACS_sample_kidney_box.instr"
    0,
#line 2237 "MACS_sample_kidney_box.instr"
    0,
#line 2237 "MACS_sample_kidney_box.instr"
    inter_analyzer_colimator_start_pos - 2 * inter_analyzer_colimator_seperation);
#line 117458 "MACS_sample_kidney_box.c"
  rot_transpose(mcrotainter_analyzer_colimator_center_7, mctr1);
  mctc2 = rot_apply(mctr1, mctc1);
  mcposainter_analyzer_colimator_7_blade_2 = coords_add(mcposainter_analyzer_colimator_center_7, mctc2);
  mctc1 = coords_sub(mcposainter_analyzer_colimator_7_blade_1, mcposainter_analyzer_colimator_7_blade_2);
  mcposrinter_analyzer_colimator_7_blade_2 = rot_apply(mcrotainter_analyzer_colimator_7_blade_2, mctc1);
  mcDEBUG_COMPONENT("inter_analyzer_colimator_7_blade_2", mcposainter_analyzer_colimator_7_blade_2, mcrotainter_analyzer_colimator_7_blade_2)
  mccomp_posa[423] = mcposainter_analyzer_colimator_7_blade_2;
  mccomp_posr[423] = mcposrinter_analyzer_colimator_7_blade_2;
  mcNCounter[423]  = mcPCounter[423] = mcP2Counter[423] = 0;
  mcAbsorbProp[423]= 0;
    /* Component inter_analyzer_colimator_7_blade_3. */
  /* Setting parameters for component inter_analyzer_colimator_7_blade_3. */
  SIG_MESSAGE("inter_analyzer_colimator_7_blade_3 (Init:SetPar)");
#line 2242 "MACS_sample_kidney_box.instr"
  if("Collimator_gad") strncpy(mccinter_analyzer_colimator_7_blade_3_material_string, "Collimator_gad" ? "Collimator_gad" : "", 16384); else mccinter_analyzer_colimator_7_blade_3_material_string[0]='\0';
#line 2242 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_7_blade_3_priority = 928;
#line 2241 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_7_blade_3_xwidth = inter_analyzer_colimator_width;
#line 2241 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_7_blade_3_yheight = inter_analyzer_colimator_height;
#line 2241 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_7_blade_3_zdepth = inter_analyzer_colimator_depth;
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_7_blade_3_xwidth2 = -1;
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_7_blade_3_yheight2 = -1;
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_7_blade_3_visualize = 1;
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_7_blade_3_target_index = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_7_blade_3_target_x = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_7_blade_3_target_y = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_7_blade_3_target_z = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_7_blade_3_focus_aw = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_7_blade_3_focus_ah = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_7_blade_3_focus_xw = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_7_blade_3_focus_xh = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_7_blade_3_focus_r = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_7_blade_3_p_interact = 0;
#line 71 "MACS_sample_kidney_box.instr"
  if(0) strncpy(mccinter_analyzer_colimator_7_blade_3_mask_string, 0 ? 0 : "", 16384); else mccinter_analyzer_colimator_7_blade_3_mask_string[0]='\0';
#line 71 "MACS_sample_kidney_box.instr"
  if(0) strncpy(mccinter_analyzer_colimator_7_blade_3_mask_setting, 0 ? 0 : "", 16384); else mccinter_analyzer_colimator_7_blade_3_mask_setting[0]='\0';
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_7_blade_3_number_of_activations = 1;
#line 117514 "MACS_sample_kidney_box.c"

  SIG_MESSAGE("inter_analyzer_colimator_7_blade_3 (Init:Place/Rotate)");
  rot_set_rotation(mctr1,
#line 2244 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 2244 "MACS_sample_kidney_box.instr"
    (- analyzer_2theta [ 7 ])*DEG2RAD,
#line 2244 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD);
#line 117524 "MACS_sample_kidney_box.c"
  rot_mul(mctr1, mcrotainter_analyzer_colimator_center_7, mcrotainter_analyzer_colimator_7_blade_3);
  rot_transpose(mcrotainter_analyzer_colimator_7_blade_2, mctr1);
  rot_mul(mcrotainter_analyzer_colimator_7_blade_3, mctr1, mcrotrinter_analyzer_colimator_7_blade_3);
  mctc1 = coords_set(
#line 2243 "MACS_sample_kidney_box.instr"
    0,
#line 2243 "MACS_sample_kidney_box.instr"
    0,
#line 2243 "MACS_sample_kidney_box.instr"
    inter_analyzer_colimator_start_pos - 3 * inter_analyzer_colimator_seperation);
#line 117535 "MACS_sample_kidney_box.c"
  rot_transpose(mcrotainter_analyzer_colimator_center_7, mctr1);
  mctc2 = rot_apply(mctr1, mctc1);
  mcposainter_analyzer_colimator_7_blade_3 = coords_add(mcposainter_analyzer_colimator_center_7, mctc2);
  mctc1 = coords_sub(mcposainter_analyzer_colimator_7_blade_2, mcposainter_analyzer_colimator_7_blade_3);
  mcposrinter_analyzer_colimator_7_blade_3 = rot_apply(mcrotainter_analyzer_colimator_7_blade_3, mctc1);
  mcDEBUG_COMPONENT("inter_analyzer_colimator_7_blade_3", mcposainter_analyzer_colimator_7_blade_3, mcrotainter_analyzer_colimator_7_blade_3)
  mccomp_posa[424] = mcposainter_analyzer_colimator_7_blade_3;
  mccomp_posr[424] = mcposrinter_analyzer_colimator_7_blade_3;
  mcNCounter[424]  = mcPCounter[424] = mcP2Counter[424] = 0;
  mcAbsorbProp[424]= 0;
    /* Component inter_analyzer_colimator_7_blade_4. */
  /* Setting parameters for component inter_analyzer_colimator_7_blade_4. */
  SIG_MESSAGE("inter_analyzer_colimator_7_blade_4 (Init:SetPar)");
#line 2248 "MACS_sample_kidney_box.instr"
  if("Collimator_gad") strncpy(mccinter_analyzer_colimator_7_blade_4_material_string, "Collimator_gad" ? "Collimator_gad" : "", 16384); else mccinter_analyzer_colimator_7_blade_4_material_string[0]='\0';
#line 2248 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_7_blade_4_priority = 929;
#line 2247 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_7_blade_4_xwidth = inter_analyzer_colimator_width;
#line 2247 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_7_blade_4_yheight = inter_analyzer_colimator_height;
#line 2247 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_7_blade_4_zdepth = inter_analyzer_colimator_depth;
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_7_blade_4_xwidth2 = -1;
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_7_blade_4_yheight2 = -1;
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_7_blade_4_visualize = 1;
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_7_blade_4_target_index = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_7_blade_4_target_x = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_7_blade_4_target_y = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_7_blade_4_target_z = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_7_blade_4_focus_aw = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_7_blade_4_focus_ah = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_7_blade_4_focus_xw = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_7_blade_4_focus_xh = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_7_blade_4_focus_r = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_7_blade_4_p_interact = 0;
#line 71 "MACS_sample_kidney_box.instr"
  if(0) strncpy(mccinter_analyzer_colimator_7_blade_4_mask_string, 0 ? 0 : "", 16384); else mccinter_analyzer_colimator_7_blade_4_mask_string[0]='\0';
#line 71 "MACS_sample_kidney_box.instr"
  if(0) strncpy(mccinter_analyzer_colimator_7_blade_4_mask_setting, 0 ? 0 : "", 16384); else mccinter_analyzer_colimator_7_blade_4_mask_setting[0]='\0';
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_7_blade_4_number_of_activations = 1;
#line 117591 "MACS_sample_kidney_box.c"

  SIG_MESSAGE("inter_analyzer_colimator_7_blade_4 (Init:Place/Rotate)");
  rot_set_rotation(mctr1,
#line 2250 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 2250 "MACS_sample_kidney_box.instr"
    (- analyzer_2theta [ 7 ])*DEG2RAD,
#line 2250 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD);
#line 117601 "MACS_sample_kidney_box.c"
  rot_mul(mctr1, mcrotainter_analyzer_colimator_center_7, mcrotainter_analyzer_colimator_7_blade_4);
  rot_transpose(mcrotainter_analyzer_colimator_7_blade_3, mctr1);
  rot_mul(mcrotainter_analyzer_colimator_7_blade_4, mctr1, mcrotrinter_analyzer_colimator_7_blade_4);
  mctc1 = coords_set(
#line 2249 "MACS_sample_kidney_box.instr"
    0,
#line 2249 "MACS_sample_kidney_box.instr"
    0,
#line 2249 "MACS_sample_kidney_box.instr"
    inter_analyzer_colimator_start_pos - 4 * inter_analyzer_colimator_seperation);
#line 117612 "MACS_sample_kidney_box.c"
  rot_transpose(mcrotainter_analyzer_colimator_center_7, mctr1);
  mctc2 = rot_apply(mctr1, mctc1);
  mcposainter_analyzer_colimator_7_blade_4 = coords_add(mcposainter_analyzer_colimator_center_7, mctc2);
  mctc1 = coords_sub(mcposainter_analyzer_colimator_7_blade_3, mcposainter_analyzer_colimator_7_blade_4);
  mcposrinter_analyzer_colimator_7_blade_4 = rot_apply(mcrotainter_analyzer_colimator_7_blade_4, mctc1);
  mcDEBUG_COMPONENT("inter_analyzer_colimator_7_blade_4", mcposainter_analyzer_colimator_7_blade_4, mcrotainter_analyzer_colimator_7_blade_4)
  mccomp_posa[425] = mcposainter_analyzer_colimator_7_blade_4;
  mccomp_posr[425] = mcposrinter_analyzer_colimator_7_blade_4;
  mcNCounter[425]  = mcPCounter[425] = mcP2Counter[425] = 0;
  mcAbsorbProp[425]= 0;
    /* Component diffraction_detector_7_exit_volume. */
  /* Setting parameters for component diffraction_detector_7_exit_volume. */
  SIG_MESSAGE("diffraction_detector_7_exit_volume (Init:SetPar)");
#line 2254 "MACS_sample_kidney_box.instr"
  if("Exit") strncpy(mccdiffraction_detector_7_exit_volume_material_string, "Exit" ? "Exit" : "", 16384); else mccdiffraction_detector_7_exit_volume_material_string[0]='\0';
#line 2254 "MACS_sample_kidney_box.instr"
  mccdiffraction_detector_7_exit_volume_priority = 931;
#line 2253 "MACS_sample_kidney_box.instr"
  mccdiffraction_detector_7_exit_volume_xwidth = 2.01 * detector_radius;
#line 2253 "MACS_sample_kidney_box.instr"
  mccdiffraction_detector_7_exit_volume_yheight = 1.01 * detector_height;
#line 2253 "MACS_sample_kidney_box.instr"
  mccdiffraction_detector_7_exit_volume_zdepth = 0.001;
#line 71 "MACS_sample_kidney_box.instr"
  mccdiffraction_detector_7_exit_volume_xwidth2 = -1;
#line 71 "MACS_sample_kidney_box.instr"
  mccdiffraction_detector_7_exit_volume_yheight2 = -1;
#line 71 "MACS_sample_kidney_box.instr"
  mccdiffraction_detector_7_exit_volume_visualize = 1;
#line 71 "MACS_sample_kidney_box.instr"
  mccdiffraction_detector_7_exit_volume_target_index = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccdiffraction_detector_7_exit_volume_target_x = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccdiffraction_detector_7_exit_volume_target_y = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccdiffraction_detector_7_exit_volume_target_z = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccdiffraction_detector_7_exit_volume_focus_aw = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccdiffraction_detector_7_exit_volume_focus_ah = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccdiffraction_detector_7_exit_volume_focus_xw = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccdiffraction_detector_7_exit_volume_focus_xh = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccdiffraction_detector_7_exit_volume_focus_r = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccdiffraction_detector_7_exit_volume_p_interact = 0;
#line 71 "MACS_sample_kidney_box.instr"
  if(0) strncpy(mccdiffraction_detector_7_exit_volume_mask_string, 0 ? 0 : "", 16384); else mccdiffraction_detector_7_exit_volume_mask_string[0]='\0';
#line 71 "MACS_sample_kidney_box.instr"
  if(0) strncpy(mccdiffraction_detector_7_exit_volume_mask_setting, 0 ? 0 : "", 16384); else mccdiffraction_detector_7_exit_volume_mask_setting[0]='\0';
#line 71 "MACS_sample_kidney_box.instr"
  mccdiffraction_detector_7_exit_volume_number_of_activations = 1;
#line 117668 "MACS_sample_kidney_box.c"

  SIG_MESSAGE("diffraction_detector_7_exit_volume (Init:Place/Rotate)");
  rot_set_rotation(mctr1,
#line 2256 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 2256 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 2256 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD);
#line 117678 "MACS_sample_kidney_box.c"
  rot_mul(mctr1, mcrotakidney_channel_7, mcrotadiffraction_detector_7_exit_volume);
  rot_transpose(mcrotainter_analyzer_colimator_7_blade_4, mctr1);
  rot_mul(mcrotadiffraction_detector_7_exit_volume, mctr1, mcrotrdiffraction_detector_7_exit_volume);
  mctc1 = coords_set(
#line 2255 "MACS_sample_kidney_box.instr"
    0,
#line 2255 "MACS_sample_kidney_box.instr"
    0,
#line 2255 "MACS_sample_kidney_box.instr"
    0);
#line 117689 "MACS_sample_kidney_box.c"
  rot_transpose(mcrotachannel_7_cave1_cyl1, mctr1);
  mctc2 = rot_apply(mctr1, mctc1);
  mcposadiffraction_detector_7_exit_volume = coords_add(mcposachannel_7_cave1_cyl1, mctc2);
  mctc1 = coords_sub(mcposainter_analyzer_colimator_7_blade_4, mcposadiffraction_detector_7_exit_volume);
  mcposrdiffraction_detector_7_exit_volume = rot_apply(mcrotadiffraction_detector_7_exit_volume, mctc1);
  mcDEBUG_COMPONENT("diffraction_detector_7_exit_volume", mcposadiffraction_detector_7_exit_volume, mcrotadiffraction_detector_7_exit_volume)
  mccomp_posa[426] = mcposadiffraction_detector_7_exit_volume;
  mccomp_posr[426] = mcposrdiffraction_detector_7_exit_volume;
  mcNCounter[426]  = mcPCounter[426] = mcP2Counter[426] = 0;
  mcAbsorbProp[426]= 0;
    /* Component spec_detector_7_exit_volume. */
  /* Setting parameters for component spec_detector_7_exit_volume. */
  SIG_MESSAGE("spec_detector_7_exit_volume (Init:SetPar)");
#line 2260 "MACS_sample_kidney_box.instr"
  if("Exit") strncpy(mccspec_detector_7_exit_volume_material_string, "Exit" ? "Exit" : "", 16384); else mccspec_detector_7_exit_volume_material_string[0]='\0';
#line 2260 "MACS_sample_kidney_box.instr"
  mccspec_detector_7_exit_volume_priority = 932;
#line 2259 "MACS_sample_kidney_box.instr"
  mccspec_detector_7_exit_volume_xwidth = 2.01 * detector_radius;
#line 2259 "MACS_sample_kidney_box.instr"
  mccspec_detector_7_exit_volume_yheight = 1.01 * detector_height;
#line 2259 "MACS_sample_kidney_box.instr"
  mccspec_detector_7_exit_volume_zdepth = 0.001;
#line 71 "MACS_sample_kidney_box.instr"
  mccspec_detector_7_exit_volume_xwidth2 = -1;
#line 71 "MACS_sample_kidney_box.instr"
  mccspec_detector_7_exit_volume_yheight2 = -1;
#line 71 "MACS_sample_kidney_box.instr"
  mccspec_detector_7_exit_volume_visualize = 1;
#line 71 "MACS_sample_kidney_box.instr"
  mccspec_detector_7_exit_volume_target_index = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccspec_detector_7_exit_volume_target_x = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccspec_detector_7_exit_volume_target_y = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccspec_detector_7_exit_volume_target_z = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccspec_detector_7_exit_volume_focus_aw = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccspec_detector_7_exit_volume_focus_ah = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccspec_detector_7_exit_volume_focus_xw = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccspec_detector_7_exit_volume_focus_xh = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccspec_detector_7_exit_volume_focus_r = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccspec_detector_7_exit_volume_p_interact = 0;
#line 71 "MACS_sample_kidney_box.instr"
  if(0) strncpy(mccspec_detector_7_exit_volume_mask_string, 0 ? 0 : "", 16384); else mccspec_detector_7_exit_volume_mask_string[0]='\0';
#line 71 "MACS_sample_kidney_box.instr"
  if(0) strncpy(mccspec_detector_7_exit_volume_mask_setting, 0 ? 0 : "", 16384); else mccspec_detector_7_exit_volume_mask_setting[0]='\0';
#line 71 "MACS_sample_kidney_box.instr"
  mccspec_detector_7_exit_volume_number_of_activations = 1;
#line 117745 "MACS_sample_kidney_box.c"

  SIG_MESSAGE("spec_detector_7_exit_volume (Init:Place/Rotate)");
  rot_set_rotation(mctr1,
#line 2262 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 2262 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 2262 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD);
#line 117755 "MACS_sample_kidney_box.c"
  rot_mul(mctr1, mcrotachannel_7_analyzer_2_center, mcrotaspec_detector_7_exit_volume);
  rot_transpose(mcrotadiffraction_detector_7_exit_volume, mctr1);
  rot_mul(mcrotaspec_detector_7_exit_volume, mctr1, mcrotrspec_detector_7_exit_volume);
  mctc1 = coords_set(
#line 2261 "MACS_sample_kidney_box.instr"
    0,
#line 2261 "MACS_sample_kidney_box.instr"
    0,
#line 2261 "MACS_sample_kidney_box.instr"
    0);
#line 117766 "MACS_sample_kidney_box.c"
  rot_transpose(mcrotachannel_7_cave2_cyl1, mctr1);
  mctc2 = rot_apply(mctr1, mctc1);
  mcposaspec_detector_7_exit_volume = coords_add(mcposachannel_7_cave2_cyl1, mctc2);
  mctc1 = coords_sub(mcposadiffraction_detector_7_exit_volume, mcposaspec_detector_7_exit_volume);
  mcposrspec_detector_7_exit_volume = rot_apply(mcrotaspec_detector_7_exit_volume, mctc1);
  mcDEBUG_COMPONENT("spec_detector_7_exit_volume", mcposaspec_detector_7_exit_volume, mcrotaspec_detector_7_exit_volume)
  mccomp_posa[427] = mcposaspec_detector_7_exit_volume;
  mccomp_posr[427] = mcposrspec_detector_7_exit_volume;
  mcNCounter[427]  = mcPCounter[427] = mcP2Counter[427] = 0;
  mcAbsorbProp[427]= 0;
    /* Component channel_8_cave1_box1. */
  /* Setting parameters for component channel_8_cave1_box1. */
  SIG_MESSAGE("channel_8_cave1_box1 (Init:SetPar)");
#line 2267 "MACS_sample_kidney_box.instr"
  if("Vacuum") strncpy(mccchannel_8_cave1_box1_material_string, "Vacuum" ? "Vacuum" : "", 16384); else mccchannel_8_cave1_box1_material_string[0]='\0';
#line 2267 "MACS_sample_kidney_box.instr"
  mccchannel_8_cave1_box1_priority = 1000;
#line 2265 "MACS_sample_kidney_box.instr"
  mccchannel_8_cave1_box1_xwidth = kidney_cave1_box1_width1;
#line 2265 "MACS_sample_kidney_box.instr"
  mccchannel_8_cave1_box1_yheight = kidney_cave1_box1_height1;
#line 2265 "MACS_sample_kidney_box.instr"
  mccchannel_8_cave1_box1_zdepth = kidney_cave1_box1_depth;
#line 2266 "MACS_sample_kidney_box.instr"
  mccchannel_8_cave1_box1_xwidth2 = kidney_cave1_box1_width2;
#line 2266 "MACS_sample_kidney_box.instr"
  mccchannel_8_cave1_box1_yheight2 = kidney_cave1_box1_height2;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_8_cave1_box1_visualize = 1;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_8_cave1_box1_target_index = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_8_cave1_box1_target_x = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_8_cave1_box1_target_y = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_8_cave1_box1_target_z = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_8_cave1_box1_focus_aw = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_8_cave1_box1_focus_ah = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_8_cave1_box1_focus_xw = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_8_cave1_box1_focus_xh = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_8_cave1_box1_focus_r = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_8_cave1_box1_p_interact = 0;
#line 71 "MACS_sample_kidney_box.instr"
  if(0) strncpy(mccchannel_8_cave1_box1_mask_string, 0 ? 0 : "", 16384); else mccchannel_8_cave1_box1_mask_string[0]='\0';
#line 71 "MACS_sample_kidney_box.instr"
  if(0) strncpy(mccchannel_8_cave1_box1_mask_setting, 0 ? 0 : "", 16384); else mccchannel_8_cave1_box1_mask_setting[0]='\0';
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_8_cave1_box1_number_of_activations = 1;
#line 117822 "MACS_sample_kidney_box.c"

  SIG_MESSAGE("channel_8_cave1_box1 (Init:Place/Rotate)");
  rot_set_rotation(mctr1,
#line 2269 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 2269 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 2269 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD);
#line 117832 "MACS_sample_kidney_box.c"
  rot_mul(mctr1, mcrotakidney_channel_8, mcrotachannel_8_cave1_box1);
  rot_transpose(mcrotaspec_detector_7_exit_volume, mctr1);
  rot_mul(mcrotachannel_8_cave1_box1, mctr1, mcrotrchannel_8_cave1_box1);
  mctc1 = coords_set(
#line 2268 "MACS_sample_kidney_box.instr"
    0,
#line 2268 "MACS_sample_kidney_box.instr"
    0,
#line 2268 "MACS_sample_kidney_box.instr"
    kidney_cave1_box1_center_to_target);
#line 117843 "MACS_sample_kidney_box.c"
  rot_transpose(mcrotakidney_channel_8, mctr1);
  mctc2 = rot_apply(mctr1, mctc1);
  mcposachannel_8_cave1_box1 = coords_add(mcposakidney_channel_8, mctc2);
  mctc1 = coords_sub(mcposaspec_detector_7_exit_volume, mcposachannel_8_cave1_box1);
  mcposrchannel_8_cave1_box1 = rot_apply(mcrotachannel_8_cave1_box1, mctc1);
  mcDEBUG_COMPONENT("channel_8_cave1_box1", mcposachannel_8_cave1_box1, mcrotachannel_8_cave1_box1)
  mccomp_posa[428] = mcposachannel_8_cave1_box1;
  mccomp_posr[428] = mcposrchannel_8_cave1_box1;
  mcNCounter[428]  = mcPCounter[428] = mcP2Counter[428] = 0;
  mcAbsorbProp[428]= 0;
    /* Component channel_8_cave1_box2. */
  /* Setting parameters for component channel_8_cave1_box2. */
  SIG_MESSAGE("channel_8_cave1_box2 (Init:SetPar)");
#line 2274 "MACS_sample_kidney_box.instr"
  if("Vacuum") strncpy(mccchannel_8_cave1_box2_material_string, "Vacuum" ? "Vacuum" : "", 16384); else mccchannel_8_cave1_box2_material_string[0]='\0';
#line 2274 "MACS_sample_kidney_box.instr"
  mccchannel_8_cave1_box2_priority = 1005;
#line 2272 "MACS_sample_kidney_box.instr"
  mccchannel_8_cave1_box2_xwidth = kidney_cave1_box2_width1;
#line 2272 "MACS_sample_kidney_box.instr"
  mccchannel_8_cave1_box2_yheight = kidney_cave1_box2_height1;
#line 2272 "MACS_sample_kidney_box.instr"
  mccchannel_8_cave1_box2_zdepth = kidney_cave1_box2_depth;
#line 2273 "MACS_sample_kidney_box.instr"
  mccchannel_8_cave1_box2_xwidth2 = kidney_cave1_box2_width2;
#line 2273 "MACS_sample_kidney_box.instr"
  mccchannel_8_cave1_box2_yheight2 = kidney_cave1_box2_height2;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_8_cave1_box2_visualize = 1;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_8_cave1_box2_target_index = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_8_cave1_box2_target_x = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_8_cave1_box2_target_y = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_8_cave1_box2_target_z = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_8_cave1_box2_focus_aw = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_8_cave1_box2_focus_ah = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_8_cave1_box2_focus_xw = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_8_cave1_box2_focus_xh = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_8_cave1_box2_focus_r = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_8_cave1_box2_p_interact = 0;
#line 71 "MACS_sample_kidney_box.instr"
  if(0) strncpy(mccchannel_8_cave1_box2_mask_string, 0 ? 0 : "", 16384); else mccchannel_8_cave1_box2_mask_string[0]='\0';
#line 71 "MACS_sample_kidney_box.instr"
  if(0) strncpy(mccchannel_8_cave1_box2_mask_setting, 0 ? 0 : "", 16384); else mccchannel_8_cave1_box2_mask_setting[0]='\0';
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_8_cave1_box2_number_of_activations = 1;
#line 117899 "MACS_sample_kidney_box.c"

  SIG_MESSAGE("channel_8_cave1_box2 (Init:Place/Rotate)");
  rot_set_rotation(mctr1,
#line 2276 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 2276 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 2276 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD);
#line 117909 "MACS_sample_kidney_box.c"
  rot_mul(mctr1, mcrotakidney_channel_8, mcrotachannel_8_cave1_box2);
  rot_transpose(mcrotachannel_8_cave1_box1, mctr1);
  rot_mul(mcrotachannel_8_cave1_box2, mctr1, mcrotrchannel_8_cave1_box2);
  mctc1 = coords_set(
#line 2275 "MACS_sample_kidney_box.instr"
    kidney_cave1_box2_x_offset,
#line 2275 "MACS_sample_kidney_box.instr"
    0,
#line 2275 "MACS_sample_kidney_box.instr"
    kidney_cave1_box2_center_to_target);
#line 117920 "MACS_sample_kidney_box.c"
  rot_transpose(mcrotakidney_channel_8, mctr1);
  mctc2 = rot_apply(mctr1, mctc1);
  mcposachannel_8_cave1_box2 = coords_add(mcposakidney_channel_8, mctc2);
  mctc1 = coords_sub(mcposachannel_8_cave1_box1, mcposachannel_8_cave1_box2);
  mcposrchannel_8_cave1_box2 = rot_apply(mcrotachannel_8_cave1_box2, mctc1);
  mcDEBUG_COMPONENT("channel_8_cave1_box2", mcposachannel_8_cave1_box2, mcrotachannel_8_cave1_box2)
  mccomp_posa[429] = mcposachannel_8_cave1_box2;
  mccomp_posr[429] = mcposrchannel_8_cave1_box2;
  mcNCounter[429]  = mcPCounter[429] = mcP2Counter[429] = 0;
  mcAbsorbProp[429]= 0;
    /* Component channel_8_cave1_box3. */
  /* Setting parameters for component channel_8_cave1_box3. */
  SIG_MESSAGE("channel_8_cave1_box3 (Init:SetPar)");
#line 2281 "MACS_sample_kidney_box.instr"
  if("Vacuum") strncpy(mccchannel_8_cave1_box3_material_string, "Vacuum" ? "Vacuum" : "", 16384); else mccchannel_8_cave1_box3_material_string[0]='\0';
#line 2281 "MACS_sample_kidney_box.instr"
  mccchannel_8_cave1_box3_priority = 1002;
#line 2279 "MACS_sample_kidney_box.instr"
  mccchannel_8_cave1_box3_xwidth = kidney_cave1_box3_width1;
#line 2279 "MACS_sample_kidney_box.instr"
  mccchannel_8_cave1_box3_yheight = kidney_cave1_box3_height1;
#line 2279 "MACS_sample_kidney_box.instr"
  mccchannel_8_cave1_box3_zdepth = kidney_cave1_box3_depth;
#line 2280 "MACS_sample_kidney_box.instr"
  mccchannel_8_cave1_box3_xwidth2 = kidney_cave1_box3_width2;
#line 2280 "MACS_sample_kidney_box.instr"
  mccchannel_8_cave1_box3_yheight2 = kidney_cave1_box3_height2;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_8_cave1_box3_visualize = 1;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_8_cave1_box3_target_index = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_8_cave1_box3_target_x = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_8_cave1_box3_target_y = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_8_cave1_box3_target_z = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_8_cave1_box3_focus_aw = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_8_cave1_box3_focus_ah = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_8_cave1_box3_focus_xw = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_8_cave1_box3_focus_xh = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_8_cave1_box3_focus_r = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_8_cave1_box3_p_interact = 0;
#line 71 "MACS_sample_kidney_box.instr"
  if(0) strncpy(mccchannel_8_cave1_box3_mask_string, 0 ? 0 : "", 16384); else mccchannel_8_cave1_box3_mask_string[0]='\0';
#line 71 "MACS_sample_kidney_box.instr"
  if(0) strncpy(mccchannel_8_cave1_box3_mask_setting, 0 ? 0 : "", 16384); else mccchannel_8_cave1_box3_mask_setting[0]='\0';
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_8_cave1_box3_number_of_activations = 1;
#line 117976 "MACS_sample_kidney_box.c"

  SIG_MESSAGE("channel_8_cave1_box3 (Init:Place/Rotate)");
  rot_set_rotation(mctr1,
#line 2283 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 2283 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 2283 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD);
#line 117986 "MACS_sample_kidney_box.c"
  rot_mul(mctr1, mcrotakidney_channel_8, mcrotachannel_8_cave1_box3);
  rot_transpose(mcrotachannel_8_cave1_box2, mctr1);
  rot_mul(mcrotachannel_8_cave1_box3, mctr1, mcrotrchannel_8_cave1_box3);
  mctc1 = coords_set(
#line 2282 "MACS_sample_kidney_box.instr"
    0,
#line 2282 "MACS_sample_kidney_box.instr"
    0,
#line 2282 "MACS_sample_kidney_box.instr"
    kidney_cave1_box3_center_to_target);
#line 117997 "MACS_sample_kidney_box.c"
  rot_transpose(mcrotakidney_channel_8, mctr1);
  mctc2 = rot_apply(mctr1, mctc1);
  mcposachannel_8_cave1_box3 = coords_add(mcposakidney_channel_8, mctc2);
  mctc1 = coords_sub(mcposachannel_8_cave1_box2, mcposachannel_8_cave1_box3);
  mcposrchannel_8_cave1_box3 = rot_apply(mcrotachannel_8_cave1_box3, mctc1);
  mcDEBUG_COMPONENT("channel_8_cave1_box3", mcposachannel_8_cave1_box3, mcrotachannel_8_cave1_box3)
  mccomp_posa[430] = mcposachannel_8_cave1_box3;
  mccomp_posr[430] = mcposrchannel_8_cave1_box3;
  mcNCounter[430]  = mcPCounter[430] = mcP2Counter[430] = 0;
  mcAbsorbProp[430]= 0;
    /* Component channel_8_cave1_cyl1. */
  /* Setting parameters for component channel_8_cave1_cyl1. */
  SIG_MESSAGE("channel_8_cave1_cyl1 (Init:SetPar)");
#line 2287 "MACS_sample_kidney_box.instr"
  if("Vacuum") strncpy(mccchannel_8_cave1_cyl1_material_string, "Vacuum" ? "Vacuum" : "", 16384); else mccchannel_8_cave1_cyl1_material_string[0]='\0';
#line 2287 "MACS_sample_kidney_box.instr"
  mccchannel_8_cave1_cyl1_priority = 1003;
#line 2286 "MACS_sample_kidney_box.instr"
  mccchannel_8_cave1_cyl1_radius = kidney_cave1_cyl1_radius;
#line 2286 "MACS_sample_kidney_box.instr"
  mccchannel_8_cave1_cyl1_yheight = kidney_cave1_cyl1_height;
#line 67 "MACS_sample_kidney_box.instr"
  mccchannel_8_cave1_cyl1_visualize = 1;
#line 67 "MACS_sample_kidney_box.instr"
  mccchannel_8_cave1_cyl1_target_index = 0;
#line 67 "MACS_sample_kidney_box.instr"
  mccchannel_8_cave1_cyl1_target_x = 0;
#line 67 "MACS_sample_kidney_box.instr"
  mccchannel_8_cave1_cyl1_target_y = 0;
#line 67 "MACS_sample_kidney_box.instr"
  mccchannel_8_cave1_cyl1_target_z = 0;
#line 67 "MACS_sample_kidney_box.instr"
  mccchannel_8_cave1_cyl1_focus_aw = 0;
#line 67 "MACS_sample_kidney_box.instr"
  mccchannel_8_cave1_cyl1_focus_ah = 0;
#line 67 "MACS_sample_kidney_box.instr"
  mccchannel_8_cave1_cyl1_focus_xw = 0;
#line 67 "MACS_sample_kidney_box.instr"
  mccchannel_8_cave1_cyl1_focus_xh = 0;
#line 67 "MACS_sample_kidney_box.instr"
  mccchannel_8_cave1_cyl1_focus_r = 0;
#line 67 "MACS_sample_kidney_box.instr"
  mccchannel_8_cave1_cyl1_p_interact = 0;
#line 67 "MACS_sample_kidney_box.instr"
  if(0) strncpy(mccchannel_8_cave1_cyl1_mask_string, 0 ? 0 : "", 16384); else mccchannel_8_cave1_cyl1_mask_string[0]='\0';
#line 67 "MACS_sample_kidney_box.instr"
  if(0) strncpy(mccchannel_8_cave1_cyl1_mask_setting, 0 ? 0 : "", 16384); else mccchannel_8_cave1_cyl1_mask_setting[0]='\0';
#line 67 "MACS_sample_kidney_box.instr"
  mccchannel_8_cave1_cyl1_number_of_activations = 1;
#line 118047 "MACS_sample_kidney_box.c"

  SIG_MESSAGE("channel_8_cave1_cyl1 (Init:Place/Rotate)");
  rot_set_rotation(mctr1,
#line 2289 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 2289 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 2289 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD);
#line 118057 "MACS_sample_kidney_box.c"
  rot_mul(mctr1, mcrotakidney_channel_8, mcrotachannel_8_cave1_cyl1);
  rot_transpose(mcrotachannel_8_cave1_box3, mctr1);
  rot_mul(mcrotachannel_8_cave1_cyl1, mctr1, mcrotrchannel_8_cave1_cyl1);
  mctc1 = coords_set(
#line 2288 "MACS_sample_kidney_box.instr"
    0,
#line 2288 "MACS_sample_kidney_box.instr"
    0,
#line 2288 "MACS_sample_kidney_box.instr"
    kidney_cave1_cyl1_center_to_target);
#line 118068 "MACS_sample_kidney_box.c"
  rot_transpose(mcrotakidney_channel_8, mctr1);
  mctc2 = rot_apply(mctr1, mctc1);
  mcposachannel_8_cave1_cyl1 = coords_add(mcposakidney_channel_8, mctc2);
  mctc1 = coords_sub(mcposachannel_8_cave1_box3, mcposachannel_8_cave1_cyl1);
  mcposrchannel_8_cave1_cyl1 = rot_apply(mcrotachannel_8_cave1_cyl1, mctc1);
  mcDEBUG_COMPONENT("channel_8_cave1_cyl1", mcposachannel_8_cave1_cyl1, mcrotachannel_8_cave1_cyl1)
  mccomp_posa[431] = mcposachannel_8_cave1_cyl1;
  mccomp_posr[431] = mcposrchannel_8_cave1_cyl1;
  mcNCounter[431]  = mcPCounter[431] = mcP2Counter[431] = 0;
  mcAbsorbProp[431]= 0;
    /* Component channel_8_analyzer_1_center. */
  /* Setting parameters for component channel_8_analyzer_1_center. */
  SIG_MESSAGE("channel_8_analyzer_1_center (Init:SetPar)");

  SIG_MESSAGE("channel_8_analyzer_1_center (Init:Place/Rotate)");
  rot_set_rotation(mctr1,
    (0.0)*DEG2RAD,
    (0.0)*DEG2RAD,
    (0.0)*DEG2RAD);
#line 118088 "MACS_sample_kidney_box.c"
  rot_mul(mctr1, mcrotakidney_channel_8, mcrotachannel_8_analyzer_1_center);
  rot_transpose(mcrotachannel_8_cave1_cyl1, mctr1);
  rot_mul(mcrotachannel_8_analyzer_1_center, mctr1, mcrotrchannel_8_analyzer_1_center);
  mctc1 = coords_set(
#line 2293 "MACS_sample_kidney_box.instr"
    0,
#line 2293 "MACS_sample_kidney_box.instr"
    0,
#line 2293 "MACS_sample_kidney_box.instr"
    analyzer_1_center_to_sample);
#line 118099 "MACS_sample_kidney_box.c"
  rot_transpose(mcrotakidney_channel_8, mctr1);
  mctc2 = rot_apply(mctr1, mctc1);
  mcposachannel_8_analyzer_1_center = coords_add(mcposakidney_channel_8, mctc2);
  mctc1 = coords_sub(mcposachannel_8_cave1_cyl1, mcposachannel_8_analyzer_1_center);
  mcposrchannel_8_analyzer_1_center = rot_apply(mcrotachannel_8_analyzer_1_center, mctc1);
  mcDEBUG_COMPONENT("channel_8_analyzer_1_center", mcposachannel_8_analyzer_1_center, mcrotachannel_8_analyzer_1_center)
  mccomp_posa[432] = mcposachannel_8_analyzer_1_center;
  mccomp_posr[432] = mcposrchannel_8_analyzer_1_center;
  mcNCounter[432]  = mcPCounter[432] = mcP2Counter[432] = 0;
  mcAbsorbProp[432]= 0;
    /* Component channel_8_analyzer_1_rotated. */
  /* Setting parameters for component channel_8_analyzer_1_rotated. */
  SIG_MESSAGE("channel_8_analyzer_1_rotated (Init:SetPar)");

  SIG_MESSAGE("channel_8_analyzer_1_rotated (Init:Place/Rotate)");
  rot_set_rotation(mctr1,
#line 2297 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 2297 "MACS_sample_kidney_box.instr"
    (180 - analyzer_theta [ 8 ])*DEG2RAD,
#line 2297 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD);
#line 118122 "MACS_sample_kidney_box.c"
  rot_mul(mctr1, mcrotachannel_8_analyzer_1_center, mcrotachannel_8_analyzer_1_rotated);
  rot_transpose(mcrotachannel_8_analyzer_1_center, mctr1);
  rot_mul(mcrotachannel_8_analyzer_1_rotated, mctr1, mcrotrchannel_8_analyzer_1_rotated);
  mctc1 = coords_set(
#line 2296 "MACS_sample_kidney_box.instr"
    0,
#line 2296 "MACS_sample_kidney_box.instr"
    0,
#line 2296 "MACS_sample_kidney_box.instr"
    -0.5 * analyzer_seperation / tan ( analyzer_2theta [ 8 ] * DEG2RAD ));
#line 118133 "MACS_sample_kidney_box.c"
  rot_transpose(mcrotachannel_8_analyzer_1_center, mctr1);
  mctc2 = rot_apply(mctr1, mctc1);
  mcposachannel_8_analyzer_1_rotated = coords_add(mcposachannel_8_analyzer_1_center, mctc2);
  mctc1 = coords_sub(mcposachannel_8_analyzer_1_center, mcposachannel_8_analyzer_1_rotated);
  mcposrchannel_8_analyzer_1_rotated = rot_apply(mcrotachannel_8_analyzer_1_rotated, mctc1);
  mcDEBUG_COMPONENT("channel_8_analyzer_1_rotated", mcposachannel_8_analyzer_1_rotated, mcrotachannel_8_analyzer_1_rotated)
  mccomp_posa[433] = mcposachannel_8_analyzer_1_rotated;
  mccomp_posr[433] = mcposrchannel_8_analyzer_1_rotated;
  mcNCounter[433]  = mcPCounter[433] = mcP2Counter[433] = 0;
  mcAbsorbProp[433]= 0;
    /* Component channel_8_analyzer_1_array_crystal_array_0. */
  /* Setting parameters for component channel_8_analyzer_1_array_crystal_array_0. */
  SIG_MESSAGE("channel_8_analyzer_1_array_crystal_array_0 (Init:SetPar)");
#line 2301 "MACS_sample_kidney_box.instr"
  if("PG_analyzer") strncpy(mccchannel_8_analyzer_1_array_crystal_array_0_material_string, "PG_analyzer" ? "PG_analyzer" : "", 16384); else mccchannel_8_analyzer_1_array_crystal_array_0_material_string[0]='\0';
#line 2301 "MACS_sample_kidney_box.instr"
  mccchannel_8_analyzer_1_array_crystal_array_0_priority = 1020.0;
#line 2300 "MACS_sample_kidney_box.instr"
  mccchannel_8_analyzer_1_array_crystal_array_0_xwidth = channel_8_analyzer_1_array_crystal_depth;
#line 2300 "MACS_sample_kidney_box.instr"
  mccchannel_8_analyzer_1_array_crystal_array_0_yheight = channel_8_analyzer_1_array_crystal_height;
#line 2300 "MACS_sample_kidney_box.instr"
  mccchannel_8_analyzer_1_array_crystal_array_0_zdepth = channel_8_analyzer_1_array_crystal_width;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_8_analyzer_1_array_crystal_array_0_xwidth2 = -1;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_8_analyzer_1_array_crystal_array_0_yheight2 = -1;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_8_analyzer_1_array_crystal_array_0_visualize = 1;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_8_analyzer_1_array_crystal_array_0_target_index = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_8_analyzer_1_array_crystal_array_0_target_x = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_8_analyzer_1_array_crystal_array_0_target_y = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_8_analyzer_1_array_crystal_array_0_target_z = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_8_analyzer_1_array_crystal_array_0_focus_aw = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_8_analyzer_1_array_crystal_array_0_focus_ah = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_8_analyzer_1_array_crystal_array_0_focus_xw = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_8_analyzer_1_array_crystal_array_0_focus_xh = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_8_analyzer_1_array_crystal_array_0_focus_r = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_8_analyzer_1_array_crystal_array_0_p_interact = 0;
#line 71 "MACS_sample_kidney_box.instr"
  if(0) strncpy(mccchannel_8_analyzer_1_array_crystal_array_0_mask_string, 0 ? 0 : "", 16384); else mccchannel_8_analyzer_1_array_crystal_array_0_mask_string[0]='\0';
#line 71 "MACS_sample_kidney_box.instr"
  if(0) strncpy(mccchannel_8_analyzer_1_array_crystal_array_0_mask_setting, 0 ? 0 : "", 16384); else mccchannel_8_analyzer_1_array_crystal_array_0_mask_setting[0]='\0';
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_8_analyzer_1_array_crystal_array_0_number_of_activations = 1;
#line 118189 "MACS_sample_kidney_box.c"

  SIG_MESSAGE("channel_8_analyzer_1_array_crystal_array_0 (Init:Place/Rotate)");
  rot_set_rotation(mctr1,
#line 2303 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 2303 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 2303 "MACS_sample_kidney_box.instr"
    (0 - RAD2DEG * channel_8_analyzer_1_array_theta [ 0 ])*DEG2RAD);
#line 118199 "MACS_sample_kidney_box.c"
  rot_mul(mctr1, mcrotachannel_8_analyzer_1_rotated, mcrotachannel_8_analyzer_1_array_crystal_array_0);
  rot_transpose(mcrotachannel_8_analyzer_1_rotated, mctr1);
  rot_mul(mcrotachannel_8_analyzer_1_array_crystal_array_0, mctr1, mcrotrchannel_8_analyzer_1_array_crystal_array_0);
  mctc1 = coords_set(
#line 2302 "MACS_sample_kidney_box.instr"
    0 + channel_8_analyzer_1_array_effective_radius_of_curvature * ( 1 - cos ( channel_8_analyzer_1_array_theta [ 0 ] ) ),
#line 2302 "MACS_sample_kidney_box.instr"
    0 + channel_8_analyzer_1_array_effective_radius_of_curvature * sin ( channel_8_analyzer_1_array_theta [ 0 ] ),
#line 2302 "MACS_sample_kidney_box.instr"
    0);
#line 118210 "MACS_sample_kidney_box.c"
  rot_transpose(mcrotachannel_8_analyzer_1_rotated, mctr1);
  mctc2 = rot_apply(mctr1, mctc1);
  mcposachannel_8_analyzer_1_array_crystal_array_0 = coords_add(mcposachannel_8_analyzer_1_rotated, mctc2);
  mctc1 = coords_sub(mcposachannel_8_analyzer_1_rotated, mcposachannel_8_analyzer_1_array_crystal_array_0);
  mcposrchannel_8_analyzer_1_array_crystal_array_0 = rot_apply(mcrotachannel_8_analyzer_1_array_crystal_array_0, mctc1);
  mcDEBUG_COMPONENT("channel_8_analyzer_1_array_crystal_array_0", mcposachannel_8_analyzer_1_array_crystal_array_0, mcrotachannel_8_analyzer_1_array_crystal_array_0)
  mccomp_posa[434] = mcposachannel_8_analyzer_1_array_crystal_array_0;
  mccomp_posr[434] = mcposrchannel_8_analyzer_1_array_crystal_array_0;
  mcNCounter[434]  = mcPCounter[434] = mcP2Counter[434] = 0;
  mcAbsorbProp[434]= 0;
    /* Component channel_8_analyzer_1_array_crystal_array_1. */
  /* Setting parameters for component channel_8_analyzer_1_array_crystal_array_1. */
  SIG_MESSAGE("channel_8_analyzer_1_array_crystal_array_1 (Init:SetPar)");
#line 2307 "MACS_sample_kidney_box.instr"
  if("PG_analyzer") strncpy(mccchannel_8_analyzer_1_array_crystal_array_1_material_string, "PG_analyzer" ? "PG_analyzer" : "", 16384); else mccchannel_8_analyzer_1_array_crystal_array_1_material_string[0]='\0';
#line 2307 "MACS_sample_kidney_box.instr"
  mccchannel_8_analyzer_1_array_crystal_array_1_priority = 1020.1;
#line 2306 "MACS_sample_kidney_box.instr"
  mccchannel_8_analyzer_1_array_crystal_array_1_xwidth = channel_8_analyzer_1_array_crystal_depth;
#line 2306 "MACS_sample_kidney_box.instr"
  mccchannel_8_analyzer_1_array_crystal_array_1_yheight = channel_8_analyzer_1_array_crystal_height;
#line 2306 "MACS_sample_kidney_box.instr"
  mccchannel_8_analyzer_1_array_crystal_array_1_zdepth = channel_8_analyzer_1_array_crystal_width;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_8_analyzer_1_array_crystal_array_1_xwidth2 = -1;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_8_analyzer_1_array_crystal_array_1_yheight2 = -1;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_8_analyzer_1_array_crystal_array_1_visualize = 1;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_8_analyzer_1_array_crystal_array_1_target_index = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_8_analyzer_1_array_crystal_array_1_target_x = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_8_analyzer_1_array_crystal_array_1_target_y = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_8_analyzer_1_array_crystal_array_1_target_z = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_8_analyzer_1_array_crystal_array_1_focus_aw = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_8_analyzer_1_array_crystal_array_1_focus_ah = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_8_analyzer_1_array_crystal_array_1_focus_xw = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_8_analyzer_1_array_crystal_array_1_focus_xh = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_8_analyzer_1_array_crystal_array_1_focus_r = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_8_analyzer_1_array_crystal_array_1_p_interact = 0;
#line 71 "MACS_sample_kidney_box.instr"
  if(0) strncpy(mccchannel_8_analyzer_1_array_crystal_array_1_mask_string, 0 ? 0 : "", 16384); else mccchannel_8_analyzer_1_array_crystal_array_1_mask_string[0]='\0';
#line 71 "MACS_sample_kidney_box.instr"
  if(0) strncpy(mccchannel_8_analyzer_1_array_crystal_array_1_mask_setting, 0 ? 0 : "", 16384); else mccchannel_8_analyzer_1_array_crystal_array_1_mask_setting[0]='\0';
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_8_analyzer_1_array_crystal_array_1_number_of_activations = 1;
#line 118266 "MACS_sample_kidney_box.c"

  SIG_MESSAGE("channel_8_analyzer_1_array_crystal_array_1 (Init:Place/Rotate)");
  rot_set_rotation(mctr1,
#line 2309 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 2309 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 2309 "MACS_sample_kidney_box.instr"
    (0 - RAD2DEG * channel_8_analyzer_1_array_theta [ 1 ])*DEG2RAD);
#line 118276 "MACS_sample_kidney_box.c"
  rot_mul(mctr1, mcrotachannel_8_analyzer_1_rotated, mcrotachannel_8_analyzer_1_array_crystal_array_1);
  rot_transpose(mcrotachannel_8_analyzer_1_array_crystal_array_0, mctr1);
  rot_mul(mcrotachannel_8_analyzer_1_array_crystal_array_1, mctr1, mcrotrchannel_8_analyzer_1_array_crystal_array_1);
  mctc1 = coords_set(
#line 2308 "MACS_sample_kidney_box.instr"
    0 + channel_8_analyzer_1_array_effective_radius_of_curvature * ( 1 - cos ( channel_8_analyzer_1_array_theta [ 1 ] ) ),
#line 2308 "MACS_sample_kidney_box.instr"
    0 + channel_8_analyzer_1_array_effective_radius_of_curvature * sin ( channel_8_analyzer_1_array_theta [ 1 ] ),
#line 2308 "MACS_sample_kidney_box.instr"
    0);
#line 118287 "MACS_sample_kidney_box.c"
  rot_transpose(mcrotachannel_8_analyzer_1_rotated, mctr1);
  mctc2 = rot_apply(mctr1, mctc1);
  mcposachannel_8_analyzer_1_array_crystal_array_1 = coords_add(mcposachannel_8_analyzer_1_rotated, mctc2);
  mctc1 = coords_sub(mcposachannel_8_analyzer_1_array_crystal_array_0, mcposachannel_8_analyzer_1_array_crystal_array_1);
  mcposrchannel_8_analyzer_1_array_crystal_array_1 = rot_apply(mcrotachannel_8_analyzer_1_array_crystal_array_1, mctc1);
  mcDEBUG_COMPONENT("channel_8_analyzer_1_array_crystal_array_1", mcposachannel_8_analyzer_1_array_crystal_array_1, mcrotachannel_8_analyzer_1_array_crystal_array_1)
  mccomp_posa[435] = mcposachannel_8_analyzer_1_array_crystal_array_1;
  mccomp_posr[435] = mcposrchannel_8_analyzer_1_array_crystal_array_1;
  mcNCounter[435]  = mcPCounter[435] = mcP2Counter[435] = 0;
  mcAbsorbProp[435]= 0;
    /* Component channel_8_analyzer_1_array_crystal_array_2. */
  /* Setting parameters for component channel_8_analyzer_1_array_crystal_array_2. */
  SIG_MESSAGE("channel_8_analyzer_1_array_crystal_array_2 (Init:SetPar)");
#line 2313 "MACS_sample_kidney_box.instr"
  if("PG_analyzer") strncpy(mccchannel_8_analyzer_1_array_crystal_array_2_material_string, "PG_analyzer" ? "PG_analyzer" : "", 16384); else mccchannel_8_analyzer_1_array_crystal_array_2_material_string[0]='\0';
#line 2313 "MACS_sample_kidney_box.instr"
  mccchannel_8_analyzer_1_array_crystal_array_2_priority = 1020.2;
#line 2312 "MACS_sample_kidney_box.instr"
  mccchannel_8_analyzer_1_array_crystal_array_2_xwidth = channel_8_analyzer_1_array_crystal_depth;
#line 2312 "MACS_sample_kidney_box.instr"
  mccchannel_8_analyzer_1_array_crystal_array_2_yheight = channel_8_analyzer_1_array_crystal_height;
#line 2312 "MACS_sample_kidney_box.instr"
  mccchannel_8_analyzer_1_array_crystal_array_2_zdepth = channel_8_analyzer_1_array_crystal_width;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_8_analyzer_1_array_crystal_array_2_xwidth2 = -1;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_8_analyzer_1_array_crystal_array_2_yheight2 = -1;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_8_analyzer_1_array_crystal_array_2_visualize = 1;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_8_analyzer_1_array_crystal_array_2_target_index = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_8_analyzer_1_array_crystal_array_2_target_x = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_8_analyzer_1_array_crystal_array_2_target_y = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_8_analyzer_1_array_crystal_array_2_target_z = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_8_analyzer_1_array_crystal_array_2_focus_aw = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_8_analyzer_1_array_crystal_array_2_focus_ah = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_8_analyzer_1_array_crystal_array_2_focus_xw = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_8_analyzer_1_array_crystal_array_2_focus_xh = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_8_analyzer_1_array_crystal_array_2_focus_r = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_8_analyzer_1_array_crystal_array_2_p_interact = 0;
#line 71 "MACS_sample_kidney_box.instr"
  if(0) strncpy(mccchannel_8_analyzer_1_array_crystal_array_2_mask_string, 0 ? 0 : "", 16384); else mccchannel_8_analyzer_1_array_crystal_array_2_mask_string[0]='\0';
#line 71 "MACS_sample_kidney_box.instr"
  if(0) strncpy(mccchannel_8_analyzer_1_array_crystal_array_2_mask_setting, 0 ? 0 : "", 16384); else mccchannel_8_analyzer_1_array_crystal_array_2_mask_setting[0]='\0';
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_8_analyzer_1_array_crystal_array_2_number_of_activations = 1;
#line 118343 "MACS_sample_kidney_box.c"

  SIG_MESSAGE("channel_8_analyzer_1_array_crystal_array_2 (Init:Place/Rotate)");
  rot_set_rotation(mctr1,
#line 2315 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 2315 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 2315 "MACS_sample_kidney_box.instr"
    (0 - RAD2DEG * channel_8_analyzer_1_array_theta [ 2 ])*DEG2RAD);
#line 118353 "MACS_sample_kidney_box.c"
  rot_mul(mctr1, mcrotachannel_8_analyzer_1_rotated, mcrotachannel_8_analyzer_1_array_crystal_array_2);
  rot_transpose(mcrotachannel_8_analyzer_1_array_crystal_array_1, mctr1);
  rot_mul(mcrotachannel_8_analyzer_1_array_crystal_array_2, mctr1, mcrotrchannel_8_analyzer_1_array_crystal_array_2);
  mctc1 = coords_set(
#line 2314 "MACS_sample_kidney_box.instr"
    0 + channel_8_analyzer_1_array_effective_radius_of_curvature * ( 1 - cos ( channel_8_analyzer_1_array_theta [ 2 ] ) ),
#line 2314 "MACS_sample_kidney_box.instr"
    0 + channel_8_analyzer_1_array_effective_radius_of_curvature * sin ( channel_8_analyzer_1_array_theta [ 2 ] ),
#line 2314 "MACS_sample_kidney_box.instr"
    0);
#line 118364 "MACS_sample_kidney_box.c"
  rot_transpose(mcrotachannel_8_analyzer_1_rotated, mctr1);
  mctc2 = rot_apply(mctr1, mctc1);
  mcposachannel_8_analyzer_1_array_crystal_array_2 = coords_add(mcposachannel_8_analyzer_1_rotated, mctc2);
  mctc1 = coords_sub(mcposachannel_8_analyzer_1_array_crystal_array_1, mcposachannel_8_analyzer_1_array_crystal_array_2);
  mcposrchannel_8_analyzer_1_array_crystal_array_2 = rot_apply(mcrotachannel_8_analyzer_1_array_crystal_array_2, mctc1);
  mcDEBUG_COMPONENT("channel_8_analyzer_1_array_crystal_array_2", mcposachannel_8_analyzer_1_array_crystal_array_2, mcrotachannel_8_analyzer_1_array_crystal_array_2)
  mccomp_posa[436] = mcposachannel_8_analyzer_1_array_crystal_array_2;
  mccomp_posr[436] = mcposrchannel_8_analyzer_1_array_crystal_array_2;
  mcNCounter[436]  = mcPCounter[436] = mcP2Counter[436] = 0;
  mcAbsorbProp[436]= 0;
    /* Component channel_8_analyzer_1_array_crystal_array_3. */
  /* Setting parameters for component channel_8_analyzer_1_array_crystal_array_3. */
  SIG_MESSAGE("channel_8_analyzer_1_array_crystal_array_3 (Init:SetPar)");
#line 2319 "MACS_sample_kidney_box.instr"
  if("PG_analyzer") strncpy(mccchannel_8_analyzer_1_array_crystal_array_3_material_string, "PG_analyzer" ? "PG_analyzer" : "", 16384); else mccchannel_8_analyzer_1_array_crystal_array_3_material_string[0]='\0';
#line 2319 "MACS_sample_kidney_box.instr"
  mccchannel_8_analyzer_1_array_crystal_array_3_priority = 1020.3;
#line 2318 "MACS_sample_kidney_box.instr"
  mccchannel_8_analyzer_1_array_crystal_array_3_xwidth = channel_8_analyzer_1_array_crystal_depth;
#line 2318 "MACS_sample_kidney_box.instr"
  mccchannel_8_analyzer_1_array_crystal_array_3_yheight = channel_8_analyzer_1_array_crystal_height;
#line 2318 "MACS_sample_kidney_box.instr"
  mccchannel_8_analyzer_1_array_crystal_array_3_zdepth = channel_8_analyzer_1_array_crystal_width;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_8_analyzer_1_array_crystal_array_3_xwidth2 = -1;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_8_analyzer_1_array_crystal_array_3_yheight2 = -1;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_8_analyzer_1_array_crystal_array_3_visualize = 1;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_8_analyzer_1_array_crystal_array_3_target_index = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_8_analyzer_1_array_crystal_array_3_target_x = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_8_analyzer_1_array_crystal_array_3_target_y = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_8_analyzer_1_array_crystal_array_3_target_z = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_8_analyzer_1_array_crystal_array_3_focus_aw = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_8_analyzer_1_array_crystal_array_3_focus_ah = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_8_analyzer_1_array_crystal_array_3_focus_xw = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_8_analyzer_1_array_crystal_array_3_focus_xh = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_8_analyzer_1_array_crystal_array_3_focus_r = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_8_analyzer_1_array_crystal_array_3_p_interact = 0;
#line 71 "MACS_sample_kidney_box.instr"
  if(0) strncpy(mccchannel_8_analyzer_1_array_crystal_array_3_mask_string, 0 ? 0 : "", 16384); else mccchannel_8_analyzer_1_array_crystal_array_3_mask_string[0]='\0';
#line 71 "MACS_sample_kidney_box.instr"
  if(0) strncpy(mccchannel_8_analyzer_1_array_crystal_array_3_mask_setting, 0 ? 0 : "", 16384); else mccchannel_8_analyzer_1_array_crystal_array_3_mask_setting[0]='\0';
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_8_analyzer_1_array_crystal_array_3_number_of_activations = 1;
#line 118420 "MACS_sample_kidney_box.c"

  SIG_MESSAGE("channel_8_analyzer_1_array_crystal_array_3 (Init:Place/Rotate)");
  rot_set_rotation(mctr1,
#line 2321 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 2321 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 2321 "MACS_sample_kidney_box.instr"
    (0 - RAD2DEG * channel_8_analyzer_1_array_theta [ 3 ])*DEG2RAD);
#line 118430 "MACS_sample_kidney_box.c"
  rot_mul(mctr1, mcrotachannel_8_analyzer_1_rotated, mcrotachannel_8_analyzer_1_array_crystal_array_3);
  rot_transpose(mcrotachannel_8_analyzer_1_array_crystal_array_2, mctr1);
  rot_mul(mcrotachannel_8_analyzer_1_array_crystal_array_3, mctr1, mcrotrchannel_8_analyzer_1_array_crystal_array_3);
  mctc1 = coords_set(
#line 2320 "MACS_sample_kidney_box.instr"
    0 + channel_8_analyzer_1_array_effective_radius_of_curvature * ( 1 - cos ( channel_8_analyzer_1_array_theta [ 3 ] ) ),
#line 2320 "MACS_sample_kidney_box.instr"
    0 + channel_8_analyzer_1_array_effective_radius_of_curvature * sin ( channel_8_analyzer_1_array_theta [ 3 ] ),
#line 2320 "MACS_sample_kidney_box.instr"
    0);
#line 118441 "MACS_sample_kidney_box.c"
  rot_transpose(mcrotachannel_8_analyzer_1_rotated, mctr1);
  mctc2 = rot_apply(mctr1, mctc1);
  mcposachannel_8_analyzer_1_array_crystal_array_3 = coords_add(mcposachannel_8_analyzer_1_rotated, mctc2);
  mctc1 = coords_sub(mcposachannel_8_analyzer_1_array_crystal_array_2, mcposachannel_8_analyzer_1_array_crystal_array_3);
  mcposrchannel_8_analyzer_1_array_crystal_array_3 = rot_apply(mcrotachannel_8_analyzer_1_array_crystal_array_3, mctc1);
  mcDEBUG_COMPONENT("channel_8_analyzer_1_array_crystal_array_3", mcposachannel_8_analyzer_1_array_crystal_array_3, mcrotachannel_8_analyzer_1_array_crystal_array_3)
  mccomp_posa[437] = mcposachannel_8_analyzer_1_array_crystal_array_3;
  mccomp_posr[437] = mcposrchannel_8_analyzer_1_array_crystal_array_3;
  mcNCounter[437]  = mcPCounter[437] = mcP2Counter[437] = 0;
  mcAbsorbProp[437]= 0;
    /* Component channel_8_analyzer_1_array_crystal_array_4. */
  /* Setting parameters for component channel_8_analyzer_1_array_crystal_array_4. */
  SIG_MESSAGE("channel_8_analyzer_1_array_crystal_array_4 (Init:SetPar)");
#line 2325 "MACS_sample_kidney_box.instr"
  if("PG_analyzer") strncpy(mccchannel_8_analyzer_1_array_crystal_array_4_material_string, "PG_analyzer" ? "PG_analyzer" : "", 16384); else mccchannel_8_analyzer_1_array_crystal_array_4_material_string[0]='\0';
#line 2325 "MACS_sample_kidney_box.instr"
  mccchannel_8_analyzer_1_array_crystal_array_4_priority = 1020.4;
#line 2324 "MACS_sample_kidney_box.instr"
  mccchannel_8_analyzer_1_array_crystal_array_4_xwidth = channel_8_analyzer_1_array_crystal_depth;
#line 2324 "MACS_sample_kidney_box.instr"
  mccchannel_8_analyzer_1_array_crystal_array_4_yheight = channel_8_analyzer_1_array_crystal_height;
#line 2324 "MACS_sample_kidney_box.instr"
  mccchannel_8_analyzer_1_array_crystal_array_4_zdepth = channel_8_analyzer_1_array_crystal_width;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_8_analyzer_1_array_crystal_array_4_xwidth2 = -1;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_8_analyzer_1_array_crystal_array_4_yheight2 = -1;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_8_analyzer_1_array_crystal_array_4_visualize = 1;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_8_analyzer_1_array_crystal_array_4_target_index = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_8_analyzer_1_array_crystal_array_4_target_x = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_8_analyzer_1_array_crystal_array_4_target_y = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_8_analyzer_1_array_crystal_array_4_target_z = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_8_analyzer_1_array_crystal_array_4_focus_aw = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_8_analyzer_1_array_crystal_array_4_focus_ah = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_8_analyzer_1_array_crystal_array_4_focus_xw = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_8_analyzer_1_array_crystal_array_4_focus_xh = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_8_analyzer_1_array_crystal_array_4_focus_r = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_8_analyzer_1_array_crystal_array_4_p_interact = 0;
#line 71 "MACS_sample_kidney_box.instr"
  if(0) strncpy(mccchannel_8_analyzer_1_array_crystal_array_4_mask_string, 0 ? 0 : "", 16384); else mccchannel_8_analyzer_1_array_crystal_array_4_mask_string[0]='\0';
#line 71 "MACS_sample_kidney_box.instr"
  if(0) strncpy(mccchannel_8_analyzer_1_array_crystal_array_4_mask_setting, 0 ? 0 : "", 16384); else mccchannel_8_analyzer_1_array_crystal_array_4_mask_setting[0]='\0';
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_8_analyzer_1_array_crystal_array_4_number_of_activations = 1;
#line 118497 "MACS_sample_kidney_box.c"

  SIG_MESSAGE("channel_8_analyzer_1_array_crystal_array_4 (Init:Place/Rotate)");
  rot_set_rotation(mctr1,
#line 2327 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 2327 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 2327 "MACS_sample_kidney_box.instr"
    (0 - RAD2DEG * channel_8_analyzer_1_array_theta [ 4 ])*DEG2RAD);
#line 118507 "MACS_sample_kidney_box.c"
  rot_mul(mctr1, mcrotachannel_8_analyzer_1_rotated, mcrotachannel_8_analyzer_1_array_crystal_array_4);
  rot_transpose(mcrotachannel_8_analyzer_1_array_crystal_array_3, mctr1);
  rot_mul(mcrotachannel_8_analyzer_1_array_crystal_array_4, mctr1, mcrotrchannel_8_analyzer_1_array_crystal_array_4);
  mctc1 = coords_set(
#line 2326 "MACS_sample_kidney_box.instr"
    0 + channel_8_analyzer_1_array_effective_radius_of_curvature * ( 1 - cos ( channel_8_analyzer_1_array_theta [ 4 ] ) ),
#line 2326 "MACS_sample_kidney_box.instr"
    0 + channel_8_analyzer_1_array_effective_radius_of_curvature * sin ( channel_8_analyzer_1_array_theta [ 4 ] ),
#line 2326 "MACS_sample_kidney_box.instr"
    0);
#line 118518 "MACS_sample_kidney_box.c"
  rot_transpose(mcrotachannel_8_analyzer_1_rotated, mctr1);
  mctc2 = rot_apply(mctr1, mctc1);
  mcposachannel_8_analyzer_1_array_crystal_array_4 = coords_add(mcposachannel_8_analyzer_1_rotated, mctc2);
  mctc1 = coords_sub(mcposachannel_8_analyzer_1_array_crystal_array_3, mcposachannel_8_analyzer_1_array_crystal_array_4);
  mcposrchannel_8_analyzer_1_array_crystal_array_4 = rot_apply(mcrotachannel_8_analyzer_1_array_crystal_array_4, mctc1);
  mcDEBUG_COMPONENT("channel_8_analyzer_1_array_crystal_array_4", mcposachannel_8_analyzer_1_array_crystal_array_4, mcrotachannel_8_analyzer_1_array_crystal_array_4)
  mccomp_posa[438] = mcposachannel_8_analyzer_1_array_crystal_array_4;
  mccomp_posr[438] = mcposrchannel_8_analyzer_1_array_crystal_array_4;
  mcNCounter[438]  = mcPCounter[438] = mcP2Counter[438] = 0;
  mcAbsorbProp[438]= 0;
    /* Component channel_8_analyzer_1_array_crystal_array_5. */
  /* Setting parameters for component channel_8_analyzer_1_array_crystal_array_5. */
  SIG_MESSAGE("channel_8_analyzer_1_array_crystal_array_5 (Init:SetPar)");
#line 2331 "MACS_sample_kidney_box.instr"
  if("PG_analyzer") strncpy(mccchannel_8_analyzer_1_array_crystal_array_5_material_string, "PG_analyzer" ? "PG_analyzer" : "", 16384); else mccchannel_8_analyzer_1_array_crystal_array_5_material_string[0]='\0';
#line 2331 "MACS_sample_kidney_box.instr"
  mccchannel_8_analyzer_1_array_crystal_array_5_priority = 1020.5;
#line 2330 "MACS_sample_kidney_box.instr"
  mccchannel_8_analyzer_1_array_crystal_array_5_xwidth = channel_8_analyzer_1_array_crystal_depth;
#line 2330 "MACS_sample_kidney_box.instr"
  mccchannel_8_analyzer_1_array_crystal_array_5_yheight = channel_8_analyzer_1_array_crystal_height;
#line 2330 "MACS_sample_kidney_box.instr"
  mccchannel_8_analyzer_1_array_crystal_array_5_zdepth = channel_8_analyzer_1_array_crystal_width;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_8_analyzer_1_array_crystal_array_5_xwidth2 = -1;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_8_analyzer_1_array_crystal_array_5_yheight2 = -1;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_8_analyzer_1_array_crystal_array_5_visualize = 1;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_8_analyzer_1_array_crystal_array_5_target_index = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_8_analyzer_1_array_crystal_array_5_target_x = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_8_analyzer_1_array_crystal_array_5_target_y = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_8_analyzer_1_array_crystal_array_5_target_z = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_8_analyzer_1_array_crystal_array_5_focus_aw = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_8_analyzer_1_array_crystal_array_5_focus_ah = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_8_analyzer_1_array_crystal_array_5_focus_xw = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_8_analyzer_1_array_crystal_array_5_focus_xh = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_8_analyzer_1_array_crystal_array_5_focus_r = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_8_analyzer_1_array_crystal_array_5_p_interact = 0;
#line 71 "MACS_sample_kidney_box.instr"
  if(0) strncpy(mccchannel_8_analyzer_1_array_crystal_array_5_mask_string, 0 ? 0 : "", 16384); else mccchannel_8_analyzer_1_array_crystal_array_5_mask_string[0]='\0';
#line 71 "MACS_sample_kidney_box.instr"
  if(0) strncpy(mccchannel_8_analyzer_1_array_crystal_array_5_mask_setting, 0 ? 0 : "", 16384); else mccchannel_8_analyzer_1_array_crystal_array_5_mask_setting[0]='\0';
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_8_analyzer_1_array_crystal_array_5_number_of_activations = 1;
#line 118574 "MACS_sample_kidney_box.c"

  SIG_MESSAGE("channel_8_analyzer_1_array_crystal_array_5 (Init:Place/Rotate)");
  rot_set_rotation(mctr1,
#line 2333 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 2333 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 2333 "MACS_sample_kidney_box.instr"
    (0 - RAD2DEG * channel_8_analyzer_1_array_theta [ 5 ])*DEG2RAD);
#line 118584 "MACS_sample_kidney_box.c"
  rot_mul(mctr1, mcrotachannel_8_analyzer_1_rotated, mcrotachannel_8_analyzer_1_array_crystal_array_5);
  rot_transpose(mcrotachannel_8_analyzer_1_array_crystal_array_4, mctr1);
  rot_mul(mcrotachannel_8_analyzer_1_array_crystal_array_5, mctr1, mcrotrchannel_8_analyzer_1_array_crystal_array_5);
  mctc1 = coords_set(
#line 2332 "MACS_sample_kidney_box.instr"
    0 + channel_8_analyzer_1_array_effective_radius_of_curvature * ( 1 - cos ( channel_8_analyzer_1_array_theta [ 5 ] ) ),
#line 2332 "MACS_sample_kidney_box.instr"
    0 + channel_8_analyzer_1_array_effective_radius_of_curvature * sin ( channel_8_analyzer_1_array_theta [ 5 ] ),
#line 2332 "MACS_sample_kidney_box.instr"
    0);
#line 118595 "MACS_sample_kidney_box.c"
  rot_transpose(mcrotachannel_8_analyzer_1_rotated, mctr1);
  mctc2 = rot_apply(mctr1, mctc1);
  mcposachannel_8_analyzer_1_array_crystal_array_5 = coords_add(mcposachannel_8_analyzer_1_rotated, mctc2);
  mctc1 = coords_sub(mcposachannel_8_analyzer_1_array_crystal_array_4, mcposachannel_8_analyzer_1_array_crystal_array_5);
  mcposrchannel_8_analyzer_1_array_crystal_array_5 = rot_apply(mcrotachannel_8_analyzer_1_array_crystal_array_5, mctc1);
  mcDEBUG_COMPONENT("channel_8_analyzer_1_array_crystal_array_5", mcposachannel_8_analyzer_1_array_crystal_array_5, mcrotachannel_8_analyzer_1_array_crystal_array_5)
  mccomp_posa[439] = mcposachannel_8_analyzer_1_array_crystal_array_5;
  mccomp_posr[439] = mcposrchannel_8_analyzer_1_array_crystal_array_5;
  mcNCounter[439]  = mcPCounter[439] = mcP2Counter[439] = 0;
  mcAbsorbProp[439]= 0;
    /* Component channel_8_analyzer_1_array_crystal_array_6. */
  /* Setting parameters for component channel_8_analyzer_1_array_crystal_array_6. */
  SIG_MESSAGE("channel_8_analyzer_1_array_crystal_array_6 (Init:SetPar)");
#line 2337 "MACS_sample_kidney_box.instr"
  if("PG_analyzer") strncpy(mccchannel_8_analyzer_1_array_crystal_array_6_material_string, "PG_analyzer" ? "PG_analyzer" : "", 16384); else mccchannel_8_analyzer_1_array_crystal_array_6_material_string[0]='\0';
#line 2337 "MACS_sample_kidney_box.instr"
  mccchannel_8_analyzer_1_array_crystal_array_6_priority = 1020.6;
#line 2336 "MACS_sample_kidney_box.instr"
  mccchannel_8_analyzer_1_array_crystal_array_6_xwidth = channel_8_analyzer_1_array_crystal_depth;
#line 2336 "MACS_sample_kidney_box.instr"
  mccchannel_8_analyzer_1_array_crystal_array_6_yheight = channel_8_analyzer_1_array_crystal_height;
#line 2336 "MACS_sample_kidney_box.instr"
  mccchannel_8_analyzer_1_array_crystal_array_6_zdepth = channel_8_analyzer_1_array_crystal_width;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_8_analyzer_1_array_crystal_array_6_xwidth2 = -1;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_8_analyzer_1_array_crystal_array_6_yheight2 = -1;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_8_analyzer_1_array_crystal_array_6_visualize = 1;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_8_analyzer_1_array_crystal_array_6_target_index = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_8_analyzer_1_array_crystal_array_6_target_x = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_8_analyzer_1_array_crystal_array_6_target_y = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_8_analyzer_1_array_crystal_array_6_target_z = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_8_analyzer_1_array_crystal_array_6_focus_aw = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_8_analyzer_1_array_crystal_array_6_focus_ah = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_8_analyzer_1_array_crystal_array_6_focus_xw = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_8_analyzer_1_array_crystal_array_6_focus_xh = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_8_analyzer_1_array_crystal_array_6_focus_r = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_8_analyzer_1_array_crystal_array_6_p_interact = 0;
#line 71 "MACS_sample_kidney_box.instr"
  if(0) strncpy(mccchannel_8_analyzer_1_array_crystal_array_6_mask_string, 0 ? 0 : "", 16384); else mccchannel_8_analyzer_1_array_crystal_array_6_mask_string[0]='\0';
#line 71 "MACS_sample_kidney_box.instr"
  if(0) strncpy(mccchannel_8_analyzer_1_array_crystal_array_6_mask_setting, 0 ? 0 : "", 16384); else mccchannel_8_analyzer_1_array_crystal_array_6_mask_setting[0]='\0';
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_8_analyzer_1_array_crystal_array_6_number_of_activations = 1;
#line 118651 "MACS_sample_kidney_box.c"

  SIG_MESSAGE("channel_8_analyzer_1_array_crystal_array_6 (Init:Place/Rotate)");
  rot_set_rotation(mctr1,
#line 2339 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 2339 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 2339 "MACS_sample_kidney_box.instr"
    (0 - RAD2DEG * channel_8_analyzer_1_array_theta [ 6 ])*DEG2RAD);
#line 118661 "MACS_sample_kidney_box.c"
  rot_mul(mctr1, mcrotachannel_8_analyzer_1_rotated, mcrotachannel_8_analyzer_1_array_crystal_array_6);
  rot_transpose(mcrotachannel_8_analyzer_1_array_crystal_array_5, mctr1);
  rot_mul(mcrotachannel_8_analyzer_1_array_crystal_array_6, mctr1, mcrotrchannel_8_analyzer_1_array_crystal_array_6);
  mctc1 = coords_set(
#line 2338 "MACS_sample_kidney_box.instr"
    0 + channel_8_analyzer_1_array_effective_radius_of_curvature * ( 1 - cos ( channel_8_analyzer_1_array_theta [ 6 ] ) ),
#line 2338 "MACS_sample_kidney_box.instr"
    0 + channel_8_analyzer_1_array_effective_radius_of_curvature * sin ( channel_8_analyzer_1_array_theta [ 6 ] ),
#line 2338 "MACS_sample_kidney_box.instr"
    0);
#line 118672 "MACS_sample_kidney_box.c"
  rot_transpose(mcrotachannel_8_analyzer_1_rotated, mctr1);
  mctc2 = rot_apply(mctr1, mctc1);
  mcposachannel_8_analyzer_1_array_crystal_array_6 = coords_add(mcposachannel_8_analyzer_1_rotated, mctc2);
  mctc1 = coords_sub(mcposachannel_8_analyzer_1_array_crystal_array_5, mcposachannel_8_analyzer_1_array_crystal_array_6);
  mcposrchannel_8_analyzer_1_array_crystal_array_6 = rot_apply(mcrotachannel_8_analyzer_1_array_crystal_array_6, mctc1);
  mcDEBUG_COMPONENT("channel_8_analyzer_1_array_crystal_array_6", mcposachannel_8_analyzer_1_array_crystal_array_6, mcrotachannel_8_analyzer_1_array_crystal_array_6)
  mccomp_posa[440] = mcposachannel_8_analyzer_1_array_crystal_array_6;
  mccomp_posr[440] = mcposrchannel_8_analyzer_1_array_crystal_array_6;
  mcNCounter[440]  = mcPCounter[440] = mcP2Counter[440] = 0;
  mcAbsorbProp[440]= 0;
    /* Component channel_8_analyzer_1_array_crystal_array_7. */
  /* Setting parameters for component channel_8_analyzer_1_array_crystal_array_7. */
  SIG_MESSAGE("channel_8_analyzer_1_array_crystal_array_7 (Init:SetPar)");
#line 2343 "MACS_sample_kidney_box.instr"
  if("PG_analyzer") strncpy(mccchannel_8_analyzer_1_array_crystal_array_7_material_string, "PG_analyzer" ? "PG_analyzer" : "", 16384); else mccchannel_8_analyzer_1_array_crystal_array_7_material_string[0]='\0';
#line 2343 "MACS_sample_kidney_box.instr"
  mccchannel_8_analyzer_1_array_crystal_array_7_priority = 1020.7;
#line 2342 "MACS_sample_kidney_box.instr"
  mccchannel_8_analyzer_1_array_crystal_array_7_xwidth = channel_8_analyzer_1_array_crystal_depth;
#line 2342 "MACS_sample_kidney_box.instr"
  mccchannel_8_analyzer_1_array_crystal_array_7_yheight = channel_8_analyzer_1_array_crystal_height;
#line 2342 "MACS_sample_kidney_box.instr"
  mccchannel_8_analyzer_1_array_crystal_array_7_zdepth = channel_8_analyzer_1_array_crystal_width;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_8_analyzer_1_array_crystal_array_7_xwidth2 = -1;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_8_analyzer_1_array_crystal_array_7_yheight2 = -1;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_8_analyzer_1_array_crystal_array_7_visualize = 1;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_8_analyzer_1_array_crystal_array_7_target_index = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_8_analyzer_1_array_crystal_array_7_target_x = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_8_analyzer_1_array_crystal_array_7_target_y = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_8_analyzer_1_array_crystal_array_7_target_z = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_8_analyzer_1_array_crystal_array_7_focus_aw = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_8_analyzer_1_array_crystal_array_7_focus_ah = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_8_analyzer_1_array_crystal_array_7_focus_xw = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_8_analyzer_1_array_crystal_array_7_focus_xh = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_8_analyzer_1_array_crystal_array_7_focus_r = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_8_analyzer_1_array_crystal_array_7_p_interact = 0;
#line 71 "MACS_sample_kidney_box.instr"
  if(0) strncpy(mccchannel_8_analyzer_1_array_crystal_array_7_mask_string, 0 ? 0 : "", 16384); else mccchannel_8_analyzer_1_array_crystal_array_7_mask_string[0]='\0';
#line 71 "MACS_sample_kidney_box.instr"
  if(0) strncpy(mccchannel_8_analyzer_1_array_crystal_array_7_mask_setting, 0 ? 0 : "", 16384); else mccchannel_8_analyzer_1_array_crystal_array_7_mask_setting[0]='\0';
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_8_analyzer_1_array_crystal_array_7_number_of_activations = 1;
#line 118728 "MACS_sample_kidney_box.c"

  SIG_MESSAGE("channel_8_analyzer_1_array_crystal_array_7 (Init:Place/Rotate)");
  rot_set_rotation(mctr1,
#line 2345 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 2345 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 2345 "MACS_sample_kidney_box.instr"
    (0 - RAD2DEG * channel_8_analyzer_1_array_theta [ 7 ])*DEG2RAD);
#line 118738 "MACS_sample_kidney_box.c"
  rot_mul(mctr1, mcrotachannel_8_analyzer_1_rotated, mcrotachannel_8_analyzer_1_array_crystal_array_7);
  rot_transpose(mcrotachannel_8_analyzer_1_array_crystal_array_6, mctr1);
  rot_mul(mcrotachannel_8_analyzer_1_array_crystal_array_7, mctr1, mcrotrchannel_8_analyzer_1_array_crystal_array_7);
  mctc1 = coords_set(
#line 2344 "MACS_sample_kidney_box.instr"
    0 + channel_8_analyzer_1_array_effective_radius_of_curvature * ( 1 - cos ( channel_8_analyzer_1_array_theta [ 7 ] ) ),
#line 2344 "MACS_sample_kidney_box.instr"
    0 + channel_8_analyzer_1_array_effective_radius_of_curvature * sin ( channel_8_analyzer_1_array_theta [ 7 ] ),
#line 2344 "MACS_sample_kidney_box.instr"
    0);
#line 118749 "MACS_sample_kidney_box.c"
  rot_transpose(mcrotachannel_8_analyzer_1_rotated, mctr1);
  mctc2 = rot_apply(mctr1, mctc1);
  mcposachannel_8_analyzer_1_array_crystal_array_7 = coords_add(mcposachannel_8_analyzer_1_rotated, mctc2);
  mctc1 = coords_sub(mcposachannel_8_analyzer_1_array_crystal_array_6, mcposachannel_8_analyzer_1_array_crystal_array_7);
  mcposrchannel_8_analyzer_1_array_crystal_array_7 = rot_apply(mcrotachannel_8_analyzer_1_array_crystal_array_7, mctc1);
  mcDEBUG_COMPONENT("channel_8_analyzer_1_array_crystal_array_7", mcposachannel_8_analyzer_1_array_crystal_array_7, mcrotachannel_8_analyzer_1_array_crystal_array_7)
  mccomp_posa[441] = mcposachannel_8_analyzer_1_array_crystal_array_7;
  mccomp_posr[441] = mcposrchannel_8_analyzer_1_array_crystal_array_7;
  mcNCounter[441]  = mcPCounter[441] = mcP2Counter[441] = 0;
  mcAbsorbProp[441]= 0;
    /* Component channel_8_analyzer_1_array_crystal_array_8. */
  /* Setting parameters for component channel_8_analyzer_1_array_crystal_array_8. */
  SIG_MESSAGE("channel_8_analyzer_1_array_crystal_array_8 (Init:SetPar)");
#line 2349 "MACS_sample_kidney_box.instr"
  if("PG_analyzer") strncpy(mccchannel_8_analyzer_1_array_crystal_array_8_material_string, "PG_analyzer" ? "PG_analyzer" : "", 16384); else mccchannel_8_analyzer_1_array_crystal_array_8_material_string[0]='\0';
#line 2349 "MACS_sample_kidney_box.instr"
  mccchannel_8_analyzer_1_array_crystal_array_8_priority = 1020.8;
#line 2348 "MACS_sample_kidney_box.instr"
  mccchannel_8_analyzer_1_array_crystal_array_8_xwidth = channel_8_analyzer_1_array_crystal_depth;
#line 2348 "MACS_sample_kidney_box.instr"
  mccchannel_8_analyzer_1_array_crystal_array_8_yheight = channel_8_analyzer_1_array_crystal_height;
#line 2348 "MACS_sample_kidney_box.instr"
  mccchannel_8_analyzer_1_array_crystal_array_8_zdepth = channel_8_analyzer_1_array_crystal_width;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_8_analyzer_1_array_crystal_array_8_xwidth2 = -1;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_8_analyzer_1_array_crystal_array_8_yheight2 = -1;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_8_analyzer_1_array_crystal_array_8_visualize = 1;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_8_analyzer_1_array_crystal_array_8_target_index = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_8_analyzer_1_array_crystal_array_8_target_x = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_8_analyzer_1_array_crystal_array_8_target_y = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_8_analyzer_1_array_crystal_array_8_target_z = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_8_analyzer_1_array_crystal_array_8_focus_aw = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_8_analyzer_1_array_crystal_array_8_focus_ah = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_8_analyzer_1_array_crystal_array_8_focus_xw = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_8_analyzer_1_array_crystal_array_8_focus_xh = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_8_analyzer_1_array_crystal_array_8_focus_r = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_8_analyzer_1_array_crystal_array_8_p_interact = 0;
#line 71 "MACS_sample_kidney_box.instr"
  if(0) strncpy(mccchannel_8_analyzer_1_array_crystal_array_8_mask_string, 0 ? 0 : "", 16384); else mccchannel_8_analyzer_1_array_crystal_array_8_mask_string[0]='\0';
#line 71 "MACS_sample_kidney_box.instr"
  if(0) strncpy(mccchannel_8_analyzer_1_array_crystal_array_8_mask_setting, 0 ? 0 : "", 16384); else mccchannel_8_analyzer_1_array_crystal_array_8_mask_setting[0]='\0';
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_8_analyzer_1_array_crystal_array_8_number_of_activations = 1;
#line 118805 "MACS_sample_kidney_box.c"

  SIG_MESSAGE("channel_8_analyzer_1_array_crystal_array_8 (Init:Place/Rotate)");
  rot_set_rotation(mctr1,
#line 2351 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 2351 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 2351 "MACS_sample_kidney_box.instr"
    (0 - RAD2DEG * channel_8_analyzer_1_array_theta [ 8 ])*DEG2RAD);
#line 118815 "MACS_sample_kidney_box.c"
  rot_mul(mctr1, mcrotachannel_8_analyzer_1_rotated, mcrotachannel_8_analyzer_1_array_crystal_array_8);
  rot_transpose(mcrotachannel_8_analyzer_1_array_crystal_array_7, mctr1);
  rot_mul(mcrotachannel_8_analyzer_1_array_crystal_array_8, mctr1, mcrotrchannel_8_analyzer_1_array_crystal_array_8);
  mctc1 = coords_set(
#line 2350 "MACS_sample_kidney_box.instr"
    0 + channel_8_analyzer_1_array_effective_radius_of_curvature * ( 1 - cos ( channel_8_analyzer_1_array_theta [ 8 ] ) ),
#line 2350 "MACS_sample_kidney_box.instr"
    0 + channel_8_analyzer_1_array_effective_radius_of_curvature * sin ( channel_8_analyzer_1_array_theta [ 8 ] ),
#line 2350 "MACS_sample_kidney_box.instr"
    0);
#line 118826 "MACS_sample_kidney_box.c"
  rot_transpose(mcrotachannel_8_analyzer_1_rotated, mctr1);
  mctc2 = rot_apply(mctr1, mctc1);
  mcposachannel_8_analyzer_1_array_crystal_array_8 = coords_add(mcposachannel_8_analyzer_1_rotated, mctc2);
  mctc1 = coords_sub(mcposachannel_8_analyzer_1_array_crystal_array_7, mcposachannel_8_analyzer_1_array_crystal_array_8);
  mcposrchannel_8_analyzer_1_array_crystal_array_8 = rot_apply(mcrotachannel_8_analyzer_1_array_crystal_array_8, mctc1);
  mcDEBUG_COMPONENT("channel_8_analyzer_1_array_crystal_array_8", mcposachannel_8_analyzer_1_array_crystal_array_8, mcrotachannel_8_analyzer_1_array_crystal_array_8)
  mccomp_posa[442] = mcposachannel_8_analyzer_1_array_crystal_array_8;
  mccomp_posr[442] = mcposrchannel_8_analyzer_1_array_crystal_array_8;
  mcNCounter[442]  = mcPCounter[442] = mcP2Counter[442] = 0;
  mcAbsorbProp[442]= 0;
    /* Component channel_8_analyzer_2_center. */
  /* Setting parameters for component channel_8_analyzer_2_center. */
  SIG_MESSAGE("channel_8_analyzer_2_center (Init:SetPar)");

  SIG_MESSAGE("channel_8_analyzer_2_center (Init:Place/Rotate)");
  rot_set_rotation(mctr1,
    (0.0)*DEG2RAD,
    (0.0)*DEG2RAD,
    (0.0)*DEG2RAD);
#line 118846 "MACS_sample_kidney_box.c"
  rot_mul(mctr1, mcrotachannel_8_analyzer_1_center, mcrotachannel_8_analyzer_2_center);
  rot_transpose(mcrotachannel_8_analyzer_1_array_crystal_array_8, mctr1);
  rot_mul(mcrotachannel_8_analyzer_2_center, mctr1, mcrotrchannel_8_analyzer_2_center);
  mctc1 = coords_set(
#line 2355 "MACS_sample_kidney_box.instr"
    - analyzer_seperation,
#line 2355 "MACS_sample_kidney_box.instr"
    0,
#line 2355 "MACS_sample_kidney_box.instr"
    0);
#line 118857 "MACS_sample_kidney_box.c"
  rot_transpose(mcrotachannel_8_analyzer_1_center, mctr1);
  mctc2 = rot_apply(mctr1, mctc1);
  mcposachannel_8_analyzer_2_center = coords_add(mcposachannel_8_analyzer_1_center, mctc2);
  mctc1 = coords_sub(mcposachannel_8_analyzer_1_array_crystal_array_8, mcposachannel_8_analyzer_2_center);
  mcposrchannel_8_analyzer_2_center = rot_apply(mcrotachannel_8_analyzer_2_center, mctc1);
  mcDEBUG_COMPONENT("channel_8_analyzer_2_center", mcposachannel_8_analyzer_2_center, mcrotachannel_8_analyzer_2_center)
  mccomp_posa[443] = mcposachannel_8_analyzer_2_center;
  mccomp_posr[443] = mcposrchannel_8_analyzer_2_center;
  mcNCounter[443]  = mcPCounter[443] = mcP2Counter[443] = 0;
  mcAbsorbProp[443]= 0;
    /* Component channel_8_analyzer_2_rotated. */
  /* Setting parameters for component channel_8_analyzer_2_rotated. */
  SIG_MESSAGE("channel_8_analyzer_2_rotated (Init:SetPar)");

  SIG_MESSAGE("channel_8_analyzer_2_rotated (Init:Place/Rotate)");
  rot_set_rotation(mctr1,
#line 2359 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 2359 "MACS_sample_kidney_box.instr"
    (- analyzer_theta [ 8 ])*DEG2RAD,
#line 2359 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD);
#line 118880 "MACS_sample_kidney_box.c"
  rot_mul(mctr1, mcrotachannel_8_analyzer_2_center, mcrotachannel_8_analyzer_2_rotated);
  rot_transpose(mcrotachannel_8_analyzer_2_center, mctr1);
  rot_mul(mcrotachannel_8_analyzer_2_rotated, mctr1, mcrotrchannel_8_analyzer_2_rotated);
  mctc1 = coords_set(
#line 2358 "MACS_sample_kidney_box.instr"
    0,
#line 2358 "MACS_sample_kidney_box.instr"
    0,
#line 2358 "MACS_sample_kidney_box.instr"
    0.5 * analyzer_seperation / tan ( analyzer_2theta [ 8 ] * DEG2RAD ));
#line 118891 "MACS_sample_kidney_box.c"
  rot_transpose(mcrotachannel_8_analyzer_2_center, mctr1);
  mctc2 = rot_apply(mctr1, mctc1);
  mcposachannel_8_analyzer_2_rotated = coords_add(mcposachannel_8_analyzer_2_center, mctc2);
  mctc1 = coords_sub(mcposachannel_8_analyzer_2_center, mcposachannel_8_analyzer_2_rotated);
  mcposrchannel_8_analyzer_2_rotated = rot_apply(mcrotachannel_8_analyzer_2_rotated, mctc1);
  mcDEBUG_COMPONENT("channel_8_analyzer_2_rotated", mcposachannel_8_analyzer_2_rotated, mcrotachannel_8_analyzer_2_rotated)
  mccomp_posa[444] = mcposachannel_8_analyzer_2_rotated;
  mccomp_posr[444] = mcposrchannel_8_analyzer_2_rotated;
  mcNCounter[444]  = mcPCounter[444] = mcP2Counter[444] = 0;
  mcAbsorbProp[444]= 0;
    /* Component channel_8_analyzer_2_array_crystal_array_0. */
  /* Setting parameters for component channel_8_analyzer_2_array_crystal_array_0. */
  SIG_MESSAGE("channel_8_analyzer_2_array_crystal_array_0 (Init:SetPar)");
#line 2363 "MACS_sample_kidney_box.instr"
  if("PG_analyzer") strncpy(mccchannel_8_analyzer_2_array_crystal_array_0_material_string, "PG_analyzer" ? "PG_analyzer" : "", 16384); else mccchannel_8_analyzer_2_array_crystal_array_0_material_string[0]='\0';
#line 2363 "MACS_sample_kidney_box.instr"
  mccchannel_8_analyzer_2_array_crystal_array_0_priority = 1021.0;
#line 2362 "MACS_sample_kidney_box.instr"
  mccchannel_8_analyzer_2_array_crystal_array_0_xwidth = channel_8_analyzer_2_array_crystal_depth;
#line 2362 "MACS_sample_kidney_box.instr"
  mccchannel_8_analyzer_2_array_crystal_array_0_yheight = channel_8_analyzer_2_array_crystal_height;
#line 2362 "MACS_sample_kidney_box.instr"
  mccchannel_8_analyzer_2_array_crystal_array_0_zdepth = channel_8_analyzer_2_array_crystal_width;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_8_analyzer_2_array_crystal_array_0_xwidth2 = -1;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_8_analyzer_2_array_crystal_array_0_yheight2 = -1;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_8_analyzer_2_array_crystal_array_0_visualize = 1;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_8_analyzer_2_array_crystal_array_0_target_index = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_8_analyzer_2_array_crystal_array_0_target_x = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_8_analyzer_2_array_crystal_array_0_target_y = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_8_analyzer_2_array_crystal_array_0_target_z = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_8_analyzer_2_array_crystal_array_0_focus_aw = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_8_analyzer_2_array_crystal_array_0_focus_ah = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_8_analyzer_2_array_crystal_array_0_focus_xw = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_8_analyzer_2_array_crystal_array_0_focus_xh = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_8_analyzer_2_array_crystal_array_0_focus_r = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_8_analyzer_2_array_crystal_array_0_p_interact = 0;
#line 71 "MACS_sample_kidney_box.instr"
  if(0) strncpy(mccchannel_8_analyzer_2_array_crystal_array_0_mask_string, 0 ? 0 : "", 16384); else mccchannel_8_analyzer_2_array_crystal_array_0_mask_string[0]='\0';
#line 71 "MACS_sample_kidney_box.instr"
  if(0) strncpy(mccchannel_8_analyzer_2_array_crystal_array_0_mask_setting, 0 ? 0 : "", 16384); else mccchannel_8_analyzer_2_array_crystal_array_0_mask_setting[0]='\0';
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_8_analyzer_2_array_crystal_array_0_number_of_activations = 1;
#line 118947 "MACS_sample_kidney_box.c"

  SIG_MESSAGE("channel_8_analyzer_2_array_crystal_array_0 (Init:Place/Rotate)");
  rot_set_rotation(mctr1,
#line 2365 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 2365 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 2365 "MACS_sample_kidney_box.instr"
    (0 - RAD2DEG * channel_8_analyzer_2_array_theta [ 0 ])*DEG2RAD);
#line 118957 "MACS_sample_kidney_box.c"
  rot_mul(mctr1, mcrotachannel_8_analyzer_2_rotated, mcrotachannel_8_analyzer_2_array_crystal_array_0);
  rot_transpose(mcrotachannel_8_analyzer_2_rotated, mctr1);
  rot_mul(mcrotachannel_8_analyzer_2_array_crystal_array_0, mctr1, mcrotrchannel_8_analyzer_2_array_crystal_array_0);
  mctc1 = coords_set(
#line 2364 "MACS_sample_kidney_box.instr"
    0 + channel_8_analyzer_2_array_effective_radius_of_curvature * ( 1 - cos ( channel_8_analyzer_2_array_theta [ 0 ] ) ),
#line 2364 "MACS_sample_kidney_box.instr"
    0 + channel_8_analyzer_2_array_effective_radius_of_curvature * sin ( channel_8_analyzer_2_array_theta [ 0 ] ),
#line 2364 "MACS_sample_kidney_box.instr"
    0);
#line 118968 "MACS_sample_kidney_box.c"
  rot_transpose(mcrotachannel_8_analyzer_2_rotated, mctr1);
  mctc2 = rot_apply(mctr1, mctc1);
  mcposachannel_8_analyzer_2_array_crystal_array_0 = coords_add(mcposachannel_8_analyzer_2_rotated, mctc2);
  mctc1 = coords_sub(mcposachannel_8_analyzer_2_rotated, mcposachannel_8_analyzer_2_array_crystal_array_0);
  mcposrchannel_8_analyzer_2_array_crystal_array_0 = rot_apply(mcrotachannel_8_analyzer_2_array_crystal_array_0, mctc1);
  mcDEBUG_COMPONENT("channel_8_analyzer_2_array_crystal_array_0", mcposachannel_8_analyzer_2_array_crystal_array_0, mcrotachannel_8_analyzer_2_array_crystal_array_0)
  mccomp_posa[445] = mcposachannel_8_analyzer_2_array_crystal_array_0;
  mccomp_posr[445] = mcposrchannel_8_analyzer_2_array_crystal_array_0;
  mcNCounter[445]  = mcPCounter[445] = mcP2Counter[445] = 0;
  mcAbsorbProp[445]= 0;
    /* Component channel_8_analyzer_2_array_crystal_array_1. */
  /* Setting parameters for component channel_8_analyzer_2_array_crystal_array_1. */
  SIG_MESSAGE("channel_8_analyzer_2_array_crystal_array_1 (Init:SetPar)");
#line 2369 "MACS_sample_kidney_box.instr"
  if("PG_analyzer") strncpy(mccchannel_8_analyzer_2_array_crystal_array_1_material_string, "PG_analyzer" ? "PG_analyzer" : "", 16384); else mccchannel_8_analyzer_2_array_crystal_array_1_material_string[0]='\0';
#line 2369 "MACS_sample_kidney_box.instr"
  mccchannel_8_analyzer_2_array_crystal_array_1_priority = 1021.1;
#line 2368 "MACS_sample_kidney_box.instr"
  mccchannel_8_analyzer_2_array_crystal_array_1_xwidth = channel_8_analyzer_2_array_crystal_depth;
#line 2368 "MACS_sample_kidney_box.instr"
  mccchannel_8_analyzer_2_array_crystal_array_1_yheight = channel_8_analyzer_2_array_crystal_height;
#line 2368 "MACS_sample_kidney_box.instr"
  mccchannel_8_analyzer_2_array_crystal_array_1_zdepth = channel_8_analyzer_2_array_crystal_width;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_8_analyzer_2_array_crystal_array_1_xwidth2 = -1;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_8_analyzer_2_array_crystal_array_1_yheight2 = -1;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_8_analyzer_2_array_crystal_array_1_visualize = 1;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_8_analyzer_2_array_crystal_array_1_target_index = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_8_analyzer_2_array_crystal_array_1_target_x = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_8_analyzer_2_array_crystal_array_1_target_y = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_8_analyzer_2_array_crystal_array_1_target_z = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_8_analyzer_2_array_crystal_array_1_focus_aw = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_8_analyzer_2_array_crystal_array_1_focus_ah = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_8_analyzer_2_array_crystal_array_1_focus_xw = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_8_analyzer_2_array_crystal_array_1_focus_xh = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_8_analyzer_2_array_crystal_array_1_focus_r = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_8_analyzer_2_array_crystal_array_1_p_interact = 0;
#line 71 "MACS_sample_kidney_box.instr"
  if(0) strncpy(mccchannel_8_analyzer_2_array_crystal_array_1_mask_string, 0 ? 0 : "", 16384); else mccchannel_8_analyzer_2_array_crystal_array_1_mask_string[0]='\0';
#line 71 "MACS_sample_kidney_box.instr"
  if(0) strncpy(mccchannel_8_analyzer_2_array_crystal_array_1_mask_setting, 0 ? 0 : "", 16384); else mccchannel_8_analyzer_2_array_crystal_array_1_mask_setting[0]='\0';
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_8_analyzer_2_array_crystal_array_1_number_of_activations = 1;
#line 119024 "MACS_sample_kidney_box.c"

  SIG_MESSAGE("channel_8_analyzer_2_array_crystal_array_1 (Init:Place/Rotate)");
  rot_set_rotation(mctr1,
#line 2371 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 2371 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 2371 "MACS_sample_kidney_box.instr"
    (0 - RAD2DEG * channel_8_analyzer_2_array_theta [ 1 ])*DEG2RAD);
#line 119034 "MACS_sample_kidney_box.c"
  rot_mul(mctr1, mcrotachannel_8_analyzer_2_rotated, mcrotachannel_8_analyzer_2_array_crystal_array_1);
  rot_transpose(mcrotachannel_8_analyzer_2_array_crystal_array_0, mctr1);
  rot_mul(mcrotachannel_8_analyzer_2_array_crystal_array_1, mctr1, mcrotrchannel_8_analyzer_2_array_crystal_array_1);
  mctc1 = coords_set(
#line 2370 "MACS_sample_kidney_box.instr"
    0 + channel_8_analyzer_2_array_effective_radius_of_curvature * ( 1 - cos ( channel_8_analyzer_2_array_theta [ 1 ] ) ),
#line 2370 "MACS_sample_kidney_box.instr"
    0 + channel_8_analyzer_2_array_effective_radius_of_curvature * sin ( channel_8_analyzer_2_array_theta [ 1 ] ),
#line 2370 "MACS_sample_kidney_box.instr"
    0);
#line 119045 "MACS_sample_kidney_box.c"
  rot_transpose(mcrotachannel_8_analyzer_2_rotated, mctr1);
  mctc2 = rot_apply(mctr1, mctc1);
  mcposachannel_8_analyzer_2_array_crystal_array_1 = coords_add(mcposachannel_8_analyzer_2_rotated, mctc2);
  mctc1 = coords_sub(mcposachannel_8_analyzer_2_array_crystal_array_0, mcposachannel_8_analyzer_2_array_crystal_array_1);
  mcposrchannel_8_analyzer_2_array_crystal_array_1 = rot_apply(mcrotachannel_8_analyzer_2_array_crystal_array_1, mctc1);
  mcDEBUG_COMPONENT("channel_8_analyzer_2_array_crystal_array_1", mcposachannel_8_analyzer_2_array_crystal_array_1, mcrotachannel_8_analyzer_2_array_crystal_array_1)
  mccomp_posa[446] = mcposachannel_8_analyzer_2_array_crystal_array_1;
  mccomp_posr[446] = mcposrchannel_8_analyzer_2_array_crystal_array_1;
  mcNCounter[446]  = mcPCounter[446] = mcP2Counter[446] = 0;
  mcAbsorbProp[446]= 0;
    /* Component channel_8_analyzer_2_array_crystal_array_2. */
  /* Setting parameters for component channel_8_analyzer_2_array_crystal_array_2. */
  SIG_MESSAGE("channel_8_analyzer_2_array_crystal_array_2 (Init:SetPar)");
#line 2375 "MACS_sample_kidney_box.instr"
  if("PG_analyzer") strncpy(mccchannel_8_analyzer_2_array_crystal_array_2_material_string, "PG_analyzer" ? "PG_analyzer" : "", 16384); else mccchannel_8_analyzer_2_array_crystal_array_2_material_string[0]='\0';
#line 2375 "MACS_sample_kidney_box.instr"
  mccchannel_8_analyzer_2_array_crystal_array_2_priority = 1021.2;
#line 2374 "MACS_sample_kidney_box.instr"
  mccchannel_8_analyzer_2_array_crystal_array_2_xwidth = channel_8_analyzer_2_array_crystal_depth;
#line 2374 "MACS_sample_kidney_box.instr"
  mccchannel_8_analyzer_2_array_crystal_array_2_yheight = channel_8_analyzer_2_array_crystal_height;
#line 2374 "MACS_sample_kidney_box.instr"
  mccchannel_8_analyzer_2_array_crystal_array_2_zdepth = channel_8_analyzer_2_array_crystal_width;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_8_analyzer_2_array_crystal_array_2_xwidth2 = -1;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_8_analyzer_2_array_crystal_array_2_yheight2 = -1;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_8_analyzer_2_array_crystal_array_2_visualize = 1;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_8_analyzer_2_array_crystal_array_2_target_index = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_8_analyzer_2_array_crystal_array_2_target_x = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_8_analyzer_2_array_crystal_array_2_target_y = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_8_analyzer_2_array_crystal_array_2_target_z = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_8_analyzer_2_array_crystal_array_2_focus_aw = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_8_analyzer_2_array_crystal_array_2_focus_ah = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_8_analyzer_2_array_crystal_array_2_focus_xw = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_8_analyzer_2_array_crystal_array_2_focus_xh = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_8_analyzer_2_array_crystal_array_2_focus_r = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_8_analyzer_2_array_crystal_array_2_p_interact = 0;
#line 71 "MACS_sample_kidney_box.instr"
  if(0) strncpy(mccchannel_8_analyzer_2_array_crystal_array_2_mask_string, 0 ? 0 : "", 16384); else mccchannel_8_analyzer_2_array_crystal_array_2_mask_string[0]='\0';
#line 71 "MACS_sample_kidney_box.instr"
  if(0) strncpy(mccchannel_8_analyzer_2_array_crystal_array_2_mask_setting, 0 ? 0 : "", 16384); else mccchannel_8_analyzer_2_array_crystal_array_2_mask_setting[0]='\0';
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_8_analyzer_2_array_crystal_array_2_number_of_activations = 1;
#line 119101 "MACS_sample_kidney_box.c"

  SIG_MESSAGE("channel_8_analyzer_2_array_crystal_array_2 (Init:Place/Rotate)");
  rot_set_rotation(mctr1,
#line 2377 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 2377 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 2377 "MACS_sample_kidney_box.instr"
    (0 - RAD2DEG * channel_8_analyzer_2_array_theta [ 2 ])*DEG2RAD);
#line 119111 "MACS_sample_kidney_box.c"
  rot_mul(mctr1, mcrotachannel_8_analyzer_2_rotated, mcrotachannel_8_analyzer_2_array_crystal_array_2);
  rot_transpose(mcrotachannel_8_analyzer_2_array_crystal_array_1, mctr1);
  rot_mul(mcrotachannel_8_analyzer_2_array_crystal_array_2, mctr1, mcrotrchannel_8_analyzer_2_array_crystal_array_2);
  mctc1 = coords_set(
#line 2376 "MACS_sample_kidney_box.instr"
    0 + channel_8_analyzer_2_array_effective_radius_of_curvature * ( 1 - cos ( channel_8_analyzer_2_array_theta [ 2 ] ) ),
#line 2376 "MACS_sample_kidney_box.instr"
    0 + channel_8_analyzer_2_array_effective_radius_of_curvature * sin ( channel_8_analyzer_2_array_theta [ 2 ] ),
#line 2376 "MACS_sample_kidney_box.instr"
    0);
#line 119122 "MACS_sample_kidney_box.c"
  rot_transpose(mcrotachannel_8_analyzer_2_rotated, mctr1);
  mctc2 = rot_apply(mctr1, mctc1);
  mcposachannel_8_analyzer_2_array_crystal_array_2 = coords_add(mcposachannel_8_analyzer_2_rotated, mctc2);
  mctc1 = coords_sub(mcposachannel_8_analyzer_2_array_crystal_array_1, mcposachannel_8_analyzer_2_array_crystal_array_2);
  mcposrchannel_8_analyzer_2_array_crystal_array_2 = rot_apply(mcrotachannel_8_analyzer_2_array_crystal_array_2, mctc1);
  mcDEBUG_COMPONENT("channel_8_analyzer_2_array_crystal_array_2", mcposachannel_8_analyzer_2_array_crystal_array_2, mcrotachannel_8_analyzer_2_array_crystal_array_2)
  mccomp_posa[447] = mcposachannel_8_analyzer_2_array_crystal_array_2;
  mccomp_posr[447] = mcposrchannel_8_analyzer_2_array_crystal_array_2;
  mcNCounter[447]  = mcPCounter[447] = mcP2Counter[447] = 0;
  mcAbsorbProp[447]= 0;
    /* Component channel_8_analyzer_2_array_crystal_array_3. */
  /* Setting parameters for component channel_8_analyzer_2_array_crystal_array_3. */
  SIG_MESSAGE("channel_8_analyzer_2_array_crystal_array_3 (Init:SetPar)");
#line 2381 "MACS_sample_kidney_box.instr"
  if("PG_analyzer") strncpy(mccchannel_8_analyzer_2_array_crystal_array_3_material_string, "PG_analyzer" ? "PG_analyzer" : "", 16384); else mccchannel_8_analyzer_2_array_crystal_array_3_material_string[0]='\0';
#line 2381 "MACS_sample_kidney_box.instr"
  mccchannel_8_analyzer_2_array_crystal_array_3_priority = 1021.3;
#line 2380 "MACS_sample_kidney_box.instr"
  mccchannel_8_analyzer_2_array_crystal_array_3_xwidth = channel_8_analyzer_2_array_crystal_depth;
#line 2380 "MACS_sample_kidney_box.instr"
  mccchannel_8_analyzer_2_array_crystal_array_3_yheight = channel_8_analyzer_2_array_crystal_height;
#line 2380 "MACS_sample_kidney_box.instr"
  mccchannel_8_analyzer_2_array_crystal_array_3_zdepth = channel_8_analyzer_2_array_crystal_width;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_8_analyzer_2_array_crystal_array_3_xwidth2 = -1;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_8_analyzer_2_array_crystal_array_3_yheight2 = -1;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_8_analyzer_2_array_crystal_array_3_visualize = 1;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_8_analyzer_2_array_crystal_array_3_target_index = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_8_analyzer_2_array_crystal_array_3_target_x = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_8_analyzer_2_array_crystal_array_3_target_y = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_8_analyzer_2_array_crystal_array_3_target_z = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_8_analyzer_2_array_crystal_array_3_focus_aw = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_8_analyzer_2_array_crystal_array_3_focus_ah = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_8_analyzer_2_array_crystal_array_3_focus_xw = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_8_analyzer_2_array_crystal_array_3_focus_xh = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_8_analyzer_2_array_crystal_array_3_focus_r = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_8_analyzer_2_array_crystal_array_3_p_interact = 0;
#line 71 "MACS_sample_kidney_box.instr"
  if(0) strncpy(mccchannel_8_analyzer_2_array_crystal_array_3_mask_string, 0 ? 0 : "", 16384); else mccchannel_8_analyzer_2_array_crystal_array_3_mask_string[0]='\0';
#line 71 "MACS_sample_kidney_box.instr"
  if(0) strncpy(mccchannel_8_analyzer_2_array_crystal_array_3_mask_setting, 0 ? 0 : "", 16384); else mccchannel_8_analyzer_2_array_crystal_array_3_mask_setting[0]='\0';
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_8_analyzer_2_array_crystal_array_3_number_of_activations = 1;
#line 119178 "MACS_sample_kidney_box.c"

  SIG_MESSAGE("channel_8_analyzer_2_array_crystal_array_3 (Init:Place/Rotate)");
  rot_set_rotation(mctr1,
#line 2383 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 2383 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 2383 "MACS_sample_kidney_box.instr"
    (0 - RAD2DEG * channel_8_analyzer_2_array_theta [ 3 ])*DEG2RAD);
#line 119188 "MACS_sample_kidney_box.c"
  rot_mul(mctr1, mcrotachannel_8_analyzer_2_rotated, mcrotachannel_8_analyzer_2_array_crystal_array_3);
  rot_transpose(mcrotachannel_8_analyzer_2_array_crystal_array_2, mctr1);
  rot_mul(mcrotachannel_8_analyzer_2_array_crystal_array_3, mctr1, mcrotrchannel_8_analyzer_2_array_crystal_array_3);
  mctc1 = coords_set(
#line 2382 "MACS_sample_kidney_box.instr"
    0 + channel_8_analyzer_2_array_effective_radius_of_curvature * ( 1 - cos ( channel_8_analyzer_2_array_theta [ 3 ] ) ),
#line 2382 "MACS_sample_kidney_box.instr"
    0 + channel_8_analyzer_2_array_effective_radius_of_curvature * sin ( channel_8_analyzer_2_array_theta [ 3 ] ),
#line 2382 "MACS_sample_kidney_box.instr"
    0);
#line 119199 "MACS_sample_kidney_box.c"
  rot_transpose(mcrotachannel_8_analyzer_2_rotated, mctr1);
  mctc2 = rot_apply(mctr1, mctc1);
  mcposachannel_8_analyzer_2_array_crystal_array_3 = coords_add(mcposachannel_8_analyzer_2_rotated, mctc2);
  mctc1 = coords_sub(mcposachannel_8_analyzer_2_array_crystal_array_2, mcposachannel_8_analyzer_2_array_crystal_array_3);
  mcposrchannel_8_analyzer_2_array_crystal_array_3 = rot_apply(mcrotachannel_8_analyzer_2_array_crystal_array_3, mctc1);
  mcDEBUG_COMPONENT("channel_8_analyzer_2_array_crystal_array_3", mcposachannel_8_analyzer_2_array_crystal_array_3, mcrotachannel_8_analyzer_2_array_crystal_array_3)
  mccomp_posa[448] = mcposachannel_8_analyzer_2_array_crystal_array_3;
  mccomp_posr[448] = mcposrchannel_8_analyzer_2_array_crystal_array_3;
  mcNCounter[448]  = mcPCounter[448] = mcP2Counter[448] = 0;
  mcAbsorbProp[448]= 0;
    /* Component channel_8_analyzer_2_array_crystal_array_4. */
  /* Setting parameters for component channel_8_analyzer_2_array_crystal_array_4. */
  SIG_MESSAGE("channel_8_analyzer_2_array_crystal_array_4 (Init:SetPar)");
#line 2387 "MACS_sample_kidney_box.instr"
  if("PG_analyzer") strncpy(mccchannel_8_analyzer_2_array_crystal_array_4_material_string, "PG_analyzer" ? "PG_analyzer" : "", 16384); else mccchannel_8_analyzer_2_array_crystal_array_4_material_string[0]='\0';
#line 2387 "MACS_sample_kidney_box.instr"
  mccchannel_8_analyzer_2_array_crystal_array_4_priority = 1021.4;
#line 2386 "MACS_sample_kidney_box.instr"
  mccchannel_8_analyzer_2_array_crystal_array_4_xwidth = channel_8_analyzer_2_array_crystal_depth;
#line 2386 "MACS_sample_kidney_box.instr"
  mccchannel_8_analyzer_2_array_crystal_array_4_yheight = channel_8_analyzer_2_array_crystal_height;
#line 2386 "MACS_sample_kidney_box.instr"
  mccchannel_8_analyzer_2_array_crystal_array_4_zdepth = channel_8_analyzer_2_array_crystal_width;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_8_analyzer_2_array_crystal_array_4_xwidth2 = -1;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_8_analyzer_2_array_crystal_array_4_yheight2 = -1;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_8_analyzer_2_array_crystal_array_4_visualize = 1;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_8_analyzer_2_array_crystal_array_4_target_index = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_8_analyzer_2_array_crystal_array_4_target_x = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_8_analyzer_2_array_crystal_array_4_target_y = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_8_analyzer_2_array_crystal_array_4_target_z = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_8_analyzer_2_array_crystal_array_4_focus_aw = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_8_analyzer_2_array_crystal_array_4_focus_ah = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_8_analyzer_2_array_crystal_array_4_focus_xw = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_8_analyzer_2_array_crystal_array_4_focus_xh = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_8_analyzer_2_array_crystal_array_4_focus_r = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_8_analyzer_2_array_crystal_array_4_p_interact = 0;
#line 71 "MACS_sample_kidney_box.instr"
  if(0) strncpy(mccchannel_8_analyzer_2_array_crystal_array_4_mask_string, 0 ? 0 : "", 16384); else mccchannel_8_analyzer_2_array_crystal_array_4_mask_string[0]='\0';
#line 71 "MACS_sample_kidney_box.instr"
  if(0) strncpy(mccchannel_8_analyzer_2_array_crystal_array_4_mask_setting, 0 ? 0 : "", 16384); else mccchannel_8_analyzer_2_array_crystal_array_4_mask_setting[0]='\0';
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_8_analyzer_2_array_crystal_array_4_number_of_activations = 1;
#line 119255 "MACS_sample_kidney_box.c"

  SIG_MESSAGE("channel_8_analyzer_2_array_crystal_array_4 (Init:Place/Rotate)");
  rot_set_rotation(mctr1,
#line 2389 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 2389 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 2389 "MACS_sample_kidney_box.instr"
    (0 - RAD2DEG * channel_8_analyzer_2_array_theta [ 4 ])*DEG2RAD);
#line 119265 "MACS_sample_kidney_box.c"
  rot_mul(mctr1, mcrotachannel_8_analyzer_2_rotated, mcrotachannel_8_analyzer_2_array_crystal_array_4);
  rot_transpose(mcrotachannel_8_analyzer_2_array_crystal_array_3, mctr1);
  rot_mul(mcrotachannel_8_analyzer_2_array_crystal_array_4, mctr1, mcrotrchannel_8_analyzer_2_array_crystal_array_4);
  mctc1 = coords_set(
#line 2388 "MACS_sample_kidney_box.instr"
    0 + channel_8_analyzer_2_array_effective_radius_of_curvature * ( 1 - cos ( channel_8_analyzer_2_array_theta [ 4 ] ) ),
#line 2388 "MACS_sample_kidney_box.instr"
    0 + channel_8_analyzer_2_array_effective_radius_of_curvature * sin ( channel_8_analyzer_2_array_theta [ 4 ] ),
#line 2388 "MACS_sample_kidney_box.instr"
    0);
#line 119276 "MACS_sample_kidney_box.c"
  rot_transpose(mcrotachannel_8_analyzer_2_rotated, mctr1);
  mctc2 = rot_apply(mctr1, mctc1);
  mcposachannel_8_analyzer_2_array_crystal_array_4 = coords_add(mcposachannel_8_analyzer_2_rotated, mctc2);
  mctc1 = coords_sub(mcposachannel_8_analyzer_2_array_crystal_array_3, mcposachannel_8_analyzer_2_array_crystal_array_4);
  mcposrchannel_8_analyzer_2_array_crystal_array_4 = rot_apply(mcrotachannel_8_analyzer_2_array_crystal_array_4, mctc1);
  mcDEBUG_COMPONENT("channel_8_analyzer_2_array_crystal_array_4", mcposachannel_8_analyzer_2_array_crystal_array_4, mcrotachannel_8_analyzer_2_array_crystal_array_4)
  mccomp_posa[449] = mcposachannel_8_analyzer_2_array_crystal_array_4;
  mccomp_posr[449] = mcposrchannel_8_analyzer_2_array_crystal_array_4;
  mcNCounter[449]  = mcPCounter[449] = mcP2Counter[449] = 0;
  mcAbsorbProp[449]= 0;
    /* Component channel_8_analyzer_2_array_crystal_array_5. */
  /* Setting parameters for component channel_8_analyzer_2_array_crystal_array_5. */
  SIG_MESSAGE("channel_8_analyzer_2_array_crystal_array_5 (Init:SetPar)");
#line 2393 "MACS_sample_kidney_box.instr"
  if("PG_analyzer") strncpy(mccchannel_8_analyzer_2_array_crystal_array_5_material_string, "PG_analyzer" ? "PG_analyzer" : "", 16384); else mccchannel_8_analyzer_2_array_crystal_array_5_material_string[0]='\0';
#line 2393 "MACS_sample_kidney_box.instr"
  mccchannel_8_analyzer_2_array_crystal_array_5_priority = 1021.5;
#line 2392 "MACS_sample_kidney_box.instr"
  mccchannel_8_analyzer_2_array_crystal_array_5_xwidth = channel_8_analyzer_2_array_crystal_depth;
#line 2392 "MACS_sample_kidney_box.instr"
  mccchannel_8_analyzer_2_array_crystal_array_5_yheight = channel_8_analyzer_2_array_crystal_height;
#line 2392 "MACS_sample_kidney_box.instr"
  mccchannel_8_analyzer_2_array_crystal_array_5_zdepth = channel_8_analyzer_2_array_crystal_width;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_8_analyzer_2_array_crystal_array_5_xwidth2 = -1;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_8_analyzer_2_array_crystal_array_5_yheight2 = -1;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_8_analyzer_2_array_crystal_array_5_visualize = 1;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_8_analyzer_2_array_crystal_array_5_target_index = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_8_analyzer_2_array_crystal_array_5_target_x = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_8_analyzer_2_array_crystal_array_5_target_y = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_8_analyzer_2_array_crystal_array_5_target_z = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_8_analyzer_2_array_crystal_array_5_focus_aw = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_8_analyzer_2_array_crystal_array_5_focus_ah = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_8_analyzer_2_array_crystal_array_5_focus_xw = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_8_analyzer_2_array_crystal_array_5_focus_xh = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_8_analyzer_2_array_crystal_array_5_focus_r = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_8_analyzer_2_array_crystal_array_5_p_interact = 0;
#line 71 "MACS_sample_kidney_box.instr"
  if(0) strncpy(mccchannel_8_analyzer_2_array_crystal_array_5_mask_string, 0 ? 0 : "", 16384); else mccchannel_8_analyzer_2_array_crystal_array_5_mask_string[0]='\0';
#line 71 "MACS_sample_kidney_box.instr"
  if(0) strncpy(mccchannel_8_analyzer_2_array_crystal_array_5_mask_setting, 0 ? 0 : "", 16384); else mccchannel_8_analyzer_2_array_crystal_array_5_mask_setting[0]='\0';
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_8_analyzer_2_array_crystal_array_5_number_of_activations = 1;
#line 119332 "MACS_sample_kidney_box.c"

  SIG_MESSAGE("channel_8_analyzer_2_array_crystal_array_5 (Init:Place/Rotate)");
  rot_set_rotation(mctr1,
#line 2395 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 2395 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 2395 "MACS_sample_kidney_box.instr"
    (0 - RAD2DEG * channel_8_analyzer_2_array_theta [ 5 ])*DEG2RAD);
#line 119342 "MACS_sample_kidney_box.c"
  rot_mul(mctr1, mcrotachannel_8_analyzer_2_rotated, mcrotachannel_8_analyzer_2_array_crystal_array_5);
  rot_transpose(mcrotachannel_8_analyzer_2_array_crystal_array_4, mctr1);
  rot_mul(mcrotachannel_8_analyzer_2_array_crystal_array_5, mctr1, mcrotrchannel_8_analyzer_2_array_crystal_array_5);
  mctc1 = coords_set(
#line 2394 "MACS_sample_kidney_box.instr"
    0 + channel_8_analyzer_2_array_effective_radius_of_curvature * ( 1 - cos ( channel_8_analyzer_2_array_theta [ 5 ] ) ),
#line 2394 "MACS_sample_kidney_box.instr"
    0 + channel_8_analyzer_2_array_effective_radius_of_curvature * sin ( channel_8_analyzer_2_array_theta [ 5 ] ),
#line 2394 "MACS_sample_kidney_box.instr"
    0);
#line 119353 "MACS_sample_kidney_box.c"
  rot_transpose(mcrotachannel_8_analyzer_2_rotated, mctr1);
  mctc2 = rot_apply(mctr1, mctc1);
  mcposachannel_8_analyzer_2_array_crystal_array_5 = coords_add(mcposachannel_8_analyzer_2_rotated, mctc2);
  mctc1 = coords_sub(mcposachannel_8_analyzer_2_array_crystal_array_4, mcposachannel_8_analyzer_2_array_crystal_array_5);
  mcposrchannel_8_analyzer_2_array_crystal_array_5 = rot_apply(mcrotachannel_8_analyzer_2_array_crystal_array_5, mctc1);
  mcDEBUG_COMPONENT("channel_8_analyzer_2_array_crystal_array_5", mcposachannel_8_analyzer_2_array_crystal_array_5, mcrotachannel_8_analyzer_2_array_crystal_array_5)
  mccomp_posa[450] = mcposachannel_8_analyzer_2_array_crystal_array_5;
  mccomp_posr[450] = mcposrchannel_8_analyzer_2_array_crystal_array_5;
  mcNCounter[450]  = mcPCounter[450] = mcP2Counter[450] = 0;
  mcAbsorbProp[450]= 0;
    /* Component channel_8_analyzer_2_array_crystal_array_6. */
  /* Setting parameters for component channel_8_analyzer_2_array_crystal_array_6. */
  SIG_MESSAGE("channel_8_analyzer_2_array_crystal_array_6 (Init:SetPar)");
#line 2399 "MACS_sample_kidney_box.instr"
  if("PG_analyzer") strncpy(mccchannel_8_analyzer_2_array_crystal_array_6_material_string, "PG_analyzer" ? "PG_analyzer" : "", 16384); else mccchannel_8_analyzer_2_array_crystal_array_6_material_string[0]='\0';
#line 2399 "MACS_sample_kidney_box.instr"
  mccchannel_8_analyzer_2_array_crystal_array_6_priority = 1021.6;
#line 2398 "MACS_sample_kidney_box.instr"
  mccchannel_8_analyzer_2_array_crystal_array_6_xwidth = channel_8_analyzer_2_array_crystal_depth;
#line 2398 "MACS_sample_kidney_box.instr"
  mccchannel_8_analyzer_2_array_crystal_array_6_yheight = channel_8_analyzer_2_array_crystal_height;
#line 2398 "MACS_sample_kidney_box.instr"
  mccchannel_8_analyzer_2_array_crystal_array_6_zdepth = channel_8_analyzer_2_array_crystal_width;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_8_analyzer_2_array_crystal_array_6_xwidth2 = -1;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_8_analyzer_2_array_crystal_array_6_yheight2 = -1;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_8_analyzer_2_array_crystal_array_6_visualize = 1;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_8_analyzer_2_array_crystal_array_6_target_index = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_8_analyzer_2_array_crystal_array_6_target_x = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_8_analyzer_2_array_crystal_array_6_target_y = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_8_analyzer_2_array_crystal_array_6_target_z = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_8_analyzer_2_array_crystal_array_6_focus_aw = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_8_analyzer_2_array_crystal_array_6_focus_ah = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_8_analyzer_2_array_crystal_array_6_focus_xw = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_8_analyzer_2_array_crystal_array_6_focus_xh = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_8_analyzer_2_array_crystal_array_6_focus_r = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_8_analyzer_2_array_crystal_array_6_p_interact = 0;
#line 71 "MACS_sample_kidney_box.instr"
  if(0) strncpy(mccchannel_8_analyzer_2_array_crystal_array_6_mask_string, 0 ? 0 : "", 16384); else mccchannel_8_analyzer_2_array_crystal_array_6_mask_string[0]='\0';
#line 71 "MACS_sample_kidney_box.instr"
  if(0) strncpy(mccchannel_8_analyzer_2_array_crystal_array_6_mask_setting, 0 ? 0 : "", 16384); else mccchannel_8_analyzer_2_array_crystal_array_6_mask_setting[0]='\0';
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_8_analyzer_2_array_crystal_array_6_number_of_activations = 1;
#line 119409 "MACS_sample_kidney_box.c"

  SIG_MESSAGE("channel_8_analyzer_2_array_crystal_array_6 (Init:Place/Rotate)");
  rot_set_rotation(mctr1,
#line 2401 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 2401 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 2401 "MACS_sample_kidney_box.instr"
    (0 - RAD2DEG * channel_8_analyzer_2_array_theta [ 6 ])*DEG2RAD);
#line 119419 "MACS_sample_kidney_box.c"
  rot_mul(mctr1, mcrotachannel_8_analyzer_2_rotated, mcrotachannel_8_analyzer_2_array_crystal_array_6);
  rot_transpose(mcrotachannel_8_analyzer_2_array_crystal_array_5, mctr1);
  rot_mul(mcrotachannel_8_analyzer_2_array_crystal_array_6, mctr1, mcrotrchannel_8_analyzer_2_array_crystal_array_6);
  mctc1 = coords_set(
#line 2400 "MACS_sample_kidney_box.instr"
    0 + channel_8_analyzer_2_array_effective_radius_of_curvature * ( 1 - cos ( channel_8_analyzer_2_array_theta [ 6 ] ) ),
#line 2400 "MACS_sample_kidney_box.instr"
    0 + channel_8_analyzer_2_array_effective_radius_of_curvature * sin ( channel_8_analyzer_2_array_theta [ 6 ] ),
#line 2400 "MACS_sample_kidney_box.instr"
    0);
#line 119430 "MACS_sample_kidney_box.c"
  rot_transpose(mcrotachannel_8_analyzer_2_rotated, mctr1);
  mctc2 = rot_apply(mctr1, mctc1);
  mcposachannel_8_analyzer_2_array_crystal_array_6 = coords_add(mcposachannel_8_analyzer_2_rotated, mctc2);
  mctc1 = coords_sub(mcposachannel_8_analyzer_2_array_crystal_array_5, mcposachannel_8_analyzer_2_array_crystal_array_6);
  mcposrchannel_8_analyzer_2_array_crystal_array_6 = rot_apply(mcrotachannel_8_analyzer_2_array_crystal_array_6, mctc1);
  mcDEBUG_COMPONENT("channel_8_analyzer_2_array_crystal_array_6", mcposachannel_8_analyzer_2_array_crystal_array_6, mcrotachannel_8_analyzer_2_array_crystal_array_6)
  mccomp_posa[451] = mcposachannel_8_analyzer_2_array_crystal_array_6;
  mccomp_posr[451] = mcposrchannel_8_analyzer_2_array_crystal_array_6;
  mcNCounter[451]  = mcPCounter[451] = mcP2Counter[451] = 0;
  mcAbsorbProp[451]= 0;
    /* Component channel_8_analyzer_2_array_crystal_array_7. */
  /* Setting parameters for component channel_8_analyzer_2_array_crystal_array_7. */
  SIG_MESSAGE("channel_8_analyzer_2_array_crystal_array_7 (Init:SetPar)");
#line 2405 "MACS_sample_kidney_box.instr"
  if("PG_analyzer") strncpy(mccchannel_8_analyzer_2_array_crystal_array_7_material_string, "PG_analyzer" ? "PG_analyzer" : "", 16384); else mccchannel_8_analyzer_2_array_crystal_array_7_material_string[0]='\0';
#line 2405 "MACS_sample_kidney_box.instr"
  mccchannel_8_analyzer_2_array_crystal_array_7_priority = 1021.7;
#line 2404 "MACS_sample_kidney_box.instr"
  mccchannel_8_analyzer_2_array_crystal_array_7_xwidth = channel_8_analyzer_2_array_crystal_depth;
#line 2404 "MACS_sample_kidney_box.instr"
  mccchannel_8_analyzer_2_array_crystal_array_7_yheight = channel_8_analyzer_2_array_crystal_height;
#line 2404 "MACS_sample_kidney_box.instr"
  mccchannel_8_analyzer_2_array_crystal_array_7_zdepth = channel_8_analyzer_2_array_crystal_width;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_8_analyzer_2_array_crystal_array_7_xwidth2 = -1;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_8_analyzer_2_array_crystal_array_7_yheight2 = -1;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_8_analyzer_2_array_crystal_array_7_visualize = 1;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_8_analyzer_2_array_crystal_array_7_target_index = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_8_analyzer_2_array_crystal_array_7_target_x = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_8_analyzer_2_array_crystal_array_7_target_y = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_8_analyzer_2_array_crystal_array_7_target_z = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_8_analyzer_2_array_crystal_array_7_focus_aw = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_8_analyzer_2_array_crystal_array_7_focus_ah = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_8_analyzer_2_array_crystal_array_7_focus_xw = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_8_analyzer_2_array_crystal_array_7_focus_xh = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_8_analyzer_2_array_crystal_array_7_focus_r = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_8_analyzer_2_array_crystal_array_7_p_interact = 0;
#line 71 "MACS_sample_kidney_box.instr"
  if(0) strncpy(mccchannel_8_analyzer_2_array_crystal_array_7_mask_string, 0 ? 0 : "", 16384); else mccchannel_8_analyzer_2_array_crystal_array_7_mask_string[0]='\0';
#line 71 "MACS_sample_kidney_box.instr"
  if(0) strncpy(mccchannel_8_analyzer_2_array_crystal_array_7_mask_setting, 0 ? 0 : "", 16384); else mccchannel_8_analyzer_2_array_crystal_array_7_mask_setting[0]='\0';
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_8_analyzer_2_array_crystal_array_7_number_of_activations = 1;
#line 119486 "MACS_sample_kidney_box.c"

  SIG_MESSAGE("channel_8_analyzer_2_array_crystal_array_7 (Init:Place/Rotate)");
  rot_set_rotation(mctr1,
#line 2407 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 2407 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 2407 "MACS_sample_kidney_box.instr"
    (0 - RAD2DEG * channel_8_analyzer_2_array_theta [ 7 ])*DEG2RAD);
#line 119496 "MACS_sample_kidney_box.c"
  rot_mul(mctr1, mcrotachannel_8_analyzer_2_rotated, mcrotachannel_8_analyzer_2_array_crystal_array_7);
  rot_transpose(mcrotachannel_8_analyzer_2_array_crystal_array_6, mctr1);
  rot_mul(mcrotachannel_8_analyzer_2_array_crystal_array_7, mctr1, mcrotrchannel_8_analyzer_2_array_crystal_array_7);
  mctc1 = coords_set(
#line 2406 "MACS_sample_kidney_box.instr"
    0 + channel_8_analyzer_2_array_effective_radius_of_curvature * ( 1 - cos ( channel_8_analyzer_2_array_theta [ 7 ] ) ),
#line 2406 "MACS_sample_kidney_box.instr"
    0 + channel_8_analyzer_2_array_effective_radius_of_curvature * sin ( channel_8_analyzer_2_array_theta [ 7 ] ),
#line 2406 "MACS_sample_kidney_box.instr"
    0);
#line 119507 "MACS_sample_kidney_box.c"
  rot_transpose(mcrotachannel_8_analyzer_2_rotated, mctr1);
  mctc2 = rot_apply(mctr1, mctc1);
  mcposachannel_8_analyzer_2_array_crystal_array_7 = coords_add(mcposachannel_8_analyzer_2_rotated, mctc2);
  mctc1 = coords_sub(mcposachannel_8_analyzer_2_array_crystal_array_6, mcposachannel_8_analyzer_2_array_crystal_array_7);
  mcposrchannel_8_analyzer_2_array_crystal_array_7 = rot_apply(mcrotachannel_8_analyzer_2_array_crystal_array_7, mctc1);
  mcDEBUG_COMPONENT("channel_8_analyzer_2_array_crystal_array_7", mcposachannel_8_analyzer_2_array_crystal_array_7, mcrotachannel_8_analyzer_2_array_crystal_array_7)
  mccomp_posa[452] = mcposachannel_8_analyzer_2_array_crystal_array_7;
  mccomp_posr[452] = mcposrchannel_8_analyzer_2_array_crystal_array_7;
  mcNCounter[452]  = mcPCounter[452] = mcP2Counter[452] = 0;
  mcAbsorbProp[452]= 0;
    /* Component channel_8_analyzer_2_array_crystal_array_8. */
  /* Setting parameters for component channel_8_analyzer_2_array_crystal_array_8. */
  SIG_MESSAGE("channel_8_analyzer_2_array_crystal_array_8 (Init:SetPar)");
#line 2411 "MACS_sample_kidney_box.instr"
  if("PG_analyzer") strncpy(mccchannel_8_analyzer_2_array_crystal_array_8_material_string, "PG_analyzer" ? "PG_analyzer" : "", 16384); else mccchannel_8_analyzer_2_array_crystal_array_8_material_string[0]='\0';
#line 2411 "MACS_sample_kidney_box.instr"
  mccchannel_8_analyzer_2_array_crystal_array_8_priority = 1021.8;
#line 2410 "MACS_sample_kidney_box.instr"
  mccchannel_8_analyzer_2_array_crystal_array_8_xwidth = channel_8_analyzer_2_array_crystal_depth;
#line 2410 "MACS_sample_kidney_box.instr"
  mccchannel_8_analyzer_2_array_crystal_array_8_yheight = channel_8_analyzer_2_array_crystal_height;
#line 2410 "MACS_sample_kidney_box.instr"
  mccchannel_8_analyzer_2_array_crystal_array_8_zdepth = channel_8_analyzer_2_array_crystal_width;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_8_analyzer_2_array_crystal_array_8_xwidth2 = -1;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_8_analyzer_2_array_crystal_array_8_yheight2 = -1;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_8_analyzer_2_array_crystal_array_8_visualize = 1;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_8_analyzer_2_array_crystal_array_8_target_index = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_8_analyzer_2_array_crystal_array_8_target_x = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_8_analyzer_2_array_crystal_array_8_target_y = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_8_analyzer_2_array_crystal_array_8_target_z = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_8_analyzer_2_array_crystal_array_8_focus_aw = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_8_analyzer_2_array_crystal_array_8_focus_ah = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_8_analyzer_2_array_crystal_array_8_focus_xw = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_8_analyzer_2_array_crystal_array_8_focus_xh = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_8_analyzer_2_array_crystal_array_8_focus_r = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_8_analyzer_2_array_crystal_array_8_p_interact = 0;
#line 71 "MACS_sample_kidney_box.instr"
  if(0) strncpy(mccchannel_8_analyzer_2_array_crystal_array_8_mask_string, 0 ? 0 : "", 16384); else mccchannel_8_analyzer_2_array_crystal_array_8_mask_string[0]='\0';
#line 71 "MACS_sample_kidney_box.instr"
  if(0) strncpy(mccchannel_8_analyzer_2_array_crystal_array_8_mask_setting, 0 ? 0 : "", 16384); else mccchannel_8_analyzer_2_array_crystal_array_8_mask_setting[0]='\0';
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_8_analyzer_2_array_crystal_array_8_number_of_activations = 1;
#line 119563 "MACS_sample_kidney_box.c"

  SIG_MESSAGE("channel_8_analyzer_2_array_crystal_array_8 (Init:Place/Rotate)");
  rot_set_rotation(mctr1,
#line 2413 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 2413 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 2413 "MACS_sample_kidney_box.instr"
    (0 - RAD2DEG * channel_8_analyzer_2_array_theta [ 8 ])*DEG2RAD);
#line 119573 "MACS_sample_kidney_box.c"
  rot_mul(mctr1, mcrotachannel_8_analyzer_2_rotated, mcrotachannel_8_analyzer_2_array_crystal_array_8);
  rot_transpose(mcrotachannel_8_analyzer_2_array_crystal_array_7, mctr1);
  rot_mul(mcrotachannel_8_analyzer_2_array_crystal_array_8, mctr1, mcrotrchannel_8_analyzer_2_array_crystal_array_8);
  mctc1 = coords_set(
#line 2412 "MACS_sample_kidney_box.instr"
    0 + channel_8_analyzer_2_array_effective_radius_of_curvature * ( 1 - cos ( channel_8_analyzer_2_array_theta [ 8 ] ) ),
#line 2412 "MACS_sample_kidney_box.instr"
    0 + channel_8_analyzer_2_array_effective_radius_of_curvature * sin ( channel_8_analyzer_2_array_theta [ 8 ] ),
#line 2412 "MACS_sample_kidney_box.instr"
    0);
#line 119584 "MACS_sample_kidney_box.c"
  rot_transpose(mcrotachannel_8_analyzer_2_rotated, mctr1);
  mctc2 = rot_apply(mctr1, mctc1);
  mcposachannel_8_analyzer_2_array_crystal_array_8 = coords_add(mcposachannel_8_analyzer_2_rotated, mctc2);
  mctc1 = coords_sub(mcposachannel_8_analyzer_2_array_crystal_array_7, mcposachannel_8_analyzer_2_array_crystal_array_8);
  mcposrchannel_8_analyzer_2_array_crystal_array_8 = rot_apply(mcrotachannel_8_analyzer_2_array_crystal_array_8, mctc1);
  mcDEBUG_COMPONENT("channel_8_analyzer_2_array_crystal_array_8", mcposachannel_8_analyzer_2_array_crystal_array_8, mcrotachannel_8_analyzer_2_array_crystal_array_8)
  mccomp_posa[453] = mcposachannel_8_analyzer_2_array_crystal_array_8;
  mccomp_posr[453] = mcposrchannel_8_analyzer_2_array_crystal_array_8;
  mcNCounter[453]  = mcPCounter[453] = mcP2Counter[453] = 0;
  mcAbsorbProp[453]= 0;
    /* Component channel_8_cave2_cyl1. */
  /* Setting parameters for component channel_8_cave2_cyl1. */
  SIG_MESSAGE("channel_8_cave2_cyl1 (Init:SetPar)");
#line 2418 "MACS_sample_kidney_box.instr"
  if("Vacuum") strncpy(mccchannel_8_cave2_cyl1_material_string, "Vacuum" ? "Vacuum" : "", 16384); else mccchannel_8_cave2_cyl1_material_string[0]='\0';
#line 2418 "MACS_sample_kidney_box.instr"
  mccchannel_8_cave2_cyl1_priority = 1007.5;
#line 2417 "MACS_sample_kidney_box.instr"
  mccchannel_8_cave2_cyl1_radius = kidney_cave2_cyl1_radius;
#line 2417 "MACS_sample_kidney_box.instr"
  mccchannel_8_cave2_cyl1_yheight = kidney_cave2_cyl1_height;
#line 67 "MACS_sample_kidney_box.instr"
  mccchannel_8_cave2_cyl1_visualize = 1;
#line 67 "MACS_sample_kidney_box.instr"
  mccchannel_8_cave2_cyl1_target_index = 0;
#line 67 "MACS_sample_kidney_box.instr"
  mccchannel_8_cave2_cyl1_target_x = 0;
#line 67 "MACS_sample_kidney_box.instr"
  mccchannel_8_cave2_cyl1_target_y = 0;
#line 67 "MACS_sample_kidney_box.instr"
  mccchannel_8_cave2_cyl1_target_z = 0;
#line 67 "MACS_sample_kidney_box.instr"
  mccchannel_8_cave2_cyl1_focus_aw = 0;
#line 67 "MACS_sample_kidney_box.instr"
  mccchannel_8_cave2_cyl1_focus_ah = 0;
#line 67 "MACS_sample_kidney_box.instr"
  mccchannel_8_cave2_cyl1_focus_xw = 0;
#line 67 "MACS_sample_kidney_box.instr"
  mccchannel_8_cave2_cyl1_focus_xh = 0;
#line 67 "MACS_sample_kidney_box.instr"
  mccchannel_8_cave2_cyl1_focus_r = 0;
#line 67 "MACS_sample_kidney_box.instr"
  mccchannel_8_cave2_cyl1_p_interact = 0;
#line 67 "MACS_sample_kidney_box.instr"
  if(0) strncpy(mccchannel_8_cave2_cyl1_mask_string, 0 ? 0 : "", 16384); else mccchannel_8_cave2_cyl1_mask_string[0]='\0';
#line 67 "MACS_sample_kidney_box.instr"
  if(0) strncpy(mccchannel_8_cave2_cyl1_mask_setting, 0 ? 0 : "", 16384); else mccchannel_8_cave2_cyl1_mask_setting[0]='\0';
#line 67 "MACS_sample_kidney_box.instr"
  mccchannel_8_cave2_cyl1_number_of_activations = 1;
#line 119634 "MACS_sample_kidney_box.c"

  SIG_MESSAGE("channel_8_cave2_cyl1 (Init:Place/Rotate)");
  rot_set_rotation(mctr1,
#line 2420 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 2420 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 2420 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD);
#line 119644 "MACS_sample_kidney_box.c"
  rot_mul(mctr1, mcrotachannel_8_analyzer_2_center, mcrotachannel_8_cave2_cyl1);
  rot_transpose(mcrotachannel_8_analyzer_2_array_crystal_array_8, mctr1);
  rot_mul(mcrotachannel_8_cave2_cyl1, mctr1, mcrotrchannel_8_cave2_cyl1);
  mctc1 = coords_set(
#line 2419 "MACS_sample_kidney_box.instr"
    0,
#line 2419 "MACS_sample_kidney_box.instr"
    0,
#line 2419 "MACS_sample_kidney_box.instr"
    spec_detector_to_analyzer_2_center);
#line 119655 "MACS_sample_kidney_box.c"
  rot_transpose(mcrotachannel_8_analyzer_2_center, mctr1);
  mctc2 = rot_apply(mctr1, mctc1);
  mcposachannel_8_cave2_cyl1 = coords_add(mcposachannel_8_analyzer_2_center, mctc2);
  mctc1 = coords_sub(mcposachannel_8_analyzer_2_array_crystal_array_8, mcposachannel_8_cave2_cyl1);
  mcposrchannel_8_cave2_cyl1 = rot_apply(mcrotachannel_8_cave2_cyl1, mctc1);
  mcDEBUG_COMPONENT("channel_8_cave2_cyl1", mcposachannel_8_cave2_cyl1, mcrotachannel_8_cave2_cyl1)
  mccomp_posa[454] = mcposachannel_8_cave2_cyl1;
  mccomp_posr[454] = mcposrchannel_8_cave2_cyl1;
  mcNCounter[454]  = mcPCounter[454] = mcP2Counter[454] = 0;
  mcAbsorbProp[454]= 0;
    /* Component channel_8_cave2_box1. */
  /* Setting parameters for component channel_8_cave2_box1. */
  SIG_MESSAGE("channel_8_cave2_box1 (Init:SetPar)");
#line 2425 "MACS_sample_kidney_box.instr"
  if("Vacuum") strncpy(mccchannel_8_cave2_box1_material_string, "Vacuum" ? "Vacuum" : "", 16384); else mccchannel_8_cave2_box1_material_string[0]='\0';
#line 2425 "MACS_sample_kidney_box.instr"
  mccchannel_8_cave2_box1_priority = 1001;
#line 2423 "MACS_sample_kidney_box.instr"
  mccchannel_8_cave2_box1_xwidth = kidney_cave2_box1_width1;
#line 2423 "MACS_sample_kidney_box.instr"
  mccchannel_8_cave2_box1_yheight = kidney_cave2_box1_height1;
#line 2423 "MACS_sample_kidney_box.instr"
  mccchannel_8_cave2_box1_zdepth = kidney_cave2_box1_depth;
#line 2424 "MACS_sample_kidney_box.instr"
  mccchannel_8_cave2_box1_xwidth2 = kidney_cave2_box1_width2;
#line 2424 "MACS_sample_kidney_box.instr"
  mccchannel_8_cave2_box1_yheight2 = kidney_cave2_box1_height2;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_8_cave2_box1_visualize = 1;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_8_cave2_box1_target_index = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_8_cave2_box1_target_x = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_8_cave2_box1_target_y = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_8_cave2_box1_target_z = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_8_cave2_box1_focus_aw = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_8_cave2_box1_focus_ah = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_8_cave2_box1_focus_xw = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_8_cave2_box1_focus_xh = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_8_cave2_box1_focus_r = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_8_cave2_box1_p_interact = 0;
#line 71 "MACS_sample_kidney_box.instr"
  if(0) strncpy(mccchannel_8_cave2_box1_mask_string, 0 ? 0 : "", 16384); else mccchannel_8_cave2_box1_mask_string[0]='\0';
#line 71 "MACS_sample_kidney_box.instr"
  if(0) strncpy(mccchannel_8_cave2_box1_mask_setting, 0 ? 0 : "", 16384); else mccchannel_8_cave2_box1_mask_setting[0]='\0';
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_8_cave2_box1_number_of_activations = 1;
#line 119711 "MACS_sample_kidney_box.c"

  SIG_MESSAGE("channel_8_cave2_box1 (Init:Place/Rotate)");
  rot_set_rotation(mctr1,
#line 2427 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 2427 "MACS_sample_kidney_box.instr"
    (kidney_cave2_box1_y_rotation)*DEG2RAD,
#line 2427 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD);
#line 119721 "MACS_sample_kidney_box.c"
  rot_mul(mctr1, mcrotachannel_8_cave2_cyl1, mcrotachannel_8_cave2_box1);
  rot_transpose(mcrotachannel_8_cave2_cyl1, mctr1);
  rot_mul(mcrotachannel_8_cave2_box1, mctr1, mcrotrchannel_8_cave2_box1);
  mctc1 = coords_set(
#line 2426 "MACS_sample_kidney_box.instr"
    kidney_cave2_box1_center_to_spec_detector_x,
#line 2426 "MACS_sample_kidney_box.instr"
    0,
#line 2426 "MACS_sample_kidney_box.instr"
    kidney_cave2_box1_center_to_spec_detector_z);
#line 119732 "MACS_sample_kidney_box.c"
  rot_transpose(mcrotachannel_8_cave2_cyl1, mctr1);
  mctc2 = rot_apply(mctr1, mctc1);
  mcposachannel_8_cave2_box1 = coords_add(mcposachannel_8_cave2_cyl1, mctc2);
  mctc1 = coords_sub(mcposachannel_8_cave2_cyl1, mcposachannel_8_cave2_box1);
  mcposrchannel_8_cave2_box1 = rot_apply(mcrotachannel_8_cave2_box1, mctc1);
  mcDEBUG_COMPONENT("channel_8_cave2_box1", mcposachannel_8_cave2_box1, mcrotachannel_8_cave2_box1)
  mccomp_posa[455] = mcposachannel_8_cave2_box1;
  mccomp_posr[455] = mcposrchannel_8_cave2_box1;
  mcNCounter[455]  = mcPCounter[455] = mcP2Counter[455] = 0;
  mcAbsorbProp[455]= 0;
    /* Component channel_8_cave2_box2. */
  /* Setting parameters for component channel_8_cave2_box2. */
  SIG_MESSAGE("channel_8_cave2_box2 (Init:SetPar)");
#line 2432 "MACS_sample_kidney_box.instr"
  if("Vacuum") strncpy(mccchannel_8_cave2_box2_material_string, "Vacuum" ? "Vacuum" : "", 16384); else mccchannel_8_cave2_box2_material_string[0]='\0';
#line 2432 "MACS_sample_kidney_box.instr"
  mccchannel_8_cave2_box2_priority = 1006;
#line 2430 "MACS_sample_kidney_box.instr"
  mccchannel_8_cave2_box2_xwidth = kidney_cave2_box2_width1;
#line 2430 "MACS_sample_kidney_box.instr"
  mccchannel_8_cave2_box2_yheight = kidney_cave2_box2_height1;
#line 2430 "MACS_sample_kidney_box.instr"
  mccchannel_8_cave2_box2_zdepth = kidney_cave2_box2_depth;
#line 2431 "MACS_sample_kidney_box.instr"
  mccchannel_8_cave2_box2_xwidth2 = kidney_cave2_box2_width2;
#line 2431 "MACS_sample_kidney_box.instr"
  mccchannel_8_cave2_box2_yheight2 = kidney_cave2_box2_height2;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_8_cave2_box2_visualize = 1;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_8_cave2_box2_target_index = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_8_cave2_box2_target_x = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_8_cave2_box2_target_y = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_8_cave2_box2_target_z = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_8_cave2_box2_focus_aw = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_8_cave2_box2_focus_ah = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_8_cave2_box2_focus_xw = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_8_cave2_box2_focus_xh = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_8_cave2_box2_focus_r = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_8_cave2_box2_p_interact = 0;
#line 71 "MACS_sample_kidney_box.instr"
  if(0) strncpy(mccchannel_8_cave2_box2_mask_string, 0 ? 0 : "", 16384); else mccchannel_8_cave2_box2_mask_string[0]='\0';
#line 71 "MACS_sample_kidney_box.instr"
  if(0) strncpy(mccchannel_8_cave2_box2_mask_setting, 0 ? 0 : "", 16384); else mccchannel_8_cave2_box2_mask_setting[0]='\0';
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_8_cave2_box2_number_of_activations = 1;
#line 119788 "MACS_sample_kidney_box.c"

  SIG_MESSAGE("channel_8_cave2_box2 (Init:Place/Rotate)");
  rot_set_rotation(mctr1,
#line 2434 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 2434 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 2434 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD);
#line 119798 "MACS_sample_kidney_box.c"
  rot_mul(mctr1, mcrotachannel_8_cave2_cyl1, mcrotachannel_8_cave2_box2);
  rot_transpose(mcrotachannel_8_cave2_box1, mctr1);
  rot_mul(mcrotachannel_8_cave2_box2, mctr1, mcrotrchannel_8_cave2_box2);
  mctc1 = coords_set(
#line 2433 "MACS_sample_kidney_box.instr"
    0,
#line 2433 "MACS_sample_kidney_box.instr"
    0,
#line 2433 "MACS_sample_kidney_box.instr"
    kidney_cave2_box2_center_to_detector);
#line 119809 "MACS_sample_kidney_box.c"
  rot_transpose(mcrotachannel_8_cave2_cyl1, mctr1);
  mctc2 = rot_apply(mctr1, mctc1);
  mcposachannel_8_cave2_box2 = coords_add(mcposachannel_8_cave2_cyl1, mctc2);
  mctc1 = coords_sub(mcposachannel_8_cave2_box1, mcposachannel_8_cave2_box2);
  mcposrchannel_8_cave2_box2 = rot_apply(mcrotachannel_8_cave2_box2, mctc1);
  mcDEBUG_COMPONENT("channel_8_cave2_box2", mcposachannel_8_cave2_box2, mcrotachannel_8_cave2_box2)
  mccomp_posa[456] = mcposachannel_8_cave2_box2;
  mccomp_posr[456] = mcposrchannel_8_cave2_box2;
  mcNCounter[456]  = mcPCounter[456] = mcP2Counter[456] = 0;
  mcAbsorbProp[456]= 0;
    /* Component channel_8_cave2_box3. */
  /* Setting parameters for component channel_8_cave2_box3. */
  SIG_MESSAGE("channel_8_cave2_box3 (Init:SetPar)");
#line 2439 "MACS_sample_kidney_box.instr"
  if("Vacuum") strncpy(mccchannel_8_cave2_box3_material_string, "Vacuum" ? "Vacuum" : "", 16384); else mccchannel_8_cave2_box3_material_string[0]='\0';
#line 2439 "MACS_sample_kidney_box.instr"
  mccchannel_8_cave2_box3_priority = 1007;
#line 2437 "MACS_sample_kidney_box.instr"
  mccchannel_8_cave2_box3_xwidth = kidney_cave2_box3_width1;
#line 2437 "MACS_sample_kidney_box.instr"
  mccchannel_8_cave2_box3_yheight = kidney_cave2_box3_height1;
#line 2437 "MACS_sample_kidney_box.instr"
  mccchannel_8_cave2_box3_zdepth = kidney_cave2_box3_depth;
#line 2438 "MACS_sample_kidney_box.instr"
  mccchannel_8_cave2_box3_xwidth2 = kidney_cave2_box3_width2;
#line 2438 "MACS_sample_kidney_box.instr"
  mccchannel_8_cave2_box3_yheight2 = kidney_cave2_box3_height2;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_8_cave2_box3_visualize = 1;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_8_cave2_box3_target_index = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_8_cave2_box3_target_x = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_8_cave2_box3_target_y = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_8_cave2_box3_target_z = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_8_cave2_box3_focus_aw = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_8_cave2_box3_focus_ah = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_8_cave2_box3_focus_xw = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_8_cave2_box3_focus_xh = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_8_cave2_box3_focus_r = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_8_cave2_box3_p_interact = 0;
#line 71 "MACS_sample_kidney_box.instr"
  if(0) strncpy(mccchannel_8_cave2_box3_mask_string, 0 ? 0 : "", 16384); else mccchannel_8_cave2_box3_mask_string[0]='\0';
#line 71 "MACS_sample_kidney_box.instr"
  if(0) strncpy(mccchannel_8_cave2_box3_mask_setting, 0 ? 0 : "", 16384); else mccchannel_8_cave2_box3_mask_setting[0]='\0';
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_8_cave2_box3_number_of_activations = 1;
#line 119865 "MACS_sample_kidney_box.c"

  SIG_MESSAGE("channel_8_cave2_box3 (Init:Place/Rotate)");
  rot_set_rotation(mctr1,
#line 2441 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 2441 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 2441 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD);
#line 119875 "MACS_sample_kidney_box.c"
  rot_mul(mctr1, mcrotachannel_8_cave2_cyl1, mcrotachannel_8_cave2_box3);
  rot_transpose(mcrotachannel_8_cave2_box2, mctr1);
  rot_mul(mcrotachannel_8_cave2_box3, mctr1, mcrotrchannel_8_cave2_box3);
  mctc1 = coords_set(
#line 2440 "MACS_sample_kidney_box.instr"
    0,
#line 2440 "MACS_sample_kidney_box.instr"
    0,
#line 2440 "MACS_sample_kidney_box.instr"
    kidney_cave2_box3_center_to_detector);
#line 119886 "MACS_sample_kidney_box.c"
  rot_transpose(mcrotachannel_8_cave2_cyl1, mctr1);
  mctc2 = rot_apply(mctr1, mctc1);
  mcposachannel_8_cave2_box3 = coords_add(mcposachannel_8_cave2_cyl1, mctc2);
  mctc1 = coords_sub(mcposachannel_8_cave2_box2, mcposachannel_8_cave2_box3);
  mcposrchannel_8_cave2_box3 = rot_apply(mcrotachannel_8_cave2_box3, mctc1);
  mcDEBUG_COMPONENT("channel_8_cave2_box3", mcposachannel_8_cave2_box3, mcrotachannel_8_cave2_box3)
  mccomp_posa[457] = mcposachannel_8_cave2_box3;
  mccomp_posr[457] = mcposrchannel_8_cave2_box3;
  mcNCounter[457]  = mcPCounter[457] = mcP2Counter[457] = 0;
  mcAbsorbProp[457]= 0;
    /* Component inter_analyzer_colimator_center_8. */
  /* Setting parameters for component inter_analyzer_colimator_center_8. */
  SIG_MESSAGE("inter_analyzer_colimator_center_8 (Init:SetPar)");

  SIG_MESSAGE("inter_analyzer_colimator_center_8 (Init:Place/Rotate)");
  rot_set_rotation(mctr1,
#line 2445 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 2445 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 2445 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD);
#line 119909 "MACS_sample_kidney_box.c"
  rot_mul(mctr1, mcrotachannel_8_analyzer_1_center, mcrotainter_analyzer_colimator_center_8);
  rot_transpose(mcrotachannel_8_cave2_box3, mctr1);
  rot_mul(mcrotainter_analyzer_colimator_center_8, mctr1, mcrotrinter_analyzer_colimator_center_8);
  mctc1 = coords_set(
#line 2444 "MACS_sample_kidney_box.instr"
    -0.5 * analyzer_seperation,
#line 2444 "MACS_sample_kidney_box.instr"
    0,
#line 2444 "MACS_sample_kidney_box.instr"
    0);
#line 119920 "MACS_sample_kidney_box.c"
  rot_transpose(mcrotachannel_8_analyzer_1_center, mctr1);
  mctc2 = rot_apply(mctr1, mctc1);
  mcposainter_analyzer_colimator_center_8 = coords_add(mcposachannel_8_analyzer_1_center, mctc2);
  mctc1 = coords_sub(mcposachannel_8_cave2_box3, mcposainter_analyzer_colimator_center_8);
  mcposrinter_analyzer_colimator_center_8 = rot_apply(mcrotainter_analyzer_colimator_center_8, mctc1);
  mcDEBUG_COMPONENT("inter_analyzer_colimator_center_8", mcposainter_analyzer_colimator_center_8, mcrotainter_analyzer_colimator_center_8)
  mccomp_posa[458] = mcposainter_analyzer_colimator_center_8;
  mccomp_posr[458] = mcposrinter_analyzer_colimator_center_8;
  mcNCounter[458]  = mcPCounter[458] = mcP2Counter[458] = 0;
  mcAbsorbProp[458]= 0;
    /* Component inter_analyzer_colimator_8_blade_0. */
  /* Setting parameters for component inter_analyzer_colimator_8_blade_0. */
  SIG_MESSAGE("inter_analyzer_colimator_8_blade_0 (Init:SetPar)");
#line 2449 "MACS_sample_kidney_box.instr"
  if("Collimator_gad") strncpy(mccinter_analyzer_colimator_8_blade_0_material_string, "Collimator_gad" ? "Collimator_gad" : "", 16384); else mccinter_analyzer_colimator_8_blade_0_material_string[0]='\0';
#line 2449 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_8_blade_0_priority = 1025;
#line 2448 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_8_blade_0_xwidth = inter_analyzer_colimator_width;
#line 2448 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_8_blade_0_yheight = inter_analyzer_colimator_height;
#line 2448 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_8_blade_0_zdepth = inter_analyzer_colimator_depth;
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_8_blade_0_xwidth2 = -1;
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_8_blade_0_yheight2 = -1;
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_8_blade_0_visualize = 1;
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_8_blade_0_target_index = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_8_blade_0_target_x = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_8_blade_0_target_y = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_8_blade_0_target_z = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_8_blade_0_focus_aw = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_8_blade_0_focus_ah = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_8_blade_0_focus_xw = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_8_blade_0_focus_xh = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_8_blade_0_focus_r = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_8_blade_0_p_interact = 0;
#line 71 "MACS_sample_kidney_box.instr"
  if(0) strncpy(mccinter_analyzer_colimator_8_blade_0_mask_string, 0 ? 0 : "", 16384); else mccinter_analyzer_colimator_8_blade_0_mask_string[0]='\0';
#line 71 "MACS_sample_kidney_box.instr"
  if(0) strncpy(mccinter_analyzer_colimator_8_blade_0_mask_setting, 0 ? 0 : "", 16384); else mccinter_analyzer_colimator_8_blade_0_mask_setting[0]='\0';
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_8_blade_0_number_of_activations = 1;
#line 119976 "MACS_sample_kidney_box.c"

  SIG_MESSAGE("inter_analyzer_colimator_8_blade_0 (Init:Place/Rotate)");
  rot_set_rotation(mctr1,
#line 2451 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 2451 "MACS_sample_kidney_box.instr"
    (- analyzer_2theta [ 8 ])*DEG2RAD,
#line 2451 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD);
#line 119986 "MACS_sample_kidney_box.c"
  rot_mul(mctr1, mcrotainter_analyzer_colimator_center_8, mcrotainter_analyzer_colimator_8_blade_0);
  rot_transpose(mcrotainter_analyzer_colimator_center_8, mctr1);
  rot_mul(mcrotainter_analyzer_colimator_8_blade_0, mctr1, mcrotrinter_analyzer_colimator_8_blade_0);
  mctc1 = coords_set(
#line 2450 "MACS_sample_kidney_box.instr"
    0,
#line 2450 "MACS_sample_kidney_box.instr"
    0,
#line 2450 "MACS_sample_kidney_box.instr"
    inter_analyzer_colimator_start_pos - 0 * inter_analyzer_colimator_seperation);
#line 119997 "MACS_sample_kidney_box.c"
  rot_transpose(mcrotainter_analyzer_colimator_center_8, mctr1);
  mctc2 = rot_apply(mctr1, mctc1);
  mcposainter_analyzer_colimator_8_blade_0 = coords_add(mcposainter_analyzer_colimator_center_8, mctc2);
  mctc1 = coords_sub(mcposainter_analyzer_colimator_center_8, mcposainter_analyzer_colimator_8_blade_0);
  mcposrinter_analyzer_colimator_8_blade_0 = rot_apply(mcrotainter_analyzer_colimator_8_blade_0, mctc1);
  mcDEBUG_COMPONENT("inter_analyzer_colimator_8_blade_0", mcposainter_analyzer_colimator_8_blade_0, mcrotainter_analyzer_colimator_8_blade_0)
  mccomp_posa[459] = mcposainter_analyzer_colimator_8_blade_0;
  mccomp_posr[459] = mcposrinter_analyzer_colimator_8_blade_0;
  mcNCounter[459]  = mcPCounter[459] = mcP2Counter[459] = 0;
  mcAbsorbProp[459]= 0;
    /* Component inter_analyzer_colimator_8_blade_1. */
  /* Setting parameters for component inter_analyzer_colimator_8_blade_1. */
  SIG_MESSAGE("inter_analyzer_colimator_8_blade_1 (Init:SetPar)");
#line 2455 "MACS_sample_kidney_box.instr"
  if("Collimator_gad") strncpy(mccinter_analyzer_colimator_8_blade_1_material_string, "Collimator_gad" ? "Collimator_gad" : "", 16384); else mccinter_analyzer_colimator_8_blade_1_material_string[0]='\0';
#line 2455 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_8_blade_1_priority = 1026;
#line 2454 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_8_blade_1_xwidth = inter_analyzer_colimator_width;
#line 2454 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_8_blade_1_yheight = inter_analyzer_colimator_height;
#line 2454 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_8_blade_1_zdepth = inter_analyzer_colimator_depth;
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_8_blade_1_xwidth2 = -1;
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_8_blade_1_yheight2 = -1;
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_8_blade_1_visualize = 1;
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_8_blade_1_target_index = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_8_blade_1_target_x = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_8_blade_1_target_y = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_8_blade_1_target_z = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_8_blade_1_focus_aw = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_8_blade_1_focus_ah = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_8_blade_1_focus_xw = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_8_blade_1_focus_xh = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_8_blade_1_focus_r = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_8_blade_1_p_interact = 0;
#line 71 "MACS_sample_kidney_box.instr"
  if(0) strncpy(mccinter_analyzer_colimator_8_blade_1_mask_string, 0 ? 0 : "", 16384); else mccinter_analyzer_colimator_8_blade_1_mask_string[0]='\0';
#line 71 "MACS_sample_kidney_box.instr"
  if(0) strncpy(mccinter_analyzer_colimator_8_blade_1_mask_setting, 0 ? 0 : "", 16384); else mccinter_analyzer_colimator_8_blade_1_mask_setting[0]='\0';
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_8_blade_1_number_of_activations = 1;
#line 120053 "MACS_sample_kidney_box.c"

  SIG_MESSAGE("inter_analyzer_colimator_8_blade_1 (Init:Place/Rotate)");
  rot_set_rotation(mctr1,
#line 2457 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 2457 "MACS_sample_kidney_box.instr"
    (- analyzer_2theta [ 8 ])*DEG2RAD,
#line 2457 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD);
#line 120063 "MACS_sample_kidney_box.c"
  rot_mul(mctr1, mcrotainter_analyzer_colimator_center_8, mcrotainter_analyzer_colimator_8_blade_1);
  rot_transpose(mcrotainter_analyzer_colimator_8_blade_0, mctr1);
  rot_mul(mcrotainter_analyzer_colimator_8_blade_1, mctr1, mcrotrinter_analyzer_colimator_8_blade_1);
  mctc1 = coords_set(
#line 2456 "MACS_sample_kidney_box.instr"
    0,
#line 2456 "MACS_sample_kidney_box.instr"
    0,
#line 2456 "MACS_sample_kidney_box.instr"
    inter_analyzer_colimator_start_pos - 1 * inter_analyzer_colimator_seperation);
#line 120074 "MACS_sample_kidney_box.c"
  rot_transpose(mcrotainter_analyzer_colimator_center_8, mctr1);
  mctc2 = rot_apply(mctr1, mctc1);
  mcposainter_analyzer_colimator_8_blade_1 = coords_add(mcposainter_analyzer_colimator_center_8, mctc2);
  mctc1 = coords_sub(mcposainter_analyzer_colimator_8_blade_0, mcposainter_analyzer_colimator_8_blade_1);
  mcposrinter_analyzer_colimator_8_blade_1 = rot_apply(mcrotainter_analyzer_colimator_8_blade_1, mctc1);
  mcDEBUG_COMPONENT("inter_analyzer_colimator_8_blade_1", mcposainter_analyzer_colimator_8_blade_1, mcrotainter_analyzer_colimator_8_blade_1)
  mccomp_posa[460] = mcposainter_analyzer_colimator_8_blade_1;
  mccomp_posr[460] = mcposrinter_analyzer_colimator_8_blade_1;
  mcNCounter[460]  = mcPCounter[460] = mcP2Counter[460] = 0;
  mcAbsorbProp[460]= 0;
    /* Component inter_analyzer_colimator_8_blade_2. */
  /* Setting parameters for component inter_analyzer_colimator_8_blade_2. */
  SIG_MESSAGE("inter_analyzer_colimator_8_blade_2 (Init:SetPar)");
#line 2461 "MACS_sample_kidney_box.instr"
  if("Collimator_gad") strncpy(mccinter_analyzer_colimator_8_blade_2_material_string, "Collimator_gad" ? "Collimator_gad" : "", 16384); else mccinter_analyzer_colimator_8_blade_2_material_string[0]='\0';
#line 2461 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_8_blade_2_priority = 1027;
#line 2460 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_8_blade_2_xwidth = inter_analyzer_colimator_width;
#line 2460 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_8_blade_2_yheight = inter_analyzer_colimator_height;
#line 2460 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_8_blade_2_zdepth = inter_analyzer_colimator_depth;
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_8_blade_2_xwidth2 = -1;
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_8_blade_2_yheight2 = -1;
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_8_blade_2_visualize = 1;
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_8_blade_2_target_index = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_8_blade_2_target_x = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_8_blade_2_target_y = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_8_blade_2_target_z = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_8_blade_2_focus_aw = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_8_blade_2_focus_ah = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_8_blade_2_focus_xw = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_8_blade_2_focus_xh = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_8_blade_2_focus_r = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_8_blade_2_p_interact = 0;
#line 71 "MACS_sample_kidney_box.instr"
  if(0) strncpy(mccinter_analyzer_colimator_8_blade_2_mask_string, 0 ? 0 : "", 16384); else mccinter_analyzer_colimator_8_blade_2_mask_string[0]='\0';
#line 71 "MACS_sample_kidney_box.instr"
  if(0) strncpy(mccinter_analyzer_colimator_8_blade_2_mask_setting, 0 ? 0 : "", 16384); else mccinter_analyzer_colimator_8_blade_2_mask_setting[0]='\0';
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_8_blade_2_number_of_activations = 1;
#line 120130 "MACS_sample_kidney_box.c"

  SIG_MESSAGE("inter_analyzer_colimator_8_blade_2 (Init:Place/Rotate)");
  rot_set_rotation(mctr1,
#line 2463 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 2463 "MACS_sample_kidney_box.instr"
    (- analyzer_2theta [ 8 ])*DEG2RAD,
#line 2463 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD);
#line 120140 "MACS_sample_kidney_box.c"
  rot_mul(mctr1, mcrotainter_analyzer_colimator_center_8, mcrotainter_analyzer_colimator_8_blade_2);
  rot_transpose(mcrotainter_analyzer_colimator_8_blade_1, mctr1);
  rot_mul(mcrotainter_analyzer_colimator_8_blade_2, mctr1, mcrotrinter_analyzer_colimator_8_blade_2);
  mctc1 = coords_set(
#line 2462 "MACS_sample_kidney_box.instr"
    0,
#line 2462 "MACS_sample_kidney_box.instr"
    0,
#line 2462 "MACS_sample_kidney_box.instr"
    inter_analyzer_colimator_start_pos - 2 * inter_analyzer_colimator_seperation);
#line 120151 "MACS_sample_kidney_box.c"
  rot_transpose(mcrotainter_analyzer_colimator_center_8, mctr1);
  mctc2 = rot_apply(mctr1, mctc1);
  mcposainter_analyzer_colimator_8_blade_2 = coords_add(mcposainter_analyzer_colimator_center_8, mctc2);
  mctc1 = coords_sub(mcposainter_analyzer_colimator_8_blade_1, mcposainter_analyzer_colimator_8_blade_2);
  mcposrinter_analyzer_colimator_8_blade_2 = rot_apply(mcrotainter_analyzer_colimator_8_blade_2, mctc1);
  mcDEBUG_COMPONENT("inter_analyzer_colimator_8_blade_2", mcposainter_analyzer_colimator_8_blade_2, mcrotainter_analyzer_colimator_8_blade_2)
  mccomp_posa[461] = mcposainter_analyzer_colimator_8_blade_2;
  mccomp_posr[461] = mcposrinter_analyzer_colimator_8_blade_2;
  mcNCounter[461]  = mcPCounter[461] = mcP2Counter[461] = 0;
  mcAbsorbProp[461]= 0;
    /* Component inter_analyzer_colimator_8_blade_3. */
  /* Setting parameters for component inter_analyzer_colimator_8_blade_3. */
  SIG_MESSAGE("inter_analyzer_colimator_8_blade_3 (Init:SetPar)");
#line 2467 "MACS_sample_kidney_box.instr"
  if("Collimator_gad") strncpy(mccinter_analyzer_colimator_8_blade_3_material_string, "Collimator_gad" ? "Collimator_gad" : "", 16384); else mccinter_analyzer_colimator_8_blade_3_material_string[0]='\0';
#line 2467 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_8_blade_3_priority = 1028;
#line 2466 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_8_blade_3_xwidth = inter_analyzer_colimator_width;
#line 2466 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_8_blade_3_yheight = inter_analyzer_colimator_height;
#line 2466 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_8_blade_3_zdepth = inter_analyzer_colimator_depth;
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_8_blade_3_xwidth2 = -1;
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_8_blade_3_yheight2 = -1;
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_8_blade_3_visualize = 1;
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_8_blade_3_target_index = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_8_blade_3_target_x = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_8_blade_3_target_y = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_8_blade_3_target_z = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_8_blade_3_focus_aw = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_8_blade_3_focus_ah = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_8_blade_3_focus_xw = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_8_blade_3_focus_xh = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_8_blade_3_focus_r = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_8_blade_3_p_interact = 0;
#line 71 "MACS_sample_kidney_box.instr"
  if(0) strncpy(mccinter_analyzer_colimator_8_blade_3_mask_string, 0 ? 0 : "", 16384); else mccinter_analyzer_colimator_8_blade_3_mask_string[0]='\0';
#line 71 "MACS_sample_kidney_box.instr"
  if(0) strncpy(mccinter_analyzer_colimator_8_blade_3_mask_setting, 0 ? 0 : "", 16384); else mccinter_analyzer_colimator_8_blade_3_mask_setting[0]='\0';
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_8_blade_3_number_of_activations = 1;
#line 120207 "MACS_sample_kidney_box.c"

  SIG_MESSAGE("inter_analyzer_colimator_8_blade_3 (Init:Place/Rotate)");
  rot_set_rotation(mctr1,
#line 2469 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 2469 "MACS_sample_kidney_box.instr"
    (- analyzer_2theta [ 8 ])*DEG2RAD,
#line 2469 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD);
#line 120217 "MACS_sample_kidney_box.c"
  rot_mul(mctr1, mcrotainter_analyzer_colimator_center_8, mcrotainter_analyzer_colimator_8_blade_3);
  rot_transpose(mcrotainter_analyzer_colimator_8_blade_2, mctr1);
  rot_mul(mcrotainter_analyzer_colimator_8_blade_3, mctr1, mcrotrinter_analyzer_colimator_8_blade_3);
  mctc1 = coords_set(
#line 2468 "MACS_sample_kidney_box.instr"
    0,
#line 2468 "MACS_sample_kidney_box.instr"
    0,
#line 2468 "MACS_sample_kidney_box.instr"
    inter_analyzer_colimator_start_pos - 3 * inter_analyzer_colimator_seperation);
#line 120228 "MACS_sample_kidney_box.c"
  rot_transpose(mcrotainter_analyzer_colimator_center_8, mctr1);
  mctc2 = rot_apply(mctr1, mctc1);
  mcposainter_analyzer_colimator_8_blade_3 = coords_add(mcposainter_analyzer_colimator_center_8, mctc2);
  mctc1 = coords_sub(mcposainter_analyzer_colimator_8_blade_2, mcposainter_analyzer_colimator_8_blade_3);
  mcposrinter_analyzer_colimator_8_blade_3 = rot_apply(mcrotainter_analyzer_colimator_8_blade_3, mctc1);
  mcDEBUG_COMPONENT("inter_analyzer_colimator_8_blade_3", mcposainter_analyzer_colimator_8_blade_3, mcrotainter_analyzer_colimator_8_blade_3)
  mccomp_posa[462] = mcposainter_analyzer_colimator_8_blade_3;
  mccomp_posr[462] = mcposrinter_analyzer_colimator_8_blade_3;
  mcNCounter[462]  = mcPCounter[462] = mcP2Counter[462] = 0;
  mcAbsorbProp[462]= 0;
    /* Component inter_analyzer_colimator_8_blade_4. */
  /* Setting parameters for component inter_analyzer_colimator_8_blade_4. */
  SIG_MESSAGE("inter_analyzer_colimator_8_blade_4 (Init:SetPar)");
#line 2473 "MACS_sample_kidney_box.instr"
  if("Collimator_gad") strncpy(mccinter_analyzer_colimator_8_blade_4_material_string, "Collimator_gad" ? "Collimator_gad" : "", 16384); else mccinter_analyzer_colimator_8_blade_4_material_string[0]='\0';
#line 2473 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_8_blade_4_priority = 1029;
#line 2472 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_8_blade_4_xwidth = inter_analyzer_colimator_width;
#line 2472 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_8_blade_4_yheight = inter_analyzer_colimator_height;
#line 2472 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_8_blade_4_zdepth = inter_analyzer_colimator_depth;
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_8_blade_4_xwidth2 = -1;
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_8_blade_4_yheight2 = -1;
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_8_blade_4_visualize = 1;
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_8_blade_4_target_index = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_8_blade_4_target_x = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_8_blade_4_target_y = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_8_blade_4_target_z = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_8_blade_4_focus_aw = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_8_blade_4_focus_ah = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_8_blade_4_focus_xw = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_8_blade_4_focus_xh = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_8_blade_4_focus_r = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_8_blade_4_p_interact = 0;
#line 71 "MACS_sample_kidney_box.instr"
  if(0) strncpy(mccinter_analyzer_colimator_8_blade_4_mask_string, 0 ? 0 : "", 16384); else mccinter_analyzer_colimator_8_blade_4_mask_string[0]='\0';
#line 71 "MACS_sample_kidney_box.instr"
  if(0) strncpy(mccinter_analyzer_colimator_8_blade_4_mask_setting, 0 ? 0 : "", 16384); else mccinter_analyzer_colimator_8_blade_4_mask_setting[0]='\0';
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_8_blade_4_number_of_activations = 1;
#line 120284 "MACS_sample_kidney_box.c"

  SIG_MESSAGE("inter_analyzer_colimator_8_blade_4 (Init:Place/Rotate)");
  rot_set_rotation(mctr1,
#line 2475 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 2475 "MACS_sample_kidney_box.instr"
    (- analyzer_2theta [ 8 ])*DEG2RAD,
#line 2475 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD);
#line 120294 "MACS_sample_kidney_box.c"
  rot_mul(mctr1, mcrotainter_analyzer_colimator_center_8, mcrotainter_analyzer_colimator_8_blade_4);
  rot_transpose(mcrotainter_analyzer_colimator_8_blade_3, mctr1);
  rot_mul(mcrotainter_analyzer_colimator_8_blade_4, mctr1, mcrotrinter_analyzer_colimator_8_blade_4);
  mctc1 = coords_set(
#line 2474 "MACS_sample_kidney_box.instr"
    0,
#line 2474 "MACS_sample_kidney_box.instr"
    0,
#line 2474 "MACS_sample_kidney_box.instr"
    inter_analyzer_colimator_start_pos - 4 * inter_analyzer_colimator_seperation);
#line 120305 "MACS_sample_kidney_box.c"
  rot_transpose(mcrotainter_analyzer_colimator_center_8, mctr1);
  mctc2 = rot_apply(mctr1, mctc1);
  mcposainter_analyzer_colimator_8_blade_4 = coords_add(mcposainter_analyzer_colimator_center_8, mctc2);
  mctc1 = coords_sub(mcposainter_analyzer_colimator_8_blade_3, mcposainter_analyzer_colimator_8_blade_4);
  mcposrinter_analyzer_colimator_8_blade_4 = rot_apply(mcrotainter_analyzer_colimator_8_blade_4, mctc1);
  mcDEBUG_COMPONENT("inter_analyzer_colimator_8_blade_4", mcposainter_analyzer_colimator_8_blade_4, mcrotainter_analyzer_colimator_8_blade_4)
  mccomp_posa[463] = mcposainter_analyzer_colimator_8_blade_4;
  mccomp_posr[463] = mcposrinter_analyzer_colimator_8_blade_4;
  mcNCounter[463]  = mcPCounter[463] = mcP2Counter[463] = 0;
  mcAbsorbProp[463]= 0;
    /* Component diffraction_detector_8_exit_volume. */
  /* Setting parameters for component diffraction_detector_8_exit_volume. */
  SIG_MESSAGE("diffraction_detector_8_exit_volume (Init:SetPar)");
#line 2479 "MACS_sample_kidney_box.instr"
  if("Exit") strncpy(mccdiffraction_detector_8_exit_volume_material_string, "Exit" ? "Exit" : "", 16384); else mccdiffraction_detector_8_exit_volume_material_string[0]='\0';
#line 2479 "MACS_sample_kidney_box.instr"
  mccdiffraction_detector_8_exit_volume_priority = 1031;
#line 2478 "MACS_sample_kidney_box.instr"
  mccdiffraction_detector_8_exit_volume_xwidth = 2.01 * detector_radius;
#line 2478 "MACS_sample_kidney_box.instr"
  mccdiffraction_detector_8_exit_volume_yheight = 1.01 * detector_height;
#line 2478 "MACS_sample_kidney_box.instr"
  mccdiffraction_detector_8_exit_volume_zdepth = 0.001;
#line 71 "MACS_sample_kidney_box.instr"
  mccdiffraction_detector_8_exit_volume_xwidth2 = -1;
#line 71 "MACS_sample_kidney_box.instr"
  mccdiffraction_detector_8_exit_volume_yheight2 = -1;
#line 71 "MACS_sample_kidney_box.instr"
  mccdiffraction_detector_8_exit_volume_visualize = 1;
#line 71 "MACS_sample_kidney_box.instr"
  mccdiffraction_detector_8_exit_volume_target_index = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccdiffraction_detector_8_exit_volume_target_x = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccdiffraction_detector_8_exit_volume_target_y = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccdiffraction_detector_8_exit_volume_target_z = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccdiffraction_detector_8_exit_volume_focus_aw = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccdiffraction_detector_8_exit_volume_focus_ah = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccdiffraction_detector_8_exit_volume_focus_xw = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccdiffraction_detector_8_exit_volume_focus_xh = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccdiffraction_detector_8_exit_volume_focus_r = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccdiffraction_detector_8_exit_volume_p_interact = 0;
#line 71 "MACS_sample_kidney_box.instr"
  if(0) strncpy(mccdiffraction_detector_8_exit_volume_mask_string, 0 ? 0 : "", 16384); else mccdiffraction_detector_8_exit_volume_mask_string[0]='\0';
#line 71 "MACS_sample_kidney_box.instr"
  if(0) strncpy(mccdiffraction_detector_8_exit_volume_mask_setting, 0 ? 0 : "", 16384); else mccdiffraction_detector_8_exit_volume_mask_setting[0]='\0';
#line 71 "MACS_sample_kidney_box.instr"
  mccdiffraction_detector_8_exit_volume_number_of_activations = 1;
#line 120361 "MACS_sample_kidney_box.c"

  SIG_MESSAGE("diffraction_detector_8_exit_volume (Init:Place/Rotate)");
  rot_set_rotation(mctr1,
#line 2481 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 2481 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 2481 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD);
#line 120371 "MACS_sample_kidney_box.c"
  rot_mul(mctr1, mcrotakidney_channel_8, mcrotadiffraction_detector_8_exit_volume);
  rot_transpose(mcrotainter_analyzer_colimator_8_blade_4, mctr1);
  rot_mul(mcrotadiffraction_detector_8_exit_volume, mctr1, mcrotrdiffraction_detector_8_exit_volume);
  mctc1 = coords_set(
#line 2480 "MACS_sample_kidney_box.instr"
    0,
#line 2480 "MACS_sample_kidney_box.instr"
    0,
#line 2480 "MACS_sample_kidney_box.instr"
    0);
#line 120382 "MACS_sample_kidney_box.c"
  rot_transpose(mcrotachannel_8_cave1_cyl1, mctr1);
  mctc2 = rot_apply(mctr1, mctc1);
  mcposadiffraction_detector_8_exit_volume = coords_add(mcposachannel_8_cave1_cyl1, mctc2);
  mctc1 = coords_sub(mcposainter_analyzer_colimator_8_blade_4, mcposadiffraction_detector_8_exit_volume);
  mcposrdiffraction_detector_8_exit_volume = rot_apply(mcrotadiffraction_detector_8_exit_volume, mctc1);
  mcDEBUG_COMPONENT("diffraction_detector_8_exit_volume", mcposadiffraction_detector_8_exit_volume, mcrotadiffraction_detector_8_exit_volume)
  mccomp_posa[464] = mcposadiffraction_detector_8_exit_volume;
  mccomp_posr[464] = mcposrdiffraction_detector_8_exit_volume;
  mcNCounter[464]  = mcPCounter[464] = mcP2Counter[464] = 0;
  mcAbsorbProp[464]= 0;
    /* Component spec_detector_8_exit_volume. */
  /* Setting parameters for component spec_detector_8_exit_volume. */
  SIG_MESSAGE("spec_detector_8_exit_volume (Init:SetPar)");
#line 2485 "MACS_sample_kidney_box.instr"
  if("Exit") strncpy(mccspec_detector_8_exit_volume_material_string, "Exit" ? "Exit" : "", 16384); else mccspec_detector_8_exit_volume_material_string[0]='\0';
#line 2485 "MACS_sample_kidney_box.instr"
  mccspec_detector_8_exit_volume_priority = 1032;
#line 2484 "MACS_sample_kidney_box.instr"
  mccspec_detector_8_exit_volume_xwidth = 2.01 * detector_radius;
#line 2484 "MACS_sample_kidney_box.instr"
  mccspec_detector_8_exit_volume_yheight = 1.01 * detector_height;
#line 2484 "MACS_sample_kidney_box.instr"
  mccspec_detector_8_exit_volume_zdepth = 0.001;
#line 71 "MACS_sample_kidney_box.instr"
  mccspec_detector_8_exit_volume_xwidth2 = -1;
#line 71 "MACS_sample_kidney_box.instr"
  mccspec_detector_8_exit_volume_yheight2 = -1;
#line 71 "MACS_sample_kidney_box.instr"
  mccspec_detector_8_exit_volume_visualize = 1;
#line 71 "MACS_sample_kidney_box.instr"
  mccspec_detector_8_exit_volume_target_index = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccspec_detector_8_exit_volume_target_x = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccspec_detector_8_exit_volume_target_y = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccspec_detector_8_exit_volume_target_z = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccspec_detector_8_exit_volume_focus_aw = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccspec_detector_8_exit_volume_focus_ah = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccspec_detector_8_exit_volume_focus_xw = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccspec_detector_8_exit_volume_focus_xh = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccspec_detector_8_exit_volume_focus_r = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccspec_detector_8_exit_volume_p_interact = 0;
#line 71 "MACS_sample_kidney_box.instr"
  if(0) strncpy(mccspec_detector_8_exit_volume_mask_string, 0 ? 0 : "", 16384); else mccspec_detector_8_exit_volume_mask_string[0]='\0';
#line 71 "MACS_sample_kidney_box.instr"
  if(0) strncpy(mccspec_detector_8_exit_volume_mask_setting, 0 ? 0 : "", 16384); else mccspec_detector_8_exit_volume_mask_setting[0]='\0';
#line 71 "MACS_sample_kidney_box.instr"
  mccspec_detector_8_exit_volume_number_of_activations = 1;
#line 120438 "MACS_sample_kidney_box.c"

  SIG_MESSAGE("spec_detector_8_exit_volume (Init:Place/Rotate)");
  rot_set_rotation(mctr1,
#line 2487 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 2487 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 2487 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD);
#line 120448 "MACS_sample_kidney_box.c"
  rot_mul(mctr1, mcrotachannel_8_analyzer_2_center, mcrotaspec_detector_8_exit_volume);
  rot_transpose(mcrotadiffraction_detector_8_exit_volume, mctr1);
  rot_mul(mcrotaspec_detector_8_exit_volume, mctr1, mcrotrspec_detector_8_exit_volume);
  mctc1 = coords_set(
#line 2486 "MACS_sample_kidney_box.instr"
    0,
#line 2486 "MACS_sample_kidney_box.instr"
    0,
#line 2486 "MACS_sample_kidney_box.instr"
    0);
#line 120459 "MACS_sample_kidney_box.c"
  rot_transpose(mcrotachannel_8_cave2_cyl1, mctr1);
  mctc2 = rot_apply(mctr1, mctc1);
  mcposaspec_detector_8_exit_volume = coords_add(mcposachannel_8_cave2_cyl1, mctc2);
  mctc1 = coords_sub(mcposadiffraction_detector_8_exit_volume, mcposaspec_detector_8_exit_volume);
  mcposrspec_detector_8_exit_volume = rot_apply(mcrotaspec_detector_8_exit_volume, mctc1);
  mcDEBUG_COMPONENT("spec_detector_8_exit_volume", mcposaspec_detector_8_exit_volume, mcrotaspec_detector_8_exit_volume)
  mccomp_posa[465] = mcposaspec_detector_8_exit_volume;
  mccomp_posr[465] = mcposrspec_detector_8_exit_volume;
  mcNCounter[465]  = mcPCounter[465] = mcP2Counter[465] = 0;
  mcAbsorbProp[465]= 0;
    /* Component channel_9_cave1_box1. */
  /* Setting parameters for component channel_9_cave1_box1. */
  SIG_MESSAGE("channel_9_cave1_box1 (Init:SetPar)");
#line 2492 "MACS_sample_kidney_box.instr"
  if("Vacuum") strncpy(mccchannel_9_cave1_box1_material_string, "Vacuum" ? "Vacuum" : "", 16384); else mccchannel_9_cave1_box1_material_string[0]='\0';
#line 2492 "MACS_sample_kidney_box.instr"
  mccchannel_9_cave1_box1_priority = 1100;
#line 2490 "MACS_sample_kidney_box.instr"
  mccchannel_9_cave1_box1_xwidth = kidney_cave1_box1_width1;
#line 2490 "MACS_sample_kidney_box.instr"
  mccchannel_9_cave1_box1_yheight = kidney_cave1_box1_height1;
#line 2490 "MACS_sample_kidney_box.instr"
  mccchannel_9_cave1_box1_zdepth = kidney_cave1_box1_depth;
#line 2491 "MACS_sample_kidney_box.instr"
  mccchannel_9_cave1_box1_xwidth2 = kidney_cave1_box1_width2;
#line 2491 "MACS_sample_kidney_box.instr"
  mccchannel_9_cave1_box1_yheight2 = kidney_cave1_box1_height2;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_9_cave1_box1_visualize = 1;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_9_cave1_box1_target_index = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_9_cave1_box1_target_x = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_9_cave1_box1_target_y = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_9_cave1_box1_target_z = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_9_cave1_box1_focus_aw = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_9_cave1_box1_focus_ah = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_9_cave1_box1_focus_xw = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_9_cave1_box1_focus_xh = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_9_cave1_box1_focus_r = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_9_cave1_box1_p_interact = 0;
#line 71 "MACS_sample_kidney_box.instr"
  if(0) strncpy(mccchannel_9_cave1_box1_mask_string, 0 ? 0 : "", 16384); else mccchannel_9_cave1_box1_mask_string[0]='\0';
#line 71 "MACS_sample_kidney_box.instr"
  if(0) strncpy(mccchannel_9_cave1_box1_mask_setting, 0 ? 0 : "", 16384); else mccchannel_9_cave1_box1_mask_setting[0]='\0';
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_9_cave1_box1_number_of_activations = 1;
#line 120515 "MACS_sample_kidney_box.c"

  SIG_MESSAGE("channel_9_cave1_box1 (Init:Place/Rotate)");
  rot_set_rotation(mctr1,
#line 2494 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 2494 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 2494 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD);
#line 120525 "MACS_sample_kidney_box.c"
  rot_mul(mctr1, mcrotakidney_channel_9, mcrotachannel_9_cave1_box1);
  rot_transpose(mcrotaspec_detector_8_exit_volume, mctr1);
  rot_mul(mcrotachannel_9_cave1_box1, mctr1, mcrotrchannel_9_cave1_box1);
  mctc1 = coords_set(
#line 2493 "MACS_sample_kidney_box.instr"
    0,
#line 2493 "MACS_sample_kidney_box.instr"
    0,
#line 2493 "MACS_sample_kidney_box.instr"
    kidney_cave1_box1_center_to_target);
#line 120536 "MACS_sample_kidney_box.c"
  rot_transpose(mcrotakidney_channel_9, mctr1);
  mctc2 = rot_apply(mctr1, mctc1);
  mcposachannel_9_cave1_box1 = coords_add(mcposakidney_channel_9, mctc2);
  mctc1 = coords_sub(mcposaspec_detector_8_exit_volume, mcposachannel_9_cave1_box1);
  mcposrchannel_9_cave1_box1 = rot_apply(mcrotachannel_9_cave1_box1, mctc1);
  mcDEBUG_COMPONENT("channel_9_cave1_box1", mcposachannel_9_cave1_box1, mcrotachannel_9_cave1_box1)
  mccomp_posa[466] = mcposachannel_9_cave1_box1;
  mccomp_posr[466] = mcposrchannel_9_cave1_box1;
  mcNCounter[466]  = mcPCounter[466] = mcP2Counter[466] = 0;
  mcAbsorbProp[466]= 0;
    /* Component channel_9_cave1_box2. */
  /* Setting parameters for component channel_9_cave1_box2. */
  SIG_MESSAGE("channel_9_cave1_box2 (Init:SetPar)");
#line 2499 "MACS_sample_kidney_box.instr"
  if("Vacuum") strncpy(mccchannel_9_cave1_box2_material_string, "Vacuum" ? "Vacuum" : "", 16384); else mccchannel_9_cave1_box2_material_string[0]='\0';
#line 2499 "MACS_sample_kidney_box.instr"
  mccchannel_9_cave1_box2_priority = 1105;
#line 2497 "MACS_sample_kidney_box.instr"
  mccchannel_9_cave1_box2_xwidth = kidney_cave1_box2_width1;
#line 2497 "MACS_sample_kidney_box.instr"
  mccchannel_9_cave1_box2_yheight = kidney_cave1_box2_height1;
#line 2497 "MACS_sample_kidney_box.instr"
  mccchannel_9_cave1_box2_zdepth = kidney_cave1_box2_depth;
#line 2498 "MACS_sample_kidney_box.instr"
  mccchannel_9_cave1_box2_xwidth2 = kidney_cave1_box2_width2;
#line 2498 "MACS_sample_kidney_box.instr"
  mccchannel_9_cave1_box2_yheight2 = kidney_cave1_box2_height2;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_9_cave1_box2_visualize = 1;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_9_cave1_box2_target_index = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_9_cave1_box2_target_x = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_9_cave1_box2_target_y = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_9_cave1_box2_target_z = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_9_cave1_box2_focus_aw = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_9_cave1_box2_focus_ah = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_9_cave1_box2_focus_xw = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_9_cave1_box2_focus_xh = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_9_cave1_box2_focus_r = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_9_cave1_box2_p_interact = 0;
#line 71 "MACS_sample_kidney_box.instr"
  if(0) strncpy(mccchannel_9_cave1_box2_mask_string, 0 ? 0 : "", 16384); else mccchannel_9_cave1_box2_mask_string[0]='\0';
#line 71 "MACS_sample_kidney_box.instr"
  if(0) strncpy(mccchannel_9_cave1_box2_mask_setting, 0 ? 0 : "", 16384); else mccchannel_9_cave1_box2_mask_setting[0]='\0';
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_9_cave1_box2_number_of_activations = 1;
#line 120592 "MACS_sample_kidney_box.c"

  SIG_MESSAGE("channel_9_cave1_box2 (Init:Place/Rotate)");
  rot_set_rotation(mctr1,
#line 2501 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 2501 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 2501 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD);
#line 120602 "MACS_sample_kidney_box.c"
  rot_mul(mctr1, mcrotakidney_channel_9, mcrotachannel_9_cave1_box2);
  rot_transpose(mcrotachannel_9_cave1_box1, mctr1);
  rot_mul(mcrotachannel_9_cave1_box2, mctr1, mcrotrchannel_9_cave1_box2);
  mctc1 = coords_set(
#line 2500 "MACS_sample_kidney_box.instr"
    kidney_cave1_box2_x_offset,
#line 2500 "MACS_sample_kidney_box.instr"
    0,
#line 2500 "MACS_sample_kidney_box.instr"
    kidney_cave1_box2_center_to_target);
#line 120613 "MACS_sample_kidney_box.c"
  rot_transpose(mcrotakidney_channel_9, mctr1);
  mctc2 = rot_apply(mctr1, mctc1);
  mcposachannel_9_cave1_box2 = coords_add(mcposakidney_channel_9, mctc2);
  mctc1 = coords_sub(mcposachannel_9_cave1_box1, mcposachannel_9_cave1_box2);
  mcposrchannel_9_cave1_box2 = rot_apply(mcrotachannel_9_cave1_box2, mctc1);
  mcDEBUG_COMPONENT("channel_9_cave1_box2", mcposachannel_9_cave1_box2, mcrotachannel_9_cave1_box2)
  mccomp_posa[467] = mcposachannel_9_cave1_box2;
  mccomp_posr[467] = mcposrchannel_9_cave1_box2;
  mcNCounter[467]  = mcPCounter[467] = mcP2Counter[467] = 0;
  mcAbsorbProp[467]= 0;
    /* Component channel_9_cave1_box3. */
  /* Setting parameters for component channel_9_cave1_box3. */
  SIG_MESSAGE("channel_9_cave1_box3 (Init:SetPar)");
#line 2506 "MACS_sample_kidney_box.instr"
  if("Vacuum") strncpy(mccchannel_9_cave1_box3_material_string, "Vacuum" ? "Vacuum" : "", 16384); else mccchannel_9_cave1_box3_material_string[0]='\0';
#line 2506 "MACS_sample_kidney_box.instr"
  mccchannel_9_cave1_box3_priority = 1102;
#line 2504 "MACS_sample_kidney_box.instr"
  mccchannel_9_cave1_box3_xwidth = kidney_cave1_box3_width1;
#line 2504 "MACS_sample_kidney_box.instr"
  mccchannel_9_cave1_box3_yheight = kidney_cave1_box3_height1;
#line 2504 "MACS_sample_kidney_box.instr"
  mccchannel_9_cave1_box3_zdepth = kidney_cave1_box3_depth;
#line 2505 "MACS_sample_kidney_box.instr"
  mccchannel_9_cave1_box3_xwidth2 = kidney_cave1_box3_width2;
#line 2505 "MACS_sample_kidney_box.instr"
  mccchannel_9_cave1_box3_yheight2 = kidney_cave1_box3_height2;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_9_cave1_box3_visualize = 1;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_9_cave1_box3_target_index = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_9_cave1_box3_target_x = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_9_cave1_box3_target_y = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_9_cave1_box3_target_z = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_9_cave1_box3_focus_aw = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_9_cave1_box3_focus_ah = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_9_cave1_box3_focus_xw = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_9_cave1_box3_focus_xh = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_9_cave1_box3_focus_r = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_9_cave1_box3_p_interact = 0;
#line 71 "MACS_sample_kidney_box.instr"
  if(0) strncpy(mccchannel_9_cave1_box3_mask_string, 0 ? 0 : "", 16384); else mccchannel_9_cave1_box3_mask_string[0]='\0';
#line 71 "MACS_sample_kidney_box.instr"
  if(0) strncpy(mccchannel_9_cave1_box3_mask_setting, 0 ? 0 : "", 16384); else mccchannel_9_cave1_box3_mask_setting[0]='\0';
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_9_cave1_box3_number_of_activations = 1;
#line 120669 "MACS_sample_kidney_box.c"

  SIG_MESSAGE("channel_9_cave1_box3 (Init:Place/Rotate)");
  rot_set_rotation(mctr1,
#line 2508 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 2508 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 2508 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD);
#line 120679 "MACS_sample_kidney_box.c"
  rot_mul(mctr1, mcrotakidney_channel_9, mcrotachannel_9_cave1_box3);
  rot_transpose(mcrotachannel_9_cave1_box2, mctr1);
  rot_mul(mcrotachannel_9_cave1_box3, mctr1, mcrotrchannel_9_cave1_box3);
  mctc1 = coords_set(
#line 2507 "MACS_sample_kidney_box.instr"
    0,
#line 2507 "MACS_sample_kidney_box.instr"
    0,
#line 2507 "MACS_sample_kidney_box.instr"
    kidney_cave1_box3_center_to_target);
#line 120690 "MACS_sample_kidney_box.c"
  rot_transpose(mcrotakidney_channel_9, mctr1);
  mctc2 = rot_apply(mctr1, mctc1);
  mcposachannel_9_cave1_box3 = coords_add(mcposakidney_channel_9, mctc2);
  mctc1 = coords_sub(mcposachannel_9_cave1_box2, mcposachannel_9_cave1_box3);
  mcposrchannel_9_cave1_box3 = rot_apply(mcrotachannel_9_cave1_box3, mctc1);
  mcDEBUG_COMPONENT("channel_9_cave1_box3", mcposachannel_9_cave1_box3, mcrotachannel_9_cave1_box3)
  mccomp_posa[468] = mcposachannel_9_cave1_box3;
  mccomp_posr[468] = mcposrchannel_9_cave1_box3;
  mcNCounter[468]  = mcPCounter[468] = mcP2Counter[468] = 0;
  mcAbsorbProp[468]= 0;
    /* Component channel_9_cave1_cyl1. */
  /* Setting parameters for component channel_9_cave1_cyl1. */
  SIG_MESSAGE("channel_9_cave1_cyl1 (Init:SetPar)");
#line 2512 "MACS_sample_kidney_box.instr"
  if("Vacuum") strncpy(mccchannel_9_cave1_cyl1_material_string, "Vacuum" ? "Vacuum" : "", 16384); else mccchannel_9_cave1_cyl1_material_string[0]='\0';
#line 2512 "MACS_sample_kidney_box.instr"
  mccchannel_9_cave1_cyl1_priority = 1103;
#line 2511 "MACS_sample_kidney_box.instr"
  mccchannel_9_cave1_cyl1_radius = kidney_cave1_cyl1_radius;
#line 2511 "MACS_sample_kidney_box.instr"
  mccchannel_9_cave1_cyl1_yheight = kidney_cave1_cyl1_height;
#line 67 "MACS_sample_kidney_box.instr"
  mccchannel_9_cave1_cyl1_visualize = 1;
#line 67 "MACS_sample_kidney_box.instr"
  mccchannel_9_cave1_cyl1_target_index = 0;
#line 67 "MACS_sample_kidney_box.instr"
  mccchannel_9_cave1_cyl1_target_x = 0;
#line 67 "MACS_sample_kidney_box.instr"
  mccchannel_9_cave1_cyl1_target_y = 0;
#line 67 "MACS_sample_kidney_box.instr"
  mccchannel_9_cave1_cyl1_target_z = 0;
#line 67 "MACS_sample_kidney_box.instr"
  mccchannel_9_cave1_cyl1_focus_aw = 0;
#line 67 "MACS_sample_kidney_box.instr"
  mccchannel_9_cave1_cyl1_focus_ah = 0;
#line 67 "MACS_sample_kidney_box.instr"
  mccchannel_9_cave1_cyl1_focus_xw = 0;
#line 67 "MACS_sample_kidney_box.instr"
  mccchannel_9_cave1_cyl1_focus_xh = 0;
#line 67 "MACS_sample_kidney_box.instr"
  mccchannel_9_cave1_cyl1_focus_r = 0;
#line 67 "MACS_sample_kidney_box.instr"
  mccchannel_9_cave1_cyl1_p_interact = 0;
#line 67 "MACS_sample_kidney_box.instr"
  if(0) strncpy(mccchannel_9_cave1_cyl1_mask_string, 0 ? 0 : "", 16384); else mccchannel_9_cave1_cyl1_mask_string[0]='\0';
#line 67 "MACS_sample_kidney_box.instr"
  if(0) strncpy(mccchannel_9_cave1_cyl1_mask_setting, 0 ? 0 : "", 16384); else mccchannel_9_cave1_cyl1_mask_setting[0]='\0';
#line 67 "MACS_sample_kidney_box.instr"
  mccchannel_9_cave1_cyl1_number_of_activations = 1;
#line 120740 "MACS_sample_kidney_box.c"

  SIG_MESSAGE("channel_9_cave1_cyl1 (Init:Place/Rotate)");
  rot_set_rotation(mctr1,
#line 2514 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 2514 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 2514 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD);
#line 120750 "MACS_sample_kidney_box.c"
  rot_mul(mctr1, mcrotakidney_channel_9, mcrotachannel_9_cave1_cyl1);
  rot_transpose(mcrotachannel_9_cave1_box3, mctr1);
  rot_mul(mcrotachannel_9_cave1_cyl1, mctr1, mcrotrchannel_9_cave1_cyl1);
  mctc1 = coords_set(
#line 2513 "MACS_sample_kidney_box.instr"
    0,
#line 2513 "MACS_sample_kidney_box.instr"
    0,
#line 2513 "MACS_sample_kidney_box.instr"
    kidney_cave1_cyl1_center_to_target);
#line 120761 "MACS_sample_kidney_box.c"
  rot_transpose(mcrotakidney_channel_9, mctr1);
  mctc2 = rot_apply(mctr1, mctc1);
  mcposachannel_9_cave1_cyl1 = coords_add(mcposakidney_channel_9, mctc2);
  mctc1 = coords_sub(mcposachannel_9_cave1_box3, mcposachannel_9_cave1_cyl1);
  mcposrchannel_9_cave1_cyl1 = rot_apply(mcrotachannel_9_cave1_cyl1, mctc1);
  mcDEBUG_COMPONENT("channel_9_cave1_cyl1", mcposachannel_9_cave1_cyl1, mcrotachannel_9_cave1_cyl1)
  mccomp_posa[469] = mcposachannel_9_cave1_cyl1;
  mccomp_posr[469] = mcposrchannel_9_cave1_cyl1;
  mcNCounter[469]  = mcPCounter[469] = mcP2Counter[469] = 0;
  mcAbsorbProp[469]= 0;
    /* Component channel_9_analyzer_1_center. */
  /* Setting parameters for component channel_9_analyzer_1_center. */
  SIG_MESSAGE("channel_9_analyzer_1_center (Init:SetPar)");

  SIG_MESSAGE("channel_9_analyzer_1_center (Init:Place/Rotate)");
  rot_set_rotation(mctr1,
    (0.0)*DEG2RAD,
    (0.0)*DEG2RAD,
    (0.0)*DEG2RAD);
#line 120781 "MACS_sample_kidney_box.c"
  rot_mul(mctr1, mcrotakidney_channel_9, mcrotachannel_9_analyzer_1_center);
  rot_transpose(mcrotachannel_9_cave1_cyl1, mctr1);
  rot_mul(mcrotachannel_9_analyzer_1_center, mctr1, mcrotrchannel_9_analyzer_1_center);
  mctc1 = coords_set(
#line 2518 "MACS_sample_kidney_box.instr"
    0,
#line 2518 "MACS_sample_kidney_box.instr"
    0,
#line 2518 "MACS_sample_kidney_box.instr"
    analyzer_1_center_to_sample);
#line 120792 "MACS_sample_kidney_box.c"
  rot_transpose(mcrotakidney_channel_9, mctr1);
  mctc2 = rot_apply(mctr1, mctc1);
  mcposachannel_9_analyzer_1_center = coords_add(mcposakidney_channel_9, mctc2);
  mctc1 = coords_sub(mcposachannel_9_cave1_cyl1, mcposachannel_9_analyzer_1_center);
  mcposrchannel_9_analyzer_1_center = rot_apply(mcrotachannel_9_analyzer_1_center, mctc1);
  mcDEBUG_COMPONENT("channel_9_analyzer_1_center", mcposachannel_9_analyzer_1_center, mcrotachannel_9_analyzer_1_center)
  mccomp_posa[470] = mcposachannel_9_analyzer_1_center;
  mccomp_posr[470] = mcposrchannel_9_analyzer_1_center;
  mcNCounter[470]  = mcPCounter[470] = mcP2Counter[470] = 0;
  mcAbsorbProp[470]= 0;
    /* Component channel_9_analyzer_1_rotated. */
  /* Setting parameters for component channel_9_analyzer_1_rotated. */
  SIG_MESSAGE("channel_9_analyzer_1_rotated (Init:SetPar)");

  SIG_MESSAGE("channel_9_analyzer_1_rotated (Init:Place/Rotate)");
  rot_set_rotation(mctr1,
#line 2522 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 2522 "MACS_sample_kidney_box.instr"
    (180 - analyzer_theta [ 9 ])*DEG2RAD,
#line 2522 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD);
#line 120815 "MACS_sample_kidney_box.c"
  rot_mul(mctr1, mcrotachannel_9_analyzer_1_center, mcrotachannel_9_analyzer_1_rotated);
  rot_transpose(mcrotachannel_9_analyzer_1_center, mctr1);
  rot_mul(mcrotachannel_9_analyzer_1_rotated, mctr1, mcrotrchannel_9_analyzer_1_rotated);
  mctc1 = coords_set(
#line 2521 "MACS_sample_kidney_box.instr"
    0,
#line 2521 "MACS_sample_kidney_box.instr"
    0,
#line 2521 "MACS_sample_kidney_box.instr"
    -0.5 * analyzer_seperation / tan ( analyzer_2theta [ 9 ] * DEG2RAD ));
#line 120826 "MACS_sample_kidney_box.c"
  rot_transpose(mcrotachannel_9_analyzer_1_center, mctr1);
  mctc2 = rot_apply(mctr1, mctc1);
  mcposachannel_9_analyzer_1_rotated = coords_add(mcposachannel_9_analyzer_1_center, mctc2);
  mctc1 = coords_sub(mcposachannel_9_analyzer_1_center, mcposachannel_9_analyzer_1_rotated);
  mcposrchannel_9_analyzer_1_rotated = rot_apply(mcrotachannel_9_analyzer_1_rotated, mctc1);
  mcDEBUG_COMPONENT("channel_9_analyzer_1_rotated", mcposachannel_9_analyzer_1_rotated, mcrotachannel_9_analyzer_1_rotated)
  mccomp_posa[471] = mcposachannel_9_analyzer_1_rotated;
  mccomp_posr[471] = mcposrchannel_9_analyzer_1_rotated;
  mcNCounter[471]  = mcPCounter[471] = mcP2Counter[471] = 0;
  mcAbsorbProp[471]= 0;
    /* Component channel_9_analyzer_1_array_crystal_array_0. */
  /* Setting parameters for component channel_9_analyzer_1_array_crystal_array_0. */
  SIG_MESSAGE("channel_9_analyzer_1_array_crystal_array_0 (Init:SetPar)");
#line 2526 "MACS_sample_kidney_box.instr"
  if("PG_analyzer") strncpy(mccchannel_9_analyzer_1_array_crystal_array_0_material_string, "PG_analyzer" ? "PG_analyzer" : "", 16384); else mccchannel_9_analyzer_1_array_crystal_array_0_material_string[0]='\0';
#line 2526 "MACS_sample_kidney_box.instr"
  mccchannel_9_analyzer_1_array_crystal_array_0_priority = 1120.0;
#line 2525 "MACS_sample_kidney_box.instr"
  mccchannel_9_analyzer_1_array_crystal_array_0_xwidth = channel_9_analyzer_1_array_crystal_depth;
#line 2525 "MACS_sample_kidney_box.instr"
  mccchannel_9_analyzer_1_array_crystal_array_0_yheight = channel_9_analyzer_1_array_crystal_height;
#line 2525 "MACS_sample_kidney_box.instr"
  mccchannel_9_analyzer_1_array_crystal_array_0_zdepth = channel_9_analyzer_1_array_crystal_width;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_9_analyzer_1_array_crystal_array_0_xwidth2 = -1;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_9_analyzer_1_array_crystal_array_0_yheight2 = -1;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_9_analyzer_1_array_crystal_array_0_visualize = 1;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_9_analyzer_1_array_crystal_array_0_target_index = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_9_analyzer_1_array_crystal_array_0_target_x = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_9_analyzer_1_array_crystal_array_0_target_y = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_9_analyzer_1_array_crystal_array_0_target_z = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_9_analyzer_1_array_crystal_array_0_focus_aw = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_9_analyzer_1_array_crystal_array_0_focus_ah = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_9_analyzer_1_array_crystal_array_0_focus_xw = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_9_analyzer_1_array_crystal_array_0_focus_xh = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_9_analyzer_1_array_crystal_array_0_focus_r = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_9_analyzer_1_array_crystal_array_0_p_interact = 0;
#line 71 "MACS_sample_kidney_box.instr"
  if(0) strncpy(mccchannel_9_analyzer_1_array_crystal_array_0_mask_string, 0 ? 0 : "", 16384); else mccchannel_9_analyzer_1_array_crystal_array_0_mask_string[0]='\0';
#line 71 "MACS_sample_kidney_box.instr"
  if(0) strncpy(mccchannel_9_analyzer_1_array_crystal_array_0_mask_setting, 0 ? 0 : "", 16384); else mccchannel_9_analyzer_1_array_crystal_array_0_mask_setting[0]='\0';
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_9_analyzer_1_array_crystal_array_0_number_of_activations = 1;
#line 120882 "MACS_sample_kidney_box.c"

  SIG_MESSAGE("channel_9_analyzer_1_array_crystal_array_0 (Init:Place/Rotate)");
  rot_set_rotation(mctr1,
#line 2528 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 2528 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 2528 "MACS_sample_kidney_box.instr"
    (0 - RAD2DEG * channel_9_analyzer_1_array_theta [ 0 ])*DEG2RAD);
#line 120892 "MACS_sample_kidney_box.c"
  rot_mul(mctr1, mcrotachannel_9_analyzer_1_rotated, mcrotachannel_9_analyzer_1_array_crystal_array_0);
  rot_transpose(mcrotachannel_9_analyzer_1_rotated, mctr1);
  rot_mul(mcrotachannel_9_analyzer_1_array_crystal_array_0, mctr1, mcrotrchannel_9_analyzer_1_array_crystal_array_0);
  mctc1 = coords_set(
#line 2527 "MACS_sample_kidney_box.instr"
    0 + channel_9_analyzer_1_array_effective_radius_of_curvature * ( 1 - cos ( channel_9_analyzer_1_array_theta [ 0 ] ) ),
#line 2527 "MACS_sample_kidney_box.instr"
    0 + channel_9_analyzer_1_array_effective_radius_of_curvature * sin ( channel_9_analyzer_1_array_theta [ 0 ] ),
#line 2527 "MACS_sample_kidney_box.instr"
    0);
#line 120903 "MACS_sample_kidney_box.c"
  rot_transpose(mcrotachannel_9_analyzer_1_rotated, mctr1);
  mctc2 = rot_apply(mctr1, mctc1);
  mcposachannel_9_analyzer_1_array_crystal_array_0 = coords_add(mcposachannel_9_analyzer_1_rotated, mctc2);
  mctc1 = coords_sub(mcposachannel_9_analyzer_1_rotated, mcposachannel_9_analyzer_1_array_crystal_array_0);
  mcposrchannel_9_analyzer_1_array_crystal_array_0 = rot_apply(mcrotachannel_9_analyzer_1_array_crystal_array_0, mctc1);
  mcDEBUG_COMPONENT("channel_9_analyzer_1_array_crystal_array_0", mcposachannel_9_analyzer_1_array_crystal_array_0, mcrotachannel_9_analyzer_1_array_crystal_array_0)
  mccomp_posa[472] = mcposachannel_9_analyzer_1_array_crystal_array_0;
  mccomp_posr[472] = mcposrchannel_9_analyzer_1_array_crystal_array_0;
  mcNCounter[472]  = mcPCounter[472] = mcP2Counter[472] = 0;
  mcAbsorbProp[472]= 0;
    /* Component channel_9_analyzer_1_array_crystal_array_1. */
  /* Setting parameters for component channel_9_analyzer_1_array_crystal_array_1. */
  SIG_MESSAGE("channel_9_analyzer_1_array_crystal_array_1 (Init:SetPar)");
#line 2532 "MACS_sample_kidney_box.instr"
  if("PG_analyzer") strncpy(mccchannel_9_analyzer_1_array_crystal_array_1_material_string, "PG_analyzer" ? "PG_analyzer" : "", 16384); else mccchannel_9_analyzer_1_array_crystal_array_1_material_string[0]='\0';
#line 2532 "MACS_sample_kidney_box.instr"
  mccchannel_9_analyzer_1_array_crystal_array_1_priority = 1120.1;
#line 2531 "MACS_sample_kidney_box.instr"
  mccchannel_9_analyzer_1_array_crystal_array_1_xwidth = channel_9_analyzer_1_array_crystal_depth;
#line 2531 "MACS_sample_kidney_box.instr"
  mccchannel_9_analyzer_1_array_crystal_array_1_yheight = channel_9_analyzer_1_array_crystal_height;
#line 2531 "MACS_sample_kidney_box.instr"
  mccchannel_9_analyzer_1_array_crystal_array_1_zdepth = channel_9_analyzer_1_array_crystal_width;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_9_analyzer_1_array_crystal_array_1_xwidth2 = -1;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_9_analyzer_1_array_crystal_array_1_yheight2 = -1;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_9_analyzer_1_array_crystal_array_1_visualize = 1;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_9_analyzer_1_array_crystal_array_1_target_index = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_9_analyzer_1_array_crystal_array_1_target_x = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_9_analyzer_1_array_crystal_array_1_target_y = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_9_analyzer_1_array_crystal_array_1_target_z = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_9_analyzer_1_array_crystal_array_1_focus_aw = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_9_analyzer_1_array_crystal_array_1_focus_ah = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_9_analyzer_1_array_crystal_array_1_focus_xw = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_9_analyzer_1_array_crystal_array_1_focus_xh = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_9_analyzer_1_array_crystal_array_1_focus_r = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_9_analyzer_1_array_crystal_array_1_p_interact = 0;
#line 71 "MACS_sample_kidney_box.instr"
  if(0) strncpy(mccchannel_9_analyzer_1_array_crystal_array_1_mask_string, 0 ? 0 : "", 16384); else mccchannel_9_analyzer_1_array_crystal_array_1_mask_string[0]='\0';
#line 71 "MACS_sample_kidney_box.instr"
  if(0) strncpy(mccchannel_9_analyzer_1_array_crystal_array_1_mask_setting, 0 ? 0 : "", 16384); else mccchannel_9_analyzer_1_array_crystal_array_1_mask_setting[0]='\0';
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_9_analyzer_1_array_crystal_array_1_number_of_activations = 1;
#line 120959 "MACS_sample_kidney_box.c"

  SIG_MESSAGE("channel_9_analyzer_1_array_crystal_array_1 (Init:Place/Rotate)");
  rot_set_rotation(mctr1,
#line 2534 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 2534 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 2534 "MACS_sample_kidney_box.instr"
    (0 - RAD2DEG * channel_9_analyzer_1_array_theta [ 1 ])*DEG2RAD);
#line 120969 "MACS_sample_kidney_box.c"
  rot_mul(mctr1, mcrotachannel_9_analyzer_1_rotated, mcrotachannel_9_analyzer_1_array_crystal_array_1);
  rot_transpose(mcrotachannel_9_analyzer_1_array_crystal_array_0, mctr1);
  rot_mul(mcrotachannel_9_analyzer_1_array_crystal_array_1, mctr1, mcrotrchannel_9_analyzer_1_array_crystal_array_1);
  mctc1 = coords_set(
#line 2533 "MACS_sample_kidney_box.instr"
    0 + channel_9_analyzer_1_array_effective_radius_of_curvature * ( 1 - cos ( channel_9_analyzer_1_array_theta [ 1 ] ) ),
#line 2533 "MACS_sample_kidney_box.instr"
    0 + channel_9_analyzer_1_array_effective_radius_of_curvature * sin ( channel_9_analyzer_1_array_theta [ 1 ] ),
#line 2533 "MACS_sample_kidney_box.instr"
    0);
#line 120980 "MACS_sample_kidney_box.c"
  rot_transpose(mcrotachannel_9_analyzer_1_rotated, mctr1);
  mctc2 = rot_apply(mctr1, mctc1);
  mcposachannel_9_analyzer_1_array_crystal_array_1 = coords_add(mcposachannel_9_analyzer_1_rotated, mctc2);
  mctc1 = coords_sub(mcposachannel_9_analyzer_1_array_crystal_array_0, mcposachannel_9_analyzer_1_array_crystal_array_1);
  mcposrchannel_9_analyzer_1_array_crystal_array_1 = rot_apply(mcrotachannel_9_analyzer_1_array_crystal_array_1, mctc1);
  mcDEBUG_COMPONENT("channel_9_analyzer_1_array_crystal_array_1", mcposachannel_9_analyzer_1_array_crystal_array_1, mcrotachannel_9_analyzer_1_array_crystal_array_1)
  mccomp_posa[473] = mcposachannel_9_analyzer_1_array_crystal_array_1;
  mccomp_posr[473] = mcposrchannel_9_analyzer_1_array_crystal_array_1;
  mcNCounter[473]  = mcPCounter[473] = mcP2Counter[473] = 0;
  mcAbsorbProp[473]= 0;
    /* Component channel_9_analyzer_1_array_crystal_array_2. */
  /* Setting parameters for component channel_9_analyzer_1_array_crystal_array_2. */
  SIG_MESSAGE("channel_9_analyzer_1_array_crystal_array_2 (Init:SetPar)");
#line 2538 "MACS_sample_kidney_box.instr"
  if("PG_analyzer") strncpy(mccchannel_9_analyzer_1_array_crystal_array_2_material_string, "PG_analyzer" ? "PG_analyzer" : "", 16384); else mccchannel_9_analyzer_1_array_crystal_array_2_material_string[0]='\0';
#line 2538 "MACS_sample_kidney_box.instr"
  mccchannel_9_analyzer_1_array_crystal_array_2_priority = 1120.2;
#line 2537 "MACS_sample_kidney_box.instr"
  mccchannel_9_analyzer_1_array_crystal_array_2_xwidth = channel_9_analyzer_1_array_crystal_depth;
#line 2537 "MACS_sample_kidney_box.instr"
  mccchannel_9_analyzer_1_array_crystal_array_2_yheight = channel_9_analyzer_1_array_crystal_height;
#line 2537 "MACS_sample_kidney_box.instr"
  mccchannel_9_analyzer_1_array_crystal_array_2_zdepth = channel_9_analyzer_1_array_crystal_width;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_9_analyzer_1_array_crystal_array_2_xwidth2 = -1;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_9_analyzer_1_array_crystal_array_2_yheight2 = -1;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_9_analyzer_1_array_crystal_array_2_visualize = 1;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_9_analyzer_1_array_crystal_array_2_target_index = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_9_analyzer_1_array_crystal_array_2_target_x = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_9_analyzer_1_array_crystal_array_2_target_y = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_9_analyzer_1_array_crystal_array_2_target_z = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_9_analyzer_1_array_crystal_array_2_focus_aw = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_9_analyzer_1_array_crystal_array_2_focus_ah = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_9_analyzer_1_array_crystal_array_2_focus_xw = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_9_analyzer_1_array_crystal_array_2_focus_xh = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_9_analyzer_1_array_crystal_array_2_focus_r = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_9_analyzer_1_array_crystal_array_2_p_interact = 0;
#line 71 "MACS_sample_kidney_box.instr"
  if(0) strncpy(mccchannel_9_analyzer_1_array_crystal_array_2_mask_string, 0 ? 0 : "", 16384); else mccchannel_9_analyzer_1_array_crystal_array_2_mask_string[0]='\0';
#line 71 "MACS_sample_kidney_box.instr"
  if(0) strncpy(mccchannel_9_analyzer_1_array_crystal_array_2_mask_setting, 0 ? 0 : "", 16384); else mccchannel_9_analyzer_1_array_crystal_array_2_mask_setting[0]='\0';
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_9_analyzer_1_array_crystal_array_2_number_of_activations = 1;
#line 121036 "MACS_sample_kidney_box.c"

  SIG_MESSAGE("channel_9_analyzer_1_array_crystal_array_2 (Init:Place/Rotate)");
  rot_set_rotation(mctr1,
#line 2540 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 2540 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 2540 "MACS_sample_kidney_box.instr"
    (0 - RAD2DEG * channel_9_analyzer_1_array_theta [ 2 ])*DEG2RAD);
#line 121046 "MACS_sample_kidney_box.c"
  rot_mul(mctr1, mcrotachannel_9_analyzer_1_rotated, mcrotachannel_9_analyzer_1_array_crystal_array_2);
  rot_transpose(mcrotachannel_9_analyzer_1_array_crystal_array_1, mctr1);
  rot_mul(mcrotachannel_9_analyzer_1_array_crystal_array_2, mctr1, mcrotrchannel_9_analyzer_1_array_crystal_array_2);
  mctc1 = coords_set(
#line 2539 "MACS_sample_kidney_box.instr"
    0 + channel_9_analyzer_1_array_effective_radius_of_curvature * ( 1 - cos ( channel_9_analyzer_1_array_theta [ 2 ] ) ),
#line 2539 "MACS_sample_kidney_box.instr"
    0 + channel_9_analyzer_1_array_effective_radius_of_curvature * sin ( channel_9_analyzer_1_array_theta [ 2 ] ),
#line 2539 "MACS_sample_kidney_box.instr"
    0);
#line 121057 "MACS_sample_kidney_box.c"
  rot_transpose(mcrotachannel_9_analyzer_1_rotated, mctr1);
  mctc2 = rot_apply(mctr1, mctc1);
  mcposachannel_9_analyzer_1_array_crystal_array_2 = coords_add(mcposachannel_9_analyzer_1_rotated, mctc2);
  mctc1 = coords_sub(mcposachannel_9_analyzer_1_array_crystal_array_1, mcposachannel_9_analyzer_1_array_crystal_array_2);
  mcposrchannel_9_analyzer_1_array_crystal_array_2 = rot_apply(mcrotachannel_9_analyzer_1_array_crystal_array_2, mctc1);
  mcDEBUG_COMPONENT("channel_9_analyzer_1_array_crystal_array_2", mcposachannel_9_analyzer_1_array_crystal_array_2, mcrotachannel_9_analyzer_1_array_crystal_array_2)
  mccomp_posa[474] = mcposachannel_9_analyzer_1_array_crystal_array_2;
  mccomp_posr[474] = mcposrchannel_9_analyzer_1_array_crystal_array_2;
  mcNCounter[474]  = mcPCounter[474] = mcP2Counter[474] = 0;
  mcAbsorbProp[474]= 0;
    /* Component channel_9_analyzer_1_array_crystal_array_3. */
  /* Setting parameters for component channel_9_analyzer_1_array_crystal_array_3. */
  SIG_MESSAGE("channel_9_analyzer_1_array_crystal_array_3 (Init:SetPar)");
#line 2544 "MACS_sample_kidney_box.instr"
  if("PG_analyzer") strncpy(mccchannel_9_analyzer_1_array_crystal_array_3_material_string, "PG_analyzer" ? "PG_analyzer" : "", 16384); else mccchannel_9_analyzer_1_array_crystal_array_3_material_string[0]='\0';
#line 2544 "MACS_sample_kidney_box.instr"
  mccchannel_9_analyzer_1_array_crystal_array_3_priority = 1120.3;
#line 2543 "MACS_sample_kidney_box.instr"
  mccchannel_9_analyzer_1_array_crystal_array_3_xwidth = channel_9_analyzer_1_array_crystal_depth;
#line 2543 "MACS_sample_kidney_box.instr"
  mccchannel_9_analyzer_1_array_crystal_array_3_yheight = channel_9_analyzer_1_array_crystal_height;
#line 2543 "MACS_sample_kidney_box.instr"
  mccchannel_9_analyzer_1_array_crystal_array_3_zdepth = channel_9_analyzer_1_array_crystal_width;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_9_analyzer_1_array_crystal_array_3_xwidth2 = -1;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_9_analyzer_1_array_crystal_array_3_yheight2 = -1;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_9_analyzer_1_array_crystal_array_3_visualize = 1;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_9_analyzer_1_array_crystal_array_3_target_index = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_9_analyzer_1_array_crystal_array_3_target_x = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_9_analyzer_1_array_crystal_array_3_target_y = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_9_analyzer_1_array_crystal_array_3_target_z = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_9_analyzer_1_array_crystal_array_3_focus_aw = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_9_analyzer_1_array_crystal_array_3_focus_ah = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_9_analyzer_1_array_crystal_array_3_focus_xw = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_9_analyzer_1_array_crystal_array_3_focus_xh = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_9_analyzer_1_array_crystal_array_3_focus_r = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_9_analyzer_1_array_crystal_array_3_p_interact = 0;
#line 71 "MACS_sample_kidney_box.instr"
  if(0) strncpy(mccchannel_9_analyzer_1_array_crystal_array_3_mask_string, 0 ? 0 : "", 16384); else mccchannel_9_analyzer_1_array_crystal_array_3_mask_string[0]='\0';
#line 71 "MACS_sample_kidney_box.instr"
  if(0) strncpy(mccchannel_9_analyzer_1_array_crystal_array_3_mask_setting, 0 ? 0 : "", 16384); else mccchannel_9_analyzer_1_array_crystal_array_3_mask_setting[0]='\0';
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_9_analyzer_1_array_crystal_array_3_number_of_activations = 1;
#line 121113 "MACS_sample_kidney_box.c"

  SIG_MESSAGE("channel_9_analyzer_1_array_crystal_array_3 (Init:Place/Rotate)");
  rot_set_rotation(mctr1,
#line 2546 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 2546 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 2546 "MACS_sample_kidney_box.instr"
    (0 - RAD2DEG * channel_9_analyzer_1_array_theta [ 3 ])*DEG2RAD);
#line 121123 "MACS_sample_kidney_box.c"
  rot_mul(mctr1, mcrotachannel_9_analyzer_1_rotated, mcrotachannel_9_analyzer_1_array_crystal_array_3);
  rot_transpose(mcrotachannel_9_analyzer_1_array_crystal_array_2, mctr1);
  rot_mul(mcrotachannel_9_analyzer_1_array_crystal_array_3, mctr1, mcrotrchannel_9_analyzer_1_array_crystal_array_3);
  mctc1 = coords_set(
#line 2545 "MACS_sample_kidney_box.instr"
    0 + channel_9_analyzer_1_array_effective_radius_of_curvature * ( 1 - cos ( channel_9_analyzer_1_array_theta [ 3 ] ) ),
#line 2545 "MACS_sample_kidney_box.instr"
    0 + channel_9_analyzer_1_array_effective_radius_of_curvature * sin ( channel_9_analyzer_1_array_theta [ 3 ] ),
#line 2545 "MACS_sample_kidney_box.instr"
    0);
#line 121134 "MACS_sample_kidney_box.c"
  rot_transpose(mcrotachannel_9_analyzer_1_rotated, mctr1);
  mctc2 = rot_apply(mctr1, mctc1);
  mcposachannel_9_analyzer_1_array_crystal_array_3 = coords_add(mcposachannel_9_analyzer_1_rotated, mctc2);
  mctc1 = coords_sub(mcposachannel_9_analyzer_1_array_crystal_array_2, mcposachannel_9_analyzer_1_array_crystal_array_3);
  mcposrchannel_9_analyzer_1_array_crystal_array_3 = rot_apply(mcrotachannel_9_analyzer_1_array_crystal_array_3, mctc1);
  mcDEBUG_COMPONENT("channel_9_analyzer_1_array_crystal_array_3", mcposachannel_9_analyzer_1_array_crystal_array_3, mcrotachannel_9_analyzer_1_array_crystal_array_3)
  mccomp_posa[475] = mcposachannel_9_analyzer_1_array_crystal_array_3;
  mccomp_posr[475] = mcposrchannel_9_analyzer_1_array_crystal_array_3;
  mcNCounter[475]  = mcPCounter[475] = mcP2Counter[475] = 0;
  mcAbsorbProp[475]= 0;
    /* Component channel_9_analyzer_1_array_crystal_array_4. */
  /* Setting parameters for component channel_9_analyzer_1_array_crystal_array_4. */
  SIG_MESSAGE("channel_9_analyzer_1_array_crystal_array_4 (Init:SetPar)");
#line 2550 "MACS_sample_kidney_box.instr"
  if("PG_analyzer") strncpy(mccchannel_9_analyzer_1_array_crystal_array_4_material_string, "PG_analyzer" ? "PG_analyzer" : "", 16384); else mccchannel_9_analyzer_1_array_crystal_array_4_material_string[0]='\0';
#line 2550 "MACS_sample_kidney_box.instr"
  mccchannel_9_analyzer_1_array_crystal_array_4_priority = 1120.4;
#line 2549 "MACS_sample_kidney_box.instr"
  mccchannel_9_analyzer_1_array_crystal_array_4_xwidth = channel_9_analyzer_1_array_crystal_depth;
#line 2549 "MACS_sample_kidney_box.instr"
  mccchannel_9_analyzer_1_array_crystal_array_4_yheight = channel_9_analyzer_1_array_crystal_height;
#line 2549 "MACS_sample_kidney_box.instr"
  mccchannel_9_analyzer_1_array_crystal_array_4_zdepth = channel_9_analyzer_1_array_crystal_width;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_9_analyzer_1_array_crystal_array_4_xwidth2 = -1;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_9_analyzer_1_array_crystal_array_4_yheight2 = -1;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_9_analyzer_1_array_crystal_array_4_visualize = 1;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_9_analyzer_1_array_crystal_array_4_target_index = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_9_analyzer_1_array_crystal_array_4_target_x = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_9_analyzer_1_array_crystal_array_4_target_y = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_9_analyzer_1_array_crystal_array_4_target_z = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_9_analyzer_1_array_crystal_array_4_focus_aw = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_9_analyzer_1_array_crystal_array_4_focus_ah = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_9_analyzer_1_array_crystal_array_4_focus_xw = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_9_analyzer_1_array_crystal_array_4_focus_xh = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_9_analyzer_1_array_crystal_array_4_focus_r = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_9_analyzer_1_array_crystal_array_4_p_interact = 0;
#line 71 "MACS_sample_kidney_box.instr"
  if(0) strncpy(mccchannel_9_analyzer_1_array_crystal_array_4_mask_string, 0 ? 0 : "", 16384); else mccchannel_9_analyzer_1_array_crystal_array_4_mask_string[0]='\0';
#line 71 "MACS_sample_kidney_box.instr"
  if(0) strncpy(mccchannel_9_analyzer_1_array_crystal_array_4_mask_setting, 0 ? 0 : "", 16384); else mccchannel_9_analyzer_1_array_crystal_array_4_mask_setting[0]='\0';
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_9_analyzer_1_array_crystal_array_4_number_of_activations = 1;
#line 121190 "MACS_sample_kidney_box.c"

  SIG_MESSAGE("channel_9_analyzer_1_array_crystal_array_4 (Init:Place/Rotate)");
  rot_set_rotation(mctr1,
#line 2552 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 2552 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 2552 "MACS_sample_kidney_box.instr"
    (0 - RAD2DEG * channel_9_analyzer_1_array_theta [ 4 ])*DEG2RAD);
#line 121200 "MACS_sample_kidney_box.c"
  rot_mul(mctr1, mcrotachannel_9_analyzer_1_rotated, mcrotachannel_9_analyzer_1_array_crystal_array_4);
  rot_transpose(mcrotachannel_9_analyzer_1_array_crystal_array_3, mctr1);
  rot_mul(mcrotachannel_9_analyzer_1_array_crystal_array_4, mctr1, mcrotrchannel_9_analyzer_1_array_crystal_array_4);
  mctc1 = coords_set(
#line 2551 "MACS_sample_kidney_box.instr"
    0 + channel_9_analyzer_1_array_effective_radius_of_curvature * ( 1 - cos ( channel_9_analyzer_1_array_theta [ 4 ] ) ),
#line 2551 "MACS_sample_kidney_box.instr"
    0 + channel_9_analyzer_1_array_effective_radius_of_curvature * sin ( channel_9_analyzer_1_array_theta [ 4 ] ),
#line 2551 "MACS_sample_kidney_box.instr"
    0);
#line 121211 "MACS_sample_kidney_box.c"
  rot_transpose(mcrotachannel_9_analyzer_1_rotated, mctr1);
  mctc2 = rot_apply(mctr1, mctc1);
  mcposachannel_9_analyzer_1_array_crystal_array_4 = coords_add(mcposachannel_9_analyzer_1_rotated, mctc2);
  mctc1 = coords_sub(mcposachannel_9_analyzer_1_array_crystal_array_3, mcposachannel_9_analyzer_1_array_crystal_array_4);
  mcposrchannel_9_analyzer_1_array_crystal_array_4 = rot_apply(mcrotachannel_9_analyzer_1_array_crystal_array_4, mctc1);
  mcDEBUG_COMPONENT("channel_9_analyzer_1_array_crystal_array_4", mcposachannel_9_analyzer_1_array_crystal_array_4, mcrotachannel_9_analyzer_1_array_crystal_array_4)
  mccomp_posa[476] = mcposachannel_9_analyzer_1_array_crystal_array_4;
  mccomp_posr[476] = mcposrchannel_9_analyzer_1_array_crystal_array_4;
  mcNCounter[476]  = mcPCounter[476] = mcP2Counter[476] = 0;
  mcAbsorbProp[476]= 0;
    /* Component channel_9_analyzer_1_array_crystal_array_5. */
  /* Setting parameters for component channel_9_analyzer_1_array_crystal_array_5. */
  SIG_MESSAGE("channel_9_analyzer_1_array_crystal_array_5 (Init:SetPar)");
#line 2556 "MACS_sample_kidney_box.instr"
  if("PG_analyzer") strncpy(mccchannel_9_analyzer_1_array_crystal_array_5_material_string, "PG_analyzer" ? "PG_analyzer" : "", 16384); else mccchannel_9_analyzer_1_array_crystal_array_5_material_string[0]='\0';
#line 2556 "MACS_sample_kidney_box.instr"
  mccchannel_9_analyzer_1_array_crystal_array_5_priority = 1120.5;
#line 2555 "MACS_sample_kidney_box.instr"
  mccchannel_9_analyzer_1_array_crystal_array_5_xwidth = channel_9_analyzer_1_array_crystal_depth;
#line 2555 "MACS_sample_kidney_box.instr"
  mccchannel_9_analyzer_1_array_crystal_array_5_yheight = channel_9_analyzer_1_array_crystal_height;
#line 2555 "MACS_sample_kidney_box.instr"
  mccchannel_9_analyzer_1_array_crystal_array_5_zdepth = channel_9_analyzer_1_array_crystal_width;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_9_analyzer_1_array_crystal_array_5_xwidth2 = -1;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_9_analyzer_1_array_crystal_array_5_yheight2 = -1;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_9_analyzer_1_array_crystal_array_5_visualize = 1;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_9_analyzer_1_array_crystal_array_5_target_index = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_9_analyzer_1_array_crystal_array_5_target_x = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_9_analyzer_1_array_crystal_array_5_target_y = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_9_analyzer_1_array_crystal_array_5_target_z = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_9_analyzer_1_array_crystal_array_5_focus_aw = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_9_analyzer_1_array_crystal_array_5_focus_ah = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_9_analyzer_1_array_crystal_array_5_focus_xw = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_9_analyzer_1_array_crystal_array_5_focus_xh = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_9_analyzer_1_array_crystal_array_5_focus_r = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_9_analyzer_1_array_crystal_array_5_p_interact = 0;
#line 71 "MACS_sample_kidney_box.instr"
  if(0) strncpy(mccchannel_9_analyzer_1_array_crystal_array_5_mask_string, 0 ? 0 : "", 16384); else mccchannel_9_analyzer_1_array_crystal_array_5_mask_string[0]='\0';
#line 71 "MACS_sample_kidney_box.instr"
  if(0) strncpy(mccchannel_9_analyzer_1_array_crystal_array_5_mask_setting, 0 ? 0 : "", 16384); else mccchannel_9_analyzer_1_array_crystal_array_5_mask_setting[0]='\0';
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_9_analyzer_1_array_crystal_array_5_number_of_activations = 1;
#line 121267 "MACS_sample_kidney_box.c"

  SIG_MESSAGE("channel_9_analyzer_1_array_crystal_array_5 (Init:Place/Rotate)");
  rot_set_rotation(mctr1,
#line 2558 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 2558 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 2558 "MACS_sample_kidney_box.instr"
    (0 - RAD2DEG * channel_9_analyzer_1_array_theta [ 5 ])*DEG2RAD);
#line 121277 "MACS_sample_kidney_box.c"
  rot_mul(mctr1, mcrotachannel_9_analyzer_1_rotated, mcrotachannel_9_analyzer_1_array_crystal_array_5);
  rot_transpose(mcrotachannel_9_analyzer_1_array_crystal_array_4, mctr1);
  rot_mul(mcrotachannel_9_analyzer_1_array_crystal_array_5, mctr1, mcrotrchannel_9_analyzer_1_array_crystal_array_5);
  mctc1 = coords_set(
#line 2557 "MACS_sample_kidney_box.instr"
    0 + channel_9_analyzer_1_array_effective_radius_of_curvature * ( 1 - cos ( channel_9_analyzer_1_array_theta [ 5 ] ) ),
#line 2557 "MACS_sample_kidney_box.instr"
    0 + channel_9_analyzer_1_array_effective_radius_of_curvature * sin ( channel_9_analyzer_1_array_theta [ 5 ] ),
#line 2557 "MACS_sample_kidney_box.instr"
    0);
#line 121288 "MACS_sample_kidney_box.c"
  rot_transpose(mcrotachannel_9_analyzer_1_rotated, mctr1);
  mctc2 = rot_apply(mctr1, mctc1);
  mcposachannel_9_analyzer_1_array_crystal_array_5 = coords_add(mcposachannel_9_analyzer_1_rotated, mctc2);
  mctc1 = coords_sub(mcposachannel_9_analyzer_1_array_crystal_array_4, mcposachannel_9_analyzer_1_array_crystal_array_5);
  mcposrchannel_9_analyzer_1_array_crystal_array_5 = rot_apply(mcrotachannel_9_analyzer_1_array_crystal_array_5, mctc1);
  mcDEBUG_COMPONENT("channel_9_analyzer_1_array_crystal_array_5", mcposachannel_9_analyzer_1_array_crystal_array_5, mcrotachannel_9_analyzer_1_array_crystal_array_5)
  mccomp_posa[477] = mcposachannel_9_analyzer_1_array_crystal_array_5;
  mccomp_posr[477] = mcposrchannel_9_analyzer_1_array_crystal_array_5;
  mcNCounter[477]  = mcPCounter[477] = mcP2Counter[477] = 0;
  mcAbsorbProp[477]= 0;
    /* Component channel_9_analyzer_1_array_crystal_array_6. */
  /* Setting parameters for component channel_9_analyzer_1_array_crystal_array_6. */
  SIG_MESSAGE("channel_9_analyzer_1_array_crystal_array_6 (Init:SetPar)");
#line 2562 "MACS_sample_kidney_box.instr"
  if("PG_analyzer") strncpy(mccchannel_9_analyzer_1_array_crystal_array_6_material_string, "PG_analyzer" ? "PG_analyzer" : "", 16384); else mccchannel_9_analyzer_1_array_crystal_array_6_material_string[0]='\0';
#line 2562 "MACS_sample_kidney_box.instr"
  mccchannel_9_analyzer_1_array_crystal_array_6_priority = 1120.6;
#line 2561 "MACS_sample_kidney_box.instr"
  mccchannel_9_analyzer_1_array_crystal_array_6_xwidth = channel_9_analyzer_1_array_crystal_depth;
#line 2561 "MACS_sample_kidney_box.instr"
  mccchannel_9_analyzer_1_array_crystal_array_6_yheight = channel_9_analyzer_1_array_crystal_height;
#line 2561 "MACS_sample_kidney_box.instr"
  mccchannel_9_analyzer_1_array_crystal_array_6_zdepth = channel_9_analyzer_1_array_crystal_width;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_9_analyzer_1_array_crystal_array_6_xwidth2 = -1;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_9_analyzer_1_array_crystal_array_6_yheight2 = -1;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_9_analyzer_1_array_crystal_array_6_visualize = 1;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_9_analyzer_1_array_crystal_array_6_target_index = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_9_analyzer_1_array_crystal_array_6_target_x = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_9_analyzer_1_array_crystal_array_6_target_y = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_9_analyzer_1_array_crystal_array_6_target_z = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_9_analyzer_1_array_crystal_array_6_focus_aw = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_9_analyzer_1_array_crystal_array_6_focus_ah = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_9_analyzer_1_array_crystal_array_6_focus_xw = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_9_analyzer_1_array_crystal_array_6_focus_xh = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_9_analyzer_1_array_crystal_array_6_focus_r = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_9_analyzer_1_array_crystal_array_6_p_interact = 0;
#line 71 "MACS_sample_kidney_box.instr"
  if(0) strncpy(mccchannel_9_analyzer_1_array_crystal_array_6_mask_string, 0 ? 0 : "", 16384); else mccchannel_9_analyzer_1_array_crystal_array_6_mask_string[0]='\0';
#line 71 "MACS_sample_kidney_box.instr"
  if(0) strncpy(mccchannel_9_analyzer_1_array_crystal_array_6_mask_setting, 0 ? 0 : "", 16384); else mccchannel_9_analyzer_1_array_crystal_array_6_mask_setting[0]='\0';
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_9_analyzer_1_array_crystal_array_6_number_of_activations = 1;
#line 121344 "MACS_sample_kidney_box.c"

  SIG_MESSAGE("channel_9_analyzer_1_array_crystal_array_6 (Init:Place/Rotate)");
  rot_set_rotation(mctr1,
#line 2564 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 2564 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 2564 "MACS_sample_kidney_box.instr"
    (0 - RAD2DEG * channel_9_analyzer_1_array_theta [ 6 ])*DEG2RAD);
#line 121354 "MACS_sample_kidney_box.c"
  rot_mul(mctr1, mcrotachannel_9_analyzer_1_rotated, mcrotachannel_9_analyzer_1_array_crystal_array_6);
  rot_transpose(mcrotachannel_9_analyzer_1_array_crystal_array_5, mctr1);
  rot_mul(mcrotachannel_9_analyzer_1_array_crystal_array_6, mctr1, mcrotrchannel_9_analyzer_1_array_crystal_array_6);
  mctc1 = coords_set(
#line 2563 "MACS_sample_kidney_box.instr"
    0 + channel_9_analyzer_1_array_effective_radius_of_curvature * ( 1 - cos ( channel_9_analyzer_1_array_theta [ 6 ] ) ),
#line 2563 "MACS_sample_kidney_box.instr"
    0 + channel_9_analyzer_1_array_effective_radius_of_curvature * sin ( channel_9_analyzer_1_array_theta [ 6 ] ),
#line 2563 "MACS_sample_kidney_box.instr"
    0);
#line 121365 "MACS_sample_kidney_box.c"
  rot_transpose(mcrotachannel_9_analyzer_1_rotated, mctr1);
  mctc2 = rot_apply(mctr1, mctc1);
  mcposachannel_9_analyzer_1_array_crystal_array_6 = coords_add(mcposachannel_9_analyzer_1_rotated, mctc2);
  mctc1 = coords_sub(mcposachannel_9_analyzer_1_array_crystal_array_5, mcposachannel_9_analyzer_1_array_crystal_array_6);
  mcposrchannel_9_analyzer_1_array_crystal_array_6 = rot_apply(mcrotachannel_9_analyzer_1_array_crystal_array_6, mctc1);
  mcDEBUG_COMPONENT("channel_9_analyzer_1_array_crystal_array_6", mcposachannel_9_analyzer_1_array_crystal_array_6, mcrotachannel_9_analyzer_1_array_crystal_array_6)
  mccomp_posa[478] = mcposachannel_9_analyzer_1_array_crystal_array_6;
  mccomp_posr[478] = mcposrchannel_9_analyzer_1_array_crystal_array_6;
  mcNCounter[478]  = mcPCounter[478] = mcP2Counter[478] = 0;
  mcAbsorbProp[478]= 0;
    /* Component channel_9_analyzer_1_array_crystal_array_7. */
  /* Setting parameters for component channel_9_analyzer_1_array_crystal_array_7. */
  SIG_MESSAGE("channel_9_analyzer_1_array_crystal_array_7 (Init:SetPar)");
#line 2568 "MACS_sample_kidney_box.instr"
  if("PG_analyzer") strncpy(mccchannel_9_analyzer_1_array_crystal_array_7_material_string, "PG_analyzer" ? "PG_analyzer" : "", 16384); else mccchannel_9_analyzer_1_array_crystal_array_7_material_string[0]='\0';
#line 2568 "MACS_sample_kidney_box.instr"
  mccchannel_9_analyzer_1_array_crystal_array_7_priority = 1120.7;
#line 2567 "MACS_sample_kidney_box.instr"
  mccchannel_9_analyzer_1_array_crystal_array_7_xwidth = channel_9_analyzer_1_array_crystal_depth;
#line 2567 "MACS_sample_kidney_box.instr"
  mccchannel_9_analyzer_1_array_crystal_array_7_yheight = channel_9_analyzer_1_array_crystal_height;
#line 2567 "MACS_sample_kidney_box.instr"
  mccchannel_9_analyzer_1_array_crystal_array_7_zdepth = channel_9_analyzer_1_array_crystal_width;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_9_analyzer_1_array_crystal_array_7_xwidth2 = -1;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_9_analyzer_1_array_crystal_array_7_yheight2 = -1;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_9_analyzer_1_array_crystal_array_7_visualize = 1;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_9_analyzer_1_array_crystal_array_7_target_index = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_9_analyzer_1_array_crystal_array_7_target_x = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_9_analyzer_1_array_crystal_array_7_target_y = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_9_analyzer_1_array_crystal_array_7_target_z = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_9_analyzer_1_array_crystal_array_7_focus_aw = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_9_analyzer_1_array_crystal_array_7_focus_ah = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_9_analyzer_1_array_crystal_array_7_focus_xw = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_9_analyzer_1_array_crystal_array_7_focus_xh = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_9_analyzer_1_array_crystal_array_7_focus_r = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_9_analyzer_1_array_crystal_array_7_p_interact = 0;
#line 71 "MACS_sample_kidney_box.instr"
  if(0) strncpy(mccchannel_9_analyzer_1_array_crystal_array_7_mask_string, 0 ? 0 : "", 16384); else mccchannel_9_analyzer_1_array_crystal_array_7_mask_string[0]='\0';
#line 71 "MACS_sample_kidney_box.instr"
  if(0) strncpy(mccchannel_9_analyzer_1_array_crystal_array_7_mask_setting, 0 ? 0 : "", 16384); else mccchannel_9_analyzer_1_array_crystal_array_7_mask_setting[0]='\0';
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_9_analyzer_1_array_crystal_array_7_number_of_activations = 1;
#line 121421 "MACS_sample_kidney_box.c"

  SIG_MESSAGE("channel_9_analyzer_1_array_crystal_array_7 (Init:Place/Rotate)");
  rot_set_rotation(mctr1,
#line 2570 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 2570 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 2570 "MACS_sample_kidney_box.instr"
    (0 - RAD2DEG * channel_9_analyzer_1_array_theta [ 7 ])*DEG2RAD);
#line 121431 "MACS_sample_kidney_box.c"
  rot_mul(mctr1, mcrotachannel_9_analyzer_1_rotated, mcrotachannel_9_analyzer_1_array_crystal_array_7);
  rot_transpose(mcrotachannel_9_analyzer_1_array_crystal_array_6, mctr1);
  rot_mul(mcrotachannel_9_analyzer_1_array_crystal_array_7, mctr1, mcrotrchannel_9_analyzer_1_array_crystal_array_7);
  mctc1 = coords_set(
#line 2569 "MACS_sample_kidney_box.instr"
    0 + channel_9_analyzer_1_array_effective_radius_of_curvature * ( 1 - cos ( channel_9_analyzer_1_array_theta [ 7 ] ) ),
#line 2569 "MACS_sample_kidney_box.instr"
    0 + channel_9_analyzer_1_array_effective_radius_of_curvature * sin ( channel_9_analyzer_1_array_theta [ 7 ] ),
#line 2569 "MACS_sample_kidney_box.instr"
    0);
#line 121442 "MACS_sample_kidney_box.c"
  rot_transpose(mcrotachannel_9_analyzer_1_rotated, mctr1);
  mctc2 = rot_apply(mctr1, mctc1);
  mcposachannel_9_analyzer_1_array_crystal_array_7 = coords_add(mcposachannel_9_analyzer_1_rotated, mctc2);
  mctc1 = coords_sub(mcposachannel_9_analyzer_1_array_crystal_array_6, mcposachannel_9_analyzer_1_array_crystal_array_7);
  mcposrchannel_9_analyzer_1_array_crystal_array_7 = rot_apply(mcrotachannel_9_analyzer_1_array_crystal_array_7, mctc1);
  mcDEBUG_COMPONENT("channel_9_analyzer_1_array_crystal_array_7", mcposachannel_9_analyzer_1_array_crystal_array_7, mcrotachannel_9_analyzer_1_array_crystal_array_7)
  mccomp_posa[479] = mcposachannel_9_analyzer_1_array_crystal_array_7;
  mccomp_posr[479] = mcposrchannel_9_analyzer_1_array_crystal_array_7;
  mcNCounter[479]  = mcPCounter[479] = mcP2Counter[479] = 0;
  mcAbsorbProp[479]= 0;
    /* Component channel_9_analyzer_1_array_crystal_array_8. */
  /* Setting parameters for component channel_9_analyzer_1_array_crystal_array_8. */
  SIG_MESSAGE("channel_9_analyzer_1_array_crystal_array_8 (Init:SetPar)");
#line 2574 "MACS_sample_kidney_box.instr"
  if("PG_analyzer") strncpy(mccchannel_9_analyzer_1_array_crystal_array_8_material_string, "PG_analyzer" ? "PG_analyzer" : "", 16384); else mccchannel_9_analyzer_1_array_crystal_array_8_material_string[0]='\0';
#line 2574 "MACS_sample_kidney_box.instr"
  mccchannel_9_analyzer_1_array_crystal_array_8_priority = 1120.8;
#line 2573 "MACS_sample_kidney_box.instr"
  mccchannel_9_analyzer_1_array_crystal_array_8_xwidth = channel_9_analyzer_1_array_crystal_depth;
#line 2573 "MACS_sample_kidney_box.instr"
  mccchannel_9_analyzer_1_array_crystal_array_8_yheight = channel_9_analyzer_1_array_crystal_height;
#line 2573 "MACS_sample_kidney_box.instr"
  mccchannel_9_analyzer_1_array_crystal_array_8_zdepth = channel_9_analyzer_1_array_crystal_width;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_9_analyzer_1_array_crystal_array_8_xwidth2 = -1;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_9_analyzer_1_array_crystal_array_8_yheight2 = -1;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_9_analyzer_1_array_crystal_array_8_visualize = 1;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_9_analyzer_1_array_crystal_array_8_target_index = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_9_analyzer_1_array_crystal_array_8_target_x = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_9_analyzer_1_array_crystal_array_8_target_y = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_9_analyzer_1_array_crystal_array_8_target_z = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_9_analyzer_1_array_crystal_array_8_focus_aw = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_9_analyzer_1_array_crystal_array_8_focus_ah = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_9_analyzer_1_array_crystal_array_8_focus_xw = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_9_analyzer_1_array_crystal_array_8_focus_xh = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_9_analyzer_1_array_crystal_array_8_focus_r = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_9_analyzer_1_array_crystal_array_8_p_interact = 0;
#line 71 "MACS_sample_kidney_box.instr"
  if(0) strncpy(mccchannel_9_analyzer_1_array_crystal_array_8_mask_string, 0 ? 0 : "", 16384); else mccchannel_9_analyzer_1_array_crystal_array_8_mask_string[0]='\0';
#line 71 "MACS_sample_kidney_box.instr"
  if(0) strncpy(mccchannel_9_analyzer_1_array_crystal_array_8_mask_setting, 0 ? 0 : "", 16384); else mccchannel_9_analyzer_1_array_crystal_array_8_mask_setting[0]='\0';
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_9_analyzer_1_array_crystal_array_8_number_of_activations = 1;
#line 121498 "MACS_sample_kidney_box.c"

  SIG_MESSAGE("channel_9_analyzer_1_array_crystal_array_8 (Init:Place/Rotate)");
  rot_set_rotation(mctr1,
#line 2576 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 2576 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 2576 "MACS_sample_kidney_box.instr"
    (0 - RAD2DEG * channel_9_analyzer_1_array_theta [ 8 ])*DEG2RAD);
#line 121508 "MACS_sample_kidney_box.c"
  rot_mul(mctr1, mcrotachannel_9_analyzer_1_rotated, mcrotachannel_9_analyzer_1_array_crystal_array_8);
  rot_transpose(mcrotachannel_9_analyzer_1_array_crystal_array_7, mctr1);
  rot_mul(mcrotachannel_9_analyzer_1_array_crystal_array_8, mctr1, mcrotrchannel_9_analyzer_1_array_crystal_array_8);
  mctc1 = coords_set(
#line 2575 "MACS_sample_kidney_box.instr"
    0 + channel_9_analyzer_1_array_effective_radius_of_curvature * ( 1 - cos ( channel_9_analyzer_1_array_theta [ 8 ] ) ),
#line 2575 "MACS_sample_kidney_box.instr"
    0 + channel_9_analyzer_1_array_effective_radius_of_curvature * sin ( channel_9_analyzer_1_array_theta [ 8 ] ),
#line 2575 "MACS_sample_kidney_box.instr"
    0);
#line 121519 "MACS_sample_kidney_box.c"
  rot_transpose(mcrotachannel_9_analyzer_1_rotated, mctr1);
  mctc2 = rot_apply(mctr1, mctc1);
  mcposachannel_9_analyzer_1_array_crystal_array_8 = coords_add(mcposachannel_9_analyzer_1_rotated, mctc2);
  mctc1 = coords_sub(mcposachannel_9_analyzer_1_array_crystal_array_7, mcposachannel_9_analyzer_1_array_crystal_array_8);
  mcposrchannel_9_analyzer_1_array_crystal_array_8 = rot_apply(mcrotachannel_9_analyzer_1_array_crystal_array_8, mctc1);
  mcDEBUG_COMPONENT("channel_9_analyzer_1_array_crystal_array_8", mcposachannel_9_analyzer_1_array_crystal_array_8, mcrotachannel_9_analyzer_1_array_crystal_array_8)
  mccomp_posa[480] = mcposachannel_9_analyzer_1_array_crystal_array_8;
  mccomp_posr[480] = mcposrchannel_9_analyzer_1_array_crystal_array_8;
  mcNCounter[480]  = mcPCounter[480] = mcP2Counter[480] = 0;
  mcAbsorbProp[480]= 0;
    /* Component channel_9_analyzer_2_center. */
  /* Setting parameters for component channel_9_analyzer_2_center. */
  SIG_MESSAGE("channel_9_analyzer_2_center (Init:SetPar)");

  SIG_MESSAGE("channel_9_analyzer_2_center (Init:Place/Rotate)");
  rot_set_rotation(mctr1,
    (0.0)*DEG2RAD,
    (0.0)*DEG2RAD,
    (0.0)*DEG2RAD);
#line 121539 "MACS_sample_kidney_box.c"
  rot_mul(mctr1, mcrotachannel_9_analyzer_1_center, mcrotachannel_9_analyzer_2_center);
  rot_transpose(mcrotachannel_9_analyzer_1_array_crystal_array_8, mctr1);
  rot_mul(mcrotachannel_9_analyzer_2_center, mctr1, mcrotrchannel_9_analyzer_2_center);
  mctc1 = coords_set(
#line 2580 "MACS_sample_kidney_box.instr"
    - analyzer_seperation,
#line 2580 "MACS_sample_kidney_box.instr"
    0,
#line 2580 "MACS_sample_kidney_box.instr"
    0);
#line 121550 "MACS_sample_kidney_box.c"
  rot_transpose(mcrotachannel_9_analyzer_1_center, mctr1);
  mctc2 = rot_apply(mctr1, mctc1);
  mcposachannel_9_analyzer_2_center = coords_add(mcposachannel_9_analyzer_1_center, mctc2);
  mctc1 = coords_sub(mcposachannel_9_analyzer_1_array_crystal_array_8, mcposachannel_9_analyzer_2_center);
  mcposrchannel_9_analyzer_2_center = rot_apply(mcrotachannel_9_analyzer_2_center, mctc1);
  mcDEBUG_COMPONENT("channel_9_analyzer_2_center", mcposachannel_9_analyzer_2_center, mcrotachannel_9_analyzer_2_center)
  mccomp_posa[481] = mcposachannel_9_analyzer_2_center;
  mccomp_posr[481] = mcposrchannel_9_analyzer_2_center;
  mcNCounter[481]  = mcPCounter[481] = mcP2Counter[481] = 0;
  mcAbsorbProp[481]= 0;
    /* Component channel_9_analyzer_2_rotated. */
  /* Setting parameters for component channel_9_analyzer_2_rotated. */
  SIG_MESSAGE("channel_9_analyzer_2_rotated (Init:SetPar)");

  SIG_MESSAGE("channel_9_analyzer_2_rotated (Init:Place/Rotate)");
  rot_set_rotation(mctr1,
#line 2584 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 2584 "MACS_sample_kidney_box.instr"
    (- analyzer_theta [ 9 ])*DEG2RAD,
#line 2584 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD);
#line 121573 "MACS_sample_kidney_box.c"
  rot_mul(mctr1, mcrotachannel_9_analyzer_2_center, mcrotachannel_9_analyzer_2_rotated);
  rot_transpose(mcrotachannel_9_analyzer_2_center, mctr1);
  rot_mul(mcrotachannel_9_analyzer_2_rotated, mctr1, mcrotrchannel_9_analyzer_2_rotated);
  mctc1 = coords_set(
#line 2583 "MACS_sample_kidney_box.instr"
    0,
#line 2583 "MACS_sample_kidney_box.instr"
    0,
#line 2583 "MACS_sample_kidney_box.instr"
    0.5 * analyzer_seperation / tan ( analyzer_2theta [ 9 ] * DEG2RAD ));
#line 121584 "MACS_sample_kidney_box.c"
  rot_transpose(mcrotachannel_9_analyzer_2_center, mctr1);
  mctc2 = rot_apply(mctr1, mctc1);
  mcposachannel_9_analyzer_2_rotated = coords_add(mcposachannel_9_analyzer_2_center, mctc2);
  mctc1 = coords_sub(mcposachannel_9_analyzer_2_center, mcposachannel_9_analyzer_2_rotated);
  mcposrchannel_9_analyzer_2_rotated = rot_apply(mcrotachannel_9_analyzer_2_rotated, mctc1);
  mcDEBUG_COMPONENT("channel_9_analyzer_2_rotated", mcposachannel_9_analyzer_2_rotated, mcrotachannel_9_analyzer_2_rotated)
  mccomp_posa[482] = mcposachannel_9_analyzer_2_rotated;
  mccomp_posr[482] = mcposrchannel_9_analyzer_2_rotated;
  mcNCounter[482]  = mcPCounter[482] = mcP2Counter[482] = 0;
  mcAbsorbProp[482]= 0;
    /* Component channel_9_analyzer_2_array_crystal_array_0. */
  /* Setting parameters for component channel_9_analyzer_2_array_crystal_array_0. */
  SIG_MESSAGE("channel_9_analyzer_2_array_crystal_array_0 (Init:SetPar)");
#line 2588 "MACS_sample_kidney_box.instr"
  if("PG_analyzer") strncpy(mccchannel_9_analyzer_2_array_crystal_array_0_material_string, "PG_analyzer" ? "PG_analyzer" : "", 16384); else mccchannel_9_analyzer_2_array_crystal_array_0_material_string[0]='\0';
#line 2588 "MACS_sample_kidney_box.instr"
  mccchannel_9_analyzer_2_array_crystal_array_0_priority = 1121.0;
#line 2587 "MACS_sample_kidney_box.instr"
  mccchannel_9_analyzer_2_array_crystal_array_0_xwidth = channel_9_analyzer_2_array_crystal_depth;
#line 2587 "MACS_sample_kidney_box.instr"
  mccchannel_9_analyzer_2_array_crystal_array_0_yheight = channel_9_analyzer_2_array_crystal_height;
#line 2587 "MACS_sample_kidney_box.instr"
  mccchannel_9_analyzer_2_array_crystal_array_0_zdepth = channel_9_analyzer_2_array_crystal_width;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_9_analyzer_2_array_crystal_array_0_xwidth2 = -1;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_9_analyzer_2_array_crystal_array_0_yheight2 = -1;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_9_analyzer_2_array_crystal_array_0_visualize = 1;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_9_analyzer_2_array_crystal_array_0_target_index = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_9_analyzer_2_array_crystal_array_0_target_x = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_9_analyzer_2_array_crystal_array_0_target_y = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_9_analyzer_2_array_crystal_array_0_target_z = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_9_analyzer_2_array_crystal_array_0_focus_aw = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_9_analyzer_2_array_crystal_array_0_focus_ah = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_9_analyzer_2_array_crystal_array_0_focus_xw = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_9_analyzer_2_array_crystal_array_0_focus_xh = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_9_analyzer_2_array_crystal_array_0_focus_r = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_9_analyzer_2_array_crystal_array_0_p_interact = 0;
#line 71 "MACS_sample_kidney_box.instr"
  if(0) strncpy(mccchannel_9_analyzer_2_array_crystal_array_0_mask_string, 0 ? 0 : "", 16384); else mccchannel_9_analyzer_2_array_crystal_array_0_mask_string[0]='\0';
#line 71 "MACS_sample_kidney_box.instr"
  if(0) strncpy(mccchannel_9_analyzer_2_array_crystal_array_0_mask_setting, 0 ? 0 : "", 16384); else mccchannel_9_analyzer_2_array_crystal_array_0_mask_setting[0]='\0';
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_9_analyzer_2_array_crystal_array_0_number_of_activations = 1;
#line 121640 "MACS_sample_kidney_box.c"

  SIG_MESSAGE("channel_9_analyzer_2_array_crystal_array_0 (Init:Place/Rotate)");
  rot_set_rotation(mctr1,
#line 2590 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 2590 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 2590 "MACS_sample_kidney_box.instr"
    (0 - RAD2DEG * channel_9_analyzer_2_array_theta [ 0 ])*DEG2RAD);
#line 121650 "MACS_sample_kidney_box.c"
  rot_mul(mctr1, mcrotachannel_9_analyzer_2_rotated, mcrotachannel_9_analyzer_2_array_crystal_array_0);
  rot_transpose(mcrotachannel_9_analyzer_2_rotated, mctr1);
  rot_mul(mcrotachannel_9_analyzer_2_array_crystal_array_0, mctr1, mcrotrchannel_9_analyzer_2_array_crystal_array_0);
  mctc1 = coords_set(
#line 2589 "MACS_sample_kidney_box.instr"
    0 + channel_9_analyzer_2_array_effective_radius_of_curvature * ( 1 - cos ( channel_9_analyzer_2_array_theta [ 0 ] ) ),
#line 2589 "MACS_sample_kidney_box.instr"
    0 + channel_9_analyzer_2_array_effective_radius_of_curvature * sin ( channel_9_analyzer_2_array_theta [ 0 ] ),
#line 2589 "MACS_sample_kidney_box.instr"
    0);
#line 121661 "MACS_sample_kidney_box.c"
  rot_transpose(mcrotachannel_9_analyzer_2_rotated, mctr1);
  mctc2 = rot_apply(mctr1, mctc1);
  mcposachannel_9_analyzer_2_array_crystal_array_0 = coords_add(mcposachannel_9_analyzer_2_rotated, mctc2);
  mctc1 = coords_sub(mcposachannel_9_analyzer_2_rotated, mcposachannel_9_analyzer_2_array_crystal_array_0);
  mcposrchannel_9_analyzer_2_array_crystal_array_0 = rot_apply(mcrotachannel_9_analyzer_2_array_crystal_array_0, mctc1);
  mcDEBUG_COMPONENT("channel_9_analyzer_2_array_crystal_array_0", mcposachannel_9_analyzer_2_array_crystal_array_0, mcrotachannel_9_analyzer_2_array_crystal_array_0)
  mccomp_posa[483] = mcposachannel_9_analyzer_2_array_crystal_array_0;
  mccomp_posr[483] = mcposrchannel_9_analyzer_2_array_crystal_array_0;
  mcNCounter[483]  = mcPCounter[483] = mcP2Counter[483] = 0;
  mcAbsorbProp[483]= 0;
    /* Component channel_9_analyzer_2_array_crystal_array_1. */
  /* Setting parameters for component channel_9_analyzer_2_array_crystal_array_1. */
  SIG_MESSAGE("channel_9_analyzer_2_array_crystal_array_1 (Init:SetPar)");
#line 2594 "MACS_sample_kidney_box.instr"
  if("PG_analyzer") strncpy(mccchannel_9_analyzer_2_array_crystal_array_1_material_string, "PG_analyzer" ? "PG_analyzer" : "", 16384); else mccchannel_9_analyzer_2_array_crystal_array_1_material_string[0]='\0';
#line 2594 "MACS_sample_kidney_box.instr"
  mccchannel_9_analyzer_2_array_crystal_array_1_priority = 1121.1;
#line 2593 "MACS_sample_kidney_box.instr"
  mccchannel_9_analyzer_2_array_crystal_array_1_xwidth = channel_9_analyzer_2_array_crystal_depth;
#line 2593 "MACS_sample_kidney_box.instr"
  mccchannel_9_analyzer_2_array_crystal_array_1_yheight = channel_9_analyzer_2_array_crystal_height;
#line 2593 "MACS_sample_kidney_box.instr"
  mccchannel_9_analyzer_2_array_crystal_array_1_zdepth = channel_9_analyzer_2_array_crystal_width;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_9_analyzer_2_array_crystal_array_1_xwidth2 = -1;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_9_analyzer_2_array_crystal_array_1_yheight2 = -1;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_9_analyzer_2_array_crystal_array_1_visualize = 1;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_9_analyzer_2_array_crystal_array_1_target_index = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_9_analyzer_2_array_crystal_array_1_target_x = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_9_analyzer_2_array_crystal_array_1_target_y = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_9_analyzer_2_array_crystal_array_1_target_z = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_9_analyzer_2_array_crystal_array_1_focus_aw = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_9_analyzer_2_array_crystal_array_1_focus_ah = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_9_analyzer_2_array_crystal_array_1_focus_xw = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_9_analyzer_2_array_crystal_array_1_focus_xh = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_9_analyzer_2_array_crystal_array_1_focus_r = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_9_analyzer_2_array_crystal_array_1_p_interact = 0;
#line 71 "MACS_sample_kidney_box.instr"
  if(0) strncpy(mccchannel_9_analyzer_2_array_crystal_array_1_mask_string, 0 ? 0 : "", 16384); else mccchannel_9_analyzer_2_array_crystal_array_1_mask_string[0]='\0';
#line 71 "MACS_sample_kidney_box.instr"
  if(0) strncpy(mccchannel_9_analyzer_2_array_crystal_array_1_mask_setting, 0 ? 0 : "", 16384); else mccchannel_9_analyzer_2_array_crystal_array_1_mask_setting[0]='\0';
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_9_analyzer_2_array_crystal_array_1_number_of_activations = 1;
#line 121717 "MACS_sample_kidney_box.c"

  SIG_MESSAGE("channel_9_analyzer_2_array_crystal_array_1 (Init:Place/Rotate)");
  rot_set_rotation(mctr1,
#line 2596 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 2596 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 2596 "MACS_sample_kidney_box.instr"
    (0 - RAD2DEG * channel_9_analyzer_2_array_theta [ 1 ])*DEG2RAD);
#line 121727 "MACS_sample_kidney_box.c"
  rot_mul(mctr1, mcrotachannel_9_analyzer_2_rotated, mcrotachannel_9_analyzer_2_array_crystal_array_1);
  rot_transpose(mcrotachannel_9_analyzer_2_array_crystal_array_0, mctr1);
  rot_mul(mcrotachannel_9_analyzer_2_array_crystal_array_1, mctr1, mcrotrchannel_9_analyzer_2_array_crystal_array_1);
  mctc1 = coords_set(
#line 2595 "MACS_sample_kidney_box.instr"
    0 + channel_9_analyzer_2_array_effective_radius_of_curvature * ( 1 - cos ( channel_9_analyzer_2_array_theta [ 1 ] ) ),
#line 2595 "MACS_sample_kidney_box.instr"
    0 + channel_9_analyzer_2_array_effective_radius_of_curvature * sin ( channel_9_analyzer_2_array_theta [ 1 ] ),
#line 2595 "MACS_sample_kidney_box.instr"
    0);
#line 121738 "MACS_sample_kidney_box.c"
  rot_transpose(mcrotachannel_9_analyzer_2_rotated, mctr1);
  mctc2 = rot_apply(mctr1, mctc1);
  mcposachannel_9_analyzer_2_array_crystal_array_1 = coords_add(mcposachannel_9_analyzer_2_rotated, mctc2);
  mctc1 = coords_sub(mcposachannel_9_analyzer_2_array_crystal_array_0, mcposachannel_9_analyzer_2_array_crystal_array_1);
  mcposrchannel_9_analyzer_2_array_crystal_array_1 = rot_apply(mcrotachannel_9_analyzer_2_array_crystal_array_1, mctc1);
  mcDEBUG_COMPONENT("channel_9_analyzer_2_array_crystal_array_1", mcposachannel_9_analyzer_2_array_crystal_array_1, mcrotachannel_9_analyzer_2_array_crystal_array_1)
  mccomp_posa[484] = mcposachannel_9_analyzer_2_array_crystal_array_1;
  mccomp_posr[484] = mcposrchannel_9_analyzer_2_array_crystal_array_1;
  mcNCounter[484]  = mcPCounter[484] = mcP2Counter[484] = 0;
  mcAbsorbProp[484]= 0;
    /* Component channel_9_analyzer_2_array_crystal_array_2. */
  /* Setting parameters for component channel_9_analyzer_2_array_crystal_array_2. */
  SIG_MESSAGE("channel_9_analyzer_2_array_crystal_array_2 (Init:SetPar)");
#line 2600 "MACS_sample_kidney_box.instr"
  if("PG_analyzer") strncpy(mccchannel_9_analyzer_2_array_crystal_array_2_material_string, "PG_analyzer" ? "PG_analyzer" : "", 16384); else mccchannel_9_analyzer_2_array_crystal_array_2_material_string[0]='\0';
#line 2600 "MACS_sample_kidney_box.instr"
  mccchannel_9_analyzer_2_array_crystal_array_2_priority = 1121.2;
#line 2599 "MACS_sample_kidney_box.instr"
  mccchannel_9_analyzer_2_array_crystal_array_2_xwidth = channel_9_analyzer_2_array_crystal_depth;
#line 2599 "MACS_sample_kidney_box.instr"
  mccchannel_9_analyzer_2_array_crystal_array_2_yheight = channel_9_analyzer_2_array_crystal_height;
#line 2599 "MACS_sample_kidney_box.instr"
  mccchannel_9_analyzer_2_array_crystal_array_2_zdepth = channel_9_analyzer_2_array_crystal_width;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_9_analyzer_2_array_crystal_array_2_xwidth2 = -1;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_9_analyzer_2_array_crystal_array_2_yheight2 = -1;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_9_analyzer_2_array_crystal_array_2_visualize = 1;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_9_analyzer_2_array_crystal_array_2_target_index = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_9_analyzer_2_array_crystal_array_2_target_x = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_9_analyzer_2_array_crystal_array_2_target_y = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_9_analyzer_2_array_crystal_array_2_target_z = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_9_analyzer_2_array_crystal_array_2_focus_aw = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_9_analyzer_2_array_crystal_array_2_focus_ah = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_9_analyzer_2_array_crystal_array_2_focus_xw = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_9_analyzer_2_array_crystal_array_2_focus_xh = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_9_analyzer_2_array_crystal_array_2_focus_r = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_9_analyzer_2_array_crystal_array_2_p_interact = 0;
#line 71 "MACS_sample_kidney_box.instr"
  if(0) strncpy(mccchannel_9_analyzer_2_array_crystal_array_2_mask_string, 0 ? 0 : "", 16384); else mccchannel_9_analyzer_2_array_crystal_array_2_mask_string[0]='\0';
#line 71 "MACS_sample_kidney_box.instr"
  if(0) strncpy(mccchannel_9_analyzer_2_array_crystal_array_2_mask_setting, 0 ? 0 : "", 16384); else mccchannel_9_analyzer_2_array_crystal_array_2_mask_setting[0]='\0';
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_9_analyzer_2_array_crystal_array_2_number_of_activations = 1;
#line 121794 "MACS_sample_kidney_box.c"

  SIG_MESSAGE("channel_9_analyzer_2_array_crystal_array_2 (Init:Place/Rotate)");
  rot_set_rotation(mctr1,
#line 2602 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 2602 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 2602 "MACS_sample_kidney_box.instr"
    (0 - RAD2DEG * channel_9_analyzer_2_array_theta [ 2 ])*DEG2RAD);
#line 121804 "MACS_sample_kidney_box.c"
  rot_mul(mctr1, mcrotachannel_9_analyzer_2_rotated, mcrotachannel_9_analyzer_2_array_crystal_array_2);
  rot_transpose(mcrotachannel_9_analyzer_2_array_crystal_array_1, mctr1);
  rot_mul(mcrotachannel_9_analyzer_2_array_crystal_array_2, mctr1, mcrotrchannel_9_analyzer_2_array_crystal_array_2);
  mctc1 = coords_set(
#line 2601 "MACS_sample_kidney_box.instr"
    0 + channel_9_analyzer_2_array_effective_radius_of_curvature * ( 1 - cos ( channel_9_analyzer_2_array_theta [ 2 ] ) ),
#line 2601 "MACS_sample_kidney_box.instr"
    0 + channel_9_analyzer_2_array_effective_radius_of_curvature * sin ( channel_9_analyzer_2_array_theta [ 2 ] ),
#line 2601 "MACS_sample_kidney_box.instr"
    0);
#line 121815 "MACS_sample_kidney_box.c"
  rot_transpose(mcrotachannel_9_analyzer_2_rotated, mctr1);
  mctc2 = rot_apply(mctr1, mctc1);
  mcposachannel_9_analyzer_2_array_crystal_array_2 = coords_add(mcposachannel_9_analyzer_2_rotated, mctc2);
  mctc1 = coords_sub(mcposachannel_9_analyzer_2_array_crystal_array_1, mcposachannel_9_analyzer_2_array_crystal_array_2);
  mcposrchannel_9_analyzer_2_array_crystal_array_2 = rot_apply(mcrotachannel_9_analyzer_2_array_crystal_array_2, mctc1);
  mcDEBUG_COMPONENT("channel_9_analyzer_2_array_crystal_array_2", mcposachannel_9_analyzer_2_array_crystal_array_2, mcrotachannel_9_analyzer_2_array_crystal_array_2)
  mccomp_posa[485] = mcposachannel_9_analyzer_2_array_crystal_array_2;
  mccomp_posr[485] = mcposrchannel_9_analyzer_2_array_crystal_array_2;
  mcNCounter[485]  = mcPCounter[485] = mcP2Counter[485] = 0;
  mcAbsorbProp[485]= 0;
    /* Component channel_9_analyzer_2_array_crystal_array_3. */
  /* Setting parameters for component channel_9_analyzer_2_array_crystal_array_3. */
  SIG_MESSAGE("channel_9_analyzer_2_array_crystal_array_3 (Init:SetPar)");
#line 2606 "MACS_sample_kidney_box.instr"
  if("PG_analyzer") strncpy(mccchannel_9_analyzer_2_array_crystal_array_3_material_string, "PG_analyzer" ? "PG_analyzer" : "", 16384); else mccchannel_9_analyzer_2_array_crystal_array_3_material_string[0]='\0';
#line 2606 "MACS_sample_kidney_box.instr"
  mccchannel_9_analyzer_2_array_crystal_array_3_priority = 1121.3;
#line 2605 "MACS_sample_kidney_box.instr"
  mccchannel_9_analyzer_2_array_crystal_array_3_xwidth = channel_9_analyzer_2_array_crystal_depth;
#line 2605 "MACS_sample_kidney_box.instr"
  mccchannel_9_analyzer_2_array_crystal_array_3_yheight = channel_9_analyzer_2_array_crystal_height;
#line 2605 "MACS_sample_kidney_box.instr"
  mccchannel_9_analyzer_2_array_crystal_array_3_zdepth = channel_9_analyzer_2_array_crystal_width;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_9_analyzer_2_array_crystal_array_3_xwidth2 = -1;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_9_analyzer_2_array_crystal_array_3_yheight2 = -1;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_9_analyzer_2_array_crystal_array_3_visualize = 1;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_9_analyzer_2_array_crystal_array_3_target_index = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_9_analyzer_2_array_crystal_array_3_target_x = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_9_analyzer_2_array_crystal_array_3_target_y = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_9_analyzer_2_array_crystal_array_3_target_z = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_9_analyzer_2_array_crystal_array_3_focus_aw = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_9_analyzer_2_array_crystal_array_3_focus_ah = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_9_analyzer_2_array_crystal_array_3_focus_xw = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_9_analyzer_2_array_crystal_array_3_focus_xh = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_9_analyzer_2_array_crystal_array_3_focus_r = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_9_analyzer_2_array_crystal_array_3_p_interact = 0;
#line 71 "MACS_sample_kidney_box.instr"
  if(0) strncpy(mccchannel_9_analyzer_2_array_crystal_array_3_mask_string, 0 ? 0 : "", 16384); else mccchannel_9_analyzer_2_array_crystal_array_3_mask_string[0]='\0';
#line 71 "MACS_sample_kidney_box.instr"
  if(0) strncpy(mccchannel_9_analyzer_2_array_crystal_array_3_mask_setting, 0 ? 0 : "", 16384); else mccchannel_9_analyzer_2_array_crystal_array_3_mask_setting[0]='\0';
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_9_analyzer_2_array_crystal_array_3_number_of_activations = 1;
#line 121871 "MACS_sample_kidney_box.c"

  SIG_MESSAGE("channel_9_analyzer_2_array_crystal_array_3 (Init:Place/Rotate)");
  rot_set_rotation(mctr1,
#line 2608 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 2608 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 2608 "MACS_sample_kidney_box.instr"
    (0 - RAD2DEG * channel_9_analyzer_2_array_theta [ 3 ])*DEG2RAD);
#line 121881 "MACS_sample_kidney_box.c"
  rot_mul(mctr1, mcrotachannel_9_analyzer_2_rotated, mcrotachannel_9_analyzer_2_array_crystal_array_3);
  rot_transpose(mcrotachannel_9_analyzer_2_array_crystal_array_2, mctr1);
  rot_mul(mcrotachannel_9_analyzer_2_array_crystal_array_3, mctr1, mcrotrchannel_9_analyzer_2_array_crystal_array_3);
  mctc1 = coords_set(
#line 2607 "MACS_sample_kidney_box.instr"
    0 + channel_9_analyzer_2_array_effective_radius_of_curvature * ( 1 - cos ( channel_9_analyzer_2_array_theta [ 3 ] ) ),
#line 2607 "MACS_sample_kidney_box.instr"
    0 + channel_9_analyzer_2_array_effective_radius_of_curvature * sin ( channel_9_analyzer_2_array_theta [ 3 ] ),
#line 2607 "MACS_sample_kidney_box.instr"
    0);
#line 121892 "MACS_sample_kidney_box.c"
  rot_transpose(mcrotachannel_9_analyzer_2_rotated, mctr1);
  mctc2 = rot_apply(mctr1, mctc1);
  mcposachannel_9_analyzer_2_array_crystal_array_3 = coords_add(mcposachannel_9_analyzer_2_rotated, mctc2);
  mctc1 = coords_sub(mcposachannel_9_analyzer_2_array_crystal_array_2, mcposachannel_9_analyzer_2_array_crystal_array_3);
  mcposrchannel_9_analyzer_2_array_crystal_array_3 = rot_apply(mcrotachannel_9_analyzer_2_array_crystal_array_3, mctc1);
  mcDEBUG_COMPONENT("channel_9_analyzer_2_array_crystal_array_3", mcposachannel_9_analyzer_2_array_crystal_array_3, mcrotachannel_9_analyzer_2_array_crystal_array_3)
  mccomp_posa[486] = mcposachannel_9_analyzer_2_array_crystal_array_3;
  mccomp_posr[486] = mcposrchannel_9_analyzer_2_array_crystal_array_3;
  mcNCounter[486]  = mcPCounter[486] = mcP2Counter[486] = 0;
  mcAbsorbProp[486]= 0;
    /* Component channel_9_analyzer_2_array_crystal_array_4. */
  /* Setting parameters for component channel_9_analyzer_2_array_crystal_array_4. */
  SIG_MESSAGE("channel_9_analyzer_2_array_crystal_array_4 (Init:SetPar)");
#line 2612 "MACS_sample_kidney_box.instr"
  if("PG_analyzer") strncpy(mccchannel_9_analyzer_2_array_crystal_array_4_material_string, "PG_analyzer" ? "PG_analyzer" : "", 16384); else mccchannel_9_analyzer_2_array_crystal_array_4_material_string[0]='\0';
#line 2612 "MACS_sample_kidney_box.instr"
  mccchannel_9_analyzer_2_array_crystal_array_4_priority = 1121.4;
#line 2611 "MACS_sample_kidney_box.instr"
  mccchannel_9_analyzer_2_array_crystal_array_4_xwidth = channel_9_analyzer_2_array_crystal_depth;
#line 2611 "MACS_sample_kidney_box.instr"
  mccchannel_9_analyzer_2_array_crystal_array_4_yheight = channel_9_analyzer_2_array_crystal_height;
#line 2611 "MACS_sample_kidney_box.instr"
  mccchannel_9_analyzer_2_array_crystal_array_4_zdepth = channel_9_analyzer_2_array_crystal_width;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_9_analyzer_2_array_crystal_array_4_xwidth2 = -1;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_9_analyzer_2_array_crystal_array_4_yheight2 = -1;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_9_analyzer_2_array_crystal_array_4_visualize = 1;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_9_analyzer_2_array_crystal_array_4_target_index = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_9_analyzer_2_array_crystal_array_4_target_x = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_9_analyzer_2_array_crystal_array_4_target_y = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_9_analyzer_2_array_crystal_array_4_target_z = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_9_analyzer_2_array_crystal_array_4_focus_aw = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_9_analyzer_2_array_crystal_array_4_focus_ah = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_9_analyzer_2_array_crystal_array_4_focus_xw = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_9_analyzer_2_array_crystal_array_4_focus_xh = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_9_analyzer_2_array_crystal_array_4_focus_r = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_9_analyzer_2_array_crystal_array_4_p_interact = 0;
#line 71 "MACS_sample_kidney_box.instr"
  if(0) strncpy(mccchannel_9_analyzer_2_array_crystal_array_4_mask_string, 0 ? 0 : "", 16384); else mccchannel_9_analyzer_2_array_crystal_array_4_mask_string[0]='\0';
#line 71 "MACS_sample_kidney_box.instr"
  if(0) strncpy(mccchannel_9_analyzer_2_array_crystal_array_4_mask_setting, 0 ? 0 : "", 16384); else mccchannel_9_analyzer_2_array_crystal_array_4_mask_setting[0]='\0';
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_9_analyzer_2_array_crystal_array_4_number_of_activations = 1;
#line 121948 "MACS_sample_kidney_box.c"

  SIG_MESSAGE("channel_9_analyzer_2_array_crystal_array_4 (Init:Place/Rotate)");
  rot_set_rotation(mctr1,
#line 2614 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 2614 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 2614 "MACS_sample_kidney_box.instr"
    (0 - RAD2DEG * channel_9_analyzer_2_array_theta [ 4 ])*DEG2RAD);
#line 121958 "MACS_sample_kidney_box.c"
  rot_mul(mctr1, mcrotachannel_9_analyzer_2_rotated, mcrotachannel_9_analyzer_2_array_crystal_array_4);
  rot_transpose(mcrotachannel_9_analyzer_2_array_crystal_array_3, mctr1);
  rot_mul(mcrotachannel_9_analyzer_2_array_crystal_array_4, mctr1, mcrotrchannel_9_analyzer_2_array_crystal_array_4);
  mctc1 = coords_set(
#line 2613 "MACS_sample_kidney_box.instr"
    0 + channel_9_analyzer_2_array_effective_radius_of_curvature * ( 1 - cos ( channel_9_analyzer_2_array_theta [ 4 ] ) ),
#line 2613 "MACS_sample_kidney_box.instr"
    0 + channel_9_analyzer_2_array_effective_radius_of_curvature * sin ( channel_9_analyzer_2_array_theta [ 4 ] ),
#line 2613 "MACS_sample_kidney_box.instr"
    0);
#line 121969 "MACS_sample_kidney_box.c"
  rot_transpose(mcrotachannel_9_analyzer_2_rotated, mctr1);
  mctc2 = rot_apply(mctr1, mctc1);
  mcposachannel_9_analyzer_2_array_crystal_array_4 = coords_add(mcposachannel_9_analyzer_2_rotated, mctc2);
  mctc1 = coords_sub(mcposachannel_9_analyzer_2_array_crystal_array_3, mcposachannel_9_analyzer_2_array_crystal_array_4);
  mcposrchannel_9_analyzer_2_array_crystal_array_4 = rot_apply(mcrotachannel_9_analyzer_2_array_crystal_array_4, mctc1);
  mcDEBUG_COMPONENT("channel_9_analyzer_2_array_crystal_array_4", mcposachannel_9_analyzer_2_array_crystal_array_4, mcrotachannel_9_analyzer_2_array_crystal_array_4)
  mccomp_posa[487] = mcposachannel_9_analyzer_2_array_crystal_array_4;
  mccomp_posr[487] = mcposrchannel_9_analyzer_2_array_crystal_array_4;
  mcNCounter[487]  = mcPCounter[487] = mcP2Counter[487] = 0;
  mcAbsorbProp[487]= 0;
    /* Component channel_9_analyzer_2_array_crystal_array_5. */
  /* Setting parameters for component channel_9_analyzer_2_array_crystal_array_5. */
  SIG_MESSAGE("channel_9_analyzer_2_array_crystal_array_5 (Init:SetPar)");
#line 2618 "MACS_sample_kidney_box.instr"
  if("PG_analyzer") strncpy(mccchannel_9_analyzer_2_array_crystal_array_5_material_string, "PG_analyzer" ? "PG_analyzer" : "", 16384); else mccchannel_9_analyzer_2_array_crystal_array_5_material_string[0]='\0';
#line 2618 "MACS_sample_kidney_box.instr"
  mccchannel_9_analyzer_2_array_crystal_array_5_priority = 1121.5;
#line 2617 "MACS_sample_kidney_box.instr"
  mccchannel_9_analyzer_2_array_crystal_array_5_xwidth = channel_9_analyzer_2_array_crystal_depth;
#line 2617 "MACS_sample_kidney_box.instr"
  mccchannel_9_analyzer_2_array_crystal_array_5_yheight = channel_9_analyzer_2_array_crystal_height;
#line 2617 "MACS_sample_kidney_box.instr"
  mccchannel_9_analyzer_2_array_crystal_array_5_zdepth = channel_9_analyzer_2_array_crystal_width;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_9_analyzer_2_array_crystal_array_5_xwidth2 = -1;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_9_analyzer_2_array_crystal_array_5_yheight2 = -1;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_9_analyzer_2_array_crystal_array_5_visualize = 1;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_9_analyzer_2_array_crystal_array_5_target_index = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_9_analyzer_2_array_crystal_array_5_target_x = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_9_analyzer_2_array_crystal_array_5_target_y = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_9_analyzer_2_array_crystal_array_5_target_z = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_9_analyzer_2_array_crystal_array_5_focus_aw = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_9_analyzer_2_array_crystal_array_5_focus_ah = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_9_analyzer_2_array_crystal_array_5_focus_xw = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_9_analyzer_2_array_crystal_array_5_focus_xh = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_9_analyzer_2_array_crystal_array_5_focus_r = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_9_analyzer_2_array_crystal_array_5_p_interact = 0;
#line 71 "MACS_sample_kidney_box.instr"
  if(0) strncpy(mccchannel_9_analyzer_2_array_crystal_array_5_mask_string, 0 ? 0 : "", 16384); else mccchannel_9_analyzer_2_array_crystal_array_5_mask_string[0]='\0';
#line 71 "MACS_sample_kidney_box.instr"
  if(0) strncpy(mccchannel_9_analyzer_2_array_crystal_array_5_mask_setting, 0 ? 0 : "", 16384); else mccchannel_9_analyzer_2_array_crystal_array_5_mask_setting[0]='\0';
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_9_analyzer_2_array_crystal_array_5_number_of_activations = 1;
#line 122025 "MACS_sample_kidney_box.c"

  SIG_MESSAGE("channel_9_analyzer_2_array_crystal_array_5 (Init:Place/Rotate)");
  rot_set_rotation(mctr1,
#line 2620 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 2620 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 2620 "MACS_sample_kidney_box.instr"
    (0 - RAD2DEG * channel_9_analyzer_2_array_theta [ 5 ])*DEG2RAD);
#line 122035 "MACS_sample_kidney_box.c"
  rot_mul(mctr1, mcrotachannel_9_analyzer_2_rotated, mcrotachannel_9_analyzer_2_array_crystal_array_5);
  rot_transpose(mcrotachannel_9_analyzer_2_array_crystal_array_4, mctr1);
  rot_mul(mcrotachannel_9_analyzer_2_array_crystal_array_5, mctr1, mcrotrchannel_9_analyzer_2_array_crystal_array_5);
  mctc1 = coords_set(
#line 2619 "MACS_sample_kidney_box.instr"
    0 + channel_9_analyzer_2_array_effective_radius_of_curvature * ( 1 - cos ( channel_9_analyzer_2_array_theta [ 5 ] ) ),
#line 2619 "MACS_sample_kidney_box.instr"
    0 + channel_9_analyzer_2_array_effective_radius_of_curvature * sin ( channel_9_analyzer_2_array_theta [ 5 ] ),
#line 2619 "MACS_sample_kidney_box.instr"
    0);
#line 122046 "MACS_sample_kidney_box.c"
  rot_transpose(mcrotachannel_9_analyzer_2_rotated, mctr1);
  mctc2 = rot_apply(mctr1, mctc1);
  mcposachannel_9_analyzer_2_array_crystal_array_5 = coords_add(mcposachannel_9_analyzer_2_rotated, mctc2);
  mctc1 = coords_sub(mcposachannel_9_analyzer_2_array_crystal_array_4, mcposachannel_9_analyzer_2_array_crystal_array_5);
  mcposrchannel_9_analyzer_2_array_crystal_array_5 = rot_apply(mcrotachannel_9_analyzer_2_array_crystal_array_5, mctc1);
  mcDEBUG_COMPONENT("channel_9_analyzer_2_array_crystal_array_5", mcposachannel_9_analyzer_2_array_crystal_array_5, mcrotachannel_9_analyzer_2_array_crystal_array_5)
  mccomp_posa[488] = mcposachannel_9_analyzer_2_array_crystal_array_5;
  mccomp_posr[488] = mcposrchannel_9_analyzer_2_array_crystal_array_5;
  mcNCounter[488]  = mcPCounter[488] = mcP2Counter[488] = 0;
  mcAbsorbProp[488]= 0;
    /* Component channel_9_analyzer_2_array_crystal_array_6. */
  /* Setting parameters for component channel_9_analyzer_2_array_crystal_array_6. */
  SIG_MESSAGE("channel_9_analyzer_2_array_crystal_array_6 (Init:SetPar)");
#line 2624 "MACS_sample_kidney_box.instr"
  if("PG_analyzer") strncpy(mccchannel_9_analyzer_2_array_crystal_array_6_material_string, "PG_analyzer" ? "PG_analyzer" : "", 16384); else mccchannel_9_analyzer_2_array_crystal_array_6_material_string[0]='\0';
#line 2624 "MACS_sample_kidney_box.instr"
  mccchannel_9_analyzer_2_array_crystal_array_6_priority = 1121.6;
#line 2623 "MACS_sample_kidney_box.instr"
  mccchannel_9_analyzer_2_array_crystal_array_6_xwidth = channel_9_analyzer_2_array_crystal_depth;
#line 2623 "MACS_sample_kidney_box.instr"
  mccchannel_9_analyzer_2_array_crystal_array_6_yheight = channel_9_analyzer_2_array_crystal_height;
#line 2623 "MACS_sample_kidney_box.instr"
  mccchannel_9_analyzer_2_array_crystal_array_6_zdepth = channel_9_analyzer_2_array_crystal_width;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_9_analyzer_2_array_crystal_array_6_xwidth2 = -1;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_9_analyzer_2_array_crystal_array_6_yheight2 = -1;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_9_analyzer_2_array_crystal_array_6_visualize = 1;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_9_analyzer_2_array_crystal_array_6_target_index = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_9_analyzer_2_array_crystal_array_6_target_x = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_9_analyzer_2_array_crystal_array_6_target_y = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_9_analyzer_2_array_crystal_array_6_target_z = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_9_analyzer_2_array_crystal_array_6_focus_aw = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_9_analyzer_2_array_crystal_array_6_focus_ah = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_9_analyzer_2_array_crystal_array_6_focus_xw = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_9_analyzer_2_array_crystal_array_6_focus_xh = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_9_analyzer_2_array_crystal_array_6_focus_r = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_9_analyzer_2_array_crystal_array_6_p_interact = 0;
#line 71 "MACS_sample_kidney_box.instr"
  if(0) strncpy(mccchannel_9_analyzer_2_array_crystal_array_6_mask_string, 0 ? 0 : "", 16384); else mccchannel_9_analyzer_2_array_crystal_array_6_mask_string[0]='\0';
#line 71 "MACS_sample_kidney_box.instr"
  if(0) strncpy(mccchannel_9_analyzer_2_array_crystal_array_6_mask_setting, 0 ? 0 : "", 16384); else mccchannel_9_analyzer_2_array_crystal_array_6_mask_setting[0]='\0';
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_9_analyzer_2_array_crystal_array_6_number_of_activations = 1;
#line 122102 "MACS_sample_kidney_box.c"

  SIG_MESSAGE("channel_9_analyzer_2_array_crystal_array_6 (Init:Place/Rotate)");
  rot_set_rotation(mctr1,
#line 2626 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 2626 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 2626 "MACS_sample_kidney_box.instr"
    (0 - RAD2DEG * channel_9_analyzer_2_array_theta [ 6 ])*DEG2RAD);
#line 122112 "MACS_sample_kidney_box.c"
  rot_mul(mctr1, mcrotachannel_9_analyzer_2_rotated, mcrotachannel_9_analyzer_2_array_crystal_array_6);
  rot_transpose(mcrotachannel_9_analyzer_2_array_crystal_array_5, mctr1);
  rot_mul(mcrotachannel_9_analyzer_2_array_crystal_array_6, mctr1, mcrotrchannel_9_analyzer_2_array_crystal_array_6);
  mctc1 = coords_set(
#line 2625 "MACS_sample_kidney_box.instr"
    0 + channel_9_analyzer_2_array_effective_radius_of_curvature * ( 1 - cos ( channel_9_analyzer_2_array_theta [ 6 ] ) ),
#line 2625 "MACS_sample_kidney_box.instr"
    0 + channel_9_analyzer_2_array_effective_radius_of_curvature * sin ( channel_9_analyzer_2_array_theta [ 6 ] ),
#line 2625 "MACS_sample_kidney_box.instr"
    0);
#line 122123 "MACS_sample_kidney_box.c"
  rot_transpose(mcrotachannel_9_analyzer_2_rotated, mctr1);
  mctc2 = rot_apply(mctr1, mctc1);
  mcposachannel_9_analyzer_2_array_crystal_array_6 = coords_add(mcposachannel_9_analyzer_2_rotated, mctc2);
  mctc1 = coords_sub(mcposachannel_9_analyzer_2_array_crystal_array_5, mcposachannel_9_analyzer_2_array_crystal_array_6);
  mcposrchannel_9_analyzer_2_array_crystal_array_6 = rot_apply(mcrotachannel_9_analyzer_2_array_crystal_array_6, mctc1);
  mcDEBUG_COMPONENT("channel_9_analyzer_2_array_crystal_array_6", mcposachannel_9_analyzer_2_array_crystal_array_6, mcrotachannel_9_analyzer_2_array_crystal_array_6)
  mccomp_posa[489] = mcposachannel_9_analyzer_2_array_crystal_array_6;
  mccomp_posr[489] = mcposrchannel_9_analyzer_2_array_crystal_array_6;
  mcNCounter[489]  = mcPCounter[489] = mcP2Counter[489] = 0;
  mcAbsorbProp[489]= 0;
    /* Component channel_9_analyzer_2_array_crystal_array_7. */
  /* Setting parameters for component channel_9_analyzer_2_array_crystal_array_7. */
  SIG_MESSAGE("channel_9_analyzer_2_array_crystal_array_7 (Init:SetPar)");
#line 2630 "MACS_sample_kidney_box.instr"
  if("PG_analyzer") strncpy(mccchannel_9_analyzer_2_array_crystal_array_7_material_string, "PG_analyzer" ? "PG_analyzer" : "", 16384); else mccchannel_9_analyzer_2_array_crystal_array_7_material_string[0]='\0';
#line 2630 "MACS_sample_kidney_box.instr"
  mccchannel_9_analyzer_2_array_crystal_array_7_priority = 1121.7;
#line 2629 "MACS_sample_kidney_box.instr"
  mccchannel_9_analyzer_2_array_crystal_array_7_xwidth = channel_9_analyzer_2_array_crystal_depth;
#line 2629 "MACS_sample_kidney_box.instr"
  mccchannel_9_analyzer_2_array_crystal_array_7_yheight = channel_9_analyzer_2_array_crystal_height;
#line 2629 "MACS_sample_kidney_box.instr"
  mccchannel_9_analyzer_2_array_crystal_array_7_zdepth = channel_9_analyzer_2_array_crystal_width;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_9_analyzer_2_array_crystal_array_7_xwidth2 = -1;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_9_analyzer_2_array_crystal_array_7_yheight2 = -1;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_9_analyzer_2_array_crystal_array_7_visualize = 1;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_9_analyzer_2_array_crystal_array_7_target_index = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_9_analyzer_2_array_crystal_array_7_target_x = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_9_analyzer_2_array_crystal_array_7_target_y = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_9_analyzer_2_array_crystal_array_7_target_z = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_9_analyzer_2_array_crystal_array_7_focus_aw = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_9_analyzer_2_array_crystal_array_7_focus_ah = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_9_analyzer_2_array_crystal_array_7_focus_xw = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_9_analyzer_2_array_crystal_array_7_focus_xh = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_9_analyzer_2_array_crystal_array_7_focus_r = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_9_analyzer_2_array_crystal_array_7_p_interact = 0;
#line 71 "MACS_sample_kidney_box.instr"
  if(0) strncpy(mccchannel_9_analyzer_2_array_crystal_array_7_mask_string, 0 ? 0 : "", 16384); else mccchannel_9_analyzer_2_array_crystal_array_7_mask_string[0]='\0';
#line 71 "MACS_sample_kidney_box.instr"
  if(0) strncpy(mccchannel_9_analyzer_2_array_crystal_array_7_mask_setting, 0 ? 0 : "", 16384); else mccchannel_9_analyzer_2_array_crystal_array_7_mask_setting[0]='\0';
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_9_analyzer_2_array_crystal_array_7_number_of_activations = 1;
#line 122179 "MACS_sample_kidney_box.c"

  SIG_MESSAGE("channel_9_analyzer_2_array_crystal_array_7 (Init:Place/Rotate)");
  rot_set_rotation(mctr1,
#line 2632 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 2632 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 2632 "MACS_sample_kidney_box.instr"
    (0 - RAD2DEG * channel_9_analyzer_2_array_theta [ 7 ])*DEG2RAD);
#line 122189 "MACS_sample_kidney_box.c"
  rot_mul(mctr1, mcrotachannel_9_analyzer_2_rotated, mcrotachannel_9_analyzer_2_array_crystal_array_7);
  rot_transpose(mcrotachannel_9_analyzer_2_array_crystal_array_6, mctr1);
  rot_mul(mcrotachannel_9_analyzer_2_array_crystal_array_7, mctr1, mcrotrchannel_9_analyzer_2_array_crystal_array_7);
  mctc1 = coords_set(
#line 2631 "MACS_sample_kidney_box.instr"
    0 + channel_9_analyzer_2_array_effective_radius_of_curvature * ( 1 - cos ( channel_9_analyzer_2_array_theta [ 7 ] ) ),
#line 2631 "MACS_sample_kidney_box.instr"
    0 + channel_9_analyzer_2_array_effective_radius_of_curvature * sin ( channel_9_analyzer_2_array_theta [ 7 ] ),
#line 2631 "MACS_sample_kidney_box.instr"
    0);
#line 122200 "MACS_sample_kidney_box.c"
  rot_transpose(mcrotachannel_9_analyzer_2_rotated, mctr1);
  mctc2 = rot_apply(mctr1, mctc1);
  mcposachannel_9_analyzer_2_array_crystal_array_7 = coords_add(mcposachannel_9_analyzer_2_rotated, mctc2);
  mctc1 = coords_sub(mcposachannel_9_analyzer_2_array_crystal_array_6, mcposachannel_9_analyzer_2_array_crystal_array_7);
  mcposrchannel_9_analyzer_2_array_crystal_array_7 = rot_apply(mcrotachannel_9_analyzer_2_array_crystal_array_7, mctc1);
  mcDEBUG_COMPONENT("channel_9_analyzer_2_array_crystal_array_7", mcposachannel_9_analyzer_2_array_crystal_array_7, mcrotachannel_9_analyzer_2_array_crystal_array_7)
  mccomp_posa[490] = mcposachannel_9_analyzer_2_array_crystal_array_7;
  mccomp_posr[490] = mcposrchannel_9_analyzer_2_array_crystal_array_7;
  mcNCounter[490]  = mcPCounter[490] = mcP2Counter[490] = 0;
  mcAbsorbProp[490]= 0;
    /* Component channel_9_analyzer_2_array_crystal_array_8. */
  /* Setting parameters for component channel_9_analyzer_2_array_crystal_array_8. */
  SIG_MESSAGE("channel_9_analyzer_2_array_crystal_array_8 (Init:SetPar)");
#line 2636 "MACS_sample_kidney_box.instr"
  if("PG_analyzer") strncpy(mccchannel_9_analyzer_2_array_crystal_array_8_material_string, "PG_analyzer" ? "PG_analyzer" : "", 16384); else mccchannel_9_analyzer_2_array_crystal_array_8_material_string[0]='\0';
#line 2636 "MACS_sample_kidney_box.instr"
  mccchannel_9_analyzer_2_array_crystal_array_8_priority = 1121.8;
#line 2635 "MACS_sample_kidney_box.instr"
  mccchannel_9_analyzer_2_array_crystal_array_8_xwidth = channel_9_analyzer_2_array_crystal_depth;
#line 2635 "MACS_sample_kidney_box.instr"
  mccchannel_9_analyzer_2_array_crystal_array_8_yheight = channel_9_analyzer_2_array_crystal_height;
#line 2635 "MACS_sample_kidney_box.instr"
  mccchannel_9_analyzer_2_array_crystal_array_8_zdepth = channel_9_analyzer_2_array_crystal_width;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_9_analyzer_2_array_crystal_array_8_xwidth2 = -1;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_9_analyzer_2_array_crystal_array_8_yheight2 = -1;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_9_analyzer_2_array_crystal_array_8_visualize = 1;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_9_analyzer_2_array_crystal_array_8_target_index = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_9_analyzer_2_array_crystal_array_8_target_x = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_9_analyzer_2_array_crystal_array_8_target_y = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_9_analyzer_2_array_crystal_array_8_target_z = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_9_analyzer_2_array_crystal_array_8_focus_aw = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_9_analyzer_2_array_crystal_array_8_focus_ah = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_9_analyzer_2_array_crystal_array_8_focus_xw = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_9_analyzer_2_array_crystal_array_8_focus_xh = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_9_analyzer_2_array_crystal_array_8_focus_r = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_9_analyzer_2_array_crystal_array_8_p_interact = 0;
#line 71 "MACS_sample_kidney_box.instr"
  if(0) strncpy(mccchannel_9_analyzer_2_array_crystal_array_8_mask_string, 0 ? 0 : "", 16384); else mccchannel_9_analyzer_2_array_crystal_array_8_mask_string[0]='\0';
#line 71 "MACS_sample_kidney_box.instr"
  if(0) strncpy(mccchannel_9_analyzer_2_array_crystal_array_8_mask_setting, 0 ? 0 : "", 16384); else mccchannel_9_analyzer_2_array_crystal_array_8_mask_setting[0]='\0';
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_9_analyzer_2_array_crystal_array_8_number_of_activations = 1;
#line 122256 "MACS_sample_kidney_box.c"

  SIG_MESSAGE("channel_9_analyzer_2_array_crystal_array_8 (Init:Place/Rotate)");
  rot_set_rotation(mctr1,
#line 2638 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 2638 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 2638 "MACS_sample_kidney_box.instr"
    (0 - RAD2DEG * channel_9_analyzer_2_array_theta [ 8 ])*DEG2RAD);
#line 122266 "MACS_sample_kidney_box.c"
  rot_mul(mctr1, mcrotachannel_9_analyzer_2_rotated, mcrotachannel_9_analyzer_2_array_crystal_array_8);
  rot_transpose(mcrotachannel_9_analyzer_2_array_crystal_array_7, mctr1);
  rot_mul(mcrotachannel_9_analyzer_2_array_crystal_array_8, mctr1, mcrotrchannel_9_analyzer_2_array_crystal_array_8);
  mctc1 = coords_set(
#line 2637 "MACS_sample_kidney_box.instr"
    0 + channel_9_analyzer_2_array_effective_radius_of_curvature * ( 1 - cos ( channel_9_analyzer_2_array_theta [ 8 ] ) ),
#line 2637 "MACS_sample_kidney_box.instr"
    0 + channel_9_analyzer_2_array_effective_radius_of_curvature * sin ( channel_9_analyzer_2_array_theta [ 8 ] ),
#line 2637 "MACS_sample_kidney_box.instr"
    0);
#line 122277 "MACS_sample_kidney_box.c"
  rot_transpose(mcrotachannel_9_analyzer_2_rotated, mctr1);
  mctc2 = rot_apply(mctr1, mctc1);
  mcposachannel_9_analyzer_2_array_crystal_array_8 = coords_add(mcposachannel_9_analyzer_2_rotated, mctc2);
  mctc1 = coords_sub(mcposachannel_9_analyzer_2_array_crystal_array_7, mcposachannel_9_analyzer_2_array_crystal_array_8);
  mcposrchannel_9_analyzer_2_array_crystal_array_8 = rot_apply(mcrotachannel_9_analyzer_2_array_crystal_array_8, mctc1);
  mcDEBUG_COMPONENT("channel_9_analyzer_2_array_crystal_array_8", mcposachannel_9_analyzer_2_array_crystal_array_8, mcrotachannel_9_analyzer_2_array_crystal_array_8)
  mccomp_posa[491] = mcposachannel_9_analyzer_2_array_crystal_array_8;
  mccomp_posr[491] = mcposrchannel_9_analyzer_2_array_crystal_array_8;
  mcNCounter[491]  = mcPCounter[491] = mcP2Counter[491] = 0;
  mcAbsorbProp[491]= 0;
    /* Component channel_9_cave2_cyl1. */
  /* Setting parameters for component channel_9_cave2_cyl1. */
  SIG_MESSAGE("channel_9_cave2_cyl1 (Init:SetPar)");
#line 2643 "MACS_sample_kidney_box.instr"
  if("Vacuum") strncpy(mccchannel_9_cave2_cyl1_material_string, "Vacuum" ? "Vacuum" : "", 16384); else mccchannel_9_cave2_cyl1_material_string[0]='\0';
#line 2643 "MACS_sample_kidney_box.instr"
  mccchannel_9_cave2_cyl1_priority = 1107.5;
#line 2642 "MACS_sample_kidney_box.instr"
  mccchannel_9_cave2_cyl1_radius = kidney_cave2_cyl1_radius;
#line 2642 "MACS_sample_kidney_box.instr"
  mccchannel_9_cave2_cyl1_yheight = kidney_cave2_cyl1_height;
#line 67 "MACS_sample_kidney_box.instr"
  mccchannel_9_cave2_cyl1_visualize = 1;
#line 67 "MACS_sample_kidney_box.instr"
  mccchannel_9_cave2_cyl1_target_index = 0;
#line 67 "MACS_sample_kidney_box.instr"
  mccchannel_9_cave2_cyl1_target_x = 0;
#line 67 "MACS_sample_kidney_box.instr"
  mccchannel_9_cave2_cyl1_target_y = 0;
#line 67 "MACS_sample_kidney_box.instr"
  mccchannel_9_cave2_cyl1_target_z = 0;
#line 67 "MACS_sample_kidney_box.instr"
  mccchannel_9_cave2_cyl1_focus_aw = 0;
#line 67 "MACS_sample_kidney_box.instr"
  mccchannel_9_cave2_cyl1_focus_ah = 0;
#line 67 "MACS_sample_kidney_box.instr"
  mccchannel_9_cave2_cyl1_focus_xw = 0;
#line 67 "MACS_sample_kidney_box.instr"
  mccchannel_9_cave2_cyl1_focus_xh = 0;
#line 67 "MACS_sample_kidney_box.instr"
  mccchannel_9_cave2_cyl1_focus_r = 0;
#line 67 "MACS_sample_kidney_box.instr"
  mccchannel_9_cave2_cyl1_p_interact = 0;
#line 67 "MACS_sample_kidney_box.instr"
  if(0) strncpy(mccchannel_9_cave2_cyl1_mask_string, 0 ? 0 : "", 16384); else mccchannel_9_cave2_cyl1_mask_string[0]='\0';
#line 67 "MACS_sample_kidney_box.instr"
  if(0) strncpy(mccchannel_9_cave2_cyl1_mask_setting, 0 ? 0 : "", 16384); else mccchannel_9_cave2_cyl1_mask_setting[0]='\0';
#line 67 "MACS_sample_kidney_box.instr"
  mccchannel_9_cave2_cyl1_number_of_activations = 1;
#line 122327 "MACS_sample_kidney_box.c"

  SIG_MESSAGE("channel_9_cave2_cyl1 (Init:Place/Rotate)");
  rot_set_rotation(mctr1,
#line 2645 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 2645 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 2645 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD);
#line 122337 "MACS_sample_kidney_box.c"
  rot_mul(mctr1, mcrotachannel_9_analyzer_2_center, mcrotachannel_9_cave2_cyl1);
  rot_transpose(mcrotachannel_9_analyzer_2_array_crystal_array_8, mctr1);
  rot_mul(mcrotachannel_9_cave2_cyl1, mctr1, mcrotrchannel_9_cave2_cyl1);
  mctc1 = coords_set(
#line 2644 "MACS_sample_kidney_box.instr"
    0,
#line 2644 "MACS_sample_kidney_box.instr"
    0,
#line 2644 "MACS_sample_kidney_box.instr"
    spec_detector_to_analyzer_2_center);
#line 122348 "MACS_sample_kidney_box.c"
  rot_transpose(mcrotachannel_9_analyzer_2_center, mctr1);
  mctc2 = rot_apply(mctr1, mctc1);
  mcposachannel_9_cave2_cyl1 = coords_add(mcposachannel_9_analyzer_2_center, mctc2);
  mctc1 = coords_sub(mcposachannel_9_analyzer_2_array_crystal_array_8, mcposachannel_9_cave2_cyl1);
  mcposrchannel_9_cave2_cyl1 = rot_apply(mcrotachannel_9_cave2_cyl1, mctc1);
  mcDEBUG_COMPONENT("channel_9_cave2_cyl1", mcposachannel_9_cave2_cyl1, mcrotachannel_9_cave2_cyl1)
  mccomp_posa[492] = mcposachannel_9_cave2_cyl1;
  mccomp_posr[492] = mcposrchannel_9_cave2_cyl1;
  mcNCounter[492]  = mcPCounter[492] = mcP2Counter[492] = 0;
  mcAbsorbProp[492]= 0;
    /* Component channel_9_cave2_box1. */
  /* Setting parameters for component channel_9_cave2_box1. */
  SIG_MESSAGE("channel_9_cave2_box1 (Init:SetPar)");
#line 2650 "MACS_sample_kidney_box.instr"
  if("Vacuum") strncpy(mccchannel_9_cave2_box1_material_string, "Vacuum" ? "Vacuum" : "", 16384); else mccchannel_9_cave2_box1_material_string[0]='\0';
#line 2650 "MACS_sample_kidney_box.instr"
  mccchannel_9_cave2_box1_priority = 1101;
#line 2648 "MACS_sample_kidney_box.instr"
  mccchannel_9_cave2_box1_xwidth = kidney_cave2_box1_width1;
#line 2648 "MACS_sample_kidney_box.instr"
  mccchannel_9_cave2_box1_yheight = kidney_cave2_box1_height1;
#line 2648 "MACS_sample_kidney_box.instr"
  mccchannel_9_cave2_box1_zdepth = kidney_cave2_box1_depth;
#line 2649 "MACS_sample_kidney_box.instr"
  mccchannel_9_cave2_box1_xwidth2 = kidney_cave2_box1_width2;
#line 2649 "MACS_sample_kidney_box.instr"
  mccchannel_9_cave2_box1_yheight2 = kidney_cave2_box1_height2;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_9_cave2_box1_visualize = 1;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_9_cave2_box1_target_index = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_9_cave2_box1_target_x = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_9_cave2_box1_target_y = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_9_cave2_box1_target_z = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_9_cave2_box1_focus_aw = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_9_cave2_box1_focus_ah = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_9_cave2_box1_focus_xw = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_9_cave2_box1_focus_xh = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_9_cave2_box1_focus_r = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_9_cave2_box1_p_interact = 0;
#line 71 "MACS_sample_kidney_box.instr"
  if(0) strncpy(mccchannel_9_cave2_box1_mask_string, 0 ? 0 : "", 16384); else mccchannel_9_cave2_box1_mask_string[0]='\0';
#line 71 "MACS_sample_kidney_box.instr"
  if(0) strncpy(mccchannel_9_cave2_box1_mask_setting, 0 ? 0 : "", 16384); else mccchannel_9_cave2_box1_mask_setting[0]='\0';
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_9_cave2_box1_number_of_activations = 1;
#line 122404 "MACS_sample_kidney_box.c"

  SIG_MESSAGE("channel_9_cave2_box1 (Init:Place/Rotate)");
  rot_set_rotation(mctr1,
#line 2652 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 2652 "MACS_sample_kidney_box.instr"
    (kidney_cave2_box1_y_rotation)*DEG2RAD,
#line 2652 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD);
#line 122414 "MACS_sample_kidney_box.c"
  rot_mul(mctr1, mcrotachannel_9_cave2_cyl1, mcrotachannel_9_cave2_box1);
  rot_transpose(mcrotachannel_9_cave2_cyl1, mctr1);
  rot_mul(mcrotachannel_9_cave2_box1, mctr1, mcrotrchannel_9_cave2_box1);
  mctc1 = coords_set(
#line 2651 "MACS_sample_kidney_box.instr"
    kidney_cave2_box1_center_to_spec_detector_x,
#line 2651 "MACS_sample_kidney_box.instr"
    0,
#line 2651 "MACS_sample_kidney_box.instr"
    kidney_cave2_box1_center_to_spec_detector_z);
#line 122425 "MACS_sample_kidney_box.c"
  rot_transpose(mcrotachannel_9_cave2_cyl1, mctr1);
  mctc2 = rot_apply(mctr1, mctc1);
  mcposachannel_9_cave2_box1 = coords_add(mcposachannel_9_cave2_cyl1, mctc2);
  mctc1 = coords_sub(mcposachannel_9_cave2_cyl1, mcposachannel_9_cave2_box1);
  mcposrchannel_9_cave2_box1 = rot_apply(mcrotachannel_9_cave2_box1, mctc1);
  mcDEBUG_COMPONENT("channel_9_cave2_box1", mcposachannel_9_cave2_box1, mcrotachannel_9_cave2_box1)
  mccomp_posa[493] = mcposachannel_9_cave2_box1;
  mccomp_posr[493] = mcposrchannel_9_cave2_box1;
  mcNCounter[493]  = mcPCounter[493] = mcP2Counter[493] = 0;
  mcAbsorbProp[493]= 0;
    /* Component channel_9_cave2_box2. */
  /* Setting parameters for component channel_9_cave2_box2. */
  SIG_MESSAGE("channel_9_cave2_box2 (Init:SetPar)");
#line 2657 "MACS_sample_kidney_box.instr"
  if("Vacuum") strncpy(mccchannel_9_cave2_box2_material_string, "Vacuum" ? "Vacuum" : "", 16384); else mccchannel_9_cave2_box2_material_string[0]='\0';
#line 2657 "MACS_sample_kidney_box.instr"
  mccchannel_9_cave2_box2_priority = 1106;
#line 2655 "MACS_sample_kidney_box.instr"
  mccchannel_9_cave2_box2_xwidth = kidney_cave2_box2_width1;
#line 2655 "MACS_sample_kidney_box.instr"
  mccchannel_9_cave2_box2_yheight = kidney_cave2_box2_height1;
#line 2655 "MACS_sample_kidney_box.instr"
  mccchannel_9_cave2_box2_zdepth = kidney_cave2_box2_depth;
#line 2656 "MACS_sample_kidney_box.instr"
  mccchannel_9_cave2_box2_xwidth2 = kidney_cave2_box2_width2;
#line 2656 "MACS_sample_kidney_box.instr"
  mccchannel_9_cave2_box2_yheight2 = kidney_cave2_box2_height2;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_9_cave2_box2_visualize = 1;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_9_cave2_box2_target_index = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_9_cave2_box2_target_x = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_9_cave2_box2_target_y = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_9_cave2_box2_target_z = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_9_cave2_box2_focus_aw = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_9_cave2_box2_focus_ah = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_9_cave2_box2_focus_xw = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_9_cave2_box2_focus_xh = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_9_cave2_box2_focus_r = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_9_cave2_box2_p_interact = 0;
#line 71 "MACS_sample_kidney_box.instr"
  if(0) strncpy(mccchannel_9_cave2_box2_mask_string, 0 ? 0 : "", 16384); else mccchannel_9_cave2_box2_mask_string[0]='\0';
#line 71 "MACS_sample_kidney_box.instr"
  if(0) strncpy(mccchannel_9_cave2_box2_mask_setting, 0 ? 0 : "", 16384); else mccchannel_9_cave2_box2_mask_setting[0]='\0';
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_9_cave2_box2_number_of_activations = 1;
#line 122481 "MACS_sample_kidney_box.c"

  SIG_MESSAGE("channel_9_cave2_box2 (Init:Place/Rotate)");
  rot_set_rotation(mctr1,
#line 2659 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 2659 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 2659 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD);
#line 122491 "MACS_sample_kidney_box.c"
  rot_mul(mctr1, mcrotachannel_9_cave2_cyl1, mcrotachannel_9_cave2_box2);
  rot_transpose(mcrotachannel_9_cave2_box1, mctr1);
  rot_mul(mcrotachannel_9_cave2_box2, mctr1, mcrotrchannel_9_cave2_box2);
  mctc1 = coords_set(
#line 2658 "MACS_sample_kidney_box.instr"
    0,
#line 2658 "MACS_sample_kidney_box.instr"
    0,
#line 2658 "MACS_sample_kidney_box.instr"
    kidney_cave2_box2_center_to_detector);
#line 122502 "MACS_sample_kidney_box.c"
  rot_transpose(mcrotachannel_9_cave2_cyl1, mctr1);
  mctc2 = rot_apply(mctr1, mctc1);
  mcposachannel_9_cave2_box2 = coords_add(mcposachannel_9_cave2_cyl1, mctc2);
  mctc1 = coords_sub(mcposachannel_9_cave2_box1, mcposachannel_9_cave2_box2);
  mcposrchannel_9_cave2_box2 = rot_apply(mcrotachannel_9_cave2_box2, mctc1);
  mcDEBUG_COMPONENT("channel_9_cave2_box2", mcposachannel_9_cave2_box2, mcrotachannel_9_cave2_box2)
  mccomp_posa[494] = mcposachannel_9_cave2_box2;
  mccomp_posr[494] = mcposrchannel_9_cave2_box2;
  mcNCounter[494]  = mcPCounter[494] = mcP2Counter[494] = 0;
  mcAbsorbProp[494]= 0;
    /* Component channel_9_cave2_box3. */
  /* Setting parameters for component channel_9_cave2_box3. */
  SIG_MESSAGE("channel_9_cave2_box3 (Init:SetPar)");
#line 2664 "MACS_sample_kidney_box.instr"
  if("Vacuum") strncpy(mccchannel_9_cave2_box3_material_string, "Vacuum" ? "Vacuum" : "", 16384); else mccchannel_9_cave2_box3_material_string[0]='\0';
#line 2664 "MACS_sample_kidney_box.instr"
  mccchannel_9_cave2_box3_priority = 1107;
#line 2662 "MACS_sample_kidney_box.instr"
  mccchannel_9_cave2_box3_xwidth = kidney_cave2_box3_width1;
#line 2662 "MACS_sample_kidney_box.instr"
  mccchannel_9_cave2_box3_yheight = kidney_cave2_box3_height1;
#line 2662 "MACS_sample_kidney_box.instr"
  mccchannel_9_cave2_box3_zdepth = kidney_cave2_box3_depth;
#line 2663 "MACS_sample_kidney_box.instr"
  mccchannel_9_cave2_box3_xwidth2 = kidney_cave2_box3_width2;
#line 2663 "MACS_sample_kidney_box.instr"
  mccchannel_9_cave2_box3_yheight2 = kidney_cave2_box3_height2;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_9_cave2_box3_visualize = 1;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_9_cave2_box3_target_index = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_9_cave2_box3_target_x = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_9_cave2_box3_target_y = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_9_cave2_box3_target_z = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_9_cave2_box3_focus_aw = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_9_cave2_box3_focus_ah = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_9_cave2_box3_focus_xw = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_9_cave2_box3_focus_xh = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_9_cave2_box3_focus_r = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_9_cave2_box3_p_interact = 0;
#line 71 "MACS_sample_kidney_box.instr"
  if(0) strncpy(mccchannel_9_cave2_box3_mask_string, 0 ? 0 : "", 16384); else mccchannel_9_cave2_box3_mask_string[0]='\0';
#line 71 "MACS_sample_kidney_box.instr"
  if(0) strncpy(mccchannel_9_cave2_box3_mask_setting, 0 ? 0 : "", 16384); else mccchannel_9_cave2_box3_mask_setting[0]='\0';
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_9_cave2_box3_number_of_activations = 1;
#line 122558 "MACS_sample_kidney_box.c"

  SIG_MESSAGE("channel_9_cave2_box3 (Init:Place/Rotate)");
  rot_set_rotation(mctr1,
#line 2666 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 2666 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 2666 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD);
#line 122568 "MACS_sample_kidney_box.c"
  rot_mul(mctr1, mcrotachannel_9_cave2_cyl1, mcrotachannel_9_cave2_box3);
  rot_transpose(mcrotachannel_9_cave2_box2, mctr1);
  rot_mul(mcrotachannel_9_cave2_box3, mctr1, mcrotrchannel_9_cave2_box3);
  mctc1 = coords_set(
#line 2665 "MACS_sample_kidney_box.instr"
    0,
#line 2665 "MACS_sample_kidney_box.instr"
    0,
#line 2665 "MACS_sample_kidney_box.instr"
    kidney_cave2_box3_center_to_detector);
#line 122579 "MACS_sample_kidney_box.c"
  rot_transpose(mcrotachannel_9_cave2_cyl1, mctr1);
  mctc2 = rot_apply(mctr1, mctc1);
  mcposachannel_9_cave2_box3 = coords_add(mcposachannel_9_cave2_cyl1, mctc2);
  mctc1 = coords_sub(mcposachannel_9_cave2_box2, mcposachannel_9_cave2_box3);
  mcposrchannel_9_cave2_box3 = rot_apply(mcrotachannel_9_cave2_box3, mctc1);
  mcDEBUG_COMPONENT("channel_9_cave2_box3", mcposachannel_9_cave2_box3, mcrotachannel_9_cave2_box3)
  mccomp_posa[495] = mcposachannel_9_cave2_box3;
  mccomp_posr[495] = mcposrchannel_9_cave2_box3;
  mcNCounter[495]  = mcPCounter[495] = mcP2Counter[495] = 0;
  mcAbsorbProp[495]= 0;
    /* Component inter_analyzer_colimator_center_9. */
  /* Setting parameters for component inter_analyzer_colimator_center_9. */
  SIG_MESSAGE("inter_analyzer_colimator_center_9 (Init:SetPar)");

  SIG_MESSAGE("inter_analyzer_colimator_center_9 (Init:Place/Rotate)");
  rot_set_rotation(mctr1,
#line 2670 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 2670 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 2670 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD);
#line 122602 "MACS_sample_kidney_box.c"
  rot_mul(mctr1, mcrotachannel_9_analyzer_1_center, mcrotainter_analyzer_colimator_center_9);
  rot_transpose(mcrotachannel_9_cave2_box3, mctr1);
  rot_mul(mcrotainter_analyzer_colimator_center_9, mctr1, mcrotrinter_analyzer_colimator_center_9);
  mctc1 = coords_set(
#line 2669 "MACS_sample_kidney_box.instr"
    -0.5 * analyzer_seperation,
#line 2669 "MACS_sample_kidney_box.instr"
    0,
#line 2669 "MACS_sample_kidney_box.instr"
    0);
#line 122613 "MACS_sample_kidney_box.c"
  rot_transpose(mcrotachannel_9_analyzer_1_center, mctr1);
  mctc2 = rot_apply(mctr1, mctc1);
  mcposainter_analyzer_colimator_center_9 = coords_add(mcposachannel_9_analyzer_1_center, mctc2);
  mctc1 = coords_sub(mcposachannel_9_cave2_box3, mcposainter_analyzer_colimator_center_9);
  mcposrinter_analyzer_colimator_center_9 = rot_apply(mcrotainter_analyzer_colimator_center_9, mctc1);
  mcDEBUG_COMPONENT("inter_analyzer_colimator_center_9", mcposainter_analyzer_colimator_center_9, mcrotainter_analyzer_colimator_center_9)
  mccomp_posa[496] = mcposainter_analyzer_colimator_center_9;
  mccomp_posr[496] = mcposrinter_analyzer_colimator_center_9;
  mcNCounter[496]  = mcPCounter[496] = mcP2Counter[496] = 0;
  mcAbsorbProp[496]= 0;
    /* Component inter_analyzer_colimator_9_blade_0. */
  /* Setting parameters for component inter_analyzer_colimator_9_blade_0. */
  SIG_MESSAGE("inter_analyzer_colimator_9_blade_0 (Init:SetPar)");
#line 2674 "MACS_sample_kidney_box.instr"
  if("Collimator_gad") strncpy(mccinter_analyzer_colimator_9_blade_0_material_string, "Collimator_gad" ? "Collimator_gad" : "", 16384); else mccinter_analyzer_colimator_9_blade_0_material_string[0]='\0';
#line 2674 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_9_blade_0_priority = 1125;
#line 2673 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_9_blade_0_xwidth = inter_analyzer_colimator_width;
#line 2673 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_9_blade_0_yheight = inter_analyzer_colimator_height;
#line 2673 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_9_blade_0_zdepth = inter_analyzer_colimator_depth;
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_9_blade_0_xwidth2 = -1;
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_9_blade_0_yheight2 = -1;
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_9_blade_0_visualize = 1;
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_9_blade_0_target_index = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_9_blade_0_target_x = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_9_blade_0_target_y = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_9_blade_0_target_z = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_9_blade_0_focus_aw = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_9_blade_0_focus_ah = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_9_blade_0_focus_xw = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_9_blade_0_focus_xh = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_9_blade_0_focus_r = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_9_blade_0_p_interact = 0;
#line 71 "MACS_sample_kidney_box.instr"
  if(0) strncpy(mccinter_analyzer_colimator_9_blade_0_mask_string, 0 ? 0 : "", 16384); else mccinter_analyzer_colimator_9_blade_0_mask_string[0]='\0';
#line 71 "MACS_sample_kidney_box.instr"
  if(0) strncpy(mccinter_analyzer_colimator_9_blade_0_mask_setting, 0 ? 0 : "", 16384); else mccinter_analyzer_colimator_9_blade_0_mask_setting[0]='\0';
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_9_blade_0_number_of_activations = 1;
#line 122669 "MACS_sample_kidney_box.c"

  SIG_MESSAGE("inter_analyzer_colimator_9_blade_0 (Init:Place/Rotate)");
  rot_set_rotation(mctr1,
#line 2676 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 2676 "MACS_sample_kidney_box.instr"
    (- analyzer_2theta [ 9 ])*DEG2RAD,
#line 2676 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD);
#line 122679 "MACS_sample_kidney_box.c"
  rot_mul(mctr1, mcrotainter_analyzer_colimator_center_9, mcrotainter_analyzer_colimator_9_blade_0);
  rot_transpose(mcrotainter_analyzer_colimator_center_9, mctr1);
  rot_mul(mcrotainter_analyzer_colimator_9_blade_0, mctr1, mcrotrinter_analyzer_colimator_9_blade_0);
  mctc1 = coords_set(
#line 2675 "MACS_sample_kidney_box.instr"
    0,
#line 2675 "MACS_sample_kidney_box.instr"
    0,
#line 2675 "MACS_sample_kidney_box.instr"
    inter_analyzer_colimator_start_pos - 0 * inter_analyzer_colimator_seperation);
#line 122690 "MACS_sample_kidney_box.c"
  rot_transpose(mcrotainter_analyzer_colimator_center_9, mctr1);
  mctc2 = rot_apply(mctr1, mctc1);
  mcposainter_analyzer_colimator_9_blade_0 = coords_add(mcposainter_analyzer_colimator_center_9, mctc2);
  mctc1 = coords_sub(mcposainter_analyzer_colimator_center_9, mcposainter_analyzer_colimator_9_blade_0);
  mcposrinter_analyzer_colimator_9_blade_0 = rot_apply(mcrotainter_analyzer_colimator_9_blade_0, mctc1);
  mcDEBUG_COMPONENT("inter_analyzer_colimator_9_blade_0", mcposainter_analyzer_colimator_9_blade_0, mcrotainter_analyzer_colimator_9_blade_0)
  mccomp_posa[497] = mcposainter_analyzer_colimator_9_blade_0;
  mccomp_posr[497] = mcposrinter_analyzer_colimator_9_blade_0;
  mcNCounter[497]  = mcPCounter[497] = mcP2Counter[497] = 0;
  mcAbsorbProp[497]= 0;
    /* Component inter_analyzer_colimator_9_blade_1. */
  /* Setting parameters for component inter_analyzer_colimator_9_blade_1. */
  SIG_MESSAGE("inter_analyzer_colimator_9_blade_1 (Init:SetPar)");
#line 2680 "MACS_sample_kidney_box.instr"
  if("Collimator_gad") strncpy(mccinter_analyzer_colimator_9_blade_1_material_string, "Collimator_gad" ? "Collimator_gad" : "", 16384); else mccinter_analyzer_colimator_9_blade_1_material_string[0]='\0';
#line 2680 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_9_blade_1_priority = 1126;
#line 2679 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_9_blade_1_xwidth = inter_analyzer_colimator_width;
#line 2679 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_9_blade_1_yheight = inter_analyzer_colimator_height;
#line 2679 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_9_blade_1_zdepth = inter_analyzer_colimator_depth;
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_9_blade_1_xwidth2 = -1;
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_9_blade_1_yheight2 = -1;
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_9_blade_1_visualize = 1;
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_9_blade_1_target_index = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_9_blade_1_target_x = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_9_blade_1_target_y = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_9_blade_1_target_z = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_9_blade_1_focus_aw = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_9_blade_1_focus_ah = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_9_blade_1_focus_xw = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_9_blade_1_focus_xh = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_9_blade_1_focus_r = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_9_blade_1_p_interact = 0;
#line 71 "MACS_sample_kidney_box.instr"
  if(0) strncpy(mccinter_analyzer_colimator_9_blade_1_mask_string, 0 ? 0 : "", 16384); else mccinter_analyzer_colimator_9_blade_1_mask_string[0]='\0';
#line 71 "MACS_sample_kidney_box.instr"
  if(0) strncpy(mccinter_analyzer_colimator_9_blade_1_mask_setting, 0 ? 0 : "", 16384); else mccinter_analyzer_colimator_9_blade_1_mask_setting[0]='\0';
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_9_blade_1_number_of_activations = 1;
#line 122746 "MACS_sample_kidney_box.c"

  SIG_MESSAGE("inter_analyzer_colimator_9_blade_1 (Init:Place/Rotate)");
  rot_set_rotation(mctr1,
#line 2682 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 2682 "MACS_sample_kidney_box.instr"
    (- analyzer_2theta [ 9 ])*DEG2RAD,
#line 2682 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD);
#line 122756 "MACS_sample_kidney_box.c"
  rot_mul(mctr1, mcrotainter_analyzer_colimator_center_9, mcrotainter_analyzer_colimator_9_blade_1);
  rot_transpose(mcrotainter_analyzer_colimator_9_blade_0, mctr1);
  rot_mul(mcrotainter_analyzer_colimator_9_blade_1, mctr1, mcrotrinter_analyzer_colimator_9_blade_1);
  mctc1 = coords_set(
#line 2681 "MACS_sample_kidney_box.instr"
    0,
#line 2681 "MACS_sample_kidney_box.instr"
    0,
#line 2681 "MACS_sample_kidney_box.instr"
    inter_analyzer_colimator_start_pos - 1 * inter_analyzer_colimator_seperation);
#line 122767 "MACS_sample_kidney_box.c"
  rot_transpose(mcrotainter_analyzer_colimator_center_9, mctr1);
  mctc2 = rot_apply(mctr1, mctc1);
  mcposainter_analyzer_colimator_9_blade_1 = coords_add(mcposainter_analyzer_colimator_center_9, mctc2);
  mctc1 = coords_sub(mcposainter_analyzer_colimator_9_blade_0, mcposainter_analyzer_colimator_9_blade_1);
  mcposrinter_analyzer_colimator_9_blade_1 = rot_apply(mcrotainter_analyzer_colimator_9_blade_1, mctc1);
  mcDEBUG_COMPONENT("inter_analyzer_colimator_9_blade_1", mcposainter_analyzer_colimator_9_blade_1, mcrotainter_analyzer_colimator_9_blade_1)
  mccomp_posa[498] = mcposainter_analyzer_colimator_9_blade_1;
  mccomp_posr[498] = mcposrinter_analyzer_colimator_9_blade_1;
  mcNCounter[498]  = mcPCounter[498] = mcP2Counter[498] = 0;
  mcAbsorbProp[498]= 0;
    /* Component inter_analyzer_colimator_9_blade_2. */
  /* Setting parameters for component inter_analyzer_colimator_9_blade_2. */
  SIG_MESSAGE("inter_analyzer_colimator_9_blade_2 (Init:SetPar)");
#line 2686 "MACS_sample_kidney_box.instr"
  if("Collimator_gad") strncpy(mccinter_analyzer_colimator_9_blade_2_material_string, "Collimator_gad" ? "Collimator_gad" : "", 16384); else mccinter_analyzer_colimator_9_blade_2_material_string[0]='\0';
#line 2686 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_9_blade_2_priority = 1127;
#line 2685 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_9_blade_2_xwidth = inter_analyzer_colimator_width;
#line 2685 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_9_blade_2_yheight = inter_analyzer_colimator_height;
#line 2685 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_9_blade_2_zdepth = inter_analyzer_colimator_depth;
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_9_blade_2_xwidth2 = -1;
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_9_blade_2_yheight2 = -1;
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_9_blade_2_visualize = 1;
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_9_blade_2_target_index = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_9_blade_2_target_x = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_9_blade_2_target_y = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_9_blade_2_target_z = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_9_blade_2_focus_aw = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_9_blade_2_focus_ah = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_9_blade_2_focus_xw = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_9_blade_2_focus_xh = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_9_blade_2_focus_r = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_9_blade_2_p_interact = 0;
#line 71 "MACS_sample_kidney_box.instr"
  if(0) strncpy(mccinter_analyzer_colimator_9_blade_2_mask_string, 0 ? 0 : "", 16384); else mccinter_analyzer_colimator_9_blade_2_mask_string[0]='\0';
#line 71 "MACS_sample_kidney_box.instr"
  if(0) strncpy(mccinter_analyzer_colimator_9_blade_2_mask_setting, 0 ? 0 : "", 16384); else mccinter_analyzer_colimator_9_blade_2_mask_setting[0]='\0';
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_9_blade_2_number_of_activations = 1;
#line 122823 "MACS_sample_kidney_box.c"

  SIG_MESSAGE("inter_analyzer_colimator_9_blade_2 (Init:Place/Rotate)");
  rot_set_rotation(mctr1,
#line 2688 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 2688 "MACS_sample_kidney_box.instr"
    (- analyzer_2theta [ 9 ])*DEG2RAD,
#line 2688 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD);
#line 122833 "MACS_sample_kidney_box.c"
  rot_mul(mctr1, mcrotainter_analyzer_colimator_center_9, mcrotainter_analyzer_colimator_9_blade_2);
  rot_transpose(mcrotainter_analyzer_colimator_9_blade_1, mctr1);
  rot_mul(mcrotainter_analyzer_colimator_9_blade_2, mctr1, mcrotrinter_analyzer_colimator_9_blade_2);
  mctc1 = coords_set(
#line 2687 "MACS_sample_kidney_box.instr"
    0,
#line 2687 "MACS_sample_kidney_box.instr"
    0,
#line 2687 "MACS_sample_kidney_box.instr"
    inter_analyzer_colimator_start_pos - 2 * inter_analyzer_colimator_seperation);
#line 122844 "MACS_sample_kidney_box.c"
  rot_transpose(mcrotainter_analyzer_colimator_center_9, mctr1);
  mctc2 = rot_apply(mctr1, mctc1);
  mcposainter_analyzer_colimator_9_blade_2 = coords_add(mcposainter_analyzer_colimator_center_9, mctc2);
  mctc1 = coords_sub(mcposainter_analyzer_colimator_9_blade_1, mcposainter_analyzer_colimator_9_blade_2);
  mcposrinter_analyzer_colimator_9_blade_2 = rot_apply(mcrotainter_analyzer_colimator_9_blade_2, mctc1);
  mcDEBUG_COMPONENT("inter_analyzer_colimator_9_blade_2", mcposainter_analyzer_colimator_9_blade_2, mcrotainter_analyzer_colimator_9_blade_2)
  mccomp_posa[499] = mcposainter_analyzer_colimator_9_blade_2;
  mccomp_posr[499] = mcposrinter_analyzer_colimator_9_blade_2;
  mcNCounter[499]  = mcPCounter[499] = mcP2Counter[499] = 0;
  mcAbsorbProp[499]= 0;
    /* Component inter_analyzer_colimator_9_blade_3. */
  /* Setting parameters for component inter_analyzer_colimator_9_blade_3. */
  SIG_MESSAGE("inter_analyzer_colimator_9_blade_3 (Init:SetPar)");
#line 2692 "MACS_sample_kidney_box.instr"
  if("Collimator_gad") strncpy(mccinter_analyzer_colimator_9_blade_3_material_string, "Collimator_gad" ? "Collimator_gad" : "", 16384); else mccinter_analyzer_colimator_9_blade_3_material_string[0]='\0';
#line 2692 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_9_blade_3_priority = 1128;
#line 2691 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_9_blade_3_xwidth = inter_analyzer_colimator_width;
#line 2691 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_9_blade_3_yheight = inter_analyzer_colimator_height;
#line 2691 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_9_blade_3_zdepth = inter_analyzer_colimator_depth;
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_9_blade_3_xwidth2 = -1;
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_9_blade_3_yheight2 = -1;
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_9_blade_3_visualize = 1;
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_9_blade_3_target_index = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_9_blade_3_target_x = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_9_blade_3_target_y = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_9_blade_3_target_z = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_9_blade_3_focus_aw = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_9_blade_3_focus_ah = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_9_blade_3_focus_xw = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_9_blade_3_focus_xh = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_9_blade_3_focus_r = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_9_blade_3_p_interact = 0;
#line 71 "MACS_sample_kidney_box.instr"
  if(0) strncpy(mccinter_analyzer_colimator_9_blade_3_mask_string, 0 ? 0 : "", 16384); else mccinter_analyzer_colimator_9_blade_3_mask_string[0]='\0';
#line 71 "MACS_sample_kidney_box.instr"
  if(0) strncpy(mccinter_analyzer_colimator_9_blade_3_mask_setting, 0 ? 0 : "", 16384); else mccinter_analyzer_colimator_9_blade_3_mask_setting[0]='\0';
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_9_blade_3_number_of_activations = 1;
#line 122900 "MACS_sample_kidney_box.c"

  SIG_MESSAGE("inter_analyzer_colimator_9_blade_3 (Init:Place/Rotate)");
  rot_set_rotation(mctr1,
#line 2694 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 2694 "MACS_sample_kidney_box.instr"
    (- analyzer_2theta [ 9 ])*DEG2RAD,
#line 2694 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD);
#line 122910 "MACS_sample_kidney_box.c"
  rot_mul(mctr1, mcrotainter_analyzer_colimator_center_9, mcrotainter_analyzer_colimator_9_blade_3);
  rot_transpose(mcrotainter_analyzer_colimator_9_blade_2, mctr1);
  rot_mul(mcrotainter_analyzer_colimator_9_blade_3, mctr1, mcrotrinter_analyzer_colimator_9_blade_3);
  mctc1 = coords_set(
#line 2693 "MACS_sample_kidney_box.instr"
    0,
#line 2693 "MACS_sample_kidney_box.instr"
    0,
#line 2693 "MACS_sample_kidney_box.instr"
    inter_analyzer_colimator_start_pos - 3 * inter_analyzer_colimator_seperation);
#line 122921 "MACS_sample_kidney_box.c"
  rot_transpose(mcrotainter_analyzer_colimator_center_9, mctr1);
  mctc2 = rot_apply(mctr1, mctc1);
  mcposainter_analyzer_colimator_9_blade_3 = coords_add(mcposainter_analyzer_colimator_center_9, mctc2);
  mctc1 = coords_sub(mcposainter_analyzer_colimator_9_blade_2, mcposainter_analyzer_colimator_9_blade_3);
  mcposrinter_analyzer_colimator_9_blade_3 = rot_apply(mcrotainter_analyzer_colimator_9_blade_3, mctc1);
  mcDEBUG_COMPONENT("inter_analyzer_colimator_9_blade_3", mcposainter_analyzer_colimator_9_blade_3, mcrotainter_analyzer_colimator_9_blade_3)
  mccomp_posa[500] = mcposainter_analyzer_colimator_9_blade_3;
  mccomp_posr[500] = mcposrinter_analyzer_colimator_9_blade_3;
  mcNCounter[500]  = mcPCounter[500] = mcP2Counter[500] = 0;
  mcAbsorbProp[500]= 0;
    /* Component inter_analyzer_colimator_9_blade_4. */
  /* Setting parameters for component inter_analyzer_colimator_9_blade_4. */
  SIG_MESSAGE("inter_analyzer_colimator_9_blade_4 (Init:SetPar)");
#line 2698 "MACS_sample_kidney_box.instr"
  if("Collimator_gad") strncpy(mccinter_analyzer_colimator_9_blade_4_material_string, "Collimator_gad" ? "Collimator_gad" : "", 16384); else mccinter_analyzer_colimator_9_blade_4_material_string[0]='\0';
#line 2698 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_9_blade_4_priority = 1129;
#line 2697 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_9_blade_4_xwidth = inter_analyzer_colimator_width;
#line 2697 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_9_blade_4_yheight = inter_analyzer_colimator_height;
#line 2697 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_9_blade_4_zdepth = inter_analyzer_colimator_depth;
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_9_blade_4_xwidth2 = -1;
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_9_blade_4_yheight2 = -1;
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_9_blade_4_visualize = 1;
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_9_blade_4_target_index = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_9_blade_4_target_x = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_9_blade_4_target_y = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_9_blade_4_target_z = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_9_blade_4_focus_aw = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_9_blade_4_focus_ah = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_9_blade_4_focus_xw = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_9_blade_4_focus_xh = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_9_blade_4_focus_r = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_9_blade_4_p_interact = 0;
#line 71 "MACS_sample_kidney_box.instr"
  if(0) strncpy(mccinter_analyzer_colimator_9_blade_4_mask_string, 0 ? 0 : "", 16384); else mccinter_analyzer_colimator_9_blade_4_mask_string[0]='\0';
#line 71 "MACS_sample_kidney_box.instr"
  if(0) strncpy(mccinter_analyzer_colimator_9_blade_4_mask_setting, 0 ? 0 : "", 16384); else mccinter_analyzer_colimator_9_blade_4_mask_setting[0]='\0';
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_9_blade_4_number_of_activations = 1;
#line 122977 "MACS_sample_kidney_box.c"

  SIG_MESSAGE("inter_analyzer_colimator_9_blade_4 (Init:Place/Rotate)");
  rot_set_rotation(mctr1,
#line 2700 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 2700 "MACS_sample_kidney_box.instr"
    (- analyzer_2theta [ 9 ])*DEG2RAD,
#line 2700 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD);
#line 122987 "MACS_sample_kidney_box.c"
  rot_mul(mctr1, mcrotainter_analyzer_colimator_center_9, mcrotainter_analyzer_colimator_9_blade_4);
  rot_transpose(mcrotainter_analyzer_colimator_9_blade_3, mctr1);
  rot_mul(mcrotainter_analyzer_colimator_9_blade_4, mctr1, mcrotrinter_analyzer_colimator_9_blade_4);
  mctc1 = coords_set(
#line 2699 "MACS_sample_kidney_box.instr"
    0,
#line 2699 "MACS_sample_kidney_box.instr"
    0,
#line 2699 "MACS_sample_kidney_box.instr"
    inter_analyzer_colimator_start_pos - 4 * inter_analyzer_colimator_seperation);
#line 122998 "MACS_sample_kidney_box.c"
  rot_transpose(mcrotainter_analyzer_colimator_center_9, mctr1);
  mctc2 = rot_apply(mctr1, mctc1);
  mcposainter_analyzer_colimator_9_blade_4 = coords_add(mcposainter_analyzer_colimator_center_9, mctc2);
  mctc1 = coords_sub(mcposainter_analyzer_colimator_9_blade_3, mcposainter_analyzer_colimator_9_blade_4);
  mcposrinter_analyzer_colimator_9_blade_4 = rot_apply(mcrotainter_analyzer_colimator_9_blade_4, mctc1);
  mcDEBUG_COMPONENT("inter_analyzer_colimator_9_blade_4", mcposainter_analyzer_colimator_9_blade_4, mcrotainter_analyzer_colimator_9_blade_4)
  mccomp_posa[501] = mcposainter_analyzer_colimator_9_blade_4;
  mccomp_posr[501] = mcposrinter_analyzer_colimator_9_blade_4;
  mcNCounter[501]  = mcPCounter[501] = mcP2Counter[501] = 0;
  mcAbsorbProp[501]= 0;
    /* Component diffraction_detector_9_exit_volume. */
  /* Setting parameters for component diffraction_detector_9_exit_volume. */
  SIG_MESSAGE("diffraction_detector_9_exit_volume (Init:SetPar)");
#line 2704 "MACS_sample_kidney_box.instr"
  if("Exit") strncpy(mccdiffraction_detector_9_exit_volume_material_string, "Exit" ? "Exit" : "", 16384); else mccdiffraction_detector_9_exit_volume_material_string[0]='\0';
#line 2704 "MACS_sample_kidney_box.instr"
  mccdiffraction_detector_9_exit_volume_priority = 1131;
#line 2703 "MACS_sample_kidney_box.instr"
  mccdiffraction_detector_9_exit_volume_xwidth = 2.01 * detector_radius;
#line 2703 "MACS_sample_kidney_box.instr"
  mccdiffraction_detector_9_exit_volume_yheight = 1.01 * detector_height;
#line 2703 "MACS_sample_kidney_box.instr"
  mccdiffraction_detector_9_exit_volume_zdepth = 0.001;
#line 71 "MACS_sample_kidney_box.instr"
  mccdiffraction_detector_9_exit_volume_xwidth2 = -1;
#line 71 "MACS_sample_kidney_box.instr"
  mccdiffraction_detector_9_exit_volume_yheight2 = -1;
#line 71 "MACS_sample_kidney_box.instr"
  mccdiffraction_detector_9_exit_volume_visualize = 1;
#line 71 "MACS_sample_kidney_box.instr"
  mccdiffraction_detector_9_exit_volume_target_index = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccdiffraction_detector_9_exit_volume_target_x = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccdiffraction_detector_9_exit_volume_target_y = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccdiffraction_detector_9_exit_volume_target_z = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccdiffraction_detector_9_exit_volume_focus_aw = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccdiffraction_detector_9_exit_volume_focus_ah = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccdiffraction_detector_9_exit_volume_focus_xw = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccdiffraction_detector_9_exit_volume_focus_xh = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccdiffraction_detector_9_exit_volume_focus_r = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccdiffraction_detector_9_exit_volume_p_interact = 0;
#line 71 "MACS_sample_kidney_box.instr"
  if(0) strncpy(mccdiffraction_detector_9_exit_volume_mask_string, 0 ? 0 : "", 16384); else mccdiffraction_detector_9_exit_volume_mask_string[0]='\0';
#line 71 "MACS_sample_kidney_box.instr"
  if(0) strncpy(mccdiffraction_detector_9_exit_volume_mask_setting, 0 ? 0 : "", 16384); else mccdiffraction_detector_9_exit_volume_mask_setting[0]='\0';
#line 71 "MACS_sample_kidney_box.instr"
  mccdiffraction_detector_9_exit_volume_number_of_activations = 1;
#line 123054 "MACS_sample_kidney_box.c"

  SIG_MESSAGE("diffraction_detector_9_exit_volume (Init:Place/Rotate)");
  rot_set_rotation(mctr1,
#line 2706 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 2706 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 2706 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD);
#line 123064 "MACS_sample_kidney_box.c"
  rot_mul(mctr1, mcrotakidney_channel_9, mcrotadiffraction_detector_9_exit_volume);
  rot_transpose(mcrotainter_analyzer_colimator_9_blade_4, mctr1);
  rot_mul(mcrotadiffraction_detector_9_exit_volume, mctr1, mcrotrdiffraction_detector_9_exit_volume);
  mctc1 = coords_set(
#line 2705 "MACS_sample_kidney_box.instr"
    0,
#line 2705 "MACS_sample_kidney_box.instr"
    0,
#line 2705 "MACS_sample_kidney_box.instr"
    0);
#line 123075 "MACS_sample_kidney_box.c"
  rot_transpose(mcrotachannel_9_cave1_cyl1, mctr1);
  mctc2 = rot_apply(mctr1, mctc1);
  mcposadiffraction_detector_9_exit_volume = coords_add(mcposachannel_9_cave1_cyl1, mctc2);
  mctc1 = coords_sub(mcposainter_analyzer_colimator_9_blade_4, mcposadiffraction_detector_9_exit_volume);
  mcposrdiffraction_detector_9_exit_volume = rot_apply(mcrotadiffraction_detector_9_exit_volume, mctc1);
  mcDEBUG_COMPONENT("diffraction_detector_9_exit_volume", mcposadiffraction_detector_9_exit_volume, mcrotadiffraction_detector_9_exit_volume)
  mccomp_posa[502] = mcposadiffraction_detector_9_exit_volume;
  mccomp_posr[502] = mcposrdiffraction_detector_9_exit_volume;
  mcNCounter[502]  = mcPCounter[502] = mcP2Counter[502] = 0;
  mcAbsorbProp[502]= 0;
    /* Component spec_detector_9_exit_volume. */
  /* Setting parameters for component spec_detector_9_exit_volume. */
  SIG_MESSAGE("spec_detector_9_exit_volume (Init:SetPar)");
#line 2710 "MACS_sample_kidney_box.instr"
  if("Exit") strncpy(mccspec_detector_9_exit_volume_material_string, "Exit" ? "Exit" : "", 16384); else mccspec_detector_9_exit_volume_material_string[0]='\0';
#line 2710 "MACS_sample_kidney_box.instr"
  mccspec_detector_9_exit_volume_priority = 1132;
#line 2709 "MACS_sample_kidney_box.instr"
  mccspec_detector_9_exit_volume_xwidth = 2.01 * detector_radius;
#line 2709 "MACS_sample_kidney_box.instr"
  mccspec_detector_9_exit_volume_yheight = 1.01 * detector_height;
#line 2709 "MACS_sample_kidney_box.instr"
  mccspec_detector_9_exit_volume_zdepth = 0.001;
#line 71 "MACS_sample_kidney_box.instr"
  mccspec_detector_9_exit_volume_xwidth2 = -1;
#line 71 "MACS_sample_kidney_box.instr"
  mccspec_detector_9_exit_volume_yheight2 = -1;
#line 71 "MACS_sample_kidney_box.instr"
  mccspec_detector_9_exit_volume_visualize = 1;
#line 71 "MACS_sample_kidney_box.instr"
  mccspec_detector_9_exit_volume_target_index = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccspec_detector_9_exit_volume_target_x = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccspec_detector_9_exit_volume_target_y = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccspec_detector_9_exit_volume_target_z = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccspec_detector_9_exit_volume_focus_aw = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccspec_detector_9_exit_volume_focus_ah = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccspec_detector_9_exit_volume_focus_xw = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccspec_detector_9_exit_volume_focus_xh = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccspec_detector_9_exit_volume_focus_r = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccspec_detector_9_exit_volume_p_interact = 0;
#line 71 "MACS_sample_kidney_box.instr"
  if(0) strncpy(mccspec_detector_9_exit_volume_mask_string, 0 ? 0 : "", 16384); else mccspec_detector_9_exit_volume_mask_string[0]='\0';
#line 71 "MACS_sample_kidney_box.instr"
  if(0) strncpy(mccspec_detector_9_exit_volume_mask_setting, 0 ? 0 : "", 16384); else mccspec_detector_9_exit_volume_mask_setting[0]='\0';
#line 71 "MACS_sample_kidney_box.instr"
  mccspec_detector_9_exit_volume_number_of_activations = 1;
#line 123131 "MACS_sample_kidney_box.c"

  SIG_MESSAGE("spec_detector_9_exit_volume (Init:Place/Rotate)");
  rot_set_rotation(mctr1,
#line 2712 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 2712 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 2712 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD);
#line 123141 "MACS_sample_kidney_box.c"
  rot_mul(mctr1, mcrotachannel_9_analyzer_2_center, mcrotaspec_detector_9_exit_volume);
  rot_transpose(mcrotadiffraction_detector_9_exit_volume, mctr1);
  rot_mul(mcrotaspec_detector_9_exit_volume, mctr1, mcrotrspec_detector_9_exit_volume);
  mctc1 = coords_set(
#line 2711 "MACS_sample_kidney_box.instr"
    0,
#line 2711 "MACS_sample_kidney_box.instr"
    0,
#line 2711 "MACS_sample_kidney_box.instr"
    0);
#line 123152 "MACS_sample_kidney_box.c"
  rot_transpose(mcrotachannel_9_cave2_cyl1, mctr1);
  mctc2 = rot_apply(mctr1, mctc1);
  mcposaspec_detector_9_exit_volume = coords_add(mcposachannel_9_cave2_cyl1, mctc2);
  mctc1 = coords_sub(mcposadiffraction_detector_9_exit_volume, mcposaspec_detector_9_exit_volume);
  mcposrspec_detector_9_exit_volume = rot_apply(mcrotaspec_detector_9_exit_volume, mctc1);
  mcDEBUG_COMPONENT("spec_detector_9_exit_volume", mcposaspec_detector_9_exit_volume, mcrotaspec_detector_9_exit_volume)
  mccomp_posa[503] = mcposaspec_detector_9_exit_volume;
  mccomp_posr[503] = mcposrspec_detector_9_exit_volume;
  mcNCounter[503]  = mcPCounter[503] = mcP2Counter[503] = 0;
  mcAbsorbProp[503]= 0;
    /* Component channel_10_cave1_box1. */
  /* Setting parameters for component channel_10_cave1_box1. */
  SIG_MESSAGE("channel_10_cave1_box1 (Init:SetPar)");
#line 2717 "MACS_sample_kidney_box.instr"
  if("Vacuum") strncpy(mccchannel_10_cave1_box1_material_string, "Vacuum" ? "Vacuum" : "", 16384); else mccchannel_10_cave1_box1_material_string[0]='\0';
#line 2717 "MACS_sample_kidney_box.instr"
  mccchannel_10_cave1_box1_priority = 1200;
#line 2715 "MACS_sample_kidney_box.instr"
  mccchannel_10_cave1_box1_xwidth = kidney_cave1_box1_width1;
#line 2715 "MACS_sample_kidney_box.instr"
  mccchannel_10_cave1_box1_yheight = kidney_cave1_box1_height1;
#line 2715 "MACS_sample_kidney_box.instr"
  mccchannel_10_cave1_box1_zdepth = kidney_cave1_box1_depth;
#line 2716 "MACS_sample_kidney_box.instr"
  mccchannel_10_cave1_box1_xwidth2 = kidney_cave1_box1_width2;
#line 2716 "MACS_sample_kidney_box.instr"
  mccchannel_10_cave1_box1_yheight2 = kidney_cave1_box1_height2;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_10_cave1_box1_visualize = 1;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_10_cave1_box1_target_index = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_10_cave1_box1_target_x = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_10_cave1_box1_target_y = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_10_cave1_box1_target_z = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_10_cave1_box1_focus_aw = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_10_cave1_box1_focus_ah = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_10_cave1_box1_focus_xw = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_10_cave1_box1_focus_xh = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_10_cave1_box1_focus_r = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_10_cave1_box1_p_interact = 0;
#line 71 "MACS_sample_kidney_box.instr"
  if(0) strncpy(mccchannel_10_cave1_box1_mask_string, 0 ? 0 : "", 16384); else mccchannel_10_cave1_box1_mask_string[0]='\0';
#line 71 "MACS_sample_kidney_box.instr"
  if(0) strncpy(mccchannel_10_cave1_box1_mask_setting, 0 ? 0 : "", 16384); else mccchannel_10_cave1_box1_mask_setting[0]='\0';
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_10_cave1_box1_number_of_activations = 1;
#line 123208 "MACS_sample_kidney_box.c"

  SIG_MESSAGE("channel_10_cave1_box1 (Init:Place/Rotate)");
  rot_set_rotation(mctr1,
#line 2719 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 2719 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 2719 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD);
#line 123218 "MACS_sample_kidney_box.c"
  rot_mul(mctr1, mcrotakidney_channel_10, mcrotachannel_10_cave1_box1);
  rot_transpose(mcrotaspec_detector_9_exit_volume, mctr1);
  rot_mul(mcrotachannel_10_cave1_box1, mctr1, mcrotrchannel_10_cave1_box1);
  mctc1 = coords_set(
#line 2718 "MACS_sample_kidney_box.instr"
    0,
#line 2718 "MACS_sample_kidney_box.instr"
    0,
#line 2718 "MACS_sample_kidney_box.instr"
    kidney_cave1_box1_center_to_target);
#line 123229 "MACS_sample_kidney_box.c"
  rot_transpose(mcrotakidney_channel_10, mctr1);
  mctc2 = rot_apply(mctr1, mctc1);
  mcposachannel_10_cave1_box1 = coords_add(mcposakidney_channel_10, mctc2);
  mctc1 = coords_sub(mcposaspec_detector_9_exit_volume, mcposachannel_10_cave1_box1);
  mcposrchannel_10_cave1_box1 = rot_apply(mcrotachannel_10_cave1_box1, mctc1);
  mcDEBUG_COMPONENT("channel_10_cave1_box1", mcposachannel_10_cave1_box1, mcrotachannel_10_cave1_box1)
  mccomp_posa[504] = mcposachannel_10_cave1_box1;
  mccomp_posr[504] = mcposrchannel_10_cave1_box1;
  mcNCounter[504]  = mcPCounter[504] = mcP2Counter[504] = 0;
  mcAbsorbProp[504]= 0;
    /* Component channel_10_cave1_box2. */
  /* Setting parameters for component channel_10_cave1_box2. */
  SIG_MESSAGE("channel_10_cave1_box2 (Init:SetPar)");
#line 2724 "MACS_sample_kidney_box.instr"
  if("Vacuum") strncpy(mccchannel_10_cave1_box2_material_string, "Vacuum" ? "Vacuum" : "", 16384); else mccchannel_10_cave1_box2_material_string[0]='\0';
#line 2724 "MACS_sample_kidney_box.instr"
  mccchannel_10_cave1_box2_priority = 1205;
#line 2722 "MACS_sample_kidney_box.instr"
  mccchannel_10_cave1_box2_xwidth = kidney_cave1_box2_width1;
#line 2722 "MACS_sample_kidney_box.instr"
  mccchannel_10_cave1_box2_yheight = kidney_cave1_box2_height1;
#line 2722 "MACS_sample_kidney_box.instr"
  mccchannel_10_cave1_box2_zdepth = kidney_cave1_box2_depth;
#line 2723 "MACS_sample_kidney_box.instr"
  mccchannel_10_cave1_box2_xwidth2 = kidney_cave1_box2_width2;
#line 2723 "MACS_sample_kidney_box.instr"
  mccchannel_10_cave1_box2_yheight2 = kidney_cave1_box2_height2;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_10_cave1_box2_visualize = 1;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_10_cave1_box2_target_index = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_10_cave1_box2_target_x = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_10_cave1_box2_target_y = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_10_cave1_box2_target_z = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_10_cave1_box2_focus_aw = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_10_cave1_box2_focus_ah = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_10_cave1_box2_focus_xw = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_10_cave1_box2_focus_xh = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_10_cave1_box2_focus_r = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_10_cave1_box2_p_interact = 0;
#line 71 "MACS_sample_kidney_box.instr"
  if(0) strncpy(mccchannel_10_cave1_box2_mask_string, 0 ? 0 : "", 16384); else mccchannel_10_cave1_box2_mask_string[0]='\0';
#line 71 "MACS_sample_kidney_box.instr"
  if(0) strncpy(mccchannel_10_cave1_box2_mask_setting, 0 ? 0 : "", 16384); else mccchannel_10_cave1_box2_mask_setting[0]='\0';
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_10_cave1_box2_number_of_activations = 1;
#line 123285 "MACS_sample_kidney_box.c"

  SIG_MESSAGE("channel_10_cave1_box2 (Init:Place/Rotate)");
  rot_set_rotation(mctr1,
#line 2726 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 2726 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 2726 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD);
#line 123295 "MACS_sample_kidney_box.c"
  rot_mul(mctr1, mcrotakidney_channel_10, mcrotachannel_10_cave1_box2);
  rot_transpose(mcrotachannel_10_cave1_box1, mctr1);
  rot_mul(mcrotachannel_10_cave1_box2, mctr1, mcrotrchannel_10_cave1_box2);
  mctc1 = coords_set(
#line 2725 "MACS_sample_kidney_box.instr"
    kidney_cave1_box2_x_offset,
#line 2725 "MACS_sample_kidney_box.instr"
    0,
#line 2725 "MACS_sample_kidney_box.instr"
    kidney_cave1_box2_center_to_target);
#line 123306 "MACS_sample_kidney_box.c"
  rot_transpose(mcrotakidney_channel_10, mctr1);
  mctc2 = rot_apply(mctr1, mctc1);
  mcposachannel_10_cave1_box2 = coords_add(mcposakidney_channel_10, mctc2);
  mctc1 = coords_sub(mcposachannel_10_cave1_box1, mcposachannel_10_cave1_box2);
  mcposrchannel_10_cave1_box2 = rot_apply(mcrotachannel_10_cave1_box2, mctc1);
  mcDEBUG_COMPONENT("channel_10_cave1_box2", mcposachannel_10_cave1_box2, mcrotachannel_10_cave1_box2)
  mccomp_posa[505] = mcposachannel_10_cave1_box2;
  mccomp_posr[505] = mcposrchannel_10_cave1_box2;
  mcNCounter[505]  = mcPCounter[505] = mcP2Counter[505] = 0;
  mcAbsorbProp[505]= 0;
    /* Component channel_10_cave1_box3. */
  /* Setting parameters for component channel_10_cave1_box3. */
  SIG_MESSAGE("channel_10_cave1_box3 (Init:SetPar)");
#line 2731 "MACS_sample_kidney_box.instr"
  if("Vacuum") strncpy(mccchannel_10_cave1_box3_material_string, "Vacuum" ? "Vacuum" : "", 16384); else mccchannel_10_cave1_box3_material_string[0]='\0';
#line 2731 "MACS_sample_kidney_box.instr"
  mccchannel_10_cave1_box3_priority = 1202;
#line 2729 "MACS_sample_kidney_box.instr"
  mccchannel_10_cave1_box3_xwidth = kidney_cave1_box3_width1;
#line 2729 "MACS_sample_kidney_box.instr"
  mccchannel_10_cave1_box3_yheight = kidney_cave1_box3_height1;
#line 2729 "MACS_sample_kidney_box.instr"
  mccchannel_10_cave1_box3_zdepth = kidney_cave1_box3_depth;
#line 2730 "MACS_sample_kidney_box.instr"
  mccchannel_10_cave1_box3_xwidth2 = kidney_cave1_box3_width2;
#line 2730 "MACS_sample_kidney_box.instr"
  mccchannel_10_cave1_box3_yheight2 = kidney_cave1_box3_height2;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_10_cave1_box3_visualize = 1;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_10_cave1_box3_target_index = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_10_cave1_box3_target_x = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_10_cave1_box3_target_y = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_10_cave1_box3_target_z = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_10_cave1_box3_focus_aw = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_10_cave1_box3_focus_ah = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_10_cave1_box3_focus_xw = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_10_cave1_box3_focus_xh = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_10_cave1_box3_focus_r = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_10_cave1_box3_p_interact = 0;
#line 71 "MACS_sample_kidney_box.instr"
  if(0) strncpy(mccchannel_10_cave1_box3_mask_string, 0 ? 0 : "", 16384); else mccchannel_10_cave1_box3_mask_string[0]='\0';
#line 71 "MACS_sample_kidney_box.instr"
  if(0) strncpy(mccchannel_10_cave1_box3_mask_setting, 0 ? 0 : "", 16384); else mccchannel_10_cave1_box3_mask_setting[0]='\0';
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_10_cave1_box3_number_of_activations = 1;
#line 123362 "MACS_sample_kidney_box.c"

  SIG_MESSAGE("channel_10_cave1_box3 (Init:Place/Rotate)");
  rot_set_rotation(mctr1,
#line 2733 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 2733 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 2733 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD);
#line 123372 "MACS_sample_kidney_box.c"
  rot_mul(mctr1, mcrotakidney_channel_10, mcrotachannel_10_cave1_box3);
  rot_transpose(mcrotachannel_10_cave1_box2, mctr1);
  rot_mul(mcrotachannel_10_cave1_box3, mctr1, mcrotrchannel_10_cave1_box3);
  mctc1 = coords_set(
#line 2732 "MACS_sample_kidney_box.instr"
    0,
#line 2732 "MACS_sample_kidney_box.instr"
    0,
#line 2732 "MACS_sample_kidney_box.instr"
    kidney_cave1_box3_center_to_target);
#line 123383 "MACS_sample_kidney_box.c"
  rot_transpose(mcrotakidney_channel_10, mctr1);
  mctc2 = rot_apply(mctr1, mctc1);
  mcposachannel_10_cave1_box3 = coords_add(mcposakidney_channel_10, mctc2);
  mctc1 = coords_sub(mcposachannel_10_cave1_box2, mcposachannel_10_cave1_box3);
  mcposrchannel_10_cave1_box3 = rot_apply(mcrotachannel_10_cave1_box3, mctc1);
  mcDEBUG_COMPONENT("channel_10_cave1_box3", mcposachannel_10_cave1_box3, mcrotachannel_10_cave1_box3)
  mccomp_posa[506] = mcposachannel_10_cave1_box3;
  mccomp_posr[506] = mcposrchannel_10_cave1_box3;
  mcNCounter[506]  = mcPCounter[506] = mcP2Counter[506] = 0;
  mcAbsorbProp[506]= 0;
    /* Component channel_10_cave1_cyl1. */
  /* Setting parameters for component channel_10_cave1_cyl1. */
  SIG_MESSAGE("channel_10_cave1_cyl1 (Init:SetPar)");
#line 2737 "MACS_sample_kidney_box.instr"
  if("Vacuum") strncpy(mccchannel_10_cave1_cyl1_material_string, "Vacuum" ? "Vacuum" : "", 16384); else mccchannel_10_cave1_cyl1_material_string[0]='\0';
#line 2737 "MACS_sample_kidney_box.instr"
  mccchannel_10_cave1_cyl1_priority = 1203;
#line 2736 "MACS_sample_kidney_box.instr"
  mccchannel_10_cave1_cyl1_radius = kidney_cave1_cyl1_radius;
#line 2736 "MACS_sample_kidney_box.instr"
  mccchannel_10_cave1_cyl1_yheight = kidney_cave1_cyl1_height;
#line 67 "MACS_sample_kidney_box.instr"
  mccchannel_10_cave1_cyl1_visualize = 1;
#line 67 "MACS_sample_kidney_box.instr"
  mccchannel_10_cave1_cyl1_target_index = 0;
#line 67 "MACS_sample_kidney_box.instr"
  mccchannel_10_cave1_cyl1_target_x = 0;
#line 67 "MACS_sample_kidney_box.instr"
  mccchannel_10_cave1_cyl1_target_y = 0;
#line 67 "MACS_sample_kidney_box.instr"
  mccchannel_10_cave1_cyl1_target_z = 0;
#line 67 "MACS_sample_kidney_box.instr"
  mccchannel_10_cave1_cyl1_focus_aw = 0;
#line 67 "MACS_sample_kidney_box.instr"
  mccchannel_10_cave1_cyl1_focus_ah = 0;
#line 67 "MACS_sample_kidney_box.instr"
  mccchannel_10_cave1_cyl1_focus_xw = 0;
#line 67 "MACS_sample_kidney_box.instr"
  mccchannel_10_cave1_cyl1_focus_xh = 0;
#line 67 "MACS_sample_kidney_box.instr"
  mccchannel_10_cave1_cyl1_focus_r = 0;
#line 67 "MACS_sample_kidney_box.instr"
  mccchannel_10_cave1_cyl1_p_interact = 0;
#line 67 "MACS_sample_kidney_box.instr"
  if(0) strncpy(mccchannel_10_cave1_cyl1_mask_string, 0 ? 0 : "", 16384); else mccchannel_10_cave1_cyl1_mask_string[0]='\0';
#line 67 "MACS_sample_kidney_box.instr"
  if(0) strncpy(mccchannel_10_cave1_cyl1_mask_setting, 0 ? 0 : "", 16384); else mccchannel_10_cave1_cyl1_mask_setting[0]='\0';
#line 67 "MACS_sample_kidney_box.instr"
  mccchannel_10_cave1_cyl1_number_of_activations = 1;
#line 123433 "MACS_sample_kidney_box.c"

  SIG_MESSAGE("channel_10_cave1_cyl1 (Init:Place/Rotate)");
  rot_set_rotation(mctr1,
#line 2739 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 2739 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 2739 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD);
#line 123443 "MACS_sample_kidney_box.c"
  rot_mul(mctr1, mcrotakidney_channel_10, mcrotachannel_10_cave1_cyl1);
  rot_transpose(mcrotachannel_10_cave1_box3, mctr1);
  rot_mul(mcrotachannel_10_cave1_cyl1, mctr1, mcrotrchannel_10_cave1_cyl1);
  mctc1 = coords_set(
#line 2738 "MACS_sample_kidney_box.instr"
    0,
#line 2738 "MACS_sample_kidney_box.instr"
    0,
#line 2738 "MACS_sample_kidney_box.instr"
    kidney_cave1_cyl1_center_to_target);
#line 123454 "MACS_sample_kidney_box.c"
  rot_transpose(mcrotakidney_channel_10, mctr1);
  mctc2 = rot_apply(mctr1, mctc1);
  mcposachannel_10_cave1_cyl1 = coords_add(mcposakidney_channel_10, mctc2);
  mctc1 = coords_sub(mcposachannel_10_cave1_box3, mcposachannel_10_cave1_cyl1);
  mcposrchannel_10_cave1_cyl1 = rot_apply(mcrotachannel_10_cave1_cyl1, mctc1);
  mcDEBUG_COMPONENT("channel_10_cave1_cyl1", mcposachannel_10_cave1_cyl1, mcrotachannel_10_cave1_cyl1)
  mccomp_posa[507] = mcposachannel_10_cave1_cyl1;
  mccomp_posr[507] = mcposrchannel_10_cave1_cyl1;
  mcNCounter[507]  = mcPCounter[507] = mcP2Counter[507] = 0;
  mcAbsorbProp[507]= 0;
    /* Component channel_10_analyzer_1_center. */
  /* Setting parameters for component channel_10_analyzer_1_center. */
  SIG_MESSAGE("channel_10_analyzer_1_center (Init:SetPar)");

  SIG_MESSAGE("channel_10_analyzer_1_center (Init:Place/Rotate)");
  rot_set_rotation(mctr1,
    (0.0)*DEG2RAD,
    (0.0)*DEG2RAD,
    (0.0)*DEG2RAD);
#line 123474 "MACS_sample_kidney_box.c"
  rot_mul(mctr1, mcrotakidney_channel_10, mcrotachannel_10_analyzer_1_center);
  rot_transpose(mcrotachannel_10_cave1_cyl1, mctr1);
  rot_mul(mcrotachannel_10_analyzer_1_center, mctr1, mcrotrchannel_10_analyzer_1_center);
  mctc1 = coords_set(
#line 2743 "MACS_sample_kidney_box.instr"
    0,
#line 2743 "MACS_sample_kidney_box.instr"
    0,
#line 2743 "MACS_sample_kidney_box.instr"
    analyzer_1_center_to_sample);
#line 123485 "MACS_sample_kidney_box.c"
  rot_transpose(mcrotakidney_channel_10, mctr1);
  mctc2 = rot_apply(mctr1, mctc1);
  mcposachannel_10_analyzer_1_center = coords_add(mcposakidney_channel_10, mctc2);
  mctc1 = coords_sub(mcposachannel_10_cave1_cyl1, mcposachannel_10_analyzer_1_center);
  mcposrchannel_10_analyzer_1_center = rot_apply(mcrotachannel_10_analyzer_1_center, mctc1);
  mcDEBUG_COMPONENT("channel_10_analyzer_1_center", mcposachannel_10_analyzer_1_center, mcrotachannel_10_analyzer_1_center)
  mccomp_posa[508] = mcposachannel_10_analyzer_1_center;
  mccomp_posr[508] = mcposrchannel_10_analyzer_1_center;
  mcNCounter[508]  = mcPCounter[508] = mcP2Counter[508] = 0;
  mcAbsorbProp[508]= 0;
    /* Component channel_10_analyzer_1_rotated. */
  /* Setting parameters for component channel_10_analyzer_1_rotated. */
  SIG_MESSAGE("channel_10_analyzer_1_rotated (Init:SetPar)");

  SIG_MESSAGE("channel_10_analyzer_1_rotated (Init:Place/Rotate)");
  rot_set_rotation(mctr1,
#line 2747 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 2747 "MACS_sample_kidney_box.instr"
    (180 - analyzer_theta [ 10 ])*DEG2RAD,
#line 2747 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD);
#line 123508 "MACS_sample_kidney_box.c"
  rot_mul(mctr1, mcrotachannel_10_analyzer_1_center, mcrotachannel_10_analyzer_1_rotated);
  rot_transpose(mcrotachannel_10_analyzer_1_center, mctr1);
  rot_mul(mcrotachannel_10_analyzer_1_rotated, mctr1, mcrotrchannel_10_analyzer_1_rotated);
  mctc1 = coords_set(
#line 2746 "MACS_sample_kidney_box.instr"
    0,
#line 2746 "MACS_sample_kidney_box.instr"
    0,
#line 2746 "MACS_sample_kidney_box.instr"
    -0.5 * analyzer_seperation / tan ( analyzer_2theta [ 10 ] * DEG2RAD ));
#line 123519 "MACS_sample_kidney_box.c"
  rot_transpose(mcrotachannel_10_analyzer_1_center, mctr1);
  mctc2 = rot_apply(mctr1, mctc1);
  mcposachannel_10_analyzer_1_rotated = coords_add(mcposachannel_10_analyzer_1_center, mctc2);
  mctc1 = coords_sub(mcposachannel_10_analyzer_1_center, mcposachannel_10_analyzer_1_rotated);
  mcposrchannel_10_analyzer_1_rotated = rot_apply(mcrotachannel_10_analyzer_1_rotated, mctc1);
  mcDEBUG_COMPONENT("channel_10_analyzer_1_rotated", mcposachannel_10_analyzer_1_rotated, mcrotachannel_10_analyzer_1_rotated)
  mccomp_posa[509] = mcposachannel_10_analyzer_1_rotated;
  mccomp_posr[509] = mcposrchannel_10_analyzer_1_rotated;
  mcNCounter[509]  = mcPCounter[509] = mcP2Counter[509] = 0;
  mcAbsorbProp[509]= 0;
    /* Component channel_10_analyzer_1_array_crystal_array_0. */
  /* Setting parameters for component channel_10_analyzer_1_array_crystal_array_0. */
  SIG_MESSAGE("channel_10_analyzer_1_array_crystal_array_0 (Init:SetPar)");
#line 2751 "MACS_sample_kidney_box.instr"
  if("PG_analyzer") strncpy(mccchannel_10_analyzer_1_array_crystal_array_0_material_string, "PG_analyzer" ? "PG_analyzer" : "", 16384); else mccchannel_10_analyzer_1_array_crystal_array_0_material_string[0]='\0';
#line 2751 "MACS_sample_kidney_box.instr"
  mccchannel_10_analyzer_1_array_crystal_array_0_priority = 1220.0;
#line 2750 "MACS_sample_kidney_box.instr"
  mccchannel_10_analyzer_1_array_crystal_array_0_xwidth = channel_10_analyzer_1_array_crystal_depth;
#line 2750 "MACS_sample_kidney_box.instr"
  mccchannel_10_analyzer_1_array_crystal_array_0_yheight = channel_10_analyzer_1_array_crystal_height;
#line 2750 "MACS_sample_kidney_box.instr"
  mccchannel_10_analyzer_1_array_crystal_array_0_zdepth = channel_10_analyzer_1_array_crystal_width;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_10_analyzer_1_array_crystal_array_0_xwidth2 = -1;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_10_analyzer_1_array_crystal_array_0_yheight2 = -1;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_10_analyzer_1_array_crystal_array_0_visualize = 1;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_10_analyzer_1_array_crystal_array_0_target_index = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_10_analyzer_1_array_crystal_array_0_target_x = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_10_analyzer_1_array_crystal_array_0_target_y = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_10_analyzer_1_array_crystal_array_0_target_z = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_10_analyzer_1_array_crystal_array_0_focus_aw = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_10_analyzer_1_array_crystal_array_0_focus_ah = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_10_analyzer_1_array_crystal_array_0_focus_xw = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_10_analyzer_1_array_crystal_array_0_focus_xh = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_10_analyzer_1_array_crystal_array_0_focus_r = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_10_analyzer_1_array_crystal_array_0_p_interact = 0;
#line 71 "MACS_sample_kidney_box.instr"
  if(0) strncpy(mccchannel_10_analyzer_1_array_crystal_array_0_mask_string, 0 ? 0 : "", 16384); else mccchannel_10_analyzer_1_array_crystal_array_0_mask_string[0]='\0';
#line 71 "MACS_sample_kidney_box.instr"
  if(0) strncpy(mccchannel_10_analyzer_1_array_crystal_array_0_mask_setting, 0 ? 0 : "", 16384); else mccchannel_10_analyzer_1_array_crystal_array_0_mask_setting[0]='\0';
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_10_analyzer_1_array_crystal_array_0_number_of_activations = 1;
#line 123575 "MACS_sample_kidney_box.c"

  SIG_MESSAGE("channel_10_analyzer_1_array_crystal_array_0 (Init:Place/Rotate)");
  rot_set_rotation(mctr1,
#line 2753 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 2753 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 2753 "MACS_sample_kidney_box.instr"
    (0 - RAD2DEG * channel_10_analyzer_1_array_theta [ 0 ])*DEG2RAD);
#line 123585 "MACS_sample_kidney_box.c"
  rot_mul(mctr1, mcrotachannel_10_analyzer_1_rotated, mcrotachannel_10_analyzer_1_array_crystal_array_0);
  rot_transpose(mcrotachannel_10_analyzer_1_rotated, mctr1);
  rot_mul(mcrotachannel_10_analyzer_1_array_crystal_array_0, mctr1, mcrotrchannel_10_analyzer_1_array_crystal_array_0);
  mctc1 = coords_set(
#line 2752 "MACS_sample_kidney_box.instr"
    0 + channel_10_analyzer_1_array_effective_radius_of_curvature * ( 1 - cos ( channel_10_analyzer_1_array_theta [ 0 ] ) ),
#line 2752 "MACS_sample_kidney_box.instr"
    0 + channel_10_analyzer_1_array_effective_radius_of_curvature * sin ( channel_10_analyzer_1_array_theta [ 0 ] ),
#line 2752 "MACS_sample_kidney_box.instr"
    0);
#line 123596 "MACS_sample_kidney_box.c"
  rot_transpose(mcrotachannel_10_analyzer_1_rotated, mctr1);
  mctc2 = rot_apply(mctr1, mctc1);
  mcposachannel_10_analyzer_1_array_crystal_array_0 = coords_add(mcposachannel_10_analyzer_1_rotated, mctc2);
  mctc1 = coords_sub(mcposachannel_10_analyzer_1_rotated, mcposachannel_10_analyzer_1_array_crystal_array_0);
  mcposrchannel_10_analyzer_1_array_crystal_array_0 = rot_apply(mcrotachannel_10_analyzer_1_array_crystal_array_0, mctc1);
  mcDEBUG_COMPONENT("channel_10_analyzer_1_array_crystal_array_0", mcposachannel_10_analyzer_1_array_crystal_array_0, mcrotachannel_10_analyzer_1_array_crystal_array_0)
  mccomp_posa[510] = mcposachannel_10_analyzer_1_array_crystal_array_0;
  mccomp_posr[510] = mcposrchannel_10_analyzer_1_array_crystal_array_0;
  mcNCounter[510]  = mcPCounter[510] = mcP2Counter[510] = 0;
  mcAbsorbProp[510]= 0;
    /* Component channel_10_analyzer_1_array_crystal_array_1. */
  /* Setting parameters for component channel_10_analyzer_1_array_crystal_array_1. */
  SIG_MESSAGE("channel_10_analyzer_1_array_crystal_array_1 (Init:SetPar)");
#line 2757 "MACS_sample_kidney_box.instr"
  if("PG_analyzer") strncpy(mccchannel_10_analyzer_1_array_crystal_array_1_material_string, "PG_analyzer" ? "PG_analyzer" : "", 16384); else mccchannel_10_analyzer_1_array_crystal_array_1_material_string[0]='\0';
#line 2757 "MACS_sample_kidney_box.instr"
  mccchannel_10_analyzer_1_array_crystal_array_1_priority = 1220.1;
#line 2756 "MACS_sample_kidney_box.instr"
  mccchannel_10_analyzer_1_array_crystal_array_1_xwidth = channel_10_analyzer_1_array_crystal_depth;
#line 2756 "MACS_sample_kidney_box.instr"
  mccchannel_10_analyzer_1_array_crystal_array_1_yheight = channel_10_analyzer_1_array_crystal_height;
#line 2756 "MACS_sample_kidney_box.instr"
  mccchannel_10_analyzer_1_array_crystal_array_1_zdepth = channel_10_analyzer_1_array_crystal_width;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_10_analyzer_1_array_crystal_array_1_xwidth2 = -1;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_10_analyzer_1_array_crystal_array_1_yheight2 = -1;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_10_analyzer_1_array_crystal_array_1_visualize = 1;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_10_analyzer_1_array_crystal_array_1_target_index = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_10_analyzer_1_array_crystal_array_1_target_x = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_10_analyzer_1_array_crystal_array_1_target_y = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_10_analyzer_1_array_crystal_array_1_target_z = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_10_analyzer_1_array_crystal_array_1_focus_aw = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_10_analyzer_1_array_crystal_array_1_focus_ah = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_10_analyzer_1_array_crystal_array_1_focus_xw = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_10_analyzer_1_array_crystal_array_1_focus_xh = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_10_analyzer_1_array_crystal_array_1_focus_r = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_10_analyzer_1_array_crystal_array_1_p_interact = 0;
#line 71 "MACS_sample_kidney_box.instr"
  if(0) strncpy(mccchannel_10_analyzer_1_array_crystal_array_1_mask_string, 0 ? 0 : "", 16384); else mccchannel_10_analyzer_1_array_crystal_array_1_mask_string[0]='\0';
#line 71 "MACS_sample_kidney_box.instr"
  if(0) strncpy(mccchannel_10_analyzer_1_array_crystal_array_1_mask_setting, 0 ? 0 : "", 16384); else mccchannel_10_analyzer_1_array_crystal_array_1_mask_setting[0]='\0';
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_10_analyzer_1_array_crystal_array_1_number_of_activations = 1;
#line 123652 "MACS_sample_kidney_box.c"

  SIG_MESSAGE("channel_10_analyzer_1_array_crystal_array_1 (Init:Place/Rotate)");
  rot_set_rotation(mctr1,
#line 2759 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 2759 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 2759 "MACS_sample_kidney_box.instr"
    (0 - RAD2DEG * channel_10_analyzer_1_array_theta [ 1 ])*DEG2RAD);
#line 123662 "MACS_sample_kidney_box.c"
  rot_mul(mctr1, mcrotachannel_10_analyzer_1_rotated, mcrotachannel_10_analyzer_1_array_crystal_array_1);
  rot_transpose(mcrotachannel_10_analyzer_1_array_crystal_array_0, mctr1);
  rot_mul(mcrotachannel_10_analyzer_1_array_crystal_array_1, mctr1, mcrotrchannel_10_analyzer_1_array_crystal_array_1);
  mctc1 = coords_set(
#line 2758 "MACS_sample_kidney_box.instr"
    0 + channel_10_analyzer_1_array_effective_radius_of_curvature * ( 1 - cos ( channel_10_analyzer_1_array_theta [ 1 ] ) ),
#line 2758 "MACS_sample_kidney_box.instr"
    0 + channel_10_analyzer_1_array_effective_radius_of_curvature * sin ( channel_10_analyzer_1_array_theta [ 1 ] ),
#line 2758 "MACS_sample_kidney_box.instr"
    0);
#line 123673 "MACS_sample_kidney_box.c"
  rot_transpose(mcrotachannel_10_analyzer_1_rotated, mctr1);
  mctc2 = rot_apply(mctr1, mctc1);
  mcposachannel_10_analyzer_1_array_crystal_array_1 = coords_add(mcposachannel_10_analyzer_1_rotated, mctc2);
  mctc1 = coords_sub(mcposachannel_10_analyzer_1_array_crystal_array_0, mcposachannel_10_analyzer_1_array_crystal_array_1);
  mcposrchannel_10_analyzer_1_array_crystal_array_1 = rot_apply(mcrotachannel_10_analyzer_1_array_crystal_array_1, mctc1);
  mcDEBUG_COMPONENT("channel_10_analyzer_1_array_crystal_array_1", mcposachannel_10_analyzer_1_array_crystal_array_1, mcrotachannel_10_analyzer_1_array_crystal_array_1)
  mccomp_posa[511] = mcposachannel_10_analyzer_1_array_crystal_array_1;
  mccomp_posr[511] = mcposrchannel_10_analyzer_1_array_crystal_array_1;
  mcNCounter[511]  = mcPCounter[511] = mcP2Counter[511] = 0;
  mcAbsorbProp[511]= 0;
    /* Component channel_10_analyzer_1_array_crystal_array_2. */
  /* Setting parameters for component channel_10_analyzer_1_array_crystal_array_2. */
  SIG_MESSAGE("channel_10_analyzer_1_array_crystal_array_2 (Init:SetPar)");
#line 2763 "MACS_sample_kidney_box.instr"
  if("PG_analyzer") strncpy(mccchannel_10_analyzer_1_array_crystal_array_2_material_string, "PG_analyzer" ? "PG_analyzer" : "", 16384); else mccchannel_10_analyzer_1_array_crystal_array_2_material_string[0]='\0';
#line 2763 "MACS_sample_kidney_box.instr"
  mccchannel_10_analyzer_1_array_crystal_array_2_priority = 1220.2;
#line 2762 "MACS_sample_kidney_box.instr"
  mccchannel_10_analyzer_1_array_crystal_array_2_xwidth = channel_10_analyzer_1_array_crystal_depth;
#line 2762 "MACS_sample_kidney_box.instr"
  mccchannel_10_analyzer_1_array_crystal_array_2_yheight = channel_10_analyzer_1_array_crystal_height;
#line 2762 "MACS_sample_kidney_box.instr"
  mccchannel_10_analyzer_1_array_crystal_array_2_zdepth = channel_10_analyzer_1_array_crystal_width;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_10_analyzer_1_array_crystal_array_2_xwidth2 = -1;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_10_analyzer_1_array_crystal_array_2_yheight2 = -1;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_10_analyzer_1_array_crystal_array_2_visualize = 1;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_10_analyzer_1_array_crystal_array_2_target_index = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_10_analyzer_1_array_crystal_array_2_target_x = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_10_analyzer_1_array_crystal_array_2_target_y = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_10_analyzer_1_array_crystal_array_2_target_z = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_10_analyzer_1_array_crystal_array_2_focus_aw = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_10_analyzer_1_array_crystal_array_2_focus_ah = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_10_analyzer_1_array_crystal_array_2_focus_xw = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_10_analyzer_1_array_crystal_array_2_focus_xh = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_10_analyzer_1_array_crystal_array_2_focus_r = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_10_analyzer_1_array_crystal_array_2_p_interact = 0;
#line 71 "MACS_sample_kidney_box.instr"
  if(0) strncpy(mccchannel_10_analyzer_1_array_crystal_array_2_mask_string, 0 ? 0 : "", 16384); else mccchannel_10_analyzer_1_array_crystal_array_2_mask_string[0]='\0';
#line 71 "MACS_sample_kidney_box.instr"
  if(0) strncpy(mccchannel_10_analyzer_1_array_crystal_array_2_mask_setting, 0 ? 0 : "", 16384); else mccchannel_10_analyzer_1_array_crystal_array_2_mask_setting[0]='\0';
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_10_analyzer_1_array_crystal_array_2_number_of_activations = 1;
#line 123729 "MACS_sample_kidney_box.c"

  SIG_MESSAGE("channel_10_analyzer_1_array_crystal_array_2 (Init:Place/Rotate)");
  rot_set_rotation(mctr1,
#line 2765 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 2765 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 2765 "MACS_sample_kidney_box.instr"
    (0 - RAD2DEG * channel_10_analyzer_1_array_theta [ 2 ])*DEG2RAD);
#line 123739 "MACS_sample_kidney_box.c"
  rot_mul(mctr1, mcrotachannel_10_analyzer_1_rotated, mcrotachannel_10_analyzer_1_array_crystal_array_2);
  rot_transpose(mcrotachannel_10_analyzer_1_array_crystal_array_1, mctr1);
  rot_mul(mcrotachannel_10_analyzer_1_array_crystal_array_2, mctr1, mcrotrchannel_10_analyzer_1_array_crystal_array_2);
  mctc1 = coords_set(
#line 2764 "MACS_sample_kidney_box.instr"
    0 + channel_10_analyzer_1_array_effective_radius_of_curvature * ( 1 - cos ( channel_10_analyzer_1_array_theta [ 2 ] ) ),
#line 2764 "MACS_sample_kidney_box.instr"
    0 + channel_10_analyzer_1_array_effective_radius_of_curvature * sin ( channel_10_analyzer_1_array_theta [ 2 ] ),
#line 2764 "MACS_sample_kidney_box.instr"
    0);
#line 123750 "MACS_sample_kidney_box.c"
  rot_transpose(mcrotachannel_10_analyzer_1_rotated, mctr1);
  mctc2 = rot_apply(mctr1, mctc1);
  mcposachannel_10_analyzer_1_array_crystal_array_2 = coords_add(mcposachannel_10_analyzer_1_rotated, mctc2);
  mctc1 = coords_sub(mcposachannel_10_analyzer_1_array_crystal_array_1, mcposachannel_10_analyzer_1_array_crystal_array_2);
  mcposrchannel_10_analyzer_1_array_crystal_array_2 = rot_apply(mcrotachannel_10_analyzer_1_array_crystal_array_2, mctc1);
  mcDEBUG_COMPONENT("channel_10_analyzer_1_array_crystal_array_2", mcposachannel_10_analyzer_1_array_crystal_array_2, mcrotachannel_10_analyzer_1_array_crystal_array_2)
  mccomp_posa[512] = mcposachannel_10_analyzer_1_array_crystal_array_2;
  mccomp_posr[512] = mcposrchannel_10_analyzer_1_array_crystal_array_2;
  mcNCounter[512]  = mcPCounter[512] = mcP2Counter[512] = 0;
  mcAbsorbProp[512]= 0;
    /* Component channel_10_analyzer_1_array_crystal_array_3. */
  /* Setting parameters for component channel_10_analyzer_1_array_crystal_array_3. */
  SIG_MESSAGE("channel_10_analyzer_1_array_crystal_array_3 (Init:SetPar)");
#line 2769 "MACS_sample_kidney_box.instr"
  if("PG_analyzer") strncpy(mccchannel_10_analyzer_1_array_crystal_array_3_material_string, "PG_analyzer" ? "PG_analyzer" : "", 16384); else mccchannel_10_analyzer_1_array_crystal_array_3_material_string[0]='\0';
#line 2769 "MACS_sample_kidney_box.instr"
  mccchannel_10_analyzer_1_array_crystal_array_3_priority = 1220.3;
#line 2768 "MACS_sample_kidney_box.instr"
  mccchannel_10_analyzer_1_array_crystal_array_3_xwidth = channel_10_analyzer_1_array_crystal_depth;
#line 2768 "MACS_sample_kidney_box.instr"
  mccchannel_10_analyzer_1_array_crystal_array_3_yheight = channel_10_analyzer_1_array_crystal_height;
#line 2768 "MACS_sample_kidney_box.instr"
  mccchannel_10_analyzer_1_array_crystal_array_3_zdepth = channel_10_analyzer_1_array_crystal_width;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_10_analyzer_1_array_crystal_array_3_xwidth2 = -1;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_10_analyzer_1_array_crystal_array_3_yheight2 = -1;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_10_analyzer_1_array_crystal_array_3_visualize = 1;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_10_analyzer_1_array_crystal_array_3_target_index = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_10_analyzer_1_array_crystal_array_3_target_x = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_10_analyzer_1_array_crystal_array_3_target_y = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_10_analyzer_1_array_crystal_array_3_target_z = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_10_analyzer_1_array_crystal_array_3_focus_aw = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_10_analyzer_1_array_crystal_array_3_focus_ah = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_10_analyzer_1_array_crystal_array_3_focus_xw = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_10_analyzer_1_array_crystal_array_3_focus_xh = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_10_analyzer_1_array_crystal_array_3_focus_r = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_10_analyzer_1_array_crystal_array_3_p_interact = 0;
#line 71 "MACS_sample_kidney_box.instr"
  if(0) strncpy(mccchannel_10_analyzer_1_array_crystal_array_3_mask_string, 0 ? 0 : "", 16384); else mccchannel_10_analyzer_1_array_crystal_array_3_mask_string[0]='\0';
#line 71 "MACS_sample_kidney_box.instr"
  if(0) strncpy(mccchannel_10_analyzer_1_array_crystal_array_3_mask_setting, 0 ? 0 : "", 16384); else mccchannel_10_analyzer_1_array_crystal_array_3_mask_setting[0]='\0';
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_10_analyzer_1_array_crystal_array_3_number_of_activations = 1;
#line 123806 "MACS_sample_kidney_box.c"

  SIG_MESSAGE("channel_10_analyzer_1_array_crystal_array_3 (Init:Place/Rotate)");
  rot_set_rotation(mctr1,
#line 2771 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 2771 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 2771 "MACS_sample_kidney_box.instr"
    (0 - RAD2DEG * channel_10_analyzer_1_array_theta [ 3 ])*DEG2RAD);
#line 123816 "MACS_sample_kidney_box.c"
  rot_mul(mctr1, mcrotachannel_10_analyzer_1_rotated, mcrotachannel_10_analyzer_1_array_crystal_array_3);
  rot_transpose(mcrotachannel_10_analyzer_1_array_crystal_array_2, mctr1);
  rot_mul(mcrotachannel_10_analyzer_1_array_crystal_array_3, mctr1, mcrotrchannel_10_analyzer_1_array_crystal_array_3);
  mctc1 = coords_set(
#line 2770 "MACS_sample_kidney_box.instr"
    0 + channel_10_analyzer_1_array_effective_radius_of_curvature * ( 1 - cos ( channel_10_analyzer_1_array_theta [ 3 ] ) ),
#line 2770 "MACS_sample_kidney_box.instr"
    0 + channel_10_analyzer_1_array_effective_radius_of_curvature * sin ( channel_10_analyzer_1_array_theta [ 3 ] ),
#line 2770 "MACS_sample_kidney_box.instr"
    0);
#line 123827 "MACS_sample_kidney_box.c"
  rot_transpose(mcrotachannel_10_analyzer_1_rotated, mctr1);
  mctc2 = rot_apply(mctr1, mctc1);
  mcposachannel_10_analyzer_1_array_crystal_array_3 = coords_add(mcposachannel_10_analyzer_1_rotated, mctc2);
  mctc1 = coords_sub(mcposachannel_10_analyzer_1_array_crystal_array_2, mcposachannel_10_analyzer_1_array_crystal_array_3);
  mcposrchannel_10_analyzer_1_array_crystal_array_3 = rot_apply(mcrotachannel_10_analyzer_1_array_crystal_array_3, mctc1);
  mcDEBUG_COMPONENT("channel_10_analyzer_1_array_crystal_array_3", mcposachannel_10_analyzer_1_array_crystal_array_3, mcrotachannel_10_analyzer_1_array_crystal_array_3)
  mccomp_posa[513] = mcposachannel_10_analyzer_1_array_crystal_array_3;
  mccomp_posr[513] = mcposrchannel_10_analyzer_1_array_crystal_array_3;
  mcNCounter[513]  = mcPCounter[513] = mcP2Counter[513] = 0;
  mcAbsorbProp[513]= 0;
    /* Component channel_10_analyzer_1_array_crystal_array_4. */
  /* Setting parameters for component channel_10_analyzer_1_array_crystal_array_4. */
  SIG_MESSAGE("channel_10_analyzer_1_array_crystal_array_4 (Init:SetPar)");
#line 2775 "MACS_sample_kidney_box.instr"
  if("PG_analyzer") strncpy(mccchannel_10_analyzer_1_array_crystal_array_4_material_string, "PG_analyzer" ? "PG_analyzer" : "", 16384); else mccchannel_10_analyzer_1_array_crystal_array_4_material_string[0]='\0';
#line 2775 "MACS_sample_kidney_box.instr"
  mccchannel_10_analyzer_1_array_crystal_array_4_priority = 1220.4;
#line 2774 "MACS_sample_kidney_box.instr"
  mccchannel_10_analyzer_1_array_crystal_array_4_xwidth = channel_10_analyzer_1_array_crystal_depth;
#line 2774 "MACS_sample_kidney_box.instr"
  mccchannel_10_analyzer_1_array_crystal_array_4_yheight = channel_10_analyzer_1_array_crystal_height;
#line 2774 "MACS_sample_kidney_box.instr"
  mccchannel_10_analyzer_1_array_crystal_array_4_zdepth = channel_10_analyzer_1_array_crystal_width;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_10_analyzer_1_array_crystal_array_4_xwidth2 = -1;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_10_analyzer_1_array_crystal_array_4_yheight2 = -1;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_10_analyzer_1_array_crystal_array_4_visualize = 1;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_10_analyzer_1_array_crystal_array_4_target_index = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_10_analyzer_1_array_crystal_array_4_target_x = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_10_analyzer_1_array_crystal_array_4_target_y = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_10_analyzer_1_array_crystal_array_4_target_z = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_10_analyzer_1_array_crystal_array_4_focus_aw = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_10_analyzer_1_array_crystal_array_4_focus_ah = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_10_analyzer_1_array_crystal_array_4_focus_xw = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_10_analyzer_1_array_crystal_array_4_focus_xh = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_10_analyzer_1_array_crystal_array_4_focus_r = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_10_analyzer_1_array_crystal_array_4_p_interact = 0;
#line 71 "MACS_sample_kidney_box.instr"
  if(0) strncpy(mccchannel_10_analyzer_1_array_crystal_array_4_mask_string, 0 ? 0 : "", 16384); else mccchannel_10_analyzer_1_array_crystal_array_4_mask_string[0]='\0';
#line 71 "MACS_sample_kidney_box.instr"
  if(0) strncpy(mccchannel_10_analyzer_1_array_crystal_array_4_mask_setting, 0 ? 0 : "", 16384); else mccchannel_10_analyzer_1_array_crystal_array_4_mask_setting[0]='\0';
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_10_analyzer_1_array_crystal_array_4_number_of_activations = 1;
#line 123883 "MACS_sample_kidney_box.c"

  SIG_MESSAGE("channel_10_analyzer_1_array_crystal_array_4 (Init:Place/Rotate)");
  rot_set_rotation(mctr1,
#line 2777 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 2777 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 2777 "MACS_sample_kidney_box.instr"
    (0 - RAD2DEG * channel_10_analyzer_1_array_theta [ 4 ])*DEG2RAD);
#line 123893 "MACS_sample_kidney_box.c"
  rot_mul(mctr1, mcrotachannel_10_analyzer_1_rotated, mcrotachannel_10_analyzer_1_array_crystal_array_4);
  rot_transpose(mcrotachannel_10_analyzer_1_array_crystal_array_3, mctr1);
  rot_mul(mcrotachannel_10_analyzer_1_array_crystal_array_4, mctr1, mcrotrchannel_10_analyzer_1_array_crystal_array_4);
  mctc1 = coords_set(
#line 2776 "MACS_sample_kidney_box.instr"
    0 + channel_10_analyzer_1_array_effective_radius_of_curvature * ( 1 - cos ( channel_10_analyzer_1_array_theta [ 4 ] ) ),
#line 2776 "MACS_sample_kidney_box.instr"
    0 + channel_10_analyzer_1_array_effective_radius_of_curvature * sin ( channel_10_analyzer_1_array_theta [ 4 ] ),
#line 2776 "MACS_sample_kidney_box.instr"
    0);
#line 123904 "MACS_sample_kidney_box.c"
  rot_transpose(mcrotachannel_10_analyzer_1_rotated, mctr1);
  mctc2 = rot_apply(mctr1, mctc1);
  mcposachannel_10_analyzer_1_array_crystal_array_4 = coords_add(mcposachannel_10_analyzer_1_rotated, mctc2);
  mctc1 = coords_sub(mcposachannel_10_analyzer_1_array_crystal_array_3, mcposachannel_10_analyzer_1_array_crystal_array_4);
  mcposrchannel_10_analyzer_1_array_crystal_array_4 = rot_apply(mcrotachannel_10_analyzer_1_array_crystal_array_4, mctc1);
  mcDEBUG_COMPONENT("channel_10_analyzer_1_array_crystal_array_4", mcposachannel_10_analyzer_1_array_crystal_array_4, mcrotachannel_10_analyzer_1_array_crystal_array_4)
  mccomp_posa[514] = mcposachannel_10_analyzer_1_array_crystal_array_4;
  mccomp_posr[514] = mcposrchannel_10_analyzer_1_array_crystal_array_4;
  mcNCounter[514]  = mcPCounter[514] = mcP2Counter[514] = 0;
  mcAbsorbProp[514]= 0;
    /* Component channel_10_analyzer_1_array_crystal_array_5. */
  /* Setting parameters for component channel_10_analyzer_1_array_crystal_array_5. */
  SIG_MESSAGE("channel_10_analyzer_1_array_crystal_array_5 (Init:SetPar)");
#line 2781 "MACS_sample_kidney_box.instr"
  if("PG_analyzer") strncpy(mccchannel_10_analyzer_1_array_crystal_array_5_material_string, "PG_analyzer" ? "PG_analyzer" : "", 16384); else mccchannel_10_analyzer_1_array_crystal_array_5_material_string[0]='\0';
#line 2781 "MACS_sample_kidney_box.instr"
  mccchannel_10_analyzer_1_array_crystal_array_5_priority = 1220.5;
#line 2780 "MACS_sample_kidney_box.instr"
  mccchannel_10_analyzer_1_array_crystal_array_5_xwidth = channel_10_analyzer_1_array_crystal_depth;
#line 2780 "MACS_sample_kidney_box.instr"
  mccchannel_10_analyzer_1_array_crystal_array_5_yheight = channel_10_analyzer_1_array_crystal_height;
#line 2780 "MACS_sample_kidney_box.instr"
  mccchannel_10_analyzer_1_array_crystal_array_5_zdepth = channel_10_analyzer_1_array_crystal_width;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_10_analyzer_1_array_crystal_array_5_xwidth2 = -1;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_10_analyzer_1_array_crystal_array_5_yheight2 = -1;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_10_analyzer_1_array_crystal_array_5_visualize = 1;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_10_analyzer_1_array_crystal_array_5_target_index = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_10_analyzer_1_array_crystal_array_5_target_x = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_10_analyzer_1_array_crystal_array_5_target_y = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_10_analyzer_1_array_crystal_array_5_target_z = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_10_analyzer_1_array_crystal_array_5_focus_aw = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_10_analyzer_1_array_crystal_array_5_focus_ah = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_10_analyzer_1_array_crystal_array_5_focus_xw = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_10_analyzer_1_array_crystal_array_5_focus_xh = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_10_analyzer_1_array_crystal_array_5_focus_r = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_10_analyzer_1_array_crystal_array_5_p_interact = 0;
#line 71 "MACS_sample_kidney_box.instr"
  if(0) strncpy(mccchannel_10_analyzer_1_array_crystal_array_5_mask_string, 0 ? 0 : "", 16384); else mccchannel_10_analyzer_1_array_crystal_array_5_mask_string[0]='\0';
#line 71 "MACS_sample_kidney_box.instr"
  if(0) strncpy(mccchannel_10_analyzer_1_array_crystal_array_5_mask_setting, 0 ? 0 : "", 16384); else mccchannel_10_analyzer_1_array_crystal_array_5_mask_setting[0]='\0';
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_10_analyzer_1_array_crystal_array_5_number_of_activations = 1;
#line 123960 "MACS_sample_kidney_box.c"

  SIG_MESSAGE("channel_10_analyzer_1_array_crystal_array_5 (Init:Place/Rotate)");
  rot_set_rotation(mctr1,
#line 2783 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 2783 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 2783 "MACS_sample_kidney_box.instr"
    (0 - RAD2DEG * channel_10_analyzer_1_array_theta [ 5 ])*DEG2RAD);
#line 123970 "MACS_sample_kidney_box.c"
  rot_mul(mctr1, mcrotachannel_10_analyzer_1_rotated, mcrotachannel_10_analyzer_1_array_crystal_array_5);
  rot_transpose(mcrotachannel_10_analyzer_1_array_crystal_array_4, mctr1);
  rot_mul(mcrotachannel_10_analyzer_1_array_crystal_array_5, mctr1, mcrotrchannel_10_analyzer_1_array_crystal_array_5);
  mctc1 = coords_set(
#line 2782 "MACS_sample_kidney_box.instr"
    0 + channel_10_analyzer_1_array_effective_radius_of_curvature * ( 1 - cos ( channel_10_analyzer_1_array_theta [ 5 ] ) ),
#line 2782 "MACS_sample_kidney_box.instr"
    0 + channel_10_analyzer_1_array_effective_radius_of_curvature * sin ( channel_10_analyzer_1_array_theta [ 5 ] ),
#line 2782 "MACS_sample_kidney_box.instr"
    0);
#line 123981 "MACS_sample_kidney_box.c"
  rot_transpose(mcrotachannel_10_analyzer_1_rotated, mctr1);
  mctc2 = rot_apply(mctr1, mctc1);
  mcposachannel_10_analyzer_1_array_crystal_array_5 = coords_add(mcposachannel_10_analyzer_1_rotated, mctc2);
  mctc1 = coords_sub(mcposachannel_10_analyzer_1_array_crystal_array_4, mcposachannel_10_analyzer_1_array_crystal_array_5);
  mcposrchannel_10_analyzer_1_array_crystal_array_5 = rot_apply(mcrotachannel_10_analyzer_1_array_crystal_array_5, mctc1);
  mcDEBUG_COMPONENT("channel_10_analyzer_1_array_crystal_array_5", mcposachannel_10_analyzer_1_array_crystal_array_5, mcrotachannel_10_analyzer_1_array_crystal_array_5)
  mccomp_posa[515] = mcposachannel_10_analyzer_1_array_crystal_array_5;
  mccomp_posr[515] = mcposrchannel_10_analyzer_1_array_crystal_array_5;
  mcNCounter[515]  = mcPCounter[515] = mcP2Counter[515] = 0;
  mcAbsorbProp[515]= 0;
    /* Component channel_10_analyzer_1_array_crystal_array_6. */
  /* Setting parameters for component channel_10_analyzer_1_array_crystal_array_6. */
  SIG_MESSAGE("channel_10_analyzer_1_array_crystal_array_6 (Init:SetPar)");
#line 2787 "MACS_sample_kidney_box.instr"
  if("PG_analyzer") strncpy(mccchannel_10_analyzer_1_array_crystal_array_6_material_string, "PG_analyzer" ? "PG_analyzer" : "", 16384); else mccchannel_10_analyzer_1_array_crystal_array_6_material_string[0]='\0';
#line 2787 "MACS_sample_kidney_box.instr"
  mccchannel_10_analyzer_1_array_crystal_array_6_priority = 1220.6;
#line 2786 "MACS_sample_kidney_box.instr"
  mccchannel_10_analyzer_1_array_crystal_array_6_xwidth = channel_10_analyzer_1_array_crystal_depth;
#line 2786 "MACS_sample_kidney_box.instr"
  mccchannel_10_analyzer_1_array_crystal_array_6_yheight = channel_10_analyzer_1_array_crystal_height;
#line 2786 "MACS_sample_kidney_box.instr"
  mccchannel_10_analyzer_1_array_crystal_array_6_zdepth = channel_10_analyzer_1_array_crystal_width;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_10_analyzer_1_array_crystal_array_6_xwidth2 = -1;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_10_analyzer_1_array_crystal_array_6_yheight2 = -1;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_10_analyzer_1_array_crystal_array_6_visualize = 1;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_10_analyzer_1_array_crystal_array_6_target_index = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_10_analyzer_1_array_crystal_array_6_target_x = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_10_analyzer_1_array_crystal_array_6_target_y = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_10_analyzer_1_array_crystal_array_6_target_z = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_10_analyzer_1_array_crystal_array_6_focus_aw = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_10_analyzer_1_array_crystal_array_6_focus_ah = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_10_analyzer_1_array_crystal_array_6_focus_xw = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_10_analyzer_1_array_crystal_array_6_focus_xh = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_10_analyzer_1_array_crystal_array_6_focus_r = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_10_analyzer_1_array_crystal_array_6_p_interact = 0;
#line 71 "MACS_sample_kidney_box.instr"
  if(0) strncpy(mccchannel_10_analyzer_1_array_crystal_array_6_mask_string, 0 ? 0 : "", 16384); else mccchannel_10_analyzer_1_array_crystal_array_6_mask_string[0]='\0';
#line 71 "MACS_sample_kidney_box.instr"
  if(0) strncpy(mccchannel_10_analyzer_1_array_crystal_array_6_mask_setting, 0 ? 0 : "", 16384); else mccchannel_10_analyzer_1_array_crystal_array_6_mask_setting[0]='\0';
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_10_analyzer_1_array_crystal_array_6_number_of_activations = 1;
#line 124037 "MACS_sample_kidney_box.c"

  SIG_MESSAGE("channel_10_analyzer_1_array_crystal_array_6 (Init:Place/Rotate)");
  rot_set_rotation(mctr1,
#line 2789 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 2789 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 2789 "MACS_sample_kidney_box.instr"
    (0 - RAD2DEG * channel_10_analyzer_1_array_theta [ 6 ])*DEG2RAD);
#line 124047 "MACS_sample_kidney_box.c"
  rot_mul(mctr1, mcrotachannel_10_analyzer_1_rotated, mcrotachannel_10_analyzer_1_array_crystal_array_6);
  rot_transpose(mcrotachannel_10_analyzer_1_array_crystal_array_5, mctr1);
  rot_mul(mcrotachannel_10_analyzer_1_array_crystal_array_6, mctr1, mcrotrchannel_10_analyzer_1_array_crystal_array_6);
  mctc1 = coords_set(
#line 2788 "MACS_sample_kidney_box.instr"
    0 + channel_10_analyzer_1_array_effective_radius_of_curvature * ( 1 - cos ( channel_10_analyzer_1_array_theta [ 6 ] ) ),
#line 2788 "MACS_sample_kidney_box.instr"
    0 + channel_10_analyzer_1_array_effective_radius_of_curvature * sin ( channel_10_analyzer_1_array_theta [ 6 ] ),
#line 2788 "MACS_sample_kidney_box.instr"
    0);
#line 124058 "MACS_sample_kidney_box.c"
  rot_transpose(mcrotachannel_10_analyzer_1_rotated, mctr1);
  mctc2 = rot_apply(mctr1, mctc1);
  mcposachannel_10_analyzer_1_array_crystal_array_6 = coords_add(mcposachannel_10_analyzer_1_rotated, mctc2);
  mctc1 = coords_sub(mcposachannel_10_analyzer_1_array_crystal_array_5, mcposachannel_10_analyzer_1_array_crystal_array_6);
  mcposrchannel_10_analyzer_1_array_crystal_array_6 = rot_apply(mcrotachannel_10_analyzer_1_array_crystal_array_6, mctc1);
  mcDEBUG_COMPONENT("channel_10_analyzer_1_array_crystal_array_6", mcposachannel_10_analyzer_1_array_crystal_array_6, mcrotachannel_10_analyzer_1_array_crystal_array_6)
  mccomp_posa[516] = mcposachannel_10_analyzer_1_array_crystal_array_6;
  mccomp_posr[516] = mcposrchannel_10_analyzer_1_array_crystal_array_6;
  mcNCounter[516]  = mcPCounter[516] = mcP2Counter[516] = 0;
  mcAbsorbProp[516]= 0;
    /* Component channel_10_analyzer_1_array_crystal_array_7. */
  /* Setting parameters for component channel_10_analyzer_1_array_crystal_array_7. */
  SIG_MESSAGE("channel_10_analyzer_1_array_crystal_array_7 (Init:SetPar)");
#line 2793 "MACS_sample_kidney_box.instr"
  if("PG_analyzer") strncpy(mccchannel_10_analyzer_1_array_crystal_array_7_material_string, "PG_analyzer" ? "PG_analyzer" : "", 16384); else mccchannel_10_analyzer_1_array_crystal_array_7_material_string[0]='\0';
#line 2793 "MACS_sample_kidney_box.instr"
  mccchannel_10_analyzer_1_array_crystal_array_7_priority = 1220.7;
#line 2792 "MACS_sample_kidney_box.instr"
  mccchannel_10_analyzer_1_array_crystal_array_7_xwidth = channel_10_analyzer_1_array_crystal_depth;
#line 2792 "MACS_sample_kidney_box.instr"
  mccchannel_10_analyzer_1_array_crystal_array_7_yheight = channel_10_analyzer_1_array_crystal_height;
#line 2792 "MACS_sample_kidney_box.instr"
  mccchannel_10_analyzer_1_array_crystal_array_7_zdepth = channel_10_analyzer_1_array_crystal_width;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_10_analyzer_1_array_crystal_array_7_xwidth2 = -1;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_10_analyzer_1_array_crystal_array_7_yheight2 = -1;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_10_analyzer_1_array_crystal_array_7_visualize = 1;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_10_analyzer_1_array_crystal_array_7_target_index = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_10_analyzer_1_array_crystal_array_7_target_x = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_10_analyzer_1_array_crystal_array_7_target_y = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_10_analyzer_1_array_crystal_array_7_target_z = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_10_analyzer_1_array_crystal_array_7_focus_aw = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_10_analyzer_1_array_crystal_array_7_focus_ah = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_10_analyzer_1_array_crystal_array_7_focus_xw = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_10_analyzer_1_array_crystal_array_7_focus_xh = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_10_analyzer_1_array_crystal_array_7_focus_r = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_10_analyzer_1_array_crystal_array_7_p_interact = 0;
#line 71 "MACS_sample_kidney_box.instr"
  if(0) strncpy(mccchannel_10_analyzer_1_array_crystal_array_7_mask_string, 0 ? 0 : "", 16384); else mccchannel_10_analyzer_1_array_crystal_array_7_mask_string[0]='\0';
#line 71 "MACS_sample_kidney_box.instr"
  if(0) strncpy(mccchannel_10_analyzer_1_array_crystal_array_7_mask_setting, 0 ? 0 : "", 16384); else mccchannel_10_analyzer_1_array_crystal_array_7_mask_setting[0]='\0';
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_10_analyzer_1_array_crystal_array_7_number_of_activations = 1;
#line 124114 "MACS_sample_kidney_box.c"

  SIG_MESSAGE("channel_10_analyzer_1_array_crystal_array_7 (Init:Place/Rotate)");
  rot_set_rotation(mctr1,
#line 2795 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 2795 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 2795 "MACS_sample_kidney_box.instr"
    (0 - RAD2DEG * channel_10_analyzer_1_array_theta [ 7 ])*DEG2RAD);
#line 124124 "MACS_sample_kidney_box.c"
  rot_mul(mctr1, mcrotachannel_10_analyzer_1_rotated, mcrotachannel_10_analyzer_1_array_crystal_array_7);
  rot_transpose(mcrotachannel_10_analyzer_1_array_crystal_array_6, mctr1);
  rot_mul(mcrotachannel_10_analyzer_1_array_crystal_array_7, mctr1, mcrotrchannel_10_analyzer_1_array_crystal_array_7);
  mctc1 = coords_set(
#line 2794 "MACS_sample_kidney_box.instr"
    0 + channel_10_analyzer_1_array_effective_radius_of_curvature * ( 1 - cos ( channel_10_analyzer_1_array_theta [ 7 ] ) ),
#line 2794 "MACS_sample_kidney_box.instr"
    0 + channel_10_analyzer_1_array_effective_radius_of_curvature * sin ( channel_10_analyzer_1_array_theta [ 7 ] ),
#line 2794 "MACS_sample_kidney_box.instr"
    0);
#line 124135 "MACS_sample_kidney_box.c"
  rot_transpose(mcrotachannel_10_analyzer_1_rotated, mctr1);
  mctc2 = rot_apply(mctr1, mctc1);
  mcposachannel_10_analyzer_1_array_crystal_array_7 = coords_add(mcposachannel_10_analyzer_1_rotated, mctc2);
  mctc1 = coords_sub(mcposachannel_10_analyzer_1_array_crystal_array_6, mcposachannel_10_analyzer_1_array_crystal_array_7);
  mcposrchannel_10_analyzer_1_array_crystal_array_7 = rot_apply(mcrotachannel_10_analyzer_1_array_crystal_array_7, mctc1);
  mcDEBUG_COMPONENT("channel_10_analyzer_1_array_crystal_array_7", mcposachannel_10_analyzer_1_array_crystal_array_7, mcrotachannel_10_analyzer_1_array_crystal_array_7)
  mccomp_posa[517] = mcposachannel_10_analyzer_1_array_crystal_array_7;
  mccomp_posr[517] = mcposrchannel_10_analyzer_1_array_crystal_array_7;
  mcNCounter[517]  = mcPCounter[517] = mcP2Counter[517] = 0;
  mcAbsorbProp[517]= 0;
    /* Component channel_10_analyzer_1_array_crystal_array_8. */
  /* Setting parameters for component channel_10_analyzer_1_array_crystal_array_8. */
  SIG_MESSAGE("channel_10_analyzer_1_array_crystal_array_8 (Init:SetPar)");
#line 2799 "MACS_sample_kidney_box.instr"
  if("PG_analyzer") strncpy(mccchannel_10_analyzer_1_array_crystal_array_8_material_string, "PG_analyzer" ? "PG_analyzer" : "", 16384); else mccchannel_10_analyzer_1_array_crystal_array_8_material_string[0]='\0';
#line 2799 "MACS_sample_kidney_box.instr"
  mccchannel_10_analyzer_1_array_crystal_array_8_priority = 1220.8;
#line 2798 "MACS_sample_kidney_box.instr"
  mccchannel_10_analyzer_1_array_crystal_array_8_xwidth = channel_10_analyzer_1_array_crystal_depth;
#line 2798 "MACS_sample_kidney_box.instr"
  mccchannel_10_analyzer_1_array_crystal_array_8_yheight = channel_10_analyzer_1_array_crystal_height;
#line 2798 "MACS_sample_kidney_box.instr"
  mccchannel_10_analyzer_1_array_crystal_array_8_zdepth = channel_10_analyzer_1_array_crystal_width;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_10_analyzer_1_array_crystal_array_8_xwidth2 = -1;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_10_analyzer_1_array_crystal_array_8_yheight2 = -1;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_10_analyzer_1_array_crystal_array_8_visualize = 1;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_10_analyzer_1_array_crystal_array_8_target_index = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_10_analyzer_1_array_crystal_array_8_target_x = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_10_analyzer_1_array_crystal_array_8_target_y = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_10_analyzer_1_array_crystal_array_8_target_z = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_10_analyzer_1_array_crystal_array_8_focus_aw = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_10_analyzer_1_array_crystal_array_8_focus_ah = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_10_analyzer_1_array_crystal_array_8_focus_xw = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_10_analyzer_1_array_crystal_array_8_focus_xh = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_10_analyzer_1_array_crystal_array_8_focus_r = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_10_analyzer_1_array_crystal_array_8_p_interact = 0;
#line 71 "MACS_sample_kidney_box.instr"
  if(0) strncpy(mccchannel_10_analyzer_1_array_crystal_array_8_mask_string, 0 ? 0 : "", 16384); else mccchannel_10_analyzer_1_array_crystal_array_8_mask_string[0]='\0';
#line 71 "MACS_sample_kidney_box.instr"
  if(0) strncpy(mccchannel_10_analyzer_1_array_crystal_array_8_mask_setting, 0 ? 0 : "", 16384); else mccchannel_10_analyzer_1_array_crystal_array_8_mask_setting[0]='\0';
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_10_analyzer_1_array_crystal_array_8_number_of_activations = 1;
#line 124191 "MACS_sample_kidney_box.c"

  SIG_MESSAGE("channel_10_analyzer_1_array_crystal_array_8 (Init:Place/Rotate)");
  rot_set_rotation(mctr1,
#line 2801 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 2801 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 2801 "MACS_sample_kidney_box.instr"
    (0 - RAD2DEG * channel_10_analyzer_1_array_theta [ 8 ])*DEG2RAD);
#line 124201 "MACS_sample_kidney_box.c"
  rot_mul(mctr1, mcrotachannel_10_analyzer_1_rotated, mcrotachannel_10_analyzer_1_array_crystal_array_8);
  rot_transpose(mcrotachannel_10_analyzer_1_array_crystal_array_7, mctr1);
  rot_mul(mcrotachannel_10_analyzer_1_array_crystal_array_8, mctr1, mcrotrchannel_10_analyzer_1_array_crystal_array_8);
  mctc1 = coords_set(
#line 2800 "MACS_sample_kidney_box.instr"
    0 + channel_10_analyzer_1_array_effective_radius_of_curvature * ( 1 - cos ( channel_10_analyzer_1_array_theta [ 8 ] ) ),
#line 2800 "MACS_sample_kidney_box.instr"
    0 + channel_10_analyzer_1_array_effective_radius_of_curvature * sin ( channel_10_analyzer_1_array_theta [ 8 ] ),
#line 2800 "MACS_sample_kidney_box.instr"
    0);
#line 124212 "MACS_sample_kidney_box.c"
  rot_transpose(mcrotachannel_10_analyzer_1_rotated, mctr1);
  mctc2 = rot_apply(mctr1, mctc1);
  mcposachannel_10_analyzer_1_array_crystal_array_8 = coords_add(mcposachannel_10_analyzer_1_rotated, mctc2);
  mctc1 = coords_sub(mcposachannel_10_analyzer_1_array_crystal_array_7, mcposachannel_10_analyzer_1_array_crystal_array_8);
  mcposrchannel_10_analyzer_1_array_crystal_array_8 = rot_apply(mcrotachannel_10_analyzer_1_array_crystal_array_8, mctc1);
  mcDEBUG_COMPONENT("channel_10_analyzer_1_array_crystal_array_8", mcposachannel_10_analyzer_1_array_crystal_array_8, mcrotachannel_10_analyzer_1_array_crystal_array_8)
  mccomp_posa[518] = mcposachannel_10_analyzer_1_array_crystal_array_8;
  mccomp_posr[518] = mcposrchannel_10_analyzer_1_array_crystal_array_8;
  mcNCounter[518]  = mcPCounter[518] = mcP2Counter[518] = 0;
  mcAbsorbProp[518]= 0;
    /* Component channel_10_analyzer_2_center. */
  /* Setting parameters for component channel_10_analyzer_2_center. */
  SIG_MESSAGE("channel_10_analyzer_2_center (Init:SetPar)");

  SIG_MESSAGE("channel_10_analyzer_2_center (Init:Place/Rotate)");
  rot_set_rotation(mctr1,
    (0.0)*DEG2RAD,
    (0.0)*DEG2RAD,
    (0.0)*DEG2RAD);
#line 124232 "MACS_sample_kidney_box.c"
  rot_mul(mctr1, mcrotachannel_10_analyzer_1_center, mcrotachannel_10_analyzer_2_center);
  rot_transpose(mcrotachannel_10_analyzer_1_array_crystal_array_8, mctr1);
  rot_mul(mcrotachannel_10_analyzer_2_center, mctr1, mcrotrchannel_10_analyzer_2_center);
  mctc1 = coords_set(
#line 2805 "MACS_sample_kidney_box.instr"
    - analyzer_seperation,
#line 2805 "MACS_sample_kidney_box.instr"
    0,
#line 2805 "MACS_sample_kidney_box.instr"
    0);
#line 124243 "MACS_sample_kidney_box.c"
  rot_transpose(mcrotachannel_10_analyzer_1_center, mctr1);
  mctc2 = rot_apply(mctr1, mctc1);
  mcposachannel_10_analyzer_2_center = coords_add(mcposachannel_10_analyzer_1_center, mctc2);
  mctc1 = coords_sub(mcposachannel_10_analyzer_1_array_crystal_array_8, mcposachannel_10_analyzer_2_center);
  mcposrchannel_10_analyzer_2_center = rot_apply(mcrotachannel_10_analyzer_2_center, mctc1);
  mcDEBUG_COMPONENT("channel_10_analyzer_2_center", mcposachannel_10_analyzer_2_center, mcrotachannel_10_analyzer_2_center)
  mccomp_posa[519] = mcposachannel_10_analyzer_2_center;
  mccomp_posr[519] = mcposrchannel_10_analyzer_2_center;
  mcNCounter[519]  = mcPCounter[519] = mcP2Counter[519] = 0;
  mcAbsorbProp[519]= 0;
    /* Component channel_10_analyzer_2_rotated. */
  /* Setting parameters for component channel_10_analyzer_2_rotated. */
  SIG_MESSAGE("channel_10_analyzer_2_rotated (Init:SetPar)");

  SIG_MESSAGE("channel_10_analyzer_2_rotated (Init:Place/Rotate)");
  rot_set_rotation(mctr1,
#line 2809 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 2809 "MACS_sample_kidney_box.instr"
    (- analyzer_theta [ 10 ])*DEG2RAD,
#line 2809 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD);
#line 124266 "MACS_sample_kidney_box.c"
  rot_mul(mctr1, mcrotachannel_10_analyzer_2_center, mcrotachannel_10_analyzer_2_rotated);
  rot_transpose(mcrotachannel_10_analyzer_2_center, mctr1);
  rot_mul(mcrotachannel_10_analyzer_2_rotated, mctr1, mcrotrchannel_10_analyzer_2_rotated);
  mctc1 = coords_set(
#line 2808 "MACS_sample_kidney_box.instr"
    0,
#line 2808 "MACS_sample_kidney_box.instr"
    0,
#line 2808 "MACS_sample_kidney_box.instr"
    0.5 * analyzer_seperation / tan ( analyzer_2theta [ 10 ] * DEG2RAD ));
#line 124277 "MACS_sample_kidney_box.c"
  rot_transpose(mcrotachannel_10_analyzer_2_center, mctr1);
  mctc2 = rot_apply(mctr1, mctc1);
  mcposachannel_10_analyzer_2_rotated = coords_add(mcposachannel_10_analyzer_2_center, mctc2);
  mctc1 = coords_sub(mcposachannel_10_analyzer_2_center, mcposachannel_10_analyzer_2_rotated);
  mcposrchannel_10_analyzer_2_rotated = rot_apply(mcrotachannel_10_analyzer_2_rotated, mctc1);
  mcDEBUG_COMPONENT("channel_10_analyzer_2_rotated", mcposachannel_10_analyzer_2_rotated, mcrotachannel_10_analyzer_2_rotated)
  mccomp_posa[520] = mcposachannel_10_analyzer_2_rotated;
  mccomp_posr[520] = mcposrchannel_10_analyzer_2_rotated;
  mcNCounter[520]  = mcPCounter[520] = mcP2Counter[520] = 0;
  mcAbsorbProp[520]= 0;
    /* Component channel_10_analyzer_2_array_crystal_array_0. */
  /* Setting parameters for component channel_10_analyzer_2_array_crystal_array_0. */
  SIG_MESSAGE("channel_10_analyzer_2_array_crystal_array_0 (Init:SetPar)");
#line 2813 "MACS_sample_kidney_box.instr"
  if("PG_analyzer") strncpy(mccchannel_10_analyzer_2_array_crystal_array_0_material_string, "PG_analyzer" ? "PG_analyzer" : "", 16384); else mccchannel_10_analyzer_2_array_crystal_array_0_material_string[0]='\0';
#line 2813 "MACS_sample_kidney_box.instr"
  mccchannel_10_analyzer_2_array_crystal_array_0_priority = 1221.0;
#line 2812 "MACS_sample_kidney_box.instr"
  mccchannel_10_analyzer_2_array_crystal_array_0_xwidth = channel_10_analyzer_2_array_crystal_depth;
#line 2812 "MACS_sample_kidney_box.instr"
  mccchannel_10_analyzer_2_array_crystal_array_0_yheight = channel_10_analyzer_2_array_crystal_height;
#line 2812 "MACS_sample_kidney_box.instr"
  mccchannel_10_analyzer_2_array_crystal_array_0_zdepth = channel_10_analyzer_2_array_crystal_width;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_10_analyzer_2_array_crystal_array_0_xwidth2 = -1;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_10_analyzer_2_array_crystal_array_0_yheight2 = -1;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_10_analyzer_2_array_crystal_array_0_visualize = 1;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_10_analyzer_2_array_crystal_array_0_target_index = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_10_analyzer_2_array_crystal_array_0_target_x = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_10_analyzer_2_array_crystal_array_0_target_y = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_10_analyzer_2_array_crystal_array_0_target_z = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_10_analyzer_2_array_crystal_array_0_focus_aw = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_10_analyzer_2_array_crystal_array_0_focus_ah = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_10_analyzer_2_array_crystal_array_0_focus_xw = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_10_analyzer_2_array_crystal_array_0_focus_xh = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_10_analyzer_2_array_crystal_array_0_focus_r = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_10_analyzer_2_array_crystal_array_0_p_interact = 0;
#line 71 "MACS_sample_kidney_box.instr"
  if(0) strncpy(mccchannel_10_analyzer_2_array_crystal_array_0_mask_string, 0 ? 0 : "", 16384); else mccchannel_10_analyzer_2_array_crystal_array_0_mask_string[0]='\0';
#line 71 "MACS_sample_kidney_box.instr"
  if(0) strncpy(mccchannel_10_analyzer_2_array_crystal_array_0_mask_setting, 0 ? 0 : "", 16384); else mccchannel_10_analyzer_2_array_crystal_array_0_mask_setting[0]='\0';
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_10_analyzer_2_array_crystal_array_0_number_of_activations = 1;
#line 124333 "MACS_sample_kidney_box.c"

  SIG_MESSAGE("channel_10_analyzer_2_array_crystal_array_0 (Init:Place/Rotate)");
  rot_set_rotation(mctr1,
#line 2815 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 2815 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 2815 "MACS_sample_kidney_box.instr"
    (0 - RAD2DEG * channel_10_analyzer_2_array_theta [ 0 ])*DEG2RAD);
#line 124343 "MACS_sample_kidney_box.c"
  rot_mul(mctr1, mcrotachannel_10_analyzer_2_rotated, mcrotachannel_10_analyzer_2_array_crystal_array_0);
  rot_transpose(mcrotachannel_10_analyzer_2_rotated, mctr1);
  rot_mul(mcrotachannel_10_analyzer_2_array_crystal_array_0, mctr1, mcrotrchannel_10_analyzer_2_array_crystal_array_0);
  mctc1 = coords_set(
#line 2814 "MACS_sample_kidney_box.instr"
    0 + channel_10_analyzer_2_array_effective_radius_of_curvature * ( 1 - cos ( channel_10_analyzer_2_array_theta [ 0 ] ) ),
#line 2814 "MACS_sample_kidney_box.instr"
    0 + channel_10_analyzer_2_array_effective_radius_of_curvature * sin ( channel_10_analyzer_2_array_theta [ 0 ] ),
#line 2814 "MACS_sample_kidney_box.instr"
    0);
#line 124354 "MACS_sample_kidney_box.c"
  rot_transpose(mcrotachannel_10_analyzer_2_rotated, mctr1);
  mctc2 = rot_apply(mctr1, mctc1);
  mcposachannel_10_analyzer_2_array_crystal_array_0 = coords_add(mcposachannel_10_analyzer_2_rotated, mctc2);
  mctc1 = coords_sub(mcposachannel_10_analyzer_2_rotated, mcposachannel_10_analyzer_2_array_crystal_array_0);
  mcposrchannel_10_analyzer_2_array_crystal_array_0 = rot_apply(mcrotachannel_10_analyzer_2_array_crystal_array_0, mctc1);
  mcDEBUG_COMPONENT("channel_10_analyzer_2_array_crystal_array_0", mcposachannel_10_analyzer_2_array_crystal_array_0, mcrotachannel_10_analyzer_2_array_crystal_array_0)
  mccomp_posa[521] = mcposachannel_10_analyzer_2_array_crystal_array_0;
  mccomp_posr[521] = mcposrchannel_10_analyzer_2_array_crystal_array_0;
  mcNCounter[521]  = mcPCounter[521] = mcP2Counter[521] = 0;
  mcAbsorbProp[521]= 0;
    /* Component channel_10_analyzer_2_array_crystal_array_1. */
  /* Setting parameters for component channel_10_analyzer_2_array_crystal_array_1. */
  SIG_MESSAGE("channel_10_analyzer_2_array_crystal_array_1 (Init:SetPar)");
#line 2819 "MACS_sample_kidney_box.instr"
  if("PG_analyzer") strncpy(mccchannel_10_analyzer_2_array_crystal_array_1_material_string, "PG_analyzer" ? "PG_analyzer" : "", 16384); else mccchannel_10_analyzer_2_array_crystal_array_1_material_string[0]='\0';
#line 2819 "MACS_sample_kidney_box.instr"
  mccchannel_10_analyzer_2_array_crystal_array_1_priority = 1221.1;
#line 2818 "MACS_sample_kidney_box.instr"
  mccchannel_10_analyzer_2_array_crystal_array_1_xwidth = channel_10_analyzer_2_array_crystal_depth;
#line 2818 "MACS_sample_kidney_box.instr"
  mccchannel_10_analyzer_2_array_crystal_array_1_yheight = channel_10_analyzer_2_array_crystal_height;
#line 2818 "MACS_sample_kidney_box.instr"
  mccchannel_10_analyzer_2_array_crystal_array_1_zdepth = channel_10_analyzer_2_array_crystal_width;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_10_analyzer_2_array_crystal_array_1_xwidth2 = -1;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_10_analyzer_2_array_crystal_array_1_yheight2 = -1;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_10_analyzer_2_array_crystal_array_1_visualize = 1;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_10_analyzer_2_array_crystal_array_1_target_index = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_10_analyzer_2_array_crystal_array_1_target_x = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_10_analyzer_2_array_crystal_array_1_target_y = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_10_analyzer_2_array_crystal_array_1_target_z = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_10_analyzer_2_array_crystal_array_1_focus_aw = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_10_analyzer_2_array_crystal_array_1_focus_ah = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_10_analyzer_2_array_crystal_array_1_focus_xw = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_10_analyzer_2_array_crystal_array_1_focus_xh = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_10_analyzer_2_array_crystal_array_1_focus_r = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_10_analyzer_2_array_crystal_array_1_p_interact = 0;
#line 71 "MACS_sample_kidney_box.instr"
  if(0) strncpy(mccchannel_10_analyzer_2_array_crystal_array_1_mask_string, 0 ? 0 : "", 16384); else mccchannel_10_analyzer_2_array_crystal_array_1_mask_string[0]='\0';
#line 71 "MACS_sample_kidney_box.instr"
  if(0) strncpy(mccchannel_10_analyzer_2_array_crystal_array_1_mask_setting, 0 ? 0 : "", 16384); else mccchannel_10_analyzer_2_array_crystal_array_1_mask_setting[0]='\0';
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_10_analyzer_2_array_crystal_array_1_number_of_activations = 1;
#line 124410 "MACS_sample_kidney_box.c"

  SIG_MESSAGE("channel_10_analyzer_2_array_crystal_array_1 (Init:Place/Rotate)");
  rot_set_rotation(mctr1,
#line 2821 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 2821 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 2821 "MACS_sample_kidney_box.instr"
    (0 - RAD2DEG * channel_10_analyzer_2_array_theta [ 1 ])*DEG2RAD);
#line 124420 "MACS_sample_kidney_box.c"
  rot_mul(mctr1, mcrotachannel_10_analyzer_2_rotated, mcrotachannel_10_analyzer_2_array_crystal_array_1);
  rot_transpose(mcrotachannel_10_analyzer_2_array_crystal_array_0, mctr1);
  rot_mul(mcrotachannel_10_analyzer_2_array_crystal_array_1, mctr1, mcrotrchannel_10_analyzer_2_array_crystal_array_1);
  mctc1 = coords_set(
#line 2820 "MACS_sample_kidney_box.instr"
    0 + channel_10_analyzer_2_array_effective_radius_of_curvature * ( 1 - cos ( channel_10_analyzer_2_array_theta [ 1 ] ) ),
#line 2820 "MACS_sample_kidney_box.instr"
    0 + channel_10_analyzer_2_array_effective_radius_of_curvature * sin ( channel_10_analyzer_2_array_theta [ 1 ] ),
#line 2820 "MACS_sample_kidney_box.instr"
    0);
#line 124431 "MACS_sample_kidney_box.c"
  rot_transpose(mcrotachannel_10_analyzer_2_rotated, mctr1);
  mctc2 = rot_apply(mctr1, mctc1);
  mcposachannel_10_analyzer_2_array_crystal_array_1 = coords_add(mcposachannel_10_analyzer_2_rotated, mctc2);
  mctc1 = coords_sub(mcposachannel_10_analyzer_2_array_crystal_array_0, mcposachannel_10_analyzer_2_array_crystal_array_1);
  mcposrchannel_10_analyzer_2_array_crystal_array_1 = rot_apply(mcrotachannel_10_analyzer_2_array_crystal_array_1, mctc1);
  mcDEBUG_COMPONENT("channel_10_analyzer_2_array_crystal_array_1", mcposachannel_10_analyzer_2_array_crystal_array_1, mcrotachannel_10_analyzer_2_array_crystal_array_1)
  mccomp_posa[522] = mcposachannel_10_analyzer_2_array_crystal_array_1;
  mccomp_posr[522] = mcposrchannel_10_analyzer_2_array_crystal_array_1;
  mcNCounter[522]  = mcPCounter[522] = mcP2Counter[522] = 0;
  mcAbsorbProp[522]= 0;
    /* Component channel_10_analyzer_2_array_crystal_array_2. */
  /* Setting parameters for component channel_10_analyzer_2_array_crystal_array_2. */
  SIG_MESSAGE("channel_10_analyzer_2_array_crystal_array_2 (Init:SetPar)");
#line 2825 "MACS_sample_kidney_box.instr"
  if("PG_analyzer") strncpy(mccchannel_10_analyzer_2_array_crystal_array_2_material_string, "PG_analyzer" ? "PG_analyzer" : "", 16384); else mccchannel_10_analyzer_2_array_crystal_array_2_material_string[0]='\0';
#line 2825 "MACS_sample_kidney_box.instr"
  mccchannel_10_analyzer_2_array_crystal_array_2_priority = 1221.2;
#line 2824 "MACS_sample_kidney_box.instr"
  mccchannel_10_analyzer_2_array_crystal_array_2_xwidth = channel_10_analyzer_2_array_crystal_depth;
#line 2824 "MACS_sample_kidney_box.instr"
  mccchannel_10_analyzer_2_array_crystal_array_2_yheight = channel_10_analyzer_2_array_crystal_height;
#line 2824 "MACS_sample_kidney_box.instr"
  mccchannel_10_analyzer_2_array_crystal_array_2_zdepth = channel_10_analyzer_2_array_crystal_width;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_10_analyzer_2_array_crystal_array_2_xwidth2 = -1;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_10_analyzer_2_array_crystal_array_2_yheight2 = -1;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_10_analyzer_2_array_crystal_array_2_visualize = 1;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_10_analyzer_2_array_crystal_array_2_target_index = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_10_analyzer_2_array_crystal_array_2_target_x = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_10_analyzer_2_array_crystal_array_2_target_y = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_10_analyzer_2_array_crystal_array_2_target_z = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_10_analyzer_2_array_crystal_array_2_focus_aw = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_10_analyzer_2_array_crystal_array_2_focus_ah = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_10_analyzer_2_array_crystal_array_2_focus_xw = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_10_analyzer_2_array_crystal_array_2_focus_xh = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_10_analyzer_2_array_crystal_array_2_focus_r = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_10_analyzer_2_array_crystal_array_2_p_interact = 0;
#line 71 "MACS_sample_kidney_box.instr"
  if(0) strncpy(mccchannel_10_analyzer_2_array_crystal_array_2_mask_string, 0 ? 0 : "", 16384); else mccchannel_10_analyzer_2_array_crystal_array_2_mask_string[0]='\0';
#line 71 "MACS_sample_kidney_box.instr"
  if(0) strncpy(mccchannel_10_analyzer_2_array_crystal_array_2_mask_setting, 0 ? 0 : "", 16384); else mccchannel_10_analyzer_2_array_crystal_array_2_mask_setting[0]='\0';
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_10_analyzer_2_array_crystal_array_2_number_of_activations = 1;
#line 124487 "MACS_sample_kidney_box.c"

  SIG_MESSAGE("channel_10_analyzer_2_array_crystal_array_2 (Init:Place/Rotate)");
  rot_set_rotation(mctr1,
#line 2827 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 2827 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 2827 "MACS_sample_kidney_box.instr"
    (0 - RAD2DEG * channel_10_analyzer_2_array_theta [ 2 ])*DEG2RAD);
#line 124497 "MACS_sample_kidney_box.c"
  rot_mul(mctr1, mcrotachannel_10_analyzer_2_rotated, mcrotachannel_10_analyzer_2_array_crystal_array_2);
  rot_transpose(mcrotachannel_10_analyzer_2_array_crystal_array_1, mctr1);
  rot_mul(mcrotachannel_10_analyzer_2_array_crystal_array_2, mctr1, mcrotrchannel_10_analyzer_2_array_crystal_array_2);
  mctc1 = coords_set(
#line 2826 "MACS_sample_kidney_box.instr"
    0 + channel_10_analyzer_2_array_effective_radius_of_curvature * ( 1 - cos ( channel_10_analyzer_2_array_theta [ 2 ] ) ),
#line 2826 "MACS_sample_kidney_box.instr"
    0 + channel_10_analyzer_2_array_effective_radius_of_curvature * sin ( channel_10_analyzer_2_array_theta [ 2 ] ),
#line 2826 "MACS_sample_kidney_box.instr"
    0);
#line 124508 "MACS_sample_kidney_box.c"
  rot_transpose(mcrotachannel_10_analyzer_2_rotated, mctr1);
  mctc2 = rot_apply(mctr1, mctc1);
  mcposachannel_10_analyzer_2_array_crystal_array_2 = coords_add(mcposachannel_10_analyzer_2_rotated, mctc2);
  mctc1 = coords_sub(mcposachannel_10_analyzer_2_array_crystal_array_1, mcposachannel_10_analyzer_2_array_crystal_array_2);
  mcposrchannel_10_analyzer_2_array_crystal_array_2 = rot_apply(mcrotachannel_10_analyzer_2_array_crystal_array_2, mctc1);
  mcDEBUG_COMPONENT("channel_10_analyzer_2_array_crystal_array_2", mcposachannel_10_analyzer_2_array_crystal_array_2, mcrotachannel_10_analyzer_2_array_crystal_array_2)
  mccomp_posa[523] = mcposachannel_10_analyzer_2_array_crystal_array_2;
  mccomp_posr[523] = mcposrchannel_10_analyzer_2_array_crystal_array_2;
  mcNCounter[523]  = mcPCounter[523] = mcP2Counter[523] = 0;
  mcAbsorbProp[523]= 0;
    /* Component channel_10_analyzer_2_array_crystal_array_3. */
  /* Setting parameters for component channel_10_analyzer_2_array_crystal_array_3. */
  SIG_MESSAGE("channel_10_analyzer_2_array_crystal_array_3 (Init:SetPar)");
#line 2831 "MACS_sample_kidney_box.instr"
  if("PG_analyzer") strncpy(mccchannel_10_analyzer_2_array_crystal_array_3_material_string, "PG_analyzer" ? "PG_analyzer" : "", 16384); else mccchannel_10_analyzer_2_array_crystal_array_3_material_string[0]='\0';
#line 2831 "MACS_sample_kidney_box.instr"
  mccchannel_10_analyzer_2_array_crystal_array_3_priority = 1221.3;
#line 2830 "MACS_sample_kidney_box.instr"
  mccchannel_10_analyzer_2_array_crystal_array_3_xwidth = channel_10_analyzer_2_array_crystal_depth;
#line 2830 "MACS_sample_kidney_box.instr"
  mccchannel_10_analyzer_2_array_crystal_array_3_yheight = channel_10_analyzer_2_array_crystal_height;
#line 2830 "MACS_sample_kidney_box.instr"
  mccchannel_10_analyzer_2_array_crystal_array_3_zdepth = channel_10_analyzer_2_array_crystal_width;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_10_analyzer_2_array_crystal_array_3_xwidth2 = -1;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_10_analyzer_2_array_crystal_array_3_yheight2 = -1;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_10_analyzer_2_array_crystal_array_3_visualize = 1;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_10_analyzer_2_array_crystal_array_3_target_index = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_10_analyzer_2_array_crystal_array_3_target_x = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_10_analyzer_2_array_crystal_array_3_target_y = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_10_analyzer_2_array_crystal_array_3_target_z = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_10_analyzer_2_array_crystal_array_3_focus_aw = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_10_analyzer_2_array_crystal_array_3_focus_ah = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_10_analyzer_2_array_crystal_array_3_focus_xw = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_10_analyzer_2_array_crystal_array_3_focus_xh = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_10_analyzer_2_array_crystal_array_3_focus_r = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_10_analyzer_2_array_crystal_array_3_p_interact = 0;
#line 71 "MACS_sample_kidney_box.instr"
  if(0) strncpy(mccchannel_10_analyzer_2_array_crystal_array_3_mask_string, 0 ? 0 : "", 16384); else mccchannel_10_analyzer_2_array_crystal_array_3_mask_string[0]='\0';
#line 71 "MACS_sample_kidney_box.instr"
  if(0) strncpy(mccchannel_10_analyzer_2_array_crystal_array_3_mask_setting, 0 ? 0 : "", 16384); else mccchannel_10_analyzer_2_array_crystal_array_3_mask_setting[0]='\0';
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_10_analyzer_2_array_crystal_array_3_number_of_activations = 1;
#line 124564 "MACS_sample_kidney_box.c"

  SIG_MESSAGE("channel_10_analyzer_2_array_crystal_array_3 (Init:Place/Rotate)");
  rot_set_rotation(mctr1,
#line 2833 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 2833 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 2833 "MACS_sample_kidney_box.instr"
    (0 - RAD2DEG * channel_10_analyzer_2_array_theta [ 3 ])*DEG2RAD);
#line 124574 "MACS_sample_kidney_box.c"
  rot_mul(mctr1, mcrotachannel_10_analyzer_2_rotated, mcrotachannel_10_analyzer_2_array_crystal_array_3);
  rot_transpose(mcrotachannel_10_analyzer_2_array_crystal_array_2, mctr1);
  rot_mul(mcrotachannel_10_analyzer_2_array_crystal_array_3, mctr1, mcrotrchannel_10_analyzer_2_array_crystal_array_3);
  mctc1 = coords_set(
#line 2832 "MACS_sample_kidney_box.instr"
    0 + channel_10_analyzer_2_array_effective_radius_of_curvature * ( 1 - cos ( channel_10_analyzer_2_array_theta [ 3 ] ) ),
#line 2832 "MACS_sample_kidney_box.instr"
    0 + channel_10_analyzer_2_array_effective_radius_of_curvature * sin ( channel_10_analyzer_2_array_theta [ 3 ] ),
#line 2832 "MACS_sample_kidney_box.instr"
    0);
#line 124585 "MACS_sample_kidney_box.c"
  rot_transpose(mcrotachannel_10_analyzer_2_rotated, mctr1);
  mctc2 = rot_apply(mctr1, mctc1);
  mcposachannel_10_analyzer_2_array_crystal_array_3 = coords_add(mcposachannel_10_analyzer_2_rotated, mctc2);
  mctc1 = coords_sub(mcposachannel_10_analyzer_2_array_crystal_array_2, mcposachannel_10_analyzer_2_array_crystal_array_3);
  mcposrchannel_10_analyzer_2_array_crystal_array_3 = rot_apply(mcrotachannel_10_analyzer_2_array_crystal_array_3, mctc1);
  mcDEBUG_COMPONENT("channel_10_analyzer_2_array_crystal_array_3", mcposachannel_10_analyzer_2_array_crystal_array_3, mcrotachannel_10_analyzer_2_array_crystal_array_3)
  mccomp_posa[524] = mcposachannel_10_analyzer_2_array_crystal_array_3;
  mccomp_posr[524] = mcposrchannel_10_analyzer_2_array_crystal_array_3;
  mcNCounter[524]  = mcPCounter[524] = mcP2Counter[524] = 0;
  mcAbsorbProp[524]= 0;
    /* Component channel_10_analyzer_2_array_crystal_array_4. */
  /* Setting parameters for component channel_10_analyzer_2_array_crystal_array_4. */
  SIG_MESSAGE("channel_10_analyzer_2_array_crystal_array_4 (Init:SetPar)");
#line 2837 "MACS_sample_kidney_box.instr"
  if("PG_analyzer") strncpy(mccchannel_10_analyzer_2_array_crystal_array_4_material_string, "PG_analyzer" ? "PG_analyzer" : "", 16384); else mccchannel_10_analyzer_2_array_crystal_array_4_material_string[0]='\0';
#line 2837 "MACS_sample_kidney_box.instr"
  mccchannel_10_analyzer_2_array_crystal_array_4_priority = 1221.4;
#line 2836 "MACS_sample_kidney_box.instr"
  mccchannel_10_analyzer_2_array_crystal_array_4_xwidth = channel_10_analyzer_2_array_crystal_depth;
#line 2836 "MACS_sample_kidney_box.instr"
  mccchannel_10_analyzer_2_array_crystal_array_4_yheight = channel_10_analyzer_2_array_crystal_height;
#line 2836 "MACS_sample_kidney_box.instr"
  mccchannel_10_analyzer_2_array_crystal_array_4_zdepth = channel_10_analyzer_2_array_crystal_width;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_10_analyzer_2_array_crystal_array_4_xwidth2 = -1;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_10_analyzer_2_array_crystal_array_4_yheight2 = -1;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_10_analyzer_2_array_crystal_array_4_visualize = 1;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_10_analyzer_2_array_crystal_array_4_target_index = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_10_analyzer_2_array_crystal_array_4_target_x = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_10_analyzer_2_array_crystal_array_4_target_y = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_10_analyzer_2_array_crystal_array_4_target_z = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_10_analyzer_2_array_crystal_array_4_focus_aw = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_10_analyzer_2_array_crystal_array_4_focus_ah = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_10_analyzer_2_array_crystal_array_4_focus_xw = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_10_analyzer_2_array_crystal_array_4_focus_xh = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_10_analyzer_2_array_crystal_array_4_focus_r = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_10_analyzer_2_array_crystal_array_4_p_interact = 0;
#line 71 "MACS_sample_kidney_box.instr"
  if(0) strncpy(mccchannel_10_analyzer_2_array_crystal_array_4_mask_string, 0 ? 0 : "", 16384); else mccchannel_10_analyzer_2_array_crystal_array_4_mask_string[0]='\0';
#line 71 "MACS_sample_kidney_box.instr"
  if(0) strncpy(mccchannel_10_analyzer_2_array_crystal_array_4_mask_setting, 0 ? 0 : "", 16384); else mccchannel_10_analyzer_2_array_crystal_array_4_mask_setting[0]='\0';
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_10_analyzer_2_array_crystal_array_4_number_of_activations = 1;
#line 124641 "MACS_sample_kidney_box.c"

  SIG_MESSAGE("channel_10_analyzer_2_array_crystal_array_4 (Init:Place/Rotate)");
  rot_set_rotation(mctr1,
#line 2839 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 2839 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 2839 "MACS_sample_kidney_box.instr"
    (0 - RAD2DEG * channel_10_analyzer_2_array_theta [ 4 ])*DEG2RAD);
#line 124651 "MACS_sample_kidney_box.c"
  rot_mul(mctr1, mcrotachannel_10_analyzer_2_rotated, mcrotachannel_10_analyzer_2_array_crystal_array_4);
  rot_transpose(mcrotachannel_10_analyzer_2_array_crystal_array_3, mctr1);
  rot_mul(mcrotachannel_10_analyzer_2_array_crystal_array_4, mctr1, mcrotrchannel_10_analyzer_2_array_crystal_array_4);
  mctc1 = coords_set(
#line 2838 "MACS_sample_kidney_box.instr"
    0 + channel_10_analyzer_2_array_effective_radius_of_curvature * ( 1 - cos ( channel_10_analyzer_2_array_theta [ 4 ] ) ),
#line 2838 "MACS_sample_kidney_box.instr"
    0 + channel_10_analyzer_2_array_effective_radius_of_curvature * sin ( channel_10_analyzer_2_array_theta [ 4 ] ),
#line 2838 "MACS_sample_kidney_box.instr"
    0);
#line 124662 "MACS_sample_kidney_box.c"
  rot_transpose(mcrotachannel_10_analyzer_2_rotated, mctr1);
  mctc2 = rot_apply(mctr1, mctc1);
  mcposachannel_10_analyzer_2_array_crystal_array_4 = coords_add(mcposachannel_10_analyzer_2_rotated, mctc2);
  mctc1 = coords_sub(mcposachannel_10_analyzer_2_array_crystal_array_3, mcposachannel_10_analyzer_2_array_crystal_array_4);
  mcposrchannel_10_analyzer_2_array_crystal_array_4 = rot_apply(mcrotachannel_10_analyzer_2_array_crystal_array_4, mctc1);
  mcDEBUG_COMPONENT("channel_10_analyzer_2_array_crystal_array_4", mcposachannel_10_analyzer_2_array_crystal_array_4, mcrotachannel_10_analyzer_2_array_crystal_array_4)
  mccomp_posa[525] = mcposachannel_10_analyzer_2_array_crystal_array_4;
  mccomp_posr[525] = mcposrchannel_10_analyzer_2_array_crystal_array_4;
  mcNCounter[525]  = mcPCounter[525] = mcP2Counter[525] = 0;
  mcAbsorbProp[525]= 0;
    /* Component channel_10_analyzer_2_array_crystal_array_5. */
  /* Setting parameters for component channel_10_analyzer_2_array_crystal_array_5. */
  SIG_MESSAGE("channel_10_analyzer_2_array_crystal_array_5 (Init:SetPar)");
#line 2843 "MACS_sample_kidney_box.instr"
  if("PG_analyzer") strncpy(mccchannel_10_analyzer_2_array_crystal_array_5_material_string, "PG_analyzer" ? "PG_analyzer" : "", 16384); else mccchannel_10_analyzer_2_array_crystal_array_5_material_string[0]='\0';
#line 2843 "MACS_sample_kidney_box.instr"
  mccchannel_10_analyzer_2_array_crystal_array_5_priority = 1221.5;
#line 2842 "MACS_sample_kidney_box.instr"
  mccchannel_10_analyzer_2_array_crystal_array_5_xwidth = channel_10_analyzer_2_array_crystal_depth;
#line 2842 "MACS_sample_kidney_box.instr"
  mccchannel_10_analyzer_2_array_crystal_array_5_yheight = channel_10_analyzer_2_array_crystal_height;
#line 2842 "MACS_sample_kidney_box.instr"
  mccchannel_10_analyzer_2_array_crystal_array_5_zdepth = channel_10_analyzer_2_array_crystal_width;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_10_analyzer_2_array_crystal_array_5_xwidth2 = -1;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_10_analyzer_2_array_crystal_array_5_yheight2 = -1;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_10_analyzer_2_array_crystal_array_5_visualize = 1;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_10_analyzer_2_array_crystal_array_5_target_index = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_10_analyzer_2_array_crystal_array_5_target_x = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_10_analyzer_2_array_crystal_array_5_target_y = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_10_analyzer_2_array_crystal_array_5_target_z = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_10_analyzer_2_array_crystal_array_5_focus_aw = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_10_analyzer_2_array_crystal_array_5_focus_ah = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_10_analyzer_2_array_crystal_array_5_focus_xw = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_10_analyzer_2_array_crystal_array_5_focus_xh = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_10_analyzer_2_array_crystal_array_5_focus_r = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_10_analyzer_2_array_crystal_array_5_p_interact = 0;
#line 71 "MACS_sample_kidney_box.instr"
  if(0) strncpy(mccchannel_10_analyzer_2_array_crystal_array_5_mask_string, 0 ? 0 : "", 16384); else mccchannel_10_analyzer_2_array_crystal_array_5_mask_string[0]='\0';
#line 71 "MACS_sample_kidney_box.instr"
  if(0) strncpy(mccchannel_10_analyzer_2_array_crystal_array_5_mask_setting, 0 ? 0 : "", 16384); else mccchannel_10_analyzer_2_array_crystal_array_5_mask_setting[0]='\0';
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_10_analyzer_2_array_crystal_array_5_number_of_activations = 1;
#line 124718 "MACS_sample_kidney_box.c"

  SIG_MESSAGE("channel_10_analyzer_2_array_crystal_array_5 (Init:Place/Rotate)");
  rot_set_rotation(mctr1,
#line 2845 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 2845 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 2845 "MACS_sample_kidney_box.instr"
    (0 - RAD2DEG * channel_10_analyzer_2_array_theta [ 5 ])*DEG2RAD);
#line 124728 "MACS_sample_kidney_box.c"
  rot_mul(mctr1, mcrotachannel_10_analyzer_2_rotated, mcrotachannel_10_analyzer_2_array_crystal_array_5);
  rot_transpose(mcrotachannel_10_analyzer_2_array_crystal_array_4, mctr1);
  rot_mul(mcrotachannel_10_analyzer_2_array_crystal_array_5, mctr1, mcrotrchannel_10_analyzer_2_array_crystal_array_5);
  mctc1 = coords_set(
#line 2844 "MACS_sample_kidney_box.instr"
    0 + channel_10_analyzer_2_array_effective_radius_of_curvature * ( 1 - cos ( channel_10_analyzer_2_array_theta [ 5 ] ) ),
#line 2844 "MACS_sample_kidney_box.instr"
    0 + channel_10_analyzer_2_array_effective_radius_of_curvature * sin ( channel_10_analyzer_2_array_theta [ 5 ] ),
#line 2844 "MACS_sample_kidney_box.instr"
    0);
#line 124739 "MACS_sample_kidney_box.c"
  rot_transpose(mcrotachannel_10_analyzer_2_rotated, mctr1);
  mctc2 = rot_apply(mctr1, mctc1);
  mcposachannel_10_analyzer_2_array_crystal_array_5 = coords_add(mcposachannel_10_analyzer_2_rotated, mctc2);
  mctc1 = coords_sub(mcposachannel_10_analyzer_2_array_crystal_array_4, mcposachannel_10_analyzer_2_array_crystal_array_5);
  mcposrchannel_10_analyzer_2_array_crystal_array_5 = rot_apply(mcrotachannel_10_analyzer_2_array_crystal_array_5, mctc1);
  mcDEBUG_COMPONENT("channel_10_analyzer_2_array_crystal_array_5", mcposachannel_10_analyzer_2_array_crystal_array_5, mcrotachannel_10_analyzer_2_array_crystal_array_5)
  mccomp_posa[526] = mcposachannel_10_analyzer_2_array_crystal_array_5;
  mccomp_posr[526] = mcposrchannel_10_analyzer_2_array_crystal_array_5;
  mcNCounter[526]  = mcPCounter[526] = mcP2Counter[526] = 0;
  mcAbsorbProp[526]= 0;
    /* Component channel_10_analyzer_2_array_crystal_array_6. */
  /* Setting parameters for component channel_10_analyzer_2_array_crystal_array_6. */
  SIG_MESSAGE("channel_10_analyzer_2_array_crystal_array_6 (Init:SetPar)");
#line 2849 "MACS_sample_kidney_box.instr"
  if("PG_analyzer") strncpy(mccchannel_10_analyzer_2_array_crystal_array_6_material_string, "PG_analyzer" ? "PG_analyzer" : "", 16384); else mccchannel_10_analyzer_2_array_crystal_array_6_material_string[0]='\0';
#line 2849 "MACS_sample_kidney_box.instr"
  mccchannel_10_analyzer_2_array_crystal_array_6_priority = 1221.6;
#line 2848 "MACS_sample_kidney_box.instr"
  mccchannel_10_analyzer_2_array_crystal_array_6_xwidth = channel_10_analyzer_2_array_crystal_depth;
#line 2848 "MACS_sample_kidney_box.instr"
  mccchannel_10_analyzer_2_array_crystal_array_6_yheight = channel_10_analyzer_2_array_crystal_height;
#line 2848 "MACS_sample_kidney_box.instr"
  mccchannel_10_analyzer_2_array_crystal_array_6_zdepth = channel_10_analyzer_2_array_crystal_width;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_10_analyzer_2_array_crystal_array_6_xwidth2 = -1;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_10_analyzer_2_array_crystal_array_6_yheight2 = -1;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_10_analyzer_2_array_crystal_array_6_visualize = 1;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_10_analyzer_2_array_crystal_array_6_target_index = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_10_analyzer_2_array_crystal_array_6_target_x = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_10_analyzer_2_array_crystal_array_6_target_y = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_10_analyzer_2_array_crystal_array_6_target_z = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_10_analyzer_2_array_crystal_array_6_focus_aw = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_10_analyzer_2_array_crystal_array_6_focus_ah = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_10_analyzer_2_array_crystal_array_6_focus_xw = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_10_analyzer_2_array_crystal_array_6_focus_xh = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_10_analyzer_2_array_crystal_array_6_focus_r = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_10_analyzer_2_array_crystal_array_6_p_interact = 0;
#line 71 "MACS_sample_kidney_box.instr"
  if(0) strncpy(mccchannel_10_analyzer_2_array_crystal_array_6_mask_string, 0 ? 0 : "", 16384); else mccchannel_10_analyzer_2_array_crystal_array_6_mask_string[0]='\0';
#line 71 "MACS_sample_kidney_box.instr"
  if(0) strncpy(mccchannel_10_analyzer_2_array_crystal_array_6_mask_setting, 0 ? 0 : "", 16384); else mccchannel_10_analyzer_2_array_crystal_array_6_mask_setting[0]='\0';
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_10_analyzer_2_array_crystal_array_6_number_of_activations = 1;
#line 124795 "MACS_sample_kidney_box.c"

  SIG_MESSAGE("channel_10_analyzer_2_array_crystal_array_6 (Init:Place/Rotate)");
  rot_set_rotation(mctr1,
#line 2851 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 2851 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 2851 "MACS_sample_kidney_box.instr"
    (0 - RAD2DEG * channel_10_analyzer_2_array_theta [ 6 ])*DEG2RAD);
#line 124805 "MACS_sample_kidney_box.c"
  rot_mul(mctr1, mcrotachannel_10_analyzer_2_rotated, mcrotachannel_10_analyzer_2_array_crystal_array_6);
  rot_transpose(mcrotachannel_10_analyzer_2_array_crystal_array_5, mctr1);
  rot_mul(mcrotachannel_10_analyzer_2_array_crystal_array_6, mctr1, mcrotrchannel_10_analyzer_2_array_crystal_array_6);
  mctc1 = coords_set(
#line 2850 "MACS_sample_kidney_box.instr"
    0 + channel_10_analyzer_2_array_effective_radius_of_curvature * ( 1 - cos ( channel_10_analyzer_2_array_theta [ 6 ] ) ),
#line 2850 "MACS_sample_kidney_box.instr"
    0 + channel_10_analyzer_2_array_effective_radius_of_curvature * sin ( channel_10_analyzer_2_array_theta [ 6 ] ),
#line 2850 "MACS_sample_kidney_box.instr"
    0);
#line 124816 "MACS_sample_kidney_box.c"
  rot_transpose(mcrotachannel_10_analyzer_2_rotated, mctr1);
  mctc2 = rot_apply(mctr1, mctc1);
  mcposachannel_10_analyzer_2_array_crystal_array_6 = coords_add(mcposachannel_10_analyzer_2_rotated, mctc2);
  mctc1 = coords_sub(mcposachannel_10_analyzer_2_array_crystal_array_5, mcposachannel_10_analyzer_2_array_crystal_array_6);
  mcposrchannel_10_analyzer_2_array_crystal_array_6 = rot_apply(mcrotachannel_10_analyzer_2_array_crystal_array_6, mctc1);
  mcDEBUG_COMPONENT("channel_10_analyzer_2_array_crystal_array_6", mcposachannel_10_analyzer_2_array_crystal_array_6, mcrotachannel_10_analyzer_2_array_crystal_array_6)
  mccomp_posa[527] = mcposachannel_10_analyzer_2_array_crystal_array_6;
  mccomp_posr[527] = mcposrchannel_10_analyzer_2_array_crystal_array_6;
  mcNCounter[527]  = mcPCounter[527] = mcP2Counter[527] = 0;
  mcAbsorbProp[527]= 0;
    /* Component channel_10_analyzer_2_array_crystal_array_7. */
  /* Setting parameters for component channel_10_analyzer_2_array_crystal_array_7. */
  SIG_MESSAGE("channel_10_analyzer_2_array_crystal_array_7 (Init:SetPar)");
#line 2855 "MACS_sample_kidney_box.instr"
  if("PG_analyzer") strncpy(mccchannel_10_analyzer_2_array_crystal_array_7_material_string, "PG_analyzer" ? "PG_analyzer" : "", 16384); else mccchannel_10_analyzer_2_array_crystal_array_7_material_string[0]='\0';
#line 2855 "MACS_sample_kidney_box.instr"
  mccchannel_10_analyzer_2_array_crystal_array_7_priority = 1221.7;
#line 2854 "MACS_sample_kidney_box.instr"
  mccchannel_10_analyzer_2_array_crystal_array_7_xwidth = channel_10_analyzer_2_array_crystal_depth;
#line 2854 "MACS_sample_kidney_box.instr"
  mccchannel_10_analyzer_2_array_crystal_array_7_yheight = channel_10_analyzer_2_array_crystal_height;
#line 2854 "MACS_sample_kidney_box.instr"
  mccchannel_10_analyzer_2_array_crystal_array_7_zdepth = channel_10_analyzer_2_array_crystal_width;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_10_analyzer_2_array_crystal_array_7_xwidth2 = -1;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_10_analyzer_2_array_crystal_array_7_yheight2 = -1;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_10_analyzer_2_array_crystal_array_7_visualize = 1;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_10_analyzer_2_array_crystal_array_7_target_index = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_10_analyzer_2_array_crystal_array_7_target_x = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_10_analyzer_2_array_crystal_array_7_target_y = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_10_analyzer_2_array_crystal_array_7_target_z = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_10_analyzer_2_array_crystal_array_7_focus_aw = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_10_analyzer_2_array_crystal_array_7_focus_ah = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_10_analyzer_2_array_crystal_array_7_focus_xw = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_10_analyzer_2_array_crystal_array_7_focus_xh = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_10_analyzer_2_array_crystal_array_7_focus_r = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_10_analyzer_2_array_crystal_array_7_p_interact = 0;
#line 71 "MACS_sample_kidney_box.instr"
  if(0) strncpy(mccchannel_10_analyzer_2_array_crystal_array_7_mask_string, 0 ? 0 : "", 16384); else mccchannel_10_analyzer_2_array_crystal_array_7_mask_string[0]='\0';
#line 71 "MACS_sample_kidney_box.instr"
  if(0) strncpy(mccchannel_10_analyzer_2_array_crystal_array_7_mask_setting, 0 ? 0 : "", 16384); else mccchannel_10_analyzer_2_array_crystal_array_7_mask_setting[0]='\0';
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_10_analyzer_2_array_crystal_array_7_number_of_activations = 1;
#line 124872 "MACS_sample_kidney_box.c"

  SIG_MESSAGE("channel_10_analyzer_2_array_crystal_array_7 (Init:Place/Rotate)");
  rot_set_rotation(mctr1,
#line 2857 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 2857 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 2857 "MACS_sample_kidney_box.instr"
    (0 - RAD2DEG * channel_10_analyzer_2_array_theta [ 7 ])*DEG2RAD);
#line 124882 "MACS_sample_kidney_box.c"
  rot_mul(mctr1, mcrotachannel_10_analyzer_2_rotated, mcrotachannel_10_analyzer_2_array_crystal_array_7);
  rot_transpose(mcrotachannel_10_analyzer_2_array_crystal_array_6, mctr1);
  rot_mul(mcrotachannel_10_analyzer_2_array_crystal_array_7, mctr1, mcrotrchannel_10_analyzer_2_array_crystal_array_7);
  mctc1 = coords_set(
#line 2856 "MACS_sample_kidney_box.instr"
    0 + channel_10_analyzer_2_array_effective_radius_of_curvature * ( 1 - cos ( channel_10_analyzer_2_array_theta [ 7 ] ) ),
#line 2856 "MACS_sample_kidney_box.instr"
    0 + channel_10_analyzer_2_array_effective_radius_of_curvature * sin ( channel_10_analyzer_2_array_theta [ 7 ] ),
#line 2856 "MACS_sample_kidney_box.instr"
    0);
#line 124893 "MACS_sample_kidney_box.c"
  rot_transpose(mcrotachannel_10_analyzer_2_rotated, mctr1);
  mctc2 = rot_apply(mctr1, mctc1);
  mcposachannel_10_analyzer_2_array_crystal_array_7 = coords_add(mcposachannel_10_analyzer_2_rotated, mctc2);
  mctc1 = coords_sub(mcposachannel_10_analyzer_2_array_crystal_array_6, mcposachannel_10_analyzer_2_array_crystal_array_7);
  mcposrchannel_10_analyzer_2_array_crystal_array_7 = rot_apply(mcrotachannel_10_analyzer_2_array_crystal_array_7, mctc1);
  mcDEBUG_COMPONENT("channel_10_analyzer_2_array_crystal_array_7", mcposachannel_10_analyzer_2_array_crystal_array_7, mcrotachannel_10_analyzer_2_array_crystal_array_7)
  mccomp_posa[528] = mcposachannel_10_analyzer_2_array_crystal_array_7;
  mccomp_posr[528] = mcposrchannel_10_analyzer_2_array_crystal_array_7;
  mcNCounter[528]  = mcPCounter[528] = mcP2Counter[528] = 0;
  mcAbsorbProp[528]= 0;
    /* Component channel_10_analyzer_2_array_crystal_array_8. */
  /* Setting parameters for component channel_10_analyzer_2_array_crystal_array_8. */
  SIG_MESSAGE("channel_10_analyzer_2_array_crystal_array_8 (Init:SetPar)");
#line 2861 "MACS_sample_kidney_box.instr"
  if("PG_analyzer") strncpy(mccchannel_10_analyzer_2_array_crystal_array_8_material_string, "PG_analyzer" ? "PG_analyzer" : "", 16384); else mccchannel_10_analyzer_2_array_crystal_array_8_material_string[0]='\0';
#line 2861 "MACS_sample_kidney_box.instr"
  mccchannel_10_analyzer_2_array_crystal_array_8_priority = 1221.8;
#line 2860 "MACS_sample_kidney_box.instr"
  mccchannel_10_analyzer_2_array_crystal_array_8_xwidth = channel_10_analyzer_2_array_crystal_depth;
#line 2860 "MACS_sample_kidney_box.instr"
  mccchannel_10_analyzer_2_array_crystal_array_8_yheight = channel_10_analyzer_2_array_crystal_height;
#line 2860 "MACS_sample_kidney_box.instr"
  mccchannel_10_analyzer_2_array_crystal_array_8_zdepth = channel_10_analyzer_2_array_crystal_width;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_10_analyzer_2_array_crystal_array_8_xwidth2 = -1;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_10_analyzer_2_array_crystal_array_8_yheight2 = -1;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_10_analyzer_2_array_crystal_array_8_visualize = 1;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_10_analyzer_2_array_crystal_array_8_target_index = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_10_analyzer_2_array_crystal_array_8_target_x = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_10_analyzer_2_array_crystal_array_8_target_y = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_10_analyzer_2_array_crystal_array_8_target_z = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_10_analyzer_2_array_crystal_array_8_focus_aw = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_10_analyzer_2_array_crystal_array_8_focus_ah = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_10_analyzer_2_array_crystal_array_8_focus_xw = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_10_analyzer_2_array_crystal_array_8_focus_xh = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_10_analyzer_2_array_crystal_array_8_focus_r = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_10_analyzer_2_array_crystal_array_8_p_interact = 0;
#line 71 "MACS_sample_kidney_box.instr"
  if(0) strncpy(mccchannel_10_analyzer_2_array_crystal_array_8_mask_string, 0 ? 0 : "", 16384); else mccchannel_10_analyzer_2_array_crystal_array_8_mask_string[0]='\0';
#line 71 "MACS_sample_kidney_box.instr"
  if(0) strncpy(mccchannel_10_analyzer_2_array_crystal_array_8_mask_setting, 0 ? 0 : "", 16384); else mccchannel_10_analyzer_2_array_crystal_array_8_mask_setting[0]='\0';
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_10_analyzer_2_array_crystal_array_8_number_of_activations = 1;
#line 124949 "MACS_sample_kidney_box.c"

  SIG_MESSAGE("channel_10_analyzer_2_array_crystal_array_8 (Init:Place/Rotate)");
  rot_set_rotation(mctr1,
#line 2863 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 2863 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 2863 "MACS_sample_kidney_box.instr"
    (0 - RAD2DEG * channel_10_analyzer_2_array_theta [ 8 ])*DEG2RAD);
#line 124959 "MACS_sample_kidney_box.c"
  rot_mul(mctr1, mcrotachannel_10_analyzer_2_rotated, mcrotachannel_10_analyzer_2_array_crystal_array_8);
  rot_transpose(mcrotachannel_10_analyzer_2_array_crystal_array_7, mctr1);
  rot_mul(mcrotachannel_10_analyzer_2_array_crystal_array_8, mctr1, mcrotrchannel_10_analyzer_2_array_crystal_array_8);
  mctc1 = coords_set(
#line 2862 "MACS_sample_kidney_box.instr"
    0 + channel_10_analyzer_2_array_effective_radius_of_curvature * ( 1 - cos ( channel_10_analyzer_2_array_theta [ 8 ] ) ),
#line 2862 "MACS_sample_kidney_box.instr"
    0 + channel_10_analyzer_2_array_effective_radius_of_curvature * sin ( channel_10_analyzer_2_array_theta [ 8 ] ),
#line 2862 "MACS_sample_kidney_box.instr"
    0);
#line 124970 "MACS_sample_kidney_box.c"
  rot_transpose(mcrotachannel_10_analyzer_2_rotated, mctr1);
  mctc2 = rot_apply(mctr1, mctc1);
  mcposachannel_10_analyzer_2_array_crystal_array_8 = coords_add(mcposachannel_10_analyzer_2_rotated, mctc2);
  mctc1 = coords_sub(mcposachannel_10_analyzer_2_array_crystal_array_7, mcposachannel_10_analyzer_2_array_crystal_array_8);
  mcposrchannel_10_analyzer_2_array_crystal_array_8 = rot_apply(mcrotachannel_10_analyzer_2_array_crystal_array_8, mctc1);
  mcDEBUG_COMPONENT("channel_10_analyzer_2_array_crystal_array_8", mcposachannel_10_analyzer_2_array_crystal_array_8, mcrotachannel_10_analyzer_2_array_crystal_array_8)
  mccomp_posa[529] = mcposachannel_10_analyzer_2_array_crystal_array_8;
  mccomp_posr[529] = mcposrchannel_10_analyzer_2_array_crystal_array_8;
  mcNCounter[529]  = mcPCounter[529] = mcP2Counter[529] = 0;
  mcAbsorbProp[529]= 0;
    /* Component channel_10_cave2_cyl1. */
  /* Setting parameters for component channel_10_cave2_cyl1. */
  SIG_MESSAGE("channel_10_cave2_cyl1 (Init:SetPar)");
#line 2868 "MACS_sample_kidney_box.instr"
  if("Vacuum") strncpy(mccchannel_10_cave2_cyl1_material_string, "Vacuum" ? "Vacuum" : "", 16384); else mccchannel_10_cave2_cyl1_material_string[0]='\0';
#line 2868 "MACS_sample_kidney_box.instr"
  mccchannel_10_cave2_cyl1_priority = 1207.5;
#line 2867 "MACS_sample_kidney_box.instr"
  mccchannel_10_cave2_cyl1_radius = kidney_cave2_cyl1_radius;
#line 2867 "MACS_sample_kidney_box.instr"
  mccchannel_10_cave2_cyl1_yheight = kidney_cave2_cyl1_height;
#line 67 "MACS_sample_kidney_box.instr"
  mccchannel_10_cave2_cyl1_visualize = 1;
#line 67 "MACS_sample_kidney_box.instr"
  mccchannel_10_cave2_cyl1_target_index = 0;
#line 67 "MACS_sample_kidney_box.instr"
  mccchannel_10_cave2_cyl1_target_x = 0;
#line 67 "MACS_sample_kidney_box.instr"
  mccchannel_10_cave2_cyl1_target_y = 0;
#line 67 "MACS_sample_kidney_box.instr"
  mccchannel_10_cave2_cyl1_target_z = 0;
#line 67 "MACS_sample_kidney_box.instr"
  mccchannel_10_cave2_cyl1_focus_aw = 0;
#line 67 "MACS_sample_kidney_box.instr"
  mccchannel_10_cave2_cyl1_focus_ah = 0;
#line 67 "MACS_sample_kidney_box.instr"
  mccchannel_10_cave2_cyl1_focus_xw = 0;
#line 67 "MACS_sample_kidney_box.instr"
  mccchannel_10_cave2_cyl1_focus_xh = 0;
#line 67 "MACS_sample_kidney_box.instr"
  mccchannel_10_cave2_cyl1_focus_r = 0;
#line 67 "MACS_sample_kidney_box.instr"
  mccchannel_10_cave2_cyl1_p_interact = 0;
#line 67 "MACS_sample_kidney_box.instr"
  if(0) strncpy(mccchannel_10_cave2_cyl1_mask_string, 0 ? 0 : "", 16384); else mccchannel_10_cave2_cyl1_mask_string[0]='\0';
#line 67 "MACS_sample_kidney_box.instr"
  if(0) strncpy(mccchannel_10_cave2_cyl1_mask_setting, 0 ? 0 : "", 16384); else mccchannel_10_cave2_cyl1_mask_setting[0]='\0';
#line 67 "MACS_sample_kidney_box.instr"
  mccchannel_10_cave2_cyl1_number_of_activations = 1;
#line 125020 "MACS_sample_kidney_box.c"

  SIG_MESSAGE("channel_10_cave2_cyl1 (Init:Place/Rotate)");
  rot_set_rotation(mctr1,
#line 2870 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 2870 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 2870 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD);
#line 125030 "MACS_sample_kidney_box.c"
  rot_mul(mctr1, mcrotachannel_10_analyzer_2_center, mcrotachannel_10_cave2_cyl1);
  rot_transpose(mcrotachannel_10_analyzer_2_array_crystal_array_8, mctr1);
  rot_mul(mcrotachannel_10_cave2_cyl1, mctr1, mcrotrchannel_10_cave2_cyl1);
  mctc1 = coords_set(
#line 2869 "MACS_sample_kidney_box.instr"
    0,
#line 2869 "MACS_sample_kidney_box.instr"
    0,
#line 2869 "MACS_sample_kidney_box.instr"
    spec_detector_to_analyzer_2_center);
#line 125041 "MACS_sample_kidney_box.c"
  rot_transpose(mcrotachannel_10_analyzer_2_center, mctr1);
  mctc2 = rot_apply(mctr1, mctc1);
  mcposachannel_10_cave2_cyl1 = coords_add(mcposachannel_10_analyzer_2_center, mctc2);
  mctc1 = coords_sub(mcposachannel_10_analyzer_2_array_crystal_array_8, mcposachannel_10_cave2_cyl1);
  mcposrchannel_10_cave2_cyl1 = rot_apply(mcrotachannel_10_cave2_cyl1, mctc1);
  mcDEBUG_COMPONENT("channel_10_cave2_cyl1", mcposachannel_10_cave2_cyl1, mcrotachannel_10_cave2_cyl1)
  mccomp_posa[530] = mcposachannel_10_cave2_cyl1;
  mccomp_posr[530] = mcposrchannel_10_cave2_cyl1;
  mcNCounter[530]  = mcPCounter[530] = mcP2Counter[530] = 0;
  mcAbsorbProp[530]= 0;
    /* Component channel_10_cave2_box1. */
  /* Setting parameters for component channel_10_cave2_box1. */
  SIG_MESSAGE("channel_10_cave2_box1 (Init:SetPar)");
#line 2875 "MACS_sample_kidney_box.instr"
  if("Vacuum") strncpy(mccchannel_10_cave2_box1_material_string, "Vacuum" ? "Vacuum" : "", 16384); else mccchannel_10_cave2_box1_material_string[0]='\0';
#line 2875 "MACS_sample_kidney_box.instr"
  mccchannel_10_cave2_box1_priority = 1201;
#line 2873 "MACS_sample_kidney_box.instr"
  mccchannel_10_cave2_box1_xwidth = kidney_cave2_box1_width1;
#line 2873 "MACS_sample_kidney_box.instr"
  mccchannel_10_cave2_box1_yheight = kidney_cave2_box1_height1;
#line 2873 "MACS_sample_kidney_box.instr"
  mccchannel_10_cave2_box1_zdepth = kidney_cave2_box1_depth;
#line 2874 "MACS_sample_kidney_box.instr"
  mccchannel_10_cave2_box1_xwidth2 = kidney_cave2_box1_width2;
#line 2874 "MACS_sample_kidney_box.instr"
  mccchannel_10_cave2_box1_yheight2 = kidney_cave2_box1_height2;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_10_cave2_box1_visualize = 1;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_10_cave2_box1_target_index = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_10_cave2_box1_target_x = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_10_cave2_box1_target_y = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_10_cave2_box1_target_z = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_10_cave2_box1_focus_aw = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_10_cave2_box1_focus_ah = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_10_cave2_box1_focus_xw = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_10_cave2_box1_focus_xh = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_10_cave2_box1_focus_r = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_10_cave2_box1_p_interact = 0;
#line 71 "MACS_sample_kidney_box.instr"
  if(0) strncpy(mccchannel_10_cave2_box1_mask_string, 0 ? 0 : "", 16384); else mccchannel_10_cave2_box1_mask_string[0]='\0';
#line 71 "MACS_sample_kidney_box.instr"
  if(0) strncpy(mccchannel_10_cave2_box1_mask_setting, 0 ? 0 : "", 16384); else mccchannel_10_cave2_box1_mask_setting[0]='\0';
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_10_cave2_box1_number_of_activations = 1;
#line 125097 "MACS_sample_kidney_box.c"

  SIG_MESSAGE("channel_10_cave2_box1 (Init:Place/Rotate)");
  rot_set_rotation(mctr1,
#line 2877 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 2877 "MACS_sample_kidney_box.instr"
    (kidney_cave2_box1_y_rotation)*DEG2RAD,
#line 2877 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD);
#line 125107 "MACS_sample_kidney_box.c"
  rot_mul(mctr1, mcrotachannel_10_cave2_cyl1, mcrotachannel_10_cave2_box1);
  rot_transpose(mcrotachannel_10_cave2_cyl1, mctr1);
  rot_mul(mcrotachannel_10_cave2_box1, mctr1, mcrotrchannel_10_cave2_box1);
  mctc1 = coords_set(
#line 2876 "MACS_sample_kidney_box.instr"
    kidney_cave2_box1_center_to_spec_detector_x,
#line 2876 "MACS_sample_kidney_box.instr"
    0,
#line 2876 "MACS_sample_kidney_box.instr"
    kidney_cave2_box1_center_to_spec_detector_z);
#line 125118 "MACS_sample_kidney_box.c"
  rot_transpose(mcrotachannel_10_cave2_cyl1, mctr1);
  mctc2 = rot_apply(mctr1, mctc1);
  mcposachannel_10_cave2_box1 = coords_add(mcposachannel_10_cave2_cyl1, mctc2);
  mctc1 = coords_sub(mcposachannel_10_cave2_cyl1, mcposachannel_10_cave2_box1);
  mcposrchannel_10_cave2_box1 = rot_apply(mcrotachannel_10_cave2_box1, mctc1);
  mcDEBUG_COMPONENT("channel_10_cave2_box1", mcposachannel_10_cave2_box1, mcrotachannel_10_cave2_box1)
  mccomp_posa[531] = mcposachannel_10_cave2_box1;
  mccomp_posr[531] = mcposrchannel_10_cave2_box1;
  mcNCounter[531]  = mcPCounter[531] = mcP2Counter[531] = 0;
  mcAbsorbProp[531]= 0;
    /* Component channel_10_cave2_box2. */
  /* Setting parameters for component channel_10_cave2_box2. */
  SIG_MESSAGE("channel_10_cave2_box2 (Init:SetPar)");
#line 2882 "MACS_sample_kidney_box.instr"
  if("Vacuum") strncpy(mccchannel_10_cave2_box2_material_string, "Vacuum" ? "Vacuum" : "", 16384); else mccchannel_10_cave2_box2_material_string[0]='\0';
#line 2882 "MACS_sample_kidney_box.instr"
  mccchannel_10_cave2_box2_priority = 1206;
#line 2880 "MACS_sample_kidney_box.instr"
  mccchannel_10_cave2_box2_xwidth = kidney_cave2_box2_width1;
#line 2880 "MACS_sample_kidney_box.instr"
  mccchannel_10_cave2_box2_yheight = kidney_cave2_box2_height1;
#line 2880 "MACS_sample_kidney_box.instr"
  mccchannel_10_cave2_box2_zdepth = kidney_cave2_box2_depth;
#line 2881 "MACS_sample_kidney_box.instr"
  mccchannel_10_cave2_box2_xwidth2 = kidney_cave2_box2_width2;
#line 2881 "MACS_sample_kidney_box.instr"
  mccchannel_10_cave2_box2_yheight2 = kidney_cave2_box2_height2;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_10_cave2_box2_visualize = 1;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_10_cave2_box2_target_index = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_10_cave2_box2_target_x = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_10_cave2_box2_target_y = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_10_cave2_box2_target_z = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_10_cave2_box2_focus_aw = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_10_cave2_box2_focus_ah = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_10_cave2_box2_focus_xw = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_10_cave2_box2_focus_xh = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_10_cave2_box2_focus_r = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_10_cave2_box2_p_interact = 0;
#line 71 "MACS_sample_kidney_box.instr"
  if(0) strncpy(mccchannel_10_cave2_box2_mask_string, 0 ? 0 : "", 16384); else mccchannel_10_cave2_box2_mask_string[0]='\0';
#line 71 "MACS_sample_kidney_box.instr"
  if(0) strncpy(mccchannel_10_cave2_box2_mask_setting, 0 ? 0 : "", 16384); else mccchannel_10_cave2_box2_mask_setting[0]='\0';
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_10_cave2_box2_number_of_activations = 1;
#line 125174 "MACS_sample_kidney_box.c"

  SIG_MESSAGE("channel_10_cave2_box2 (Init:Place/Rotate)");
  rot_set_rotation(mctr1,
#line 2884 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 2884 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 2884 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD);
#line 125184 "MACS_sample_kidney_box.c"
  rot_mul(mctr1, mcrotachannel_10_cave2_cyl1, mcrotachannel_10_cave2_box2);
  rot_transpose(mcrotachannel_10_cave2_box1, mctr1);
  rot_mul(mcrotachannel_10_cave2_box2, mctr1, mcrotrchannel_10_cave2_box2);
  mctc1 = coords_set(
#line 2883 "MACS_sample_kidney_box.instr"
    0,
#line 2883 "MACS_sample_kidney_box.instr"
    0,
#line 2883 "MACS_sample_kidney_box.instr"
    kidney_cave2_box2_center_to_detector);
#line 125195 "MACS_sample_kidney_box.c"
  rot_transpose(mcrotachannel_10_cave2_cyl1, mctr1);
  mctc2 = rot_apply(mctr1, mctc1);
  mcposachannel_10_cave2_box2 = coords_add(mcposachannel_10_cave2_cyl1, mctc2);
  mctc1 = coords_sub(mcposachannel_10_cave2_box1, mcposachannel_10_cave2_box2);
  mcposrchannel_10_cave2_box2 = rot_apply(mcrotachannel_10_cave2_box2, mctc1);
  mcDEBUG_COMPONENT("channel_10_cave2_box2", mcposachannel_10_cave2_box2, mcrotachannel_10_cave2_box2)
  mccomp_posa[532] = mcposachannel_10_cave2_box2;
  mccomp_posr[532] = mcposrchannel_10_cave2_box2;
  mcNCounter[532]  = mcPCounter[532] = mcP2Counter[532] = 0;
  mcAbsorbProp[532]= 0;
    /* Component channel_10_cave2_box3. */
  /* Setting parameters for component channel_10_cave2_box3. */
  SIG_MESSAGE("channel_10_cave2_box3 (Init:SetPar)");
#line 2889 "MACS_sample_kidney_box.instr"
  if("Vacuum") strncpy(mccchannel_10_cave2_box3_material_string, "Vacuum" ? "Vacuum" : "", 16384); else mccchannel_10_cave2_box3_material_string[0]='\0';
#line 2889 "MACS_sample_kidney_box.instr"
  mccchannel_10_cave2_box3_priority = 1207;
#line 2887 "MACS_sample_kidney_box.instr"
  mccchannel_10_cave2_box3_xwidth = kidney_cave2_box3_width1;
#line 2887 "MACS_sample_kidney_box.instr"
  mccchannel_10_cave2_box3_yheight = kidney_cave2_box3_height1;
#line 2887 "MACS_sample_kidney_box.instr"
  mccchannel_10_cave2_box3_zdepth = kidney_cave2_box3_depth;
#line 2888 "MACS_sample_kidney_box.instr"
  mccchannel_10_cave2_box3_xwidth2 = kidney_cave2_box3_width2;
#line 2888 "MACS_sample_kidney_box.instr"
  mccchannel_10_cave2_box3_yheight2 = kidney_cave2_box3_height2;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_10_cave2_box3_visualize = 1;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_10_cave2_box3_target_index = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_10_cave2_box3_target_x = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_10_cave2_box3_target_y = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_10_cave2_box3_target_z = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_10_cave2_box3_focus_aw = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_10_cave2_box3_focus_ah = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_10_cave2_box3_focus_xw = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_10_cave2_box3_focus_xh = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_10_cave2_box3_focus_r = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_10_cave2_box3_p_interact = 0;
#line 71 "MACS_sample_kidney_box.instr"
  if(0) strncpy(mccchannel_10_cave2_box3_mask_string, 0 ? 0 : "", 16384); else mccchannel_10_cave2_box3_mask_string[0]='\0';
#line 71 "MACS_sample_kidney_box.instr"
  if(0) strncpy(mccchannel_10_cave2_box3_mask_setting, 0 ? 0 : "", 16384); else mccchannel_10_cave2_box3_mask_setting[0]='\0';
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_10_cave2_box3_number_of_activations = 1;
#line 125251 "MACS_sample_kidney_box.c"

  SIG_MESSAGE("channel_10_cave2_box3 (Init:Place/Rotate)");
  rot_set_rotation(mctr1,
#line 2891 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 2891 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 2891 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD);
#line 125261 "MACS_sample_kidney_box.c"
  rot_mul(mctr1, mcrotachannel_10_cave2_cyl1, mcrotachannel_10_cave2_box3);
  rot_transpose(mcrotachannel_10_cave2_box2, mctr1);
  rot_mul(mcrotachannel_10_cave2_box3, mctr1, mcrotrchannel_10_cave2_box3);
  mctc1 = coords_set(
#line 2890 "MACS_sample_kidney_box.instr"
    0,
#line 2890 "MACS_sample_kidney_box.instr"
    0,
#line 2890 "MACS_sample_kidney_box.instr"
    kidney_cave2_box3_center_to_detector);
#line 125272 "MACS_sample_kidney_box.c"
  rot_transpose(mcrotachannel_10_cave2_cyl1, mctr1);
  mctc2 = rot_apply(mctr1, mctc1);
  mcposachannel_10_cave2_box3 = coords_add(mcposachannel_10_cave2_cyl1, mctc2);
  mctc1 = coords_sub(mcposachannel_10_cave2_box2, mcposachannel_10_cave2_box3);
  mcposrchannel_10_cave2_box3 = rot_apply(mcrotachannel_10_cave2_box3, mctc1);
  mcDEBUG_COMPONENT("channel_10_cave2_box3", mcposachannel_10_cave2_box3, mcrotachannel_10_cave2_box3)
  mccomp_posa[533] = mcposachannel_10_cave2_box3;
  mccomp_posr[533] = mcposrchannel_10_cave2_box3;
  mcNCounter[533]  = mcPCounter[533] = mcP2Counter[533] = 0;
  mcAbsorbProp[533]= 0;
    /* Component inter_analyzer_colimator_center_10. */
  /* Setting parameters for component inter_analyzer_colimator_center_10. */
  SIG_MESSAGE("inter_analyzer_colimator_center_10 (Init:SetPar)");

  SIG_MESSAGE("inter_analyzer_colimator_center_10 (Init:Place/Rotate)");
  rot_set_rotation(mctr1,
#line 2895 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 2895 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 2895 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD);
#line 125295 "MACS_sample_kidney_box.c"
  rot_mul(mctr1, mcrotachannel_10_analyzer_1_center, mcrotainter_analyzer_colimator_center_10);
  rot_transpose(mcrotachannel_10_cave2_box3, mctr1);
  rot_mul(mcrotainter_analyzer_colimator_center_10, mctr1, mcrotrinter_analyzer_colimator_center_10);
  mctc1 = coords_set(
#line 2894 "MACS_sample_kidney_box.instr"
    -0.5 * analyzer_seperation,
#line 2894 "MACS_sample_kidney_box.instr"
    0,
#line 2894 "MACS_sample_kidney_box.instr"
    0);
#line 125306 "MACS_sample_kidney_box.c"
  rot_transpose(mcrotachannel_10_analyzer_1_center, mctr1);
  mctc2 = rot_apply(mctr1, mctc1);
  mcposainter_analyzer_colimator_center_10 = coords_add(mcposachannel_10_analyzer_1_center, mctc2);
  mctc1 = coords_sub(mcposachannel_10_cave2_box3, mcposainter_analyzer_colimator_center_10);
  mcposrinter_analyzer_colimator_center_10 = rot_apply(mcrotainter_analyzer_colimator_center_10, mctc1);
  mcDEBUG_COMPONENT("inter_analyzer_colimator_center_10", mcposainter_analyzer_colimator_center_10, mcrotainter_analyzer_colimator_center_10)
  mccomp_posa[534] = mcposainter_analyzer_colimator_center_10;
  mccomp_posr[534] = mcposrinter_analyzer_colimator_center_10;
  mcNCounter[534]  = mcPCounter[534] = mcP2Counter[534] = 0;
  mcAbsorbProp[534]= 0;
    /* Component inter_analyzer_colimator_10_blade_0. */
  /* Setting parameters for component inter_analyzer_colimator_10_blade_0. */
  SIG_MESSAGE("inter_analyzer_colimator_10_blade_0 (Init:SetPar)");
#line 2899 "MACS_sample_kidney_box.instr"
  if("Collimator_gad") strncpy(mccinter_analyzer_colimator_10_blade_0_material_string, "Collimator_gad" ? "Collimator_gad" : "", 16384); else mccinter_analyzer_colimator_10_blade_0_material_string[0]='\0';
#line 2899 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_10_blade_0_priority = 1225;
#line 2898 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_10_blade_0_xwidth = inter_analyzer_colimator_width;
#line 2898 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_10_blade_0_yheight = inter_analyzer_colimator_height;
#line 2898 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_10_blade_0_zdepth = inter_analyzer_colimator_depth;
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_10_blade_0_xwidth2 = -1;
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_10_blade_0_yheight2 = -1;
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_10_blade_0_visualize = 1;
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_10_blade_0_target_index = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_10_blade_0_target_x = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_10_blade_0_target_y = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_10_blade_0_target_z = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_10_blade_0_focus_aw = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_10_blade_0_focus_ah = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_10_blade_0_focus_xw = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_10_blade_0_focus_xh = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_10_blade_0_focus_r = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_10_blade_0_p_interact = 0;
#line 71 "MACS_sample_kidney_box.instr"
  if(0) strncpy(mccinter_analyzer_colimator_10_blade_0_mask_string, 0 ? 0 : "", 16384); else mccinter_analyzer_colimator_10_blade_0_mask_string[0]='\0';
#line 71 "MACS_sample_kidney_box.instr"
  if(0) strncpy(mccinter_analyzer_colimator_10_blade_0_mask_setting, 0 ? 0 : "", 16384); else mccinter_analyzer_colimator_10_blade_0_mask_setting[0]='\0';
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_10_blade_0_number_of_activations = 1;
#line 125362 "MACS_sample_kidney_box.c"

  SIG_MESSAGE("inter_analyzer_colimator_10_blade_0 (Init:Place/Rotate)");
  rot_set_rotation(mctr1,
#line 2901 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 2901 "MACS_sample_kidney_box.instr"
    (- analyzer_2theta [ 10 ])*DEG2RAD,
#line 2901 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD);
#line 125372 "MACS_sample_kidney_box.c"
  rot_mul(mctr1, mcrotainter_analyzer_colimator_center_10, mcrotainter_analyzer_colimator_10_blade_0);
  rot_transpose(mcrotainter_analyzer_colimator_center_10, mctr1);
  rot_mul(mcrotainter_analyzer_colimator_10_blade_0, mctr1, mcrotrinter_analyzer_colimator_10_blade_0);
  mctc1 = coords_set(
#line 2900 "MACS_sample_kidney_box.instr"
    0,
#line 2900 "MACS_sample_kidney_box.instr"
    0,
#line 2900 "MACS_sample_kidney_box.instr"
    inter_analyzer_colimator_start_pos - 0 * inter_analyzer_colimator_seperation);
#line 125383 "MACS_sample_kidney_box.c"
  rot_transpose(mcrotainter_analyzer_colimator_center_10, mctr1);
  mctc2 = rot_apply(mctr1, mctc1);
  mcposainter_analyzer_colimator_10_blade_0 = coords_add(mcposainter_analyzer_colimator_center_10, mctc2);
  mctc1 = coords_sub(mcposainter_analyzer_colimator_center_10, mcposainter_analyzer_colimator_10_blade_0);
  mcposrinter_analyzer_colimator_10_blade_0 = rot_apply(mcrotainter_analyzer_colimator_10_blade_0, mctc1);
  mcDEBUG_COMPONENT("inter_analyzer_colimator_10_blade_0", mcposainter_analyzer_colimator_10_blade_0, mcrotainter_analyzer_colimator_10_blade_0)
  mccomp_posa[535] = mcposainter_analyzer_colimator_10_blade_0;
  mccomp_posr[535] = mcposrinter_analyzer_colimator_10_blade_0;
  mcNCounter[535]  = mcPCounter[535] = mcP2Counter[535] = 0;
  mcAbsorbProp[535]= 0;
    /* Component inter_analyzer_colimator_10_blade_1. */
  /* Setting parameters for component inter_analyzer_colimator_10_blade_1. */
  SIG_MESSAGE("inter_analyzer_colimator_10_blade_1 (Init:SetPar)");
#line 2905 "MACS_sample_kidney_box.instr"
  if("Collimator_gad") strncpy(mccinter_analyzer_colimator_10_blade_1_material_string, "Collimator_gad" ? "Collimator_gad" : "", 16384); else mccinter_analyzer_colimator_10_blade_1_material_string[0]='\0';
#line 2905 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_10_blade_1_priority = 1226;
#line 2904 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_10_blade_1_xwidth = inter_analyzer_colimator_width;
#line 2904 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_10_blade_1_yheight = inter_analyzer_colimator_height;
#line 2904 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_10_blade_1_zdepth = inter_analyzer_colimator_depth;
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_10_blade_1_xwidth2 = -1;
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_10_blade_1_yheight2 = -1;
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_10_blade_1_visualize = 1;
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_10_blade_1_target_index = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_10_blade_1_target_x = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_10_blade_1_target_y = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_10_blade_1_target_z = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_10_blade_1_focus_aw = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_10_blade_1_focus_ah = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_10_blade_1_focus_xw = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_10_blade_1_focus_xh = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_10_blade_1_focus_r = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_10_blade_1_p_interact = 0;
#line 71 "MACS_sample_kidney_box.instr"
  if(0) strncpy(mccinter_analyzer_colimator_10_blade_1_mask_string, 0 ? 0 : "", 16384); else mccinter_analyzer_colimator_10_blade_1_mask_string[0]='\0';
#line 71 "MACS_sample_kidney_box.instr"
  if(0) strncpy(mccinter_analyzer_colimator_10_blade_1_mask_setting, 0 ? 0 : "", 16384); else mccinter_analyzer_colimator_10_blade_1_mask_setting[0]='\0';
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_10_blade_1_number_of_activations = 1;
#line 125439 "MACS_sample_kidney_box.c"

  SIG_MESSAGE("inter_analyzer_colimator_10_blade_1 (Init:Place/Rotate)");
  rot_set_rotation(mctr1,
#line 2907 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 2907 "MACS_sample_kidney_box.instr"
    (- analyzer_2theta [ 10 ])*DEG2RAD,
#line 2907 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD);
#line 125449 "MACS_sample_kidney_box.c"
  rot_mul(mctr1, mcrotainter_analyzer_colimator_center_10, mcrotainter_analyzer_colimator_10_blade_1);
  rot_transpose(mcrotainter_analyzer_colimator_10_blade_0, mctr1);
  rot_mul(mcrotainter_analyzer_colimator_10_blade_1, mctr1, mcrotrinter_analyzer_colimator_10_blade_1);
  mctc1 = coords_set(
#line 2906 "MACS_sample_kidney_box.instr"
    0,
#line 2906 "MACS_sample_kidney_box.instr"
    0,
#line 2906 "MACS_sample_kidney_box.instr"
    inter_analyzer_colimator_start_pos - 1 * inter_analyzer_colimator_seperation);
#line 125460 "MACS_sample_kidney_box.c"
  rot_transpose(mcrotainter_analyzer_colimator_center_10, mctr1);
  mctc2 = rot_apply(mctr1, mctc1);
  mcposainter_analyzer_colimator_10_blade_1 = coords_add(mcposainter_analyzer_colimator_center_10, mctc2);
  mctc1 = coords_sub(mcposainter_analyzer_colimator_10_blade_0, mcposainter_analyzer_colimator_10_blade_1);
  mcposrinter_analyzer_colimator_10_blade_1 = rot_apply(mcrotainter_analyzer_colimator_10_blade_1, mctc1);
  mcDEBUG_COMPONENT("inter_analyzer_colimator_10_blade_1", mcposainter_analyzer_colimator_10_blade_1, mcrotainter_analyzer_colimator_10_blade_1)
  mccomp_posa[536] = mcposainter_analyzer_colimator_10_blade_1;
  mccomp_posr[536] = mcposrinter_analyzer_colimator_10_blade_1;
  mcNCounter[536]  = mcPCounter[536] = mcP2Counter[536] = 0;
  mcAbsorbProp[536]= 0;
    /* Component inter_analyzer_colimator_10_blade_2. */
  /* Setting parameters for component inter_analyzer_colimator_10_blade_2. */
  SIG_MESSAGE("inter_analyzer_colimator_10_blade_2 (Init:SetPar)");
#line 2911 "MACS_sample_kidney_box.instr"
  if("Collimator_gad") strncpy(mccinter_analyzer_colimator_10_blade_2_material_string, "Collimator_gad" ? "Collimator_gad" : "", 16384); else mccinter_analyzer_colimator_10_blade_2_material_string[0]='\0';
#line 2911 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_10_blade_2_priority = 1227;
#line 2910 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_10_blade_2_xwidth = inter_analyzer_colimator_width;
#line 2910 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_10_blade_2_yheight = inter_analyzer_colimator_height;
#line 2910 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_10_blade_2_zdepth = inter_analyzer_colimator_depth;
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_10_blade_2_xwidth2 = -1;
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_10_blade_2_yheight2 = -1;
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_10_blade_2_visualize = 1;
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_10_blade_2_target_index = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_10_blade_2_target_x = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_10_blade_2_target_y = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_10_blade_2_target_z = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_10_blade_2_focus_aw = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_10_blade_2_focus_ah = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_10_blade_2_focus_xw = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_10_blade_2_focus_xh = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_10_blade_2_focus_r = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_10_blade_2_p_interact = 0;
#line 71 "MACS_sample_kidney_box.instr"
  if(0) strncpy(mccinter_analyzer_colimator_10_blade_2_mask_string, 0 ? 0 : "", 16384); else mccinter_analyzer_colimator_10_blade_2_mask_string[0]='\0';
#line 71 "MACS_sample_kidney_box.instr"
  if(0) strncpy(mccinter_analyzer_colimator_10_blade_2_mask_setting, 0 ? 0 : "", 16384); else mccinter_analyzer_colimator_10_blade_2_mask_setting[0]='\0';
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_10_blade_2_number_of_activations = 1;
#line 125516 "MACS_sample_kidney_box.c"

  SIG_MESSAGE("inter_analyzer_colimator_10_blade_2 (Init:Place/Rotate)");
  rot_set_rotation(mctr1,
#line 2913 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 2913 "MACS_sample_kidney_box.instr"
    (- analyzer_2theta [ 10 ])*DEG2RAD,
#line 2913 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD);
#line 125526 "MACS_sample_kidney_box.c"
  rot_mul(mctr1, mcrotainter_analyzer_colimator_center_10, mcrotainter_analyzer_colimator_10_blade_2);
  rot_transpose(mcrotainter_analyzer_colimator_10_blade_1, mctr1);
  rot_mul(mcrotainter_analyzer_colimator_10_blade_2, mctr1, mcrotrinter_analyzer_colimator_10_blade_2);
  mctc1 = coords_set(
#line 2912 "MACS_sample_kidney_box.instr"
    0,
#line 2912 "MACS_sample_kidney_box.instr"
    0,
#line 2912 "MACS_sample_kidney_box.instr"
    inter_analyzer_colimator_start_pos - 2 * inter_analyzer_colimator_seperation);
#line 125537 "MACS_sample_kidney_box.c"
  rot_transpose(mcrotainter_analyzer_colimator_center_10, mctr1);
  mctc2 = rot_apply(mctr1, mctc1);
  mcposainter_analyzer_colimator_10_blade_2 = coords_add(mcposainter_analyzer_colimator_center_10, mctc2);
  mctc1 = coords_sub(mcposainter_analyzer_colimator_10_blade_1, mcposainter_analyzer_colimator_10_blade_2);
  mcposrinter_analyzer_colimator_10_blade_2 = rot_apply(mcrotainter_analyzer_colimator_10_blade_2, mctc1);
  mcDEBUG_COMPONENT("inter_analyzer_colimator_10_blade_2", mcposainter_analyzer_colimator_10_blade_2, mcrotainter_analyzer_colimator_10_blade_2)
  mccomp_posa[537] = mcposainter_analyzer_colimator_10_blade_2;
  mccomp_posr[537] = mcposrinter_analyzer_colimator_10_blade_2;
  mcNCounter[537]  = mcPCounter[537] = mcP2Counter[537] = 0;
  mcAbsorbProp[537]= 0;
    /* Component inter_analyzer_colimator_10_blade_3. */
  /* Setting parameters for component inter_analyzer_colimator_10_blade_3. */
  SIG_MESSAGE("inter_analyzer_colimator_10_blade_3 (Init:SetPar)");
#line 2917 "MACS_sample_kidney_box.instr"
  if("Collimator_gad") strncpy(mccinter_analyzer_colimator_10_blade_3_material_string, "Collimator_gad" ? "Collimator_gad" : "", 16384); else mccinter_analyzer_colimator_10_blade_3_material_string[0]='\0';
#line 2917 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_10_blade_3_priority = 1228;
#line 2916 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_10_blade_3_xwidth = inter_analyzer_colimator_width;
#line 2916 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_10_blade_3_yheight = inter_analyzer_colimator_height;
#line 2916 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_10_blade_3_zdepth = inter_analyzer_colimator_depth;
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_10_blade_3_xwidth2 = -1;
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_10_blade_3_yheight2 = -1;
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_10_blade_3_visualize = 1;
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_10_blade_3_target_index = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_10_blade_3_target_x = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_10_blade_3_target_y = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_10_blade_3_target_z = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_10_blade_3_focus_aw = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_10_blade_3_focus_ah = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_10_blade_3_focus_xw = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_10_blade_3_focus_xh = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_10_blade_3_focus_r = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_10_blade_3_p_interact = 0;
#line 71 "MACS_sample_kidney_box.instr"
  if(0) strncpy(mccinter_analyzer_colimator_10_blade_3_mask_string, 0 ? 0 : "", 16384); else mccinter_analyzer_colimator_10_blade_3_mask_string[0]='\0';
#line 71 "MACS_sample_kidney_box.instr"
  if(0) strncpy(mccinter_analyzer_colimator_10_blade_3_mask_setting, 0 ? 0 : "", 16384); else mccinter_analyzer_colimator_10_blade_3_mask_setting[0]='\0';
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_10_blade_3_number_of_activations = 1;
#line 125593 "MACS_sample_kidney_box.c"

  SIG_MESSAGE("inter_analyzer_colimator_10_blade_3 (Init:Place/Rotate)");
  rot_set_rotation(mctr1,
#line 2919 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 2919 "MACS_sample_kidney_box.instr"
    (- analyzer_2theta [ 10 ])*DEG2RAD,
#line 2919 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD);
#line 125603 "MACS_sample_kidney_box.c"
  rot_mul(mctr1, mcrotainter_analyzer_colimator_center_10, mcrotainter_analyzer_colimator_10_blade_3);
  rot_transpose(mcrotainter_analyzer_colimator_10_blade_2, mctr1);
  rot_mul(mcrotainter_analyzer_colimator_10_blade_3, mctr1, mcrotrinter_analyzer_colimator_10_blade_3);
  mctc1 = coords_set(
#line 2918 "MACS_sample_kidney_box.instr"
    0,
#line 2918 "MACS_sample_kidney_box.instr"
    0,
#line 2918 "MACS_sample_kidney_box.instr"
    inter_analyzer_colimator_start_pos - 3 * inter_analyzer_colimator_seperation);
#line 125614 "MACS_sample_kidney_box.c"
  rot_transpose(mcrotainter_analyzer_colimator_center_10, mctr1);
  mctc2 = rot_apply(mctr1, mctc1);
  mcposainter_analyzer_colimator_10_blade_3 = coords_add(mcposainter_analyzer_colimator_center_10, mctc2);
  mctc1 = coords_sub(mcposainter_analyzer_colimator_10_blade_2, mcposainter_analyzer_colimator_10_blade_3);
  mcposrinter_analyzer_colimator_10_blade_3 = rot_apply(mcrotainter_analyzer_colimator_10_blade_3, mctc1);
  mcDEBUG_COMPONENT("inter_analyzer_colimator_10_blade_3", mcposainter_analyzer_colimator_10_blade_3, mcrotainter_analyzer_colimator_10_blade_3)
  mccomp_posa[538] = mcposainter_analyzer_colimator_10_blade_3;
  mccomp_posr[538] = mcposrinter_analyzer_colimator_10_blade_3;
  mcNCounter[538]  = mcPCounter[538] = mcP2Counter[538] = 0;
  mcAbsorbProp[538]= 0;
    /* Component inter_analyzer_colimator_10_blade_4. */
  /* Setting parameters for component inter_analyzer_colimator_10_blade_4. */
  SIG_MESSAGE("inter_analyzer_colimator_10_blade_4 (Init:SetPar)");
#line 2923 "MACS_sample_kidney_box.instr"
  if("Collimator_gad") strncpy(mccinter_analyzer_colimator_10_blade_4_material_string, "Collimator_gad" ? "Collimator_gad" : "", 16384); else mccinter_analyzer_colimator_10_blade_4_material_string[0]='\0';
#line 2923 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_10_blade_4_priority = 1229;
#line 2922 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_10_blade_4_xwidth = inter_analyzer_colimator_width;
#line 2922 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_10_blade_4_yheight = inter_analyzer_colimator_height;
#line 2922 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_10_blade_4_zdepth = inter_analyzer_colimator_depth;
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_10_blade_4_xwidth2 = -1;
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_10_blade_4_yheight2 = -1;
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_10_blade_4_visualize = 1;
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_10_blade_4_target_index = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_10_blade_4_target_x = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_10_blade_4_target_y = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_10_blade_4_target_z = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_10_blade_4_focus_aw = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_10_blade_4_focus_ah = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_10_blade_4_focus_xw = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_10_blade_4_focus_xh = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_10_blade_4_focus_r = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_10_blade_4_p_interact = 0;
#line 71 "MACS_sample_kidney_box.instr"
  if(0) strncpy(mccinter_analyzer_colimator_10_blade_4_mask_string, 0 ? 0 : "", 16384); else mccinter_analyzer_colimator_10_blade_4_mask_string[0]='\0';
#line 71 "MACS_sample_kidney_box.instr"
  if(0) strncpy(mccinter_analyzer_colimator_10_blade_4_mask_setting, 0 ? 0 : "", 16384); else mccinter_analyzer_colimator_10_blade_4_mask_setting[0]='\0';
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_10_blade_4_number_of_activations = 1;
#line 125670 "MACS_sample_kidney_box.c"

  SIG_MESSAGE("inter_analyzer_colimator_10_blade_4 (Init:Place/Rotate)");
  rot_set_rotation(mctr1,
#line 2925 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 2925 "MACS_sample_kidney_box.instr"
    (- analyzer_2theta [ 10 ])*DEG2RAD,
#line 2925 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD);
#line 125680 "MACS_sample_kidney_box.c"
  rot_mul(mctr1, mcrotainter_analyzer_colimator_center_10, mcrotainter_analyzer_colimator_10_blade_4);
  rot_transpose(mcrotainter_analyzer_colimator_10_blade_3, mctr1);
  rot_mul(mcrotainter_analyzer_colimator_10_blade_4, mctr1, mcrotrinter_analyzer_colimator_10_blade_4);
  mctc1 = coords_set(
#line 2924 "MACS_sample_kidney_box.instr"
    0,
#line 2924 "MACS_sample_kidney_box.instr"
    0,
#line 2924 "MACS_sample_kidney_box.instr"
    inter_analyzer_colimator_start_pos - 4 * inter_analyzer_colimator_seperation);
#line 125691 "MACS_sample_kidney_box.c"
  rot_transpose(mcrotainter_analyzer_colimator_center_10, mctr1);
  mctc2 = rot_apply(mctr1, mctc1);
  mcposainter_analyzer_colimator_10_blade_4 = coords_add(mcposainter_analyzer_colimator_center_10, mctc2);
  mctc1 = coords_sub(mcposainter_analyzer_colimator_10_blade_3, mcposainter_analyzer_colimator_10_blade_4);
  mcposrinter_analyzer_colimator_10_blade_4 = rot_apply(mcrotainter_analyzer_colimator_10_blade_4, mctc1);
  mcDEBUG_COMPONENT("inter_analyzer_colimator_10_blade_4", mcposainter_analyzer_colimator_10_blade_4, mcrotainter_analyzer_colimator_10_blade_4)
  mccomp_posa[539] = mcposainter_analyzer_colimator_10_blade_4;
  mccomp_posr[539] = mcposrinter_analyzer_colimator_10_blade_4;
  mcNCounter[539]  = mcPCounter[539] = mcP2Counter[539] = 0;
  mcAbsorbProp[539]= 0;
    /* Component diffraction_detector_10_exit_volume. */
  /* Setting parameters for component diffraction_detector_10_exit_volume. */
  SIG_MESSAGE("diffraction_detector_10_exit_volume (Init:SetPar)");
#line 2929 "MACS_sample_kidney_box.instr"
  if("Exit") strncpy(mccdiffraction_detector_10_exit_volume_material_string, "Exit" ? "Exit" : "", 16384); else mccdiffraction_detector_10_exit_volume_material_string[0]='\0';
#line 2929 "MACS_sample_kidney_box.instr"
  mccdiffraction_detector_10_exit_volume_priority = 1231;
#line 2928 "MACS_sample_kidney_box.instr"
  mccdiffraction_detector_10_exit_volume_xwidth = 2.01 * detector_radius;
#line 2928 "MACS_sample_kidney_box.instr"
  mccdiffraction_detector_10_exit_volume_yheight = 1.01 * detector_height;
#line 2928 "MACS_sample_kidney_box.instr"
  mccdiffraction_detector_10_exit_volume_zdepth = 0.001;
#line 71 "MACS_sample_kidney_box.instr"
  mccdiffraction_detector_10_exit_volume_xwidth2 = -1;
#line 71 "MACS_sample_kidney_box.instr"
  mccdiffraction_detector_10_exit_volume_yheight2 = -1;
#line 71 "MACS_sample_kidney_box.instr"
  mccdiffraction_detector_10_exit_volume_visualize = 1;
#line 71 "MACS_sample_kidney_box.instr"
  mccdiffraction_detector_10_exit_volume_target_index = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccdiffraction_detector_10_exit_volume_target_x = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccdiffraction_detector_10_exit_volume_target_y = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccdiffraction_detector_10_exit_volume_target_z = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccdiffraction_detector_10_exit_volume_focus_aw = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccdiffraction_detector_10_exit_volume_focus_ah = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccdiffraction_detector_10_exit_volume_focus_xw = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccdiffraction_detector_10_exit_volume_focus_xh = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccdiffraction_detector_10_exit_volume_focus_r = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccdiffraction_detector_10_exit_volume_p_interact = 0;
#line 71 "MACS_sample_kidney_box.instr"
  if(0) strncpy(mccdiffraction_detector_10_exit_volume_mask_string, 0 ? 0 : "", 16384); else mccdiffraction_detector_10_exit_volume_mask_string[0]='\0';
#line 71 "MACS_sample_kidney_box.instr"
  if(0) strncpy(mccdiffraction_detector_10_exit_volume_mask_setting, 0 ? 0 : "", 16384); else mccdiffraction_detector_10_exit_volume_mask_setting[0]='\0';
#line 71 "MACS_sample_kidney_box.instr"
  mccdiffraction_detector_10_exit_volume_number_of_activations = 1;
#line 125747 "MACS_sample_kidney_box.c"

  SIG_MESSAGE("diffraction_detector_10_exit_volume (Init:Place/Rotate)");
  rot_set_rotation(mctr1,
#line 2931 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 2931 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 2931 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD);
#line 125757 "MACS_sample_kidney_box.c"
  rot_mul(mctr1, mcrotakidney_channel_10, mcrotadiffraction_detector_10_exit_volume);
  rot_transpose(mcrotainter_analyzer_colimator_10_blade_4, mctr1);
  rot_mul(mcrotadiffraction_detector_10_exit_volume, mctr1, mcrotrdiffraction_detector_10_exit_volume);
  mctc1 = coords_set(
#line 2930 "MACS_sample_kidney_box.instr"
    0,
#line 2930 "MACS_sample_kidney_box.instr"
    0,
#line 2930 "MACS_sample_kidney_box.instr"
    0);
#line 125768 "MACS_sample_kidney_box.c"
  rot_transpose(mcrotachannel_10_cave1_cyl1, mctr1);
  mctc2 = rot_apply(mctr1, mctc1);
  mcposadiffraction_detector_10_exit_volume = coords_add(mcposachannel_10_cave1_cyl1, mctc2);
  mctc1 = coords_sub(mcposainter_analyzer_colimator_10_blade_4, mcposadiffraction_detector_10_exit_volume);
  mcposrdiffraction_detector_10_exit_volume = rot_apply(mcrotadiffraction_detector_10_exit_volume, mctc1);
  mcDEBUG_COMPONENT("diffraction_detector_10_exit_volume", mcposadiffraction_detector_10_exit_volume, mcrotadiffraction_detector_10_exit_volume)
  mccomp_posa[540] = mcposadiffraction_detector_10_exit_volume;
  mccomp_posr[540] = mcposrdiffraction_detector_10_exit_volume;
  mcNCounter[540]  = mcPCounter[540] = mcP2Counter[540] = 0;
  mcAbsorbProp[540]= 0;
    /* Component spec_detector_10_exit_volume. */
  /* Setting parameters for component spec_detector_10_exit_volume. */
  SIG_MESSAGE("spec_detector_10_exit_volume (Init:SetPar)");
#line 2935 "MACS_sample_kidney_box.instr"
  if("Exit") strncpy(mccspec_detector_10_exit_volume_material_string, "Exit" ? "Exit" : "", 16384); else mccspec_detector_10_exit_volume_material_string[0]='\0';
#line 2935 "MACS_sample_kidney_box.instr"
  mccspec_detector_10_exit_volume_priority = 1232;
#line 2934 "MACS_sample_kidney_box.instr"
  mccspec_detector_10_exit_volume_xwidth = 2.01 * detector_radius;
#line 2934 "MACS_sample_kidney_box.instr"
  mccspec_detector_10_exit_volume_yheight = 1.01 * detector_height;
#line 2934 "MACS_sample_kidney_box.instr"
  mccspec_detector_10_exit_volume_zdepth = 0.001;
#line 71 "MACS_sample_kidney_box.instr"
  mccspec_detector_10_exit_volume_xwidth2 = -1;
#line 71 "MACS_sample_kidney_box.instr"
  mccspec_detector_10_exit_volume_yheight2 = -1;
#line 71 "MACS_sample_kidney_box.instr"
  mccspec_detector_10_exit_volume_visualize = 1;
#line 71 "MACS_sample_kidney_box.instr"
  mccspec_detector_10_exit_volume_target_index = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccspec_detector_10_exit_volume_target_x = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccspec_detector_10_exit_volume_target_y = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccspec_detector_10_exit_volume_target_z = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccspec_detector_10_exit_volume_focus_aw = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccspec_detector_10_exit_volume_focus_ah = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccspec_detector_10_exit_volume_focus_xw = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccspec_detector_10_exit_volume_focus_xh = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccspec_detector_10_exit_volume_focus_r = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccspec_detector_10_exit_volume_p_interact = 0;
#line 71 "MACS_sample_kidney_box.instr"
  if(0) strncpy(mccspec_detector_10_exit_volume_mask_string, 0 ? 0 : "", 16384); else mccspec_detector_10_exit_volume_mask_string[0]='\0';
#line 71 "MACS_sample_kidney_box.instr"
  if(0) strncpy(mccspec_detector_10_exit_volume_mask_setting, 0 ? 0 : "", 16384); else mccspec_detector_10_exit_volume_mask_setting[0]='\0';
#line 71 "MACS_sample_kidney_box.instr"
  mccspec_detector_10_exit_volume_number_of_activations = 1;
#line 125824 "MACS_sample_kidney_box.c"

  SIG_MESSAGE("spec_detector_10_exit_volume (Init:Place/Rotate)");
  rot_set_rotation(mctr1,
#line 2937 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 2937 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 2937 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD);
#line 125834 "MACS_sample_kidney_box.c"
  rot_mul(mctr1, mcrotachannel_10_analyzer_2_center, mcrotaspec_detector_10_exit_volume);
  rot_transpose(mcrotadiffraction_detector_10_exit_volume, mctr1);
  rot_mul(mcrotaspec_detector_10_exit_volume, mctr1, mcrotrspec_detector_10_exit_volume);
  mctc1 = coords_set(
#line 2936 "MACS_sample_kidney_box.instr"
    0,
#line 2936 "MACS_sample_kidney_box.instr"
    0,
#line 2936 "MACS_sample_kidney_box.instr"
    0);
#line 125845 "MACS_sample_kidney_box.c"
  rot_transpose(mcrotachannel_10_cave2_cyl1, mctr1);
  mctc2 = rot_apply(mctr1, mctc1);
  mcposaspec_detector_10_exit_volume = coords_add(mcposachannel_10_cave2_cyl1, mctc2);
  mctc1 = coords_sub(mcposadiffraction_detector_10_exit_volume, mcposaspec_detector_10_exit_volume);
  mcposrspec_detector_10_exit_volume = rot_apply(mcrotaspec_detector_10_exit_volume, mctc1);
  mcDEBUG_COMPONENT("spec_detector_10_exit_volume", mcposaspec_detector_10_exit_volume, mcrotaspec_detector_10_exit_volume)
  mccomp_posa[541] = mcposaspec_detector_10_exit_volume;
  mccomp_posr[541] = mcposrspec_detector_10_exit_volume;
  mcNCounter[541]  = mcPCounter[541] = mcP2Counter[541] = 0;
  mcAbsorbProp[541]= 0;
    /* Component channel_11_cave1_box1. */
  /* Setting parameters for component channel_11_cave1_box1. */
  SIG_MESSAGE("channel_11_cave1_box1 (Init:SetPar)");
#line 2942 "MACS_sample_kidney_box.instr"
  if("Vacuum") strncpy(mccchannel_11_cave1_box1_material_string, "Vacuum" ? "Vacuum" : "", 16384); else mccchannel_11_cave1_box1_material_string[0]='\0';
#line 2942 "MACS_sample_kidney_box.instr"
  mccchannel_11_cave1_box1_priority = 1300;
#line 2940 "MACS_sample_kidney_box.instr"
  mccchannel_11_cave1_box1_xwidth = kidney_cave1_box1_width1;
#line 2940 "MACS_sample_kidney_box.instr"
  mccchannel_11_cave1_box1_yheight = kidney_cave1_box1_height1;
#line 2940 "MACS_sample_kidney_box.instr"
  mccchannel_11_cave1_box1_zdepth = kidney_cave1_box1_depth;
#line 2941 "MACS_sample_kidney_box.instr"
  mccchannel_11_cave1_box1_xwidth2 = kidney_cave1_box1_width2;
#line 2941 "MACS_sample_kidney_box.instr"
  mccchannel_11_cave1_box1_yheight2 = kidney_cave1_box1_height2;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_11_cave1_box1_visualize = 1;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_11_cave1_box1_target_index = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_11_cave1_box1_target_x = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_11_cave1_box1_target_y = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_11_cave1_box1_target_z = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_11_cave1_box1_focus_aw = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_11_cave1_box1_focus_ah = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_11_cave1_box1_focus_xw = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_11_cave1_box1_focus_xh = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_11_cave1_box1_focus_r = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_11_cave1_box1_p_interact = 0;
#line 71 "MACS_sample_kidney_box.instr"
  if(0) strncpy(mccchannel_11_cave1_box1_mask_string, 0 ? 0 : "", 16384); else mccchannel_11_cave1_box1_mask_string[0]='\0';
#line 71 "MACS_sample_kidney_box.instr"
  if(0) strncpy(mccchannel_11_cave1_box1_mask_setting, 0 ? 0 : "", 16384); else mccchannel_11_cave1_box1_mask_setting[0]='\0';
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_11_cave1_box1_number_of_activations = 1;
#line 125901 "MACS_sample_kidney_box.c"

  SIG_MESSAGE("channel_11_cave1_box1 (Init:Place/Rotate)");
  rot_set_rotation(mctr1,
#line 2944 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 2944 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 2944 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD);
#line 125911 "MACS_sample_kidney_box.c"
  rot_mul(mctr1, mcrotakidney_channel_11, mcrotachannel_11_cave1_box1);
  rot_transpose(mcrotaspec_detector_10_exit_volume, mctr1);
  rot_mul(mcrotachannel_11_cave1_box1, mctr1, mcrotrchannel_11_cave1_box1);
  mctc1 = coords_set(
#line 2943 "MACS_sample_kidney_box.instr"
    0,
#line 2943 "MACS_sample_kidney_box.instr"
    0,
#line 2943 "MACS_sample_kidney_box.instr"
    kidney_cave1_box1_center_to_target);
#line 125922 "MACS_sample_kidney_box.c"
  rot_transpose(mcrotakidney_channel_11, mctr1);
  mctc2 = rot_apply(mctr1, mctc1);
  mcposachannel_11_cave1_box1 = coords_add(mcposakidney_channel_11, mctc2);
  mctc1 = coords_sub(mcposaspec_detector_10_exit_volume, mcposachannel_11_cave1_box1);
  mcposrchannel_11_cave1_box1 = rot_apply(mcrotachannel_11_cave1_box1, mctc1);
  mcDEBUG_COMPONENT("channel_11_cave1_box1", mcposachannel_11_cave1_box1, mcrotachannel_11_cave1_box1)
  mccomp_posa[542] = mcposachannel_11_cave1_box1;
  mccomp_posr[542] = mcposrchannel_11_cave1_box1;
  mcNCounter[542]  = mcPCounter[542] = mcP2Counter[542] = 0;
  mcAbsorbProp[542]= 0;
    /* Component channel_11_cave1_box2. */
  /* Setting parameters for component channel_11_cave1_box2. */
  SIG_MESSAGE("channel_11_cave1_box2 (Init:SetPar)");
#line 2949 "MACS_sample_kidney_box.instr"
  if("Vacuum") strncpy(mccchannel_11_cave1_box2_material_string, "Vacuum" ? "Vacuum" : "", 16384); else mccchannel_11_cave1_box2_material_string[0]='\0';
#line 2949 "MACS_sample_kidney_box.instr"
  mccchannel_11_cave1_box2_priority = 1305;
#line 2947 "MACS_sample_kidney_box.instr"
  mccchannel_11_cave1_box2_xwidth = kidney_cave1_box2_width1;
#line 2947 "MACS_sample_kidney_box.instr"
  mccchannel_11_cave1_box2_yheight = kidney_cave1_box2_height1;
#line 2947 "MACS_sample_kidney_box.instr"
  mccchannel_11_cave1_box2_zdepth = kidney_cave1_box2_depth;
#line 2948 "MACS_sample_kidney_box.instr"
  mccchannel_11_cave1_box2_xwidth2 = kidney_cave1_box2_width2;
#line 2948 "MACS_sample_kidney_box.instr"
  mccchannel_11_cave1_box2_yheight2 = kidney_cave1_box2_height2;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_11_cave1_box2_visualize = 1;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_11_cave1_box2_target_index = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_11_cave1_box2_target_x = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_11_cave1_box2_target_y = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_11_cave1_box2_target_z = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_11_cave1_box2_focus_aw = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_11_cave1_box2_focus_ah = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_11_cave1_box2_focus_xw = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_11_cave1_box2_focus_xh = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_11_cave1_box2_focus_r = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_11_cave1_box2_p_interact = 0;
#line 71 "MACS_sample_kidney_box.instr"
  if(0) strncpy(mccchannel_11_cave1_box2_mask_string, 0 ? 0 : "", 16384); else mccchannel_11_cave1_box2_mask_string[0]='\0';
#line 71 "MACS_sample_kidney_box.instr"
  if(0) strncpy(mccchannel_11_cave1_box2_mask_setting, 0 ? 0 : "", 16384); else mccchannel_11_cave1_box2_mask_setting[0]='\0';
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_11_cave1_box2_number_of_activations = 1;
#line 125978 "MACS_sample_kidney_box.c"

  SIG_MESSAGE("channel_11_cave1_box2 (Init:Place/Rotate)");
  rot_set_rotation(mctr1,
#line 2951 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 2951 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 2951 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD);
#line 125988 "MACS_sample_kidney_box.c"
  rot_mul(mctr1, mcrotakidney_channel_11, mcrotachannel_11_cave1_box2);
  rot_transpose(mcrotachannel_11_cave1_box1, mctr1);
  rot_mul(mcrotachannel_11_cave1_box2, mctr1, mcrotrchannel_11_cave1_box2);
  mctc1 = coords_set(
#line 2950 "MACS_sample_kidney_box.instr"
    kidney_cave1_box2_x_offset,
#line 2950 "MACS_sample_kidney_box.instr"
    0,
#line 2950 "MACS_sample_kidney_box.instr"
    kidney_cave1_box2_center_to_target);
#line 125999 "MACS_sample_kidney_box.c"
  rot_transpose(mcrotakidney_channel_11, mctr1);
  mctc2 = rot_apply(mctr1, mctc1);
  mcposachannel_11_cave1_box2 = coords_add(mcposakidney_channel_11, mctc2);
  mctc1 = coords_sub(mcposachannel_11_cave1_box1, mcposachannel_11_cave1_box2);
  mcposrchannel_11_cave1_box2 = rot_apply(mcrotachannel_11_cave1_box2, mctc1);
  mcDEBUG_COMPONENT("channel_11_cave1_box2", mcposachannel_11_cave1_box2, mcrotachannel_11_cave1_box2)
  mccomp_posa[543] = mcposachannel_11_cave1_box2;
  mccomp_posr[543] = mcposrchannel_11_cave1_box2;
  mcNCounter[543]  = mcPCounter[543] = mcP2Counter[543] = 0;
  mcAbsorbProp[543]= 0;
    /* Component channel_11_cave1_box3. */
  /* Setting parameters for component channel_11_cave1_box3. */
  SIG_MESSAGE("channel_11_cave1_box3 (Init:SetPar)");
#line 2956 "MACS_sample_kidney_box.instr"
  if("Vacuum") strncpy(mccchannel_11_cave1_box3_material_string, "Vacuum" ? "Vacuum" : "", 16384); else mccchannel_11_cave1_box3_material_string[0]='\0';
#line 2956 "MACS_sample_kidney_box.instr"
  mccchannel_11_cave1_box3_priority = 1302;
#line 2954 "MACS_sample_kidney_box.instr"
  mccchannel_11_cave1_box3_xwidth = kidney_cave1_box3_width1;
#line 2954 "MACS_sample_kidney_box.instr"
  mccchannel_11_cave1_box3_yheight = kidney_cave1_box3_height1;
#line 2954 "MACS_sample_kidney_box.instr"
  mccchannel_11_cave1_box3_zdepth = kidney_cave1_box3_depth;
#line 2955 "MACS_sample_kidney_box.instr"
  mccchannel_11_cave1_box3_xwidth2 = kidney_cave1_box3_width2;
#line 2955 "MACS_sample_kidney_box.instr"
  mccchannel_11_cave1_box3_yheight2 = kidney_cave1_box3_height2;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_11_cave1_box3_visualize = 1;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_11_cave1_box3_target_index = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_11_cave1_box3_target_x = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_11_cave1_box3_target_y = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_11_cave1_box3_target_z = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_11_cave1_box3_focus_aw = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_11_cave1_box3_focus_ah = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_11_cave1_box3_focus_xw = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_11_cave1_box3_focus_xh = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_11_cave1_box3_focus_r = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_11_cave1_box3_p_interact = 0;
#line 71 "MACS_sample_kidney_box.instr"
  if(0) strncpy(mccchannel_11_cave1_box3_mask_string, 0 ? 0 : "", 16384); else mccchannel_11_cave1_box3_mask_string[0]='\0';
#line 71 "MACS_sample_kidney_box.instr"
  if(0) strncpy(mccchannel_11_cave1_box3_mask_setting, 0 ? 0 : "", 16384); else mccchannel_11_cave1_box3_mask_setting[0]='\0';
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_11_cave1_box3_number_of_activations = 1;
#line 126055 "MACS_sample_kidney_box.c"

  SIG_MESSAGE("channel_11_cave1_box3 (Init:Place/Rotate)");
  rot_set_rotation(mctr1,
#line 2958 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 2958 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 2958 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD);
#line 126065 "MACS_sample_kidney_box.c"
  rot_mul(mctr1, mcrotakidney_channel_11, mcrotachannel_11_cave1_box3);
  rot_transpose(mcrotachannel_11_cave1_box2, mctr1);
  rot_mul(mcrotachannel_11_cave1_box3, mctr1, mcrotrchannel_11_cave1_box3);
  mctc1 = coords_set(
#line 2957 "MACS_sample_kidney_box.instr"
    0,
#line 2957 "MACS_sample_kidney_box.instr"
    0,
#line 2957 "MACS_sample_kidney_box.instr"
    kidney_cave1_box3_center_to_target);
#line 126076 "MACS_sample_kidney_box.c"
  rot_transpose(mcrotakidney_channel_11, mctr1);
  mctc2 = rot_apply(mctr1, mctc1);
  mcposachannel_11_cave1_box3 = coords_add(mcposakidney_channel_11, mctc2);
  mctc1 = coords_sub(mcposachannel_11_cave1_box2, mcposachannel_11_cave1_box3);
  mcposrchannel_11_cave1_box3 = rot_apply(mcrotachannel_11_cave1_box3, mctc1);
  mcDEBUG_COMPONENT("channel_11_cave1_box3", mcposachannel_11_cave1_box3, mcrotachannel_11_cave1_box3)
  mccomp_posa[544] = mcposachannel_11_cave1_box3;
  mccomp_posr[544] = mcposrchannel_11_cave1_box3;
  mcNCounter[544]  = mcPCounter[544] = mcP2Counter[544] = 0;
  mcAbsorbProp[544]= 0;
    /* Component channel_11_cave1_cyl1. */
  /* Setting parameters for component channel_11_cave1_cyl1. */
  SIG_MESSAGE("channel_11_cave1_cyl1 (Init:SetPar)");
#line 2962 "MACS_sample_kidney_box.instr"
  if("Vacuum") strncpy(mccchannel_11_cave1_cyl1_material_string, "Vacuum" ? "Vacuum" : "", 16384); else mccchannel_11_cave1_cyl1_material_string[0]='\0';
#line 2962 "MACS_sample_kidney_box.instr"
  mccchannel_11_cave1_cyl1_priority = 1303;
#line 2961 "MACS_sample_kidney_box.instr"
  mccchannel_11_cave1_cyl1_radius = kidney_cave1_cyl1_radius;
#line 2961 "MACS_sample_kidney_box.instr"
  mccchannel_11_cave1_cyl1_yheight = kidney_cave1_cyl1_height;
#line 67 "MACS_sample_kidney_box.instr"
  mccchannel_11_cave1_cyl1_visualize = 1;
#line 67 "MACS_sample_kidney_box.instr"
  mccchannel_11_cave1_cyl1_target_index = 0;
#line 67 "MACS_sample_kidney_box.instr"
  mccchannel_11_cave1_cyl1_target_x = 0;
#line 67 "MACS_sample_kidney_box.instr"
  mccchannel_11_cave1_cyl1_target_y = 0;
#line 67 "MACS_sample_kidney_box.instr"
  mccchannel_11_cave1_cyl1_target_z = 0;
#line 67 "MACS_sample_kidney_box.instr"
  mccchannel_11_cave1_cyl1_focus_aw = 0;
#line 67 "MACS_sample_kidney_box.instr"
  mccchannel_11_cave1_cyl1_focus_ah = 0;
#line 67 "MACS_sample_kidney_box.instr"
  mccchannel_11_cave1_cyl1_focus_xw = 0;
#line 67 "MACS_sample_kidney_box.instr"
  mccchannel_11_cave1_cyl1_focus_xh = 0;
#line 67 "MACS_sample_kidney_box.instr"
  mccchannel_11_cave1_cyl1_focus_r = 0;
#line 67 "MACS_sample_kidney_box.instr"
  mccchannel_11_cave1_cyl1_p_interact = 0;
#line 67 "MACS_sample_kidney_box.instr"
  if(0) strncpy(mccchannel_11_cave1_cyl1_mask_string, 0 ? 0 : "", 16384); else mccchannel_11_cave1_cyl1_mask_string[0]='\0';
#line 67 "MACS_sample_kidney_box.instr"
  if(0) strncpy(mccchannel_11_cave1_cyl1_mask_setting, 0 ? 0 : "", 16384); else mccchannel_11_cave1_cyl1_mask_setting[0]='\0';
#line 67 "MACS_sample_kidney_box.instr"
  mccchannel_11_cave1_cyl1_number_of_activations = 1;
#line 126126 "MACS_sample_kidney_box.c"

  SIG_MESSAGE("channel_11_cave1_cyl1 (Init:Place/Rotate)");
  rot_set_rotation(mctr1,
#line 2964 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 2964 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 2964 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD);
#line 126136 "MACS_sample_kidney_box.c"
  rot_mul(mctr1, mcrotakidney_channel_11, mcrotachannel_11_cave1_cyl1);
  rot_transpose(mcrotachannel_11_cave1_box3, mctr1);
  rot_mul(mcrotachannel_11_cave1_cyl1, mctr1, mcrotrchannel_11_cave1_cyl1);
  mctc1 = coords_set(
#line 2963 "MACS_sample_kidney_box.instr"
    0,
#line 2963 "MACS_sample_kidney_box.instr"
    0,
#line 2963 "MACS_sample_kidney_box.instr"
    kidney_cave1_cyl1_center_to_target);
#line 126147 "MACS_sample_kidney_box.c"
  rot_transpose(mcrotakidney_channel_11, mctr1);
  mctc2 = rot_apply(mctr1, mctc1);
  mcposachannel_11_cave1_cyl1 = coords_add(mcposakidney_channel_11, mctc2);
  mctc1 = coords_sub(mcposachannel_11_cave1_box3, mcposachannel_11_cave1_cyl1);
  mcposrchannel_11_cave1_cyl1 = rot_apply(mcrotachannel_11_cave1_cyl1, mctc1);
  mcDEBUG_COMPONENT("channel_11_cave1_cyl1", mcposachannel_11_cave1_cyl1, mcrotachannel_11_cave1_cyl1)
  mccomp_posa[545] = mcposachannel_11_cave1_cyl1;
  mccomp_posr[545] = mcposrchannel_11_cave1_cyl1;
  mcNCounter[545]  = mcPCounter[545] = mcP2Counter[545] = 0;
  mcAbsorbProp[545]= 0;
    /* Component channel_11_analyzer_1_center. */
  /* Setting parameters for component channel_11_analyzer_1_center. */
  SIG_MESSAGE("channel_11_analyzer_1_center (Init:SetPar)");

  SIG_MESSAGE("channel_11_analyzer_1_center (Init:Place/Rotate)");
  rot_set_rotation(mctr1,
    (0.0)*DEG2RAD,
    (0.0)*DEG2RAD,
    (0.0)*DEG2RAD);
#line 126167 "MACS_sample_kidney_box.c"
  rot_mul(mctr1, mcrotakidney_channel_11, mcrotachannel_11_analyzer_1_center);
  rot_transpose(mcrotachannel_11_cave1_cyl1, mctr1);
  rot_mul(mcrotachannel_11_analyzer_1_center, mctr1, mcrotrchannel_11_analyzer_1_center);
  mctc1 = coords_set(
#line 2968 "MACS_sample_kidney_box.instr"
    0,
#line 2968 "MACS_sample_kidney_box.instr"
    0,
#line 2968 "MACS_sample_kidney_box.instr"
    analyzer_1_center_to_sample);
#line 126178 "MACS_sample_kidney_box.c"
  rot_transpose(mcrotakidney_channel_11, mctr1);
  mctc2 = rot_apply(mctr1, mctc1);
  mcposachannel_11_analyzer_1_center = coords_add(mcposakidney_channel_11, mctc2);
  mctc1 = coords_sub(mcposachannel_11_cave1_cyl1, mcposachannel_11_analyzer_1_center);
  mcposrchannel_11_analyzer_1_center = rot_apply(mcrotachannel_11_analyzer_1_center, mctc1);
  mcDEBUG_COMPONENT("channel_11_analyzer_1_center", mcposachannel_11_analyzer_1_center, mcrotachannel_11_analyzer_1_center)
  mccomp_posa[546] = mcposachannel_11_analyzer_1_center;
  mccomp_posr[546] = mcposrchannel_11_analyzer_1_center;
  mcNCounter[546]  = mcPCounter[546] = mcP2Counter[546] = 0;
  mcAbsorbProp[546]= 0;
    /* Component channel_11_analyzer_1_rotated. */
  /* Setting parameters for component channel_11_analyzer_1_rotated. */
  SIG_MESSAGE("channel_11_analyzer_1_rotated (Init:SetPar)");

  SIG_MESSAGE("channel_11_analyzer_1_rotated (Init:Place/Rotate)");
  rot_set_rotation(mctr1,
#line 2972 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 2972 "MACS_sample_kidney_box.instr"
    (180 - analyzer_theta [ 11 ])*DEG2RAD,
#line 2972 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD);
#line 126201 "MACS_sample_kidney_box.c"
  rot_mul(mctr1, mcrotachannel_11_analyzer_1_center, mcrotachannel_11_analyzer_1_rotated);
  rot_transpose(mcrotachannel_11_analyzer_1_center, mctr1);
  rot_mul(mcrotachannel_11_analyzer_1_rotated, mctr1, mcrotrchannel_11_analyzer_1_rotated);
  mctc1 = coords_set(
#line 2971 "MACS_sample_kidney_box.instr"
    0,
#line 2971 "MACS_sample_kidney_box.instr"
    0,
#line 2971 "MACS_sample_kidney_box.instr"
    -0.5 * analyzer_seperation / tan ( analyzer_2theta [ 11 ] * DEG2RAD ));
#line 126212 "MACS_sample_kidney_box.c"
  rot_transpose(mcrotachannel_11_analyzer_1_center, mctr1);
  mctc2 = rot_apply(mctr1, mctc1);
  mcposachannel_11_analyzer_1_rotated = coords_add(mcposachannel_11_analyzer_1_center, mctc2);
  mctc1 = coords_sub(mcposachannel_11_analyzer_1_center, mcposachannel_11_analyzer_1_rotated);
  mcposrchannel_11_analyzer_1_rotated = rot_apply(mcrotachannel_11_analyzer_1_rotated, mctc1);
  mcDEBUG_COMPONENT("channel_11_analyzer_1_rotated", mcposachannel_11_analyzer_1_rotated, mcrotachannel_11_analyzer_1_rotated)
  mccomp_posa[547] = mcposachannel_11_analyzer_1_rotated;
  mccomp_posr[547] = mcposrchannel_11_analyzer_1_rotated;
  mcNCounter[547]  = mcPCounter[547] = mcP2Counter[547] = 0;
  mcAbsorbProp[547]= 0;
    /* Component channel_11_analyzer_1_array_crystal_array_0. */
  /* Setting parameters for component channel_11_analyzer_1_array_crystal_array_0. */
  SIG_MESSAGE("channel_11_analyzer_1_array_crystal_array_0 (Init:SetPar)");
#line 2976 "MACS_sample_kidney_box.instr"
  if("PG_analyzer") strncpy(mccchannel_11_analyzer_1_array_crystal_array_0_material_string, "PG_analyzer" ? "PG_analyzer" : "", 16384); else mccchannel_11_analyzer_1_array_crystal_array_0_material_string[0]='\0';
#line 2976 "MACS_sample_kidney_box.instr"
  mccchannel_11_analyzer_1_array_crystal_array_0_priority = 1320.0;
#line 2975 "MACS_sample_kidney_box.instr"
  mccchannel_11_analyzer_1_array_crystal_array_0_xwidth = channel_11_analyzer_1_array_crystal_depth;
#line 2975 "MACS_sample_kidney_box.instr"
  mccchannel_11_analyzer_1_array_crystal_array_0_yheight = channel_11_analyzer_1_array_crystal_height;
#line 2975 "MACS_sample_kidney_box.instr"
  mccchannel_11_analyzer_1_array_crystal_array_0_zdepth = channel_11_analyzer_1_array_crystal_width;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_11_analyzer_1_array_crystal_array_0_xwidth2 = -1;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_11_analyzer_1_array_crystal_array_0_yheight2 = -1;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_11_analyzer_1_array_crystal_array_0_visualize = 1;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_11_analyzer_1_array_crystal_array_0_target_index = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_11_analyzer_1_array_crystal_array_0_target_x = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_11_analyzer_1_array_crystal_array_0_target_y = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_11_analyzer_1_array_crystal_array_0_target_z = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_11_analyzer_1_array_crystal_array_0_focus_aw = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_11_analyzer_1_array_crystal_array_0_focus_ah = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_11_analyzer_1_array_crystal_array_0_focus_xw = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_11_analyzer_1_array_crystal_array_0_focus_xh = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_11_analyzer_1_array_crystal_array_0_focus_r = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_11_analyzer_1_array_crystal_array_0_p_interact = 0;
#line 71 "MACS_sample_kidney_box.instr"
  if(0) strncpy(mccchannel_11_analyzer_1_array_crystal_array_0_mask_string, 0 ? 0 : "", 16384); else mccchannel_11_analyzer_1_array_crystal_array_0_mask_string[0]='\0';
#line 71 "MACS_sample_kidney_box.instr"
  if(0) strncpy(mccchannel_11_analyzer_1_array_crystal_array_0_mask_setting, 0 ? 0 : "", 16384); else mccchannel_11_analyzer_1_array_crystal_array_0_mask_setting[0]='\0';
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_11_analyzer_1_array_crystal_array_0_number_of_activations = 1;
#line 126268 "MACS_sample_kidney_box.c"

  SIG_MESSAGE("channel_11_analyzer_1_array_crystal_array_0 (Init:Place/Rotate)");
  rot_set_rotation(mctr1,
#line 2978 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 2978 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 2978 "MACS_sample_kidney_box.instr"
    (0 - RAD2DEG * channel_11_analyzer_1_array_theta [ 0 ])*DEG2RAD);
#line 126278 "MACS_sample_kidney_box.c"
  rot_mul(mctr1, mcrotachannel_11_analyzer_1_rotated, mcrotachannel_11_analyzer_1_array_crystal_array_0);
  rot_transpose(mcrotachannel_11_analyzer_1_rotated, mctr1);
  rot_mul(mcrotachannel_11_analyzer_1_array_crystal_array_0, mctr1, mcrotrchannel_11_analyzer_1_array_crystal_array_0);
  mctc1 = coords_set(
#line 2977 "MACS_sample_kidney_box.instr"
    0 + channel_11_analyzer_1_array_effective_radius_of_curvature * ( 1 - cos ( channel_11_analyzer_1_array_theta [ 0 ] ) ),
#line 2977 "MACS_sample_kidney_box.instr"
    0 + channel_11_analyzer_1_array_effective_radius_of_curvature * sin ( channel_11_analyzer_1_array_theta [ 0 ] ),
#line 2977 "MACS_sample_kidney_box.instr"
    0);
#line 126289 "MACS_sample_kidney_box.c"
  rot_transpose(mcrotachannel_11_analyzer_1_rotated, mctr1);
  mctc2 = rot_apply(mctr1, mctc1);
  mcposachannel_11_analyzer_1_array_crystal_array_0 = coords_add(mcposachannel_11_analyzer_1_rotated, mctc2);
  mctc1 = coords_sub(mcposachannel_11_analyzer_1_rotated, mcposachannel_11_analyzer_1_array_crystal_array_0);
  mcposrchannel_11_analyzer_1_array_crystal_array_0 = rot_apply(mcrotachannel_11_analyzer_1_array_crystal_array_0, mctc1);
  mcDEBUG_COMPONENT("channel_11_analyzer_1_array_crystal_array_0", mcposachannel_11_analyzer_1_array_crystal_array_0, mcrotachannel_11_analyzer_1_array_crystal_array_0)
  mccomp_posa[548] = mcposachannel_11_analyzer_1_array_crystal_array_0;
  mccomp_posr[548] = mcposrchannel_11_analyzer_1_array_crystal_array_0;
  mcNCounter[548]  = mcPCounter[548] = mcP2Counter[548] = 0;
  mcAbsorbProp[548]= 0;
    /* Component channel_11_analyzer_1_array_crystal_array_1. */
  /* Setting parameters for component channel_11_analyzer_1_array_crystal_array_1. */
  SIG_MESSAGE("channel_11_analyzer_1_array_crystal_array_1 (Init:SetPar)");
#line 2982 "MACS_sample_kidney_box.instr"
  if("PG_analyzer") strncpy(mccchannel_11_analyzer_1_array_crystal_array_1_material_string, "PG_analyzer" ? "PG_analyzer" : "", 16384); else mccchannel_11_analyzer_1_array_crystal_array_1_material_string[0]='\0';
#line 2982 "MACS_sample_kidney_box.instr"
  mccchannel_11_analyzer_1_array_crystal_array_1_priority = 1320.1;
#line 2981 "MACS_sample_kidney_box.instr"
  mccchannel_11_analyzer_1_array_crystal_array_1_xwidth = channel_11_analyzer_1_array_crystal_depth;
#line 2981 "MACS_sample_kidney_box.instr"
  mccchannel_11_analyzer_1_array_crystal_array_1_yheight = channel_11_analyzer_1_array_crystal_height;
#line 2981 "MACS_sample_kidney_box.instr"
  mccchannel_11_analyzer_1_array_crystal_array_1_zdepth = channel_11_analyzer_1_array_crystal_width;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_11_analyzer_1_array_crystal_array_1_xwidth2 = -1;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_11_analyzer_1_array_crystal_array_1_yheight2 = -1;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_11_analyzer_1_array_crystal_array_1_visualize = 1;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_11_analyzer_1_array_crystal_array_1_target_index = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_11_analyzer_1_array_crystal_array_1_target_x = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_11_analyzer_1_array_crystal_array_1_target_y = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_11_analyzer_1_array_crystal_array_1_target_z = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_11_analyzer_1_array_crystal_array_1_focus_aw = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_11_analyzer_1_array_crystal_array_1_focus_ah = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_11_analyzer_1_array_crystal_array_1_focus_xw = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_11_analyzer_1_array_crystal_array_1_focus_xh = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_11_analyzer_1_array_crystal_array_1_focus_r = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_11_analyzer_1_array_crystal_array_1_p_interact = 0;
#line 71 "MACS_sample_kidney_box.instr"
  if(0) strncpy(mccchannel_11_analyzer_1_array_crystal_array_1_mask_string, 0 ? 0 : "", 16384); else mccchannel_11_analyzer_1_array_crystal_array_1_mask_string[0]='\0';
#line 71 "MACS_sample_kidney_box.instr"
  if(0) strncpy(mccchannel_11_analyzer_1_array_crystal_array_1_mask_setting, 0 ? 0 : "", 16384); else mccchannel_11_analyzer_1_array_crystal_array_1_mask_setting[0]='\0';
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_11_analyzer_1_array_crystal_array_1_number_of_activations = 1;
#line 126345 "MACS_sample_kidney_box.c"

  SIG_MESSAGE("channel_11_analyzer_1_array_crystal_array_1 (Init:Place/Rotate)");
  rot_set_rotation(mctr1,
#line 2984 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 2984 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 2984 "MACS_sample_kidney_box.instr"
    (0 - RAD2DEG * channel_11_analyzer_1_array_theta [ 1 ])*DEG2RAD);
#line 126355 "MACS_sample_kidney_box.c"
  rot_mul(mctr1, mcrotachannel_11_analyzer_1_rotated, mcrotachannel_11_analyzer_1_array_crystal_array_1);
  rot_transpose(mcrotachannel_11_analyzer_1_array_crystal_array_0, mctr1);
  rot_mul(mcrotachannel_11_analyzer_1_array_crystal_array_1, mctr1, mcrotrchannel_11_analyzer_1_array_crystal_array_1);
  mctc1 = coords_set(
#line 2983 "MACS_sample_kidney_box.instr"
    0 + channel_11_analyzer_1_array_effective_radius_of_curvature * ( 1 - cos ( channel_11_analyzer_1_array_theta [ 1 ] ) ),
#line 2983 "MACS_sample_kidney_box.instr"
    0 + channel_11_analyzer_1_array_effective_radius_of_curvature * sin ( channel_11_analyzer_1_array_theta [ 1 ] ),
#line 2983 "MACS_sample_kidney_box.instr"
    0);
#line 126366 "MACS_sample_kidney_box.c"
  rot_transpose(mcrotachannel_11_analyzer_1_rotated, mctr1);
  mctc2 = rot_apply(mctr1, mctc1);
  mcposachannel_11_analyzer_1_array_crystal_array_1 = coords_add(mcposachannel_11_analyzer_1_rotated, mctc2);
  mctc1 = coords_sub(mcposachannel_11_analyzer_1_array_crystal_array_0, mcposachannel_11_analyzer_1_array_crystal_array_1);
  mcposrchannel_11_analyzer_1_array_crystal_array_1 = rot_apply(mcrotachannel_11_analyzer_1_array_crystal_array_1, mctc1);
  mcDEBUG_COMPONENT("channel_11_analyzer_1_array_crystal_array_1", mcposachannel_11_analyzer_1_array_crystal_array_1, mcrotachannel_11_analyzer_1_array_crystal_array_1)
  mccomp_posa[549] = mcposachannel_11_analyzer_1_array_crystal_array_1;
  mccomp_posr[549] = mcposrchannel_11_analyzer_1_array_crystal_array_1;
  mcNCounter[549]  = mcPCounter[549] = mcP2Counter[549] = 0;
  mcAbsorbProp[549]= 0;
    /* Component channel_11_analyzer_1_array_crystal_array_2. */
  /* Setting parameters for component channel_11_analyzer_1_array_crystal_array_2. */
  SIG_MESSAGE("channel_11_analyzer_1_array_crystal_array_2 (Init:SetPar)");
#line 2988 "MACS_sample_kidney_box.instr"
  if("PG_analyzer") strncpy(mccchannel_11_analyzer_1_array_crystal_array_2_material_string, "PG_analyzer" ? "PG_analyzer" : "", 16384); else mccchannel_11_analyzer_1_array_crystal_array_2_material_string[0]='\0';
#line 2988 "MACS_sample_kidney_box.instr"
  mccchannel_11_analyzer_1_array_crystal_array_2_priority = 1320.2;
#line 2987 "MACS_sample_kidney_box.instr"
  mccchannel_11_analyzer_1_array_crystal_array_2_xwidth = channel_11_analyzer_1_array_crystal_depth;
#line 2987 "MACS_sample_kidney_box.instr"
  mccchannel_11_analyzer_1_array_crystal_array_2_yheight = channel_11_analyzer_1_array_crystal_height;
#line 2987 "MACS_sample_kidney_box.instr"
  mccchannel_11_analyzer_1_array_crystal_array_2_zdepth = channel_11_analyzer_1_array_crystal_width;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_11_analyzer_1_array_crystal_array_2_xwidth2 = -1;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_11_analyzer_1_array_crystal_array_2_yheight2 = -1;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_11_analyzer_1_array_crystal_array_2_visualize = 1;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_11_analyzer_1_array_crystal_array_2_target_index = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_11_analyzer_1_array_crystal_array_2_target_x = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_11_analyzer_1_array_crystal_array_2_target_y = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_11_analyzer_1_array_crystal_array_2_target_z = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_11_analyzer_1_array_crystal_array_2_focus_aw = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_11_analyzer_1_array_crystal_array_2_focus_ah = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_11_analyzer_1_array_crystal_array_2_focus_xw = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_11_analyzer_1_array_crystal_array_2_focus_xh = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_11_analyzer_1_array_crystal_array_2_focus_r = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_11_analyzer_1_array_crystal_array_2_p_interact = 0;
#line 71 "MACS_sample_kidney_box.instr"
  if(0) strncpy(mccchannel_11_analyzer_1_array_crystal_array_2_mask_string, 0 ? 0 : "", 16384); else mccchannel_11_analyzer_1_array_crystal_array_2_mask_string[0]='\0';
#line 71 "MACS_sample_kidney_box.instr"
  if(0) strncpy(mccchannel_11_analyzer_1_array_crystal_array_2_mask_setting, 0 ? 0 : "", 16384); else mccchannel_11_analyzer_1_array_crystal_array_2_mask_setting[0]='\0';
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_11_analyzer_1_array_crystal_array_2_number_of_activations = 1;
#line 126422 "MACS_sample_kidney_box.c"

  SIG_MESSAGE("channel_11_analyzer_1_array_crystal_array_2 (Init:Place/Rotate)");
  rot_set_rotation(mctr1,
#line 2990 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 2990 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 2990 "MACS_sample_kidney_box.instr"
    (0 - RAD2DEG * channel_11_analyzer_1_array_theta [ 2 ])*DEG2RAD);
#line 126432 "MACS_sample_kidney_box.c"
  rot_mul(mctr1, mcrotachannel_11_analyzer_1_rotated, mcrotachannel_11_analyzer_1_array_crystal_array_2);
  rot_transpose(mcrotachannel_11_analyzer_1_array_crystal_array_1, mctr1);
  rot_mul(mcrotachannel_11_analyzer_1_array_crystal_array_2, mctr1, mcrotrchannel_11_analyzer_1_array_crystal_array_2);
  mctc1 = coords_set(
#line 2989 "MACS_sample_kidney_box.instr"
    0 + channel_11_analyzer_1_array_effective_radius_of_curvature * ( 1 - cos ( channel_11_analyzer_1_array_theta [ 2 ] ) ),
#line 2989 "MACS_sample_kidney_box.instr"
    0 + channel_11_analyzer_1_array_effective_radius_of_curvature * sin ( channel_11_analyzer_1_array_theta [ 2 ] ),
#line 2989 "MACS_sample_kidney_box.instr"
    0);
#line 126443 "MACS_sample_kidney_box.c"
  rot_transpose(mcrotachannel_11_analyzer_1_rotated, mctr1);
  mctc2 = rot_apply(mctr1, mctc1);
  mcposachannel_11_analyzer_1_array_crystal_array_2 = coords_add(mcposachannel_11_analyzer_1_rotated, mctc2);
  mctc1 = coords_sub(mcposachannel_11_analyzer_1_array_crystal_array_1, mcposachannel_11_analyzer_1_array_crystal_array_2);
  mcposrchannel_11_analyzer_1_array_crystal_array_2 = rot_apply(mcrotachannel_11_analyzer_1_array_crystal_array_2, mctc1);
  mcDEBUG_COMPONENT("channel_11_analyzer_1_array_crystal_array_2", mcposachannel_11_analyzer_1_array_crystal_array_2, mcrotachannel_11_analyzer_1_array_crystal_array_2)
  mccomp_posa[550] = mcposachannel_11_analyzer_1_array_crystal_array_2;
  mccomp_posr[550] = mcposrchannel_11_analyzer_1_array_crystal_array_2;
  mcNCounter[550]  = mcPCounter[550] = mcP2Counter[550] = 0;
  mcAbsorbProp[550]= 0;
    /* Component channel_11_analyzer_1_array_crystal_array_3. */
  /* Setting parameters for component channel_11_analyzer_1_array_crystal_array_3. */
  SIG_MESSAGE("channel_11_analyzer_1_array_crystal_array_3 (Init:SetPar)");
#line 2994 "MACS_sample_kidney_box.instr"
  if("PG_analyzer") strncpy(mccchannel_11_analyzer_1_array_crystal_array_3_material_string, "PG_analyzer" ? "PG_analyzer" : "", 16384); else mccchannel_11_analyzer_1_array_crystal_array_3_material_string[0]='\0';
#line 2994 "MACS_sample_kidney_box.instr"
  mccchannel_11_analyzer_1_array_crystal_array_3_priority = 1320.3;
#line 2993 "MACS_sample_kidney_box.instr"
  mccchannel_11_analyzer_1_array_crystal_array_3_xwidth = channel_11_analyzer_1_array_crystal_depth;
#line 2993 "MACS_sample_kidney_box.instr"
  mccchannel_11_analyzer_1_array_crystal_array_3_yheight = channel_11_analyzer_1_array_crystal_height;
#line 2993 "MACS_sample_kidney_box.instr"
  mccchannel_11_analyzer_1_array_crystal_array_3_zdepth = channel_11_analyzer_1_array_crystal_width;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_11_analyzer_1_array_crystal_array_3_xwidth2 = -1;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_11_analyzer_1_array_crystal_array_3_yheight2 = -1;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_11_analyzer_1_array_crystal_array_3_visualize = 1;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_11_analyzer_1_array_crystal_array_3_target_index = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_11_analyzer_1_array_crystal_array_3_target_x = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_11_analyzer_1_array_crystal_array_3_target_y = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_11_analyzer_1_array_crystal_array_3_target_z = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_11_analyzer_1_array_crystal_array_3_focus_aw = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_11_analyzer_1_array_crystal_array_3_focus_ah = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_11_analyzer_1_array_crystal_array_3_focus_xw = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_11_analyzer_1_array_crystal_array_3_focus_xh = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_11_analyzer_1_array_crystal_array_3_focus_r = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_11_analyzer_1_array_crystal_array_3_p_interact = 0;
#line 71 "MACS_sample_kidney_box.instr"
  if(0) strncpy(mccchannel_11_analyzer_1_array_crystal_array_3_mask_string, 0 ? 0 : "", 16384); else mccchannel_11_analyzer_1_array_crystal_array_3_mask_string[0]='\0';
#line 71 "MACS_sample_kidney_box.instr"
  if(0) strncpy(mccchannel_11_analyzer_1_array_crystal_array_3_mask_setting, 0 ? 0 : "", 16384); else mccchannel_11_analyzer_1_array_crystal_array_3_mask_setting[0]='\0';
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_11_analyzer_1_array_crystal_array_3_number_of_activations = 1;
#line 126499 "MACS_sample_kidney_box.c"

  SIG_MESSAGE("channel_11_analyzer_1_array_crystal_array_3 (Init:Place/Rotate)");
  rot_set_rotation(mctr1,
#line 2996 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 2996 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 2996 "MACS_sample_kidney_box.instr"
    (0 - RAD2DEG * channel_11_analyzer_1_array_theta [ 3 ])*DEG2RAD);
#line 126509 "MACS_sample_kidney_box.c"
  rot_mul(mctr1, mcrotachannel_11_analyzer_1_rotated, mcrotachannel_11_analyzer_1_array_crystal_array_3);
  rot_transpose(mcrotachannel_11_analyzer_1_array_crystal_array_2, mctr1);
  rot_mul(mcrotachannel_11_analyzer_1_array_crystal_array_3, mctr1, mcrotrchannel_11_analyzer_1_array_crystal_array_3);
  mctc1 = coords_set(
#line 2995 "MACS_sample_kidney_box.instr"
    0 + channel_11_analyzer_1_array_effective_radius_of_curvature * ( 1 - cos ( channel_11_analyzer_1_array_theta [ 3 ] ) ),
#line 2995 "MACS_sample_kidney_box.instr"
    0 + channel_11_analyzer_1_array_effective_radius_of_curvature * sin ( channel_11_analyzer_1_array_theta [ 3 ] ),
#line 2995 "MACS_sample_kidney_box.instr"
    0);
#line 126520 "MACS_sample_kidney_box.c"
  rot_transpose(mcrotachannel_11_analyzer_1_rotated, mctr1);
  mctc2 = rot_apply(mctr1, mctc1);
  mcposachannel_11_analyzer_1_array_crystal_array_3 = coords_add(mcposachannel_11_analyzer_1_rotated, mctc2);
  mctc1 = coords_sub(mcposachannel_11_analyzer_1_array_crystal_array_2, mcposachannel_11_analyzer_1_array_crystal_array_3);
  mcposrchannel_11_analyzer_1_array_crystal_array_3 = rot_apply(mcrotachannel_11_analyzer_1_array_crystal_array_3, mctc1);
  mcDEBUG_COMPONENT("channel_11_analyzer_1_array_crystal_array_3", mcposachannel_11_analyzer_1_array_crystal_array_3, mcrotachannel_11_analyzer_1_array_crystal_array_3)
  mccomp_posa[551] = mcposachannel_11_analyzer_1_array_crystal_array_3;
  mccomp_posr[551] = mcposrchannel_11_analyzer_1_array_crystal_array_3;
  mcNCounter[551]  = mcPCounter[551] = mcP2Counter[551] = 0;
  mcAbsorbProp[551]= 0;
    /* Component channel_11_analyzer_1_array_crystal_array_4. */
  /* Setting parameters for component channel_11_analyzer_1_array_crystal_array_4. */
  SIG_MESSAGE("channel_11_analyzer_1_array_crystal_array_4 (Init:SetPar)");
#line 3000 "MACS_sample_kidney_box.instr"
  if("PG_analyzer") strncpy(mccchannel_11_analyzer_1_array_crystal_array_4_material_string, "PG_analyzer" ? "PG_analyzer" : "", 16384); else mccchannel_11_analyzer_1_array_crystal_array_4_material_string[0]='\0';
#line 3000 "MACS_sample_kidney_box.instr"
  mccchannel_11_analyzer_1_array_crystal_array_4_priority = 1320.4;
#line 2999 "MACS_sample_kidney_box.instr"
  mccchannel_11_analyzer_1_array_crystal_array_4_xwidth = channel_11_analyzer_1_array_crystal_depth;
#line 2999 "MACS_sample_kidney_box.instr"
  mccchannel_11_analyzer_1_array_crystal_array_4_yheight = channel_11_analyzer_1_array_crystal_height;
#line 2999 "MACS_sample_kidney_box.instr"
  mccchannel_11_analyzer_1_array_crystal_array_4_zdepth = channel_11_analyzer_1_array_crystal_width;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_11_analyzer_1_array_crystal_array_4_xwidth2 = -1;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_11_analyzer_1_array_crystal_array_4_yheight2 = -1;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_11_analyzer_1_array_crystal_array_4_visualize = 1;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_11_analyzer_1_array_crystal_array_4_target_index = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_11_analyzer_1_array_crystal_array_4_target_x = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_11_analyzer_1_array_crystal_array_4_target_y = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_11_analyzer_1_array_crystal_array_4_target_z = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_11_analyzer_1_array_crystal_array_4_focus_aw = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_11_analyzer_1_array_crystal_array_4_focus_ah = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_11_analyzer_1_array_crystal_array_4_focus_xw = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_11_analyzer_1_array_crystal_array_4_focus_xh = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_11_analyzer_1_array_crystal_array_4_focus_r = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_11_analyzer_1_array_crystal_array_4_p_interact = 0;
#line 71 "MACS_sample_kidney_box.instr"
  if(0) strncpy(mccchannel_11_analyzer_1_array_crystal_array_4_mask_string, 0 ? 0 : "", 16384); else mccchannel_11_analyzer_1_array_crystal_array_4_mask_string[0]='\0';
#line 71 "MACS_sample_kidney_box.instr"
  if(0) strncpy(mccchannel_11_analyzer_1_array_crystal_array_4_mask_setting, 0 ? 0 : "", 16384); else mccchannel_11_analyzer_1_array_crystal_array_4_mask_setting[0]='\0';
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_11_analyzer_1_array_crystal_array_4_number_of_activations = 1;
#line 126576 "MACS_sample_kidney_box.c"

  SIG_MESSAGE("channel_11_analyzer_1_array_crystal_array_4 (Init:Place/Rotate)");
  rot_set_rotation(mctr1,
#line 3002 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 3002 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 3002 "MACS_sample_kidney_box.instr"
    (0 - RAD2DEG * channel_11_analyzer_1_array_theta [ 4 ])*DEG2RAD);
#line 126586 "MACS_sample_kidney_box.c"
  rot_mul(mctr1, mcrotachannel_11_analyzer_1_rotated, mcrotachannel_11_analyzer_1_array_crystal_array_4);
  rot_transpose(mcrotachannel_11_analyzer_1_array_crystal_array_3, mctr1);
  rot_mul(mcrotachannel_11_analyzer_1_array_crystal_array_4, mctr1, mcrotrchannel_11_analyzer_1_array_crystal_array_4);
  mctc1 = coords_set(
#line 3001 "MACS_sample_kidney_box.instr"
    0 + channel_11_analyzer_1_array_effective_radius_of_curvature * ( 1 - cos ( channel_11_analyzer_1_array_theta [ 4 ] ) ),
#line 3001 "MACS_sample_kidney_box.instr"
    0 + channel_11_analyzer_1_array_effective_radius_of_curvature * sin ( channel_11_analyzer_1_array_theta [ 4 ] ),
#line 3001 "MACS_sample_kidney_box.instr"
    0);
#line 126597 "MACS_sample_kidney_box.c"
  rot_transpose(mcrotachannel_11_analyzer_1_rotated, mctr1);
  mctc2 = rot_apply(mctr1, mctc1);
  mcposachannel_11_analyzer_1_array_crystal_array_4 = coords_add(mcposachannel_11_analyzer_1_rotated, mctc2);
  mctc1 = coords_sub(mcposachannel_11_analyzer_1_array_crystal_array_3, mcposachannel_11_analyzer_1_array_crystal_array_4);
  mcposrchannel_11_analyzer_1_array_crystal_array_4 = rot_apply(mcrotachannel_11_analyzer_1_array_crystal_array_4, mctc1);
  mcDEBUG_COMPONENT("channel_11_analyzer_1_array_crystal_array_4", mcposachannel_11_analyzer_1_array_crystal_array_4, mcrotachannel_11_analyzer_1_array_crystal_array_4)
  mccomp_posa[552] = mcposachannel_11_analyzer_1_array_crystal_array_4;
  mccomp_posr[552] = mcposrchannel_11_analyzer_1_array_crystal_array_4;
  mcNCounter[552]  = mcPCounter[552] = mcP2Counter[552] = 0;
  mcAbsorbProp[552]= 0;
    /* Component channel_11_analyzer_1_array_crystal_array_5. */
  /* Setting parameters for component channel_11_analyzer_1_array_crystal_array_5. */
  SIG_MESSAGE("channel_11_analyzer_1_array_crystal_array_5 (Init:SetPar)");
#line 3006 "MACS_sample_kidney_box.instr"
  if("PG_analyzer") strncpy(mccchannel_11_analyzer_1_array_crystal_array_5_material_string, "PG_analyzer" ? "PG_analyzer" : "", 16384); else mccchannel_11_analyzer_1_array_crystal_array_5_material_string[0]='\0';
#line 3006 "MACS_sample_kidney_box.instr"
  mccchannel_11_analyzer_1_array_crystal_array_5_priority = 1320.5;
#line 3005 "MACS_sample_kidney_box.instr"
  mccchannel_11_analyzer_1_array_crystal_array_5_xwidth = channel_11_analyzer_1_array_crystal_depth;
#line 3005 "MACS_sample_kidney_box.instr"
  mccchannel_11_analyzer_1_array_crystal_array_5_yheight = channel_11_analyzer_1_array_crystal_height;
#line 3005 "MACS_sample_kidney_box.instr"
  mccchannel_11_analyzer_1_array_crystal_array_5_zdepth = channel_11_analyzer_1_array_crystal_width;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_11_analyzer_1_array_crystal_array_5_xwidth2 = -1;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_11_analyzer_1_array_crystal_array_5_yheight2 = -1;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_11_analyzer_1_array_crystal_array_5_visualize = 1;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_11_analyzer_1_array_crystal_array_5_target_index = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_11_analyzer_1_array_crystal_array_5_target_x = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_11_analyzer_1_array_crystal_array_5_target_y = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_11_analyzer_1_array_crystal_array_5_target_z = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_11_analyzer_1_array_crystal_array_5_focus_aw = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_11_analyzer_1_array_crystal_array_5_focus_ah = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_11_analyzer_1_array_crystal_array_5_focus_xw = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_11_analyzer_1_array_crystal_array_5_focus_xh = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_11_analyzer_1_array_crystal_array_5_focus_r = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_11_analyzer_1_array_crystal_array_5_p_interact = 0;
#line 71 "MACS_sample_kidney_box.instr"
  if(0) strncpy(mccchannel_11_analyzer_1_array_crystal_array_5_mask_string, 0 ? 0 : "", 16384); else mccchannel_11_analyzer_1_array_crystal_array_5_mask_string[0]='\0';
#line 71 "MACS_sample_kidney_box.instr"
  if(0) strncpy(mccchannel_11_analyzer_1_array_crystal_array_5_mask_setting, 0 ? 0 : "", 16384); else mccchannel_11_analyzer_1_array_crystal_array_5_mask_setting[0]='\0';
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_11_analyzer_1_array_crystal_array_5_number_of_activations = 1;
#line 126653 "MACS_sample_kidney_box.c"

  SIG_MESSAGE("channel_11_analyzer_1_array_crystal_array_5 (Init:Place/Rotate)");
  rot_set_rotation(mctr1,
#line 3008 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 3008 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 3008 "MACS_sample_kidney_box.instr"
    (0 - RAD2DEG * channel_11_analyzer_1_array_theta [ 5 ])*DEG2RAD);
#line 126663 "MACS_sample_kidney_box.c"
  rot_mul(mctr1, mcrotachannel_11_analyzer_1_rotated, mcrotachannel_11_analyzer_1_array_crystal_array_5);
  rot_transpose(mcrotachannel_11_analyzer_1_array_crystal_array_4, mctr1);
  rot_mul(mcrotachannel_11_analyzer_1_array_crystal_array_5, mctr1, mcrotrchannel_11_analyzer_1_array_crystal_array_5);
  mctc1 = coords_set(
#line 3007 "MACS_sample_kidney_box.instr"
    0 + channel_11_analyzer_1_array_effective_radius_of_curvature * ( 1 - cos ( channel_11_analyzer_1_array_theta [ 5 ] ) ),
#line 3007 "MACS_sample_kidney_box.instr"
    0 + channel_11_analyzer_1_array_effective_radius_of_curvature * sin ( channel_11_analyzer_1_array_theta [ 5 ] ),
#line 3007 "MACS_sample_kidney_box.instr"
    0);
#line 126674 "MACS_sample_kidney_box.c"
  rot_transpose(mcrotachannel_11_analyzer_1_rotated, mctr1);
  mctc2 = rot_apply(mctr1, mctc1);
  mcposachannel_11_analyzer_1_array_crystal_array_5 = coords_add(mcposachannel_11_analyzer_1_rotated, mctc2);
  mctc1 = coords_sub(mcposachannel_11_analyzer_1_array_crystal_array_4, mcposachannel_11_analyzer_1_array_crystal_array_5);
  mcposrchannel_11_analyzer_1_array_crystal_array_5 = rot_apply(mcrotachannel_11_analyzer_1_array_crystal_array_5, mctc1);
  mcDEBUG_COMPONENT("channel_11_analyzer_1_array_crystal_array_5", mcposachannel_11_analyzer_1_array_crystal_array_5, mcrotachannel_11_analyzer_1_array_crystal_array_5)
  mccomp_posa[553] = mcposachannel_11_analyzer_1_array_crystal_array_5;
  mccomp_posr[553] = mcposrchannel_11_analyzer_1_array_crystal_array_5;
  mcNCounter[553]  = mcPCounter[553] = mcP2Counter[553] = 0;
  mcAbsorbProp[553]= 0;
    /* Component channel_11_analyzer_1_array_crystal_array_6. */
  /* Setting parameters for component channel_11_analyzer_1_array_crystal_array_6. */
  SIG_MESSAGE("channel_11_analyzer_1_array_crystal_array_6 (Init:SetPar)");
#line 3012 "MACS_sample_kidney_box.instr"
  if("PG_analyzer") strncpy(mccchannel_11_analyzer_1_array_crystal_array_6_material_string, "PG_analyzer" ? "PG_analyzer" : "", 16384); else mccchannel_11_analyzer_1_array_crystal_array_6_material_string[0]='\0';
#line 3012 "MACS_sample_kidney_box.instr"
  mccchannel_11_analyzer_1_array_crystal_array_6_priority = 1320.6;
#line 3011 "MACS_sample_kidney_box.instr"
  mccchannel_11_analyzer_1_array_crystal_array_6_xwidth = channel_11_analyzer_1_array_crystal_depth;
#line 3011 "MACS_sample_kidney_box.instr"
  mccchannel_11_analyzer_1_array_crystal_array_6_yheight = channel_11_analyzer_1_array_crystal_height;
#line 3011 "MACS_sample_kidney_box.instr"
  mccchannel_11_analyzer_1_array_crystal_array_6_zdepth = channel_11_analyzer_1_array_crystal_width;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_11_analyzer_1_array_crystal_array_6_xwidth2 = -1;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_11_analyzer_1_array_crystal_array_6_yheight2 = -1;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_11_analyzer_1_array_crystal_array_6_visualize = 1;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_11_analyzer_1_array_crystal_array_6_target_index = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_11_analyzer_1_array_crystal_array_6_target_x = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_11_analyzer_1_array_crystal_array_6_target_y = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_11_analyzer_1_array_crystal_array_6_target_z = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_11_analyzer_1_array_crystal_array_6_focus_aw = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_11_analyzer_1_array_crystal_array_6_focus_ah = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_11_analyzer_1_array_crystal_array_6_focus_xw = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_11_analyzer_1_array_crystal_array_6_focus_xh = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_11_analyzer_1_array_crystal_array_6_focus_r = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_11_analyzer_1_array_crystal_array_6_p_interact = 0;
#line 71 "MACS_sample_kidney_box.instr"
  if(0) strncpy(mccchannel_11_analyzer_1_array_crystal_array_6_mask_string, 0 ? 0 : "", 16384); else mccchannel_11_analyzer_1_array_crystal_array_6_mask_string[0]='\0';
#line 71 "MACS_sample_kidney_box.instr"
  if(0) strncpy(mccchannel_11_analyzer_1_array_crystal_array_6_mask_setting, 0 ? 0 : "", 16384); else mccchannel_11_analyzer_1_array_crystal_array_6_mask_setting[0]='\0';
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_11_analyzer_1_array_crystal_array_6_number_of_activations = 1;
#line 126730 "MACS_sample_kidney_box.c"

  SIG_MESSAGE("channel_11_analyzer_1_array_crystal_array_6 (Init:Place/Rotate)");
  rot_set_rotation(mctr1,
#line 3014 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 3014 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 3014 "MACS_sample_kidney_box.instr"
    (0 - RAD2DEG * channel_11_analyzer_1_array_theta [ 6 ])*DEG2RAD);
#line 126740 "MACS_sample_kidney_box.c"
  rot_mul(mctr1, mcrotachannel_11_analyzer_1_rotated, mcrotachannel_11_analyzer_1_array_crystal_array_6);
  rot_transpose(mcrotachannel_11_analyzer_1_array_crystal_array_5, mctr1);
  rot_mul(mcrotachannel_11_analyzer_1_array_crystal_array_6, mctr1, mcrotrchannel_11_analyzer_1_array_crystal_array_6);
  mctc1 = coords_set(
#line 3013 "MACS_sample_kidney_box.instr"
    0 + channel_11_analyzer_1_array_effective_radius_of_curvature * ( 1 - cos ( channel_11_analyzer_1_array_theta [ 6 ] ) ),
#line 3013 "MACS_sample_kidney_box.instr"
    0 + channel_11_analyzer_1_array_effective_radius_of_curvature * sin ( channel_11_analyzer_1_array_theta [ 6 ] ),
#line 3013 "MACS_sample_kidney_box.instr"
    0);
#line 126751 "MACS_sample_kidney_box.c"
  rot_transpose(mcrotachannel_11_analyzer_1_rotated, mctr1);
  mctc2 = rot_apply(mctr1, mctc1);
  mcposachannel_11_analyzer_1_array_crystal_array_6 = coords_add(mcposachannel_11_analyzer_1_rotated, mctc2);
  mctc1 = coords_sub(mcposachannel_11_analyzer_1_array_crystal_array_5, mcposachannel_11_analyzer_1_array_crystal_array_6);
  mcposrchannel_11_analyzer_1_array_crystal_array_6 = rot_apply(mcrotachannel_11_analyzer_1_array_crystal_array_6, mctc1);
  mcDEBUG_COMPONENT("channel_11_analyzer_1_array_crystal_array_6", mcposachannel_11_analyzer_1_array_crystal_array_6, mcrotachannel_11_analyzer_1_array_crystal_array_6)
  mccomp_posa[554] = mcposachannel_11_analyzer_1_array_crystal_array_6;
  mccomp_posr[554] = mcposrchannel_11_analyzer_1_array_crystal_array_6;
  mcNCounter[554]  = mcPCounter[554] = mcP2Counter[554] = 0;
  mcAbsorbProp[554]= 0;
    /* Component channel_11_analyzer_1_array_crystal_array_7. */
  /* Setting parameters for component channel_11_analyzer_1_array_crystal_array_7. */
  SIG_MESSAGE("channel_11_analyzer_1_array_crystal_array_7 (Init:SetPar)");
#line 3018 "MACS_sample_kidney_box.instr"
  if("PG_analyzer") strncpy(mccchannel_11_analyzer_1_array_crystal_array_7_material_string, "PG_analyzer" ? "PG_analyzer" : "", 16384); else mccchannel_11_analyzer_1_array_crystal_array_7_material_string[0]='\0';
#line 3018 "MACS_sample_kidney_box.instr"
  mccchannel_11_analyzer_1_array_crystal_array_7_priority = 1320.7;
#line 3017 "MACS_sample_kidney_box.instr"
  mccchannel_11_analyzer_1_array_crystal_array_7_xwidth = channel_11_analyzer_1_array_crystal_depth;
#line 3017 "MACS_sample_kidney_box.instr"
  mccchannel_11_analyzer_1_array_crystal_array_7_yheight = channel_11_analyzer_1_array_crystal_height;
#line 3017 "MACS_sample_kidney_box.instr"
  mccchannel_11_analyzer_1_array_crystal_array_7_zdepth = channel_11_analyzer_1_array_crystal_width;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_11_analyzer_1_array_crystal_array_7_xwidth2 = -1;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_11_analyzer_1_array_crystal_array_7_yheight2 = -1;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_11_analyzer_1_array_crystal_array_7_visualize = 1;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_11_analyzer_1_array_crystal_array_7_target_index = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_11_analyzer_1_array_crystal_array_7_target_x = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_11_analyzer_1_array_crystal_array_7_target_y = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_11_analyzer_1_array_crystal_array_7_target_z = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_11_analyzer_1_array_crystal_array_7_focus_aw = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_11_analyzer_1_array_crystal_array_7_focus_ah = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_11_analyzer_1_array_crystal_array_7_focus_xw = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_11_analyzer_1_array_crystal_array_7_focus_xh = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_11_analyzer_1_array_crystal_array_7_focus_r = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_11_analyzer_1_array_crystal_array_7_p_interact = 0;
#line 71 "MACS_sample_kidney_box.instr"
  if(0) strncpy(mccchannel_11_analyzer_1_array_crystal_array_7_mask_string, 0 ? 0 : "", 16384); else mccchannel_11_analyzer_1_array_crystal_array_7_mask_string[0]='\0';
#line 71 "MACS_sample_kidney_box.instr"
  if(0) strncpy(mccchannel_11_analyzer_1_array_crystal_array_7_mask_setting, 0 ? 0 : "", 16384); else mccchannel_11_analyzer_1_array_crystal_array_7_mask_setting[0]='\0';
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_11_analyzer_1_array_crystal_array_7_number_of_activations = 1;
#line 126807 "MACS_sample_kidney_box.c"

  SIG_MESSAGE("channel_11_analyzer_1_array_crystal_array_7 (Init:Place/Rotate)");
  rot_set_rotation(mctr1,
#line 3020 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 3020 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 3020 "MACS_sample_kidney_box.instr"
    (0 - RAD2DEG * channel_11_analyzer_1_array_theta [ 7 ])*DEG2RAD);
#line 126817 "MACS_sample_kidney_box.c"
  rot_mul(mctr1, mcrotachannel_11_analyzer_1_rotated, mcrotachannel_11_analyzer_1_array_crystal_array_7);
  rot_transpose(mcrotachannel_11_analyzer_1_array_crystal_array_6, mctr1);
  rot_mul(mcrotachannel_11_analyzer_1_array_crystal_array_7, mctr1, mcrotrchannel_11_analyzer_1_array_crystal_array_7);
  mctc1 = coords_set(
#line 3019 "MACS_sample_kidney_box.instr"
    0 + channel_11_analyzer_1_array_effective_radius_of_curvature * ( 1 - cos ( channel_11_analyzer_1_array_theta [ 7 ] ) ),
#line 3019 "MACS_sample_kidney_box.instr"
    0 + channel_11_analyzer_1_array_effective_radius_of_curvature * sin ( channel_11_analyzer_1_array_theta [ 7 ] ),
#line 3019 "MACS_sample_kidney_box.instr"
    0);
#line 126828 "MACS_sample_kidney_box.c"
  rot_transpose(mcrotachannel_11_analyzer_1_rotated, mctr1);
  mctc2 = rot_apply(mctr1, mctc1);
  mcposachannel_11_analyzer_1_array_crystal_array_7 = coords_add(mcposachannel_11_analyzer_1_rotated, mctc2);
  mctc1 = coords_sub(mcposachannel_11_analyzer_1_array_crystal_array_6, mcposachannel_11_analyzer_1_array_crystal_array_7);
  mcposrchannel_11_analyzer_1_array_crystal_array_7 = rot_apply(mcrotachannel_11_analyzer_1_array_crystal_array_7, mctc1);
  mcDEBUG_COMPONENT("channel_11_analyzer_1_array_crystal_array_7", mcposachannel_11_analyzer_1_array_crystal_array_7, mcrotachannel_11_analyzer_1_array_crystal_array_7)
  mccomp_posa[555] = mcposachannel_11_analyzer_1_array_crystal_array_7;
  mccomp_posr[555] = mcposrchannel_11_analyzer_1_array_crystal_array_7;
  mcNCounter[555]  = mcPCounter[555] = mcP2Counter[555] = 0;
  mcAbsorbProp[555]= 0;
    /* Component channel_11_analyzer_1_array_crystal_array_8. */
  /* Setting parameters for component channel_11_analyzer_1_array_crystal_array_8. */
  SIG_MESSAGE("channel_11_analyzer_1_array_crystal_array_8 (Init:SetPar)");
#line 3024 "MACS_sample_kidney_box.instr"
  if("PG_analyzer") strncpy(mccchannel_11_analyzer_1_array_crystal_array_8_material_string, "PG_analyzer" ? "PG_analyzer" : "", 16384); else mccchannel_11_analyzer_1_array_crystal_array_8_material_string[0]='\0';
#line 3024 "MACS_sample_kidney_box.instr"
  mccchannel_11_analyzer_1_array_crystal_array_8_priority = 1320.8;
#line 3023 "MACS_sample_kidney_box.instr"
  mccchannel_11_analyzer_1_array_crystal_array_8_xwidth = channel_11_analyzer_1_array_crystal_depth;
#line 3023 "MACS_sample_kidney_box.instr"
  mccchannel_11_analyzer_1_array_crystal_array_8_yheight = channel_11_analyzer_1_array_crystal_height;
#line 3023 "MACS_sample_kidney_box.instr"
  mccchannel_11_analyzer_1_array_crystal_array_8_zdepth = channel_11_analyzer_1_array_crystal_width;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_11_analyzer_1_array_crystal_array_8_xwidth2 = -1;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_11_analyzer_1_array_crystal_array_8_yheight2 = -1;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_11_analyzer_1_array_crystal_array_8_visualize = 1;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_11_analyzer_1_array_crystal_array_8_target_index = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_11_analyzer_1_array_crystal_array_8_target_x = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_11_analyzer_1_array_crystal_array_8_target_y = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_11_analyzer_1_array_crystal_array_8_target_z = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_11_analyzer_1_array_crystal_array_8_focus_aw = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_11_analyzer_1_array_crystal_array_8_focus_ah = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_11_analyzer_1_array_crystal_array_8_focus_xw = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_11_analyzer_1_array_crystal_array_8_focus_xh = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_11_analyzer_1_array_crystal_array_8_focus_r = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_11_analyzer_1_array_crystal_array_8_p_interact = 0;
#line 71 "MACS_sample_kidney_box.instr"
  if(0) strncpy(mccchannel_11_analyzer_1_array_crystal_array_8_mask_string, 0 ? 0 : "", 16384); else mccchannel_11_analyzer_1_array_crystal_array_8_mask_string[0]='\0';
#line 71 "MACS_sample_kidney_box.instr"
  if(0) strncpy(mccchannel_11_analyzer_1_array_crystal_array_8_mask_setting, 0 ? 0 : "", 16384); else mccchannel_11_analyzer_1_array_crystal_array_8_mask_setting[0]='\0';
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_11_analyzer_1_array_crystal_array_8_number_of_activations = 1;
#line 126884 "MACS_sample_kidney_box.c"

  SIG_MESSAGE("channel_11_analyzer_1_array_crystal_array_8 (Init:Place/Rotate)");
  rot_set_rotation(mctr1,
#line 3026 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 3026 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 3026 "MACS_sample_kidney_box.instr"
    (0 - RAD2DEG * channel_11_analyzer_1_array_theta [ 8 ])*DEG2RAD);
#line 126894 "MACS_sample_kidney_box.c"
  rot_mul(mctr1, mcrotachannel_11_analyzer_1_rotated, mcrotachannel_11_analyzer_1_array_crystal_array_8);
  rot_transpose(mcrotachannel_11_analyzer_1_array_crystal_array_7, mctr1);
  rot_mul(mcrotachannel_11_analyzer_1_array_crystal_array_8, mctr1, mcrotrchannel_11_analyzer_1_array_crystal_array_8);
  mctc1 = coords_set(
#line 3025 "MACS_sample_kidney_box.instr"
    0 + channel_11_analyzer_1_array_effective_radius_of_curvature * ( 1 - cos ( channel_11_analyzer_1_array_theta [ 8 ] ) ),
#line 3025 "MACS_sample_kidney_box.instr"
    0 + channel_11_analyzer_1_array_effective_radius_of_curvature * sin ( channel_11_analyzer_1_array_theta [ 8 ] ),
#line 3025 "MACS_sample_kidney_box.instr"
    0);
#line 126905 "MACS_sample_kidney_box.c"
  rot_transpose(mcrotachannel_11_analyzer_1_rotated, mctr1);
  mctc2 = rot_apply(mctr1, mctc1);
  mcposachannel_11_analyzer_1_array_crystal_array_8 = coords_add(mcposachannel_11_analyzer_1_rotated, mctc2);
  mctc1 = coords_sub(mcposachannel_11_analyzer_1_array_crystal_array_7, mcposachannel_11_analyzer_1_array_crystal_array_8);
  mcposrchannel_11_analyzer_1_array_crystal_array_8 = rot_apply(mcrotachannel_11_analyzer_1_array_crystal_array_8, mctc1);
  mcDEBUG_COMPONENT("channel_11_analyzer_1_array_crystal_array_8", mcposachannel_11_analyzer_1_array_crystal_array_8, mcrotachannel_11_analyzer_1_array_crystal_array_8)
  mccomp_posa[556] = mcposachannel_11_analyzer_1_array_crystal_array_8;
  mccomp_posr[556] = mcposrchannel_11_analyzer_1_array_crystal_array_8;
  mcNCounter[556]  = mcPCounter[556] = mcP2Counter[556] = 0;
  mcAbsorbProp[556]= 0;
    /* Component channel_11_analyzer_2_center. */
  /* Setting parameters for component channel_11_analyzer_2_center. */
  SIG_MESSAGE("channel_11_analyzer_2_center (Init:SetPar)");

  SIG_MESSAGE("channel_11_analyzer_2_center (Init:Place/Rotate)");
  rot_set_rotation(mctr1,
    (0.0)*DEG2RAD,
    (0.0)*DEG2RAD,
    (0.0)*DEG2RAD);
#line 126925 "MACS_sample_kidney_box.c"
  rot_mul(mctr1, mcrotachannel_11_analyzer_1_center, mcrotachannel_11_analyzer_2_center);
  rot_transpose(mcrotachannel_11_analyzer_1_array_crystal_array_8, mctr1);
  rot_mul(mcrotachannel_11_analyzer_2_center, mctr1, mcrotrchannel_11_analyzer_2_center);
  mctc1 = coords_set(
#line 3030 "MACS_sample_kidney_box.instr"
    - analyzer_seperation,
#line 3030 "MACS_sample_kidney_box.instr"
    0,
#line 3030 "MACS_sample_kidney_box.instr"
    0);
#line 126936 "MACS_sample_kidney_box.c"
  rot_transpose(mcrotachannel_11_analyzer_1_center, mctr1);
  mctc2 = rot_apply(mctr1, mctc1);
  mcposachannel_11_analyzer_2_center = coords_add(mcposachannel_11_analyzer_1_center, mctc2);
  mctc1 = coords_sub(mcposachannel_11_analyzer_1_array_crystal_array_8, mcposachannel_11_analyzer_2_center);
  mcposrchannel_11_analyzer_2_center = rot_apply(mcrotachannel_11_analyzer_2_center, mctc1);
  mcDEBUG_COMPONENT("channel_11_analyzer_2_center", mcposachannel_11_analyzer_2_center, mcrotachannel_11_analyzer_2_center)
  mccomp_posa[557] = mcposachannel_11_analyzer_2_center;
  mccomp_posr[557] = mcposrchannel_11_analyzer_2_center;
  mcNCounter[557]  = mcPCounter[557] = mcP2Counter[557] = 0;
  mcAbsorbProp[557]= 0;
    /* Component channel_11_analyzer_2_rotated. */
  /* Setting parameters for component channel_11_analyzer_2_rotated. */
  SIG_MESSAGE("channel_11_analyzer_2_rotated (Init:SetPar)");

  SIG_MESSAGE("channel_11_analyzer_2_rotated (Init:Place/Rotate)");
  rot_set_rotation(mctr1,
#line 3034 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 3034 "MACS_sample_kidney_box.instr"
    (- analyzer_theta [ 11 ])*DEG2RAD,
#line 3034 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD);
#line 126959 "MACS_sample_kidney_box.c"
  rot_mul(mctr1, mcrotachannel_11_analyzer_2_center, mcrotachannel_11_analyzer_2_rotated);
  rot_transpose(mcrotachannel_11_analyzer_2_center, mctr1);
  rot_mul(mcrotachannel_11_analyzer_2_rotated, mctr1, mcrotrchannel_11_analyzer_2_rotated);
  mctc1 = coords_set(
#line 3033 "MACS_sample_kidney_box.instr"
    0,
#line 3033 "MACS_sample_kidney_box.instr"
    0,
#line 3033 "MACS_sample_kidney_box.instr"
    0.5 * analyzer_seperation / tan ( analyzer_2theta [ 11 ] * DEG2RAD ));
#line 126970 "MACS_sample_kidney_box.c"
  rot_transpose(mcrotachannel_11_analyzer_2_center, mctr1);
  mctc2 = rot_apply(mctr1, mctc1);
  mcposachannel_11_analyzer_2_rotated = coords_add(mcposachannel_11_analyzer_2_center, mctc2);
  mctc1 = coords_sub(mcposachannel_11_analyzer_2_center, mcposachannel_11_analyzer_2_rotated);
  mcposrchannel_11_analyzer_2_rotated = rot_apply(mcrotachannel_11_analyzer_2_rotated, mctc1);
  mcDEBUG_COMPONENT("channel_11_analyzer_2_rotated", mcposachannel_11_analyzer_2_rotated, mcrotachannel_11_analyzer_2_rotated)
  mccomp_posa[558] = mcposachannel_11_analyzer_2_rotated;
  mccomp_posr[558] = mcposrchannel_11_analyzer_2_rotated;
  mcNCounter[558]  = mcPCounter[558] = mcP2Counter[558] = 0;
  mcAbsorbProp[558]= 0;
    /* Component channel_11_analyzer_2_array_crystal_array_0. */
  /* Setting parameters for component channel_11_analyzer_2_array_crystal_array_0. */
  SIG_MESSAGE("channel_11_analyzer_2_array_crystal_array_0 (Init:SetPar)");
#line 3038 "MACS_sample_kidney_box.instr"
  if("PG_analyzer") strncpy(mccchannel_11_analyzer_2_array_crystal_array_0_material_string, "PG_analyzer" ? "PG_analyzer" : "", 16384); else mccchannel_11_analyzer_2_array_crystal_array_0_material_string[0]='\0';
#line 3038 "MACS_sample_kidney_box.instr"
  mccchannel_11_analyzer_2_array_crystal_array_0_priority = 1321.0;
#line 3037 "MACS_sample_kidney_box.instr"
  mccchannel_11_analyzer_2_array_crystal_array_0_xwidth = channel_11_analyzer_2_array_crystal_depth;
#line 3037 "MACS_sample_kidney_box.instr"
  mccchannel_11_analyzer_2_array_crystal_array_0_yheight = channel_11_analyzer_2_array_crystal_height;
#line 3037 "MACS_sample_kidney_box.instr"
  mccchannel_11_analyzer_2_array_crystal_array_0_zdepth = channel_11_analyzer_2_array_crystal_width;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_11_analyzer_2_array_crystal_array_0_xwidth2 = -1;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_11_analyzer_2_array_crystal_array_0_yheight2 = -1;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_11_analyzer_2_array_crystal_array_0_visualize = 1;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_11_analyzer_2_array_crystal_array_0_target_index = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_11_analyzer_2_array_crystal_array_0_target_x = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_11_analyzer_2_array_crystal_array_0_target_y = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_11_analyzer_2_array_crystal_array_0_target_z = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_11_analyzer_2_array_crystal_array_0_focus_aw = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_11_analyzer_2_array_crystal_array_0_focus_ah = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_11_analyzer_2_array_crystal_array_0_focus_xw = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_11_analyzer_2_array_crystal_array_0_focus_xh = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_11_analyzer_2_array_crystal_array_0_focus_r = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_11_analyzer_2_array_crystal_array_0_p_interact = 0;
#line 71 "MACS_sample_kidney_box.instr"
  if(0) strncpy(mccchannel_11_analyzer_2_array_crystal_array_0_mask_string, 0 ? 0 : "", 16384); else mccchannel_11_analyzer_2_array_crystal_array_0_mask_string[0]='\0';
#line 71 "MACS_sample_kidney_box.instr"
  if(0) strncpy(mccchannel_11_analyzer_2_array_crystal_array_0_mask_setting, 0 ? 0 : "", 16384); else mccchannel_11_analyzer_2_array_crystal_array_0_mask_setting[0]='\0';
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_11_analyzer_2_array_crystal_array_0_number_of_activations = 1;
#line 127026 "MACS_sample_kidney_box.c"

  SIG_MESSAGE("channel_11_analyzer_2_array_crystal_array_0 (Init:Place/Rotate)");
  rot_set_rotation(mctr1,
#line 3040 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 3040 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 3040 "MACS_sample_kidney_box.instr"
    (0 - RAD2DEG * channel_11_analyzer_2_array_theta [ 0 ])*DEG2RAD);
#line 127036 "MACS_sample_kidney_box.c"
  rot_mul(mctr1, mcrotachannel_11_analyzer_2_rotated, mcrotachannel_11_analyzer_2_array_crystal_array_0);
  rot_transpose(mcrotachannel_11_analyzer_2_rotated, mctr1);
  rot_mul(mcrotachannel_11_analyzer_2_array_crystal_array_0, mctr1, mcrotrchannel_11_analyzer_2_array_crystal_array_0);
  mctc1 = coords_set(
#line 3039 "MACS_sample_kidney_box.instr"
    0 + channel_11_analyzer_2_array_effective_radius_of_curvature * ( 1 - cos ( channel_11_analyzer_2_array_theta [ 0 ] ) ),
#line 3039 "MACS_sample_kidney_box.instr"
    0 + channel_11_analyzer_2_array_effective_radius_of_curvature * sin ( channel_11_analyzer_2_array_theta [ 0 ] ),
#line 3039 "MACS_sample_kidney_box.instr"
    0);
#line 127047 "MACS_sample_kidney_box.c"
  rot_transpose(mcrotachannel_11_analyzer_2_rotated, mctr1);
  mctc2 = rot_apply(mctr1, mctc1);
  mcposachannel_11_analyzer_2_array_crystal_array_0 = coords_add(mcposachannel_11_analyzer_2_rotated, mctc2);
  mctc1 = coords_sub(mcposachannel_11_analyzer_2_rotated, mcposachannel_11_analyzer_2_array_crystal_array_0);
  mcposrchannel_11_analyzer_2_array_crystal_array_0 = rot_apply(mcrotachannel_11_analyzer_2_array_crystal_array_0, mctc1);
  mcDEBUG_COMPONENT("channel_11_analyzer_2_array_crystal_array_0", mcposachannel_11_analyzer_2_array_crystal_array_0, mcrotachannel_11_analyzer_2_array_crystal_array_0)
  mccomp_posa[559] = mcposachannel_11_analyzer_2_array_crystal_array_0;
  mccomp_posr[559] = mcposrchannel_11_analyzer_2_array_crystal_array_0;
  mcNCounter[559]  = mcPCounter[559] = mcP2Counter[559] = 0;
  mcAbsorbProp[559]= 0;
    /* Component channel_11_analyzer_2_array_crystal_array_1. */
  /* Setting parameters for component channel_11_analyzer_2_array_crystal_array_1. */
  SIG_MESSAGE("channel_11_analyzer_2_array_crystal_array_1 (Init:SetPar)");
#line 3044 "MACS_sample_kidney_box.instr"
  if("PG_analyzer") strncpy(mccchannel_11_analyzer_2_array_crystal_array_1_material_string, "PG_analyzer" ? "PG_analyzer" : "", 16384); else mccchannel_11_analyzer_2_array_crystal_array_1_material_string[0]='\0';
#line 3044 "MACS_sample_kidney_box.instr"
  mccchannel_11_analyzer_2_array_crystal_array_1_priority = 1321.1;
#line 3043 "MACS_sample_kidney_box.instr"
  mccchannel_11_analyzer_2_array_crystal_array_1_xwidth = channel_11_analyzer_2_array_crystal_depth;
#line 3043 "MACS_sample_kidney_box.instr"
  mccchannel_11_analyzer_2_array_crystal_array_1_yheight = channel_11_analyzer_2_array_crystal_height;
#line 3043 "MACS_sample_kidney_box.instr"
  mccchannel_11_analyzer_2_array_crystal_array_1_zdepth = channel_11_analyzer_2_array_crystal_width;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_11_analyzer_2_array_crystal_array_1_xwidth2 = -1;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_11_analyzer_2_array_crystal_array_1_yheight2 = -1;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_11_analyzer_2_array_crystal_array_1_visualize = 1;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_11_analyzer_2_array_crystal_array_1_target_index = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_11_analyzer_2_array_crystal_array_1_target_x = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_11_analyzer_2_array_crystal_array_1_target_y = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_11_analyzer_2_array_crystal_array_1_target_z = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_11_analyzer_2_array_crystal_array_1_focus_aw = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_11_analyzer_2_array_crystal_array_1_focus_ah = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_11_analyzer_2_array_crystal_array_1_focus_xw = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_11_analyzer_2_array_crystal_array_1_focus_xh = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_11_analyzer_2_array_crystal_array_1_focus_r = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_11_analyzer_2_array_crystal_array_1_p_interact = 0;
#line 71 "MACS_sample_kidney_box.instr"
  if(0) strncpy(mccchannel_11_analyzer_2_array_crystal_array_1_mask_string, 0 ? 0 : "", 16384); else mccchannel_11_analyzer_2_array_crystal_array_1_mask_string[0]='\0';
#line 71 "MACS_sample_kidney_box.instr"
  if(0) strncpy(mccchannel_11_analyzer_2_array_crystal_array_1_mask_setting, 0 ? 0 : "", 16384); else mccchannel_11_analyzer_2_array_crystal_array_1_mask_setting[0]='\0';
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_11_analyzer_2_array_crystal_array_1_number_of_activations = 1;
#line 127103 "MACS_sample_kidney_box.c"

  SIG_MESSAGE("channel_11_analyzer_2_array_crystal_array_1 (Init:Place/Rotate)");
  rot_set_rotation(mctr1,
#line 3046 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 3046 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 3046 "MACS_sample_kidney_box.instr"
    (0 - RAD2DEG * channel_11_analyzer_2_array_theta [ 1 ])*DEG2RAD);
#line 127113 "MACS_sample_kidney_box.c"
  rot_mul(mctr1, mcrotachannel_11_analyzer_2_rotated, mcrotachannel_11_analyzer_2_array_crystal_array_1);
  rot_transpose(mcrotachannel_11_analyzer_2_array_crystal_array_0, mctr1);
  rot_mul(mcrotachannel_11_analyzer_2_array_crystal_array_1, mctr1, mcrotrchannel_11_analyzer_2_array_crystal_array_1);
  mctc1 = coords_set(
#line 3045 "MACS_sample_kidney_box.instr"
    0 + channel_11_analyzer_2_array_effective_radius_of_curvature * ( 1 - cos ( channel_11_analyzer_2_array_theta [ 1 ] ) ),
#line 3045 "MACS_sample_kidney_box.instr"
    0 + channel_11_analyzer_2_array_effective_radius_of_curvature * sin ( channel_11_analyzer_2_array_theta [ 1 ] ),
#line 3045 "MACS_sample_kidney_box.instr"
    0);
#line 127124 "MACS_sample_kidney_box.c"
  rot_transpose(mcrotachannel_11_analyzer_2_rotated, mctr1);
  mctc2 = rot_apply(mctr1, mctc1);
  mcposachannel_11_analyzer_2_array_crystal_array_1 = coords_add(mcposachannel_11_analyzer_2_rotated, mctc2);
  mctc1 = coords_sub(mcposachannel_11_analyzer_2_array_crystal_array_0, mcposachannel_11_analyzer_2_array_crystal_array_1);
  mcposrchannel_11_analyzer_2_array_crystal_array_1 = rot_apply(mcrotachannel_11_analyzer_2_array_crystal_array_1, mctc1);
  mcDEBUG_COMPONENT("channel_11_analyzer_2_array_crystal_array_1", mcposachannel_11_analyzer_2_array_crystal_array_1, mcrotachannel_11_analyzer_2_array_crystal_array_1)
  mccomp_posa[560] = mcposachannel_11_analyzer_2_array_crystal_array_1;
  mccomp_posr[560] = mcposrchannel_11_analyzer_2_array_crystal_array_1;
  mcNCounter[560]  = mcPCounter[560] = mcP2Counter[560] = 0;
  mcAbsorbProp[560]= 0;
    /* Component channel_11_analyzer_2_array_crystal_array_2. */
  /* Setting parameters for component channel_11_analyzer_2_array_crystal_array_2. */
  SIG_MESSAGE("channel_11_analyzer_2_array_crystal_array_2 (Init:SetPar)");
#line 3050 "MACS_sample_kidney_box.instr"
  if("PG_analyzer") strncpy(mccchannel_11_analyzer_2_array_crystal_array_2_material_string, "PG_analyzer" ? "PG_analyzer" : "", 16384); else mccchannel_11_analyzer_2_array_crystal_array_2_material_string[0]='\0';
#line 3050 "MACS_sample_kidney_box.instr"
  mccchannel_11_analyzer_2_array_crystal_array_2_priority = 1321.2;
#line 3049 "MACS_sample_kidney_box.instr"
  mccchannel_11_analyzer_2_array_crystal_array_2_xwidth = channel_11_analyzer_2_array_crystal_depth;
#line 3049 "MACS_sample_kidney_box.instr"
  mccchannel_11_analyzer_2_array_crystal_array_2_yheight = channel_11_analyzer_2_array_crystal_height;
#line 3049 "MACS_sample_kidney_box.instr"
  mccchannel_11_analyzer_2_array_crystal_array_2_zdepth = channel_11_analyzer_2_array_crystal_width;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_11_analyzer_2_array_crystal_array_2_xwidth2 = -1;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_11_analyzer_2_array_crystal_array_2_yheight2 = -1;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_11_analyzer_2_array_crystal_array_2_visualize = 1;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_11_analyzer_2_array_crystal_array_2_target_index = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_11_analyzer_2_array_crystal_array_2_target_x = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_11_analyzer_2_array_crystal_array_2_target_y = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_11_analyzer_2_array_crystal_array_2_target_z = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_11_analyzer_2_array_crystal_array_2_focus_aw = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_11_analyzer_2_array_crystal_array_2_focus_ah = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_11_analyzer_2_array_crystal_array_2_focus_xw = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_11_analyzer_2_array_crystal_array_2_focus_xh = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_11_analyzer_2_array_crystal_array_2_focus_r = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_11_analyzer_2_array_crystal_array_2_p_interact = 0;
#line 71 "MACS_sample_kidney_box.instr"
  if(0) strncpy(mccchannel_11_analyzer_2_array_crystal_array_2_mask_string, 0 ? 0 : "", 16384); else mccchannel_11_analyzer_2_array_crystal_array_2_mask_string[0]='\0';
#line 71 "MACS_sample_kidney_box.instr"
  if(0) strncpy(mccchannel_11_analyzer_2_array_crystal_array_2_mask_setting, 0 ? 0 : "", 16384); else mccchannel_11_analyzer_2_array_crystal_array_2_mask_setting[0]='\0';
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_11_analyzer_2_array_crystal_array_2_number_of_activations = 1;
#line 127180 "MACS_sample_kidney_box.c"

  SIG_MESSAGE("channel_11_analyzer_2_array_crystal_array_2 (Init:Place/Rotate)");
  rot_set_rotation(mctr1,
#line 3052 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 3052 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 3052 "MACS_sample_kidney_box.instr"
    (0 - RAD2DEG * channel_11_analyzer_2_array_theta [ 2 ])*DEG2RAD);
#line 127190 "MACS_sample_kidney_box.c"
  rot_mul(mctr1, mcrotachannel_11_analyzer_2_rotated, mcrotachannel_11_analyzer_2_array_crystal_array_2);
  rot_transpose(mcrotachannel_11_analyzer_2_array_crystal_array_1, mctr1);
  rot_mul(mcrotachannel_11_analyzer_2_array_crystal_array_2, mctr1, mcrotrchannel_11_analyzer_2_array_crystal_array_2);
  mctc1 = coords_set(
#line 3051 "MACS_sample_kidney_box.instr"
    0 + channel_11_analyzer_2_array_effective_radius_of_curvature * ( 1 - cos ( channel_11_analyzer_2_array_theta [ 2 ] ) ),
#line 3051 "MACS_sample_kidney_box.instr"
    0 + channel_11_analyzer_2_array_effective_radius_of_curvature * sin ( channel_11_analyzer_2_array_theta [ 2 ] ),
#line 3051 "MACS_sample_kidney_box.instr"
    0);
#line 127201 "MACS_sample_kidney_box.c"
  rot_transpose(mcrotachannel_11_analyzer_2_rotated, mctr1);
  mctc2 = rot_apply(mctr1, mctc1);
  mcposachannel_11_analyzer_2_array_crystal_array_2 = coords_add(mcposachannel_11_analyzer_2_rotated, mctc2);
  mctc1 = coords_sub(mcposachannel_11_analyzer_2_array_crystal_array_1, mcposachannel_11_analyzer_2_array_crystal_array_2);
  mcposrchannel_11_analyzer_2_array_crystal_array_2 = rot_apply(mcrotachannel_11_analyzer_2_array_crystal_array_2, mctc1);
  mcDEBUG_COMPONENT("channel_11_analyzer_2_array_crystal_array_2", mcposachannel_11_analyzer_2_array_crystal_array_2, mcrotachannel_11_analyzer_2_array_crystal_array_2)
  mccomp_posa[561] = mcposachannel_11_analyzer_2_array_crystal_array_2;
  mccomp_posr[561] = mcposrchannel_11_analyzer_2_array_crystal_array_2;
  mcNCounter[561]  = mcPCounter[561] = mcP2Counter[561] = 0;
  mcAbsorbProp[561]= 0;
    /* Component channel_11_analyzer_2_array_crystal_array_3. */
  /* Setting parameters for component channel_11_analyzer_2_array_crystal_array_3. */
  SIG_MESSAGE("channel_11_analyzer_2_array_crystal_array_3 (Init:SetPar)");
#line 3056 "MACS_sample_kidney_box.instr"
  if("PG_analyzer") strncpy(mccchannel_11_analyzer_2_array_crystal_array_3_material_string, "PG_analyzer" ? "PG_analyzer" : "", 16384); else mccchannel_11_analyzer_2_array_crystal_array_3_material_string[0]='\0';
#line 3056 "MACS_sample_kidney_box.instr"
  mccchannel_11_analyzer_2_array_crystal_array_3_priority = 1321.3;
#line 3055 "MACS_sample_kidney_box.instr"
  mccchannel_11_analyzer_2_array_crystal_array_3_xwidth = channel_11_analyzer_2_array_crystal_depth;
#line 3055 "MACS_sample_kidney_box.instr"
  mccchannel_11_analyzer_2_array_crystal_array_3_yheight = channel_11_analyzer_2_array_crystal_height;
#line 3055 "MACS_sample_kidney_box.instr"
  mccchannel_11_analyzer_2_array_crystal_array_3_zdepth = channel_11_analyzer_2_array_crystal_width;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_11_analyzer_2_array_crystal_array_3_xwidth2 = -1;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_11_analyzer_2_array_crystal_array_3_yheight2 = -1;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_11_analyzer_2_array_crystal_array_3_visualize = 1;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_11_analyzer_2_array_crystal_array_3_target_index = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_11_analyzer_2_array_crystal_array_3_target_x = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_11_analyzer_2_array_crystal_array_3_target_y = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_11_analyzer_2_array_crystal_array_3_target_z = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_11_analyzer_2_array_crystal_array_3_focus_aw = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_11_analyzer_2_array_crystal_array_3_focus_ah = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_11_analyzer_2_array_crystal_array_3_focus_xw = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_11_analyzer_2_array_crystal_array_3_focus_xh = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_11_analyzer_2_array_crystal_array_3_focus_r = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_11_analyzer_2_array_crystal_array_3_p_interact = 0;
#line 71 "MACS_sample_kidney_box.instr"
  if(0) strncpy(mccchannel_11_analyzer_2_array_crystal_array_3_mask_string, 0 ? 0 : "", 16384); else mccchannel_11_analyzer_2_array_crystal_array_3_mask_string[0]='\0';
#line 71 "MACS_sample_kidney_box.instr"
  if(0) strncpy(mccchannel_11_analyzer_2_array_crystal_array_3_mask_setting, 0 ? 0 : "", 16384); else mccchannel_11_analyzer_2_array_crystal_array_3_mask_setting[0]='\0';
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_11_analyzer_2_array_crystal_array_3_number_of_activations = 1;
#line 127257 "MACS_sample_kidney_box.c"

  SIG_MESSAGE("channel_11_analyzer_2_array_crystal_array_3 (Init:Place/Rotate)");
  rot_set_rotation(mctr1,
#line 3058 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 3058 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 3058 "MACS_sample_kidney_box.instr"
    (0 - RAD2DEG * channel_11_analyzer_2_array_theta [ 3 ])*DEG2RAD);
#line 127267 "MACS_sample_kidney_box.c"
  rot_mul(mctr1, mcrotachannel_11_analyzer_2_rotated, mcrotachannel_11_analyzer_2_array_crystal_array_3);
  rot_transpose(mcrotachannel_11_analyzer_2_array_crystal_array_2, mctr1);
  rot_mul(mcrotachannel_11_analyzer_2_array_crystal_array_3, mctr1, mcrotrchannel_11_analyzer_2_array_crystal_array_3);
  mctc1 = coords_set(
#line 3057 "MACS_sample_kidney_box.instr"
    0 + channel_11_analyzer_2_array_effective_radius_of_curvature * ( 1 - cos ( channel_11_analyzer_2_array_theta [ 3 ] ) ),
#line 3057 "MACS_sample_kidney_box.instr"
    0 + channel_11_analyzer_2_array_effective_radius_of_curvature * sin ( channel_11_analyzer_2_array_theta [ 3 ] ),
#line 3057 "MACS_sample_kidney_box.instr"
    0);
#line 127278 "MACS_sample_kidney_box.c"
  rot_transpose(mcrotachannel_11_analyzer_2_rotated, mctr1);
  mctc2 = rot_apply(mctr1, mctc1);
  mcposachannel_11_analyzer_2_array_crystal_array_3 = coords_add(mcposachannel_11_analyzer_2_rotated, mctc2);
  mctc1 = coords_sub(mcposachannel_11_analyzer_2_array_crystal_array_2, mcposachannel_11_analyzer_2_array_crystal_array_3);
  mcposrchannel_11_analyzer_2_array_crystal_array_3 = rot_apply(mcrotachannel_11_analyzer_2_array_crystal_array_3, mctc1);
  mcDEBUG_COMPONENT("channel_11_analyzer_2_array_crystal_array_3", mcposachannel_11_analyzer_2_array_crystal_array_3, mcrotachannel_11_analyzer_2_array_crystal_array_3)
  mccomp_posa[562] = mcposachannel_11_analyzer_2_array_crystal_array_3;
  mccomp_posr[562] = mcposrchannel_11_analyzer_2_array_crystal_array_3;
  mcNCounter[562]  = mcPCounter[562] = mcP2Counter[562] = 0;
  mcAbsorbProp[562]= 0;
    /* Component channel_11_analyzer_2_array_crystal_array_4. */
  /* Setting parameters for component channel_11_analyzer_2_array_crystal_array_4. */
  SIG_MESSAGE("channel_11_analyzer_2_array_crystal_array_4 (Init:SetPar)");
#line 3062 "MACS_sample_kidney_box.instr"
  if("PG_analyzer") strncpy(mccchannel_11_analyzer_2_array_crystal_array_4_material_string, "PG_analyzer" ? "PG_analyzer" : "", 16384); else mccchannel_11_analyzer_2_array_crystal_array_4_material_string[0]='\0';
#line 3062 "MACS_sample_kidney_box.instr"
  mccchannel_11_analyzer_2_array_crystal_array_4_priority = 1321.4;
#line 3061 "MACS_sample_kidney_box.instr"
  mccchannel_11_analyzer_2_array_crystal_array_4_xwidth = channel_11_analyzer_2_array_crystal_depth;
#line 3061 "MACS_sample_kidney_box.instr"
  mccchannel_11_analyzer_2_array_crystal_array_4_yheight = channel_11_analyzer_2_array_crystal_height;
#line 3061 "MACS_sample_kidney_box.instr"
  mccchannel_11_analyzer_2_array_crystal_array_4_zdepth = channel_11_analyzer_2_array_crystal_width;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_11_analyzer_2_array_crystal_array_4_xwidth2 = -1;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_11_analyzer_2_array_crystal_array_4_yheight2 = -1;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_11_analyzer_2_array_crystal_array_4_visualize = 1;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_11_analyzer_2_array_crystal_array_4_target_index = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_11_analyzer_2_array_crystal_array_4_target_x = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_11_analyzer_2_array_crystal_array_4_target_y = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_11_analyzer_2_array_crystal_array_4_target_z = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_11_analyzer_2_array_crystal_array_4_focus_aw = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_11_analyzer_2_array_crystal_array_4_focus_ah = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_11_analyzer_2_array_crystal_array_4_focus_xw = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_11_analyzer_2_array_crystal_array_4_focus_xh = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_11_analyzer_2_array_crystal_array_4_focus_r = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_11_analyzer_2_array_crystal_array_4_p_interact = 0;
#line 71 "MACS_sample_kidney_box.instr"
  if(0) strncpy(mccchannel_11_analyzer_2_array_crystal_array_4_mask_string, 0 ? 0 : "", 16384); else mccchannel_11_analyzer_2_array_crystal_array_4_mask_string[0]='\0';
#line 71 "MACS_sample_kidney_box.instr"
  if(0) strncpy(mccchannel_11_analyzer_2_array_crystal_array_4_mask_setting, 0 ? 0 : "", 16384); else mccchannel_11_analyzer_2_array_crystal_array_4_mask_setting[0]='\0';
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_11_analyzer_2_array_crystal_array_4_number_of_activations = 1;
#line 127334 "MACS_sample_kidney_box.c"

  SIG_MESSAGE("channel_11_analyzer_2_array_crystal_array_4 (Init:Place/Rotate)");
  rot_set_rotation(mctr1,
#line 3064 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 3064 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 3064 "MACS_sample_kidney_box.instr"
    (0 - RAD2DEG * channel_11_analyzer_2_array_theta [ 4 ])*DEG2RAD);
#line 127344 "MACS_sample_kidney_box.c"
  rot_mul(mctr1, mcrotachannel_11_analyzer_2_rotated, mcrotachannel_11_analyzer_2_array_crystal_array_4);
  rot_transpose(mcrotachannel_11_analyzer_2_array_crystal_array_3, mctr1);
  rot_mul(mcrotachannel_11_analyzer_2_array_crystal_array_4, mctr1, mcrotrchannel_11_analyzer_2_array_crystal_array_4);
  mctc1 = coords_set(
#line 3063 "MACS_sample_kidney_box.instr"
    0 + channel_11_analyzer_2_array_effective_radius_of_curvature * ( 1 - cos ( channel_11_analyzer_2_array_theta [ 4 ] ) ),
#line 3063 "MACS_sample_kidney_box.instr"
    0 + channel_11_analyzer_2_array_effective_radius_of_curvature * sin ( channel_11_analyzer_2_array_theta [ 4 ] ),
#line 3063 "MACS_sample_kidney_box.instr"
    0);
#line 127355 "MACS_sample_kidney_box.c"
  rot_transpose(mcrotachannel_11_analyzer_2_rotated, mctr1);
  mctc2 = rot_apply(mctr1, mctc1);
  mcposachannel_11_analyzer_2_array_crystal_array_4 = coords_add(mcposachannel_11_analyzer_2_rotated, mctc2);
  mctc1 = coords_sub(mcposachannel_11_analyzer_2_array_crystal_array_3, mcposachannel_11_analyzer_2_array_crystal_array_4);
  mcposrchannel_11_analyzer_2_array_crystal_array_4 = rot_apply(mcrotachannel_11_analyzer_2_array_crystal_array_4, mctc1);
  mcDEBUG_COMPONENT("channel_11_analyzer_2_array_crystal_array_4", mcposachannel_11_analyzer_2_array_crystal_array_4, mcrotachannel_11_analyzer_2_array_crystal_array_4)
  mccomp_posa[563] = mcposachannel_11_analyzer_2_array_crystal_array_4;
  mccomp_posr[563] = mcposrchannel_11_analyzer_2_array_crystal_array_4;
  mcNCounter[563]  = mcPCounter[563] = mcP2Counter[563] = 0;
  mcAbsorbProp[563]= 0;
    /* Component channel_11_analyzer_2_array_crystal_array_5. */
  /* Setting parameters for component channel_11_analyzer_2_array_crystal_array_5. */
  SIG_MESSAGE("channel_11_analyzer_2_array_crystal_array_5 (Init:SetPar)");
#line 3068 "MACS_sample_kidney_box.instr"
  if("PG_analyzer") strncpy(mccchannel_11_analyzer_2_array_crystal_array_5_material_string, "PG_analyzer" ? "PG_analyzer" : "", 16384); else mccchannel_11_analyzer_2_array_crystal_array_5_material_string[0]='\0';
#line 3068 "MACS_sample_kidney_box.instr"
  mccchannel_11_analyzer_2_array_crystal_array_5_priority = 1321.5;
#line 3067 "MACS_sample_kidney_box.instr"
  mccchannel_11_analyzer_2_array_crystal_array_5_xwidth = channel_11_analyzer_2_array_crystal_depth;
#line 3067 "MACS_sample_kidney_box.instr"
  mccchannel_11_analyzer_2_array_crystal_array_5_yheight = channel_11_analyzer_2_array_crystal_height;
#line 3067 "MACS_sample_kidney_box.instr"
  mccchannel_11_analyzer_2_array_crystal_array_5_zdepth = channel_11_analyzer_2_array_crystal_width;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_11_analyzer_2_array_crystal_array_5_xwidth2 = -1;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_11_analyzer_2_array_crystal_array_5_yheight2 = -1;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_11_analyzer_2_array_crystal_array_5_visualize = 1;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_11_analyzer_2_array_crystal_array_5_target_index = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_11_analyzer_2_array_crystal_array_5_target_x = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_11_analyzer_2_array_crystal_array_5_target_y = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_11_analyzer_2_array_crystal_array_5_target_z = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_11_analyzer_2_array_crystal_array_5_focus_aw = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_11_analyzer_2_array_crystal_array_5_focus_ah = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_11_analyzer_2_array_crystal_array_5_focus_xw = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_11_analyzer_2_array_crystal_array_5_focus_xh = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_11_analyzer_2_array_crystal_array_5_focus_r = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_11_analyzer_2_array_crystal_array_5_p_interact = 0;
#line 71 "MACS_sample_kidney_box.instr"
  if(0) strncpy(mccchannel_11_analyzer_2_array_crystal_array_5_mask_string, 0 ? 0 : "", 16384); else mccchannel_11_analyzer_2_array_crystal_array_5_mask_string[0]='\0';
#line 71 "MACS_sample_kidney_box.instr"
  if(0) strncpy(mccchannel_11_analyzer_2_array_crystal_array_5_mask_setting, 0 ? 0 : "", 16384); else mccchannel_11_analyzer_2_array_crystal_array_5_mask_setting[0]='\0';
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_11_analyzer_2_array_crystal_array_5_number_of_activations = 1;
#line 127411 "MACS_sample_kidney_box.c"

  SIG_MESSAGE("channel_11_analyzer_2_array_crystal_array_5 (Init:Place/Rotate)");
  rot_set_rotation(mctr1,
#line 3070 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 3070 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 3070 "MACS_sample_kidney_box.instr"
    (0 - RAD2DEG * channel_11_analyzer_2_array_theta [ 5 ])*DEG2RAD);
#line 127421 "MACS_sample_kidney_box.c"
  rot_mul(mctr1, mcrotachannel_11_analyzer_2_rotated, mcrotachannel_11_analyzer_2_array_crystal_array_5);
  rot_transpose(mcrotachannel_11_analyzer_2_array_crystal_array_4, mctr1);
  rot_mul(mcrotachannel_11_analyzer_2_array_crystal_array_5, mctr1, mcrotrchannel_11_analyzer_2_array_crystal_array_5);
  mctc1 = coords_set(
#line 3069 "MACS_sample_kidney_box.instr"
    0 + channel_11_analyzer_2_array_effective_radius_of_curvature * ( 1 - cos ( channel_11_analyzer_2_array_theta [ 5 ] ) ),
#line 3069 "MACS_sample_kidney_box.instr"
    0 + channel_11_analyzer_2_array_effective_radius_of_curvature * sin ( channel_11_analyzer_2_array_theta [ 5 ] ),
#line 3069 "MACS_sample_kidney_box.instr"
    0);
#line 127432 "MACS_sample_kidney_box.c"
  rot_transpose(mcrotachannel_11_analyzer_2_rotated, mctr1);
  mctc2 = rot_apply(mctr1, mctc1);
  mcposachannel_11_analyzer_2_array_crystal_array_5 = coords_add(mcposachannel_11_analyzer_2_rotated, mctc2);
  mctc1 = coords_sub(mcposachannel_11_analyzer_2_array_crystal_array_4, mcposachannel_11_analyzer_2_array_crystal_array_5);
  mcposrchannel_11_analyzer_2_array_crystal_array_5 = rot_apply(mcrotachannel_11_analyzer_2_array_crystal_array_5, mctc1);
  mcDEBUG_COMPONENT("channel_11_analyzer_2_array_crystal_array_5", mcposachannel_11_analyzer_2_array_crystal_array_5, mcrotachannel_11_analyzer_2_array_crystal_array_5)
  mccomp_posa[564] = mcposachannel_11_analyzer_2_array_crystal_array_5;
  mccomp_posr[564] = mcposrchannel_11_analyzer_2_array_crystal_array_5;
  mcNCounter[564]  = mcPCounter[564] = mcP2Counter[564] = 0;
  mcAbsorbProp[564]= 0;
    /* Component channel_11_analyzer_2_array_crystal_array_6. */
  /* Setting parameters for component channel_11_analyzer_2_array_crystal_array_6. */
  SIG_MESSAGE("channel_11_analyzer_2_array_crystal_array_6 (Init:SetPar)");
#line 3074 "MACS_sample_kidney_box.instr"
  if("PG_analyzer") strncpy(mccchannel_11_analyzer_2_array_crystal_array_6_material_string, "PG_analyzer" ? "PG_analyzer" : "", 16384); else mccchannel_11_analyzer_2_array_crystal_array_6_material_string[0]='\0';
#line 3074 "MACS_sample_kidney_box.instr"
  mccchannel_11_analyzer_2_array_crystal_array_6_priority = 1321.6;
#line 3073 "MACS_sample_kidney_box.instr"
  mccchannel_11_analyzer_2_array_crystal_array_6_xwidth = channel_11_analyzer_2_array_crystal_depth;
#line 3073 "MACS_sample_kidney_box.instr"
  mccchannel_11_analyzer_2_array_crystal_array_6_yheight = channel_11_analyzer_2_array_crystal_height;
#line 3073 "MACS_sample_kidney_box.instr"
  mccchannel_11_analyzer_2_array_crystal_array_6_zdepth = channel_11_analyzer_2_array_crystal_width;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_11_analyzer_2_array_crystal_array_6_xwidth2 = -1;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_11_analyzer_2_array_crystal_array_6_yheight2 = -1;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_11_analyzer_2_array_crystal_array_6_visualize = 1;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_11_analyzer_2_array_crystal_array_6_target_index = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_11_analyzer_2_array_crystal_array_6_target_x = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_11_analyzer_2_array_crystal_array_6_target_y = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_11_analyzer_2_array_crystal_array_6_target_z = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_11_analyzer_2_array_crystal_array_6_focus_aw = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_11_analyzer_2_array_crystal_array_6_focus_ah = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_11_analyzer_2_array_crystal_array_6_focus_xw = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_11_analyzer_2_array_crystal_array_6_focus_xh = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_11_analyzer_2_array_crystal_array_6_focus_r = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_11_analyzer_2_array_crystal_array_6_p_interact = 0;
#line 71 "MACS_sample_kidney_box.instr"
  if(0) strncpy(mccchannel_11_analyzer_2_array_crystal_array_6_mask_string, 0 ? 0 : "", 16384); else mccchannel_11_analyzer_2_array_crystal_array_6_mask_string[0]='\0';
#line 71 "MACS_sample_kidney_box.instr"
  if(0) strncpy(mccchannel_11_analyzer_2_array_crystal_array_6_mask_setting, 0 ? 0 : "", 16384); else mccchannel_11_analyzer_2_array_crystal_array_6_mask_setting[0]='\0';
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_11_analyzer_2_array_crystal_array_6_number_of_activations = 1;
#line 127488 "MACS_sample_kidney_box.c"

  SIG_MESSAGE("channel_11_analyzer_2_array_crystal_array_6 (Init:Place/Rotate)");
  rot_set_rotation(mctr1,
#line 3076 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 3076 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 3076 "MACS_sample_kidney_box.instr"
    (0 - RAD2DEG * channel_11_analyzer_2_array_theta [ 6 ])*DEG2RAD);
#line 127498 "MACS_sample_kidney_box.c"
  rot_mul(mctr1, mcrotachannel_11_analyzer_2_rotated, mcrotachannel_11_analyzer_2_array_crystal_array_6);
  rot_transpose(mcrotachannel_11_analyzer_2_array_crystal_array_5, mctr1);
  rot_mul(mcrotachannel_11_analyzer_2_array_crystal_array_6, mctr1, mcrotrchannel_11_analyzer_2_array_crystal_array_6);
  mctc1 = coords_set(
#line 3075 "MACS_sample_kidney_box.instr"
    0 + channel_11_analyzer_2_array_effective_radius_of_curvature * ( 1 - cos ( channel_11_analyzer_2_array_theta [ 6 ] ) ),
#line 3075 "MACS_sample_kidney_box.instr"
    0 + channel_11_analyzer_2_array_effective_radius_of_curvature * sin ( channel_11_analyzer_2_array_theta [ 6 ] ),
#line 3075 "MACS_sample_kidney_box.instr"
    0);
#line 127509 "MACS_sample_kidney_box.c"
  rot_transpose(mcrotachannel_11_analyzer_2_rotated, mctr1);
  mctc2 = rot_apply(mctr1, mctc1);
  mcposachannel_11_analyzer_2_array_crystal_array_6 = coords_add(mcposachannel_11_analyzer_2_rotated, mctc2);
  mctc1 = coords_sub(mcposachannel_11_analyzer_2_array_crystal_array_5, mcposachannel_11_analyzer_2_array_crystal_array_6);
  mcposrchannel_11_analyzer_2_array_crystal_array_6 = rot_apply(mcrotachannel_11_analyzer_2_array_crystal_array_6, mctc1);
  mcDEBUG_COMPONENT("channel_11_analyzer_2_array_crystal_array_6", mcposachannel_11_analyzer_2_array_crystal_array_6, mcrotachannel_11_analyzer_2_array_crystal_array_6)
  mccomp_posa[565] = mcposachannel_11_analyzer_2_array_crystal_array_6;
  mccomp_posr[565] = mcposrchannel_11_analyzer_2_array_crystal_array_6;
  mcNCounter[565]  = mcPCounter[565] = mcP2Counter[565] = 0;
  mcAbsorbProp[565]= 0;
    /* Component channel_11_analyzer_2_array_crystal_array_7. */
  /* Setting parameters for component channel_11_analyzer_2_array_crystal_array_7. */
  SIG_MESSAGE("channel_11_analyzer_2_array_crystal_array_7 (Init:SetPar)");
#line 3080 "MACS_sample_kidney_box.instr"
  if("PG_analyzer") strncpy(mccchannel_11_analyzer_2_array_crystal_array_7_material_string, "PG_analyzer" ? "PG_analyzer" : "", 16384); else mccchannel_11_analyzer_2_array_crystal_array_7_material_string[0]='\0';
#line 3080 "MACS_sample_kidney_box.instr"
  mccchannel_11_analyzer_2_array_crystal_array_7_priority = 1321.7;
#line 3079 "MACS_sample_kidney_box.instr"
  mccchannel_11_analyzer_2_array_crystal_array_7_xwidth = channel_11_analyzer_2_array_crystal_depth;
#line 3079 "MACS_sample_kidney_box.instr"
  mccchannel_11_analyzer_2_array_crystal_array_7_yheight = channel_11_analyzer_2_array_crystal_height;
#line 3079 "MACS_sample_kidney_box.instr"
  mccchannel_11_analyzer_2_array_crystal_array_7_zdepth = channel_11_analyzer_2_array_crystal_width;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_11_analyzer_2_array_crystal_array_7_xwidth2 = -1;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_11_analyzer_2_array_crystal_array_7_yheight2 = -1;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_11_analyzer_2_array_crystal_array_7_visualize = 1;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_11_analyzer_2_array_crystal_array_7_target_index = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_11_analyzer_2_array_crystal_array_7_target_x = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_11_analyzer_2_array_crystal_array_7_target_y = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_11_analyzer_2_array_crystal_array_7_target_z = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_11_analyzer_2_array_crystal_array_7_focus_aw = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_11_analyzer_2_array_crystal_array_7_focus_ah = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_11_analyzer_2_array_crystal_array_7_focus_xw = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_11_analyzer_2_array_crystal_array_7_focus_xh = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_11_analyzer_2_array_crystal_array_7_focus_r = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_11_analyzer_2_array_crystal_array_7_p_interact = 0;
#line 71 "MACS_sample_kidney_box.instr"
  if(0) strncpy(mccchannel_11_analyzer_2_array_crystal_array_7_mask_string, 0 ? 0 : "", 16384); else mccchannel_11_analyzer_2_array_crystal_array_7_mask_string[0]='\0';
#line 71 "MACS_sample_kidney_box.instr"
  if(0) strncpy(mccchannel_11_analyzer_2_array_crystal_array_7_mask_setting, 0 ? 0 : "", 16384); else mccchannel_11_analyzer_2_array_crystal_array_7_mask_setting[0]='\0';
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_11_analyzer_2_array_crystal_array_7_number_of_activations = 1;
#line 127565 "MACS_sample_kidney_box.c"

  SIG_MESSAGE("channel_11_analyzer_2_array_crystal_array_7 (Init:Place/Rotate)");
  rot_set_rotation(mctr1,
#line 3082 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 3082 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 3082 "MACS_sample_kidney_box.instr"
    (0 - RAD2DEG * channel_11_analyzer_2_array_theta [ 7 ])*DEG2RAD);
#line 127575 "MACS_sample_kidney_box.c"
  rot_mul(mctr1, mcrotachannel_11_analyzer_2_rotated, mcrotachannel_11_analyzer_2_array_crystal_array_7);
  rot_transpose(mcrotachannel_11_analyzer_2_array_crystal_array_6, mctr1);
  rot_mul(mcrotachannel_11_analyzer_2_array_crystal_array_7, mctr1, mcrotrchannel_11_analyzer_2_array_crystal_array_7);
  mctc1 = coords_set(
#line 3081 "MACS_sample_kidney_box.instr"
    0 + channel_11_analyzer_2_array_effective_radius_of_curvature * ( 1 - cos ( channel_11_analyzer_2_array_theta [ 7 ] ) ),
#line 3081 "MACS_sample_kidney_box.instr"
    0 + channel_11_analyzer_2_array_effective_radius_of_curvature * sin ( channel_11_analyzer_2_array_theta [ 7 ] ),
#line 3081 "MACS_sample_kidney_box.instr"
    0);
#line 127586 "MACS_sample_kidney_box.c"
  rot_transpose(mcrotachannel_11_analyzer_2_rotated, mctr1);
  mctc2 = rot_apply(mctr1, mctc1);
  mcposachannel_11_analyzer_2_array_crystal_array_7 = coords_add(mcposachannel_11_analyzer_2_rotated, mctc2);
  mctc1 = coords_sub(mcposachannel_11_analyzer_2_array_crystal_array_6, mcposachannel_11_analyzer_2_array_crystal_array_7);
  mcposrchannel_11_analyzer_2_array_crystal_array_7 = rot_apply(mcrotachannel_11_analyzer_2_array_crystal_array_7, mctc1);
  mcDEBUG_COMPONENT("channel_11_analyzer_2_array_crystal_array_7", mcposachannel_11_analyzer_2_array_crystal_array_7, mcrotachannel_11_analyzer_2_array_crystal_array_7)
  mccomp_posa[566] = mcposachannel_11_analyzer_2_array_crystal_array_7;
  mccomp_posr[566] = mcposrchannel_11_analyzer_2_array_crystal_array_7;
  mcNCounter[566]  = mcPCounter[566] = mcP2Counter[566] = 0;
  mcAbsorbProp[566]= 0;
    /* Component channel_11_analyzer_2_array_crystal_array_8. */
  /* Setting parameters for component channel_11_analyzer_2_array_crystal_array_8. */
  SIG_MESSAGE("channel_11_analyzer_2_array_crystal_array_8 (Init:SetPar)");
#line 3086 "MACS_sample_kidney_box.instr"
  if("PG_analyzer") strncpy(mccchannel_11_analyzer_2_array_crystal_array_8_material_string, "PG_analyzer" ? "PG_analyzer" : "", 16384); else mccchannel_11_analyzer_2_array_crystal_array_8_material_string[0]='\0';
#line 3086 "MACS_sample_kidney_box.instr"
  mccchannel_11_analyzer_2_array_crystal_array_8_priority = 1321.8;
#line 3085 "MACS_sample_kidney_box.instr"
  mccchannel_11_analyzer_2_array_crystal_array_8_xwidth = channel_11_analyzer_2_array_crystal_depth;
#line 3085 "MACS_sample_kidney_box.instr"
  mccchannel_11_analyzer_2_array_crystal_array_8_yheight = channel_11_analyzer_2_array_crystal_height;
#line 3085 "MACS_sample_kidney_box.instr"
  mccchannel_11_analyzer_2_array_crystal_array_8_zdepth = channel_11_analyzer_2_array_crystal_width;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_11_analyzer_2_array_crystal_array_8_xwidth2 = -1;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_11_analyzer_2_array_crystal_array_8_yheight2 = -1;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_11_analyzer_2_array_crystal_array_8_visualize = 1;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_11_analyzer_2_array_crystal_array_8_target_index = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_11_analyzer_2_array_crystal_array_8_target_x = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_11_analyzer_2_array_crystal_array_8_target_y = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_11_analyzer_2_array_crystal_array_8_target_z = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_11_analyzer_2_array_crystal_array_8_focus_aw = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_11_analyzer_2_array_crystal_array_8_focus_ah = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_11_analyzer_2_array_crystal_array_8_focus_xw = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_11_analyzer_2_array_crystal_array_8_focus_xh = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_11_analyzer_2_array_crystal_array_8_focus_r = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_11_analyzer_2_array_crystal_array_8_p_interact = 0;
#line 71 "MACS_sample_kidney_box.instr"
  if(0) strncpy(mccchannel_11_analyzer_2_array_crystal_array_8_mask_string, 0 ? 0 : "", 16384); else mccchannel_11_analyzer_2_array_crystal_array_8_mask_string[0]='\0';
#line 71 "MACS_sample_kidney_box.instr"
  if(0) strncpy(mccchannel_11_analyzer_2_array_crystal_array_8_mask_setting, 0 ? 0 : "", 16384); else mccchannel_11_analyzer_2_array_crystal_array_8_mask_setting[0]='\0';
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_11_analyzer_2_array_crystal_array_8_number_of_activations = 1;
#line 127642 "MACS_sample_kidney_box.c"

  SIG_MESSAGE("channel_11_analyzer_2_array_crystal_array_8 (Init:Place/Rotate)");
  rot_set_rotation(mctr1,
#line 3088 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 3088 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 3088 "MACS_sample_kidney_box.instr"
    (0 - RAD2DEG * channel_11_analyzer_2_array_theta [ 8 ])*DEG2RAD);
#line 127652 "MACS_sample_kidney_box.c"
  rot_mul(mctr1, mcrotachannel_11_analyzer_2_rotated, mcrotachannel_11_analyzer_2_array_crystal_array_8);
  rot_transpose(mcrotachannel_11_analyzer_2_array_crystal_array_7, mctr1);
  rot_mul(mcrotachannel_11_analyzer_2_array_crystal_array_8, mctr1, mcrotrchannel_11_analyzer_2_array_crystal_array_8);
  mctc1 = coords_set(
#line 3087 "MACS_sample_kidney_box.instr"
    0 + channel_11_analyzer_2_array_effective_radius_of_curvature * ( 1 - cos ( channel_11_analyzer_2_array_theta [ 8 ] ) ),
#line 3087 "MACS_sample_kidney_box.instr"
    0 + channel_11_analyzer_2_array_effective_radius_of_curvature * sin ( channel_11_analyzer_2_array_theta [ 8 ] ),
#line 3087 "MACS_sample_kidney_box.instr"
    0);
#line 127663 "MACS_sample_kidney_box.c"
  rot_transpose(mcrotachannel_11_analyzer_2_rotated, mctr1);
  mctc2 = rot_apply(mctr1, mctc1);
  mcposachannel_11_analyzer_2_array_crystal_array_8 = coords_add(mcposachannel_11_analyzer_2_rotated, mctc2);
  mctc1 = coords_sub(mcposachannel_11_analyzer_2_array_crystal_array_7, mcposachannel_11_analyzer_2_array_crystal_array_8);
  mcposrchannel_11_analyzer_2_array_crystal_array_8 = rot_apply(mcrotachannel_11_analyzer_2_array_crystal_array_8, mctc1);
  mcDEBUG_COMPONENT("channel_11_analyzer_2_array_crystal_array_8", mcposachannel_11_analyzer_2_array_crystal_array_8, mcrotachannel_11_analyzer_2_array_crystal_array_8)
  mccomp_posa[567] = mcposachannel_11_analyzer_2_array_crystal_array_8;
  mccomp_posr[567] = mcposrchannel_11_analyzer_2_array_crystal_array_8;
  mcNCounter[567]  = mcPCounter[567] = mcP2Counter[567] = 0;
  mcAbsorbProp[567]= 0;
    /* Component channel_11_cave2_cyl1. */
  /* Setting parameters for component channel_11_cave2_cyl1. */
  SIG_MESSAGE("channel_11_cave2_cyl1 (Init:SetPar)");
#line 3093 "MACS_sample_kidney_box.instr"
  if("Vacuum") strncpy(mccchannel_11_cave2_cyl1_material_string, "Vacuum" ? "Vacuum" : "", 16384); else mccchannel_11_cave2_cyl1_material_string[0]='\0';
#line 3093 "MACS_sample_kidney_box.instr"
  mccchannel_11_cave2_cyl1_priority = 1307.5;
#line 3092 "MACS_sample_kidney_box.instr"
  mccchannel_11_cave2_cyl1_radius = kidney_cave2_cyl1_radius;
#line 3092 "MACS_sample_kidney_box.instr"
  mccchannel_11_cave2_cyl1_yheight = kidney_cave2_cyl1_height;
#line 67 "MACS_sample_kidney_box.instr"
  mccchannel_11_cave2_cyl1_visualize = 1;
#line 67 "MACS_sample_kidney_box.instr"
  mccchannel_11_cave2_cyl1_target_index = 0;
#line 67 "MACS_sample_kidney_box.instr"
  mccchannel_11_cave2_cyl1_target_x = 0;
#line 67 "MACS_sample_kidney_box.instr"
  mccchannel_11_cave2_cyl1_target_y = 0;
#line 67 "MACS_sample_kidney_box.instr"
  mccchannel_11_cave2_cyl1_target_z = 0;
#line 67 "MACS_sample_kidney_box.instr"
  mccchannel_11_cave2_cyl1_focus_aw = 0;
#line 67 "MACS_sample_kidney_box.instr"
  mccchannel_11_cave2_cyl1_focus_ah = 0;
#line 67 "MACS_sample_kidney_box.instr"
  mccchannel_11_cave2_cyl1_focus_xw = 0;
#line 67 "MACS_sample_kidney_box.instr"
  mccchannel_11_cave2_cyl1_focus_xh = 0;
#line 67 "MACS_sample_kidney_box.instr"
  mccchannel_11_cave2_cyl1_focus_r = 0;
#line 67 "MACS_sample_kidney_box.instr"
  mccchannel_11_cave2_cyl1_p_interact = 0;
#line 67 "MACS_sample_kidney_box.instr"
  if(0) strncpy(mccchannel_11_cave2_cyl1_mask_string, 0 ? 0 : "", 16384); else mccchannel_11_cave2_cyl1_mask_string[0]='\0';
#line 67 "MACS_sample_kidney_box.instr"
  if(0) strncpy(mccchannel_11_cave2_cyl1_mask_setting, 0 ? 0 : "", 16384); else mccchannel_11_cave2_cyl1_mask_setting[0]='\0';
#line 67 "MACS_sample_kidney_box.instr"
  mccchannel_11_cave2_cyl1_number_of_activations = 1;
#line 127713 "MACS_sample_kidney_box.c"

  SIG_MESSAGE("channel_11_cave2_cyl1 (Init:Place/Rotate)");
  rot_set_rotation(mctr1,
#line 3095 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 3095 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 3095 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD);
#line 127723 "MACS_sample_kidney_box.c"
  rot_mul(mctr1, mcrotachannel_11_analyzer_2_center, mcrotachannel_11_cave2_cyl1);
  rot_transpose(mcrotachannel_11_analyzer_2_array_crystal_array_8, mctr1);
  rot_mul(mcrotachannel_11_cave2_cyl1, mctr1, mcrotrchannel_11_cave2_cyl1);
  mctc1 = coords_set(
#line 3094 "MACS_sample_kidney_box.instr"
    0,
#line 3094 "MACS_sample_kidney_box.instr"
    0,
#line 3094 "MACS_sample_kidney_box.instr"
    spec_detector_to_analyzer_2_center);
#line 127734 "MACS_sample_kidney_box.c"
  rot_transpose(mcrotachannel_11_analyzer_2_center, mctr1);
  mctc2 = rot_apply(mctr1, mctc1);
  mcposachannel_11_cave2_cyl1 = coords_add(mcposachannel_11_analyzer_2_center, mctc2);
  mctc1 = coords_sub(mcposachannel_11_analyzer_2_array_crystal_array_8, mcposachannel_11_cave2_cyl1);
  mcposrchannel_11_cave2_cyl1 = rot_apply(mcrotachannel_11_cave2_cyl1, mctc1);
  mcDEBUG_COMPONENT("channel_11_cave2_cyl1", mcposachannel_11_cave2_cyl1, mcrotachannel_11_cave2_cyl1)
  mccomp_posa[568] = mcposachannel_11_cave2_cyl1;
  mccomp_posr[568] = mcposrchannel_11_cave2_cyl1;
  mcNCounter[568]  = mcPCounter[568] = mcP2Counter[568] = 0;
  mcAbsorbProp[568]= 0;
    /* Component channel_11_cave2_box1. */
  /* Setting parameters for component channel_11_cave2_box1. */
  SIG_MESSAGE("channel_11_cave2_box1 (Init:SetPar)");
#line 3100 "MACS_sample_kidney_box.instr"
  if("Vacuum") strncpy(mccchannel_11_cave2_box1_material_string, "Vacuum" ? "Vacuum" : "", 16384); else mccchannel_11_cave2_box1_material_string[0]='\0';
#line 3100 "MACS_sample_kidney_box.instr"
  mccchannel_11_cave2_box1_priority = 1301;
#line 3098 "MACS_sample_kidney_box.instr"
  mccchannel_11_cave2_box1_xwidth = kidney_cave2_box1_width1;
#line 3098 "MACS_sample_kidney_box.instr"
  mccchannel_11_cave2_box1_yheight = kidney_cave2_box1_height1;
#line 3098 "MACS_sample_kidney_box.instr"
  mccchannel_11_cave2_box1_zdepth = kidney_cave2_box1_depth;
#line 3099 "MACS_sample_kidney_box.instr"
  mccchannel_11_cave2_box1_xwidth2 = kidney_cave2_box1_width2;
#line 3099 "MACS_sample_kidney_box.instr"
  mccchannel_11_cave2_box1_yheight2 = kidney_cave2_box1_height2;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_11_cave2_box1_visualize = 1;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_11_cave2_box1_target_index = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_11_cave2_box1_target_x = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_11_cave2_box1_target_y = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_11_cave2_box1_target_z = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_11_cave2_box1_focus_aw = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_11_cave2_box1_focus_ah = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_11_cave2_box1_focus_xw = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_11_cave2_box1_focus_xh = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_11_cave2_box1_focus_r = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_11_cave2_box1_p_interact = 0;
#line 71 "MACS_sample_kidney_box.instr"
  if(0) strncpy(mccchannel_11_cave2_box1_mask_string, 0 ? 0 : "", 16384); else mccchannel_11_cave2_box1_mask_string[0]='\0';
#line 71 "MACS_sample_kidney_box.instr"
  if(0) strncpy(mccchannel_11_cave2_box1_mask_setting, 0 ? 0 : "", 16384); else mccchannel_11_cave2_box1_mask_setting[0]='\0';
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_11_cave2_box1_number_of_activations = 1;
#line 127790 "MACS_sample_kidney_box.c"

  SIG_MESSAGE("channel_11_cave2_box1 (Init:Place/Rotate)");
  rot_set_rotation(mctr1,
#line 3102 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 3102 "MACS_sample_kidney_box.instr"
    (kidney_cave2_box1_y_rotation)*DEG2RAD,
#line 3102 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD);
#line 127800 "MACS_sample_kidney_box.c"
  rot_mul(mctr1, mcrotachannel_11_cave2_cyl1, mcrotachannel_11_cave2_box1);
  rot_transpose(mcrotachannel_11_cave2_cyl1, mctr1);
  rot_mul(mcrotachannel_11_cave2_box1, mctr1, mcrotrchannel_11_cave2_box1);
  mctc1 = coords_set(
#line 3101 "MACS_sample_kidney_box.instr"
    kidney_cave2_box1_center_to_spec_detector_x,
#line 3101 "MACS_sample_kidney_box.instr"
    0,
#line 3101 "MACS_sample_kidney_box.instr"
    kidney_cave2_box1_center_to_spec_detector_z);
#line 127811 "MACS_sample_kidney_box.c"
  rot_transpose(mcrotachannel_11_cave2_cyl1, mctr1);
  mctc2 = rot_apply(mctr1, mctc1);
  mcposachannel_11_cave2_box1 = coords_add(mcposachannel_11_cave2_cyl1, mctc2);
  mctc1 = coords_sub(mcposachannel_11_cave2_cyl1, mcposachannel_11_cave2_box1);
  mcposrchannel_11_cave2_box1 = rot_apply(mcrotachannel_11_cave2_box1, mctc1);
  mcDEBUG_COMPONENT("channel_11_cave2_box1", mcposachannel_11_cave2_box1, mcrotachannel_11_cave2_box1)
  mccomp_posa[569] = mcposachannel_11_cave2_box1;
  mccomp_posr[569] = mcposrchannel_11_cave2_box1;
  mcNCounter[569]  = mcPCounter[569] = mcP2Counter[569] = 0;
  mcAbsorbProp[569]= 0;
    /* Component channel_11_cave2_box2. */
  /* Setting parameters for component channel_11_cave2_box2. */
  SIG_MESSAGE("channel_11_cave2_box2 (Init:SetPar)");
#line 3107 "MACS_sample_kidney_box.instr"
  if("Vacuum") strncpy(mccchannel_11_cave2_box2_material_string, "Vacuum" ? "Vacuum" : "", 16384); else mccchannel_11_cave2_box2_material_string[0]='\0';
#line 3107 "MACS_sample_kidney_box.instr"
  mccchannel_11_cave2_box2_priority = 1306;
#line 3105 "MACS_sample_kidney_box.instr"
  mccchannel_11_cave2_box2_xwidth = kidney_cave2_box2_width1;
#line 3105 "MACS_sample_kidney_box.instr"
  mccchannel_11_cave2_box2_yheight = kidney_cave2_box2_height1;
#line 3105 "MACS_sample_kidney_box.instr"
  mccchannel_11_cave2_box2_zdepth = kidney_cave2_box2_depth;
#line 3106 "MACS_sample_kidney_box.instr"
  mccchannel_11_cave2_box2_xwidth2 = kidney_cave2_box2_width2;
#line 3106 "MACS_sample_kidney_box.instr"
  mccchannel_11_cave2_box2_yheight2 = kidney_cave2_box2_height2;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_11_cave2_box2_visualize = 1;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_11_cave2_box2_target_index = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_11_cave2_box2_target_x = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_11_cave2_box2_target_y = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_11_cave2_box2_target_z = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_11_cave2_box2_focus_aw = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_11_cave2_box2_focus_ah = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_11_cave2_box2_focus_xw = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_11_cave2_box2_focus_xh = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_11_cave2_box2_focus_r = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_11_cave2_box2_p_interact = 0;
#line 71 "MACS_sample_kidney_box.instr"
  if(0) strncpy(mccchannel_11_cave2_box2_mask_string, 0 ? 0 : "", 16384); else mccchannel_11_cave2_box2_mask_string[0]='\0';
#line 71 "MACS_sample_kidney_box.instr"
  if(0) strncpy(mccchannel_11_cave2_box2_mask_setting, 0 ? 0 : "", 16384); else mccchannel_11_cave2_box2_mask_setting[0]='\0';
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_11_cave2_box2_number_of_activations = 1;
#line 127867 "MACS_sample_kidney_box.c"

  SIG_MESSAGE("channel_11_cave2_box2 (Init:Place/Rotate)");
  rot_set_rotation(mctr1,
#line 3109 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 3109 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 3109 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD);
#line 127877 "MACS_sample_kidney_box.c"
  rot_mul(mctr1, mcrotachannel_11_cave2_cyl1, mcrotachannel_11_cave2_box2);
  rot_transpose(mcrotachannel_11_cave2_box1, mctr1);
  rot_mul(mcrotachannel_11_cave2_box2, mctr1, mcrotrchannel_11_cave2_box2);
  mctc1 = coords_set(
#line 3108 "MACS_sample_kidney_box.instr"
    0,
#line 3108 "MACS_sample_kidney_box.instr"
    0,
#line 3108 "MACS_sample_kidney_box.instr"
    kidney_cave2_box2_center_to_detector);
#line 127888 "MACS_sample_kidney_box.c"
  rot_transpose(mcrotachannel_11_cave2_cyl1, mctr1);
  mctc2 = rot_apply(mctr1, mctc1);
  mcposachannel_11_cave2_box2 = coords_add(mcposachannel_11_cave2_cyl1, mctc2);
  mctc1 = coords_sub(mcposachannel_11_cave2_box1, mcposachannel_11_cave2_box2);
  mcposrchannel_11_cave2_box2 = rot_apply(mcrotachannel_11_cave2_box2, mctc1);
  mcDEBUG_COMPONENT("channel_11_cave2_box2", mcposachannel_11_cave2_box2, mcrotachannel_11_cave2_box2)
  mccomp_posa[570] = mcposachannel_11_cave2_box2;
  mccomp_posr[570] = mcposrchannel_11_cave2_box2;
  mcNCounter[570]  = mcPCounter[570] = mcP2Counter[570] = 0;
  mcAbsorbProp[570]= 0;
    /* Component channel_11_cave2_box3. */
  /* Setting parameters for component channel_11_cave2_box3. */
  SIG_MESSAGE("channel_11_cave2_box3 (Init:SetPar)");
#line 3114 "MACS_sample_kidney_box.instr"
  if("Vacuum") strncpy(mccchannel_11_cave2_box3_material_string, "Vacuum" ? "Vacuum" : "", 16384); else mccchannel_11_cave2_box3_material_string[0]='\0';
#line 3114 "MACS_sample_kidney_box.instr"
  mccchannel_11_cave2_box3_priority = 1307;
#line 3112 "MACS_sample_kidney_box.instr"
  mccchannel_11_cave2_box3_xwidth = kidney_cave2_box3_width1;
#line 3112 "MACS_sample_kidney_box.instr"
  mccchannel_11_cave2_box3_yheight = kidney_cave2_box3_height1;
#line 3112 "MACS_sample_kidney_box.instr"
  mccchannel_11_cave2_box3_zdepth = kidney_cave2_box3_depth;
#line 3113 "MACS_sample_kidney_box.instr"
  mccchannel_11_cave2_box3_xwidth2 = kidney_cave2_box3_width2;
#line 3113 "MACS_sample_kidney_box.instr"
  mccchannel_11_cave2_box3_yheight2 = kidney_cave2_box3_height2;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_11_cave2_box3_visualize = 1;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_11_cave2_box3_target_index = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_11_cave2_box3_target_x = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_11_cave2_box3_target_y = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_11_cave2_box3_target_z = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_11_cave2_box3_focus_aw = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_11_cave2_box3_focus_ah = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_11_cave2_box3_focus_xw = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_11_cave2_box3_focus_xh = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_11_cave2_box3_focus_r = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_11_cave2_box3_p_interact = 0;
#line 71 "MACS_sample_kidney_box.instr"
  if(0) strncpy(mccchannel_11_cave2_box3_mask_string, 0 ? 0 : "", 16384); else mccchannel_11_cave2_box3_mask_string[0]='\0';
#line 71 "MACS_sample_kidney_box.instr"
  if(0) strncpy(mccchannel_11_cave2_box3_mask_setting, 0 ? 0 : "", 16384); else mccchannel_11_cave2_box3_mask_setting[0]='\0';
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_11_cave2_box3_number_of_activations = 1;
#line 127944 "MACS_sample_kidney_box.c"

  SIG_MESSAGE("channel_11_cave2_box3 (Init:Place/Rotate)");
  rot_set_rotation(mctr1,
#line 3116 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 3116 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 3116 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD);
#line 127954 "MACS_sample_kidney_box.c"
  rot_mul(mctr1, mcrotachannel_11_cave2_cyl1, mcrotachannel_11_cave2_box3);
  rot_transpose(mcrotachannel_11_cave2_box2, mctr1);
  rot_mul(mcrotachannel_11_cave2_box3, mctr1, mcrotrchannel_11_cave2_box3);
  mctc1 = coords_set(
#line 3115 "MACS_sample_kidney_box.instr"
    0,
#line 3115 "MACS_sample_kidney_box.instr"
    0,
#line 3115 "MACS_sample_kidney_box.instr"
    kidney_cave2_box3_center_to_detector);
#line 127965 "MACS_sample_kidney_box.c"
  rot_transpose(mcrotachannel_11_cave2_cyl1, mctr1);
  mctc2 = rot_apply(mctr1, mctc1);
  mcposachannel_11_cave2_box3 = coords_add(mcposachannel_11_cave2_cyl1, mctc2);
  mctc1 = coords_sub(mcposachannel_11_cave2_box2, mcposachannel_11_cave2_box3);
  mcposrchannel_11_cave2_box3 = rot_apply(mcrotachannel_11_cave2_box3, mctc1);
  mcDEBUG_COMPONENT("channel_11_cave2_box3", mcposachannel_11_cave2_box3, mcrotachannel_11_cave2_box3)
  mccomp_posa[571] = mcposachannel_11_cave2_box3;
  mccomp_posr[571] = mcposrchannel_11_cave2_box3;
  mcNCounter[571]  = mcPCounter[571] = mcP2Counter[571] = 0;
  mcAbsorbProp[571]= 0;
    /* Component inter_analyzer_colimator_center_11. */
  /* Setting parameters for component inter_analyzer_colimator_center_11. */
  SIG_MESSAGE("inter_analyzer_colimator_center_11 (Init:SetPar)");

  SIG_MESSAGE("inter_analyzer_colimator_center_11 (Init:Place/Rotate)");
  rot_set_rotation(mctr1,
#line 3120 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 3120 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 3120 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD);
#line 127988 "MACS_sample_kidney_box.c"
  rot_mul(mctr1, mcrotachannel_11_analyzer_1_center, mcrotainter_analyzer_colimator_center_11);
  rot_transpose(mcrotachannel_11_cave2_box3, mctr1);
  rot_mul(mcrotainter_analyzer_colimator_center_11, mctr1, mcrotrinter_analyzer_colimator_center_11);
  mctc1 = coords_set(
#line 3119 "MACS_sample_kidney_box.instr"
    -0.5 * analyzer_seperation,
#line 3119 "MACS_sample_kidney_box.instr"
    0,
#line 3119 "MACS_sample_kidney_box.instr"
    0);
#line 127999 "MACS_sample_kidney_box.c"
  rot_transpose(mcrotachannel_11_analyzer_1_center, mctr1);
  mctc2 = rot_apply(mctr1, mctc1);
  mcposainter_analyzer_colimator_center_11 = coords_add(mcposachannel_11_analyzer_1_center, mctc2);
  mctc1 = coords_sub(mcposachannel_11_cave2_box3, mcposainter_analyzer_colimator_center_11);
  mcposrinter_analyzer_colimator_center_11 = rot_apply(mcrotainter_analyzer_colimator_center_11, mctc1);
  mcDEBUG_COMPONENT("inter_analyzer_colimator_center_11", mcposainter_analyzer_colimator_center_11, mcrotainter_analyzer_colimator_center_11)
  mccomp_posa[572] = mcposainter_analyzer_colimator_center_11;
  mccomp_posr[572] = mcposrinter_analyzer_colimator_center_11;
  mcNCounter[572]  = mcPCounter[572] = mcP2Counter[572] = 0;
  mcAbsorbProp[572]= 0;
    /* Component inter_analyzer_colimator_11_blade_0. */
  /* Setting parameters for component inter_analyzer_colimator_11_blade_0. */
  SIG_MESSAGE("inter_analyzer_colimator_11_blade_0 (Init:SetPar)");
#line 3124 "MACS_sample_kidney_box.instr"
  if("Collimator_gad") strncpy(mccinter_analyzer_colimator_11_blade_0_material_string, "Collimator_gad" ? "Collimator_gad" : "", 16384); else mccinter_analyzer_colimator_11_blade_0_material_string[0]='\0';
#line 3124 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_11_blade_0_priority = 1325;
#line 3123 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_11_blade_0_xwidth = inter_analyzer_colimator_width;
#line 3123 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_11_blade_0_yheight = inter_analyzer_colimator_height;
#line 3123 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_11_blade_0_zdepth = inter_analyzer_colimator_depth;
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_11_blade_0_xwidth2 = -1;
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_11_blade_0_yheight2 = -1;
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_11_blade_0_visualize = 1;
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_11_blade_0_target_index = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_11_blade_0_target_x = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_11_blade_0_target_y = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_11_blade_0_target_z = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_11_blade_0_focus_aw = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_11_blade_0_focus_ah = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_11_blade_0_focus_xw = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_11_blade_0_focus_xh = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_11_blade_0_focus_r = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_11_blade_0_p_interact = 0;
#line 71 "MACS_sample_kidney_box.instr"
  if(0) strncpy(mccinter_analyzer_colimator_11_blade_0_mask_string, 0 ? 0 : "", 16384); else mccinter_analyzer_colimator_11_blade_0_mask_string[0]='\0';
#line 71 "MACS_sample_kidney_box.instr"
  if(0) strncpy(mccinter_analyzer_colimator_11_blade_0_mask_setting, 0 ? 0 : "", 16384); else mccinter_analyzer_colimator_11_blade_0_mask_setting[0]='\0';
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_11_blade_0_number_of_activations = 1;
#line 128055 "MACS_sample_kidney_box.c"

  SIG_MESSAGE("inter_analyzer_colimator_11_blade_0 (Init:Place/Rotate)");
  rot_set_rotation(mctr1,
#line 3126 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 3126 "MACS_sample_kidney_box.instr"
    (- analyzer_2theta [ 11 ])*DEG2RAD,
#line 3126 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD);
#line 128065 "MACS_sample_kidney_box.c"
  rot_mul(mctr1, mcrotainter_analyzer_colimator_center_11, mcrotainter_analyzer_colimator_11_blade_0);
  rot_transpose(mcrotainter_analyzer_colimator_center_11, mctr1);
  rot_mul(mcrotainter_analyzer_colimator_11_blade_0, mctr1, mcrotrinter_analyzer_colimator_11_blade_0);
  mctc1 = coords_set(
#line 3125 "MACS_sample_kidney_box.instr"
    0,
#line 3125 "MACS_sample_kidney_box.instr"
    0,
#line 3125 "MACS_sample_kidney_box.instr"
    inter_analyzer_colimator_start_pos - 0 * inter_analyzer_colimator_seperation);
#line 128076 "MACS_sample_kidney_box.c"
  rot_transpose(mcrotainter_analyzer_colimator_center_11, mctr1);
  mctc2 = rot_apply(mctr1, mctc1);
  mcposainter_analyzer_colimator_11_blade_0 = coords_add(mcposainter_analyzer_colimator_center_11, mctc2);
  mctc1 = coords_sub(mcposainter_analyzer_colimator_center_11, mcposainter_analyzer_colimator_11_blade_0);
  mcposrinter_analyzer_colimator_11_blade_0 = rot_apply(mcrotainter_analyzer_colimator_11_blade_0, mctc1);
  mcDEBUG_COMPONENT("inter_analyzer_colimator_11_blade_0", mcposainter_analyzer_colimator_11_blade_0, mcrotainter_analyzer_colimator_11_blade_0)
  mccomp_posa[573] = mcposainter_analyzer_colimator_11_blade_0;
  mccomp_posr[573] = mcposrinter_analyzer_colimator_11_blade_0;
  mcNCounter[573]  = mcPCounter[573] = mcP2Counter[573] = 0;
  mcAbsorbProp[573]= 0;
    /* Component inter_analyzer_colimator_11_blade_1. */
  /* Setting parameters for component inter_analyzer_colimator_11_blade_1. */
  SIG_MESSAGE("inter_analyzer_colimator_11_blade_1 (Init:SetPar)");
#line 3130 "MACS_sample_kidney_box.instr"
  if("Collimator_gad") strncpy(mccinter_analyzer_colimator_11_blade_1_material_string, "Collimator_gad" ? "Collimator_gad" : "", 16384); else mccinter_analyzer_colimator_11_blade_1_material_string[0]='\0';
#line 3130 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_11_blade_1_priority = 1326;
#line 3129 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_11_blade_1_xwidth = inter_analyzer_colimator_width;
#line 3129 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_11_blade_1_yheight = inter_analyzer_colimator_height;
#line 3129 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_11_blade_1_zdepth = inter_analyzer_colimator_depth;
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_11_blade_1_xwidth2 = -1;
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_11_blade_1_yheight2 = -1;
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_11_blade_1_visualize = 1;
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_11_blade_1_target_index = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_11_blade_1_target_x = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_11_blade_1_target_y = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_11_blade_1_target_z = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_11_blade_1_focus_aw = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_11_blade_1_focus_ah = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_11_blade_1_focus_xw = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_11_blade_1_focus_xh = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_11_blade_1_focus_r = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_11_blade_1_p_interact = 0;
#line 71 "MACS_sample_kidney_box.instr"
  if(0) strncpy(mccinter_analyzer_colimator_11_blade_1_mask_string, 0 ? 0 : "", 16384); else mccinter_analyzer_colimator_11_blade_1_mask_string[0]='\0';
#line 71 "MACS_sample_kidney_box.instr"
  if(0) strncpy(mccinter_analyzer_colimator_11_blade_1_mask_setting, 0 ? 0 : "", 16384); else mccinter_analyzer_colimator_11_blade_1_mask_setting[0]='\0';
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_11_blade_1_number_of_activations = 1;
#line 128132 "MACS_sample_kidney_box.c"

  SIG_MESSAGE("inter_analyzer_colimator_11_blade_1 (Init:Place/Rotate)");
  rot_set_rotation(mctr1,
#line 3132 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 3132 "MACS_sample_kidney_box.instr"
    (- analyzer_2theta [ 11 ])*DEG2RAD,
#line 3132 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD);
#line 128142 "MACS_sample_kidney_box.c"
  rot_mul(mctr1, mcrotainter_analyzer_colimator_center_11, mcrotainter_analyzer_colimator_11_blade_1);
  rot_transpose(mcrotainter_analyzer_colimator_11_blade_0, mctr1);
  rot_mul(mcrotainter_analyzer_colimator_11_blade_1, mctr1, mcrotrinter_analyzer_colimator_11_blade_1);
  mctc1 = coords_set(
#line 3131 "MACS_sample_kidney_box.instr"
    0,
#line 3131 "MACS_sample_kidney_box.instr"
    0,
#line 3131 "MACS_sample_kidney_box.instr"
    inter_analyzer_colimator_start_pos - 1 * inter_analyzer_colimator_seperation);
#line 128153 "MACS_sample_kidney_box.c"
  rot_transpose(mcrotainter_analyzer_colimator_center_11, mctr1);
  mctc2 = rot_apply(mctr1, mctc1);
  mcposainter_analyzer_colimator_11_blade_1 = coords_add(mcposainter_analyzer_colimator_center_11, mctc2);
  mctc1 = coords_sub(mcposainter_analyzer_colimator_11_blade_0, mcposainter_analyzer_colimator_11_blade_1);
  mcposrinter_analyzer_colimator_11_blade_1 = rot_apply(mcrotainter_analyzer_colimator_11_blade_1, mctc1);
  mcDEBUG_COMPONENT("inter_analyzer_colimator_11_blade_1", mcposainter_analyzer_colimator_11_blade_1, mcrotainter_analyzer_colimator_11_blade_1)
  mccomp_posa[574] = mcposainter_analyzer_colimator_11_blade_1;
  mccomp_posr[574] = mcposrinter_analyzer_colimator_11_blade_1;
  mcNCounter[574]  = mcPCounter[574] = mcP2Counter[574] = 0;
  mcAbsorbProp[574]= 0;
    /* Component inter_analyzer_colimator_11_blade_2. */
  /* Setting parameters for component inter_analyzer_colimator_11_blade_2. */
  SIG_MESSAGE("inter_analyzer_colimator_11_blade_2 (Init:SetPar)");
#line 3136 "MACS_sample_kidney_box.instr"
  if("Collimator_gad") strncpy(mccinter_analyzer_colimator_11_blade_2_material_string, "Collimator_gad" ? "Collimator_gad" : "", 16384); else mccinter_analyzer_colimator_11_blade_2_material_string[0]='\0';
#line 3136 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_11_blade_2_priority = 1327;
#line 3135 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_11_blade_2_xwidth = inter_analyzer_colimator_width;
#line 3135 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_11_blade_2_yheight = inter_analyzer_colimator_height;
#line 3135 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_11_blade_2_zdepth = inter_analyzer_colimator_depth;
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_11_blade_2_xwidth2 = -1;
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_11_blade_2_yheight2 = -1;
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_11_blade_2_visualize = 1;
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_11_blade_2_target_index = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_11_blade_2_target_x = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_11_blade_2_target_y = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_11_blade_2_target_z = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_11_blade_2_focus_aw = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_11_blade_2_focus_ah = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_11_blade_2_focus_xw = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_11_blade_2_focus_xh = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_11_blade_2_focus_r = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_11_blade_2_p_interact = 0;
#line 71 "MACS_sample_kidney_box.instr"
  if(0) strncpy(mccinter_analyzer_colimator_11_blade_2_mask_string, 0 ? 0 : "", 16384); else mccinter_analyzer_colimator_11_blade_2_mask_string[0]='\0';
#line 71 "MACS_sample_kidney_box.instr"
  if(0) strncpy(mccinter_analyzer_colimator_11_blade_2_mask_setting, 0 ? 0 : "", 16384); else mccinter_analyzer_colimator_11_blade_2_mask_setting[0]='\0';
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_11_blade_2_number_of_activations = 1;
#line 128209 "MACS_sample_kidney_box.c"

  SIG_MESSAGE("inter_analyzer_colimator_11_blade_2 (Init:Place/Rotate)");
  rot_set_rotation(mctr1,
#line 3138 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 3138 "MACS_sample_kidney_box.instr"
    (- analyzer_2theta [ 11 ])*DEG2RAD,
#line 3138 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD);
#line 128219 "MACS_sample_kidney_box.c"
  rot_mul(mctr1, mcrotainter_analyzer_colimator_center_11, mcrotainter_analyzer_colimator_11_blade_2);
  rot_transpose(mcrotainter_analyzer_colimator_11_blade_1, mctr1);
  rot_mul(mcrotainter_analyzer_colimator_11_blade_2, mctr1, mcrotrinter_analyzer_colimator_11_blade_2);
  mctc1 = coords_set(
#line 3137 "MACS_sample_kidney_box.instr"
    0,
#line 3137 "MACS_sample_kidney_box.instr"
    0,
#line 3137 "MACS_sample_kidney_box.instr"
    inter_analyzer_colimator_start_pos - 2 * inter_analyzer_colimator_seperation);
#line 128230 "MACS_sample_kidney_box.c"
  rot_transpose(mcrotainter_analyzer_colimator_center_11, mctr1);
  mctc2 = rot_apply(mctr1, mctc1);
  mcposainter_analyzer_colimator_11_blade_2 = coords_add(mcposainter_analyzer_colimator_center_11, mctc2);
  mctc1 = coords_sub(mcposainter_analyzer_colimator_11_blade_1, mcposainter_analyzer_colimator_11_blade_2);
  mcposrinter_analyzer_colimator_11_blade_2 = rot_apply(mcrotainter_analyzer_colimator_11_blade_2, mctc1);
  mcDEBUG_COMPONENT("inter_analyzer_colimator_11_blade_2", mcposainter_analyzer_colimator_11_blade_2, mcrotainter_analyzer_colimator_11_blade_2)
  mccomp_posa[575] = mcposainter_analyzer_colimator_11_blade_2;
  mccomp_posr[575] = mcposrinter_analyzer_colimator_11_blade_2;
  mcNCounter[575]  = mcPCounter[575] = mcP2Counter[575] = 0;
  mcAbsorbProp[575]= 0;
    /* Component inter_analyzer_colimator_11_blade_3. */
  /* Setting parameters for component inter_analyzer_colimator_11_blade_3. */
  SIG_MESSAGE("inter_analyzer_colimator_11_blade_3 (Init:SetPar)");
#line 3142 "MACS_sample_kidney_box.instr"
  if("Collimator_gad") strncpy(mccinter_analyzer_colimator_11_blade_3_material_string, "Collimator_gad" ? "Collimator_gad" : "", 16384); else mccinter_analyzer_colimator_11_blade_3_material_string[0]='\0';
#line 3142 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_11_blade_3_priority = 1328;
#line 3141 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_11_blade_3_xwidth = inter_analyzer_colimator_width;
#line 3141 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_11_blade_3_yheight = inter_analyzer_colimator_height;
#line 3141 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_11_blade_3_zdepth = inter_analyzer_colimator_depth;
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_11_blade_3_xwidth2 = -1;
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_11_blade_3_yheight2 = -1;
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_11_blade_3_visualize = 1;
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_11_blade_3_target_index = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_11_blade_3_target_x = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_11_blade_3_target_y = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_11_blade_3_target_z = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_11_blade_3_focus_aw = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_11_blade_3_focus_ah = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_11_blade_3_focus_xw = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_11_blade_3_focus_xh = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_11_blade_3_focus_r = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_11_blade_3_p_interact = 0;
#line 71 "MACS_sample_kidney_box.instr"
  if(0) strncpy(mccinter_analyzer_colimator_11_blade_3_mask_string, 0 ? 0 : "", 16384); else mccinter_analyzer_colimator_11_blade_3_mask_string[0]='\0';
#line 71 "MACS_sample_kidney_box.instr"
  if(0) strncpy(mccinter_analyzer_colimator_11_blade_3_mask_setting, 0 ? 0 : "", 16384); else mccinter_analyzer_colimator_11_blade_3_mask_setting[0]='\0';
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_11_blade_3_number_of_activations = 1;
#line 128286 "MACS_sample_kidney_box.c"

  SIG_MESSAGE("inter_analyzer_colimator_11_blade_3 (Init:Place/Rotate)");
  rot_set_rotation(mctr1,
#line 3144 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 3144 "MACS_sample_kidney_box.instr"
    (- analyzer_2theta [ 11 ])*DEG2RAD,
#line 3144 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD);
#line 128296 "MACS_sample_kidney_box.c"
  rot_mul(mctr1, mcrotainter_analyzer_colimator_center_11, mcrotainter_analyzer_colimator_11_blade_3);
  rot_transpose(mcrotainter_analyzer_colimator_11_blade_2, mctr1);
  rot_mul(mcrotainter_analyzer_colimator_11_blade_3, mctr1, mcrotrinter_analyzer_colimator_11_blade_3);
  mctc1 = coords_set(
#line 3143 "MACS_sample_kidney_box.instr"
    0,
#line 3143 "MACS_sample_kidney_box.instr"
    0,
#line 3143 "MACS_sample_kidney_box.instr"
    inter_analyzer_colimator_start_pos - 3 * inter_analyzer_colimator_seperation);
#line 128307 "MACS_sample_kidney_box.c"
  rot_transpose(mcrotainter_analyzer_colimator_center_11, mctr1);
  mctc2 = rot_apply(mctr1, mctc1);
  mcposainter_analyzer_colimator_11_blade_3 = coords_add(mcposainter_analyzer_colimator_center_11, mctc2);
  mctc1 = coords_sub(mcposainter_analyzer_colimator_11_blade_2, mcposainter_analyzer_colimator_11_blade_3);
  mcposrinter_analyzer_colimator_11_blade_3 = rot_apply(mcrotainter_analyzer_colimator_11_blade_3, mctc1);
  mcDEBUG_COMPONENT("inter_analyzer_colimator_11_blade_3", mcposainter_analyzer_colimator_11_blade_3, mcrotainter_analyzer_colimator_11_blade_3)
  mccomp_posa[576] = mcposainter_analyzer_colimator_11_blade_3;
  mccomp_posr[576] = mcposrinter_analyzer_colimator_11_blade_3;
  mcNCounter[576]  = mcPCounter[576] = mcP2Counter[576] = 0;
  mcAbsorbProp[576]= 0;
    /* Component inter_analyzer_colimator_11_blade_4. */
  /* Setting parameters for component inter_analyzer_colimator_11_blade_4. */
  SIG_MESSAGE("inter_analyzer_colimator_11_blade_4 (Init:SetPar)");
#line 3148 "MACS_sample_kidney_box.instr"
  if("Collimator_gad") strncpy(mccinter_analyzer_colimator_11_blade_4_material_string, "Collimator_gad" ? "Collimator_gad" : "", 16384); else mccinter_analyzer_colimator_11_blade_4_material_string[0]='\0';
#line 3148 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_11_blade_4_priority = 1329;
#line 3147 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_11_blade_4_xwidth = inter_analyzer_colimator_width;
#line 3147 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_11_blade_4_yheight = inter_analyzer_colimator_height;
#line 3147 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_11_blade_4_zdepth = inter_analyzer_colimator_depth;
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_11_blade_4_xwidth2 = -1;
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_11_blade_4_yheight2 = -1;
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_11_blade_4_visualize = 1;
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_11_blade_4_target_index = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_11_blade_4_target_x = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_11_blade_4_target_y = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_11_blade_4_target_z = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_11_blade_4_focus_aw = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_11_blade_4_focus_ah = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_11_blade_4_focus_xw = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_11_blade_4_focus_xh = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_11_blade_4_focus_r = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_11_blade_4_p_interact = 0;
#line 71 "MACS_sample_kidney_box.instr"
  if(0) strncpy(mccinter_analyzer_colimator_11_blade_4_mask_string, 0 ? 0 : "", 16384); else mccinter_analyzer_colimator_11_blade_4_mask_string[0]='\0';
#line 71 "MACS_sample_kidney_box.instr"
  if(0) strncpy(mccinter_analyzer_colimator_11_blade_4_mask_setting, 0 ? 0 : "", 16384); else mccinter_analyzer_colimator_11_blade_4_mask_setting[0]='\0';
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_11_blade_4_number_of_activations = 1;
#line 128363 "MACS_sample_kidney_box.c"

  SIG_MESSAGE("inter_analyzer_colimator_11_blade_4 (Init:Place/Rotate)");
  rot_set_rotation(mctr1,
#line 3150 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 3150 "MACS_sample_kidney_box.instr"
    (- analyzer_2theta [ 11 ])*DEG2RAD,
#line 3150 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD);
#line 128373 "MACS_sample_kidney_box.c"
  rot_mul(mctr1, mcrotainter_analyzer_colimator_center_11, mcrotainter_analyzer_colimator_11_blade_4);
  rot_transpose(mcrotainter_analyzer_colimator_11_blade_3, mctr1);
  rot_mul(mcrotainter_analyzer_colimator_11_blade_4, mctr1, mcrotrinter_analyzer_colimator_11_blade_4);
  mctc1 = coords_set(
#line 3149 "MACS_sample_kidney_box.instr"
    0,
#line 3149 "MACS_sample_kidney_box.instr"
    0,
#line 3149 "MACS_sample_kidney_box.instr"
    inter_analyzer_colimator_start_pos - 4 * inter_analyzer_colimator_seperation);
#line 128384 "MACS_sample_kidney_box.c"
  rot_transpose(mcrotainter_analyzer_colimator_center_11, mctr1);
  mctc2 = rot_apply(mctr1, mctc1);
  mcposainter_analyzer_colimator_11_blade_4 = coords_add(mcposainter_analyzer_colimator_center_11, mctc2);
  mctc1 = coords_sub(mcposainter_analyzer_colimator_11_blade_3, mcposainter_analyzer_colimator_11_blade_4);
  mcposrinter_analyzer_colimator_11_blade_4 = rot_apply(mcrotainter_analyzer_colimator_11_blade_4, mctc1);
  mcDEBUG_COMPONENT("inter_analyzer_colimator_11_blade_4", mcposainter_analyzer_colimator_11_blade_4, mcrotainter_analyzer_colimator_11_blade_4)
  mccomp_posa[577] = mcposainter_analyzer_colimator_11_blade_4;
  mccomp_posr[577] = mcposrinter_analyzer_colimator_11_blade_4;
  mcNCounter[577]  = mcPCounter[577] = mcP2Counter[577] = 0;
  mcAbsorbProp[577]= 0;
    /* Component diffraction_detector_11_exit_volume. */
  /* Setting parameters for component diffraction_detector_11_exit_volume. */
  SIG_MESSAGE("diffraction_detector_11_exit_volume (Init:SetPar)");
#line 3154 "MACS_sample_kidney_box.instr"
  if("Exit") strncpy(mccdiffraction_detector_11_exit_volume_material_string, "Exit" ? "Exit" : "", 16384); else mccdiffraction_detector_11_exit_volume_material_string[0]='\0';
#line 3154 "MACS_sample_kidney_box.instr"
  mccdiffraction_detector_11_exit_volume_priority = 1331;
#line 3153 "MACS_sample_kidney_box.instr"
  mccdiffraction_detector_11_exit_volume_xwidth = 2.01 * detector_radius;
#line 3153 "MACS_sample_kidney_box.instr"
  mccdiffraction_detector_11_exit_volume_yheight = 1.01 * detector_height;
#line 3153 "MACS_sample_kidney_box.instr"
  mccdiffraction_detector_11_exit_volume_zdepth = 0.001;
#line 71 "MACS_sample_kidney_box.instr"
  mccdiffraction_detector_11_exit_volume_xwidth2 = -1;
#line 71 "MACS_sample_kidney_box.instr"
  mccdiffraction_detector_11_exit_volume_yheight2 = -1;
#line 71 "MACS_sample_kidney_box.instr"
  mccdiffraction_detector_11_exit_volume_visualize = 1;
#line 71 "MACS_sample_kidney_box.instr"
  mccdiffraction_detector_11_exit_volume_target_index = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccdiffraction_detector_11_exit_volume_target_x = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccdiffraction_detector_11_exit_volume_target_y = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccdiffraction_detector_11_exit_volume_target_z = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccdiffraction_detector_11_exit_volume_focus_aw = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccdiffraction_detector_11_exit_volume_focus_ah = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccdiffraction_detector_11_exit_volume_focus_xw = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccdiffraction_detector_11_exit_volume_focus_xh = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccdiffraction_detector_11_exit_volume_focus_r = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccdiffraction_detector_11_exit_volume_p_interact = 0;
#line 71 "MACS_sample_kidney_box.instr"
  if(0) strncpy(mccdiffraction_detector_11_exit_volume_mask_string, 0 ? 0 : "", 16384); else mccdiffraction_detector_11_exit_volume_mask_string[0]='\0';
#line 71 "MACS_sample_kidney_box.instr"
  if(0) strncpy(mccdiffraction_detector_11_exit_volume_mask_setting, 0 ? 0 : "", 16384); else mccdiffraction_detector_11_exit_volume_mask_setting[0]='\0';
#line 71 "MACS_sample_kidney_box.instr"
  mccdiffraction_detector_11_exit_volume_number_of_activations = 1;
#line 128440 "MACS_sample_kidney_box.c"

  SIG_MESSAGE("diffraction_detector_11_exit_volume (Init:Place/Rotate)");
  rot_set_rotation(mctr1,
#line 3156 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 3156 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 3156 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD);
#line 128450 "MACS_sample_kidney_box.c"
  rot_mul(mctr1, mcrotakidney_channel_11, mcrotadiffraction_detector_11_exit_volume);
  rot_transpose(mcrotainter_analyzer_colimator_11_blade_4, mctr1);
  rot_mul(mcrotadiffraction_detector_11_exit_volume, mctr1, mcrotrdiffraction_detector_11_exit_volume);
  mctc1 = coords_set(
#line 3155 "MACS_sample_kidney_box.instr"
    0,
#line 3155 "MACS_sample_kidney_box.instr"
    0,
#line 3155 "MACS_sample_kidney_box.instr"
    0);
#line 128461 "MACS_sample_kidney_box.c"
  rot_transpose(mcrotachannel_11_cave1_cyl1, mctr1);
  mctc2 = rot_apply(mctr1, mctc1);
  mcposadiffraction_detector_11_exit_volume = coords_add(mcposachannel_11_cave1_cyl1, mctc2);
  mctc1 = coords_sub(mcposainter_analyzer_colimator_11_blade_4, mcposadiffraction_detector_11_exit_volume);
  mcposrdiffraction_detector_11_exit_volume = rot_apply(mcrotadiffraction_detector_11_exit_volume, mctc1);
  mcDEBUG_COMPONENT("diffraction_detector_11_exit_volume", mcposadiffraction_detector_11_exit_volume, mcrotadiffraction_detector_11_exit_volume)
  mccomp_posa[578] = mcposadiffraction_detector_11_exit_volume;
  mccomp_posr[578] = mcposrdiffraction_detector_11_exit_volume;
  mcNCounter[578]  = mcPCounter[578] = mcP2Counter[578] = 0;
  mcAbsorbProp[578]= 0;
    /* Component spec_detector_11_exit_volume. */
  /* Setting parameters for component spec_detector_11_exit_volume. */
  SIG_MESSAGE("spec_detector_11_exit_volume (Init:SetPar)");
#line 3160 "MACS_sample_kidney_box.instr"
  if("Exit") strncpy(mccspec_detector_11_exit_volume_material_string, "Exit" ? "Exit" : "", 16384); else mccspec_detector_11_exit_volume_material_string[0]='\0';
#line 3160 "MACS_sample_kidney_box.instr"
  mccspec_detector_11_exit_volume_priority = 1332;
#line 3159 "MACS_sample_kidney_box.instr"
  mccspec_detector_11_exit_volume_xwidth = 2.01 * detector_radius;
#line 3159 "MACS_sample_kidney_box.instr"
  mccspec_detector_11_exit_volume_yheight = 1.01 * detector_height;
#line 3159 "MACS_sample_kidney_box.instr"
  mccspec_detector_11_exit_volume_zdepth = 0.001;
#line 71 "MACS_sample_kidney_box.instr"
  mccspec_detector_11_exit_volume_xwidth2 = -1;
#line 71 "MACS_sample_kidney_box.instr"
  mccspec_detector_11_exit_volume_yheight2 = -1;
#line 71 "MACS_sample_kidney_box.instr"
  mccspec_detector_11_exit_volume_visualize = 1;
#line 71 "MACS_sample_kidney_box.instr"
  mccspec_detector_11_exit_volume_target_index = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccspec_detector_11_exit_volume_target_x = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccspec_detector_11_exit_volume_target_y = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccspec_detector_11_exit_volume_target_z = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccspec_detector_11_exit_volume_focus_aw = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccspec_detector_11_exit_volume_focus_ah = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccspec_detector_11_exit_volume_focus_xw = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccspec_detector_11_exit_volume_focus_xh = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccspec_detector_11_exit_volume_focus_r = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccspec_detector_11_exit_volume_p_interact = 0;
#line 71 "MACS_sample_kidney_box.instr"
  if(0) strncpy(mccspec_detector_11_exit_volume_mask_string, 0 ? 0 : "", 16384); else mccspec_detector_11_exit_volume_mask_string[0]='\0';
#line 71 "MACS_sample_kidney_box.instr"
  if(0) strncpy(mccspec_detector_11_exit_volume_mask_setting, 0 ? 0 : "", 16384); else mccspec_detector_11_exit_volume_mask_setting[0]='\0';
#line 71 "MACS_sample_kidney_box.instr"
  mccspec_detector_11_exit_volume_number_of_activations = 1;
#line 128517 "MACS_sample_kidney_box.c"

  SIG_MESSAGE("spec_detector_11_exit_volume (Init:Place/Rotate)");
  rot_set_rotation(mctr1,
#line 3162 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 3162 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 3162 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD);
#line 128527 "MACS_sample_kidney_box.c"
  rot_mul(mctr1, mcrotachannel_11_analyzer_2_center, mcrotaspec_detector_11_exit_volume);
  rot_transpose(mcrotadiffraction_detector_11_exit_volume, mctr1);
  rot_mul(mcrotaspec_detector_11_exit_volume, mctr1, mcrotrspec_detector_11_exit_volume);
  mctc1 = coords_set(
#line 3161 "MACS_sample_kidney_box.instr"
    0,
#line 3161 "MACS_sample_kidney_box.instr"
    0,
#line 3161 "MACS_sample_kidney_box.instr"
    0);
#line 128538 "MACS_sample_kidney_box.c"
  rot_transpose(mcrotachannel_11_cave2_cyl1, mctr1);
  mctc2 = rot_apply(mctr1, mctc1);
  mcposaspec_detector_11_exit_volume = coords_add(mcposachannel_11_cave2_cyl1, mctc2);
  mctc1 = coords_sub(mcposadiffraction_detector_11_exit_volume, mcposaspec_detector_11_exit_volume);
  mcposrspec_detector_11_exit_volume = rot_apply(mcrotaspec_detector_11_exit_volume, mctc1);
  mcDEBUG_COMPONENT("spec_detector_11_exit_volume", mcposaspec_detector_11_exit_volume, mcrotaspec_detector_11_exit_volume)
  mccomp_posa[579] = mcposaspec_detector_11_exit_volume;
  mccomp_posr[579] = mcposrspec_detector_11_exit_volume;
  mcNCounter[579]  = mcPCounter[579] = mcP2Counter[579] = 0;
  mcAbsorbProp[579]= 0;
    /* Component channel_12_cave1_box1. */
  /* Setting parameters for component channel_12_cave1_box1. */
  SIG_MESSAGE("channel_12_cave1_box1 (Init:SetPar)");
#line 3167 "MACS_sample_kidney_box.instr"
  if("Vacuum") strncpy(mccchannel_12_cave1_box1_material_string, "Vacuum" ? "Vacuum" : "", 16384); else mccchannel_12_cave1_box1_material_string[0]='\0';
#line 3167 "MACS_sample_kidney_box.instr"
  mccchannel_12_cave1_box1_priority = 1400;
#line 3165 "MACS_sample_kidney_box.instr"
  mccchannel_12_cave1_box1_xwidth = kidney_cave1_box1_width1;
#line 3165 "MACS_sample_kidney_box.instr"
  mccchannel_12_cave1_box1_yheight = kidney_cave1_box1_height1;
#line 3165 "MACS_sample_kidney_box.instr"
  mccchannel_12_cave1_box1_zdepth = kidney_cave1_box1_depth;
#line 3166 "MACS_sample_kidney_box.instr"
  mccchannel_12_cave1_box1_xwidth2 = kidney_cave1_box1_width2;
#line 3166 "MACS_sample_kidney_box.instr"
  mccchannel_12_cave1_box1_yheight2 = kidney_cave1_box1_height2;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_12_cave1_box1_visualize = 1;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_12_cave1_box1_target_index = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_12_cave1_box1_target_x = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_12_cave1_box1_target_y = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_12_cave1_box1_target_z = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_12_cave1_box1_focus_aw = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_12_cave1_box1_focus_ah = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_12_cave1_box1_focus_xw = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_12_cave1_box1_focus_xh = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_12_cave1_box1_focus_r = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_12_cave1_box1_p_interact = 0;
#line 71 "MACS_sample_kidney_box.instr"
  if(0) strncpy(mccchannel_12_cave1_box1_mask_string, 0 ? 0 : "", 16384); else mccchannel_12_cave1_box1_mask_string[0]='\0';
#line 71 "MACS_sample_kidney_box.instr"
  if(0) strncpy(mccchannel_12_cave1_box1_mask_setting, 0 ? 0 : "", 16384); else mccchannel_12_cave1_box1_mask_setting[0]='\0';
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_12_cave1_box1_number_of_activations = 1;
#line 128594 "MACS_sample_kidney_box.c"

  SIG_MESSAGE("channel_12_cave1_box1 (Init:Place/Rotate)");
  rot_set_rotation(mctr1,
#line 3169 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 3169 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 3169 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD);
#line 128604 "MACS_sample_kidney_box.c"
  rot_mul(mctr1, mcrotakidney_channel_12, mcrotachannel_12_cave1_box1);
  rot_transpose(mcrotaspec_detector_11_exit_volume, mctr1);
  rot_mul(mcrotachannel_12_cave1_box1, mctr1, mcrotrchannel_12_cave1_box1);
  mctc1 = coords_set(
#line 3168 "MACS_sample_kidney_box.instr"
    0,
#line 3168 "MACS_sample_kidney_box.instr"
    0,
#line 3168 "MACS_sample_kidney_box.instr"
    kidney_cave1_box1_center_to_target);
#line 128615 "MACS_sample_kidney_box.c"
  rot_transpose(mcrotakidney_channel_12, mctr1);
  mctc2 = rot_apply(mctr1, mctc1);
  mcposachannel_12_cave1_box1 = coords_add(mcposakidney_channel_12, mctc2);
  mctc1 = coords_sub(mcposaspec_detector_11_exit_volume, mcposachannel_12_cave1_box1);
  mcposrchannel_12_cave1_box1 = rot_apply(mcrotachannel_12_cave1_box1, mctc1);
  mcDEBUG_COMPONENT("channel_12_cave1_box1", mcposachannel_12_cave1_box1, mcrotachannel_12_cave1_box1)
  mccomp_posa[580] = mcposachannel_12_cave1_box1;
  mccomp_posr[580] = mcposrchannel_12_cave1_box1;
  mcNCounter[580]  = mcPCounter[580] = mcP2Counter[580] = 0;
  mcAbsorbProp[580]= 0;
    /* Component channel_12_cave1_box2. */
  /* Setting parameters for component channel_12_cave1_box2. */
  SIG_MESSAGE("channel_12_cave1_box2 (Init:SetPar)");
#line 3174 "MACS_sample_kidney_box.instr"
  if("Vacuum") strncpy(mccchannel_12_cave1_box2_material_string, "Vacuum" ? "Vacuum" : "", 16384); else mccchannel_12_cave1_box2_material_string[0]='\0';
#line 3174 "MACS_sample_kidney_box.instr"
  mccchannel_12_cave1_box2_priority = 1405;
#line 3172 "MACS_sample_kidney_box.instr"
  mccchannel_12_cave1_box2_xwidth = kidney_cave1_box2_width1;
#line 3172 "MACS_sample_kidney_box.instr"
  mccchannel_12_cave1_box2_yheight = kidney_cave1_box2_height1;
#line 3172 "MACS_sample_kidney_box.instr"
  mccchannel_12_cave1_box2_zdepth = kidney_cave1_box2_depth;
#line 3173 "MACS_sample_kidney_box.instr"
  mccchannel_12_cave1_box2_xwidth2 = kidney_cave1_box2_width2;
#line 3173 "MACS_sample_kidney_box.instr"
  mccchannel_12_cave1_box2_yheight2 = kidney_cave1_box2_height2;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_12_cave1_box2_visualize = 1;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_12_cave1_box2_target_index = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_12_cave1_box2_target_x = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_12_cave1_box2_target_y = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_12_cave1_box2_target_z = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_12_cave1_box2_focus_aw = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_12_cave1_box2_focus_ah = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_12_cave1_box2_focus_xw = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_12_cave1_box2_focus_xh = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_12_cave1_box2_focus_r = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_12_cave1_box2_p_interact = 0;
#line 71 "MACS_sample_kidney_box.instr"
  if(0) strncpy(mccchannel_12_cave1_box2_mask_string, 0 ? 0 : "", 16384); else mccchannel_12_cave1_box2_mask_string[0]='\0';
#line 71 "MACS_sample_kidney_box.instr"
  if(0) strncpy(mccchannel_12_cave1_box2_mask_setting, 0 ? 0 : "", 16384); else mccchannel_12_cave1_box2_mask_setting[0]='\0';
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_12_cave1_box2_number_of_activations = 1;
#line 128671 "MACS_sample_kidney_box.c"

  SIG_MESSAGE("channel_12_cave1_box2 (Init:Place/Rotate)");
  rot_set_rotation(mctr1,
#line 3176 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 3176 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 3176 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD);
#line 128681 "MACS_sample_kidney_box.c"
  rot_mul(mctr1, mcrotakidney_channel_12, mcrotachannel_12_cave1_box2);
  rot_transpose(mcrotachannel_12_cave1_box1, mctr1);
  rot_mul(mcrotachannel_12_cave1_box2, mctr1, mcrotrchannel_12_cave1_box2);
  mctc1 = coords_set(
#line 3175 "MACS_sample_kidney_box.instr"
    kidney_cave1_box2_x_offset,
#line 3175 "MACS_sample_kidney_box.instr"
    0,
#line 3175 "MACS_sample_kidney_box.instr"
    kidney_cave1_box2_center_to_target);
#line 128692 "MACS_sample_kidney_box.c"
  rot_transpose(mcrotakidney_channel_12, mctr1);
  mctc2 = rot_apply(mctr1, mctc1);
  mcposachannel_12_cave1_box2 = coords_add(mcposakidney_channel_12, mctc2);
  mctc1 = coords_sub(mcposachannel_12_cave1_box1, mcposachannel_12_cave1_box2);
  mcposrchannel_12_cave1_box2 = rot_apply(mcrotachannel_12_cave1_box2, mctc1);
  mcDEBUG_COMPONENT("channel_12_cave1_box2", mcposachannel_12_cave1_box2, mcrotachannel_12_cave1_box2)
  mccomp_posa[581] = mcposachannel_12_cave1_box2;
  mccomp_posr[581] = mcposrchannel_12_cave1_box2;
  mcNCounter[581]  = mcPCounter[581] = mcP2Counter[581] = 0;
  mcAbsorbProp[581]= 0;
    /* Component channel_12_cave1_box3. */
  /* Setting parameters for component channel_12_cave1_box3. */
  SIG_MESSAGE("channel_12_cave1_box3 (Init:SetPar)");
#line 3181 "MACS_sample_kidney_box.instr"
  if("Vacuum") strncpy(mccchannel_12_cave1_box3_material_string, "Vacuum" ? "Vacuum" : "", 16384); else mccchannel_12_cave1_box3_material_string[0]='\0';
#line 3181 "MACS_sample_kidney_box.instr"
  mccchannel_12_cave1_box3_priority = 1402;
#line 3179 "MACS_sample_kidney_box.instr"
  mccchannel_12_cave1_box3_xwidth = kidney_cave1_box3_width1;
#line 3179 "MACS_sample_kidney_box.instr"
  mccchannel_12_cave1_box3_yheight = kidney_cave1_box3_height1;
#line 3179 "MACS_sample_kidney_box.instr"
  mccchannel_12_cave1_box3_zdepth = kidney_cave1_box3_depth;
#line 3180 "MACS_sample_kidney_box.instr"
  mccchannel_12_cave1_box3_xwidth2 = kidney_cave1_box3_width2;
#line 3180 "MACS_sample_kidney_box.instr"
  mccchannel_12_cave1_box3_yheight2 = kidney_cave1_box3_height2;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_12_cave1_box3_visualize = 1;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_12_cave1_box3_target_index = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_12_cave1_box3_target_x = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_12_cave1_box3_target_y = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_12_cave1_box3_target_z = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_12_cave1_box3_focus_aw = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_12_cave1_box3_focus_ah = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_12_cave1_box3_focus_xw = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_12_cave1_box3_focus_xh = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_12_cave1_box3_focus_r = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_12_cave1_box3_p_interact = 0;
#line 71 "MACS_sample_kidney_box.instr"
  if(0) strncpy(mccchannel_12_cave1_box3_mask_string, 0 ? 0 : "", 16384); else mccchannel_12_cave1_box3_mask_string[0]='\0';
#line 71 "MACS_sample_kidney_box.instr"
  if(0) strncpy(mccchannel_12_cave1_box3_mask_setting, 0 ? 0 : "", 16384); else mccchannel_12_cave1_box3_mask_setting[0]='\0';
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_12_cave1_box3_number_of_activations = 1;
#line 128748 "MACS_sample_kidney_box.c"

  SIG_MESSAGE("channel_12_cave1_box3 (Init:Place/Rotate)");
  rot_set_rotation(mctr1,
#line 3183 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 3183 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 3183 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD);
#line 128758 "MACS_sample_kidney_box.c"
  rot_mul(mctr1, mcrotakidney_channel_12, mcrotachannel_12_cave1_box3);
  rot_transpose(mcrotachannel_12_cave1_box2, mctr1);
  rot_mul(mcrotachannel_12_cave1_box3, mctr1, mcrotrchannel_12_cave1_box3);
  mctc1 = coords_set(
#line 3182 "MACS_sample_kidney_box.instr"
    0,
#line 3182 "MACS_sample_kidney_box.instr"
    0,
#line 3182 "MACS_sample_kidney_box.instr"
    kidney_cave1_box3_center_to_target);
#line 128769 "MACS_sample_kidney_box.c"
  rot_transpose(mcrotakidney_channel_12, mctr1);
  mctc2 = rot_apply(mctr1, mctc1);
  mcposachannel_12_cave1_box3 = coords_add(mcposakidney_channel_12, mctc2);
  mctc1 = coords_sub(mcposachannel_12_cave1_box2, mcposachannel_12_cave1_box3);
  mcposrchannel_12_cave1_box3 = rot_apply(mcrotachannel_12_cave1_box3, mctc1);
  mcDEBUG_COMPONENT("channel_12_cave1_box3", mcposachannel_12_cave1_box3, mcrotachannel_12_cave1_box3)
  mccomp_posa[582] = mcposachannel_12_cave1_box3;
  mccomp_posr[582] = mcposrchannel_12_cave1_box3;
  mcNCounter[582]  = mcPCounter[582] = mcP2Counter[582] = 0;
  mcAbsorbProp[582]= 0;
    /* Component channel_12_cave1_cyl1. */
  /* Setting parameters for component channel_12_cave1_cyl1. */
  SIG_MESSAGE("channel_12_cave1_cyl1 (Init:SetPar)");
#line 3187 "MACS_sample_kidney_box.instr"
  if("Vacuum") strncpy(mccchannel_12_cave1_cyl1_material_string, "Vacuum" ? "Vacuum" : "", 16384); else mccchannel_12_cave1_cyl1_material_string[0]='\0';
#line 3187 "MACS_sample_kidney_box.instr"
  mccchannel_12_cave1_cyl1_priority = 1403;
#line 3186 "MACS_sample_kidney_box.instr"
  mccchannel_12_cave1_cyl1_radius = kidney_cave1_cyl1_radius;
#line 3186 "MACS_sample_kidney_box.instr"
  mccchannel_12_cave1_cyl1_yheight = kidney_cave1_cyl1_height;
#line 67 "MACS_sample_kidney_box.instr"
  mccchannel_12_cave1_cyl1_visualize = 1;
#line 67 "MACS_sample_kidney_box.instr"
  mccchannel_12_cave1_cyl1_target_index = 0;
#line 67 "MACS_sample_kidney_box.instr"
  mccchannel_12_cave1_cyl1_target_x = 0;
#line 67 "MACS_sample_kidney_box.instr"
  mccchannel_12_cave1_cyl1_target_y = 0;
#line 67 "MACS_sample_kidney_box.instr"
  mccchannel_12_cave1_cyl1_target_z = 0;
#line 67 "MACS_sample_kidney_box.instr"
  mccchannel_12_cave1_cyl1_focus_aw = 0;
#line 67 "MACS_sample_kidney_box.instr"
  mccchannel_12_cave1_cyl1_focus_ah = 0;
#line 67 "MACS_sample_kidney_box.instr"
  mccchannel_12_cave1_cyl1_focus_xw = 0;
#line 67 "MACS_sample_kidney_box.instr"
  mccchannel_12_cave1_cyl1_focus_xh = 0;
#line 67 "MACS_sample_kidney_box.instr"
  mccchannel_12_cave1_cyl1_focus_r = 0;
#line 67 "MACS_sample_kidney_box.instr"
  mccchannel_12_cave1_cyl1_p_interact = 0;
#line 67 "MACS_sample_kidney_box.instr"
  if(0) strncpy(mccchannel_12_cave1_cyl1_mask_string, 0 ? 0 : "", 16384); else mccchannel_12_cave1_cyl1_mask_string[0]='\0';
#line 67 "MACS_sample_kidney_box.instr"
  if(0) strncpy(mccchannel_12_cave1_cyl1_mask_setting, 0 ? 0 : "", 16384); else mccchannel_12_cave1_cyl1_mask_setting[0]='\0';
#line 67 "MACS_sample_kidney_box.instr"
  mccchannel_12_cave1_cyl1_number_of_activations = 1;
#line 128819 "MACS_sample_kidney_box.c"

  SIG_MESSAGE("channel_12_cave1_cyl1 (Init:Place/Rotate)");
  rot_set_rotation(mctr1,
#line 3189 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 3189 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 3189 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD);
#line 128829 "MACS_sample_kidney_box.c"
  rot_mul(mctr1, mcrotakidney_channel_12, mcrotachannel_12_cave1_cyl1);
  rot_transpose(mcrotachannel_12_cave1_box3, mctr1);
  rot_mul(mcrotachannel_12_cave1_cyl1, mctr1, mcrotrchannel_12_cave1_cyl1);
  mctc1 = coords_set(
#line 3188 "MACS_sample_kidney_box.instr"
    0,
#line 3188 "MACS_sample_kidney_box.instr"
    0,
#line 3188 "MACS_sample_kidney_box.instr"
    kidney_cave1_cyl1_center_to_target);
#line 128840 "MACS_sample_kidney_box.c"
  rot_transpose(mcrotakidney_channel_12, mctr1);
  mctc2 = rot_apply(mctr1, mctc1);
  mcposachannel_12_cave1_cyl1 = coords_add(mcposakidney_channel_12, mctc2);
  mctc1 = coords_sub(mcposachannel_12_cave1_box3, mcposachannel_12_cave1_cyl1);
  mcposrchannel_12_cave1_cyl1 = rot_apply(mcrotachannel_12_cave1_cyl1, mctc1);
  mcDEBUG_COMPONENT("channel_12_cave1_cyl1", mcposachannel_12_cave1_cyl1, mcrotachannel_12_cave1_cyl1)
  mccomp_posa[583] = mcposachannel_12_cave1_cyl1;
  mccomp_posr[583] = mcposrchannel_12_cave1_cyl1;
  mcNCounter[583]  = mcPCounter[583] = mcP2Counter[583] = 0;
  mcAbsorbProp[583]= 0;
    /* Component channel_12_analyzer_1_center. */
  /* Setting parameters for component channel_12_analyzer_1_center. */
  SIG_MESSAGE("channel_12_analyzer_1_center (Init:SetPar)");

  SIG_MESSAGE("channel_12_analyzer_1_center (Init:Place/Rotate)");
  rot_set_rotation(mctr1,
    (0.0)*DEG2RAD,
    (0.0)*DEG2RAD,
    (0.0)*DEG2RAD);
#line 128860 "MACS_sample_kidney_box.c"
  rot_mul(mctr1, mcrotakidney_channel_12, mcrotachannel_12_analyzer_1_center);
  rot_transpose(mcrotachannel_12_cave1_cyl1, mctr1);
  rot_mul(mcrotachannel_12_analyzer_1_center, mctr1, mcrotrchannel_12_analyzer_1_center);
  mctc1 = coords_set(
#line 3193 "MACS_sample_kidney_box.instr"
    0,
#line 3193 "MACS_sample_kidney_box.instr"
    0,
#line 3193 "MACS_sample_kidney_box.instr"
    analyzer_1_center_to_sample);
#line 128871 "MACS_sample_kidney_box.c"
  rot_transpose(mcrotakidney_channel_12, mctr1);
  mctc2 = rot_apply(mctr1, mctc1);
  mcposachannel_12_analyzer_1_center = coords_add(mcposakidney_channel_12, mctc2);
  mctc1 = coords_sub(mcposachannel_12_cave1_cyl1, mcposachannel_12_analyzer_1_center);
  mcposrchannel_12_analyzer_1_center = rot_apply(mcrotachannel_12_analyzer_1_center, mctc1);
  mcDEBUG_COMPONENT("channel_12_analyzer_1_center", mcposachannel_12_analyzer_1_center, mcrotachannel_12_analyzer_1_center)
  mccomp_posa[584] = mcposachannel_12_analyzer_1_center;
  mccomp_posr[584] = mcposrchannel_12_analyzer_1_center;
  mcNCounter[584]  = mcPCounter[584] = mcP2Counter[584] = 0;
  mcAbsorbProp[584]= 0;
    /* Component channel_12_analyzer_1_rotated. */
  /* Setting parameters for component channel_12_analyzer_1_rotated. */
  SIG_MESSAGE("channel_12_analyzer_1_rotated (Init:SetPar)");

  SIG_MESSAGE("channel_12_analyzer_1_rotated (Init:Place/Rotate)");
  rot_set_rotation(mctr1,
#line 3197 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 3197 "MACS_sample_kidney_box.instr"
    (180 - analyzer_theta [ 12 ])*DEG2RAD,
#line 3197 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD);
#line 128894 "MACS_sample_kidney_box.c"
  rot_mul(mctr1, mcrotachannel_12_analyzer_1_center, mcrotachannel_12_analyzer_1_rotated);
  rot_transpose(mcrotachannel_12_analyzer_1_center, mctr1);
  rot_mul(mcrotachannel_12_analyzer_1_rotated, mctr1, mcrotrchannel_12_analyzer_1_rotated);
  mctc1 = coords_set(
#line 3196 "MACS_sample_kidney_box.instr"
    0,
#line 3196 "MACS_sample_kidney_box.instr"
    0,
#line 3196 "MACS_sample_kidney_box.instr"
    -0.5 * analyzer_seperation / tan ( analyzer_2theta [ 12 ] * DEG2RAD ));
#line 128905 "MACS_sample_kidney_box.c"
  rot_transpose(mcrotachannel_12_analyzer_1_center, mctr1);
  mctc2 = rot_apply(mctr1, mctc1);
  mcposachannel_12_analyzer_1_rotated = coords_add(mcposachannel_12_analyzer_1_center, mctc2);
  mctc1 = coords_sub(mcposachannel_12_analyzer_1_center, mcposachannel_12_analyzer_1_rotated);
  mcposrchannel_12_analyzer_1_rotated = rot_apply(mcrotachannel_12_analyzer_1_rotated, mctc1);
  mcDEBUG_COMPONENT("channel_12_analyzer_1_rotated", mcposachannel_12_analyzer_1_rotated, mcrotachannel_12_analyzer_1_rotated)
  mccomp_posa[585] = mcposachannel_12_analyzer_1_rotated;
  mccomp_posr[585] = mcposrchannel_12_analyzer_1_rotated;
  mcNCounter[585]  = mcPCounter[585] = mcP2Counter[585] = 0;
  mcAbsorbProp[585]= 0;
    /* Component channel_12_analyzer_1_array_crystal_array_0. */
  /* Setting parameters for component channel_12_analyzer_1_array_crystal_array_0. */
  SIG_MESSAGE("channel_12_analyzer_1_array_crystal_array_0 (Init:SetPar)");
#line 3201 "MACS_sample_kidney_box.instr"
  if("PG_analyzer") strncpy(mccchannel_12_analyzer_1_array_crystal_array_0_material_string, "PG_analyzer" ? "PG_analyzer" : "", 16384); else mccchannel_12_analyzer_1_array_crystal_array_0_material_string[0]='\0';
#line 3201 "MACS_sample_kidney_box.instr"
  mccchannel_12_analyzer_1_array_crystal_array_0_priority = 1420.0;
#line 3200 "MACS_sample_kidney_box.instr"
  mccchannel_12_analyzer_1_array_crystal_array_0_xwidth = channel_12_analyzer_1_array_crystal_depth;
#line 3200 "MACS_sample_kidney_box.instr"
  mccchannel_12_analyzer_1_array_crystal_array_0_yheight = channel_12_analyzer_1_array_crystal_height;
#line 3200 "MACS_sample_kidney_box.instr"
  mccchannel_12_analyzer_1_array_crystal_array_0_zdepth = channel_12_analyzer_1_array_crystal_width;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_12_analyzer_1_array_crystal_array_0_xwidth2 = -1;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_12_analyzer_1_array_crystal_array_0_yheight2 = -1;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_12_analyzer_1_array_crystal_array_0_visualize = 1;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_12_analyzer_1_array_crystal_array_0_target_index = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_12_analyzer_1_array_crystal_array_0_target_x = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_12_analyzer_1_array_crystal_array_0_target_y = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_12_analyzer_1_array_crystal_array_0_target_z = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_12_analyzer_1_array_crystal_array_0_focus_aw = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_12_analyzer_1_array_crystal_array_0_focus_ah = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_12_analyzer_1_array_crystal_array_0_focus_xw = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_12_analyzer_1_array_crystal_array_0_focus_xh = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_12_analyzer_1_array_crystal_array_0_focus_r = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_12_analyzer_1_array_crystal_array_0_p_interact = 0;
#line 71 "MACS_sample_kidney_box.instr"
  if(0) strncpy(mccchannel_12_analyzer_1_array_crystal_array_0_mask_string, 0 ? 0 : "", 16384); else mccchannel_12_analyzer_1_array_crystal_array_0_mask_string[0]='\0';
#line 71 "MACS_sample_kidney_box.instr"
  if(0) strncpy(mccchannel_12_analyzer_1_array_crystal_array_0_mask_setting, 0 ? 0 : "", 16384); else mccchannel_12_analyzer_1_array_crystal_array_0_mask_setting[0]='\0';
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_12_analyzer_1_array_crystal_array_0_number_of_activations = 1;
#line 128961 "MACS_sample_kidney_box.c"

  SIG_MESSAGE("channel_12_analyzer_1_array_crystal_array_0 (Init:Place/Rotate)");
  rot_set_rotation(mctr1,
#line 3203 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 3203 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 3203 "MACS_sample_kidney_box.instr"
    (0 - RAD2DEG * channel_12_analyzer_1_array_theta [ 0 ])*DEG2RAD);
#line 128971 "MACS_sample_kidney_box.c"
  rot_mul(mctr1, mcrotachannel_12_analyzer_1_rotated, mcrotachannel_12_analyzer_1_array_crystal_array_0);
  rot_transpose(mcrotachannel_12_analyzer_1_rotated, mctr1);
  rot_mul(mcrotachannel_12_analyzer_1_array_crystal_array_0, mctr1, mcrotrchannel_12_analyzer_1_array_crystal_array_0);
  mctc1 = coords_set(
#line 3202 "MACS_sample_kidney_box.instr"
    0 + channel_12_analyzer_1_array_effective_radius_of_curvature * ( 1 - cos ( channel_12_analyzer_1_array_theta [ 0 ] ) ),
#line 3202 "MACS_sample_kidney_box.instr"
    0 + channel_12_analyzer_1_array_effective_radius_of_curvature * sin ( channel_12_analyzer_1_array_theta [ 0 ] ),
#line 3202 "MACS_sample_kidney_box.instr"
    0);
#line 128982 "MACS_sample_kidney_box.c"
  rot_transpose(mcrotachannel_12_analyzer_1_rotated, mctr1);
  mctc2 = rot_apply(mctr1, mctc1);
  mcposachannel_12_analyzer_1_array_crystal_array_0 = coords_add(mcposachannel_12_analyzer_1_rotated, mctc2);
  mctc1 = coords_sub(mcposachannel_12_analyzer_1_rotated, mcposachannel_12_analyzer_1_array_crystal_array_0);
  mcposrchannel_12_analyzer_1_array_crystal_array_0 = rot_apply(mcrotachannel_12_analyzer_1_array_crystal_array_0, mctc1);
  mcDEBUG_COMPONENT("channel_12_analyzer_1_array_crystal_array_0", mcposachannel_12_analyzer_1_array_crystal_array_0, mcrotachannel_12_analyzer_1_array_crystal_array_0)
  mccomp_posa[586] = mcposachannel_12_analyzer_1_array_crystal_array_0;
  mccomp_posr[586] = mcposrchannel_12_analyzer_1_array_crystal_array_0;
  mcNCounter[586]  = mcPCounter[586] = mcP2Counter[586] = 0;
  mcAbsorbProp[586]= 0;
    /* Component channel_12_analyzer_1_array_crystal_array_1. */
  /* Setting parameters for component channel_12_analyzer_1_array_crystal_array_1. */
  SIG_MESSAGE("channel_12_analyzer_1_array_crystal_array_1 (Init:SetPar)");
#line 3207 "MACS_sample_kidney_box.instr"
  if("PG_analyzer") strncpy(mccchannel_12_analyzer_1_array_crystal_array_1_material_string, "PG_analyzer" ? "PG_analyzer" : "", 16384); else mccchannel_12_analyzer_1_array_crystal_array_1_material_string[0]='\0';
#line 3207 "MACS_sample_kidney_box.instr"
  mccchannel_12_analyzer_1_array_crystal_array_1_priority = 1420.1;
#line 3206 "MACS_sample_kidney_box.instr"
  mccchannel_12_analyzer_1_array_crystal_array_1_xwidth = channel_12_analyzer_1_array_crystal_depth;
#line 3206 "MACS_sample_kidney_box.instr"
  mccchannel_12_analyzer_1_array_crystal_array_1_yheight = channel_12_analyzer_1_array_crystal_height;
#line 3206 "MACS_sample_kidney_box.instr"
  mccchannel_12_analyzer_1_array_crystal_array_1_zdepth = channel_12_analyzer_1_array_crystal_width;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_12_analyzer_1_array_crystal_array_1_xwidth2 = -1;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_12_analyzer_1_array_crystal_array_1_yheight2 = -1;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_12_analyzer_1_array_crystal_array_1_visualize = 1;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_12_analyzer_1_array_crystal_array_1_target_index = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_12_analyzer_1_array_crystal_array_1_target_x = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_12_analyzer_1_array_crystal_array_1_target_y = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_12_analyzer_1_array_crystal_array_1_target_z = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_12_analyzer_1_array_crystal_array_1_focus_aw = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_12_analyzer_1_array_crystal_array_1_focus_ah = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_12_analyzer_1_array_crystal_array_1_focus_xw = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_12_analyzer_1_array_crystal_array_1_focus_xh = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_12_analyzer_1_array_crystal_array_1_focus_r = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_12_analyzer_1_array_crystal_array_1_p_interact = 0;
#line 71 "MACS_sample_kidney_box.instr"
  if(0) strncpy(mccchannel_12_analyzer_1_array_crystal_array_1_mask_string, 0 ? 0 : "", 16384); else mccchannel_12_analyzer_1_array_crystal_array_1_mask_string[0]='\0';
#line 71 "MACS_sample_kidney_box.instr"
  if(0) strncpy(mccchannel_12_analyzer_1_array_crystal_array_1_mask_setting, 0 ? 0 : "", 16384); else mccchannel_12_analyzer_1_array_crystal_array_1_mask_setting[0]='\0';
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_12_analyzer_1_array_crystal_array_1_number_of_activations = 1;
#line 129038 "MACS_sample_kidney_box.c"

  SIG_MESSAGE("channel_12_analyzer_1_array_crystal_array_1 (Init:Place/Rotate)");
  rot_set_rotation(mctr1,
#line 3209 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 3209 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 3209 "MACS_sample_kidney_box.instr"
    (0 - RAD2DEG * channel_12_analyzer_1_array_theta [ 1 ])*DEG2RAD);
#line 129048 "MACS_sample_kidney_box.c"
  rot_mul(mctr1, mcrotachannel_12_analyzer_1_rotated, mcrotachannel_12_analyzer_1_array_crystal_array_1);
  rot_transpose(mcrotachannel_12_analyzer_1_array_crystal_array_0, mctr1);
  rot_mul(mcrotachannel_12_analyzer_1_array_crystal_array_1, mctr1, mcrotrchannel_12_analyzer_1_array_crystal_array_1);
  mctc1 = coords_set(
#line 3208 "MACS_sample_kidney_box.instr"
    0 + channel_12_analyzer_1_array_effective_radius_of_curvature * ( 1 - cos ( channel_12_analyzer_1_array_theta [ 1 ] ) ),
#line 3208 "MACS_sample_kidney_box.instr"
    0 + channel_12_analyzer_1_array_effective_radius_of_curvature * sin ( channel_12_analyzer_1_array_theta [ 1 ] ),
#line 3208 "MACS_sample_kidney_box.instr"
    0);
#line 129059 "MACS_sample_kidney_box.c"
  rot_transpose(mcrotachannel_12_analyzer_1_rotated, mctr1);
  mctc2 = rot_apply(mctr1, mctc1);
  mcposachannel_12_analyzer_1_array_crystal_array_1 = coords_add(mcposachannel_12_analyzer_1_rotated, mctc2);
  mctc1 = coords_sub(mcposachannel_12_analyzer_1_array_crystal_array_0, mcposachannel_12_analyzer_1_array_crystal_array_1);
  mcposrchannel_12_analyzer_1_array_crystal_array_1 = rot_apply(mcrotachannel_12_analyzer_1_array_crystal_array_1, mctc1);
  mcDEBUG_COMPONENT("channel_12_analyzer_1_array_crystal_array_1", mcposachannel_12_analyzer_1_array_crystal_array_1, mcrotachannel_12_analyzer_1_array_crystal_array_1)
  mccomp_posa[587] = mcposachannel_12_analyzer_1_array_crystal_array_1;
  mccomp_posr[587] = mcposrchannel_12_analyzer_1_array_crystal_array_1;
  mcNCounter[587]  = mcPCounter[587] = mcP2Counter[587] = 0;
  mcAbsorbProp[587]= 0;
    /* Component channel_12_analyzer_1_array_crystal_array_2. */
  /* Setting parameters for component channel_12_analyzer_1_array_crystal_array_2. */
  SIG_MESSAGE("channel_12_analyzer_1_array_crystal_array_2 (Init:SetPar)");
#line 3213 "MACS_sample_kidney_box.instr"
  if("PG_analyzer") strncpy(mccchannel_12_analyzer_1_array_crystal_array_2_material_string, "PG_analyzer" ? "PG_analyzer" : "", 16384); else mccchannel_12_analyzer_1_array_crystal_array_2_material_string[0]='\0';
#line 3213 "MACS_sample_kidney_box.instr"
  mccchannel_12_analyzer_1_array_crystal_array_2_priority = 1420.2;
#line 3212 "MACS_sample_kidney_box.instr"
  mccchannel_12_analyzer_1_array_crystal_array_2_xwidth = channel_12_analyzer_1_array_crystal_depth;
#line 3212 "MACS_sample_kidney_box.instr"
  mccchannel_12_analyzer_1_array_crystal_array_2_yheight = channel_12_analyzer_1_array_crystal_height;
#line 3212 "MACS_sample_kidney_box.instr"
  mccchannel_12_analyzer_1_array_crystal_array_2_zdepth = channel_12_analyzer_1_array_crystal_width;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_12_analyzer_1_array_crystal_array_2_xwidth2 = -1;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_12_analyzer_1_array_crystal_array_2_yheight2 = -1;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_12_analyzer_1_array_crystal_array_2_visualize = 1;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_12_analyzer_1_array_crystal_array_2_target_index = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_12_analyzer_1_array_crystal_array_2_target_x = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_12_analyzer_1_array_crystal_array_2_target_y = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_12_analyzer_1_array_crystal_array_2_target_z = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_12_analyzer_1_array_crystal_array_2_focus_aw = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_12_analyzer_1_array_crystal_array_2_focus_ah = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_12_analyzer_1_array_crystal_array_2_focus_xw = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_12_analyzer_1_array_crystal_array_2_focus_xh = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_12_analyzer_1_array_crystal_array_2_focus_r = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_12_analyzer_1_array_crystal_array_2_p_interact = 0;
#line 71 "MACS_sample_kidney_box.instr"
  if(0) strncpy(mccchannel_12_analyzer_1_array_crystal_array_2_mask_string, 0 ? 0 : "", 16384); else mccchannel_12_analyzer_1_array_crystal_array_2_mask_string[0]='\0';
#line 71 "MACS_sample_kidney_box.instr"
  if(0) strncpy(mccchannel_12_analyzer_1_array_crystal_array_2_mask_setting, 0 ? 0 : "", 16384); else mccchannel_12_analyzer_1_array_crystal_array_2_mask_setting[0]='\0';
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_12_analyzer_1_array_crystal_array_2_number_of_activations = 1;
#line 129115 "MACS_sample_kidney_box.c"

  SIG_MESSAGE("channel_12_analyzer_1_array_crystal_array_2 (Init:Place/Rotate)");
  rot_set_rotation(mctr1,
#line 3215 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 3215 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 3215 "MACS_sample_kidney_box.instr"
    (0 - RAD2DEG * channel_12_analyzer_1_array_theta [ 2 ])*DEG2RAD);
#line 129125 "MACS_sample_kidney_box.c"
  rot_mul(mctr1, mcrotachannel_12_analyzer_1_rotated, mcrotachannel_12_analyzer_1_array_crystal_array_2);
  rot_transpose(mcrotachannel_12_analyzer_1_array_crystal_array_1, mctr1);
  rot_mul(mcrotachannel_12_analyzer_1_array_crystal_array_2, mctr1, mcrotrchannel_12_analyzer_1_array_crystal_array_2);
  mctc1 = coords_set(
#line 3214 "MACS_sample_kidney_box.instr"
    0 + channel_12_analyzer_1_array_effective_radius_of_curvature * ( 1 - cos ( channel_12_analyzer_1_array_theta [ 2 ] ) ),
#line 3214 "MACS_sample_kidney_box.instr"
    0 + channel_12_analyzer_1_array_effective_radius_of_curvature * sin ( channel_12_analyzer_1_array_theta [ 2 ] ),
#line 3214 "MACS_sample_kidney_box.instr"
    0);
#line 129136 "MACS_sample_kidney_box.c"
  rot_transpose(mcrotachannel_12_analyzer_1_rotated, mctr1);
  mctc2 = rot_apply(mctr1, mctc1);
  mcposachannel_12_analyzer_1_array_crystal_array_2 = coords_add(mcposachannel_12_analyzer_1_rotated, mctc2);
  mctc1 = coords_sub(mcposachannel_12_analyzer_1_array_crystal_array_1, mcposachannel_12_analyzer_1_array_crystal_array_2);
  mcposrchannel_12_analyzer_1_array_crystal_array_2 = rot_apply(mcrotachannel_12_analyzer_1_array_crystal_array_2, mctc1);
  mcDEBUG_COMPONENT("channel_12_analyzer_1_array_crystal_array_2", mcposachannel_12_analyzer_1_array_crystal_array_2, mcrotachannel_12_analyzer_1_array_crystal_array_2)
  mccomp_posa[588] = mcposachannel_12_analyzer_1_array_crystal_array_2;
  mccomp_posr[588] = mcposrchannel_12_analyzer_1_array_crystal_array_2;
  mcNCounter[588]  = mcPCounter[588] = mcP2Counter[588] = 0;
  mcAbsorbProp[588]= 0;
    /* Component channel_12_analyzer_1_array_crystal_array_3. */
  /* Setting parameters for component channel_12_analyzer_1_array_crystal_array_3. */
  SIG_MESSAGE("channel_12_analyzer_1_array_crystal_array_3 (Init:SetPar)");
#line 3219 "MACS_sample_kidney_box.instr"
  if("PG_analyzer") strncpy(mccchannel_12_analyzer_1_array_crystal_array_3_material_string, "PG_analyzer" ? "PG_analyzer" : "", 16384); else mccchannel_12_analyzer_1_array_crystal_array_3_material_string[0]='\0';
#line 3219 "MACS_sample_kidney_box.instr"
  mccchannel_12_analyzer_1_array_crystal_array_3_priority = 1420.3;
#line 3218 "MACS_sample_kidney_box.instr"
  mccchannel_12_analyzer_1_array_crystal_array_3_xwidth = channel_12_analyzer_1_array_crystal_depth;
#line 3218 "MACS_sample_kidney_box.instr"
  mccchannel_12_analyzer_1_array_crystal_array_3_yheight = channel_12_analyzer_1_array_crystal_height;
#line 3218 "MACS_sample_kidney_box.instr"
  mccchannel_12_analyzer_1_array_crystal_array_3_zdepth = channel_12_analyzer_1_array_crystal_width;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_12_analyzer_1_array_crystal_array_3_xwidth2 = -1;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_12_analyzer_1_array_crystal_array_3_yheight2 = -1;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_12_analyzer_1_array_crystal_array_3_visualize = 1;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_12_analyzer_1_array_crystal_array_3_target_index = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_12_analyzer_1_array_crystal_array_3_target_x = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_12_analyzer_1_array_crystal_array_3_target_y = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_12_analyzer_1_array_crystal_array_3_target_z = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_12_analyzer_1_array_crystal_array_3_focus_aw = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_12_analyzer_1_array_crystal_array_3_focus_ah = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_12_analyzer_1_array_crystal_array_3_focus_xw = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_12_analyzer_1_array_crystal_array_3_focus_xh = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_12_analyzer_1_array_crystal_array_3_focus_r = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_12_analyzer_1_array_crystal_array_3_p_interact = 0;
#line 71 "MACS_sample_kidney_box.instr"
  if(0) strncpy(mccchannel_12_analyzer_1_array_crystal_array_3_mask_string, 0 ? 0 : "", 16384); else mccchannel_12_analyzer_1_array_crystal_array_3_mask_string[0]='\0';
#line 71 "MACS_sample_kidney_box.instr"
  if(0) strncpy(mccchannel_12_analyzer_1_array_crystal_array_3_mask_setting, 0 ? 0 : "", 16384); else mccchannel_12_analyzer_1_array_crystal_array_3_mask_setting[0]='\0';
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_12_analyzer_1_array_crystal_array_3_number_of_activations = 1;
#line 129192 "MACS_sample_kidney_box.c"

  SIG_MESSAGE("channel_12_analyzer_1_array_crystal_array_3 (Init:Place/Rotate)");
  rot_set_rotation(mctr1,
#line 3221 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 3221 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 3221 "MACS_sample_kidney_box.instr"
    (0 - RAD2DEG * channel_12_analyzer_1_array_theta [ 3 ])*DEG2RAD);
#line 129202 "MACS_sample_kidney_box.c"
  rot_mul(mctr1, mcrotachannel_12_analyzer_1_rotated, mcrotachannel_12_analyzer_1_array_crystal_array_3);
  rot_transpose(mcrotachannel_12_analyzer_1_array_crystal_array_2, mctr1);
  rot_mul(mcrotachannel_12_analyzer_1_array_crystal_array_3, mctr1, mcrotrchannel_12_analyzer_1_array_crystal_array_3);
  mctc1 = coords_set(
#line 3220 "MACS_sample_kidney_box.instr"
    0 + channel_12_analyzer_1_array_effective_radius_of_curvature * ( 1 - cos ( channel_12_analyzer_1_array_theta [ 3 ] ) ),
#line 3220 "MACS_sample_kidney_box.instr"
    0 + channel_12_analyzer_1_array_effective_radius_of_curvature * sin ( channel_12_analyzer_1_array_theta [ 3 ] ),
#line 3220 "MACS_sample_kidney_box.instr"
    0);
#line 129213 "MACS_sample_kidney_box.c"
  rot_transpose(mcrotachannel_12_analyzer_1_rotated, mctr1);
  mctc2 = rot_apply(mctr1, mctc1);
  mcposachannel_12_analyzer_1_array_crystal_array_3 = coords_add(mcposachannel_12_analyzer_1_rotated, mctc2);
  mctc1 = coords_sub(mcposachannel_12_analyzer_1_array_crystal_array_2, mcposachannel_12_analyzer_1_array_crystal_array_3);
  mcposrchannel_12_analyzer_1_array_crystal_array_3 = rot_apply(mcrotachannel_12_analyzer_1_array_crystal_array_3, mctc1);
  mcDEBUG_COMPONENT("channel_12_analyzer_1_array_crystal_array_3", mcposachannel_12_analyzer_1_array_crystal_array_3, mcrotachannel_12_analyzer_1_array_crystal_array_3)
  mccomp_posa[589] = mcposachannel_12_analyzer_1_array_crystal_array_3;
  mccomp_posr[589] = mcposrchannel_12_analyzer_1_array_crystal_array_3;
  mcNCounter[589]  = mcPCounter[589] = mcP2Counter[589] = 0;
  mcAbsorbProp[589]= 0;
    /* Component channel_12_analyzer_1_array_crystal_array_4. */
  /* Setting parameters for component channel_12_analyzer_1_array_crystal_array_4. */
  SIG_MESSAGE("channel_12_analyzer_1_array_crystal_array_4 (Init:SetPar)");
#line 3225 "MACS_sample_kidney_box.instr"
  if("PG_analyzer") strncpy(mccchannel_12_analyzer_1_array_crystal_array_4_material_string, "PG_analyzer" ? "PG_analyzer" : "", 16384); else mccchannel_12_analyzer_1_array_crystal_array_4_material_string[0]='\0';
#line 3225 "MACS_sample_kidney_box.instr"
  mccchannel_12_analyzer_1_array_crystal_array_4_priority = 1420.4;
#line 3224 "MACS_sample_kidney_box.instr"
  mccchannel_12_analyzer_1_array_crystal_array_4_xwidth = channel_12_analyzer_1_array_crystal_depth;
#line 3224 "MACS_sample_kidney_box.instr"
  mccchannel_12_analyzer_1_array_crystal_array_4_yheight = channel_12_analyzer_1_array_crystal_height;
#line 3224 "MACS_sample_kidney_box.instr"
  mccchannel_12_analyzer_1_array_crystal_array_4_zdepth = channel_12_analyzer_1_array_crystal_width;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_12_analyzer_1_array_crystal_array_4_xwidth2 = -1;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_12_analyzer_1_array_crystal_array_4_yheight2 = -1;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_12_analyzer_1_array_crystal_array_4_visualize = 1;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_12_analyzer_1_array_crystal_array_4_target_index = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_12_analyzer_1_array_crystal_array_4_target_x = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_12_analyzer_1_array_crystal_array_4_target_y = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_12_analyzer_1_array_crystal_array_4_target_z = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_12_analyzer_1_array_crystal_array_4_focus_aw = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_12_analyzer_1_array_crystal_array_4_focus_ah = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_12_analyzer_1_array_crystal_array_4_focus_xw = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_12_analyzer_1_array_crystal_array_4_focus_xh = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_12_analyzer_1_array_crystal_array_4_focus_r = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_12_analyzer_1_array_crystal_array_4_p_interact = 0;
#line 71 "MACS_sample_kidney_box.instr"
  if(0) strncpy(mccchannel_12_analyzer_1_array_crystal_array_4_mask_string, 0 ? 0 : "", 16384); else mccchannel_12_analyzer_1_array_crystal_array_4_mask_string[0]='\0';
#line 71 "MACS_sample_kidney_box.instr"
  if(0) strncpy(mccchannel_12_analyzer_1_array_crystal_array_4_mask_setting, 0 ? 0 : "", 16384); else mccchannel_12_analyzer_1_array_crystal_array_4_mask_setting[0]='\0';
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_12_analyzer_1_array_crystal_array_4_number_of_activations = 1;
#line 129269 "MACS_sample_kidney_box.c"

  SIG_MESSAGE("channel_12_analyzer_1_array_crystal_array_4 (Init:Place/Rotate)");
  rot_set_rotation(mctr1,
#line 3227 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 3227 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 3227 "MACS_sample_kidney_box.instr"
    (0 - RAD2DEG * channel_12_analyzer_1_array_theta [ 4 ])*DEG2RAD);
#line 129279 "MACS_sample_kidney_box.c"
  rot_mul(mctr1, mcrotachannel_12_analyzer_1_rotated, mcrotachannel_12_analyzer_1_array_crystal_array_4);
  rot_transpose(mcrotachannel_12_analyzer_1_array_crystal_array_3, mctr1);
  rot_mul(mcrotachannel_12_analyzer_1_array_crystal_array_4, mctr1, mcrotrchannel_12_analyzer_1_array_crystal_array_4);
  mctc1 = coords_set(
#line 3226 "MACS_sample_kidney_box.instr"
    0 + channel_12_analyzer_1_array_effective_radius_of_curvature * ( 1 - cos ( channel_12_analyzer_1_array_theta [ 4 ] ) ),
#line 3226 "MACS_sample_kidney_box.instr"
    0 + channel_12_analyzer_1_array_effective_radius_of_curvature * sin ( channel_12_analyzer_1_array_theta [ 4 ] ),
#line 3226 "MACS_sample_kidney_box.instr"
    0);
#line 129290 "MACS_sample_kidney_box.c"
  rot_transpose(mcrotachannel_12_analyzer_1_rotated, mctr1);
  mctc2 = rot_apply(mctr1, mctc1);
  mcposachannel_12_analyzer_1_array_crystal_array_4 = coords_add(mcposachannel_12_analyzer_1_rotated, mctc2);
  mctc1 = coords_sub(mcposachannel_12_analyzer_1_array_crystal_array_3, mcposachannel_12_analyzer_1_array_crystal_array_4);
  mcposrchannel_12_analyzer_1_array_crystal_array_4 = rot_apply(mcrotachannel_12_analyzer_1_array_crystal_array_4, mctc1);
  mcDEBUG_COMPONENT("channel_12_analyzer_1_array_crystal_array_4", mcposachannel_12_analyzer_1_array_crystal_array_4, mcrotachannel_12_analyzer_1_array_crystal_array_4)
  mccomp_posa[590] = mcposachannel_12_analyzer_1_array_crystal_array_4;
  mccomp_posr[590] = mcposrchannel_12_analyzer_1_array_crystal_array_4;
  mcNCounter[590]  = mcPCounter[590] = mcP2Counter[590] = 0;
  mcAbsorbProp[590]= 0;
    /* Component channel_12_analyzer_1_array_crystal_array_5. */
  /* Setting parameters for component channel_12_analyzer_1_array_crystal_array_5. */
  SIG_MESSAGE("channel_12_analyzer_1_array_crystal_array_5 (Init:SetPar)");
#line 3231 "MACS_sample_kidney_box.instr"
  if("PG_analyzer") strncpy(mccchannel_12_analyzer_1_array_crystal_array_5_material_string, "PG_analyzer" ? "PG_analyzer" : "", 16384); else mccchannel_12_analyzer_1_array_crystal_array_5_material_string[0]='\0';
#line 3231 "MACS_sample_kidney_box.instr"
  mccchannel_12_analyzer_1_array_crystal_array_5_priority = 1420.5;
#line 3230 "MACS_sample_kidney_box.instr"
  mccchannel_12_analyzer_1_array_crystal_array_5_xwidth = channel_12_analyzer_1_array_crystal_depth;
#line 3230 "MACS_sample_kidney_box.instr"
  mccchannel_12_analyzer_1_array_crystal_array_5_yheight = channel_12_analyzer_1_array_crystal_height;
#line 3230 "MACS_sample_kidney_box.instr"
  mccchannel_12_analyzer_1_array_crystal_array_5_zdepth = channel_12_analyzer_1_array_crystal_width;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_12_analyzer_1_array_crystal_array_5_xwidth2 = -1;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_12_analyzer_1_array_crystal_array_5_yheight2 = -1;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_12_analyzer_1_array_crystal_array_5_visualize = 1;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_12_analyzer_1_array_crystal_array_5_target_index = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_12_analyzer_1_array_crystal_array_5_target_x = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_12_analyzer_1_array_crystal_array_5_target_y = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_12_analyzer_1_array_crystal_array_5_target_z = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_12_analyzer_1_array_crystal_array_5_focus_aw = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_12_analyzer_1_array_crystal_array_5_focus_ah = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_12_analyzer_1_array_crystal_array_5_focus_xw = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_12_analyzer_1_array_crystal_array_5_focus_xh = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_12_analyzer_1_array_crystal_array_5_focus_r = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_12_analyzer_1_array_crystal_array_5_p_interact = 0;
#line 71 "MACS_sample_kidney_box.instr"
  if(0) strncpy(mccchannel_12_analyzer_1_array_crystal_array_5_mask_string, 0 ? 0 : "", 16384); else mccchannel_12_analyzer_1_array_crystal_array_5_mask_string[0]='\0';
#line 71 "MACS_sample_kidney_box.instr"
  if(0) strncpy(mccchannel_12_analyzer_1_array_crystal_array_5_mask_setting, 0 ? 0 : "", 16384); else mccchannel_12_analyzer_1_array_crystal_array_5_mask_setting[0]='\0';
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_12_analyzer_1_array_crystal_array_5_number_of_activations = 1;
#line 129346 "MACS_sample_kidney_box.c"

  SIG_MESSAGE("channel_12_analyzer_1_array_crystal_array_5 (Init:Place/Rotate)");
  rot_set_rotation(mctr1,
#line 3233 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 3233 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 3233 "MACS_sample_kidney_box.instr"
    (0 - RAD2DEG * channel_12_analyzer_1_array_theta [ 5 ])*DEG2RAD);
#line 129356 "MACS_sample_kidney_box.c"
  rot_mul(mctr1, mcrotachannel_12_analyzer_1_rotated, mcrotachannel_12_analyzer_1_array_crystal_array_5);
  rot_transpose(mcrotachannel_12_analyzer_1_array_crystal_array_4, mctr1);
  rot_mul(mcrotachannel_12_analyzer_1_array_crystal_array_5, mctr1, mcrotrchannel_12_analyzer_1_array_crystal_array_5);
  mctc1 = coords_set(
#line 3232 "MACS_sample_kidney_box.instr"
    0 + channel_12_analyzer_1_array_effective_radius_of_curvature * ( 1 - cos ( channel_12_analyzer_1_array_theta [ 5 ] ) ),
#line 3232 "MACS_sample_kidney_box.instr"
    0 + channel_12_analyzer_1_array_effective_radius_of_curvature * sin ( channel_12_analyzer_1_array_theta [ 5 ] ),
#line 3232 "MACS_sample_kidney_box.instr"
    0);
#line 129367 "MACS_sample_kidney_box.c"
  rot_transpose(mcrotachannel_12_analyzer_1_rotated, mctr1);
  mctc2 = rot_apply(mctr1, mctc1);
  mcposachannel_12_analyzer_1_array_crystal_array_5 = coords_add(mcposachannel_12_analyzer_1_rotated, mctc2);
  mctc1 = coords_sub(mcposachannel_12_analyzer_1_array_crystal_array_4, mcposachannel_12_analyzer_1_array_crystal_array_5);
  mcposrchannel_12_analyzer_1_array_crystal_array_5 = rot_apply(mcrotachannel_12_analyzer_1_array_crystal_array_5, mctc1);
  mcDEBUG_COMPONENT("channel_12_analyzer_1_array_crystal_array_5", mcposachannel_12_analyzer_1_array_crystal_array_5, mcrotachannel_12_analyzer_1_array_crystal_array_5)
  mccomp_posa[591] = mcposachannel_12_analyzer_1_array_crystal_array_5;
  mccomp_posr[591] = mcposrchannel_12_analyzer_1_array_crystal_array_5;
  mcNCounter[591]  = mcPCounter[591] = mcP2Counter[591] = 0;
  mcAbsorbProp[591]= 0;
    /* Component channel_12_analyzer_1_array_crystal_array_6. */
  /* Setting parameters for component channel_12_analyzer_1_array_crystal_array_6. */
  SIG_MESSAGE("channel_12_analyzer_1_array_crystal_array_6 (Init:SetPar)");
#line 3237 "MACS_sample_kidney_box.instr"
  if("PG_analyzer") strncpy(mccchannel_12_analyzer_1_array_crystal_array_6_material_string, "PG_analyzer" ? "PG_analyzer" : "", 16384); else mccchannel_12_analyzer_1_array_crystal_array_6_material_string[0]='\0';
#line 3237 "MACS_sample_kidney_box.instr"
  mccchannel_12_analyzer_1_array_crystal_array_6_priority = 1420.6;
#line 3236 "MACS_sample_kidney_box.instr"
  mccchannel_12_analyzer_1_array_crystal_array_6_xwidth = channel_12_analyzer_1_array_crystal_depth;
#line 3236 "MACS_sample_kidney_box.instr"
  mccchannel_12_analyzer_1_array_crystal_array_6_yheight = channel_12_analyzer_1_array_crystal_height;
#line 3236 "MACS_sample_kidney_box.instr"
  mccchannel_12_analyzer_1_array_crystal_array_6_zdepth = channel_12_analyzer_1_array_crystal_width;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_12_analyzer_1_array_crystal_array_6_xwidth2 = -1;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_12_analyzer_1_array_crystal_array_6_yheight2 = -1;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_12_analyzer_1_array_crystal_array_6_visualize = 1;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_12_analyzer_1_array_crystal_array_6_target_index = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_12_analyzer_1_array_crystal_array_6_target_x = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_12_analyzer_1_array_crystal_array_6_target_y = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_12_analyzer_1_array_crystal_array_6_target_z = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_12_analyzer_1_array_crystal_array_6_focus_aw = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_12_analyzer_1_array_crystal_array_6_focus_ah = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_12_analyzer_1_array_crystal_array_6_focus_xw = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_12_analyzer_1_array_crystal_array_6_focus_xh = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_12_analyzer_1_array_crystal_array_6_focus_r = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_12_analyzer_1_array_crystal_array_6_p_interact = 0;
#line 71 "MACS_sample_kidney_box.instr"
  if(0) strncpy(mccchannel_12_analyzer_1_array_crystal_array_6_mask_string, 0 ? 0 : "", 16384); else mccchannel_12_analyzer_1_array_crystal_array_6_mask_string[0]='\0';
#line 71 "MACS_sample_kidney_box.instr"
  if(0) strncpy(mccchannel_12_analyzer_1_array_crystal_array_6_mask_setting, 0 ? 0 : "", 16384); else mccchannel_12_analyzer_1_array_crystal_array_6_mask_setting[0]='\0';
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_12_analyzer_1_array_crystal_array_6_number_of_activations = 1;
#line 129423 "MACS_sample_kidney_box.c"

  SIG_MESSAGE("channel_12_analyzer_1_array_crystal_array_6 (Init:Place/Rotate)");
  rot_set_rotation(mctr1,
#line 3239 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 3239 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 3239 "MACS_sample_kidney_box.instr"
    (0 - RAD2DEG * channel_12_analyzer_1_array_theta [ 6 ])*DEG2RAD);
#line 129433 "MACS_sample_kidney_box.c"
  rot_mul(mctr1, mcrotachannel_12_analyzer_1_rotated, mcrotachannel_12_analyzer_1_array_crystal_array_6);
  rot_transpose(mcrotachannel_12_analyzer_1_array_crystal_array_5, mctr1);
  rot_mul(mcrotachannel_12_analyzer_1_array_crystal_array_6, mctr1, mcrotrchannel_12_analyzer_1_array_crystal_array_6);
  mctc1 = coords_set(
#line 3238 "MACS_sample_kidney_box.instr"
    0 + channel_12_analyzer_1_array_effective_radius_of_curvature * ( 1 - cos ( channel_12_analyzer_1_array_theta [ 6 ] ) ),
#line 3238 "MACS_sample_kidney_box.instr"
    0 + channel_12_analyzer_1_array_effective_radius_of_curvature * sin ( channel_12_analyzer_1_array_theta [ 6 ] ),
#line 3238 "MACS_sample_kidney_box.instr"
    0);
#line 129444 "MACS_sample_kidney_box.c"
  rot_transpose(mcrotachannel_12_analyzer_1_rotated, mctr1);
  mctc2 = rot_apply(mctr1, mctc1);
  mcposachannel_12_analyzer_1_array_crystal_array_6 = coords_add(mcposachannel_12_analyzer_1_rotated, mctc2);
  mctc1 = coords_sub(mcposachannel_12_analyzer_1_array_crystal_array_5, mcposachannel_12_analyzer_1_array_crystal_array_6);
  mcposrchannel_12_analyzer_1_array_crystal_array_6 = rot_apply(mcrotachannel_12_analyzer_1_array_crystal_array_6, mctc1);
  mcDEBUG_COMPONENT("channel_12_analyzer_1_array_crystal_array_6", mcposachannel_12_analyzer_1_array_crystal_array_6, mcrotachannel_12_analyzer_1_array_crystal_array_6)
  mccomp_posa[592] = mcposachannel_12_analyzer_1_array_crystal_array_6;
  mccomp_posr[592] = mcposrchannel_12_analyzer_1_array_crystal_array_6;
  mcNCounter[592]  = mcPCounter[592] = mcP2Counter[592] = 0;
  mcAbsorbProp[592]= 0;
    /* Component channel_12_analyzer_1_array_crystal_array_7. */
  /* Setting parameters for component channel_12_analyzer_1_array_crystal_array_7. */
  SIG_MESSAGE("channel_12_analyzer_1_array_crystal_array_7 (Init:SetPar)");
#line 3243 "MACS_sample_kidney_box.instr"
  if("PG_analyzer") strncpy(mccchannel_12_analyzer_1_array_crystal_array_7_material_string, "PG_analyzer" ? "PG_analyzer" : "", 16384); else mccchannel_12_analyzer_1_array_crystal_array_7_material_string[0]='\0';
#line 3243 "MACS_sample_kidney_box.instr"
  mccchannel_12_analyzer_1_array_crystal_array_7_priority = 1420.7;
#line 3242 "MACS_sample_kidney_box.instr"
  mccchannel_12_analyzer_1_array_crystal_array_7_xwidth = channel_12_analyzer_1_array_crystal_depth;
#line 3242 "MACS_sample_kidney_box.instr"
  mccchannel_12_analyzer_1_array_crystal_array_7_yheight = channel_12_analyzer_1_array_crystal_height;
#line 3242 "MACS_sample_kidney_box.instr"
  mccchannel_12_analyzer_1_array_crystal_array_7_zdepth = channel_12_analyzer_1_array_crystal_width;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_12_analyzer_1_array_crystal_array_7_xwidth2 = -1;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_12_analyzer_1_array_crystal_array_7_yheight2 = -1;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_12_analyzer_1_array_crystal_array_7_visualize = 1;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_12_analyzer_1_array_crystal_array_7_target_index = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_12_analyzer_1_array_crystal_array_7_target_x = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_12_analyzer_1_array_crystal_array_7_target_y = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_12_analyzer_1_array_crystal_array_7_target_z = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_12_analyzer_1_array_crystal_array_7_focus_aw = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_12_analyzer_1_array_crystal_array_7_focus_ah = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_12_analyzer_1_array_crystal_array_7_focus_xw = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_12_analyzer_1_array_crystal_array_7_focus_xh = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_12_analyzer_1_array_crystal_array_7_focus_r = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_12_analyzer_1_array_crystal_array_7_p_interact = 0;
#line 71 "MACS_sample_kidney_box.instr"
  if(0) strncpy(mccchannel_12_analyzer_1_array_crystal_array_7_mask_string, 0 ? 0 : "", 16384); else mccchannel_12_analyzer_1_array_crystal_array_7_mask_string[0]='\0';
#line 71 "MACS_sample_kidney_box.instr"
  if(0) strncpy(mccchannel_12_analyzer_1_array_crystal_array_7_mask_setting, 0 ? 0 : "", 16384); else mccchannel_12_analyzer_1_array_crystal_array_7_mask_setting[0]='\0';
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_12_analyzer_1_array_crystal_array_7_number_of_activations = 1;
#line 129500 "MACS_sample_kidney_box.c"

  SIG_MESSAGE("channel_12_analyzer_1_array_crystal_array_7 (Init:Place/Rotate)");
  rot_set_rotation(mctr1,
#line 3245 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 3245 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 3245 "MACS_sample_kidney_box.instr"
    (0 - RAD2DEG * channel_12_analyzer_1_array_theta [ 7 ])*DEG2RAD);
#line 129510 "MACS_sample_kidney_box.c"
  rot_mul(mctr1, mcrotachannel_12_analyzer_1_rotated, mcrotachannel_12_analyzer_1_array_crystal_array_7);
  rot_transpose(mcrotachannel_12_analyzer_1_array_crystal_array_6, mctr1);
  rot_mul(mcrotachannel_12_analyzer_1_array_crystal_array_7, mctr1, mcrotrchannel_12_analyzer_1_array_crystal_array_7);
  mctc1 = coords_set(
#line 3244 "MACS_sample_kidney_box.instr"
    0 + channel_12_analyzer_1_array_effective_radius_of_curvature * ( 1 - cos ( channel_12_analyzer_1_array_theta [ 7 ] ) ),
#line 3244 "MACS_sample_kidney_box.instr"
    0 + channel_12_analyzer_1_array_effective_radius_of_curvature * sin ( channel_12_analyzer_1_array_theta [ 7 ] ),
#line 3244 "MACS_sample_kidney_box.instr"
    0);
#line 129521 "MACS_sample_kidney_box.c"
  rot_transpose(mcrotachannel_12_analyzer_1_rotated, mctr1);
  mctc2 = rot_apply(mctr1, mctc1);
  mcposachannel_12_analyzer_1_array_crystal_array_7 = coords_add(mcposachannel_12_analyzer_1_rotated, mctc2);
  mctc1 = coords_sub(mcposachannel_12_analyzer_1_array_crystal_array_6, mcposachannel_12_analyzer_1_array_crystal_array_7);
  mcposrchannel_12_analyzer_1_array_crystal_array_7 = rot_apply(mcrotachannel_12_analyzer_1_array_crystal_array_7, mctc1);
  mcDEBUG_COMPONENT("channel_12_analyzer_1_array_crystal_array_7", mcposachannel_12_analyzer_1_array_crystal_array_7, mcrotachannel_12_analyzer_1_array_crystal_array_7)
  mccomp_posa[593] = mcposachannel_12_analyzer_1_array_crystal_array_7;
  mccomp_posr[593] = mcposrchannel_12_analyzer_1_array_crystal_array_7;
  mcNCounter[593]  = mcPCounter[593] = mcP2Counter[593] = 0;
  mcAbsorbProp[593]= 0;
    /* Component channel_12_analyzer_1_array_crystal_array_8. */
  /* Setting parameters for component channel_12_analyzer_1_array_crystal_array_8. */
  SIG_MESSAGE("channel_12_analyzer_1_array_crystal_array_8 (Init:SetPar)");
#line 3249 "MACS_sample_kidney_box.instr"
  if("PG_analyzer") strncpy(mccchannel_12_analyzer_1_array_crystal_array_8_material_string, "PG_analyzer" ? "PG_analyzer" : "", 16384); else mccchannel_12_analyzer_1_array_crystal_array_8_material_string[0]='\0';
#line 3249 "MACS_sample_kidney_box.instr"
  mccchannel_12_analyzer_1_array_crystal_array_8_priority = 1420.8;
#line 3248 "MACS_sample_kidney_box.instr"
  mccchannel_12_analyzer_1_array_crystal_array_8_xwidth = channel_12_analyzer_1_array_crystal_depth;
#line 3248 "MACS_sample_kidney_box.instr"
  mccchannel_12_analyzer_1_array_crystal_array_8_yheight = channel_12_analyzer_1_array_crystal_height;
#line 3248 "MACS_sample_kidney_box.instr"
  mccchannel_12_analyzer_1_array_crystal_array_8_zdepth = channel_12_analyzer_1_array_crystal_width;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_12_analyzer_1_array_crystal_array_8_xwidth2 = -1;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_12_analyzer_1_array_crystal_array_8_yheight2 = -1;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_12_analyzer_1_array_crystal_array_8_visualize = 1;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_12_analyzer_1_array_crystal_array_8_target_index = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_12_analyzer_1_array_crystal_array_8_target_x = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_12_analyzer_1_array_crystal_array_8_target_y = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_12_analyzer_1_array_crystal_array_8_target_z = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_12_analyzer_1_array_crystal_array_8_focus_aw = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_12_analyzer_1_array_crystal_array_8_focus_ah = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_12_analyzer_1_array_crystal_array_8_focus_xw = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_12_analyzer_1_array_crystal_array_8_focus_xh = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_12_analyzer_1_array_crystal_array_8_focus_r = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_12_analyzer_1_array_crystal_array_8_p_interact = 0;
#line 71 "MACS_sample_kidney_box.instr"
  if(0) strncpy(mccchannel_12_analyzer_1_array_crystal_array_8_mask_string, 0 ? 0 : "", 16384); else mccchannel_12_analyzer_1_array_crystal_array_8_mask_string[0]='\0';
#line 71 "MACS_sample_kidney_box.instr"
  if(0) strncpy(mccchannel_12_analyzer_1_array_crystal_array_8_mask_setting, 0 ? 0 : "", 16384); else mccchannel_12_analyzer_1_array_crystal_array_8_mask_setting[0]='\0';
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_12_analyzer_1_array_crystal_array_8_number_of_activations = 1;
#line 129577 "MACS_sample_kidney_box.c"

  SIG_MESSAGE("channel_12_analyzer_1_array_crystal_array_8 (Init:Place/Rotate)");
  rot_set_rotation(mctr1,
#line 3251 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 3251 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 3251 "MACS_sample_kidney_box.instr"
    (0 - RAD2DEG * channel_12_analyzer_1_array_theta [ 8 ])*DEG2RAD);
#line 129587 "MACS_sample_kidney_box.c"
  rot_mul(mctr1, mcrotachannel_12_analyzer_1_rotated, mcrotachannel_12_analyzer_1_array_crystal_array_8);
  rot_transpose(mcrotachannel_12_analyzer_1_array_crystal_array_7, mctr1);
  rot_mul(mcrotachannel_12_analyzer_1_array_crystal_array_8, mctr1, mcrotrchannel_12_analyzer_1_array_crystal_array_8);
  mctc1 = coords_set(
#line 3250 "MACS_sample_kidney_box.instr"
    0 + channel_12_analyzer_1_array_effective_radius_of_curvature * ( 1 - cos ( channel_12_analyzer_1_array_theta [ 8 ] ) ),
#line 3250 "MACS_sample_kidney_box.instr"
    0 + channel_12_analyzer_1_array_effective_radius_of_curvature * sin ( channel_12_analyzer_1_array_theta [ 8 ] ),
#line 3250 "MACS_sample_kidney_box.instr"
    0);
#line 129598 "MACS_sample_kidney_box.c"
  rot_transpose(mcrotachannel_12_analyzer_1_rotated, mctr1);
  mctc2 = rot_apply(mctr1, mctc1);
  mcposachannel_12_analyzer_1_array_crystal_array_8 = coords_add(mcposachannel_12_analyzer_1_rotated, mctc2);
  mctc1 = coords_sub(mcposachannel_12_analyzer_1_array_crystal_array_7, mcposachannel_12_analyzer_1_array_crystal_array_8);
  mcposrchannel_12_analyzer_1_array_crystal_array_8 = rot_apply(mcrotachannel_12_analyzer_1_array_crystal_array_8, mctc1);
  mcDEBUG_COMPONENT("channel_12_analyzer_1_array_crystal_array_8", mcposachannel_12_analyzer_1_array_crystal_array_8, mcrotachannel_12_analyzer_1_array_crystal_array_8)
  mccomp_posa[594] = mcposachannel_12_analyzer_1_array_crystal_array_8;
  mccomp_posr[594] = mcposrchannel_12_analyzer_1_array_crystal_array_8;
  mcNCounter[594]  = mcPCounter[594] = mcP2Counter[594] = 0;
  mcAbsorbProp[594]= 0;
    /* Component channel_12_analyzer_2_center. */
  /* Setting parameters for component channel_12_analyzer_2_center. */
  SIG_MESSAGE("channel_12_analyzer_2_center (Init:SetPar)");

  SIG_MESSAGE("channel_12_analyzer_2_center (Init:Place/Rotate)");
  rot_set_rotation(mctr1,
    (0.0)*DEG2RAD,
    (0.0)*DEG2RAD,
    (0.0)*DEG2RAD);
#line 129618 "MACS_sample_kidney_box.c"
  rot_mul(mctr1, mcrotachannel_12_analyzer_1_center, mcrotachannel_12_analyzer_2_center);
  rot_transpose(mcrotachannel_12_analyzer_1_array_crystal_array_8, mctr1);
  rot_mul(mcrotachannel_12_analyzer_2_center, mctr1, mcrotrchannel_12_analyzer_2_center);
  mctc1 = coords_set(
#line 3255 "MACS_sample_kidney_box.instr"
    - analyzer_seperation,
#line 3255 "MACS_sample_kidney_box.instr"
    0,
#line 3255 "MACS_sample_kidney_box.instr"
    0);
#line 129629 "MACS_sample_kidney_box.c"
  rot_transpose(mcrotachannel_12_analyzer_1_center, mctr1);
  mctc2 = rot_apply(mctr1, mctc1);
  mcposachannel_12_analyzer_2_center = coords_add(mcposachannel_12_analyzer_1_center, mctc2);
  mctc1 = coords_sub(mcposachannel_12_analyzer_1_array_crystal_array_8, mcposachannel_12_analyzer_2_center);
  mcposrchannel_12_analyzer_2_center = rot_apply(mcrotachannel_12_analyzer_2_center, mctc1);
  mcDEBUG_COMPONENT("channel_12_analyzer_2_center", mcposachannel_12_analyzer_2_center, mcrotachannel_12_analyzer_2_center)
  mccomp_posa[595] = mcposachannel_12_analyzer_2_center;
  mccomp_posr[595] = mcposrchannel_12_analyzer_2_center;
  mcNCounter[595]  = mcPCounter[595] = mcP2Counter[595] = 0;
  mcAbsorbProp[595]= 0;
    /* Component channel_12_analyzer_2_rotated. */
  /* Setting parameters for component channel_12_analyzer_2_rotated. */
  SIG_MESSAGE("channel_12_analyzer_2_rotated (Init:SetPar)");

  SIG_MESSAGE("channel_12_analyzer_2_rotated (Init:Place/Rotate)");
  rot_set_rotation(mctr1,
#line 3259 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 3259 "MACS_sample_kidney_box.instr"
    (- analyzer_theta [ 12 ])*DEG2RAD,
#line 3259 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD);
#line 129652 "MACS_sample_kidney_box.c"
  rot_mul(mctr1, mcrotachannel_12_analyzer_2_center, mcrotachannel_12_analyzer_2_rotated);
  rot_transpose(mcrotachannel_12_analyzer_2_center, mctr1);
  rot_mul(mcrotachannel_12_analyzer_2_rotated, mctr1, mcrotrchannel_12_analyzer_2_rotated);
  mctc1 = coords_set(
#line 3258 "MACS_sample_kidney_box.instr"
    0,
#line 3258 "MACS_sample_kidney_box.instr"
    0,
#line 3258 "MACS_sample_kidney_box.instr"
    0.5 * analyzer_seperation / tan ( analyzer_2theta [ 12 ] * DEG2RAD ));
#line 129663 "MACS_sample_kidney_box.c"
  rot_transpose(mcrotachannel_12_analyzer_2_center, mctr1);
  mctc2 = rot_apply(mctr1, mctc1);
  mcposachannel_12_analyzer_2_rotated = coords_add(mcposachannel_12_analyzer_2_center, mctc2);
  mctc1 = coords_sub(mcposachannel_12_analyzer_2_center, mcposachannel_12_analyzer_2_rotated);
  mcposrchannel_12_analyzer_2_rotated = rot_apply(mcrotachannel_12_analyzer_2_rotated, mctc1);
  mcDEBUG_COMPONENT("channel_12_analyzer_2_rotated", mcposachannel_12_analyzer_2_rotated, mcrotachannel_12_analyzer_2_rotated)
  mccomp_posa[596] = mcposachannel_12_analyzer_2_rotated;
  mccomp_posr[596] = mcposrchannel_12_analyzer_2_rotated;
  mcNCounter[596]  = mcPCounter[596] = mcP2Counter[596] = 0;
  mcAbsorbProp[596]= 0;
    /* Component channel_12_analyzer_2_array_crystal_array_0. */
  /* Setting parameters for component channel_12_analyzer_2_array_crystal_array_0. */
  SIG_MESSAGE("channel_12_analyzer_2_array_crystal_array_0 (Init:SetPar)");
#line 3263 "MACS_sample_kidney_box.instr"
  if("PG_analyzer") strncpy(mccchannel_12_analyzer_2_array_crystal_array_0_material_string, "PG_analyzer" ? "PG_analyzer" : "", 16384); else mccchannel_12_analyzer_2_array_crystal_array_0_material_string[0]='\0';
#line 3263 "MACS_sample_kidney_box.instr"
  mccchannel_12_analyzer_2_array_crystal_array_0_priority = 1421.0;
#line 3262 "MACS_sample_kidney_box.instr"
  mccchannel_12_analyzer_2_array_crystal_array_0_xwidth = channel_12_analyzer_2_array_crystal_depth;
#line 3262 "MACS_sample_kidney_box.instr"
  mccchannel_12_analyzer_2_array_crystal_array_0_yheight = channel_12_analyzer_2_array_crystal_height;
#line 3262 "MACS_sample_kidney_box.instr"
  mccchannel_12_analyzer_2_array_crystal_array_0_zdepth = channel_12_analyzer_2_array_crystal_width;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_12_analyzer_2_array_crystal_array_0_xwidth2 = -1;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_12_analyzer_2_array_crystal_array_0_yheight2 = -1;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_12_analyzer_2_array_crystal_array_0_visualize = 1;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_12_analyzer_2_array_crystal_array_0_target_index = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_12_analyzer_2_array_crystal_array_0_target_x = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_12_analyzer_2_array_crystal_array_0_target_y = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_12_analyzer_2_array_crystal_array_0_target_z = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_12_analyzer_2_array_crystal_array_0_focus_aw = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_12_analyzer_2_array_crystal_array_0_focus_ah = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_12_analyzer_2_array_crystal_array_0_focus_xw = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_12_analyzer_2_array_crystal_array_0_focus_xh = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_12_analyzer_2_array_crystal_array_0_focus_r = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_12_analyzer_2_array_crystal_array_0_p_interact = 0;
#line 71 "MACS_sample_kidney_box.instr"
  if(0) strncpy(mccchannel_12_analyzer_2_array_crystal_array_0_mask_string, 0 ? 0 : "", 16384); else mccchannel_12_analyzer_2_array_crystal_array_0_mask_string[0]='\0';
#line 71 "MACS_sample_kidney_box.instr"
  if(0) strncpy(mccchannel_12_analyzer_2_array_crystal_array_0_mask_setting, 0 ? 0 : "", 16384); else mccchannel_12_analyzer_2_array_crystal_array_0_mask_setting[0]='\0';
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_12_analyzer_2_array_crystal_array_0_number_of_activations = 1;
#line 129719 "MACS_sample_kidney_box.c"

  SIG_MESSAGE("channel_12_analyzer_2_array_crystal_array_0 (Init:Place/Rotate)");
  rot_set_rotation(mctr1,
#line 3265 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 3265 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 3265 "MACS_sample_kidney_box.instr"
    (0 - RAD2DEG * channel_12_analyzer_2_array_theta [ 0 ])*DEG2RAD);
#line 129729 "MACS_sample_kidney_box.c"
  rot_mul(mctr1, mcrotachannel_12_analyzer_2_rotated, mcrotachannel_12_analyzer_2_array_crystal_array_0);
  rot_transpose(mcrotachannel_12_analyzer_2_rotated, mctr1);
  rot_mul(mcrotachannel_12_analyzer_2_array_crystal_array_0, mctr1, mcrotrchannel_12_analyzer_2_array_crystal_array_0);
  mctc1 = coords_set(
#line 3264 "MACS_sample_kidney_box.instr"
    0 + channel_12_analyzer_2_array_effective_radius_of_curvature * ( 1 - cos ( channel_12_analyzer_2_array_theta [ 0 ] ) ),
#line 3264 "MACS_sample_kidney_box.instr"
    0 + channel_12_analyzer_2_array_effective_radius_of_curvature * sin ( channel_12_analyzer_2_array_theta [ 0 ] ),
#line 3264 "MACS_sample_kidney_box.instr"
    0);
#line 129740 "MACS_sample_kidney_box.c"
  rot_transpose(mcrotachannel_12_analyzer_2_rotated, mctr1);
  mctc2 = rot_apply(mctr1, mctc1);
  mcposachannel_12_analyzer_2_array_crystal_array_0 = coords_add(mcposachannel_12_analyzer_2_rotated, mctc2);
  mctc1 = coords_sub(mcposachannel_12_analyzer_2_rotated, mcposachannel_12_analyzer_2_array_crystal_array_0);
  mcposrchannel_12_analyzer_2_array_crystal_array_0 = rot_apply(mcrotachannel_12_analyzer_2_array_crystal_array_0, mctc1);
  mcDEBUG_COMPONENT("channel_12_analyzer_2_array_crystal_array_0", mcposachannel_12_analyzer_2_array_crystal_array_0, mcrotachannel_12_analyzer_2_array_crystal_array_0)
  mccomp_posa[597] = mcposachannel_12_analyzer_2_array_crystal_array_0;
  mccomp_posr[597] = mcposrchannel_12_analyzer_2_array_crystal_array_0;
  mcNCounter[597]  = mcPCounter[597] = mcP2Counter[597] = 0;
  mcAbsorbProp[597]= 0;
    /* Component channel_12_analyzer_2_array_crystal_array_1. */
  /* Setting parameters for component channel_12_analyzer_2_array_crystal_array_1. */
  SIG_MESSAGE("channel_12_analyzer_2_array_crystal_array_1 (Init:SetPar)");
#line 3269 "MACS_sample_kidney_box.instr"
  if("PG_analyzer") strncpy(mccchannel_12_analyzer_2_array_crystal_array_1_material_string, "PG_analyzer" ? "PG_analyzer" : "", 16384); else mccchannel_12_analyzer_2_array_crystal_array_1_material_string[0]='\0';
#line 3269 "MACS_sample_kidney_box.instr"
  mccchannel_12_analyzer_2_array_crystal_array_1_priority = 1421.1;
#line 3268 "MACS_sample_kidney_box.instr"
  mccchannel_12_analyzer_2_array_crystal_array_1_xwidth = channel_12_analyzer_2_array_crystal_depth;
#line 3268 "MACS_sample_kidney_box.instr"
  mccchannel_12_analyzer_2_array_crystal_array_1_yheight = channel_12_analyzer_2_array_crystal_height;
#line 3268 "MACS_sample_kidney_box.instr"
  mccchannel_12_analyzer_2_array_crystal_array_1_zdepth = channel_12_analyzer_2_array_crystal_width;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_12_analyzer_2_array_crystal_array_1_xwidth2 = -1;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_12_analyzer_2_array_crystal_array_1_yheight2 = -1;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_12_analyzer_2_array_crystal_array_1_visualize = 1;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_12_analyzer_2_array_crystal_array_1_target_index = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_12_analyzer_2_array_crystal_array_1_target_x = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_12_analyzer_2_array_crystal_array_1_target_y = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_12_analyzer_2_array_crystal_array_1_target_z = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_12_analyzer_2_array_crystal_array_1_focus_aw = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_12_analyzer_2_array_crystal_array_1_focus_ah = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_12_analyzer_2_array_crystal_array_1_focus_xw = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_12_analyzer_2_array_crystal_array_1_focus_xh = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_12_analyzer_2_array_crystal_array_1_focus_r = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_12_analyzer_2_array_crystal_array_1_p_interact = 0;
#line 71 "MACS_sample_kidney_box.instr"
  if(0) strncpy(mccchannel_12_analyzer_2_array_crystal_array_1_mask_string, 0 ? 0 : "", 16384); else mccchannel_12_analyzer_2_array_crystal_array_1_mask_string[0]='\0';
#line 71 "MACS_sample_kidney_box.instr"
  if(0) strncpy(mccchannel_12_analyzer_2_array_crystal_array_1_mask_setting, 0 ? 0 : "", 16384); else mccchannel_12_analyzer_2_array_crystal_array_1_mask_setting[0]='\0';
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_12_analyzer_2_array_crystal_array_1_number_of_activations = 1;
#line 129796 "MACS_sample_kidney_box.c"

  SIG_MESSAGE("channel_12_analyzer_2_array_crystal_array_1 (Init:Place/Rotate)");
  rot_set_rotation(mctr1,
#line 3271 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 3271 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 3271 "MACS_sample_kidney_box.instr"
    (0 - RAD2DEG * channel_12_analyzer_2_array_theta [ 1 ])*DEG2RAD);
#line 129806 "MACS_sample_kidney_box.c"
  rot_mul(mctr1, mcrotachannel_12_analyzer_2_rotated, mcrotachannel_12_analyzer_2_array_crystal_array_1);
  rot_transpose(mcrotachannel_12_analyzer_2_array_crystal_array_0, mctr1);
  rot_mul(mcrotachannel_12_analyzer_2_array_crystal_array_1, mctr1, mcrotrchannel_12_analyzer_2_array_crystal_array_1);
  mctc1 = coords_set(
#line 3270 "MACS_sample_kidney_box.instr"
    0 + channel_12_analyzer_2_array_effective_radius_of_curvature * ( 1 - cos ( channel_12_analyzer_2_array_theta [ 1 ] ) ),
#line 3270 "MACS_sample_kidney_box.instr"
    0 + channel_12_analyzer_2_array_effective_radius_of_curvature * sin ( channel_12_analyzer_2_array_theta [ 1 ] ),
#line 3270 "MACS_sample_kidney_box.instr"
    0);
#line 129817 "MACS_sample_kidney_box.c"
  rot_transpose(mcrotachannel_12_analyzer_2_rotated, mctr1);
  mctc2 = rot_apply(mctr1, mctc1);
  mcposachannel_12_analyzer_2_array_crystal_array_1 = coords_add(mcposachannel_12_analyzer_2_rotated, mctc2);
  mctc1 = coords_sub(mcposachannel_12_analyzer_2_array_crystal_array_0, mcposachannel_12_analyzer_2_array_crystal_array_1);
  mcposrchannel_12_analyzer_2_array_crystal_array_1 = rot_apply(mcrotachannel_12_analyzer_2_array_crystal_array_1, mctc1);
  mcDEBUG_COMPONENT("channel_12_analyzer_2_array_crystal_array_1", mcposachannel_12_analyzer_2_array_crystal_array_1, mcrotachannel_12_analyzer_2_array_crystal_array_1)
  mccomp_posa[598] = mcposachannel_12_analyzer_2_array_crystal_array_1;
  mccomp_posr[598] = mcposrchannel_12_analyzer_2_array_crystal_array_1;
  mcNCounter[598]  = mcPCounter[598] = mcP2Counter[598] = 0;
  mcAbsorbProp[598]= 0;
    /* Component channel_12_analyzer_2_array_crystal_array_2. */
  /* Setting parameters for component channel_12_analyzer_2_array_crystal_array_2. */
  SIG_MESSAGE("channel_12_analyzer_2_array_crystal_array_2 (Init:SetPar)");
#line 3275 "MACS_sample_kidney_box.instr"
  if("PG_analyzer") strncpy(mccchannel_12_analyzer_2_array_crystal_array_2_material_string, "PG_analyzer" ? "PG_analyzer" : "", 16384); else mccchannel_12_analyzer_2_array_crystal_array_2_material_string[0]='\0';
#line 3275 "MACS_sample_kidney_box.instr"
  mccchannel_12_analyzer_2_array_crystal_array_2_priority = 1421.2;
#line 3274 "MACS_sample_kidney_box.instr"
  mccchannel_12_analyzer_2_array_crystal_array_2_xwidth = channel_12_analyzer_2_array_crystal_depth;
#line 3274 "MACS_sample_kidney_box.instr"
  mccchannel_12_analyzer_2_array_crystal_array_2_yheight = channel_12_analyzer_2_array_crystal_height;
#line 3274 "MACS_sample_kidney_box.instr"
  mccchannel_12_analyzer_2_array_crystal_array_2_zdepth = channel_12_analyzer_2_array_crystal_width;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_12_analyzer_2_array_crystal_array_2_xwidth2 = -1;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_12_analyzer_2_array_crystal_array_2_yheight2 = -1;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_12_analyzer_2_array_crystal_array_2_visualize = 1;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_12_analyzer_2_array_crystal_array_2_target_index = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_12_analyzer_2_array_crystal_array_2_target_x = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_12_analyzer_2_array_crystal_array_2_target_y = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_12_analyzer_2_array_crystal_array_2_target_z = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_12_analyzer_2_array_crystal_array_2_focus_aw = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_12_analyzer_2_array_crystal_array_2_focus_ah = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_12_analyzer_2_array_crystal_array_2_focus_xw = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_12_analyzer_2_array_crystal_array_2_focus_xh = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_12_analyzer_2_array_crystal_array_2_focus_r = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_12_analyzer_2_array_crystal_array_2_p_interact = 0;
#line 71 "MACS_sample_kidney_box.instr"
  if(0) strncpy(mccchannel_12_analyzer_2_array_crystal_array_2_mask_string, 0 ? 0 : "", 16384); else mccchannel_12_analyzer_2_array_crystal_array_2_mask_string[0]='\0';
#line 71 "MACS_sample_kidney_box.instr"
  if(0) strncpy(mccchannel_12_analyzer_2_array_crystal_array_2_mask_setting, 0 ? 0 : "", 16384); else mccchannel_12_analyzer_2_array_crystal_array_2_mask_setting[0]='\0';
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_12_analyzer_2_array_crystal_array_2_number_of_activations = 1;
#line 129873 "MACS_sample_kidney_box.c"

  SIG_MESSAGE("channel_12_analyzer_2_array_crystal_array_2 (Init:Place/Rotate)");
  rot_set_rotation(mctr1,
#line 3277 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 3277 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 3277 "MACS_sample_kidney_box.instr"
    (0 - RAD2DEG * channel_12_analyzer_2_array_theta [ 2 ])*DEG2RAD);
#line 129883 "MACS_sample_kidney_box.c"
  rot_mul(mctr1, mcrotachannel_12_analyzer_2_rotated, mcrotachannel_12_analyzer_2_array_crystal_array_2);
  rot_transpose(mcrotachannel_12_analyzer_2_array_crystal_array_1, mctr1);
  rot_mul(mcrotachannel_12_analyzer_2_array_crystal_array_2, mctr1, mcrotrchannel_12_analyzer_2_array_crystal_array_2);
  mctc1 = coords_set(
#line 3276 "MACS_sample_kidney_box.instr"
    0 + channel_12_analyzer_2_array_effective_radius_of_curvature * ( 1 - cos ( channel_12_analyzer_2_array_theta [ 2 ] ) ),
#line 3276 "MACS_sample_kidney_box.instr"
    0 + channel_12_analyzer_2_array_effective_radius_of_curvature * sin ( channel_12_analyzer_2_array_theta [ 2 ] ),
#line 3276 "MACS_sample_kidney_box.instr"
    0);
#line 129894 "MACS_sample_kidney_box.c"
  rot_transpose(mcrotachannel_12_analyzer_2_rotated, mctr1);
  mctc2 = rot_apply(mctr1, mctc1);
  mcposachannel_12_analyzer_2_array_crystal_array_2 = coords_add(mcposachannel_12_analyzer_2_rotated, mctc2);
  mctc1 = coords_sub(mcposachannel_12_analyzer_2_array_crystal_array_1, mcposachannel_12_analyzer_2_array_crystal_array_2);
  mcposrchannel_12_analyzer_2_array_crystal_array_2 = rot_apply(mcrotachannel_12_analyzer_2_array_crystal_array_2, mctc1);
  mcDEBUG_COMPONENT("channel_12_analyzer_2_array_crystal_array_2", mcposachannel_12_analyzer_2_array_crystal_array_2, mcrotachannel_12_analyzer_2_array_crystal_array_2)
  mccomp_posa[599] = mcposachannel_12_analyzer_2_array_crystal_array_2;
  mccomp_posr[599] = mcposrchannel_12_analyzer_2_array_crystal_array_2;
  mcNCounter[599]  = mcPCounter[599] = mcP2Counter[599] = 0;
  mcAbsorbProp[599]= 0;
    /* Component channel_12_analyzer_2_array_crystal_array_3. */
  /* Setting parameters for component channel_12_analyzer_2_array_crystal_array_3. */
  SIG_MESSAGE("channel_12_analyzer_2_array_crystal_array_3 (Init:SetPar)");
#line 3281 "MACS_sample_kidney_box.instr"
  if("PG_analyzer") strncpy(mccchannel_12_analyzer_2_array_crystal_array_3_material_string, "PG_analyzer" ? "PG_analyzer" : "", 16384); else mccchannel_12_analyzer_2_array_crystal_array_3_material_string[0]='\0';
#line 3281 "MACS_sample_kidney_box.instr"
  mccchannel_12_analyzer_2_array_crystal_array_3_priority = 1421.3;
#line 3280 "MACS_sample_kidney_box.instr"
  mccchannel_12_analyzer_2_array_crystal_array_3_xwidth = channel_12_analyzer_2_array_crystal_depth;
#line 3280 "MACS_sample_kidney_box.instr"
  mccchannel_12_analyzer_2_array_crystal_array_3_yheight = channel_12_analyzer_2_array_crystal_height;
#line 3280 "MACS_sample_kidney_box.instr"
  mccchannel_12_analyzer_2_array_crystal_array_3_zdepth = channel_12_analyzer_2_array_crystal_width;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_12_analyzer_2_array_crystal_array_3_xwidth2 = -1;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_12_analyzer_2_array_crystal_array_3_yheight2 = -1;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_12_analyzer_2_array_crystal_array_3_visualize = 1;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_12_analyzer_2_array_crystal_array_3_target_index = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_12_analyzer_2_array_crystal_array_3_target_x = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_12_analyzer_2_array_crystal_array_3_target_y = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_12_analyzer_2_array_crystal_array_3_target_z = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_12_analyzer_2_array_crystal_array_3_focus_aw = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_12_analyzer_2_array_crystal_array_3_focus_ah = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_12_analyzer_2_array_crystal_array_3_focus_xw = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_12_analyzer_2_array_crystal_array_3_focus_xh = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_12_analyzer_2_array_crystal_array_3_focus_r = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_12_analyzer_2_array_crystal_array_3_p_interact = 0;
#line 71 "MACS_sample_kidney_box.instr"
  if(0) strncpy(mccchannel_12_analyzer_2_array_crystal_array_3_mask_string, 0 ? 0 : "", 16384); else mccchannel_12_analyzer_2_array_crystal_array_3_mask_string[0]='\0';
#line 71 "MACS_sample_kidney_box.instr"
  if(0) strncpy(mccchannel_12_analyzer_2_array_crystal_array_3_mask_setting, 0 ? 0 : "", 16384); else mccchannel_12_analyzer_2_array_crystal_array_3_mask_setting[0]='\0';
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_12_analyzer_2_array_crystal_array_3_number_of_activations = 1;
#line 129950 "MACS_sample_kidney_box.c"

  SIG_MESSAGE("channel_12_analyzer_2_array_crystal_array_3 (Init:Place/Rotate)");
  rot_set_rotation(mctr1,
#line 3283 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 3283 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 3283 "MACS_sample_kidney_box.instr"
    (0 - RAD2DEG * channel_12_analyzer_2_array_theta [ 3 ])*DEG2RAD);
#line 129960 "MACS_sample_kidney_box.c"
  rot_mul(mctr1, mcrotachannel_12_analyzer_2_rotated, mcrotachannel_12_analyzer_2_array_crystal_array_3);
  rot_transpose(mcrotachannel_12_analyzer_2_array_crystal_array_2, mctr1);
  rot_mul(mcrotachannel_12_analyzer_2_array_crystal_array_3, mctr1, mcrotrchannel_12_analyzer_2_array_crystal_array_3);
  mctc1 = coords_set(
#line 3282 "MACS_sample_kidney_box.instr"
    0 + channel_12_analyzer_2_array_effective_radius_of_curvature * ( 1 - cos ( channel_12_analyzer_2_array_theta [ 3 ] ) ),
#line 3282 "MACS_sample_kidney_box.instr"
    0 + channel_12_analyzer_2_array_effective_radius_of_curvature * sin ( channel_12_analyzer_2_array_theta [ 3 ] ),
#line 3282 "MACS_sample_kidney_box.instr"
    0);
#line 129971 "MACS_sample_kidney_box.c"
  rot_transpose(mcrotachannel_12_analyzer_2_rotated, mctr1);
  mctc2 = rot_apply(mctr1, mctc1);
  mcposachannel_12_analyzer_2_array_crystal_array_3 = coords_add(mcposachannel_12_analyzer_2_rotated, mctc2);
  mctc1 = coords_sub(mcposachannel_12_analyzer_2_array_crystal_array_2, mcposachannel_12_analyzer_2_array_crystal_array_3);
  mcposrchannel_12_analyzer_2_array_crystal_array_3 = rot_apply(mcrotachannel_12_analyzer_2_array_crystal_array_3, mctc1);
  mcDEBUG_COMPONENT("channel_12_analyzer_2_array_crystal_array_3", mcposachannel_12_analyzer_2_array_crystal_array_3, mcrotachannel_12_analyzer_2_array_crystal_array_3)
  mccomp_posa[600] = mcposachannel_12_analyzer_2_array_crystal_array_3;
  mccomp_posr[600] = mcposrchannel_12_analyzer_2_array_crystal_array_3;
  mcNCounter[600]  = mcPCounter[600] = mcP2Counter[600] = 0;
  mcAbsorbProp[600]= 0;
    /* Component channel_12_analyzer_2_array_crystal_array_4. */
  /* Setting parameters for component channel_12_analyzer_2_array_crystal_array_4. */
  SIG_MESSAGE("channel_12_analyzer_2_array_crystal_array_4 (Init:SetPar)");
#line 3287 "MACS_sample_kidney_box.instr"
  if("PG_analyzer") strncpy(mccchannel_12_analyzer_2_array_crystal_array_4_material_string, "PG_analyzer" ? "PG_analyzer" : "", 16384); else mccchannel_12_analyzer_2_array_crystal_array_4_material_string[0]='\0';
#line 3287 "MACS_sample_kidney_box.instr"
  mccchannel_12_analyzer_2_array_crystal_array_4_priority = 1421.4;
#line 3286 "MACS_sample_kidney_box.instr"
  mccchannel_12_analyzer_2_array_crystal_array_4_xwidth = channel_12_analyzer_2_array_crystal_depth;
#line 3286 "MACS_sample_kidney_box.instr"
  mccchannel_12_analyzer_2_array_crystal_array_4_yheight = channel_12_analyzer_2_array_crystal_height;
#line 3286 "MACS_sample_kidney_box.instr"
  mccchannel_12_analyzer_2_array_crystal_array_4_zdepth = channel_12_analyzer_2_array_crystal_width;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_12_analyzer_2_array_crystal_array_4_xwidth2 = -1;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_12_analyzer_2_array_crystal_array_4_yheight2 = -1;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_12_analyzer_2_array_crystal_array_4_visualize = 1;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_12_analyzer_2_array_crystal_array_4_target_index = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_12_analyzer_2_array_crystal_array_4_target_x = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_12_analyzer_2_array_crystal_array_4_target_y = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_12_analyzer_2_array_crystal_array_4_target_z = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_12_analyzer_2_array_crystal_array_4_focus_aw = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_12_analyzer_2_array_crystal_array_4_focus_ah = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_12_analyzer_2_array_crystal_array_4_focus_xw = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_12_analyzer_2_array_crystal_array_4_focus_xh = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_12_analyzer_2_array_crystal_array_4_focus_r = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_12_analyzer_2_array_crystal_array_4_p_interact = 0;
#line 71 "MACS_sample_kidney_box.instr"
  if(0) strncpy(mccchannel_12_analyzer_2_array_crystal_array_4_mask_string, 0 ? 0 : "", 16384); else mccchannel_12_analyzer_2_array_crystal_array_4_mask_string[0]='\0';
#line 71 "MACS_sample_kidney_box.instr"
  if(0) strncpy(mccchannel_12_analyzer_2_array_crystal_array_4_mask_setting, 0 ? 0 : "", 16384); else mccchannel_12_analyzer_2_array_crystal_array_4_mask_setting[0]='\0';
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_12_analyzer_2_array_crystal_array_4_number_of_activations = 1;
#line 130027 "MACS_sample_kidney_box.c"

  SIG_MESSAGE("channel_12_analyzer_2_array_crystal_array_4 (Init:Place/Rotate)");
  rot_set_rotation(mctr1,
#line 3289 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 3289 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 3289 "MACS_sample_kidney_box.instr"
    (0 - RAD2DEG * channel_12_analyzer_2_array_theta [ 4 ])*DEG2RAD);
#line 130037 "MACS_sample_kidney_box.c"
  rot_mul(mctr1, mcrotachannel_12_analyzer_2_rotated, mcrotachannel_12_analyzer_2_array_crystal_array_4);
  rot_transpose(mcrotachannel_12_analyzer_2_array_crystal_array_3, mctr1);
  rot_mul(mcrotachannel_12_analyzer_2_array_crystal_array_4, mctr1, mcrotrchannel_12_analyzer_2_array_crystal_array_4);
  mctc1 = coords_set(
#line 3288 "MACS_sample_kidney_box.instr"
    0 + channel_12_analyzer_2_array_effective_radius_of_curvature * ( 1 - cos ( channel_12_analyzer_2_array_theta [ 4 ] ) ),
#line 3288 "MACS_sample_kidney_box.instr"
    0 + channel_12_analyzer_2_array_effective_radius_of_curvature * sin ( channel_12_analyzer_2_array_theta [ 4 ] ),
#line 3288 "MACS_sample_kidney_box.instr"
    0);
#line 130048 "MACS_sample_kidney_box.c"
  rot_transpose(mcrotachannel_12_analyzer_2_rotated, mctr1);
  mctc2 = rot_apply(mctr1, mctc1);
  mcposachannel_12_analyzer_2_array_crystal_array_4 = coords_add(mcposachannel_12_analyzer_2_rotated, mctc2);
  mctc1 = coords_sub(mcposachannel_12_analyzer_2_array_crystal_array_3, mcposachannel_12_analyzer_2_array_crystal_array_4);
  mcposrchannel_12_analyzer_2_array_crystal_array_4 = rot_apply(mcrotachannel_12_analyzer_2_array_crystal_array_4, mctc1);
  mcDEBUG_COMPONENT("channel_12_analyzer_2_array_crystal_array_4", mcposachannel_12_analyzer_2_array_crystal_array_4, mcrotachannel_12_analyzer_2_array_crystal_array_4)
  mccomp_posa[601] = mcposachannel_12_analyzer_2_array_crystal_array_4;
  mccomp_posr[601] = mcposrchannel_12_analyzer_2_array_crystal_array_4;
  mcNCounter[601]  = mcPCounter[601] = mcP2Counter[601] = 0;
  mcAbsorbProp[601]= 0;
    /* Component channel_12_analyzer_2_array_crystal_array_5. */
  /* Setting parameters for component channel_12_analyzer_2_array_crystal_array_5. */
  SIG_MESSAGE("channel_12_analyzer_2_array_crystal_array_5 (Init:SetPar)");
#line 3293 "MACS_sample_kidney_box.instr"
  if("PG_analyzer") strncpy(mccchannel_12_analyzer_2_array_crystal_array_5_material_string, "PG_analyzer" ? "PG_analyzer" : "", 16384); else mccchannel_12_analyzer_2_array_crystal_array_5_material_string[0]='\0';
#line 3293 "MACS_sample_kidney_box.instr"
  mccchannel_12_analyzer_2_array_crystal_array_5_priority = 1421.5;
#line 3292 "MACS_sample_kidney_box.instr"
  mccchannel_12_analyzer_2_array_crystal_array_5_xwidth = channel_12_analyzer_2_array_crystal_depth;
#line 3292 "MACS_sample_kidney_box.instr"
  mccchannel_12_analyzer_2_array_crystal_array_5_yheight = channel_12_analyzer_2_array_crystal_height;
#line 3292 "MACS_sample_kidney_box.instr"
  mccchannel_12_analyzer_2_array_crystal_array_5_zdepth = channel_12_analyzer_2_array_crystal_width;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_12_analyzer_2_array_crystal_array_5_xwidth2 = -1;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_12_analyzer_2_array_crystal_array_5_yheight2 = -1;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_12_analyzer_2_array_crystal_array_5_visualize = 1;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_12_analyzer_2_array_crystal_array_5_target_index = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_12_analyzer_2_array_crystal_array_5_target_x = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_12_analyzer_2_array_crystal_array_5_target_y = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_12_analyzer_2_array_crystal_array_5_target_z = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_12_analyzer_2_array_crystal_array_5_focus_aw = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_12_analyzer_2_array_crystal_array_5_focus_ah = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_12_analyzer_2_array_crystal_array_5_focus_xw = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_12_analyzer_2_array_crystal_array_5_focus_xh = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_12_analyzer_2_array_crystal_array_5_focus_r = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_12_analyzer_2_array_crystal_array_5_p_interact = 0;
#line 71 "MACS_sample_kidney_box.instr"
  if(0) strncpy(mccchannel_12_analyzer_2_array_crystal_array_5_mask_string, 0 ? 0 : "", 16384); else mccchannel_12_analyzer_2_array_crystal_array_5_mask_string[0]='\0';
#line 71 "MACS_sample_kidney_box.instr"
  if(0) strncpy(mccchannel_12_analyzer_2_array_crystal_array_5_mask_setting, 0 ? 0 : "", 16384); else mccchannel_12_analyzer_2_array_crystal_array_5_mask_setting[0]='\0';
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_12_analyzer_2_array_crystal_array_5_number_of_activations = 1;
#line 130104 "MACS_sample_kidney_box.c"

  SIG_MESSAGE("channel_12_analyzer_2_array_crystal_array_5 (Init:Place/Rotate)");
  rot_set_rotation(mctr1,
#line 3295 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 3295 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 3295 "MACS_sample_kidney_box.instr"
    (0 - RAD2DEG * channel_12_analyzer_2_array_theta [ 5 ])*DEG2RAD);
#line 130114 "MACS_sample_kidney_box.c"
  rot_mul(mctr1, mcrotachannel_12_analyzer_2_rotated, mcrotachannel_12_analyzer_2_array_crystal_array_5);
  rot_transpose(mcrotachannel_12_analyzer_2_array_crystal_array_4, mctr1);
  rot_mul(mcrotachannel_12_analyzer_2_array_crystal_array_5, mctr1, mcrotrchannel_12_analyzer_2_array_crystal_array_5);
  mctc1 = coords_set(
#line 3294 "MACS_sample_kidney_box.instr"
    0 + channel_12_analyzer_2_array_effective_radius_of_curvature * ( 1 - cos ( channel_12_analyzer_2_array_theta [ 5 ] ) ),
#line 3294 "MACS_sample_kidney_box.instr"
    0 + channel_12_analyzer_2_array_effective_radius_of_curvature * sin ( channel_12_analyzer_2_array_theta [ 5 ] ),
#line 3294 "MACS_sample_kidney_box.instr"
    0);
#line 130125 "MACS_sample_kidney_box.c"
  rot_transpose(mcrotachannel_12_analyzer_2_rotated, mctr1);
  mctc2 = rot_apply(mctr1, mctc1);
  mcposachannel_12_analyzer_2_array_crystal_array_5 = coords_add(mcposachannel_12_analyzer_2_rotated, mctc2);
  mctc1 = coords_sub(mcposachannel_12_analyzer_2_array_crystal_array_4, mcposachannel_12_analyzer_2_array_crystal_array_5);
  mcposrchannel_12_analyzer_2_array_crystal_array_5 = rot_apply(mcrotachannel_12_analyzer_2_array_crystal_array_5, mctc1);
  mcDEBUG_COMPONENT("channel_12_analyzer_2_array_crystal_array_5", mcposachannel_12_analyzer_2_array_crystal_array_5, mcrotachannel_12_analyzer_2_array_crystal_array_5)
  mccomp_posa[602] = mcposachannel_12_analyzer_2_array_crystal_array_5;
  mccomp_posr[602] = mcposrchannel_12_analyzer_2_array_crystal_array_5;
  mcNCounter[602]  = mcPCounter[602] = mcP2Counter[602] = 0;
  mcAbsorbProp[602]= 0;
    /* Component channel_12_analyzer_2_array_crystal_array_6. */
  /* Setting parameters for component channel_12_analyzer_2_array_crystal_array_6. */
  SIG_MESSAGE("channel_12_analyzer_2_array_crystal_array_6 (Init:SetPar)");
#line 3299 "MACS_sample_kidney_box.instr"
  if("PG_analyzer") strncpy(mccchannel_12_analyzer_2_array_crystal_array_6_material_string, "PG_analyzer" ? "PG_analyzer" : "", 16384); else mccchannel_12_analyzer_2_array_crystal_array_6_material_string[0]='\0';
#line 3299 "MACS_sample_kidney_box.instr"
  mccchannel_12_analyzer_2_array_crystal_array_6_priority = 1421.6;
#line 3298 "MACS_sample_kidney_box.instr"
  mccchannel_12_analyzer_2_array_crystal_array_6_xwidth = channel_12_analyzer_2_array_crystal_depth;
#line 3298 "MACS_sample_kidney_box.instr"
  mccchannel_12_analyzer_2_array_crystal_array_6_yheight = channel_12_analyzer_2_array_crystal_height;
#line 3298 "MACS_sample_kidney_box.instr"
  mccchannel_12_analyzer_2_array_crystal_array_6_zdepth = channel_12_analyzer_2_array_crystal_width;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_12_analyzer_2_array_crystal_array_6_xwidth2 = -1;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_12_analyzer_2_array_crystal_array_6_yheight2 = -1;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_12_analyzer_2_array_crystal_array_6_visualize = 1;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_12_analyzer_2_array_crystal_array_6_target_index = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_12_analyzer_2_array_crystal_array_6_target_x = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_12_analyzer_2_array_crystal_array_6_target_y = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_12_analyzer_2_array_crystal_array_6_target_z = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_12_analyzer_2_array_crystal_array_6_focus_aw = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_12_analyzer_2_array_crystal_array_6_focus_ah = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_12_analyzer_2_array_crystal_array_6_focus_xw = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_12_analyzer_2_array_crystal_array_6_focus_xh = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_12_analyzer_2_array_crystal_array_6_focus_r = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_12_analyzer_2_array_crystal_array_6_p_interact = 0;
#line 71 "MACS_sample_kidney_box.instr"
  if(0) strncpy(mccchannel_12_analyzer_2_array_crystal_array_6_mask_string, 0 ? 0 : "", 16384); else mccchannel_12_analyzer_2_array_crystal_array_6_mask_string[0]='\0';
#line 71 "MACS_sample_kidney_box.instr"
  if(0) strncpy(mccchannel_12_analyzer_2_array_crystal_array_6_mask_setting, 0 ? 0 : "", 16384); else mccchannel_12_analyzer_2_array_crystal_array_6_mask_setting[0]='\0';
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_12_analyzer_2_array_crystal_array_6_number_of_activations = 1;
#line 130181 "MACS_sample_kidney_box.c"

  SIG_MESSAGE("channel_12_analyzer_2_array_crystal_array_6 (Init:Place/Rotate)");
  rot_set_rotation(mctr1,
#line 3301 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 3301 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 3301 "MACS_sample_kidney_box.instr"
    (0 - RAD2DEG * channel_12_analyzer_2_array_theta [ 6 ])*DEG2RAD);
#line 130191 "MACS_sample_kidney_box.c"
  rot_mul(mctr1, mcrotachannel_12_analyzer_2_rotated, mcrotachannel_12_analyzer_2_array_crystal_array_6);
  rot_transpose(mcrotachannel_12_analyzer_2_array_crystal_array_5, mctr1);
  rot_mul(mcrotachannel_12_analyzer_2_array_crystal_array_6, mctr1, mcrotrchannel_12_analyzer_2_array_crystal_array_6);
  mctc1 = coords_set(
#line 3300 "MACS_sample_kidney_box.instr"
    0 + channel_12_analyzer_2_array_effective_radius_of_curvature * ( 1 - cos ( channel_12_analyzer_2_array_theta [ 6 ] ) ),
#line 3300 "MACS_sample_kidney_box.instr"
    0 + channel_12_analyzer_2_array_effective_radius_of_curvature * sin ( channel_12_analyzer_2_array_theta [ 6 ] ),
#line 3300 "MACS_sample_kidney_box.instr"
    0);
#line 130202 "MACS_sample_kidney_box.c"
  rot_transpose(mcrotachannel_12_analyzer_2_rotated, mctr1);
  mctc2 = rot_apply(mctr1, mctc1);
  mcposachannel_12_analyzer_2_array_crystal_array_6 = coords_add(mcposachannel_12_analyzer_2_rotated, mctc2);
  mctc1 = coords_sub(mcposachannel_12_analyzer_2_array_crystal_array_5, mcposachannel_12_analyzer_2_array_crystal_array_6);
  mcposrchannel_12_analyzer_2_array_crystal_array_6 = rot_apply(mcrotachannel_12_analyzer_2_array_crystal_array_6, mctc1);
  mcDEBUG_COMPONENT("channel_12_analyzer_2_array_crystal_array_6", mcposachannel_12_analyzer_2_array_crystal_array_6, mcrotachannel_12_analyzer_2_array_crystal_array_6)
  mccomp_posa[603] = mcposachannel_12_analyzer_2_array_crystal_array_6;
  mccomp_posr[603] = mcposrchannel_12_analyzer_2_array_crystal_array_6;
  mcNCounter[603]  = mcPCounter[603] = mcP2Counter[603] = 0;
  mcAbsorbProp[603]= 0;
    /* Component channel_12_analyzer_2_array_crystal_array_7. */
  /* Setting parameters for component channel_12_analyzer_2_array_crystal_array_7. */
  SIG_MESSAGE("channel_12_analyzer_2_array_crystal_array_7 (Init:SetPar)");
#line 3305 "MACS_sample_kidney_box.instr"
  if("PG_analyzer") strncpy(mccchannel_12_analyzer_2_array_crystal_array_7_material_string, "PG_analyzer" ? "PG_analyzer" : "", 16384); else mccchannel_12_analyzer_2_array_crystal_array_7_material_string[0]='\0';
#line 3305 "MACS_sample_kidney_box.instr"
  mccchannel_12_analyzer_2_array_crystal_array_7_priority = 1421.7;
#line 3304 "MACS_sample_kidney_box.instr"
  mccchannel_12_analyzer_2_array_crystal_array_7_xwidth = channel_12_analyzer_2_array_crystal_depth;
#line 3304 "MACS_sample_kidney_box.instr"
  mccchannel_12_analyzer_2_array_crystal_array_7_yheight = channel_12_analyzer_2_array_crystal_height;
#line 3304 "MACS_sample_kidney_box.instr"
  mccchannel_12_analyzer_2_array_crystal_array_7_zdepth = channel_12_analyzer_2_array_crystal_width;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_12_analyzer_2_array_crystal_array_7_xwidth2 = -1;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_12_analyzer_2_array_crystal_array_7_yheight2 = -1;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_12_analyzer_2_array_crystal_array_7_visualize = 1;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_12_analyzer_2_array_crystal_array_7_target_index = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_12_analyzer_2_array_crystal_array_7_target_x = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_12_analyzer_2_array_crystal_array_7_target_y = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_12_analyzer_2_array_crystal_array_7_target_z = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_12_analyzer_2_array_crystal_array_7_focus_aw = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_12_analyzer_2_array_crystal_array_7_focus_ah = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_12_analyzer_2_array_crystal_array_7_focus_xw = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_12_analyzer_2_array_crystal_array_7_focus_xh = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_12_analyzer_2_array_crystal_array_7_focus_r = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_12_analyzer_2_array_crystal_array_7_p_interact = 0;
#line 71 "MACS_sample_kidney_box.instr"
  if(0) strncpy(mccchannel_12_analyzer_2_array_crystal_array_7_mask_string, 0 ? 0 : "", 16384); else mccchannel_12_analyzer_2_array_crystal_array_7_mask_string[0]='\0';
#line 71 "MACS_sample_kidney_box.instr"
  if(0) strncpy(mccchannel_12_analyzer_2_array_crystal_array_7_mask_setting, 0 ? 0 : "", 16384); else mccchannel_12_analyzer_2_array_crystal_array_7_mask_setting[0]='\0';
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_12_analyzer_2_array_crystal_array_7_number_of_activations = 1;
#line 130258 "MACS_sample_kidney_box.c"

  SIG_MESSAGE("channel_12_analyzer_2_array_crystal_array_7 (Init:Place/Rotate)");
  rot_set_rotation(mctr1,
#line 3307 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 3307 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 3307 "MACS_sample_kidney_box.instr"
    (0 - RAD2DEG * channel_12_analyzer_2_array_theta [ 7 ])*DEG2RAD);
#line 130268 "MACS_sample_kidney_box.c"
  rot_mul(mctr1, mcrotachannel_12_analyzer_2_rotated, mcrotachannel_12_analyzer_2_array_crystal_array_7);
  rot_transpose(mcrotachannel_12_analyzer_2_array_crystal_array_6, mctr1);
  rot_mul(mcrotachannel_12_analyzer_2_array_crystal_array_7, mctr1, mcrotrchannel_12_analyzer_2_array_crystal_array_7);
  mctc1 = coords_set(
#line 3306 "MACS_sample_kidney_box.instr"
    0 + channel_12_analyzer_2_array_effective_radius_of_curvature * ( 1 - cos ( channel_12_analyzer_2_array_theta [ 7 ] ) ),
#line 3306 "MACS_sample_kidney_box.instr"
    0 + channel_12_analyzer_2_array_effective_radius_of_curvature * sin ( channel_12_analyzer_2_array_theta [ 7 ] ),
#line 3306 "MACS_sample_kidney_box.instr"
    0);
#line 130279 "MACS_sample_kidney_box.c"
  rot_transpose(mcrotachannel_12_analyzer_2_rotated, mctr1);
  mctc2 = rot_apply(mctr1, mctc1);
  mcposachannel_12_analyzer_2_array_crystal_array_7 = coords_add(mcposachannel_12_analyzer_2_rotated, mctc2);
  mctc1 = coords_sub(mcposachannel_12_analyzer_2_array_crystal_array_6, mcposachannel_12_analyzer_2_array_crystal_array_7);
  mcposrchannel_12_analyzer_2_array_crystal_array_7 = rot_apply(mcrotachannel_12_analyzer_2_array_crystal_array_7, mctc1);
  mcDEBUG_COMPONENT("channel_12_analyzer_2_array_crystal_array_7", mcposachannel_12_analyzer_2_array_crystal_array_7, mcrotachannel_12_analyzer_2_array_crystal_array_7)
  mccomp_posa[604] = mcposachannel_12_analyzer_2_array_crystal_array_7;
  mccomp_posr[604] = mcposrchannel_12_analyzer_2_array_crystal_array_7;
  mcNCounter[604]  = mcPCounter[604] = mcP2Counter[604] = 0;
  mcAbsorbProp[604]= 0;
    /* Component channel_12_analyzer_2_array_crystal_array_8. */
  /* Setting parameters for component channel_12_analyzer_2_array_crystal_array_8. */
  SIG_MESSAGE("channel_12_analyzer_2_array_crystal_array_8 (Init:SetPar)");
#line 3311 "MACS_sample_kidney_box.instr"
  if("PG_analyzer") strncpy(mccchannel_12_analyzer_2_array_crystal_array_8_material_string, "PG_analyzer" ? "PG_analyzer" : "", 16384); else mccchannel_12_analyzer_2_array_crystal_array_8_material_string[0]='\0';
#line 3311 "MACS_sample_kidney_box.instr"
  mccchannel_12_analyzer_2_array_crystal_array_8_priority = 1421.8;
#line 3310 "MACS_sample_kidney_box.instr"
  mccchannel_12_analyzer_2_array_crystal_array_8_xwidth = channel_12_analyzer_2_array_crystal_depth;
#line 3310 "MACS_sample_kidney_box.instr"
  mccchannel_12_analyzer_2_array_crystal_array_8_yheight = channel_12_analyzer_2_array_crystal_height;
#line 3310 "MACS_sample_kidney_box.instr"
  mccchannel_12_analyzer_2_array_crystal_array_8_zdepth = channel_12_analyzer_2_array_crystal_width;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_12_analyzer_2_array_crystal_array_8_xwidth2 = -1;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_12_analyzer_2_array_crystal_array_8_yheight2 = -1;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_12_analyzer_2_array_crystal_array_8_visualize = 1;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_12_analyzer_2_array_crystal_array_8_target_index = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_12_analyzer_2_array_crystal_array_8_target_x = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_12_analyzer_2_array_crystal_array_8_target_y = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_12_analyzer_2_array_crystal_array_8_target_z = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_12_analyzer_2_array_crystal_array_8_focus_aw = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_12_analyzer_2_array_crystal_array_8_focus_ah = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_12_analyzer_2_array_crystal_array_8_focus_xw = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_12_analyzer_2_array_crystal_array_8_focus_xh = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_12_analyzer_2_array_crystal_array_8_focus_r = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_12_analyzer_2_array_crystal_array_8_p_interact = 0;
#line 71 "MACS_sample_kidney_box.instr"
  if(0) strncpy(mccchannel_12_analyzer_2_array_crystal_array_8_mask_string, 0 ? 0 : "", 16384); else mccchannel_12_analyzer_2_array_crystal_array_8_mask_string[0]='\0';
#line 71 "MACS_sample_kidney_box.instr"
  if(0) strncpy(mccchannel_12_analyzer_2_array_crystal_array_8_mask_setting, 0 ? 0 : "", 16384); else mccchannel_12_analyzer_2_array_crystal_array_8_mask_setting[0]='\0';
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_12_analyzer_2_array_crystal_array_8_number_of_activations = 1;
#line 130335 "MACS_sample_kidney_box.c"

  SIG_MESSAGE("channel_12_analyzer_2_array_crystal_array_8 (Init:Place/Rotate)");
  rot_set_rotation(mctr1,
#line 3313 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 3313 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 3313 "MACS_sample_kidney_box.instr"
    (0 - RAD2DEG * channel_12_analyzer_2_array_theta [ 8 ])*DEG2RAD);
#line 130345 "MACS_sample_kidney_box.c"
  rot_mul(mctr1, mcrotachannel_12_analyzer_2_rotated, mcrotachannel_12_analyzer_2_array_crystal_array_8);
  rot_transpose(mcrotachannel_12_analyzer_2_array_crystal_array_7, mctr1);
  rot_mul(mcrotachannel_12_analyzer_2_array_crystal_array_8, mctr1, mcrotrchannel_12_analyzer_2_array_crystal_array_8);
  mctc1 = coords_set(
#line 3312 "MACS_sample_kidney_box.instr"
    0 + channel_12_analyzer_2_array_effective_radius_of_curvature * ( 1 - cos ( channel_12_analyzer_2_array_theta [ 8 ] ) ),
#line 3312 "MACS_sample_kidney_box.instr"
    0 + channel_12_analyzer_2_array_effective_radius_of_curvature * sin ( channel_12_analyzer_2_array_theta [ 8 ] ),
#line 3312 "MACS_sample_kidney_box.instr"
    0);
#line 130356 "MACS_sample_kidney_box.c"
  rot_transpose(mcrotachannel_12_analyzer_2_rotated, mctr1);
  mctc2 = rot_apply(mctr1, mctc1);
  mcposachannel_12_analyzer_2_array_crystal_array_8 = coords_add(mcposachannel_12_analyzer_2_rotated, mctc2);
  mctc1 = coords_sub(mcposachannel_12_analyzer_2_array_crystal_array_7, mcposachannel_12_analyzer_2_array_crystal_array_8);
  mcposrchannel_12_analyzer_2_array_crystal_array_8 = rot_apply(mcrotachannel_12_analyzer_2_array_crystal_array_8, mctc1);
  mcDEBUG_COMPONENT("channel_12_analyzer_2_array_crystal_array_8", mcposachannel_12_analyzer_2_array_crystal_array_8, mcrotachannel_12_analyzer_2_array_crystal_array_8)
  mccomp_posa[605] = mcposachannel_12_analyzer_2_array_crystal_array_8;
  mccomp_posr[605] = mcposrchannel_12_analyzer_2_array_crystal_array_8;
  mcNCounter[605]  = mcPCounter[605] = mcP2Counter[605] = 0;
  mcAbsorbProp[605]= 0;
    /* Component channel_12_cave2_cyl1. */
  /* Setting parameters for component channel_12_cave2_cyl1. */
  SIG_MESSAGE("channel_12_cave2_cyl1 (Init:SetPar)");
#line 3318 "MACS_sample_kidney_box.instr"
  if("Vacuum") strncpy(mccchannel_12_cave2_cyl1_material_string, "Vacuum" ? "Vacuum" : "", 16384); else mccchannel_12_cave2_cyl1_material_string[0]='\0';
#line 3318 "MACS_sample_kidney_box.instr"
  mccchannel_12_cave2_cyl1_priority = 1407.5;
#line 3317 "MACS_sample_kidney_box.instr"
  mccchannel_12_cave2_cyl1_radius = kidney_cave2_cyl1_radius;
#line 3317 "MACS_sample_kidney_box.instr"
  mccchannel_12_cave2_cyl1_yheight = kidney_cave2_cyl1_height;
#line 67 "MACS_sample_kidney_box.instr"
  mccchannel_12_cave2_cyl1_visualize = 1;
#line 67 "MACS_sample_kidney_box.instr"
  mccchannel_12_cave2_cyl1_target_index = 0;
#line 67 "MACS_sample_kidney_box.instr"
  mccchannel_12_cave2_cyl1_target_x = 0;
#line 67 "MACS_sample_kidney_box.instr"
  mccchannel_12_cave2_cyl1_target_y = 0;
#line 67 "MACS_sample_kidney_box.instr"
  mccchannel_12_cave2_cyl1_target_z = 0;
#line 67 "MACS_sample_kidney_box.instr"
  mccchannel_12_cave2_cyl1_focus_aw = 0;
#line 67 "MACS_sample_kidney_box.instr"
  mccchannel_12_cave2_cyl1_focus_ah = 0;
#line 67 "MACS_sample_kidney_box.instr"
  mccchannel_12_cave2_cyl1_focus_xw = 0;
#line 67 "MACS_sample_kidney_box.instr"
  mccchannel_12_cave2_cyl1_focus_xh = 0;
#line 67 "MACS_sample_kidney_box.instr"
  mccchannel_12_cave2_cyl1_focus_r = 0;
#line 67 "MACS_sample_kidney_box.instr"
  mccchannel_12_cave2_cyl1_p_interact = 0;
#line 67 "MACS_sample_kidney_box.instr"
  if(0) strncpy(mccchannel_12_cave2_cyl1_mask_string, 0 ? 0 : "", 16384); else mccchannel_12_cave2_cyl1_mask_string[0]='\0';
#line 67 "MACS_sample_kidney_box.instr"
  if(0) strncpy(mccchannel_12_cave2_cyl1_mask_setting, 0 ? 0 : "", 16384); else mccchannel_12_cave2_cyl1_mask_setting[0]='\0';
#line 67 "MACS_sample_kidney_box.instr"
  mccchannel_12_cave2_cyl1_number_of_activations = 1;
#line 130406 "MACS_sample_kidney_box.c"

  SIG_MESSAGE("channel_12_cave2_cyl1 (Init:Place/Rotate)");
  rot_set_rotation(mctr1,
#line 3320 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 3320 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 3320 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD);
#line 130416 "MACS_sample_kidney_box.c"
  rot_mul(mctr1, mcrotachannel_12_analyzer_2_center, mcrotachannel_12_cave2_cyl1);
  rot_transpose(mcrotachannel_12_analyzer_2_array_crystal_array_8, mctr1);
  rot_mul(mcrotachannel_12_cave2_cyl1, mctr1, mcrotrchannel_12_cave2_cyl1);
  mctc1 = coords_set(
#line 3319 "MACS_sample_kidney_box.instr"
    0,
#line 3319 "MACS_sample_kidney_box.instr"
    0,
#line 3319 "MACS_sample_kidney_box.instr"
    spec_detector_to_analyzer_2_center);
#line 130427 "MACS_sample_kidney_box.c"
  rot_transpose(mcrotachannel_12_analyzer_2_center, mctr1);
  mctc2 = rot_apply(mctr1, mctc1);
  mcposachannel_12_cave2_cyl1 = coords_add(mcposachannel_12_analyzer_2_center, mctc2);
  mctc1 = coords_sub(mcposachannel_12_analyzer_2_array_crystal_array_8, mcposachannel_12_cave2_cyl1);
  mcposrchannel_12_cave2_cyl1 = rot_apply(mcrotachannel_12_cave2_cyl1, mctc1);
  mcDEBUG_COMPONENT("channel_12_cave2_cyl1", mcposachannel_12_cave2_cyl1, mcrotachannel_12_cave2_cyl1)
  mccomp_posa[606] = mcposachannel_12_cave2_cyl1;
  mccomp_posr[606] = mcposrchannel_12_cave2_cyl1;
  mcNCounter[606]  = mcPCounter[606] = mcP2Counter[606] = 0;
  mcAbsorbProp[606]= 0;
    /* Component channel_12_cave2_box1. */
  /* Setting parameters for component channel_12_cave2_box1. */
  SIG_MESSAGE("channel_12_cave2_box1 (Init:SetPar)");
#line 3325 "MACS_sample_kidney_box.instr"
  if("Vacuum") strncpy(mccchannel_12_cave2_box1_material_string, "Vacuum" ? "Vacuum" : "", 16384); else mccchannel_12_cave2_box1_material_string[0]='\0';
#line 3325 "MACS_sample_kidney_box.instr"
  mccchannel_12_cave2_box1_priority = 1401;
#line 3323 "MACS_sample_kidney_box.instr"
  mccchannel_12_cave2_box1_xwidth = kidney_cave2_box1_width1;
#line 3323 "MACS_sample_kidney_box.instr"
  mccchannel_12_cave2_box1_yheight = kidney_cave2_box1_height1;
#line 3323 "MACS_sample_kidney_box.instr"
  mccchannel_12_cave2_box1_zdepth = kidney_cave2_box1_depth;
#line 3324 "MACS_sample_kidney_box.instr"
  mccchannel_12_cave2_box1_xwidth2 = kidney_cave2_box1_width2;
#line 3324 "MACS_sample_kidney_box.instr"
  mccchannel_12_cave2_box1_yheight2 = kidney_cave2_box1_height2;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_12_cave2_box1_visualize = 1;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_12_cave2_box1_target_index = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_12_cave2_box1_target_x = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_12_cave2_box1_target_y = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_12_cave2_box1_target_z = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_12_cave2_box1_focus_aw = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_12_cave2_box1_focus_ah = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_12_cave2_box1_focus_xw = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_12_cave2_box1_focus_xh = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_12_cave2_box1_focus_r = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_12_cave2_box1_p_interact = 0;
#line 71 "MACS_sample_kidney_box.instr"
  if(0) strncpy(mccchannel_12_cave2_box1_mask_string, 0 ? 0 : "", 16384); else mccchannel_12_cave2_box1_mask_string[0]='\0';
#line 71 "MACS_sample_kidney_box.instr"
  if(0) strncpy(mccchannel_12_cave2_box1_mask_setting, 0 ? 0 : "", 16384); else mccchannel_12_cave2_box1_mask_setting[0]='\0';
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_12_cave2_box1_number_of_activations = 1;
#line 130483 "MACS_sample_kidney_box.c"

  SIG_MESSAGE("channel_12_cave2_box1 (Init:Place/Rotate)");
  rot_set_rotation(mctr1,
#line 3327 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 3327 "MACS_sample_kidney_box.instr"
    (kidney_cave2_box1_y_rotation)*DEG2RAD,
#line 3327 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD);
#line 130493 "MACS_sample_kidney_box.c"
  rot_mul(mctr1, mcrotachannel_12_cave2_cyl1, mcrotachannel_12_cave2_box1);
  rot_transpose(mcrotachannel_12_cave2_cyl1, mctr1);
  rot_mul(mcrotachannel_12_cave2_box1, mctr1, mcrotrchannel_12_cave2_box1);
  mctc1 = coords_set(
#line 3326 "MACS_sample_kidney_box.instr"
    kidney_cave2_box1_center_to_spec_detector_x,
#line 3326 "MACS_sample_kidney_box.instr"
    0,
#line 3326 "MACS_sample_kidney_box.instr"
    kidney_cave2_box1_center_to_spec_detector_z);
#line 130504 "MACS_sample_kidney_box.c"
  rot_transpose(mcrotachannel_12_cave2_cyl1, mctr1);
  mctc2 = rot_apply(mctr1, mctc1);
  mcposachannel_12_cave2_box1 = coords_add(mcposachannel_12_cave2_cyl1, mctc2);
  mctc1 = coords_sub(mcposachannel_12_cave2_cyl1, mcposachannel_12_cave2_box1);
  mcposrchannel_12_cave2_box1 = rot_apply(mcrotachannel_12_cave2_box1, mctc1);
  mcDEBUG_COMPONENT("channel_12_cave2_box1", mcposachannel_12_cave2_box1, mcrotachannel_12_cave2_box1)
  mccomp_posa[607] = mcposachannel_12_cave2_box1;
  mccomp_posr[607] = mcposrchannel_12_cave2_box1;
  mcNCounter[607]  = mcPCounter[607] = mcP2Counter[607] = 0;
  mcAbsorbProp[607]= 0;
    /* Component channel_12_cave2_box2. */
  /* Setting parameters for component channel_12_cave2_box2. */
  SIG_MESSAGE("channel_12_cave2_box2 (Init:SetPar)");
#line 3332 "MACS_sample_kidney_box.instr"
  if("Vacuum") strncpy(mccchannel_12_cave2_box2_material_string, "Vacuum" ? "Vacuum" : "", 16384); else mccchannel_12_cave2_box2_material_string[0]='\0';
#line 3332 "MACS_sample_kidney_box.instr"
  mccchannel_12_cave2_box2_priority = 1406;
#line 3330 "MACS_sample_kidney_box.instr"
  mccchannel_12_cave2_box2_xwidth = kidney_cave2_box2_width1;
#line 3330 "MACS_sample_kidney_box.instr"
  mccchannel_12_cave2_box2_yheight = kidney_cave2_box2_height1;
#line 3330 "MACS_sample_kidney_box.instr"
  mccchannel_12_cave2_box2_zdepth = kidney_cave2_box2_depth;
#line 3331 "MACS_sample_kidney_box.instr"
  mccchannel_12_cave2_box2_xwidth2 = kidney_cave2_box2_width2;
#line 3331 "MACS_sample_kidney_box.instr"
  mccchannel_12_cave2_box2_yheight2 = kidney_cave2_box2_height2;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_12_cave2_box2_visualize = 1;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_12_cave2_box2_target_index = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_12_cave2_box2_target_x = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_12_cave2_box2_target_y = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_12_cave2_box2_target_z = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_12_cave2_box2_focus_aw = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_12_cave2_box2_focus_ah = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_12_cave2_box2_focus_xw = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_12_cave2_box2_focus_xh = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_12_cave2_box2_focus_r = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_12_cave2_box2_p_interact = 0;
#line 71 "MACS_sample_kidney_box.instr"
  if(0) strncpy(mccchannel_12_cave2_box2_mask_string, 0 ? 0 : "", 16384); else mccchannel_12_cave2_box2_mask_string[0]='\0';
#line 71 "MACS_sample_kidney_box.instr"
  if(0) strncpy(mccchannel_12_cave2_box2_mask_setting, 0 ? 0 : "", 16384); else mccchannel_12_cave2_box2_mask_setting[0]='\0';
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_12_cave2_box2_number_of_activations = 1;
#line 130560 "MACS_sample_kidney_box.c"

  SIG_MESSAGE("channel_12_cave2_box2 (Init:Place/Rotate)");
  rot_set_rotation(mctr1,
#line 3334 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 3334 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 3334 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD);
#line 130570 "MACS_sample_kidney_box.c"
  rot_mul(mctr1, mcrotachannel_12_cave2_cyl1, mcrotachannel_12_cave2_box2);
  rot_transpose(mcrotachannel_12_cave2_box1, mctr1);
  rot_mul(mcrotachannel_12_cave2_box2, mctr1, mcrotrchannel_12_cave2_box2);
  mctc1 = coords_set(
#line 3333 "MACS_sample_kidney_box.instr"
    0,
#line 3333 "MACS_sample_kidney_box.instr"
    0,
#line 3333 "MACS_sample_kidney_box.instr"
    kidney_cave2_box2_center_to_detector);
#line 130581 "MACS_sample_kidney_box.c"
  rot_transpose(mcrotachannel_12_cave2_cyl1, mctr1);
  mctc2 = rot_apply(mctr1, mctc1);
  mcposachannel_12_cave2_box2 = coords_add(mcposachannel_12_cave2_cyl1, mctc2);
  mctc1 = coords_sub(mcposachannel_12_cave2_box1, mcposachannel_12_cave2_box2);
  mcposrchannel_12_cave2_box2 = rot_apply(mcrotachannel_12_cave2_box2, mctc1);
  mcDEBUG_COMPONENT("channel_12_cave2_box2", mcposachannel_12_cave2_box2, mcrotachannel_12_cave2_box2)
  mccomp_posa[608] = mcposachannel_12_cave2_box2;
  mccomp_posr[608] = mcposrchannel_12_cave2_box2;
  mcNCounter[608]  = mcPCounter[608] = mcP2Counter[608] = 0;
  mcAbsorbProp[608]= 0;
    /* Component channel_12_cave2_box3. */
  /* Setting parameters for component channel_12_cave2_box3. */
  SIG_MESSAGE("channel_12_cave2_box3 (Init:SetPar)");
#line 3339 "MACS_sample_kidney_box.instr"
  if("Vacuum") strncpy(mccchannel_12_cave2_box3_material_string, "Vacuum" ? "Vacuum" : "", 16384); else mccchannel_12_cave2_box3_material_string[0]='\0';
#line 3339 "MACS_sample_kidney_box.instr"
  mccchannel_12_cave2_box3_priority = 1407;
#line 3337 "MACS_sample_kidney_box.instr"
  mccchannel_12_cave2_box3_xwidth = kidney_cave2_box3_width1;
#line 3337 "MACS_sample_kidney_box.instr"
  mccchannel_12_cave2_box3_yheight = kidney_cave2_box3_height1;
#line 3337 "MACS_sample_kidney_box.instr"
  mccchannel_12_cave2_box3_zdepth = kidney_cave2_box3_depth;
#line 3338 "MACS_sample_kidney_box.instr"
  mccchannel_12_cave2_box3_xwidth2 = kidney_cave2_box3_width2;
#line 3338 "MACS_sample_kidney_box.instr"
  mccchannel_12_cave2_box3_yheight2 = kidney_cave2_box3_height2;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_12_cave2_box3_visualize = 1;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_12_cave2_box3_target_index = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_12_cave2_box3_target_x = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_12_cave2_box3_target_y = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_12_cave2_box3_target_z = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_12_cave2_box3_focus_aw = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_12_cave2_box3_focus_ah = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_12_cave2_box3_focus_xw = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_12_cave2_box3_focus_xh = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_12_cave2_box3_focus_r = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_12_cave2_box3_p_interact = 0;
#line 71 "MACS_sample_kidney_box.instr"
  if(0) strncpy(mccchannel_12_cave2_box3_mask_string, 0 ? 0 : "", 16384); else mccchannel_12_cave2_box3_mask_string[0]='\0';
#line 71 "MACS_sample_kidney_box.instr"
  if(0) strncpy(mccchannel_12_cave2_box3_mask_setting, 0 ? 0 : "", 16384); else mccchannel_12_cave2_box3_mask_setting[0]='\0';
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_12_cave2_box3_number_of_activations = 1;
#line 130637 "MACS_sample_kidney_box.c"

  SIG_MESSAGE("channel_12_cave2_box3 (Init:Place/Rotate)");
  rot_set_rotation(mctr1,
#line 3341 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 3341 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 3341 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD);
#line 130647 "MACS_sample_kidney_box.c"
  rot_mul(mctr1, mcrotachannel_12_cave2_cyl1, mcrotachannel_12_cave2_box3);
  rot_transpose(mcrotachannel_12_cave2_box2, mctr1);
  rot_mul(mcrotachannel_12_cave2_box3, mctr1, mcrotrchannel_12_cave2_box3);
  mctc1 = coords_set(
#line 3340 "MACS_sample_kidney_box.instr"
    0,
#line 3340 "MACS_sample_kidney_box.instr"
    0,
#line 3340 "MACS_sample_kidney_box.instr"
    kidney_cave2_box3_center_to_detector);
#line 130658 "MACS_sample_kidney_box.c"
  rot_transpose(mcrotachannel_12_cave2_cyl1, mctr1);
  mctc2 = rot_apply(mctr1, mctc1);
  mcposachannel_12_cave2_box3 = coords_add(mcposachannel_12_cave2_cyl1, mctc2);
  mctc1 = coords_sub(mcposachannel_12_cave2_box2, mcposachannel_12_cave2_box3);
  mcposrchannel_12_cave2_box3 = rot_apply(mcrotachannel_12_cave2_box3, mctc1);
  mcDEBUG_COMPONENT("channel_12_cave2_box3", mcposachannel_12_cave2_box3, mcrotachannel_12_cave2_box3)
  mccomp_posa[609] = mcposachannel_12_cave2_box3;
  mccomp_posr[609] = mcposrchannel_12_cave2_box3;
  mcNCounter[609]  = mcPCounter[609] = mcP2Counter[609] = 0;
  mcAbsorbProp[609]= 0;
    /* Component inter_analyzer_colimator_center_12. */
  /* Setting parameters for component inter_analyzer_colimator_center_12. */
  SIG_MESSAGE("inter_analyzer_colimator_center_12 (Init:SetPar)");

  SIG_MESSAGE("inter_analyzer_colimator_center_12 (Init:Place/Rotate)");
  rot_set_rotation(mctr1,
#line 3345 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 3345 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 3345 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD);
#line 130681 "MACS_sample_kidney_box.c"
  rot_mul(mctr1, mcrotachannel_12_analyzer_1_center, mcrotainter_analyzer_colimator_center_12);
  rot_transpose(mcrotachannel_12_cave2_box3, mctr1);
  rot_mul(mcrotainter_analyzer_colimator_center_12, mctr1, mcrotrinter_analyzer_colimator_center_12);
  mctc1 = coords_set(
#line 3344 "MACS_sample_kidney_box.instr"
    -0.5 * analyzer_seperation,
#line 3344 "MACS_sample_kidney_box.instr"
    0,
#line 3344 "MACS_sample_kidney_box.instr"
    0);
#line 130692 "MACS_sample_kidney_box.c"
  rot_transpose(mcrotachannel_12_analyzer_1_center, mctr1);
  mctc2 = rot_apply(mctr1, mctc1);
  mcposainter_analyzer_colimator_center_12 = coords_add(mcposachannel_12_analyzer_1_center, mctc2);
  mctc1 = coords_sub(mcposachannel_12_cave2_box3, mcposainter_analyzer_colimator_center_12);
  mcposrinter_analyzer_colimator_center_12 = rot_apply(mcrotainter_analyzer_colimator_center_12, mctc1);
  mcDEBUG_COMPONENT("inter_analyzer_colimator_center_12", mcposainter_analyzer_colimator_center_12, mcrotainter_analyzer_colimator_center_12)
  mccomp_posa[610] = mcposainter_analyzer_colimator_center_12;
  mccomp_posr[610] = mcposrinter_analyzer_colimator_center_12;
  mcNCounter[610]  = mcPCounter[610] = mcP2Counter[610] = 0;
  mcAbsorbProp[610]= 0;
    /* Component inter_analyzer_colimator_12_blade_0. */
  /* Setting parameters for component inter_analyzer_colimator_12_blade_0. */
  SIG_MESSAGE("inter_analyzer_colimator_12_blade_0 (Init:SetPar)");
#line 3349 "MACS_sample_kidney_box.instr"
  if("Collimator_gad") strncpy(mccinter_analyzer_colimator_12_blade_0_material_string, "Collimator_gad" ? "Collimator_gad" : "", 16384); else mccinter_analyzer_colimator_12_blade_0_material_string[0]='\0';
#line 3349 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_12_blade_0_priority = 1425;
#line 3348 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_12_blade_0_xwidth = inter_analyzer_colimator_width;
#line 3348 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_12_blade_0_yheight = inter_analyzer_colimator_height;
#line 3348 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_12_blade_0_zdepth = inter_analyzer_colimator_depth;
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_12_blade_0_xwidth2 = -1;
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_12_blade_0_yheight2 = -1;
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_12_blade_0_visualize = 1;
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_12_blade_0_target_index = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_12_blade_0_target_x = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_12_blade_0_target_y = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_12_blade_0_target_z = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_12_blade_0_focus_aw = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_12_blade_0_focus_ah = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_12_blade_0_focus_xw = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_12_blade_0_focus_xh = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_12_blade_0_focus_r = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_12_blade_0_p_interact = 0;
#line 71 "MACS_sample_kidney_box.instr"
  if(0) strncpy(mccinter_analyzer_colimator_12_blade_0_mask_string, 0 ? 0 : "", 16384); else mccinter_analyzer_colimator_12_blade_0_mask_string[0]='\0';
#line 71 "MACS_sample_kidney_box.instr"
  if(0) strncpy(mccinter_analyzer_colimator_12_blade_0_mask_setting, 0 ? 0 : "", 16384); else mccinter_analyzer_colimator_12_blade_0_mask_setting[0]='\0';
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_12_blade_0_number_of_activations = 1;
#line 130748 "MACS_sample_kidney_box.c"

  SIG_MESSAGE("inter_analyzer_colimator_12_blade_0 (Init:Place/Rotate)");
  rot_set_rotation(mctr1,
#line 3351 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 3351 "MACS_sample_kidney_box.instr"
    (- analyzer_2theta [ 12 ])*DEG2RAD,
#line 3351 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD);
#line 130758 "MACS_sample_kidney_box.c"
  rot_mul(mctr1, mcrotainter_analyzer_colimator_center_12, mcrotainter_analyzer_colimator_12_blade_0);
  rot_transpose(mcrotainter_analyzer_colimator_center_12, mctr1);
  rot_mul(mcrotainter_analyzer_colimator_12_blade_0, mctr1, mcrotrinter_analyzer_colimator_12_blade_0);
  mctc1 = coords_set(
#line 3350 "MACS_sample_kidney_box.instr"
    0,
#line 3350 "MACS_sample_kidney_box.instr"
    0,
#line 3350 "MACS_sample_kidney_box.instr"
    inter_analyzer_colimator_start_pos - 0 * inter_analyzer_colimator_seperation);
#line 130769 "MACS_sample_kidney_box.c"
  rot_transpose(mcrotainter_analyzer_colimator_center_12, mctr1);
  mctc2 = rot_apply(mctr1, mctc1);
  mcposainter_analyzer_colimator_12_blade_0 = coords_add(mcposainter_analyzer_colimator_center_12, mctc2);
  mctc1 = coords_sub(mcposainter_analyzer_colimator_center_12, mcposainter_analyzer_colimator_12_blade_0);
  mcposrinter_analyzer_colimator_12_blade_0 = rot_apply(mcrotainter_analyzer_colimator_12_blade_0, mctc1);
  mcDEBUG_COMPONENT("inter_analyzer_colimator_12_blade_0", mcposainter_analyzer_colimator_12_blade_0, mcrotainter_analyzer_colimator_12_blade_0)
  mccomp_posa[611] = mcposainter_analyzer_colimator_12_blade_0;
  mccomp_posr[611] = mcposrinter_analyzer_colimator_12_blade_0;
  mcNCounter[611]  = mcPCounter[611] = mcP2Counter[611] = 0;
  mcAbsorbProp[611]= 0;
    /* Component inter_analyzer_colimator_12_blade_1. */
  /* Setting parameters for component inter_analyzer_colimator_12_blade_1. */
  SIG_MESSAGE("inter_analyzer_colimator_12_blade_1 (Init:SetPar)");
#line 3355 "MACS_sample_kidney_box.instr"
  if("Collimator_gad") strncpy(mccinter_analyzer_colimator_12_blade_1_material_string, "Collimator_gad" ? "Collimator_gad" : "", 16384); else mccinter_analyzer_colimator_12_blade_1_material_string[0]='\0';
#line 3355 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_12_blade_1_priority = 1426;
#line 3354 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_12_blade_1_xwidth = inter_analyzer_colimator_width;
#line 3354 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_12_blade_1_yheight = inter_analyzer_colimator_height;
#line 3354 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_12_blade_1_zdepth = inter_analyzer_colimator_depth;
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_12_blade_1_xwidth2 = -1;
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_12_blade_1_yheight2 = -1;
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_12_blade_1_visualize = 1;
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_12_blade_1_target_index = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_12_blade_1_target_x = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_12_blade_1_target_y = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_12_blade_1_target_z = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_12_blade_1_focus_aw = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_12_blade_1_focus_ah = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_12_blade_1_focus_xw = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_12_blade_1_focus_xh = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_12_blade_1_focus_r = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_12_blade_1_p_interact = 0;
#line 71 "MACS_sample_kidney_box.instr"
  if(0) strncpy(mccinter_analyzer_colimator_12_blade_1_mask_string, 0 ? 0 : "", 16384); else mccinter_analyzer_colimator_12_blade_1_mask_string[0]='\0';
#line 71 "MACS_sample_kidney_box.instr"
  if(0) strncpy(mccinter_analyzer_colimator_12_blade_1_mask_setting, 0 ? 0 : "", 16384); else mccinter_analyzer_colimator_12_blade_1_mask_setting[0]='\0';
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_12_blade_1_number_of_activations = 1;
#line 130825 "MACS_sample_kidney_box.c"

  SIG_MESSAGE("inter_analyzer_colimator_12_blade_1 (Init:Place/Rotate)");
  rot_set_rotation(mctr1,
#line 3357 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 3357 "MACS_sample_kidney_box.instr"
    (- analyzer_2theta [ 12 ])*DEG2RAD,
#line 3357 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD);
#line 130835 "MACS_sample_kidney_box.c"
  rot_mul(mctr1, mcrotainter_analyzer_colimator_center_12, mcrotainter_analyzer_colimator_12_blade_1);
  rot_transpose(mcrotainter_analyzer_colimator_12_blade_0, mctr1);
  rot_mul(mcrotainter_analyzer_colimator_12_blade_1, mctr1, mcrotrinter_analyzer_colimator_12_blade_1);
  mctc1 = coords_set(
#line 3356 "MACS_sample_kidney_box.instr"
    0,
#line 3356 "MACS_sample_kidney_box.instr"
    0,
#line 3356 "MACS_sample_kidney_box.instr"
    inter_analyzer_colimator_start_pos - 1 * inter_analyzer_colimator_seperation);
#line 130846 "MACS_sample_kidney_box.c"
  rot_transpose(mcrotainter_analyzer_colimator_center_12, mctr1);
  mctc2 = rot_apply(mctr1, mctc1);
  mcposainter_analyzer_colimator_12_blade_1 = coords_add(mcposainter_analyzer_colimator_center_12, mctc2);
  mctc1 = coords_sub(mcposainter_analyzer_colimator_12_blade_0, mcposainter_analyzer_colimator_12_blade_1);
  mcposrinter_analyzer_colimator_12_blade_1 = rot_apply(mcrotainter_analyzer_colimator_12_blade_1, mctc1);
  mcDEBUG_COMPONENT("inter_analyzer_colimator_12_blade_1", mcposainter_analyzer_colimator_12_blade_1, mcrotainter_analyzer_colimator_12_blade_1)
  mccomp_posa[612] = mcposainter_analyzer_colimator_12_blade_1;
  mccomp_posr[612] = mcposrinter_analyzer_colimator_12_blade_1;
  mcNCounter[612]  = mcPCounter[612] = mcP2Counter[612] = 0;
  mcAbsorbProp[612]= 0;
    /* Component inter_analyzer_colimator_12_blade_2. */
  /* Setting parameters for component inter_analyzer_colimator_12_blade_2. */
  SIG_MESSAGE("inter_analyzer_colimator_12_blade_2 (Init:SetPar)");
#line 3361 "MACS_sample_kidney_box.instr"
  if("Collimator_gad") strncpy(mccinter_analyzer_colimator_12_blade_2_material_string, "Collimator_gad" ? "Collimator_gad" : "", 16384); else mccinter_analyzer_colimator_12_blade_2_material_string[0]='\0';
#line 3361 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_12_blade_2_priority = 1427;
#line 3360 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_12_blade_2_xwidth = inter_analyzer_colimator_width;
#line 3360 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_12_blade_2_yheight = inter_analyzer_colimator_height;
#line 3360 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_12_blade_2_zdepth = inter_analyzer_colimator_depth;
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_12_blade_2_xwidth2 = -1;
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_12_blade_2_yheight2 = -1;
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_12_blade_2_visualize = 1;
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_12_blade_2_target_index = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_12_blade_2_target_x = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_12_blade_2_target_y = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_12_blade_2_target_z = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_12_blade_2_focus_aw = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_12_blade_2_focus_ah = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_12_blade_2_focus_xw = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_12_blade_2_focus_xh = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_12_blade_2_focus_r = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_12_blade_2_p_interact = 0;
#line 71 "MACS_sample_kidney_box.instr"
  if(0) strncpy(mccinter_analyzer_colimator_12_blade_2_mask_string, 0 ? 0 : "", 16384); else mccinter_analyzer_colimator_12_blade_2_mask_string[0]='\0';
#line 71 "MACS_sample_kidney_box.instr"
  if(0) strncpy(mccinter_analyzer_colimator_12_blade_2_mask_setting, 0 ? 0 : "", 16384); else mccinter_analyzer_colimator_12_blade_2_mask_setting[0]='\0';
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_12_blade_2_number_of_activations = 1;
#line 130902 "MACS_sample_kidney_box.c"

  SIG_MESSAGE("inter_analyzer_colimator_12_blade_2 (Init:Place/Rotate)");
  rot_set_rotation(mctr1,
#line 3363 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 3363 "MACS_sample_kidney_box.instr"
    (- analyzer_2theta [ 12 ])*DEG2RAD,
#line 3363 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD);
#line 130912 "MACS_sample_kidney_box.c"
  rot_mul(mctr1, mcrotainter_analyzer_colimator_center_12, mcrotainter_analyzer_colimator_12_blade_2);
  rot_transpose(mcrotainter_analyzer_colimator_12_blade_1, mctr1);
  rot_mul(mcrotainter_analyzer_colimator_12_blade_2, mctr1, mcrotrinter_analyzer_colimator_12_blade_2);
  mctc1 = coords_set(
#line 3362 "MACS_sample_kidney_box.instr"
    0,
#line 3362 "MACS_sample_kidney_box.instr"
    0,
#line 3362 "MACS_sample_kidney_box.instr"
    inter_analyzer_colimator_start_pos - 2 * inter_analyzer_colimator_seperation);
#line 130923 "MACS_sample_kidney_box.c"
  rot_transpose(mcrotainter_analyzer_colimator_center_12, mctr1);
  mctc2 = rot_apply(mctr1, mctc1);
  mcposainter_analyzer_colimator_12_blade_2 = coords_add(mcposainter_analyzer_colimator_center_12, mctc2);
  mctc1 = coords_sub(mcposainter_analyzer_colimator_12_blade_1, mcposainter_analyzer_colimator_12_blade_2);
  mcposrinter_analyzer_colimator_12_blade_2 = rot_apply(mcrotainter_analyzer_colimator_12_blade_2, mctc1);
  mcDEBUG_COMPONENT("inter_analyzer_colimator_12_blade_2", mcposainter_analyzer_colimator_12_blade_2, mcrotainter_analyzer_colimator_12_blade_2)
  mccomp_posa[613] = mcposainter_analyzer_colimator_12_blade_2;
  mccomp_posr[613] = mcposrinter_analyzer_colimator_12_blade_2;
  mcNCounter[613]  = mcPCounter[613] = mcP2Counter[613] = 0;
  mcAbsorbProp[613]= 0;
    /* Component inter_analyzer_colimator_12_blade_3. */
  /* Setting parameters for component inter_analyzer_colimator_12_blade_3. */
  SIG_MESSAGE("inter_analyzer_colimator_12_blade_3 (Init:SetPar)");
#line 3367 "MACS_sample_kidney_box.instr"
  if("Collimator_gad") strncpy(mccinter_analyzer_colimator_12_blade_3_material_string, "Collimator_gad" ? "Collimator_gad" : "", 16384); else mccinter_analyzer_colimator_12_blade_3_material_string[0]='\0';
#line 3367 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_12_blade_3_priority = 1428;
#line 3366 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_12_blade_3_xwidth = inter_analyzer_colimator_width;
#line 3366 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_12_blade_3_yheight = inter_analyzer_colimator_height;
#line 3366 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_12_blade_3_zdepth = inter_analyzer_colimator_depth;
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_12_blade_3_xwidth2 = -1;
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_12_blade_3_yheight2 = -1;
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_12_blade_3_visualize = 1;
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_12_blade_3_target_index = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_12_blade_3_target_x = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_12_blade_3_target_y = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_12_blade_3_target_z = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_12_blade_3_focus_aw = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_12_blade_3_focus_ah = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_12_blade_3_focus_xw = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_12_blade_3_focus_xh = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_12_blade_3_focus_r = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_12_blade_3_p_interact = 0;
#line 71 "MACS_sample_kidney_box.instr"
  if(0) strncpy(mccinter_analyzer_colimator_12_blade_3_mask_string, 0 ? 0 : "", 16384); else mccinter_analyzer_colimator_12_blade_3_mask_string[0]='\0';
#line 71 "MACS_sample_kidney_box.instr"
  if(0) strncpy(mccinter_analyzer_colimator_12_blade_3_mask_setting, 0 ? 0 : "", 16384); else mccinter_analyzer_colimator_12_blade_3_mask_setting[0]='\0';
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_12_blade_3_number_of_activations = 1;
#line 130979 "MACS_sample_kidney_box.c"

  SIG_MESSAGE("inter_analyzer_colimator_12_blade_3 (Init:Place/Rotate)");
  rot_set_rotation(mctr1,
#line 3369 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 3369 "MACS_sample_kidney_box.instr"
    (- analyzer_2theta [ 12 ])*DEG2RAD,
#line 3369 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD);
#line 130989 "MACS_sample_kidney_box.c"
  rot_mul(mctr1, mcrotainter_analyzer_colimator_center_12, mcrotainter_analyzer_colimator_12_blade_3);
  rot_transpose(mcrotainter_analyzer_colimator_12_blade_2, mctr1);
  rot_mul(mcrotainter_analyzer_colimator_12_blade_3, mctr1, mcrotrinter_analyzer_colimator_12_blade_3);
  mctc1 = coords_set(
#line 3368 "MACS_sample_kidney_box.instr"
    0,
#line 3368 "MACS_sample_kidney_box.instr"
    0,
#line 3368 "MACS_sample_kidney_box.instr"
    inter_analyzer_colimator_start_pos - 3 * inter_analyzer_colimator_seperation);
#line 131000 "MACS_sample_kidney_box.c"
  rot_transpose(mcrotainter_analyzer_colimator_center_12, mctr1);
  mctc2 = rot_apply(mctr1, mctc1);
  mcposainter_analyzer_colimator_12_blade_3 = coords_add(mcposainter_analyzer_colimator_center_12, mctc2);
  mctc1 = coords_sub(mcposainter_analyzer_colimator_12_blade_2, mcposainter_analyzer_colimator_12_blade_3);
  mcposrinter_analyzer_colimator_12_blade_3 = rot_apply(mcrotainter_analyzer_colimator_12_blade_3, mctc1);
  mcDEBUG_COMPONENT("inter_analyzer_colimator_12_blade_3", mcposainter_analyzer_colimator_12_blade_3, mcrotainter_analyzer_colimator_12_blade_3)
  mccomp_posa[614] = mcposainter_analyzer_colimator_12_blade_3;
  mccomp_posr[614] = mcposrinter_analyzer_colimator_12_blade_3;
  mcNCounter[614]  = mcPCounter[614] = mcP2Counter[614] = 0;
  mcAbsorbProp[614]= 0;
    /* Component inter_analyzer_colimator_12_blade_4. */
  /* Setting parameters for component inter_analyzer_colimator_12_blade_4. */
  SIG_MESSAGE("inter_analyzer_colimator_12_blade_4 (Init:SetPar)");
#line 3373 "MACS_sample_kidney_box.instr"
  if("Collimator_gad") strncpy(mccinter_analyzer_colimator_12_blade_4_material_string, "Collimator_gad" ? "Collimator_gad" : "", 16384); else mccinter_analyzer_colimator_12_blade_4_material_string[0]='\0';
#line 3373 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_12_blade_4_priority = 1429;
#line 3372 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_12_blade_4_xwidth = inter_analyzer_colimator_width;
#line 3372 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_12_blade_4_yheight = inter_analyzer_colimator_height;
#line 3372 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_12_blade_4_zdepth = inter_analyzer_colimator_depth;
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_12_blade_4_xwidth2 = -1;
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_12_blade_4_yheight2 = -1;
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_12_blade_4_visualize = 1;
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_12_blade_4_target_index = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_12_blade_4_target_x = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_12_blade_4_target_y = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_12_blade_4_target_z = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_12_blade_4_focus_aw = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_12_blade_4_focus_ah = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_12_blade_4_focus_xw = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_12_blade_4_focus_xh = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_12_blade_4_focus_r = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_12_blade_4_p_interact = 0;
#line 71 "MACS_sample_kidney_box.instr"
  if(0) strncpy(mccinter_analyzer_colimator_12_blade_4_mask_string, 0 ? 0 : "", 16384); else mccinter_analyzer_colimator_12_blade_4_mask_string[0]='\0';
#line 71 "MACS_sample_kidney_box.instr"
  if(0) strncpy(mccinter_analyzer_colimator_12_blade_4_mask_setting, 0 ? 0 : "", 16384); else mccinter_analyzer_colimator_12_blade_4_mask_setting[0]='\0';
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_12_blade_4_number_of_activations = 1;
#line 131056 "MACS_sample_kidney_box.c"

  SIG_MESSAGE("inter_analyzer_colimator_12_blade_4 (Init:Place/Rotate)");
  rot_set_rotation(mctr1,
#line 3375 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 3375 "MACS_sample_kidney_box.instr"
    (- analyzer_2theta [ 12 ])*DEG2RAD,
#line 3375 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD);
#line 131066 "MACS_sample_kidney_box.c"
  rot_mul(mctr1, mcrotainter_analyzer_colimator_center_12, mcrotainter_analyzer_colimator_12_blade_4);
  rot_transpose(mcrotainter_analyzer_colimator_12_blade_3, mctr1);
  rot_mul(mcrotainter_analyzer_colimator_12_blade_4, mctr1, mcrotrinter_analyzer_colimator_12_blade_4);
  mctc1 = coords_set(
#line 3374 "MACS_sample_kidney_box.instr"
    0,
#line 3374 "MACS_sample_kidney_box.instr"
    0,
#line 3374 "MACS_sample_kidney_box.instr"
    inter_analyzer_colimator_start_pos - 4 * inter_analyzer_colimator_seperation);
#line 131077 "MACS_sample_kidney_box.c"
  rot_transpose(mcrotainter_analyzer_colimator_center_12, mctr1);
  mctc2 = rot_apply(mctr1, mctc1);
  mcposainter_analyzer_colimator_12_blade_4 = coords_add(mcposainter_analyzer_colimator_center_12, mctc2);
  mctc1 = coords_sub(mcposainter_analyzer_colimator_12_blade_3, mcposainter_analyzer_colimator_12_blade_4);
  mcposrinter_analyzer_colimator_12_blade_4 = rot_apply(mcrotainter_analyzer_colimator_12_blade_4, mctc1);
  mcDEBUG_COMPONENT("inter_analyzer_colimator_12_blade_4", mcposainter_analyzer_colimator_12_blade_4, mcrotainter_analyzer_colimator_12_blade_4)
  mccomp_posa[615] = mcposainter_analyzer_colimator_12_blade_4;
  mccomp_posr[615] = mcposrinter_analyzer_colimator_12_blade_4;
  mcNCounter[615]  = mcPCounter[615] = mcP2Counter[615] = 0;
  mcAbsorbProp[615]= 0;
    /* Component diffraction_detector_12_exit_volume. */
  /* Setting parameters for component diffraction_detector_12_exit_volume. */
  SIG_MESSAGE("diffraction_detector_12_exit_volume (Init:SetPar)");
#line 3379 "MACS_sample_kidney_box.instr"
  if("Exit") strncpy(mccdiffraction_detector_12_exit_volume_material_string, "Exit" ? "Exit" : "", 16384); else mccdiffraction_detector_12_exit_volume_material_string[0]='\0';
#line 3379 "MACS_sample_kidney_box.instr"
  mccdiffraction_detector_12_exit_volume_priority = 1431;
#line 3378 "MACS_sample_kidney_box.instr"
  mccdiffraction_detector_12_exit_volume_xwidth = 2.01 * detector_radius;
#line 3378 "MACS_sample_kidney_box.instr"
  mccdiffraction_detector_12_exit_volume_yheight = 1.01 * detector_height;
#line 3378 "MACS_sample_kidney_box.instr"
  mccdiffraction_detector_12_exit_volume_zdepth = 0.001;
#line 71 "MACS_sample_kidney_box.instr"
  mccdiffraction_detector_12_exit_volume_xwidth2 = -1;
#line 71 "MACS_sample_kidney_box.instr"
  mccdiffraction_detector_12_exit_volume_yheight2 = -1;
#line 71 "MACS_sample_kidney_box.instr"
  mccdiffraction_detector_12_exit_volume_visualize = 1;
#line 71 "MACS_sample_kidney_box.instr"
  mccdiffraction_detector_12_exit_volume_target_index = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccdiffraction_detector_12_exit_volume_target_x = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccdiffraction_detector_12_exit_volume_target_y = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccdiffraction_detector_12_exit_volume_target_z = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccdiffraction_detector_12_exit_volume_focus_aw = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccdiffraction_detector_12_exit_volume_focus_ah = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccdiffraction_detector_12_exit_volume_focus_xw = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccdiffraction_detector_12_exit_volume_focus_xh = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccdiffraction_detector_12_exit_volume_focus_r = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccdiffraction_detector_12_exit_volume_p_interact = 0;
#line 71 "MACS_sample_kidney_box.instr"
  if(0) strncpy(mccdiffraction_detector_12_exit_volume_mask_string, 0 ? 0 : "", 16384); else mccdiffraction_detector_12_exit_volume_mask_string[0]='\0';
#line 71 "MACS_sample_kidney_box.instr"
  if(0) strncpy(mccdiffraction_detector_12_exit_volume_mask_setting, 0 ? 0 : "", 16384); else mccdiffraction_detector_12_exit_volume_mask_setting[0]='\0';
#line 71 "MACS_sample_kidney_box.instr"
  mccdiffraction_detector_12_exit_volume_number_of_activations = 1;
#line 131133 "MACS_sample_kidney_box.c"

  SIG_MESSAGE("diffraction_detector_12_exit_volume (Init:Place/Rotate)");
  rot_set_rotation(mctr1,
#line 3381 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 3381 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 3381 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD);
#line 131143 "MACS_sample_kidney_box.c"
  rot_mul(mctr1, mcrotakidney_channel_12, mcrotadiffraction_detector_12_exit_volume);
  rot_transpose(mcrotainter_analyzer_colimator_12_blade_4, mctr1);
  rot_mul(mcrotadiffraction_detector_12_exit_volume, mctr1, mcrotrdiffraction_detector_12_exit_volume);
  mctc1 = coords_set(
#line 3380 "MACS_sample_kidney_box.instr"
    0,
#line 3380 "MACS_sample_kidney_box.instr"
    0,
#line 3380 "MACS_sample_kidney_box.instr"
    0);
#line 131154 "MACS_sample_kidney_box.c"
  rot_transpose(mcrotachannel_12_cave1_cyl1, mctr1);
  mctc2 = rot_apply(mctr1, mctc1);
  mcposadiffraction_detector_12_exit_volume = coords_add(mcposachannel_12_cave1_cyl1, mctc2);
  mctc1 = coords_sub(mcposainter_analyzer_colimator_12_blade_4, mcposadiffraction_detector_12_exit_volume);
  mcposrdiffraction_detector_12_exit_volume = rot_apply(mcrotadiffraction_detector_12_exit_volume, mctc1);
  mcDEBUG_COMPONENT("diffraction_detector_12_exit_volume", mcposadiffraction_detector_12_exit_volume, mcrotadiffraction_detector_12_exit_volume)
  mccomp_posa[616] = mcposadiffraction_detector_12_exit_volume;
  mccomp_posr[616] = mcposrdiffraction_detector_12_exit_volume;
  mcNCounter[616]  = mcPCounter[616] = mcP2Counter[616] = 0;
  mcAbsorbProp[616]= 0;
    /* Component spec_detector_12_exit_volume. */
  /* Setting parameters for component spec_detector_12_exit_volume. */
  SIG_MESSAGE("spec_detector_12_exit_volume (Init:SetPar)");
#line 3385 "MACS_sample_kidney_box.instr"
  if("Exit") strncpy(mccspec_detector_12_exit_volume_material_string, "Exit" ? "Exit" : "", 16384); else mccspec_detector_12_exit_volume_material_string[0]='\0';
#line 3385 "MACS_sample_kidney_box.instr"
  mccspec_detector_12_exit_volume_priority = 1432;
#line 3384 "MACS_sample_kidney_box.instr"
  mccspec_detector_12_exit_volume_xwidth = 2.01 * detector_radius;
#line 3384 "MACS_sample_kidney_box.instr"
  mccspec_detector_12_exit_volume_yheight = 1.01 * detector_height;
#line 3384 "MACS_sample_kidney_box.instr"
  mccspec_detector_12_exit_volume_zdepth = 0.001;
#line 71 "MACS_sample_kidney_box.instr"
  mccspec_detector_12_exit_volume_xwidth2 = -1;
#line 71 "MACS_sample_kidney_box.instr"
  mccspec_detector_12_exit_volume_yheight2 = -1;
#line 71 "MACS_sample_kidney_box.instr"
  mccspec_detector_12_exit_volume_visualize = 1;
#line 71 "MACS_sample_kidney_box.instr"
  mccspec_detector_12_exit_volume_target_index = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccspec_detector_12_exit_volume_target_x = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccspec_detector_12_exit_volume_target_y = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccspec_detector_12_exit_volume_target_z = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccspec_detector_12_exit_volume_focus_aw = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccspec_detector_12_exit_volume_focus_ah = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccspec_detector_12_exit_volume_focus_xw = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccspec_detector_12_exit_volume_focus_xh = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccspec_detector_12_exit_volume_focus_r = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccspec_detector_12_exit_volume_p_interact = 0;
#line 71 "MACS_sample_kidney_box.instr"
  if(0) strncpy(mccspec_detector_12_exit_volume_mask_string, 0 ? 0 : "", 16384); else mccspec_detector_12_exit_volume_mask_string[0]='\0';
#line 71 "MACS_sample_kidney_box.instr"
  if(0) strncpy(mccspec_detector_12_exit_volume_mask_setting, 0 ? 0 : "", 16384); else mccspec_detector_12_exit_volume_mask_setting[0]='\0';
#line 71 "MACS_sample_kidney_box.instr"
  mccspec_detector_12_exit_volume_number_of_activations = 1;
#line 131210 "MACS_sample_kidney_box.c"

  SIG_MESSAGE("spec_detector_12_exit_volume (Init:Place/Rotate)");
  rot_set_rotation(mctr1,
#line 3387 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 3387 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 3387 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD);
#line 131220 "MACS_sample_kidney_box.c"
  rot_mul(mctr1, mcrotachannel_12_analyzer_2_center, mcrotaspec_detector_12_exit_volume);
  rot_transpose(mcrotadiffraction_detector_12_exit_volume, mctr1);
  rot_mul(mcrotaspec_detector_12_exit_volume, mctr1, mcrotrspec_detector_12_exit_volume);
  mctc1 = coords_set(
#line 3386 "MACS_sample_kidney_box.instr"
    0,
#line 3386 "MACS_sample_kidney_box.instr"
    0,
#line 3386 "MACS_sample_kidney_box.instr"
    0);
#line 131231 "MACS_sample_kidney_box.c"
  rot_transpose(mcrotachannel_12_cave2_cyl1, mctr1);
  mctc2 = rot_apply(mctr1, mctc1);
  mcposaspec_detector_12_exit_volume = coords_add(mcposachannel_12_cave2_cyl1, mctc2);
  mctc1 = coords_sub(mcposadiffraction_detector_12_exit_volume, mcposaspec_detector_12_exit_volume);
  mcposrspec_detector_12_exit_volume = rot_apply(mcrotaspec_detector_12_exit_volume, mctc1);
  mcDEBUG_COMPONENT("spec_detector_12_exit_volume", mcposaspec_detector_12_exit_volume, mcrotaspec_detector_12_exit_volume)
  mccomp_posa[617] = mcposaspec_detector_12_exit_volume;
  mccomp_posr[617] = mcposrspec_detector_12_exit_volume;
  mcNCounter[617]  = mcPCounter[617] = mcP2Counter[617] = 0;
  mcAbsorbProp[617]= 0;
    /* Component channel_13_cave1_box1. */
  /* Setting parameters for component channel_13_cave1_box1. */
  SIG_MESSAGE("channel_13_cave1_box1 (Init:SetPar)");
#line 3392 "MACS_sample_kidney_box.instr"
  if("Vacuum") strncpy(mccchannel_13_cave1_box1_material_string, "Vacuum" ? "Vacuum" : "", 16384); else mccchannel_13_cave1_box1_material_string[0]='\0';
#line 3392 "MACS_sample_kidney_box.instr"
  mccchannel_13_cave1_box1_priority = 1500;
#line 3390 "MACS_sample_kidney_box.instr"
  mccchannel_13_cave1_box1_xwidth = kidney_cave1_box1_width1;
#line 3390 "MACS_sample_kidney_box.instr"
  mccchannel_13_cave1_box1_yheight = kidney_cave1_box1_height1;
#line 3390 "MACS_sample_kidney_box.instr"
  mccchannel_13_cave1_box1_zdepth = kidney_cave1_box1_depth;
#line 3391 "MACS_sample_kidney_box.instr"
  mccchannel_13_cave1_box1_xwidth2 = kidney_cave1_box1_width2;
#line 3391 "MACS_sample_kidney_box.instr"
  mccchannel_13_cave1_box1_yheight2 = kidney_cave1_box1_height2;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_13_cave1_box1_visualize = 1;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_13_cave1_box1_target_index = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_13_cave1_box1_target_x = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_13_cave1_box1_target_y = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_13_cave1_box1_target_z = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_13_cave1_box1_focus_aw = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_13_cave1_box1_focus_ah = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_13_cave1_box1_focus_xw = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_13_cave1_box1_focus_xh = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_13_cave1_box1_focus_r = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_13_cave1_box1_p_interact = 0;
#line 71 "MACS_sample_kidney_box.instr"
  if(0) strncpy(mccchannel_13_cave1_box1_mask_string, 0 ? 0 : "", 16384); else mccchannel_13_cave1_box1_mask_string[0]='\0';
#line 71 "MACS_sample_kidney_box.instr"
  if(0) strncpy(mccchannel_13_cave1_box1_mask_setting, 0 ? 0 : "", 16384); else mccchannel_13_cave1_box1_mask_setting[0]='\0';
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_13_cave1_box1_number_of_activations = 1;
#line 131287 "MACS_sample_kidney_box.c"

  SIG_MESSAGE("channel_13_cave1_box1 (Init:Place/Rotate)");
  rot_set_rotation(mctr1,
#line 3394 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 3394 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 3394 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD);
#line 131297 "MACS_sample_kidney_box.c"
  rot_mul(mctr1, mcrotakidney_channel_13, mcrotachannel_13_cave1_box1);
  rot_transpose(mcrotaspec_detector_12_exit_volume, mctr1);
  rot_mul(mcrotachannel_13_cave1_box1, mctr1, mcrotrchannel_13_cave1_box1);
  mctc1 = coords_set(
#line 3393 "MACS_sample_kidney_box.instr"
    0,
#line 3393 "MACS_sample_kidney_box.instr"
    0,
#line 3393 "MACS_sample_kidney_box.instr"
    kidney_cave1_box1_center_to_target);
#line 131308 "MACS_sample_kidney_box.c"
  rot_transpose(mcrotakidney_channel_13, mctr1);
  mctc2 = rot_apply(mctr1, mctc1);
  mcposachannel_13_cave1_box1 = coords_add(mcposakidney_channel_13, mctc2);
  mctc1 = coords_sub(mcposaspec_detector_12_exit_volume, mcposachannel_13_cave1_box1);
  mcposrchannel_13_cave1_box1 = rot_apply(mcrotachannel_13_cave1_box1, mctc1);
  mcDEBUG_COMPONENT("channel_13_cave1_box1", mcposachannel_13_cave1_box1, mcrotachannel_13_cave1_box1)
  mccomp_posa[618] = mcposachannel_13_cave1_box1;
  mccomp_posr[618] = mcposrchannel_13_cave1_box1;
  mcNCounter[618]  = mcPCounter[618] = mcP2Counter[618] = 0;
  mcAbsorbProp[618]= 0;
    /* Component channel_13_cave1_box2. */
  /* Setting parameters for component channel_13_cave1_box2. */
  SIG_MESSAGE("channel_13_cave1_box2 (Init:SetPar)");
#line 3399 "MACS_sample_kidney_box.instr"
  if("Vacuum") strncpy(mccchannel_13_cave1_box2_material_string, "Vacuum" ? "Vacuum" : "", 16384); else mccchannel_13_cave1_box2_material_string[0]='\0';
#line 3399 "MACS_sample_kidney_box.instr"
  mccchannel_13_cave1_box2_priority = 1505;
#line 3397 "MACS_sample_kidney_box.instr"
  mccchannel_13_cave1_box2_xwidth = kidney_cave1_box2_width1;
#line 3397 "MACS_sample_kidney_box.instr"
  mccchannel_13_cave1_box2_yheight = kidney_cave1_box2_height1;
#line 3397 "MACS_sample_kidney_box.instr"
  mccchannel_13_cave1_box2_zdepth = kidney_cave1_box2_depth;
#line 3398 "MACS_sample_kidney_box.instr"
  mccchannel_13_cave1_box2_xwidth2 = kidney_cave1_box2_width2;
#line 3398 "MACS_sample_kidney_box.instr"
  mccchannel_13_cave1_box2_yheight2 = kidney_cave1_box2_height2;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_13_cave1_box2_visualize = 1;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_13_cave1_box2_target_index = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_13_cave1_box2_target_x = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_13_cave1_box2_target_y = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_13_cave1_box2_target_z = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_13_cave1_box2_focus_aw = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_13_cave1_box2_focus_ah = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_13_cave1_box2_focus_xw = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_13_cave1_box2_focus_xh = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_13_cave1_box2_focus_r = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_13_cave1_box2_p_interact = 0;
#line 71 "MACS_sample_kidney_box.instr"
  if(0) strncpy(mccchannel_13_cave1_box2_mask_string, 0 ? 0 : "", 16384); else mccchannel_13_cave1_box2_mask_string[0]='\0';
#line 71 "MACS_sample_kidney_box.instr"
  if(0) strncpy(mccchannel_13_cave1_box2_mask_setting, 0 ? 0 : "", 16384); else mccchannel_13_cave1_box2_mask_setting[0]='\0';
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_13_cave1_box2_number_of_activations = 1;
#line 131364 "MACS_sample_kidney_box.c"

  SIG_MESSAGE("channel_13_cave1_box2 (Init:Place/Rotate)");
  rot_set_rotation(mctr1,
#line 3401 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 3401 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 3401 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD);
#line 131374 "MACS_sample_kidney_box.c"
  rot_mul(mctr1, mcrotakidney_channel_13, mcrotachannel_13_cave1_box2);
  rot_transpose(mcrotachannel_13_cave1_box1, mctr1);
  rot_mul(mcrotachannel_13_cave1_box2, mctr1, mcrotrchannel_13_cave1_box2);
  mctc1 = coords_set(
#line 3400 "MACS_sample_kidney_box.instr"
    kidney_cave1_box2_x_offset,
#line 3400 "MACS_sample_kidney_box.instr"
    0,
#line 3400 "MACS_sample_kidney_box.instr"
    kidney_cave1_box2_center_to_target);
#line 131385 "MACS_sample_kidney_box.c"
  rot_transpose(mcrotakidney_channel_13, mctr1);
  mctc2 = rot_apply(mctr1, mctc1);
  mcposachannel_13_cave1_box2 = coords_add(mcposakidney_channel_13, mctc2);
  mctc1 = coords_sub(mcposachannel_13_cave1_box1, mcposachannel_13_cave1_box2);
  mcposrchannel_13_cave1_box2 = rot_apply(mcrotachannel_13_cave1_box2, mctc1);
  mcDEBUG_COMPONENT("channel_13_cave1_box2", mcposachannel_13_cave1_box2, mcrotachannel_13_cave1_box2)
  mccomp_posa[619] = mcposachannel_13_cave1_box2;
  mccomp_posr[619] = mcposrchannel_13_cave1_box2;
  mcNCounter[619]  = mcPCounter[619] = mcP2Counter[619] = 0;
  mcAbsorbProp[619]= 0;
    /* Component channel_13_cave1_box3. */
  /* Setting parameters for component channel_13_cave1_box3. */
  SIG_MESSAGE("channel_13_cave1_box3 (Init:SetPar)");
#line 3406 "MACS_sample_kidney_box.instr"
  if("Vacuum") strncpy(mccchannel_13_cave1_box3_material_string, "Vacuum" ? "Vacuum" : "", 16384); else mccchannel_13_cave1_box3_material_string[0]='\0';
#line 3406 "MACS_sample_kidney_box.instr"
  mccchannel_13_cave1_box3_priority = 1502;
#line 3404 "MACS_sample_kidney_box.instr"
  mccchannel_13_cave1_box3_xwidth = kidney_cave1_box3_width1;
#line 3404 "MACS_sample_kidney_box.instr"
  mccchannel_13_cave1_box3_yheight = kidney_cave1_box3_height1;
#line 3404 "MACS_sample_kidney_box.instr"
  mccchannel_13_cave1_box3_zdepth = kidney_cave1_box3_depth;
#line 3405 "MACS_sample_kidney_box.instr"
  mccchannel_13_cave1_box3_xwidth2 = kidney_cave1_box3_width2;
#line 3405 "MACS_sample_kidney_box.instr"
  mccchannel_13_cave1_box3_yheight2 = kidney_cave1_box3_height2;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_13_cave1_box3_visualize = 1;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_13_cave1_box3_target_index = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_13_cave1_box3_target_x = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_13_cave1_box3_target_y = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_13_cave1_box3_target_z = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_13_cave1_box3_focus_aw = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_13_cave1_box3_focus_ah = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_13_cave1_box3_focus_xw = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_13_cave1_box3_focus_xh = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_13_cave1_box3_focus_r = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_13_cave1_box3_p_interact = 0;
#line 71 "MACS_sample_kidney_box.instr"
  if(0) strncpy(mccchannel_13_cave1_box3_mask_string, 0 ? 0 : "", 16384); else mccchannel_13_cave1_box3_mask_string[0]='\0';
#line 71 "MACS_sample_kidney_box.instr"
  if(0) strncpy(mccchannel_13_cave1_box3_mask_setting, 0 ? 0 : "", 16384); else mccchannel_13_cave1_box3_mask_setting[0]='\0';
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_13_cave1_box3_number_of_activations = 1;
#line 131441 "MACS_sample_kidney_box.c"

  SIG_MESSAGE("channel_13_cave1_box3 (Init:Place/Rotate)");
  rot_set_rotation(mctr1,
#line 3408 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 3408 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 3408 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD);
#line 131451 "MACS_sample_kidney_box.c"
  rot_mul(mctr1, mcrotakidney_channel_13, mcrotachannel_13_cave1_box3);
  rot_transpose(mcrotachannel_13_cave1_box2, mctr1);
  rot_mul(mcrotachannel_13_cave1_box3, mctr1, mcrotrchannel_13_cave1_box3);
  mctc1 = coords_set(
#line 3407 "MACS_sample_kidney_box.instr"
    0,
#line 3407 "MACS_sample_kidney_box.instr"
    0,
#line 3407 "MACS_sample_kidney_box.instr"
    kidney_cave1_box3_center_to_target);
#line 131462 "MACS_sample_kidney_box.c"
  rot_transpose(mcrotakidney_channel_13, mctr1);
  mctc2 = rot_apply(mctr1, mctc1);
  mcposachannel_13_cave1_box3 = coords_add(mcposakidney_channel_13, mctc2);
  mctc1 = coords_sub(mcposachannel_13_cave1_box2, mcposachannel_13_cave1_box3);
  mcposrchannel_13_cave1_box3 = rot_apply(mcrotachannel_13_cave1_box3, mctc1);
  mcDEBUG_COMPONENT("channel_13_cave1_box3", mcposachannel_13_cave1_box3, mcrotachannel_13_cave1_box3)
  mccomp_posa[620] = mcposachannel_13_cave1_box3;
  mccomp_posr[620] = mcposrchannel_13_cave1_box3;
  mcNCounter[620]  = mcPCounter[620] = mcP2Counter[620] = 0;
  mcAbsorbProp[620]= 0;
    /* Component channel_13_cave1_cyl1. */
  /* Setting parameters for component channel_13_cave1_cyl1. */
  SIG_MESSAGE("channel_13_cave1_cyl1 (Init:SetPar)");
#line 3412 "MACS_sample_kidney_box.instr"
  if("Vacuum") strncpy(mccchannel_13_cave1_cyl1_material_string, "Vacuum" ? "Vacuum" : "", 16384); else mccchannel_13_cave1_cyl1_material_string[0]='\0';
#line 3412 "MACS_sample_kidney_box.instr"
  mccchannel_13_cave1_cyl1_priority = 1503;
#line 3411 "MACS_sample_kidney_box.instr"
  mccchannel_13_cave1_cyl1_radius = kidney_cave1_cyl1_radius;
#line 3411 "MACS_sample_kidney_box.instr"
  mccchannel_13_cave1_cyl1_yheight = kidney_cave1_cyl1_height;
#line 67 "MACS_sample_kidney_box.instr"
  mccchannel_13_cave1_cyl1_visualize = 1;
#line 67 "MACS_sample_kidney_box.instr"
  mccchannel_13_cave1_cyl1_target_index = 0;
#line 67 "MACS_sample_kidney_box.instr"
  mccchannel_13_cave1_cyl1_target_x = 0;
#line 67 "MACS_sample_kidney_box.instr"
  mccchannel_13_cave1_cyl1_target_y = 0;
#line 67 "MACS_sample_kidney_box.instr"
  mccchannel_13_cave1_cyl1_target_z = 0;
#line 67 "MACS_sample_kidney_box.instr"
  mccchannel_13_cave1_cyl1_focus_aw = 0;
#line 67 "MACS_sample_kidney_box.instr"
  mccchannel_13_cave1_cyl1_focus_ah = 0;
#line 67 "MACS_sample_kidney_box.instr"
  mccchannel_13_cave1_cyl1_focus_xw = 0;
#line 67 "MACS_sample_kidney_box.instr"
  mccchannel_13_cave1_cyl1_focus_xh = 0;
#line 67 "MACS_sample_kidney_box.instr"
  mccchannel_13_cave1_cyl1_focus_r = 0;
#line 67 "MACS_sample_kidney_box.instr"
  mccchannel_13_cave1_cyl1_p_interact = 0;
#line 67 "MACS_sample_kidney_box.instr"
  if(0) strncpy(mccchannel_13_cave1_cyl1_mask_string, 0 ? 0 : "", 16384); else mccchannel_13_cave1_cyl1_mask_string[0]='\0';
#line 67 "MACS_sample_kidney_box.instr"
  if(0) strncpy(mccchannel_13_cave1_cyl1_mask_setting, 0 ? 0 : "", 16384); else mccchannel_13_cave1_cyl1_mask_setting[0]='\0';
#line 67 "MACS_sample_kidney_box.instr"
  mccchannel_13_cave1_cyl1_number_of_activations = 1;
#line 131512 "MACS_sample_kidney_box.c"

  SIG_MESSAGE("channel_13_cave1_cyl1 (Init:Place/Rotate)");
  rot_set_rotation(mctr1,
#line 3414 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 3414 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 3414 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD);
#line 131522 "MACS_sample_kidney_box.c"
  rot_mul(mctr1, mcrotakidney_channel_13, mcrotachannel_13_cave1_cyl1);
  rot_transpose(mcrotachannel_13_cave1_box3, mctr1);
  rot_mul(mcrotachannel_13_cave1_cyl1, mctr1, mcrotrchannel_13_cave1_cyl1);
  mctc1 = coords_set(
#line 3413 "MACS_sample_kidney_box.instr"
    0,
#line 3413 "MACS_sample_kidney_box.instr"
    0,
#line 3413 "MACS_sample_kidney_box.instr"
    kidney_cave1_cyl1_center_to_target);
#line 131533 "MACS_sample_kidney_box.c"
  rot_transpose(mcrotakidney_channel_13, mctr1);
  mctc2 = rot_apply(mctr1, mctc1);
  mcposachannel_13_cave1_cyl1 = coords_add(mcposakidney_channel_13, mctc2);
  mctc1 = coords_sub(mcposachannel_13_cave1_box3, mcposachannel_13_cave1_cyl1);
  mcposrchannel_13_cave1_cyl1 = rot_apply(mcrotachannel_13_cave1_cyl1, mctc1);
  mcDEBUG_COMPONENT("channel_13_cave1_cyl1", mcposachannel_13_cave1_cyl1, mcrotachannel_13_cave1_cyl1)
  mccomp_posa[621] = mcposachannel_13_cave1_cyl1;
  mccomp_posr[621] = mcposrchannel_13_cave1_cyl1;
  mcNCounter[621]  = mcPCounter[621] = mcP2Counter[621] = 0;
  mcAbsorbProp[621]= 0;
    /* Component channel_13_analyzer_1_center. */
  /* Setting parameters for component channel_13_analyzer_1_center. */
  SIG_MESSAGE("channel_13_analyzer_1_center (Init:SetPar)");

  SIG_MESSAGE("channel_13_analyzer_1_center (Init:Place/Rotate)");
  rot_set_rotation(mctr1,
    (0.0)*DEG2RAD,
    (0.0)*DEG2RAD,
    (0.0)*DEG2RAD);
#line 131553 "MACS_sample_kidney_box.c"
  rot_mul(mctr1, mcrotakidney_channel_13, mcrotachannel_13_analyzer_1_center);
  rot_transpose(mcrotachannel_13_cave1_cyl1, mctr1);
  rot_mul(mcrotachannel_13_analyzer_1_center, mctr1, mcrotrchannel_13_analyzer_1_center);
  mctc1 = coords_set(
#line 3418 "MACS_sample_kidney_box.instr"
    0,
#line 3418 "MACS_sample_kidney_box.instr"
    0,
#line 3418 "MACS_sample_kidney_box.instr"
    analyzer_1_center_to_sample);
#line 131564 "MACS_sample_kidney_box.c"
  rot_transpose(mcrotakidney_channel_13, mctr1);
  mctc2 = rot_apply(mctr1, mctc1);
  mcposachannel_13_analyzer_1_center = coords_add(mcposakidney_channel_13, mctc2);
  mctc1 = coords_sub(mcposachannel_13_cave1_cyl1, mcposachannel_13_analyzer_1_center);
  mcposrchannel_13_analyzer_1_center = rot_apply(mcrotachannel_13_analyzer_1_center, mctc1);
  mcDEBUG_COMPONENT("channel_13_analyzer_1_center", mcposachannel_13_analyzer_1_center, mcrotachannel_13_analyzer_1_center)
  mccomp_posa[622] = mcposachannel_13_analyzer_1_center;
  mccomp_posr[622] = mcposrchannel_13_analyzer_1_center;
  mcNCounter[622]  = mcPCounter[622] = mcP2Counter[622] = 0;
  mcAbsorbProp[622]= 0;
    /* Component channel_13_analyzer_1_rotated. */
  /* Setting parameters for component channel_13_analyzer_1_rotated. */
  SIG_MESSAGE("channel_13_analyzer_1_rotated (Init:SetPar)");

  SIG_MESSAGE("channel_13_analyzer_1_rotated (Init:Place/Rotate)");
  rot_set_rotation(mctr1,
#line 3422 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 3422 "MACS_sample_kidney_box.instr"
    (180 - analyzer_theta [ 13 ])*DEG2RAD,
#line 3422 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD);
#line 131587 "MACS_sample_kidney_box.c"
  rot_mul(mctr1, mcrotachannel_13_analyzer_1_center, mcrotachannel_13_analyzer_1_rotated);
  rot_transpose(mcrotachannel_13_analyzer_1_center, mctr1);
  rot_mul(mcrotachannel_13_analyzer_1_rotated, mctr1, mcrotrchannel_13_analyzer_1_rotated);
  mctc1 = coords_set(
#line 3421 "MACS_sample_kidney_box.instr"
    0,
#line 3421 "MACS_sample_kidney_box.instr"
    0,
#line 3421 "MACS_sample_kidney_box.instr"
    -0.5 * analyzer_seperation / tan ( analyzer_2theta [ 13 ] * DEG2RAD ));
#line 131598 "MACS_sample_kidney_box.c"
  rot_transpose(mcrotachannel_13_analyzer_1_center, mctr1);
  mctc2 = rot_apply(mctr1, mctc1);
  mcposachannel_13_analyzer_1_rotated = coords_add(mcposachannel_13_analyzer_1_center, mctc2);
  mctc1 = coords_sub(mcposachannel_13_analyzer_1_center, mcposachannel_13_analyzer_1_rotated);
  mcposrchannel_13_analyzer_1_rotated = rot_apply(mcrotachannel_13_analyzer_1_rotated, mctc1);
  mcDEBUG_COMPONENT("channel_13_analyzer_1_rotated", mcposachannel_13_analyzer_1_rotated, mcrotachannel_13_analyzer_1_rotated)
  mccomp_posa[623] = mcposachannel_13_analyzer_1_rotated;
  mccomp_posr[623] = mcposrchannel_13_analyzer_1_rotated;
  mcNCounter[623]  = mcPCounter[623] = mcP2Counter[623] = 0;
  mcAbsorbProp[623]= 0;
    /* Component channel_13_analyzer_1_array_crystal_array_0. */
  /* Setting parameters for component channel_13_analyzer_1_array_crystal_array_0. */
  SIG_MESSAGE("channel_13_analyzer_1_array_crystal_array_0 (Init:SetPar)");
#line 3426 "MACS_sample_kidney_box.instr"
  if("PG_analyzer") strncpy(mccchannel_13_analyzer_1_array_crystal_array_0_material_string, "PG_analyzer" ? "PG_analyzer" : "", 16384); else mccchannel_13_analyzer_1_array_crystal_array_0_material_string[0]='\0';
#line 3426 "MACS_sample_kidney_box.instr"
  mccchannel_13_analyzer_1_array_crystal_array_0_priority = 1520.0;
#line 3425 "MACS_sample_kidney_box.instr"
  mccchannel_13_analyzer_1_array_crystal_array_0_xwidth = channel_13_analyzer_1_array_crystal_depth;
#line 3425 "MACS_sample_kidney_box.instr"
  mccchannel_13_analyzer_1_array_crystal_array_0_yheight = channel_13_analyzer_1_array_crystal_height;
#line 3425 "MACS_sample_kidney_box.instr"
  mccchannel_13_analyzer_1_array_crystal_array_0_zdepth = channel_13_analyzer_1_array_crystal_width;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_13_analyzer_1_array_crystal_array_0_xwidth2 = -1;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_13_analyzer_1_array_crystal_array_0_yheight2 = -1;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_13_analyzer_1_array_crystal_array_0_visualize = 1;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_13_analyzer_1_array_crystal_array_0_target_index = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_13_analyzer_1_array_crystal_array_0_target_x = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_13_analyzer_1_array_crystal_array_0_target_y = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_13_analyzer_1_array_crystal_array_0_target_z = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_13_analyzer_1_array_crystal_array_0_focus_aw = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_13_analyzer_1_array_crystal_array_0_focus_ah = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_13_analyzer_1_array_crystal_array_0_focus_xw = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_13_analyzer_1_array_crystal_array_0_focus_xh = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_13_analyzer_1_array_crystal_array_0_focus_r = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_13_analyzer_1_array_crystal_array_0_p_interact = 0;
#line 71 "MACS_sample_kidney_box.instr"
  if(0) strncpy(mccchannel_13_analyzer_1_array_crystal_array_0_mask_string, 0 ? 0 : "", 16384); else mccchannel_13_analyzer_1_array_crystal_array_0_mask_string[0]='\0';
#line 71 "MACS_sample_kidney_box.instr"
  if(0) strncpy(mccchannel_13_analyzer_1_array_crystal_array_0_mask_setting, 0 ? 0 : "", 16384); else mccchannel_13_analyzer_1_array_crystal_array_0_mask_setting[0]='\0';
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_13_analyzer_1_array_crystal_array_0_number_of_activations = 1;
#line 131654 "MACS_sample_kidney_box.c"

  SIG_MESSAGE("channel_13_analyzer_1_array_crystal_array_0 (Init:Place/Rotate)");
  rot_set_rotation(mctr1,
#line 3428 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 3428 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 3428 "MACS_sample_kidney_box.instr"
    (0 - RAD2DEG * channel_13_analyzer_1_array_theta [ 0 ])*DEG2RAD);
#line 131664 "MACS_sample_kidney_box.c"
  rot_mul(mctr1, mcrotachannel_13_analyzer_1_rotated, mcrotachannel_13_analyzer_1_array_crystal_array_0);
  rot_transpose(mcrotachannel_13_analyzer_1_rotated, mctr1);
  rot_mul(mcrotachannel_13_analyzer_1_array_crystal_array_0, mctr1, mcrotrchannel_13_analyzer_1_array_crystal_array_0);
  mctc1 = coords_set(
#line 3427 "MACS_sample_kidney_box.instr"
    0 + channel_13_analyzer_1_array_effective_radius_of_curvature * ( 1 - cos ( channel_13_analyzer_1_array_theta [ 0 ] ) ),
#line 3427 "MACS_sample_kidney_box.instr"
    0 + channel_13_analyzer_1_array_effective_radius_of_curvature * sin ( channel_13_analyzer_1_array_theta [ 0 ] ),
#line 3427 "MACS_sample_kidney_box.instr"
    0);
#line 131675 "MACS_sample_kidney_box.c"
  rot_transpose(mcrotachannel_13_analyzer_1_rotated, mctr1);
  mctc2 = rot_apply(mctr1, mctc1);
  mcposachannel_13_analyzer_1_array_crystal_array_0 = coords_add(mcposachannel_13_analyzer_1_rotated, mctc2);
  mctc1 = coords_sub(mcposachannel_13_analyzer_1_rotated, mcposachannel_13_analyzer_1_array_crystal_array_0);
  mcposrchannel_13_analyzer_1_array_crystal_array_0 = rot_apply(mcrotachannel_13_analyzer_1_array_crystal_array_0, mctc1);
  mcDEBUG_COMPONENT("channel_13_analyzer_1_array_crystal_array_0", mcposachannel_13_analyzer_1_array_crystal_array_0, mcrotachannel_13_analyzer_1_array_crystal_array_0)
  mccomp_posa[624] = mcposachannel_13_analyzer_1_array_crystal_array_0;
  mccomp_posr[624] = mcposrchannel_13_analyzer_1_array_crystal_array_0;
  mcNCounter[624]  = mcPCounter[624] = mcP2Counter[624] = 0;
  mcAbsorbProp[624]= 0;
    /* Component channel_13_analyzer_1_array_crystal_array_1. */
  /* Setting parameters for component channel_13_analyzer_1_array_crystal_array_1. */
  SIG_MESSAGE("channel_13_analyzer_1_array_crystal_array_1 (Init:SetPar)");
#line 3432 "MACS_sample_kidney_box.instr"
  if("PG_analyzer") strncpy(mccchannel_13_analyzer_1_array_crystal_array_1_material_string, "PG_analyzer" ? "PG_analyzer" : "", 16384); else mccchannel_13_analyzer_1_array_crystal_array_1_material_string[0]='\0';
#line 3432 "MACS_sample_kidney_box.instr"
  mccchannel_13_analyzer_1_array_crystal_array_1_priority = 1520.1;
#line 3431 "MACS_sample_kidney_box.instr"
  mccchannel_13_analyzer_1_array_crystal_array_1_xwidth = channel_13_analyzer_1_array_crystal_depth;
#line 3431 "MACS_sample_kidney_box.instr"
  mccchannel_13_analyzer_1_array_crystal_array_1_yheight = channel_13_analyzer_1_array_crystal_height;
#line 3431 "MACS_sample_kidney_box.instr"
  mccchannel_13_analyzer_1_array_crystal_array_1_zdepth = channel_13_analyzer_1_array_crystal_width;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_13_analyzer_1_array_crystal_array_1_xwidth2 = -1;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_13_analyzer_1_array_crystal_array_1_yheight2 = -1;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_13_analyzer_1_array_crystal_array_1_visualize = 1;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_13_analyzer_1_array_crystal_array_1_target_index = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_13_analyzer_1_array_crystal_array_1_target_x = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_13_analyzer_1_array_crystal_array_1_target_y = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_13_analyzer_1_array_crystal_array_1_target_z = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_13_analyzer_1_array_crystal_array_1_focus_aw = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_13_analyzer_1_array_crystal_array_1_focus_ah = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_13_analyzer_1_array_crystal_array_1_focus_xw = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_13_analyzer_1_array_crystal_array_1_focus_xh = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_13_analyzer_1_array_crystal_array_1_focus_r = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_13_analyzer_1_array_crystal_array_1_p_interact = 0;
#line 71 "MACS_sample_kidney_box.instr"
  if(0) strncpy(mccchannel_13_analyzer_1_array_crystal_array_1_mask_string, 0 ? 0 : "", 16384); else mccchannel_13_analyzer_1_array_crystal_array_1_mask_string[0]='\0';
#line 71 "MACS_sample_kidney_box.instr"
  if(0) strncpy(mccchannel_13_analyzer_1_array_crystal_array_1_mask_setting, 0 ? 0 : "", 16384); else mccchannel_13_analyzer_1_array_crystal_array_1_mask_setting[0]='\0';
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_13_analyzer_1_array_crystal_array_1_number_of_activations = 1;
#line 131731 "MACS_sample_kidney_box.c"

  SIG_MESSAGE("channel_13_analyzer_1_array_crystal_array_1 (Init:Place/Rotate)");
  rot_set_rotation(mctr1,
#line 3434 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 3434 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 3434 "MACS_sample_kidney_box.instr"
    (0 - RAD2DEG * channel_13_analyzer_1_array_theta [ 1 ])*DEG2RAD);
#line 131741 "MACS_sample_kidney_box.c"
  rot_mul(mctr1, mcrotachannel_13_analyzer_1_rotated, mcrotachannel_13_analyzer_1_array_crystal_array_1);
  rot_transpose(mcrotachannel_13_analyzer_1_array_crystal_array_0, mctr1);
  rot_mul(mcrotachannel_13_analyzer_1_array_crystal_array_1, mctr1, mcrotrchannel_13_analyzer_1_array_crystal_array_1);
  mctc1 = coords_set(
#line 3433 "MACS_sample_kidney_box.instr"
    0 + channel_13_analyzer_1_array_effective_radius_of_curvature * ( 1 - cos ( channel_13_analyzer_1_array_theta [ 1 ] ) ),
#line 3433 "MACS_sample_kidney_box.instr"
    0 + channel_13_analyzer_1_array_effective_radius_of_curvature * sin ( channel_13_analyzer_1_array_theta [ 1 ] ),
#line 3433 "MACS_sample_kidney_box.instr"
    0);
#line 131752 "MACS_sample_kidney_box.c"
  rot_transpose(mcrotachannel_13_analyzer_1_rotated, mctr1);
  mctc2 = rot_apply(mctr1, mctc1);
  mcposachannel_13_analyzer_1_array_crystal_array_1 = coords_add(mcposachannel_13_analyzer_1_rotated, mctc2);
  mctc1 = coords_sub(mcposachannel_13_analyzer_1_array_crystal_array_0, mcposachannel_13_analyzer_1_array_crystal_array_1);
  mcposrchannel_13_analyzer_1_array_crystal_array_1 = rot_apply(mcrotachannel_13_analyzer_1_array_crystal_array_1, mctc1);
  mcDEBUG_COMPONENT("channel_13_analyzer_1_array_crystal_array_1", mcposachannel_13_analyzer_1_array_crystal_array_1, mcrotachannel_13_analyzer_1_array_crystal_array_1)
  mccomp_posa[625] = mcposachannel_13_analyzer_1_array_crystal_array_1;
  mccomp_posr[625] = mcposrchannel_13_analyzer_1_array_crystal_array_1;
  mcNCounter[625]  = mcPCounter[625] = mcP2Counter[625] = 0;
  mcAbsorbProp[625]= 0;
    /* Component channel_13_analyzer_1_array_crystal_array_2. */
  /* Setting parameters for component channel_13_analyzer_1_array_crystal_array_2. */
  SIG_MESSAGE("channel_13_analyzer_1_array_crystal_array_2 (Init:SetPar)");
#line 3438 "MACS_sample_kidney_box.instr"
  if("PG_analyzer") strncpy(mccchannel_13_analyzer_1_array_crystal_array_2_material_string, "PG_analyzer" ? "PG_analyzer" : "", 16384); else mccchannel_13_analyzer_1_array_crystal_array_2_material_string[0]='\0';
#line 3438 "MACS_sample_kidney_box.instr"
  mccchannel_13_analyzer_1_array_crystal_array_2_priority = 1520.2;
#line 3437 "MACS_sample_kidney_box.instr"
  mccchannel_13_analyzer_1_array_crystal_array_2_xwidth = channel_13_analyzer_1_array_crystal_depth;
#line 3437 "MACS_sample_kidney_box.instr"
  mccchannel_13_analyzer_1_array_crystal_array_2_yheight = channel_13_analyzer_1_array_crystal_height;
#line 3437 "MACS_sample_kidney_box.instr"
  mccchannel_13_analyzer_1_array_crystal_array_2_zdepth = channel_13_analyzer_1_array_crystal_width;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_13_analyzer_1_array_crystal_array_2_xwidth2 = -1;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_13_analyzer_1_array_crystal_array_2_yheight2 = -1;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_13_analyzer_1_array_crystal_array_2_visualize = 1;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_13_analyzer_1_array_crystal_array_2_target_index = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_13_analyzer_1_array_crystal_array_2_target_x = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_13_analyzer_1_array_crystal_array_2_target_y = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_13_analyzer_1_array_crystal_array_2_target_z = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_13_analyzer_1_array_crystal_array_2_focus_aw = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_13_analyzer_1_array_crystal_array_2_focus_ah = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_13_analyzer_1_array_crystal_array_2_focus_xw = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_13_analyzer_1_array_crystal_array_2_focus_xh = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_13_analyzer_1_array_crystal_array_2_focus_r = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_13_analyzer_1_array_crystal_array_2_p_interact = 0;
#line 71 "MACS_sample_kidney_box.instr"
  if(0) strncpy(mccchannel_13_analyzer_1_array_crystal_array_2_mask_string, 0 ? 0 : "", 16384); else mccchannel_13_analyzer_1_array_crystal_array_2_mask_string[0]='\0';
#line 71 "MACS_sample_kidney_box.instr"
  if(0) strncpy(mccchannel_13_analyzer_1_array_crystal_array_2_mask_setting, 0 ? 0 : "", 16384); else mccchannel_13_analyzer_1_array_crystal_array_2_mask_setting[0]='\0';
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_13_analyzer_1_array_crystal_array_2_number_of_activations = 1;
#line 131808 "MACS_sample_kidney_box.c"

  SIG_MESSAGE("channel_13_analyzer_1_array_crystal_array_2 (Init:Place/Rotate)");
  rot_set_rotation(mctr1,
#line 3440 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 3440 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 3440 "MACS_sample_kidney_box.instr"
    (0 - RAD2DEG * channel_13_analyzer_1_array_theta [ 2 ])*DEG2RAD);
#line 131818 "MACS_sample_kidney_box.c"
  rot_mul(mctr1, mcrotachannel_13_analyzer_1_rotated, mcrotachannel_13_analyzer_1_array_crystal_array_2);
  rot_transpose(mcrotachannel_13_analyzer_1_array_crystal_array_1, mctr1);
  rot_mul(mcrotachannel_13_analyzer_1_array_crystal_array_2, mctr1, mcrotrchannel_13_analyzer_1_array_crystal_array_2);
  mctc1 = coords_set(
#line 3439 "MACS_sample_kidney_box.instr"
    0 + channel_13_analyzer_1_array_effective_radius_of_curvature * ( 1 - cos ( channel_13_analyzer_1_array_theta [ 2 ] ) ),
#line 3439 "MACS_sample_kidney_box.instr"
    0 + channel_13_analyzer_1_array_effective_radius_of_curvature * sin ( channel_13_analyzer_1_array_theta [ 2 ] ),
#line 3439 "MACS_sample_kidney_box.instr"
    0);
#line 131829 "MACS_sample_kidney_box.c"
  rot_transpose(mcrotachannel_13_analyzer_1_rotated, mctr1);
  mctc2 = rot_apply(mctr1, mctc1);
  mcposachannel_13_analyzer_1_array_crystal_array_2 = coords_add(mcposachannel_13_analyzer_1_rotated, mctc2);
  mctc1 = coords_sub(mcposachannel_13_analyzer_1_array_crystal_array_1, mcposachannel_13_analyzer_1_array_crystal_array_2);
  mcposrchannel_13_analyzer_1_array_crystal_array_2 = rot_apply(mcrotachannel_13_analyzer_1_array_crystal_array_2, mctc1);
  mcDEBUG_COMPONENT("channel_13_analyzer_1_array_crystal_array_2", mcposachannel_13_analyzer_1_array_crystal_array_2, mcrotachannel_13_analyzer_1_array_crystal_array_2)
  mccomp_posa[626] = mcposachannel_13_analyzer_1_array_crystal_array_2;
  mccomp_posr[626] = mcposrchannel_13_analyzer_1_array_crystal_array_2;
  mcNCounter[626]  = mcPCounter[626] = mcP2Counter[626] = 0;
  mcAbsorbProp[626]= 0;
    /* Component channel_13_analyzer_1_array_crystal_array_3. */
  /* Setting parameters for component channel_13_analyzer_1_array_crystal_array_3. */
  SIG_MESSAGE("channel_13_analyzer_1_array_crystal_array_3 (Init:SetPar)");
#line 3444 "MACS_sample_kidney_box.instr"
  if("PG_analyzer") strncpy(mccchannel_13_analyzer_1_array_crystal_array_3_material_string, "PG_analyzer" ? "PG_analyzer" : "", 16384); else mccchannel_13_analyzer_1_array_crystal_array_3_material_string[0]='\0';
#line 3444 "MACS_sample_kidney_box.instr"
  mccchannel_13_analyzer_1_array_crystal_array_3_priority = 1520.3;
#line 3443 "MACS_sample_kidney_box.instr"
  mccchannel_13_analyzer_1_array_crystal_array_3_xwidth = channel_13_analyzer_1_array_crystal_depth;
#line 3443 "MACS_sample_kidney_box.instr"
  mccchannel_13_analyzer_1_array_crystal_array_3_yheight = channel_13_analyzer_1_array_crystal_height;
#line 3443 "MACS_sample_kidney_box.instr"
  mccchannel_13_analyzer_1_array_crystal_array_3_zdepth = channel_13_analyzer_1_array_crystal_width;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_13_analyzer_1_array_crystal_array_3_xwidth2 = -1;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_13_analyzer_1_array_crystal_array_3_yheight2 = -1;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_13_analyzer_1_array_crystal_array_3_visualize = 1;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_13_analyzer_1_array_crystal_array_3_target_index = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_13_analyzer_1_array_crystal_array_3_target_x = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_13_analyzer_1_array_crystal_array_3_target_y = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_13_analyzer_1_array_crystal_array_3_target_z = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_13_analyzer_1_array_crystal_array_3_focus_aw = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_13_analyzer_1_array_crystal_array_3_focus_ah = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_13_analyzer_1_array_crystal_array_3_focus_xw = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_13_analyzer_1_array_crystal_array_3_focus_xh = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_13_analyzer_1_array_crystal_array_3_focus_r = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_13_analyzer_1_array_crystal_array_3_p_interact = 0;
#line 71 "MACS_sample_kidney_box.instr"
  if(0) strncpy(mccchannel_13_analyzer_1_array_crystal_array_3_mask_string, 0 ? 0 : "", 16384); else mccchannel_13_analyzer_1_array_crystal_array_3_mask_string[0]='\0';
#line 71 "MACS_sample_kidney_box.instr"
  if(0) strncpy(mccchannel_13_analyzer_1_array_crystal_array_3_mask_setting, 0 ? 0 : "", 16384); else mccchannel_13_analyzer_1_array_crystal_array_3_mask_setting[0]='\0';
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_13_analyzer_1_array_crystal_array_3_number_of_activations = 1;
#line 131885 "MACS_sample_kidney_box.c"

  SIG_MESSAGE("channel_13_analyzer_1_array_crystal_array_3 (Init:Place/Rotate)");
  rot_set_rotation(mctr1,
#line 3446 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 3446 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 3446 "MACS_sample_kidney_box.instr"
    (0 - RAD2DEG * channel_13_analyzer_1_array_theta [ 3 ])*DEG2RAD);
#line 131895 "MACS_sample_kidney_box.c"
  rot_mul(mctr1, mcrotachannel_13_analyzer_1_rotated, mcrotachannel_13_analyzer_1_array_crystal_array_3);
  rot_transpose(mcrotachannel_13_analyzer_1_array_crystal_array_2, mctr1);
  rot_mul(mcrotachannel_13_analyzer_1_array_crystal_array_3, mctr1, mcrotrchannel_13_analyzer_1_array_crystal_array_3);
  mctc1 = coords_set(
#line 3445 "MACS_sample_kidney_box.instr"
    0 + channel_13_analyzer_1_array_effective_radius_of_curvature * ( 1 - cos ( channel_13_analyzer_1_array_theta [ 3 ] ) ),
#line 3445 "MACS_sample_kidney_box.instr"
    0 + channel_13_analyzer_1_array_effective_radius_of_curvature * sin ( channel_13_analyzer_1_array_theta [ 3 ] ),
#line 3445 "MACS_sample_kidney_box.instr"
    0);
#line 131906 "MACS_sample_kidney_box.c"
  rot_transpose(mcrotachannel_13_analyzer_1_rotated, mctr1);
  mctc2 = rot_apply(mctr1, mctc1);
  mcposachannel_13_analyzer_1_array_crystal_array_3 = coords_add(mcposachannel_13_analyzer_1_rotated, mctc2);
  mctc1 = coords_sub(mcposachannel_13_analyzer_1_array_crystal_array_2, mcposachannel_13_analyzer_1_array_crystal_array_3);
  mcposrchannel_13_analyzer_1_array_crystal_array_3 = rot_apply(mcrotachannel_13_analyzer_1_array_crystal_array_3, mctc1);
  mcDEBUG_COMPONENT("channel_13_analyzer_1_array_crystal_array_3", mcposachannel_13_analyzer_1_array_crystal_array_3, mcrotachannel_13_analyzer_1_array_crystal_array_3)
  mccomp_posa[627] = mcposachannel_13_analyzer_1_array_crystal_array_3;
  mccomp_posr[627] = mcposrchannel_13_analyzer_1_array_crystal_array_3;
  mcNCounter[627]  = mcPCounter[627] = mcP2Counter[627] = 0;
  mcAbsorbProp[627]= 0;
    /* Component channel_13_analyzer_1_array_crystal_array_4. */
  /* Setting parameters for component channel_13_analyzer_1_array_crystal_array_4. */
  SIG_MESSAGE("channel_13_analyzer_1_array_crystal_array_4 (Init:SetPar)");
#line 3450 "MACS_sample_kidney_box.instr"
  if("PG_analyzer") strncpy(mccchannel_13_analyzer_1_array_crystal_array_4_material_string, "PG_analyzer" ? "PG_analyzer" : "", 16384); else mccchannel_13_analyzer_1_array_crystal_array_4_material_string[0]='\0';
#line 3450 "MACS_sample_kidney_box.instr"
  mccchannel_13_analyzer_1_array_crystal_array_4_priority = 1520.4;
#line 3449 "MACS_sample_kidney_box.instr"
  mccchannel_13_analyzer_1_array_crystal_array_4_xwidth = channel_13_analyzer_1_array_crystal_depth;
#line 3449 "MACS_sample_kidney_box.instr"
  mccchannel_13_analyzer_1_array_crystal_array_4_yheight = channel_13_analyzer_1_array_crystal_height;
#line 3449 "MACS_sample_kidney_box.instr"
  mccchannel_13_analyzer_1_array_crystal_array_4_zdepth = channel_13_analyzer_1_array_crystal_width;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_13_analyzer_1_array_crystal_array_4_xwidth2 = -1;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_13_analyzer_1_array_crystal_array_4_yheight2 = -1;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_13_analyzer_1_array_crystal_array_4_visualize = 1;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_13_analyzer_1_array_crystal_array_4_target_index = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_13_analyzer_1_array_crystal_array_4_target_x = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_13_analyzer_1_array_crystal_array_4_target_y = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_13_analyzer_1_array_crystal_array_4_target_z = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_13_analyzer_1_array_crystal_array_4_focus_aw = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_13_analyzer_1_array_crystal_array_4_focus_ah = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_13_analyzer_1_array_crystal_array_4_focus_xw = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_13_analyzer_1_array_crystal_array_4_focus_xh = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_13_analyzer_1_array_crystal_array_4_focus_r = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_13_analyzer_1_array_crystal_array_4_p_interact = 0;
#line 71 "MACS_sample_kidney_box.instr"
  if(0) strncpy(mccchannel_13_analyzer_1_array_crystal_array_4_mask_string, 0 ? 0 : "", 16384); else mccchannel_13_analyzer_1_array_crystal_array_4_mask_string[0]='\0';
#line 71 "MACS_sample_kidney_box.instr"
  if(0) strncpy(mccchannel_13_analyzer_1_array_crystal_array_4_mask_setting, 0 ? 0 : "", 16384); else mccchannel_13_analyzer_1_array_crystal_array_4_mask_setting[0]='\0';
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_13_analyzer_1_array_crystal_array_4_number_of_activations = 1;
#line 131962 "MACS_sample_kidney_box.c"

  SIG_MESSAGE("channel_13_analyzer_1_array_crystal_array_4 (Init:Place/Rotate)");
  rot_set_rotation(mctr1,
#line 3452 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 3452 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 3452 "MACS_sample_kidney_box.instr"
    (0 - RAD2DEG * channel_13_analyzer_1_array_theta [ 4 ])*DEG2RAD);
#line 131972 "MACS_sample_kidney_box.c"
  rot_mul(mctr1, mcrotachannel_13_analyzer_1_rotated, mcrotachannel_13_analyzer_1_array_crystal_array_4);
  rot_transpose(mcrotachannel_13_analyzer_1_array_crystal_array_3, mctr1);
  rot_mul(mcrotachannel_13_analyzer_1_array_crystal_array_4, mctr1, mcrotrchannel_13_analyzer_1_array_crystal_array_4);
  mctc1 = coords_set(
#line 3451 "MACS_sample_kidney_box.instr"
    0 + channel_13_analyzer_1_array_effective_radius_of_curvature * ( 1 - cos ( channel_13_analyzer_1_array_theta [ 4 ] ) ),
#line 3451 "MACS_sample_kidney_box.instr"
    0 + channel_13_analyzer_1_array_effective_radius_of_curvature * sin ( channel_13_analyzer_1_array_theta [ 4 ] ),
#line 3451 "MACS_sample_kidney_box.instr"
    0);
#line 131983 "MACS_sample_kidney_box.c"
  rot_transpose(mcrotachannel_13_analyzer_1_rotated, mctr1);
  mctc2 = rot_apply(mctr1, mctc1);
  mcposachannel_13_analyzer_1_array_crystal_array_4 = coords_add(mcposachannel_13_analyzer_1_rotated, mctc2);
  mctc1 = coords_sub(mcposachannel_13_analyzer_1_array_crystal_array_3, mcposachannel_13_analyzer_1_array_crystal_array_4);
  mcposrchannel_13_analyzer_1_array_crystal_array_4 = rot_apply(mcrotachannel_13_analyzer_1_array_crystal_array_4, mctc1);
  mcDEBUG_COMPONENT("channel_13_analyzer_1_array_crystal_array_4", mcposachannel_13_analyzer_1_array_crystal_array_4, mcrotachannel_13_analyzer_1_array_crystal_array_4)
  mccomp_posa[628] = mcposachannel_13_analyzer_1_array_crystal_array_4;
  mccomp_posr[628] = mcposrchannel_13_analyzer_1_array_crystal_array_4;
  mcNCounter[628]  = mcPCounter[628] = mcP2Counter[628] = 0;
  mcAbsorbProp[628]= 0;
    /* Component channel_13_analyzer_1_array_crystal_array_5. */
  /* Setting parameters for component channel_13_analyzer_1_array_crystal_array_5. */
  SIG_MESSAGE("channel_13_analyzer_1_array_crystal_array_5 (Init:SetPar)");
#line 3456 "MACS_sample_kidney_box.instr"
  if("PG_analyzer") strncpy(mccchannel_13_analyzer_1_array_crystal_array_5_material_string, "PG_analyzer" ? "PG_analyzer" : "", 16384); else mccchannel_13_analyzer_1_array_crystal_array_5_material_string[0]='\0';
#line 3456 "MACS_sample_kidney_box.instr"
  mccchannel_13_analyzer_1_array_crystal_array_5_priority = 1520.5;
#line 3455 "MACS_sample_kidney_box.instr"
  mccchannel_13_analyzer_1_array_crystal_array_5_xwidth = channel_13_analyzer_1_array_crystal_depth;
#line 3455 "MACS_sample_kidney_box.instr"
  mccchannel_13_analyzer_1_array_crystal_array_5_yheight = channel_13_analyzer_1_array_crystal_height;
#line 3455 "MACS_sample_kidney_box.instr"
  mccchannel_13_analyzer_1_array_crystal_array_5_zdepth = channel_13_analyzer_1_array_crystal_width;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_13_analyzer_1_array_crystal_array_5_xwidth2 = -1;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_13_analyzer_1_array_crystal_array_5_yheight2 = -1;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_13_analyzer_1_array_crystal_array_5_visualize = 1;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_13_analyzer_1_array_crystal_array_5_target_index = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_13_analyzer_1_array_crystal_array_5_target_x = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_13_analyzer_1_array_crystal_array_5_target_y = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_13_analyzer_1_array_crystal_array_5_target_z = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_13_analyzer_1_array_crystal_array_5_focus_aw = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_13_analyzer_1_array_crystal_array_5_focus_ah = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_13_analyzer_1_array_crystal_array_5_focus_xw = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_13_analyzer_1_array_crystal_array_5_focus_xh = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_13_analyzer_1_array_crystal_array_5_focus_r = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_13_analyzer_1_array_crystal_array_5_p_interact = 0;
#line 71 "MACS_sample_kidney_box.instr"
  if(0) strncpy(mccchannel_13_analyzer_1_array_crystal_array_5_mask_string, 0 ? 0 : "", 16384); else mccchannel_13_analyzer_1_array_crystal_array_5_mask_string[0]='\0';
#line 71 "MACS_sample_kidney_box.instr"
  if(0) strncpy(mccchannel_13_analyzer_1_array_crystal_array_5_mask_setting, 0 ? 0 : "", 16384); else mccchannel_13_analyzer_1_array_crystal_array_5_mask_setting[0]='\0';
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_13_analyzer_1_array_crystal_array_5_number_of_activations = 1;
#line 132039 "MACS_sample_kidney_box.c"

  SIG_MESSAGE("channel_13_analyzer_1_array_crystal_array_5 (Init:Place/Rotate)");
  rot_set_rotation(mctr1,
#line 3458 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 3458 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 3458 "MACS_sample_kidney_box.instr"
    (0 - RAD2DEG * channel_13_analyzer_1_array_theta [ 5 ])*DEG2RAD);
#line 132049 "MACS_sample_kidney_box.c"
  rot_mul(mctr1, mcrotachannel_13_analyzer_1_rotated, mcrotachannel_13_analyzer_1_array_crystal_array_5);
  rot_transpose(mcrotachannel_13_analyzer_1_array_crystal_array_4, mctr1);
  rot_mul(mcrotachannel_13_analyzer_1_array_crystal_array_5, mctr1, mcrotrchannel_13_analyzer_1_array_crystal_array_5);
  mctc1 = coords_set(
#line 3457 "MACS_sample_kidney_box.instr"
    0 + channel_13_analyzer_1_array_effective_radius_of_curvature * ( 1 - cos ( channel_13_analyzer_1_array_theta [ 5 ] ) ),
#line 3457 "MACS_sample_kidney_box.instr"
    0 + channel_13_analyzer_1_array_effective_radius_of_curvature * sin ( channel_13_analyzer_1_array_theta [ 5 ] ),
#line 3457 "MACS_sample_kidney_box.instr"
    0);
#line 132060 "MACS_sample_kidney_box.c"
  rot_transpose(mcrotachannel_13_analyzer_1_rotated, mctr1);
  mctc2 = rot_apply(mctr1, mctc1);
  mcposachannel_13_analyzer_1_array_crystal_array_5 = coords_add(mcposachannel_13_analyzer_1_rotated, mctc2);
  mctc1 = coords_sub(mcposachannel_13_analyzer_1_array_crystal_array_4, mcposachannel_13_analyzer_1_array_crystal_array_5);
  mcposrchannel_13_analyzer_1_array_crystal_array_5 = rot_apply(mcrotachannel_13_analyzer_1_array_crystal_array_5, mctc1);
  mcDEBUG_COMPONENT("channel_13_analyzer_1_array_crystal_array_5", mcposachannel_13_analyzer_1_array_crystal_array_5, mcrotachannel_13_analyzer_1_array_crystal_array_5)
  mccomp_posa[629] = mcposachannel_13_analyzer_1_array_crystal_array_5;
  mccomp_posr[629] = mcposrchannel_13_analyzer_1_array_crystal_array_5;
  mcNCounter[629]  = mcPCounter[629] = mcP2Counter[629] = 0;
  mcAbsorbProp[629]= 0;
    /* Component channel_13_analyzer_1_array_crystal_array_6. */
  /* Setting parameters for component channel_13_analyzer_1_array_crystal_array_6. */
  SIG_MESSAGE("channel_13_analyzer_1_array_crystal_array_6 (Init:SetPar)");
#line 3462 "MACS_sample_kidney_box.instr"
  if("PG_analyzer") strncpy(mccchannel_13_analyzer_1_array_crystal_array_6_material_string, "PG_analyzer" ? "PG_analyzer" : "", 16384); else mccchannel_13_analyzer_1_array_crystal_array_6_material_string[0]='\0';
#line 3462 "MACS_sample_kidney_box.instr"
  mccchannel_13_analyzer_1_array_crystal_array_6_priority = 1520.6;
#line 3461 "MACS_sample_kidney_box.instr"
  mccchannel_13_analyzer_1_array_crystal_array_6_xwidth = channel_13_analyzer_1_array_crystal_depth;
#line 3461 "MACS_sample_kidney_box.instr"
  mccchannel_13_analyzer_1_array_crystal_array_6_yheight = channel_13_analyzer_1_array_crystal_height;
#line 3461 "MACS_sample_kidney_box.instr"
  mccchannel_13_analyzer_1_array_crystal_array_6_zdepth = channel_13_analyzer_1_array_crystal_width;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_13_analyzer_1_array_crystal_array_6_xwidth2 = -1;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_13_analyzer_1_array_crystal_array_6_yheight2 = -1;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_13_analyzer_1_array_crystal_array_6_visualize = 1;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_13_analyzer_1_array_crystal_array_6_target_index = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_13_analyzer_1_array_crystal_array_6_target_x = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_13_analyzer_1_array_crystal_array_6_target_y = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_13_analyzer_1_array_crystal_array_6_target_z = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_13_analyzer_1_array_crystal_array_6_focus_aw = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_13_analyzer_1_array_crystal_array_6_focus_ah = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_13_analyzer_1_array_crystal_array_6_focus_xw = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_13_analyzer_1_array_crystal_array_6_focus_xh = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_13_analyzer_1_array_crystal_array_6_focus_r = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_13_analyzer_1_array_crystal_array_6_p_interact = 0;
#line 71 "MACS_sample_kidney_box.instr"
  if(0) strncpy(mccchannel_13_analyzer_1_array_crystal_array_6_mask_string, 0 ? 0 : "", 16384); else mccchannel_13_analyzer_1_array_crystal_array_6_mask_string[0]='\0';
#line 71 "MACS_sample_kidney_box.instr"
  if(0) strncpy(mccchannel_13_analyzer_1_array_crystal_array_6_mask_setting, 0 ? 0 : "", 16384); else mccchannel_13_analyzer_1_array_crystal_array_6_mask_setting[0]='\0';
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_13_analyzer_1_array_crystal_array_6_number_of_activations = 1;
#line 132116 "MACS_sample_kidney_box.c"

  SIG_MESSAGE("channel_13_analyzer_1_array_crystal_array_6 (Init:Place/Rotate)");
  rot_set_rotation(mctr1,
#line 3464 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 3464 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 3464 "MACS_sample_kidney_box.instr"
    (0 - RAD2DEG * channel_13_analyzer_1_array_theta [ 6 ])*DEG2RAD);
#line 132126 "MACS_sample_kidney_box.c"
  rot_mul(mctr1, mcrotachannel_13_analyzer_1_rotated, mcrotachannel_13_analyzer_1_array_crystal_array_6);
  rot_transpose(mcrotachannel_13_analyzer_1_array_crystal_array_5, mctr1);
  rot_mul(mcrotachannel_13_analyzer_1_array_crystal_array_6, mctr1, mcrotrchannel_13_analyzer_1_array_crystal_array_6);
  mctc1 = coords_set(
#line 3463 "MACS_sample_kidney_box.instr"
    0 + channel_13_analyzer_1_array_effective_radius_of_curvature * ( 1 - cos ( channel_13_analyzer_1_array_theta [ 6 ] ) ),
#line 3463 "MACS_sample_kidney_box.instr"
    0 + channel_13_analyzer_1_array_effective_radius_of_curvature * sin ( channel_13_analyzer_1_array_theta [ 6 ] ),
#line 3463 "MACS_sample_kidney_box.instr"
    0);
#line 132137 "MACS_sample_kidney_box.c"
  rot_transpose(mcrotachannel_13_analyzer_1_rotated, mctr1);
  mctc2 = rot_apply(mctr1, mctc1);
  mcposachannel_13_analyzer_1_array_crystal_array_6 = coords_add(mcposachannel_13_analyzer_1_rotated, mctc2);
  mctc1 = coords_sub(mcposachannel_13_analyzer_1_array_crystal_array_5, mcposachannel_13_analyzer_1_array_crystal_array_6);
  mcposrchannel_13_analyzer_1_array_crystal_array_6 = rot_apply(mcrotachannel_13_analyzer_1_array_crystal_array_6, mctc1);
  mcDEBUG_COMPONENT("channel_13_analyzer_1_array_crystal_array_6", mcposachannel_13_analyzer_1_array_crystal_array_6, mcrotachannel_13_analyzer_1_array_crystal_array_6)
  mccomp_posa[630] = mcposachannel_13_analyzer_1_array_crystal_array_6;
  mccomp_posr[630] = mcposrchannel_13_analyzer_1_array_crystal_array_6;
  mcNCounter[630]  = mcPCounter[630] = mcP2Counter[630] = 0;
  mcAbsorbProp[630]= 0;
    /* Component channel_13_analyzer_1_array_crystal_array_7. */
  /* Setting parameters for component channel_13_analyzer_1_array_crystal_array_7. */
  SIG_MESSAGE("channel_13_analyzer_1_array_crystal_array_7 (Init:SetPar)");
#line 3468 "MACS_sample_kidney_box.instr"
  if("PG_analyzer") strncpy(mccchannel_13_analyzer_1_array_crystal_array_7_material_string, "PG_analyzer" ? "PG_analyzer" : "", 16384); else mccchannel_13_analyzer_1_array_crystal_array_7_material_string[0]='\0';
#line 3468 "MACS_sample_kidney_box.instr"
  mccchannel_13_analyzer_1_array_crystal_array_7_priority = 1520.7;
#line 3467 "MACS_sample_kidney_box.instr"
  mccchannel_13_analyzer_1_array_crystal_array_7_xwidth = channel_13_analyzer_1_array_crystal_depth;
#line 3467 "MACS_sample_kidney_box.instr"
  mccchannel_13_analyzer_1_array_crystal_array_7_yheight = channel_13_analyzer_1_array_crystal_height;
#line 3467 "MACS_sample_kidney_box.instr"
  mccchannel_13_analyzer_1_array_crystal_array_7_zdepth = channel_13_analyzer_1_array_crystal_width;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_13_analyzer_1_array_crystal_array_7_xwidth2 = -1;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_13_analyzer_1_array_crystal_array_7_yheight2 = -1;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_13_analyzer_1_array_crystal_array_7_visualize = 1;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_13_analyzer_1_array_crystal_array_7_target_index = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_13_analyzer_1_array_crystal_array_7_target_x = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_13_analyzer_1_array_crystal_array_7_target_y = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_13_analyzer_1_array_crystal_array_7_target_z = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_13_analyzer_1_array_crystal_array_7_focus_aw = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_13_analyzer_1_array_crystal_array_7_focus_ah = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_13_analyzer_1_array_crystal_array_7_focus_xw = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_13_analyzer_1_array_crystal_array_7_focus_xh = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_13_analyzer_1_array_crystal_array_7_focus_r = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_13_analyzer_1_array_crystal_array_7_p_interact = 0;
#line 71 "MACS_sample_kidney_box.instr"
  if(0) strncpy(mccchannel_13_analyzer_1_array_crystal_array_7_mask_string, 0 ? 0 : "", 16384); else mccchannel_13_analyzer_1_array_crystal_array_7_mask_string[0]='\0';
#line 71 "MACS_sample_kidney_box.instr"
  if(0) strncpy(mccchannel_13_analyzer_1_array_crystal_array_7_mask_setting, 0 ? 0 : "", 16384); else mccchannel_13_analyzer_1_array_crystal_array_7_mask_setting[0]='\0';
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_13_analyzer_1_array_crystal_array_7_number_of_activations = 1;
#line 132193 "MACS_sample_kidney_box.c"

  SIG_MESSAGE("channel_13_analyzer_1_array_crystal_array_7 (Init:Place/Rotate)");
  rot_set_rotation(mctr1,
#line 3470 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 3470 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 3470 "MACS_sample_kidney_box.instr"
    (0 - RAD2DEG * channel_13_analyzer_1_array_theta [ 7 ])*DEG2RAD);
#line 132203 "MACS_sample_kidney_box.c"
  rot_mul(mctr1, mcrotachannel_13_analyzer_1_rotated, mcrotachannel_13_analyzer_1_array_crystal_array_7);
  rot_transpose(mcrotachannel_13_analyzer_1_array_crystal_array_6, mctr1);
  rot_mul(mcrotachannel_13_analyzer_1_array_crystal_array_7, mctr1, mcrotrchannel_13_analyzer_1_array_crystal_array_7);
  mctc1 = coords_set(
#line 3469 "MACS_sample_kidney_box.instr"
    0 + channel_13_analyzer_1_array_effective_radius_of_curvature * ( 1 - cos ( channel_13_analyzer_1_array_theta [ 7 ] ) ),
#line 3469 "MACS_sample_kidney_box.instr"
    0 + channel_13_analyzer_1_array_effective_radius_of_curvature * sin ( channel_13_analyzer_1_array_theta [ 7 ] ),
#line 3469 "MACS_sample_kidney_box.instr"
    0);
#line 132214 "MACS_sample_kidney_box.c"
  rot_transpose(mcrotachannel_13_analyzer_1_rotated, mctr1);
  mctc2 = rot_apply(mctr1, mctc1);
  mcposachannel_13_analyzer_1_array_crystal_array_7 = coords_add(mcposachannel_13_analyzer_1_rotated, mctc2);
  mctc1 = coords_sub(mcposachannel_13_analyzer_1_array_crystal_array_6, mcposachannel_13_analyzer_1_array_crystal_array_7);
  mcposrchannel_13_analyzer_1_array_crystal_array_7 = rot_apply(mcrotachannel_13_analyzer_1_array_crystal_array_7, mctc1);
  mcDEBUG_COMPONENT("channel_13_analyzer_1_array_crystal_array_7", mcposachannel_13_analyzer_1_array_crystal_array_7, mcrotachannel_13_analyzer_1_array_crystal_array_7)
  mccomp_posa[631] = mcposachannel_13_analyzer_1_array_crystal_array_7;
  mccomp_posr[631] = mcposrchannel_13_analyzer_1_array_crystal_array_7;
  mcNCounter[631]  = mcPCounter[631] = mcP2Counter[631] = 0;
  mcAbsorbProp[631]= 0;
    /* Component channel_13_analyzer_1_array_crystal_array_8. */
  /* Setting parameters for component channel_13_analyzer_1_array_crystal_array_8. */
  SIG_MESSAGE("channel_13_analyzer_1_array_crystal_array_8 (Init:SetPar)");
#line 3474 "MACS_sample_kidney_box.instr"
  if("PG_analyzer") strncpy(mccchannel_13_analyzer_1_array_crystal_array_8_material_string, "PG_analyzer" ? "PG_analyzer" : "", 16384); else mccchannel_13_analyzer_1_array_crystal_array_8_material_string[0]='\0';
#line 3474 "MACS_sample_kidney_box.instr"
  mccchannel_13_analyzer_1_array_crystal_array_8_priority = 1520.8;
#line 3473 "MACS_sample_kidney_box.instr"
  mccchannel_13_analyzer_1_array_crystal_array_8_xwidth = channel_13_analyzer_1_array_crystal_depth;
#line 3473 "MACS_sample_kidney_box.instr"
  mccchannel_13_analyzer_1_array_crystal_array_8_yheight = channel_13_analyzer_1_array_crystal_height;
#line 3473 "MACS_sample_kidney_box.instr"
  mccchannel_13_analyzer_1_array_crystal_array_8_zdepth = channel_13_analyzer_1_array_crystal_width;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_13_analyzer_1_array_crystal_array_8_xwidth2 = -1;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_13_analyzer_1_array_crystal_array_8_yheight2 = -1;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_13_analyzer_1_array_crystal_array_8_visualize = 1;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_13_analyzer_1_array_crystal_array_8_target_index = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_13_analyzer_1_array_crystal_array_8_target_x = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_13_analyzer_1_array_crystal_array_8_target_y = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_13_analyzer_1_array_crystal_array_8_target_z = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_13_analyzer_1_array_crystal_array_8_focus_aw = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_13_analyzer_1_array_crystal_array_8_focus_ah = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_13_analyzer_1_array_crystal_array_8_focus_xw = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_13_analyzer_1_array_crystal_array_8_focus_xh = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_13_analyzer_1_array_crystal_array_8_focus_r = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_13_analyzer_1_array_crystal_array_8_p_interact = 0;
#line 71 "MACS_sample_kidney_box.instr"
  if(0) strncpy(mccchannel_13_analyzer_1_array_crystal_array_8_mask_string, 0 ? 0 : "", 16384); else mccchannel_13_analyzer_1_array_crystal_array_8_mask_string[0]='\0';
#line 71 "MACS_sample_kidney_box.instr"
  if(0) strncpy(mccchannel_13_analyzer_1_array_crystal_array_8_mask_setting, 0 ? 0 : "", 16384); else mccchannel_13_analyzer_1_array_crystal_array_8_mask_setting[0]='\0';
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_13_analyzer_1_array_crystal_array_8_number_of_activations = 1;
#line 132270 "MACS_sample_kidney_box.c"

  SIG_MESSAGE("channel_13_analyzer_1_array_crystal_array_8 (Init:Place/Rotate)");
  rot_set_rotation(mctr1,
#line 3476 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 3476 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 3476 "MACS_sample_kidney_box.instr"
    (0 - RAD2DEG * channel_13_analyzer_1_array_theta [ 8 ])*DEG2RAD);
#line 132280 "MACS_sample_kidney_box.c"
  rot_mul(mctr1, mcrotachannel_13_analyzer_1_rotated, mcrotachannel_13_analyzer_1_array_crystal_array_8);
  rot_transpose(mcrotachannel_13_analyzer_1_array_crystal_array_7, mctr1);
  rot_mul(mcrotachannel_13_analyzer_1_array_crystal_array_8, mctr1, mcrotrchannel_13_analyzer_1_array_crystal_array_8);
  mctc1 = coords_set(
#line 3475 "MACS_sample_kidney_box.instr"
    0 + channel_13_analyzer_1_array_effective_radius_of_curvature * ( 1 - cos ( channel_13_analyzer_1_array_theta [ 8 ] ) ),
#line 3475 "MACS_sample_kidney_box.instr"
    0 + channel_13_analyzer_1_array_effective_radius_of_curvature * sin ( channel_13_analyzer_1_array_theta [ 8 ] ),
#line 3475 "MACS_sample_kidney_box.instr"
    0);
#line 132291 "MACS_sample_kidney_box.c"
  rot_transpose(mcrotachannel_13_analyzer_1_rotated, mctr1);
  mctc2 = rot_apply(mctr1, mctc1);
  mcposachannel_13_analyzer_1_array_crystal_array_8 = coords_add(mcposachannel_13_analyzer_1_rotated, mctc2);
  mctc1 = coords_sub(mcposachannel_13_analyzer_1_array_crystal_array_7, mcposachannel_13_analyzer_1_array_crystal_array_8);
  mcposrchannel_13_analyzer_1_array_crystal_array_8 = rot_apply(mcrotachannel_13_analyzer_1_array_crystal_array_8, mctc1);
  mcDEBUG_COMPONENT("channel_13_analyzer_1_array_crystal_array_8", mcposachannel_13_analyzer_1_array_crystal_array_8, mcrotachannel_13_analyzer_1_array_crystal_array_8)
  mccomp_posa[632] = mcposachannel_13_analyzer_1_array_crystal_array_8;
  mccomp_posr[632] = mcposrchannel_13_analyzer_1_array_crystal_array_8;
  mcNCounter[632]  = mcPCounter[632] = mcP2Counter[632] = 0;
  mcAbsorbProp[632]= 0;
    /* Component channel_13_analyzer_2_center. */
  /* Setting parameters for component channel_13_analyzer_2_center. */
  SIG_MESSAGE("channel_13_analyzer_2_center (Init:SetPar)");

  SIG_MESSAGE("channel_13_analyzer_2_center (Init:Place/Rotate)");
  rot_set_rotation(mctr1,
    (0.0)*DEG2RAD,
    (0.0)*DEG2RAD,
    (0.0)*DEG2RAD);
#line 132311 "MACS_sample_kidney_box.c"
  rot_mul(mctr1, mcrotachannel_13_analyzer_1_center, mcrotachannel_13_analyzer_2_center);
  rot_transpose(mcrotachannel_13_analyzer_1_array_crystal_array_8, mctr1);
  rot_mul(mcrotachannel_13_analyzer_2_center, mctr1, mcrotrchannel_13_analyzer_2_center);
  mctc1 = coords_set(
#line 3480 "MACS_sample_kidney_box.instr"
    - analyzer_seperation,
#line 3480 "MACS_sample_kidney_box.instr"
    0,
#line 3480 "MACS_sample_kidney_box.instr"
    0);
#line 132322 "MACS_sample_kidney_box.c"
  rot_transpose(mcrotachannel_13_analyzer_1_center, mctr1);
  mctc2 = rot_apply(mctr1, mctc1);
  mcposachannel_13_analyzer_2_center = coords_add(mcposachannel_13_analyzer_1_center, mctc2);
  mctc1 = coords_sub(mcposachannel_13_analyzer_1_array_crystal_array_8, mcposachannel_13_analyzer_2_center);
  mcposrchannel_13_analyzer_2_center = rot_apply(mcrotachannel_13_analyzer_2_center, mctc1);
  mcDEBUG_COMPONENT("channel_13_analyzer_2_center", mcposachannel_13_analyzer_2_center, mcrotachannel_13_analyzer_2_center)
  mccomp_posa[633] = mcposachannel_13_analyzer_2_center;
  mccomp_posr[633] = mcposrchannel_13_analyzer_2_center;
  mcNCounter[633]  = mcPCounter[633] = mcP2Counter[633] = 0;
  mcAbsorbProp[633]= 0;
    /* Component channel_13_analyzer_2_rotated. */
  /* Setting parameters for component channel_13_analyzer_2_rotated. */
  SIG_MESSAGE("channel_13_analyzer_2_rotated (Init:SetPar)");

  SIG_MESSAGE("channel_13_analyzer_2_rotated (Init:Place/Rotate)");
  rot_set_rotation(mctr1,
#line 3484 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 3484 "MACS_sample_kidney_box.instr"
    (- analyzer_theta [ 13 ])*DEG2RAD,
#line 3484 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD);
#line 132345 "MACS_sample_kidney_box.c"
  rot_mul(mctr1, mcrotachannel_13_analyzer_2_center, mcrotachannel_13_analyzer_2_rotated);
  rot_transpose(mcrotachannel_13_analyzer_2_center, mctr1);
  rot_mul(mcrotachannel_13_analyzer_2_rotated, mctr1, mcrotrchannel_13_analyzer_2_rotated);
  mctc1 = coords_set(
#line 3483 "MACS_sample_kidney_box.instr"
    0,
#line 3483 "MACS_sample_kidney_box.instr"
    0,
#line 3483 "MACS_sample_kidney_box.instr"
    0.5 * analyzer_seperation / tan ( analyzer_2theta [ 13 ] * DEG2RAD ));
#line 132356 "MACS_sample_kidney_box.c"
  rot_transpose(mcrotachannel_13_analyzer_2_center, mctr1);
  mctc2 = rot_apply(mctr1, mctc1);
  mcposachannel_13_analyzer_2_rotated = coords_add(mcposachannel_13_analyzer_2_center, mctc2);
  mctc1 = coords_sub(mcposachannel_13_analyzer_2_center, mcposachannel_13_analyzer_2_rotated);
  mcposrchannel_13_analyzer_2_rotated = rot_apply(mcrotachannel_13_analyzer_2_rotated, mctc1);
  mcDEBUG_COMPONENT("channel_13_analyzer_2_rotated", mcposachannel_13_analyzer_2_rotated, mcrotachannel_13_analyzer_2_rotated)
  mccomp_posa[634] = mcposachannel_13_analyzer_2_rotated;
  mccomp_posr[634] = mcposrchannel_13_analyzer_2_rotated;
  mcNCounter[634]  = mcPCounter[634] = mcP2Counter[634] = 0;
  mcAbsorbProp[634]= 0;
    /* Component channel_13_analyzer_2_array_crystal_array_0. */
  /* Setting parameters for component channel_13_analyzer_2_array_crystal_array_0. */
  SIG_MESSAGE("channel_13_analyzer_2_array_crystal_array_0 (Init:SetPar)");
#line 3488 "MACS_sample_kidney_box.instr"
  if("PG_analyzer") strncpy(mccchannel_13_analyzer_2_array_crystal_array_0_material_string, "PG_analyzer" ? "PG_analyzer" : "", 16384); else mccchannel_13_analyzer_2_array_crystal_array_0_material_string[0]='\0';
#line 3488 "MACS_sample_kidney_box.instr"
  mccchannel_13_analyzer_2_array_crystal_array_0_priority = 1521.0;
#line 3487 "MACS_sample_kidney_box.instr"
  mccchannel_13_analyzer_2_array_crystal_array_0_xwidth = channel_13_analyzer_2_array_crystal_depth;
#line 3487 "MACS_sample_kidney_box.instr"
  mccchannel_13_analyzer_2_array_crystal_array_0_yheight = channel_13_analyzer_2_array_crystal_height;
#line 3487 "MACS_sample_kidney_box.instr"
  mccchannel_13_analyzer_2_array_crystal_array_0_zdepth = channel_13_analyzer_2_array_crystal_width;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_13_analyzer_2_array_crystal_array_0_xwidth2 = -1;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_13_analyzer_2_array_crystal_array_0_yheight2 = -1;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_13_analyzer_2_array_crystal_array_0_visualize = 1;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_13_analyzer_2_array_crystal_array_0_target_index = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_13_analyzer_2_array_crystal_array_0_target_x = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_13_analyzer_2_array_crystal_array_0_target_y = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_13_analyzer_2_array_crystal_array_0_target_z = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_13_analyzer_2_array_crystal_array_0_focus_aw = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_13_analyzer_2_array_crystal_array_0_focus_ah = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_13_analyzer_2_array_crystal_array_0_focus_xw = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_13_analyzer_2_array_crystal_array_0_focus_xh = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_13_analyzer_2_array_crystal_array_0_focus_r = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_13_analyzer_2_array_crystal_array_0_p_interact = 0;
#line 71 "MACS_sample_kidney_box.instr"
  if(0) strncpy(mccchannel_13_analyzer_2_array_crystal_array_0_mask_string, 0 ? 0 : "", 16384); else mccchannel_13_analyzer_2_array_crystal_array_0_mask_string[0]='\0';
#line 71 "MACS_sample_kidney_box.instr"
  if(0) strncpy(mccchannel_13_analyzer_2_array_crystal_array_0_mask_setting, 0 ? 0 : "", 16384); else mccchannel_13_analyzer_2_array_crystal_array_0_mask_setting[0]='\0';
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_13_analyzer_2_array_crystal_array_0_number_of_activations = 1;
#line 132412 "MACS_sample_kidney_box.c"

  SIG_MESSAGE("channel_13_analyzer_2_array_crystal_array_0 (Init:Place/Rotate)");
  rot_set_rotation(mctr1,
#line 3490 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 3490 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 3490 "MACS_sample_kidney_box.instr"
    (0 - RAD2DEG * channel_13_analyzer_2_array_theta [ 0 ])*DEG2RAD);
#line 132422 "MACS_sample_kidney_box.c"
  rot_mul(mctr1, mcrotachannel_13_analyzer_2_rotated, mcrotachannel_13_analyzer_2_array_crystal_array_0);
  rot_transpose(mcrotachannel_13_analyzer_2_rotated, mctr1);
  rot_mul(mcrotachannel_13_analyzer_2_array_crystal_array_0, mctr1, mcrotrchannel_13_analyzer_2_array_crystal_array_0);
  mctc1 = coords_set(
#line 3489 "MACS_sample_kidney_box.instr"
    0 + channel_13_analyzer_2_array_effective_radius_of_curvature * ( 1 - cos ( channel_13_analyzer_2_array_theta [ 0 ] ) ),
#line 3489 "MACS_sample_kidney_box.instr"
    0 + channel_13_analyzer_2_array_effective_radius_of_curvature * sin ( channel_13_analyzer_2_array_theta [ 0 ] ),
#line 3489 "MACS_sample_kidney_box.instr"
    0);
#line 132433 "MACS_sample_kidney_box.c"
  rot_transpose(mcrotachannel_13_analyzer_2_rotated, mctr1);
  mctc2 = rot_apply(mctr1, mctc1);
  mcposachannel_13_analyzer_2_array_crystal_array_0 = coords_add(mcposachannel_13_analyzer_2_rotated, mctc2);
  mctc1 = coords_sub(mcposachannel_13_analyzer_2_rotated, mcposachannel_13_analyzer_2_array_crystal_array_0);
  mcposrchannel_13_analyzer_2_array_crystal_array_0 = rot_apply(mcrotachannel_13_analyzer_2_array_crystal_array_0, mctc1);
  mcDEBUG_COMPONENT("channel_13_analyzer_2_array_crystal_array_0", mcposachannel_13_analyzer_2_array_crystal_array_0, mcrotachannel_13_analyzer_2_array_crystal_array_0)
  mccomp_posa[635] = mcposachannel_13_analyzer_2_array_crystal_array_0;
  mccomp_posr[635] = mcposrchannel_13_analyzer_2_array_crystal_array_0;
  mcNCounter[635]  = mcPCounter[635] = mcP2Counter[635] = 0;
  mcAbsorbProp[635]= 0;
    /* Component channel_13_analyzer_2_array_crystal_array_1. */
  /* Setting parameters for component channel_13_analyzer_2_array_crystal_array_1. */
  SIG_MESSAGE("channel_13_analyzer_2_array_crystal_array_1 (Init:SetPar)");
#line 3494 "MACS_sample_kidney_box.instr"
  if("PG_analyzer") strncpy(mccchannel_13_analyzer_2_array_crystal_array_1_material_string, "PG_analyzer" ? "PG_analyzer" : "", 16384); else mccchannel_13_analyzer_2_array_crystal_array_1_material_string[0]='\0';
#line 3494 "MACS_sample_kidney_box.instr"
  mccchannel_13_analyzer_2_array_crystal_array_1_priority = 1521.1;
#line 3493 "MACS_sample_kidney_box.instr"
  mccchannel_13_analyzer_2_array_crystal_array_1_xwidth = channel_13_analyzer_2_array_crystal_depth;
#line 3493 "MACS_sample_kidney_box.instr"
  mccchannel_13_analyzer_2_array_crystal_array_1_yheight = channel_13_analyzer_2_array_crystal_height;
#line 3493 "MACS_sample_kidney_box.instr"
  mccchannel_13_analyzer_2_array_crystal_array_1_zdepth = channel_13_analyzer_2_array_crystal_width;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_13_analyzer_2_array_crystal_array_1_xwidth2 = -1;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_13_analyzer_2_array_crystal_array_1_yheight2 = -1;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_13_analyzer_2_array_crystal_array_1_visualize = 1;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_13_analyzer_2_array_crystal_array_1_target_index = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_13_analyzer_2_array_crystal_array_1_target_x = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_13_analyzer_2_array_crystal_array_1_target_y = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_13_analyzer_2_array_crystal_array_1_target_z = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_13_analyzer_2_array_crystal_array_1_focus_aw = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_13_analyzer_2_array_crystal_array_1_focus_ah = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_13_analyzer_2_array_crystal_array_1_focus_xw = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_13_analyzer_2_array_crystal_array_1_focus_xh = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_13_analyzer_2_array_crystal_array_1_focus_r = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_13_analyzer_2_array_crystal_array_1_p_interact = 0;
#line 71 "MACS_sample_kidney_box.instr"
  if(0) strncpy(mccchannel_13_analyzer_2_array_crystal_array_1_mask_string, 0 ? 0 : "", 16384); else mccchannel_13_analyzer_2_array_crystal_array_1_mask_string[0]='\0';
#line 71 "MACS_sample_kidney_box.instr"
  if(0) strncpy(mccchannel_13_analyzer_2_array_crystal_array_1_mask_setting, 0 ? 0 : "", 16384); else mccchannel_13_analyzer_2_array_crystal_array_1_mask_setting[0]='\0';
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_13_analyzer_2_array_crystal_array_1_number_of_activations = 1;
#line 132489 "MACS_sample_kidney_box.c"

  SIG_MESSAGE("channel_13_analyzer_2_array_crystal_array_1 (Init:Place/Rotate)");
  rot_set_rotation(mctr1,
#line 3496 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 3496 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 3496 "MACS_sample_kidney_box.instr"
    (0 - RAD2DEG * channel_13_analyzer_2_array_theta [ 1 ])*DEG2RAD);
#line 132499 "MACS_sample_kidney_box.c"
  rot_mul(mctr1, mcrotachannel_13_analyzer_2_rotated, mcrotachannel_13_analyzer_2_array_crystal_array_1);
  rot_transpose(mcrotachannel_13_analyzer_2_array_crystal_array_0, mctr1);
  rot_mul(mcrotachannel_13_analyzer_2_array_crystal_array_1, mctr1, mcrotrchannel_13_analyzer_2_array_crystal_array_1);
  mctc1 = coords_set(
#line 3495 "MACS_sample_kidney_box.instr"
    0 + channel_13_analyzer_2_array_effective_radius_of_curvature * ( 1 - cos ( channel_13_analyzer_2_array_theta [ 1 ] ) ),
#line 3495 "MACS_sample_kidney_box.instr"
    0 + channel_13_analyzer_2_array_effective_radius_of_curvature * sin ( channel_13_analyzer_2_array_theta [ 1 ] ),
#line 3495 "MACS_sample_kidney_box.instr"
    0);
#line 132510 "MACS_sample_kidney_box.c"
  rot_transpose(mcrotachannel_13_analyzer_2_rotated, mctr1);
  mctc2 = rot_apply(mctr1, mctc1);
  mcposachannel_13_analyzer_2_array_crystal_array_1 = coords_add(mcposachannel_13_analyzer_2_rotated, mctc2);
  mctc1 = coords_sub(mcposachannel_13_analyzer_2_array_crystal_array_0, mcposachannel_13_analyzer_2_array_crystal_array_1);
  mcposrchannel_13_analyzer_2_array_crystal_array_1 = rot_apply(mcrotachannel_13_analyzer_2_array_crystal_array_1, mctc1);
  mcDEBUG_COMPONENT("channel_13_analyzer_2_array_crystal_array_1", mcposachannel_13_analyzer_2_array_crystal_array_1, mcrotachannel_13_analyzer_2_array_crystal_array_1)
  mccomp_posa[636] = mcposachannel_13_analyzer_2_array_crystal_array_1;
  mccomp_posr[636] = mcposrchannel_13_analyzer_2_array_crystal_array_1;
  mcNCounter[636]  = mcPCounter[636] = mcP2Counter[636] = 0;
  mcAbsorbProp[636]= 0;
    /* Component channel_13_analyzer_2_array_crystal_array_2. */
  /* Setting parameters for component channel_13_analyzer_2_array_crystal_array_2. */
  SIG_MESSAGE("channel_13_analyzer_2_array_crystal_array_2 (Init:SetPar)");
#line 3500 "MACS_sample_kidney_box.instr"
  if("PG_analyzer") strncpy(mccchannel_13_analyzer_2_array_crystal_array_2_material_string, "PG_analyzer" ? "PG_analyzer" : "", 16384); else mccchannel_13_analyzer_2_array_crystal_array_2_material_string[0]='\0';
#line 3500 "MACS_sample_kidney_box.instr"
  mccchannel_13_analyzer_2_array_crystal_array_2_priority = 1521.2;
#line 3499 "MACS_sample_kidney_box.instr"
  mccchannel_13_analyzer_2_array_crystal_array_2_xwidth = channel_13_analyzer_2_array_crystal_depth;
#line 3499 "MACS_sample_kidney_box.instr"
  mccchannel_13_analyzer_2_array_crystal_array_2_yheight = channel_13_analyzer_2_array_crystal_height;
#line 3499 "MACS_sample_kidney_box.instr"
  mccchannel_13_analyzer_2_array_crystal_array_2_zdepth = channel_13_analyzer_2_array_crystal_width;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_13_analyzer_2_array_crystal_array_2_xwidth2 = -1;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_13_analyzer_2_array_crystal_array_2_yheight2 = -1;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_13_analyzer_2_array_crystal_array_2_visualize = 1;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_13_analyzer_2_array_crystal_array_2_target_index = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_13_analyzer_2_array_crystal_array_2_target_x = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_13_analyzer_2_array_crystal_array_2_target_y = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_13_analyzer_2_array_crystal_array_2_target_z = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_13_analyzer_2_array_crystal_array_2_focus_aw = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_13_analyzer_2_array_crystal_array_2_focus_ah = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_13_analyzer_2_array_crystal_array_2_focus_xw = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_13_analyzer_2_array_crystal_array_2_focus_xh = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_13_analyzer_2_array_crystal_array_2_focus_r = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_13_analyzer_2_array_crystal_array_2_p_interact = 0;
#line 71 "MACS_sample_kidney_box.instr"
  if(0) strncpy(mccchannel_13_analyzer_2_array_crystal_array_2_mask_string, 0 ? 0 : "", 16384); else mccchannel_13_analyzer_2_array_crystal_array_2_mask_string[0]='\0';
#line 71 "MACS_sample_kidney_box.instr"
  if(0) strncpy(mccchannel_13_analyzer_2_array_crystal_array_2_mask_setting, 0 ? 0 : "", 16384); else mccchannel_13_analyzer_2_array_crystal_array_2_mask_setting[0]='\0';
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_13_analyzer_2_array_crystal_array_2_number_of_activations = 1;
#line 132566 "MACS_sample_kidney_box.c"

  SIG_MESSAGE("channel_13_analyzer_2_array_crystal_array_2 (Init:Place/Rotate)");
  rot_set_rotation(mctr1,
#line 3502 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 3502 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 3502 "MACS_sample_kidney_box.instr"
    (0 - RAD2DEG * channel_13_analyzer_2_array_theta [ 2 ])*DEG2RAD);
#line 132576 "MACS_sample_kidney_box.c"
  rot_mul(mctr1, mcrotachannel_13_analyzer_2_rotated, mcrotachannel_13_analyzer_2_array_crystal_array_2);
  rot_transpose(mcrotachannel_13_analyzer_2_array_crystal_array_1, mctr1);
  rot_mul(mcrotachannel_13_analyzer_2_array_crystal_array_2, mctr1, mcrotrchannel_13_analyzer_2_array_crystal_array_2);
  mctc1 = coords_set(
#line 3501 "MACS_sample_kidney_box.instr"
    0 + channel_13_analyzer_2_array_effective_radius_of_curvature * ( 1 - cos ( channel_13_analyzer_2_array_theta [ 2 ] ) ),
#line 3501 "MACS_sample_kidney_box.instr"
    0 + channel_13_analyzer_2_array_effective_radius_of_curvature * sin ( channel_13_analyzer_2_array_theta [ 2 ] ),
#line 3501 "MACS_sample_kidney_box.instr"
    0);
#line 132587 "MACS_sample_kidney_box.c"
  rot_transpose(mcrotachannel_13_analyzer_2_rotated, mctr1);
  mctc2 = rot_apply(mctr1, mctc1);
  mcposachannel_13_analyzer_2_array_crystal_array_2 = coords_add(mcposachannel_13_analyzer_2_rotated, mctc2);
  mctc1 = coords_sub(mcposachannel_13_analyzer_2_array_crystal_array_1, mcposachannel_13_analyzer_2_array_crystal_array_2);
  mcposrchannel_13_analyzer_2_array_crystal_array_2 = rot_apply(mcrotachannel_13_analyzer_2_array_crystal_array_2, mctc1);
  mcDEBUG_COMPONENT("channel_13_analyzer_2_array_crystal_array_2", mcposachannel_13_analyzer_2_array_crystal_array_2, mcrotachannel_13_analyzer_2_array_crystal_array_2)
  mccomp_posa[637] = mcposachannel_13_analyzer_2_array_crystal_array_2;
  mccomp_posr[637] = mcposrchannel_13_analyzer_2_array_crystal_array_2;
  mcNCounter[637]  = mcPCounter[637] = mcP2Counter[637] = 0;
  mcAbsorbProp[637]= 0;
    /* Component channel_13_analyzer_2_array_crystal_array_3. */
  /* Setting parameters for component channel_13_analyzer_2_array_crystal_array_3. */
  SIG_MESSAGE("channel_13_analyzer_2_array_crystal_array_3 (Init:SetPar)");
#line 3506 "MACS_sample_kidney_box.instr"
  if("PG_analyzer") strncpy(mccchannel_13_analyzer_2_array_crystal_array_3_material_string, "PG_analyzer" ? "PG_analyzer" : "", 16384); else mccchannel_13_analyzer_2_array_crystal_array_3_material_string[0]='\0';
#line 3506 "MACS_sample_kidney_box.instr"
  mccchannel_13_analyzer_2_array_crystal_array_3_priority = 1521.3;
#line 3505 "MACS_sample_kidney_box.instr"
  mccchannel_13_analyzer_2_array_crystal_array_3_xwidth = channel_13_analyzer_2_array_crystal_depth;
#line 3505 "MACS_sample_kidney_box.instr"
  mccchannel_13_analyzer_2_array_crystal_array_3_yheight = channel_13_analyzer_2_array_crystal_height;
#line 3505 "MACS_sample_kidney_box.instr"
  mccchannel_13_analyzer_2_array_crystal_array_3_zdepth = channel_13_analyzer_2_array_crystal_width;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_13_analyzer_2_array_crystal_array_3_xwidth2 = -1;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_13_analyzer_2_array_crystal_array_3_yheight2 = -1;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_13_analyzer_2_array_crystal_array_3_visualize = 1;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_13_analyzer_2_array_crystal_array_3_target_index = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_13_analyzer_2_array_crystal_array_3_target_x = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_13_analyzer_2_array_crystal_array_3_target_y = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_13_analyzer_2_array_crystal_array_3_target_z = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_13_analyzer_2_array_crystal_array_3_focus_aw = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_13_analyzer_2_array_crystal_array_3_focus_ah = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_13_analyzer_2_array_crystal_array_3_focus_xw = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_13_analyzer_2_array_crystal_array_3_focus_xh = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_13_analyzer_2_array_crystal_array_3_focus_r = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_13_analyzer_2_array_crystal_array_3_p_interact = 0;
#line 71 "MACS_sample_kidney_box.instr"
  if(0) strncpy(mccchannel_13_analyzer_2_array_crystal_array_3_mask_string, 0 ? 0 : "", 16384); else mccchannel_13_analyzer_2_array_crystal_array_3_mask_string[0]='\0';
#line 71 "MACS_sample_kidney_box.instr"
  if(0) strncpy(mccchannel_13_analyzer_2_array_crystal_array_3_mask_setting, 0 ? 0 : "", 16384); else mccchannel_13_analyzer_2_array_crystal_array_3_mask_setting[0]='\0';
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_13_analyzer_2_array_crystal_array_3_number_of_activations = 1;
#line 132643 "MACS_sample_kidney_box.c"

  SIG_MESSAGE("channel_13_analyzer_2_array_crystal_array_3 (Init:Place/Rotate)");
  rot_set_rotation(mctr1,
#line 3508 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 3508 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 3508 "MACS_sample_kidney_box.instr"
    (0 - RAD2DEG * channel_13_analyzer_2_array_theta [ 3 ])*DEG2RAD);
#line 132653 "MACS_sample_kidney_box.c"
  rot_mul(mctr1, mcrotachannel_13_analyzer_2_rotated, mcrotachannel_13_analyzer_2_array_crystal_array_3);
  rot_transpose(mcrotachannel_13_analyzer_2_array_crystal_array_2, mctr1);
  rot_mul(mcrotachannel_13_analyzer_2_array_crystal_array_3, mctr1, mcrotrchannel_13_analyzer_2_array_crystal_array_3);
  mctc1 = coords_set(
#line 3507 "MACS_sample_kidney_box.instr"
    0 + channel_13_analyzer_2_array_effective_radius_of_curvature * ( 1 - cos ( channel_13_analyzer_2_array_theta [ 3 ] ) ),
#line 3507 "MACS_sample_kidney_box.instr"
    0 + channel_13_analyzer_2_array_effective_radius_of_curvature * sin ( channel_13_analyzer_2_array_theta [ 3 ] ),
#line 3507 "MACS_sample_kidney_box.instr"
    0);
#line 132664 "MACS_sample_kidney_box.c"
  rot_transpose(mcrotachannel_13_analyzer_2_rotated, mctr1);
  mctc2 = rot_apply(mctr1, mctc1);
  mcposachannel_13_analyzer_2_array_crystal_array_3 = coords_add(mcposachannel_13_analyzer_2_rotated, mctc2);
  mctc1 = coords_sub(mcposachannel_13_analyzer_2_array_crystal_array_2, mcposachannel_13_analyzer_2_array_crystal_array_3);
  mcposrchannel_13_analyzer_2_array_crystal_array_3 = rot_apply(mcrotachannel_13_analyzer_2_array_crystal_array_3, mctc1);
  mcDEBUG_COMPONENT("channel_13_analyzer_2_array_crystal_array_3", mcposachannel_13_analyzer_2_array_crystal_array_3, mcrotachannel_13_analyzer_2_array_crystal_array_3)
  mccomp_posa[638] = mcposachannel_13_analyzer_2_array_crystal_array_3;
  mccomp_posr[638] = mcposrchannel_13_analyzer_2_array_crystal_array_3;
  mcNCounter[638]  = mcPCounter[638] = mcP2Counter[638] = 0;
  mcAbsorbProp[638]= 0;
    /* Component channel_13_analyzer_2_array_crystal_array_4. */
  /* Setting parameters for component channel_13_analyzer_2_array_crystal_array_4. */
  SIG_MESSAGE("channel_13_analyzer_2_array_crystal_array_4 (Init:SetPar)");
#line 3512 "MACS_sample_kidney_box.instr"
  if("PG_analyzer") strncpy(mccchannel_13_analyzer_2_array_crystal_array_4_material_string, "PG_analyzer" ? "PG_analyzer" : "", 16384); else mccchannel_13_analyzer_2_array_crystal_array_4_material_string[0]='\0';
#line 3512 "MACS_sample_kidney_box.instr"
  mccchannel_13_analyzer_2_array_crystal_array_4_priority = 1521.4;
#line 3511 "MACS_sample_kidney_box.instr"
  mccchannel_13_analyzer_2_array_crystal_array_4_xwidth = channel_13_analyzer_2_array_crystal_depth;
#line 3511 "MACS_sample_kidney_box.instr"
  mccchannel_13_analyzer_2_array_crystal_array_4_yheight = channel_13_analyzer_2_array_crystal_height;
#line 3511 "MACS_sample_kidney_box.instr"
  mccchannel_13_analyzer_2_array_crystal_array_4_zdepth = channel_13_analyzer_2_array_crystal_width;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_13_analyzer_2_array_crystal_array_4_xwidth2 = -1;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_13_analyzer_2_array_crystal_array_4_yheight2 = -1;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_13_analyzer_2_array_crystal_array_4_visualize = 1;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_13_analyzer_2_array_crystal_array_4_target_index = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_13_analyzer_2_array_crystal_array_4_target_x = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_13_analyzer_2_array_crystal_array_4_target_y = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_13_analyzer_2_array_crystal_array_4_target_z = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_13_analyzer_2_array_crystal_array_4_focus_aw = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_13_analyzer_2_array_crystal_array_4_focus_ah = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_13_analyzer_2_array_crystal_array_4_focus_xw = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_13_analyzer_2_array_crystal_array_4_focus_xh = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_13_analyzer_2_array_crystal_array_4_focus_r = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_13_analyzer_2_array_crystal_array_4_p_interact = 0;
#line 71 "MACS_sample_kidney_box.instr"
  if(0) strncpy(mccchannel_13_analyzer_2_array_crystal_array_4_mask_string, 0 ? 0 : "", 16384); else mccchannel_13_analyzer_2_array_crystal_array_4_mask_string[0]='\0';
#line 71 "MACS_sample_kidney_box.instr"
  if(0) strncpy(mccchannel_13_analyzer_2_array_crystal_array_4_mask_setting, 0 ? 0 : "", 16384); else mccchannel_13_analyzer_2_array_crystal_array_4_mask_setting[0]='\0';
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_13_analyzer_2_array_crystal_array_4_number_of_activations = 1;
#line 132720 "MACS_sample_kidney_box.c"

  SIG_MESSAGE("channel_13_analyzer_2_array_crystal_array_4 (Init:Place/Rotate)");
  rot_set_rotation(mctr1,
#line 3514 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 3514 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 3514 "MACS_sample_kidney_box.instr"
    (0 - RAD2DEG * channel_13_analyzer_2_array_theta [ 4 ])*DEG2RAD);
#line 132730 "MACS_sample_kidney_box.c"
  rot_mul(mctr1, mcrotachannel_13_analyzer_2_rotated, mcrotachannel_13_analyzer_2_array_crystal_array_4);
  rot_transpose(mcrotachannel_13_analyzer_2_array_crystal_array_3, mctr1);
  rot_mul(mcrotachannel_13_analyzer_2_array_crystal_array_4, mctr1, mcrotrchannel_13_analyzer_2_array_crystal_array_4);
  mctc1 = coords_set(
#line 3513 "MACS_sample_kidney_box.instr"
    0 + channel_13_analyzer_2_array_effective_radius_of_curvature * ( 1 - cos ( channel_13_analyzer_2_array_theta [ 4 ] ) ),
#line 3513 "MACS_sample_kidney_box.instr"
    0 + channel_13_analyzer_2_array_effective_radius_of_curvature * sin ( channel_13_analyzer_2_array_theta [ 4 ] ),
#line 3513 "MACS_sample_kidney_box.instr"
    0);
#line 132741 "MACS_sample_kidney_box.c"
  rot_transpose(mcrotachannel_13_analyzer_2_rotated, mctr1);
  mctc2 = rot_apply(mctr1, mctc1);
  mcposachannel_13_analyzer_2_array_crystal_array_4 = coords_add(mcposachannel_13_analyzer_2_rotated, mctc2);
  mctc1 = coords_sub(mcposachannel_13_analyzer_2_array_crystal_array_3, mcposachannel_13_analyzer_2_array_crystal_array_4);
  mcposrchannel_13_analyzer_2_array_crystal_array_4 = rot_apply(mcrotachannel_13_analyzer_2_array_crystal_array_4, mctc1);
  mcDEBUG_COMPONENT("channel_13_analyzer_2_array_crystal_array_4", mcposachannel_13_analyzer_2_array_crystal_array_4, mcrotachannel_13_analyzer_2_array_crystal_array_4)
  mccomp_posa[639] = mcposachannel_13_analyzer_2_array_crystal_array_4;
  mccomp_posr[639] = mcposrchannel_13_analyzer_2_array_crystal_array_4;
  mcNCounter[639]  = mcPCounter[639] = mcP2Counter[639] = 0;
  mcAbsorbProp[639]= 0;
    /* Component channel_13_analyzer_2_array_crystal_array_5. */
  /* Setting parameters for component channel_13_analyzer_2_array_crystal_array_5. */
  SIG_MESSAGE("channel_13_analyzer_2_array_crystal_array_5 (Init:SetPar)");
#line 3518 "MACS_sample_kidney_box.instr"
  if("PG_analyzer") strncpy(mccchannel_13_analyzer_2_array_crystal_array_5_material_string, "PG_analyzer" ? "PG_analyzer" : "", 16384); else mccchannel_13_analyzer_2_array_crystal_array_5_material_string[0]='\0';
#line 3518 "MACS_sample_kidney_box.instr"
  mccchannel_13_analyzer_2_array_crystal_array_5_priority = 1521.5;
#line 3517 "MACS_sample_kidney_box.instr"
  mccchannel_13_analyzer_2_array_crystal_array_5_xwidth = channel_13_analyzer_2_array_crystal_depth;
#line 3517 "MACS_sample_kidney_box.instr"
  mccchannel_13_analyzer_2_array_crystal_array_5_yheight = channel_13_analyzer_2_array_crystal_height;
#line 3517 "MACS_sample_kidney_box.instr"
  mccchannel_13_analyzer_2_array_crystal_array_5_zdepth = channel_13_analyzer_2_array_crystal_width;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_13_analyzer_2_array_crystal_array_5_xwidth2 = -1;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_13_analyzer_2_array_crystal_array_5_yheight2 = -1;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_13_analyzer_2_array_crystal_array_5_visualize = 1;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_13_analyzer_2_array_crystal_array_5_target_index = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_13_analyzer_2_array_crystal_array_5_target_x = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_13_analyzer_2_array_crystal_array_5_target_y = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_13_analyzer_2_array_crystal_array_5_target_z = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_13_analyzer_2_array_crystal_array_5_focus_aw = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_13_analyzer_2_array_crystal_array_5_focus_ah = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_13_analyzer_2_array_crystal_array_5_focus_xw = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_13_analyzer_2_array_crystal_array_5_focus_xh = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_13_analyzer_2_array_crystal_array_5_focus_r = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_13_analyzer_2_array_crystal_array_5_p_interact = 0;
#line 71 "MACS_sample_kidney_box.instr"
  if(0) strncpy(mccchannel_13_analyzer_2_array_crystal_array_5_mask_string, 0 ? 0 : "", 16384); else mccchannel_13_analyzer_2_array_crystal_array_5_mask_string[0]='\0';
#line 71 "MACS_sample_kidney_box.instr"
  if(0) strncpy(mccchannel_13_analyzer_2_array_crystal_array_5_mask_setting, 0 ? 0 : "", 16384); else mccchannel_13_analyzer_2_array_crystal_array_5_mask_setting[0]='\0';
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_13_analyzer_2_array_crystal_array_5_number_of_activations = 1;
#line 132797 "MACS_sample_kidney_box.c"

  SIG_MESSAGE("channel_13_analyzer_2_array_crystal_array_5 (Init:Place/Rotate)");
  rot_set_rotation(mctr1,
#line 3520 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 3520 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 3520 "MACS_sample_kidney_box.instr"
    (0 - RAD2DEG * channel_13_analyzer_2_array_theta [ 5 ])*DEG2RAD);
#line 132807 "MACS_sample_kidney_box.c"
  rot_mul(mctr1, mcrotachannel_13_analyzer_2_rotated, mcrotachannel_13_analyzer_2_array_crystal_array_5);
  rot_transpose(mcrotachannel_13_analyzer_2_array_crystal_array_4, mctr1);
  rot_mul(mcrotachannel_13_analyzer_2_array_crystal_array_5, mctr1, mcrotrchannel_13_analyzer_2_array_crystal_array_5);
  mctc1 = coords_set(
#line 3519 "MACS_sample_kidney_box.instr"
    0 + channel_13_analyzer_2_array_effective_radius_of_curvature * ( 1 - cos ( channel_13_analyzer_2_array_theta [ 5 ] ) ),
#line 3519 "MACS_sample_kidney_box.instr"
    0 + channel_13_analyzer_2_array_effective_radius_of_curvature * sin ( channel_13_analyzer_2_array_theta [ 5 ] ),
#line 3519 "MACS_sample_kidney_box.instr"
    0);
#line 132818 "MACS_sample_kidney_box.c"
  rot_transpose(mcrotachannel_13_analyzer_2_rotated, mctr1);
  mctc2 = rot_apply(mctr1, mctc1);
  mcposachannel_13_analyzer_2_array_crystal_array_5 = coords_add(mcposachannel_13_analyzer_2_rotated, mctc2);
  mctc1 = coords_sub(mcposachannel_13_analyzer_2_array_crystal_array_4, mcposachannel_13_analyzer_2_array_crystal_array_5);
  mcposrchannel_13_analyzer_2_array_crystal_array_5 = rot_apply(mcrotachannel_13_analyzer_2_array_crystal_array_5, mctc1);
  mcDEBUG_COMPONENT("channel_13_analyzer_2_array_crystal_array_5", mcposachannel_13_analyzer_2_array_crystal_array_5, mcrotachannel_13_analyzer_2_array_crystal_array_5)
  mccomp_posa[640] = mcposachannel_13_analyzer_2_array_crystal_array_5;
  mccomp_posr[640] = mcposrchannel_13_analyzer_2_array_crystal_array_5;
  mcNCounter[640]  = mcPCounter[640] = mcP2Counter[640] = 0;
  mcAbsorbProp[640]= 0;
    /* Component channel_13_analyzer_2_array_crystal_array_6. */
  /* Setting parameters for component channel_13_analyzer_2_array_crystal_array_6. */
  SIG_MESSAGE("channel_13_analyzer_2_array_crystal_array_6 (Init:SetPar)");
#line 3524 "MACS_sample_kidney_box.instr"
  if("PG_analyzer") strncpy(mccchannel_13_analyzer_2_array_crystal_array_6_material_string, "PG_analyzer" ? "PG_analyzer" : "", 16384); else mccchannel_13_analyzer_2_array_crystal_array_6_material_string[0]='\0';
#line 3524 "MACS_sample_kidney_box.instr"
  mccchannel_13_analyzer_2_array_crystal_array_6_priority = 1521.6;
#line 3523 "MACS_sample_kidney_box.instr"
  mccchannel_13_analyzer_2_array_crystal_array_6_xwidth = channel_13_analyzer_2_array_crystal_depth;
#line 3523 "MACS_sample_kidney_box.instr"
  mccchannel_13_analyzer_2_array_crystal_array_6_yheight = channel_13_analyzer_2_array_crystal_height;
#line 3523 "MACS_sample_kidney_box.instr"
  mccchannel_13_analyzer_2_array_crystal_array_6_zdepth = channel_13_analyzer_2_array_crystal_width;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_13_analyzer_2_array_crystal_array_6_xwidth2 = -1;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_13_analyzer_2_array_crystal_array_6_yheight2 = -1;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_13_analyzer_2_array_crystal_array_6_visualize = 1;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_13_analyzer_2_array_crystal_array_6_target_index = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_13_analyzer_2_array_crystal_array_6_target_x = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_13_analyzer_2_array_crystal_array_6_target_y = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_13_analyzer_2_array_crystal_array_6_target_z = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_13_analyzer_2_array_crystal_array_6_focus_aw = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_13_analyzer_2_array_crystal_array_6_focus_ah = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_13_analyzer_2_array_crystal_array_6_focus_xw = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_13_analyzer_2_array_crystal_array_6_focus_xh = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_13_analyzer_2_array_crystal_array_6_focus_r = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_13_analyzer_2_array_crystal_array_6_p_interact = 0;
#line 71 "MACS_sample_kidney_box.instr"
  if(0) strncpy(mccchannel_13_analyzer_2_array_crystal_array_6_mask_string, 0 ? 0 : "", 16384); else mccchannel_13_analyzer_2_array_crystal_array_6_mask_string[0]='\0';
#line 71 "MACS_sample_kidney_box.instr"
  if(0) strncpy(mccchannel_13_analyzer_2_array_crystal_array_6_mask_setting, 0 ? 0 : "", 16384); else mccchannel_13_analyzer_2_array_crystal_array_6_mask_setting[0]='\0';
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_13_analyzer_2_array_crystal_array_6_number_of_activations = 1;
#line 132874 "MACS_sample_kidney_box.c"

  SIG_MESSAGE("channel_13_analyzer_2_array_crystal_array_6 (Init:Place/Rotate)");
  rot_set_rotation(mctr1,
#line 3526 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 3526 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 3526 "MACS_sample_kidney_box.instr"
    (0 - RAD2DEG * channel_13_analyzer_2_array_theta [ 6 ])*DEG2RAD);
#line 132884 "MACS_sample_kidney_box.c"
  rot_mul(mctr1, mcrotachannel_13_analyzer_2_rotated, mcrotachannel_13_analyzer_2_array_crystal_array_6);
  rot_transpose(mcrotachannel_13_analyzer_2_array_crystal_array_5, mctr1);
  rot_mul(mcrotachannel_13_analyzer_2_array_crystal_array_6, mctr1, mcrotrchannel_13_analyzer_2_array_crystal_array_6);
  mctc1 = coords_set(
#line 3525 "MACS_sample_kidney_box.instr"
    0 + channel_13_analyzer_2_array_effective_radius_of_curvature * ( 1 - cos ( channel_13_analyzer_2_array_theta [ 6 ] ) ),
#line 3525 "MACS_sample_kidney_box.instr"
    0 + channel_13_analyzer_2_array_effective_radius_of_curvature * sin ( channel_13_analyzer_2_array_theta [ 6 ] ),
#line 3525 "MACS_sample_kidney_box.instr"
    0);
#line 132895 "MACS_sample_kidney_box.c"
  rot_transpose(mcrotachannel_13_analyzer_2_rotated, mctr1);
  mctc2 = rot_apply(mctr1, mctc1);
  mcposachannel_13_analyzer_2_array_crystal_array_6 = coords_add(mcposachannel_13_analyzer_2_rotated, mctc2);
  mctc1 = coords_sub(mcposachannel_13_analyzer_2_array_crystal_array_5, mcposachannel_13_analyzer_2_array_crystal_array_6);
  mcposrchannel_13_analyzer_2_array_crystal_array_6 = rot_apply(mcrotachannel_13_analyzer_2_array_crystal_array_6, mctc1);
  mcDEBUG_COMPONENT("channel_13_analyzer_2_array_crystal_array_6", mcposachannel_13_analyzer_2_array_crystal_array_6, mcrotachannel_13_analyzer_2_array_crystal_array_6)
  mccomp_posa[641] = mcposachannel_13_analyzer_2_array_crystal_array_6;
  mccomp_posr[641] = mcposrchannel_13_analyzer_2_array_crystal_array_6;
  mcNCounter[641]  = mcPCounter[641] = mcP2Counter[641] = 0;
  mcAbsorbProp[641]= 0;
    /* Component channel_13_analyzer_2_array_crystal_array_7. */
  /* Setting parameters for component channel_13_analyzer_2_array_crystal_array_7. */
  SIG_MESSAGE("channel_13_analyzer_2_array_crystal_array_7 (Init:SetPar)");
#line 3530 "MACS_sample_kidney_box.instr"
  if("PG_analyzer") strncpy(mccchannel_13_analyzer_2_array_crystal_array_7_material_string, "PG_analyzer" ? "PG_analyzer" : "", 16384); else mccchannel_13_analyzer_2_array_crystal_array_7_material_string[0]='\0';
#line 3530 "MACS_sample_kidney_box.instr"
  mccchannel_13_analyzer_2_array_crystal_array_7_priority = 1521.7;
#line 3529 "MACS_sample_kidney_box.instr"
  mccchannel_13_analyzer_2_array_crystal_array_7_xwidth = channel_13_analyzer_2_array_crystal_depth;
#line 3529 "MACS_sample_kidney_box.instr"
  mccchannel_13_analyzer_2_array_crystal_array_7_yheight = channel_13_analyzer_2_array_crystal_height;
#line 3529 "MACS_sample_kidney_box.instr"
  mccchannel_13_analyzer_2_array_crystal_array_7_zdepth = channel_13_analyzer_2_array_crystal_width;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_13_analyzer_2_array_crystal_array_7_xwidth2 = -1;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_13_analyzer_2_array_crystal_array_7_yheight2 = -1;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_13_analyzer_2_array_crystal_array_7_visualize = 1;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_13_analyzer_2_array_crystal_array_7_target_index = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_13_analyzer_2_array_crystal_array_7_target_x = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_13_analyzer_2_array_crystal_array_7_target_y = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_13_analyzer_2_array_crystal_array_7_target_z = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_13_analyzer_2_array_crystal_array_7_focus_aw = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_13_analyzer_2_array_crystal_array_7_focus_ah = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_13_analyzer_2_array_crystal_array_7_focus_xw = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_13_analyzer_2_array_crystal_array_7_focus_xh = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_13_analyzer_2_array_crystal_array_7_focus_r = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_13_analyzer_2_array_crystal_array_7_p_interact = 0;
#line 71 "MACS_sample_kidney_box.instr"
  if(0) strncpy(mccchannel_13_analyzer_2_array_crystal_array_7_mask_string, 0 ? 0 : "", 16384); else mccchannel_13_analyzer_2_array_crystal_array_7_mask_string[0]='\0';
#line 71 "MACS_sample_kidney_box.instr"
  if(0) strncpy(mccchannel_13_analyzer_2_array_crystal_array_7_mask_setting, 0 ? 0 : "", 16384); else mccchannel_13_analyzer_2_array_crystal_array_7_mask_setting[0]='\0';
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_13_analyzer_2_array_crystal_array_7_number_of_activations = 1;
#line 132951 "MACS_sample_kidney_box.c"

  SIG_MESSAGE("channel_13_analyzer_2_array_crystal_array_7 (Init:Place/Rotate)");
  rot_set_rotation(mctr1,
#line 3532 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 3532 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 3532 "MACS_sample_kidney_box.instr"
    (0 - RAD2DEG * channel_13_analyzer_2_array_theta [ 7 ])*DEG2RAD);
#line 132961 "MACS_sample_kidney_box.c"
  rot_mul(mctr1, mcrotachannel_13_analyzer_2_rotated, mcrotachannel_13_analyzer_2_array_crystal_array_7);
  rot_transpose(mcrotachannel_13_analyzer_2_array_crystal_array_6, mctr1);
  rot_mul(mcrotachannel_13_analyzer_2_array_crystal_array_7, mctr1, mcrotrchannel_13_analyzer_2_array_crystal_array_7);
  mctc1 = coords_set(
#line 3531 "MACS_sample_kidney_box.instr"
    0 + channel_13_analyzer_2_array_effective_radius_of_curvature * ( 1 - cos ( channel_13_analyzer_2_array_theta [ 7 ] ) ),
#line 3531 "MACS_sample_kidney_box.instr"
    0 + channel_13_analyzer_2_array_effective_radius_of_curvature * sin ( channel_13_analyzer_2_array_theta [ 7 ] ),
#line 3531 "MACS_sample_kidney_box.instr"
    0);
#line 132972 "MACS_sample_kidney_box.c"
  rot_transpose(mcrotachannel_13_analyzer_2_rotated, mctr1);
  mctc2 = rot_apply(mctr1, mctc1);
  mcposachannel_13_analyzer_2_array_crystal_array_7 = coords_add(mcposachannel_13_analyzer_2_rotated, mctc2);
  mctc1 = coords_sub(mcposachannel_13_analyzer_2_array_crystal_array_6, mcposachannel_13_analyzer_2_array_crystal_array_7);
  mcposrchannel_13_analyzer_2_array_crystal_array_7 = rot_apply(mcrotachannel_13_analyzer_2_array_crystal_array_7, mctc1);
  mcDEBUG_COMPONENT("channel_13_analyzer_2_array_crystal_array_7", mcposachannel_13_analyzer_2_array_crystal_array_7, mcrotachannel_13_analyzer_2_array_crystal_array_7)
  mccomp_posa[642] = mcposachannel_13_analyzer_2_array_crystal_array_7;
  mccomp_posr[642] = mcposrchannel_13_analyzer_2_array_crystal_array_7;
  mcNCounter[642]  = mcPCounter[642] = mcP2Counter[642] = 0;
  mcAbsorbProp[642]= 0;
    /* Component channel_13_analyzer_2_array_crystal_array_8. */
  /* Setting parameters for component channel_13_analyzer_2_array_crystal_array_8. */
  SIG_MESSAGE("channel_13_analyzer_2_array_crystal_array_8 (Init:SetPar)");
#line 3536 "MACS_sample_kidney_box.instr"
  if("PG_analyzer") strncpy(mccchannel_13_analyzer_2_array_crystal_array_8_material_string, "PG_analyzer" ? "PG_analyzer" : "", 16384); else mccchannel_13_analyzer_2_array_crystal_array_8_material_string[0]='\0';
#line 3536 "MACS_sample_kidney_box.instr"
  mccchannel_13_analyzer_2_array_crystal_array_8_priority = 1521.8;
#line 3535 "MACS_sample_kidney_box.instr"
  mccchannel_13_analyzer_2_array_crystal_array_8_xwidth = channel_13_analyzer_2_array_crystal_depth;
#line 3535 "MACS_sample_kidney_box.instr"
  mccchannel_13_analyzer_2_array_crystal_array_8_yheight = channel_13_analyzer_2_array_crystal_height;
#line 3535 "MACS_sample_kidney_box.instr"
  mccchannel_13_analyzer_2_array_crystal_array_8_zdepth = channel_13_analyzer_2_array_crystal_width;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_13_analyzer_2_array_crystal_array_8_xwidth2 = -1;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_13_analyzer_2_array_crystal_array_8_yheight2 = -1;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_13_analyzer_2_array_crystal_array_8_visualize = 1;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_13_analyzer_2_array_crystal_array_8_target_index = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_13_analyzer_2_array_crystal_array_8_target_x = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_13_analyzer_2_array_crystal_array_8_target_y = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_13_analyzer_2_array_crystal_array_8_target_z = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_13_analyzer_2_array_crystal_array_8_focus_aw = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_13_analyzer_2_array_crystal_array_8_focus_ah = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_13_analyzer_2_array_crystal_array_8_focus_xw = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_13_analyzer_2_array_crystal_array_8_focus_xh = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_13_analyzer_2_array_crystal_array_8_focus_r = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_13_analyzer_2_array_crystal_array_8_p_interact = 0;
#line 71 "MACS_sample_kidney_box.instr"
  if(0) strncpy(mccchannel_13_analyzer_2_array_crystal_array_8_mask_string, 0 ? 0 : "", 16384); else mccchannel_13_analyzer_2_array_crystal_array_8_mask_string[0]='\0';
#line 71 "MACS_sample_kidney_box.instr"
  if(0) strncpy(mccchannel_13_analyzer_2_array_crystal_array_8_mask_setting, 0 ? 0 : "", 16384); else mccchannel_13_analyzer_2_array_crystal_array_8_mask_setting[0]='\0';
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_13_analyzer_2_array_crystal_array_8_number_of_activations = 1;
#line 133028 "MACS_sample_kidney_box.c"

  SIG_MESSAGE("channel_13_analyzer_2_array_crystal_array_8 (Init:Place/Rotate)");
  rot_set_rotation(mctr1,
#line 3538 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 3538 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 3538 "MACS_sample_kidney_box.instr"
    (0 - RAD2DEG * channel_13_analyzer_2_array_theta [ 8 ])*DEG2RAD);
#line 133038 "MACS_sample_kidney_box.c"
  rot_mul(mctr1, mcrotachannel_13_analyzer_2_rotated, mcrotachannel_13_analyzer_2_array_crystal_array_8);
  rot_transpose(mcrotachannel_13_analyzer_2_array_crystal_array_7, mctr1);
  rot_mul(mcrotachannel_13_analyzer_2_array_crystal_array_8, mctr1, mcrotrchannel_13_analyzer_2_array_crystal_array_8);
  mctc1 = coords_set(
#line 3537 "MACS_sample_kidney_box.instr"
    0 + channel_13_analyzer_2_array_effective_radius_of_curvature * ( 1 - cos ( channel_13_analyzer_2_array_theta [ 8 ] ) ),
#line 3537 "MACS_sample_kidney_box.instr"
    0 + channel_13_analyzer_2_array_effective_radius_of_curvature * sin ( channel_13_analyzer_2_array_theta [ 8 ] ),
#line 3537 "MACS_sample_kidney_box.instr"
    0);
#line 133049 "MACS_sample_kidney_box.c"
  rot_transpose(mcrotachannel_13_analyzer_2_rotated, mctr1);
  mctc2 = rot_apply(mctr1, mctc1);
  mcposachannel_13_analyzer_2_array_crystal_array_8 = coords_add(mcposachannel_13_analyzer_2_rotated, mctc2);
  mctc1 = coords_sub(mcposachannel_13_analyzer_2_array_crystal_array_7, mcposachannel_13_analyzer_2_array_crystal_array_8);
  mcposrchannel_13_analyzer_2_array_crystal_array_8 = rot_apply(mcrotachannel_13_analyzer_2_array_crystal_array_8, mctc1);
  mcDEBUG_COMPONENT("channel_13_analyzer_2_array_crystal_array_8", mcposachannel_13_analyzer_2_array_crystal_array_8, mcrotachannel_13_analyzer_2_array_crystal_array_8)
  mccomp_posa[643] = mcposachannel_13_analyzer_2_array_crystal_array_8;
  mccomp_posr[643] = mcposrchannel_13_analyzer_2_array_crystal_array_8;
  mcNCounter[643]  = mcPCounter[643] = mcP2Counter[643] = 0;
  mcAbsorbProp[643]= 0;
    /* Component channel_13_cave2_cyl1. */
  /* Setting parameters for component channel_13_cave2_cyl1. */
  SIG_MESSAGE("channel_13_cave2_cyl1 (Init:SetPar)");
#line 3543 "MACS_sample_kidney_box.instr"
  if("Vacuum") strncpy(mccchannel_13_cave2_cyl1_material_string, "Vacuum" ? "Vacuum" : "", 16384); else mccchannel_13_cave2_cyl1_material_string[0]='\0';
#line 3543 "MACS_sample_kidney_box.instr"
  mccchannel_13_cave2_cyl1_priority = 1507.5;
#line 3542 "MACS_sample_kidney_box.instr"
  mccchannel_13_cave2_cyl1_radius = kidney_cave2_cyl1_radius;
#line 3542 "MACS_sample_kidney_box.instr"
  mccchannel_13_cave2_cyl1_yheight = kidney_cave2_cyl1_height;
#line 67 "MACS_sample_kidney_box.instr"
  mccchannel_13_cave2_cyl1_visualize = 1;
#line 67 "MACS_sample_kidney_box.instr"
  mccchannel_13_cave2_cyl1_target_index = 0;
#line 67 "MACS_sample_kidney_box.instr"
  mccchannel_13_cave2_cyl1_target_x = 0;
#line 67 "MACS_sample_kidney_box.instr"
  mccchannel_13_cave2_cyl1_target_y = 0;
#line 67 "MACS_sample_kidney_box.instr"
  mccchannel_13_cave2_cyl1_target_z = 0;
#line 67 "MACS_sample_kidney_box.instr"
  mccchannel_13_cave2_cyl1_focus_aw = 0;
#line 67 "MACS_sample_kidney_box.instr"
  mccchannel_13_cave2_cyl1_focus_ah = 0;
#line 67 "MACS_sample_kidney_box.instr"
  mccchannel_13_cave2_cyl1_focus_xw = 0;
#line 67 "MACS_sample_kidney_box.instr"
  mccchannel_13_cave2_cyl1_focus_xh = 0;
#line 67 "MACS_sample_kidney_box.instr"
  mccchannel_13_cave2_cyl1_focus_r = 0;
#line 67 "MACS_sample_kidney_box.instr"
  mccchannel_13_cave2_cyl1_p_interact = 0;
#line 67 "MACS_sample_kidney_box.instr"
  if(0) strncpy(mccchannel_13_cave2_cyl1_mask_string, 0 ? 0 : "", 16384); else mccchannel_13_cave2_cyl1_mask_string[0]='\0';
#line 67 "MACS_sample_kidney_box.instr"
  if(0) strncpy(mccchannel_13_cave2_cyl1_mask_setting, 0 ? 0 : "", 16384); else mccchannel_13_cave2_cyl1_mask_setting[0]='\0';
#line 67 "MACS_sample_kidney_box.instr"
  mccchannel_13_cave2_cyl1_number_of_activations = 1;
#line 133099 "MACS_sample_kidney_box.c"

  SIG_MESSAGE("channel_13_cave2_cyl1 (Init:Place/Rotate)");
  rot_set_rotation(mctr1,
#line 3545 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 3545 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 3545 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD);
#line 133109 "MACS_sample_kidney_box.c"
  rot_mul(mctr1, mcrotachannel_13_analyzer_2_center, mcrotachannel_13_cave2_cyl1);
  rot_transpose(mcrotachannel_13_analyzer_2_array_crystal_array_8, mctr1);
  rot_mul(mcrotachannel_13_cave2_cyl1, mctr1, mcrotrchannel_13_cave2_cyl1);
  mctc1 = coords_set(
#line 3544 "MACS_sample_kidney_box.instr"
    0,
#line 3544 "MACS_sample_kidney_box.instr"
    0,
#line 3544 "MACS_sample_kidney_box.instr"
    spec_detector_to_analyzer_2_center);
#line 133120 "MACS_sample_kidney_box.c"
  rot_transpose(mcrotachannel_13_analyzer_2_center, mctr1);
  mctc2 = rot_apply(mctr1, mctc1);
  mcposachannel_13_cave2_cyl1 = coords_add(mcposachannel_13_analyzer_2_center, mctc2);
  mctc1 = coords_sub(mcposachannel_13_analyzer_2_array_crystal_array_8, mcposachannel_13_cave2_cyl1);
  mcposrchannel_13_cave2_cyl1 = rot_apply(mcrotachannel_13_cave2_cyl1, mctc1);
  mcDEBUG_COMPONENT("channel_13_cave2_cyl1", mcposachannel_13_cave2_cyl1, mcrotachannel_13_cave2_cyl1)
  mccomp_posa[644] = mcposachannel_13_cave2_cyl1;
  mccomp_posr[644] = mcposrchannel_13_cave2_cyl1;
  mcNCounter[644]  = mcPCounter[644] = mcP2Counter[644] = 0;
  mcAbsorbProp[644]= 0;
    /* Component channel_13_cave2_box1. */
  /* Setting parameters for component channel_13_cave2_box1. */
  SIG_MESSAGE("channel_13_cave2_box1 (Init:SetPar)");
#line 3550 "MACS_sample_kidney_box.instr"
  if("Vacuum") strncpy(mccchannel_13_cave2_box1_material_string, "Vacuum" ? "Vacuum" : "", 16384); else mccchannel_13_cave2_box1_material_string[0]='\0';
#line 3550 "MACS_sample_kidney_box.instr"
  mccchannel_13_cave2_box1_priority = 1501;
#line 3548 "MACS_sample_kidney_box.instr"
  mccchannel_13_cave2_box1_xwidth = kidney_cave2_box1_width1;
#line 3548 "MACS_sample_kidney_box.instr"
  mccchannel_13_cave2_box1_yheight = kidney_cave2_box1_height1;
#line 3548 "MACS_sample_kidney_box.instr"
  mccchannel_13_cave2_box1_zdepth = kidney_cave2_box1_depth;
#line 3549 "MACS_sample_kidney_box.instr"
  mccchannel_13_cave2_box1_xwidth2 = kidney_cave2_box1_width2;
#line 3549 "MACS_sample_kidney_box.instr"
  mccchannel_13_cave2_box1_yheight2 = kidney_cave2_box1_height2;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_13_cave2_box1_visualize = 1;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_13_cave2_box1_target_index = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_13_cave2_box1_target_x = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_13_cave2_box1_target_y = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_13_cave2_box1_target_z = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_13_cave2_box1_focus_aw = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_13_cave2_box1_focus_ah = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_13_cave2_box1_focus_xw = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_13_cave2_box1_focus_xh = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_13_cave2_box1_focus_r = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_13_cave2_box1_p_interact = 0;
#line 71 "MACS_sample_kidney_box.instr"
  if(0) strncpy(mccchannel_13_cave2_box1_mask_string, 0 ? 0 : "", 16384); else mccchannel_13_cave2_box1_mask_string[0]='\0';
#line 71 "MACS_sample_kidney_box.instr"
  if(0) strncpy(mccchannel_13_cave2_box1_mask_setting, 0 ? 0 : "", 16384); else mccchannel_13_cave2_box1_mask_setting[0]='\0';
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_13_cave2_box1_number_of_activations = 1;
#line 133176 "MACS_sample_kidney_box.c"

  SIG_MESSAGE("channel_13_cave2_box1 (Init:Place/Rotate)");
  rot_set_rotation(mctr1,
#line 3552 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 3552 "MACS_sample_kidney_box.instr"
    (kidney_cave2_box1_y_rotation)*DEG2RAD,
#line 3552 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD);
#line 133186 "MACS_sample_kidney_box.c"
  rot_mul(mctr1, mcrotachannel_13_cave2_cyl1, mcrotachannel_13_cave2_box1);
  rot_transpose(mcrotachannel_13_cave2_cyl1, mctr1);
  rot_mul(mcrotachannel_13_cave2_box1, mctr1, mcrotrchannel_13_cave2_box1);
  mctc1 = coords_set(
#line 3551 "MACS_sample_kidney_box.instr"
    kidney_cave2_box1_center_to_spec_detector_x,
#line 3551 "MACS_sample_kidney_box.instr"
    0,
#line 3551 "MACS_sample_kidney_box.instr"
    kidney_cave2_box1_center_to_spec_detector_z);
#line 133197 "MACS_sample_kidney_box.c"
  rot_transpose(mcrotachannel_13_cave2_cyl1, mctr1);
  mctc2 = rot_apply(mctr1, mctc1);
  mcposachannel_13_cave2_box1 = coords_add(mcposachannel_13_cave2_cyl1, mctc2);
  mctc1 = coords_sub(mcposachannel_13_cave2_cyl1, mcposachannel_13_cave2_box1);
  mcposrchannel_13_cave2_box1 = rot_apply(mcrotachannel_13_cave2_box1, mctc1);
  mcDEBUG_COMPONENT("channel_13_cave2_box1", mcposachannel_13_cave2_box1, mcrotachannel_13_cave2_box1)
  mccomp_posa[645] = mcposachannel_13_cave2_box1;
  mccomp_posr[645] = mcposrchannel_13_cave2_box1;
  mcNCounter[645]  = mcPCounter[645] = mcP2Counter[645] = 0;
  mcAbsorbProp[645]= 0;
    /* Component channel_13_cave2_box2. */
  /* Setting parameters for component channel_13_cave2_box2. */
  SIG_MESSAGE("channel_13_cave2_box2 (Init:SetPar)");
#line 3557 "MACS_sample_kidney_box.instr"
  if("Vacuum") strncpy(mccchannel_13_cave2_box2_material_string, "Vacuum" ? "Vacuum" : "", 16384); else mccchannel_13_cave2_box2_material_string[0]='\0';
#line 3557 "MACS_sample_kidney_box.instr"
  mccchannel_13_cave2_box2_priority = 1506;
#line 3555 "MACS_sample_kidney_box.instr"
  mccchannel_13_cave2_box2_xwidth = kidney_cave2_box2_width1;
#line 3555 "MACS_sample_kidney_box.instr"
  mccchannel_13_cave2_box2_yheight = kidney_cave2_box2_height1;
#line 3555 "MACS_sample_kidney_box.instr"
  mccchannel_13_cave2_box2_zdepth = kidney_cave2_box2_depth;
#line 3556 "MACS_sample_kidney_box.instr"
  mccchannel_13_cave2_box2_xwidth2 = kidney_cave2_box2_width2;
#line 3556 "MACS_sample_kidney_box.instr"
  mccchannel_13_cave2_box2_yheight2 = kidney_cave2_box2_height2;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_13_cave2_box2_visualize = 1;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_13_cave2_box2_target_index = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_13_cave2_box2_target_x = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_13_cave2_box2_target_y = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_13_cave2_box2_target_z = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_13_cave2_box2_focus_aw = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_13_cave2_box2_focus_ah = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_13_cave2_box2_focus_xw = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_13_cave2_box2_focus_xh = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_13_cave2_box2_focus_r = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_13_cave2_box2_p_interact = 0;
#line 71 "MACS_sample_kidney_box.instr"
  if(0) strncpy(mccchannel_13_cave2_box2_mask_string, 0 ? 0 : "", 16384); else mccchannel_13_cave2_box2_mask_string[0]='\0';
#line 71 "MACS_sample_kidney_box.instr"
  if(0) strncpy(mccchannel_13_cave2_box2_mask_setting, 0 ? 0 : "", 16384); else mccchannel_13_cave2_box2_mask_setting[0]='\0';
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_13_cave2_box2_number_of_activations = 1;
#line 133253 "MACS_sample_kidney_box.c"

  SIG_MESSAGE("channel_13_cave2_box2 (Init:Place/Rotate)");
  rot_set_rotation(mctr1,
#line 3559 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 3559 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 3559 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD);
#line 133263 "MACS_sample_kidney_box.c"
  rot_mul(mctr1, mcrotachannel_13_cave2_cyl1, mcrotachannel_13_cave2_box2);
  rot_transpose(mcrotachannel_13_cave2_box1, mctr1);
  rot_mul(mcrotachannel_13_cave2_box2, mctr1, mcrotrchannel_13_cave2_box2);
  mctc1 = coords_set(
#line 3558 "MACS_sample_kidney_box.instr"
    0,
#line 3558 "MACS_sample_kidney_box.instr"
    0,
#line 3558 "MACS_sample_kidney_box.instr"
    kidney_cave2_box2_center_to_detector);
#line 133274 "MACS_sample_kidney_box.c"
  rot_transpose(mcrotachannel_13_cave2_cyl1, mctr1);
  mctc2 = rot_apply(mctr1, mctc1);
  mcposachannel_13_cave2_box2 = coords_add(mcposachannel_13_cave2_cyl1, mctc2);
  mctc1 = coords_sub(mcposachannel_13_cave2_box1, mcposachannel_13_cave2_box2);
  mcposrchannel_13_cave2_box2 = rot_apply(mcrotachannel_13_cave2_box2, mctc1);
  mcDEBUG_COMPONENT("channel_13_cave2_box2", mcposachannel_13_cave2_box2, mcrotachannel_13_cave2_box2)
  mccomp_posa[646] = mcposachannel_13_cave2_box2;
  mccomp_posr[646] = mcposrchannel_13_cave2_box2;
  mcNCounter[646]  = mcPCounter[646] = mcP2Counter[646] = 0;
  mcAbsorbProp[646]= 0;
    /* Component channel_13_cave2_box3. */
  /* Setting parameters for component channel_13_cave2_box3. */
  SIG_MESSAGE("channel_13_cave2_box3 (Init:SetPar)");
#line 3564 "MACS_sample_kidney_box.instr"
  if("Vacuum") strncpy(mccchannel_13_cave2_box3_material_string, "Vacuum" ? "Vacuum" : "", 16384); else mccchannel_13_cave2_box3_material_string[0]='\0';
#line 3564 "MACS_sample_kidney_box.instr"
  mccchannel_13_cave2_box3_priority = 1507;
#line 3562 "MACS_sample_kidney_box.instr"
  mccchannel_13_cave2_box3_xwidth = kidney_cave2_box3_width1;
#line 3562 "MACS_sample_kidney_box.instr"
  mccchannel_13_cave2_box3_yheight = kidney_cave2_box3_height1;
#line 3562 "MACS_sample_kidney_box.instr"
  mccchannel_13_cave2_box3_zdepth = kidney_cave2_box3_depth;
#line 3563 "MACS_sample_kidney_box.instr"
  mccchannel_13_cave2_box3_xwidth2 = kidney_cave2_box3_width2;
#line 3563 "MACS_sample_kidney_box.instr"
  mccchannel_13_cave2_box3_yheight2 = kidney_cave2_box3_height2;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_13_cave2_box3_visualize = 1;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_13_cave2_box3_target_index = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_13_cave2_box3_target_x = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_13_cave2_box3_target_y = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_13_cave2_box3_target_z = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_13_cave2_box3_focus_aw = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_13_cave2_box3_focus_ah = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_13_cave2_box3_focus_xw = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_13_cave2_box3_focus_xh = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_13_cave2_box3_focus_r = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_13_cave2_box3_p_interact = 0;
#line 71 "MACS_sample_kidney_box.instr"
  if(0) strncpy(mccchannel_13_cave2_box3_mask_string, 0 ? 0 : "", 16384); else mccchannel_13_cave2_box3_mask_string[0]='\0';
#line 71 "MACS_sample_kidney_box.instr"
  if(0) strncpy(mccchannel_13_cave2_box3_mask_setting, 0 ? 0 : "", 16384); else mccchannel_13_cave2_box3_mask_setting[0]='\0';
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_13_cave2_box3_number_of_activations = 1;
#line 133330 "MACS_sample_kidney_box.c"

  SIG_MESSAGE("channel_13_cave2_box3 (Init:Place/Rotate)");
  rot_set_rotation(mctr1,
#line 3566 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 3566 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 3566 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD);
#line 133340 "MACS_sample_kidney_box.c"
  rot_mul(mctr1, mcrotachannel_13_cave2_cyl1, mcrotachannel_13_cave2_box3);
  rot_transpose(mcrotachannel_13_cave2_box2, mctr1);
  rot_mul(mcrotachannel_13_cave2_box3, mctr1, mcrotrchannel_13_cave2_box3);
  mctc1 = coords_set(
#line 3565 "MACS_sample_kidney_box.instr"
    0,
#line 3565 "MACS_sample_kidney_box.instr"
    0,
#line 3565 "MACS_sample_kidney_box.instr"
    kidney_cave2_box3_center_to_detector);
#line 133351 "MACS_sample_kidney_box.c"
  rot_transpose(mcrotachannel_13_cave2_cyl1, mctr1);
  mctc2 = rot_apply(mctr1, mctc1);
  mcposachannel_13_cave2_box3 = coords_add(mcposachannel_13_cave2_cyl1, mctc2);
  mctc1 = coords_sub(mcposachannel_13_cave2_box2, mcposachannel_13_cave2_box3);
  mcposrchannel_13_cave2_box3 = rot_apply(mcrotachannel_13_cave2_box3, mctc1);
  mcDEBUG_COMPONENT("channel_13_cave2_box3", mcposachannel_13_cave2_box3, mcrotachannel_13_cave2_box3)
  mccomp_posa[647] = mcposachannel_13_cave2_box3;
  mccomp_posr[647] = mcposrchannel_13_cave2_box3;
  mcNCounter[647]  = mcPCounter[647] = mcP2Counter[647] = 0;
  mcAbsorbProp[647]= 0;
    /* Component inter_analyzer_colimator_center_13. */
  /* Setting parameters for component inter_analyzer_colimator_center_13. */
  SIG_MESSAGE("inter_analyzer_colimator_center_13 (Init:SetPar)");

  SIG_MESSAGE("inter_analyzer_colimator_center_13 (Init:Place/Rotate)");
  rot_set_rotation(mctr1,
#line 3570 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 3570 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 3570 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD);
#line 133374 "MACS_sample_kidney_box.c"
  rot_mul(mctr1, mcrotachannel_13_analyzer_1_center, mcrotainter_analyzer_colimator_center_13);
  rot_transpose(mcrotachannel_13_cave2_box3, mctr1);
  rot_mul(mcrotainter_analyzer_colimator_center_13, mctr1, mcrotrinter_analyzer_colimator_center_13);
  mctc1 = coords_set(
#line 3569 "MACS_sample_kidney_box.instr"
    -0.5 * analyzer_seperation,
#line 3569 "MACS_sample_kidney_box.instr"
    0,
#line 3569 "MACS_sample_kidney_box.instr"
    0);
#line 133385 "MACS_sample_kidney_box.c"
  rot_transpose(mcrotachannel_13_analyzer_1_center, mctr1);
  mctc2 = rot_apply(mctr1, mctc1);
  mcposainter_analyzer_colimator_center_13 = coords_add(mcposachannel_13_analyzer_1_center, mctc2);
  mctc1 = coords_sub(mcposachannel_13_cave2_box3, mcposainter_analyzer_colimator_center_13);
  mcposrinter_analyzer_colimator_center_13 = rot_apply(mcrotainter_analyzer_colimator_center_13, mctc1);
  mcDEBUG_COMPONENT("inter_analyzer_colimator_center_13", mcposainter_analyzer_colimator_center_13, mcrotainter_analyzer_colimator_center_13)
  mccomp_posa[648] = mcposainter_analyzer_colimator_center_13;
  mccomp_posr[648] = mcposrinter_analyzer_colimator_center_13;
  mcNCounter[648]  = mcPCounter[648] = mcP2Counter[648] = 0;
  mcAbsorbProp[648]= 0;
    /* Component inter_analyzer_colimator_13_blade_0. */
  /* Setting parameters for component inter_analyzer_colimator_13_blade_0. */
  SIG_MESSAGE("inter_analyzer_colimator_13_blade_0 (Init:SetPar)");
#line 3574 "MACS_sample_kidney_box.instr"
  if("Collimator_gad") strncpy(mccinter_analyzer_colimator_13_blade_0_material_string, "Collimator_gad" ? "Collimator_gad" : "", 16384); else mccinter_analyzer_colimator_13_blade_0_material_string[0]='\0';
#line 3574 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_13_blade_0_priority = 1525;
#line 3573 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_13_blade_0_xwidth = inter_analyzer_colimator_width;
#line 3573 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_13_blade_0_yheight = inter_analyzer_colimator_height;
#line 3573 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_13_blade_0_zdepth = inter_analyzer_colimator_depth;
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_13_blade_0_xwidth2 = -1;
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_13_blade_0_yheight2 = -1;
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_13_blade_0_visualize = 1;
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_13_blade_0_target_index = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_13_blade_0_target_x = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_13_blade_0_target_y = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_13_blade_0_target_z = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_13_blade_0_focus_aw = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_13_blade_0_focus_ah = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_13_blade_0_focus_xw = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_13_blade_0_focus_xh = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_13_blade_0_focus_r = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_13_blade_0_p_interact = 0;
#line 71 "MACS_sample_kidney_box.instr"
  if(0) strncpy(mccinter_analyzer_colimator_13_blade_0_mask_string, 0 ? 0 : "", 16384); else mccinter_analyzer_colimator_13_blade_0_mask_string[0]='\0';
#line 71 "MACS_sample_kidney_box.instr"
  if(0) strncpy(mccinter_analyzer_colimator_13_blade_0_mask_setting, 0 ? 0 : "", 16384); else mccinter_analyzer_colimator_13_blade_0_mask_setting[0]='\0';
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_13_blade_0_number_of_activations = 1;
#line 133441 "MACS_sample_kidney_box.c"

  SIG_MESSAGE("inter_analyzer_colimator_13_blade_0 (Init:Place/Rotate)");
  rot_set_rotation(mctr1,
#line 3576 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 3576 "MACS_sample_kidney_box.instr"
    (- analyzer_2theta [ 13 ])*DEG2RAD,
#line 3576 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD);
#line 133451 "MACS_sample_kidney_box.c"
  rot_mul(mctr1, mcrotainter_analyzer_colimator_center_13, mcrotainter_analyzer_colimator_13_blade_0);
  rot_transpose(mcrotainter_analyzer_colimator_center_13, mctr1);
  rot_mul(mcrotainter_analyzer_colimator_13_blade_0, mctr1, mcrotrinter_analyzer_colimator_13_blade_0);
  mctc1 = coords_set(
#line 3575 "MACS_sample_kidney_box.instr"
    0,
#line 3575 "MACS_sample_kidney_box.instr"
    0,
#line 3575 "MACS_sample_kidney_box.instr"
    inter_analyzer_colimator_start_pos - 0 * inter_analyzer_colimator_seperation);
#line 133462 "MACS_sample_kidney_box.c"
  rot_transpose(mcrotainter_analyzer_colimator_center_13, mctr1);
  mctc2 = rot_apply(mctr1, mctc1);
  mcposainter_analyzer_colimator_13_blade_0 = coords_add(mcposainter_analyzer_colimator_center_13, mctc2);
  mctc1 = coords_sub(mcposainter_analyzer_colimator_center_13, mcposainter_analyzer_colimator_13_blade_0);
  mcposrinter_analyzer_colimator_13_blade_0 = rot_apply(mcrotainter_analyzer_colimator_13_blade_0, mctc1);
  mcDEBUG_COMPONENT("inter_analyzer_colimator_13_blade_0", mcposainter_analyzer_colimator_13_blade_0, mcrotainter_analyzer_colimator_13_blade_0)
  mccomp_posa[649] = mcposainter_analyzer_colimator_13_blade_0;
  mccomp_posr[649] = mcposrinter_analyzer_colimator_13_blade_0;
  mcNCounter[649]  = mcPCounter[649] = mcP2Counter[649] = 0;
  mcAbsorbProp[649]= 0;
    /* Component inter_analyzer_colimator_13_blade_1. */
  /* Setting parameters for component inter_analyzer_colimator_13_blade_1. */
  SIG_MESSAGE("inter_analyzer_colimator_13_blade_1 (Init:SetPar)");
#line 3580 "MACS_sample_kidney_box.instr"
  if("Collimator_gad") strncpy(mccinter_analyzer_colimator_13_blade_1_material_string, "Collimator_gad" ? "Collimator_gad" : "", 16384); else mccinter_analyzer_colimator_13_blade_1_material_string[0]='\0';
#line 3580 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_13_blade_1_priority = 1526;
#line 3579 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_13_blade_1_xwidth = inter_analyzer_colimator_width;
#line 3579 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_13_blade_1_yheight = inter_analyzer_colimator_height;
#line 3579 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_13_blade_1_zdepth = inter_analyzer_colimator_depth;
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_13_blade_1_xwidth2 = -1;
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_13_blade_1_yheight2 = -1;
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_13_blade_1_visualize = 1;
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_13_blade_1_target_index = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_13_blade_1_target_x = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_13_blade_1_target_y = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_13_blade_1_target_z = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_13_blade_1_focus_aw = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_13_blade_1_focus_ah = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_13_blade_1_focus_xw = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_13_blade_1_focus_xh = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_13_blade_1_focus_r = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_13_blade_1_p_interact = 0;
#line 71 "MACS_sample_kidney_box.instr"
  if(0) strncpy(mccinter_analyzer_colimator_13_blade_1_mask_string, 0 ? 0 : "", 16384); else mccinter_analyzer_colimator_13_blade_1_mask_string[0]='\0';
#line 71 "MACS_sample_kidney_box.instr"
  if(0) strncpy(mccinter_analyzer_colimator_13_blade_1_mask_setting, 0 ? 0 : "", 16384); else mccinter_analyzer_colimator_13_blade_1_mask_setting[0]='\0';
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_13_blade_1_number_of_activations = 1;
#line 133518 "MACS_sample_kidney_box.c"

  SIG_MESSAGE("inter_analyzer_colimator_13_blade_1 (Init:Place/Rotate)");
  rot_set_rotation(mctr1,
#line 3582 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 3582 "MACS_sample_kidney_box.instr"
    (- analyzer_2theta [ 13 ])*DEG2RAD,
#line 3582 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD);
#line 133528 "MACS_sample_kidney_box.c"
  rot_mul(mctr1, mcrotainter_analyzer_colimator_center_13, mcrotainter_analyzer_colimator_13_blade_1);
  rot_transpose(mcrotainter_analyzer_colimator_13_blade_0, mctr1);
  rot_mul(mcrotainter_analyzer_colimator_13_blade_1, mctr1, mcrotrinter_analyzer_colimator_13_blade_1);
  mctc1 = coords_set(
#line 3581 "MACS_sample_kidney_box.instr"
    0,
#line 3581 "MACS_sample_kidney_box.instr"
    0,
#line 3581 "MACS_sample_kidney_box.instr"
    inter_analyzer_colimator_start_pos - 1 * inter_analyzer_colimator_seperation);
#line 133539 "MACS_sample_kidney_box.c"
  rot_transpose(mcrotainter_analyzer_colimator_center_13, mctr1);
  mctc2 = rot_apply(mctr1, mctc1);
  mcposainter_analyzer_colimator_13_blade_1 = coords_add(mcposainter_analyzer_colimator_center_13, mctc2);
  mctc1 = coords_sub(mcposainter_analyzer_colimator_13_blade_0, mcposainter_analyzer_colimator_13_blade_1);
  mcposrinter_analyzer_colimator_13_blade_1 = rot_apply(mcrotainter_analyzer_colimator_13_blade_1, mctc1);
  mcDEBUG_COMPONENT("inter_analyzer_colimator_13_blade_1", mcposainter_analyzer_colimator_13_blade_1, mcrotainter_analyzer_colimator_13_blade_1)
  mccomp_posa[650] = mcposainter_analyzer_colimator_13_blade_1;
  mccomp_posr[650] = mcposrinter_analyzer_colimator_13_blade_1;
  mcNCounter[650]  = mcPCounter[650] = mcP2Counter[650] = 0;
  mcAbsorbProp[650]= 0;
    /* Component inter_analyzer_colimator_13_blade_2. */
  /* Setting parameters for component inter_analyzer_colimator_13_blade_2. */
  SIG_MESSAGE("inter_analyzer_colimator_13_blade_2 (Init:SetPar)");
#line 3586 "MACS_sample_kidney_box.instr"
  if("Collimator_gad") strncpy(mccinter_analyzer_colimator_13_blade_2_material_string, "Collimator_gad" ? "Collimator_gad" : "", 16384); else mccinter_analyzer_colimator_13_blade_2_material_string[0]='\0';
#line 3586 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_13_blade_2_priority = 1527;
#line 3585 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_13_blade_2_xwidth = inter_analyzer_colimator_width;
#line 3585 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_13_blade_2_yheight = inter_analyzer_colimator_height;
#line 3585 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_13_blade_2_zdepth = inter_analyzer_colimator_depth;
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_13_blade_2_xwidth2 = -1;
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_13_blade_2_yheight2 = -1;
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_13_blade_2_visualize = 1;
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_13_blade_2_target_index = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_13_blade_2_target_x = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_13_blade_2_target_y = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_13_blade_2_target_z = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_13_blade_2_focus_aw = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_13_blade_2_focus_ah = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_13_blade_2_focus_xw = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_13_blade_2_focus_xh = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_13_blade_2_focus_r = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_13_blade_2_p_interact = 0;
#line 71 "MACS_sample_kidney_box.instr"
  if(0) strncpy(mccinter_analyzer_colimator_13_blade_2_mask_string, 0 ? 0 : "", 16384); else mccinter_analyzer_colimator_13_blade_2_mask_string[0]='\0';
#line 71 "MACS_sample_kidney_box.instr"
  if(0) strncpy(mccinter_analyzer_colimator_13_blade_2_mask_setting, 0 ? 0 : "", 16384); else mccinter_analyzer_colimator_13_blade_2_mask_setting[0]='\0';
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_13_blade_2_number_of_activations = 1;
#line 133595 "MACS_sample_kidney_box.c"

  SIG_MESSAGE("inter_analyzer_colimator_13_blade_2 (Init:Place/Rotate)");
  rot_set_rotation(mctr1,
#line 3588 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 3588 "MACS_sample_kidney_box.instr"
    (- analyzer_2theta [ 13 ])*DEG2RAD,
#line 3588 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD);
#line 133605 "MACS_sample_kidney_box.c"
  rot_mul(mctr1, mcrotainter_analyzer_colimator_center_13, mcrotainter_analyzer_colimator_13_blade_2);
  rot_transpose(mcrotainter_analyzer_colimator_13_blade_1, mctr1);
  rot_mul(mcrotainter_analyzer_colimator_13_blade_2, mctr1, mcrotrinter_analyzer_colimator_13_blade_2);
  mctc1 = coords_set(
#line 3587 "MACS_sample_kidney_box.instr"
    0,
#line 3587 "MACS_sample_kidney_box.instr"
    0,
#line 3587 "MACS_sample_kidney_box.instr"
    inter_analyzer_colimator_start_pos - 2 * inter_analyzer_colimator_seperation);
#line 133616 "MACS_sample_kidney_box.c"
  rot_transpose(mcrotainter_analyzer_colimator_center_13, mctr1);
  mctc2 = rot_apply(mctr1, mctc1);
  mcposainter_analyzer_colimator_13_blade_2 = coords_add(mcposainter_analyzer_colimator_center_13, mctc2);
  mctc1 = coords_sub(mcposainter_analyzer_colimator_13_blade_1, mcposainter_analyzer_colimator_13_blade_2);
  mcposrinter_analyzer_colimator_13_blade_2 = rot_apply(mcrotainter_analyzer_colimator_13_blade_2, mctc1);
  mcDEBUG_COMPONENT("inter_analyzer_colimator_13_blade_2", mcposainter_analyzer_colimator_13_blade_2, mcrotainter_analyzer_colimator_13_blade_2)
  mccomp_posa[651] = mcposainter_analyzer_colimator_13_blade_2;
  mccomp_posr[651] = mcposrinter_analyzer_colimator_13_blade_2;
  mcNCounter[651]  = mcPCounter[651] = mcP2Counter[651] = 0;
  mcAbsorbProp[651]= 0;
    /* Component inter_analyzer_colimator_13_blade_3. */
  /* Setting parameters for component inter_analyzer_colimator_13_blade_3. */
  SIG_MESSAGE("inter_analyzer_colimator_13_blade_3 (Init:SetPar)");
#line 3592 "MACS_sample_kidney_box.instr"
  if("Collimator_gad") strncpy(mccinter_analyzer_colimator_13_blade_3_material_string, "Collimator_gad" ? "Collimator_gad" : "", 16384); else mccinter_analyzer_colimator_13_blade_3_material_string[0]='\0';
#line 3592 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_13_blade_3_priority = 1528;
#line 3591 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_13_blade_3_xwidth = inter_analyzer_colimator_width;
#line 3591 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_13_blade_3_yheight = inter_analyzer_colimator_height;
#line 3591 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_13_blade_3_zdepth = inter_analyzer_colimator_depth;
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_13_blade_3_xwidth2 = -1;
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_13_blade_3_yheight2 = -1;
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_13_blade_3_visualize = 1;
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_13_blade_3_target_index = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_13_blade_3_target_x = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_13_blade_3_target_y = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_13_blade_3_target_z = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_13_blade_3_focus_aw = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_13_blade_3_focus_ah = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_13_blade_3_focus_xw = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_13_blade_3_focus_xh = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_13_blade_3_focus_r = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_13_blade_3_p_interact = 0;
#line 71 "MACS_sample_kidney_box.instr"
  if(0) strncpy(mccinter_analyzer_colimator_13_blade_3_mask_string, 0 ? 0 : "", 16384); else mccinter_analyzer_colimator_13_blade_3_mask_string[0]='\0';
#line 71 "MACS_sample_kidney_box.instr"
  if(0) strncpy(mccinter_analyzer_colimator_13_blade_3_mask_setting, 0 ? 0 : "", 16384); else mccinter_analyzer_colimator_13_blade_3_mask_setting[0]='\0';
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_13_blade_3_number_of_activations = 1;
#line 133672 "MACS_sample_kidney_box.c"

  SIG_MESSAGE("inter_analyzer_colimator_13_blade_3 (Init:Place/Rotate)");
  rot_set_rotation(mctr1,
#line 3594 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 3594 "MACS_sample_kidney_box.instr"
    (- analyzer_2theta [ 13 ])*DEG2RAD,
#line 3594 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD);
#line 133682 "MACS_sample_kidney_box.c"
  rot_mul(mctr1, mcrotainter_analyzer_colimator_center_13, mcrotainter_analyzer_colimator_13_blade_3);
  rot_transpose(mcrotainter_analyzer_colimator_13_blade_2, mctr1);
  rot_mul(mcrotainter_analyzer_colimator_13_blade_3, mctr1, mcrotrinter_analyzer_colimator_13_blade_3);
  mctc1 = coords_set(
#line 3593 "MACS_sample_kidney_box.instr"
    0,
#line 3593 "MACS_sample_kidney_box.instr"
    0,
#line 3593 "MACS_sample_kidney_box.instr"
    inter_analyzer_colimator_start_pos - 3 * inter_analyzer_colimator_seperation);
#line 133693 "MACS_sample_kidney_box.c"
  rot_transpose(mcrotainter_analyzer_colimator_center_13, mctr1);
  mctc2 = rot_apply(mctr1, mctc1);
  mcposainter_analyzer_colimator_13_blade_3 = coords_add(mcposainter_analyzer_colimator_center_13, mctc2);
  mctc1 = coords_sub(mcposainter_analyzer_colimator_13_blade_2, mcposainter_analyzer_colimator_13_blade_3);
  mcposrinter_analyzer_colimator_13_blade_3 = rot_apply(mcrotainter_analyzer_colimator_13_blade_3, mctc1);
  mcDEBUG_COMPONENT("inter_analyzer_colimator_13_blade_3", mcposainter_analyzer_colimator_13_blade_3, mcrotainter_analyzer_colimator_13_blade_3)
  mccomp_posa[652] = mcposainter_analyzer_colimator_13_blade_3;
  mccomp_posr[652] = mcposrinter_analyzer_colimator_13_blade_3;
  mcNCounter[652]  = mcPCounter[652] = mcP2Counter[652] = 0;
  mcAbsorbProp[652]= 0;
    /* Component inter_analyzer_colimator_13_blade_4. */
  /* Setting parameters for component inter_analyzer_colimator_13_blade_4. */
  SIG_MESSAGE("inter_analyzer_colimator_13_blade_4 (Init:SetPar)");
#line 3598 "MACS_sample_kidney_box.instr"
  if("Collimator_gad") strncpy(mccinter_analyzer_colimator_13_blade_4_material_string, "Collimator_gad" ? "Collimator_gad" : "", 16384); else mccinter_analyzer_colimator_13_blade_4_material_string[0]='\0';
#line 3598 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_13_blade_4_priority = 1529;
#line 3597 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_13_blade_4_xwidth = inter_analyzer_colimator_width;
#line 3597 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_13_blade_4_yheight = inter_analyzer_colimator_height;
#line 3597 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_13_blade_4_zdepth = inter_analyzer_colimator_depth;
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_13_blade_4_xwidth2 = -1;
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_13_blade_4_yheight2 = -1;
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_13_blade_4_visualize = 1;
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_13_blade_4_target_index = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_13_blade_4_target_x = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_13_blade_4_target_y = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_13_blade_4_target_z = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_13_blade_4_focus_aw = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_13_blade_4_focus_ah = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_13_blade_4_focus_xw = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_13_blade_4_focus_xh = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_13_blade_4_focus_r = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_13_blade_4_p_interact = 0;
#line 71 "MACS_sample_kidney_box.instr"
  if(0) strncpy(mccinter_analyzer_colimator_13_blade_4_mask_string, 0 ? 0 : "", 16384); else mccinter_analyzer_colimator_13_blade_4_mask_string[0]='\0';
#line 71 "MACS_sample_kidney_box.instr"
  if(0) strncpy(mccinter_analyzer_colimator_13_blade_4_mask_setting, 0 ? 0 : "", 16384); else mccinter_analyzer_colimator_13_blade_4_mask_setting[0]='\0';
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_13_blade_4_number_of_activations = 1;
#line 133749 "MACS_sample_kidney_box.c"

  SIG_MESSAGE("inter_analyzer_colimator_13_blade_4 (Init:Place/Rotate)");
  rot_set_rotation(mctr1,
#line 3600 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 3600 "MACS_sample_kidney_box.instr"
    (- analyzer_2theta [ 13 ])*DEG2RAD,
#line 3600 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD);
#line 133759 "MACS_sample_kidney_box.c"
  rot_mul(mctr1, mcrotainter_analyzer_colimator_center_13, mcrotainter_analyzer_colimator_13_blade_4);
  rot_transpose(mcrotainter_analyzer_colimator_13_blade_3, mctr1);
  rot_mul(mcrotainter_analyzer_colimator_13_blade_4, mctr1, mcrotrinter_analyzer_colimator_13_blade_4);
  mctc1 = coords_set(
#line 3599 "MACS_sample_kidney_box.instr"
    0,
#line 3599 "MACS_sample_kidney_box.instr"
    0,
#line 3599 "MACS_sample_kidney_box.instr"
    inter_analyzer_colimator_start_pos - 4 * inter_analyzer_colimator_seperation);
#line 133770 "MACS_sample_kidney_box.c"
  rot_transpose(mcrotainter_analyzer_colimator_center_13, mctr1);
  mctc2 = rot_apply(mctr1, mctc1);
  mcposainter_analyzer_colimator_13_blade_4 = coords_add(mcposainter_analyzer_colimator_center_13, mctc2);
  mctc1 = coords_sub(mcposainter_analyzer_colimator_13_blade_3, mcposainter_analyzer_colimator_13_blade_4);
  mcposrinter_analyzer_colimator_13_blade_4 = rot_apply(mcrotainter_analyzer_colimator_13_blade_4, mctc1);
  mcDEBUG_COMPONENT("inter_analyzer_colimator_13_blade_4", mcposainter_analyzer_colimator_13_blade_4, mcrotainter_analyzer_colimator_13_blade_4)
  mccomp_posa[653] = mcposainter_analyzer_colimator_13_blade_4;
  mccomp_posr[653] = mcposrinter_analyzer_colimator_13_blade_4;
  mcNCounter[653]  = mcPCounter[653] = mcP2Counter[653] = 0;
  mcAbsorbProp[653]= 0;
    /* Component diffraction_detector_13_exit_volume. */
  /* Setting parameters for component diffraction_detector_13_exit_volume. */
  SIG_MESSAGE("diffraction_detector_13_exit_volume (Init:SetPar)");
#line 3604 "MACS_sample_kidney_box.instr"
  if("Exit") strncpy(mccdiffraction_detector_13_exit_volume_material_string, "Exit" ? "Exit" : "", 16384); else mccdiffraction_detector_13_exit_volume_material_string[0]='\0';
#line 3604 "MACS_sample_kidney_box.instr"
  mccdiffraction_detector_13_exit_volume_priority = 1531;
#line 3603 "MACS_sample_kidney_box.instr"
  mccdiffraction_detector_13_exit_volume_xwidth = 2.01 * detector_radius;
#line 3603 "MACS_sample_kidney_box.instr"
  mccdiffraction_detector_13_exit_volume_yheight = 1.01 * detector_height;
#line 3603 "MACS_sample_kidney_box.instr"
  mccdiffraction_detector_13_exit_volume_zdepth = 0.001;
#line 71 "MACS_sample_kidney_box.instr"
  mccdiffraction_detector_13_exit_volume_xwidth2 = -1;
#line 71 "MACS_sample_kidney_box.instr"
  mccdiffraction_detector_13_exit_volume_yheight2 = -1;
#line 71 "MACS_sample_kidney_box.instr"
  mccdiffraction_detector_13_exit_volume_visualize = 1;
#line 71 "MACS_sample_kidney_box.instr"
  mccdiffraction_detector_13_exit_volume_target_index = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccdiffraction_detector_13_exit_volume_target_x = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccdiffraction_detector_13_exit_volume_target_y = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccdiffraction_detector_13_exit_volume_target_z = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccdiffraction_detector_13_exit_volume_focus_aw = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccdiffraction_detector_13_exit_volume_focus_ah = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccdiffraction_detector_13_exit_volume_focus_xw = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccdiffraction_detector_13_exit_volume_focus_xh = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccdiffraction_detector_13_exit_volume_focus_r = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccdiffraction_detector_13_exit_volume_p_interact = 0;
#line 71 "MACS_sample_kidney_box.instr"
  if(0) strncpy(mccdiffraction_detector_13_exit_volume_mask_string, 0 ? 0 : "", 16384); else mccdiffraction_detector_13_exit_volume_mask_string[0]='\0';
#line 71 "MACS_sample_kidney_box.instr"
  if(0) strncpy(mccdiffraction_detector_13_exit_volume_mask_setting, 0 ? 0 : "", 16384); else mccdiffraction_detector_13_exit_volume_mask_setting[0]='\0';
#line 71 "MACS_sample_kidney_box.instr"
  mccdiffraction_detector_13_exit_volume_number_of_activations = 1;
#line 133826 "MACS_sample_kidney_box.c"

  SIG_MESSAGE("diffraction_detector_13_exit_volume (Init:Place/Rotate)");
  rot_set_rotation(mctr1,
#line 3606 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 3606 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 3606 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD);
#line 133836 "MACS_sample_kidney_box.c"
  rot_mul(mctr1, mcrotakidney_channel_13, mcrotadiffraction_detector_13_exit_volume);
  rot_transpose(mcrotainter_analyzer_colimator_13_blade_4, mctr1);
  rot_mul(mcrotadiffraction_detector_13_exit_volume, mctr1, mcrotrdiffraction_detector_13_exit_volume);
  mctc1 = coords_set(
#line 3605 "MACS_sample_kidney_box.instr"
    0,
#line 3605 "MACS_sample_kidney_box.instr"
    0,
#line 3605 "MACS_sample_kidney_box.instr"
    0);
#line 133847 "MACS_sample_kidney_box.c"
  rot_transpose(mcrotachannel_13_cave1_cyl1, mctr1);
  mctc2 = rot_apply(mctr1, mctc1);
  mcposadiffraction_detector_13_exit_volume = coords_add(mcposachannel_13_cave1_cyl1, mctc2);
  mctc1 = coords_sub(mcposainter_analyzer_colimator_13_blade_4, mcposadiffraction_detector_13_exit_volume);
  mcposrdiffraction_detector_13_exit_volume = rot_apply(mcrotadiffraction_detector_13_exit_volume, mctc1);
  mcDEBUG_COMPONENT("diffraction_detector_13_exit_volume", mcposadiffraction_detector_13_exit_volume, mcrotadiffraction_detector_13_exit_volume)
  mccomp_posa[654] = mcposadiffraction_detector_13_exit_volume;
  mccomp_posr[654] = mcposrdiffraction_detector_13_exit_volume;
  mcNCounter[654]  = mcPCounter[654] = mcP2Counter[654] = 0;
  mcAbsorbProp[654]= 0;
    /* Component spec_detector_13_exit_volume. */
  /* Setting parameters for component spec_detector_13_exit_volume. */
  SIG_MESSAGE("spec_detector_13_exit_volume (Init:SetPar)");
#line 3610 "MACS_sample_kidney_box.instr"
  if("Exit") strncpy(mccspec_detector_13_exit_volume_material_string, "Exit" ? "Exit" : "", 16384); else mccspec_detector_13_exit_volume_material_string[0]='\0';
#line 3610 "MACS_sample_kidney_box.instr"
  mccspec_detector_13_exit_volume_priority = 1532;
#line 3609 "MACS_sample_kidney_box.instr"
  mccspec_detector_13_exit_volume_xwidth = 2.01 * detector_radius;
#line 3609 "MACS_sample_kidney_box.instr"
  mccspec_detector_13_exit_volume_yheight = 1.01 * detector_height;
#line 3609 "MACS_sample_kidney_box.instr"
  mccspec_detector_13_exit_volume_zdepth = 0.001;
#line 71 "MACS_sample_kidney_box.instr"
  mccspec_detector_13_exit_volume_xwidth2 = -1;
#line 71 "MACS_sample_kidney_box.instr"
  mccspec_detector_13_exit_volume_yheight2 = -1;
#line 71 "MACS_sample_kidney_box.instr"
  mccspec_detector_13_exit_volume_visualize = 1;
#line 71 "MACS_sample_kidney_box.instr"
  mccspec_detector_13_exit_volume_target_index = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccspec_detector_13_exit_volume_target_x = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccspec_detector_13_exit_volume_target_y = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccspec_detector_13_exit_volume_target_z = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccspec_detector_13_exit_volume_focus_aw = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccspec_detector_13_exit_volume_focus_ah = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccspec_detector_13_exit_volume_focus_xw = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccspec_detector_13_exit_volume_focus_xh = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccspec_detector_13_exit_volume_focus_r = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccspec_detector_13_exit_volume_p_interact = 0;
#line 71 "MACS_sample_kidney_box.instr"
  if(0) strncpy(mccspec_detector_13_exit_volume_mask_string, 0 ? 0 : "", 16384); else mccspec_detector_13_exit_volume_mask_string[0]='\0';
#line 71 "MACS_sample_kidney_box.instr"
  if(0) strncpy(mccspec_detector_13_exit_volume_mask_setting, 0 ? 0 : "", 16384); else mccspec_detector_13_exit_volume_mask_setting[0]='\0';
#line 71 "MACS_sample_kidney_box.instr"
  mccspec_detector_13_exit_volume_number_of_activations = 1;
#line 133903 "MACS_sample_kidney_box.c"

  SIG_MESSAGE("spec_detector_13_exit_volume (Init:Place/Rotate)");
  rot_set_rotation(mctr1,
#line 3612 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 3612 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 3612 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD);
#line 133913 "MACS_sample_kidney_box.c"
  rot_mul(mctr1, mcrotachannel_13_analyzer_2_center, mcrotaspec_detector_13_exit_volume);
  rot_transpose(mcrotadiffraction_detector_13_exit_volume, mctr1);
  rot_mul(mcrotaspec_detector_13_exit_volume, mctr1, mcrotrspec_detector_13_exit_volume);
  mctc1 = coords_set(
#line 3611 "MACS_sample_kidney_box.instr"
    0,
#line 3611 "MACS_sample_kidney_box.instr"
    0,
#line 3611 "MACS_sample_kidney_box.instr"
    0);
#line 133924 "MACS_sample_kidney_box.c"
  rot_transpose(mcrotachannel_13_cave2_cyl1, mctr1);
  mctc2 = rot_apply(mctr1, mctc1);
  mcposaspec_detector_13_exit_volume = coords_add(mcposachannel_13_cave2_cyl1, mctc2);
  mctc1 = coords_sub(mcposadiffraction_detector_13_exit_volume, mcposaspec_detector_13_exit_volume);
  mcposrspec_detector_13_exit_volume = rot_apply(mcrotaspec_detector_13_exit_volume, mctc1);
  mcDEBUG_COMPONENT("spec_detector_13_exit_volume", mcposaspec_detector_13_exit_volume, mcrotaspec_detector_13_exit_volume)
  mccomp_posa[655] = mcposaspec_detector_13_exit_volume;
  mccomp_posr[655] = mcposrspec_detector_13_exit_volume;
  mcNCounter[655]  = mcPCounter[655] = mcP2Counter[655] = 0;
  mcAbsorbProp[655]= 0;
    /* Component channel_14_cave1_box1. */
  /* Setting parameters for component channel_14_cave1_box1. */
  SIG_MESSAGE("channel_14_cave1_box1 (Init:SetPar)");
#line 3617 "MACS_sample_kidney_box.instr"
  if("Vacuum") strncpy(mccchannel_14_cave1_box1_material_string, "Vacuum" ? "Vacuum" : "", 16384); else mccchannel_14_cave1_box1_material_string[0]='\0';
#line 3617 "MACS_sample_kidney_box.instr"
  mccchannel_14_cave1_box1_priority = 1600;
#line 3615 "MACS_sample_kidney_box.instr"
  mccchannel_14_cave1_box1_xwidth = kidney_cave1_box1_width1;
#line 3615 "MACS_sample_kidney_box.instr"
  mccchannel_14_cave1_box1_yheight = kidney_cave1_box1_height1;
#line 3615 "MACS_sample_kidney_box.instr"
  mccchannel_14_cave1_box1_zdepth = kidney_cave1_box1_depth;
#line 3616 "MACS_sample_kidney_box.instr"
  mccchannel_14_cave1_box1_xwidth2 = kidney_cave1_box1_width2;
#line 3616 "MACS_sample_kidney_box.instr"
  mccchannel_14_cave1_box1_yheight2 = kidney_cave1_box1_height2;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_14_cave1_box1_visualize = 1;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_14_cave1_box1_target_index = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_14_cave1_box1_target_x = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_14_cave1_box1_target_y = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_14_cave1_box1_target_z = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_14_cave1_box1_focus_aw = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_14_cave1_box1_focus_ah = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_14_cave1_box1_focus_xw = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_14_cave1_box1_focus_xh = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_14_cave1_box1_focus_r = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_14_cave1_box1_p_interact = 0;
#line 71 "MACS_sample_kidney_box.instr"
  if(0) strncpy(mccchannel_14_cave1_box1_mask_string, 0 ? 0 : "", 16384); else mccchannel_14_cave1_box1_mask_string[0]='\0';
#line 71 "MACS_sample_kidney_box.instr"
  if(0) strncpy(mccchannel_14_cave1_box1_mask_setting, 0 ? 0 : "", 16384); else mccchannel_14_cave1_box1_mask_setting[0]='\0';
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_14_cave1_box1_number_of_activations = 1;
#line 133980 "MACS_sample_kidney_box.c"

  SIG_MESSAGE("channel_14_cave1_box1 (Init:Place/Rotate)");
  rot_set_rotation(mctr1,
#line 3619 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 3619 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 3619 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD);
#line 133990 "MACS_sample_kidney_box.c"
  rot_mul(mctr1, mcrotakidney_channel_14, mcrotachannel_14_cave1_box1);
  rot_transpose(mcrotaspec_detector_13_exit_volume, mctr1);
  rot_mul(mcrotachannel_14_cave1_box1, mctr1, mcrotrchannel_14_cave1_box1);
  mctc1 = coords_set(
#line 3618 "MACS_sample_kidney_box.instr"
    0,
#line 3618 "MACS_sample_kidney_box.instr"
    0,
#line 3618 "MACS_sample_kidney_box.instr"
    kidney_cave1_box1_center_to_target);
#line 134001 "MACS_sample_kidney_box.c"
  rot_transpose(mcrotakidney_channel_14, mctr1);
  mctc2 = rot_apply(mctr1, mctc1);
  mcposachannel_14_cave1_box1 = coords_add(mcposakidney_channel_14, mctc2);
  mctc1 = coords_sub(mcposaspec_detector_13_exit_volume, mcposachannel_14_cave1_box1);
  mcposrchannel_14_cave1_box1 = rot_apply(mcrotachannel_14_cave1_box1, mctc1);
  mcDEBUG_COMPONENT("channel_14_cave1_box1", mcposachannel_14_cave1_box1, mcrotachannel_14_cave1_box1)
  mccomp_posa[656] = mcposachannel_14_cave1_box1;
  mccomp_posr[656] = mcposrchannel_14_cave1_box1;
  mcNCounter[656]  = mcPCounter[656] = mcP2Counter[656] = 0;
  mcAbsorbProp[656]= 0;
    /* Component channel_14_cave1_box2. */
  /* Setting parameters for component channel_14_cave1_box2. */
  SIG_MESSAGE("channel_14_cave1_box2 (Init:SetPar)");
#line 3624 "MACS_sample_kidney_box.instr"
  if("Vacuum") strncpy(mccchannel_14_cave1_box2_material_string, "Vacuum" ? "Vacuum" : "", 16384); else mccchannel_14_cave1_box2_material_string[0]='\0';
#line 3624 "MACS_sample_kidney_box.instr"
  mccchannel_14_cave1_box2_priority = 1605;
#line 3622 "MACS_sample_kidney_box.instr"
  mccchannel_14_cave1_box2_xwidth = kidney_cave1_box2_width1;
#line 3622 "MACS_sample_kidney_box.instr"
  mccchannel_14_cave1_box2_yheight = kidney_cave1_box2_height1;
#line 3622 "MACS_sample_kidney_box.instr"
  mccchannel_14_cave1_box2_zdepth = kidney_cave1_box2_depth;
#line 3623 "MACS_sample_kidney_box.instr"
  mccchannel_14_cave1_box2_xwidth2 = kidney_cave1_box2_width2;
#line 3623 "MACS_sample_kidney_box.instr"
  mccchannel_14_cave1_box2_yheight2 = kidney_cave1_box2_height2;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_14_cave1_box2_visualize = 1;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_14_cave1_box2_target_index = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_14_cave1_box2_target_x = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_14_cave1_box2_target_y = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_14_cave1_box2_target_z = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_14_cave1_box2_focus_aw = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_14_cave1_box2_focus_ah = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_14_cave1_box2_focus_xw = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_14_cave1_box2_focus_xh = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_14_cave1_box2_focus_r = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_14_cave1_box2_p_interact = 0;
#line 71 "MACS_sample_kidney_box.instr"
  if(0) strncpy(mccchannel_14_cave1_box2_mask_string, 0 ? 0 : "", 16384); else mccchannel_14_cave1_box2_mask_string[0]='\0';
#line 71 "MACS_sample_kidney_box.instr"
  if(0) strncpy(mccchannel_14_cave1_box2_mask_setting, 0 ? 0 : "", 16384); else mccchannel_14_cave1_box2_mask_setting[0]='\0';
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_14_cave1_box2_number_of_activations = 1;
#line 134057 "MACS_sample_kidney_box.c"

  SIG_MESSAGE("channel_14_cave1_box2 (Init:Place/Rotate)");
  rot_set_rotation(mctr1,
#line 3626 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 3626 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 3626 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD);
#line 134067 "MACS_sample_kidney_box.c"
  rot_mul(mctr1, mcrotakidney_channel_14, mcrotachannel_14_cave1_box2);
  rot_transpose(mcrotachannel_14_cave1_box1, mctr1);
  rot_mul(mcrotachannel_14_cave1_box2, mctr1, mcrotrchannel_14_cave1_box2);
  mctc1 = coords_set(
#line 3625 "MACS_sample_kidney_box.instr"
    kidney_cave1_box2_x_offset,
#line 3625 "MACS_sample_kidney_box.instr"
    0,
#line 3625 "MACS_sample_kidney_box.instr"
    kidney_cave1_box2_center_to_target);
#line 134078 "MACS_sample_kidney_box.c"
  rot_transpose(mcrotakidney_channel_14, mctr1);
  mctc2 = rot_apply(mctr1, mctc1);
  mcposachannel_14_cave1_box2 = coords_add(mcposakidney_channel_14, mctc2);
  mctc1 = coords_sub(mcposachannel_14_cave1_box1, mcposachannel_14_cave1_box2);
  mcposrchannel_14_cave1_box2 = rot_apply(mcrotachannel_14_cave1_box2, mctc1);
  mcDEBUG_COMPONENT("channel_14_cave1_box2", mcposachannel_14_cave1_box2, mcrotachannel_14_cave1_box2)
  mccomp_posa[657] = mcposachannel_14_cave1_box2;
  mccomp_posr[657] = mcposrchannel_14_cave1_box2;
  mcNCounter[657]  = mcPCounter[657] = mcP2Counter[657] = 0;
  mcAbsorbProp[657]= 0;
    /* Component channel_14_cave1_box3. */
  /* Setting parameters for component channel_14_cave1_box3. */
  SIG_MESSAGE("channel_14_cave1_box3 (Init:SetPar)");
#line 3631 "MACS_sample_kidney_box.instr"
  if("Vacuum") strncpy(mccchannel_14_cave1_box3_material_string, "Vacuum" ? "Vacuum" : "", 16384); else mccchannel_14_cave1_box3_material_string[0]='\0';
#line 3631 "MACS_sample_kidney_box.instr"
  mccchannel_14_cave1_box3_priority = 1602;
#line 3629 "MACS_sample_kidney_box.instr"
  mccchannel_14_cave1_box3_xwidth = kidney_cave1_box3_width1;
#line 3629 "MACS_sample_kidney_box.instr"
  mccchannel_14_cave1_box3_yheight = kidney_cave1_box3_height1;
#line 3629 "MACS_sample_kidney_box.instr"
  mccchannel_14_cave1_box3_zdepth = kidney_cave1_box3_depth;
#line 3630 "MACS_sample_kidney_box.instr"
  mccchannel_14_cave1_box3_xwidth2 = kidney_cave1_box3_width2;
#line 3630 "MACS_sample_kidney_box.instr"
  mccchannel_14_cave1_box3_yheight2 = kidney_cave1_box3_height2;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_14_cave1_box3_visualize = 1;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_14_cave1_box3_target_index = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_14_cave1_box3_target_x = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_14_cave1_box3_target_y = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_14_cave1_box3_target_z = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_14_cave1_box3_focus_aw = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_14_cave1_box3_focus_ah = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_14_cave1_box3_focus_xw = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_14_cave1_box3_focus_xh = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_14_cave1_box3_focus_r = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_14_cave1_box3_p_interact = 0;
#line 71 "MACS_sample_kidney_box.instr"
  if(0) strncpy(mccchannel_14_cave1_box3_mask_string, 0 ? 0 : "", 16384); else mccchannel_14_cave1_box3_mask_string[0]='\0';
#line 71 "MACS_sample_kidney_box.instr"
  if(0) strncpy(mccchannel_14_cave1_box3_mask_setting, 0 ? 0 : "", 16384); else mccchannel_14_cave1_box3_mask_setting[0]='\0';
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_14_cave1_box3_number_of_activations = 1;
#line 134134 "MACS_sample_kidney_box.c"

  SIG_MESSAGE("channel_14_cave1_box3 (Init:Place/Rotate)");
  rot_set_rotation(mctr1,
#line 3633 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 3633 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 3633 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD);
#line 134144 "MACS_sample_kidney_box.c"
  rot_mul(mctr1, mcrotakidney_channel_14, mcrotachannel_14_cave1_box3);
  rot_transpose(mcrotachannel_14_cave1_box2, mctr1);
  rot_mul(mcrotachannel_14_cave1_box3, mctr1, mcrotrchannel_14_cave1_box3);
  mctc1 = coords_set(
#line 3632 "MACS_sample_kidney_box.instr"
    0,
#line 3632 "MACS_sample_kidney_box.instr"
    0,
#line 3632 "MACS_sample_kidney_box.instr"
    kidney_cave1_box3_center_to_target);
#line 134155 "MACS_sample_kidney_box.c"
  rot_transpose(mcrotakidney_channel_14, mctr1);
  mctc2 = rot_apply(mctr1, mctc1);
  mcposachannel_14_cave1_box3 = coords_add(mcposakidney_channel_14, mctc2);
  mctc1 = coords_sub(mcposachannel_14_cave1_box2, mcposachannel_14_cave1_box3);
  mcposrchannel_14_cave1_box3 = rot_apply(mcrotachannel_14_cave1_box3, mctc1);
  mcDEBUG_COMPONENT("channel_14_cave1_box3", mcposachannel_14_cave1_box3, mcrotachannel_14_cave1_box3)
  mccomp_posa[658] = mcposachannel_14_cave1_box3;
  mccomp_posr[658] = mcposrchannel_14_cave1_box3;
  mcNCounter[658]  = mcPCounter[658] = mcP2Counter[658] = 0;
  mcAbsorbProp[658]= 0;
    /* Component channel_14_cave1_cyl1. */
  /* Setting parameters for component channel_14_cave1_cyl1. */
  SIG_MESSAGE("channel_14_cave1_cyl1 (Init:SetPar)");
#line 3637 "MACS_sample_kidney_box.instr"
  if("Vacuum") strncpy(mccchannel_14_cave1_cyl1_material_string, "Vacuum" ? "Vacuum" : "", 16384); else mccchannel_14_cave1_cyl1_material_string[0]='\0';
#line 3637 "MACS_sample_kidney_box.instr"
  mccchannel_14_cave1_cyl1_priority = 1603;
#line 3636 "MACS_sample_kidney_box.instr"
  mccchannel_14_cave1_cyl1_radius = kidney_cave1_cyl1_radius;
#line 3636 "MACS_sample_kidney_box.instr"
  mccchannel_14_cave1_cyl1_yheight = kidney_cave1_cyl1_height;
#line 67 "MACS_sample_kidney_box.instr"
  mccchannel_14_cave1_cyl1_visualize = 1;
#line 67 "MACS_sample_kidney_box.instr"
  mccchannel_14_cave1_cyl1_target_index = 0;
#line 67 "MACS_sample_kidney_box.instr"
  mccchannel_14_cave1_cyl1_target_x = 0;
#line 67 "MACS_sample_kidney_box.instr"
  mccchannel_14_cave1_cyl1_target_y = 0;
#line 67 "MACS_sample_kidney_box.instr"
  mccchannel_14_cave1_cyl1_target_z = 0;
#line 67 "MACS_sample_kidney_box.instr"
  mccchannel_14_cave1_cyl1_focus_aw = 0;
#line 67 "MACS_sample_kidney_box.instr"
  mccchannel_14_cave1_cyl1_focus_ah = 0;
#line 67 "MACS_sample_kidney_box.instr"
  mccchannel_14_cave1_cyl1_focus_xw = 0;
#line 67 "MACS_sample_kidney_box.instr"
  mccchannel_14_cave1_cyl1_focus_xh = 0;
#line 67 "MACS_sample_kidney_box.instr"
  mccchannel_14_cave1_cyl1_focus_r = 0;
#line 67 "MACS_sample_kidney_box.instr"
  mccchannel_14_cave1_cyl1_p_interact = 0;
#line 67 "MACS_sample_kidney_box.instr"
  if(0) strncpy(mccchannel_14_cave1_cyl1_mask_string, 0 ? 0 : "", 16384); else mccchannel_14_cave1_cyl1_mask_string[0]='\0';
#line 67 "MACS_sample_kidney_box.instr"
  if(0) strncpy(mccchannel_14_cave1_cyl1_mask_setting, 0 ? 0 : "", 16384); else mccchannel_14_cave1_cyl1_mask_setting[0]='\0';
#line 67 "MACS_sample_kidney_box.instr"
  mccchannel_14_cave1_cyl1_number_of_activations = 1;
#line 134205 "MACS_sample_kidney_box.c"

  SIG_MESSAGE("channel_14_cave1_cyl1 (Init:Place/Rotate)");
  rot_set_rotation(mctr1,
#line 3639 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 3639 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 3639 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD);
#line 134215 "MACS_sample_kidney_box.c"
  rot_mul(mctr1, mcrotakidney_channel_14, mcrotachannel_14_cave1_cyl1);
  rot_transpose(mcrotachannel_14_cave1_box3, mctr1);
  rot_mul(mcrotachannel_14_cave1_cyl1, mctr1, mcrotrchannel_14_cave1_cyl1);
  mctc1 = coords_set(
#line 3638 "MACS_sample_kidney_box.instr"
    0,
#line 3638 "MACS_sample_kidney_box.instr"
    0,
#line 3638 "MACS_sample_kidney_box.instr"
    kidney_cave1_cyl1_center_to_target);
#line 134226 "MACS_sample_kidney_box.c"
  rot_transpose(mcrotakidney_channel_14, mctr1);
  mctc2 = rot_apply(mctr1, mctc1);
  mcposachannel_14_cave1_cyl1 = coords_add(mcposakidney_channel_14, mctc2);
  mctc1 = coords_sub(mcposachannel_14_cave1_box3, mcposachannel_14_cave1_cyl1);
  mcposrchannel_14_cave1_cyl1 = rot_apply(mcrotachannel_14_cave1_cyl1, mctc1);
  mcDEBUG_COMPONENT("channel_14_cave1_cyl1", mcposachannel_14_cave1_cyl1, mcrotachannel_14_cave1_cyl1)
  mccomp_posa[659] = mcposachannel_14_cave1_cyl1;
  mccomp_posr[659] = mcposrchannel_14_cave1_cyl1;
  mcNCounter[659]  = mcPCounter[659] = mcP2Counter[659] = 0;
  mcAbsorbProp[659]= 0;
    /* Component channel_14_analyzer_1_center. */
  /* Setting parameters for component channel_14_analyzer_1_center. */
  SIG_MESSAGE("channel_14_analyzer_1_center (Init:SetPar)");

  SIG_MESSAGE("channel_14_analyzer_1_center (Init:Place/Rotate)");
  rot_set_rotation(mctr1,
    (0.0)*DEG2RAD,
    (0.0)*DEG2RAD,
    (0.0)*DEG2RAD);
#line 134246 "MACS_sample_kidney_box.c"
  rot_mul(mctr1, mcrotakidney_channel_14, mcrotachannel_14_analyzer_1_center);
  rot_transpose(mcrotachannel_14_cave1_cyl1, mctr1);
  rot_mul(mcrotachannel_14_analyzer_1_center, mctr1, mcrotrchannel_14_analyzer_1_center);
  mctc1 = coords_set(
#line 3643 "MACS_sample_kidney_box.instr"
    0,
#line 3643 "MACS_sample_kidney_box.instr"
    0,
#line 3643 "MACS_sample_kidney_box.instr"
    analyzer_1_center_to_sample);
#line 134257 "MACS_sample_kidney_box.c"
  rot_transpose(mcrotakidney_channel_14, mctr1);
  mctc2 = rot_apply(mctr1, mctc1);
  mcposachannel_14_analyzer_1_center = coords_add(mcposakidney_channel_14, mctc2);
  mctc1 = coords_sub(mcposachannel_14_cave1_cyl1, mcposachannel_14_analyzer_1_center);
  mcposrchannel_14_analyzer_1_center = rot_apply(mcrotachannel_14_analyzer_1_center, mctc1);
  mcDEBUG_COMPONENT("channel_14_analyzer_1_center", mcposachannel_14_analyzer_1_center, mcrotachannel_14_analyzer_1_center)
  mccomp_posa[660] = mcposachannel_14_analyzer_1_center;
  mccomp_posr[660] = mcposrchannel_14_analyzer_1_center;
  mcNCounter[660]  = mcPCounter[660] = mcP2Counter[660] = 0;
  mcAbsorbProp[660]= 0;
    /* Component channel_14_analyzer_1_rotated. */
  /* Setting parameters for component channel_14_analyzer_1_rotated. */
  SIG_MESSAGE("channel_14_analyzer_1_rotated (Init:SetPar)");

  SIG_MESSAGE("channel_14_analyzer_1_rotated (Init:Place/Rotate)");
  rot_set_rotation(mctr1,
#line 3647 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 3647 "MACS_sample_kidney_box.instr"
    (180 - analyzer_theta [ 14 ])*DEG2RAD,
#line 3647 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD);
#line 134280 "MACS_sample_kidney_box.c"
  rot_mul(mctr1, mcrotachannel_14_analyzer_1_center, mcrotachannel_14_analyzer_1_rotated);
  rot_transpose(mcrotachannel_14_analyzer_1_center, mctr1);
  rot_mul(mcrotachannel_14_analyzer_1_rotated, mctr1, mcrotrchannel_14_analyzer_1_rotated);
  mctc1 = coords_set(
#line 3646 "MACS_sample_kidney_box.instr"
    0,
#line 3646 "MACS_sample_kidney_box.instr"
    0,
#line 3646 "MACS_sample_kidney_box.instr"
    -0.5 * analyzer_seperation / tan ( analyzer_2theta [ 14 ] * DEG2RAD ));
#line 134291 "MACS_sample_kidney_box.c"
  rot_transpose(mcrotachannel_14_analyzer_1_center, mctr1);
  mctc2 = rot_apply(mctr1, mctc1);
  mcposachannel_14_analyzer_1_rotated = coords_add(mcposachannel_14_analyzer_1_center, mctc2);
  mctc1 = coords_sub(mcposachannel_14_analyzer_1_center, mcposachannel_14_analyzer_1_rotated);
  mcposrchannel_14_analyzer_1_rotated = rot_apply(mcrotachannel_14_analyzer_1_rotated, mctc1);
  mcDEBUG_COMPONENT("channel_14_analyzer_1_rotated", mcposachannel_14_analyzer_1_rotated, mcrotachannel_14_analyzer_1_rotated)
  mccomp_posa[661] = mcposachannel_14_analyzer_1_rotated;
  mccomp_posr[661] = mcposrchannel_14_analyzer_1_rotated;
  mcNCounter[661]  = mcPCounter[661] = mcP2Counter[661] = 0;
  mcAbsorbProp[661]= 0;
    /* Component channel_14_analyzer_1_array_crystal_array_0. */
  /* Setting parameters for component channel_14_analyzer_1_array_crystal_array_0. */
  SIG_MESSAGE("channel_14_analyzer_1_array_crystal_array_0 (Init:SetPar)");
#line 3651 "MACS_sample_kidney_box.instr"
  if("PG_analyzer") strncpy(mccchannel_14_analyzer_1_array_crystal_array_0_material_string, "PG_analyzer" ? "PG_analyzer" : "", 16384); else mccchannel_14_analyzer_1_array_crystal_array_0_material_string[0]='\0';
#line 3651 "MACS_sample_kidney_box.instr"
  mccchannel_14_analyzer_1_array_crystal_array_0_priority = 1620.0;
#line 3650 "MACS_sample_kidney_box.instr"
  mccchannel_14_analyzer_1_array_crystal_array_0_xwidth = channel_14_analyzer_1_array_crystal_depth;
#line 3650 "MACS_sample_kidney_box.instr"
  mccchannel_14_analyzer_1_array_crystal_array_0_yheight = channel_14_analyzer_1_array_crystal_height;
#line 3650 "MACS_sample_kidney_box.instr"
  mccchannel_14_analyzer_1_array_crystal_array_0_zdepth = channel_14_analyzer_1_array_crystal_width;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_14_analyzer_1_array_crystal_array_0_xwidth2 = -1;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_14_analyzer_1_array_crystal_array_0_yheight2 = -1;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_14_analyzer_1_array_crystal_array_0_visualize = 1;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_14_analyzer_1_array_crystal_array_0_target_index = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_14_analyzer_1_array_crystal_array_0_target_x = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_14_analyzer_1_array_crystal_array_0_target_y = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_14_analyzer_1_array_crystal_array_0_target_z = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_14_analyzer_1_array_crystal_array_0_focus_aw = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_14_analyzer_1_array_crystal_array_0_focus_ah = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_14_analyzer_1_array_crystal_array_0_focus_xw = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_14_analyzer_1_array_crystal_array_0_focus_xh = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_14_analyzer_1_array_crystal_array_0_focus_r = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_14_analyzer_1_array_crystal_array_0_p_interact = 0;
#line 71 "MACS_sample_kidney_box.instr"
  if(0) strncpy(mccchannel_14_analyzer_1_array_crystal_array_0_mask_string, 0 ? 0 : "", 16384); else mccchannel_14_analyzer_1_array_crystal_array_0_mask_string[0]='\0';
#line 71 "MACS_sample_kidney_box.instr"
  if(0) strncpy(mccchannel_14_analyzer_1_array_crystal_array_0_mask_setting, 0 ? 0 : "", 16384); else mccchannel_14_analyzer_1_array_crystal_array_0_mask_setting[0]='\0';
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_14_analyzer_1_array_crystal_array_0_number_of_activations = 1;
#line 134347 "MACS_sample_kidney_box.c"

  SIG_MESSAGE("channel_14_analyzer_1_array_crystal_array_0 (Init:Place/Rotate)");
  rot_set_rotation(mctr1,
#line 3653 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 3653 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 3653 "MACS_sample_kidney_box.instr"
    (0 - RAD2DEG * channel_14_analyzer_1_array_theta [ 0 ])*DEG2RAD);
#line 134357 "MACS_sample_kidney_box.c"
  rot_mul(mctr1, mcrotachannel_14_analyzer_1_rotated, mcrotachannel_14_analyzer_1_array_crystal_array_0);
  rot_transpose(mcrotachannel_14_analyzer_1_rotated, mctr1);
  rot_mul(mcrotachannel_14_analyzer_1_array_crystal_array_0, mctr1, mcrotrchannel_14_analyzer_1_array_crystal_array_0);
  mctc1 = coords_set(
#line 3652 "MACS_sample_kidney_box.instr"
    0 + channel_14_analyzer_1_array_effective_radius_of_curvature * ( 1 - cos ( channel_14_analyzer_1_array_theta [ 0 ] ) ),
#line 3652 "MACS_sample_kidney_box.instr"
    0 + channel_14_analyzer_1_array_effective_radius_of_curvature * sin ( channel_14_analyzer_1_array_theta [ 0 ] ),
#line 3652 "MACS_sample_kidney_box.instr"
    0);
#line 134368 "MACS_sample_kidney_box.c"
  rot_transpose(mcrotachannel_14_analyzer_1_rotated, mctr1);
  mctc2 = rot_apply(mctr1, mctc1);
  mcposachannel_14_analyzer_1_array_crystal_array_0 = coords_add(mcposachannel_14_analyzer_1_rotated, mctc2);
  mctc1 = coords_sub(mcposachannel_14_analyzer_1_rotated, mcposachannel_14_analyzer_1_array_crystal_array_0);
  mcposrchannel_14_analyzer_1_array_crystal_array_0 = rot_apply(mcrotachannel_14_analyzer_1_array_crystal_array_0, mctc1);
  mcDEBUG_COMPONENT("channel_14_analyzer_1_array_crystal_array_0", mcposachannel_14_analyzer_1_array_crystal_array_0, mcrotachannel_14_analyzer_1_array_crystal_array_0)
  mccomp_posa[662] = mcposachannel_14_analyzer_1_array_crystal_array_0;
  mccomp_posr[662] = mcposrchannel_14_analyzer_1_array_crystal_array_0;
  mcNCounter[662]  = mcPCounter[662] = mcP2Counter[662] = 0;
  mcAbsorbProp[662]= 0;
    /* Component channel_14_analyzer_1_array_crystal_array_1. */
  /* Setting parameters for component channel_14_analyzer_1_array_crystal_array_1. */
  SIG_MESSAGE("channel_14_analyzer_1_array_crystal_array_1 (Init:SetPar)");
#line 3657 "MACS_sample_kidney_box.instr"
  if("PG_analyzer") strncpy(mccchannel_14_analyzer_1_array_crystal_array_1_material_string, "PG_analyzer" ? "PG_analyzer" : "", 16384); else mccchannel_14_analyzer_1_array_crystal_array_1_material_string[0]='\0';
#line 3657 "MACS_sample_kidney_box.instr"
  mccchannel_14_analyzer_1_array_crystal_array_1_priority = 1620.1;
#line 3656 "MACS_sample_kidney_box.instr"
  mccchannel_14_analyzer_1_array_crystal_array_1_xwidth = channel_14_analyzer_1_array_crystal_depth;
#line 3656 "MACS_sample_kidney_box.instr"
  mccchannel_14_analyzer_1_array_crystal_array_1_yheight = channel_14_analyzer_1_array_crystal_height;
#line 3656 "MACS_sample_kidney_box.instr"
  mccchannel_14_analyzer_1_array_crystal_array_1_zdepth = channel_14_analyzer_1_array_crystal_width;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_14_analyzer_1_array_crystal_array_1_xwidth2 = -1;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_14_analyzer_1_array_crystal_array_1_yheight2 = -1;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_14_analyzer_1_array_crystal_array_1_visualize = 1;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_14_analyzer_1_array_crystal_array_1_target_index = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_14_analyzer_1_array_crystal_array_1_target_x = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_14_analyzer_1_array_crystal_array_1_target_y = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_14_analyzer_1_array_crystal_array_1_target_z = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_14_analyzer_1_array_crystal_array_1_focus_aw = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_14_analyzer_1_array_crystal_array_1_focus_ah = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_14_analyzer_1_array_crystal_array_1_focus_xw = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_14_analyzer_1_array_crystal_array_1_focus_xh = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_14_analyzer_1_array_crystal_array_1_focus_r = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_14_analyzer_1_array_crystal_array_1_p_interact = 0;
#line 71 "MACS_sample_kidney_box.instr"
  if(0) strncpy(mccchannel_14_analyzer_1_array_crystal_array_1_mask_string, 0 ? 0 : "", 16384); else mccchannel_14_analyzer_1_array_crystal_array_1_mask_string[0]='\0';
#line 71 "MACS_sample_kidney_box.instr"
  if(0) strncpy(mccchannel_14_analyzer_1_array_crystal_array_1_mask_setting, 0 ? 0 : "", 16384); else mccchannel_14_analyzer_1_array_crystal_array_1_mask_setting[0]='\0';
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_14_analyzer_1_array_crystal_array_1_number_of_activations = 1;
#line 134424 "MACS_sample_kidney_box.c"

  SIG_MESSAGE("channel_14_analyzer_1_array_crystal_array_1 (Init:Place/Rotate)");
  rot_set_rotation(mctr1,
#line 3659 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 3659 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 3659 "MACS_sample_kidney_box.instr"
    (0 - RAD2DEG * channel_14_analyzer_1_array_theta [ 1 ])*DEG2RAD);
#line 134434 "MACS_sample_kidney_box.c"
  rot_mul(mctr1, mcrotachannel_14_analyzer_1_rotated, mcrotachannel_14_analyzer_1_array_crystal_array_1);
  rot_transpose(mcrotachannel_14_analyzer_1_array_crystal_array_0, mctr1);
  rot_mul(mcrotachannel_14_analyzer_1_array_crystal_array_1, mctr1, mcrotrchannel_14_analyzer_1_array_crystal_array_1);
  mctc1 = coords_set(
#line 3658 "MACS_sample_kidney_box.instr"
    0 + channel_14_analyzer_1_array_effective_radius_of_curvature * ( 1 - cos ( channel_14_analyzer_1_array_theta [ 1 ] ) ),
#line 3658 "MACS_sample_kidney_box.instr"
    0 + channel_14_analyzer_1_array_effective_radius_of_curvature * sin ( channel_14_analyzer_1_array_theta [ 1 ] ),
#line 3658 "MACS_sample_kidney_box.instr"
    0);
#line 134445 "MACS_sample_kidney_box.c"
  rot_transpose(mcrotachannel_14_analyzer_1_rotated, mctr1);
  mctc2 = rot_apply(mctr1, mctc1);
  mcposachannel_14_analyzer_1_array_crystal_array_1 = coords_add(mcposachannel_14_analyzer_1_rotated, mctc2);
  mctc1 = coords_sub(mcposachannel_14_analyzer_1_array_crystal_array_0, mcposachannel_14_analyzer_1_array_crystal_array_1);
  mcposrchannel_14_analyzer_1_array_crystal_array_1 = rot_apply(mcrotachannel_14_analyzer_1_array_crystal_array_1, mctc1);
  mcDEBUG_COMPONENT("channel_14_analyzer_1_array_crystal_array_1", mcposachannel_14_analyzer_1_array_crystal_array_1, mcrotachannel_14_analyzer_1_array_crystal_array_1)
  mccomp_posa[663] = mcposachannel_14_analyzer_1_array_crystal_array_1;
  mccomp_posr[663] = mcposrchannel_14_analyzer_1_array_crystal_array_1;
  mcNCounter[663]  = mcPCounter[663] = mcP2Counter[663] = 0;
  mcAbsorbProp[663]= 0;
    /* Component channel_14_analyzer_1_array_crystal_array_2. */
  /* Setting parameters for component channel_14_analyzer_1_array_crystal_array_2. */
  SIG_MESSAGE("channel_14_analyzer_1_array_crystal_array_2 (Init:SetPar)");
#line 3663 "MACS_sample_kidney_box.instr"
  if("PG_analyzer") strncpy(mccchannel_14_analyzer_1_array_crystal_array_2_material_string, "PG_analyzer" ? "PG_analyzer" : "", 16384); else mccchannel_14_analyzer_1_array_crystal_array_2_material_string[0]='\0';
#line 3663 "MACS_sample_kidney_box.instr"
  mccchannel_14_analyzer_1_array_crystal_array_2_priority = 1620.2;
#line 3662 "MACS_sample_kidney_box.instr"
  mccchannel_14_analyzer_1_array_crystal_array_2_xwidth = channel_14_analyzer_1_array_crystal_depth;
#line 3662 "MACS_sample_kidney_box.instr"
  mccchannel_14_analyzer_1_array_crystal_array_2_yheight = channel_14_analyzer_1_array_crystal_height;
#line 3662 "MACS_sample_kidney_box.instr"
  mccchannel_14_analyzer_1_array_crystal_array_2_zdepth = channel_14_analyzer_1_array_crystal_width;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_14_analyzer_1_array_crystal_array_2_xwidth2 = -1;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_14_analyzer_1_array_crystal_array_2_yheight2 = -1;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_14_analyzer_1_array_crystal_array_2_visualize = 1;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_14_analyzer_1_array_crystal_array_2_target_index = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_14_analyzer_1_array_crystal_array_2_target_x = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_14_analyzer_1_array_crystal_array_2_target_y = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_14_analyzer_1_array_crystal_array_2_target_z = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_14_analyzer_1_array_crystal_array_2_focus_aw = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_14_analyzer_1_array_crystal_array_2_focus_ah = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_14_analyzer_1_array_crystal_array_2_focus_xw = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_14_analyzer_1_array_crystal_array_2_focus_xh = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_14_analyzer_1_array_crystal_array_2_focus_r = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_14_analyzer_1_array_crystal_array_2_p_interact = 0;
#line 71 "MACS_sample_kidney_box.instr"
  if(0) strncpy(mccchannel_14_analyzer_1_array_crystal_array_2_mask_string, 0 ? 0 : "", 16384); else mccchannel_14_analyzer_1_array_crystal_array_2_mask_string[0]='\0';
#line 71 "MACS_sample_kidney_box.instr"
  if(0) strncpy(mccchannel_14_analyzer_1_array_crystal_array_2_mask_setting, 0 ? 0 : "", 16384); else mccchannel_14_analyzer_1_array_crystal_array_2_mask_setting[0]='\0';
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_14_analyzer_1_array_crystal_array_2_number_of_activations = 1;
#line 134501 "MACS_sample_kidney_box.c"

  SIG_MESSAGE("channel_14_analyzer_1_array_crystal_array_2 (Init:Place/Rotate)");
  rot_set_rotation(mctr1,
#line 3665 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 3665 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 3665 "MACS_sample_kidney_box.instr"
    (0 - RAD2DEG * channel_14_analyzer_1_array_theta [ 2 ])*DEG2RAD);
#line 134511 "MACS_sample_kidney_box.c"
  rot_mul(mctr1, mcrotachannel_14_analyzer_1_rotated, mcrotachannel_14_analyzer_1_array_crystal_array_2);
  rot_transpose(mcrotachannel_14_analyzer_1_array_crystal_array_1, mctr1);
  rot_mul(mcrotachannel_14_analyzer_1_array_crystal_array_2, mctr1, mcrotrchannel_14_analyzer_1_array_crystal_array_2);
  mctc1 = coords_set(
#line 3664 "MACS_sample_kidney_box.instr"
    0 + channel_14_analyzer_1_array_effective_radius_of_curvature * ( 1 - cos ( channel_14_analyzer_1_array_theta [ 2 ] ) ),
#line 3664 "MACS_sample_kidney_box.instr"
    0 + channel_14_analyzer_1_array_effective_radius_of_curvature * sin ( channel_14_analyzer_1_array_theta [ 2 ] ),
#line 3664 "MACS_sample_kidney_box.instr"
    0);
#line 134522 "MACS_sample_kidney_box.c"
  rot_transpose(mcrotachannel_14_analyzer_1_rotated, mctr1);
  mctc2 = rot_apply(mctr1, mctc1);
  mcposachannel_14_analyzer_1_array_crystal_array_2 = coords_add(mcposachannel_14_analyzer_1_rotated, mctc2);
  mctc1 = coords_sub(mcposachannel_14_analyzer_1_array_crystal_array_1, mcposachannel_14_analyzer_1_array_crystal_array_2);
  mcposrchannel_14_analyzer_1_array_crystal_array_2 = rot_apply(mcrotachannel_14_analyzer_1_array_crystal_array_2, mctc1);
  mcDEBUG_COMPONENT("channel_14_analyzer_1_array_crystal_array_2", mcposachannel_14_analyzer_1_array_crystal_array_2, mcrotachannel_14_analyzer_1_array_crystal_array_2)
  mccomp_posa[664] = mcposachannel_14_analyzer_1_array_crystal_array_2;
  mccomp_posr[664] = mcposrchannel_14_analyzer_1_array_crystal_array_2;
  mcNCounter[664]  = mcPCounter[664] = mcP2Counter[664] = 0;
  mcAbsorbProp[664]= 0;
    /* Component channel_14_analyzer_1_array_crystal_array_3. */
  /* Setting parameters for component channel_14_analyzer_1_array_crystal_array_3. */
  SIG_MESSAGE("channel_14_analyzer_1_array_crystal_array_3 (Init:SetPar)");
#line 3669 "MACS_sample_kidney_box.instr"
  if("PG_analyzer") strncpy(mccchannel_14_analyzer_1_array_crystal_array_3_material_string, "PG_analyzer" ? "PG_analyzer" : "", 16384); else mccchannel_14_analyzer_1_array_crystal_array_3_material_string[0]='\0';
#line 3669 "MACS_sample_kidney_box.instr"
  mccchannel_14_analyzer_1_array_crystal_array_3_priority = 1620.3;
#line 3668 "MACS_sample_kidney_box.instr"
  mccchannel_14_analyzer_1_array_crystal_array_3_xwidth = channel_14_analyzer_1_array_crystal_depth;
#line 3668 "MACS_sample_kidney_box.instr"
  mccchannel_14_analyzer_1_array_crystal_array_3_yheight = channel_14_analyzer_1_array_crystal_height;
#line 3668 "MACS_sample_kidney_box.instr"
  mccchannel_14_analyzer_1_array_crystal_array_3_zdepth = channel_14_analyzer_1_array_crystal_width;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_14_analyzer_1_array_crystal_array_3_xwidth2 = -1;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_14_analyzer_1_array_crystal_array_3_yheight2 = -1;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_14_analyzer_1_array_crystal_array_3_visualize = 1;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_14_analyzer_1_array_crystal_array_3_target_index = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_14_analyzer_1_array_crystal_array_3_target_x = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_14_analyzer_1_array_crystal_array_3_target_y = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_14_analyzer_1_array_crystal_array_3_target_z = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_14_analyzer_1_array_crystal_array_3_focus_aw = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_14_analyzer_1_array_crystal_array_3_focus_ah = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_14_analyzer_1_array_crystal_array_3_focus_xw = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_14_analyzer_1_array_crystal_array_3_focus_xh = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_14_analyzer_1_array_crystal_array_3_focus_r = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_14_analyzer_1_array_crystal_array_3_p_interact = 0;
#line 71 "MACS_sample_kidney_box.instr"
  if(0) strncpy(mccchannel_14_analyzer_1_array_crystal_array_3_mask_string, 0 ? 0 : "", 16384); else mccchannel_14_analyzer_1_array_crystal_array_3_mask_string[0]='\0';
#line 71 "MACS_sample_kidney_box.instr"
  if(0) strncpy(mccchannel_14_analyzer_1_array_crystal_array_3_mask_setting, 0 ? 0 : "", 16384); else mccchannel_14_analyzer_1_array_crystal_array_3_mask_setting[0]='\0';
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_14_analyzer_1_array_crystal_array_3_number_of_activations = 1;
#line 134578 "MACS_sample_kidney_box.c"

  SIG_MESSAGE("channel_14_analyzer_1_array_crystal_array_3 (Init:Place/Rotate)");
  rot_set_rotation(mctr1,
#line 3671 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 3671 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 3671 "MACS_sample_kidney_box.instr"
    (0 - RAD2DEG * channel_14_analyzer_1_array_theta [ 3 ])*DEG2RAD);
#line 134588 "MACS_sample_kidney_box.c"
  rot_mul(mctr1, mcrotachannel_14_analyzer_1_rotated, mcrotachannel_14_analyzer_1_array_crystal_array_3);
  rot_transpose(mcrotachannel_14_analyzer_1_array_crystal_array_2, mctr1);
  rot_mul(mcrotachannel_14_analyzer_1_array_crystal_array_3, mctr1, mcrotrchannel_14_analyzer_1_array_crystal_array_3);
  mctc1 = coords_set(
#line 3670 "MACS_sample_kidney_box.instr"
    0 + channel_14_analyzer_1_array_effective_radius_of_curvature * ( 1 - cos ( channel_14_analyzer_1_array_theta [ 3 ] ) ),
#line 3670 "MACS_sample_kidney_box.instr"
    0 + channel_14_analyzer_1_array_effective_radius_of_curvature * sin ( channel_14_analyzer_1_array_theta [ 3 ] ),
#line 3670 "MACS_sample_kidney_box.instr"
    0);
#line 134599 "MACS_sample_kidney_box.c"
  rot_transpose(mcrotachannel_14_analyzer_1_rotated, mctr1);
  mctc2 = rot_apply(mctr1, mctc1);
  mcposachannel_14_analyzer_1_array_crystal_array_3 = coords_add(mcposachannel_14_analyzer_1_rotated, mctc2);
  mctc1 = coords_sub(mcposachannel_14_analyzer_1_array_crystal_array_2, mcposachannel_14_analyzer_1_array_crystal_array_3);
  mcposrchannel_14_analyzer_1_array_crystal_array_3 = rot_apply(mcrotachannel_14_analyzer_1_array_crystal_array_3, mctc1);
  mcDEBUG_COMPONENT("channel_14_analyzer_1_array_crystal_array_3", mcposachannel_14_analyzer_1_array_crystal_array_3, mcrotachannel_14_analyzer_1_array_crystal_array_3)
  mccomp_posa[665] = mcposachannel_14_analyzer_1_array_crystal_array_3;
  mccomp_posr[665] = mcposrchannel_14_analyzer_1_array_crystal_array_3;
  mcNCounter[665]  = mcPCounter[665] = mcP2Counter[665] = 0;
  mcAbsorbProp[665]= 0;
    /* Component channel_14_analyzer_1_array_crystal_array_4. */
  /* Setting parameters for component channel_14_analyzer_1_array_crystal_array_4. */
  SIG_MESSAGE("channel_14_analyzer_1_array_crystal_array_4 (Init:SetPar)");
#line 3675 "MACS_sample_kidney_box.instr"
  if("PG_analyzer") strncpy(mccchannel_14_analyzer_1_array_crystal_array_4_material_string, "PG_analyzer" ? "PG_analyzer" : "", 16384); else mccchannel_14_analyzer_1_array_crystal_array_4_material_string[0]='\0';
#line 3675 "MACS_sample_kidney_box.instr"
  mccchannel_14_analyzer_1_array_crystal_array_4_priority = 1620.4;
#line 3674 "MACS_sample_kidney_box.instr"
  mccchannel_14_analyzer_1_array_crystal_array_4_xwidth = channel_14_analyzer_1_array_crystal_depth;
#line 3674 "MACS_sample_kidney_box.instr"
  mccchannel_14_analyzer_1_array_crystal_array_4_yheight = channel_14_analyzer_1_array_crystal_height;
#line 3674 "MACS_sample_kidney_box.instr"
  mccchannel_14_analyzer_1_array_crystal_array_4_zdepth = channel_14_analyzer_1_array_crystal_width;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_14_analyzer_1_array_crystal_array_4_xwidth2 = -1;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_14_analyzer_1_array_crystal_array_4_yheight2 = -1;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_14_analyzer_1_array_crystal_array_4_visualize = 1;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_14_analyzer_1_array_crystal_array_4_target_index = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_14_analyzer_1_array_crystal_array_4_target_x = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_14_analyzer_1_array_crystal_array_4_target_y = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_14_analyzer_1_array_crystal_array_4_target_z = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_14_analyzer_1_array_crystal_array_4_focus_aw = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_14_analyzer_1_array_crystal_array_4_focus_ah = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_14_analyzer_1_array_crystal_array_4_focus_xw = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_14_analyzer_1_array_crystal_array_4_focus_xh = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_14_analyzer_1_array_crystal_array_4_focus_r = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_14_analyzer_1_array_crystal_array_4_p_interact = 0;
#line 71 "MACS_sample_kidney_box.instr"
  if(0) strncpy(mccchannel_14_analyzer_1_array_crystal_array_4_mask_string, 0 ? 0 : "", 16384); else mccchannel_14_analyzer_1_array_crystal_array_4_mask_string[0]='\0';
#line 71 "MACS_sample_kidney_box.instr"
  if(0) strncpy(mccchannel_14_analyzer_1_array_crystal_array_4_mask_setting, 0 ? 0 : "", 16384); else mccchannel_14_analyzer_1_array_crystal_array_4_mask_setting[0]='\0';
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_14_analyzer_1_array_crystal_array_4_number_of_activations = 1;
#line 134655 "MACS_sample_kidney_box.c"

  SIG_MESSAGE("channel_14_analyzer_1_array_crystal_array_4 (Init:Place/Rotate)");
  rot_set_rotation(mctr1,
#line 3677 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 3677 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 3677 "MACS_sample_kidney_box.instr"
    (0 - RAD2DEG * channel_14_analyzer_1_array_theta [ 4 ])*DEG2RAD);
#line 134665 "MACS_sample_kidney_box.c"
  rot_mul(mctr1, mcrotachannel_14_analyzer_1_rotated, mcrotachannel_14_analyzer_1_array_crystal_array_4);
  rot_transpose(mcrotachannel_14_analyzer_1_array_crystal_array_3, mctr1);
  rot_mul(mcrotachannel_14_analyzer_1_array_crystal_array_4, mctr1, mcrotrchannel_14_analyzer_1_array_crystal_array_4);
  mctc1 = coords_set(
#line 3676 "MACS_sample_kidney_box.instr"
    0 + channel_14_analyzer_1_array_effective_radius_of_curvature * ( 1 - cos ( channel_14_analyzer_1_array_theta [ 4 ] ) ),
#line 3676 "MACS_sample_kidney_box.instr"
    0 + channel_14_analyzer_1_array_effective_radius_of_curvature * sin ( channel_14_analyzer_1_array_theta [ 4 ] ),
#line 3676 "MACS_sample_kidney_box.instr"
    0);
#line 134676 "MACS_sample_kidney_box.c"
  rot_transpose(mcrotachannel_14_analyzer_1_rotated, mctr1);
  mctc2 = rot_apply(mctr1, mctc1);
  mcposachannel_14_analyzer_1_array_crystal_array_4 = coords_add(mcposachannel_14_analyzer_1_rotated, mctc2);
  mctc1 = coords_sub(mcposachannel_14_analyzer_1_array_crystal_array_3, mcposachannel_14_analyzer_1_array_crystal_array_4);
  mcposrchannel_14_analyzer_1_array_crystal_array_4 = rot_apply(mcrotachannel_14_analyzer_1_array_crystal_array_4, mctc1);
  mcDEBUG_COMPONENT("channel_14_analyzer_1_array_crystal_array_4", mcposachannel_14_analyzer_1_array_crystal_array_4, mcrotachannel_14_analyzer_1_array_crystal_array_4)
  mccomp_posa[666] = mcposachannel_14_analyzer_1_array_crystal_array_4;
  mccomp_posr[666] = mcposrchannel_14_analyzer_1_array_crystal_array_4;
  mcNCounter[666]  = mcPCounter[666] = mcP2Counter[666] = 0;
  mcAbsorbProp[666]= 0;
    /* Component channel_14_analyzer_1_array_crystal_array_5. */
  /* Setting parameters for component channel_14_analyzer_1_array_crystal_array_5. */
  SIG_MESSAGE("channel_14_analyzer_1_array_crystal_array_5 (Init:SetPar)");
#line 3681 "MACS_sample_kidney_box.instr"
  if("PG_analyzer") strncpy(mccchannel_14_analyzer_1_array_crystal_array_5_material_string, "PG_analyzer" ? "PG_analyzer" : "", 16384); else mccchannel_14_analyzer_1_array_crystal_array_5_material_string[0]='\0';
#line 3681 "MACS_sample_kidney_box.instr"
  mccchannel_14_analyzer_1_array_crystal_array_5_priority = 1620.5;
#line 3680 "MACS_sample_kidney_box.instr"
  mccchannel_14_analyzer_1_array_crystal_array_5_xwidth = channel_14_analyzer_1_array_crystal_depth;
#line 3680 "MACS_sample_kidney_box.instr"
  mccchannel_14_analyzer_1_array_crystal_array_5_yheight = channel_14_analyzer_1_array_crystal_height;
#line 3680 "MACS_sample_kidney_box.instr"
  mccchannel_14_analyzer_1_array_crystal_array_5_zdepth = channel_14_analyzer_1_array_crystal_width;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_14_analyzer_1_array_crystal_array_5_xwidth2 = -1;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_14_analyzer_1_array_crystal_array_5_yheight2 = -1;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_14_analyzer_1_array_crystal_array_5_visualize = 1;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_14_analyzer_1_array_crystal_array_5_target_index = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_14_analyzer_1_array_crystal_array_5_target_x = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_14_analyzer_1_array_crystal_array_5_target_y = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_14_analyzer_1_array_crystal_array_5_target_z = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_14_analyzer_1_array_crystal_array_5_focus_aw = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_14_analyzer_1_array_crystal_array_5_focus_ah = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_14_analyzer_1_array_crystal_array_5_focus_xw = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_14_analyzer_1_array_crystal_array_5_focus_xh = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_14_analyzer_1_array_crystal_array_5_focus_r = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_14_analyzer_1_array_crystal_array_5_p_interact = 0;
#line 71 "MACS_sample_kidney_box.instr"
  if(0) strncpy(mccchannel_14_analyzer_1_array_crystal_array_5_mask_string, 0 ? 0 : "", 16384); else mccchannel_14_analyzer_1_array_crystal_array_5_mask_string[0]='\0';
#line 71 "MACS_sample_kidney_box.instr"
  if(0) strncpy(mccchannel_14_analyzer_1_array_crystal_array_5_mask_setting, 0 ? 0 : "", 16384); else mccchannel_14_analyzer_1_array_crystal_array_5_mask_setting[0]='\0';
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_14_analyzer_1_array_crystal_array_5_number_of_activations = 1;
#line 134732 "MACS_sample_kidney_box.c"

  SIG_MESSAGE("channel_14_analyzer_1_array_crystal_array_5 (Init:Place/Rotate)");
  rot_set_rotation(mctr1,
#line 3683 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 3683 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 3683 "MACS_sample_kidney_box.instr"
    (0 - RAD2DEG * channel_14_analyzer_1_array_theta [ 5 ])*DEG2RAD);
#line 134742 "MACS_sample_kidney_box.c"
  rot_mul(mctr1, mcrotachannel_14_analyzer_1_rotated, mcrotachannel_14_analyzer_1_array_crystal_array_5);
  rot_transpose(mcrotachannel_14_analyzer_1_array_crystal_array_4, mctr1);
  rot_mul(mcrotachannel_14_analyzer_1_array_crystal_array_5, mctr1, mcrotrchannel_14_analyzer_1_array_crystal_array_5);
  mctc1 = coords_set(
#line 3682 "MACS_sample_kidney_box.instr"
    0 + channel_14_analyzer_1_array_effective_radius_of_curvature * ( 1 - cos ( channel_14_analyzer_1_array_theta [ 5 ] ) ),
#line 3682 "MACS_sample_kidney_box.instr"
    0 + channel_14_analyzer_1_array_effective_radius_of_curvature * sin ( channel_14_analyzer_1_array_theta [ 5 ] ),
#line 3682 "MACS_sample_kidney_box.instr"
    0);
#line 134753 "MACS_sample_kidney_box.c"
  rot_transpose(mcrotachannel_14_analyzer_1_rotated, mctr1);
  mctc2 = rot_apply(mctr1, mctc1);
  mcposachannel_14_analyzer_1_array_crystal_array_5 = coords_add(mcposachannel_14_analyzer_1_rotated, mctc2);
  mctc1 = coords_sub(mcposachannel_14_analyzer_1_array_crystal_array_4, mcposachannel_14_analyzer_1_array_crystal_array_5);
  mcposrchannel_14_analyzer_1_array_crystal_array_5 = rot_apply(mcrotachannel_14_analyzer_1_array_crystal_array_5, mctc1);
  mcDEBUG_COMPONENT("channel_14_analyzer_1_array_crystal_array_5", mcposachannel_14_analyzer_1_array_crystal_array_5, mcrotachannel_14_analyzer_1_array_crystal_array_5)
  mccomp_posa[667] = mcposachannel_14_analyzer_1_array_crystal_array_5;
  mccomp_posr[667] = mcposrchannel_14_analyzer_1_array_crystal_array_5;
  mcNCounter[667]  = mcPCounter[667] = mcP2Counter[667] = 0;
  mcAbsorbProp[667]= 0;
    /* Component channel_14_analyzer_1_array_crystal_array_6. */
  /* Setting parameters for component channel_14_analyzer_1_array_crystal_array_6. */
  SIG_MESSAGE("channel_14_analyzer_1_array_crystal_array_6 (Init:SetPar)");
#line 3687 "MACS_sample_kidney_box.instr"
  if("PG_analyzer") strncpy(mccchannel_14_analyzer_1_array_crystal_array_6_material_string, "PG_analyzer" ? "PG_analyzer" : "", 16384); else mccchannel_14_analyzer_1_array_crystal_array_6_material_string[0]='\0';
#line 3687 "MACS_sample_kidney_box.instr"
  mccchannel_14_analyzer_1_array_crystal_array_6_priority = 1620.6;
#line 3686 "MACS_sample_kidney_box.instr"
  mccchannel_14_analyzer_1_array_crystal_array_6_xwidth = channel_14_analyzer_1_array_crystal_depth;
#line 3686 "MACS_sample_kidney_box.instr"
  mccchannel_14_analyzer_1_array_crystal_array_6_yheight = channel_14_analyzer_1_array_crystal_height;
#line 3686 "MACS_sample_kidney_box.instr"
  mccchannel_14_analyzer_1_array_crystal_array_6_zdepth = channel_14_analyzer_1_array_crystal_width;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_14_analyzer_1_array_crystal_array_6_xwidth2 = -1;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_14_analyzer_1_array_crystal_array_6_yheight2 = -1;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_14_analyzer_1_array_crystal_array_6_visualize = 1;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_14_analyzer_1_array_crystal_array_6_target_index = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_14_analyzer_1_array_crystal_array_6_target_x = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_14_analyzer_1_array_crystal_array_6_target_y = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_14_analyzer_1_array_crystal_array_6_target_z = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_14_analyzer_1_array_crystal_array_6_focus_aw = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_14_analyzer_1_array_crystal_array_6_focus_ah = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_14_analyzer_1_array_crystal_array_6_focus_xw = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_14_analyzer_1_array_crystal_array_6_focus_xh = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_14_analyzer_1_array_crystal_array_6_focus_r = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_14_analyzer_1_array_crystal_array_6_p_interact = 0;
#line 71 "MACS_sample_kidney_box.instr"
  if(0) strncpy(mccchannel_14_analyzer_1_array_crystal_array_6_mask_string, 0 ? 0 : "", 16384); else mccchannel_14_analyzer_1_array_crystal_array_6_mask_string[0]='\0';
#line 71 "MACS_sample_kidney_box.instr"
  if(0) strncpy(mccchannel_14_analyzer_1_array_crystal_array_6_mask_setting, 0 ? 0 : "", 16384); else mccchannel_14_analyzer_1_array_crystal_array_6_mask_setting[0]='\0';
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_14_analyzer_1_array_crystal_array_6_number_of_activations = 1;
#line 134809 "MACS_sample_kidney_box.c"

  SIG_MESSAGE("channel_14_analyzer_1_array_crystal_array_6 (Init:Place/Rotate)");
  rot_set_rotation(mctr1,
#line 3689 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 3689 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 3689 "MACS_sample_kidney_box.instr"
    (0 - RAD2DEG * channel_14_analyzer_1_array_theta [ 6 ])*DEG2RAD);
#line 134819 "MACS_sample_kidney_box.c"
  rot_mul(mctr1, mcrotachannel_14_analyzer_1_rotated, mcrotachannel_14_analyzer_1_array_crystal_array_6);
  rot_transpose(mcrotachannel_14_analyzer_1_array_crystal_array_5, mctr1);
  rot_mul(mcrotachannel_14_analyzer_1_array_crystal_array_6, mctr1, mcrotrchannel_14_analyzer_1_array_crystal_array_6);
  mctc1 = coords_set(
#line 3688 "MACS_sample_kidney_box.instr"
    0 + channel_14_analyzer_1_array_effective_radius_of_curvature * ( 1 - cos ( channel_14_analyzer_1_array_theta [ 6 ] ) ),
#line 3688 "MACS_sample_kidney_box.instr"
    0 + channel_14_analyzer_1_array_effective_radius_of_curvature * sin ( channel_14_analyzer_1_array_theta [ 6 ] ),
#line 3688 "MACS_sample_kidney_box.instr"
    0);
#line 134830 "MACS_sample_kidney_box.c"
  rot_transpose(mcrotachannel_14_analyzer_1_rotated, mctr1);
  mctc2 = rot_apply(mctr1, mctc1);
  mcposachannel_14_analyzer_1_array_crystal_array_6 = coords_add(mcposachannel_14_analyzer_1_rotated, mctc2);
  mctc1 = coords_sub(mcposachannel_14_analyzer_1_array_crystal_array_5, mcposachannel_14_analyzer_1_array_crystal_array_6);
  mcposrchannel_14_analyzer_1_array_crystal_array_6 = rot_apply(mcrotachannel_14_analyzer_1_array_crystal_array_6, mctc1);
  mcDEBUG_COMPONENT("channel_14_analyzer_1_array_crystal_array_6", mcposachannel_14_analyzer_1_array_crystal_array_6, mcrotachannel_14_analyzer_1_array_crystal_array_6)
  mccomp_posa[668] = mcposachannel_14_analyzer_1_array_crystal_array_6;
  mccomp_posr[668] = mcposrchannel_14_analyzer_1_array_crystal_array_6;
  mcNCounter[668]  = mcPCounter[668] = mcP2Counter[668] = 0;
  mcAbsorbProp[668]= 0;
    /* Component channel_14_analyzer_1_array_crystal_array_7. */
  /* Setting parameters for component channel_14_analyzer_1_array_crystal_array_7. */
  SIG_MESSAGE("channel_14_analyzer_1_array_crystal_array_7 (Init:SetPar)");
#line 3693 "MACS_sample_kidney_box.instr"
  if("PG_analyzer") strncpy(mccchannel_14_analyzer_1_array_crystal_array_7_material_string, "PG_analyzer" ? "PG_analyzer" : "", 16384); else mccchannel_14_analyzer_1_array_crystal_array_7_material_string[0]='\0';
#line 3693 "MACS_sample_kidney_box.instr"
  mccchannel_14_analyzer_1_array_crystal_array_7_priority = 1620.7;
#line 3692 "MACS_sample_kidney_box.instr"
  mccchannel_14_analyzer_1_array_crystal_array_7_xwidth = channel_14_analyzer_1_array_crystal_depth;
#line 3692 "MACS_sample_kidney_box.instr"
  mccchannel_14_analyzer_1_array_crystal_array_7_yheight = channel_14_analyzer_1_array_crystal_height;
#line 3692 "MACS_sample_kidney_box.instr"
  mccchannel_14_analyzer_1_array_crystal_array_7_zdepth = channel_14_analyzer_1_array_crystal_width;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_14_analyzer_1_array_crystal_array_7_xwidth2 = -1;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_14_analyzer_1_array_crystal_array_7_yheight2 = -1;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_14_analyzer_1_array_crystal_array_7_visualize = 1;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_14_analyzer_1_array_crystal_array_7_target_index = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_14_analyzer_1_array_crystal_array_7_target_x = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_14_analyzer_1_array_crystal_array_7_target_y = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_14_analyzer_1_array_crystal_array_7_target_z = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_14_analyzer_1_array_crystal_array_7_focus_aw = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_14_analyzer_1_array_crystal_array_7_focus_ah = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_14_analyzer_1_array_crystal_array_7_focus_xw = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_14_analyzer_1_array_crystal_array_7_focus_xh = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_14_analyzer_1_array_crystal_array_7_focus_r = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_14_analyzer_1_array_crystal_array_7_p_interact = 0;
#line 71 "MACS_sample_kidney_box.instr"
  if(0) strncpy(mccchannel_14_analyzer_1_array_crystal_array_7_mask_string, 0 ? 0 : "", 16384); else mccchannel_14_analyzer_1_array_crystal_array_7_mask_string[0]='\0';
#line 71 "MACS_sample_kidney_box.instr"
  if(0) strncpy(mccchannel_14_analyzer_1_array_crystal_array_7_mask_setting, 0 ? 0 : "", 16384); else mccchannel_14_analyzer_1_array_crystal_array_7_mask_setting[0]='\0';
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_14_analyzer_1_array_crystal_array_7_number_of_activations = 1;
#line 134886 "MACS_sample_kidney_box.c"

  SIG_MESSAGE("channel_14_analyzer_1_array_crystal_array_7 (Init:Place/Rotate)");
  rot_set_rotation(mctr1,
#line 3695 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 3695 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 3695 "MACS_sample_kidney_box.instr"
    (0 - RAD2DEG * channel_14_analyzer_1_array_theta [ 7 ])*DEG2RAD);
#line 134896 "MACS_sample_kidney_box.c"
  rot_mul(mctr1, mcrotachannel_14_analyzer_1_rotated, mcrotachannel_14_analyzer_1_array_crystal_array_7);
  rot_transpose(mcrotachannel_14_analyzer_1_array_crystal_array_6, mctr1);
  rot_mul(mcrotachannel_14_analyzer_1_array_crystal_array_7, mctr1, mcrotrchannel_14_analyzer_1_array_crystal_array_7);
  mctc1 = coords_set(
#line 3694 "MACS_sample_kidney_box.instr"
    0 + channel_14_analyzer_1_array_effective_radius_of_curvature * ( 1 - cos ( channel_14_analyzer_1_array_theta [ 7 ] ) ),
#line 3694 "MACS_sample_kidney_box.instr"
    0 + channel_14_analyzer_1_array_effective_radius_of_curvature * sin ( channel_14_analyzer_1_array_theta [ 7 ] ),
#line 3694 "MACS_sample_kidney_box.instr"
    0);
#line 134907 "MACS_sample_kidney_box.c"
  rot_transpose(mcrotachannel_14_analyzer_1_rotated, mctr1);
  mctc2 = rot_apply(mctr1, mctc1);
  mcposachannel_14_analyzer_1_array_crystal_array_7 = coords_add(mcposachannel_14_analyzer_1_rotated, mctc2);
  mctc1 = coords_sub(mcposachannel_14_analyzer_1_array_crystal_array_6, mcposachannel_14_analyzer_1_array_crystal_array_7);
  mcposrchannel_14_analyzer_1_array_crystal_array_7 = rot_apply(mcrotachannel_14_analyzer_1_array_crystal_array_7, mctc1);
  mcDEBUG_COMPONENT("channel_14_analyzer_1_array_crystal_array_7", mcposachannel_14_analyzer_1_array_crystal_array_7, mcrotachannel_14_analyzer_1_array_crystal_array_7)
  mccomp_posa[669] = mcposachannel_14_analyzer_1_array_crystal_array_7;
  mccomp_posr[669] = mcposrchannel_14_analyzer_1_array_crystal_array_7;
  mcNCounter[669]  = mcPCounter[669] = mcP2Counter[669] = 0;
  mcAbsorbProp[669]= 0;
    /* Component channel_14_analyzer_1_array_crystal_array_8. */
  /* Setting parameters for component channel_14_analyzer_1_array_crystal_array_8. */
  SIG_MESSAGE("channel_14_analyzer_1_array_crystal_array_8 (Init:SetPar)");
#line 3699 "MACS_sample_kidney_box.instr"
  if("PG_analyzer") strncpy(mccchannel_14_analyzer_1_array_crystal_array_8_material_string, "PG_analyzer" ? "PG_analyzer" : "", 16384); else mccchannel_14_analyzer_1_array_crystal_array_8_material_string[0]='\0';
#line 3699 "MACS_sample_kidney_box.instr"
  mccchannel_14_analyzer_1_array_crystal_array_8_priority = 1620.8;
#line 3698 "MACS_sample_kidney_box.instr"
  mccchannel_14_analyzer_1_array_crystal_array_8_xwidth = channel_14_analyzer_1_array_crystal_depth;
#line 3698 "MACS_sample_kidney_box.instr"
  mccchannel_14_analyzer_1_array_crystal_array_8_yheight = channel_14_analyzer_1_array_crystal_height;
#line 3698 "MACS_sample_kidney_box.instr"
  mccchannel_14_analyzer_1_array_crystal_array_8_zdepth = channel_14_analyzer_1_array_crystal_width;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_14_analyzer_1_array_crystal_array_8_xwidth2 = -1;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_14_analyzer_1_array_crystal_array_8_yheight2 = -1;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_14_analyzer_1_array_crystal_array_8_visualize = 1;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_14_analyzer_1_array_crystal_array_8_target_index = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_14_analyzer_1_array_crystal_array_8_target_x = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_14_analyzer_1_array_crystal_array_8_target_y = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_14_analyzer_1_array_crystal_array_8_target_z = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_14_analyzer_1_array_crystal_array_8_focus_aw = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_14_analyzer_1_array_crystal_array_8_focus_ah = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_14_analyzer_1_array_crystal_array_8_focus_xw = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_14_analyzer_1_array_crystal_array_8_focus_xh = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_14_analyzer_1_array_crystal_array_8_focus_r = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_14_analyzer_1_array_crystal_array_8_p_interact = 0;
#line 71 "MACS_sample_kidney_box.instr"
  if(0) strncpy(mccchannel_14_analyzer_1_array_crystal_array_8_mask_string, 0 ? 0 : "", 16384); else mccchannel_14_analyzer_1_array_crystal_array_8_mask_string[0]='\0';
#line 71 "MACS_sample_kidney_box.instr"
  if(0) strncpy(mccchannel_14_analyzer_1_array_crystal_array_8_mask_setting, 0 ? 0 : "", 16384); else mccchannel_14_analyzer_1_array_crystal_array_8_mask_setting[0]='\0';
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_14_analyzer_1_array_crystal_array_8_number_of_activations = 1;
#line 134963 "MACS_sample_kidney_box.c"

  SIG_MESSAGE("channel_14_analyzer_1_array_crystal_array_8 (Init:Place/Rotate)");
  rot_set_rotation(mctr1,
#line 3701 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 3701 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 3701 "MACS_sample_kidney_box.instr"
    (0 - RAD2DEG * channel_14_analyzer_1_array_theta [ 8 ])*DEG2RAD);
#line 134973 "MACS_sample_kidney_box.c"
  rot_mul(mctr1, mcrotachannel_14_analyzer_1_rotated, mcrotachannel_14_analyzer_1_array_crystal_array_8);
  rot_transpose(mcrotachannel_14_analyzer_1_array_crystal_array_7, mctr1);
  rot_mul(mcrotachannel_14_analyzer_1_array_crystal_array_8, mctr1, mcrotrchannel_14_analyzer_1_array_crystal_array_8);
  mctc1 = coords_set(
#line 3700 "MACS_sample_kidney_box.instr"
    0 + channel_14_analyzer_1_array_effective_radius_of_curvature * ( 1 - cos ( channel_14_analyzer_1_array_theta [ 8 ] ) ),
#line 3700 "MACS_sample_kidney_box.instr"
    0 + channel_14_analyzer_1_array_effective_radius_of_curvature * sin ( channel_14_analyzer_1_array_theta [ 8 ] ),
#line 3700 "MACS_sample_kidney_box.instr"
    0);
#line 134984 "MACS_sample_kidney_box.c"
  rot_transpose(mcrotachannel_14_analyzer_1_rotated, mctr1);
  mctc2 = rot_apply(mctr1, mctc1);
  mcposachannel_14_analyzer_1_array_crystal_array_8 = coords_add(mcposachannel_14_analyzer_1_rotated, mctc2);
  mctc1 = coords_sub(mcposachannel_14_analyzer_1_array_crystal_array_7, mcposachannel_14_analyzer_1_array_crystal_array_8);
  mcposrchannel_14_analyzer_1_array_crystal_array_8 = rot_apply(mcrotachannel_14_analyzer_1_array_crystal_array_8, mctc1);
  mcDEBUG_COMPONENT("channel_14_analyzer_1_array_crystal_array_8", mcposachannel_14_analyzer_1_array_crystal_array_8, mcrotachannel_14_analyzer_1_array_crystal_array_8)
  mccomp_posa[670] = mcposachannel_14_analyzer_1_array_crystal_array_8;
  mccomp_posr[670] = mcposrchannel_14_analyzer_1_array_crystal_array_8;
  mcNCounter[670]  = mcPCounter[670] = mcP2Counter[670] = 0;
  mcAbsorbProp[670]= 0;
    /* Component channel_14_analyzer_2_center. */
  /* Setting parameters for component channel_14_analyzer_2_center. */
  SIG_MESSAGE("channel_14_analyzer_2_center (Init:SetPar)");

  SIG_MESSAGE("channel_14_analyzer_2_center (Init:Place/Rotate)");
  rot_set_rotation(mctr1,
    (0.0)*DEG2RAD,
    (0.0)*DEG2RAD,
    (0.0)*DEG2RAD);
#line 135004 "MACS_sample_kidney_box.c"
  rot_mul(mctr1, mcrotachannel_14_analyzer_1_center, mcrotachannel_14_analyzer_2_center);
  rot_transpose(mcrotachannel_14_analyzer_1_array_crystal_array_8, mctr1);
  rot_mul(mcrotachannel_14_analyzer_2_center, mctr1, mcrotrchannel_14_analyzer_2_center);
  mctc1 = coords_set(
#line 3705 "MACS_sample_kidney_box.instr"
    - analyzer_seperation,
#line 3705 "MACS_sample_kidney_box.instr"
    0,
#line 3705 "MACS_sample_kidney_box.instr"
    0);
#line 135015 "MACS_sample_kidney_box.c"
  rot_transpose(mcrotachannel_14_analyzer_1_center, mctr1);
  mctc2 = rot_apply(mctr1, mctc1);
  mcposachannel_14_analyzer_2_center = coords_add(mcposachannel_14_analyzer_1_center, mctc2);
  mctc1 = coords_sub(mcposachannel_14_analyzer_1_array_crystal_array_8, mcposachannel_14_analyzer_2_center);
  mcposrchannel_14_analyzer_2_center = rot_apply(mcrotachannel_14_analyzer_2_center, mctc1);
  mcDEBUG_COMPONENT("channel_14_analyzer_2_center", mcposachannel_14_analyzer_2_center, mcrotachannel_14_analyzer_2_center)
  mccomp_posa[671] = mcposachannel_14_analyzer_2_center;
  mccomp_posr[671] = mcposrchannel_14_analyzer_2_center;
  mcNCounter[671]  = mcPCounter[671] = mcP2Counter[671] = 0;
  mcAbsorbProp[671]= 0;
    /* Component channel_14_analyzer_2_rotated. */
  /* Setting parameters for component channel_14_analyzer_2_rotated. */
  SIG_MESSAGE("channel_14_analyzer_2_rotated (Init:SetPar)");

  SIG_MESSAGE("channel_14_analyzer_2_rotated (Init:Place/Rotate)");
  rot_set_rotation(mctr1,
#line 3709 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 3709 "MACS_sample_kidney_box.instr"
    (- analyzer_theta [ 14 ])*DEG2RAD,
#line 3709 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD);
#line 135038 "MACS_sample_kidney_box.c"
  rot_mul(mctr1, mcrotachannel_14_analyzer_2_center, mcrotachannel_14_analyzer_2_rotated);
  rot_transpose(mcrotachannel_14_analyzer_2_center, mctr1);
  rot_mul(mcrotachannel_14_analyzer_2_rotated, mctr1, mcrotrchannel_14_analyzer_2_rotated);
  mctc1 = coords_set(
#line 3708 "MACS_sample_kidney_box.instr"
    0,
#line 3708 "MACS_sample_kidney_box.instr"
    0,
#line 3708 "MACS_sample_kidney_box.instr"
    0.5 * analyzer_seperation / tan ( analyzer_2theta [ 14 ] * DEG2RAD ));
#line 135049 "MACS_sample_kidney_box.c"
  rot_transpose(mcrotachannel_14_analyzer_2_center, mctr1);
  mctc2 = rot_apply(mctr1, mctc1);
  mcposachannel_14_analyzer_2_rotated = coords_add(mcposachannel_14_analyzer_2_center, mctc2);
  mctc1 = coords_sub(mcposachannel_14_analyzer_2_center, mcposachannel_14_analyzer_2_rotated);
  mcposrchannel_14_analyzer_2_rotated = rot_apply(mcrotachannel_14_analyzer_2_rotated, mctc1);
  mcDEBUG_COMPONENT("channel_14_analyzer_2_rotated", mcposachannel_14_analyzer_2_rotated, mcrotachannel_14_analyzer_2_rotated)
  mccomp_posa[672] = mcposachannel_14_analyzer_2_rotated;
  mccomp_posr[672] = mcposrchannel_14_analyzer_2_rotated;
  mcNCounter[672]  = mcPCounter[672] = mcP2Counter[672] = 0;
  mcAbsorbProp[672]= 0;
    /* Component channel_14_analyzer_2_array_crystal_array_0. */
  /* Setting parameters for component channel_14_analyzer_2_array_crystal_array_0. */
  SIG_MESSAGE("channel_14_analyzer_2_array_crystal_array_0 (Init:SetPar)");
#line 3713 "MACS_sample_kidney_box.instr"
  if("PG_analyzer") strncpy(mccchannel_14_analyzer_2_array_crystal_array_0_material_string, "PG_analyzer" ? "PG_analyzer" : "", 16384); else mccchannel_14_analyzer_2_array_crystal_array_0_material_string[0]='\0';
#line 3713 "MACS_sample_kidney_box.instr"
  mccchannel_14_analyzer_2_array_crystal_array_0_priority = 1621.0;
#line 3712 "MACS_sample_kidney_box.instr"
  mccchannel_14_analyzer_2_array_crystal_array_0_xwidth = channel_14_analyzer_2_array_crystal_depth;
#line 3712 "MACS_sample_kidney_box.instr"
  mccchannel_14_analyzer_2_array_crystal_array_0_yheight = channel_14_analyzer_2_array_crystal_height;
#line 3712 "MACS_sample_kidney_box.instr"
  mccchannel_14_analyzer_2_array_crystal_array_0_zdepth = channel_14_analyzer_2_array_crystal_width;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_14_analyzer_2_array_crystal_array_0_xwidth2 = -1;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_14_analyzer_2_array_crystal_array_0_yheight2 = -1;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_14_analyzer_2_array_crystal_array_0_visualize = 1;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_14_analyzer_2_array_crystal_array_0_target_index = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_14_analyzer_2_array_crystal_array_0_target_x = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_14_analyzer_2_array_crystal_array_0_target_y = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_14_analyzer_2_array_crystal_array_0_target_z = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_14_analyzer_2_array_crystal_array_0_focus_aw = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_14_analyzer_2_array_crystal_array_0_focus_ah = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_14_analyzer_2_array_crystal_array_0_focus_xw = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_14_analyzer_2_array_crystal_array_0_focus_xh = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_14_analyzer_2_array_crystal_array_0_focus_r = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_14_analyzer_2_array_crystal_array_0_p_interact = 0;
#line 71 "MACS_sample_kidney_box.instr"
  if(0) strncpy(mccchannel_14_analyzer_2_array_crystal_array_0_mask_string, 0 ? 0 : "", 16384); else mccchannel_14_analyzer_2_array_crystal_array_0_mask_string[0]='\0';
#line 71 "MACS_sample_kidney_box.instr"
  if(0) strncpy(mccchannel_14_analyzer_2_array_crystal_array_0_mask_setting, 0 ? 0 : "", 16384); else mccchannel_14_analyzer_2_array_crystal_array_0_mask_setting[0]='\0';
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_14_analyzer_2_array_crystal_array_0_number_of_activations = 1;
#line 135105 "MACS_sample_kidney_box.c"

  SIG_MESSAGE("channel_14_analyzer_2_array_crystal_array_0 (Init:Place/Rotate)");
  rot_set_rotation(mctr1,
#line 3715 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 3715 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 3715 "MACS_sample_kidney_box.instr"
    (0 - RAD2DEG * channel_14_analyzer_2_array_theta [ 0 ])*DEG2RAD);
#line 135115 "MACS_sample_kidney_box.c"
  rot_mul(mctr1, mcrotachannel_14_analyzer_2_rotated, mcrotachannel_14_analyzer_2_array_crystal_array_0);
  rot_transpose(mcrotachannel_14_analyzer_2_rotated, mctr1);
  rot_mul(mcrotachannel_14_analyzer_2_array_crystal_array_0, mctr1, mcrotrchannel_14_analyzer_2_array_crystal_array_0);
  mctc1 = coords_set(
#line 3714 "MACS_sample_kidney_box.instr"
    0 + channel_14_analyzer_2_array_effective_radius_of_curvature * ( 1 - cos ( channel_14_analyzer_2_array_theta [ 0 ] ) ),
#line 3714 "MACS_sample_kidney_box.instr"
    0 + channel_14_analyzer_2_array_effective_radius_of_curvature * sin ( channel_14_analyzer_2_array_theta [ 0 ] ),
#line 3714 "MACS_sample_kidney_box.instr"
    0);
#line 135126 "MACS_sample_kidney_box.c"
  rot_transpose(mcrotachannel_14_analyzer_2_rotated, mctr1);
  mctc2 = rot_apply(mctr1, mctc1);
  mcposachannel_14_analyzer_2_array_crystal_array_0 = coords_add(mcposachannel_14_analyzer_2_rotated, mctc2);
  mctc1 = coords_sub(mcposachannel_14_analyzer_2_rotated, mcposachannel_14_analyzer_2_array_crystal_array_0);
  mcposrchannel_14_analyzer_2_array_crystal_array_0 = rot_apply(mcrotachannel_14_analyzer_2_array_crystal_array_0, mctc1);
  mcDEBUG_COMPONENT("channel_14_analyzer_2_array_crystal_array_0", mcposachannel_14_analyzer_2_array_crystal_array_0, mcrotachannel_14_analyzer_2_array_crystal_array_0)
  mccomp_posa[673] = mcposachannel_14_analyzer_2_array_crystal_array_0;
  mccomp_posr[673] = mcposrchannel_14_analyzer_2_array_crystal_array_0;
  mcNCounter[673]  = mcPCounter[673] = mcP2Counter[673] = 0;
  mcAbsorbProp[673]= 0;
    /* Component channel_14_analyzer_2_array_crystal_array_1. */
  /* Setting parameters for component channel_14_analyzer_2_array_crystal_array_1. */
  SIG_MESSAGE("channel_14_analyzer_2_array_crystal_array_1 (Init:SetPar)");
#line 3719 "MACS_sample_kidney_box.instr"
  if("PG_analyzer") strncpy(mccchannel_14_analyzer_2_array_crystal_array_1_material_string, "PG_analyzer" ? "PG_analyzer" : "", 16384); else mccchannel_14_analyzer_2_array_crystal_array_1_material_string[0]='\0';
#line 3719 "MACS_sample_kidney_box.instr"
  mccchannel_14_analyzer_2_array_crystal_array_1_priority = 1621.1;
#line 3718 "MACS_sample_kidney_box.instr"
  mccchannel_14_analyzer_2_array_crystal_array_1_xwidth = channel_14_analyzer_2_array_crystal_depth;
#line 3718 "MACS_sample_kidney_box.instr"
  mccchannel_14_analyzer_2_array_crystal_array_1_yheight = channel_14_analyzer_2_array_crystal_height;
#line 3718 "MACS_sample_kidney_box.instr"
  mccchannel_14_analyzer_2_array_crystal_array_1_zdepth = channel_14_analyzer_2_array_crystal_width;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_14_analyzer_2_array_crystal_array_1_xwidth2 = -1;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_14_analyzer_2_array_crystal_array_1_yheight2 = -1;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_14_analyzer_2_array_crystal_array_1_visualize = 1;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_14_analyzer_2_array_crystal_array_1_target_index = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_14_analyzer_2_array_crystal_array_1_target_x = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_14_analyzer_2_array_crystal_array_1_target_y = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_14_analyzer_2_array_crystal_array_1_target_z = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_14_analyzer_2_array_crystal_array_1_focus_aw = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_14_analyzer_2_array_crystal_array_1_focus_ah = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_14_analyzer_2_array_crystal_array_1_focus_xw = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_14_analyzer_2_array_crystal_array_1_focus_xh = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_14_analyzer_2_array_crystal_array_1_focus_r = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_14_analyzer_2_array_crystal_array_1_p_interact = 0;
#line 71 "MACS_sample_kidney_box.instr"
  if(0) strncpy(mccchannel_14_analyzer_2_array_crystal_array_1_mask_string, 0 ? 0 : "", 16384); else mccchannel_14_analyzer_2_array_crystal_array_1_mask_string[0]='\0';
#line 71 "MACS_sample_kidney_box.instr"
  if(0) strncpy(mccchannel_14_analyzer_2_array_crystal_array_1_mask_setting, 0 ? 0 : "", 16384); else mccchannel_14_analyzer_2_array_crystal_array_1_mask_setting[0]='\0';
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_14_analyzer_2_array_crystal_array_1_number_of_activations = 1;
#line 135182 "MACS_sample_kidney_box.c"

  SIG_MESSAGE("channel_14_analyzer_2_array_crystal_array_1 (Init:Place/Rotate)");
  rot_set_rotation(mctr1,
#line 3721 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 3721 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 3721 "MACS_sample_kidney_box.instr"
    (0 - RAD2DEG * channel_14_analyzer_2_array_theta [ 1 ])*DEG2RAD);
#line 135192 "MACS_sample_kidney_box.c"
  rot_mul(mctr1, mcrotachannel_14_analyzer_2_rotated, mcrotachannel_14_analyzer_2_array_crystal_array_1);
  rot_transpose(mcrotachannel_14_analyzer_2_array_crystal_array_0, mctr1);
  rot_mul(mcrotachannel_14_analyzer_2_array_crystal_array_1, mctr1, mcrotrchannel_14_analyzer_2_array_crystal_array_1);
  mctc1 = coords_set(
#line 3720 "MACS_sample_kidney_box.instr"
    0 + channel_14_analyzer_2_array_effective_radius_of_curvature * ( 1 - cos ( channel_14_analyzer_2_array_theta [ 1 ] ) ),
#line 3720 "MACS_sample_kidney_box.instr"
    0 + channel_14_analyzer_2_array_effective_radius_of_curvature * sin ( channel_14_analyzer_2_array_theta [ 1 ] ),
#line 3720 "MACS_sample_kidney_box.instr"
    0);
#line 135203 "MACS_sample_kidney_box.c"
  rot_transpose(mcrotachannel_14_analyzer_2_rotated, mctr1);
  mctc2 = rot_apply(mctr1, mctc1);
  mcposachannel_14_analyzer_2_array_crystal_array_1 = coords_add(mcposachannel_14_analyzer_2_rotated, mctc2);
  mctc1 = coords_sub(mcposachannel_14_analyzer_2_array_crystal_array_0, mcposachannel_14_analyzer_2_array_crystal_array_1);
  mcposrchannel_14_analyzer_2_array_crystal_array_1 = rot_apply(mcrotachannel_14_analyzer_2_array_crystal_array_1, mctc1);
  mcDEBUG_COMPONENT("channel_14_analyzer_2_array_crystal_array_1", mcposachannel_14_analyzer_2_array_crystal_array_1, mcrotachannel_14_analyzer_2_array_crystal_array_1)
  mccomp_posa[674] = mcposachannel_14_analyzer_2_array_crystal_array_1;
  mccomp_posr[674] = mcposrchannel_14_analyzer_2_array_crystal_array_1;
  mcNCounter[674]  = mcPCounter[674] = mcP2Counter[674] = 0;
  mcAbsorbProp[674]= 0;
    /* Component channel_14_analyzer_2_array_crystal_array_2. */
  /* Setting parameters for component channel_14_analyzer_2_array_crystal_array_2. */
  SIG_MESSAGE("channel_14_analyzer_2_array_crystal_array_2 (Init:SetPar)");
#line 3725 "MACS_sample_kidney_box.instr"
  if("PG_analyzer") strncpy(mccchannel_14_analyzer_2_array_crystal_array_2_material_string, "PG_analyzer" ? "PG_analyzer" : "", 16384); else mccchannel_14_analyzer_2_array_crystal_array_2_material_string[0]='\0';
#line 3725 "MACS_sample_kidney_box.instr"
  mccchannel_14_analyzer_2_array_crystal_array_2_priority = 1621.2;
#line 3724 "MACS_sample_kidney_box.instr"
  mccchannel_14_analyzer_2_array_crystal_array_2_xwidth = channel_14_analyzer_2_array_crystal_depth;
#line 3724 "MACS_sample_kidney_box.instr"
  mccchannel_14_analyzer_2_array_crystal_array_2_yheight = channel_14_analyzer_2_array_crystal_height;
#line 3724 "MACS_sample_kidney_box.instr"
  mccchannel_14_analyzer_2_array_crystal_array_2_zdepth = channel_14_analyzer_2_array_crystal_width;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_14_analyzer_2_array_crystal_array_2_xwidth2 = -1;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_14_analyzer_2_array_crystal_array_2_yheight2 = -1;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_14_analyzer_2_array_crystal_array_2_visualize = 1;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_14_analyzer_2_array_crystal_array_2_target_index = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_14_analyzer_2_array_crystal_array_2_target_x = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_14_analyzer_2_array_crystal_array_2_target_y = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_14_analyzer_2_array_crystal_array_2_target_z = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_14_analyzer_2_array_crystal_array_2_focus_aw = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_14_analyzer_2_array_crystal_array_2_focus_ah = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_14_analyzer_2_array_crystal_array_2_focus_xw = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_14_analyzer_2_array_crystal_array_2_focus_xh = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_14_analyzer_2_array_crystal_array_2_focus_r = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_14_analyzer_2_array_crystal_array_2_p_interact = 0;
#line 71 "MACS_sample_kidney_box.instr"
  if(0) strncpy(mccchannel_14_analyzer_2_array_crystal_array_2_mask_string, 0 ? 0 : "", 16384); else mccchannel_14_analyzer_2_array_crystal_array_2_mask_string[0]='\0';
#line 71 "MACS_sample_kidney_box.instr"
  if(0) strncpy(mccchannel_14_analyzer_2_array_crystal_array_2_mask_setting, 0 ? 0 : "", 16384); else mccchannel_14_analyzer_2_array_crystal_array_2_mask_setting[0]='\0';
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_14_analyzer_2_array_crystal_array_2_number_of_activations = 1;
#line 135259 "MACS_sample_kidney_box.c"

  SIG_MESSAGE("channel_14_analyzer_2_array_crystal_array_2 (Init:Place/Rotate)");
  rot_set_rotation(mctr1,
#line 3727 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 3727 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 3727 "MACS_sample_kidney_box.instr"
    (0 - RAD2DEG * channel_14_analyzer_2_array_theta [ 2 ])*DEG2RAD);
#line 135269 "MACS_sample_kidney_box.c"
  rot_mul(mctr1, mcrotachannel_14_analyzer_2_rotated, mcrotachannel_14_analyzer_2_array_crystal_array_2);
  rot_transpose(mcrotachannel_14_analyzer_2_array_crystal_array_1, mctr1);
  rot_mul(mcrotachannel_14_analyzer_2_array_crystal_array_2, mctr1, mcrotrchannel_14_analyzer_2_array_crystal_array_2);
  mctc1 = coords_set(
#line 3726 "MACS_sample_kidney_box.instr"
    0 + channel_14_analyzer_2_array_effective_radius_of_curvature * ( 1 - cos ( channel_14_analyzer_2_array_theta [ 2 ] ) ),
#line 3726 "MACS_sample_kidney_box.instr"
    0 + channel_14_analyzer_2_array_effective_radius_of_curvature * sin ( channel_14_analyzer_2_array_theta [ 2 ] ),
#line 3726 "MACS_sample_kidney_box.instr"
    0);
#line 135280 "MACS_sample_kidney_box.c"
  rot_transpose(mcrotachannel_14_analyzer_2_rotated, mctr1);
  mctc2 = rot_apply(mctr1, mctc1);
  mcposachannel_14_analyzer_2_array_crystal_array_2 = coords_add(mcposachannel_14_analyzer_2_rotated, mctc2);
  mctc1 = coords_sub(mcposachannel_14_analyzer_2_array_crystal_array_1, mcposachannel_14_analyzer_2_array_crystal_array_2);
  mcposrchannel_14_analyzer_2_array_crystal_array_2 = rot_apply(mcrotachannel_14_analyzer_2_array_crystal_array_2, mctc1);
  mcDEBUG_COMPONENT("channel_14_analyzer_2_array_crystal_array_2", mcposachannel_14_analyzer_2_array_crystal_array_2, mcrotachannel_14_analyzer_2_array_crystal_array_2)
  mccomp_posa[675] = mcposachannel_14_analyzer_2_array_crystal_array_2;
  mccomp_posr[675] = mcposrchannel_14_analyzer_2_array_crystal_array_2;
  mcNCounter[675]  = mcPCounter[675] = mcP2Counter[675] = 0;
  mcAbsorbProp[675]= 0;
    /* Component channel_14_analyzer_2_array_crystal_array_3. */
  /* Setting parameters for component channel_14_analyzer_2_array_crystal_array_3. */
  SIG_MESSAGE("channel_14_analyzer_2_array_crystal_array_3 (Init:SetPar)");
#line 3731 "MACS_sample_kidney_box.instr"
  if("PG_analyzer") strncpy(mccchannel_14_analyzer_2_array_crystal_array_3_material_string, "PG_analyzer" ? "PG_analyzer" : "", 16384); else mccchannel_14_analyzer_2_array_crystal_array_3_material_string[0]='\0';
#line 3731 "MACS_sample_kidney_box.instr"
  mccchannel_14_analyzer_2_array_crystal_array_3_priority = 1621.3;
#line 3730 "MACS_sample_kidney_box.instr"
  mccchannel_14_analyzer_2_array_crystal_array_3_xwidth = channel_14_analyzer_2_array_crystal_depth;
#line 3730 "MACS_sample_kidney_box.instr"
  mccchannel_14_analyzer_2_array_crystal_array_3_yheight = channel_14_analyzer_2_array_crystal_height;
#line 3730 "MACS_sample_kidney_box.instr"
  mccchannel_14_analyzer_2_array_crystal_array_3_zdepth = channel_14_analyzer_2_array_crystal_width;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_14_analyzer_2_array_crystal_array_3_xwidth2 = -1;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_14_analyzer_2_array_crystal_array_3_yheight2 = -1;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_14_analyzer_2_array_crystal_array_3_visualize = 1;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_14_analyzer_2_array_crystal_array_3_target_index = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_14_analyzer_2_array_crystal_array_3_target_x = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_14_analyzer_2_array_crystal_array_3_target_y = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_14_analyzer_2_array_crystal_array_3_target_z = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_14_analyzer_2_array_crystal_array_3_focus_aw = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_14_analyzer_2_array_crystal_array_3_focus_ah = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_14_analyzer_2_array_crystal_array_3_focus_xw = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_14_analyzer_2_array_crystal_array_3_focus_xh = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_14_analyzer_2_array_crystal_array_3_focus_r = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_14_analyzer_2_array_crystal_array_3_p_interact = 0;
#line 71 "MACS_sample_kidney_box.instr"
  if(0) strncpy(mccchannel_14_analyzer_2_array_crystal_array_3_mask_string, 0 ? 0 : "", 16384); else mccchannel_14_analyzer_2_array_crystal_array_3_mask_string[0]='\0';
#line 71 "MACS_sample_kidney_box.instr"
  if(0) strncpy(mccchannel_14_analyzer_2_array_crystal_array_3_mask_setting, 0 ? 0 : "", 16384); else mccchannel_14_analyzer_2_array_crystal_array_3_mask_setting[0]='\0';
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_14_analyzer_2_array_crystal_array_3_number_of_activations = 1;
#line 135336 "MACS_sample_kidney_box.c"

  SIG_MESSAGE("channel_14_analyzer_2_array_crystal_array_3 (Init:Place/Rotate)");
  rot_set_rotation(mctr1,
#line 3733 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 3733 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 3733 "MACS_sample_kidney_box.instr"
    (0 - RAD2DEG * channel_14_analyzer_2_array_theta [ 3 ])*DEG2RAD);
#line 135346 "MACS_sample_kidney_box.c"
  rot_mul(mctr1, mcrotachannel_14_analyzer_2_rotated, mcrotachannel_14_analyzer_2_array_crystal_array_3);
  rot_transpose(mcrotachannel_14_analyzer_2_array_crystal_array_2, mctr1);
  rot_mul(mcrotachannel_14_analyzer_2_array_crystal_array_3, mctr1, mcrotrchannel_14_analyzer_2_array_crystal_array_3);
  mctc1 = coords_set(
#line 3732 "MACS_sample_kidney_box.instr"
    0 + channel_14_analyzer_2_array_effective_radius_of_curvature * ( 1 - cos ( channel_14_analyzer_2_array_theta [ 3 ] ) ),
#line 3732 "MACS_sample_kidney_box.instr"
    0 + channel_14_analyzer_2_array_effective_radius_of_curvature * sin ( channel_14_analyzer_2_array_theta [ 3 ] ),
#line 3732 "MACS_sample_kidney_box.instr"
    0);
#line 135357 "MACS_sample_kidney_box.c"
  rot_transpose(mcrotachannel_14_analyzer_2_rotated, mctr1);
  mctc2 = rot_apply(mctr1, mctc1);
  mcposachannel_14_analyzer_2_array_crystal_array_3 = coords_add(mcposachannel_14_analyzer_2_rotated, mctc2);
  mctc1 = coords_sub(mcposachannel_14_analyzer_2_array_crystal_array_2, mcposachannel_14_analyzer_2_array_crystal_array_3);
  mcposrchannel_14_analyzer_2_array_crystal_array_3 = rot_apply(mcrotachannel_14_analyzer_2_array_crystal_array_3, mctc1);
  mcDEBUG_COMPONENT("channel_14_analyzer_2_array_crystal_array_3", mcposachannel_14_analyzer_2_array_crystal_array_3, mcrotachannel_14_analyzer_2_array_crystal_array_3)
  mccomp_posa[676] = mcposachannel_14_analyzer_2_array_crystal_array_3;
  mccomp_posr[676] = mcposrchannel_14_analyzer_2_array_crystal_array_3;
  mcNCounter[676]  = mcPCounter[676] = mcP2Counter[676] = 0;
  mcAbsorbProp[676]= 0;
    /* Component channel_14_analyzer_2_array_crystal_array_4. */
  /* Setting parameters for component channel_14_analyzer_2_array_crystal_array_4. */
  SIG_MESSAGE("channel_14_analyzer_2_array_crystal_array_4 (Init:SetPar)");
#line 3737 "MACS_sample_kidney_box.instr"
  if("PG_analyzer") strncpy(mccchannel_14_analyzer_2_array_crystal_array_4_material_string, "PG_analyzer" ? "PG_analyzer" : "", 16384); else mccchannel_14_analyzer_2_array_crystal_array_4_material_string[0]='\0';
#line 3737 "MACS_sample_kidney_box.instr"
  mccchannel_14_analyzer_2_array_crystal_array_4_priority = 1621.4;
#line 3736 "MACS_sample_kidney_box.instr"
  mccchannel_14_analyzer_2_array_crystal_array_4_xwidth = channel_14_analyzer_2_array_crystal_depth;
#line 3736 "MACS_sample_kidney_box.instr"
  mccchannel_14_analyzer_2_array_crystal_array_4_yheight = channel_14_analyzer_2_array_crystal_height;
#line 3736 "MACS_sample_kidney_box.instr"
  mccchannel_14_analyzer_2_array_crystal_array_4_zdepth = channel_14_analyzer_2_array_crystal_width;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_14_analyzer_2_array_crystal_array_4_xwidth2 = -1;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_14_analyzer_2_array_crystal_array_4_yheight2 = -1;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_14_analyzer_2_array_crystal_array_4_visualize = 1;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_14_analyzer_2_array_crystal_array_4_target_index = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_14_analyzer_2_array_crystal_array_4_target_x = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_14_analyzer_2_array_crystal_array_4_target_y = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_14_analyzer_2_array_crystal_array_4_target_z = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_14_analyzer_2_array_crystal_array_4_focus_aw = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_14_analyzer_2_array_crystal_array_4_focus_ah = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_14_analyzer_2_array_crystal_array_4_focus_xw = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_14_analyzer_2_array_crystal_array_4_focus_xh = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_14_analyzer_2_array_crystal_array_4_focus_r = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_14_analyzer_2_array_crystal_array_4_p_interact = 0;
#line 71 "MACS_sample_kidney_box.instr"
  if(0) strncpy(mccchannel_14_analyzer_2_array_crystal_array_4_mask_string, 0 ? 0 : "", 16384); else mccchannel_14_analyzer_2_array_crystal_array_4_mask_string[0]='\0';
#line 71 "MACS_sample_kidney_box.instr"
  if(0) strncpy(mccchannel_14_analyzer_2_array_crystal_array_4_mask_setting, 0 ? 0 : "", 16384); else mccchannel_14_analyzer_2_array_crystal_array_4_mask_setting[0]='\0';
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_14_analyzer_2_array_crystal_array_4_number_of_activations = 1;
#line 135413 "MACS_sample_kidney_box.c"

  SIG_MESSAGE("channel_14_analyzer_2_array_crystal_array_4 (Init:Place/Rotate)");
  rot_set_rotation(mctr1,
#line 3739 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 3739 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 3739 "MACS_sample_kidney_box.instr"
    (0 - RAD2DEG * channel_14_analyzer_2_array_theta [ 4 ])*DEG2RAD);
#line 135423 "MACS_sample_kidney_box.c"
  rot_mul(mctr1, mcrotachannel_14_analyzer_2_rotated, mcrotachannel_14_analyzer_2_array_crystal_array_4);
  rot_transpose(mcrotachannel_14_analyzer_2_array_crystal_array_3, mctr1);
  rot_mul(mcrotachannel_14_analyzer_2_array_crystal_array_4, mctr1, mcrotrchannel_14_analyzer_2_array_crystal_array_4);
  mctc1 = coords_set(
#line 3738 "MACS_sample_kidney_box.instr"
    0 + channel_14_analyzer_2_array_effective_radius_of_curvature * ( 1 - cos ( channel_14_analyzer_2_array_theta [ 4 ] ) ),
#line 3738 "MACS_sample_kidney_box.instr"
    0 + channel_14_analyzer_2_array_effective_radius_of_curvature * sin ( channel_14_analyzer_2_array_theta [ 4 ] ),
#line 3738 "MACS_sample_kidney_box.instr"
    0);
#line 135434 "MACS_sample_kidney_box.c"
  rot_transpose(mcrotachannel_14_analyzer_2_rotated, mctr1);
  mctc2 = rot_apply(mctr1, mctc1);
  mcposachannel_14_analyzer_2_array_crystal_array_4 = coords_add(mcposachannel_14_analyzer_2_rotated, mctc2);
  mctc1 = coords_sub(mcposachannel_14_analyzer_2_array_crystal_array_3, mcposachannel_14_analyzer_2_array_crystal_array_4);
  mcposrchannel_14_analyzer_2_array_crystal_array_4 = rot_apply(mcrotachannel_14_analyzer_2_array_crystal_array_4, mctc1);
  mcDEBUG_COMPONENT("channel_14_analyzer_2_array_crystal_array_4", mcposachannel_14_analyzer_2_array_crystal_array_4, mcrotachannel_14_analyzer_2_array_crystal_array_4)
  mccomp_posa[677] = mcposachannel_14_analyzer_2_array_crystal_array_4;
  mccomp_posr[677] = mcposrchannel_14_analyzer_2_array_crystal_array_4;
  mcNCounter[677]  = mcPCounter[677] = mcP2Counter[677] = 0;
  mcAbsorbProp[677]= 0;
    /* Component channel_14_analyzer_2_array_crystal_array_5. */
  /* Setting parameters for component channel_14_analyzer_2_array_crystal_array_5. */
  SIG_MESSAGE("channel_14_analyzer_2_array_crystal_array_5 (Init:SetPar)");
#line 3743 "MACS_sample_kidney_box.instr"
  if("PG_analyzer") strncpy(mccchannel_14_analyzer_2_array_crystal_array_5_material_string, "PG_analyzer" ? "PG_analyzer" : "", 16384); else mccchannel_14_analyzer_2_array_crystal_array_5_material_string[0]='\0';
#line 3743 "MACS_sample_kidney_box.instr"
  mccchannel_14_analyzer_2_array_crystal_array_5_priority = 1621.5;
#line 3742 "MACS_sample_kidney_box.instr"
  mccchannel_14_analyzer_2_array_crystal_array_5_xwidth = channel_14_analyzer_2_array_crystal_depth;
#line 3742 "MACS_sample_kidney_box.instr"
  mccchannel_14_analyzer_2_array_crystal_array_5_yheight = channel_14_analyzer_2_array_crystal_height;
#line 3742 "MACS_sample_kidney_box.instr"
  mccchannel_14_analyzer_2_array_crystal_array_5_zdepth = channel_14_analyzer_2_array_crystal_width;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_14_analyzer_2_array_crystal_array_5_xwidth2 = -1;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_14_analyzer_2_array_crystal_array_5_yheight2 = -1;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_14_analyzer_2_array_crystal_array_5_visualize = 1;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_14_analyzer_2_array_crystal_array_5_target_index = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_14_analyzer_2_array_crystal_array_5_target_x = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_14_analyzer_2_array_crystal_array_5_target_y = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_14_analyzer_2_array_crystal_array_5_target_z = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_14_analyzer_2_array_crystal_array_5_focus_aw = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_14_analyzer_2_array_crystal_array_5_focus_ah = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_14_analyzer_2_array_crystal_array_5_focus_xw = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_14_analyzer_2_array_crystal_array_5_focus_xh = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_14_analyzer_2_array_crystal_array_5_focus_r = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_14_analyzer_2_array_crystal_array_5_p_interact = 0;
#line 71 "MACS_sample_kidney_box.instr"
  if(0) strncpy(mccchannel_14_analyzer_2_array_crystal_array_5_mask_string, 0 ? 0 : "", 16384); else mccchannel_14_analyzer_2_array_crystal_array_5_mask_string[0]='\0';
#line 71 "MACS_sample_kidney_box.instr"
  if(0) strncpy(mccchannel_14_analyzer_2_array_crystal_array_5_mask_setting, 0 ? 0 : "", 16384); else mccchannel_14_analyzer_2_array_crystal_array_5_mask_setting[0]='\0';
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_14_analyzer_2_array_crystal_array_5_number_of_activations = 1;
#line 135490 "MACS_sample_kidney_box.c"

  SIG_MESSAGE("channel_14_analyzer_2_array_crystal_array_5 (Init:Place/Rotate)");
  rot_set_rotation(mctr1,
#line 3745 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 3745 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 3745 "MACS_sample_kidney_box.instr"
    (0 - RAD2DEG * channel_14_analyzer_2_array_theta [ 5 ])*DEG2RAD);
#line 135500 "MACS_sample_kidney_box.c"
  rot_mul(mctr1, mcrotachannel_14_analyzer_2_rotated, mcrotachannel_14_analyzer_2_array_crystal_array_5);
  rot_transpose(mcrotachannel_14_analyzer_2_array_crystal_array_4, mctr1);
  rot_mul(mcrotachannel_14_analyzer_2_array_crystal_array_5, mctr1, mcrotrchannel_14_analyzer_2_array_crystal_array_5);
  mctc1 = coords_set(
#line 3744 "MACS_sample_kidney_box.instr"
    0 + channel_14_analyzer_2_array_effective_radius_of_curvature * ( 1 - cos ( channel_14_analyzer_2_array_theta [ 5 ] ) ),
#line 3744 "MACS_sample_kidney_box.instr"
    0 + channel_14_analyzer_2_array_effective_radius_of_curvature * sin ( channel_14_analyzer_2_array_theta [ 5 ] ),
#line 3744 "MACS_sample_kidney_box.instr"
    0);
#line 135511 "MACS_sample_kidney_box.c"
  rot_transpose(mcrotachannel_14_analyzer_2_rotated, mctr1);
  mctc2 = rot_apply(mctr1, mctc1);
  mcposachannel_14_analyzer_2_array_crystal_array_5 = coords_add(mcposachannel_14_analyzer_2_rotated, mctc2);
  mctc1 = coords_sub(mcposachannel_14_analyzer_2_array_crystal_array_4, mcposachannel_14_analyzer_2_array_crystal_array_5);
  mcposrchannel_14_analyzer_2_array_crystal_array_5 = rot_apply(mcrotachannel_14_analyzer_2_array_crystal_array_5, mctc1);
  mcDEBUG_COMPONENT("channel_14_analyzer_2_array_crystal_array_5", mcposachannel_14_analyzer_2_array_crystal_array_5, mcrotachannel_14_analyzer_2_array_crystal_array_5)
  mccomp_posa[678] = mcposachannel_14_analyzer_2_array_crystal_array_5;
  mccomp_posr[678] = mcposrchannel_14_analyzer_2_array_crystal_array_5;
  mcNCounter[678]  = mcPCounter[678] = mcP2Counter[678] = 0;
  mcAbsorbProp[678]= 0;
    /* Component channel_14_analyzer_2_array_crystal_array_6. */
  /* Setting parameters for component channel_14_analyzer_2_array_crystal_array_6. */
  SIG_MESSAGE("channel_14_analyzer_2_array_crystal_array_6 (Init:SetPar)");
#line 3749 "MACS_sample_kidney_box.instr"
  if("PG_analyzer") strncpy(mccchannel_14_analyzer_2_array_crystal_array_6_material_string, "PG_analyzer" ? "PG_analyzer" : "", 16384); else mccchannel_14_analyzer_2_array_crystal_array_6_material_string[0]='\0';
#line 3749 "MACS_sample_kidney_box.instr"
  mccchannel_14_analyzer_2_array_crystal_array_6_priority = 1621.6;
#line 3748 "MACS_sample_kidney_box.instr"
  mccchannel_14_analyzer_2_array_crystal_array_6_xwidth = channel_14_analyzer_2_array_crystal_depth;
#line 3748 "MACS_sample_kidney_box.instr"
  mccchannel_14_analyzer_2_array_crystal_array_6_yheight = channel_14_analyzer_2_array_crystal_height;
#line 3748 "MACS_sample_kidney_box.instr"
  mccchannel_14_analyzer_2_array_crystal_array_6_zdepth = channel_14_analyzer_2_array_crystal_width;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_14_analyzer_2_array_crystal_array_6_xwidth2 = -1;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_14_analyzer_2_array_crystal_array_6_yheight2 = -1;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_14_analyzer_2_array_crystal_array_6_visualize = 1;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_14_analyzer_2_array_crystal_array_6_target_index = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_14_analyzer_2_array_crystal_array_6_target_x = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_14_analyzer_2_array_crystal_array_6_target_y = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_14_analyzer_2_array_crystal_array_6_target_z = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_14_analyzer_2_array_crystal_array_6_focus_aw = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_14_analyzer_2_array_crystal_array_6_focus_ah = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_14_analyzer_2_array_crystal_array_6_focus_xw = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_14_analyzer_2_array_crystal_array_6_focus_xh = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_14_analyzer_2_array_crystal_array_6_focus_r = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_14_analyzer_2_array_crystal_array_6_p_interact = 0;
#line 71 "MACS_sample_kidney_box.instr"
  if(0) strncpy(mccchannel_14_analyzer_2_array_crystal_array_6_mask_string, 0 ? 0 : "", 16384); else mccchannel_14_analyzer_2_array_crystal_array_6_mask_string[0]='\0';
#line 71 "MACS_sample_kidney_box.instr"
  if(0) strncpy(mccchannel_14_analyzer_2_array_crystal_array_6_mask_setting, 0 ? 0 : "", 16384); else mccchannel_14_analyzer_2_array_crystal_array_6_mask_setting[0]='\0';
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_14_analyzer_2_array_crystal_array_6_number_of_activations = 1;
#line 135567 "MACS_sample_kidney_box.c"

  SIG_MESSAGE("channel_14_analyzer_2_array_crystal_array_6 (Init:Place/Rotate)");
  rot_set_rotation(mctr1,
#line 3751 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 3751 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 3751 "MACS_sample_kidney_box.instr"
    (0 - RAD2DEG * channel_14_analyzer_2_array_theta [ 6 ])*DEG2RAD);
#line 135577 "MACS_sample_kidney_box.c"
  rot_mul(mctr1, mcrotachannel_14_analyzer_2_rotated, mcrotachannel_14_analyzer_2_array_crystal_array_6);
  rot_transpose(mcrotachannel_14_analyzer_2_array_crystal_array_5, mctr1);
  rot_mul(mcrotachannel_14_analyzer_2_array_crystal_array_6, mctr1, mcrotrchannel_14_analyzer_2_array_crystal_array_6);
  mctc1 = coords_set(
#line 3750 "MACS_sample_kidney_box.instr"
    0 + channel_14_analyzer_2_array_effective_radius_of_curvature * ( 1 - cos ( channel_14_analyzer_2_array_theta [ 6 ] ) ),
#line 3750 "MACS_sample_kidney_box.instr"
    0 + channel_14_analyzer_2_array_effective_radius_of_curvature * sin ( channel_14_analyzer_2_array_theta [ 6 ] ),
#line 3750 "MACS_sample_kidney_box.instr"
    0);
#line 135588 "MACS_sample_kidney_box.c"
  rot_transpose(mcrotachannel_14_analyzer_2_rotated, mctr1);
  mctc2 = rot_apply(mctr1, mctc1);
  mcposachannel_14_analyzer_2_array_crystal_array_6 = coords_add(mcposachannel_14_analyzer_2_rotated, mctc2);
  mctc1 = coords_sub(mcposachannel_14_analyzer_2_array_crystal_array_5, mcposachannel_14_analyzer_2_array_crystal_array_6);
  mcposrchannel_14_analyzer_2_array_crystal_array_6 = rot_apply(mcrotachannel_14_analyzer_2_array_crystal_array_6, mctc1);
  mcDEBUG_COMPONENT("channel_14_analyzer_2_array_crystal_array_6", mcposachannel_14_analyzer_2_array_crystal_array_6, mcrotachannel_14_analyzer_2_array_crystal_array_6)
  mccomp_posa[679] = mcposachannel_14_analyzer_2_array_crystal_array_6;
  mccomp_posr[679] = mcposrchannel_14_analyzer_2_array_crystal_array_6;
  mcNCounter[679]  = mcPCounter[679] = mcP2Counter[679] = 0;
  mcAbsorbProp[679]= 0;
    /* Component channel_14_analyzer_2_array_crystal_array_7. */
  /* Setting parameters for component channel_14_analyzer_2_array_crystal_array_7. */
  SIG_MESSAGE("channel_14_analyzer_2_array_crystal_array_7 (Init:SetPar)");
#line 3755 "MACS_sample_kidney_box.instr"
  if("PG_analyzer") strncpy(mccchannel_14_analyzer_2_array_crystal_array_7_material_string, "PG_analyzer" ? "PG_analyzer" : "", 16384); else mccchannel_14_analyzer_2_array_crystal_array_7_material_string[0]='\0';
#line 3755 "MACS_sample_kidney_box.instr"
  mccchannel_14_analyzer_2_array_crystal_array_7_priority = 1621.7;
#line 3754 "MACS_sample_kidney_box.instr"
  mccchannel_14_analyzer_2_array_crystal_array_7_xwidth = channel_14_analyzer_2_array_crystal_depth;
#line 3754 "MACS_sample_kidney_box.instr"
  mccchannel_14_analyzer_2_array_crystal_array_7_yheight = channel_14_analyzer_2_array_crystal_height;
#line 3754 "MACS_sample_kidney_box.instr"
  mccchannel_14_analyzer_2_array_crystal_array_7_zdepth = channel_14_analyzer_2_array_crystal_width;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_14_analyzer_2_array_crystal_array_7_xwidth2 = -1;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_14_analyzer_2_array_crystal_array_7_yheight2 = -1;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_14_analyzer_2_array_crystal_array_7_visualize = 1;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_14_analyzer_2_array_crystal_array_7_target_index = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_14_analyzer_2_array_crystal_array_7_target_x = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_14_analyzer_2_array_crystal_array_7_target_y = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_14_analyzer_2_array_crystal_array_7_target_z = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_14_analyzer_2_array_crystal_array_7_focus_aw = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_14_analyzer_2_array_crystal_array_7_focus_ah = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_14_analyzer_2_array_crystal_array_7_focus_xw = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_14_analyzer_2_array_crystal_array_7_focus_xh = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_14_analyzer_2_array_crystal_array_7_focus_r = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_14_analyzer_2_array_crystal_array_7_p_interact = 0;
#line 71 "MACS_sample_kidney_box.instr"
  if(0) strncpy(mccchannel_14_analyzer_2_array_crystal_array_7_mask_string, 0 ? 0 : "", 16384); else mccchannel_14_analyzer_2_array_crystal_array_7_mask_string[0]='\0';
#line 71 "MACS_sample_kidney_box.instr"
  if(0) strncpy(mccchannel_14_analyzer_2_array_crystal_array_7_mask_setting, 0 ? 0 : "", 16384); else mccchannel_14_analyzer_2_array_crystal_array_7_mask_setting[0]='\0';
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_14_analyzer_2_array_crystal_array_7_number_of_activations = 1;
#line 135644 "MACS_sample_kidney_box.c"

  SIG_MESSAGE("channel_14_analyzer_2_array_crystal_array_7 (Init:Place/Rotate)");
  rot_set_rotation(mctr1,
#line 3757 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 3757 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 3757 "MACS_sample_kidney_box.instr"
    (0 - RAD2DEG * channel_14_analyzer_2_array_theta [ 7 ])*DEG2RAD);
#line 135654 "MACS_sample_kidney_box.c"
  rot_mul(mctr1, mcrotachannel_14_analyzer_2_rotated, mcrotachannel_14_analyzer_2_array_crystal_array_7);
  rot_transpose(mcrotachannel_14_analyzer_2_array_crystal_array_6, mctr1);
  rot_mul(mcrotachannel_14_analyzer_2_array_crystal_array_7, mctr1, mcrotrchannel_14_analyzer_2_array_crystal_array_7);
  mctc1 = coords_set(
#line 3756 "MACS_sample_kidney_box.instr"
    0 + channel_14_analyzer_2_array_effective_radius_of_curvature * ( 1 - cos ( channel_14_analyzer_2_array_theta [ 7 ] ) ),
#line 3756 "MACS_sample_kidney_box.instr"
    0 + channel_14_analyzer_2_array_effective_radius_of_curvature * sin ( channel_14_analyzer_2_array_theta [ 7 ] ),
#line 3756 "MACS_sample_kidney_box.instr"
    0);
#line 135665 "MACS_sample_kidney_box.c"
  rot_transpose(mcrotachannel_14_analyzer_2_rotated, mctr1);
  mctc2 = rot_apply(mctr1, mctc1);
  mcposachannel_14_analyzer_2_array_crystal_array_7 = coords_add(mcposachannel_14_analyzer_2_rotated, mctc2);
  mctc1 = coords_sub(mcposachannel_14_analyzer_2_array_crystal_array_6, mcposachannel_14_analyzer_2_array_crystal_array_7);
  mcposrchannel_14_analyzer_2_array_crystal_array_7 = rot_apply(mcrotachannel_14_analyzer_2_array_crystal_array_7, mctc1);
  mcDEBUG_COMPONENT("channel_14_analyzer_2_array_crystal_array_7", mcposachannel_14_analyzer_2_array_crystal_array_7, mcrotachannel_14_analyzer_2_array_crystal_array_7)
  mccomp_posa[680] = mcposachannel_14_analyzer_2_array_crystal_array_7;
  mccomp_posr[680] = mcposrchannel_14_analyzer_2_array_crystal_array_7;
  mcNCounter[680]  = mcPCounter[680] = mcP2Counter[680] = 0;
  mcAbsorbProp[680]= 0;
    /* Component channel_14_analyzer_2_array_crystal_array_8. */
  /* Setting parameters for component channel_14_analyzer_2_array_crystal_array_8. */
  SIG_MESSAGE("channel_14_analyzer_2_array_crystal_array_8 (Init:SetPar)");
#line 3761 "MACS_sample_kidney_box.instr"
  if("PG_analyzer") strncpy(mccchannel_14_analyzer_2_array_crystal_array_8_material_string, "PG_analyzer" ? "PG_analyzer" : "", 16384); else mccchannel_14_analyzer_2_array_crystal_array_8_material_string[0]='\0';
#line 3761 "MACS_sample_kidney_box.instr"
  mccchannel_14_analyzer_2_array_crystal_array_8_priority = 1621.8;
#line 3760 "MACS_sample_kidney_box.instr"
  mccchannel_14_analyzer_2_array_crystal_array_8_xwidth = channel_14_analyzer_2_array_crystal_depth;
#line 3760 "MACS_sample_kidney_box.instr"
  mccchannel_14_analyzer_2_array_crystal_array_8_yheight = channel_14_analyzer_2_array_crystal_height;
#line 3760 "MACS_sample_kidney_box.instr"
  mccchannel_14_analyzer_2_array_crystal_array_8_zdepth = channel_14_analyzer_2_array_crystal_width;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_14_analyzer_2_array_crystal_array_8_xwidth2 = -1;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_14_analyzer_2_array_crystal_array_8_yheight2 = -1;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_14_analyzer_2_array_crystal_array_8_visualize = 1;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_14_analyzer_2_array_crystal_array_8_target_index = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_14_analyzer_2_array_crystal_array_8_target_x = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_14_analyzer_2_array_crystal_array_8_target_y = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_14_analyzer_2_array_crystal_array_8_target_z = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_14_analyzer_2_array_crystal_array_8_focus_aw = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_14_analyzer_2_array_crystal_array_8_focus_ah = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_14_analyzer_2_array_crystal_array_8_focus_xw = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_14_analyzer_2_array_crystal_array_8_focus_xh = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_14_analyzer_2_array_crystal_array_8_focus_r = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_14_analyzer_2_array_crystal_array_8_p_interact = 0;
#line 71 "MACS_sample_kidney_box.instr"
  if(0) strncpy(mccchannel_14_analyzer_2_array_crystal_array_8_mask_string, 0 ? 0 : "", 16384); else mccchannel_14_analyzer_2_array_crystal_array_8_mask_string[0]='\0';
#line 71 "MACS_sample_kidney_box.instr"
  if(0) strncpy(mccchannel_14_analyzer_2_array_crystal_array_8_mask_setting, 0 ? 0 : "", 16384); else mccchannel_14_analyzer_2_array_crystal_array_8_mask_setting[0]='\0';
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_14_analyzer_2_array_crystal_array_8_number_of_activations = 1;
#line 135721 "MACS_sample_kidney_box.c"

  SIG_MESSAGE("channel_14_analyzer_2_array_crystal_array_8 (Init:Place/Rotate)");
  rot_set_rotation(mctr1,
#line 3763 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 3763 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 3763 "MACS_sample_kidney_box.instr"
    (0 - RAD2DEG * channel_14_analyzer_2_array_theta [ 8 ])*DEG2RAD);
#line 135731 "MACS_sample_kidney_box.c"
  rot_mul(mctr1, mcrotachannel_14_analyzer_2_rotated, mcrotachannel_14_analyzer_2_array_crystal_array_8);
  rot_transpose(mcrotachannel_14_analyzer_2_array_crystal_array_7, mctr1);
  rot_mul(mcrotachannel_14_analyzer_2_array_crystal_array_8, mctr1, mcrotrchannel_14_analyzer_2_array_crystal_array_8);
  mctc1 = coords_set(
#line 3762 "MACS_sample_kidney_box.instr"
    0 + channel_14_analyzer_2_array_effective_radius_of_curvature * ( 1 - cos ( channel_14_analyzer_2_array_theta [ 8 ] ) ),
#line 3762 "MACS_sample_kidney_box.instr"
    0 + channel_14_analyzer_2_array_effective_radius_of_curvature * sin ( channel_14_analyzer_2_array_theta [ 8 ] ),
#line 3762 "MACS_sample_kidney_box.instr"
    0);
#line 135742 "MACS_sample_kidney_box.c"
  rot_transpose(mcrotachannel_14_analyzer_2_rotated, mctr1);
  mctc2 = rot_apply(mctr1, mctc1);
  mcposachannel_14_analyzer_2_array_crystal_array_8 = coords_add(mcposachannel_14_analyzer_2_rotated, mctc2);
  mctc1 = coords_sub(mcposachannel_14_analyzer_2_array_crystal_array_7, mcposachannel_14_analyzer_2_array_crystal_array_8);
  mcposrchannel_14_analyzer_2_array_crystal_array_8 = rot_apply(mcrotachannel_14_analyzer_2_array_crystal_array_8, mctc1);
  mcDEBUG_COMPONENT("channel_14_analyzer_2_array_crystal_array_8", mcposachannel_14_analyzer_2_array_crystal_array_8, mcrotachannel_14_analyzer_2_array_crystal_array_8)
  mccomp_posa[681] = mcposachannel_14_analyzer_2_array_crystal_array_8;
  mccomp_posr[681] = mcposrchannel_14_analyzer_2_array_crystal_array_8;
  mcNCounter[681]  = mcPCounter[681] = mcP2Counter[681] = 0;
  mcAbsorbProp[681]= 0;
    /* Component channel_14_cave2_cyl1. */
  /* Setting parameters for component channel_14_cave2_cyl1. */
  SIG_MESSAGE("channel_14_cave2_cyl1 (Init:SetPar)");
#line 3768 "MACS_sample_kidney_box.instr"
  if("Vacuum") strncpy(mccchannel_14_cave2_cyl1_material_string, "Vacuum" ? "Vacuum" : "", 16384); else mccchannel_14_cave2_cyl1_material_string[0]='\0';
#line 3768 "MACS_sample_kidney_box.instr"
  mccchannel_14_cave2_cyl1_priority = 1607.5;
#line 3767 "MACS_sample_kidney_box.instr"
  mccchannel_14_cave2_cyl1_radius = kidney_cave2_cyl1_radius;
#line 3767 "MACS_sample_kidney_box.instr"
  mccchannel_14_cave2_cyl1_yheight = kidney_cave2_cyl1_height;
#line 67 "MACS_sample_kidney_box.instr"
  mccchannel_14_cave2_cyl1_visualize = 1;
#line 67 "MACS_sample_kidney_box.instr"
  mccchannel_14_cave2_cyl1_target_index = 0;
#line 67 "MACS_sample_kidney_box.instr"
  mccchannel_14_cave2_cyl1_target_x = 0;
#line 67 "MACS_sample_kidney_box.instr"
  mccchannel_14_cave2_cyl1_target_y = 0;
#line 67 "MACS_sample_kidney_box.instr"
  mccchannel_14_cave2_cyl1_target_z = 0;
#line 67 "MACS_sample_kidney_box.instr"
  mccchannel_14_cave2_cyl1_focus_aw = 0;
#line 67 "MACS_sample_kidney_box.instr"
  mccchannel_14_cave2_cyl1_focus_ah = 0;
#line 67 "MACS_sample_kidney_box.instr"
  mccchannel_14_cave2_cyl1_focus_xw = 0;
#line 67 "MACS_sample_kidney_box.instr"
  mccchannel_14_cave2_cyl1_focus_xh = 0;
#line 67 "MACS_sample_kidney_box.instr"
  mccchannel_14_cave2_cyl1_focus_r = 0;
#line 67 "MACS_sample_kidney_box.instr"
  mccchannel_14_cave2_cyl1_p_interact = 0;
#line 67 "MACS_sample_kidney_box.instr"
  if(0) strncpy(mccchannel_14_cave2_cyl1_mask_string, 0 ? 0 : "", 16384); else mccchannel_14_cave2_cyl1_mask_string[0]='\0';
#line 67 "MACS_sample_kidney_box.instr"
  if(0) strncpy(mccchannel_14_cave2_cyl1_mask_setting, 0 ? 0 : "", 16384); else mccchannel_14_cave2_cyl1_mask_setting[0]='\0';
#line 67 "MACS_sample_kidney_box.instr"
  mccchannel_14_cave2_cyl1_number_of_activations = 1;
#line 135792 "MACS_sample_kidney_box.c"

  SIG_MESSAGE("channel_14_cave2_cyl1 (Init:Place/Rotate)");
  rot_set_rotation(mctr1,
#line 3770 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 3770 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 3770 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD);
#line 135802 "MACS_sample_kidney_box.c"
  rot_mul(mctr1, mcrotachannel_14_analyzer_2_center, mcrotachannel_14_cave2_cyl1);
  rot_transpose(mcrotachannel_14_analyzer_2_array_crystal_array_8, mctr1);
  rot_mul(mcrotachannel_14_cave2_cyl1, mctr1, mcrotrchannel_14_cave2_cyl1);
  mctc1 = coords_set(
#line 3769 "MACS_sample_kidney_box.instr"
    0,
#line 3769 "MACS_sample_kidney_box.instr"
    0,
#line 3769 "MACS_sample_kidney_box.instr"
    spec_detector_to_analyzer_2_center);
#line 135813 "MACS_sample_kidney_box.c"
  rot_transpose(mcrotachannel_14_analyzer_2_center, mctr1);
  mctc2 = rot_apply(mctr1, mctc1);
  mcposachannel_14_cave2_cyl1 = coords_add(mcposachannel_14_analyzer_2_center, mctc2);
  mctc1 = coords_sub(mcposachannel_14_analyzer_2_array_crystal_array_8, mcposachannel_14_cave2_cyl1);
  mcposrchannel_14_cave2_cyl1 = rot_apply(mcrotachannel_14_cave2_cyl1, mctc1);
  mcDEBUG_COMPONENT("channel_14_cave2_cyl1", mcposachannel_14_cave2_cyl1, mcrotachannel_14_cave2_cyl1)
  mccomp_posa[682] = mcposachannel_14_cave2_cyl1;
  mccomp_posr[682] = mcposrchannel_14_cave2_cyl1;
  mcNCounter[682]  = mcPCounter[682] = mcP2Counter[682] = 0;
  mcAbsorbProp[682]= 0;
    /* Component channel_14_cave2_box1. */
  /* Setting parameters for component channel_14_cave2_box1. */
  SIG_MESSAGE("channel_14_cave2_box1 (Init:SetPar)");
#line 3775 "MACS_sample_kidney_box.instr"
  if("Vacuum") strncpy(mccchannel_14_cave2_box1_material_string, "Vacuum" ? "Vacuum" : "", 16384); else mccchannel_14_cave2_box1_material_string[0]='\0';
#line 3775 "MACS_sample_kidney_box.instr"
  mccchannel_14_cave2_box1_priority = 1601;
#line 3773 "MACS_sample_kidney_box.instr"
  mccchannel_14_cave2_box1_xwidth = kidney_cave2_box1_width1;
#line 3773 "MACS_sample_kidney_box.instr"
  mccchannel_14_cave2_box1_yheight = kidney_cave2_box1_height1;
#line 3773 "MACS_sample_kidney_box.instr"
  mccchannel_14_cave2_box1_zdepth = kidney_cave2_box1_depth;
#line 3774 "MACS_sample_kidney_box.instr"
  mccchannel_14_cave2_box1_xwidth2 = kidney_cave2_box1_width2;
#line 3774 "MACS_sample_kidney_box.instr"
  mccchannel_14_cave2_box1_yheight2 = kidney_cave2_box1_height2;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_14_cave2_box1_visualize = 1;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_14_cave2_box1_target_index = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_14_cave2_box1_target_x = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_14_cave2_box1_target_y = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_14_cave2_box1_target_z = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_14_cave2_box1_focus_aw = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_14_cave2_box1_focus_ah = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_14_cave2_box1_focus_xw = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_14_cave2_box1_focus_xh = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_14_cave2_box1_focus_r = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_14_cave2_box1_p_interact = 0;
#line 71 "MACS_sample_kidney_box.instr"
  if(0) strncpy(mccchannel_14_cave2_box1_mask_string, 0 ? 0 : "", 16384); else mccchannel_14_cave2_box1_mask_string[0]='\0';
#line 71 "MACS_sample_kidney_box.instr"
  if(0) strncpy(mccchannel_14_cave2_box1_mask_setting, 0 ? 0 : "", 16384); else mccchannel_14_cave2_box1_mask_setting[0]='\0';
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_14_cave2_box1_number_of_activations = 1;
#line 135869 "MACS_sample_kidney_box.c"

  SIG_MESSAGE("channel_14_cave2_box1 (Init:Place/Rotate)");
  rot_set_rotation(mctr1,
#line 3777 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 3777 "MACS_sample_kidney_box.instr"
    (kidney_cave2_box1_y_rotation)*DEG2RAD,
#line 3777 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD);
#line 135879 "MACS_sample_kidney_box.c"
  rot_mul(mctr1, mcrotachannel_14_cave2_cyl1, mcrotachannel_14_cave2_box1);
  rot_transpose(mcrotachannel_14_cave2_cyl1, mctr1);
  rot_mul(mcrotachannel_14_cave2_box1, mctr1, mcrotrchannel_14_cave2_box1);
  mctc1 = coords_set(
#line 3776 "MACS_sample_kidney_box.instr"
    kidney_cave2_box1_center_to_spec_detector_x,
#line 3776 "MACS_sample_kidney_box.instr"
    0,
#line 3776 "MACS_sample_kidney_box.instr"
    kidney_cave2_box1_center_to_spec_detector_z);
#line 135890 "MACS_sample_kidney_box.c"
  rot_transpose(mcrotachannel_14_cave2_cyl1, mctr1);
  mctc2 = rot_apply(mctr1, mctc1);
  mcposachannel_14_cave2_box1 = coords_add(mcposachannel_14_cave2_cyl1, mctc2);
  mctc1 = coords_sub(mcposachannel_14_cave2_cyl1, mcposachannel_14_cave2_box1);
  mcposrchannel_14_cave2_box1 = rot_apply(mcrotachannel_14_cave2_box1, mctc1);
  mcDEBUG_COMPONENT("channel_14_cave2_box1", mcposachannel_14_cave2_box1, mcrotachannel_14_cave2_box1)
  mccomp_posa[683] = mcposachannel_14_cave2_box1;
  mccomp_posr[683] = mcposrchannel_14_cave2_box1;
  mcNCounter[683]  = mcPCounter[683] = mcP2Counter[683] = 0;
  mcAbsorbProp[683]= 0;
    /* Component channel_14_cave2_box2. */
  /* Setting parameters for component channel_14_cave2_box2. */
  SIG_MESSAGE("channel_14_cave2_box2 (Init:SetPar)");
#line 3782 "MACS_sample_kidney_box.instr"
  if("Vacuum") strncpy(mccchannel_14_cave2_box2_material_string, "Vacuum" ? "Vacuum" : "", 16384); else mccchannel_14_cave2_box2_material_string[0]='\0';
#line 3782 "MACS_sample_kidney_box.instr"
  mccchannel_14_cave2_box2_priority = 1606;
#line 3780 "MACS_sample_kidney_box.instr"
  mccchannel_14_cave2_box2_xwidth = kidney_cave2_box2_width1;
#line 3780 "MACS_sample_kidney_box.instr"
  mccchannel_14_cave2_box2_yheight = kidney_cave2_box2_height1;
#line 3780 "MACS_sample_kidney_box.instr"
  mccchannel_14_cave2_box2_zdepth = kidney_cave2_box2_depth;
#line 3781 "MACS_sample_kidney_box.instr"
  mccchannel_14_cave2_box2_xwidth2 = kidney_cave2_box2_width2;
#line 3781 "MACS_sample_kidney_box.instr"
  mccchannel_14_cave2_box2_yheight2 = kidney_cave2_box2_height2;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_14_cave2_box2_visualize = 1;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_14_cave2_box2_target_index = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_14_cave2_box2_target_x = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_14_cave2_box2_target_y = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_14_cave2_box2_target_z = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_14_cave2_box2_focus_aw = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_14_cave2_box2_focus_ah = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_14_cave2_box2_focus_xw = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_14_cave2_box2_focus_xh = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_14_cave2_box2_focus_r = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_14_cave2_box2_p_interact = 0;
#line 71 "MACS_sample_kidney_box.instr"
  if(0) strncpy(mccchannel_14_cave2_box2_mask_string, 0 ? 0 : "", 16384); else mccchannel_14_cave2_box2_mask_string[0]='\0';
#line 71 "MACS_sample_kidney_box.instr"
  if(0) strncpy(mccchannel_14_cave2_box2_mask_setting, 0 ? 0 : "", 16384); else mccchannel_14_cave2_box2_mask_setting[0]='\0';
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_14_cave2_box2_number_of_activations = 1;
#line 135946 "MACS_sample_kidney_box.c"

  SIG_MESSAGE("channel_14_cave2_box2 (Init:Place/Rotate)");
  rot_set_rotation(mctr1,
#line 3784 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 3784 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 3784 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD);
#line 135956 "MACS_sample_kidney_box.c"
  rot_mul(mctr1, mcrotachannel_14_cave2_cyl1, mcrotachannel_14_cave2_box2);
  rot_transpose(mcrotachannel_14_cave2_box1, mctr1);
  rot_mul(mcrotachannel_14_cave2_box2, mctr1, mcrotrchannel_14_cave2_box2);
  mctc1 = coords_set(
#line 3783 "MACS_sample_kidney_box.instr"
    0,
#line 3783 "MACS_sample_kidney_box.instr"
    0,
#line 3783 "MACS_sample_kidney_box.instr"
    kidney_cave2_box2_center_to_detector);
#line 135967 "MACS_sample_kidney_box.c"
  rot_transpose(mcrotachannel_14_cave2_cyl1, mctr1);
  mctc2 = rot_apply(mctr1, mctc1);
  mcposachannel_14_cave2_box2 = coords_add(mcposachannel_14_cave2_cyl1, mctc2);
  mctc1 = coords_sub(mcposachannel_14_cave2_box1, mcposachannel_14_cave2_box2);
  mcposrchannel_14_cave2_box2 = rot_apply(mcrotachannel_14_cave2_box2, mctc1);
  mcDEBUG_COMPONENT("channel_14_cave2_box2", mcposachannel_14_cave2_box2, mcrotachannel_14_cave2_box2)
  mccomp_posa[684] = mcposachannel_14_cave2_box2;
  mccomp_posr[684] = mcposrchannel_14_cave2_box2;
  mcNCounter[684]  = mcPCounter[684] = mcP2Counter[684] = 0;
  mcAbsorbProp[684]= 0;
    /* Component channel_14_cave2_box3. */
  /* Setting parameters for component channel_14_cave2_box3. */
  SIG_MESSAGE("channel_14_cave2_box3 (Init:SetPar)");
#line 3789 "MACS_sample_kidney_box.instr"
  if("Vacuum") strncpy(mccchannel_14_cave2_box3_material_string, "Vacuum" ? "Vacuum" : "", 16384); else mccchannel_14_cave2_box3_material_string[0]='\0';
#line 3789 "MACS_sample_kidney_box.instr"
  mccchannel_14_cave2_box3_priority = 1607;
#line 3787 "MACS_sample_kidney_box.instr"
  mccchannel_14_cave2_box3_xwidth = kidney_cave2_box3_width1;
#line 3787 "MACS_sample_kidney_box.instr"
  mccchannel_14_cave2_box3_yheight = kidney_cave2_box3_height1;
#line 3787 "MACS_sample_kidney_box.instr"
  mccchannel_14_cave2_box3_zdepth = kidney_cave2_box3_depth;
#line 3788 "MACS_sample_kidney_box.instr"
  mccchannel_14_cave2_box3_xwidth2 = kidney_cave2_box3_width2;
#line 3788 "MACS_sample_kidney_box.instr"
  mccchannel_14_cave2_box3_yheight2 = kidney_cave2_box3_height2;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_14_cave2_box3_visualize = 1;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_14_cave2_box3_target_index = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_14_cave2_box3_target_x = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_14_cave2_box3_target_y = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_14_cave2_box3_target_z = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_14_cave2_box3_focus_aw = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_14_cave2_box3_focus_ah = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_14_cave2_box3_focus_xw = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_14_cave2_box3_focus_xh = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_14_cave2_box3_focus_r = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_14_cave2_box3_p_interact = 0;
#line 71 "MACS_sample_kidney_box.instr"
  if(0) strncpy(mccchannel_14_cave2_box3_mask_string, 0 ? 0 : "", 16384); else mccchannel_14_cave2_box3_mask_string[0]='\0';
#line 71 "MACS_sample_kidney_box.instr"
  if(0) strncpy(mccchannel_14_cave2_box3_mask_setting, 0 ? 0 : "", 16384); else mccchannel_14_cave2_box3_mask_setting[0]='\0';
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_14_cave2_box3_number_of_activations = 1;
#line 136023 "MACS_sample_kidney_box.c"

  SIG_MESSAGE("channel_14_cave2_box3 (Init:Place/Rotate)");
  rot_set_rotation(mctr1,
#line 3791 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 3791 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 3791 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD);
#line 136033 "MACS_sample_kidney_box.c"
  rot_mul(mctr1, mcrotachannel_14_cave2_cyl1, mcrotachannel_14_cave2_box3);
  rot_transpose(mcrotachannel_14_cave2_box2, mctr1);
  rot_mul(mcrotachannel_14_cave2_box3, mctr1, mcrotrchannel_14_cave2_box3);
  mctc1 = coords_set(
#line 3790 "MACS_sample_kidney_box.instr"
    0,
#line 3790 "MACS_sample_kidney_box.instr"
    0,
#line 3790 "MACS_sample_kidney_box.instr"
    kidney_cave2_box3_center_to_detector);
#line 136044 "MACS_sample_kidney_box.c"
  rot_transpose(mcrotachannel_14_cave2_cyl1, mctr1);
  mctc2 = rot_apply(mctr1, mctc1);
  mcposachannel_14_cave2_box3 = coords_add(mcposachannel_14_cave2_cyl1, mctc2);
  mctc1 = coords_sub(mcposachannel_14_cave2_box2, mcposachannel_14_cave2_box3);
  mcposrchannel_14_cave2_box3 = rot_apply(mcrotachannel_14_cave2_box3, mctc1);
  mcDEBUG_COMPONENT("channel_14_cave2_box3", mcposachannel_14_cave2_box3, mcrotachannel_14_cave2_box3)
  mccomp_posa[685] = mcposachannel_14_cave2_box3;
  mccomp_posr[685] = mcposrchannel_14_cave2_box3;
  mcNCounter[685]  = mcPCounter[685] = mcP2Counter[685] = 0;
  mcAbsorbProp[685]= 0;
    /* Component inter_analyzer_colimator_center_14. */
  /* Setting parameters for component inter_analyzer_colimator_center_14. */
  SIG_MESSAGE("inter_analyzer_colimator_center_14 (Init:SetPar)");

  SIG_MESSAGE("inter_analyzer_colimator_center_14 (Init:Place/Rotate)");
  rot_set_rotation(mctr1,
#line 3795 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 3795 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 3795 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD);
#line 136067 "MACS_sample_kidney_box.c"
  rot_mul(mctr1, mcrotachannel_14_analyzer_1_center, mcrotainter_analyzer_colimator_center_14);
  rot_transpose(mcrotachannel_14_cave2_box3, mctr1);
  rot_mul(mcrotainter_analyzer_colimator_center_14, mctr1, mcrotrinter_analyzer_colimator_center_14);
  mctc1 = coords_set(
#line 3794 "MACS_sample_kidney_box.instr"
    -0.5 * analyzer_seperation,
#line 3794 "MACS_sample_kidney_box.instr"
    0,
#line 3794 "MACS_sample_kidney_box.instr"
    0);
#line 136078 "MACS_sample_kidney_box.c"
  rot_transpose(mcrotachannel_14_analyzer_1_center, mctr1);
  mctc2 = rot_apply(mctr1, mctc1);
  mcposainter_analyzer_colimator_center_14 = coords_add(mcposachannel_14_analyzer_1_center, mctc2);
  mctc1 = coords_sub(mcposachannel_14_cave2_box3, mcposainter_analyzer_colimator_center_14);
  mcposrinter_analyzer_colimator_center_14 = rot_apply(mcrotainter_analyzer_colimator_center_14, mctc1);
  mcDEBUG_COMPONENT("inter_analyzer_colimator_center_14", mcposainter_analyzer_colimator_center_14, mcrotainter_analyzer_colimator_center_14)
  mccomp_posa[686] = mcposainter_analyzer_colimator_center_14;
  mccomp_posr[686] = mcposrinter_analyzer_colimator_center_14;
  mcNCounter[686]  = mcPCounter[686] = mcP2Counter[686] = 0;
  mcAbsorbProp[686]= 0;
    /* Component inter_analyzer_colimator_14_blade_0. */
  /* Setting parameters for component inter_analyzer_colimator_14_blade_0. */
  SIG_MESSAGE("inter_analyzer_colimator_14_blade_0 (Init:SetPar)");
#line 3799 "MACS_sample_kidney_box.instr"
  if("Collimator_gad") strncpy(mccinter_analyzer_colimator_14_blade_0_material_string, "Collimator_gad" ? "Collimator_gad" : "", 16384); else mccinter_analyzer_colimator_14_blade_0_material_string[0]='\0';
#line 3799 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_14_blade_0_priority = 1625;
#line 3798 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_14_blade_0_xwidth = inter_analyzer_colimator_width;
#line 3798 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_14_blade_0_yheight = inter_analyzer_colimator_height;
#line 3798 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_14_blade_0_zdepth = inter_analyzer_colimator_depth;
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_14_blade_0_xwidth2 = -1;
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_14_blade_0_yheight2 = -1;
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_14_blade_0_visualize = 1;
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_14_blade_0_target_index = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_14_blade_0_target_x = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_14_blade_0_target_y = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_14_blade_0_target_z = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_14_blade_0_focus_aw = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_14_blade_0_focus_ah = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_14_blade_0_focus_xw = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_14_blade_0_focus_xh = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_14_blade_0_focus_r = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_14_blade_0_p_interact = 0;
#line 71 "MACS_sample_kidney_box.instr"
  if(0) strncpy(mccinter_analyzer_colimator_14_blade_0_mask_string, 0 ? 0 : "", 16384); else mccinter_analyzer_colimator_14_blade_0_mask_string[0]='\0';
#line 71 "MACS_sample_kidney_box.instr"
  if(0) strncpy(mccinter_analyzer_colimator_14_blade_0_mask_setting, 0 ? 0 : "", 16384); else mccinter_analyzer_colimator_14_blade_0_mask_setting[0]='\0';
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_14_blade_0_number_of_activations = 1;
#line 136134 "MACS_sample_kidney_box.c"

  SIG_MESSAGE("inter_analyzer_colimator_14_blade_0 (Init:Place/Rotate)");
  rot_set_rotation(mctr1,
#line 3801 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 3801 "MACS_sample_kidney_box.instr"
    (- analyzer_2theta [ 14 ])*DEG2RAD,
#line 3801 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD);
#line 136144 "MACS_sample_kidney_box.c"
  rot_mul(mctr1, mcrotainter_analyzer_colimator_center_14, mcrotainter_analyzer_colimator_14_blade_0);
  rot_transpose(mcrotainter_analyzer_colimator_center_14, mctr1);
  rot_mul(mcrotainter_analyzer_colimator_14_blade_0, mctr1, mcrotrinter_analyzer_colimator_14_blade_0);
  mctc1 = coords_set(
#line 3800 "MACS_sample_kidney_box.instr"
    0,
#line 3800 "MACS_sample_kidney_box.instr"
    0,
#line 3800 "MACS_sample_kidney_box.instr"
    inter_analyzer_colimator_start_pos - 0 * inter_analyzer_colimator_seperation);
#line 136155 "MACS_sample_kidney_box.c"
  rot_transpose(mcrotainter_analyzer_colimator_center_14, mctr1);
  mctc2 = rot_apply(mctr1, mctc1);
  mcposainter_analyzer_colimator_14_blade_0 = coords_add(mcposainter_analyzer_colimator_center_14, mctc2);
  mctc1 = coords_sub(mcposainter_analyzer_colimator_center_14, mcposainter_analyzer_colimator_14_blade_0);
  mcposrinter_analyzer_colimator_14_blade_0 = rot_apply(mcrotainter_analyzer_colimator_14_blade_0, mctc1);
  mcDEBUG_COMPONENT("inter_analyzer_colimator_14_blade_0", mcposainter_analyzer_colimator_14_blade_0, mcrotainter_analyzer_colimator_14_blade_0)
  mccomp_posa[687] = mcposainter_analyzer_colimator_14_blade_0;
  mccomp_posr[687] = mcposrinter_analyzer_colimator_14_blade_0;
  mcNCounter[687]  = mcPCounter[687] = mcP2Counter[687] = 0;
  mcAbsorbProp[687]= 0;
    /* Component inter_analyzer_colimator_14_blade_1. */
  /* Setting parameters for component inter_analyzer_colimator_14_blade_1. */
  SIG_MESSAGE("inter_analyzer_colimator_14_blade_1 (Init:SetPar)");
#line 3805 "MACS_sample_kidney_box.instr"
  if("Collimator_gad") strncpy(mccinter_analyzer_colimator_14_blade_1_material_string, "Collimator_gad" ? "Collimator_gad" : "", 16384); else mccinter_analyzer_colimator_14_blade_1_material_string[0]='\0';
#line 3805 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_14_blade_1_priority = 1626;
#line 3804 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_14_blade_1_xwidth = inter_analyzer_colimator_width;
#line 3804 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_14_blade_1_yheight = inter_analyzer_colimator_height;
#line 3804 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_14_blade_1_zdepth = inter_analyzer_colimator_depth;
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_14_blade_1_xwidth2 = -1;
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_14_blade_1_yheight2 = -1;
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_14_blade_1_visualize = 1;
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_14_blade_1_target_index = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_14_blade_1_target_x = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_14_blade_1_target_y = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_14_blade_1_target_z = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_14_blade_1_focus_aw = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_14_blade_1_focus_ah = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_14_blade_1_focus_xw = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_14_blade_1_focus_xh = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_14_blade_1_focus_r = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_14_blade_1_p_interact = 0;
#line 71 "MACS_sample_kidney_box.instr"
  if(0) strncpy(mccinter_analyzer_colimator_14_blade_1_mask_string, 0 ? 0 : "", 16384); else mccinter_analyzer_colimator_14_blade_1_mask_string[0]='\0';
#line 71 "MACS_sample_kidney_box.instr"
  if(0) strncpy(mccinter_analyzer_colimator_14_blade_1_mask_setting, 0 ? 0 : "", 16384); else mccinter_analyzer_colimator_14_blade_1_mask_setting[0]='\0';
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_14_blade_1_number_of_activations = 1;
#line 136211 "MACS_sample_kidney_box.c"

  SIG_MESSAGE("inter_analyzer_colimator_14_blade_1 (Init:Place/Rotate)");
  rot_set_rotation(mctr1,
#line 3807 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 3807 "MACS_sample_kidney_box.instr"
    (- analyzer_2theta [ 14 ])*DEG2RAD,
#line 3807 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD);
#line 136221 "MACS_sample_kidney_box.c"
  rot_mul(mctr1, mcrotainter_analyzer_colimator_center_14, mcrotainter_analyzer_colimator_14_blade_1);
  rot_transpose(mcrotainter_analyzer_colimator_14_blade_0, mctr1);
  rot_mul(mcrotainter_analyzer_colimator_14_blade_1, mctr1, mcrotrinter_analyzer_colimator_14_blade_1);
  mctc1 = coords_set(
#line 3806 "MACS_sample_kidney_box.instr"
    0,
#line 3806 "MACS_sample_kidney_box.instr"
    0,
#line 3806 "MACS_sample_kidney_box.instr"
    inter_analyzer_colimator_start_pos - 1 * inter_analyzer_colimator_seperation);
#line 136232 "MACS_sample_kidney_box.c"
  rot_transpose(mcrotainter_analyzer_colimator_center_14, mctr1);
  mctc2 = rot_apply(mctr1, mctc1);
  mcposainter_analyzer_colimator_14_blade_1 = coords_add(mcposainter_analyzer_colimator_center_14, mctc2);
  mctc1 = coords_sub(mcposainter_analyzer_colimator_14_blade_0, mcposainter_analyzer_colimator_14_blade_1);
  mcposrinter_analyzer_colimator_14_blade_1 = rot_apply(mcrotainter_analyzer_colimator_14_blade_1, mctc1);
  mcDEBUG_COMPONENT("inter_analyzer_colimator_14_blade_1", mcposainter_analyzer_colimator_14_blade_1, mcrotainter_analyzer_colimator_14_blade_1)
  mccomp_posa[688] = mcposainter_analyzer_colimator_14_blade_1;
  mccomp_posr[688] = mcposrinter_analyzer_colimator_14_blade_1;
  mcNCounter[688]  = mcPCounter[688] = mcP2Counter[688] = 0;
  mcAbsorbProp[688]= 0;
    /* Component inter_analyzer_colimator_14_blade_2. */
  /* Setting parameters for component inter_analyzer_colimator_14_blade_2. */
  SIG_MESSAGE("inter_analyzer_colimator_14_blade_2 (Init:SetPar)");
#line 3811 "MACS_sample_kidney_box.instr"
  if("Collimator_gad") strncpy(mccinter_analyzer_colimator_14_blade_2_material_string, "Collimator_gad" ? "Collimator_gad" : "", 16384); else mccinter_analyzer_colimator_14_blade_2_material_string[0]='\0';
#line 3811 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_14_blade_2_priority = 1627;
#line 3810 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_14_blade_2_xwidth = inter_analyzer_colimator_width;
#line 3810 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_14_blade_2_yheight = inter_analyzer_colimator_height;
#line 3810 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_14_blade_2_zdepth = inter_analyzer_colimator_depth;
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_14_blade_2_xwidth2 = -1;
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_14_blade_2_yheight2 = -1;
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_14_blade_2_visualize = 1;
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_14_blade_2_target_index = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_14_blade_2_target_x = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_14_blade_2_target_y = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_14_blade_2_target_z = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_14_blade_2_focus_aw = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_14_blade_2_focus_ah = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_14_blade_2_focus_xw = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_14_blade_2_focus_xh = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_14_blade_2_focus_r = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_14_blade_2_p_interact = 0;
#line 71 "MACS_sample_kidney_box.instr"
  if(0) strncpy(mccinter_analyzer_colimator_14_blade_2_mask_string, 0 ? 0 : "", 16384); else mccinter_analyzer_colimator_14_blade_2_mask_string[0]='\0';
#line 71 "MACS_sample_kidney_box.instr"
  if(0) strncpy(mccinter_analyzer_colimator_14_blade_2_mask_setting, 0 ? 0 : "", 16384); else mccinter_analyzer_colimator_14_blade_2_mask_setting[0]='\0';
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_14_blade_2_number_of_activations = 1;
#line 136288 "MACS_sample_kidney_box.c"

  SIG_MESSAGE("inter_analyzer_colimator_14_blade_2 (Init:Place/Rotate)");
  rot_set_rotation(mctr1,
#line 3813 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 3813 "MACS_sample_kidney_box.instr"
    (- analyzer_2theta [ 14 ])*DEG2RAD,
#line 3813 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD);
#line 136298 "MACS_sample_kidney_box.c"
  rot_mul(mctr1, mcrotainter_analyzer_colimator_center_14, mcrotainter_analyzer_colimator_14_blade_2);
  rot_transpose(mcrotainter_analyzer_colimator_14_blade_1, mctr1);
  rot_mul(mcrotainter_analyzer_colimator_14_blade_2, mctr1, mcrotrinter_analyzer_colimator_14_blade_2);
  mctc1 = coords_set(
#line 3812 "MACS_sample_kidney_box.instr"
    0,
#line 3812 "MACS_sample_kidney_box.instr"
    0,
#line 3812 "MACS_sample_kidney_box.instr"
    inter_analyzer_colimator_start_pos - 2 * inter_analyzer_colimator_seperation);
#line 136309 "MACS_sample_kidney_box.c"
  rot_transpose(mcrotainter_analyzer_colimator_center_14, mctr1);
  mctc2 = rot_apply(mctr1, mctc1);
  mcposainter_analyzer_colimator_14_blade_2 = coords_add(mcposainter_analyzer_colimator_center_14, mctc2);
  mctc1 = coords_sub(mcposainter_analyzer_colimator_14_blade_1, mcposainter_analyzer_colimator_14_blade_2);
  mcposrinter_analyzer_colimator_14_blade_2 = rot_apply(mcrotainter_analyzer_colimator_14_blade_2, mctc1);
  mcDEBUG_COMPONENT("inter_analyzer_colimator_14_blade_2", mcposainter_analyzer_colimator_14_blade_2, mcrotainter_analyzer_colimator_14_blade_2)
  mccomp_posa[689] = mcposainter_analyzer_colimator_14_blade_2;
  mccomp_posr[689] = mcposrinter_analyzer_colimator_14_blade_2;
  mcNCounter[689]  = mcPCounter[689] = mcP2Counter[689] = 0;
  mcAbsorbProp[689]= 0;
    /* Component inter_analyzer_colimator_14_blade_3. */
  /* Setting parameters for component inter_analyzer_colimator_14_blade_3. */
  SIG_MESSAGE("inter_analyzer_colimator_14_blade_3 (Init:SetPar)");
#line 3817 "MACS_sample_kidney_box.instr"
  if("Collimator_gad") strncpy(mccinter_analyzer_colimator_14_blade_3_material_string, "Collimator_gad" ? "Collimator_gad" : "", 16384); else mccinter_analyzer_colimator_14_blade_3_material_string[0]='\0';
#line 3817 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_14_blade_3_priority = 1628;
#line 3816 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_14_blade_3_xwidth = inter_analyzer_colimator_width;
#line 3816 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_14_blade_3_yheight = inter_analyzer_colimator_height;
#line 3816 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_14_blade_3_zdepth = inter_analyzer_colimator_depth;
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_14_blade_3_xwidth2 = -1;
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_14_blade_3_yheight2 = -1;
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_14_blade_3_visualize = 1;
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_14_blade_3_target_index = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_14_blade_3_target_x = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_14_blade_3_target_y = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_14_blade_3_target_z = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_14_blade_3_focus_aw = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_14_blade_3_focus_ah = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_14_blade_3_focus_xw = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_14_blade_3_focus_xh = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_14_blade_3_focus_r = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_14_blade_3_p_interact = 0;
#line 71 "MACS_sample_kidney_box.instr"
  if(0) strncpy(mccinter_analyzer_colimator_14_blade_3_mask_string, 0 ? 0 : "", 16384); else mccinter_analyzer_colimator_14_blade_3_mask_string[0]='\0';
#line 71 "MACS_sample_kidney_box.instr"
  if(0) strncpy(mccinter_analyzer_colimator_14_blade_3_mask_setting, 0 ? 0 : "", 16384); else mccinter_analyzer_colimator_14_blade_3_mask_setting[0]='\0';
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_14_blade_3_number_of_activations = 1;
#line 136365 "MACS_sample_kidney_box.c"

  SIG_MESSAGE("inter_analyzer_colimator_14_blade_3 (Init:Place/Rotate)");
  rot_set_rotation(mctr1,
#line 3819 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 3819 "MACS_sample_kidney_box.instr"
    (- analyzer_2theta [ 14 ])*DEG2RAD,
#line 3819 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD);
#line 136375 "MACS_sample_kidney_box.c"
  rot_mul(mctr1, mcrotainter_analyzer_colimator_center_14, mcrotainter_analyzer_colimator_14_blade_3);
  rot_transpose(mcrotainter_analyzer_colimator_14_blade_2, mctr1);
  rot_mul(mcrotainter_analyzer_colimator_14_blade_3, mctr1, mcrotrinter_analyzer_colimator_14_blade_3);
  mctc1 = coords_set(
#line 3818 "MACS_sample_kidney_box.instr"
    0,
#line 3818 "MACS_sample_kidney_box.instr"
    0,
#line 3818 "MACS_sample_kidney_box.instr"
    inter_analyzer_colimator_start_pos - 3 * inter_analyzer_colimator_seperation);
#line 136386 "MACS_sample_kidney_box.c"
  rot_transpose(mcrotainter_analyzer_colimator_center_14, mctr1);
  mctc2 = rot_apply(mctr1, mctc1);
  mcposainter_analyzer_colimator_14_blade_3 = coords_add(mcposainter_analyzer_colimator_center_14, mctc2);
  mctc1 = coords_sub(mcposainter_analyzer_colimator_14_blade_2, mcposainter_analyzer_colimator_14_blade_3);
  mcposrinter_analyzer_colimator_14_blade_3 = rot_apply(mcrotainter_analyzer_colimator_14_blade_3, mctc1);
  mcDEBUG_COMPONENT("inter_analyzer_colimator_14_blade_3", mcposainter_analyzer_colimator_14_blade_3, mcrotainter_analyzer_colimator_14_blade_3)
  mccomp_posa[690] = mcposainter_analyzer_colimator_14_blade_3;
  mccomp_posr[690] = mcposrinter_analyzer_colimator_14_blade_3;
  mcNCounter[690]  = mcPCounter[690] = mcP2Counter[690] = 0;
  mcAbsorbProp[690]= 0;
    /* Component inter_analyzer_colimator_14_blade_4. */
  /* Setting parameters for component inter_analyzer_colimator_14_blade_4. */
  SIG_MESSAGE("inter_analyzer_colimator_14_blade_4 (Init:SetPar)");
#line 3823 "MACS_sample_kidney_box.instr"
  if("Collimator_gad") strncpy(mccinter_analyzer_colimator_14_blade_4_material_string, "Collimator_gad" ? "Collimator_gad" : "", 16384); else mccinter_analyzer_colimator_14_blade_4_material_string[0]='\0';
#line 3823 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_14_blade_4_priority = 1629;
#line 3822 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_14_blade_4_xwidth = inter_analyzer_colimator_width;
#line 3822 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_14_blade_4_yheight = inter_analyzer_colimator_height;
#line 3822 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_14_blade_4_zdepth = inter_analyzer_colimator_depth;
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_14_blade_4_xwidth2 = -1;
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_14_blade_4_yheight2 = -1;
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_14_blade_4_visualize = 1;
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_14_blade_4_target_index = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_14_blade_4_target_x = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_14_blade_4_target_y = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_14_blade_4_target_z = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_14_blade_4_focus_aw = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_14_blade_4_focus_ah = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_14_blade_4_focus_xw = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_14_blade_4_focus_xh = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_14_blade_4_focus_r = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_14_blade_4_p_interact = 0;
#line 71 "MACS_sample_kidney_box.instr"
  if(0) strncpy(mccinter_analyzer_colimator_14_blade_4_mask_string, 0 ? 0 : "", 16384); else mccinter_analyzer_colimator_14_blade_4_mask_string[0]='\0';
#line 71 "MACS_sample_kidney_box.instr"
  if(0) strncpy(mccinter_analyzer_colimator_14_blade_4_mask_setting, 0 ? 0 : "", 16384); else mccinter_analyzer_colimator_14_blade_4_mask_setting[0]='\0';
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_14_blade_4_number_of_activations = 1;
#line 136442 "MACS_sample_kidney_box.c"

  SIG_MESSAGE("inter_analyzer_colimator_14_blade_4 (Init:Place/Rotate)");
  rot_set_rotation(mctr1,
#line 3825 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 3825 "MACS_sample_kidney_box.instr"
    (- analyzer_2theta [ 14 ])*DEG2RAD,
#line 3825 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD);
#line 136452 "MACS_sample_kidney_box.c"
  rot_mul(mctr1, mcrotainter_analyzer_colimator_center_14, mcrotainter_analyzer_colimator_14_blade_4);
  rot_transpose(mcrotainter_analyzer_colimator_14_blade_3, mctr1);
  rot_mul(mcrotainter_analyzer_colimator_14_blade_4, mctr1, mcrotrinter_analyzer_colimator_14_blade_4);
  mctc1 = coords_set(
#line 3824 "MACS_sample_kidney_box.instr"
    0,
#line 3824 "MACS_sample_kidney_box.instr"
    0,
#line 3824 "MACS_sample_kidney_box.instr"
    inter_analyzer_colimator_start_pos - 4 * inter_analyzer_colimator_seperation);
#line 136463 "MACS_sample_kidney_box.c"
  rot_transpose(mcrotainter_analyzer_colimator_center_14, mctr1);
  mctc2 = rot_apply(mctr1, mctc1);
  mcposainter_analyzer_colimator_14_blade_4 = coords_add(mcposainter_analyzer_colimator_center_14, mctc2);
  mctc1 = coords_sub(mcposainter_analyzer_colimator_14_blade_3, mcposainter_analyzer_colimator_14_blade_4);
  mcposrinter_analyzer_colimator_14_blade_4 = rot_apply(mcrotainter_analyzer_colimator_14_blade_4, mctc1);
  mcDEBUG_COMPONENT("inter_analyzer_colimator_14_blade_4", mcposainter_analyzer_colimator_14_blade_4, mcrotainter_analyzer_colimator_14_blade_4)
  mccomp_posa[691] = mcposainter_analyzer_colimator_14_blade_4;
  mccomp_posr[691] = mcposrinter_analyzer_colimator_14_blade_4;
  mcNCounter[691]  = mcPCounter[691] = mcP2Counter[691] = 0;
  mcAbsorbProp[691]= 0;
    /* Component diffraction_detector_14_exit_volume. */
  /* Setting parameters for component diffraction_detector_14_exit_volume. */
  SIG_MESSAGE("diffraction_detector_14_exit_volume (Init:SetPar)");
#line 3829 "MACS_sample_kidney_box.instr"
  if("Exit") strncpy(mccdiffraction_detector_14_exit_volume_material_string, "Exit" ? "Exit" : "", 16384); else mccdiffraction_detector_14_exit_volume_material_string[0]='\0';
#line 3829 "MACS_sample_kidney_box.instr"
  mccdiffraction_detector_14_exit_volume_priority = 1631;
#line 3828 "MACS_sample_kidney_box.instr"
  mccdiffraction_detector_14_exit_volume_xwidth = 2.01 * detector_radius;
#line 3828 "MACS_sample_kidney_box.instr"
  mccdiffraction_detector_14_exit_volume_yheight = 1.01 * detector_height;
#line 3828 "MACS_sample_kidney_box.instr"
  mccdiffraction_detector_14_exit_volume_zdepth = 0.001;
#line 71 "MACS_sample_kidney_box.instr"
  mccdiffraction_detector_14_exit_volume_xwidth2 = -1;
#line 71 "MACS_sample_kidney_box.instr"
  mccdiffraction_detector_14_exit_volume_yheight2 = -1;
#line 71 "MACS_sample_kidney_box.instr"
  mccdiffraction_detector_14_exit_volume_visualize = 1;
#line 71 "MACS_sample_kidney_box.instr"
  mccdiffraction_detector_14_exit_volume_target_index = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccdiffraction_detector_14_exit_volume_target_x = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccdiffraction_detector_14_exit_volume_target_y = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccdiffraction_detector_14_exit_volume_target_z = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccdiffraction_detector_14_exit_volume_focus_aw = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccdiffraction_detector_14_exit_volume_focus_ah = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccdiffraction_detector_14_exit_volume_focus_xw = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccdiffraction_detector_14_exit_volume_focus_xh = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccdiffraction_detector_14_exit_volume_focus_r = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccdiffraction_detector_14_exit_volume_p_interact = 0;
#line 71 "MACS_sample_kidney_box.instr"
  if(0) strncpy(mccdiffraction_detector_14_exit_volume_mask_string, 0 ? 0 : "", 16384); else mccdiffraction_detector_14_exit_volume_mask_string[0]='\0';
#line 71 "MACS_sample_kidney_box.instr"
  if(0) strncpy(mccdiffraction_detector_14_exit_volume_mask_setting, 0 ? 0 : "", 16384); else mccdiffraction_detector_14_exit_volume_mask_setting[0]='\0';
#line 71 "MACS_sample_kidney_box.instr"
  mccdiffraction_detector_14_exit_volume_number_of_activations = 1;
#line 136519 "MACS_sample_kidney_box.c"

  SIG_MESSAGE("diffraction_detector_14_exit_volume (Init:Place/Rotate)");
  rot_set_rotation(mctr1,
#line 3831 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 3831 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 3831 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD);
#line 136529 "MACS_sample_kidney_box.c"
  rot_mul(mctr1, mcrotakidney_channel_14, mcrotadiffraction_detector_14_exit_volume);
  rot_transpose(mcrotainter_analyzer_colimator_14_blade_4, mctr1);
  rot_mul(mcrotadiffraction_detector_14_exit_volume, mctr1, mcrotrdiffraction_detector_14_exit_volume);
  mctc1 = coords_set(
#line 3830 "MACS_sample_kidney_box.instr"
    0,
#line 3830 "MACS_sample_kidney_box.instr"
    0,
#line 3830 "MACS_sample_kidney_box.instr"
    0);
#line 136540 "MACS_sample_kidney_box.c"
  rot_transpose(mcrotachannel_14_cave1_cyl1, mctr1);
  mctc2 = rot_apply(mctr1, mctc1);
  mcposadiffraction_detector_14_exit_volume = coords_add(mcposachannel_14_cave1_cyl1, mctc2);
  mctc1 = coords_sub(mcposainter_analyzer_colimator_14_blade_4, mcposadiffraction_detector_14_exit_volume);
  mcposrdiffraction_detector_14_exit_volume = rot_apply(mcrotadiffraction_detector_14_exit_volume, mctc1);
  mcDEBUG_COMPONENT("diffraction_detector_14_exit_volume", mcposadiffraction_detector_14_exit_volume, mcrotadiffraction_detector_14_exit_volume)
  mccomp_posa[692] = mcposadiffraction_detector_14_exit_volume;
  mccomp_posr[692] = mcposrdiffraction_detector_14_exit_volume;
  mcNCounter[692]  = mcPCounter[692] = mcP2Counter[692] = 0;
  mcAbsorbProp[692]= 0;
    /* Component spec_detector_14_exit_volume. */
  /* Setting parameters for component spec_detector_14_exit_volume. */
  SIG_MESSAGE("spec_detector_14_exit_volume (Init:SetPar)");
#line 3835 "MACS_sample_kidney_box.instr"
  if("Exit") strncpy(mccspec_detector_14_exit_volume_material_string, "Exit" ? "Exit" : "", 16384); else mccspec_detector_14_exit_volume_material_string[0]='\0';
#line 3835 "MACS_sample_kidney_box.instr"
  mccspec_detector_14_exit_volume_priority = 1632;
#line 3834 "MACS_sample_kidney_box.instr"
  mccspec_detector_14_exit_volume_xwidth = 2.01 * detector_radius;
#line 3834 "MACS_sample_kidney_box.instr"
  mccspec_detector_14_exit_volume_yheight = 1.01 * detector_height;
#line 3834 "MACS_sample_kidney_box.instr"
  mccspec_detector_14_exit_volume_zdepth = 0.001;
#line 71 "MACS_sample_kidney_box.instr"
  mccspec_detector_14_exit_volume_xwidth2 = -1;
#line 71 "MACS_sample_kidney_box.instr"
  mccspec_detector_14_exit_volume_yheight2 = -1;
#line 71 "MACS_sample_kidney_box.instr"
  mccspec_detector_14_exit_volume_visualize = 1;
#line 71 "MACS_sample_kidney_box.instr"
  mccspec_detector_14_exit_volume_target_index = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccspec_detector_14_exit_volume_target_x = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccspec_detector_14_exit_volume_target_y = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccspec_detector_14_exit_volume_target_z = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccspec_detector_14_exit_volume_focus_aw = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccspec_detector_14_exit_volume_focus_ah = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccspec_detector_14_exit_volume_focus_xw = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccspec_detector_14_exit_volume_focus_xh = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccspec_detector_14_exit_volume_focus_r = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccspec_detector_14_exit_volume_p_interact = 0;
#line 71 "MACS_sample_kidney_box.instr"
  if(0) strncpy(mccspec_detector_14_exit_volume_mask_string, 0 ? 0 : "", 16384); else mccspec_detector_14_exit_volume_mask_string[0]='\0';
#line 71 "MACS_sample_kidney_box.instr"
  if(0) strncpy(mccspec_detector_14_exit_volume_mask_setting, 0 ? 0 : "", 16384); else mccspec_detector_14_exit_volume_mask_setting[0]='\0';
#line 71 "MACS_sample_kidney_box.instr"
  mccspec_detector_14_exit_volume_number_of_activations = 1;
#line 136596 "MACS_sample_kidney_box.c"

  SIG_MESSAGE("spec_detector_14_exit_volume (Init:Place/Rotate)");
  rot_set_rotation(mctr1,
#line 3837 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 3837 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 3837 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD);
#line 136606 "MACS_sample_kidney_box.c"
  rot_mul(mctr1, mcrotachannel_14_analyzer_2_center, mcrotaspec_detector_14_exit_volume);
  rot_transpose(mcrotadiffraction_detector_14_exit_volume, mctr1);
  rot_mul(mcrotaspec_detector_14_exit_volume, mctr1, mcrotrspec_detector_14_exit_volume);
  mctc1 = coords_set(
#line 3836 "MACS_sample_kidney_box.instr"
    0,
#line 3836 "MACS_sample_kidney_box.instr"
    0,
#line 3836 "MACS_sample_kidney_box.instr"
    0);
#line 136617 "MACS_sample_kidney_box.c"
  rot_transpose(mcrotachannel_14_cave2_cyl1, mctr1);
  mctc2 = rot_apply(mctr1, mctc1);
  mcposaspec_detector_14_exit_volume = coords_add(mcposachannel_14_cave2_cyl1, mctc2);
  mctc1 = coords_sub(mcposadiffraction_detector_14_exit_volume, mcposaspec_detector_14_exit_volume);
  mcposrspec_detector_14_exit_volume = rot_apply(mcrotaspec_detector_14_exit_volume, mctc1);
  mcDEBUG_COMPONENT("spec_detector_14_exit_volume", mcposaspec_detector_14_exit_volume, mcrotaspec_detector_14_exit_volume)
  mccomp_posa[693] = mcposaspec_detector_14_exit_volume;
  mccomp_posr[693] = mcposrspec_detector_14_exit_volume;
  mcNCounter[693]  = mcPCounter[693] = mcP2Counter[693] = 0;
  mcAbsorbProp[693]= 0;
    /* Component channel_15_cave1_box1. */
  /* Setting parameters for component channel_15_cave1_box1. */
  SIG_MESSAGE("channel_15_cave1_box1 (Init:SetPar)");
#line 3842 "MACS_sample_kidney_box.instr"
  if("Vacuum") strncpy(mccchannel_15_cave1_box1_material_string, "Vacuum" ? "Vacuum" : "", 16384); else mccchannel_15_cave1_box1_material_string[0]='\0';
#line 3842 "MACS_sample_kidney_box.instr"
  mccchannel_15_cave1_box1_priority = 1700;
#line 3840 "MACS_sample_kidney_box.instr"
  mccchannel_15_cave1_box1_xwidth = kidney_cave1_box1_width1;
#line 3840 "MACS_sample_kidney_box.instr"
  mccchannel_15_cave1_box1_yheight = kidney_cave1_box1_height1;
#line 3840 "MACS_sample_kidney_box.instr"
  mccchannel_15_cave1_box1_zdepth = kidney_cave1_box1_depth;
#line 3841 "MACS_sample_kidney_box.instr"
  mccchannel_15_cave1_box1_xwidth2 = kidney_cave1_box1_width2;
#line 3841 "MACS_sample_kidney_box.instr"
  mccchannel_15_cave1_box1_yheight2 = kidney_cave1_box1_height2;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_15_cave1_box1_visualize = 1;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_15_cave1_box1_target_index = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_15_cave1_box1_target_x = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_15_cave1_box1_target_y = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_15_cave1_box1_target_z = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_15_cave1_box1_focus_aw = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_15_cave1_box1_focus_ah = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_15_cave1_box1_focus_xw = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_15_cave1_box1_focus_xh = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_15_cave1_box1_focus_r = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_15_cave1_box1_p_interact = 0;
#line 71 "MACS_sample_kidney_box.instr"
  if(0) strncpy(mccchannel_15_cave1_box1_mask_string, 0 ? 0 : "", 16384); else mccchannel_15_cave1_box1_mask_string[0]='\0';
#line 71 "MACS_sample_kidney_box.instr"
  if(0) strncpy(mccchannel_15_cave1_box1_mask_setting, 0 ? 0 : "", 16384); else mccchannel_15_cave1_box1_mask_setting[0]='\0';
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_15_cave1_box1_number_of_activations = 1;
#line 136673 "MACS_sample_kidney_box.c"

  SIG_MESSAGE("channel_15_cave1_box1 (Init:Place/Rotate)");
  rot_set_rotation(mctr1,
#line 3844 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 3844 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 3844 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD);
#line 136683 "MACS_sample_kidney_box.c"
  rot_mul(mctr1, mcrotakidney_channel_15, mcrotachannel_15_cave1_box1);
  rot_transpose(mcrotaspec_detector_14_exit_volume, mctr1);
  rot_mul(mcrotachannel_15_cave1_box1, mctr1, mcrotrchannel_15_cave1_box1);
  mctc1 = coords_set(
#line 3843 "MACS_sample_kidney_box.instr"
    0,
#line 3843 "MACS_sample_kidney_box.instr"
    0,
#line 3843 "MACS_sample_kidney_box.instr"
    kidney_cave1_box1_center_to_target);
#line 136694 "MACS_sample_kidney_box.c"
  rot_transpose(mcrotakidney_channel_15, mctr1);
  mctc2 = rot_apply(mctr1, mctc1);
  mcposachannel_15_cave1_box1 = coords_add(mcposakidney_channel_15, mctc2);
  mctc1 = coords_sub(mcposaspec_detector_14_exit_volume, mcposachannel_15_cave1_box1);
  mcposrchannel_15_cave1_box1 = rot_apply(mcrotachannel_15_cave1_box1, mctc1);
  mcDEBUG_COMPONENT("channel_15_cave1_box1", mcposachannel_15_cave1_box1, mcrotachannel_15_cave1_box1)
  mccomp_posa[694] = mcposachannel_15_cave1_box1;
  mccomp_posr[694] = mcposrchannel_15_cave1_box1;
  mcNCounter[694]  = mcPCounter[694] = mcP2Counter[694] = 0;
  mcAbsorbProp[694]= 0;
    /* Component channel_15_cave1_box2. */
  /* Setting parameters for component channel_15_cave1_box2. */
  SIG_MESSAGE("channel_15_cave1_box2 (Init:SetPar)");
#line 3849 "MACS_sample_kidney_box.instr"
  if("Vacuum") strncpy(mccchannel_15_cave1_box2_material_string, "Vacuum" ? "Vacuum" : "", 16384); else mccchannel_15_cave1_box2_material_string[0]='\0';
#line 3849 "MACS_sample_kidney_box.instr"
  mccchannel_15_cave1_box2_priority = 1705;
#line 3847 "MACS_sample_kidney_box.instr"
  mccchannel_15_cave1_box2_xwidth = kidney_cave1_box2_width1;
#line 3847 "MACS_sample_kidney_box.instr"
  mccchannel_15_cave1_box2_yheight = kidney_cave1_box2_height1;
#line 3847 "MACS_sample_kidney_box.instr"
  mccchannel_15_cave1_box2_zdepth = kidney_cave1_box2_depth;
#line 3848 "MACS_sample_kidney_box.instr"
  mccchannel_15_cave1_box2_xwidth2 = kidney_cave1_box2_width2;
#line 3848 "MACS_sample_kidney_box.instr"
  mccchannel_15_cave1_box2_yheight2 = kidney_cave1_box2_height2;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_15_cave1_box2_visualize = 1;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_15_cave1_box2_target_index = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_15_cave1_box2_target_x = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_15_cave1_box2_target_y = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_15_cave1_box2_target_z = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_15_cave1_box2_focus_aw = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_15_cave1_box2_focus_ah = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_15_cave1_box2_focus_xw = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_15_cave1_box2_focus_xh = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_15_cave1_box2_focus_r = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_15_cave1_box2_p_interact = 0;
#line 71 "MACS_sample_kidney_box.instr"
  if(0) strncpy(mccchannel_15_cave1_box2_mask_string, 0 ? 0 : "", 16384); else mccchannel_15_cave1_box2_mask_string[0]='\0';
#line 71 "MACS_sample_kidney_box.instr"
  if(0) strncpy(mccchannel_15_cave1_box2_mask_setting, 0 ? 0 : "", 16384); else mccchannel_15_cave1_box2_mask_setting[0]='\0';
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_15_cave1_box2_number_of_activations = 1;
#line 136750 "MACS_sample_kidney_box.c"

  SIG_MESSAGE("channel_15_cave1_box2 (Init:Place/Rotate)");
  rot_set_rotation(mctr1,
#line 3851 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 3851 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 3851 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD);
#line 136760 "MACS_sample_kidney_box.c"
  rot_mul(mctr1, mcrotakidney_channel_15, mcrotachannel_15_cave1_box2);
  rot_transpose(mcrotachannel_15_cave1_box1, mctr1);
  rot_mul(mcrotachannel_15_cave1_box2, mctr1, mcrotrchannel_15_cave1_box2);
  mctc1 = coords_set(
#line 3850 "MACS_sample_kidney_box.instr"
    kidney_cave1_box2_x_offset,
#line 3850 "MACS_sample_kidney_box.instr"
    0,
#line 3850 "MACS_sample_kidney_box.instr"
    kidney_cave1_box2_center_to_target);
#line 136771 "MACS_sample_kidney_box.c"
  rot_transpose(mcrotakidney_channel_15, mctr1);
  mctc2 = rot_apply(mctr1, mctc1);
  mcposachannel_15_cave1_box2 = coords_add(mcposakidney_channel_15, mctc2);
  mctc1 = coords_sub(mcposachannel_15_cave1_box1, mcposachannel_15_cave1_box2);
  mcposrchannel_15_cave1_box2 = rot_apply(mcrotachannel_15_cave1_box2, mctc1);
  mcDEBUG_COMPONENT("channel_15_cave1_box2", mcposachannel_15_cave1_box2, mcrotachannel_15_cave1_box2)
  mccomp_posa[695] = mcposachannel_15_cave1_box2;
  mccomp_posr[695] = mcposrchannel_15_cave1_box2;
  mcNCounter[695]  = mcPCounter[695] = mcP2Counter[695] = 0;
  mcAbsorbProp[695]= 0;
    /* Component channel_15_cave1_box3. */
  /* Setting parameters for component channel_15_cave1_box3. */
  SIG_MESSAGE("channel_15_cave1_box3 (Init:SetPar)");
#line 3856 "MACS_sample_kidney_box.instr"
  if("Vacuum") strncpy(mccchannel_15_cave1_box3_material_string, "Vacuum" ? "Vacuum" : "", 16384); else mccchannel_15_cave1_box3_material_string[0]='\0';
#line 3856 "MACS_sample_kidney_box.instr"
  mccchannel_15_cave1_box3_priority = 1702;
#line 3854 "MACS_sample_kidney_box.instr"
  mccchannel_15_cave1_box3_xwidth = kidney_cave1_box3_width1;
#line 3854 "MACS_sample_kidney_box.instr"
  mccchannel_15_cave1_box3_yheight = kidney_cave1_box3_height1;
#line 3854 "MACS_sample_kidney_box.instr"
  mccchannel_15_cave1_box3_zdepth = kidney_cave1_box3_depth;
#line 3855 "MACS_sample_kidney_box.instr"
  mccchannel_15_cave1_box3_xwidth2 = kidney_cave1_box3_width2;
#line 3855 "MACS_sample_kidney_box.instr"
  mccchannel_15_cave1_box3_yheight2 = kidney_cave1_box3_height2;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_15_cave1_box3_visualize = 1;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_15_cave1_box3_target_index = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_15_cave1_box3_target_x = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_15_cave1_box3_target_y = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_15_cave1_box3_target_z = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_15_cave1_box3_focus_aw = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_15_cave1_box3_focus_ah = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_15_cave1_box3_focus_xw = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_15_cave1_box3_focus_xh = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_15_cave1_box3_focus_r = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_15_cave1_box3_p_interact = 0;
#line 71 "MACS_sample_kidney_box.instr"
  if(0) strncpy(mccchannel_15_cave1_box3_mask_string, 0 ? 0 : "", 16384); else mccchannel_15_cave1_box3_mask_string[0]='\0';
#line 71 "MACS_sample_kidney_box.instr"
  if(0) strncpy(mccchannel_15_cave1_box3_mask_setting, 0 ? 0 : "", 16384); else mccchannel_15_cave1_box3_mask_setting[0]='\0';
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_15_cave1_box3_number_of_activations = 1;
#line 136827 "MACS_sample_kidney_box.c"

  SIG_MESSAGE("channel_15_cave1_box3 (Init:Place/Rotate)");
  rot_set_rotation(mctr1,
#line 3858 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 3858 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 3858 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD);
#line 136837 "MACS_sample_kidney_box.c"
  rot_mul(mctr1, mcrotakidney_channel_15, mcrotachannel_15_cave1_box3);
  rot_transpose(mcrotachannel_15_cave1_box2, mctr1);
  rot_mul(mcrotachannel_15_cave1_box3, mctr1, mcrotrchannel_15_cave1_box3);
  mctc1 = coords_set(
#line 3857 "MACS_sample_kidney_box.instr"
    0,
#line 3857 "MACS_sample_kidney_box.instr"
    0,
#line 3857 "MACS_sample_kidney_box.instr"
    kidney_cave1_box3_center_to_target);
#line 136848 "MACS_sample_kidney_box.c"
  rot_transpose(mcrotakidney_channel_15, mctr1);
  mctc2 = rot_apply(mctr1, mctc1);
  mcposachannel_15_cave1_box3 = coords_add(mcposakidney_channel_15, mctc2);
  mctc1 = coords_sub(mcposachannel_15_cave1_box2, mcposachannel_15_cave1_box3);
  mcposrchannel_15_cave1_box3 = rot_apply(mcrotachannel_15_cave1_box3, mctc1);
  mcDEBUG_COMPONENT("channel_15_cave1_box3", mcposachannel_15_cave1_box3, mcrotachannel_15_cave1_box3)
  mccomp_posa[696] = mcposachannel_15_cave1_box3;
  mccomp_posr[696] = mcposrchannel_15_cave1_box3;
  mcNCounter[696]  = mcPCounter[696] = mcP2Counter[696] = 0;
  mcAbsorbProp[696]= 0;
    /* Component channel_15_cave1_cyl1. */
  /* Setting parameters for component channel_15_cave1_cyl1. */
  SIG_MESSAGE("channel_15_cave1_cyl1 (Init:SetPar)");
#line 3862 "MACS_sample_kidney_box.instr"
  if("Vacuum") strncpy(mccchannel_15_cave1_cyl1_material_string, "Vacuum" ? "Vacuum" : "", 16384); else mccchannel_15_cave1_cyl1_material_string[0]='\0';
#line 3862 "MACS_sample_kidney_box.instr"
  mccchannel_15_cave1_cyl1_priority = 1703;
#line 3861 "MACS_sample_kidney_box.instr"
  mccchannel_15_cave1_cyl1_radius = kidney_cave1_cyl1_radius;
#line 3861 "MACS_sample_kidney_box.instr"
  mccchannel_15_cave1_cyl1_yheight = kidney_cave1_cyl1_height;
#line 67 "MACS_sample_kidney_box.instr"
  mccchannel_15_cave1_cyl1_visualize = 1;
#line 67 "MACS_sample_kidney_box.instr"
  mccchannel_15_cave1_cyl1_target_index = 0;
#line 67 "MACS_sample_kidney_box.instr"
  mccchannel_15_cave1_cyl1_target_x = 0;
#line 67 "MACS_sample_kidney_box.instr"
  mccchannel_15_cave1_cyl1_target_y = 0;
#line 67 "MACS_sample_kidney_box.instr"
  mccchannel_15_cave1_cyl1_target_z = 0;
#line 67 "MACS_sample_kidney_box.instr"
  mccchannel_15_cave1_cyl1_focus_aw = 0;
#line 67 "MACS_sample_kidney_box.instr"
  mccchannel_15_cave1_cyl1_focus_ah = 0;
#line 67 "MACS_sample_kidney_box.instr"
  mccchannel_15_cave1_cyl1_focus_xw = 0;
#line 67 "MACS_sample_kidney_box.instr"
  mccchannel_15_cave1_cyl1_focus_xh = 0;
#line 67 "MACS_sample_kidney_box.instr"
  mccchannel_15_cave1_cyl1_focus_r = 0;
#line 67 "MACS_sample_kidney_box.instr"
  mccchannel_15_cave1_cyl1_p_interact = 0;
#line 67 "MACS_sample_kidney_box.instr"
  if(0) strncpy(mccchannel_15_cave1_cyl1_mask_string, 0 ? 0 : "", 16384); else mccchannel_15_cave1_cyl1_mask_string[0]='\0';
#line 67 "MACS_sample_kidney_box.instr"
  if(0) strncpy(mccchannel_15_cave1_cyl1_mask_setting, 0 ? 0 : "", 16384); else mccchannel_15_cave1_cyl1_mask_setting[0]='\0';
#line 67 "MACS_sample_kidney_box.instr"
  mccchannel_15_cave1_cyl1_number_of_activations = 1;
#line 136898 "MACS_sample_kidney_box.c"

  SIG_MESSAGE("channel_15_cave1_cyl1 (Init:Place/Rotate)");
  rot_set_rotation(mctr1,
#line 3864 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 3864 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 3864 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD);
#line 136908 "MACS_sample_kidney_box.c"
  rot_mul(mctr1, mcrotakidney_channel_15, mcrotachannel_15_cave1_cyl1);
  rot_transpose(mcrotachannel_15_cave1_box3, mctr1);
  rot_mul(mcrotachannel_15_cave1_cyl1, mctr1, mcrotrchannel_15_cave1_cyl1);
  mctc1 = coords_set(
#line 3863 "MACS_sample_kidney_box.instr"
    0,
#line 3863 "MACS_sample_kidney_box.instr"
    0,
#line 3863 "MACS_sample_kidney_box.instr"
    kidney_cave1_cyl1_center_to_target);
#line 136919 "MACS_sample_kidney_box.c"
  rot_transpose(mcrotakidney_channel_15, mctr1);
  mctc2 = rot_apply(mctr1, mctc1);
  mcposachannel_15_cave1_cyl1 = coords_add(mcposakidney_channel_15, mctc2);
  mctc1 = coords_sub(mcposachannel_15_cave1_box3, mcposachannel_15_cave1_cyl1);
  mcposrchannel_15_cave1_cyl1 = rot_apply(mcrotachannel_15_cave1_cyl1, mctc1);
  mcDEBUG_COMPONENT("channel_15_cave1_cyl1", mcposachannel_15_cave1_cyl1, mcrotachannel_15_cave1_cyl1)
  mccomp_posa[697] = mcposachannel_15_cave1_cyl1;
  mccomp_posr[697] = mcposrchannel_15_cave1_cyl1;
  mcNCounter[697]  = mcPCounter[697] = mcP2Counter[697] = 0;
  mcAbsorbProp[697]= 0;
    /* Component channel_15_analyzer_1_center. */
  /* Setting parameters for component channel_15_analyzer_1_center. */
  SIG_MESSAGE("channel_15_analyzer_1_center (Init:SetPar)");

  SIG_MESSAGE("channel_15_analyzer_1_center (Init:Place/Rotate)");
  rot_set_rotation(mctr1,
    (0.0)*DEG2RAD,
    (0.0)*DEG2RAD,
    (0.0)*DEG2RAD);
#line 136939 "MACS_sample_kidney_box.c"
  rot_mul(mctr1, mcrotakidney_channel_15, mcrotachannel_15_analyzer_1_center);
  rot_transpose(mcrotachannel_15_cave1_cyl1, mctr1);
  rot_mul(mcrotachannel_15_analyzer_1_center, mctr1, mcrotrchannel_15_analyzer_1_center);
  mctc1 = coords_set(
#line 3868 "MACS_sample_kidney_box.instr"
    0,
#line 3868 "MACS_sample_kidney_box.instr"
    0,
#line 3868 "MACS_sample_kidney_box.instr"
    analyzer_1_center_to_sample);
#line 136950 "MACS_sample_kidney_box.c"
  rot_transpose(mcrotakidney_channel_15, mctr1);
  mctc2 = rot_apply(mctr1, mctc1);
  mcposachannel_15_analyzer_1_center = coords_add(mcposakidney_channel_15, mctc2);
  mctc1 = coords_sub(mcposachannel_15_cave1_cyl1, mcposachannel_15_analyzer_1_center);
  mcposrchannel_15_analyzer_1_center = rot_apply(mcrotachannel_15_analyzer_1_center, mctc1);
  mcDEBUG_COMPONENT("channel_15_analyzer_1_center", mcposachannel_15_analyzer_1_center, mcrotachannel_15_analyzer_1_center)
  mccomp_posa[698] = mcposachannel_15_analyzer_1_center;
  mccomp_posr[698] = mcposrchannel_15_analyzer_1_center;
  mcNCounter[698]  = mcPCounter[698] = mcP2Counter[698] = 0;
  mcAbsorbProp[698]= 0;
    /* Component channel_15_analyzer_1_rotated. */
  /* Setting parameters for component channel_15_analyzer_1_rotated. */
  SIG_MESSAGE("channel_15_analyzer_1_rotated (Init:SetPar)");

  SIG_MESSAGE("channel_15_analyzer_1_rotated (Init:Place/Rotate)");
  rot_set_rotation(mctr1,
#line 3872 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 3872 "MACS_sample_kidney_box.instr"
    (180 - analyzer_theta [ 15 ])*DEG2RAD,
#line 3872 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD);
#line 136973 "MACS_sample_kidney_box.c"
  rot_mul(mctr1, mcrotachannel_15_analyzer_1_center, mcrotachannel_15_analyzer_1_rotated);
  rot_transpose(mcrotachannel_15_analyzer_1_center, mctr1);
  rot_mul(mcrotachannel_15_analyzer_1_rotated, mctr1, mcrotrchannel_15_analyzer_1_rotated);
  mctc1 = coords_set(
#line 3871 "MACS_sample_kidney_box.instr"
    0,
#line 3871 "MACS_sample_kidney_box.instr"
    0,
#line 3871 "MACS_sample_kidney_box.instr"
    -0.5 * analyzer_seperation / tan ( analyzer_2theta [ 15 ] * DEG2RAD ));
#line 136984 "MACS_sample_kidney_box.c"
  rot_transpose(mcrotachannel_15_analyzer_1_center, mctr1);
  mctc2 = rot_apply(mctr1, mctc1);
  mcposachannel_15_analyzer_1_rotated = coords_add(mcposachannel_15_analyzer_1_center, mctc2);
  mctc1 = coords_sub(mcposachannel_15_analyzer_1_center, mcposachannel_15_analyzer_1_rotated);
  mcposrchannel_15_analyzer_1_rotated = rot_apply(mcrotachannel_15_analyzer_1_rotated, mctc1);
  mcDEBUG_COMPONENT("channel_15_analyzer_1_rotated", mcposachannel_15_analyzer_1_rotated, mcrotachannel_15_analyzer_1_rotated)
  mccomp_posa[699] = mcposachannel_15_analyzer_1_rotated;
  mccomp_posr[699] = mcposrchannel_15_analyzer_1_rotated;
  mcNCounter[699]  = mcPCounter[699] = mcP2Counter[699] = 0;
  mcAbsorbProp[699]= 0;
    /* Component channel_15_analyzer_1_array_crystal_array_0. */
  /* Setting parameters for component channel_15_analyzer_1_array_crystal_array_0. */
  SIG_MESSAGE("channel_15_analyzer_1_array_crystal_array_0 (Init:SetPar)");
#line 3876 "MACS_sample_kidney_box.instr"
  if("PG_analyzer") strncpy(mccchannel_15_analyzer_1_array_crystal_array_0_material_string, "PG_analyzer" ? "PG_analyzer" : "", 16384); else mccchannel_15_analyzer_1_array_crystal_array_0_material_string[0]='\0';
#line 3876 "MACS_sample_kidney_box.instr"
  mccchannel_15_analyzer_1_array_crystal_array_0_priority = 1720.0;
#line 3875 "MACS_sample_kidney_box.instr"
  mccchannel_15_analyzer_1_array_crystal_array_0_xwidth = channel_15_analyzer_1_array_crystal_depth;
#line 3875 "MACS_sample_kidney_box.instr"
  mccchannel_15_analyzer_1_array_crystal_array_0_yheight = channel_15_analyzer_1_array_crystal_height;
#line 3875 "MACS_sample_kidney_box.instr"
  mccchannel_15_analyzer_1_array_crystal_array_0_zdepth = channel_15_analyzer_1_array_crystal_width;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_15_analyzer_1_array_crystal_array_0_xwidth2 = -1;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_15_analyzer_1_array_crystal_array_0_yheight2 = -1;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_15_analyzer_1_array_crystal_array_0_visualize = 1;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_15_analyzer_1_array_crystal_array_0_target_index = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_15_analyzer_1_array_crystal_array_0_target_x = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_15_analyzer_1_array_crystal_array_0_target_y = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_15_analyzer_1_array_crystal_array_0_target_z = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_15_analyzer_1_array_crystal_array_0_focus_aw = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_15_analyzer_1_array_crystal_array_0_focus_ah = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_15_analyzer_1_array_crystal_array_0_focus_xw = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_15_analyzer_1_array_crystal_array_0_focus_xh = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_15_analyzer_1_array_crystal_array_0_focus_r = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_15_analyzer_1_array_crystal_array_0_p_interact = 0;
#line 71 "MACS_sample_kidney_box.instr"
  if(0) strncpy(mccchannel_15_analyzer_1_array_crystal_array_0_mask_string, 0 ? 0 : "", 16384); else mccchannel_15_analyzer_1_array_crystal_array_0_mask_string[0]='\0';
#line 71 "MACS_sample_kidney_box.instr"
  if(0) strncpy(mccchannel_15_analyzer_1_array_crystal_array_0_mask_setting, 0 ? 0 : "", 16384); else mccchannel_15_analyzer_1_array_crystal_array_0_mask_setting[0]='\0';
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_15_analyzer_1_array_crystal_array_0_number_of_activations = 1;
#line 137040 "MACS_sample_kidney_box.c"

  SIG_MESSAGE("channel_15_analyzer_1_array_crystal_array_0 (Init:Place/Rotate)");
  rot_set_rotation(mctr1,
#line 3878 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 3878 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 3878 "MACS_sample_kidney_box.instr"
    (0 - RAD2DEG * channel_15_analyzer_1_array_theta [ 0 ])*DEG2RAD);
#line 137050 "MACS_sample_kidney_box.c"
  rot_mul(mctr1, mcrotachannel_15_analyzer_1_rotated, mcrotachannel_15_analyzer_1_array_crystal_array_0);
  rot_transpose(mcrotachannel_15_analyzer_1_rotated, mctr1);
  rot_mul(mcrotachannel_15_analyzer_1_array_crystal_array_0, mctr1, mcrotrchannel_15_analyzer_1_array_crystal_array_0);
  mctc1 = coords_set(
#line 3877 "MACS_sample_kidney_box.instr"
    0 + channel_15_analyzer_1_array_effective_radius_of_curvature * ( 1 - cos ( channel_15_analyzer_1_array_theta [ 0 ] ) ),
#line 3877 "MACS_sample_kidney_box.instr"
    0 + channel_15_analyzer_1_array_effective_radius_of_curvature * sin ( channel_15_analyzer_1_array_theta [ 0 ] ),
#line 3877 "MACS_sample_kidney_box.instr"
    0);
#line 137061 "MACS_sample_kidney_box.c"
  rot_transpose(mcrotachannel_15_analyzer_1_rotated, mctr1);
  mctc2 = rot_apply(mctr1, mctc1);
  mcposachannel_15_analyzer_1_array_crystal_array_0 = coords_add(mcposachannel_15_analyzer_1_rotated, mctc2);
  mctc1 = coords_sub(mcposachannel_15_analyzer_1_rotated, mcposachannel_15_analyzer_1_array_crystal_array_0);
  mcposrchannel_15_analyzer_1_array_crystal_array_0 = rot_apply(mcrotachannel_15_analyzer_1_array_crystal_array_0, mctc1);
  mcDEBUG_COMPONENT("channel_15_analyzer_1_array_crystal_array_0", mcposachannel_15_analyzer_1_array_crystal_array_0, mcrotachannel_15_analyzer_1_array_crystal_array_0)
  mccomp_posa[700] = mcposachannel_15_analyzer_1_array_crystal_array_0;
  mccomp_posr[700] = mcposrchannel_15_analyzer_1_array_crystal_array_0;
  mcNCounter[700]  = mcPCounter[700] = mcP2Counter[700] = 0;
  mcAbsorbProp[700]= 0;
    /* Component channel_15_analyzer_1_array_crystal_array_1. */
  /* Setting parameters for component channel_15_analyzer_1_array_crystal_array_1. */
  SIG_MESSAGE("channel_15_analyzer_1_array_crystal_array_1 (Init:SetPar)");
#line 3882 "MACS_sample_kidney_box.instr"
  if("PG_analyzer") strncpy(mccchannel_15_analyzer_1_array_crystal_array_1_material_string, "PG_analyzer" ? "PG_analyzer" : "", 16384); else mccchannel_15_analyzer_1_array_crystal_array_1_material_string[0]='\0';
#line 3882 "MACS_sample_kidney_box.instr"
  mccchannel_15_analyzer_1_array_crystal_array_1_priority = 1720.1;
#line 3881 "MACS_sample_kidney_box.instr"
  mccchannel_15_analyzer_1_array_crystal_array_1_xwidth = channel_15_analyzer_1_array_crystal_depth;
#line 3881 "MACS_sample_kidney_box.instr"
  mccchannel_15_analyzer_1_array_crystal_array_1_yheight = channel_15_analyzer_1_array_crystal_height;
#line 3881 "MACS_sample_kidney_box.instr"
  mccchannel_15_analyzer_1_array_crystal_array_1_zdepth = channel_15_analyzer_1_array_crystal_width;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_15_analyzer_1_array_crystal_array_1_xwidth2 = -1;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_15_analyzer_1_array_crystal_array_1_yheight2 = -1;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_15_analyzer_1_array_crystal_array_1_visualize = 1;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_15_analyzer_1_array_crystal_array_1_target_index = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_15_analyzer_1_array_crystal_array_1_target_x = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_15_analyzer_1_array_crystal_array_1_target_y = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_15_analyzer_1_array_crystal_array_1_target_z = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_15_analyzer_1_array_crystal_array_1_focus_aw = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_15_analyzer_1_array_crystal_array_1_focus_ah = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_15_analyzer_1_array_crystal_array_1_focus_xw = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_15_analyzer_1_array_crystal_array_1_focus_xh = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_15_analyzer_1_array_crystal_array_1_focus_r = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_15_analyzer_1_array_crystal_array_1_p_interact = 0;
#line 71 "MACS_sample_kidney_box.instr"
  if(0) strncpy(mccchannel_15_analyzer_1_array_crystal_array_1_mask_string, 0 ? 0 : "", 16384); else mccchannel_15_analyzer_1_array_crystal_array_1_mask_string[0]='\0';
#line 71 "MACS_sample_kidney_box.instr"
  if(0) strncpy(mccchannel_15_analyzer_1_array_crystal_array_1_mask_setting, 0 ? 0 : "", 16384); else mccchannel_15_analyzer_1_array_crystal_array_1_mask_setting[0]='\0';
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_15_analyzer_1_array_crystal_array_1_number_of_activations = 1;
#line 137117 "MACS_sample_kidney_box.c"

  SIG_MESSAGE("channel_15_analyzer_1_array_crystal_array_1 (Init:Place/Rotate)");
  rot_set_rotation(mctr1,
#line 3884 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 3884 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 3884 "MACS_sample_kidney_box.instr"
    (0 - RAD2DEG * channel_15_analyzer_1_array_theta [ 1 ])*DEG2RAD);
#line 137127 "MACS_sample_kidney_box.c"
  rot_mul(mctr1, mcrotachannel_15_analyzer_1_rotated, mcrotachannel_15_analyzer_1_array_crystal_array_1);
  rot_transpose(mcrotachannel_15_analyzer_1_array_crystal_array_0, mctr1);
  rot_mul(mcrotachannel_15_analyzer_1_array_crystal_array_1, mctr1, mcrotrchannel_15_analyzer_1_array_crystal_array_1);
  mctc1 = coords_set(
#line 3883 "MACS_sample_kidney_box.instr"
    0 + channel_15_analyzer_1_array_effective_radius_of_curvature * ( 1 - cos ( channel_15_analyzer_1_array_theta [ 1 ] ) ),
#line 3883 "MACS_sample_kidney_box.instr"
    0 + channel_15_analyzer_1_array_effective_radius_of_curvature * sin ( channel_15_analyzer_1_array_theta [ 1 ] ),
#line 3883 "MACS_sample_kidney_box.instr"
    0);
#line 137138 "MACS_sample_kidney_box.c"
  rot_transpose(mcrotachannel_15_analyzer_1_rotated, mctr1);
  mctc2 = rot_apply(mctr1, mctc1);
  mcposachannel_15_analyzer_1_array_crystal_array_1 = coords_add(mcposachannel_15_analyzer_1_rotated, mctc2);
  mctc1 = coords_sub(mcposachannel_15_analyzer_1_array_crystal_array_0, mcposachannel_15_analyzer_1_array_crystal_array_1);
  mcposrchannel_15_analyzer_1_array_crystal_array_1 = rot_apply(mcrotachannel_15_analyzer_1_array_crystal_array_1, mctc1);
  mcDEBUG_COMPONENT("channel_15_analyzer_1_array_crystal_array_1", mcposachannel_15_analyzer_1_array_crystal_array_1, mcrotachannel_15_analyzer_1_array_crystal_array_1)
  mccomp_posa[701] = mcposachannel_15_analyzer_1_array_crystal_array_1;
  mccomp_posr[701] = mcposrchannel_15_analyzer_1_array_crystal_array_1;
  mcNCounter[701]  = mcPCounter[701] = mcP2Counter[701] = 0;
  mcAbsorbProp[701]= 0;
    /* Component channel_15_analyzer_1_array_crystal_array_2. */
  /* Setting parameters for component channel_15_analyzer_1_array_crystal_array_2. */
  SIG_MESSAGE("channel_15_analyzer_1_array_crystal_array_2 (Init:SetPar)");
#line 3888 "MACS_sample_kidney_box.instr"
  if("PG_analyzer") strncpy(mccchannel_15_analyzer_1_array_crystal_array_2_material_string, "PG_analyzer" ? "PG_analyzer" : "", 16384); else mccchannel_15_analyzer_1_array_crystal_array_2_material_string[0]='\0';
#line 3888 "MACS_sample_kidney_box.instr"
  mccchannel_15_analyzer_1_array_crystal_array_2_priority = 1720.2;
#line 3887 "MACS_sample_kidney_box.instr"
  mccchannel_15_analyzer_1_array_crystal_array_2_xwidth = channel_15_analyzer_1_array_crystal_depth;
#line 3887 "MACS_sample_kidney_box.instr"
  mccchannel_15_analyzer_1_array_crystal_array_2_yheight = channel_15_analyzer_1_array_crystal_height;
#line 3887 "MACS_sample_kidney_box.instr"
  mccchannel_15_analyzer_1_array_crystal_array_2_zdepth = channel_15_analyzer_1_array_crystal_width;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_15_analyzer_1_array_crystal_array_2_xwidth2 = -1;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_15_analyzer_1_array_crystal_array_2_yheight2 = -1;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_15_analyzer_1_array_crystal_array_2_visualize = 1;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_15_analyzer_1_array_crystal_array_2_target_index = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_15_analyzer_1_array_crystal_array_2_target_x = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_15_analyzer_1_array_crystal_array_2_target_y = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_15_analyzer_1_array_crystal_array_2_target_z = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_15_analyzer_1_array_crystal_array_2_focus_aw = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_15_analyzer_1_array_crystal_array_2_focus_ah = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_15_analyzer_1_array_crystal_array_2_focus_xw = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_15_analyzer_1_array_crystal_array_2_focus_xh = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_15_analyzer_1_array_crystal_array_2_focus_r = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_15_analyzer_1_array_crystal_array_2_p_interact = 0;
#line 71 "MACS_sample_kidney_box.instr"
  if(0) strncpy(mccchannel_15_analyzer_1_array_crystal_array_2_mask_string, 0 ? 0 : "", 16384); else mccchannel_15_analyzer_1_array_crystal_array_2_mask_string[0]='\0';
#line 71 "MACS_sample_kidney_box.instr"
  if(0) strncpy(mccchannel_15_analyzer_1_array_crystal_array_2_mask_setting, 0 ? 0 : "", 16384); else mccchannel_15_analyzer_1_array_crystal_array_2_mask_setting[0]='\0';
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_15_analyzer_1_array_crystal_array_2_number_of_activations = 1;
#line 137194 "MACS_sample_kidney_box.c"

  SIG_MESSAGE("channel_15_analyzer_1_array_crystal_array_2 (Init:Place/Rotate)");
  rot_set_rotation(mctr1,
#line 3890 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 3890 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 3890 "MACS_sample_kidney_box.instr"
    (0 - RAD2DEG * channel_15_analyzer_1_array_theta [ 2 ])*DEG2RAD);
#line 137204 "MACS_sample_kidney_box.c"
  rot_mul(mctr1, mcrotachannel_15_analyzer_1_rotated, mcrotachannel_15_analyzer_1_array_crystal_array_2);
  rot_transpose(mcrotachannel_15_analyzer_1_array_crystal_array_1, mctr1);
  rot_mul(mcrotachannel_15_analyzer_1_array_crystal_array_2, mctr1, mcrotrchannel_15_analyzer_1_array_crystal_array_2);
  mctc1 = coords_set(
#line 3889 "MACS_sample_kidney_box.instr"
    0 + channel_15_analyzer_1_array_effective_radius_of_curvature * ( 1 - cos ( channel_15_analyzer_1_array_theta [ 2 ] ) ),
#line 3889 "MACS_sample_kidney_box.instr"
    0 + channel_15_analyzer_1_array_effective_radius_of_curvature * sin ( channel_15_analyzer_1_array_theta [ 2 ] ),
#line 3889 "MACS_sample_kidney_box.instr"
    0);
#line 137215 "MACS_sample_kidney_box.c"
  rot_transpose(mcrotachannel_15_analyzer_1_rotated, mctr1);
  mctc2 = rot_apply(mctr1, mctc1);
  mcposachannel_15_analyzer_1_array_crystal_array_2 = coords_add(mcposachannel_15_analyzer_1_rotated, mctc2);
  mctc1 = coords_sub(mcposachannel_15_analyzer_1_array_crystal_array_1, mcposachannel_15_analyzer_1_array_crystal_array_2);
  mcposrchannel_15_analyzer_1_array_crystal_array_2 = rot_apply(mcrotachannel_15_analyzer_1_array_crystal_array_2, mctc1);
  mcDEBUG_COMPONENT("channel_15_analyzer_1_array_crystal_array_2", mcposachannel_15_analyzer_1_array_crystal_array_2, mcrotachannel_15_analyzer_1_array_crystal_array_2)
  mccomp_posa[702] = mcposachannel_15_analyzer_1_array_crystal_array_2;
  mccomp_posr[702] = mcposrchannel_15_analyzer_1_array_crystal_array_2;
  mcNCounter[702]  = mcPCounter[702] = mcP2Counter[702] = 0;
  mcAbsorbProp[702]= 0;
    /* Component channel_15_analyzer_1_array_crystal_array_3. */
  /* Setting parameters for component channel_15_analyzer_1_array_crystal_array_3. */
  SIG_MESSAGE("channel_15_analyzer_1_array_crystal_array_3 (Init:SetPar)");
#line 3894 "MACS_sample_kidney_box.instr"
  if("PG_analyzer") strncpy(mccchannel_15_analyzer_1_array_crystal_array_3_material_string, "PG_analyzer" ? "PG_analyzer" : "", 16384); else mccchannel_15_analyzer_1_array_crystal_array_3_material_string[0]='\0';
#line 3894 "MACS_sample_kidney_box.instr"
  mccchannel_15_analyzer_1_array_crystal_array_3_priority = 1720.3;
#line 3893 "MACS_sample_kidney_box.instr"
  mccchannel_15_analyzer_1_array_crystal_array_3_xwidth = channel_15_analyzer_1_array_crystal_depth;
#line 3893 "MACS_sample_kidney_box.instr"
  mccchannel_15_analyzer_1_array_crystal_array_3_yheight = channel_15_analyzer_1_array_crystal_height;
#line 3893 "MACS_sample_kidney_box.instr"
  mccchannel_15_analyzer_1_array_crystal_array_3_zdepth = channel_15_analyzer_1_array_crystal_width;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_15_analyzer_1_array_crystal_array_3_xwidth2 = -1;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_15_analyzer_1_array_crystal_array_3_yheight2 = -1;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_15_analyzer_1_array_crystal_array_3_visualize = 1;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_15_analyzer_1_array_crystal_array_3_target_index = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_15_analyzer_1_array_crystal_array_3_target_x = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_15_analyzer_1_array_crystal_array_3_target_y = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_15_analyzer_1_array_crystal_array_3_target_z = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_15_analyzer_1_array_crystal_array_3_focus_aw = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_15_analyzer_1_array_crystal_array_3_focus_ah = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_15_analyzer_1_array_crystal_array_3_focus_xw = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_15_analyzer_1_array_crystal_array_3_focus_xh = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_15_analyzer_1_array_crystal_array_3_focus_r = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_15_analyzer_1_array_crystal_array_3_p_interact = 0;
#line 71 "MACS_sample_kidney_box.instr"
  if(0) strncpy(mccchannel_15_analyzer_1_array_crystal_array_3_mask_string, 0 ? 0 : "", 16384); else mccchannel_15_analyzer_1_array_crystal_array_3_mask_string[0]='\0';
#line 71 "MACS_sample_kidney_box.instr"
  if(0) strncpy(mccchannel_15_analyzer_1_array_crystal_array_3_mask_setting, 0 ? 0 : "", 16384); else mccchannel_15_analyzer_1_array_crystal_array_3_mask_setting[0]='\0';
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_15_analyzer_1_array_crystal_array_3_number_of_activations = 1;
#line 137271 "MACS_sample_kidney_box.c"

  SIG_MESSAGE("channel_15_analyzer_1_array_crystal_array_3 (Init:Place/Rotate)");
  rot_set_rotation(mctr1,
#line 3896 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 3896 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 3896 "MACS_sample_kidney_box.instr"
    (0 - RAD2DEG * channel_15_analyzer_1_array_theta [ 3 ])*DEG2RAD);
#line 137281 "MACS_sample_kidney_box.c"
  rot_mul(mctr1, mcrotachannel_15_analyzer_1_rotated, mcrotachannel_15_analyzer_1_array_crystal_array_3);
  rot_transpose(mcrotachannel_15_analyzer_1_array_crystal_array_2, mctr1);
  rot_mul(mcrotachannel_15_analyzer_1_array_crystal_array_3, mctr1, mcrotrchannel_15_analyzer_1_array_crystal_array_3);
  mctc1 = coords_set(
#line 3895 "MACS_sample_kidney_box.instr"
    0 + channel_15_analyzer_1_array_effective_radius_of_curvature * ( 1 - cos ( channel_15_analyzer_1_array_theta [ 3 ] ) ),
#line 3895 "MACS_sample_kidney_box.instr"
    0 + channel_15_analyzer_1_array_effective_radius_of_curvature * sin ( channel_15_analyzer_1_array_theta [ 3 ] ),
#line 3895 "MACS_sample_kidney_box.instr"
    0);
#line 137292 "MACS_sample_kidney_box.c"
  rot_transpose(mcrotachannel_15_analyzer_1_rotated, mctr1);
  mctc2 = rot_apply(mctr1, mctc1);
  mcposachannel_15_analyzer_1_array_crystal_array_3 = coords_add(mcposachannel_15_analyzer_1_rotated, mctc2);
  mctc1 = coords_sub(mcposachannel_15_analyzer_1_array_crystal_array_2, mcposachannel_15_analyzer_1_array_crystal_array_3);
  mcposrchannel_15_analyzer_1_array_crystal_array_3 = rot_apply(mcrotachannel_15_analyzer_1_array_crystal_array_3, mctc1);
  mcDEBUG_COMPONENT("channel_15_analyzer_1_array_crystal_array_3", mcposachannel_15_analyzer_1_array_crystal_array_3, mcrotachannel_15_analyzer_1_array_crystal_array_3)
  mccomp_posa[703] = mcposachannel_15_analyzer_1_array_crystal_array_3;
  mccomp_posr[703] = mcposrchannel_15_analyzer_1_array_crystal_array_3;
  mcNCounter[703]  = mcPCounter[703] = mcP2Counter[703] = 0;
  mcAbsorbProp[703]= 0;
    /* Component channel_15_analyzer_1_array_crystal_array_4. */
  /* Setting parameters for component channel_15_analyzer_1_array_crystal_array_4. */
  SIG_MESSAGE("channel_15_analyzer_1_array_crystal_array_4 (Init:SetPar)");
#line 3900 "MACS_sample_kidney_box.instr"
  if("PG_analyzer") strncpy(mccchannel_15_analyzer_1_array_crystal_array_4_material_string, "PG_analyzer" ? "PG_analyzer" : "", 16384); else mccchannel_15_analyzer_1_array_crystal_array_4_material_string[0]='\0';
#line 3900 "MACS_sample_kidney_box.instr"
  mccchannel_15_analyzer_1_array_crystal_array_4_priority = 1720.4;
#line 3899 "MACS_sample_kidney_box.instr"
  mccchannel_15_analyzer_1_array_crystal_array_4_xwidth = channel_15_analyzer_1_array_crystal_depth;
#line 3899 "MACS_sample_kidney_box.instr"
  mccchannel_15_analyzer_1_array_crystal_array_4_yheight = channel_15_analyzer_1_array_crystal_height;
#line 3899 "MACS_sample_kidney_box.instr"
  mccchannel_15_analyzer_1_array_crystal_array_4_zdepth = channel_15_analyzer_1_array_crystal_width;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_15_analyzer_1_array_crystal_array_4_xwidth2 = -1;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_15_analyzer_1_array_crystal_array_4_yheight2 = -1;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_15_analyzer_1_array_crystal_array_4_visualize = 1;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_15_analyzer_1_array_crystal_array_4_target_index = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_15_analyzer_1_array_crystal_array_4_target_x = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_15_analyzer_1_array_crystal_array_4_target_y = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_15_analyzer_1_array_crystal_array_4_target_z = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_15_analyzer_1_array_crystal_array_4_focus_aw = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_15_analyzer_1_array_crystal_array_4_focus_ah = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_15_analyzer_1_array_crystal_array_4_focus_xw = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_15_analyzer_1_array_crystal_array_4_focus_xh = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_15_analyzer_1_array_crystal_array_4_focus_r = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_15_analyzer_1_array_crystal_array_4_p_interact = 0;
#line 71 "MACS_sample_kidney_box.instr"
  if(0) strncpy(mccchannel_15_analyzer_1_array_crystal_array_4_mask_string, 0 ? 0 : "", 16384); else mccchannel_15_analyzer_1_array_crystal_array_4_mask_string[0]='\0';
#line 71 "MACS_sample_kidney_box.instr"
  if(0) strncpy(mccchannel_15_analyzer_1_array_crystal_array_4_mask_setting, 0 ? 0 : "", 16384); else mccchannel_15_analyzer_1_array_crystal_array_4_mask_setting[0]='\0';
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_15_analyzer_1_array_crystal_array_4_number_of_activations = 1;
#line 137348 "MACS_sample_kidney_box.c"

  SIG_MESSAGE("channel_15_analyzer_1_array_crystal_array_4 (Init:Place/Rotate)");
  rot_set_rotation(mctr1,
#line 3902 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 3902 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 3902 "MACS_sample_kidney_box.instr"
    (0 - RAD2DEG * channel_15_analyzer_1_array_theta [ 4 ])*DEG2RAD);
#line 137358 "MACS_sample_kidney_box.c"
  rot_mul(mctr1, mcrotachannel_15_analyzer_1_rotated, mcrotachannel_15_analyzer_1_array_crystal_array_4);
  rot_transpose(mcrotachannel_15_analyzer_1_array_crystal_array_3, mctr1);
  rot_mul(mcrotachannel_15_analyzer_1_array_crystal_array_4, mctr1, mcrotrchannel_15_analyzer_1_array_crystal_array_4);
  mctc1 = coords_set(
#line 3901 "MACS_sample_kidney_box.instr"
    0 + channel_15_analyzer_1_array_effective_radius_of_curvature * ( 1 - cos ( channel_15_analyzer_1_array_theta [ 4 ] ) ),
#line 3901 "MACS_sample_kidney_box.instr"
    0 + channel_15_analyzer_1_array_effective_radius_of_curvature * sin ( channel_15_analyzer_1_array_theta [ 4 ] ),
#line 3901 "MACS_sample_kidney_box.instr"
    0);
#line 137369 "MACS_sample_kidney_box.c"
  rot_transpose(mcrotachannel_15_analyzer_1_rotated, mctr1);
  mctc2 = rot_apply(mctr1, mctc1);
  mcposachannel_15_analyzer_1_array_crystal_array_4 = coords_add(mcposachannel_15_analyzer_1_rotated, mctc2);
  mctc1 = coords_sub(mcposachannel_15_analyzer_1_array_crystal_array_3, mcposachannel_15_analyzer_1_array_crystal_array_4);
  mcposrchannel_15_analyzer_1_array_crystal_array_4 = rot_apply(mcrotachannel_15_analyzer_1_array_crystal_array_4, mctc1);
  mcDEBUG_COMPONENT("channel_15_analyzer_1_array_crystal_array_4", mcposachannel_15_analyzer_1_array_crystal_array_4, mcrotachannel_15_analyzer_1_array_crystal_array_4)
  mccomp_posa[704] = mcposachannel_15_analyzer_1_array_crystal_array_4;
  mccomp_posr[704] = mcposrchannel_15_analyzer_1_array_crystal_array_4;
  mcNCounter[704]  = mcPCounter[704] = mcP2Counter[704] = 0;
  mcAbsorbProp[704]= 0;
    /* Component channel_15_analyzer_1_array_crystal_array_5. */
  /* Setting parameters for component channel_15_analyzer_1_array_crystal_array_5. */
  SIG_MESSAGE("channel_15_analyzer_1_array_crystal_array_5 (Init:SetPar)");
#line 3906 "MACS_sample_kidney_box.instr"
  if("PG_analyzer") strncpy(mccchannel_15_analyzer_1_array_crystal_array_5_material_string, "PG_analyzer" ? "PG_analyzer" : "", 16384); else mccchannel_15_analyzer_1_array_crystal_array_5_material_string[0]='\0';
#line 3906 "MACS_sample_kidney_box.instr"
  mccchannel_15_analyzer_1_array_crystal_array_5_priority = 1720.5;
#line 3905 "MACS_sample_kidney_box.instr"
  mccchannel_15_analyzer_1_array_crystal_array_5_xwidth = channel_15_analyzer_1_array_crystal_depth;
#line 3905 "MACS_sample_kidney_box.instr"
  mccchannel_15_analyzer_1_array_crystal_array_5_yheight = channel_15_analyzer_1_array_crystal_height;
#line 3905 "MACS_sample_kidney_box.instr"
  mccchannel_15_analyzer_1_array_crystal_array_5_zdepth = channel_15_analyzer_1_array_crystal_width;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_15_analyzer_1_array_crystal_array_5_xwidth2 = -1;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_15_analyzer_1_array_crystal_array_5_yheight2 = -1;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_15_analyzer_1_array_crystal_array_5_visualize = 1;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_15_analyzer_1_array_crystal_array_5_target_index = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_15_analyzer_1_array_crystal_array_5_target_x = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_15_analyzer_1_array_crystal_array_5_target_y = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_15_analyzer_1_array_crystal_array_5_target_z = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_15_analyzer_1_array_crystal_array_5_focus_aw = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_15_analyzer_1_array_crystal_array_5_focus_ah = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_15_analyzer_1_array_crystal_array_5_focus_xw = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_15_analyzer_1_array_crystal_array_5_focus_xh = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_15_analyzer_1_array_crystal_array_5_focus_r = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_15_analyzer_1_array_crystal_array_5_p_interact = 0;
#line 71 "MACS_sample_kidney_box.instr"
  if(0) strncpy(mccchannel_15_analyzer_1_array_crystal_array_5_mask_string, 0 ? 0 : "", 16384); else mccchannel_15_analyzer_1_array_crystal_array_5_mask_string[0]='\0';
#line 71 "MACS_sample_kidney_box.instr"
  if(0) strncpy(mccchannel_15_analyzer_1_array_crystal_array_5_mask_setting, 0 ? 0 : "", 16384); else mccchannel_15_analyzer_1_array_crystal_array_5_mask_setting[0]='\0';
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_15_analyzer_1_array_crystal_array_5_number_of_activations = 1;
#line 137425 "MACS_sample_kidney_box.c"

  SIG_MESSAGE("channel_15_analyzer_1_array_crystal_array_5 (Init:Place/Rotate)");
  rot_set_rotation(mctr1,
#line 3908 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 3908 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 3908 "MACS_sample_kidney_box.instr"
    (0 - RAD2DEG * channel_15_analyzer_1_array_theta [ 5 ])*DEG2RAD);
#line 137435 "MACS_sample_kidney_box.c"
  rot_mul(mctr1, mcrotachannel_15_analyzer_1_rotated, mcrotachannel_15_analyzer_1_array_crystal_array_5);
  rot_transpose(mcrotachannel_15_analyzer_1_array_crystal_array_4, mctr1);
  rot_mul(mcrotachannel_15_analyzer_1_array_crystal_array_5, mctr1, mcrotrchannel_15_analyzer_1_array_crystal_array_5);
  mctc1 = coords_set(
#line 3907 "MACS_sample_kidney_box.instr"
    0 + channel_15_analyzer_1_array_effective_radius_of_curvature * ( 1 - cos ( channel_15_analyzer_1_array_theta [ 5 ] ) ),
#line 3907 "MACS_sample_kidney_box.instr"
    0 + channel_15_analyzer_1_array_effective_radius_of_curvature * sin ( channel_15_analyzer_1_array_theta [ 5 ] ),
#line 3907 "MACS_sample_kidney_box.instr"
    0);
#line 137446 "MACS_sample_kidney_box.c"
  rot_transpose(mcrotachannel_15_analyzer_1_rotated, mctr1);
  mctc2 = rot_apply(mctr1, mctc1);
  mcposachannel_15_analyzer_1_array_crystal_array_5 = coords_add(mcposachannel_15_analyzer_1_rotated, mctc2);
  mctc1 = coords_sub(mcposachannel_15_analyzer_1_array_crystal_array_4, mcposachannel_15_analyzer_1_array_crystal_array_5);
  mcposrchannel_15_analyzer_1_array_crystal_array_5 = rot_apply(mcrotachannel_15_analyzer_1_array_crystal_array_5, mctc1);
  mcDEBUG_COMPONENT("channel_15_analyzer_1_array_crystal_array_5", mcposachannel_15_analyzer_1_array_crystal_array_5, mcrotachannel_15_analyzer_1_array_crystal_array_5)
  mccomp_posa[705] = mcposachannel_15_analyzer_1_array_crystal_array_5;
  mccomp_posr[705] = mcposrchannel_15_analyzer_1_array_crystal_array_5;
  mcNCounter[705]  = mcPCounter[705] = mcP2Counter[705] = 0;
  mcAbsorbProp[705]= 0;
    /* Component channel_15_analyzer_1_array_crystal_array_6. */
  /* Setting parameters for component channel_15_analyzer_1_array_crystal_array_6. */
  SIG_MESSAGE("channel_15_analyzer_1_array_crystal_array_6 (Init:SetPar)");
#line 3912 "MACS_sample_kidney_box.instr"
  if("PG_analyzer") strncpy(mccchannel_15_analyzer_1_array_crystal_array_6_material_string, "PG_analyzer" ? "PG_analyzer" : "", 16384); else mccchannel_15_analyzer_1_array_crystal_array_6_material_string[0]='\0';
#line 3912 "MACS_sample_kidney_box.instr"
  mccchannel_15_analyzer_1_array_crystal_array_6_priority = 1720.6;
#line 3911 "MACS_sample_kidney_box.instr"
  mccchannel_15_analyzer_1_array_crystal_array_6_xwidth = channel_15_analyzer_1_array_crystal_depth;
#line 3911 "MACS_sample_kidney_box.instr"
  mccchannel_15_analyzer_1_array_crystal_array_6_yheight = channel_15_analyzer_1_array_crystal_height;
#line 3911 "MACS_sample_kidney_box.instr"
  mccchannel_15_analyzer_1_array_crystal_array_6_zdepth = channel_15_analyzer_1_array_crystal_width;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_15_analyzer_1_array_crystal_array_6_xwidth2 = -1;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_15_analyzer_1_array_crystal_array_6_yheight2 = -1;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_15_analyzer_1_array_crystal_array_6_visualize = 1;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_15_analyzer_1_array_crystal_array_6_target_index = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_15_analyzer_1_array_crystal_array_6_target_x = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_15_analyzer_1_array_crystal_array_6_target_y = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_15_analyzer_1_array_crystal_array_6_target_z = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_15_analyzer_1_array_crystal_array_6_focus_aw = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_15_analyzer_1_array_crystal_array_6_focus_ah = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_15_analyzer_1_array_crystal_array_6_focus_xw = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_15_analyzer_1_array_crystal_array_6_focus_xh = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_15_analyzer_1_array_crystal_array_6_focus_r = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_15_analyzer_1_array_crystal_array_6_p_interact = 0;
#line 71 "MACS_sample_kidney_box.instr"
  if(0) strncpy(mccchannel_15_analyzer_1_array_crystal_array_6_mask_string, 0 ? 0 : "", 16384); else mccchannel_15_analyzer_1_array_crystal_array_6_mask_string[0]='\0';
#line 71 "MACS_sample_kidney_box.instr"
  if(0) strncpy(mccchannel_15_analyzer_1_array_crystal_array_6_mask_setting, 0 ? 0 : "", 16384); else mccchannel_15_analyzer_1_array_crystal_array_6_mask_setting[0]='\0';
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_15_analyzer_1_array_crystal_array_6_number_of_activations = 1;
#line 137502 "MACS_sample_kidney_box.c"

  SIG_MESSAGE("channel_15_analyzer_1_array_crystal_array_6 (Init:Place/Rotate)");
  rot_set_rotation(mctr1,
#line 3914 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 3914 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 3914 "MACS_sample_kidney_box.instr"
    (0 - RAD2DEG * channel_15_analyzer_1_array_theta [ 6 ])*DEG2RAD);
#line 137512 "MACS_sample_kidney_box.c"
  rot_mul(mctr1, mcrotachannel_15_analyzer_1_rotated, mcrotachannel_15_analyzer_1_array_crystal_array_6);
  rot_transpose(mcrotachannel_15_analyzer_1_array_crystal_array_5, mctr1);
  rot_mul(mcrotachannel_15_analyzer_1_array_crystal_array_6, mctr1, mcrotrchannel_15_analyzer_1_array_crystal_array_6);
  mctc1 = coords_set(
#line 3913 "MACS_sample_kidney_box.instr"
    0 + channel_15_analyzer_1_array_effective_radius_of_curvature * ( 1 - cos ( channel_15_analyzer_1_array_theta [ 6 ] ) ),
#line 3913 "MACS_sample_kidney_box.instr"
    0 + channel_15_analyzer_1_array_effective_radius_of_curvature * sin ( channel_15_analyzer_1_array_theta [ 6 ] ),
#line 3913 "MACS_sample_kidney_box.instr"
    0);
#line 137523 "MACS_sample_kidney_box.c"
  rot_transpose(mcrotachannel_15_analyzer_1_rotated, mctr1);
  mctc2 = rot_apply(mctr1, mctc1);
  mcposachannel_15_analyzer_1_array_crystal_array_6 = coords_add(mcposachannel_15_analyzer_1_rotated, mctc2);
  mctc1 = coords_sub(mcposachannel_15_analyzer_1_array_crystal_array_5, mcposachannel_15_analyzer_1_array_crystal_array_6);
  mcposrchannel_15_analyzer_1_array_crystal_array_6 = rot_apply(mcrotachannel_15_analyzer_1_array_crystal_array_6, mctc1);
  mcDEBUG_COMPONENT("channel_15_analyzer_1_array_crystal_array_6", mcposachannel_15_analyzer_1_array_crystal_array_6, mcrotachannel_15_analyzer_1_array_crystal_array_6)
  mccomp_posa[706] = mcposachannel_15_analyzer_1_array_crystal_array_6;
  mccomp_posr[706] = mcposrchannel_15_analyzer_1_array_crystal_array_6;
  mcNCounter[706]  = mcPCounter[706] = mcP2Counter[706] = 0;
  mcAbsorbProp[706]= 0;
    /* Component channel_15_analyzer_1_array_crystal_array_7. */
  /* Setting parameters for component channel_15_analyzer_1_array_crystal_array_7. */
  SIG_MESSAGE("channel_15_analyzer_1_array_crystal_array_7 (Init:SetPar)");
#line 3918 "MACS_sample_kidney_box.instr"
  if("PG_analyzer") strncpy(mccchannel_15_analyzer_1_array_crystal_array_7_material_string, "PG_analyzer" ? "PG_analyzer" : "", 16384); else mccchannel_15_analyzer_1_array_crystal_array_7_material_string[0]='\0';
#line 3918 "MACS_sample_kidney_box.instr"
  mccchannel_15_analyzer_1_array_crystal_array_7_priority = 1720.7;
#line 3917 "MACS_sample_kidney_box.instr"
  mccchannel_15_analyzer_1_array_crystal_array_7_xwidth = channel_15_analyzer_1_array_crystal_depth;
#line 3917 "MACS_sample_kidney_box.instr"
  mccchannel_15_analyzer_1_array_crystal_array_7_yheight = channel_15_analyzer_1_array_crystal_height;
#line 3917 "MACS_sample_kidney_box.instr"
  mccchannel_15_analyzer_1_array_crystal_array_7_zdepth = channel_15_analyzer_1_array_crystal_width;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_15_analyzer_1_array_crystal_array_7_xwidth2 = -1;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_15_analyzer_1_array_crystal_array_7_yheight2 = -1;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_15_analyzer_1_array_crystal_array_7_visualize = 1;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_15_analyzer_1_array_crystal_array_7_target_index = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_15_analyzer_1_array_crystal_array_7_target_x = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_15_analyzer_1_array_crystal_array_7_target_y = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_15_analyzer_1_array_crystal_array_7_target_z = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_15_analyzer_1_array_crystal_array_7_focus_aw = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_15_analyzer_1_array_crystal_array_7_focus_ah = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_15_analyzer_1_array_crystal_array_7_focus_xw = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_15_analyzer_1_array_crystal_array_7_focus_xh = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_15_analyzer_1_array_crystal_array_7_focus_r = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_15_analyzer_1_array_crystal_array_7_p_interact = 0;
#line 71 "MACS_sample_kidney_box.instr"
  if(0) strncpy(mccchannel_15_analyzer_1_array_crystal_array_7_mask_string, 0 ? 0 : "", 16384); else mccchannel_15_analyzer_1_array_crystal_array_7_mask_string[0]='\0';
#line 71 "MACS_sample_kidney_box.instr"
  if(0) strncpy(mccchannel_15_analyzer_1_array_crystal_array_7_mask_setting, 0 ? 0 : "", 16384); else mccchannel_15_analyzer_1_array_crystal_array_7_mask_setting[0]='\0';
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_15_analyzer_1_array_crystal_array_7_number_of_activations = 1;
#line 137579 "MACS_sample_kidney_box.c"

  SIG_MESSAGE("channel_15_analyzer_1_array_crystal_array_7 (Init:Place/Rotate)");
  rot_set_rotation(mctr1,
#line 3920 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 3920 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 3920 "MACS_sample_kidney_box.instr"
    (0 - RAD2DEG * channel_15_analyzer_1_array_theta [ 7 ])*DEG2RAD);
#line 137589 "MACS_sample_kidney_box.c"
  rot_mul(mctr1, mcrotachannel_15_analyzer_1_rotated, mcrotachannel_15_analyzer_1_array_crystal_array_7);
  rot_transpose(mcrotachannel_15_analyzer_1_array_crystal_array_6, mctr1);
  rot_mul(mcrotachannel_15_analyzer_1_array_crystal_array_7, mctr1, mcrotrchannel_15_analyzer_1_array_crystal_array_7);
  mctc1 = coords_set(
#line 3919 "MACS_sample_kidney_box.instr"
    0 + channel_15_analyzer_1_array_effective_radius_of_curvature * ( 1 - cos ( channel_15_analyzer_1_array_theta [ 7 ] ) ),
#line 3919 "MACS_sample_kidney_box.instr"
    0 + channel_15_analyzer_1_array_effective_radius_of_curvature * sin ( channel_15_analyzer_1_array_theta [ 7 ] ),
#line 3919 "MACS_sample_kidney_box.instr"
    0);
#line 137600 "MACS_sample_kidney_box.c"
  rot_transpose(mcrotachannel_15_analyzer_1_rotated, mctr1);
  mctc2 = rot_apply(mctr1, mctc1);
  mcposachannel_15_analyzer_1_array_crystal_array_7 = coords_add(mcposachannel_15_analyzer_1_rotated, mctc2);
  mctc1 = coords_sub(mcposachannel_15_analyzer_1_array_crystal_array_6, mcposachannel_15_analyzer_1_array_crystal_array_7);
  mcposrchannel_15_analyzer_1_array_crystal_array_7 = rot_apply(mcrotachannel_15_analyzer_1_array_crystal_array_7, mctc1);
  mcDEBUG_COMPONENT("channel_15_analyzer_1_array_crystal_array_7", mcposachannel_15_analyzer_1_array_crystal_array_7, mcrotachannel_15_analyzer_1_array_crystal_array_7)
  mccomp_posa[707] = mcposachannel_15_analyzer_1_array_crystal_array_7;
  mccomp_posr[707] = mcposrchannel_15_analyzer_1_array_crystal_array_7;
  mcNCounter[707]  = mcPCounter[707] = mcP2Counter[707] = 0;
  mcAbsorbProp[707]= 0;
    /* Component channel_15_analyzer_1_array_crystal_array_8. */
  /* Setting parameters for component channel_15_analyzer_1_array_crystal_array_8. */
  SIG_MESSAGE("channel_15_analyzer_1_array_crystal_array_8 (Init:SetPar)");
#line 3924 "MACS_sample_kidney_box.instr"
  if("PG_analyzer") strncpy(mccchannel_15_analyzer_1_array_crystal_array_8_material_string, "PG_analyzer" ? "PG_analyzer" : "", 16384); else mccchannel_15_analyzer_1_array_crystal_array_8_material_string[0]='\0';
#line 3924 "MACS_sample_kidney_box.instr"
  mccchannel_15_analyzer_1_array_crystal_array_8_priority = 1720.8;
#line 3923 "MACS_sample_kidney_box.instr"
  mccchannel_15_analyzer_1_array_crystal_array_8_xwidth = channel_15_analyzer_1_array_crystal_depth;
#line 3923 "MACS_sample_kidney_box.instr"
  mccchannel_15_analyzer_1_array_crystal_array_8_yheight = channel_15_analyzer_1_array_crystal_height;
#line 3923 "MACS_sample_kidney_box.instr"
  mccchannel_15_analyzer_1_array_crystal_array_8_zdepth = channel_15_analyzer_1_array_crystal_width;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_15_analyzer_1_array_crystal_array_8_xwidth2 = -1;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_15_analyzer_1_array_crystal_array_8_yheight2 = -1;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_15_analyzer_1_array_crystal_array_8_visualize = 1;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_15_analyzer_1_array_crystal_array_8_target_index = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_15_analyzer_1_array_crystal_array_8_target_x = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_15_analyzer_1_array_crystal_array_8_target_y = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_15_analyzer_1_array_crystal_array_8_target_z = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_15_analyzer_1_array_crystal_array_8_focus_aw = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_15_analyzer_1_array_crystal_array_8_focus_ah = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_15_analyzer_1_array_crystal_array_8_focus_xw = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_15_analyzer_1_array_crystal_array_8_focus_xh = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_15_analyzer_1_array_crystal_array_8_focus_r = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_15_analyzer_1_array_crystal_array_8_p_interact = 0;
#line 71 "MACS_sample_kidney_box.instr"
  if(0) strncpy(mccchannel_15_analyzer_1_array_crystal_array_8_mask_string, 0 ? 0 : "", 16384); else mccchannel_15_analyzer_1_array_crystal_array_8_mask_string[0]='\0';
#line 71 "MACS_sample_kidney_box.instr"
  if(0) strncpy(mccchannel_15_analyzer_1_array_crystal_array_8_mask_setting, 0 ? 0 : "", 16384); else mccchannel_15_analyzer_1_array_crystal_array_8_mask_setting[0]='\0';
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_15_analyzer_1_array_crystal_array_8_number_of_activations = 1;
#line 137656 "MACS_sample_kidney_box.c"

  SIG_MESSAGE("channel_15_analyzer_1_array_crystal_array_8 (Init:Place/Rotate)");
  rot_set_rotation(mctr1,
#line 3926 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 3926 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 3926 "MACS_sample_kidney_box.instr"
    (0 - RAD2DEG * channel_15_analyzer_1_array_theta [ 8 ])*DEG2RAD);
#line 137666 "MACS_sample_kidney_box.c"
  rot_mul(mctr1, mcrotachannel_15_analyzer_1_rotated, mcrotachannel_15_analyzer_1_array_crystal_array_8);
  rot_transpose(mcrotachannel_15_analyzer_1_array_crystal_array_7, mctr1);
  rot_mul(mcrotachannel_15_analyzer_1_array_crystal_array_8, mctr1, mcrotrchannel_15_analyzer_1_array_crystal_array_8);
  mctc1 = coords_set(
#line 3925 "MACS_sample_kidney_box.instr"
    0 + channel_15_analyzer_1_array_effective_radius_of_curvature * ( 1 - cos ( channel_15_analyzer_1_array_theta [ 8 ] ) ),
#line 3925 "MACS_sample_kidney_box.instr"
    0 + channel_15_analyzer_1_array_effective_radius_of_curvature * sin ( channel_15_analyzer_1_array_theta [ 8 ] ),
#line 3925 "MACS_sample_kidney_box.instr"
    0);
#line 137677 "MACS_sample_kidney_box.c"
  rot_transpose(mcrotachannel_15_analyzer_1_rotated, mctr1);
  mctc2 = rot_apply(mctr1, mctc1);
  mcposachannel_15_analyzer_1_array_crystal_array_8 = coords_add(mcposachannel_15_analyzer_1_rotated, mctc2);
  mctc1 = coords_sub(mcposachannel_15_analyzer_1_array_crystal_array_7, mcposachannel_15_analyzer_1_array_crystal_array_8);
  mcposrchannel_15_analyzer_1_array_crystal_array_8 = rot_apply(mcrotachannel_15_analyzer_1_array_crystal_array_8, mctc1);
  mcDEBUG_COMPONENT("channel_15_analyzer_1_array_crystal_array_8", mcposachannel_15_analyzer_1_array_crystal_array_8, mcrotachannel_15_analyzer_1_array_crystal_array_8)
  mccomp_posa[708] = mcposachannel_15_analyzer_1_array_crystal_array_8;
  mccomp_posr[708] = mcposrchannel_15_analyzer_1_array_crystal_array_8;
  mcNCounter[708]  = mcPCounter[708] = mcP2Counter[708] = 0;
  mcAbsorbProp[708]= 0;
    /* Component channel_15_analyzer_2_center. */
  /* Setting parameters for component channel_15_analyzer_2_center. */
  SIG_MESSAGE("channel_15_analyzer_2_center (Init:SetPar)");

  SIG_MESSAGE("channel_15_analyzer_2_center (Init:Place/Rotate)");
  rot_set_rotation(mctr1,
    (0.0)*DEG2RAD,
    (0.0)*DEG2RAD,
    (0.0)*DEG2RAD);
#line 137697 "MACS_sample_kidney_box.c"
  rot_mul(mctr1, mcrotachannel_15_analyzer_1_center, mcrotachannel_15_analyzer_2_center);
  rot_transpose(mcrotachannel_15_analyzer_1_array_crystal_array_8, mctr1);
  rot_mul(mcrotachannel_15_analyzer_2_center, mctr1, mcrotrchannel_15_analyzer_2_center);
  mctc1 = coords_set(
#line 3930 "MACS_sample_kidney_box.instr"
    - analyzer_seperation,
#line 3930 "MACS_sample_kidney_box.instr"
    0,
#line 3930 "MACS_sample_kidney_box.instr"
    0);
#line 137708 "MACS_sample_kidney_box.c"
  rot_transpose(mcrotachannel_15_analyzer_1_center, mctr1);
  mctc2 = rot_apply(mctr1, mctc1);
  mcposachannel_15_analyzer_2_center = coords_add(mcposachannel_15_analyzer_1_center, mctc2);
  mctc1 = coords_sub(mcposachannel_15_analyzer_1_array_crystal_array_8, mcposachannel_15_analyzer_2_center);
  mcposrchannel_15_analyzer_2_center = rot_apply(mcrotachannel_15_analyzer_2_center, mctc1);
  mcDEBUG_COMPONENT("channel_15_analyzer_2_center", mcposachannel_15_analyzer_2_center, mcrotachannel_15_analyzer_2_center)
  mccomp_posa[709] = mcposachannel_15_analyzer_2_center;
  mccomp_posr[709] = mcposrchannel_15_analyzer_2_center;
  mcNCounter[709]  = mcPCounter[709] = mcP2Counter[709] = 0;
  mcAbsorbProp[709]= 0;
    /* Component channel_15_analyzer_2_rotated. */
  /* Setting parameters for component channel_15_analyzer_2_rotated. */
  SIG_MESSAGE("channel_15_analyzer_2_rotated (Init:SetPar)");

  SIG_MESSAGE("channel_15_analyzer_2_rotated (Init:Place/Rotate)");
  rot_set_rotation(mctr1,
#line 3934 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 3934 "MACS_sample_kidney_box.instr"
    (- analyzer_theta [ 15 ])*DEG2RAD,
#line 3934 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD);
#line 137731 "MACS_sample_kidney_box.c"
  rot_mul(mctr1, mcrotachannel_15_analyzer_2_center, mcrotachannel_15_analyzer_2_rotated);
  rot_transpose(mcrotachannel_15_analyzer_2_center, mctr1);
  rot_mul(mcrotachannel_15_analyzer_2_rotated, mctr1, mcrotrchannel_15_analyzer_2_rotated);
  mctc1 = coords_set(
#line 3933 "MACS_sample_kidney_box.instr"
    0,
#line 3933 "MACS_sample_kidney_box.instr"
    0,
#line 3933 "MACS_sample_kidney_box.instr"
    0.5 * analyzer_seperation / tan ( analyzer_2theta [ 15 ] * DEG2RAD ));
#line 137742 "MACS_sample_kidney_box.c"
  rot_transpose(mcrotachannel_15_analyzer_2_center, mctr1);
  mctc2 = rot_apply(mctr1, mctc1);
  mcposachannel_15_analyzer_2_rotated = coords_add(mcposachannel_15_analyzer_2_center, mctc2);
  mctc1 = coords_sub(mcposachannel_15_analyzer_2_center, mcposachannel_15_analyzer_2_rotated);
  mcposrchannel_15_analyzer_2_rotated = rot_apply(mcrotachannel_15_analyzer_2_rotated, mctc1);
  mcDEBUG_COMPONENT("channel_15_analyzer_2_rotated", mcposachannel_15_analyzer_2_rotated, mcrotachannel_15_analyzer_2_rotated)
  mccomp_posa[710] = mcposachannel_15_analyzer_2_rotated;
  mccomp_posr[710] = mcposrchannel_15_analyzer_2_rotated;
  mcNCounter[710]  = mcPCounter[710] = mcP2Counter[710] = 0;
  mcAbsorbProp[710]= 0;
    /* Component channel_15_analyzer_2_array_crystal_array_0. */
  /* Setting parameters for component channel_15_analyzer_2_array_crystal_array_0. */
  SIG_MESSAGE("channel_15_analyzer_2_array_crystal_array_0 (Init:SetPar)");
#line 3938 "MACS_sample_kidney_box.instr"
  if("PG_analyzer") strncpy(mccchannel_15_analyzer_2_array_crystal_array_0_material_string, "PG_analyzer" ? "PG_analyzer" : "", 16384); else mccchannel_15_analyzer_2_array_crystal_array_0_material_string[0]='\0';
#line 3938 "MACS_sample_kidney_box.instr"
  mccchannel_15_analyzer_2_array_crystal_array_0_priority = 1721.0;
#line 3937 "MACS_sample_kidney_box.instr"
  mccchannel_15_analyzer_2_array_crystal_array_0_xwidth = channel_15_analyzer_2_array_crystal_depth;
#line 3937 "MACS_sample_kidney_box.instr"
  mccchannel_15_analyzer_2_array_crystal_array_0_yheight = channel_15_analyzer_2_array_crystal_height;
#line 3937 "MACS_sample_kidney_box.instr"
  mccchannel_15_analyzer_2_array_crystal_array_0_zdepth = channel_15_analyzer_2_array_crystal_width;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_15_analyzer_2_array_crystal_array_0_xwidth2 = -1;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_15_analyzer_2_array_crystal_array_0_yheight2 = -1;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_15_analyzer_2_array_crystal_array_0_visualize = 1;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_15_analyzer_2_array_crystal_array_0_target_index = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_15_analyzer_2_array_crystal_array_0_target_x = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_15_analyzer_2_array_crystal_array_0_target_y = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_15_analyzer_2_array_crystal_array_0_target_z = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_15_analyzer_2_array_crystal_array_0_focus_aw = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_15_analyzer_2_array_crystal_array_0_focus_ah = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_15_analyzer_2_array_crystal_array_0_focus_xw = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_15_analyzer_2_array_crystal_array_0_focus_xh = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_15_analyzer_2_array_crystal_array_0_focus_r = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_15_analyzer_2_array_crystal_array_0_p_interact = 0;
#line 71 "MACS_sample_kidney_box.instr"
  if(0) strncpy(mccchannel_15_analyzer_2_array_crystal_array_0_mask_string, 0 ? 0 : "", 16384); else mccchannel_15_analyzer_2_array_crystal_array_0_mask_string[0]='\0';
#line 71 "MACS_sample_kidney_box.instr"
  if(0) strncpy(mccchannel_15_analyzer_2_array_crystal_array_0_mask_setting, 0 ? 0 : "", 16384); else mccchannel_15_analyzer_2_array_crystal_array_0_mask_setting[0]='\0';
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_15_analyzer_2_array_crystal_array_0_number_of_activations = 1;
#line 137798 "MACS_sample_kidney_box.c"

  SIG_MESSAGE("channel_15_analyzer_2_array_crystal_array_0 (Init:Place/Rotate)");
  rot_set_rotation(mctr1,
#line 3940 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 3940 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 3940 "MACS_sample_kidney_box.instr"
    (0 - RAD2DEG * channel_15_analyzer_2_array_theta [ 0 ])*DEG2RAD);
#line 137808 "MACS_sample_kidney_box.c"
  rot_mul(mctr1, mcrotachannel_15_analyzer_2_rotated, mcrotachannel_15_analyzer_2_array_crystal_array_0);
  rot_transpose(mcrotachannel_15_analyzer_2_rotated, mctr1);
  rot_mul(mcrotachannel_15_analyzer_2_array_crystal_array_0, mctr1, mcrotrchannel_15_analyzer_2_array_crystal_array_0);
  mctc1 = coords_set(
#line 3939 "MACS_sample_kidney_box.instr"
    0 + channel_15_analyzer_2_array_effective_radius_of_curvature * ( 1 - cos ( channel_15_analyzer_2_array_theta [ 0 ] ) ),
#line 3939 "MACS_sample_kidney_box.instr"
    0 + channel_15_analyzer_2_array_effective_radius_of_curvature * sin ( channel_15_analyzer_2_array_theta [ 0 ] ),
#line 3939 "MACS_sample_kidney_box.instr"
    0);
#line 137819 "MACS_sample_kidney_box.c"
  rot_transpose(mcrotachannel_15_analyzer_2_rotated, mctr1);
  mctc2 = rot_apply(mctr1, mctc1);
  mcposachannel_15_analyzer_2_array_crystal_array_0 = coords_add(mcposachannel_15_analyzer_2_rotated, mctc2);
  mctc1 = coords_sub(mcposachannel_15_analyzer_2_rotated, mcposachannel_15_analyzer_2_array_crystal_array_0);
  mcposrchannel_15_analyzer_2_array_crystal_array_0 = rot_apply(mcrotachannel_15_analyzer_2_array_crystal_array_0, mctc1);
  mcDEBUG_COMPONENT("channel_15_analyzer_2_array_crystal_array_0", mcposachannel_15_analyzer_2_array_crystal_array_0, mcrotachannel_15_analyzer_2_array_crystal_array_0)
  mccomp_posa[711] = mcposachannel_15_analyzer_2_array_crystal_array_0;
  mccomp_posr[711] = mcposrchannel_15_analyzer_2_array_crystal_array_0;
  mcNCounter[711]  = mcPCounter[711] = mcP2Counter[711] = 0;
  mcAbsorbProp[711]= 0;
    /* Component channel_15_analyzer_2_array_crystal_array_1. */
  /* Setting parameters for component channel_15_analyzer_2_array_crystal_array_1. */
  SIG_MESSAGE("channel_15_analyzer_2_array_crystal_array_1 (Init:SetPar)");
#line 3944 "MACS_sample_kidney_box.instr"
  if("PG_analyzer") strncpy(mccchannel_15_analyzer_2_array_crystal_array_1_material_string, "PG_analyzer" ? "PG_analyzer" : "", 16384); else mccchannel_15_analyzer_2_array_crystal_array_1_material_string[0]='\0';
#line 3944 "MACS_sample_kidney_box.instr"
  mccchannel_15_analyzer_2_array_crystal_array_1_priority = 1721.1;
#line 3943 "MACS_sample_kidney_box.instr"
  mccchannel_15_analyzer_2_array_crystal_array_1_xwidth = channel_15_analyzer_2_array_crystal_depth;
#line 3943 "MACS_sample_kidney_box.instr"
  mccchannel_15_analyzer_2_array_crystal_array_1_yheight = channel_15_analyzer_2_array_crystal_height;
#line 3943 "MACS_sample_kidney_box.instr"
  mccchannel_15_analyzer_2_array_crystal_array_1_zdepth = channel_15_analyzer_2_array_crystal_width;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_15_analyzer_2_array_crystal_array_1_xwidth2 = -1;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_15_analyzer_2_array_crystal_array_1_yheight2 = -1;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_15_analyzer_2_array_crystal_array_1_visualize = 1;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_15_analyzer_2_array_crystal_array_1_target_index = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_15_analyzer_2_array_crystal_array_1_target_x = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_15_analyzer_2_array_crystal_array_1_target_y = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_15_analyzer_2_array_crystal_array_1_target_z = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_15_analyzer_2_array_crystal_array_1_focus_aw = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_15_analyzer_2_array_crystal_array_1_focus_ah = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_15_analyzer_2_array_crystal_array_1_focus_xw = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_15_analyzer_2_array_crystal_array_1_focus_xh = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_15_analyzer_2_array_crystal_array_1_focus_r = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_15_analyzer_2_array_crystal_array_1_p_interact = 0;
#line 71 "MACS_sample_kidney_box.instr"
  if(0) strncpy(mccchannel_15_analyzer_2_array_crystal_array_1_mask_string, 0 ? 0 : "", 16384); else mccchannel_15_analyzer_2_array_crystal_array_1_mask_string[0]='\0';
#line 71 "MACS_sample_kidney_box.instr"
  if(0) strncpy(mccchannel_15_analyzer_2_array_crystal_array_1_mask_setting, 0 ? 0 : "", 16384); else mccchannel_15_analyzer_2_array_crystal_array_1_mask_setting[0]='\0';
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_15_analyzer_2_array_crystal_array_1_number_of_activations = 1;
#line 137875 "MACS_sample_kidney_box.c"

  SIG_MESSAGE("channel_15_analyzer_2_array_crystal_array_1 (Init:Place/Rotate)");
  rot_set_rotation(mctr1,
#line 3946 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 3946 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 3946 "MACS_sample_kidney_box.instr"
    (0 - RAD2DEG * channel_15_analyzer_2_array_theta [ 1 ])*DEG2RAD);
#line 137885 "MACS_sample_kidney_box.c"
  rot_mul(mctr1, mcrotachannel_15_analyzer_2_rotated, mcrotachannel_15_analyzer_2_array_crystal_array_1);
  rot_transpose(mcrotachannel_15_analyzer_2_array_crystal_array_0, mctr1);
  rot_mul(mcrotachannel_15_analyzer_2_array_crystal_array_1, mctr1, mcrotrchannel_15_analyzer_2_array_crystal_array_1);
  mctc1 = coords_set(
#line 3945 "MACS_sample_kidney_box.instr"
    0 + channel_15_analyzer_2_array_effective_radius_of_curvature * ( 1 - cos ( channel_15_analyzer_2_array_theta [ 1 ] ) ),
#line 3945 "MACS_sample_kidney_box.instr"
    0 + channel_15_analyzer_2_array_effective_radius_of_curvature * sin ( channel_15_analyzer_2_array_theta [ 1 ] ),
#line 3945 "MACS_sample_kidney_box.instr"
    0);
#line 137896 "MACS_sample_kidney_box.c"
  rot_transpose(mcrotachannel_15_analyzer_2_rotated, mctr1);
  mctc2 = rot_apply(mctr1, mctc1);
  mcposachannel_15_analyzer_2_array_crystal_array_1 = coords_add(mcposachannel_15_analyzer_2_rotated, mctc2);
  mctc1 = coords_sub(mcposachannel_15_analyzer_2_array_crystal_array_0, mcposachannel_15_analyzer_2_array_crystal_array_1);
  mcposrchannel_15_analyzer_2_array_crystal_array_1 = rot_apply(mcrotachannel_15_analyzer_2_array_crystal_array_1, mctc1);
  mcDEBUG_COMPONENT("channel_15_analyzer_2_array_crystal_array_1", mcposachannel_15_analyzer_2_array_crystal_array_1, mcrotachannel_15_analyzer_2_array_crystal_array_1)
  mccomp_posa[712] = mcposachannel_15_analyzer_2_array_crystal_array_1;
  mccomp_posr[712] = mcposrchannel_15_analyzer_2_array_crystal_array_1;
  mcNCounter[712]  = mcPCounter[712] = mcP2Counter[712] = 0;
  mcAbsorbProp[712]= 0;
    /* Component channel_15_analyzer_2_array_crystal_array_2. */
  /* Setting parameters for component channel_15_analyzer_2_array_crystal_array_2. */
  SIG_MESSAGE("channel_15_analyzer_2_array_crystal_array_2 (Init:SetPar)");
#line 3950 "MACS_sample_kidney_box.instr"
  if("PG_analyzer") strncpy(mccchannel_15_analyzer_2_array_crystal_array_2_material_string, "PG_analyzer" ? "PG_analyzer" : "", 16384); else mccchannel_15_analyzer_2_array_crystal_array_2_material_string[0]='\0';
#line 3950 "MACS_sample_kidney_box.instr"
  mccchannel_15_analyzer_2_array_crystal_array_2_priority = 1721.2;
#line 3949 "MACS_sample_kidney_box.instr"
  mccchannel_15_analyzer_2_array_crystal_array_2_xwidth = channel_15_analyzer_2_array_crystal_depth;
#line 3949 "MACS_sample_kidney_box.instr"
  mccchannel_15_analyzer_2_array_crystal_array_2_yheight = channel_15_analyzer_2_array_crystal_height;
#line 3949 "MACS_sample_kidney_box.instr"
  mccchannel_15_analyzer_2_array_crystal_array_2_zdepth = channel_15_analyzer_2_array_crystal_width;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_15_analyzer_2_array_crystal_array_2_xwidth2 = -1;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_15_analyzer_2_array_crystal_array_2_yheight2 = -1;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_15_analyzer_2_array_crystal_array_2_visualize = 1;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_15_analyzer_2_array_crystal_array_2_target_index = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_15_analyzer_2_array_crystal_array_2_target_x = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_15_analyzer_2_array_crystal_array_2_target_y = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_15_analyzer_2_array_crystal_array_2_target_z = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_15_analyzer_2_array_crystal_array_2_focus_aw = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_15_analyzer_2_array_crystal_array_2_focus_ah = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_15_analyzer_2_array_crystal_array_2_focus_xw = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_15_analyzer_2_array_crystal_array_2_focus_xh = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_15_analyzer_2_array_crystal_array_2_focus_r = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_15_analyzer_2_array_crystal_array_2_p_interact = 0;
#line 71 "MACS_sample_kidney_box.instr"
  if(0) strncpy(mccchannel_15_analyzer_2_array_crystal_array_2_mask_string, 0 ? 0 : "", 16384); else mccchannel_15_analyzer_2_array_crystal_array_2_mask_string[0]='\0';
#line 71 "MACS_sample_kidney_box.instr"
  if(0) strncpy(mccchannel_15_analyzer_2_array_crystal_array_2_mask_setting, 0 ? 0 : "", 16384); else mccchannel_15_analyzer_2_array_crystal_array_2_mask_setting[0]='\0';
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_15_analyzer_2_array_crystal_array_2_number_of_activations = 1;
#line 137952 "MACS_sample_kidney_box.c"

  SIG_MESSAGE("channel_15_analyzer_2_array_crystal_array_2 (Init:Place/Rotate)");
  rot_set_rotation(mctr1,
#line 3952 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 3952 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 3952 "MACS_sample_kidney_box.instr"
    (0 - RAD2DEG * channel_15_analyzer_2_array_theta [ 2 ])*DEG2RAD);
#line 137962 "MACS_sample_kidney_box.c"
  rot_mul(mctr1, mcrotachannel_15_analyzer_2_rotated, mcrotachannel_15_analyzer_2_array_crystal_array_2);
  rot_transpose(mcrotachannel_15_analyzer_2_array_crystal_array_1, mctr1);
  rot_mul(mcrotachannel_15_analyzer_2_array_crystal_array_2, mctr1, mcrotrchannel_15_analyzer_2_array_crystal_array_2);
  mctc1 = coords_set(
#line 3951 "MACS_sample_kidney_box.instr"
    0 + channel_15_analyzer_2_array_effective_radius_of_curvature * ( 1 - cos ( channel_15_analyzer_2_array_theta [ 2 ] ) ),
#line 3951 "MACS_sample_kidney_box.instr"
    0 + channel_15_analyzer_2_array_effective_radius_of_curvature * sin ( channel_15_analyzer_2_array_theta [ 2 ] ),
#line 3951 "MACS_sample_kidney_box.instr"
    0);
#line 137973 "MACS_sample_kidney_box.c"
  rot_transpose(mcrotachannel_15_analyzer_2_rotated, mctr1);
  mctc2 = rot_apply(mctr1, mctc1);
  mcposachannel_15_analyzer_2_array_crystal_array_2 = coords_add(mcposachannel_15_analyzer_2_rotated, mctc2);
  mctc1 = coords_sub(mcposachannel_15_analyzer_2_array_crystal_array_1, mcposachannel_15_analyzer_2_array_crystal_array_2);
  mcposrchannel_15_analyzer_2_array_crystal_array_2 = rot_apply(mcrotachannel_15_analyzer_2_array_crystal_array_2, mctc1);
  mcDEBUG_COMPONENT("channel_15_analyzer_2_array_crystal_array_2", mcposachannel_15_analyzer_2_array_crystal_array_2, mcrotachannel_15_analyzer_2_array_crystal_array_2)
  mccomp_posa[713] = mcposachannel_15_analyzer_2_array_crystal_array_2;
  mccomp_posr[713] = mcposrchannel_15_analyzer_2_array_crystal_array_2;
  mcNCounter[713]  = mcPCounter[713] = mcP2Counter[713] = 0;
  mcAbsorbProp[713]= 0;
    /* Component channel_15_analyzer_2_array_crystal_array_3. */
  /* Setting parameters for component channel_15_analyzer_2_array_crystal_array_3. */
  SIG_MESSAGE("channel_15_analyzer_2_array_crystal_array_3 (Init:SetPar)");
#line 3956 "MACS_sample_kidney_box.instr"
  if("PG_analyzer") strncpy(mccchannel_15_analyzer_2_array_crystal_array_3_material_string, "PG_analyzer" ? "PG_analyzer" : "", 16384); else mccchannel_15_analyzer_2_array_crystal_array_3_material_string[0]='\0';
#line 3956 "MACS_sample_kidney_box.instr"
  mccchannel_15_analyzer_2_array_crystal_array_3_priority = 1721.3;
#line 3955 "MACS_sample_kidney_box.instr"
  mccchannel_15_analyzer_2_array_crystal_array_3_xwidth = channel_15_analyzer_2_array_crystal_depth;
#line 3955 "MACS_sample_kidney_box.instr"
  mccchannel_15_analyzer_2_array_crystal_array_3_yheight = channel_15_analyzer_2_array_crystal_height;
#line 3955 "MACS_sample_kidney_box.instr"
  mccchannel_15_analyzer_2_array_crystal_array_3_zdepth = channel_15_analyzer_2_array_crystal_width;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_15_analyzer_2_array_crystal_array_3_xwidth2 = -1;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_15_analyzer_2_array_crystal_array_3_yheight2 = -1;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_15_analyzer_2_array_crystal_array_3_visualize = 1;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_15_analyzer_2_array_crystal_array_3_target_index = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_15_analyzer_2_array_crystal_array_3_target_x = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_15_analyzer_2_array_crystal_array_3_target_y = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_15_analyzer_2_array_crystal_array_3_target_z = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_15_analyzer_2_array_crystal_array_3_focus_aw = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_15_analyzer_2_array_crystal_array_3_focus_ah = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_15_analyzer_2_array_crystal_array_3_focus_xw = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_15_analyzer_2_array_crystal_array_3_focus_xh = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_15_analyzer_2_array_crystal_array_3_focus_r = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_15_analyzer_2_array_crystal_array_3_p_interact = 0;
#line 71 "MACS_sample_kidney_box.instr"
  if(0) strncpy(mccchannel_15_analyzer_2_array_crystal_array_3_mask_string, 0 ? 0 : "", 16384); else mccchannel_15_analyzer_2_array_crystal_array_3_mask_string[0]='\0';
#line 71 "MACS_sample_kidney_box.instr"
  if(0) strncpy(mccchannel_15_analyzer_2_array_crystal_array_3_mask_setting, 0 ? 0 : "", 16384); else mccchannel_15_analyzer_2_array_crystal_array_3_mask_setting[0]='\0';
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_15_analyzer_2_array_crystal_array_3_number_of_activations = 1;
#line 138029 "MACS_sample_kidney_box.c"

  SIG_MESSAGE("channel_15_analyzer_2_array_crystal_array_3 (Init:Place/Rotate)");
  rot_set_rotation(mctr1,
#line 3958 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 3958 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 3958 "MACS_sample_kidney_box.instr"
    (0 - RAD2DEG * channel_15_analyzer_2_array_theta [ 3 ])*DEG2RAD);
#line 138039 "MACS_sample_kidney_box.c"
  rot_mul(mctr1, mcrotachannel_15_analyzer_2_rotated, mcrotachannel_15_analyzer_2_array_crystal_array_3);
  rot_transpose(mcrotachannel_15_analyzer_2_array_crystal_array_2, mctr1);
  rot_mul(mcrotachannel_15_analyzer_2_array_crystal_array_3, mctr1, mcrotrchannel_15_analyzer_2_array_crystal_array_3);
  mctc1 = coords_set(
#line 3957 "MACS_sample_kidney_box.instr"
    0 + channel_15_analyzer_2_array_effective_radius_of_curvature * ( 1 - cos ( channel_15_analyzer_2_array_theta [ 3 ] ) ),
#line 3957 "MACS_sample_kidney_box.instr"
    0 + channel_15_analyzer_2_array_effective_radius_of_curvature * sin ( channel_15_analyzer_2_array_theta [ 3 ] ),
#line 3957 "MACS_sample_kidney_box.instr"
    0);
#line 138050 "MACS_sample_kidney_box.c"
  rot_transpose(mcrotachannel_15_analyzer_2_rotated, mctr1);
  mctc2 = rot_apply(mctr1, mctc1);
  mcposachannel_15_analyzer_2_array_crystal_array_3 = coords_add(mcposachannel_15_analyzer_2_rotated, mctc2);
  mctc1 = coords_sub(mcposachannel_15_analyzer_2_array_crystal_array_2, mcposachannel_15_analyzer_2_array_crystal_array_3);
  mcposrchannel_15_analyzer_2_array_crystal_array_3 = rot_apply(mcrotachannel_15_analyzer_2_array_crystal_array_3, mctc1);
  mcDEBUG_COMPONENT("channel_15_analyzer_2_array_crystal_array_3", mcposachannel_15_analyzer_2_array_crystal_array_3, mcrotachannel_15_analyzer_2_array_crystal_array_3)
  mccomp_posa[714] = mcposachannel_15_analyzer_2_array_crystal_array_3;
  mccomp_posr[714] = mcposrchannel_15_analyzer_2_array_crystal_array_3;
  mcNCounter[714]  = mcPCounter[714] = mcP2Counter[714] = 0;
  mcAbsorbProp[714]= 0;
    /* Component channel_15_analyzer_2_array_crystal_array_4. */
  /* Setting parameters for component channel_15_analyzer_2_array_crystal_array_4. */
  SIG_MESSAGE("channel_15_analyzer_2_array_crystal_array_4 (Init:SetPar)");
#line 3962 "MACS_sample_kidney_box.instr"
  if("PG_analyzer") strncpy(mccchannel_15_analyzer_2_array_crystal_array_4_material_string, "PG_analyzer" ? "PG_analyzer" : "", 16384); else mccchannel_15_analyzer_2_array_crystal_array_4_material_string[0]='\0';
#line 3962 "MACS_sample_kidney_box.instr"
  mccchannel_15_analyzer_2_array_crystal_array_4_priority = 1721.4;
#line 3961 "MACS_sample_kidney_box.instr"
  mccchannel_15_analyzer_2_array_crystal_array_4_xwidth = channel_15_analyzer_2_array_crystal_depth;
#line 3961 "MACS_sample_kidney_box.instr"
  mccchannel_15_analyzer_2_array_crystal_array_4_yheight = channel_15_analyzer_2_array_crystal_height;
#line 3961 "MACS_sample_kidney_box.instr"
  mccchannel_15_analyzer_2_array_crystal_array_4_zdepth = channel_15_analyzer_2_array_crystal_width;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_15_analyzer_2_array_crystal_array_4_xwidth2 = -1;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_15_analyzer_2_array_crystal_array_4_yheight2 = -1;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_15_analyzer_2_array_crystal_array_4_visualize = 1;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_15_analyzer_2_array_crystal_array_4_target_index = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_15_analyzer_2_array_crystal_array_4_target_x = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_15_analyzer_2_array_crystal_array_4_target_y = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_15_analyzer_2_array_crystal_array_4_target_z = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_15_analyzer_2_array_crystal_array_4_focus_aw = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_15_analyzer_2_array_crystal_array_4_focus_ah = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_15_analyzer_2_array_crystal_array_4_focus_xw = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_15_analyzer_2_array_crystal_array_4_focus_xh = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_15_analyzer_2_array_crystal_array_4_focus_r = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_15_analyzer_2_array_crystal_array_4_p_interact = 0;
#line 71 "MACS_sample_kidney_box.instr"
  if(0) strncpy(mccchannel_15_analyzer_2_array_crystal_array_4_mask_string, 0 ? 0 : "", 16384); else mccchannel_15_analyzer_2_array_crystal_array_4_mask_string[0]='\0';
#line 71 "MACS_sample_kidney_box.instr"
  if(0) strncpy(mccchannel_15_analyzer_2_array_crystal_array_4_mask_setting, 0 ? 0 : "", 16384); else mccchannel_15_analyzer_2_array_crystal_array_4_mask_setting[0]='\0';
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_15_analyzer_2_array_crystal_array_4_number_of_activations = 1;
#line 138106 "MACS_sample_kidney_box.c"

  SIG_MESSAGE("channel_15_analyzer_2_array_crystal_array_4 (Init:Place/Rotate)");
  rot_set_rotation(mctr1,
#line 3964 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 3964 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 3964 "MACS_sample_kidney_box.instr"
    (0 - RAD2DEG * channel_15_analyzer_2_array_theta [ 4 ])*DEG2RAD);
#line 138116 "MACS_sample_kidney_box.c"
  rot_mul(mctr1, mcrotachannel_15_analyzer_2_rotated, mcrotachannel_15_analyzer_2_array_crystal_array_4);
  rot_transpose(mcrotachannel_15_analyzer_2_array_crystal_array_3, mctr1);
  rot_mul(mcrotachannel_15_analyzer_2_array_crystal_array_4, mctr1, mcrotrchannel_15_analyzer_2_array_crystal_array_4);
  mctc1 = coords_set(
#line 3963 "MACS_sample_kidney_box.instr"
    0 + channel_15_analyzer_2_array_effective_radius_of_curvature * ( 1 - cos ( channel_15_analyzer_2_array_theta [ 4 ] ) ),
#line 3963 "MACS_sample_kidney_box.instr"
    0 + channel_15_analyzer_2_array_effective_radius_of_curvature * sin ( channel_15_analyzer_2_array_theta [ 4 ] ),
#line 3963 "MACS_sample_kidney_box.instr"
    0);
#line 138127 "MACS_sample_kidney_box.c"
  rot_transpose(mcrotachannel_15_analyzer_2_rotated, mctr1);
  mctc2 = rot_apply(mctr1, mctc1);
  mcposachannel_15_analyzer_2_array_crystal_array_4 = coords_add(mcposachannel_15_analyzer_2_rotated, mctc2);
  mctc1 = coords_sub(mcposachannel_15_analyzer_2_array_crystal_array_3, mcposachannel_15_analyzer_2_array_crystal_array_4);
  mcposrchannel_15_analyzer_2_array_crystal_array_4 = rot_apply(mcrotachannel_15_analyzer_2_array_crystal_array_4, mctc1);
  mcDEBUG_COMPONENT("channel_15_analyzer_2_array_crystal_array_4", mcposachannel_15_analyzer_2_array_crystal_array_4, mcrotachannel_15_analyzer_2_array_crystal_array_4)
  mccomp_posa[715] = mcposachannel_15_analyzer_2_array_crystal_array_4;
  mccomp_posr[715] = mcposrchannel_15_analyzer_2_array_crystal_array_4;
  mcNCounter[715]  = mcPCounter[715] = mcP2Counter[715] = 0;
  mcAbsorbProp[715]= 0;
    /* Component channel_15_analyzer_2_array_crystal_array_5. */
  /* Setting parameters for component channel_15_analyzer_2_array_crystal_array_5. */
  SIG_MESSAGE("channel_15_analyzer_2_array_crystal_array_5 (Init:SetPar)");
#line 3968 "MACS_sample_kidney_box.instr"
  if("PG_analyzer") strncpy(mccchannel_15_analyzer_2_array_crystal_array_5_material_string, "PG_analyzer" ? "PG_analyzer" : "", 16384); else mccchannel_15_analyzer_2_array_crystal_array_5_material_string[0]='\0';
#line 3968 "MACS_sample_kidney_box.instr"
  mccchannel_15_analyzer_2_array_crystal_array_5_priority = 1721.5;
#line 3967 "MACS_sample_kidney_box.instr"
  mccchannel_15_analyzer_2_array_crystal_array_5_xwidth = channel_15_analyzer_2_array_crystal_depth;
#line 3967 "MACS_sample_kidney_box.instr"
  mccchannel_15_analyzer_2_array_crystal_array_5_yheight = channel_15_analyzer_2_array_crystal_height;
#line 3967 "MACS_sample_kidney_box.instr"
  mccchannel_15_analyzer_2_array_crystal_array_5_zdepth = channel_15_analyzer_2_array_crystal_width;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_15_analyzer_2_array_crystal_array_5_xwidth2 = -1;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_15_analyzer_2_array_crystal_array_5_yheight2 = -1;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_15_analyzer_2_array_crystal_array_5_visualize = 1;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_15_analyzer_2_array_crystal_array_5_target_index = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_15_analyzer_2_array_crystal_array_5_target_x = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_15_analyzer_2_array_crystal_array_5_target_y = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_15_analyzer_2_array_crystal_array_5_target_z = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_15_analyzer_2_array_crystal_array_5_focus_aw = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_15_analyzer_2_array_crystal_array_5_focus_ah = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_15_analyzer_2_array_crystal_array_5_focus_xw = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_15_analyzer_2_array_crystal_array_5_focus_xh = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_15_analyzer_2_array_crystal_array_5_focus_r = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_15_analyzer_2_array_crystal_array_5_p_interact = 0;
#line 71 "MACS_sample_kidney_box.instr"
  if(0) strncpy(mccchannel_15_analyzer_2_array_crystal_array_5_mask_string, 0 ? 0 : "", 16384); else mccchannel_15_analyzer_2_array_crystal_array_5_mask_string[0]='\0';
#line 71 "MACS_sample_kidney_box.instr"
  if(0) strncpy(mccchannel_15_analyzer_2_array_crystal_array_5_mask_setting, 0 ? 0 : "", 16384); else mccchannel_15_analyzer_2_array_crystal_array_5_mask_setting[0]='\0';
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_15_analyzer_2_array_crystal_array_5_number_of_activations = 1;
#line 138183 "MACS_sample_kidney_box.c"

  SIG_MESSAGE("channel_15_analyzer_2_array_crystal_array_5 (Init:Place/Rotate)");
  rot_set_rotation(mctr1,
#line 3970 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 3970 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 3970 "MACS_sample_kidney_box.instr"
    (0 - RAD2DEG * channel_15_analyzer_2_array_theta [ 5 ])*DEG2RAD);
#line 138193 "MACS_sample_kidney_box.c"
  rot_mul(mctr1, mcrotachannel_15_analyzer_2_rotated, mcrotachannel_15_analyzer_2_array_crystal_array_5);
  rot_transpose(mcrotachannel_15_analyzer_2_array_crystal_array_4, mctr1);
  rot_mul(mcrotachannel_15_analyzer_2_array_crystal_array_5, mctr1, mcrotrchannel_15_analyzer_2_array_crystal_array_5);
  mctc1 = coords_set(
#line 3969 "MACS_sample_kidney_box.instr"
    0 + channel_15_analyzer_2_array_effective_radius_of_curvature * ( 1 - cos ( channel_15_analyzer_2_array_theta [ 5 ] ) ),
#line 3969 "MACS_sample_kidney_box.instr"
    0 + channel_15_analyzer_2_array_effective_radius_of_curvature * sin ( channel_15_analyzer_2_array_theta [ 5 ] ),
#line 3969 "MACS_sample_kidney_box.instr"
    0);
#line 138204 "MACS_sample_kidney_box.c"
  rot_transpose(mcrotachannel_15_analyzer_2_rotated, mctr1);
  mctc2 = rot_apply(mctr1, mctc1);
  mcposachannel_15_analyzer_2_array_crystal_array_5 = coords_add(mcposachannel_15_analyzer_2_rotated, mctc2);
  mctc1 = coords_sub(mcposachannel_15_analyzer_2_array_crystal_array_4, mcposachannel_15_analyzer_2_array_crystal_array_5);
  mcposrchannel_15_analyzer_2_array_crystal_array_5 = rot_apply(mcrotachannel_15_analyzer_2_array_crystal_array_5, mctc1);
  mcDEBUG_COMPONENT("channel_15_analyzer_2_array_crystal_array_5", mcposachannel_15_analyzer_2_array_crystal_array_5, mcrotachannel_15_analyzer_2_array_crystal_array_5)
  mccomp_posa[716] = mcposachannel_15_analyzer_2_array_crystal_array_5;
  mccomp_posr[716] = mcposrchannel_15_analyzer_2_array_crystal_array_5;
  mcNCounter[716]  = mcPCounter[716] = mcP2Counter[716] = 0;
  mcAbsorbProp[716]= 0;
    /* Component channel_15_analyzer_2_array_crystal_array_6. */
  /* Setting parameters for component channel_15_analyzer_2_array_crystal_array_6. */
  SIG_MESSAGE("channel_15_analyzer_2_array_crystal_array_6 (Init:SetPar)");
#line 3974 "MACS_sample_kidney_box.instr"
  if("PG_analyzer") strncpy(mccchannel_15_analyzer_2_array_crystal_array_6_material_string, "PG_analyzer" ? "PG_analyzer" : "", 16384); else mccchannel_15_analyzer_2_array_crystal_array_6_material_string[0]='\0';
#line 3974 "MACS_sample_kidney_box.instr"
  mccchannel_15_analyzer_2_array_crystal_array_6_priority = 1721.6;
#line 3973 "MACS_sample_kidney_box.instr"
  mccchannel_15_analyzer_2_array_crystal_array_6_xwidth = channel_15_analyzer_2_array_crystal_depth;
#line 3973 "MACS_sample_kidney_box.instr"
  mccchannel_15_analyzer_2_array_crystal_array_6_yheight = channel_15_analyzer_2_array_crystal_height;
#line 3973 "MACS_sample_kidney_box.instr"
  mccchannel_15_analyzer_2_array_crystal_array_6_zdepth = channel_15_analyzer_2_array_crystal_width;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_15_analyzer_2_array_crystal_array_6_xwidth2 = -1;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_15_analyzer_2_array_crystal_array_6_yheight2 = -1;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_15_analyzer_2_array_crystal_array_6_visualize = 1;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_15_analyzer_2_array_crystal_array_6_target_index = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_15_analyzer_2_array_crystal_array_6_target_x = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_15_analyzer_2_array_crystal_array_6_target_y = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_15_analyzer_2_array_crystal_array_6_target_z = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_15_analyzer_2_array_crystal_array_6_focus_aw = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_15_analyzer_2_array_crystal_array_6_focus_ah = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_15_analyzer_2_array_crystal_array_6_focus_xw = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_15_analyzer_2_array_crystal_array_6_focus_xh = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_15_analyzer_2_array_crystal_array_6_focus_r = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_15_analyzer_2_array_crystal_array_6_p_interact = 0;
#line 71 "MACS_sample_kidney_box.instr"
  if(0) strncpy(mccchannel_15_analyzer_2_array_crystal_array_6_mask_string, 0 ? 0 : "", 16384); else mccchannel_15_analyzer_2_array_crystal_array_6_mask_string[0]='\0';
#line 71 "MACS_sample_kidney_box.instr"
  if(0) strncpy(mccchannel_15_analyzer_2_array_crystal_array_6_mask_setting, 0 ? 0 : "", 16384); else mccchannel_15_analyzer_2_array_crystal_array_6_mask_setting[0]='\0';
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_15_analyzer_2_array_crystal_array_6_number_of_activations = 1;
#line 138260 "MACS_sample_kidney_box.c"

  SIG_MESSAGE("channel_15_analyzer_2_array_crystal_array_6 (Init:Place/Rotate)");
  rot_set_rotation(mctr1,
#line 3976 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 3976 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 3976 "MACS_sample_kidney_box.instr"
    (0 - RAD2DEG * channel_15_analyzer_2_array_theta [ 6 ])*DEG2RAD);
#line 138270 "MACS_sample_kidney_box.c"
  rot_mul(mctr1, mcrotachannel_15_analyzer_2_rotated, mcrotachannel_15_analyzer_2_array_crystal_array_6);
  rot_transpose(mcrotachannel_15_analyzer_2_array_crystal_array_5, mctr1);
  rot_mul(mcrotachannel_15_analyzer_2_array_crystal_array_6, mctr1, mcrotrchannel_15_analyzer_2_array_crystal_array_6);
  mctc1 = coords_set(
#line 3975 "MACS_sample_kidney_box.instr"
    0 + channel_15_analyzer_2_array_effective_radius_of_curvature * ( 1 - cos ( channel_15_analyzer_2_array_theta [ 6 ] ) ),
#line 3975 "MACS_sample_kidney_box.instr"
    0 + channel_15_analyzer_2_array_effective_radius_of_curvature * sin ( channel_15_analyzer_2_array_theta [ 6 ] ),
#line 3975 "MACS_sample_kidney_box.instr"
    0);
#line 138281 "MACS_sample_kidney_box.c"
  rot_transpose(mcrotachannel_15_analyzer_2_rotated, mctr1);
  mctc2 = rot_apply(mctr1, mctc1);
  mcposachannel_15_analyzer_2_array_crystal_array_6 = coords_add(mcposachannel_15_analyzer_2_rotated, mctc2);
  mctc1 = coords_sub(mcposachannel_15_analyzer_2_array_crystal_array_5, mcposachannel_15_analyzer_2_array_crystal_array_6);
  mcposrchannel_15_analyzer_2_array_crystal_array_6 = rot_apply(mcrotachannel_15_analyzer_2_array_crystal_array_6, mctc1);
  mcDEBUG_COMPONENT("channel_15_analyzer_2_array_crystal_array_6", mcposachannel_15_analyzer_2_array_crystal_array_6, mcrotachannel_15_analyzer_2_array_crystal_array_6)
  mccomp_posa[717] = mcposachannel_15_analyzer_2_array_crystal_array_6;
  mccomp_posr[717] = mcposrchannel_15_analyzer_2_array_crystal_array_6;
  mcNCounter[717]  = mcPCounter[717] = mcP2Counter[717] = 0;
  mcAbsorbProp[717]= 0;
    /* Component channel_15_analyzer_2_array_crystal_array_7. */
  /* Setting parameters for component channel_15_analyzer_2_array_crystal_array_7. */
  SIG_MESSAGE("channel_15_analyzer_2_array_crystal_array_7 (Init:SetPar)");
#line 3980 "MACS_sample_kidney_box.instr"
  if("PG_analyzer") strncpy(mccchannel_15_analyzer_2_array_crystal_array_7_material_string, "PG_analyzer" ? "PG_analyzer" : "", 16384); else mccchannel_15_analyzer_2_array_crystal_array_7_material_string[0]='\0';
#line 3980 "MACS_sample_kidney_box.instr"
  mccchannel_15_analyzer_2_array_crystal_array_7_priority = 1721.7;
#line 3979 "MACS_sample_kidney_box.instr"
  mccchannel_15_analyzer_2_array_crystal_array_7_xwidth = channel_15_analyzer_2_array_crystal_depth;
#line 3979 "MACS_sample_kidney_box.instr"
  mccchannel_15_analyzer_2_array_crystal_array_7_yheight = channel_15_analyzer_2_array_crystal_height;
#line 3979 "MACS_sample_kidney_box.instr"
  mccchannel_15_analyzer_2_array_crystal_array_7_zdepth = channel_15_analyzer_2_array_crystal_width;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_15_analyzer_2_array_crystal_array_7_xwidth2 = -1;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_15_analyzer_2_array_crystal_array_7_yheight2 = -1;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_15_analyzer_2_array_crystal_array_7_visualize = 1;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_15_analyzer_2_array_crystal_array_7_target_index = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_15_analyzer_2_array_crystal_array_7_target_x = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_15_analyzer_2_array_crystal_array_7_target_y = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_15_analyzer_2_array_crystal_array_7_target_z = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_15_analyzer_2_array_crystal_array_7_focus_aw = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_15_analyzer_2_array_crystal_array_7_focus_ah = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_15_analyzer_2_array_crystal_array_7_focus_xw = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_15_analyzer_2_array_crystal_array_7_focus_xh = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_15_analyzer_2_array_crystal_array_7_focus_r = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_15_analyzer_2_array_crystal_array_7_p_interact = 0;
#line 71 "MACS_sample_kidney_box.instr"
  if(0) strncpy(mccchannel_15_analyzer_2_array_crystal_array_7_mask_string, 0 ? 0 : "", 16384); else mccchannel_15_analyzer_2_array_crystal_array_7_mask_string[0]='\0';
#line 71 "MACS_sample_kidney_box.instr"
  if(0) strncpy(mccchannel_15_analyzer_2_array_crystal_array_7_mask_setting, 0 ? 0 : "", 16384); else mccchannel_15_analyzer_2_array_crystal_array_7_mask_setting[0]='\0';
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_15_analyzer_2_array_crystal_array_7_number_of_activations = 1;
#line 138337 "MACS_sample_kidney_box.c"

  SIG_MESSAGE("channel_15_analyzer_2_array_crystal_array_7 (Init:Place/Rotate)");
  rot_set_rotation(mctr1,
#line 3982 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 3982 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 3982 "MACS_sample_kidney_box.instr"
    (0 - RAD2DEG * channel_15_analyzer_2_array_theta [ 7 ])*DEG2RAD);
#line 138347 "MACS_sample_kidney_box.c"
  rot_mul(mctr1, mcrotachannel_15_analyzer_2_rotated, mcrotachannel_15_analyzer_2_array_crystal_array_7);
  rot_transpose(mcrotachannel_15_analyzer_2_array_crystal_array_6, mctr1);
  rot_mul(mcrotachannel_15_analyzer_2_array_crystal_array_7, mctr1, mcrotrchannel_15_analyzer_2_array_crystal_array_7);
  mctc1 = coords_set(
#line 3981 "MACS_sample_kidney_box.instr"
    0 + channel_15_analyzer_2_array_effective_radius_of_curvature * ( 1 - cos ( channel_15_analyzer_2_array_theta [ 7 ] ) ),
#line 3981 "MACS_sample_kidney_box.instr"
    0 + channel_15_analyzer_2_array_effective_radius_of_curvature * sin ( channel_15_analyzer_2_array_theta [ 7 ] ),
#line 3981 "MACS_sample_kidney_box.instr"
    0);
#line 138358 "MACS_sample_kidney_box.c"
  rot_transpose(mcrotachannel_15_analyzer_2_rotated, mctr1);
  mctc2 = rot_apply(mctr1, mctc1);
  mcposachannel_15_analyzer_2_array_crystal_array_7 = coords_add(mcposachannel_15_analyzer_2_rotated, mctc2);
  mctc1 = coords_sub(mcposachannel_15_analyzer_2_array_crystal_array_6, mcposachannel_15_analyzer_2_array_crystal_array_7);
  mcposrchannel_15_analyzer_2_array_crystal_array_7 = rot_apply(mcrotachannel_15_analyzer_2_array_crystal_array_7, mctc1);
  mcDEBUG_COMPONENT("channel_15_analyzer_2_array_crystal_array_7", mcposachannel_15_analyzer_2_array_crystal_array_7, mcrotachannel_15_analyzer_2_array_crystal_array_7)
  mccomp_posa[718] = mcposachannel_15_analyzer_2_array_crystal_array_7;
  mccomp_posr[718] = mcposrchannel_15_analyzer_2_array_crystal_array_7;
  mcNCounter[718]  = mcPCounter[718] = mcP2Counter[718] = 0;
  mcAbsorbProp[718]= 0;
    /* Component channel_15_analyzer_2_array_crystal_array_8. */
  /* Setting parameters for component channel_15_analyzer_2_array_crystal_array_8. */
  SIG_MESSAGE("channel_15_analyzer_2_array_crystal_array_8 (Init:SetPar)");
#line 3986 "MACS_sample_kidney_box.instr"
  if("PG_analyzer") strncpy(mccchannel_15_analyzer_2_array_crystal_array_8_material_string, "PG_analyzer" ? "PG_analyzer" : "", 16384); else mccchannel_15_analyzer_2_array_crystal_array_8_material_string[0]='\0';
#line 3986 "MACS_sample_kidney_box.instr"
  mccchannel_15_analyzer_2_array_crystal_array_8_priority = 1721.8;
#line 3985 "MACS_sample_kidney_box.instr"
  mccchannel_15_analyzer_2_array_crystal_array_8_xwidth = channel_15_analyzer_2_array_crystal_depth;
#line 3985 "MACS_sample_kidney_box.instr"
  mccchannel_15_analyzer_2_array_crystal_array_8_yheight = channel_15_analyzer_2_array_crystal_height;
#line 3985 "MACS_sample_kidney_box.instr"
  mccchannel_15_analyzer_2_array_crystal_array_8_zdepth = channel_15_analyzer_2_array_crystal_width;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_15_analyzer_2_array_crystal_array_8_xwidth2 = -1;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_15_analyzer_2_array_crystal_array_8_yheight2 = -1;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_15_analyzer_2_array_crystal_array_8_visualize = 1;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_15_analyzer_2_array_crystal_array_8_target_index = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_15_analyzer_2_array_crystal_array_8_target_x = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_15_analyzer_2_array_crystal_array_8_target_y = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_15_analyzer_2_array_crystal_array_8_target_z = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_15_analyzer_2_array_crystal_array_8_focus_aw = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_15_analyzer_2_array_crystal_array_8_focus_ah = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_15_analyzer_2_array_crystal_array_8_focus_xw = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_15_analyzer_2_array_crystal_array_8_focus_xh = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_15_analyzer_2_array_crystal_array_8_focus_r = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_15_analyzer_2_array_crystal_array_8_p_interact = 0;
#line 71 "MACS_sample_kidney_box.instr"
  if(0) strncpy(mccchannel_15_analyzer_2_array_crystal_array_8_mask_string, 0 ? 0 : "", 16384); else mccchannel_15_analyzer_2_array_crystal_array_8_mask_string[0]='\0';
#line 71 "MACS_sample_kidney_box.instr"
  if(0) strncpy(mccchannel_15_analyzer_2_array_crystal_array_8_mask_setting, 0 ? 0 : "", 16384); else mccchannel_15_analyzer_2_array_crystal_array_8_mask_setting[0]='\0';
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_15_analyzer_2_array_crystal_array_8_number_of_activations = 1;
#line 138414 "MACS_sample_kidney_box.c"

  SIG_MESSAGE("channel_15_analyzer_2_array_crystal_array_8 (Init:Place/Rotate)");
  rot_set_rotation(mctr1,
#line 3988 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 3988 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 3988 "MACS_sample_kidney_box.instr"
    (0 - RAD2DEG * channel_15_analyzer_2_array_theta [ 8 ])*DEG2RAD);
#line 138424 "MACS_sample_kidney_box.c"
  rot_mul(mctr1, mcrotachannel_15_analyzer_2_rotated, mcrotachannel_15_analyzer_2_array_crystal_array_8);
  rot_transpose(mcrotachannel_15_analyzer_2_array_crystal_array_7, mctr1);
  rot_mul(mcrotachannel_15_analyzer_2_array_crystal_array_8, mctr1, mcrotrchannel_15_analyzer_2_array_crystal_array_8);
  mctc1 = coords_set(
#line 3987 "MACS_sample_kidney_box.instr"
    0 + channel_15_analyzer_2_array_effective_radius_of_curvature * ( 1 - cos ( channel_15_analyzer_2_array_theta [ 8 ] ) ),
#line 3987 "MACS_sample_kidney_box.instr"
    0 + channel_15_analyzer_2_array_effective_radius_of_curvature * sin ( channel_15_analyzer_2_array_theta [ 8 ] ),
#line 3987 "MACS_sample_kidney_box.instr"
    0);
#line 138435 "MACS_sample_kidney_box.c"
  rot_transpose(mcrotachannel_15_analyzer_2_rotated, mctr1);
  mctc2 = rot_apply(mctr1, mctc1);
  mcposachannel_15_analyzer_2_array_crystal_array_8 = coords_add(mcposachannel_15_analyzer_2_rotated, mctc2);
  mctc1 = coords_sub(mcposachannel_15_analyzer_2_array_crystal_array_7, mcposachannel_15_analyzer_2_array_crystal_array_8);
  mcposrchannel_15_analyzer_2_array_crystal_array_8 = rot_apply(mcrotachannel_15_analyzer_2_array_crystal_array_8, mctc1);
  mcDEBUG_COMPONENT("channel_15_analyzer_2_array_crystal_array_8", mcposachannel_15_analyzer_2_array_crystal_array_8, mcrotachannel_15_analyzer_2_array_crystal_array_8)
  mccomp_posa[719] = mcposachannel_15_analyzer_2_array_crystal_array_8;
  mccomp_posr[719] = mcposrchannel_15_analyzer_2_array_crystal_array_8;
  mcNCounter[719]  = mcPCounter[719] = mcP2Counter[719] = 0;
  mcAbsorbProp[719]= 0;
    /* Component channel_15_cave2_cyl1. */
  /* Setting parameters for component channel_15_cave2_cyl1. */
  SIG_MESSAGE("channel_15_cave2_cyl1 (Init:SetPar)");
#line 3993 "MACS_sample_kidney_box.instr"
  if("Vacuum") strncpy(mccchannel_15_cave2_cyl1_material_string, "Vacuum" ? "Vacuum" : "", 16384); else mccchannel_15_cave2_cyl1_material_string[0]='\0';
#line 3993 "MACS_sample_kidney_box.instr"
  mccchannel_15_cave2_cyl1_priority = 1707.5;
#line 3992 "MACS_sample_kidney_box.instr"
  mccchannel_15_cave2_cyl1_radius = kidney_cave2_cyl1_radius;
#line 3992 "MACS_sample_kidney_box.instr"
  mccchannel_15_cave2_cyl1_yheight = kidney_cave2_cyl1_height;
#line 67 "MACS_sample_kidney_box.instr"
  mccchannel_15_cave2_cyl1_visualize = 1;
#line 67 "MACS_sample_kidney_box.instr"
  mccchannel_15_cave2_cyl1_target_index = 0;
#line 67 "MACS_sample_kidney_box.instr"
  mccchannel_15_cave2_cyl1_target_x = 0;
#line 67 "MACS_sample_kidney_box.instr"
  mccchannel_15_cave2_cyl1_target_y = 0;
#line 67 "MACS_sample_kidney_box.instr"
  mccchannel_15_cave2_cyl1_target_z = 0;
#line 67 "MACS_sample_kidney_box.instr"
  mccchannel_15_cave2_cyl1_focus_aw = 0;
#line 67 "MACS_sample_kidney_box.instr"
  mccchannel_15_cave2_cyl1_focus_ah = 0;
#line 67 "MACS_sample_kidney_box.instr"
  mccchannel_15_cave2_cyl1_focus_xw = 0;
#line 67 "MACS_sample_kidney_box.instr"
  mccchannel_15_cave2_cyl1_focus_xh = 0;
#line 67 "MACS_sample_kidney_box.instr"
  mccchannel_15_cave2_cyl1_focus_r = 0;
#line 67 "MACS_sample_kidney_box.instr"
  mccchannel_15_cave2_cyl1_p_interact = 0;
#line 67 "MACS_sample_kidney_box.instr"
  if(0) strncpy(mccchannel_15_cave2_cyl1_mask_string, 0 ? 0 : "", 16384); else mccchannel_15_cave2_cyl1_mask_string[0]='\0';
#line 67 "MACS_sample_kidney_box.instr"
  if(0) strncpy(mccchannel_15_cave2_cyl1_mask_setting, 0 ? 0 : "", 16384); else mccchannel_15_cave2_cyl1_mask_setting[0]='\0';
#line 67 "MACS_sample_kidney_box.instr"
  mccchannel_15_cave2_cyl1_number_of_activations = 1;
#line 138485 "MACS_sample_kidney_box.c"

  SIG_MESSAGE("channel_15_cave2_cyl1 (Init:Place/Rotate)");
  rot_set_rotation(mctr1,
#line 3995 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 3995 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 3995 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD);
#line 138495 "MACS_sample_kidney_box.c"
  rot_mul(mctr1, mcrotachannel_15_analyzer_2_center, mcrotachannel_15_cave2_cyl1);
  rot_transpose(mcrotachannel_15_analyzer_2_array_crystal_array_8, mctr1);
  rot_mul(mcrotachannel_15_cave2_cyl1, mctr1, mcrotrchannel_15_cave2_cyl1);
  mctc1 = coords_set(
#line 3994 "MACS_sample_kidney_box.instr"
    0,
#line 3994 "MACS_sample_kidney_box.instr"
    0,
#line 3994 "MACS_sample_kidney_box.instr"
    spec_detector_to_analyzer_2_center);
#line 138506 "MACS_sample_kidney_box.c"
  rot_transpose(mcrotachannel_15_analyzer_2_center, mctr1);
  mctc2 = rot_apply(mctr1, mctc1);
  mcposachannel_15_cave2_cyl1 = coords_add(mcposachannel_15_analyzer_2_center, mctc2);
  mctc1 = coords_sub(mcposachannel_15_analyzer_2_array_crystal_array_8, mcposachannel_15_cave2_cyl1);
  mcposrchannel_15_cave2_cyl1 = rot_apply(mcrotachannel_15_cave2_cyl1, mctc1);
  mcDEBUG_COMPONENT("channel_15_cave2_cyl1", mcposachannel_15_cave2_cyl1, mcrotachannel_15_cave2_cyl1)
  mccomp_posa[720] = mcposachannel_15_cave2_cyl1;
  mccomp_posr[720] = mcposrchannel_15_cave2_cyl1;
  mcNCounter[720]  = mcPCounter[720] = mcP2Counter[720] = 0;
  mcAbsorbProp[720]= 0;
    /* Component channel_15_cave2_box1. */
  /* Setting parameters for component channel_15_cave2_box1. */
  SIG_MESSAGE("channel_15_cave2_box1 (Init:SetPar)");
#line 4000 "MACS_sample_kidney_box.instr"
  if("Vacuum") strncpy(mccchannel_15_cave2_box1_material_string, "Vacuum" ? "Vacuum" : "", 16384); else mccchannel_15_cave2_box1_material_string[0]='\0';
#line 4000 "MACS_sample_kidney_box.instr"
  mccchannel_15_cave2_box1_priority = 1701;
#line 3998 "MACS_sample_kidney_box.instr"
  mccchannel_15_cave2_box1_xwidth = kidney_cave2_box1_width1;
#line 3998 "MACS_sample_kidney_box.instr"
  mccchannel_15_cave2_box1_yheight = kidney_cave2_box1_height1;
#line 3998 "MACS_sample_kidney_box.instr"
  mccchannel_15_cave2_box1_zdepth = kidney_cave2_box1_depth;
#line 3999 "MACS_sample_kidney_box.instr"
  mccchannel_15_cave2_box1_xwidth2 = kidney_cave2_box1_width2;
#line 3999 "MACS_sample_kidney_box.instr"
  mccchannel_15_cave2_box1_yheight2 = kidney_cave2_box1_height2;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_15_cave2_box1_visualize = 1;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_15_cave2_box1_target_index = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_15_cave2_box1_target_x = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_15_cave2_box1_target_y = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_15_cave2_box1_target_z = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_15_cave2_box1_focus_aw = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_15_cave2_box1_focus_ah = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_15_cave2_box1_focus_xw = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_15_cave2_box1_focus_xh = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_15_cave2_box1_focus_r = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_15_cave2_box1_p_interact = 0;
#line 71 "MACS_sample_kidney_box.instr"
  if(0) strncpy(mccchannel_15_cave2_box1_mask_string, 0 ? 0 : "", 16384); else mccchannel_15_cave2_box1_mask_string[0]='\0';
#line 71 "MACS_sample_kidney_box.instr"
  if(0) strncpy(mccchannel_15_cave2_box1_mask_setting, 0 ? 0 : "", 16384); else mccchannel_15_cave2_box1_mask_setting[0]='\0';
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_15_cave2_box1_number_of_activations = 1;
#line 138562 "MACS_sample_kidney_box.c"

  SIG_MESSAGE("channel_15_cave2_box1 (Init:Place/Rotate)");
  rot_set_rotation(mctr1,
#line 4002 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 4002 "MACS_sample_kidney_box.instr"
    (kidney_cave2_box1_y_rotation)*DEG2RAD,
#line 4002 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD);
#line 138572 "MACS_sample_kidney_box.c"
  rot_mul(mctr1, mcrotachannel_15_cave2_cyl1, mcrotachannel_15_cave2_box1);
  rot_transpose(mcrotachannel_15_cave2_cyl1, mctr1);
  rot_mul(mcrotachannel_15_cave2_box1, mctr1, mcrotrchannel_15_cave2_box1);
  mctc1 = coords_set(
#line 4001 "MACS_sample_kidney_box.instr"
    kidney_cave2_box1_center_to_spec_detector_x,
#line 4001 "MACS_sample_kidney_box.instr"
    0,
#line 4001 "MACS_sample_kidney_box.instr"
    kidney_cave2_box1_center_to_spec_detector_z);
#line 138583 "MACS_sample_kidney_box.c"
  rot_transpose(mcrotachannel_15_cave2_cyl1, mctr1);
  mctc2 = rot_apply(mctr1, mctc1);
  mcposachannel_15_cave2_box1 = coords_add(mcposachannel_15_cave2_cyl1, mctc2);
  mctc1 = coords_sub(mcposachannel_15_cave2_cyl1, mcposachannel_15_cave2_box1);
  mcposrchannel_15_cave2_box1 = rot_apply(mcrotachannel_15_cave2_box1, mctc1);
  mcDEBUG_COMPONENT("channel_15_cave2_box1", mcposachannel_15_cave2_box1, mcrotachannel_15_cave2_box1)
  mccomp_posa[721] = mcposachannel_15_cave2_box1;
  mccomp_posr[721] = mcposrchannel_15_cave2_box1;
  mcNCounter[721]  = mcPCounter[721] = mcP2Counter[721] = 0;
  mcAbsorbProp[721]= 0;
    /* Component channel_15_cave2_box2. */
  /* Setting parameters for component channel_15_cave2_box2. */
  SIG_MESSAGE("channel_15_cave2_box2 (Init:SetPar)");
#line 4007 "MACS_sample_kidney_box.instr"
  if("Vacuum") strncpy(mccchannel_15_cave2_box2_material_string, "Vacuum" ? "Vacuum" : "", 16384); else mccchannel_15_cave2_box2_material_string[0]='\0';
#line 4007 "MACS_sample_kidney_box.instr"
  mccchannel_15_cave2_box2_priority = 1706;
#line 4005 "MACS_sample_kidney_box.instr"
  mccchannel_15_cave2_box2_xwidth = kidney_cave2_box2_width1;
#line 4005 "MACS_sample_kidney_box.instr"
  mccchannel_15_cave2_box2_yheight = kidney_cave2_box2_height1;
#line 4005 "MACS_sample_kidney_box.instr"
  mccchannel_15_cave2_box2_zdepth = kidney_cave2_box2_depth;
#line 4006 "MACS_sample_kidney_box.instr"
  mccchannel_15_cave2_box2_xwidth2 = kidney_cave2_box2_width2;
#line 4006 "MACS_sample_kidney_box.instr"
  mccchannel_15_cave2_box2_yheight2 = kidney_cave2_box2_height2;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_15_cave2_box2_visualize = 1;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_15_cave2_box2_target_index = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_15_cave2_box2_target_x = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_15_cave2_box2_target_y = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_15_cave2_box2_target_z = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_15_cave2_box2_focus_aw = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_15_cave2_box2_focus_ah = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_15_cave2_box2_focus_xw = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_15_cave2_box2_focus_xh = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_15_cave2_box2_focus_r = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_15_cave2_box2_p_interact = 0;
#line 71 "MACS_sample_kidney_box.instr"
  if(0) strncpy(mccchannel_15_cave2_box2_mask_string, 0 ? 0 : "", 16384); else mccchannel_15_cave2_box2_mask_string[0]='\0';
#line 71 "MACS_sample_kidney_box.instr"
  if(0) strncpy(mccchannel_15_cave2_box2_mask_setting, 0 ? 0 : "", 16384); else mccchannel_15_cave2_box2_mask_setting[0]='\0';
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_15_cave2_box2_number_of_activations = 1;
#line 138639 "MACS_sample_kidney_box.c"

  SIG_MESSAGE("channel_15_cave2_box2 (Init:Place/Rotate)");
  rot_set_rotation(mctr1,
#line 4009 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 4009 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 4009 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD);
#line 138649 "MACS_sample_kidney_box.c"
  rot_mul(mctr1, mcrotachannel_15_cave2_cyl1, mcrotachannel_15_cave2_box2);
  rot_transpose(mcrotachannel_15_cave2_box1, mctr1);
  rot_mul(mcrotachannel_15_cave2_box2, mctr1, mcrotrchannel_15_cave2_box2);
  mctc1 = coords_set(
#line 4008 "MACS_sample_kidney_box.instr"
    0,
#line 4008 "MACS_sample_kidney_box.instr"
    0,
#line 4008 "MACS_sample_kidney_box.instr"
    kidney_cave2_box2_center_to_detector);
#line 138660 "MACS_sample_kidney_box.c"
  rot_transpose(mcrotachannel_15_cave2_cyl1, mctr1);
  mctc2 = rot_apply(mctr1, mctc1);
  mcposachannel_15_cave2_box2 = coords_add(mcposachannel_15_cave2_cyl1, mctc2);
  mctc1 = coords_sub(mcposachannel_15_cave2_box1, mcposachannel_15_cave2_box2);
  mcposrchannel_15_cave2_box2 = rot_apply(mcrotachannel_15_cave2_box2, mctc1);
  mcDEBUG_COMPONENT("channel_15_cave2_box2", mcposachannel_15_cave2_box2, mcrotachannel_15_cave2_box2)
  mccomp_posa[722] = mcposachannel_15_cave2_box2;
  mccomp_posr[722] = mcposrchannel_15_cave2_box2;
  mcNCounter[722]  = mcPCounter[722] = mcP2Counter[722] = 0;
  mcAbsorbProp[722]= 0;
    /* Component channel_15_cave2_box3. */
  /* Setting parameters for component channel_15_cave2_box3. */
  SIG_MESSAGE("channel_15_cave2_box3 (Init:SetPar)");
#line 4014 "MACS_sample_kidney_box.instr"
  if("Vacuum") strncpy(mccchannel_15_cave2_box3_material_string, "Vacuum" ? "Vacuum" : "", 16384); else mccchannel_15_cave2_box3_material_string[0]='\0';
#line 4014 "MACS_sample_kidney_box.instr"
  mccchannel_15_cave2_box3_priority = 1707;
#line 4012 "MACS_sample_kidney_box.instr"
  mccchannel_15_cave2_box3_xwidth = kidney_cave2_box3_width1;
#line 4012 "MACS_sample_kidney_box.instr"
  mccchannel_15_cave2_box3_yheight = kidney_cave2_box3_height1;
#line 4012 "MACS_sample_kidney_box.instr"
  mccchannel_15_cave2_box3_zdepth = kidney_cave2_box3_depth;
#line 4013 "MACS_sample_kidney_box.instr"
  mccchannel_15_cave2_box3_xwidth2 = kidney_cave2_box3_width2;
#line 4013 "MACS_sample_kidney_box.instr"
  mccchannel_15_cave2_box3_yheight2 = kidney_cave2_box3_height2;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_15_cave2_box3_visualize = 1;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_15_cave2_box3_target_index = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_15_cave2_box3_target_x = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_15_cave2_box3_target_y = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_15_cave2_box3_target_z = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_15_cave2_box3_focus_aw = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_15_cave2_box3_focus_ah = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_15_cave2_box3_focus_xw = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_15_cave2_box3_focus_xh = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_15_cave2_box3_focus_r = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_15_cave2_box3_p_interact = 0;
#line 71 "MACS_sample_kidney_box.instr"
  if(0) strncpy(mccchannel_15_cave2_box3_mask_string, 0 ? 0 : "", 16384); else mccchannel_15_cave2_box3_mask_string[0]='\0';
#line 71 "MACS_sample_kidney_box.instr"
  if(0) strncpy(mccchannel_15_cave2_box3_mask_setting, 0 ? 0 : "", 16384); else mccchannel_15_cave2_box3_mask_setting[0]='\0';
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_15_cave2_box3_number_of_activations = 1;
#line 138716 "MACS_sample_kidney_box.c"

  SIG_MESSAGE("channel_15_cave2_box3 (Init:Place/Rotate)");
  rot_set_rotation(mctr1,
#line 4016 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 4016 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 4016 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD);
#line 138726 "MACS_sample_kidney_box.c"
  rot_mul(mctr1, mcrotachannel_15_cave2_cyl1, mcrotachannel_15_cave2_box3);
  rot_transpose(mcrotachannel_15_cave2_box2, mctr1);
  rot_mul(mcrotachannel_15_cave2_box3, mctr1, mcrotrchannel_15_cave2_box3);
  mctc1 = coords_set(
#line 4015 "MACS_sample_kidney_box.instr"
    0,
#line 4015 "MACS_sample_kidney_box.instr"
    0,
#line 4015 "MACS_sample_kidney_box.instr"
    kidney_cave2_box3_center_to_detector);
#line 138737 "MACS_sample_kidney_box.c"
  rot_transpose(mcrotachannel_15_cave2_cyl1, mctr1);
  mctc2 = rot_apply(mctr1, mctc1);
  mcposachannel_15_cave2_box3 = coords_add(mcposachannel_15_cave2_cyl1, mctc2);
  mctc1 = coords_sub(mcposachannel_15_cave2_box2, mcposachannel_15_cave2_box3);
  mcposrchannel_15_cave2_box3 = rot_apply(mcrotachannel_15_cave2_box3, mctc1);
  mcDEBUG_COMPONENT("channel_15_cave2_box3", mcposachannel_15_cave2_box3, mcrotachannel_15_cave2_box3)
  mccomp_posa[723] = mcposachannel_15_cave2_box3;
  mccomp_posr[723] = mcposrchannel_15_cave2_box3;
  mcNCounter[723]  = mcPCounter[723] = mcP2Counter[723] = 0;
  mcAbsorbProp[723]= 0;
    /* Component inter_analyzer_colimator_center_15. */
  /* Setting parameters for component inter_analyzer_colimator_center_15. */
  SIG_MESSAGE("inter_analyzer_colimator_center_15 (Init:SetPar)");

  SIG_MESSAGE("inter_analyzer_colimator_center_15 (Init:Place/Rotate)");
  rot_set_rotation(mctr1,
#line 4020 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 4020 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 4020 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD);
#line 138760 "MACS_sample_kidney_box.c"
  rot_mul(mctr1, mcrotachannel_15_analyzer_1_center, mcrotainter_analyzer_colimator_center_15);
  rot_transpose(mcrotachannel_15_cave2_box3, mctr1);
  rot_mul(mcrotainter_analyzer_colimator_center_15, mctr1, mcrotrinter_analyzer_colimator_center_15);
  mctc1 = coords_set(
#line 4019 "MACS_sample_kidney_box.instr"
    -0.5 * analyzer_seperation,
#line 4019 "MACS_sample_kidney_box.instr"
    0,
#line 4019 "MACS_sample_kidney_box.instr"
    0);
#line 138771 "MACS_sample_kidney_box.c"
  rot_transpose(mcrotachannel_15_analyzer_1_center, mctr1);
  mctc2 = rot_apply(mctr1, mctc1);
  mcposainter_analyzer_colimator_center_15 = coords_add(mcposachannel_15_analyzer_1_center, mctc2);
  mctc1 = coords_sub(mcposachannel_15_cave2_box3, mcposainter_analyzer_colimator_center_15);
  mcposrinter_analyzer_colimator_center_15 = rot_apply(mcrotainter_analyzer_colimator_center_15, mctc1);
  mcDEBUG_COMPONENT("inter_analyzer_colimator_center_15", mcposainter_analyzer_colimator_center_15, mcrotainter_analyzer_colimator_center_15)
  mccomp_posa[724] = mcposainter_analyzer_colimator_center_15;
  mccomp_posr[724] = mcposrinter_analyzer_colimator_center_15;
  mcNCounter[724]  = mcPCounter[724] = mcP2Counter[724] = 0;
  mcAbsorbProp[724]= 0;
    /* Component inter_analyzer_colimator_15_blade_0. */
  /* Setting parameters for component inter_analyzer_colimator_15_blade_0. */
  SIG_MESSAGE("inter_analyzer_colimator_15_blade_0 (Init:SetPar)");
#line 4024 "MACS_sample_kidney_box.instr"
  if("Collimator_gad") strncpy(mccinter_analyzer_colimator_15_blade_0_material_string, "Collimator_gad" ? "Collimator_gad" : "", 16384); else mccinter_analyzer_colimator_15_blade_0_material_string[0]='\0';
#line 4024 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_15_blade_0_priority = 1725;
#line 4023 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_15_blade_0_xwidth = inter_analyzer_colimator_width;
#line 4023 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_15_blade_0_yheight = inter_analyzer_colimator_height;
#line 4023 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_15_blade_0_zdepth = inter_analyzer_colimator_depth;
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_15_blade_0_xwidth2 = -1;
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_15_blade_0_yheight2 = -1;
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_15_blade_0_visualize = 1;
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_15_blade_0_target_index = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_15_blade_0_target_x = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_15_blade_0_target_y = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_15_blade_0_target_z = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_15_blade_0_focus_aw = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_15_blade_0_focus_ah = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_15_blade_0_focus_xw = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_15_blade_0_focus_xh = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_15_blade_0_focus_r = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_15_blade_0_p_interact = 0;
#line 71 "MACS_sample_kidney_box.instr"
  if(0) strncpy(mccinter_analyzer_colimator_15_blade_0_mask_string, 0 ? 0 : "", 16384); else mccinter_analyzer_colimator_15_blade_0_mask_string[0]='\0';
#line 71 "MACS_sample_kidney_box.instr"
  if(0) strncpy(mccinter_analyzer_colimator_15_blade_0_mask_setting, 0 ? 0 : "", 16384); else mccinter_analyzer_colimator_15_blade_0_mask_setting[0]='\0';
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_15_blade_0_number_of_activations = 1;
#line 138827 "MACS_sample_kidney_box.c"

  SIG_MESSAGE("inter_analyzer_colimator_15_blade_0 (Init:Place/Rotate)");
  rot_set_rotation(mctr1,
#line 4026 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 4026 "MACS_sample_kidney_box.instr"
    (- analyzer_2theta [ 15 ])*DEG2RAD,
#line 4026 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD);
#line 138837 "MACS_sample_kidney_box.c"
  rot_mul(mctr1, mcrotainter_analyzer_colimator_center_15, mcrotainter_analyzer_colimator_15_blade_0);
  rot_transpose(mcrotainter_analyzer_colimator_center_15, mctr1);
  rot_mul(mcrotainter_analyzer_colimator_15_blade_0, mctr1, mcrotrinter_analyzer_colimator_15_blade_0);
  mctc1 = coords_set(
#line 4025 "MACS_sample_kidney_box.instr"
    0,
#line 4025 "MACS_sample_kidney_box.instr"
    0,
#line 4025 "MACS_sample_kidney_box.instr"
    inter_analyzer_colimator_start_pos - 0 * inter_analyzer_colimator_seperation);
#line 138848 "MACS_sample_kidney_box.c"
  rot_transpose(mcrotainter_analyzer_colimator_center_15, mctr1);
  mctc2 = rot_apply(mctr1, mctc1);
  mcposainter_analyzer_colimator_15_blade_0 = coords_add(mcposainter_analyzer_colimator_center_15, mctc2);
  mctc1 = coords_sub(mcposainter_analyzer_colimator_center_15, mcposainter_analyzer_colimator_15_blade_0);
  mcposrinter_analyzer_colimator_15_blade_0 = rot_apply(mcrotainter_analyzer_colimator_15_blade_0, mctc1);
  mcDEBUG_COMPONENT("inter_analyzer_colimator_15_blade_0", mcposainter_analyzer_colimator_15_blade_0, mcrotainter_analyzer_colimator_15_blade_0)
  mccomp_posa[725] = mcposainter_analyzer_colimator_15_blade_0;
  mccomp_posr[725] = mcposrinter_analyzer_colimator_15_blade_0;
  mcNCounter[725]  = mcPCounter[725] = mcP2Counter[725] = 0;
  mcAbsorbProp[725]= 0;
    /* Component inter_analyzer_colimator_15_blade_1. */
  /* Setting parameters for component inter_analyzer_colimator_15_blade_1. */
  SIG_MESSAGE("inter_analyzer_colimator_15_blade_1 (Init:SetPar)");
#line 4030 "MACS_sample_kidney_box.instr"
  if("Collimator_gad") strncpy(mccinter_analyzer_colimator_15_blade_1_material_string, "Collimator_gad" ? "Collimator_gad" : "", 16384); else mccinter_analyzer_colimator_15_blade_1_material_string[0]='\0';
#line 4030 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_15_blade_1_priority = 1726;
#line 4029 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_15_blade_1_xwidth = inter_analyzer_colimator_width;
#line 4029 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_15_blade_1_yheight = inter_analyzer_colimator_height;
#line 4029 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_15_blade_1_zdepth = inter_analyzer_colimator_depth;
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_15_blade_1_xwidth2 = -1;
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_15_blade_1_yheight2 = -1;
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_15_blade_1_visualize = 1;
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_15_blade_1_target_index = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_15_blade_1_target_x = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_15_blade_1_target_y = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_15_blade_1_target_z = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_15_blade_1_focus_aw = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_15_blade_1_focus_ah = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_15_blade_1_focus_xw = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_15_blade_1_focus_xh = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_15_blade_1_focus_r = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_15_blade_1_p_interact = 0;
#line 71 "MACS_sample_kidney_box.instr"
  if(0) strncpy(mccinter_analyzer_colimator_15_blade_1_mask_string, 0 ? 0 : "", 16384); else mccinter_analyzer_colimator_15_blade_1_mask_string[0]='\0';
#line 71 "MACS_sample_kidney_box.instr"
  if(0) strncpy(mccinter_analyzer_colimator_15_blade_1_mask_setting, 0 ? 0 : "", 16384); else mccinter_analyzer_colimator_15_blade_1_mask_setting[0]='\0';
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_15_blade_1_number_of_activations = 1;
#line 138904 "MACS_sample_kidney_box.c"

  SIG_MESSAGE("inter_analyzer_colimator_15_blade_1 (Init:Place/Rotate)");
  rot_set_rotation(mctr1,
#line 4032 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 4032 "MACS_sample_kidney_box.instr"
    (- analyzer_2theta [ 15 ])*DEG2RAD,
#line 4032 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD);
#line 138914 "MACS_sample_kidney_box.c"
  rot_mul(mctr1, mcrotainter_analyzer_colimator_center_15, mcrotainter_analyzer_colimator_15_blade_1);
  rot_transpose(mcrotainter_analyzer_colimator_15_blade_0, mctr1);
  rot_mul(mcrotainter_analyzer_colimator_15_blade_1, mctr1, mcrotrinter_analyzer_colimator_15_blade_1);
  mctc1 = coords_set(
#line 4031 "MACS_sample_kidney_box.instr"
    0,
#line 4031 "MACS_sample_kidney_box.instr"
    0,
#line 4031 "MACS_sample_kidney_box.instr"
    inter_analyzer_colimator_start_pos - 1 * inter_analyzer_colimator_seperation);
#line 138925 "MACS_sample_kidney_box.c"
  rot_transpose(mcrotainter_analyzer_colimator_center_15, mctr1);
  mctc2 = rot_apply(mctr1, mctc1);
  mcposainter_analyzer_colimator_15_blade_1 = coords_add(mcposainter_analyzer_colimator_center_15, mctc2);
  mctc1 = coords_sub(mcposainter_analyzer_colimator_15_blade_0, mcposainter_analyzer_colimator_15_blade_1);
  mcposrinter_analyzer_colimator_15_blade_1 = rot_apply(mcrotainter_analyzer_colimator_15_blade_1, mctc1);
  mcDEBUG_COMPONENT("inter_analyzer_colimator_15_blade_1", mcposainter_analyzer_colimator_15_blade_1, mcrotainter_analyzer_colimator_15_blade_1)
  mccomp_posa[726] = mcposainter_analyzer_colimator_15_blade_1;
  mccomp_posr[726] = mcposrinter_analyzer_colimator_15_blade_1;
  mcNCounter[726]  = mcPCounter[726] = mcP2Counter[726] = 0;
  mcAbsorbProp[726]= 0;
    /* Component inter_analyzer_colimator_15_blade_2. */
  /* Setting parameters for component inter_analyzer_colimator_15_blade_2. */
  SIG_MESSAGE("inter_analyzer_colimator_15_blade_2 (Init:SetPar)");
#line 4036 "MACS_sample_kidney_box.instr"
  if("Collimator_gad") strncpy(mccinter_analyzer_colimator_15_blade_2_material_string, "Collimator_gad" ? "Collimator_gad" : "", 16384); else mccinter_analyzer_colimator_15_blade_2_material_string[0]='\0';
#line 4036 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_15_blade_2_priority = 1727;
#line 4035 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_15_blade_2_xwidth = inter_analyzer_colimator_width;
#line 4035 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_15_blade_2_yheight = inter_analyzer_colimator_height;
#line 4035 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_15_blade_2_zdepth = inter_analyzer_colimator_depth;
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_15_blade_2_xwidth2 = -1;
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_15_blade_2_yheight2 = -1;
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_15_blade_2_visualize = 1;
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_15_blade_2_target_index = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_15_blade_2_target_x = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_15_blade_2_target_y = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_15_blade_2_target_z = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_15_blade_2_focus_aw = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_15_blade_2_focus_ah = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_15_blade_2_focus_xw = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_15_blade_2_focus_xh = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_15_blade_2_focus_r = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_15_blade_2_p_interact = 0;
#line 71 "MACS_sample_kidney_box.instr"
  if(0) strncpy(mccinter_analyzer_colimator_15_blade_2_mask_string, 0 ? 0 : "", 16384); else mccinter_analyzer_colimator_15_blade_2_mask_string[0]='\0';
#line 71 "MACS_sample_kidney_box.instr"
  if(0) strncpy(mccinter_analyzer_colimator_15_blade_2_mask_setting, 0 ? 0 : "", 16384); else mccinter_analyzer_colimator_15_blade_2_mask_setting[0]='\0';
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_15_blade_2_number_of_activations = 1;
#line 138981 "MACS_sample_kidney_box.c"

  SIG_MESSAGE("inter_analyzer_colimator_15_blade_2 (Init:Place/Rotate)");
  rot_set_rotation(mctr1,
#line 4038 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 4038 "MACS_sample_kidney_box.instr"
    (- analyzer_2theta [ 15 ])*DEG2RAD,
#line 4038 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD);
#line 138991 "MACS_sample_kidney_box.c"
  rot_mul(mctr1, mcrotainter_analyzer_colimator_center_15, mcrotainter_analyzer_colimator_15_blade_2);
  rot_transpose(mcrotainter_analyzer_colimator_15_blade_1, mctr1);
  rot_mul(mcrotainter_analyzer_colimator_15_blade_2, mctr1, mcrotrinter_analyzer_colimator_15_blade_2);
  mctc1 = coords_set(
#line 4037 "MACS_sample_kidney_box.instr"
    0,
#line 4037 "MACS_sample_kidney_box.instr"
    0,
#line 4037 "MACS_sample_kidney_box.instr"
    inter_analyzer_colimator_start_pos - 2 * inter_analyzer_colimator_seperation);
#line 139002 "MACS_sample_kidney_box.c"
  rot_transpose(mcrotainter_analyzer_colimator_center_15, mctr1);
  mctc2 = rot_apply(mctr1, mctc1);
  mcposainter_analyzer_colimator_15_blade_2 = coords_add(mcposainter_analyzer_colimator_center_15, mctc2);
  mctc1 = coords_sub(mcposainter_analyzer_colimator_15_blade_1, mcposainter_analyzer_colimator_15_blade_2);
  mcposrinter_analyzer_colimator_15_blade_2 = rot_apply(mcrotainter_analyzer_colimator_15_blade_2, mctc1);
  mcDEBUG_COMPONENT("inter_analyzer_colimator_15_blade_2", mcposainter_analyzer_colimator_15_blade_2, mcrotainter_analyzer_colimator_15_blade_2)
  mccomp_posa[727] = mcposainter_analyzer_colimator_15_blade_2;
  mccomp_posr[727] = mcposrinter_analyzer_colimator_15_blade_2;
  mcNCounter[727]  = mcPCounter[727] = mcP2Counter[727] = 0;
  mcAbsorbProp[727]= 0;
    /* Component inter_analyzer_colimator_15_blade_3. */
  /* Setting parameters for component inter_analyzer_colimator_15_blade_3. */
  SIG_MESSAGE("inter_analyzer_colimator_15_blade_3 (Init:SetPar)");
#line 4042 "MACS_sample_kidney_box.instr"
  if("Collimator_gad") strncpy(mccinter_analyzer_colimator_15_blade_3_material_string, "Collimator_gad" ? "Collimator_gad" : "", 16384); else mccinter_analyzer_colimator_15_blade_3_material_string[0]='\0';
#line 4042 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_15_blade_3_priority = 1728;
#line 4041 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_15_blade_3_xwidth = inter_analyzer_colimator_width;
#line 4041 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_15_blade_3_yheight = inter_analyzer_colimator_height;
#line 4041 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_15_blade_3_zdepth = inter_analyzer_colimator_depth;
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_15_blade_3_xwidth2 = -1;
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_15_blade_3_yheight2 = -1;
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_15_blade_3_visualize = 1;
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_15_blade_3_target_index = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_15_blade_3_target_x = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_15_blade_3_target_y = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_15_blade_3_target_z = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_15_blade_3_focus_aw = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_15_blade_3_focus_ah = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_15_blade_3_focus_xw = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_15_blade_3_focus_xh = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_15_blade_3_focus_r = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_15_blade_3_p_interact = 0;
#line 71 "MACS_sample_kidney_box.instr"
  if(0) strncpy(mccinter_analyzer_colimator_15_blade_3_mask_string, 0 ? 0 : "", 16384); else mccinter_analyzer_colimator_15_blade_3_mask_string[0]='\0';
#line 71 "MACS_sample_kidney_box.instr"
  if(0) strncpy(mccinter_analyzer_colimator_15_blade_3_mask_setting, 0 ? 0 : "", 16384); else mccinter_analyzer_colimator_15_blade_3_mask_setting[0]='\0';
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_15_blade_3_number_of_activations = 1;
#line 139058 "MACS_sample_kidney_box.c"

  SIG_MESSAGE("inter_analyzer_colimator_15_blade_3 (Init:Place/Rotate)");
  rot_set_rotation(mctr1,
#line 4044 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 4044 "MACS_sample_kidney_box.instr"
    (- analyzer_2theta [ 15 ])*DEG2RAD,
#line 4044 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD);
#line 139068 "MACS_sample_kidney_box.c"
  rot_mul(mctr1, mcrotainter_analyzer_colimator_center_15, mcrotainter_analyzer_colimator_15_blade_3);
  rot_transpose(mcrotainter_analyzer_colimator_15_blade_2, mctr1);
  rot_mul(mcrotainter_analyzer_colimator_15_blade_3, mctr1, mcrotrinter_analyzer_colimator_15_blade_3);
  mctc1 = coords_set(
#line 4043 "MACS_sample_kidney_box.instr"
    0,
#line 4043 "MACS_sample_kidney_box.instr"
    0,
#line 4043 "MACS_sample_kidney_box.instr"
    inter_analyzer_colimator_start_pos - 3 * inter_analyzer_colimator_seperation);
#line 139079 "MACS_sample_kidney_box.c"
  rot_transpose(mcrotainter_analyzer_colimator_center_15, mctr1);
  mctc2 = rot_apply(mctr1, mctc1);
  mcposainter_analyzer_colimator_15_blade_3 = coords_add(mcposainter_analyzer_colimator_center_15, mctc2);
  mctc1 = coords_sub(mcposainter_analyzer_colimator_15_blade_2, mcposainter_analyzer_colimator_15_blade_3);
  mcposrinter_analyzer_colimator_15_blade_3 = rot_apply(mcrotainter_analyzer_colimator_15_blade_3, mctc1);
  mcDEBUG_COMPONENT("inter_analyzer_colimator_15_blade_3", mcposainter_analyzer_colimator_15_blade_3, mcrotainter_analyzer_colimator_15_blade_3)
  mccomp_posa[728] = mcposainter_analyzer_colimator_15_blade_3;
  mccomp_posr[728] = mcposrinter_analyzer_colimator_15_blade_3;
  mcNCounter[728]  = mcPCounter[728] = mcP2Counter[728] = 0;
  mcAbsorbProp[728]= 0;
    /* Component inter_analyzer_colimator_15_blade_4. */
  /* Setting parameters for component inter_analyzer_colimator_15_blade_4. */
  SIG_MESSAGE("inter_analyzer_colimator_15_blade_4 (Init:SetPar)");
#line 4048 "MACS_sample_kidney_box.instr"
  if("Collimator_gad") strncpy(mccinter_analyzer_colimator_15_blade_4_material_string, "Collimator_gad" ? "Collimator_gad" : "", 16384); else mccinter_analyzer_colimator_15_blade_4_material_string[0]='\0';
#line 4048 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_15_blade_4_priority = 1729;
#line 4047 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_15_blade_4_xwidth = inter_analyzer_colimator_width;
#line 4047 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_15_blade_4_yheight = inter_analyzer_colimator_height;
#line 4047 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_15_blade_4_zdepth = inter_analyzer_colimator_depth;
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_15_blade_4_xwidth2 = -1;
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_15_blade_4_yheight2 = -1;
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_15_blade_4_visualize = 1;
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_15_blade_4_target_index = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_15_blade_4_target_x = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_15_blade_4_target_y = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_15_blade_4_target_z = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_15_blade_4_focus_aw = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_15_blade_4_focus_ah = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_15_blade_4_focus_xw = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_15_blade_4_focus_xh = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_15_blade_4_focus_r = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_15_blade_4_p_interact = 0;
#line 71 "MACS_sample_kidney_box.instr"
  if(0) strncpy(mccinter_analyzer_colimator_15_blade_4_mask_string, 0 ? 0 : "", 16384); else mccinter_analyzer_colimator_15_blade_4_mask_string[0]='\0';
#line 71 "MACS_sample_kidney_box.instr"
  if(0) strncpy(mccinter_analyzer_colimator_15_blade_4_mask_setting, 0 ? 0 : "", 16384); else mccinter_analyzer_colimator_15_blade_4_mask_setting[0]='\0';
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_15_blade_4_number_of_activations = 1;
#line 139135 "MACS_sample_kidney_box.c"

  SIG_MESSAGE("inter_analyzer_colimator_15_blade_4 (Init:Place/Rotate)");
  rot_set_rotation(mctr1,
#line 4050 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 4050 "MACS_sample_kidney_box.instr"
    (- analyzer_2theta [ 15 ])*DEG2RAD,
#line 4050 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD);
#line 139145 "MACS_sample_kidney_box.c"
  rot_mul(mctr1, mcrotainter_analyzer_colimator_center_15, mcrotainter_analyzer_colimator_15_blade_4);
  rot_transpose(mcrotainter_analyzer_colimator_15_blade_3, mctr1);
  rot_mul(mcrotainter_analyzer_colimator_15_blade_4, mctr1, mcrotrinter_analyzer_colimator_15_blade_4);
  mctc1 = coords_set(
#line 4049 "MACS_sample_kidney_box.instr"
    0,
#line 4049 "MACS_sample_kidney_box.instr"
    0,
#line 4049 "MACS_sample_kidney_box.instr"
    inter_analyzer_colimator_start_pos - 4 * inter_analyzer_colimator_seperation);
#line 139156 "MACS_sample_kidney_box.c"
  rot_transpose(mcrotainter_analyzer_colimator_center_15, mctr1);
  mctc2 = rot_apply(mctr1, mctc1);
  mcposainter_analyzer_colimator_15_blade_4 = coords_add(mcposainter_analyzer_colimator_center_15, mctc2);
  mctc1 = coords_sub(mcposainter_analyzer_colimator_15_blade_3, mcposainter_analyzer_colimator_15_blade_4);
  mcposrinter_analyzer_colimator_15_blade_4 = rot_apply(mcrotainter_analyzer_colimator_15_blade_4, mctc1);
  mcDEBUG_COMPONENT("inter_analyzer_colimator_15_blade_4", mcposainter_analyzer_colimator_15_blade_4, mcrotainter_analyzer_colimator_15_blade_4)
  mccomp_posa[729] = mcposainter_analyzer_colimator_15_blade_4;
  mccomp_posr[729] = mcposrinter_analyzer_colimator_15_blade_4;
  mcNCounter[729]  = mcPCounter[729] = mcP2Counter[729] = 0;
  mcAbsorbProp[729]= 0;
    /* Component diffraction_detector_15_exit_volume. */
  /* Setting parameters for component diffraction_detector_15_exit_volume. */
  SIG_MESSAGE("diffraction_detector_15_exit_volume (Init:SetPar)");
#line 4054 "MACS_sample_kidney_box.instr"
  if("Exit") strncpy(mccdiffraction_detector_15_exit_volume_material_string, "Exit" ? "Exit" : "", 16384); else mccdiffraction_detector_15_exit_volume_material_string[0]='\0';
#line 4054 "MACS_sample_kidney_box.instr"
  mccdiffraction_detector_15_exit_volume_priority = 1731;
#line 4053 "MACS_sample_kidney_box.instr"
  mccdiffraction_detector_15_exit_volume_xwidth = 2.01 * detector_radius;
#line 4053 "MACS_sample_kidney_box.instr"
  mccdiffraction_detector_15_exit_volume_yheight = 1.01 * detector_height;
#line 4053 "MACS_sample_kidney_box.instr"
  mccdiffraction_detector_15_exit_volume_zdepth = 0.001;
#line 71 "MACS_sample_kidney_box.instr"
  mccdiffraction_detector_15_exit_volume_xwidth2 = -1;
#line 71 "MACS_sample_kidney_box.instr"
  mccdiffraction_detector_15_exit_volume_yheight2 = -1;
#line 71 "MACS_sample_kidney_box.instr"
  mccdiffraction_detector_15_exit_volume_visualize = 1;
#line 71 "MACS_sample_kidney_box.instr"
  mccdiffraction_detector_15_exit_volume_target_index = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccdiffraction_detector_15_exit_volume_target_x = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccdiffraction_detector_15_exit_volume_target_y = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccdiffraction_detector_15_exit_volume_target_z = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccdiffraction_detector_15_exit_volume_focus_aw = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccdiffraction_detector_15_exit_volume_focus_ah = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccdiffraction_detector_15_exit_volume_focus_xw = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccdiffraction_detector_15_exit_volume_focus_xh = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccdiffraction_detector_15_exit_volume_focus_r = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccdiffraction_detector_15_exit_volume_p_interact = 0;
#line 71 "MACS_sample_kidney_box.instr"
  if(0) strncpy(mccdiffraction_detector_15_exit_volume_mask_string, 0 ? 0 : "", 16384); else mccdiffraction_detector_15_exit_volume_mask_string[0]='\0';
#line 71 "MACS_sample_kidney_box.instr"
  if(0) strncpy(mccdiffraction_detector_15_exit_volume_mask_setting, 0 ? 0 : "", 16384); else mccdiffraction_detector_15_exit_volume_mask_setting[0]='\0';
#line 71 "MACS_sample_kidney_box.instr"
  mccdiffraction_detector_15_exit_volume_number_of_activations = 1;
#line 139212 "MACS_sample_kidney_box.c"

  SIG_MESSAGE("diffraction_detector_15_exit_volume (Init:Place/Rotate)");
  rot_set_rotation(mctr1,
#line 4056 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 4056 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 4056 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD);
#line 139222 "MACS_sample_kidney_box.c"
  rot_mul(mctr1, mcrotakidney_channel_15, mcrotadiffraction_detector_15_exit_volume);
  rot_transpose(mcrotainter_analyzer_colimator_15_blade_4, mctr1);
  rot_mul(mcrotadiffraction_detector_15_exit_volume, mctr1, mcrotrdiffraction_detector_15_exit_volume);
  mctc1 = coords_set(
#line 4055 "MACS_sample_kidney_box.instr"
    0,
#line 4055 "MACS_sample_kidney_box.instr"
    0,
#line 4055 "MACS_sample_kidney_box.instr"
    0);
#line 139233 "MACS_sample_kidney_box.c"
  rot_transpose(mcrotachannel_15_cave1_cyl1, mctr1);
  mctc2 = rot_apply(mctr1, mctc1);
  mcposadiffraction_detector_15_exit_volume = coords_add(mcposachannel_15_cave1_cyl1, mctc2);
  mctc1 = coords_sub(mcposainter_analyzer_colimator_15_blade_4, mcposadiffraction_detector_15_exit_volume);
  mcposrdiffraction_detector_15_exit_volume = rot_apply(mcrotadiffraction_detector_15_exit_volume, mctc1);
  mcDEBUG_COMPONENT("diffraction_detector_15_exit_volume", mcposadiffraction_detector_15_exit_volume, mcrotadiffraction_detector_15_exit_volume)
  mccomp_posa[730] = mcposadiffraction_detector_15_exit_volume;
  mccomp_posr[730] = mcposrdiffraction_detector_15_exit_volume;
  mcNCounter[730]  = mcPCounter[730] = mcP2Counter[730] = 0;
  mcAbsorbProp[730]= 0;
    /* Component spec_detector_15_exit_volume. */
  /* Setting parameters for component spec_detector_15_exit_volume. */
  SIG_MESSAGE("spec_detector_15_exit_volume (Init:SetPar)");
#line 4060 "MACS_sample_kidney_box.instr"
  if("Exit") strncpy(mccspec_detector_15_exit_volume_material_string, "Exit" ? "Exit" : "", 16384); else mccspec_detector_15_exit_volume_material_string[0]='\0';
#line 4060 "MACS_sample_kidney_box.instr"
  mccspec_detector_15_exit_volume_priority = 1732;
#line 4059 "MACS_sample_kidney_box.instr"
  mccspec_detector_15_exit_volume_xwidth = 2.01 * detector_radius;
#line 4059 "MACS_sample_kidney_box.instr"
  mccspec_detector_15_exit_volume_yheight = 1.01 * detector_height;
#line 4059 "MACS_sample_kidney_box.instr"
  mccspec_detector_15_exit_volume_zdepth = 0.001;
#line 71 "MACS_sample_kidney_box.instr"
  mccspec_detector_15_exit_volume_xwidth2 = -1;
#line 71 "MACS_sample_kidney_box.instr"
  mccspec_detector_15_exit_volume_yheight2 = -1;
#line 71 "MACS_sample_kidney_box.instr"
  mccspec_detector_15_exit_volume_visualize = 1;
#line 71 "MACS_sample_kidney_box.instr"
  mccspec_detector_15_exit_volume_target_index = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccspec_detector_15_exit_volume_target_x = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccspec_detector_15_exit_volume_target_y = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccspec_detector_15_exit_volume_target_z = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccspec_detector_15_exit_volume_focus_aw = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccspec_detector_15_exit_volume_focus_ah = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccspec_detector_15_exit_volume_focus_xw = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccspec_detector_15_exit_volume_focus_xh = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccspec_detector_15_exit_volume_focus_r = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccspec_detector_15_exit_volume_p_interact = 0;
#line 71 "MACS_sample_kidney_box.instr"
  if(0) strncpy(mccspec_detector_15_exit_volume_mask_string, 0 ? 0 : "", 16384); else mccspec_detector_15_exit_volume_mask_string[0]='\0';
#line 71 "MACS_sample_kidney_box.instr"
  if(0) strncpy(mccspec_detector_15_exit_volume_mask_setting, 0 ? 0 : "", 16384); else mccspec_detector_15_exit_volume_mask_setting[0]='\0';
#line 71 "MACS_sample_kidney_box.instr"
  mccspec_detector_15_exit_volume_number_of_activations = 1;
#line 139289 "MACS_sample_kidney_box.c"

  SIG_MESSAGE("spec_detector_15_exit_volume (Init:Place/Rotate)");
  rot_set_rotation(mctr1,
#line 4062 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 4062 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 4062 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD);
#line 139299 "MACS_sample_kidney_box.c"
  rot_mul(mctr1, mcrotachannel_15_analyzer_2_center, mcrotaspec_detector_15_exit_volume);
  rot_transpose(mcrotadiffraction_detector_15_exit_volume, mctr1);
  rot_mul(mcrotaspec_detector_15_exit_volume, mctr1, mcrotrspec_detector_15_exit_volume);
  mctc1 = coords_set(
#line 4061 "MACS_sample_kidney_box.instr"
    0,
#line 4061 "MACS_sample_kidney_box.instr"
    0,
#line 4061 "MACS_sample_kidney_box.instr"
    0);
#line 139310 "MACS_sample_kidney_box.c"
  rot_transpose(mcrotachannel_15_cave2_cyl1, mctr1);
  mctc2 = rot_apply(mctr1, mctc1);
  mcposaspec_detector_15_exit_volume = coords_add(mcposachannel_15_cave2_cyl1, mctc2);
  mctc1 = coords_sub(mcposadiffraction_detector_15_exit_volume, mcposaspec_detector_15_exit_volume);
  mcposrspec_detector_15_exit_volume = rot_apply(mcrotaspec_detector_15_exit_volume, mctc1);
  mcDEBUG_COMPONENT("spec_detector_15_exit_volume", mcposaspec_detector_15_exit_volume, mcrotaspec_detector_15_exit_volume)
  mccomp_posa[731] = mcposaspec_detector_15_exit_volume;
  mccomp_posr[731] = mcposrspec_detector_15_exit_volume;
  mcNCounter[731]  = mcPCounter[731] = mcP2Counter[731] = 0;
  mcAbsorbProp[731]= 0;
    /* Component channel_16_cave1_box1. */
  /* Setting parameters for component channel_16_cave1_box1. */
  SIG_MESSAGE("channel_16_cave1_box1 (Init:SetPar)");
#line 4067 "MACS_sample_kidney_box.instr"
  if("Vacuum") strncpy(mccchannel_16_cave1_box1_material_string, "Vacuum" ? "Vacuum" : "", 16384); else mccchannel_16_cave1_box1_material_string[0]='\0';
#line 4067 "MACS_sample_kidney_box.instr"
  mccchannel_16_cave1_box1_priority = 1800;
#line 4065 "MACS_sample_kidney_box.instr"
  mccchannel_16_cave1_box1_xwidth = kidney_cave1_box1_width1;
#line 4065 "MACS_sample_kidney_box.instr"
  mccchannel_16_cave1_box1_yheight = kidney_cave1_box1_height1;
#line 4065 "MACS_sample_kidney_box.instr"
  mccchannel_16_cave1_box1_zdepth = kidney_cave1_box1_depth;
#line 4066 "MACS_sample_kidney_box.instr"
  mccchannel_16_cave1_box1_xwidth2 = kidney_cave1_box1_width2;
#line 4066 "MACS_sample_kidney_box.instr"
  mccchannel_16_cave1_box1_yheight2 = kidney_cave1_box1_height2;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_16_cave1_box1_visualize = 1;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_16_cave1_box1_target_index = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_16_cave1_box1_target_x = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_16_cave1_box1_target_y = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_16_cave1_box1_target_z = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_16_cave1_box1_focus_aw = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_16_cave1_box1_focus_ah = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_16_cave1_box1_focus_xw = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_16_cave1_box1_focus_xh = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_16_cave1_box1_focus_r = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_16_cave1_box1_p_interact = 0;
#line 71 "MACS_sample_kidney_box.instr"
  if(0) strncpy(mccchannel_16_cave1_box1_mask_string, 0 ? 0 : "", 16384); else mccchannel_16_cave1_box1_mask_string[0]='\0';
#line 71 "MACS_sample_kidney_box.instr"
  if(0) strncpy(mccchannel_16_cave1_box1_mask_setting, 0 ? 0 : "", 16384); else mccchannel_16_cave1_box1_mask_setting[0]='\0';
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_16_cave1_box1_number_of_activations = 1;
#line 139366 "MACS_sample_kidney_box.c"

  SIG_MESSAGE("channel_16_cave1_box1 (Init:Place/Rotate)");
  rot_set_rotation(mctr1,
#line 4069 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 4069 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 4069 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD);
#line 139376 "MACS_sample_kidney_box.c"
  rot_mul(mctr1, mcrotakidney_channel_16, mcrotachannel_16_cave1_box1);
  rot_transpose(mcrotaspec_detector_15_exit_volume, mctr1);
  rot_mul(mcrotachannel_16_cave1_box1, mctr1, mcrotrchannel_16_cave1_box1);
  mctc1 = coords_set(
#line 4068 "MACS_sample_kidney_box.instr"
    0,
#line 4068 "MACS_sample_kidney_box.instr"
    0,
#line 4068 "MACS_sample_kidney_box.instr"
    kidney_cave1_box1_center_to_target);
#line 139387 "MACS_sample_kidney_box.c"
  rot_transpose(mcrotakidney_channel_16, mctr1);
  mctc2 = rot_apply(mctr1, mctc1);
  mcposachannel_16_cave1_box1 = coords_add(mcposakidney_channel_16, mctc2);
  mctc1 = coords_sub(mcposaspec_detector_15_exit_volume, mcposachannel_16_cave1_box1);
  mcposrchannel_16_cave1_box1 = rot_apply(mcrotachannel_16_cave1_box1, mctc1);
  mcDEBUG_COMPONENT("channel_16_cave1_box1", mcposachannel_16_cave1_box1, mcrotachannel_16_cave1_box1)
  mccomp_posa[732] = mcposachannel_16_cave1_box1;
  mccomp_posr[732] = mcposrchannel_16_cave1_box1;
  mcNCounter[732]  = mcPCounter[732] = mcP2Counter[732] = 0;
  mcAbsorbProp[732]= 0;
    /* Component channel_16_cave1_box2. */
  /* Setting parameters for component channel_16_cave1_box2. */
  SIG_MESSAGE("channel_16_cave1_box2 (Init:SetPar)");
#line 4074 "MACS_sample_kidney_box.instr"
  if("Vacuum") strncpy(mccchannel_16_cave1_box2_material_string, "Vacuum" ? "Vacuum" : "", 16384); else mccchannel_16_cave1_box2_material_string[0]='\0';
#line 4074 "MACS_sample_kidney_box.instr"
  mccchannel_16_cave1_box2_priority = 1805;
#line 4072 "MACS_sample_kidney_box.instr"
  mccchannel_16_cave1_box2_xwidth = kidney_cave1_box2_width1;
#line 4072 "MACS_sample_kidney_box.instr"
  mccchannel_16_cave1_box2_yheight = kidney_cave1_box2_height1;
#line 4072 "MACS_sample_kidney_box.instr"
  mccchannel_16_cave1_box2_zdepth = kidney_cave1_box2_depth;
#line 4073 "MACS_sample_kidney_box.instr"
  mccchannel_16_cave1_box2_xwidth2 = kidney_cave1_box2_width2;
#line 4073 "MACS_sample_kidney_box.instr"
  mccchannel_16_cave1_box2_yheight2 = kidney_cave1_box2_height2;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_16_cave1_box2_visualize = 1;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_16_cave1_box2_target_index = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_16_cave1_box2_target_x = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_16_cave1_box2_target_y = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_16_cave1_box2_target_z = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_16_cave1_box2_focus_aw = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_16_cave1_box2_focus_ah = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_16_cave1_box2_focus_xw = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_16_cave1_box2_focus_xh = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_16_cave1_box2_focus_r = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_16_cave1_box2_p_interact = 0;
#line 71 "MACS_sample_kidney_box.instr"
  if(0) strncpy(mccchannel_16_cave1_box2_mask_string, 0 ? 0 : "", 16384); else mccchannel_16_cave1_box2_mask_string[0]='\0';
#line 71 "MACS_sample_kidney_box.instr"
  if(0) strncpy(mccchannel_16_cave1_box2_mask_setting, 0 ? 0 : "", 16384); else mccchannel_16_cave1_box2_mask_setting[0]='\0';
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_16_cave1_box2_number_of_activations = 1;
#line 139443 "MACS_sample_kidney_box.c"

  SIG_MESSAGE("channel_16_cave1_box2 (Init:Place/Rotate)");
  rot_set_rotation(mctr1,
#line 4076 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 4076 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 4076 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD);
#line 139453 "MACS_sample_kidney_box.c"
  rot_mul(mctr1, mcrotakidney_channel_16, mcrotachannel_16_cave1_box2);
  rot_transpose(mcrotachannel_16_cave1_box1, mctr1);
  rot_mul(mcrotachannel_16_cave1_box2, mctr1, mcrotrchannel_16_cave1_box2);
  mctc1 = coords_set(
#line 4075 "MACS_sample_kidney_box.instr"
    kidney_cave1_box2_x_offset,
#line 4075 "MACS_sample_kidney_box.instr"
    0,
#line 4075 "MACS_sample_kidney_box.instr"
    kidney_cave1_box2_center_to_target);
#line 139464 "MACS_sample_kidney_box.c"
  rot_transpose(mcrotakidney_channel_16, mctr1);
  mctc2 = rot_apply(mctr1, mctc1);
  mcposachannel_16_cave1_box2 = coords_add(mcposakidney_channel_16, mctc2);
  mctc1 = coords_sub(mcposachannel_16_cave1_box1, mcposachannel_16_cave1_box2);
  mcposrchannel_16_cave1_box2 = rot_apply(mcrotachannel_16_cave1_box2, mctc1);
  mcDEBUG_COMPONENT("channel_16_cave1_box2", mcposachannel_16_cave1_box2, mcrotachannel_16_cave1_box2)
  mccomp_posa[733] = mcposachannel_16_cave1_box2;
  mccomp_posr[733] = mcposrchannel_16_cave1_box2;
  mcNCounter[733]  = mcPCounter[733] = mcP2Counter[733] = 0;
  mcAbsorbProp[733]= 0;
    /* Component channel_16_cave1_box3. */
  /* Setting parameters for component channel_16_cave1_box3. */
  SIG_MESSAGE("channel_16_cave1_box3 (Init:SetPar)");
#line 4081 "MACS_sample_kidney_box.instr"
  if("Vacuum") strncpy(mccchannel_16_cave1_box3_material_string, "Vacuum" ? "Vacuum" : "", 16384); else mccchannel_16_cave1_box3_material_string[0]='\0';
#line 4081 "MACS_sample_kidney_box.instr"
  mccchannel_16_cave1_box3_priority = 1802;
#line 4079 "MACS_sample_kidney_box.instr"
  mccchannel_16_cave1_box3_xwidth = kidney_cave1_box3_width1;
#line 4079 "MACS_sample_kidney_box.instr"
  mccchannel_16_cave1_box3_yheight = kidney_cave1_box3_height1;
#line 4079 "MACS_sample_kidney_box.instr"
  mccchannel_16_cave1_box3_zdepth = kidney_cave1_box3_depth;
#line 4080 "MACS_sample_kidney_box.instr"
  mccchannel_16_cave1_box3_xwidth2 = kidney_cave1_box3_width2;
#line 4080 "MACS_sample_kidney_box.instr"
  mccchannel_16_cave1_box3_yheight2 = kidney_cave1_box3_height2;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_16_cave1_box3_visualize = 1;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_16_cave1_box3_target_index = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_16_cave1_box3_target_x = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_16_cave1_box3_target_y = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_16_cave1_box3_target_z = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_16_cave1_box3_focus_aw = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_16_cave1_box3_focus_ah = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_16_cave1_box3_focus_xw = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_16_cave1_box3_focus_xh = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_16_cave1_box3_focus_r = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_16_cave1_box3_p_interact = 0;
#line 71 "MACS_sample_kidney_box.instr"
  if(0) strncpy(mccchannel_16_cave1_box3_mask_string, 0 ? 0 : "", 16384); else mccchannel_16_cave1_box3_mask_string[0]='\0';
#line 71 "MACS_sample_kidney_box.instr"
  if(0) strncpy(mccchannel_16_cave1_box3_mask_setting, 0 ? 0 : "", 16384); else mccchannel_16_cave1_box3_mask_setting[0]='\0';
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_16_cave1_box3_number_of_activations = 1;
#line 139520 "MACS_sample_kidney_box.c"

  SIG_MESSAGE("channel_16_cave1_box3 (Init:Place/Rotate)");
  rot_set_rotation(mctr1,
#line 4083 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 4083 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 4083 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD);
#line 139530 "MACS_sample_kidney_box.c"
  rot_mul(mctr1, mcrotakidney_channel_16, mcrotachannel_16_cave1_box3);
  rot_transpose(mcrotachannel_16_cave1_box2, mctr1);
  rot_mul(mcrotachannel_16_cave1_box3, mctr1, mcrotrchannel_16_cave1_box3);
  mctc1 = coords_set(
#line 4082 "MACS_sample_kidney_box.instr"
    0,
#line 4082 "MACS_sample_kidney_box.instr"
    0,
#line 4082 "MACS_sample_kidney_box.instr"
    kidney_cave1_box3_center_to_target);
#line 139541 "MACS_sample_kidney_box.c"
  rot_transpose(mcrotakidney_channel_16, mctr1);
  mctc2 = rot_apply(mctr1, mctc1);
  mcposachannel_16_cave1_box3 = coords_add(mcposakidney_channel_16, mctc2);
  mctc1 = coords_sub(mcposachannel_16_cave1_box2, mcposachannel_16_cave1_box3);
  mcposrchannel_16_cave1_box3 = rot_apply(mcrotachannel_16_cave1_box3, mctc1);
  mcDEBUG_COMPONENT("channel_16_cave1_box3", mcposachannel_16_cave1_box3, mcrotachannel_16_cave1_box3)
  mccomp_posa[734] = mcposachannel_16_cave1_box3;
  mccomp_posr[734] = mcposrchannel_16_cave1_box3;
  mcNCounter[734]  = mcPCounter[734] = mcP2Counter[734] = 0;
  mcAbsorbProp[734]= 0;
    /* Component channel_16_cave1_cyl1. */
  /* Setting parameters for component channel_16_cave1_cyl1. */
  SIG_MESSAGE("channel_16_cave1_cyl1 (Init:SetPar)");
#line 4087 "MACS_sample_kidney_box.instr"
  if("Vacuum") strncpy(mccchannel_16_cave1_cyl1_material_string, "Vacuum" ? "Vacuum" : "", 16384); else mccchannel_16_cave1_cyl1_material_string[0]='\0';
#line 4087 "MACS_sample_kidney_box.instr"
  mccchannel_16_cave1_cyl1_priority = 1803;
#line 4086 "MACS_sample_kidney_box.instr"
  mccchannel_16_cave1_cyl1_radius = kidney_cave1_cyl1_radius;
#line 4086 "MACS_sample_kidney_box.instr"
  mccchannel_16_cave1_cyl1_yheight = kidney_cave1_cyl1_height;
#line 67 "MACS_sample_kidney_box.instr"
  mccchannel_16_cave1_cyl1_visualize = 1;
#line 67 "MACS_sample_kidney_box.instr"
  mccchannel_16_cave1_cyl1_target_index = 0;
#line 67 "MACS_sample_kidney_box.instr"
  mccchannel_16_cave1_cyl1_target_x = 0;
#line 67 "MACS_sample_kidney_box.instr"
  mccchannel_16_cave1_cyl1_target_y = 0;
#line 67 "MACS_sample_kidney_box.instr"
  mccchannel_16_cave1_cyl1_target_z = 0;
#line 67 "MACS_sample_kidney_box.instr"
  mccchannel_16_cave1_cyl1_focus_aw = 0;
#line 67 "MACS_sample_kidney_box.instr"
  mccchannel_16_cave1_cyl1_focus_ah = 0;
#line 67 "MACS_sample_kidney_box.instr"
  mccchannel_16_cave1_cyl1_focus_xw = 0;
#line 67 "MACS_sample_kidney_box.instr"
  mccchannel_16_cave1_cyl1_focus_xh = 0;
#line 67 "MACS_sample_kidney_box.instr"
  mccchannel_16_cave1_cyl1_focus_r = 0;
#line 67 "MACS_sample_kidney_box.instr"
  mccchannel_16_cave1_cyl1_p_interact = 0;
#line 67 "MACS_sample_kidney_box.instr"
  if(0) strncpy(mccchannel_16_cave1_cyl1_mask_string, 0 ? 0 : "", 16384); else mccchannel_16_cave1_cyl1_mask_string[0]='\0';
#line 67 "MACS_sample_kidney_box.instr"
  if(0) strncpy(mccchannel_16_cave1_cyl1_mask_setting, 0 ? 0 : "", 16384); else mccchannel_16_cave1_cyl1_mask_setting[0]='\0';
#line 67 "MACS_sample_kidney_box.instr"
  mccchannel_16_cave1_cyl1_number_of_activations = 1;
#line 139591 "MACS_sample_kidney_box.c"

  SIG_MESSAGE("channel_16_cave1_cyl1 (Init:Place/Rotate)");
  rot_set_rotation(mctr1,
#line 4089 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 4089 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 4089 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD);
#line 139601 "MACS_sample_kidney_box.c"
  rot_mul(mctr1, mcrotakidney_channel_16, mcrotachannel_16_cave1_cyl1);
  rot_transpose(mcrotachannel_16_cave1_box3, mctr1);
  rot_mul(mcrotachannel_16_cave1_cyl1, mctr1, mcrotrchannel_16_cave1_cyl1);
  mctc1 = coords_set(
#line 4088 "MACS_sample_kidney_box.instr"
    0,
#line 4088 "MACS_sample_kidney_box.instr"
    0,
#line 4088 "MACS_sample_kidney_box.instr"
    kidney_cave1_cyl1_center_to_target);
#line 139612 "MACS_sample_kidney_box.c"
  rot_transpose(mcrotakidney_channel_16, mctr1);
  mctc2 = rot_apply(mctr1, mctc1);
  mcposachannel_16_cave1_cyl1 = coords_add(mcposakidney_channel_16, mctc2);
  mctc1 = coords_sub(mcposachannel_16_cave1_box3, mcposachannel_16_cave1_cyl1);
  mcposrchannel_16_cave1_cyl1 = rot_apply(mcrotachannel_16_cave1_cyl1, mctc1);
  mcDEBUG_COMPONENT("channel_16_cave1_cyl1", mcposachannel_16_cave1_cyl1, mcrotachannel_16_cave1_cyl1)
  mccomp_posa[735] = mcposachannel_16_cave1_cyl1;
  mccomp_posr[735] = mcposrchannel_16_cave1_cyl1;
  mcNCounter[735]  = mcPCounter[735] = mcP2Counter[735] = 0;
  mcAbsorbProp[735]= 0;
    /* Component channel_16_analyzer_1_center. */
  /* Setting parameters for component channel_16_analyzer_1_center. */
  SIG_MESSAGE("channel_16_analyzer_1_center (Init:SetPar)");

  SIG_MESSAGE("channel_16_analyzer_1_center (Init:Place/Rotate)");
  rot_set_rotation(mctr1,
    (0.0)*DEG2RAD,
    (0.0)*DEG2RAD,
    (0.0)*DEG2RAD);
#line 139632 "MACS_sample_kidney_box.c"
  rot_mul(mctr1, mcrotakidney_channel_16, mcrotachannel_16_analyzer_1_center);
  rot_transpose(mcrotachannel_16_cave1_cyl1, mctr1);
  rot_mul(mcrotachannel_16_analyzer_1_center, mctr1, mcrotrchannel_16_analyzer_1_center);
  mctc1 = coords_set(
#line 4093 "MACS_sample_kidney_box.instr"
    0,
#line 4093 "MACS_sample_kidney_box.instr"
    0,
#line 4093 "MACS_sample_kidney_box.instr"
    analyzer_1_center_to_sample);
#line 139643 "MACS_sample_kidney_box.c"
  rot_transpose(mcrotakidney_channel_16, mctr1);
  mctc2 = rot_apply(mctr1, mctc1);
  mcposachannel_16_analyzer_1_center = coords_add(mcposakidney_channel_16, mctc2);
  mctc1 = coords_sub(mcposachannel_16_cave1_cyl1, mcposachannel_16_analyzer_1_center);
  mcposrchannel_16_analyzer_1_center = rot_apply(mcrotachannel_16_analyzer_1_center, mctc1);
  mcDEBUG_COMPONENT("channel_16_analyzer_1_center", mcposachannel_16_analyzer_1_center, mcrotachannel_16_analyzer_1_center)
  mccomp_posa[736] = mcposachannel_16_analyzer_1_center;
  mccomp_posr[736] = mcposrchannel_16_analyzer_1_center;
  mcNCounter[736]  = mcPCounter[736] = mcP2Counter[736] = 0;
  mcAbsorbProp[736]= 0;
    /* Component channel_16_analyzer_1_rotated. */
  /* Setting parameters for component channel_16_analyzer_1_rotated. */
  SIG_MESSAGE("channel_16_analyzer_1_rotated (Init:SetPar)");

  SIG_MESSAGE("channel_16_analyzer_1_rotated (Init:Place/Rotate)");
  rot_set_rotation(mctr1,
#line 4097 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 4097 "MACS_sample_kidney_box.instr"
    (180 - analyzer_theta [ 16 ])*DEG2RAD,
#line 4097 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD);
#line 139666 "MACS_sample_kidney_box.c"
  rot_mul(mctr1, mcrotachannel_16_analyzer_1_center, mcrotachannel_16_analyzer_1_rotated);
  rot_transpose(mcrotachannel_16_analyzer_1_center, mctr1);
  rot_mul(mcrotachannel_16_analyzer_1_rotated, mctr1, mcrotrchannel_16_analyzer_1_rotated);
  mctc1 = coords_set(
#line 4096 "MACS_sample_kidney_box.instr"
    0,
#line 4096 "MACS_sample_kidney_box.instr"
    0,
#line 4096 "MACS_sample_kidney_box.instr"
    -0.5 * analyzer_seperation / tan ( analyzer_2theta [ 16 ] * DEG2RAD ));
#line 139677 "MACS_sample_kidney_box.c"
  rot_transpose(mcrotachannel_16_analyzer_1_center, mctr1);
  mctc2 = rot_apply(mctr1, mctc1);
  mcposachannel_16_analyzer_1_rotated = coords_add(mcposachannel_16_analyzer_1_center, mctc2);
  mctc1 = coords_sub(mcposachannel_16_analyzer_1_center, mcposachannel_16_analyzer_1_rotated);
  mcposrchannel_16_analyzer_1_rotated = rot_apply(mcrotachannel_16_analyzer_1_rotated, mctc1);
  mcDEBUG_COMPONENT("channel_16_analyzer_1_rotated", mcposachannel_16_analyzer_1_rotated, mcrotachannel_16_analyzer_1_rotated)
  mccomp_posa[737] = mcposachannel_16_analyzer_1_rotated;
  mccomp_posr[737] = mcposrchannel_16_analyzer_1_rotated;
  mcNCounter[737]  = mcPCounter[737] = mcP2Counter[737] = 0;
  mcAbsorbProp[737]= 0;
    /* Component channel_16_analyzer_1_array_crystal_array_0. */
  /* Setting parameters for component channel_16_analyzer_1_array_crystal_array_0. */
  SIG_MESSAGE("channel_16_analyzer_1_array_crystal_array_0 (Init:SetPar)");
#line 4101 "MACS_sample_kidney_box.instr"
  if("PG_analyzer") strncpy(mccchannel_16_analyzer_1_array_crystal_array_0_material_string, "PG_analyzer" ? "PG_analyzer" : "", 16384); else mccchannel_16_analyzer_1_array_crystal_array_0_material_string[0]='\0';
#line 4101 "MACS_sample_kidney_box.instr"
  mccchannel_16_analyzer_1_array_crystal_array_0_priority = 1820.0;
#line 4100 "MACS_sample_kidney_box.instr"
  mccchannel_16_analyzer_1_array_crystal_array_0_xwidth = channel_16_analyzer_1_array_crystal_depth;
#line 4100 "MACS_sample_kidney_box.instr"
  mccchannel_16_analyzer_1_array_crystal_array_0_yheight = channel_16_analyzer_1_array_crystal_height;
#line 4100 "MACS_sample_kidney_box.instr"
  mccchannel_16_analyzer_1_array_crystal_array_0_zdepth = channel_16_analyzer_1_array_crystal_width;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_16_analyzer_1_array_crystal_array_0_xwidth2 = -1;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_16_analyzer_1_array_crystal_array_0_yheight2 = -1;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_16_analyzer_1_array_crystal_array_0_visualize = 1;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_16_analyzer_1_array_crystal_array_0_target_index = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_16_analyzer_1_array_crystal_array_0_target_x = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_16_analyzer_1_array_crystal_array_0_target_y = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_16_analyzer_1_array_crystal_array_0_target_z = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_16_analyzer_1_array_crystal_array_0_focus_aw = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_16_analyzer_1_array_crystal_array_0_focus_ah = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_16_analyzer_1_array_crystal_array_0_focus_xw = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_16_analyzer_1_array_crystal_array_0_focus_xh = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_16_analyzer_1_array_crystal_array_0_focus_r = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_16_analyzer_1_array_crystal_array_0_p_interact = 0;
#line 71 "MACS_sample_kidney_box.instr"
  if(0) strncpy(mccchannel_16_analyzer_1_array_crystal_array_0_mask_string, 0 ? 0 : "", 16384); else mccchannel_16_analyzer_1_array_crystal_array_0_mask_string[0]='\0';
#line 71 "MACS_sample_kidney_box.instr"
  if(0) strncpy(mccchannel_16_analyzer_1_array_crystal_array_0_mask_setting, 0 ? 0 : "", 16384); else mccchannel_16_analyzer_1_array_crystal_array_0_mask_setting[0]='\0';
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_16_analyzer_1_array_crystal_array_0_number_of_activations = 1;
#line 139733 "MACS_sample_kidney_box.c"

  SIG_MESSAGE("channel_16_analyzer_1_array_crystal_array_0 (Init:Place/Rotate)");
  rot_set_rotation(mctr1,
#line 4103 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 4103 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 4103 "MACS_sample_kidney_box.instr"
    (0 - RAD2DEG * channel_16_analyzer_1_array_theta [ 0 ])*DEG2RAD);
#line 139743 "MACS_sample_kidney_box.c"
  rot_mul(mctr1, mcrotachannel_16_analyzer_1_rotated, mcrotachannel_16_analyzer_1_array_crystal_array_0);
  rot_transpose(mcrotachannel_16_analyzer_1_rotated, mctr1);
  rot_mul(mcrotachannel_16_analyzer_1_array_crystal_array_0, mctr1, mcrotrchannel_16_analyzer_1_array_crystal_array_0);
  mctc1 = coords_set(
#line 4102 "MACS_sample_kidney_box.instr"
    0 + channel_16_analyzer_1_array_effective_radius_of_curvature * ( 1 - cos ( channel_16_analyzer_1_array_theta [ 0 ] ) ),
#line 4102 "MACS_sample_kidney_box.instr"
    0 + channel_16_analyzer_1_array_effective_radius_of_curvature * sin ( channel_16_analyzer_1_array_theta [ 0 ] ),
#line 4102 "MACS_sample_kidney_box.instr"
    0);
#line 139754 "MACS_sample_kidney_box.c"
  rot_transpose(mcrotachannel_16_analyzer_1_rotated, mctr1);
  mctc2 = rot_apply(mctr1, mctc1);
  mcposachannel_16_analyzer_1_array_crystal_array_0 = coords_add(mcposachannel_16_analyzer_1_rotated, mctc2);
  mctc1 = coords_sub(mcposachannel_16_analyzer_1_rotated, mcposachannel_16_analyzer_1_array_crystal_array_0);
  mcposrchannel_16_analyzer_1_array_crystal_array_0 = rot_apply(mcrotachannel_16_analyzer_1_array_crystal_array_0, mctc1);
  mcDEBUG_COMPONENT("channel_16_analyzer_1_array_crystal_array_0", mcposachannel_16_analyzer_1_array_crystal_array_0, mcrotachannel_16_analyzer_1_array_crystal_array_0)
  mccomp_posa[738] = mcposachannel_16_analyzer_1_array_crystal_array_0;
  mccomp_posr[738] = mcposrchannel_16_analyzer_1_array_crystal_array_0;
  mcNCounter[738]  = mcPCounter[738] = mcP2Counter[738] = 0;
  mcAbsorbProp[738]= 0;
    /* Component channel_16_analyzer_1_array_crystal_array_1. */
  /* Setting parameters for component channel_16_analyzer_1_array_crystal_array_1. */
  SIG_MESSAGE("channel_16_analyzer_1_array_crystal_array_1 (Init:SetPar)");
#line 4107 "MACS_sample_kidney_box.instr"
  if("PG_analyzer") strncpy(mccchannel_16_analyzer_1_array_crystal_array_1_material_string, "PG_analyzer" ? "PG_analyzer" : "", 16384); else mccchannel_16_analyzer_1_array_crystal_array_1_material_string[0]='\0';
#line 4107 "MACS_sample_kidney_box.instr"
  mccchannel_16_analyzer_1_array_crystal_array_1_priority = 1820.1;
#line 4106 "MACS_sample_kidney_box.instr"
  mccchannel_16_analyzer_1_array_crystal_array_1_xwidth = channel_16_analyzer_1_array_crystal_depth;
#line 4106 "MACS_sample_kidney_box.instr"
  mccchannel_16_analyzer_1_array_crystal_array_1_yheight = channel_16_analyzer_1_array_crystal_height;
#line 4106 "MACS_sample_kidney_box.instr"
  mccchannel_16_analyzer_1_array_crystal_array_1_zdepth = channel_16_analyzer_1_array_crystal_width;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_16_analyzer_1_array_crystal_array_1_xwidth2 = -1;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_16_analyzer_1_array_crystal_array_1_yheight2 = -1;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_16_analyzer_1_array_crystal_array_1_visualize = 1;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_16_analyzer_1_array_crystal_array_1_target_index = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_16_analyzer_1_array_crystal_array_1_target_x = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_16_analyzer_1_array_crystal_array_1_target_y = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_16_analyzer_1_array_crystal_array_1_target_z = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_16_analyzer_1_array_crystal_array_1_focus_aw = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_16_analyzer_1_array_crystal_array_1_focus_ah = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_16_analyzer_1_array_crystal_array_1_focus_xw = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_16_analyzer_1_array_crystal_array_1_focus_xh = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_16_analyzer_1_array_crystal_array_1_focus_r = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_16_analyzer_1_array_crystal_array_1_p_interact = 0;
#line 71 "MACS_sample_kidney_box.instr"
  if(0) strncpy(mccchannel_16_analyzer_1_array_crystal_array_1_mask_string, 0 ? 0 : "", 16384); else mccchannel_16_analyzer_1_array_crystal_array_1_mask_string[0]='\0';
#line 71 "MACS_sample_kidney_box.instr"
  if(0) strncpy(mccchannel_16_analyzer_1_array_crystal_array_1_mask_setting, 0 ? 0 : "", 16384); else mccchannel_16_analyzer_1_array_crystal_array_1_mask_setting[0]='\0';
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_16_analyzer_1_array_crystal_array_1_number_of_activations = 1;
#line 139810 "MACS_sample_kidney_box.c"

  SIG_MESSAGE("channel_16_analyzer_1_array_crystal_array_1 (Init:Place/Rotate)");
  rot_set_rotation(mctr1,
#line 4109 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 4109 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 4109 "MACS_sample_kidney_box.instr"
    (0 - RAD2DEG * channel_16_analyzer_1_array_theta [ 1 ])*DEG2RAD);
#line 139820 "MACS_sample_kidney_box.c"
  rot_mul(mctr1, mcrotachannel_16_analyzer_1_rotated, mcrotachannel_16_analyzer_1_array_crystal_array_1);
  rot_transpose(mcrotachannel_16_analyzer_1_array_crystal_array_0, mctr1);
  rot_mul(mcrotachannel_16_analyzer_1_array_crystal_array_1, mctr1, mcrotrchannel_16_analyzer_1_array_crystal_array_1);
  mctc1 = coords_set(
#line 4108 "MACS_sample_kidney_box.instr"
    0 + channel_16_analyzer_1_array_effective_radius_of_curvature * ( 1 - cos ( channel_16_analyzer_1_array_theta [ 1 ] ) ),
#line 4108 "MACS_sample_kidney_box.instr"
    0 + channel_16_analyzer_1_array_effective_radius_of_curvature * sin ( channel_16_analyzer_1_array_theta [ 1 ] ),
#line 4108 "MACS_sample_kidney_box.instr"
    0);
#line 139831 "MACS_sample_kidney_box.c"
  rot_transpose(mcrotachannel_16_analyzer_1_rotated, mctr1);
  mctc2 = rot_apply(mctr1, mctc1);
  mcposachannel_16_analyzer_1_array_crystal_array_1 = coords_add(mcposachannel_16_analyzer_1_rotated, mctc2);
  mctc1 = coords_sub(mcposachannel_16_analyzer_1_array_crystal_array_0, mcposachannel_16_analyzer_1_array_crystal_array_1);
  mcposrchannel_16_analyzer_1_array_crystal_array_1 = rot_apply(mcrotachannel_16_analyzer_1_array_crystal_array_1, mctc1);
  mcDEBUG_COMPONENT("channel_16_analyzer_1_array_crystal_array_1", mcposachannel_16_analyzer_1_array_crystal_array_1, mcrotachannel_16_analyzer_1_array_crystal_array_1)
  mccomp_posa[739] = mcposachannel_16_analyzer_1_array_crystal_array_1;
  mccomp_posr[739] = mcposrchannel_16_analyzer_1_array_crystal_array_1;
  mcNCounter[739]  = mcPCounter[739] = mcP2Counter[739] = 0;
  mcAbsorbProp[739]= 0;
    /* Component channel_16_analyzer_1_array_crystal_array_2. */
  /* Setting parameters for component channel_16_analyzer_1_array_crystal_array_2. */
  SIG_MESSAGE("channel_16_analyzer_1_array_crystal_array_2 (Init:SetPar)");
#line 4113 "MACS_sample_kidney_box.instr"
  if("PG_analyzer") strncpy(mccchannel_16_analyzer_1_array_crystal_array_2_material_string, "PG_analyzer" ? "PG_analyzer" : "", 16384); else mccchannel_16_analyzer_1_array_crystal_array_2_material_string[0]='\0';
#line 4113 "MACS_sample_kidney_box.instr"
  mccchannel_16_analyzer_1_array_crystal_array_2_priority = 1820.2;
#line 4112 "MACS_sample_kidney_box.instr"
  mccchannel_16_analyzer_1_array_crystal_array_2_xwidth = channel_16_analyzer_1_array_crystal_depth;
#line 4112 "MACS_sample_kidney_box.instr"
  mccchannel_16_analyzer_1_array_crystal_array_2_yheight = channel_16_analyzer_1_array_crystal_height;
#line 4112 "MACS_sample_kidney_box.instr"
  mccchannel_16_analyzer_1_array_crystal_array_2_zdepth = channel_16_analyzer_1_array_crystal_width;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_16_analyzer_1_array_crystal_array_2_xwidth2 = -1;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_16_analyzer_1_array_crystal_array_2_yheight2 = -1;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_16_analyzer_1_array_crystal_array_2_visualize = 1;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_16_analyzer_1_array_crystal_array_2_target_index = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_16_analyzer_1_array_crystal_array_2_target_x = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_16_analyzer_1_array_crystal_array_2_target_y = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_16_analyzer_1_array_crystal_array_2_target_z = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_16_analyzer_1_array_crystal_array_2_focus_aw = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_16_analyzer_1_array_crystal_array_2_focus_ah = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_16_analyzer_1_array_crystal_array_2_focus_xw = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_16_analyzer_1_array_crystal_array_2_focus_xh = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_16_analyzer_1_array_crystal_array_2_focus_r = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_16_analyzer_1_array_crystal_array_2_p_interact = 0;
#line 71 "MACS_sample_kidney_box.instr"
  if(0) strncpy(mccchannel_16_analyzer_1_array_crystal_array_2_mask_string, 0 ? 0 : "", 16384); else mccchannel_16_analyzer_1_array_crystal_array_2_mask_string[0]='\0';
#line 71 "MACS_sample_kidney_box.instr"
  if(0) strncpy(mccchannel_16_analyzer_1_array_crystal_array_2_mask_setting, 0 ? 0 : "", 16384); else mccchannel_16_analyzer_1_array_crystal_array_2_mask_setting[0]='\0';
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_16_analyzer_1_array_crystal_array_2_number_of_activations = 1;
#line 139887 "MACS_sample_kidney_box.c"

  SIG_MESSAGE("channel_16_analyzer_1_array_crystal_array_2 (Init:Place/Rotate)");
  rot_set_rotation(mctr1,
#line 4115 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 4115 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 4115 "MACS_sample_kidney_box.instr"
    (0 - RAD2DEG * channel_16_analyzer_1_array_theta [ 2 ])*DEG2RAD);
#line 139897 "MACS_sample_kidney_box.c"
  rot_mul(mctr1, mcrotachannel_16_analyzer_1_rotated, mcrotachannel_16_analyzer_1_array_crystal_array_2);
  rot_transpose(mcrotachannel_16_analyzer_1_array_crystal_array_1, mctr1);
  rot_mul(mcrotachannel_16_analyzer_1_array_crystal_array_2, mctr1, mcrotrchannel_16_analyzer_1_array_crystal_array_2);
  mctc1 = coords_set(
#line 4114 "MACS_sample_kidney_box.instr"
    0 + channel_16_analyzer_1_array_effective_radius_of_curvature * ( 1 - cos ( channel_16_analyzer_1_array_theta [ 2 ] ) ),
#line 4114 "MACS_sample_kidney_box.instr"
    0 + channel_16_analyzer_1_array_effective_radius_of_curvature * sin ( channel_16_analyzer_1_array_theta [ 2 ] ),
#line 4114 "MACS_sample_kidney_box.instr"
    0);
#line 139908 "MACS_sample_kidney_box.c"
  rot_transpose(mcrotachannel_16_analyzer_1_rotated, mctr1);
  mctc2 = rot_apply(mctr1, mctc1);
  mcposachannel_16_analyzer_1_array_crystal_array_2 = coords_add(mcposachannel_16_analyzer_1_rotated, mctc2);
  mctc1 = coords_sub(mcposachannel_16_analyzer_1_array_crystal_array_1, mcposachannel_16_analyzer_1_array_crystal_array_2);
  mcposrchannel_16_analyzer_1_array_crystal_array_2 = rot_apply(mcrotachannel_16_analyzer_1_array_crystal_array_2, mctc1);
  mcDEBUG_COMPONENT("channel_16_analyzer_1_array_crystal_array_2", mcposachannel_16_analyzer_1_array_crystal_array_2, mcrotachannel_16_analyzer_1_array_crystal_array_2)
  mccomp_posa[740] = mcposachannel_16_analyzer_1_array_crystal_array_2;
  mccomp_posr[740] = mcposrchannel_16_analyzer_1_array_crystal_array_2;
  mcNCounter[740]  = mcPCounter[740] = mcP2Counter[740] = 0;
  mcAbsorbProp[740]= 0;
    /* Component channel_16_analyzer_1_array_crystal_array_3. */
  /* Setting parameters for component channel_16_analyzer_1_array_crystal_array_3. */
  SIG_MESSAGE("channel_16_analyzer_1_array_crystal_array_3 (Init:SetPar)");
#line 4119 "MACS_sample_kidney_box.instr"
  if("PG_analyzer") strncpy(mccchannel_16_analyzer_1_array_crystal_array_3_material_string, "PG_analyzer" ? "PG_analyzer" : "", 16384); else mccchannel_16_analyzer_1_array_crystal_array_3_material_string[0]='\0';
#line 4119 "MACS_sample_kidney_box.instr"
  mccchannel_16_analyzer_1_array_crystal_array_3_priority = 1820.3;
#line 4118 "MACS_sample_kidney_box.instr"
  mccchannel_16_analyzer_1_array_crystal_array_3_xwidth = channel_16_analyzer_1_array_crystal_depth;
#line 4118 "MACS_sample_kidney_box.instr"
  mccchannel_16_analyzer_1_array_crystal_array_3_yheight = channel_16_analyzer_1_array_crystal_height;
#line 4118 "MACS_sample_kidney_box.instr"
  mccchannel_16_analyzer_1_array_crystal_array_3_zdepth = channel_16_analyzer_1_array_crystal_width;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_16_analyzer_1_array_crystal_array_3_xwidth2 = -1;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_16_analyzer_1_array_crystal_array_3_yheight2 = -1;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_16_analyzer_1_array_crystal_array_3_visualize = 1;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_16_analyzer_1_array_crystal_array_3_target_index = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_16_analyzer_1_array_crystal_array_3_target_x = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_16_analyzer_1_array_crystal_array_3_target_y = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_16_analyzer_1_array_crystal_array_3_target_z = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_16_analyzer_1_array_crystal_array_3_focus_aw = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_16_analyzer_1_array_crystal_array_3_focus_ah = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_16_analyzer_1_array_crystal_array_3_focus_xw = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_16_analyzer_1_array_crystal_array_3_focus_xh = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_16_analyzer_1_array_crystal_array_3_focus_r = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_16_analyzer_1_array_crystal_array_3_p_interact = 0;
#line 71 "MACS_sample_kidney_box.instr"
  if(0) strncpy(mccchannel_16_analyzer_1_array_crystal_array_3_mask_string, 0 ? 0 : "", 16384); else mccchannel_16_analyzer_1_array_crystal_array_3_mask_string[0]='\0';
#line 71 "MACS_sample_kidney_box.instr"
  if(0) strncpy(mccchannel_16_analyzer_1_array_crystal_array_3_mask_setting, 0 ? 0 : "", 16384); else mccchannel_16_analyzer_1_array_crystal_array_3_mask_setting[0]='\0';
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_16_analyzer_1_array_crystal_array_3_number_of_activations = 1;
#line 139964 "MACS_sample_kidney_box.c"

  SIG_MESSAGE("channel_16_analyzer_1_array_crystal_array_3 (Init:Place/Rotate)");
  rot_set_rotation(mctr1,
#line 4121 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 4121 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 4121 "MACS_sample_kidney_box.instr"
    (0 - RAD2DEG * channel_16_analyzer_1_array_theta [ 3 ])*DEG2RAD);
#line 139974 "MACS_sample_kidney_box.c"
  rot_mul(mctr1, mcrotachannel_16_analyzer_1_rotated, mcrotachannel_16_analyzer_1_array_crystal_array_3);
  rot_transpose(mcrotachannel_16_analyzer_1_array_crystal_array_2, mctr1);
  rot_mul(mcrotachannel_16_analyzer_1_array_crystal_array_3, mctr1, mcrotrchannel_16_analyzer_1_array_crystal_array_3);
  mctc1 = coords_set(
#line 4120 "MACS_sample_kidney_box.instr"
    0 + channel_16_analyzer_1_array_effective_radius_of_curvature * ( 1 - cos ( channel_16_analyzer_1_array_theta [ 3 ] ) ),
#line 4120 "MACS_sample_kidney_box.instr"
    0 + channel_16_analyzer_1_array_effective_radius_of_curvature * sin ( channel_16_analyzer_1_array_theta [ 3 ] ),
#line 4120 "MACS_sample_kidney_box.instr"
    0);
#line 139985 "MACS_sample_kidney_box.c"
  rot_transpose(mcrotachannel_16_analyzer_1_rotated, mctr1);
  mctc2 = rot_apply(mctr1, mctc1);
  mcposachannel_16_analyzer_1_array_crystal_array_3 = coords_add(mcposachannel_16_analyzer_1_rotated, mctc2);
  mctc1 = coords_sub(mcposachannel_16_analyzer_1_array_crystal_array_2, mcposachannel_16_analyzer_1_array_crystal_array_3);
  mcposrchannel_16_analyzer_1_array_crystal_array_3 = rot_apply(mcrotachannel_16_analyzer_1_array_crystal_array_3, mctc1);
  mcDEBUG_COMPONENT("channel_16_analyzer_1_array_crystal_array_3", mcposachannel_16_analyzer_1_array_crystal_array_3, mcrotachannel_16_analyzer_1_array_crystal_array_3)
  mccomp_posa[741] = mcposachannel_16_analyzer_1_array_crystal_array_3;
  mccomp_posr[741] = mcposrchannel_16_analyzer_1_array_crystal_array_3;
  mcNCounter[741]  = mcPCounter[741] = mcP2Counter[741] = 0;
  mcAbsorbProp[741]= 0;
    /* Component channel_16_analyzer_1_array_crystal_array_4. */
  /* Setting parameters for component channel_16_analyzer_1_array_crystal_array_4. */
  SIG_MESSAGE("channel_16_analyzer_1_array_crystal_array_4 (Init:SetPar)");
#line 4125 "MACS_sample_kidney_box.instr"
  if("PG_analyzer") strncpy(mccchannel_16_analyzer_1_array_crystal_array_4_material_string, "PG_analyzer" ? "PG_analyzer" : "", 16384); else mccchannel_16_analyzer_1_array_crystal_array_4_material_string[0]='\0';
#line 4125 "MACS_sample_kidney_box.instr"
  mccchannel_16_analyzer_1_array_crystal_array_4_priority = 1820.4;
#line 4124 "MACS_sample_kidney_box.instr"
  mccchannel_16_analyzer_1_array_crystal_array_4_xwidth = channel_16_analyzer_1_array_crystal_depth;
#line 4124 "MACS_sample_kidney_box.instr"
  mccchannel_16_analyzer_1_array_crystal_array_4_yheight = channel_16_analyzer_1_array_crystal_height;
#line 4124 "MACS_sample_kidney_box.instr"
  mccchannel_16_analyzer_1_array_crystal_array_4_zdepth = channel_16_analyzer_1_array_crystal_width;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_16_analyzer_1_array_crystal_array_4_xwidth2 = -1;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_16_analyzer_1_array_crystal_array_4_yheight2 = -1;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_16_analyzer_1_array_crystal_array_4_visualize = 1;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_16_analyzer_1_array_crystal_array_4_target_index = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_16_analyzer_1_array_crystal_array_4_target_x = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_16_analyzer_1_array_crystal_array_4_target_y = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_16_analyzer_1_array_crystal_array_4_target_z = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_16_analyzer_1_array_crystal_array_4_focus_aw = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_16_analyzer_1_array_crystal_array_4_focus_ah = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_16_analyzer_1_array_crystal_array_4_focus_xw = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_16_analyzer_1_array_crystal_array_4_focus_xh = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_16_analyzer_1_array_crystal_array_4_focus_r = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_16_analyzer_1_array_crystal_array_4_p_interact = 0;
#line 71 "MACS_sample_kidney_box.instr"
  if(0) strncpy(mccchannel_16_analyzer_1_array_crystal_array_4_mask_string, 0 ? 0 : "", 16384); else mccchannel_16_analyzer_1_array_crystal_array_4_mask_string[0]='\0';
#line 71 "MACS_sample_kidney_box.instr"
  if(0) strncpy(mccchannel_16_analyzer_1_array_crystal_array_4_mask_setting, 0 ? 0 : "", 16384); else mccchannel_16_analyzer_1_array_crystal_array_4_mask_setting[0]='\0';
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_16_analyzer_1_array_crystal_array_4_number_of_activations = 1;
#line 140041 "MACS_sample_kidney_box.c"

  SIG_MESSAGE("channel_16_analyzer_1_array_crystal_array_4 (Init:Place/Rotate)");
  rot_set_rotation(mctr1,
#line 4127 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 4127 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 4127 "MACS_sample_kidney_box.instr"
    (0 - RAD2DEG * channel_16_analyzer_1_array_theta [ 4 ])*DEG2RAD);
#line 140051 "MACS_sample_kidney_box.c"
  rot_mul(mctr1, mcrotachannel_16_analyzer_1_rotated, mcrotachannel_16_analyzer_1_array_crystal_array_4);
  rot_transpose(mcrotachannel_16_analyzer_1_array_crystal_array_3, mctr1);
  rot_mul(mcrotachannel_16_analyzer_1_array_crystal_array_4, mctr1, mcrotrchannel_16_analyzer_1_array_crystal_array_4);
  mctc1 = coords_set(
#line 4126 "MACS_sample_kidney_box.instr"
    0 + channel_16_analyzer_1_array_effective_radius_of_curvature * ( 1 - cos ( channel_16_analyzer_1_array_theta [ 4 ] ) ),
#line 4126 "MACS_sample_kidney_box.instr"
    0 + channel_16_analyzer_1_array_effective_radius_of_curvature * sin ( channel_16_analyzer_1_array_theta [ 4 ] ),
#line 4126 "MACS_sample_kidney_box.instr"
    0);
#line 140062 "MACS_sample_kidney_box.c"
  rot_transpose(mcrotachannel_16_analyzer_1_rotated, mctr1);
  mctc2 = rot_apply(mctr1, mctc1);
  mcposachannel_16_analyzer_1_array_crystal_array_4 = coords_add(mcposachannel_16_analyzer_1_rotated, mctc2);
  mctc1 = coords_sub(mcposachannel_16_analyzer_1_array_crystal_array_3, mcposachannel_16_analyzer_1_array_crystal_array_4);
  mcposrchannel_16_analyzer_1_array_crystal_array_4 = rot_apply(mcrotachannel_16_analyzer_1_array_crystal_array_4, mctc1);
  mcDEBUG_COMPONENT("channel_16_analyzer_1_array_crystal_array_4", mcposachannel_16_analyzer_1_array_crystal_array_4, mcrotachannel_16_analyzer_1_array_crystal_array_4)
  mccomp_posa[742] = mcposachannel_16_analyzer_1_array_crystal_array_4;
  mccomp_posr[742] = mcposrchannel_16_analyzer_1_array_crystal_array_4;
  mcNCounter[742]  = mcPCounter[742] = mcP2Counter[742] = 0;
  mcAbsorbProp[742]= 0;
    /* Component channel_16_analyzer_1_array_crystal_array_5. */
  /* Setting parameters for component channel_16_analyzer_1_array_crystal_array_5. */
  SIG_MESSAGE("channel_16_analyzer_1_array_crystal_array_5 (Init:SetPar)");
#line 4131 "MACS_sample_kidney_box.instr"
  if("PG_analyzer") strncpy(mccchannel_16_analyzer_1_array_crystal_array_5_material_string, "PG_analyzer" ? "PG_analyzer" : "", 16384); else mccchannel_16_analyzer_1_array_crystal_array_5_material_string[0]='\0';
#line 4131 "MACS_sample_kidney_box.instr"
  mccchannel_16_analyzer_1_array_crystal_array_5_priority = 1820.5;
#line 4130 "MACS_sample_kidney_box.instr"
  mccchannel_16_analyzer_1_array_crystal_array_5_xwidth = channel_16_analyzer_1_array_crystal_depth;
#line 4130 "MACS_sample_kidney_box.instr"
  mccchannel_16_analyzer_1_array_crystal_array_5_yheight = channel_16_analyzer_1_array_crystal_height;
#line 4130 "MACS_sample_kidney_box.instr"
  mccchannel_16_analyzer_1_array_crystal_array_5_zdepth = channel_16_analyzer_1_array_crystal_width;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_16_analyzer_1_array_crystal_array_5_xwidth2 = -1;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_16_analyzer_1_array_crystal_array_5_yheight2 = -1;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_16_analyzer_1_array_crystal_array_5_visualize = 1;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_16_analyzer_1_array_crystal_array_5_target_index = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_16_analyzer_1_array_crystal_array_5_target_x = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_16_analyzer_1_array_crystal_array_5_target_y = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_16_analyzer_1_array_crystal_array_5_target_z = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_16_analyzer_1_array_crystal_array_5_focus_aw = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_16_analyzer_1_array_crystal_array_5_focus_ah = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_16_analyzer_1_array_crystal_array_5_focus_xw = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_16_analyzer_1_array_crystal_array_5_focus_xh = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_16_analyzer_1_array_crystal_array_5_focus_r = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_16_analyzer_1_array_crystal_array_5_p_interact = 0;
#line 71 "MACS_sample_kidney_box.instr"
  if(0) strncpy(mccchannel_16_analyzer_1_array_crystal_array_5_mask_string, 0 ? 0 : "", 16384); else mccchannel_16_analyzer_1_array_crystal_array_5_mask_string[0]='\0';
#line 71 "MACS_sample_kidney_box.instr"
  if(0) strncpy(mccchannel_16_analyzer_1_array_crystal_array_5_mask_setting, 0 ? 0 : "", 16384); else mccchannel_16_analyzer_1_array_crystal_array_5_mask_setting[0]='\0';
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_16_analyzer_1_array_crystal_array_5_number_of_activations = 1;
#line 140118 "MACS_sample_kidney_box.c"

  SIG_MESSAGE("channel_16_analyzer_1_array_crystal_array_5 (Init:Place/Rotate)");
  rot_set_rotation(mctr1,
#line 4133 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 4133 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 4133 "MACS_sample_kidney_box.instr"
    (0 - RAD2DEG * channel_16_analyzer_1_array_theta [ 5 ])*DEG2RAD);
#line 140128 "MACS_sample_kidney_box.c"
  rot_mul(mctr1, mcrotachannel_16_analyzer_1_rotated, mcrotachannel_16_analyzer_1_array_crystal_array_5);
  rot_transpose(mcrotachannel_16_analyzer_1_array_crystal_array_4, mctr1);
  rot_mul(mcrotachannel_16_analyzer_1_array_crystal_array_5, mctr1, mcrotrchannel_16_analyzer_1_array_crystal_array_5);
  mctc1 = coords_set(
#line 4132 "MACS_sample_kidney_box.instr"
    0 + channel_16_analyzer_1_array_effective_radius_of_curvature * ( 1 - cos ( channel_16_analyzer_1_array_theta [ 5 ] ) ),
#line 4132 "MACS_sample_kidney_box.instr"
    0 + channel_16_analyzer_1_array_effective_radius_of_curvature * sin ( channel_16_analyzer_1_array_theta [ 5 ] ),
#line 4132 "MACS_sample_kidney_box.instr"
    0);
#line 140139 "MACS_sample_kidney_box.c"
  rot_transpose(mcrotachannel_16_analyzer_1_rotated, mctr1);
  mctc2 = rot_apply(mctr1, mctc1);
  mcposachannel_16_analyzer_1_array_crystal_array_5 = coords_add(mcposachannel_16_analyzer_1_rotated, mctc2);
  mctc1 = coords_sub(mcposachannel_16_analyzer_1_array_crystal_array_4, mcposachannel_16_analyzer_1_array_crystal_array_5);
  mcposrchannel_16_analyzer_1_array_crystal_array_5 = rot_apply(mcrotachannel_16_analyzer_1_array_crystal_array_5, mctc1);
  mcDEBUG_COMPONENT("channel_16_analyzer_1_array_crystal_array_5", mcposachannel_16_analyzer_1_array_crystal_array_5, mcrotachannel_16_analyzer_1_array_crystal_array_5)
  mccomp_posa[743] = mcposachannel_16_analyzer_1_array_crystal_array_5;
  mccomp_posr[743] = mcposrchannel_16_analyzer_1_array_crystal_array_5;
  mcNCounter[743]  = mcPCounter[743] = mcP2Counter[743] = 0;
  mcAbsorbProp[743]= 0;
    /* Component channel_16_analyzer_1_array_crystal_array_6. */
  /* Setting parameters for component channel_16_analyzer_1_array_crystal_array_6. */
  SIG_MESSAGE("channel_16_analyzer_1_array_crystal_array_6 (Init:SetPar)");
#line 4137 "MACS_sample_kidney_box.instr"
  if("PG_analyzer") strncpy(mccchannel_16_analyzer_1_array_crystal_array_6_material_string, "PG_analyzer" ? "PG_analyzer" : "", 16384); else mccchannel_16_analyzer_1_array_crystal_array_6_material_string[0]='\0';
#line 4137 "MACS_sample_kidney_box.instr"
  mccchannel_16_analyzer_1_array_crystal_array_6_priority = 1820.6;
#line 4136 "MACS_sample_kidney_box.instr"
  mccchannel_16_analyzer_1_array_crystal_array_6_xwidth = channel_16_analyzer_1_array_crystal_depth;
#line 4136 "MACS_sample_kidney_box.instr"
  mccchannel_16_analyzer_1_array_crystal_array_6_yheight = channel_16_analyzer_1_array_crystal_height;
#line 4136 "MACS_sample_kidney_box.instr"
  mccchannel_16_analyzer_1_array_crystal_array_6_zdepth = channel_16_analyzer_1_array_crystal_width;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_16_analyzer_1_array_crystal_array_6_xwidth2 = -1;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_16_analyzer_1_array_crystal_array_6_yheight2 = -1;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_16_analyzer_1_array_crystal_array_6_visualize = 1;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_16_analyzer_1_array_crystal_array_6_target_index = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_16_analyzer_1_array_crystal_array_6_target_x = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_16_analyzer_1_array_crystal_array_6_target_y = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_16_analyzer_1_array_crystal_array_6_target_z = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_16_analyzer_1_array_crystal_array_6_focus_aw = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_16_analyzer_1_array_crystal_array_6_focus_ah = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_16_analyzer_1_array_crystal_array_6_focus_xw = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_16_analyzer_1_array_crystal_array_6_focus_xh = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_16_analyzer_1_array_crystal_array_6_focus_r = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_16_analyzer_1_array_crystal_array_6_p_interact = 0;
#line 71 "MACS_sample_kidney_box.instr"
  if(0) strncpy(mccchannel_16_analyzer_1_array_crystal_array_6_mask_string, 0 ? 0 : "", 16384); else mccchannel_16_analyzer_1_array_crystal_array_6_mask_string[0]='\0';
#line 71 "MACS_sample_kidney_box.instr"
  if(0) strncpy(mccchannel_16_analyzer_1_array_crystal_array_6_mask_setting, 0 ? 0 : "", 16384); else mccchannel_16_analyzer_1_array_crystal_array_6_mask_setting[0]='\0';
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_16_analyzer_1_array_crystal_array_6_number_of_activations = 1;
#line 140195 "MACS_sample_kidney_box.c"

  SIG_MESSAGE("channel_16_analyzer_1_array_crystal_array_6 (Init:Place/Rotate)");
  rot_set_rotation(mctr1,
#line 4139 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 4139 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 4139 "MACS_sample_kidney_box.instr"
    (0 - RAD2DEG * channel_16_analyzer_1_array_theta [ 6 ])*DEG2RAD);
#line 140205 "MACS_sample_kidney_box.c"
  rot_mul(mctr1, mcrotachannel_16_analyzer_1_rotated, mcrotachannel_16_analyzer_1_array_crystal_array_6);
  rot_transpose(mcrotachannel_16_analyzer_1_array_crystal_array_5, mctr1);
  rot_mul(mcrotachannel_16_analyzer_1_array_crystal_array_6, mctr1, mcrotrchannel_16_analyzer_1_array_crystal_array_6);
  mctc1 = coords_set(
#line 4138 "MACS_sample_kidney_box.instr"
    0 + channel_16_analyzer_1_array_effective_radius_of_curvature * ( 1 - cos ( channel_16_analyzer_1_array_theta [ 6 ] ) ),
#line 4138 "MACS_sample_kidney_box.instr"
    0 + channel_16_analyzer_1_array_effective_radius_of_curvature * sin ( channel_16_analyzer_1_array_theta [ 6 ] ),
#line 4138 "MACS_sample_kidney_box.instr"
    0);
#line 140216 "MACS_sample_kidney_box.c"
  rot_transpose(mcrotachannel_16_analyzer_1_rotated, mctr1);
  mctc2 = rot_apply(mctr1, mctc1);
  mcposachannel_16_analyzer_1_array_crystal_array_6 = coords_add(mcposachannel_16_analyzer_1_rotated, mctc2);
  mctc1 = coords_sub(mcposachannel_16_analyzer_1_array_crystal_array_5, mcposachannel_16_analyzer_1_array_crystal_array_6);
  mcposrchannel_16_analyzer_1_array_crystal_array_6 = rot_apply(mcrotachannel_16_analyzer_1_array_crystal_array_6, mctc1);
  mcDEBUG_COMPONENT("channel_16_analyzer_1_array_crystal_array_6", mcposachannel_16_analyzer_1_array_crystal_array_6, mcrotachannel_16_analyzer_1_array_crystal_array_6)
  mccomp_posa[744] = mcposachannel_16_analyzer_1_array_crystal_array_6;
  mccomp_posr[744] = mcposrchannel_16_analyzer_1_array_crystal_array_6;
  mcNCounter[744]  = mcPCounter[744] = mcP2Counter[744] = 0;
  mcAbsorbProp[744]= 0;
    /* Component channel_16_analyzer_1_array_crystal_array_7. */
  /* Setting parameters for component channel_16_analyzer_1_array_crystal_array_7. */
  SIG_MESSAGE("channel_16_analyzer_1_array_crystal_array_7 (Init:SetPar)");
#line 4143 "MACS_sample_kidney_box.instr"
  if("PG_analyzer") strncpy(mccchannel_16_analyzer_1_array_crystal_array_7_material_string, "PG_analyzer" ? "PG_analyzer" : "", 16384); else mccchannel_16_analyzer_1_array_crystal_array_7_material_string[0]='\0';
#line 4143 "MACS_sample_kidney_box.instr"
  mccchannel_16_analyzer_1_array_crystal_array_7_priority = 1820.7;
#line 4142 "MACS_sample_kidney_box.instr"
  mccchannel_16_analyzer_1_array_crystal_array_7_xwidth = channel_16_analyzer_1_array_crystal_depth;
#line 4142 "MACS_sample_kidney_box.instr"
  mccchannel_16_analyzer_1_array_crystal_array_7_yheight = channel_16_analyzer_1_array_crystal_height;
#line 4142 "MACS_sample_kidney_box.instr"
  mccchannel_16_analyzer_1_array_crystal_array_7_zdepth = channel_16_analyzer_1_array_crystal_width;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_16_analyzer_1_array_crystal_array_7_xwidth2 = -1;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_16_analyzer_1_array_crystal_array_7_yheight2 = -1;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_16_analyzer_1_array_crystal_array_7_visualize = 1;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_16_analyzer_1_array_crystal_array_7_target_index = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_16_analyzer_1_array_crystal_array_7_target_x = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_16_analyzer_1_array_crystal_array_7_target_y = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_16_analyzer_1_array_crystal_array_7_target_z = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_16_analyzer_1_array_crystal_array_7_focus_aw = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_16_analyzer_1_array_crystal_array_7_focus_ah = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_16_analyzer_1_array_crystal_array_7_focus_xw = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_16_analyzer_1_array_crystal_array_7_focus_xh = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_16_analyzer_1_array_crystal_array_7_focus_r = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_16_analyzer_1_array_crystal_array_7_p_interact = 0;
#line 71 "MACS_sample_kidney_box.instr"
  if(0) strncpy(mccchannel_16_analyzer_1_array_crystal_array_7_mask_string, 0 ? 0 : "", 16384); else mccchannel_16_analyzer_1_array_crystal_array_7_mask_string[0]='\0';
#line 71 "MACS_sample_kidney_box.instr"
  if(0) strncpy(mccchannel_16_analyzer_1_array_crystal_array_7_mask_setting, 0 ? 0 : "", 16384); else mccchannel_16_analyzer_1_array_crystal_array_7_mask_setting[0]='\0';
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_16_analyzer_1_array_crystal_array_7_number_of_activations = 1;
#line 140272 "MACS_sample_kidney_box.c"

  SIG_MESSAGE("channel_16_analyzer_1_array_crystal_array_7 (Init:Place/Rotate)");
  rot_set_rotation(mctr1,
#line 4145 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 4145 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 4145 "MACS_sample_kidney_box.instr"
    (0 - RAD2DEG * channel_16_analyzer_1_array_theta [ 7 ])*DEG2RAD);
#line 140282 "MACS_sample_kidney_box.c"
  rot_mul(mctr1, mcrotachannel_16_analyzer_1_rotated, mcrotachannel_16_analyzer_1_array_crystal_array_7);
  rot_transpose(mcrotachannel_16_analyzer_1_array_crystal_array_6, mctr1);
  rot_mul(mcrotachannel_16_analyzer_1_array_crystal_array_7, mctr1, mcrotrchannel_16_analyzer_1_array_crystal_array_7);
  mctc1 = coords_set(
#line 4144 "MACS_sample_kidney_box.instr"
    0 + channel_16_analyzer_1_array_effective_radius_of_curvature * ( 1 - cos ( channel_16_analyzer_1_array_theta [ 7 ] ) ),
#line 4144 "MACS_sample_kidney_box.instr"
    0 + channel_16_analyzer_1_array_effective_radius_of_curvature * sin ( channel_16_analyzer_1_array_theta [ 7 ] ),
#line 4144 "MACS_sample_kidney_box.instr"
    0);
#line 140293 "MACS_sample_kidney_box.c"
  rot_transpose(mcrotachannel_16_analyzer_1_rotated, mctr1);
  mctc2 = rot_apply(mctr1, mctc1);
  mcposachannel_16_analyzer_1_array_crystal_array_7 = coords_add(mcposachannel_16_analyzer_1_rotated, mctc2);
  mctc1 = coords_sub(mcposachannel_16_analyzer_1_array_crystal_array_6, mcposachannel_16_analyzer_1_array_crystal_array_7);
  mcposrchannel_16_analyzer_1_array_crystal_array_7 = rot_apply(mcrotachannel_16_analyzer_1_array_crystal_array_7, mctc1);
  mcDEBUG_COMPONENT("channel_16_analyzer_1_array_crystal_array_7", mcposachannel_16_analyzer_1_array_crystal_array_7, mcrotachannel_16_analyzer_1_array_crystal_array_7)
  mccomp_posa[745] = mcposachannel_16_analyzer_1_array_crystal_array_7;
  mccomp_posr[745] = mcposrchannel_16_analyzer_1_array_crystal_array_7;
  mcNCounter[745]  = mcPCounter[745] = mcP2Counter[745] = 0;
  mcAbsorbProp[745]= 0;
    /* Component channel_16_analyzer_1_array_crystal_array_8. */
  /* Setting parameters for component channel_16_analyzer_1_array_crystal_array_8. */
  SIG_MESSAGE("channel_16_analyzer_1_array_crystal_array_8 (Init:SetPar)");
#line 4149 "MACS_sample_kidney_box.instr"
  if("PG_analyzer") strncpy(mccchannel_16_analyzer_1_array_crystal_array_8_material_string, "PG_analyzer" ? "PG_analyzer" : "", 16384); else mccchannel_16_analyzer_1_array_crystal_array_8_material_string[0]='\0';
#line 4149 "MACS_sample_kidney_box.instr"
  mccchannel_16_analyzer_1_array_crystal_array_8_priority = 1820.8;
#line 4148 "MACS_sample_kidney_box.instr"
  mccchannel_16_analyzer_1_array_crystal_array_8_xwidth = channel_16_analyzer_1_array_crystal_depth;
#line 4148 "MACS_sample_kidney_box.instr"
  mccchannel_16_analyzer_1_array_crystal_array_8_yheight = channel_16_analyzer_1_array_crystal_height;
#line 4148 "MACS_sample_kidney_box.instr"
  mccchannel_16_analyzer_1_array_crystal_array_8_zdepth = channel_16_analyzer_1_array_crystal_width;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_16_analyzer_1_array_crystal_array_8_xwidth2 = -1;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_16_analyzer_1_array_crystal_array_8_yheight2 = -1;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_16_analyzer_1_array_crystal_array_8_visualize = 1;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_16_analyzer_1_array_crystal_array_8_target_index = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_16_analyzer_1_array_crystal_array_8_target_x = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_16_analyzer_1_array_crystal_array_8_target_y = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_16_analyzer_1_array_crystal_array_8_target_z = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_16_analyzer_1_array_crystal_array_8_focus_aw = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_16_analyzer_1_array_crystal_array_8_focus_ah = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_16_analyzer_1_array_crystal_array_8_focus_xw = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_16_analyzer_1_array_crystal_array_8_focus_xh = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_16_analyzer_1_array_crystal_array_8_focus_r = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_16_analyzer_1_array_crystal_array_8_p_interact = 0;
#line 71 "MACS_sample_kidney_box.instr"
  if(0) strncpy(mccchannel_16_analyzer_1_array_crystal_array_8_mask_string, 0 ? 0 : "", 16384); else mccchannel_16_analyzer_1_array_crystal_array_8_mask_string[0]='\0';
#line 71 "MACS_sample_kidney_box.instr"
  if(0) strncpy(mccchannel_16_analyzer_1_array_crystal_array_8_mask_setting, 0 ? 0 : "", 16384); else mccchannel_16_analyzer_1_array_crystal_array_8_mask_setting[0]='\0';
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_16_analyzer_1_array_crystal_array_8_number_of_activations = 1;
#line 140349 "MACS_sample_kidney_box.c"

  SIG_MESSAGE("channel_16_analyzer_1_array_crystal_array_8 (Init:Place/Rotate)");
  rot_set_rotation(mctr1,
#line 4151 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 4151 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 4151 "MACS_sample_kidney_box.instr"
    (0 - RAD2DEG * channel_16_analyzer_1_array_theta [ 8 ])*DEG2RAD);
#line 140359 "MACS_sample_kidney_box.c"
  rot_mul(mctr1, mcrotachannel_16_analyzer_1_rotated, mcrotachannel_16_analyzer_1_array_crystal_array_8);
  rot_transpose(mcrotachannel_16_analyzer_1_array_crystal_array_7, mctr1);
  rot_mul(mcrotachannel_16_analyzer_1_array_crystal_array_8, mctr1, mcrotrchannel_16_analyzer_1_array_crystal_array_8);
  mctc1 = coords_set(
#line 4150 "MACS_sample_kidney_box.instr"
    0 + channel_16_analyzer_1_array_effective_radius_of_curvature * ( 1 - cos ( channel_16_analyzer_1_array_theta [ 8 ] ) ),
#line 4150 "MACS_sample_kidney_box.instr"
    0 + channel_16_analyzer_1_array_effective_radius_of_curvature * sin ( channel_16_analyzer_1_array_theta [ 8 ] ),
#line 4150 "MACS_sample_kidney_box.instr"
    0);
#line 140370 "MACS_sample_kidney_box.c"
  rot_transpose(mcrotachannel_16_analyzer_1_rotated, mctr1);
  mctc2 = rot_apply(mctr1, mctc1);
  mcposachannel_16_analyzer_1_array_crystal_array_8 = coords_add(mcposachannel_16_analyzer_1_rotated, mctc2);
  mctc1 = coords_sub(mcposachannel_16_analyzer_1_array_crystal_array_7, mcposachannel_16_analyzer_1_array_crystal_array_8);
  mcposrchannel_16_analyzer_1_array_crystal_array_8 = rot_apply(mcrotachannel_16_analyzer_1_array_crystal_array_8, mctc1);
  mcDEBUG_COMPONENT("channel_16_analyzer_1_array_crystal_array_8", mcposachannel_16_analyzer_1_array_crystal_array_8, mcrotachannel_16_analyzer_1_array_crystal_array_8)
  mccomp_posa[746] = mcposachannel_16_analyzer_1_array_crystal_array_8;
  mccomp_posr[746] = mcposrchannel_16_analyzer_1_array_crystal_array_8;
  mcNCounter[746]  = mcPCounter[746] = mcP2Counter[746] = 0;
  mcAbsorbProp[746]= 0;
    /* Component channel_16_analyzer_2_center. */
  /* Setting parameters for component channel_16_analyzer_2_center. */
  SIG_MESSAGE("channel_16_analyzer_2_center (Init:SetPar)");

  SIG_MESSAGE("channel_16_analyzer_2_center (Init:Place/Rotate)");
  rot_set_rotation(mctr1,
    (0.0)*DEG2RAD,
    (0.0)*DEG2RAD,
    (0.0)*DEG2RAD);
#line 140390 "MACS_sample_kidney_box.c"
  rot_mul(mctr1, mcrotachannel_16_analyzer_1_center, mcrotachannel_16_analyzer_2_center);
  rot_transpose(mcrotachannel_16_analyzer_1_array_crystal_array_8, mctr1);
  rot_mul(mcrotachannel_16_analyzer_2_center, mctr1, mcrotrchannel_16_analyzer_2_center);
  mctc1 = coords_set(
#line 4155 "MACS_sample_kidney_box.instr"
    - analyzer_seperation,
#line 4155 "MACS_sample_kidney_box.instr"
    0,
#line 4155 "MACS_sample_kidney_box.instr"
    0);
#line 140401 "MACS_sample_kidney_box.c"
  rot_transpose(mcrotachannel_16_analyzer_1_center, mctr1);
  mctc2 = rot_apply(mctr1, mctc1);
  mcposachannel_16_analyzer_2_center = coords_add(mcposachannel_16_analyzer_1_center, mctc2);
  mctc1 = coords_sub(mcposachannel_16_analyzer_1_array_crystal_array_8, mcposachannel_16_analyzer_2_center);
  mcposrchannel_16_analyzer_2_center = rot_apply(mcrotachannel_16_analyzer_2_center, mctc1);
  mcDEBUG_COMPONENT("channel_16_analyzer_2_center", mcposachannel_16_analyzer_2_center, mcrotachannel_16_analyzer_2_center)
  mccomp_posa[747] = mcposachannel_16_analyzer_2_center;
  mccomp_posr[747] = mcposrchannel_16_analyzer_2_center;
  mcNCounter[747]  = mcPCounter[747] = mcP2Counter[747] = 0;
  mcAbsorbProp[747]= 0;
    /* Component channel_16_analyzer_2_rotated. */
  /* Setting parameters for component channel_16_analyzer_2_rotated. */
  SIG_MESSAGE("channel_16_analyzer_2_rotated (Init:SetPar)");

  SIG_MESSAGE("channel_16_analyzer_2_rotated (Init:Place/Rotate)");
  rot_set_rotation(mctr1,
#line 4159 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 4159 "MACS_sample_kidney_box.instr"
    (- analyzer_theta [ 16 ])*DEG2RAD,
#line 4159 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD);
#line 140424 "MACS_sample_kidney_box.c"
  rot_mul(mctr1, mcrotachannel_16_analyzer_2_center, mcrotachannel_16_analyzer_2_rotated);
  rot_transpose(mcrotachannel_16_analyzer_2_center, mctr1);
  rot_mul(mcrotachannel_16_analyzer_2_rotated, mctr1, mcrotrchannel_16_analyzer_2_rotated);
  mctc1 = coords_set(
#line 4158 "MACS_sample_kidney_box.instr"
    0,
#line 4158 "MACS_sample_kidney_box.instr"
    0,
#line 4158 "MACS_sample_kidney_box.instr"
    0.5 * analyzer_seperation / tan ( analyzer_2theta [ 16 ] * DEG2RAD ));
#line 140435 "MACS_sample_kidney_box.c"
  rot_transpose(mcrotachannel_16_analyzer_2_center, mctr1);
  mctc2 = rot_apply(mctr1, mctc1);
  mcposachannel_16_analyzer_2_rotated = coords_add(mcposachannel_16_analyzer_2_center, mctc2);
  mctc1 = coords_sub(mcposachannel_16_analyzer_2_center, mcposachannel_16_analyzer_2_rotated);
  mcposrchannel_16_analyzer_2_rotated = rot_apply(mcrotachannel_16_analyzer_2_rotated, mctc1);
  mcDEBUG_COMPONENT("channel_16_analyzer_2_rotated", mcposachannel_16_analyzer_2_rotated, mcrotachannel_16_analyzer_2_rotated)
  mccomp_posa[748] = mcposachannel_16_analyzer_2_rotated;
  mccomp_posr[748] = mcposrchannel_16_analyzer_2_rotated;
  mcNCounter[748]  = mcPCounter[748] = mcP2Counter[748] = 0;
  mcAbsorbProp[748]= 0;
    /* Component channel_16_analyzer_2_array_crystal_array_0. */
  /* Setting parameters for component channel_16_analyzer_2_array_crystal_array_0. */
  SIG_MESSAGE("channel_16_analyzer_2_array_crystal_array_0 (Init:SetPar)");
#line 4163 "MACS_sample_kidney_box.instr"
  if("PG_analyzer") strncpy(mccchannel_16_analyzer_2_array_crystal_array_0_material_string, "PG_analyzer" ? "PG_analyzer" : "", 16384); else mccchannel_16_analyzer_2_array_crystal_array_0_material_string[0]='\0';
#line 4163 "MACS_sample_kidney_box.instr"
  mccchannel_16_analyzer_2_array_crystal_array_0_priority = 1821.0;
#line 4162 "MACS_sample_kidney_box.instr"
  mccchannel_16_analyzer_2_array_crystal_array_0_xwidth = channel_16_analyzer_2_array_crystal_depth;
#line 4162 "MACS_sample_kidney_box.instr"
  mccchannel_16_analyzer_2_array_crystal_array_0_yheight = channel_16_analyzer_2_array_crystal_height;
#line 4162 "MACS_sample_kidney_box.instr"
  mccchannel_16_analyzer_2_array_crystal_array_0_zdepth = channel_16_analyzer_2_array_crystal_width;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_16_analyzer_2_array_crystal_array_0_xwidth2 = -1;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_16_analyzer_2_array_crystal_array_0_yheight2 = -1;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_16_analyzer_2_array_crystal_array_0_visualize = 1;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_16_analyzer_2_array_crystal_array_0_target_index = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_16_analyzer_2_array_crystal_array_0_target_x = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_16_analyzer_2_array_crystal_array_0_target_y = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_16_analyzer_2_array_crystal_array_0_target_z = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_16_analyzer_2_array_crystal_array_0_focus_aw = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_16_analyzer_2_array_crystal_array_0_focus_ah = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_16_analyzer_2_array_crystal_array_0_focus_xw = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_16_analyzer_2_array_crystal_array_0_focus_xh = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_16_analyzer_2_array_crystal_array_0_focus_r = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_16_analyzer_2_array_crystal_array_0_p_interact = 0;
#line 71 "MACS_sample_kidney_box.instr"
  if(0) strncpy(mccchannel_16_analyzer_2_array_crystal_array_0_mask_string, 0 ? 0 : "", 16384); else mccchannel_16_analyzer_2_array_crystal_array_0_mask_string[0]='\0';
#line 71 "MACS_sample_kidney_box.instr"
  if(0) strncpy(mccchannel_16_analyzer_2_array_crystal_array_0_mask_setting, 0 ? 0 : "", 16384); else mccchannel_16_analyzer_2_array_crystal_array_0_mask_setting[0]='\0';
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_16_analyzer_2_array_crystal_array_0_number_of_activations = 1;
#line 140491 "MACS_sample_kidney_box.c"

  SIG_MESSAGE("channel_16_analyzer_2_array_crystal_array_0 (Init:Place/Rotate)");
  rot_set_rotation(mctr1,
#line 4165 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 4165 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 4165 "MACS_sample_kidney_box.instr"
    (0 - RAD2DEG * channel_16_analyzer_2_array_theta [ 0 ])*DEG2RAD);
#line 140501 "MACS_sample_kidney_box.c"
  rot_mul(mctr1, mcrotachannel_16_analyzer_2_rotated, mcrotachannel_16_analyzer_2_array_crystal_array_0);
  rot_transpose(mcrotachannel_16_analyzer_2_rotated, mctr1);
  rot_mul(mcrotachannel_16_analyzer_2_array_crystal_array_0, mctr1, mcrotrchannel_16_analyzer_2_array_crystal_array_0);
  mctc1 = coords_set(
#line 4164 "MACS_sample_kidney_box.instr"
    0 + channel_16_analyzer_2_array_effective_radius_of_curvature * ( 1 - cos ( channel_16_analyzer_2_array_theta [ 0 ] ) ),
#line 4164 "MACS_sample_kidney_box.instr"
    0 + channel_16_analyzer_2_array_effective_radius_of_curvature * sin ( channel_16_analyzer_2_array_theta [ 0 ] ),
#line 4164 "MACS_sample_kidney_box.instr"
    0);
#line 140512 "MACS_sample_kidney_box.c"
  rot_transpose(mcrotachannel_16_analyzer_2_rotated, mctr1);
  mctc2 = rot_apply(mctr1, mctc1);
  mcposachannel_16_analyzer_2_array_crystal_array_0 = coords_add(mcposachannel_16_analyzer_2_rotated, mctc2);
  mctc1 = coords_sub(mcposachannel_16_analyzer_2_rotated, mcposachannel_16_analyzer_2_array_crystal_array_0);
  mcposrchannel_16_analyzer_2_array_crystal_array_0 = rot_apply(mcrotachannel_16_analyzer_2_array_crystal_array_0, mctc1);
  mcDEBUG_COMPONENT("channel_16_analyzer_2_array_crystal_array_0", mcposachannel_16_analyzer_2_array_crystal_array_0, mcrotachannel_16_analyzer_2_array_crystal_array_0)
  mccomp_posa[749] = mcposachannel_16_analyzer_2_array_crystal_array_0;
  mccomp_posr[749] = mcposrchannel_16_analyzer_2_array_crystal_array_0;
  mcNCounter[749]  = mcPCounter[749] = mcP2Counter[749] = 0;
  mcAbsorbProp[749]= 0;
    /* Component channel_16_analyzer_2_array_crystal_array_1. */
  /* Setting parameters for component channel_16_analyzer_2_array_crystal_array_1. */
  SIG_MESSAGE("channel_16_analyzer_2_array_crystal_array_1 (Init:SetPar)");
#line 4169 "MACS_sample_kidney_box.instr"
  if("PG_analyzer") strncpy(mccchannel_16_analyzer_2_array_crystal_array_1_material_string, "PG_analyzer" ? "PG_analyzer" : "", 16384); else mccchannel_16_analyzer_2_array_crystal_array_1_material_string[0]='\0';
#line 4169 "MACS_sample_kidney_box.instr"
  mccchannel_16_analyzer_2_array_crystal_array_1_priority = 1821.1;
#line 4168 "MACS_sample_kidney_box.instr"
  mccchannel_16_analyzer_2_array_crystal_array_1_xwidth = channel_16_analyzer_2_array_crystal_depth;
#line 4168 "MACS_sample_kidney_box.instr"
  mccchannel_16_analyzer_2_array_crystal_array_1_yheight = channel_16_analyzer_2_array_crystal_height;
#line 4168 "MACS_sample_kidney_box.instr"
  mccchannel_16_analyzer_2_array_crystal_array_1_zdepth = channel_16_analyzer_2_array_crystal_width;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_16_analyzer_2_array_crystal_array_1_xwidth2 = -1;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_16_analyzer_2_array_crystal_array_1_yheight2 = -1;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_16_analyzer_2_array_crystal_array_1_visualize = 1;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_16_analyzer_2_array_crystal_array_1_target_index = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_16_analyzer_2_array_crystal_array_1_target_x = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_16_analyzer_2_array_crystal_array_1_target_y = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_16_analyzer_2_array_crystal_array_1_target_z = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_16_analyzer_2_array_crystal_array_1_focus_aw = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_16_analyzer_2_array_crystal_array_1_focus_ah = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_16_analyzer_2_array_crystal_array_1_focus_xw = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_16_analyzer_2_array_crystal_array_1_focus_xh = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_16_analyzer_2_array_crystal_array_1_focus_r = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_16_analyzer_2_array_crystal_array_1_p_interact = 0;
#line 71 "MACS_sample_kidney_box.instr"
  if(0) strncpy(mccchannel_16_analyzer_2_array_crystal_array_1_mask_string, 0 ? 0 : "", 16384); else mccchannel_16_analyzer_2_array_crystal_array_1_mask_string[0]='\0';
#line 71 "MACS_sample_kidney_box.instr"
  if(0) strncpy(mccchannel_16_analyzer_2_array_crystal_array_1_mask_setting, 0 ? 0 : "", 16384); else mccchannel_16_analyzer_2_array_crystal_array_1_mask_setting[0]='\0';
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_16_analyzer_2_array_crystal_array_1_number_of_activations = 1;
#line 140568 "MACS_sample_kidney_box.c"

  SIG_MESSAGE("channel_16_analyzer_2_array_crystal_array_1 (Init:Place/Rotate)");
  rot_set_rotation(mctr1,
#line 4171 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 4171 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 4171 "MACS_sample_kidney_box.instr"
    (0 - RAD2DEG * channel_16_analyzer_2_array_theta [ 1 ])*DEG2RAD);
#line 140578 "MACS_sample_kidney_box.c"
  rot_mul(mctr1, mcrotachannel_16_analyzer_2_rotated, mcrotachannel_16_analyzer_2_array_crystal_array_1);
  rot_transpose(mcrotachannel_16_analyzer_2_array_crystal_array_0, mctr1);
  rot_mul(mcrotachannel_16_analyzer_2_array_crystal_array_1, mctr1, mcrotrchannel_16_analyzer_2_array_crystal_array_1);
  mctc1 = coords_set(
#line 4170 "MACS_sample_kidney_box.instr"
    0 + channel_16_analyzer_2_array_effective_radius_of_curvature * ( 1 - cos ( channel_16_analyzer_2_array_theta [ 1 ] ) ),
#line 4170 "MACS_sample_kidney_box.instr"
    0 + channel_16_analyzer_2_array_effective_radius_of_curvature * sin ( channel_16_analyzer_2_array_theta [ 1 ] ),
#line 4170 "MACS_sample_kidney_box.instr"
    0);
#line 140589 "MACS_sample_kidney_box.c"
  rot_transpose(mcrotachannel_16_analyzer_2_rotated, mctr1);
  mctc2 = rot_apply(mctr1, mctc1);
  mcposachannel_16_analyzer_2_array_crystal_array_1 = coords_add(mcposachannel_16_analyzer_2_rotated, mctc2);
  mctc1 = coords_sub(mcposachannel_16_analyzer_2_array_crystal_array_0, mcposachannel_16_analyzer_2_array_crystal_array_1);
  mcposrchannel_16_analyzer_2_array_crystal_array_1 = rot_apply(mcrotachannel_16_analyzer_2_array_crystal_array_1, mctc1);
  mcDEBUG_COMPONENT("channel_16_analyzer_2_array_crystal_array_1", mcposachannel_16_analyzer_2_array_crystal_array_1, mcrotachannel_16_analyzer_2_array_crystal_array_1)
  mccomp_posa[750] = mcposachannel_16_analyzer_2_array_crystal_array_1;
  mccomp_posr[750] = mcposrchannel_16_analyzer_2_array_crystal_array_1;
  mcNCounter[750]  = mcPCounter[750] = mcP2Counter[750] = 0;
  mcAbsorbProp[750]= 0;
    /* Component channel_16_analyzer_2_array_crystal_array_2. */
  /* Setting parameters for component channel_16_analyzer_2_array_crystal_array_2. */
  SIG_MESSAGE("channel_16_analyzer_2_array_crystal_array_2 (Init:SetPar)");
#line 4175 "MACS_sample_kidney_box.instr"
  if("PG_analyzer") strncpy(mccchannel_16_analyzer_2_array_crystal_array_2_material_string, "PG_analyzer" ? "PG_analyzer" : "", 16384); else mccchannel_16_analyzer_2_array_crystal_array_2_material_string[0]='\0';
#line 4175 "MACS_sample_kidney_box.instr"
  mccchannel_16_analyzer_2_array_crystal_array_2_priority = 1821.2;
#line 4174 "MACS_sample_kidney_box.instr"
  mccchannel_16_analyzer_2_array_crystal_array_2_xwidth = channel_16_analyzer_2_array_crystal_depth;
#line 4174 "MACS_sample_kidney_box.instr"
  mccchannel_16_analyzer_2_array_crystal_array_2_yheight = channel_16_analyzer_2_array_crystal_height;
#line 4174 "MACS_sample_kidney_box.instr"
  mccchannel_16_analyzer_2_array_crystal_array_2_zdepth = channel_16_analyzer_2_array_crystal_width;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_16_analyzer_2_array_crystal_array_2_xwidth2 = -1;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_16_analyzer_2_array_crystal_array_2_yheight2 = -1;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_16_analyzer_2_array_crystal_array_2_visualize = 1;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_16_analyzer_2_array_crystal_array_2_target_index = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_16_analyzer_2_array_crystal_array_2_target_x = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_16_analyzer_2_array_crystal_array_2_target_y = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_16_analyzer_2_array_crystal_array_2_target_z = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_16_analyzer_2_array_crystal_array_2_focus_aw = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_16_analyzer_2_array_crystal_array_2_focus_ah = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_16_analyzer_2_array_crystal_array_2_focus_xw = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_16_analyzer_2_array_crystal_array_2_focus_xh = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_16_analyzer_2_array_crystal_array_2_focus_r = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_16_analyzer_2_array_crystal_array_2_p_interact = 0;
#line 71 "MACS_sample_kidney_box.instr"
  if(0) strncpy(mccchannel_16_analyzer_2_array_crystal_array_2_mask_string, 0 ? 0 : "", 16384); else mccchannel_16_analyzer_2_array_crystal_array_2_mask_string[0]='\0';
#line 71 "MACS_sample_kidney_box.instr"
  if(0) strncpy(mccchannel_16_analyzer_2_array_crystal_array_2_mask_setting, 0 ? 0 : "", 16384); else mccchannel_16_analyzer_2_array_crystal_array_2_mask_setting[0]='\0';
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_16_analyzer_2_array_crystal_array_2_number_of_activations = 1;
#line 140645 "MACS_sample_kidney_box.c"

  SIG_MESSAGE("channel_16_analyzer_2_array_crystal_array_2 (Init:Place/Rotate)");
  rot_set_rotation(mctr1,
#line 4177 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 4177 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 4177 "MACS_sample_kidney_box.instr"
    (0 - RAD2DEG * channel_16_analyzer_2_array_theta [ 2 ])*DEG2RAD);
#line 140655 "MACS_sample_kidney_box.c"
  rot_mul(mctr1, mcrotachannel_16_analyzer_2_rotated, mcrotachannel_16_analyzer_2_array_crystal_array_2);
  rot_transpose(mcrotachannel_16_analyzer_2_array_crystal_array_1, mctr1);
  rot_mul(mcrotachannel_16_analyzer_2_array_crystal_array_2, mctr1, mcrotrchannel_16_analyzer_2_array_crystal_array_2);
  mctc1 = coords_set(
#line 4176 "MACS_sample_kidney_box.instr"
    0 + channel_16_analyzer_2_array_effective_radius_of_curvature * ( 1 - cos ( channel_16_analyzer_2_array_theta [ 2 ] ) ),
#line 4176 "MACS_sample_kidney_box.instr"
    0 + channel_16_analyzer_2_array_effective_radius_of_curvature * sin ( channel_16_analyzer_2_array_theta [ 2 ] ),
#line 4176 "MACS_sample_kidney_box.instr"
    0);
#line 140666 "MACS_sample_kidney_box.c"
  rot_transpose(mcrotachannel_16_analyzer_2_rotated, mctr1);
  mctc2 = rot_apply(mctr1, mctc1);
  mcposachannel_16_analyzer_2_array_crystal_array_2 = coords_add(mcposachannel_16_analyzer_2_rotated, mctc2);
  mctc1 = coords_sub(mcposachannel_16_analyzer_2_array_crystal_array_1, mcposachannel_16_analyzer_2_array_crystal_array_2);
  mcposrchannel_16_analyzer_2_array_crystal_array_2 = rot_apply(mcrotachannel_16_analyzer_2_array_crystal_array_2, mctc1);
  mcDEBUG_COMPONENT("channel_16_analyzer_2_array_crystal_array_2", mcposachannel_16_analyzer_2_array_crystal_array_2, mcrotachannel_16_analyzer_2_array_crystal_array_2)
  mccomp_posa[751] = mcposachannel_16_analyzer_2_array_crystal_array_2;
  mccomp_posr[751] = mcposrchannel_16_analyzer_2_array_crystal_array_2;
  mcNCounter[751]  = mcPCounter[751] = mcP2Counter[751] = 0;
  mcAbsorbProp[751]= 0;
    /* Component channel_16_analyzer_2_array_crystal_array_3. */
  /* Setting parameters for component channel_16_analyzer_2_array_crystal_array_3. */
  SIG_MESSAGE("channel_16_analyzer_2_array_crystal_array_3 (Init:SetPar)");
#line 4181 "MACS_sample_kidney_box.instr"
  if("PG_analyzer") strncpy(mccchannel_16_analyzer_2_array_crystal_array_3_material_string, "PG_analyzer" ? "PG_analyzer" : "", 16384); else mccchannel_16_analyzer_2_array_crystal_array_3_material_string[0]='\0';
#line 4181 "MACS_sample_kidney_box.instr"
  mccchannel_16_analyzer_2_array_crystal_array_3_priority = 1821.3;
#line 4180 "MACS_sample_kidney_box.instr"
  mccchannel_16_analyzer_2_array_crystal_array_3_xwidth = channel_16_analyzer_2_array_crystal_depth;
#line 4180 "MACS_sample_kidney_box.instr"
  mccchannel_16_analyzer_2_array_crystal_array_3_yheight = channel_16_analyzer_2_array_crystal_height;
#line 4180 "MACS_sample_kidney_box.instr"
  mccchannel_16_analyzer_2_array_crystal_array_3_zdepth = channel_16_analyzer_2_array_crystal_width;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_16_analyzer_2_array_crystal_array_3_xwidth2 = -1;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_16_analyzer_2_array_crystal_array_3_yheight2 = -1;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_16_analyzer_2_array_crystal_array_3_visualize = 1;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_16_analyzer_2_array_crystal_array_3_target_index = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_16_analyzer_2_array_crystal_array_3_target_x = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_16_analyzer_2_array_crystal_array_3_target_y = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_16_analyzer_2_array_crystal_array_3_target_z = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_16_analyzer_2_array_crystal_array_3_focus_aw = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_16_analyzer_2_array_crystal_array_3_focus_ah = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_16_analyzer_2_array_crystal_array_3_focus_xw = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_16_analyzer_2_array_crystal_array_3_focus_xh = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_16_analyzer_2_array_crystal_array_3_focus_r = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_16_analyzer_2_array_crystal_array_3_p_interact = 0;
#line 71 "MACS_sample_kidney_box.instr"
  if(0) strncpy(mccchannel_16_analyzer_2_array_crystal_array_3_mask_string, 0 ? 0 : "", 16384); else mccchannel_16_analyzer_2_array_crystal_array_3_mask_string[0]='\0';
#line 71 "MACS_sample_kidney_box.instr"
  if(0) strncpy(mccchannel_16_analyzer_2_array_crystal_array_3_mask_setting, 0 ? 0 : "", 16384); else mccchannel_16_analyzer_2_array_crystal_array_3_mask_setting[0]='\0';
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_16_analyzer_2_array_crystal_array_3_number_of_activations = 1;
#line 140722 "MACS_sample_kidney_box.c"

  SIG_MESSAGE("channel_16_analyzer_2_array_crystal_array_3 (Init:Place/Rotate)");
  rot_set_rotation(mctr1,
#line 4183 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 4183 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 4183 "MACS_sample_kidney_box.instr"
    (0 - RAD2DEG * channel_16_analyzer_2_array_theta [ 3 ])*DEG2RAD);
#line 140732 "MACS_sample_kidney_box.c"
  rot_mul(mctr1, mcrotachannel_16_analyzer_2_rotated, mcrotachannel_16_analyzer_2_array_crystal_array_3);
  rot_transpose(mcrotachannel_16_analyzer_2_array_crystal_array_2, mctr1);
  rot_mul(mcrotachannel_16_analyzer_2_array_crystal_array_3, mctr1, mcrotrchannel_16_analyzer_2_array_crystal_array_3);
  mctc1 = coords_set(
#line 4182 "MACS_sample_kidney_box.instr"
    0 + channel_16_analyzer_2_array_effective_radius_of_curvature * ( 1 - cos ( channel_16_analyzer_2_array_theta [ 3 ] ) ),
#line 4182 "MACS_sample_kidney_box.instr"
    0 + channel_16_analyzer_2_array_effective_radius_of_curvature * sin ( channel_16_analyzer_2_array_theta [ 3 ] ),
#line 4182 "MACS_sample_kidney_box.instr"
    0);
#line 140743 "MACS_sample_kidney_box.c"
  rot_transpose(mcrotachannel_16_analyzer_2_rotated, mctr1);
  mctc2 = rot_apply(mctr1, mctc1);
  mcposachannel_16_analyzer_2_array_crystal_array_3 = coords_add(mcposachannel_16_analyzer_2_rotated, mctc2);
  mctc1 = coords_sub(mcposachannel_16_analyzer_2_array_crystal_array_2, mcposachannel_16_analyzer_2_array_crystal_array_3);
  mcposrchannel_16_analyzer_2_array_crystal_array_3 = rot_apply(mcrotachannel_16_analyzer_2_array_crystal_array_3, mctc1);
  mcDEBUG_COMPONENT("channel_16_analyzer_2_array_crystal_array_3", mcposachannel_16_analyzer_2_array_crystal_array_3, mcrotachannel_16_analyzer_2_array_crystal_array_3)
  mccomp_posa[752] = mcposachannel_16_analyzer_2_array_crystal_array_3;
  mccomp_posr[752] = mcposrchannel_16_analyzer_2_array_crystal_array_3;
  mcNCounter[752]  = mcPCounter[752] = mcP2Counter[752] = 0;
  mcAbsorbProp[752]= 0;
    /* Component channel_16_analyzer_2_array_crystal_array_4. */
  /* Setting parameters for component channel_16_analyzer_2_array_crystal_array_4. */
  SIG_MESSAGE("channel_16_analyzer_2_array_crystal_array_4 (Init:SetPar)");
#line 4187 "MACS_sample_kidney_box.instr"
  if("PG_analyzer") strncpy(mccchannel_16_analyzer_2_array_crystal_array_4_material_string, "PG_analyzer" ? "PG_analyzer" : "", 16384); else mccchannel_16_analyzer_2_array_crystal_array_4_material_string[0]='\0';
#line 4187 "MACS_sample_kidney_box.instr"
  mccchannel_16_analyzer_2_array_crystal_array_4_priority = 1821.4;
#line 4186 "MACS_sample_kidney_box.instr"
  mccchannel_16_analyzer_2_array_crystal_array_4_xwidth = channel_16_analyzer_2_array_crystal_depth;
#line 4186 "MACS_sample_kidney_box.instr"
  mccchannel_16_analyzer_2_array_crystal_array_4_yheight = channel_16_analyzer_2_array_crystal_height;
#line 4186 "MACS_sample_kidney_box.instr"
  mccchannel_16_analyzer_2_array_crystal_array_4_zdepth = channel_16_analyzer_2_array_crystal_width;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_16_analyzer_2_array_crystal_array_4_xwidth2 = -1;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_16_analyzer_2_array_crystal_array_4_yheight2 = -1;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_16_analyzer_2_array_crystal_array_4_visualize = 1;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_16_analyzer_2_array_crystal_array_4_target_index = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_16_analyzer_2_array_crystal_array_4_target_x = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_16_analyzer_2_array_crystal_array_4_target_y = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_16_analyzer_2_array_crystal_array_4_target_z = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_16_analyzer_2_array_crystal_array_4_focus_aw = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_16_analyzer_2_array_crystal_array_4_focus_ah = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_16_analyzer_2_array_crystal_array_4_focus_xw = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_16_analyzer_2_array_crystal_array_4_focus_xh = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_16_analyzer_2_array_crystal_array_4_focus_r = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_16_analyzer_2_array_crystal_array_4_p_interact = 0;
#line 71 "MACS_sample_kidney_box.instr"
  if(0) strncpy(mccchannel_16_analyzer_2_array_crystal_array_4_mask_string, 0 ? 0 : "", 16384); else mccchannel_16_analyzer_2_array_crystal_array_4_mask_string[0]='\0';
#line 71 "MACS_sample_kidney_box.instr"
  if(0) strncpy(mccchannel_16_analyzer_2_array_crystal_array_4_mask_setting, 0 ? 0 : "", 16384); else mccchannel_16_analyzer_2_array_crystal_array_4_mask_setting[0]='\0';
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_16_analyzer_2_array_crystal_array_4_number_of_activations = 1;
#line 140799 "MACS_sample_kidney_box.c"

  SIG_MESSAGE("channel_16_analyzer_2_array_crystal_array_4 (Init:Place/Rotate)");
  rot_set_rotation(mctr1,
#line 4189 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 4189 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 4189 "MACS_sample_kidney_box.instr"
    (0 - RAD2DEG * channel_16_analyzer_2_array_theta [ 4 ])*DEG2RAD);
#line 140809 "MACS_sample_kidney_box.c"
  rot_mul(mctr1, mcrotachannel_16_analyzer_2_rotated, mcrotachannel_16_analyzer_2_array_crystal_array_4);
  rot_transpose(mcrotachannel_16_analyzer_2_array_crystal_array_3, mctr1);
  rot_mul(mcrotachannel_16_analyzer_2_array_crystal_array_4, mctr1, mcrotrchannel_16_analyzer_2_array_crystal_array_4);
  mctc1 = coords_set(
#line 4188 "MACS_sample_kidney_box.instr"
    0 + channel_16_analyzer_2_array_effective_radius_of_curvature * ( 1 - cos ( channel_16_analyzer_2_array_theta [ 4 ] ) ),
#line 4188 "MACS_sample_kidney_box.instr"
    0 + channel_16_analyzer_2_array_effective_radius_of_curvature * sin ( channel_16_analyzer_2_array_theta [ 4 ] ),
#line 4188 "MACS_sample_kidney_box.instr"
    0);
#line 140820 "MACS_sample_kidney_box.c"
  rot_transpose(mcrotachannel_16_analyzer_2_rotated, mctr1);
  mctc2 = rot_apply(mctr1, mctc1);
  mcposachannel_16_analyzer_2_array_crystal_array_4 = coords_add(mcposachannel_16_analyzer_2_rotated, mctc2);
  mctc1 = coords_sub(mcposachannel_16_analyzer_2_array_crystal_array_3, mcposachannel_16_analyzer_2_array_crystal_array_4);
  mcposrchannel_16_analyzer_2_array_crystal_array_4 = rot_apply(mcrotachannel_16_analyzer_2_array_crystal_array_4, mctc1);
  mcDEBUG_COMPONENT("channel_16_analyzer_2_array_crystal_array_4", mcposachannel_16_analyzer_2_array_crystal_array_4, mcrotachannel_16_analyzer_2_array_crystal_array_4)
  mccomp_posa[753] = mcposachannel_16_analyzer_2_array_crystal_array_4;
  mccomp_posr[753] = mcposrchannel_16_analyzer_2_array_crystal_array_4;
  mcNCounter[753]  = mcPCounter[753] = mcP2Counter[753] = 0;
  mcAbsorbProp[753]= 0;
    /* Component channel_16_analyzer_2_array_crystal_array_5. */
  /* Setting parameters for component channel_16_analyzer_2_array_crystal_array_5. */
  SIG_MESSAGE("channel_16_analyzer_2_array_crystal_array_5 (Init:SetPar)");
#line 4193 "MACS_sample_kidney_box.instr"
  if("PG_analyzer") strncpy(mccchannel_16_analyzer_2_array_crystal_array_5_material_string, "PG_analyzer" ? "PG_analyzer" : "", 16384); else mccchannel_16_analyzer_2_array_crystal_array_5_material_string[0]='\0';
#line 4193 "MACS_sample_kidney_box.instr"
  mccchannel_16_analyzer_2_array_crystal_array_5_priority = 1821.5;
#line 4192 "MACS_sample_kidney_box.instr"
  mccchannel_16_analyzer_2_array_crystal_array_5_xwidth = channel_16_analyzer_2_array_crystal_depth;
#line 4192 "MACS_sample_kidney_box.instr"
  mccchannel_16_analyzer_2_array_crystal_array_5_yheight = channel_16_analyzer_2_array_crystal_height;
#line 4192 "MACS_sample_kidney_box.instr"
  mccchannel_16_analyzer_2_array_crystal_array_5_zdepth = channel_16_analyzer_2_array_crystal_width;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_16_analyzer_2_array_crystal_array_5_xwidth2 = -1;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_16_analyzer_2_array_crystal_array_5_yheight2 = -1;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_16_analyzer_2_array_crystal_array_5_visualize = 1;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_16_analyzer_2_array_crystal_array_5_target_index = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_16_analyzer_2_array_crystal_array_5_target_x = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_16_analyzer_2_array_crystal_array_5_target_y = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_16_analyzer_2_array_crystal_array_5_target_z = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_16_analyzer_2_array_crystal_array_5_focus_aw = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_16_analyzer_2_array_crystal_array_5_focus_ah = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_16_analyzer_2_array_crystal_array_5_focus_xw = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_16_analyzer_2_array_crystal_array_5_focus_xh = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_16_analyzer_2_array_crystal_array_5_focus_r = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_16_analyzer_2_array_crystal_array_5_p_interact = 0;
#line 71 "MACS_sample_kidney_box.instr"
  if(0) strncpy(mccchannel_16_analyzer_2_array_crystal_array_5_mask_string, 0 ? 0 : "", 16384); else mccchannel_16_analyzer_2_array_crystal_array_5_mask_string[0]='\0';
#line 71 "MACS_sample_kidney_box.instr"
  if(0) strncpy(mccchannel_16_analyzer_2_array_crystal_array_5_mask_setting, 0 ? 0 : "", 16384); else mccchannel_16_analyzer_2_array_crystal_array_5_mask_setting[0]='\0';
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_16_analyzer_2_array_crystal_array_5_number_of_activations = 1;
#line 140876 "MACS_sample_kidney_box.c"

  SIG_MESSAGE("channel_16_analyzer_2_array_crystal_array_5 (Init:Place/Rotate)");
  rot_set_rotation(mctr1,
#line 4195 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 4195 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 4195 "MACS_sample_kidney_box.instr"
    (0 - RAD2DEG * channel_16_analyzer_2_array_theta [ 5 ])*DEG2RAD);
#line 140886 "MACS_sample_kidney_box.c"
  rot_mul(mctr1, mcrotachannel_16_analyzer_2_rotated, mcrotachannel_16_analyzer_2_array_crystal_array_5);
  rot_transpose(mcrotachannel_16_analyzer_2_array_crystal_array_4, mctr1);
  rot_mul(mcrotachannel_16_analyzer_2_array_crystal_array_5, mctr1, mcrotrchannel_16_analyzer_2_array_crystal_array_5);
  mctc1 = coords_set(
#line 4194 "MACS_sample_kidney_box.instr"
    0 + channel_16_analyzer_2_array_effective_radius_of_curvature * ( 1 - cos ( channel_16_analyzer_2_array_theta [ 5 ] ) ),
#line 4194 "MACS_sample_kidney_box.instr"
    0 + channel_16_analyzer_2_array_effective_radius_of_curvature * sin ( channel_16_analyzer_2_array_theta [ 5 ] ),
#line 4194 "MACS_sample_kidney_box.instr"
    0);
#line 140897 "MACS_sample_kidney_box.c"
  rot_transpose(mcrotachannel_16_analyzer_2_rotated, mctr1);
  mctc2 = rot_apply(mctr1, mctc1);
  mcposachannel_16_analyzer_2_array_crystal_array_5 = coords_add(mcposachannel_16_analyzer_2_rotated, mctc2);
  mctc1 = coords_sub(mcposachannel_16_analyzer_2_array_crystal_array_4, mcposachannel_16_analyzer_2_array_crystal_array_5);
  mcposrchannel_16_analyzer_2_array_crystal_array_5 = rot_apply(mcrotachannel_16_analyzer_2_array_crystal_array_5, mctc1);
  mcDEBUG_COMPONENT("channel_16_analyzer_2_array_crystal_array_5", mcposachannel_16_analyzer_2_array_crystal_array_5, mcrotachannel_16_analyzer_2_array_crystal_array_5)
  mccomp_posa[754] = mcposachannel_16_analyzer_2_array_crystal_array_5;
  mccomp_posr[754] = mcposrchannel_16_analyzer_2_array_crystal_array_5;
  mcNCounter[754]  = mcPCounter[754] = mcP2Counter[754] = 0;
  mcAbsorbProp[754]= 0;
    /* Component channel_16_analyzer_2_array_crystal_array_6. */
  /* Setting parameters for component channel_16_analyzer_2_array_crystal_array_6. */
  SIG_MESSAGE("channel_16_analyzer_2_array_crystal_array_6 (Init:SetPar)");
#line 4199 "MACS_sample_kidney_box.instr"
  if("PG_analyzer") strncpy(mccchannel_16_analyzer_2_array_crystal_array_6_material_string, "PG_analyzer" ? "PG_analyzer" : "", 16384); else mccchannel_16_analyzer_2_array_crystal_array_6_material_string[0]='\0';
#line 4199 "MACS_sample_kidney_box.instr"
  mccchannel_16_analyzer_2_array_crystal_array_6_priority = 1821.6;
#line 4198 "MACS_sample_kidney_box.instr"
  mccchannel_16_analyzer_2_array_crystal_array_6_xwidth = channel_16_analyzer_2_array_crystal_depth;
#line 4198 "MACS_sample_kidney_box.instr"
  mccchannel_16_analyzer_2_array_crystal_array_6_yheight = channel_16_analyzer_2_array_crystal_height;
#line 4198 "MACS_sample_kidney_box.instr"
  mccchannel_16_analyzer_2_array_crystal_array_6_zdepth = channel_16_analyzer_2_array_crystal_width;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_16_analyzer_2_array_crystal_array_6_xwidth2 = -1;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_16_analyzer_2_array_crystal_array_6_yheight2 = -1;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_16_analyzer_2_array_crystal_array_6_visualize = 1;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_16_analyzer_2_array_crystal_array_6_target_index = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_16_analyzer_2_array_crystal_array_6_target_x = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_16_analyzer_2_array_crystal_array_6_target_y = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_16_analyzer_2_array_crystal_array_6_target_z = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_16_analyzer_2_array_crystal_array_6_focus_aw = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_16_analyzer_2_array_crystal_array_6_focus_ah = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_16_analyzer_2_array_crystal_array_6_focus_xw = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_16_analyzer_2_array_crystal_array_6_focus_xh = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_16_analyzer_2_array_crystal_array_6_focus_r = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_16_analyzer_2_array_crystal_array_6_p_interact = 0;
#line 71 "MACS_sample_kidney_box.instr"
  if(0) strncpy(mccchannel_16_analyzer_2_array_crystal_array_6_mask_string, 0 ? 0 : "", 16384); else mccchannel_16_analyzer_2_array_crystal_array_6_mask_string[0]='\0';
#line 71 "MACS_sample_kidney_box.instr"
  if(0) strncpy(mccchannel_16_analyzer_2_array_crystal_array_6_mask_setting, 0 ? 0 : "", 16384); else mccchannel_16_analyzer_2_array_crystal_array_6_mask_setting[0]='\0';
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_16_analyzer_2_array_crystal_array_6_number_of_activations = 1;
#line 140953 "MACS_sample_kidney_box.c"

  SIG_MESSAGE("channel_16_analyzer_2_array_crystal_array_6 (Init:Place/Rotate)");
  rot_set_rotation(mctr1,
#line 4201 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 4201 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 4201 "MACS_sample_kidney_box.instr"
    (0 - RAD2DEG * channel_16_analyzer_2_array_theta [ 6 ])*DEG2RAD);
#line 140963 "MACS_sample_kidney_box.c"
  rot_mul(mctr1, mcrotachannel_16_analyzer_2_rotated, mcrotachannel_16_analyzer_2_array_crystal_array_6);
  rot_transpose(mcrotachannel_16_analyzer_2_array_crystal_array_5, mctr1);
  rot_mul(mcrotachannel_16_analyzer_2_array_crystal_array_6, mctr1, mcrotrchannel_16_analyzer_2_array_crystal_array_6);
  mctc1 = coords_set(
#line 4200 "MACS_sample_kidney_box.instr"
    0 + channel_16_analyzer_2_array_effective_radius_of_curvature * ( 1 - cos ( channel_16_analyzer_2_array_theta [ 6 ] ) ),
#line 4200 "MACS_sample_kidney_box.instr"
    0 + channel_16_analyzer_2_array_effective_radius_of_curvature * sin ( channel_16_analyzer_2_array_theta [ 6 ] ),
#line 4200 "MACS_sample_kidney_box.instr"
    0);
#line 140974 "MACS_sample_kidney_box.c"
  rot_transpose(mcrotachannel_16_analyzer_2_rotated, mctr1);
  mctc2 = rot_apply(mctr1, mctc1);
  mcposachannel_16_analyzer_2_array_crystal_array_6 = coords_add(mcposachannel_16_analyzer_2_rotated, mctc2);
  mctc1 = coords_sub(mcposachannel_16_analyzer_2_array_crystal_array_5, mcposachannel_16_analyzer_2_array_crystal_array_6);
  mcposrchannel_16_analyzer_2_array_crystal_array_6 = rot_apply(mcrotachannel_16_analyzer_2_array_crystal_array_6, mctc1);
  mcDEBUG_COMPONENT("channel_16_analyzer_2_array_crystal_array_6", mcposachannel_16_analyzer_2_array_crystal_array_6, mcrotachannel_16_analyzer_2_array_crystal_array_6)
  mccomp_posa[755] = mcposachannel_16_analyzer_2_array_crystal_array_6;
  mccomp_posr[755] = mcposrchannel_16_analyzer_2_array_crystal_array_6;
  mcNCounter[755]  = mcPCounter[755] = mcP2Counter[755] = 0;
  mcAbsorbProp[755]= 0;
    /* Component channel_16_analyzer_2_array_crystal_array_7. */
  /* Setting parameters for component channel_16_analyzer_2_array_crystal_array_7. */
  SIG_MESSAGE("channel_16_analyzer_2_array_crystal_array_7 (Init:SetPar)");
#line 4205 "MACS_sample_kidney_box.instr"
  if("PG_analyzer") strncpy(mccchannel_16_analyzer_2_array_crystal_array_7_material_string, "PG_analyzer" ? "PG_analyzer" : "", 16384); else mccchannel_16_analyzer_2_array_crystal_array_7_material_string[0]='\0';
#line 4205 "MACS_sample_kidney_box.instr"
  mccchannel_16_analyzer_2_array_crystal_array_7_priority = 1821.7;
#line 4204 "MACS_sample_kidney_box.instr"
  mccchannel_16_analyzer_2_array_crystal_array_7_xwidth = channel_16_analyzer_2_array_crystal_depth;
#line 4204 "MACS_sample_kidney_box.instr"
  mccchannel_16_analyzer_2_array_crystal_array_7_yheight = channel_16_analyzer_2_array_crystal_height;
#line 4204 "MACS_sample_kidney_box.instr"
  mccchannel_16_analyzer_2_array_crystal_array_7_zdepth = channel_16_analyzer_2_array_crystal_width;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_16_analyzer_2_array_crystal_array_7_xwidth2 = -1;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_16_analyzer_2_array_crystal_array_7_yheight2 = -1;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_16_analyzer_2_array_crystal_array_7_visualize = 1;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_16_analyzer_2_array_crystal_array_7_target_index = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_16_analyzer_2_array_crystal_array_7_target_x = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_16_analyzer_2_array_crystal_array_7_target_y = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_16_analyzer_2_array_crystal_array_7_target_z = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_16_analyzer_2_array_crystal_array_7_focus_aw = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_16_analyzer_2_array_crystal_array_7_focus_ah = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_16_analyzer_2_array_crystal_array_7_focus_xw = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_16_analyzer_2_array_crystal_array_7_focus_xh = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_16_analyzer_2_array_crystal_array_7_focus_r = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_16_analyzer_2_array_crystal_array_7_p_interact = 0;
#line 71 "MACS_sample_kidney_box.instr"
  if(0) strncpy(mccchannel_16_analyzer_2_array_crystal_array_7_mask_string, 0 ? 0 : "", 16384); else mccchannel_16_analyzer_2_array_crystal_array_7_mask_string[0]='\0';
#line 71 "MACS_sample_kidney_box.instr"
  if(0) strncpy(mccchannel_16_analyzer_2_array_crystal_array_7_mask_setting, 0 ? 0 : "", 16384); else mccchannel_16_analyzer_2_array_crystal_array_7_mask_setting[0]='\0';
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_16_analyzer_2_array_crystal_array_7_number_of_activations = 1;
#line 141030 "MACS_sample_kidney_box.c"

  SIG_MESSAGE("channel_16_analyzer_2_array_crystal_array_7 (Init:Place/Rotate)");
  rot_set_rotation(mctr1,
#line 4207 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 4207 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 4207 "MACS_sample_kidney_box.instr"
    (0 - RAD2DEG * channel_16_analyzer_2_array_theta [ 7 ])*DEG2RAD);
#line 141040 "MACS_sample_kidney_box.c"
  rot_mul(mctr1, mcrotachannel_16_analyzer_2_rotated, mcrotachannel_16_analyzer_2_array_crystal_array_7);
  rot_transpose(mcrotachannel_16_analyzer_2_array_crystal_array_6, mctr1);
  rot_mul(mcrotachannel_16_analyzer_2_array_crystal_array_7, mctr1, mcrotrchannel_16_analyzer_2_array_crystal_array_7);
  mctc1 = coords_set(
#line 4206 "MACS_sample_kidney_box.instr"
    0 + channel_16_analyzer_2_array_effective_radius_of_curvature * ( 1 - cos ( channel_16_analyzer_2_array_theta [ 7 ] ) ),
#line 4206 "MACS_sample_kidney_box.instr"
    0 + channel_16_analyzer_2_array_effective_radius_of_curvature * sin ( channel_16_analyzer_2_array_theta [ 7 ] ),
#line 4206 "MACS_sample_kidney_box.instr"
    0);
#line 141051 "MACS_sample_kidney_box.c"
  rot_transpose(mcrotachannel_16_analyzer_2_rotated, mctr1);
  mctc2 = rot_apply(mctr1, mctc1);
  mcposachannel_16_analyzer_2_array_crystal_array_7 = coords_add(mcposachannel_16_analyzer_2_rotated, mctc2);
  mctc1 = coords_sub(mcposachannel_16_analyzer_2_array_crystal_array_6, mcposachannel_16_analyzer_2_array_crystal_array_7);
  mcposrchannel_16_analyzer_2_array_crystal_array_7 = rot_apply(mcrotachannel_16_analyzer_2_array_crystal_array_7, mctc1);
  mcDEBUG_COMPONENT("channel_16_analyzer_2_array_crystal_array_7", mcposachannel_16_analyzer_2_array_crystal_array_7, mcrotachannel_16_analyzer_2_array_crystal_array_7)
  mccomp_posa[756] = mcposachannel_16_analyzer_2_array_crystal_array_7;
  mccomp_posr[756] = mcposrchannel_16_analyzer_2_array_crystal_array_7;
  mcNCounter[756]  = mcPCounter[756] = mcP2Counter[756] = 0;
  mcAbsorbProp[756]= 0;
    /* Component channel_16_analyzer_2_array_crystal_array_8. */
  /* Setting parameters for component channel_16_analyzer_2_array_crystal_array_8. */
  SIG_MESSAGE("channel_16_analyzer_2_array_crystal_array_8 (Init:SetPar)");
#line 4211 "MACS_sample_kidney_box.instr"
  if("PG_analyzer") strncpy(mccchannel_16_analyzer_2_array_crystal_array_8_material_string, "PG_analyzer" ? "PG_analyzer" : "", 16384); else mccchannel_16_analyzer_2_array_crystal_array_8_material_string[0]='\0';
#line 4211 "MACS_sample_kidney_box.instr"
  mccchannel_16_analyzer_2_array_crystal_array_8_priority = 1821.8;
#line 4210 "MACS_sample_kidney_box.instr"
  mccchannel_16_analyzer_2_array_crystal_array_8_xwidth = channel_16_analyzer_2_array_crystal_depth;
#line 4210 "MACS_sample_kidney_box.instr"
  mccchannel_16_analyzer_2_array_crystal_array_8_yheight = channel_16_analyzer_2_array_crystal_height;
#line 4210 "MACS_sample_kidney_box.instr"
  mccchannel_16_analyzer_2_array_crystal_array_8_zdepth = channel_16_analyzer_2_array_crystal_width;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_16_analyzer_2_array_crystal_array_8_xwidth2 = -1;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_16_analyzer_2_array_crystal_array_8_yheight2 = -1;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_16_analyzer_2_array_crystal_array_8_visualize = 1;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_16_analyzer_2_array_crystal_array_8_target_index = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_16_analyzer_2_array_crystal_array_8_target_x = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_16_analyzer_2_array_crystal_array_8_target_y = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_16_analyzer_2_array_crystal_array_8_target_z = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_16_analyzer_2_array_crystal_array_8_focus_aw = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_16_analyzer_2_array_crystal_array_8_focus_ah = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_16_analyzer_2_array_crystal_array_8_focus_xw = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_16_analyzer_2_array_crystal_array_8_focus_xh = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_16_analyzer_2_array_crystal_array_8_focus_r = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_16_analyzer_2_array_crystal_array_8_p_interact = 0;
#line 71 "MACS_sample_kidney_box.instr"
  if(0) strncpy(mccchannel_16_analyzer_2_array_crystal_array_8_mask_string, 0 ? 0 : "", 16384); else mccchannel_16_analyzer_2_array_crystal_array_8_mask_string[0]='\0';
#line 71 "MACS_sample_kidney_box.instr"
  if(0) strncpy(mccchannel_16_analyzer_2_array_crystal_array_8_mask_setting, 0 ? 0 : "", 16384); else mccchannel_16_analyzer_2_array_crystal_array_8_mask_setting[0]='\0';
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_16_analyzer_2_array_crystal_array_8_number_of_activations = 1;
#line 141107 "MACS_sample_kidney_box.c"

  SIG_MESSAGE("channel_16_analyzer_2_array_crystal_array_8 (Init:Place/Rotate)");
  rot_set_rotation(mctr1,
#line 4213 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 4213 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 4213 "MACS_sample_kidney_box.instr"
    (0 - RAD2DEG * channel_16_analyzer_2_array_theta [ 8 ])*DEG2RAD);
#line 141117 "MACS_sample_kidney_box.c"
  rot_mul(mctr1, mcrotachannel_16_analyzer_2_rotated, mcrotachannel_16_analyzer_2_array_crystal_array_8);
  rot_transpose(mcrotachannel_16_analyzer_2_array_crystal_array_7, mctr1);
  rot_mul(mcrotachannel_16_analyzer_2_array_crystal_array_8, mctr1, mcrotrchannel_16_analyzer_2_array_crystal_array_8);
  mctc1 = coords_set(
#line 4212 "MACS_sample_kidney_box.instr"
    0 + channel_16_analyzer_2_array_effective_radius_of_curvature * ( 1 - cos ( channel_16_analyzer_2_array_theta [ 8 ] ) ),
#line 4212 "MACS_sample_kidney_box.instr"
    0 + channel_16_analyzer_2_array_effective_radius_of_curvature * sin ( channel_16_analyzer_2_array_theta [ 8 ] ),
#line 4212 "MACS_sample_kidney_box.instr"
    0);
#line 141128 "MACS_sample_kidney_box.c"
  rot_transpose(mcrotachannel_16_analyzer_2_rotated, mctr1);
  mctc2 = rot_apply(mctr1, mctc1);
  mcposachannel_16_analyzer_2_array_crystal_array_8 = coords_add(mcposachannel_16_analyzer_2_rotated, mctc2);
  mctc1 = coords_sub(mcposachannel_16_analyzer_2_array_crystal_array_7, mcposachannel_16_analyzer_2_array_crystal_array_8);
  mcposrchannel_16_analyzer_2_array_crystal_array_8 = rot_apply(mcrotachannel_16_analyzer_2_array_crystal_array_8, mctc1);
  mcDEBUG_COMPONENT("channel_16_analyzer_2_array_crystal_array_8", mcposachannel_16_analyzer_2_array_crystal_array_8, mcrotachannel_16_analyzer_2_array_crystal_array_8)
  mccomp_posa[757] = mcposachannel_16_analyzer_2_array_crystal_array_8;
  mccomp_posr[757] = mcposrchannel_16_analyzer_2_array_crystal_array_8;
  mcNCounter[757]  = mcPCounter[757] = mcP2Counter[757] = 0;
  mcAbsorbProp[757]= 0;
    /* Component channel_16_cave2_cyl1. */
  /* Setting parameters for component channel_16_cave2_cyl1. */
  SIG_MESSAGE("channel_16_cave2_cyl1 (Init:SetPar)");
#line 4218 "MACS_sample_kidney_box.instr"
  if("Vacuum") strncpy(mccchannel_16_cave2_cyl1_material_string, "Vacuum" ? "Vacuum" : "", 16384); else mccchannel_16_cave2_cyl1_material_string[0]='\0';
#line 4218 "MACS_sample_kidney_box.instr"
  mccchannel_16_cave2_cyl1_priority = 1807.5;
#line 4217 "MACS_sample_kidney_box.instr"
  mccchannel_16_cave2_cyl1_radius = kidney_cave2_cyl1_radius;
#line 4217 "MACS_sample_kidney_box.instr"
  mccchannel_16_cave2_cyl1_yheight = kidney_cave2_cyl1_height;
#line 67 "MACS_sample_kidney_box.instr"
  mccchannel_16_cave2_cyl1_visualize = 1;
#line 67 "MACS_sample_kidney_box.instr"
  mccchannel_16_cave2_cyl1_target_index = 0;
#line 67 "MACS_sample_kidney_box.instr"
  mccchannel_16_cave2_cyl1_target_x = 0;
#line 67 "MACS_sample_kidney_box.instr"
  mccchannel_16_cave2_cyl1_target_y = 0;
#line 67 "MACS_sample_kidney_box.instr"
  mccchannel_16_cave2_cyl1_target_z = 0;
#line 67 "MACS_sample_kidney_box.instr"
  mccchannel_16_cave2_cyl1_focus_aw = 0;
#line 67 "MACS_sample_kidney_box.instr"
  mccchannel_16_cave2_cyl1_focus_ah = 0;
#line 67 "MACS_sample_kidney_box.instr"
  mccchannel_16_cave2_cyl1_focus_xw = 0;
#line 67 "MACS_sample_kidney_box.instr"
  mccchannel_16_cave2_cyl1_focus_xh = 0;
#line 67 "MACS_sample_kidney_box.instr"
  mccchannel_16_cave2_cyl1_focus_r = 0;
#line 67 "MACS_sample_kidney_box.instr"
  mccchannel_16_cave2_cyl1_p_interact = 0;
#line 67 "MACS_sample_kidney_box.instr"
  if(0) strncpy(mccchannel_16_cave2_cyl1_mask_string, 0 ? 0 : "", 16384); else mccchannel_16_cave2_cyl1_mask_string[0]='\0';
#line 67 "MACS_sample_kidney_box.instr"
  if(0) strncpy(mccchannel_16_cave2_cyl1_mask_setting, 0 ? 0 : "", 16384); else mccchannel_16_cave2_cyl1_mask_setting[0]='\0';
#line 67 "MACS_sample_kidney_box.instr"
  mccchannel_16_cave2_cyl1_number_of_activations = 1;
#line 141178 "MACS_sample_kidney_box.c"

  SIG_MESSAGE("channel_16_cave2_cyl1 (Init:Place/Rotate)");
  rot_set_rotation(mctr1,
#line 4220 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 4220 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 4220 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD);
#line 141188 "MACS_sample_kidney_box.c"
  rot_mul(mctr1, mcrotachannel_16_analyzer_2_center, mcrotachannel_16_cave2_cyl1);
  rot_transpose(mcrotachannel_16_analyzer_2_array_crystal_array_8, mctr1);
  rot_mul(mcrotachannel_16_cave2_cyl1, mctr1, mcrotrchannel_16_cave2_cyl1);
  mctc1 = coords_set(
#line 4219 "MACS_sample_kidney_box.instr"
    0,
#line 4219 "MACS_sample_kidney_box.instr"
    0,
#line 4219 "MACS_sample_kidney_box.instr"
    spec_detector_to_analyzer_2_center);
#line 141199 "MACS_sample_kidney_box.c"
  rot_transpose(mcrotachannel_16_analyzer_2_center, mctr1);
  mctc2 = rot_apply(mctr1, mctc1);
  mcposachannel_16_cave2_cyl1 = coords_add(mcposachannel_16_analyzer_2_center, mctc2);
  mctc1 = coords_sub(mcposachannel_16_analyzer_2_array_crystal_array_8, mcposachannel_16_cave2_cyl1);
  mcposrchannel_16_cave2_cyl1 = rot_apply(mcrotachannel_16_cave2_cyl1, mctc1);
  mcDEBUG_COMPONENT("channel_16_cave2_cyl1", mcposachannel_16_cave2_cyl1, mcrotachannel_16_cave2_cyl1)
  mccomp_posa[758] = mcposachannel_16_cave2_cyl1;
  mccomp_posr[758] = mcposrchannel_16_cave2_cyl1;
  mcNCounter[758]  = mcPCounter[758] = mcP2Counter[758] = 0;
  mcAbsorbProp[758]= 0;
    /* Component channel_16_cave2_box1. */
  /* Setting parameters for component channel_16_cave2_box1. */
  SIG_MESSAGE("channel_16_cave2_box1 (Init:SetPar)");
#line 4225 "MACS_sample_kidney_box.instr"
  if("Vacuum") strncpy(mccchannel_16_cave2_box1_material_string, "Vacuum" ? "Vacuum" : "", 16384); else mccchannel_16_cave2_box1_material_string[0]='\0';
#line 4225 "MACS_sample_kidney_box.instr"
  mccchannel_16_cave2_box1_priority = 1801;
#line 4223 "MACS_sample_kidney_box.instr"
  mccchannel_16_cave2_box1_xwidth = kidney_cave2_box1_width1;
#line 4223 "MACS_sample_kidney_box.instr"
  mccchannel_16_cave2_box1_yheight = kidney_cave2_box1_height1;
#line 4223 "MACS_sample_kidney_box.instr"
  mccchannel_16_cave2_box1_zdepth = kidney_cave2_box1_depth;
#line 4224 "MACS_sample_kidney_box.instr"
  mccchannel_16_cave2_box1_xwidth2 = kidney_cave2_box1_width2;
#line 4224 "MACS_sample_kidney_box.instr"
  mccchannel_16_cave2_box1_yheight2 = kidney_cave2_box1_height2;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_16_cave2_box1_visualize = 1;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_16_cave2_box1_target_index = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_16_cave2_box1_target_x = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_16_cave2_box1_target_y = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_16_cave2_box1_target_z = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_16_cave2_box1_focus_aw = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_16_cave2_box1_focus_ah = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_16_cave2_box1_focus_xw = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_16_cave2_box1_focus_xh = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_16_cave2_box1_focus_r = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_16_cave2_box1_p_interact = 0;
#line 71 "MACS_sample_kidney_box.instr"
  if(0) strncpy(mccchannel_16_cave2_box1_mask_string, 0 ? 0 : "", 16384); else mccchannel_16_cave2_box1_mask_string[0]='\0';
#line 71 "MACS_sample_kidney_box.instr"
  if(0) strncpy(mccchannel_16_cave2_box1_mask_setting, 0 ? 0 : "", 16384); else mccchannel_16_cave2_box1_mask_setting[0]='\0';
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_16_cave2_box1_number_of_activations = 1;
#line 141255 "MACS_sample_kidney_box.c"

  SIG_MESSAGE("channel_16_cave2_box1 (Init:Place/Rotate)");
  rot_set_rotation(mctr1,
#line 4227 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 4227 "MACS_sample_kidney_box.instr"
    (kidney_cave2_box1_y_rotation)*DEG2RAD,
#line 4227 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD);
#line 141265 "MACS_sample_kidney_box.c"
  rot_mul(mctr1, mcrotachannel_16_cave2_cyl1, mcrotachannel_16_cave2_box1);
  rot_transpose(mcrotachannel_16_cave2_cyl1, mctr1);
  rot_mul(mcrotachannel_16_cave2_box1, mctr1, mcrotrchannel_16_cave2_box1);
  mctc1 = coords_set(
#line 4226 "MACS_sample_kidney_box.instr"
    kidney_cave2_box1_center_to_spec_detector_x,
#line 4226 "MACS_sample_kidney_box.instr"
    0,
#line 4226 "MACS_sample_kidney_box.instr"
    kidney_cave2_box1_center_to_spec_detector_z);
#line 141276 "MACS_sample_kidney_box.c"
  rot_transpose(mcrotachannel_16_cave2_cyl1, mctr1);
  mctc2 = rot_apply(mctr1, mctc1);
  mcposachannel_16_cave2_box1 = coords_add(mcposachannel_16_cave2_cyl1, mctc2);
  mctc1 = coords_sub(mcposachannel_16_cave2_cyl1, mcposachannel_16_cave2_box1);
  mcposrchannel_16_cave2_box1 = rot_apply(mcrotachannel_16_cave2_box1, mctc1);
  mcDEBUG_COMPONENT("channel_16_cave2_box1", mcposachannel_16_cave2_box1, mcrotachannel_16_cave2_box1)
  mccomp_posa[759] = mcposachannel_16_cave2_box1;
  mccomp_posr[759] = mcposrchannel_16_cave2_box1;
  mcNCounter[759]  = mcPCounter[759] = mcP2Counter[759] = 0;
  mcAbsorbProp[759]= 0;
    /* Component channel_16_cave2_box2. */
  /* Setting parameters for component channel_16_cave2_box2. */
  SIG_MESSAGE("channel_16_cave2_box2 (Init:SetPar)");
#line 4232 "MACS_sample_kidney_box.instr"
  if("Vacuum") strncpy(mccchannel_16_cave2_box2_material_string, "Vacuum" ? "Vacuum" : "", 16384); else mccchannel_16_cave2_box2_material_string[0]='\0';
#line 4232 "MACS_sample_kidney_box.instr"
  mccchannel_16_cave2_box2_priority = 1806;
#line 4230 "MACS_sample_kidney_box.instr"
  mccchannel_16_cave2_box2_xwidth = kidney_cave2_box2_width1;
#line 4230 "MACS_sample_kidney_box.instr"
  mccchannel_16_cave2_box2_yheight = kidney_cave2_box2_height1;
#line 4230 "MACS_sample_kidney_box.instr"
  mccchannel_16_cave2_box2_zdepth = kidney_cave2_box2_depth;
#line 4231 "MACS_sample_kidney_box.instr"
  mccchannel_16_cave2_box2_xwidth2 = kidney_cave2_box2_width2;
#line 4231 "MACS_sample_kidney_box.instr"
  mccchannel_16_cave2_box2_yheight2 = kidney_cave2_box2_height2;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_16_cave2_box2_visualize = 1;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_16_cave2_box2_target_index = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_16_cave2_box2_target_x = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_16_cave2_box2_target_y = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_16_cave2_box2_target_z = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_16_cave2_box2_focus_aw = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_16_cave2_box2_focus_ah = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_16_cave2_box2_focus_xw = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_16_cave2_box2_focus_xh = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_16_cave2_box2_focus_r = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_16_cave2_box2_p_interact = 0;
#line 71 "MACS_sample_kidney_box.instr"
  if(0) strncpy(mccchannel_16_cave2_box2_mask_string, 0 ? 0 : "", 16384); else mccchannel_16_cave2_box2_mask_string[0]='\0';
#line 71 "MACS_sample_kidney_box.instr"
  if(0) strncpy(mccchannel_16_cave2_box2_mask_setting, 0 ? 0 : "", 16384); else mccchannel_16_cave2_box2_mask_setting[0]='\0';
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_16_cave2_box2_number_of_activations = 1;
#line 141332 "MACS_sample_kidney_box.c"

  SIG_MESSAGE("channel_16_cave2_box2 (Init:Place/Rotate)");
  rot_set_rotation(mctr1,
#line 4234 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 4234 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 4234 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD);
#line 141342 "MACS_sample_kidney_box.c"
  rot_mul(mctr1, mcrotachannel_16_cave2_cyl1, mcrotachannel_16_cave2_box2);
  rot_transpose(mcrotachannel_16_cave2_box1, mctr1);
  rot_mul(mcrotachannel_16_cave2_box2, mctr1, mcrotrchannel_16_cave2_box2);
  mctc1 = coords_set(
#line 4233 "MACS_sample_kidney_box.instr"
    0,
#line 4233 "MACS_sample_kidney_box.instr"
    0,
#line 4233 "MACS_sample_kidney_box.instr"
    kidney_cave2_box2_center_to_detector);
#line 141353 "MACS_sample_kidney_box.c"
  rot_transpose(mcrotachannel_16_cave2_cyl1, mctr1);
  mctc2 = rot_apply(mctr1, mctc1);
  mcposachannel_16_cave2_box2 = coords_add(mcposachannel_16_cave2_cyl1, mctc2);
  mctc1 = coords_sub(mcposachannel_16_cave2_box1, mcposachannel_16_cave2_box2);
  mcposrchannel_16_cave2_box2 = rot_apply(mcrotachannel_16_cave2_box2, mctc1);
  mcDEBUG_COMPONENT("channel_16_cave2_box2", mcposachannel_16_cave2_box2, mcrotachannel_16_cave2_box2)
  mccomp_posa[760] = mcposachannel_16_cave2_box2;
  mccomp_posr[760] = mcposrchannel_16_cave2_box2;
  mcNCounter[760]  = mcPCounter[760] = mcP2Counter[760] = 0;
  mcAbsorbProp[760]= 0;
    /* Component channel_16_cave2_box3. */
  /* Setting parameters for component channel_16_cave2_box3. */
  SIG_MESSAGE("channel_16_cave2_box3 (Init:SetPar)");
#line 4239 "MACS_sample_kidney_box.instr"
  if("Vacuum") strncpy(mccchannel_16_cave2_box3_material_string, "Vacuum" ? "Vacuum" : "", 16384); else mccchannel_16_cave2_box3_material_string[0]='\0';
#line 4239 "MACS_sample_kidney_box.instr"
  mccchannel_16_cave2_box3_priority = 1807;
#line 4237 "MACS_sample_kidney_box.instr"
  mccchannel_16_cave2_box3_xwidth = kidney_cave2_box3_width1;
#line 4237 "MACS_sample_kidney_box.instr"
  mccchannel_16_cave2_box3_yheight = kidney_cave2_box3_height1;
#line 4237 "MACS_sample_kidney_box.instr"
  mccchannel_16_cave2_box3_zdepth = kidney_cave2_box3_depth;
#line 4238 "MACS_sample_kidney_box.instr"
  mccchannel_16_cave2_box3_xwidth2 = kidney_cave2_box3_width2;
#line 4238 "MACS_sample_kidney_box.instr"
  mccchannel_16_cave2_box3_yheight2 = kidney_cave2_box3_height2;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_16_cave2_box3_visualize = 1;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_16_cave2_box3_target_index = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_16_cave2_box3_target_x = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_16_cave2_box3_target_y = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_16_cave2_box3_target_z = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_16_cave2_box3_focus_aw = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_16_cave2_box3_focus_ah = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_16_cave2_box3_focus_xw = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_16_cave2_box3_focus_xh = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_16_cave2_box3_focus_r = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_16_cave2_box3_p_interact = 0;
#line 71 "MACS_sample_kidney_box.instr"
  if(0) strncpy(mccchannel_16_cave2_box3_mask_string, 0 ? 0 : "", 16384); else mccchannel_16_cave2_box3_mask_string[0]='\0';
#line 71 "MACS_sample_kidney_box.instr"
  if(0) strncpy(mccchannel_16_cave2_box3_mask_setting, 0 ? 0 : "", 16384); else mccchannel_16_cave2_box3_mask_setting[0]='\0';
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_16_cave2_box3_number_of_activations = 1;
#line 141409 "MACS_sample_kidney_box.c"

  SIG_MESSAGE("channel_16_cave2_box3 (Init:Place/Rotate)");
  rot_set_rotation(mctr1,
#line 4241 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 4241 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 4241 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD);
#line 141419 "MACS_sample_kidney_box.c"
  rot_mul(mctr1, mcrotachannel_16_cave2_cyl1, mcrotachannel_16_cave2_box3);
  rot_transpose(mcrotachannel_16_cave2_box2, mctr1);
  rot_mul(mcrotachannel_16_cave2_box3, mctr1, mcrotrchannel_16_cave2_box3);
  mctc1 = coords_set(
#line 4240 "MACS_sample_kidney_box.instr"
    0,
#line 4240 "MACS_sample_kidney_box.instr"
    0,
#line 4240 "MACS_sample_kidney_box.instr"
    kidney_cave2_box3_center_to_detector);
#line 141430 "MACS_sample_kidney_box.c"
  rot_transpose(mcrotachannel_16_cave2_cyl1, mctr1);
  mctc2 = rot_apply(mctr1, mctc1);
  mcposachannel_16_cave2_box3 = coords_add(mcposachannel_16_cave2_cyl1, mctc2);
  mctc1 = coords_sub(mcposachannel_16_cave2_box2, mcposachannel_16_cave2_box3);
  mcposrchannel_16_cave2_box3 = rot_apply(mcrotachannel_16_cave2_box3, mctc1);
  mcDEBUG_COMPONENT("channel_16_cave2_box3", mcposachannel_16_cave2_box3, mcrotachannel_16_cave2_box3)
  mccomp_posa[761] = mcposachannel_16_cave2_box3;
  mccomp_posr[761] = mcposrchannel_16_cave2_box3;
  mcNCounter[761]  = mcPCounter[761] = mcP2Counter[761] = 0;
  mcAbsorbProp[761]= 0;
    /* Component inter_analyzer_colimator_center_16. */
  /* Setting parameters for component inter_analyzer_colimator_center_16. */
  SIG_MESSAGE("inter_analyzer_colimator_center_16 (Init:SetPar)");

  SIG_MESSAGE("inter_analyzer_colimator_center_16 (Init:Place/Rotate)");
  rot_set_rotation(mctr1,
#line 4245 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 4245 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 4245 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD);
#line 141453 "MACS_sample_kidney_box.c"
  rot_mul(mctr1, mcrotachannel_16_analyzer_1_center, mcrotainter_analyzer_colimator_center_16);
  rot_transpose(mcrotachannel_16_cave2_box3, mctr1);
  rot_mul(mcrotainter_analyzer_colimator_center_16, mctr1, mcrotrinter_analyzer_colimator_center_16);
  mctc1 = coords_set(
#line 4244 "MACS_sample_kidney_box.instr"
    -0.5 * analyzer_seperation,
#line 4244 "MACS_sample_kidney_box.instr"
    0,
#line 4244 "MACS_sample_kidney_box.instr"
    0);
#line 141464 "MACS_sample_kidney_box.c"
  rot_transpose(mcrotachannel_16_analyzer_1_center, mctr1);
  mctc2 = rot_apply(mctr1, mctc1);
  mcposainter_analyzer_colimator_center_16 = coords_add(mcposachannel_16_analyzer_1_center, mctc2);
  mctc1 = coords_sub(mcposachannel_16_cave2_box3, mcposainter_analyzer_colimator_center_16);
  mcposrinter_analyzer_colimator_center_16 = rot_apply(mcrotainter_analyzer_colimator_center_16, mctc1);
  mcDEBUG_COMPONENT("inter_analyzer_colimator_center_16", mcposainter_analyzer_colimator_center_16, mcrotainter_analyzer_colimator_center_16)
  mccomp_posa[762] = mcposainter_analyzer_colimator_center_16;
  mccomp_posr[762] = mcposrinter_analyzer_colimator_center_16;
  mcNCounter[762]  = mcPCounter[762] = mcP2Counter[762] = 0;
  mcAbsorbProp[762]= 0;
    /* Component inter_analyzer_colimator_16_blade_0. */
  /* Setting parameters for component inter_analyzer_colimator_16_blade_0. */
  SIG_MESSAGE("inter_analyzer_colimator_16_blade_0 (Init:SetPar)");
#line 4249 "MACS_sample_kidney_box.instr"
  if("Collimator_gad") strncpy(mccinter_analyzer_colimator_16_blade_0_material_string, "Collimator_gad" ? "Collimator_gad" : "", 16384); else mccinter_analyzer_colimator_16_blade_0_material_string[0]='\0';
#line 4249 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_16_blade_0_priority = 1825;
#line 4248 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_16_blade_0_xwidth = inter_analyzer_colimator_width;
#line 4248 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_16_blade_0_yheight = inter_analyzer_colimator_height;
#line 4248 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_16_blade_0_zdepth = inter_analyzer_colimator_depth;
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_16_blade_0_xwidth2 = -1;
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_16_blade_0_yheight2 = -1;
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_16_blade_0_visualize = 1;
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_16_blade_0_target_index = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_16_blade_0_target_x = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_16_blade_0_target_y = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_16_blade_0_target_z = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_16_blade_0_focus_aw = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_16_blade_0_focus_ah = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_16_blade_0_focus_xw = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_16_blade_0_focus_xh = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_16_blade_0_focus_r = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_16_blade_0_p_interact = 0;
#line 71 "MACS_sample_kidney_box.instr"
  if(0) strncpy(mccinter_analyzer_colimator_16_blade_0_mask_string, 0 ? 0 : "", 16384); else mccinter_analyzer_colimator_16_blade_0_mask_string[0]='\0';
#line 71 "MACS_sample_kidney_box.instr"
  if(0) strncpy(mccinter_analyzer_colimator_16_blade_0_mask_setting, 0 ? 0 : "", 16384); else mccinter_analyzer_colimator_16_blade_0_mask_setting[0]='\0';
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_16_blade_0_number_of_activations = 1;
#line 141520 "MACS_sample_kidney_box.c"

  SIG_MESSAGE("inter_analyzer_colimator_16_blade_0 (Init:Place/Rotate)");
  rot_set_rotation(mctr1,
#line 4251 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 4251 "MACS_sample_kidney_box.instr"
    (- analyzer_2theta [ 16 ])*DEG2RAD,
#line 4251 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD);
#line 141530 "MACS_sample_kidney_box.c"
  rot_mul(mctr1, mcrotainter_analyzer_colimator_center_16, mcrotainter_analyzer_colimator_16_blade_0);
  rot_transpose(mcrotainter_analyzer_colimator_center_16, mctr1);
  rot_mul(mcrotainter_analyzer_colimator_16_blade_0, mctr1, mcrotrinter_analyzer_colimator_16_blade_0);
  mctc1 = coords_set(
#line 4250 "MACS_sample_kidney_box.instr"
    0,
#line 4250 "MACS_sample_kidney_box.instr"
    0,
#line 4250 "MACS_sample_kidney_box.instr"
    inter_analyzer_colimator_start_pos - 0 * inter_analyzer_colimator_seperation);
#line 141541 "MACS_sample_kidney_box.c"
  rot_transpose(mcrotainter_analyzer_colimator_center_16, mctr1);
  mctc2 = rot_apply(mctr1, mctc1);
  mcposainter_analyzer_colimator_16_blade_0 = coords_add(mcposainter_analyzer_colimator_center_16, mctc2);
  mctc1 = coords_sub(mcposainter_analyzer_colimator_center_16, mcposainter_analyzer_colimator_16_blade_0);
  mcposrinter_analyzer_colimator_16_blade_0 = rot_apply(mcrotainter_analyzer_colimator_16_blade_0, mctc1);
  mcDEBUG_COMPONENT("inter_analyzer_colimator_16_blade_0", mcposainter_analyzer_colimator_16_blade_0, mcrotainter_analyzer_colimator_16_blade_0)
  mccomp_posa[763] = mcposainter_analyzer_colimator_16_blade_0;
  mccomp_posr[763] = mcposrinter_analyzer_colimator_16_blade_0;
  mcNCounter[763]  = mcPCounter[763] = mcP2Counter[763] = 0;
  mcAbsorbProp[763]= 0;
    /* Component inter_analyzer_colimator_16_blade_1. */
  /* Setting parameters for component inter_analyzer_colimator_16_blade_1. */
  SIG_MESSAGE("inter_analyzer_colimator_16_blade_1 (Init:SetPar)");
#line 4255 "MACS_sample_kidney_box.instr"
  if("Collimator_gad") strncpy(mccinter_analyzer_colimator_16_blade_1_material_string, "Collimator_gad" ? "Collimator_gad" : "", 16384); else mccinter_analyzer_colimator_16_blade_1_material_string[0]='\0';
#line 4255 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_16_blade_1_priority = 1826;
#line 4254 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_16_blade_1_xwidth = inter_analyzer_colimator_width;
#line 4254 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_16_blade_1_yheight = inter_analyzer_colimator_height;
#line 4254 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_16_blade_1_zdepth = inter_analyzer_colimator_depth;
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_16_blade_1_xwidth2 = -1;
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_16_blade_1_yheight2 = -1;
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_16_blade_1_visualize = 1;
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_16_blade_1_target_index = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_16_blade_1_target_x = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_16_blade_1_target_y = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_16_blade_1_target_z = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_16_blade_1_focus_aw = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_16_blade_1_focus_ah = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_16_blade_1_focus_xw = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_16_blade_1_focus_xh = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_16_blade_1_focus_r = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_16_blade_1_p_interact = 0;
#line 71 "MACS_sample_kidney_box.instr"
  if(0) strncpy(mccinter_analyzer_colimator_16_blade_1_mask_string, 0 ? 0 : "", 16384); else mccinter_analyzer_colimator_16_blade_1_mask_string[0]='\0';
#line 71 "MACS_sample_kidney_box.instr"
  if(0) strncpy(mccinter_analyzer_colimator_16_blade_1_mask_setting, 0 ? 0 : "", 16384); else mccinter_analyzer_colimator_16_blade_1_mask_setting[0]='\0';
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_16_blade_1_number_of_activations = 1;
#line 141597 "MACS_sample_kidney_box.c"

  SIG_MESSAGE("inter_analyzer_colimator_16_blade_1 (Init:Place/Rotate)");
  rot_set_rotation(mctr1,
#line 4257 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 4257 "MACS_sample_kidney_box.instr"
    (- analyzer_2theta [ 16 ])*DEG2RAD,
#line 4257 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD);
#line 141607 "MACS_sample_kidney_box.c"
  rot_mul(mctr1, mcrotainter_analyzer_colimator_center_16, mcrotainter_analyzer_colimator_16_blade_1);
  rot_transpose(mcrotainter_analyzer_colimator_16_blade_0, mctr1);
  rot_mul(mcrotainter_analyzer_colimator_16_blade_1, mctr1, mcrotrinter_analyzer_colimator_16_blade_1);
  mctc1 = coords_set(
#line 4256 "MACS_sample_kidney_box.instr"
    0,
#line 4256 "MACS_sample_kidney_box.instr"
    0,
#line 4256 "MACS_sample_kidney_box.instr"
    inter_analyzer_colimator_start_pos - 1 * inter_analyzer_colimator_seperation);
#line 141618 "MACS_sample_kidney_box.c"
  rot_transpose(mcrotainter_analyzer_colimator_center_16, mctr1);
  mctc2 = rot_apply(mctr1, mctc1);
  mcposainter_analyzer_colimator_16_blade_1 = coords_add(mcposainter_analyzer_colimator_center_16, mctc2);
  mctc1 = coords_sub(mcposainter_analyzer_colimator_16_blade_0, mcposainter_analyzer_colimator_16_blade_1);
  mcposrinter_analyzer_colimator_16_blade_1 = rot_apply(mcrotainter_analyzer_colimator_16_blade_1, mctc1);
  mcDEBUG_COMPONENT("inter_analyzer_colimator_16_blade_1", mcposainter_analyzer_colimator_16_blade_1, mcrotainter_analyzer_colimator_16_blade_1)
  mccomp_posa[764] = mcposainter_analyzer_colimator_16_blade_1;
  mccomp_posr[764] = mcposrinter_analyzer_colimator_16_blade_1;
  mcNCounter[764]  = mcPCounter[764] = mcP2Counter[764] = 0;
  mcAbsorbProp[764]= 0;
    /* Component inter_analyzer_colimator_16_blade_2. */
  /* Setting parameters for component inter_analyzer_colimator_16_blade_2. */
  SIG_MESSAGE("inter_analyzer_colimator_16_blade_2 (Init:SetPar)");
#line 4261 "MACS_sample_kidney_box.instr"
  if("Collimator_gad") strncpy(mccinter_analyzer_colimator_16_blade_2_material_string, "Collimator_gad" ? "Collimator_gad" : "", 16384); else mccinter_analyzer_colimator_16_blade_2_material_string[0]='\0';
#line 4261 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_16_blade_2_priority = 1827;
#line 4260 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_16_blade_2_xwidth = inter_analyzer_colimator_width;
#line 4260 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_16_blade_2_yheight = inter_analyzer_colimator_height;
#line 4260 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_16_blade_2_zdepth = inter_analyzer_colimator_depth;
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_16_blade_2_xwidth2 = -1;
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_16_blade_2_yheight2 = -1;
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_16_blade_2_visualize = 1;
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_16_blade_2_target_index = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_16_blade_2_target_x = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_16_blade_2_target_y = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_16_blade_2_target_z = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_16_blade_2_focus_aw = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_16_blade_2_focus_ah = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_16_blade_2_focus_xw = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_16_blade_2_focus_xh = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_16_blade_2_focus_r = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_16_blade_2_p_interact = 0;
#line 71 "MACS_sample_kidney_box.instr"
  if(0) strncpy(mccinter_analyzer_colimator_16_blade_2_mask_string, 0 ? 0 : "", 16384); else mccinter_analyzer_colimator_16_blade_2_mask_string[0]='\0';
#line 71 "MACS_sample_kidney_box.instr"
  if(0) strncpy(mccinter_analyzer_colimator_16_blade_2_mask_setting, 0 ? 0 : "", 16384); else mccinter_analyzer_colimator_16_blade_2_mask_setting[0]='\0';
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_16_blade_2_number_of_activations = 1;
#line 141674 "MACS_sample_kidney_box.c"

  SIG_MESSAGE("inter_analyzer_colimator_16_blade_2 (Init:Place/Rotate)");
  rot_set_rotation(mctr1,
#line 4263 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 4263 "MACS_sample_kidney_box.instr"
    (- analyzer_2theta [ 16 ])*DEG2RAD,
#line 4263 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD);
#line 141684 "MACS_sample_kidney_box.c"
  rot_mul(mctr1, mcrotainter_analyzer_colimator_center_16, mcrotainter_analyzer_colimator_16_blade_2);
  rot_transpose(mcrotainter_analyzer_colimator_16_blade_1, mctr1);
  rot_mul(mcrotainter_analyzer_colimator_16_blade_2, mctr1, mcrotrinter_analyzer_colimator_16_blade_2);
  mctc1 = coords_set(
#line 4262 "MACS_sample_kidney_box.instr"
    0,
#line 4262 "MACS_sample_kidney_box.instr"
    0,
#line 4262 "MACS_sample_kidney_box.instr"
    inter_analyzer_colimator_start_pos - 2 * inter_analyzer_colimator_seperation);
#line 141695 "MACS_sample_kidney_box.c"
  rot_transpose(mcrotainter_analyzer_colimator_center_16, mctr1);
  mctc2 = rot_apply(mctr1, mctc1);
  mcposainter_analyzer_colimator_16_blade_2 = coords_add(mcposainter_analyzer_colimator_center_16, mctc2);
  mctc1 = coords_sub(mcposainter_analyzer_colimator_16_blade_1, mcposainter_analyzer_colimator_16_blade_2);
  mcposrinter_analyzer_colimator_16_blade_2 = rot_apply(mcrotainter_analyzer_colimator_16_blade_2, mctc1);
  mcDEBUG_COMPONENT("inter_analyzer_colimator_16_blade_2", mcposainter_analyzer_colimator_16_blade_2, mcrotainter_analyzer_colimator_16_blade_2)
  mccomp_posa[765] = mcposainter_analyzer_colimator_16_blade_2;
  mccomp_posr[765] = mcposrinter_analyzer_colimator_16_blade_2;
  mcNCounter[765]  = mcPCounter[765] = mcP2Counter[765] = 0;
  mcAbsorbProp[765]= 0;
    /* Component inter_analyzer_colimator_16_blade_3. */
  /* Setting parameters for component inter_analyzer_colimator_16_blade_3. */
  SIG_MESSAGE("inter_analyzer_colimator_16_blade_3 (Init:SetPar)");
#line 4267 "MACS_sample_kidney_box.instr"
  if("Collimator_gad") strncpy(mccinter_analyzer_colimator_16_blade_3_material_string, "Collimator_gad" ? "Collimator_gad" : "", 16384); else mccinter_analyzer_colimator_16_blade_3_material_string[0]='\0';
#line 4267 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_16_blade_3_priority = 1828;
#line 4266 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_16_blade_3_xwidth = inter_analyzer_colimator_width;
#line 4266 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_16_blade_3_yheight = inter_analyzer_colimator_height;
#line 4266 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_16_blade_3_zdepth = inter_analyzer_colimator_depth;
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_16_blade_3_xwidth2 = -1;
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_16_blade_3_yheight2 = -1;
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_16_blade_3_visualize = 1;
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_16_blade_3_target_index = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_16_blade_3_target_x = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_16_blade_3_target_y = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_16_blade_3_target_z = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_16_blade_3_focus_aw = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_16_blade_3_focus_ah = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_16_blade_3_focus_xw = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_16_blade_3_focus_xh = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_16_blade_3_focus_r = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_16_blade_3_p_interact = 0;
#line 71 "MACS_sample_kidney_box.instr"
  if(0) strncpy(mccinter_analyzer_colimator_16_blade_3_mask_string, 0 ? 0 : "", 16384); else mccinter_analyzer_colimator_16_blade_3_mask_string[0]='\0';
#line 71 "MACS_sample_kidney_box.instr"
  if(0) strncpy(mccinter_analyzer_colimator_16_blade_3_mask_setting, 0 ? 0 : "", 16384); else mccinter_analyzer_colimator_16_blade_3_mask_setting[0]='\0';
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_16_blade_3_number_of_activations = 1;
#line 141751 "MACS_sample_kidney_box.c"

  SIG_MESSAGE("inter_analyzer_colimator_16_blade_3 (Init:Place/Rotate)");
  rot_set_rotation(mctr1,
#line 4269 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 4269 "MACS_sample_kidney_box.instr"
    (- analyzer_2theta [ 16 ])*DEG2RAD,
#line 4269 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD);
#line 141761 "MACS_sample_kidney_box.c"
  rot_mul(mctr1, mcrotainter_analyzer_colimator_center_16, mcrotainter_analyzer_colimator_16_blade_3);
  rot_transpose(mcrotainter_analyzer_colimator_16_blade_2, mctr1);
  rot_mul(mcrotainter_analyzer_colimator_16_blade_3, mctr1, mcrotrinter_analyzer_colimator_16_blade_3);
  mctc1 = coords_set(
#line 4268 "MACS_sample_kidney_box.instr"
    0,
#line 4268 "MACS_sample_kidney_box.instr"
    0,
#line 4268 "MACS_sample_kidney_box.instr"
    inter_analyzer_colimator_start_pos - 3 * inter_analyzer_colimator_seperation);
#line 141772 "MACS_sample_kidney_box.c"
  rot_transpose(mcrotainter_analyzer_colimator_center_16, mctr1);
  mctc2 = rot_apply(mctr1, mctc1);
  mcposainter_analyzer_colimator_16_blade_3 = coords_add(mcposainter_analyzer_colimator_center_16, mctc2);
  mctc1 = coords_sub(mcposainter_analyzer_colimator_16_blade_2, mcposainter_analyzer_colimator_16_blade_3);
  mcposrinter_analyzer_colimator_16_blade_3 = rot_apply(mcrotainter_analyzer_colimator_16_blade_3, mctc1);
  mcDEBUG_COMPONENT("inter_analyzer_colimator_16_blade_3", mcposainter_analyzer_colimator_16_blade_3, mcrotainter_analyzer_colimator_16_blade_3)
  mccomp_posa[766] = mcposainter_analyzer_colimator_16_blade_3;
  mccomp_posr[766] = mcposrinter_analyzer_colimator_16_blade_3;
  mcNCounter[766]  = mcPCounter[766] = mcP2Counter[766] = 0;
  mcAbsorbProp[766]= 0;
    /* Component inter_analyzer_colimator_16_blade_4. */
  /* Setting parameters for component inter_analyzer_colimator_16_blade_4. */
  SIG_MESSAGE("inter_analyzer_colimator_16_blade_4 (Init:SetPar)");
#line 4273 "MACS_sample_kidney_box.instr"
  if("Collimator_gad") strncpy(mccinter_analyzer_colimator_16_blade_4_material_string, "Collimator_gad" ? "Collimator_gad" : "", 16384); else mccinter_analyzer_colimator_16_blade_4_material_string[0]='\0';
#line 4273 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_16_blade_4_priority = 1829;
#line 4272 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_16_blade_4_xwidth = inter_analyzer_colimator_width;
#line 4272 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_16_blade_4_yheight = inter_analyzer_colimator_height;
#line 4272 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_16_blade_4_zdepth = inter_analyzer_colimator_depth;
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_16_blade_4_xwidth2 = -1;
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_16_blade_4_yheight2 = -1;
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_16_blade_4_visualize = 1;
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_16_blade_4_target_index = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_16_blade_4_target_x = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_16_blade_4_target_y = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_16_blade_4_target_z = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_16_blade_4_focus_aw = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_16_blade_4_focus_ah = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_16_blade_4_focus_xw = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_16_blade_4_focus_xh = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_16_blade_4_focus_r = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_16_blade_4_p_interact = 0;
#line 71 "MACS_sample_kidney_box.instr"
  if(0) strncpy(mccinter_analyzer_colimator_16_blade_4_mask_string, 0 ? 0 : "", 16384); else mccinter_analyzer_colimator_16_blade_4_mask_string[0]='\0';
#line 71 "MACS_sample_kidney_box.instr"
  if(0) strncpy(mccinter_analyzer_colimator_16_blade_4_mask_setting, 0 ? 0 : "", 16384); else mccinter_analyzer_colimator_16_blade_4_mask_setting[0]='\0';
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_16_blade_4_number_of_activations = 1;
#line 141828 "MACS_sample_kidney_box.c"

  SIG_MESSAGE("inter_analyzer_colimator_16_blade_4 (Init:Place/Rotate)");
  rot_set_rotation(mctr1,
#line 4275 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 4275 "MACS_sample_kidney_box.instr"
    (- analyzer_2theta [ 16 ])*DEG2RAD,
#line 4275 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD);
#line 141838 "MACS_sample_kidney_box.c"
  rot_mul(mctr1, mcrotainter_analyzer_colimator_center_16, mcrotainter_analyzer_colimator_16_blade_4);
  rot_transpose(mcrotainter_analyzer_colimator_16_blade_3, mctr1);
  rot_mul(mcrotainter_analyzer_colimator_16_blade_4, mctr1, mcrotrinter_analyzer_colimator_16_blade_4);
  mctc1 = coords_set(
#line 4274 "MACS_sample_kidney_box.instr"
    0,
#line 4274 "MACS_sample_kidney_box.instr"
    0,
#line 4274 "MACS_sample_kidney_box.instr"
    inter_analyzer_colimator_start_pos - 4 * inter_analyzer_colimator_seperation);
#line 141849 "MACS_sample_kidney_box.c"
  rot_transpose(mcrotainter_analyzer_colimator_center_16, mctr1);
  mctc2 = rot_apply(mctr1, mctc1);
  mcposainter_analyzer_colimator_16_blade_4 = coords_add(mcposainter_analyzer_colimator_center_16, mctc2);
  mctc1 = coords_sub(mcposainter_analyzer_colimator_16_blade_3, mcposainter_analyzer_colimator_16_blade_4);
  mcposrinter_analyzer_colimator_16_blade_4 = rot_apply(mcrotainter_analyzer_colimator_16_blade_4, mctc1);
  mcDEBUG_COMPONENT("inter_analyzer_colimator_16_blade_4", mcposainter_analyzer_colimator_16_blade_4, mcrotainter_analyzer_colimator_16_blade_4)
  mccomp_posa[767] = mcposainter_analyzer_colimator_16_blade_4;
  mccomp_posr[767] = mcposrinter_analyzer_colimator_16_blade_4;
  mcNCounter[767]  = mcPCounter[767] = mcP2Counter[767] = 0;
  mcAbsorbProp[767]= 0;
    /* Component diffraction_detector_16_exit_volume. */
  /* Setting parameters for component diffraction_detector_16_exit_volume. */
  SIG_MESSAGE("diffraction_detector_16_exit_volume (Init:SetPar)");
#line 4279 "MACS_sample_kidney_box.instr"
  if("Exit") strncpy(mccdiffraction_detector_16_exit_volume_material_string, "Exit" ? "Exit" : "", 16384); else mccdiffraction_detector_16_exit_volume_material_string[0]='\0';
#line 4279 "MACS_sample_kidney_box.instr"
  mccdiffraction_detector_16_exit_volume_priority = 1831;
#line 4278 "MACS_sample_kidney_box.instr"
  mccdiffraction_detector_16_exit_volume_xwidth = 2.01 * detector_radius;
#line 4278 "MACS_sample_kidney_box.instr"
  mccdiffraction_detector_16_exit_volume_yheight = 1.01 * detector_height;
#line 4278 "MACS_sample_kidney_box.instr"
  mccdiffraction_detector_16_exit_volume_zdepth = 0.001;
#line 71 "MACS_sample_kidney_box.instr"
  mccdiffraction_detector_16_exit_volume_xwidth2 = -1;
#line 71 "MACS_sample_kidney_box.instr"
  mccdiffraction_detector_16_exit_volume_yheight2 = -1;
#line 71 "MACS_sample_kidney_box.instr"
  mccdiffraction_detector_16_exit_volume_visualize = 1;
#line 71 "MACS_sample_kidney_box.instr"
  mccdiffraction_detector_16_exit_volume_target_index = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccdiffraction_detector_16_exit_volume_target_x = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccdiffraction_detector_16_exit_volume_target_y = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccdiffraction_detector_16_exit_volume_target_z = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccdiffraction_detector_16_exit_volume_focus_aw = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccdiffraction_detector_16_exit_volume_focus_ah = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccdiffraction_detector_16_exit_volume_focus_xw = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccdiffraction_detector_16_exit_volume_focus_xh = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccdiffraction_detector_16_exit_volume_focus_r = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccdiffraction_detector_16_exit_volume_p_interact = 0;
#line 71 "MACS_sample_kidney_box.instr"
  if(0) strncpy(mccdiffraction_detector_16_exit_volume_mask_string, 0 ? 0 : "", 16384); else mccdiffraction_detector_16_exit_volume_mask_string[0]='\0';
#line 71 "MACS_sample_kidney_box.instr"
  if(0) strncpy(mccdiffraction_detector_16_exit_volume_mask_setting, 0 ? 0 : "", 16384); else mccdiffraction_detector_16_exit_volume_mask_setting[0]='\0';
#line 71 "MACS_sample_kidney_box.instr"
  mccdiffraction_detector_16_exit_volume_number_of_activations = 1;
#line 141905 "MACS_sample_kidney_box.c"

  SIG_MESSAGE("diffraction_detector_16_exit_volume (Init:Place/Rotate)");
  rot_set_rotation(mctr1,
#line 4281 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 4281 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 4281 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD);
#line 141915 "MACS_sample_kidney_box.c"
  rot_mul(mctr1, mcrotakidney_channel_16, mcrotadiffraction_detector_16_exit_volume);
  rot_transpose(mcrotainter_analyzer_colimator_16_blade_4, mctr1);
  rot_mul(mcrotadiffraction_detector_16_exit_volume, mctr1, mcrotrdiffraction_detector_16_exit_volume);
  mctc1 = coords_set(
#line 4280 "MACS_sample_kidney_box.instr"
    0,
#line 4280 "MACS_sample_kidney_box.instr"
    0,
#line 4280 "MACS_sample_kidney_box.instr"
    0);
#line 141926 "MACS_sample_kidney_box.c"
  rot_transpose(mcrotachannel_16_cave1_cyl1, mctr1);
  mctc2 = rot_apply(mctr1, mctc1);
  mcposadiffraction_detector_16_exit_volume = coords_add(mcposachannel_16_cave1_cyl1, mctc2);
  mctc1 = coords_sub(mcposainter_analyzer_colimator_16_blade_4, mcposadiffraction_detector_16_exit_volume);
  mcposrdiffraction_detector_16_exit_volume = rot_apply(mcrotadiffraction_detector_16_exit_volume, mctc1);
  mcDEBUG_COMPONENT("diffraction_detector_16_exit_volume", mcposadiffraction_detector_16_exit_volume, mcrotadiffraction_detector_16_exit_volume)
  mccomp_posa[768] = mcposadiffraction_detector_16_exit_volume;
  mccomp_posr[768] = mcposrdiffraction_detector_16_exit_volume;
  mcNCounter[768]  = mcPCounter[768] = mcP2Counter[768] = 0;
  mcAbsorbProp[768]= 0;
    /* Component spec_detector_16_exit_volume. */
  /* Setting parameters for component spec_detector_16_exit_volume. */
  SIG_MESSAGE("spec_detector_16_exit_volume (Init:SetPar)");
#line 4285 "MACS_sample_kidney_box.instr"
  if("Exit") strncpy(mccspec_detector_16_exit_volume_material_string, "Exit" ? "Exit" : "", 16384); else mccspec_detector_16_exit_volume_material_string[0]='\0';
#line 4285 "MACS_sample_kidney_box.instr"
  mccspec_detector_16_exit_volume_priority = 1832;
#line 4284 "MACS_sample_kidney_box.instr"
  mccspec_detector_16_exit_volume_xwidth = 2.01 * detector_radius;
#line 4284 "MACS_sample_kidney_box.instr"
  mccspec_detector_16_exit_volume_yheight = 1.01 * detector_height;
#line 4284 "MACS_sample_kidney_box.instr"
  mccspec_detector_16_exit_volume_zdepth = 0.001;
#line 71 "MACS_sample_kidney_box.instr"
  mccspec_detector_16_exit_volume_xwidth2 = -1;
#line 71 "MACS_sample_kidney_box.instr"
  mccspec_detector_16_exit_volume_yheight2 = -1;
#line 71 "MACS_sample_kidney_box.instr"
  mccspec_detector_16_exit_volume_visualize = 1;
#line 71 "MACS_sample_kidney_box.instr"
  mccspec_detector_16_exit_volume_target_index = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccspec_detector_16_exit_volume_target_x = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccspec_detector_16_exit_volume_target_y = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccspec_detector_16_exit_volume_target_z = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccspec_detector_16_exit_volume_focus_aw = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccspec_detector_16_exit_volume_focus_ah = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccspec_detector_16_exit_volume_focus_xw = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccspec_detector_16_exit_volume_focus_xh = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccspec_detector_16_exit_volume_focus_r = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccspec_detector_16_exit_volume_p_interact = 0;
#line 71 "MACS_sample_kidney_box.instr"
  if(0) strncpy(mccspec_detector_16_exit_volume_mask_string, 0 ? 0 : "", 16384); else mccspec_detector_16_exit_volume_mask_string[0]='\0';
#line 71 "MACS_sample_kidney_box.instr"
  if(0) strncpy(mccspec_detector_16_exit_volume_mask_setting, 0 ? 0 : "", 16384); else mccspec_detector_16_exit_volume_mask_setting[0]='\0';
#line 71 "MACS_sample_kidney_box.instr"
  mccspec_detector_16_exit_volume_number_of_activations = 1;
#line 141982 "MACS_sample_kidney_box.c"

  SIG_MESSAGE("spec_detector_16_exit_volume (Init:Place/Rotate)");
  rot_set_rotation(mctr1,
#line 4287 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 4287 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 4287 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD);
#line 141992 "MACS_sample_kidney_box.c"
  rot_mul(mctr1, mcrotachannel_16_analyzer_2_center, mcrotaspec_detector_16_exit_volume);
  rot_transpose(mcrotadiffraction_detector_16_exit_volume, mctr1);
  rot_mul(mcrotaspec_detector_16_exit_volume, mctr1, mcrotrspec_detector_16_exit_volume);
  mctc1 = coords_set(
#line 4286 "MACS_sample_kidney_box.instr"
    0,
#line 4286 "MACS_sample_kidney_box.instr"
    0,
#line 4286 "MACS_sample_kidney_box.instr"
    0);
#line 142003 "MACS_sample_kidney_box.c"
  rot_transpose(mcrotachannel_16_cave2_cyl1, mctr1);
  mctc2 = rot_apply(mctr1, mctc1);
  mcposaspec_detector_16_exit_volume = coords_add(mcposachannel_16_cave2_cyl1, mctc2);
  mctc1 = coords_sub(mcposadiffraction_detector_16_exit_volume, mcposaspec_detector_16_exit_volume);
  mcposrspec_detector_16_exit_volume = rot_apply(mcrotaspec_detector_16_exit_volume, mctc1);
  mcDEBUG_COMPONENT("spec_detector_16_exit_volume", mcposaspec_detector_16_exit_volume, mcrotaspec_detector_16_exit_volume)
  mccomp_posa[769] = mcposaspec_detector_16_exit_volume;
  mccomp_posr[769] = mcposrspec_detector_16_exit_volume;
  mcNCounter[769]  = mcPCounter[769] = mcP2Counter[769] = 0;
  mcAbsorbProp[769]= 0;
    /* Component channel_17_cave1_box1. */
  /* Setting parameters for component channel_17_cave1_box1. */
  SIG_MESSAGE("channel_17_cave1_box1 (Init:SetPar)");
#line 4292 "MACS_sample_kidney_box.instr"
  if("Vacuum") strncpy(mccchannel_17_cave1_box1_material_string, "Vacuum" ? "Vacuum" : "", 16384); else mccchannel_17_cave1_box1_material_string[0]='\0';
#line 4292 "MACS_sample_kidney_box.instr"
  mccchannel_17_cave1_box1_priority = 1900;
#line 4290 "MACS_sample_kidney_box.instr"
  mccchannel_17_cave1_box1_xwidth = kidney_cave1_box1_width1;
#line 4290 "MACS_sample_kidney_box.instr"
  mccchannel_17_cave1_box1_yheight = kidney_cave1_box1_height1;
#line 4290 "MACS_sample_kidney_box.instr"
  mccchannel_17_cave1_box1_zdepth = kidney_cave1_box1_depth;
#line 4291 "MACS_sample_kidney_box.instr"
  mccchannel_17_cave1_box1_xwidth2 = kidney_cave1_box1_width2;
#line 4291 "MACS_sample_kidney_box.instr"
  mccchannel_17_cave1_box1_yheight2 = kidney_cave1_box1_height2;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_17_cave1_box1_visualize = 1;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_17_cave1_box1_target_index = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_17_cave1_box1_target_x = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_17_cave1_box1_target_y = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_17_cave1_box1_target_z = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_17_cave1_box1_focus_aw = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_17_cave1_box1_focus_ah = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_17_cave1_box1_focus_xw = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_17_cave1_box1_focus_xh = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_17_cave1_box1_focus_r = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_17_cave1_box1_p_interact = 0;
#line 71 "MACS_sample_kidney_box.instr"
  if(0) strncpy(mccchannel_17_cave1_box1_mask_string, 0 ? 0 : "", 16384); else mccchannel_17_cave1_box1_mask_string[0]='\0';
#line 71 "MACS_sample_kidney_box.instr"
  if(0) strncpy(mccchannel_17_cave1_box1_mask_setting, 0 ? 0 : "", 16384); else mccchannel_17_cave1_box1_mask_setting[0]='\0';
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_17_cave1_box1_number_of_activations = 1;
#line 142059 "MACS_sample_kidney_box.c"

  SIG_MESSAGE("channel_17_cave1_box1 (Init:Place/Rotate)");
  rot_set_rotation(mctr1,
#line 4294 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 4294 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 4294 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD);
#line 142069 "MACS_sample_kidney_box.c"
  rot_mul(mctr1, mcrotakidney_channel_17, mcrotachannel_17_cave1_box1);
  rot_transpose(mcrotaspec_detector_16_exit_volume, mctr1);
  rot_mul(mcrotachannel_17_cave1_box1, mctr1, mcrotrchannel_17_cave1_box1);
  mctc1 = coords_set(
#line 4293 "MACS_sample_kidney_box.instr"
    0,
#line 4293 "MACS_sample_kidney_box.instr"
    0,
#line 4293 "MACS_sample_kidney_box.instr"
    kidney_cave1_box1_center_to_target);
#line 142080 "MACS_sample_kidney_box.c"
  rot_transpose(mcrotakidney_channel_17, mctr1);
  mctc2 = rot_apply(mctr1, mctc1);
  mcposachannel_17_cave1_box1 = coords_add(mcposakidney_channel_17, mctc2);
  mctc1 = coords_sub(mcposaspec_detector_16_exit_volume, mcposachannel_17_cave1_box1);
  mcposrchannel_17_cave1_box1 = rot_apply(mcrotachannel_17_cave1_box1, mctc1);
  mcDEBUG_COMPONENT("channel_17_cave1_box1", mcposachannel_17_cave1_box1, mcrotachannel_17_cave1_box1)
  mccomp_posa[770] = mcposachannel_17_cave1_box1;
  mccomp_posr[770] = mcposrchannel_17_cave1_box1;
  mcNCounter[770]  = mcPCounter[770] = mcP2Counter[770] = 0;
  mcAbsorbProp[770]= 0;
    /* Component channel_17_cave1_box2. */
  /* Setting parameters for component channel_17_cave1_box2. */
  SIG_MESSAGE("channel_17_cave1_box2 (Init:SetPar)");
#line 4299 "MACS_sample_kidney_box.instr"
  if("Vacuum") strncpy(mccchannel_17_cave1_box2_material_string, "Vacuum" ? "Vacuum" : "", 16384); else mccchannel_17_cave1_box2_material_string[0]='\0';
#line 4299 "MACS_sample_kidney_box.instr"
  mccchannel_17_cave1_box2_priority = 1905;
#line 4297 "MACS_sample_kidney_box.instr"
  mccchannel_17_cave1_box2_xwidth = kidney_cave1_box2_width1;
#line 4297 "MACS_sample_kidney_box.instr"
  mccchannel_17_cave1_box2_yheight = kidney_cave1_box2_height1;
#line 4297 "MACS_sample_kidney_box.instr"
  mccchannel_17_cave1_box2_zdepth = kidney_cave1_box2_depth;
#line 4298 "MACS_sample_kidney_box.instr"
  mccchannel_17_cave1_box2_xwidth2 = kidney_cave1_box2_width2;
#line 4298 "MACS_sample_kidney_box.instr"
  mccchannel_17_cave1_box2_yheight2 = kidney_cave1_box2_height2;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_17_cave1_box2_visualize = 1;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_17_cave1_box2_target_index = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_17_cave1_box2_target_x = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_17_cave1_box2_target_y = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_17_cave1_box2_target_z = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_17_cave1_box2_focus_aw = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_17_cave1_box2_focus_ah = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_17_cave1_box2_focus_xw = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_17_cave1_box2_focus_xh = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_17_cave1_box2_focus_r = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_17_cave1_box2_p_interact = 0;
#line 71 "MACS_sample_kidney_box.instr"
  if(0) strncpy(mccchannel_17_cave1_box2_mask_string, 0 ? 0 : "", 16384); else mccchannel_17_cave1_box2_mask_string[0]='\0';
#line 71 "MACS_sample_kidney_box.instr"
  if(0) strncpy(mccchannel_17_cave1_box2_mask_setting, 0 ? 0 : "", 16384); else mccchannel_17_cave1_box2_mask_setting[0]='\0';
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_17_cave1_box2_number_of_activations = 1;
#line 142136 "MACS_sample_kidney_box.c"

  SIG_MESSAGE("channel_17_cave1_box2 (Init:Place/Rotate)");
  rot_set_rotation(mctr1,
#line 4301 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 4301 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 4301 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD);
#line 142146 "MACS_sample_kidney_box.c"
  rot_mul(mctr1, mcrotakidney_channel_17, mcrotachannel_17_cave1_box2);
  rot_transpose(mcrotachannel_17_cave1_box1, mctr1);
  rot_mul(mcrotachannel_17_cave1_box2, mctr1, mcrotrchannel_17_cave1_box2);
  mctc1 = coords_set(
#line 4300 "MACS_sample_kidney_box.instr"
    kidney_cave1_box2_x_offset,
#line 4300 "MACS_sample_kidney_box.instr"
    0,
#line 4300 "MACS_sample_kidney_box.instr"
    kidney_cave1_box2_center_to_target);
#line 142157 "MACS_sample_kidney_box.c"
  rot_transpose(mcrotakidney_channel_17, mctr1);
  mctc2 = rot_apply(mctr1, mctc1);
  mcposachannel_17_cave1_box2 = coords_add(mcposakidney_channel_17, mctc2);
  mctc1 = coords_sub(mcposachannel_17_cave1_box1, mcposachannel_17_cave1_box2);
  mcposrchannel_17_cave1_box2 = rot_apply(mcrotachannel_17_cave1_box2, mctc1);
  mcDEBUG_COMPONENT("channel_17_cave1_box2", mcposachannel_17_cave1_box2, mcrotachannel_17_cave1_box2)
  mccomp_posa[771] = mcposachannel_17_cave1_box2;
  mccomp_posr[771] = mcposrchannel_17_cave1_box2;
  mcNCounter[771]  = mcPCounter[771] = mcP2Counter[771] = 0;
  mcAbsorbProp[771]= 0;
    /* Component channel_17_cave1_box3. */
  /* Setting parameters for component channel_17_cave1_box3. */
  SIG_MESSAGE("channel_17_cave1_box3 (Init:SetPar)");
#line 4306 "MACS_sample_kidney_box.instr"
  if("Vacuum") strncpy(mccchannel_17_cave1_box3_material_string, "Vacuum" ? "Vacuum" : "", 16384); else mccchannel_17_cave1_box3_material_string[0]='\0';
#line 4306 "MACS_sample_kidney_box.instr"
  mccchannel_17_cave1_box3_priority = 1902;
#line 4304 "MACS_sample_kidney_box.instr"
  mccchannel_17_cave1_box3_xwidth = kidney_cave1_box3_width1;
#line 4304 "MACS_sample_kidney_box.instr"
  mccchannel_17_cave1_box3_yheight = kidney_cave1_box3_height1;
#line 4304 "MACS_sample_kidney_box.instr"
  mccchannel_17_cave1_box3_zdepth = kidney_cave1_box3_depth;
#line 4305 "MACS_sample_kidney_box.instr"
  mccchannel_17_cave1_box3_xwidth2 = kidney_cave1_box3_width2;
#line 4305 "MACS_sample_kidney_box.instr"
  mccchannel_17_cave1_box3_yheight2 = kidney_cave1_box3_height2;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_17_cave1_box3_visualize = 1;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_17_cave1_box3_target_index = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_17_cave1_box3_target_x = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_17_cave1_box3_target_y = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_17_cave1_box3_target_z = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_17_cave1_box3_focus_aw = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_17_cave1_box3_focus_ah = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_17_cave1_box3_focus_xw = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_17_cave1_box3_focus_xh = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_17_cave1_box3_focus_r = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_17_cave1_box3_p_interact = 0;
#line 71 "MACS_sample_kidney_box.instr"
  if(0) strncpy(mccchannel_17_cave1_box3_mask_string, 0 ? 0 : "", 16384); else mccchannel_17_cave1_box3_mask_string[0]='\0';
#line 71 "MACS_sample_kidney_box.instr"
  if(0) strncpy(mccchannel_17_cave1_box3_mask_setting, 0 ? 0 : "", 16384); else mccchannel_17_cave1_box3_mask_setting[0]='\0';
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_17_cave1_box3_number_of_activations = 1;
#line 142213 "MACS_sample_kidney_box.c"

  SIG_MESSAGE("channel_17_cave1_box3 (Init:Place/Rotate)");
  rot_set_rotation(mctr1,
#line 4308 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 4308 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 4308 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD);
#line 142223 "MACS_sample_kidney_box.c"
  rot_mul(mctr1, mcrotakidney_channel_17, mcrotachannel_17_cave1_box3);
  rot_transpose(mcrotachannel_17_cave1_box2, mctr1);
  rot_mul(mcrotachannel_17_cave1_box3, mctr1, mcrotrchannel_17_cave1_box3);
  mctc1 = coords_set(
#line 4307 "MACS_sample_kidney_box.instr"
    0,
#line 4307 "MACS_sample_kidney_box.instr"
    0,
#line 4307 "MACS_sample_kidney_box.instr"
    kidney_cave1_box3_center_to_target);
#line 142234 "MACS_sample_kidney_box.c"
  rot_transpose(mcrotakidney_channel_17, mctr1);
  mctc2 = rot_apply(mctr1, mctc1);
  mcposachannel_17_cave1_box3 = coords_add(mcposakidney_channel_17, mctc2);
  mctc1 = coords_sub(mcposachannel_17_cave1_box2, mcposachannel_17_cave1_box3);
  mcposrchannel_17_cave1_box3 = rot_apply(mcrotachannel_17_cave1_box3, mctc1);
  mcDEBUG_COMPONENT("channel_17_cave1_box3", mcposachannel_17_cave1_box3, mcrotachannel_17_cave1_box3)
  mccomp_posa[772] = mcposachannel_17_cave1_box3;
  mccomp_posr[772] = mcposrchannel_17_cave1_box3;
  mcNCounter[772]  = mcPCounter[772] = mcP2Counter[772] = 0;
  mcAbsorbProp[772]= 0;
    /* Component channel_17_cave1_cyl1. */
  /* Setting parameters for component channel_17_cave1_cyl1. */
  SIG_MESSAGE("channel_17_cave1_cyl1 (Init:SetPar)");
#line 4312 "MACS_sample_kidney_box.instr"
  if("Vacuum") strncpy(mccchannel_17_cave1_cyl1_material_string, "Vacuum" ? "Vacuum" : "", 16384); else mccchannel_17_cave1_cyl1_material_string[0]='\0';
#line 4312 "MACS_sample_kidney_box.instr"
  mccchannel_17_cave1_cyl1_priority = 1903;
#line 4311 "MACS_sample_kidney_box.instr"
  mccchannel_17_cave1_cyl1_radius = kidney_cave1_cyl1_radius;
#line 4311 "MACS_sample_kidney_box.instr"
  mccchannel_17_cave1_cyl1_yheight = kidney_cave1_cyl1_height;
#line 67 "MACS_sample_kidney_box.instr"
  mccchannel_17_cave1_cyl1_visualize = 1;
#line 67 "MACS_sample_kidney_box.instr"
  mccchannel_17_cave1_cyl1_target_index = 0;
#line 67 "MACS_sample_kidney_box.instr"
  mccchannel_17_cave1_cyl1_target_x = 0;
#line 67 "MACS_sample_kidney_box.instr"
  mccchannel_17_cave1_cyl1_target_y = 0;
#line 67 "MACS_sample_kidney_box.instr"
  mccchannel_17_cave1_cyl1_target_z = 0;
#line 67 "MACS_sample_kidney_box.instr"
  mccchannel_17_cave1_cyl1_focus_aw = 0;
#line 67 "MACS_sample_kidney_box.instr"
  mccchannel_17_cave1_cyl1_focus_ah = 0;
#line 67 "MACS_sample_kidney_box.instr"
  mccchannel_17_cave1_cyl1_focus_xw = 0;
#line 67 "MACS_sample_kidney_box.instr"
  mccchannel_17_cave1_cyl1_focus_xh = 0;
#line 67 "MACS_sample_kidney_box.instr"
  mccchannel_17_cave1_cyl1_focus_r = 0;
#line 67 "MACS_sample_kidney_box.instr"
  mccchannel_17_cave1_cyl1_p_interact = 0;
#line 67 "MACS_sample_kidney_box.instr"
  if(0) strncpy(mccchannel_17_cave1_cyl1_mask_string, 0 ? 0 : "", 16384); else mccchannel_17_cave1_cyl1_mask_string[0]='\0';
#line 67 "MACS_sample_kidney_box.instr"
  if(0) strncpy(mccchannel_17_cave1_cyl1_mask_setting, 0 ? 0 : "", 16384); else mccchannel_17_cave1_cyl1_mask_setting[0]='\0';
#line 67 "MACS_sample_kidney_box.instr"
  mccchannel_17_cave1_cyl1_number_of_activations = 1;
#line 142284 "MACS_sample_kidney_box.c"

  SIG_MESSAGE("channel_17_cave1_cyl1 (Init:Place/Rotate)");
  rot_set_rotation(mctr1,
#line 4314 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 4314 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 4314 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD);
#line 142294 "MACS_sample_kidney_box.c"
  rot_mul(mctr1, mcrotakidney_channel_17, mcrotachannel_17_cave1_cyl1);
  rot_transpose(mcrotachannel_17_cave1_box3, mctr1);
  rot_mul(mcrotachannel_17_cave1_cyl1, mctr1, mcrotrchannel_17_cave1_cyl1);
  mctc1 = coords_set(
#line 4313 "MACS_sample_kidney_box.instr"
    0,
#line 4313 "MACS_sample_kidney_box.instr"
    0,
#line 4313 "MACS_sample_kidney_box.instr"
    kidney_cave1_cyl1_center_to_target);
#line 142305 "MACS_sample_kidney_box.c"
  rot_transpose(mcrotakidney_channel_17, mctr1);
  mctc2 = rot_apply(mctr1, mctc1);
  mcposachannel_17_cave1_cyl1 = coords_add(mcposakidney_channel_17, mctc2);
  mctc1 = coords_sub(mcposachannel_17_cave1_box3, mcposachannel_17_cave1_cyl1);
  mcposrchannel_17_cave1_cyl1 = rot_apply(mcrotachannel_17_cave1_cyl1, mctc1);
  mcDEBUG_COMPONENT("channel_17_cave1_cyl1", mcposachannel_17_cave1_cyl1, mcrotachannel_17_cave1_cyl1)
  mccomp_posa[773] = mcposachannel_17_cave1_cyl1;
  mccomp_posr[773] = mcposrchannel_17_cave1_cyl1;
  mcNCounter[773]  = mcPCounter[773] = mcP2Counter[773] = 0;
  mcAbsorbProp[773]= 0;
    /* Component channel_17_analyzer_1_center. */
  /* Setting parameters for component channel_17_analyzer_1_center. */
  SIG_MESSAGE("channel_17_analyzer_1_center (Init:SetPar)");

  SIG_MESSAGE("channel_17_analyzer_1_center (Init:Place/Rotate)");
  rot_set_rotation(mctr1,
    (0.0)*DEG2RAD,
    (0.0)*DEG2RAD,
    (0.0)*DEG2RAD);
#line 142325 "MACS_sample_kidney_box.c"
  rot_mul(mctr1, mcrotakidney_channel_17, mcrotachannel_17_analyzer_1_center);
  rot_transpose(mcrotachannel_17_cave1_cyl1, mctr1);
  rot_mul(mcrotachannel_17_analyzer_1_center, mctr1, mcrotrchannel_17_analyzer_1_center);
  mctc1 = coords_set(
#line 4318 "MACS_sample_kidney_box.instr"
    0,
#line 4318 "MACS_sample_kidney_box.instr"
    0,
#line 4318 "MACS_sample_kidney_box.instr"
    analyzer_1_center_to_sample);
#line 142336 "MACS_sample_kidney_box.c"
  rot_transpose(mcrotakidney_channel_17, mctr1);
  mctc2 = rot_apply(mctr1, mctc1);
  mcposachannel_17_analyzer_1_center = coords_add(mcposakidney_channel_17, mctc2);
  mctc1 = coords_sub(mcposachannel_17_cave1_cyl1, mcposachannel_17_analyzer_1_center);
  mcposrchannel_17_analyzer_1_center = rot_apply(mcrotachannel_17_analyzer_1_center, mctc1);
  mcDEBUG_COMPONENT("channel_17_analyzer_1_center", mcposachannel_17_analyzer_1_center, mcrotachannel_17_analyzer_1_center)
  mccomp_posa[774] = mcposachannel_17_analyzer_1_center;
  mccomp_posr[774] = mcposrchannel_17_analyzer_1_center;
  mcNCounter[774]  = mcPCounter[774] = mcP2Counter[774] = 0;
  mcAbsorbProp[774]= 0;
    /* Component channel_17_analyzer_1_rotated. */
  /* Setting parameters for component channel_17_analyzer_1_rotated. */
  SIG_MESSAGE("channel_17_analyzer_1_rotated (Init:SetPar)");

  SIG_MESSAGE("channel_17_analyzer_1_rotated (Init:Place/Rotate)");
  rot_set_rotation(mctr1,
#line 4322 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 4322 "MACS_sample_kidney_box.instr"
    (180 - analyzer_theta [ 17 ])*DEG2RAD,
#line 4322 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD);
#line 142359 "MACS_sample_kidney_box.c"
  rot_mul(mctr1, mcrotachannel_17_analyzer_1_center, mcrotachannel_17_analyzer_1_rotated);
  rot_transpose(mcrotachannel_17_analyzer_1_center, mctr1);
  rot_mul(mcrotachannel_17_analyzer_1_rotated, mctr1, mcrotrchannel_17_analyzer_1_rotated);
  mctc1 = coords_set(
#line 4321 "MACS_sample_kidney_box.instr"
    0,
#line 4321 "MACS_sample_kidney_box.instr"
    0,
#line 4321 "MACS_sample_kidney_box.instr"
    -0.5 * analyzer_seperation / tan ( analyzer_2theta [ 17 ] * DEG2RAD ));
#line 142370 "MACS_sample_kidney_box.c"
  rot_transpose(mcrotachannel_17_analyzer_1_center, mctr1);
  mctc2 = rot_apply(mctr1, mctc1);
  mcposachannel_17_analyzer_1_rotated = coords_add(mcposachannel_17_analyzer_1_center, mctc2);
  mctc1 = coords_sub(mcposachannel_17_analyzer_1_center, mcposachannel_17_analyzer_1_rotated);
  mcposrchannel_17_analyzer_1_rotated = rot_apply(mcrotachannel_17_analyzer_1_rotated, mctc1);
  mcDEBUG_COMPONENT("channel_17_analyzer_1_rotated", mcposachannel_17_analyzer_1_rotated, mcrotachannel_17_analyzer_1_rotated)
  mccomp_posa[775] = mcposachannel_17_analyzer_1_rotated;
  mccomp_posr[775] = mcposrchannel_17_analyzer_1_rotated;
  mcNCounter[775]  = mcPCounter[775] = mcP2Counter[775] = 0;
  mcAbsorbProp[775]= 0;
    /* Component channel_17_analyzer_1_array_crystal_array_0. */
  /* Setting parameters for component channel_17_analyzer_1_array_crystal_array_0. */
  SIG_MESSAGE("channel_17_analyzer_1_array_crystal_array_0 (Init:SetPar)");
#line 4326 "MACS_sample_kidney_box.instr"
  if("PG_analyzer") strncpy(mccchannel_17_analyzer_1_array_crystal_array_0_material_string, "PG_analyzer" ? "PG_analyzer" : "", 16384); else mccchannel_17_analyzer_1_array_crystal_array_0_material_string[0]='\0';
#line 4326 "MACS_sample_kidney_box.instr"
  mccchannel_17_analyzer_1_array_crystal_array_0_priority = 1920.0;
#line 4325 "MACS_sample_kidney_box.instr"
  mccchannel_17_analyzer_1_array_crystal_array_0_xwidth = channel_17_analyzer_1_array_crystal_depth;
#line 4325 "MACS_sample_kidney_box.instr"
  mccchannel_17_analyzer_1_array_crystal_array_0_yheight = channel_17_analyzer_1_array_crystal_height;
#line 4325 "MACS_sample_kidney_box.instr"
  mccchannel_17_analyzer_1_array_crystal_array_0_zdepth = channel_17_analyzer_1_array_crystal_width;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_17_analyzer_1_array_crystal_array_0_xwidth2 = -1;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_17_analyzer_1_array_crystal_array_0_yheight2 = -1;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_17_analyzer_1_array_crystal_array_0_visualize = 1;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_17_analyzer_1_array_crystal_array_0_target_index = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_17_analyzer_1_array_crystal_array_0_target_x = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_17_analyzer_1_array_crystal_array_0_target_y = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_17_analyzer_1_array_crystal_array_0_target_z = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_17_analyzer_1_array_crystal_array_0_focus_aw = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_17_analyzer_1_array_crystal_array_0_focus_ah = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_17_analyzer_1_array_crystal_array_0_focus_xw = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_17_analyzer_1_array_crystal_array_0_focus_xh = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_17_analyzer_1_array_crystal_array_0_focus_r = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_17_analyzer_1_array_crystal_array_0_p_interact = 0;
#line 71 "MACS_sample_kidney_box.instr"
  if(0) strncpy(mccchannel_17_analyzer_1_array_crystal_array_0_mask_string, 0 ? 0 : "", 16384); else mccchannel_17_analyzer_1_array_crystal_array_0_mask_string[0]='\0';
#line 71 "MACS_sample_kidney_box.instr"
  if(0) strncpy(mccchannel_17_analyzer_1_array_crystal_array_0_mask_setting, 0 ? 0 : "", 16384); else mccchannel_17_analyzer_1_array_crystal_array_0_mask_setting[0]='\0';
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_17_analyzer_1_array_crystal_array_0_number_of_activations = 1;
#line 142426 "MACS_sample_kidney_box.c"

  SIG_MESSAGE("channel_17_analyzer_1_array_crystal_array_0 (Init:Place/Rotate)");
  rot_set_rotation(mctr1,
#line 4328 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 4328 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 4328 "MACS_sample_kidney_box.instr"
    (0 - RAD2DEG * channel_17_analyzer_1_array_theta [ 0 ])*DEG2RAD);
#line 142436 "MACS_sample_kidney_box.c"
  rot_mul(mctr1, mcrotachannel_17_analyzer_1_rotated, mcrotachannel_17_analyzer_1_array_crystal_array_0);
  rot_transpose(mcrotachannel_17_analyzer_1_rotated, mctr1);
  rot_mul(mcrotachannel_17_analyzer_1_array_crystal_array_0, mctr1, mcrotrchannel_17_analyzer_1_array_crystal_array_0);
  mctc1 = coords_set(
#line 4327 "MACS_sample_kidney_box.instr"
    0 + channel_17_analyzer_1_array_effective_radius_of_curvature * ( 1 - cos ( channel_17_analyzer_1_array_theta [ 0 ] ) ),
#line 4327 "MACS_sample_kidney_box.instr"
    0 + channel_17_analyzer_1_array_effective_radius_of_curvature * sin ( channel_17_analyzer_1_array_theta [ 0 ] ),
#line 4327 "MACS_sample_kidney_box.instr"
    0);
#line 142447 "MACS_sample_kidney_box.c"
  rot_transpose(mcrotachannel_17_analyzer_1_rotated, mctr1);
  mctc2 = rot_apply(mctr1, mctc1);
  mcposachannel_17_analyzer_1_array_crystal_array_0 = coords_add(mcposachannel_17_analyzer_1_rotated, mctc2);
  mctc1 = coords_sub(mcposachannel_17_analyzer_1_rotated, mcposachannel_17_analyzer_1_array_crystal_array_0);
  mcposrchannel_17_analyzer_1_array_crystal_array_0 = rot_apply(mcrotachannel_17_analyzer_1_array_crystal_array_0, mctc1);
  mcDEBUG_COMPONENT("channel_17_analyzer_1_array_crystal_array_0", mcposachannel_17_analyzer_1_array_crystal_array_0, mcrotachannel_17_analyzer_1_array_crystal_array_0)
  mccomp_posa[776] = mcposachannel_17_analyzer_1_array_crystal_array_0;
  mccomp_posr[776] = mcposrchannel_17_analyzer_1_array_crystal_array_0;
  mcNCounter[776]  = mcPCounter[776] = mcP2Counter[776] = 0;
  mcAbsorbProp[776]= 0;
    /* Component channel_17_analyzer_1_array_crystal_array_1. */
  /* Setting parameters for component channel_17_analyzer_1_array_crystal_array_1. */
  SIG_MESSAGE("channel_17_analyzer_1_array_crystal_array_1 (Init:SetPar)");
#line 4332 "MACS_sample_kidney_box.instr"
  if("PG_analyzer") strncpy(mccchannel_17_analyzer_1_array_crystal_array_1_material_string, "PG_analyzer" ? "PG_analyzer" : "", 16384); else mccchannel_17_analyzer_1_array_crystal_array_1_material_string[0]='\0';
#line 4332 "MACS_sample_kidney_box.instr"
  mccchannel_17_analyzer_1_array_crystal_array_1_priority = 1920.1;
#line 4331 "MACS_sample_kidney_box.instr"
  mccchannel_17_analyzer_1_array_crystal_array_1_xwidth = channel_17_analyzer_1_array_crystal_depth;
#line 4331 "MACS_sample_kidney_box.instr"
  mccchannel_17_analyzer_1_array_crystal_array_1_yheight = channel_17_analyzer_1_array_crystal_height;
#line 4331 "MACS_sample_kidney_box.instr"
  mccchannel_17_analyzer_1_array_crystal_array_1_zdepth = channel_17_analyzer_1_array_crystal_width;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_17_analyzer_1_array_crystal_array_1_xwidth2 = -1;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_17_analyzer_1_array_crystal_array_1_yheight2 = -1;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_17_analyzer_1_array_crystal_array_1_visualize = 1;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_17_analyzer_1_array_crystal_array_1_target_index = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_17_analyzer_1_array_crystal_array_1_target_x = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_17_analyzer_1_array_crystal_array_1_target_y = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_17_analyzer_1_array_crystal_array_1_target_z = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_17_analyzer_1_array_crystal_array_1_focus_aw = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_17_analyzer_1_array_crystal_array_1_focus_ah = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_17_analyzer_1_array_crystal_array_1_focus_xw = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_17_analyzer_1_array_crystal_array_1_focus_xh = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_17_analyzer_1_array_crystal_array_1_focus_r = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_17_analyzer_1_array_crystal_array_1_p_interact = 0;
#line 71 "MACS_sample_kidney_box.instr"
  if(0) strncpy(mccchannel_17_analyzer_1_array_crystal_array_1_mask_string, 0 ? 0 : "", 16384); else mccchannel_17_analyzer_1_array_crystal_array_1_mask_string[0]='\0';
#line 71 "MACS_sample_kidney_box.instr"
  if(0) strncpy(mccchannel_17_analyzer_1_array_crystal_array_1_mask_setting, 0 ? 0 : "", 16384); else mccchannel_17_analyzer_1_array_crystal_array_1_mask_setting[0]='\0';
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_17_analyzer_1_array_crystal_array_1_number_of_activations = 1;
#line 142503 "MACS_sample_kidney_box.c"

  SIG_MESSAGE("channel_17_analyzer_1_array_crystal_array_1 (Init:Place/Rotate)");
  rot_set_rotation(mctr1,
#line 4334 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 4334 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 4334 "MACS_sample_kidney_box.instr"
    (0 - RAD2DEG * channel_17_analyzer_1_array_theta [ 1 ])*DEG2RAD);
#line 142513 "MACS_sample_kidney_box.c"
  rot_mul(mctr1, mcrotachannel_17_analyzer_1_rotated, mcrotachannel_17_analyzer_1_array_crystal_array_1);
  rot_transpose(mcrotachannel_17_analyzer_1_array_crystal_array_0, mctr1);
  rot_mul(mcrotachannel_17_analyzer_1_array_crystal_array_1, mctr1, mcrotrchannel_17_analyzer_1_array_crystal_array_1);
  mctc1 = coords_set(
#line 4333 "MACS_sample_kidney_box.instr"
    0 + channel_17_analyzer_1_array_effective_radius_of_curvature * ( 1 - cos ( channel_17_analyzer_1_array_theta [ 1 ] ) ),
#line 4333 "MACS_sample_kidney_box.instr"
    0 + channel_17_analyzer_1_array_effective_radius_of_curvature * sin ( channel_17_analyzer_1_array_theta [ 1 ] ),
#line 4333 "MACS_sample_kidney_box.instr"
    0);
#line 142524 "MACS_sample_kidney_box.c"
  rot_transpose(mcrotachannel_17_analyzer_1_rotated, mctr1);
  mctc2 = rot_apply(mctr1, mctc1);
  mcposachannel_17_analyzer_1_array_crystal_array_1 = coords_add(mcposachannel_17_analyzer_1_rotated, mctc2);
  mctc1 = coords_sub(mcposachannel_17_analyzer_1_array_crystal_array_0, mcposachannel_17_analyzer_1_array_crystal_array_1);
  mcposrchannel_17_analyzer_1_array_crystal_array_1 = rot_apply(mcrotachannel_17_analyzer_1_array_crystal_array_1, mctc1);
  mcDEBUG_COMPONENT("channel_17_analyzer_1_array_crystal_array_1", mcposachannel_17_analyzer_1_array_crystal_array_1, mcrotachannel_17_analyzer_1_array_crystal_array_1)
  mccomp_posa[777] = mcposachannel_17_analyzer_1_array_crystal_array_1;
  mccomp_posr[777] = mcposrchannel_17_analyzer_1_array_crystal_array_1;
  mcNCounter[777]  = mcPCounter[777] = mcP2Counter[777] = 0;
  mcAbsorbProp[777]= 0;
    /* Component channel_17_analyzer_1_array_crystal_array_2. */
  /* Setting parameters for component channel_17_analyzer_1_array_crystal_array_2. */
  SIG_MESSAGE("channel_17_analyzer_1_array_crystal_array_2 (Init:SetPar)");
#line 4338 "MACS_sample_kidney_box.instr"
  if("PG_analyzer") strncpy(mccchannel_17_analyzer_1_array_crystal_array_2_material_string, "PG_analyzer" ? "PG_analyzer" : "", 16384); else mccchannel_17_analyzer_1_array_crystal_array_2_material_string[0]='\0';
#line 4338 "MACS_sample_kidney_box.instr"
  mccchannel_17_analyzer_1_array_crystal_array_2_priority = 1920.2;
#line 4337 "MACS_sample_kidney_box.instr"
  mccchannel_17_analyzer_1_array_crystal_array_2_xwidth = channel_17_analyzer_1_array_crystal_depth;
#line 4337 "MACS_sample_kidney_box.instr"
  mccchannel_17_analyzer_1_array_crystal_array_2_yheight = channel_17_analyzer_1_array_crystal_height;
#line 4337 "MACS_sample_kidney_box.instr"
  mccchannel_17_analyzer_1_array_crystal_array_2_zdepth = channel_17_analyzer_1_array_crystal_width;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_17_analyzer_1_array_crystal_array_2_xwidth2 = -1;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_17_analyzer_1_array_crystal_array_2_yheight2 = -1;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_17_analyzer_1_array_crystal_array_2_visualize = 1;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_17_analyzer_1_array_crystal_array_2_target_index = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_17_analyzer_1_array_crystal_array_2_target_x = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_17_analyzer_1_array_crystal_array_2_target_y = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_17_analyzer_1_array_crystal_array_2_target_z = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_17_analyzer_1_array_crystal_array_2_focus_aw = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_17_analyzer_1_array_crystal_array_2_focus_ah = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_17_analyzer_1_array_crystal_array_2_focus_xw = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_17_analyzer_1_array_crystal_array_2_focus_xh = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_17_analyzer_1_array_crystal_array_2_focus_r = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_17_analyzer_1_array_crystal_array_2_p_interact = 0;
#line 71 "MACS_sample_kidney_box.instr"
  if(0) strncpy(mccchannel_17_analyzer_1_array_crystal_array_2_mask_string, 0 ? 0 : "", 16384); else mccchannel_17_analyzer_1_array_crystal_array_2_mask_string[0]='\0';
#line 71 "MACS_sample_kidney_box.instr"
  if(0) strncpy(mccchannel_17_analyzer_1_array_crystal_array_2_mask_setting, 0 ? 0 : "", 16384); else mccchannel_17_analyzer_1_array_crystal_array_2_mask_setting[0]='\0';
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_17_analyzer_1_array_crystal_array_2_number_of_activations = 1;
#line 142580 "MACS_sample_kidney_box.c"

  SIG_MESSAGE("channel_17_analyzer_1_array_crystal_array_2 (Init:Place/Rotate)");
  rot_set_rotation(mctr1,
#line 4340 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 4340 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 4340 "MACS_sample_kidney_box.instr"
    (0 - RAD2DEG * channel_17_analyzer_1_array_theta [ 2 ])*DEG2RAD);
#line 142590 "MACS_sample_kidney_box.c"
  rot_mul(mctr1, mcrotachannel_17_analyzer_1_rotated, mcrotachannel_17_analyzer_1_array_crystal_array_2);
  rot_transpose(mcrotachannel_17_analyzer_1_array_crystal_array_1, mctr1);
  rot_mul(mcrotachannel_17_analyzer_1_array_crystal_array_2, mctr1, mcrotrchannel_17_analyzer_1_array_crystal_array_2);
  mctc1 = coords_set(
#line 4339 "MACS_sample_kidney_box.instr"
    0 + channel_17_analyzer_1_array_effective_radius_of_curvature * ( 1 - cos ( channel_17_analyzer_1_array_theta [ 2 ] ) ),
#line 4339 "MACS_sample_kidney_box.instr"
    0 + channel_17_analyzer_1_array_effective_radius_of_curvature * sin ( channel_17_analyzer_1_array_theta [ 2 ] ),
#line 4339 "MACS_sample_kidney_box.instr"
    0);
#line 142601 "MACS_sample_kidney_box.c"
  rot_transpose(mcrotachannel_17_analyzer_1_rotated, mctr1);
  mctc2 = rot_apply(mctr1, mctc1);
  mcposachannel_17_analyzer_1_array_crystal_array_2 = coords_add(mcposachannel_17_analyzer_1_rotated, mctc2);
  mctc1 = coords_sub(mcposachannel_17_analyzer_1_array_crystal_array_1, mcposachannel_17_analyzer_1_array_crystal_array_2);
  mcposrchannel_17_analyzer_1_array_crystal_array_2 = rot_apply(mcrotachannel_17_analyzer_1_array_crystal_array_2, mctc1);
  mcDEBUG_COMPONENT("channel_17_analyzer_1_array_crystal_array_2", mcposachannel_17_analyzer_1_array_crystal_array_2, mcrotachannel_17_analyzer_1_array_crystal_array_2)
  mccomp_posa[778] = mcposachannel_17_analyzer_1_array_crystal_array_2;
  mccomp_posr[778] = mcposrchannel_17_analyzer_1_array_crystal_array_2;
  mcNCounter[778]  = mcPCounter[778] = mcP2Counter[778] = 0;
  mcAbsorbProp[778]= 0;
    /* Component channel_17_analyzer_1_array_crystal_array_3. */
  /* Setting parameters for component channel_17_analyzer_1_array_crystal_array_3. */
  SIG_MESSAGE("channel_17_analyzer_1_array_crystal_array_3 (Init:SetPar)");
#line 4344 "MACS_sample_kidney_box.instr"
  if("PG_analyzer") strncpy(mccchannel_17_analyzer_1_array_crystal_array_3_material_string, "PG_analyzer" ? "PG_analyzer" : "", 16384); else mccchannel_17_analyzer_1_array_crystal_array_3_material_string[0]='\0';
#line 4344 "MACS_sample_kidney_box.instr"
  mccchannel_17_analyzer_1_array_crystal_array_3_priority = 1920.3;
#line 4343 "MACS_sample_kidney_box.instr"
  mccchannel_17_analyzer_1_array_crystal_array_3_xwidth = channel_17_analyzer_1_array_crystal_depth;
#line 4343 "MACS_sample_kidney_box.instr"
  mccchannel_17_analyzer_1_array_crystal_array_3_yheight = channel_17_analyzer_1_array_crystal_height;
#line 4343 "MACS_sample_kidney_box.instr"
  mccchannel_17_analyzer_1_array_crystal_array_3_zdepth = channel_17_analyzer_1_array_crystal_width;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_17_analyzer_1_array_crystal_array_3_xwidth2 = -1;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_17_analyzer_1_array_crystal_array_3_yheight2 = -1;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_17_analyzer_1_array_crystal_array_3_visualize = 1;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_17_analyzer_1_array_crystal_array_3_target_index = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_17_analyzer_1_array_crystal_array_3_target_x = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_17_analyzer_1_array_crystal_array_3_target_y = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_17_analyzer_1_array_crystal_array_3_target_z = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_17_analyzer_1_array_crystal_array_3_focus_aw = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_17_analyzer_1_array_crystal_array_3_focus_ah = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_17_analyzer_1_array_crystal_array_3_focus_xw = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_17_analyzer_1_array_crystal_array_3_focus_xh = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_17_analyzer_1_array_crystal_array_3_focus_r = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_17_analyzer_1_array_crystal_array_3_p_interact = 0;
#line 71 "MACS_sample_kidney_box.instr"
  if(0) strncpy(mccchannel_17_analyzer_1_array_crystal_array_3_mask_string, 0 ? 0 : "", 16384); else mccchannel_17_analyzer_1_array_crystal_array_3_mask_string[0]='\0';
#line 71 "MACS_sample_kidney_box.instr"
  if(0) strncpy(mccchannel_17_analyzer_1_array_crystal_array_3_mask_setting, 0 ? 0 : "", 16384); else mccchannel_17_analyzer_1_array_crystal_array_3_mask_setting[0]='\0';
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_17_analyzer_1_array_crystal_array_3_number_of_activations = 1;
#line 142657 "MACS_sample_kidney_box.c"

  SIG_MESSAGE("channel_17_analyzer_1_array_crystal_array_3 (Init:Place/Rotate)");
  rot_set_rotation(mctr1,
#line 4346 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 4346 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 4346 "MACS_sample_kidney_box.instr"
    (0 - RAD2DEG * channel_17_analyzer_1_array_theta [ 3 ])*DEG2RAD);
#line 142667 "MACS_sample_kidney_box.c"
  rot_mul(mctr1, mcrotachannel_17_analyzer_1_rotated, mcrotachannel_17_analyzer_1_array_crystal_array_3);
  rot_transpose(mcrotachannel_17_analyzer_1_array_crystal_array_2, mctr1);
  rot_mul(mcrotachannel_17_analyzer_1_array_crystal_array_3, mctr1, mcrotrchannel_17_analyzer_1_array_crystal_array_3);
  mctc1 = coords_set(
#line 4345 "MACS_sample_kidney_box.instr"
    0 + channel_17_analyzer_1_array_effective_radius_of_curvature * ( 1 - cos ( channel_17_analyzer_1_array_theta [ 3 ] ) ),
#line 4345 "MACS_sample_kidney_box.instr"
    0 + channel_17_analyzer_1_array_effective_radius_of_curvature * sin ( channel_17_analyzer_1_array_theta [ 3 ] ),
#line 4345 "MACS_sample_kidney_box.instr"
    0);
#line 142678 "MACS_sample_kidney_box.c"
  rot_transpose(mcrotachannel_17_analyzer_1_rotated, mctr1);
  mctc2 = rot_apply(mctr1, mctc1);
  mcposachannel_17_analyzer_1_array_crystal_array_3 = coords_add(mcposachannel_17_analyzer_1_rotated, mctc2);
  mctc1 = coords_sub(mcposachannel_17_analyzer_1_array_crystal_array_2, mcposachannel_17_analyzer_1_array_crystal_array_3);
  mcposrchannel_17_analyzer_1_array_crystal_array_3 = rot_apply(mcrotachannel_17_analyzer_1_array_crystal_array_3, mctc1);
  mcDEBUG_COMPONENT("channel_17_analyzer_1_array_crystal_array_3", mcposachannel_17_analyzer_1_array_crystal_array_3, mcrotachannel_17_analyzer_1_array_crystal_array_3)
  mccomp_posa[779] = mcposachannel_17_analyzer_1_array_crystal_array_3;
  mccomp_posr[779] = mcposrchannel_17_analyzer_1_array_crystal_array_3;
  mcNCounter[779]  = mcPCounter[779] = mcP2Counter[779] = 0;
  mcAbsorbProp[779]= 0;
    /* Component channel_17_analyzer_1_array_crystal_array_4. */
  /* Setting parameters for component channel_17_analyzer_1_array_crystal_array_4. */
  SIG_MESSAGE("channel_17_analyzer_1_array_crystal_array_4 (Init:SetPar)");
#line 4350 "MACS_sample_kidney_box.instr"
  if("PG_analyzer") strncpy(mccchannel_17_analyzer_1_array_crystal_array_4_material_string, "PG_analyzer" ? "PG_analyzer" : "", 16384); else mccchannel_17_analyzer_1_array_crystal_array_4_material_string[0]='\0';
#line 4350 "MACS_sample_kidney_box.instr"
  mccchannel_17_analyzer_1_array_crystal_array_4_priority = 1920.4;
#line 4349 "MACS_sample_kidney_box.instr"
  mccchannel_17_analyzer_1_array_crystal_array_4_xwidth = channel_17_analyzer_1_array_crystal_depth;
#line 4349 "MACS_sample_kidney_box.instr"
  mccchannel_17_analyzer_1_array_crystal_array_4_yheight = channel_17_analyzer_1_array_crystal_height;
#line 4349 "MACS_sample_kidney_box.instr"
  mccchannel_17_analyzer_1_array_crystal_array_4_zdepth = channel_17_analyzer_1_array_crystal_width;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_17_analyzer_1_array_crystal_array_4_xwidth2 = -1;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_17_analyzer_1_array_crystal_array_4_yheight2 = -1;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_17_analyzer_1_array_crystal_array_4_visualize = 1;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_17_analyzer_1_array_crystal_array_4_target_index = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_17_analyzer_1_array_crystal_array_4_target_x = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_17_analyzer_1_array_crystal_array_4_target_y = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_17_analyzer_1_array_crystal_array_4_target_z = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_17_analyzer_1_array_crystal_array_4_focus_aw = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_17_analyzer_1_array_crystal_array_4_focus_ah = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_17_analyzer_1_array_crystal_array_4_focus_xw = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_17_analyzer_1_array_crystal_array_4_focus_xh = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_17_analyzer_1_array_crystal_array_4_focus_r = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_17_analyzer_1_array_crystal_array_4_p_interact = 0;
#line 71 "MACS_sample_kidney_box.instr"
  if(0) strncpy(mccchannel_17_analyzer_1_array_crystal_array_4_mask_string, 0 ? 0 : "", 16384); else mccchannel_17_analyzer_1_array_crystal_array_4_mask_string[0]='\0';
#line 71 "MACS_sample_kidney_box.instr"
  if(0) strncpy(mccchannel_17_analyzer_1_array_crystal_array_4_mask_setting, 0 ? 0 : "", 16384); else mccchannel_17_analyzer_1_array_crystal_array_4_mask_setting[0]='\0';
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_17_analyzer_1_array_crystal_array_4_number_of_activations = 1;
#line 142734 "MACS_sample_kidney_box.c"

  SIG_MESSAGE("channel_17_analyzer_1_array_crystal_array_4 (Init:Place/Rotate)");
  rot_set_rotation(mctr1,
#line 4352 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 4352 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 4352 "MACS_sample_kidney_box.instr"
    (0 - RAD2DEG * channel_17_analyzer_1_array_theta [ 4 ])*DEG2RAD);
#line 142744 "MACS_sample_kidney_box.c"
  rot_mul(mctr1, mcrotachannel_17_analyzer_1_rotated, mcrotachannel_17_analyzer_1_array_crystal_array_4);
  rot_transpose(mcrotachannel_17_analyzer_1_array_crystal_array_3, mctr1);
  rot_mul(mcrotachannel_17_analyzer_1_array_crystal_array_4, mctr1, mcrotrchannel_17_analyzer_1_array_crystal_array_4);
  mctc1 = coords_set(
#line 4351 "MACS_sample_kidney_box.instr"
    0 + channel_17_analyzer_1_array_effective_radius_of_curvature * ( 1 - cos ( channel_17_analyzer_1_array_theta [ 4 ] ) ),
#line 4351 "MACS_sample_kidney_box.instr"
    0 + channel_17_analyzer_1_array_effective_radius_of_curvature * sin ( channel_17_analyzer_1_array_theta [ 4 ] ),
#line 4351 "MACS_sample_kidney_box.instr"
    0);
#line 142755 "MACS_sample_kidney_box.c"
  rot_transpose(mcrotachannel_17_analyzer_1_rotated, mctr1);
  mctc2 = rot_apply(mctr1, mctc1);
  mcposachannel_17_analyzer_1_array_crystal_array_4 = coords_add(mcposachannel_17_analyzer_1_rotated, mctc2);
  mctc1 = coords_sub(mcposachannel_17_analyzer_1_array_crystal_array_3, mcposachannel_17_analyzer_1_array_crystal_array_4);
  mcposrchannel_17_analyzer_1_array_crystal_array_4 = rot_apply(mcrotachannel_17_analyzer_1_array_crystal_array_4, mctc1);
  mcDEBUG_COMPONENT("channel_17_analyzer_1_array_crystal_array_4", mcposachannel_17_analyzer_1_array_crystal_array_4, mcrotachannel_17_analyzer_1_array_crystal_array_4)
  mccomp_posa[780] = mcposachannel_17_analyzer_1_array_crystal_array_4;
  mccomp_posr[780] = mcposrchannel_17_analyzer_1_array_crystal_array_4;
  mcNCounter[780]  = mcPCounter[780] = mcP2Counter[780] = 0;
  mcAbsorbProp[780]= 0;
    /* Component channel_17_analyzer_1_array_crystal_array_5. */
  /* Setting parameters for component channel_17_analyzer_1_array_crystal_array_5. */
  SIG_MESSAGE("channel_17_analyzer_1_array_crystal_array_5 (Init:SetPar)");
#line 4356 "MACS_sample_kidney_box.instr"
  if("PG_analyzer") strncpy(mccchannel_17_analyzer_1_array_crystal_array_5_material_string, "PG_analyzer" ? "PG_analyzer" : "", 16384); else mccchannel_17_analyzer_1_array_crystal_array_5_material_string[0]='\0';
#line 4356 "MACS_sample_kidney_box.instr"
  mccchannel_17_analyzer_1_array_crystal_array_5_priority = 1920.5;
#line 4355 "MACS_sample_kidney_box.instr"
  mccchannel_17_analyzer_1_array_crystal_array_5_xwidth = channel_17_analyzer_1_array_crystal_depth;
#line 4355 "MACS_sample_kidney_box.instr"
  mccchannel_17_analyzer_1_array_crystal_array_5_yheight = channel_17_analyzer_1_array_crystal_height;
#line 4355 "MACS_sample_kidney_box.instr"
  mccchannel_17_analyzer_1_array_crystal_array_5_zdepth = channel_17_analyzer_1_array_crystal_width;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_17_analyzer_1_array_crystal_array_5_xwidth2 = -1;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_17_analyzer_1_array_crystal_array_5_yheight2 = -1;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_17_analyzer_1_array_crystal_array_5_visualize = 1;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_17_analyzer_1_array_crystal_array_5_target_index = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_17_analyzer_1_array_crystal_array_5_target_x = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_17_analyzer_1_array_crystal_array_5_target_y = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_17_analyzer_1_array_crystal_array_5_target_z = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_17_analyzer_1_array_crystal_array_5_focus_aw = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_17_analyzer_1_array_crystal_array_5_focus_ah = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_17_analyzer_1_array_crystal_array_5_focus_xw = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_17_analyzer_1_array_crystal_array_5_focus_xh = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_17_analyzer_1_array_crystal_array_5_focus_r = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_17_analyzer_1_array_crystal_array_5_p_interact = 0;
#line 71 "MACS_sample_kidney_box.instr"
  if(0) strncpy(mccchannel_17_analyzer_1_array_crystal_array_5_mask_string, 0 ? 0 : "", 16384); else mccchannel_17_analyzer_1_array_crystal_array_5_mask_string[0]='\0';
#line 71 "MACS_sample_kidney_box.instr"
  if(0) strncpy(mccchannel_17_analyzer_1_array_crystal_array_5_mask_setting, 0 ? 0 : "", 16384); else mccchannel_17_analyzer_1_array_crystal_array_5_mask_setting[0]='\0';
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_17_analyzer_1_array_crystal_array_5_number_of_activations = 1;
#line 142811 "MACS_sample_kidney_box.c"

  SIG_MESSAGE("channel_17_analyzer_1_array_crystal_array_5 (Init:Place/Rotate)");
  rot_set_rotation(mctr1,
#line 4358 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 4358 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 4358 "MACS_sample_kidney_box.instr"
    (0 - RAD2DEG * channel_17_analyzer_1_array_theta [ 5 ])*DEG2RAD);
#line 142821 "MACS_sample_kidney_box.c"
  rot_mul(mctr1, mcrotachannel_17_analyzer_1_rotated, mcrotachannel_17_analyzer_1_array_crystal_array_5);
  rot_transpose(mcrotachannel_17_analyzer_1_array_crystal_array_4, mctr1);
  rot_mul(mcrotachannel_17_analyzer_1_array_crystal_array_5, mctr1, mcrotrchannel_17_analyzer_1_array_crystal_array_5);
  mctc1 = coords_set(
#line 4357 "MACS_sample_kidney_box.instr"
    0 + channel_17_analyzer_1_array_effective_radius_of_curvature * ( 1 - cos ( channel_17_analyzer_1_array_theta [ 5 ] ) ),
#line 4357 "MACS_sample_kidney_box.instr"
    0 + channel_17_analyzer_1_array_effective_radius_of_curvature * sin ( channel_17_analyzer_1_array_theta [ 5 ] ),
#line 4357 "MACS_sample_kidney_box.instr"
    0);
#line 142832 "MACS_sample_kidney_box.c"
  rot_transpose(mcrotachannel_17_analyzer_1_rotated, mctr1);
  mctc2 = rot_apply(mctr1, mctc1);
  mcposachannel_17_analyzer_1_array_crystal_array_5 = coords_add(mcposachannel_17_analyzer_1_rotated, mctc2);
  mctc1 = coords_sub(mcposachannel_17_analyzer_1_array_crystal_array_4, mcposachannel_17_analyzer_1_array_crystal_array_5);
  mcposrchannel_17_analyzer_1_array_crystal_array_5 = rot_apply(mcrotachannel_17_analyzer_1_array_crystal_array_5, mctc1);
  mcDEBUG_COMPONENT("channel_17_analyzer_1_array_crystal_array_5", mcposachannel_17_analyzer_1_array_crystal_array_5, mcrotachannel_17_analyzer_1_array_crystal_array_5)
  mccomp_posa[781] = mcposachannel_17_analyzer_1_array_crystal_array_5;
  mccomp_posr[781] = mcposrchannel_17_analyzer_1_array_crystal_array_5;
  mcNCounter[781]  = mcPCounter[781] = mcP2Counter[781] = 0;
  mcAbsorbProp[781]= 0;
    /* Component channel_17_analyzer_1_array_crystal_array_6. */
  /* Setting parameters for component channel_17_analyzer_1_array_crystal_array_6. */
  SIG_MESSAGE("channel_17_analyzer_1_array_crystal_array_6 (Init:SetPar)");
#line 4362 "MACS_sample_kidney_box.instr"
  if("PG_analyzer") strncpy(mccchannel_17_analyzer_1_array_crystal_array_6_material_string, "PG_analyzer" ? "PG_analyzer" : "", 16384); else mccchannel_17_analyzer_1_array_crystal_array_6_material_string[0]='\0';
#line 4362 "MACS_sample_kidney_box.instr"
  mccchannel_17_analyzer_1_array_crystal_array_6_priority = 1920.6;
#line 4361 "MACS_sample_kidney_box.instr"
  mccchannel_17_analyzer_1_array_crystal_array_6_xwidth = channel_17_analyzer_1_array_crystal_depth;
#line 4361 "MACS_sample_kidney_box.instr"
  mccchannel_17_analyzer_1_array_crystal_array_6_yheight = channel_17_analyzer_1_array_crystal_height;
#line 4361 "MACS_sample_kidney_box.instr"
  mccchannel_17_analyzer_1_array_crystal_array_6_zdepth = channel_17_analyzer_1_array_crystal_width;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_17_analyzer_1_array_crystal_array_6_xwidth2 = -1;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_17_analyzer_1_array_crystal_array_6_yheight2 = -1;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_17_analyzer_1_array_crystal_array_6_visualize = 1;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_17_analyzer_1_array_crystal_array_6_target_index = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_17_analyzer_1_array_crystal_array_6_target_x = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_17_analyzer_1_array_crystal_array_6_target_y = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_17_analyzer_1_array_crystal_array_6_target_z = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_17_analyzer_1_array_crystal_array_6_focus_aw = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_17_analyzer_1_array_crystal_array_6_focus_ah = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_17_analyzer_1_array_crystal_array_6_focus_xw = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_17_analyzer_1_array_crystal_array_6_focus_xh = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_17_analyzer_1_array_crystal_array_6_focus_r = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_17_analyzer_1_array_crystal_array_6_p_interact = 0;
#line 71 "MACS_sample_kidney_box.instr"
  if(0) strncpy(mccchannel_17_analyzer_1_array_crystal_array_6_mask_string, 0 ? 0 : "", 16384); else mccchannel_17_analyzer_1_array_crystal_array_6_mask_string[0]='\0';
#line 71 "MACS_sample_kidney_box.instr"
  if(0) strncpy(mccchannel_17_analyzer_1_array_crystal_array_6_mask_setting, 0 ? 0 : "", 16384); else mccchannel_17_analyzer_1_array_crystal_array_6_mask_setting[0]='\0';
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_17_analyzer_1_array_crystal_array_6_number_of_activations = 1;
#line 142888 "MACS_sample_kidney_box.c"

  SIG_MESSAGE("channel_17_analyzer_1_array_crystal_array_6 (Init:Place/Rotate)");
  rot_set_rotation(mctr1,
#line 4364 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 4364 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 4364 "MACS_sample_kidney_box.instr"
    (0 - RAD2DEG * channel_17_analyzer_1_array_theta [ 6 ])*DEG2RAD);
#line 142898 "MACS_sample_kidney_box.c"
  rot_mul(mctr1, mcrotachannel_17_analyzer_1_rotated, mcrotachannel_17_analyzer_1_array_crystal_array_6);
  rot_transpose(mcrotachannel_17_analyzer_1_array_crystal_array_5, mctr1);
  rot_mul(mcrotachannel_17_analyzer_1_array_crystal_array_6, mctr1, mcrotrchannel_17_analyzer_1_array_crystal_array_6);
  mctc1 = coords_set(
#line 4363 "MACS_sample_kidney_box.instr"
    0 + channel_17_analyzer_1_array_effective_radius_of_curvature * ( 1 - cos ( channel_17_analyzer_1_array_theta [ 6 ] ) ),
#line 4363 "MACS_sample_kidney_box.instr"
    0 + channel_17_analyzer_1_array_effective_radius_of_curvature * sin ( channel_17_analyzer_1_array_theta [ 6 ] ),
#line 4363 "MACS_sample_kidney_box.instr"
    0);
#line 142909 "MACS_sample_kidney_box.c"
  rot_transpose(mcrotachannel_17_analyzer_1_rotated, mctr1);
  mctc2 = rot_apply(mctr1, mctc1);
  mcposachannel_17_analyzer_1_array_crystal_array_6 = coords_add(mcposachannel_17_analyzer_1_rotated, mctc2);
  mctc1 = coords_sub(mcposachannel_17_analyzer_1_array_crystal_array_5, mcposachannel_17_analyzer_1_array_crystal_array_6);
  mcposrchannel_17_analyzer_1_array_crystal_array_6 = rot_apply(mcrotachannel_17_analyzer_1_array_crystal_array_6, mctc1);
  mcDEBUG_COMPONENT("channel_17_analyzer_1_array_crystal_array_6", mcposachannel_17_analyzer_1_array_crystal_array_6, mcrotachannel_17_analyzer_1_array_crystal_array_6)
  mccomp_posa[782] = mcposachannel_17_analyzer_1_array_crystal_array_6;
  mccomp_posr[782] = mcposrchannel_17_analyzer_1_array_crystal_array_6;
  mcNCounter[782]  = mcPCounter[782] = mcP2Counter[782] = 0;
  mcAbsorbProp[782]= 0;
    /* Component channel_17_analyzer_1_array_crystal_array_7. */
  /* Setting parameters for component channel_17_analyzer_1_array_crystal_array_7. */
  SIG_MESSAGE("channel_17_analyzer_1_array_crystal_array_7 (Init:SetPar)");
#line 4368 "MACS_sample_kidney_box.instr"
  if("PG_analyzer") strncpy(mccchannel_17_analyzer_1_array_crystal_array_7_material_string, "PG_analyzer" ? "PG_analyzer" : "", 16384); else mccchannel_17_analyzer_1_array_crystal_array_7_material_string[0]='\0';
#line 4368 "MACS_sample_kidney_box.instr"
  mccchannel_17_analyzer_1_array_crystal_array_7_priority = 1920.7;
#line 4367 "MACS_sample_kidney_box.instr"
  mccchannel_17_analyzer_1_array_crystal_array_7_xwidth = channel_17_analyzer_1_array_crystal_depth;
#line 4367 "MACS_sample_kidney_box.instr"
  mccchannel_17_analyzer_1_array_crystal_array_7_yheight = channel_17_analyzer_1_array_crystal_height;
#line 4367 "MACS_sample_kidney_box.instr"
  mccchannel_17_analyzer_1_array_crystal_array_7_zdepth = channel_17_analyzer_1_array_crystal_width;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_17_analyzer_1_array_crystal_array_7_xwidth2 = -1;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_17_analyzer_1_array_crystal_array_7_yheight2 = -1;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_17_analyzer_1_array_crystal_array_7_visualize = 1;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_17_analyzer_1_array_crystal_array_7_target_index = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_17_analyzer_1_array_crystal_array_7_target_x = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_17_analyzer_1_array_crystal_array_7_target_y = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_17_analyzer_1_array_crystal_array_7_target_z = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_17_analyzer_1_array_crystal_array_7_focus_aw = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_17_analyzer_1_array_crystal_array_7_focus_ah = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_17_analyzer_1_array_crystal_array_7_focus_xw = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_17_analyzer_1_array_crystal_array_7_focus_xh = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_17_analyzer_1_array_crystal_array_7_focus_r = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_17_analyzer_1_array_crystal_array_7_p_interact = 0;
#line 71 "MACS_sample_kidney_box.instr"
  if(0) strncpy(mccchannel_17_analyzer_1_array_crystal_array_7_mask_string, 0 ? 0 : "", 16384); else mccchannel_17_analyzer_1_array_crystal_array_7_mask_string[0]='\0';
#line 71 "MACS_sample_kidney_box.instr"
  if(0) strncpy(mccchannel_17_analyzer_1_array_crystal_array_7_mask_setting, 0 ? 0 : "", 16384); else mccchannel_17_analyzer_1_array_crystal_array_7_mask_setting[0]='\0';
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_17_analyzer_1_array_crystal_array_7_number_of_activations = 1;
#line 142965 "MACS_sample_kidney_box.c"

  SIG_MESSAGE("channel_17_analyzer_1_array_crystal_array_7 (Init:Place/Rotate)");
  rot_set_rotation(mctr1,
#line 4370 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 4370 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 4370 "MACS_sample_kidney_box.instr"
    (0 - RAD2DEG * channel_17_analyzer_1_array_theta [ 7 ])*DEG2RAD);
#line 142975 "MACS_sample_kidney_box.c"
  rot_mul(mctr1, mcrotachannel_17_analyzer_1_rotated, mcrotachannel_17_analyzer_1_array_crystal_array_7);
  rot_transpose(mcrotachannel_17_analyzer_1_array_crystal_array_6, mctr1);
  rot_mul(mcrotachannel_17_analyzer_1_array_crystal_array_7, mctr1, mcrotrchannel_17_analyzer_1_array_crystal_array_7);
  mctc1 = coords_set(
#line 4369 "MACS_sample_kidney_box.instr"
    0 + channel_17_analyzer_1_array_effective_radius_of_curvature * ( 1 - cos ( channel_17_analyzer_1_array_theta [ 7 ] ) ),
#line 4369 "MACS_sample_kidney_box.instr"
    0 + channel_17_analyzer_1_array_effective_radius_of_curvature * sin ( channel_17_analyzer_1_array_theta [ 7 ] ),
#line 4369 "MACS_sample_kidney_box.instr"
    0);
#line 142986 "MACS_sample_kidney_box.c"
  rot_transpose(mcrotachannel_17_analyzer_1_rotated, mctr1);
  mctc2 = rot_apply(mctr1, mctc1);
  mcposachannel_17_analyzer_1_array_crystal_array_7 = coords_add(mcposachannel_17_analyzer_1_rotated, mctc2);
  mctc1 = coords_sub(mcposachannel_17_analyzer_1_array_crystal_array_6, mcposachannel_17_analyzer_1_array_crystal_array_7);
  mcposrchannel_17_analyzer_1_array_crystal_array_7 = rot_apply(mcrotachannel_17_analyzer_1_array_crystal_array_7, mctc1);
  mcDEBUG_COMPONENT("channel_17_analyzer_1_array_crystal_array_7", mcposachannel_17_analyzer_1_array_crystal_array_7, mcrotachannel_17_analyzer_1_array_crystal_array_7)
  mccomp_posa[783] = mcposachannel_17_analyzer_1_array_crystal_array_7;
  mccomp_posr[783] = mcposrchannel_17_analyzer_1_array_crystal_array_7;
  mcNCounter[783]  = mcPCounter[783] = mcP2Counter[783] = 0;
  mcAbsorbProp[783]= 0;
    /* Component channel_17_analyzer_1_array_crystal_array_8. */
  /* Setting parameters for component channel_17_analyzer_1_array_crystal_array_8. */
  SIG_MESSAGE("channel_17_analyzer_1_array_crystal_array_8 (Init:SetPar)");
#line 4374 "MACS_sample_kidney_box.instr"
  if("PG_analyzer") strncpy(mccchannel_17_analyzer_1_array_crystal_array_8_material_string, "PG_analyzer" ? "PG_analyzer" : "", 16384); else mccchannel_17_analyzer_1_array_crystal_array_8_material_string[0]='\0';
#line 4374 "MACS_sample_kidney_box.instr"
  mccchannel_17_analyzer_1_array_crystal_array_8_priority = 1920.8;
#line 4373 "MACS_sample_kidney_box.instr"
  mccchannel_17_analyzer_1_array_crystal_array_8_xwidth = channel_17_analyzer_1_array_crystal_depth;
#line 4373 "MACS_sample_kidney_box.instr"
  mccchannel_17_analyzer_1_array_crystal_array_8_yheight = channel_17_analyzer_1_array_crystal_height;
#line 4373 "MACS_sample_kidney_box.instr"
  mccchannel_17_analyzer_1_array_crystal_array_8_zdepth = channel_17_analyzer_1_array_crystal_width;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_17_analyzer_1_array_crystal_array_8_xwidth2 = -1;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_17_analyzer_1_array_crystal_array_8_yheight2 = -1;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_17_analyzer_1_array_crystal_array_8_visualize = 1;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_17_analyzer_1_array_crystal_array_8_target_index = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_17_analyzer_1_array_crystal_array_8_target_x = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_17_analyzer_1_array_crystal_array_8_target_y = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_17_analyzer_1_array_crystal_array_8_target_z = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_17_analyzer_1_array_crystal_array_8_focus_aw = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_17_analyzer_1_array_crystal_array_8_focus_ah = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_17_analyzer_1_array_crystal_array_8_focus_xw = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_17_analyzer_1_array_crystal_array_8_focus_xh = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_17_analyzer_1_array_crystal_array_8_focus_r = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_17_analyzer_1_array_crystal_array_8_p_interact = 0;
#line 71 "MACS_sample_kidney_box.instr"
  if(0) strncpy(mccchannel_17_analyzer_1_array_crystal_array_8_mask_string, 0 ? 0 : "", 16384); else mccchannel_17_analyzer_1_array_crystal_array_8_mask_string[0]='\0';
#line 71 "MACS_sample_kidney_box.instr"
  if(0) strncpy(mccchannel_17_analyzer_1_array_crystal_array_8_mask_setting, 0 ? 0 : "", 16384); else mccchannel_17_analyzer_1_array_crystal_array_8_mask_setting[0]='\0';
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_17_analyzer_1_array_crystal_array_8_number_of_activations = 1;
#line 143042 "MACS_sample_kidney_box.c"

  SIG_MESSAGE("channel_17_analyzer_1_array_crystal_array_8 (Init:Place/Rotate)");
  rot_set_rotation(mctr1,
#line 4376 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 4376 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 4376 "MACS_sample_kidney_box.instr"
    (0 - RAD2DEG * channel_17_analyzer_1_array_theta [ 8 ])*DEG2RAD);
#line 143052 "MACS_sample_kidney_box.c"
  rot_mul(mctr1, mcrotachannel_17_analyzer_1_rotated, mcrotachannel_17_analyzer_1_array_crystal_array_8);
  rot_transpose(mcrotachannel_17_analyzer_1_array_crystal_array_7, mctr1);
  rot_mul(mcrotachannel_17_analyzer_1_array_crystal_array_8, mctr1, mcrotrchannel_17_analyzer_1_array_crystal_array_8);
  mctc1 = coords_set(
#line 4375 "MACS_sample_kidney_box.instr"
    0 + channel_17_analyzer_1_array_effective_radius_of_curvature * ( 1 - cos ( channel_17_analyzer_1_array_theta [ 8 ] ) ),
#line 4375 "MACS_sample_kidney_box.instr"
    0 + channel_17_analyzer_1_array_effective_radius_of_curvature * sin ( channel_17_analyzer_1_array_theta [ 8 ] ),
#line 4375 "MACS_sample_kidney_box.instr"
    0);
#line 143063 "MACS_sample_kidney_box.c"
  rot_transpose(mcrotachannel_17_analyzer_1_rotated, mctr1);
  mctc2 = rot_apply(mctr1, mctc1);
  mcposachannel_17_analyzer_1_array_crystal_array_8 = coords_add(mcposachannel_17_analyzer_1_rotated, mctc2);
  mctc1 = coords_sub(mcposachannel_17_analyzer_1_array_crystal_array_7, mcposachannel_17_analyzer_1_array_crystal_array_8);
  mcposrchannel_17_analyzer_1_array_crystal_array_8 = rot_apply(mcrotachannel_17_analyzer_1_array_crystal_array_8, mctc1);
  mcDEBUG_COMPONENT("channel_17_analyzer_1_array_crystal_array_8", mcposachannel_17_analyzer_1_array_crystal_array_8, mcrotachannel_17_analyzer_1_array_crystal_array_8)
  mccomp_posa[784] = mcposachannel_17_analyzer_1_array_crystal_array_8;
  mccomp_posr[784] = mcposrchannel_17_analyzer_1_array_crystal_array_8;
  mcNCounter[784]  = mcPCounter[784] = mcP2Counter[784] = 0;
  mcAbsorbProp[784]= 0;
    /* Component channel_17_analyzer_2_center. */
  /* Setting parameters for component channel_17_analyzer_2_center. */
  SIG_MESSAGE("channel_17_analyzer_2_center (Init:SetPar)");

  SIG_MESSAGE("channel_17_analyzer_2_center (Init:Place/Rotate)");
  rot_set_rotation(mctr1,
    (0.0)*DEG2RAD,
    (0.0)*DEG2RAD,
    (0.0)*DEG2RAD);
#line 143083 "MACS_sample_kidney_box.c"
  rot_mul(mctr1, mcrotachannel_17_analyzer_1_center, mcrotachannel_17_analyzer_2_center);
  rot_transpose(mcrotachannel_17_analyzer_1_array_crystal_array_8, mctr1);
  rot_mul(mcrotachannel_17_analyzer_2_center, mctr1, mcrotrchannel_17_analyzer_2_center);
  mctc1 = coords_set(
#line 4380 "MACS_sample_kidney_box.instr"
    - analyzer_seperation,
#line 4380 "MACS_sample_kidney_box.instr"
    0,
#line 4380 "MACS_sample_kidney_box.instr"
    0);
#line 143094 "MACS_sample_kidney_box.c"
  rot_transpose(mcrotachannel_17_analyzer_1_center, mctr1);
  mctc2 = rot_apply(mctr1, mctc1);
  mcposachannel_17_analyzer_2_center = coords_add(mcposachannel_17_analyzer_1_center, mctc2);
  mctc1 = coords_sub(mcposachannel_17_analyzer_1_array_crystal_array_8, mcposachannel_17_analyzer_2_center);
  mcposrchannel_17_analyzer_2_center = rot_apply(mcrotachannel_17_analyzer_2_center, mctc1);
  mcDEBUG_COMPONENT("channel_17_analyzer_2_center", mcposachannel_17_analyzer_2_center, mcrotachannel_17_analyzer_2_center)
  mccomp_posa[785] = mcposachannel_17_analyzer_2_center;
  mccomp_posr[785] = mcposrchannel_17_analyzer_2_center;
  mcNCounter[785]  = mcPCounter[785] = mcP2Counter[785] = 0;
  mcAbsorbProp[785]= 0;
    /* Component channel_17_analyzer_2_rotated. */
  /* Setting parameters for component channel_17_analyzer_2_rotated. */
  SIG_MESSAGE("channel_17_analyzer_2_rotated (Init:SetPar)");

  SIG_MESSAGE("channel_17_analyzer_2_rotated (Init:Place/Rotate)");
  rot_set_rotation(mctr1,
#line 4384 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 4384 "MACS_sample_kidney_box.instr"
    (- analyzer_theta [ 17 ])*DEG2RAD,
#line 4384 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD);
#line 143117 "MACS_sample_kidney_box.c"
  rot_mul(mctr1, mcrotachannel_17_analyzer_2_center, mcrotachannel_17_analyzer_2_rotated);
  rot_transpose(mcrotachannel_17_analyzer_2_center, mctr1);
  rot_mul(mcrotachannel_17_analyzer_2_rotated, mctr1, mcrotrchannel_17_analyzer_2_rotated);
  mctc1 = coords_set(
#line 4383 "MACS_sample_kidney_box.instr"
    0,
#line 4383 "MACS_sample_kidney_box.instr"
    0,
#line 4383 "MACS_sample_kidney_box.instr"
    0.5 * analyzer_seperation / tan ( analyzer_2theta [ 17 ] * DEG2RAD ));
#line 143128 "MACS_sample_kidney_box.c"
  rot_transpose(mcrotachannel_17_analyzer_2_center, mctr1);
  mctc2 = rot_apply(mctr1, mctc1);
  mcposachannel_17_analyzer_2_rotated = coords_add(mcposachannel_17_analyzer_2_center, mctc2);
  mctc1 = coords_sub(mcposachannel_17_analyzer_2_center, mcposachannel_17_analyzer_2_rotated);
  mcposrchannel_17_analyzer_2_rotated = rot_apply(mcrotachannel_17_analyzer_2_rotated, mctc1);
  mcDEBUG_COMPONENT("channel_17_analyzer_2_rotated", mcposachannel_17_analyzer_2_rotated, mcrotachannel_17_analyzer_2_rotated)
  mccomp_posa[786] = mcposachannel_17_analyzer_2_rotated;
  mccomp_posr[786] = mcposrchannel_17_analyzer_2_rotated;
  mcNCounter[786]  = mcPCounter[786] = mcP2Counter[786] = 0;
  mcAbsorbProp[786]= 0;
    /* Component channel_17_analyzer_2_array_crystal_array_0. */
  /* Setting parameters for component channel_17_analyzer_2_array_crystal_array_0. */
  SIG_MESSAGE("channel_17_analyzer_2_array_crystal_array_0 (Init:SetPar)");
#line 4388 "MACS_sample_kidney_box.instr"
  if("PG_analyzer") strncpy(mccchannel_17_analyzer_2_array_crystal_array_0_material_string, "PG_analyzer" ? "PG_analyzer" : "", 16384); else mccchannel_17_analyzer_2_array_crystal_array_0_material_string[0]='\0';
#line 4388 "MACS_sample_kidney_box.instr"
  mccchannel_17_analyzer_2_array_crystal_array_0_priority = 1921.0;
#line 4387 "MACS_sample_kidney_box.instr"
  mccchannel_17_analyzer_2_array_crystal_array_0_xwidth = channel_17_analyzer_2_array_crystal_depth;
#line 4387 "MACS_sample_kidney_box.instr"
  mccchannel_17_analyzer_2_array_crystal_array_0_yheight = channel_17_analyzer_2_array_crystal_height;
#line 4387 "MACS_sample_kidney_box.instr"
  mccchannel_17_analyzer_2_array_crystal_array_0_zdepth = channel_17_analyzer_2_array_crystal_width;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_17_analyzer_2_array_crystal_array_0_xwidth2 = -1;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_17_analyzer_2_array_crystal_array_0_yheight2 = -1;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_17_analyzer_2_array_crystal_array_0_visualize = 1;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_17_analyzer_2_array_crystal_array_0_target_index = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_17_analyzer_2_array_crystal_array_0_target_x = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_17_analyzer_2_array_crystal_array_0_target_y = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_17_analyzer_2_array_crystal_array_0_target_z = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_17_analyzer_2_array_crystal_array_0_focus_aw = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_17_analyzer_2_array_crystal_array_0_focus_ah = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_17_analyzer_2_array_crystal_array_0_focus_xw = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_17_analyzer_2_array_crystal_array_0_focus_xh = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_17_analyzer_2_array_crystal_array_0_focus_r = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_17_analyzer_2_array_crystal_array_0_p_interact = 0;
#line 71 "MACS_sample_kidney_box.instr"
  if(0) strncpy(mccchannel_17_analyzer_2_array_crystal_array_0_mask_string, 0 ? 0 : "", 16384); else mccchannel_17_analyzer_2_array_crystal_array_0_mask_string[0]='\0';
#line 71 "MACS_sample_kidney_box.instr"
  if(0) strncpy(mccchannel_17_analyzer_2_array_crystal_array_0_mask_setting, 0 ? 0 : "", 16384); else mccchannel_17_analyzer_2_array_crystal_array_0_mask_setting[0]='\0';
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_17_analyzer_2_array_crystal_array_0_number_of_activations = 1;
#line 143184 "MACS_sample_kidney_box.c"

  SIG_MESSAGE("channel_17_analyzer_2_array_crystal_array_0 (Init:Place/Rotate)");
  rot_set_rotation(mctr1,
#line 4390 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 4390 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 4390 "MACS_sample_kidney_box.instr"
    (0 - RAD2DEG * channel_17_analyzer_2_array_theta [ 0 ])*DEG2RAD);
#line 143194 "MACS_sample_kidney_box.c"
  rot_mul(mctr1, mcrotachannel_17_analyzer_2_rotated, mcrotachannel_17_analyzer_2_array_crystal_array_0);
  rot_transpose(mcrotachannel_17_analyzer_2_rotated, mctr1);
  rot_mul(mcrotachannel_17_analyzer_2_array_crystal_array_0, mctr1, mcrotrchannel_17_analyzer_2_array_crystal_array_0);
  mctc1 = coords_set(
#line 4389 "MACS_sample_kidney_box.instr"
    0 + channel_17_analyzer_2_array_effective_radius_of_curvature * ( 1 - cos ( channel_17_analyzer_2_array_theta [ 0 ] ) ),
#line 4389 "MACS_sample_kidney_box.instr"
    0 + channel_17_analyzer_2_array_effective_radius_of_curvature * sin ( channel_17_analyzer_2_array_theta [ 0 ] ),
#line 4389 "MACS_sample_kidney_box.instr"
    0);
#line 143205 "MACS_sample_kidney_box.c"
  rot_transpose(mcrotachannel_17_analyzer_2_rotated, mctr1);
  mctc2 = rot_apply(mctr1, mctc1);
  mcposachannel_17_analyzer_2_array_crystal_array_0 = coords_add(mcposachannel_17_analyzer_2_rotated, mctc2);
  mctc1 = coords_sub(mcposachannel_17_analyzer_2_rotated, mcposachannel_17_analyzer_2_array_crystal_array_0);
  mcposrchannel_17_analyzer_2_array_crystal_array_0 = rot_apply(mcrotachannel_17_analyzer_2_array_crystal_array_0, mctc1);
  mcDEBUG_COMPONENT("channel_17_analyzer_2_array_crystal_array_0", mcposachannel_17_analyzer_2_array_crystal_array_0, mcrotachannel_17_analyzer_2_array_crystal_array_0)
  mccomp_posa[787] = mcposachannel_17_analyzer_2_array_crystal_array_0;
  mccomp_posr[787] = mcposrchannel_17_analyzer_2_array_crystal_array_0;
  mcNCounter[787]  = mcPCounter[787] = mcP2Counter[787] = 0;
  mcAbsorbProp[787]= 0;
    /* Component channel_17_analyzer_2_array_crystal_array_1. */
  /* Setting parameters for component channel_17_analyzer_2_array_crystal_array_1. */
  SIG_MESSAGE("channel_17_analyzer_2_array_crystal_array_1 (Init:SetPar)");
#line 4394 "MACS_sample_kidney_box.instr"
  if("PG_analyzer") strncpy(mccchannel_17_analyzer_2_array_crystal_array_1_material_string, "PG_analyzer" ? "PG_analyzer" : "", 16384); else mccchannel_17_analyzer_2_array_crystal_array_1_material_string[0]='\0';
#line 4394 "MACS_sample_kidney_box.instr"
  mccchannel_17_analyzer_2_array_crystal_array_1_priority = 1921.1;
#line 4393 "MACS_sample_kidney_box.instr"
  mccchannel_17_analyzer_2_array_crystal_array_1_xwidth = channel_17_analyzer_2_array_crystal_depth;
#line 4393 "MACS_sample_kidney_box.instr"
  mccchannel_17_analyzer_2_array_crystal_array_1_yheight = channel_17_analyzer_2_array_crystal_height;
#line 4393 "MACS_sample_kidney_box.instr"
  mccchannel_17_analyzer_2_array_crystal_array_1_zdepth = channel_17_analyzer_2_array_crystal_width;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_17_analyzer_2_array_crystal_array_1_xwidth2 = -1;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_17_analyzer_2_array_crystal_array_1_yheight2 = -1;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_17_analyzer_2_array_crystal_array_1_visualize = 1;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_17_analyzer_2_array_crystal_array_1_target_index = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_17_analyzer_2_array_crystal_array_1_target_x = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_17_analyzer_2_array_crystal_array_1_target_y = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_17_analyzer_2_array_crystal_array_1_target_z = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_17_analyzer_2_array_crystal_array_1_focus_aw = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_17_analyzer_2_array_crystal_array_1_focus_ah = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_17_analyzer_2_array_crystal_array_1_focus_xw = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_17_analyzer_2_array_crystal_array_1_focus_xh = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_17_analyzer_2_array_crystal_array_1_focus_r = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_17_analyzer_2_array_crystal_array_1_p_interact = 0;
#line 71 "MACS_sample_kidney_box.instr"
  if(0) strncpy(mccchannel_17_analyzer_2_array_crystal_array_1_mask_string, 0 ? 0 : "", 16384); else mccchannel_17_analyzer_2_array_crystal_array_1_mask_string[0]='\0';
#line 71 "MACS_sample_kidney_box.instr"
  if(0) strncpy(mccchannel_17_analyzer_2_array_crystal_array_1_mask_setting, 0 ? 0 : "", 16384); else mccchannel_17_analyzer_2_array_crystal_array_1_mask_setting[0]='\0';
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_17_analyzer_2_array_crystal_array_1_number_of_activations = 1;
#line 143261 "MACS_sample_kidney_box.c"

  SIG_MESSAGE("channel_17_analyzer_2_array_crystal_array_1 (Init:Place/Rotate)");
  rot_set_rotation(mctr1,
#line 4396 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 4396 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 4396 "MACS_sample_kidney_box.instr"
    (0 - RAD2DEG * channel_17_analyzer_2_array_theta [ 1 ])*DEG2RAD);
#line 143271 "MACS_sample_kidney_box.c"
  rot_mul(mctr1, mcrotachannel_17_analyzer_2_rotated, mcrotachannel_17_analyzer_2_array_crystal_array_1);
  rot_transpose(mcrotachannel_17_analyzer_2_array_crystal_array_0, mctr1);
  rot_mul(mcrotachannel_17_analyzer_2_array_crystal_array_1, mctr1, mcrotrchannel_17_analyzer_2_array_crystal_array_1);
  mctc1 = coords_set(
#line 4395 "MACS_sample_kidney_box.instr"
    0 + channel_17_analyzer_2_array_effective_radius_of_curvature * ( 1 - cos ( channel_17_analyzer_2_array_theta [ 1 ] ) ),
#line 4395 "MACS_sample_kidney_box.instr"
    0 + channel_17_analyzer_2_array_effective_radius_of_curvature * sin ( channel_17_analyzer_2_array_theta [ 1 ] ),
#line 4395 "MACS_sample_kidney_box.instr"
    0);
#line 143282 "MACS_sample_kidney_box.c"
  rot_transpose(mcrotachannel_17_analyzer_2_rotated, mctr1);
  mctc2 = rot_apply(mctr1, mctc1);
  mcposachannel_17_analyzer_2_array_crystal_array_1 = coords_add(mcposachannel_17_analyzer_2_rotated, mctc2);
  mctc1 = coords_sub(mcposachannel_17_analyzer_2_array_crystal_array_0, mcposachannel_17_analyzer_2_array_crystal_array_1);
  mcposrchannel_17_analyzer_2_array_crystal_array_1 = rot_apply(mcrotachannel_17_analyzer_2_array_crystal_array_1, mctc1);
  mcDEBUG_COMPONENT("channel_17_analyzer_2_array_crystal_array_1", mcposachannel_17_analyzer_2_array_crystal_array_1, mcrotachannel_17_analyzer_2_array_crystal_array_1)
  mccomp_posa[788] = mcposachannel_17_analyzer_2_array_crystal_array_1;
  mccomp_posr[788] = mcposrchannel_17_analyzer_2_array_crystal_array_1;
  mcNCounter[788]  = mcPCounter[788] = mcP2Counter[788] = 0;
  mcAbsorbProp[788]= 0;
    /* Component channel_17_analyzer_2_array_crystal_array_2. */
  /* Setting parameters for component channel_17_analyzer_2_array_crystal_array_2. */
  SIG_MESSAGE("channel_17_analyzer_2_array_crystal_array_2 (Init:SetPar)");
#line 4400 "MACS_sample_kidney_box.instr"
  if("PG_analyzer") strncpy(mccchannel_17_analyzer_2_array_crystal_array_2_material_string, "PG_analyzer" ? "PG_analyzer" : "", 16384); else mccchannel_17_analyzer_2_array_crystal_array_2_material_string[0]='\0';
#line 4400 "MACS_sample_kidney_box.instr"
  mccchannel_17_analyzer_2_array_crystal_array_2_priority = 1921.2;
#line 4399 "MACS_sample_kidney_box.instr"
  mccchannel_17_analyzer_2_array_crystal_array_2_xwidth = channel_17_analyzer_2_array_crystal_depth;
#line 4399 "MACS_sample_kidney_box.instr"
  mccchannel_17_analyzer_2_array_crystal_array_2_yheight = channel_17_analyzer_2_array_crystal_height;
#line 4399 "MACS_sample_kidney_box.instr"
  mccchannel_17_analyzer_2_array_crystal_array_2_zdepth = channel_17_analyzer_2_array_crystal_width;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_17_analyzer_2_array_crystal_array_2_xwidth2 = -1;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_17_analyzer_2_array_crystal_array_2_yheight2 = -1;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_17_analyzer_2_array_crystal_array_2_visualize = 1;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_17_analyzer_2_array_crystal_array_2_target_index = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_17_analyzer_2_array_crystal_array_2_target_x = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_17_analyzer_2_array_crystal_array_2_target_y = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_17_analyzer_2_array_crystal_array_2_target_z = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_17_analyzer_2_array_crystal_array_2_focus_aw = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_17_analyzer_2_array_crystal_array_2_focus_ah = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_17_analyzer_2_array_crystal_array_2_focus_xw = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_17_analyzer_2_array_crystal_array_2_focus_xh = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_17_analyzer_2_array_crystal_array_2_focus_r = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_17_analyzer_2_array_crystal_array_2_p_interact = 0;
#line 71 "MACS_sample_kidney_box.instr"
  if(0) strncpy(mccchannel_17_analyzer_2_array_crystal_array_2_mask_string, 0 ? 0 : "", 16384); else mccchannel_17_analyzer_2_array_crystal_array_2_mask_string[0]='\0';
#line 71 "MACS_sample_kidney_box.instr"
  if(0) strncpy(mccchannel_17_analyzer_2_array_crystal_array_2_mask_setting, 0 ? 0 : "", 16384); else mccchannel_17_analyzer_2_array_crystal_array_2_mask_setting[0]='\0';
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_17_analyzer_2_array_crystal_array_2_number_of_activations = 1;
#line 143338 "MACS_sample_kidney_box.c"

  SIG_MESSAGE("channel_17_analyzer_2_array_crystal_array_2 (Init:Place/Rotate)");
  rot_set_rotation(mctr1,
#line 4402 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 4402 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 4402 "MACS_sample_kidney_box.instr"
    (0 - RAD2DEG * channel_17_analyzer_2_array_theta [ 2 ])*DEG2RAD);
#line 143348 "MACS_sample_kidney_box.c"
  rot_mul(mctr1, mcrotachannel_17_analyzer_2_rotated, mcrotachannel_17_analyzer_2_array_crystal_array_2);
  rot_transpose(mcrotachannel_17_analyzer_2_array_crystal_array_1, mctr1);
  rot_mul(mcrotachannel_17_analyzer_2_array_crystal_array_2, mctr1, mcrotrchannel_17_analyzer_2_array_crystal_array_2);
  mctc1 = coords_set(
#line 4401 "MACS_sample_kidney_box.instr"
    0 + channel_17_analyzer_2_array_effective_radius_of_curvature * ( 1 - cos ( channel_17_analyzer_2_array_theta [ 2 ] ) ),
#line 4401 "MACS_sample_kidney_box.instr"
    0 + channel_17_analyzer_2_array_effective_radius_of_curvature * sin ( channel_17_analyzer_2_array_theta [ 2 ] ),
#line 4401 "MACS_sample_kidney_box.instr"
    0);
#line 143359 "MACS_sample_kidney_box.c"
  rot_transpose(mcrotachannel_17_analyzer_2_rotated, mctr1);
  mctc2 = rot_apply(mctr1, mctc1);
  mcposachannel_17_analyzer_2_array_crystal_array_2 = coords_add(mcposachannel_17_analyzer_2_rotated, mctc2);
  mctc1 = coords_sub(mcposachannel_17_analyzer_2_array_crystal_array_1, mcposachannel_17_analyzer_2_array_crystal_array_2);
  mcposrchannel_17_analyzer_2_array_crystal_array_2 = rot_apply(mcrotachannel_17_analyzer_2_array_crystal_array_2, mctc1);
  mcDEBUG_COMPONENT("channel_17_analyzer_2_array_crystal_array_2", mcposachannel_17_analyzer_2_array_crystal_array_2, mcrotachannel_17_analyzer_2_array_crystal_array_2)
  mccomp_posa[789] = mcposachannel_17_analyzer_2_array_crystal_array_2;
  mccomp_posr[789] = mcposrchannel_17_analyzer_2_array_crystal_array_2;
  mcNCounter[789]  = mcPCounter[789] = mcP2Counter[789] = 0;
  mcAbsorbProp[789]= 0;
    /* Component channel_17_analyzer_2_array_crystal_array_3. */
  /* Setting parameters for component channel_17_analyzer_2_array_crystal_array_3. */
  SIG_MESSAGE("channel_17_analyzer_2_array_crystal_array_3 (Init:SetPar)");
#line 4406 "MACS_sample_kidney_box.instr"
  if("PG_analyzer") strncpy(mccchannel_17_analyzer_2_array_crystal_array_3_material_string, "PG_analyzer" ? "PG_analyzer" : "", 16384); else mccchannel_17_analyzer_2_array_crystal_array_3_material_string[0]='\0';
#line 4406 "MACS_sample_kidney_box.instr"
  mccchannel_17_analyzer_2_array_crystal_array_3_priority = 1921.3;
#line 4405 "MACS_sample_kidney_box.instr"
  mccchannel_17_analyzer_2_array_crystal_array_3_xwidth = channel_17_analyzer_2_array_crystal_depth;
#line 4405 "MACS_sample_kidney_box.instr"
  mccchannel_17_analyzer_2_array_crystal_array_3_yheight = channel_17_analyzer_2_array_crystal_height;
#line 4405 "MACS_sample_kidney_box.instr"
  mccchannel_17_analyzer_2_array_crystal_array_3_zdepth = channel_17_analyzer_2_array_crystal_width;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_17_analyzer_2_array_crystal_array_3_xwidth2 = -1;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_17_analyzer_2_array_crystal_array_3_yheight2 = -1;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_17_analyzer_2_array_crystal_array_3_visualize = 1;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_17_analyzer_2_array_crystal_array_3_target_index = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_17_analyzer_2_array_crystal_array_3_target_x = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_17_analyzer_2_array_crystal_array_3_target_y = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_17_analyzer_2_array_crystal_array_3_target_z = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_17_analyzer_2_array_crystal_array_3_focus_aw = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_17_analyzer_2_array_crystal_array_3_focus_ah = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_17_analyzer_2_array_crystal_array_3_focus_xw = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_17_analyzer_2_array_crystal_array_3_focus_xh = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_17_analyzer_2_array_crystal_array_3_focus_r = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_17_analyzer_2_array_crystal_array_3_p_interact = 0;
#line 71 "MACS_sample_kidney_box.instr"
  if(0) strncpy(mccchannel_17_analyzer_2_array_crystal_array_3_mask_string, 0 ? 0 : "", 16384); else mccchannel_17_analyzer_2_array_crystal_array_3_mask_string[0]='\0';
#line 71 "MACS_sample_kidney_box.instr"
  if(0) strncpy(mccchannel_17_analyzer_2_array_crystal_array_3_mask_setting, 0 ? 0 : "", 16384); else mccchannel_17_analyzer_2_array_crystal_array_3_mask_setting[0]='\0';
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_17_analyzer_2_array_crystal_array_3_number_of_activations = 1;
#line 143415 "MACS_sample_kidney_box.c"

  SIG_MESSAGE("channel_17_analyzer_2_array_crystal_array_3 (Init:Place/Rotate)");
  rot_set_rotation(mctr1,
#line 4408 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 4408 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 4408 "MACS_sample_kidney_box.instr"
    (0 - RAD2DEG * channel_17_analyzer_2_array_theta [ 3 ])*DEG2RAD);
#line 143425 "MACS_sample_kidney_box.c"
  rot_mul(mctr1, mcrotachannel_17_analyzer_2_rotated, mcrotachannel_17_analyzer_2_array_crystal_array_3);
  rot_transpose(mcrotachannel_17_analyzer_2_array_crystal_array_2, mctr1);
  rot_mul(mcrotachannel_17_analyzer_2_array_crystal_array_3, mctr1, mcrotrchannel_17_analyzer_2_array_crystal_array_3);
  mctc1 = coords_set(
#line 4407 "MACS_sample_kidney_box.instr"
    0 + channel_17_analyzer_2_array_effective_radius_of_curvature * ( 1 - cos ( channel_17_analyzer_2_array_theta [ 3 ] ) ),
#line 4407 "MACS_sample_kidney_box.instr"
    0 + channel_17_analyzer_2_array_effective_radius_of_curvature * sin ( channel_17_analyzer_2_array_theta [ 3 ] ),
#line 4407 "MACS_sample_kidney_box.instr"
    0);
#line 143436 "MACS_sample_kidney_box.c"
  rot_transpose(mcrotachannel_17_analyzer_2_rotated, mctr1);
  mctc2 = rot_apply(mctr1, mctc1);
  mcposachannel_17_analyzer_2_array_crystal_array_3 = coords_add(mcposachannel_17_analyzer_2_rotated, mctc2);
  mctc1 = coords_sub(mcposachannel_17_analyzer_2_array_crystal_array_2, mcposachannel_17_analyzer_2_array_crystal_array_3);
  mcposrchannel_17_analyzer_2_array_crystal_array_3 = rot_apply(mcrotachannel_17_analyzer_2_array_crystal_array_3, mctc1);
  mcDEBUG_COMPONENT("channel_17_analyzer_2_array_crystal_array_3", mcposachannel_17_analyzer_2_array_crystal_array_3, mcrotachannel_17_analyzer_2_array_crystal_array_3)
  mccomp_posa[790] = mcposachannel_17_analyzer_2_array_crystal_array_3;
  mccomp_posr[790] = mcposrchannel_17_analyzer_2_array_crystal_array_3;
  mcNCounter[790]  = mcPCounter[790] = mcP2Counter[790] = 0;
  mcAbsorbProp[790]= 0;
    /* Component channel_17_analyzer_2_array_crystal_array_4. */
  /* Setting parameters for component channel_17_analyzer_2_array_crystal_array_4. */
  SIG_MESSAGE("channel_17_analyzer_2_array_crystal_array_4 (Init:SetPar)");
#line 4412 "MACS_sample_kidney_box.instr"
  if("PG_analyzer") strncpy(mccchannel_17_analyzer_2_array_crystal_array_4_material_string, "PG_analyzer" ? "PG_analyzer" : "", 16384); else mccchannel_17_analyzer_2_array_crystal_array_4_material_string[0]='\0';
#line 4412 "MACS_sample_kidney_box.instr"
  mccchannel_17_analyzer_2_array_crystal_array_4_priority = 1921.4;
#line 4411 "MACS_sample_kidney_box.instr"
  mccchannel_17_analyzer_2_array_crystal_array_4_xwidth = channel_17_analyzer_2_array_crystal_depth;
#line 4411 "MACS_sample_kidney_box.instr"
  mccchannel_17_analyzer_2_array_crystal_array_4_yheight = channel_17_analyzer_2_array_crystal_height;
#line 4411 "MACS_sample_kidney_box.instr"
  mccchannel_17_analyzer_2_array_crystal_array_4_zdepth = channel_17_analyzer_2_array_crystal_width;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_17_analyzer_2_array_crystal_array_4_xwidth2 = -1;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_17_analyzer_2_array_crystal_array_4_yheight2 = -1;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_17_analyzer_2_array_crystal_array_4_visualize = 1;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_17_analyzer_2_array_crystal_array_4_target_index = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_17_analyzer_2_array_crystal_array_4_target_x = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_17_analyzer_2_array_crystal_array_4_target_y = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_17_analyzer_2_array_crystal_array_4_target_z = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_17_analyzer_2_array_crystal_array_4_focus_aw = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_17_analyzer_2_array_crystal_array_4_focus_ah = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_17_analyzer_2_array_crystal_array_4_focus_xw = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_17_analyzer_2_array_crystal_array_4_focus_xh = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_17_analyzer_2_array_crystal_array_4_focus_r = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_17_analyzer_2_array_crystal_array_4_p_interact = 0;
#line 71 "MACS_sample_kidney_box.instr"
  if(0) strncpy(mccchannel_17_analyzer_2_array_crystal_array_4_mask_string, 0 ? 0 : "", 16384); else mccchannel_17_analyzer_2_array_crystal_array_4_mask_string[0]='\0';
#line 71 "MACS_sample_kidney_box.instr"
  if(0) strncpy(mccchannel_17_analyzer_2_array_crystal_array_4_mask_setting, 0 ? 0 : "", 16384); else mccchannel_17_analyzer_2_array_crystal_array_4_mask_setting[0]='\0';
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_17_analyzer_2_array_crystal_array_4_number_of_activations = 1;
#line 143492 "MACS_sample_kidney_box.c"

  SIG_MESSAGE("channel_17_analyzer_2_array_crystal_array_4 (Init:Place/Rotate)");
  rot_set_rotation(mctr1,
#line 4414 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 4414 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 4414 "MACS_sample_kidney_box.instr"
    (0 - RAD2DEG * channel_17_analyzer_2_array_theta [ 4 ])*DEG2RAD);
#line 143502 "MACS_sample_kidney_box.c"
  rot_mul(mctr1, mcrotachannel_17_analyzer_2_rotated, mcrotachannel_17_analyzer_2_array_crystal_array_4);
  rot_transpose(mcrotachannel_17_analyzer_2_array_crystal_array_3, mctr1);
  rot_mul(mcrotachannel_17_analyzer_2_array_crystal_array_4, mctr1, mcrotrchannel_17_analyzer_2_array_crystal_array_4);
  mctc1 = coords_set(
#line 4413 "MACS_sample_kidney_box.instr"
    0 + channel_17_analyzer_2_array_effective_radius_of_curvature * ( 1 - cos ( channel_17_analyzer_2_array_theta [ 4 ] ) ),
#line 4413 "MACS_sample_kidney_box.instr"
    0 + channel_17_analyzer_2_array_effective_radius_of_curvature * sin ( channel_17_analyzer_2_array_theta [ 4 ] ),
#line 4413 "MACS_sample_kidney_box.instr"
    0);
#line 143513 "MACS_sample_kidney_box.c"
  rot_transpose(mcrotachannel_17_analyzer_2_rotated, mctr1);
  mctc2 = rot_apply(mctr1, mctc1);
  mcposachannel_17_analyzer_2_array_crystal_array_4 = coords_add(mcposachannel_17_analyzer_2_rotated, mctc2);
  mctc1 = coords_sub(mcposachannel_17_analyzer_2_array_crystal_array_3, mcposachannel_17_analyzer_2_array_crystal_array_4);
  mcposrchannel_17_analyzer_2_array_crystal_array_4 = rot_apply(mcrotachannel_17_analyzer_2_array_crystal_array_4, mctc1);
  mcDEBUG_COMPONENT("channel_17_analyzer_2_array_crystal_array_4", mcposachannel_17_analyzer_2_array_crystal_array_4, mcrotachannel_17_analyzer_2_array_crystal_array_4)
  mccomp_posa[791] = mcposachannel_17_analyzer_2_array_crystal_array_4;
  mccomp_posr[791] = mcposrchannel_17_analyzer_2_array_crystal_array_4;
  mcNCounter[791]  = mcPCounter[791] = mcP2Counter[791] = 0;
  mcAbsorbProp[791]= 0;
    /* Component channel_17_analyzer_2_array_crystal_array_5. */
  /* Setting parameters for component channel_17_analyzer_2_array_crystal_array_5. */
  SIG_MESSAGE("channel_17_analyzer_2_array_crystal_array_5 (Init:SetPar)");
#line 4418 "MACS_sample_kidney_box.instr"
  if("PG_analyzer") strncpy(mccchannel_17_analyzer_2_array_crystal_array_5_material_string, "PG_analyzer" ? "PG_analyzer" : "", 16384); else mccchannel_17_analyzer_2_array_crystal_array_5_material_string[0]='\0';
#line 4418 "MACS_sample_kidney_box.instr"
  mccchannel_17_analyzer_2_array_crystal_array_5_priority = 1921.5;
#line 4417 "MACS_sample_kidney_box.instr"
  mccchannel_17_analyzer_2_array_crystal_array_5_xwidth = channel_17_analyzer_2_array_crystal_depth;
#line 4417 "MACS_sample_kidney_box.instr"
  mccchannel_17_analyzer_2_array_crystal_array_5_yheight = channel_17_analyzer_2_array_crystal_height;
#line 4417 "MACS_sample_kidney_box.instr"
  mccchannel_17_analyzer_2_array_crystal_array_5_zdepth = channel_17_analyzer_2_array_crystal_width;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_17_analyzer_2_array_crystal_array_5_xwidth2 = -1;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_17_analyzer_2_array_crystal_array_5_yheight2 = -1;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_17_analyzer_2_array_crystal_array_5_visualize = 1;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_17_analyzer_2_array_crystal_array_5_target_index = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_17_analyzer_2_array_crystal_array_5_target_x = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_17_analyzer_2_array_crystal_array_5_target_y = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_17_analyzer_2_array_crystal_array_5_target_z = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_17_analyzer_2_array_crystal_array_5_focus_aw = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_17_analyzer_2_array_crystal_array_5_focus_ah = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_17_analyzer_2_array_crystal_array_5_focus_xw = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_17_analyzer_2_array_crystal_array_5_focus_xh = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_17_analyzer_2_array_crystal_array_5_focus_r = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_17_analyzer_2_array_crystal_array_5_p_interact = 0;
#line 71 "MACS_sample_kidney_box.instr"
  if(0) strncpy(mccchannel_17_analyzer_2_array_crystal_array_5_mask_string, 0 ? 0 : "", 16384); else mccchannel_17_analyzer_2_array_crystal_array_5_mask_string[0]='\0';
#line 71 "MACS_sample_kidney_box.instr"
  if(0) strncpy(mccchannel_17_analyzer_2_array_crystal_array_5_mask_setting, 0 ? 0 : "", 16384); else mccchannel_17_analyzer_2_array_crystal_array_5_mask_setting[0]='\0';
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_17_analyzer_2_array_crystal_array_5_number_of_activations = 1;
#line 143569 "MACS_sample_kidney_box.c"

  SIG_MESSAGE("channel_17_analyzer_2_array_crystal_array_5 (Init:Place/Rotate)");
  rot_set_rotation(mctr1,
#line 4420 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 4420 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 4420 "MACS_sample_kidney_box.instr"
    (0 - RAD2DEG * channel_17_analyzer_2_array_theta [ 5 ])*DEG2RAD);
#line 143579 "MACS_sample_kidney_box.c"
  rot_mul(mctr1, mcrotachannel_17_analyzer_2_rotated, mcrotachannel_17_analyzer_2_array_crystal_array_5);
  rot_transpose(mcrotachannel_17_analyzer_2_array_crystal_array_4, mctr1);
  rot_mul(mcrotachannel_17_analyzer_2_array_crystal_array_5, mctr1, mcrotrchannel_17_analyzer_2_array_crystal_array_5);
  mctc1 = coords_set(
#line 4419 "MACS_sample_kidney_box.instr"
    0 + channel_17_analyzer_2_array_effective_radius_of_curvature * ( 1 - cos ( channel_17_analyzer_2_array_theta [ 5 ] ) ),
#line 4419 "MACS_sample_kidney_box.instr"
    0 + channel_17_analyzer_2_array_effective_radius_of_curvature * sin ( channel_17_analyzer_2_array_theta [ 5 ] ),
#line 4419 "MACS_sample_kidney_box.instr"
    0);
#line 143590 "MACS_sample_kidney_box.c"
  rot_transpose(mcrotachannel_17_analyzer_2_rotated, mctr1);
  mctc2 = rot_apply(mctr1, mctc1);
  mcposachannel_17_analyzer_2_array_crystal_array_5 = coords_add(mcposachannel_17_analyzer_2_rotated, mctc2);
  mctc1 = coords_sub(mcposachannel_17_analyzer_2_array_crystal_array_4, mcposachannel_17_analyzer_2_array_crystal_array_5);
  mcposrchannel_17_analyzer_2_array_crystal_array_5 = rot_apply(mcrotachannel_17_analyzer_2_array_crystal_array_5, mctc1);
  mcDEBUG_COMPONENT("channel_17_analyzer_2_array_crystal_array_5", mcposachannel_17_analyzer_2_array_crystal_array_5, mcrotachannel_17_analyzer_2_array_crystal_array_5)
  mccomp_posa[792] = mcposachannel_17_analyzer_2_array_crystal_array_5;
  mccomp_posr[792] = mcposrchannel_17_analyzer_2_array_crystal_array_5;
  mcNCounter[792]  = mcPCounter[792] = mcP2Counter[792] = 0;
  mcAbsorbProp[792]= 0;
    /* Component channel_17_analyzer_2_array_crystal_array_6. */
  /* Setting parameters for component channel_17_analyzer_2_array_crystal_array_6. */
  SIG_MESSAGE("channel_17_analyzer_2_array_crystal_array_6 (Init:SetPar)");
#line 4424 "MACS_sample_kidney_box.instr"
  if("PG_analyzer") strncpy(mccchannel_17_analyzer_2_array_crystal_array_6_material_string, "PG_analyzer" ? "PG_analyzer" : "", 16384); else mccchannel_17_analyzer_2_array_crystal_array_6_material_string[0]='\0';
#line 4424 "MACS_sample_kidney_box.instr"
  mccchannel_17_analyzer_2_array_crystal_array_6_priority = 1921.6;
#line 4423 "MACS_sample_kidney_box.instr"
  mccchannel_17_analyzer_2_array_crystal_array_6_xwidth = channel_17_analyzer_2_array_crystal_depth;
#line 4423 "MACS_sample_kidney_box.instr"
  mccchannel_17_analyzer_2_array_crystal_array_6_yheight = channel_17_analyzer_2_array_crystal_height;
#line 4423 "MACS_sample_kidney_box.instr"
  mccchannel_17_analyzer_2_array_crystal_array_6_zdepth = channel_17_analyzer_2_array_crystal_width;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_17_analyzer_2_array_crystal_array_6_xwidth2 = -1;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_17_analyzer_2_array_crystal_array_6_yheight2 = -1;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_17_analyzer_2_array_crystal_array_6_visualize = 1;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_17_analyzer_2_array_crystal_array_6_target_index = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_17_analyzer_2_array_crystal_array_6_target_x = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_17_analyzer_2_array_crystal_array_6_target_y = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_17_analyzer_2_array_crystal_array_6_target_z = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_17_analyzer_2_array_crystal_array_6_focus_aw = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_17_analyzer_2_array_crystal_array_6_focus_ah = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_17_analyzer_2_array_crystal_array_6_focus_xw = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_17_analyzer_2_array_crystal_array_6_focus_xh = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_17_analyzer_2_array_crystal_array_6_focus_r = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_17_analyzer_2_array_crystal_array_6_p_interact = 0;
#line 71 "MACS_sample_kidney_box.instr"
  if(0) strncpy(mccchannel_17_analyzer_2_array_crystal_array_6_mask_string, 0 ? 0 : "", 16384); else mccchannel_17_analyzer_2_array_crystal_array_6_mask_string[0]='\0';
#line 71 "MACS_sample_kidney_box.instr"
  if(0) strncpy(mccchannel_17_analyzer_2_array_crystal_array_6_mask_setting, 0 ? 0 : "", 16384); else mccchannel_17_analyzer_2_array_crystal_array_6_mask_setting[0]='\0';
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_17_analyzer_2_array_crystal_array_6_number_of_activations = 1;
#line 143646 "MACS_sample_kidney_box.c"

  SIG_MESSAGE("channel_17_analyzer_2_array_crystal_array_6 (Init:Place/Rotate)");
  rot_set_rotation(mctr1,
#line 4426 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 4426 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 4426 "MACS_sample_kidney_box.instr"
    (0 - RAD2DEG * channel_17_analyzer_2_array_theta [ 6 ])*DEG2RAD);
#line 143656 "MACS_sample_kidney_box.c"
  rot_mul(mctr1, mcrotachannel_17_analyzer_2_rotated, mcrotachannel_17_analyzer_2_array_crystal_array_6);
  rot_transpose(mcrotachannel_17_analyzer_2_array_crystal_array_5, mctr1);
  rot_mul(mcrotachannel_17_analyzer_2_array_crystal_array_6, mctr1, mcrotrchannel_17_analyzer_2_array_crystal_array_6);
  mctc1 = coords_set(
#line 4425 "MACS_sample_kidney_box.instr"
    0 + channel_17_analyzer_2_array_effective_radius_of_curvature * ( 1 - cos ( channel_17_analyzer_2_array_theta [ 6 ] ) ),
#line 4425 "MACS_sample_kidney_box.instr"
    0 + channel_17_analyzer_2_array_effective_radius_of_curvature * sin ( channel_17_analyzer_2_array_theta [ 6 ] ),
#line 4425 "MACS_sample_kidney_box.instr"
    0);
#line 143667 "MACS_sample_kidney_box.c"
  rot_transpose(mcrotachannel_17_analyzer_2_rotated, mctr1);
  mctc2 = rot_apply(mctr1, mctc1);
  mcposachannel_17_analyzer_2_array_crystal_array_6 = coords_add(mcposachannel_17_analyzer_2_rotated, mctc2);
  mctc1 = coords_sub(mcposachannel_17_analyzer_2_array_crystal_array_5, mcposachannel_17_analyzer_2_array_crystal_array_6);
  mcposrchannel_17_analyzer_2_array_crystal_array_6 = rot_apply(mcrotachannel_17_analyzer_2_array_crystal_array_6, mctc1);
  mcDEBUG_COMPONENT("channel_17_analyzer_2_array_crystal_array_6", mcposachannel_17_analyzer_2_array_crystal_array_6, mcrotachannel_17_analyzer_2_array_crystal_array_6)
  mccomp_posa[793] = mcposachannel_17_analyzer_2_array_crystal_array_6;
  mccomp_posr[793] = mcposrchannel_17_analyzer_2_array_crystal_array_6;
  mcNCounter[793]  = mcPCounter[793] = mcP2Counter[793] = 0;
  mcAbsorbProp[793]= 0;
    /* Component channel_17_analyzer_2_array_crystal_array_7. */
  /* Setting parameters for component channel_17_analyzer_2_array_crystal_array_7. */
  SIG_MESSAGE("channel_17_analyzer_2_array_crystal_array_7 (Init:SetPar)");
#line 4430 "MACS_sample_kidney_box.instr"
  if("PG_analyzer") strncpy(mccchannel_17_analyzer_2_array_crystal_array_7_material_string, "PG_analyzer" ? "PG_analyzer" : "", 16384); else mccchannel_17_analyzer_2_array_crystal_array_7_material_string[0]='\0';
#line 4430 "MACS_sample_kidney_box.instr"
  mccchannel_17_analyzer_2_array_crystal_array_7_priority = 1921.7;
#line 4429 "MACS_sample_kidney_box.instr"
  mccchannel_17_analyzer_2_array_crystal_array_7_xwidth = channel_17_analyzer_2_array_crystal_depth;
#line 4429 "MACS_sample_kidney_box.instr"
  mccchannel_17_analyzer_2_array_crystal_array_7_yheight = channel_17_analyzer_2_array_crystal_height;
#line 4429 "MACS_sample_kidney_box.instr"
  mccchannel_17_analyzer_2_array_crystal_array_7_zdepth = channel_17_analyzer_2_array_crystal_width;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_17_analyzer_2_array_crystal_array_7_xwidth2 = -1;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_17_analyzer_2_array_crystal_array_7_yheight2 = -1;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_17_analyzer_2_array_crystal_array_7_visualize = 1;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_17_analyzer_2_array_crystal_array_7_target_index = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_17_analyzer_2_array_crystal_array_7_target_x = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_17_analyzer_2_array_crystal_array_7_target_y = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_17_analyzer_2_array_crystal_array_7_target_z = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_17_analyzer_2_array_crystal_array_7_focus_aw = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_17_analyzer_2_array_crystal_array_7_focus_ah = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_17_analyzer_2_array_crystal_array_7_focus_xw = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_17_analyzer_2_array_crystal_array_7_focus_xh = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_17_analyzer_2_array_crystal_array_7_focus_r = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_17_analyzer_2_array_crystal_array_7_p_interact = 0;
#line 71 "MACS_sample_kidney_box.instr"
  if(0) strncpy(mccchannel_17_analyzer_2_array_crystal_array_7_mask_string, 0 ? 0 : "", 16384); else mccchannel_17_analyzer_2_array_crystal_array_7_mask_string[0]='\0';
#line 71 "MACS_sample_kidney_box.instr"
  if(0) strncpy(mccchannel_17_analyzer_2_array_crystal_array_7_mask_setting, 0 ? 0 : "", 16384); else mccchannel_17_analyzer_2_array_crystal_array_7_mask_setting[0]='\0';
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_17_analyzer_2_array_crystal_array_7_number_of_activations = 1;
#line 143723 "MACS_sample_kidney_box.c"

  SIG_MESSAGE("channel_17_analyzer_2_array_crystal_array_7 (Init:Place/Rotate)");
  rot_set_rotation(mctr1,
#line 4432 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 4432 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 4432 "MACS_sample_kidney_box.instr"
    (0 - RAD2DEG * channel_17_analyzer_2_array_theta [ 7 ])*DEG2RAD);
#line 143733 "MACS_sample_kidney_box.c"
  rot_mul(mctr1, mcrotachannel_17_analyzer_2_rotated, mcrotachannel_17_analyzer_2_array_crystal_array_7);
  rot_transpose(mcrotachannel_17_analyzer_2_array_crystal_array_6, mctr1);
  rot_mul(mcrotachannel_17_analyzer_2_array_crystal_array_7, mctr1, mcrotrchannel_17_analyzer_2_array_crystal_array_7);
  mctc1 = coords_set(
#line 4431 "MACS_sample_kidney_box.instr"
    0 + channel_17_analyzer_2_array_effective_radius_of_curvature * ( 1 - cos ( channel_17_analyzer_2_array_theta [ 7 ] ) ),
#line 4431 "MACS_sample_kidney_box.instr"
    0 + channel_17_analyzer_2_array_effective_radius_of_curvature * sin ( channel_17_analyzer_2_array_theta [ 7 ] ),
#line 4431 "MACS_sample_kidney_box.instr"
    0);
#line 143744 "MACS_sample_kidney_box.c"
  rot_transpose(mcrotachannel_17_analyzer_2_rotated, mctr1);
  mctc2 = rot_apply(mctr1, mctc1);
  mcposachannel_17_analyzer_2_array_crystal_array_7 = coords_add(mcposachannel_17_analyzer_2_rotated, mctc2);
  mctc1 = coords_sub(mcposachannel_17_analyzer_2_array_crystal_array_6, mcposachannel_17_analyzer_2_array_crystal_array_7);
  mcposrchannel_17_analyzer_2_array_crystal_array_7 = rot_apply(mcrotachannel_17_analyzer_2_array_crystal_array_7, mctc1);
  mcDEBUG_COMPONENT("channel_17_analyzer_2_array_crystal_array_7", mcposachannel_17_analyzer_2_array_crystal_array_7, mcrotachannel_17_analyzer_2_array_crystal_array_7)
  mccomp_posa[794] = mcposachannel_17_analyzer_2_array_crystal_array_7;
  mccomp_posr[794] = mcposrchannel_17_analyzer_2_array_crystal_array_7;
  mcNCounter[794]  = mcPCounter[794] = mcP2Counter[794] = 0;
  mcAbsorbProp[794]= 0;
    /* Component channel_17_analyzer_2_array_crystal_array_8. */
  /* Setting parameters for component channel_17_analyzer_2_array_crystal_array_8. */
  SIG_MESSAGE("channel_17_analyzer_2_array_crystal_array_8 (Init:SetPar)");
#line 4436 "MACS_sample_kidney_box.instr"
  if("PG_analyzer") strncpy(mccchannel_17_analyzer_2_array_crystal_array_8_material_string, "PG_analyzer" ? "PG_analyzer" : "", 16384); else mccchannel_17_analyzer_2_array_crystal_array_8_material_string[0]='\0';
#line 4436 "MACS_sample_kidney_box.instr"
  mccchannel_17_analyzer_2_array_crystal_array_8_priority = 1921.8;
#line 4435 "MACS_sample_kidney_box.instr"
  mccchannel_17_analyzer_2_array_crystal_array_8_xwidth = channel_17_analyzer_2_array_crystal_depth;
#line 4435 "MACS_sample_kidney_box.instr"
  mccchannel_17_analyzer_2_array_crystal_array_8_yheight = channel_17_analyzer_2_array_crystal_height;
#line 4435 "MACS_sample_kidney_box.instr"
  mccchannel_17_analyzer_2_array_crystal_array_8_zdepth = channel_17_analyzer_2_array_crystal_width;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_17_analyzer_2_array_crystal_array_8_xwidth2 = -1;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_17_analyzer_2_array_crystal_array_8_yheight2 = -1;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_17_analyzer_2_array_crystal_array_8_visualize = 1;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_17_analyzer_2_array_crystal_array_8_target_index = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_17_analyzer_2_array_crystal_array_8_target_x = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_17_analyzer_2_array_crystal_array_8_target_y = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_17_analyzer_2_array_crystal_array_8_target_z = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_17_analyzer_2_array_crystal_array_8_focus_aw = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_17_analyzer_2_array_crystal_array_8_focus_ah = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_17_analyzer_2_array_crystal_array_8_focus_xw = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_17_analyzer_2_array_crystal_array_8_focus_xh = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_17_analyzer_2_array_crystal_array_8_focus_r = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_17_analyzer_2_array_crystal_array_8_p_interact = 0;
#line 71 "MACS_sample_kidney_box.instr"
  if(0) strncpy(mccchannel_17_analyzer_2_array_crystal_array_8_mask_string, 0 ? 0 : "", 16384); else mccchannel_17_analyzer_2_array_crystal_array_8_mask_string[0]='\0';
#line 71 "MACS_sample_kidney_box.instr"
  if(0) strncpy(mccchannel_17_analyzer_2_array_crystal_array_8_mask_setting, 0 ? 0 : "", 16384); else mccchannel_17_analyzer_2_array_crystal_array_8_mask_setting[0]='\0';
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_17_analyzer_2_array_crystal_array_8_number_of_activations = 1;
#line 143800 "MACS_sample_kidney_box.c"

  SIG_MESSAGE("channel_17_analyzer_2_array_crystal_array_8 (Init:Place/Rotate)");
  rot_set_rotation(mctr1,
#line 4438 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 4438 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 4438 "MACS_sample_kidney_box.instr"
    (0 - RAD2DEG * channel_17_analyzer_2_array_theta [ 8 ])*DEG2RAD);
#line 143810 "MACS_sample_kidney_box.c"
  rot_mul(mctr1, mcrotachannel_17_analyzer_2_rotated, mcrotachannel_17_analyzer_2_array_crystal_array_8);
  rot_transpose(mcrotachannel_17_analyzer_2_array_crystal_array_7, mctr1);
  rot_mul(mcrotachannel_17_analyzer_2_array_crystal_array_8, mctr1, mcrotrchannel_17_analyzer_2_array_crystal_array_8);
  mctc1 = coords_set(
#line 4437 "MACS_sample_kidney_box.instr"
    0 + channel_17_analyzer_2_array_effective_radius_of_curvature * ( 1 - cos ( channel_17_analyzer_2_array_theta [ 8 ] ) ),
#line 4437 "MACS_sample_kidney_box.instr"
    0 + channel_17_analyzer_2_array_effective_radius_of_curvature * sin ( channel_17_analyzer_2_array_theta [ 8 ] ),
#line 4437 "MACS_sample_kidney_box.instr"
    0);
#line 143821 "MACS_sample_kidney_box.c"
  rot_transpose(mcrotachannel_17_analyzer_2_rotated, mctr1);
  mctc2 = rot_apply(mctr1, mctc1);
  mcposachannel_17_analyzer_2_array_crystal_array_8 = coords_add(mcposachannel_17_analyzer_2_rotated, mctc2);
  mctc1 = coords_sub(mcposachannel_17_analyzer_2_array_crystal_array_7, mcposachannel_17_analyzer_2_array_crystal_array_8);
  mcposrchannel_17_analyzer_2_array_crystal_array_8 = rot_apply(mcrotachannel_17_analyzer_2_array_crystal_array_8, mctc1);
  mcDEBUG_COMPONENT("channel_17_analyzer_2_array_crystal_array_8", mcposachannel_17_analyzer_2_array_crystal_array_8, mcrotachannel_17_analyzer_2_array_crystal_array_8)
  mccomp_posa[795] = mcposachannel_17_analyzer_2_array_crystal_array_8;
  mccomp_posr[795] = mcposrchannel_17_analyzer_2_array_crystal_array_8;
  mcNCounter[795]  = mcPCounter[795] = mcP2Counter[795] = 0;
  mcAbsorbProp[795]= 0;
    /* Component channel_17_cave2_cyl1. */
  /* Setting parameters for component channel_17_cave2_cyl1. */
  SIG_MESSAGE("channel_17_cave2_cyl1 (Init:SetPar)");
#line 4443 "MACS_sample_kidney_box.instr"
  if("Vacuum") strncpy(mccchannel_17_cave2_cyl1_material_string, "Vacuum" ? "Vacuum" : "", 16384); else mccchannel_17_cave2_cyl1_material_string[0]='\0';
#line 4443 "MACS_sample_kidney_box.instr"
  mccchannel_17_cave2_cyl1_priority = 1907.5;
#line 4442 "MACS_sample_kidney_box.instr"
  mccchannel_17_cave2_cyl1_radius = kidney_cave2_cyl1_radius;
#line 4442 "MACS_sample_kidney_box.instr"
  mccchannel_17_cave2_cyl1_yheight = kidney_cave2_cyl1_height;
#line 67 "MACS_sample_kidney_box.instr"
  mccchannel_17_cave2_cyl1_visualize = 1;
#line 67 "MACS_sample_kidney_box.instr"
  mccchannel_17_cave2_cyl1_target_index = 0;
#line 67 "MACS_sample_kidney_box.instr"
  mccchannel_17_cave2_cyl1_target_x = 0;
#line 67 "MACS_sample_kidney_box.instr"
  mccchannel_17_cave2_cyl1_target_y = 0;
#line 67 "MACS_sample_kidney_box.instr"
  mccchannel_17_cave2_cyl1_target_z = 0;
#line 67 "MACS_sample_kidney_box.instr"
  mccchannel_17_cave2_cyl1_focus_aw = 0;
#line 67 "MACS_sample_kidney_box.instr"
  mccchannel_17_cave2_cyl1_focus_ah = 0;
#line 67 "MACS_sample_kidney_box.instr"
  mccchannel_17_cave2_cyl1_focus_xw = 0;
#line 67 "MACS_sample_kidney_box.instr"
  mccchannel_17_cave2_cyl1_focus_xh = 0;
#line 67 "MACS_sample_kidney_box.instr"
  mccchannel_17_cave2_cyl1_focus_r = 0;
#line 67 "MACS_sample_kidney_box.instr"
  mccchannel_17_cave2_cyl1_p_interact = 0;
#line 67 "MACS_sample_kidney_box.instr"
  if(0) strncpy(mccchannel_17_cave2_cyl1_mask_string, 0 ? 0 : "", 16384); else mccchannel_17_cave2_cyl1_mask_string[0]='\0';
#line 67 "MACS_sample_kidney_box.instr"
  if(0) strncpy(mccchannel_17_cave2_cyl1_mask_setting, 0 ? 0 : "", 16384); else mccchannel_17_cave2_cyl1_mask_setting[0]='\0';
#line 67 "MACS_sample_kidney_box.instr"
  mccchannel_17_cave2_cyl1_number_of_activations = 1;
#line 143871 "MACS_sample_kidney_box.c"

  SIG_MESSAGE("channel_17_cave2_cyl1 (Init:Place/Rotate)");
  rot_set_rotation(mctr1,
#line 4445 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 4445 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 4445 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD);
#line 143881 "MACS_sample_kidney_box.c"
  rot_mul(mctr1, mcrotachannel_17_analyzer_2_center, mcrotachannel_17_cave2_cyl1);
  rot_transpose(mcrotachannel_17_analyzer_2_array_crystal_array_8, mctr1);
  rot_mul(mcrotachannel_17_cave2_cyl1, mctr1, mcrotrchannel_17_cave2_cyl1);
  mctc1 = coords_set(
#line 4444 "MACS_sample_kidney_box.instr"
    0,
#line 4444 "MACS_sample_kidney_box.instr"
    0,
#line 4444 "MACS_sample_kidney_box.instr"
    spec_detector_to_analyzer_2_center);
#line 143892 "MACS_sample_kidney_box.c"
  rot_transpose(mcrotachannel_17_analyzer_2_center, mctr1);
  mctc2 = rot_apply(mctr1, mctc1);
  mcposachannel_17_cave2_cyl1 = coords_add(mcposachannel_17_analyzer_2_center, mctc2);
  mctc1 = coords_sub(mcposachannel_17_analyzer_2_array_crystal_array_8, mcposachannel_17_cave2_cyl1);
  mcposrchannel_17_cave2_cyl1 = rot_apply(mcrotachannel_17_cave2_cyl1, mctc1);
  mcDEBUG_COMPONENT("channel_17_cave2_cyl1", mcposachannel_17_cave2_cyl1, mcrotachannel_17_cave2_cyl1)
  mccomp_posa[796] = mcposachannel_17_cave2_cyl1;
  mccomp_posr[796] = mcposrchannel_17_cave2_cyl1;
  mcNCounter[796]  = mcPCounter[796] = mcP2Counter[796] = 0;
  mcAbsorbProp[796]= 0;
    /* Component channel_17_cave2_box1. */
  /* Setting parameters for component channel_17_cave2_box1. */
  SIG_MESSAGE("channel_17_cave2_box1 (Init:SetPar)");
#line 4450 "MACS_sample_kidney_box.instr"
  if("Vacuum") strncpy(mccchannel_17_cave2_box1_material_string, "Vacuum" ? "Vacuum" : "", 16384); else mccchannel_17_cave2_box1_material_string[0]='\0';
#line 4450 "MACS_sample_kidney_box.instr"
  mccchannel_17_cave2_box1_priority = 1901;
#line 4448 "MACS_sample_kidney_box.instr"
  mccchannel_17_cave2_box1_xwidth = kidney_cave2_box1_width1;
#line 4448 "MACS_sample_kidney_box.instr"
  mccchannel_17_cave2_box1_yheight = kidney_cave2_box1_height1;
#line 4448 "MACS_sample_kidney_box.instr"
  mccchannel_17_cave2_box1_zdepth = kidney_cave2_box1_depth;
#line 4449 "MACS_sample_kidney_box.instr"
  mccchannel_17_cave2_box1_xwidth2 = kidney_cave2_box1_width2;
#line 4449 "MACS_sample_kidney_box.instr"
  mccchannel_17_cave2_box1_yheight2 = kidney_cave2_box1_height2;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_17_cave2_box1_visualize = 1;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_17_cave2_box1_target_index = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_17_cave2_box1_target_x = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_17_cave2_box1_target_y = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_17_cave2_box1_target_z = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_17_cave2_box1_focus_aw = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_17_cave2_box1_focus_ah = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_17_cave2_box1_focus_xw = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_17_cave2_box1_focus_xh = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_17_cave2_box1_focus_r = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_17_cave2_box1_p_interact = 0;
#line 71 "MACS_sample_kidney_box.instr"
  if(0) strncpy(mccchannel_17_cave2_box1_mask_string, 0 ? 0 : "", 16384); else mccchannel_17_cave2_box1_mask_string[0]='\0';
#line 71 "MACS_sample_kidney_box.instr"
  if(0) strncpy(mccchannel_17_cave2_box1_mask_setting, 0 ? 0 : "", 16384); else mccchannel_17_cave2_box1_mask_setting[0]='\0';
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_17_cave2_box1_number_of_activations = 1;
#line 143948 "MACS_sample_kidney_box.c"

  SIG_MESSAGE("channel_17_cave2_box1 (Init:Place/Rotate)");
  rot_set_rotation(mctr1,
#line 4452 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 4452 "MACS_sample_kidney_box.instr"
    (kidney_cave2_box1_y_rotation)*DEG2RAD,
#line 4452 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD);
#line 143958 "MACS_sample_kidney_box.c"
  rot_mul(mctr1, mcrotachannel_17_cave2_cyl1, mcrotachannel_17_cave2_box1);
  rot_transpose(mcrotachannel_17_cave2_cyl1, mctr1);
  rot_mul(mcrotachannel_17_cave2_box1, mctr1, mcrotrchannel_17_cave2_box1);
  mctc1 = coords_set(
#line 4451 "MACS_sample_kidney_box.instr"
    kidney_cave2_box1_center_to_spec_detector_x,
#line 4451 "MACS_sample_kidney_box.instr"
    0,
#line 4451 "MACS_sample_kidney_box.instr"
    kidney_cave2_box1_center_to_spec_detector_z);
#line 143969 "MACS_sample_kidney_box.c"
  rot_transpose(mcrotachannel_17_cave2_cyl1, mctr1);
  mctc2 = rot_apply(mctr1, mctc1);
  mcposachannel_17_cave2_box1 = coords_add(mcposachannel_17_cave2_cyl1, mctc2);
  mctc1 = coords_sub(mcposachannel_17_cave2_cyl1, mcposachannel_17_cave2_box1);
  mcposrchannel_17_cave2_box1 = rot_apply(mcrotachannel_17_cave2_box1, mctc1);
  mcDEBUG_COMPONENT("channel_17_cave2_box1", mcposachannel_17_cave2_box1, mcrotachannel_17_cave2_box1)
  mccomp_posa[797] = mcposachannel_17_cave2_box1;
  mccomp_posr[797] = mcposrchannel_17_cave2_box1;
  mcNCounter[797]  = mcPCounter[797] = mcP2Counter[797] = 0;
  mcAbsorbProp[797]= 0;
    /* Component channel_17_cave2_box2. */
  /* Setting parameters for component channel_17_cave2_box2. */
  SIG_MESSAGE("channel_17_cave2_box2 (Init:SetPar)");
#line 4457 "MACS_sample_kidney_box.instr"
  if("Vacuum") strncpy(mccchannel_17_cave2_box2_material_string, "Vacuum" ? "Vacuum" : "", 16384); else mccchannel_17_cave2_box2_material_string[0]='\0';
#line 4457 "MACS_sample_kidney_box.instr"
  mccchannel_17_cave2_box2_priority = 1906;
#line 4455 "MACS_sample_kidney_box.instr"
  mccchannel_17_cave2_box2_xwidth = kidney_cave2_box2_width1;
#line 4455 "MACS_sample_kidney_box.instr"
  mccchannel_17_cave2_box2_yheight = kidney_cave2_box2_height1;
#line 4455 "MACS_sample_kidney_box.instr"
  mccchannel_17_cave2_box2_zdepth = kidney_cave2_box2_depth;
#line 4456 "MACS_sample_kidney_box.instr"
  mccchannel_17_cave2_box2_xwidth2 = kidney_cave2_box2_width2;
#line 4456 "MACS_sample_kidney_box.instr"
  mccchannel_17_cave2_box2_yheight2 = kidney_cave2_box2_height2;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_17_cave2_box2_visualize = 1;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_17_cave2_box2_target_index = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_17_cave2_box2_target_x = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_17_cave2_box2_target_y = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_17_cave2_box2_target_z = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_17_cave2_box2_focus_aw = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_17_cave2_box2_focus_ah = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_17_cave2_box2_focus_xw = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_17_cave2_box2_focus_xh = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_17_cave2_box2_focus_r = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_17_cave2_box2_p_interact = 0;
#line 71 "MACS_sample_kidney_box.instr"
  if(0) strncpy(mccchannel_17_cave2_box2_mask_string, 0 ? 0 : "", 16384); else mccchannel_17_cave2_box2_mask_string[0]='\0';
#line 71 "MACS_sample_kidney_box.instr"
  if(0) strncpy(mccchannel_17_cave2_box2_mask_setting, 0 ? 0 : "", 16384); else mccchannel_17_cave2_box2_mask_setting[0]='\0';
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_17_cave2_box2_number_of_activations = 1;
#line 144025 "MACS_sample_kidney_box.c"

  SIG_MESSAGE("channel_17_cave2_box2 (Init:Place/Rotate)");
  rot_set_rotation(mctr1,
#line 4459 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 4459 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 4459 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD);
#line 144035 "MACS_sample_kidney_box.c"
  rot_mul(mctr1, mcrotachannel_17_cave2_cyl1, mcrotachannel_17_cave2_box2);
  rot_transpose(mcrotachannel_17_cave2_box1, mctr1);
  rot_mul(mcrotachannel_17_cave2_box2, mctr1, mcrotrchannel_17_cave2_box2);
  mctc1 = coords_set(
#line 4458 "MACS_sample_kidney_box.instr"
    0,
#line 4458 "MACS_sample_kidney_box.instr"
    0,
#line 4458 "MACS_sample_kidney_box.instr"
    kidney_cave2_box2_center_to_detector);
#line 144046 "MACS_sample_kidney_box.c"
  rot_transpose(mcrotachannel_17_cave2_cyl1, mctr1);
  mctc2 = rot_apply(mctr1, mctc1);
  mcposachannel_17_cave2_box2 = coords_add(mcposachannel_17_cave2_cyl1, mctc2);
  mctc1 = coords_sub(mcposachannel_17_cave2_box1, mcposachannel_17_cave2_box2);
  mcposrchannel_17_cave2_box2 = rot_apply(mcrotachannel_17_cave2_box2, mctc1);
  mcDEBUG_COMPONENT("channel_17_cave2_box2", mcposachannel_17_cave2_box2, mcrotachannel_17_cave2_box2)
  mccomp_posa[798] = mcposachannel_17_cave2_box2;
  mccomp_posr[798] = mcposrchannel_17_cave2_box2;
  mcNCounter[798]  = mcPCounter[798] = mcP2Counter[798] = 0;
  mcAbsorbProp[798]= 0;
    /* Component channel_17_cave2_box3. */
  /* Setting parameters for component channel_17_cave2_box3. */
  SIG_MESSAGE("channel_17_cave2_box3 (Init:SetPar)");
#line 4464 "MACS_sample_kidney_box.instr"
  if("Vacuum") strncpy(mccchannel_17_cave2_box3_material_string, "Vacuum" ? "Vacuum" : "", 16384); else mccchannel_17_cave2_box3_material_string[0]='\0';
#line 4464 "MACS_sample_kidney_box.instr"
  mccchannel_17_cave2_box3_priority = 1907;
#line 4462 "MACS_sample_kidney_box.instr"
  mccchannel_17_cave2_box3_xwidth = kidney_cave2_box3_width1;
#line 4462 "MACS_sample_kidney_box.instr"
  mccchannel_17_cave2_box3_yheight = kidney_cave2_box3_height1;
#line 4462 "MACS_sample_kidney_box.instr"
  mccchannel_17_cave2_box3_zdepth = kidney_cave2_box3_depth;
#line 4463 "MACS_sample_kidney_box.instr"
  mccchannel_17_cave2_box3_xwidth2 = kidney_cave2_box3_width2;
#line 4463 "MACS_sample_kidney_box.instr"
  mccchannel_17_cave2_box3_yheight2 = kidney_cave2_box3_height2;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_17_cave2_box3_visualize = 1;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_17_cave2_box3_target_index = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_17_cave2_box3_target_x = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_17_cave2_box3_target_y = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_17_cave2_box3_target_z = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_17_cave2_box3_focus_aw = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_17_cave2_box3_focus_ah = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_17_cave2_box3_focus_xw = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_17_cave2_box3_focus_xh = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_17_cave2_box3_focus_r = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_17_cave2_box3_p_interact = 0;
#line 71 "MACS_sample_kidney_box.instr"
  if(0) strncpy(mccchannel_17_cave2_box3_mask_string, 0 ? 0 : "", 16384); else mccchannel_17_cave2_box3_mask_string[0]='\0';
#line 71 "MACS_sample_kidney_box.instr"
  if(0) strncpy(mccchannel_17_cave2_box3_mask_setting, 0 ? 0 : "", 16384); else mccchannel_17_cave2_box3_mask_setting[0]='\0';
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_17_cave2_box3_number_of_activations = 1;
#line 144102 "MACS_sample_kidney_box.c"

  SIG_MESSAGE("channel_17_cave2_box3 (Init:Place/Rotate)");
  rot_set_rotation(mctr1,
#line 4466 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 4466 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 4466 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD);
#line 144112 "MACS_sample_kidney_box.c"
  rot_mul(mctr1, mcrotachannel_17_cave2_cyl1, mcrotachannel_17_cave2_box3);
  rot_transpose(mcrotachannel_17_cave2_box2, mctr1);
  rot_mul(mcrotachannel_17_cave2_box3, mctr1, mcrotrchannel_17_cave2_box3);
  mctc1 = coords_set(
#line 4465 "MACS_sample_kidney_box.instr"
    0,
#line 4465 "MACS_sample_kidney_box.instr"
    0,
#line 4465 "MACS_sample_kidney_box.instr"
    kidney_cave2_box3_center_to_detector);
#line 144123 "MACS_sample_kidney_box.c"
  rot_transpose(mcrotachannel_17_cave2_cyl1, mctr1);
  mctc2 = rot_apply(mctr1, mctc1);
  mcposachannel_17_cave2_box3 = coords_add(mcposachannel_17_cave2_cyl1, mctc2);
  mctc1 = coords_sub(mcposachannel_17_cave2_box2, mcposachannel_17_cave2_box3);
  mcposrchannel_17_cave2_box3 = rot_apply(mcrotachannel_17_cave2_box3, mctc1);
  mcDEBUG_COMPONENT("channel_17_cave2_box3", mcposachannel_17_cave2_box3, mcrotachannel_17_cave2_box3)
  mccomp_posa[799] = mcposachannel_17_cave2_box3;
  mccomp_posr[799] = mcposrchannel_17_cave2_box3;
  mcNCounter[799]  = mcPCounter[799] = mcP2Counter[799] = 0;
  mcAbsorbProp[799]= 0;
    /* Component inter_analyzer_colimator_center_17. */
  /* Setting parameters for component inter_analyzer_colimator_center_17. */
  SIG_MESSAGE("inter_analyzer_colimator_center_17 (Init:SetPar)");

  SIG_MESSAGE("inter_analyzer_colimator_center_17 (Init:Place/Rotate)");
  rot_set_rotation(mctr1,
#line 4470 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 4470 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 4470 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD);
#line 144146 "MACS_sample_kidney_box.c"
  rot_mul(mctr1, mcrotachannel_17_analyzer_1_center, mcrotainter_analyzer_colimator_center_17);
  rot_transpose(mcrotachannel_17_cave2_box3, mctr1);
  rot_mul(mcrotainter_analyzer_colimator_center_17, mctr1, mcrotrinter_analyzer_colimator_center_17);
  mctc1 = coords_set(
#line 4469 "MACS_sample_kidney_box.instr"
    -0.5 * analyzer_seperation,
#line 4469 "MACS_sample_kidney_box.instr"
    0,
#line 4469 "MACS_sample_kidney_box.instr"
    0);
#line 144157 "MACS_sample_kidney_box.c"
  rot_transpose(mcrotachannel_17_analyzer_1_center, mctr1);
  mctc2 = rot_apply(mctr1, mctc1);
  mcposainter_analyzer_colimator_center_17 = coords_add(mcposachannel_17_analyzer_1_center, mctc2);
  mctc1 = coords_sub(mcposachannel_17_cave2_box3, mcposainter_analyzer_colimator_center_17);
  mcposrinter_analyzer_colimator_center_17 = rot_apply(mcrotainter_analyzer_colimator_center_17, mctc1);
  mcDEBUG_COMPONENT("inter_analyzer_colimator_center_17", mcposainter_analyzer_colimator_center_17, mcrotainter_analyzer_colimator_center_17)
  mccomp_posa[800] = mcposainter_analyzer_colimator_center_17;
  mccomp_posr[800] = mcposrinter_analyzer_colimator_center_17;
  mcNCounter[800]  = mcPCounter[800] = mcP2Counter[800] = 0;
  mcAbsorbProp[800]= 0;
    /* Component inter_analyzer_colimator_17_blade_0. */
  /* Setting parameters for component inter_analyzer_colimator_17_blade_0. */
  SIG_MESSAGE("inter_analyzer_colimator_17_blade_0 (Init:SetPar)");
#line 4474 "MACS_sample_kidney_box.instr"
  if("Collimator_gad") strncpy(mccinter_analyzer_colimator_17_blade_0_material_string, "Collimator_gad" ? "Collimator_gad" : "", 16384); else mccinter_analyzer_colimator_17_blade_0_material_string[0]='\0';
#line 4474 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_17_blade_0_priority = 1925;
#line 4473 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_17_blade_0_xwidth = inter_analyzer_colimator_width;
#line 4473 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_17_blade_0_yheight = inter_analyzer_colimator_height;
#line 4473 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_17_blade_0_zdepth = inter_analyzer_colimator_depth;
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_17_blade_0_xwidth2 = -1;
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_17_blade_0_yheight2 = -1;
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_17_blade_0_visualize = 1;
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_17_blade_0_target_index = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_17_blade_0_target_x = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_17_blade_0_target_y = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_17_blade_0_target_z = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_17_blade_0_focus_aw = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_17_blade_0_focus_ah = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_17_blade_0_focus_xw = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_17_blade_0_focus_xh = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_17_blade_0_focus_r = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_17_blade_0_p_interact = 0;
#line 71 "MACS_sample_kidney_box.instr"
  if(0) strncpy(mccinter_analyzer_colimator_17_blade_0_mask_string, 0 ? 0 : "", 16384); else mccinter_analyzer_colimator_17_blade_0_mask_string[0]='\0';
#line 71 "MACS_sample_kidney_box.instr"
  if(0) strncpy(mccinter_analyzer_colimator_17_blade_0_mask_setting, 0 ? 0 : "", 16384); else mccinter_analyzer_colimator_17_blade_0_mask_setting[0]='\0';
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_17_blade_0_number_of_activations = 1;
#line 144213 "MACS_sample_kidney_box.c"

  SIG_MESSAGE("inter_analyzer_colimator_17_blade_0 (Init:Place/Rotate)");
  rot_set_rotation(mctr1,
#line 4476 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 4476 "MACS_sample_kidney_box.instr"
    (- analyzer_2theta [ 17 ])*DEG2RAD,
#line 4476 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD);
#line 144223 "MACS_sample_kidney_box.c"
  rot_mul(mctr1, mcrotainter_analyzer_colimator_center_17, mcrotainter_analyzer_colimator_17_blade_0);
  rot_transpose(mcrotainter_analyzer_colimator_center_17, mctr1);
  rot_mul(mcrotainter_analyzer_colimator_17_blade_0, mctr1, mcrotrinter_analyzer_colimator_17_blade_0);
  mctc1 = coords_set(
#line 4475 "MACS_sample_kidney_box.instr"
    0,
#line 4475 "MACS_sample_kidney_box.instr"
    0,
#line 4475 "MACS_sample_kidney_box.instr"
    inter_analyzer_colimator_start_pos - 0 * inter_analyzer_colimator_seperation);
#line 144234 "MACS_sample_kidney_box.c"
  rot_transpose(mcrotainter_analyzer_colimator_center_17, mctr1);
  mctc2 = rot_apply(mctr1, mctc1);
  mcposainter_analyzer_colimator_17_blade_0 = coords_add(mcposainter_analyzer_colimator_center_17, mctc2);
  mctc1 = coords_sub(mcposainter_analyzer_colimator_center_17, mcposainter_analyzer_colimator_17_blade_0);
  mcposrinter_analyzer_colimator_17_blade_0 = rot_apply(mcrotainter_analyzer_colimator_17_blade_0, mctc1);
  mcDEBUG_COMPONENT("inter_analyzer_colimator_17_blade_0", mcposainter_analyzer_colimator_17_blade_0, mcrotainter_analyzer_colimator_17_blade_0)
  mccomp_posa[801] = mcposainter_analyzer_colimator_17_blade_0;
  mccomp_posr[801] = mcposrinter_analyzer_colimator_17_blade_0;
  mcNCounter[801]  = mcPCounter[801] = mcP2Counter[801] = 0;
  mcAbsorbProp[801]= 0;
    /* Component inter_analyzer_colimator_17_blade_1. */
  /* Setting parameters for component inter_analyzer_colimator_17_blade_1. */
  SIG_MESSAGE("inter_analyzer_colimator_17_blade_1 (Init:SetPar)");
#line 4480 "MACS_sample_kidney_box.instr"
  if("Collimator_gad") strncpy(mccinter_analyzer_colimator_17_blade_1_material_string, "Collimator_gad" ? "Collimator_gad" : "", 16384); else mccinter_analyzer_colimator_17_blade_1_material_string[0]='\0';
#line 4480 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_17_blade_1_priority = 1926;
#line 4479 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_17_blade_1_xwidth = inter_analyzer_colimator_width;
#line 4479 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_17_blade_1_yheight = inter_analyzer_colimator_height;
#line 4479 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_17_blade_1_zdepth = inter_analyzer_colimator_depth;
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_17_blade_1_xwidth2 = -1;
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_17_blade_1_yheight2 = -1;
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_17_blade_1_visualize = 1;
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_17_blade_1_target_index = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_17_blade_1_target_x = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_17_blade_1_target_y = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_17_blade_1_target_z = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_17_blade_1_focus_aw = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_17_blade_1_focus_ah = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_17_blade_1_focus_xw = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_17_blade_1_focus_xh = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_17_blade_1_focus_r = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_17_blade_1_p_interact = 0;
#line 71 "MACS_sample_kidney_box.instr"
  if(0) strncpy(mccinter_analyzer_colimator_17_blade_1_mask_string, 0 ? 0 : "", 16384); else mccinter_analyzer_colimator_17_blade_1_mask_string[0]='\0';
#line 71 "MACS_sample_kidney_box.instr"
  if(0) strncpy(mccinter_analyzer_colimator_17_blade_1_mask_setting, 0 ? 0 : "", 16384); else mccinter_analyzer_colimator_17_blade_1_mask_setting[0]='\0';
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_17_blade_1_number_of_activations = 1;
#line 144290 "MACS_sample_kidney_box.c"

  SIG_MESSAGE("inter_analyzer_colimator_17_blade_1 (Init:Place/Rotate)");
  rot_set_rotation(mctr1,
#line 4482 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 4482 "MACS_sample_kidney_box.instr"
    (- analyzer_2theta [ 17 ])*DEG2RAD,
#line 4482 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD);
#line 144300 "MACS_sample_kidney_box.c"
  rot_mul(mctr1, mcrotainter_analyzer_colimator_center_17, mcrotainter_analyzer_colimator_17_blade_1);
  rot_transpose(mcrotainter_analyzer_colimator_17_blade_0, mctr1);
  rot_mul(mcrotainter_analyzer_colimator_17_blade_1, mctr1, mcrotrinter_analyzer_colimator_17_blade_1);
  mctc1 = coords_set(
#line 4481 "MACS_sample_kidney_box.instr"
    0,
#line 4481 "MACS_sample_kidney_box.instr"
    0,
#line 4481 "MACS_sample_kidney_box.instr"
    inter_analyzer_colimator_start_pos - 1 * inter_analyzer_colimator_seperation);
#line 144311 "MACS_sample_kidney_box.c"
  rot_transpose(mcrotainter_analyzer_colimator_center_17, mctr1);
  mctc2 = rot_apply(mctr1, mctc1);
  mcposainter_analyzer_colimator_17_blade_1 = coords_add(mcposainter_analyzer_colimator_center_17, mctc2);
  mctc1 = coords_sub(mcposainter_analyzer_colimator_17_blade_0, mcposainter_analyzer_colimator_17_blade_1);
  mcposrinter_analyzer_colimator_17_blade_1 = rot_apply(mcrotainter_analyzer_colimator_17_blade_1, mctc1);
  mcDEBUG_COMPONENT("inter_analyzer_colimator_17_blade_1", mcposainter_analyzer_colimator_17_blade_1, mcrotainter_analyzer_colimator_17_blade_1)
  mccomp_posa[802] = mcposainter_analyzer_colimator_17_blade_1;
  mccomp_posr[802] = mcposrinter_analyzer_colimator_17_blade_1;
  mcNCounter[802]  = mcPCounter[802] = mcP2Counter[802] = 0;
  mcAbsorbProp[802]= 0;
    /* Component inter_analyzer_colimator_17_blade_2. */
  /* Setting parameters for component inter_analyzer_colimator_17_blade_2. */
  SIG_MESSAGE("inter_analyzer_colimator_17_blade_2 (Init:SetPar)");
#line 4486 "MACS_sample_kidney_box.instr"
  if("Collimator_gad") strncpy(mccinter_analyzer_colimator_17_blade_2_material_string, "Collimator_gad" ? "Collimator_gad" : "", 16384); else mccinter_analyzer_colimator_17_blade_2_material_string[0]='\0';
#line 4486 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_17_blade_2_priority = 1927;
#line 4485 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_17_blade_2_xwidth = inter_analyzer_colimator_width;
#line 4485 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_17_blade_2_yheight = inter_analyzer_colimator_height;
#line 4485 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_17_blade_2_zdepth = inter_analyzer_colimator_depth;
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_17_blade_2_xwidth2 = -1;
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_17_blade_2_yheight2 = -1;
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_17_blade_2_visualize = 1;
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_17_blade_2_target_index = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_17_blade_2_target_x = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_17_blade_2_target_y = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_17_blade_2_target_z = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_17_blade_2_focus_aw = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_17_blade_2_focus_ah = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_17_blade_2_focus_xw = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_17_blade_2_focus_xh = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_17_blade_2_focus_r = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_17_blade_2_p_interact = 0;
#line 71 "MACS_sample_kidney_box.instr"
  if(0) strncpy(mccinter_analyzer_colimator_17_blade_2_mask_string, 0 ? 0 : "", 16384); else mccinter_analyzer_colimator_17_blade_2_mask_string[0]='\0';
#line 71 "MACS_sample_kidney_box.instr"
  if(0) strncpy(mccinter_analyzer_colimator_17_blade_2_mask_setting, 0 ? 0 : "", 16384); else mccinter_analyzer_colimator_17_blade_2_mask_setting[0]='\0';
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_17_blade_2_number_of_activations = 1;
#line 144367 "MACS_sample_kidney_box.c"

  SIG_MESSAGE("inter_analyzer_colimator_17_blade_2 (Init:Place/Rotate)");
  rot_set_rotation(mctr1,
#line 4488 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 4488 "MACS_sample_kidney_box.instr"
    (- analyzer_2theta [ 17 ])*DEG2RAD,
#line 4488 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD);
#line 144377 "MACS_sample_kidney_box.c"
  rot_mul(mctr1, mcrotainter_analyzer_colimator_center_17, mcrotainter_analyzer_colimator_17_blade_2);
  rot_transpose(mcrotainter_analyzer_colimator_17_blade_1, mctr1);
  rot_mul(mcrotainter_analyzer_colimator_17_blade_2, mctr1, mcrotrinter_analyzer_colimator_17_blade_2);
  mctc1 = coords_set(
#line 4487 "MACS_sample_kidney_box.instr"
    0,
#line 4487 "MACS_sample_kidney_box.instr"
    0,
#line 4487 "MACS_sample_kidney_box.instr"
    inter_analyzer_colimator_start_pos - 2 * inter_analyzer_colimator_seperation);
#line 144388 "MACS_sample_kidney_box.c"
  rot_transpose(mcrotainter_analyzer_colimator_center_17, mctr1);
  mctc2 = rot_apply(mctr1, mctc1);
  mcposainter_analyzer_colimator_17_blade_2 = coords_add(mcposainter_analyzer_colimator_center_17, mctc2);
  mctc1 = coords_sub(mcposainter_analyzer_colimator_17_blade_1, mcposainter_analyzer_colimator_17_blade_2);
  mcposrinter_analyzer_colimator_17_blade_2 = rot_apply(mcrotainter_analyzer_colimator_17_blade_2, mctc1);
  mcDEBUG_COMPONENT("inter_analyzer_colimator_17_blade_2", mcposainter_analyzer_colimator_17_blade_2, mcrotainter_analyzer_colimator_17_blade_2)
  mccomp_posa[803] = mcposainter_analyzer_colimator_17_blade_2;
  mccomp_posr[803] = mcposrinter_analyzer_colimator_17_blade_2;
  mcNCounter[803]  = mcPCounter[803] = mcP2Counter[803] = 0;
  mcAbsorbProp[803]= 0;
    /* Component inter_analyzer_colimator_17_blade_3. */
  /* Setting parameters for component inter_analyzer_colimator_17_blade_3. */
  SIG_MESSAGE("inter_analyzer_colimator_17_blade_3 (Init:SetPar)");
#line 4492 "MACS_sample_kidney_box.instr"
  if("Collimator_gad") strncpy(mccinter_analyzer_colimator_17_blade_3_material_string, "Collimator_gad" ? "Collimator_gad" : "", 16384); else mccinter_analyzer_colimator_17_blade_3_material_string[0]='\0';
#line 4492 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_17_blade_3_priority = 1928;
#line 4491 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_17_blade_3_xwidth = inter_analyzer_colimator_width;
#line 4491 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_17_blade_3_yheight = inter_analyzer_colimator_height;
#line 4491 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_17_blade_3_zdepth = inter_analyzer_colimator_depth;
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_17_blade_3_xwidth2 = -1;
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_17_blade_3_yheight2 = -1;
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_17_blade_3_visualize = 1;
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_17_blade_3_target_index = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_17_blade_3_target_x = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_17_blade_3_target_y = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_17_blade_3_target_z = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_17_blade_3_focus_aw = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_17_blade_3_focus_ah = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_17_blade_3_focus_xw = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_17_blade_3_focus_xh = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_17_blade_3_focus_r = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_17_blade_3_p_interact = 0;
#line 71 "MACS_sample_kidney_box.instr"
  if(0) strncpy(mccinter_analyzer_colimator_17_blade_3_mask_string, 0 ? 0 : "", 16384); else mccinter_analyzer_colimator_17_blade_3_mask_string[0]='\0';
#line 71 "MACS_sample_kidney_box.instr"
  if(0) strncpy(mccinter_analyzer_colimator_17_blade_3_mask_setting, 0 ? 0 : "", 16384); else mccinter_analyzer_colimator_17_blade_3_mask_setting[0]='\0';
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_17_blade_3_number_of_activations = 1;
#line 144444 "MACS_sample_kidney_box.c"

  SIG_MESSAGE("inter_analyzer_colimator_17_blade_3 (Init:Place/Rotate)");
  rot_set_rotation(mctr1,
#line 4494 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 4494 "MACS_sample_kidney_box.instr"
    (- analyzer_2theta [ 17 ])*DEG2RAD,
#line 4494 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD);
#line 144454 "MACS_sample_kidney_box.c"
  rot_mul(mctr1, mcrotainter_analyzer_colimator_center_17, mcrotainter_analyzer_colimator_17_blade_3);
  rot_transpose(mcrotainter_analyzer_colimator_17_blade_2, mctr1);
  rot_mul(mcrotainter_analyzer_colimator_17_blade_3, mctr1, mcrotrinter_analyzer_colimator_17_blade_3);
  mctc1 = coords_set(
#line 4493 "MACS_sample_kidney_box.instr"
    0,
#line 4493 "MACS_sample_kidney_box.instr"
    0,
#line 4493 "MACS_sample_kidney_box.instr"
    inter_analyzer_colimator_start_pos - 3 * inter_analyzer_colimator_seperation);
#line 144465 "MACS_sample_kidney_box.c"
  rot_transpose(mcrotainter_analyzer_colimator_center_17, mctr1);
  mctc2 = rot_apply(mctr1, mctc1);
  mcposainter_analyzer_colimator_17_blade_3 = coords_add(mcposainter_analyzer_colimator_center_17, mctc2);
  mctc1 = coords_sub(mcposainter_analyzer_colimator_17_blade_2, mcposainter_analyzer_colimator_17_blade_3);
  mcposrinter_analyzer_colimator_17_blade_3 = rot_apply(mcrotainter_analyzer_colimator_17_blade_3, mctc1);
  mcDEBUG_COMPONENT("inter_analyzer_colimator_17_blade_3", mcposainter_analyzer_colimator_17_blade_3, mcrotainter_analyzer_colimator_17_blade_3)
  mccomp_posa[804] = mcposainter_analyzer_colimator_17_blade_3;
  mccomp_posr[804] = mcposrinter_analyzer_colimator_17_blade_3;
  mcNCounter[804]  = mcPCounter[804] = mcP2Counter[804] = 0;
  mcAbsorbProp[804]= 0;
    /* Component inter_analyzer_colimator_17_blade_4. */
  /* Setting parameters for component inter_analyzer_colimator_17_blade_4. */
  SIG_MESSAGE("inter_analyzer_colimator_17_blade_4 (Init:SetPar)");
#line 4498 "MACS_sample_kidney_box.instr"
  if("Collimator_gad") strncpy(mccinter_analyzer_colimator_17_blade_4_material_string, "Collimator_gad" ? "Collimator_gad" : "", 16384); else mccinter_analyzer_colimator_17_blade_4_material_string[0]='\0';
#line 4498 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_17_blade_4_priority = 1929;
#line 4497 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_17_blade_4_xwidth = inter_analyzer_colimator_width;
#line 4497 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_17_blade_4_yheight = inter_analyzer_colimator_height;
#line 4497 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_17_blade_4_zdepth = inter_analyzer_colimator_depth;
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_17_blade_4_xwidth2 = -1;
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_17_blade_4_yheight2 = -1;
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_17_blade_4_visualize = 1;
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_17_blade_4_target_index = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_17_blade_4_target_x = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_17_blade_4_target_y = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_17_blade_4_target_z = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_17_blade_4_focus_aw = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_17_blade_4_focus_ah = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_17_blade_4_focus_xw = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_17_blade_4_focus_xh = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_17_blade_4_focus_r = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_17_blade_4_p_interact = 0;
#line 71 "MACS_sample_kidney_box.instr"
  if(0) strncpy(mccinter_analyzer_colimator_17_blade_4_mask_string, 0 ? 0 : "", 16384); else mccinter_analyzer_colimator_17_blade_4_mask_string[0]='\0';
#line 71 "MACS_sample_kidney_box.instr"
  if(0) strncpy(mccinter_analyzer_colimator_17_blade_4_mask_setting, 0 ? 0 : "", 16384); else mccinter_analyzer_colimator_17_blade_4_mask_setting[0]='\0';
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_17_blade_4_number_of_activations = 1;
#line 144521 "MACS_sample_kidney_box.c"

  SIG_MESSAGE("inter_analyzer_colimator_17_blade_4 (Init:Place/Rotate)");
  rot_set_rotation(mctr1,
#line 4500 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 4500 "MACS_sample_kidney_box.instr"
    (- analyzer_2theta [ 17 ])*DEG2RAD,
#line 4500 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD);
#line 144531 "MACS_sample_kidney_box.c"
  rot_mul(mctr1, mcrotainter_analyzer_colimator_center_17, mcrotainter_analyzer_colimator_17_blade_4);
  rot_transpose(mcrotainter_analyzer_colimator_17_blade_3, mctr1);
  rot_mul(mcrotainter_analyzer_colimator_17_blade_4, mctr1, mcrotrinter_analyzer_colimator_17_blade_4);
  mctc1 = coords_set(
#line 4499 "MACS_sample_kidney_box.instr"
    0,
#line 4499 "MACS_sample_kidney_box.instr"
    0,
#line 4499 "MACS_sample_kidney_box.instr"
    inter_analyzer_colimator_start_pos - 4 * inter_analyzer_colimator_seperation);
#line 144542 "MACS_sample_kidney_box.c"
  rot_transpose(mcrotainter_analyzer_colimator_center_17, mctr1);
  mctc2 = rot_apply(mctr1, mctc1);
  mcposainter_analyzer_colimator_17_blade_4 = coords_add(mcposainter_analyzer_colimator_center_17, mctc2);
  mctc1 = coords_sub(mcposainter_analyzer_colimator_17_blade_3, mcposainter_analyzer_colimator_17_blade_4);
  mcposrinter_analyzer_colimator_17_blade_4 = rot_apply(mcrotainter_analyzer_colimator_17_blade_4, mctc1);
  mcDEBUG_COMPONENT("inter_analyzer_colimator_17_blade_4", mcposainter_analyzer_colimator_17_blade_4, mcrotainter_analyzer_colimator_17_blade_4)
  mccomp_posa[805] = mcposainter_analyzer_colimator_17_blade_4;
  mccomp_posr[805] = mcposrinter_analyzer_colimator_17_blade_4;
  mcNCounter[805]  = mcPCounter[805] = mcP2Counter[805] = 0;
  mcAbsorbProp[805]= 0;
    /* Component diffraction_detector_17_exit_volume. */
  /* Setting parameters for component diffraction_detector_17_exit_volume. */
  SIG_MESSAGE("diffraction_detector_17_exit_volume (Init:SetPar)");
#line 4504 "MACS_sample_kidney_box.instr"
  if("Exit") strncpy(mccdiffraction_detector_17_exit_volume_material_string, "Exit" ? "Exit" : "", 16384); else mccdiffraction_detector_17_exit_volume_material_string[0]='\0';
#line 4504 "MACS_sample_kidney_box.instr"
  mccdiffraction_detector_17_exit_volume_priority = 1931;
#line 4503 "MACS_sample_kidney_box.instr"
  mccdiffraction_detector_17_exit_volume_xwidth = 2.01 * detector_radius;
#line 4503 "MACS_sample_kidney_box.instr"
  mccdiffraction_detector_17_exit_volume_yheight = 1.01 * detector_height;
#line 4503 "MACS_sample_kidney_box.instr"
  mccdiffraction_detector_17_exit_volume_zdepth = 0.001;
#line 71 "MACS_sample_kidney_box.instr"
  mccdiffraction_detector_17_exit_volume_xwidth2 = -1;
#line 71 "MACS_sample_kidney_box.instr"
  mccdiffraction_detector_17_exit_volume_yheight2 = -1;
#line 71 "MACS_sample_kidney_box.instr"
  mccdiffraction_detector_17_exit_volume_visualize = 1;
#line 71 "MACS_sample_kidney_box.instr"
  mccdiffraction_detector_17_exit_volume_target_index = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccdiffraction_detector_17_exit_volume_target_x = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccdiffraction_detector_17_exit_volume_target_y = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccdiffraction_detector_17_exit_volume_target_z = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccdiffraction_detector_17_exit_volume_focus_aw = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccdiffraction_detector_17_exit_volume_focus_ah = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccdiffraction_detector_17_exit_volume_focus_xw = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccdiffraction_detector_17_exit_volume_focus_xh = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccdiffraction_detector_17_exit_volume_focus_r = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccdiffraction_detector_17_exit_volume_p_interact = 0;
#line 71 "MACS_sample_kidney_box.instr"
  if(0) strncpy(mccdiffraction_detector_17_exit_volume_mask_string, 0 ? 0 : "", 16384); else mccdiffraction_detector_17_exit_volume_mask_string[0]='\0';
#line 71 "MACS_sample_kidney_box.instr"
  if(0) strncpy(mccdiffraction_detector_17_exit_volume_mask_setting, 0 ? 0 : "", 16384); else mccdiffraction_detector_17_exit_volume_mask_setting[0]='\0';
#line 71 "MACS_sample_kidney_box.instr"
  mccdiffraction_detector_17_exit_volume_number_of_activations = 1;
#line 144598 "MACS_sample_kidney_box.c"

  SIG_MESSAGE("diffraction_detector_17_exit_volume (Init:Place/Rotate)");
  rot_set_rotation(mctr1,
#line 4506 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 4506 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 4506 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD);
#line 144608 "MACS_sample_kidney_box.c"
  rot_mul(mctr1, mcrotakidney_channel_17, mcrotadiffraction_detector_17_exit_volume);
  rot_transpose(mcrotainter_analyzer_colimator_17_blade_4, mctr1);
  rot_mul(mcrotadiffraction_detector_17_exit_volume, mctr1, mcrotrdiffraction_detector_17_exit_volume);
  mctc1 = coords_set(
#line 4505 "MACS_sample_kidney_box.instr"
    0,
#line 4505 "MACS_sample_kidney_box.instr"
    0,
#line 4505 "MACS_sample_kidney_box.instr"
    0);
#line 144619 "MACS_sample_kidney_box.c"
  rot_transpose(mcrotachannel_17_cave1_cyl1, mctr1);
  mctc2 = rot_apply(mctr1, mctc1);
  mcposadiffraction_detector_17_exit_volume = coords_add(mcposachannel_17_cave1_cyl1, mctc2);
  mctc1 = coords_sub(mcposainter_analyzer_colimator_17_blade_4, mcposadiffraction_detector_17_exit_volume);
  mcposrdiffraction_detector_17_exit_volume = rot_apply(mcrotadiffraction_detector_17_exit_volume, mctc1);
  mcDEBUG_COMPONENT("diffraction_detector_17_exit_volume", mcposadiffraction_detector_17_exit_volume, mcrotadiffraction_detector_17_exit_volume)
  mccomp_posa[806] = mcposadiffraction_detector_17_exit_volume;
  mccomp_posr[806] = mcposrdiffraction_detector_17_exit_volume;
  mcNCounter[806]  = mcPCounter[806] = mcP2Counter[806] = 0;
  mcAbsorbProp[806]= 0;
    /* Component spec_detector_17_exit_volume. */
  /* Setting parameters for component spec_detector_17_exit_volume. */
  SIG_MESSAGE("spec_detector_17_exit_volume (Init:SetPar)");
#line 4510 "MACS_sample_kidney_box.instr"
  if("Exit") strncpy(mccspec_detector_17_exit_volume_material_string, "Exit" ? "Exit" : "", 16384); else mccspec_detector_17_exit_volume_material_string[0]='\0';
#line 4510 "MACS_sample_kidney_box.instr"
  mccspec_detector_17_exit_volume_priority = 1932;
#line 4509 "MACS_sample_kidney_box.instr"
  mccspec_detector_17_exit_volume_xwidth = 2.01 * detector_radius;
#line 4509 "MACS_sample_kidney_box.instr"
  mccspec_detector_17_exit_volume_yheight = 1.01 * detector_height;
#line 4509 "MACS_sample_kidney_box.instr"
  mccspec_detector_17_exit_volume_zdepth = 0.001;
#line 71 "MACS_sample_kidney_box.instr"
  mccspec_detector_17_exit_volume_xwidth2 = -1;
#line 71 "MACS_sample_kidney_box.instr"
  mccspec_detector_17_exit_volume_yheight2 = -1;
#line 71 "MACS_sample_kidney_box.instr"
  mccspec_detector_17_exit_volume_visualize = 1;
#line 71 "MACS_sample_kidney_box.instr"
  mccspec_detector_17_exit_volume_target_index = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccspec_detector_17_exit_volume_target_x = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccspec_detector_17_exit_volume_target_y = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccspec_detector_17_exit_volume_target_z = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccspec_detector_17_exit_volume_focus_aw = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccspec_detector_17_exit_volume_focus_ah = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccspec_detector_17_exit_volume_focus_xw = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccspec_detector_17_exit_volume_focus_xh = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccspec_detector_17_exit_volume_focus_r = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccspec_detector_17_exit_volume_p_interact = 0;
#line 71 "MACS_sample_kidney_box.instr"
  if(0) strncpy(mccspec_detector_17_exit_volume_mask_string, 0 ? 0 : "", 16384); else mccspec_detector_17_exit_volume_mask_string[0]='\0';
#line 71 "MACS_sample_kidney_box.instr"
  if(0) strncpy(mccspec_detector_17_exit_volume_mask_setting, 0 ? 0 : "", 16384); else mccspec_detector_17_exit_volume_mask_setting[0]='\0';
#line 71 "MACS_sample_kidney_box.instr"
  mccspec_detector_17_exit_volume_number_of_activations = 1;
#line 144675 "MACS_sample_kidney_box.c"

  SIG_MESSAGE("spec_detector_17_exit_volume (Init:Place/Rotate)");
  rot_set_rotation(mctr1,
#line 4512 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 4512 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 4512 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD);
#line 144685 "MACS_sample_kidney_box.c"
  rot_mul(mctr1, mcrotachannel_17_analyzer_2_center, mcrotaspec_detector_17_exit_volume);
  rot_transpose(mcrotadiffraction_detector_17_exit_volume, mctr1);
  rot_mul(mcrotaspec_detector_17_exit_volume, mctr1, mcrotrspec_detector_17_exit_volume);
  mctc1 = coords_set(
#line 4511 "MACS_sample_kidney_box.instr"
    0,
#line 4511 "MACS_sample_kidney_box.instr"
    0,
#line 4511 "MACS_sample_kidney_box.instr"
    0);
#line 144696 "MACS_sample_kidney_box.c"
  rot_transpose(mcrotachannel_17_cave2_cyl1, mctr1);
  mctc2 = rot_apply(mctr1, mctc1);
  mcposaspec_detector_17_exit_volume = coords_add(mcposachannel_17_cave2_cyl1, mctc2);
  mctc1 = coords_sub(mcposadiffraction_detector_17_exit_volume, mcposaspec_detector_17_exit_volume);
  mcposrspec_detector_17_exit_volume = rot_apply(mcrotaspec_detector_17_exit_volume, mctc1);
  mcDEBUG_COMPONENT("spec_detector_17_exit_volume", mcposaspec_detector_17_exit_volume, mcrotaspec_detector_17_exit_volume)
  mccomp_posa[807] = mcposaspec_detector_17_exit_volume;
  mccomp_posr[807] = mcposrspec_detector_17_exit_volume;
  mcNCounter[807]  = mcPCounter[807] = mcP2Counter[807] = 0;
  mcAbsorbProp[807]= 0;
    /* Component channel_18_cave1_box1. */
  /* Setting parameters for component channel_18_cave1_box1. */
  SIG_MESSAGE("channel_18_cave1_box1 (Init:SetPar)");
#line 4517 "MACS_sample_kidney_box.instr"
  if("Vacuum") strncpy(mccchannel_18_cave1_box1_material_string, "Vacuum" ? "Vacuum" : "", 16384); else mccchannel_18_cave1_box1_material_string[0]='\0';
#line 4517 "MACS_sample_kidney_box.instr"
  mccchannel_18_cave1_box1_priority = 2000;
#line 4515 "MACS_sample_kidney_box.instr"
  mccchannel_18_cave1_box1_xwidth = kidney_cave1_box1_width1;
#line 4515 "MACS_sample_kidney_box.instr"
  mccchannel_18_cave1_box1_yheight = kidney_cave1_box1_height1;
#line 4515 "MACS_sample_kidney_box.instr"
  mccchannel_18_cave1_box1_zdepth = kidney_cave1_box1_depth;
#line 4516 "MACS_sample_kidney_box.instr"
  mccchannel_18_cave1_box1_xwidth2 = kidney_cave1_box1_width2;
#line 4516 "MACS_sample_kidney_box.instr"
  mccchannel_18_cave1_box1_yheight2 = kidney_cave1_box1_height2;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_18_cave1_box1_visualize = 1;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_18_cave1_box1_target_index = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_18_cave1_box1_target_x = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_18_cave1_box1_target_y = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_18_cave1_box1_target_z = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_18_cave1_box1_focus_aw = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_18_cave1_box1_focus_ah = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_18_cave1_box1_focus_xw = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_18_cave1_box1_focus_xh = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_18_cave1_box1_focus_r = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_18_cave1_box1_p_interact = 0;
#line 71 "MACS_sample_kidney_box.instr"
  if(0) strncpy(mccchannel_18_cave1_box1_mask_string, 0 ? 0 : "", 16384); else mccchannel_18_cave1_box1_mask_string[0]='\0';
#line 71 "MACS_sample_kidney_box.instr"
  if(0) strncpy(mccchannel_18_cave1_box1_mask_setting, 0 ? 0 : "", 16384); else mccchannel_18_cave1_box1_mask_setting[0]='\0';
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_18_cave1_box1_number_of_activations = 1;
#line 144752 "MACS_sample_kidney_box.c"

  SIG_MESSAGE("channel_18_cave1_box1 (Init:Place/Rotate)");
  rot_set_rotation(mctr1,
#line 4519 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 4519 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 4519 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD);
#line 144762 "MACS_sample_kidney_box.c"
  rot_mul(mctr1, mcrotakidney_channel_18, mcrotachannel_18_cave1_box1);
  rot_transpose(mcrotaspec_detector_17_exit_volume, mctr1);
  rot_mul(mcrotachannel_18_cave1_box1, mctr1, mcrotrchannel_18_cave1_box1);
  mctc1 = coords_set(
#line 4518 "MACS_sample_kidney_box.instr"
    0,
#line 4518 "MACS_sample_kidney_box.instr"
    0,
#line 4518 "MACS_sample_kidney_box.instr"
    kidney_cave1_box1_center_to_target);
#line 144773 "MACS_sample_kidney_box.c"
  rot_transpose(mcrotakidney_channel_18, mctr1);
  mctc2 = rot_apply(mctr1, mctc1);
  mcposachannel_18_cave1_box1 = coords_add(mcposakidney_channel_18, mctc2);
  mctc1 = coords_sub(mcposaspec_detector_17_exit_volume, mcposachannel_18_cave1_box1);
  mcposrchannel_18_cave1_box1 = rot_apply(mcrotachannel_18_cave1_box1, mctc1);
  mcDEBUG_COMPONENT("channel_18_cave1_box1", mcposachannel_18_cave1_box1, mcrotachannel_18_cave1_box1)
  mccomp_posa[808] = mcposachannel_18_cave1_box1;
  mccomp_posr[808] = mcposrchannel_18_cave1_box1;
  mcNCounter[808]  = mcPCounter[808] = mcP2Counter[808] = 0;
  mcAbsorbProp[808]= 0;
    /* Component channel_18_cave1_box2. */
  /* Setting parameters for component channel_18_cave1_box2. */
  SIG_MESSAGE("channel_18_cave1_box2 (Init:SetPar)");
#line 4524 "MACS_sample_kidney_box.instr"
  if("Vacuum") strncpy(mccchannel_18_cave1_box2_material_string, "Vacuum" ? "Vacuum" : "", 16384); else mccchannel_18_cave1_box2_material_string[0]='\0';
#line 4524 "MACS_sample_kidney_box.instr"
  mccchannel_18_cave1_box2_priority = 2005;
#line 4522 "MACS_sample_kidney_box.instr"
  mccchannel_18_cave1_box2_xwidth = kidney_cave1_box2_width1;
#line 4522 "MACS_sample_kidney_box.instr"
  mccchannel_18_cave1_box2_yheight = kidney_cave1_box2_height1;
#line 4522 "MACS_sample_kidney_box.instr"
  mccchannel_18_cave1_box2_zdepth = kidney_cave1_box2_depth;
#line 4523 "MACS_sample_kidney_box.instr"
  mccchannel_18_cave1_box2_xwidth2 = kidney_cave1_box2_width2;
#line 4523 "MACS_sample_kidney_box.instr"
  mccchannel_18_cave1_box2_yheight2 = kidney_cave1_box2_height2;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_18_cave1_box2_visualize = 1;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_18_cave1_box2_target_index = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_18_cave1_box2_target_x = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_18_cave1_box2_target_y = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_18_cave1_box2_target_z = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_18_cave1_box2_focus_aw = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_18_cave1_box2_focus_ah = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_18_cave1_box2_focus_xw = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_18_cave1_box2_focus_xh = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_18_cave1_box2_focus_r = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_18_cave1_box2_p_interact = 0;
#line 71 "MACS_sample_kidney_box.instr"
  if(0) strncpy(mccchannel_18_cave1_box2_mask_string, 0 ? 0 : "", 16384); else mccchannel_18_cave1_box2_mask_string[0]='\0';
#line 71 "MACS_sample_kidney_box.instr"
  if(0) strncpy(mccchannel_18_cave1_box2_mask_setting, 0 ? 0 : "", 16384); else mccchannel_18_cave1_box2_mask_setting[0]='\0';
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_18_cave1_box2_number_of_activations = 1;
#line 144829 "MACS_sample_kidney_box.c"

  SIG_MESSAGE("channel_18_cave1_box2 (Init:Place/Rotate)");
  rot_set_rotation(mctr1,
#line 4526 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 4526 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 4526 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD);
#line 144839 "MACS_sample_kidney_box.c"
  rot_mul(mctr1, mcrotakidney_channel_18, mcrotachannel_18_cave1_box2);
  rot_transpose(mcrotachannel_18_cave1_box1, mctr1);
  rot_mul(mcrotachannel_18_cave1_box2, mctr1, mcrotrchannel_18_cave1_box2);
  mctc1 = coords_set(
#line 4525 "MACS_sample_kidney_box.instr"
    kidney_cave1_box2_x_offset,
#line 4525 "MACS_sample_kidney_box.instr"
    0,
#line 4525 "MACS_sample_kidney_box.instr"
    kidney_cave1_box2_center_to_target);
#line 144850 "MACS_sample_kidney_box.c"
  rot_transpose(mcrotakidney_channel_18, mctr1);
  mctc2 = rot_apply(mctr1, mctc1);
  mcposachannel_18_cave1_box2 = coords_add(mcposakidney_channel_18, mctc2);
  mctc1 = coords_sub(mcposachannel_18_cave1_box1, mcposachannel_18_cave1_box2);
  mcposrchannel_18_cave1_box2 = rot_apply(mcrotachannel_18_cave1_box2, mctc1);
  mcDEBUG_COMPONENT("channel_18_cave1_box2", mcposachannel_18_cave1_box2, mcrotachannel_18_cave1_box2)
  mccomp_posa[809] = mcposachannel_18_cave1_box2;
  mccomp_posr[809] = mcposrchannel_18_cave1_box2;
  mcNCounter[809]  = mcPCounter[809] = mcP2Counter[809] = 0;
  mcAbsorbProp[809]= 0;
    /* Component channel_18_cave1_box3. */
  /* Setting parameters for component channel_18_cave1_box3. */
  SIG_MESSAGE("channel_18_cave1_box3 (Init:SetPar)");
#line 4531 "MACS_sample_kidney_box.instr"
  if("Vacuum") strncpy(mccchannel_18_cave1_box3_material_string, "Vacuum" ? "Vacuum" : "", 16384); else mccchannel_18_cave1_box3_material_string[0]='\0';
#line 4531 "MACS_sample_kidney_box.instr"
  mccchannel_18_cave1_box3_priority = 2002;
#line 4529 "MACS_sample_kidney_box.instr"
  mccchannel_18_cave1_box3_xwidth = kidney_cave1_box3_width1;
#line 4529 "MACS_sample_kidney_box.instr"
  mccchannel_18_cave1_box3_yheight = kidney_cave1_box3_height1;
#line 4529 "MACS_sample_kidney_box.instr"
  mccchannel_18_cave1_box3_zdepth = kidney_cave1_box3_depth;
#line 4530 "MACS_sample_kidney_box.instr"
  mccchannel_18_cave1_box3_xwidth2 = kidney_cave1_box3_width2;
#line 4530 "MACS_sample_kidney_box.instr"
  mccchannel_18_cave1_box3_yheight2 = kidney_cave1_box3_height2;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_18_cave1_box3_visualize = 1;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_18_cave1_box3_target_index = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_18_cave1_box3_target_x = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_18_cave1_box3_target_y = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_18_cave1_box3_target_z = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_18_cave1_box3_focus_aw = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_18_cave1_box3_focus_ah = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_18_cave1_box3_focus_xw = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_18_cave1_box3_focus_xh = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_18_cave1_box3_focus_r = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_18_cave1_box3_p_interact = 0;
#line 71 "MACS_sample_kidney_box.instr"
  if(0) strncpy(mccchannel_18_cave1_box3_mask_string, 0 ? 0 : "", 16384); else mccchannel_18_cave1_box3_mask_string[0]='\0';
#line 71 "MACS_sample_kidney_box.instr"
  if(0) strncpy(mccchannel_18_cave1_box3_mask_setting, 0 ? 0 : "", 16384); else mccchannel_18_cave1_box3_mask_setting[0]='\0';
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_18_cave1_box3_number_of_activations = 1;
#line 144906 "MACS_sample_kidney_box.c"

  SIG_MESSAGE("channel_18_cave1_box3 (Init:Place/Rotate)");
  rot_set_rotation(mctr1,
#line 4533 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 4533 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 4533 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD);
#line 144916 "MACS_sample_kidney_box.c"
  rot_mul(mctr1, mcrotakidney_channel_18, mcrotachannel_18_cave1_box3);
  rot_transpose(mcrotachannel_18_cave1_box2, mctr1);
  rot_mul(mcrotachannel_18_cave1_box3, mctr1, mcrotrchannel_18_cave1_box3);
  mctc1 = coords_set(
#line 4532 "MACS_sample_kidney_box.instr"
    0,
#line 4532 "MACS_sample_kidney_box.instr"
    0,
#line 4532 "MACS_sample_kidney_box.instr"
    kidney_cave1_box3_center_to_target);
#line 144927 "MACS_sample_kidney_box.c"
  rot_transpose(mcrotakidney_channel_18, mctr1);
  mctc2 = rot_apply(mctr1, mctc1);
  mcposachannel_18_cave1_box3 = coords_add(mcposakidney_channel_18, mctc2);
  mctc1 = coords_sub(mcposachannel_18_cave1_box2, mcposachannel_18_cave1_box3);
  mcposrchannel_18_cave1_box3 = rot_apply(mcrotachannel_18_cave1_box3, mctc1);
  mcDEBUG_COMPONENT("channel_18_cave1_box3", mcposachannel_18_cave1_box3, mcrotachannel_18_cave1_box3)
  mccomp_posa[810] = mcposachannel_18_cave1_box3;
  mccomp_posr[810] = mcposrchannel_18_cave1_box3;
  mcNCounter[810]  = mcPCounter[810] = mcP2Counter[810] = 0;
  mcAbsorbProp[810]= 0;
    /* Component channel_18_cave1_cyl1. */
  /* Setting parameters for component channel_18_cave1_cyl1. */
  SIG_MESSAGE("channel_18_cave1_cyl1 (Init:SetPar)");
#line 4537 "MACS_sample_kidney_box.instr"
  if("Vacuum") strncpy(mccchannel_18_cave1_cyl1_material_string, "Vacuum" ? "Vacuum" : "", 16384); else mccchannel_18_cave1_cyl1_material_string[0]='\0';
#line 4537 "MACS_sample_kidney_box.instr"
  mccchannel_18_cave1_cyl1_priority = 2003;
#line 4536 "MACS_sample_kidney_box.instr"
  mccchannel_18_cave1_cyl1_radius = kidney_cave1_cyl1_radius;
#line 4536 "MACS_sample_kidney_box.instr"
  mccchannel_18_cave1_cyl1_yheight = kidney_cave1_cyl1_height;
#line 67 "MACS_sample_kidney_box.instr"
  mccchannel_18_cave1_cyl1_visualize = 1;
#line 67 "MACS_sample_kidney_box.instr"
  mccchannel_18_cave1_cyl1_target_index = 0;
#line 67 "MACS_sample_kidney_box.instr"
  mccchannel_18_cave1_cyl1_target_x = 0;
#line 67 "MACS_sample_kidney_box.instr"
  mccchannel_18_cave1_cyl1_target_y = 0;
#line 67 "MACS_sample_kidney_box.instr"
  mccchannel_18_cave1_cyl1_target_z = 0;
#line 67 "MACS_sample_kidney_box.instr"
  mccchannel_18_cave1_cyl1_focus_aw = 0;
#line 67 "MACS_sample_kidney_box.instr"
  mccchannel_18_cave1_cyl1_focus_ah = 0;
#line 67 "MACS_sample_kidney_box.instr"
  mccchannel_18_cave1_cyl1_focus_xw = 0;
#line 67 "MACS_sample_kidney_box.instr"
  mccchannel_18_cave1_cyl1_focus_xh = 0;
#line 67 "MACS_sample_kidney_box.instr"
  mccchannel_18_cave1_cyl1_focus_r = 0;
#line 67 "MACS_sample_kidney_box.instr"
  mccchannel_18_cave1_cyl1_p_interact = 0;
#line 67 "MACS_sample_kidney_box.instr"
  if(0) strncpy(mccchannel_18_cave1_cyl1_mask_string, 0 ? 0 : "", 16384); else mccchannel_18_cave1_cyl1_mask_string[0]='\0';
#line 67 "MACS_sample_kidney_box.instr"
  if(0) strncpy(mccchannel_18_cave1_cyl1_mask_setting, 0 ? 0 : "", 16384); else mccchannel_18_cave1_cyl1_mask_setting[0]='\0';
#line 67 "MACS_sample_kidney_box.instr"
  mccchannel_18_cave1_cyl1_number_of_activations = 1;
#line 144977 "MACS_sample_kidney_box.c"

  SIG_MESSAGE("channel_18_cave1_cyl1 (Init:Place/Rotate)");
  rot_set_rotation(mctr1,
#line 4539 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 4539 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 4539 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD);
#line 144987 "MACS_sample_kidney_box.c"
  rot_mul(mctr1, mcrotakidney_channel_18, mcrotachannel_18_cave1_cyl1);
  rot_transpose(mcrotachannel_18_cave1_box3, mctr1);
  rot_mul(mcrotachannel_18_cave1_cyl1, mctr1, mcrotrchannel_18_cave1_cyl1);
  mctc1 = coords_set(
#line 4538 "MACS_sample_kidney_box.instr"
    0,
#line 4538 "MACS_sample_kidney_box.instr"
    0,
#line 4538 "MACS_sample_kidney_box.instr"
    kidney_cave1_cyl1_center_to_target);
#line 144998 "MACS_sample_kidney_box.c"
  rot_transpose(mcrotakidney_channel_18, mctr1);
  mctc2 = rot_apply(mctr1, mctc1);
  mcposachannel_18_cave1_cyl1 = coords_add(mcposakidney_channel_18, mctc2);
  mctc1 = coords_sub(mcposachannel_18_cave1_box3, mcposachannel_18_cave1_cyl1);
  mcposrchannel_18_cave1_cyl1 = rot_apply(mcrotachannel_18_cave1_cyl1, mctc1);
  mcDEBUG_COMPONENT("channel_18_cave1_cyl1", mcposachannel_18_cave1_cyl1, mcrotachannel_18_cave1_cyl1)
  mccomp_posa[811] = mcposachannel_18_cave1_cyl1;
  mccomp_posr[811] = mcposrchannel_18_cave1_cyl1;
  mcNCounter[811]  = mcPCounter[811] = mcP2Counter[811] = 0;
  mcAbsorbProp[811]= 0;
    /* Component channel_18_analyzer_1_center. */
  /* Setting parameters for component channel_18_analyzer_1_center. */
  SIG_MESSAGE("channel_18_analyzer_1_center (Init:SetPar)");

  SIG_MESSAGE("channel_18_analyzer_1_center (Init:Place/Rotate)");
  rot_set_rotation(mctr1,
    (0.0)*DEG2RAD,
    (0.0)*DEG2RAD,
    (0.0)*DEG2RAD);
#line 145018 "MACS_sample_kidney_box.c"
  rot_mul(mctr1, mcrotakidney_channel_18, mcrotachannel_18_analyzer_1_center);
  rot_transpose(mcrotachannel_18_cave1_cyl1, mctr1);
  rot_mul(mcrotachannel_18_analyzer_1_center, mctr1, mcrotrchannel_18_analyzer_1_center);
  mctc1 = coords_set(
#line 4543 "MACS_sample_kidney_box.instr"
    0,
#line 4543 "MACS_sample_kidney_box.instr"
    0,
#line 4543 "MACS_sample_kidney_box.instr"
    analyzer_1_center_to_sample);
#line 145029 "MACS_sample_kidney_box.c"
  rot_transpose(mcrotakidney_channel_18, mctr1);
  mctc2 = rot_apply(mctr1, mctc1);
  mcposachannel_18_analyzer_1_center = coords_add(mcposakidney_channel_18, mctc2);
  mctc1 = coords_sub(mcposachannel_18_cave1_cyl1, mcposachannel_18_analyzer_1_center);
  mcposrchannel_18_analyzer_1_center = rot_apply(mcrotachannel_18_analyzer_1_center, mctc1);
  mcDEBUG_COMPONENT("channel_18_analyzer_1_center", mcposachannel_18_analyzer_1_center, mcrotachannel_18_analyzer_1_center)
  mccomp_posa[812] = mcposachannel_18_analyzer_1_center;
  mccomp_posr[812] = mcposrchannel_18_analyzer_1_center;
  mcNCounter[812]  = mcPCounter[812] = mcP2Counter[812] = 0;
  mcAbsorbProp[812]= 0;
    /* Component channel_18_analyzer_1_rotated. */
  /* Setting parameters for component channel_18_analyzer_1_rotated. */
  SIG_MESSAGE("channel_18_analyzer_1_rotated (Init:SetPar)");

  SIG_MESSAGE("channel_18_analyzer_1_rotated (Init:Place/Rotate)");
  rot_set_rotation(mctr1,
#line 4547 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 4547 "MACS_sample_kidney_box.instr"
    (180 - analyzer_theta [ 18 ])*DEG2RAD,
#line 4547 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD);
#line 145052 "MACS_sample_kidney_box.c"
  rot_mul(mctr1, mcrotachannel_18_analyzer_1_center, mcrotachannel_18_analyzer_1_rotated);
  rot_transpose(mcrotachannel_18_analyzer_1_center, mctr1);
  rot_mul(mcrotachannel_18_analyzer_1_rotated, mctr1, mcrotrchannel_18_analyzer_1_rotated);
  mctc1 = coords_set(
#line 4546 "MACS_sample_kidney_box.instr"
    0,
#line 4546 "MACS_sample_kidney_box.instr"
    0,
#line 4546 "MACS_sample_kidney_box.instr"
    -0.5 * analyzer_seperation / tan ( analyzer_2theta [ 18 ] * DEG2RAD ));
#line 145063 "MACS_sample_kidney_box.c"
  rot_transpose(mcrotachannel_18_analyzer_1_center, mctr1);
  mctc2 = rot_apply(mctr1, mctc1);
  mcposachannel_18_analyzer_1_rotated = coords_add(mcposachannel_18_analyzer_1_center, mctc2);
  mctc1 = coords_sub(mcposachannel_18_analyzer_1_center, mcposachannel_18_analyzer_1_rotated);
  mcposrchannel_18_analyzer_1_rotated = rot_apply(mcrotachannel_18_analyzer_1_rotated, mctc1);
  mcDEBUG_COMPONENT("channel_18_analyzer_1_rotated", mcposachannel_18_analyzer_1_rotated, mcrotachannel_18_analyzer_1_rotated)
  mccomp_posa[813] = mcposachannel_18_analyzer_1_rotated;
  mccomp_posr[813] = mcposrchannel_18_analyzer_1_rotated;
  mcNCounter[813]  = mcPCounter[813] = mcP2Counter[813] = 0;
  mcAbsorbProp[813]= 0;
    /* Component channel_18_analyzer_1_array_crystal_array_0. */
  /* Setting parameters for component channel_18_analyzer_1_array_crystal_array_0. */
  SIG_MESSAGE("channel_18_analyzer_1_array_crystal_array_0 (Init:SetPar)");
#line 4551 "MACS_sample_kidney_box.instr"
  if("PG_analyzer") strncpy(mccchannel_18_analyzer_1_array_crystal_array_0_material_string, "PG_analyzer" ? "PG_analyzer" : "", 16384); else mccchannel_18_analyzer_1_array_crystal_array_0_material_string[0]='\0';
#line 4551 "MACS_sample_kidney_box.instr"
  mccchannel_18_analyzer_1_array_crystal_array_0_priority = 2020.0;
#line 4550 "MACS_sample_kidney_box.instr"
  mccchannel_18_analyzer_1_array_crystal_array_0_xwidth = channel_18_analyzer_1_array_crystal_depth;
#line 4550 "MACS_sample_kidney_box.instr"
  mccchannel_18_analyzer_1_array_crystal_array_0_yheight = channel_18_analyzer_1_array_crystal_height;
#line 4550 "MACS_sample_kidney_box.instr"
  mccchannel_18_analyzer_1_array_crystal_array_0_zdepth = channel_18_analyzer_1_array_crystal_width;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_18_analyzer_1_array_crystal_array_0_xwidth2 = -1;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_18_analyzer_1_array_crystal_array_0_yheight2 = -1;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_18_analyzer_1_array_crystal_array_0_visualize = 1;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_18_analyzer_1_array_crystal_array_0_target_index = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_18_analyzer_1_array_crystal_array_0_target_x = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_18_analyzer_1_array_crystal_array_0_target_y = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_18_analyzer_1_array_crystal_array_0_target_z = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_18_analyzer_1_array_crystal_array_0_focus_aw = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_18_analyzer_1_array_crystal_array_0_focus_ah = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_18_analyzer_1_array_crystal_array_0_focus_xw = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_18_analyzer_1_array_crystal_array_0_focus_xh = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_18_analyzer_1_array_crystal_array_0_focus_r = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_18_analyzer_1_array_crystal_array_0_p_interact = 0;
#line 71 "MACS_sample_kidney_box.instr"
  if(0) strncpy(mccchannel_18_analyzer_1_array_crystal_array_0_mask_string, 0 ? 0 : "", 16384); else mccchannel_18_analyzer_1_array_crystal_array_0_mask_string[0]='\0';
#line 71 "MACS_sample_kidney_box.instr"
  if(0) strncpy(mccchannel_18_analyzer_1_array_crystal_array_0_mask_setting, 0 ? 0 : "", 16384); else mccchannel_18_analyzer_1_array_crystal_array_0_mask_setting[0]='\0';
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_18_analyzer_1_array_crystal_array_0_number_of_activations = 1;
#line 145119 "MACS_sample_kidney_box.c"

  SIG_MESSAGE("channel_18_analyzer_1_array_crystal_array_0 (Init:Place/Rotate)");
  rot_set_rotation(mctr1,
#line 4553 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 4553 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 4553 "MACS_sample_kidney_box.instr"
    (0 - RAD2DEG * channel_18_analyzer_1_array_theta [ 0 ])*DEG2RAD);
#line 145129 "MACS_sample_kidney_box.c"
  rot_mul(mctr1, mcrotachannel_18_analyzer_1_rotated, mcrotachannel_18_analyzer_1_array_crystal_array_0);
  rot_transpose(mcrotachannel_18_analyzer_1_rotated, mctr1);
  rot_mul(mcrotachannel_18_analyzer_1_array_crystal_array_0, mctr1, mcrotrchannel_18_analyzer_1_array_crystal_array_0);
  mctc1 = coords_set(
#line 4552 "MACS_sample_kidney_box.instr"
    0 + channel_18_analyzer_1_array_effective_radius_of_curvature * ( 1 - cos ( channel_18_analyzer_1_array_theta [ 0 ] ) ),
#line 4552 "MACS_sample_kidney_box.instr"
    0 + channel_18_analyzer_1_array_effective_radius_of_curvature * sin ( channel_18_analyzer_1_array_theta [ 0 ] ),
#line 4552 "MACS_sample_kidney_box.instr"
    0);
#line 145140 "MACS_sample_kidney_box.c"
  rot_transpose(mcrotachannel_18_analyzer_1_rotated, mctr1);
  mctc2 = rot_apply(mctr1, mctc1);
  mcposachannel_18_analyzer_1_array_crystal_array_0 = coords_add(mcposachannel_18_analyzer_1_rotated, mctc2);
  mctc1 = coords_sub(mcposachannel_18_analyzer_1_rotated, mcposachannel_18_analyzer_1_array_crystal_array_0);
  mcposrchannel_18_analyzer_1_array_crystal_array_0 = rot_apply(mcrotachannel_18_analyzer_1_array_crystal_array_0, mctc1);
  mcDEBUG_COMPONENT("channel_18_analyzer_1_array_crystal_array_0", mcposachannel_18_analyzer_1_array_crystal_array_0, mcrotachannel_18_analyzer_1_array_crystal_array_0)
  mccomp_posa[814] = mcposachannel_18_analyzer_1_array_crystal_array_0;
  mccomp_posr[814] = mcposrchannel_18_analyzer_1_array_crystal_array_0;
  mcNCounter[814]  = mcPCounter[814] = mcP2Counter[814] = 0;
  mcAbsorbProp[814]= 0;
    /* Component channel_18_analyzer_1_array_crystal_array_1. */
  /* Setting parameters for component channel_18_analyzer_1_array_crystal_array_1. */
  SIG_MESSAGE("channel_18_analyzer_1_array_crystal_array_1 (Init:SetPar)");
#line 4557 "MACS_sample_kidney_box.instr"
  if("PG_analyzer") strncpy(mccchannel_18_analyzer_1_array_crystal_array_1_material_string, "PG_analyzer" ? "PG_analyzer" : "", 16384); else mccchannel_18_analyzer_1_array_crystal_array_1_material_string[0]='\0';
#line 4557 "MACS_sample_kidney_box.instr"
  mccchannel_18_analyzer_1_array_crystal_array_1_priority = 2020.1;
#line 4556 "MACS_sample_kidney_box.instr"
  mccchannel_18_analyzer_1_array_crystal_array_1_xwidth = channel_18_analyzer_1_array_crystal_depth;
#line 4556 "MACS_sample_kidney_box.instr"
  mccchannel_18_analyzer_1_array_crystal_array_1_yheight = channel_18_analyzer_1_array_crystal_height;
#line 4556 "MACS_sample_kidney_box.instr"
  mccchannel_18_analyzer_1_array_crystal_array_1_zdepth = channel_18_analyzer_1_array_crystal_width;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_18_analyzer_1_array_crystal_array_1_xwidth2 = -1;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_18_analyzer_1_array_crystal_array_1_yheight2 = -1;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_18_analyzer_1_array_crystal_array_1_visualize = 1;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_18_analyzer_1_array_crystal_array_1_target_index = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_18_analyzer_1_array_crystal_array_1_target_x = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_18_analyzer_1_array_crystal_array_1_target_y = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_18_analyzer_1_array_crystal_array_1_target_z = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_18_analyzer_1_array_crystal_array_1_focus_aw = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_18_analyzer_1_array_crystal_array_1_focus_ah = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_18_analyzer_1_array_crystal_array_1_focus_xw = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_18_analyzer_1_array_crystal_array_1_focus_xh = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_18_analyzer_1_array_crystal_array_1_focus_r = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_18_analyzer_1_array_crystal_array_1_p_interact = 0;
#line 71 "MACS_sample_kidney_box.instr"
  if(0) strncpy(mccchannel_18_analyzer_1_array_crystal_array_1_mask_string, 0 ? 0 : "", 16384); else mccchannel_18_analyzer_1_array_crystal_array_1_mask_string[0]='\0';
#line 71 "MACS_sample_kidney_box.instr"
  if(0) strncpy(mccchannel_18_analyzer_1_array_crystal_array_1_mask_setting, 0 ? 0 : "", 16384); else mccchannel_18_analyzer_1_array_crystal_array_1_mask_setting[0]='\0';
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_18_analyzer_1_array_crystal_array_1_number_of_activations = 1;
#line 145196 "MACS_sample_kidney_box.c"

  SIG_MESSAGE("channel_18_analyzer_1_array_crystal_array_1 (Init:Place/Rotate)");
  rot_set_rotation(mctr1,
#line 4559 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 4559 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 4559 "MACS_sample_kidney_box.instr"
    (0 - RAD2DEG * channel_18_analyzer_1_array_theta [ 1 ])*DEG2RAD);
#line 145206 "MACS_sample_kidney_box.c"
  rot_mul(mctr1, mcrotachannel_18_analyzer_1_rotated, mcrotachannel_18_analyzer_1_array_crystal_array_1);
  rot_transpose(mcrotachannel_18_analyzer_1_array_crystal_array_0, mctr1);
  rot_mul(mcrotachannel_18_analyzer_1_array_crystal_array_1, mctr1, mcrotrchannel_18_analyzer_1_array_crystal_array_1);
  mctc1 = coords_set(
#line 4558 "MACS_sample_kidney_box.instr"
    0 + channel_18_analyzer_1_array_effective_radius_of_curvature * ( 1 - cos ( channel_18_analyzer_1_array_theta [ 1 ] ) ),
#line 4558 "MACS_sample_kidney_box.instr"
    0 + channel_18_analyzer_1_array_effective_radius_of_curvature * sin ( channel_18_analyzer_1_array_theta [ 1 ] ),
#line 4558 "MACS_sample_kidney_box.instr"
    0);
#line 145217 "MACS_sample_kidney_box.c"
  rot_transpose(mcrotachannel_18_analyzer_1_rotated, mctr1);
  mctc2 = rot_apply(mctr1, mctc1);
  mcposachannel_18_analyzer_1_array_crystal_array_1 = coords_add(mcposachannel_18_analyzer_1_rotated, mctc2);
  mctc1 = coords_sub(mcposachannel_18_analyzer_1_array_crystal_array_0, mcposachannel_18_analyzer_1_array_crystal_array_1);
  mcposrchannel_18_analyzer_1_array_crystal_array_1 = rot_apply(mcrotachannel_18_analyzer_1_array_crystal_array_1, mctc1);
  mcDEBUG_COMPONENT("channel_18_analyzer_1_array_crystal_array_1", mcposachannel_18_analyzer_1_array_crystal_array_1, mcrotachannel_18_analyzer_1_array_crystal_array_1)
  mccomp_posa[815] = mcposachannel_18_analyzer_1_array_crystal_array_1;
  mccomp_posr[815] = mcposrchannel_18_analyzer_1_array_crystal_array_1;
  mcNCounter[815]  = mcPCounter[815] = mcP2Counter[815] = 0;
  mcAbsorbProp[815]= 0;
    /* Component channel_18_analyzer_1_array_crystal_array_2. */
  /* Setting parameters for component channel_18_analyzer_1_array_crystal_array_2. */
  SIG_MESSAGE("channel_18_analyzer_1_array_crystal_array_2 (Init:SetPar)");
#line 4563 "MACS_sample_kidney_box.instr"
  if("PG_analyzer") strncpy(mccchannel_18_analyzer_1_array_crystal_array_2_material_string, "PG_analyzer" ? "PG_analyzer" : "", 16384); else mccchannel_18_analyzer_1_array_crystal_array_2_material_string[0]='\0';
#line 4563 "MACS_sample_kidney_box.instr"
  mccchannel_18_analyzer_1_array_crystal_array_2_priority = 2020.2;
#line 4562 "MACS_sample_kidney_box.instr"
  mccchannel_18_analyzer_1_array_crystal_array_2_xwidth = channel_18_analyzer_1_array_crystal_depth;
#line 4562 "MACS_sample_kidney_box.instr"
  mccchannel_18_analyzer_1_array_crystal_array_2_yheight = channel_18_analyzer_1_array_crystal_height;
#line 4562 "MACS_sample_kidney_box.instr"
  mccchannel_18_analyzer_1_array_crystal_array_2_zdepth = channel_18_analyzer_1_array_crystal_width;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_18_analyzer_1_array_crystal_array_2_xwidth2 = -1;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_18_analyzer_1_array_crystal_array_2_yheight2 = -1;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_18_analyzer_1_array_crystal_array_2_visualize = 1;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_18_analyzer_1_array_crystal_array_2_target_index = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_18_analyzer_1_array_crystal_array_2_target_x = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_18_analyzer_1_array_crystal_array_2_target_y = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_18_analyzer_1_array_crystal_array_2_target_z = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_18_analyzer_1_array_crystal_array_2_focus_aw = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_18_analyzer_1_array_crystal_array_2_focus_ah = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_18_analyzer_1_array_crystal_array_2_focus_xw = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_18_analyzer_1_array_crystal_array_2_focus_xh = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_18_analyzer_1_array_crystal_array_2_focus_r = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_18_analyzer_1_array_crystal_array_2_p_interact = 0;
#line 71 "MACS_sample_kidney_box.instr"
  if(0) strncpy(mccchannel_18_analyzer_1_array_crystal_array_2_mask_string, 0 ? 0 : "", 16384); else mccchannel_18_analyzer_1_array_crystal_array_2_mask_string[0]='\0';
#line 71 "MACS_sample_kidney_box.instr"
  if(0) strncpy(mccchannel_18_analyzer_1_array_crystal_array_2_mask_setting, 0 ? 0 : "", 16384); else mccchannel_18_analyzer_1_array_crystal_array_2_mask_setting[0]='\0';
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_18_analyzer_1_array_crystal_array_2_number_of_activations = 1;
#line 145273 "MACS_sample_kidney_box.c"

  SIG_MESSAGE("channel_18_analyzer_1_array_crystal_array_2 (Init:Place/Rotate)");
  rot_set_rotation(mctr1,
#line 4565 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 4565 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 4565 "MACS_sample_kidney_box.instr"
    (0 - RAD2DEG * channel_18_analyzer_1_array_theta [ 2 ])*DEG2RAD);
#line 145283 "MACS_sample_kidney_box.c"
  rot_mul(mctr1, mcrotachannel_18_analyzer_1_rotated, mcrotachannel_18_analyzer_1_array_crystal_array_2);
  rot_transpose(mcrotachannel_18_analyzer_1_array_crystal_array_1, mctr1);
  rot_mul(mcrotachannel_18_analyzer_1_array_crystal_array_2, mctr1, mcrotrchannel_18_analyzer_1_array_crystal_array_2);
  mctc1 = coords_set(
#line 4564 "MACS_sample_kidney_box.instr"
    0 + channel_18_analyzer_1_array_effective_radius_of_curvature * ( 1 - cos ( channel_18_analyzer_1_array_theta [ 2 ] ) ),
#line 4564 "MACS_sample_kidney_box.instr"
    0 + channel_18_analyzer_1_array_effective_radius_of_curvature * sin ( channel_18_analyzer_1_array_theta [ 2 ] ),
#line 4564 "MACS_sample_kidney_box.instr"
    0);
#line 145294 "MACS_sample_kidney_box.c"
  rot_transpose(mcrotachannel_18_analyzer_1_rotated, mctr1);
  mctc2 = rot_apply(mctr1, mctc1);
  mcposachannel_18_analyzer_1_array_crystal_array_2 = coords_add(mcposachannel_18_analyzer_1_rotated, mctc2);
  mctc1 = coords_sub(mcposachannel_18_analyzer_1_array_crystal_array_1, mcposachannel_18_analyzer_1_array_crystal_array_2);
  mcposrchannel_18_analyzer_1_array_crystal_array_2 = rot_apply(mcrotachannel_18_analyzer_1_array_crystal_array_2, mctc1);
  mcDEBUG_COMPONENT("channel_18_analyzer_1_array_crystal_array_2", mcposachannel_18_analyzer_1_array_crystal_array_2, mcrotachannel_18_analyzer_1_array_crystal_array_2)
  mccomp_posa[816] = mcposachannel_18_analyzer_1_array_crystal_array_2;
  mccomp_posr[816] = mcposrchannel_18_analyzer_1_array_crystal_array_2;
  mcNCounter[816]  = mcPCounter[816] = mcP2Counter[816] = 0;
  mcAbsorbProp[816]= 0;
    /* Component channel_18_analyzer_1_array_crystal_array_3. */
  /* Setting parameters for component channel_18_analyzer_1_array_crystal_array_3. */
  SIG_MESSAGE("channel_18_analyzer_1_array_crystal_array_3 (Init:SetPar)");
#line 4569 "MACS_sample_kidney_box.instr"
  if("PG_analyzer") strncpy(mccchannel_18_analyzer_1_array_crystal_array_3_material_string, "PG_analyzer" ? "PG_analyzer" : "", 16384); else mccchannel_18_analyzer_1_array_crystal_array_3_material_string[0]='\0';
#line 4569 "MACS_sample_kidney_box.instr"
  mccchannel_18_analyzer_1_array_crystal_array_3_priority = 2020.3;
#line 4568 "MACS_sample_kidney_box.instr"
  mccchannel_18_analyzer_1_array_crystal_array_3_xwidth = channel_18_analyzer_1_array_crystal_depth;
#line 4568 "MACS_sample_kidney_box.instr"
  mccchannel_18_analyzer_1_array_crystal_array_3_yheight = channel_18_analyzer_1_array_crystal_height;
#line 4568 "MACS_sample_kidney_box.instr"
  mccchannel_18_analyzer_1_array_crystal_array_3_zdepth = channel_18_analyzer_1_array_crystal_width;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_18_analyzer_1_array_crystal_array_3_xwidth2 = -1;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_18_analyzer_1_array_crystal_array_3_yheight2 = -1;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_18_analyzer_1_array_crystal_array_3_visualize = 1;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_18_analyzer_1_array_crystal_array_3_target_index = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_18_analyzer_1_array_crystal_array_3_target_x = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_18_analyzer_1_array_crystal_array_3_target_y = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_18_analyzer_1_array_crystal_array_3_target_z = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_18_analyzer_1_array_crystal_array_3_focus_aw = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_18_analyzer_1_array_crystal_array_3_focus_ah = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_18_analyzer_1_array_crystal_array_3_focus_xw = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_18_analyzer_1_array_crystal_array_3_focus_xh = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_18_analyzer_1_array_crystal_array_3_focus_r = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_18_analyzer_1_array_crystal_array_3_p_interact = 0;
#line 71 "MACS_sample_kidney_box.instr"
  if(0) strncpy(mccchannel_18_analyzer_1_array_crystal_array_3_mask_string, 0 ? 0 : "", 16384); else mccchannel_18_analyzer_1_array_crystal_array_3_mask_string[0]='\0';
#line 71 "MACS_sample_kidney_box.instr"
  if(0) strncpy(mccchannel_18_analyzer_1_array_crystal_array_3_mask_setting, 0 ? 0 : "", 16384); else mccchannel_18_analyzer_1_array_crystal_array_3_mask_setting[0]='\0';
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_18_analyzer_1_array_crystal_array_3_number_of_activations = 1;
#line 145350 "MACS_sample_kidney_box.c"

  SIG_MESSAGE("channel_18_analyzer_1_array_crystal_array_3 (Init:Place/Rotate)");
  rot_set_rotation(mctr1,
#line 4571 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 4571 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 4571 "MACS_sample_kidney_box.instr"
    (0 - RAD2DEG * channel_18_analyzer_1_array_theta [ 3 ])*DEG2RAD);
#line 145360 "MACS_sample_kidney_box.c"
  rot_mul(mctr1, mcrotachannel_18_analyzer_1_rotated, mcrotachannel_18_analyzer_1_array_crystal_array_3);
  rot_transpose(mcrotachannel_18_analyzer_1_array_crystal_array_2, mctr1);
  rot_mul(mcrotachannel_18_analyzer_1_array_crystal_array_3, mctr1, mcrotrchannel_18_analyzer_1_array_crystal_array_3);
  mctc1 = coords_set(
#line 4570 "MACS_sample_kidney_box.instr"
    0 + channel_18_analyzer_1_array_effective_radius_of_curvature * ( 1 - cos ( channel_18_analyzer_1_array_theta [ 3 ] ) ),
#line 4570 "MACS_sample_kidney_box.instr"
    0 + channel_18_analyzer_1_array_effective_radius_of_curvature * sin ( channel_18_analyzer_1_array_theta [ 3 ] ),
#line 4570 "MACS_sample_kidney_box.instr"
    0);
#line 145371 "MACS_sample_kidney_box.c"
  rot_transpose(mcrotachannel_18_analyzer_1_rotated, mctr1);
  mctc2 = rot_apply(mctr1, mctc1);
  mcposachannel_18_analyzer_1_array_crystal_array_3 = coords_add(mcposachannel_18_analyzer_1_rotated, mctc2);
  mctc1 = coords_sub(mcposachannel_18_analyzer_1_array_crystal_array_2, mcposachannel_18_analyzer_1_array_crystal_array_3);
  mcposrchannel_18_analyzer_1_array_crystal_array_3 = rot_apply(mcrotachannel_18_analyzer_1_array_crystal_array_3, mctc1);
  mcDEBUG_COMPONENT("channel_18_analyzer_1_array_crystal_array_3", mcposachannel_18_analyzer_1_array_crystal_array_3, mcrotachannel_18_analyzer_1_array_crystal_array_3)
  mccomp_posa[817] = mcposachannel_18_analyzer_1_array_crystal_array_3;
  mccomp_posr[817] = mcposrchannel_18_analyzer_1_array_crystal_array_3;
  mcNCounter[817]  = mcPCounter[817] = mcP2Counter[817] = 0;
  mcAbsorbProp[817]= 0;
    /* Component channel_18_analyzer_1_array_crystal_array_4. */
  /* Setting parameters for component channel_18_analyzer_1_array_crystal_array_4. */
  SIG_MESSAGE("channel_18_analyzer_1_array_crystal_array_4 (Init:SetPar)");
#line 4575 "MACS_sample_kidney_box.instr"
  if("PG_analyzer") strncpy(mccchannel_18_analyzer_1_array_crystal_array_4_material_string, "PG_analyzer" ? "PG_analyzer" : "", 16384); else mccchannel_18_analyzer_1_array_crystal_array_4_material_string[0]='\0';
#line 4575 "MACS_sample_kidney_box.instr"
  mccchannel_18_analyzer_1_array_crystal_array_4_priority = 2020.4;
#line 4574 "MACS_sample_kidney_box.instr"
  mccchannel_18_analyzer_1_array_crystal_array_4_xwidth = channel_18_analyzer_1_array_crystal_depth;
#line 4574 "MACS_sample_kidney_box.instr"
  mccchannel_18_analyzer_1_array_crystal_array_4_yheight = channel_18_analyzer_1_array_crystal_height;
#line 4574 "MACS_sample_kidney_box.instr"
  mccchannel_18_analyzer_1_array_crystal_array_4_zdepth = channel_18_analyzer_1_array_crystal_width;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_18_analyzer_1_array_crystal_array_4_xwidth2 = -1;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_18_analyzer_1_array_crystal_array_4_yheight2 = -1;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_18_analyzer_1_array_crystal_array_4_visualize = 1;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_18_analyzer_1_array_crystal_array_4_target_index = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_18_analyzer_1_array_crystal_array_4_target_x = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_18_analyzer_1_array_crystal_array_4_target_y = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_18_analyzer_1_array_crystal_array_4_target_z = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_18_analyzer_1_array_crystal_array_4_focus_aw = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_18_analyzer_1_array_crystal_array_4_focus_ah = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_18_analyzer_1_array_crystal_array_4_focus_xw = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_18_analyzer_1_array_crystal_array_4_focus_xh = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_18_analyzer_1_array_crystal_array_4_focus_r = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_18_analyzer_1_array_crystal_array_4_p_interact = 0;
#line 71 "MACS_sample_kidney_box.instr"
  if(0) strncpy(mccchannel_18_analyzer_1_array_crystal_array_4_mask_string, 0 ? 0 : "", 16384); else mccchannel_18_analyzer_1_array_crystal_array_4_mask_string[0]='\0';
#line 71 "MACS_sample_kidney_box.instr"
  if(0) strncpy(mccchannel_18_analyzer_1_array_crystal_array_4_mask_setting, 0 ? 0 : "", 16384); else mccchannel_18_analyzer_1_array_crystal_array_4_mask_setting[0]='\0';
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_18_analyzer_1_array_crystal_array_4_number_of_activations = 1;
#line 145427 "MACS_sample_kidney_box.c"

  SIG_MESSAGE("channel_18_analyzer_1_array_crystal_array_4 (Init:Place/Rotate)");
  rot_set_rotation(mctr1,
#line 4577 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 4577 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 4577 "MACS_sample_kidney_box.instr"
    (0 - RAD2DEG * channel_18_analyzer_1_array_theta [ 4 ])*DEG2RAD);
#line 145437 "MACS_sample_kidney_box.c"
  rot_mul(mctr1, mcrotachannel_18_analyzer_1_rotated, mcrotachannel_18_analyzer_1_array_crystal_array_4);
  rot_transpose(mcrotachannel_18_analyzer_1_array_crystal_array_3, mctr1);
  rot_mul(mcrotachannel_18_analyzer_1_array_crystal_array_4, mctr1, mcrotrchannel_18_analyzer_1_array_crystal_array_4);
  mctc1 = coords_set(
#line 4576 "MACS_sample_kidney_box.instr"
    0 + channel_18_analyzer_1_array_effective_radius_of_curvature * ( 1 - cos ( channel_18_analyzer_1_array_theta [ 4 ] ) ),
#line 4576 "MACS_sample_kidney_box.instr"
    0 + channel_18_analyzer_1_array_effective_radius_of_curvature * sin ( channel_18_analyzer_1_array_theta [ 4 ] ),
#line 4576 "MACS_sample_kidney_box.instr"
    0);
#line 145448 "MACS_sample_kidney_box.c"
  rot_transpose(mcrotachannel_18_analyzer_1_rotated, mctr1);
  mctc2 = rot_apply(mctr1, mctc1);
  mcposachannel_18_analyzer_1_array_crystal_array_4 = coords_add(mcposachannel_18_analyzer_1_rotated, mctc2);
  mctc1 = coords_sub(mcposachannel_18_analyzer_1_array_crystal_array_3, mcposachannel_18_analyzer_1_array_crystal_array_4);
  mcposrchannel_18_analyzer_1_array_crystal_array_4 = rot_apply(mcrotachannel_18_analyzer_1_array_crystal_array_4, mctc1);
  mcDEBUG_COMPONENT("channel_18_analyzer_1_array_crystal_array_4", mcposachannel_18_analyzer_1_array_crystal_array_4, mcrotachannel_18_analyzer_1_array_crystal_array_4)
  mccomp_posa[818] = mcposachannel_18_analyzer_1_array_crystal_array_4;
  mccomp_posr[818] = mcposrchannel_18_analyzer_1_array_crystal_array_4;
  mcNCounter[818]  = mcPCounter[818] = mcP2Counter[818] = 0;
  mcAbsorbProp[818]= 0;
    /* Component channel_18_analyzer_1_array_crystal_array_5. */
  /* Setting parameters for component channel_18_analyzer_1_array_crystal_array_5. */
  SIG_MESSAGE("channel_18_analyzer_1_array_crystal_array_5 (Init:SetPar)");
#line 4581 "MACS_sample_kidney_box.instr"
  if("PG_analyzer") strncpy(mccchannel_18_analyzer_1_array_crystal_array_5_material_string, "PG_analyzer" ? "PG_analyzer" : "", 16384); else mccchannel_18_analyzer_1_array_crystal_array_5_material_string[0]='\0';
#line 4581 "MACS_sample_kidney_box.instr"
  mccchannel_18_analyzer_1_array_crystal_array_5_priority = 2020.5;
#line 4580 "MACS_sample_kidney_box.instr"
  mccchannel_18_analyzer_1_array_crystal_array_5_xwidth = channel_18_analyzer_1_array_crystal_depth;
#line 4580 "MACS_sample_kidney_box.instr"
  mccchannel_18_analyzer_1_array_crystal_array_5_yheight = channel_18_analyzer_1_array_crystal_height;
#line 4580 "MACS_sample_kidney_box.instr"
  mccchannel_18_analyzer_1_array_crystal_array_5_zdepth = channel_18_analyzer_1_array_crystal_width;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_18_analyzer_1_array_crystal_array_5_xwidth2 = -1;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_18_analyzer_1_array_crystal_array_5_yheight2 = -1;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_18_analyzer_1_array_crystal_array_5_visualize = 1;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_18_analyzer_1_array_crystal_array_5_target_index = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_18_analyzer_1_array_crystal_array_5_target_x = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_18_analyzer_1_array_crystal_array_5_target_y = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_18_analyzer_1_array_crystal_array_5_target_z = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_18_analyzer_1_array_crystal_array_5_focus_aw = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_18_analyzer_1_array_crystal_array_5_focus_ah = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_18_analyzer_1_array_crystal_array_5_focus_xw = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_18_analyzer_1_array_crystal_array_5_focus_xh = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_18_analyzer_1_array_crystal_array_5_focus_r = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_18_analyzer_1_array_crystal_array_5_p_interact = 0;
#line 71 "MACS_sample_kidney_box.instr"
  if(0) strncpy(mccchannel_18_analyzer_1_array_crystal_array_5_mask_string, 0 ? 0 : "", 16384); else mccchannel_18_analyzer_1_array_crystal_array_5_mask_string[0]='\0';
#line 71 "MACS_sample_kidney_box.instr"
  if(0) strncpy(mccchannel_18_analyzer_1_array_crystal_array_5_mask_setting, 0 ? 0 : "", 16384); else mccchannel_18_analyzer_1_array_crystal_array_5_mask_setting[0]='\0';
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_18_analyzer_1_array_crystal_array_5_number_of_activations = 1;
#line 145504 "MACS_sample_kidney_box.c"

  SIG_MESSAGE("channel_18_analyzer_1_array_crystal_array_5 (Init:Place/Rotate)");
  rot_set_rotation(mctr1,
#line 4583 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 4583 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 4583 "MACS_sample_kidney_box.instr"
    (0 - RAD2DEG * channel_18_analyzer_1_array_theta [ 5 ])*DEG2RAD);
#line 145514 "MACS_sample_kidney_box.c"
  rot_mul(mctr1, mcrotachannel_18_analyzer_1_rotated, mcrotachannel_18_analyzer_1_array_crystal_array_5);
  rot_transpose(mcrotachannel_18_analyzer_1_array_crystal_array_4, mctr1);
  rot_mul(mcrotachannel_18_analyzer_1_array_crystal_array_5, mctr1, mcrotrchannel_18_analyzer_1_array_crystal_array_5);
  mctc1 = coords_set(
#line 4582 "MACS_sample_kidney_box.instr"
    0 + channel_18_analyzer_1_array_effective_radius_of_curvature * ( 1 - cos ( channel_18_analyzer_1_array_theta [ 5 ] ) ),
#line 4582 "MACS_sample_kidney_box.instr"
    0 + channel_18_analyzer_1_array_effective_radius_of_curvature * sin ( channel_18_analyzer_1_array_theta [ 5 ] ),
#line 4582 "MACS_sample_kidney_box.instr"
    0);
#line 145525 "MACS_sample_kidney_box.c"
  rot_transpose(mcrotachannel_18_analyzer_1_rotated, mctr1);
  mctc2 = rot_apply(mctr1, mctc1);
  mcposachannel_18_analyzer_1_array_crystal_array_5 = coords_add(mcposachannel_18_analyzer_1_rotated, mctc2);
  mctc1 = coords_sub(mcposachannel_18_analyzer_1_array_crystal_array_4, mcposachannel_18_analyzer_1_array_crystal_array_5);
  mcposrchannel_18_analyzer_1_array_crystal_array_5 = rot_apply(mcrotachannel_18_analyzer_1_array_crystal_array_5, mctc1);
  mcDEBUG_COMPONENT("channel_18_analyzer_1_array_crystal_array_5", mcposachannel_18_analyzer_1_array_crystal_array_5, mcrotachannel_18_analyzer_1_array_crystal_array_5)
  mccomp_posa[819] = mcposachannel_18_analyzer_1_array_crystal_array_5;
  mccomp_posr[819] = mcposrchannel_18_analyzer_1_array_crystal_array_5;
  mcNCounter[819]  = mcPCounter[819] = mcP2Counter[819] = 0;
  mcAbsorbProp[819]= 0;
    /* Component channel_18_analyzer_1_array_crystal_array_6. */
  /* Setting parameters for component channel_18_analyzer_1_array_crystal_array_6. */
  SIG_MESSAGE("channel_18_analyzer_1_array_crystal_array_6 (Init:SetPar)");
#line 4587 "MACS_sample_kidney_box.instr"
  if("PG_analyzer") strncpy(mccchannel_18_analyzer_1_array_crystal_array_6_material_string, "PG_analyzer" ? "PG_analyzer" : "", 16384); else mccchannel_18_analyzer_1_array_crystal_array_6_material_string[0]='\0';
#line 4587 "MACS_sample_kidney_box.instr"
  mccchannel_18_analyzer_1_array_crystal_array_6_priority = 2020.6;
#line 4586 "MACS_sample_kidney_box.instr"
  mccchannel_18_analyzer_1_array_crystal_array_6_xwidth = channel_18_analyzer_1_array_crystal_depth;
#line 4586 "MACS_sample_kidney_box.instr"
  mccchannel_18_analyzer_1_array_crystal_array_6_yheight = channel_18_analyzer_1_array_crystal_height;
#line 4586 "MACS_sample_kidney_box.instr"
  mccchannel_18_analyzer_1_array_crystal_array_6_zdepth = channel_18_analyzer_1_array_crystal_width;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_18_analyzer_1_array_crystal_array_6_xwidth2 = -1;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_18_analyzer_1_array_crystal_array_6_yheight2 = -1;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_18_analyzer_1_array_crystal_array_6_visualize = 1;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_18_analyzer_1_array_crystal_array_6_target_index = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_18_analyzer_1_array_crystal_array_6_target_x = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_18_analyzer_1_array_crystal_array_6_target_y = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_18_analyzer_1_array_crystal_array_6_target_z = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_18_analyzer_1_array_crystal_array_6_focus_aw = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_18_analyzer_1_array_crystal_array_6_focus_ah = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_18_analyzer_1_array_crystal_array_6_focus_xw = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_18_analyzer_1_array_crystal_array_6_focus_xh = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_18_analyzer_1_array_crystal_array_6_focus_r = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_18_analyzer_1_array_crystal_array_6_p_interact = 0;
#line 71 "MACS_sample_kidney_box.instr"
  if(0) strncpy(mccchannel_18_analyzer_1_array_crystal_array_6_mask_string, 0 ? 0 : "", 16384); else mccchannel_18_analyzer_1_array_crystal_array_6_mask_string[0]='\0';
#line 71 "MACS_sample_kidney_box.instr"
  if(0) strncpy(mccchannel_18_analyzer_1_array_crystal_array_6_mask_setting, 0 ? 0 : "", 16384); else mccchannel_18_analyzer_1_array_crystal_array_6_mask_setting[0]='\0';
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_18_analyzer_1_array_crystal_array_6_number_of_activations = 1;
#line 145581 "MACS_sample_kidney_box.c"

  SIG_MESSAGE("channel_18_analyzer_1_array_crystal_array_6 (Init:Place/Rotate)");
  rot_set_rotation(mctr1,
#line 4589 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 4589 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 4589 "MACS_sample_kidney_box.instr"
    (0 - RAD2DEG * channel_18_analyzer_1_array_theta [ 6 ])*DEG2RAD);
#line 145591 "MACS_sample_kidney_box.c"
  rot_mul(mctr1, mcrotachannel_18_analyzer_1_rotated, mcrotachannel_18_analyzer_1_array_crystal_array_6);
  rot_transpose(mcrotachannel_18_analyzer_1_array_crystal_array_5, mctr1);
  rot_mul(mcrotachannel_18_analyzer_1_array_crystal_array_6, mctr1, mcrotrchannel_18_analyzer_1_array_crystal_array_6);
  mctc1 = coords_set(
#line 4588 "MACS_sample_kidney_box.instr"
    0 + channel_18_analyzer_1_array_effective_radius_of_curvature * ( 1 - cos ( channel_18_analyzer_1_array_theta [ 6 ] ) ),
#line 4588 "MACS_sample_kidney_box.instr"
    0 + channel_18_analyzer_1_array_effective_radius_of_curvature * sin ( channel_18_analyzer_1_array_theta [ 6 ] ),
#line 4588 "MACS_sample_kidney_box.instr"
    0);
#line 145602 "MACS_sample_kidney_box.c"
  rot_transpose(mcrotachannel_18_analyzer_1_rotated, mctr1);
  mctc2 = rot_apply(mctr1, mctc1);
  mcposachannel_18_analyzer_1_array_crystal_array_6 = coords_add(mcposachannel_18_analyzer_1_rotated, mctc2);
  mctc1 = coords_sub(mcposachannel_18_analyzer_1_array_crystal_array_5, mcposachannel_18_analyzer_1_array_crystal_array_6);
  mcposrchannel_18_analyzer_1_array_crystal_array_6 = rot_apply(mcrotachannel_18_analyzer_1_array_crystal_array_6, mctc1);
  mcDEBUG_COMPONENT("channel_18_analyzer_1_array_crystal_array_6", mcposachannel_18_analyzer_1_array_crystal_array_6, mcrotachannel_18_analyzer_1_array_crystal_array_6)
  mccomp_posa[820] = mcposachannel_18_analyzer_1_array_crystal_array_6;
  mccomp_posr[820] = mcposrchannel_18_analyzer_1_array_crystal_array_6;
  mcNCounter[820]  = mcPCounter[820] = mcP2Counter[820] = 0;
  mcAbsorbProp[820]= 0;
    /* Component channel_18_analyzer_1_array_crystal_array_7. */
  /* Setting parameters for component channel_18_analyzer_1_array_crystal_array_7. */
  SIG_MESSAGE("channel_18_analyzer_1_array_crystal_array_7 (Init:SetPar)");
#line 4593 "MACS_sample_kidney_box.instr"
  if("PG_analyzer") strncpy(mccchannel_18_analyzer_1_array_crystal_array_7_material_string, "PG_analyzer" ? "PG_analyzer" : "", 16384); else mccchannel_18_analyzer_1_array_crystal_array_7_material_string[0]='\0';
#line 4593 "MACS_sample_kidney_box.instr"
  mccchannel_18_analyzer_1_array_crystal_array_7_priority = 2020.7;
#line 4592 "MACS_sample_kidney_box.instr"
  mccchannel_18_analyzer_1_array_crystal_array_7_xwidth = channel_18_analyzer_1_array_crystal_depth;
#line 4592 "MACS_sample_kidney_box.instr"
  mccchannel_18_analyzer_1_array_crystal_array_7_yheight = channel_18_analyzer_1_array_crystal_height;
#line 4592 "MACS_sample_kidney_box.instr"
  mccchannel_18_analyzer_1_array_crystal_array_7_zdepth = channel_18_analyzer_1_array_crystal_width;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_18_analyzer_1_array_crystal_array_7_xwidth2 = -1;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_18_analyzer_1_array_crystal_array_7_yheight2 = -1;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_18_analyzer_1_array_crystal_array_7_visualize = 1;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_18_analyzer_1_array_crystal_array_7_target_index = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_18_analyzer_1_array_crystal_array_7_target_x = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_18_analyzer_1_array_crystal_array_7_target_y = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_18_analyzer_1_array_crystal_array_7_target_z = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_18_analyzer_1_array_crystal_array_7_focus_aw = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_18_analyzer_1_array_crystal_array_7_focus_ah = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_18_analyzer_1_array_crystal_array_7_focus_xw = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_18_analyzer_1_array_crystal_array_7_focus_xh = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_18_analyzer_1_array_crystal_array_7_focus_r = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_18_analyzer_1_array_crystal_array_7_p_interact = 0;
#line 71 "MACS_sample_kidney_box.instr"
  if(0) strncpy(mccchannel_18_analyzer_1_array_crystal_array_7_mask_string, 0 ? 0 : "", 16384); else mccchannel_18_analyzer_1_array_crystal_array_7_mask_string[0]='\0';
#line 71 "MACS_sample_kidney_box.instr"
  if(0) strncpy(mccchannel_18_analyzer_1_array_crystal_array_7_mask_setting, 0 ? 0 : "", 16384); else mccchannel_18_analyzer_1_array_crystal_array_7_mask_setting[0]='\0';
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_18_analyzer_1_array_crystal_array_7_number_of_activations = 1;
#line 145658 "MACS_sample_kidney_box.c"

  SIG_MESSAGE("channel_18_analyzer_1_array_crystal_array_7 (Init:Place/Rotate)");
  rot_set_rotation(mctr1,
#line 4595 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 4595 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 4595 "MACS_sample_kidney_box.instr"
    (0 - RAD2DEG * channel_18_analyzer_1_array_theta [ 7 ])*DEG2RAD);
#line 145668 "MACS_sample_kidney_box.c"
  rot_mul(mctr1, mcrotachannel_18_analyzer_1_rotated, mcrotachannel_18_analyzer_1_array_crystal_array_7);
  rot_transpose(mcrotachannel_18_analyzer_1_array_crystal_array_6, mctr1);
  rot_mul(mcrotachannel_18_analyzer_1_array_crystal_array_7, mctr1, mcrotrchannel_18_analyzer_1_array_crystal_array_7);
  mctc1 = coords_set(
#line 4594 "MACS_sample_kidney_box.instr"
    0 + channel_18_analyzer_1_array_effective_radius_of_curvature * ( 1 - cos ( channel_18_analyzer_1_array_theta [ 7 ] ) ),
#line 4594 "MACS_sample_kidney_box.instr"
    0 + channel_18_analyzer_1_array_effective_radius_of_curvature * sin ( channel_18_analyzer_1_array_theta [ 7 ] ),
#line 4594 "MACS_sample_kidney_box.instr"
    0);
#line 145679 "MACS_sample_kidney_box.c"
  rot_transpose(mcrotachannel_18_analyzer_1_rotated, mctr1);
  mctc2 = rot_apply(mctr1, mctc1);
  mcposachannel_18_analyzer_1_array_crystal_array_7 = coords_add(mcposachannel_18_analyzer_1_rotated, mctc2);
  mctc1 = coords_sub(mcposachannel_18_analyzer_1_array_crystal_array_6, mcposachannel_18_analyzer_1_array_crystal_array_7);
  mcposrchannel_18_analyzer_1_array_crystal_array_7 = rot_apply(mcrotachannel_18_analyzer_1_array_crystal_array_7, mctc1);
  mcDEBUG_COMPONENT("channel_18_analyzer_1_array_crystal_array_7", mcposachannel_18_analyzer_1_array_crystal_array_7, mcrotachannel_18_analyzer_1_array_crystal_array_7)
  mccomp_posa[821] = mcposachannel_18_analyzer_1_array_crystal_array_7;
  mccomp_posr[821] = mcposrchannel_18_analyzer_1_array_crystal_array_7;
  mcNCounter[821]  = mcPCounter[821] = mcP2Counter[821] = 0;
  mcAbsorbProp[821]= 0;
    /* Component channel_18_analyzer_1_array_crystal_array_8. */
  /* Setting parameters for component channel_18_analyzer_1_array_crystal_array_8. */
  SIG_MESSAGE("channel_18_analyzer_1_array_crystal_array_8 (Init:SetPar)");
#line 4599 "MACS_sample_kidney_box.instr"
  if("PG_analyzer") strncpy(mccchannel_18_analyzer_1_array_crystal_array_8_material_string, "PG_analyzer" ? "PG_analyzer" : "", 16384); else mccchannel_18_analyzer_1_array_crystal_array_8_material_string[0]='\0';
#line 4599 "MACS_sample_kidney_box.instr"
  mccchannel_18_analyzer_1_array_crystal_array_8_priority = 2020.8;
#line 4598 "MACS_sample_kidney_box.instr"
  mccchannel_18_analyzer_1_array_crystal_array_8_xwidth = channel_18_analyzer_1_array_crystal_depth;
#line 4598 "MACS_sample_kidney_box.instr"
  mccchannel_18_analyzer_1_array_crystal_array_8_yheight = channel_18_analyzer_1_array_crystal_height;
#line 4598 "MACS_sample_kidney_box.instr"
  mccchannel_18_analyzer_1_array_crystal_array_8_zdepth = channel_18_analyzer_1_array_crystal_width;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_18_analyzer_1_array_crystal_array_8_xwidth2 = -1;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_18_analyzer_1_array_crystal_array_8_yheight2 = -1;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_18_analyzer_1_array_crystal_array_8_visualize = 1;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_18_analyzer_1_array_crystal_array_8_target_index = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_18_analyzer_1_array_crystal_array_8_target_x = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_18_analyzer_1_array_crystal_array_8_target_y = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_18_analyzer_1_array_crystal_array_8_target_z = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_18_analyzer_1_array_crystal_array_8_focus_aw = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_18_analyzer_1_array_crystal_array_8_focus_ah = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_18_analyzer_1_array_crystal_array_8_focus_xw = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_18_analyzer_1_array_crystal_array_8_focus_xh = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_18_analyzer_1_array_crystal_array_8_focus_r = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_18_analyzer_1_array_crystal_array_8_p_interact = 0;
#line 71 "MACS_sample_kidney_box.instr"
  if(0) strncpy(mccchannel_18_analyzer_1_array_crystal_array_8_mask_string, 0 ? 0 : "", 16384); else mccchannel_18_analyzer_1_array_crystal_array_8_mask_string[0]='\0';
#line 71 "MACS_sample_kidney_box.instr"
  if(0) strncpy(mccchannel_18_analyzer_1_array_crystal_array_8_mask_setting, 0 ? 0 : "", 16384); else mccchannel_18_analyzer_1_array_crystal_array_8_mask_setting[0]='\0';
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_18_analyzer_1_array_crystal_array_8_number_of_activations = 1;
#line 145735 "MACS_sample_kidney_box.c"

  SIG_MESSAGE("channel_18_analyzer_1_array_crystal_array_8 (Init:Place/Rotate)");
  rot_set_rotation(mctr1,
#line 4601 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 4601 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 4601 "MACS_sample_kidney_box.instr"
    (0 - RAD2DEG * channel_18_analyzer_1_array_theta [ 8 ])*DEG2RAD);
#line 145745 "MACS_sample_kidney_box.c"
  rot_mul(mctr1, mcrotachannel_18_analyzer_1_rotated, mcrotachannel_18_analyzer_1_array_crystal_array_8);
  rot_transpose(mcrotachannel_18_analyzer_1_array_crystal_array_7, mctr1);
  rot_mul(mcrotachannel_18_analyzer_1_array_crystal_array_8, mctr1, mcrotrchannel_18_analyzer_1_array_crystal_array_8);
  mctc1 = coords_set(
#line 4600 "MACS_sample_kidney_box.instr"
    0 + channel_18_analyzer_1_array_effective_radius_of_curvature * ( 1 - cos ( channel_18_analyzer_1_array_theta [ 8 ] ) ),
#line 4600 "MACS_sample_kidney_box.instr"
    0 + channel_18_analyzer_1_array_effective_radius_of_curvature * sin ( channel_18_analyzer_1_array_theta [ 8 ] ),
#line 4600 "MACS_sample_kidney_box.instr"
    0);
#line 145756 "MACS_sample_kidney_box.c"
  rot_transpose(mcrotachannel_18_analyzer_1_rotated, mctr1);
  mctc2 = rot_apply(mctr1, mctc1);
  mcposachannel_18_analyzer_1_array_crystal_array_8 = coords_add(mcposachannel_18_analyzer_1_rotated, mctc2);
  mctc1 = coords_sub(mcposachannel_18_analyzer_1_array_crystal_array_7, mcposachannel_18_analyzer_1_array_crystal_array_8);
  mcposrchannel_18_analyzer_1_array_crystal_array_8 = rot_apply(mcrotachannel_18_analyzer_1_array_crystal_array_8, mctc1);
  mcDEBUG_COMPONENT("channel_18_analyzer_1_array_crystal_array_8", mcposachannel_18_analyzer_1_array_crystal_array_8, mcrotachannel_18_analyzer_1_array_crystal_array_8)
  mccomp_posa[822] = mcposachannel_18_analyzer_1_array_crystal_array_8;
  mccomp_posr[822] = mcposrchannel_18_analyzer_1_array_crystal_array_8;
  mcNCounter[822]  = mcPCounter[822] = mcP2Counter[822] = 0;
  mcAbsorbProp[822]= 0;
    /* Component channel_18_analyzer_2_center. */
  /* Setting parameters for component channel_18_analyzer_2_center. */
  SIG_MESSAGE("channel_18_analyzer_2_center (Init:SetPar)");

  SIG_MESSAGE("channel_18_analyzer_2_center (Init:Place/Rotate)");
  rot_set_rotation(mctr1,
    (0.0)*DEG2RAD,
    (0.0)*DEG2RAD,
    (0.0)*DEG2RAD);
#line 145776 "MACS_sample_kidney_box.c"
  rot_mul(mctr1, mcrotachannel_18_analyzer_1_center, mcrotachannel_18_analyzer_2_center);
  rot_transpose(mcrotachannel_18_analyzer_1_array_crystal_array_8, mctr1);
  rot_mul(mcrotachannel_18_analyzer_2_center, mctr1, mcrotrchannel_18_analyzer_2_center);
  mctc1 = coords_set(
#line 4605 "MACS_sample_kidney_box.instr"
    - analyzer_seperation,
#line 4605 "MACS_sample_kidney_box.instr"
    0,
#line 4605 "MACS_sample_kidney_box.instr"
    0);
#line 145787 "MACS_sample_kidney_box.c"
  rot_transpose(mcrotachannel_18_analyzer_1_center, mctr1);
  mctc2 = rot_apply(mctr1, mctc1);
  mcposachannel_18_analyzer_2_center = coords_add(mcposachannel_18_analyzer_1_center, mctc2);
  mctc1 = coords_sub(mcposachannel_18_analyzer_1_array_crystal_array_8, mcposachannel_18_analyzer_2_center);
  mcposrchannel_18_analyzer_2_center = rot_apply(mcrotachannel_18_analyzer_2_center, mctc1);
  mcDEBUG_COMPONENT("channel_18_analyzer_2_center", mcposachannel_18_analyzer_2_center, mcrotachannel_18_analyzer_2_center)
  mccomp_posa[823] = mcposachannel_18_analyzer_2_center;
  mccomp_posr[823] = mcposrchannel_18_analyzer_2_center;
  mcNCounter[823]  = mcPCounter[823] = mcP2Counter[823] = 0;
  mcAbsorbProp[823]= 0;
    /* Component channel_18_analyzer_2_rotated. */
  /* Setting parameters for component channel_18_analyzer_2_rotated. */
  SIG_MESSAGE("channel_18_analyzer_2_rotated (Init:SetPar)");

  SIG_MESSAGE("channel_18_analyzer_2_rotated (Init:Place/Rotate)");
  rot_set_rotation(mctr1,
#line 4609 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 4609 "MACS_sample_kidney_box.instr"
    (- analyzer_theta [ 18 ])*DEG2RAD,
#line 4609 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD);
#line 145810 "MACS_sample_kidney_box.c"
  rot_mul(mctr1, mcrotachannel_18_analyzer_2_center, mcrotachannel_18_analyzer_2_rotated);
  rot_transpose(mcrotachannel_18_analyzer_2_center, mctr1);
  rot_mul(mcrotachannel_18_analyzer_2_rotated, mctr1, mcrotrchannel_18_analyzer_2_rotated);
  mctc1 = coords_set(
#line 4608 "MACS_sample_kidney_box.instr"
    0,
#line 4608 "MACS_sample_kidney_box.instr"
    0,
#line 4608 "MACS_sample_kidney_box.instr"
    0.5 * analyzer_seperation / tan ( analyzer_2theta [ 18 ] * DEG2RAD ));
#line 145821 "MACS_sample_kidney_box.c"
  rot_transpose(mcrotachannel_18_analyzer_2_center, mctr1);
  mctc2 = rot_apply(mctr1, mctc1);
  mcposachannel_18_analyzer_2_rotated = coords_add(mcposachannel_18_analyzer_2_center, mctc2);
  mctc1 = coords_sub(mcposachannel_18_analyzer_2_center, mcposachannel_18_analyzer_2_rotated);
  mcposrchannel_18_analyzer_2_rotated = rot_apply(mcrotachannel_18_analyzer_2_rotated, mctc1);
  mcDEBUG_COMPONENT("channel_18_analyzer_2_rotated", mcposachannel_18_analyzer_2_rotated, mcrotachannel_18_analyzer_2_rotated)
  mccomp_posa[824] = mcposachannel_18_analyzer_2_rotated;
  mccomp_posr[824] = mcposrchannel_18_analyzer_2_rotated;
  mcNCounter[824]  = mcPCounter[824] = mcP2Counter[824] = 0;
  mcAbsorbProp[824]= 0;
    /* Component channel_18_analyzer_2_array_crystal_array_0. */
  /* Setting parameters for component channel_18_analyzer_2_array_crystal_array_0. */
  SIG_MESSAGE("channel_18_analyzer_2_array_crystal_array_0 (Init:SetPar)");
#line 4613 "MACS_sample_kidney_box.instr"
  if("PG_analyzer") strncpy(mccchannel_18_analyzer_2_array_crystal_array_0_material_string, "PG_analyzer" ? "PG_analyzer" : "", 16384); else mccchannel_18_analyzer_2_array_crystal_array_0_material_string[0]='\0';
#line 4613 "MACS_sample_kidney_box.instr"
  mccchannel_18_analyzer_2_array_crystal_array_0_priority = 2021.0;
#line 4612 "MACS_sample_kidney_box.instr"
  mccchannel_18_analyzer_2_array_crystal_array_0_xwidth = channel_18_analyzer_2_array_crystal_depth;
#line 4612 "MACS_sample_kidney_box.instr"
  mccchannel_18_analyzer_2_array_crystal_array_0_yheight = channel_18_analyzer_2_array_crystal_height;
#line 4612 "MACS_sample_kidney_box.instr"
  mccchannel_18_analyzer_2_array_crystal_array_0_zdepth = channel_18_analyzer_2_array_crystal_width;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_18_analyzer_2_array_crystal_array_0_xwidth2 = -1;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_18_analyzer_2_array_crystal_array_0_yheight2 = -1;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_18_analyzer_2_array_crystal_array_0_visualize = 1;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_18_analyzer_2_array_crystal_array_0_target_index = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_18_analyzer_2_array_crystal_array_0_target_x = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_18_analyzer_2_array_crystal_array_0_target_y = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_18_analyzer_2_array_crystal_array_0_target_z = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_18_analyzer_2_array_crystal_array_0_focus_aw = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_18_analyzer_2_array_crystal_array_0_focus_ah = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_18_analyzer_2_array_crystal_array_0_focus_xw = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_18_analyzer_2_array_crystal_array_0_focus_xh = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_18_analyzer_2_array_crystal_array_0_focus_r = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_18_analyzer_2_array_crystal_array_0_p_interact = 0;
#line 71 "MACS_sample_kidney_box.instr"
  if(0) strncpy(mccchannel_18_analyzer_2_array_crystal_array_0_mask_string, 0 ? 0 : "", 16384); else mccchannel_18_analyzer_2_array_crystal_array_0_mask_string[0]='\0';
#line 71 "MACS_sample_kidney_box.instr"
  if(0) strncpy(mccchannel_18_analyzer_2_array_crystal_array_0_mask_setting, 0 ? 0 : "", 16384); else mccchannel_18_analyzer_2_array_crystal_array_0_mask_setting[0]='\0';
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_18_analyzer_2_array_crystal_array_0_number_of_activations = 1;
#line 145877 "MACS_sample_kidney_box.c"

  SIG_MESSAGE("channel_18_analyzer_2_array_crystal_array_0 (Init:Place/Rotate)");
  rot_set_rotation(mctr1,
#line 4615 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 4615 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 4615 "MACS_sample_kidney_box.instr"
    (0 - RAD2DEG * channel_18_analyzer_2_array_theta [ 0 ])*DEG2RAD);
#line 145887 "MACS_sample_kidney_box.c"
  rot_mul(mctr1, mcrotachannel_18_analyzer_2_rotated, mcrotachannel_18_analyzer_2_array_crystal_array_0);
  rot_transpose(mcrotachannel_18_analyzer_2_rotated, mctr1);
  rot_mul(mcrotachannel_18_analyzer_2_array_crystal_array_0, mctr1, mcrotrchannel_18_analyzer_2_array_crystal_array_0);
  mctc1 = coords_set(
#line 4614 "MACS_sample_kidney_box.instr"
    0 + channel_18_analyzer_2_array_effective_radius_of_curvature * ( 1 - cos ( channel_18_analyzer_2_array_theta [ 0 ] ) ),
#line 4614 "MACS_sample_kidney_box.instr"
    0 + channel_18_analyzer_2_array_effective_radius_of_curvature * sin ( channel_18_analyzer_2_array_theta [ 0 ] ),
#line 4614 "MACS_sample_kidney_box.instr"
    0);
#line 145898 "MACS_sample_kidney_box.c"
  rot_transpose(mcrotachannel_18_analyzer_2_rotated, mctr1);
  mctc2 = rot_apply(mctr1, mctc1);
  mcposachannel_18_analyzer_2_array_crystal_array_0 = coords_add(mcposachannel_18_analyzer_2_rotated, mctc2);
  mctc1 = coords_sub(mcposachannel_18_analyzer_2_rotated, mcposachannel_18_analyzer_2_array_crystal_array_0);
  mcposrchannel_18_analyzer_2_array_crystal_array_0 = rot_apply(mcrotachannel_18_analyzer_2_array_crystal_array_0, mctc1);
  mcDEBUG_COMPONENT("channel_18_analyzer_2_array_crystal_array_0", mcposachannel_18_analyzer_2_array_crystal_array_0, mcrotachannel_18_analyzer_2_array_crystal_array_0)
  mccomp_posa[825] = mcposachannel_18_analyzer_2_array_crystal_array_0;
  mccomp_posr[825] = mcposrchannel_18_analyzer_2_array_crystal_array_0;
  mcNCounter[825]  = mcPCounter[825] = mcP2Counter[825] = 0;
  mcAbsorbProp[825]= 0;
    /* Component channel_18_analyzer_2_array_crystal_array_1. */
  /* Setting parameters for component channel_18_analyzer_2_array_crystal_array_1. */
  SIG_MESSAGE("channel_18_analyzer_2_array_crystal_array_1 (Init:SetPar)");
#line 4619 "MACS_sample_kidney_box.instr"
  if("PG_analyzer") strncpy(mccchannel_18_analyzer_2_array_crystal_array_1_material_string, "PG_analyzer" ? "PG_analyzer" : "", 16384); else mccchannel_18_analyzer_2_array_crystal_array_1_material_string[0]='\0';
#line 4619 "MACS_sample_kidney_box.instr"
  mccchannel_18_analyzer_2_array_crystal_array_1_priority = 2021.1;
#line 4618 "MACS_sample_kidney_box.instr"
  mccchannel_18_analyzer_2_array_crystal_array_1_xwidth = channel_18_analyzer_2_array_crystal_depth;
#line 4618 "MACS_sample_kidney_box.instr"
  mccchannel_18_analyzer_2_array_crystal_array_1_yheight = channel_18_analyzer_2_array_crystal_height;
#line 4618 "MACS_sample_kidney_box.instr"
  mccchannel_18_analyzer_2_array_crystal_array_1_zdepth = channel_18_analyzer_2_array_crystal_width;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_18_analyzer_2_array_crystal_array_1_xwidth2 = -1;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_18_analyzer_2_array_crystal_array_1_yheight2 = -1;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_18_analyzer_2_array_crystal_array_1_visualize = 1;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_18_analyzer_2_array_crystal_array_1_target_index = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_18_analyzer_2_array_crystal_array_1_target_x = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_18_analyzer_2_array_crystal_array_1_target_y = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_18_analyzer_2_array_crystal_array_1_target_z = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_18_analyzer_2_array_crystal_array_1_focus_aw = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_18_analyzer_2_array_crystal_array_1_focus_ah = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_18_analyzer_2_array_crystal_array_1_focus_xw = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_18_analyzer_2_array_crystal_array_1_focus_xh = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_18_analyzer_2_array_crystal_array_1_focus_r = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_18_analyzer_2_array_crystal_array_1_p_interact = 0;
#line 71 "MACS_sample_kidney_box.instr"
  if(0) strncpy(mccchannel_18_analyzer_2_array_crystal_array_1_mask_string, 0 ? 0 : "", 16384); else mccchannel_18_analyzer_2_array_crystal_array_1_mask_string[0]='\0';
#line 71 "MACS_sample_kidney_box.instr"
  if(0) strncpy(mccchannel_18_analyzer_2_array_crystal_array_1_mask_setting, 0 ? 0 : "", 16384); else mccchannel_18_analyzer_2_array_crystal_array_1_mask_setting[0]='\0';
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_18_analyzer_2_array_crystal_array_1_number_of_activations = 1;
#line 145954 "MACS_sample_kidney_box.c"

  SIG_MESSAGE("channel_18_analyzer_2_array_crystal_array_1 (Init:Place/Rotate)");
  rot_set_rotation(mctr1,
#line 4621 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 4621 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 4621 "MACS_sample_kidney_box.instr"
    (0 - RAD2DEG * channel_18_analyzer_2_array_theta [ 1 ])*DEG2RAD);
#line 145964 "MACS_sample_kidney_box.c"
  rot_mul(mctr1, mcrotachannel_18_analyzer_2_rotated, mcrotachannel_18_analyzer_2_array_crystal_array_1);
  rot_transpose(mcrotachannel_18_analyzer_2_array_crystal_array_0, mctr1);
  rot_mul(mcrotachannel_18_analyzer_2_array_crystal_array_1, mctr1, mcrotrchannel_18_analyzer_2_array_crystal_array_1);
  mctc1 = coords_set(
#line 4620 "MACS_sample_kidney_box.instr"
    0 + channel_18_analyzer_2_array_effective_radius_of_curvature * ( 1 - cos ( channel_18_analyzer_2_array_theta [ 1 ] ) ),
#line 4620 "MACS_sample_kidney_box.instr"
    0 + channel_18_analyzer_2_array_effective_radius_of_curvature * sin ( channel_18_analyzer_2_array_theta [ 1 ] ),
#line 4620 "MACS_sample_kidney_box.instr"
    0);
#line 145975 "MACS_sample_kidney_box.c"
  rot_transpose(mcrotachannel_18_analyzer_2_rotated, mctr1);
  mctc2 = rot_apply(mctr1, mctc1);
  mcposachannel_18_analyzer_2_array_crystal_array_1 = coords_add(mcposachannel_18_analyzer_2_rotated, mctc2);
  mctc1 = coords_sub(mcposachannel_18_analyzer_2_array_crystal_array_0, mcposachannel_18_analyzer_2_array_crystal_array_1);
  mcposrchannel_18_analyzer_2_array_crystal_array_1 = rot_apply(mcrotachannel_18_analyzer_2_array_crystal_array_1, mctc1);
  mcDEBUG_COMPONENT("channel_18_analyzer_2_array_crystal_array_1", mcposachannel_18_analyzer_2_array_crystal_array_1, mcrotachannel_18_analyzer_2_array_crystal_array_1)
  mccomp_posa[826] = mcposachannel_18_analyzer_2_array_crystal_array_1;
  mccomp_posr[826] = mcposrchannel_18_analyzer_2_array_crystal_array_1;
  mcNCounter[826]  = mcPCounter[826] = mcP2Counter[826] = 0;
  mcAbsorbProp[826]= 0;
    /* Component channel_18_analyzer_2_array_crystal_array_2. */
  /* Setting parameters for component channel_18_analyzer_2_array_crystal_array_2. */
  SIG_MESSAGE("channel_18_analyzer_2_array_crystal_array_2 (Init:SetPar)");
#line 4625 "MACS_sample_kidney_box.instr"
  if("PG_analyzer") strncpy(mccchannel_18_analyzer_2_array_crystal_array_2_material_string, "PG_analyzer" ? "PG_analyzer" : "", 16384); else mccchannel_18_analyzer_2_array_crystal_array_2_material_string[0]='\0';
#line 4625 "MACS_sample_kidney_box.instr"
  mccchannel_18_analyzer_2_array_crystal_array_2_priority = 2021.2;
#line 4624 "MACS_sample_kidney_box.instr"
  mccchannel_18_analyzer_2_array_crystal_array_2_xwidth = channel_18_analyzer_2_array_crystal_depth;
#line 4624 "MACS_sample_kidney_box.instr"
  mccchannel_18_analyzer_2_array_crystal_array_2_yheight = channel_18_analyzer_2_array_crystal_height;
#line 4624 "MACS_sample_kidney_box.instr"
  mccchannel_18_analyzer_2_array_crystal_array_2_zdepth = channel_18_analyzer_2_array_crystal_width;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_18_analyzer_2_array_crystal_array_2_xwidth2 = -1;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_18_analyzer_2_array_crystal_array_2_yheight2 = -1;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_18_analyzer_2_array_crystal_array_2_visualize = 1;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_18_analyzer_2_array_crystal_array_2_target_index = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_18_analyzer_2_array_crystal_array_2_target_x = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_18_analyzer_2_array_crystal_array_2_target_y = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_18_analyzer_2_array_crystal_array_2_target_z = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_18_analyzer_2_array_crystal_array_2_focus_aw = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_18_analyzer_2_array_crystal_array_2_focus_ah = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_18_analyzer_2_array_crystal_array_2_focus_xw = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_18_analyzer_2_array_crystal_array_2_focus_xh = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_18_analyzer_2_array_crystal_array_2_focus_r = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_18_analyzer_2_array_crystal_array_2_p_interact = 0;
#line 71 "MACS_sample_kidney_box.instr"
  if(0) strncpy(mccchannel_18_analyzer_2_array_crystal_array_2_mask_string, 0 ? 0 : "", 16384); else mccchannel_18_analyzer_2_array_crystal_array_2_mask_string[0]='\0';
#line 71 "MACS_sample_kidney_box.instr"
  if(0) strncpy(mccchannel_18_analyzer_2_array_crystal_array_2_mask_setting, 0 ? 0 : "", 16384); else mccchannel_18_analyzer_2_array_crystal_array_2_mask_setting[0]='\0';
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_18_analyzer_2_array_crystal_array_2_number_of_activations = 1;
#line 146031 "MACS_sample_kidney_box.c"

  SIG_MESSAGE("channel_18_analyzer_2_array_crystal_array_2 (Init:Place/Rotate)");
  rot_set_rotation(mctr1,
#line 4627 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 4627 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 4627 "MACS_sample_kidney_box.instr"
    (0 - RAD2DEG * channel_18_analyzer_2_array_theta [ 2 ])*DEG2RAD);
#line 146041 "MACS_sample_kidney_box.c"
  rot_mul(mctr1, mcrotachannel_18_analyzer_2_rotated, mcrotachannel_18_analyzer_2_array_crystal_array_2);
  rot_transpose(mcrotachannel_18_analyzer_2_array_crystal_array_1, mctr1);
  rot_mul(mcrotachannel_18_analyzer_2_array_crystal_array_2, mctr1, mcrotrchannel_18_analyzer_2_array_crystal_array_2);
  mctc1 = coords_set(
#line 4626 "MACS_sample_kidney_box.instr"
    0 + channel_18_analyzer_2_array_effective_radius_of_curvature * ( 1 - cos ( channel_18_analyzer_2_array_theta [ 2 ] ) ),
#line 4626 "MACS_sample_kidney_box.instr"
    0 + channel_18_analyzer_2_array_effective_radius_of_curvature * sin ( channel_18_analyzer_2_array_theta [ 2 ] ),
#line 4626 "MACS_sample_kidney_box.instr"
    0);
#line 146052 "MACS_sample_kidney_box.c"
  rot_transpose(mcrotachannel_18_analyzer_2_rotated, mctr1);
  mctc2 = rot_apply(mctr1, mctc1);
  mcposachannel_18_analyzer_2_array_crystal_array_2 = coords_add(mcposachannel_18_analyzer_2_rotated, mctc2);
  mctc1 = coords_sub(mcposachannel_18_analyzer_2_array_crystal_array_1, mcposachannel_18_analyzer_2_array_crystal_array_2);
  mcposrchannel_18_analyzer_2_array_crystal_array_2 = rot_apply(mcrotachannel_18_analyzer_2_array_crystal_array_2, mctc1);
  mcDEBUG_COMPONENT("channel_18_analyzer_2_array_crystal_array_2", mcposachannel_18_analyzer_2_array_crystal_array_2, mcrotachannel_18_analyzer_2_array_crystal_array_2)
  mccomp_posa[827] = mcposachannel_18_analyzer_2_array_crystal_array_2;
  mccomp_posr[827] = mcposrchannel_18_analyzer_2_array_crystal_array_2;
  mcNCounter[827]  = mcPCounter[827] = mcP2Counter[827] = 0;
  mcAbsorbProp[827]= 0;
    /* Component channel_18_analyzer_2_array_crystal_array_3. */
  /* Setting parameters for component channel_18_analyzer_2_array_crystal_array_3. */
  SIG_MESSAGE("channel_18_analyzer_2_array_crystal_array_3 (Init:SetPar)");
#line 4631 "MACS_sample_kidney_box.instr"
  if("PG_analyzer") strncpy(mccchannel_18_analyzer_2_array_crystal_array_3_material_string, "PG_analyzer" ? "PG_analyzer" : "", 16384); else mccchannel_18_analyzer_2_array_crystal_array_3_material_string[0]='\0';
#line 4631 "MACS_sample_kidney_box.instr"
  mccchannel_18_analyzer_2_array_crystal_array_3_priority = 2021.3;
#line 4630 "MACS_sample_kidney_box.instr"
  mccchannel_18_analyzer_2_array_crystal_array_3_xwidth = channel_18_analyzer_2_array_crystal_depth;
#line 4630 "MACS_sample_kidney_box.instr"
  mccchannel_18_analyzer_2_array_crystal_array_3_yheight = channel_18_analyzer_2_array_crystal_height;
#line 4630 "MACS_sample_kidney_box.instr"
  mccchannel_18_analyzer_2_array_crystal_array_3_zdepth = channel_18_analyzer_2_array_crystal_width;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_18_analyzer_2_array_crystal_array_3_xwidth2 = -1;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_18_analyzer_2_array_crystal_array_3_yheight2 = -1;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_18_analyzer_2_array_crystal_array_3_visualize = 1;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_18_analyzer_2_array_crystal_array_3_target_index = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_18_analyzer_2_array_crystal_array_3_target_x = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_18_analyzer_2_array_crystal_array_3_target_y = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_18_analyzer_2_array_crystal_array_3_target_z = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_18_analyzer_2_array_crystal_array_3_focus_aw = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_18_analyzer_2_array_crystal_array_3_focus_ah = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_18_analyzer_2_array_crystal_array_3_focus_xw = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_18_analyzer_2_array_crystal_array_3_focus_xh = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_18_analyzer_2_array_crystal_array_3_focus_r = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_18_analyzer_2_array_crystal_array_3_p_interact = 0;
#line 71 "MACS_sample_kidney_box.instr"
  if(0) strncpy(mccchannel_18_analyzer_2_array_crystal_array_3_mask_string, 0 ? 0 : "", 16384); else mccchannel_18_analyzer_2_array_crystal_array_3_mask_string[0]='\0';
#line 71 "MACS_sample_kidney_box.instr"
  if(0) strncpy(mccchannel_18_analyzer_2_array_crystal_array_3_mask_setting, 0 ? 0 : "", 16384); else mccchannel_18_analyzer_2_array_crystal_array_3_mask_setting[0]='\0';
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_18_analyzer_2_array_crystal_array_3_number_of_activations = 1;
#line 146108 "MACS_sample_kidney_box.c"

  SIG_MESSAGE("channel_18_analyzer_2_array_crystal_array_3 (Init:Place/Rotate)");
  rot_set_rotation(mctr1,
#line 4633 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 4633 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 4633 "MACS_sample_kidney_box.instr"
    (0 - RAD2DEG * channel_18_analyzer_2_array_theta [ 3 ])*DEG2RAD);
#line 146118 "MACS_sample_kidney_box.c"
  rot_mul(mctr1, mcrotachannel_18_analyzer_2_rotated, mcrotachannel_18_analyzer_2_array_crystal_array_3);
  rot_transpose(mcrotachannel_18_analyzer_2_array_crystal_array_2, mctr1);
  rot_mul(mcrotachannel_18_analyzer_2_array_crystal_array_3, mctr1, mcrotrchannel_18_analyzer_2_array_crystal_array_3);
  mctc1 = coords_set(
#line 4632 "MACS_sample_kidney_box.instr"
    0 + channel_18_analyzer_2_array_effective_radius_of_curvature * ( 1 - cos ( channel_18_analyzer_2_array_theta [ 3 ] ) ),
#line 4632 "MACS_sample_kidney_box.instr"
    0 + channel_18_analyzer_2_array_effective_radius_of_curvature * sin ( channel_18_analyzer_2_array_theta [ 3 ] ),
#line 4632 "MACS_sample_kidney_box.instr"
    0);
#line 146129 "MACS_sample_kidney_box.c"
  rot_transpose(mcrotachannel_18_analyzer_2_rotated, mctr1);
  mctc2 = rot_apply(mctr1, mctc1);
  mcposachannel_18_analyzer_2_array_crystal_array_3 = coords_add(mcposachannel_18_analyzer_2_rotated, mctc2);
  mctc1 = coords_sub(mcposachannel_18_analyzer_2_array_crystal_array_2, mcposachannel_18_analyzer_2_array_crystal_array_3);
  mcposrchannel_18_analyzer_2_array_crystal_array_3 = rot_apply(mcrotachannel_18_analyzer_2_array_crystal_array_3, mctc1);
  mcDEBUG_COMPONENT("channel_18_analyzer_2_array_crystal_array_3", mcposachannel_18_analyzer_2_array_crystal_array_3, mcrotachannel_18_analyzer_2_array_crystal_array_3)
  mccomp_posa[828] = mcposachannel_18_analyzer_2_array_crystal_array_3;
  mccomp_posr[828] = mcposrchannel_18_analyzer_2_array_crystal_array_3;
  mcNCounter[828]  = mcPCounter[828] = mcP2Counter[828] = 0;
  mcAbsorbProp[828]= 0;
    /* Component channel_18_analyzer_2_array_crystal_array_4. */
  /* Setting parameters for component channel_18_analyzer_2_array_crystal_array_4. */
  SIG_MESSAGE("channel_18_analyzer_2_array_crystal_array_4 (Init:SetPar)");
#line 4637 "MACS_sample_kidney_box.instr"
  if("PG_analyzer") strncpy(mccchannel_18_analyzer_2_array_crystal_array_4_material_string, "PG_analyzer" ? "PG_analyzer" : "", 16384); else mccchannel_18_analyzer_2_array_crystal_array_4_material_string[0]='\0';
#line 4637 "MACS_sample_kidney_box.instr"
  mccchannel_18_analyzer_2_array_crystal_array_4_priority = 2021.4;
#line 4636 "MACS_sample_kidney_box.instr"
  mccchannel_18_analyzer_2_array_crystal_array_4_xwidth = channel_18_analyzer_2_array_crystal_depth;
#line 4636 "MACS_sample_kidney_box.instr"
  mccchannel_18_analyzer_2_array_crystal_array_4_yheight = channel_18_analyzer_2_array_crystal_height;
#line 4636 "MACS_sample_kidney_box.instr"
  mccchannel_18_analyzer_2_array_crystal_array_4_zdepth = channel_18_analyzer_2_array_crystal_width;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_18_analyzer_2_array_crystal_array_4_xwidth2 = -1;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_18_analyzer_2_array_crystal_array_4_yheight2 = -1;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_18_analyzer_2_array_crystal_array_4_visualize = 1;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_18_analyzer_2_array_crystal_array_4_target_index = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_18_analyzer_2_array_crystal_array_4_target_x = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_18_analyzer_2_array_crystal_array_4_target_y = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_18_analyzer_2_array_crystal_array_4_target_z = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_18_analyzer_2_array_crystal_array_4_focus_aw = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_18_analyzer_2_array_crystal_array_4_focus_ah = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_18_analyzer_2_array_crystal_array_4_focus_xw = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_18_analyzer_2_array_crystal_array_4_focus_xh = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_18_analyzer_2_array_crystal_array_4_focus_r = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_18_analyzer_2_array_crystal_array_4_p_interact = 0;
#line 71 "MACS_sample_kidney_box.instr"
  if(0) strncpy(mccchannel_18_analyzer_2_array_crystal_array_4_mask_string, 0 ? 0 : "", 16384); else mccchannel_18_analyzer_2_array_crystal_array_4_mask_string[0]='\0';
#line 71 "MACS_sample_kidney_box.instr"
  if(0) strncpy(mccchannel_18_analyzer_2_array_crystal_array_4_mask_setting, 0 ? 0 : "", 16384); else mccchannel_18_analyzer_2_array_crystal_array_4_mask_setting[0]='\0';
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_18_analyzer_2_array_crystal_array_4_number_of_activations = 1;
#line 146185 "MACS_sample_kidney_box.c"

  SIG_MESSAGE("channel_18_analyzer_2_array_crystal_array_4 (Init:Place/Rotate)");
  rot_set_rotation(mctr1,
#line 4639 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 4639 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 4639 "MACS_sample_kidney_box.instr"
    (0 - RAD2DEG * channel_18_analyzer_2_array_theta [ 4 ])*DEG2RAD);
#line 146195 "MACS_sample_kidney_box.c"
  rot_mul(mctr1, mcrotachannel_18_analyzer_2_rotated, mcrotachannel_18_analyzer_2_array_crystal_array_4);
  rot_transpose(mcrotachannel_18_analyzer_2_array_crystal_array_3, mctr1);
  rot_mul(mcrotachannel_18_analyzer_2_array_crystal_array_4, mctr1, mcrotrchannel_18_analyzer_2_array_crystal_array_4);
  mctc1 = coords_set(
#line 4638 "MACS_sample_kidney_box.instr"
    0 + channel_18_analyzer_2_array_effective_radius_of_curvature * ( 1 - cos ( channel_18_analyzer_2_array_theta [ 4 ] ) ),
#line 4638 "MACS_sample_kidney_box.instr"
    0 + channel_18_analyzer_2_array_effective_radius_of_curvature * sin ( channel_18_analyzer_2_array_theta [ 4 ] ),
#line 4638 "MACS_sample_kidney_box.instr"
    0);
#line 146206 "MACS_sample_kidney_box.c"
  rot_transpose(mcrotachannel_18_analyzer_2_rotated, mctr1);
  mctc2 = rot_apply(mctr1, mctc1);
  mcposachannel_18_analyzer_2_array_crystal_array_4 = coords_add(mcposachannel_18_analyzer_2_rotated, mctc2);
  mctc1 = coords_sub(mcposachannel_18_analyzer_2_array_crystal_array_3, mcposachannel_18_analyzer_2_array_crystal_array_4);
  mcposrchannel_18_analyzer_2_array_crystal_array_4 = rot_apply(mcrotachannel_18_analyzer_2_array_crystal_array_4, mctc1);
  mcDEBUG_COMPONENT("channel_18_analyzer_2_array_crystal_array_4", mcposachannel_18_analyzer_2_array_crystal_array_4, mcrotachannel_18_analyzer_2_array_crystal_array_4)
  mccomp_posa[829] = mcposachannel_18_analyzer_2_array_crystal_array_4;
  mccomp_posr[829] = mcposrchannel_18_analyzer_2_array_crystal_array_4;
  mcNCounter[829]  = mcPCounter[829] = mcP2Counter[829] = 0;
  mcAbsorbProp[829]= 0;
    /* Component channel_18_analyzer_2_array_crystal_array_5. */
  /* Setting parameters for component channel_18_analyzer_2_array_crystal_array_5. */
  SIG_MESSAGE("channel_18_analyzer_2_array_crystal_array_5 (Init:SetPar)");
#line 4643 "MACS_sample_kidney_box.instr"
  if("PG_analyzer") strncpy(mccchannel_18_analyzer_2_array_crystal_array_5_material_string, "PG_analyzer" ? "PG_analyzer" : "", 16384); else mccchannel_18_analyzer_2_array_crystal_array_5_material_string[0]='\0';
#line 4643 "MACS_sample_kidney_box.instr"
  mccchannel_18_analyzer_2_array_crystal_array_5_priority = 2021.5;
#line 4642 "MACS_sample_kidney_box.instr"
  mccchannel_18_analyzer_2_array_crystal_array_5_xwidth = channel_18_analyzer_2_array_crystal_depth;
#line 4642 "MACS_sample_kidney_box.instr"
  mccchannel_18_analyzer_2_array_crystal_array_5_yheight = channel_18_analyzer_2_array_crystal_height;
#line 4642 "MACS_sample_kidney_box.instr"
  mccchannel_18_analyzer_2_array_crystal_array_5_zdepth = channel_18_analyzer_2_array_crystal_width;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_18_analyzer_2_array_crystal_array_5_xwidth2 = -1;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_18_analyzer_2_array_crystal_array_5_yheight2 = -1;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_18_analyzer_2_array_crystal_array_5_visualize = 1;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_18_analyzer_2_array_crystal_array_5_target_index = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_18_analyzer_2_array_crystal_array_5_target_x = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_18_analyzer_2_array_crystal_array_5_target_y = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_18_analyzer_2_array_crystal_array_5_target_z = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_18_analyzer_2_array_crystal_array_5_focus_aw = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_18_analyzer_2_array_crystal_array_5_focus_ah = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_18_analyzer_2_array_crystal_array_5_focus_xw = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_18_analyzer_2_array_crystal_array_5_focus_xh = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_18_analyzer_2_array_crystal_array_5_focus_r = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_18_analyzer_2_array_crystal_array_5_p_interact = 0;
#line 71 "MACS_sample_kidney_box.instr"
  if(0) strncpy(mccchannel_18_analyzer_2_array_crystal_array_5_mask_string, 0 ? 0 : "", 16384); else mccchannel_18_analyzer_2_array_crystal_array_5_mask_string[0]='\0';
#line 71 "MACS_sample_kidney_box.instr"
  if(0) strncpy(mccchannel_18_analyzer_2_array_crystal_array_5_mask_setting, 0 ? 0 : "", 16384); else mccchannel_18_analyzer_2_array_crystal_array_5_mask_setting[0]='\0';
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_18_analyzer_2_array_crystal_array_5_number_of_activations = 1;
#line 146262 "MACS_sample_kidney_box.c"

  SIG_MESSAGE("channel_18_analyzer_2_array_crystal_array_5 (Init:Place/Rotate)");
  rot_set_rotation(mctr1,
#line 4645 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 4645 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 4645 "MACS_sample_kidney_box.instr"
    (0 - RAD2DEG * channel_18_analyzer_2_array_theta [ 5 ])*DEG2RAD);
#line 146272 "MACS_sample_kidney_box.c"
  rot_mul(mctr1, mcrotachannel_18_analyzer_2_rotated, mcrotachannel_18_analyzer_2_array_crystal_array_5);
  rot_transpose(mcrotachannel_18_analyzer_2_array_crystal_array_4, mctr1);
  rot_mul(mcrotachannel_18_analyzer_2_array_crystal_array_5, mctr1, mcrotrchannel_18_analyzer_2_array_crystal_array_5);
  mctc1 = coords_set(
#line 4644 "MACS_sample_kidney_box.instr"
    0 + channel_18_analyzer_2_array_effective_radius_of_curvature * ( 1 - cos ( channel_18_analyzer_2_array_theta [ 5 ] ) ),
#line 4644 "MACS_sample_kidney_box.instr"
    0 + channel_18_analyzer_2_array_effective_radius_of_curvature * sin ( channel_18_analyzer_2_array_theta [ 5 ] ),
#line 4644 "MACS_sample_kidney_box.instr"
    0);
#line 146283 "MACS_sample_kidney_box.c"
  rot_transpose(mcrotachannel_18_analyzer_2_rotated, mctr1);
  mctc2 = rot_apply(mctr1, mctc1);
  mcposachannel_18_analyzer_2_array_crystal_array_5 = coords_add(mcposachannel_18_analyzer_2_rotated, mctc2);
  mctc1 = coords_sub(mcposachannel_18_analyzer_2_array_crystal_array_4, mcposachannel_18_analyzer_2_array_crystal_array_5);
  mcposrchannel_18_analyzer_2_array_crystal_array_5 = rot_apply(mcrotachannel_18_analyzer_2_array_crystal_array_5, mctc1);
  mcDEBUG_COMPONENT("channel_18_analyzer_2_array_crystal_array_5", mcposachannel_18_analyzer_2_array_crystal_array_5, mcrotachannel_18_analyzer_2_array_crystal_array_5)
  mccomp_posa[830] = mcposachannel_18_analyzer_2_array_crystal_array_5;
  mccomp_posr[830] = mcposrchannel_18_analyzer_2_array_crystal_array_5;
  mcNCounter[830]  = mcPCounter[830] = mcP2Counter[830] = 0;
  mcAbsorbProp[830]= 0;
    /* Component channel_18_analyzer_2_array_crystal_array_6. */
  /* Setting parameters for component channel_18_analyzer_2_array_crystal_array_6. */
  SIG_MESSAGE("channel_18_analyzer_2_array_crystal_array_6 (Init:SetPar)");
#line 4649 "MACS_sample_kidney_box.instr"
  if("PG_analyzer") strncpy(mccchannel_18_analyzer_2_array_crystal_array_6_material_string, "PG_analyzer" ? "PG_analyzer" : "", 16384); else mccchannel_18_analyzer_2_array_crystal_array_6_material_string[0]='\0';
#line 4649 "MACS_sample_kidney_box.instr"
  mccchannel_18_analyzer_2_array_crystal_array_6_priority = 2021.6;
#line 4648 "MACS_sample_kidney_box.instr"
  mccchannel_18_analyzer_2_array_crystal_array_6_xwidth = channel_18_analyzer_2_array_crystal_depth;
#line 4648 "MACS_sample_kidney_box.instr"
  mccchannel_18_analyzer_2_array_crystal_array_6_yheight = channel_18_analyzer_2_array_crystal_height;
#line 4648 "MACS_sample_kidney_box.instr"
  mccchannel_18_analyzer_2_array_crystal_array_6_zdepth = channel_18_analyzer_2_array_crystal_width;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_18_analyzer_2_array_crystal_array_6_xwidth2 = -1;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_18_analyzer_2_array_crystal_array_6_yheight2 = -1;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_18_analyzer_2_array_crystal_array_6_visualize = 1;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_18_analyzer_2_array_crystal_array_6_target_index = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_18_analyzer_2_array_crystal_array_6_target_x = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_18_analyzer_2_array_crystal_array_6_target_y = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_18_analyzer_2_array_crystal_array_6_target_z = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_18_analyzer_2_array_crystal_array_6_focus_aw = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_18_analyzer_2_array_crystal_array_6_focus_ah = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_18_analyzer_2_array_crystal_array_6_focus_xw = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_18_analyzer_2_array_crystal_array_6_focus_xh = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_18_analyzer_2_array_crystal_array_6_focus_r = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_18_analyzer_2_array_crystal_array_6_p_interact = 0;
#line 71 "MACS_sample_kidney_box.instr"
  if(0) strncpy(mccchannel_18_analyzer_2_array_crystal_array_6_mask_string, 0 ? 0 : "", 16384); else mccchannel_18_analyzer_2_array_crystal_array_6_mask_string[0]='\0';
#line 71 "MACS_sample_kidney_box.instr"
  if(0) strncpy(mccchannel_18_analyzer_2_array_crystal_array_6_mask_setting, 0 ? 0 : "", 16384); else mccchannel_18_analyzer_2_array_crystal_array_6_mask_setting[0]='\0';
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_18_analyzer_2_array_crystal_array_6_number_of_activations = 1;
#line 146339 "MACS_sample_kidney_box.c"

  SIG_MESSAGE("channel_18_analyzer_2_array_crystal_array_6 (Init:Place/Rotate)");
  rot_set_rotation(mctr1,
#line 4651 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 4651 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 4651 "MACS_sample_kidney_box.instr"
    (0 - RAD2DEG * channel_18_analyzer_2_array_theta [ 6 ])*DEG2RAD);
#line 146349 "MACS_sample_kidney_box.c"
  rot_mul(mctr1, mcrotachannel_18_analyzer_2_rotated, mcrotachannel_18_analyzer_2_array_crystal_array_6);
  rot_transpose(mcrotachannel_18_analyzer_2_array_crystal_array_5, mctr1);
  rot_mul(mcrotachannel_18_analyzer_2_array_crystal_array_6, mctr1, mcrotrchannel_18_analyzer_2_array_crystal_array_6);
  mctc1 = coords_set(
#line 4650 "MACS_sample_kidney_box.instr"
    0 + channel_18_analyzer_2_array_effective_radius_of_curvature * ( 1 - cos ( channel_18_analyzer_2_array_theta [ 6 ] ) ),
#line 4650 "MACS_sample_kidney_box.instr"
    0 + channel_18_analyzer_2_array_effective_radius_of_curvature * sin ( channel_18_analyzer_2_array_theta [ 6 ] ),
#line 4650 "MACS_sample_kidney_box.instr"
    0);
#line 146360 "MACS_sample_kidney_box.c"
  rot_transpose(mcrotachannel_18_analyzer_2_rotated, mctr1);
  mctc2 = rot_apply(mctr1, mctc1);
  mcposachannel_18_analyzer_2_array_crystal_array_6 = coords_add(mcposachannel_18_analyzer_2_rotated, mctc2);
  mctc1 = coords_sub(mcposachannel_18_analyzer_2_array_crystal_array_5, mcposachannel_18_analyzer_2_array_crystal_array_6);
  mcposrchannel_18_analyzer_2_array_crystal_array_6 = rot_apply(mcrotachannel_18_analyzer_2_array_crystal_array_6, mctc1);
  mcDEBUG_COMPONENT("channel_18_analyzer_2_array_crystal_array_6", mcposachannel_18_analyzer_2_array_crystal_array_6, mcrotachannel_18_analyzer_2_array_crystal_array_6)
  mccomp_posa[831] = mcposachannel_18_analyzer_2_array_crystal_array_6;
  mccomp_posr[831] = mcposrchannel_18_analyzer_2_array_crystal_array_6;
  mcNCounter[831]  = mcPCounter[831] = mcP2Counter[831] = 0;
  mcAbsorbProp[831]= 0;
    /* Component channel_18_analyzer_2_array_crystal_array_7. */
  /* Setting parameters for component channel_18_analyzer_2_array_crystal_array_7. */
  SIG_MESSAGE("channel_18_analyzer_2_array_crystal_array_7 (Init:SetPar)");
#line 4655 "MACS_sample_kidney_box.instr"
  if("PG_analyzer") strncpy(mccchannel_18_analyzer_2_array_crystal_array_7_material_string, "PG_analyzer" ? "PG_analyzer" : "", 16384); else mccchannel_18_analyzer_2_array_crystal_array_7_material_string[0]='\0';
#line 4655 "MACS_sample_kidney_box.instr"
  mccchannel_18_analyzer_2_array_crystal_array_7_priority = 2021.7;
#line 4654 "MACS_sample_kidney_box.instr"
  mccchannel_18_analyzer_2_array_crystal_array_7_xwidth = channel_18_analyzer_2_array_crystal_depth;
#line 4654 "MACS_sample_kidney_box.instr"
  mccchannel_18_analyzer_2_array_crystal_array_7_yheight = channel_18_analyzer_2_array_crystal_height;
#line 4654 "MACS_sample_kidney_box.instr"
  mccchannel_18_analyzer_2_array_crystal_array_7_zdepth = channel_18_analyzer_2_array_crystal_width;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_18_analyzer_2_array_crystal_array_7_xwidth2 = -1;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_18_analyzer_2_array_crystal_array_7_yheight2 = -1;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_18_analyzer_2_array_crystal_array_7_visualize = 1;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_18_analyzer_2_array_crystal_array_7_target_index = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_18_analyzer_2_array_crystal_array_7_target_x = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_18_analyzer_2_array_crystal_array_7_target_y = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_18_analyzer_2_array_crystal_array_7_target_z = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_18_analyzer_2_array_crystal_array_7_focus_aw = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_18_analyzer_2_array_crystal_array_7_focus_ah = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_18_analyzer_2_array_crystal_array_7_focus_xw = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_18_analyzer_2_array_crystal_array_7_focus_xh = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_18_analyzer_2_array_crystal_array_7_focus_r = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_18_analyzer_2_array_crystal_array_7_p_interact = 0;
#line 71 "MACS_sample_kidney_box.instr"
  if(0) strncpy(mccchannel_18_analyzer_2_array_crystal_array_7_mask_string, 0 ? 0 : "", 16384); else mccchannel_18_analyzer_2_array_crystal_array_7_mask_string[0]='\0';
#line 71 "MACS_sample_kidney_box.instr"
  if(0) strncpy(mccchannel_18_analyzer_2_array_crystal_array_7_mask_setting, 0 ? 0 : "", 16384); else mccchannel_18_analyzer_2_array_crystal_array_7_mask_setting[0]='\0';
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_18_analyzer_2_array_crystal_array_7_number_of_activations = 1;
#line 146416 "MACS_sample_kidney_box.c"

  SIG_MESSAGE("channel_18_analyzer_2_array_crystal_array_7 (Init:Place/Rotate)");
  rot_set_rotation(mctr1,
#line 4657 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 4657 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 4657 "MACS_sample_kidney_box.instr"
    (0 - RAD2DEG * channel_18_analyzer_2_array_theta [ 7 ])*DEG2RAD);
#line 146426 "MACS_sample_kidney_box.c"
  rot_mul(mctr1, mcrotachannel_18_analyzer_2_rotated, mcrotachannel_18_analyzer_2_array_crystal_array_7);
  rot_transpose(mcrotachannel_18_analyzer_2_array_crystal_array_6, mctr1);
  rot_mul(mcrotachannel_18_analyzer_2_array_crystal_array_7, mctr1, mcrotrchannel_18_analyzer_2_array_crystal_array_7);
  mctc1 = coords_set(
#line 4656 "MACS_sample_kidney_box.instr"
    0 + channel_18_analyzer_2_array_effective_radius_of_curvature * ( 1 - cos ( channel_18_analyzer_2_array_theta [ 7 ] ) ),
#line 4656 "MACS_sample_kidney_box.instr"
    0 + channel_18_analyzer_2_array_effective_radius_of_curvature * sin ( channel_18_analyzer_2_array_theta [ 7 ] ),
#line 4656 "MACS_sample_kidney_box.instr"
    0);
#line 146437 "MACS_sample_kidney_box.c"
  rot_transpose(mcrotachannel_18_analyzer_2_rotated, mctr1);
  mctc2 = rot_apply(mctr1, mctc1);
  mcposachannel_18_analyzer_2_array_crystal_array_7 = coords_add(mcposachannel_18_analyzer_2_rotated, mctc2);
  mctc1 = coords_sub(mcposachannel_18_analyzer_2_array_crystal_array_6, mcposachannel_18_analyzer_2_array_crystal_array_7);
  mcposrchannel_18_analyzer_2_array_crystal_array_7 = rot_apply(mcrotachannel_18_analyzer_2_array_crystal_array_7, mctc1);
  mcDEBUG_COMPONENT("channel_18_analyzer_2_array_crystal_array_7", mcposachannel_18_analyzer_2_array_crystal_array_7, mcrotachannel_18_analyzer_2_array_crystal_array_7)
  mccomp_posa[832] = mcposachannel_18_analyzer_2_array_crystal_array_7;
  mccomp_posr[832] = mcposrchannel_18_analyzer_2_array_crystal_array_7;
  mcNCounter[832]  = mcPCounter[832] = mcP2Counter[832] = 0;
  mcAbsorbProp[832]= 0;
    /* Component channel_18_analyzer_2_array_crystal_array_8. */
  /* Setting parameters for component channel_18_analyzer_2_array_crystal_array_8. */
  SIG_MESSAGE("channel_18_analyzer_2_array_crystal_array_8 (Init:SetPar)");
#line 4661 "MACS_sample_kidney_box.instr"
  if("PG_analyzer") strncpy(mccchannel_18_analyzer_2_array_crystal_array_8_material_string, "PG_analyzer" ? "PG_analyzer" : "", 16384); else mccchannel_18_analyzer_2_array_crystal_array_8_material_string[0]='\0';
#line 4661 "MACS_sample_kidney_box.instr"
  mccchannel_18_analyzer_2_array_crystal_array_8_priority = 2021.8;
#line 4660 "MACS_sample_kidney_box.instr"
  mccchannel_18_analyzer_2_array_crystal_array_8_xwidth = channel_18_analyzer_2_array_crystal_depth;
#line 4660 "MACS_sample_kidney_box.instr"
  mccchannel_18_analyzer_2_array_crystal_array_8_yheight = channel_18_analyzer_2_array_crystal_height;
#line 4660 "MACS_sample_kidney_box.instr"
  mccchannel_18_analyzer_2_array_crystal_array_8_zdepth = channel_18_analyzer_2_array_crystal_width;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_18_analyzer_2_array_crystal_array_8_xwidth2 = -1;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_18_analyzer_2_array_crystal_array_8_yheight2 = -1;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_18_analyzer_2_array_crystal_array_8_visualize = 1;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_18_analyzer_2_array_crystal_array_8_target_index = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_18_analyzer_2_array_crystal_array_8_target_x = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_18_analyzer_2_array_crystal_array_8_target_y = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_18_analyzer_2_array_crystal_array_8_target_z = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_18_analyzer_2_array_crystal_array_8_focus_aw = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_18_analyzer_2_array_crystal_array_8_focus_ah = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_18_analyzer_2_array_crystal_array_8_focus_xw = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_18_analyzer_2_array_crystal_array_8_focus_xh = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_18_analyzer_2_array_crystal_array_8_focus_r = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_18_analyzer_2_array_crystal_array_8_p_interact = 0;
#line 71 "MACS_sample_kidney_box.instr"
  if(0) strncpy(mccchannel_18_analyzer_2_array_crystal_array_8_mask_string, 0 ? 0 : "", 16384); else mccchannel_18_analyzer_2_array_crystal_array_8_mask_string[0]='\0';
#line 71 "MACS_sample_kidney_box.instr"
  if(0) strncpy(mccchannel_18_analyzer_2_array_crystal_array_8_mask_setting, 0 ? 0 : "", 16384); else mccchannel_18_analyzer_2_array_crystal_array_8_mask_setting[0]='\0';
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_18_analyzer_2_array_crystal_array_8_number_of_activations = 1;
#line 146493 "MACS_sample_kidney_box.c"

  SIG_MESSAGE("channel_18_analyzer_2_array_crystal_array_8 (Init:Place/Rotate)");
  rot_set_rotation(mctr1,
#line 4663 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 4663 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 4663 "MACS_sample_kidney_box.instr"
    (0 - RAD2DEG * channel_18_analyzer_2_array_theta [ 8 ])*DEG2RAD);
#line 146503 "MACS_sample_kidney_box.c"
  rot_mul(mctr1, mcrotachannel_18_analyzer_2_rotated, mcrotachannel_18_analyzer_2_array_crystal_array_8);
  rot_transpose(mcrotachannel_18_analyzer_2_array_crystal_array_7, mctr1);
  rot_mul(mcrotachannel_18_analyzer_2_array_crystal_array_8, mctr1, mcrotrchannel_18_analyzer_2_array_crystal_array_8);
  mctc1 = coords_set(
#line 4662 "MACS_sample_kidney_box.instr"
    0 + channel_18_analyzer_2_array_effective_radius_of_curvature * ( 1 - cos ( channel_18_analyzer_2_array_theta [ 8 ] ) ),
#line 4662 "MACS_sample_kidney_box.instr"
    0 + channel_18_analyzer_2_array_effective_radius_of_curvature * sin ( channel_18_analyzer_2_array_theta [ 8 ] ),
#line 4662 "MACS_sample_kidney_box.instr"
    0);
#line 146514 "MACS_sample_kidney_box.c"
  rot_transpose(mcrotachannel_18_analyzer_2_rotated, mctr1);
  mctc2 = rot_apply(mctr1, mctc1);
  mcposachannel_18_analyzer_2_array_crystal_array_8 = coords_add(mcposachannel_18_analyzer_2_rotated, mctc2);
  mctc1 = coords_sub(mcposachannel_18_analyzer_2_array_crystal_array_7, mcposachannel_18_analyzer_2_array_crystal_array_8);
  mcposrchannel_18_analyzer_2_array_crystal_array_8 = rot_apply(mcrotachannel_18_analyzer_2_array_crystal_array_8, mctc1);
  mcDEBUG_COMPONENT("channel_18_analyzer_2_array_crystal_array_8", mcposachannel_18_analyzer_2_array_crystal_array_8, mcrotachannel_18_analyzer_2_array_crystal_array_8)
  mccomp_posa[833] = mcposachannel_18_analyzer_2_array_crystal_array_8;
  mccomp_posr[833] = mcposrchannel_18_analyzer_2_array_crystal_array_8;
  mcNCounter[833]  = mcPCounter[833] = mcP2Counter[833] = 0;
  mcAbsorbProp[833]= 0;
    /* Component channel_18_cave2_cyl1. */
  /* Setting parameters for component channel_18_cave2_cyl1. */
  SIG_MESSAGE("channel_18_cave2_cyl1 (Init:SetPar)");
#line 4668 "MACS_sample_kidney_box.instr"
  if("Vacuum") strncpy(mccchannel_18_cave2_cyl1_material_string, "Vacuum" ? "Vacuum" : "", 16384); else mccchannel_18_cave2_cyl1_material_string[0]='\0';
#line 4668 "MACS_sample_kidney_box.instr"
  mccchannel_18_cave2_cyl1_priority = 2007.5;
#line 4667 "MACS_sample_kidney_box.instr"
  mccchannel_18_cave2_cyl1_radius = kidney_cave2_cyl1_radius;
#line 4667 "MACS_sample_kidney_box.instr"
  mccchannel_18_cave2_cyl1_yheight = kidney_cave2_cyl1_height;
#line 67 "MACS_sample_kidney_box.instr"
  mccchannel_18_cave2_cyl1_visualize = 1;
#line 67 "MACS_sample_kidney_box.instr"
  mccchannel_18_cave2_cyl1_target_index = 0;
#line 67 "MACS_sample_kidney_box.instr"
  mccchannel_18_cave2_cyl1_target_x = 0;
#line 67 "MACS_sample_kidney_box.instr"
  mccchannel_18_cave2_cyl1_target_y = 0;
#line 67 "MACS_sample_kidney_box.instr"
  mccchannel_18_cave2_cyl1_target_z = 0;
#line 67 "MACS_sample_kidney_box.instr"
  mccchannel_18_cave2_cyl1_focus_aw = 0;
#line 67 "MACS_sample_kidney_box.instr"
  mccchannel_18_cave2_cyl1_focus_ah = 0;
#line 67 "MACS_sample_kidney_box.instr"
  mccchannel_18_cave2_cyl1_focus_xw = 0;
#line 67 "MACS_sample_kidney_box.instr"
  mccchannel_18_cave2_cyl1_focus_xh = 0;
#line 67 "MACS_sample_kidney_box.instr"
  mccchannel_18_cave2_cyl1_focus_r = 0;
#line 67 "MACS_sample_kidney_box.instr"
  mccchannel_18_cave2_cyl1_p_interact = 0;
#line 67 "MACS_sample_kidney_box.instr"
  if(0) strncpy(mccchannel_18_cave2_cyl1_mask_string, 0 ? 0 : "", 16384); else mccchannel_18_cave2_cyl1_mask_string[0]='\0';
#line 67 "MACS_sample_kidney_box.instr"
  if(0) strncpy(mccchannel_18_cave2_cyl1_mask_setting, 0 ? 0 : "", 16384); else mccchannel_18_cave2_cyl1_mask_setting[0]='\0';
#line 67 "MACS_sample_kidney_box.instr"
  mccchannel_18_cave2_cyl1_number_of_activations = 1;
#line 146564 "MACS_sample_kidney_box.c"

  SIG_MESSAGE("channel_18_cave2_cyl1 (Init:Place/Rotate)");
  rot_set_rotation(mctr1,
#line 4670 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 4670 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 4670 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD);
#line 146574 "MACS_sample_kidney_box.c"
  rot_mul(mctr1, mcrotachannel_18_analyzer_2_center, mcrotachannel_18_cave2_cyl1);
  rot_transpose(mcrotachannel_18_analyzer_2_array_crystal_array_8, mctr1);
  rot_mul(mcrotachannel_18_cave2_cyl1, mctr1, mcrotrchannel_18_cave2_cyl1);
  mctc1 = coords_set(
#line 4669 "MACS_sample_kidney_box.instr"
    0,
#line 4669 "MACS_sample_kidney_box.instr"
    0,
#line 4669 "MACS_sample_kidney_box.instr"
    spec_detector_to_analyzer_2_center);
#line 146585 "MACS_sample_kidney_box.c"
  rot_transpose(mcrotachannel_18_analyzer_2_center, mctr1);
  mctc2 = rot_apply(mctr1, mctc1);
  mcposachannel_18_cave2_cyl1 = coords_add(mcposachannel_18_analyzer_2_center, mctc2);
  mctc1 = coords_sub(mcposachannel_18_analyzer_2_array_crystal_array_8, mcposachannel_18_cave2_cyl1);
  mcposrchannel_18_cave2_cyl1 = rot_apply(mcrotachannel_18_cave2_cyl1, mctc1);
  mcDEBUG_COMPONENT("channel_18_cave2_cyl1", mcposachannel_18_cave2_cyl1, mcrotachannel_18_cave2_cyl1)
  mccomp_posa[834] = mcposachannel_18_cave2_cyl1;
  mccomp_posr[834] = mcposrchannel_18_cave2_cyl1;
  mcNCounter[834]  = mcPCounter[834] = mcP2Counter[834] = 0;
  mcAbsorbProp[834]= 0;
    /* Component channel_18_cave2_box1. */
  /* Setting parameters for component channel_18_cave2_box1. */
  SIG_MESSAGE("channel_18_cave2_box1 (Init:SetPar)");
#line 4675 "MACS_sample_kidney_box.instr"
  if("Vacuum") strncpy(mccchannel_18_cave2_box1_material_string, "Vacuum" ? "Vacuum" : "", 16384); else mccchannel_18_cave2_box1_material_string[0]='\0';
#line 4675 "MACS_sample_kidney_box.instr"
  mccchannel_18_cave2_box1_priority = 2001;
#line 4673 "MACS_sample_kidney_box.instr"
  mccchannel_18_cave2_box1_xwidth = kidney_cave2_box1_width1;
#line 4673 "MACS_sample_kidney_box.instr"
  mccchannel_18_cave2_box1_yheight = kidney_cave2_box1_height1;
#line 4673 "MACS_sample_kidney_box.instr"
  mccchannel_18_cave2_box1_zdepth = kidney_cave2_box1_depth;
#line 4674 "MACS_sample_kidney_box.instr"
  mccchannel_18_cave2_box1_xwidth2 = kidney_cave2_box1_width2;
#line 4674 "MACS_sample_kidney_box.instr"
  mccchannel_18_cave2_box1_yheight2 = kidney_cave2_box1_height2;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_18_cave2_box1_visualize = 1;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_18_cave2_box1_target_index = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_18_cave2_box1_target_x = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_18_cave2_box1_target_y = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_18_cave2_box1_target_z = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_18_cave2_box1_focus_aw = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_18_cave2_box1_focus_ah = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_18_cave2_box1_focus_xw = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_18_cave2_box1_focus_xh = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_18_cave2_box1_focus_r = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_18_cave2_box1_p_interact = 0;
#line 71 "MACS_sample_kidney_box.instr"
  if(0) strncpy(mccchannel_18_cave2_box1_mask_string, 0 ? 0 : "", 16384); else mccchannel_18_cave2_box1_mask_string[0]='\0';
#line 71 "MACS_sample_kidney_box.instr"
  if(0) strncpy(mccchannel_18_cave2_box1_mask_setting, 0 ? 0 : "", 16384); else mccchannel_18_cave2_box1_mask_setting[0]='\0';
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_18_cave2_box1_number_of_activations = 1;
#line 146641 "MACS_sample_kidney_box.c"

  SIG_MESSAGE("channel_18_cave2_box1 (Init:Place/Rotate)");
  rot_set_rotation(mctr1,
#line 4677 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 4677 "MACS_sample_kidney_box.instr"
    (kidney_cave2_box1_y_rotation)*DEG2RAD,
#line 4677 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD);
#line 146651 "MACS_sample_kidney_box.c"
  rot_mul(mctr1, mcrotachannel_18_cave2_cyl1, mcrotachannel_18_cave2_box1);
  rot_transpose(mcrotachannel_18_cave2_cyl1, mctr1);
  rot_mul(mcrotachannel_18_cave2_box1, mctr1, mcrotrchannel_18_cave2_box1);
  mctc1 = coords_set(
#line 4676 "MACS_sample_kidney_box.instr"
    kidney_cave2_box1_center_to_spec_detector_x,
#line 4676 "MACS_sample_kidney_box.instr"
    0,
#line 4676 "MACS_sample_kidney_box.instr"
    kidney_cave2_box1_center_to_spec_detector_z);
#line 146662 "MACS_sample_kidney_box.c"
  rot_transpose(mcrotachannel_18_cave2_cyl1, mctr1);
  mctc2 = rot_apply(mctr1, mctc1);
  mcposachannel_18_cave2_box1 = coords_add(mcposachannel_18_cave2_cyl1, mctc2);
  mctc1 = coords_sub(mcposachannel_18_cave2_cyl1, mcposachannel_18_cave2_box1);
  mcposrchannel_18_cave2_box1 = rot_apply(mcrotachannel_18_cave2_box1, mctc1);
  mcDEBUG_COMPONENT("channel_18_cave2_box1", mcposachannel_18_cave2_box1, mcrotachannel_18_cave2_box1)
  mccomp_posa[835] = mcposachannel_18_cave2_box1;
  mccomp_posr[835] = mcposrchannel_18_cave2_box1;
  mcNCounter[835]  = mcPCounter[835] = mcP2Counter[835] = 0;
  mcAbsorbProp[835]= 0;
    /* Component channel_18_cave2_box2. */
  /* Setting parameters for component channel_18_cave2_box2. */
  SIG_MESSAGE("channel_18_cave2_box2 (Init:SetPar)");
#line 4682 "MACS_sample_kidney_box.instr"
  if("Vacuum") strncpy(mccchannel_18_cave2_box2_material_string, "Vacuum" ? "Vacuum" : "", 16384); else mccchannel_18_cave2_box2_material_string[0]='\0';
#line 4682 "MACS_sample_kidney_box.instr"
  mccchannel_18_cave2_box2_priority = 2006;
#line 4680 "MACS_sample_kidney_box.instr"
  mccchannel_18_cave2_box2_xwidth = kidney_cave2_box2_width1;
#line 4680 "MACS_sample_kidney_box.instr"
  mccchannel_18_cave2_box2_yheight = kidney_cave2_box2_height1;
#line 4680 "MACS_sample_kidney_box.instr"
  mccchannel_18_cave2_box2_zdepth = kidney_cave2_box2_depth;
#line 4681 "MACS_sample_kidney_box.instr"
  mccchannel_18_cave2_box2_xwidth2 = kidney_cave2_box2_width2;
#line 4681 "MACS_sample_kidney_box.instr"
  mccchannel_18_cave2_box2_yheight2 = kidney_cave2_box2_height2;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_18_cave2_box2_visualize = 1;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_18_cave2_box2_target_index = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_18_cave2_box2_target_x = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_18_cave2_box2_target_y = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_18_cave2_box2_target_z = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_18_cave2_box2_focus_aw = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_18_cave2_box2_focus_ah = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_18_cave2_box2_focus_xw = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_18_cave2_box2_focus_xh = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_18_cave2_box2_focus_r = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_18_cave2_box2_p_interact = 0;
#line 71 "MACS_sample_kidney_box.instr"
  if(0) strncpy(mccchannel_18_cave2_box2_mask_string, 0 ? 0 : "", 16384); else mccchannel_18_cave2_box2_mask_string[0]='\0';
#line 71 "MACS_sample_kidney_box.instr"
  if(0) strncpy(mccchannel_18_cave2_box2_mask_setting, 0 ? 0 : "", 16384); else mccchannel_18_cave2_box2_mask_setting[0]='\0';
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_18_cave2_box2_number_of_activations = 1;
#line 146718 "MACS_sample_kidney_box.c"

  SIG_MESSAGE("channel_18_cave2_box2 (Init:Place/Rotate)");
  rot_set_rotation(mctr1,
#line 4684 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 4684 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 4684 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD);
#line 146728 "MACS_sample_kidney_box.c"
  rot_mul(mctr1, mcrotachannel_18_cave2_cyl1, mcrotachannel_18_cave2_box2);
  rot_transpose(mcrotachannel_18_cave2_box1, mctr1);
  rot_mul(mcrotachannel_18_cave2_box2, mctr1, mcrotrchannel_18_cave2_box2);
  mctc1 = coords_set(
#line 4683 "MACS_sample_kidney_box.instr"
    0,
#line 4683 "MACS_sample_kidney_box.instr"
    0,
#line 4683 "MACS_sample_kidney_box.instr"
    kidney_cave2_box2_center_to_detector);
#line 146739 "MACS_sample_kidney_box.c"
  rot_transpose(mcrotachannel_18_cave2_cyl1, mctr1);
  mctc2 = rot_apply(mctr1, mctc1);
  mcposachannel_18_cave2_box2 = coords_add(mcposachannel_18_cave2_cyl1, mctc2);
  mctc1 = coords_sub(mcposachannel_18_cave2_box1, mcposachannel_18_cave2_box2);
  mcposrchannel_18_cave2_box2 = rot_apply(mcrotachannel_18_cave2_box2, mctc1);
  mcDEBUG_COMPONENT("channel_18_cave2_box2", mcposachannel_18_cave2_box2, mcrotachannel_18_cave2_box2)
  mccomp_posa[836] = mcposachannel_18_cave2_box2;
  mccomp_posr[836] = mcposrchannel_18_cave2_box2;
  mcNCounter[836]  = mcPCounter[836] = mcP2Counter[836] = 0;
  mcAbsorbProp[836]= 0;
    /* Component channel_18_cave2_box3. */
  /* Setting parameters for component channel_18_cave2_box3. */
  SIG_MESSAGE("channel_18_cave2_box3 (Init:SetPar)");
#line 4689 "MACS_sample_kidney_box.instr"
  if("Vacuum") strncpy(mccchannel_18_cave2_box3_material_string, "Vacuum" ? "Vacuum" : "", 16384); else mccchannel_18_cave2_box3_material_string[0]='\0';
#line 4689 "MACS_sample_kidney_box.instr"
  mccchannel_18_cave2_box3_priority = 2007;
#line 4687 "MACS_sample_kidney_box.instr"
  mccchannel_18_cave2_box3_xwidth = kidney_cave2_box3_width1;
#line 4687 "MACS_sample_kidney_box.instr"
  mccchannel_18_cave2_box3_yheight = kidney_cave2_box3_height1;
#line 4687 "MACS_sample_kidney_box.instr"
  mccchannel_18_cave2_box3_zdepth = kidney_cave2_box3_depth;
#line 4688 "MACS_sample_kidney_box.instr"
  mccchannel_18_cave2_box3_xwidth2 = kidney_cave2_box3_width2;
#line 4688 "MACS_sample_kidney_box.instr"
  mccchannel_18_cave2_box3_yheight2 = kidney_cave2_box3_height2;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_18_cave2_box3_visualize = 1;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_18_cave2_box3_target_index = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_18_cave2_box3_target_x = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_18_cave2_box3_target_y = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_18_cave2_box3_target_z = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_18_cave2_box3_focus_aw = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_18_cave2_box3_focus_ah = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_18_cave2_box3_focus_xw = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_18_cave2_box3_focus_xh = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_18_cave2_box3_focus_r = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_18_cave2_box3_p_interact = 0;
#line 71 "MACS_sample_kidney_box.instr"
  if(0) strncpy(mccchannel_18_cave2_box3_mask_string, 0 ? 0 : "", 16384); else mccchannel_18_cave2_box3_mask_string[0]='\0';
#line 71 "MACS_sample_kidney_box.instr"
  if(0) strncpy(mccchannel_18_cave2_box3_mask_setting, 0 ? 0 : "", 16384); else mccchannel_18_cave2_box3_mask_setting[0]='\0';
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_18_cave2_box3_number_of_activations = 1;
#line 146795 "MACS_sample_kidney_box.c"

  SIG_MESSAGE("channel_18_cave2_box3 (Init:Place/Rotate)");
  rot_set_rotation(mctr1,
#line 4691 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 4691 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 4691 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD);
#line 146805 "MACS_sample_kidney_box.c"
  rot_mul(mctr1, mcrotachannel_18_cave2_cyl1, mcrotachannel_18_cave2_box3);
  rot_transpose(mcrotachannel_18_cave2_box2, mctr1);
  rot_mul(mcrotachannel_18_cave2_box3, mctr1, mcrotrchannel_18_cave2_box3);
  mctc1 = coords_set(
#line 4690 "MACS_sample_kidney_box.instr"
    0,
#line 4690 "MACS_sample_kidney_box.instr"
    0,
#line 4690 "MACS_sample_kidney_box.instr"
    kidney_cave2_box3_center_to_detector);
#line 146816 "MACS_sample_kidney_box.c"
  rot_transpose(mcrotachannel_18_cave2_cyl1, mctr1);
  mctc2 = rot_apply(mctr1, mctc1);
  mcposachannel_18_cave2_box3 = coords_add(mcposachannel_18_cave2_cyl1, mctc2);
  mctc1 = coords_sub(mcposachannel_18_cave2_box2, mcposachannel_18_cave2_box3);
  mcposrchannel_18_cave2_box3 = rot_apply(mcrotachannel_18_cave2_box3, mctc1);
  mcDEBUG_COMPONENT("channel_18_cave2_box3", mcposachannel_18_cave2_box3, mcrotachannel_18_cave2_box3)
  mccomp_posa[837] = mcposachannel_18_cave2_box3;
  mccomp_posr[837] = mcposrchannel_18_cave2_box3;
  mcNCounter[837]  = mcPCounter[837] = mcP2Counter[837] = 0;
  mcAbsorbProp[837]= 0;
    /* Component inter_analyzer_colimator_center_18. */
  /* Setting parameters for component inter_analyzer_colimator_center_18. */
  SIG_MESSAGE("inter_analyzer_colimator_center_18 (Init:SetPar)");

  SIG_MESSAGE("inter_analyzer_colimator_center_18 (Init:Place/Rotate)");
  rot_set_rotation(mctr1,
#line 4695 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 4695 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 4695 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD);
#line 146839 "MACS_sample_kidney_box.c"
  rot_mul(mctr1, mcrotachannel_18_analyzer_1_center, mcrotainter_analyzer_colimator_center_18);
  rot_transpose(mcrotachannel_18_cave2_box3, mctr1);
  rot_mul(mcrotainter_analyzer_colimator_center_18, mctr1, mcrotrinter_analyzer_colimator_center_18);
  mctc1 = coords_set(
#line 4694 "MACS_sample_kidney_box.instr"
    -0.5 * analyzer_seperation,
#line 4694 "MACS_sample_kidney_box.instr"
    0,
#line 4694 "MACS_sample_kidney_box.instr"
    0);
#line 146850 "MACS_sample_kidney_box.c"
  rot_transpose(mcrotachannel_18_analyzer_1_center, mctr1);
  mctc2 = rot_apply(mctr1, mctc1);
  mcposainter_analyzer_colimator_center_18 = coords_add(mcposachannel_18_analyzer_1_center, mctc2);
  mctc1 = coords_sub(mcposachannel_18_cave2_box3, mcposainter_analyzer_colimator_center_18);
  mcposrinter_analyzer_colimator_center_18 = rot_apply(mcrotainter_analyzer_colimator_center_18, mctc1);
  mcDEBUG_COMPONENT("inter_analyzer_colimator_center_18", mcposainter_analyzer_colimator_center_18, mcrotainter_analyzer_colimator_center_18)
  mccomp_posa[838] = mcposainter_analyzer_colimator_center_18;
  mccomp_posr[838] = mcposrinter_analyzer_colimator_center_18;
  mcNCounter[838]  = mcPCounter[838] = mcP2Counter[838] = 0;
  mcAbsorbProp[838]= 0;
    /* Component inter_analyzer_colimator_18_blade_0. */
  /* Setting parameters for component inter_analyzer_colimator_18_blade_0. */
  SIG_MESSAGE("inter_analyzer_colimator_18_blade_0 (Init:SetPar)");
#line 4699 "MACS_sample_kidney_box.instr"
  if("Collimator_gad") strncpy(mccinter_analyzer_colimator_18_blade_0_material_string, "Collimator_gad" ? "Collimator_gad" : "", 16384); else mccinter_analyzer_colimator_18_blade_0_material_string[0]='\0';
#line 4699 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_18_blade_0_priority = 2025;
#line 4698 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_18_blade_0_xwidth = inter_analyzer_colimator_width;
#line 4698 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_18_blade_0_yheight = inter_analyzer_colimator_height;
#line 4698 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_18_blade_0_zdepth = inter_analyzer_colimator_depth;
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_18_blade_0_xwidth2 = -1;
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_18_blade_0_yheight2 = -1;
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_18_blade_0_visualize = 1;
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_18_blade_0_target_index = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_18_blade_0_target_x = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_18_blade_0_target_y = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_18_blade_0_target_z = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_18_blade_0_focus_aw = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_18_blade_0_focus_ah = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_18_blade_0_focus_xw = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_18_blade_0_focus_xh = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_18_blade_0_focus_r = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_18_blade_0_p_interact = 0;
#line 71 "MACS_sample_kidney_box.instr"
  if(0) strncpy(mccinter_analyzer_colimator_18_blade_0_mask_string, 0 ? 0 : "", 16384); else mccinter_analyzer_colimator_18_blade_0_mask_string[0]='\0';
#line 71 "MACS_sample_kidney_box.instr"
  if(0) strncpy(mccinter_analyzer_colimator_18_blade_0_mask_setting, 0 ? 0 : "", 16384); else mccinter_analyzer_colimator_18_blade_0_mask_setting[0]='\0';
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_18_blade_0_number_of_activations = 1;
#line 146906 "MACS_sample_kidney_box.c"

  SIG_MESSAGE("inter_analyzer_colimator_18_blade_0 (Init:Place/Rotate)");
  rot_set_rotation(mctr1,
#line 4701 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 4701 "MACS_sample_kidney_box.instr"
    (- analyzer_2theta [ 18 ])*DEG2RAD,
#line 4701 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD);
#line 146916 "MACS_sample_kidney_box.c"
  rot_mul(mctr1, mcrotainter_analyzer_colimator_center_18, mcrotainter_analyzer_colimator_18_blade_0);
  rot_transpose(mcrotainter_analyzer_colimator_center_18, mctr1);
  rot_mul(mcrotainter_analyzer_colimator_18_blade_0, mctr1, mcrotrinter_analyzer_colimator_18_blade_0);
  mctc1 = coords_set(
#line 4700 "MACS_sample_kidney_box.instr"
    0,
#line 4700 "MACS_sample_kidney_box.instr"
    0,
#line 4700 "MACS_sample_kidney_box.instr"
    inter_analyzer_colimator_start_pos - 0 * inter_analyzer_colimator_seperation);
#line 146927 "MACS_sample_kidney_box.c"
  rot_transpose(mcrotainter_analyzer_colimator_center_18, mctr1);
  mctc2 = rot_apply(mctr1, mctc1);
  mcposainter_analyzer_colimator_18_blade_0 = coords_add(mcposainter_analyzer_colimator_center_18, mctc2);
  mctc1 = coords_sub(mcposainter_analyzer_colimator_center_18, mcposainter_analyzer_colimator_18_blade_0);
  mcposrinter_analyzer_colimator_18_blade_0 = rot_apply(mcrotainter_analyzer_colimator_18_blade_0, mctc1);
  mcDEBUG_COMPONENT("inter_analyzer_colimator_18_blade_0", mcposainter_analyzer_colimator_18_blade_0, mcrotainter_analyzer_colimator_18_blade_0)
  mccomp_posa[839] = mcposainter_analyzer_colimator_18_blade_0;
  mccomp_posr[839] = mcposrinter_analyzer_colimator_18_blade_0;
  mcNCounter[839]  = mcPCounter[839] = mcP2Counter[839] = 0;
  mcAbsorbProp[839]= 0;
    /* Component inter_analyzer_colimator_18_blade_1. */
  /* Setting parameters for component inter_analyzer_colimator_18_blade_1. */
  SIG_MESSAGE("inter_analyzer_colimator_18_blade_1 (Init:SetPar)");
#line 4705 "MACS_sample_kidney_box.instr"
  if("Collimator_gad") strncpy(mccinter_analyzer_colimator_18_blade_1_material_string, "Collimator_gad" ? "Collimator_gad" : "", 16384); else mccinter_analyzer_colimator_18_blade_1_material_string[0]='\0';
#line 4705 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_18_blade_1_priority = 2026;
#line 4704 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_18_blade_1_xwidth = inter_analyzer_colimator_width;
#line 4704 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_18_blade_1_yheight = inter_analyzer_colimator_height;
#line 4704 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_18_blade_1_zdepth = inter_analyzer_colimator_depth;
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_18_blade_1_xwidth2 = -1;
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_18_blade_1_yheight2 = -1;
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_18_blade_1_visualize = 1;
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_18_blade_1_target_index = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_18_blade_1_target_x = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_18_blade_1_target_y = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_18_blade_1_target_z = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_18_blade_1_focus_aw = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_18_blade_1_focus_ah = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_18_blade_1_focus_xw = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_18_blade_1_focus_xh = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_18_blade_1_focus_r = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_18_blade_1_p_interact = 0;
#line 71 "MACS_sample_kidney_box.instr"
  if(0) strncpy(mccinter_analyzer_colimator_18_blade_1_mask_string, 0 ? 0 : "", 16384); else mccinter_analyzer_colimator_18_blade_1_mask_string[0]='\0';
#line 71 "MACS_sample_kidney_box.instr"
  if(0) strncpy(mccinter_analyzer_colimator_18_blade_1_mask_setting, 0 ? 0 : "", 16384); else mccinter_analyzer_colimator_18_blade_1_mask_setting[0]='\0';
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_18_blade_1_number_of_activations = 1;
#line 146983 "MACS_sample_kidney_box.c"

  SIG_MESSAGE("inter_analyzer_colimator_18_blade_1 (Init:Place/Rotate)");
  rot_set_rotation(mctr1,
#line 4707 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 4707 "MACS_sample_kidney_box.instr"
    (- analyzer_2theta [ 18 ])*DEG2RAD,
#line 4707 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD);
#line 146993 "MACS_sample_kidney_box.c"
  rot_mul(mctr1, mcrotainter_analyzer_colimator_center_18, mcrotainter_analyzer_colimator_18_blade_1);
  rot_transpose(mcrotainter_analyzer_colimator_18_blade_0, mctr1);
  rot_mul(mcrotainter_analyzer_colimator_18_blade_1, mctr1, mcrotrinter_analyzer_colimator_18_blade_1);
  mctc1 = coords_set(
#line 4706 "MACS_sample_kidney_box.instr"
    0,
#line 4706 "MACS_sample_kidney_box.instr"
    0,
#line 4706 "MACS_sample_kidney_box.instr"
    inter_analyzer_colimator_start_pos - 1 * inter_analyzer_colimator_seperation);
#line 147004 "MACS_sample_kidney_box.c"
  rot_transpose(mcrotainter_analyzer_colimator_center_18, mctr1);
  mctc2 = rot_apply(mctr1, mctc1);
  mcposainter_analyzer_colimator_18_blade_1 = coords_add(mcposainter_analyzer_colimator_center_18, mctc2);
  mctc1 = coords_sub(mcposainter_analyzer_colimator_18_blade_0, mcposainter_analyzer_colimator_18_blade_1);
  mcposrinter_analyzer_colimator_18_blade_1 = rot_apply(mcrotainter_analyzer_colimator_18_blade_1, mctc1);
  mcDEBUG_COMPONENT("inter_analyzer_colimator_18_blade_1", mcposainter_analyzer_colimator_18_blade_1, mcrotainter_analyzer_colimator_18_blade_1)
  mccomp_posa[840] = mcposainter_analyzer_colimator_18_blade_1;
  mccomp_posr[840] = mcposrinter_analyzer_colimator_18_blade_1;
  mcNCounter[840]  = mcPCounter[840] = mcP2Counter[840] = 0;
  mcAbsorbProp[840]= 0;
    /* Component inter_analyzer_colimator_18_blade_2. */
  /* Setting parameters for component inter_analyzer_colimator_18_blade_2. */
  SIG_MESSAGE("inter_analyzer_colimator_18_blade_2 (Init:SetPar)");
#line 4711 "MACS_sample_kidney_box.instr"
  if("Collimator_gad") strncpy(mccinter_analyzer_colimator_18_blade_2_material_string, "Collimator_gad" ? "Collimator_gad" : "", 16384); else mccinter_analyzer_colimator_18_blade_2_material_string[0]='\0';
#line 4711 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_18_blade_2_priority = 2027;
#line 4710 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_18_blade_2_xwidth = inter_analyzer_colimator_width;
#line 4710 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_18_blade_2_yheight = inter_analyzer_colimator_height;
#line 4710 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_18_blade_2_zdepth = inter_analyzer_colimator_depth;
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_18_blade_2_xwidth2 = -1;
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_18_blade_2_yheight2 = -1;
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_18_blade_2_visualize = 1;
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_18_blade_2_target_index = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_18_blade_2_target_x = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_18_blade_2_target_y = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_18_blade_2_target_z = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_18_blade_2_focus_aw = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_18_blade_2_focus_ah = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_18_blade_2_focus_xw = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_18_blade_2_focus_xh = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_18_blade_2_focus_r = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_18_blade_2_p_interact = 0;
#line 71 "MACS_sample_kidney_box.instr"
  if(0) strncpy(mccinter_analyzer_colimator_18_blade_2_mask_string, 0 ? 0 : "", 16384); else mccinter_analyzer_colimator_18_blade_2_mask_string[0]='\0';
#line 71 "MACS_sample_kidney_box.instr"
  if(0) strncpy(mccinter_analyzer_colimator_18_blade_2_mask_setting, 0 ? 0 : "", 16384); else mccinter_analyzer_colimator_18_blade_2_mask_setting[0]='\0';
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_18_blade_2_number_of_activations = 1;
#line 147060 "MACS_sample_kidney_box.c"

  SIG_MESSAGE("inter_analyzer_colimator_18_blade_2 (Init:Place/Rotate)");
  rot_set_rotation(mctr1,
#line 4713 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 4713 "MACS_sample_kidney_box.instr"
    (- analyzer_2theta [ 18 ])*DEG2RAD,
#line 4713 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD);
#line 147070 "MACS_sample_kidney_box.c"
  rot_mul(mctr1, mcrotainter_analyzer_colimator_center_18, mcrotainter_analyzer_colimator_18_blade_2);
  rot_transpose(mcrotainter_analyzer_colimator_18_blade_1, mctr1);
  rot_mul(mcrotainter_analyzer_colimator_18_blade_2, mctr1, mcrotrinter_analyzer_colimator_18_blade_2);
  mctc1 = coords_set(
#line 4712 "MACS_sample_kidney_box.instr"
    0,
#line 4712 "MACS_sample_kidney_box.instr"
    0,
#line 4712 "MACS_sample_kidney_box.instr"
    inter_analyzer_colimator_start_pos - 2 * inter_analyzer_colimator_seperation);
#line 147081 "MACS_sample_kidney_box.c"
  rot_transpose(mcrotainter_analyzer_colimator_center_18, mctr1);
  mctc2 = rot_apply(mctr1, mctc1);
  mcposainter_analyzer_colimator_18_blade_2 = coords_add(mcposainter_analyzer_colimator_center_18, mctc2);
  mctc1 = coords_sub(mcposainter_analyzer_colimator_18_blade_1, mcposainter_analyzer_colimator_18_blade_2);
  mcposrinter_analyzer_colimator_18_blade_2 = rot_apply(mcrotainter_analyzer_colimator_18_blade_2, mctc1);
  mcDEBUG_COMPONENT("inter_analyzer_colimator_18_blade_2", mcposainter_analyzer_colimator_18_blade_2, mcrotainter_analyzer_colimator_18_blade_2)
  mccomp_posa[841] = mcposainter_analyzer_colimator_18_blade_2;
  mccomp_posr[841] = mcposrinter_analyzer_colimator_18_blade_2;
  mcNCounter[841]  = mcPCounter[841] = mcP2Counter[841] = 0;
  mcAbsorbProp[841]= 0;
    /* Component inter_analyzer_colimator_18_blade_3. */
  /* Setting parameters for component inter_analyzer_colimator_18_blade_3. */
  SIG_MESSAGE("inter_analyzer_colimator_18_blade_3 (Init:SetPar)");
#line 4717 "MACS_sample_kidney_box.instr"
  if("Collimator_gad") strncpy(mccinter_analyzer_colimator_18_blade_3_material_string, "Collimator_gad" ? "Collimator_gad" : "", 16384); else mccinter_analyzer_colimator_18_blade_3_material_string[0]='\0';
#line 4717 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_18_blade_3_priority = 2028;
#line 4716 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_18_blade_3_xwidth = inter_analyzer_colimator_width;
#line 4716 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_18_blade_3_yheight = inter_analyzer_colimator_height;
#line 4716 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_18_blade_3_zdepth = inter_analyzer_colimator_depth;
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_18_blade_3_xwidth2 = -1;
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_18_blade_3_yheight2 = -1;
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_18_blade_3_visualize = 1;
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_18_blade_3_target_index = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_18_blade_3_target_x = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_18_blade_3_target_y = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_18_blade_3_target_z = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_18_blade_3_focus_aw = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_18_blade_3_focus_ah = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_18_blade_3_focus_xw = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_18_blade_3_focus_xh = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_18_blade_3_focus_r = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_18_blade_3_p_interact = 0;
#line 71 "MACS_sample_kidney_box.instr"
  if(0) strncpy(mccinter_analyzer_colimator_18_blade_3_mask_string, 0 ? 0 : "", 16384); else mccinter_analyzer_colimator_18_blade_3_mask_string[0]='\0';
#line 71 "MACS_sample_kidney_box.instr"
  if(0) strncpy(mccinter_analyzer_colimator_18_blade_3_mask_setting, 0 ? 0 : "", 16384); else mccinter_analyzer_colimator_18_blade_3_mask_setting[0]='\0';
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_18_blade_3_number_of_activations = 1;
#line 147137 "MACS_sample_kidney_box.c"

  SIG_MESSAGE("inter_analyzer_colimator_18_blade_3 (Init:Place/Rotate)");
  rot_set_rotation(mctr1,
#line 4719 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 4719 "MACS_sample_kidney_box.instr"
    (- analyzer_2theta [ 18 ])*DEG2RAD,
#line 4719 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD);
#line 147147 "MACS_sample_kidney_box.c"
  rot_mul(mctr1, mcrotainter_analyzer_colimator_center_18, mcrotainter_analyzer_colimator_18_blade_3);
  rot_transpose(mcrotainter_analyzer_colimator_18_blade_2, mctr1);
  rot_mul(mcrotainter_analyzer_colimator_18_blade_3, mctr1, mcrotrinter_analyzer_colimator_18_blade_3);
  mctc1 = coords_set(
#line 4718 "MACS_sample_kidney_box.instr"
    0,
#line 4718 "MACS_sample_kidney_box.instr"
    0,
#line 4718 "MACS_sample_kidney_box.instr"
    inter_analyzer_colimator_start_pos - 3 * inter_analyzer_colimator_seperation);
#line 147158 "MACS_sample_kidney_box.c"
  rot_transpose(mcrotainter_analyzer_colimator_center_18, mctr1);
  mctc2 = rot_apply(mctr1, mctc1);
  mcposainter_analyzer_colimator_18_blade_3 = coords_add(mcposainter_analyzer_colimator_center_18, mctc2);
  mctc1 = coords_sub(mcposainter_analyzer_colimator_18_blade_2, mcposainter_analyzer_colimator_18_blade_3);
  mcposrinter_analyzer_colimator_18_blade_3 = rot_apply(mcrotainter_analyzer_colimator_18_blade_3, mctc1);
  mcDEBUG_COMPONENT("inter_analyzer_colimator_18_blade_3", mcposainter_analyzer_colimator_18_blade_3, mcrotainter_analyzer_colimator_18_blade_3)
  mccomp_posa[842] = mcposainter_analyzer_colimator_18_blade_3;
  mccomp_posr[842] = mcposrinter_analyzer_colimator_18_blade_3;
  mcNCounter[842]  = mcPCounter[842] = mcP2Counter[842] = 0;
  mcAbsorbProp[842]= 0;
    /* Component inter_analyzer_colimator_18_blade_4. */
  /* Setting parameters for component inter_analyzer_colimator_18_blade_4. */
  SIG_MESSAGE("inter_analyzer_colimator_18_blade_4 (Init:SetPar)");
#line 4723 "MACS_sample_kidney_box.instr"
  if("Collimator_gad") strncpy(mccinter_analyzer_colimator_18_blade_4_material_string, "Collimator_gad" ? "Collimator_gad" : "", 16384); else mccinter_analyzer_colimator_18_blade_4_material_string[0]='\0';
#line 4723 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_18_blade_4_priority = 2029;
#line 4722 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_18_blade_4_xwidth = inter_analyzer_colimator_width;
#line 4722 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_18_blade_4_yheight = inter_analyzer_colimator_height;
#line 4722 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_18_blade_4_zdepth = inter_analyzer_colimator_depth;
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_18_blade_4_xwidth2 = -1;
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_18_blade_4_yheight2 = -1;
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_18_blade_4_visualize = 1;
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_18_blade_4_target_index = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_18_blade_4_target_x = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_18_blade_4_target_y = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_18_blade_4_target_z = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_18_blade_4_focus_aw = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_18_blade_4_focus_ah = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_18_blade_4_focus_xw = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_18_blade_4_focus_xh = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_18_blade_4_focus_r = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_18_blade_4_p_interact = 0;
#line 71 "MACS_sample_kidney_box.instr"
  if(0) strncpy(mccinter_analyzer_colimator_18_blade_4_mask_string, 0 ? 0 : "", 16384); else mccinter_analyzer_colimator_18_blade_4_mask_string[0]='\0';
#line 71 "MACS_sample_kidney_box.instr"
  if(0) strncpy(mccinter_analyzer_colimator_18_blade_4_mask_setting, 0 ? 0 : "", 16384); else mccinter_analyzer_colimator_18_blade_4_mask_setting[0]='\0';
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_18_blade_4_number_of_activations = 1;
#line 147214 "MACS_sample_kidney_box.c"

  SIG_MESSAGE("inter_analyzer_colimator_18_blade_4 (Init:Place/Rotate)");
  rot_set_rotation(mctr1,
#line 4725 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 4725 "MACS_sample_kidney_box.instr"
    (- analyzer_2theta [ 18 ])*DEG2RAD,
#line 4725 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD);
#line 147224 "MACS_sample_kidney_box.c"
  rot_mul(mctr1, mcrotainter_analyzer_colimator_center_18, mcrotainter_analyzer_colimator_18_blade_4);
  rot_transpose(mcrotainter_analyzer_colimator_18_blade_3, mctr1);
  rot_mul(mcrotainter_analyzer_colimator_18_blade_4, mctr1, mcrotrinter_analyzer_colimator_18_blade_4);
  mctc1 = coords_set(
#line 4724 "MACS_sample_kidney_box.instr"
    0,
#line 4724 "MACS_sample_kidney_box.instr"
    0,
#line 4724 "MACS_sample_kidney_box.instr"
    inter_analyzer_colimator_start_pos - 4 * inter_analyzer_colimator_seperation);
#line 147235 "MACS_sample_kidney_box.c"
  rot_transpose(mcrotainter_analyzer_colimator_center_18, mctr1);
  mctc2 = rot_apply(mctr1, mctc1);
  mcposainter_analyzer_colimator_18_blade_4 = coords_add(mcposainter_analyzer_colimator_center_18, mctc2);
  mctc1 = coords_sub(mcposainter_analyzer_colimator_18_blade_3, mcposainter_analyzer_colimator_18_blade_4);
  mcposrinter_analyzer_colimator_18_blade_4 = rot_apply(mcrotainter_analyzer_colimator_18_blade_4, mctc1);
  mcDEBUG_COMPONENT("inter_analyzer_colimator_18_blade_4", mcposainter_analyzer_colimator_18_blade_4, mcrotainter_analyzer_colimator_18_blade_4)
  mccomp_posa[843] = mcposainter_analyzer_colimator_18_blade_4;
  mccomp_posr[843] = mcposrinter_analyzer_colimator_18_blade_4;
  mcNCounter[843]  = mcPCounter[843] = mcP2Counter[843] = 0;
  mcAbsorbProp[843]= 0;
    /* Component diffraction_detector_18_exit_volume. */
  /* Setting parameters for component diffraction_detector_18_exit_volume. */
  SIG_MESSAGE("diffraction_detector_18_exit_volume (Init:SetPar)");
#line 4729 "MACS_sample_kidney_box.instr"
  if("Exit") strncpy(mccdiffraction_detector_18_exit_volume_material_string, "Exit" ? "Exit" : "", 16384); else mccdiffraction_detector_18_exit_volume_material_string[0]='\0';
#line 4729 "MACS_sample_kidney_box.instr"
  mccdiffraction_detector_18_exit_volume_priority = 2031;
#line 4728 "MACS_sample_kidney_box.instr"
  mccdiffraction_detector_18_exit_volume_xwidth = 2.01 * detector_radius;
#line 4728 "MACS_sample_kidney_box.instr"
  mccdiffraction_detector_18_exit_volume_yheight = 1.01 * detector_height;
#line 4728 "MACS_sample_kidney_box.instr"
  mccdiffraction_detector_18_exit_volume_zdepth = 0.001;
#line 71 "MACS_sample_kidney_box.instr"
  mccdiffraction_detector_18_exit_volume_xwidth2 = -1;
#line 71 "MACS_sample_kidney_box.instr"
  mccdiffraction_detector_18_exit_volume_yheight2 = -1;
#line 71 "MACS_sample_kidney_box.instr"
  mccdiffraction_detector_18_exit_volume_visualize = 1;
#line 71 "MACS_sample_kidney_box.instr"
  mccdiffraction_detector_18_exit_volume_target_index = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccdiffraction_detector_18_exit_volume_target_x = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccdiffraction_detector_18_exit_volume_target_y = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccdiffraction_detector_18_exit_volume_target_z = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccdiffraction_detector_18_exit_volume_focus_aw = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccdiffraction_detector_18_exit_volume_focus_ah = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccdiffraction_detector_18_exit_volume_focus_xw = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccdiffraction_detector_18_exit_volume_focus_xh = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccdiffraction_detector_18_exit_volume_focus_r = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccdiffraction_detector_18_exit_volume_p_interact = 0;
#line 71 "MACS_sample_kidney_box.instr"
  if(0) strncpy(mccdiffraction_detector_18_exit_volume_mask_string, 0 ? 0 : "", 16384); else mccdiffraction_detector_18_exit_volume_mask_string[0]='\0';
#line 71 "MACS_sample_kidney_box.instr"
  if(0) strncpy(mccdiffraction_detector_18_exit_volume_mask_setting, 0 ? 0 : "", 16384); else mccdiffraction_detector_18_exit_volume_mask_setting[0]='\0';
#line 71 "MACS_sample_kidney_box.instr"
  mccdiffraction_detector_18_exit_volume_number_of_activations = 1;
#line 147291 "MACS_sample_kidney_box.c"

  SIG_MESSAGE("diffraction_detector_18_exit_volume (Init:Place/Rotate)");
  rot_set_rotation(mctr1,
#line 4731 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 4731 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 4731 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD);
#line 147301 "MACS_sample_kidney_box.c"
  rot_mul(mctr1, mcrotakidney_channel_18, mcrotadiffraction_detector_18_exit_volume);
  rot_transpose(mcrotainter_analyzer_colimator_18_blade_4, mctr1);
  rot_mul(mcrotadiffraction_detector_18_exit_volume, mctr1, mcrotrdiffraction_detector_18_exit_volume);
  mctc1 = coords_set(
#line 4730 "MACS_sample_kidney_box.instr"
    0,
#line 4730 "MACS_sample_kidney_box.instr"
    0,
#line 4730 "MACS_sample_kidney_box.instr"
    0);
#line 147312 "MACS_sample_kidney_box.c"
  rot_transpose(mcrotachannel_18_cave1_cyl1, mctr1);
  mctc2 = rot_apply(mctr1, mctc1);
  mcposadiffraction_detector_18_exit_volume = coords_add(mcposachannel_18_cave1_cyl1, mctc2);
  mctc1 = coords_sub(mcposainter_analyzer_colimator_18_blade_4, mcposadiffraction_detector_18_exit_volume);
  mcposrdiffraction_detector_18_exit_volume = rot_apply(mcrotadiffraction_detector_18_exit_volume, mctc1);
  mcDEBUG_COMPONENT("diffraction_detector_18_exit_volume", mcposadiffraction_detector_18_exit_volume, mcrotadiffraction_detector_18_exit_volume)
  mccomp_posa[844] = mcposadiffraction_detector_18_exit_volume;
  mccomp_posr[844] = mcposrdiffraction_detector_18_exit_volume;
  mcNCounter[844]  = mcPCounter[844] = mcP2Counter[844] = 0;
  mcAbsorbProp[844]= 0;
    /* Component spec_detector_18_exit_volume. */
  /* Setting parameters for component spec_detector_18_exit_volume. */
  SIG_MESSAGE("spec_detector_18_exit_volume (Init:SetPar)");
#line 4735 "MACS_sample_kidney_box.instr"
  if("Exit") strncpy(mccspec_detector_18_exit_volume_material_string, "Exit" ? "Exit" : "", 16384); else mccspec_detector_18_exit_volume_material_string[0]='\0';
#line 4735 "MACS_sample_kidney_box.instr"
  mccspec_detector_18_exit_volume_priority = 2032;
#line 4734 "MACS_sample_kidney_box.instr"
  mccspec_detector_18_exit_volume_xwidth = 2.01 * detector_radius;
#line 4734 "MACS_sample_kidney_box.instr"
  mccspec_detector_18_exit_volume_yheight = 1.01 * detector_height;
#line 4734 "MACS_sample_kidney_box.instr"
  mccspec_detector_18_exit_volume_zdepth = 0.001;
#line 71 "MACS_sample_kidney_box.instr"
  mccspec_detector_18_exit_volume_xwidth2 = -1;
#line 71 "MACS_sample_kidney_box.instr"
  mccspec_detector_18_exit_volume_yheight2 = -1;
#line 71 "MACS_sample_kidney_box.instr"
  mccspec_detector_18_exit_volume_visualize = 1;
#line 71 "MACS_sample_kidney_box.instr"
  mccspec_detector_18_exit_volume_target_index = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccspec_detector_18_exit_volume_target_x = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccspec_detector_18_exit_volume_target_y = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccspec_detector_18_exit_volume_target_z = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccspec_detector_18_exit_volume_focus_aw = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccspec_detector_18_exit_volume_focus_ah = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccspec_detector_18_exit_volume_focus_xw = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccspec_detector_18_exit_volume_focus_xh = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccspec_detector_18_exit_volume_focus_r = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccspec_detector_18_exit_volume_p_interact = 0;
#line 71 "MACS_sample_kidney_box.instr"
  if(0) strncpy(mccspec_detector_18_exit_volume_mask_string, 0 ? 0 : "", 16384); else mccspec_detector_18_exit_volume_mask_string[0]='\0';
#line 71 "MACS_sample_kidney_box.instr"
  if(0) strncpy(mccspec_detector_18_exit_volume_mask_setting, 0 ? 0 : "", 16384); else mccspec_detector_18_exit_volume_mask_setting[0]='\0';
#line 71 "MACS_sample_kidney_box.instr"
  mccspec_detector_18_exit_volume_number_of_activations = 1;
#line 147368 "MACS_sample_kidney_box.c"

  SIG_MESSAGE("spec_detector_18_exit_volume (Init:Place/Rotate)");
  rot_set_rotation(mctr1,
#line 4737 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 4737 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 4737 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD);
#line 147378 "MACS_sample_kidney_box.c"
  rot_mul(mctr1, mcrotachannel_18_analyzer_2_center, mcrotaspec_detector_18_exit_volume);
  rot_transpose(mcrotadiffraction_detector_18_exit_volume, mctr1);
  rot_mul(mcrotaspec_detector_18_exit_volume, mctr1, mcrotrspec_detector_18_exit_volume);
  mctc1 = coords_set(
#line 4736 "MACS_sample_kidney_box.instr"
    0,
#line 4736 "MACS_sample_kidney_box.instr"
    0,
#line 4736 "MACS_sample_kidney_box.instr"
    0);
#line 147389 "MACS_sample_kidney_box.c"
  rot_transpose(mcrotachannel_18_cave2_cyl1, mctr1);
  mctc2 = rot_apply(mctr1, mctc1);
  mcposaspec_detector_18_exit_volume = coords_add(mcposachannel_18_cave2_cyl1, mctc2);
  mctc1 = coords_sub(mcposadiffraction_detector_18_exit_volume, mcposaspec_detector_18_exit_volume);
  mcposrspec_detector_18_exit_volume = rot_apply(mcrotaspec_detector_18_exit_volume, mctc1);
  mcDEBUG_COMPONENT("spec_detector_18_exit_volume", mcposaspec_detector_18_exit_volume, mcrotaspec_detector_18_exit_volume)
  mccomp_posa[845] = mcposaspec_detector_18_exit_volume;
  mccomp_posr[845] = mcposrspec_detector_18_exit_volume;
  mcNCounter[845]  = mcPCounter[845] = mcP2Counter[845] = 0;
  mcAbsorbProp[845]= 0;
    /* Component channel_19_cave1_box1. */
  /* Setting parameters for component channel_19_cave1_box1. */
  SIG_MESSAGE("channel_19_cave1_box1 (Init:SetPar)");
#line 4742 "MACS_sample_kidney_box.instr"
  if("Vacuum") strncpy(mccchannel_19_cave1_box1_material_string, "Vacuum" ? "Vacuum" : "", 16384); else mccchannel_19_cave1_box1_material_string[0]='\0';
#line 4742 "MACS_sample_kidney_box.instr"
  mccchannel_19_cave1_box1_priority = 2100;
#line 4740 "MACS_sample_kidney_box.instr"
  mccchannel_19_cave1_box1_xwidth = kidney_cave1_box1_width1;
#line 4740 "MACS_sample_kidney_box.instr"
  mccchannel_19_cave1_box1_yheight = kidney_cave1_box1_height1;
#line 4740 "MACS_sample_kidney_box.instr"
  mccchannel_19_cave1_box1_zdepth = kidney_cave1_box1_depth;
#line 4741 "MACS_sample_kidney_box.instr"
  mccchannel_19_cave1_box1_xwidth2 = kidney_cave1_box1_width2;
#line 4741 "MACS_sample_kidney_box.instr"
  mccchannel_19_cave1_box1_yheight2 = kidney_cave1_box1_height2;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_19_cave1_box1_visualize = 1;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_19_cave1_box1_target_index = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_19_cave1_box1_target_x = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_19_cave1_box1_target_y = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_19_cave1_box1_target_z = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_19_cave1_box1_focus_aw = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_19_cave1_box1_focus_ah = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_19_cave1_box1_focus_xw = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_19_cave1_box1_focus_xh = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_19_cave1_box1_focus_r = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_19_cave1_box1_p_interact = 0;
#line 71 "MACS_sample_kidney_box.instr"
  if(0) strncpy(mccchannel_19_cave1_box1_mask_string, 0 ? 0 : "", 16384); else mccchannel_19_cave1_box1_mask_string[0]='\0';
#line 71 "MACS_sample_kidney_box.instr"
  if(0) strncpy(mccchannel_19_cave1_box1_mask_setting, 0 ? 0 : "", 16384); else mccchannel_19_cave1_box1_mask_setting[0]='\0';
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_19_cave1_box1_number_of_activations = 1;
#line 147445 "MACS_sample_kidney_box.c"

  SIG_MESSAGE("channel_19_cave1_box1 (Init:Place/Rotate)");
  rot_set_rotation(mctr1,
#line 4744 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 4744 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 4744 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD);
#line 147455 "MACS_sample_kidney_box.c"
  rot_mul(mctr1, mcrotakidney_channel_19, mcrotachannel_19_cave1_box1);
  rot_transpose(mcrotaspec_detector_18_exit_volume, mctr1);
  rot_mul(mcrotachannel_19_cave1_box1, mctr1, mcrotrchannel_19_cave1_box1);
  mctc1 = coords_set(
#line 4743 "MACS_sample_kidney_box.instr"
    0,
#line 4743 "MACS_sample_kidney_box.instr"
    0,
#line 4743 "MACS_sample_kidney_box.instr"
    kidney_cave1_box1_center_to_target);
#line 147466 "MACS_sample_kidney_box.c"
  rot_transpose(mcrotakidney_channel_19, mctr1);
  mctc2 = rot_apply(mctr1, mctc1);
  mcposachannel_19_cave1_box1 = coords_add(mcposakidney_channel_19, mctc2);
  mctc1 = coords_sub(mcposaspec_detector_18_exit_volume, mcposachannel_19_cave1_box1);
  mcposrchannel_19_cave1_box1 = rot_apply(mcrotachannel_19_cave1_box1, mctc1);
  mcDEBUG_COMPONENT("channel_19_cave1_box1", mcposachannel_19_cave1_box1, mcrotachannel_19_cave1_box1)
  mccomp_posa[846] = mcposachannel_19_cave1_box1;
  mccomp_posr[846] = mcposrchannel_19_cave1_box1;
  mcNCounter[846]  = mcPCounter[846] = mcP2Counter[846] = 0;
  mcAbsorbProp[846]= 0;
    /* Component channel_19_cave1_box2. */
  /* Setting parameters for component channel_19_cave1_box2. */
  SIG_MESSAGE("channel_19_cave1_box2 (Init:SetPar)");
#line 4749 "MACS_sample_kidney_box.instr"
  if("Vacuum") strncpy(mccchannel_19_cave1_box2_material_string, "Vacuum" ? "Vacuum" : "", 16384); else mccchannel_19_cave1_box2_material_string[0]='\0';
#line 4749 "MACS_sample_kidney_box.instr"
  mccchannel_19_cave1_box2_priority = 2105;
#line 4747 "MACS_sample_kidney_box.instr"
  mccchannel_19_cave1_box2_xwidth = kidney_cave1_box2_width1;
#line 4747 "MACS_sample_kidney_box.instr"
  mccchannel_19_cave1_box2_yheight = kidney_cave1_box2_height1;
#line 4747 "MACS_sample_kidney_box.instr"
  mccchannel_19_cave1_box2_zdepth = kidney_cave1_box2_depth;
#line 4748 "MACS_sample_kidney_box.instr"
  mccchannel_19_cave1_box2_xwidth2 = kidney_cave1_box2_width2;
#line 4748 "MACS_sample_kidney_box.instr"
  mccchannel_19_cave1_box2_yheight2 = kidney_cave1_box2_height2;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_19_cave1_box2_visualize = 1;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_19_cave1_box2_target_index = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_19_cave1_box2_target_x = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_19_cave1_box2_target_y = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_19_cave1_box2_target_z = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_19_cave1_box2_focus_aw = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_19_cave1_box2_focus_ah = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_19_cave1_box2_focus_xw = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_19_cave1_box2_focus_xh = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_19_cave1_box2_focus_r = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_19_cave1_box2_p_interact = 0;
#line 71 "MACS_sample_kidney_box.instr"
  if(0) strncpy(mccchannel_19_cave1_box2_mask_string, 0 ? 0 : "", 16384); else mccchannel_19_cave1_box2_mask_string[0]='\0';
#line 71 "MACS_sample_kidney_box.instr"
  if(0) strncpy(mccchannel_19_cave1_box2_mask_setting, 0 ? 0 : "", 16384); else mccchannel_19_cave1_box2_mask_setting[0]='\0';
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_19_cave1_box2_number_of_activations = 1;
#line 147522 "MACS_sample_kidney_box.c"

  SIG_MESSAGE("channel_19_cave1_box2 (Init:Place/Rotate)");
  rot_set_rotation(mctr1,
#line 4751 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 4751 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 4751 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD);
#line 147532 "MACS_sample_kidney_box.c"
  rot_mul(mctr1, mcrotakidney_channel_19, mcrotachannel_19_cave1_box2);
  rot_transpose(mcrotachannel_19_cave1_box1, mctr1);
  rot_mul(mcrotachannel_19_cave1_box2, mctr1, mcrotrchannel_19_cave1_box2);
  mctc1 = coords_set(
#line 4750 "MACS_sample_kidney_box.instr"
    kidney_cave1_box2_x_offset,
#line 4750 "MACS_sample_kidney_box.instr"
    0,
#line 4750 "MACS_sample_kidney_box.instr"
    kidney_cave1_box2_center_to_target);
#line 147543 "MACS_sample_kidney_box.c"
  rot_transpose(mcrotakidney_channel_19, mctr1);
  mctc2 = rot_apply(mctr1, mctc1);
  mcposachannel_19_cave1_box2 = coords_add(mcposakidney_channel_19, mctc2);
  mctc1 = coords_sub(mcposachannel_19_cave1_box1, mcposachannel_19_cave1_box2);
  mcposrchannel_19_cave1_box2 = rot_apply(mcrotachannel_19_cave1_box2, mctc1);
  mcDEBUG_COMPONENT("channel_19_cave1_box2", mcposachannel_19_cave1_box2, mcrotachannel_19_cave1_box2)
  mccomp_posa[847] = mcposachannel_19_cave1_box2;
  mccomp_posr[847] = mcposrchannel_19_cave1_box2;
  mcNCounter[847]  = mcPCounter[847] = mcP2Counter[847] = 0;
  mcAbsorbProp[847]= 0;
    /* Component channel_19_cave1_box3. */
  /* Setting parameters for component channel_19_cave1_box3. */
  SIG_MESSAGE("channel_19_cave1_box3 (Init:SetPar)");
#line 4756 "MACS_sample_kidney_box.instr"
  if("Vacuum") strncpy(mccchannel_19_cave1_box3_material_string, "Vacuum" ? "Vacuum" : "", 16384); else mccchannel_19_cave1_box3_material_string[0]='\0';
#line 4756 "MACS_sample_kidney_box.instr"
  mccchannel_19_cave1_box3_priority = 2102;
#line 4754 "MACS_sample_kidney_box.instr"
  mccchannel_19_cave1_box3_xwidth = kidney_cave1_box3_width1;
#line 4754 "MACS_sample_kidney_box.instr"
  mccchannel_19_cave1_box3_yheight = kidney_cave1_box3_height1;
#line 4754 "MACS_sample_kidney_box.instr"
  mccchannel_19_cave1_box3_zdepth = kidney_cave1_box3_depth;
#line 4755 "MACS_sample_kidney_box.instr"
  mccchannel_19_cave1_box3_xwidth2 = kidney_cave1_box3_width2;
#line 4755 "MACS_sample_kidney_box.instr"
  mccchannel_19_cave1_box3_yheight2 = kidney_cave1_box3_height2;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_19_cave1_box3_visualize = 1;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_19_cave1_box3_target_index = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_19_cave1_box3_target_x = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_19_cave1_box3_target_y = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_19_cave1_box3_target_z = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_19_cave1_box3_focus_aw = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_19_cave1_box3_focus_ah = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_19_cave1_box3_focus_xw = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_19_cave1_box3_focus_xh = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_19_cave1_box3_focus_r = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_19_cave1_box3_p_interact = 0;
#line 71 "MACS_sample_kidney_box.instr"
  if(0) strncpy(mccchannel_19_cave1_box3_mask_string, 0 ? 0 : "", 16384); else mccchannel_19_cave1_box3_mask_string[0]='\0';
#line 71 "MACS_sample_kidney_box.instr"
  if(0) strncpy(mccchannel_19_cave1_box3_mask_setting, 0 ? 0 : "", 16384); else mccchannel_19_cave1_box3_mask_setting[0]='\0';
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_19_cave1_box3_number_of_activations = 1;
#line 147599 "MACS_sample_kidney_box.c"

  SIG_MESSAGE("channel_19_cave1_box3 (Init:Place/Rotate)");
  rot_set_rotation(mctr1,
#line 4758 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 4758 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 4758 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD);
#line 147609 "MACS_sample_kidney_box.c"
  rot_mul(mctr1, mcrotakidney_channel_19, mcrotachannel_19_cave1_box3);
  rot_transpose(mcrotachannel_19_cave1_box2, mctr1);
  rot_mul(mcrotachannel_19_cave1_box3, mctr1, mcrotrchannel_19_cave1_box3);
  mctc1 = coords_set(
#line 4757 "MACS_sample_kidney_box.instr"
    0,
#line 4757 "MACS_sample_kidney_box.instr"
    0,
#line 4757 "MACS_sample_kidney_box.instr"
    kidney_cave1_box3_center_to_target);
#line 147620 "MACS_sample_kidney_box.c"
  rot_transpose(mcrotakidney_channel_19, mctr1);
  mctc2 = rot_apply(mctr1, mctc1);
  mcposachannel_19_cave1_box3 = coords_add(mcposakidney_channel_19, mctc2);
  mctc1 = coords_sub(mcposachannel_19_cave1_box2, mcposachannel_19_cave1_box3);
  mcposrchannel_19_cave1_box3 = rot_apply(mcrotachannel_19_cave1_box3, mctc1);
  mcDEBUG_COMPONENT("channel_19_cave1_box3", mcposachannel_19_cave1_box3, mcrotachannel_19_cave1_box3)
  mccomp_posa[848] = mcposachannel_19_cave1_box3;
  mccomp_posr[848] = mcposrchannel_19_cave1_box3;
  mcNCounter[848]  = mcPCounter[848] = mcP2Counter[848] = 0;
  mcAbsorbProp[848]= 0;
    /* Component channel_19_cave1_cyl1. */
  /* Setting parameters for component channel_19_cave1_cyl1. */
  SIG_MESSAGE("channel_19_cave1_cyl1 (Init:SetPar)");
#line 4762 "MACS_sample_kidney_box.instr"
  if("Vacuum") strncpy(mccchannel_19_cave1_cyl1_material_string, "Vacuum" ? "Vacuum" : "", 16384); else mccchannel_19_cave1_cyl1_material_string[0]='\0';
#line 4762 "MACS_sample_kidney_box.instr"
  mccchannel_19_cave1_cyl1_priority = 2103;
#line 4761 "MACS_sample_kidney_box.instr"
  mccchannel_19_cave1_cyl1_radius = kidney_cave1_cyl1_radius;
#line 4761 "MACS_sample_kidney_box.instr"
  mccchannel_19_cave1_cyl1_yheight = kidney_cave1_cyl1_height;
#line 67 "MACS_sample_kidney_box.instr"
  mccchannel_19_cave1_cyl1_visualize = 1;
#line 67 "MACS_sample_kidney_box.instr"
  mccchannel_19_cave1_cyl1_target_index = 0;
#line 67 "MACS_sample_kidney_box.instr"
  mccchannel_19_cave1_cyl1_target_x = 0;
#line 67 "MACS_sample_kidney_box.instr"
  mccchannel_19_cave1_cyl1_target_y = 0;
#line 67 "MACS_sample_kidney_box.instr"
  mccchannel_19_cave1_cyl1_target_z = 0;
#line 67 "MACS_sample_kidney_box.instr"
  mccchannel_19_cave1_cyl1_focus_aw = 0;
#line 67 "MACS_sample_kidney_box.instr"
  mccchannel_19_cave1_cyl1_focus_ah = 0;
#line 67 "MACS_sample_kidney_box.instr"
  mccchannel_19_cave1_cyl1_focus_xw = 0;
#line 67 "MACS_sample_kidney_box.instr"
  mccchannel_19_cave1_cyl1_focus_xh = 0;
#line 67 "MACS_sample_kidney_box.instr"
  mccchannel_19_cave1_cyl1_focus_r = 0;
#line 67 "MACS_sample_kidney_box.instr"
  mccchannel_19_cave1_cyl1_p_interact = 0;
#line 67 "MACS_sample_kidney_box.instr"
  if(0) strncpy(mccchannel_19_cave1_cyl1_mask_string, 0 ? 0 : "", 16384); else mccchannel_19_cave1_cyl1_mask_string[0]='\0';
#line 67 "MACS_sample_kidney_box.instr"
  if(0) strncpy(mccchannel_19_cave1_cyl1_mask_setting, 0 ? 0 : "", 16384); else mccchannel_19_cave1_cyl1_mask_setting[0]='\0';
#line 67 "MACS_sample_kidney_box.instr"
  mccchannel_19_cave1_cyl1_number_of_activations = 1;
#line 147670 "MACS_sample_kidney_box.c"

  SIG_MESSAGE("channel_19_cave1_cyl1 (Init:Place/Rotate)");
  rot_set_rotation(mctr1,
#line 4764 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 4764 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 4764 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD);
#line 147680 "MACS_sample_kidney_box.c"
  rot_mul(mctr1, mcrotakidney_channel_19, mcrotachannel_19_cave1_cyl1);
  rot_transpose(mcrotachannel_19_cave1_box3, mctr1);
  rot_mul(mcrotachannel_19_cave1_cyl1, mctr1, mcrotrchannel_19_cave1_cyl1);
  mctc1 = coords_set(
#line 4763 "MACS_sample_kidney_box.instr"
    0,
#line 4763 "MACS_sample_kidney_box.instr"
    0,
#line 4763 "MACS_sample_kidney_box.instr"
    kidney_cave1_cyl1_center_to_target);
#line 147691 "MACS_sample_kidney_box.c"
  rot_transpose(mcrotakidney_channel_19, mctr1);
  mctc2 = rot_apply(mctr1, mctc1);
  mcposachannel_19_cave1_cyl1 = coords_add(mcposakidney_channel_19, mctc2);
  mctc1 = coords_sub(mcposachannel_19_cave1_box3, mcposachannel_19_cave1_cyl1);
  mcposrchannel_19_cave1_cyl1 = rot_apply(mcrotachannel_19_cave1_cyl1, mctc1);
  mcDEBUG_COMPONENT("channel_19_cave1_cyl1", mcposachannel_19_cave1_cyl1, mcrotachannel_19_cave1_cyl1)
  mccomp_posa[849] = mcposachannel_19_cave1_cyl1;
  mccomp_posr[849] = mcposrchannel_19_cave1_cyl1;
  mcNCounter[849]  = mcPCounter[849] = mcP2Counter[849] = 0;
  mcAbsorbProp[849]= 0;
    /* Component channel_19_analyzer_1_center. */
  /* Setting parameters for component channel_19_analyzer_1_center. */
  SIG_MESSAGE("channel_19_analyzer_1_center (Init:SetPar)");

  SIG_MESSAGE("channel_19_analyzer_1_center (Init:Place/Rotate)");
  rot_set_rotation(mctr1,
    (0.0)*DEG2RAD,
    (0.0)*DEG2RAD,
    (0.0)*DEG2RAD);
#line 147711 "MACS_sample_kidney_box.c"
  rot_mul(mctr1, mcrotakidney_channel_19, mcrotachannel_19_analyzer_1_center);
  rot_transpose(mcrotachannel_19_cave1_cyl1, mctr1);
  rot_mul(mcrotachannel_19_analyzer_1_center, mctr1, mcrotrchannel_19_analyzer_1_center);
  mctc1 = coords_set(
#line 4768 "MACS_sample_kidney_box.instr"
    0,
#line 4768 "MACS_sample_kidney_box.instr"
    0,
#line 4768 "MACS_sample_kidney_box.instr"
    analyzer_1_center_to_sample);
#line 147722 "MACS_sample_kidney_box.c"
  rot_transpose(mcrotakidney_channel_19, mctr1);
  mctc2 = rot_apply(mctr1, mctc1);
  mcposachannel_19_analyzer_1_center = coords_add(mcposakidney_channel_19, mctc2);
  mctc1 = coords_sub(mcposachannel_19_cave1_cyl1, mcposachannel_19_analyzer_1_center);
  mcposrchannel_19_analyzer_1_center = rot_apply(mcrotachannel_19_analyzer_1_center, mctc1);
  mcDEBUG_COMPONENT("channel_19_analyzer_1_center", mcposachannel_19_analyzer_1_center, mcrotachannel_19_analyzer_1_center)
  mccomp_posa[850] = mcposachannel_19_analyzer_1_center;
  mccomp_posr[850] = mcposrchannel_19_analyzer_1_center;
  mcNCounter[850]  = mcPCounter[850] = mcP2Counter[850] = 0;
  mcAbsorbProp[850]= 0;
    /* Component channel_19_analyzer_1_rotated. */
  /* Setting parameters for component channel_19_analyzer_1_rotated. */
  SIG_MESSAGE("channel_19_analyzer_1_rotated (Init:SetPar)");

  SIG_MESSAGE("channel_19_analyzer_1_rotated (Init:Place/Rotate)");
  rot_set_rotation(mctr1,
#line 4772 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 4772 "MACS_sample_kidney_box.instr"
    (180 - analyzer_theta [ 19 ])*DEG2RAD,
#line 4772 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD);
#line 147745 "MACS_sample_kidney_box.c"
  rot_mul(mctr1, mcrotachannel_19_analyzer_1_center, mcrotachannel_19_analyzer_1_rotated);
  rot_transpose(mcrotachannel_19_analyzer_1_center, mctr1);
  rot_mul(mcrotachannel_19_analyzer_1_rotated, mctr1, mcrotrchannel_19_analyzer_1_rotated);
  mctc1 = coords_set(
#line 4771 "MACS_sample_kidney_box.instr"
    0,
#line 4771 "MACS_sample_kidney_box.instr"
    0,
#line 4771 "MACS_sample_kidney_box.instr"
    -0.5 * analyzer_seperation / tan ( analyzer_2theta [ 19 ] * DEG2RAD ));
#line 147756 "MACS_sample_kidney_box.c"
  rot_transpose(mcrotachannel_19_analyzer_1_center, mctr1);
  mctc2 = rot_apply(mctr1, mctc1);
  mcposachannel_19_analyzer_1_rotated = coords_add(mcposachannel_19_analyzer_1_center, mctc2);
  mctc1 = coords_sub(mcposachannel_19_analyzer_1_center, mcposachannel_19_analyzer_1_rotated);
  mcposrchannel_19_analyzer_1_rotated = rot_apply(mcrotachannel_19_analyzer_1_rotated, mctc1);
  mcDEBUG_COMPONENT("channel_19_analyzer_1_rotated", mcposachannel_19_analyzer_1_rotated, mcrotachannel_19_analyzer_1_rotated)
  mccomp_posa[851] = mcposachannel_19_analyzer_1_rotated;
  mccomp_posr[851] = mcposrchannel_19_analyzer_1_rotated;
  mcNCounter[851]  = mcPCounter[851] = mcP2Counter[851] = 0;
  mcAbsorbProp[851]= 0;
    /* Component channel_19_analyzer_1_array_crystal_array_0. */
  /* Setting parameters for component channel_19_analyzer_1_array_crystal_array_0. */
  SIG_MESSAGE("channel_19_analyzer_1_array_crystal_array_0 (Init:SetPar)");
#line 4776 "MACS_sample_kidney_box.instr"
  if("PG_analyzer") strncpy(mccchannel_19_analyzer_1_array_crystal_array_0_material_string, "PG_analyzer" ? "PG_analyzer" : "", 16384); else mccchannel_19_analyzer_1_array_crystal_array_0_material_string[0]='\0';
#line 4776 "MACS_sample_kidney_box.instr"
  mccchannel_19_analyzer_1_array_crystal_array_0_priority = 2120.0;
#line 4775 "MACS_sample_kidney_box.instr"
  mccchannel_19_analyzer_1_array_crystal_array_0_xwidth = channel_19_analyzer_1_array_crystal_depth;
#line 4775 "MACS_sample_kidney_box.instr"
  mccchannel_19_analyzer_1_array_crystal_array_0_yheight = channel_19_analyzer_1_array_crystal_height;
#line 4775 "MACS_sample_kidney_box.instr"
  mccchannel_19_analyzer_1_array_crystal_array_0_zdepth = channel_19_analyzer_1_array_crystal_width;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_19_analyzer_1_array_crystal_array_0_xwidth2 = -1;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_19_analyzer_1_array_crystal_array_0_yheight2 = -1;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_19_analyzer_1_array_crystal_array_0_visualize = 1;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_19_analyzer_1_array_crystal_array_0_target_index = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_19_analyzer_1_array_crystal_array_0_target_x = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_19_analyzer_1_array_crystal_array_0_target_y = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_19_analyzer_1_array_crystal_array_0_target_z = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_19_analyzer_1_array_crystal_array_0_focus_aw = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_19_analyzer_1_array_crystal_array_0_focus_ah = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_19_analyzer_1_array_crystal_array_0_focus_xw = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_19_analyzer_1_array_crystal_array_0_focus_xh = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_19_analyzer_1_array_crystal_array_0_focus_r = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_19_analyzer_1_array_crystal_array_0_p_interact = 0;
#line 71 "MACS_sample_kidney_box.instr"
  if(0) strncpy(mccchannel_19_analyzer_1_array_crystal_array_0_mask_string, 0 ? 0 : "", 16384); else mccchannel_19_analyzer_1_array_crystal_array_0_mask_string[0]='\0';
#line 71 "MACS_sample_kidney_box.instr"
  if(0) strncpy(mccchannel_19_analyzer_1_array_crystal_array_0_mask_setting, 0 ? 0 : "", 16384); else mccchannel_19_analyzer_1_array_crystal_array_0_mask_setting[0]='\0';
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_19_analyzer_1_array_crystal_array_0_number_of_activations = 1;
#line 147812 "MACS_sample_kidney_box.c"

  SIG_MESSAGE("channel_19_analyzer_1_array_crystal_array_0 (Init:Place/Rotate)");
  rot_set_rotation(mctr1,
#line 4778 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 4778 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 4778 "MACS_sample_kidney_box.instr"
    (0 - RAD2DEG * channel_19_analyzer_1_array_theta [ 0 ])*DEG2RAD);
#line 147822 "MACS_sample_kidney_box.c"
  rot_mul(mctr1, mcrotachannel_19_analyzer_1_rotated, mcrotachannel_19_analyzer_1_array_crystal_array_0);
  rot_transpose(mcrotachannel_19_analyzer_1_rotated, mctr1);
  rot_mul(mcrotachannel_19_analyzer_1_array_crystal_array_0, mctr1, mcrotrchannel_19_analyzer_1_array_crystal_array_0);
  mctc1 = coords_set(
#line 4777 "MACS_sample_kidney_box.instr"
    0 + channel_19_analyzer_1_array_effective_radius_of_curvature * ( 1 - cos ( channel_19_analyzer_1_array_theta [ 0 ] ) ),
#line 4777 "MACS_sample_kidney_box.instr"
    0 + channel_19_analyzer_1_array_effective_radius_of_curvature * sin ( channel_19_analyzer_1_array_theta [ 0 ] ),
#line 4777 "MACS_sample_kidney_box.instr"
    0);
#line 147833 "MACS_sample_kidney_box.c"
  rot_transpose(mcrotachannel_19_analyzer_1_rotated, mctr1);
  mctc2 = rot_apply(mctr1, mctc1);
  mcposachannel_19_analyzer_1_array_crystal_array_0 = coords_add(mcposachannel_19_analyzer_1_rotated, mctc2);
  mctc1 = coords_sub(mcposachannel_19_analyzer_1_rotated, mcposachannel_19_analyzer_1_array_crystal_array_0);
  mcposrchannel_19_analyzer_1_array_crystal_array_0 = rot_apply(mcrotachannel_19_analyzer_1_array_crystal_array_0, mctc1);
  mcDEBUG_COMPONENT("channel_19_analyzer_1_array_crystal_array_0", mcposachannel_19_analyzer_1_array_crystal_array_0, mcrotachannel_19_analyzer_1_array_crystal_array_0)
  mccomp_posa[852] = mcposachannel_19_analyzer_1_array_crystal_array_0;
  mccomp_posr[852] = mcposrchannel_19_analyzer_1_array_crystal_array_0;
  mcNCounter[852]  = mcPCounter[852] = mcP2Counter[852] = 0;
  mcAbsorbProp[852]= 0;
    /* Component channel_19_analyzer_1_array_crystal_array_1. */
  /* Setting parameters for component channel_19_analyzer_1_array_crystal_array_1. */
  SIG_MESSAGE("channel_19_analyzer_1_array_crystal_array_1 (Init:SetPar)");
#line 4782 "MACS_sample_kidney_box.instr"
  if("PG_analyzer") strncpy(mccchannel_19_analyzer_1_array_crystal_array_1_material_string, "PG_analyzer" ? "PG_analyzer" : "", 16384); else mccchannel_19_analyzer_1_array_crystal_array_1_material_string[0]='\0';
#line 4782 "MACS_sample_kidney_box.instr"
  mccchannel_19_analyzer_1_array_crystal_array_1_priority = 2120.1;
#line 4781 "MACS_sample_kidney_box.instr"
  mccchannel_19_analyzer_1_array_crystal_array_1_xwidth = channel_19_analyzer_1_array_crystal_depth;
#line 4781 "MACS_sample_kidney_box.instr"
  mccchannel_19_analyzer_1_array_crystal_array_1_yheight = channel_19_analyzer_1_array_crystal_height;
#line 4781 "MACS_sample_kidney_box.instr"
  mccchannel_19_analyzer_1_array_crystal_array_1_zdepth = channel_19_analyzer_1_array_crystal_width;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_19_analyzer_1_array_crystal_array_1_xwidth2 = -1;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_19_analyzer_1_array_crystal_array_1_yheight2 = -1;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_19_analyzer_1_array_crystal_array_1_visualize = 1;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_19_analyzer_1_array_crystal_array_1_target_index = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_19_analyzer_1_array_crystal_array_1_target_x = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_19_analyzer_1_array_crystal_array_1_target_y = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_19_analyzer_1_array_crystal_array_1_target_z = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_19_analyzer_1_array_crystal_array_1_focus_aw = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_19_analyzer_1_array_crystal_array_1_focus_ah = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_19_analyzer_1_array_crystal_array_1_focus_xw = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_19_analyzer_1_array_crystal_array_1_focus_xh = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_19_analyzer_1_array_crystal_array_1_focus_r = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_19_analyzer_1_array_crystal_array_1_p_interact = 0;
#line 71 "MACS_sample_kidney_box.instr"
  if(0) strncpy(mccchannel_19_analyzer_1_array_crystal_array_1_mask_string, 0 ? 0 : "", 16384); else mccchannel_19_analyzer_1_array_crystal_array_1_mask_string[0]='\0';
#line 71 "MACS_sample_kidney_box.instr"
  if(0) strncpy(mccchannel_19_analyzer_1_array_crystal_array_1_mask_setting, 0 ? 0 : "", 16384); else mccchannel_19_analyzer_1_array_crystal_array_1_mask_setting[0]='\0';
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_19_analyzer_1_array_crystal_array_1_number_of_activations = 1;
#line 147889 "MACS_sample_kidney_box.c"

  SIG_MESSAGE("channel_19_analyzer_1_array_crystal_array_1 (Init:Place/Rotate)");
  rot_set_rotation(mctr1,
#line 4784 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 4784 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 4784 "MACS_sample_kidney_box.instr"
    (0 - RAD2DEG * channel_19_analyzer_1_array_theta [ 1 ])*DEG2RAD);
#line 147899 "MACS_sample_kidney_box.c"
  rot_mul(mctr1, mcrotachannel_19_analyzer_1_rotated, mcrotachannel_19_analyzer_1_array_crystal_array_1);
  rot_transpose(mcrotachannel_19_analyzer_1_array_crystal_array_0, mctr1);
  rot_mul(mcrotachannel_19_analyzer_1_array_crystal_array_1, mctr1, mcrotrchannel_19_analyzer_1_array_crystal_array_1);
  mctc1 = coords_set(
#line 4783 "MACS_sample_kidney_box.instr"
    0 + channel_19_analyzer_1_array_effective_radius_of_curvature * ( 1 - cos ( channel_19_analyzer_1_array_theta [ 1 ] ) ),
#line 4783 "MACS_sample_kidney_box.instr"
    0 + channel_19_analyzer_1_array_effective_radius_of_curvature * sin ( channel_19_analyzer_1_array_theta [ 1 ] ),
#line 4783 "MACS_sample_kidney_box.instr"
    0);
#line 147910 "MACS_sample_kidney_box.c"
  rot_transpose(mcrotachannel_19_analyzer_1_rotated, mctr1);
  mctc2 = rot_apply(mctr1, mctc1);
  mcposachannel_19_analyzer_1_array_crystal_array_1 = coords_add(mcposachannel_19_analyzer_1_rotated, mctc2);
  mctc1 = coords_sub(mcposachannel_19_analyzer_1_array_crystal_array_0, mcposachannel_19_analyzer_1_array_crystal_array_1);
  mcposrchannel_19_analyzer_1_array_crystal_array_1 = rot_apply(mcrotachannel_19_analyzer_1_array_crystal_array_1, mctc1);
  mcDEBUG_COMPONENT("channel_19_analyzer_1_array_crystal_array_1", mcposachannel_19_analyzer_1_array_crystal_array_1, mcrotachannel_19_analyzer_1_array_crystal_array_1)
  mccomp_posa[853] = mcposachannel_19_analyzer_1_array_crystal_array_1;
  mccomp_posr[853] = mcposrchannel_19_analyzer_1_array_crystal_array_1;
  mcNCounter[853]  = mcPCounter[853] = mcP2Counter[853] = 0;
  mcAbsorbProp[853]= 0;
    /* Component channel_19_analyzer_1_array_crystal_array_2. */
  /* Setting parameters for component channel_19_analyzer_1_array_crystal_array_2. */
  SIG_MESSAGE("channel_19_analyzer_1_array_crystal_array_2 (Init:SetPar)");
#line 4788 "MACS_sample_kidney_box.instr"
  if("PG_analyzer") strncpy(mccchannel_19_analyzer_1_array_crystal_array_2_material_string, "PG_analyzer" ? "PG_analyzer" : "", 16384); else mccchannel_19_analyzer_1_array_crystal_array_2_material_string[0]='\0';
#line 4788 "MACS_sample_kidney_box.instr"
  mccchannel_19_analyzer_1_array_crystal_array_2_priority = 2120.2;
#line 4787 "MACS_sample_kidney_box.instr"
  mccchannel_19_analyzer_1_array_crystal_array_2_xwidth = channel_19_analyzer_1_array_crystal_depth;
#line 4787 "MACS_sample_kidney_box.instr"
  mccchannel_19_analyzer_1_array_crystal_array_2_yheight = channel_19_analyzer_1_array_crystal_height;
#line 4787 "MACS_sample_kidney_box.instr"
  mccchannel_19_analyzer_1_array_crystal_array_2_zdepth = channel_19_analyzer_1_array_crystal_width;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_19_analyzer_1_array_crystal_array_2_xwidth2 = -1;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_19_analyzer_1_array_crystal_array_2_yheight2 = -1;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_19_analyzer_1_array_crystal_array_2_visualize = 1;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_19_analyzer_1_array_crystal_array_2_target_index = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_19_analyzer_1_array_crystal_array_2_target_x = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_19_analyzer_1_array_crystal_array_2_target_y = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_19_analyzer_1_array_crystal_array_2_target_z = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_19_analyzer_1_array_crystal_array_2_focus_aw = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_19_analyzer_1_array_crystal_array_2_focus_ah = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_19_analyzer_1_array_crystal_array_2_focus_xw = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_19_analyzer_1_array_crystal_array_2_focus_xh = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_19_analyzer_1_array_crystal_array_2_focus_r = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_19_analyzer_1_array_crystal_array_2_p_interact = 0;
#line 71 "MACS_sample_kidney_box.instr"
  if(0) strncpy(mccchannel_19_analyzer_1_array_crystal_array_2_mask_string, 0 ? 0 : "", 16384); else mccchannel_19_analyzer_1_array_crystal_array_2_mask_string[0]='\0';
#line 71 "MACS_sample_kidney_box.instr"
  if(0) strncpy(mccchannel_19_analyzer_1_array_crystal_array_2_mask_setting, 0 ? 0 : "", 16384); else mccchannel_19_analyzer_1_array_crystal_array_2_mask_setting[0]='\0';
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_19_analyzer_1_array_crystal_array_2_number_of_activations = 1;
#line 147966 "MACS_sample_kidney_box.c"

  SIG_MESSAGE("channel_19_analyzer_1_array_crystal_array_2 (Init:Place/Rotate)");
  rot_set_rotation(mctr1,
#line 4790 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 4790 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 4790 "MACS_sample_kidney_box.instr"
    (0 - RAD2DEG * channel_19_analyzer_1_array_theta [ 2 ])*DEG2RAD);
#line 147976 "MACS_sample_kidney_box.c"
  rot_mul(mctr1, mcrotachannel_19_analyzer_1_rotated, mcrotachannel_19_analyzer_1_array_crystal_array_2);
  rot_transpose(mcrotachannel_19_analyzer_1_array_crystal_array_1, mctr1);
  rot_mul(mcrotachannel_19_analyzer_1_array_crystal_array_2, mctr1, mcrotrchannel_19_analyzer_1_array_crystal_array_2);
  mctc1 = coords_set(
#line 4789 "MACS_sample_kidney_box.instr"
    0 + channel_19_analyzer_1_array_effective_radius_of_curvature * ( 1 - cos ( channel_19_analyzer_1_array_theta [ 2 ] ) ),
#line 4789 "MACS_sample_kidney_box.instr"
    0 + channel_19_analyzer_1_array_effective_radius_of_curvature * sin ( channel_19_analyzer_1_array_theta [ 2 ] ),
#line 4789 "MACS_sample_kidney_box.instr"
    0);
#line 147987 "MACS_sample_kidney_box.c"
  rot_transpose(mcrotachannel_19_analyzer_1_rotated, mctr1);
  mctc2 = rot_apply(mctr1, mctc1);
  mcposachannel_19_analyzer_1_array_crystal_array_2 = coords_add(mcposachannel_19_analyzer_1_rotated, mctc2);
  mctc1 = coords_sub(mcposachannel_19_analyzer_1_array_crystal_array_1, mcposachannel_19_analyzer_1_array_crystal_array_2);
  mcposrchannel_19_analyzer_1_array_crystal_array_2 = rot_apply(mcrotachannel_19_analyzer_1_array_crystal_array_2, mctc1);
  mcDEBUG_COMPONENT("channel_19_analyzer_1_array_crystal_array_2", mcposachannel_19_analyzer_1_array_crystal_array_2, mcrotachannel_19_analyzer_1_array_crystal_array_2)
  mccomp_posa[854] = mcposachannel_19_analyzer_1_array_crystal_array_2;
  mccomp_posr[854] = mcposrchannel_19_analyzer_1_array_crystal_array_2;
  mcNCounter[854]  = mcPCounter[854] = mcP2Counter[854] = 0;
  mcAbsorbProp[854]= 0;
    /* Component channel_19_analyzer_1_array_crystal_array_3. */
  /* Setting parameters for component channel_19_analyzer_1_array_crystal_array_3. */
  SIG_MESSAGE("channel_19_analyzer_1_array_crystal_array_3 (Init:SetPar)");
#line 4794 "MACS_sample_kidney_box.instr"
  if("PG_analyzer") strncpy(mccchannel_19_analyzer_1_array_crystal_array_3_material_string, "PG_analyzer" ? "PG_analyzer" : "", 16384); else mccchannel_19_analyzer_1_array_crystal_array_3_material_string[0]='\0';
#line 4794 "MACS_sample_kidney_box.instr"
  mccchannel_19_analyzer_1_array_crystal_array_3_priority = 2120.3;
#line 4793 "MACS_sample_kidney_box.instr"
  mccchannel_19_analyzer_1_array_crystal_array_3_xwidth = channel_19_analyzer_1_array_crystal_depth;
#line 4793 "MACS_sample_kidney_box.instr"
  mccchannel_19_analyzer_1_array_crystal_array_3_yheight = channel_19_analyzer_1_array_crystal_height;
#line 4793 "MACS_sample_kidney_box.instr"
  mccchannel_19_analyzer_1_array_crystal_array_3_zdepth = channel_19_analyzer_1_array_crystal_width;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_19_analyzer_1_array_crystal_array_3_xwidth2 = -1;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_19_analyzer_1_array_crystal_array_3_yheight2 = -1;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_19_analyzer_1_array_crystal_array_3_visualize = 1;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_19_analyzer_1_array_crystal_array_3_target_index = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_19_analyzer_1_array_crystal_array_3_target_x = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_19_analyzer_1_array_crystal_array_3_target_y = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_19_analyzer_1_array_crystal_array_3_target_z = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_19_analyzer_1_array_crystal_array_3_focus_aw = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_19_analyzer_1_array_crystal_array_3_focus_ah = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_19_analyzer_1_array_crystal_array_3_focus_xw = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_19_analyzer_1_array_crystal_array_3_focus_xh = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_19_analyzer_1_array_crystal_array_3_focus_r = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_19_analyzer_1_array_crystal_array_3_p_interact = 0;
#line 71 "MACS_sample_kidney_box.instr"
  if(0) strncpy(mccchannel_19_analyzer_1_array_crystal_array_3_mask_string, 0 ? 0 : "", 16384); else mccchannel_19_analyzer_1_array_crystal_array_3_mask_string[0]='\0';
#line 71 "MACS_sample_kidney_box.instr"
  if(0) strncpy(mccchannel_19_analyzer_1_array_crystal_array_3_mask_setting, 0 ? 0 : "", 16384); else mccchannel_19_analyzer_1_array_crystal_array_3_mask_setting[0]='\0';
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_19_analyzer_1_array_crystal_array_3_number_of_activations = 1;
#line 148043 "MACS_sample_kidney_box.c"

  SIG_MESSAGE("channel_19_analyzer_1_array_crystal_array_3 (Init:Place/Rotate)");
  rot_set_rotation(mctr1,
#line 4796 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 4796 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 4796 "MACS_sample_kidney_box.instr"
    (0 - RAD2DEG * channel_19_analyzer_1_array_theta [ 3 ])*DEG2RAD);
#line 148053 "MACS_sample_kidney_box.c"
  rot_mul(mctr1, mcrotachannel_19_analyzer_1_rotated, mcrotachannel_19_analyzer_1_array_crystal_array_3);
  rot_transpose(mcrotachannel_19_analyzer_1_array_crystal_array_2, mctr1);
  rot_mul(mcrotachannel_19_analyzer_1_array_crystal_array_3, mctr1, mcrotrchannel_19_analyzer_1_array_crystal_array_3);
  mctc1 = coords_set(
#line 4795 "MACS_sample_kidney_box.instr"
    0 + channel_19_analyzer_1_array_effective_radius_of_curvature * ( 1 - cos ( channel_19_analyzer_1_array_theta [ 3 ] ) ),
#line 4795 "MACS_sample_kidney_box.instr"
    0 + channel_19_analyzer_1_array_effective_radius_of_curvature * sin ( channel_19_analyzer_1_array_theta [ 3 ] ),
#line 4795 "MACS_sample_kidney_box.instr"
    0);
#line 148064 "MACS_sample_kidney_box.c"
  rot_transpose(mcrotachannel_19_analyzer_1_rotated, mctr1);
  mctc2 = rot_apply(mctr1, mctc1);
  mcposachannel_19_analyzer_1_array_crystal_array_3 = coords_add(mcposachannel_19_analyzer_1_rotated, mctc2);
  mctc1 = coords_sub(mcposachannel_19_analyzer_1_array_crystal_array_2, mcposachannel_19_analyzer_1_array_crystal_array_3);
  mcposrchannel_19_analyzer_1_array_crystal_array_3 = rot_apply(mcrotachannel_19_analyzer_1_array_crystal_array_3, mctc1);
  mcDEBUG_COMPONENT("channel_19_analyzer_1_array_crystal_array_3", mcposachannel_19_analyzer_1_array_crystal_array_3, mcrotachannel_19_analyzer_1_array_crystal_array_3)
  mccomp_posa[855] = mcposachannel_19_analyzer_1_array_crystal_array_3;
  mccomp_posr[855] = mcposrchannel_19_analyzer_1_array_crystal_array_3;
  mcNCounter[855]  = mcPCounter[855] = mcP2Counter[855] = 0;
  mcAbsorbProp[855]= 0;
    /* Component channel_19_analyzer_1_array_crystal_array_4. */
  /* Setting parameters for component channel_19_analyzer_1_array_crystal_array_4. */
  SIG_MESSAGE("channel_19_analyzer_1_array_crystal_array_4 (Init:SetPar)");
#line 4800 "MACS_sample_kidney_box.instr"
  if("PG_analyzer") strncpy(mccchannel_19_analyzer_1_array_crystal_array_4_material_string, "PG_analyzer" ? "PG_analyzer" : "", 16384); else mccchannel_19_analyzer_1_array_crystal_array_4_material_string[0]='\0';
#line 4800 "MACS_sample_kidney_box.instr"
  mccchannel_19_analyzer_1_array_crystal_array_4_priority = 2120.4;
#line 4799 "MACS_sample_kidney_box.instr"
  mccchannel_19_analyzer_1_array_crystal_array_4_xwidth = channel_19_analyzer_1_array_crystal_depth;
#line 4799 "MACS_sample_kidney_box.instr"
  mccchannel_19_analyzer_1_array_crystal_array_4_yheight = channel_19_analyzer_1_array_crystal_height;
#line 4799 "MACS_sample_kidney_box.instr"
  mccchannel_19_analyzer_1_array_crystal_array_4_zdepth = channel_19_analyzer_1_array_crystal_width;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_19_analyzer_1_array_crystal_array_4_xwidth2 = -1;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_19_analyzer_1_array_crystal_array_4_yheight2 = -1;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_19_analyzer_1_array_crystal_array_4_visualize = 1;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_19_analyzer_1_array_crystal_array_4_target_index = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_19_analyzer_1_array_crystal_array_4_target_x = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_19_analyzer_1_array_crystal_array_4_target_y = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_19_analyzer_1_array_crystal_array_4_target_z = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_19_analyzer_1_array_crystal_array_4_focus_aw = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_19_analyzer_1_array_crystal_array_4_focus_ah = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_19_analyzer_1_array_crystal_array_4_focus_xw = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_19_analyzer_1_array_crystal_array_4_focus_xh = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_19_analyzer_1_array_crystal_array_4_focus_r = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_19_analyzer_1_array_crystal_array_4_p_interact = 0;
#line 71 "MACS_sample_kidney_box.instr"
  if(0) strncpy(mccchannel_19_analyzer_1_array_crystal_array_4_mask_string, 0 ? 0 : "", 16384); else mccchannel_19_analyzer_1_array_crystal_array_4_mask_string[0]='\0';
#line 71 "MACS_sample_kidney_box.instr"
  if(0) strncpy(mccchannel_19_analyzer_1_array_crystal_array_4_mask_setting, 0 ? 0 : "", 16384); else mccchannel_19_analyzer_1_array_crystal_array_4_mask_setting[0]='\0';
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_19_analyzer_1_array_crystal_array_4_number_of_activations = 1;
#line 148120 "MACS_sample_kidney_box.c"

  SIG_MESSAGE("channel_19_analyzer_1_array_crystal_array_4 (Init:Place/Rotate)");
  rot_set_rotation(mctr1,
#line 4802 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 4802 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 4802 "MACS_sample_kidney_box.instr"
    (0 - RAD2DEG * channel_19_analyzer_1_array_theta [ 4 ])*DEG2RAD);
#line 148130 "MACS_sample_kidney_box.c"
  rot_mul(mctr1, mcrotachannel_19_analyzer_1_rotated, mcrotachannel_19_analyzer_1_array_crystal_array_4);
  rot_transpose(mcrotachannel_19_analyzer_1_array_crystal_array_3, mctr1);
  rot_mul(mcrotachannel_19_analyzer_1_array_crystal_array_4, mctr1, mcrotrchannel_19_analyzer_1_array_crystal_array_4);
  mctc1 = coords_set(
#line 4801 "MACS_sample_kidney_box.instr"
    0 + channel_19_analyzer_1_array_effective_radius_of_curvature * ( 1 - cos ( channel_19_analyzer_1_array_theta [ 4 ] ) ),
#line 4801 "MACS_sample_kidney_box.instr"
    0 + channel_19_analyzer_1_array_effective_radius_of_curvature * sin ( channel_19_analyzer_1_array_theta [ 4 ] ),
#line 4801 "MACS_sample_kidney_box.instr"
    0);
#line 148141 "MACS_sample_kidney_box.c"
  rot_transpose(mcrotachannel_19_analyzer_1_rotated, mctr1);
  mctc2 = rot_apply(mctr1, mctc1);
  mcposachannel_19_analyzer_1_array_crystal_array_4 = coords_add(mcposachannel_19_analyzer_1_rotated, mctc2);
  mctc1 = coords_sub(mcposachannel_19_analyzer_1_array_crystal_array_3, mcposachannel_19_analyzer_1_array_crystal_array_4);
  mcposrchannel_19_analyzer_1_array_crystal_array_4 = rot_apply(mcrotachannel_19_analyzer_1_array_crystal_array_4, mctc1);
  mcDEBUG_COMPONENT("channel_19_analyzer_1_array_crystal_array_4", mcposachannel_19_analyzer_1_array_crystal_array_4, mcrotachannel_19_analyzer_1_array_crystal_array_4)
  mccomp_posa[856] = mcposachannel_19_analyzer_1_array_crystal_array_4;
  mccomp_posr[856] = mcposrchannel_19_analyzer_1_array_crystal_array_4;
  mcNCounter[856]  = mcPCounter[856] = mcP2Counter[856] = 0;
  mcAbsorbProp[856]= 0;
    /* Component channel_19_analyzer_1_array_crystal_array_5. */
  /* Setting parameters for component channel_19_analyzer_1_array_crystal_array_5. */
  SIG_MESSAGE("channel_19_analyzer_1_array_crystal_array_5 (Init:SetPar)");
#line 4806 "MACS_sample_kidney_box.instr"
  if("PG_analyzer") strncpy(mccchannel_19_analyzer_1_array_crystal_array_5_material_string, "PG_analyzer" ? "PG_analyzer" : "", 16384); else mccchannel_19_analyzer_1_array_crystal_array_5_material_string[0]='\0';
#line 4806 "MACS_sample_kidney_box.instr"
  mccchannel_19_analyzer_1_array_crystal_array_5_priority = 2120.5;
#line 4805 "MACS_sample_kidney_box.instr"
  mccchannel_19_analyzer_1_array_crystal_array_5_xwidth = channel_19_analyzer_1_array_crystal_depth;
#line 4805 "MACS_sample_kidney_box.instr"
  mccchannel_19_analyzer_1_array_crystal_array_5_yheight = channel_19_analyzer_1_array_crystal_height;
#line 4805 "MACS_sample_kidney_box.instr"
  mccchannel_19_analyzer_1_array_crystal_array_5_zdepth = channel_19_analyzer_1_array_crystal_width;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_19_analyzer_1_array_crystal_array_5_xwidth2 = -1;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_19_analyzer_1_array_crystal_array_5_yheight2 = -1;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_19_analyzer_1_array_crystal_array_5_visualize = 1;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_19_analyzer_1_array_crystal_array_5_target_index = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_19_analyzer_1_array_crystal_array_5_target_x = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_19_analyzer_1_array_crystal_array_5_target_y = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_19_analyzer_1_array_crystal_array_5_target_z = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_19_analyzer_1_array_crystal_array_5_focus_aw = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_19_analyzer_1_array_crystal_array_5_focus_ah = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_19_analyzer_1_array_crystal_array_5_focus_xw = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_19_analyzer_1_array_crystal_array_5_focus_xh = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_19_analyzer_1_array_crystal_array_5_focus_r = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_19_analyzer_1_array_crystal_array_5_p_interact = 0;
#line 71 "MACS_sample_kidney_box.instr"
  if(0) strncpy(mccchannel_19_analyzer_1_array_crystal_array_5_mask_string, 0 ? 0 : "", 16384); else mccchannel_19_analyzer_1_array_crystal_array_5_mask_string[0]='\0';
#line 71 "MACS_sample_kidney_box.instr"
  if(0) strncpy(mccchannel_19_analyzer_1_array_crystal_array_5_mask_setting, 0 ? 0 : "", 16384); else mccchannel_19_analyzer_1_array_crystal_array_5_mask_setting[0]='\0';
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_19_analyzer_1_array_crystal_array_5_number_of_activations = 1;
#line 148197 "MACS_sample_kidney_box.c"

  SIG_MESSAGE("channel_19_analyzer_1_array_crystal_array_5 (Init:Place/Rotate)");
  rot_set_rotation(mctr1,
#line 4808 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 4808 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 4808 "MACS_sample_kidney_box.instr"
    (0 - RAD2DEG * channel_19_analyzer_1_array_theta [ 5 ])*DEG2RAD);
#line 148207 "MACS_sample_kidney_box.c"
  rot_mul(mctr1, mcrotachannel_19_analyzer_1_rotated, mcrotachannel_19_analyzer_1_array_crystal_array_5);
  rot_transpose(mcrotachannel_19_analyzer_1_array_crystal_array_4, mctr1);
  rot_mul(mcrotachannel_19_analyzer_1_array_crystal_array_5, mctr1, mcrotrchannel_19_analyzer_1_array_crystal_array_5);
  mctc1 = coords_set(
#line 4807 "MACS_sample_kidney_box.instr"
    0 + channel_19_analyzer_1_array_effective_radius_of_curvature * ( 1 - cos ( channel_19_analyzer_1_array_theta [ 5 ] ) ),
#line 4807 "MACS_sample_kidney_box.instr"
    0 + channel_19_analyzer_1_array_effective_radius_of_curvature * sin ( channel_19_analyzer_1_array_theta [ 5 ] ),
#line 4807 "MACS_sample_kidney_box.instr"
    0);
#line 148218 "MACS_sample_kidney_box.c"
  rot_transpose(mcrotachannel_19_analyzer_1_rotated, mctr1);
  mctc2 = rot_apply(mctr1, mctc1);
  mcposachannel_19_analyzer_1_array_crystal_array_5 = coords_add(mcposachannel_19_analyzer_1_rotated, mctc2);
  mctc1 = coords_sub(mcposachannel_19_analyzer_1_array_crystal_array_4, mcposachannel_19_analyzer_1_array_crystal_array_5);
  mcposrchannel_19_analyzer_1_array_crystal_array_5 = rot_apply(mcrotachannel_19_analyzer_1_array_crystal_array_5, mctc1);
  mcDEBUG_COMPONENT("channel_19_analyzer_1_array_crystal_array_5", mcposachannel_19_analyzer_1_array_crystal_array_5, mcrotachannel_19_analyzer_1_array_crystal_array_5)
  mccomp_posa[857] = mcposachannel_19_analyzer_1_array_crystal_array_5;
  mccomp_posr[857] = mcposrchannel_19_analyzer_1_array_crystal_array_5;
  mcNCounter[857]  = mcPCounter[857] = mcP2Counter[857] = 0;
  mcAbsorbProp[857]= 0;
    /* Component channel_19_analyzer_1_array_crystal_array_6. */
  /* Setting parameters for component channel_19_analyzer_1_array_crystal_array_6. */
  SIG_MESSAGE("channel_19_analyzer_1_array_crystal_array_6 (Init:SetPar)");
#line 4812 "MACS_sample_kidney_box.instr"
  if("PG_analyzer") strncpy(mccchannel_19_analyzer_1_array_crystal_array_6_material_string, "PG_analyzer" ? "PG_analyzer" : "", 16384); else mccchannel_19_analyzer_1_array_crystal_array_6_material_string[0]='\0';
#line 4812 "MACS_sample_kidney_box.instr"
  mccchannel_19_analyzer_1_array_crystal_array_6_priority = 2120.6;
#line 4811 "MACS_sample_kidney_box.instr"
  mccchannel_19_analyzer_1_array_crystal_array_6_xwidth = channel_19_analyzer_1_array_crystal_depth;
#line 4811 "MACS_sample_kidney_box.instr"
  mccchannel_19_analyzer_1_array_crystal_array_6_yheight = channel_19_analyzer_1_array_crystal_height;
#line 4811 "MACS_sample_kidney_box.instr"
  mccchannel_19_analyzer_1_array_crystal_array_6_zdepth = channel_19_analyzer_1_array_crystal_width;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_19_analyzer_1_array_crystal_array_6_xwidth2 = -1;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_19_analyzer_1_array_crystal_array_6_yheight2 = -1;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_19_analyzer_1_array_crystal_array_6_visualize = 1;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_19_analyzer_1_array_crystal_array_6_target_index = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_19_analyzer_1_array_crystal_array_6_target_x = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_19_analyzer_1_array_crystal_array_6_target_y = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_19_analyzer_1_array_crystal_array_6_target_z = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_19_analyzer_1_array_crystal_array_6_focus_aw = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_19_analyzer_1_array_crystal_array_6_focus_ah = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_19_analyzer_1_array_crystal_array_6_focus_xw = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_19_analyzer_1_array_crystal_array_6_focus_xh = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_19_analyzer_1_array_crystal_array_6_focus_r = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_19_analyzer_1_array_crystal_array_6_p_interact = 0;
#line 71 "MACS_sample_kidney_box.instr"
  if(0) strncpy(mccchannel_19_analyzer_1_array_crystal_array_6_mask_string, 0 ? 0 : "", 16384); else mccchannel_19_analyzer_1_array_crystal_array_6_mask_string[0]='\0';
#line 71 "MACS_sample_kidney_box.instr"
  if(0) strncpy(mccchannel_19_analyzer_1_array_crystal_array_6_mask_setting, 0 ? 0 : "", 16384); else mccchannel_19_analyzer_1_array_crystal_array_6_mask_setting[0]='\0';
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_19_analyzer_1_array_crystal_array_6_number_of_activations = 1;
#line 148274 "MACS_sample_kidney_box.c"

  SIG_MESSAGE("channel_19_analyzer_1_array_crystal_array_6 (Init:Place/Rotate)");
  rot_set_rotation(mctr1,
#line 4814 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 4814 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 4814 "MACS_sample_kidney_box.instr"
    (0 - RAD2DEG * channel_19_analyzer_1_array_theta [ 6 ])*DEG2RAD);
#line 148284 "MACS_sample_kidney_box.c"
  rot_mul(mctr1, mcrotachannel_19_analyzer_1_rotated, mcrotachannel_19_analyzer_1_array_crystal_array_6);
  rot_transpose(mcrotachannel_19_analyzer_1_array_crystal_array_5, mctr1);
  rot_mul(mcrotachannel_19_analyzer_1_array_crystal_array_6, mctr1, mcrotrchannel_19_analyzer_1_array_crystal_array_6);
  mctc1 = coords_set(
#line 4813 "MACS_sample_kidney_box.instr"
    0 + channel_19_analyzer_1_array_effective_radius_of_curvature * ( 1 - cos ( channel_19_analyzer_1_array_theta [ 6 ] ) ),
#line 4813 "MACS_sample_kidney_box.instr"
    0 + channel_19_analyzer_1_array_effective_radius_of_curvature * sin ( channel_19_analyzer_1_array_theta [ 6 ] ),
#line 4813 "MACS_sample_kidney_box.instr"
    0);
#line 148295 "MACS_sample_kidney_box.c"
  rot_transpose(mcrotachannel_19_analyzer_1_rotated, mctr1);
  mctc2 = rot_apply(mctr1, mctc1);
  mcposachannel_19_analyzer_1_array_crystal_array_6 = coords_add(mcposachannel_19_analyzer_1_rotated, mctc2);
  mctc1 = coords_sub(mcposachannel_19_analyzer_1_array_crystal_array_5, mcposachannel_19_analyzer_1_array_crystal_array_6);
  mcposrchannel_19_analyzer_1_array_crystal_array_6 = rot_apply(mcrotachannel_19_analyzer_1_array_crystal_array_6, mctc1);
  mcDEBUG_COMPONENT("channel_19_analyzer_1_array_crystal_array_6", mcposachannel_19_analyzer_1_array_crystal_array_6, mcrotachannel_19_analyzer_1_array_crystal_array_6)
  mccomp_posa[858] = mcposachannel_19_analyzer_1_array_crystal_array_6;
  mccomp_posr[858] = mcposrchannel_19_analyzer_1_array_crystal_array_6;
  mcNCounter[858]  = mcPCounter[858] = mcP2Counter[858] = 0;
  mcAbsorbProp[858]= 0;
    /* Component channel_19_analyzer_1_array_crystal_array_7. */
  /* Setting parameters for component channel_19_analyzer_1_array_crystal_array_7. */
  SIG_MESSAGE("channel_19_analyzer_1_array_crystal_array_7 (Init:SetPar)");
#line 4818 "MACS_sample_kidney_box.instr"
  if("PG_analyzer") strncpy(mccchannel_19_analyzer_1_array_crystal_array_7_material_string, "PG_analyzer" ? "PG_analyzer" : "", 16384); else mccchannel_19_analyzer_1_array_crystal_array_7_material_string[0]='\0';
#line 4818 "MACS_sample_kidney_box.instr"
  mccchannel_19_analyzer_1_array_crystal_array_7_priority = 2120.7;
#line 4817 "MACS_sample_kidney_box.instr"
  mccchannel_19_analyzer_1_array_crystal_array_7_xwidth = channel_19_analyzer_1_array_crystal_depth;
#line 4817 "MACS_sample_kidney_box.instr"
  mccchannel_19_analyzer_1_array_crystal_array_7_yheight = channel_19_analyzer_1_array_crystal_height;
#line 4817 "MACS_sample_kidney_box.instr"
  mccchannel_19_analyzer_1_array_crystal_array_7_zdepth = channel_19_analyzer_1_array_crystal_width;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_19_analyzer_1_array_crystal_array_7_xwidth2 = -1;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_19_analyzer_1_array_crystal_array_7_yheight2 = -1;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_19_analyzer_1_array_crystal_array_7_visualize = 1;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_19_analyzer_1_array_crystal_array_7_target_index = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_19_analyzer_1_array_crystal_array_7_target_x = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_19_analyzer_1_array_crystal_array_7_target_y = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_19_analyzer_1_array_crystal_array_7_target_z = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_19_analyzer_1_array_crystal_array_7_focus_aw = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_19_analyzer_1_array_crystal_array_7_focus_ah = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_19_analyzer_1_array_crystal_array_7_focus_xw = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_19_analyzer_1_array_crystal_array_7_focus_xh = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_19_analyzer_1_array_crystal_array_7_focus_r = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_19_analyzer_1_array_crystal_array_7_p_interact = 0;
#line 71 "MACS_sample_kidney_box.instr"
  if(0) strncpy(mccchannel_19_analyzer_1_array_crystal_array_7_mask_string, 0 ? 0 : "", 16384); else mccchannel_19_analyzer_1_array_crystal_array_7_mask_string[0]='\0';
#line 71 "MACS_sample_kidney_box.instr"
  if(0) strncpy(mccchannel_19_analyzer_1_array_crystal_array_7_mask_setting, 0 ? 0 : "", 16384); else mccchannel_19_analyzer_1_array_crystal_array_7_mask_setting[0]='\0';
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_19_analyzer_1_array_crystal_array_7_number_of_activations = 1;
#line 148351 "MACS_sample_kidney_box.c"

  SIG_MESSAGE("channel_19_analyzer_1_array_crystal_array_7 (Init:Place/Rotate)");
  rot_set_rotation(mctr1,
#line 4820 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 4820 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 4820 "MACS_sample_kidney_box.instr"
    (0 - RAD2DEG * channel_19_analyzer_1_array_theta [ 7 ])*DEG2RAD);
#line 148361 "MACS_sample_kidney_box.c"
  rot_mul(mctr1, mcrotachannel_19_analyzer_1_rotated, mcrotachannel_19_analyzer_1_array_crystal_array_7);
  rot_transpose(mcrotachannel_19_analyzer_1_array_crystal_array_6, mctr1);
  rot_mul(mcrotachannel_19_analyzer_1_array_crystal_array_7, mctr1, mcrotrchannel_19_analyzer_1_array_crystal_array_7);
  mctc1 = coords_set(
#line 4819 "MACS_sample_kidney_box.instr"
    0 + channel_19_analyzer_1_array_effective_radius_of_curvature * ( 1 - cos ( channel_19_analyzer_1_array_theta [ 7 ] ) ),
#line 4819 "MACS_sample_kidney_box.instr"
    0 + channel_19_analyzer_1_array_effective_radius_of_curvature * sin ( channel_19_analyzer_1_array_theta [ 7 ] ),
#line 4819 "MACS_sample_kidney_box.instr"
    0);
#line 148372 "MACS_sample_kidney_box.c"
  rot_transpose(mcrotachannel_19_analyzer_1_rotated, mctr1);
  mctc2 = rot_apply(mctr1, mctc1);
  mcposachannel_19_analyzer_1_array_crystal_array_7 = coords_add(mcposachannel_19_analyzer_1_rotated, mctc2);
  mctc1 = coords_sub(mcposachannel_19_analyzer_1_array_crystal_array_6, mcposachannel_19_analyzer_1_array_crystal_array_7);
  mcposrchannel_19_analyzer_1_array_crystal_array_7 = rot_apply(mcrotachannel_19_analyzer_1_array_crystal_array_7, mctc1);
  mcDEBUG_COMPONENT("channel_19_analyzer_1_array_crystal_array_7", mcposachannel_19_analyzer_1_array_crystal_array_7, mcrotachannel_19_analyzer_1_array_crystal_array_7)
  mccomp_posa[859] = mcposachannel_19_analyzer_1_array_crystal_array_7;
  mccomp_posr[859] = mcposrchannel_19_analyzer_1_array_crystal_array_7;
  mcNCounter[859]  = mcPCounter[859] = mcP2Counter[859] = 0;
  mcAbsorbProp[859]= 0;
    /* Component channel_19_analyzer_1_array_crystal_array_8. */
  /* Setting parameters for component channel_19_analyzer_1_array_crystal_array_8. */
  SIG_MESSAGE("channel_19_analyzer_1_array_crystal_array_8 (Init:SetPar)");
#line 4824 "MACS_sample_kidney_box.instr"
  if("PG_analyzer") strncpy(mccchannel_19_analyzer_1_array_crystal_array_8_material_string, "PG_analyzer" ? "PG_analyzer" : "", 16384); else mccchannel_19_analyzer_1_array_crystal_array_8_material_string[0]='\0';
#line 4824 "MACS_sample_kidney_box.instr"
  mccchannel_19_analyzer_1_array_crystal_array_8_priority = 2120.8;
#line 4823 "MACS_sample_kidney_box.instr"
  mccchannel_19_analyzer_1_array_crystal_array_8_xwidth = channel_19_analyzer_1_array_crystal_depth;
#line 4823 "MACS_sample_kidney_box.instr"
  mccchannel_19_analyzer_1_array_crystal_array_8_yheight = channel_19_analyzer_1_array_crystal_height;
#line 4823 "MACS_sample_kidney_box.instr"
  mccchannel_19_analyzer_1_array_crystal_array_8_zdepth = channel_19_analyzer_1_array_crystal_width;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_19_analyzer_1_array_crystal_array_8_xwidth2 = -1;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_19_analyzer_1_array_crystal_array_8_yheight2 = -1;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_19_analyzer_1_array_crystal_array_8_visualize = 1;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_19_analyzer_1_array_crystal_array_8_target_index = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_19_analyzer_1_array_crystal_array_8_target_x = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_19_analyzer_1_array_crystal_array_8_target_y = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_19_analyzer_1_array_crystal_array_8_target_z = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_19_analyzer_1_array_crystal_array_8_focus_aw = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_19_analyzer_1_array_crystal_array_8_focus_ah = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_19_analyzer_1_array_crystal_array_8_focus_xw = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_19_analyzer_1_array_crystal_array_8_focus_xh = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_19_analyzer_1_array_crystal_array_8_focus_r = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_19_analyzer_1_array_crystal_array_8_p_interact = 0;
#line 71 "MACS_sample_kidney_box.instr"
  if(0) strncpy(mccchannel_19_analyzer_1_array_crystal_array_8_mask_string, 0 ? 0 : "", 16384); else mccchannel_19_analyzer_1_array_crystal_array_8_mask_string[0]='\0';
#line 71 "MACS_sample_kidney_box.instr"
  if(0) strncpy(mccchannel_19_analyzer_1_array_crystal_array_8_mask_setting, 0 ? 0 : "", 16384); else mccchannel_19_analyzer_1_array_crystal_array_8_mask_setting[0]='\0';
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_19_analyzer_1_array_crystal_array_8_number_of_activations = 1;
#line 148428 "MACS_sample_kidney_box.c"

  SIG_MESSAGE("channel_19_analyzer_1_array_crystal_array_8 (Init:Place/Rotate)");
  rot_set_rotation(mctr1,
#line 4826 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 4826 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 4826 "MACS_sample_kidney_box.instr"
    (0 - RAD2DEG * channel_19_analyzer_1_array_theta [ 8 ])*DEG2RAD);
#line 148438 "MACS_sample_kidney_box.c"
  rot_mul(mctr1, mcrotachannel_19_analyzer_1_rotated, mcrotachannel_19_analyzer_1_array_crystal_array_8);
  rot_transpose(mcrotachannel_19_analyzer_1_array_crystal_array_7, mctr1);
  rot_mul(mcrotachannel_19_analyzer_1_array_crystal_array_8, mctr1, mcrotrchannel_19_analyzer_1_array_crystal_array_8);
  mctc1 = coords_set(
#line 4825 "MACS_sample_kidney_box.instr"
    0 + channel_19_analyzer_1_array_effective_radius_of_curvature * ( 1 - cos ( channel_19_analyzer_1_array_theta [ 8 ] ) ),
#line 4825 "MACS_sample_kidney_box.instr"
    0 + channel_19_analyzer_1_array_effective_radius_of_curvature * sin ( channel_19_analyzer_1_array_theta [ 8 ] ),
#line 4825 "MACS_sample_kidney_box.instr"
    0);
#line 148449 "MACS_sample_kidney_box.c"
  rot_transpose(mcrotachannel_19_analyzer_1_rotated, mctr1);
  mctc2 = rot_apply(mctr1, mctc1);
  mcposachannel_19_analyzer_1_array_crystal_array_8 = coords_add(mcposachannel_19_analyzer_1_rotated, mctc2);
  mctc1 = coords_sub(mcposachannel_19_analyzer_1_array_crystal_array_7, mcposachannel_19_analyzer_1_array_crystal_array_8);
  mcposrchannel_19_analyzer_1_array_crystal_array_8 = rot_apply(mcrotachannel_19_analyzer_1_array_crystal_array_8, mctc1);
  mcDEBUG_COMPONENT("channel_19_analyzer_1_array_crystal_array_8", mcposachannel_19_analyzer_1_array_crystal_array_8, mcrotachannel_19_analyzer_1_array_crystal_array_8)
  mccomp_posa[860] = mcposachannel_19_analyzer_1_array_crystal_array_8;
  mccomp_posr[860] = mcposrchannel_19_analyzer_1_array_crystal_array_8;
  mcNCounter[860]  = mcPCounter[860] = mcP2Counter[860] = 0;
  mcAbsorbProp[860]= 0;
    /* Component channel_19_analyzer_2_center. */
  /* Setting parameters for component channel_19_analyzer_2_center. */
  SIG_MESSAGE("channel_19_analyzer_2_center (Init:SetPar)");

  SIG_MESSAGE("channel_19_analyzer_2_center (Init:Place/Rotate)");
  rot_set_rotation(mctr1,
    (0.0)*DEG2RAD,
    (0.0)*DEG2RAD,
    (0.0)*DEG2RAD);
#line 148469 "MACS_sample_kidney_box.c"
  rot_mul(mctr1, mcrotachannel_19_analyzer_1_center, mcrotachannel_19_analyzer_2_center);
  rot_transpose(mcrotachannel_19_analyzer_1_array_crystal_array_8, mctr1);
  rot_mul(mcrotachannel_19_analyzer_2_center, mctr1, mcrotrchannel_19_analyzer_2_center);
  mctc1 = coords_set(
#line 4830 "MACS_sample_kidney_box.instr"
    - analyzer_seperation,
#line 4830 "MACS_sample_kidney_box.instr"
    0,
#line 4830 "MACS_sample_kidney_box.instr"
    0);
#line 148480 "MACS_sample_kidney_box.c"
  rot_transpose(mcrotachannel_19_analyzer_1_center, mctr1);
  mctc2 = rot_apply(mctr1, mctc1);
  mcposachannel_19_analyzer_2_center = coords_add(mcposachannel_19_analyzer_1_center, mctc2);
  mctc1 = coords_sub(mcposachannel_19_analyzer_1_array_crystal_array_8, mcposachannel_19_analyzer_2_center);
  mcposrchannel_19_analyzer_2_center = rot_apply(mcrotachannel_19_analyzer_2_center, mctc1);
  mcDEBUG_COMPONENT("channel_19_analyzer_2_center", mcposachannel_19_analyzer_2_center, mcrotachannel_19_analyzer_2_center)
  mccomp_posa[861] = mcposachannel_19_analyzer_2_center;
  mccomp_posr[861] = mcposrchannel_19_analyzer_2_center;
  mcNCounter[861]  = mcPCounter[861] = mcP2Counter[861] = 0;
  mcAbsorbProp[861]= 0;
    /* Component channel_19_analyzer_2_rotated. */
  /* Setting parameters for component channel_19_analyzer_2_rotated. */
  SIG_MESSAGE("channel_19_analyzer_2_rotated (Init:SetPar)");

  SIG_MESSAGE("channel_19_analyzer_2_rotated (Init:Place/Rotate)");
  rot_set_rotation(mctr1,
#line 4834 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 4834 "MACS_sample_kidney_box.instr"
    (- analyzer_theta [ 19 ])*DEG2RAD,
#line 4834 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD);
#line 148503 "MACS_sample_kidney_box.c"
  rot_mul(mctr1, mcrotachannel_19_analyzer_2_center, mcrotachannel_19_analyzer_2_rotated);
  rot_transpose(mcrotachannel_19_analyzer_2_center, mctr1);
  rot_mul(mcrotachannel_19_analyzer_2_rotated, mctr1, mcrotrchannel_19_analyzer_2_rotated);
  mctc1 = coords_set(
#line 4833 "MACS_sample_kidney_box.instr"
    0,
#line 4833 "MACS_sample_kidney_box.instr"
    0,
#line 4833 "MACS_sample_kidney_box.instr"
    0.5 * analyzer_seperation / tan ( analyzer_2theta [ 19 ] * DEG2RAD ));
#line 148514 "MACS_sample_kidney_box.c"
  rot_transpose(mcrotachannel_19_analyzer_2_center, mctr1);
  mctc2 = rot_apply(mctr1, mctc1);
  mcposachannel_19_analyzer_2_rotated = coords_add(mcposachannel_19_analyzer_2_center, mctc2);
  mctc1 = coords_sub(mcposachannel_19_analyzer_2_center, mcposachannel_19_analyzer_2_rotated);
  mcposrchannel_19_analyzer_2_rotated = rot_apply(mcrotachannel_19_analyzer_2_rotated, mctc1);
  mcDEBUG_COMPONENT("channel_19_analyzer_2_rotated", mcposachannel_19_analyzer_2_rotated, mcrotachannel_19_analyzer_2_rotated)
  mccomp_posa[862] = mcposachannel_19_analyzer_2_rotated;
  mccomp_posr[862] = mcposrchannel_19_analyzer_2_rotated;
  mcNCounter[862]  = mcPCounter[862] = mcP2Counter[862] = 0;
  mcAbsorbProp[862]= 0;
    /* Component channel_19_analyzer_2_array_crystal_array_0. */
  /* Setting parameters for component channel_19_analyzer_2_array_crystal_array_0. */
  SIG_MESSAGE("channel_19_analyzer_2_array_crystal_array_0 (Init:SetPar)");
#line 4838 "MACS_sample_kidney_box.instr"
  if("PG_analyzer") strncpy(mccchannel_19_analyzer_2_array_crystal_array_0_material_string, "PG_analyzer" ? "PG_analyzer" : "", 16384); else mccchannel_19_analyzer_2_array_crystal_array_0_material_string[0]='\0';
#line 4838 "MACS_sample_kidney_box.instr"
  mccchannel_19_analyzer_2_array_crystal_array_0_priority = 2121.0;
#line 4837 "MACS_sample_kidney_box.instr"
  mccchannel_19_analyzer_2_array_crystal_array_0_xwidth = channel_19_analyzer_2_array_crystal_depth;
#line 4837 "MACS_sample_kidney_box.instr"
  mccchannel_19_analyzer_2_array_crystal_array_0_yheight = channel_19_analyzer_2_array_crystal_height;
#line 4837 "MACS_sample_kidney_box.instr"
  mccchannel_19_analyzer_2_array_crystal_array_0_zdepth = channel_19_analyzer_2_array_crystal_width;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_19_analyzer_2_array_crystal_array_0_xwidth2 = -1;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_19_analyzer_2_array_crystal_array_0_yheight2 = -1;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_19_analyzer_2_array_crystal_array_0_visualize = 1;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_19_analyzer_2_array_crystal_array_0_target_index = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_19_analyzer_2_array_crystal_array_0_target_x = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_19_analyzer_2_array_crystal_array_0_target_y = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_19_analyzer_2_array_crystal_array_0_target_z = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_19_analyzer_2_array_crystal_array_0_focus_aw = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_19_analyzer_2_array_crystal_array_0_focus_ah = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_19_analyzer_2_array_crystal_array_0_focus_xw = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_19_analyzer_2_array_crystal_array_0_focus_xh = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_19_analyzer_2_array_crystal_array_0_focus_r = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_19_analyzer_2_array_crystal_array_0_p_interact = 0;
#line 71 "MACS_sample_kidney_box.instr"
  if(0) strncpy(mccchannel_19_analyzer_2_array_crystal_array_0_mask_string, 0 ? 0 : "", 16384); else mccchannel_19_analyzer_2_array_crystal_array_0_mask_string[0]='\0';
#line 71 "MACS_sample_kidney_box.instr"
  if(0) strncpy(mccchannel_19_analyzer_2_array_crystal_array_0_mask_setting, 0 ? 0 : "", 16384); else mccchannel_19_analyzer_2_array_crystal_array_0_mask_setting[0]='\0';
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_19_analyzer_2_array_crystal_array_0_number_of_activations = 1;
#line 148570 "MACS_sample_kidney_box.c"

  SIG_MESSAGE("channel_19_analyzer_2_array_crystal_array_0 (Init:Place/Rotate)");
  rot_set_rotation(mctr1,
#line 4840 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 4840 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 4840 "MACS_sample_kidney_box.instr"
    (0 - RAD2DEG * channel_19_analyzer_2_array_theta [ 0 ])*DEG2RAD);
#line 148580 "MACS_sample_kidney_box.c"
  rot_mul(mctr1, mcrotachannel_19_analyzer_2_rotated, mcrotachannel_19_analyzer_2_array_crystal_array_0);
  rot_transpose(mcrotachannel_19_analyzer_2_rotated, mctr1);
  rot_mul(mcrotachannel_19_analyzer_2_array_crystal_array_0, mctr1, mcrotrchannel_19_analyzer_2_array_crystal_array_0);
  mctc1 = coords_set(
#line 4839 "MACS_sample_kidney_box.instr"
    0 + channel_19_analyzer_2_array_effective_radius_of_curvature * ( 1 - cos ( channel_19_analyzer_2_array_theta [ 0 ] ) ),
#line 4839 "MACS_sample_kidney_box.instr"
    0 + channel_19_analyzer_2_array_effective_radius_of_curvature * sin ( channel_19_analyzer_2_array_theta [ 0 ] ),
#line 4839 "MACS_sample_kidney_box.instr"
    0);
#line 148591 "MACS_sample_kidney_box.c"
  rot_transpose(mcrotachannel_19_analyzer_2_rotated, mctr1);
  mctc2 = rot_apply(mctr1, mctc1);
  mcposachannel_19_analyzer_2_array_crystal_array_0 = coords_add(mcposachannel_19_analyzer_2_rotated, mctc2);
  mctc1 = coords_sub(mcposachannel_19_analyzer_2_rotated, mcposachannel_19_analyzer_2_array_crystal_array_0);
  mcposrchannel_19_analyzer_2_array_crystal_array_0 = rot_apply(mcrotachannel_19_analyzer_2_array_crystal_array_0, mctc1);
  mcDEBUG_COMPONENT("channel_19_analyzer_2_array_crystal_array_0", mcposachannel_19_analyzer_2_array_crystal_array_0, mcrotachannel_19_analyzer_2_array_crystal_array_0)
  mccomp_posa[863] = mcposachannel_19_analyzer_2_array_crystal_array_0;
  mccomp_posr[863] = mcposrchannel_19_analyzer_2_array_crystal_array_0;
  mcNCounter[863]  = mcPCounter[863] = mcP2Counter[863] = 0;
  mcAbsorbProp[863]= 0;
    /* Component channel_19_analyzer_2_array_crystal_array_1. */
  /* Setting parameters for component channel_19_analyzer_2_array_crystal_array_1. */
  SIG_MESSAGE("channel_19_analyzer_2_array_crystal_array_1 (Init:SetPar)");
#line 4844 "MACS_sample_kidney_box.instr"
  if("PG_analyzer") strncpy(mccchannel_19_analyzer_2_array_crystal_array_1_material_string, "PG_analyzer" ? "PG_analyzer" : "", 16384); else mccchannel_19_analyzer_2_array_crystal_array_1_material_string[0]='\0';
#line 4844 "MACS_sample_kidney_box.instr"
  mccchannel_19_analyzer_2_array_crystal_array_1_priority = 2121.1;
#line 4843 "MACS_sample_kidney_box.instr"
  mccchannel_19_analyzer_2_array_crystal_array_1_xwidth = channel_19_analyzer_2_array_crystal_depth;
#line 4843 "MACS_sample_kidney_box.instr"
  mccchannel_19_analyzer_2_array_crystal_array_1_yheight = channel_19_analyzer_2_array_crystal_height;
#line 4843 "MACS_sample_kidney_box.instr"
  mccchannel_19_analyzer_2_array_crystal_array_1_zdepth = channel_19_analyzer_2_array_crystal_width;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_19_analyzer_2_array_crystal_array_1_xwidth2 = -1;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_19_analyzer_2_array_crystal_array_1_yheight2 = -1;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_19_analyzer_2_array_crystal_array_1_visualize = 1;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_19_analyzer_2_array_crystal_array_1_target_index = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_19_analyzer_2_array_crystal_array_1_target_x = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_19_analyzer_2_array_crystal_array_1_target_y = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_19_analyzer_2_array_crystal_array_1_target_z = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_19_analyzer_2_array_crystal_array_1_focus_aw = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_19_analyzer_2_array_crystal_array_1_focus_ah = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_19_analyzer_2_array_crystal_array_1_focus_xw = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_19_analyzer_2_array_crystal_array_1_focus_xh = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_19_analyzer_2_array_crystal_array_1_focus_r = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_19_analyzer_2_array_crystal_array_1_p_interact = 0;
#line 71 "MACS_sample_kidney_box.instr"
  if(0) strncpy(mccchannel_19_analyzer_2_array_crystal_array_1_mask_string, 0 ? 0 : "", 16384); else mccchannel_19_analyzer_2_array_crystal_array_1_mask_string[0]='\0';
#line 71 "MACS_sample_kidney_box.instr"
  if(0) strncpy(mccchannel_19_analyzer_2_array_crystal_array_1_mask_setting, 0 ? 0 : "", 16384); else mccchannel_19_analyzer_2_array_crystal_array_1_mask_setting[0]='\0';
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_19_analyzer_2_array_crystal_array_1_number_of_activations = 1;
#line 148647 "MACS_sample_kidney_box.c"

  SIG_MESSAGE("channel_19_analyzer_2_array_crystal_array_1 (Init:Place/Rotate)");
  rot_set_rotation(mctr1,
#line 4846 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 4846 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 4846 "MACS_sample_kidney_box.instr"
    (0 - RAD2DEG * channel_19_analyzer_2_array_theta [ 1 ])*DEG2RAD);
#line 148657 "MACS_sample_kidney_box.c"
  rot_mul(mctr1, mcrotachannel_19_analyzer_2_rotated, mcrotachannel_19_analyzer_2_array_crystal_array_1);
  rot_transpose(mcrotachannel_19_analyzer_2_array_crystal_array_0, mctr1);
  rot_mul(mcrotachannel_19_analyzer_2_array_crystal_array_1, mctr1, mcrotrchannel_19_analyzer_2_array_crystal_array_1);
  mctc1 = coords_set(
#line 4845 "MACS_sample_kidney_box.instr"
    0 + channel_19_analyzer_2_array_effective_radius_of_curvature * ( 1 - cos ( channel_19_analyzer_2_array_theta [ 1 ] ) ),
#line 4845 "MACS_sample_kidney_box.instr"
    0 + channel_19_analyzer_2_array_effective_radius_of_curvature * sin ( channel_19_analyzer_2_array_theta [ 1 ] ),
#line 4845 "MACS_sample_kidney_box.instr"
    0);
#line 148668 "MACS_sample_kidney_box.c"
  rot_transpose(mcrotachannel_19_analyzer_2_rotated, mctr1);
  mctc2 = rot_apply(mctr1, mctc1);
  mcposachannel_19_analyzer_2_array_crystal_array_1 = coords_add(mcposachannel_19_analyzer_2_rotated, mctc2);
  mctc1 = coords_sub(mcposachannel_19_analyzer_2_array_crystal_array_0, mcposachannel_19_analyzer_2_array_crystal_array_1);
  mcposrchannel_19_analyzer_2_array_crystal_array_1 = rot_apply(mcrotachannel_19_analyzer_2_array_crystal_array_1, mctc1);
  mcDEBUG_COMPONENT("channel_19_analyzer_2_array_crystal_array_1", mcposachannel_19_analyzer_2_array_crystal_array_1, mcrotachannel_19_analyzer_2_array_crystal_array_1)
  mccomp_posa[864] = mcposachannel_19_analyzer_2_array_crystal_array_1;
  mccomp_posr[864] = mcposrchannel_19_analyzer_2_array_crystal_array_1;
  mcNCounter[864]  = mcPCounter[864] = mcP2Counter[864] = 0;
  mcAbsorbProp[864]= 0;
    /* Component channel_19_analyzer_2_array_crystal_array_2. */
  /* Setting parameters for component channel_19_analyzer_2_array_crystal_array_2. */
  SIG_MESSAGE("channel_19_analyzer_2_array_crystal_array_2 (Init:SetPar)");
#line 4850 "MACS_sample_kidney_box.instr"
  if("PG_analyzer") strncpy(mccchannel_19_analyzer_2_array_crystal_array_2_material_string, "PG_analyzer" ? "PG_analyzer" : "", 16384); else mccchannel_19_analyzer_2_array_crystal_array_2_material_string[0]='\0';
#line 4850 "MACS_sample_kidney_box.instr"
  mccchannel_19_analyzer_2_array_crystal_array_2_priority = 2121.2;
#line 4849 "MACS_sample_kidney_box.instr"
  mccchannel_19_analyzer_2_array_crystal_array_2_xwidth = channel_19_analyzer_2_array_crystal_depth;
#line 4849 "MACS_sample_kidney_box.instr"
  mccchannel_19_analyzer_2_array_crystal_array_2_yheight = channel_19_analyzer_2_array_crystal_height;
#line 4849 "MACS_sample_kidney_box.instr"
  mccchannel_19_analyzer_2_array_crystal_array_2_zdepth = channel_19_analyzer_2_array_crystal_width;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_19_analyzer_2_array_crystal_array_2_xwidth2 = -1;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_19_analyzer_2_array_crystal_array_2_yheight2 = -1;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_19_analyzer_2_array_crystal_array_2_visualize = 1;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_19_analyzer_2_array_crystal_array_2_target_index = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_19_analyzer_2_array_crystal_array_2_target_x = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_19_analyzer_2_array_crystal_array_2_target_y = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_19_analyzer_2_array_crystal_array_2_target_z = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_19_analyzer_2_array_crystal_array_2_focus_aw = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_19_analyzer_2_array_crystal_array_2_focus_ah = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_19_analyzer_2_array_crystal_array_2_focus_xw = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_19_analyzer_2_array_crystal_array_2_focus_xh = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_19_analyzer_2_array_crystal_array_2_focus_r = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_19_analyzer_2_array_crystal_array_2_p_interact = 0;
#line 71 "MACS_sample_kidney_box.instr"
  if(0) strncpy(mccchannel_19_analyzer_2_array_crystal_array_2_mask_string, 0 ? 0 : "", 16384); else mccchannel_19_analyzer_2_array_crystal_array_2_mask_string[0]='\0';
#line 71 "MACS_sample_kidney_box.instr"
  if(0) strncpy(mccchannel_19_analyzer_2_array_crystal_array_2_mask_setting, 0 ? 0 : "", 16384); else mccchannel_19_analyzer_2_array_crystal_array_2_mask_setting[0]='\0';
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_19_analyzer_2_array_crystal_array_2_number_of_activations = 1;
#line 148724 "MACS_sample_kidney_box.c"

  SIG_MESSAGE("channel_19_analyzer_2_array_crystal_array_2 (Init:Place/Rotate)");
  rot_set_rotation(mctr1,
#line 4852 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 4852 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 4852 "MACS_sample_kidney_box.instr"
    (0 - RAD2DEG * channel_19_analyzer_2_array_theta [ 2 ])*DEG2RAD);
#line 148734 "MACS_sample_kidney_box.c"
  rot_mul(mctr1, mcrotachannel_19_analyzer_2_rotated, mcrotachannel_19_analyzer_2_array_crystal_array_2);
  rot_transpose(mcrotachannel_19_analyzer_2_array_crystal_array_1, mctr1);
  rot_mul(mcrotachannel_19_analyzer_2_array_crystal_array_2, mctr1, mcrotrchannel_19_analyzer_2_array_crystal_array_2);
  mctc1 = coords_set(
#line 4851 "MACS_sample_kidney_box.instr"
    0 + channel_19_analyzer_2_array_effective_radius_of_curvature * ( 1 - cos ( channel_19_analyzer_2_array_theta [ 2 ] ) ),
#line 4851 "MACS_sample_kidney_box.instr"
    0 + channel_19_analyzer_2_array_effective_radius_of_curvature * sin ( channel_19_analyzer_2_array_theta [ 2 ] ),
#line 4851 "MACS_sample_kidney_box.instr"
    0);
#line 148745 "MACS_sample_kidney_box.c"
  rot_transpose(mcrotachannel_19_analyzer_2_rotated, mctr1);
  mctc2 = rot_apply(mctr1, mctc1);
  mcposachannel_19_analyzer_2_array_crystal_array_2 = coords_add(mcposachannel_19_analyzer_2_rotated, mctc2);
  mctc1 = coords_sub(mcposachannel_19_analyzer_2_array_crystal_array_1, mcposachannel_19_analyzer_2_array_crystal_array_2);
  mcposrchannel_19_analyzer_2_array_crystal_array_2 = rot_apply(mcrotachannel_19_analyzer_2_array_crystal_array_2, mctc1);
  mcDEBUG_COMPONENT("channel_19_analyzer_2_array_crystal_array_2", mcposachannel_19_analyzer_2_array_crystal_array_2, mcrotachannel_19_analyzer_2_array_crystal_array_2)
  mccomp_posa[865] = mcposachannel_19_analyzer_2_array_crystal_array_2;
  mccomp_posr[865] = mcposrchannel_19_analyzer_2_array_crystal_array_2;
  mcNCounter[865]  = mcPCounter[865] = mcP2Counter[865] = 0;
  mcAbsorbProp[865]= 0;
    /* Component channel_19_analyzer_2_array_crystal_array_3. */
  /* Setting parameters for component channel_19_analyzer_2_array_crystal_array_3. */
  SIG_MESSAGE("channel_19_analyzer_2_array_crystal_array_3 (Init:SetPar)");
#line 4856 "MACS_sample_kidney_box.instr"
  if("PG_analyzer") strncpy(mccchannel_19_analyzer_2_array_crystal_array_3_material_string, "PG_analyzer" ? "PG_analyzer" : "", 16384); else mccchannel_19_analyzer_2_array_crystal_array_3_material_string[0]='\0';
#line 4856 "MACS_sample_kidney_box.instr"
  mccchannel_19_analyzer_2_array_crystal_array_3_priority = 2121.3;
#line 4855 "MACS_sample_kidney_box.instr"
  mccchannel_19_analyzer_2_array_crystal_array_3_xwidth = channel_19_analyzer_2_array_crystal_depth;
#line 4855 "MACS_sample_kidney_box.instr"
  mccchannel_19_analyzer_2_array_crystal_array_3_yheight = channel_19_analyzer_2_array_crystal_height;
#line 4855 "MACS_sample_kidney_box.instr"
  mccchannel_19_analyzer_2_array_crystal_array_3_zdepth = channel_19_analyzer_2_array_crystal_width;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_19_analyzer_2_array_crystal_array_3_xwidth2 = -1;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_19_analyzer_2_array_crystal_array_3_yheight2 = -1;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_19_analyzer_2_array_crystal_array_3_visualize = 1;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_19_analyzer_2_array_crystal_array_3_target_index = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_19_analyzer_2_array_crystal_array_3_target_x = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_19_analyzer_2_array_crystal_array_3_target_y = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_19_analyzer_2_array_crystal_array_3_target_z = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_19_analyzer_2_array_crystal_array_3_focus_aw = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_19_analyzer_2_array_crystal_array_3_focus_ah = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_19_analyzer_2_array_crystal_array_3_focus_xw = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_19_analyzer_2_array_crystal_array_3_focus_xh = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_19_analyzer_2_array_crystal_array_3_focus_r = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_19_analyzer_2_array_crystal_array_3_p_interact = 0;
#line 71 "MACS_sample_kidney_box.instr"
  if(0) strncpy(mccchannel_19_analyzer_2_array_crystal_array_3_mask_string, 0 ? 0 : "", 16384); else mccchannel_19_analyzer_2_array_crystal_array_3_mask_string[0]='\0';
#line 71 "MACS_sample_kidney_box.instr"
  if(0) strncpy(mccchannel_19_analyzer_2_array_crystal_array_3_mask_setting, 0 ? 0 : "", 16384); else mccchannel_19_analyzer_2_array_crystal_array_3_mask_setting[0]='\0';
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_19_analyzer_2_array_crystal_array_3_number_of_activations = 1;
#line 148801 "MACS_sample_kidney_box.c"

  SIG_MESSAGE("channel_19_analyzer_2_array_crystal_array_3 (Init:Place/Rotate)");
  rot_set_rotation(mctr1,
#line 4858 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 4858 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 4858 "MACS_sample_kidney_box.instr"
    (0 - RAD2DEG * channel_19_analyzer_2_array_theta [ 3 ])*DEG2RAD);
#line 148811 "MACS_sample_kidney_box.c"
  rot_mul(mctr1, mcrotachannel_19_analyzer_2_rotated, mcrotachannel_19_analyzer_2_array_crystal_array_3);
  rot_transpose(mcrotachannel_19_analyzer_2_array_crystal_array_2, mctr1);
  rot_mul(mcrotachannel_19_analyzer_2_array_crystal_array_3, mctr1, mcrotrchannel_19_analyzer_2_array_crystal_array_3);
  mctc1 = coords_set(
#line 4857 "MACS_sample_kidney_box.instr"
    0 + channel_19_analyzer_2_array_effective_radius_of_curvature * ( 1 - cos ( channel_19_analyzer_2_array_theta [ 3 ] ) ),
#line 4857 "MACS_sample_kidney_box.instr"
    0 + channel_19_analyzer_2_array_effective_radius_of_curvature * sin ( channel_19_analyzer_2_array_theta [ 3 ] ),
#line 4857 "MACS_sample_kidney_box.instr"
    0);
#line 148822 "MACS_sample_kidney_box.c"
  rot_transpose(mcrotachannel_19_analyzer_2_rotated, mctr1);
  mctc2 = rot_apply(mctr1, mctc1);
  mcposachannel_19_analyzer_2_array_crystal_array_3 = coords_add(mcposachannel_19_analyzer_2_rotated, mctc2);
  mctc1 = coords_sub(mcposachannel_19_analyzer_2_array_crystal_array_2, mcposachannel_19_analyzer_2_array_crystal_array_3);
  mcposrchannel_19_analyzer_2_array_crystal_array_3 = rot_apply(mcrotachannel_19_analyzer_2_array_crystal_array_3, mctc1);
  mcDEBUG_COMPONENT("channel_19_analyzer_2_array_crystal_array_3", mcposachannel_19_analyzer_2_array_crystal_array_3, mcrotachannel_19_analyzer_2_array_crystal_array_3)
  mccomp_posa[866] = mcposachannel_19_analyzer_2_array_crystal_array_3;
  mccomp_posr[866] = mcposrchannel_19_analyzer_2_array_crystal_array_3;
  mcNCounter[866]  = mcPCounter[866] = mcP2Counter[866] = 0;
  mcAbsorbProp[866]= 0;
    /* Component channel_19_analyzer_2_array_crystal_array_4. */
  /* Setting parameters for component channel_19_analyzer_2_array_crystal_array_4. */
  SIG_MESSAGE("channel_19_analyzer_2_array_crystal_array_4 (Init:SetPar)");
#line 4862 "MACS_sample_kidney_box.instr"
  if("PG_analyzer") strncpy(mccchannel_19_analyzer_2_array_crystal_array_4_material_string, "PG_analyzer" ? "PG_analyzer" : "", 16384); else mccchannel_19_analyzer_2_array_crystal_array_4_material_string[0]='\0';
#line 4862 "MACS_sample_kidney_box.instr"
  mccchannel_19_analyzer_2_array_crystal_array_4_priority = 2121.4;
#line 4861 "MACS_sample_kidney_box.instr"
  mccchannel_19_analyzer_2_array_crystal_array_4_xwidth = channel_19_analyzer_2_array_crystal_depth;
#line 4861 "MACS_sample_kidney_box.instr"
  mccchannel_19_analyzer_2_array_crystal_array_4_yheight = channel_19_analyzer_2_array_crystal_height;
#line 4861 "MACS_sample_kidney_box.instr"
  mccchannel_19_analyzer_2_array_crystal_array_4_zdepth = channel_19_analyzer_2_array_crystal_width;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_19_analyzer_2_array_crystal_array_4_xwidth2 = -1;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_19_analyzer_2_array_crystal_array_4_yheight2 = -1;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_19_analyzer_2_array_crystal_array_4_visualize = 1;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_19_analyzer_2_array_crystal_array_4_target_index = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_19_analyzer_2_array_crystal_array_4_target_x = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_19_analyzer_2_array_crystal_array_4_target_y = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_19_analyzer_2_array_crystal_array_4_target_z = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_19_analyzer_2_array_crystal_array_4_focus_aw = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_19_analyzer_2_array_crystal_array_4_focus_ah = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_19_analyzer_2_array_crystal_array_4_focus_xw = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_19_analyzer_2_array_crystal_array_4_focus_xh = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_19_analyzer_2_array_crystal_array_4_focus_r = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_19_analyzer_2_array_crystal_array_4_p_interact = 0;
#line 71 "MACS_sample_kidney_box.instr"
  if(0) strncpy(mccchannel_19_analyzer_2_array_crystal_array_4_mask_string, 0 ? 0 : "", 16384); else mccchannel_19_analyzer_2_array_crystal_array_4_mask_string[0]='\0';
#line 71 "MACS_sample_kidney_box.instr"
  if(0) strncpy(mccchannel_19_analyzer_2_array_crystal_array_4_mask_setting, 0 ? 0 : "", 16384); else mccchannel_19_analyzer_2_array_crystal_array_4_mask_setting[0]='\0';
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_19_analyzer_2_array_crystal_array_4_number_of_activations = 1;
#line 148878 "MACS_sample_kidney_box.c"

  SIG_MESSAGE("channel_19_analyzer_2_array_crystal_array_4 (Init:Place/Rotate)");
  rot_set_rotation(mctr1,
#line 4864 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 4864 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 4864 "MACS_sample_kidney_box.instr"
    (0 - RAD2DEG * channel_19_analyzer_2_array_theta [ 4 ])*DEG2RAD);
#line 148888 "MACS_sample_kidney_box.c"
  rot_mul(mctr1, mcrotachannel_19_analyzer_2_rotated, mcrotachannel_19_analyzer_2_array_crystal_array_4);
  rot_transpose(mcrotachannel_19_analyzer_2_array_crystal_array_3, mctr1);
  rot_mul(mcrotachannel_19_analyzer_2_array_crystal_array_4, mctr1, mcrotrchannel_19_analyzer_2_array_crystal_array_4);
  mctc1 = coords_set(
#line 4863 "MACS_sample_kidney_box.instr"
    0 + channel_19_analyzer_2_array_effective_radius_of_curvature * ( 1 - cos ( channel_19_analyzer_2_array_theta [ 4 ] ) ),
#line 4863 "MACS_sample_kidney_box.instr"
    0 + channel_19_analyzer_2_array_effective_radius_of_curvature * sin ( channel_19_analyzer_2_array_theta [ 4 ] ),
#line 4863 "MACS_sample_kidney_box.instr"
    0);
#line 148899 "MACS_sample_kidney_box.c"
  rot_transpose(mcrotachannel_19_analyzer_2_rotated, mctr1);
  mctc2 = rot_apply(mctr1, mctc1);
  mcposachannel_19_analyzer_2_array_crystal_array_4 = coords_add(mcposachannel_19_analyzer_2_rotated, mctc2);
  mctc1 = coords_sub(mcposachannel_19_analyzer_2_array_crystal_array_3, mcposachannel_19_analyzer_2_array_crystal_array_4);
  mcposrchannel_19_analyzer_2_array_crystal_array_4 = rot_apply(mcrotachannel_19_analyzer_2_array_crystal_array_4, mctc1);
  mcDEBUG_COMPONENT("channel_19_analyzer_2_array_crystal_array_4", mcposachannel_19_analyzer_2_array_crystal_array_4, mcrotachannel_19_analyzer_2_array_crystal_array_4)
  mccomp_posa[867] = mcposachannel_19_analyzer_2_array_crystal_array_4;
  mccomp_posr[867] = mcposrchannel_19_analyzer_2_array_crystal_array_4;
  mcNCounter[867]  = mcPCounter[867] = mcP2Counter[867] = 0;
  mcAbsorbProp[867]= 0;
    /* Component channel_19_analyzer_2_array_crystal_array_5. */
  /* Setting parameters for component channel_19_analyzer_2_array_crystal_array_5. */
  SIG_MESSAGE("channel_19_analyzer_2_array_crystal_array_5 (Init:SetPar)");
#line 4868 "MACS_sample_kidney_box.instr"
  if("PG_analyzer") strncpy(mccchannel_19_analyzer_2_array_crystal_array_5_material_string, "PG_analyzer" ? "PG_analyzer" : "", 16384); else mccchannel_19_analyzer_2_array_crystal_array_5_material_string[0]='\0';
#line 4868 "MACS_sample_kidney_box.instr"
  mccchannel_19_analyzer_2_array_crystal_array_5_priority = 2121.5;
#line 4867 "MACS_sample_kidney_box.instr"
  mccchannel_19_analyzer_2_array_crystal_array_5_xwidth = channel_19_analyzer_2_array_crystal_depth;
#line 4867 "MACS_sample_kidney_box.instr"
  mccchannel_19_analyzer_2_array_crystal_array_5_yheight = channel_19_analyzer_2_array_crystal_height;
#line 4867 "MACS_sample_kidney_box.instr"
  mccchannel_19_analyzer_2_array_crystal_array_5_zdepth = channel_19_analyzer_2_array_crystal_width;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_19_analyzer_2_array_crystal_array_5_xwidth2 = -1;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_19_analyzer_2_array_crystal_array_5_yheight2 = -1;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_19_analyzer_2_array_crystal_array_5_visualize = 1;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_19_analyzer_2_array_crystal_array_5_target_index = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_19_analyzer_2_array_crystal_array_5_target_x = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_19_analyzer_2_array_crystal_array_5_target_y = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_19_analyzer_2_array_crystal_array_5_target_z = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_19_analyzer_2_array_crystal_array_5_focus_aw = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_19_analyzer_2_array_crystal_array_5_focus_ah = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_19_analyzer_2_array_crystal_array_5_focus_xw = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_19_analyzer_2_array_crystal_array_5_focus_xh = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_19_analyzer_2_array_crystal_array_5_focus_r = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_19_analyzer_2_array_crystal_array_5_p_interact = 0;
#line 71 "MACS_sample_kidney_box.instr"
  if(0) strncpy(mccchannel_19_analyzer_2_array_crystal_array_5_mask_string, 0 ? 0 : "", 16384); else mccchannel_19_analyzer_2_array_crystal_array_5_mask_string[0]='\0';
#line 71 "MACS_sample_kidney_box.instr"
  if(0) strncpy(mccchannel_19_analyzer_2_array_crystal_array_5_mask_setting, 0 ? 0 : "", 16384); else mccchannel_19_analyzer_2_array_crystal_array_5_mask_setting[0]='\0';
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_19_analyzer_2_array_crystal_array_5_number_of_activations = 1;
#line 148955 "MACS_sample_kidney_box.c"

  SIG_MESSAGE("channel_19_analyzer_2_array_crystal_array_5 (Init:Place/Rotate)");
  rot_set_rotation(mctr1,
#line 4870 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 4870 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 4870 "MACS_sample_kidney_box.instr"
    (0 - RAD2DEG * channel_19_analyzer_2_array_theta [ 5 ])*DEG2RAD);
#line 148965 "MACS_sample_kidney_box.c"
  rot_mul(mctr1, mcrotachannel_19_analyzer_2_rotated, mcrotachannel_19_analyzer_2_array_crystal_array_5);
  rot_transpose(mcrotachannel_19_analyzer_2_array_crystal_array_4, mctr1);
  rot_mul(mcrotachannel_19_analyzer_2_array_crystal_array_5, mctr1, mcrotrchannel_19_analyzer_2_array_crystal_array_5);
  mctc1 = coords_set(
#line 4869 "MACS_sample_kidney_box.instr"
    0 + channel_19_analyzer_2_array_effective_radius_of_curvature * ( 1 - cos ( channel_19_analyzer_2_array_theta [ 5 ] ) ),
#line 4869 "MACS_sample_kidney_box.instr"
    0 + channel_19_analyzer_2_array_effective_radius_of_curvature * sin ( channel_19_analyzer_2_array_theta [ 5 ] ),
#line 4869 "MACS_sample_kidney_box.instr"
    0);
#line 148976 "MACS_sample_kidney_box.c"
  rot_transpose(mcrotachannel_19_analyzer_2_rotated, mctr1);
  mctc2 = rot_apply(mctr1, mctc1);
  mcposachannel_19_analyzer_2_array_crystal_array_5 = coords_add(mcposachannel_19_analyzer_2_rotated, mctc2);
  mctc1 = coords_sub(mcposachannel_19_analyzer_2_array_crystal_array_4, mcposachannel_19_analyzer_2_array_crystal_array_5);
  mcposrchannel_19_analyzer_2_array_crystal_array_5 = rot_apply(mcrotachannel_19_analyzer_2_array_crystal_array_5, mctc1);
  mcDEBUG_COMPONENT("channel_19_analyzer_2_array_crystal_array_5", mcposachannel_19_analyzer_2_array_crystal_array_5, mcrotachannel_19_analyzer_2_array_crystal_array_5)
  mccomp_posa[868] = mcposachannel_19_analyzer_2_array_crystal_array_5;
  mccomp_posr[868] = mcposrchannel_19_analyzer_2_array_crystal_array_5;
  mcNCounter[868]  = mcPCounter[868] = mcP2Counter[868] = 0;
  mcAbsorbProp[868]= 0;
    /* Component channel_19_analyzer_2_array_crystal_array_6. */
  /* Setting parameters for component channel_19_analyzer_2_array_crystal_array_6. */
  SIG_MESSAGE("channel_19_analyzer_2_array_crystal_array_6 (Init:SetPar)");
#line 4874 "MACS_sample_kidney_box.instr"
  if("PG_analyzer") strncpy(mccchannel_19_analyzer_2_array_crystal_array_6_material_string, "PG_analyzer" ? "PG_analyzer" : "", 16384); else mccchannel_19_analyzer_2_array_crystal_array_6_material_string[0]='\0';
#line 4874 "MACS_sample_kidney_box.instr"
  mccchannel_19_analyzer_2_array_crystal_array_6_priority = 2121.6;
#line 4873 "MACS_sample_kidney_box.instr"
  mccchannel_19_analyzer_2_array_crystal_array_6_xwidth = channel_19_analyzer_2_array_crystal_depth;
#line 4873 "MACS_sample_kidney_box.instr"
  mccchannel_19_analyzer_2_array_crystal_array_6_yheight = channel_19_analyzer_2_array_crystal_height;
#line 4873 "MACS_sample_kidney_box.instr"
  mccchannel_19_analyzer_2_array_crystal_array_6_zdepth = channel_19_analyzer_2_array_crystal_width;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_19_analyzer_2_array_crystal_array_6_xwidth2 = -1;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_19_analyzer_2_array_crystal_array_6_yheight2 = -1;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_19_analyzer_2_array_crystal_array_6_visualize = 1;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_19_analyzer_2_array_crystal_array_6_target_index = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_19_analyzer_2_array_crystal_array_6_target_x = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_19_analyzer_2_array_crystal_array_6_target_y = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_19_analyzer_2_array_crystal_array_6_target_z = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_19_analyzer_2_array_crystal_array_6_focus_aw = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_19_analyzer_2_array_crystal_array_6_focus_ah = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_19_analyzer_2_array_crystal_array_6_focus_xw = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_19_analyzer_2_array_crystal_array_6_focus_xh = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_19_analyzer_2_array_crystal_array_6_focus_r = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_19_analyzer_2_array_crystal_array_6_p_interact = 0;
#line 71 "MACS_sample_kidney_box.instr"
  if(0) strncpy(mccchannel_19_analyzer_2_array_crystal_array_6_mask_string, 0 ? 0 : "", 16384); else mccchannel_19_analyzer_2_array_crystal_array_6_mask_string[0]='\0';
#line 71 "MACS_sample_kidney_box.instr"
  if(0) strncpy(mccchannel_19_analyzer_2_array_crystal_array_6_mask_setting, 0 ? 0 : "", 16384); else mccchannel_19_analyzer_2_array_crystal_array_6_mask_setting[0]='\0';
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_19_analyzer_2_array_crystal_array_6_number_of_activations = 1;
#line 149032 "MACS_sample_kidney_box.c"

  SIG_MESSAGE("channel_19_analyzer_2_array_crystal_array_6 (Init:Place/Rotate)");
  rot_set_rotation(mctr1,
#line 4876 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 4876 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 4876 "MACS_sample_kidney_box.instr"
    (0 - RAD2DEG * channel_19_analyzer_2_array_theta [ 6 ])*DEG2RAD);
#line 149042 "MACS_sample_kidney_box.c"
  rot_mul(mctr1, mcrotachannel_19_analyzer_2_rotated, mcrotachannel_19_analyzer_2_array_crystal_array_6);
  rot_transpose(mcrotachannel_19_analyzer_2_array_crystal_array_5, mctr1);
  rot_mul(mcrotachannel_19_analyzer_2_array_crystal_array_6, mctr1, mcrotrchannel_19_analyzer_2_array_crystal_array_6);
  mctc1 = coords_set(
#line 4875 "MACS_sample_kidney_box.instr"
    0 + channel_19_analyzer_2_array_effective_radius_of_curvature * ( 1 - cos ( channel_19_analyzer_2_array_theta [ 6 ] ) ),
#line 4875 "MACS_sample_kidney_box.instr"
    0 + channel_19_analyzer_2_array_effective_radius_of_curvature * sin ( channel_19_analyzer_2_array_theta [ 6 ] ),
#line 4875 "MACS_sample_kidney_box.instr"
    0);
#line 149053 "MACS_sample_kidney_box.c"
  rot_transpose(mcrotachannel_19_analyzer_2_rotated, mctr1);
  mctc2 = rot_apply(mctr1, mctc1);
  mcposachannel_19_analyzer_2_array_crystal_array_6 = coords_add(mcposachannel_19_analyzer_2_rotated, mctc2);
  mctc1 = coords_sub(mcposachannel_19_analyzer_2_array_crystal_array_5, mcposachannel_19_analyzer_2_array_crystal_array_6);
  mcposrchannel_19_analyzer_2_array_crystal_array_6 = rot_apply(mcrotachannel_19_analyzer_2_array_crystal_array_6, mctc1);
  mcDEBUG_COMPONENT("channel_19_analyzer_2_array_crystal_array_6", mcposachannel_19_analyzer_2_array_crystal_array_6, mcrotachannel_19_analyzer_2_array_crystal_array_6)
  mccomp_posa[869] = mcposachannel_19_analyzer_2_array_crystal_array_6;
  mccomp_posr[869] = mcposrchannel_19_analyzer_2_array_crystal_array_6;
  mcNCounter[869]  = mcPCounter[869] = mcP2Counter[869] = 0;
  mcAbsorbProp[869]= 0;
    /* Component channel_19_analyzer_2_array_crystal_array_7. */
  /* Setting parameters for component channel_19_analyzer_2_array_crystal_array_7. */
  SIG_MESSAGE("channel_19_analyzer_2_array_crystal_array_7 (Init:SetPar)");
#line 4880 "MACS_sample_kidney_box.instr"
  if("PG_analyzer") strncpy(mccchannel_19_analyzer_2_array_crystal_array_7_material_string, "PG_analyzer" ? "PG_analyzer" : "", 16384); else mccchannel_19_analyzer_2_array_crystal_array_7_material_string[0]='\0';
#line 4880 "MACS_sample_kidney_box.instr"
  mccchannel_19_analyzer_2_array_crystal_array_7_priority = 2121.7;
#line 4879 "MACS_sample_kidney_box.instr"
  mccchannel_19_analyzer_2_array_crystal_array_7_xwidth = channel_19_analyzer_2_array_crystal_depth;
#line 4879 "MACS_sample_kidney_box.instr"
  mccchannel_19_analyzer_2_array_crystal_array_7_yheight = channel_19_analyzer_2_array_crystal_height;
#line 4879 "MACS_sample_kidney_box.instr"
  mccchannel_19_analyzer_2_array_crystal_array_7_zdepth = channel_19_analyzer_2_array_crystal_width;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_19_analyzer_2_array_crystal_array_7_xwidth2 = -1;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_19_analyzer_2_array_crystal_array_7_yheight2 = -1;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_19_analyzer_2_array_crystal_array_7_visualize = 1;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_19_analyzer_2_array_crystal_array_7_target_index = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_19_analyzer_2_array_crystal_array_7_target_x = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_19_analyzer_2_array_crystal_array_7_target_y = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_19_analyzer_2_array_crystal_array_7_target_z = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_19_analyzer_2_array_crystal_array_7_focus_aw = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_19_analyzer_2_array_crystal_array_7_focus_ah = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_19_analyzer_2_array_crystal_array_7_focus_xw = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_19_analyzer_2_array_crystal_array_7_focus_xh = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_19_analyzer_2_array_crystal_array_7_focus_r = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_19_analyzer_2_array_crystal_array_7_p_interact = 0;
#line 71 "MACS_sample_kidney_box.instr"
  if(0) strncpy(mccchannel_19_analyzer_2_array_crystal_array_7_mask_string, 0 ? 0 : "", 16384); else mccchannel_19_analyzer_2_array_crystal_array_7_mask_string[0]='\0';
#line 71 "MACS_sample_kidney_box.instr"
  if(0) strncpy(mccchannel_19_analyzer_2_array_crystal_array_7_mask_setting, 0 ? 0 : "", 16384); else mccchannel_19_analyzer_2_array_crystal_array_7_mask_setting[0]='\0';
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_19_analyzer_2_array_crystal_array_7_number_of_activations = 1;
#line 149109 "MACS_sample_kidney_box.c"

  SIG_MESSAGE("channel_19_analyzer_2_array_crystal_array_7 (Init:Place/Rotate)");
  rot_set_rotation(mctr1,
#line 4882 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 4882 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 4882 "MACS_sample_kidney_box.instr"
    (0 - RAD2DEG * channel_19_analyzer_2_array_theta [ 7 ])*DEG2RAD);
#line 149119 "MACS_sample_kidney_box.c"
  rot_mul(mctr1, mcrotachannel_19_analyzer_2_rotated, mcrotachannel_19_analyzer_2_array_crystal_array_7);
  rot_transpose(mcrotachannel_19_analyzer_2_array_crystal_array_6, mctr1);
  rot_mul(mcrotachannel_19_analyzer_2_array_crystal_array_7, mctr1, mcrotrchannel_19_analyzer_2_array_crystal_array_7);
  mctc1 = coords_set(
#line 4881 "MACS_sample_kidney_box.instr"
    0 + channel_19_analyzer_2_array_effective_radius_of_curvature * ( 1 - cos ( channel_19_analyzer_2_array_theta [ 7 ] ) ),
#line 4881 "MACS_sample_kidney_box.instr"
    0 + channel_19_analyzer_2_array_effective_radius_of_curvature * sin ( channel_19_analyzer_2_array_theta [ 7 ] ),
#line 4881 "MACS_sample_kidney_box.instr"
    0);
#line 149130 "MACS_sample_kidney_box.c"
  rot_transpose(mcrotachannel_19_analyzer_2_rotated, mctr1);
  mctc2 = rot_apply(mctr1, mctc1);
  mcposachannel_19_analyzer_2_array_crystal_array_7 = coords_add(mcposachannel_19_analyzer_2_rotated, mctc2);
  mctc1 = coords_sub(mcposachannel_19_analyzer_2_array_crystal_array_6, mcposachannel_19_analyzer_2_array_crystal_array_7);
  mcposrchannel_19_analyzer_2_array_crystal_array_7 = rot_apply(mcrotachannel_19_analyzer_2_array_crystal_array_7, mctc1);
  mcDEBUG_COMPONENT("channel_19_analyzer_2_array_crystal_array_7", mcposachannel_19_analyzer_2_array_crystal_array_7, mcrotachannel_19_analyzer_2_array_crystal_array_7)
  mccomp_posa[870] = mcposachannel_19_analyzer_2_array_crystal_array_7;
  mccomp_posr[870] = mcposrchannel_19_analyzer_2_array_crystal_array_7;
  mcNCounter[870]  = mcPCounter[870] = mcP2Counter[870] = 0;
  mcAbsorbProp[870]= 0;
    /* Component channel_19_analyzer_2_array_crystal_array_8. */
  /* Setting parameters for component channel_19_analyzer_2_array_crystal_array_8. */
  SIG_MESSAGE("channel_19_analyzer_2_array_crystal_array_8 (Init:SetPar)");
#line 4886 "MACS_sample_kidney_box.instr"
  if("PG_analyzer") strncpy(mccchannel_19_analyzer_2_array_crystal_array_8_material_string, "PG_analyzer" ? "PG_analyzer" : "", 16384); else mccchannel_19_analyzer_2_array_crystal_array_8_material_string[0]='\0';
#line 4886 "MACS_sample_kidney_box.instr"
  mccchannel_19_analyzer_2_array_crystal_array_8_priority = 2121.8;
#line 4885 "MACS_sample_kidney_box.instr"
  mccchannel_19_analyzer_2_array_crystal_array_8_xwidth = channel_19_analyzer_2_array_crystal_depth;
#line 4885 "MACS_sample_kidney_box.instr"
  mccchannel_19_analyzer_2_array_crystal_array_8_yheight = channel_19_analyzer_2_array_crystal_height;
#line 4885 "MACS_sample_kidney_box.instr"
  mccchannel_19_analyzer_2_array_crystal_array_8_zdepth = channel_19_analyzer_2_array_crystal_width;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_19_analyzer_2_array_crystal_array_8_xwidth2 = -1;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_19_analyzer_2_array_crystal_array_8_yheight2 = -1;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_19_analyzer_2_array_crystal_array_8_visualize = 1;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_19_analyzer_2_array_crystal_array_8_target_index = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_19_analyzer_2_array_crystal_array_8_target_x = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_19_analyzer_2_array_crystal_array_8_target_y = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_19_analyzer_2_array_crystal_array_8_target_z = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_19_analyzer_2_array_crystal_array_8_focus_aw = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_19_analyzer_2_array_crystal_array_8_focus_ah = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_19_analyzer_2_array_crystal_array_8_focus_xw = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_19_analyzer_2_array_crystal_array_8_focus_xh = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_19_analyzer_2_array_crystal_array_8_focus_r = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_19_analyzer_2_array_crystal_array_8_p_interact = 0;
#line 71 "MACS_sample_kidney_box.instr"
  if(0) strncpy(mccchannel_19_analyzer_2_array_crystal_array_8_mask_string, 0 ? 0 : "", 16384); else mccchannel_19_analyzer_2_array_crystal_array_8_mask_string[0]='\0';
#line 71 "MACS_sample_kidney_box.instr"
  if(0) strncpy(mccchannel_19_analyzer_2_array_crystal_array_8_mask_setting, 0 ? 0 : "", 16384); else mccchannel_19_analyzer_2_array_crystal_array_8_mask_setting[0]='\0';
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_19_analyzer_2_array_crystal_array_8_number_of_activations = 1;
#line 149186 "MACS_sample_kidney_box.c"

  SIG_MESSAGE("channel_19_analyzer_2_array_crystal_array_8 (Init:Place/Rotate)");
  rot_set_rotation(mctr1,
#line 4888 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 4888 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 4888 "MACS_sample_kidney_box.instr"
    (0 - RAD2DEG * channel_19_analyzer_2_array_theta [ 8 ])*DEG2RAD);
#line 149196 "MACS_sample_kidney_box.c"
  rot_mul(mctr1, mcrotachannel_19_analyzer_2_rotated, mcrotachannel_19_analyzer_2_array_crystal_array_8);
  rot_transpose(mcrotachannel_19_analyzer_2_array_crystal_array_7, mctr1);
  rot_mul(mcrotachannel_19_analyzer_2_array_crystal_array_8, mctr1, mcrotrchannel_19_analyzer_2_array_crystal_array_8);
  mctc1 = coords_set(
#line 4887 "MACS_sample_kidney_box.instr"
    0 + channel_19_analyzer_2_array_effective_radius_of_curvature * ( 1 - cos ( channel_19_analyzer_2_array_theta [ 8 ] ) ),
#line 4887 "MACS_sample_kidney_box.instr"
    0 + channel_19_analyzer_2_array_effective_radius_of_curvature * sin ( channel_19_analyzer_2_array_theta [ 8 ] ),
#line 4887 "MACS_sample_kidney_box.instr"
    0);
#line 149207 "MACS_sample_kidney_box.c"
  rot_transpose(mcrotachannel_19_analyzer_2_rotated, mctr1);
  mctc2 = rot_apply(mctr1, mctc1);
  mcposachannel_19_analyzer_2_array_crystal_array_8 = coords_add(mcposachannel_19_analyzer_2_rotated, mctc2);
  mctc1 = coords_sub(mcposachannel_19_analyzer_2_array_crystal_array_7, mcposachannel_19_analyzer_2_array_crystal_array_8);
  mcposrchannel_19_analyzer_2_array_crystal_array_8 = rot_apply(mcrotachannel_19_analyzer_2_array_crystal_array_8, mctc1);
  mcDEBUG_COMPONENT("channel_19_analyzer_2_array_crystal_array_8", mcposachannel_19_analyzer_2_array_crystal_array_8, mcrotachannel_19_analyzer_2_array_crystal_array_8)
  mccomp_posa[871] = mcposachannel_19_analyzer_2_array_crystal_array_8;
  mccomp_posr[871] = mcposrchannel_19_analyzer_2_array_crystal_array_8;
  mcNCounter[871]  = mcPCounter[871] = mcP2Counter[871] = 0;
  mcAbsorbProp[871]= 0;
    /* Component channel_19_cave2_cyl1. */
  /* Setting parameters for component channel_19_cave2_cyl1. */
  SIG_MESSAGE("channel_19_cave2_cyl1 (Init:SetPar)");
#line 4893 "MACS_sample_kidney_box.instr"
  if("Vacuum") strncpy(mccchannel_19_cave2_cyl1_material_string, "Vacuum" ? "Vacuum" : "", 16384); else mccchannel_19_cave2_cyl1_material_string[0]='\0';
#line 4893 "MACS_sample_kidney_box.instr"
  mccchannel_19_cave2_cyl1_priority = 2107.5;
#line 4892 "MACS_sample_kidney_box.instr"
  mccchannel_19_cave2_cyl1_radius = kidney_cave2_cyl1_radius;
#line 4892 "MACS_sample_kidney_box.instr"
  mccchannel_19_cave2_cyl1_yheight = kidney_cave2_cyl1_height;
#line 67 "MACS_sample_kidney_box.instr"
  mccchannel_19_cave2_cyl1_visualize = 1;
#line 67 "MACS_sample_kidney_box.instr"
  mccchannel_19_cave2_cyl1_target_index = 0;
#line 67 "MACS_sample_kidney_box.instr"
  mccchannel_19_cave2_cyl1_target_x = 0;
#line 67 "MACS_sample_kidney_box.instr"
  mccchannel_19_cave2_cyl1_target_y = 0;
#line 67 "MACS_sample_kidney_box.instr"
  mccchannel_19_cave2_cyl1_target_z = 0;
#line 67 "MACS_sample_kidney_box.instr"
  mccchannel_19_cave2_cyl1_focus_aw = 0;
#line 67 "MACS_sample_kidney_box.instr"
  mccchannel_19_cave2_cyl1_focus_ah = 0;
#line 67 "MACS_sample_kidney_box.instr"
  mccchannel_19_cave2_cyl1_focus_xw = 0;
#line 67 "MACS_sample_kidney_box.instr"
  mccchannel_19_cave2_cyl1_focus_xh = 0;
#line 67 "MACS_sample_kidney_box.instr"
  mccchannel_19_cave2_cyl1_focus_r = 0;
#line 67 "MACS_sample_kidney_box.instr"
  mccchannel_19_cave2_cyl1_p_interact = 0;
#line 67 "MACS_sample_kidney_box.instr"
  if(0) strncpy(mccchannel_19_cave2_cyl1_mask_string, 0 ? 0 : "", 16384); else mccchannel_19_cave2_cyl1_mask_string[0]='\0';
#line 67 "MACS_sample_kidney_box.instr"
  if(0) strncpy(mccchannel_19_cave2_cyl1_mask_setting, 0 ? 0 : "", 16384); else mccchannel_19_cave2_cyl1_mask_setting[0]='\0';
#line 67 "MACS_sample_kidney_box.instr"
  mccchannel_19_cave2_cyl1_number_of_activations = 1;
#line 149257 "MACS_sample_kidney_box.c"

  SIG_MESSAGE("channel_19_cave2_cyl1 (Init:Place/Rotate)");
  rot_set_rotation(mctr1,
#line 4895 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 4895 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 4895 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD);
#line 149267 "MACS_sample_kidney_box.c"
  rot_mul(mctr1, mcrotachannel_19_analyzer_2_center, mcrotachannel_19_cave2_cyl1);
  rot_transpose(mcrotachannel_19_analyzer_2_array_crystal_array_8, mctr1);
  rot_mul(mcrotachannel_19_cave2_cyl1, mctr1, mcrotrchannel_19_cave2_cyl1);
  mctc1 = coords_set(
#line 4894 "MACS_sample_kidney_box.instr"
    0,
#line 4894 "MACS_sample_kidney_box.instr"
    0,
#line 4894 "MACS_sample_kidney_box.instr"
    spec_detector_to_analyzer_2_center);
#line 149278 "MACS_sample_kidney_box.c"
  rot_transpose(mcrotachannel_19_analyzer_2_center, mctr1);
  mctc2 = rot_apply(mctr1, mctc1);
  mcposachannel_19_cave2_cyl1 = coords_add(mcposachannel_19_analyzer_2_center, mctc2);
  mctc1 = coords_sub(mcposachannel_19_analyzer_2_array_crystal_array_8, mcposachannel_19_cave2_cyl1);
  mcposrchannel_19_cave2_cyl1 = rot_apply(mcrotachannel_19_cave2_cyl1, mctc1);
  mcDEBUG_COMPONENT("channel_19_cave2_cyl1", mcposachannel_19_cave2_cyl1, mcrotachannel_19_cave2_cyl1)
  mccomp_posa[872] = mcposachannel_19_cave2_cyl1;
  mccomp_posr[872] = mcposrchannel_19_cave2_cyl1;
  mcNCounter[872]  = mcPCounter[872] = mcP2Counter[872] = 0;
  mcAbsorbProp[872]= 0;
    /* Component channel_19_cave2_box1. */
  /* Setting parameters for component channel_19_cave2_box1. */
  SIG_MESSAGE("channel_19_cave2_box1 (Init:SetPar)");
#line 4900 "MACS_sample_kidney_box.instr"
  if("Vacuum") strncpy(mccchannel_19_cave2_box1_material_string, "Vacuum" ? "Vacuum" : "", 16384); else mccchannel_19_cave2_box1_material_string[0]='\0';
#line 4900 "MACS_sample_kidney_box.instr"
  mccchannel_19_cave2_box1_priority = 2101;
#line 4898 "MACS_sample_kidney_box.instr"
  mccchannel_19_cave2_box1_xwidth = kidney_cave2_box1_width1;
#line 4898 "MACS_sample_kidney_box.instr"
  mccchannel_19_cave2_box1_yheight = kidney_cave2_box1_height1;
#line 4898 "MACS_sample_kidney_box.instr"
  mccchannel_19_cave2_box1_zdepth = kidney_cave2_box1_depth;
#line 4899 "MACS_sample_kidney_box.instr"
  mccchannel_19_cave2_box1_xwidth2 = kidney_cave2_box1_width2;
#line 4899 "MACS_sample_kidney_box.instr"
  mccchannel_19_cave2_box1_yheight2 = kidney_cave2_box1_height2;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_19_cave2_box1_visualize = 1;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_19_cave2_box1_target_index = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_19_cave2_box1_target_x = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_19_cave2_box1_target_y = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_19_cave2_box1_target_z = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_19_cave2_box1_focus_aw = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_19_cave2_box1_focus_ah = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_19_cave2_box1_focus_xw = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_19_cave2_box1_focus_xh = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_19_cave2_box1_focus_r = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_19_cave2_box1_p_interact = 0;
#line 71 "MACS_sample_kidney_box.instr"
  if(0) strncpy(mccchannel_19_cave2_box1_mask_string, 0 ? 0 : "", 16384); else mccchannel_19_cave2_box1_mask_string[0]='\0';
#line 71 "MACS_sample_kidney_box.instr"
  if(0) strncpy(mccchannel_19_cave2_box1_mask_setting, 0 ? 0 : "", 16384); else mccchannel_19_cave2_box1_mask_setting[0]='\0';
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_19_cave2_box1_number_of_activations = 1;
#line 149334 "MACS_sample_kidney_box.c"

  SIG_MESSAGE("channel_19_cave2_box1 (Init:Place/Rotate)");
  rot_set_rotation(mctr1,
#line 4902 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 4902 "MACS_sample_kidney_box.instr"
    (kidney_cave2_box1_y_rotation)*DEG2RAD,
#line 4902 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD);
#line 149344 "MACS_sample_kidney_box.c"
  rot_mul(mctr1, mcrotachannel_19_cave2_cyl1, mcrotachannel_19_cave2_box1);
  rot_transpose(mcrotachannel_19_cave2_cyl1, mctr1);
  rot_mul(mcrotachannel_19_cave2_box1, mctr1, mcrotrchannel_19_cave2_box1);
  mctc1 = coords_set(
#line 4901 "MACS_sample_kidney_box.instr"
    kidney_cave2_box1_center_to_spec_detector_x,
#line 4901 "MACS_sample_kidney_box.instr"
    0,
#line 4901 "MACS_sample_kidney_box.instr"
    kidney_cave2_box1_center_to_spec_detector_z);
#line 149355 "MACS_sample_kidney_box.c"
  rot_transpose(mcrotachannel_19_cave2_cyl1, mctr1);
  mctc2 = rot_apply(mctr1, mctc1);
  mcposachannel_19_cave2_box1 = coords_add(mcposachannel_19_cave2_cyl1, mctc2);
  mctc1 = coords_sub(mcposachannel_19_cave2_cyl1, mcposachannel_19_cave2_box1);
  mcposrchannel_19_cave2_box1 = rot_apply(mcrotachannel_19_cave2_box1, mctc1);
  mcDEBUG_COMPONENT("channel_19_cave2_box1", mcposachannel_19_cave2_box1, mcrotachannel_19_cave2_box1)
  mccomp_posa[873] = mcposachannel_19_cave2_box1;
  mccomp_posr[873] = mcposrchannel_19_cave2_box1;
  mcNCounter[873]  = mcPCounter[873] = mcP2Counter[873] = 0;
  mcAbsorbProp[873]= 0;
    /* Component channel_19_cave2_box2. */
  /* Setting parameters for component channel_19_cave2_box2. */
  SIG_MESSAGE("channel_19_cave2_box2 (Init:SetPar)");
#line 4907 "MACS_sample_kidney_box.instr"
  if("Vacuum") strncpy(mccchannel_19_cave2_box2_material_string, "Vacuum" ? "Vacuum" : "", 16384); else mccchannel_19_cave2_box2_material_string[0]='\0';
#line 4907 "MACS_sample_kidney_box.instr"
  mccchannel_19_cave2_box2_priority = 2106;
#line 4905 "MACS_sample_kidney_box.instr"
  mccchannel_19_cave2_box2_xwidth = kidney_cave2_box2_width1;
#line 4905 "MACS_sample_kidney_box.instr"
  mccchannel_19_cave2_box2_yheight = kidney_cave2_box2_height1;
#line 4905 "MACS_sample_kidney_box.instr"
  mccchannel_19_cave2_box2_zdepth = kidney_cave2_box2_depth;
#line 4906 "MACS_sample_kidney_box.instr"
  mccchannel_19_cave2_box2_xwidth2 = kidney_cave2_box2_width2;
#line 4906 "MACS_sample_kidney_box.instr"
  mccchannel_19_cave2_box2_yheight2 = kidney_cave2_box2_height2;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_19_cave2_box2_visualize = 1;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_19_cave2_box2_target_index = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_19_cave2_box2_target_x = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_19_cave2_box2_target_y = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_19_cave2_box2_target_z = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_19_cave2_box2_focus_aw = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_19_cave2_box2_focus_ah = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_19_cave2_box2_focus_xw = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_19_cave2_box2_focus_xh = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_19_cave2_box2_focus_r = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_19_cave2_box2_p_interact = 0;
#line 71 "MACS_sample_kidney_box.instr"
  if(0) strncpy(mccchannel_19_cave2_box2_mask_string, 0 ? 0 : "", 16384); else mccchannel_19_cave2_box2_mask_string[0]='\0';
#line 71 "MACS_sample_kidney_box.instr"
  if(0) strncpy(mccchannel_19_cave2_box2_mask_setting, 0 ? 0 : "", 16384); else mccchannel_19_cave2_box2_mask_setting[0]='\0';
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_19_cave2_box2_number_of_activations = 1;
#line 149411 "MACS_sample_kidney_box.c"

  SIG_MESSAGE("channel_19_cave2_box2 (Init:Place/Rotate)");
  rot_set_rotation(mctr1,
#line 4909 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 4909 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 4909 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD);
#line 149421 "MACS_sample_kidney_box.c"
  rot_mul(mctr1, mcrotachannel_19_cave2_cyl1, mcrotachannel_19_cave2_box2);
  rot_transpose(mcrotachannel_19_cave2_box1, mctr1);
  rot_mul(mcrotachannel_19_cave2_box2, mctr1, mcrotrchannel_19_cave2_box2);
  mctc1 = coords_set(
#line 4908 "MACS_sample_kidney_box.instr"
    0,
#line 4908 "MACS_sample_kidney_box.instr"
    0,
#line 4908 "MACS_sample_kidney_box.instr"
    kidney_cave2_box2_center_to_detector);
#line 149432 "MACS_sample_kidney_box.c"
  rot_transpose(mcrotachannel_19_cave2_cyl1, mctr1);
  mctc2 = rot_apply(mctr1, mctc1);
  mcposachannel_19_cave2_box2 = coords_add(mcposachannel_19_cave2_cyl1, mctc2);
  mctc1 = coords_sub(mcposachannel_19_cave2_box1, mcposachannel_19_cave2_box2);
  mcposrchannel_19_cave2_box2 = rot_apply(mcrotachannel_19_cave2_box2, mctc1);
  mcDEBUG_COMPONENT("channel_19_cave2_box2", mcposachannel_19_cave2_box2, mcrotachannel_19_cave2_box2)
  mccomp_posa[874] = mcposachannel_19_cave2_box2;
  mccomp_posr[874] = mcposrchannel_19_cave2_box2;
  mcNCounter[874]  = mcPCounter[874] = mcP2Counter[874] = 0;
  mcAbsorbProp[874]= 0;
    /* Component channel_19_cave2_box3. */
  /* Setting parameters for component channel_19_cave2_box3. */
  SIG_MESSAGE("channel_19_cave2_box3 (Init:SetPar)");
#line 4914 "MACS_sample_kidney_box.instr"
  if("Vacuum") strncpy(mccchannel_19_cave2_box3_material_string, "Vacuum" ? "Vacuum" : "", 16384); else mccchannel_19_cave2_box3_material_string[0]='\0';
#line 4914 "MACS_sample_kidney_box.instr"
  mccchannel_19_cave2_box3_priority = 2107;
#line 4912 "MACS_sample_kidney_box.instr"
  mccchannel_19_cave2_box3_xwidth = kidney_cave2_box3_width1;
#line 4912 "MACS_sample_kidney_box.instr"
  mccchannel_19_cave2_box3_yheight = kidney_cave2_box3_height1;
#line 4912 "MACS_sample_kidney_box.instr"
  mccchannel_19_cave2_box3_zdepth = kidney_cave2_box3_depth;
#line 4913 "MACS_sample_kidney_box.instr"
  mccchannel_19_cave2_box3_xwidth2 = kidney_cave2_box3_width2;
#line 4913 "MACS_sample_kidney_box.instr"
  mccchannel_19_cave2_box3_yheight2 = kidney_cave2_box3_height2;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_19_cave2_box3_visualize = 1;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_19_cave2_box3_target_index = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_19_cave2_box3_target_x = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_19_cave2_box3_target_y = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_19_cave2_box3_target_z = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_19_cave2_box3_focus_aw = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_19_cave2_box3_focus_ah = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_19_cave2_box3_focus_xw = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_19_cave2_box3_focus_xh = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_19_cave2_box3_focus_r = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_19_cave2_box3_p_interact = 0;
#line 71 "MACS_sample_kidney_box.instr"
  if(0) strncpy(mccchannel_19_cave2_box3_mask_string, 0 ? 0 : "", 16384); else mccchannel_19_cave2_box3_mask_string[0]='\0';
#line 71 "MACS_sample_kidney_box.instr"
  if(0) strncpy(mccchannel_19_cave2_box3_mask_setting, 0 ? 0 : "", 16384); else mccchannel_19_cave2_box3_mask_setting[0]='\0';
#line 71 "MACS_sample_kidney_box.instr"
  mccchannel_19_cave2_box3_number_of_activations = 1;
#line 149488 "MACS_sample_kidney_box.c"

  SIG_MESSAGE("channel_19_cave2_box3 (Init:Place/Rotate)");
  rot_set_rotation(mctr1,
#line 4916 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 4916 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 4916 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD);
#line 149498 "MACS_sample_kidney_box.c"
  rot_mul(mctr1, mcrotachannel_19_cave2_cyl1, mcrotachannel_19_cave2_box3);
  rot_transpose(mcrotachannel_19_cave2_box2, mctr1);
  rot_mul(mcrotachannel_19_cave2_box3, mctr1, mcrotrchannel_19_cave2_box3);
  mctc1 = coords_set(
#line 4915 "MACS_sample_kidney_box.instr"
    0,
#line 4915 "MACS_sample_kidney_box.instr"
    0,
#line 4915 "MACS_sample_kidney_box.instr"
    kidney_cave2_box3_center_to_detector);
#line 149509 "MACS_sample_kidney_box.c"
  rot_transpose(mcrotachannel_19_cave2_cyl1, mctr1);
  mctc2 = rot_apply(mctr1, mctc1);
  mcposachannel_19_cave2_box3 = coords_add(mcposachannel_19_cave2_cyl1, mctc2);
  mctc1 = coords_sub(mcposachannel_19_cave2_box2, mcposachannel_19_cave2_box3);
  mcposrchannel_19_cave2_box3 = rot_apply(mcrotachannel_19_cave2_box3, mctc1);
  mcDEBUG_COMPONENT("channel_19_cave2_box3", mcposachannel_19_cave2_box3, mcrotachannel_19_cave2_box3)
  mccomp_posa[875] = mcposachannel_19_cave2_box3;
  mccomp_posr[875] = mcposrchannel_19_cave2_box3;
  mcNCounter[875]  = mcPCounter[875] = mcP2Counter[875] = 0;
  mcAbsorbProp[875]= 0;
    /* Component inter_analyzer_colimator_center_19. */
  /* Setting parameters for component inter_analyzer_colimator_center_19. */
  SIG_MESSAGE("inter_analyzer_colimator_center_19 (Init:SetPar)");

  SIG_MESSAGE("inter_analyzer_colimator_center_19 (Init:Place/Rotate)");
  rot_set_rotation(mctr1,
#line 4920 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 4920 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 4920 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD);
#line 149532 "MACS_sample_kidney_box.c"
  rot_mul(mctr1, mcrotachannel_19_analyzer_1_center, mcrotainter_analyzer_colimator_center_19);
  rot_transpose(mcrotachannel_19_cave2_box3, mctr1);
  rot_mul(mcrotainter_analyzer_colimator_center_19, mctr1, mcrotrinter_analyzer_colimator_center_19);
  mctc1 = coords_set(
#line 4919 "MACS_sample_kidney_box.instr"
    -0.5 * analyzer_seperation,
#line 4919 "MACS_sample_kidney_box.instr"
    0,
#line 4919 "MACS_sample_kidney_box.instr"
    0);
#line 149543 "MACS_sample_kidney_box.c"
  rot_transpose(mcrotachannel_19_analyzer_1_center, mctr1);
  mctc2 = rot_apply(mctr1, mctc1);
  mcposainter_analyzer_colimator_center_19 = coords_add(mcposachannel_19_analyzer_1_center, mctc2);
  mctc1 = coords_sub(mcposachannel_19_cave2_box3, mcposainter_analyzer_colimator_center_19);
  mcposrinter_analyzer_colimator_center_19 = rot_apply(mcrotainter_analyzer_colimator_center_19, mctc1);
  mcDEBUG_COMPONENT("inter_analyzer_colimator_center_19", mcposainter_analyzer_colimator_center_19, mcrotainter_analyzer_colimator_center_19)
  mccomp_posa[876] = mcposainter_analyzer_colimator_center_19;
  mccomp_posr[876] = mcposrinter_analyzer_colimator_center_19;
  mcNCounter[876]  = mcPCounter[876] = mcP2Counter[876] = 0;
  mcAbsorbProp[876]= 0;
    /* Component inter_analyzer_colimator_19_blade_0. */
  /* Setting parameters for component inter_analyzer_colimator_19_blade_0. */
  SIG_MESSAGE("inter_analyzer_colimator_19_blade_0 (Init:SetPar)");
#line 4924 "MACS_sample_kidney_box.instr"
  if("Collimator_gad") strncpy(mccinter_analyzer_colimator_19_blade_0_material_string, "Collimator_gad" ? "Collimator_gad" : "", 16384); else mccinter_analyzer_colimator_19_blade_0_material_string[0]='\0';
#line 4924 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_19_blade_0_priority = 2125;
#line 4923 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_19_blade_0_xwidth = inter_analyzer_colimator_width;
#line 4923 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_19_blade_0_yheight = inter_analyzer_colimator_height;
#line 4923 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_19_blade_0_zdepth = inter_analyzer_colimator_depth;
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_19_blade_0_xwidth2 = -1;
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_19_blade_0_yheight2 = -1;
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_19_blade_0_visualize = 1;
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_19_blade_0_target_index = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_19_blade_0_target_x = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_19_blade_0_target_y = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_19_blade_0_target_z = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_19_blade_0_focus_aw = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_19_blade_0_focus_ah = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_19_blade_0_focus_xw = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_19_blade_0_focus_xh = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_19_blade_0_focus_r = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_19_blade_0_p_interact = 0;
#line 71 "MACS_sample_kidney_box.instr"
  if(0) strncpy(mccinter_analyzer_colimator_19_blade_0_mask_string, 0 ? 0 : "", 16384); else mccinter_analyzer_colimator_19_blade_0_mask_string[0]='\0';
#line 71 "MACS_sample_kidney_box.instr"
  if(0) strncpy(mccinter_analyzer_colimator_19_blade_0_mask_setting, 0 ? 0 : "", 16384); else mccinter_analyzer_colimator_19_blade_0_mask_setting[0]='\0';
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_19_blade_0_number_of_activations = 1;
#line 149599 "MACS_sample_kidney_box.c"

  SIG_MESSAGE("inter_analyzer_colimator_19_blade_0 (Init:Place/Rotate)");
  rot_set_rotation(mctr1,
#line 4926 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 4926 "MACS_sample_kidney_box.instr"
    (- analyzer_2theta [ 19 ])*DEG2RAD,
#line 4926 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD);
#line 149609 "MACS_sample_kidney_box.c"
  rot_mul(mctr1, mcrotainter_analyzer_colimator_center_19, mcrotainter_analyzer_colimator_19_blade_0);
  rot_transpose(mcrotainter_analyzer_colimator_center_19, mctr1);
  rot_mul(mcrotainter_analyzer_colimator_19_blade_0, mctr1, mcrotrinter_analyzer_colimator_19_blade_0);
  mctc1 = coords_set(
#line 4925 "MACS_sample_kidney_box.instr"
    0,
#line 4925 "MACS_sample_kidney_box.instr"
    0,
#line 4925 "MACS_sample_kidney_box.instr"
    inter_analyzer_colimator_start_pos - 0 * inter_analyzer_colimator_seperation);
#line 149620 "MACS_sample_kidney_box.c"
  rot_transpose(mcrotainter_analyzer_colimator_center_19, mctr1);
  mctc2 = rot_apply(mctr1, mctc1);
  mcposainter_analyzer_colimator_19_blade_0 = coords_add(mcposainter_analyzer_colimator_center_19, mctc2);
  mctc1 = coords_sub(mcposainter_analyzer_colimator_center_19, mcposainter_analyzer_colimator_19_blade_0);
  mcposrinter_analyzer_colimator_19_blade_0 = rot_apply(mcrotainter_analyzer_colimator_19_blade_0, mctc1);
  mcDEBUG_COMPONENT("inter_analyzer_colimator_19_blade_0", mcposainter_analyzer_colimator_19_blade_0, mcrotainter_analyzer_colimator_19_blade_0)
  mccomp_posa[877] = mcposainter_analyzer_colimator_19_blade_0;
  mccomp_posr[877] = mcposrinter_analyzer_colimator_19_blade_0;
  mcNCounter[877]  = mcPCounter[877] = mcP2Counter[877] = 0;
  mcAbsorbProp[877]= 0;
    /* Component inter_analyzer_colimator_19_blade_1. */
  /* Setting parameters for component inter_analyzer_colimator_19_blade_1. */
  SIG_MESSAGE("inter_analyzer_colimator_19_blade_1 (Init:SetPar)");
#line 4930 "MACS_sample_kidney_box.instr"
  if("Collimator_gad") strncpy(mccinter_analyzer_colimator_19_blade_1_material_string, "Collimator_gad" ? "Collimator_gad" : "", 16384); else mccinter_analyzer_colimator_19_blade_1_material_string[0]='\0';
#line 4930 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_19_blade_1_priority = 2126;
#line 4929 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_19_blade_1_xwidth = inter_analyzer_colimator_width;
#line 4929 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_19_blade_1_yheight = inter_analyzer_colimator_height;
#line 4929 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_19_blade_1_zdepth = inter_analyzer_colimator_depth;
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_19_blade_1_xwidth2 = -1;
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_19_blade_1_yheight2 = -1;
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_19_blade_1_visualize = 1;
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_19_blade_1_target_index = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_19_blade_1_target_x = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_19_blade_1_target_y = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_19_blade_1_target_z = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_19_blade_1_focus_aw = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_19_blade_1_focus_ah = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_19_blade_1_focus_xw = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_19_blade_1_focus_xh = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_19_blade_1_focus_r = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_19_blade_1_p_interact = 0;
#line 71 "MACS_sample_kidney_box.instr"
  if(0) strncpy(mccinter_analyzer_colimator_19_blade_1_mask_string, 0 ? 0 : "", 16384); else mccinter_analyzer_colimator_19_blade_1_mask_string[0]='\0';
#line 71 "MACS_sample_kidney_box.instr"
  if(0) strncpy(mccinter_analyzer_colimator_19_blade_1_mask_setting, 0 ? 0 : "", 16384); else mccinter_analyzer_colimator_19_blade_1_mask_setting[0]='\0';
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_19_blade_1_number_of_activations = 1;
#line 149676 "MACS_sample_kidney_box.c"

  SIG_MESSAGE("inter_analyzer_colimator_19_blade_1 (Init:Place/Rotate)");
  rot_set_rotation(mctr1,
#line 4932 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 4932 "MACS_sample_kidney_box.instr"
    (- analyzer_2theta [ 19 ])*DEG2RAD,
#line 4932 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD);
#line 149686 "MACS_sample_kidney_box.c"
  rot_mul(mctr1, mcrotainter_analyzer_colimator_center_19, mcrotainter_analyzer_colimator_19_blade_1);
  rot_transpose(mcrotainter_analyzer_colimator_19_blade_0, mctr1);
  rot_mul(mcrotainter_analyzer_colimator_19_blade_1, mctr1, mcrotrinter_analyzer_colimator_19_blade_1);
  mctc1 = coords_set(
#line 4931 "MACS_sample_kidney_box.instr"
    0,
#line 4931 "MACS_sample_kidney_box.instr"
    0,
#line 4931 "MACS_sample_kidney_box.instr"
    inter_analyzer_colimator_start_pos - 1 * inter_analyzer_colimator_seperation);
#line 149697 "MACS_sample_kidney_box.c"
  rot_transpose(mcrotainter_analyzer_colimator_center_19, mctr1);
  mctc2 = rot_apply(mctr1, mctc1);
  mcposainter_analyzer_colimator_19_blade_1 = coords_add(mcposainter_analyzer_colimator_center_19, mctc2);
  mctc1 = coords_sub(mcposainter_analyzer_colimator_19_blade_0, mcposainter_analyzer_colimator_19_blade_1);
  mcposrinter_analyzer_colimator_19_blade_1 = rot_apply(mcrotainter_analyzer_colimator_19_blade_1, mctc1);
  mcDEBUG_COMPONENT("inter_analyzer_colimator_19_blade_1", mcposainter_analyzer_colimator_19_blade_1, mcrotainter_analyzer_colimator_19_blade_1)
  mccomp_posa[878] = mcposainter_analyzer_colimator_19_blade_1;
  mccomp_posr[878] = mcposrinter_analyzer_colimator_19_blade_1;
  mcNCounter[878]  = mcPCounter[878] = mcP2Counter[878] = 0;
  mcAbsorbProp[878]= 0;
    /* Component inter_analyzer_colimator_19_blade_2. */
  /* Setting parameters for component inter_analyzer_colimator_19_blade_2. */
  SIG_MESSAGE("inter_analyzer_colimator_19_blade_2 (Init:SetPar)");
#line 4936 "MACS_sample_kidney_box.instr"
  if("Collimator_gad") strncpy(mccinter_analyzer_colimator_19_blade_2_material_string, "Collimator_gad" ? "Collimator_gad" : "", 16384); else mccinter_analyzer_colimator_19_blade_2_material_string[0]='\0';
#line 4936 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_19_blade_2_priority = 2127;
#line 4935 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_19_blade_2_xwidth = inter_analyzer_colimator_width;
#line 4935 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_19_blade_2_yheight = inter_analyzer_colimator_height;
#line 4935 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_19_blade_2_zdepth = inter_analyzer_colimator_depth;
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_19_blade_2_xwidth2 = -1;
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_19_blade_2_yheight2 = -1;
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_19_blade_2_visualize = 1;
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_19_blade_2_target_index = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_19_blade_2_target_x = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_19_blade_2_target_y = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_19_blade_2_target_z = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_19_blade_2_focus_aw = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_19_blade_2_focus_ah = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_19_blade_2_focus_xw = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_19_blade_2_focus_xh = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_19_blade_2_focus_r = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_19_blade_2_p_interact = 0;
#line 71 "MACS_sample_kidney_box.instr"
  if(0) strncpy(mccinter_analyzer_colimator_19_blade_2_mask_string, 0 ? 0 : "", 16384); else mccinter_analyzer_colimator_19_blade_2_mask_string[0]='\0';
#line 71 "MACS_sample_kidney_box.instr"
  if(0) strncpy(mccinter_analyzer_colimator_19_blade_2_mask_setting, 0 ? 0 : "", 16384); else mccinter_analyzer_colimator_19_blade_2_mask_setting[0]='\0';
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_19_blade_2_number_of_activations = 1;
#line 149753 "MACS_sample_kidney_box.c"

  SIG_MESSAGE("inter_analyzer_colimator_19_blade_2 (Init:Place/Rotate)");
  rot_set_rotation(mctr1,
#line 4938 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 4938 "MACS_sample_kidney_box.instr"
    (- analyzer_2theta [ 19 ])*DEG2RAD,
#line 4938 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD);
#line 149763 "MACS_sample_kidney_box.c"
  rot_mul(mctr1, mcrotainter_analyzer_colimator_center_19, mcrotainter_analyzer_colimator_19_blade_2);
  rot_transpose(mcrotainter_analyzer_colimator_19_blade_1, mctr1);
  rot_mul(mcrotainter_analyzer_colimator_19_blade_2, mctr1, mcrotrinter_analyzer_colimator_19_blade_2);
  mctc1 = coords_set(
#line 4937 "MACS_sample_kidney_box.instr"
    0,
#line 4937 "MACS_sample_kidney_box.instr"
    0,
#line 4937 "MACS_sample_kidney_box.instr"
    inter_analyzer_colimator_start_pos - 2 * inter_analyzer_colimator_seperation);
#line 149774 "MACS_sample_kidney_box.c"
  rot_transpose(mcrotainter_analyzer_colimator_center_19, mctr1);
  mctc2 = rot_apply(mctr1, mctc1);
  mcposainter_analyzer_colimator_19_blade_2 = coords_add(mcposainter_analyzer_colimator_center_19, mctc2);
  mctc1 = coords_sub(mcposainter_analyzer_colimator_19_blade_1, mcposainter_analyzer_colimator_19_blade_2);
  mcposrinter_analyzer_colimator_19_blade_2 = rot_apply(mcrotainter_analyzer_colimator_19_blade_2, mctc1);
  mcDEBUG_COMPONENT("inter_analyzer_colimator_19_blade_2", mcposainter_analyzer_colimator_19_blade_2, mcrotainter_analyzer_colimator_19_blade_2)
  mccomp_posa[879] = mcposainter_analyzer_colimator_19_blade_2;
  mccomp_posr[879] = mcposrinter_analyzer_colimator_19_blade_2;
  mcNCounter[879]  = mcPCounter[879] = mcP2Counter[879] = 0;
  mcAbsorbProp[879]= 0;
    /* Component inter_analyzer_colimator_19_blade_3. */
  /* Setting parameters for component inter_analyzer_colimator_19_blade_3. */
  SIG_MESSAGE("inter_analyzer_colimator_19_blade_3 (Init:SetPar)");
#line 4942 "MACS_sample_kidney_box.instr"
  if("Collimator_gad") strncpy(mccinter_analyzer_colimator_19_blade_3_material_string, "Collimator_gad" ? "Collimator_gad" : "", 16384); else mccinter_analyzer_colimator_19_blade_3_material_string[0]='\0';
#line 4942 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_19_blade_3_priority = 2128;
#line 4941 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_19_blade_3_xwidth = inter_analyzer_colimator_width;
#line 4941 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_19_blade_3_yheight = inter_analyzer_colimator_height;
#line 4941 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_19_blade_3_zdepth = inter_analyzer_colimator_depth;
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_19_blade_3_xwidth2 = -1;
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_19_blade_3_yheight2 = -1;
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_19_blade_3_visualize = 1;
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_19_blade_3_target_index = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_19_blade_3_target_x = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_19_blade_3_target_y = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_19_blade_3_target_z = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_19_blade_3_focus_aw = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_19_blade_3_focus_ah = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_19_blade_3_focus_xw = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_19_blade_3_focus_xh = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_19_blade_3_focus_r = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_19_blade_3_p_interact = 0;
#line 71 "MACS_sample_kidney_box.instr"
  if(0) strncpy(mccinter_analyzer_colimator_19_blade_3_mask_string, 0 ? 0 : "", 16384); else mccinter_analyzer_colimator_19_blade_3_mask_string[0]='\0';
#line 71 "MACS_sample_kidney_box.instr"
  if(0) strncpy(mccinter_analyzer_colimator_19_blade_3_mask_setting, 0 ? 0 : "", 16384); else mccinter_analyzer_colimator_19_blade_3_mask_setting[0]='\0';
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_19_blade_3_number_of_activations = 1;
#line 149830 "MACS_sample_kidney_box.c"

  SIG_MESSAGE("inter_analyzer_colimator_19_blade_3 (Init:Place/Rotate)");
  rot_set_rotation(mctr1,
#line 4944 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 4944 "MACS_sample_kidney_box.instr"
    (- analyzer_2theta [ 19 ])*DEG2RAD,
#line 4944 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD);
#line 149840 "MACS_sample_kidney_box.c"
  rot_mul(mctr1, mcrotainter_analyzer_colimator_center_19, mcrotainter_analyzer_colimator_19_blade_3);
  rot_transpose(mcrotainter_analyzer_colimator_19_blade_2, mctr1);
  rot_mul(mcrotainter_analyzer_colimator_19_blade_3, mctr1, mcrotrinter_analyzer_colimator_19_blade_3);
  mctc1 = coords_set(
#line 4943 "MACS_sample_kidney_box.instr"
    0,
#line 4943 "MACS_sample_kidney_box.instr"
    0,
#line 4943 "MACS_sample_kidney_box.instr"
    inter_analyzer_colimator_start_pos - 3 * inter_analyzer_colimator_seperation);
#line 149851 "MACS_sample_kidney_box.c"
  rot_transpose(mcrotainter_analyzer_colimator_center_19, mctr1);
  mctc2 = rot_apply(mctr1, mctc1);
  mcposainter_analyzer_colimator_19_blade_3 = coords_add(mcposainter_analyzer_colimator_center_19, mctc2);
  mctc1 = coords_sub(mcposainter_analyzer_colimator_19_blade_2, mcposainter_analyzer_colimator_19_blade_3);
  mcposrinter_analyzer_colimator_19_blade_3 = rot_apply(mcrotainter_analyzer_colimator_19_blade_3, mctc1);
  mcDEBUG_COMPONENT("inter_analyzer_colimator_19_blade_3", mcposainter_analyzer_colimator_19_blade_3, mcrotainter_analyzer_colimator_19_blade_3)
  mccomp_posa[880] = mcposainter_analyzer_colimator_19_blade_3;
  mccomp_posr[880] = mcposrinter_analyzer_colimator_19_blade_3;
  mcNCounter[880]  = mcPCounter[880] = mcP2Counter[880] = 0;
  mcAbsorbProp[880]= 0;
    /* Component inter_analyzer_colimator_19_blade_4. */
  /* Setting parameters for component inter_analyzer_colimator_19_blade_4. */
  SIG_MESSAGE("inter_analyzer_colimator_19_blade_4 (Init:SetPar)");
#line 4948 "MACS_sample_kidney_box.instr"
  if("Collimator_gad") strncpy(mccinter_analyzer_colimator_19_blade_4_material_string, "Collimator_gad" ? "Collimator_gad" : "", 16384); else mccinter_analyzer_colimator_19_blade_4_material_string[0]='\0';
#line 4948 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_19_blade_4_priority = 2129;
#line 4947 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_19_blade_4_xwidth = inter_analyzer_colimator_width;
#line 4947 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_19_blade_4_yheight = inter_analyzer_colimator_height;
#line 4947 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_19_blade_4_zdepth = inter_analyzer_colimator_depth;
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_19_blade_4_xwidth2 = -1;
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_19_blade_4_yheight2 = -1;
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_19_blade_4_visualize = 1;
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_19_blade_4_target_index = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_19_blade_4_target_x = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_19_blade_4_target_y = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_19_blade_4_target_z = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_19_blade_4_focus_aw = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_19_blade_4_focus_ah = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_19_blade_4_focus_xw = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_19_blade_4_focus_xh = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_19_blade_4_focus_r = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_19_blade_4_p_interact = 0;
#line 71 "MACS_sample_kidney_box.instr"
  if(0) strncpy(mccinter_analyzer_colimator_19_blade_4_mask_string, 0 ? 0 : "", 16384); else mccinter_analyzer_colimator_19_blade_4_mask_string[0]='\0';
#line 71 "MACS_sample_kidney_box.instr"
  if(0) strncpy(mccinter_analyzer_colimator_19_blade_4_mask_setting, 0 ? 0 : "", 16384); else mccinter_analyzer_colimator_19_blade_4_mask_setting[0]='\0';
#line 71 "MACS_sample_kidney_box.instr"
  mccinter_analyzer_colimator_19_blade_4_number_of_activations = 1;
#line 149907 "MACS_sample_kidney_box.c"

  SIG_MESSAGE("inter_analyzer_colimator_19_blade_4 (Init:Place/Rotate)");
  rot_set_rotation(mctr1,
#line 4950 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 4950 "MACS_sample_kidney_box.instr"
    (- analyzer_2theta [ 19 ])*DEG2RAD,
#line 4950 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD);
#line 149917 "MACS_sample_kidney_box.c"
  rot_mul(mctr1, mcrotainter_analyzer_colimator_center_19, mcrotainter_analyzer_colimator_19_blade_4);
  rot_transpose(mcrotainter_analyzer_colimator_19_blade_3, mctr1);
  rot_mul(mcrotainter_analyzer_colimator_19_blade_4, mctr1, mcrotrinter_analyzer_colimator_19_blade_4);
  mctc1 = coords_set(
#line 4949 "MACS_sample_kidney_box.instr"
    0,
#line 4949 "MACS_sample_kidney_box.instr"
    0,
#line 4949 "MACS_sample_kidney_box.instr"
    inter_analyzer_colimator_start_pos - 4 * inter_analyzer_colimator_seperation);
#line 149928 "MACS_sample_kidney_box.c"
  rot_transpose(mcrotainter_analyzer_colimator_center_19, mctr1);
  mctc2 = rot_apply(mctr1, mctc1);
  mcposainter_analyzer_colimator_19_blade_4 = coords_add(mcposainter_analyzer_colimator_center_19, mctc2);
  mctc1 = coords_sub(mcposainter_analyzer_colimator_19_blade_3, mcposainter_analyzer_colimator_19_blade_4);
  mcposrinter_analyzer_colimator_19_blade_4 = rot_apply(mcrotainter_analyzer_colimator_19_blade_4, mctc1);
  mcDEBUG_COMPONENT("inter_analyzer_colimator_19_blade_4", mcposainter_analyzer_colimator_19_blade_4, mcrotainter_analyzer_colimator_19_blade_4)
  mccomp_posa[881] = mcposainter_analyzer_colimator_19_blade_4;
  mccomp_posr[881] = mcposrinter_analyzer_colimator_19_blade_4;
  mcNCounter[881]  = mcPCounter[881] = mcP2Counter[881] = 0;
  mcAbsorbProp[881]= 0;
    /* Component diffraction_detector_19_exit_volume. */
  /* Setting parameters for component diffraction_detector_19_exit_volume. */
  SIG_MESSAGE("diffraction_detector_19_exit_volume (Init:SetPar)");
#line 4954 "MACS_sample_kidney_box.instr"
  if("Exit") strncpy(mccdiffraction_detector_19_exit_volume_material_string, "Exit" ? "Exit" : "", 16384); else mccdiffraction_detector_19_exit_volume_material_string[0]='\0';
#line 4954 "MACS_sample_kidney_box.instr"
  mccdiffraction_detector_19_exit_volume_priority = 2131;
#line 4953 "MACS_sample_kidney_box.instr"
  mccdiffraction_detector_19_exit_volume_xwidth = 2.01 * detector_radius;
#line 4953 "MACS_sample_kidney_box.instr"
  mccdiffraction_detector_19_exit_volume_yheight = 1.01 * detector_height;
#line 4953 "MACS_sample_kidney_box.instr"
  mccdiffraction_detector_19_exit_volume_zdepth = 0.001;
#line 71 "MACS_sample_kidney_box.instr"
  mccdiffraction_detector_19_exit_volume_xwidth2 = -1;
#line 71 "MACS_sample_kidney_box.instr"
  mccdiffraction_detector_19_exit_volume_yheight2 = -1;
#line 71 "MACS_sample_kidney_box.instr"
  mccdiffraction_detector_19_exit_volume_visualize = 1;
#line 71 "MACS_sample_kidney_box.instr"
  mccdiffraction_detector_19_exit_volume_target_index = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccdiffraction_detector_19_exit_volume_target_x = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccdiffraction_detector_19_exit_volume_target_y = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccdiffraction_detector_19_exit_volume_target_z = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccdiffraction_detector_19_exit_volume_focus_aw = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccdiffraction_detector_19_exit_volume_focus_ah = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccdiffraction_detector_19_exit_volume_focus_xw = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccdiffraction_detector_19_exit_volume_focus_xh = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccdiffraction_detector_19_exit_volume_focus_r = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccdiffraction_detector_19_exit_volume_p_interact = 0;
#line 71 "MACS_sample_kidney_box.instr"
  if(0) strncpy(mccdiffraction_detector_19_exit_volume_mask_string, 0 ? 0 : "", 16384); else mccdiffraction_detector_19_exit_volume_mask_string[0]='\0';
#line 71 "MACS_sample_kidney_box.instr"
  if(0) strncpy(mccdiffraction_detector_19_exit_volume_mask_setting, 0 ? 0 : "", 16384); else mccdiffraction_detector_19_exit_volume_mask_setting[0]='\0';
#line 71 "MACS_sample_kidney_box.instr"
  mccdiffraction_detector_19_exit_volume_number_of_activations = 1;
#line 149984 "MACS_sample_kidney_box.c"

  SIG_MESSAGE("diffraction_detector_19_exit_volume (Init:Place/Rotate)");
  rot_set_rotation(mctr1,
#line 4956 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 4956 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 4956 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD);
#line 149994 "MACS_sample_kidney_box.c"
  rot_mul(mctr1, mcrotakidney_channel_19, mcrotadiffraction_detector_19_exit_volume);
  rot_transpose(mcrotainter_analyzer_colimator_19_blade_4, mctr1);
  rot_mul(mcrotadiffraction_detector_19_exit_volume, mctr1, mcrotrdiffraction_detector_19_exit_volume);
  mctc1 = coords_set(
#line 4955 "MACS_sample_kidney_box.instr"
    0,
#line 4955 "MACS_sample_kidney_box.instr"
    0,
#line 4955 "MACS_sample_kidney_box.instr"
    0);
#line 150005 "MACS_sample_kidney_box.c"
  rot_transpose(mcrotachannel_19_cave1_cyl1, mctr1);
  mctc2 = rot_apply(mctr1, mctc1);
  mcposadiffraction_detector_19_exit_volume = coords_add(mcposachannel_19_cave1_cyl1, mctc2);
  mctc1 = coords_sub(mcposainter_analyzer_colimator_19_blade_4, mcposadiffraction_detector_19_exit_volume);
  mcposrdiffraction_detector_19_exit_volume = rot_apply(mcrotadiffraction_detector_19_exit_volume, mctc1);
  mcDEBUG_COMPONENT("diffraction_detector_19_exit_volume", mcposadiffraction_detector_19_exit_volume, mcrotadiffraction_detector_19_exit_volume)
  mccomp_posa[882] = mcposadiffraction_detector_19_exit_volume;
  mccomp_posr[882] = mcposrdiffraction_detector_19_exit_volume;
  mcNCounter[882]  = mcPCounter[882] = mcP2Counter[882] = 0;
  mcAbsorbProp[882]= 0;
    /* Component spec_detector_19_exit_volume. */
  /* Setting parameters for component spec_detector_19_exit_volume. */
  SIG_MESSAGE("spec_detector_19_exit_volume (Init:SetPar)");
#line 4960 "MACS_sample_kidney_box.instr"
  if("Exit") strncpy(mccspec_detector_19_exit_volume_material_string, "Exit" ? "Exit" : "", 16384); else mccspec_detector_19_exit_volume_material_string[0]='\0';
#line 4960 "MACS_sample_kidney_box.instr"
  mccspec_detector_19_exit_volume_priority = 2132;
#line 4959 "MACS_sample_kidney_box.instr"
  mccspec_detector_19_exit_volume_xwidth = 2.01 * detector_radius;
#line 4959 "MACS_sample_kidney_box.instr"
  mccspec_detector_19_exit_volume_yheight = 1.01 * detector_height;
#line 4959 "MACS_sample_kidney_box.instr"
  mccspec_detector_19_exit_volume_zdepth = 0.001;
#line 71 "MACS_sample_kidney_box.instr"
  mccspec_detector_19_exit_volume_xwidth2 = -1;
#line 71 "MACS_sample_kidney_box.instr"
  mccspec_detector_19_exit_volume_yheight2 = -1;
#line 71 "MACS_sample_kidney_box.instr"
  mccspec_detector_19_exit_volume_visualize = 1;
#line 71 "MACS_sample_kidney_box.instr"
  mccspec_detector_19_exit_volume_target_index = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccspec_detector_19_exit_volume_target_x = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccspec_detector_19_exit_volume_target_y = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccspec_detector_19_exit_volume_target_z = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccspec_detector_19_exit_volume_focus_aw = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccspec_detector_19_exit_volume_focus_ah = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccspec_detector_19_exit_volume_focus_xw = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccspec_detector_19_exit_volume_focus_xh = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccspec_detector_19_exit_volume_focus_r = 0;
#line 71 "MACS_sample_kidney_box.instr"
  mccspec_detector_19_exit_volume_p_interact = 0;
#line 71 "MACS_sample_kidney_box.instr"
  if(0) strncpy(mccspec_detector_19_exit_volume_mask_string, 0 ? 0 : "", 16384); else mccspec_detector_19_exit_volume_mask_string[0]='\0';
#line 71 "MACS_sample_kidney_box.instr"
  if(0) strncpy(mccspec_detector_19_exit_volume_mask_setting, 0 ? 0 : "", 16384); else mccspec_detector_19_exit_volume_mask_setting[0]='\0';
#line 71 "MACS_sample_kidney_box.instr"
  mccspec_detector_19_exit_volume_number_of_activations = 1;
#line 150061 "MACS_sample_kidney_box.c"

  SIG_MESSAGE("spec_detector_19_exit_volume (Init:Place/Rotate)");
  rot_set_rotation(mctr1,
#line 4962 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 4962 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 4962 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD);
#line 150071 "MACS_sample_kidney_box.c"
  rot_mul(mctr1, mcrotachannel_19_analyzer_2_center, mcrotaspec_detector_19_exit_volume);
  rot_transpose(mcrotadiffraction_detector_19_exit_volume, mctr1);
  rot_mul(mcrotaspec_detector_19_exit_volume, mctr1, mcrotrspec_detector_19_exit_volume);
  mctc1 = coords_set(
#line 4961 "MACS_sample_kidney_box.instr"
    0,
#line 4961 "MACS_sample_kidney_box.instr"
    0,
#line 4961 "MACS_sample_kidney_box.instr"
    0);
#line 150082 "MACS_sample_kidney_box.c"
  rot_transpose(mcrotachannel_19_cave2_cyl1, mctr1);
  mctc2 = rot_apply(mctr1, mctc1);
  mcposaspec_detector_19_exit_volume = coords_add(mcposachannel_19_cave2_cyl1, mctc2);
  mctc1 = coords_sub(mcposadiffraction_detector_19_exit_volume, mcposaspec_detector_19_exit_volume);
  mcposrspec_detector_19_exit_volume = rot_apply(mcrotaspec_detector_19_exit_volume, mctc1);
  mcDEBUG_COMPONENT("spec_detector_19_exit_volume", mcposaspec_detector_19_exit_volume, mcrotaspec_detector_19_exit_volume)
  mccomp_posa[883] = mcposaspec_detector_19_exit_volume;
  mccomp_posr[883] = mcposrspec_detector_19_exit_volume;
  mcNCounter[883]  = mcPCounter[883] = mcP2Counter[883] = 0;
  mcAbsorbProp[883]= 0;
    /* Component kidney_union_master. */
  /* Setting parameters for component kidney_union_master. */
  SIG_MESSAGE("kidney_union_master (Init:SetPar)");
#line 45 "MACS_sample_kidney_box.instr"
  mcckidney_union_master_allow_inside_start = 0;
#line 45 "MACS_sample_kidney_box.instr"
  mcckidney_union_master_history_limit = 300000;
#line 45 "MACS_sample_kidney_box.instr"
  mcckidney_union_master_enable_conditionals = 1;
#line 4964 "MACS_sample_kidney_box.instr"
  mcckidney_union_master_inherit_number_of_scattering_events = 1;
#line 150104 "MACS_sample_kidney_box.c"

  SIG_MESSAGE("kidney_union_master (Init:Place/Rotate)");
  rot_set_rotation(mctr1,
    (0.0)*DEG2RAD,
    (0.0)*DEG2RAD,
    (0.0)*DEG2RAD);
#line 150111 "MACS_sample_kidney_box.c"
  rot_mul(mctr1, mcrotatarget, mcrotakidney_union_master);
  rot_transpose(mcrotaspec_detector_19_exit_volume, mctr1);
  rot_mul(mcrotakidney_union_master, mctr1, mcrotrkidney_union_master);
  mctc1 = coords_set(
#line 4965 "MACS_sample_kidney_box.instr"
    0,
#line 4965 "MACS_sample_kidney_box.instr"
    0,
#line 4965 "MACS_sample_kidney_box.instr"
    0);
#line 150122 "MACS_sample_kidney_box.c"
  rot_transpose(mcrotatarget, mctr1);
  mctc2 = rot_apply(mctr1, mctc1);
  mcposakidney_union_master = coords_add(mcposatarget, mctc2);
  mctc1 = coords_sub(mcposaspec_detector_19_exit_volume, mcposakidney_union_master);
  mcposrkidney_union_master = rot_apply(mcrotakidney_union_master, mctc1);
  mcDEBUG_COMPONENT("kidney_union_master", mcposakidney_union_master, mcrotakidney_union_master)
  mccomp_posa[884] = mcposakidney_union_master;
  mccomp_posr[884] = mcposrkidney_union_master;
  mcNCounter[884]  = mcPCounter[884] = mcP2Counter[884] = 0;
  mcAbsorbProp[884]= 0;
    /* Component diffraction_detector_0. */
  /* Setting parameters for component diffraction_detector_0. */
  SIG_MESSAGE("diffraction_detector_0 (Init:SetPar)");
#line 4969 "MACS_sample_kidney_box.instr"
  mccdiffraction_detector_0_nx = 5;
#line 4969 "MACS_sample_kidney_box.instr"
  mccdiffraction_detector_0_ny = 5;
#line 4969 "MACS_sample_kidney_box.instr"
  if("diff_detector_0") strncpy(mccdiffraction_detector_0_filename, "diff_detector_0" ? "diff_detector_0" : "", 16384); else mccdiffraction_detector_0_filename[0]='\0';
#line 50 "MACS_sample_kidney_box.instr"
  mccdiffraction_detector_0_xmin = -0.05;
#line 50 "MACS_sample_kidney_box.instr"
  mccdiffraction_detector_0_xmax = 0.05;
#line 50 "MACS_sample_kidney_box.instr"
  mccdiffraction_detector_0_ymin = -0.05;
#line 50 "MACS_sample_kidney_box.instr"
  mccdiffraction_detector_0_ymax = 0.05;
#line 4968 "MACS_sample_kidney_box.instr"
  mccdiffraction_detector_0_xwidth = 2.0 * detector_radius;
#line 4968 "MACS_sample_kidney_box.instr"
  mccdiffraction_detector_0_yheight = 1.0 * detector_height;
#line 4968 "MACS_sample_kidney_box.instr"
  mccdiffraction_detector_0_restore_neutron = 1;
#line 150156 "MACS_sample_kidney_box.c"

  SIG_MESSAGE("diffraction_detector_0 (Init:Place/Rotate)");
  rot_set_rotation(mctr1,
#line 4971 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 4971 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 4971 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD);
#line 150166 "MACS_sample_kidney_box.c"
  rot_mul(mctr1, mcrotadiffraction_detector_0_exit_volume, mcrotadiffraction_detector_0);
  rot_transpose(mcrotakidney_union_master, mctr1);
  rot_mul(mcrotadiffraction_detector_0, mctr1, mcrotrdiffraction_detector_0);
  mctc1 = coords_set(
#line 4970 "MACS_sample_kidney_box.instr"
    0,
#line 4970 "MACS_sample_kidney_box.instr"
    0,
#line 4970 "MACS_sample_kidney_box.instr"
    0);
#line 150177 "MACS_sample_kidney_box.c"
  rot_transpose(mcrotadiffraction_detector_0_exit_volume, mctr1);
  mctc2 = rot_apply(mctr1, mctc1);
  mcposadiffraction_detector_0 = coords_add(mcposadiffraction_detector_0_exit_volume, mctc2);
  mctc1 = coords_sub(mcposakidney_union_master, mcposadiffraction_detector_0);
  mcposrdiffraction_detector_0 = rot_apply(mcrotadiffraction_detector_0, mctc1);
  mcDEBUG_COMPONENT("diffraction_detector_0", mcposadiffraction_detector_0, mcrotadiffraction_detector_0)
  mccomp_posa[885] = mcposadiffraction_detector_0;
  mccomp_posr[885] = mcposrdiffraction_detector_0;
  mcNCounter[885]  = mcPCounter[885] = mcP2Counter[885] = 0;
  mcAbsorbProp[885]= 0;
    /* Component spec_detector_0. */
  /* Setting parameters for component spec_detector_0. */
  SIG_MESSAGE("spec_detector_0 (Init:SetPar)");
#line 4983 "MACS_sample_kidney_box.instr"
  mccspec_detector_0_nx = 5;
#line 4983 "MACS_sample_kidney_box.instr"
  mccspec_detector_0_ny = 5;
#line 4983 "MACS_sample_kidney_box.instr"
  if("spec_detector_0") strncpy(mccspec_detector_0_filename, "spec_detector_0" ? "spec_detector_0" : "", 16384); else mccspec_detector_0_filename[0]='\0';
#line 50 "MACS_sample_kidney_box.instr"
  mccspec_detector_0_xmin = -0.05;
#line 50 "MACS_sample_kidney_box.instr"
  mccspec_detector_0_xmax = 0.05;
#line 50 "MACS_sample_kidney_box.instr"
  mccspec_detector_0_ymin = -0.05;
#line 50 "MACS_sample_kidney_box.instr"
  mccspec_detector_0_ymax = 0.05;
#line 4982 "MACS_sample_kidney_box.instr"
  mccspec_detector_0_xwidth = 2.0 * detector_radius;
#line 4982 "MACS_sample_kidney_box.instr"
  mccspec_detector_0_yheight = 1.0 * detector_height;
#line 4982 "MACS_sample_kidney_box.instr"
  mccspec_detector_0_restore_neutron = 1;
#line 150211 "MACS_sample_kidney_box.c"

  SIG_MESSAGE("spec_detector_0 (Init:Place/Rotate)");
  rot_set_rotation(mctr1,
#line 4985 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 4985 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 4985 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD);
#line 150221 "MACS_sample_kidney_box.c"
  rot_mul(mctr1, mcrotaspec_detector_0_exit_volume, mcrotaspec_detector_0);
  rot_transpose(mcrotadiffraction_detector_0, mctr1);
  rot_mul(mcrotaspec_detector_0, mctr1, mcrotrspec_detector_0);
  mctc1 = coords_set(
#line 4984 "MACS_sample_kidney_box.instr"
    0,
#line 4984 "MACS_sample_kidney_box.instr"
    0,
#line 4984 "MACS_sample_kidney_box.instr"
    0);
#line 150232 "MACS_sample_kidney_box.c"
  rot_transpose(mcrotaspec_detector_0_exit_volume, mctr1);
  mctc2 = rot_apply(mctr1, mctc1);
  mcposaspec_detector_0 = coords_add(mcposaspec_detector_0_exit_volume, mctc2);
  mctc1 = coords_sub(mcposadiffraction_detector_0, mcposaspec_detector_0);
  mcposrspec_detector_0 = rot_apply(mcrotaspec_detector_0, mctc1);
  mcDEBUG_COMPONENT("spec_detector_0", mcposaspec_detector_0, mcrotaspec_detector_0)
  mccomp_posa[886] = mcposaspec_detector_0;
  mccomp_posr[886] = mcposrspec_detector_0;
  mcNCounter[886]  = mcPCounter[886] = mcP2Counter[886] = 0;
  mcAbsorbProp[886]= 0;
    /* Component diffraction_detector_1. */
  /* Setting parameters for component diffraction_detector_1. */
  SIG_MESSAGE("diffraction_detector_1 (Init:SetPar)");
#line 4997 "MACS_sample_kidney_box.instr"
  mccdiffraction_detector_1_nx = 5;
#line 4997 "MACS_sample_kidney_box.instr"
  mccdiffraction_detector_1_ny = 5;
#line 4997 "MACS_sample_kidney_box.instr"
  if("diff_detector_1") strncpy(mccdiffraction_detector_1_filename, "diff_detector_1" ? "diff_detector_1" : "", 16384); else mccdiffraction_detector_1_filename[0]='\0';
#line 50 "MACS_sample_kidney_box.instr"
  mccdiffraction_detector_1_xmin = -0.05;
#line 50 "MACS_sample_kidney_box.instr"
  mccdiffraction_detector_1_xmax = 0.05;
#line 50 "MACS_sample_kidney_box.instr"
  mccdiffraction_detector_1_ymin = -0.05;
#line 50 "MACS_sample_kidney_box.instr"
  mccdiffraction_detector_1_ymax = 0.05;
#line 4996 "MACS_sample_kidney_box.instr"
  mccdiffraction_detector_1_xwidth = 2.0 * detector_radius;
#line 4996 "MACS_sample_kidney_box.instr"
  mccdiffraction_detector_1_yheight = 1.0 * detector_height;
#line 4996 "MACS_sample_kidney_box.instr"
  mccdiffraction_detector_1_restore_neutron = 1;
#line 150266 "MACS_sample_kidney_box.c"

  SIG_MESSAGE("diffraction_detector_1 (Init:Place/Rotate)");
  rot_set_rotation(mctr1,
#line 4999 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 4999 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 4999 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD);
#line 150276 "MACS_sample_kidney_box.c"
  rot_mul(mctr1, mcrotadiffraction_detector_1_exit_volume, mcrotadiffraction_detector_1);
  rot_transpose(mcrotaspec_detector_0, mctr1);
  rot_mul(mcrotadiffraction_detector_1, mctr1, mcrotrdiffraction_detector_1);
  mctc1 = coords_set(
#line 4998 "MACS_sample_kidney_box.instr"
    0,
#line 4998 "MACS_sample_kidney_box.instr"
    0,
#line 4998 "MACS_sample_kidney_box.instr"
    0);
#line 150287 "MACS_sample_kidney_box.c"
  rot_transpose(mcrotadiffraction_detector_1_exit_volume, mctr1);
  mctc2 = rot_apply(mctr1, mctc1);
  mcposadiffraction_detector_1 = coords_add(mcposadiffraction_detector_1_exit_volume, mctc2);
  mctc1 = coords_sub(mcposaspec_detector_0, mcposadiffraction_detector_1);
  mcposrdiffraction_detector_1 = rot_apply(mcrotadiffraction_detector_1, mctc1);
  mcDEBUG_COMPONENT("diffraction_detector_1", mcposadiffraction_detector_1, mcrotadiffraction_detector_1)
  mccomp_posa[887] = mcposadiffraction_detector_1;
  mccomp_posr[887] = mcposrdiffraction_detector_1;
  mcNCounter[887]  = mcPCounter[887] = mcP2Counter[887] = 0;
  mcAbsorbProp[887]= 0;
    /* Component spec_detector_1. */
  /* Setting parameters for component spec_detector_1. */
  SIG_MESSAGE("spec_detector_1 (Init:SetPar)");
#line 5011 "MACS_sample_kidney_box.instr"
  mccspec_detector_1_nx = 5;
#line 5011 "MACS_sample_kidney_box.instr"
  mccspec_detector_1_ny = 5;
#line 5011 "MACS_sample_kidney_box.instr"
  if("spec_detector_1") strncpy(mccspec_detector_1_filename, "spec_detector_1" ? "spec_detector_1" : "", 16384); else mccspec_detector_1_filename[0]='\0';
#line 50 "MACS_sample_kidney_box.instr"
  mccspec_detector_1_xmin = -0.05;
#line 50 "MACS_sample_kidney_box.instr"
  mccspec_detector_1_xmax = 0.05;
#line 50 "MACS_sample_kidney_box.instr"
  mccspec_detector_1_ymin = -0.05;
#line 50 "MACS_sample_kidney_box.instr"
  mccspec_detector_1_ymax = 0.05;
#line 5010 "MACS_sample_kidney_box.instr"
  mccspec_detector_1_xwidth = 2.0 * detector_radius;
#line 5010 "MACS_sample_kidney_box.instr"
  mccspec_detector_1_yheight = 1.0 * detector_height;
#line 5010 "MACS_sample_kidney_box.instr"
  mccspec_detector_1_restore_neutron = 1;
#line 150321 "MACS_sample_kidney_box.c"

  SIG_MESSAGE("spec_detector_1 (Init:Place/Rotate)");
  rot_set_rotation(mctr1,
#line 5013 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 5013 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 5013 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD);
#line 150331 "MACS_sample_kidney_box.c"
  rot_mul(mctr1, mcrotaspec_detector_1_exit_volume, mcrotaspec_detector_1);
  rot_transpose(mcrotadiffraction_detector_1, mctr1);
  rot_mul(mcrotaspec_detector_1, mctr1, mcrotrspec_detector_1);
  mctc1 = coords_set(
#line 5012 "MACS_sample_kidney_box.instr"
    0,
#line 5012 "MACS_sample_kidney_box.instr"
    0,
#line 5012 "MACS_sample_kidney_box.instr"
    0);
#line 150342 "MACS_sample_kidney_box.c"
  rot_transpose(mcrotaspec_detector_1_exit_volume, mctr1);
  mctc2 = rot_apply(mctr1, mctc1);
  mcposaspec_detector_1 = coords_add(mcposaspec_detector_1_exit_volume, mctc2);
  mctc1 = coords_sub(mcposadiffraction_detector_1, mcposaspec_detector_1);
  mcposrspec_detector_1 = rot_apply(mcrotaspec_detector_1, mctc1);
  mcDEBUG_COMPONENT("spec_detector_1", mcposaspec_detector_1, mcrotaspec_detector_1)
  mccomp_posa[888] = mcposaspec_detector_1;
  mccomp_posr[888] = mcposrspec_detector_1;
  mcNCounter[888]  = mcPCounter[888] = mcP2Counter[888] = 0;
  mcAbsorbProp[888]= 0;
    /* Component diffraction_detector_2. */
  /* Setting parameters for component diffraction_detector_2. */
  SIG_MESSAGE("diffraction_detector_2 (Init:SetPar)");
#line 5025 "MACS_sample_kidney_box.instr"
  mccdiffraction_detector_2_nx = 5;
#line 5025 "MACS_sample_kidney_box.instr"
  mccdiffraction_detector_2_ny = 5;
#line 5025 "MACS_sample_kidney_box.instr"
  if("diff_detector_2") strncpy(mccdiffraction_detector_2_filename, "diff_detector_2" ? "diff_detector_2" : "", 16384); else mccdiffraction_detector_2_filename[0]='\0';
#line 50 "MACS_sample_kidney_box.instr"
  mccdiffraction_detector_2_xmin = -0.05;
#line 50 "MACS_sample_kidney_box.instr"
  mccdiffraction_detector_2_xmax = 0.05;
#line 50 "MACS_sample_kidney_box.instr"
  mccdiffraction_detector_2_ymin = -0.05;
#line 50 "MACS_sample_kidney_box.instr"
  mccdiffraction_detector_2_ymax = 0.05;
#line 5024 "MACS_sample_kidney_box.instr"
  mccdiffraction_detector_2_xwidth = 2.0 * detector_radius;
#line 5024 "MACS_sample_kidney_box.instr"
  mccdiffraction_detector_2_yheight = 1.0 * detector_height;
#line 5024 "MACS_sample_kidney_box.instr"
  mccdiffraction_detector_2_restore_neutron = 1;
#line 150376 "MACS_sample_kidney_box.c"

  SIG_MESSAGE("diffraction_detector_2 (Init:Place/Rotate)");
  rot_set_rotation(mctr1,
#line 5027 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 5027 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 5027 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD);
#line 150386 "MACS_sample_kidney_box.c"
  rot_mul(mctr1, mcrotadiffraction_detector_2_exit_volume, mcrotadiffraction_detector_2);
  rot_transpose(mcrotaspec_detector_1, mctr1);
  rot_mul(mcrotadiffraction_detector_2, mctr1, mcrotrdiffraction_detector_2);
  mctc1 = coords_set(
#line 5026 "MACS_sample_kidney_box.instr"
    0,
#line 5026 "MACS_sample_kidney_box.instr"
    0,
#line 5026 "MACS_sample_kidney_box.instr"
    0);
#line 150397 "MACS_sample_kidney_box.c"
  rot_transpose(mcrotadiffraction_detector_2_exit_volume, mctr1);
  mctc2 = rot_apply(mctr1, mctc1);
  mcposadiffraction_detector_2 = coords_add(mcposadiffraction_detector_2_exit_volume, mctc2);
  mctc1 = coords_sub(mcposaspec_detector_1, mcposadiffraction_detector_2);
  mcposrdiffraction_detector_2 = rot_apply(mcrotadiffraction_detector_2, mctc1);
  mcDEBUG_COMPONENT("diffraction_detector_2", mcposadiffraction_detector_2, mcrotadiffraction_detector_2)
  mccomp_posa[889] = mcposadiffraction_detector_2;
  mccomp_posr[889] = mcposrdiffraction_detector_2;
  mcNCounter[889]  = mcPCounter[889] = mcP2Counter[889] = 0;
  mcAbsorbProp[889]= 0;
    /* Component spec_detector_2. */
  /* Setting parameters for component spec_detector_2. */
  SIG_MESSAGE("spec_detector_2 (Init:SetPar)");
#line 5039 "MACS_sample_kidney_box.instr"
  mccspec_detector_2_nx = 5;
#line 5039 "MACS_sample_kidney_box.instr"
  mccspec_detector_2_ny = 5;
#line 5039 "MACS_sample_kidney_box.instr"
  if("spec_detector_2") strncpy(mccspec_detector_2_filename, "spec_detector_2" ? "spec_detector_2" : "", 16384); else mccspec_detector_2_filename[0]='\0';
#line 50 "MACS_sample_kidney_box.instr"
  mccspec_detector_2_xmin = -0.05;
#line 50 "MACS_sample_kidney_box.instr"
  mccspec_detector_2_xmax = 0.05;
#line 50 "MACS_sample_kidney_box.instr"
  mccspec_detector_2_ymin = -0.05;
#line 50 "MACS_sample_kidney_box.instr"
  mccspec_detector_2_ymax = 0.05;
#line 5038 "MACS_sample_kidney_box.instr"
  mccspec_detector_2_xwidth = 2.0 * detector_radius;
#line 5038 "MACS_sample_kidney_box.instr"
  mccspec_detector_2_yheight = 1.0 * detector_height;
#line 5038 "MACS_sample_kidney_box.instr"
  mccspec_detector_2_restore_neutron = 1;
#line 150431 "MACS_sample_kidney_box.c"

  SIG_MESSAGE("spec_detector_2 (Init:Place/Rotate)");
  rot_set_rotation(mctr1,
#line 5041 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 5041 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 5041 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD);
#line 150441 "MACS_sample_kidney_box.c"
  rot_mul(mctr1, mcrotaspec_detector_2_exit_volume, mcrotaspec_detector_2);
  rot_transpose(mcrotadiffraction_detector_2, mctr1);
  rot_mul(mcrotaspec_detector_2, mctr1, mcrotrspec_detector_2);
  mctc1 = coords_set(
#line 5040 "MACS_sample_kidney_box.instr"
    0,
#line 5040 "MACS_sample_kidney_box.instr"
    0,
#line 5040 "MACS_sample_kidney_box.instr"
    0);
#line 150452 "MACS_sample_kidney_box.c"
  rot_transpose(mcrotaspec_detector_2_exit_volume, mctr1);
  mctc2 = rot_apply(mctr1, mctc1);
  mcposaspec_detector_2 = coords_add(mcposaspec_detector_2_exit_volume, mctc2);
  mctc1 = coords_sub(mcposadiffraction_detector_2, mcposaspec_detector_2);
  mcposrspec_detector_2 = rot_apply(mcrotaspec_detector_2, mctc1);
  mcDEBUG_COMPONENT("spec_detector_2", mcposaspec_detector_2, mcrotaspec_detector_2)
  mccomp_posa[890] = mcposaspec_detector_2;
  mccomp_posr[890] = mcposrspec_detector_2;
  mcNCounter[890]  = mcPCounter[890] = mcP2Counter[890] = 0;
  mcAbsorbProp[890]= 0;
    /* Component diffraction_detector_3. */
  /* Setting parameters for component diffraction_detector_3. */
  SIG_MESSAGE("diffraction_detector_3 (Init:SetPar)");
#line 5053 "MACS_sample_kidney_box.instr"
  mccdiffraction_detector_3_nx = 5;
#line 5053 "MACS_sample_kidney_box.instr"
  mccdiffraction_detector_3_ny = 5;
#line 5053 "MACS_sample_kidney_box.instr"
  if("diff_detector_3") strncpy(mccdiffraction_detector_3_filename, "diff_detector_3" ? "diff_detector_3" : "", 16384); else mccdiffraction_detector_3_filename[0]='\0';
#line 50 "MACS_sample_kidney_box.instr"
  mccdiffraction_detector_3_xmin = -0.05;
#line 50 "MACS_sample_kidney_box.instr"
  mccdiffraction_detector_3_xmax = 0.05;
#line 50 "MACS_sample_kidney_box.instr"
  mccdiffraction_detector_3_ymin = -0.05;
#line 50 "MACS_sample_kidney_box.instr"
  mccdiffraction_detector_3_ymax = 0.05;
#line 5052 "MACS_sample_kidney_box.instr"
  mccdiffraction_detector_3_xwidth = 2.0 * detector_radius;
#line 5052 "MACS_sample_kidney_box.instr"
  mccdiffraction_detector_3_yheight = 1.0 * detector_height;
#line 5052 "MACS_sample_kidney_box.instr"
  mccdiffraction_detector_3_restore_neutron = 1;
#line 150486 "MACS_sample_kidney_box.c"

  SIG_MESSAGE("diffraction_detector_3 (Init:Place/Rotate)");
  rot_set_rotation(mctr1,
#line 5055 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 5055 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 5055 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD);
#line 150496 "MACS_sample_kidney_box.c"
  rot_mul(mctr1, mcrotadiffraction_detector_3_exit_volume, mcrotadiffraction_detector_3);
  rot_transpose(mcrotaspec_detector_2, mctr1);
  rot_mul(mcrotadiffraction_detector_3, mctr1, mcrotrdiffraction_detector_3);
  mctc1 = coords_set(
#line 5054 "MACS_sample_kidney_box.instr"
    0,
#line 5054 "MACS_sample_kidney_box.instr"
    0,
#line 5054 "MACS_sample_kidney_box.instr"
    0);
#line 150507 "MACS_sample_kidney_box.c"
  rot_transpose(mcrotadiffraction_detector_3_exit_volume, mctr1);
  mctc2 = rot_apply(mctr1, mctc1);
  mcposadiffraction_detector_3 = coords_add(mcposadiffraction_detector_3_exit_volume, mctc2);
  mctc1 = coords_sub(mcposaspec_detector_2, mcposadiffraction_detector_3);
  mcposrdiffraction_detector_3 = rot_apply(mcrotadiffraction_detector_3, mctc1);
  mcDEBUG_COMPONENT("diffraction_detector_3", mcposadiffraction_detector_3, mcrotadiffraction_detector_3)
  mccomp_posa[891] = mcposadiffraction_detector_3;
  mccomp_posr[891] = mcposrdiffraction_detector_3;
  mcNCounter[891]  = mcPCounter[891] = mcP2Counter[891] = 0;
  mcAbsorbProp[891]= 0;
    /* Component spec_detector_3. */
  /* Setting parameters for component spec_detector_3. */
  SIG_MESSAGE("spec_detector_3 (Init:SetPar)");
#line 5067 "MACS_sample_kidney_box.instr"
  mccspec_detector_3_nx = 5;
#line 5067 "MACS_sample_kidney_box.instr"
  mccspec_detector_3_ny = 5;
#line 5067 "MACS_sample_kidney_box.instr"
  if("spec_detector_3") strncpy(mccspec_detector_3_filename, "spec_detector_3" ? "spec_detector_3" : "", 16384); else mccspec_detector_3_filename[0]='\0';
#line 50 "MACS_sample_kidney_box.instr"
  mccspec_detector_3_xmin = -0.05;
#line 50 "MACS_sample_kidney_box.instr"
  mccspec_detector_3_xmax = 0.05;
#line 50 "MACS_sample_kidney_box.instr"
  mccspec_detector_3_ymin = -0.05;
#line 50 "MACS_sample_kidney_box.instr"
  mccspec_detector_3_ymax = 0.05;
#line 5066 "MACS_sample_kidney_box.instr"
  mccspec_detector_3_xwidth = 2.0 * detector_radius;
#line 5066 "MACS_sample_kidney_box.instr"
  mccspec_detector_3_yheight = 1.0 * detector_height;
#line 5066 "MACS_sample_kidney_box.instr"
  mccspec_detector_3_restore_neutron = 1;
#line 150541 "MACS_sample_kidney_box.c"

  SIG_MESSAGE("spec_detector_3 (Init:Place/Rotate)");
  rot_set_rotation(mctr1,
#line 5069 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 5069 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 5069 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD);
#line 150551 "MACS_sample_kidney_box.c"
  rot_mul(mctr1, mcrotaspec_detector_3_exit_volume, mcrotaspec_detector_3);
  rot_transpose(mcrotadiffraction_detector_3, mctr1);
  rot_mul(mcrotaspec_detector_3, mctr1, mcrotrspec_detector_3);
  mctc1 = coords_set(
#line 5068 "MACS_sample_kidney_box.instr"
    0,
#line 5068 "MACS_sample_kidney_box.instr"
    0,
#line 5068 "MACS_sample_kidney_box.instr"
    0);
#line 150562 "MACS_sample_kidney_box.c"
  rot_transpose(mcrotaspec_detector_3_exit_volume, mctr1);
  mctc2 = rot_apply(mctr1, mctc1);
  mcposaspec_detector_3 = coords_add(mcposaspec_detector_3_exit_volume, mctc2);
  mctc1 = coords_sub(mcposadiffraction_detector_3, mcposaspec_detector_3);
  mcposrspec_detector_3 = rot_apply(mcrotaspec_detector_3, mctc1);
  mcDEBUG_COMPONENT("spec_detector_3", mcposaspec_detector_3, mcrotaspec_detector_3)
  mccomp_posa[892] = mcposaspec_detector_3;
  mccomp_posr[892] = mcposrspec_detector_3;
  mcNCounter[892]  = mcPCounter[892] = mcP2Counter[892] = 0;
  mcAbsorbProp[892]= 0;
    /* Component diffraction_detector_4. */
  /* Setting parameters for component diffraction_detector_4. */
  SIG_MESSAGE("diffraction_detector_4 (Init:SetPar)");
#line 5081 "MACS_sample_kidney_box.instr"
  mccdiffraction_detector_4_nx = 5;
#line 5081 "MACS_sample_kidney_box.instr"
  mccdiffraction_detector_4_ny = 5;
#line 5081 "MACS_sample_kidney_box.instr"
  if("diff_detector_4") strncpy(mccdiffraction_detector_4_filename, "diff_detector_4" ? "diff_detector_4" : "", 16384); else mccdiffraction_detector_4_filename[0]='\0';
#line 50 "MACS_sample_kidney_box.instr"
  mccdiffraction_detector_4_xmin = -0.05;
#line 50 "MACS_sample_kidney_box.instr"
  mccdiffraction_detector_4_xmax = 0.05;
#line 50 "MACS_sample_kidney_box.instr"
  mccdiffraction_detector_4_ymin = -0.05;
#line 50 "MACS_sample_kidney_box.instr"
  mccdiffraction_detector_4_ymax = 0.05;
#line 5080 "MACS_sample_kidney_box.instr"
  mccdiffraction_detector_4_xwidth = 2.0 * detector_radius;
#line 5080 "MACS_sample_kidney_box.instr"
  mccdiffraction_detector_4_yheight = 1.0 * detector_height;
#line 5080 "MACS_sample_kidney_box.instr"
  mccdiffraction_detector_4_restore_neutron = 1;
#line 150596 "MACS_sample_kidney_box.c"

  SIG_MESSAGE("diffraction_detector_4 (Init:Place/Rotate)");
  rot_set_rotation(mctr1,
#line 5083 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 5083 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 5083 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD);
#line 150606 "MACS_sample_kidney_box.c"
  rot_mul(mctr1, mcrotadiffraction_detector_4_exit_volume, mcrotadiffraction_detector_4);
  rot_transpose(mcrotaspec_detector_3, mctr1);
  rot_mul(mcrotadiffraction_detector_4, mctr1, mcrotrdiffraction_detector_4);
  mctc1 = coords_set(
#line 5082 "MACS_sample_kidney_box.instr"
    0,
#line 5082 "MACS_sample_kidney_box.instr"
    0,
#line 5082 "MACS_sample_kidney_box.instr"
    0);
#line 150617 "MACS_sample_kidney_box.c"
  rot_transpose(mcrotadiffraction_detector_4_exit_volume, mctr1);
  mctc2 = rot_apply(mctr1, mctc1);
  mcposadiffraction_detector_4 = coords_add(mcposadiffraction_detector_4_exit_volume, mctc2);
  mctc1 = coords_sub(mcposaspec_detector_3, mcposadiffraction_detector_4);
  mcposrdiffraction_detector_4 = rot_apply(mcrotadiffraction_detector_4, mctc1);
  mcDEBUG_COMPONENT("diffraction_detector_4", mcposadiffraction_detector_4, mcrotadiffraction_detector_4)
  mccomp_posa[893] = mcposadiffraction_detector_4;
  mccomp_posr[893] = mcposrdiffraction_detector_4;
  mcNCounter[893]  = mcPCounter[893] = mcP2Counter[893] = 0;
  mcAbsorbProp[893]= 0;
    /* Component spec_detector_4. */
  /* Setting parameters for component spec_detector_4. */
  SIG_MESSAGE("spec_detector_4 (Init:SetPar)");
#line 5095 "MACS_sample_kidney_box.instr"
  mccspec_detector_4_nx = 5;
#line 5095 "MACS_sample_kidney_box.instr"
  mccspec_detector_4_ny = 5;
#line 5095 "MACS_sample_kidney_box.instr"
  if("spec_detector_4") strncpy(mccspec_detector_4_filename, "spec_detector_4" ? "spec_detector_4" : "", 16384); else mccspec_detector_4_filename[0]='\0';
#line 50 "MACS_sample_kidney_box.instr"
  mccspec_detector_4_xmin = -0.05;
#line 50 "MACS_sample_kidney_box.instr"
  mccspec_detector_4_xmax = 0.05;
#line 50 "MACS_sample_kidney_box.instr"
  mccspec_detector_4_ymin = -0.05;
#line 50 "MACS_sample_kidney_box.instr"
  mccspec_detector_4_ymax = 0.05;
#line 5094 "MACS_sample_kidney_box.instr"
  mccspec_detector_4_xwidth = 2.0 * detector_radius;
#line 5094 "MACS_sample_kidney_box.instr"
  mccspec_detector_4_yheight = 1.0 * detector_height;
#line 5094 "MACS_sample_kidney_box.instr"
  mccspec_detector_4_restore_neutron = 1;
#line 150651 "MACS_sample_kidney_box.c"

  SIG_MESSAGE("spec_detector_4 (Init:Place/Rotate)");
  rot_set_rotation(mctr1,
#line 5097 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 5097 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 5097 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD);
#line 150661 "MACS_sample_kidney_box.c"
  rot_mul(mctr1, mcrotaspec_detector_4_exit_volume, mcrotaspec_detector_4);
  rot_transpose(mcrotadiffraction_detector_4, mctr1);
  rot_mul(mcrotaspec_detector_4, mctr1, mcrotrspec_detector_4);
  mctc1 = coords_set(
#line 5096 "MACS_sample_kidney_box.instr"
    0,
#line 5096 "MACS_sample_kidney_box.instr"
    0,
#line 5096 "MACS_sample_kidney_box.instr"
    0);
#line 150672 "MACS_sample_kidney_box.c"
  rot_transpose(mcrotaspec_detector_4_exit_volume, mctr1);
  mctc2 = rot_apply(mctr1, mctc1);
  mcposaspec_detector_4 = coords_add(mcposaspec_detector_4_exit_volume, mctc2);
  mctc1 = coords_sub(mcposadiffraction_detector_4, mcposaspec_detector_4);
  mcposrspec_detector_4 = rot_apply(mcrotaspec_detector_4, mctc1);
  mcDEBUG_COMPONENT("spec_detector_4", mcposaspec_detector_4, mcrotaspec_detector_4)
  mccomp_posa[894] = mcposaspec_detector_4;
  mccomp_posr[894] = mcposrspec_detector_4;
  mcNCounter[894]  = mcPCounter[894] = mcP2Counter[894] = 0;
  mcAbsorbProp[894]= 0;
    /* Component diffraction_detector_5. */
  /* Setting parameters for component diffraction_detector_5. */
  SIG_MESSAGE("diffraction_detector_5 (Init:SetPar)");
#line 5109 "MACS_sample_kidney_box.instr"
  mccdiffraction_detector_5_nx = 5;
#line 5109 "MACS_sample_kidney_box.instr"
  mccdiffraction_detector_5_ny = 5;
#line 5109 "MACS_sample_kidney_box.instr"
  if("diff_detector_5") strncpy(mccdiffraction_detector_5_filename, "diff_detector_5" ? "diff_detector_5" : "", 16384); else mccdiffraction_detector_5_filename[0]='\0';
#line 50 "MACS_sample_kidney_box.instr"
  mccdiffraction_detector_5_xmin = -0.05;
#line 50 "MACS_sample_kidney_box.instr"
  mccdiffraction_detector_5_xmax = 0.05;
#line 50 "MACS_sample_kidney_box.instr"
  mccdiffraction_detector_5_ymin = -0.05;
#line 50 "MACS_sample_kidney_box.instr"
  mccdiffraction_detector_5_ymax = 0.05;
#line 5108 "MACS_sample_kidney_box.instr"
  mccdiffraction_detector_5_xwidth = 2.0 * detector_radius;
#line 5108 "MACS_sample_kidney_box.instr"
  mccdiffraction_detector_5_yheight = 1.0 * detector_height;
#line 5108 "MACS_sample_kidney_box.instr"
  mccdiffraction_detector_5_restore_neutron = 1;
#line 150706 "MACS_sample_kidney_box.c"

  SIG_MESSAGE("diffraction_detector_5 (Init:Place/Rotate)");
  rot_set_rotation(mctr1,
#line 5111 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 5111 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 5111 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD);
#line 150716 "MACS_sample_kidney_box.c"
  rot_mul(mctr1, mcrotadiffraction_detector_5_exit_volume, mcrotadiffraction_detector_5);
  rot_transpose(mcrotaspec_detector_4, mctr1);
  rot_mul(mcrotadiffraction_detector_5, mctr1, mcrotrdiffraction_detector_5);
  mctc1 = coords_set(
#line 5110 "MACS_sample_kidney_box.instr"
    0,
#line 5110 "MACS_sample_kidney_box.instr"
    0,
#line 5110 "MACS_sample_kidney_box.instr"
    0);
#line 150727 "MACS_sample_kidney_box.c"
  rot_transpose(mcrotadiffraction_detector_5_exit_volume, mctr1);
  mctc2 = rot_apply(mctr1, mctc1);
  mcposadiffraction_detector_5 = coords_add(mcposadiffraction_detector_5_exit_volume, mctc2);
  mctc1 = coords_sub(mcposaspec_detector_4, mcposadiffraction_detector_5);
  mcposrdiffraction_detector_5 = rot_apply(mcrotadiffraction_detector_5, mctc1);
  mcDEBUG_COMPONENT("diffraction_detector_5", mcposadiffraction_detector_5, mcrotadiffraction_detector_5)
  mccomp_posa[895] = mcposadiffraction_detector_5;
  mccomp_posr[895] = mcposrdiffraction_detector_5;
  mcNCounter[895]  = mcPCounter[895] = mcP2Counter[895] = 0;
  mcAbsorbProp[895]= 0;
    /* Component spec_detector_5. */
  /* Setting parameters for component spec_detector_5. */
  SIG_MESSAGE("spec_detector_5 (Init:SetPar)");
#line 5123 "MACS_sample_kidney_box.instr"
  mccspec_detector_5_nx = 5;
#line 5123 "MACS_sample_kidney_box.instr"
  mccspec_detector_5_ny = 5;
#line 5123 "MACS_sample_kidney_box.instr"
  if("spec_detector_5") strncpy(mccspec_detector_5_filename, "spec_detector_5" ? "spec_detector_5" : "", 16384); else mccspec_detector_5_filename[0]='\0';
#line 50 "MACS_sample_kidney_box.instr"
  mccspec_detector_5_xmin = -0.05;
#line 50 "MACS_sample_kidney_box.instr"
  mccspec_detector_5_xmax = 0.05;
#line 50 "MACS_sample_kidney_box.instr"
  mccspec_detector_5_ymin = -0.05;
#line 50 "MACS_sample_kidney_box.instr"
  mccspec_detector_5_ymax = 0.05;
#line 5122 "MACS_sample_kidney_box.instr"
  mccspec_detector_5_xwidth = 2.0 * detector_radius;
#line 5122 "MACS_sample_kidney_box.instr"
  mccspec_detector_5_yheight = 1.0 * detector_height;
#line 5122 "MACS_sample_kidney_box.instr"
  mccspec_detector_5_restore_neutron = 1;
#line 150761 "MACS_sample_kidney_box.c"

  SIG_MESSAGE("spec_detector_5 (Init:Place/Rotate)");
  rot_set_rotation(mctr1,
#line 5125 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 5125 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 5125 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD);
#line 150771 "MACS_sample_kidney_box.c"
  rot_mul(mctr1, mcrotaspec_detector_5_exit_volume, mcrotaspec_detector_5);
  rot_transpose(mcrotadiffraction_detector_5, mctr1);
  rot_mul(mcrotaspec_detector_5, mctr1, mcrotrspec_detector_5);
  mctc1 = coords_set(
#line 5124 "MACS_sample_kidney_box.instr"
    0,
#line 5124 "MACS_sample_kidney_box.instr"
    0,
#line 5124 "MACS_sample_kidney_box.instr"
    0);
#line 150782 "MACS_sample_kidney_box.c"
  rot_transpose(mcrotaspec_detector_5_exit_volume, mctr1);
  mctc2 = rot_apply(mctr1, mctc1);
  mcposaspec_detector_5 = coords_add(mcposaspec_detector_5_exit_volume, mctc2);
  mctc1 = coords_sub(mcposadiffraction_detector_5, mcposaspec_detector_5);
  mcposrspec_detector_5 = rot_apply(mcrotaspec_detector_5, mctc1);
  mcDEBUG_COMPONENT("spec_detector_5", mcposaspec_detector_5, mcrotaspec_detector_5)
  mccomp_posa[896] = mcposaspec_detector_5;
  mccomp_posr[896] = mcposrspec_detector_5;
  mcNCounter[896]  = mcPCounter[896] = mcP2Counter[896] = 0;
  mcAbsorbProp[896]= 0;
    /* Component diffraction_detector_6. */
  /* Setting parameters for component diffraction_detector_6. */
  SIG_MESSAGE("diffraction_detector_6 (Init:SetPar)");
#line 5137 "MACS_sample_kidney_box.instr"
  mccdiffraction_detector_6_nx = 5;
#line 5137 "MACS_sample_kidney_box.instr"
  mccdiffraction_detector_6_ny = 5;
#line 5137 "MACS_sample_kidney_box.instr"
  if("diff_detector_6") strncpy(mccdiffraction_detector_6_filename, "diff_detector_6" ? "diff_detector_6" : "", 16384); else mccdiffraction_detector_6_filename[0]='\0';
#line 50 "MACS_sample_kidney_box.instr"
  mccdiffraction_detector_6_xmin = -0.05;
#line 50 "MACS_sample_kidney_box.instr"
  mccdiffraction_detector_6_xmax = 0.05;
#line 50 "MACS_sample_kidney_box.instr"
  mccdiffraction_detector_6_ymin = -0.05;
#line 50 "MACS_sample_kidney_box.instr"
  mccdiffraction_detector_6_ymax = 0.05;
#line 5136 "MACS_sample_kidney_box.instr"
  mccdiffraction_detector_6_xwidth = 2.0 * detector_radius;
#line 5136 "MACS_sample_kidney_box.instr"
  mccdiffraction_detector_6_yheight = 1.0 * detector_height;
#line 5136 "MACS_sample_kidney_box.instr"
  mccdiffraction_detector_6_restore_neutron = 1;
#line 150816 "MACS_sample_kidney_box.c"

  SIG_MESSAGE("diffraction_detector_6 (Init:Place/Rotate)");
  rot_set_rotation(mctr1,
#line 5139 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 5139 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 5139 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD);
#line 150826 "MACS_sample_kidney_box.c"
  rot_mul(mctr1, mcrotadiffraction_detector_6_exit_volume, mcrotadiffraction_detector_6);
  rot_transpose(mcrotaspec_detector_5, mctr1);
  rot_mul(mcrotadiffraction_detector_6, mctr1, mcrotrdiffraction_detector_6);
  mctc1 = coords_set(
#line 5138 "MACS_sample_kidney_box.instr"
    0,
#line 5138 "MACS_sample_kidney_box.instr"
    0,
#line 5138 "MACS_sample_kidney_box.instr"
    0);
#line 150837 "MACS_sample_kidney_box.c"
  rot_transpose(mcrotadiffraction_detector_6_exit_volume, mctr1);
  mctc2 = rot_apply(mctr1, mctc1);
  mcposadiffraction_detector_6 = coords_add(mcposadiffraction_detector_6_exit_volume, mctc2);
  mctc1 = coords_sub(mcposaspec_detector_5, mcposadiffraction_detector_6);
  mcposrdiffraction_detector_6 = rot_apply(mcrotadiffraction_detector_6, mctc1);
  mcDEBUG_COMPONENT("diffraction_detector_6", mcposadiffraction_detector_6, mcrotadiffraction_detector_6)
  mccomp_posa[897] = mcposadiffraction_detector_6;
  mccomp_posr[897] = mcposrdiffraction_detector_6;
  mcNCounter[897]  = mcPCounter[897] = mcP2Counter[897] = 0;
  mcAbsorbProp[897]= 0;
    /* Component spec_detector_6. */
  /* Setting parameters for component spec_detector_6. */
  SIG_MESSAGE("spec_detector_6 (Init:SetPar)");
#line 5151 "MACS_sample_kidney_box.instr"
  mccspec_detector_6_nx = 5;
#line 5151 "MACS_sample_kidney_box.instr"
  mccspec_detector_6_ny = 5;
#line 5151 "MACS_sample_kidney_box.instr"
  if("spec_detector_6") strncpy(mccspec_detector_6_filename, "spec_detector_6" ? "spec_detector_6" : "", 16384); else mccspec_detector_6_filename[0]='\0';
#line 50 "MACS_sample_kidney_box.instr"
  mccspec_detector_6_xmin = -0.05;
#line 50 "MACS_sample_kidney_box.instr"
  mccspec_detector_6_xmax = 0.05;
#line 50 "MACS_sample_kidney_box.instr"
  mccspec_detector_6_ymin = -0.05;
#line 50 "MACS_sample_kidney_box.instr"
  mccspec_detector_6_ymax = 0.05;
#line 5150 "MACS_sample_kidney_box.instr"
  mccspec_detector_6_xwidth = 2.0 * detector_radius;
#line 5150 "MACS_sample_kidney_box.instr"
  mccspec_detector_6_yheight = 1.0 * detector_height;
#line 5150 "MACS_sample_kidney_box.instr"
  mccspec_detector_6_restore_neutron = 1;
#line 150871 "MACS_sample_kidney_box.c"

  SIG_MESSAGE("spec_detector_6 (Init:Place/Rotate)");
  rot_set_rotation(mctr1,
#line 5153 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 5153 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 5153 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD);
#line 150881 "MACS_sample_kidney_box.c"
  rot_mul(mctr1, mcrotaspec_detector_6_exit_volume, mcrotaspec_detector_6);
  rot_transpose(mcrotadiffraction_detector_6, mctr1);
  rot_mul(mcrotaspec_detector_6, mctr1, mcrotrspec_detector_6);
  mctc1 = coords_set(
#line 5152 "MACS_sample_kidney_box.instr"
    0,
#line 5152 "MACS_sample_kidney_box.instr"
    0,
#line 5152 "MACS_sample_kidney_box.instr"
    0);
#line 150892 "MACS_sample_kidney_box.c"
  rot_transpose(mcrotaspec_detector_6_exit_volume, mctr1);
  mctc2 = rot_apply(mctr1, mctc1);
  mcposaspec_detector_6 = coords_add(mcposaspec_detector_6_exit_volume, mctc2);
  mctc1 = coords_sub(mcposadiffraction_detector_6, mcposaspec_detector_6);
  mcposrspec_detector_6 = rot_apply(mcrotaspec_detector_6, mctc1);
  mcDEBUG_COMPONENT("spec_detector_6", mcposaspec_detector_6, mcrotaspec_detector_6)
  mccomp_posa[898] = mcposaspec_detector_6;
  mccomp_posr[898] = mcposrspec_detector_6;
  mcNCounter[898]  = mcPCounter[898] = mcP2Counter[898] = 0;
  mcAbsorbProp[898]= 0;
    /* Component diffraction_detector_7. */
  /* Setting parameters for component diffraction_detector_7. */
  SIG_MESSAGE("diffraction_detector_7 (Init:SetPar)");
#line 5165 "MACS_sample_kidney_box.instr"
  mccdiffraction_detector_7_nx = 5;
#line 5165 "MACS_sample_kidney_box.instr"
  mccdiffraction_detector_7_ny = 5;
#line 5165 "MACS_sample_kidney_box.instr"
  if("diff_detector_7") strncpy(mccdiffraction_detector_7_filename, "diff_detector_7" ? "diff_detector_7" : "", 16384); else mccdiffraction_detector_7_filename[0]='\0';
#line 50 "MACS_sample_kidney_box.instr"
  mccdiffraction_detector_7_xmin = -0.05;
#line 50 "MACS_sample_kidney_box.instr"
  mccdiffraction_detector_7_xmax = 0.05;
#line 50 "MACS_sample_kidney_box.instr"
  mccdiffraction_detector_7_ymin = -0.05;
#line 50 "MACS_sample_kidney_box.instr"
  mccdiffraction_detector_7_ymax = 0.05;
#line 5164 "MACS_sample_kidney_box.instr"
  mccdiffraction_detector_7_xwidth = 2.0 * detector_radius;
#line 5164 "MACS_sample_kidney_box.instr"
  mccdiffraction_detector_7_yheight = 1.0 * detector_height;
#line 5164 "MACS_sample_kidney_box.instr"
  mccdiffraction_detector_7_restore_neutron = 1;
#line 150926 "MACS_sample_kidney_box.c"

  SIG_MESSAGE("diffraction_detector_7 (Init:Place/Rotate)");
  rot_set_rotation(mctr1,
#line 5167 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 5167 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 5167 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD);
#line 150936 "MACS_sample_kidney_box.c"
  rot_mul(mctr1, mcrotadiffraction_detector_7_exit_volume, mcrotadiffraction_detector_7);
  rot_transpose(mcrotaspec_detector_6, mctr1);
  rot_mul(mcrotadiffraction_detector_7, mctr1, mcrotrdiffraction_detector_7);
  mctc1 = coords_set(
#line 5166 "MACS_sample_kidney_box.instr"
    0,
#line 5166 "MACS_sample_kidney_box.instr"
    0,
#line 5166 "MACS_sample_kidney_box.instr"
    0);
#line 150947 "MACS_sample_kidney_box.c"
  rot_transpose(mcrotadiffraction_detector_7_exit_volume, mctr1);
  mctc2 = rot_apply(mctr1, mctc1);
  mcposadiffraction_detector_7 = coords_add(mcposadiffraction_detector_7_exit_volume, mctc2);
  mctc1 = coords_sub(mcposaspec_detector_6, mcposadiffraction_detector_7);
  mcposrdiffraction_detector_7 = rot_apply(mcrotadiffraction_detector_7, mctc1);
  mcDEBUG_COMPONENT("diffraction_detector_7", mcposadiffraction_detector_7, mcrotadiffraction_detector_7)
  mccomp_posa[899] = mcposadiffraction_detector_7;
  mccomp_posr[899] = mcposrdiffraction_detector_7;
  mcNCounter[899]  = mcPCounter[899] = mcP2Counter[899] = 0;
  mcAbsorbProp[899]= 0;
    /* Component spec_detector_7. */
  /* Setting parameters for component spec_detector_7. */
  SIG_MESSAGE("spec_detector_7 (Init:SetPar)");
#line 5179 "MACS_sample_kidney_box.instr"
  mccspec_detector_7_nx = 5;
#line 5179 "MACS_sample_kidney_box.instr"
  mccspec_detector_7_ny = 5;
#line 5179 "MACS_sample_kidney_box.instr"
  if("spec_detector_7") strncpy(mccspec_detector_7_filename, "spec_detector_7" ? "spec_detector_7" : "", 16384); else mccspec_detector_7_filename[0]='\0';
#line 50 "MACS_sample_kidney_box.instr"
  mccspec_detector_7_xmin = -0.05;
#line 50 "MACS_sample_kidney_box.instr"
  mccspec_detector_7_xmax = 0.05;
#line 50 "MACS_sample_kidney_box.instr"
  mccspec_detector_7_ymin = -0.05;
#line 50 "MACS_sample_kidney_box.instr"
  mccspec_detector_7_ymax = 0.05;
#line 5178 "MACS_sample_kidney_box.instr"
  mccspec_detector_7_xwidth = 2.0 * detector_radius;
#line 5178 "MACS_sample_kidney_box.instr"
  mccspec_detector_7_yheight = 1.0 * detector_height;
#line 5178 "MACS_sample_kidney_box.instr"
  mccspec_detector_7_restore_neutron = 1;
#line 150981 "MACS_sample_kidney_box.c"

  SIG_MESSAGE("spec_detector_7 (Init:Place/Rotate)");
  rot_set_rotation(mctr1,
#line 5181 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 5181 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 5181 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD);
#line 150991 "MACS_sample_kidney_box.c"
  rot_mul(mctr1, mcrotaspec_detector_7_exit_volume, mcrotaspec_detector_7);
  rot_transpose(mcrotadiffraction_detector_7, mctr1);
  rot_mul(mcrotaspec_detector_7, mctr1, mcrotrspec_detector_7);
  mctc1 = coords_set(
#line 5180 "MACS_sample_kidney_box.instr"
    0,
#line 5180 "MACS_sample_kidney_box.instr"
    0,
#line 5180 "MACS_sample_kidney_box.instr"
    0);
#line 151002 "MACS_sample_kidney_box.c"
  rot_transpose(mcrotaspec_detector_7_exit_volume, mctr1);
  mctc2 = rot_apply(mctr1, mctc1);
  mcposaspec_detector_7 = coords_add(mcposaspec_detector_7_exit_volume, mctc2);
  mctc1 = coords_sub(mcposadiffraction_detector_7, mcposaspec_detector_7);
  mcposrspec_detector_7 = rot_apply(mcrotaspec_detector_7, mctc1);
  mcDEBUG_COMPONENT("spec_detector_7", mcposaspec_detector_7, mcrotaspec_detector_7)
  mccomp_posa[900] = mcposaspec_detector_7;
  mccomp_posr[900] = mcposrspec_detector_7;
  mcNCounter[900]  = mcPCounter[900] = mcP2Counter[900] = 0;
  mcAbsorbProp[900]= 0;
    /* Component diffraction_detector_8. */
  /* Setting parameters for component diffraction_detector_8. */
  SIG_MESSAGE("diffraction_detector_8 (Init:SetPar)");
#line 5193 "MACS_sample_kidney_box.instr"
  mccdiffraction_detector_8_nx = 5;
#line 5193 "MACS_sample_kidney_box.instr"
  mccdiffraction_detector_8_ny = 5;
#line 5193 "MACS_sample_kidney_box.instr"
  if("diff_detector_8") strncpy(mccdiffraction_detector_8_filename, "diff_detector_8" ? "diff_detector_8" : "", 16384); else mccdiffraction_detector_8_filename[0]='\0';
#line 50 "MACS_sample_kidney_box.instr"
  mccdiffraction_detector_8_xmin = -0.05;
#line 50 "MACS_sample_kidney_box.instr"
  mccdiffraction_detector_8_xmax = 0.05;
#line 50 "MACS_sample_kidney_box.instr"
  mccdiffraction_detector_8_ymin = -0.05;
#line 50 "MACS_sample_kidney_box.instr"
  mccdiffraction_detector_8_ymax = 0.05;
#line 5192 "MACS_sample_kidney_box.instr"
  mccdiffraction_detector_8_xwidth = 2.0 * detector_radius;
#line 5192 "MACS_sample_kidney_box.instr"
  mccdiffraction_detector_8_yheight = 1.0 * detector_height;
#line 5192 "MACS_sample_kidney_box.instr"
  mccdiffraction_detector_8_restore_neutron = 1;
#line 151036 "MACS_sample_kidney_box.c"

  SIG_MESSAGE("diffraction_detector_8 (Init:Place/Rotate)");
  rot_set_rotation(mctr1,
#line 5195 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 5195 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 5195 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD);
#line 151046 "MACS_sample_kidney_box.c"
  rot_mul(mctr1, mcrotadiffraction_detector_8_exit_volume, mcrotadiffraction_detector_8);
  rot_transpose(mcrotaspec_detector_7, mctr1);
  rot_mul(mcrotadiffraction_detector_8, mctr1, mcrotrdiffraction_detector_8);
  mctc1 = coords_set(
#line 5194 "MACS_sample_kidney_box.instr"
    0,
#line 5194 "MACS_sample_kidney_box.instr"
    0,
#line 5194 "MACS_sample_kidney_box.instr"
    0);
#line 151057 "MACS_sample_kidney_box.c"
  rot_transpose(mcrotadiffraction_detector_8_exit_volume, mctr1);
  mctc2 = rot_apply(mctr1, mctc1);
  mcposadiffraction_detector_8 = coords_add(mcposadiffraction_detector_8_exit_volume, mctc2);
  mctc1 = coords_sub(mcposaspec_detector_7, mcposadiffraction_detector_8);
  mcposrdiffraction_detector_8 = rot_apply(mcrotadiffraction_detector_8, mctc1);
  mcDEBUG_COMPONENT("diffraction_detector_8", mcposadiffraction_detector_8, mcrotadiffraction_detector_8)
  mccomp_posa[901] = mcposadiffraction_detector_8;
  mccomp_posr[901] = mcposrdiffraction_detector_8;
  mcNCounter[901]  = mcPCounter[901] = mcP2Counter[901] = 0;
  mcAbsorbProp[901]= 0;
    /* Component spec_detector_8. */
  /* Setting parameters for component spec_detector_8. */
  SIG_MESSAGE("spec_detector_8 (Init:SetPar)");
#line 5207 "MACS_sample_kidney_box.instr"
  mccspec_detector_8_nx = 5;
#line 5207 "MACS_sample_kidney_box.instr"
  mccspec_detector_8_ny = 5;
#line 5207 "MACS_sample_kidney_box.instr"
  if("spec_detector_8") strncpy(mccspec_detector_8_filename, "spec_detector_8" ? "spec_detector_8" : "", 16384); else mccspec_detector_8_filename[0]='\0';
#line 50 "MACS_sample_kidney_box.instr"
  mccspec_detector_8_xmin = -0.05;
#line 50 "MACS_sample_kidney_box.instr"
  mccspec_detector_8_xmax = 0.05;
#line 50 "MACS_sample_kidney_box.instr"
  mccspec_detector_8_ymin = -0.05;
#line 50 "MACS_sample_kidney_box.instr"
  mccspec_detector_8_ymax = 0.05;
#line 5206 "MACS_sample_kidney_box.instr"
  mccspec_detector_8_xwidth = 2.0 * detector_radius;
#line 5206 "MACS_sample_kidney_box.instr"
  mccspec_detector_8_yheight = 1.0 * detector_height;
#line 5206 "MACS_sample_kidney_box.instr"
  mccspec_detector_8_restore_neutron = 1;
#line 151091 "MACS_sample_kidney_box.c"

  SIG_MESSAGE("spec_detector_8 (Init:Place/Rotate)");
  rot_set_rotation(mctr1,
#line 5209 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 5209 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 5209 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD);
#line 151101 "MACS_sample_kidney_box.c"
  rot_mul(mctr1, mcrotaspec_detector_8_exit_volume, mcrotaspec_detector_8);
  rot_transpose(mcrotadiffraction_detector_8, mctr1);
  rot_mul(mcrotaspec_detector_8, mctr1, mcrotrspec_detector_8);
  mctc1 = coords_set(
#line 5208 "MACS_sample_kidney_box.instr"
    0,
#line 5208 "MACS_sample_kidney_box.instr"
    0,
#line 5208 "MACS_sample_kidney_box.instr"
    0);
#line 151112 "MACS_sample_kidney_box.c"
  rot_transpose(mcrotaspec_detector_8_exit_volume, mctr1);
  mctc2 = rot_apply(mctr1, mctc1);
  mcposaspec_detector_8 = coords_add(mcposaspec_detector_8_exit_volume, mctc2);
  mctc1 = coords_sub(mcposadiffraction_detector_8, mcposaspec_detector_8);
  mcposrspec_detector_8 = rot_apply(mcrotaspec_detector_8, mctc1);
  mcDEBUG_COMPONENT("spec_detector_8", mcposaspec_detector_8, mcrotaspec_detector_8)
  mccomp_posa[902] = mcposaspec_detector_8;
  mccomp_posr[902] = mcposrspec_detector_8;
  mcNCounter[902]  = mcPCounter[902] = mcP2Counter[902] = 0;
  mcAbsorbProp[902]= 0;
    /* Component diffraction_detector_9. */
  /* Setting parameters for component diffraction_detector_9. */
  SIG_MESSAGE("diffraction_detector_9 (Init:SetPar)");
#line 5221 "MACS_sample_kidney_box.instr"
  mccdiffraction_detector_9_nx = 5;
#line 5221 "MACS_sample_kidney_box.instr"
  mccdiffraction_detector_9_ny = 5;
#line 5221 "MACS_sample_kidney_box.instr"
  if("diff_detector_9") strncpy(mccdiffraction_detector_9_filename, "diff_detector_9" ? "diff_detector_9" : "", 16384); else mccdiffraction_detector_9_filename[0]='\0';
#line 50 "MACS_sample_kidney_box.instr"
  mccdiffraction_detector_9_xmin = -0.05;
#line 50 "MACS_sample_kidney_box.instr"
  mccdiffraction_detector_9_xmax = 0.05;
#line 50 "MACS_sample_kidney_box.instr"
  mccdiffraction_detector_9_ymin = -0.05;
#line 50 "MACS_sample_kidney_box.instr"
  mccdiffraction_detector_9_ymax = 0.05;
#line 5220 "MACS_sample_kidney_box.instr"
  mccdiffraction_detector_9_xwidth = 2.0 * detector_radius;
#line 5220 "MACS_sample_kidney_box.instr"
  mccdiffraction_detector_9_yheight = 1.0 * detector_height;
#line 5220 "MACS_sample_kidney_box.instr"
  mccdiffraction_detector_9_restore_neutron = 1;
#line 151146 "MACS_sample_kidney_box.c"

  SIG_MESSAGE("diffraction_detector_9 (Init:Place/Rotate)");
  rot_set_rotation(mctr1,
#line 5223 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 5223 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 5223 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD);
#line 151156 "MACS_sample_kidney_box.c"
  rot_mul(mctr1, mcrotadiffraction_detector_9_exit_volume, mcrotadiffraction_detector_9);
  rot_transpose(mcrotaspec_detector_8, mctr1);
  rot_mul(mcrotadiffraction_detector_9, mctr1, mcrotrdiffraction_detector_9);
  mctc1 = coords_set(
#line 5222 "MACS_sample_kidney_box.instr"
    0,
#line 5222 "MACS_sample_kidney_box.instr"
    0,
#line 5222 "MACS_sample_kidney_box.instr"
    0);
#line 151167 "MACS_sample_kidney_box.c"
  rot_transpose(mcrotadiffraction_detector_9_exit_volume, mctr1);
  mctc2 = rot_apply(mctr1, mctc1);
  mcposadiffraction_detector_9 = coords_add(mcposadiffraction_detector_9_exit_volume, mctc2);
  mctc1 = coords_sub(mcposaspec_detector_8, mcposadiffraction_detector_9);
  mcposrdiffraction_detector_9 = rot_apply(mcrotadiffraction_detector_9, mctc1);
  mcDEBUG_COMPONENT("diffraction_detector_9", mcposadiffraction_detector_9, mcrotadiffraction_detector_9)
  mccomp_posa[903] = mcposadiffraction_detector_9;
  mccomp_posr[903] = mcposrdiffraction_detector_9;
  mcNCounter[903]  = mcPCounter[903] = mcP2Counter[903] = 0;
  mcAbsorbProp[903]= 0;
    /* Component spec_detector_9. */
  /* Setting parameters for component spec_detector_9. */
  SIG_MESSAGE("spec_detector_9 (Init:SetPar)");
#line 5235 "MACS_sample_kidney_box.instr"
  mccspec_detector_9_nx = 5;
#line 5235 "MACS_sample_kidney_box.instr"
  mccspec_detector_9_ny = 5;
#line 5235 "MACS_sample_kidney_box.instr"
  if("spec_detector_9") strncpy(mccspec_detector_9_filename, "spec_detector_9" ? "spec_detector_9" : "", 16384); else mccspec_detector_9_filename[0]='\0';
#line 50 "MACS_sample_kidney_box.instr"
  mccspec_detector_9_xmin = -0.05;
#line 50 "MACS_sample_kidney_box.instr"
  mccspec_detector_9_xmax = 0.05;
#line 50 "MACS_sample_kidney_box.instr"
  mccspec_detector_9_ymin = -0.05;
#line 50 "MACS_sample_kidney_box.instr"
  mccspec_detector_9_ymax = 0.05;
#line 5234 "MACS_sample_kidney_box.instr"
  mccspec_detector_9_xwidth = 2.0 * detector_radius;
#line 5234 "MACS_sample_kidney_box.instr"
  mccspec_detector_9_yheight = 1.0 * detector_height;
#line 5234 "MACS_sample_kidney_box.instr"
  mccspec_detector_9_restore_neutron = 1;
#line 151201 "MACS_sample_kidney_box.c"

  SIG_MESSAGE("spec_detector_9 (Init:Place/Rotate)");
  rot_set_rotation(mctr1,
#line 5237 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 5237 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 5237 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD);
#line 151211 "MACS_sample_kidney_box.c"
  rot_mul(mctr1, mcrotaspec_detector_9_exit_volume, mcrotaspec_detector_9);
  rot_transpose(mcrotadiffraction_detector_9, mctr1);
  rot_mul(mcrotaspec_detector_9, mctr1, mcrotrspec_detector_9);
  mctc1 = coords_set(
#line 5236 "MACS_sample_kidney_box.instr"
    0,
#line 5236 "MACS_sample_kidney_box.instr"
    0,
#line 5236 "MACS_sample_kidney_box.instr"
    0);
#line 151222 "MACS_sample_kidney_box.c"
  rot_transpose(mcrotaspec_detector_9_exit_volume, mctr1);
  mctc2 = rot_apply(mctr1, mctc1);
  mcposaspec_detector_9 = coords_add(mcposaspec_detector_9_exit_volume, mctc2);
  mctc1 = coords_sub(mcposadiffraction_detector_9, mcposaspec_detector_9);
  mcposrspec_detector_9 = rot_apply(mcrotaspec_detector_9, mctc1);
  mcDEBUG_COMPONENT("spec_detector_9", mcposaspec_detector_9, mcrotaspec_detector_9)
  mccomp_posa[904] = mcposaspec_detector_9;
  mccomp_posr[904] = mcposrspec_detector_9;
  mcNCounter[904]  = mcPCounter[904] = mcP2Counter[904] = 0;
  mcAbsorbProp[904]= 0;
    /* Component diffraction_detector_10. */
  /* Setting parameters for component diffraction_detector_10. */
  SIG_MESSAGE("diffraction_detector_10 (Init:SetPar)");
#line 5249 "MACS_sample_kidney_box.instr"
  mccdiffraction_detector_10_nx = 5;
#line 5249 "MACS_sample_kidney_box.instr"
  mccdiffraction_detector_10_ny = 5;
#line 5249 "MACS_sample_kidney_box.instr"
  if("diff_detector_10") strncpy(mccdiffraction_detector_10_filename, "diff_detector_10" ? "diff_detector_10" : "", 16384); else mccdiffraction_detector_10_filename[0]='\0';
#line 50 "MACS_sample_kidney_box.instr"
  mccdiffraction_detector_10_xmin = -0.05;
#line 50 "MACS_sample_kidney_box.instr"
  mccdiffraction_detector_10_xmax = 0.05;
#line 50 "MACS_sample_kidney_box.instr"
  mccdiffraction_detector_10_ymin = -0.05;
#line 50 "MACS_sample_kidney_box.instr"
  mccdiffraction_detector_10_ymax = 0.05;
#line 5248 "MACS_sample_kidney_box.instr"
  mccdiffraction_detector_10_xwidth = 2.0 * detector_radius;
#line 5248 "MACS_sample_kidney_box.instr"
  mccdiffraction_detector_10_yheight = 1.0 * detector_height;
#line 5248 "MACS_sample_kidney_box.instr"
  mccdiffraction_detector_10_restore_neutron = 1;
#line 151256 "MACS_sample_kidney_box.c"

  SIG_MESSAGE("diffraction_detector_10 (Init:Place/Rotate)");
  rot_set_rotation(mctr1,
#line 5251 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 5251 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 5251 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD);
#line 151266 "MACS_sample_kidney_box.c"
  rot_mul(mctr1, mcrotadiffraction_detector_10_exit_volume, mcrotadiffraction_detector_10);
  rot_transpose(mcrotaspec_detector_9, mctr1);
  rot_mul(mcrotadiffraction_detector_10, mctr1, mcrotrdiffraction_detector_10);
  mctc1 = coords_set(
#line 5250 "MACS_sample_kidney_box.instr"
    0,
#line 5250 "MACS_sample_kidney_box.instr"
    0,
#line 5250 "MACS_sample_kidney_box.instr"
    0);
#line 151277 "MACS_sample_kidney_box.c"
  rot_transpose(mcrotadiffraction_detector_10_exit_volume, mctr1);
  mctc2 = rot_apply(mctr1, mctc1);
  mcposadiffraction_detector_10 = coords_add(mcposadiffraction_detector_10_exit_volume, mctc2);
  mctc1 = coords_sub(mcposaspec_detector_9, mcposadiffraction_detector_10);
  mcposrdiffraction_detector_10 = rot_apply(mcrotadiffraction_detector_10, mctc1);
  mcDEBUG_COMPONENT("diffraction_detector_10", mcposadiffraction_detector_10, mcrotadiffraction_detector_10)
  mccomp_posa[905] = mcposadiffraction_detector_10;
  mccomp_posr[905] = mcposrdiffraction_detector_10;
  mcNCounter[905]  = mcPCounter[905] = mcP2Counter[905] = 0;
  mcAbsorbProp[905]= 0;
    /* Component spec_detector_10. */
  /* Setting parameters for component spec_detector_10. */
  SIG_MESSAGE("spec_detector_10 (Init:SetPar)");
#line 5263 "MACS_sample_kidney_box.instr"
  mccspec_detector_10_nx = 5;
#line 5263 "MACS_sample_kidney_box.instr"
  mccspec_detector_10_ny = 5;
#line 5263 "MACS_sample_kidney_box.instr"
  if("spec_detector_10") strncpy(mccspec_detector_10_filename, "spec_detector_10" ? "spec_detector_10" : "", 16384); else mccspec_detector_10_filename[0]='\0';
#line 50 "MACS_sample_kidney_box.instr"
  mccspec_detector_10_xmin = -0.05;
#line 50 "MACS_sample_kidney_box.instr"
  mccspec_detector_10_xmax = 0.05;
#line 50 "MACS_sample_kidney_box.instr"
  mccspec_detector_10_ymin = -0.05;
#line 50 "MACS_sample_kidney_box.instr"
  mccspec_detector_10_ymax = 0.05;
#line 5262 "MACS_sample_kidney_box.instr"
  mccspec_detector_10_xwidth = 2.0 * detector_radius;
#line 5262 "MACS_sample_kidney_box.instr"
  mccspec_detector_10_yheight = 1.0 * detector_height;
#line 5262 "MACS_sample_kidney_box.instr"
  mccspec_detector_10_restore_neutron = 1;
#line 151311 "MACS_sample_kidney_box.c"

  SIG_MESSAGE("spec_detector_10 (Init:Place/Rotate)");
  rot_set_rotation(mctr1,
#line 5265 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 5265 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 5265 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD);
#line 151321 "MACS_sample_kidney_box.c"
  rot_mul(mctr1, mcrotaspec_detector_10_exit_volume, mcrotaspec_detector_10);
  rot_transpose(mcrotadiffraction_detector_10, mctr1);
  rot_mul(mcrotaspec_detector_10, mctr1, mcrotrspec_detector_10);
  mctc1 = coords_set(
#line 5264 "MACS_sample_kidney_box.instr"
    0,
#line 5264 "MACS_sample_kidney_box.instr"
    0,
#line 5264 "MACS_sample_kidney_box.instr"
    0);
#line 151332 "MACS_sample_kidney_box.c"
  rot_transpose(mcrotaspec_detector_10_exit_volume, mctr1);
  mctc2 = rot_apply(mctr1, mctc1);
  mcposaspec_detector_10 = coords_add(mcposaspec_detector_10_exit_volume, mctc2);
  mctc1 = coords_sub(mcposadiffraction_detector_10, mcposaspec_detector_10);
  mcposrspec_detector_10 = rot_apply(mcrotaspec_detector_10, mctc1);
  mcDEBUG_COMPONENT("spec_detector_10", mcposaspec_detector_10, mcrotaspec_detector_10)
  mccomp_posa[906] = mcposaspec_detector_10;
  mccomp_posr[906] = mcposrspec_detector_10;
  mcNCounter[906]  = mcPCounter[906] = mcP2Counter[906] = 0;
  mcAbsorbProp[906]= 0;
    /* Component diffraction_detector_11. */
  /* Setting parameters for component diffraction_detector_11. */
  SIG_MESSAGE("diffraction_detector_11 (Init:SetPar)");
#line 5277 "MACS_sample_kidney_box.instr"
  mccdiffraction_detector_11_nx = 5;
#line 5277 "MACS_sample_kidney_box.instr"
  mccdiffraction_detector_11_ny = 5;
#line 5277 "MACS_sample_kidney_box.instr"
  if("diff_detector_11") strncpy(mccdiffraction_detector_11_filename, "diff_detector_11" ? "diff_detector_11" : "", 16384); else mccdiffraction_detector_11_filename[0]='\0';
#line 50 "MACS_sample_kidney_box.instr"
  mccdiffraction_detector_11_xmin = -0.05;
#line 50 "MACS_sample_kidney_box.instr"
  mccdiffraction_detector_11_xmax = 0.05;
#line 50 "MACS_sample_kidney_box.instr"
  mccdiffraction_detector_11_ymin = -0.05;
#line 50 "MACS_sample_kidney_box.instr"
  mccdiffraction_detector_11_ymax = 0.05;
#line 5276 "MACS_sample_kidney_box.instr"
  mccdiffraction_detector_11_xwidth = 2.0 * detector_radius;
#line 5276 "MACS_sample_kidney_box.instr"
  mccdiffraction_detector_11_yheight = 1.0 * detector_height;
#line 5276 "MACS_sample_kidney_box.instr"
  mccdiffraction_detector_11_restore_neutron = 1;
#line 151366 "MACS_sample_kidney_box.c"

  SIG_MESSAGE("diffraction_detector_11 (Init:Place/Rotate)");
  rot_set_rotation(mctr1,
#line 5279 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 5279 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 5279 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD);
#line 151376 "MACS_sample_kidney_box.c"
  rot_mul(mctr1, mcrotadiffraction_detector_11_exit_volume, mcrotadiffraction_detector_11);
  rot_transpose(mcrotaspec_detector_10, mctr1);
  rot_mul(mcrotadiffraction_detector_11, mctr1, mcrotrdiffraction_detector_11);
  mctc1 = coords_set(
#line 5278 "MACS_sample_kidney_box.instr"
    0,
#line 5278 "MACS_sample_kidney_box.instr"
    0,
#line 5278 "MACS_sample_kidney_box.instr"
    0);
#line 151387 "MACS_sample_kidney_box.c"
  rot_transpose(mcrotadiffraction_detector_11_exit_volume, mctr1);
  mctc2 = rot_apply(mctr1, mctc1);
  mcposadiffraction_detector_11 = coords_add(mcposadiffraction_detector_11_exit_volume, mctc2);
  mctc1 = coords_sub(mcposaspec_detector_10, mcposadiffraction_detector_11);
  mcposrdiffraction_detector_11 = rot_apply(mcrotadiffraction_detector_11, mctc1);
  mcDEBUG_COMPONENT("diffraction_detector_11", mcposadiffraction_detector_11, mcrotadiffraction_detector_11)
  mccomp_posa[907] = mcposadiffraction_detector_11;
  mccomp_posr[907] = mcposrdiffraction_detector_11;
  mcNCounter[907]  = mcPCounter[907] = mcP2Counter[907] = 0;
  mcAbsorbProp[907]= 0;
    /* Component spec_detector_11. */
  /* Setting parameters for component spec_detector_11. */
  SIG_MESSAGE("spec_detector_11 (Init:SetPar)");
#line 5291 "MACS_sample_kidney_box.instr"
  mccspec_detector_11_nx = 5;
#line 5291 "MACS_sample_kidney_box.instr"
  mccspec_detector_11_ny = 5;
#line 5291 "MACS_sample_kidney_box.instr"
  if("spec_detector_11") strncpy(mccspec_detector_11_filename, "spec_detector_11" ? "spec_detector_11" : "", 16384); else mccspec_detector_11_filename[0]='\0';
#line 50 "MACS_sample_kidney_box.instr"
  mccspec_detector_11_xmin = -0.05;
#line 50 "MACS_sample_kidney_box.instr"
  mccspec_detector_11_xmax = 0.05;
#line 50 "MACS_sample_kidney_box.instr"
  mccspec_detector_11_ymin = -0.05;
#line 50 "MACS_sample_kidney_box.instr"
  mccspec_detector_11_ymax = 0.05;
#line 5290 "MACS_sample_kidney_box.instr"
  mccspec_detector_11_xwidth = 2.0 * detector_radius;
#line 5290 "MACS_sample_kidney_box.instr"
  mccspec_detector_11_yheight = 1.0 * detector_height;
#line 5290 "MACS_sample_kidney_box.instr"
  mccspec_detector_11_restore_neutron = 1;
#line 151421 "MACS_sample_kidney_box.c"

  SIG_MESSAGE("spec_detector_11 (Init:Place/Rotate)");
  rot_set_rotation(mctr1,
#line 5293 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 5293 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 5293 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD);
#line 151431 "MACS_sample_kidney_box.c"
  rot_mul(mctr1, mcrotaspec_detector_11_exit_volume, mcrotaspec_detector_11);
  rot_transpose(mcrotadiffraction_detector_11, mctr1);
  rot_mul(mcrotaspec_detector_11, mctr1, mcrotrspec_detector_11);
  mctc1 = coords_set(
#line 5292 "MACS_sample_kidney_box.instr"
    0,
#line 5292 "MACS_sample_kidney_box.instr"
    0,
#line 5292 "MACS_sample_kidney_box.instr"
    0);
#line 151442 "MACS_sample_kidney_box.c"
  rot_transpose(mcrotaspec_detector_11_exit_volume, mctr1);
  mctc2 = rot_apply(mctr1, mctc1);
  mcposaspec_detector_11 = coords_add(mcposaspec_detector_11_exit_volume, mctc2);
  mctc1 = coords_sub(mcposadiffraction_detector_11, mcposaspec_detector_11);
  mcposrspec_detector_11 = rot_apply(mcrotaspec_detector_11, mctc1);
  mcDEBUG_COMPONENT("spec_detector_11", mcposaspec_detector_11, mcrotaspec_detector_11)
  mccomp_posa[908] = mcposaspec_detector_11;
  mccomp_posr[908] = mcposrspec_detector_11;
  mcNCounter[908]  = mcPCounter[908] = mcP2Counter[908] = 0;
  mcAbsorbProp[908]= 0;
    /* Component diffraction_detector_12. */
  /* Setting parameters for component diffraction_detector_12. */
  SIG_MESSAGE("diffraction_detector_12 (Init:SetPar)");
#line 5305 "MACS_sample_kidney_box.instr"
  mccdiffraction_detector_12_nx = 5;
#line 5305 "MACS_sample_kidney_box.instr"
  mccdiffraction_detector_12_ny = 5;
#line 5305 "MACS_sample_kidney_box.instr"
  if("diff_detector_12") strncpy(mccdiffraction_detector_12_filename, "diff_detector_12" ? "diff_detector_12" : "", 16384); else mccdiffraction_detector_12_filename[0]='\0';
#line 50 "MACS_sample_kidney_box.instr"
  mccdiffraction_detector_12_xmin = -0.05;
#line 50 "MACS_sample_kidney_box.instr"
  mccdiffraction_detector_12_xmax = 0.05;
#line 50 "MACS_sample_kidney_box.instr"
  mccdiffraction_detector_12_ymin = -0.05;
#line 50 "MACS_sample_kidney_box.instr"
  mccdiffraction_detector_12_ymax = 0.05;
#line 5304 "MACS_sample_kidney_box.instr"
  mccdiffraction_detector_12_xwidth = 2.0 * detector_radius;
#line 5304 "MACS_sample_kidney_box.instr"
  mccdiffraction_detector_12_yheight = 1.0 * detector_height;
#line 5304 "MACS_sample_kidney_box.instr"
  mccdiffraction_detector_12_restore_neutron = 1;
#line 151476 "MACS_sample_kidney_box.c"

  SIG_MESSAGE("diffraction_detector_12 (Init:Place/Rotate)");
  rot_set_rotation(mctr1,
#line 5307 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 5307 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 5307 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD);
#line 151486 "MACS_sample_kidney_box.c"
  rot_mul(mctr1, mcrotadiffraction_detector_12_exit_volume, mcrotadiffraction_detector_12);
  rot_transpose(mcrotaspec_detector_11, mctr1);
  rot_mul(mcrotadiffraction_detector_12, mctr1, mcrotrdiffraction_detector_12);
  mctc1 = coords_set(
#line 5306 "MACS_sample_kidney_box.instr"
    0,
#line 5306 "MACS_sample_kidney_box.instr"
    0,
#line 5306 "MACS_sample_kidney_box.instr"
    0);
#line 151497 "MACS_sample_kidney_box.c"
  rot_transpose(mcrotadiffraction_detector_12_exit_volume, mctr1);
  mctc2 = rot_apply(mctr1, mctc1);
  mcposadiffraction_detector_12 = coords_add(mcposadiffraction_detector_12_exit_volume, mctc2);
  mctc1 = coords_sub(mcposaspec_detector_11, mcposadiffraction_detector_12);
  mcposrdiffraction_detector_12 = rot_apply(mcrotadiffraction_detector_12, mctc1);
  mcDEBUG_COMPONENT("diffraction_detector_12", mcposadiffraction_detector_12, mcrotadiffraction_detector_12)
  mccomp_posa[909] = mcposadiffraction_detector_12;
  mccomp_posr[909] = mcposrdiffraction_detector_12;
  mcNCounter[909]  = mcPCounter[909] = mcP2Counter[909] = 0;
  mcAbsorbProp[909]= 0;
    /* Component spec_detector_12. */
  /* Setting parameters for component spec_detector_12. */
  SIG_MESSAGE("spec_detector_12 (Init:SetPar)");
#line 5319 "MACS_sample_kidney_box.instr"
  mccspec_detector_12_nx = 5;
#line 5319 "MACS_sample_kidney_box.instr"
  mccspec_detector_12_ny = 5;
#line 5319 "MACS_sample_kidney_box.instr"
  if("spec_detector_12") strncpy(mccspec_detector_12_filename, "spec_detector_12" ? "spec_detector_12" : "", 16384); else mccspec_detector_12_filename[0]='\0';
#line 50 "MACS_sample_kidney_box.instr"
  mccspec_detector_12_xmin = -0.05;
#line 50 "MACS_sample_kidney_box.instr"
  mccspec_detector_12_xmax = 0.05;
#line 50 "MACS_sample_kidney_box.instr"
  mccspec_detector_12_ymin = -0.05;
#line 50 "MACS_sample_kidney_box.instr"
  mccspec_detector_12_ymax = 0.05;
#line 5318 "MACS_sample_kidney_box.instr"
  mccspec_detector_12_xwidth = 2.0 * detector_radius;
#line 5318 "MACS_sample_kidney_box.instr"
  mccspec_detector_12_yheight = 1.0 * detector_height;
#line 5318 "MACS_sample_kidney_box.instr"
  mccspec_detector_12_restore_neutron = 1;
#line 151531 "MACS_sample_kidney_box.c"

  SIG_MESSAGE("spec_detector_12 (Init:Place/Rotate)");
  rot_set_rotation(mctr1,
#line 5321 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 5321 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 5321 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD);
#line 151541 "MACS_sample_kidney_box.c"
  rot_mul(mctr1, mcrotaspec_detector_12_exit_volume, mcrotaspec_detector_12);
  rot_transpose(mcrotadiffraction_detector_12, mctr1);
  rot_mul(mcrotaspec_detector_12, mctr1, mcrotrspec_detector_12);
  mctc1 = coords_set(
#line 5320 "MACS_sample_kidney_box.instr"
    0,
#line 5320 "MACS_sample_kidney_box.instr"
    0,
#line 5320 "MACS_sample_kidney_box.instr"
    0);
#line 151552 "MACS_sample_kidney_box.c"
  rot_transpose(mcrotaspec_detector_12_exit_volume, mctr1);
  mctc2 = rot_apply(mctr1, mctc1);
  mcposaspec_detector_12 = coords_add(mcposaspec_detector_12_exit_volume, mctc2);
  mctc1 = coords_sub(mcposadiffraction_detector_12, mcposaspec_detector_12);
  mcposrspec_detector_12 = rot_apply(mcrotaspec_detector_12, mctc1);
  mcDEBUG_COMPONENT("spec_detector_12", mcposaspec_detector_12, mcrotaspec_detector_12)
  mccomp_posa[910] = mcposaspec_detector_12;
  mccomp_posr[910] = mcposrspec_detector_12;
  mcNCounter[910]  = mcPCounter[910] = mcP2Counter[910] = 0;
  mcAbsorbProp[910]= 0;
    /* Component diffraction_detector_13. */
  /* Setting parameters for component diffraction_detector_13. */
  SIG_MESSAGE("diffraction_detector_13 (Init:SetPar)");
#line 5333 "MACS_sample_kidney_box.instr"
  mccdiffraction_detector_13_nx = 5;
#line 5333 "MACS_sample_kidney_box.instr"
  mccdiffraction_detector_13_ny = 5;
#line 5333 "MACS_sample_kidney_box.instr"
  if("diff_detector_13") strncpy(mccdiffraction_detector_13_filename, "diff_detector_13" ? "diff_detector_13" : "", 16384); else mccdiffraction_detector_13_filename[0]='\0';
#line 50 "MACS_sample_kidney_box.instr"
  mccdiffraction_detector_13_xmin = -0.05;
#line 50 "MACS_sample_kidney_box.instr"
  mccdiffraction_detector_13_xmax = 0.05;
#line 50 "MACS_sample_kidney_box.instr"
  mccdiffraction_detector_13_ymin = -0.05;
#line 50 "MACS_sample_kidney_box.instr"
  mccdiffraction_detector_13_ymax = 0.05;
#line 5332 "MACS_sample_kidney_box.instr"
  mccdiffraction_detector_13_xwidth = 2.0 * detector_radius;
#line 5332 "MACS_sample_kidney_box.instr"
  mccdiffraction_detector_13_yheight = 1.0 * detector_height;
#line 5332 "MACS_sample_kidney_box.instr"
  mccdiffraction_detector_13_restore_neutron = 1;
#line 151586 "MACS_sample_kidney_box.c"

  SIG_MESSAGE("diffraction_detector_13 (Init:Place/Rotate)");
  rot_set_rotation(mctr1,
#line 5335 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 5335 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 5335 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD);
#line 151596 "MACS_sample_kidney_box.c"
  rot_mul(mctr1, mcrotadiffraction_detector_13_exit_volume, mcrotadiffraction_detector_13);
  rot_transpose(mcrotaspec_detector_12, mctr1);
  rot_mul(mcrotadiffraction_detector_13, mctr1, mcrotrdiffraction_detector_13);
  mctc1 = coords_set(
#line 5334 "MACS_sample_kidney_box.instr"
    0,
#line 5334 "MACS_sample_kidney_box.instr"
    0,
#line 5334 "MACS_sample_kidney_box.instr"
    0);
#line 151607 "MACS_sample_kidney_box.c"
  rot_transpose(mcrotadiffraction_detector_13_exit_volume, mctr1);
  mctc2 = rot_apply(mctr1, mctc1);
  mcposadiffraction_detector_13 = coords_add(mcposadiffraction_detector_13_exit_volume, mctc2);
  mctc1 = coords_sub(mcposaspec_detector_12, mcposadiffraction_detector_13);
  mcposrdiffraction_detector_13 = rot_apply(mcrotadiffraction_detector_13, mctc1);
  mcDEBUG_COMPONENT("diffraction_detector_13", mcposadiffraction_detector_13, mcrotadiffraction_detector_13)
  mccomp_posa[911] = mcposadiffraction_detector_13;
  mccomp_posr[911] = mcposrdiffraction_detector_13;
  mcNCounter[911]  = mcPCounter[911] = mcP2Counter[911] = 0;
  mcAbsorbProp[911]= 0;
    /* Component spec_detector_13. */
  /* Setting parameters for component spec_detector_13. */
  SIG_MESSAGE("spec_detector_13 (Init:SetPar)");
#line 5347 "MACS_sample_kidney_box.instr"
  mccspec_detector_13_nx = 5;
#line 5347 "MACS_sample_kidney_box.instr"
  mccspec_detector_13_ny = 5;
#line 5347 "MACS_sample_kidney_box.instr"
  if("spec_detector_13") strncpy(mccspec_detector_13_filename, "spec_detector_13" ? "spec_detector_13" : "", 16384); else mccspec_detector_13_filename[0]='\0';
#line 50 "MACS_sample_kidney_box.instr"
  mccspec_detector_13_xmin = -0.05;
#line 50 "MACS_sample_kidney_box.instr"
  mccspec_detector_13_xmax = 0.05;
#line 50 "MACS_sample_kidney_box.instr"
  mccspec_detector_13_ymin = -0.05;
#line 50 "MACS_sample_kidney_box.instr"
  mccspec_detector_13_ymax = 0.05;
#line 5346 "MACS_sample_kidney_box.instr"
  mccspec_detector_13_xwidth = 2.0 * detector_radius;
#line 5346 "MACS_sample_kidney_box.instr"
  mccspec_detector_13_yheight = 1.0 * detector_height;
#line 5346 "MACS_sample_kidney_box.instr"
  mccspec_detector_13_restore_neutron = 1;
#line 151641 "MACS_sample_kidney_box.c"

  SIG_MESSAGE("spec_detector_13 (Init:Place/Rotate)");
  rot_set_rotation(mctr1,
#line 5349 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 5349 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 5349 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD);
#line 151651 "MACS_sample_kidney_box.c"
  rot_mul(mctr1, mcrotaspec_detector_13_exit_volume, mcrotaspec_detector_13);
  rot_transpose(mcrotadiffraction_detector_13, mctr1);
  rot_mul(mcrotaspec_detector_13, mctr1, mcrotrspec_detector_13);
  mctc1 = coords_set(
#line 5348 "MACS_sample_kidney_box.instr"
    0,
#line 5348 "MACS_sample_kidney_box.instr"
    0,
#line 5348 "MACS_sample_kidney_box.instr"
    0);
#line 151662 "MACS_sample_kidney_box.c"
  rot_transpose(mcrotaspec_detector_13_exit_volume, mctr1);
  mctc2 = rot_apply(mctr1, mctc1);
  mcposaspec_detector_13 = coords_add(mcposaspec_detector_13_exit_volume, mctc2);
  mctc1 = coords_sub(mcposadiffraction_detector_13, mcposaspec_detector_13);
  mcposrspec_detector_13 = rot_apply(mcrotaspec_detector_13, mctc1);
  mcDEBUG_COMPONENT("spec_detector_13", mcposaspec_detector_13, mcrotaspec_detector_13)
  mccomp_posa[912] = mcposaspec_detector_13;
  mccomp_posr[912] = mcposrspec_detector_13;
  mcNCounter[912]  = mcPCounter[912] = mcP2Counter[912] = 0;
  mcAbsorbProp[912]= 0;
    /* Component diffraction_detector_14. */
  /* Setting parameters for component diffraction_detector_14. */
  SIG_MESSAGE("diffraction_detector_14 (Init:SetPar)");
#line 5361 "MACS_sample_kidney_box.instr"
  mccdiffraction_detector_14_nx = 5;
#line 5361 "MACS_sample_kidney_box.instr"
  mccdiffraction_detector_14_ny = 5;
#line 5361 "MACS_sample_kidney_box.instr"
  if("diff_detector_14") strncpy(mccdiffraction_detector_14_filename, "diff_detector_14" ? "diff_detector_14" : "", 16384); else mccdiffraction_detector_14_filename[0]='\0';
#line 50 "MACS_sample_kidney_box.instr"
  mccdiffraction_detector_14_xmin = -0.05;
#line 50 "MACS_sample_kidney_box.instr"
  mccdiffraction_detector_14_xmax = 0.05;
#line 50 "MACS_sample_kidney_box.instr"
  mccdiffraction_detector_14_ymin = -0.05;
#line 50 "MACS_sample_kidney_box.instr"
  mccdiffraction_detector_14_ymax = 0.05;
#line 5360 "MACS_sample_kidney_box.instr"
  mccdiffraction_detector_14_xwidth = 2.0 * detector_radius;
#line 5360 "MACS_sample_kidney_box.instr"
  mccdiffraction_detector_14_yheight = 1.0 * detector_height;
#line 5360 "MACS_sample_kidney_box.instr"
  mccdiffraction_detector_14_restore_neutron = 1;
#line 151696 "MACS_sample_kidney_box.c"

  SIG_MESSAGE("diffraction_detector_14 (Init:Place/Rotate)");
  rot_set_rotation(mctr1,
#line 5363 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 5363 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 5363 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD);
#line 151706 "MACS_sample_kidney_box.c"
  rot_mul(mctr1, mcrotadiffraction_detector_14_exit_volume, mcrotadiffraction_detector_14);
  rot_transpose(mcrotaspec_detector_13, mctr1);
  rot_mul(mcrotadiffraction_detector_14, mctr1, mcrotrdiffraction_detector_14);
  mctc1 = coords_set(
#line 5362 "MACS_sample_kidney_box.instr"
    0,
#line 5362 "MACS_sample_kidney_box.instr"
    0,
#line 5362 "MACS_sample_kidney_box.instr"
    0);
#line 151717 "MACS_sample_kidney_box.c"
  rot_transpose(mcrotadiffraction_detector_14_exit_volume, mctr1);
  mctc2 = rot_apply(mctr1, mctc1);
  mcposadiffraction_detector_14 = coords_add(mcposadiffraction_detector_14_exit_volume, mctc2);
  mctc1 = coords_sub(mcposaspec_detector_13, mcposadiffraction_detector_14);
  mcposrdiffraction_detector_14 = rot_apply(mcrotadiffraction_detector_14, mctc1);
  mcDEBUG_COMPONENT("diffraction_detector_14", mcposadiffraction_detector_14, mcrotadiffraction_detector_14)
  mccomp_posa[913] = mcposadiffraction_detector_14;
  mccomp_posr[913] = mcposrdiffraction_detector_14;
  mcNCounter[913]  = mcPCounter[913] = mcP2Counter[913] = 0;
  mcAbsorbProp[913]= 0;
    /* Component spec_detector_14. */
  /* Setting parameters for component spec_detector_14. */
  SIG_MESSAGE("spec_detector_14 (Init:SetPar)");
#line 5375 "MACS_sample_kidney_box.instr"
  mccspec_detector_14_nx = 5;
#line 5375 "MACS_sample_kidney_box.instr"
  mccspec_detector_14_ny = 5;
#line 5375 "MACS_sample_kidney_box.instr"
  if("spec_detector_14") strncpy(mccspec_detector_14_filename, "spec_detector_14" ? "spec_detector_14" : "", 16384); else mccspec_detector_14_filename[0]='\0';
#line 50 "MACS_sample_kidney_box.instr"
  mccspec_detector_14_xmin = -0.05;
#line 50 "MACS_sample_kidney_box.instr"
  mccspec_detector_14_xmax = 0.05;
#line 50 "MACS_sample_kidney_box.instr"
  mccspec_detector_14_ymin = -0.05;
#line 50 "MACS_sample_kidney_box.instr"
  mccspec_detector_14_ymax = 0.05;
#line 5374 "MACS_sample_kidney_box.instr"
  mccspec_detector_14_xwidth = 2.0 * detector_radius;
#line 5374 "MACS_sample_kidney_box.instr"
  mccspec_detector_14_yheight = 1.0 * detector_height;
#line 5374 "MACS_sample_kidney_box.instr"
  mccspec_detector_14_restore_neutron = 1;
#line 151751 "MACS_sample_kidney_box.c"

  SIG_MESSAGE("spec_detector_14 (Init:Place/Rotate)");
  rot_set_rotation(mctr1,
#line 5377 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 5377 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 5377 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD);
#line 151761 "MACS_sample_kidney_box.c"
  rot_mul(mctr1, mcrotaspec_detector_14_exit_volume, mcrotaspec_detector_14);
  rot_transpose(mcrotadiffraction_detector_14, mctr1);
  rot_mul(mcrotaspec_detector_14, mctr1, mcrotrspec_detector_14);
  mctc1 = coords_set(
#line 5376 "MACS_sample_kidney_box.instr"
    0,
#line 5376 "MACS_sample_kidney_box.instr"
    0,
#line 5376 "MACS_sample_kidney_box.instr"
    0);
#line 151772 "MACS_sample_kidney_box.c"
  rot_transpose(mcrotaspec_detector_14_exit_volume, mctr1);
  mctc2 = rot_apply(mctr1, mctc1);
  mcposaspec_detector_14 = coords_add(mcposaspec_detector_14_exit_volume, mctc2);
  mctc1 = coords_sub(mcposadiffraction_detector_14, mcposaspec_detector_14);
  mcposrspec_detector_14 = rot_apply(mcrotaspec_detector_14, mctc1);
  mcDEBUG_COMPONENT("spec_detector_14", mcposaspec_detector_14, mcrotaspec_detector_14)
  mccomp_posa[914] = mcposaspec_detector_14;
  mccomp_posr[914] = mcposrspec_detector_14;
  mcNCounter[914]  = mcPCounter[914] = mcP2Counter[914] = 0;
  mcAbsorbProp[914]= 0;
    /* Component diffraction_detector_15. */
  /* Setting parameters for component diffraction_detector_15. */
  SIG_MESSAGE("diffraction_detector_15 (Init:SetPar)");
#line 5389 "MACS_sample_kidney_box.instr"
  mccdiffraction_detector_15_nx = 5;
#line 5389 "MACS_sample_kidney_box.instr"
  mccdiffraction_detector_15_ny = 5;
#line 5389 "MACS_sample_kidney_box.instr"
  if("diff_detector_15") strncpy(mccdiffraction_detector_15_filename, "diff_detector_15" ? "diff_detector_15" : "", 16384); else mccdiffraction_detector_15_filename[0]='\0';
#line 50 "MACS_sample_kidney_box.instr"
  mccdiffraction_detector_15_xmin = -0.05;
#line 50 "MACS_sample_kidney_box.instr"
  mccdiffraction_detector_15_xmax = 0.05;
#line 50 "MACS_sample_kidney_box.instr"
  mccdiffraction_detector_15_ymin = -0.05;
#line 50 "MACS_sample_kidney_box.instr"
  mccdiffraction_detector_15_ymax = 0.05;
#line 5388 "MACS_sample_kidney_box.instr"
  mccdiffraction_detector_15_xwidth = 2.0 * detector_radius;
#line 5388 "MACS_sample_kidney_box.instr"
  mccdiffraction_detector_15_yheight = 1.0 * detector_height;
#line 5388 "MACS_sample_kidney_box.instr"
  mccdiffraction_detector_15_restore_neutron = 1;
#line 151806 "MACS_sample_kidney_box.c"

  SIG_MESSAGE("diffraction_detector_15 (Init:Place/Rotate)");
  rot_set_rotation(mctr1,
#line 5391 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 5391 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 5391 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD);
#line 151816 "MACS_sample_kidney_box.c"
  rot_mul(mctr1, mcrotadiffraction_detector_15_exit_volume, mcrotadiffraction_detector_15);
  rot_transpose(mcrotaspec_detector_14, mctr1);
  rot_mul(mcrotadiffraction_detector_15, mctr1, mcrotrdiffraction_detector_15);
  mctc1 = coords_set(
#line 5390 "MACS_sample_kidney_box.instr"
    0,
#line 5390 "MACS_sample_kidney_box.instr"
    0,
#line 5390 "MACS_sample_kidney_box.instr"
    0);
#line 151827 "MACS_sample_kidney_box.c"
  rot_transpose(mcrotadiffraction_detector_15_exit_volume, mctr1);
  mctc2 = rot_apply(mctr1, mctc1);
  mcposadiffraction_detector_15 = coords_add(mcposadiffraction_detector_15_exit_volume, mctc2);
  mctc1 = coords_sub(mcposaspec_detector_14, mcposadiffraction_detector_15);
  mcposrdiffraction_detector_15 = rot_apply(mcrotadiffraction_detector_15, mctc1);
  mcDEBUG_COMPONENT("diffraction_detector_15", mcposadiffraction_detector_15, mcrotadiffraction_detector_15)
  mccomp_posa[915] = mcposadiffraction_detector_15;
  mccomp_posr[915] = mcposrdiffraction_detector_15;
  mcNCounter[915]  = mcPCounter[915] = mcP2Counter[915] = 0;
  mcAbsorbProp[915]= 0;
    /* Component spec_detector_15. */
  /* Setting parameters for component spec_detector_15. */
  SIG_MESSAGE("spec_detector_15 (Init:SetPar)");
#line 5403 "MACS_sample_kidney_box.instr"
  mccspec_detector_15_nx = 5;
#line 5403 "MACS_sample_kidney_box.instr"
  mccspec_detector_15_ny = 5;
#line 5403 "MACS_sample_kidney_box.instr"
  if("spec_detector_15") strncpy(mccspec_detector_15_filename, "spec_detector_15" ? "spec_detector_15" : "", 16384); else mccspec_detector_15_filename[0]='\0';
#line 50 "MACS_sample_kidney_box.instr"
  mccspec_detector_15_xmin = -0.05;
#line 50 "MACS_sample_kidney_box.instr"
  mccspec_detector_15_xmax = 0.05;
#line 50 "MACS_sample_kidney_box.instr"
  mccspec_detector_15_ymin = -0.05;
#line 50 "MACS_sample_kidney_box.instr"
  mccspec_detector_15_ymax = 0.05;
#line 5402 "MACS_sample_kidney_box.instr"
  mccspec_detector_15_xwidth = 2.0 * detector_radius;
#line 5402 "MACS_sample_kidney_box.instr"
  mccspec_detector_15_yheight = 1.0 * detector_height;
#line 5402 "MACS_sample_kidney_box.instr"
  mccspec_detector_15_restore_neutron = 1;
#line 151861 "MACS_sample_kidney_box.c"

  SIG_MESSAGE("spec_detector_15 (Init:Place/Rotate)");
  rot_set_rotation(mctr1,
#line 5405 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 5405 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 5405 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD);
#line 151871 "MACS_sample_kidney_box.c"
  rot_mul(mctr1, mcrotaspec_detector_15_exit_volume, mcrotaspec_detector_15);
  rot_transpose(mcrotadiffraction_detector_15, mctr1);
  rot_mul(mcrotaspec_detector_15, mctr1, mcrotrspec_detector_15);
  mctc1 = coords_set(
#line 5404 "MACS_sample_kidney_box.instr"
    0,
#line 5404 "MACS_sample_kidney_box.instr"
    0,
#line 5404 "MACS_sample_kidney_box.instr"
    0);
#line 151882 "MACS_sample_kidney_box.c"
  rot_transpose(mcrotaspec_detector_15_exit_volume, mctr1);
  mctc2 = rot_apply(mctr1, mctc1);
  mcposaspec_detector_15 = coords_add(mcposaspec_detector_15_exit_volume, mctc2);
  mctc1 = coords_sub(mcposadiffraction_detector_15, mcposaspec_detector_15);
  mcposrspec_detector_15 = rot_apply(mcrotaspec_detector_15, mctc1);
  mcDEBUG_COMPONENT("spec_detector_15", mcposaspec_detector_15, mcrotaspec_detector_15)
  mccomp_posa[916] = mcposaspec_detector_15;
  mccomp_posr[916] = mcposrspec_detector_15;
  mcNCounter[916]  = mcPCounter[916] = mcP2Counter[916] = 0;
  mcAbsorbProp[916]= 0;
    /* Component diffraction_detector_16. */
  /* Setting parameters for component diffraction_detector_16. */
  SIG_MESSAGE("diffraction_detector_16 (Init:SetPar)");
#line 5417 "MACS_sample_kidney_box.instr"
  mccdiffraction_detector_16_nx = 5;
#line 5417 "MACS_sample_kidney_box.instr"
  mccdiffraction_detector_16_ny = 5;
#line 5417 "MACS_sample_kidney_box.instr"
  if("diff_detector_16") strncpy(mccdiffraction_detector_16_filename, "diff_detector_16" ? "diff_detector_16" : "", 16384); else mccdiffraction_detector_16_filename[0]='\0';
#line 50 "MACS_sample_kidney_box.instr"
  mccdiffraction_detector_16_xmin = -0.05;
#line 50 "MACS_sample_kidney_box.instr"
  mccdiffraction_detector_16_xmax = 0.05;
#line 50 "MACS_sample_kidney_box.instr"
  mccdiffraction_detector_16_ymin = -0.05;
#line 50 "MACS_sample_kidney_box.instr"
  mccdiffraction_detector_16_ymax = 0.05;
#line 5416 "MACS_sample_kidney_box.instr"
  mccdiffraction_detector_16_xwidth = 2.0 * detector_radius;
#line 5416 "MACS_sample_kidney_box.instr"
  mccdiffraction_detector_16_yheight = 1.0 * detector_height;
#line 5416 "MACS_sample_kidney_box.instr"
  mccdiffraction_detector_16_restore_neutron = 1;
#line 151916 "MACS_sample_kidney_box.c"

  SIG_MESSAGE("diffraction_detector_16 (Init:Place/Rotate)");
  rot_set_rotation(mctr1,
#line 5419 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 5419 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 5419 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD);
#line 151926 "MACS_sample_kidney_box.c"
  rot_mul(mctr1, mcrotadiffraction_detector_16_exit_volume, mcrotadiffraction_detector_16);
  rot_transpose(mcrotaspec_detector_15, mctr1);
  rot_mul(mcrotadiffraction_detector_16, mctr1, mcrotrdiffraction_detector_16);
  mctc1 = coords_set(
#line 5418 "MACS_sample_kidney_box.instr"
    0,
#line 5418 "MACS_sample_kidney_box.instr"
    0,
#line 5418 "MACS_sample_kidney_box.instr"
    0);
#line 151937 "MACS_sample_kidney_box.c"
  rot_transpose(mcrotadiffraction_detector_16_exit_volume, mctr1);
  mctc2 = rot_apply(mctr1, mctc1);
  mcposadiffraction_detector_16 = coords_add(mcposadiffraction_detector_16_exit_volume, mctc2);
  mctc1 = coords_sub(mcposaspec_detector_15, mcposadiffraction_detector_16);
  mcposrdiffraction_detector_16 = rot_apply(mcrotadiffraction_detector_16, mctc1);
  mcDEBUG_COMPONENT("diffraction_detector_16", mcposadiffraction_detector_16, mcrotadiffraction_detector_16)
  mccomp_posa[917] = mcposadiffraction_detector_16;
  mccomp_posr[917] = mcposrdiffraction_detector_16;
  mcNCounter[917]  = mcPCounter[917] = mcP2Counter[917] = 0;
  mcAbsorbProp[917]= 0;
    /* Component spec_detector_16. */
  /* Setting parameters for component spec_detector_16. */
  SIG_MESSAGE("spec_detector_16 (Init:SetPar)");
#line 5431 "MACS_sample_kidney_box.instr"
  mccspec_detector_16_nx = 5;
#line 5431 "MACS_sample_kidney_box.instr"
  mccspec_detector_16_ny = 5;
#line 5431 "MACS_sample_kidney_box.instr"
  if("spec_detector_16") strncpy(mccspec_detector_16_filename, "spec_detector_16" ? "spec_detector_16" : "", 16384); else mccspec_detector_16_filename[0]='\0';
#line 50 "MACS_sample_kidney_box.instr"
  mccspec_detector_16_xmin = -0.05;
#line 50 "MACS_sample_kidney_box.instr"
  mccspec_detector_16_xmax = 0.05;
#line 50 "MACS_sample_kidney_box.instr"
  mccspec_detector_16_ymin = -0.05;
#line 50 "MACS_sample_kidney_box.instr"
  mccspec_detector_16_ymax = 0.05;
#line 5430 "MACS_sample_kidney_box.instr"
  mccspec_detector_16_xwidth = 2.0 * detector_radius;
#line 5430 "MACS_sample_kidney_box.instr"
  mccspec_detector_16_yheight = 1.0 * detector_height;
#line 5430 "MACS_sample_kidney_box.instr"
  mccspec_detector_16_restore_neutron = 1;
#line 151971 "MACS_sample_kidney_box.c"

  SIG_MESSAGE("spec_detector_16 (Init:Place/Rotate)");
  rot_set_rotation(mctr1,
#line 5433 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 5433 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 5433 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD);
#line 151981 "MACS_sample_kidney_box.c"
  rot_mul(mctr1, mcrotaspec_detector_16_exit_volume, mcrotaspec_detector_16);
  rot_transpose(mcrotadiffraction_detector_16, mctr1);
  rot_mul(mcrotaspec_detector_16, mctr1, mcrotrspec_detector_16);
  mctc1 = coords_set(
#line 5432 "MACS_sample_kidney_box.instr"
    0,
#line 5432 "MACS_sample_kidney_box.instr"
    0,
#line 5432 "MACS_sample_kidney_box.instr"
    0);
#line 151992 "MACS_sample_kidney_box.c"
  rot_transpose(mcrotaspec_detector_16_exit_volume, mctr1);
  mctc2 = rot_apply(mctr1, mctc1);
  mcposaspec_detector_16 = coords_add(mcposaspec_detector_16_exit_volume, mctc2);
  mctc1 = coords_sub(mcposadiffraction_detector_16, mcposaspec_detector_16);
  mcposrspec_detector_16 = rot_apply(mcrotaspec_detector_16, mctc1);
  mcDEBUG_COMPONENT("spec_detector_16", mcposaspec_detector_16, mcrotaspec_detector_16)
  mccomp_posa[918] = mcposaspec_detector_16;
  mccomp_posr[918] = mcposrspec_detector_16;
  mcNCounter[918]  = mcPCounter[918] = mcP2Counter[918] = 0;
  mcAbsorbProp[918]= 0;
    /* Component diffraction_detector_17. */
  /* Setting parameters for component diffraction_detector_17. */
  SIG_MESSAGE("diffraction_detector_17 (Init:SetPar)");
#line 5445 "MACS_sample_kidney_box.instr"
  mccdiffraction_detector_17_nx = 5;
#line 5445 "MACS_sample_kidney_box.instr"
  mccdiffraction_detector_17_ny = 5;
#line 5445 "MACS_sample_kidney_box.instr"
  if("diff_detector_17") strncpy(mccdiffraction_detector_17_filename, "diff_detector_17" ? "diff_detector_17" : "", 16384); else mccdiffraction_detector_17_filename[0]='\0';
#line 50 "MACS_sample_kidney_box.instr"
  mccdiffraction_detector_17_xmin = -0.05;
#line 50 "MACS_sample_kidney_box.instr"
  mccdiffraction_detector_17_xmax = 0.05;
#line 50 "MACS_sample_kidney_box.instr"
  mccdiffraction_detector_17_ymin = -0.05;
#line 50 "MACS_sample_kidney_box.instr"
  mccdiffraction_detector_17_ymax = 0.05;
#line 5444 "MACS_sample_kidney_box.instr"
  mccdiffraction_detector_17_xwidth = 2.0 * detector_radius;
#line 5444 "MACS_sample_kidney_box.instr"
  mccdiffraction_detector_17_yheight = 1.0 * detector_height;
#line 5444 "MACS_sample_kidney_box.instr"
  mccdiffraction_detector_17_restore_neutron = 1;
#line 152026 "MACS_sample_kidney_box.c"

  SIG_MESSAGE("diffraction_detector_17 (Init:Place/Rotate)");
  rot_set_rotation(mctr1,
#line 5447 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 5447 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 5447 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD);
#line 152036 "MACS_sample_kidney_box.c"
  rot_mul(mctr1, mcrotadiffraction_detector_17_exit_volume, mcrotadiffraction_detector_17);
  rot_transpose(mcrotaspec_detector_16, mctr1);
  rot_mul(mcrotadiffraction_detector_17, mctr1, mcrotrdiffraction_detector_17);
  mctc1 = coords_set(
#line 5446 "MACS_sample_kidney_box.instr"
    0,
#line 5446 "MACS_sample_kidney_box.instr"
    0,
#line 5446 "MACS_sample_kidney_box.instr"
    0);
#line 152047 "MACS_sample_kidney_box.c"
  rot_transpose(mcrotadiffraction_detector_17_exit_volume, mctr1);
  mctc2 = rot_apply(mctr1, mctc1);
  mcposadiffraction_detector_17 = coords_add(mcposadiffraction_detector_17_exit_volume, mctc2);
  mctc1 = coords_sub(mcposaspec_detector_16, mcposadiffraction_detector_17);
  mcposrdiffraction_detector_17 = rot_apply(mcrotadiffraction_detector_17, mctc1);
  mcDEBUG_COMPONENT("diffraction_detector_17", mcposadiffraction_detector_17, mcrotadiffraction_detector_17)
  mccomp_posa[919] = mcposadiffraction_detector_17;
  mccomp_posr[919] = mcposrdiffraction_detector_17;
  mcNCounter[919]  = mcPCounter[919] = mcP2Counter[919] = 0;
  mcAbsorbProp[919]= 0;
    /* Component spec_detector_17. */
  /* Setting parameters for component spec_detector_17. */
  SIG_MESSAGE("spec_detector_17 (Init:SetPar)");
#line 5459 "MACS_sample_kidney_box.instr"
  mccspec_detector_17_nx = 5;
#line 5459 "MACS_sample_kidney_box.instr"
  mccspec_detector_17_ny = 5;
#line 5459 "MACS_sample_kidney_box.instr"
  if("spec_detector_17") strncpy(mccspec_detector_17_filename, "spec_detector_17" ? "spec_detector_17" : "", 16384); else mccspec_detector_17_filename[0]='\0';
#line 50 "MACS_sample_kidney_box.instr"
  mccspec_detector_17_xmin = -0.05;
#line 50 "MACS_sample_kidney_box.instr"
  mccspec_detector_17_xmax = 0.05;
#line 50 "MACS_sample_kidney_box.instr"
  mccspec_detector_17_ymin = -0.05;
#line 50 "MACS_sample_kidney_box.instr"
  mccspec_detector_17_ymax = 0.05;
#line 5458 "MACS_sample_kidney_box.instr"
  mccspec_detector_17_xwidth = 2.0 * detector_radius;
#line 5458 "MACS_sample_kidney_box.instr"
  mccspec_detector_17_yheight = 1.0 * detector_height;
#line 5458 "MACS_sample_kidney_box.instr"
  mccspec_detector_17_restore_neutron = 1;
#line 152081 "MACS_sample_kidney_box.c"

  SIG_MESSAGE("spec_detector_17 (Init:Place/Rotate)");
  rot_set_rotation(mctr1,
#line 5461 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 5461 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 5461 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD);
#line 152091 "MACS_sample_kidney_box.c"
  rot_mul(mctr1, mcrotaspec_detector_17_exit_volume, mcrotaspec_detector_17);
  rot_transpose(mcrotadiffraction_detector_17, mctr1);
  rot_mul(mcrotaspec_detector_17, mctr1, mcrotrspec_detector_17);
  mctc1 = coords_set(
#line 5460 "MACS_sample_kidney_box.instr"
    0,
#line 5460 "MACS_sample_kidney_box.instr"
    0,
#line 5460 "MACS_sample_kidney_box.instr"
    0);
#line 152102 "MACS_sample_kidney_box.c"
  rot_transpose(mcrotaspec_detector_17_exit_volume, mctr1);
  mctc2 = rot_apply(mctr1, mctc1);
  mcposaspec_detector_17 = coords_add(mcposaspec_detector_17_exit_volume, mctc2);
  mctc1 = coords_sub(mcposadiffraction_detector_17, mcposaspec_detector_17);
  mcposrspec_detector_17 = rot_apply(mcrotaspec_detector_17, mctc1);
  mcDEBUG_COMPONENT("spec_detector_17", mcposaspec_detector_17, mcrotaspec_detector_17)
  mccomp_posa[920] = mcposaspec_detector_17;
  mccomp_posr[920] = mcposrspec_detector_17;
  mcNCounter[920]  = mcPCounter[920] = mcP2Counter[920] = 0;
  mcAbsorbProp[920]= 0;
    /* Component diffraction_detector_18. */
  /* Setting parameters for component diffraction_detector_18. */
  SIG_MESSAGE("diffraction_detector_18 (Init:SetPar)");
#line 5473 "MACS_sample_kidney_box.instr"
  mccdiffraction_detector_18_nx = 5;
#line 5473 "MACS_sample_kidney_box.instr"
  mccdiffraction_detector_18_ny = 5;
#line 5473 "MACS_sample_kidney_box.instr"
  if("diff_detector_18") strncpy(mccdiffraction_detector_18_filename, "diff_detector_18" ? "diff_detector_18" : "", 16384); else mccdiffraction_detector_18_filename[0]='\0';
#line 50 "MACS_sample_kidney_box.instr"
  mccdiffraction_detector_18_xmin = -0.05;
#line 50 "MACS_sample_kidney_box.instr"
  mccdiffraction_detector_18_xmax = 0.05;
#line 50 "MACS_sample_kidney_box.instr"
  mccdiffraction_detector_18_ymin = -0.05;
#line 50 "MACS_sample_kidney_box.instr"
  mccdiffraction_detector_18_ymax = 0.05;
#line 5472 "MACS_sample_kidney_box.instr"
  mccdiffraction_detector_18_xwidth = 2.0 * detector_radius;
#line 5472 "MACS_sample_kidney_box.instr"
  mccdiffraction_detector_18_yheight = 1.0 * detector_height;
#line 5472 "MACS_sample_kidney_box.instr"
  mccdiffraction_detector_18_restore_neutron = 1;
#line 152136 "MACS_sample_kidney_box.c"

  SIG_MESSAGE("diffraction_detector_18 (Init:Place/Rotate)");
  rot_set_rotation(mctr1,
#line 5475 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 5475 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 5475 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD);
#line 152146 "MACS_sample_kidney_box.c"
  rot_mul(mctr1, mcrotadiffraction_detector_18_exit_volume, mcrotadiffraction_detector_18);
  rot_transpose(mcrotaspec_detector_17, mctr1);
  rot_mul(mcrotadiffraction_detector_18, mctr1, mcrotrdiffraction_detector_18);
  mctc1 = coords_set(
#line 5474 "MACS_sample_kidney_box.instr"
    0,
#line 5474 "MACS_sample_kidney_box.instr"
    0,
#line 5474 "MACS_sample_kidney_box.instr"
    0);
#line 152157 "MACS_sample_kidney_box.c"
  rot_transpose(mcrotadiffraction_detector_18_exit_volume, mctr1);
  mctc2 = rot_apply(mctr1, mctc1);
  mcposadiffraction_detector_18 = coords_add(mcposadiffraction_detector_18_exit_volume, mctc2);
  mctc1 = coords_sub(mcposaspec_detector_17, mcposadiffraction_detector_18);
  mcposrdiffraction_detector_18 = rot_apply(mcrotadiffraction_detector_18, mctc1);
  mcDEBUG_COMPONENT("diffraction_detector_18", mcposadiffraction_detector_18, mcrotadiffraction_detector_18)
  mccomp_posa[921] = mcposadiffraction_detector_18;
  mccomp_posr[921] = mcposrdiffraction_detector_18;
  mcNCounter[921]  = mcPCounter[921] = mcP2Counter[921] = 0;
  mcAbsorbProp[921]= 0;
    /* Component spec_detector_18. */
  /* Setting parameters for component spec_detector_18. */
  SIG_MESSAGE("spec_detector_18 (Init:SetPar)");
#line 5487 "MACS_sample_kidney_box.instr"
  mccspec_detector_18_nx = 5;
#line 5487 "MACS_sample_kidney_box.instr"
  mccspec_detector_18_ny = 5;
#line 5487 "MACS_sample_kidney_box.instr"
  if("spec_detector_18") strncpy(mccspec_detector_18_filename, "spec_detector_18" ? "spec_detector_18" : "", 16384); else mccspec_detector_18_filename[0]='\0';
#line 50 "MACS_sample_kidney_box.instr"
  mccspec_detector_18_xmin = -0.05;
#line 50 "MACS_sample_kidney_box.instr"
  mccspec_detector_18_xmax = 0.05;
#line 50 "MACS_sample_kidney_box.instr"
  mccspec_detector_18_ymin = -0.05;
#line 50 "MACS_sample_kidney_box.instr"
  mccspec_detector_18_ymax = 0.05;
#line 5486 "MACS_sample_kidney_box.instr"
  mccspec_detector_18_xwidth = 2.0 * detector_radius;
#line 5486 "MACS_sample_kidney_box.instr"
  mccspec_detector_18_yheight = 1.0 * detector_height;
#line 5486 "MACS_sample_kidney_box.instr"
  mccspec_detector_18_restore_neutron = 1;
#line 152191 "MACS_sample_kidney_box.c"

  SIG_MESSAGE("spec_detector_18 (Init:Place/Rotate)");
  rot_set_rotation(mctr1,
#line 5489 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 5489 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 5489 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD);
#line 152201 "MACS_sample_kidney_box.c"
  rot_mul(mctr1, mcrotaspec_detector_18_exit_volume, mcrotaspec_detector_18);
  rot_transpose(mcrotadiffraction_detector_18, mctr1);
  rot_mul(mcrotaspec_detector_18, mctr1, mcrotrspec_detector_18);
  mctc1 = coords_set(
#line 5488 "MACS_sample_kidney_box.instr"
    0,
#line 5488 "MACS_sample_kidney_box.instr"
    0,
#line 5488 "MACS_sample_kidney_box.instr"
    0);
#line 152212 "MACS_sample_kidney_box.c"
  rot_transpose(mcrotaspec_detector_18_exit_volume, mctr1);
  mctc2 = rot_apply(mctr1, mctc1);
  mcposaspec_detector_18 = coords_add(mcposaspec_detector_18_exit_volume, mctc2);
  mctc1 = coords_sub(mcposadiffraction_detector_18, mcposaspec_detector_18);
  mcposrspec_detector_18 = rot_apply(mcrotaspec_detector_18, mctc1);
  mcDEBUG_COMPONENT("spec_detector_18", mcposaspec_detector_18, mcrotaspec_detector_18)
  mccomp_posa[922] = mcposaspec_detector_18;
  mccomp_posr[922] = mcposrspec_detector_18;
  mcNCounter[922]  = mcPCounter[922] = mcP2Counter[922] = 0;
  mcAbsorbProp[922]= 0;
    /* Component diffraction_detector_19. */
  /* Setting parameters for component diffraction_detector_19. */
  SIG_MESSAGE("diffraction_detector_19 (Init:SetPar)");
#line 5501 "MACS_sample_kidney_box.instr"
  mccdiffraction_detector_19_nx = 5;
#line 5501 "MACS_sample_kidney_box.instr"
  mccdiffraction_detector_19_ny = 5;
#line 5501 "MACS_sample_kidney_box.instr"
  if("diff_detector_19") strncpy(mccdiffraction_detector_19_filename, "diff_detector_19" ? "diff_detector_19" : "", 16384); else mccdiffraction_detector_19_filename[0]='\0';
#line 50 "MACS_sample_kidney_box.instr"
  mccdiffraction_detector_19_xmin = -0.05;
#line 50 "MACS_sample_kidney_box.instr"
  mccdiffraction_detector_19_xmax = 0.05;
#line 50 "MACS_sample_kidney_box.instr"
  mccdiffraction_detector_19_ymin = -0.05;
#line 50 "MACS_sample_kidney_box.instr"
  mccdiffraction_detector_19_ymax = 0.05;
#line 5500 "MACS_sample_kidney_box.instr"
  mccdiffraction_detector_19_xwidth = 2.0 * detector_radius;
#line 5500 "MACS_sample_kidney_box.instr"
  mccdiffraction_detector_19_yheight = 1.0 * detector_height;
#line 5500 "MACS_sample_kidney_box.instr"
  mccdiffraction_detector_19_restore_neutron = 1;
#line 152246 "MACS_sample_kidney_box.c"

  SIG_MESSAGE("diffraction_detector_19 (Init:Place/Rotate)");
  rot_set_rotation(mctr1,
#line 5503 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 5503 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 5503 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD);
#line 152256 "MACS_sample_kidney_box.c"
  rot_mul(mctr1, mcrotadiffraction_detector_19_exit_volume, mcrotadiffraction_detector_19);
  rot_transpose(mcrotaspec_detector_18, mctr1);
  rot_mul(mcrotadiffraction_detector_19, mctr1, mcrotrdiffraction_detector_19);
  mctc1 = coords_set(
#line 5502 "MACS_sample_kidney_box.instr"
    0,
#line 5502 "MACS_sample_kidney_box.instr"
    0,
#line 5502 "MACS_sample_kidney_box.instr"
    0);
#line 152267 "MACS_sample_kidney_box.c"
  rot_transpose(mcrotadiffraction_detector_19_exit_volume, mctr1);
  mctc2 = rot_apply(mctr1, mctc1);
  mcposadiffraction_detector_19 = coords_add(mcposadiffraction_detector_19_exit_volume, mctc2);
  mctc1 = coords_sub(mcposaspec_detector_18, mcposadiffraction_detector_19);
  mcposrdiffraction_detector_19 = rot_apply(mcrotadiffraction_detector_19, mctc1);
  mcDEBUG_COMPONENT("diffraction_detector_19", mcposadiffraction_detector_19, mcrotadiffraction_detector_19)
  mccomp_posa[923] = mcposadiffraction_detector_19;
  mccomp_posr[923] = mcposrdiffraction_detector_19;
  mcNCounter[923]  = mcPCounter[923] = mcP2Counter[923] = 0;
  mcAbsorbProp[923]= 0;
    /* Component spec_detector_19. */
  /* Setting parameters for component spec_detector_19. */
  SIG_MESSAGE("spec_detector_19 (Init:SetPar)");
#line 5515 "MACS_sample_kidney_box.instr"
  mccspec_detector_19_nx = 5;
#line 5515 "MACS_sample_kidney_box.instr"
  mccspec_detector_19_ny = 5;
#line 5515 "MACS_sample_kidney_box.instr"
  if("spec_detector_19") strncpy(mccspec_detector_19_filename, "spec_detector_19" ? "spec_detector_19" : "", 16384); else mccspec_detector_19_filename[0]='\0';
#line 50 "MACS_sample_kidney_box.instr"
  mccspec_detector_19_xmin = -0.05;
#line 50 "MACS_sample_kidney_box.instr"
  mccspec_detector_19_xmax = 0.05;
#line 50 "MACS_sample_kidney_box.instr"
  mccspec_detector_19_ymin = -0.05;
#line 50 "MACS_sample_kidney_box.instr"
  mccspec_detector_19_ymax = 0.05;
#line 5514 "MACS_sample_kidney_box.instr"
  mccspec_detector_19_xwidth = 2.0 * detector_radius;
#line 5514 "MACS_sample_kidney_box.instr"
  mccspec_detector_19_yheight = 1.0 * detector_height;
#line 5514 "MACS_sample_kidney_box.instr"
  mccspec_detector_19_restore_neutron = 1;
#line 152301 "MACS_sample_kidney_box.c"

  SIG_MESSAGE("spec_detector_19 (Init:Place/Rotate)");
  rot_set_rotation(mctr1,
#line 5517 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 5517 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 5517 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD);
#line 152311 "MACS_sample_kidney_box.c"
  rot_mul(mctr1, mcrotaspec_detector_19_exit_volume, mcrotaspec_detector_19);
  rot_transpose(mcrotadiffraction_detector_19, mctr1);
  rot_mul(mcrotaspec_detector_19, mctr1, mcrotrspec_detector_19);
  mctc1 = coords_set(
#line 5516 "MACS_sample_kidney_box.instr"
    0,
#line 5516 "MACS_sample_kidney_box.instr"
    0,
#line 5516 "MACS_sample_kidney_box.instr"
    0);
#line 152322 "MACS_sample_kidney_box.c"
  rot_transpose(mcrotaspec_detector_19_exit_volume, mctr1);
  mctc2 = rot_apply(mctr1, mctc1);
  mcposaspec_detector_19 = coords_add(mcposaspec_detector_19_exit_volume, mctc2);
  mctc1 = coords_sub(mcposadiffraction_detector_19, mcposaspec_detector_19);
  mcposrspec_detector_19 = rot_apply(mcrotaspec_detector_19, mctc1);
  mcDEBUG_COMPONENT("spec_detector_19", mcposaspec_detector_19, mcrotaspec_detector_19)
  mccomp_posa[924] = mcposaspec_detector_19;
  mccomp_posr[924] = mcposrspec_detector_19;
  mcNCounter[924]  = mcPCounter[924] = mcP2Counter[924] = 0;
  mcAbsorbProp[924]= 0;
    /* Component spec_detector_history_0. */
  /* Setting parameters for component spec_detector_history_0. */
  SIG_MESSAGE("spec_detector_history_0 (Init:SetPar)");
#line 5529 "MACS_sample_kidney_box.instr"
  if("spec_detector_history_0") strncpy(mccspec_detector_history_0_filename, "spec_detector_history_0" ? "spec_detector_history_0" : "", 16384); else mccspec_detector_history_0_filename[0]='\0';
#line 50 "MACS_sample_kidney_box.instr"
  mccspec_detector_history_0_xmin = -0.05;
#line 50 "MACS_sample_kidney_box.instr"
  mccspec_detector_history_0_xmax = 0.05;
#line 50 "MACS_sample_kidney_box.instr"
  mccspec_detector_history_0_ymin = -0.05;
#line 50 "MACS_sample_kidney_box.instr"
  mccspec_detector_history_0_ymax = 0.05;
#line 5528 "MACS_sample_kidney_box.instr"
  mccspec_detector_history_0_xwidth = 2.0 * detector_radius;
#line 5528 "MACS_sample_kidney_box.instr"
  mccspec_detector_history_0_yheight = 1.0 * detector_height;
#line 5528 "MACS_sample_kidney_box.instr"
  mccspec_detector_history_0_restore_neutron = 1;
#line 152352 "MACS_sample_kidney_box.c"

  SIG_MESSAGE("spec_detector_history_0 (Init:Place/Rotate)");
  rot_set_rotation(mctr1,
#line 5532 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 5532 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 5532 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD);
#line 152362 "MACS_sample_kidney_box.c"
  rot_mul(mctr1, mcrotaspec_detector_0_exit_volume, mcrotaspec_detector_history_0);
  rot_transpose(mcrotaspec_detector_19, mctr1);
  rot_mul(mcrotaspec_detector_history_0, mctr1, mcrotrspec_detector_history_0);
  mctc1 = coords_set(
#line 5531 "MACS_sample_kidney_box.instr"
    0,
#line 5531 "MACS_sample_kidney_box.instr"
    0,
#line 5531 "MACS_sample_kidney_box.instr"
    0);
#line 152373 "MACS_sample_kidney_box.c"
  rot_transpose(mcrotaspec_detector_0_exit_volume, mctr1);
  mctc2 = rot_apply(mctr1, mctc1);
  mcposaspec_detector_history_0 = coords_add(mcposaspec_detector_0_exit_volume, mctc2);
  mctc1 = coords_sub(mcposaspec_detector_19, mcposaspec_detector_history_0);
  mcposrspec_detector_history_0 = rot_apply(mcrotaspec_detector_history_0, mctc1);
  mcDEBUG_COMPONENT("spec_detector_history_0", mcposaspec_detector_history_0, mcrotaspec_detector_history_0)
  mccomp_posa[925] = mcposaspec_detector_history_0;
  mccomp_posr[925] = mcposrspec_detector_history_0;
  mcNCounter[925]  = mcPCounter[925] = mcP2Counter[925] = 0;
  mcAbsorbProp[925]= 0;
    /* Component spec_detector_history_1. */
  /* Setting parameters for component spec_detector_history_1. */
  SIG_MESSAGE("spec_detector_history_1 (Init:SetPar)");
#line 5562 "MACS_sample_kidney_box.instr"
  if("spec_detector_history_1") strncpy(mccspec_detector_history_1_filename, "spec_detector_history_1" ? "spec_detector_history_1" : "", 16384); else mccspec_detector_history_1_filename[0]='\0';
#line 50 "MACS_sample_kidney_box.instr"
  mccspec_detector_history_1_xmin = -0.05;
#line 50 "MACS_sample_kidney_box.instr"
  mccspec_detector_history_1_xmax = 0.05;
#line 50 "MACS_sample_kidney_box.instr"
  mccspec_detector_history_1_ymin = -0.05;
#line 50 "MACS_sample_kidney_box.instr"
  mccspec_detector_history_1_ymax = 0.05;
#line 5561 "MACS_sample_kidney_box.instr"
  mccspec_detector_history_1_xwidth = 2.0 * detector_radius;
#line 5561 "MACS_sample_kidney_box.instr"
  mccspec_detector_history_1_yheight = 1.0 * detector_height;
#line 5561 "MACS_sample_kidney_box.instr"
  mccspec_detector_history_1_restore_neutron = 1;
#line 152403 "MACS_sample_kidney_box.c"

  SIG_MESSAGE("spec_detector_history_1 (Init:Place/Rotate)");
  rot_set_rotation(mctr1,
#line 5565 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 5565 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 5565 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD);
#line 152413 "MACS_sample_kidney_box.c"
  rot_mul(mctr1, mcrotaspec_detector_1_exit_volume, mcrotaspec_detector_history_1);
  rot_transpose(mcrotaspec_detector_history_0, mctr1);
  rot_mul(mcrotaspec_detector_history_1, mctr1, mcrotrspec_detector_history_1);
  mctc1 = coords_set(
#line 5564 "MACS_sample_kidney_box.instr"
    0,
#line 5564 "MACS_sample_kidney_box.instr"
    0,
#line 5564 "MACS_sample_kidney_box.instr"
    0);
#line 152424 "MACS_sample_kidney_box.c"
  rot_transpose(mcrotaspec_detector_1_exit_volume, mctr1);
  mctc2 = rot_apply(mctr1, mctc1);
  mcposaspec_detector_history_1 = coords_add(mcposaspec_detector_1_exit_volume, mctc2);
  mctc1 = coords_sub(mcposaspec_detector_history_0, mcposaspec_detector_history_1);
  mcposrspec_detector_history_1 = rot_apply(mcrotaspec_detector_history_1, mctc1);
  mcDEBUG_COMPONENT("spec_detector_history_1", mcposaspec_detector_history_1, mcrotaspec_detector_history_1)
  mccomp_posa[926] = mcposaspec_detector_history_1;
  mccomp_posr[926] = mcposrspec_detector_history_1;
  mcNCounter[926]  = mcPCounter[926] = mcP2Counter[926] = 0;
  mcAbsorbProp[926]= 0;
    /* Component spec_detector_history_2. */
  /* Setting parameters for component spec_detector_history_2. */
  SIG_MESSAGE("spec_detector_history_2 (Init:SetPar)");
#line 5595 "MACS_sample_kidney_box.instr"
  if("spec_detector_history_2") strncpy(mccspec_detector_history_2_filename, "spec_detector_history_2" ? "spec_detector_history_2" : "", 16384); else mccspec_detector_history_2_filename[0]='\0';
#line 50 "MACS_sample_kidney_box.instr"
  mccspec_detector_history_2_xmin = -0.05;
#line 50 "MACS_sample_kidney_box.instr"
  mccspec_detector_history_2_xmax = 0.05;
#line 50 "MACS_sample_kidney_box.instr"
  mccspec_detector_history_2_ymin = -0.05;
#line 50 "MACS_sample_kidney_box.instr"
  mccspec_detector_history_2_ymax = 0.05;
#line 5594 "MACS_sample_kidney_box.instr"
  mccspec_detector_history_2_xwidth = 2.0 * detector_radius;
#line 5594 "MACS_sample_kidney_box.instr"
  mccspec_detector_history_2_yheight = 1.0 * detector_height;
#line 5594 "MACS_sample_kidney_box.instr"
  mccspec_detector_history_2_restore_neutron = 1;
#line 152454 "MACS_sample_kidney_box.c"

  SIG_MESSAGE("spec_detector_history_2 (Init:Place/Rotate)");
  rot_set_rotation(mctr1,
#line 5598 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 5598 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 5598 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD);
#line 152464 "MACS_sample_kidney_box.c"
  rot_mul(mctr1, mcrotaspec_detector_2_exit_volume, mcrotaspec_detector_history_2);
  rot_transpose(mcrotaspec_detector_history_1, mctr1);
  rot_mul(mcrotaspec_detector_history_2, mctr1, mcrotrspec_detector_history_2);
  mctc1 = coords_set(
#line 5597 "MACS_sample_kidney_box.instr"
    0,
#line 5597 "MACS_sample_kidney_box.instr"
    0,
#line 5597 "MACS_sample_kidney_box.instr"
    0);
#line 152475 "MACS_sample_kidney_box.c"
  rot_transpose(mcrotaspec_detector_2_exit_volume, mctr1);
  mctc2 = rot_apply(mctr1, mctc1);
  mcposaspec_detector_history_2 = coords_add(mcposaspec_detector_2_exit_volume, mctc2);
  mctc1 = coords_sub(mcposaspec_detector_history_1, mcposaspec_detector_history_2);
  mcposrspec_detector_history_2 = rot_apply(mcrotaspec_detector_history_2, mctc1);
  mcDEBUG_COMPONENT("spec_detector_history_2", mcposaspec_detector_history_2, mcrotaspec_detector_history_2)
  mccomp_posa[927] = mcposaspec_detector_history_2;
  mccomp_posr[927] = mcposrspec_detector_history_2;
  mcNCounter[927]  = mcPCounter[927] = mcP2Counter[927] = 0;
  mcAbsorbProp[927]= 0;
    /* Component spec_detector_history_3. */
  /* Setting parameters for component spec_detector_history_3. */
  SIG_MESSAGE("spec_detector_history_3 (Init:SetPar)");
#line 5628 "MACS_sample_kidney_box.instr"
  if("spec_detector_history_3") strncpy(mccspec_detector_history_3_filename, "spec_detector_history_3" ? "spec_detector_history_3" : "", 16384); else mccspec_detector_history_3_filename[0]='\0';
#line 50 "MACS_sample_kidney_box.instr"
  mccspec_detector_history_3_xmin = -0.05;
#line 50 "MACS_sample_kidney_box.instr"
  mccspec_detector_history_3_xmax = 0.05;
#line 50 "MACS_sample_kidney_box.instr"
  mccspec_detector_history_3_ymin = -0.05;
#line 50 "MACS_sample_kidney_box.instr"
  mccspec_detector_history_3_ymax = 0.05;
#line 5627 "MACS_sample_kidney_box.instr"
  mccspec_detector_history_3_xwidth = 2.0 * detector_radius;
#line 5627 "MACS_sample_kidney_box.instr"
  mccspec_detector_history_3_yheight = 1.0 * detector_height;
#line 5627 "MACS_sample_kidney_box.instr"
  mccspec_detector_history_3_restore_neutron = 1;
#line 152505 "MACS_sample_kidney_box.c"

  SIG_MESSAGE("spec_detector_history_3 (Init:Place/Rotate)");
  rot_set_rotation(mctr1,
#line 5631 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 5631 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 5631 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD);
#line 152515 "MACS_sample_kidney_box.c"
  rot_mul(mctr1, mcrotaspec_detector_3_exit_volume, mcrotaspec_detector_history_3);
  rot_transpose(mcrotaspec_detector_history_2, mctr1);
  rot_mul(mcrotaspec_detector_history_3, mctr1, mcrotrspec_detector_history_3);
  mctc1 = coords_set(
#line 5630 "MACS_sample_kidney_box.instr"
    0,
#line 5630 "MACS_sample_kidney_box.instr"
    0,
#line 5630 "MACS_sample_kidney_box.instr"
    0);
#line 152526 "MACS_sample_kidney_box.c"
  rot_transpose(mcrotaspec_detector_3_exit_volume, mctr1);
  mctc2 = rot_apply(mctr1, mctc1);
  mcposaspec_detector_history_3 = coords_add(mcposaspec_detector_3_exit_volume, mctc2);
  mctc1 = coords_sub(mcposaspec_detector_history_2, mcposaspec_detector_history_3);
  mcposrspec_detector_history_3 = rot_apply(mcrotaspec_detector_history_3, mctc1);
  mcDEBUG_COMPONENT("spec_detector_history_3", mcposaspec_detector_history_3, mcrotaspec_detector_history_3)
  mccomp_posa[928] = mcposaspec_detector_history_3;
  mccomp_posr[928] = mcposrspec_detector_history_3;
  mcNCounter[928]  = mcPCounter[928] = mcP2Counter[928] = 0;
  mcAbsorbProp[928]= 0;
    /* Component spec_detector_history_4. */
  /* Setting parameters for component spec_detector_history_4. */
  SIG_MESSAGE("spec_detector_history_4 (Init:SetPar)");
#line 5661 "MACS_sample_kidney_box.instr"
  if("spec_detector_history_4") strncpy(mccspec_detector_history_4_filename, "spec_detector_history_4" ? "spec_detector_history_4" : "", 16384); else mccspec_detector_history_4_filename[0]='\0';
#line 50 "MACS_sample_kidney_box.instr"
  mccspec_detector_history_4_xmin = -0.05;
#line 50 "MACS_sample_kidney_box.instr"
  mccspec_detector_history_4_xmax = 0.05;
#line 50 "MACS_sample_kidney_box.instr"
  mccspec_detector_history_4_ymin = -0.05;
#line 50 "MACS_sample_kidney_box.instr"
  mccspec_detector_history_4_ymax = 0.05;
#line 5660 "MACS_sample_kidney_box.instr"
  mccspec_detector_history_4_xwidth = 2.0 * detector_radius;
#line 5660 "MACS_sample_kidney_box.instr"
  mccspec_detector_history_4_yheight = 1.0 * detector_height;
#line 5660 "MACS_sample_kidney_box.instr"
  mccspec_detector_history_4_restore_neutron = 1;
#line 152556 "MACS_sample_kidney_box.c"

  SIG_MESSAGE("spec_detector_history_4 (Init:Place/Rotate)");
  rot_set_rotation(mctr1,
#line 5664 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 5664 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 5664 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD);
#line 152566 "MACS_sample_kidney_box.c"
  rot_mul(mctr1, mcrotaspec_detector_4_exit_volume, mcrotaspec_detector_history_4);
  rot_transpose(mcrotaspec_detector_history_3, mctr1);
  rot_mul(mcrotaspec_detector_history_4, mctr1, mcrotrspec_detector_history_4);
  mctc1 = coords_set(
#line 5663 "MACS_sample_kidney_box.instr"
    0,
#line 5663 "MACS_sample_kidney_box.instr"
    0,
#line 5663 "MACS_sample_kidney_box.instr"
    0);
#line 152577 "MACS_sample_kidney_box.c"
  rot_transpose(mcrotaspec_detector_4_exit_volume, mctr1);
  mctc2 = rot_apply(mctr1, mctc1);
  mcposaspec_detector_history_4 = coords_add(mcposaspec_detector_4_exit_volume, mctc2);
  mctc1 = coords_sub(mcposaspec_detector_history_3, mcposaspec_detector_history_4);
  mcposrspec_detector_history_4 = rot_apply(mcrotaspec_detector_history_4, mctc1);
  mcDEBUG_COMPONENT("spec_detector_history_4", mcposaspec_detector_history_4, mcrotaspec_detector_history_4)
  mccomp_posa[929] = mcposaspec_detector_history_4;
  mccomp_posr[929] = mcposrspec_detector_history_4;
  mcNCounter[929]  = mcPCounter[929] = mcP2Counter[929] = 0;
  mcAbsorbProp[929]= 0;
    /* Component spec_detector_history_5. */
  /* Setting parameters for component spec_detector_history_5. */
  SIG_MESSAGE("spec_detector_history_5 (Init:SetPar)");
#line 5694 "MACS_sample_kidney_box.instr"
  if("spec_detector_history_5") strncpy(mccspec_detector_history_5_filename, "spec_detector_history_5" ? "spec_detector_history_5" : "", 16384); else mccspec_detector_history_5_filename[0]='\0';
#line 50 "MACS_sample_kidney_box.instr"
  mccspec_detector_history_5_xmin = -0.05;
#line 50 "MACS_sample_kidney_box.instr"
  mccspec_detector_history_5_xmax = 0.05;
#line 50 "MACS_sample_kidney_box.instr"
  mccspec_detector_history_5_ymin = -0.05;
#line 50 "MACS_sample_kidney_box.instr"
  mccspec_detector_history_5_ymax = 0.05;
#line 5693 "MACS_sample_kidney_box.instr"
  mccspec_detector_history_5_xwidth = 2.0 * detector_radius;
#line 5693 "MACS_sample_kidney_box.instr"
  mccspec_detector_history_5_yheight = 1.0 * detector_height;
#line 5693 "MACS_sample_kidney_box.instr"
  mccspec_detector_history_5_restore_neutron = 1;
#line 152607 "MACS_sample_kidney_box.c"

  SIG_MESSAGE("spec_detector_history_5 (Init:Place/Rotate)");
  rot_set_rotation(mctr1,
#line 5697 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 5697 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 5697 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD);
#line 152617 "MACS_sample_kidney_box.c"
  rot_mul(mctr1, mcrotaspec_detector_5_exit_volume, mcrotaspec_detector_history_5);
  rot_transpose(mcrotaspec_detector_history_4, mctr1);
  rot_mul(mcrotaspec_detector_history_5, mctr1, mcrotrspec_detector_history_5);
  mctc1 = coords_set(
#line 5696 "MACS_sample_kidney_box.instr"
    0,
#line 5696 "MACS_sample_kidney_box.instr"
    0,
#line 5696 "MACS_sample_kidney_box.instr"
    0);
#line 152628 "MACS_sample_kidney_box.c"
  rot_transpose(mcrotaspec_detector_5_exit_volume, mctr1);
  mctc2 = rot_apply(mctr1, mctc1);
  mcposaspec_detector_history_5 = coords_add(mcposaspec_detector_5_exit_volume, mctc2);
  mctc1 = coords_sub(mcposaspec_detector_history_4, mcposaspec_detector_history_5);
  mcposrspec_detector_history_5 = rot_apply(mcrotaspec_detector_history_5, mctc1);
  mcDEBUG_COMPONENT("spec_detector_history_5", mcposaspec_detector_history_5, mcrotaspec_detector_history_5)
  mccomp_posa[930] = mcposaspec_detector_history_5;
  mccomp_posr[930] = mcposrspec_detector_history_5;
  mcNCounter[930]  = mcPCounter[930] = mcP2Counter[930] = 0;
  mcAbsorbProp[930]= 0;
    /* Component spec_detector_history_6. */
  /* Setting parameters for component spec_detector_history_6. */
  SIG_MESSAGE("spec_detector_history_6 (Init:SetPar)");
#line 5727 "MACS_sample_kidney_box.instr"
  if("spec_detector_history_6") strncpy(mccspec_detector_history_6_filename, "spec_detector_history_6" ? "spec_detector_history_6" : "", 16384); else mccspec_detector_history_6_filename[0]='\0';
#line 50 "MACS_sample_kidney_box.instr"
  mccspec_detector_history_6_xmin = -0.05;
#line 50 "MACS_sample_kidney_box.instr"
  mccspec_detector_history_6_xmax = 0.05;
#line 50 "MACS_sample_kidney_box.instr"
  mccspec_detector_history_6_ymin = -0.05;
#line 50 "MACS_sample_kidney_box.instr"
  mccspec_detector_history_6_ymax = 0.05;
#line 5726 "MACS_sample_kidney_box.instr"
  mccspec_detector_history_6_xwidth = 2.0 * detector_radius;
#line 5726 "MACS_sample_kidney_box.instr"
  mccspec_detector_history_6_yheight = 1.0 * detector_height;
#line 5726 "MACS_sample_kidney_box.instr"
  mccspec_detector_history_6_restore_neutron = 1;
#line 152658 "MACS_sample_kidney_box.c"

  SIG_MESSAGE("spec_detector_history_6 (Init:Place/Rotate)");
  rot_set_rotation(mctr1,
#line 5730 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 5730 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 5730 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD);
#line 152668 "MACS_sample_kidney_box.c"
  rot_mul(mctr1, mcrotaspec_detector_6_exit_volume, mcrotaspec_detector_history_6);
  rot_transpose(mcrotaspec_detector_history_5, mctr1);
  rot_mul(mcrotaspec_detector_history_6, mctr1, mcrotrspec_detector_history_6);
  mctc1 = coords_set(
#line 5729 "MACS_sample_kidney_box.instr"
    0,
#line 5729 "MACS_sample_kidney_box.instr"
    0,
#line 5729 "MACS_sample_kidney_box.instr"
    0);
#line 152679 "MACS_sample_kidney_box.c"
  rot_transpose(mcrotaspec_detector_6_exit_volume, mctr1);
  mctc2 = rot_apply(mctr1, mctc1);
  mcposaspec_detector_history_6 = coords_add(mcposaspec_detector_6_exit_volume, mctc2);
  mctc1 = coords_sub(mcposaspec_detector_history_5, mcposaspec_detector_history_6);
  mcposrspec_detector_history_6 = rot_apply(mcrotaspec_detector_history_6, mctc1);
  mcDEBUG_COMPONENT("spec_detector_history_6", mcposaspec_detector_history_6, mcrotaspec_detector_history_6)
  mccomp_posa[931] = mcposaspec_detector_history_6;
  mccomp_posr[931] = mcposrspec_detector_history_6;
  mcNCounter[931]  = mcPCounter[931] = mcP2Counter[931] = 0;
  mcAbsorbProp[931]= 0;
    /* Component spec_detector_history_7. */
  /* Setting parameters for component spec_detector_history_7. */
  SIG_MESSAGE("spec_detector_history_7 (Init:SetPar)");
#line 5760 "MACS_sample_kidney_box.instr"
  if("spec_detector_history_7") strncpy(mccspec_detector_history_7_filename, "spec_detector_history_7" ? "spec_detector_history_7" : "", 16384); else mccspec_detector_history_7_filename[0]='\0';
#line 50 "MACS_sample_kidney_box.instr"
  mccspec_detector_history_7_xmin = -0.05;
#line 50 "MACS_sample_kidney_box.instr"
  mccspec_detector_history_7_xmax = 0.05;
#line 50 "MACS_sample_kidney_box.instr"
  mccspec_detector_history_7_ymin = -0.05;
#line 50 "MACS_sample_kidney_box.instr"
  mccspec_detector_history_7_ymax = 0.05;
#line 5759 "MACS_sample_kidney_box.instr"
  mccspec_detector_history_7_xwidth = 2.0 * detector_radius;
#line 5759 "MACS_sample_kidney_box.instr"
  mccspec_detector_history_7_yheight = 1.0 * detector_height;
#line 5759 "MACS_sample_kidney_box.instr"
  mccspec_detector_history_7_restore_neutron = 1;
#line 152709 "MACS_sample_kidney_box.c"

  SIG_MESSAGE("spec_detector_history_7 (Init:Place/Rotate)");
  rot_set_rotation(mctr1,
#line 5763 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 5763 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 5763 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD);
#line 152719 "MACS_sample_kidney_box.c"
  rot_mul(mctr1, mcrotaspec_detector_7_exit_volume, mcrotaspec_detector_history_7);
  rot_transpose(mcrotaspec_detector_history_6, mctr1);
  rot_mul(mcrotaspec_detector_history_7, mctr1, mcrotrspec_detector_history_7);
  mctc1 = coords_set(
#line 5762 "MACS_sample_kidney_box.instr"
    0,
#line 5762 "MACS_sample_kidney_box.instr"
    0,
#line 5762 "MACS_sample_kidney_box.instr"
    0);
#line 152730 "MACS_sample_kidney_box.c"
  rot_transpose(mcrotaspec_detector_7_exit_volume, mctr1);
  mctc2 = rot_apply(mctr1, mctc1);
  mcposaspec_detector_history_7 = coords_add(mcposaspec_detector_7_exit_volume, mctc2);
  mctc1 = coords_sub(mcposaspec_detector_history_6, mcposaspec_detector_history_7);
  mcposrspec_detector_history_7 = rot_apply(mcrotaspec_detector_history_7, mctc1);
  mcDEBUG_COMPONENT("spec_detector_history_7", mcposaspec_detector_history_7, mcrotaspec_detector_history_7)
  mccomp_posa[932] = mcposaspec_detector_history_7;
  mccomp_posr[932] = mcposrspec_detector_history_7;
  mcNCounter[932]  = mcPCounter[932] = mcP2Counter[932] = 0;
  mcAbsorbProp[932]= 0;
    /* Component spec_detector_history_8. */
  /* Setting parameters for component spec_detector_history_8. */
  SIG_MESSAGE("spec_detector_history_8 (Init:SetPar)");
#line 5793 "MACS_sample_kidney_box.instr"
  if("spec_detector_history_8") strncpy(mccspec_detector_history_8_filename, "spec_detector_history_8" ? "spec_detector_history_8" : "", 16384); else mccspec_detector_history_8_filename[0]='\0';
#line 50 "MACS_sample_kidney_box.instr"
  mccspec_detector_history_8_xmin = -0.05;
#line 50 "MACS_sample_kidney_box.instr"
  mccspec_detector_history_8_xmax = 0.05;
#line 50 "MACS_sample_kidney_box.instr"
  mccspec_detector_history_8_ymin = -0.05;
#line 50 "MACS_sample_kidney_box.instr"
  mccspec_detector_history_8_ymax = 0.05;
#line 5792 "MACS_sample_kidney_box.instr"
  mccspec_detector_history_8_xwidth = 2.0 * detector_radius;
#line 5792 "MACS_sample_kidney_box.instr"
  mccspec_detector_history_8_yheight = 1.0 * detector_height;
#line 5792 "MACS_sample_kidney_box.instr"
  mccspec_detector_history_8_restore_neutron = 1;
#line 152760 "MACS_sample_kidney_box.c"

  SIG_MESSAGE("spec_detector_history_8 (Init:Place/Rotate)");
  rot_set_rotation(mctr1,
#line 5796 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 5796 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 5796 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD);
#line 152770 "MACS_sample_kidney_box.c"
  rot_mul(mctr1, mcrotaspec_detector_8_exit_volume, mcrotaspec_detector_history_8);
  rot_transpose(mcrotaspec_detector_history_7, mctr1);
  rot_mul(mcrotaspec_detector_history_8, mctr1, mcrotrspec_detector_history_8);
  mctc1 = coords_set(
#line 5795 "MACS_sample_kidney_box.instr"
    0,
#line 5795 "MACS_sample_kidney_box.instr"
    0,
#line 5795 "MACS_sample_kidney_box.instr"
    0);
#line 152781 "MACS_sample_kidney_box.c"
  rot_transpose(mcrotaspec_detector_8_exit_volume, mctr1);
  mctc2 = rot_apply(mctr1, mctc1);
  mcposaspec_detector_history_8 = coords_add(mcposaspec_detector_8_exit_volume, mctc2);
  mctc1 = coords_sub(mcposaspec_detector_history_7, mcposaspec_detector_history_8);
  mcposrspec_detector_history_8 = rot_apply(mcrotaspec_detector_history_8, mctc1);
  mcDEBUG_COMPONENT("spec_detector_history_8", mcposaspec_detector_history_8, mcrotaspec_detector_history_8)
  mccomp_posa[933] = mcposaspec_detector_history_8;
  mccomp_posr[933] = mcposrspec_detector_history_8;
  mcNCounter[933]  = mcPCounter[933] = mcP2Counter[933] = 0;
  mcAbsorbProp[933]= 0;
    /* Component spec_detector_history_9. */
  /* Setting parameters for component spec_detector_history_9. */
  SIG_MESSAGE("spec_detector_history_9 (Init:SetPar)");
#line 5826 "MACS_sample_kidney_box.instr"
  if("spec_detector_history_9") strncpy(mccspec_detector_history_9_filename, "spec_detector_history_9" ? "spec_detector_history_9" : "", 16384); else mccspec_detector_history_9_filename[0]='\0';
#line 50 "MACS_sample_kidney_box.instr"
  mccspec_detector_history_9_xmin = -0.05;
#line 50 "MACS_sample_kidney_box.instr"
  mccspec_detector_history_9_xmax = 0.05;
#line 50 "MACS_sample_kidney_box.instr"
  mccspec_detector_history_9_ymin = -0.05;
#line 50 "MACS_sample_kidney_box.instr"
  mccspec_detector_history_9_ymax = 0.05;
#line 5825 "MACS_sample_kidney_box.instr"
  mccspec_detector_history_9_xwidth = 2.0 * detector_radius;
#line 5825 "MACS_sample_kidney_box.instr"
  mccspec_detector_history_9_yheight = 1.0 * detector_height;
#line 5825 "MACS_sample_kidney_box.instr"
  mccspec_detector_history_9_restore_neutron = 1;
#line 152811 "MACS_sample_kidney_box.c"

  SIG_MESSAGE("spec_detector_history_9 (Init:Place/Rotate)");
  rot_set_rotation(mctr1,
#line 5829 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 5829 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 5829 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD);
#line 152821 "MACS_sample_kidney_box.c"
  rot_mul(mctr1, mcrotaspec_detector_9_exit_volume, mcrotaspec_detector_history_9);
  rot_transpose(mcrotaspec_detector_history_8, mctr1);
  rot_mul(mcrotaspec_detector_history_9, mctr1, mcrotrspec_detector_history_9);
  mctc1 = coords_set(
#line 5828 "MACS_sample_kidney_box.instr"
    0,
#line 5828 "MACS_sample_kidney_box.instr"
    0,
#line 5828 "MACS_sample_kidney_box.instr"
    0);
#line 152832 "MACS_sample_kidney_box.c"
  rot_transpose(mcrotaspec_detector_9_exit_volume, mctr1);
  mctc2 = rot_apply(mctr1, mctc1);
  mcposaspec_detector_history_9 = coords_add(mcposaspec_detector_9_exit_volume, mctc2);
  mctc1 = coords_sub(mcposaspec_detector_history_8, mcposaspec_detector_history_9);
  mcposrspec_detector_history_9 = rot_apply(mcrotaspec_detector_history_9, mctc1);
  mcDEBUG_COMPONENT("spec_detector_history_9", mcposaspec_detector_history_9, mcrotaspec_detector_history_9)
  mccomp_posa[934] = mcposaspec_detector_history_9;
  mccomp_posr[934] = mcposrspec_detector_history_9;
  mcNCounter[934]  = mcPCounter[934] = mcP2Counter[934] = 0;
  mcAbsorbProp[934]= 0;
    /* Component spec_detector_history_10. */
  /* Setting parameters for component spec_detector_history_10. */
  SIG_MESSAGE("spec_detector_history_10 (Init:SetPar)");
#line 5859 "MACS_sample_kidney_box.instr"
  if("spec_detector_history_10") strncpy(mccspec_detector_history_10_filename, "spec_detector_history_10" ? "spec_detector_history_10" : "", 16384); else mccspec_detector_history_10_filename[0]='\0';
#line 50 "MACS_sample_kidney_box.instr"
  mccspec_detector_history_10_xmin = -0.05;
#line 50 "MACS_sample_kidney_box.instr"
  mccspec_detector_history_10_xmax = 0.05;
#line 50 "MACS_sample_kidney_box.instr"
  mccspec_detector_history_10_ymin = -0.05;
#line 50 "MACS_sample_kidney_box.instr"
  mccspec_detector_history_10_ymax = 0.05;
#line 5858 "MACS_sample_kidney_box.instr"
  mccspec_detector_history_10_xwidth = 2.0 * detector_radius;
#line 5858 "MACS_sample_kidney_box.instr"
  mccspec_detector_history_10_yheight = 1.0 * detector_height;
#line 5858 "MACS_sample_kidney_box.instr"
  mccspec_detector_history_10_restore_neutron = 1;
#line 152862 "MACS_sample_kidney_box.c"

  SIG_MESSAGE("spec_detector_history_10 (Init:Place/Rotate)");
  rot_set_rotation(mctr1,
#line 5862 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 5862 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 5862 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD);
#line 152872 "MACS_sample_kidney_box.c"
  rot_mul(mctr1, mcrotaspec_detector_10_exit_volume, mcrotaspec_detector_history_10);
  rot_transpose(mcrotaspec_detector_history_9, mctr1);
  rot_mul(mcrotaspec_detector_history_10, mctr1, mcrotrspec_detector_history_10);
  mctc1 = coords_set(
#line 5861 "MACS_sample_kidney_box.instr"
    0,
#line 5861 "MACS_sample_kidney_box.instr"
    0,
#line 5861 "MACS_sample_kidney_box.instr"
    0);
#line 152883 "MACS_sample_kidney_box.c"
  rot_transpose(mcrotaspec_detector_10_exit_volume, mctr1);
  mctc2 = rot_apply(mctr1, mctc1);
  mcposaspec_detector_history_10 = coords_add(mcposaspec_detector_10_exit_volume, mctc2);
  mctc1 = coords_sub(mcposaspec_detector_history_9, mcposaspec_detector_history_10);
  mcposrspec_detector_history_10 = rot_apply(mcrotaspec_detector_history_10, mctc1);
  mcDEBUG_COMPONENT("spec_detector_history_10", mcposaspec_detector_history_10, mcrotaspec_detector_history_10)
  mccomp_posa[935] = mcposaspec_detector_history_10;
  mccomp_posr[935] = mcposrspec_detector_history_10;
  mcNCounter[935]  = mcPCounter[935] = mcP2Counter[935] = 0;
  mcAbsorbProp[935]= 0;
    /* Component spec_detector_history_11. */
  /* Setting parameters for component spec_detector_history_11. */
  SIG_MESSAGE("spec_detector_history_11 (Init:SetPar)");
#line 5892 "MACS_sample_kidney_box.instr"
  if("spec_detector_history_11") strncpy(mccspec_detector_history_11_filename, "spec_detector_history_11" ? "spec_detector_history_11" : "", 16384); else mccspec_detector_history_11_filename[0]='\0';
#line 50 "MACS_sample_kidney_box.instr"
  mccspec_detector_history_11_xmin = -0.05;
#line 50 "MACS_sample_kidney_box.instr"
  mccspec_detector_history_11_xmax = 0.05;
#line 50 "MACS_sample_kidney_box.instr"
  mccspec_detector_history_11_ymin = -0.05;
#line 50 "MACS_sample_kidney_box.instr"
  mccspec_detector_history_11_ymax = 0.05;
#line 5891 "MACS_sample_kidney_box.instr"
  mccspec_detector_history_11_xwidth = 2.0 * detector_radius;
#line 5891 "MACS_sample_kidney_box.instr"
  mccspec_detector_history_11_yheight = 1.0 * detector_height;
#line 5891 "MACS_sample_kidney_box.instr"
  mccspec_detector_history_11_restore_neutron = 1;
#line 152913 "MACS_sample_kidney_box.c"

  SIG_MESSAGE("spec_detector_history_11 (Init:Place/Rotate)");
  rot_set_rotation(mctr1,
#line 5895 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 5895 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 5895 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD);
#line 152923 "MACS_sample_kidney_box.c"
  rot_mul(mctr1, mcrotaspec_detector_11_exit_volume, mcrotaspec_detector_history_11);
  rot_transpose(mcrotaspec_detector_history_10, mctr1);
  rot_mul(mcrotaspec_detector_history_11, mctr1, mcrotrspec_detector_history_11);
  mctc1 = coords_set(
#line 5894 "MACS_sample_kidney_box.instr"
    0,
#line 5894 "MACS_sample_kidney_box.instr"
    0,
#line 5894 "MACS_sample_kidney_box.instr"
    0);
#line 152934 "MACS_sample_kidney_box.c"
  rot_transpose(mcrotaspec_detector_11_exit_volume, mctr1);
  mctc2 = rot_apply(mctr1, mctc1);
  mcposaspec_detector_history_11 = coords_add(mcposaspec_detector_11_exit_volume, mctc2);
  mctc1 = coords_sub(mcposaspec_detector_history_10, mcposaspec_detector_history_11);
  mcposrspec_detector_history_11 = rot_apply(mcrotaspec_detector_history_11, mctc1);
  mcDEBUG_COMPONENT("spec_detector_history_11", mcposaspec_detector_history_11, mcrotaspec_detector_history_11)
  mccomp_posa[936] = mcposaspec_detector_history_11;
  mccomp_posr[936] = mcposrspec_detector_history_11;
  mcNCounter[936]  = mcPCounter[936] = mcP2Counter[936] = 0;
  mcAbsorbProp[936]= 0;
    /* Component spec_detector_history_12. */
  /* Setting parameters for component spec_detector_history_12. */
  SIG_MESSAGE("spec_detector_history_12 (Init:SetPar)");
#line 5925 "MACS_sample_kidney_box.instr"
  if("spec_detector_history_12") strncpy(mccspec_detector_history_12_filename, "spec_detector_history_12" ? "spec_detector_history_12" : "", 16384); else mccspec_detector_history_12_filename[0]='\0';
#line 50 "MACS_sample_kidney_box.instr"
  mccspec_detector_history_12_xmin = -0.05;
#line 50 "MACS_sample_kidney_box.instr"
  mccspec_detector_history_12_xmax = 0.05;
#line 50 "MACS_sample_kidney_box.instr"
  mccspec_detector_history_12_ymin = -0.05;
#line 50 "MACS_sample_kidney_box.instr"
  mccspec_detector_history_12_ymax = 0.05;
#line 5924 "MACS_sample_kidney_box.instr"
  mccspec_detector_history_12_xwidth = 2.0 * detector_radius;
#line 5924 "MACS_sample_kidney_box.instr"
  mccspec_detector_history_12_yheight = 1.0 * detector_height;
#line 5924 "MACS_sample_kidney_box.instr"
  mccspec_detector_history_12_restore_neutron = 1;
#line 152964 "MACS_sample_kidney_box.c"

  SIG_MESSAGE("spec_detector_history_12 (Init:Place/Rotate)");
  rot_set_rotation(mctr1,
#line 5928 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 5928 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 5928 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD);
#line 152974 "MACS_sample_kidney_box.c"
  rot_mul(mctr1, mcrotaspec_detector_12_exit_volume, mcrotaspec_detector_history_12);
  rot_transpose(mcrotaspec_detector_history_11, mctr1);
  rot_mul(mcrotaspec_detector_history_12, mctr1, mcrotrspec_detector_history_12);
  mctc1 = coords_set(
#line 5927 "MACS_sample_kidney_box.instr"
    0,
#line 5927 "MACS_sample_kidney_box.instr"
    0,
#line 5927 "MACS_sample_kidney_box.instr"
    0);
#line 152985 "MACS_sample_kidney_box.c"
  rot_transpose(mcrotaspec_detector_12_exit_volume, mctr1);
  mctc2 = rot_apply(mctr1, mctc1);
  mcposaspec_detector_history_12 = coords_add(mcposaspec_detector_12_exit_volume, mctc2);
  mctc1 = coords_sub(mcposaspec_detector_history_11, mcposaspec_detector_history_12);
  mcposrspec_detector_history_12 = rot_apply(mcrotaspec_detector_history_12, mctc1);
  mcDEBUG_COMPONENT("spec_detector_history_12", mcposaspec_detector_history_12, mcrotaspec_detector_history_12)
  mccomp_posa[937] = mcposaspec_detector_history_12;
  mccomp_posr[937] = mcposrspec_detector_history_12;
  mcNCounter[937]  = mcPCounter[937] = mcP2Counter[937] = 0;
  mcAbsorbProp[937]= 0;
    /* Component spec_detector_history_13. */
  /* Setting parameters for component spec_detector_history_13. */
  SIG_MESSAGE("spec_detector_history_13 (Init:SetPar)");
#line 5958 "MACS_sample_kidney_box.instr"
  if("spec_detector_history_13") strncpy(mccspec_detector_history_13_filename, "spec_detector_history_13" ? "spec_detector_history_13" : "", 16384); else mccspec_detector_history_13_filename[0]='\0';
#line 50 "MACS_sample_kidney_box.instr"
  mccspec_detector_history_13_xmin = -0.05;
#line 50 "MACS_sample_kidney_box.instr"
  mccspec_detector_history_13_xmax = 0.05;
#line 50 "MACS_sample_kidney_box.instr"
  mccspec_detector_history_13_ymin = -0.05;
#line 50 "MACS_sample_kidney_box.instr"
  mccspec_detector_history_13_ymax = 0.05;
#line 5957 "MACS_sample_kidney_box.instr"
  mccspec_detector_history_13_xwidth = 2.0 * detector_radius;
#line 5957 "MACS_sample_kidney_box.instr"
  mccspec_detector_history_13_yheight = 1.0 * detector_height;
#line 5957 "MACS_sample_kidney_box.instr"
  mccspec_detector_history_13_restore_neutron = 1;
#line 153015 "MACS_sample_kidney_box.c"

  SIG_MESSAGE("spec_detector_history_13 (Init:Place/Rotate)");
  rot_set_rotation(mctr1,
#line 5961 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 5961 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 5961 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD);
#line 153025 "MACS_sample_kidney_box.c"
  rot_mul(mctr1, mcrotaspec_detector_13_exit_volume, mcrotaspec_detector_history_13);
  rot_transpose(mcrotaspec_detector_history_12, mctr1);
  rot_mul(mcrotaspec_detector_history_13, mctr1, mcrotrspec_detector_history_13);
  mctc1 = coords_set(
#line 5960 "MACS_sample_kidney_box.instr"
    0,
#line 5960 "MACS_sample_kidney_box.instr"
    0,
#line 5960 "MACS_sample_kidney_box.instr"
    0);
#line 153036 "MACS_sample_kidney_box.c"
  rot_transpose(mcrotaspec_detector_13_exit_volume, mctr1);
  mctc2 = rot_apply(mctr1, mctc1);
  mcposaspec_detector_history_13 = coords_add(mcposaspec_detector_13_exit_volume, mctc2);
  mctc1 = coords_sub(mcposaspec_detector_history_12, mcposaspec_detector_history_13);
  mcposrspec_detector_history_13 = rot_apply(mcrotaspec_detector_history_13, mctc1);
  mcDEBUG_COMPONENT("spec_detector_history_13", mcposaspec_detector_history_13, mcrotaspec_detector_history_13)
  mccomp_posa[938] = mcposaspec_detector_history_13;
  mccomp_posr[938] = mcposrspec_detector_history_13;
  mcNCounter[938]  = mcPCounter[938] = mcP2Counter[938] = 0;
  mcAbsorbProp[938]= 0;
    /* Component spec_detector_history_14. */
  /* Setting parameters for component spec_detector_history_14. */
  SIG_MESSAGE("spec_detector_history_14 (Init:SetPar)");
#line 5991 "MACS_sample_kidney_box.instr"
  if("spec_detector_history_14") strncpy(mccspec_detector_history_14_filename, "spec_detector_history_14" ? "spec_detector_history_14" : "", 16384); else mccspec_detector_history_14_filename[0]='\0';
#line 50 "MACS_sample_kidney_box.instr"
  mccspec_detector_history_14_xmin = -0.05;
#line 50 "MACS_sample_kidney_box.instr"
  mccspec_detector_history_14_xmax = 0.05;
#line 50 "MACS_sample_kidney_box.instr"
  mccspec_detector_history_14_ymin = -0.05;
#line 50 "MACS_sample_kidney_box.instr"
  mccspec_detector_history_14_ymax = 0.05;
#line 5990 "MACS_sample_kidney_box.instr"
  mccspec_detector_history_14_xwidth = 2.0 * detector_radius;
#line 5990 "MACS_sample_kidney_box.instr"
  mccspec_detector_history_14_yheight = 1.0 * detector_height;
#line 5990 "MACS_sample_kidney_box.instr"
  mccspec_detector_history_14_restore_neutron = 1;
#line 153066 "MACS_sample_kidney_box.c"

  SIG_MESSAGE("spec_detector_history_14 (Init:Place/Rotate)");
  rot_set_rotation(mctr1,
#line 5994 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 5994 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 5994 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD);
#line 153076 "MACS_sample_kidney_box.c"
  rot_mul(mctr1, mcrotaspec_detector_14_exit_volume, mcrotaspec_detector_history_14);
  rot_transpose(mcrotaspec_detector_history_13, mctr1);
  rot_mul(mcrotaspec_detector_history_14, mctr1, mcrotrspec_detector_history_14);
  mctc1 = coords_set(
#line 5993 "MACS_sample_kidney_box.instr"
    0,
#line 5993 "MACS_sample_kidney_box.instr"
    0,
#line 5993 "MACS_sample_kidney_box.instr"
    0);
#line 153087 "MACS_sample_kidney_box.c"
  rot_transpose(mcrotaspec_detector_14_exit_volume, mctr1);
  mctc2 = rot_apply(mctr1, mctc1);
  mcposaspec_detector_history_14 = coords_add(mcposaspec_detector_14_exit_volume, mctc2);
  mctc1 = coords_sub(mcposaspec_detector_history_13, mcposaspec_detector_history_14);
  mcposrspec_detector_history_14 = rot_apply(mcrotaspec_detector_history_14, mctc1);
  mcDEBUG_COMPONENT("spec_detector_history_14", mcposaspec_detector_history_14, mcrotaspec_detector_history_14)
  mccomp_posa[939] = mcposaspec_detector_history_14;
  mccomp_posr[939] = mcposrspec_detector_history_14;
  mcNCounter[939]  = mcPCounter[939] = mcP2Counter[939] = 0;
  mcAbsorbProp[939]= 0;
    /* Component spec_detector_history_15. */
  /* Setting parameters for component spec_detector_history_15. */
  SIG_MESSAGE("spec_detector_history_15 (Init:SetPar)");
#line 6024 "MACS_sample_kidney_box.instr"
  if("spec_detector_history_15") strncpy(mccspec_detector_history_15_filename, "spec_detector_history_15" ? "spec_detector_history_15" : "", 16384); else mccspec_detector_history_15_filename[0]='\0';
#line 50 "MACS_sample_kidney_box.instr"
  mccspec_detector_history_15_xmin = -0.05;
#line 50 "MACS_sample_kidney_box.instr"
  mccspec_detector_history_15_xmax = 0.05;
#line 50 "MACS_sample_kidney_box.instr"
  mccspec_detector_history_15_ymin = -0.05;
#line 50 "MACS_sample_kidney_box.instr"
  mccspec_detector_history_15_ymax = 0.05;
#line 6023 "MACS_sample_kidney_box.instr"
  mccspec_detector_history_15_xwidth = 2.0 * detector_radius;
#line 6023 "MACS_sample_kidney_box.instr"
  mccspec_detector_history_15_yheight = 1.0 * detector_height;
#line 6023 "MACS_sample_kidney_box.instr"
  mccspec_detector_history_15_restore_neutron = 1;
#line 153117 "MACS_sample_kidney_box.c"

  SIG_MESSAGE("spec_detector_history_15 (Init:Place/Rotate)");
  rot_set_rotation(mctr1,
#line 6027 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 6027 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 6027 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD);
#line 153127 "MACS_sample_kidney_box.c"
  rot_mul(mctr1, mcrotaspec_detector_15_exit_volume, mcrotaspec_detector_history_15);
  rot_transpose(mcrotaspec_detector_history_14, mctr1);
  rot_mul(mcrotaspec_detector_history_15, mctr1, mcrotrspec_detector_history_15);
  mctc1 = coords_set(
#line 6026 "MACS_sample_kidney_box.instr"
    0,
#line 6026 "MACS_sample_kidney_box.instr"
    0,
#line 6026 "MACS_sample_kidney_box.instr"
    0);
#line 153138 "MACS_sample_kidney_box.c"
  rot_transpose(mcrotaspec_detector_15_exit_volume, mctr1);
  mctc2 = rot_apply(mctr1, mctc1);
  mcposaspec_detector_history_15 = coords_add(mcposaspec_detector_15_exit_volume, mctc2);
  mctc1 = coords_sub(mcposaspec_detector_history_14, mcposaspec_detector_history_15);
  mcposrspec_detector_history_15 = rot_apply(mcrotaspec_detector_history_15, mctc1);
  mcDEBUG_COMPONENT("spec_detector_history_15", mcposaspec_detector_history_15, mcrotaspec_detector_history_15)
  mccomp_posa[940] = mcposaspec_detector_history_15;
  mccomp_posr[940] = mcposrspec_detector_history_15;
  mcNCounter[940]  = mcPCounter[940] = mcP2Counter[940] = 0;
  mcAbsorbProp[940]= 0;
    /* Component spec_detector_history_16. */
  /* Setting parameters for component spec_detector_history_16. */
  SIG_MESSAGE("spec_detector_history_16 (Init:SetPar)");
#line 6057 "MACS_sample_kidney_box.instr"
  if("spec_detector_history_16") strncpy(mccspec_detector_history_16_filename, "spec_detector_history_16" ? "spec_detector_history_16" : "", 16384); else mccspec_detector_history_16_filename[0]='\0';
#line 50 "MACS_sample_kidney_box.instr"
  mccspec_detector_history_16_xmin = -0.05;
#line 50 "MACS_sample_kidney_box.instr"
  mccspec_detector_history_16_xmax = 0.05;
#line 50 "MACS_sample_kidney_box.instr"
  mccspec_detector_history_16_ymin = -0.05;
#line 50 "MACS_sample_kidney_box.instr"
  mccspec_detector_history_16_ymax = 0.05;
#line 6056 "MACS_sample_kidney_box.instr"
  mccspec_detector_history_16_xwidth = 2.0 * detector_radius;
#line 6056 "MACS_sample_kidney_box.instr"
  mccspec_detector_history_16_yheight = 1.0 * detector_height;
#line 6056 "MACS_sample_kidney_box.instr"
  mccspec_detector_history_16_restore_neutron = 1;
#line 153168 "MACS_sample_kidney_box.c"

  SIG_MESSAGE("spec_detector_history_16 (Init:Place/Rotate)");
  rot_set_rotation(mctr1,
#line 6060 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 6060 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 6060 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD);
#line 153178 "MACS_sample_kidney_box.c"
  rot_mul(mctr1, mcrotaspec_detector_16_exit_volume, mcrotaspec_detector_history_16);
  rot_transpose(mcrotaspec_detector_history_15, mctr1);
  rot_mul(mcrotaspec_detector_history_16, mctr1, mcrotrspec_detector_history_16);
  mctc1 = coords_set(
#line 6059 "MACS_sample_kidney_box.instr"
    0,
#line 6059 "MACS_sample_kidney_box.instr"
    0,
#line 6059 "MACS_sample_kidney_box.instr"
    0);
#line 153189 "MACS_sample_kidney_box.c"
  rot_transpose(mcrotaspec_detector_16_exit_volume, mctr1);
  mctc2 = rot_apply(mctr1, mctc1);
  mcposaspec_detector_history_16 = coords_add(mcposaspec_detector_16_exit_volume, mctc2);
  mctc1 = coords_sub(mcposaspec_detector_history_15, mcposaspec_detector_history_16);
  mcposrspec_detector_history_16 = rot_apply(mcrotaspec_detector_history_16, mctc1);
  mcDEBUG_COMPONENT("spec_detector_history_16", mcposaspec_detector_history_16, mcrotaspec_detector_history_16)
  mccomp_posa[941] = mcposaspec_detector_history_16;
  mccomp_posr[941] = mcposrspec_detector_history_16;
  mcNCounter[941]  = mcPCounter[941] = mcP2Counter[941] = 0;
  mcAbsorbProp[941]= 0;
    /* Component spec_detector_history_17. */
  /* Setting parameters for component spec_detector_history_17. */
  SIG_MESSAGE("spec_detector_history_17 (Init:SetPar)");
#line 6090 "MACS_sample_kidney_box.instr"
  if("spec_detector_history_17") strncpy(mccspec_detector_history_17_filename, "spec_detector_history_17" ? "spec_detector_history_17" : "", 16384); else mccspec_detector_history_17_filename[0]='\0';
#line 50 "MACS_sample_kidney_box.instr"
  mccspec_detector_history_17_xmin = -0.05;
#line 50 "MACS_sample_kidney_box.instr"
  mccspec_detector_history_17_xmax = 0.05;
#line 50 "MACS_sample_kidney_box.instr"
  mccspec_detector_history_17_ymin = -0.05;
#line 50 "MACS_sample_kidney_box.instr"
  mccspec_detector_history_17_ymax = 0.05;
#line 6089 "MACS_sample_kidney_box.instr"
  mccspec_detector_history_17_xwidth = 2.0 * detector_radius;
#line 6089 "MACS_sample_kidney_box.instr"
  mccspec_detector_history_17_yheight = 1.0 * detector_height;
#line 6089 "MACS_sample_kidney_box.instr"
  mccspec_detector_history_17_restore_neutron = 1;
#line 153219 "MACS_sample_kidney_box.c"

  SIG_MESSAGE("spec_detector_history_17 (Init:Place/Rotate)");
  rot_set_rotation(mctr1,
#line 6093 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 6093 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 6093 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD);
#line 153229 "MACS_sample_kidney_box.c"
  rot_mul(mctr1, mcrotaspec_detector_17_exit_volume, mcrotaspec_detector_history_17);
  rot_transpose(mcrotaspec_detector_history_16, mctr1);
  rot_mul(mcrotaspec_detector_history_17, mctr1, mcrotrspec_detector_history_17);
  mctc1 = coords_set(
#line 6092 "MACS_sample_kidney_box.instr"
    0,
#line 6092 "MACS_sample_kidney_box.instr"
    0,
#line 6092 "MACS_sample_kidney_box.instr"
    0);
#line 153240 "MACS_sample_kidney_box.c"
  rot_transpose(mcrotaspec_detector_17_exit_volume, mctr1);
  mctc2 = rot_apply(mctr1, mctc1);
  mcposaspec_detector_history_17 = coords_add(mcposaspec_detector_17_exit_volume, mctc2);
  mctc1 = coords_sub(mcposaspec_detector_history_16, mcposaspec_detector_history_17);
  mcposrspec_detector_history_17 = rot_apply(mcrotaspec_detector_history_17, mctc1);
  mcDEBUG_COMPONENT("spec_detector_history_17", mcposaspec_detector_history_17, mcrotaspec_detector_history_17)
  mccomp_posa[942] = mcposaspec_detector_history_17;
  mccomp_posr[942] = mcposrspec_detector_history_17;
  mcNCounter[942]  = mcPCounter[942] = mcP2Counter[942] = 0;
  mcAbsorbProp[942]= 0;
    /* Component spec_detector_history_18. */
  /* Setting parameters for component spec_detector_history_18. */
  SIG_MESSAGE("spec_detector_history_18 (Init:SetPar)");
#line 6123 "MACS_sample_kidney_box.instr"
  if("spec_detector_history_18") strncpy(mccspec_detector_history_18_filename, "spec_detector_history_18" ? "spec_detector_history_18" : "", 16384); else mccspec_detector_history_18_filename[0]='\0';
#line 50 "MACS_sample_kidney_box.instr"
  mccspec_detector_history_18_xmin = -0.05;
#line 50 "MACS_sample_kidney_box.instr"
  mccspec_detector_history_18_xmax = 0.05;
#line 50 "MACS_sample_kidney_box.instr"
  mccspec_detector_history_18_ymin = -0.05;
#line 50 "MACS_sample_kidney_box.instr"
  mccspec_detector_history_18_ymax = 0.05;
#line 6122 "MACS_sample_kidney_box.instr"
  mccspec_detector_history_18_xwidth = 2.0 * detector_radius;
#line 6122 "MACS_sample_kidney_box.instr"
  mccspec_detector_history_18_yheight = 1.0 * detector_height;
#line 6122 "MACS_sample_kidney_box.instr"
  mccspec_detector_history_18_restore_neutron = 1;
#line 153270 "MACS_sample_kidney_box.c"

  SIG_MESSAGE("spec_detector_history_18 (Init:Place/Rotate)");
  rot_set_rotation(mctr1,
#line 6126 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 6126 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 6126 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD);
#line 153280 "MACS_sample_kidney_box.c"
  rot_mul(mctr1, mcrotaspec_detector_18_exit_volume, mcrotaspec_detector_history_18);
  rot_transpose(mcrotaspec_detector_history_17, mctr1);
  rot_mul(mcrotaspec_detector_history_18, mctr1, mcrotrspec_detector_history_18);
  mctc1 = coords_set(
#line 6125 "MACS_sample_kidney_box.instr"
    0,
#line 6125 "MACS_sample_kidney_box.instr"
    0,
#line 6125 "MACS_sample_kidney_box.instr"
    0);
#line 153291 "MACS_sample_kidney_box.c"
  rot_transpose(mcrotaspec_detector_18_exit_volume, mctr1);
  mctc2 = rot_apply(mctr1, mctc1);
  mcposaspec_detector_history_18 = coords_add(mcposaspec_detector_18_exit_volume, mctc2);
  mctc1 = coords_sub(mcposaspec_detector_history_17, mcposaspec_detector_history_18);
  mcposrspec_detector_history_18 = rot_apply(mcrotaspec_detector_history_18, mctc1);
  mcDEBUG_COMPONENT("spec_detector_history_18", mcposaspec_detector_history_18, mcrotaspec_detector_history_18)
  mccomp_posa[943] = mcposaspec_detector_history_18;
  mccomp_posr[943] = mcposrspec_detector_history_18;
  mcNCounter[943]  = mcPCounter[943] = mcP2Counter[943] = 0;
  mcAbsorbProp[943]= 0;
    /* Component spec_detector_history_19. */
  /* Setting parameters for component spec_detector_history_19. */
  SIG_MESSAGE("spec_detector_history_19 (Init:SetPar)");
#line 6156 "MACS_sample_kidney_box.instr"
  if("spec_detector_history_19") strncpy(mccspec_detector_history_19_filename, "spec_detector_history_19" ? "spec_detector_history_19" : "", 16384); else mccspec_detector_history_19_filename[0]='\0';
#line 50 "MACS_sample_kidney_box.instr"
  mccspec_detector_history_19_xmin = -0.05;
#line 50 "MACS_sample_kidney_box.instr"
  mccspec_detector_history_19_xmax = 0.05;
#line 50 "MACS_sample_kidney_box.instr"
  mccspec_detector_history_19_ymin = -0.05;
#line 50 "MACS_sample_kidney_box.instr"
  mccspec_detector_history_19_ymax = 0.05;
#line 6155 "MACS_sample_kidney_box.instr"
  mccspec_detector_history_19_xwidth = 2.0 * detector_radius;
#line 6155 "MACS_sample_kidney_box.instr"
  mccspec_detector_history_19_yheight = 1.0 * detector_height;
#line 6155 "MACS_sample_kidney_box.instr"
  mccspec_detector_history_19_restore_neutron = 1;
#line 153321 "MACS_sample_kidney_box.c"

  SIG_MESSAGE("spec_detector_history_19 (Init:Place/Rotate)");
  rot_set_rotation(mctr1,
#line 6159 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 6159 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD,
#line 6159 "MACS_sample_kidney_box.instr"
    (0)*DEG2RAD);
#line 153331 "MACS_sample_kidney_box.c"
  rot_mul(mctr1, mcrotaspec_detector_19_exit_volume, mcrotaspec_detector_history_19);
  rot_transpose(mcrotaspec_detector_history_18, mctr1);
  rot_mul(mcrotaspec_detector_history_19, mctr1, mcrotrspec_detector_history_19);
  mctc1 = coords_set(
#line 6158 "MACS_sample_kidney_box.instr"
    0,
#line 6158 "MACS_sample_kidney_box.instr"
    0,
#line 6158 "MACS_sample_kidney_box.instr"
    0);
#line 153342 "MACS_sample_kidney_box.c"
  rot_transpose(mcrotaspec_detector_19_exit_volume, mctr1);
  mctc2 = rot_apply(mctr1, mctc1);
  mcposaspec_detector_history_19 = coords_add(mcposaspec_detector_19_exit_volume, mctc2);
  mctc1 = coords_sub(mcposaspec_detector_history_18, mcposaspec_detector_history_19);
  mcposrspec_detector_history_19 = rot_apply(mcrotaspec_detector_history_19, mctc1);
  mcDEBUG_COMPONENT("spec_detector_history_19", mcposaspec_detector_history_19, mcrotaspec_detector_history_19)
  mccomp_posa[944] = mcposaspec_detector_history_19;
  mccomp_posr[944] = mcposrspec_detector_history_19;
  mcNCounter[944]  = mcPCounter[944] = mcP2Counter[944] = 0;
  mcAbsorbProp[944]= 0;
  /* Component initializations. */
  /* Initializations for component Al_incoherent. */
  SIG_MESSAGE("Al_incoherent (Init)");
#define mccompcurname  Al_incoherent
#define mccompcurtype  Incoherent_process
#define mccompcurindex 1
#define This_process mccAl_incoherent_This_process
#define Incoherent_storage mccAl_incoherent_Incoherent_storage
#define effective_my_scattering mccAl_incoherent_effective_my_scattering
#define sigma mccAl_incoherent_sigma
#define f_QE mccAl_incoherent_f_QE
#define gamma mccAl_incoherent_gamma
#define packing_factor mccAl_incoherent_packing_factor
#define unit_cell_volume mccAl_incoherent_unit_cell_volume
#define interact_fraction mccAl_incoherent_interact_fraction
#line 139 "Incoherent_process.comp"
{
  // Initialize done in the component
  effective_my_scattering = ((packing_factor/unit_cell_volume) * 100 * sigma);
  Incoherent_storage.my_scattering = effective_my_scattering;
  
  Incoherent_storage.QE_sampling_frequency = f_QE;
  Incoherent_storage.lorentzian_width = gamma;

  // Need to specify if this process is isotropic
  This_process.non_isotropic_rot_index = -1; // Yes (powder)
  //This_process.non_isotropic_rot_index =  1;  // No (single crystal)

  // Packing the data into a structure that is transported to the main component
  sprintf(This_process.name,NAME_CURRENT_COMP);
  This_process.process_p_interact = interact_fraction;
  This_process.data_transfer.pointer_to_a_Incoherent_physics_storage_struct = &Incoherent_storage;
  //This_process.data_transfer.pointer_to_a_Incoherent_physics_storage_struct->my_scattering = effective_my_scattering;
  This_process.probability_for_scattering_function = &Incoherent_physics_my;
  This_process.scattering_function = &Incoherent_physics_scattering;

  // This will be the same for all process's, and can thus be moved to an include.
  sprintf(global_process_element.name,NAME_CURRENT_COMP);
  global_process_element.component_index = INDEX_CURRENT_COMP;
  global_process_element.p_scattering_process = &This_process;
  add_element_to_process_list(&global_process_list,global_process_element);
}
#line 153395 "MACS_sample_kidney_box.c"
#undef interact_fraction
#undef unit_cell_volume
#undef packing_factor
#undef gamma
#undef f_QE
#undef sigma
#undef effective_my_scattering
#undef Incoherent_storage
#undef This_process
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

  /* Initializations for component Al_powder. */
  SIG_MESSAGE("Al_powder (Init)");
#define mccompcurname  Al_powder
#define mccompcurtype  Powder_process
#define mccompcurindex 2
#define format mccAl_powder_format
#define This_process mccAl_powder_This_process
#define Powder_storage mccAl_powder_Powder_storage
#define effective_my_scattering mccAl_powder_effective_my_scattering
#define d_phi mccAl_powder_d_phi
#define line_info mccAl_powder_line_info
#define columns mccAl_powder_columns
#define reflections mccAl_powder_reflections
#define packing_factor mccAl_powder_packing_factor
#define Vc mccAl_powder_Vc
#define delta_d_d mccAl_powder_delta_d_d
#define DW mccAl_powder_DW
#define nb_atoms mccAl_powder_nb_atoms
#define d_phi mccAl_powder_d_phi
#define density mccAl_powder_density
#define weight mccAl_powder_weight
#define barns mccAl_powder_barns
#define Strain mccAl_powder_Strain
#define interact_fraction mccAl_powder_interact_fraction
#line 638 "Powder_process.comp"
{

  // Initialize done in the component
  
  // Copy from PowderN component
  int i=0;
  struct line_data_union *L;
  line_info.Dd       = delta_d_d;
  line_info.DWfactor = DW;
  line_info.V_0      = Vc;
  line_info.rho      = density;
  line_info.at_weight= weight;
  line_info.at_nb    = nb_atoms;
  line_info.sigma_a  = 0; // This inputs are not needed, as absorption is handled elsewhere
  line_info.sigma_i  = 0; // This input is not needed, as incoherent scattering is handled elsewhere
  line_info.flag_barns=barns;
  //line_info.shape    = 0;
  line_info.flag_warning=0;
  line_info.Epsilon  = Strain;
  line_info.radius_i =line_info.xwidth_i=line_info.yheight_i=line_info.zdepth_i=0;
  line_info.v  = 0;
  line_info.Nq = 0;
  //line_info.v_min = FLT_MAX; line_info.v_max = 0;
  line_info.v_min = 10000000000; line_info.v_max = 0;
  line_info.neutron_passed=0;
  line_info.nb_reuses = line_info.nb_refl = line_info.nb_refl_count = 0;
  line_info.xs_compute= line_info.xs_reuse= line_info.xs_calls =0;
  for (i=0; i< 9; i++) line_info.column_order[i] = columns[i];
  strncpy(line_info.compname, NAME_CURRENT_COMP, 256);

  // p_interact handled elsewhere
  //if (p_interact) {
  //  if (p_interact < p_inc) { double tmp=p_interact; p_interact=p_inc; p_inc=tmp; }
  //  p_transmit = 1-p_interact-p_inc;
  //}

  if (reflections && strlen(reflections) && strcmp(reflections, "NULL") && strcmp(reflections, "0")) {
    i = read_line_data_union(reflections, &line_info);
    if (i == 0)
      exit(fprintf(stderr,"PowderN: %s: reflection file %s is not valid.\n"
                          "ERROR    Please check file format (laz or lau).\n", NAME_CURRENT_COMP, reflections));
  }

  /* compute the scattering unit density from material weight and density */
  /* the weight of the scattering element is the chemical formula molecular weight
   * times the nb of chemical formulae in the scattering element (nb_atoms) */
  if (!line_info.V_0 && line_info.at_nb > 0
    && line_info.at_weight > 0 && line_info.rho > 0) {
    /* molar volume [cm^3/mol] = weight [g/mol] / density [g/cm^3] */
    /* atom density per Angs^3 = [mol/cm^3] * N_Avogadro *(1e-8)^3 */
    line_info.V_0 = line_info.at_nb
      /(line_info.rho/line_info.at_weight/1e24*6.02214199e23);
  }

  /* the scattering unit cross sections are the chemical formula onces
   * times the nb of chemical formulae in the scattering element */
  if (line_info.at_nb > 0) {
    line_info.sigma_a *= line_info.at_nb; line_info.sigma_i *= line_info.at_nb;
  }

  if (line_info.V_0 <= 0)
    fprintf(stderr,"PowderN: %s: density/unit cell volume is NULL (Vc). Unactivating component.\n", NAME_CURRENT_COMP);


  if (line_info.flag_barns) { /* Factor 100 to convert from barns to fm^2 */
    line_info.XsectionFactor = 100;
  } else {
    line_info.XsectionFactor = 1;
  }

  if (line_info.V_0 && i) {
    L = line_info.list;

    line_info.q_v = malloc(line_info.count*sizeof(double));
    line_info.w_v = malloc(line_info.count*sizeof(double));
    line_info.my_s_v2 = malloc(line_info.count*sizeof(double));
    if (!line_info.q_v || !line_info.w_v || !line_info.my_s_v2)
      exit(fprintf(stderr,"PowderN: %s: ERROR allocating memory (init)\n", NAME_CURRENT_COMP));
    for(i=0; i<line_info.count; i++)
    {
      line_info.my_s_v2[i] = 4*PI*PI*PI*packing_factor*(L[i].DWfactor ? L[i].DWfactor : 1)
                 /(line_info.V_0*line_info.V_0*V2K*V2K)
                 *(L[i].j * L[i].F2 / L[i].q)*line_info.XsectionFactor;
      /* Is not yet divided by v^2 */
      /* Squires [3.103] */
      line_info.q_v[i] = L[i].q*K2V;
      line_info.w_v[i] = L[i].w;
    }
  }
  if (line_info.V_0) {
    /* Is not yet divided by v */
    line_info.my_a_v = packing_factor*line_info.sigma_a/line_info.V_0*2200*100;   // Factor 100 to convert from barns to fm^2
    line_info.my_inc = packing_factor*line_info.sigma_i/line_info.V_0*100;   // Factor 100 to convert from barns to fm^2

    printf("PowderN: %s: Vc=%g [Angs] sigma_abs=%g [barn] sigma_inc=%g [barn] reflections=%s\n",
      NAME_CURRENT_COMP, line_info.V_0, line_info.sigma_a, line_info.sigma_i, reflections && strlen(reflections) ? reflections : "NULL");
  }

  //printf("INTIALIZE line_info.v = %f, line_info.v_min = %f, line_info.v_max = %f, line_info.neutron_passed = %f\n",line_info.v,line_info.v_min,line_info.v_max,line_info.neutron_passed);

  Powder_storage.line_info_storage = &line_info;
  Powder_storage.vertical_angular_limit = d_phi;
  
  // Need to specify if this process is isotropic
  This_process.non_isotropic_rot_index = -1; // Yes (powder)
  //This_process.non_isotropic_rot_index =  1;  // No (single crystal)

  // Packing the data into a structure that is transported to the main component
  This_process.data_transfer.pointer_to_a_Powder_physics_storage_struct = &Powder_storage;
  This_process.data_transfer.pointer_to_a_Powder_physics_storage_struct->my_scattering = effective_my_scattering;
  This_process.probability_for_scattering_function = &Powder_physics_my;
  This_process.scattering_function = &Powder_physics_scattering;
    
  // This will be the same for all process's, and can thus be moved to an include.
  This_process.process_p_interact = interact_fraction;
  sprintf(This_process.name,NAME_CURRENT_COMP);
  rot_copy(This_process.rotation_matrix,ROT_A_CURRENT_COMP);
  sprintf(global_process_element.name,NAME_CURRENT_COMP);
  global_process_element.component_index = INDEX_CURRENT_COMP;
  global_process_element.p_scattering_process = &This_process;
  add_element_to_process_list(&global_process_list,global_process_element);
}
#line 153556 "MACS_sample_kidney_box.c"
#undef interact_fraction
#undef Strain
#undef barns
#undef weight
#undef density
#undef d_phi
#undef nb_atoms
#undef DW
#undef delta_d_d
#undef Vc
#undef packing_factor
#undef reflections
#undef columns
#undef line_info
#undef d_phi
#undef effective_my_scattering
#undef Powder_storage
#undef This_process
#undef format
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

  /* Initializations for component Al. */
  SIG_MESSAGE("Al (Init)");
#define mccompcurname  Al
#define mccompcurtype  Union_make_material
#define mccompcurindex 3
#define loop_index mccAl_loop_index
#define this_material mccAl_this_material
#define accepted_processes mccAl_accepted_processes
#define global_material_element mccAl_global_material_element
#define process_string mccAl_process_string
#define my_absorption mccAl_my_absorption
#define absorber mccAl_absorber
#line 193 "Union_make_material.comp"
{

  /*
  // Comma test
  printf("Starting comma test on string: %s \n",process_string);
  printf("Number of commas in string: %d \n",count_commas(process_string));
  exit(1);
  */
  

  if (0 == strcmp(NAME_CURRENT_COMP,"vacuum") || 0 == strcmp(NAME_CURRENT_COMP,"Vacuum")) {
    printf("ERROR, a Union material may not be called Vacuum. A vacuum volume may be created by material=\"Vacuum\" in a geometry component.\n");
    exit(1);
  }
  if (0 == strcmp(NAME_CURRENT_COMP,"exit") || 0 == strcmp(NAME_CURRENT_COMP,"Exit")) {
    printf("ERROR, a Union material may not be called Exit. A exit volume may be created by material=\"Exit\" in a geometry component.\n");
    exit(1);
  }
  if (my_absorption < 0) {
    printf("ERROR, Union make material named %s have a negative absorption cross section!.\n",NAME_CURRENT_COMP);
    exit(1);
  }
  
  if (absorber == 0) {
    if (process_string && strlen(process_string) && strcmp(process_string,"NULL") && strcmp(process_string, "0")) {
        manual_linking_function_material(process_string, &global_process_list, &accepted_processes, NAME_CURRENT_COMP);
    } else {
      for (loop_index=0;loop_index<global_process_list.num_elements;loop_index++) {
        // printf("Automatic linking chosen [loop index = %d] with process_string = %s  \n",loop_index,process_string);
        // automatic linking
        // accept a process if index is between current and former index of make_material components
          if (1 == automatic_linking_materials_function(global_process_list.elements[loop_index],global_material_list,INDEX_CURRENT_COMP))
              add_element_to_int_list(&accepted_processes,loop_index);
      }
    }
  }

  this_material.number_of_processes = accepted_processes.num_elements; // Add number of processes
  this_material.is_vacuum = 0; // This material is not vacuum
  
  if (this_material.number_of_processes == 0 && my_absorption == 0) {
    printf("ERROR, the material named %s has no processes assigned and no absorption cross section, making it eqvialent to vacuum. Vacuums are assigned by setting material=\"Vacuum\" in a geometry component.\n",NAME_CURRENT_COMP);
    exit(1);
  }
  
  // add process element to this_material, building an array of processes called p_scattering_array
  if (this_material.number_of_processes > 0) this_material.p_scattering_array = malloc(this_material.number_of_processes * sizeof(struct scattering_process_struct));
  for (loop_index=0;loop_index<accepted_processes.num_elements;loop_index++) {
        this_material.p_scattering_array[loop_index]=*global_process_list.elements[accepted_processes.elements[loop_index]].p_scattering_process;
  }
  
  this_material.my_a = my_absorption;  // add the absorption to this material
  sprintf(this_material.name,NAME_CURRENT_COMP);
  
  // packing the information into the global_material_element, which is then included in the global_material_list.
  sprintf(global_material_element.name,NAME_CURRENT_COMP);
  global_material_element.component_index = INDEX_CURRENT_COMP;
  global_material_element.physics = &this_material; // Would be nicer if this material was a pointer, now we have the (small) data two places
  add_element_to_material_list(&global_material_list,global_material_element);
}
#line 153653 "MACS_sample_kidney_box.c"
#undef absorber
#undef my_absorption
#undef process_string
#undef global_material_element
#undef accepted_processes
#undef this_material
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

  /* Initializations for component TiO2_incoherent. */
  SIG_MESSAGE("TiO2_incoherent (Init)");
#define mccompcurname  TiO2_incoherent
#define mccompcurtype  Incoherent_process
#define mccompcurindex 4
#define This_process mccTiO2_incoherent_This_process
#define Incoherent_storage mccTiO2_incoherent_Incoherent_storage
#define effective_my_scattering mccTiO2_incoherent_effective_my_scattering
#define sigma mccTiO2_incoherent_sigma
#define f_QE mccTiO2_incoherent_f_QE
#define gamma mccTiO2_incoherent_gamma
#define packing_factor mccTiO2_incoherent_packing_factor
#define unit_cell_volume mccTiO2_incoherent_unit_cell_volume
#define interact_fraction mccTiO2_incoherent_interact_fraction
#line 139 "Incoherent_process.comp"
{
  // Initialize done in the component
  effective_my_scattering = ((packing_factor/unit_cell_volume) * 100 * sigma);
  Incoherent_storage.my_scattering = effective_my_scattering;
  
  Incoherent_storage.QE_sampling_frequency = f_QE;
  Incoherent_storage.lorentzian_width = gamma;

  // Need to specify if this process is isotropic
  This_process.non_isotropic_rot_index = -1; // Yes (powder)
  //This_process.non_isotropic_rot_index =  1;  // No (single crystal)

  // Packing the data into a structure that is transported to the main component
  sprintf(This_process.name,NAME_CURRENT_COMP);
  This_process.process_p_interact = interact_fraction;
  This_process.data_transfer.pointer_to_a_Incoherent_physics_storage_struct = &Incoherent_storage;
  //This_process.data_transfer.pointer_to_a_Incoherent_physics_storage_struct->my_scattering = effective_my_scattering;
  This_process.probability_for_scattering_function = &Incoherent_physics_my;
  This_process.scattering_function = &Incoherent_physics_scattering;

  // This will be the same for all process's, and can thus be moved to an include.
  sprintf(global_process_element.name,NAME_CURRENT_COMP);
  global_process_element.component_index = INDEX_CURRENT_COMP;
  global_process_element.p_scattering_process = &This_process;
  add_element_to_process_list(&global_process_list,global_process_element);
}
#line 153706 "MACS_sample_kidney_box.c"
#undef interact_fraction
#undef unit_cell_volume
#undef packing_factor
#undef gamma
#undef f_QE
#undef sigma
#undef effective_my_scattering
#undef Incoherent_storage
#undef This_process
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

  /* Initializations for component TiO2_single_crystal. */
  SIG_MESSAGE("TiO2_single_crystal (Init)");
#define mccompcurname  TiO2_single_crystal
#define mccompcurtype  Single_crystal_process
#define mccompcurindex 5
#define mosaic_AB mccTiO2_single_crystal_mosaic_AB
#define This_process mccTiO2_single_crystal_This_process
#define Single_crystal_storage mccTiO2_single_crystal_Single_crystal_storage
#define effective_my_scattering mccTiO2_single_crystal_effective_my_scattering
#define hkl_info_union mccTiO2_single_crystal_hkl_info_union
#define packing_factor mccTiO2_single_crystal_packing_factor
#define reflections mccTiO2_single_crystal_reflections
#define delta_d_d mccTiO2_single_crystal_delta_d_d
#define mosaic mccTiO2_single_crystal_mosaic
#define mosaic_a mccTiO2_single_crystal_mosaic_a
#define mosaic_b mccTiO2_single_crystal_mosaic_b
#define mosaic_c mccTiO2_single_crystal_mosaic_c
#define recip_cell mccTiO2_single_crystal_recip_cell
#define barns mccTiO2_single_crystal_barns
#define ax mccTiO2_single_crystal_ax
#define ay mccTiO2_single_crystal_ay
#define az mccTiO2_single_crystal_az
#define bx mccTiO2_single_crystal_bx
#define by mccTiO2_single_crystal_by
#define bz mccTiO2_single_crystal_bz
#define cx mccTiO2_single_crystal_cx
#define cy mccTiO2_single_crystal_cy
#define cz mccTiO2_single_crystal_cz
#define aa mccTiO2_single_crystal_aa
#define bb mccTiO2_single_crystal_bb
#define cc mccTiO2_single_crystal_cc
#define order mccTiO2_single_crystal_order
#define RX mccTiO2_single_crystal_RX
#define RY mccTiO2_single_crystal_RY
#define RZ mccTiO2_single_crystal_RZ
#define powder mccTiO2_single_crystal_powder
#define PG mccTiO2_single_crystal_PG
#define interact_fraction mccTiO2_single_crystal_interact_fraction
#define packing_factor mccTiO2_single_crystal_packing_factor
#line 937 "Single_crystal_process.comp"
{
  // Single crystal initialize
  double as, bs, cs;
  int i=0;

  /* transfer input parameters */
  hkl_info_union.m_delta_d_d = delta_d_d;
  hkl_info_union.m_a  = 0;
  hkl_info_union.m_b  = 0;
  hkl_info_union.m_c  = 0;
  hkl_info_union.m_aa = aa;
  hkl_info_union.m_bb = bb;
  hkl_info_union.m_cc = cc;
  hkl_info_union.m_ax = ax;
  hkl_info_union.m_ay = ay;
  hkl_info_union.m_az = az;
  hkl_info_union.m_bx = bx;
  hkl_info_union.m_by = by;
  hkl_info_union.m_bz = bz;
  hkl_info_union.m_cx = cx;
  hkl_info_union.m_cy = cy;
  hkl_info_union.m_cz = cz;
  //hkl_info_union.sigma_a = sigma_abs;
  //hkl_info_union.sigma_i = sigma_inc;
  hkl_info_union.recip   = recip_cell;

  /* default format h,k,l,F,F2  */
  hkl_info_union.column_order[0]=1;
  hkl_info_union.column_order[1]=2;
  hkl_info_union.column_order[2]=3;
  hkl_info_union.column_order[3]=0;
  hkl_info_union.column_order[4]=7;
  hkl_info_union.kix = hkl_info_union.kiy = hkl_info_union.kiz = 0;
  hkl_info_union.nb_reuses = hkl_info_union.nb_refl = hkl_info_union.nb_refl_count = 0;
  hkl_info_union.tau_count = 0;

  /*this is necessary to allow a numerical array to be passed through as a DEFINITION parameter*/ 
  double mosaic_ABin[]=mosaic_AB;
  /* Read in structure factors, and do some pre-calculations. */
  if (!read_hkl_data_union(reflections, &hkl_info_union, mosaic, mosaic_a, mosaic_b, mosaic_c, mosaic_ABin)) {
    printf("Single_crystal_process: %s: Error: Aborting.\n", NAME_CURRENT_COMP);
    exit(0);
  }
    
  if (hkl_info_union.sigma_a<0) hkl_info_union.sigma_a=0;
  if (hkl_info_union.sigma_i<0) hkl_info_union.sigma_i=0;
  
  if (hkl_info_union.count)
    printf("Single_crystal_process: %s: Read %d reflections from file '%s'\n",
      NAME_CURRENT_COMP, hkl_info_union.count, reflections);
  else printf("Single_crystal_process: %s: Using incoherent elastic scattering only sigma=%g.\n",
      NAME_CURRENT_COMP, hkl_info_union.sigma_i);
  
  /*
  hkl_info.shape=-1; // -1:no shape, 0:cyl, 1:box, 2:sphere, 3:any-shape
  if (geometry && strlen(geometry) && strcmp(geometry, "NULL") && strcmp(geometry, "0")) {
	  if (off_init(geometry, xwidth, yheight, zdepth, 0, &offdata)) {
      hkl_info.shape=3; 
    }
  }
  else if (xwidth && yheight && zdepth)  hkl_info.shape=1; // box
  else if (radius > 0 && yheight)        hkl_info.shape=0; // cylinder
  else if (radius > 0 && !yheight)       hkl_info.shape=2; // sphere

  if (hkl_info.shape < 0) 
    exit(fprintf(stderr,"Single_crystal: %s: sample has invalid dimensions.\n"
                        "ERROR           Please check parameter values (xwidth, yheight, zdepth, radius).\n", NAME_CURRENT_COMP));
  */
  
  printf("Single_crystal: %s: Vc=%g [Angs] sigma_abs=%g [barn] sigma_inc=%g [barn] reflections=%s\n",
      NAME_CURRENT_COMP, hkl_info_union.V0, hkl_info_union.sigma_a, hkl_info_union.sigma_i,
      reflections && strlen(reflections) ? reflections : "NULL");

  if (powder && PG) 
    exit(fprintf(stderr,"Single_crystal_process: %s: powder and PG modes can not be used together!\n"
	     "ERROR           Please use EITHER powder or PG mode.\n", NAME_CURRENT_COMP));

  if (powder && !(order==1)) {
    fprintf(stderr,"Single_crystal_process: %s: powder mode means implicit choice of no multiple scattering!\n"
	    "WARNING setting order=1\n", NAME_CURRENT_COMP);
    order=1;
  } 
  
  if (PG && !(order==1)) {
    fprintf(stderr,"Single_crystal_process: %s: PG mode means implicit choice of no multiple scattering!\n"
	    "WARNING setting order=1\n", NAME_CURRENT_COMP);
    order=1;
  } 

  // Temporary errors untill these features are either added or removed from input
  
  if (powder)
    exit(fprintf(stderr,"Single_crystal_process: %s: powder mode not supported yet!\n"
	     "ERROR           Please disable powder mode.\n", NAME_CURRENT_COMP));
  
  if (PG)
    exit(fprintf(stderr,"Single_crystal_process: %s: PG mode not supported yet!\n"
	     "ERROR           Please disable PG mode.\n", NAME_CURRENT_COMP));
  
  if (order)
    exit(fprintf(stderr,"Single_crystal_process: %s: Order control not supported yet!\n"
	     "ERROR           Please set order to zero.\n", NAME_CURRENT_COMP));
  
  
  // Initialize done in the component
  // Added for single crystal
  Single_crystal_storage.PG_setting = PG;
  Single_crystal_storage.powder_setting = powder;
  Single_crystal_storage.barns_setting = barns;
  Single_crystal_storage.pack = packing_factor;
  Single_crystal_storage.hkl_info_storage = &hkl_info_union;

  // Need to specify if this process is isotropic
  //This_process.non_isotropic_rot_index = -1; // Yes (powder)
  This_process.non_isotropic_rot_index =  1;  // No (single crystal)

  // Packing the data into a structure that is transported to the main component
  This_process.data_transfer.pointer_to_a_Single_crystal_physics_storage_struct = &Single_crystal_storage;
  This_process.probability_for_scattering_function = &Single_crystal_physics_my;
  This_process.scattering_function = &Single_crystal_physics_scattering;

  // This will be the same for all process's, and can thus be moved to an include.
  This_process.process_p_interact = interact_fraction;
  sprintf(This_process.name,NAME_CURRENT_COMP);
  rot_copy(This_process.rotation_matrix,ROT_A_CURRENT_COMP);
  sprintf(global_process_element.name,NAME_CURRENT_COMP);
  global_process_element.component_index = INDEX_CURRENT_COMP;
  global_process_element.p_scattering_process = &This_process;
  add_element_to_process_list(&global_process_list,global_process_element);
}
#line 153890 "MACS_sample_kidney_box.c"
#undef packing_factor
#undef interact_fraction
#undef PG
#undef powder
#undef RZ
#undef RY
#undef RX
#undef order
#undef cc
#undef bb
#undef aa
#undef cz
#undef cy
#undef cx
#undef bz
#undef by
#undef bx
#undef az
#undef ay
#undef ax
#undef barns
#undef recip_cell
#undef mosaic_c
#undef mosaic_b
#undef mosaic_a
#undef mosaic
#undef delta_d_d
#undef reflections
#undef packing_factor
#undef hkl_info_union
#undef effective_my_scattering
#undef Single_crystal_storage
#undef This_process
#undef mosaic_AB
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

  /* Initializations for component TiO2. */
  SIG_MESSAGE("TiO2 (Init)");
#define mccompcurname  TiO2
#define mccompcurtype  Union_make_material
#define mccompcurindex 6
#define loop_index mccTiO2_loop_index
#define this_material mccTiO2_this_material
#define accepted_processes mccTiO2_accepted_processes
#define global_material_element mccTiO2_global_material_element
#define process_string mccTiO2_process_string
#define my_absorption mccTiO2_my_absorption
#define absorber mccTiO2_absorber
#line 193 "Union_make_material.comp"
{

  /*
  // Comma test
  printf("Starting comma test on string: %s \n",process_string);
  printf("Number of commas in string: %d \n",count_commas(process_string));
  exit(1);
  */
  

  if (0 == strcmp(NAME_CURRENT_COMP,"vacuum") || 0 == strcmp(NAME_CURRENT_COMP,"Vacuum")) {
    printf("ERROR, a Union material may not be called Vacuum. A vacuum volume may be created by material=\"Vacuum\" in a geometry component.\n");
    exit(1);
  }
  if (0 == strcmp(NAME_CURRENT_COMP,"exit") || 0 == strcmp(NAME_CURRENT_COMP,"Exit")) {
    printf("ERROR, a Union material may not be called Exit. A exit volume may be created by material=\"Exit\" in a geometry component.\n");
    exit(1);
  }
  if (my_absorption < 0) {
    printf("ERROR, Union make material named %s have a negative absorption cross section!.\n",NAME_CURRENT_COMP);
    exit(1);
  }
  
  if (absorber == 0) {
    if (process_string && strlen(process_string) && strcmp(process_string,"NULL") && strcmp(process_string, "0")) {
        manual_linking_function_material(process_string, &global_process_list, &accepted_processes, NAME_CURRENT_COMP);
    } else {
      for (loop_index=0;loop_index<global_process_list.num_elements;loop_index++) {
        // printf("Automatic linking chosen [loop index = %d] with process_string = %s  \n",loop_index,process_string);
        // automatic linking
        // accept a process if index is between current and former index of make_material components
          if (1 == automatic_linking_materials_function(global_process_list.elements[loop_index],global_material_list,INDEX_CURRENT_COMP))
              add_element_to_int_list(&accepted_processes,loop_index);
      }
    }
  }

  this_material.number_of_processes = accepted_processes.num_elements; // Add number of processes
  this_material.is_vacuum = 0; // This material is not vacuum
  
  if (this_material.number_of_processes == 0 && my_absorption == 0) {
    printf("ERROR, the material named %s has no processes assigned and no absorption cross section, making it eqvialent to vacuum. Vacuums are assigned by setting material=\"Vacuum\" in a geometry component.\n",NAME_CURRENT_COMP);
    exit(1);
  }
  
  // add process element to this_material, building an array of processes called p_scattering_array
  if (this_material.number_of_processes > 0) this_material.p_scattering_array = malloc(this_material.number_of_processes * sizeof(struct scattering_process_struct));
  for (loop_index=0;loop_index<accepted_processes.num_elements;loop_index++) {
        this_material.p_scattering_array[loop_index]=*global_process_list.elements[accepted_processes.elements[loop_index]].p_scattering_process;
  }
  
  this_material.my_a = my_absorption;  // add the absorption to this material
  sprintf(this_material.name,NAME_CURRENT_COMP);
  
  // packing the information into the global_material_element, which is then included in the global_material_list.
  sprintf(global_material_element.name,NAME_CURRENT_COMP);
  global_material_element.component_index = INDEX_CURRENT_COMP;
  global_material_element.physics = &this_material; // Would be nicer if this material was a pointer, now we have the (small) data two places
  add_element_to_material_list(&global_material_list,global_material_element);
}
#line 154002 "MACS_sample_kidney_box.c"
#undef absorber
#undef my_absorption
#undef process_string
#undef global_material_element
#undef accepted_processes
#undef this_material
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

  /* Initializations for component TiO2_poly_incoherent. */
  SIG_MESSAGE("TiO2_poly_incoherent (Init)");
#define mccompcurname  TiO2_poly_incoherent
#define mccompcurtype  Incoherent_process
#define mccompcurindex 7
#define This_process mccTiO2_poly_incoherent_This_process
#define Incoherent_storage mccTiO2_poly_incoherent_Incoherent_storage
#define effective_my_scattering mccTiO2_poly_incoherent_effective_my_scattering
#define sigma mccTiO2_poly_incoherent_sigma
#define f_QE mccTiO2_poly_incoherent_f_QE
#define gamma mccTiO2_poly_incoherent_gamma
#define packing_factor mccTiO2_poly_incoherent_packing_factor
#define unit_cell_volume mccTiO2_poly_incoherent_unit_cell_volume
#define interact_fraction mccTiO2_poly_incoherent_interact_fraction
#line 139 "Incoherent_process.comp"
{
  // Initialize done in the component
  effective_my_scattering = ((packing_factor/unit_cell_volume) * 100 * sigma);
  Incoherent_storage.my_scattering = effective_my_scattering;
  
  Incoherent_storage.QE_sampling_frequency = f_QE;
  Incoherent_storage.lorentzian_width = gamma;

  // Need to specify if this process is isotropic
  This_process.non_isotropic_rot_index = -1; // Yes (powder)
  //This_process.non_isotropic_rot_index =  1;  // No (single crystal)

  // Packing the data into a structure that is transported to the main component
  sprintf(This_process.name,NAME_CURRENT_COMP);
  This_process.process_p_interact = interact_fraction;
  This_process.data_transfer.pointer_to_a_Incoherent_physics_storage_struct = &Incoherent_storage;
  //This_process.data_transfer.pointer_to_a_Incoherent_physics_storage_struct->my_scattering = effective_my_scattering;
  This_process.probability_for_scattering_function = &Incoherent_physics_my;
  This_process.scattering_function = &Incoherent_physics_scattering;

  // This will be the same for all process's, and can thus be moved to an include.
  sprintf(global_process_element.name,NAME_CURRENT_COMP);
  global_process_element.component_index = INDEX_CURRENT_COMP;
  global_process_element.p_scattering_process = &This_process;
  add_element_to_process_list(&global_process_list,global_process_element);
}
#line 154055 "MACS_sample_kidney_box.c"
#undef interact_fraction
#undef unit_cell_volume
#undef packing_factor
#undef gamma
#undef f_QE
#undef sigma
#undef effective_my_scattering
#undef Incoherent_storage
#undef This_process
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

  /* Initializations for component TiO2_poly. */
  SIG_MESSAGE("TiO2_poly (Init)");
#define mccompcurname  TiO2_poly
#define mccompcurtype  Union_make_material
#define mccompcurindex 8
#define loop_index mccTiO2_poly_loop_index
#define this_material mccTiO2_poly_this_material
#define accepted_processes mccTiO2_poly_accepted_processes
#define global_material_element mccTiO2_poly_global_material_element
#define process_string mccTiO2_poly_process_string
#define my_absorption mccTiO2_poly_my_absorption
#define absorber mccTiO2_poly_absorber
#line 193 "Union_make_material.comp"
{

  /*
  // Comma test
  printf("Starting comma test on string: %s \n",process_string);
  printf("Number of commas in string: %d \n",count_commas(process_string));
  exit(1);
  */
  

  if (0 == strcmp(NAME_CURRENT_COMP,"vacuum") || 0 == strcmp(NAME_CURRENT_COMP,"Vacuum")) {
    printf("ERROR, a Union material may not be called Vacuum. A vacuum volume may be created by material=\"Vacuum\" in a geometry component.\n");
    exit(1);
  }
  if (0 == strcmp(NAME_CURRENT_COMP,"exit") || 0 == strcmp(NAME_CURRENT_COMP,"Exit")) {
    printf("ERROR, a Union material may not be called Exit. A exit volume may be created by material=\"Exit\" in a geometry component.\n");
    exit(1);
  }
  if (my_absorption < 0) {
    printf("ERROR, Union make material named %s have a negative absorption cross section!.\n",NAME_CURRENT_COMP);
    exit(1);
  }
  
  if (absorber == 0) {
    if (process_string && strlen(process_string) && strcmp(process_string,"NULL") && strcmp(process_string, "0")) {
        manual_linking_function_material(process_string, &global_process_list, &accepted_processes, NAME_CURRENT_COMP);
    } else {
      for (loop_index=0;loop_index<global_process_list.num_elements;loop_index++) {
        // printf("Automatic linking chosen [loop index = %d] with process_string = %s  \n",loop_index,process_string);
        // automatic linking
        // accept a process if index is between current and former index of make_material components
          if (1 == automatic_linking_materials_function(global_process_list.elements[loop_index],global_material_list,INDEX_CURRENT_COMP))
              add_element_to_int_list(&accepted_processes,loop_index);
      }
    }
  }

  this_material.number_of_processes = accepted_processes.num_elements; // Add number of processes
  this_material.is_vacuum = 0; // This material is not vacuum
  
  if (this_material.number_of_processes == 0 && my_absorption == 0) {
    printf("ERROR, the material named %s has no processes assigned and no absorption cross section, making it eqvialent to vacuum. Vacuums are assigned by setting material=\"Vacuum\" in a geometry component.\n",NAME_CURRENT_COMP);
    exit(1);
  }
  
  // add process element to this_material, building an array of processes called p_scattering_array
  if (this_material.number_of_processes > 0) this_material.p_scattering_array = malloc(this_material.number_of_processes * sizeof(struct scattering_process_struct));
  for (loop_index=0;loop_index<accepted_processes.num_elements;loop_index++) {
        this_material.p_scattering_array[loop_index]=*global_process_list.elements[accepted_processes.elements[loop_index]].p_scattering_process;
  }
  
  this_material.my_a = my_absorption;  // add the absorption to this material
  sprintf(this_material.name,NAME_CURRENT_COMP);
  
  // packing the information into the global_material_element, which is then included in the global_material_list.
  sprintf(global_material_element.name,NAME_CURRENT_COMP);
  global_material_element.component_index = INDEX_CURRENT_COMP;
  global_material_element.physics = &this_material; // Would be nicer if this material was a pointer, now we have the (small) data two places
  add_element_to_material_list(&global_material_list,global_material_element);
}
#line 154142 "MACS_sample_kidney_box.c"
#undef absorber
#undef my_absorption
#undef process_string
#undef global_material_element
#undef accepted_processes
#undef this_material
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

  /* Initializations for component Al_incoherent_B. */
  SIG_MESSAGE("Al_incoherent_B (Init)");
#define mccompcurname  Al_incoherent_B
#define mccompcurtype  Incoherent_process
#define mccompcurindex 9
#define This_process mccAl_incoherent_B_This_process
#define Incoherent_storage mccAl_incoherent_B_Incoherent_storage
#define effective_my_scattering mccAl_incoherent_B_effective_my_scattering
#define sigma mccAl_incoherent_B_sigma
#define f_QE mccAl_incoherent_B_f_QE
#define gamma mccAl_incoherent_B_gamma
#define packing_factor mccAl_incoherent_B_packing_factor
#define unit_cell_volume mccAl_incoherent_B_unit_cell_volume
#define interact_fraction mccAl_incoherent_B_interact_fraction
#line 139 "Incoherent_process.comp"
{
  // Initialize done in the component
  effective_my_scattering = ((packing_factor/unit_cell_volume) * 100 * sigma);
  Incoherent_storage.my_scattering = effective_my_scattering;
  
  Incoherent_storage.QE_sampling_frequency = f_QE;
  Incoherent_storage.lorentzian_width = gamma;

  // Need to specify if this process is isotropic
  This_process.non_isotropic_rot_index = -1; // Yes (powder)
  //This_process.non_isotropic_rot_index =  1;  // No (single crystal)

  // Packing the data into a structure that is transported to the main component
  sprintf(This_process.name,NAME_CURRENT_COMP);
  This_process.process_p_interact = interact_fraction;
  This_process.data_transfer.pointer_to_a_Incoherent_physics_storage_struct = &Incoherent_storage;
  //This_process.data_transfer.pointer_to_a_Incoherent_physics_storage_struct->my_scattering = effective_my_scattering;
  This_process.probability_for_scattering_function = &Incoherent_physics_my;
  This_process.scattering_function = &Incoherent_physics_scattering;

  // This will be the same for all process's, and can thus be moved to an include.
  sprintf(global_process_element.name,NAME_CURRENT_COMP);
  global_process_element.component_index = INDEX_CURRENT_COMP;
  global_process_element.p_scattering_process = &This_process;
  add_element_to_process_list(&global_process_list,global_process_element);
}
#line 154195 "MACS_sample_kidney_box.c"
#undef interact_fraction
#undef unit_cell_volume
#undef packing_factor
#undef gamma
#undef f_QE
#undef sigma
#undef effective_my_scattering
#undef Incoherent_storage
#undef This_process
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

  /* Initializations for component Al_powder_B. */
  SIG_MESSAGE("Al_powder_B (Init)");
#define mccompcurname  Al_powder_B
#define mccompcurtype  Powder_process
#define mccompcurindex 10
#define format mccAl_powder_B_format
#define This_process mccAl_powder_B_This_process
#define Powder_storage mccAl_powder_B_Powder_storage
#define effective_my_scattering mccAl_powder_B_effective_my_scattering
#define d_phi mccAl_powder_B_d_phi
#define line_info mccAl_powder_B_line_info
#define columns mccAl_powder_B_columns
#define reflections mccAl_powder_B_reflections
#define packing_factor mccAl_powder_B_packing_factor
#define Vc mccAl_powder_B_Vc
#define delta_d_d mccAl_powder_B_delta_d_d
#define DW mccAl_powder_B_DW
#define nb_atoms mccAl_powder_B_nb_atoms
#define d_phi mccAl_powder_B_d_phi
#define density mccAl_powder_B_density
#define weight mccAl_powder_B_weight
#define barns mccAl_powder_B_barns
#define Strain mccAl_powder_B_Strain
#define interact_fraction mccAl_powder_B_interact_fraction
#line 638 "Powder_process.comp"
{

  // Initialize done in the component
  
  // Copy from PowderN component
  int i=0;
  struct line_data_union *L;
  line_info.Dd       = delta_d_d;
  line_info.DWfactor = DW;
  line_info.V_0      = Vc;
  line_info.rho      = density;
  line_info.at_weight= weight;
  line_info.at_nb    = nb_atoms;
  line_info.sigma_a  = 0; // This inputs are not needed, as absorption is handled elsewhere
  line_info.sigma_i  = 0; // This input is not needed, as incoherent scattering is handled elsewhere
  line_info.flag_barns=barns;
  //line_info.shape    = 0;
  line_info.flag_warning=0;
  line_info.Epsilon  = Strain;
  line_info.radius_i =line_info.xwidth_i=line_info.yheight_i=line_info.zdepth_i=0;
  line_info.v  = 0;
  line_info.Nq = 0;
  //line_info.v_min = FLT_MAX; line_info.v_max = 0;
  line_info.v_min = 10000000000; line_info.v_max = 0;
  line_info.neutron_passed=0;
  line_info.nb_reuses = line_info.nb_refl = line_info.nb_refl_count = 0;
  line_info.xs_compute= line_info.xs_reuse= line_info.xs_calls =0;
  for (i=0; i< 9; i++) line_info.column_order[i] = columns[i];
  strncpy(line_info.compname, NAME_CURRENT_COMP, 256);

  // p_interact handled elsewhere
  //if (p_interact) {
  //  if (p_interact < p_inc) { double tmp=p_interact; p_interact=p_inc; p_inc=tmp; }
  //  p_transmit = 1-p_interact-p_inc;
  //}

  if (reflections && strlen(reflections) && strcmp(reflections, "NULL") && strcmp(reflections, "0")) {
    i = read_line_data_union(reflections, &line_info);
    if (i == 0)
      exit(fprintf(stderr,"PowderN: %s: reflection file %s is not valid.\n"
                          "ERROR    Please check file format (laz or lau).\n", NAME_CURRENT_COMP, reflections));
  }

  /* compute the scattering unit density from material weight and density */
  /* the weight of the scattering element is the chemical formula molecular weight
   * times the nb of chemical formulae in the scattering element (nb_atoms) */
  if (!line_info.V_0 && line_info.at_nb > 0
    && line_info.at_weight > 0 && line_info.rho > 0) {
    /* molar volume [cm^3/mol] = weight [g/mol] / density [g/cm^3] */
    /* atom density per Angs^3 = [mol/cm^3] * N_Avogadro *(1e-8)^3 */
    line_info.V_0 = line_info.at_nb
      /(line_info.rho/line_info.at_weight/1e24*6.02214199e23);
  }

  /* the scattering unit cross sections are the chemical formula onces
   * times the nb of chemical formulae in the scattering element */
  if (line_info.at_nb > 0) {
    line_info.sigma_a *= line_info.at_nb; line_info.sigma_i *= line_info.at_nb;
  }

  if (line_info.V_0 <= 0)
    fprintf(stderr,"PowderN: %s: density/unit cell volume is NULL (Vc). Unactivating component.\n", NAME_CURRENT_COMP);


  if (line_info.flag_barns) { /* Factor 100 to convert from barns to fm^2 */
    line_info.XsectionFactor = 100;
  } else {
    line_info.XsectionFactor = 1;
  }

  if (line_info.V_0 && i) {
    L = line_info.list;

    line_info.q_v = malloc(line_info.count*sizeof(double));
    line_info.w_v = malloc(line_info.count*sizeof(double));
    line_info.my_s_v2 = malloc(line_info.count*sizeof(double));
    if (!line_info.q_v || !line_info.w_v || !line_info.my_s_v2)
      exit(fprintf(stderr,"PowderN: %s: ERROR allocating memory (init)\n", NAME_CURRENT_COMP));
    for(i=0; i<line_info.count; i++)
    {
      line_info.my_s_v2[i] = 4*PI*PI*PI*packing_factor*(L[i].DWfactor ? L[i].DWfactor : 1)
                 /(line_info.V_0*line_info.V_0*V2K*V2K)
                 *(L[i].j * L[i].F2 / L[i].q)*line_info.XsectionFactor;
      /* Is not yet divided by v^2 */
      /* Squires [3.103] */
      line_info.q_v[i] = L[i].q*K2V;
      line_info.w_v[i] = L[i].w;
    }
  }
  if (line_info.V_0) {
    /* Is not yet divided by v */
    line_info.my_a_v = packing_factor*line_info.sigma_a/line_info.V_0*2200*100;   // Factor 100 to convert from barns to fm^2
    line_info.my_inc = packing_factor*line_info.sigma_i/line_info.V_0*100;   // Factor 100 to convert from barns to fm^2

    printf("PowderN: %s: Vc=%g [Angs] sigma_abs=%g [barn] sigma_inc=%g [barn] reflections=%s\n",
      NAME_CURRENT_COMP, line_info.V_0, line_info.sigma_a, line_info.sigma_i, reflections && strlen(reflections) ? reflections : "NULL");
  }

  //printf("INTIALIZE line_info.v = %f, line_info.v_min = %f, line_info.v_max = %f, line_info.neutron_passed = %f\n",line_info.v,line_info.v_min,line_info.v_max,line_info.neutron_passed);

  Powder_storage.line_info_storage = &line_info;
  Powder_storage.vertical_angular_limit = d_phi;
  
  // Need to specify if this process is isotropic
  This_process.non_isotropic_rot_index = -1; // Yes (powder)
  //This_process.non_isotropic_rot_index =  1;  // No (single crystal)

  // Packing the data into a structure that is transported to the main component
  This_process.data_transfer.pointer_to_a_Powder_physics_storage_struct = &Powder_storage;
  This_process.data_transfer.pointer_to_a_Powder_physics_storage_struct->my_scattering = effective_my_scattering;
  This_process.probability_for_scattering_function = &Powder_physics_my;
  This_process.scattering_function = &Powder_physics_scattering;
    
  // This will be the same for all process's, and can thus be moved to an include.
  This_process.process_p_interact = interact_fraction;
  sprintf(This_process.name,NAME_CURRENT_COMP);
  rot_copy(This_process.rotation_matrix,ROT_A_CURRENT_COMP);
  sprintf(global_process_element.name,NAME_CURRENT_COMP);
  global_process_element.component_index = INDEX_CURRENT_COMP;
  global_process_element.p_scattering_process = &This_process;
  add_element_to_process_list(&global_process_list,global_process_element);
}
#line 154356 "MACS_sample_kidney_box.c"
#undef interact_fraction
#undef Strain
#undef barns
#undef weight
#undef density
#undef d_phi
#undef nb_atoms
#undef DW
#undef delta_d_d
#undef Vc
#undef packing_factor
#undef reflections
#undef columns
#undef line_info
#undef d_phi
#undef effective_my_scattering
#undef Powder_storage
#undef This_process
#undef format
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

  /* Initializations for component Al_B. */
  SIG_MESSAGE("Al_B (Init)");
#define mccompcurname  Al_B
#define mccompcurtype  Union_make_material
#define mccompcurindex 11
#define loop_index mccAl_B_loop_index
#define this_material mccAl_B_this_material
#define accepted_processes mccAl_B_accepted_processes
#define global_material_element mccAl_B_global_material_element
#define process_string mccAl_B_process_string
#define my_absorption mccAl_B_my_absorption
#define absorber mccAl_B_absorber
#line 193 "Union_make_material.comp"
{

  /*
  // Comma test
  printf("Starting comma test on string: %s \n",process_string);
  printf("Number of commas in string: %d \n",count_commas(process_string));
  exit(1);
  */
  

  if (0 == strcmp(NAME_CURRENT_COMP,"vacuum") || 0 == strcmp(NAME_CURRENT_COMP,"Vacuum")) {
    printf("ERROR, a Union material may not be called Vacuum. A vacuum volume may be created by material=\"Vacuum\" in a geometry component.\n");
    exit(1);
  }
  if (0 == strcmp(NAME_CURRENT_COMP,"exit") || 0 == strcmp(NAME_CURRENT_COMP,"Exit")) {
    printf("ERROR, a Union material may not be called Exit. A exit volume may be created by material=\"Exit\" in a geometry component.\n");
    exit(1);
  }
  if (my_absorption < 0) {
    printf("ERROR, Union make material named %s have a negative absorption cross section!.\n",NAME_CURRENT_COMP);
    exit(1);
  }
  
  if (absorber == 0) {
    if (process_string && strlen(process_string) && strcmp(process_string,"NULL") && strcmp(process_string, "0")) {
        manual_linking_function_material(process_string, &global_process_list, &accepted_processes, NAME_CURRENT_COMP);
    } else {
      for (loop_index=0;loop_index<global_process_list.num_elements;loop_index++) {
        // printf("Automatic linking chosen [loop index = %d] with process_string = %s  \n",loop_index,process_string);
        // automatic linking
        // accept a process if index is between current and former index of make_material components
          if (1 == automatic_linking_materials_function(global_process_list.elements[loop_index],global_material_list,INDEX_CURRENT_COMP))
              add_element_to_int_list(&accepted_processes,loop_index);
      }
    }
  }

  this_material.number_of_processes = accepted_processes.num_elements; // Add number of processes
  this_material.is_vacuum = 0; // This material is not vacuum
  
  if (this_material.number_of_processes == 0 && my_absorption == 0) {
    printf("ERROR, the material named %s has no processes assigned and no absorption cross section, making it eqvialent to vacuum. Vacuums are assigned by setting material=\"Vacuum\" in a geometry component.\n",NAME_CURRENT_COMP);
    exit(1);
  }
  
  // add process element to this_material, building an array of processes called p_scattering_array
  if (this_material.number_of_processes > 0) this_material.p_scattering_array = malloc(this_material.number_of_processes * sizeof(struct scattering_process_struct));
  for (loop_index=0;loop_index<accepted_processes.num_elements;loop_index++) {
        this_material.p_scattering_array[loop_index]=*global_process_list.elements[accepted_processes.elements[loop_index]].p_scattering_process;
  }
  
  this_material.my_a = my_absorption;  // add the absorption to this material
  sprintf(this_material.name,NAME_CURRENT_COMP);
  
  // packing the information into the global_material_element, which is then included in the global_material_list.
  sprintf(global_material_element.name,NAME_CURRENT_COMP);
  global_material_element.component_index = INDEX_CURRENT_COMP;
  global_material_element.physics = &this_material; // Would be nicer if this material was a pointer, now we have the (small) data two places
  add_element_to_material_list(&global_material_list,global_material_element);
}
#line 154453 "MACS_sample_kidney_box.c"
#undef absorber
#undef my_absorption
#undef process_string
#undef global_material_element
#undef accepted_processes
#undef this_material
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

  /* Initializations for component Arm0. */
  SIG_MESSAGE("Arm0 (Init)");
#define mccompcurname  Arm0
#define mccompcurtype  Progress_bar
#define mccompcurindex 12
#define IntermediateCnts mccArm0_IntermediateCnts
#define StartTime mccArm0_StartTime
#define EndTime mccArm0_EndTime
#define CurrentTime mccArm0_CurrentTime
#define profile mccArm0_profile
#define percent mccArm0_percent
#define flag_save mccArm0_flag_save
#define minutes mccArm0_minutes
#line 57 "/usr/share/mcstas/2.7/misc/Progress_bar.comp"
{
IntermediateCnts=0;
StartTime=0;
EndTime=0;
CurrentTime=0;

fprintf(stdout, "[%s] Initialize\n", mcinstrument_name);
  if (percent*mcget_ncount()/100 < 1e5) {
    percent=1e5*100.0/mcget_ncount();
  }
}
#line 154490 "MACS_sample_kidney_box.c"
#undef minutes
#undef flag_save
#undef percent
#undef profile
#undef CurrentTime
#undef EndTime
#undef StartTime
#undef IntermediateCnts
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

  /* Initializations for component Guide_end. */
  SIG_MESSAGE("Guide_end (Init)");
#define mccompcurname  Guide_end
#define mccompcurtype  Virtual_input
#define mccompcurindex 13
#define read_block mccGuide_end_read_block
#define pos mccGuide_end_pos
#define nrows mccGuide_end_nrows
#define Offset mccGuide_end_Offset
#define rTable mccGuide_end_rTable
#define repeat_number mccGuide_end_repeat_number
#define filename_ncount mccGuide_end_filename_ncount
#define mean_vx mccGuide_end_mean_vx
#define mean_vy mccGuide_end_mean_vy
#define mean_vz mccGuide_end_mean_vz
#define mean_dx mccGuide_end_mean_dx
#define mean_dy mccGuide_end_mean_dy
#define mean_dz mccGuide_end_mean_dz
#define n_neutrons mccGuide_end_n_neutrons
#define min_x mccGuide_end_min_x
#define min_y mccGuide_end_min_y
#define min_z mccGuide_end_min_z
#define max_x mccGuide_end_max_x
#define max_y mccGuide_end_max_y
#define max_z mccGuide_end_max_z
#define min_vx mccGuide_end_min_vx
#define min_vy mccGuide_end_min_vy
#define min_vz mccGuide_end_min_vz
#define max_vx mccGuide_end_max_vx
#define max_vy mccGuide_end_max_vy
#define max_vz mccGuide_end_max_vz
#define first_block mccGuide_end_first_block
#define mean_x mccGuide_end_mean_x
#define mean_y mccGuide_end_mean_y
#define mean_z mccGuide_end_mean_z
#define end_reading mccGuide_end_end_reading
#define n_count_extrapolated mccGuide_end_n_count_extrapolated
#define repeat_cnt mccGuide_end_repeat_cnt
#define filename mccGuide_end_filename
#define verbose mccGuide_end_verbose
#define repeat_count mccGuide_end_repeat_count
#define smooth mccGuide_end_smooth
#define display mccGuide_end_display
#line 128 "/usr/share/mcstas/2.7/obsolete/Virtual_input.comp"
{
  repeat_number=1;
  pos=0;
  nrows=0;
  Offset=0;
  filename_ncount=0;
  n_neutrons=0;
  read_block=1;
  first_block=1;
  end_reading=0;
  mean_x=0;
  mean_y=0;
  mean_z=0;
  mean_vx=0;
  mean_vy=0;
  mean_vz=0;
  mean_dx=0;
  mean_dy=0;
  mean_dz=0;
  min_x=FLT_MAX;
  min_y=FLT_MAX;
  min_z=FLT_MAX;
  max_x=-FLT_MAX;
  max_y=-FLT_MAX;
  max_z=-FLT_MAX;
  min_vx=FLT_MAX;
  min_vy=FLT_MAX;
  min_vz=FLT_MAX;
  max_vx=-FLT_MAX;
  max_vy=-FLT_MAX;
  max_vz=-FLT_MAX;
  n_count_extrapolated=0;


  sprintf(type,"text");
  Table_Init(&rTable, 0, 0);

  if (!filename || !repeat_count)
  {
    fprintf(stderr,"Virtual_input: %s: please give me a filename name (filename) to read (repeat_count>0).\n", NAME_CURRENT_COMP);
    exit(-1);
  }

  if (filename && strlen(filename) && strcmp(filename, "NULL") && strcmp(filename,"0") && repeat_count>0) {
    if (type && strstr(type, "Vitess"))
    { fprintf(stderr, "Virtual_input: %s: Vitess files may be read using the Vitess_input component\n", NAME_CURRENT_COMP); exit(-1); }

    if (verbose)
      printf("Virtual_input: %s: Reading neutron events from filename '%s'. Repeat %g time(s)\n", NAME_CURRENT_COMP, filename, repeat_count);

#if defined (USE_MPI)
    if (!smooth && mpi_node_count > 1) {
      if (verbose)
      printf("Virtual_input: %s: smoothing (smooth=1) is recommended when running MPI execution\n", NAME_CURRENT_COMP);
    }
#endif

    double min_dv=fabs(max_vx-min_vx);
    if (min_dv > fabs(max_vy-min_vy)) min_dv = fabs(max_vy-min_vy);
    if (min_dv > fabs(max_vz-min_vz)) min_dv = fabs(max_vz-min_vz);
    min_vx = min_dv;

    if (verbose && smooth)
        printf("* Beam will be smoothed\n");
  } else if (!filename)
    exit(fprintf(stderr,"Virtual_input: %s: please give me a filename name (filename).\n", NAME_CURRENT_COMP));

  repeat_cnt = repeat_count;
#if defined (USE_MPI)
  repeat_cnt = ceil(1.0*repeat_cnt/mpi_node_count);
#endif
}
#line 154619 "MACS_sample_kidney_box.c"
#undef display
#undef smooth
#undef repeat_count
#undef verbose
#undef filename
#undef repeat_cnt
#undef n_count_extrapolated
#undef end_reading
#undef mean_z
#undef mean_y
#undef mean_x
#undef first_block
#undef max_vz
#undef max_vy
#undef max_vx
#undef min_vz
#undef min_vy
#undef min_vx
#undef max_z
#undef max_y
#undef max_x
#undef min_z
#undef min_y
#undef min_x
#undef n_neutrons
#undef mean_dz
#undef mean_dy
#undef mean_dx
#undef mean_vz
#undef mean_vy
#undef mean_vx
#undef filename_ncount
#undef repeat_number
#undef rTable
#undef Offset
#undef nrows
#undef pos
#undef read_block
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

  /* Initializations for component main_slit. */
  SIG_MESSAGE("main_slit (Init)");
#define mccompcurname  main_slit
#define mccompcurtype  Slit
#define mccompcurindex 14
#define xmin mccmain_slit_xmin
#define xmax mccmain_slit_xmax
#define ymin mccmain_slit_ymin
#define ymax mccmain_slit_ymax
#define radius mccmain_slit_radius
#define xwidth mccmain_slit_xwidth
#define yheight mccmain_slit_yheight
#line 50 "/usr/share/mcstas/2.7/optics/Slit.comp"
{
if (xwidth > 0)  { 
  if (!xmin && !xmax) {
    xmax=xwidth/2;  xmin=-xmax;
  } else {
    fprintf(stderr,"Slit: %s: Error: please specify EITHER xmin & xmax or xwidth\n", NAME_CURRENT_COMP); exit(-1);
  }
 }
 if (yheight > 0) { 
   if (!ymin && !ymax) {
     ymax=yheight/2; ymin=-ymax; 
   } else {
     fprintf(stderr,"Slit: %s: Error: please specify EITHER ymin & ymax or ywidth\n", NAME_CURRENT_COMP); exit(-1);
   }
 }
 if (xmin == 0 && xmax == 0 && ymin == 0 && ymax == 0 && radius == 0)
    { fprintf(stderr,"Slit: %s: Warning: Running with CLOSED slit - is this intentional?? \n", NAME_CURRENT_COMP); }

}
#line 154694 "MACS_sample_kidney_box.c"
#undef yheight
#undef xwidth
#undef radius
#undef ymax
#undef ymin
#undef xmax
#undef xmin
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

  /* Initializations for component target. */
  SIG_MESSAGE("target (Init)");

  /* Initializations for component cryostat_center. */
  SIG_MESSAGE("cryostat_center (Init)");

  /* Initializations for component drum_center. */
  SIG_MESSAGE("drum_center (Init)");

  /* Initializations for component crystal_assembly. */
  SIG_MESSAGE("crystal_assembly (Init)");

  /* Initializations for component crystal_axis. */
  SIG_MESSAGE("crystal_axis (Init)");

  /* Initializations for component sample. */
  SIG_MESSAGE("sample (Init)");
#define mccompcurname  sample
#define mccompcurtype  Union_box
#define mccompcurindex 20
#define loop_index mccsample_loop_index
#define this_box_volume mccsample_this_box_volume
#define global_geometry_element mccsample_global_geometry_element
#define this_box_storage mccsample_this_box_storage
#define material_string mccsample_material_string
#define priority mccsample_priority
#define xwidth mccsample_xwidth
#define yheight mccsample_yheight
#define zdepth mccsample_zdepth
#define xwidth2 mccsample_xwidth2
#define yheight2 mccsample_yheight2
#define visualize mccsample_visualize
#define target_index mccsample_target_index
#define target_x mccsample_target_x
#define target_y mccsample_target_y
#define target_z mccsample_target_z
#define focus_aw mccsample_focus_aw
#define focus_ah mccsample_focus_ah
#define focus_xw mccsample_focus_xw
#define focus_xh mccsample_focus_xh
#define focus_r mccsample_focus_r
#define p_interact mccsample_p_interact
#define mask_string mccsample_mask_string
#define mask_setting mccsample_mask_setting
#define number_of_activations mccsample_number_of_activations
#line 224 "Union_box.comp"
{
// Initializes the focusing system for this volume including input sanitation.
focus_initialize(&this_box_volume.geometry, POS_A_COMP_INDEX(INDEX_CURRENT_COMP+target_index), POS_A_CURRENT_COMP, ROT_A_CURRENT_COMP, target_index, target_x, target_y, target_z, focus_aw, focus_ah, focus_xw, focus_xh, focus_r, NAME_CURRENT_COMP);

// Input sanitation for this geometry
if (xwidth <= 0) {
  printf("\nERROR in Union_box named %s, the xwidth is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (yheight <= 0) {
  printf("\nERROR in Union_box named %s, yheight is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (zdepth <= 0) {
  printf("\nERROR in Union_box named %s, zdepth is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (xwidth2 <= 0 && xwidth2 != -1) {
  printf("\nERROR in Union_box named %s, the xwidth2 is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (yheight2 <= 0 && yheight2 != -1) {
  printf("\nERROR in Union_box named %s, yheight2 is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}

// Use sanitation
if (global_material_list.num_elements == 0) {
  printf("\nERROR: Need to define a material using Union_make_material before using a Union geometry component. \n");
  printf("       %s was defined before first use of Union_make_material.\n",NAME_CURRENT_COMP);
  exit(1);
}

this_box_volume.geometry.is_masked_volume = 0;
this_box_volume.geometry.is_exit_volume = 0;
this_box_volume.geometry.is_mask_volume = 0;
// check if the volume is a mask, if it is the material string is irelevant.
if (mask_string && strlen(mask_string) && strcmp(mask_string, "NULL") && strcmp(mask_string, "0")) {
    // A mask volume is used to limit the extend of other volumes, called the masked volumes. These are specified in the mask_string.
    // In order for a ray to enter a masked volume, it needs to be both in the region covered by that volume AND the mask volume.
    // When more than
    this_box_volume.geometry.mask_mode = 1; // Default is mask mode is ALL
    if (mask_setting && strlen(mask_setting) && strcmp(mask_setting, "NULL") && strcmp(mask_setting, "0")) {
        if (strcmp(mask_setting,"ALL") == 0 || strcmp(mask_setting,"All") == 0) this_box_volume.geometry.mask_mode = 1;
        else if (strcmp(mask_setting,"ANY") == 0 || strcmp(mask_setting,"Any") == 0) this_box_volume.geometry.mask_mode = 2;
        else {
            printf("The mask_mode of component %s is set to %s, but must be either ALL or ANY.\n",NAME_CURRENT_COMP,mask_setting);
            exit(1);
        }
    }
    
    for (loop_index=0;loop_index<global_geometry_list.num_elements;loop_index++) {
        // Add mask list
        if (1 == manual_linking_function(global_geometry_list.elements[loop_index].name,mask_string)) {
            add_element_to_int_list(&this_box_volume.geometry.mask_list,global_geometry_list.elements[loop_index].component_index);
            add_element_to_int_list(&global_geometry_list.elements[loop_index].Volume->geometry.masked_by_list,INDEX_CURRENT_COMP);
            global_geometry_list.elements[loop_index].Volume->geometry.is_masked_volume = 1;
            if (this_box_volume.geometry.mask_mode == 2)
                global_geometry_list.elements[loop_index].Volume->geometry.mask_mode = 2;
            if (this_box_volume.geometry.mask_mode == 1) {
                if (global_geometry_list.elements[loop_index].Volume->geometry.is_masked_volume == 1 && global_geometry_list.elements[loop_index].Volume->geometry.mask_mode != 2)
                    // If more than one mask is added to one volume, the ANY mode overwrites the (default) ALL mode.
                    global_geometry_list.elements[loop_index].Volume->geometry.mask_mode = 1;
            }
            
            found_geometries = 1;
        }
    }
    if (found_geometries == 0) {
        printf("The mask_string in geometry: %s did not find any of the specified volumes in the mask_string %s \n",NAME_CURRENT_COMP,mask_string);
        exit(1);
    }
    this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
    this_box_volume.p_physics->is_vacuum = 0; // Makes this volume a vacuum
    this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
    this_box_volume.p_physics->my_a = 0; // Should not be used.
    sprintf(this_box_volume.p_physics->name,"Mask");
    this_box_volume.geometry.is_mask_volume = 1;
    
    
// Read the material input, or if it lacks, use automatic linking.
} else if (material_string && strlen(material_string) && strcmp(material_string, "NULL") && strcmp(material_string, "0")) {
    // A geometry string was given, use it to determine which material
    if (0 == strcmp(material_string,"vacuum") || 0 == strcmp(material_string,"Vacuum")) {
        // One could have a global physics struct for vacuum instead of creating one for each
        this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
        this_box_volume.p_physics->is_vacuum = 1; // Makes this volume a vacuum
        this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
        this_box_volume.p_physics->my_a = 0; // Should not be used.
        sprintf(this_box_volume.p_physics->name,"Vacuum");
    } else if (0 == strcmp(material_string,"exit") || 0 == strcmp(material_string,"Exit")) {
        // One could have a global physics struct for vacuum instead of creating one for each
        this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
        this_box_volume.p_physics->is_vacuum = 1; // Makes this volume a vacuum
        this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
        this_box_volume.p_physics->my_a = 0; // Should not be used.
        this_box_volume.geometry.is_exit_volume = 1;
        sprintf(this_box_volume.p_physics->name,"Exit");
    } else {
        #ifndef MATERIAL_DETECTOR
            printf("Need to define a material before refering to it in a geometry %s.\n",NAME_CURRENT_COMP);
            exit(1);
        #endif
        for (loop_index=0;loop_index<global_material_list.num_elements;loop_index++) {
            if (0 == strcmp(material_string,global_material_list.elements[loop_index].name)) {
                this_box_volume.p_physics = global_material_list.elements[loop_index].physics;
                break;
            }
            if (loop_index == global_material_list.num_elements-1) {
            printf("\n");
            printf("ERROR: The material string \"%s\" in Union geometry \"%s\" did not match a specified material. \n",material_string,NAME_CURRENT_COMP);
            printf("       The materials available at this point (need to be defined before the geometry): \n");
            for (loop_index=0;loop_index<global_material_list.num_elements;loop_index++)
              printf("         %s\n",global_material_list.elements[loop_index].name);
            printf("\n");
            printf("       It is also possible to use one of the defualt materials avaiable: \n");
            printf("           Vacuum (for a Volume without scattering or absorption)\n");
            printf("           Exit (for a Volume where the ray exits the component if it enters)\n");
            printf("           Mask (for a Volume that masks existing volumes specified in the mask_string\n");
            exit(1);
          }
        }
    }
} else {
    // Automatic linking, simply using the last defined material.
    #ifndef MATERIAL_DETECTOR
        printf("Need to define a material before the geometry to use automatic linking %s.\n",NAME_CURRENT_COMP);
        exit(1);
    #endif
    this_box_volume.p_physics = global_material_list.elements[global_material_list.num_elements-1].physics;
}

sprintf(this_box_volume.name,NAME_CURRENT_COMP);
sprintf(this_box_volume.geometry.shape,"box");
this_box_volume.geometry.priority_value = priority;
this_box_volume.geometry.geometry_p_interact = p_interact;
// Currently the coordinates will be in absolute space.
this_box_volume.geometry.center = POS_A_CURRENT_COMP;

this_box_storage.z_depth = zdepth;
this_box_storage.x_width1 = xwidth;
this_box_storage.y_height1 = yheight;

this_box_storage.is_rectangle = 0;
if (xwidth2 < 0 && yheight2 < 0) this_box_storage.is_rectangle = 1;
if (xwidth == xwidth2 && yheight == yheight2) this_box_storage.is_rectangle = 1;

if (xwidth2 < 0) {
    this_box_storage.x_width2 = xwidth;
    xwidth2 = xwidth;
} else this_box_storage.x_width2 = xwidth2;

if (yheight2 < 0) {
    this_box_storage.y_height2 = yheight;
    yheight2 = yheight;
} else this_box_storage.y_height2 = yheight2;


this_box_storage.normal_vectors[0] = coords_set(0,0,1);
this_box_storage.normal_vectors[1] = coords_set(0,0,1);

// for sides with y component = 0
x_component = 2*zdepth/sqrt((xwidth-xwidth2)*(xwidth-xwidth2)+4*zdepth*zdepth);
z_component = (xwidth-xwidth2)/sqrt(4*zdepth*zdepth+(xwidth-xwidth2)*(xwidth-xwidth2));

this_box_storage.normal_vectors[2] = coords_set(x_component,0,z_component);
this_box_storage.normal_vectors[3] = coords_set(-x_component,0,z_component);

// for sides with x component = 0
y_component = 2*zdepth/sqrt((yheight-yheight2)*(yheight-yheight2)+4*zdepth*zdepth);
z_component = (yheight-yheight2)/sqrt(4*zdepth*zdepth+(yheight-yheight2)*(yheight-yheight2));

this_box_storage.normal_vectors[4] = coords_set(0,y_component,z_component);
this_box_storage.normal_vectors[5] = coords_set(0,-y_component,z_component);

this_box_volume.geometry.visualization_on = visualize;

this_box_volume.geometry.geometry_parameters.p_box_storage = &this_box_storage;

// Assign pointers to functions for intersection with the shape, checking if a point is inside the shape
if (this_box_storage.is_rectangle == 1) {
this_box_volume.geometry.intersect_function = &sample_box_intersect_simple;
this_box_volume.geometry.within_function = &r_within_box_simple;
}
else {
this_box_volume.geometry.intersect_function = &sample_box_intersect_advanced;
this_box_volume.geometry.within_function = &r_within_box_advanced;
}

this_box_volume.geometry.shell_points = &box_shell_points;
this_box_volume.geometry.mcdisplay_function = &mcdisplay_box_function;
this_box_volume.geometry.initialize_from_main_function = &initialize_box_geometry_from_main_component;
this_box_volume.geometry.process_rot_allocated = 0;

this_box_volume.geometry.copy_geometry_parameters = &allocate_box_storage_copy;

rot_copy(this_box_volume.geometry.rotation_matrix,ROT_A_CURRENT_COMP); //check how ROT_R_CURRENT_COMP would work
rot_transpose(ROT_A_CURRENT_COMP,this_box_volume.geometry.transpose_rotation_matrix);

// Initialize loggers
this_box_volume.loggers.num_elements = 0;

// packing the information into the global_geometry_element, which is then included in the global_geometry_list.
sprintf(global_geometry_element.name,NAME_CURRENT_COMP);
global_geometry_element.activation_counter = number_of_activations;
global_geometry_element.component_index = INDEX_CURRENT_COMP;
global_geometry_element.Volume = &this_box_volume; // Would be nicer if this m was a pointer, now we have the (small) data two places
add_element_to_geometry_list(&global_geometry_list,global_geometry_element);
}
#line 154961 "MACS_sample_kidney_box.c"
#undef number_of_activations
#undef mask_setting
#undef mask_string
#undef p_interact
#undef focus_r
#undef focus_xh
#undef focus_xw
#undef focus_ah
#undef focus_aw
#undef target_z
#undef target_y
#undef target_x
#undef target_index
#undef visualize
#undef yheight2
#undef xwidth2
#undef zdepth
#undef yheight
#undef xwidth
#undef priority
#undef material_string
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

  /* Initializations for component sample_plate. */
  SIG_MESSAGE("sample_plate (Init)");
#define mccompcurname  sample_plate
#define mccompcurtype  Union_cylinder
#define mccompcurindex 21
#define loop_index mccsample_plate_loop_index
#define this_cylinder_volume mccsample_plate_this_cylinder_volume
#define global_geometry_element mccsample_plate_global_geometry_element
#define this_cylinder_storage mccsample_plate_this_cylinder_storage
#define material_string mccsample_plate_material_string
#define priority mccsample_plate_priority
#define radius mccsample_plate_radius
#define yheight mccsample_plate_yheight
#define visualize mccsample_plate_visualize
#define target_index mccsample_plate_target_index
#define target_x mccsample_plate_target_x
#define target_y mccsample_plate_target_y
#define target_z mccsample_plate_target_z
#define focus_aw mccsample_plate_focus_aw
#define focus_ah mccsample_plate_focus_ah
#define focus_xw mccsample_plate_focus_xw
#define focus_xh mccsample_plate_focus_xh
#define focus_r mccsample_plate_focus_r
#define p_interact mccsample_plate_p_interact
#define mask_string mccsample_plate_mask_string
#define mask_setting mccsample_plate_mask_setting
#define number_of_activations mccsample_plate_number_of_activations
#line 185 "Union_cylinder.comp"
{
// Initializes the focusing system for this volume including input sanitation.
focus_initialize(&this_cylinder_volume.geometry, POS_A_COMP_INDEX(INDEX_CURRENT_COMP+target_index), POS_A_CURRENT_COMP, ROT_A_CURRENT_COMP, target_index, target_x, target_y, target_z, focus_aw, focus_ah, focus_xw, focus_xh, focus_r, NAME_CURRENT_COMP);

// Input sanitation for this geometry
if (radius <= 0) {
  printf("\nERROR in Union_cylinder named %s, the radius is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}

if (yheight <= 0) {
  printf("\nERROR in Union_cylinder named %s, yheight is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}

// Use sanitation
#ifdef MATERIAL_DETECTOR
if (global_material_list.num_elements == 0) {
  // Here if the user have defined a material, but only after this material
  printf("\nERROR: Need to define a material using Union_make_material before using a Union geometry component. \n");
  printf("       %s was defined before first use of Union_make_material.\n",NAME_CURRENT_COMP);
  exit(1);
}
#endif
#ifndef MATERIAL_DETECTOR
  printf("\nERROR: Need to define a material using Union_make_material before using a Union geometry component. \n");
  exit(1);
#endif


this_cylinder_volume.geometry.is_masked_volume = 0;
this_cylinder_volume.geometry.is_exit_volume = 0;
this_cylinder_volume.geometry.is_mask_volume = 0;

// Read the material input, or if it lacks, use automatic linking.
if (mask_string && strlen(mask_string) && strcmp(mask_string, "NULL") && strcmp(mask_string, "0")) {
    // A mask volume is used to limit the extend of other volumes, called the masked volumes. These are specified in the mask_string.
    // In order for a ray to enter a masked volume, it needs to be both in the region covered by that volume AND the mask volume.
    // When more than
    this_cylinder_volume.geometry.mask_mode = 1; // Default is mask mode is ALL
    if (mask_setting && strlen(mask_setting) && strcmp(mask_setting, "NULL") && strcmp(mask_setting, "0")) {
        if (strcmp(mask_setting,"ALL") == 0 || strcmp(mask_setting,"All") == 0) this_cylinder_volume.geometry.mask_mode = 1;
        else if (strcmp(mask_setting,"ANY") == 0 || strcmp(mask_setting,"Any") == 0) this_cylinder_volume.geometry.mask_mode = 2;
        else {
            printf("The mask_mode of component %s is set to %s, but must be either ALL or ANY.\n",NAME_CURRENT_COMP,mask_setting);
            exit(1);
        }
    }
    
    for (loop_index=0;loop_index<global_geometry_list.num_elements;loop_index++) {
        // Add mask list
        if (1 == manual_linking_function(global_geometry_list.elements[loop_index].name,mask_string)) {
            add_element_to_int_list(&this_cylinder_volume.geometry.mask_list,global_geometry_list.elements[loop_index].component_index);
            add_element_to_int_list(&global_geometry_list.elements[loop_index].Volume->geometry.masked_by_list,INDEX_CURRENT_COMP);
            global_geometry_list.elements[loop_index].Volume->geometry.is_masked_volume = 1;
            if (this_cylinder_volume.geometry.mask_mode == 2)
                global_geometry_list.elements[loop_index].Volume->geometry.mask_mode = 2;
            if (this_cylinder_volume.geometry.mask_mode == 1) {
                if (global_geometry_list.elements[loop_index].Volume->geometry.is_masked_volume == 1 && global_geometry_list.elements[loop_index].Volume->geometry.mask_mode != 2)
                    // If more than one mask is added to one volume, the ANY mode overwrites the (default) ALL mode.
                    global_geometry_list.elements[loop_index].Volume->geometry.mask_mode = 1;
            }
            
            found_geometries = 1;
        }
    }
    if (found_geometries == 0) {
        printf("The mask_string in geometry: %s did not find any of the specified volumes in the mask_string %s \n",NAME_CURRENT_COMP,mask_string);
        exit(1);
    }
    this_cylinder_volume.p_physics = malloc(sizeof(struct physics_struct));
    this_cylinder_volume.p_physics->is_vacuum = 0; // Makes this volume a vacuum
    this_cylinder_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
    this_cylinder_volume.p_physics->my_a = 0; // Should not be used.
    sprintf(this_cylinder_volume.p_physics->name,"Mask");
    this_cylinder_volume.geometry.is_mask_volume = 1;
    
    
// Read the material input, or if it lacks, use automatic linking.
} else if (material_string && strlen(material_string) && strcmp(material_string, "NULL") && strcmp(material_string, "0")) {
    // A geometry string was given, use it to determine which material
    if (0 == strcmp(material_string,"vacuum") || 0 == strcmp(material_string,"Vacuum")) {
        // One could have a global physics struct for vacuum instead of creating one for each
        this_cylinder_volume.p_physics = malloc(sizeof(struct physics_struct));
        this_cylinder_volume.p_physics->is_vacuum = 1; // Makes this volume a vacuum
        this_cylinder_volume.p_physics->number_of_processes = (int) 0;
        this_cylinder_volume.p_physics->my_a = 0; // Should not be used.
        sprintf(this_cylinder_volume.p_physics->name,"Vacuum");
    } else if (0 == strcmp(material_string,"exit") || 0 == strcmp(material_string,"Exit")) {
        // One could have a global physics struct for exit instead of creating one for each
        this_cylinder_volume.p_physics = malloc(sizeof(struct physics_struct));
        this_cylinder_volume.p_physics->is_vacuum = 1; // Makes this volume a vacuum
        this_cylinder_volume.p_physics->number_of_processes = (int) 0;
        this_cylinder_volume.p_physics->my_a = 0; // Should not be used.
        this_cylinder_volume.geometry.is_exit_volume = 1;
        sprintf(this_cylinder_volume.p_physics->name,"Exit");
    } else {
        for (loop_index=0;loop_index<global_material_list.num_elements;loop_index++) {
          if (0 == strcmp(material_string,global_material_list.elements[loop_index].name)) {
            this_cylinder_volume.p_physics = global_material_list.elements[loop_index].physics;
            break;
          }
          if (loop_index == global_material_list.num_elements-1) {
            printf("\n");
            printf("ERROR: The material string \"%s\" in Union geometry \"%s\" did not match a specified material. \n",material_string,NAME_CURRENT_COMP);
            printf("       The materials available at this point (need to be defined before the geometry): \n");
            for (loop_index=0;loop_index<global_material_list.num_elements;loop_index++)
              printf("         %s\n",global_material_list.elements[loop_index].name);
            printf("\n");
            printf("       It is also possible to use one of the defualt materials avaiable: \n");
            printf("           Vacuum (for a Volume without scattering or absorption)\n");
            printf("           Exit (for a Volume where the ray exits the component if it enters)\n");
            printf("           Mask (for a Volume that masks existing volumes specified in the mask_string\n");
            exit(1);
          }
        }
    }
} else {
    // Automatic linking, simply using the last defined material.
    #ifndef MATERIAL_DETECTOR
        printf("Need to define a material before the geometry to use automatic linking %s.\n",NAME_CURRENT_COMP);
        exit(1);
    #endif
    this_cylinder_volume.p_physics = global_material_list.elements[global_material_list.num_elements-1].physics;
}

sprintf(this_cylinder_volume.name,NAME_CURRENT_COMP);
sprintf(this_cylinder_volume.geometry.shape,"cylinder");
this_cylinder_volume.geometry.priority_value = priority;
// Currently the coordinates will be in absolute space.
this_cylinder_volume.geometry.center = POS_A_CURRENT_COMP;

this_cylinder_volume.geometry.geometry_p_interact = p_interact;
this_cylinder_storage.cyl_radius = radius;
this_cylinder_storage.height = yheight;
this_cylinder_volume.geometry.visualization_on = visualize;
this_cylinder_volume.geometry.geometry_parameters.p_cylinder_storage = &this_cylinder_storage;
this_cylinder_volume.geometry.within_function = &r_within_cylinder;
this_cylinder_volume.geometry.intersect_function = &sample_cylinder_intersect;
this_cylinder_volume.geometry.mcdisplay_function = &mcdisplay_cylinder_function;
this_cylinder_volume.geometry.shell_points = &cylinder_shell_points;
this_cylinder_volume.geometry.initialize_from_main_function = &initialize_cylinder_geometry_from_main_component;
this_cylinder_volume.geometry.process_rot_allocated = 0;
this_cylinder_volume.geometry.copy_geometry_parameters = &allocate_cylinder_storage_copy;

rot_copy(this_cylinder_volume.geometry.rotation_matrix,ROT_A_CURRENT_COMP);
rot_transpose(ROT_A_CURRENT_COMP,this_cylinder_volume.geometry.transpose_rotation_matrix);

// Initialize loggers
this_cylinder_volume.loggers.num_elements = 0;

// packing the information into the global_geometry_element, which is then included in the global_geometry_list.
sprintf(global_geometry_element.name,NAME_CURRENT_COMP);
global_geometry_element.activation_counter = number_of_activations;
global_geometry_element.component_index = INDEX_CURRENT_COMP;
global_geometry_element.Volume = &this_cylinder_volume; // Would be nicer if this m was a pointer, now we have the (small) data two places
add_element_to_geometry_list(&global_geometry_list,global_geometry_element);
}
#line 155177 "MACS_sample_kidney_box.c"
#undef number_of_activations
#undef mask_setting
#undef mask_string
#undef p_interact
#undef focus_r
#undef focus_xh
#undef focus_xw
#undef focus_ah
#undef focus_aw
#undef target_z
#undef target_y
#undef target_x
#undef target_index
#undef visualize
#undef yheight
#undef radius
#undef priority
#undef material_string
#undef this_cylinder_storage
#undef global_geometry_element
#undef this_cylinder_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

  /* Initializations for component sample_plate_rod. */
  SIG_MESSAGE("sample_plate_rod (Init)");
#define mccompcurname  sample_plate_rod
#define mccompcurtype  Union_cylinder
#define mccompcurindex 22
#define loop_index mccsample_plate_rod_loop_index
#define this_cylinder_volume mccsample_plate_rod_this_cylinder_volume
#define global_geometry_element mccsample_plate_rod_global_geometry_element
#define this_cylinder_storage mccsample_plate_rod_this_cylinder_storage
#define material_string mccsample_plate_rod_material_string
#define priority mccsample_plate_rod_priority
#define radius mccsample_plate_rod_radius
#define yheight mccsample_plate_rod_yheight
#define visualize mccsample_plate_rod_visualize
#define target_index mccsample_plate_rod_target_index
#define target_x mccsample_plate_rod_target_x
#define target_y mccsample_plate_rod_target_y
#define target_z mccsample_plate_rod_target_z
#define focus_aw mccsample_plate_rod_focus_aw
#define focus_ah mccsample_plate_rod_focus_ah
#define focus_xw mccsample_plate_rod_focus_xw
#define focus_xh mccsample_plate_rod_focus_xh
#define focus_r mccsample_plate_rod_focus_r
#define p_interact mccsample_plate_rod_p_interact
#define mask_string mccsample_plate_rod_mask_string
#define mask_setting mccsample_plate_rod_mask_setting
#define number_of_activations mccsample_plate_rod_number_of_activations
#line 185 "Union_cylinder.comp"
{
// Initializes the focusing system for this volume including input sanitation.
focus_initialize(&this_cylinder_volume.geometry, POS_A_COMP_INDEX(INDEX_CURRENT_COMP+target_index), POS_A_CURRENT_COMP, ROT_A_CURRENT_COMP, target_index, target_x, target_y, target_z, focus_aw, focus_ah, focus_xw, focus_xh, focus_r, NAME_CURRENT_COMP);

// Input sanitation for this geometry
if (radius <= 0) {
  printf("\nERROR in Union_cylinder named %s, the radius is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}

if (yheight <= 0) {
  printf("\nERROR in Union_cylinder named %s, yheight is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}

// Use sanitation
#ifdef MATERIAL_DETECTOR
if (global_material_list.num_elements == 0) {
  // Here if the user have defined a material, but only after this material
  printf("\nERROR: Need to define a material using Union_make_material before using a Union geometry component. \n");
  printf("       %s was defined before first use of Union_make_material.\n",NAME_CURRENT_COMP);
  exit(1);
}
#endif
#ifndef MATERIAL_DETECTOR
  printf("\nERROR: Need to define a material using Union_make_material before using a Union geometry component. \n");
  exit(1);
#endif


this_cylinder_volume.geometry.is_masked_volume = 0;
this_cylinder_volume.geometry.is_exit_volume = 0;
this_cylinder_volume.geometry.is_mask_volume = 0;

// Read the material input, or if it lacks, use automatic linking.
if (mask_string && strlen(mask_string) && strcmp(mask_string, "NULL") && strcmp(mask_string, "0")) {
    // A mask volume is used to limit the extend of other volumes, called the masked volumes. These are specified in the mask_string.
    // In order for a ray to enter a masked volume, it needs to be both in the region covered by that volume AND the mask volume.
    // When more than
    this_cylinder_volume.geometry.mask_mode = 1; // Default is mask mode is ALL
    if (mask_setting && strlen(mask_setting) && strcmp(mask_setting, "NULL") && strcmp(mask_setting, "0")) {
        if (strcmp(mask_setting,"ALL") == 0 || strcmp(mask_setting,"All") == 0) this_cylinder_volume.geometry.mask_mode = 1;
        else if (strcmp(mask_setting,"ANY") == 0 || strcmp(mask_setting,"Any") == 0) this_cylinder_volume.geometry.mask_mode = 2;
        else {
            printf("The mask_mode of component %s is set to %s, but must be either ALL or ANY.\n",NAME_CURRENT_COMP,mask_setting);
            exit(1);
        }
    }
    
    for (loop_index=0;loop_index<global_geometry_list.num_elements;loop_index++) {
        // Add mask list
        if (1 == manual_linking_function(global_geometry_list.elements[loop_index].name,mask_string)) {
            add_element_to_int_list(&this_cylinder_volume.geometry.mask_list,global_geometry_list.elements[loop_index].component_index);
            add_element_to_int_list(&global_geometry_list.elements[loop_index].Volume->geometry.masked_by_list,INDEX_CURRENT_COMP);
            global_geometry_list.elements[loop_index].Volume->geometry.is_masked_volume = 1;
            if (this_cylinder_volume.geometry.mask_mode == 2)
                global_geometry_list.elements[loop_index].Volume->geometry.mask_mode = 2;
            if (this_cylinder_volume.geometry.mask_mode == 1) {
                if (global_geometry_list.elements[loop_index].Volume->geometry.is_masked_volume == 1 && global_geometry_list.elements[loop_index].Volume->geometry.mask_mode != 2)
                    // If more than one mask is added to one volume, the ANY mode overwrites the (default) ALL mode.
                    global_geometry_list.elements[loop_index].Volume->geometry.mask_mode = 1;
            }
            
            found_geometries = 1;
        }
    }
    if (found_geometries == 0) {
        printf("The mask_string in geometry: %s did not find any of the specified volumes in the mask_string %s \n",NAME_CURRENT_COMP,mask_string);
        exit(1);
    }
    this_cylinder_volume.p_physics = malloc(sizeof(struct physics_struct));
    this_cylinder_volume.p_physics->is_vacuum = 0; // Makes this volume a vacuum
    this_cylinder_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
    this_cylinder_volume.p_physics->my_a = 0; // Should not be used.
    sprintf(this_cylinder_volume.p_physics->name,"Mask");
    this_cylinder_volume.geometry.is_mask_volume = 1;
    
    
// Read the material input, or if it lacks, use automatic linking.
} else if (material_string && strlen(material_string) && strcmp(material_string, "NULL") && strcmp(material_string, "0")) {
    // A geometry string was given, use it to determine which material
    if (0 == strcmp(material_string,"vacuum") || 0 == strcmp(material_string,"Vacuum")) {
        // One could have a global physics struct for vacuum instead of creating one for each
        this_cylinder_volume.p_physics = malloc(sizeof(struct physics_struct));
        this_cylinder_volume.p_physics->is_vacuum = 1; // Makes this volume a vacuum
        this_cylinder_volume.p_physics->number_of_processes = (int) 0;
        this_cylinder_volume.p_physics->my_a = 0; // Should not be used.
        sprintf(this_cylinder_volume.p_physics->name,"Vacuum");
    } else if (0 == strcmp(material_string,"exit") || 0 == strcmp(material_string,"Exit")) {
        // One could have a global physics struct for exit instead of creating one for each
        this_cylinder_volume.p_physics = malloc(sizeof(struct physics_struct));
        this_cylinder_volume.p_physics->is_vacuum = 1; // Makes this volume a vacuum
        this_cylinder_volume.p_physics->number_of_processes = (int) 0;
        this_cylinder_volume.p_physics->my_a = 0; // Should not be used.
        this_cylinder_volume.geometry.is_exit_volume = 1;
        sprintf(this_cylinder_volume.p_physics->name,"Exit");
    } else {
        for (loop_index=0;loop_index<global_material_list.num_elements;loop_index++) {
          if (0 == strcmp(material_string,global_material_list.elements[loop_index].name)) {
            this_cylinder_volume.p_physics = global_material_list.elements[loop_index].physics;
            break;
          }
          if (loop_index == global_material_list.num_elements-1) {
            printf("\n");
            printf("ERROR: The material string \"%s\" in Union geometry \"%s\" did not match a specified material. \n",material_string,NAME_CURRENT_COMP);
            printf("       The materials available at this point (need to be defined before the geometry): \n");
            for (loop_index=0;loop_index<global_material_list.num_elements;loop_index++)
              printf("         %s\n",global_material_list.elements[loop_index].name);
            printf("\n");
            printf("       It is also possible to use one of the defualt materials avaiable: \n");
            printf("           Vacuum (for a Volume without scattering or absorption)\n");
            printf("           Exit (for a Volume where the ray exits the component if it enters)\n");
            printf("           Mask (for a Volume that masks existing volumes specified in the mask_string\n");
            exit(1);
          }
        }
    }
} else {
    // Automatic linking, simply using the last defined material.
    #ifndef MATERIAL_DETECTOR
        printf("Need to define a material before the geometry to use automatic linking %s.\n",NAME_CURRENT_COMP);
        exit(1);
    #endif
    this_cylinder_volume.p_physics = global_material_list.elements[global_material_list.num_elements-1].physics;
}

sprintf(this_cylinder_volume.name,NAME_CURRENT_COMP);
sprintf(this_cylinder_volume.geometry.shape,"cylinder");
this_cylinder_volume.geometry.priority_value = priority;
// Currently the coordinates will be in absolute space.
this_cylinder_volume.geometry.center = POS_A_CURRENT_COMP;

this_cylinder_volume.geometry.geometry_p_interact = p_interact;
this_cylinder_storage.cyl_radius = radius;
this_cylinder_storage.height = yheight;
this_cylinder_volume.geometry.visualization_on = visualize;
this_cylinder_volume.geometry.geometry_parameters.p_cylinder_storage = &this_cylinder_storage;
this_cylinder_volume.geometry.within_function = &r_within_cylinder;
this_cylinder_volume.geometry.intersect_function = &sample_cylinder_intersect;
this_cylinder_volume.geometry.mcdisplay_function = &mcdisplay_cylinder_function;
this_cylinder_volume.geometry.shell_points = &cylinder_shell_points;
this_cylinder_volume.geometry.initialize_from_main_function = &initialize_cylinder_geometry_from_main_component;
this_cylinder_volume.geometry.process_rot_allocated = 0;
this_cylinder_volume.geometry.copy_geometry_parameters = &allocate_cylinder_storage_copy;

rot_copy(this_cylinder_volume.geometry.rotation_matrix,ROT_A_CURRENT_COMP);
rot_transpose(ROT_A_CURRENT_COMP,this_cylinder_volume.geometry.transpose_rotation_matrix);

// Initialize loggers
this_cylinder_volume.loggers.num_elements = 0;

// packing the information into the global_geometry_element, which is then included in the global_geometry_list.
sprintf(global_geometry_element.name,NAME_CURRENT_COMP);
global_geometry_element.activation_counter = number_of_activations;
global_geometry_element.component_index = INDEX_CURRENT_COMP;
global_geometry_element.Volume = &this_cylinder_volume; // Would be nicer if this m was a pointer, now we have the (small) data two places
add_element_to_geometry_list(&global_geometry_list,global_geometry_element);
}
#line 155390 "MACS_sample_kidney_box.c"
#undef number_of_activations
#undef mask_setting
#undef mask_string
#undef p_interact
#undef focus_r
#undef focus_xh
#undef focus_xw
#undef focus_ah
#undef focus_aw
#undef target_z
#undef target_y
#undef target_x
#undef target_index
#undef visualize
#undef yheight
#undef radius
#undef priority
#undef material_string
#undef this_cylinder_storage
#undef global_geometry_element
#undef this_cylinder_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

  /* Initializations for component sample_base. */
  SIG_MESSAGE("sample_base (Init)");
#define mccompcurname  sample_base
#define mccompcurtype  Union_cylinder
#define mccompcurindex 23
#define loop_index mccsample_base_loop_index
#define this_cylinder_volume mccsample_base_this_cylinder_volume
#define global_geometry_element mccsample_base_global_geometry_element
#define this_cylinder_storage mccsample_base_this_cylinder_storage
#define material_string mccsample_base_material_string
#define priority mccsample_base_priority
#define radius mccsample_base_radius
#define yheight mccsample_base_yheight
#define visualize mccsample_base_visualize
#define target_index mccsample_base_target_index
#define target_x mccsample_base_target_x
#define target_y mccsample_base_target_y
#define target_z mccsample_base_target_z
#define focus_aw mccsample_base_focus_aw
#define focus_ah mccsample_base_focus_ah
#define focus_xw mccsample_base_focus_xw
#define focus_xh mccsample_base_focus_xh
#define focus_r mccsample_base_focus_r
#define p_interact mccsample_base_p_interact
#define mask_string mccsample_base_mask_string
#define mask_setting mccsample_base_mask_setting
#define number_of_activations mccsample_base_number_of_activations
#line 185 "Union_cylinder.comp"
{
// Initializes the focusing system for this volume including input sanitation.
focus_initialize(&this_cylinder_volume.geometry, POS_A_COMP_INDEX(INDEX_CURRENT_COMP+target_index), POS_A_CURRENT_COMP, ROT_A_CURRENT_COMP, target_index, target_x, target_y, target_z, focus_aw, focus_ah, focus_xw, focus_xh, focus_r, NAME_CURRENT_COMP);

// Input sanitation for this geometry
if (radius <= 0) {
  printf("\nERROR in Union_cylinder named %s, the radius is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}

if (yheight <= 0) {
  printf("\nERROR in Union_cylinder named %s, yheight is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}

// Use sanitation
#ifdef MATERIAL_DETECTOR
if (global_material_list.num_elements == 0) {
  // Here if the user have defined a material, but only after this material
  printf("\nERROR: Need to define a material using Union_make_material before using a Union geometry component. \n");
  printf("       %s was defined before first use of Union_make_material.\n",NAME_CURRENT_COMP);
  exit(1);
}
#endif
#ifndef MATERIAL_DETECTOR
  printf("\nERROR: Need to define a material using Union_make_material before using a Union geometry component. \n");
  exit(1);
#endif


this_cylinder_volume.geometry.is_masked_volume = 0;
this_cylinder_volume.geometry.is_exit_volume = 0;
this_cylinder_volume.geometry.is_mask_volume = 0;

// Read the material input, or if it lacks, use automatic linking.
if (mask_string && strlen(mask_string) && strcmp(mask_string, "NULL") && strcmp(mask_string, "0")) {
    // A mask volume is used to limit the extend of other volumes, called the masked volumes. These are specified in the mask_string.
    // In order for a ray to enter a masked volume, it needs to be both in the region covered by that volume AND the mask volume.
    // When more than
    this_cylinder_volume.geometry.mask_mode = 1; // Default is mask mode is ALL
    if (mask_setting && strlen(mask_setting) && strcmp(mask_setting, "NULL") && strcmp(mask_setting, "0")) {
        if (strcmp(mask_setting,"ALL") == 0 || strcmp(mask_setting,"All") == 0) this_cylinder_volume.geometry.mask_mode = 1;
        else if (strcmp(mask_setting,"ANY") == 0 || strcmp(mask_setting,"Any") == 0) this_cylinder_volume.geometry.mask_mode = 2;
        else {
            printf("The mask_mode of component %s is set to %s, but must be either ALL or ANY.\n",NAME_CURRENT_COMP,mask_setting);
            exit(1);
        }
    }
    
    for (loop_index=0;loop_index<global_geometry_list.num_elements;loop_index++) {
        // Add mask list
        if (1 == manual_linking_function(global_geometry_list.elements[loop_index].name,mask_string)) {
            add_element_to_int_list(&this_cylinder_volume.geometry.mask_list,global_geometry_list.elements[loop_index].component_index);
            add_element_to_int_list(&global_geometry_list.elements[loop_index].Volume->geometry.masked_by_list,INDEX_CURRENT_COMP);
            global_geometry_list.elements[loop_index].Volume->geometry.is_masked_volume = 1;
            if (this_cylinder_volume.geometry.mask_mode == 2)
                global_geometry_list.elements[loop_index].Volume->geometry.mask_mode = 2;
            if (this_cylinder_volume.geometry.mask_mode == 1) {
                if (global_geometry_list.elements[loop_index].Volume->geometry.is_masked_volume == 1 && global_geometry_list.elements[loop_index].Volume->geometry.mask_mode != 2)
                    // If more than one mask is added to one volume, the ANY mode overwrites the (default) ALL mode.
                    global_geometry_list.elements[loop_index].Volume->geometry.mask_mode = 1;
            }
            
            found_geometries = 1;
        }
    }
    if (found_geometries == 0) {
        printf("The mask_string in geometry: %s did not find any of the specified volumes in the mask_string %s \n",NAME_CURRENT_COMP,mask_string);
        exit(1);
    }
    this_cylinder_volume.p_physics = malloc(sizeof(struct physics_struct));
    this_cylinder_volume.p_physics->is_vacuum = 0; // Makes this volume a vacuum
    this_cylinder_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
    this_cylinder_volume.p_physics->my_a = 0; // Should not be used.
    sprintf(this_cylinder_volume.p_physics->name,"Mask");
    this_cylinder_volume.geometry.is_mask_volume = 1;
    
    
// Read the material input, or if it lacks, use automatic linking.
} else if (material_string && strlen(material_string) && strcmp(material_string, "NULL") && strcmp(material_string, "0")) {
    // A geometry string was given, use it to determine which material
    if (0 == strcmp(material_string,"vacuum") || 0 == strcmp(material_string,"Vacuum")) {
        // One could have a global physics struct for vacuum instead of creating one for each
        this_cylinder_volume.p_physics = malloc(sizeof(struct physics_struct));
        this_cylinder_volume.p_physics->is_vacuum = 1; // Makes this volume a vacuum
        this_cylinder_volume.p_physics->number_of_processes = (int) 0;
        this_cylinder_volume.p_physics->my_a = 0; // Should not be used.
        sprintf(this_cylinder_volume.p_physics->name,"Vacuum");
    } else if (0 == strcmp(material_string,"exit") || 0 == strcmp(material_string,"Exit")) {
        // One could have a global physics struct for exit instead of creating one for each
        this_cylinder_volume.p_physics = malloc(sizeof(struct physics_struct));
        this_cylinder_volume.p_physics->is_vacuum = 1; // Makes this volume a vacuum
        this_cylinder_volume.p_physics->number_of_processes = (int) 0;
        this_cylinder_volume.p_physics->my_a = 0; // Should not be used.
        this_cylinder_volume.geometry.is_exit_volume = 1;
        sprintf(this_cylinder_volume.p_physics->name,"Exit");
    } else {
        for (loop_index=0;loop_index<global_material_list.num_elements;loop_index++) {
          if (0 == strcmp(material_string,global_material_list.elements[loop_index].name)) {
            this_cylinder_volume.p_physics = global_material_list.elements[loop_index].physics;
            break;
          }
          if (loop_index == global_material_list.num_elements-1) {
            printf("\n");
            printf("ERROR: The material string \"%s\" in Union geometry \"%s\" did not match a specified material. \n",material_string,NAME_CURRENT_COMP);
            printf("       The materials available at this point (need to be defined before the geometry): \n");
            for (loop_index=0;loop_index<global_material_list.num_elements;loop_index++)
              printf("         %s\n",global_material_list.elements[loop_index].name);
            printf("\n");
            printf("       It is also possible to use one of the defualt materials avaiable: \n");
            printf("           Vacuum (for a Volume without scattering or absorption)\n");
            printf("           Exit (for a Volume where the ray exits the component if it enters)\n");
            printf("           Mask (for a Volume that masks existing volumes specified in the mask_string\n");
            exit(1);
          }
        }
    }
} else {
    // Automatic linking, simply using the last defined material.
    #ifndef MATERIAL_DETECTOR
        printf("Need to define a material before the geometry to use automatic linking %s.\n",NAME_CURRENT_COMP);
        exit(1);
    #endif
    this_cylinder_volume.p_physics = global_material_list.elements[global_material_list.num_elements-1].physics;
}

sprintf(this_cylinder_volume.name,NAME_CURRENT_COMP);
sprintf(this_cylinder_volume.geometry.shape,"cylinder");
this_cylinder_volume.geometry.priority_value = priority;
// Currently the coordinates will be in absolute space.
this_cylinder_volume.geometry.center = POS_A_CURRENT_COMP;

this_cylinder_volume.geometry.geometry_p_interact = p_interact;
this_cylinder_storage.cyl_radius = radius;
this_cylinder_storage.height = yheight;
this_cylinder_volume.geometry.visualization_on = visualize;
this_cylinder_volume.geometry.geometry_parameters.p_cylinder_storage = &this_cylinder_storage;
this_cylinder_volume.geometry.within_function = &r_within_cylinder;
this_cylinder_volume.geometry.intersect_function = &sample_cylinder_intersect;
this_cylinder_volume.geometry.mcdisplay_function = &mcdisplay_cylinder_function;
this_cylinder_volume.geometry.shell_points = &cylinder_shell_points;
this_cylinder_volume.geometry.initialize_from_main_function = &initialize_cylinder_geometry_from_main_component;
this_cylinder_volume.geometry.process_rot_allocated = 0;
this_cylinder_volume.geometry.copy_geometry_parameters = &allocate_cylinder_storage_copy;

rot_copy(this_cylinder_volume.geometry.rotation_matrix,ROT_A_CURRENT_COMP);
rot_transpose(ROT_A_CURRENT_COMP,this_cylinder_volume.geometry.transpose_rotation_matrix);

// Initialize loggers
this_cylinder_volume.loggers.num_elements = 0;

// packing the information into the global_geometry_element, which is then included in the global_geometry_list.
sprintf(global_geometry_element.name,NAME_CURRENT_COMP);
global_geometry_element.activation_counter = number_of_activations;
global_geometry_element.component_index = INDEX_CURRENT_COMP;
global_geometry_element.Volume = &this_cylinder_volume; // Would be nicer if this m was a pointer, now we have the (small) data two places
add_element_to_geometry_list(&global_geometry_list,global_geometry_element);
}
#line 155603 "MACS_sample_kidney_box.c"
#undef number_of_activations
#undef mask_setting
#undef mask_string
#undef p_interact
#undef focus_r
#undef focus_xh
#undef focus_xw
#undef focus_ah
#undef focus_aw
#undef target_z
#undef target_y
#undef target_x
#undef target_index
#undef visualize
#undef yheight
#undef radius
#undef priority
#undef material_string
#undef this_cylinder_storage
#undef global_geometry_element
#undef this_cylinder_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

  /* Initializations for component sample_base_gap. */
  SIG_MESSAGE("sample_base_gap (Init)");
#define mccompcurname  sample_base_gap
#define mccompcurtype  Union_cylinder
#define mccompcurindex 24
#define loop_index mccsample_base_gap_loop_index
#define this_cylinder_volume mccsample_base_gap_this_cylinder_volume
#define global_geometry_element mccsample_base_gap_global_geometry_element
#define this_cylinder_storage mccsample_base_gap_this_cylinder_storage
#define material_string mccsample_base_gap_material_string
#define priority mccsample_base_gap_priority
#define radius mccsample_base_gap_radius
#define yheight mccsample_base_gap_yheight
#define visualize mccsample_base_gap_visualize
#define target_index mccsample_base_gap_target_index
#define target_x mccsample_base_gap_target_x
#define target_y mccsample_base_gap_target_y
#define target_z mccsample_base_gap_target_z
#define focus_aw mccsample_base_gap_focus_aw
#define focus_ah mccsample_base_gap_focus_ah
#define focus_xw mccsample_base_gap_focus_xw
#define focus_xh mccsample_base_gap_focus_xh
#define focus_r mccsample_base_gap_focus_r
#define p_interact mccsample_base_gap_p_interact
#define mask_string mccsample_base_gap_mask_string
#define mask_setting mccsample_base_gap_mask_setting
#define number_of_activations mccsample_base_gap_number_of_activations
#line 185 "Union_cylinder.comp"
{
// Initializes the focusing system for this volume including input sanitation.
focus_initialize(&this_cylinder_volume.geometry, POS_A_COMP_INDEX(INDEX_CURRENT_COMP+target_index), POS_A_CURRENT_COMP, ROT_A_CURRENT_COMP, target_index, target_x, target_y, target_z, focus_aw, focus_ah, focus_xw, focus_xh, focus_r, NAME_CURRENT_COMP);

// Input sanitation for this geometry
if (radius <= 0) {
  printf("\nERROR in Union_cylinder named %s, the radius is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}

if (yheight <= 0) {
  printf("\nERROR in Union_cylinder named %s, yheight is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}

// Use sanitation
#ifdef MATERIAL_DETECTOR
if (global_material_list.num_elements == 0) {
  // Here if the user have defined a material, but only after this material
  printf("\nERROR: Need to define a material using Union_make_material before using a Union geometry component. \n");
  printf("       %s was defined before first use of Union_make_material.\n",NAME_CURRENT_COMP);
  exit(1);
}
#endif
#ifndef MATERIAL_DETECTOR
  printf("\nERROR: Need to define a material using Union_make_material before using a Union geometry component. \n");
  exit(1);
#endif


this_cylinder_volume.geometry.is_masked_volume = 0;
this_cylinder_volume.geometry.is_exit_volume = 0;
this_cylinder_volume.geometry.is_mask_volume = 0;

// Read the material input, or if it lacks, use automatic linking.
if (mask_string && strlen(mask_string) && strcmp(mask_string, "NULL") && strcmp(mask_string, "0")) {
    // A mask volume is used to limit the extend of other volumes, called the masked volumes. These are specified in the mask_string.
    // In order for a ray to enter a masked volume, it needs to be both in the region covered by that volume AND the mask volume.
    // When more than
    this_cylinder_volume.geometry.mask_mode = 1; // Default is mask mode is ALL
    if (mask_setting && strlen(mask_setting) && strcmp(mask_setting, "NULL") && strcmp(mask_setting, "0")) {
        if (strcmp(mask_setting,"ALL") == 0 || strcmp(mask_setting,"All") == 0) this_cylinder_volume.geometry.mask_mode = 1;
        else if (strcmp(mask_setting,"ANY") == 0 || strcmp(mask_setting,"Any") == 0) this_cylinder_volume.geometry.mask_mode = 2;
        else {
            printf("The mask_mode of component %s is set to %s, but must be either ALL or ANY.\n",NAME_CURRENT_COMP,mask_setting);
            exit(1);
        }
    }
    
    for (loop_index=0;loop_index<global_geometry_list.num_elements;loop_index++) {
        // Add mask list
        if (1 == manual_linking_function(global_geometry_list.elements[loop_index].name,mask_string)) {
            add_element_to_int_list(&this_cylinder_volume.geometry.mask_list,global_geometry_list.elements[loop_index].component_index);
            add_element_to_int_list(&global_geometry_list.elements[loop_index].Volume->geometry.masked_by_list,INDEX_CURRENT_COMP);
            global_geometry_list.elements[loop_index].Volume->geometry.is_masked_volume = 1;
            if (this_cylinder_volume.geometry.mask_mode == 2)
                global_geometry_list.elements[loop_index].Volume->geometry.mask_mode = 2;
            if (this_cylinder_volume.geometry.mask_mode == 1) {
                if (global_geometry_list.elements[loop_index].Volume->geometry.is_masked_volume == 1 && global_geometry_list.elements[loop_index].Volume->geometry.mask_mode != 2)
                    // If more than one mask is added to one volume, the ANY mode overwrites the (default) ALL mode.
                    global_geometry_list.elements[loop_index].Volume->geometry.mask_mode = 1;
            }
            
            found_geometries = 1;
        }
    }
    if (found_geometries == 0) {
        printf("The mask_string in geometry: %s did not find any of the specified volumes in the mask_string %s \n",NAME_CURRENT_COMP,mask_string);
        exit(1);
    }
    this_cylinder_volume.p_physics = malloc(sizeof(struct physics_struct));
    this_cylinder_volume.p_physics->is_vacuum = 0; // Makes this volume a vacuum
    this_cylinder_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
    this_cylinder_volume.p_physics->my_a = 0; // Should not be used.
    sprintf(this_cylinder_volume.p_physics->name,"Mask");
    this_cylinder_volume.geometry.is_mask_volume = 1;
    
    
// Read the material input, or if it lacks, use automatic linking.
} else if (material_string && strlen(material_string) && strcmp(material_string, "NULL") && strcmp(material_string, "0")) {
    // A geometry string was given, use it to determine which material
    if (0 == strcmp(material_string,"vacuum") || 0 == strcmp(material_string,"Vacuum")) {
        // One could have a global physics struct for vacuum instead of creating one for each
        this_cylinder_volume.p_physics = malloc(sizeof(struct physics_struct));
        this_cylinder_volume.p_physics->is_vacuum = 1; // Makes this volume a vacuum
        this_cylinder_volume.p_physics->number_of_processes = (int) 0;
        this_cylinder_volume.p_physics->my_a = 0; // Should not be used.
        sprintf(this_cylinder_volume.p_physics->name,"Vacuum");
    } else if (0 == strcmp(material_string,"exit") || 0 == strcmp(material_string,"Exit")) {
        // One could have a global physics struct for exit instead of creating one for each
        this_cylinder_volume.p_physics = malloc(sizeof(struct physics_struct));
        this_cylinder_volume.p_physics->is_vacuum = 1; // Makes this volume a vacuum
        this_cylinder_volume.p_physics->number_of_processes = (int) 0;
        this_cylinder_volume.p_physics->my_a = 0; // Should not be used.
        this_cylinder_volume.geometry.is_exit_volume = 1;
        sprintf(this_cylinder_volume.p_physics->name,"Exit");
    } else {
        for (loop_index=0;loop_index<global_material_list.num_elements;loop_index++) {
          if (0 == strcmp(material_string,global_material_list.elements[loop_index].name)) {
            this_cylinder_volume.p_physics = global_material_list.elements[loop_index].physics;
            break;
          }
          if (loop_index == global_material_list.num_elements-1) {
            printf("\n");
            printf("ERROR: The material string \"%s\" in Union geometry \"%s\" did not match a specified material. \n",material_string,NAME_CURRENT_COMP);
            printf("       The materials available at this point (need to be defined before the geometry): \n");
            for (loop_index=0;loop_index<global_material_list.num_elements;loop_index++)
              printf("         %s\n",global_material_list.elements[loop_index].name);
            printf("\n");
            printf("       It is also possible to use one of the defualt materials avaiable: \n");
            printf("           Vacuum (for a Volume without scattering or absorption)\n");
            printf("           Exit (for a Volume where the ray exits the component if it enters)\n");
            printf("           Mask (for a Volume that masks existing volumes specified in the mask_string\n");
            exit(1);
          }
        }
    }
} else {
    // Automatic linking, simply using the last defined material.
    #ifndef MATERIAL_DETECTOR
        printf("Need to define a material before the geometry to use automatic linking %s.\n",NAME_CURRENT_COMP);
        exit(1);
    #endif
    this_cylinder_volume.p_physics = global_material_list.elements[global_material_list.num_elements-1].physics;
}

sprintf(this_cylinder_volume.name,NAME_CURRENT_COMP);
sprintf(this_cylinder_volume.geometry.shape,"cylinder");
this_cylinder_volume.geometry.priority_value = priority;
// Currently the coordinates will be in absolute space.
this_cylinder_volume.geometry.center = POS_A_CURRENT_COMP;

this_cylinder_volume.geometry.geometry_p_interact = p_interact;
this_cylinder_storage.cyl_radius = radius;
this_cylinder_storage.height = yheight;
this_cylinder_volume.geometry.visualization_on = visualize;
this_cylinder_volume.geometry.geometry_parameters.p_cylinder_storage = &this_cylinder_storage;
this_cylinder_volume.geometry.within_function = &r_within_cylinder;
this_cylinder_volume.geometry.intersect_function = &sample_cylinder_intersect;
this_cylinder_volume.geometry.mcdisplay_function = &mcdisplay_cylinder_function;
this_cylinder_volume.geometry.shell_points = &cylinder_shell_points;
this_cylinder_volume.geometry.initialize_from_main_function = &initialize_cylinder_geometry_from_main_component;
this_cylinder_volume.geometry.process_rot_allocated = 0;
this_cylinder_volume.geometry.copy_geometry_parameters = &allocate_cylinder_storage_copy;

rot_copy(this_cylinder_volume.geometry.rotation_matrix,ROT_A_CURRENT_COMP);
rot_transpose(ROT_A_CURRENT_COMP,this_cylinder_volume.geometry.transpose_rotation_matrix);

// Initialize loggers
this_cylinder_volume.loggers.num_elements = 0;

// packing the information into the global_geometry_element, which is then included in the global_geometry_list.
sprintf(global_geometry_element.name,NAME_CURRENT_COMP);
global_geometry_element.activation_counter = number_of_activations;
global_geometry_element.component_index = INDEX_CURRENT_COMP;
global_geometry_element.Volume = &this_cylinder_volume; // Would be nicer if this m was a pointer, now we have the (small) data two places
add_element_to_geometry_list(&global_geometry_list,global_geometry_element);
}
#line 155816 "MACS_sample_kidney_box.c"
#undef number_of_activations
#undef mask_setting
#undef mask_string
#undef p_interact
#undef focus_r
#undef focus_xh
#undef focus_xw
#undef focus_ah
#undef focus_aw
#undef target_z
#undef target_y
#undef target_x
#undef target_index
#undef visualize
#undef yheight
#undef radius
#undef priority
#undef material_string
#undef this_cylinder_storage
#undef global_geometry_element
#undef this_cylinder_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

  /* Initializations for component cryostat_mountin_plate. */
  SIG_MESSAGE("cryostat_mountin_plate (Init)");
#define mccompcurname  cryostat_mountin_plate
#define mccompcurtype  Union_cylinder
#define mccompcurindex 25
#define loop_index mcccryostat_mountin_plate_loop_index
#define this_cylinder_volume mcccryostat_mountin_plate_this_cylinder_volume
#define global_geometry_element mcccryostat_mountin_plate_global_geometry_element
#define this_cylinder_storage mcccryostat_mountin_plate_this_cylinder_storage
#define material_string mcccryostat_mountin_plate_material_string
#define priority mcccryostat_mountin_plate_priority
#define radius mcccryostat_mountin_plate_radius
#define yheight mcccryostat_mountin_plate_yheight
#define visualize mcccryostat_mountin_plate_visualize
#define target_index mcccryostat_mountin_plate_target_index
#define target_x mcccryostat_mountin_plate_target_x
#define target_y mcccryostat_mountin_plate_target_y
#define target_z mcccryostat_mountin_plate_target_z
#define focus_aw mcccryostat_mountin_plate_focus_aw
#define focus_ah mcccryostat_mountin_plate_focus_ah
#define focus_xw mcccryostat_mountin_plate_focus_xw
#define focus_xh mcccryostat_mountin_plate_focus_xh
#define focus_r mcccryostat_mountin_plate_focus_r
#define p_interact mcccryostat_mountin_plate_p_interact
#define mask_string mcccryostat_mountin_plate_mask_string
#define mask_setting mcccryostat_mountin_plate_mask_setting
#define number_of_activations mcccryostat_mountin_plate_number_of_activations
#line 185 "Union_cylinder.comp"
{
// Initializes the focusing system for this volume including input sanitation.
focus_initialize(&this_cylinder_volume.geometry, POS_A_COMP_INDEX(INDEX_CURRENT_COMP+target_index), POS_A_CURRENT_COMP, ROT_A_CURRENT_COMP, target_index, target_x, target_y, target_z, focus_aw, focus_ah, focus_xw, focus_xh, focus_r, NAME_CURRENT_COMP);

// Input sanitation for this geometry
if (radius <= 0) {
  printf("\nERROR in Union_cylinder named %s, the radius is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}

if (yheight <= 0) {
  printf("\nERROR in Union_cylinder named %s, yheight is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}

// Use sanitation
#ifdef MATERIAL_DETECTOR
if (global_material_list.num_elements == 0) {
  // Here if the user have defined a material, but only after this material
  printf("\nERROR: Need to define a material using Union_make_material before using a Union geometry component. \n");
  printf("       %s was defined before first use of Union_make_material.\n",NAME_CURRENT_COMP);
  exit(1);
}
#endif
#ifndef MATERIAL_DETECTOR
  printf("\nERROR: Need to define a material using Union_make_material before using a Union geometry component. \n");
  exit(1);
#endif


this_cylinder_volume.geometry.is_masked_volume = 0;
this_cylinder_volume.geometry.is_exit_volume = 0;
this_cylinder_volume.geometry.is_mask_volume = 0;

// Read the material input, or if it lacks, use automatic linking.
if (mask_string && strlen(mask_string) && strcmp(mask_string, "NULL") && strcmp(mask_string, "0")) {
    // A mask volume is used to limit the extend of other volumes, called the masked volumes. These are specified in the mask_string.
    // In order for a ray to enter a masked volume, it needs to be both in the region covered by that volume AND the mask volume.
    // When more than
    this_cylinder_volume.geometry.mask_mode = 1; // Default is mask mode is ALL
    if (mask_setting && strlen(mask_setting) && strcmp(mask_setting, "NULL") && strcmp(mask_setting, "0")) {
        if (strcmp(mask_setting,"ALL") == 0 || strcmp(mask_setting,"All") == 0) this_cylinder_volume.geometry.mask_mode = 1;
        else if (strcmp(mask_setting,"ANY") == 0 || strcmp(mask_setting,"Any") == 0) this_cylinder_volume.geometry.mask_mode = 2;
        else {
            printf("The mask_mode of component %s is set to %s, but must be either ALL or ANY.\n",NAME_CURRENT_COMP,mask_setting);
            exit(1);
        }
    }
    
    for (loop_index=0;loop_index<global_geometry_list.num_elements;loop_index++) {
        // Add mask list
        if (1 == manual_linking_function(global_geometry_list.elements[loop_index].name,mask_string)) {
            add_element_to_int_list(&this_cylinder_volume.geometry.mask_list,global_geometry_list.elements[loop_index].component_index);
            add_element_to_int_list(&global_geometry_list.elements[loop_index].Volume->geometry.masked_by_list,INDEX_CURRENT_COMP);
            global_geometry_list.elements[loop_index].Volume->geometry.is_masked_volume = 1;
            if (this_cylinder_volume.geometry.mask_mode == 2)
                global_geometry_list.elements[loop_index].Volume->geometry.mask_mode = 2;
            if (this_cylinder_volume.geometry.mask_mode == 1) {
                if (global_geometry_list.elements[loop_index].Volume->geometry.is_masked_volume == 1 && global_geometry_list.elements[loop_index].Volume->geometry.mask_mode != 2)
                    // If more than one mask is added to one volume, the ANY mode overwrites the (default) ALL mode.
                    global_geometry_list.elements[loop_index].Volume->geometry.mask_mode = 1;
            }
            
            found_geometries = 1;
        }
    }
    if (found_geometries == 0) {
        printf("The mask_string in geometry: %s did not find any of the specified volumes in the mask_string %s \n",NAME_CURRENT_COMP,mask_string);
        exit(1);
    }
    this_cylinder_volume.p_physics = malloc(sizeof(struct physics_struct));
    this_cylinder_volume.p_physics->is_vacuum = 0; // Makes this volume a vacuum
    this_cylinder_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
    this_cylinder_volume.p_physics->my_a = 0; // Should not be used.
    sprintf(this_cylinder_volume.p_physics->name,"Mask");
    this_cylinder_volume.geometry.is_mask_volume = 1;
    
    
// Read the material input, or if it lacks, use automatic linking.
} else if (material_string && strlen(material_string) && strcmp(material_string, "NULL") && strcmp(material_string, "0")) {
    // A geometry string was given, use it to determine which material
    if (0 == strcmp(material_string,"vacuum") || 0 == strcmp(material_string,"Vacuum")) {
        // One could have a global physics struct for vacuum instead of creating one for each
        this_cylinder_volume.p_physics = malloc(sizeof(struct physics_struct));
        this_cylinder_volume.p_physics->is_vacuum = 1; // Makes this volume a vacuum
        this_cylinder_volume.p_physics->number_of_processes = (int) 0;
        this_cylinder_volume.p_physics->my_a = 0; // Should not be used.
        sprintf(this_cylinder_volume.p_physics->name,"Vacuum");
    } else if (0 == strcmp(material_string,"exit") || 0 == strcmp(material_string,"Exit")) {
        // One could have a global physics struct for exit instead of creating one for each
        this_cylinder_volume.p_physics = malloc(sizeof(struct physics_struct));
        this_cylinder_volume.p_physics->is_vacuum = 1; // Makes this volume a vacuum
        this_cylinder_volume.p_physics->number_of_processes = (int) 0;
        this_cylinder_volume.p_physics->my_a = 0; // Should not be used.
        this_cylinder_volume.geometry.is_exit_volume = 1;
        sprintf(this_cylinder_volume.p_physics->name,"Exit");
    } else {
        for (loop_index=0;loop_index<global_material_list.num_elements;loop_index++) {
          if (0 == strcmp(material_string,global_material_list.elements[loop_index].name)) {
            this_cylinder_volume.p_physics = global_material_list.elements[loop_index].physics;
            break;
          }
          if (loop_index == global_material_list.num_elements-1) {
            printf("\n");
            printf("ERROR: The material string \"%s\" in Union geometry \"%s\" did not match a specified material. \n",material_string,NAME_CURRENT_COMP);
            printf("       The materials available at this point (need to be defined before the geometry): \n");
            for (loop_index=0;loop_index<global_material_list.num_elements;loop_index++)
              printf("         %s\n",global_material_list.elements[loop_index].name);
            printf("\n");
            printf("       It is also possible to use one of the defualt materials avaiable: \n");
            printf("           Vacuum (for a Volume without scattering or absorption)\n");
            printf("           Exit (for a Volume where the ray exits the component if it enters)\n");
            printf("           Mask (for a Volume that masks existing volumes specified in the mask_string\n");
            exit(1);
          }
        }
    }
} else {
    // Automatic linking, simply using the last defined material.
    #ifndef MATERIAL_DETECTOR
        printf("Need to define a material before the geometry to use automatic linking %s.\n",NAME_CURRENT_COMP);
        exit(1);
    #endif
    this_cylinder_volume.p_physics = global_material_list.elements[global_material_list.num_elements-1].physics;
}

sprintf(this_cylinder_volume.name,NAME_CURRENT_COMP);
sprintf(this_cylinder_volume.geometry.shape,"cylinder");
this_cylinder_volume.geometry.priority_value = priority;
// Currently the coordinates will be in absolute space.
this_cylinder_volume.geometry.center = POS_A_CURRENT_COMP;

this_cylinder_volume.geometry.geometry_p_interact = p_interact;
this_cylinder_storage.cyl_radius = radius;
this_cylinder_storage.height = yheight;
this_cylinder_volume.geometry.visualization_on = visualize;
this_cylinder_volume.geometry.geometry_parameters.p_cylinder_storage = &this_cylinder_storage;
this_cylinder_volume.geometry.within_function = &r_within_cylinder;
this_cylinder_volume.geometry.intersect_function = &sample_cylinder_intersect;
this_cylinder_volume.geometry.mcdisplay_function = &mcdisplay_cylinder_function;
this_cylinder_volume.geometry.shell_points = &cylinder_shell_points;
this_cylinder_volume.geometry.initialize_from_main_function = &initialize_cylinder_geometry_from_main_component;
this_cylinder_volume.geometry.process_rot_allocated = 0;
this_cylinder_volume.geometry.copy_geometry_parameters = &allocate_cylinder_storage_copy;

rot_copy(this_cylinder_volume.geometry.rotation_matrix,ROT_A_CURRENT_COMP);
rot_transpose(ROT_A_CURRENT_COMP,this_cylinder_volume.geometry.transpose_rotation_matrix);

// Initialize loggers
this_cylinder_volume.loggers.num_elements = 0;

// packing the information into the global_geometry_element, which is then included in the global_geometry_list.
sprintf(global_geometry_element.name,NAME_CURRENT_COMP);
global_geometry_element.activation_counter = number_of_activations;
global_geometry_element.component_index = INDEX_CURRENT_COMP;
global_geometry_element.Volume = &this_cylinder_volume; // Would be nicer if this m was a pointer, now we have the (small) data two places
add_element_to_geometry_list(&global_geometry_list,global_geometry_element);
}
#line 156029 "MACS_sample_kidney_box.c"
#undef number_of_activations
#undef mask_setting
#undef mask_string
#undef p_interact
#undef focus_r
#undef focus_xh
#undef focus_xw
#undef focus_ah
#undef focus_aw
#undef target_z
#undef target_y
#undef target_x
#undef target_index
#undef visualize
#undef yheight
#undef radius
#undef priority
#undef material_string
#undef this_cylinder_storage
#undef global_geometry_element
#undef this_cylinder_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

  /* Initializations for component cryostat_drum_walls. */
  SIG_MESSAGE("cryostat_drum_walls (Init)");
#define mccompcurname  cryostat_drum_walls
#define mccompcurtype  Union_cylinder
#define mccompcurindex 26
#define loop_index mcccryostat_drum_walls_loop_index
#define this_cylinder_volume mcccryostat_drum_walls_this_cylinder_volume
#define global_geometry_element mcccryostat_drum_walls_global_geometry_element
#define this_cylinder_storage mcccryostat_drum_walls_this_cylinder_storage
#define material_string mcccryostat_drum_walls_material_string
#define priority mcccryostat_drum_walls_priority
#define radius mcccryostat_drum_walls_radius
#define yheight mcccryostat_drum_walls_yheight
#define visualize mcccryostat_drum_walls_visualize
#define target_index mcccryostat_drum_walls_target_index
#define target_x mcccryostat_drum_walls_target_x
#define target_y mcccryostat_drum_walls_target_y
#define target_z mcccryostat_drum_walls_target_z
#define focus_aw mcccryostat_drum_walls_focus_aw
#define focus_ah mcccryostat_drum_walls_focus_ah
#define focus_xw mcccryostat_drum_walls_focus_xw
#define focus_xh mcccryostat_drum_walls_focus_xh
#define focus_r mcccryostat_drum_walls_focus_r
#define p_interact mcccryostat_drum_walls_p_interact
#define mask_string mcccryostat_drum_walls_mask_string
#define mask_setting mcccryostat_drum_walls_mask_setting
#define number_of_activations mcccryostat_drum_walls_number_of_activations
#line 185 "Union_cylinder.comp"
{
// Initializes the focusing system for this volume including input sanitation.
focus_initialize(&this_cylinder_volume.geometry, POS_A_COMP_INDEX(INDEX_CURRENT_COMP+target_index), POS_A_CURRENT_COMP, ROT_A_CURRENT_COMP, target_index, target_x, target_y, target_z, focus_aw, focus_ah, focus_xw, focus_xh, focus_r, NAME_CURRENT_COMP);

// Input sanitation for this geometry
if (radius <= 0) {
  printf("\nERROR in Union_cylinder named %s, the radius is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}

if (yheight <= 0) {
  printf("\nERROR in Union_cylinder named %s, yheight is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}

// Use sanitation
#ifdef MATERIAL_DETECTOR
if (global_material_list.num_elements == 0) {
  // Here if the user have defined a material, but only after this material
  printf("\nERROR: Need to define a material using Union_make_material before using a Union geometry component. \n");
  printf("       %s was defined before first use of Union_make_material.\n",NAME_CURRENT_COMP);
  exit(1);
}
#endif
#ifndef MATERIAL_DETECTOR
  printf("\nERROR: Need to define a material using Union_make_material before using a Union geometry component. \n");
  exit(1);
#endif


this_cylinder_volume.geometry.is_masked_volume = 0;
this_cylinder_volume.geometry.is_exit_volume = 0;
this_cylinder_volume.geometry.is_mask_volume = 0;

// Read the material input, or if it lacks, use automatic linking.
if (mask_string && strlen(mask_string) && strcmp(mask_string, "NULL") && strcmp(mask_string, "0")) {
    // A mask volume is used to limit the extend of other volumes, called the masked volumes. These are specified in the mask_string.
    // In order for a ray to enter a masked volume, it needs to be both in the region covered by that volume AND the mask volume.
    // When more than
    this_cylinder_volume.geometry.mask_mode = 1; // Default is mask mode is ALL
    if (mask_setting && strlen(mask_setting) && strcmp(mask_setting, "NULL") && strcmp(mask_setting, "0")) {
        if (strcmp(mask_setting,"ALL") == 0 || strcmp(mask_setting,"All") == 0) this_cylinder_volume.geometry.mask_mode = 1;
        else if (strcmp(mask_setting,"ANY") == 0 || strcmp(mask_setting,"Any") == 0) this_cylinder_volume.geometry.mask_mode = 2;
        else {
            printf("The mask_mode of component %s is set to %s, but must be either ALL or ANY.\n",NAME_CURRENT_COMP,mask_setting);
            exit(1);
        }
    }
    
    for (loop_index=0;loop_index<global_geometry_list.num_elements;loop_index++) {
        // Add mask list
        if (1 == manual_linking_function(global_geometry_list.elements[loop_index].name,mask_string)) {
            add_element_to_int_list(&this_cylinder_volume.geometry.mask_list,global_geometry_list.elements[loop_index].component_index);
            add_element_to_int_list(&global_geometry_list.elements[loop_index].Volume->geometry.masked_by_list,INDEX_CURRENT_COMP);
            global_geometry_list.elements[loop_index].Volume->geometry.is_masked_volume = 1;
            if (this_cylinder_volume.geometry.mask_mode == 2)
                global_geometry_list.elements[loop_index].Volume->geometry.mask_mode = 2;
            if (this_cylinder_volume.geometry.mask_mode == 1) {
                if (global_geometry_list.elements[loop_index].Volume->geometry.is_masked_volume == 1 && global_geometry_list.elements[loop_index].Volume->geometry.mask_mode != 2)
                    // If more than one mask is added to one volume, the ANY mode overwrites the (default) ALL mode.
                    global_geometry_list.elements[loop_index].Volume->geometry.mask_mode = 1;
            }
            
            found_geometries = 1;
        }
    }
    if (found_geometries == 0) {
        printf("The mask_string in geometry: %s did not find any of the specified volumes in the mask_string %s \n",NAME_CURRENT_COMP,mask_string);
        exit(1);
    }
    this_cylinder_volume.p_physics = malloc(sizeof(struct physics_struct));
    this_cylinder_volume.p_physics->is_vacuum = 0; // Makes this volume a vacuum
    this_cylinder_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
    this_cylinder_volume.p_physics->my_a = 0; // Should not be used.
    sprintf(this_cylinder_volume.p_physics->name,"Mask");
    this_cylinder_volume.geometry.is_mask_volume = 1;
    
    
// Read the material input, or if it lacks, use automatic linking.
} else if (material_string && strlen(material_string) && strcmp(material_string, "NULL") && strcmp(material_string, "0")) {
    // A geometry string was given, use it to determine which material
    if (0 == strcmp(material_string,"vacuum") || 0 == strcmp(material_string,"Vacuum")) {
        // One could have a global physics struct for vacuum instead of creating one for each
        this_cylinder_volume.p_physics = malloc(sizeof(struct physics_struct));
        this_cylinder_volume.p_physics->is_vacuum = 1; // Makes this volume a vacuum
        this_cylinder_volume.p_physics->number_of_processes = (int) 0;
        this_cylinder_volume.p_physics->my_a = 0; // Should not be used.
        sprintf(this_cylinder_volume.p_physics->name,"Vacuum");
    } else if (0 == strcmp(material_string,"exit") || 0 == strcmp(material_string,"Exit")) {
        // One could have a global physics struct for exit instead of creating one for each
        this_cylinder_volume.p_physics = malloc(sizeof(struct physics_struct));
        this_cylinder_volume.p_physics->is_vacuum = 1; // Makes this volume a vacuum
        this_cylinder_volume.p_physics->number_of_processes = (int) 0;
        this_cylinder_volume.p_physics->my_a = 0; // Should not be used.
        this_cylinder_volume.geometry.is_exit_volume = 1;
        sprintf(this_cylinder_volume.p_physics->name,"Exit");
    } else {
        for (loop_index=0;loop_index<global_material_list.num_elements;loop_index++) {
          if (0 == strcmp(material_string,global_material_list.elements[loop_index].name)) {
            this_cylinder_volume.p_physics = global_material_list.elements[loop_index].physics;
            break;
          }
          if (loop_index == global_material_list.num_elements-1) {
            printf("\n");
            printf("ERROR: The material string \"%s\" in Union geometry \"%s\" did not match a specified material. \n",material_string,NAME_CURRENT_COMP);
            printf("       The materials available at this point (need to be defined before the geometry): \n");
            for (loop_index=0;loop_index<global_material_list.num_elements;loop_index++)
              printf("         %s\n",global_material_list.elements[loop_index].name);
            printf("\n");
            printf("       It is also possible to use one of the defualt materials avaiable: \n");
            printf("           Vacuum (for a Volume without scattering or absorption)\n");
            printf("           Exit (for a Volume where the ray exits the component if it enters)\n");
            printf("           Mask (for a Volume that masks existing volumes specified in the mask_string\n");
            exit(1);
          }
        }
    }
} else {
    // Automatic linking, simply using the last defined material.
    #ifndef MATERIAL_DETECTOR
        printf("Need to define a material before the geometry to use automatic linking %s.\n",NAME_CURRENT_COMP);
        exit(1);
    #endif
    this_cylinder_volume.p_physics = global_material_list.elements[global_material_list.num_elements-1].physics;
}

sprintf(this_cylinder_volume.name,NAME_CURRENT_COMP);
sprintf(this_cylinder_volume.geometry.shape,"cylinder");
this_cylinder_volume.geometry.priority_value = priority;
// Currently the coordinates will be in absolute space.
this_cylinder_volume.geometry.center = POS_A_CURRENT_COMP;

this_cylinder_volume.geometry.geometry_p_interact = p_interact;
this_cylinder_storage.cyl_radius = radius;
this_cylinder_storage.height = yheight;
this_cylinder_volume.geometry.visualization_on = visualize;
this_cylinder_volume.geometry.geometry_parameters.p_cylinder_storage = &this_cylinder_storage;
this_cylinder_volume.geometry.within_function = &r_within_cylinder;
this_cylinder_volume.geometry.intersect_function = &sample_cylinder_intersect;
this_cylinder_volume.geometry.mcdisplay_function = &mcdisplay_cylinder_function;
this_cylinder_volume.geometry.shell_points = &cylinder_shell_points;
this_cylinder_volume.geometry.initialize_from_main_function = &initialize_cylinder_geometry_from_main_component;
this_cylinder_volume.geometry.process_rot_allocated = 0;
this_cylinder_volume.geometry.copy_geometry_parameters = &allocate_cylinder_storage_copy;

rot_copy(this_cylinder_volume.geometry.rotation_matrix,ROT_A_CURRENT_COMP);
rot_transpose(ROT_A_CURRENT_COMP,this_cylinder_volume.geometry.transpose_rotation_matrix);

// Initialize loggers
this_cylinder_volume.loggers.num_elements = 0;

// packing the information into the global_geometry_element, which is then included in the global_geometry_list.
sprintf(global_geometry_element.name,NAME_CURRENT_COMP);
global_geometry_element.activation_counter = number_of_activations;
global_geometry_element.component_index = INDEX_CURRENT_COMP;
global_geometry_element.Volume = &this_cylinder_volume; // Would be nicer if this m was a pointer, now we have the (small) data two places
add_element_to_geometry_list(&global_geometry_list,global_geometry_element);
}
#line 156242 "MACS_sample_kidney_box.c"
#undef number_of_activations
#undef mask_setting
#undef mask_string
#undef p_interact
#undef focus_r
#undef focus_xh
#undef focus_xw
#undef focus_ah
#undef focus_aw
#undef target_z
#undef target_y
#undef target_x
#undef target_index
#undef visualize
#undef yheight
#undef radius
#undef priority
#undef material_string
#undef this_cylinder_storage
#undef global_geometry_element
#undef this_cylinder_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

  /* Initializations for component cryostat_drum_vacuum. */
  SIG_MESSAGE("cryostat_drum_vacuum (Init)");
#define mccompcurname  cryostat_drum_vacuum
#define mccompcurtype  Union_cylinder
#define mccompcurindex 27
#define loop_index mcccryostat_drum_vacuum_loop_index
#define this_cylinder_volume mcccryostat_drum_vacuum_this_cylinder_volume
#define global_geometry_element mcccryostat_drum_vacuum_global_geometry_element
#define this_cylinder_storage mcccryostat_drum_vacuum_this_cylinder_storage
#define material_string mcccryostat_drum_vacuum_material_string
#define priority mcccryostat_drum_vacuum_priority
#define radius mcccryostat_drum_vacuum_radius
#define yheight mcccryostat_drum_vacuum_yheight
#define visualize mcccryostat_drum_vacuum_visualize
#define target_index mcccryostat_drum_vacuum_target_index
#define target_x mcccryostat_drum_vacuum_target_x
#define target_y mcccryostat_drum_vacuum_target_y
#define target_z mcccryostat_drum_vacuum_target_z
#define focus_aw mcccryostat_drum_vacuum_focus_aw
#define focus_ah mcccryostat_drum_vacuum_focus_ah
#define focus_xw mcccryostat_drum_vacuum_focus_xw
#define focus_xh mcccryostat_drum_vacuum_focus_xh
#define focus_r mcccryostat_drum_vacuum_focus_r
#define p_interact mcccryostat_drum_vacuum_p_interact
#define mask_string mcccryostat_drum_vacuum_mask_string
#define mask_setting mcccryostat_drum_vacuum_mask_setting
#define number_of_activations mcccryostat_drum_vacuum_number_of_activations
#line 185 "Union_cylinder.comp"
{
// Initializes the focusing system for this volume including input sanitation.
focus_initialize(&this_cylinder_volume.geometry, POS_A_COMP_INDEX(INDEX_CURRENT_COMP+target_index), POS_A_CURRENT_COMP, ROT_A_CURRENT_COMP, target_index, target_x, target_y, target_z, focus_aw, focus_ah, focus_xw, focus_xh, focus_r, NAME_CURRENT_COMP);

// Input sanitation for this geometry
if (radius <= 0) {
  printf("\nERROR in Union_cylinder named %s, the radius is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}

if (yheight <= 0) {
  printf("\nERROR in Union_cylinder named %s, yheight is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}

// Use sanitation
#ifdef MATERIAL_DETECTOR
if (global_material_list.num_elements == 0) {
  // Here if the user have defined a material, but only after this material
  printf("\nERROR: Need to define a material using Union_make_material before using a Union geometry component. \n");
  printf("       %s was defined before first use of Union_make_material.\n",NAME_CURRENT_COMP);
  exit(1);
}
#endif
#ifndef MATERIAL_DETECTOR
  printf("\nERROR: Need to define a material using Union_make_material before using a Union geometry component. \n");
  exit(1);
#endif


this_cylinder_volume.geometry.is_masked_volume = 0;
this_cylinder_volume.geometry.is_exit_volume = 0;
this_cylinder_volume.geometry.is_mask_volume = 0;

// Read the material input, or if it lacks, use automatic linking.
if (mask_string && strlen(mask_string) && strcmp(mask_string, "NULL") && strcmp(mask_string, "0")) {
    // A mask volume is used to limit the extend of other volumes, called the masked volumes. These are specified in the mask_string.
    // In order for a ray to enter a masked volume, it needs to be both in the region covered by that volume AND the mask volume.
    // When more than
    this_cylinder_volume.geometry.mask_mode = 1; // Default is mask mode is ALL
    if (mask_setting && strlen(mask_setting) && strcmp(mask_setting, "NULL") && strcmp(mask_setting, "0")) {
        if (strcmp(mask_setting,"ALL") == 0 || strcmp(mask_setting,"All") == 0) this_cylinder_volume.geometry.mask_mode = 1;
        else if (strcmp(mask_setting,"ANY") == 0 || strcmp(mask_setting,"Any") == 0) this_cylinder_volume.geometry.mask_mode = 2;
        else {
            printf("The mask_mode of component %s is set to %s, but must be either ALL or ANY.\n",NAME_CURRENT_COMP,mask_setting);
            exit(1);
        }
    }
    
    for (loop_index=0;loop_index<global_geometry_list.num_elements;loop_index++) {
        // Add mask list
        if (1 == manual_linking_function(global_geometry_list.elements[loop_index].name,mask_string)) {
            add_element_to_int_list(&this_cylinder_volume.geometry.mask_list,global_geometry_list.elements[loop_index].component_index);
            add_element_to_int_list(&global_geometry_list.elements[loop_index].Volume->geometry.masked_by_list,INDEX_CURRENT_COMP);
            global_geometry_list.elements[loop_index].Volume->geometry.is_masked_volume = 1;
            if (this_cylinder_volume.geometry.mask_mode == 2)
                global_geometry_list.elements[loop_index].Volume->geometry.mask_mode = 2;
            if (this_cylinder_volume.geometry.mask_mode == 1) {
                if (global_geometry_list.elements[loop_index].Volume->geometry.is_masked_volume == 1 && global_geometry_list.elements[loop_index].Volume->geometry.mask_mode != 2)
                    // If more than one mask is added to one volume, the ANY mode overwrites the (default) ALL mode.
                    global_geometry_list.elements[loop_index].Volume->geometry.mask_mode = 1;
            }
            
            found_geometries = 1;
        }
    }
    if (found_geometries == 0) {
        printf("The mask_string in geometry: %s did not find any of the specified volumes in the mask_string %s \n",NAME_CURRENT_COMP,mask_string);
        exit(1);
    }
    this_cylinder_volume.p_physics = malloc(sizeof(struct physics_struct));
    this_cylinder_volume.p_physics->is_vacuum = 0; // Makes this volume a vacuum
    this_cylinder_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
    this_cylinder_volume.p_physics->my_a = 0; // Should not be used.
    sprintf(this_cylinder_volume.p_physics->name,"Mask");
    this_cylinder_volume.geometry.is_mask_volume = 1;
    
    
// Read the material input, or if it lacks, use automatic linking.
} else if (material_string && strlen(material_string) && strcmp(material_string, "NULL") && strcmp(material_string, "0")) {
    // A geometry string was given, use it to determine which material
    if (0 == strcmp(material_string,"vacuum") || 0 == strcmp(material_string,"Vacuum")) {
        // One could have a global physics struct for vacuum instead of creating one for each
        this_cylinder_volume.p_physics = malloc(sizeof(struct physics_struct));
        this_cylinder_volume.p_physics->is_vacuum = 1; // Makes this volume a vacuum
        this_cylinder_volume.p_physics->number_of_processes = (int) 0;
        this_cylinder_volume.p_physics->my_a = 0; // Should not be used.
        sprintf(this_cylinder_volume.p_physics->name,"Vacuum");
    } else if (0 == strcmp(material_string,"exit") || 0 == strcmp(material_string,"Exit")) {
        // One could have a global physics struct for exit instead of creating one for each
        this_cylinder_volume.p_physics = malloc(sizeof(struct physics_struct));
        this_cylinder_volume.p_physics->is_vacuum = 1; // Makes this volume a vacuum
        this_cylinder_volume.p_physics->number_of_processes = (int) 0;
        this_cylinder_volume.p_physics->my_a = 0; // Should not be used.
        this_cylinder_volume.geometry.is_exit_volume = 1;
        sprintf(this_cylinder_volume.p_physics->name,"Exit");
    } else {
        for (loop_index=0;loop_index<global_material_list.num_elements;loop_index++) {
          if (0 == strcmp(material_string,global_material_list.elements[loop_index].name)) {
            this_cylinder_volume.p_physics = global_material_list.elements[loop_index].physics;
            break;
          }
          if (loop_index == global_material_list.num_elements-1) {
            printf("\n");
            printf("ERROR: The material string \"%s\" in Union geometry \"%s\" did not match a specified material. \n",material_string,NAME_CURRENT_COMP);
            printf("       The materials available at this point (need to be defined before the geometry): \n");
            for (loop_index=0;loop_index<global_material_list.num_elements;loop_index++)
              printf("         %s\n",global_material_list.elements[loop_index].name);
            printf("\n");
            printf("       It is also possible to use one of the defualt materials avaiable: \n");
            printf("           Vacuum (for a Volume without scattering or absorption)\n");
            printf("           Exit (for a Volume where the ray exits the component if it enters)\n");
            printf("           Mask (for a Volume that masks existing volumes specified in the mask_string\n");
            exit(1);
          }
        }
    }
} else {
    // Automatic linking, simply using the last defined material.
    #ifndef MATERIAL_DETECTOR
        printf("Need to define a material before the geometry to use automatic linking %s.\n",NAME_CURRENT_COMP);
        exit(1);
    #endif
    this_cylinder_volume.p_physics = global_material_list.elements[global_material_list.num_elements-1].physics;
}

sprintf(this_cylinder_volume.name,NAME_CURRENT_COMP);
sprintf(this_cylinder_volume.geometry.shape,"cylinder");
this_cylinder_volume.geometry.priority_value = priority;
// Currently the coordinates will be in absolute space.
this_cylinder_volume.geometry.center = POS_A_CURRENT_COMP;

this_cylinder_volume.geometry.geometry_p_interact = p_interact;
this_cylinder_storage.cyl_radius = radius;
this_cylinder_storage.height = yheight;
this_cylinder_volume.geometry.visualization_on = visualize;
this_cylinder_volume.geometry.geometry_parameters.p_cylinder_storage = &this_cylinder_storage;
this_cylinder_volume.geometry.within_function = &r_within_cylinder;
this_cylinder_volume.geometry.intersect_function = &sample_cylinder_intersect;
this_cylinder_volume.geometry.mcdisplay_function = &mcdisplay_cylinder_function;
this_cylinder_volume.geometry.shell_points = &cylinder_shell_points;
this_cylinder_volume.geometry.initialize_from_main_function = &initialize_cylinder_geometry_from_main_component;
this_cylinder_volume.geometry.process_rot_allocated = 0;
this_cylinder_volume.geometry.copy_geometry_parameters = &allocate_cylinder_storage_copy;

rot_copy(this_cylinder_volume.geometry.rotation_matrix,ROT_A_CURRENT_COMP);
rot_transpose(ROT_A_CURRENT_COMP,this_cylinder_volume.geometry.transpose_rotation_matrix);

// Initialize loggers
this_cylinder_volume.loggers.num_elements = 0;

// packing the information into the global_geometry_element, which is then included in the global_geometry_list.
sprintf(global_geometry_element.name,NAME_CURRENT_COMP);
global_geometry_element.activation_counter = number_of_activations;
global_geometry_element.component_index = INDEX_CURRENT_COMP;
global_geometry_element.Volume = &this_cylinder_volume; // Would be nicer if this m was a pointer, now we have the (small) data two places
add_element_to_geometry_list(&global_geometry_list,global_geometry_element);
}
#line 156455 "MACS_sample_kidney_box.c"
#undef number_of_activations
#undef mask_setting
#undef mask_string
#undef p_interact
#undef focus_r
#undef focus_xh
#undef focus_xw
#undef focus_ah
#undef focus_aw
#undef target_z
#undef target_y
#undef target_x
#undef target_index
#undef visualize
#undef yheight
#undef radius
#undef priority
#undef material_string
#undef this_cylinder_storage
#undef global_geometry_element
#undef this_cylinder_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

  /* Initializations for component outer_cryostat_wall. */
  SIG_MESSAGE("outer_cryostat_wall (Init)");
#define mccompcurname  outer_cryostat_wall
#define mccompcurtype  Union_cylinder
#define mccompcurindex 28
#define loop_index mccouter_cryostat_wall_loop_index
#define this_cylinder_volume mccouter_cryostat_wall_this_cylinder_volume
#define global_geometry_element mccouter_cryostat_wall_global_geometry_element
#define this_cylinder_storage mccouter_cryostat_wall_this_cylinder_storage
#define material_string mccouter_cryostat_wall_material_string
#define priority mccouter_cryostat_wall_priority
#define radius mccouter_cryostat_wall_radius
#define yheight mccouter_cryostat_wall_yheight
#define visualize mccouter_cryostat_wall_visualize
#define target_index mccouter_cryostat_wall_target_index
#define target_x mccouter_cryostat_wall_target_x
#define target_y mccouter_cryostat_wall_target_y
#define target_z mccouter_cryostat_wall_target_z
#define focus_aw mccouter_cryostat_wall_focus_aw
#define focus_ah mccouter_cryostat_wall_focus_ah
#define focus_xw mccouter_cryostat_wall_focus_xw
#define focus_xh mccouter_cryostat_wall_focus_xh
#define focus_r mccouter_cryostat_wall_focus_r
#define p_interact mccouter_cryostat_wall_p_interact
#define mask_string mccouter_cryostat_wall_mask_string
#define mask_setting mccouter_cryostat_wall_mask_setting
#define number_of_activations mccouter_cryostat_wall_number_of_activations
#line 185 "Union_cylinder.comp"
{
// Initializes the focusing system for this volume including input sanitation.
focus_initialize(&this_cylinder_volume.geometry, POS_A_COMP_INDEX(INDEX_CURRENT_COMP+target_index), POS_A_CURRENT_COMP, ROT_A_CURRENT_COMP, target_index, target_x, target_y, target_z, focus_aw, focus_ah, focus_xw, focus_xh, focus_r, NAME_CURRENT_COMP);

// Input sanitation for this geometry
if (radius <= 0) {
  printf("\nERROR in Union_cylinder named %s, the radius is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}

if (yheight <= 0) {
  printf("\nERROR in Union_cylinder named %s, yheight is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}

// Use sanitation
#ifdef MATERIAL_DETECTOR
if (global_material_list.num_elements == 0) {
  // Here if the user have defined a material, but only after this material
  printf("\nERROR: Need to define a material using Union_make_material before using a Union geometry component. \n");
  printf("       %s was defined before first use of Union_make_material.\n",NAME_CURRENT_COMP);
  exit(1);
}
#endif
#ifndef MATERIAL_DETECTOR
  printf("\nERROR: Need to define a material using Union_make_material before using a Union geometry component. \n");
  exit(1);
#endif


this_cylinder_volume.geometry.is_masked_volume = 0;
this_cylinder_volume.geometry.is_exit_volume = 0;
this_cylinder_volume.geometry.is_mask_volume = 0;

// Read the material input, or if it lacks, use automatic linking.
if (mask_string && strlen(mask_string) && strcmp(mask_string, "NULL") && strcmp(mask_string, "0")) {
    // A mask volume is used to limit the extend of other volumes, called the masked volumes. These are specified in the mask_string.
    // In order for a ray to enter a masked volume, it needs to be both in the region covered by that volume AND the mask volume.
    // When more than
    this_cylinder_volume.geometry.mask_mode = 1; // Default is mask mode is ALL
    if (mask_setting && strlen(mask_setting) && strcmp(mask_setting, "NULL") && strcmp(mask_setting, "0")) {
        if (strcmp(mask_setting,"ALL") == 0 || strcmp(mask_setting,"All") == 0) this_cylinder_volume.geometry.mask_mode = 1;
        else if (strcmp(mask_setting,"ANY") == 0 || strcmp(mask_setting,"Any") == 0) this_cylinder_volume.geometry.mask_mode = 2;
        else {
            printf("The mask_mode of component %s is set to %s, but must be either ALL or ANY.\n",NAME_CURRENT_COMP,mask_setting);
            exit(1);
        }
    }
    
    for (loop_index=0;loop_index<global_geometry_list.num_elements;loop_index++) {
        // Add mask list
        if (1 == manual_linking_function(global_geometry_list.elements[loop_index].name,mask_string)) {
            add_element_to_int_list(&this_cylinder_volume.geometry.mask_list,global_geometry_list.elements[loop_index].component_index);
            add_element_to_int_list(&global_geometry_list.elements[loop_index].Volume->geometry.masked_by_list,INDEX_CURRENT_COMP);
            global_geometry_list.elements[loop_index].Volume->geometry.is_masked_volume = 1;
            if (this_cylinder_volume.geometry.mask_mode == 2)
                global_geometry_list.elements[loop_index].Volume->geometry.mask_mode = 2;
            if (this_cylinder_volume.geometry.mask_mode == 1) {
                if (global_geometry_list.elements[loop_index].Volume->geometry.is_masked_volume == 1 && global_geometry_list.elements[loop_index].Volume->geometry.mask_mode != 2)
                    // If more than one mask is added to one volume, the ANY mode overwrites the (default) ALL mode.
                    global_geometry_list.elements[loop_index].Volume->geometry.mask_mode = 1;
            }
            
            found_geometries = 1;
        }
    }
    if (found_geometries == 0) {
        printf("The mask_string in geometry: %s did not find any of the specified volumes in the mask_string %s \n",NAME_CURRENT_COMP,mask_string);
        exit(1);
    }
    this_cylinder_volume.p_physics = malloc(sizeof(struct physics_struct));
    this_cylinder_volume.p_physics->is_vacuum = 0; // Makes this volume a vacuum
    this_cylinder_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
    this_cylinder_volume.p_physics->my_a = 0; // Should not be used.
    sprintf(this_cylinder_volume.p_physics->name,"Mask");
    this_cylinder_volume.geometry.is_mask_volume = 1;
    
    
// Read the material input, or if it lacks, use automatic linking.
} else if (material_string && strlen(material_string) && strcmp(material_string, "NULL") && strcmp(material_string, "0")) {
    // A geometry string was given, use it to determine which material
    if (0 == strcmp(material_string,"vacuum") || 0 == strcmp(material_string,"Vacuum")) {
        // One could have a global physics struct for vacuum instead of creating one for each
        this_cylinder_volume.p_physics = malloc(sizeof(struct physics_struct));
        this_cylinder_volume.p_physics->is_vacuum = 1; // Makes this volume a vacuum
        this_cylinder_volume.p_physics->number_of_processes = (int) 0;
        this_cylinder_volume.p_physics->my_a = 0; // Should not be used.
        sprintf(this_cylinder_volume.p_physics->name,"Vacuum");
    } else if (0 == strcmp(material_string,"exit") || 0 == strcmp(material_string,"Exit")) {
        // One could have a global physics struct for exit instead of creating one for each
        this_cylinder_volume.p_physics = malloc(sizeof(struct physics_struct));
        this_cylinder_volume.p_physics->is_vacuum = 1; // Makes this volume a vacuum
        this_cylinder_volume.p_physics->number_of_processes = (int) 0;
        this_cylinder_volume.p_physics->my_a = 0; // Should not be used.
        this_cylinder_volume.geometry.is_exit_volume = 1;
        sprintf(this_cylinder_volume.p_physics->name,"Exit");
    } else {
        for (loop_index=0;loop_index<global_material_list.num_elements;loop_index++) {
          if (0 == strcmp(material_string,global_material_list.elements[loop_index].name)) {
            this_cylinder_volume.p_physics = global_material_list.elements[loop_index].physics;
            break;
          }
          if (loop_index == global_material_list.num_elements-1) {
            printf("\n");
            printf("ERROR: The material string \"%s\" in Union geometry \"%s\" did not match a specified material. \n",material_string,NAME_CURRENT_COMP);
            printf("       The materials available at this point (need to be defined before the geometry): \n");
            for (loop_index=0;loop_index<global_material_list.num_elements;loop_index++)
              printf("         %s\n",global_material_list.elements[loop_index].name);
            printf("\n");
            printf("       It is also possible to use one of the defualt materials avaiable: \n");
            printf("           Vacuum (for a Volume without scattering or absorption)\n");
            printf("           Exit (for a Volume where the ray exits the component if it enters)\n");
            printf("           Mask (for a Volume that masks existing volumes specified in the mask_string\n");
            exit(1);
          }
        }
    }
} else {
    // Automatic linking, simply using the last defined material.
    #ifndef MATERIAL_DETECTOR
        printf("Need to define a material before the geometry to use automatic linking %s.\n",NAME_CURRENT_COMP);
        exit(1);
    #endif
    this_cylinder_volume.p_physics = global_material_list.elements[global_material_list.num_elements-1].physics;
}

sprintf(this_cylinder_volume.name,NAME_CURRENT_COMP);
sprintf(this_cylinder_volume.geometry.shape,"cylinder");
this_cylinder_volume.geometry.priority_value = priority;
// Currently the coordinates will be in absolute space.
this_cylinder_volume.geometry.center = POS_A_CURRENT_COMP;

this_cylinder_volume.geometry.geometry_p_interact = p_interact;
this_cylinder_storage.cyl_radius = radius;
this_cylinder_storage.height = yheight;
this_cylinder_volume.geometry.visualization_on = visualize;
this_cylinder_volume.geometry.geometry_parameters.p_cylinder_storage = &this_cylinder_storage;
this_cylinder_volume.geometry.within_function = &r_within_cylinder;
this_cylinder_volume.geometry.intersect_function = &sample_cylinder_intersect;
this_cylinder_volume.geometry.mcdisplay_function = &mcdisplay_cylinder_function;
this_cylinder_volume.geometry.shell_points = &cylinder_shell_points;
this_cylinder_volume.geometry.initialize_from_main_function = &initialize_cylinder_geometry_from_main_component;
this_cylinder_volume.geometry.process_rot_allocated = 0;
this_cylinder_volume.geometry.copy_geometry_parameters = &allocate_cylinder_storage_copy;

rot_copy(this_cylinder_volume.geometry.rotation_matrix,ROT_A_CURRENT_COMP);
rot_transpose(ROT_A_CURRENT_COMP,this_cylinder_volume.geometry.transpose_rotation_matrix);

// Initialize loggers
this_cylinder_volume.loggers.num_elements = 0;

// packing the information into the global_geometry_element, which is then included in the global_geometry_list.
sprintf(global_geometry_element.name,NAME_CURRENT_COMP);
global_geometry_element.activation_counter = number_of_activations;
global_geometry_element.component_index = INDEX_CURRENT_COMP;
global_geometry_element.Volume = &this_cylinder_volume; // Would be nicer if this m was a pointer, now we have the (small) data two places
add_element_to_geometry_list(&global_geometry_list,global_geometry_element);
}
#line 156668 "MACS_sample_kidney_box.c"
#undef number_of_activations
#undef mask_setting
#undef mask_string
#undef p_interact
#undef focus_r
#undef focus_xh
#undef focus_xw
#undef focus_ah
#undef focus_aw
#undef target_z
#undef target_y
#undef target_x
#undef target_index
#undef visualize
#undef yheight
#undef radius
#undef priority
#undef material_string
#undef this_cylinder_storage
#undef global_geometry_element
#undef this_cylinder_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

  /* Initializations for component outer_cryostat_vacuum. */
  SIG_MESSAGE("outer_cryostat_vacuum (Init)");
#define mccompcurname  outer_cryostat_vacuum
#define mccompcurtype  Union_cylinder
#define mccompcurindex 29
#define loop_index mccouter_cryostat_vacuum_loop_index
#define this_cylinder_volume mccouter_cryostat_vacuum_this_cylinder_volume
#define global_geometry_element mccouter_cryostat_vacuum_global_geometry_element
#define this_cylinder_storage mccouter_cryostat_vacuum_this_cylinder_storage
#define material_string mccouter_cryostat_vacuum_material_string
#define priority mccouter_cryostat_vacuum_priority
#define radius mccouter_cryostat_vacuum_radius
#define yheight mccouter_cryostat_vacuum_yheight
#define visualize mccouter_cryostat_vacuum_visualize
#define target_index mccouter_cryostat_vacuum_target_index
#define target_x mccouter_cryostat_vacuum_target_x
#define target_y mccouter_cryostat_vacuum_target_y
#define target_z mccouter_cryostat_vacuum_target_z
#define focus_aw mccouter_cryostat_vacuum_focus_aw
#define focus_ah mccouter_cryostat_vacuum_focus_ah
#define focus_xw mccouter_cryostat_vacuum_focus_xw
#define focus_xh mccouter_cryostat_vacuum_focus_xh
#define focus_r mccouter_cryostat_vacuum_focus_r
#define p_interact mccouter_cryostat_vacuum_p_interact
#define mask_string mccouter_cryostat_vacuum_mask_string
#define mask_setting mccouter_cryostat_vacuum_mask_setting
#define number_of_activations mccouter_cryostat_vacuum_number_of_activations
#line 185 "Union_cylinder.comp"
{
// Initializes the focusing system for this volume including input sanitation.
focus_initialize(&this_cylinder_volume.geometry, POS_A_COMP_INDEX(INDEX_CURRENT_COMP+target_index), POS_A_CURRENT_COMP, ROT_A_CURRENT_COMP, target_index, target_x, target_y, target_z, focus_aw, focus_ah, focus_xw, focus_xh, focus_r, NAME_CURRENT_COMP);

// Input sanitation for this geometry
if (radius <= 0) {
  printf("\nERROR in Union_cylinder named %s, the radius is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}

if (yheight <= 0) {
  printf("\nERROR in Union_cylinder named %s, yheight is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}

// Use sanitation
#ifdef MATERIAL_DETECTOR
if (global_material_list.num_elements == 0) {
  // Here if the user have defined a material, but only after this material
  printf("\nERROR: Need to define a material using Union_make_material before using a Union geometry component. \n");
  printf("       %s was defined before first use of Union_make_material.\n",NAME_CURRENT_COMP);
  exit(1);
}
#endif
#ifndef MATERIAL_DETECTOR
  printf("\nERROR: Need to define a material using Union_make_material before using a Union geometry component. \n");
  exit(1);
#endif


this_cylinder_volume.geometry.is_masked_volume = 0;
this_cylinder_volume.geometry.is_exit_volume = 0;
this_cylinder_volume.geometry.is_mask_volume = 0;

// Read the material input, or if it lacks, use automatic linking.
if (mask_string && strlen(mask_string) && strcmp(mask_string, "NULL") && strcmp(mask_string, "0")) {
    // A mask volume is used to limit the extend of other volumes, called the masked volumes. These are specified in the mask_string.
    // In order for a ray to enter a masked volume, it needs to be both in the region covered by that volume AND the mask volume.
    // When more than
    this_cylinder_volume.geometry.mask_mode = 1; // Default is mask mode is ALL
    if (mask_setting && strlen(mask_setting) && strcmp(mask_setting, "NULL") && strcmp(mask_setting, "0")) {
        if (strcmp(mask_setting,"ALL") == 0 || strcmp(mask_setting,"All") == 0) this_cylinder_volume.geometry.mask_mode = 1;
        else if (strcmp(mask_setting,"ANY") == 0 || strcmp(mask_setting,"Any") == 0) this_cylinder_volume.geometry.mask_mode = 2;
        else {
            printf("The mask_mode of component %s is set to %s, but must be either ALL or ANY.\n",NAME_CURRENT_COMP,mask_setting);
            exit(1);
        }
    }
    
    for (loop_index=0;loop_index<global_geometry_list.num_elements;loop_index++) {
        // Add mask list
        if (1 == manual_linking_function(global_geometry_list.elements[loop_index].name,mask_string)) {
            add_element_to_int_list(&this_cylinder_volume.geometry.mask_list,global_geometry_list.elements[loop_index].component_index);
            add_element_to_int_list(&global_geometry_list.elements[loop_index].Volume->geometry.masked_by_list,INDEX_CURRENT_COMP);
            global_geometry_list.elements[loop_index].Volume->geometry.is_masked_volume = 1;
            if (this_cylinder_volume.geometry.mask_mode == 2)
                global_geometry_list.elements[loop_index].Volume->geometry.mask_mode = 2;
            if (this_cylinder_volume.geometry.mask_mode == 1) {
                if (global_geometry_list.elements[loop_index].Volume->geometry.is_masked_volume == 1 && global_geometry_list.elements[loop_index].Volume->geometry.mask_mode != 2)
                    // If more than one mask is added to one volume, the ANY mode overwrites the (default) ALL mode.
                    global_geometry_list.elements[loop_index].Volume->geometry.mask_mode = 1;
            }
            
            found_geometries = 1;
        }
    }
    if (found_geometries == 0) {
        printf("The mask_string in geometry: %s did not find any of the specified volumes in the mask_string %s \n",NAME_CURRENT_COMP,mask_string);
        exit(1);
    }
    this_cylinder_volume.p_physics = malloc(sizeof(struct physics_struct));
    this_cylinder_volume.p_physics->is_vacuum = 0; // Makes this volume a vacuum
    this_cylinder_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
    this_cylinder_volume.p_physics->my_a = 0; // Should not be used.
    sprintf(this_cylinder_volume.p_physics->name,"Mask");
    this_cylinder_volume.geometry.is_mask_volume = 1;
    
    
// Read the material input, or if it lacks, use automatic linking.
} else if (material_string && strlen(material_string) && strcmp(material_string, "NULL") && strcmp(material_string, "0")) {
    // A geometry string was given, use it to determine which material
    if (0 == strcmp(material_string,"vacuum") || 0 == strcmp(material_string,"Vacuum")) {
        // One could have a global physics struct for vacuum instead of creating one for each
        this_cylinder_volume.p_physics = malloc(sizeof(struct physics_struct));
        this_cylinder_volume.p_physics->is_vacuum = 1; // Makes this volume a vacuum
        this_cylinder_volume.p_physics->number_of_processes = (int) 0;
        this_cylinder_volume.p_physics->my_a = 0; // Should not be used.
        sprintf(this_cylinder_volume.p_physics->name,"Vacuum");
    } else if (0 == strcmp(material_string,"exit") || 0 == strcmp(material_string,"Exit")) {
        // One could have a global physics struct for exit instead of creating one for each
        this_cylinder_volume.p_physics = malloc(sizeof(struct physics_struct));
        this_cylinder_volume.p_physics->is_vacuum = 1; // Makes this volume a vacuum
        this_cylinder_volume.p_physics->number_of_processes = (int) 0;
        this_cylinder_volume.p_physics->my_a = 0; // Should not be used.
        this_cylinder_volume.geometry.is_exit_volume = 1;
        sprintf(this_cylinder_volume.p_physics->name,"Exit");
    } else {
        for (loop_index=0;loop_index<global_material_list.num_elements;loop_index++) {
          if (0 == strcmp(material_string,global_material_list.elements[loop_index].name)) {
            this_cylinder_volume.p_physics = global_material_list.elements[loop_index].physics;
            break;
          }
          if (loop_index == global_material_list.num_elements-1) {
            printf("\n");
            printf("ERROR: The material string \"%s\" in Union geometry \"%s\" did not match a specified material. \n",material_string,NAME_CURRENT_COMP);
            printf("       The materials available at this point (need to be defined before the geometry): \n");
            for (loop_index=0;loop_index<global_material_list.num_elements;loop_index++)
              printf("         %s\n",global_material_list.elements[loop_index].name);
            printf("\n");
            printf("       It is also possible to use one of the defualt materials avaiable: \n");
            printf("           Vacuum (for a Volume without scattering or absorption)\n");
            printf("           Exit (for a Volume where the ray exits the component if it enters)\n");
            printf("           Mask (for a Volume that masks existing volumes specified in the mask_string\n");
            exit(1);
          }
        }
    }
} else {
    // Automatic linking, simply using the last defined material.
    #ifndef MATERIAL_DETECTOR
        printf("Need to define a material before the geometry to use automatic linking %s.\n",NAME_CURRENT_COMP);
        exit(1);
    #endif
    this_cylinder_volume.p_physics = global_material_list.elements[global_material_list.num_elements-1].physics;
}

sprintf(this_cylinder_volume.name,NAME_CURRENT_COMP);
sprintf(this_cylinder_volume.geometry.shape,"cylinder");
this_cylinder_volume.geometry.priority_value = priority;
// Currently the coordinates will be in absolute space.
this_cylinder_volume.geometry.center = POS_A_CURRENT_COMP;

this_cylinder_volume.geometry.geometry_p_interact = p_interact;
this_cylinder_storage.cyl_radius = radius;
this_cylinder_storage.height = yheight;
this_cylinder_volume.geometry.visualization_on = visualize;
this_cylinder_volume.geometry.geometry_parameters.p_cylinder_storage = &this_cylinder_storage;
this_cylinder_volume.geometry.within_function = &r_within_cylinder;
this_cylinder_volume.geometry.intersect_function = &sample_cylinder_intersect;
this_cylinder_volume.geometry.mcdisplay_function = &mcdisplay_cylinder_function;
this_cylinder_volume.geometry.shell_points = &cylinder_shell_points;
this_cylinder_volume.geometry.initialize_from_main_function = &initialize_cylinder_geometry_from_main_component;
this_cylinder_volume.geometry.process_rot_allocated = 0;
this_cylinder_volume.geometry.copy_geometry_parameters = &allocate_cylinder_storage_copy;

rot_copy(this_cylinder_volume.geometry.rotation_matrix,ROT_A_CURRENT_COMP);
rot_transpose(ROT_A_CURRENT_COMP,this_cylinder_volume.geometry.transpose_rotation_matrix);

// Initialize loggers
this_cylinder_volume.loggers.num_elements = 0;

// packing the information into the global_geometry_element, which is then included in the global_geometry_list.
sprintf(global_geometry_element.name,NAME_CURRENT_COMP);
global_geometry_element.activation_counter = number_of_activations;
global_geometry_element.component_index = INDEX_CURRENT_COMP;
global_geometry_element.Volume = &this_cylinder_volume; // Would be nicer if this m was a pointer, now we have the (small) data two places
add_element_to_geometry_list(&global_geometry_list,global_geometry_element);
}
#line 156881 "MACS_sample_kidney_box.c"
#undef number_of_activations
#undef mask_setting
#undef mask_string
#undef p_interact
#undef focus_r
#undef focus_xh
#undef focus_xw
#undef focus_ah
#undef focus_aw
#undef target_z
#undef target_y
#undef target_x
#undef target_index
#undef visualize
#undef yheight
#undef radius
#undef priority
#undef material_string
#undef this_cylinder_storage
#undef global_geometry_element
#undef this_cylinder_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

  /* Initializations for component inner_cryostat_wall. */
  SIG_MESSAGE("inner_cryostat_wall (Init)");
#define mccompcurname  inner_cryostat_wall
#define mccompcurtype  Union_cylinder
#define mccompcurindex 30
#define loop_index mccinner_cryostat_wall_loop_index
#define this_cylinder_volume mccinner_cryostat_wall_this_cylinder_volume
#define global_geometry_element mccinner_cryostat_wall_global_geometry_element
#define this_cylinder_storage mccinner_cryostat_wall_this_cylinder_storage
#define material_string mccinner_cryostat_wall_material_string
#define priority mccinner_cryostat_wall_priority
#define radius mccinner_cryostat_wall_radius
#define yheight mccinner_cryostat_wall_yheight
#define visualize mccinner_cryostat_wall_visualize
#define target_index mccinner_cryostat_wall_target_index
#define target_x mccinner_cryostat_wall_target_x
#define target_y mccinner_cryostat_wall_target_y
#define target_z mccinner_cryostat_wall_target_z
#define focus_aw mccinner_cryostat_wall_focus_aw
#define focus_ah mccinner_cryostat_wall_focus_ah
#define focus_xw mccinner_cryostat_wall_focus_xw
#define focus_xh mccinner_cryostat_wall_focus_xh
#define focus_r mccinner_cryostat_wall_focus_r
#define p_interact mccinner_cryostat_wall_p_interact
#define mask_string mccinner_cryostat_wall_mask_string
#define mask_setting mccinner_cryostat_wall_mask_setting
#define number_of_activations mccinner_cryostat_wall_number_of_activations
#line 185 "Union_cylinder.comp"
{
// Initializes the focusing system for this volume including input sanitation.
focus_initialize(&this_cylinder_volume.geometry, POS_A_COMP_INDEX(INDEX_CURRENT_COMP+target_index), POS_A_CURRENT_COMP, ROT_A_CURRENT_COMP, target_index, target_x, target_y, target_z, focus_aw, focus_ah, focus_xw, focus_xh, focus_r, NAME_CURRENT_COMP);

// Input sanitation for this geometry
if (radius <= 0) {
  printf("\nERROR in Union_cylinder named %s, the radius is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}

if (yheight <= 0) {
  printf("\nERROR in Union_cylinder named %s, yheight is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}

// Use sanitation
#ifdef MATERIAL_DETECTOR
if (global_material_list.num_elements == 0) {
  // Here if the user have defined a material, but only after this material
  printf("\nERROR: Need to define a material using Union_make_material before using a Union geometry component. \n");
  printf("       %s was defined before first use of Union_make_material.\n",NAME_CURRENT_COMP);
  exit(1);
}
#endif
#ifndef MATERIAL_DETECTOR
  printf("\nERROR: Need to define a material using Union_make_material before using a Union geometry component. \n");
  exit(1);
#endif


this_cylinder_volume.geometry.is_masked_volume = 0;
this_cylinder_volume.geometry.is_exit_volume = 0;
this_cylinder_volume.geometry.is_mask_volume = 0;

// Read the material input, or if it lacks, use automatic linking.
if (mask_string && strlen(mask_string) && strcmp(mask_string, "NULL") && strcmp(mask_string, "0")) {
    // A mask volume is used to limit the extend of other volumes, called the masked volumes. These are specified in the mask_string.
    // In order for a ray to enter a masked volume, it needs to be both in the region covered by that volume AND the mask volume.
    // When more than
    this_cylinder_volume.geometry.mask_mode = 1; // Default is mask mode is ALL
    if (mask_setting && strlen(mask_setting) && strcmp(mask_setting, "NULL") && strcmp(mask_setting, "0")) {
        if (strcmp(mask_setting,"ALL") == 0 || strcmp(mask_setting,"All") == 0) this_cylinder_volume.geometry.mask_mode = 1;
        else if (strcmp(mask_setting,"ANY") == 0 || strcmp(mask_setting,"Any") == 0) this_cylinder_volume.geometry.mask_mode = 2;
        else {
            printf("The mask_mode of component %s is set to %s, but must be either ALL or ANY.\n",NAME_CURRENT_COMP,mask_setting);
            exit(1);
        }
    }
    
    for (loop_index=0;loop_index<global_geometry_list.num_elements;loop_index++) {
        // Add mask list
        if (1 == manual_linking_function(global_geometry_list.elements[loop_index].name,mask_string)) {
            add_element_to_int_list(&this_cylinder_volume.geometry.mask_list,global_geometry_list.elements[loop_index].component_index);
            add_element_to_int_list(&global_geometry_list.elements[loop_index].Volume->geometry.masked_by_list,INDEX_CURRENT_COMP);
            global_geometry_list.elements[loop_index].Volume->geometry.is_masked_volume = 1;
            if (this_cylinder_volume.geometry.mask_mode == 2)
                global_geometry_list.elements[loop_index].Volume->geometry.mask_mode = 2;
            if (this_cylinder_volume.geometry.mask_mode == 1) {
                if (global_geometry_list.elements[loop_index].Volume->geometry.is_masked_volume == 1 && global_geometry_list.elements[loop_index].Volume->geometry.mask_mode != 2)
                    // If more than one mask is added to one volume, the ANY mode overwrites the (default) ALL mode.
                    global_geometry_list.elements[loop_index].Volume->geometry.mask_mode = 1;
            }
            
            found_geometries = 1;
        }
    }
    if (found_geometries == 0) {
        printf("The mask_string in geometry: %s did not find any of the specified volumes in the mask_string %s \n",NAME_CURRENT_COMP,mask_string);
        exit(1);
    }
    this_cylinder_volume.p_physics = malloc(sizeof(struct physics_struct));
    this_cylinder_volume.p_physics->is_vacuum = 0; // Makes this volume a vacuum
    this_cylinder_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
    this_cylinder_volume.p_physics->my_a = 0; // Should not be used.
    sprintf(this_cylinder_volume.p_physics->name,"Mask");
    this_cylinder_volume.geometry.is_mask_volume = 1;
    
    
// Read the material input, or if it lacks, use automatic linking.
} else if (material_string && strlen(material_string) && strcmp(material_string, "NULL") && strcmp(material_string, "0")) {
    // A geometry string was given, use it to determine which material
    if (0 == strcmp(material_string,"vacuum") || 0 == strcmp(material_string,"Vacuum")) {
        // One could have a global physics struct for vacuum instead of creating one for each
        this_cylinder_volume.p_physics = malloc(sizeof(struct physics_struct));
        this_cylinder_volume.p_physics->is_vacuum = 1; // Makes this volume a vacuum
        this_cylinder_volume.p_physics->number_of_processes = (int) 0;
        this_cylinder_volume.p_physics->my_a = 0; // Should not be used.
        sprintf(this_cylinder_volume.p_physics->name,"Vacuum");
    } else if (0 == strcmp(material_string,"exit") || 0 == strcmp(material_string,"Exit")) {
        // One could have a global physics struct for exit instead of creating one for each
        this_cylinder_volume.p_physics = malloc(sizeof(struct physics_struct));
        this_cylinder_volume.p_physics->is_vacuum = 1; // Makes this volume a vacuum
        this_cylinder_volume.p_physics->number_of_processes = (int) 0;
        this_cylinder_volume.p_physics->my_a = 0; // Should not be used.
        this_cylinder_volume.geometry.is_exit_volume = 1;
        sprintf(this_cylinder_volume.p_physics->name,"Exit");
    } else {
        for (loop_index=0;loop_index<global_material_list.num_elements;loop_index++) {
          if (0 == strcmp(material_string,global_material_list.elements[loop_index].name)) {
            this_cylinder_volume.p_physics = global_material_list.elements[loop_index].physics;
            break;
          }
          if (loop_index == global_material_list.num_elements-1) {
            printf("\n");
            printf("ERROR: The material string \"%s\" in Union geometry \"%s\" did not match a specified material. \n",material_string,NAME_CURRENT_COMP);
            printf("       The materials available at this point (need to be defined before the geometry): \n");
            for (loop_index=0;loop_index<global_material_list.num_elements;loop_index++)
              printf("         %s\n",global_material_list.elements[loop_index].name);
            printf("\n");
            printf("       It is also possible to use one of the defualt materials avaiable: \n");
            printf("           Vacuum (for a Volume without scattering or absorption)\n");
            printf("           Exit (for a Volume where the ray exits the component if it enters)\n");
            printf("           Mask (for a Volume that masks existing volumes specified in the mask_string\n");
            exit(1);
          }
        }
    }
} else {
    // Automatic linking, simply using the last defined material.
    #ifndef MATERIAL_DETECTOR
        printf("Need to define a material before the geometry to use automatic linking %s.\n",NAME_CURRENT_COMP);
        exit(1);
    #endif
    this_cylinder_volume.p_physics = global_material_list.elements[global_material_list.num_elements-1].physics;
}

sprintf(this_cylinder_volume.name,NAME_CURRENT_COMP);
sprintf(this_cylinder_volume.geometry.shape,"cylinder");
this_cylinder_volume.geometry.priority_value = priority;
// Currently the coordinates will be in absolute space.
this_cylinder_volume.geometry.center = POS_A_CURRENT_COMP;

this_cylinder_volume.geometry.geometry_p_interact = p_interact;
this_cylinder_storage.cyl_radius = radius;
this_cylinder_storage.height = yheight;
this_cylinder_volume.geometry.visualization_on = visualize;
this_cylinder_volume.geometry.geometry_parameters.p_cylinder_storage = &this_cylinder_storage;
this_cylinder_volume.geometry.within_function = &r_within_cylinder;
this_cylinder_volume.geometry.intersect_function = &sample_cylinder_intersect;
this_cylinder_volume.geometry.mcdisplay_function = &mcdisplay_cylinder_function;
this_cylinder_volume.geometry.shell_points = &cylinder_shell_points;
this_cylinder_volume.geometry.initialize_from_main_function = &initialize_cylinder_geometry_from_main_component;
this_cylinder_volume.geometry.process_rot_allocated = 0;
this_cylinder_volume.geometry.copy_geometry_parameters = &allocate_cylinder_storage_copy;

rot_copy(this_cylinder_volume.geometry.rotation_matrix,ROT_A_CURRENT_COMP);
rot_transpose(ROT_A_CURRENT_COMP,this_cylinder_volume.geometry.transpose_rotation_matrix);

// Initialize loggers
this_cylinder_volume.loggers.num_elements = 0;

// packing the information into the global_geometry_element, which is then included in the global_geometry_list.
sprintf(global_geometry_element.name,NAME_CURRENT_COMP);
global_geometry_element.activation_counter = number_of_activations;
global_geometry_element.component_index = INDEX_CURRENT_COMP;
global_geometry_element.Volume = &this_cylinder_volume; // Would be nicer if this m was a pointer, now we have the (small) data two places
add_element_to_geometry_list(&global_geometry_list,global_geometry_element);
}
#line 157094 "MACS_sample_kidney_box.c"
#undef number_of_activations
#undef mask_setting
#undef mask_string
#undef p_interact
#undef focus_r
#undef focus_xh
#undef focus_xw
#undef focus_ah
#undef focus_aw
#undef target_z
#undef target_y
#undef target_x
#undef target_index
#undef visualize
#undef yheight
#undef radius
#undef priority
#undef material_string
#undef this_cylinder_storage
#undef global_geometry_element
#undef this_cylinder_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

  /* Initializations for component inner_cryostat_vacuum. */
  SIG_MESSAGE("inner_cryostat_vacuum (Init)");
#define mccompcurname  inner_cryostat_vacuum
#define mccompcurtype  Union_cylinder
#define mccompcurindex 31
#define loop_index mccinner_cryostat_vacuum_loop_index
#define this_cylinder_volume mccinner_cryostat_vacuum_this_cylinder_volume
#define global_geometry_element mccinner_cryostat_vacuum_global_geometry_element
#define this_cylinder_storage mccinner_cryostat_vacuum_this_cylinder_storage
#define material_string mccinner_cryostat_vacuum_material_string
#define priority mccinner_cryostat_vacuum_priority
#define radius mccinner_cryostat_vacuum_radius
#define yheight mccinner_cryostat_vacuum_yheight
#define visualize mccinner_cryostat_vacuum_visualize
#define target_index mccinner_cryostat_vacuum_target_index
#define target_x mccinner_cryostat_vacuum_target_x
#define target_y mccinner_cryostat_vacuum_target_y
#define target_z mccinner_cryostat_vacuum_target_z
#define focus_aw mccinner_cryostat_vacuum_focus_aw
#define focus_ah mccinner_cryostat_vacuum_focus_ah
#define focus_xw mccinner_cryostat_vacuum_focus_xw
#define focus_xh mccinner_cryostat_vacuum_focus_xh
#define focus_r mccinner_cryostat_vacuum_focus_r
#define p_interact mccinner_cryostat_vacuum_p_interact
#define mask_string mccinner_cryostat_vacuum_mask_string
#define mask_setting mccinner_cryostat_vacuum_mask_setting
#define number_of_activations mccinner_cryostat_vacuum_number_of_activations
#line 185 "Union_cylinder.comp"
{
// Initializes the focusing system for this volume including input sanitation.
focus_initialize(&this_cylinder_volume.geometry, POS_A_COMP_INDEX(INDEX_CURRENT_COMP+target_index), POS_A_CURRENT_COMP, ROT_A_CURRENT_COMP, target_index, target_x, target_y, target_z, focus_aw, focus_ah, focus_xw, focus_xh, focus_r, NAME_CURRENT_COMP);

// Input sanitation for this geometry
if (radius <= 0) {
  printf("\nERROR in Union_cylinder named %s, the radius is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}

if (yheight <= 0) {
  printf("\nERROR in Union_cylinder named %s, yheight is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}

// Use sanitation
#ifdef MATERIAL_DETECTOR
if (global_material_list.num_elements == 0) {
  // Here if the user have defined a material, but only after this material
  printf("\nERROR: Need to define a material using Union_make_material before using a Union geometry component. \n");
  printf("       %s was defined before first use of Union_make_material.\n",NAME_CURRENT_COMP);
  exit(1);
}
#endif
#ifndef MATERIAL_DETECTOR
  printf("\nERROR: Need to define a material using Union_make_material before using a Union geometry component. \n");
  exit(1);
#endif


this_cylinder_volume.geometry.is_masked_volume = 0;
this_cylinder_volume.geometry.is_exit_volume = 0;
this_cylinder_volume.geometry.is_mask_volume = 0;

// Read the material input, or if it lacks, use automatic linking.
if (mask_string && strlen(mask_string) && strcmp(mask_string, "NULL") && strcmp(mask_string, "0")) {
    // A mask volume is used to limit the extend of other volumes, called the masked volumes. These are specified in the mask_string.
    // In order for a ray to enter a masked volume, it needs to be both in the region covered by that volume AND the mask volume.
    // When more than
    this_cylinder_volume.geometry.mask_mode = 1; // Default is mask mode is ALL
    if (mask_setting && strlen(mask_setting) && strcmp(mask_setting, "NULL") && strcmp(mask_setting, "0")) {
        if (strcmp(mask_setting,"ALL") == 0 || strcmp(mask_setting,"All") == 0) this_cylinder_volume.geometry.mask_mode = 1;
        else if (strcmp(mask_setting,"ANY") == 0 || strcmp(mask_setting,"Any") == 0) this_cylinder_volume.geometry.mask_mode = 2;
        else {
            printf("The mask_mode of component %s is set to %s, but must be either ALL or ANY.\n",NAME_CURRENT_COMP,mask_setting);
            exit(1);
        }
    }
    
    for (loop_index=0;loop_index<global_geometry_list.num_elements;loop_index++) {
        // Add mask list
        if (1 == manual_linking_function(global_geometry_list.elements[loop_index].name,mask_string)) {
            add_element_to_int_list(&this_cylinder_volume.geometry.mask_list,global_geometry_list.elements[loop_index].component_index);
            add_element_to_int_list(&global_geometry_list.elements[loop_index].Volume->geometry.masked_by_list,INDEX_CURRENT_COMP);
            global_geometry_list.elements[loop_index].Volume->geometry.is_masked_volume = 1;
            if (this_cylinder_volume.geometry.mask_mode == 2)
                global_geometry_list.elements[loop_index].Volume->geometry.mask_mode = 2;
            if (this_cylinder_volume.geometry.mask_mode == 1) {
                if (global_geometry_list.elements[loop_index].Volume->geometry.is_masked_volume == 1 && global_geometry_list.elements[loop_index].Volume->geometry.mask_mode != 2)
                    // If more than one mask is added to one volume, the ANY mode overwrites the (default) ALL mode.
                    global_geometry_list.elements[loop_index].Volume->geometry.mask_mode = 1;
            }
            
            found_geometries = 1;
        }
    }
    if (found_geometries == 0) {
        printf("The mask_string in geometry: %s did not find any of the specified volumes in the mask_string %s \n",NAME_CURRENT_COMP,mask_string);
        exit(1);
    }
    this_cylinder_volume.p_physics = malloc(sizeof(struct physics_struct));
    this_cylinder_volume.p_physics->is_vacuum = 0; // Makes this volume a vacuum
    this_cylinder_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
    this_cylinder_volume.p_physics->my_a = 0; // Should not be used.
    sprintf(this_cylinder_volume.p_physics->name,"Mask");
    this_cylinder_volume.geometry.is_mask_volume = 1;
    
    
// Read the material input, or if it lacks, use automatic linking.
} else if (material_string && strlen(material_string) && strcmp(material_string, "NULL") && strcmp(material_string, "0")) {
    // A geometry string was given, use it to determine which material
    if (0 == strcmp(material_string,"vacuum") || 0 == strcmp(material_string,"Vacuum")) {
        // One could have a global physics struct for vacuum instead of creating one for each
        this_cylinder_volume.p_physics = malloc(sizeof(struct physics_struct));
        this_cylinder_volume.p_physics->is_vacuum = 1; // Makes this volume a vacuum
        this_cylinder_volume.p_physics->number_of_processes = (int) 0;
        this_cylinder_volume.p_physics->my_a = 0; // Should not be used.
        sprintf(this_cylinder_volume.p_physics->name,"Vacuum");
    } else if (0 == strcmp(material_string,"exit") || 0 == strcmp(material_string,"Exit")) {
        // One could have a global physics struct for exit instead of creating one for each
        this_cylinder_volume.p_physics = malloc(sizeof(struct physics_struct));
        this_cylinder_volume.p_physics->is_vacuum = 1; // Makes this volume a vacuum
        this_cylinder_volume.p_physics->number_of_processes = (int) 0;
        this_cylinder_volume.p_physics->my_a = 0; // Should not be used.
        this_cylinder_volume.geometry.is_exit_volume = 1;
        sprintf(this_cylinder_volume.p_physics->name,"Exit");
    } else {
        for (loop_index=0;loop_index<global_material_list.num_elements;loop_index++) {
          if (0 == strcmp(material_string,global_material_list.elements[loop_index].name)) {
            this_cylinder_volume.p_physics = global_material_list.elements[loop_index].physics;
            break;
          }
          if (loop_index == global_material_list.num_elements-1) {
            printf("\n");
            printf("ERROR: The material string \"%s\" in Union geometry \"%s\" did not match a specified material. \n",material_string,NAME_CURRENT_COMP);
            printf("       The materials available at this point (need to be defined before the geometry): \n");
            for (loop_index=0;loop_index<global_material_list.num_elements;loop_index++)
              printf("         %s\n",global_material_list.elements[loop_index].name);
            printf("\n");
            printf("       It is also possible to use one of the defualt materials avaiable: \n");
            printf("           Vacuum (for a Volume without scattering or absorption)\n");
            printf("           Exit (for a Volume where the ray exits the component if it enters)\n");
            printf("           Mask (for a Volume that masks existing volumes specified in the mask_string\n");
            exit(1);
          }
        }
    }
} else {
    // Automatic linking, simply using the last defined material.
    #ifndef MATERIAL_DETECTOR
        printf("Need to define a material before the geometry to use automatic linking %s.\n",NAME_CURRENT_COMP);
        exit(1);
    #endif
    this_cylinder_volume.p_physics = global_material_list.elements[global_material_list.num_elements-1].physics;
}

sprintf(this_cylinder_volume.name,NAME_CURRENT_COMP);
sprintf(this_cylinder_volume.geometry.shape,"cylinder");
this_cylinder_volume.geometry.priority_value = priority;
// Currently the coordinates will be in absolute space.
this_cylinder_volume.geometry.center = POS_A_CURRENT_COMP;

this_cylinder_volume.geometry.geometry_p_interact = p_interact;
this_cylinder_storage.cyl_radius = radius;
this_cylinder_storage.height = yheight;
this_cylinder_volume.geometry.visualization_on = visualize;
this_cylinder_volume.geometry.geometry_parameters.p_cylinder_storage = &this_cylinder_storage;
this_cylinder_volume.geometry.within_function = &r_within_cylinder;
this_cylinder_volume.geometry.intersect_function = &sample_cylinder_intersect;
this_cylinder_volume.geometry.mcdisplay_function = &mcdisplay_cylinder_function;
this_cylinder_volume.geometry.shell_points = &cylinder_shell_points;
this_cylinder_volume.geometry.initialize_from_main_function = &initialize_cylinder_geometry_from_main_component;
this_cylinder_volume.geometry.process_rot_allocated = 0;
this_cylinder_volume.geometry.copy_geometry_parameters = &allocate_cylinder_storage_copy;

rot_copy(this_cylinder_volume.geometry.rotation_matrix,ROT_A_CURRENT_COMP);
rot_transpose(ROT_A_CURRENT_COMP,this_cylinder_volume.geometry.transpose_rotation_matrix);

// Initialize loggers
this_cylinder_volume.loggers.num_elements = 0;

// packing the information into the global_geometry_element, which is then included in the global_geometry_list.
sprintf(global_geometry_element.name,NAME_CURRENT_COMP);
global_geometry_element.activation_counter = number_of_activations;
global_geometry_element.component_index = INDEX_CURRENT_COMP;
global_geometry_element.Volume = &this_cylinder_volume; // Would be nicer if this m was a pointer, now we have the (small) data two places
add_element_to_geometry_list(&global_geometry_list,global_geometry_element);
}
#line 157307 "MACS_sample_kidney_box.c"
#undef number_of_activations
#undef mask_setting
#undef mask_string
#undef p_interact
#undef focus_r
#undef focus_xh
#undef focus_xw
#undef focus_ah
#undef focus_aw
#undef target_z
#undef target_y
#undef target_x
#undef target_index
#undef visualize
#undef yheight
#undef radius
#undef priority
#undef material_string
#undef this_cylinder_storage
#undef global_geometry_element
#undef this_cylinder_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

  /* Initializations for component sample_stick_walls. */
  SIG_MESSAGE("sample_stick_walls (Init)");
#define mccompcurname  sample_stick_walls
#define mccompcurtype  Union_cylinder
#define mccompcurindex 32
#define loop_index mccsample_stick_walls_loop_index
#define this_cylinder_volume mccsample_stick_walls_this_cylinder_volume
#define global_geometry_element mccsample_stick_walls_global_geometry_element
#define this_cylinder_storage mccsample_stick_walls_this_cylinder_storage
#define material_string mccsample_stick_walls_material_string
#define priority mccsample_stick_walls_priority
#define radius mccsample_stick_walls_radius
#define yheight mccsample_stick_walls_yheight
#define visualize mccsample_stick_walls_visualize
#define target_index mccsample_stick_walls_target_index
#define target_x mccsample_stick_walls_target_x
#define target_y mccsample_stick_walls_target_y
#define target_z mccsample_stick_walls_target_z
#define focus_aw mccsample_stick_walls_focus_aw
#define focus_ah mccsample_stick_walls_focus_ah
#define focus_xw mccsample_stick_walls_focus_xw
#define focus_xh mccsample_stick_walls_focus_xh
#define focus_r mccsample_stick_walls_focus_r
#define p_interact mccsample_stick_walls_p_interact
#define mask_string mccsample_stick_walls_mask_string
#define mask_setting mccsample_stick_walls_mask_setting
#define number_of_activations mccsample_stick_walls_number_of_activations
#line 185 "Union_cylinder.comp"
{
// Initializes the focusing system for this volume including input sanitation.
focus_initialize(&this_cylinder_volume.geometry, POS_A_COMP_INDEX(INDEX_CURRENT_COMP+target_index), POS_A_CURRENT_COMP, ROT_A_CURRENT_COMP, target_index, target_x, target_y, target_z, focus_aw, focus_ah, focus_xw, focus_xh, focus_r, NAME_CURRENT_COMP);

// Input sanitation for this geometry
if (radius <= 0) {
  printf("\nERROR in Union_cylinder named %s, the radius is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}

if (yheight <= 0) {
  printf("\nERROR in Union_cylinder named %s, yheight is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}

// Use sanitation
#ifdef MATERIAL_DETECTOR
if (global_material_list.num_elements == 0) {
  // Here if the user have defined a material, but only after this material
  printf("\nERROR: Need to define a material using Union_make_material before using a Union geometry component. \n");
  printf("       %s was defined before first use of Union_make_material.\n",NAME_CURRENT_COMP);
  exit(1);
}
#endif
#ifndef MATERIAL_DETECTOR
  printf("\nERROR: Need to define a material using Union_make_material before using a Union geometry component. \n");
  exit(1);
#endif


this_cylinder_volume.geometry.is_masked_volume = 0;
this_cylinder_volume.geometry.is_exit_volume = 0;
this_cylinder_volume.geometry.is_mask_volume = 0;

// Read the material input, or if it lacks, use automatic linking.
if (mask_string && strlen(mask_string) && strcmp(mask_string, "NULL") && strcmp(mask_string, "0")) {
    // A mask volume is used to limit the extend of other volumes, called the masked volumes. These are specified in the mask_string.
    // In order for a ray to enter a masked volume, it needs to be both in the region covered by that volume AND the mask volume.
    // When more than
    this_cylinder_volume.geometry.mask_mode = 1; // Default is mask mode is ALL
    if (mask_setting && strlen(mask_setting) && strcmp(mask_setting, "NULL") && strcmp(mask_setting, "0")) {
        if (strcmp(mask_setting,"ALL") == 0 || strcmp(mask_setting,"All") == 0) this_cylinder_volume.geometry.mask_mode = 1;
        else if (strcmp(mask_setting,"ANY") == 0 || strcmp(mask_setting,"Any") == 0) this_cylinder_volume.geometry.mask_mode = 2;
        else {
            printf("The mask_mode of component %s is set to %s, but must be either ALL or ANY.\n",NAME_CURRENT_COMP,mask_setting);
            exit(1);
        }
    }
    
    for (loop_index=0;loop_index<global_geometry_list.num_elements;loop_index++) {
        // Add mask list
        if (1 == manual_linking_function(global_geometry_list.elements[loop_index].name,mask_string)) {
            add_element_to_int_list(&this_cylinder_volume.geometry.mask_list,global_geometry_list.elements[loop_index].component_index);
            add_element_to_int_list(&global_geometry_list.elements[loop_index].Volume->geometry.masked_by_list,INDEX_CURRENT_COMP);
            global_geometry_list.elements[loop_index].Volume->geometry.is_masked_volume = 1;
            if (this_cylinder_volume.geometry.mask_mode == 2)
                global_geometry_list.elements[loop_index].Volume->geometry.mask_mode = 2;
            if (this_cylinder_volume.geometry.mask_mode == 1) {
                if (global_geometry_list.elements[loop_index].Volume->geometry.is_masked_volume == 1 && global_geometry_list.elements[loop_index].Volume->geometry.mask_mode != 2)
                    // If more than one mask is added to one volume, the ANY mode overwrites the (default) ALL mode.
                    global_geometry_list.elements[loop_index].Volume->geometry.mask_mode = 1;
            }
            
            found_geometries = 1;
        }
    }
    if (found_geometries == 0) {
        printf("The mask_string in geometry: %s did not find any of the specified volumes in the mask_string %s \n",NAME_CURRENT_COMP,mask_string);
        exit(1);
    }
    this_cylinder_volume.p_physics = malloc(sizeof(struct physics_struct));
    this_cylinder_volume.p_physics->is_vacuum = 0; // Makes this volume a vacuum
    this_cylinder_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
    this_cylinder_volume.p_physics->my_a = 0; // Should not be used.
    sprintf(this_cylinder_volume.p_physics->name,"Mask");
    this_cylinder_volume.geometry.is_mask_volume = 1;
    
    
// Read the material input, or if it lacks, use automatic linking.
} else if (material_string && strlen(material_string) && strcmp(material_string, "NULL") && strcmp(material_string, "0")) {
    // A geometry string was given, use it to determine which material
    if (0 == strcmp(material_string,"vacuum") || 0 == strcmp(material_string,"Vacuum")) {
        // One could have a global physics struct for vacuum instead of creating one for each
        this_cylinder_volume.p_physics = malloc(sizeof(struct physics_struct));
        this_cylinder_volume.p_physics->is_vacuum = 1; // Makes this volume a vacuum
        this_cylinder_volume.p_physics->number_of_processes = (int) 0;
        this_cylinder_volume.p_physics->my_a = 0; // Should not be used.
        sprintf(this_cylinder_volume.p_physics->name,"Vacuum");
    } else if (0 == strcmp(material_string,"exit") || 0 == strcmp(material_string,"Exit")) {
        // One could have a global physics struct for exit instead of creating one for each
        this_cylinder_volume.p_physics = malloc(sizeof(struct physics_struct));
        this_cylinder_volume.p_physics->is_vacuum = 1; // Makes this volume a vacuum
        this_cylinder_volume.p_physics->number_of_processes = (int) 0;
        this_cylinder_volume.p_physics->my_a = 0; // Should not be used.
        this_cylinder_volume.geometry.is_exit_volume = 1;
        sprintf(this_cylinder_volume.p_physics->name,"Exit");
    } else {
        for (loop_index=0;loop_index<global_material_list.num_elements;loop_index++) {
          if (0 == strcmp(material_string,global_material_list.elements[loop_index].name)) {
            this_cylinder_volume.p_physics = global_material_list.elements[loop_index].physics;
            break;
          }
          if (loop_index == global_material_list.num_elements-1) {
            printf("\n");
            printf("ERROR: The material string \"%s\" in Union geometry \"%s\" did not match a specified material. \n",material_string,NAME_CURRENT_COMP);
            printf("       The materials available at this point (need to be defined before the geometry): \n");
            for (loop_index=0;loop_index<global_material_list.num_elements;loop_index++)
              printf("         %s\n",global_material_list.elements[loop_index].name);
            printf("\n");
            printf("       It is also possible to use one of the defualt materials avaiable: \n");
            printf("           Vacuum (for a Volume without scattering or absorption)\n");
            printf("           Exit (for a Volume where the ray exits the component if it enters)\n");
            printf("           Mask (for a Volume that masks existing volumes specified in the mask_string\n");
            exit(1);
          }
        }
    }
} else {
    // Automatic linking, simply using the last defined material.
    #ifndef MATERIAL_DETECTOR
        printf("Need to define a material before the geometry to use automatic linking %s.\n",NAME_CURRENT_COMP);
        exit(1);
    #endif
    this_cylinder_volume.p_physics = global_material_list.elements[global_material_list.num_elements-1].physics;
}

sprintf(this_cylinder_volume.name,NAME_CURRENT_COMP);
sprintf(this_cylinder_volume.geometry.shape,"cylinder");
this_cylinder_volume.geometry.priority_value = priority;
// Currently the coordinates will be in absolute space.
this_cylinder_volume.geometry.center = POS_A_CURRENT_COMP;

this_cylinder_volume.geometry.geometry_p_interact = p_interact;
this_cylinder_storage.cyl_radius = radius;
this_cylinder_storage.height = yheight;
this_cylinder_volume.geometry.visualization_on = visualize;
this_cylinder_volume.geometry.geometry_parameters.p_cylinder_storage = &this_cylinder_storage;
this_cylinder_volume.geometry.within_function = &r_within_cylinder;
this_cylinder_volume.geometry.intersect_function = &sample_cylinder_intersect;
this_cylinder_volume.geometry.mcdisplay_function = &mcdisplay_cylinder_function;
this_cylinder_volume.geometry.shell_points = &cylinder_shell_points;
this_cylinder_volume.geometry.initialize_from_main_function = &initialize_cylinder_geometry_from_main_component;
this_cylinder_volume.geometry.process_rot_allocated = 0;
this_cylinder_volume.geometry.copy_geometry_parameters = &allocate_cylinder_storage_copy;

rot_copy(this_cylinder_volume.geometry.rotation_matrix,ROT_A_CURRENT_COMP);
rot_transpose(ROT_A_CURRENT_COMP,this_cylinder_volume.geometry.transpose_rotation_matrix);

// Initialize loggers
this_cylinder_volume.loggers.num_elements = 0;

// packing the information into the global_geometry_element, which is then included in the global_geometry_list.
sprintf(global_geometry_element.name,NAME_CURRENT_COMP);
global_geometry_element.activation_counter = number_of_activations;
global_geometry_element.component_index = INDEX_CURRENT_COMP;
global_geometry_element.Volume = &this_cylinder_volume; // Would be nicer if this m was a pointer, now we have the (small) data two places
add_element_to_geometry_list(&global_geometry_list,global_geometry_element);
}
#line 157520 "MACS_sample_kidney_box.c"
#undef number_of_activations
#undef mask_setting
#undef mask_string
#undef p_interact
#undef focus_r
#undef focus_xh
#undef focus_xw
#undef focus_ah
#undef focus_aw
#undef target_z
#undef target_y
#undef target_x
#undef target_index
#undef visualize
#undef yheight
#undef radius
#undef priority
#undef material_string
#undef this_cylinder_storage
#undef global_geometry_element
#undef this_cylinder_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

  /* Initializations for component sample_stick_vacuum. */
  SIG_MESSAGE("sample_stick_vacuum (Init)");
#define mccompcurname  sample_stick_vacuum
#define mccompcurtype  Union_cylinder
#define mccompcurindex 33
#define loop_index mccsample_stick_vacuum_loop_index
#define this_cylinder_volume mccsample_stick_vacuum_this_cylinder_volume
#define global_geometry_element mccsample_stick_vacuum_global_geometry_element
#define this_cylinder_storage mccsample_stick_vacuum_this_cylinder_storage
#define material_string mccsample_stick_vacuum_material_string
#define priority mccsample_stick_vacuum_priority
#define radius mccsample_stick_vacuum_radius
#define yheight mccsample_stick_vacuum_yheight
#define visualize mccsample_stick_vacuum_visualize
#define target_index mccsample_stick_vacuum_target_index
#define target_x mccsample_stick_vacuum_target_x
#define target_y mccsample_stick_vacuum_target_y
#define target_z mccsample_stick_vacuum_target_z
#define focus_aw mccsample_stick_vacuum_focus_aw
#define focus_ah mccsample_stick_vacuum_focus_ah
#define focus_xw mccsample_stick_vacuum_focus_xw
#define focus_xh mccsample_stick_vacuum_focus_xh
#define focus_r mccsample_stick_vacuum_focus_r
#define p_interact mccsample_stick_vacuum_p_interact
#define mask_string mccsample_stick_vacuum_mask_string
#define mask_setting mccsample_stick_vacuum_mask_setting
#define number_of_activations mccsample_stick_vacuum_number_of_activations
#line 185 "Union_cylinder.comp"
{
// Initializes the focusing system for this volume including input sanitation.
focus_initialize(&this_cylinder_volume.geometry, POS_A_COMP_INDEX(INDEX_CURRENT_COMP+target_index), POS_A_CURRENT_COMP, ROT_A_CURRENT_COMP, target_index, target_x, target_y, target_z, focus_aw, focus_ah, focus_xw, focus_xh, focus_r, NAME_CURRENT_COMP);

// Input sanitation for this geometry
if (radius <= 0) {
  printf("\nERROR in Union_cylinder named %s, the radius is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}

if (yheight <= 0) {
  printf("\nERROR in Union_cylinder named %s, yheight is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}

// Use sanitation
#ifdef MATERIAL_DETECTOR
if (global_material_list.num_elements == 0) {
  // Here if the user have defined a material, but only after this material
  printf("\nERROR: Need to define a material using Union_make_material before using a Union geometry component. \n");
  printf("       %s was defined before first use of Union_make_material.\n",NAME_CURRENT_COMP);
  exit(1);
}
#endif
#ifndef MATERIAL_DETECTOR
  printf("\nERROR: Need to define a material using Union_make_material before using a Union geometry component. \n");
  exit(1);
#endif


this_cylinder_volume.geometry.is_masked_volume = 0;
this_cylinder_volume.geometry.is_exit_volume = 0;
this_cylinder_volume.geometry.is_mask_volume = 0;

// Read the material input, or if it lacks, use automatic linking.
if (mask_string && strlen(mask_string) && strcmp(mask_string, "NULL") && strcmp(mask_string, "0")) {
    // A mask volume is used to limit the extend of other volumes, called the masked volumes. These are specified in the mask_string.
    // In order for a ray to enter a masked volume, it needs to be both in the region covered by that volume AND the mask volume.
    // When more than
    this_cylinder_volume.geometry.mask_mode = 1; // Default is mask mode is ALL
    if (mask_setting && strlen(mask_setting) && strcmp(mask_setting, "NULL") && strcmp(mask_setting, "0")) {
        if (strcmp(mask_setting,"ALL") == 0 || strcmp(mask_setting,"All") == 0) this_cylinder_volume.geometry.mask_mode = 1;
        else if (strcmp(mask_setting,"ANY") == 0 || strcmp(mask_setting,"Any") == 0) this_cylinder_volume.geometry.mask_mode = 2;
        else {
            printf("The mask_mode of component %s is set to %s, but must be either ALL or ANY.\n",NAME_CURRENT_COMP,mask_setting);
            exit(1);
        }
    }
    
    for (loop_index=0;loop_index<global_geometry_list.num_elements;loop_index++) {
        // Add mask list
        if (1 == manual_linking_function(global_geometry_list.elements[loop_index].name,mask_string)) {
            add_element_to_int_list(&this_cylinder_volume.geometry.mask_list,global_geometry_list.elements[loop_index].component_index);
            add_element_to_int_list(&global_geometry_list.elements[loop_index].Volume->geometry.masked_by_list,INDEX_CURRENT_COMP);
            global_geometry_list.elements[loop_index].Volume->geometry.is_masked_volume = 1;
            if (this_cylinder_volume.geometry.mask_mode == 2)
                global_geometry_list.elements[loop_index].Volume->geometry.mask_mode = 2;
            if (this_cylinder_volume.geometry.mask_mode == 1) {
                if (global_geometry_list.elements[loop_index].Volume->geometry.is_masked_volume == 1 && global_geometry_list.elements[loop_index].Volume->geometry.mask_mode != 2)
                    // If more than one mask is added to one volume, the ANY mode overwrites the (default) ALL mode.
                    global_geometry_list.elements[loop_index].Volume->geometry.mask_mode = 1;
            }
            
            found_geometries = 1;
        }
    }
    if (found_geometries == 0) {
        printf("The mask_string in geometry: %s did not find any of the specified volumes in the mask_string %s \n",NAME_CURRENT_COMP,mask_string);
        exit(1);
    }
    this_cylinder_volume.p_physics = malloc(sizeof(struct physics_struct));
    this_cylinder_volume.p_physics->is_vacuum = 0; // Makes this volume a vacuum
    this_cylinder_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
    this_cylinder_volume.p_physics->my_a = 0; // Should not be used.
    sprintf(this_cylinder_volume.p_physics->name,"Mask");
    this_cylinder_volume.geometry.is_mask_volume = 1;
    
    
// Read the material input, or if it lacks, use automatic linking.
} else if (material_string && strlen(material_string) && strcmp(material_string, "NULL") && strcmp(material_string, "0")) {
    // A geometry string was given, use it to determine which material
    if (0 == strcmp(material_string,"vacuum") || 0 == strcmp(material_string,"Vacuum")) {
        // One could have a global physics struct for vacuum instead of creating one for each
        this_cylinder_volume.p_physics = malloc(sizeof(struct physics_struct));
        this_cylinder_volume.p_physics->is_vacuum = 1; // Makes this volume a vacuum
        this_cylinder_volume.p_physics->number_of_processes = (int) 0;
        this_cylinder_volume.p_physics->my_a = 0; // Should not be used.
        sprintf(this_cylinder_volume.p_physics->name,"Vacuum");
    } else if (0 == strcmp(material_string,"exit") || 0 == strcmp(material_string,"Exit")) {
        // One could have a global physics struct for exit instead of creating one for each
        this_cylinder_volume.p_physics = malloc(sizeof(struct physics_struct));
        this_cylinder_volume.p_physics->is_vacuum = 1; // Makes this volume a vacuum
        this_cylinder_volume.p_physics->number_of_processes = (int) 0;
        this_cylinder_volume.p_physics->my_a = 0; // Should not be used.
        this_cylinder_volume.geometry.is_exit_volume = 1;
        sprintf(this_cylinder_volume.p_physics->name,"Exit");
    } else {
        for (loop_index=0;loop_index<global_material_list.num_elements;loop_index++) {
          if (0 == strcmp(material_string,global_material_list.elements[loop_index].name)) {
            this_cylinder_volume.p_physics = global_material_list.elements[loop_index].physics;
            break;
          }
          if (loop_index == global_material_list.num_elements-1) {
            printf("\n");
            printf("ERROR: The material string \"%s\" in Union geometry \"%s\" did not match a specified material. \n",material_string,NAME_CURRENT_COMP);
            printf("       The materials available at this point (need to be defined before the geometry): \n");
            for (loop_index=0;loop_index<global_material_list.num_elements;loop_index++)
              printf("         %s\n",global_material_list.elements[loop_index].name);
            printf("\n");
            printf("       It is also possible to use one of the defualt materials avaiable: \n");
            printf("           Vacuum (for a Volume without scattering or absorption)\n");
            printf("           Exit (for a Volume where the ray exits the component if it enters)\n");
            printf("           Mask (for a Volume that masks existing volumes specified in the mask_string\n");
            exit(1);
          }
        }
    }
} else {
    // Automatic linking, simply using the last defined material.
    #ifndef MATERIAL_DETECTOR
        printf("Need to define a material before the geometry to use automatic linking %s.\n",NAME_CURRENT_COMP);
        exit(1);
    #endif
    this_cylinder_volume.p_physics = global_material_list.elements[global_material_list.num_elements-1].physics;
}

sprintf(this_cylinder_volume.name,NAME_CURRENT_COMP);
sprintf(this_cylinder_volume.geometry.shape,"cylinder");
this_cylinder_volume.geometry.priority_value = priority;
// Currently the coordinates will be in absolute space.
this_cylinder_volume.geometry.center = POS_A_CURRENT_COMP;

this_cylinder_volume.geometry.geometry_p_interact = p_interact;
this_cylinder_storage.cyl_radius = radius;
this_cylinder_storage.height = yheight;
this_cylinder_volume.geometry.visualization_on = visualize;
this_cylinder_volume.geometry.geometry_parameters.p_cylinder_storage = &this_cylinder_storage;
this_cylinder_volume.geometry.within_function = &r_within_cylinder;
this_cylinder_volume.geometry.intersect_function = &sample_cylinder_intersect;
this_cylinder_volume.geometry.mcdisplay_function = &mcdisplay_cylinder_function;
this_cylinder_volume.geometry.shell_points = &cylinder_shell_points;
this_cylinder_volume.geometry.initialize_from_main_function = &initialize_cylinder_geometry_from_main_component;
this_cylinder_volume.geometry.process_rot_allocated = 0;
this_cylinder_volume.geometry.copy_geometry_parameters = &allocate_cylinder_storage_copy;

rot_copy(this_cylinder_volume.geometry.rotation_matrix,ROT_A_CURRENT_COMP);
rot_transpose(ROT_A_CURRENT_COMP,this_cylinder_volume.geometry.transpose_rotation_matrix);

// Initialize loggers
this_cylinder_volume.loggers.num_elements = 0;

// packing the information into the global_geometry_element, which is then included in the global_geometry_list.
sprintf(global_geometry_element.name,NAME_CURRENT_COMP);
global_geometry_element.activation_counter = number_of_activations;
global_geometry_element.component_index = INDEX_CURRENT_COMP;
global_geometry_element.Volume = &this_cylinder_volume; // Would be nicer if this m was a pointer, now we have the (small) data two places
add_element_to_geometry_list(&global_geometry_list,global_geometry_element);
}
#line 157733 "MACS_sample_kidney_box.c"
#undef number_of_activations
#undef mask_setting
#undef mask_string
#undef p_interact
#undef focus_r
#undef focus_xh
#undef focus_xw
#undef focus_ah
#undef focus_aw
#undef target_z
#undef target_y
#undef target_x
#undef target_index
#undef visualize
#undef yheight
#undef radius
#undef priority
#undef material_string
#undef this_cylinder_storage
#undef global_geometry_element
#undef this_cylinder_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

  /* Initializations for component sample_rod_bottom. */
  SIG_MESSAGE("sample_rod_bottom (Init)");

  /* Initializations for component sample_rod. */
  SIG_MESSAGE("sample_rod (Init)");
#define mccompcurname  sample_rod
#define mccompcurtype  Union_cylinder
#define mccompcurindex 35
#define loop_index mccsample_rod_loop_index
#define this_cylinder_volume mccsample_rod_this_cylinder_volume
#define global_geometry_element mccsample_rod_global_geometry_element
#define this_cylinder_storage mccsample_rod_this_cylinder_storage
#define material_string mccsample_rod_material_string
#define priority mccsample_rod_priority
#define radius mccsample_rod_radius
#define yheight mccsample_rod_yheight
#define visualize mccsample_rod_visualize
#define target_index mccsample_rod_target_index
#define target_x mccsample_rod_target_x
#define target_y mccsample_rod_target_y
#define target_z mccsample_rod_target_z
#define focus_aw mccsample_rod_focus_aw
#define focus_ah mccsample_rod_focus_ah
#define focus_xw mccsample_rod_focus_xw
#define focus_xh mccsample_rod_focus_xh
#define focus_r mccsample_rod_focus_r
#define p_interact mccsample_rod_p_interact
#define mask_string mccsample_rod_mask_string
#define mask_setting mccsample_rod_mask_setting
#define number_of_activations mccsample_rod_number_of_activations
#line 185 "Union_cylinder.comp"
{
// Initializes the focusing system for this volume including input sanitation.
focus_initialize(&this_cylinder_volume.geometry, POS_A_COMP_INDEX(INDEX_CURRENT_COMP+target_index), POS_A_CURRENT_COMP, ROT_A_CURRENT_COMP, target_index, target_x, target_y, target_z, focus_aw, focus_ah, focus_xw, focus_xh, focus_r, NAME_CURRENT_COMP);

// Input sanitation for this geometry
if (radius <= 0) {
  printf("\nERROR in Union_cylinder named %s, the radius is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}

if (yheight <= 0) {
  printf("\nERROR in Union_cylinder named %s, yheight is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}

// Use sanitation
#ifdef MATERIAL_DETECTOR
if (global_material_list.num_elements == 0) {
  // Here if the user have defined a material, but only after this material
  printf("\nERROR: Need to define a material using Union_make_material before using a Union geometry component. \n");
  printf("       %s was defined before first use of Union_make_material.\n",NAME_CURRENT_COMP);
  exit(1);
}
#endif
#ifndef MATERIAL_DETECTOR
  printf("\nERROR: Need to define a material using Union_make_material before using a Union geometry component. \n");
  exit(1);
#endif


this_cylinder_volume.geometry.is_masked_volume = 0;
this_cylinder_volume.geometry.is_exit_volume = 0;
this_cylinder_volume.geometry.is_mask_volume = 0;

// Read the material input, or if it lacks, use automatic linking.
if (mask_string && strlen(mask_string) && strcmp(mask_string, "NULL") && strcmp(mask_string, "0")) {
    // A mask volume is used to limit the extend of other volumes, called the masked volumes. These are specified in the mask_string.
    // In order for a ray to enter a masked volume, it needs to be both in the region covered by that volume AND the mask volume.
    // When more than
    this_cylinder_volume.geometry.mask_mode = 1; // Default is mask mode is ALL
    if (mask_setting && strlen(mask_setting) && strcmp(mask_setting, "NULL") && strcmp(mask_setting, "0")) {
        if (strcmp(mask_setting,"ALL") == 0 || strcmp(mask_setting,"All") == 0) this_cylinder_volume.geometry.mask_mode = 1;
        else if (strcmp(mask_setting,"ANY") == 0 || strcmp(mask_setting,"Any") == 0) this_cylinder_volume.geometry.mask_mode = 2;
        else {
            printf("The mask_mode of component %s is set to %s, but must be either ALL or ANY.\n",NAME_CURRENT_COMP,mask_setting);
            exit(1);
        }
    }
    
    for (loop_index=0;loop_index<global_geometry_list.num_elements;loop_index++) {
        // Add mask list
        if (1 == manual_linking_function(global_geometry_list.elements[loop_index].name,mask_string)) {
            add_element_to_int_list(&this_cylinder_volume.geometry.mask_list,global_geometry_list.elements[loop_index].component_index);
            add_element_to_int_list(&global_geometry_list.elements[loop_index].Volume->geometry.masked_by_list,INDEX_CURRENT_COMP);
            global_geometry_list.elements[loop_index].Volume->geometry.is_masked_volume = 1;
            if (this_cylinder_volume.geometry.mask_mode == 2)
                global_geometry_list.elements[loop_index].Volume->geometry.mask_mode = 2;
            if (this_cylinder_volume.geometry.mask_mode == 1) {
                if (global_geometry_list.elements[loop_index].Volume->geometry.is_masked_volume == 1 && global_geometry_list.elements[loop_index].Volume->geometry.mask_mode != 2)
                    // If more than one mask is added to one volume, the ANY mode overwrites the (default) ALL mode.
                    global_geometry_list.elements[loop_index].Volume->geometry.mask_mode = 1;
            }
            
            found_geometries = 1;
        }
    }
    if (found_geometries == 0) {
        printf("The mask_string in geometry: %s did not find any of the specified volumes in the mask_string %s \n",NAME_CURRENT_COMP,mask_string);
        exit(1);
    }
    this_cylinder_volume.p_physics = malloc(sizeof(struct physics_struct));
    this_cylinder_volume.p_physics->is_vacuum = 0; // Makes this volume a vacuum
    this_cylinder_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
    this_cylinder_volume.p_physics->my_a = 0; // Should not be used.
    sprintf(this_cylinder_volume.p_physics->name,"Mask");
    this_cylinder_volume.geometry.is_mask_volume = 1;
    
    
// Read the material input, or if it lacks, use automatic linking.
} else if (material_string && strlen(material_string) && strcmp(material_string, "NULL") && strcmp(material_string, "0")) {
    // A geometry string was given, use it to determine which material
    if (0 == strcmp(material_string,"vacuum") || 0 == strcmp(material_string,"Vacuum")) {
        // One could have a global physics struct for vacuum instead of creating one for each
        this_cylinder_volume.p_physics = malloc(sizeof(struct physics_struct));
        this_cylinder_volume.p_physics->is_vacuum = 1; // Makes this volume a vacuum
        this_cylinder_volume.p_physics->number_of_processes = (int) 0;
        this_cylinder_volume.p_physics->my_a = 0; // Should not be used.
        sprintf(this_cylinder_volume.p_physics->name,"Vacuum");
    } else if (0 == strcmp(material_string,"exit") || 0 == strcmp(material_string,"Exit")) {
        // One could have a global physics struct for exit instead of creating one for each
        this_cylinder_volume.p_physics = malloc(sizeof(struct physics_struct));
        this_cylinder_volume.p_physics->is_vacuum = 1; // Makes this volume a vacuum
        this_cylinder_volume.p_physics->number_of_processes = (int) 0;
        this_cylinder_volume.p_physics->my_a = 0; // Should not be used.
        this_cylinder_volume.geometry.is_exit_volume = 1;
        sprintf(this_cylinder_volume.p_physics->name,"Exit");
    } else {
        for (loop_index=0;loop_index<global_material_list.num_elements;loop_index++) {
          if (0 == strcmp(material_string,global_material_list.elements[loop_index].name)) {
            this_cylinder_volume.p_physics = global_material_list.elements[loop_index].physics;
            break;
          }
          if (loop_index == global_material_list.num_elements-1) {
            printf("\n");
            printf("ERROR: The material string \"%s\" in Union geometry \"%s\" did not match a specified material. \n",material_string,NAME_CURRENT_COMP);
            printf("       The materials available at this point (need to be defined before the geometry): \n");
            for (loop_index=0;loop_index<global_material_list.num_elements;loop_index++)
              printf("         %s\n",global_material_list.elements[loop_index].name);
            printf("\n");
            printf("       It is also possible to use one of the defualt materials avaiable: \n");
            printf("           Vacuum (for a Volume without scattering or absorption)\n");
            printf("           Exit (for a Volume where the ray exits the component if it enters)\n");
            printf("           Mask (for a Volume that masks existing volumes specified in the mask_string\n");
            exit(1);
          }
        }
    }
} else {
    // Automatic linking, simply using the last defined material.
    #ifndef MATERIAL_DETECTOR
        printf("Need to define a material before the geometry to use automatic linking %s.\n",NAME_CURRENT_COMP);
        exit(1);
    #endif
    this_cylinder_volume.p_physics = global_material_list.elements[global_material_list.num_elements-1].physics;
}

sprintf(this_cylinder_volume.name,NAME_CURRENT_COMP);
sprintf(this_cylinder_volume.geometry.shape,"cylinder");
this_cylinder_volume.geometry.priority_value = priority;
// Currently the coordinates will be in absolute space.
this_cylinder_volume.geometry.center = POS_A_CURRENT_COMP;

this_cylinder_volume.geometry.geometry_p_interact = p_interact;
this_cylinder_storage.cyl_radius = radius;
this_cylinder_storage.height = yheight;
this_cylinder_volume.geometry.visualization_on = visualize;
this_cylinder_volume.geometry.geometry_parameters.p_cylinder_storage = &this_cylinder_storage;
this_cylinder_volume.geometry.within_function = &r_within_cylinder;
this_cylinder_volume.geometry.intersect_function = &sample_cylinder_intersect;
this_cylinder_volume.geometry.mcdisplay_function = &mcdisplay_cylinder_function;
this_cylinder_volume.geometry.shell_points = &cylinder_shell_points;
this_cylinder_volume.geometry.initialize_from_main_function = &initialize_cylinder_geometry_from_main_component;
this_cylinder_volume.geometry.process_rot_allocated = 0;
this_cylinder_volume.geometry.copy_geometry_parameters = &allocate_cylinder_storage_copy;

rot_copy(this_cylinder_volume.geometry.rotation_matrix,ROT_A_CURRENT_COMP);
rot_transpose(ROT_A_CURRENT_COMP,this_cylinder_volume.geometry.transpose_rotation_matrix);

// Initialize loggers
this_cylinder_volume.loggers.num_elements = 0;

// packing the information into the global_geometry_element, which is then included in the global_geometry_list.
sprintf(global_geometry_element.name,NAME_CURRENT_COMP);
global_geometry_element.activation_counter = number_of_activations;
global_geometry_element.component_index = INDEX_CURRENT_COMP;
global_geometry_element.Volume = &this_cylinder_volume; // Would be nicer if this m was a pointer, now we have the (small) data two places
add_element_to_geometry_list(&global_geometry_list,global_geometry_element);
}
#line 157949 "MACS_sample_kidney_box.c"
#undef number_of_activations
#undef mask_setting
#undef mask_string
#undef p_interact
#undef focus_r
#undef focus_xh
#undef focus_xw
#undef focus_ah
#undef focus_aw
#undef target_z
#undef target_y
#undef target_x
#undef target_index
#undef visualize
#undef yheight
#undef radius
#undef priority
#undef material_string
#undef this_cylinder_storage
#undef global_geometry_element
#undef this_cylinder_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

  /* Initializations for component sample_rod_collar_1. */
  SIG_MESSAGE("sample_rod_collar_1 (Init)");
#define mccompcurname  sample_rod_collar_1
#define mccompcurtype  Union_cylinder
#define mccompcurindex 36
#define loop_index mccsample_rod_collar_1_loop_index
#define this_cylinder_volume mccsample_rod_collar_1_this_cylinder_volume
#define global_geometry_element mccsample_rod_collar_1_global_geometry_element
#define this_cylinder_storage mccsample_rod_collar_1_this_cylinder_storage
#define material_string mccsample_rod_collar_1_material_string
#define priority mccsample_rod_collar_1_priority
#define radius mccsample_rod_collar_1_radius
#define yheight mccsample_rod_collar_1_yheight
#define visualize mccsample_rod_collar_1_visualize
#define target_index mccsample_rod_collar_1_target_index
#define target_x mccsample_rod_collar_1_target_x
#define target_y mccsample_rod_collar_1_target_y
#define target_z mccsample_rod_collar_1_target_z
#define focus_aw mccsample_rod_collar_1_focus_aw
#define focus_ah mccsample_rod_collar_1_focus_ah
#define focus_xw mccsample_rod_collar_1_focus_xw
#define focus_xh mccsample_rod_collar_1_focus_xh
#define focus_r mccsample_rod_collar_1_focus_r
#define p_interact mccsample_rod_collar_1_p_interact
#define mask_string mccsample_rod_collar_1_mask_string
#define mask_setting mccsample_rod_collar_1_mask_setting
#define number_of_activations mccsample_rod_collar_1_number_of_activations
#line 185 "Union_cylinder.comp"
{
// Initializes the focusing system for this volume including input sanitation.
focus_initialize(&this_cylinder_volume.geometry, POS_A_COMP_INDEX(INDEX_CURRENT_COMP+target_index), POS_A_CURRENT_COMP, ROT_A_CURRENT_COMP, target_index, target_x, target_y, target_z, focus_aw, focus_ah, focus_xw, focus_xh, focus_r, NAME_CURRENT_COMP);

// Input sanitation for this geometry
if (radius <= 0) {
  printf("\nERROR in Union_cylinder named %s, the radius is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}

if (yheight <= 0) {
  printf("\nERROR in Union_cylinder named %s, yheight is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}

// Use sanitation
#ifdef MATERIAL_DETECTOR
if (global_material_list.num_elements == 0) {
  // Here if the user have defined a material, but only after this material
  printf("\nERROR: Need to define a material using Union_make_material before using a Union geometry component. \n");
  printf("       %s was defined before first use of Union_make_material.\n",NAME_CURRENT_COMP);
  exit(1);
}
#endif
#ifndef MATERIAL_DETECTOR
  printf("\nERROR: Need to define a material using Union_make_material before using a Union geometry component. \n");
  exit(1);
#endif


this_cylinder_volume.geometry.is_masked_volume = 0;
this_cylinder_volume.geometry.is_exit_volume = 0;
this_cylinder_volume.geometry.is_mask_volume = 0;

// Read the material input, or if it lacks, use automatic linking.
if (mask_string && strlen(mask_string) && strcmp(mask_string, "NULL") && strcmp(mask_string, "0")) {
    // A mask volume is used to limit the extend of other volumes, called the masked volumes. These are specified in the mask_string.
    // In order for a ray to enter a masked volume, it needs to be both in the region covered by that volume AND the mask volume.
    // When more than
    this_cylinder_volume.geometry.mask_mode = 1; // Default is mask mode is ALL
    if (mask_setting && strlen(mask_setting) && strcmp(mask_setting, "NULL") && strcmp(mask_setting, "0")) {
        if (strcmp(mask_setting,"ALL") == 0 || strcmp(mask_setting,"All") == 0) this_cylinder_volume.geometry.mask_mode = 1;
        else if (strcmp(mask_setting,"ANY") == 0 || strcmp(mask_setting,"Any") == 0) this_cylinder_volume.geometry.mask_mode = 2;
        else {
            printf("The mask_mode of component %s is set to %s, but must be either ALL or ANY.\n",NAME_CURRENT_COMP,mask_setting);
            exit(1);
        }
    }
    
    for (loop_index=0;loop_index<global_geometry_list.num_elements;loop_index++) {
        // Add mask list
        if (1 == manual_linking_function(global_geometry_list.elements[loop_index].name,mask_string)) {
            add_element_to_int_list(&this_cylinder_volume.geometry.mask_list,global_geometry_list.elements[loop_index].component_index);
            add_element_to_int_list(&global_geometry_list.elements[loop_index].Volume->geometry.masked_by_list,INDEX_CURRENT_COMP);
            global_geometry_list.elements[loop_index].Volume->geometry.is_masked_volume = 1;
            if (this_cylinder_volume.geometry.mask_mode == 2)
                global_geometry_list.elements[loop_index].Volume->geometry.mask_mode = 2;
            if (this_cylinder_volume.geometry.mask_mode == 1) {
                if (global_geometry_list.elements[loop_index].Volume->geometry.is_masked_volume == 1 && global_geometry_list.elements[loop_index].Volume->geometry.mask_mode != 2)
                    // If more than one mask is added to one volume, the ANY mode overwrites the (default) ALL mode.
                    global_geometry_list.elements[loop_index].Volume->geometry.mask_mode = 1;
            }
            
            found_geometries = 1;
        }
    }
    if (found_geometries == 0) {
        printf("The mask_string in geometry: %s did not find any of the specified volumes in the mask_string %s \n",NAME_CURRENT_COMP,mask_string);
        exit(1);
    }
    this_cylinder_volume.p_physics = malloc(sizeof(struct physics_struct));
    this_cylinder_volume.p_physics->is_vacuum = 0; // Makes this volume a vacuum
    this_cylinder_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
    this_cylinder_volume.p_physics->my_a = 0; // Should not be used.
    sprintf(this_cylinder_volume.p_physics->name,"Mask");
    this_cylinder_volume.geometry.is_mask_volume = 1;
    
    
// Read the material input, or if it lacks, use automatic linking.
} else if (material_string && strlen(material_string) && strcmp(material_string, "NULL") && strcmp(material_string, "0")) {
    // A geometry string was given, use it to determine which material
    if (0 == strcmp(material_string,"vacuum") || 0 == strcmp(material_string,"Vacuum")) {
        // One could have a global physics struct for vacuum instead of creating one for each
        this_cylinder_volume.p_physics = malloc(sizeof(struct physics_struct));
        this_cylinder_volume.p_physics->is_vacuum = 1; // Makes this volume a vacuum
        this_cylinder_volume.p_physics->number_of_processes = (int) 0;
        this_cylinder_volume.p_physics->my_a = 0; // Should not be used.
        sprintf(this_cylinder_volume.p_physics->name,"Vacuum");
    } else if (0 == strcmp(material_string,"exit") || 0 == strcmp(material_string,"Exit")) {
        // One could have a global physics struct for exit instead of creating one for each
        this_cylinder_volume.p_physics = malloc(sizeof(struct physics_struct));
        this_cylinder_volume.p_physics->is_vacuum = 1; // Makes this volume a vacuum
        this_cylinder_volume.p_physics->number_of_processes = (int) 0;
        this_cylinder_volume.p_physics->my_a = 0; // Should not be used.
        this_cylinder_volume.geometry.is_exit_volume = 1;
        sprintf(this_cylinder_volume.p_physics->name,"Exit");
    } else {
        for (loop_index=0;loop_index<global_material_list.num_elements;loop_index++) {
          if (0 == strcmp(material_string,global_material_list.elements[loop_index].name)) {
            this_cylinder_volume.p_physics = global_material_list.elements[loop_index].physics;
            break;
          }
          if (loop_index == global_material_list.num_elements-1) {
            printf("\n");
            printf("ERROR: The material string \"%s\" in Union geometry \"%s\" did not match a specified material. \n",material_string,NAME_CURRENT_COMP);
            printf("       The materials available at this point (need to be defined before the geometry): \n");
            for (loop_index=0;loop_index<global_material_list.num_elements;loop_index++)
              printf("         %s\n",global_material_list.elements[loop_index].name);
            printf("\n");
            printf("       It is also possible to use one of the defualt materials avaiable: \n");
            printf("           Vacuum (for a Volume without scattering or absorption)\n");
            printf("           Exit (for a Volume where the ray exits the component if it enters)\n");
            printf("           Mask (for a Volume that masks existing volumes specified in the mask_string\n");
            exit(1);
          }
        }
    }
} else {
    // Automatic linking, simply using the last defined material.
    #ifndef MATERIAL_DETECTOR
        printf("Need to define a material before the geometry to use automatic linking %s.\n",NAME_CURRENT_COMP);
        exit(1);
    #endif
    this_cylinder_volume.p_physics = global_material_list.elements[global_material_list.num_elements-1].physics;
}

sprintf(this_cylinder_volume.name,NAME_CURRENT_COMP);
sprintf(this_cylinder_volume.geometry.shape,"cylinder");
this_cylinder_volume.geometry.priority_value = priority;
// Currently the coordinates will be in absolute space.
this_cylinder_volume.geometry.center = POS_A_CURRENT_COMP;

this_cylinder_volume.geometry.geometry_p_interact = p_interact;
this_cylinder_storage.cyl_radius = radius;
this_cylinder_storage.height = yheight;
this_cylinder_volume.geometry.visualization_on = visualize;
this_cylinder_volume.geometry.geometry_parameters.p_cylinder_storage = &this_cylinder_storage;
this_cylinder_volume.geometry.within_function = &r_within_cylinder;
this_cylinder_volume.geometry.intersect_function = &sample_cylinder_intersect;
this_cylinder_volume.geometry.mcdisplay_function = &mcdisplay_cylinder_function;
this_cylinder_volume.geometry.shell_points = &cylinder_shell_points;
this_cylinder_volume.geometry.initialize_from_main_function = &initialize_cylinder_geometry_from_main_component;
this_cylinder_volume.geometry.process_rot_allocated = 0;
this_cylinder_volume.geometry.copy_geometry_parameters = &allocate_cylinder_storage_copy;

rot_copy(this_cylinder_volume.geometry.rotation_matrix,ROT_A_CURRENT_COMP);
rot_transpose(ROT_A_CURRENT_COMP,this_cylinder_volume.geometry.transpose_rotation_matrix);

// Initialize loggers
this_cylinder_volume.loggers.num_elements = 0;

// packing the information into the global_geometry_element, which is then included in the global_geometry_list.
sprintf(global_geometry_element.name,NAME_CURRENT_COMP);
global_geometry_element.activation_counter = number_of_activations;
global_geometry_element.component_index = INDEX_CURRENT_COMP;
global_geometry_element.Volume = &this_cylinder_volume; // Would be nicer if this m was a pointer, now we have the (small) data two places
add_element_to_geometry_list(&global_geometry_list,global_geometry_element);
}
#line 158162 "MACS_sample_kidney_box.c"
#undef number_of_activations
#undef mask_setting
#undef mask_string
#undef p_interact
#undef focus_r
#undef focus_xh
#undef focus_xw
#undef focus_ah
#undef focus_aw
#undef target_z
#undef target_y
#undef target_x
#undef target_index
#undef visualize
#undef yheight
#undef radius
#undef priority
#undef material_string
#undef this_cylinder_storage
#undef global_geometry_element
#undef this_cylinder_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

  /* Initializations for component sample_rod_collar_2. */
  SIG_MESSAGE("sample_rod_collar_2 (Init)");
#define mccompcurname  sample_rod_collar_2
#define mccompcurtype  Union_cylinder
#define mccompcurindex 37
#define loop_index mccsample_rod_collar_2_loop_index
#define this_cylinder_volume mccsample_rod_collar_2_this_cylinder_volume
#define global_geometry_element mccsample_rod_collar_2_global_geometry_element
#define this_cylinder_storage mccsample_rod_collar_2_this_cylinder_storage
#define material_string mccsample_rod_collar_2_material_string
#define priority mccsample_rod_collar_2_priority
#define radius mccsample_rod_collar_2_radius
#define yheight mccsample_rod_collar_2_yheight
#define visualize mccsample_rod_collar_2_visualize
#define target_index mccsample_rod_collar_2_target_index
#define target_x mccsample_rod_collar_2_target_x
#define target_y mccsample_rod_collar_2_target_y
#define target_z mccsample_rod_collar_2_target_z
#define focus_aw mccsample_rod_collar_2_focus_aw
#define focus_ah mccsample_rod_collar_2_focus_ah
#define focus_xw mccsample_rod_collar_2_focus_xw
#define focus_xh mccsample_rod_collar_2_focus_xh
#define focus_r mccsample_rod_collar_2_focus_r
#define p_interact mccsample_rod_collar_2_p_interact
#define mask_string mccsample_rod_collar_2_mask_string
#define mask_setting mccsample_rod_collar_2_mask_setting
#define number_of_activations mccsample_rod_collar_2_number_of_activations
#line 185 "Union_cylinder.comp"
{
// Initializes the focusing system for this volume including input sanitation.
focus_initialize(&this_cylinder_volume.geometry, POS_A_COMP_INDEX(INDEX_CURRENT_COMP+target_index), POS_A_CURRENT_COMP, ROT_A_CURRENT_COMP, target_index, target_x, target_y, target_z, focus_aw, focus_ah, focus_xw, focus_xh, focus_r, NAME_CURRENT_COMP);

// Input sanitation for this geometry
if (radius <= 0) {
  printf("\nERROR in Union_cylinder named %s, the radius is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}

if (yheight <= 0) {
  printf("\nERROR in Union_cylinder named %s, yheight is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}

// Use sanitation
#ifdef MATERIAL_DETECTOR
if (global_material_list.num_elements == 0) {
  // Here if the user have defined a material, but only after this material
  printf("\nERROR: Need to define a material using Union_make_material before using a Union geometry component. \n");
  printf("       %s was defined before first use of Union_make_material.\n",NAME_CURRENT_COMP);
  exit(1);
}
#endif
#ifndef MATERIAL_DETECTOR
  printf("\nERROR: Need to define a material using Union_make_material before using a Union geometry component. \n");
  exit(1);
#endif


this_cylinder_volume.geometry.is_masked_volume = 0;
this_cylinder_volume.geometry.is_exit_volume = 0;
this_cylinder_volume.geometry.is_mask_volume = 0;

// Read the material input, or if it lacks, use automatic linking.
if (mask_string && strlen(mask_string) && strcmp(mask_string, "NULL") && strcmp(mask_string, "0")) {
    // A mask volume is used to limit the extend of other volumes, called the masked volumes. These are specified in the mask_string.
    // In order for a ray to enter a masked volume, it needs to be both in the region covered by that volume AND the mask volume.
    // When more than
    this_cylinder_volume.geometry.mask_mode = 1; // Default is mask mode is ALL
    if (mask_setting && strlen(mask_setting) && strcmp(mask_setting, "NULL") && strcmp(mask_setting, "0")) {
        if (strcmp(mask_setting,"ALL") == 0 || strcmp(mask_setting,"All") == 0) this_cylinder_volume.geometry.mask_mode = 1;
        else if (strcmp(mask_setting,"ANY") == 0 || strcmp(mask_setting,"Any") == 0) this_cylinder_volume.geometry.mask_mode = 2;
        else {
            printf("The mask_mode of component %s is set to %s, but must be either ALL or ANY.\n",NAME_CURRENT_COMP,mask_setting);
            exit(1);
        }
    }
    
    for (loop_index=0;loop_index<global_geometry_list.num_elements;loop_index++) {
        // Add mask list
        if (1 == manual_linking_function(global_geometry_list.elements[loop_index].name,mask_string)) {
            add_element_to_int_list(&this_cylinder_volume.geometry.mask_list,global_geometry_list.elements[loop_index].component_index);
            add_element_to_int_list(&global_geometry_list.elements[loop_index].Volume->geometry.masked_by_list,INDEX_CURRENT_COMP);
            global_geometry_list.elements[loop_index].Volume->geometry.is_masked_volume = 1;
            if (this_cylinder_volume.geometry.mask_mode == 2)
                global_geometry_list.elements[loop_index].Volume->geometry.mask_mode = 2;
            if (this_cylinder_volume.geometry.mask_mode == 1) {
                if (global_geometry_list.elements[loop_index].Volume->geometry.is_masked_volume == 1 && global_geometry_list.elements[loop_index].Volume->geometry.mask_mode != 2)
                    // If more than one mask is added to one volume, the ANY mode overwrites the (default) ALL mode.
                    global_geometry_list.elements[loop_index].Volume->geometry.mask_mode = 1;
            }
            
            found_geometries = 1;
        }
    }
    if (found_geometries == 0) {
        printf("The mask_string in geometry: %s did not find any of the specified volumes in the mask_string %s \n",NAME_CURRENT_COMP,mask_string);
        exit(1);
    }
    this_cylinder_volume.p_physics = malloc(sizeof(struct physics_struct));
    this_cylinder_volume.p_physics->is_vacuum = 0; // Makes this volume a vacuum
    this_cylinder_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
    this_cylinder_volume.p_physics->my_a = 0; // Should not be used.
    sprintf(this_cylinder_volume.p_physics->name,"Mask");
    this_cylinder_volume.geometry.is_mask_volume = 1;
    
    
// Read the material input, or if it lacks, use automatic linking.
} else if (material_string && strlen(material_string) && strcmp(material_string, "NULL") && strcmp(material_string, "0")) {
    // A geometry string was given, use it to determine which material
    if (0 == strcmp(material_string,"vacuum") || 0 == strcmp(material_string,"Vacuum")) {
        // One could have a global physics struct for vacuum instead of creating one for each
        this_cylinder_volume.p_physics = malloc(sizeof(struct physics_struct));
        this_cylinder_volume.p_physics->is_vacuum = 1; // Makes this volume a vacuum
        this_cylinder_volume.p_physics->number_of_processes = (int) 0;
        this_cylinder_volume.p_physics->my_a = 0; // Should not be used.
        sprintf(this_cylinder_volume.p_physics->name,"Vacuum");
    } else if (0 == strcmp(material_string,"exit") || 0 == strcmp(material_string,"Exit")) {
        // One could have a global physics struct for exit instead of creating one for each
        this_cylinder_volume.p_physics = malloc(sizeof(struct physics_struct));
        this_cylinder_volume.p_physics->is_vacuum = 1; // Makes this volume a vacuum
        this_cylinder_volume.p_physics->number_of_processes = (int) 0;
        this_cylinder_volume.p_physics->my_a = 0; // Should not be used.
        this_cylinder_volume.geometry.is_exit_volume = 1;
        sprintf(this_cylinder_volume.p_physics->name,"Exit");
    } else {
        for (loop_index=0;loop_index<global_material_list.num_elements;loop_index++) {
          if (0 == strcmp(material_string,global_material_list.elements[loop_index].name)) {
            this_cylinder_volume.p_physics = global_material_list.elements[loop_index].physics;
            break;
          }
          if (loop_index == global_material_list.num_elements-1) {
            printf("\n");
            printf("ERROR: The material string \"%s\" in Union geometry \"%s\" did not match a specified material. \n",material_string,NAME_CURRENT_COMP);
            printf("       The materials available at this point (need to be defined before the geometry): \n");
            for (loop_index=0;loop_index<global_material_list.num_elements;loop_index++)
              printf("         %s\n",global_material_list.elements[loop_index].name);
            printf("\n");
            printf("       It is also possible to use one of the defualt materials avaiable: \n");
            printf("           Vacuum (for a Volume without scattering or absorption)\n");
            printf("           Exit (for a Volume where the ray exits the component if it enters)\n");
            printf("           Mask (for a Volume that masks existing volumes specified in the mask_string\n");
            exit(1);
          }
        }
    }
} else {
    // Automatic linking, simply using the last defined material.
    #ifndef MATERIAL_DETECTOR
        printf("Need to define a material before the geometry to use automatic linking %s.\n",NAME_CURRENT_COMP);
        exit(1);
    #endif
    this_cylinder_volume.p_physics = global_material_list.elements[global_material_list.num_elements-1].physics;
}

sprintf(this_cylinder_volume.name,NAME_CURRENT_COMP);
sprintf(this_cylinder_volume.geometry.shape,"cylinder");
this_cylinder_volume.geometry.priority_value = priority;
// Currently the coordinates will be in absolute space.
this_cylinder_volume.geometry.center = POS_A_CURRENT_COMP;

this_cylinder_volume.geometry.geometry_p_interact = p_interact;
this_cylinder_storage.cyl_radius = radius;
this_cylinder_storage.height = yheight;
this_cylinder_volume.geometry.visualization_on = visualize;
this_cylinder_volume.geometry.geometry_parameters.p_cylinder_storage = &this_cylinder_storage;
this_cylinder_volume.geometry.within_function = &r_within_cylinder;
this_cylinder_volume.geometry.intersect_function = &sample_cylinder_intersect;
this_cylinder_volume.geometry.mcdisplay_function = &mcdisplay_cylinder_function;
this_cylinder_volume.geometry.shell_points = &cylinder_shell_points;
this_cylinder_volume.geometry.initialize_from_main_function = &initialize_cylinder_geometry_from_main_component;
this_cylinder_volume.geometry.process_rot_allocated = 0;
this_cylinder_volume.geometry.copy_geometry_parameters = &allocate_cylinder_storage_copy;

rot_copy(this_cylinder_volume.geometry.rotation_matrix,ROT_A_CURRENT_COMP);
rot_transpose(ROT_A_CURRENT_COMP,this_cylinder_volume.geometry.transpose_rotation_matrix);

// Initialize loggers
this_cylinder_volume.loggers.num_elements = 0;

// packing the information into the global_geometry_element, which is then included in the global_geometry_list.
sprintf(global_geometry_element.name,NAME_CURRENT_COMP);
global_geometry_element.activation_counter = number_of_activations;
global_geometry_element.component_index = INDEX_CURRENT_COMP;
global_geometry_element.Volume = &this_cylinder_volume; // Would be nicer if this m was a pointer, now we have the (small) data two places
add_element_to_geometry_list(&global_geometry_list,global_geometry_element);
}
#line 158375 "MACS_sample_kidney_box.c"
#undef number_of_activations
#undef mask_setting
#undef mask_string
#undef p_interact
#undef focus_r
#undef focus_xh
#undef focus_xw
#undef focus_ah
#undef focus_aw
#undef target_z
#undef target_y
#undef target_x
#undef target_index
#undef visualize
#undef yheight
#undef radius
#undef priority
#undef material_string
#undef this_cylinder_storage
#undef global_geometry_element
#undef this_cylinder_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

  /* Initializations for component sample_rod_collar_3. */
  SIG_MESSAGE("sample_rod_collar_3 (Init)");
#define mccompcurname  sample_rod_collar_3
#define mccompcurtype  Union_cylinder
#define mccompcurindex 38
#define loop_index mccsample_rod_collar_3_loop_index
#define this_cylinder_volume mccsample_rod_collar_3_this_cylinder_volume
#define global_geometry_element mccsample_rod_collar_3_global_geometry_element
#define this_cylinder_storage mccsample_rod_collar_3_this_cylinder_storage
#define material_string mccsample_rod_collar_3_material_string
#define priority mccsample_rod_collar_3_priority
#define radius mccsample_rod_collar_3_radius
#define yheight mccsample_rod_collar_3_yheight
#define visualize mccsample_rod_collar_3_visualize
#define target_index mccsample_rod_collar_3_target_index
#define target_x mccsample_rod_collar_3_target_x
#define target_y mccsample_rod_collar_3_target_y
#define target_z mccsample_rod_collar_3_target_z
#define focus_aw mccsample_rod_collar_3_focus_aw
#define focus_ah mccsample_rod_collar_3_focus_ah
#define focus_xw mccsample_rod_collar_3_focus_xw
#define focus_xh mccsample_rod_collar_3_focus_xh
#define focus_r mccsample_rod_collar_3_focus_r
#define p_interact mccsample_rod_collar_3_p_interact
#define mask_string mccsample_rod_collar_3_mask_string
#define mask_setting mccsample_rod_collar_3_mask_setting
#define number_of_activations mccsample_rod_collar_3_number_of_activations
#line 185 "Union_cylinder.comp"
{
// Initializes the focusing system for this volume including input sanitation.
focus_initialize(&this_cylinder_volume.geometry, POS_A_COMP_INDEX(INDEX_CURRENT_COMP+target_index), POS_A_CURRENT_COMP, ROT_A_CURRENT_COMP, target_index, target_x, target_y, target_z, focus_aw, focus_ah, focus_xw, focus_xh, focus_r, NAME_CURRENT_COMP);

// Input sanitation for this geometry
if (radius <= 0) {
  printf("\nERROR in Union_cylinder named %s, the radius is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}

if (yheight <= 0) {
  printf("\nERROR in Union_cylinder named %s, yheight is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}

// Use sanitation
#ifdef MATERIAL_DETECTOR
if (global_material_list.num_elements == 0) {
  // Here if the user have defined a material, but only after this material
  printf("\nERROR: Need to define a material using Union_make_material before using a Union geometry component. \n");
  printf("       %s was defined before first use of Union_make_material.\n",NAME_CURRENT_COMP);
  exit(1);
}
#endif
#ifndef MATERIAL_DETECTOR
  printf("\nERROR: Need to define a material using Union_make_material before using a Union geometry component. \n");
  exit(1);
#endif


this_cylinder_volume.geometry.is_masked_volume = 0;
this_cylinder_volume.geometry.is_exit_volume = 0;
this_cylinder_volume.geometry.is_mask_volume = 0;

// Read the material input, or if it lacks, use automatic linking.
if (mask_string && strlen(mask_string) && strcmp(mask_string, "NULL") && strcmp(mask_string, "0")) {
    // A mask volume is used to limit the extend of other volumes, called the masked volumes. These are specified in the mask_string.
    // In order for a ray to enter a masked volume, it needs to be both in the region covered by that volume AND the mask volume.
    // When more than
    this_cylinder_volume.geometry.mask_mode = 1; // Default is mask mode is ALL
    if (mask_setting && strlen(mask_setting) && strcmp(mask_setting, "NULL") && strcmp(mask_setting, "0")) {
        if (strcmp(mask_setting,"ALL") == 0 || strcmp(mask_setting,"All") == 0) this_cylinder_volume.geometry.mask_mode = 1;
        else if (strcmp(mask_setting,"ANY") == 0 || strcmp(mask_setting,"Any") == 0) this_cylinder_volume.geometry.mask_mode = 2;
        else {
            printf("The mask_mode of component %s is set to %s, but must be either ALL or ANY.\n",NAME_CURRENT_COMP,mask_setting);
            exit(1);
        }
    }
    
    for (loop_index=0;loop_index<global_geometry_list.num_elements;loop_index++) {
        // Add mask list
        if (1 == manual_linking_function(global_geometry_list.elements[loop_index].name,mask_string)) {
            add_element_to_int_list(&this_cylinder_volume.geometry.mask_list,global_geometry_list.elements[loop_index].component_index);
            add_element_to_int_list(&global_geometry_list.elements[loop_index].Volume->geometry.masked_by_list,INDEX_CURRENT_COMP);
            global_geometry_list.elements[loop_index].Volume->geometry.is_masked_volume = 1;
            if (this_cylinder_volume.geometry.mask_mode == 2)
                global_geometry_list.elements[loop_index].Volume->geometry.mask_mode = 2;
            if (this_cylinder_volume.geometry.mask_mode == 1) {
                if (global_geometry_list.elements[loop_index].Volume->geometry.is_masked_volume == 1 && global_geometry_list.elements[loop_index].Volume->geometry.mask_mode != 2)
                    // If more than one mask is added to one volume, the ANY mode overwrites the (default) ALL mode.
                    global_geometry_list.elements[loop_index].Volume->geometry.mask_mode = 1;
            }
            
            found_geometries = 1;
        }
    }
    if (found_geometries == 0) {
        printf("The mask_string in geometry: %s did not find any of the specified volumes in the mask_string %s \n",NAME_CURRENT_COMP,mask_string);
        exit(1);
    }
    this_cylinder_volume.p_physics = malloc(sizeof(struct physics_struct));
    this_cylinder_volume.p_physics->is_vacuum = 0; // Makes this volume a vacuum
    this_cylinder_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
    this_cylinder_volume.p_physics->my_a = 0; // Should not be used.
    sprintf(this_cylinder_volume.p_physics->name,"Mask");
    this_cylinder_volume.geometry.is_mask_volume = 1;
    
    
// Read the material input, or if it lacks, use automatic linking.
} else if (material_string && strlen(material_string) && strcmp(material_string, "NULL") && strcmp(material_string, "0")) {
    // A geometry string was given, use it to determine which material
    if (0 == strcmp(material_string,"vacuum") || 0 == strcmp(material_string,"Vacuum")) {
        // One could have a global physics struct for vacuum instead of creating one for each
        this_cylinder_volume.p_physics = malloc(sizeof(struct physics_struct));
        this_cylinder_volume.p_physics->is_vacuum = 1; // Makes this volume a vacuum
        this_cylinder_volume.p_physics->number_of_processes = (int) 0;
        this_cylinder_volume.p_physics->my_a = 0; // Should not be used.
        sprintf(this_cylinder_volume.p_physics->name,"Vacuum");
    } else if (0 == strcmp(material_string,"exit") || 0 == strcmp(material_string,"Exit")) {
        // One could have a global physics struct for exit instead of creating one for each
        this_cylinder_volume.p_physics = malloc(sizeof(struct physics_struct));
        this_cylinder_volume.p_physics->is_vacuum = 1; // Makes this volume a vacuum
        this_cylinder_volume.p_physics->number_of_processes = (int) 0;
        this_cylinder_volume.p_physics->my_a = 0; // Should not be used.
        this_cylinder_volume.geometry.is_exit_volume = 1;
        sprintf(this_cylinder_volume.p_physics->name,"Exit");
    } else {
        for (loop_index=0;loop_index<global_material_list.num_elements;loop_index++) {
          if (0 == strcmp(material_string,global_material_list.elements[loop_index].name)) {
            this_cylinder_volume.p_physics = global_material_list.elements[loop_index].physics;
            break;
          }
          if (loop_index == global_material_list.num_elements-1) {
            printf("\n");
            printf("ERROR: The material string \"%s\" in Union geometry \"%s\" did not match a specified material. \n",material_string,NAME_CURRENT_COMP);
            printf("       The materials available at this point (need to be defined before the geometry): \n");
            for (loop_index=0;loop_index<global_material_list.num_elements;loop_index++)
              printf("         %s\n",global_material_list.elements[loop_index].name);
            printf("\n");
            printf("       It is also possible to use one of the defualt materials avaiable: \n");
            printf("           Vacuum (for a Volume without scattering or absorption)\n");
            printf("           Exit (for a Volume where the ray exits the component if it enters)\n");
            printf("           Mask (for a Volume that masks existing volumes specified in the mask_string\n");
            exit(1);
          }
        }
    }
} else {
    // Automatic linking, simply using the last defined material.
    #ifndef MATERIAL_DETECTOR
        printf("Need to define a material before the geometry to use automatic linking %s.\n",NAME_CURRENT_COMP);
        exit(1);
    #endif
    this_cylinder_volume.p_physics = global_material_list.elements[global_material_list.num_elements-1].physics;
}

sprintf(this_cylinder_volume.name,NAME_CURRENT_COMP);
sprintf(this_cylinder_volume.geometry.shape,"cylinder");
this_cylinder_volume.geometry.priority_value = priority;
// Currently the coordinates will be in absolute space.
this_cylinder_volume.geometry.center = POS_A_CURRENT_COMP;

this_cylinder_volume.geometry.geometry_p_interact = p_interact;
this_cylinder_storage.cyl_radius = radius;
this_cylinder_storage.height = yheight;
this_cylinder_volume.geometry.visualization_on = visualize;
this_cylinder_volume.geometry.geometry_parameters.p_cylinder_storage = &this_cylinder_storage;
this_cylinder_volume.geometry.within_function = &r_within_cylinder;
this_cylinder_volume.geometry.intersect_function = &sample_cylinder_intersect;
this_cylinder_volume.geometry.mcdisplay_function = &mcdisplay_cylinder_function;
this_cylinder_volume.geometry.shell_points = &cylinder_shell_points;
this_cylinder_volume.geometry.initialize_from_main_function = &initialize_cylinder_geometry_from_main_component;
this_cylinder_volume.geometry.process_rot_allocated = 0;
this_cylinder_volume.geometry.copy_geometry_parameters = &allocate_cylinder_storage_copy;

rot_copy(this_cylinder_volume.geometry.rotation_matrix,ROT_A_CURRENT_COMP);
rot_transpose(ROT_A_CURRENT_COMP,this_cylinder_volume.geometry.transpose_rotation_matrix);

// Initialize loggers
this_cylinder_volume.loggers.num_elements = 0;

// packing the information into the global_geometry_element, which is then included in the global_geometry_list.
sprintf(global_geometry_element.name,NAME_CURRENT_COMP);
global_geometry_element.activation_counter = number_of_activations;
global_geometry_element.component_index = INDEX_CURRENT_COMP;
global_geometry_element.Volume = &this_cylinder_volume; // Would be nicer if this m was a pointer, now we have the (small) data two places
add_element_to_geometry_list(&global_geometry_list,global_geometry_element);
}
#line 158588 "MACS_sample_kidney_box.c"
#undef number_of_activations
#undef mask_setting
#undef mask_string
#undef p_interact
#undef focus_r
#undef focus_xh
#undef focus_xw
#undef focus_ah
#undef focus_aw
#undef target_z
#undef target_y
#undef target_x
#undef target_index
#undef visualize
#undef yheight
#undef radius
#undef priority
#undef material_string
#undef this_cylinder_storage
#undef global_geometry_element
#undef this_cylinder_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

  /* Initializations for component sample_rod_collar_4. */
  SIG_MESSAGE("sample_rod_collar_4 (Init)");
#define mccompcurname  sample_rod_collar_4
#define mccompcurtype  Union_cylinder
#define mccompcurindex 39
#define loop_index mccsample_rod_collar_4_loop_index
#define this_cylinder_volume mccsample_rod_collar_4_this_cylinder_volume
#define global_geometry_element mccsample_rod_collar_4_global_geometry_element
#define this_cylinder_storage mccsample_rod_collar_4_this_cylinder_storage
#define material_string mccsample_rod_collar_4_material_string
#define priority mccsample_rod_collar_4_priority
#define radius mccsample_rod_collar_4_radius
#define yheight mccsample_rod_collar_4_yheight
#define visualize mccsample_rod_collar_4_visualize
#define target_index mccsample_rod_collar_4_target_index
#define target_x mccsample_rod_collar_4_target_x
#define target_y mccsample_rod_collar_4_target_y
#define target_z mccsample_rod_collar_4_target_z
#define focus_aw mccsample_rod_collar_4_focus_aw
#define focus_ah mccsample_rod_collar_4_focus_ah
#define focus_xw mccsample_rod_collar_4_focus_xw
#define focus_xh mccsample_rod_collar_4_focus_xh
#define focus_r mccsample_rod_collar_4_focus_r
#define p_interact mccsample_rod_collar_4_p_interact
#define mask_string mccsample_rod_collar_4_mask_string
#define mask_setting mccsample_rod_collar_4_mask_setting
#define number_of_activations mccsample_rod_collar_4_number_of_activations
#line 185 "Union_cylinder.comp"
{
// Initializes the focusing system for this volume including input sanitation.
focus_initialize(&this_cylinder_volume.geometry, POS_A_COMP_INDEX(INDEX_CURRENT_COMP+target_index), POS_A_CURRENT_COMP, ROT_A_CURRENT_COMP, target_index, target_x, target_y, target_z, focus_aw, focus_ah, focus_xw, focus_xh, focus_r, NAME_CURRENT_COMP);

// Input sanitation for this geometry
if (radius <= 0) {
  printf("\nERROR in Union_cylinder named %s, the radius is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}

if (yheight <= 0) {
  printf("\nERROR in Union_cylinder named %s, yheight is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}

// Use sanitation
#ifdef MATERIAL_DETECTOR
if (global_material_list.num_elements == 0) {
  // Here if the user have defined a material, but only after this material
  printf("\nERROR: Need to define a material using Union_make_material before using a Union geometry component. \n");
  printf("       %s was defined before first use of Union_make_material.\n",NAME_CURRENT_COMP);
  exit(1);
}
#endif
#ifndef MATERIAL_DETECTOR
  printf("\nERROR: Need to define a material using Union_make_material before using a Union geometry component. \n");
  exit(1);
#endif


this_cylinder_volume.geometry.is_masked_volume = 0;
this_cylinder_volume.geometry.is_exit_volume = 0;
this_cylinder_volume.geometry.is_mask_volume = 0;

// Read the material input, or if it lacks, use automatic linking.
if (mask_string && strlen(mask_string) && strcmp(mask_string, "NULL") && strcmp(mask_string, "0")) {
    // A mask volume is used to limit the extend of other volumes, called the masked volumes. These are specified in the mask_string.
    // In order for a ray to enter a masked volume, it needs to be both in the region covered by that volume AND the mask volume.
    // When more than
    this_cylinder_volume.geometry.mask_mode = 1; // Default is mask mode is ALL
    if (mask_setting && strlen(mask_setting) && strcmp(mask_setting, "NULL") && strcmp(mask_setting, "0")) {
        if (strcmp(mask_setting,"ALL") == 0 || strcmp(mask_setting,"All") == 0) this_cylinder_volume.geometry.mask_mode = 1;
        else if (strcmp(mask_setting,"ANY") == 0 || strcmp(mask_setting,"Any") == 0) this_cylinder_volume.geometry.mask_mode = 2;
        else {
            printf("The mask_mode of component %s is set to %s, but must be either ALL or ANY.\n",NAME_CURRENT_COMP,mask_setting);
            exit(1);
        }
    }
    
    for (loop_index=0;loop_index<global_geometry_list.num_elements;loop_index++) {
        // Add mask list
        if (1 == manual_linking_function(global_geometry_list.elements[loop_index].name,mask_string)) {
            add_element_to_int_list(&this_cylinder_volume.geometry.mask_list,global_geometry_list.elements[loop_index].component_index);
            add_element_to_int_list(&global_geometry_list.elements[loop_index].Volume->geometry.masked_by_list,INDEX_CURRENT_COMP);
            global_geometry_list.elements[loop_index].Volume->geometry.is_masked_volume = 1;
            if (this_cylinder_volume.geometry.mask_mode == 2)
                global_geometry_list.elements[loop_index].Volume->geometry.mask_mode = 2;
            if (this_cylinder_volume.geometry.mask_mode == 1) {
                if (global_geometry_list.elements[loop_index].Volume->geometry.is_masked_volume == 1 && global_geometry_list.elements[loop_index].Volume->geometry.mask_mode != 2)
                    // If more than one mask is added to one volume, the ANY mode overwrites the (default) ALL mode.
                    global_geometry_list.elements[loop_index].Volume->geometry.mask_mode = 1;
            }
            
            found_geometries = 1;
        }
    }
    if (found_geometries == 0) {
        printf("The mask_string in geometry: %s did not find any of the specified volumes in the mask_string %s \n",NAME_CURRENT_COMP,mask_string);
        exit(1);
    }
    this_cylinder_volume.p_physics = malloc(sizeof(struct physics_struct));
    this_cylinder_volume.p_physics->is_vacuum = 0; // Makes this volume a vacuum
    this_cylinder_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
    this_cylinder_volume.p_physics->my_a = 0; // Should not be used.
    sprintf(this_cylinder_volume.p_physics->name,"Mask");
    this_cylinder_volume.geometry.is_mask_volume = 1;
    
    
// Read the material input, or if it lacks, use automatic linking.
} else if (material_string && strlen(material_string) && strcmp(material_string, "NULL") && strcmp(material_string, "0")) {
    // A geometry string was given, use it to determine which material
    if (0 == strcmp(material_string,"vacuum") || 0 == strcmp(material_string,"Vacuum")) {
        // One could have a global physics struct for vacuum instead of creating one for each
        this_cylinder_volume.p_physics = malloc(sizeof(struct physics_struct));
        this_cylinder_volume.p_physics->is_vacuum = 1; // Makes this volume a vacuum
        this_cylinder_volume.p_physics->number_of_processes = (int) 0;
        this_cylinder_volume.p_physics->my_a = 0; // Should not be used.
        sprintf(this_cylinder_volume.p_physics->name,"Vacuum");
    } else if (0 == strcmp(material_string,"exit") || 0 == strcmp(material_string,"Exit")) {
        // One could have a global physics struct for exit instead of creating one for each
        this_cylinder_volume.p_physics = malloc(sizeof(struct physics_struct));
        this_cylinder_volume.p_physics->is_vacuum = 1; // Makes this volume a vacuum
        this_cylinder_volume.p_physics->number_of_processes = (int) 0;
        this_cylinder_volume.p_physics->my_a = 0; // Should not be used.
        this_cylinder_volume.geometry.is_exit_volume = 1;
        sprintf(this_cylinder_volume.p_physics->name,"Exit");
    } else {
        for (loop_index=0;loop_index<global_material_list.num_elements;loop_index++) {
          if (0 == strcmp(material_string,global_material_list.elements[loop_index].name)) {
            this_cylinder_volume.p_physics = global_material_list.elements[loop_index].physics;
            break;
          }
          if (loop_index == global_material_list.num_elements-1) {
            printf("\n");
            printf("ERROR: The material string \"%s\" in Union geometry \"%s\" did not match a specified material. \n",material_string,NAME_CURRENT_COMP);
            printf("       The materials available at this point (need to be defined before the geometry): \n");
            for (loop_index=0;loop_index<global_material_list.num_elements;loop_index++)
              printf("         %s\n",global_material_list.elements[loop_index].name);
            printf("\n");
            printf("       It is also possible to use one of the defualt materials avaiable: \n");
            printf("           Vacuum (for a Volume without scattering or absorption)\n");
            printf("           Exit (for a Volume where the ray exits the component if it enters)\n");
            printf("           Mask (for a Volume that masks existing volumes specified in the mask_string\n");
            exit(1);
          }
        }
    }
} else {
    // Automatic linking, simply using the last defined material.
    #ifndef MATERIAL_DETECTOR
        printf("Need to define a material before the geometry to use automatic linking %s.\n",NAME_CURRENT_COMP);
        exit(1);
    #endif
    this_cylinder_volume.p_physics = global_material_list.elements[global_material_list.num_elements-1].physics;
}

sprintf(this_cylinder_volume.name,NAME_CURRENT_COMP);
sprintf(this_cylinder_volume.geometry.shape,"cylinder");
this_cylinder_volume.geometry.priority_value = priority;
// Currently the coordinates will be in absolute space.
this_cylinder_volume.geometry.center = POS_A_CURRENT_COMP;

this_cylinder_volume.geometry.geometry_p_interact = p_interact;
this_cylinder_storage.cyl_radius = radius;
this_cylinder_storage.height = yheight;
this_cylinder_volume.geometry.visualization_on = visualize;
this_cylinder_volume.geometry.geometry_parameters.p_cylinder_storage = &this_cylinder_storage;
this_cylinder_volume.geometry.within_function = &r_within_cylinder;
this_cylinder_volume.geometry.intersect_function = &sample_cylinder_intersect;
this_cylinder_volume.geometry.mcdisplay_function = &mcdisplay_cylinder_function;
this_cylinder_volume.geometry.shell_points = &cylinder_shell_points;
this_cylinder_volume.geometry.initialize_from_main_function = &initialize_cylinder_geometry_from_main_component;
this_cylinder_volume.geometry.process_rot_allocated = 0;
this_cylinder_volume.geometry.copy_geometry_parameters = &allocate_cylinder_storage_copy;

rot_copy(this_cylinder_volume.geometry.rotation_matrix,ROT_A_CURRENT_COMP);
rot_transpose(ROT_A_CURRENT_COMP,this_cylinder_volume.geometry.transpose_rotation_matrix);

// Initialize loggers
this_cylinder_volume.loggers.num_elements = 0;

// packing the information into the global_geometry_element, which is then included in the global_geometry_list.
sprintf(global_geometry_element.name,NAME_CURRENT_COMP);
global_geometry_element.activation_counter = number_of_activations;
global_geometry_element.component_index = INDEX_CURRENT_COMP;
global_geometry_element.Volume = &this_cylinder_volume; // Would be nicer if this m was a pointer, now we have the (small) data two places
add_element_to_geometry_list(&global_geometry_list,global_geometry_element);
}
#line 158801 "MACS_sample_kidney_box.c"
#undef number_of_activations
#undef mask_setting
#undef mask_string
#undef p_interact
#undef focus_r
#undef focus_xh
#undef focus_xw
#undef focus_ah
#undef focus_aw
#undef target_z
#undef target_y
#undef target_x
#undef target_index
#undef visualize
#undef yheight
#undef radius
#undef priority
#undef material_string
#undef this_cylinder_storage
#undef global_geometry_element
#undef this_cylinder_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

  /* Initializations for component sample_rod_collar_1_vacuum. */
  SIG_MESSAGE("sample_rod_collar_1_vacuum (Init)");
#define mccompcurname  sample_rod_collar_1_vacuum
#define mccompcurtype  Union_cylinder
#define mccompcurindex 40
#define loop_index mccsample_rod_collar_1_vacuum_loop_index
#define this_cylinder_volume mccsample_rod_collar_1_vacuum_this_cylinder_volume
#define global_geometry_element mccsample_rod_collar_1_vacuum_global_geometry_element
#define this_cylinder_storage mccsample_rod_collar_1_vacuum_this_cylinder_storage
#define material_string mccsample_rod_collar_1_vacuum_material_string
#define priority mccsample_rod_collar_1_vacuum_priority
#define radius mccsample_rod_collar_1_vacuum_radius
#define yheight mccsample_rod_collar_1_vacuum_yheight
#define visualize mccsample_rod_collar_1_vacuum_visualize
#define target_index mccsample_rod_collar_1_vacuum_target_index
#define target_x mccsample_rod_collar_1_vacuum_target_x
#define target_y mccsample_rod_collar_1_vacuum_target_y
#define target_z mccsample_rod_collar_1_vacuum_target_z
#define focus_aw mccsample_rod_collar_1_vacuum_focus_aw
#define focus_ah mccsample_rod_collar_1_vacuum_focus_ah
#define focus_xw mccsample_rod_collar_1_vacuum_focus_xw
#define focus_xh mccsample_rod_collar_1_vacuum_focus_xh
#define focus_r mccsample_rod_collar_1_vacuum_focus_r
#define p_interact mccsample_rod_collar_1_vacuum_p_interact
#define mask_string mccsample_rod_collar_1_vacuum_mask_string
#define mask_setting mccsample_rod_collar_1_vacuum_mask_setting
#define number_of_activations mccsample_rod_collar_1_vacuum_number_of_activations
#line 185 "Union_cylinder.comp"
{
// Initializes the focusing system for this volume including input sanitation.
focus_initialize(&this_cylinder_volume.geometry, POS_A_COMP_INDEX(INDEX_CURRENT_COMP+target_index), POS_A_CURRENT_COMP, ROT_A_CURRENT_COMP, target_index, target_x, target_y, target_z, focus_aw, focus_ah, focus_xw, focus_xh, focus_r, NAME_CURRENT_COMP);

// Input sanitation for this geometry
if (radius <= 0) {
  printf("\nERROR in Union_cylinder named %s, the radius is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}

if (yheight <= 0) {
  printf("\nERROR in Union_cylinder named %s, yheight is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}

// Use sanitation
#ifdef MATERIAL_DETECTOR
if (global_material_list.num_elements == 0) {
  // Here if the user have defined a material, but only after this material
  printf("\nERROR: Need to define a material using Union_make_material before using a Union geometry component. \n");
  printf("       %s was defined before first use of Union_make_material.\n",NAME_CURRENT_COMP);
  exit(1);
}
#endif
#ifndef MATERIAL_DETECTOR
  printf("\nERROR: Need to define a material using Union_make_material before using a Union geometry component. \n");
  exit(1);
#endif


this_cylinder_volume.geometry.is_masked_volume = 0;
this_cylinder_volume.geometry.is_exit_volume = 0;
this_cylinder_volume.geometry.is_mask_volume = 0;

// Read the material input, or if it lacks, use automatic linking.
if (mask_string && strlen(mask_string) && strcmp(mask_string, "NULL") && strcmp(mask_string, "0")) {
    // A mask volume is used to limit the extend of other volumes, called the masked volumes. These are specified in the mask_string.
    // In order for a ray to enter a masked volume, it needs to be both in the region covered by that volume AND the mask volume.
    // When more than
    this_cylinder_volume.geometry.mask_mode = 1; // Default is mask mode is ALL
    if (mask_setting && strlen(mask_setting) && strcmp(mask_setting, "NULL") && strcmp(mask_setting, "0")) {
        if (strcmp(mask_setting,"ALL") == 0 || strcmp(mask_setting,"All") == 0) this_cylinder_volume.geometry.mask_mode = 1;
        else if (strcmp(mask_setting,"ANY") == 0 || strcmp(mask_setting,"Any") == 0) this_cylinder_volume.geometry.mask_mode = 2;
        else {
            printf("The mask_mode of component %s is set to %s, but must be either ALL or ANY.\n",NAME_CURRENT_COMP,mask_setting);
            exit(1);
        }
    }
    
    for (loop_index=0;loop_index<global_geometry_list.num_elements;loop_index++) {
        // Add mask list
        if (1 == manual_linking_function(global_geometry_list.elements[loop_index].name,mask_string)) {
            add_element_to_int_list(&this_cylinder_volume.geometry.mask_list,global_geometry_list.elements[loop_index].component_index);
            add_element_to_int_list(&global_geometry_list.elements[loop_index].Volume->geometry.masked_by_list,INDEX_CURRENT_COMP);
            global_geometry_list.elements[loop_index].Volume->geometry.is_masked_volume = 1;
            if (this_cylinder_volume.geometry.mask_mode == 2)
                global_geometry_list.elements[loop_index].Volume->geometry.mask_mode = 2;
            if (this_cylinder_volume.geometry.mask_mode == 1) {
                if (global_geometry_list.elements[loop_index].Volume->geometry.is_masked_volume == 1 && global_geometry_list.elements[loop_index].Volume->geometry.mask_mode != 2)
                    // If more than one mask is added to one volume, the ANY mode overwrites the (default) ALL mode.
                    global_geometry_list.elements[loop_index].Volume->geometry.mask_mode = 1;
            }
            
            found_geometries = 1;
        }
    }
    if (found_geometries == 0) {
        printf("The mask_string in geometry: %s did not find any of the specified volumes in the mask_string %s \n",NAME_CURRENT_COMP,mask_string);
        exit(1);
    }
    this_cylinder_volume.p_physics = malloc(sizeof(struct physics_struct));
    this_cylinder_volume.p_physics->is_vacuum = 0; // Makes this volume a vacuum
    this_cylinder_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
    this_cylinder_volume.p_physics->my_a = 0; // Should not be used.
    sprintf(this_cylinder_volume.p_physics->name,"Mask");
    this_cylinder_volume.geometry.is_mask_volume = 1;
    
    
// Read the material input, or if it lacks, use automatic linking.
} else if (material_string && strlen(material_string) && strcmp(material_string, "NULL") && strcmp(material_string, "0")) {
    // A geometry string was given, use it to determine which material
    if (0 == strcmp(material_string,"vacuum") || 0 == strcmp(material_string,"Vacuum")) {
        // One could have a global physics struct for vacuum instead of creating one for each
        this_cylinder_volume.p_physics = malloc(sizeof(struct physics_struct));
        this_cylinder_volume.p_physics->is_vacuum = 1; // Makes this volume a vacuum
        this_cylinder_volume.p_physics->number_of_processes = (int) 0;
        this_cylinder_volume.p_physics->my_a = 0; // Should not be used.
        sprintf(this_cylinder_volume.p_physics->name,"Vacuum");
    } else if (0 == strcmp(material_string,"exit") || 0 == strcmp(material_string,"Exit")) {
        // One could have a global physics struct for exit instead of creating one for each
        this_cylinder_volume.p_physics = malloc(sizeof(struct physics_struct));
        this_cylinder_volume.p_physics->is_vacuum = 1; // Makes this volume a vacuum
        this_cylinder_volume.p_physics->number_of_processes = (int) 0;
        this_cylinder_volume.p_physics->my_a = 0; // Should not be used.
        this_cylinder_volume.geometry.is_exit_volume = 1;
        sprintf(this_cylinder_volume.p_physics->name,"Exit");
    } else {
        for (loop_index=0;loop_index<global_material_list.num_elements;loop_index++) {
          if (0 == strcmp(material_string,global_material_list.elements[loop_index].name)) {
            this_cylinder_volume.p_physics = global_material_list.elements[loop_index].physics;
            break;
          }
          if (loop_index == global_material_list.num_elements-1) {
            printf("\n");
            printf("ERROR: The material string \"%s\" in Union geometry \"%s\" did not match a specified material. \n",material_string,NAME_CURRENT_COMP);
            printf("       The materials available at this point (need to be defined before the geometry): \n");
            for (loop_index=0;loop_index<global_material_list.num_elements;loop_index++)
              printf("         %s\n",global_material_list.elements[loop_index].name);
            printf("\n");
            printf("       It is also possible to use one of the defualt materials avaiable: \n");
            printf("           Vacuum (for a Volume without scattering or absorption)\n");
            printf("           Exit (for a Volume where the ray exits the component if it enters)\n");
            printf("           Mask (for a Volume that masks existing volumes specified in the mask_string\n");
            exit(1);
          }
        }
    }
} else {
    // Automatic linking, simply using the last defined material.
    #ifndef MATERIAL_DETECTOR
        printf("Need to define a material before the geometry to use automatic linking %s.\n",NAME_CURRENT_COMP);
        exit(1);
    #endif
    this_cylinder_volume.p_physics = global_material_list.elements[global_material_list.num_elements-1].physics;
}

sprintf(this_cylinder_volume.name,NAME_CURRENT_COMP);
sprintf(this_cylinder_volume.geometry.shape,"cylinder");
this_cylinder_volume.geometry.priority_value = priority;
// Currently the coordinates will be in absolute space.
this_cylinder_volume.geometry.center = POS_A_CURRENT_COMP;

this_cylinder_volume.geometry.geometry_p_interact = p_interact;
this_cylinder_storage.cyl_radius = radius;
this_cylinder_storage.height = yheight;
this_cylinder_volume.geometry.visualization_on = visualize;
this_cylinder_volume.geometry.geometry_parameters.p_cylinder_storage = &this_cylinder_storage;
this_cylinder_volume.geometry.within_function = &r_within_cylinder;
this_cylinder_volume.geometry.intersect_function = &sample_cylinder_intersect;
this_cylinder_volume.geometry.mcdisplay_function = &mcdisplay_cylinder_function;
this_cylinder_volume.geometry.shell_points = &cylinder_shell_points;
this_cylinder_volume.geometry.initialize_from_main_function = &initialize_cylinder_geometry_from_main_component;
this_cylinder_volume.geometry.process_rot_allocated = 0;
this_cylinder_volume.geometry.copy_geometry_parameters = &allocate_cylinder_storage_copy;

rot_copy(this_cylinder_volume.geometry.rotation_matrix,ROT_A_CURRENT_COMP);
rot_transpose(ROT_A_CURRENT_COMP,this_cylinder_volume.geometry.transpose_rotation_matrix);

// Initialize loggers
this_cylinder_volume.loggers.num_elements = 0;

// packing the information into the global_geometry_element, which is then included in the global_geometry_list.
sprintf(global_geometry_element.name,NAME_CURRENT_COMP);
global_geometry_element.activation_counter = number_of_activations;
global_geometry_element.component_index = INDEX_CURRENT_COMP;
global_geometry_element.Volume = &this_cylinder_volume; // Would be nicer if this m was a pointer, now we have the (small) data two places
add_element_to_geometry_list(&global_geometry_list,global_geometry_element);
}
#line 159014 "MACS_sample_kidney_box.c"
#undef number_of_activations
#undef mask_setting
#undef mask_string
#undef p_interact
#undef focus_r
#undef focus_xh
#undef focus_xw
#undef focus_ah
#undef focus_aw
#undef target_z
#undef target_y
#undef target_x
#undef target_index
#undef visualize
#undef yheight
#undef radius
#undef priority
#undef material_string
#undef this_cylinder_storage
#undef global_geometry_element
#undef this_cylinder_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

  /* Initializations for component sample_rod_collar_2_vacuum. */
  SIG_MESSAGE("sample_rod_collar_2_vacuum (Init)");
#define mccompcurname  sample_rod_collar_2_vacuum
#define mccompcurtype  Union_cylinder
#define mccompcurindex 41
#define loop_index mccsample_rod_collar_2_vacuum_loop_index
#define this_cylinder_volume mccsample_rod_collar_2_vacuum_this_cylinder_volume
#define global_geometry_element mccsample_rod_collar_2_vacuum_global_geometry_element
#define this_cylinder_storage mccsample_rod_collar_2_vacuum_this_cylinder_storage
#define material_string mccsample_rod_collar_2_vacuum_material_string
#define priority mccsample_rod_collar_2_vacuum_priority
#define radius mccsample_rod_collar_2_vacuum_radius
#define yheight mccsample_rod_collar_2_vacuum_yheight
#define visualize mccsample_rod_collar_2_vacuum_visualize
#define target_index mccsample_rod_collar_2_vacuum_target_index
#define target_x mccsample_rod_collar_2_vacuum_target_x
#define target_y mccsample_rod_collar_2_vacuum_target_y
#define target_z mccsample_rod_collar_2_vacuum_target_z
#define focus_aw mccsample_rod_collar_2_vacuum_focus_aw
#define focus_ah mccsample_rod_collar_2_vacuum_focus_ah
#define focus_xw mccsample_rod_collar_2_vacuum_focus_xw
#define focus_xh mccsample_rod_collar_2_vacuum_focus_xh
#define focus_r mccsample_rod_collar_2_vacuum_focus_r
#define p_interact mccsample_rod_collar_2_vacuum_p_interact
#define mask_string mccsample_rod_collar_2_vacuum_mask_string
#define mask_setting mccsample_rod_collar_2_vacuum_mask_setting
#define number_of_activations mccsample_rod_collar_2_vacuum_number_of_activations
#line 185 "Union_cylinder.comp"
{
// Initializes the focusing system for this volume including input sanitation.
focus_initialize(&this_cylinder_volume.geometry, POS_A_COMP_INDEX(INDEX_CURRENT_COMP+target_index), POS_A_CURRENT_COMP, ROT_A_CURRENT_COMP, target_index, target_x, target_y, target_z, focus_aw, focus_ah, focus_xw, focus_xh, focus_r, NAME_CURRENT_COMP);

// Input sanitation for this geometry
if (radius <= 0) {
  printf("\nERROR in Union_cylinder named %s, the radius is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}

if (yheight <= 0) {
  printf("\nERROR in Union_cylinder named %s, yheight is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}

// Use sanitation
#ifdef MATERIAL_DETECTOR
if (global_material_list.num_elements == 0) {
  // Here if the user have defined a material, but only after this material
  printf("\nERROR: Need to define a material using Union_make_material before using a Union geometry component. \n");
  printf("       %s was defined before first use of Union_make_material.\n",NAME_CURRENT_COMP);
  exit(1);
}
#endif
#ifndef MATERIAL_DETECTOR
  printf("\nERROR: Need to define a material using Union_make_material before using a Union geometry component. \n");
  exit(1);
#endif


this_cylinder_volume.geometry.is_masked_volume = 0;
this_cylinder_volume.geometry.is_exit_volume = 0;
this_cylinder_volume.geometry.is_mask_volume = 0;

// Read the material input, or if it lacks, use automatic linking.
if (mask_string && strlen(mask_string) && strcmp(mask_string, "NULL") && strcmp(mask_string, "0")) {
    // A mask volume is used to limit the extend of other volumes, called the masked volumes. These are specified in the mask_string.
    // In order for a ray to enter a masked volume, it needs to be both in the region covered by that volume AND the mask volume.
    // When more than
    this_cylinder_volume.geometry.mask_mode = 1; // Default is mask mode is ALL
    if (mask_setting && strlen(mask_setting) && strcmp(mask_setting, "NULL") && strcmp(mask_setting, "0")) {
        if (strcmp(mask_setting,"ALL") == 0 || strcmp(mask_setting,"All") == 0) this_cylinder_volume.geometry.mask_mode = 1;
        else if (strcmp(mask_setting,"ANY") == 0 || strcmp(mask_setting,"Any") == 0) this_cylinder_volume.geometry.mask_mode = 2;
        else {
            printf("The mask_mode of component %s is set to %s, but must be either ALL or ANY.\n",NAME_CURRENT_COMP,mask_setting);
            exit(1);
        }
    }
    
    for (loop_index=0;loop_index<global_geometry_list.num_elements;loop_index++) {
        // Add mask list
        if (1 == manual_linking_function(global_geometry_list.elements[loop_index].name,mask_string)) {
            add_element_to_int_list(&this_cylinder_volume.geometry.mask_list,global_geometry_list.elements[loop_index].component_index);
            add_element_to_int_list(&global_geometry_list.elements[loop_index].Volume->geometry.masked_by_list,INDEX_CURRENT_COMP);
            global_geometry_list.elements[loop_index].Volume->geometry.is_masked_volume = 1;
            if (this_cylinder_volume.geometry.mask_mode == 2)
                global_geometry_list.elements[loop_index].Volume->geometry.mask_mode = 2;
            if (this_cylinder_volume.geometry.mask_mode == 1) {
                if (global_geometry_list.elements[loop_index].Volume->geometry.is_masked_volume == 1 && global_geometry_list.elements[loop_index].Volume->geometry.mask_mode != 2)
                    // If more than one mask is added to one volume, the ANY mode overwrites the (default) ALL mode.
                    global_geometry_list.elements[loop_index].Volume->geometry.mask_mode = 1;
            }
            
            found_geometries = 1;
        }
    }
    if (found_geometries == 0) {
        printf("The mask_string in geometry: %s did not find any of the specified volumes in the mask_string %s \n",NAME_CURRENT_COMP,mask_string);
        exit(1);
    }
    this_cylinder_volume.p_physics = malloc(sizeof(struct physics_struct));
    this_cylinder_volume.p_physics->is_vacuum = 0; // Makes this volume a vacuum
    this_cylinder_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
    this_cylinder_volume.p_physics->my_a = 0; // Should not be used.
    sprintf(this_cylinder_volume.p_physics->name,"Mask");
    this_cylinder_volume.geometry.is_mask_volume = 1;
    
    
// Read the material input, or if it lacks, use automatic linking.
} else if (material_string && strlen(material_string) && strcmp(material_string, "NULL") && strcmp(material_string, "0")) {
    // A geometry string was given, use it to determine which material
    if (0 == strcmp(material_string,"vacuum") || 0 == strcmp(material_string,"Vacuum")) {
        // One could have a global physics struct for vacuum instead of creating one for each
        this_cylinder_volume.p_physics = malloc(sizeof(struct physics_struct));
        this_cylinder_volume.p_physics->is_vacuum = 1; // Makes this volume a vacuum
        this_cylinder_volume.p_physics->number_of_processes = (int) 0;
        this_cylinder_volume.p_physics->my_a = 0; // Should not be used.
        sprintf(this_cylinder_volume.p_physics->name,"Vacuum");
    } else if (0 == strcmp(material_string,"exit") || 0 == strcmp(material_string,"Exit")) {
        // One could have a global physics struct for exit instead of creating one for each
        this_cylinder_volume.p_physics = malloc(sizeof(struct physics_struct));
        this_cylinder_volume.p_physics->is_vacuum = 1; // Makes this volume a vacuum
        this_cylinder_volume.p_physics->number_of_processes = (int) 0;
        this_cylinder_volume.p_physics->my_a = 0; // Should not be used.
        this_cylinder_volume.geometry.is_exit_volume = 1;
        sprintf(this_cylinder_volume.p_physics->name,"Exit");
    } else {
        for (loop_index=0;loop_index<global_material_list.num_elements;loop_index++) {
          if (0 == strcmp(material_string,global_material_list.elements[loop_index].name)) {
            this_cylinder_volume.p_physics = global_material_list.elements[loop_index].physics;
            break;
          }
          if (loop_index == global_material_list.num_elements-1) {
            printf("\n");
            printf("ERROR: The material string \"%s\" in Union geometry \"%s\" did not match a specified material. \n",material_string,NAME_CURRENT_COMP);
            printf("       The materials available at this point (need to be defined before the geometry): \n");
            for (loop_index=0;loop_index<global_material_list.num_elements;loop_index++)
              printf("         %s\n",global_material_list.elements[loop_index].name);
            printf("\n");
            printf("       It is also possible to use one of the defualt materials avaiable: \n");
            printf("           Vacuum (for a Volume without scattering or absorption)\n");
            printf("           Exit (for a Volume where the ray exits the component if it enters)\n");
            printf("           Mask (for a Volume that masks existing volumes specified in the mask_string\n");
            exit(1);
          }
        }
    }
} else {
    // Automatic linking, simply using the last defined material.
    #ifndef MATERIAL_DETECTOR
        printf("Need to define a material before the geometry to use automatic linking %s.\n",NAME_CURRENT_COMP);
        exit(1);
    #endif
    this_cylinder_volume.p_physics = global_material_list.elements[global_material_list.num_elements-1].physics;
}

sprintf(this_cylinder_volume.name,NAME_CURRENT_COMP);
sprintf(this_cylinder_volume.geometry.shape,"cylinder");
this_cylinder_volume.geometry.priority_value = priority;
// Currently the coordinates will be in absolute space.
this_cylinder_volume.geometry.center = POS_A_CURRENT_COMP;

this_cylinder_volume.geometry.geometry_p_interact = p_interact;
this_cylinder_storage.cyl_radius = radius;
this_cylinder_storage.height = yheight;
this_cylinder_volume.geometry.visualization_on = visualize;
this_cylinder_volume.geometry.geometry_parameters.p_cylinder_storage = &this_cylinder_storage;
this_cylinder_volume.geometry.within_function = &r_within_cylinder;
this_cylinder_volume.geometry.intersect_function = &sample_cylinder_intersect;
this_cylinder_volume.geometry.mcdisplay_function = &mcdisplay_cylinder_function;
this_cylinder_volume.geometry.shell_points = &cylinder_shell_points;
this_cylinder_volume.geometry.initialize_from_main_function = &initialize_cylinder_geometry_from_main_component;
this_cylinder_volume.geometry.process_rot_allocated = 0;
this_cylinder_volume.geometry.copy_geometry_parameters = &allocate_cylinder_storage_copy;

rot_copy(this_cylinder_volume.geometry.rotation_matrix,ROT_A_CURRENT_COMP);
rot_transpose(ROT_A_CURRENT_COMP,this_cylinder_volume.geometry.transpose_rotation_matrix);

// Initialize loggers
this_cylinder_volume.loggers.num_elements = 0;

// packing the information into the global_geometry_element, which is then included in the global_geometry_list.
sprintf(global_geometry_element.name,NAME_CURRENT_COMP);
global_geometry_element.activation_counter = number_of_activations;
global_geometry_element.component_index = INDEX_CURRENT_COMP;
global_geometry_element.Volume = &this_cylinder_volume; // Would be nicer if this m was a pointer, now we have the (small) data two places
add_element_to_geometry_list(&global_geometry_list,global_geometry_element);
}
#line 159227 "MACS_sample_kidney_box.c"
#undef number_of_activations
#undef mask_setting
#undef mask_string
#undef p_interact
#undef focus_r
#undef focus_xh
#undef focus_xw
#undef focus_ah
#undef focus_aw
#undef target_z
#undef target_y
#undef target_x
#undef target_index
#undef visualize
#undef yheight
#undef radius
#undef priority
#undef material_string
#undef this_cylinder_storage
#undef global_geometry_element
#undef this_cylinder_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

  /* Initializations for component sample_rod_collar_3_vacuum. */
  SIG_MESSAGE("sample_rod_collar_3_vacuum (Init)");
#define mccompcurname  sample_rod_collar_3_vacuum
#define mccompcurtype  Union_cylinder
#define mccompcurindex 42
#define loop_index mccsample_rod_collar_3_vacuum_loop_index
#define this_cylinder_volume mccsample_rod_collar_3_vacuum_this_cylinder_volume
#define global_geometry_element mccsample_rod_collar_3_vacuum_global_geometry_element
#define this_cylinder_storage mccsample_rod_collar_3_vacuum_this_cylinder_storage
#define material_string mccsample_rod_collar_3_vacuum_material_string
#define priority mccsample_rod_collar_3_vacuum_priority
#define radius mccsample_rod_collar_3_vacuum_radius
#define yheight mccsample_rod_collar_3_vacuum_yheight
#define visualize mccsample_rod_collar_3_vacuum_visualize
#define target_index mccsample_rod_collar_3_vacuum_target_index
#define target_x mccsample_rod_collar_3_vacuum_target_x
#define target_y mccsample_rod_collar_3_vacuum_target_y
#define target_z mccsample_rod_collar_3_vacuum_target_z
#define focus_aw mccsample_rod_collar_3_vacuum_focus_aw
#define focus_ah mccsample_rod_collar_3_vacuum_focus_ah
#define focus_xw mccsample_rod_collar_3_vacuum_focus_xw
#define focus_xh mccsample_rod_collar_3_vacuum_focus_xh
#define focus_r mccsample_rod_collar_3_vacuum_focus_r
#define p_interact mccsample_rod_collar_3_vacuum_p_interact
#define mask_string mccsample_rod_collar_3_vacuum_mask_string
#define mask_setting mccsample_rod_collar_3_vacuum_mask_setting
#define number_of_activations mccsample_rod_collar_3_vacuum_number_of_activations
#line 185 "Union_cylinder.comp"
{
// Initializes the focusing system for this volume including input sanitation.
focus_initialize(&this_cylinder_volume.geometry, POS_A_COMP_INDEX(INDEX_CURRENT_COMP+target_index), POS_A_CURRENT_COMP, ROT_A_CURRENT_COMP, target_index, target_x, target_y, target_z, focus_aw, focus_ah, focus_xw, focus_xh, focus_r, NAME_CURRENT_COMP);

// Input sanitation for this geometry
if (radius <= 0) {
  printf("\nERROR in Union_cylinder named %s, the radius is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}

if (yheight <= 0) {
  printf("\nERROR in Union_cylinder named %s, yheight is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}

// Use sanitation
#ifdef MATERIAL_DETECTOR
if (global_material_list.num_elements == 0) {
  // Here if the user have defined a material, but only after this material
  printf("\nERROR: Need to define a material using Union_make_material before using a Union geometry component. \n");
  printf("       %s was defined before first use of Union_make_material.\n",NAME_CURRENT_COMP);
  exit(1);
}
#endif
#ifndef MATERIAL_DETECTOR
  printf("\nERROR: Need to define a material using Union_make_material before using a Union geometry component. \n");
  exit(1);
#endif


this_cylinder_volume.geometry.is_masked_volume = 0;
this_cylinder_volume.geometry.is_exit_volume = 0;
this_cylinder_volume.geometry.is_mask_volume = 0;

// Read the material input, or if it lacks, use automatic linking.
if (mask_string && strlen(mask_string) && strcmp(mask_string, "NULL") && strcmp(mask_string, "0")) {
    // A mask volume is used to limit the extend of other volumes, called the masked volumes. These are specified in the mask_string.
    // In order for a ray to enter a masked volume, it needs to be both in the region covered by that volume AND the mask volume.
    // When more than
    this_cylinder_volume.geometry.mask_mode = 1; // Default is mask mode is ALL
    if (mask_setting && strlen(mask_setting) && strcmp(mask_setting, "NULL") && strcmp(mask_setting, "0")) {
        if (strcmp(mask_setting,"ALL") == 0 || strcmp(mask_setting,"All") == 0) this_cylinder_volume.geometry.mask_mode = 1;
        else if (strcmp(mask_setting,"ANY") == 0 || strcmp(mask_setting,"Any") == 0) this_cylinder_volume.geometry.mask_mode = 2;
        else {
            printf("The mask_mode of component %s is set to %s, but must be either ALL or ANY.\n",NAME_CURRENT_COMP,mask_setting);
            exit(1);
        }
    }
    
    for (loop_index=0;loop_index<global_geometry_list.num_elements;loop_index++) {
        // Add mask list
        if (1 == manual_linking_function(global_geometry_list.elements[loop_index].name,mask_string)) {
            add_element_to_int_list(&this_cylinder_volume.geometry.mask_list,global_geometry_list.elements[loop_index].component_index);
            add_element_to_int_list(&global_geometry_list.elements[loop_index].Volume->geometry.masked_by_list,INDEX_CURRENT_COMP);
            global_geometry_list.elements[loop_index].Volume->geometry.is_masked_volume = 1;
            if (this_cylinder_volume.geometry.mask_mode == 2)
                global_geometry_list.elements[loop_index].Volume->geometry.mask_mode = 2;
            if (this_cylinder_volume.geometry.mask_mode == 1) {
                if (global_geometry_list.elements[loop_index].Volume->geometry.is_masked_volume == 1 && global_geometry_list.elements[loop_index].Volume->geometry.mask_mode != 2)
                    // If more than one mask is added to one volume, the ANY mode overwrites the (default) ALL mode.
                    global_geometry_list.elements[loop_index].Volume->geometry.mask_mode = 1;
            }
            
            found_geometries = 1;
        }
    }
    if (found_geometries == 0) {
        printf("The mask_string in geometry: %s did not find any of the specified volumes in the mask_string %s \n",NAME_CURRENT_COMP,mask_string);
        exit(1);
    }
    this_cylinder_volume.p_physics = malloc(sizeof(struct physics_struct));
    this_cylinder_volume.p_physics->is_vacuum = 0; // Makes this volume a vacuum
    this_cylinder_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
    this_cylinder_volume.p_physics->my_a = 0; // Should not be used.
    sprintf(this_cylinder_volume.p_physics->name,"Mask");
    this_cylinder_volume.geometry.is_mask_volume = 1;
    
    
// Read the material input, or if it lacks, use automatic linking.
} else if (material_string && strlen(material_string) && strcmp(material_string, "NULL") && strcmp(material_string, "0")) {
    // A geometry string was given, use it to determine which material
    if (0 == strcmp(material_string,"vacuum") || 0 == strcmp(material_string,"Vacuum")) {
        // One could have a global physics struct for vacuum instead of creating one for each
        this_cylinder_volume.p_physics = malloc(sizeof(struct physics_struct));
        this_cylinder_volume.p_physics->is_vacuum = 1; // Makes this volume a vacuum
        this_cylinder_volume.p_physics->number_of_processes = (int) 0;
        this_cylinder_volume.p_physics->my_a = 0; // Should not be used.
        sprintf(this_cylinder_volume.p_physics->name,"Vacuum");
    } else if (0 == strcmp(material_string,"exit") || 0 == strcmp(material_string,"Exit")) {
        // One could have a global physics struct for exit instead of creating one for each
        this_cylinder_volume.p_physics = malloc(sizeof(struct physics_struct));
        this_cylinder_volume.p_physics->is_vacuum = 1; // Makes this volume a vacuum
        this_cylinder_volume.p_physics->number_of_processes = (int) 0;
        this_cylinder_volume.p_physics->my_a = 0; // Should not be used.
        this_cylinder_volume.geometry.is_exit_volume = 1;
        sprintf(this_cylinder_volume.p_physics->name,"Exit");
    } else {
        for (loop_index=0;loop_index<global_material_list.num_elements;loop_index++) {
          if (0 == strcmp(material_string,global_material_list.elements[loop_index].name)) {
            this_cylinder_volume.p_physics = global_material_list.elements[loop_index].physics;
            break;
          }
          if (loop_index == global_material_list.num_elements-1) {
            printf("\n");
            printf("ERROR: The material string \"%s\" in Union geometry \"%s\" did not match a specified material. \n",material_string,NAME_CURRENT_COMP);
            printf("       The materials available at this point (need to be defined before the geometry): \n");
            for (loop_index=0;loop_index<global_material_list.num_elements;loop_index++)
              printf("         %s\n",global_material_list.elements[loop_index].name);
            printf("\n");
            printf("       It is also possible to use one of the defualt materials avaiable: \n");
            printf("           Vacuum (for a Volume without scattering or absorption)\n");
            printf("           Exit (for a Volume where the ray exits the component if it enters)\n");
            printf("           Mask (for a Volume that masks existing volumes specified in the mask_string\n");
            exit(1);
          }
        }
    }
} else {
    // Automatic linking, simply using the last defined material.
    #ifndef MATERIAL_DETECTOR
        printf("Need to define a material before the geometry to use automatic linking %s.\n",NAME_CURRENT_COMP);
        exit(1);
    #endif
    this_cylinder_volume.p_physics = global_material_list.elements[global_material_list.num_elements-1].physics;
}

sprintf(this_cylinder_volume.name,NAME_CURRENT_COMP);
sprintf(this_cylinder_volume.geometry.shape,"cylinder");
this_cylinder_volume.geometry.priority_value = priority;
// Currently the coordinates will be in absolute space.
this_cylinder_volume.geometry.center = POS_A_CURRENT_COMP;

this_cylinder_volume.geometry.geometry_p_interact = p_interact;
this_cylinder_storage.cyl_radius = radius;
this_cylinder_storage.height = yheight;
this_cylinder_volume.geometry.visualization_on = visualize;
this_cylinder_volume.geometry.geometry_parameters.p_cylinder_storage = &this_cylinder_storage;
this_cylinder_volume.geometry.within_function = &r_within_cylinder;
this_cylinder_volume.geometry.intersect_function = &sample_cylinder_intersect;
this_cylinder_volume.geometry.mcdisplay_function = &mcdisplay_cylinder_function;
this_cylinder_volume.geometry.shell_points = &cylinder_shell_points;
this_cylinder_volume.geometry.initialize_from_main_function = &initialize_cylinder_geometry_from_main_component;
this_cylinder_volume.geometry.process_rot_allocated = 0;
this_cylinder_volume.geometry.copy_geometry_parameters = &allocate_cylinder_storage_copy;

rot_copy(this_cylinder_volume.geometry.rotation_matrix,ROT_A_CURRENT_COMP);
rot_transpose(ROT_A_CURRENT_COMP,this_cylinder_volume.geometry.transpose_rotation_matrix);

// Initialize loggers
this_cylinder_volume.loggers.num_elements = 0;

// packing the information into the global_geometry_element, which is then included in the global_geometry_list.
sprintf(global_geometry_element.name,NAME_CURRENT_COMP);
global_geometry_element.activation_counter = number_of_activations;
global_geometry_element.component_index = INDEX_CURRENT_COMP;
global_geometry_element.Volume = &this_cylinder_volume; // Would be nicer if this m was a pointer, now we have the (small) data two places
add_element_to_geometry_list(&global_geometry_list,global_geometry_element);
}
#line 159440 "MACS_sample_kidney_box.c"
#undef number_of_activations
#undef mask_setting
#undef mask_string
#undef p_interact
#undef focus_r
#undef focus_xh
#undef focus_xw
#undef focus_ah
#undef focus_aw
#undef target_z
#undef target_y
#undef target_x
#undef target_index
#undef visualize
#undef yheight
#undef radius
#undef priority
#undef material_string
#undef this_cylinder_storage
#undef global_geometry_element
#undef this_cylinder_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

  /* Initializations for component sample_rod_collar_4_vacuum. */
  SIG_MESSAGE("sample_rod_collar_4_vacuum (Init)");
#define mccompcurname  sample_rod_collar_4_vacuum
#define mccompcurtype  Union_cylinder
#define mccompcurindex 43
#define loop_index mccsample_rod_collar_4_vacuum_loop_index
#define this_cylinder_volume mccsample_rod_collar_4_vacuum_this_cylinder_volume
#define global_geometry_element mccsample_rod_collar_4_vacuum_global_geometry_element
#define this_cylinder_storage mccsample_rod_collar_4_vacuum_this_cylinder_storage
#define material_string mccsample_rod_collar_4_vacuum_material_string
#define priority mccsample_rod_collar_4_vacuum_priority
#define radius mccsample_rod_collar_4_vacuum_radius
#define yheight mccsample_rod_collar_4_vacuum_yheight
#define visualize mccsample_rod_collar_4_vacuum_visualize
#define target_index mccsample_rod_collar_4_vacuum_target_index
#define target_x mccsample_rod_collar_4_vacuum_target_x
#define target_y mccsample_rod_collar_4_vacuum_target_y
#define target_z mccsample_rod_collar_4_vacuum_target_z
#define focus_aw mccsample_rod_collar_4_vacuum_focus_aw
#define focus_ah mccsample_rod_collar_4_vacuum_focus_ah
#define focus_xw mccsample_rod_collar_4_vacuum_focus_xw
#define focus_xh mccsample_rod_collar_4_vacuum_focus_xh
#define focus_r mccsample_rod_collar_4_vacuum_focus_r
#define p_interact mccsample_rod_collar_4_vacuum_p_interact
#define mask_string mccsample_rod_collar_4_vacuum_mask_string
#define mask_setting mccsample_rod_collar_4_vacuum_mask_setting
#define number_of_activations mccsample_rod_collar_4_vacuum_number_of_activations
#line 185 "Union_cylinder.comp"
{
// Initializes the focusing system for this volume including input sanitation.
focus_initialize(&this_cylinder_volume.geometry, POS_A_COMP_INDEX(INDEX_CURRENT_COMP+target_index), POS_A_CURRENT_COMP, ROT_A_CURRENT_COMP, target_index, target_x, target_y, target_z, focus_aw, focus_ah, focus_xw, focus_xh, focus_r, NAME_CURRENT_COMP);

// Input sanitation for this geometry
if (radius <= 0) {
  printf("\nERROR in Union_cylinder named %s, the radius is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}

if (yheight <= 0) {
  printf("\nERROR in Union_cylinder named %s, yheight is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}

// Use sanitation
#ifdef MATERIAL_DETECTOR
if (global_material_list.num_elements == 0) {
  // Here if the user have defined a material, but only after this material
  printf("\nERROR: Need to define a material using Union_make_material before using a Union geometry component. \n");
  printf("       %s was defined before first use of Union_make_material.\n",NAME_CURRENT_COMP);
  exit(1);
}
#endif
#ifndef MATERIAL_DETECTOR
  printf("\nERROR: Need to define a material using Union_make_material before using a Union geometry component. \n");
  exit(1);
#endif


this_cylinder_volume.geometry.is_masked_volume = 0;
this_cylinder_volume.geometry.is_exit_volume = 0;
this_cylinder_volume.geometry.is_mask_volume = 0;

// Read the material input, or if it lacks, use automatic linking.
if (mask_string && strlen(mask_string) && strcmp(mask_string, "NULL") && strcmp(mask_string, "0")) {
    // A mask volume is used to limit the extend of other volumes, called the masked volumes. These are specified in the mask_string.
    // In order for a ray to enter a masked volume, it needs to be both in the region covered by that volume AND the mask volume.
    // When more than
    this_cylinder_volume.geometry.mask_mode = 1; // Default is mask mode is ALL
    if (mask_setting && strlen(mask_setting) && strcmp(mask_setting, "NULL") && strcmp(mask_setting, "0")) {
        if (strcmp(mask_setting,"ALL") == 0 || strcmp(mask_setting,"All") == 0) this_cylinder_volume.geometry.mask_mode = 1;
        else if (strcmp(mask_setting,"ANY") == 0 || strcmp(mask_setting,"Any") == 0) this_cylinder_volume.geometry.mask_mode = 2;
        else {
            printf("The mask_mode of component %s is set to %s, but must be either ALL or ANY.\n",NAME_CURRENT_COMP,mask_setting);
            exit(1);
        }
    }
    
    for (loop_index=0;loop_index<global_geometry_list.num_elements;loop_index++) {
        // Add mask list
        if (1 == manual_linking_function(global_geometry_list.elements[loop_index].name,mask_string)) {
            add_element_to_int_list(&this_cylinder_volume.geometry.mask_list,global_geometry_list.elements[loop_index].component_index);
            add_element_to_int_list(&global_geometry_list.elements[loop_index].Volume->geometry.masked_by_list,INDEX_CURRENT_COMP);
            global_geometry_list.elements[loop_index].Volume->geometry.is_masked_volume = 1;
            if (this_cylinder_volume.geometry.mask_mode == 2)
                global_geometry_list.elements[loop_index].Volume->geometry.mask_mode = 2;
            if (this_cylinder_volume.geometry.mask_mode == 1) {
                if (global_geometry_list.elements[loop_index].Volume->geometry.is_masked_volume == 1 && global_geometry_list.elements[loop_index].Volume->geometry.mask_mode != 2)
                    // If more than one mask is added to one volume, the ANY mode overwrites the (default) ALL mode.
                    global_geometry_list.elements[loop_index].Volume->geometry.mask_mode = 1;
            }
            
            found_geometries = 1;
        }
    }
    if (found_geometries == 0) {
        printf("The mask_string in geometry: %s did not find any of the specified volumes in the mask_string %s \n",NAME_CURRENT_COMP,mask_string);
        exit(1);
    }
    this_cylinder_volume.p_physics = malloc(sizeof(struct physics_struct));
    this_cylinder_volume.p_physics->is_vacuum = 0; // Makes this volume a vacuum
    this_cylinder_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
    this_cylinder_volume.p_physics->my_a = 0; // Should not be used.
    sprintf(this_cylinder_volume.p_physics->name,"Mask");
    this_cylinder_volume.geometry.is_mask_volume = 1;
    
    
// Read the material input, or if it lacks, use automatic linking.
} else if (material_string && strlen(material_string) && strcmp(material_string, "NULL") && strcmp(material_string, "0")) {
    // A geometry string was given, use it to determine which material
    if (0 == strcmp(material_string,"vacuum") || 0 == strcmp(material_string,"Vacuum")) {
        // One could have a global physics struct for vacuum instead of creating one for each
        this_cylinder_volume.p_physics = malloc(sizeof(struct physics_struct));
        this_cylinder_volume.p_physics->is_vacuum = 1; // Makes this volume a vacuum
        this_cylinder_volume.p_physics->number_of_processes = (int) 0;
        this_cylinder_volume.p_physics->my_a = 0; // Should not be used.
        sprintf(this_cylinder_volume.p_physics->name,"Vacuum");
    } else if (0 == strcmp(material_string,"exit") || 0 == strcmp(material_string,"Exit")) {
        // One could have a global physics struct for exit instead of creating one for each
        this_cylinder_volume.p_physics = malloc(sizeof(struct physics_struct));
        this_cylinder_volume.p_physics->is_vacuum = 1; // Makes this volume a vacuum
        this_cylinder_volume.p_physics->number_of_processes = (int) 0;
        this_cylinder_volume.p_physics->my_a = 0; // Should not be used.
        this_cylinder_volume.geometry.is_exit_volume = 1;
        sprintf(this_cylinder_volume.p_physics->name,"Exit");
    } else {
        for (loop_index=0;loop_index<global_material_list.num_elements;loop_index++) {
          if (0 == strcmp(material_string,global_material_list.elements[loop_index].name)) {
            this_cylinder_volume.p_physics = global_material_list.elements[loop_index].physics;
            break;
          }
          if (loop_index == global_material_list.num_elements-1) {
            printf("\n");
            printf("ERROR: The material string \"%s\" in Union geometry \"%s\" did not match a specified material. \n",material_string,NAME_CURRENT_COMP);
            printf("       The materials available at this point (need to be defined before the geometry): \n");
            for (loop_index=0;loop_index<global_material_list.num_elements;loop_index++)
              printf("         %s\n",global_material_list.elements[loop_index].name);
            printf("\n");
            printf("       It is also possible to use one of the defualt materials avaiable: \n");
            printf("           Vacuum (for a Volume without scattering or absorption)\n");
            printf("           Exit (for a Volume where the ray exits the component if it enters)\n");
            printf("           Mask (for a Volume that masks existing volumes specified in the mask_string\n");
            exit(1);
          }
        }
    }
} else {
    // Automatic linking, simply using the last defined material.
    #ifndef MATERIAL_DETECTOR
        printf("Need to define a material before the geometry to use automatic linking %s.\n",NAME_CURRENT_COMP);
        exit(1);
    #endif
    this_cylinder_volume.p_physics = global_material_list.elements[global_material_list.num_elements-1].physics;
}

sprintf(this_cylinder_volume.name,NAME_CURRENT_COMP);
sprintf(this_cylinder_volume.geometry.shape,"cylinder");
this_cylinder_volume.geometry.priority_value = priority;
// Currently the coordinates will be in absolute space.
this_cylinder_volume.geometry.center = POS_A_CURRENT_COMP;

this_cylinder_volume.geometry.geometry_p_interact = p_interact;
this_cylinder_storage.cyl_radius = radius;
this_cylinder_storage.height = yheight;
this_cylinder_volume.geometry.visualization_on = visualize;
this_cylinder_volume.geometry.geometry_parameters.p_cylinder_storage = &this_cylinder_storage;
this_cylinder_volume.geometry.within_function = &r_within_cylinder;
this_cylinder_volume.geometry.intersect_function = &sample_cylinder_intersect;
this_cylinder_volume.geometry.mcdisplay_function = &mcdisplay_cylinder_function;
this_cylinder_volume.geometry.shell_points = &cylinder_shell_points;
this_cylinder_volume.geometry.initialize_from_main_function = &initialize_cylinder_geometry_from_main_component;
this_cylinder_volume.geometry.process_rot_allocated = 0;
this_cylinder_volume.geometry.copy_geometry_parameters = &allocate_cylinder_storage_copy;

rot_copy(this_cylinder_volume.geometry.rotation_matrix,ROT_A_CURRENT_COMP);
rot_transpose(ROT_A_CURRENT_COMP,this_cylinder_volume.geometry.transpose_rotation_matrix);

// Initialize loggers
this_cylinder_volume.loggers.num_elements = 0;

// packing the information into the global_geometry_element, which is then included in the global_geometry_list.
sprintf(global_geometry_element.name,NAME_CURRENT_COMP);
global_geometry_element.activation_counter = number_of_activations;
global_geometry_element.component_index = INDEX_CURRENT_COMP;
global_geometry_element.Volume = &this_cylinder_volume; // Would be nicer if this m was a pointer, now we have the (small) data two places
add_element_to_geometry_list(&global_geometry_list,global_geometry_element);
}
#line 159653 "MACS_sample_kidney_box.c"
#undef number_of_activations
#undef mask_setting
#undef mask_string
#undef p_interact
#undef focus_r
#undef focus_xh
#undef focus_xw
#undef focus_ah
#undef focus_aw
#undef target_z
#undef target_y
#undef target_x
#undef target_index
#undef visualize
#undef yheight
#undef radius
#undef priority
#undef material_string
#undef this_cylinder_storage
#undef global_geometry_element
#undef this_cylinder_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

  /* Initializations for component resolution_sample_exit. */
  SIG_MESSAGE("resolution_sample_exit (Init)");
#define mccompcurname  resolution_sample_exit
#define mccompcurtype  Union_cylinder
#define mccompcurindex 44
#define loop_index mccresolution_sample_exit_loop_index
#define this_cylinder_volume mccresolution_sample_exit_this_cylinder_volume
#define global_geometry_element mccresolution_sample_exit_global_geometry_element
#define this_cylinder_storage mccresolution_sample_exit_this_cylinder_storage
#define material_string mccresolution_sample_exit_material_string
#define priority mccresolution_sample_exit_priority
#define radius mccresolution_sample_exit_radius
#define yheight mccresolution_sample_exit_yheight
#define visualize mccresolution_sample_exit_visualize
#define target_index mccresolution_sample_exit_target_index
#define target_x mccresolution_sample_exit_target_x
#define target_y mccresolution_sample_exit_target_y
#define target_z mccresolution_sample_exit_target_z
#define focus_aw mccresolution_sample_exit_focus_aw
#define focus_ah mccresolution_sample_exit_focus_ah
#define focus_xw mccresolution_sample_exit_focus_xw
#define focus_xh mccresolution_sample_exit_focus_xh
#define focus_r mccresolution_sample_exit_focus_r
#define p_interact mccresolution_sample_exit_p_interact
#define mask_string mccresolution_sample_exit_mask_string
#define mask_setting mccresolution_sample_exit_mask_setting
#define number_of_activations mccresolution_sample_exit_number_of_activations
#line 185 "Union_cylinder.comp"
{
// Initializes the focusing system for this volume including input sanitation.
focus_initialize(&this_cylinder_volume.geometry, POS_A_COMP_INDEX(INDEX_CURRENT_COMP+target_index), POS_A_CURRENT_COMP, ROT_A_CURRENT_COMP, target_index, target_x, target_y, target_z, focus_aw, focus_ah, focus_xw, focus_xh, focus_r, NAME_CURRENT_COMP);

// Input sanitation for this geometry
if (radius <= 0) {
  printf("\nERROR in Union_cylinder named %s, the radius is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}

if (yheight <= 0) {
  printf("\nERROR in Union_cylinder named %s, yheight is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}

// Use sanitation
#ifdef MATERIAL_DETECTOR
if (global_material_list.num_elements == 0) {
  // Here if the user have defined a material, but only after this material
  printf("\nERROR: Need to define a material using Union_make_material before using a Union geometry component. \n");
  printf("       %s was defined before first use of Union_make_material.\n",NAME_CURRENT_COMP);
  exit(1);
}
#endif
#ifndef MATERIAL_DETECTOR
  printf("\nERROR: Need to define a material using Union_make_material before using a Union geometry component. \n");
  exit(1);
#endif


this_cylinder_volume.geometry.is_masked_volume = 0;
this_cylinder_volume.geometry.is_exit_volume = 0;
this_cylinder_volume.geometry.is_mask_volume = 0;

// Read the material input, or if it lacks, use automatic linking.
if (mask_string && strlen(mask_string) && strcmp(mask_string, "NULL") && strcmp(mask_string, "0")) {
    // A mask volume is used to limit the extend of other volumes, called the masked volumes. These are specified in the mask_string.
    // In order for a ray to enter a masked volume, it needs to be both in the region covered by that volume AND the mask volume.
    // When more than
    this_cylinder_volume.geometry.mask_mode = 1; // Default is mask mode is ALL
    if (mask_setting && strlen(mask_setting) && strcmp(mask_setting, "NULL") && strcmp(mask_setting, "0")) {
        if (strcmp(mask_setting,"ALL") == 0 || strcmp(mask_setting,"All") == 0) this_cylinder_volume.geometry.mask_mode = 1;
        else if (strcmp(mask_setting,"ANY") == 0 || strcmp(mask_setting,"Any") == 0) this_cylinder_volume.geometry.mask_mode = 2;
        else {
            printf("The mask_mode of component %s is set to %s, but must be either ALL or ANY.\n",NAME_CURRENT_COMP,mask_setting);
            exit(1);
        }
    }
    
    for (loop_index=0;loop_index<global_geometry_list.num_elements;loop_index++) {
        // Add mask list
        if (1 == manual_linking_function(global_geometry_list.elements[loop_index].name,mask_string)) {
            add_element_to_int_list(&this_cylinder_volume.geometry.mask_list,global_geometry_list.elements[loop_index].component_index);
            add_element_to_int_list(&global_geometry_list.elements[loop_index].Volume->geometry.masked_by_list,INDEX_CURRENT_COMP);
            global_geometry_list.elements[loop_index].Volume->geometry.is_masked_volume = 1;
            if (this_cylinder_volume.geometry.mask_mode == 2)
                global_geometry_list.elements[loop_index].Volume->geometry.mask_mode = 2;
            if (this_cylinder_volume.geometry.mask_mode == 1) {
                if (global_geometry_list.elements[loop_index].Volume->geometry.is_masked_volume == 1 && global_geometry_list.elements[loop_index].Volume->geometry.mask_mode != 2)
                    // If more than one mask is added to one volume, the ANY mode overwrites the (default) ALL mode.
                    global_geometry_list.elements[loop_index].Volume->geometry.mask_mode = 1;
            }
            
            found_geometries = 1;
        }
    }
    if (found_geometries == 0) {
        printf("The mask_string in geometry: %s did not find any of the specified volumes in the mask_string %s \n",NAME_CURRENT_COMP,mask_string);
        exit(1);
    }
    this_cylinder_volume.p_physics = malloc(sizeof(struct physics_struct));
    this_cylinder_volume.p_physics->is_vacuum = 0; // Makes this volume a vacuum
    this_cylinder_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
    this_cylinder_volume.p_physics->my_a = 0; // Should not be used.
    sprintf(this_cylinder_volume.p_physics->name,"Mask");
    this_cylinder_volume.geometry.is_mask_volume = 1;
    
    
// Read the material input, or if it lacks, use automatic linking.
} else if (material_string && strlen(material_string) && strcmp(material_string, "NULL") && strcmp(material_string, "0")) {
    // A geometry string was given, use it to determine which material
    if (0 == strcmp(material_string,"vacuum") || 0 == strcmp(material_string,"Vacuum")) {
        // One could have a global physics struct for vacuum instead of creating one for each
        this_cylinder_volume.p_physics = malloc(sizeof(struct physics_struct));
        this_cylinder_volume.p_physics->is_vacuum = 1; // Makes this volume a vacuum
        this_cylinder_volume.p_physics->number_of_processes = (int) 0;
        this_cylinder_volume.p_physics->my_a = 0; // Should not be used.
        sprintf(this_cylinder_volume.p_physics->name,"Vacuum");
    } else if (0 == strcmp(material_string,"exit") || 0 == strcmp(material_string,"Exit")) {
        // One could have a global physics struct for exit instead of creating one for each
        this_cylinder_volume.p_physics = malloc(sizeof(struct physics_struct));
        this_cylinder_volume.p_physics->is_vacuum = 1; // Makes this volume a vacuum
        this_cylinder_volume.p_physics->number_of_processes = (int) 0;
        this_cylinder_volume.p_physics->my_a = 0; // Should not be used.
        this_cylinder_volume.geometry.is_exit_volume = 1;
        sprintf(this_cylinder_volume.p_physics->name,"Exit");
    } else {
        for (loop_index=0;loop_index<global_material_list.num_elements;loop_index++) {
          if (0 == strcmp(material_string,global_material_list.elements[loop_index].name)) {
            this_cylinder_volume.p_physics = global_material_list.elements[loop_index].physics;
            break;
          }
          if (loop_index == global_material_list.num_elements-1) {
            printf("\n");
            printf("ERROR: The material string \"%s\" in Union geometry \"%s\" did not match a specified material. \n",material_string,NAME_CURRENT_COMP);
            printf("       The materials available at this point (need to be defined before the geometry): \n");
            for (loop_index=0;loop_index<global_material_list.num_elements;loop_index++)
              printf("         %s\n",global_material_list.elements[loop_index].name);
            printf("\n");
            printf("       It is also possible to use one of the defualt materials avaiable: \n");
            printf("           Vacuum (for a Volume without scattering or absorption)\n");
            printf("           Exit (for a Volume where the ray exits the component if it enters)\n");
            printf("           Mask (for a Volume that masks existing volumes specified in the mask_string\n");
            exit(1);
          }
        }
    }
} else {
    // Automatic linking, simply using the last defined material.
    #ifndef MATERIAL_DETECTOR
        printf("Need to define a material before the geometry to use automatic linking %s.\n",NAME_CURRENT_COMP);
        exit(1);
    #endif
    this_cylinder_volume.p_physics = global_material_list.elements[global_material_list.num_elements-1].physics;
}

sprintf(this_cylinder_volume.name,NAME_CURRENT_COMP);
sprintf(this_cylinder_volume.geometry.shape,"cylinder");
this_cylinder_volume.geometry.priority_value = priority;
// Currently the coordinates will be in absolute space.
this_cylinder_volume.geometry.center = POS_A_CURRENT_COMP;

this_cylinder_volume.geometry.geometry_p_interact = p_interact;
this_cylinder_storage.cyl_radius = radius;
this_cylinder_storage.height = yheight;
this_cylinder_volume.geometry.visualization_on = visualize;
this_cylinder_volume.geometry.geometry_parameters.p_cylinder_storage = &this_cylinder_storage;
this_cylinder_volume.geometry.within_function = &r_within_cylinder;
this_cylinder_volume.geometry.intersect_function = &sample_cylinder_intersect;
this_cylinder_volume.geometry.mcdisplay_function = &mcdisplay_cylinder_function;
this_cylinder_volume.geometry.shell_points = &cylinder_shell_points;
this_cylinder_volume.geometry.initialize_from_main_function = &initialize_cylinder_geometry_from_main_component;
this_cylinder_volume.geometry.process_rot_allocated = 0;
this_cylinder_volume.geometry.copy_geometry_parameters = &allocate_cylinder_storage_copy;

rot_copy(this_cylinder_volume.geometry.rotation_matrix,ROT_A_CURRENT_COMP);
rot_transpose(ROT_A_CURRENT_COMP,this_cylinder_volume.geometry.transpose_rotation_matrix);

// Initialize loggers
this_cylinder_volume.loggers.num_elements = 0;

// packing the information into the global_geometry_element, which is then included in the global_geometry_list.
sprintf(global_geometry_element.name,NAME_CURRENT_COMP);
global_geometry_element.activation_counter = number_of_activations;
global_geometry_element.component_index = INDEX_CURRENT_COMP;
global_geometry_element.Volume = &this_cylinder_volume; // Would be nicer if this m was a pointer, now we have the (small) data two places
add_element_to_geometry_list(&global_geometry_list,global_geometry_element);
}
#line 159866 "MACS_sample_kidney_box.c"
#undef number_of_activations
#undef mask_setting
#undef mask_string
#undef p_interact
#undef focus_r
#undef focus_xh
#undef focus_xw
#undef focus_ah
#undef focus_aw
#undef target_z
#undef target_y
#undef target_x
#undef target_index
#undef visualize
#undef yheight
#undef radius
#undef priority
#undef material_string
#undef this_cylinder_storage
#undef global_geometry_element
#undef this_cylinder_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

  /* Initializations for component sample_cryostat. */
  SIG_MESSAGE("sample_cryostat (Init)");
#define mccompcurname  sample_cryostat
#define mccompcurtype  Union_master
#define mccompcurindex 45
#define verbal mccsample_cryostat_verbal
#define list_verbal mccsample_cryostat_list_verbal
#define trace_verbal mccsample_cryostat_trace_verbal
#define finally_verbal mccsample_cryostat_finally_verbal
#define starting_volume_warning mccsample_cryostat_starting_volume_warning
#define global_master_element mccsample_cryostat_global_master_element
#define this_global_master_index mccsample_cryostat_this_global_master_index
#define previous_master_index mccsample_cryostat_previous_master_index
#define geometry_list_index mccsample_cryostat_geometry_list_index
#define intersection_time_table mccsample_cryostat_intersection_time_table
#define Volumes mccsample_cryostat_Volumes
#define Geometries mccsample_cryostat_Geometries
#define starting_lists mccsample_cryostat_starting_lists
#define r mccsample_cryostat_r
#define r_start mccsample_cryostat_r_start
#define v mccsample_cryostat_v
#define error_msg mccsample_cryostat_error_msg
#define component_error_msg mccsample_cryostat_component_error_msg
#define string_output mccsample_cryostat_string_output
#define number_of_volumes mccsample_cryostat_number_of_volumes
#define volume_index mccsample_cryostat_volume_index
#define process_index mccsample_cryostat_process_index
#define solutions mccsample_cryostat_solutions
#define max_number_of_processes mccsample_cryostat_max_number_of_processes
#define limit mccsample_cryostat_limit
#define solution mccsample_cryostat_solution
#define min_solution mccsample_cryostat_min_solution
#define min_volume mccsample_cryostat_min_volume
#define time_found mccsample_cryostat_time_found
#define intersection_time mccsample_cryostat_intersection_time
#define min_intersection_time mccsample_cryostat_min_intersection_time
#define process mccsample_cryostat_process
#define process_start mccsample_cryostat_process_start
#define my_trace mccsample_cryostat_my_trace
#define p_my_trace mccsample_cryostat_p_my_trace
#define my_trace_fraction_control mccsample_cryostat_my_trace_fraction_control
#define k mccsample_cryostat_k
#define k_new mccsample_cryostat_k_new
#define k_old mccsample_cryostat_k_old
#define v_length mccsample_cryostat_v_length
#define my_sum mccsample_cryostat_my_sum
#define my_sum_plus_abs mccsample_cryostat_my_sum_plus_abs
#define culmative_probability mccsample_cryostat_culmative_probability
#define mc_prop mccsample_cryostat_mc_prop
#define time_to_scattering mccsample_cryostat_time_to_scattering
#define length_to_scattering mccsample_cryostat_length_to_scattering
#define length_to_boundery mccsample_cryostat_length_to_boundery
#define time_to_boundery mccsample_cryostat_time_to_boundery
#define selected_process mccsample_cryostat_selected_process
#define scattering_event mccsample_cryostat_scattering_event
#define time_propagated_without_scattering mccsample_cryostat_time_propagated_without_scattering
#define a_next_volume_found mccsample_cryostat_a_next_volume_found
#define next_volume mccsample_cryostat_next_volume
#define next_volume_priority mccsample_cryostat_next_volume_priority
#define done mccsample_cryostat_done
#define current_volume mccsample_cryostat_current_volume
#define number_of_solutions mccsample_cryostat_number_of_solutions
#define number_of_solutions_static mccsample_cryostat_number_of_solutions_static
#define check mccsample_cryostat_check
#define start mccsample_cryostat_start
#define intersection_with_children mccsample_cryostat_intersection_with_children
#define geometry_output mccsample_cryostat_geometry_output
#define tree_next_volume mccsample_cryostat_tree_next_volume
#define pre_allocated1 mccsample_cryostat_pre_allocated1
#define pre_allocated2 mccsample_cryostat_pre_allocated2
#define pre_allocated3 mccsample_cryostat_pre_allocated3
#define ray_position mccsample_cryostat_ray_position
#define ray_velocity mccsample_cryostat_ray_velocity
#define ray_velocity_final mccsample_cryostat_ray_velocity_final
#define volume_0_found mccsample_cryostat_volume_0_found
#define scattered_flag mccsample_cryostat_scattered_flag
#define scattered_flag_VP mccsample_cryostat_scattered_flag_VP
#define master_transposed_rotation_matrix mccsample_cryostat_master_transposed_rotation_matrix
#define temp_rotation_matrix mccsample_cryostat_temp_rotation_matrix
#define non_rotated_position mccsample_cryostat_non_rotated_position
#define rotated_position mccsample_cryostat_rotated_position
#define enable_tagging mccsample_cryostat_enable_tagging
#define stop_tagging_ray mccsample_cryostat_stop_tagging_ray
#define stop_creating_nodes mccsample_cryostat_stop_creating_nodes
#define enable_tagging_check mccsample_cryostat_enable_tagging_check
#define master_tagging_node_list mccsample_cryostat_master_tagging_node_list
#define current_tagging_node mccsample_cryostat_current_tagging_node
#define tagging_leaf_counter mccsample_cryostat_tagging_leaf_counter
#define number_of_scattering_events mccsample_cryostat_number_of_scattering_events
#define real_transmission_probability mccsample_cryostat_real_transmission_probability
#define mc_transmission_probability mccsample_cryostat_mc_transmission_probability
#define number_of_masks mccsample_cryostat_number_of_masks
#define number_of_masked_volumes mccsample_cryostat_number_of_masked_volumes
#define need_to_run_within_which_volume mccsample_cryostat_need_to_run_within_which_volume
#define mask_index_main mccsample_cryostat_mask_index_main
#define mask_iterate mccsample_cryostat_mask_iterate
#define mask_status_list mccsample_cryostat_mask_status_list
#define current_mask_intersect_list_status mccsample_cryostat_current_mask_intersect_list_status
#define mask_volume_index_list mccsample_cryostat_mask_volume_index_list
#define geometry_component_index_list mccsample_cryostat_geometry_component_index_list
#define Volume_copies_allocated mccsample_cryostat_Volume_copies_allocated
#define p_old mccsample_cryostat_p_old
#define this_logger mccsample_cryostat_this_logger
#define conditional_status mccsample_cryostat_conditional_status
#define tagging_conditional_list mccsample_cryostat_tagging_conditional_list
#define free_tagging_conditioanl_list mccsample_cryostat_free_tagging_conditioanl_list
#define logger_conditional_extend_array mccsample_cryostat_logger_conditional_extend_array
#define tagging_conditional_extend mccsample_cryostat_tagging_conditional_extend
#define max_conditional_extend_index mccsample_cryostat_max_conditional_extend_index
#define safty_distance mccsample_cryostat_safty_distance
#define safty_distance2 mccsample_cryostat_safty_distance2
#define number_of_processes_array mccsample_cryostat_number_of_processes_array
#define temporary_focus_data mccsample_cryostat_temporary_focus_data
#define focus_data_index mccsample_cryostat_focus_data_index
#define allow_inside_start mccsample_cryostat_allow_inside_start
#define history_limit mccsample_cryostat_history_limit
#define enable_conditionals mccsample_cryostat_enable_conditionals
#define inherit_number_of_scattering_events mccsample_cryostat_inherit_number_of_scattering_events
#line 208 "Union_master.comp"
{
  // Use sanitation
  #ifndef ANY_GEOMETRY_DETECTOR_DECLARE
    printf("\nERROR: Need to define at least one Volume using Union_cylinder or Union_box before using the Union_master component. \n");
    exit(1);
  #endif
  #ifdef ANY_GEOMETRY_DETECTOR_DECLARE
    if (global_geometry_list.num_elements == 0) {
      printf("\nERROR: Need to define at least one Volume using Union_cylinder or Union_box before using the Union_master component. \n");
      printf("       Union_master component named \"%s\" is before any Volumes in the instrument file. At least one Volume need to be defined before\n",NAME_CURRENT_COMP);
    
      exit(1);
    }
  #endif
  
  // Parameters describing the safety distances close to surfaces, as scattering should not occur closer to a surface than the
  //  accuracy of the intersection calculation.
  safty_distance = 1E-11;
  safty_distance2 = safty_distance*2;
  
  // Write information to the global_master_list about the current Union_master
  sprintf(global_master_element.name,NAME_CURRENT_COMP);
  global_master_element.component_index = INDEX_CURRENT_COMP;
  add_element_to_master_list(&global_master_list,global_master_element);
  if (inherit_number_of_scattering_events == 1 && global_master_list.num_elements == 1) {
     printf("ERROR in Union_master with name %s. Inherit_number_of_scattering_events set to 1 for first Union_master component, but there is no preceeding Union_master component. Aborting.\n",NAME_CURRENT_COMP);
     exit(1);
  }
  this_global_master_index = global_master_list.num_elements - 1; // Save the index for this master in global master list
  
  // Set the component index of the previous Union_master component if one exists
  if (global_master_list.num_elements == 1) previous_master_index = 0; // no previous index
  else previous_master_index = global_master_list.elements[global_master_list.num_elements-2].component_index; // -2 because of zero indexing and needing the previous index.
  //printf("Assigned previous_master_index = %d \n",previous_master_index);
  
  // All volumes in the global_geometry_list is being check for activity using the number_of_activations input made for each geometry (default is 1)
  // In addition it is counted how many volumes, mask volumes and masked volumes are active in this Union_master.
  number_of_volumes = 1; // Starting with 1 as the surrounding vacuum is considered a volume
  number_of_masks = 0;   // Starting with 0 mask volumes
  number_of_masked_volumes = 0; // Starting with 0 masked volumes
  for (iterate=0;iterate<global_geometry_list.num_elements;iterate++) {
    if (global_geometry_list.elements[iterate].component_index < INDEX_CURRENT_COMP && global_geometry_list.elements[iterate].activation_counter > 0) {
        global_geometry_list.elements[iterate].active = 1;
        global_geometry_list.elements[iterate].activation_counter--;
        number_of_volumes++;
        if (global_geometry_list.elements[iterate].Volume->geometry.is_mask_volume == 1) number_of_masks++;
        if (global_geometry_list.elements[iterate].Volume->geometry.is_masked_volume == 1) number_of_masked_volumes++;
    } else global_geometry_list.elements[iterate].active = 0;
  }
  //printf("Found number of volumes to be %d \n",number_of_volumes);
  
  // Allocation of global lists
  geometry_component_index_list.num_elements = number_of_volumes;
  geometry_component_index_list.elements = malloc( geometry_component_index_list.num_elements * sizeof(int));
  mask_volume_index_list.num_elements = number_of_masks;
  if (number_of_masks >0) mask_volume_index_list.elements = malloc( number_of_masks * sizeof(int));
  mask_status_list.num_elements = number_of_masks;
  if (number_of_masks >0) mask_status_list.elements = malloc( number_of_masks * sizeof(int));
  current_mask_intersect_list_status.num_elements = number_of_masked_volumes;
  if (number_of_masked_volumes >0) current_mask_intersect_list_status.elements = malloc( number_of_masked_volumes * sizeof(int));
  
  // Make a list of component index from each volume index
  volume_index = 0;
  for (iterate=0;iterate<global_geometry_list.num_elements;iterate++) {
    if (global_geometry_list.elements[iterate].active == 1)
        geometry_component_index_list.elements[++volume_index] = global_geometry_list.elements[iterate].component_index;
      
  }
  geometry_component_index_list.elements[0] = 0; // Volume 0 is never set in the above code, but should never be used.
  
  // The input for this component is done through a series of input components
  // All information needed is stored in global lists, some of which is printed here for an overview to the user.
  MPI_MASTER( // MPI_MASTER ensures just one thread output this information to the user
  if (verbal == 1) {
      printf("---------------------------------------------------------------------\n");
      printf("global_process_list.num_elements: %d\n",global_process_list.num_elements);
      for (iterate=0;iterate<global_process_list.num_elements;iterate++) {
      printf("name of process [%d]: %s \n",iterate,global_process_list.elements[iterate].name);
      printf("component index [%d]: %d \n",iterate,global_process_list.elements[iterate].component_index);
      }
      
      printf("---------------------------------------------------------------------\n");
      printf("global_material_list.num_elements: %d\n",global_material_list.num_elements);
      for (iterate=0;iterate<global_material_list.num_elements;iterate++) {
      printf("name of material    [%d]: %s \n",iterate,global_material_list.elements[iterate].name);
      printf("component index     [%d]: %d \n",iterate,global_material_list.elements[iterate].component_index);
      printf("my_absoprtion       [%d]: %f \n",iterate,global_material_list.elements[iterate].physics->my_a);
      printf("number of processes [%d]: %d \n",iterate,global_material_list.elements[iterate].physics->number_of_processes);
      }

      printf("---------------------------------------------------------------------\n");
      printf("global_geometry_list.num_elements: %d\n",global_material_list.num_elements);
      for (iterate=0;iterate<global_geometry_list.num_elements;iterate++) {
        if (global_geometry_list.elements[iterate].active == 1) {
          printf("\n");
          printf("name of geometry    [%d]: %s \n",iterate,global_geometry_list.elements[iterate].name);
          printf("component index     [%d]: %d \n",iterate,global_geometry_list.elements[iterate].component_index);
          printf("Volume.name         [%d]: %s \n",iterate,global_geometry_list.elements[iterate].Volume->name);
          if (global_geometry_list.elements[iterate].Volume->geometry.is_mask_volume == 0) {
          printf("Volume.p_physics.is_vacuum           [%d]: %d \n",iterate,global_geometry_list.elements[iterate].Volume->p_physics->is_vacuum);
          printf("Volume.p_physics.my_absoprtion       [%d]: %f \n",iterate,global_geometry_list.elements[iterate].Volume->p_physics->my_a);
          printf("Volume.p_physics.number of processes [%d]: %d \n",iterate,global_geometry_list.elements[iterate].Volume->p_physics->number_of_processes);
          }
          printf("Volume.geometry.shape                [%d]: %s \n",iterate,global_geometry_list.elements[iterate].Volume->geometry.shape);
          printf("Volume.geometry.center.x             [%d]: %f \n",iterate,global_geometry_list.elements[iterate].Volume->geometry.center.x);
          printf("Volume.geometry.center.y             [%d]: %f \n",iterate,global_geometry_list.elements[iterate].Volume->geometry.center.y);
          printf("Volume.geometry.center.z             [%d]: %f \n",iterate,global_geometry_list.elements[iterate].Volume->geometry.center.z);
          printf("Volume.geometry.rotation_matrix[0]           [%d]: [%f %f %f] \n",iterate,global_geometry_list.elements[iterate].Volume->geometry.rotation_matrix[0][0],global_geometry_list.elements[iterate].Volume->geometry.rotation_matrix[0][1],global_geometry_list.elements[iterate].Volume->geometry.rotation_matrix[0][2]);
          printf("Volume.geometry.rotation_matrix[1]           [%d]: [%f %f %f] \n",iterate,global_geometry_list.elements[iterate].Volume->geometry.rotation_matrix[1][0],global_geometry_list.elements[iterate].Volume->geometry.rotation_matrix[1][1],global_geometry_list.elements[iterate].Volume->geometry.rotation_matrix[1][2]);
          printf("Volume.geometry.rotation_matrix[2]           [%d]: [%f %f %f] \n",iterate,global_geometry_list.elements[iterate].Volume->geometry.rotation_matrix[2][0],global_geometry_list.elements[iterate].Volume->geometry.rotation_matrix[2][1],global_geometry_list.elements[iterate].Volume->geometry.rotation_matrix[2][2]);
          if (strcmp(global_geometry_list.elements[iterate].Volume->geometry.shape,"cylinder") == 0) {
          printf("Volume.geometry.geometry_parameters.cyl_radius [%d]: %f \n",iterate,global_geometry_list.elements[iterate].Volume->geometry.geometry_parameters.p_cylinder_storage->cyl_radius);
          printf("Volume.geometry.geometry_parameters.height [%d]: %f \n",iterate,global_geometry_list.elements[iterate].Volume->geometry.geometry_parameters.p_cylinder_storage->height);
          }
          printf("Volume.geometry.focus_data_array.elements[0].Aim             [%d]: [%f %f %f] \n",iterate,global_geometry_list.elements[iterate].Volume->geometry.focus_data_array.elements[0].Aim.x,global_geometry_list.elements[iterate].Volume->geometry.focus_data_array.elements[0].Aim.y,global_geometry_list.elements[iterate].Volume->geometry.focus_data_array.elements[0].Aim.z);
        }
      }
      printf("---------------------------------------------------------------------\n");
      printf("number_of_volumes = %d\n",number_of_volumes);
      printf("number_of_masks = %d\n",number_of_masks);
      printf("number_of_masked_volumes = %d\n",number_of_masked_volumes);
  }
  ); // End MPI_MASTER
  
  
  // --- Initialization tasks independent of volume stucture -----------------------

  // Store a pointer to the conditional list and update the current index in that structure
  // If no tagging_conditionals were defined between this and the previous master, a dummy is allocated instead
  if (global_tagging_conditional_list.num_elements == global_tagging_conditional_list.current_index + 1) {
    tagging_conditional_list = &global_tagging_conditional_list.elements[global_tagging_conditional_list.current_index++].conditional_list;
    free_tagging_conditioanl_list = 0;
  } else {
    tagging_conditional_list = malloc(sizeof(struct conditional_list_struct));
    tagging_conditional_list->num_elements = 0;
    free_tagging_conditioanl_list = 1;
  }
  
  // Find the maximum logger extend index so that the correct memory allocation can be performed later
  // Here the loggers applied to all volumes are searched, later this result is compared to volume specific loggers and updated
  max_conditional_extend_index = -1;
  for (iterate=0;iterate<global_all_volume_logger_list.num_elements;iterate++) {
    if (global_all_volume_logger_list.elements[iterate].logger->logger_extend_index > max_conditional_extend_index) {
      max_conditional_extend_index = global_all_volume_logger_list.elements[iterate].logger->logger_extend_index;
    }
  }
  
  // The absolute rotation of this component is saved for use in initialization
  rot_transpose(ROT_A_CURRENT_COMP,master_transposed_rotation_matrix);
  
  // Preceeding componnets can add coordinates and rotations to global_positions_to_transform and global_rotations_to_transform
  //  in order to have these transformed into the coordinate system of the next master compoent in the instrument file.
  // Here these transformations are performed, and the lists are cleared so no transformed information is further altered by
  //  next master components.
  
  // Position transformation
  for (iterate=0;iterate<global_positions_to_transform_list.num_elements;iterate++) {
    //print_position(*global_positions_to_transform_list.positions[iterate],"Position to transform before");
    non_rotated_position = coords_sub(*(global_positions_to_transform_list.positions[iterate]),POS_A_CURRENT_COMP);
    *(global_positions_to_transform_list.positions[iterate]) = rot_apply(ROT_A_CURRENT_COMP,non_rotated_position);
    //print_position(*global_positions_to_transform_list.positions[iterate],"Position to transform after");
  }
  if (global_positions_to_transform_list.num_elements > 0) {
    global_positions_to_transform_list.num_elements = 0;
    free(global_positions_to_transform_list.positions);
  }
  // Rotation transformation
  for (iterate=0;iterate<global_rotations_to_transform_list.num_elements;iterate++) {
    //print_rotation(*(global_rotations_to_transform_list.rotations[iterate]),"rotation matrix to be updated");
    rot_mul(master_transposed_rotation_matrix,*(global_rotations_to_transform_list.rotations[iterate]),temp_rotation_matrix);
    rot_copy(*(global_rotations_to_transform_list.rotations[iterate]),temp_rotation_matrix);
  }
  if (global_rotations_to_transform_list.num_elements > 0) {
    global_rotations_to_transform_list.num_elements = 0;
    free(global_rotations_to_transform_list.rotations);
  }

  
  // --- Definition of volumes and loading of appropriate data  -----------------------
  
  // The information stored in global lists is to be stored in one array of structures that is allocated here
  Volumes = malloc(number_of_volumes * sizeof(struct Volume_struct*));
  scattered_flag = malloc(number_of_volumes*sizeof(int));
  scattered_flag_VP = (int**) malloc(number_of_volumes * sizeof(int*));
  number_of_processes_array = malloc(number_of_volumes*sizeof(int));
  
  // The mcdisplay functions need access to the other geomtries, but can not use the Volumes struct because of order of definition.
  // A separate list of pointers to the geometry structures is thus allocated
  Geometries = malloc(number_of_volumes * sizeof(struct geometry_struct *));
  
  // When activation counter is used to have several copies of one volume, it can become necessary to have soft copies of volumes
  // Not all of these will necessarily be allocated or used.
  Volume_copies = malloc(number_of_volumes * sizeof(struct Volume_struct *));
  Volume_copies_allocated.num_elements = 0;
  
  // The central structure is called a "Volume", it describes a region in space with certain scattering processes and absorption cross section

  // ---  Volume 0 ------------------------------------------------------------------------------------------------
  // Volume 0 is the vacuum surrounding the experiment (infinite, everywhere) and its properties are hardcoded here
  Volumes[0] = malloc(sizeof(struct Volume_struct));
  strcpy(Volumes[0]->name,"Surrounding vacuum");
  // Assign geometry
  
  // This information is meaningless for volume 0, and is never be acsessed in the logic.
  Volumes[0]->geometry.priority_value = 0.0;
  Volumes[0]->geometry.center.x = 0;
  Volumes[0]->geometry.center.y = 0;
  Volumes[0]->geometry.center.z = 0;
  strcpy(Volumes[0]->geometry.shape,"vacuum");
  Volumes[0]->geometry.within_function = &r_within_surroundings; // Always returns 1
  // No physics struct allocated
  Volumes[0]->p_physics = NULL;
  number_of_processes_array[volume_index] = 0;
  
  // These are never used for volume 0, but by setting the length to 0 it is automatically skipped in many forloops without the need for an if statement
  Volumes[0]->geometry.children.num_elements=0;
  Volumes[0]->geometry.direct_children.num_elements=0;
  Volumes[0]->geometry.destinations_list.num_elements=0;
  Volumes[0]->geometry.reduced_destinations_list.num_elements=0;
  
  Volumes[0]->geometry.masked_by_list.num_elements = 0;
  Volumes[0]->geometry.mask_list.num_elements = 0;
  Volumes[0]->geometry.masked_by_mask_index_list.num_elements = 0;
  Volumes[0]->geometry.mask_mode=0;
  Volumes[0]->geometry.is_mask_volume=0;
  Volumes[0]->geometry.is_masked_volume=0;
  
  // A pointer to the geometry structure
  Geometries[0] = &Volumes[0]->geometry;
  
  // Logging initialization
  Volumes[0]->loggers.num_elements = 0;
  
  
  // --- Loop over user defined volumes ------------------------------------------------------------------------
  // Here the user defined volumes are loaded into the volume structure that is used in the ray-tracing
  //  algorithm. Not all user defined volumes are used, some could be used by a previous master, some
  //  could be used by the previous master, this one, and perhaps more. This is controlled by the
  //  activation counter input for geometries, and is here condensed to the active variable.
  // Volumes that were used before
  
  
  max_number_of_processes = 0; // The maximum number of processes in a volume is assumed 0 and updated during the following loop
  
  volume_index = 0;
  mask_index_main = 0;
  for (geometry_list_index=0;geometry_list_index<global_geometry_list.num_elements;geometry_list_index++) {
    if (global_geometry_list.elements[geometry_list_index].active == 1) { // Only include the volume if it is active
      volume_index++;
      // Connect a volume for each of the geometry.comp instances in the McStas instrument files
      if (global_geometry_list.elements[geometry_list_index].activation_counter == 0) {
        // This is the last time this volume is used, use the hard copy from the geometry component
        Volumes[volume_index] = global_geometry_list.elements[geometry_list_index].Volume;
        //printf("used hard copy of volume %d \n",volume_index);
      } else {
        // Since this volume is still needed more than this once, we need to make a shallow copy and use instead
        
        //printf("\n");
        //printf("making local copy of volume %d \n",volume_index);
        Volume_copies[volume_index] = malloc(sizeof(struct Volume_struct));
        *(Volume_copies[volume_index]) = *global_geometry_list.elements[geometry_list_index].Volume; // Makes shallow copy
        Volumes[volume_index] = Volume_copies[volume_index];
        add_element_to_int_list(&Volume_copies_allocated,volume_index); // Keep track of dynamically allocated volumes in order to free them in FINALLY.
        
        // The geometry storage needs a shallow copy as well (hard copy not necessary for any current geometries), may need changes in future
        // A simple copy_geometry_parameters function is added to the geometry in each geometry component
        Volumes[volume_index]->geometry.geometry_parameters = Volumes[volume_index]->geometry.copy_geometry_parameters(&global_geometry_list.elements[geometry_list_index].Volume->geometry.geometry_parameters);
          
      }
      
      // This section identifies the different non isotropic processes in the current volume and give them appropriate transformation matrices
      // Identify the number of non isotropic processes in a material (this code can be safely executed for the same material many times)
      // A setting of -1 means no transformation necessary, other settings are assigned a unique identifier instead
      non_isotropic_found = 0;
      for (iterate=0;iterate<Volumes[volume_index]->p_physics->number_of_processes;iterate++) {
        if (Volumes[volume_index]->p_physics->p_scattering_array[iterate].non_isotropic_rot_index != -1) {
            Volumes[volume_index]->p_physics->p_scattering_array[iterate].non_isotropic_rot_index = non_isotropic_found;
            non_isotropic_found++;
        }
      }
      
      Volumes[volume_index]->geometry.focus_array_indices.num_elements=0;
      // For the non_isotropic volumes found, rotation matrices need to be allocated and calculated
      if (non_isotropic_found > 0) {
        // Allocation of rotation and transpose rotation matrices
        if (Volumes[volume_index]->geometry.process_rot_allocated == 0) {
          Volumes[volume_index]->geometry.process_rot_matrix_array = malloc(non_isotropic_found * sizeof(Rotation));
          Volumes[volume_index]->geometry.transpose_process_rot_matrix_array = malloc(non_isotropic_found * sizeof(Rotation));
          Volumes[volume_index]->geometry.process_rot_allocated = 1;
        }
      
        // Calculation of the appropriate rotation matrices for transformation between Union_master and the process in a given volume.
        non_isotropic_found = 0;
        for (iterate=0;iterate<Volumes[volume_index]->p_physics->number_of_processes;iterate++) {
          if (Volumes[volume_index]->p_physics->p_scattering_array[iterate].non_isotropic_rot_index != -1) {
            // Transformation for each process / geometry combination
            
            // The focus vector is given in relation to the geometry and needs to be transformed to the process
            // Work on temporary_focus_data_element which is added to the focus_data_array_at the end
            temporary_focus_data = Volumes[volume_index]->geometry.focus_data_array.elements[0];
            
            // Correct for process rotation
            temporary_focus_data.Aim = rot_apply(Volumes[volume_index]->p_physics->p_scattering_array[iterate].rotation_matrix,temporary_focus_data.Aim);
            
            // Add element to focus_array_indices
            // focus_array_indices refers to the correct element in focus_data_array for this volume/process combination
            // focus_data_array[0] is the isotropic version in all cases, so the first non_isotropic goes to focus_data_array[1]
            //  and so forth. When a process is isotropic, this array is appended with a zero.
            // The focus_array_indices maps process numbers to the correct focus_data_array index.
            add_element_to_int_list(&Volumes[volume_index]->geometry.focus_array_indices,non_isotropic_found+1);
            
            // Add the new focus_data element to this volumes focus_data_array.
            add_element_to_focus_data_array(&Volumes[volume_index]->geometry.focus_data_array,temporary_focus_data);
            
            // Quick error check to see the length is correct which indirectly confirms the indices are correct
            if (Volumes[volume_index]->geometry.focus_data_array.num_elements != non_isotropic_found + 2) {
              printf("ERROR, focus_data_array length for volume %s inconsistent with number of non isotropic processes found!\n",Volumes[volume_index]->name);
              exit(1);
            }
            
            // Create rotation matrix for this specific volume / process combination to transform from master coordinate system to the non-isotropics process coordinate system
            // This is done by multipling the transpose master component roration matrix, the volume rotation, and then the process rotation matrix onto the velocity / wavevector
            rot_mul(Volumes[volume_index]->geometry.rotation_matrix,master_transposed_rotation_matrix,temp_rotation_matrix);
            rot_mul(Volumes[volume_index]->p_physics->p_scattering_array[iterate].rotation_matrix,temp_rotation_matrix,Volumes[volume_index]->geometry.process_rot_matrix_array[non_isotropic_found]);
            
            // Need to transpose as well to transform back to the master coordinate system
            rot_transpose(Volumes[volume_index]->geometry.process_rot_matrix_array[non_isotropic_found],Volumes[volume_index]->geometry.transpose_process_rot_matrix_array[non_isotropic_found]);

            // Debug print
            //print_rotation(Volumes[volume_index]->geometry.process_rot_matrix_array[non_isotropic_found],"Process rotation matrix");
            //print_rotation(Volumes[volume_index]->geometry.transpose_process_rot_matrix_array[non_isotropic_found],"Transpose process rotation matrix");
            
            non_isotropic_found++;
          } else {
            // This process can use the standard isotropic focus_data_array which is indexed zero.
            add_element_to_int_list(&Volumes[volume_index]->geometry.focus_array_indices,0);
          }
        }
      } else {
      // No non isotropic volumes found, focus_array_indices should just be a list of 0's of same length as the number of processes.
      // In this way all processes use the isotropic focus_data structure
        Volumes[volume_index]->geometry.focus_array_indices.elements = malloc(Volumes[volume_index]->p_physics->number_of_processes * sizeof(int));
        for (iterate=0;iterate<Volumes[volume_index]->p_physics->number_of_processes;iterate++)
          Volumes[volume_index]->geometry.focus_array_indices.elements[iterate] = 0;
          
      }
      //print_1d_int_list(Volumes[volume_index]->geometry.focus_array_indices,"focus_array_indices");
      
      
      // This component works in its local coordinate system, and thus all information from the input components should be transformed to its coordinate system.
      // All the input components saved their absolute rotation/position into their Volume structure, and the absolute rotation of the current component is known.
      // The next section finds the relative rotation and translation of all the volumes and the master component.
      
      // Transform the rotation matrices for each volume
      rot_mul(ROT_A_CURRENT_COMP,Volumes[volume_index]->geometry.transpose_rotation_matrix,temp_rotation_matrix);
      // Copy the result back to the volumes structure
      rot_copy(Volumes[volume_index]->geometry.rotation_matrix,temp_rotation_matrix);
      // Now update the transpose as well
      rot_transpose(Volumes[volume_index]->geometry.rotation_matrix,temp_rotation_matrix);
      rot_copy(Volumes[volume_index]->geometry.transpose_rotation_matrix,temp_rotation_matrix);
        
      // Transform the position for each volume
      non_rotated_position.x = Volumes[volume_index]->geometry.center.x - POS_A_CURRENT_COMP.x;
      non_rotated_position.y = Volumes[volume_index]->geometry.center.y - POS_A_CURRENT_COMP.y;
      non_rotated_position.z = Volumes[volume_index]->geometry.center.z - POS_A_CURRENT_COMP.z;

      rot_transpose(ROT_A_CURRENT_COMP,temp_rotation_matrix); // REVIEW LINE
      rotated_position = rot_apply(ROT_A_CURRENT_COMP,non_rotated_position);

      Volumes[volume_index]->geometry.center.x = rotated_position.x;
      Volumes[volume_index]->geometry.center.y = rotated_position.y;
      Volumes[volume_index]->geometry.center.z = rotated_position.z;
      
      // The focus_data information need to be updated as well
      rot_mul(ROT_A_CURRENT_COMP,Volumes[volume_index]->geometry.focus_data_array.elements[0].absolute_rotation,temp_rotation_matrix);
      // Copy the result back to the volumes structure
      rot_copy(Volumes[volume_index]->geometry.focus_data_array.elements[0].absolute_rotation,temp_rotation_matrix);
      
      // Use same rotation on the aim vector of the isotropic focus_data element
      Volumes[volume_index]->geometry.focus_data_array.elements[0].Aim = rot_apply(Volumes[volume_index]->geometry.rotation_matrix,Volumes[volume_index]->geometry.focus_data_array.elements[0].Aim);
      
      // To allocate enough memory to hold information on all processes, the maximum of these is updated if this volume has more
      if (Volumes[volume_index]->p_physics->number_of_processes > max_number_of_processes)
          max_number_of_processes = Volumes[volume_index]->p_physics->number_of_processes;
        
      // Allocate memory to scattered_flag_VP (holds statistics for scatterings in each process of the volume)
      scattered_flag_VP[volume_index] = malloc(Volumes[volume_index]->p_physics->number_of_processes * sizeof(int));
      number_of_processes_array[volume_index] = Volumes[volume_index]->p_physics->number_of_processes;
      
      // Normalizing and error checking process interact fraction
      number_of_process_interacts_set = 0; total_process_interact=0;
      for (process_index=0;process_index<Volumes[volume_index]->p_physics->number_of_processes;process_index++) {
        if (Volumes[volume_index]->p_physics->p_scattering_array[process_index].process_p_interact != -1) {
          number_of_process_interacts_set++;
          total_process_interact += Volumes[volume_index]->p_physics->p_scattering_array[process_index].process_p_interact;
        } else {
          index_of_lacking_process = process_index;
        }
      }
      
      if (number_of_process_interacts_set == 0) Volumes[volume_index]->p_physics->interact_control = 0;
      else Volumes[volume_index]->p_physics->interact_control = 1;
      
      // If all are set, check if they need renormalization so that the sum is one.
      if (number_of_process_interacts_set == Volumes[volume_index]->p_physics->number_of_processes) {
        if (total_process_interact > 1.001 || total_process_interact < 0.999) {
          for (process_index=0;process_index<Volumes[volume_index]->p_physics->number_of_processes;process_index++) {
            Volumes[volume_index]->p_physics->p_scattering_array[process_index].process_p_interact = Volumes[volume_index]->p_physics->p_scattering_array[process_index].process_p_interact/total_process_interact;
          }
        }
      } else if ( number_of_process_interacts_set != 0) {
        if (number_of_process_interacts_set == Volumes[volume_index]->p_physics->number_of_processes - 1) {// If all but one is set, it is an easy fix
          Volumes[volume_index]->p_physics->p_scattering_array[index_of_lacking_process].process_p_interact = 1 - total_process_interact;
          if (total_process_interact >= 1) {
            printf("ERROR, material %s has a total interact_fraction above 1 and a process without an interact_fraction. Either set all so they can be renormalized, or have a sum below 1, so that the last can have 1 - sum.\n",Volumes[volume_index]->p_physics->name);
            exit(1);
          }
        } else {
            printf("ERROR, material %s needs to have all, all minus one or none of its processes with an interact_fraction \n",Volumes[volume_index]->p_physics->name);
            exit(1);
        }
      }
        
      // Some initialization can only happen after the rotation matrix relative to the master is known
      // Such initialization is placed in the geometry component, and executed here through a function pointer
      Volumes[volume_index]->geometry.initialize_from_main_function(&Volumes[volume_index]->geometry);
      
      // Add pointer to geometry to Geometries
      Geometries[volume_index] = &Volumes[volume_index]->geometry;
      
      // Initialize mask intersect list
      Volumes[volume_index]->geometry.mask_intersect_list.num_elements = 0;
      
      // Here the mask_list and masked_by_list for the volume is updated from component index values to volume indexes
      for (iterate=0;iterate<Volumes[volume_index]->geometry.mask_list.num_elements;iterate++)
        Volumes[volume_index]->geometry.mask_list.elements[iterate] = find_on_int_list(geometry_component_index_list,Volumes[volume_index]->geometry.mask_list.elements[iterate]);
      
      for (iterate=0;iterate<Volumes[volume_index]->geometry.masked_by_list.num_elements;iterate++)
        Volumes[volume_index]->geometry.masked_by_list.elements[iterate] = find_on_int_list(geometry_component_index_list,Volumes[volume_index]->geometry.masked_by_list.elements[iterate]);
      
      // If the volume is a mask, its volume number is added to the mask_volume_index list so volume index can be converted to mask_index.
      if (Volumes[volume_index]->geometry.is_mask_volume == 1) Volumes[volume_index]->geometry.mask_index = mask_index_main;
      if (Volumes[volume_index]->geometry.is_mask_volume == 1) mask_volume_index_list.elements[mask_index_main++] = volume_index;
     
      // Check all loggers assosiated with this volume and update the max_conditional_extend_index if necessary
      //printf("reached max_test for volume %d \n",volume_index);
      for (iterate=0;iterate<Volumes[volume_index]->loggers.num_elements;iterate++) {
        //printf("iterate = %d \n",iterate);
        for (process_index=0;process_index<Volumes[volume_index]->loggers.p_logger_volume[iterate].num_elements;process_index++) {
        //printf("process_index = %d \n",process_index);
          if (Volumes[volume_index]->loggers.p_logger_volume[iterate].p_logger_process[process_index] != NULL) {
            if (Volumes[volume_index]->loggers.p_logger_volume[iterate].p_logger_process[process_index]->logger_extend_index > max_conditional_extend_index)
              max_conditional_extend_index = Volumes[volume_index]->loggers.p_logger_volume[iterate].p_logger_process[process_index]->logger_extend_index;
          }
        }
      }
      //printf("did max_test for volume %d\n",volume_index);
      
    
    }
  } // Initialization for each volume done
  
  // ------- Initialization of ray-tracing algorithm ------------------------------------
   
  my_trace = malloc(max_number_of_processes*sizeof(double));
  my_trace_fraction_control = malloc(max_number_of_processes*sizeof(double));
  
  // All geometries can have 2 intersections currently, when this changes the maximum number of solutions need to be reported to the Union_master.
  number_of_solutions = &number_of_solutions_static;
  component_error_msg = 0;
  
  // Pre allocated memory for destination list search
  pre_allocated1 = malloc(number_of_volumes * sizeof(int));
  pre_allocated2 = malloc(number_of_volumes * sizeof(int));
  pre_allocated3 = malloc(number_of_volumes * sizeof(int));
  
  // Allocate memory for logger_conditional_extend_array used in the extend section of the master component, if it is needed.
  if (max_conditional_extend_index > -1) {
    logger_conditional_extend_array = malloc((max_conditional_extend_index + 1)*sizeof(int));
  }
  
  // In this function different lists of volume indecies are generated. They are the key to the speed of the component and central for the logic.
  // They use simple set algebra to generate these lists for each volume:
  // Children list for volume n: Indicies of volumes that are entirely within the set described by volume n
  // Overlap list for volume n: Indicies of volume that contains some of the set described by volume n (excluding volume n)
  // Intersect check list for volume n: Indicies of volumes to check for intersection if a ray originates from volume n (is generated from the children and overlap lists)
  // Parents list for volume n: Indicies of volumes that contain the entire set of volume n
  // Grandparents lists for volume n: Indicies of volumes that contain the entire set of at least one parent of volume n
  // Destination list for volume n: Indicies of volumes that could be the destination volume when a ray leaves volume n
  // The overlap, parents and grandparents lists are local variables in the function, and not in the main scope.
  
  generate_lists(Volumes, &starting_lists, number_of_volumes, list_verbal);
  
  // Generate "safe starting list", which contains all volumes that the ray may enter from other components
  // These are all volumes without scattering or absorption
  
  // Updating mask lists from volume index to global_mask_indices
  // Filling out the masked_by list that uses mask indices
  for (volume_index=0;volume_index<number_of_volumes;volume_index++) {
    Volumes[volume_index]->geometry.masked_by_mask_index_list.num_elements = Volumes[volume_index]->geometry.masked_by_list.num_elements;
    Volumes[volume_index]->geometry.masked_by_mask_index_list.elements = malloc(Volumes[volume_index]->geometry.masked_by_mask_index_list.num_elements * sizeof(int));
    for (iterate=0;iterate<Volumes[volume_index]->geometry.masked_by_list.num_elements;iterate++)
        Volumes[volume_index]->geometry.masked_by_mask_index_list.elements[iterate] = find_on_int_list(mask_volume_index_list,Volumes[volume_index]->geometry.masked_by_list.elements[iterate]);
  }
  
  // Optimizing speed of the within_which_volume search algorithm
  int volume_index_main; // REVIEW_LINE
  /*
  for (volume_index_main=0;volume_index_main<number_of_volumes;volume_index_main++) {
    Volumes[volume_index_main]->geometry.destinations_logic_list.elements[0] = 0;
  }
  */
  
  // Checking for equal priorities in order to alert the user to a potential input error
  for (volume_index_main=0;volume_index_main<number_of_volumes;volume_index_main++) {
    for (volume_index=0;volume_index<number_of_volumes;volume_index++)
        if (Volumes[volume_index_main]->geometry.priority_value == Volumes[volume_index]->geometry.priority_value && volume_index_main != volume_index) {
            if (Volumes[volume_index_main]->geometry.is_mask_volume == 0 && Volumes[volume_index]->geometry.is_mask_volume == 0) {
              // Priority of masks do not matter
              printf("ERROR in Union_master with name %s. The volumes named %s and %s have the same priority. Change the priorities so the one present in case of overlap has highest priority.\n",NAME_CURRENT_COMP,Volumes[volume_index_main]->name,Volumes[volume_index]->name);
              exit(1);
            }
        }
  }
  
  
  // Printing the generated lists for all volumes.
  MPI_MASTER(
  if (verbal) printf("\n ---- Overview of the lists generated for each volume ---- \n");
  
  for (volume_index_main=0;volume_index_main<number_of_volumes;volume_index_main++) {
      if (verbal) sprintf(string_output,"Children for Volume                  %d",volume_index_main);
      if (verbal) print_1d_int_list(Volumes[volume_index_main]->geometry.children,string_output);
      
      if (verbal) sprintf(string_output,"Direct_children for Volume           %d",volume_index_main);
      if (verbal) print_1d_int_list(Volumes[volume_index_main]->geometry.direct_children,string_output);
      
      if (verbal) sprintf(string_output,"Intersect_check_list for Volume      %d",volume_index_main);
      if (verbal) print_1d_int_list(Volumes[volume_index_main]->geometry.intersect_check_list,string_output);
      
      if (verbal) sprintf(string_output,"Mask_intersect_list for Volume       %d",volume_index_main);
      if (verbal) print_1d_int_list(Volumes[volume_index_main]->geometry.mask_intersect_list,string_output);
      
      if (verbal) sprintf(string_output,"Destinations_list for Volume         %d",volume_index_main);
      if (verbal) print_1d_int_list(Volumes[volume_index_main]->geometry.destinations_list,string_output);
      
      //if (verbal) sprintf(string_output,"Destinations_logic_list for Volume   %d",volume_index_main);
      //if (verbal) print_1d_int_list(Volumes[volume_index_main]->geometry.destinations_logic_list,string_output);
      
      if (verbal) sprintf(string_output,"Reduced_destinations_list for Volume %d",volume_index_main);
      if (verbal) print_1d_int_list(Volumes[volume_index_main]->geometry.reduced_destinations_list,string_output);
      
      if (verbal) sprintf(string_output,"Next_volume_list for Volume          %d",volume_index_main);
      if (verbal) print_1d_int_list(Volumes[volume_index_main]->geometry.next_volume_list,string_output);
      
      if (verbal) {
        if (volume_index_main != 0)
                           printf("      Is_vacuum for Volume                 %d = %d\n",volume_index_main,Volumes[volume_index_main]->p_physics->is_vacuum);
      }
      if (verbal) {
        if (volume_index_main != 0)
                           printf("      is_mask_volume for Volume            %d = %d\n",volume_index_main,Volumes[volume_index_main]->geometry.is_mask_volume);
      }
      if (verbal) {
        if (volume_index_main != 0)
                           printf("      is_masked_volume for Volume          %d = %d\n",volume_index_main,Volumes[volume_index_main]->geometry.is_masked_volume);
      }
      if (verbal) {
        if (volume_index_main != 0)
                           printf("      is_exit_volume for Volume            %d = %d\n",volume_index_main,Volumes[volume_index_main]->geometry.is_exit_volume);
      }
      
      if (verbal) sprintf(string_output,"mask_list for Volume                 %d",volume_index_main);
      if (verbal) print_1d_int_list(Volumes[volume_index_main]->geometry.mask_list,string_output);
      
      if (verbal) sprintf(string_output,"masked_by_list for Volume            %d",volume_index_main);
      if (verbal) print_1d_int_list(Volumes[volume_index_main]->geometry.masked_by_list,string_output);
      
      if (verbal) sprintf(string_output,"masked_by_mask_index_list for Volume %d",volume_index_main);
      if (verbal) print_1d_int_list(Volumes[volume_index_main]->geometry.masked_by_mask_index_list,string_output);
      
      if (verbal)          printf("      mask_mode for Volume                 %d = %d\n",volume_index_main,Volumes[volume_index_main]->geometry.mask_mode);
      if (verbal) printf("\n");
  }
  ) // End of MPI_MASTER
  

  // Initializing intersection_time_table
  // The intersection time table contains all information on intersection times for the current position/direction, and is cleared everytime a ray changes direction.
  // Not all entries needs to be calculated, so there is a variable that keeps track of which intersection times have been calculated in order to avoid redoing that.
  // When the intersections times are calculated for a volume, all future intersections are kept in the time table.
  // Thus the memory allocation have to take into account how many intersections there can be with each volume, but it is currently set to 2, but can easily be changed. This may need to be reported by individual geometry components in the future.
  
  intersection_time_table.num_volumes = number_of_volumes;
  
  intersection_time_table.n_elements = (int*) malloc(intersection_time_table.num_volumes * sizeof(int));
  intersection_time_table.calculated = (int*) malloc(intersection_time_table.num_volumes * sizeof(int));
  intersection_time_table.intersection_times = (double**) malloc(intersection_time_table.num_volumes * sizeof(double));
  for (iterate = 0;iterate < intersection_time_table.num_volumes;iterate++){
      intersection_time_table.n_elements[iterate] = (int) 2; // number of intersection solutions
      if (iterate == 0) intersection_time_table.n_elements[iterate] = (int) 0; // number of intersection solutions
      intersection_time_table.calculated[iterate] = (int) 0; // Initializing calculated logic
      
      if (iterate == 0) {
           intersection_time_table.intersection_times[0] = NULL;
      }
      else {
        intersection_time_table.intersection_times[iterate] = (double*) malloc(intersection_time_table.n_elements[iterate]*sizeof(double));
        for (solutions = 0;solutions < intersection_time_table.n_elements[iterate];solutions++) {
              intersection_time_table.intersection_times[iterate][solutions] = -1.0;
        }
      }
  }
  
  
  
  
  // If enabled, the tagging system tracks all different histories sampled by the program.

  // Initialize the tagging tree
  // Allocate a list of host nodes with the same length as the number of volumes
  
  stop_creating_nodes = 0; stop_tagging_ray = 0; tagging_leaf_counter = 0;
  if (enable_tagging) {
    master_tagging_node_list.num_elements = number_of_volumes;
    master_tagging_node_list.elements = malloc(master_tagging_node_list.num_elements * sizeof(struct tagging_tree_node_struct*));
  
    // Initialize
    for (volume_index=0;volume_index<number_of_volumes;volume_index++) {
      //if (verbal) printf("Allocating master tagging node for volume number %d \n",volume_index);
      master_tagging_node_list.elements[volume_index] = initialize_tagging_tree_node(master_tagging_node_list.elements[volume_index], NULL, Volumes[volume_index]);
      //if (verbal) printf("Allocated master tagging node for volume number %d \n",volume_index);
    }
  }
  
  // Initialize loggers
  loggers_with_data_array.allocated_elements = 0;
  loggers_with_data_array.used_elements = 0;
  
  
  // Signal initialization complete
  MPI_MASTER(
    printf("Union_master component %s initialized sucessfully\n",NAME_CURRENT_COMP);
  )

}
#line 160658 "MACS_sample_kidney_box.c"
#undef inherit_number_of_scattering_events
#undef enable_conditionals
#undef history_limit
#undef allow_inside_start
#undef focus_data_index
#undef temporary_focus_data
#undef number_of_processes_array
#undef safty_distance2
#undef safty_distance
#undef max_conditional_extend_index
#undef tagging_conditional_extend
#undef logger_conditional_extend_array
#undef free_tagging_conditioanl_list
#undef tagging_conditional_list
#undef conditional_status
#undef this_logger
#undef p_old
#undef Volume_copies_allocated
#undef geometry_component_index_list
#undef mask_volume_index_list
#undef current_mask_intersect_list_status
#undef mask_status_list
#undef mask_iterate
#undef mask_index_main
#undef need_to_run_within_which_volume
#undef number_of_masked_volumes
#undef number_of_masks
#undef mc_transmission_probability
#undef real_transmission_probability
#undef number_of_scattering_events
#undef tagging_leaf_counter
#undef current_tagging_node
#undef master_tagging_node_list
#undef enable_tagging_check
#undef stop_creating_nodes
#undef stop_tagging_ray
#undef enable_tagging
#undef rotated_position
#undef non_rotated_position
#undef temp_rotation_matrix
#undef master_transposed_rotation_matrix
#undef scattered_flag_VP
#undef scattered_flag
#undef volume_0_found
#undef ray_velocity_final
#undef ray_velocity
#undef ray_position
#undef pre_allocated3
#undef pre_allocated2
#undef pre_allocated1
#undef tree_next_volume
#undef geometry_output
#undef intersection_with_children
#undef start
#undef check
#undef number_of_solutions_static
#undef number_of_solutions
#undef current_volume
#undef done
#undef next_volume_priority
#undef next_volume
#undef a_next_volume_found
#undef time_propagated_without_scattering
#undef scattering_event
#undef selected_process
#undef time_to_boundery
#undef length_to_boundery
#undef length_to_scattering
#undef time_to_scattering
#undef mc_prop
#undef culmative_probability
#undef my_sum_plus_abs
#undef my_sum
#undef v_length
#undef k_old
#undef k_new
#undef k
#undef my_trace_fraction_control
#undef p_my_trace
#undef my_trace
#undef process_start
#undef process
#undef min_intersection_time
#undef intersection_time
#undef time_found
#undef min_volume
#undef min_solution
#undef solution
#undef limit
#undef max_number_of_processes
#undef solutions
#undef process_index
#undef volume_index
#undef number_of_volumes
#undef string_output
#undef component_error_msg
#undef error_msg
#undef v
#undef r_start
#undef r
#undef starting_lists
#undef Geometries
#undef Volumes
#undef intersection_time_table
#undef geometry_list_index
#undef previous_master_index
#undef this_global_master_index
#undef global_master_element
#undef starting_volume_warning
#undef finally_verbal
#undef trace_verbal
#undef list_verbal
#undef verbal
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

  /* Initializations for component Resolution_sample. */
  SIG_MESSAGE("Resolution_sample (Init)");
#define mccompcurname  Resolution_sample
#define mccompcurtype  Res_sample
#define mccompcurindex 46
#define res_struct mccResolution_sample_res_struct
#define thickness mccResolution_sample_thickness
#define radius mccResolution_sample_radius
#define focus_r mccResolution_sample_focus_r
#define E0 mccResolution_sample_E0
#define dE mccResolution_sample_dE
#define target_x mccResolution_sample_target_x
#define target_y mccResolution_sample_target_y
#define target_z mccResolution_sample_target_z
#define focus_xw mccResolution_sample_focus_xw
#define focus_yh mccResolution_sample_focus_yh
#define focus_aw mccResolution_sample_focus_aw
#define focus_ah mccResolution_sample_focus_ah
#define xwidth mccResolution_sample_xwidth
#define yheight mccResolution_sample_yheight
#define zdepth mccResolution_sample_zdepth
#define target_index mccResolution_sample_target_index
#line 88 "/usr/share/mcstas/2.7/samples/Res_sample.comp"
{
if (!radius || !yheight) {
    if (!xwidth || !yheight || !zdepth) exit(fprintf(stderr,"Res_sample: %s: sample has no volume (zero dimensions)\n", NAME_CURRENT_COMP));
    else res_struct.isrect=1; }
  else res_struct.isrect=0;

  /* now compute target coords if a component index is supplied */
  if (!target_index && !target_x && !target_y && !target_z) target_index=1;
  if (target_index)
  {
    Coords ToTarget;
    ToTarget = coords_sub(POS_A_COMP_INDEX(INDEX_CURRENT_COMP+target_index),POS_A_CURRENT_COMP);
    ToTarget = rot_apply(ROT_A_CURRENT_COMP, ToTarget);
    coords_get(ToTarget, &res_struct.tx, &res_struct.ty, &res_struct.tz);
  }
  else
  { res_struct.tx = target_x; res_struct.ty = target_y; res_struct.tz = target_z; }

  if (!(res_struct.tx || res_struct.ty || res_struct.tz)) {
    printf("Res_sample: %s: The target is not defined. Using direct beam (Z-axis).\n",
      NAME_CURRENT_COMP);
    res_struct.tz=1;
  }

  /* different ways of setting rectangular area */
  res_struct.aw  = res_struct.ah = 0;
  if (focus_xw) {
    res_struct.xw = focus_xw;
  }
  if (focus_yh) {
    res_struct.yh = focus_yh;
  }
  if (focus_aw) {
    res_struct.aw = DEG2RAD*focus_aw;
  }
  if (focus_ah) {
    res_struct.ah = DEG2RAD*focus_ah;
  }
}
#line 160838 "MACS_sample_kidney_box.c"
#undef target_index
#undef zdepth
#undef yheight
#undef xwidth
#undef focus_ah
#undef focus_aw
#undef focus_yh
#undef focus_xw
#undef target_z
#undef target_y
#undef target_x
#undef dE
#undef E0
#undef focus_r
#undef radius
#undef thickness
#undef res_struct
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

  /* Initializations for component post_sample_beamstop. */
  SIG_MESSAGE("post_sample_beamstop (Init)");
#define mccompcurname  post_sample_beamstop
#define mccompcurtype  Beamstop
#define mccompcurindex 47
#define xmin mccpost_sample_beamstop_xmin
#define xmax mccpost_sample_beamstop_xmax
#define ymin mccpost_sample_beamstop_ymin
#define ymax mccpost_sample_beamstop_ymax
#define xwidth mccpost_sample_beamstop_xwidth
#define yheight mccpost_sample_beamstop_yheight
#define radius mccpost_sample_beamstop_radius
#line 50 "/usr/share/mcstas/2.7/optics/Beamstop.comp"
{
if (xwidth  > 0) { xmax = xwidth/2;  xmin = -xmax; }
  if (yheight > 0) { ymax = yheight/2; ymin = -ymax; }

  if (xmin == 0 && xmax == 0 && ymin == 0 & ymax == 0 && radius == 0)
  { fprintf(stderr,"Beamstop: %s: Error: give geometry\n", NAME_CURRENT_COMP); exit(-1); }
}
#line 160880 "MACS_sample_kidney_box.c"
#undef radius
#undef yheight
#undef xwidth
#undef ymax
#undef ymin
#undef xmax
#undef xmin
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

  /* Initializations for component kidney_master. */
  SIG_MESSAGE("kidney_master (Init)");

  /* Initializations for component kidney_channel_0. */
  SIG_MESSAGE("kidney_channel_0 (Init)");

  /* Initializations for component kidney_channel_1. */
  SIG_MESSAGE("kidney_channel_1 (Init)");

  /* Initializations for component kidney_channel_2. */
  SIG_MESSAGE("kidney_channel_2 (Init)");

  /* Initializations for component kidney_channel_3. */
  SIG_MESSAGE("kidney_channel_3 (Init)");

  /* Initializations for component kidney_channel_4. */
  SIG_MESSAGE("kidney_channel_4 (Init)");

  /* Initializations for component kidney_channel_5. */
  SIG_MESSAGE("kidney_channel_5 (Init)");

  /* Initializations for component kidney_channel_6. */
  SIG_MESSAGE("kidney_channel_6 (Init)");

  /* Initializations for component kidney_channel_7. */
  SIG_MESSAGE("kidney_channel_7 (Init)");

  /* Initializations for component kidney_channel_8. */
  SIG_MESSAGE("kidney_channel_8 (Init)");

  /* Initializations for component kidney_channel_9. */
  SIG_MESSAGE("kidney_channel_9 (Init)");

  /* Initializations for component kidney_channel_10. */
  SIG_MESSAGE("kidney_channel_10 (Init)");

  /* Initializations for component kidney_channel_11. */
  SIG_MESSAGE("kidney_channel_11 (Init)");

  /* Initializations for component kidney_channel_12. */
  SIG_MESSAGE("kidney_channel_12 (Init)");

  /* Initializations for component kidney_channel_13. */
  SIG_MESSAGE("kidney_channel_13 (Init)");

  /* Initializations for component kidney_channel_14. */
  SIG_MESSAGE("kidney_channel_14 (Init)");

  /* Initializations for component kidney_channel_15. */
  SIG_MESSAGE("kidney_channel_15 (Init)");

  /* Initializations for component kidney_channel_16. */
  SIG_MESSAGE("kidney_channel_16 (Init)");

  /* Initializations for component kidney_channel_17. */
  SIG_MESSAGE("kidney_channel_17 (Init)");

  /* Initializations for component kidney_channel_18. */
  SIG_MESSAGE("kidney_channel_18 (Init)");

  /* Initializations for component kidney_channel_19. */
  SIG_MESSAGE("kidney_channel_19 (Init)");

  /* Initializations for component channel_0_filter. */
  SIG_MESSAGE("channel_0_filter (Init)");
#define mccompcurname  channel_0_filter
#define mccompcurtype  Slit_MACS
#define mccompcurindex 69
#define xmin mccchannel_0_filter_xmin
#define xmax mccchannel_0_filter_xmax
#define ymin mccchannel_0_filter_ymin
#define ymax mccchannel_0_filter_ymax
#define radius mccchannel_0_filter_radius
#define xwidth mccchannel_0_filter_xwidth
#define yheight mccchannel_0_filter_yheight
#line 50 "Slit_MACS.comp"
{
if (xwidth > 0)  { 
  if (!xmin && !xmax) {
    xmax=xwidth/2;  xmin=-xmax;
  } else {
    fprintf(stderr,"Slit: %s: Error: please specify EITHER xmin & xmax or xwidth\n", NAME_CURRENT_COMP); exit(-1);
  }
 }
 if (yheight > 0) { 
   if (!ymin && !ymax) {
     ymax=yheight/2; ymin=-ymax; 
   } else {
     fprintf(stderr,"Slit: %s: Error: please specify EITHER ymin & ymax or ywidth\n", NAME_CURRENT_COMP); exit(-1);
   }
 }
 if (xmin == 0 && xmax == 0 && ymin == 0 && ymax == 0 && radius == 0)
    { fprintf(stderr,"Slit: %s: Warning: Running with CLOSED slit - is this intentional?? \n", NAME_CURRENT_COMP); }

}
#line 160987 "MACS_sample_kidney_box.c"
#undef yheight
#undef xwidth
#undef radius
#undef ymax
#undef ymin
#undef xmax
#undef xmin
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

  /* Initializations for component channel_1_filter. */
  SIG_MESSAGE("channel_1_filter (Init)");
#define mccompcurname  channel_1_filter
#define mccompcurtype  Slit_MACS
#define mccompcurindex 70
#define xmin mccchannel_1_filter_xmin
#define xmax mccchannel_1_filter_xmax
#define ymin mccchannel_1_filter_ymin
#define ymax mccchannel_1_filter_ymax
#define radius mccchannel_1_filter_radius
#define xwidth mccchannel_1_filter_xwidth
#define yheight mccchannel_1_filter_yheight
#line 50 "Slit_MACS.comp"
{
if (xwidth > 0)  { 
  if (!xmin && !xmax) {
    xmax=xwidth/2;  xmin=-xmax;
  } else {
    fprintf(stderr,"Slit: %s: Error: please specify EITHER xmin & xmax or xwidth\n", NAME_CURRENT_COMP); exit(-1);
  }
 }
 if (yheight > 0) { 
   if (!ymin && !ymax) {
     ymax=yheight/2; ymin=-ymax; 
   } else {
     fprintf(stderr,"Slit: %s: Error: please specify EITHER ymin & ymax or ywidth\n", NAME_CURRENT_COMP); exit(-1);
   }
 }
 if (xmin == 0 && xmax == 0 && ymin == 0 && ymax == 0 && radius == 0)
    { fprintf(stderr,"Slit: %s: Warning: Running with CLOSED slit - is this intentional?? \n", NAME_CURRENT_COMP); }

}
#line 161031 "MACS_sample_kidney_box.c"
#undef yheight
#undef xwidth
#undef radius
#undef ymax
#undef ymin
#undef xmax
#undef xmin
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

  /* Initializations for component channel_2_filter. */
  SIG_MESSAGE("channel_2_filter (Init)");
#define mccompcurname  channel_2_filter
#define mccompcurtype  Slit_MACS
#define mccompcurindex 71
#define xmin mccchannel_2_filter_xmin
#define xmax mccchannel_2_filter_xmax
#define ymin mccchannel_2_filter_ymin
#define ymax mccchannel_2_filter_ymax
#define radius mccchannel_2_filter_radius
#define xwidth mccchannel_2_filter_xwidth
#define yheight mccchannel_2_filter_yheight
#line 50 "Slit_MACS.comp"
{
if (xwidth > 0)  { 
  if (!xmin && !xmax) {
    xmax=xwidth/2;  xmin=-xmax;
  } else {
    fprintf(stderr,"Slit: %s: Error: please specify EITHER xmin & xmax or xwidth\n", NAME_CURRENT_COMP); exit(-1);
  }
 }
 if (yheight > 0) { 
   if (!ymin && !ymax) {
     ymax=yheight/2; ymin=-ymax; 
   } else {
     fprintf(stderr,"Slit: %s: Error: please specify EITHER ymin & ymax or ywidth\n", NAME_CURRENT_COMP); exit(-1);
   }
 }
 if (xmin == 0 && xmax == 0 && ymin == 0 && ymax == 0 && radius == 0)
    { fprintf(stderr,"Slit: %s: Warning: Running with CLOSED slit - is this intentional?? \n", NAME_CURRENT_COMP); }

}
#line 161075 "MACS_sample_kidney_box.c"
#undef yheight
#undef xwidth
#undef radius
#undef ymax
#undef ymin
#undef xmax
#undef xmin
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

  /* Initializations for component channel_3_filter. */
  SIG_MESSAGE("channel_3_filter (Init)");
#define mccompcurname  channel_3_filter
#define mccompcurtype  Slit_MACS
#define mccompcurindex 72
#define xmin mccchannel_3_filter_xmin
#define xmax mccchannel_3_filter_xmax
#define ymin mccchannel_3_filter_ymin
#define ymax mccchannel_3_filter_ymax
#define radius mccchannel_3_filter_radius
#define xwidth mccchannel_3_filter_xwidth
#define yheight mccchannel_3_filter_yheight
#line 50 "Slit_MACS.comp"
{
if (xwidth > 0)  { 
  if (!xmin && !xmax) {
    xmax=xwidth/2;  xmin=-xmax;
  } else {
    fprintf(stderr,"Slit: %s: Error: please specify EITHER xmin & xmax or xwidth\n", NAME_CURRENT_COMP); exit(-1);
  }
 }
 if (yheight > 0) { 
   if (!ymin && !ymax) {
     ymax=yheight/2; ymin=-ymax; 
   } else {
     fprintf(stderr,"Slit: %s: Error: please specify EITHER ymin & ymax or ywidth\n", NAME_CURRENT_COMP); exit(-1);
   }
 }
 if (xmin == 0 && xmax == 0 && ymin == 0 && ymax == 0 && radius == 0)
    { fprintf(stderr,"Slit: %s: Warning: Running with CLOSED slit - is this intentional?? \n", NAME_CURRENT_COMP); }

}
#line 161119 "MACS_sample_kidney_box.c"
#undef yheight
#undef xwidth
#undef radius
#undef ymax
#undef ymin
#undef xmax
#undef xmin
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

  /* Initializations for component channel_4_filter. */
  SIG_MESSAGE("channel_4_filter (Init)");
#define mccompcurname  channel_4_filter
#define mccompcurtype  Slit_MACS
#define mccompcurindex 73
#define xmin mccchannel_4_filter_xmin
#define xmax mccchannel_4_filter_xmax
#define ymin mccchannel_4_filter_ymin
#define ymax mccchannel_4_filter_ymax
#define radius mccchannel_4_filter_radius
#define xwidth mccchannel_4_filter_xwidth
#define yheight mccchannel_4_filter_yheight
#line 50 "Slit_MACS.comp"
{
if (xwidth > 0)  { 
  if (!xmin && !xmax) {
    xmax=xwidth/2;  xmin=-xmax;
  } else {
    fprintf(stderr,"Slit: %s: Error: please specify EITHER xmin & xmax or xwidth\n", NAME_CURRENT_COMP); exit(-1);
  }
 }
 if (yheight > 0) { 
   if (!ymin && !ymax) {
     ymax=yheight/2; ymin=-ymax; 
   } else {
     fprintf(stderr,"Slit: %s: Error: please specify EITHER ymin & ymax or ywidth\n", NAME_CURRENT_COMP); exit(-1);
   }
 }
 if (xmin == 0 && xmax == 0 && ymin == 0 && ymax == 0 && radius == 0)
    { fprintf(stderr,"Slit: %s: Warning: Running with CLOSED slit - is this intentional?? \n", NAME_CURRENT_COMP); }

}
#line 161163 "MACS_sample_kidney_box.c"
#undef yheight
#undef xwidth
#undef radius
#undef ymax
#undef ymin
#undef xmax
#undef xmin
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

  /* Initializations for component channel_5_filter. */
  SIG_MESSAGE("channel_5_filter (Init)");
#define mccompcurname  channel_5_filter
#define mccompcurtype  Slit_MACS
#define mccompcurindex 74
#define xmin mccchannel_5_filter_xmin
#define xmax mccchannel_5_filter_xmax
#define ymin mccchannel_5_filter_ymin
#define ymax mccchannel_5_filter_ymax
#define radius mccchannel_5_filter_radius
#define xwidth mccchannel_5_filter_xwidth
#define yheight mccchannel_5_filter_yheight
#line 50 "Slit_MACS.comp"
{
if (xwidth > 0)  { 
  if (!xmin && !xmax) {
    xmax=xwidth/2;  xmin=-xmax;
  } else {
    fprintf(stderr,"Slit: %s: Error: please specify EITHER xmin & xmax or xwidth\n", NAME_CURRENT_COMP); exit(-1);
  }
 }
 if (yheight > 0) { 
   if (!ymin && !ymax) {
     ymax=yheight/2; ymin=-ymax; 
   } else {
     fprintf(stderr,"Slit: %s: Error: please specify EITHER ymin & ymax or ywidth\n", NAME_CURRENT_COMP); exit(-1);
   }
 }
 if (xmin == 0 && xmax == 0 && ymin == 0 && ymax == 0 && radius == 0)
    { fprintf(stderr,"Slit: %s: Warning: Running with CLOSED slit - is this intentional?? \n", NAME_CURRENT_COMP); }

}
#line 161207 "MACS_sample_kidney_box.c"
#undef yheight
#undef xwidth
#undef radius
#undef ymax
#undef ymin
#undef xmax
#undef xmin
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

  /* Initializations for component channel_6_filter. */
  SIG_MESSAGE("channel_6_filter (Init)");
#define mccompcurname  channel_6_filter
#define mccompcurtype  Slit_MACS
#define mccompcurindex 75
#define xmin mccchannel_6_filter_xmin
#define xmax mccchannel_6_filter_xmax
#define ymin mccchannel_6_filter_ymin
#define ymax mccchannel_6_filter_ymax
#define radius mccchannel_6_filter_radius
#define xwidth mccchannel_6_filter_xwidth
#define yheight mccchannel_6_filter_yheight
#line 50 "Slit_MACS.comp"
{
if (xwidth > 0)  { 
  if (!xmin && !xmax) {
    xmax=xwidth/2;  xmin=-xmax;
  } else {
    fprintf(stderr,"Slit: %s: Error: please specify EITHER xmin & xmax or xwidth\n", NAME_CURRENT_COMP); exit(-1);
  }
 }
 if (yheight > 0) { 
   if (!ymin && !ymax) {
     ymax=yheight/2; ymin=-ymax; 
   } else {
     fprintf(stderr,"Slit: %s: Error: please specify EITHER ymin & ymax or ywidth\n", NAME_CURRENT_COMP); exit(-1);
   }
 }
 if (xmin == 0 && xmax == 0 && ymin == 0 && ymax == 0 && radius == 0)
    { fprintf(stderr,"Slit: %s: Warning: Running with CLOSED slit - is this intentional?? \n", NAME_CURRENT_COMP); }

}
#line 161251 "MACS_sample_kidney_box.c"
#undef yheight
#undef xwidth
#undef radius
#undef ymax
#undef ymin
#undef xmax
#undef xmin
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

  /* Initializations for component channel_7_filter. */
  SIG_MESSAGE("channel_7_filter (Init)");
#define mccompcurname  channel_7_filter
#define mccompcurtype  Slit_MACS
#define mccompcurindex 76
#define xmin mccchannel_7_filter_xmin
#define xmax mccchannel_7_filter_xmax
#define ymin mccchannel_7_filter_ymin
#define ymax mccchannel_7_filter_ymax
#define radius mccchannel_7_filter_radius
#define xwidth mccchannel_7_filter_xwidth
#define yheight mccchannel_7_filter_yheight
#line 50 "Slit_MACS.comp"
{
if (xwidth > 0)  { 
  if (!xmin && !xmax) {
    xmax=xwidth/2;  xmin=-xmax;
  } else {
    fprintf(stderr,"Slit: %s: Error: please specify EITHER xmin & xmax or xwidth\n", NAME_CURRENT_COMP); exit(-1);
  }
 }
 if (yheight > 0) { 
   if (!ymin && !ymax) {
     ymax=yheight/2; ymin=-ymax; 
   } else {
     fprintf(stderr,"Slit: %s: Error: please specify EITHER ymin & ymax or ywidth\n", NAME_CURRENT_COMP); exit(-1);
   }
 }
 if (xmin == 0 && xmax == 0 && ymin == 0 && ymax == 0 && radius == 0)
    { fprintf(stderr,"Slit: %s: Warning: Running with CLOSED slit - is this intentional?? \n", NAME_CURRENT_COMP); }

}
#line 161295 "MACS_sample_kidney_box.c"
#undef yheight
#undef xwidth
#undef radius
#undef ymax
#undef ymin
#undef xmax
#undef xmin
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

  /* Initializations for component channel_8_filter. */
  SIG_MESSAGE("channel_8_filter (Init)");
#define mccompcurname  channel_8_filter
#define mccompcurtype  Slit_MACS
#define mccompcurindex 77
#define xmin mccchannel_8_filter_xmin
#define xmax mccchannel_8_filter_xmax
#define ymin mccchannel_8_filter_ymin
#define ymax mccchannel_8_filter_ymax
#define radius mccchannel_8_filter_radius
#define xwidth mccchannel_8_filter_xwidth
#define yheight mccchannel_8_filter_yheight
#line 50 "Slit_MACS.comp"
{
if (xwidth > 0)  { 
  if (!xmin && !xmax) {
    xmax=xwidth/2;  xmin=-xmax;
  } else {
    fprintf(stderr,"Slit: %s: Error: please specify EITHER xmin & xmax or xwidth\n", NAME_CURRENT_COMP); exit(-1);
  }
 }
 if (yheight > 0) { 
   if (!ymin && !ymax) {
     ymax=yheight/2; ymin=-ymax; 
   } else {
     fprintf(stderr,"Slit: %s: Error: please specify EITHER ymin & ymax or ywidth\n", NAME_CURRENT_COMP); exit(-1);
   }
 }
 if (xmin == 0 && xmax == 0 && ymin == 0 && ymax == 0 && radius == 0)
    { fprintf(stderr,"Slit: %s: Warning: Running with CLOSED slit - is this intentional?? \n", NAME_CURRENT_COMP); }

}
#line 161339 "MACS_sample_kidney_box.c"
#undef yheight
#undef xwidth
#undef radius
#undef ymax
#undef ymin
#undef xmax
#undef xmin
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

  /* Initializations for component channel_9_filter. */
  SIG_MESSAGE("channel_9_filter (Init)");
#define mccompcurname  channel_9_filter
#define mccompcurtype  Slit_MACS
#define mccompcurindex 78
#define xmin mccchannel_9_filter_xmin
#define xmax mccchannel_9_filter_xmax
#define ymin mccchannel_9_filter_ymin
#define ymax mccchannel_9_filter_ymax
#define radius mccchannel_9_filter_radius
#define xwidth mccchannel_9_filter_xwidth
#define yheight mccchannel_9_filter_yheight
#line 50 "Slit_MACS.comp"
{
if (xwidth > 0)  { 
  if (!xmin && !xmax) {
    xmax=xwidth/2;  xmin=-xmax;
  } else {
    fprintf(stderr,"Slit: %s: Error: please specify EITHER xmin & xmax or xwidth\n", NAME_CURRENT_COMP); exit(-1);
  }
 }
 if (yheight > 0) { 
   if (!ymin && !ymax) {
     ymax=yheight/2; ymin=-ymax; 
   } else {
     fprintf(stderr,"Slit: %s: Error: please specify EITHER ymin & ymax or ywidth\n", NAME_CURRENT_COMP); exit(-1);
   }
 }
 if (xmin == 0 && xmax == 0 && ymin == 0 && ymax == 0 && radius == 0)
    { fprintf(stderr,"Slit: %s: Warning: Running with CLOSED slit - is this intentional?? \n", NAME_CURRENT_COMP); }

}
#line 161383 "MACS_sample_kidney_box.c"
#undef yheight
#undef xwidth
#undef radius
#undef ymax
#undef ymin
#undef xmax
#undef xmin
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

  /* Initializations for component channel_10_filter. */
  SIG_MESSAGE("channel_10_filter (Init)");
#define mccompcurname  channel_10_filter
#define mccompcurtype  Slit_MACS
#define mccompcurindex 79
#define xmin mccchannel_10_filter_xmin
#define xmax mccchannel_10_filter_xmax
#define ymin mccchannel_10_filter_ymin
#define ymax mccchannel_10_filter_ymax
#define radius mccchannel_10_filter_radius
#define xwidth mccchannel_10_filter_xwidth
#define yheight mccchannel_10_filter_yheight
#line 50 "Slit_MACS.comp"
{
if (xwidth > 0)  { 
  if (!xmin && !xmax) {
    xmax=xwidth/2;  xmin=-xmax;
  } else {
    fprintf(stderr,"Slit: %s: Error: please specify EITHER xmin & xmax or xwidth\n", NAME_CURRENT_COMP); exit(-1);
  }
 }
 if (yheight > 0) { 
   if (!ymin && !ymax) {
     ymax=yheight/2; ymin=-ymax; 
   } else {
     fprintf(stderr,"Slit: %s: Error: please specify EITHER ymin & ymax or ywidth\n", NAME_CURRENT_COMP); exit(-1);
   }
 }
 if (xmin == 0 && xmax == 0 && ymin == 0 && ymax == 0 && radius == 0)
    { fprintf(stderr,"Slit: %s: Warning: Running with CLOSED slit - is this intentional?? \n", NAME_CURRENT_COMP); }

}
#line 161427 "MACS_sample_kidney_box.c"
#undef yheight
#undef xwidth
#undef radius
#undef ymax
#undef ymin
#undef xmax
#undef xmin
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

  /* Initializations for component channel_11_filter. */
  SIG_MESSAGE("channel_11_filter (Init)");
#define mccompcurname  channel_11_filter
#define mccompcurtype  Slit_MACS
#define mccompcurindex 80
#define xmin mccchannel_11_filter_xmin
#define xmax mccchannel_11_filter_xmax
#define ymin mccchannel_11_filter_ymin
#define ymax mccchannel_11_filter_ymax
#define radius mccchannel_11_filter_radius
#define xwidth mccchannel_11_filter_xwidth
#define yheight mccchannel_11_filter_yheight
#line 50 "Slit_MACS.comp"
{
if (xwidth > 0)  { 
  if (!xmin && !xmax) {
    xmax=xwidth/2;  xmin=-xmax;
  } else {
    fprintf(stderr,"Slit: %s: Error: please specify EITHER xmin & xmax or xwidth\n", NAME_CURRENT_COMP); exit(-1);
  }
 }
 if (yheight > 0) { 
   if (!ymin && !ymax) {
     ymax=yheight/2; ymin=-ymax; 
   } else {
     fprintf(stderr,"Slit: %s: Error: please specify EITHER ymin & ymax or ywidth\n", NAME_CURRENT_COMP); exit(-1);
   }
 }
 if (xmin == 0 && xmax == 0 && ymin == 0 && ymax == 0 && radius == 0)
    { fprintf(stderr,"Slit: %s: Warning: Running with CLOSED slit - is this intentional?? \n", NAME_CURRENT_COMP); }

}
#line 161471 "MACS_sample_kidney_box.c"
#undef yheight
#undef xwidth
#undef radius
#undef ymax
#undef ymin
#undef xmax
#undef xmin
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

  /* Initializations for component channel_12_filter. */
  SIG_MESSAGE("channel_12_filter (Init)");
#define mccompcurname  channel_12_filter
#define mccompcurtype  Slit_MACS
#define mccompcurindex 81
#define xmin mccchannel_12_filter_xmin
#define xmax mccchannel_12_filter_xmax
#define ymin mccchannel_12_filter_ymin
#define ymax mccchannel_12_filter_ymax
#define radius mccchannel_12_filter_radius
#define xwidth mccchannel_12_filter_xwidth
#define yheight mccchannel_12_filter_yheight
#line 50 "Slit_MACS.comp"
{
if (xwidth > 0)  { 
  if (!xmin && !xmax) {
    xmax=xwidth/2;  xmin=-xmax;
  } else {
    fprintf(stderr,"Slit: %s: Error: please specify EITHER xmin & xmax or xwidth\n", NAME_CURRENT_COMP); exit(-1);
  }
 }
 if (yheight > 0) { 
   if (!ymin && !ymax) {
     ymax=yheight/2; ymin=-ymax; 
   } else {
     fprintf(stderr,"Slit: %s: Error: please specify EITHER ymin & ymax or ywidth\n", NAME_CURRENT_COMP); exit(-1);
   }
 }
 if (xmin == 0 && xmax == 0 && ymin == 0 && ymax == 0 && radius == 0)
    { fprintf(stderr,"Slit: %s: Warning: Running with CLOSED slit - is this intentional?? \n", NAME_CURRENT_COMP); }

}
#line 161515 "MACS_sample_kidney_box.c"
#undef yheight
#undef xwidth
#undef radius
#undef ymax
#undef ymin
#undef xmax
#undef xmin
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

  /* Initializations for component channel_13_filter. */
  SIG_MESSAGE("channel_13_filter (Init)");
#define mccompcurname  channel_13_filter
#define mccompcurtype  Slit_MACS
#define mccompcurindex 82
#define xmin mccchannel_13_filter_xmin
#define xmax mccchannel_13_filter_xmax
#define ymin mccchannel_13_filter_ymin
#define ymax mccchannel_13_filter_ymax
#define radius mccchannel_13_filter_radius
#define xwidth mccchannel_13_filter_xwidth
#define yheight mccchannel_13_filter_yheight
#line 50 "Slit_MACS.comp"
{
if (xwidth > 0)  { 
  if (!xmin && !xmax) {
    xmax=xwidth/2;  xmin=-xmax;
  } else {
    fprintf(stderr,"Slit: %s: Error: please specify EITHER xmin & xmax or xwidth\n", NAME_CURRENT_COMP); exit(-1);
  }
 }
 if (yheight > 0) { 
   if (!ymin && !ymax) {
     ymax=yheight/2; ymin=-ymax; 
   } else {
     fprintf(stderr,"Slit: %s: Error: please specify EITHER ymin & ymax or ywidth\n", NAME_CURRENT_COMP); exit(-1);
   }
 }
 if (xmin == 0 && xmax == 0 && ymin == 0 && ymax == 0 && radius == 0)
    { fprintf(stderr,"Slit: %s: Warning: Running with CLOSED slit - is this intentional?? \n", NAME_CURRENT_COMP); }

}
#line 161559 "MACS_sample_kidney_box.c"
#undef yheight
#undef xwidth
#undef radius
#undef ymax
#undef ymin
#undef xmax
#undef xmin
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

  /* Initializations for component channel_14_filter. */
  SIG_MESSAGE("channel_14_filter (Init)");
#define mccompcurname  channel_14_filter
#define mccompcurtype  Slit_MACS
#define mccompcurindex 83
#define xmin mccchannel_14_filter_xmin
#define xmax mccchannel_14_filter_xmax
#define ymin mccchannel_14_filter_ymin
#define ymax mccchannel_14_filter_ymax
#define radius mccchannel_14_filter_radius
#define xwidth mccchannel_14_filter_xwidth
#define yheight mccchannel_14_filter_yheight
#line 50 "Slit_MACS.comp"
{
if (xwidth > 0)  { 
  if (!xmin && !xmax) {
    xmax=xwidth/2;  xmin=-xmax;
  } else {
    fprintf(stderr,"Slit: %s: Error: please specify EITHER xmin & xmax or xwidth\n", NAME_CURRENT_COMP); exit(-1);
  }
 }
 if (yheight > 0) { 
   if (!ymin && !ymax) {
     ymax=yheight/2; ymin=-ymax; 
   } else {
     fprintf(stderr,"Slit: %s: Error: please specify EITHER ymin & ymax or ywidth\n", NAME_CURRENT_COMP); exit(-1);
   }
 }
 if (xmin == 0 && xmax == 0 && ymin == 0 && ymax == 0 && radius == 0)
    { fprintf(stderr,"Slit: %s: Warning: Running with CLOSED slit - is this intentional?? \n", NAME_CURRENT_COMP); }

}
#line 161603 "MACS_sample_kidney_box.c"
#undef yheight
#undef xwidth
#undef radius
#undef ymax
#undef ymin
#undef xmax
#undef xmin
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

  /* Initializations for component channel_15_filter. */
  SIG_MESSAGE("channel_15_filter (Init)");
#define mccompcurname  channel_15_filter
#define mccompcurtype  Slit_MACS
#define mccompcurindex 84
#define xmin mccchannel_15_filter_xmin
#define xmax mccchannel_15_filter_xmax
#define ymin mccchannel_15_filter_ymin
#define ymax mccchannel_15_filter_ymax
#define radius mccchannel_15_filter_radius
#define xwidth mccchannel_15_filter_xwidth
#define yheight mccchannel_15_filter_yheight
#line 50 "Slit_MACS.comp"
{
if (xwidth > 0)  { 
  if (!xmin && !xmax) {
    xmax=xwidth/2;  xmin=-xmax;
  } else {
    fprintf(stderr,"Slit: %s: Error: please specify EITHER xmin & xmax or xwidth\n", NAME_CURRENT_COMP); exit(-1);
  }
 }
 if (yheight > 0) { 
   if (!ymin && !ymax) {
     ymax=yheight/2; ymin=-ymax; 
   } else {
     fprintf(stderr,"Slit: %s: Error: please specify EITHER ymin & ymax or ywidth\n", NAME_CURRENT_COMP); exit(-1);
   }
 }
 if (xmin == 0 && xmax == 0 && ymin == 0 && ymax == 0 && radius == 0)
    { fprintf(stderr,"Slit: %s: Warning: Running with CLOSED slit - is this intentional?? \n", NAME_CURRENT_COMP); }

}
#line 161647 "MACS_sample_kidney_box.c"
#undef yheight
#undef xwidth
#undef radius
#undef ymax
#undef ymin
#undef xmax
#undef xmin
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

  /* Initializations for component channel_16_filter. */
  SIG_MESSAGE("channel_16_filter (Init)");
#define mccompcurname  channel_16_filter
#define mccompcurtype  Slit_MACS
#define mccompcurindex 85
#define xmin mccchannel_16_filter_xmin
#define xmax mccchannel_16_filter_xmax
#define ymin mccchannel_16_filter_ymin
#define ymax mccchannel_16_filter_ymax
#define radius mccchannel_16_filter_radius
#define xwidth mccchannel_16_filter_xwidth
#define yheight mccchannel_16_filter_yheight
#line 50 "Slit_MACS.comp"
{
if (xwidth > 0)  { 
  if (!xmin && !xmax) {
    xmax=xwidth/2;  xmin=-xmax;
  } else {
    fprintf(stderr,"Slit: %s: Error: please specify EITHER xmin & xmax or xwidth\n", NAME_CURRENT_COMP); exit(-1);
  }
 }
 if (yheight > 0) { 
   if (!ymin && !ymax) {
     ymax=yheight/2; ymin=-ymax; 
   } else {
     fprintf(stderr,"Slit: %s: Error: please specify EITHER ymin & ymax or ywidth\n", NAME_CURRENT_COMP); exit(-1);
   }
 }
 if (xmin == 0 && xmax == 0 && ymin == 0 && ymax == 0 && radius == 0)
    { fprintf(stderr,"Slit: %s: Warning: Running with CLOSED slit - is this intentional?? \n", NAME_CURRENT_COMP); }

}
#line 161691 "MACS_sample_kidney_box.c"
#undef yheight
#undef xwidth
#undef radius
#undef ymax
#undef ymin
#undef xmax
#undef xmin
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

  /* Initializations for component channel_17_filter. */
  SIG_MESSAGE("channel_17_filter (Init)");
#define mccompcurname  channel_17_filter
#define mccompcurtype  Slit_MACS
#define mccompcurindex 86
#define xmin mccchannel_17_filter_xmin
#define xmax mccchannel_17_filter_xmax
#define ymin mccchannel_17_filter_ymin
#define ymax mccchannel_17_filter_ymax
#define radius mccchannel_17_filter_radius
#define xwidth mccchannel_17_filter_xwidth
#define yheight mccchannel_17_filter_yheight
#line 50 "Slit_MACS.comp"
{
if (xwidth > 0)  { 
  if (!xmin && !xmax) {
    xmax=xwidth/2;  xmin=-xmax;
  } else {
    fprintf(stderr,"Slit: %s: Error: please specify EITHER xmin & xmax or xwidth\n", NAME_CURRENT_COMP); exit(-1);
  }
 }
 if (yheight > 0) { 
   if (!ymin && !ymax) {
     ymax=yheight/2; ymin=-ymax; 
   } else {
     fprintf(stderr,"Slit: %s: Error: please specify EITHER ymin & ymax or ywidth\n", NAME_CURRENT_COMP); exit(-1);
   }
 }
 if (xmin == 0 && xmax == 0 && ymin == 0 && ymax == 0 && radius == 0)
    { fprintf(stderr,"Slit: %s: Warning: Running with CLOSED slit - is this intentional?? \n", NAME_CURRENT_COMP); }

}
#line 161735 "MACS_sample_kidney_box.c"
#undef yheight
#undef xwidth
#undef radius
#undef ymax
#undef ymin
#undef xmax
#undef xmin
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

  /* Initializations for component channel_18_filter. */
  SIG_MESSAGE("channel_18_filter (Init)");
#define mccompcurname  channel_18_filter
#define mccompcurtype  Slit_MACS
#define mccompcurindex 87
#define xmin mccchannel_18_filter_xmin
#define xmax mccchannel_18_filter_xmax
#define ymin mccchannel_18_filter_ymin
#define ymax mccchannel_18_filter_ymax
#define radius mccchannel_18_filter_radius
#define xwidth mccchannel_18_filter_xwidth
#define yheight mccchannel_18_filter_yheight
#line 50 "Slit_MACS.comp"
{
if (xwidth > 0)  { 
  if (!xmin && !xmax) {
    xmax=xwidth/2;  xmin=-xmax;
  } else {
    fprintf(stderr,"Slit: %s: Error: please specify EITHER xmin & xmax or xwidth\n", NAME_CURRENT_COMP); exit(-1);
  }
 }
 if (yheight > 0) { 
   if (!ymin && !ymax) {
     ymax=yheight/2; ymin=-ymax; 
   } else {
     fprintf(stderr,"Slit: %s: Error: please specify EITHER ymin & ymax or ywidth\n", NAME_CURRENT_COMP); exit(-1);
   }
 }
 if (xmin == 0 && xmax == 0 && ymin == 0 && ymax == 0 && radius == 0)
    { fprintf(stderr,"Slit: %s: Warning: Running with CLOSED slit - is this intentional?? \n", NAME_CURRENT_COMP); }

}
#line 161779 "MACS_sample_kidney_box.c"
#undef yheight
#undef xwidth
#undef radius
#undef ymax
#undef ymin
#undef xmax
#undef xmin
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

  /* Initializations for component channel_19_filter. */
  SIG_MESSAGE("channel_19_filter (Init)");
#define mccompcurname  channel_19_filter
#define mccompcurtype  Slit_MACS
#define mccompcurindex 88
#define xmin mccchannel_19_filter_xmin
#define xmax mccchannel_19_filter_xmax
#define ymin mccchannel_19_filter_ymin
#define ymax mccchannel_19_filter_ymax
#define radius mccchannel_19_filter_radius
#define xwidth mccchannel_19_filter_xwidth
#define yheight mccchannel_19_filter_yheight
#line 50 "Slit_MACS.comp"
{
if (xwidth > 0)  { 
  if (!xmin && !xmax) {
    xmax=xwidth/2;  xmin=-xmax;
  } else {
    fprintf(stderr,"Slit: %s: Error: please specify EITHER xmin & xmax or xwidth\n", NAME_CURRENT_COMP); exit(-1);
  }
 }
 if (yheight > 0) { 
   if (!ymin && !ymax) {
     ymax=yheight/2; ymin=-ymax; 
   } else {
     fprintf(stderr,"Slit: %s: Error: please specify EITHER ymin & ymax or ywidth\n", NAME_CURRENT_COMP); exit(-1);
   }
 }
 if (xmin == 0 && xmax == 0 && ymin == 0 && ymax == 0 && radius == 0)
    { fprintf(stderr,"Slit: %s: Warning: Running with CLOSED slit - is this intentional?? \n", NAME_CURRENT_COMP); }

}
#line 161823 "MACS_sample_kidney_box.c"
#undef yheight
#undef xwidth
#undef radius
#undef ymax
#undef ymin
#undef xmax
#undef xmin
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

  /* Initializations for component channel_selector. */
  SIG_MESSAGE("channel_selector (Init)");

  /* Initializations for component channel_0_colimator. */
  SIG_MESSAGE("channel_0_colimator (Init)");
#define mccompcurname  channel_0_colimator
#define mccompcurtype  Collimator_linear
#define mccompcurindex 90
#define slope mccchannel_0_colimator_slope
#define slopeV mccchannel_0_colimator_slopeV
#define xmin mccchannel_0_colimator_xmin
#define xmax mccchannel_0_colimator_xmax
#define ymin mccchannel_0_colimator_ymin
#define ymax mccchannel_0_colimator_ymax
#define xwidth mccchannel_0_colimator_xwidth
#define yheight mccchannel_0_colimator_yheight
#define length mccchannel_0_colimator_length
#define divergence mccchannel_0_colimator_divergence
#define transmission mccchannel_0_colimator_transmission
#define divergenceV mccchannel_0_colimator_divergenceV
#line 54 "/usr/share/mcstas/2.7/optics/Collimator_linear.comp"
{
slope = tan(MIN2RAD*divergence);
  slopeV= tan(MIN2RAD*divergenceV);
  if (xwidth  > 0) { xmax = xwidth/2;  xmin = -xmax; }
  if (yheight > 0) { ymax = yheight/2; ymin = -ymax; }

  if ((xmin >= xmax) || (ymin >= ymax)) {
    printf("Collimator_linear: %s: Null slit opening area !\n"
	         "ERROR              (xwidth,yheight,xmin,xmax,ymin,ymax). Exiting",
           NAME_CURRENT_COMP);
    exit(-1);
  }

}
#line 161870 "MACS_sample_kidney_box.c"
#undef divergenceV
#undef transmission
#undef divergence
#undef length
#undef yheight
#undef xwidth
#undef ymax
#undef ymin
#undef xmax
#undef xmin
#undef slopeV
#undef slope
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

  /* Initializations for component channel_1_colimator. */
  SIG_MESSAGE("channel_1_colimator (Init)");
#define mccompcurname  channel_1_colimator
#define mccompcurtype  Collimator_linear
#define mccompcurindex 91
#define slope mccchannel_1_colimator_slope
#define slopeV mccchannel_1_colimator_slopeV
#define xmin mccchannel_1_colimator_xmin
#define xmax mccchannel_1_colimator_xmax
#define ymin mccchannel_1_colimator_ymin
#define ymax mccchannel_1_colimator_ymax
#define xwidth mccchannel_1_colimator_xwidth
#define yheight mccchannel_1_colimator_yheight
#define length mccchannel_1_colimator_length
#define divergence mccchannel_1_colimator_divergence
#define transmission mccchannel_1_colimator_transmission
#define divergenceV mccchannel_1_colimator_divergenceV
#line 54 "/usr/share/mcstas/2.7/optics/Collimator_linear.comp"
{
slope = tan(MIN2RAD*divergence);
  slopeV= tan(MIN2RAD*divergenceV);
  if (xwidth  > 0) { xmax = xwidth/2;  xmin = -xmax; }
  if (yheight > 0) { ymax = yheight/2; ymin = -ymax; }

  if ((xmin >= xmax) || (ymin >= ymax)) {
    printf("Collimator_linear: %s: Null slit opening area !\n"
	         "ERROR              (xwidth,yheight,xmin,xmax,ymin,ymax). Exiting",
           NAME_CURRENT_COMP);
    exit(-1);
  }

}
#line 161919 "MACS_sample_kidney_box.c"
#undef divergenceV
#undef transmission
#undef divergence
#undef length
#undef yheight
#undef xwidth
#undef ymax
#undef ymin
#undef xmax
#undef xmin
#undef slopeV
#undef slope
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

  /* Initializations for component channel_2_colimator. */
  SIG_MESSAGE("channel_2_colimator (Init)");
#define mccompcurname  channel_2_colimator
#define mccompcurtype  Collimator_linear
#define mccompcurindex 92
#define slope mccchannel_2_colimator_slope
#define slopeV mccchannel_2_colimator_slopeV
#define xmin mccchannel_2_colimator_xmin
#define xmax mccchannel_2_colimator_xmax
#define ymin mccchannel_2_colimator_ymin
#define ymax mccchannel_2_colimator_ymax
#define xwidth mccchannel_2_colimator_xwidth
#define yheight mccchannel_2_colimator_yheight
#define length mccchannel_2_colimator_length
#define divergence mccchannel_2_colimator_divergence
#define transmission mccchannel_2_colimator_transmission
#define divergenceV mccchannel_2_colimator_divergenceV
#line 54 "/usr/share/mcstas/2.7/optics/Collimator_linear.comp"
{
slope = tan(MIN2RAD*divergence);
  slopeV= tan(MIN2RAD*divergenceV);
  if (xwidth  > 0) { xmax = xwidth/2;  xmin = -xmax; }
  if (yheight > 0) { ymax = yheight/2; ymin = -ymax; }

  if ((xmin >= xmax) || (ymin >= ymax)) {
    printf("Collimator_linear: %s: Null slit opening area !\n"
	         "ERROR              (xwidth,yheight,xmin,xmax,ymin,ymax). Exiting",
           NAME_CURRENT_COMP);
    exit(-1);
  }

}
#line 161968 "MACS_sample_kidney_box.c"
#undef divergenceV
#undef transmission
#undef divergence
#undef length
#undef yheight
#undef xwidth
#undef ymax
#undef ymin
#undef xmax
#undef xmin
#undef slopeV
#undef slope
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

  /* Initializations for component channel_3_colimator. */
  SIG_MESSAGE("channel_3_colimator (Init)");
#define mccompcurname  channel_3_colimator
#define mccompcurtype  Collimator_linear
#define mccompcurindex 93
#define slope mccchannel_3_colimator_slope
#define slopeV mccchannel_3_colimator_slopeV
#define xmin mccchannel_3_colimator_xmin
#define xmax mccchannel_3_colimator_xmax
#define ymin mccchannel_3_colimator_ymin
#define ymax mccchannel_3_colimator_ymax
#define xwidth mccchannel_3_colimator_xwidth
#define yheight mccchannel_3_colimator_yheight
#define length mccchannel_3_colimator_length
#define divergence mccchannel_3_colimator_divergence
#define transmission mccchannel_3_colimator_transmission
#define divergenceV mccchannel_3_colimator_divergenceV
#line 54 "/usr/share/mcstas/2.7/optics/Collimator_linear.comp"
{
slope = tan(MIN2RAD*divergence);
  slopeV= tan(MIN2RAD*divergenceV);
  if (xwidth  > 0) { xmax = xwidth/2;  xmin = -xmax; }
  if (yheight > 0) { ymax = yheight/2; ymin = -ymax; }

  if ((xmin >= xmax) || (ymin >= ymax)) {
    printf("Collimator_linear: %s: Null slit opening area !\n"
	         "ERROR              (xwidth,yheight,xmin,xmax,ymin,ymax). Exiting",
           NAME_CURRENT_COMP);
    exit(-1);
  }

}
#line 162017 "MACS_sample_kidney_box.c"
#undef divergenceV
#undef transmission
#undef divergence
#undef length
#undef yheight
#undef xwidth
#undef ymax
#undef ymin
#undef xmax
#undef xmin
#undef slopeV
#undef slope
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

  /* Initializations for component channel_4_colimator. */
  SIG_MESSAGE("channel_4_colimator (Init)");
#define mccompcurname  channel_4_colimator
#define mccompcurtype  Collimator_linear
#define mccompcurindex 94
#define slope mccchannel_4_colimator_slope
#define slopeV mccchannel_4_colimator_slopeV
#define xmin mccchannel_4_colimator_xmin
#define xmax mccchannel_4_colimator_xmax
#define ymin mccchannel_4_colimator_ymin
#define ymax mccchannel_4_colimator_ymax
#define xwidth mccchannel_4_colimator_xwidth
#define yheight mccchannel_4_colimator_yheight
#define length mccchannel_4_colimator_length
#define divergence mccchannel_4_colimator_divergence
#define transmission mccchannel_4_colimator_transmission
#define divergenceV mccchannel_4_colimator_divergenceV
#line 54 "/usr/share/mcstas/2.7/optics/Collimator_linear.comp"
{
slope = tan(MIN2RAD*divergence);
  slopeV= tan(MIN2RAD*divergenceV);
  if (xwidth  > 0) { xmax = xwidth/2;  xmin = -xmax; }
  if (yheight > 0) { ymax = yheight/2; ymin = -ymax; }

  if ((xmin >= xmax) || (ymin >= ymax)) {
    printf("Collimator_linear: %s: Null slit opening area !\n"
	         "ERROR              (xwidth,yheight,xmin,xmax,ymin,ymax). Exiting",
           NAME_CURRENT_COMP);
    exit(-1);
  }

}
#line 162066 "MACS_sample_kidney_box.c"
#undef divergenceV
#undef transmission
#undef divergence
#undef length
#undef yheight
#undef xwidth
#undef ymax
#undef ymin
#undef xmax
#undef xmin
#undef slopeV
#undef slope
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

  /* Initializations for component channel_5_colimator. */
  SIG_MESSAGE("channel_5_colimator (Init)");
#define mccompcurname  channel_5_colimator
#define mccompcurtype  Collimator_linear
#define mccompcurindex 95
#define slope mccchannel_5_colimator_slope
#define slopeV mccchannel_5_colimator_slopeV
#define xmin mccchannel_5_colimator_xmin
#define xmax mccchannel_5_colimator_xmax
#define ymin mccchannel_5_colimator_ymin
#define ymax mccchannel_5_colimator_ymax
#define xwidth mccchannel_5_colimator_xwidth
#define yheight mccchannel_5_colimator_yheight
#define length mccchannel_5_colimator_length
#define divergence mccchannel_5_colimator_divergence
#define transmission mccchannel_5_colimator_transmission
#define divergenceV mccchannel_5_colimator_divergenceV
#line 54 "/usr/share/mcstas/2.7/optics/Collimator_linear.comp"
{
slope = tan(MIN2RAD*divergence);
  slopeV= tan(MIN2RAD*divergenceV);
  if (xwidth  > 0) { xmax = xwidth/2;  xmin = -xmax; }
  if (yheight > 0) { ymax = yheight/2; ymin = -ymax; }

  if ((xmin >= xmax) || (ymin >= ymax)) {
    printf("Collimator_linear: %s: Null slit opening area !\n"
	         "ERROR              (xwidth,yheight,xmin,xmax,ymin,ymax). Exiting",
           NAME_CURRENT_COMP);
    exit(-1);
  }

}
#line 162115 "MACS_sample_kidney_box.c"
#undef divergenceV
#undef transmission
#undef divergence
#undef length
#undef yheight
#undef xwidth
#undef ymax
#undef ymin
#undef xmax
#undef xmin
#undef slopeV
#undef slope
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

  /* Initializations for component channel_6_colimator. */
  SIG_MESSAGE("channel_6_colimator (Init)");
#define mccompcurname  channel_6_colimator
#define mccompcurtype  Collimator_linear
#define mccompcurindex 96
#define slope mccchannel_6_colimator_slope
#define slopeV mccchannel_6_colimator_slopeV
#define xmin mccchannel_6_colimator_xmin
#define xmax mccchannel_6_colimator_xmax
#define ymin mccchannel_6_colimator_ymin
#define ymax mccchannel_6_colimator_ymax
#define xwidth mccchannel_6_colimator_xwidth
#define yheight mccchannel_6_colimator_yheight
#define length mccchannel_6_colimator_length
#define divergence mccchannel_6_colimator_divergence
#define transmission mccchannel_6_colimator_transmission
#define divergenceV mccchannel_6_colimator_divergenceV
#line 54 "/usr/share/mcstas/2.7/optics/Collimator_linear.comp"
{
slope = tan(MIN2RAD*divergence);
  slopeV= tan(MIN2RAD*divergenceV);
  if (xwidth  > 0) { xmax = xwidth/2;  xmin = -xmax; }
  if (yheight > 0) { ymax = yheight/2; ymin = -ymax; }

  if ((xmin >= xmax) || (ymin >= ymax)) {
    printf("Collimator_linear: %s: Null slit opening area !\n"
	         "ERROR              (xwidth,yheight,xmin,xmax,ymin,ymax). Exiting",
           NAME_CURRENT_COMP);
    exit(-1);
  }

}
#line 162164 "MACS_sample_kidney_box.c"
#undef divergenceV
#undef transmission
#undef divergence
#undef length
#undef yheight
#undef xwidth
#undef ymax
#undef ymin
#undef xmax
#undef xmin
#undef slopeV
#undef slope
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

  /* Initializations for component channel_7_colimator. */
  SIG_MESSAGE("channel_7_colimator (Init)");
#define mccompcurname  channel_7_colimator
#define mccompcurtype  Collimator_linear
#define mccompcurindex 97
#define slope mccchannel_7_colimator_slope
#define slopeV mccchannel_7_colimator_slopeV
#define xmin mccchannel_7_colimator_xmin
#define xmax mccchannel_7_colimator_xmax
#define ymin mccchannel_7_colimator_ymin
#define ymax mccchannel_7_colimator_ymax
#define xwidth mccchannel_7_colimator_xwidth
#define yheight mccchannel_7_colimator_yheight
#define length mccchannel_7_colimator_length
#define divergence mccchannel_7_colimator_divergence
#define transmission mccchannel_7_colimator_transmission
#define divergenceV mccchannel_7_colimator_divergenceV
#line 54 "/usr/share/mcstas/2.7/optics/Collimator_linear.comp"
{
slope = tan(MIN2RAD*divergence);
  slopeV= tan(MIN2RAD*divergenceV);
  if (xwidth  > 0) { xmax = xwidth/2;  xmin = -xmax; }
  if (yheight > 0) { ymax = yheight/2; ymin = -ymax; }

  if ((xmin >= xmax) || (ymin >= ymax)) {
    printf("Collimator_linear: %s: Null slit opening area !\n"
	         "ERROR              (xwidth,yheight,xmin,xmax,ymin,ymax). Exiting",
           NAME_CURRENT_COMP);
    exit(-1);
  }

}
#line 162213 "MACS_sample_kidney_box.c"
#undef divergenceV
#undef transmission
#undef divergence
#undef length
#undef yheight
#undef xwidth
#undef ymax
#undef ymin
#undef xmax
#undef xmin
#undef slopeV
#undef slope
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

  /* Initializations for component channel_8_colimator. */
  SIG_MESSAGE("channel_8_colimator (Init)");
#define mccompcurname  channel_8_colimator
#define mccompcurtype  Collimator_linear
#define mccompcurindex 98
#define slope mccchannel_8_colimator_slope
#define slopeV mccchannel_8_colimator_slopeV
#define xmin mccchannel_8_colimator_xmin
#define xmax mccchannel_8_colimator_xmax
#define ymin mccchannel_8_colimator_ymin
#define ymax mccchannel_8_colimator_ymax
#define xwidth mccchannel_8_colimator_xwidth
#define yheight mccchannel_8_colimator_yheight
#define length mccchannel_8_colimator_length
#define divergence mccchannel_8_colimator_divergence
#define transmission mccchannel_8_colimator_transmission
#define divergenceV mccchannel_8_colimator_divergenceV
#line 54 "/usr/share/mcstas/2.7/optics/Collimator_linear.comp"
{
slope = tan(MIN2RAD*divergence);
  slopeV= tan(MIN2RAD*divergenceV);
  if (xwidth  > 0) { xmax = xwidth/2;  xmin = -xmax; }
  if (yheight > 0) { ymax = yheight/2; ymin = -ymax; }

  if ((xmin >= xmax) || (ymin >= ymax)) {
    printf("Collimator_linear: %s: Null slit opening area !\n"
	         "ERROR              (xwidth,yheight,xmin,xmax,ymin,ymax). Exiting",
           NAME_CURRENT_COMP);
    exit(-1);
  }

}
#line 162262 "MACS_sample_kidney_box.c"
#undef divergenceV
#undef transmission
#undef divergence
#undef length
#undef yheight
#undef xwidth
#undef ymax
#undef ymin
#undef xmax
#undef xmin
#undef slopeV
#undef slope
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

  /* Initializations for component channel_9_colimator. */
  SIG_MESSAGE("channel_9_colimator (Init)");
#define mccompcurname  channel_9_colimator
#define mccompcurtype  Collimator_linear
#define mccompcurindex 99
#define slope mccchannel_9_colimator_slope
#define slopeV mccchannel_9_colimator_slopeV
#define xmin mccchannel_9_colimator_xmin
#define xmax mccchannel_9_colimator_xmax
#define ymin mccchannel_9_colimator_ymin
#define ymax mccchannel_9_colimator_ymax
#define xwidth mccchannel_9_colimator_xwidth
#define yheight mccchannel_9_colimator_yheight
#define length mccchannel_9_colimator_length
#define divergence mccchannel_9_colimator_divergence
#define transmission mccchannel_9_colimator_transmission
#define divergenceV mccchannel_9_colimator_divergenceV
#line 54 "/usr/share/mcstas/2.7/optics/Collimator_linear.comp"
{
slope = tan(MIN2RAD*divergence);
  slopeV= tan(MIN2RAD*divergenceV);
  if (xwidth  > 0) { xmax = xwidth/2;  xmin = -xmax; }
  if (yheight > 0) { ymax = yheight/2; ymin = -ymax; }

  if ((xmin >= xmax) || (ymin >= ymax)) {
    printf("Collimator_linear: %s: Null slit opening area !\n"
	         "ERROR              (xwidth,yheight,xmin,xmax,ymin,ymax). Exiting",
           NAME_CURRENT_COMP);
    exit(-1);
  }

}
#line 162311 "MACS_sample_kidney_box.c"
#undef divergenceV
#undef transmission
#undef divergence
#undef length
#undef yheight
#undef xwidth
#undef ymax
#undef ymin
#undef xmax
#undef xmin
#undef slopeV
#undef slope
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

  /* Initializations for component channel_10_colimator. */
  SIG_MESSAGE("channel_10_colimator (Init)");
#define mccompcurname  channel_10_colimator
#define mccompcurtype  Collimator_linear
#define mccompcurindex 100
#define slope mccchannel_10_colimator_slope
#define slopeV mccchannel_10_colimator_slopeV
#define xmin mccchannel_10_colimator_xmin
#define xmax mccchannel_10_colimator_xmax
#define ymin mccchannel_10_colimator_ymin
#define ymax mccchannel_10_colimator_ymax
#define xwidth mccchannel_10_colimator_xwidth
#define yheight mccchannel_10_colimator_yheight
#define length mccchannel_10_colimator_length
#define divergence mccchannel_10_colimator_divergence
#define transmission mccchannel_10_colimator_transmission
#define divergenceV mccchannel_10_colimator_divergenceV
#line 54 "/usr/share/mcstas/2.7/optics/Collimator_linear.comp"
{
slope = tan(MIN2RAD*divergence);
  slopeV= tan(MIN2RAD*divergenceV);
  if (xwidth  > 0) { xmax = xwidth/2;  xmin = -xmax; }
  if (yheight > 0) { ymax = yheight/2; ymin = -ymax; }

  if ((xmin >= xmax) || (ymin >= ymax)) {
    printf("Collimator_linear: %s: Null slit opening area !\n"
	         "ERROR              (xwidth,yheight,xmin,xmax,ymin,ymax). Exiting",
           NAME_CURRENT_COMP);
    exit(-1);
  }

}
#line 162360 "MACS_sample_kidney_box.c"
#undef divergenceV
#undef transmission
#undef divergence
#undef length
#undef yheight
#undef xwidth
#undef ymax
#undef ymin
#undef xmax
#undef xmin
#undef slopeV
#undef slope
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

  /* Initializations for component channel_11_colimator. */
  SIG_MESSAGE("channel_11_colimator (Init)");
#define mccompcurname  channel_11_colimator
#define mccompcurtype  Collimator_linear
#define mccompcurindex 101
#define slope mccchannel_11_colimator_slope
#define slopeV mccchannel_11_colimator_slopeV
#define xmin mccchannel_11_colimator_xmin
#define xmax mccchannel_11_colimator_xmax
#define ymin mccchannel_11_colimator_ymin
#define ymax mccchannel_11_colimator_ymax
#define xwidth mccchannel_11_colimator_xwidth
#define yheight mccchannel_11_colimator_yheight
#define length mccchannel_11_colimator_length
#define divergence mccchannel_11_colimator_divergence
#define transmission mccchannel_11_colimator_transmission
#define divergenceV mccchannel_11_colimator_divergenceV
#line 54 "/usr/share/mcstas/2.7/optics/Collimator_linear.comp"
{
slope = tan(MIN2RAD*divergence);
  slopeV= tan(MIN2RAD*divergenceV);
  if (xwidth  > 0) { xmax = xwidth/2;  xmin = -xmax; }
  if (yheight > 0) { ymax = yheight/2; ymin = -ymax; }

  if ((xmin >= xmax) || (ymin >= ymax)) {
    printf("Collimator_linear: %s: Null slit opening area !\n"
	         "ERROR              (xwidth,yheight,xmin,xmax,ymin,ymax). Exiting",
           NAME_CURRENT_COMP);
    exit(-1);
  }

}
#line 162409 "MACS_sample_kidney_box.c"
#undef divergenceV
#undef transmission
#undef divergence
#undef length
#undef yheight
#undef xwidth
#undef ymax
#undef ymin
#undef xmax
#undef xmin
#undef slopeV
#undef slope
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

  /* Initializations for component channel_12_colimator. */
  SIG_MESSAGE("channel_12_colimator (Init)");
#define mccompcurname  channel_12_colimator
#define mccompcurtype  Collimator_linear
#define mccompcurindex 102
#define slope mccchannel_12_colimator_slope
#define slopeV mccchannel_12_colimator_slopeV
#define xmin mccchannel_12_colimator_xmin
#define xmax mccchannel_12_colimator_xmax
#define ymin mccchannel_12_colimator_ymin
#define ymax mccchannel_12_colimator_ymax
#define xwidth mccchannel_12_colimator_xwidth
#define yheight mccchannel_12_colimator_yheight
#define length mccchannel_12_colimator_length
#define divergence mccchannel_12_colimator_divergence
#define transmission mccchannel_12_colimator_transmission
#define divergenceV mccchannel_12_colimator_divergenceV
#line 54 "/usr/share/mcstas/2.7/optics/Collimator_linear.comp"
{
slope = tan(MIN2RAD*divergence);
  slopeV= tan(MIN2RAD*divergenceV);
  if (xwidth  > 0) { xmax = xwidth/2;  xmin = -xmax; }
  if (yheight > 0) { ymax = yheight/2; ymin = -ymax; }

  if ((xmin >= xmax) || (ymin >= ymax)) {
    printf("Collimator_linear: %s: Null slit opening area !\n"
	         "ERROR              (xwidth,yheight,xmin,xmax,ymin,ymax). Exiting",
           NAME_CURRENT_COMP);
    exit(-1);
  }

}
#line 162458 "MACS_sample_kidney_box.c"
#undef divergenceV
#undef transmission
#undef divergence
#undef length
#undef yheight
#undef xwidth
#undef ymax
#undef ymin
#undef xmax
#undef xmin
#undef slopeV
#undef slope
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

  /* Initializations for component channel_13_colimator. */
  SIG_MESSAGE("channel_13_colimator (Init)");
#define mccompcurname  channel_13_colimator
#define mccompcurtype  Collimator_linear
#define mccompcurindex 103
#define slope mccchannel_13_colimator_slope
#define slopeV mccchannel_13_colimator_slopeV
#define xmin mccchannel_13_colimator_xmin
#define xmax mccchannel_13_colimator_xmax
#define ymin mccchannel_13_colimator_ymin
#define ymax mccchannel_13_colimator_ymax
#define xwidth mccchannel_13_colimator_xwidth
#define yheight mccchannel_13_colimator_yheight
#define length mccchannel_13_colimator_length
#define divergence mccchannel_13_colimator_divergence
#define transmission mccchannel_13_colimator_transmission
#define divergenceV mccchannel_13_colimator_divergenceV
#line 54 "/usr/share/mcstas/2.7/optics/Collimator_linear.comp"
{
slope = tan(MIN2RAD*divergence);
  slopeV= tan(MIN2RAD*divergenceV);
  if (xwidth  > 0) { xmax = xwidth/2;  xmin = -xmax; }
  if (yheight > 0) { ymax = yheight/2; ymin = -ymax; }

  if ((xmin >= xmax) || (ymin >= ymax)) {
    printf("Collimator_linear: %s: Null slit opening area !\n"
	         "ERROR              (xwidth,yheight,xmin,xmax,ymin,ymax). Exiting",
           NAME_CURRENT_COMP);
    exit(-1);
  }

}
#line 162507 "MACS_sample_kidney_box.c"
#undef divergenceV
#undef transmission
#undef divergence
#undef length
#undef yheight
#undef xwidth
#undef ymax
#undef ymin
#undef xmax
#undef xmin
#undef slopeV
#undef slope
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

  /* Initializations for component channel_14_colimator. */
  SIG_MESSAGE("channel_14_colimator (Init)");
#define mccompcurname  channel_14_colimator
#define mccompcurtype  Collimator_linear
#define mccompcurindex 104
#define slope mccchannel_14_colimator_slope
#define slopeV mccchannel_14_colimator_slopeV
#define xmin mccchannel_14_colimator_xmin
#define xmax mccchannel_14_colimator_xmax
#define ymin mccchannel_14_colimator_ymin
#define ymax mccchannel_14_colimator_ymax
#define xwidth mccchannel_14_colimator_xwidth
#define yheight mccchannel_14_colimator_yheight
#define length mccchannel_14_colimator_length
#define divergence mccchannel_14_colimator_divergence
#define transmission mccchannel_14_colimator_transmission
#define divergenceV mccchannel_14_colimator_divergenceV
#line 54 "/usr/share/mcstas/2.7/optics/Collimator_linear.comp"
{
slope = tan(MIN2RAD*divergence);
  slopeV= tan(MIN2RAD*divergenceV);
  if (xwidth  > 0) { xmax = xwidth/2;  xmin = -xmax; }
  if (yheight > 0) { ymax = yheight/2; ymin = -ymax; }

  if ((xmin >= xmax) || (ymin >= ymax)) {
    printf("Collimator_linear: %s: Null slit opening area !\n"
	         "ERROR              (xwidth,yheight,xmin,xmax,ymin,ymax). Exiting",
           NAME_CURRENT_COMP);
    exit(-1);
  }

}
#line 162556 "MACS_sample_kidney_box.c"
#undef divergenceV
#undef transmission
#undef divergence
#undef length
#undef yheight
#undef xwidth
#undef ymax
#undef ymin
#undef xmax
#undef xmin
#undef slopeV
#undef slope
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

  /* Initializations for component channel_15_colimator. */
  SIG_MESSAGE("channel_15_colimator (Init)");
#define mccompcurname  channel_15_colimator
#define mccompcurtype  Collimator_linear
#define mccompcurindex 105
#define slope mccchannel_15_colimator_slope
#define slopeV mccchannel_15_colimator_slopeV
#define xmin mccchannel_15_colimator_xmin
#define xmax mccchannel_15_colimator_xmax
#define ymin mccchannel_15_colimator_ymin
#define ymax mccchannel_15_colimator_ymax
#define xwidth mccchannel_15_colimator_xwidth
#define yheight mccchannel_15_colimator_yheight
#define length mccchannel_15_colimator_length
#define divergence mccchannel_15_colimator_divergence
#define transmission mccchannel_15_colimator_transmission
#define divergenceV mccchannel_15_colimator_divergenceV
#line 54 "/usr/share/mcstas/2.7/optics/Collimator_linear.comp"
{
slope = tan(MIN2RAD*divergence);
  slopeV= tan(MIN2RAD*divergenceV);
  if (xwidth  > 0) { xmax = xwidth/2;  xmin = -xmax; }
  if (yheight > 0) { ymax = yheight/2; ymin = -ymax; }

  if ((xmin >= xmax) || (ymin >= ymax)) {
    printf("Collimator_linear: %s: Null slit opening area !\n"
	         "ERROR              (xwidth,yheight,xmin,xmax,ymin,ymax). Exiting",
           NAME_CURRENT_COMP);
    exit(-1);
  }

}
#line 162605 "MACS_sample_kidney_box.c"
#undef divergenceV
#undef transmission
#undef divergence
#undef length
#undef yheight
#undef xwidth
#undef ymax
#undef ymin
#undef xmax
#undef xmin
#undef slopeV
#undef slope
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

  /* Initializations for component channel_16_colimator. */
  SIG_MESSAGE("channel_16_colimator (Init)");
#define mccompcurname  channel_16_colimator
#define mccompcurtype  Collimator_linear
#define mccompcurindex 106
#define slope mccchannel_16_colimator_slope
#define slopeV mccchannel_16_colimator_slopeV
#define xmin mccchannel_16_colimator_xmin
#define xmax mccchannel_16_colimator_xmax
#define ymin mccchannel_16_colimator_ymin
#define ymax mccchannel_16_colimator_ymax
#define xwidth mccchannel_16_colimator_xwidth
#define yheight mccchannel_16_colimator_yheight
#define length mccchannel_16_colimator_length
#define divergence mccchannel_16_colimator_divergence
#define transmission mccchannel_16_colimator_transmission
#define divergenceV mccchannel_16_colimator_divergenceV
#line 54 "/usr/share/mcstas/2.7/optics/Collimator_linear.comp"
{
slope = tan(MIN2RAD*divergence);
  slopeV= tan(MIN2RAD*divergenceV);
  if (xwidth  > 0) { xmax = xwidth/2;  xmin = -xmax; }
  if (yheight > 0) { ymax = yheight/2; ymin = -ymax; }

  if ((xmin >= xmax) || (ymin >= ymax)) {
    printf("Collimator_linear: %s: Null slit opening area !\n"
	         "ERROR              (xwidth,yheight,xmin,xmax,ymin,ymax). Exiting",
           NAME_CURRENT_COMP);
    exit(-1);
  }

}
#line 162654 "MACS_sample_kidney_box.c"
#undef divergenceV
#undef transmission
#undef divergence
#undef length
#undef yheight
#undef xwidth
#undef ymax
#undef ymin
#undef xmax
#undef xmin
#undef slopeV
#undef slope
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

  /* Initializations for component channel_17_colimator. */
  SIG_MESSAGE("channel_17_colimator (Init)");
#define mccompcurname  channel_17_colimator
#define mccompcurtype  Collimator_linear
#define mccompcurindex 107
#define slope mccchannel_17_colimator_slope
#define slopeV mccchannel_17_colimator_slopeV
#define xmin mccchannel_17_colimator_xmin
#define xmax mccchannel_17_colimator_xmax
#define ymin mccchannel_17_colimator_ymin
#define ymax mccchannel_17_colimator_ymax
#define xwidth mccchannel_17_colimator_xwidth
#define yheight mccchannel_17_colimator_yheight
#define length mccchannel_17_colimator_length
#define divergence mccchannel_17_colimator_divergence
#define transmission mccchannel_17_colimator_transmission
#define divergenceV mccchannel_17_colimator_divergenceV
#line 54 "/usr/share/mcstas/2.7/optics/Collimator_linear.comp"
{
slope = tan(MIN2RAD*divergence);
  slopeV= tan(MIN2RAD*divergenceV);
  if (xwidth  > 0) { xmax = xwidth/2;  xmin = -xmax; }
  if (yheight > 0) { ymax = yheight/2; ymin = -ymax; }

  if ((xmin >= xmax) || (ymin >= ymax)) {
    printf("Collimator_linear: %s: Null slit opening area !\n"
	         "ERROR              (xwidth,yheight,xmin,xmax,ymin,ymax). Exiting",
           NAME_CURRENT_COMP);
    exit(-1);
  }

}
#line 162703 "MACS_sample_kidney_box.c"
#undef divergenceV
#undef transmission
#undef divergence
#undef length
#undef yheight
#undef xwidth
#undef ymax
#undef ymin
#undef xmax
#undef xmin
#undef slopeV
#undef slope
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

  /* Initializations for component channel_18_colimator. */
  SIG_MESSAGE("channel_18_colimator (Init)");
#define mccompcurname  channel_18_colimator
#define mccompcurtype  Collimator_linear
#define mccompcurindex 108
#define slope mccchannel_18_colimator_slope
#define slopeV mccchannel_18_colimator_slopeV
#define xmin mccchannel_18_colimator_xmin
#define xmax mccchannel_18_colimator_xmax
#define ymin mccchannel_18_colimator_ymin
#define ymax mccchannel_18_colimator_ymax
#define xwidth mccchannel_18_colimator_xwidth
#define yheight mccchannel_18_colimator_yheight
#define length mccchannel_18_colimator_length
#define divergence mccchannel_18_colimator_divergence
#define transmission mccchannel_18_colimator_transmission
#define divergenceV mccchannel_18_colimator_divergenceV
#line 54 "/usr/share/mcstas/2.7/optics/Collimator_linear.comp"
{
slope = tan(MIN2RAD*divergence);
  slopeV= tan(MIN2RAD*divergenceV);
  if (xwidth  > 0) { xmax = xwidth/2;  xmin = -xmax; }
  if (yheight > 0) { ymax = yheight/2; ymin = -ymax; }

  if ((xmin >= xmax) || (ymin >= ymax)) {
    printf("Collimator_linear: %s: Null slit opening area !\n"
	         "ERROR              (xwidth,yheight,xmin,xmax,ymin,ymax). Exiting",
           NAME_CURRENT_COMP);
    exit(-1);
  }

}
#line 162752 "MACS_sample_kidney_box.c"
#undef divergenceV
#undef transmission
#undef divergence
#undef length
#undef yheight
#undef xwidth
#undef ymax
#undef ymin
#undef xmax
#undef xmin
#undef slopeV
#undef slope
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

  /* Initializations for component channel_19_colimator. */
  SIG_MESSAGE("channel_19_colimator (Init)");
#define mccompcurname  channel_19_colimator
#define mccompcurtype  Collimator_linear
#define mccompcurindex 109
#define slope mccchannel_19_colimator_slope
#define slopeV mccchannel_19_colimator_slopeV
#define xmin mccchannel_19_colimator_xmin
#define xmax mccchannel_19_colimator_xmax
#define ymin mccchannel_19_colimator_ymin
#define ymax mccchannel_19_colimator_ymax
#define xwidth mccchannel_19_colimator_xwidth
#define yheight mccchannel_19_colimator_yheight
#define length mccchannel_19_colimator_length
#define divergence mccchannel_19_colimator_divergence
#define transmission mccchannel_19_colimator_transmission
#define divergenceV mccchannel_19_colimator_divergenceV
#line 54 "/usr/share/mcstas/2.7/optics/Collimator_linear.comp"
{
slope = tan(MIN2RAD*divergence);
  slopeV= tan(MIN2RAD*divergenceV);
  if (xwidth  > 0) { xmax = xwidth/2;  xmin = -xmax; }
  if (yheight > 0) { ymax = yheight/2; ymin = -ymax; }

  if ((xmin >= xmax) || (ymin >= ymax)) {
    printf("Collimator_linear: %s: Null slit opening area !\n"
	         "ERROR              (xwidth,yheight,xmin,xmax,ymin,ymax). Exiting",
           NAME_CURRENT_COMP);
    exit(-1);
  }

}
#line 162801 "MACS_sample_kidney_box.c"
#undef divergenceV
#undef transmission
#undef divergence
#undef length
#undef yheight
#undef xwidth
#undef ymax
#undef ymin
#undef xmax
#undef xmin
#undef slopeV
#undef slope
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

  /* Initializations for component boron_plastic_incoherent. */
  SIG_MESSAGE("boron_plastic_incoherent (Init)");
#define mccompcurname  boron_plastic_incoherent
#define mccompcurtype  Incoherent_process
#define mccompcurindex 110
#define This_process mccboron_plastic_incoherent_This_process
#define Incoherent_storage mccboron_plastic_incoherent_Incoherent_storage
#define effective_my_scattering mccboron_plastic_incoherent_effective_my_scattering
#define sigma mccboron_plastic_incoherent_sigma
#define f_QE mccboron_plastic_incoherent_f_QE
#define gamma mccboron_plastic_incoherent_gamma
#define packing_factor mccboron_plastic_incoherent_packing_factor
#define unit_cell_volume mccboron_plastic_incoherent_unit_cell_volume
#define interact_fraction mccboron_plastic_incoherent_interact_fraction
#line 139 "Incoherent_process.comp"
{
  // Initialize done in the component
  effective_my_scattering = ((packing_factor/unit_cell_volume) * 100 * sigma);
  Incoherent_storage.my_scattering = effective_my_scattering;
  
  Incoherent_storage.QE_sampling_frequency = f_QE;
  Incoherent_storage.lorentzian_width = gamma;

  // Need to specify if this process is isotropic
  This_process.non_isotropic_rot_index = -1; // Yes (powder)
  //This_process.non_isotropic_rot_index =  1;  // No (single crystal)

  // Packing the data into a structure that is transported to the main component
  sprintf(This_process.name,NAME_CURRENT_COMP);
  This_process.process_p_interact = interact_fraction;
  This_process.data_transfer.pointer_to_a_Incoherent_physics_storage_struct = &Incoherent_storage;
  //This_process.data_transfer.pointer_to_a_Incoherent_physics_storage_struct->my_scattering = effective_my_scattering;
  This_process.probability_for_scattering_function = &Incoherent_physics_my;
  This_process.scattering_function = &Incoherent_physics_scattering;

  // This will be the same for all process's, and can thus be moved to an include.
  sprintf(global_process_element.name,NAME_CURRENT_COMP);
  global_process_element.component_index = INDEX_CURRENT_COMP;
  global_process_element.p_scattering_process = &This_process;
  add_element_to_process_list(&global_process_list,global_process_element);
}
#line 162859 "MACS_sample_kidney_box.c"
#undef interact_fraction
#undef unit_cell_volume
#undef packing_factor
#undef gamma
#undef f_QE
#undef sigma
#undef effective_my_scattering
#undef Incoherent_storage
#undef This_process
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

  /* Initializations for component boron_plastic. */
  SIG_MESSAGE("boron_plastic (Init)");
#define mccompcurname  boron_plastic
#define mccompcurtype  Union_make_material
#define mccompcurindex 111
#define loop_index mccboron_plastic_loop_index
#define this_material mccboron_plastic_this_material
#define accepted_processes mccboron_plastic_accepted_processes
#define global_material_element mccboron_plastic_global_material_element
#define process_string mccboron_plastic_process_string
#define my_absorption mccboron_plastic_my_absorption
#define absorber mccboron_plastic_absorber
#line 193 "Union_make_material.comp"
{

  /*
  // Comma test
  printf("Starting comma test on string: %s \n",process_string);
  printf("Number of commas in string: %d \n",count_commas(process_string));
  exit(1);
  */
  

  if (0 == strcmp(NAME_CURRENT_COMP,"vacuum") || 0 == strcmp(NAME_CURRENT_COMP,"Vacuum")) {
    printf("ERROR, a Union material may not be called Vacuum. A vacuum volume may be created by material=\"Vacuum\" in a geometry component.\n");
    exit(1);
  }
  if (0 == strcmp(NAME_CURRENT_COMP,"exit") || 0 == strcmp(NAME_CURRENT_COMP,"Exit")) {
    printf("ERROR, a Union material may not be called Exit. A exit volume may be created by material=\"Exit\" in a geometry component.\n");
    exit(1);
  }
  if (my_absorption < 0) {
    printf("ERROR, Union make material named %s have a negative absorption cross section!.\n",NAME_CURRENT_COMP);
    exit(1);
  }
  
  if (absorber == 0) {
    if (process_string && strlen(process_string) && strcmp(process_string,"NULL") && strcmp(process_string, "0")) {
        manual_linking_function_material(process_string, &global_process_list, &accepted_processes, NAME_CURRENT_COMP);
    } else {
      for (loop_index=0;loop_index<global_process_list.num_elements;loop_index++) {
        // printf("Automatic linking chosen [loop index = %d] with process_string = %s  \n",loop_index,process_string);
        // automatic linking
        // accept a process if index is between current and former index of make_material components
          if (1 == automatic_linking_materials_function(global_process_list.elements[loop_index],global_material_list,INDEX_CURRENT_COMP))
              add_element_to_int_list(&accepted_processes,loop_index);
      }
    }
  }

  this_material.number_of_processes = accepted_processes.num_elements; // Add number of processes
  this_material.is_vacuum = 0; // This material is not vacuum
  
  if (this_material.number_of_processes == 0 && my_absorption == 0) {
    printf("ERROR, the material named %s has no processes assigned and no absorption cross section, making it eqvialent to vacuum. Vacuums are assigned by setting material=\"Vacuum\" in a geometry component.\n",NAME_CURRENT_COMP);
    exit(1);
  }
  
  // add process element to this_material, building an array of processes called p_scattering_array
  if (this_material.number_of_processes > 0) this_material.p_scattering_array = malloc(this_material.number_of_processes * sizeof(struct scattering_process_struct));
  for (loop_index=0;loop_index<accepted_processes.num_elements;loop_index++) {
        this_material.p_scattering_array[loop_index]=*global_process_list.elements[accepted_processes.elements[loop_index]].p_scattering_process;
  }
  
  this_material.my_a = my_absorption;  // add the absorption to this material
  sprintf(this_material.name,NAME_CURRENT_COMP);
  
  // packing the information into the global_material_element, which is then included in the global_material_list.
  sprintf(global_material_element.name,NAME_CURRENT_COMP);
  global_material_element.component_index = INDEX_CURRENT_COMP;
  global_material_element.physics = &this_material; // Would be nicer if this material was a pointer, now we have the (small) data two places
  add_element_to_material_list(&global_material_list,global_material_element);
}
#line 162946 "MACS_sample_kidney_box.c"
#undef absorber
#undef my_absorption
#undef process_string
#undef global_material_element
#undef accepted_processes
#undef this_material
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

  /* Initializations for component boron_plastic_enriched_incoherent. */
  SIG_MESSAGE("boron_plastic_enriched_incoherent (Init)");
#define mccompcurname  boron_plastic_enriched_incoherent
#define mccompcurtype  Incoherent_process
#define mccompcurindex 112
#define This_process mccboron_plastic_enriched_incoherent_This_process
#define Incoherent_storage mccboron_plastic_enriched_incoherent_Incoherent_storage
#define effective_my_scattering mccboron_plastic_enriched_incoherent_effective_my_scattering
#define sigma mccboron_plastic_enriched_incoherent_sigma
#define f_QE mccboron_plastic_enriched_incoherent_f_QE
#define gamma mccboron_plastic_enriched_incoherent_gamma
#define packing_factor mccboron_plastic_enriched_incoherent_packing_factor
#define unit_cell_volume mccboron_plastic_enriched_incoherent_unit_cell_volume
#define interact_fraction mccboron_plastic_enriched_incoherent_interact_fraction
#line 139 "Incoherent_process.comp"
{
  // Initialize done in the component
  effective_my_scattering = ((packing_factor/unit_cell_volume) * 100 * sigma);
  Incoherent_storage.my_scattering = effective_my_scattering;
  
  Incoherent_storage.QE_sampling_frequency = f_QE;
  Incoherent_storage.lorentzian_width = gamma;

  // Need to specify if this process is isotropic
  This_process.non_isotropic_rot_index = -1; // Yes (powder)
  //This_process.non_isotropic_rot_index =  1;  // No (single crystal)

  // Packing the data into a structure that is transported to the main component
  sprintf(This_process.name,NAME_CURRENT_COMP);
  This_process.process_p_interact = interact_fraction;
  This_process.data_transfer.pointer_to_a_Incoherent_physics_storage_struct = &Incoherent_storage;
  //This_process.data_transfer.pointer_to_a_Incoherent_physics_storage_struct->my_scattering = effective_my_scattering;
  This_process.probability_for_scattering_function = &Incoherent_physics_my;
  This_process.scattering_function = &Incoherent_physics_scattering;

  // This will be the same for all process's, and can thus be moved to an include.
  sprintf(global_process_element.name,NAME_CURRENT_COMP);
  global_process_element.component_index = INDEX_CURRENT_COMP;
  global_process_element.p_scattering_process = &This_process;
  add_element_to_process_list(&global_process_list,global_process_element);
}
#line 162999 "MACS_sample_kidney_box.c"
#undef interact_fraction
#undef unit_cell_volume
#undef packing_factor
#undef gamma
#undef f_QE
#undef sigma
#undef effective_my_scattering
#undef Incoherent_storage
#undef This_process
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

  /* Initializations for component boron_plastic_enriched. */
  SIG_MESSAGE("boron_plastic_enriched (Init)");
#define mccompcurname  boron_plastic_enriched
#define mccompcurtype  Union_make_material
#define mccompcurindex 113
#define loop_index mccboron_plastic_enriched_loop_index
#define this_material mccboron_plastic_enriched_this_material
#define accepted_processes mccboron_plastic_enriched_accepted_processes
#define global_material_element mccboron_plastic_enriched_global_material_element
#define process_string mccboron_plastic_enriched_process_string
#define my_absorption mccboron_plastic_enriched_my_absorption
#define absorber mccboron_plastic_enriched_absorber
#line 193 "Union_make_material.comp"
{

  /*
  // Comma test
  printf("Starting comma test on string: %s \n",process_string);
  printf("Number of commas in string: %d \n",count_commas(process_string));
  exit(1);
  */
  

  if (0 == strcmp(NAME_CURRENT_COMP,"vacuum") || 0 == strcmp(NAME_CURRENT_COMP,"Vacuum")) {
    printf("ERROR, a Union material may not be called Vacuum. A vacuum volume may be created by material=\"Vacuum\" in a geometry component.\n");
    exit(1);
  }
  if (0 == strcmp(NAME_CURRENT_COMP,"exit") || 0 == strcmp(NAME_CURRENT_COMP,"Exit")) {
    printf("ERROR, a Union material may not be called Exit. A exit volume may be created by material=\"Exit\" in a geometry component.\n");
    exit(1);
  }
  if (my_absorption < 0) {
    printf("ERROR, Union make material named %s have a negative absorption cross section!.\n",NAME_CURRENT_COMP);
    exit(1);
  }
  
  if (absorber == 0) {
    if (process_string && strlen(process_string) && strcmp(process_string,"NULL") && strcmp(process_string, "0")) {
        manual_linking_function_material(process_string, &global_process_list, &accepted_processes, NAME_CURRENT_COMP);
    } else {
      for (loop_index=0;loop_index<global_process_list.num_elements;loop_index++) {
        // printf("Automatic linking chosen [loop index = %d] with process_string = %s  \n",loop_index,process_string);
        // automatic linking
        // accept a process if index is between current and former index of make_material components
          if (1 == automatic_linking_materials_function(global_process_list.elements[loop_index],global_material_list,INDEX_CURRENT_COMP))
              add_element_to_int_list(&accepted_processes,loop_index);
      }
    }
  }

  this_material.number_of_processes = accepted_processes.num_elements; // Add number of processes
  this_material.is_vacuum = 0; // This material is not vacuum
  
  if (this_material.number_of_processes == 0 && my_absorption == 0) {
    printf("ERROR, the material named %s has no processes assigned and no absorption cross section, making it eqvialent to vacuum. Vacuums are assigned by setting material=\"Vacuum\" in a geometry component.\n",NAME_CURRENT_COMP);
    exit(1);
  }
  
  // add process element to this_material, building an array of processes called p_scattering_array
  if (this_material.number_of_processes > 0) this_material.p_scattering_array = malloc(this_material.number_of_processes * sizeof(struct scattering_process_struct));
  for (loop_index=0;loop_index<accepted_processes.num_elements;loop_index++) {
        this_material.p_scattering_array[loop_index]=*global_process_list.elements[accepted_processes.elements[loop_index]].p_scattering_process;
  }
  
  this_material.my_a = my_absorption;  // add the absorption to this material
  sprintf(this_material.name,NAME_CURRENT_COMP);
  
  // packing the information into the global_material_element, which is then included in the global_material_list.
  sprintf(global_material_element.name,NAME_CURRENT_COMP);
  global_material_element.component_index = INDEX_CURRENT_COMP;
  global_material_element.physics = &this_material; // Would be nicer if this material was a pointer, now we have the (small) data two places
  add_element_to_material_list(&global_material_list,global_material_element);
}
#line 163086 "MACS_sample_kidney_box.c"
#undef absorber
#undef my_absorption
#undef process_string
#undef global_material_element
#undef accepted_processes
#undef this_material
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

  /* Initializations for component Collimator_gad. */
  SIG_MESSAGE("Collimator_gad (Init)");
#define mccompcurname  Collimator_gad
#define mccompcurtype  Union_make_material
#define mccompcurindex 114
#define loop_index mccCollimator_gad_loop_index
#define this_material mccCollimator_gad_this_material
#define accepted_processes mccCollimator_gad_accepted_processes
#define global_material_element mccCollimator_gad_global_material_element
#define process_string mccCollimator_gad_process_string
#define my_absorption mccCollimator_gad_my_absorption
#define absorber mccCollimator_gad_absorber
#line 193 "Union_make_material.comp"
{

  /*
  // Comma test
  printf("Starting comma test on string: %s \n",process_string);
  printf("Number of commas in string: %d \n",count_commas(process_string));
  exit(1);
  */
  

  if (0 == strcmp(NAME_CURRENT_COMP,"vacuum") || 0 == strcmp(NAME_CURRENT_COMP,"Vacuum")) {
    printf("ERROR, a Union material may not be called Vacuum. A vacuum volume may be created by material=\"Vacuum\" in a geometry component.\n");
    exit(1);
  }
  if (0 == strcmp(NAME_CURRENT_COMP,"exit") || 0 == strcmp(NAME_CURRENT_COMP,"Exit")) {
    printf("ERROR, a Union material may not be called Exit. A exit volume may be created by material=\"Exit\" in a geometry component.\n");
    exit(1);
  }
  if (my_absorption < 0) {
    printf("ERROR, Union make material named %s have a negative absorption cross section!.\n",NAME_CURRENT_COMP);
    exit(1);
  }
  
  if (absorber == 0) {
    if (process_string && strlen(process_string) && strcmp(process_string,"NULL") && strcmp(process_string, "0")) {
        manual_linking_function_material(process_string, &global_process_list, &accepted_processes, NAME_CURRENT_COMP);
    } else {
      for (loop_index=0;loop_index<global_process_list.num_elements;loop_index++) {
        // printf("Automatic linking chosen [loop index = %d] with process_string = %s  \n",loop_index,process_string);
        // automatic linking
        // accept a process if index is between current and former index of make_material components
          if (1 == automatic_linking_materials_function(global_process_list.elements[loop_index],global_material_list,INDEX_CURRENT_COMP))
              add_element_to_int_list(&accepted_processes,loop_index);
      }
    }
  }

  this_material.number_of_processes = accepted_processes.num_elements; // Add number of processes
  this_material.is_vacuum = 0; // This material is not vacuum
  
  if (this_material.number_of_processes == 0 && my_absorption == 0) {
    printf("ERROR, the material named %s has no processes assigned and no absorption cross section, making it eqvialent to vacuum. Vacuums are assigned by setting material=\"Vacuum\" in a geometry component.\n",NAME_CURRENT_COMP);
    exit(1);
  }
  
  // add process element to this_material, building an array of processes called p_scattering_array
  if (this_material.number_of_processes > 0) this_material.p_scattering_array = malloc(this_material.number_of_processes * sizeof(struct scattering_process_struct));
  for (loop_index=0;loop_index<accepted_processes.num_elements;loop_index++) {
        this_material.p_scattering_array[loop_index]=*global_process_list.elements[accepted_processes.elements[loop_index]].p_scattering_process;
  }
  
  this_material.my_a = my_absorption;  // add the absorption to this material
  sprintf(this_material.name,NAME_CURRENT_COMP);
  
  // packing the information into the global_material_element, which is then included in the global_material_list.
  sprintf(global_material_element.name,NAME_CURRENT_COMP);
  global_material_element.component_index = INDEX_CURRENT_COMP;
  global_material_element.physics = &this_material; // Would be nicer if this material was a pointer, now we have the (small) data two places
  add_element_to_material_list(&global_material_list,global_material_element);
}
#line 163171 "MACS_sample_kidney_box.c"
#undef absorber
#undef my_absorption
#undef process_string
#undef global_material_element
#undef accepted_processes
#undef this_material
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

  /* Initializations for component Incoherent_PG_analyzer. */
  SIG_MESSAGE("Incoherent_PG_analyzer (Init)");
#define mccompcurname  Incoherent_PG_analyzer
#define mccompcurtype  Incoherent_process
#define mccompcurindex 115
#define This_process mccIncoherent_PG_analyzer_This_process
#define Incoherent_storage mccIncoherent_PG_analyzer_Incoherent_storage
#define effective_my_scattering mccIncoherent_PG_analyzer_effective_my_scattering
#define sigma mccIncoherent_PG_analyzer_sigma
#define f_QE mccIncoherent_PG_analyzer_f_QE
#define gamma mccIncoherent_PG_analyzer_gamma
#define packing_factor mccIncoherent_PG_analyzer_packing_factor
#define unit_cell_volume mccIncoherent_PG_analyzer_unit_cell_volume
#define interact_fraction mccIncoherent_PG_analyzer_interact_fraction
#line 139 "Incoherent_process.comp"
{
  // Initialize done in the component
  effective_my_scattering = ((packing_factor/unit_cell_volume) * 100 * sigma);
  Incoherent_storage.my_scattering = effective_my_scattering;
  
  Incoherent_storage.QE_sampling_frequency = f_QE;
  Incoherent_storage.lorentzian_width = gamma;

  // Need to specify if this process is isotropic
  This_process.non_isotropic_rot_index = -1; // Yes (powder)
  //This_process.non_isotropic_rot_index =  1;  // No (single crystal)

  // Packing the data into a structure that is transported to the main component
  sprintf(This_process.name,NAME_CURRENT_COMP);
  This_process.process_p_interact = interact_fraction;
  This_process.data_transfer.pointer_to_a_Incoherent_physics_storage_struct = &Incoherent_storage;
  //This_process.data_transfer.pointer_to_a_Incoherent_physics_storage_struct->my_scattering = effective_my_scattering;
  This_process.probability_for_scattering_function = &Incoherent_physics_my;
  This_process.scattering_function = &Incoherent_physics_scattering;

  // This will be the same for all process's, and can thus be moved to an include.
  sprintf(global_process_element.name,NAME_CURRENT_COMP);
  global_process_element.component_index = INDEX_CURRENT_COMP;
  global_process_element.p_scattering_process = &This_process;
  add_element_to_process_list(&global_process_list,global_process_element);
}
#line 163224 "MACS_sample_kidney_box.c"
#undef interact_fraction
#undef unit_cell_volume
#undef packing_factor
#undef gamma
#undef f_QE
#undef sigma
#undef effective_my_scattering
#undef Incoherent_storage
#undef This_process
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

  /* Initializations for component Single_crystal_PG_analyzer. */
  SIG_MESSAGE("Single_crystal_PG_analyzer (Init)");
#define mccompcurname  Single_crystal_PG_analyzer
#define mccompcurtype  Single_crystal_process
#define mccompcurindex 116
#define mosaic_AB mccSingle_crystal_PG_analyzer_mosaic_AB
#define This_process mccSingle_crystal_PG_analyzer_This_process
#define Single_crystal_storage mccSingle_crystal_PG_analyzer_Single_crystal_storage
#define effective_my_scattering mccSingle_crystal_PG_analyzer_effective_my_scattering
#define hkl_info_union mccSingle_crystal_PG_analyzer_hkl_info_union
#define packing_factor mccSingle_crystal_PG_analyzer_packing_factor
#define reflections mccSingle_crystal_PG_analyzer_reflections
#define delta_d_d mccSingle_crystal_PG_analyzer_delta_d_d
#define mosaic mccSingle_crystal_PG_analyzer_mosaic
#define mosaic_a mccSingle_crystal_PG_analyzer_mosaic_a
#define mosaic_b mccSingle_crystal_PG_analyzer_mosaic_b
#define mosaic_c mccSingle_crystal_PG_analyzer_mosaic_c
#define recip_cell mccSingle_crystal_PG_analyzer_recip_cell
#define barns mccSingle_crystal_PG_analyzer_barns
#define ax mccSingle_crystal_PG_analyzer_ax
#define ay mccSingle_crystal_PG_analyzer_ay
#define az mccSingle_crystal_PG_analyzer_az
#define bx mccSingle_crystal_PG_analyzer_bx
#define by mccSingle_crystal_PG_analyzer_by
#define bz mccSingle_crystal_PG_analyzer_bz
#define cx mccSingle_crystal_PG_analyzer_cx
#define cy mccSingle_crystal_PG_analyzer_cy
#define cz mccSingle_crystal_PG_analyzer_cz
#define aa mccSingle_crystal_PG_analyzer_aa
#define bb mccSingle_crystal_PG_analyzer_bb
#define cc mccSingle_crystal_PG_analyzer_cc
#define order mccSingle_crystal_PG_analyzer_order
#define RX mccSingle_crystal_PG_analyzer_RX
#define RY mccSingle_crystal_PG_analyzer_RY
#define RZ mccSingle_crystal_PG_analyzer_RZ
#define powder mccSingle_crystal_PG_analyzer_powder
#define PG mccSingle_crystal_PG_analyzer_PG
#define interact_fraction mccSingle_crystal_PG_analyzer_interact_fraction
#define packing_factor mccSingle_crystal_PG_analyzer_packing_factor
#line 937 "Single_crystal_process.comp"
{
  // Single crystal initialize
  double as, bs, cs;
  int i=0;

  /* transfer input parameters */
  hkl_info_union.m_delta_d_d = delta_d_d;
  hkl_info_union.m_a  = 0;
  hkl_info_union.m_b  = 0;
  hkl_info_union.m_c  = 0;
  hkl_info_union.m_aa = aa;
  hkl_info_union.m_bb = bb;
  hkl_info_union.m_cc = cc;
  hkl_info_union.m_ax = ax;
  hkl_info_union.m_ay = ay;
  hkl_info_union.m_az = az;
  hkl_info_union.m_bx = bx;
  hkl_info_union.m_by = by;
  hkl_info_union.m_bz = bz;
  hkl_info_union.m_cx = cx;
  hkl_info_union.m_cy = cy;
  hkl_info_union.m_cz = cz;
  //hkl_info_union.sigma_a = sigma_abs;
  //hkl_info_union.sigma_i = sigma_inc;
  hkl_info_union.recip   = recip_cell;

  /* default format h,k,l,F,F2  */
  hkl_info_union.column_order[0]=1;
  hkl_info_union.column_order[1]=2;
  hkl_info_union.column_order[2]=3;
  hkl_info_union.column_order[3]=0;
  hkl_info_union.column_order[4]=7;
  hkl_info_union.kix = hkl_info_union.kiy = hkl_info_union.kiz = 0;
  hkl_info_union.nb_reuses = hkl_info_union.nb_refl = hkl_info_union.nb_refl_count = 0;
  hkl_info_union.tau_count = 0;

  /*this is necessary to allow a numerical array to be passed through as a DEFINITION parameter*/ 
  double mosaic_ABin[]=mosaic_AB;
  /* Read in structure factors, and do some pre-calculations. */
  if (!read_hkl_data_union(reflections, &hkl_info_union, mosaic, mosaic_a, mosaic_b, mosaic_c, mosaic_ABin)) {
    printf("Single_crystal_process: %s: Error: Aborting.\n", NAME_CURRENT_COMP);
    exit(0);
  }
    
  if (hkl_info_union.sigma_a<0) hkl_info_union.sigma_a=0;
  if (hkl_info_union.sigma_i<0) hkl_info_union.sigma_i=0;
  
  if (hkl_info_union.count)
    printf("Single_crystal_process: %s: Read %d reflections from file '%s'\n",
      NAME_CURRENT_COMP, hkl_info_union.count, reflections);
  else printf("Single_crystal_process: %s: Using incoherent elastic scattering only sigma=%g.\n",
      NAME_CURRENT_COMP, hkl_info_union.sigma_i);
  
  /*
  hkl_info.shape=-1; // -1:no shape, 0:cyl, 1:box, 2:sphere, 3:any-shape
  if (geometry && strlen(geometry) && strcmp(geometry, "NULL") && strcmp(geometry, "0")) {
	  if (off_init(geometry, xwidth, yheight, zdepth, 0, &offdata)) {
      hkl_info.shape=3; 
    }
  }
  else if (xwidth && yheight && zdepth)  hkl_info.shape=1; // box
  else if (radius > 0 && yheight)        hkl_info.shape=0; // cylinder
  else if (radius > 0 && !yheight)       hkl_info.shape=2; // sphere

  if (hkl_info.shape < 0) 
    exit(fprintf(stderr,"Single_crystal: %s: sample has invalid dimensions.\n"
                        "ERROR           Please check parameter values (xwidth, yheight, zdepth, radius).\n", NAME_CURRENT_COMP));
  */
  
  printf("Single_crystal: %s: Vc=%g [Angs] sigma_abs=%g [barn] sigma_inc=%g [barn] reflections=%s\n",
      NAME_CURRENT_COMP, hkl_info_union.V0, hkl_info_union.sigma_a, hkl_info_union.sigma_i,
      reflections && strlen(reflections) ? reflections : "NULL");

  if (powder && PG) 
    exit(fprintf(stderr,"Single_crystal_process: %s: powder and PG modes can not be used together!\n"
	     "ERROR           Please use EITHER powder or PG mode.\n", NAME_CURRENT_COMP));

  if (powder && !(order==1)) {
    fprintf(stderr,"Single_crystal_process: %s: powder mode means implicit choice of no multiple scattering!\n"
	    "WARNING setting order=1\n", NAME_CURRENT_COMP);
    order=1;
  } 
  
  if (PG && !(order==1)) {
    fprintf(stderr,"Single_crystal_process: %s: PG mode means implicit choice of no multiple scattering!\n"
	    "WARNING setting order=1\n", NAME_CURRENT_COMP);
    order=1;
  } 

  // Temporary errors untill these features are either added or removed from input
  
  if (powder)
    exit(fprintf(stderr,"Single_crystal_process: %s: powder mode not supported yet!\n"
	     "ERROR           Please disable powder mode.\n", NAME_CURRENT_COMP));
  
  if (PG)
    exit(fprintf(stderr,"Single_crystal_process: %s: PG mode not supported yet!\n"
	     "ERROR           Please disable PG mode.\n", NAME_CURRENT_COMP));
  
  if (order)
    exit(fprintf(stderr,"Single_crystal_process: %s: Order control not supported yet!\n"
	     "ERROR           Please set order to zero.\n", NAME_CURRENT_COMP));
  
  
  // Initialize done in the component
  // Added for single crystal
  Single_crystal_storage.PG_setting = PG;
  Single_crystal_storage.powder_setting = powder;
  Single_crystal_storage.barns_setting = barns;
  Single_crystal_storage.pack = packing_factor;
  Single_crystal_storage.hkl_info_storage = &hkl_info_union;

  // Need to specify if this process is isotropic
  //This_process.non_isotropic_rot_index = -1; // Yes (powder)
  This_process.non_isotropic_rot_index =  1;  // No (single crystal)

  // Packing the data into a structure that is transported to the main component
  This_process.data_transfer.pointer_to_a_Single_crystal_physics_storage_struct = &Single_crystal_storage;
  This_process.probability_for_scattering_function = &Single_crystal_physics_my;
  This_process.scattering_function = &Single_crystal_physics_scattering;

  // This will be the same for all process's, and can thus be moved to an include.
  This_process.process_p_interact = interact_fraction;
  sprintf(This_process.name,NAME_CURRENT_COMP);
  rot_copy(This_process.rotation_matrix,ROT_A_CURRENT_COMP);
  sprintf(global_process_element.name,NAME_CURRENT_COMP);
  global_process_element.component_index = INDEX_CURRENT_COMP;
  global_process_element.p_scattering_process = &This_process;
  add_element_to_process_list(&global_process_list,global_process_element);
}
#line 163408 "MACS_sample_kidney_box.c"
#undef packing_factor
#undef interact_fraction
#undef PG
#undef powder
#undef RZ
#undef RY
#undef RX
#undef order
#undef cc
#undef bb
#undef aa
#undef cz
#undef cy
#undef cx
#undef bz
#undef by
#undef bx
#undef az
#undef ay
#undef ax
#undef barns
#undef recip_cell
#undef mosaic_c
#undef mosaic_b
#undef mosaic_a
#undef mosaic
#undef delta_d_d
#undef reflections
#undef packing_factor
#undef hkl_info_union
#undef effective_my_scattering
#undef Single_crystal_storage
#undef This_process
#undef mosaic_AB
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

  /* Initializations for component PG_analyzer. */
  SIG_MESSAGE("PG_analyzer (Init)");
#define mccompcurname  PG_analyzer
#define mccompcurtype  Union_make_material
#define mccompcurindex 117
#define loop_index mccPG_analyzer_loop_index
#define this_material mccPG_analyzer_this_material
#define accepted_processes mccPG_analyzer_accepted_processes
#define global_material_element mccPG_analyzer_global_material_element
#define process_string mccPG_analyzer_process_string
#define my_absorption mccPG_analyzer_my_absorption
#define absorber mccPG_analyzer_absorber
#line 193 "Union_make_material.comp"
{

  /*
  // Comma test
  printf("Starting comma test on string: %s \n",process_string);
  printf("Number of commas in string: %d \n",count_commas(process_string));
  exit(1);
  */
  

  if (0 == strcmp(NAME_CURRENT_COMP,"vacuum") || 0 == strcmp(NAME_CURRENT_COMP,"Vacuum")) {
    printf("ERROR, a Union material may not be called Vacuum. A vacuum volume may be created by material=\"Vacuum\" in a geometry component.\n");
    exit(1);
  }
  if (0 == strcmp(NAME_CURRENT_COMP,"exit") || 0 == strcmp(NAME_CURRENT_COMP,"Exit")) {
    printf("ERROR, a Union material may not be called Exit. A exit volume may be created by material=\"Exit\" in a geometry component.\n");
    exit(1);
  }
  if (my_absorption < 0) {
    printf("ERROR, Union make material named %s have a negative absorption cross section!.\n",NAME_CURRENT_COMP);
    exit(1);
  }
  
  if (absorber == 0) {
    if (process_string && strlen(process_string) && strcmp(process_string,"NULL") && strcmp(process_string, "0")) {
        manual_linking_function_material(process_string, &global_process_list, &accepted_processes, NAME_CURRENT_COMP);
    } else {
      for (loop_index=0;loop_index<global_process_list.num_elements;loop_index++) {
        // printf("Automatic linking chosen [loop index = %d] with process_string = %s  \n",loop_index,process_string);
        // automatic linking
        // accept a process if index is between current and former index of make_material components
          if (1 == automatic_linking_materials_function(global_process_list.elements[loop_index],global_material_list,INDEX_CURRENT_COMP))
              add_element_to_int_list(&accepted_processes,loop_index);
      }
    }
  }

  this_material.number_of_processes = accepted_processes.num_elements; // Add number of processes
  this_material.is_vacuum = 0; // This material is not vacuum
  
  if (this_material.number_of_processes == 0 && my_absorption == 0) {
    printf("ERROR, the material named %s has no processes assigned and no absorption cross section, making it eqvialent to vacuum. Vacuums are assigned by setting material=\"Vacuum\" in a geometry component.\n",NAME_CURRENT_COMP);
    exit(1);
  }
  
  // add process element to this_material, building an array of processes called p_scattering_array
  if (this_material.number_of_processes > 0) this_material.p_scattering_array = malloc(this_material.number_of_processes * sizeof(struct scattering_process_struct));
  for (loop_index=0;loop_index<accepted_processes.num_elements;loop_index++) {
        this_material.p_scattering_array[loop_index]=*global_process_list.elements[accepted_processes.elements[loop_index]].p_scattering_process;
  }
  
  this_material.my_a = my_absorption;  // add the absorption to this material
  sprintf(this_material.name,NAME_CURRENT_COMP);
  
  // packing the information into the global_material_element, which is then included in the global_material_list.
  sprintf(global_material_element.name,NAME_CURRENT_COMP);
  global_material_element.component_index = INDEX_CURRENT_COMP;
  global_material_element.physics = &this_material; // Would be nicer if this material was a pointer, now we have the (small) data two places
  add_element_to_material_list(&global_material_list,global_material_element);
}
#line 163520 "MACS_sample_kidney_box.c"
#undef absorber
#undef my_absorption
#undef process_string
#undef global_material_element
#undef accepted_processes
#undef this_material
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

  /* Initializations for component kidney_hull. */
  SIG_MESSAGE("kidney_hull (Init)");
#define mccompcurname  kidney_hull
#define mccompcurtype  Union_cylinder
#define mccompcurindex 118
#define loop_index mcckidney_hull_loop_index
#define this_cylinder_volume mcckidney_hull_this_cylinder_volume
#define global_geometry_element mcckidney_hull_global_geometry_element
#define this_cylinder_storage mcckidney_hull_this_cylinder_storage
#define material_string mcckidney_hull_material_string
#define priority mcckidney_hull_priority
#define radius mcckidney_hull_radius
#define yheight mcckidney_hull_yheight
#define visualize mcckidney_hull_visualize
#define target_index mcckidney_hull_target_index
#define target_x mcckidney_hull_target_x
#define target_y mcckidney_hull_target_y
#define target_z mcckidney_hull_target_z
#define focus_aw mcckidney_hull_focus_aw
#define focus_ah mcckidney_hull_focus_ah
#define focus_xw mcckidney_hull_focus_xw
#define focus_xh mcckidney_hull_focus_xh
#define focus_r mcckidney_hull_focus_r
#define p_interact mcckidney_hull_p_interact
#define mask_string mcckidney_hull_mask_string
#define mask_setting mcckidney_hull_mask_setting
#define number_of_activations mcckidney_hull_number_of_activations
#line 185 "Union_cylinder.comp"
{
// Initializes the focusing system for this volume including input sanitation.
focus_initialize(&this_cylinder_volume.geometry, POS_A_COMP_INDEX(INDEX_CURRENT_COMP+target_index), POS_A_CURRENT_COMP, ROT_A_CURRENT_COMP, target_index, target_x, target_y, target_z, focus_aw, focus_ah, focus_xw, focus_xh, focus_r, NAME_CURRENT_COMP);

// Input sanitation for this geometry
if (radius <= 0) {
  printf("\nERROR in Union_cylinder named %s, the radius is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}

if (yheight <= 0) {
  printf("\nERROR in Union_cylinder named %s, yheight is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}

// Use sanitation
#ifdef MATERIAL_DETECTOR
if (global_material_list.num_elements == 0) {
  // Here if the user have defined a material, but only after this material
  printf("\nERROR: Need to define a material using Union_make_material before using a Union geometry component. \n");
  printf("       %s was defined before first use of Union_make_material.\n",NAME_CURRENT_COMP);
  exit(1);
}
#endif
#ifndef MATERIAL_DETECTOR
  printf("\nERROR: Need to define a material using Union_make_material before using a Union geometry component. \n");
  exit(1);
#endif


this_cylinder_volume.geometry.is_masked_volume = 0;
this_cylinder_volume.geometry.is_exit_volume = 0;
this_cylinder_volume.geometry.is_mask_volume = 0;

// Read the material input, or if it lacks, use automatic linking.
if (mask_string && strlen(mask_string) && strcmp(mask_string, "NULL") && strcmp(mask_string, "0")) {
    // A mask volume is used to limit the extend of other volumes, called the masked volumes. These are specified in the mask_string.
    // In order for a ray to enter a masked volume, it needs to be both in the region covered by that volume AND the mask volume.
    // When more than
    this_cylinder_volume.geometry.mask_mode = 1; // Default is mask mode is ALL
    if (mask_setting && strlen(mask_setting) && strcmp(mask_setting, "NULL") && strcmp(mask_setting, "0")) {
        if (strcmp(mask_setting,"ALL") == 0 || strcmp(mask_setting,"All") == 0) this_cylinder_volume.geometry.mask_mode = 1;
        else if (strcmp(mask_setting,"ANY") == 0 || strcmp(mask_setting,"Any") == 0) this_cylinder_volume.geometry.mask_mode = 2;
        else {
            printf("The mask_mode of component %s is set to %s, but must be either ALL or ANY.\n",NAME_CURRENT_COMP,mask_setting);
            exit(1);
        }
    }
    
    for (loop_index=0;loop_index<global_geometry_list.num_elements;loop_index++) {
        // Add mask list
        if (1 == manual_linking_function(global_geometry_list.elements[loop_index].name,mask_string)) {
            add_element_to_int_list(&this_cylinder_volume.geometry.mask_list,global_geometry_list.elements[loop_index].component_index);
            add_element_to_int_list(&global_geometry_list.elements[loop_index].Volume->geometry.masked_by_list,INDEX_CURRENT_COMP);
            global_geometry_list.elements[loop_index].Volume->geometry.is_masked_volume = 1;
            if (this_cylinder_volume.geometry.mask_mode == 2)
                global_geometry_list.elements[loop_index].Volume->geometry.mask_mode = 2;
            if (this_cylinder_volume.geometry.mask_mode == 1) {
                if (global_geometry_list.elements[loop_index].Volume->geometry.is_masked_volume == 1 && global_geometry_list.elements[loop_index].Volume->geometry.mask_mode != 2)
                    // If more than one mask is added to one volume, the ANY mode overwrites the (default) ALL mode.
                    global_geometry_list.elements[loop_index].Volume->geometry.mask_mode = 1;
            }
            
            found_geometries = 1;
        }
    }
    if (found_geometries == 0) {
        printf("The mask_string in geometry: %s did not find any of the specified volumes in the mask_string %s \n",NAME_CURRENT_COMP,mask_string);
        exit(1);
    }
    this_cylinder_volume.p_physics = malloc(sizeof(struct physics_struct));
    this_cylinder_volume.p_physics->is_vacuum = 0; // Makes this volume a vacuum
    this_cylinder_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
    this_cylinder_volume.p_physics->my_a = 0; // Should not be used.
    sprintf(this_cylinder_volume.p_physics->name,"Mask");
    this_cylinder_volume.geometry.is_mask_volume = 1;
    
    
// Read the material input, or if it lacks, use automatic linking.
} else if (material_string && strlen(material_string) && strcmp(material_string, "NULL") && strcmp(material_string, "0")) {
    // A geometry string was given, use it to determine which material
    if (0 == strcmp(material_string,"vacuum") || 0 == strcmp(material_string,"Vacuum")) {
        // One could have a global physics struct for vacuum instead of creating one for each
        this_cylinder_volume.p_physics = malloc(sizeof(struct physics_struct));
        this_cylinder_volume.p_physics->is_vacuum = 1; // Makes this volume a vacuum
        this_cylinder_volume.p_physics->number_of_processes = (int) 0;
        this_cylinder_volume.p_physics->my_a = 0; // Should not be used.
        sprintf(this_cylinder_volume.p_physics->name,"Vacuum");
    } else if (0 == strcmp(material_string,"exit") || 0 == strcmp(material_string,"Exit")) {
        // One could have a global physics struct for exit instead of creating one for each
        this_cylinder_volume.p_physics = malloc(sizeof(struct physics_struct));
        this_cylinder_volume.p_physics->is_vacuum = 1; // Makes this volume a vacuum
        this_cylinder_volume.p_physics->number_of_processes = (int) 0;
        this_cylinder_volume.p_physics->my_a = 0; // Should not be used.
        this_cylinder_volume.geometry.is_exit_volume = 1;
        sprintf(this_cylinder_volume.p_physics->name,"Exit");
    } else {
        for (loop_index=0;loop_index<global_material_list.num_elements;loop_index++) {
          if (0 == strcmp(material_string,global_material_list.elements[loop_index].name)) {
            this_cylinder_volume.p_physics = global_material_list.elements[loop_index].physics;
            break;
          }
          if (loop_index == global_material_list.num_elements-1) {
            printf("\n");
            printf("ERROR: The material string \"%s\" in Union geometry \"%s\" did not match a specified material. \n",material_string,NAME_CURRENT_COMP);
            printf("       The materials available at this point (need to be defined before the geometry): \n");
            for (loop_index=0;loop_index<global_material_list.num_elements;loop_index++)
              printf("         %s\n",global_material_list.elements[loop_index].name);
            printf("\n");
            printf("       It is also possible to use one of the defualt materials avaiable: \n");
            printf("           Vacuum (for a Volume without scattering or absorption)\n");
            printf("           Exit (for a Volume where the ray exits the component if it enters)\n");
            printf("           Mask (for a Volume that masks existing volumes specified in the mask_string\n");
            exit(1);
          }
        }
    }
} else {
    // Automatic linking, simply using the last defined material.
    #ifndef MATERIAL_DETECTOR
        printf("Need to define a material before the geometry to use automatic linking %s.\n",NAME_CURRENT_COMP);
        exit(1);
    #endif
    this_cylinder_volume.p_physics = global_material_list.elements[global_material_list.num_elements-1].physics;
}

sprintf(this_cylinder_volume.name,NAME_CURRENT_COMP);
sprintf(this_cylinder_volume.geometry.shape,"cylinder");
this_cylinder_volume.geometry.priority_value = priority;
// Currently the coordinates will be in absolute space.
this_cylinder_volume.geometry.center = POS_A_CURRENT_COMP;

this_cylinder_volume.geometry.geometry_p_interact = p_interact;
this_cylinder_storage.cyl_radius = radius;
this_cylinder_storage.height = yheight;
this_cylinder_volume.geometry.visualization_on = visualize;
this_cylinder_volume.geometry.geometry_parameters.p_cylinder_storage = &this_cylinder_storage;
this_cylinder_volume.geometry.within_function = &r_within_cylinder;
this_cylinder_volume.geometry.intersect_function = &sample_cylinder_intersect;
this_cylinder_volume.geometry.mcdisplay_function = &mcdisplay_cylinder_function;
this_cylinder_volume.geometry.shell_points = &cylinder_shell_points;
this_cylinder_volume.geometry.initialize_from_main_function = &initialize_cylinder_geometry_from_main_component;
this_cylinder_volume.geometry.process_rot_allocated = 0;
this_cylinder_volume.geometry.copy_geometry_parameters = &allocate_cylinder_storage_copy;

rot_copy(this_cylinder_volume.geometry.rotation_matrix,ROT_A_CURRENT_COMP);
rot_transpose(ROT_A_CURRENT_COMP,this_cylinder_volume.geometry.transpose_rotation_matrix);

// Initialize loggers
this_cylinder_volume.loggers.num_elements = 0;

// packing the information into the global_geometry_element, which is then included in the global_geometry_list.
sprintf(global_geometry_element.name,NAME_CURRENT_COMP);
global_geometry_element.activation_counter = number_of_activations;
global_geometry_element.component_index = INDEX_CURRENT_COMP;
global_geometry_element.Volume = &this_cylinder_volume; // Would be nicer if this m was a pointer, now we have the (small) data two places
add_element_to_geometry_list(&global_geometry_list,global_geometry_element);
}
#line 163718 "MACS_sample_kidney_box.c"
#undef number_of_activations
#undef mask_setting
#undef mask_string
#undef p_interact
#undef focus_r
#undef focus_xh
#undef focus_xw
#undef focus_ah
#undef focus_aw
#undef target_z
#undef target_y
#undef target_x
#undef target_index
#undef visualize
#undef yheight
#undef radius
#undef priority
#undef material_string
#undef this_cylinder_storage
#undef global_geometry_element
#undef this_cylinder_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

  /* Initializations for component kidney_hull_cut. */
  SIG_MESSAGE("kidney_hull_cut (Init)");
#define mccompcurname  kidney_hull_cut
#define mccompcurtype  Union_cylinder
#define mccompcurindex 119
#define loop_index mcckidney_hull_cut_loop_index
#define this_cylinder_volume mcckidney_hull_cut_this_cylinder_volume
#define global_geometry_element mcckidney_hull_cut_global_geometry_element
#define this_cylinder_storage mcckidney_hull_cut_this_cylinder_storage
#define material_string mcckidney_hull_cut_material_string
#define priority mcckidney_hull_cut_priority
#define radius mcckidney_hull_cut_radius
#define yheight mcckidney_hull_cut_yheight
#define visualize mcckidney_hull_cut_visualize
#define target_index mcckidney_hull_cut_target_index
#define target_x mcckidney_hull_cut_target_x
#define target_y mcckidney_hull_cut_target_y
#define target_z mcckidney_hull_cut_target_z
#define focus_aw mcckidney_hull_cut_focus_aw
#define focus_ah mcckidney_hull_cut_focus_ah
#define focus_xw mcckidney_hull_cut_focus_xw
#define focus_xh mcckidney_hull_cut_focus_xh
#define focus_r mcckidney_hull_cut_focus_r
#define p_interact mcckidney_hull_cut_p_interact
#define mask_string mcckidney_hull_cut_mask_string
#define mask_setting mcckidney_hull_cut_mask_setting
#define number_of_activations mcckidney_hull_cut_number_of_activations
#line 185 "Union_cylinder.comp"
{
// Initializes the focusing system for this volume including input sanitation.
focus_initialize(&this_cylinder_volume.geometry, POS_A_COMP_INDEX(INDEX_CURRENT_COMP+target_index), POS_A_CURRENT_COMP, ROT_A_CURRENT_COMP, target_index, target_x, target_y, target_z, focus_aw, focus_ah, focus_xw, focus_xh, focus_r, NAME_CURRENT_COMP);

// Input sanitation for this geometry
if (radius <= 0) {
  printf("\nERROR in Union_cylinder named %s, the radius is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}

if (yheight <= 0) {
  printf("\nERROR in Union_cylinder named %s, yheight is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}

// Use sanitation
#ifdef MATERIAL_DETECTOR
if (global_material_list.num_elements == 0) {
  // Here if the user have defined a material, but only after this material
  printf("\nERROR: Need to define a material using Union_make_material before using a Union geometry component. \n");
  printf("       %s was defined before first use of Union_make_material.\n",NAME_CURRENT_COMP);
  exit(1);
}
#endif
#ifndef MATERIAL_DETECTOR
  printf("\nERROR: Need to define a material using Union_make_material before using a Union geometry component. \n");
  exit(1);
#endif


this_cylinder_volume.geometry.is_masked_volume = 0;
this_cylinder_volume.geometry.is_exit_volume = 0;
this_cylinder_volume.geometry.is_mask_volume = 0;

// Read the material input, or if it lacks, use automatic linking.
if (mask_string && strlen(mask_string) && strcmp(mask_string, "NULL") && strcmp(mask_string, "0")) {
    // A mask volume is used to limit the extend of other volumes, called the masked volumes. These are specified in the mask_string.
    // In order for a ray to enter a masked volume, it needs to be both in the region covered by that volume AND the mask volume.
    // When more than
    this_cylinder_volume.geometry.mask_mode = 1; // Default is mask mode is ALL
    if (mask_setting && strlen(mask_setting) && strcmp(mask_setting, "NULL") && strcmp(mask_setting, "0")) {
        if (strcmp(mask_setting,"ALL") == 0 || strcmp(mask_setting,"All") == 0) this_cylinder_volume.geometry.mask_mode = 1;
        else if (strcmp(mask_setting,"ANY") == 0 || strcmp(mask_setting,"Any") == 0) this_cylinder_volume.geometry.mask_mode = 2;
        else {
            printf("The mask_mode of component %s is set to %s, but must be either ALL or ANY.\n",NAME_CURRENT_COMP,mask_setting);
            exit(1);
        }
    }
    
    for (loop_index=0;loop_index<global_geometry_list.num_elements;loop_index++) {
        // Add mask list
        if (1 == manual_linking_function(global_geometry_list.elements[loop_index].name,mask_string)) {
            add_element_to_int_list(&this_cylinder_volume.geometry.mask_list,global_geometry_list.elements[loop_index].component_index);
            add_element_to_int_list(&global_geometry_list.elements[loop_index].Volume->geometry.masked_by_list,INDEX_CURRENT_COMP);
            global_geometry_list.elements[loop_index].Volume->geometry.is_masked_volume = 1;
            if (this_cylinder_volume.geometry.mask_mode == 2)
                global_geometry_list.elements[loop_index].Volume->geometry.mask_mode = 2;
            if (this_cylinder_volume.geometry.mask_mode == 1) {
                if (global_geometry_list.elements[loop_index].Volume->geometry.is_masked_volume == 1 && global_geometry_list.elements[loop_index].Volume->geometry.mask_mode != 2)
                    // If more than one mask is added to one volume, the ANY mode overwrites the (default) ALL mode.
                    global_geometry_list.elements[loop_index].Volume->geometry.mask_mode = 1;
            }
            
            found_geometries = 1;
        }
    }
    if (found_geometries == 0) {
        printf("The mask_string in geometry: %s did not find any of the specified volumes in the mask_string %s \n",NAME_CURRENT_COMP,mask_string);
        exit(1);
    }
    this_cylinder_volume.p_physics = malloc(sizeof(struct physics_struct));
    this_cylinder_volume.p_physics->is_vacuum = 0; // Makes this volume a vacuum
    this_cylinder_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
    this_cylinder_volume.p_physics->my_a = 0; // Should not be used.
    sprintf(this_cylinder_volume.p_physics->name,"Mask");
    this_cylinder_volume.geometry.is_mask_volume = 1;
    
    
// Read the material input, or if it lacks, use automatic linking.
} else if (material_string && strlen(material_string) && strcmp(material_string, "NULL") && strcmp(material_string, "0")) {
    // A geometry string was given, use it to determine which material
    if (0 == strcmp(material_string,"vacuum") || 0 == strcmp(material_string,"Vacuum")) {
        // One could have a global physics struct for vacuum instead of creating one for each
        this_cylinder_volume.p_physics = malloc(sizeof(struct physics_struct));
        this_cylinder_volume.p_physics->is_vacuum = 1; // Makes this volume a vacuum
        this_cylinder_volume.p_physics->number_of_processes = (int) 0;
        this_cylinder_volume.p_physics->my_a = 0; // Should not be used.
        sprintf(this_cylinder_volume.p_physics->name,"Vacuum");
    } else if (0 == strcmp(material_string,"exit") || 0 == strcmp(material_string,"Exit")) {
        // One could have a global physics struct for exit instead of creating one for each
        this_cylinder_volume.p_physics = malloc(sizeof(struct physics_struct));
        this_cylinder_volume.p_physics->is_vacuum = 1; // Makes this volume a vacuum
        this_cylinder_volume.p_physics->number_of_processes = (int) 0;
        this_cylinder_volume.p_physics->my_a = 0; // Should not be used.
        this_cylinder_volume.geometry.is_exit_volume = 1;
        sprintf(this_cylinder_volume.p_physics->name,"Exit");
    } else {
        for (loop_index=0;loop_index<global_material_list.num_elements;loop_index++) {
          if (0 == strcmp(material_string,global_material_list.elements[loop_index].name)) {
            this_cylinder_volume.p_physics = global_material_list.elements[loop_index].physics;
            break;
          }
          if (loop_index == global_material_list.num_elements-1) {
            printf("\n");
            printf("ERROR: The material string \"%s\" in Union geometry \"%s\" did not match a specified material. \n",material_string,NAME_CURRENT_COMP);
            printf("       The materials available at this point (need to be defined before the geometry): \n");
            for (loop_index=0;loop_index<global_material_list.num_elements;loop_index++)
              printf("         %s\n",global_material_list.elements[loop_index].name);
            printf("\n");
            printf("       It is also possible to use one of the defualt materials avaiable: \n");
            printf("           Vacuum (for a Volume without scattering or absorption)\n");
            printf("           Exit (for a Volume where the ray exits the component if it enters)\n");
            printf("           Mask (for a Volume that masks existing volumes specified in the mask_string\n");
            exit(1);
          }
        }
    }
} else {
    // Automatic linking, simply using the last defined material.
    #ifndef MATERIAL_DETECTOR
        printf("Need to define a material before the geometry to use automatic linking %s.\n",NAME_CURRENT_COMP);
        exit(1);
    #endif
    this_cylinder_volume.p_physics = global_material_list.elements[global_material_list.num_elements-1].physics;
}

sprintf(this_cylinder_volume.name,NAME_CURRENT_COMP);
sprintf(this_cylinder_volume.geometry.shape,"cylinder");
this_cylinder_volume.geometry.priority_value = priority;
// Currently the coordinates will be in absolute space.
this_cylinder_volume.geometry.center = POS_A_CURRENT_COMP;

this_cylinder_volume.geometry.geometry_p_interact = p_interact;
this_cylinder_storage.cyl_radius = radius;
this_cylinder_storage.height = yheight;
this_cylinder_volume.geometry.visualization_on = visualize;
this_cylinder_volume.geometry.geometry_parameters.p_cylinder_storage = &this_cylinder_storage;
this_cylinder_volume.geometry.within_function = &r_within_cylinder;
this_cylinder_volume.geometry.intersect_function = &sample_cylinder_intersect;
this_cylinder_volume.geometry.mcdisplay_function = &mcdisplay_cylinder_function;
this_cylinder_volume.geometry.shell_points = &cylinder_shell_points;
this_cylinder_volume.geometry.initialize_from_main_function = &initialize_cylinder_geometry_from_main_component;
this_cylinder_volume.geometry.process_rot_allocated = 0;
this_cylinder_volume.geometry.copy_geometry_parameters = &allocate_cylinder_storage_copy;

rot_copy(this_cylinder_volume.geometry.rotation_matrix,ROT_A_CURRENT_COMP);
rot_transpose(ROT_A_CURRENT_COMP,this_cylinder_volume.geometry.transpose_rotation_matrix);

// Initialize loggers
this_cylinder_volume.loggers.num_elements = 0;

// packing the information into the global_geometry_element, which is then included in the global_geometry_list.
sprintf(global_geometry_element.name,NAME_CURRENT_COMP);
global_geometry_element.activation_counter = number_of_activations;
global_geometry_element.component_index = INDEX_CURRENT_COMP;
global_geometry_element.Volume = &this_cylinder_volume; // Would be nicer if this m was a pointer, now we have the (small) data two places
add_element_to_geometry_list(&global_geometry_list,global_geometry_element);
}
#line 163931 "MACS_sample_kidney_box.c"
#undef number_of_activations
#undef mask_setting
#undef mask_string
#undef p_interact
#undef focus_r
#undef focus_xh
#undef focus_xw
#undef focus_ah
#undef focus_aw
#undef target_z
#undef target_y
#undef target_x
#undef target_index
#undef visualize
#undef yheight
#undef radius
#undef priority
#undef material_string
#undef this_cylinder_storage
#undef global_geometry_element
#undef this_cylinder_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

  /* Initializations for component kidney_hull_box_cut_arm1. */
  SIG_MESSAGE("kidney_hull_box_cut_arm1 (Init)");

  /* Initializations for component kidney_hull_box_cut1. */
  SIG_MESSAGE("kidney_hull_box_cut1 (Init)");
#define mccompcurname  kidney_hull_box_cut1
#define mccompcurtype  Union_box
#define mccompcurindex 121
#define loop_index mcckidney_hull_box_cut1_loop_index
#define this_box_volume mcckidney_hull_box_cut1_this_box_volume
#define global_geometry_element mcckidney_hull_box_cut1_global_geometry_element
#define this_box_storage mcckidney_hull_box_cut1_this_box_storage
#define material_string mcckidney_hull_box_cut1_material_string
#define priority mcckidney_hull_box_cut1_priority
#define xwidth mcckidney_hull_box_cut1_xwidth
#define yheight mcckidney_hull_box_cut1_yheight
#define zdepth mcckidney_hull_box_cut1_zdepth
#define xwidth2 mcckidney_hull_box_cut1_xwidth2
#define yheight2 mcckidney_hull_box_cut1_yheight2
#define visualize mcckidney_hull_box_cut1_visualize
#define target_index mcckidney_hull_box_cut1_target_index
#define target_x mcckidney_hull_box_cut1_target_x
#define target_y mcckidney_hull_box_cut1_target_y
#define target_z mcckidney_hull_box_cut1_target_z
#define focus_aw mcckidney_hull_box_cut1_focus_aw
#define focus_ah mcckidney_hull_box_cut1_focus_ah
#define focus_xw mcckidney_hull_box_cut1_focus_xw
#define focus_xh mcckidney_hull_box_cut1_focus_xh
#define focus_r mcckidney_hull_box_cut1_focus_r
#define p_interact mcckidney_hull_box_cut1_p_interact
#define mask_string mcckidney_hull_box_cut1_mask_string
#define mask_setting mcckidney_hull_box_cut1_mask_setting
#define number_of_activations mcckidney_hull_box_cut1_number_of_activations
#line 224 "Union_box.comp"
{
// Initializes the focusing system for this volume including input sanitation.
focus_initialize(&this_box_volume.geometry, POS_A_COMP_INDEX(INDEX_CURRENT_COMP+target_index), POS_A_CURRENT_COMP, ROT_A_CURRENT_COMP, target_index, target_x, target_y, target_z, focus_aw, focus_ah, focus_xw, focus_xh, focus_r, NAME_CURRENT_COMP);

// Input sanitation for this geometry
if (xwidth <= 0) {
  printf("\nERROR in Union_box named %s, the xwidth is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (yheight <= 0) {
  printf("\nERROR in Union_box named %s, yheight is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (zdepth <= 0) {
  printf("\nERROR in Union_box named %s, zdepth is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (xwidth2 <= 0 && xwidth2 != -1) {
  printf("\nERROR in Union_box named %s, the xwidth2 is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (yheight2 <= 0 && yheight2 != -1) {
  printf("\nERROR in Union_box named %s, yheight2 is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}

// Use sanitation
if (global_material_list.num_elements == 0) {
  printf("\nERROR: Need to define a material using Union_make_material before using a Union geometry component. \n");
  printf("       %s was defined before first use of Union_make_material.\n",NAME_CURRENT_COMP);
  exit(1);
}

this_box_volume.geometry.is_masked_volume = 0;
this_box_volume.geometry.is_exit_volume = 0;
this_box_volume.geometry.is_mask_volume = 0;
// check if the volume is a mask, if it is the material string is irelevant.
if (mask_string && strlen(mask_string) && strcmp(mask_string, "NULL") && strcmp(mask_string, "0")) {
    // A mask volume is used to limit the extend of other volumes, called the masked volumes. These are specified in the mask_string.
    // In order for a ray to enter a masked volume, it needs to be both in the region covered by that volume AND the mask volume.
    // When more than
    this_box_volume.geometry.mask_mode = 1; // Default is mask mode is ALL
    if (mask_setting && strlen(mask_setting) && strcmp(mask_setting, "NULL") && strcmp(mask_setting, "0")) {
        if (strcmp(mask_setting,"ALL") == 0 || strcmp(mask_setting,"All") == 0) this_box_volume.geometry.mask_mode = 1;
        else if (strcmp(mask_setting,"ANY") == 0 || strcmp(mask_setting,"Any") == 0) this_box_volume.geometry.mask_mode = 2;
        else {
            printf("The mask_mode of component %s is set to %s, but must be either ALL or ANY.\n",NAME_CURRENT_COMP,mask_setting);
            exit(1);
        }
    }
    
    for (loop_index=0;loop_index<global_geometry_list.num_elements;loop_index++) {
        // Add mask list
        if (1 == manual_linking_function(global_geometry_list.elements[loop_index].name,mask_string)) {
            add_element_to_int_list(&this_box_volume.geometry.mask_list,global_geometry_list.elements[loop_index].component_index);
            add_element_to_int_list(&global_geometry_list.elements[loop_index].Volume->geometry.masked_by_list,INDEX_CURRENT_COMP);
            global_geometry_list.elements[loop_index].Volume->geometry.is_masked_volume = 1;
            if (this_box_volume.geometry.mask_mode == 2)
                global_geometry_list.elements[loop_index].Volume->geometry.mask_mode = 2;
            if (this_box_volume.geometry.mask_mode == 1) {
                if (global_geometry_list.elements[loop_index].Volume->geometry.is_masked_volume == 1 && global_geometry_list.elements[loop_index].Volume->geometry.mask_mode != 2)
                    // If more than one mask is added to one volume, the ANY mode overwrites the (default) ALL mode.
                    global_geometry_list.elements[loop_index].Volume->geometry.mask_mode = 1;
            }
            
            found_geometries = 1;
        }
    }
    if (found_geometries == 0) {
        printf("The mask_string in geometry: %s did not find any of the specified volumes in the mask_string %s \n",NAME_CURRENT_COMP,mask_string);
        exit(1);
    }
    this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
    this_box_volume.p_physics->is_vacuum = 0; // Makes this volume a vacuum
    this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
    this_box_volume.p_physics->my_a = 0; // Should not be used.
    sprintf(this_box_volume.p_physics->name,"Mask");
    this_box_volume.geometry.is_mask_volume = 1;
    
    
// Read the material input, or if it lacks, use automatic linking.
} else if (material_string && strlen(material_string) && strcmp(material_string, "NULL") && strcmp(material_string, "0")) {
    // A geometry string was given, use it to determine which material
    if (0 == strcmp(material_string,"vacuum") || 0 == strcmp(material_string,"Vacuum")) {
        // One could have a global physics struct for vacuum instead of creating one for each
        this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
        this_box_volume.p_physics->is_vacuum = 1; // Makes this volume a vacuum
        this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
        this_box_volume.p_physics->my_a = 0; // Should not be used.
        sprintf(this_box_volume.p_physics->name,"Vacuum");
    } else if (0 == strcmp(material_string,"exit") || 0 == strcmp(material_string,"Exit")) {
        // One could have a global physics struct for vacuum instead of creating one for each
        this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
        this_box_volume.p_physics->is_vacuum = 1; // Makes this volume a vacuum
        this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
        this_box_volume.p_physics->my_a = 0; // Should not be used.
        this_box_volume.geometry.is_exit_volume = 1;
        sprintf(this_box_volume.p_physics->name,"Exit");
    } else {
        #ifndef MATERIAL_DETECTOR
            printf("Need to define a material before refering to it in a geometry %s.\n",NAME_CURRENT_COMP);
            exit(1);
        #endif
        for (loop_index=0;loop_index<global_material_list.num_elements;loop_index++) {
            if (0 == strcmp(material_string,global_material_list.elements[loop_index].name)) {
                this_box_volume.p_physics = global_material_list.elements[loop_index].physics;
                break;
            }
            if (loop_index == global_material_list.num_elements-1) {
            printf("\n");
            printf("ERROR: The material string \"%s\" in Union geometry \"%s\" did not match a specified material. \n",material_string,NAME_CURRENT_COMP);
            printf("       The materials available at this point (need to be defined before the geometry): \n");
            for (loop_index=0;loop_index<global_material_list.num_elements;loop_index++)
              printf("         %s\n",global_material_list.elements[loop_index].name);
            printf("\n");
            printf("       It is also possible to use one of the defualt materials avaiable: \n");
            printf("           Vacuum (for a Volume without scattering or absorption)\n");
            printf("           Exit (for a Volume where the ray exits the component if it enters)\n");
            printf("           Mask (for a Volume that masks existing volumes specified in the mask_string\n");
            exit(1);
          }
        }
    }
} else {
    // Automatic linking, simply using the last defined material.
    #ifndef MATERIAL_DETECTOR
        printf("Need to define a material before the geometry to use automatic linking %s.\n",NAME_CURRENT_COMP);
        exit(1);
    #endif
    this_box_volume.p_physics = global_material_list.elements[global_material_list.num_elements-1].physics;
}

sprintf(this_box_volume.name,NAME_CURRENT_COMP);
sprintf(this_box_volume.geometry.shape,"box");
this_box_volume.geometry.priority_value = priority;
this_box_volume.geometry.geometry_p_interact = p_interact;
// Currently the coordinates will be in absolute space.
this_box_volume.geometry.center = POS_A_CURRENT_COMP;

this_box_storage.z_depth = zdepth;
this_box_storage.x_width1 = xwidth;
this_box_storage.y_height1 = yheight;

this_box_storage.is_rectangle = 0;
if (xwidth2 < 0 && yheight2 < 0) this_box_storage.is_rectangle = 1;
if (xwidth == xwidth2 && yheight == yheight2) this_box_storage.is_rectangle = 1;

if (xwidth2 < 0) {
    this_box_storage.x_width2 = xwidth;
    xwidth2 = xwidth;
} else this_box_storage.x_width2 = xwidth2;

if (yheight2 < 0) {
    this_box_storage.y_height2 = yheight;
    yheight2 = yheight;
} else this_box_storage.y_height2 = yheight2;


this_box_storage.normal_vectors[0] = coords_set(0,0,1);
this_box_storage.normal_vectors[1] = coords_set(0,0,1);

// for sides with y component = 0
x_component = 2*zdepth/sqrt((xwidth-xwidth2)*(xwidth-xwidth2)+4*zdepth*zdepth);
z_component = (xwidth-xwidth2)/sqrt(4*zdepth*zdepth+(xwidth-xwidth2)*(xwidth-xwidth2));

this_box_storage.normal_vectors[2] = coords_set(x_component,0,z_component);
this_box_storage.normal_vectors[3] = coords_set(-x_component,0,z_component);

// for sides with x component = 0
y_component = 2*zdepth/sqrt((yheight-yheight2)*(yheight-yheight2)+4*zdepth*zdepth);
z_component = (yheight-yheight2)/sqrt(4*zdepth*zdepth+(yheight-yheight2)*(yheight-yheight2));

this_box_storage.normal_vectors[4] = coords_set(0,y_component,z_component);
this_box_storage.normal_vectors[5] = coords_set(0,-y_component,z_component);

this_box_volume.geometry.visualization_on = visualize;

this_box_volume.geometry.geometry_parameters.p_box_storage = &this_box_storage;

// Assign pointers to functions for intersection with the shape, checking if a point is inside the shape
if (this_box_storage.is_rectangle == 1) {
this_box_volume.geometry.intersect_function = &sample_box_intersect_simple;
this_box_volume.geometry.within_function = &r_within_box_simple;
}
else {
this_box_volume.geometry.intersect_function = &sample_box_intersect_advanced;
this_box_volume.geometry.within_function = &r_within_box_advanced;
}

this_box_volume.geometry.shell_points = &box_shell_points;
this_box_volume.geometry.mcdisplay_function = &mcdisplay_box_function;
this_box_volume.geometry.initialize_from_main_function = &initialize_box_geometry_from_main_component;
this_box_volume.geometry.process_rot_allocated = 0;

this_box_volume.geometry.copy_geometry_parameters = &allocate_box_storage_copy;

rot_copy(this_box_volume.geometry.rotation_matrix,ROT_A_CURRENT_COMP); //check how ROT_R_CURRENT_COMP would work
rot_transpose(ROT_A_CURRENT_COMP,this_box_volume.geometry.transpose_rotation_matrix);

// Initialize loggers
this_box_volume.loggers.num_elements = 0;

// packing the information into the global_geometry_element, which is then included in the global_geometry_list.
sprintf(global_geometry_element.name,NAME_CURRENT_COMP);
global_geometry_element.activation_counter = number_of_activations;
global_geometry_element.component_index = INDEX_CURRENT_COMP;
global_geometry_element.Volume = &this_box_volume; // Would be nicer if this m was a pointer, now we have the (small) data two places
add_element_to_geometry_list(&global_geometry_list,global_geometry_element);
}
#line 164201 "MACS_sample_kidney_box.c"
#undef number_of_activations
#undef mask_setting
#undef mask_string
#undef p_interact
#undef focus_r
#undef focus_xh
#undef focus_xw
#undef focus_ah
#undef focus_aw
#undef target_z
#undef target_y
#undef target_x
#undef target_index
#undef visualize
#undef yheight2
#undef xwidth2
#undef zdepth
#undef yheight
#undef xwidth
#undef priority
#undef material_string
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

  /* Initializations for component kidney_hull_box_cut_arm2. */
  SIG_MESSAGE("kidney_hull_box_cut_arm2 (Init)");

  /* Initializations for component kidney_hull_box_cut2. */
  SIG_MESSAGE("kidney_hull_box_cut2 (Init)");
#define mccompcurname  kidney_hull_box_cut2
#define mccompcurtype  Union_box
#define mccompcurindex 123
#define loop_index mcckidney_hull_box_cut2_loop_index
#define this_box_volume mcckidney_hull_box_cut2_this_box_volume
#define global_geometry_element mcckidney_hull_box_cut2_global_geometry_element
#define this_box_storage mcckidney_hull_box_cut2_this_box_storage
#define material_string mcckidney_hull_box_cut2_material_string
#define priority mcckidney_hull_box_cut2_priority
#define xwidth mcckidney_hull_box_cut2_xwidth
#define yheight mcckidney_hull_box_cut2_yheight
#define zdepth mcckidney_hull_box_cut2_zdepth
#define xwidth2 mcckidney_hull_box_cut2_xwidth2
#define yheight2 mcckidney_hull_box_cut2_yheight2
#define visualize mcckidney_hull_box_cut2_visualize
#define target_index mcckidney_hull_box_cut2_target_index
#define target_x mcckidney_hull_box_cut2_target_x
#define target_y mcckidney_hull_box_cut2_target_y
#define target_z mcckidney_hull_box_cut2_target_z
#define focus_aw mcckidney_hull_box_cut2_focus_aw
#define focus_ah mcckidney_hull_box_cut2_focus_ah
#define focus_xw mcckidney_hull_box_cut2_focus_xw
#define focus_xh mcckidney_hull_box_cut2_focus_xh
#define focus_r mcckidney_hull_box_cut2_focus_r
#define p_interact mcckidney_hull_box_cut2_p_interact
#define mask_string mcckidney_hull_box_cut2_mask_string
#define mask_setting mcckidney_hull_box_cut2_mask_setting
#define number_of_activations mcckidney_hull_box_cut2_number_of_activations
#line 224 "Union_box.comp"
{
// Initializes the focusing system for this volume including input sanitation.
focus_initialize(&this_box_volume.geometry, POS_A_COMP_INDEX(INDEX_CURRENT_COMP+target_index), POS_A_CURRENT_COMP, ROT_A_CURRENT_COMP, target_index, target_x, target_y, target_z, focus_aw, focus_ah, focus_xw, focus_xh, focus_r, NAME_CURRENT_COMP);

// Input sanitation for this geometry
if (xwidth <= 0) {
  printf("\nERROR in Union_box named %s, the xwidth is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (yheight <= 0) {
  printf("\nERROR in Union_box named %s, yheight is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (zdepth <= 0) {
  printf("\nERROR in Union_box named %s, zdepth is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (xwidth2 <= 0 && xwidth2 != -1) {
  printf("\nERROR in Union_box named %s, the xwidth2 is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (yheight2 <= 0 && yheight2 != -1) {
  printf("\nERROR in Union_box named %s, yheight2 is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}

// Use sanitation
if (global_material_list.num_elements == 0) {
  printf("\nERROR: Need to define a material using Union_make_material before using a Union geometry component. \n");
  printf("       %s was defined before first use of Union_make_material.\n",NAME_CURRENT_COMP);
  exit(1);
}

this_box_volume.geometry.is_masked_volume = 0;
this_box_volume.geometry.is_exit_volume = 0;
this_box_volume.geometry.is_mask_volume = 0;
// check if the volume is a mask, if it is the material string is irelevant.
if (mask_string && strlen(mask_string) && strcmp(mask_string, "NULL") && strcmp(mask_string, "0")) {
    // A mask volume is used to limit the extend of other volumes, called the masked volumes. These are specified in the mask_string.
    // In order for a ray to enter a masked volume, it needs to be both in the region covered by that volume AND the mask volume.
    // When more than
    this_box_volume.geometry.mask_mode = 1; // Default is mask mode is ALL
    if (mask_setting && strlen(mask_setting) && strcmp(mask_setting, "NULL") && strcmp(mask_setting, "0")) {
        if (strcmp(mask_setting,"ALL") == 0 || strcmp(mask_setting,"All") == 0) this_box_volume.geometry.mask_mode = 1;
        else if (strcmp(mask_setting,"ANY") == 0 || strcmp(mask_setting,"Any") == 0) this_box_volume.geometry.mask_mode = 2;
        else {
            printf("The mask_mode of component %s is set to %s, but must be either ALL or ANY.\n",NAME_CURRENT_COMP,mask_setting);
            exit(1);
        }
    }
    
    for (loop_index=0;loop_index<global_geometry_list.num_elements;loop_index++) {
        // Add mask list
        if (1 == manual_linking_function(global_geometry_list.elements[loop_index].name,mask_string)) {
            add_element_to_int_list(&this_box_volume.geometry.mask_list,global_geometry_list.elements[loop_index].component_index);
            add_element_to_int_list(&global_geometry_list.elements[loop_index].Volume->geometry.masked_by_list,INDEX_CURRENT_COMP);
            global_geometry_list.elements[loop_index].Volume->geometry.is_masked_volume = 1;
            if (this_box_volume.geometry.mask_mode == 2)
                global_geometry_list.elements[loop_index].Volume->geometry.mask_mode = 2;
            if (this_box_volume.geometry.mask_mode == 1) {
                if (global_geometry_list.elements[loop_index].Volume->geometry.is_masked_volume == 1 && global_geometry_list.elements[loop_index].Volume->geometry.mask_mode != 2)
                    // If more than one mask is added to one volume, the ANY mode overwrites the (default) ALL mode.
                    global_geometry_list.elements[loop_index].Volume->geometry.mask_mode = 1;
            }
            
            found_geometries = 1;
        }
    }
    if (found_geometries == 0) {
        printf("The mask_string in geometry: %s did not find any of the specified volumes in the mask_string %s \n",NAME_CURRENT_COMP,mask_string);
        exit(1);
    }
    this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
    this_box_volume.p_physics->is_vacuum = 0; // Makes this volume a vacuum
    this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
    this_box_volume.p_physics->my_a = 0; // Should not be used.
    sprintf(this_box_volume.p_physics->name,"Mask");
    this_box_volume.geometry.is_mask_volume = 1;
    
    
// Read the material input, or if it lacks, use automatic linking.
} else if (material_string && strlen(material_string) && strcmp(material_string, "NULL") && strcmp(material_string, "0")) {
    // A geometry string was given, use it to determine which material
    if (0 == strcmp(material_string,"vacuum") || 0 == strcmp(material_string,"Vacuum")) {
        // One could have a global physics struct for vacuum instead of creating one for each
        this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
        this_box_volume.p_physics->is_vacuum = 1; // Makes this volume a vacuum
        this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
        this_box_volume.p_physics->my_a = 0; // Should not be used.
        sprintf(this_box_volume.p_physics->name,"Vacuum");
    } else if (0 == strcmp(material_string,"exit") || 0 == strcmp(material_string,"Exit")) {
        // One could have a global physics struct for vacuum instead of creating one for each
        this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
        this_box_volume.p_physics->is_vacuum = 1; // Makes this volume a vacuum
        this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
        this_box_volume.p_physics->my_a = 0; // Should not be used.
        this_box_volume.geometry.is_exit_volume = 1;
        sprintf(this_box_volume.p_physics->name,"Exit");
    } else {
        #ifndef MATERIAL_DETECTOR
            printf("Need to define a material before refering to it in a geometry %s.\n",NAME_CURRENT_COMP);
            exit(1);
        #endif
        for (loop_index=0;loop_index<global_material_list.num_elements;loop_index++) {
            if (0 == strcmp(material_string,global_material_list.elements[loop_index].name)) {
                this_box_volume.p_physics = global_material_list.elements[loop_index].physics;
                break;
            }
            if (loop_index == global_material_list.num_elements-1) {
            printf("\n");
            printf("ERROR: The material string \"%s\" in Union geometry \"%s\" did not match a specified material. \n",material_string,NAME_CURRENT_COMP);
            printf("       The materials available at this point (need to be defined before the geometry): \n");
            for (loop_index=0;loop_index<global_material_list.num_elements;loop_index++)
              printf("         %s\n",global_material_list.elements[loop_index].name);
            printf("\n");
            printf("       It is also possible to use one of the defualt materials avaiable: \n");
            printf("           Vacuum (for a Volume without scattering or absorption)\n");
            printf("           Exit (for a Volume where the ray exits the component if it enters)\n");
            printf("           Mask (for a Volume that masks existing volumes specified in the mask_string\n");
            exit(1);
          }
        }
    }
} else {
    // Automatic linking, simply using the last defined material.
    #ifndef MATERIAL_DETECTOR
        printf("Need to define a material before the geometry to use automatic linking %s.\n",NAME_CURRENT_COMP);
        exit(1);
    #endif
    this_box_volume.p_physics = global_material_list.elements[global_material_list.num_elements-1].physics;
}

sprintf(this_box_volume.name,NAME_CURRENT_COMP);
sprintf(this_box_volume.geometry.shape,"box");
this_box_volume.geometry.priority_value = priority;
this_box_volume.geometry.geometry_p_interact = p_interact;
// Currently the coordinates will be in absolute space.
this_box_volume.geometry.center = POS_A_CURRENT_COMP;

this_box_storage.z_depth = zdepth;
this_box_storage.x_width1 = xwidth;
this_box_storage.y_height1 = yheight;

this_box_storage.is_rectangle = 0;
if (xwidth2 < 0 && yheight2 < 0) this_box_storage.is_rectangle = 1;
if (xwidth == xwidth2 && yheight == yheight2) this_box_storage.is_rectangle = 1;

if (xwidth2 < 0) {
    this_box_storage.x_width2 = xwidth;
    xwidth2 = xwidth;
} else this_box_storage.x_width2 = xwidth2;

if (yheight2 < 0) {
    this_box_storage.y_height2 = yheight;
    yheight2 = yheight;
} else this_box_storage.y_height2 = yheight2;


this_box_storage.normal_vectors[0] = coords_set(0,0,1);
this_box_storage.normal_vectors[1] = coords_set(0,0,1);

// for sides with y component = 0
x_component = 2*zdepth/sqrt((xwidth-xwidth2)*(xwidth-xwidth2)+4*zdepth*zdepth);
z_component = (xwidth-xwidth2)/sqrt(4*zdepth*zdepth+(xwidth-xwidth2)*(xwidth-xwidth2));

this_box_storage.normal_vectors[2] = coords_set(x_component,0,z_component);
this_box_storage.normal_vectors[3] = coords_set(-x_component,0,z_component);

// for sides with x component = 0
y_component = 2*zdepth/sqrt((yheight-yheight2)*(yheight-yheight2)+4*zdepth*zdepth);
z_component = (yheight-yheight2)/sqrt(4*zdepth*zdepth+(yheight-yheight2)*(yheight-yheight2));

this_box_storage.normal_vectors[4] = coords_set(0,y_component,z_component);
this_box_storage.normal_vectors[5] = coords_set(0,-y_component,z_component);

this_box_volume.geometry.visualization_on = visualize;

this_box_volume.geometry.geometry_parameters.p_box_storage = &this_box_storage;

// Assign pointers to functions for intersection with the shape, checking if a point is inside the shape
if (this_box_storage.is_rectangle == 1) {
this_box_volume.geometry.intersect_function = &sample_box_intersect_simple;
this_box_volume.geometry.within_function = &r_within_box_simple;
}
else {
this_box_volume.geometry.intersect_function = &sample_box_intersect_advanced;
this_box_volume.geometry.within_function = &r_within_box_advanced;
}

this_box_volume.geometry.shell_points = &box_shell_points;
this_box_volume.geometry.mcdisplay_function = &mcdisplay_box_function;
this_box_volume.geometry.initialize_from_main_function = &initialize_box_geometry_from_main_component;
this_box_volume.geometry.process_rot_allocated = 0;

this_box_volume.geometry.copy_geometry_parameters = &allocate_box_storage_copy;

rot_copy(this_box_volume.geometry.rotation_matrix,ROT_A_CURRENT_COMP); //check how ROT_R_CURRENT_COMP would work
rot_transpose(ROT_A_CURRENT_COMP,this_box_volume.geometry.transpose_rotation_matrix);

// Initialize loggers
this_box_volume.loggers.num_elements = 0;

// packing the information into the global_geometry_element, which is then included in the global_geometry_list.
sprintf(global_geometry_element.name,NAME_CURRENT_COMP);
global_geometry_element.activation_counter = number_of_activations;
global_geometry_element.component_index = INDEX_CURRENT_COMP;
global_geometry_element.Volume = &this_box_volume; // Would be nicer if this m was a pointer, now we have the (small) data two places
add_element_to_geometry_list(&global_geometry_list,global_geometry_element);
}
#line 164474 "MACS_sample_kidney_box.c"
#undef number_of_activations
#undef mask_setting
#undef mask_string
#undef p_interact
#undef focus_r
#undef focus_xh
#undef focus_xw
#undef focus_ah
#undef focus_aw
#undef target_z
#undef target_y
#undef target_x
#undef target_index
#undef visualize
#undef yheight2
#undef xwidth2
#undef zdepth
#undef yheight
#undef xwidth
#undef priority
#undef material_string
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

  /* Initializations for component channel_0_cave1_box1. */
  SIG_MESSAGE("channel_0_cave1_box1 (Init)");
#define mccompcurname  channel_0_cave1_box1
#define mccompcurtype  Union_box
#define mccompcurindex 124
#define loop_index mccchannel_0_cave1_box1_loop_index
#define this_box_volume mccchannel_0_cave1_box1_this_box_volume
#define global_geometry_element mccchannel_0_cave1_box1_global_geometry_element
#define this_box_storage mccchannel_0_cave1_box1_this_box_storage
#define material_string mccchannel_0_cave1_box1_material_string
#define priority mccchannel_0_cave1_box1_priority
#define xwidth mccchannel_0_cave1_box1_xwidth
#define yheight mccchannel_0_cave1_box1_yheight
#define zdepth mccchannel_0_cave1_box1_zdepth
#define xwidth2 mccchannel_0_cave1_box1_xwidth2
#define yheight2 mccchannel_0_cave1_box1_yheight2
#define visualize mccchannel_0_cave1_box1_visualize
#define target_index mccchannel_0_cave1_box1_target_index
#define target_x mccchannel_0_cave1_box1_target_x
#define target_y mccchannel_0_cave1_box1_target_y
#define target_z mccchannel_0_cave1_box1_target_z
#define focus_aw mccchannel_0_cave1_box1_focus_aw
#define focus_ah mccchannel_0_cave1_box1_focus_ah
#define focus_xw mccchannel_0_cave1_box1_focus_xw
#define focus_xh mccchannel_0_cave1_box1_focus_xh
#define focus_r mccchannel_0_cave1_box1_focus_r
#define p_interact mccchannel_0_cave1_box1_p_interact
#define mask_string mccchannel_0_cave1_box1_mask_string
#define mask_setting mccchannel_0_cave1_box1_mask_setting
#define number_of_activations mccchannel_0_cave1_box1_number_of_activations
#line 224 "Union_box.comp"
{
// Initializes the focusing system for this volume including input sanitation.
focus_initialize(&this_box_volume.geometry, POS_A_COMP_INDEX(INDEX_CURRENT_COMP+target_index), POS_A_CURRENT_COMP, ROT_A_CURRENT_COMP, target_index, target_x, target_y, target_z, focus_aw, focus_ah, focus_xw, focus_xh, focus_r, NAME_CURRENT_COMP);

// Input sanitation for this geometry
if (xwidth <= 0) {
  printf("\nERROR in Union_box named %s, the xwidth is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (yheight <= 0) {
  printf("\nERROR in Union_box named %s, yheight is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (zdepth <= 0) {
  printf("\nERROR in Union_box named %s, zdepth is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (xwidth2 <= 0 && xwidth2 != -1) {
  printf("\nERROR in Union_box named %s, the xwidth2 is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (yheight2 <= 0 && yheight2 != -1) {
  printf("\nERROR in Union_box named %s, yheight2 is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}

// Use sanitation
if (global_material_list.num_elements == 0) {
  printf("\nERROR: Need to define a material using Union_make_material before using a Union geometry component. \n");
  printf("       %s was defined before first use of Union_make_material.\n",NAME_CURRENT_COMP);
  exit(1);
}

this_box_volume.geometry.is_masked_volume = 0;
this_box_volume.geometry.is_exit_volume = 0;
this_box_volume.geometry.is_mask_volume = 0;
// check if the volume is a mask, if it is the material string is irelevant.
if (mask_string && strlen(mask_string) && strcmp(mask_string, "NULL") && strcmp(mask_string, "0")) {
    // A mask volume is used to limit the extend of other volumes, called the masked volumes. These are specified in the mask_string.
    // In order for a ray to enter a masked volume, it needs to be both in the region covered by that volume AND the mask volume.
    // When more than
    this_box_volume.geometry.mask_mode = 1; // Default is mask mode is ALL
    if (mask_setting && strlen(mask_setting) && strcmp(mask_setting, "NULL") && strcmp(mask_setting, "0")) {
        if (strcmp(mask_setting,"ALL") == 0 || strcmp(mask_setting,"All") == 0) this_box_volume.geometry.mask_mode = 1;
        else if (strcmp(mask_setting,"ANY") == 0 || strcmp(mask_setting,"Any") == 0) this_box_volume.geometry.mask_mode = 2;
        else {
            printf("The mask_mode of component %s is set to %s, but must be either ALL or ANY.\n",NAME_CURRENT_COMP,mask_setting);
            exit(1);
        }
    }
    
    for (loop_index=0;loop_index<global_geometry_list.num_elements;loop_index++) {
        // Add mask list
        if (1 == manual_linking_function(global_geometry_list.elements[loop_index].name,mask_string)) {
            add_element_to_int_list(&this_box_volume.geometry.mask_list,global_geometry_list.elements[loop_index].component_index);
            add_element_to_int_list(&global_geometry_list.elements[loop_index].Volume->geometry.masked_by_list,INDEX_CURRENT_COMP);
            global_geometry_list.elements[loop_index].Volume->geometry.is_masked_volume = 1;
            if (this_box_volume.geometry.mask_mode == 2)
                global_geometry_list.elements[loop_index].Volume->geometry.mask_mode = 2;
            if (this_box_volume.geometry.mask_mode == 1) {
                if (global_geometry_list.elements[loop_index].Volume->geometry.is_masked_volume == 1 && global_geometry_list.elements[loop_index].Volume->geometry.mask_mode != 2)
                    // If more than one mask is added to one volume, the ANY mode overwrites the (default) ALL mode.
                    global_geometry_list.elements[loop_index].Volume->geometry.mask_mode = 1;
            }
            
            found_geometries = 1;
        }
    }
    if (found_geometries == 0) {
        printf("The mask_string in geometry: %s did not find any of the specified volumes in the mask_string %s \n",NAME_CURRENT_COMP,mask_string);
        exit(1);
    }
    this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
    this_box_volume.p_physics->is_vacuum = 0; // Makes this volume a vacuum
    this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
    this_box_volume.p_physics->my_a = 0; // Should not be used.
    sprintf(this_box_volume.p_physics->name,"Mask");
    this_box_volume.geometry.is_mask_volume = 1;
    
    
// Read the material input, or if it lacks, use automatic linking.
} else if (material_string && strlen(material_string) && strcmp(material_string, "NULL") && strcmp(material_string, "0")) {
    // A geometry string was given, use it to determine which material
    if (0 == strcmp(material_string,"vacuum") || 0 == strcmp(material_string,"Vacuum")) {
        // One could have a global physics struct for vacuum instead of creating one for each
        this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
        this_box_volume.p_physics->is_vacuum = 1; // Makes this volume a vacuum
        this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
        this_box_volume.p_physics->my_a = 0; // Should not be used.
        sprintf(this_box_volume.p_physics->name,"Vacuum");
    } else if (0 == strcmp(material_string,"exit") || 0 == strcmp(material_string,"Exit")) {
        // One could have a global physics struct for vacuum instead of creating one for each
        this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
        this_box_volume.p_physics->is_vacuum = 1; // Makes this volume a vacuum
        this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
        this_box_volume.p_physics->my_a = 0; // Should not be used.
        this_box_volume.geometry.is_exit_volume = 1;
        sprintf(this_box_volume.p_physics->name,"Exit");
    } else {
        #ifndef MATERIAL_DETECTOR
            printf("Need to define a material before refering to it in a geometry %s.\n",NAME_CURRENT_COMP);
            exit(1);
        #endif
        for (loop_index=0;loop_index<global_material_list.num_elements;loop_index++) {
            if (0 == strcmp(material_string,global_material_list.elements[loop_index].name)) {
                this_box_volume.p_physics = global_material_list.elements[loop_index].physics;
                break;
            }
            if (loop_index == global_material_list.num_elements-1) {
            printf("\n");
            printf("ERROR: The material string \"%s\" in Union geometry \"%s\" did not match a specified material. \n",material_string,NAME_CURRENT_COMP);
            printf("       The materials available at this point (need to be defined before the geometry): \n");
            for (loop_index=0;loop_index<global_material_list.num_elements;loop_index++)
              printf("         %s\n",global_material_list.elements[loop_index].name);
            printf("\n");
            printf("       It is also possible to use one of the defualt materials avaiable: \n");
            printf("           Vacuum (for a Volume without scattering or absorption)\n");
            printf("           Exit (for a Volume where the ray exits the component if it enters)\n");
            printf("           Mask (for a Volume that masks existing volumes specified in the mask_string\n");
            exit(1);
          }
        }
    }
} else {
    // Automatic linking, simply using the last defined material.
    #ifndef MATERIAL_DETECTOR
        printf("Need to define a material before the geometry to use automatic linking %s.\n",NAME_CURRENT_COMP);
        exit(1);
    #endif
    this_box_volume.p_physics = global_material_list.elements[global_material_list.num_elements-1].physics;
}

sprintf(this_box_volume.name,NAME_CURRENT_COMP);
sprintf(this_box_volume.geometry.shape,"box");
this_box_volume.geometry.priority_value = priority;
this_box_volume.geometry.geometry_p_interact = p_interact;
// Currently the coordinates will be in absolute space.
this_box_volume.geometry.center = POS_A_CURRENT_COMP;

this_box_storage.z_depth = zdepth;
this_box_storage.x_width1 = xwidth;
this_box_storage.y_height1 = yheight;

this_box_storage.is_rectangle = 0;
if (xwidth2 < 0 && yheight2 < 0) this_box_storage.is_rectangle = 1;
if (xwidth == xwidth2 && yheight == yheight2) this_box_storage.is_rectangle = 1;

if (xwidth2 < 0) {
    this_box_storage.x_width2 = xwidth;
    xwidth2 = xwidth;
} else this_box_storage.x_width2 = xwidth2;

if (yheight2 < 0) {
    this_box_storage.y_height2 = yheight;
    yheight2 = yheight;
} else this_box_storage.y_height2 = yheight2;


this_box_storage.normal_vectors[0] = coords_set(0,0,1);
this_box_storage.normal_vectors[1] = coords_set(0,0,1);

// for sides with y component = 0
x_component = 2*zdepth/sqrt((xwidth-xwidth2)*(xwidth-xwidth2)+4*zdepth*zdepth);
z_component = (xwidth-xwidth2)/sqrt(4*zdepth*zdepth+(xwidth-xwidth2)*(xwidth-xwidth2));

this_box_storage.normal_vectors[2] = coords_set(x_component,0,z_component);
this_box_storage.normal_vectors[3] = coords_set(-x_component,0,z_component);

// for sides with x component = 0
y_component = 2*zdepth/sqrt((yheight-yheight2)*(yheight-yheight2)+4*zdepth*zdepth);
z_component = (yheight-yheight2)/sqrt(4*zdepth*zdepth+(yheight-yheight2)*(yheight-yheight2));

this_box_storage.normal_vectors[4] = coords_set(0,y_component,z_component);
this_box_storage.normal_vectors[5] = coords_set(0,-y_component,z_component);

this_box_volume.geometry.visualization_on = visualize;

this_box_volume.geometry.geometry_parameters.p_box_storage = &this_box_storage;

// Assign pointers to functions for intersection with the shape, checking if a point is inside the shape
if (this_box_storage.is_rectangle == 1) {
this_box_volume.geometry.intersect_function = &sample_box_intersect_simple;
this_box_volume.geometry.within_function = &r_within_box_simple;
}
else {
this_box_volume.geometry.intersect_function = &sample_box_intersect_advanced;
this_box_volume.geometry.within_function = &r_within_box_advanced;
}

this_box_volume.geometry.shell_points = &box_shell_points;
this_box_volume.geometry.mcdisplay_function = &mcdisplay_box_function;
this_box_volume.geometry.initialize_from_main_function = &initialize_box_geometry_from_main_component;
this_box_volume.geometry.process_rot_allocated = 0;

this_box_volume.geometry.copy_geometry_parameters = &allocate_box_storage_copy;

rot_copy(this_box_volume.geometry.rotation_matrix,ROT_A_CURRENT_COMP); //check how ROT_R_CURRENT_COMP would work
rot_transpose(ROT_A_CURRENT_COMP,this_box_volume.geometry.transpose_rotation_matrix);

// Initialize loggers
this_box_volume.loggers.num_elements = 0;

// packing the information into the global_geometry_element, which is then included in the global_geometry_list.
sprintf(global_geometry_element.name,NAME_CURRENT_COMP);
global_geometry_element.activation_counter = number_of_activations;
global_geometry_element.component_index = INDEX_CURRENT_COMP;
global_geometry_element.Volume = &this_box_volume; // Would be nicer if this m was a pointer, now we have the (small) data two places
add_element_to_geometry_list(&global_geometry_list,global_geometry_element);
}
#line 164744 "MACS_sample_kidney_box.c"
#undef number_of_activations
#undef mask_setting
#undef mask_string
#undef p_interact
#undef focus_r
#undef focus_xh
#undef focus_xw
#undef focus_ah
#undef focus_aw
#undef target_z
#undef target_y
#undef target_x
#undef target_index
#undef visualize
#undef yheight2
#undef xwidth2
#undef zdepth
#undef yheight
#undef xwidth
#undef priority
#undef material_string
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

  /* Initializations for component channel_0_cave1_box2. */
  SIG_MESSAGE("channel_0_cave1_box2 (Init)");
#define mccompcurname  channel_0_cave1_box2
#define mccompcurtype  Union_box
#define mccompcurindex 125
#define loop_index mccchannel_0_cave1_box2_loop_index
#define this_box_volume mccchannel_0_cave1_box2_this_box_volume
#define global_geometry_element mccchannel_0_cave1_box2_global_geometry_element
#define this_box_storage mccchannel_0_cave1_box2_this_box_storage
#define material_string mccchannel_0_cave1_box2_material_string
#define priority mccchannel_0_cave1_box2_priority
#define xwidth mccchannel_0_cave1_box2_xwidth
#define yheight mccchannel_0_cave1_box2_yheight
#define zdepth mccchannel_0_cave1_box2_zdepth
#define xwidth2 mccchannel_0_cave1_box2_xwidth2
#define yheight2 mccchannel_0_cave1_box2_yheight2
#define visualize mccchannel_0_cave1_box2_visualize
#define target_index mccchannel_0_cave1_box2_target_index
#define target_x mccchannel_0_cave1_box2_target_x
#define target_y mccchannel_0_cave1_box2_target_y
#define target_z mccchannel_0_cave1_box2_target_z
#define focus_aw mccchannel_0_cave1_box2_focus_aw
#define focus_ah mccchannel_0_cave1_box2_focus_ah
#define focus_xw mccchannel_0_cave1_box2_focus_xw
#define focus_xh mccchannel_0_cave1_box2_focus_xh
#define focus_r mccchannel_0_cave1_box2_focus_r
#define p_interact mccchannel_0_cave1_box2_p_interact
#define mask_string mccchannel_0_cave1_box2_mask_string
#define mask_setting mccchannel_0_cave1_box2_mask_setting
#define number_of_activations mccchannel_0_cave1_box2_number_of_activations
#line 224 "Union_box.comp"
{
// Initializes the focusing system for this volume including input sanitation.
focus_initialize(&this_box_volume.geometry, POS_A_COMP_INDEX(INDEX_CURRENT_COMP+target_index), POS_A_CURRENT_COMP, ROT_A_CURRENT_COMP, target_index, target_x, target_y, target_z, focus_aw, focus_ah, focus_xw, focus_xh, focus_r, NAME_CURRENT_COMP);

// Input sanitation for this geometry
if (xwidth <= 0) {
  printf("\nERROR in Union_box named %s, the xwidth is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (yheight <= 0) {
  printf("\nERROR in Union_box named %s, yheight is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (zdepth <= 0) {
  printf("\nERROR in Union_box named %s, zdepth is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (xwidth2 <= 0 && xwidth2 != -1) {
  printf("\nERROR in Union_box named %s, the xwidth2 is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (yheight2 <= 0 && yheight2 != -1) {
  printf("\nERROR in Union_box named %s, yheight2 is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}

// Use sanitation
if (global_material_list.num_elements == 0) {
  printf("\nERROR: Need to define a material using Union_make_material before using a Union geometry component. \n");
  printf("       %s was defined before first use of Union_make_material.\n",NAME_CURRENT_COMP);
  exit(1);
}

this_box_volume.geometry.is_masked_volume = 0;
this_box_volume.geometry.is_exit_volume = 0;
this_box_volume.geometry.is_mask_volume = 0;
// check if the volume is a mask, if it is the material string is irelevant.
if (mask_string && strlen(mask_string) && strcmp(mask_string, "NULL") && strcmp(mask_string, "0")) {
    // A mask volume is used to limit the extend of other volumes, called the masked volumes. These are specified in the mask_string.
    // In order for a ray to enter a masked volume, it needs to be both in the region covered by that volume AND the mask volume.
    // When more than
    this_box_volume.geometry.mask_mode = 1; // Default is mask mode is ALL
    if (mask_setting && strlen(mask_setting) && strcmp(mask_setting, "NULL") && strcmp(mask_setting, "0")) {
        if (strcmp(mask_setting,"ALL") == 0 || strcmp(mask_setting,"All") == 0) this_box_volume.geometry.mask_mode = 1;
        else if (strcmp(mask_setting,"ANY") == 0 || strcmp(mask_setting,"Any") == 0) this_box_volume.geometry.mask_mode = 2;
        else {
            printf("The mask_mode of component %s is set to %s, but must be either ALL or ANY.\n",NAME_CURRENT_COMP,mask_setting);
            exit(1);
        }
    }
    
    for (loop_index=0;loop_index<global_geometry_list.num_elements;loop_index++) {
        // Add mask list
        if (1 == manual_linking_function(global_geometry_list.elements[loop_index].name,mask_string)) {
            add_element_to_int_list(&this_box_volume.geometry.mask_list,global_geometry_list.elements[loop_index].component_index);
            add_element_to_int_list(&global_geometry_list.elements[loop_index].Volume->geometry.masked_by_list,INDEX_CURRENT_COMP);
            global_geometry_list.elements[loop_index].Volume->geometry.is_masked_volume = 1;
            if (this_box_volume.geometry.mask_mode == 2)
                global_geometry_list.elements[loop_index].Volume->geometry.mask_mode = 2;
            if (this_box_volume.geometry.mask_mode == 1) {
                if (global_geometry_list.elements[loop_index].Volume->geometry.is_masked_volume == 1 && global_geometry_list.elements[loop_index].Volume->geometry.mask_mode != 2)
                    // If more than one mask is added to one volume, the ANY mode overwrites the (default) ALL mode.
                    global_geometry_list.elements[loop_index].Volume->geometry.mask_mode = 1;
            }
            
            found_geometries = 1;
        }
    }
    if (found_geometries == 0) {
        printf("The mask_string in geometry: %s did not find any of the specified volumes in the mask_string %s \n",NAME_CURRENT_COMP,mask_string);
        exit(1);
    }
    this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
    this_box_volume.p_physics->is_vacuum = 0; // Makes this volume a vacuum
    this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
    this_box_volume.p_physics->my_a = 0; // Should not be used.
    sprintf(this_box_volume.p_physics->name,"Mask");
    this_box_volume.geometry.is_mask_volume = 1;
    
    
// Read the material input, or if it lacks, use automatic linking.
} else if (material_string && strlen(material_string) && strcmp(material_string, "NULL") && strcmp(material_string, "0")) {
    // A geometry string was given, use it to determine which material
    if (0 == strcmp(material_string,"vacuum") || 0 == strcmp(material_string,"Vacuum")) {
        // One could have a global physics struct for vacuum instead of creating one for each
        this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
        this_box_volume.p_physics->is_vacuum = 1; // Makes this volume a vacuum
        this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
        this_box_volume.p_physics->my_a = 0; // Should not be used.
        sprintf(this_box_volume.p_physics->name,"Vacuum");
    } else if (0 == strcmp(material_string,"exit") || 0 == strcmp(material_string,"Exit")) {
        // One could have a global physics struct for vacuum instead of creating one for each
        this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
        this_box_volume.p_physics->is_vacuum = 1; // Makes this volume a vacuum
        this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
        this_box_volume.p_physics->my_a = 0; // Should not be used.
        this_box_volume.geometry.is_exit_volume = 1;
        sprintf(this_box_volume.p_physics->name,"Exit");
    } else {
        #ifndef MATERIAL_DETECTOR
            printf("Need to define a material before refering to it in a geometry %s.\n",NAME_CURRENT_COMP);
            exit(1);
        #endif
        for (loop_index=0;loop_index<global_material_list.num_elements;loop_index++) {
            if (0 == strcmp(material_string,global_material_list.elements[loop_index].name)) {
                this_box_volume.p_physics = global_material_list.elements[loop_index].physics;
                break;
            }
            if (loop_index == global_material_list.num_elements-1) {
            printf("\n");
            printf("ERROR: The material string \"%s\" in Union geometry \"%s\" did not match a specified material. \n",material_string,NAME_CURRENT_COMP);
            printf("       The materials available at this point (need to be defined before the geometry): \n");
            for (loop_index=0;loop_index<global_material_list.num_elements;loop_index++)
              printf("         %s\n",global_material_list.elements[loop_index].name);
            printf("\n");
            printf("       It is also possible to use one of the defualt materials avaiable: \n");
            printf("           Vacuum (for a Volume without scattering or absorption)\n");
            printf("           Exit (for a Volume where the ray exits the component if it enters)\n");
            printf("           Mask (for a Volume that masks existing volumes specified in the mask_string\n");
            exit(1);
          }
        }
    }
} else {
    // Automatic linking, simply using the last defined material.
    #ifndef MATERIAL_DETECTOR
        printf("Need to define a material before the geometry to use automatic linking %s.\n",NAME_CURRENT_COMP);
        exit(1);
    #endif
    this_box_volume.p_physics = global_material_list.elements[global_material_list.num_elements-1].physics;
}

sprintf(this_box_volume.name,NAME_CURRENT_COMP);
sprintf(this_box_volume.geometry.shape,"box");
this_box_volume.geometry.priority_value = priority;
this_box_volume.geometry.geometry_p_interact = p_interact;
// Currently the coordinates will be in absolute space.
this_box_volume.geometry.center = POS_A_CURRENT_COMP;

this_box_storage.z_depth = zdepth;
this_box_storage.x_width1 = xwidth;
this_box_storage.y_height1 = yheight;

this_box_storage.is_rectangle = 0;
if (xwidth2 < 0 && yheight2 < 0) this_box_storage.is_rectangle = 1;
if (xwidth == xwidth2 && yheight == yheight2) this_box_storage.is_rectangle = 1;

if (xwidth2 < 0) {
    this_box_storage.x_width2 = xwidth;
    xwidth2 = xwidth;
} else this_box_storage.x_width2 = xwidth2;

if (yheight2 < 0) {
    this_box_storage.y_height2 = yheight;
    yheight2 = yheight;
} else this_box_storage.y_height2 = yheight2;


this_box_storage.normal_vectors[0] = coords_set(0,0,1);
this_box_storage.normal_vectors[1] = coords_set(0,0,1);

// for sides with y component = 0
x_component = 2*zdepth/sqrt((xwidth-xwidth2)*(xwidth-xwidth2)+4*zdepth*zdepth);
z_component = (xwidth-xwidth2)/sqrt(4*zdepth*zdepth+(xwidth-xwidth2)*(xwidth-xwidth2));

this_box_storage.normal_vectors[2] = coords_set(x_component,0,z_component);
this_box_storage.normal_vectors[3] = coords_set(-x_component,0,z_component);

// for sides with x component = 0
y_component = 2*zdepth/sqrt((yheight-yheight2)*(yheight-yheight2)+4*zdepth*zdepth);
z_component = (yheight-yheight2)/sqrt(4*zdepth*zdepth+(yheight-yheight2)*(yheight-yheight2));

this_box_storage.normal_vectors[4] = coords_set(0,y_component,z_component);
this_box_storage.normal_vectors[5] = coords_set(0,-y_component,z_component);

this_box_volume.geometry.visualization_on = visualize;

this_box_volume.geometry.geometry_parameters.p_box_storage = &this_box_storage;

// Assign pointers to functions for intersection with the shape, checking if a point is inside the shape
if (this_box_storage.is_rectangle == 1) {
this_box_volume.geometry.intersect_function = &sample_box_intersect_simple;
this_box_volume.geometry.within_function = &r_within_box_simple;
}
else {
this_box_volume.geometry.intersect_function = &sample_box_intersect_advanced;
this_box_volume.geometry.within_function = &r_within_box_advanced;
}

this_box_volume.geometry.shell_points = &box_shell_points;
this_box_volume.geometry.mcdisplay_function = &mcdisplay_box_function;
this_box_volume.geometry.initialize_from_main_function = &initialize_box_geometry_from_main_component;
this_box_volume.geometry.process_rot_allocated = 0;

this_box_volume.geometry.copy_geometry_parameters = &allocate_box_storage_copy;

rot_copy(this_box_volume.geometry.rotation_matrix,ROT_A_CURRENT_COMP); //check how ROT_R_CURRENT_COMP would work
rot_transpose(ROT_A_CURRENT_COMP,this_box_volume.geometry.transpose_rotation_matrix);

// Initialize loggers
this_box_volume.loggers.num_elements = 0;

// packing the information into the global_geometry_element, which is then included in the global_geometry_list.
sprintf(global_geometry_element.name,NAME_CURRENT_COMP);
global_geometry_element.activation_counter = number_of_activations;
global_geometry_element.component_index = INDEX_CURRENT_COMP;
global_geometry_element.Volume = &this_box_volume; // Would be nicer if this m was a pointer, now we have the (small) data two places
add_element_to_geometry_list(&global_geometry_list,global_geometry_element);
}
#line 165014 "MACS_sample_kidney_box.c"
#undef number_of_activations
#undef mask_setting
#undef mask_string
#undef p_interact
#undef focus_r
#undef focus_xh
#undef focus_xw
#undef focus_ah
#undef focus_aw
#undef target_z
#undef target_y
#undef target_x
#undef target_index
#undef visualize
#undef yheight2
#undef xwidth2
#undef zdepth
#undef yheight
#undef xwidth
#undef priority
#undef material_string
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

  /* Initializations for component channel_0_cave1_box3. */
  SIG_MESSAGE("channel_0_cave1_box3 (Init)");
#define mccompcurname  channel_0_cave1_box3
#define mccompcurtype  Union_box
#define mccompcurindex 126
#define loop_index mccchannel_0_cave1_box3_loop_index
#define this_box_volume mccchannel_0_cave1_box3_this_box_volume
#define global_geometry_element mccchannel_0_cave1_box3_global_geometry_element
#define this_box_storage mccchannel_0_cave1_box3_this_box_storage
#define material_string mccchannel_0_cave1_box3_material_string
#define priority mccchannel_0_cave1_box3_priority
#define xwidth mccchannel_0_cave1_box3_xwidth
#define yheight mccchannel_0_cave1_box3_yheight
#define zdepth mccchannel_0_cave1_box3_zdepth
#define xwidth2 mccchannel_0_cave1_box3_xwidth2
#define yheight2 mccchannel_0_cave1_box3_yheight2
#define visualize mccchannel_0_cave1_box3_visualize
#define target_index mccchannel_0_cave1_box3_target_index
#define target_x mccchannel_0_cave1_box3_target_x
#define target_y mccchannel_0_cave1_box3_target_y
#define target_z mccchannel_0_cave1_box3_target_z
#define focus_aw mccchannel_0_cave1_box3_focus_aw
#define focus_ah mccchannel_0_cave1_box3_focus_ah
#define focus_xw mccchannel_0_cave1_box3_focus_xw
#define focus_xh mccchannel_0_cave1_box3_focus_xh
#define focus_r mccchannel_0_cave1_box3_focus_r
#define p_interact mccchannel_0_cave1_box3_p_interact
#define mask_string mccchannel_0_cave1_box3_mask_string
#define mask_setting mccchannel_0_cave1_box3_mask_setting
#define number_of_activations mccchannel_0_cave1_box3_number_of_activations
#line 224 "Union_box.comp"
{
// Initializes the focusing system for this volume including input sanitation.
focus_initialize(&this_box_volume.geometry, POS_A_COMP_INDEX(INDEX_CURRENT_COMP+target_index), POS_A_CURRENT_COMP, ROT_A_CURRENT_COMP, target_index, target_x, target_y, target_z, focus_aw, focus_ah, focus_xw, focus_xh, focus_r, NAME_CURRENT_COMP);

// Input sanitation for this geometry
if (xwidth <= 0) {
  printf("\nERROR in Union_box named %s, the xwidth is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (yheight <= 0) {
  printf("\nERROR in Union_box named %s, yheight is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (zdepth <= 0) {
  printf("\nERROR in Union_box named %s, zdepth is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (xwidth2 <= 0 && xwidth2 != -1) {
  printf("\nERROR in Union_box named %s, the xwidth2 is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (yheight2 <= 0 && yheight2 != -1) {
  printf("\nERROR in Union_box named %s, yheight2 is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}

// Use sanitation
if (global_material_list.num_elements == 0) {
  printf("\nERROR: Need to define a material using Union_make_material before using a Union geometry component. \n");
  printf("       %s was defined before first use of Union_make_material.\n",NAME_CURRENT_COMP);
  exit(1);
}

this_box_volume.geometry.is_masked_volume = 0;
this_box_volume.geometry.is_exit_volume = 0;
this_box_volume.geometry.is_mask_volume = 0;
// check if the volume is a mask, if it is the material string is irelevant.
if (mask_string && strlen(mask_string) && strcmp(mask_string, "NULL") && strcmp(mask_string, "0")) {
    // A mask volume is used to limit the extend of other volumes, called the masked volumes. These are specified in the mask_string.
    // In order for a ray to enter a masked volume, it needs to be both in the region covered by that volume AND the mask volume.
    // When more than
    this_box_volume.geometry.mask_mode = 1; // Default is mask mode is ALL
    if (mask_setting && strlen(mask_setting) && strcmp(mask_setting, "NULL") && strcmp(mask_setting, "0")) {
        if (strcmp(mask_setting,"ALL") == 0 || strcmp(mask_setting,"All") == 0) this_box_volume.geometry.mask_mode = 1;
        else if (strcmp(mask_setting,"ANY") == 0 || strcmp(mask_setting,"Any") == 0) this_box_volume.geometry.mask_mode = 2;
        else {
            printf("The mask_mode of component %s is set to %s, but must be either ALL or ANY.\n",NAME_CURRENT_COMP,mask_setting);
            exit(1);
        }
    }
    
    for (loop_index=0;loop_index<global_geometry_list.num_elements;loop_index++) {
        // Add mask list
        if (1 == manual_linking_function(global_geometry_list.elements[loop_index].name,mask_string)) {
            add_element_to_int_list(&this_box_volume.geometry.mask_list,global_geometry_list.elements[loop_index].component_index);
            add_element_to_int_list(&global_geometry_list.elements[loop_index].Volume->geometry.masked_by_list,INDEX_CURRENT_COMP);
            global_geometry_list.elements[loop_index].Volume->geometry.is_masked_volume = 1;
            if (this_box_volume.geometry.mask_mode == 2)
                global_geometry_list.elements[loop_index].Volume->geometry.mask_mode = 2;
            if (this_box_volume.geometry.mask_mode == 1) {
                if (global_geometry_list.elements[loop_index].Volume->geometry.is_masked_volume == 1 && global_geometry_list.elements[loop_index].Volume->geometry.mask_mode != 2)
                    // If more than one mask is added to one volume, the ANY mode overwrites the (default) ALL mode.
                    global_geometry_list.elements[loop_index].Volume->geometry.mask_mode = 1;
            }
            
            found_geometries = 1;
        }
    }
    if (found_geometries == 0) {
        printf("The mask_string in geometry: %s did not find any of the specified volumes in the mask_string %s \n",NAME_CURRENT_COMP,mask_string);
        exit(1);
    }
    this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
    this_box_volume.p_physics->is_vacuum = 0; // Makes this volume a vacuum
    this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
    this_box_volume.p_physics->my_a = 0; // Should not be used.
    sprintf(this_box_volume.p_physics->name,"Mask");
    this_box_volume.geometry.is_mask_volume = 1;
    
    
// Read the material input, or if it lacks, use automatic linking.
} else if (material_string && strlen(material_string) && strcmp(material_string, "NULL") && strcmp(material_string, "0")) {
    // A geometry string was given, use it to determine which material
    if (0 == strcmp(material_string,"vacuum") || 0 == strcmp(material_string,"Vacuum")) {
        // One could have a global physics struct for vacuum instead of creating one for each
        this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
        this_box_volume.p_physics->is_vacuum = 1; // Makes this volume a vacuum
        this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
        this_box_volume.p_physics->my_a = 0; // Should not be used.
        sprintf(this_box_volume.p_physics->name,"Vacuum");
    } else if (0 == strcmp(material_string,"exit") || 0 == strcmp(material_string,"Exit")) {
        // One could have a global physics struct for vacuum instead of creating one for each
        this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
        this_box_volume.p_physics->is_vacuum = 1; // Makes this volume a vacuum
        this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
        this_box_volume.p_physics->my_a = 0; // Should not be used.
        this_box_volume.geometry.is_exit_volume = 1;
        sprintf(this_box_volume.p_physics->name,"Exit");
    } else {
        #ifndef MATERIAL_DETECTOR
            printf("Need to define a material before refering to it in a geometry %s.\n",NAME_CURRENT_COMP);
            exit(1);
        #endif
        for (loop_index=0;loop_index<global_material_list.num_elements;loop_index++) {
            if (0 == strcmp(material_string,global_material_list.elements[loop_index].name)) {
                this_box_volume.p_physics = global_material_list.elements[loop_index].physics;
                break;
            }
            if (loop_index == global_material_list.num_elements-1) {
            printf("\n");
            printf("ERROR: The material string \"%s\" in Union geometry \"%s\" did not match a specified material. \n",material_string,NAME_CURRENT_COMP);
            printf("       The materials available at this point (need to be defined before the geometry): \n");
            for (loop_index=0;loop_index<global_material_list.num_elements;loop_index++)
              printf("         %s\n",global_material_list.elements[loop_index].name);
            printf("\n");
            printf("       It is also possible to use one of the defualt materials avaiable: \n");
            printf("           Vacuum (for a Volume without scattering or absorption)\n");
            printf("           Exit (for a Volume where the ray exits the component if it enters)\n");
            printf("           Mask (for a Volume that masks existing volumes specified in the mask_string\n");
            exit(1);
          }
        }
    }
} else {
    // Automatic linking, simply using the last defined material.
    #ifndef MATERIAL_DETECTOR
        printf("Need to define a material before the geometry to use automatic linking %s.\n",NAME_CURRENT_COMP);
        exit(1);
    #endif
    this_box_volume.p_physics = global_material_list.elements[global_material_list.num_elements-1].physics;
}

sprintf(this_box_volume.name,NAME_CURRENT_COMP);
sprintf(this_box_volume.geometry.shape,"box");
this_box_volume.geometry.priority_value = priority;
this_box_volume.geometry.geometry_p_interact = p_interact;
// Currently the coordinates will be in absolute space.
this_box_volume.geometry.center = POS_A_CURRENT_COMP;

this_box_storage.z_depth = zdepth;
this_box_storage.x_width1 = xwidth;
this_box_storage.y_height1 = yheight;

this_box_storage.is_rectangle = 0;
if (xwidth2 < 0 && yheight2 < 0) this_box_storage.is_rectangle = 1;
if (xwidth == xwidth2 && yheight == yheight2) this_box_storage.is_rectangle = 1;

if (xwidth2 < 0) {
    this_box_storage.x_width2 = xwidth;
    xwidth2 = xwidth;
} else this_box_storage.x_width2 = xwidth2;

if (yheight2 < 0) {
    this_box_storage.y_height2 = yheight;
    yheight2 = yheight;
} else this_box_storage.y_height2 = yheight2;


this_box_storage.normal_vectors[0] = coords_set(0,0,1);
this_box_storage.normal_vectors[1] = coords_set(0,0,1);

// for sides with y component = 0
x_component = 2*zdepth/sqrt((xwidth-xwidth2)*(xwidth-xwidth2)+4*zdepth*zdepth);
z_component = (xwidth-xwidth2)/sqrt(4*zdepth*zdepth+(xwidth-xwidth2)*(xwidth-xwidth2));

this_box_storage.normal_vectors[2] = coords_set(x_component,0,z_component);
this_box_storage.normal_vectors[3] = coords_set(-x_component,0,z_component);

// for sides with x component = 0
y_component = 2*zdepth/sqrt((yheight-yheight2)*(yheight-yheight2)+4*zdepth*zdepth);
z_component = (yheight-yheight2)/sqrt(4*zdepth*zdepth+(yheight-yheight2)*(yheight-yheight2));

this_box_storage.normal_vectors[4] = coords_set(0,y_component,z_component);
this_box_storage.normal_vectors[5] = coords_set(0,-y_component,z_component);

this_box_volume.geometry.visualization_on = visualize;

this_box_volume.geometry.geometry_parameters.p_box_storage = &this_box_storage;

// Assign pointers to functions for intersection with the shape, checking if a point is inside the shape
if (this_box_storage.is_rectangle == 1) {
this_box_volume.geometry.intersect_function = &sample_box_intersect_simple;
this_box_volume.geometry.within_function = &r_within_box_simple;
}
else {
this_box_volume.geometry.intersect_function = &sample_box_intersect_advanced;
this_box_volume.geometry.within_function = &r_within_box_advanced;
}

this_box_volume.geometry.shell_points = &box_shell_points;
this_box_volume.geometry.mcdisplay_function = &mcdisplay_box_function;
this_box_volume.geometry.initialize_from_main_function = &initialize_box_geometry_from_main_component;
this_box_volume.geometry.process_rot_allocated = 0;

this_box_volume.geometry.copy_geometry_parameters = &allocate_box_storage_copy;

rot_copy(this_box_volume.geometry.rotation_matrix,ROT_A_CURRENT_COMP); //check how ROT_R_CURRENT_COMP would work
rot_transpose(ROT_A_CURRENT_COMP,this_box_volume.geometry.transpose_rotation_matrix);

// Initialize loggers
this_box_volume.loggers.num_elements = 0;

// packing the information into the global_geometry_element, which is then included in the global_geometry_list.
sprintf(global_geometry_element.name,NAME_CURRENT_COMP);
global_geometry_element.activation_counter = number_of_activations;
global_geometry_element.component_index = INDEX_CURRENT_COMP;
global_geometry_element.Volume = &this_box_volume; // Would be nicer if this m was a pointer, now we have the (small) data two places
add_element_to_geometry_list(&global_geometry_list,global_geometry_element);
}
#line 165284 "MACS_sample_kidney_box.c"
#undef number_of_activations
#undef mask_setting
#undef mask_string
#undef p_interact
#undef focus_r
#undef focus_xh
#undef focus_xw
#undef focus_ah
#undef focus_aw
#undef target_z
#undef target_y
#undef target_x
#undef target_index
#undef visualize
#undef yheight2
#undef xwidth2
#undef zdepth
#undef yheight
#undef xwidth
#undef priority
#undef material_string
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

  /* Initializations for component channel_0_cave1_cyl1. */
  SIG_MESSAGE("channel_0_cave1_cyl1 (Init)");
#define mccompcurname  channel_0_cave1_cyl1
#define mccompcurtype  Union_cylinder
#define mccompcurindex 127
#define loop_index mccchannel_0_cave1_cyl1_loop_index
#define this_cylinder_volume mccchannel_0_cave1_cyl1_this_cylinder_volume
#define global_geometry_element mccchannel_0_cave1_cyl1_global_geometry_element
#define this_cylinder_storage mccchannel_0_cave1_cyl1_this_cylinder_storage
#define material_string mccchannel_0_cave1_cyl1_material_string
#define priority mccchannel_0_cave1_cyl1_priority
#define radius mccchannel_0_cave1_cyl1_radius
#define yheight mccchannel_0_cave1_cyl1_yheight
#define visualize mccchannel_0_cave1_cyl1_visualize
#define target_index mccchannel_0_cave1_cyl1_target_index
#define target_x mccchannel_0_cave1_cyl1_target_x
#define target_y mccchannel_0_cave1_cyl1_target_y
#define target_z mccchannel_0_cave1_cyl1_target_z
#define focus_aw mccchannel_0_cave1_cyl1_focus_aw
#define focus_ah mccchannel_0_cave1_cyl1_focus_ah
#define focus_xw mccchannel_0_cave1_cyl1_focus_xw
#define focus_xh mccchannel_0_cave1_cyl1_focus_xh
#define focus_r mccchannel_0_cave1_cyl1_focus_r
#define p_interact mccchannel_0_cave1_cyl1_p_interact
#define mask_string mccchannel_0_cave1_cyl1_mask_string
#define mask_setting mccchannel_0_cave1_cyl1_mask_setting
#define number_of_activations mccchannel_0_cave1_cyl1_number_of_activations
#line 185 "Union_cylinder.comp"
{
// Initializes the focusing system for this volume including input sanitation.
focus_initialize(&this_cylinder_volume.geometry, POS_A_COMP_INDEX(INDEX_CURRENT_COMP+target_index), POS_A_CURRENT_COMP, ROT_A_CURRENT_COMP, target_index, target_x, target_y, target_z, focus_aw, focus_ah, focus_xw, focus_xh, focus_r, NAME_CURRENT_COMP);

// Input sanitation for this geometry
if (radius <= 0) {
  printf("\nERROR in Union_cylinder named %s, the radius is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}

if (yheight <= 0) {
  printf("\nERROR in Union_cylinder named %s, yheight is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}

// Use sanitation
#ifdef MATERIAL_DETECTOR
if (global_material_list.num_elements == 0) {
  // Here if the user have defined a material, but only after this material
  printf("\nERROR: Need to define a material using Union_make_material before using a Union geometry component. \n");
  printf("       %s was defined before first use of Union_make_material.\n",NAME_CURRENT_COMP);
  exit(1);
}
#endif
#ifndef MATERIAL_DETECTOR
  printf("\nERROR: Need to define a material using Union_make_material before using a Union geometry component. \n");
  exit(1);
#endif


this_cylinder_volume.geometry.is_masked_volume = 0;
this_cylinder_volume.geometry.is_exit_volume = 0;
this_cylinder_volume.geometry.is_mask_volume = 0;

// Read the material input, or if it lacks, use automatic linking.
if (mask_string && strlen(mask_string) && strcmp(mask_string, "NULL") && strcmp(mask_string, "0")) {
    // A mask volume is used to limit the extend of other volumes, called the masked volumes. These are specified in the mask_string.
    // In order for a ray to enter a masked volume, it needs to be both in the region covered by that volume AND the mask volume.
    // When more than
    this_cylinder_volume.geometry.mask_mode = 1; // Default is mask mode is ALL
    if (mask_setting && strlen(mask_setting) && strcmp(mask_setting, "NULL") && strcmp(mask_setting, "0")) {
        if (strcmp(mask_setting,"ALL") == 0 || strcmp(mask_setting,"All") == 0) this_cylinder_volume.geometry.mask_mode = 1;
        else if (strcmp(mask_setting,"ANY") == 0 || strcmp(mask_setting,"Any") == 0) this_cylinder_volume.geometry.mask_mode = 2;
        else {
            printf("The mask_mode of component %s is set to %s, but must be either ALL or ANY.\n",NAME_CURRENT_COMP,mask_setting);
            exit(1);
        }
    }
    
    for (loop_index=0;loop_index<global_geometry_list.num_elements;loop_index++) {
        // Add mask list
        if (1 == manual_linking_function(global_geometry_list.elements[loop_index].name,mask_string)) {
            add_element_to_int_list(&this_cylinder_volume.geometry.mask_list,global_geometry_list.elements[loop_index].component_index);
            add_element_to_int_list(&global_geometry_list.elements[loop_index].Volume->geometry.masked_by_list,INDEX_CURRENT_COMP);
            global_geometry_list.elements[loop_index].Volume->geometry.is_masked_volume = 1;
            if (this_cylinder_volume.geometry.mask_mode == 2)
                global_geometry_list.elements[loop_index].Volume->geometry.mask_mode = 2;
            if (this_cylinder_volume.geometry.mask_mode == 1) {
                if (global_geometry_list.elements[loop_index].Volume->geometry.is_masked_volume == 1 && global_geometry_list.elements[loop_index].Volume->geometry.mask_mode != 2)
                    // If more than one mask is added to one volume, the ANY mode overwrites the (default) ALL mode.
                    global_geometry_list.elements[loop_index].Volume->geometry.mask_mode = 1;
            }
            
            found_geometries = 1;
        }
    }
    if (found_geometries == 0) {
        printf("The mask_string in geometry: %s did not find any of the specified volumes in the mask_string %s \n",NAME_CURRENT_COMP,mask_string);
        exit(1);
    }
    this_cylinder_volume.p_physics = malloc(sizeof(struct physics_struct));
    this_cylinder_volume.p_physics->is_vacuum = 0; // Makes this volume a vacuum
    this_cylinder_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
    this_cylinder_volume.p_physics->my_a = 0; // Should not be used.
    sprintf(this_cylinder_volume.p_physics->name,"Mask");
    this_cylinder_volume.geometry.is_mask_volume = 1;
    
    
// Read the material input, or if it lacks, use automatic linking.
} else if (material_string && strlen(material_string) && strcmp(material_string, "NULL") && strcmp(material_string, "0")) {
    // A geometry string was given, use it to determine which material
    if (0 == strcmp(material_string,"vacuum") || 0 == strcmp(material_string,"Vacuum")) {
        // One could have a global physics struct for vacuum instead of creating one for each
        this_cylinder_volume.p_physics = malloc(sizeof(struct physics_struct));
        this_cylinder_volume.p_physics->is_vacuum = 1; // Makes this volume a vacuum
        this_cylinder_volume.p_physics->number_of_processes = (int) 0;
        this_cylinder_volume.p_physics->my_a = 0; // Should not be used.
        sprintf(this_cylinder_volume.p_physics->name,"Vacuum");
    } else if (0 == strcmp(material_string,"exit") || 0 == strcmp(material_string,"Exit")) {
        // One could have a global physics struct for exit instead of creating one for each
        this_cylinder_volume.p_physics = malloc(sizeof(struct physics_struct));
        this_cylinder_volume.p_physics->is_vacuum = 1; // Makes this volume a vacuum
        this_cylinder_volume.p_physics->number_of_processes = (int) 0;
        this_cylinder_volume.p_physics->my_a = 0; // Should not be used.
        this_cylinder_volume.geometry.is_exit_volume = 1;
        sprintf(this_cylinder_volume.p_physics->name,"Exit");
    } else {
        for (loop_index=0;loop_index<global_material_list.num_elements;loop_index++) {
          if (0 == strcmp(material_string,global_material_list.elements[loop_index].name)) {
            this_cylinder_volume.p_physics = global_material_list.elements[loop_index].physics;
            break;
          }
          if (loop_index == global_material_list.num_elements-1) {
            printf("\n");
            printf("ERROR: The material string \"%s\" in Union geometry \"%s\" did not match a specified material. \n",material_string,NAME_CURRENT_COMP);
            printf("       The materials available at this point (need to be defined before the geometry): \n");
            for (loop_index=0;loop_index<global_material_list.num_elements;loop_index++)
              printf("         %s\n",global_material_list.elements[loop_index].name);
            printf("\n");
            printf("       It is also possible to use one of the defualt materials avaiable: \n");
            printf("           Vacuum (for a Volume without scattering or absorption)\n");
            printf("           Exit (for a Volume where the ray exits the component if it enters)\n");
            printf("           Mask (for a Volume that masks existing volumes specified in the mask_string\n");
            exit(1);
          }
        }
    }
} else {
    // Automatic linking, simply using the last defined material.
    #ifndef MATERIAL_DETECTOR
        printf("Need to define a material before the geometry to use automatic linking %s.\n",NAME_CURRENT_COMP);
        exit(1);
    #endif
    this_cylinder_volume.p_physics = global_material_list.elements[global_material_list.num_elements-1].physics;
}

sprintf(this_cylinder_volume.name,NAME_CURRENT_COMP);
sprintf(this_cylinder_volume.geometry.shape,"cylinder");
this_cylinder_volume.geometry.priority_value = priority;
// Currently the coordinates will be in absolute space.
this_cylinder_volume.geometry.center = POS_A_CURRENT_COMP;

this_cylinder_volume.geometry.geometry_p_interact = p_interact;
this_cylinder_storage.cyl_radius = radius;
this_cylinder_storage.height = yheight;
this_cylinder_volume.geometry.visualization_on = visualize;
this_cylinder_volume.geometry.geometry_parameters.p_cylinder_storage = &this_cylinder_storage;
this_cylinder_volume.geometry.within_function = &r_within_cylinder;
this_cylinder_volume.geometry.intersect_function = &sample_cylinder_intersect;
this_cylinder_volume.geometry.mcdisplay_function = &mcdisplay_cylinder_function;
this_cylinder_volume.geometry.shell_points = &cylinder_shell_points;
this_cylinder_volume.geometry.initialize_from_main_function = &initialize_cylinder_geometry_from_main_component;
this_cylinder_volume.geometry.process_rot_allocated = 0;
this_cylinder_volume.geometry.copy_geometry_parameters = &allocate_cylinder_storage_copy;

rot_copy(this_cylinder_volume.geometry.rotation_matrix,ROT_A_CURRENT_COMP);
rot_transpose(ROT_A_CURRENT_COMP,this_cylinder_volume.geometry.transpose_rotation_matrix);

// Initialize loggers
this_cylinder_volume.loggers.num_elements = 0;

// packing the information into the global_geometry_element, which is then included in the global_geometry_list.
sprintf(global_geometry_element.name,NAME_CURRENT_COMP);
global_geometry_element.activation_counter = number_of_activations;
global_geometry_element.component_index = INDEX_CURRENT_COMP;
global_geometry_element.Volume = &this_cylinder_volume; // Would be nicer if this m was a pointer, now we have the (small) data two places
add_element_to_geometry_list(&global_geometry_list,global_geometry_element);
}
#line 165500 "MACS_sample_kidney_box.c"
#undef number_of_activations
#undef mask_setting
#undef mask_string
#undef p_interact
#undef focus_r
#undef focus_xh
#undef focus_xw
#undef focus_ah
#undef focus_aw
#undef target_z
#undef target_y
#undef target_x
#undef target_index
#undef visualize
#undef yheight
#undef radius
#undef priority
#undef material_string
#undef this_cylinder_storage
#undef global_geometry_element
#undef this_cylinder_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

  /* Initializations for component channel_0_analyzer_1_center. */
  SIG_MESSAGE("channel_0_analyzer_1_center (Init)");

  /* Initializations for component channel_0_analyzer_1_rotated. */
  SIG_MESSAGE("channel_0_analyzer_1_rotated (Init)");

  /* Initializations for component channel_0_analyzer_1_array_crystal_array_0. */
  SIG_MESSAGE("channel_0_analyzer_1_array_crystal_array_0 (Init)");
#define mccompcurname  channel_0_analyzer_1_array_crystal_array_0
#define mccompcurtype  Union_box
#define mccompcurindex 130
#define loop_index mccchannel_0_analyzer_1_array_crystal_array_0_loop_index
#define this_box_volume mccchannel_0_analyzer_1_array_crystal_array_0_this_box_volume
#define global_geometry_element mccchannel_0_analyzer_1_array_crystal_array_0_global_geometry_element
#define this_box_storage mccchannel_0_analyzer_1_array_crystal_array_0_this_box_storage
#define material_string mccchannel_0_analyzer_1_array_crystal_array_0_material_string
#define priority mccchannel_0_analyzer_1_array_crystal_array_0_priority
#define xwidth mccchannel_0_analyzer_1_array_crystal_array_0_xwidth
#define yheight mccchannel_0_analyzer_1_array_crystal_array_0_yheight
#define zdepth mccchannel_0_analyzer_1_array_crystal_array_0_zdepth
#define xwidth2 mccchannel_0_analyzer_1_array_crystal_array_0_xwidth2
#define yheight2 mccchannel_0_analyzer_1_array_crystal_array_0_yheight2
#define visualize mccchannel_0_analyzer_1_array_crystal_array_0_visualize
#define target_index mccchannel_0_analyzer_1_array_crystal_array_0_target_index
#define target_x mccchannel_0_analyzer_1_array_crystal_array_0_target_x
#define target_y mccchannel_0_analyzer_1_array_crystal_array_0_target_y
#define target_z mccchannel_0_analyzer_1_array_crystal_array_0_target_z
#define focus_aw mccchannel_0_analyzer_1_array_crystal_array_0_focus_aw
#define focus_ah mccchannel_0_analyzer_1_array_crystal_array_0_focus_ah
#define focus_xw mccchannel_0_analyzer_1_array_crystal_array_0_focus_xw
#define focus_xh mccchannel_0_analyzer_1_array_crystal_array_0_focus_xh
#define focus_r mccchannel_0_analyzer_1_array_crystal_array_0_focus_r
#define p_interact mccchannel_0_analyzer_1_array_crystal_array_0_p_interact
#define mask_string mccchannel_0_analyzer_1_array_crystal_array_0_mask_string
#define mask_setting mccchannel_0_analyzer_1_array_crystal_array_0_mask_setting
#define number_of_activations mccchannel_0_analyzer_1_array_crystal_array_0_number_of_activations
#line 224 "Union_box.comp"
{
// Initializes the focusing system for this volume including input sanitation.
focus_initialize(&this_box_volume.geometry, POS_A_COMP_INDEX(INDEX_CURRENT_COMP+target_index), POS_A_CURRENT_COMP, ROT_A_CURRENT_COMP, target_index, target_x, target_y, target_z, focus_aw, focus_ah, focus_xw, focus_xh, focus_r, NAME_CURRENT_COMP);

// Input sanitation for this geometry
if (xwidth <= 0) {
  printf("\nERROR in Union_box named %s, the xwidth is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (yheight <= 0) {
  printf("\nERROR in Union_box named %s, yheight is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (zdepth <= 0) {
  printf("\nERROR in Union_box named %s, zdepth is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (xwidth2 <= 0 && xwidth2 != -1) {
  printf("\nERROR in Union_box named %s, the xwidth2 is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (yheight2 <= 0 && yheight2 != -1) {
  printf("\nERROR in Union_box named %s, yheight2 is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}

// Use sanitation
if (global_material_list.num_elements == 0) {
  printf("\nERROR: Need to define a material using Union_make_material before using a Union geometry component. \n");
  printf("       %s was defined before first use of Union_make_material.\n",NAME_CURRENT_COMP);
  exit(1);
}

this_box_volume.geometry.is_masked_volume = 0;
this_box_volume.geometry.is_exit_volume = 0;
this_box_volume.geometry.is_mask_volume = 0;
// check if the volume is a mask, if it is the material string is irelevant.
if (mask_string && strlen(mask_string) && strcmp(mask_string, "NULL") && strcmp(mask_string, "0")) {
    // A mask volume is used to limit the extend of other volumes, called the masked volumes. These are specified in the mask_string.
    // In order for a ray to enter a masked volume, it needs to be both in the region covered by that volume AND the mask volume.
    // When more than
    this_box_volume.geometry.mask_mode = 1; // Default is mask mode is ALL
    if (mask_setting && strlen(mask_setting) && strcmp(mask_setting, "NULL") && strcmp(mask_setting, "0")) {
        if (strcmp(mask_setting,"ALL") == 0 || strcmp(mask_setting,"All") == 0) this_box_volume.geometry.mask_mode = 1;
        else if (strcmp(mask_setting,"ANY") == 0 || strcmp(mask_setting,"Any") == 0) this_box_volume.geometry.mask_mode = 2;
        else {
            printf("The mask_mode of component %s is set to %s, but must be either ALL or ANY.\n",NAME_CURRENT_COMP,mask_setting);
            exit(1);
        }
    }
    
    for (loop_index=0;loop_index<global_geometry_list.num_elements;loop_index++) {
        // Add mask list
        if (1 == manual_linking_function(global_geometry_list.elements[loop_index].name,mask_string)) {
            add_element_to_int_list(&this_box_volume.geometry.mask_list,global_geometry_list.elements[loop_index].component_index);
            add_element_to_int_list(&global_geometry_list.elements[loop_index].Volume->geometry.masked_by_list,INDEX_CURRENT_COMP);
            global_geometry_list.elements[loop_index].Volume->geometry.is_masked_volume = 1;
            if (this_box_volume.geometry.mask_mode == 2)
                global_geometry_list.elements[loop_index].Volume->geometry.mask_mode = 2;
            if (this_box_volume.geometry.mask_mode == 1) {
                if (global_geometry_list.elements[loop_index].Volume->geometry.is_masked_volume == 1 && global_geometry_list.elements[loop_index].Volume->geometry.mask_mode != 2)
                    // If more than one mask is added to one volume, the ANY mode overwrites the (default) ALL mode.
                    global_geometry_list.elements[loop_index].Volume->geometry.mask_mode = 1;
            }
            
            found_geometries = 1;
        }
    }
    if (found_geometries == 0) {
        printf("The mask_string in geometry: %s did not find any of the specified volumes in the mask_string %s \n",NAME_CURRENT_COMP,mask_string);
        exit(1);
    }
    this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
    this_box_volume.p_physics->is_vacuum = 0; // Makes this volume a vacuum
    this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
    this_box_volume.p_physics->my_a = 0; // Should not be used.
    sprintf(this_box_volume.p_physics->name,"Mask");
    this_box_volume.geometry.is_mask_volume = 1;
    
    
// Read the material input, or if it lacks, use automatic linking.
} else if (material_string && strlen(material_string) && strcmp(material_string, "NULL") && strcmp(material_string, "0")) {
    // A geometry string was given, use it to determine which material
    if (0 == strcmp(material_string,"vacuum") || 0 == strcmp(material_string,"Vacuum")) {
        // One could have a global physics struct for vacuum instead of creating one for each
        this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
        this_box_volume.p_physics->is_vacuum = 1; // Makes this volume a vacuum
        this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
        this_box_volume.p_physics->my_a = 0; // Should not be used.
        sprintf(this_box_volume.p_physics->name,"Vacuum");
    } else if (0 == strcmp(material_string,"exit") || 0 == strcmp(material_string,"Exit")) {
        // One could have a global physics struct for vacuum instead of creating one for each
        this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
        this_box_volume.p_physics->is_vacuum = 1; // Makes this volume a vacuum
        this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
        this_box_volume.p_physics->my_a = 0; // Should not be used.
        this_box_volume.geometry.is_exit_volume = 1;
        sprintf(this_box_volume.p_physics->name,"Exit");
    } else {
        #ifndef MATERIAL_DETECTOR
            printf("Need to define a material before refering to it in a geometry %s.\n",NAME_CURRENT_COMP);
            exit(1);
        #endif
        for (loop_index=0;loop_index<global_material_list.num_elements;loop_index++) {
            if (0 == strcmp(material_string,global_material_list.elements[loop_index].name)) {
                this_box_volume.p_physics = global_material_list.elements[loop_index].physics;
                break;
            }
            if (loop_index == global_material_list.num_elements-1) {
            printf("\n");
            printf("ERROR: The material string \"%s\" in Union geometry \"%s\" did not match a specified material. \n",material_string,NAME_CURRENT_COMP);
            printf("       The materials available at this point (need to be defined before the geometry): \n");
            for (loop_index=0;loop_index<global_material_list.num_elements;loop_index++)
              printf("         %s\n",global_material_list.elements[loop_index].name);
            printf("\n");
            printf("       It is also possible to use one of the defualt materials avaiable: \n");
            printf("           Vacuum (for a Volume without scattering or absorption)\n");
            printf("           Exit (for a Volume where the ray exits the component if it enters)\n");
            printf("           Mask (for a Volume that masks existing volumes specified in the mask_string\n");
            exit(1);
          }
        }
    }
} else {
    // Automatic linking, simply using the last defined material.
    #ifndef MATERIAL_DETECTOR
        printf("Need to define a material before the geometry to use automatic linking %s.\n",NAME_CURRENT_COMP);
        exit(1);
    #endif
    this_box_volume.p_physics = global_material_list.elements[global_material_list.num_elements-1].physics;
}

sprintf(this_box_volume.name,NAME_CURRENT_COMP);
sprintf(this_box_volume.geometry.shape,"box");
this_box_volume.geometry.priority_value = priority;
this_box_volume.geometry.geometry_p_interact = p_interact;
// Currently the coordinates will be in absolute space.
this_box_volume.geometry.center = POS_A_CURRENT_COMP;

this_box_storage.z_depth = zdepth;
this_box_storage.x_width1 = xwidth;
this_box_storage.y_height1 = yheight;

this_box_storage.is_rectangle = 0;
if (xwidth2 < 0 && yheight2 < 0) this_box_storage.is_rectangle = 1;
if (xwidth == xwidth2 && yheight == yheight2) this_box_storage.is_rectangle = 1;

if (xwidth2 < 0) {
    this_box_storage.x_width2 = xwidth;
    xwidth2 = xwidth;
} else this_box_storage.x_width2 = xwidth2;

if (yheight2 < 0) {
    this_box_storage.y_height2 = yheight;
    yheight2 = yheight;
} else this_box_storage.y_height2 = yheight2;


this_box_storage.normal_vectors[0] = coords_set(0,0,1);
this_box_storage.normal_vectors[1] = coords_set(0,0,1);

// for sides with y component = 0
x_component = 2*zdepth/sqrt((xwidth-xwidth2)*(xwidth-xwidth2)+4*zdepth*zdepth);
z_component = (xwidth-xwidth2)/sqrt(4*zdepth*zdepth+(xwidth-xwidth2)*(xwidth-xwidth2));

this_box_storage.normal_vectors[2] = coords_set(x_component,0,z_component);
this_box_storage.normal_vectors[3] = coords_set(-x_component,0,z_component);

// for sides with x component = 0
y_component = 2*zdepth/sqrt((yheight-yheight2)*(yheight-yheight2)+4*zdepth*zdepth);
z_component = (yheight-yheight2)/sqrt(4*zdepth*zdepth+(yheight-yheight2)*(yheight-yheight2));

this_box_storage.normal_vectors[4] = coords_set(0,y_component,z_component);
this_box_storage.normal_vectors[5] = coords_set(0,-y_component,z_component);

this_box_volume.geometry.visualization_on = visualize;

this_box_volume.geometry.geometry_parameters.p_box_storage = &this_box_storage;

// Assign pointers to functions for intersection with the shape, checking if a point is inside the shape
if (this_box_storage.is_rectangle == 1) {
this_box_volume.geometry.intersect_function = &sample_box_intersect_simple;
this_box_volume.geometry.within_function = &r_within_box_simple;
}
else {
this_box_volume.geometry.intersect_function = &sample_box_intersect_advanced;
this_box_volume.geometry.within_function = &r_within_box_advanced;
}

this_box_volume.geometry.shell_points = &box_shell_points;
this_box_volume.geometry.mcdisplay_function = &mcdisplay_box_function;
this_box_volume.geometry.initialize_from_main_function = &initialize_box_geometry_from_main_component;
this_box_volume.geometry.process_rot_allocated = 0;

this_box_volume.geometry.copy_geometry_parameters = &allocate_box_storage_copy;

rot_copy(this_box_volume.geometry.rotation_matrix,ROT_A_CURRENT_COMP); //check how ROT_R_CURRENT_COMP would work
rot_transpose(ROT_A_CURRENT_COMP,this_box_volume.geometry.transpose_rotation_matrix);

// Initialize loggers
this_box_volume.loggers.num_elements = 0;

// packing the information into the global_geometry_element, which is then included in the global_geometry_list.
sprintf(global_geometry_element.name,NAME_CURRENT_COMP);
global_geometry_element.activation_counter = number_of_activations;
global_geometry_element.component_index = INDEX_CURRENT_COMP;
global_geometry_element.Volume = &this_box_volume; // Would be nicer if this m was a pointer, now we have the (small) data two places
add_element_to_geometry_list(&global_geometry_list,global_geometry_element);
}
#line 165773 "MACS_sample_kidney_box.c"
#undef number_of_activations
#undef mask_setting
#undef mask_string
#undef p_interact
#undef focus_r
#undef focus_xh
#undef focus_xw
#undef focus_ah
#undef focus_aw
#undef target_z
#undef target_y
#undef target_x
#undef target_index
#undef visualize
#undef yheight2
#undef xwidth2
#undef zdepth
#undef yheight
#undef xwidth
#undef priority
#undef material_string
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

  /* Initializations for component channel_0_analyzer_1_array_crystal_array_1. */
  SIG_MESSAGE("channel_0_analyzer_1_array_crystal_array_1 (Init)");
#define mccompcurname  channel_0_analyzer_1_array_crystal_array_1
#define mccompcurtype  Union_box
#define mccompcurindex 131
#define loop_index mccchannel_0_analyzer_1_array_crystal_array_1_loop_index
#define this_box_volume mccchannel_0_analyzer_1_array_crystal_array_1_this_box_volume
#define global_geometry_element mccchannel_0_analyzer_1_array_crystal_array_1_global_geometry_element
#define this_box_storage mccchannel_0_analyzer_1_array_crystal_array_1_this_box_storage
#define material_string mccchannel_0_analyzer_1_array_crystal_array_1_material_string
#define priority mccchannel_0_analyzer_1_array_crystal_array_1_priority
#define xwidth mccchannel_0_analyzer_1_array_crystal_array_1_xwidth
#define yheight mccchannel_0_analyzer_1_array_crystal_array_1_yheight
#define zdepth mccchannel_0_analyzer_1_array_crystal_array_1_zdepth
#define xwidth2 mccchannel_0_analyzer_1_array_crystal_array_1_xwidth2
#define yheight2 mccchannel_0_analyzer_1_array_crystal_array_1_yheight2
#define visualize mccchannel_0_analyzer_1_array_crystal_array_1_visualize
#define target_index mccchannel_0_analyzer_1_array_crystal_array_1_target_index
#define target_x mccchannel_0_analyzer_1_array_crystal_array_1_target_x
#define target_y mccchannel_0_analyzer_1_array_crystal_array_1_target_y
#define target_z mccchannel_0_analyzer_1_array_crystal_array_1_target_z
#define focus_aw mccchannel_0_analyzer_1_array_crystal_array_1_focus_aw
#define focus_ah mccchannel_0_analyzer_1_array_crystal_array_1_focus_ah
#define focus_xw mccchannel_0_analyzer_1_array_crystal_array_1_focus_xw
#define focus_xh mccchannel_0_analyzer_1_array_crystal_array_1_focus_xh
#define focus_r mccchannel_0_analyzer_1_array_crystal_array_1_focus_r
#define p_interact mccchannel_0_analyzer_1_array_crystal_array_1_p_interact
#define mask_string mccchannel_0_analyzer_1_array_crystal_array_1_mask_string
#define mask_setting mccchannel_0_analyzer_1_array_crystal_array_1_mask_setting
#define number_of_activations mccchannel_0_analyzer_1_array_crystal_array_1_number_of_activations
#line 224 "Union_box.comp"
{
// Initializes the focusing system for this volume including input sanitation.
focus_initialize(&this_box_volume.geometry, POS_A_COMP_INDEX(INDEX_CURRENT_COMP+target_index), POS_A_CURRENT_COMP, ROT_A_CURRENT_COMP, target_index, target_x, target_y, target_z, focus_aw, focus_ah, focus_xw, focus_xh, focus_r, NAME_CURRENT_COMP);

// Input sanitation for this geometry
if (xwidth <= 0) {
  printf("\nERROR in Union_box named %s, the xwidth is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (yheight <= 0) {
  printf("\nERROR in Union_box named %s, yheight is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (zdepth <= 0) {
  printf("\nERROR in Union_box named %s, zdepth is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (xwidth2 <= 0 && xwidth2 != -1) {
  printf("\nERROR in Union_box named %s, the xwidth2 is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (yheight2 <= 0 && yheight2 != -1) {
  printf("\nERROR in Union_box named %s, yheight2 is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}

// Use sanitation
if (global_material_list.num_elements == 0) {
  printf("\nERROR: Need to define a material using Union_make_material before using a Union geometry component. \n");
  printf("       %s was defined before first use of Union_make_material.\n",NAME_CURRENT_COMP);
  exit(1);
}

this_box_volume.geometry.is_masked_volume = 0;
this_box_volume.geometry.is_exit_volume = 0;
this_box_volume.geometry.is_mask_volume = 0;
// check if the volume is a mask, if it is the material string is irelevant.
if (mask_string && strlen(mask_string) && strcmp(mask_string, "NULL") && strcmp(mask_string, "0")) {
    // A mask volume is used to limit the extend of other volumes, called the masked volumes. These are specified in the mask_string.
    // In order for a ray to enter a masked volume, it needs to be both in the region covered by that volume AND the mask volume.
    // When more than
    this_box_volume.geometry.mask_mode = 1; // Default is mask mode is ALL
    if (mask_setting && strlen(mask_setting) && strcmp(mask_setting, "NULL") && strcmp(mask_setting, "0")) {
        if (strcmp(mask_setting,"ALL") == 0 || strcmp(mask_setting,"All") == 0) this_box_volume.geometry.mask_mode = 1;
        else if (strcmp(mask_setting,"ANY") == 0 || strcmp(mask_setting,"Any") == 0) this_box_volume.geometry.mask_mode = 2;
        else {
            printf("The mask_mode of component %s is set to %s, but must be either ALL or ANY.\n",NAME_CURRENT_COMP,mask_setting);
            exit(1);
        }
    }
    
    for (loop_index=0;loop_index<global_geometry_list.num_elements;loop_index++) {
        // Add mask list
        if (1 == manual_linking_function(global_geometry_list.elements[loop_index].name,mask_string)) {
            add_element_to_int_list(&this_box_volume.geometry.mask_list,global_geometry_list.elements[loop_index].component_index);
            add_element_to_int_list(&global_geometry_list.elements[loop_index].Volume->geometry.masked_by_list,INDEX_CURRENT_COMP);
            global_geometry_list.elements[loop_index].Volume->geometry.is_masked_volume = 1;
            if (this_box_volume.geometry.mask_mode == 2)
                global_geometry_list.elements[loop_index].Volume->geometry.mask_mode = 2;
            if (this_box_volume.geometry.mask_mode == 1) {
                if (global_geometry_list.elements[loop_index].Volume->geometry.is_masked_volume == 1 && global_geometry_list.elements[loop_index].Volume->geometry.mask_mode != 2)
                    // If more than one mask is added to one volume, the ANY mode overwrites the (default) ALL mode.
                    global_geometry_list.elements[loop_index].Volume->geometry.mask_mode = 1;
            }
            
            found_geometries = 1;
        }
    }
    if (found_geometries == 0) {
        printf("The mask_string in geometry: %s did not find any of the specified volumes in the mask_string %s \n",NAME_CURRENT_COMP,mask_string);
        exit(1);
    }
    this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
    this_box_volume.p_physics->is_vacuum = 0; // Makes this volume a vacuum
    this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
    this_box_volume.p_physics->my_a = 0; // Should not be used.
    sprintf(this_box_volume.p_physics->name,"Mask");
    this_box_volume.geometry.is_mask_volume = 1;
    
    
// Read the material input, or if it lacks, use automatic linking.
} else if (material_string && strlen(material_string) && strcmp(material_string, "NULL") && strcmp(material_string, "0")) {
    // A geometry string was given, use it to determine which material
    if (0 == strcmp(material_string,"vacuum") || 0 == strcmp(material_string,"Vacuum")) {
        // One could have a global physics struct for vacuum instead of creating one for each
        this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
        this_box_volume.p_physics->is_vacuum = 1; // Makes this volume a vacuum
        this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
        this_box_volume.p_physics->my_a = 0; // Should not be used.
        sprintf(this_box_volume.p_physics->name,"Vacuum");
    } else if (0 == strcmp(material_string,"exit") || 0 == strcmp(material_string,"Exit")) {
        // One could have a global physics struct for vacuum instead of creating one for each
        this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
        this_box_volume.p_physics->is_vacuum = 1; // Makes this volume a vacuum
        this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
        this_box_volume.p_physics->my_a = 0; // Should not be used.
        this_box_volume.geometry.is_exit_volume = 1;
        sprintf(this_box_volume.p_physics->name,"Exit");
    } else {
        #ifndef MATERIAL_DETECTOR
            printf("Need to define a material before refering to it in a geometry %s.\n",NAME_CURRENT_COMP);
            exit(1);
        #endif
        for (loop_index=0;loop_index<global_material_list.num_elements;loop_index++) {
            if (0 == strcmp(material_string,global_material_list.elements[loop_index].name)) {
                this_box_volume.p_physics = global_material_list.elements[loop_index].physics;
                break;
            }
            if (loop_index == global_material_list.num_elements-1) {
            printf("\n");
            printf("ERROR: The material string \"%s\" in Union geometry \"%s\" did not match a specified material. \n",material_string,NAME_CURRENT_COMP);
            printf("       The materials available at this point (need to be defined before the geometry): \n");
            for (loop_index=0;loop_index<global_material_list.num_elements;loop_index++)
              printf("         %s\n",global_material_list.elements[loop_index].name);
            printf("\n");
            printf("       It is also possible to use one of the defualt materials avaiable: \n");
            printf("           Vacuum (for a Volume without scattering or absorption)\n");
            printf("           Exit (for a Volume where the ray exits the component if it enters)\n");
            printf("           Mask (for a Volume that masks existing volumes specified in the mask_string\n");
            exit(1);
          }
        }
    }
} else {
    // Automatic linking, simply using the last defined material.
    #ifndef MATERIAL_DETECTOR
        printf("Need to define a material before the geometry to use automatic linking %s.\n",NAME_CURRENT_COMP);
        exit(1);
    #endif
    this_box_volume.p_physics = global_material_list.elements[global_material_list.num_elements-1].physics;
}

sprintf(this_box_volume.name,NAME_CURRENT_COMP);
sprintf(this_box_volume.geometry.shape,"box");
this_box_volume.geometry.priority_value = priority;
this_box_volume.geometry.geometry_p_interact = p_interact;
// Currently the coordinates will be in absolute space.
this_box_volume.geometry.center = POS_A_CURRENT_COMP;

this_box_storage.z_depth = zdepth;
this_box_storage.x_width1 = xwidth;
this_box_storage.y_height1 = yheight;

this_box_storage.is_rectangle = 0;
if (xwidth2 < 0 && yheight2 < 0) this_box_storage.is_rectangle = 1;
if (xwidth == xwidth2 && yheight == yheight2) this_box_storage.is_rectangle = 1;

if (xwidth2 < 0) {
    this_box_storage.x_width2 = xwidth;
    xwidth2 = xwidth;
} else this_box_storage.x_width2 = xwidth2;

if (yheight2 < 0) {
    this_box_storage.y_height2 = yheight;
    yheight2 = yheight;
} else this_box_storage.y_height2 = yheight2;


this_box_storage.normal_vectors[0] = coords_set(0,0,1);
this_box_storage.normal_vectors[1] = coords_set(0,0,1);

// for sides with y component = 0
x_component = 2*zdepth/sqrt((xwidth-xwidth2)*(xwidth-xwidth2)+4*zdepth*zdepth);
z_component = (xwidth-xwidth2)/sqrt(4*zdepth*zdepth+(xwidth-xwidth2)*(xwidth-xwidth2));

this_box_storage.normal_vectors[2] = coords_set(x_component,0,z_component);
this_box_storage.normal_vectors[3] = coords_set(-x_component,0,z_component);

// for sides with x component = 0
y_component = 2*zdepth/sqrt((yheight-yheight2)*(yheight-yheight2)+4*zdepth*zdepth);
z_component = (yheight-yheight2)/sqrt(4*zdepth*zdepth+(yheight-yheight2)*(yheight-yheight2));

this_box_storage.normal_vectors[4] = coords_set(0,y_component,z_component);
this_box_storage.normal_vectors[5] = coords_set(0,-y_component,z_component);

this_box_volume.geometry.visualization_on = visualize;

this_box_volume.geometry.geometry_parameters.p_box_storage = &this_box_storage;

// Assign pointers to functions for intersection with the shape, checking if a point is inside the shape
if (this_box_storage.is_rectangle == 1) {
this_box_volume.geometry.intersect_function = &sample_box_intersect_simple;
this_box_volume.geometry.within_function = &r_within_box_simple;
}
else {
this_box_volume.geometry.intersect_function = &sample_box_intersect_advanced;
this_box_volume.geometry.within_function = &r_within_box_advanced;
}

this_box_volume.geometry.shell_points = &box_shell_points;
this_box_volume.geometry.mcdisplay_function = &mcdisplay_box_function;
this_box_volume.geometry.initialize_from_main_function = &initialize_box_geometry_from_main_component;
this_box_volume.geometry.process_rot_allocated = 0;

this_box_volume.geometry.copy_geometry_parameters = &allocate_box_storage_copy;

rot_copy(this_box_volume.geometry.rotation_matrix,ROT_A_CURRENT_COMP); //check how ROT_R_CURRENT_COMP would work
rot_transpose(ROT_A_CURRENT_COMP,this_box_volume.geometry.transpose_rotation_matrix);

// Initialize loggers
this_box_volume.loggers.num_elements = 0;

// packing the information into the global_geometry_element, which is then included in the global_geometry_list.
sprintf(global_geometry_element.name,NAME_CURRENT_COMP);
global_geometry_element.activation_counter = number_of_activations;
global_geometry_element.component_index = INDEX_CURRENT_COMP;
global_geometry_element.Volume = &this_box_volume; // Would be nicer if this m was a pointer, now we have the (small) data two places
add_element_to_geometry_list(&global_geometry_list,global_geometry_element);
}
#line 166043 "MACS_sample_kidney_box.c"
#undef number_of_activations
#undef mask_setting
#undef mask_string
#undef p_interact
#undef focus_r
#undef focus_xh
#undef focus_xw
#undef focus_ah
#undef focus_aw
#undef target_z
#undef target_y
#undef target_x
#undef target_index
#undef visualize
#undef yheight2
#undef xwidth2
#undef zdepth
#undef yheight
#undef xwidth
#undef priority
#undef material_string
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

  /* Initializations for component channel_0_analyzer_1_array_crystal_array_2. */
  SIG_MESSAGE("channel_0_analyzer_1_array_crystal_array_2 (Init)");
#define mccompcurname  channel_0_analyzer_1_array_crystal_array_2
#define mccompcurtype  Union_box
#define mccompcurindex 132
#define loop_index mccchannel_0_analyzer_1_array_crystal_array_2_loop_index
#define this_box_volume mccchannel_0_analyzer_1_array_crystal_array_2_this_box_volume
#define global_geometry_element mccchannel_0_analyzer_1_array_crystal_array_2_global_geometry_element
#define this_box_storage mccchannel_0_analyzer_1_array_crystal_array_2_this_box_storage
#define material_string mccchannel_0_analyzer_1_array_crystal_array_2_material_string
#define priority mccchannel_0_analyzer_1_array_crystal_array_2_priority
#define xwidth mccchannel_0_analyzer_1_array_crystal_array_2_xwidth
#define yheight mccchannel_0_analyzer_1_array_crystal_array_2_yheight
#define zdepth mccchannel_0_analyzer_1_array_crystal_array_2_zdepth
#define xwidth2 mccchannel_0_analyzer_1_array_crystal_array_2_xwidth2
#define yheight2 mccchannel_0_analyzer_1_array_crystal_array_2_yheight2
#define visualize mccchannel_0_analyzer_1_array_crystal_array_2_visualize
#define target_index mccchannel_0_analyzer_1_array_crystal_array_2_target_index
#define target_x mccchannel_0_analyzer_1_array_crystal_array_2_target_x
#define target_y mccchannel_0_analyzer_1_array_crystal_array_2_target_y
#define target_z mccchannel_0_analyzer_1_array_crystal_array_2_target_z
#define focus_aw mccchannel_0_analyzer_1_array_crystal_array_2_focus_aw
#define focus_ah mccchannel_0_analyzer_1_array_crystal_array_2_focus_ah
#define focus_xw mccchannel_0_analyzer_1_array_crystal_array_2_focus_xw
#define focus_xh mccchannel_0_analyzer_1_array_crystal_array_2_focus_xh
#define focus_r mccchannel_0_analyzer_1_array_crystal_array_2_focus_r
#define p_interact mccchannel_0_analyzer_1_array_crystal_array_2_p_interact
#define mask_string mccchannel_0_analyzer_1_array_crystal_array_2_mask_string
#define mask_setting mccchannel_0_analyzer_1_array_crystal_array_2_mask_setting
#define number_of_activations mccchannel_0_analyzer_1_array_crystal_array_2_number_of_activations
#line 224 "Union_box.comp"
{
// Initializes the focusing system for this volume including input sanitation.
focus_initialize(&this_box_volume.geometry, POS_A_COMP_INDEX(INDEX_CURRENT_COMP+target_index), POS_A_CURRENT_COMP, ROT_A_CURRENT_COMP, target_index, target_x, target_y, target_z, focus_aw, focus_ah, focus_xw, focus_xh, focus_r, NAME_CURRENT_COMP);

// Input sanitation for this geometry
if (xwidth <= 0) {
  printf("\nERROR in Union_box named %s, the xwidth is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (yheight <= 0) {
  printf("\nERROR in Union_box named %s, yheight is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (zdepth <= 0) {
  printf("\nERROR in Union_box named %s, zdepth is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (xwidth2 <= 0 && xwidth2 != -1) {
  printf("\nERROR in Union_box named %s, the xwidth2 is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (yheight2 <= 0 && yheight2 != -1) {
  printf("\nERROR in Union_box named %s, yheight2 is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}

// Use sanitation
if (global_material_list.num_elements == 0) {
  printf("\nERROR: Need to define a material using Union_make_material before using a Union geometry component. \n");
  printf("       %s was defined before first use of Union_make_material.\n",NAME_CURRENT_COMP);
  exit(1);
}

this_box_volume.geometry.is_masked_volume = 0;
this_box_volume.geometry.is_exit_volume = 0;
this_box_volume.geometry.is_mask_volume = 0;
// check if the volume is a mask, if it is the material string is irelevant.
if (mask_string && strlen(mask_string) && strcmp(mask_string, "NULL") && strcmp(mask_string, "0")) {
    // A mask volume is used to limit the extend of other volumes, called the masked volumes. These are specified in the mask_string.
    // In order for a ray to enter a masked volume, it needs to be both in the region covered by that volume AND the mask volume.
    // When more than
    this_box_volume.geometry.mask_mode = 1; // Default is mask mode is ALL
    if (mask_setting && strlen(mask_setting) && strcmp(mask_setting, "NULL") && strcmp(mask_setting, "0")) {
        if (strcmp(mask_setting,"ALL") == 0 || strcmp(mask_setting,"All") == 0) this_box_volume.geometry.mask_mode = 1;
        else if (strcmp(mask_setting,"ANY") == 0 || strcmp(mask_setting,"Any") == 0) this_box_volume.geometry.mask_mode = 2;
        else {
            printf("The mask_mode of component %s is set to %s, but must be either ALL or ANY.\n",NAME_CURRENT_COMP,mask_setting);
            exit(1);
        }
    }
    
    for (loop_index=0;loop_index<global_geometry_list.num_elements;loop_index++) {
        // Add mask list
        if (1 == manual_linking_function(global_geometry_list.elements[loop_index].name,mask_string)) {
            add_element_to_int_list(&this_box_volume.geometry.mask_list,global_geometry_list.elements[loop_index].component_index);
            add_element_to_int_list(&global_geometry_list.elements[loop_index].Volume->geometry.masked_by_list,INDEX_CURRENT_COMP);
            global_geometry_list.elements[loop_index].Volume->geometry.is_masked_volume = 1;
            if (this_box_volume.geometry.mask_mode == 2)
                global_geometry_list.elements[loop_index].Volume->geometry.mask_mode = 2;
            if (this_box_volume.geometry.mask_mode == 1) {
                if (global_geometry_list.elements[loop_index].Volume->geometry.is_masked_volume == 1 && global_geometry_list.elements[loop_index].Volume->geometry.mask_mode != 2)
                    // If more than one mask is added to one volume, the ANY mode overwrites the (default) ALL mode.
                    global_geometry_list.elements[loop_index].Volume->geometry.mask_mode = 1;
            }
            
            found_geometries = 1;
        }
    }
    if (found_geometries == 0) {
        printf("The mask_string in geometry: %s did not find any of the specified volumes in the mask_string %s \n",NAME_CURRENT_COMP,mask_string);
        exit(1);
    }
    this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
    this_box_volume.p_physics->is_vacuum = 0; // Makes this volume a vacuum
    this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
    this_box_volume.p_physics->my_a = 0; // Should not be used.
    sprintf(this_box_volume.p_physics->name,"Mask");
    this_box_volume.geometry.is_mask_volume = 1;
    
    
// Read the material input, or if it lacks, use automatic linking.
} else if (material_string && strlen(material_string) && strcmp(material_string, "NULL") && strcmp(material_string, "0")) {
    // A geometry string was given, use it to determine which material
    if (0 == strcmp(material_string,"vacuum") || 0 == strcmp(material_string,"Vacuum")) {
        // One could have a global physics struct for vacuum instead of creating one for each
        this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
        this_box_volume.p_physics->is_vacuum = 1; // Makes this volume a vacuum
        this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
        this_box_volume.p_physics->my_a = 0; // Should not be used.
        sprintf(this_box_volume.p_physics->name,"Vacuum");
    } else if (0 == strcmp(material_string,"exit") || 0 == strcmp(material_string,"Exit")) {
        // One could have a global physics struct for vacuum instead of creating one for each
        this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
        this_box_volume.p_physics->is_vacuum = 1; // Makes this volume a vacuum
        this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
        this_box_volume.p_physics->my_a = 0; // Should not be used.
        this_box_volume.geometry.is_exit_volume = 1;
        sprintf(this_box_volume.p_physics->name,"Exit");
    } else {
        #ifndef MATERIAL_DETECTOR
            printf("Need to define a material before refering to it in a geometry %s.\n",NAME_CURRENT_COMP);
            exit(1);
        #endif
        for (loop_index=0;loop_index<global_material_list.num_elements;loop_index++) {
            if (0 == strcmp(material_string,global_material_list.elements[loop_index].name)) {
                this_box_volume.p_physics = global_material_list.elements[loop_index].physics;
                break;
            }
            if (loop_index == global_material_list.num_elements-1) {
            printf("\n");
            printf("ERROR: The material string \"%s\" in Union geometry \"%s\" did not match a specified material. \n",material_string,NAME_CURRENT_COMP);
            printf("       The materials available at this point (need to be defined before the geometry): \n");
            for (loop_index=0;loop_index<global_material_list.num_elements;loop_index++)
              printf("         %s\n",global_material_list.elements[loop_index].name);
            printf("\n");
            printf("       It is also possible to use one of the defualt materials avaiable: \n");
            printf("           Vacuum (for a Volume without scattering or absorption)\n");
            printf("           Exit (for a Volume where the ray exits the component if it enters)\n");
            printf("           Mask (for a Volume that masks existing volumes specified in the mask_string\n");
            exit(1);
          }
        }
    }
} else {
    // Automatic linking, simply using the last defined material.
    #ifndef MATERIAL_DETECTOR
        printf("Need to define a material before the geometry to use automatic linking %s.\n",NAME_CURRENT_COMP);
        exit(1);
    #endif
    this_box_volume.p_physics = global_material_list.elements[global_material_list.num_elements-1].physics;
}

sprintf(this_box_volume.name,NAME_CURRENT_COMP);
sprintf(this_box_volume.geometry.shape,"box");
this_box_volume.geometry.priority_value = priority;
this_box_volume.geometry.geometry_p_interact = p_interact;
// Currently the coordinates will be in absolute space.
this_box_volume.geometry.center = POS_A_CURRENT_COMP;

this_box_storage.z_depth = zdepth;
this_box_storage.x_width1 = xwidth;
this_box_storage.y_height1 = yheight;

this_box_storage.is_rectangle = 0;
if (xwidth2 < 0 && yheight2 < 0) this_box_storage.is_rectangle = 1;
if (xwidth == xwidth2 && yheight == yheight2) this_box_storage.is_rectangle = 1;

if (xwidth2 < 0) {
    this_box_storage.x_width2 = xwidth;
    xwidth2 = xwidth;
} else this_box_storage.x_width2 = xwidth2;

if (yheight2 < 0) {
    this_box_storage.y_height2 = yheight;
    yheight2 = yheight;
} else this_box_storage.y_height2 = yheight2;


this_box_storage.normal_vectors[0] = coords_set(0,0,1);
this_box_storage.normal_vectors[1] = coords_set(0,0,1);

// for sides with y component = 0
x_component = 2*zdepth/sqrt((xwidth-xwidth2)*(xwidth-xwidth2)+4*zdepth*zdepth);
z_component = (xwidth-xwidth2)/sqrt(4*zdepth*zdepth+(xwidth-xwidth2)*(xwidth-xwidth2));

this_box_storage.normal_vectors[2] = coords_set(x_component,0,z_component);
this_box_storage.normal_vectors[3] = coords_set(-x_component,0,z_component);

// for sides with x component = 0
y_component = 2*zdepth/sqrt((yheight-yheight2)*(yheight-yheight2)+4*zdepth*zdepth);
z_component = (yheight-yheight2)/sqrt(4*zdepth*zdepth+(yheight-yheight2)*(yheight-yheight2));

this_box_storage.normal_vectors[4] = coords_set(0,y_component,z_component);
this_box_storage.normal_vectors[5] = coords_set(0,-y_component,z_component);

this_box_volume.geometry.visualization_on = visualize;

this_box_volume.geometry.geometry_parameters.p_box_storage = &this_box_storage;

// Assign pointers to functions for intersection with the shape, checking if a point is inside the shape
if (this_box_storage.is_rectangle == 1) {
this_box_volume.geometry.intersect_function = &sample_box_intersect_simple;
this_box_volume.geometry.within_function = &r_within_box_simple;
}
else {
this_box_volume.geometry.intersect_function = &sample_box_intersect_advanced;
this_box_volume.geometry.within_function = &r_within_box_advanced;
}

this_box_volume.geometry.shell_points = &box_shell_points;
this_box_volume.geometry.mcdisplay_function = &mcdisplay_box_function;
this_box_volume.geometry.initialize_from_main_function = &initialize_box_geometry_from_main_component;
this_box_volume.geometry.process_rot_allocated = 0;

this_box_volume.geometry.copy_geometry_parameters = &allocate_box_storage_copy;

rot_copy(this_box_volume.geometry.rotation_matrix,ROT_A_CURRENT_COMP); //check how ROT_R_CURRENT_COMP would work
rot_transpose(ROT_A_CURRENT_COMP,this_box_volume.geometry.transpose_rotation_matrix);

// Initialize loggers
this_box_volume.loggers.num_elements = 0;

// packing the information into the global_geometry_element, which is then included in the global_geometry_list.
sprintf(global_geometry_element.name,NAME_CURRENT_COMP);
global_geometry_element.activation_counter = number_of_activations;
global_geometry_element.component_index = INDEX_CURRENT_COMP;
global_geometry_element.Volume = &this_box_volume; // Would be nicer if this m was a pointer, now we have the (small) data two places
add_element_to_geometry_list(&global_geometry_list,global_geometry_element);
}
#line 166313 "MACS_sample_kidney_box.c"
#undef number_of_activations
#undef mask_setting
#undef mask_string
#undef p_interact
#undef focus_r
#undef focus_xh
#undef focus_xw
#undef focus_ah
#undef focus_aw
#undef target_z
#undef target_y
#undef target_x
#undef target_index
#undef visualize
#undef yheight2
#undef xwidth2
#undef zdepth
#undef yheight
#undef xwidth
#undef priority
#undef material_string
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

  /* Initializations for component channel_0_analyzer_1_array_crystal_array_3. */
  SIG_MESSAGE("channel_0_analyzer_1_array_crystal_array_3 (Init)");
#define mccompcurname  channel_0_analyzer_1_array_crystal_array_3
#define mccompcurtype  Union_box
#define mccompcurindex 133
#define loop_index mccchannel_0_analyzer_1_array_crystal_array_3_loop_index
#define this_box_volume mccchannel_0_analyzer_1_array_crystal_array_3_this_box_volume
#define global_geometry_element mccchannel_0_analyzer_1_array_crystal_array_3_global_geometry_element
#define this_box_storage mccchannel_0_analyzer_1_array_crystal_array_3_this_box_storage
#define material_string mccchannel_0_analyzer_1_array_crystal_array_3_material_string
#define priority mccchannel_0_analyzer_1_array_crystal_array_3_priority
#define xwidth mccchannel_0_analyzer_1_array_crystal_array_3_xwidth
#define yheight mccchannel_0_analyzer_1_array_crystal_array_3_yheight
#define zdepth mccchannel_0_analyzer_1_array_crystal_array_3_zdepth
#define xwidth2 mccchannel_0_analyzer_1_array_crystal_array_3_xwidth2
#define yheight2 mccchannel_0_analyzer_1_array_crystal_array_3_yheight2
#define visualize mccchannel_0_analyzer_1_array_crystal_array_3_visualize
#define target_index mccchannel_0_analyzer_1_array_crystal_array_3_target_index
#define target_x mccchannel_0_analyzer_1_array_crystal_array_3_target_x
#define target_y mccchannel_0_analyzer_1_array_crystal_array_3_target_y
#define target_z mccchannel_0_analyzer_1_array_crystal_array_3_target_z
#define focus_aw mccchannel_0_analyzer_1_array_crystal_array_3_focus_aw
#define focus_ah mccchannel_0_analyzer_1_array_crystal_array_3_focus_ah
#define focus_xw mccchannel_0_analyzer_1_array_crystal_array_3_focus_xw
#define focus_xh mccchannel_0_analyzer_1_array_crystal_array_3_focus_xh
#define focus_r mccchannel_0_analyzer_1_array_crystal_array_3_focus_r
#define p_interact mccchannel_0_analyzer_1_array_crystal_array_3_p_interact
#define mask_string mccchannel_0_analyzer_1_array_crystal_array_3_mask_string
#define mask_setting mccchannel_0_analyzer_1_array_crystal_array_3_mask_setting
#define number_of_activations mccchannel_0_analyzer_1_array_crystal_array_3_number_of_activations
#line 224 "Union_box.comp"
{
// Initializes the focusing system for this volume including input sanitation.
focus_initialize(&this_box_volume.geometry, POS_A_COMP_INDEX(INDEX_CURRENT_COMP+target_index), POS_A_CURRENT_COMP, ROT_A_CURRENT_COMP, target_index, target_x, target_y, target_z, focus_aw, focus_ah, focus_xw, focus_xh, focus_r, NAME_CURRENT_COMP);

// Input sanitation for this geometry
if (xwidth <= 0) {
  printf("\nERROR in Union_box named %s, the xwidth is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (yheight <= 0) {
  printf("\nERROR in Union_box named %s, yheight is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (zdepth <= 0) {
  printf("\nERROR in Union_box named %s, zdepth is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (xwidth2 <= 0 && xwidth2 != -1) {
  printf("\nERROR in Union_box named %s, the xwidth2 is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (yheight2 <= 0 && yheight2 != -1) {
  printf("\nERROR in Union_box named %s, yheight2 is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}

// Use sanitation
if (global_material_list.num_elements == 0) {
  printf("\nERROR: Need to define a material using Union_make_material before using a Union geometry component. \n");
  printf("       %s was defined before first use of Union_make_material.\n",NAME_CURRENT_COMP);
  exit(1);
}

this_box_volume.geometry.is_masked_volume = 0;
this_box_volume.geometry.is_exit_volume = 0;
this_box_volume.geometry.is_mask_volume = 0;
// check if the volume is a mask, if it is the material string is irelevant.
if (mask_string && strlen(mask_string) && strcmp(mask_string, "NULL") && strcmp(mask_string, "0")) {
    // A mask volume is used to limit the extend of other volumes, called the masked volumes. These are specified in the mask_string.
    // In order for a ray to enter a masked volume, it needs to be both in the region covered by that volume AND the mask volume.
    // When more than
    this_box_volume.geometry.mask_mode = 1; // Default is mask mode is ALL
    if (mask_setting && strlen(mask_setting) && strcmp(mask_setting, "NULL") && strcmp(mask_setting, "0")) {
        if (strcmp(mask_setting,"ALL") == 0 || strcmp(mask_setting,"All") == 0) this_box_volume.geometry.mask_mode = 1;
        else if (strcmp(mask_setting,"ANY") == 0 || strcmp(mask_setting,"Any") == 0) this_box_volume.geometry.mask_mode = 2;
        else {
            printf("The mask_mode of component %s is set to %s, but must be either ALL or ANY.\n",NAME_CURRENT_COMP,mask_setting);
            exit(1);
        }
    }
    
    for (loop_index=0;loop_index<global_geometry_list.num_elements;loop_index++) {
        // Add mask list
        if (1 == manual_linking_function(global_geometry_list.elements[loop_index].name,mask_string)) {
            add_element_to_int_list(&this_box_volume.geometry.mask_list,global_geometry_list.elements[loop_index].component_index);
            add_element_to_int_list(&global_geometry_list.elements[loop_index].Volume->geometry.masked_by_list,INDEX_CURRENT_COMP);
            global_geometry_list.elements[loop_index].Volume->geometry.is_masked_volume = 1;
            if (this_box_volume.geometry.mask_mode == 2)
                global_geometry_list.elements[loop_index].Volume->geometry.mask_mode = 2;
            if (this_box_volume.geometry.mask_mode == 1) {
                if (global_geometry_list.elements[loop_index].Volume->geometry.is_masked_volume == 1 && global_geometry_list.elements[loop_index].Volume->geometry.mask_mode != 2)
                    // If more than one mask is added to one volume, the ANY mode overwrites the (default) ALL mode.
                    global_geometry_list.elements[loop_index].Volume->geometry.mask_mode = 1;
            }
            
            found_geometries = 1;
        }
    }
    if (found_geometries == 0) {
        printf("The mask_string in geometry: %s did not find any of the specified volumes in the mask_string %s \n",NAME_CURRENT_COMP,mask_string);
        exit(1);
    }
    this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
    this_box_volume.p_physics->is_vacuum = 0; // Makes this volume a vacuum
    this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
    this_box_volume.p_physics->my_a = 0; // Should not be used.
    sprintf(this_box_volume.p_physics->name,"Mask");
    this_box_volume.geometry.is_mask_volume = 1;
    
    
// Read the material input, or if it lacks, use automatic linking.
} else if (material_string && strlen(material_string) && strcmp(material_string, "NULL") && strcmp(material_string, "0")) {
    // A geometry string was given, use it to determine which material
    if (0 == strcmp(material_string,"vacuum") || 0 == strcmp(material_string,"Vacuum")) {
        // One could have a global physics struct for vacuum instead of creating one for each
        this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
        this_box_volume.p_physics->is_vacuum = 1; // Makes this volume a vacuum
        this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
        this_box_volume.p_physics->my_a = 0; // Should not be used.
        sprintf(this_box_volume.p_physics->name,"Vacuum");
    } else if (0 == strcmp(material_string,"exit") || 0 == strcmp(material_string,"Exit")) {
        // One could have a global physics struct for vacuum instead of creating one for each
        this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
        this_box_volume.p_physics->is_vacuum = 1; // Makes this volume a vacuum
        this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
        this_box_volume.p_physics->my_a = 0; // Should not be used.
        this_box_volume.geometry.is_exit_volume = 1;
        sprintf(this_box_volume.p_physics->name,"Exit");
    } else {
        #ifndef MATERIAL_DETECTOR
            printf("Need to define a material before refering to it in a geometry %s.\n",NAME_CURRENT_COMP);
            exit(1);
        #endif
        for (loop_index=0;loop_index<global_material_list.num_elements;loop_index++) {
            if (0 == strcmp(material_string,global_material_list.elements[loop_index].name)) {
                this_box_volume.p_physics = global_material_list.elements[loop_index].physics;
                break;
            }
            if (loop_index == global_material_list.num_elements-1) {
            printf("\n");
            printf("ERROR: The material string \"%s\" in Union geometry \"%s\" did not match a specified material. \n",material_string,NAME_CURRENT_COMP);
            printf("       The materials available at this point (need to be defined before the geometry): \n");
            for (loop_index=0;loop_index<global_material_list.num_elements;loop_index++)
              printf("         %s\n",global_material_list.elements[loop_index].name);
            printf("\n");
            printf("       It is also possible to use one of the defualt materials avaiable: \n");
            printf("           Vacuum (for a Volume without scattering or absorption)\n");
            printf("           Exit (for a Volume where the ray exits the component if it enters)\n");
            printf("           Mask (for a Volume that masks existing volumes specified in the mask_string\n");
            exit(1);
          }
        }
    }
} else {
    // Automatic linking, simply using the last defined material.
    #ifndef MATERIAL_DETECTOR
        printf("Need to define a material before the geometry to use automatic linking %s.\n",NAME_CURRENT_COMP);
        exit(1);
    #endif
    this_box_volume.p_physics = global_material_list.elements[global_material_list.num_elements-1].physics;
}

sprintf(this_box_volume.name,NAME_CURRENT_COMP);
sprintf(this_box_volume.geometry.shape,"box");
this_box_volume.geometry.priority_value = priority;
this_box_volume.geometry.geometry_p_interact = p_interact;
// Currently the coordinates will be in absolute space.
this_box_volume.geometry.center = POS_A_CURRENT_COMP;

this_box_storage.z_depth = zdepth;
this_box_storage.x_width1 = xwidth;
this_box_storage.y_height1 = yheight;

this_box_storage.is_rectangle = 0;
if (xwidth2 < 0 && yheight2 < 0) this_box_storage.is_rectangle = 1;
if (xwidth == xwidth2 && yheight == yheight2) this_box_storage.is_rectangle = 1;

if (xwidth2 < 0) {
    this_box_storage.x_width2 = xwidth;
    xwidth2 = xwidth;
} else this_box_storage.x_width2 = xwidth2;

if (yheight2 < 0) {
    this_box_storage.y_height2 = yheight;
    yheight2 = yheight;
} else this_box_storage.y_height2 = yheight2;


this_box_storage.normal_vectors[0] = coords_set(0,0,1);
this_box_storage.normal_vectors[1] = coords_set(0,0,1);

// for sides with y component = 0
x_component = 2*zdepth/sqrt((xwidth-xwidth2)*(xwidth-xwidth2)+4*zdepth*zdepth);
z_component = (xwidth-xwidth2)/sqrt(4*zdepth*zdepth+(xwidth-xwidth2)*(xwidth-xwidth2));

this_box_storage.normal_vectors[2] = coords_set(x_component,0,z_component);
this_box_storage.normal_vectors[3] = coords_set(-x_component,0,z_component);

// for sides with x component = 0
y_component = 2*zdepth/sqrt((yheight-yheight2)*(yheight-yheight2)+4*zdepth*zdepth);
z_component = (yheight-yheight2)/sqrt(4*zdepth*zdepth+(yheight-yheight2)*(yheight-yheight2));

this_box_storage.normal_vectors[4] = coords_set(0,y_component,z_component);
this_box_storage.normal_vectors[5] = coords_set(0,-y_component,z_component);

this_box_volume.geometry.visualization_on = visualize;

this_box_volume.geometry.geometry_parameters.p_box_storage = &this_box_storage;

// Assign pointers to functions for intersection with the shape, checking if a point is inside the shape
if (this_box_storage.is_rectangle == 1) {
this_box_volume.geometry.intersect_function = &sample_box_intersect_simple;
this_box_volume.geometry.within_function = &r_within_box_simple;
}
else {
this_box_volume.geometry.intersect_function = &sample_box_intersect_advanced;
this_box_volume.geometry.within_function = &r_within_box_advanced;
}

this_box_volume.geometry.shell_points = &box_shell_points;
this_box_volume.geometry.mcdisplay_function = &mcdisplay_box_function;
this_box_volume.geometry.initialize_from_main_function = &initialize_box_geometry_from_main_component;
this_box_volume.geometry.process_rot_allocated = 0;

this_box_volume.geometry.copy_geometry_parameters = &allocate_box_storage_copy;

rot_copy(this_box_volume.geometry.rotation_matrix,ROT_A_CURRENT_COMP); //check how ROT_R_CURRENT_COMP would work
rot_transpose(ROT_A_CURRENT_COMP,this_box_volume.geometry.transpose_rotation_matrix);

// Initialize loggers
this_box_volume.loggers.num_elements = 0;

// packing the information into the global_geometry_element, which is then included in the global_geometry_list.
sprintf(global_geometry_element.name,NAME_CURRENT_COMP);
global_geometry_element.activation_counter = number_of_activations;
global_geometry_element.component_index = INDEX_CURRENT_COMP;
global_geometry_element.Volume = &this_box_volume; // Would be nicer if this m was a pointer, now we have the (small) data two places
add_element_to_geometry_list(&global_geometry_list,global_geometry_element);
}
#line 166583 "MACS_sample_kidney_box.c"
#undef number_of_activations
#undef mask_setting
#undef mask_string
#undef p_interact
#undef focus_r
#undef focus_xh
#undef focus_xw
#undef focus_ah
#undef focus_aw
#undef target_z
#undef target_y
#undef target_x
#undef target_index
#undef visualize
#undef yheight2
#undef xwidth2
#undef zdepth
#undef yheight
#undef xwidth
#undef priority
#undef material_string
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

  /* Initializations for component channel_0_analyzer_1_array_crystal_array_4. */
  SIG_MESSAGE("channel_0_analyzer_1_array_crystal_array_4 (Init)");
#define mccompcurname  channel_0_analyzer_1_array_crystal_array_4
#define mccompcurtype  Union_box
#define mccompcurindex 134
#define loop_index mccchannel_0_analyzer_1_array_crystal_array_4_loop_index
#define this_box_volume mccchannel_0_analyzer_1_array_crystal_array_4_this_box_volume
#define global_geometry_element mccchannel_0_analyzer_1_array_crystal_array_4_global_geometry_element
#define this_box_storage mccchannel_0_analyzer_1_array_crystal_array_4_this_box_storage
#define material_string mccchannel_0_analyzer_1_array_crystal_array_4_material_string
#define priority mccchannel_0_analyzer_1_array_crystal_array_4_priority
#define xwidth mccchannel_0_analyzer_1_array_crystal_array_4_xwidth
#define yheight mccchannel_0_analyzer_1_array_crystal_array_4_yheight
#define zdepth mccchannel_0_analyzer_1_array_crystal_array_4_zdepth
#define xwidth2 mccchannel_0_analyzer_1_array_crystal_array_4_xwidth2
#define yheight2 mccchannel_0_analyzer_1_array_crystal_array_4_yheight2
#define visualize mccchannel_0_analyzer_1_array_crystal_array_4_visualize
#define target_index mccchannel_0_analyzer_1_array_crystal_array_4_target_index
#define target_x mccchannel_0_analyzer_1_array_crystal_array_4_target_x
#define target_y mccchannel_0_analyzer_1_array_crystal_array_4_target_y
#define target_z mccchannel_0_analyzer_1_array_crystal_array_4_target_z
#define focus_aw mccchannel_0_analyzer_1_array_crystal_array_4_focus_aw
#define focus_ah mccchannel_0_analyzer_1_array_crystal_array_4_focus_ah
#define focus_xw mccchannel_0_analyzer_1_array_crystal_array_4_focus_xw
#define focus_xh mccchannel_0_analyzer_1_array_crystal_array_4_focus_xh
#define focus_r mccchannel_0_analyzer_1_array_crystal_array_4_focus_r
#define p_interact mccchannel_0_analyzer_1_array_crystal_array_4_p_interact
#define mask_string mccchannel_0_analyzer_1_array_crystal_array_4_mask_string
#define mask_setting mccchannel_0_analyzer_1_array_crystal_array_4_mask_setting
#define number_of_activations mccchannel_0_analyzer_1_array_crystal_array_4_number_of_activations
#line 224 "Union_box.comp"
{
// Initializes the focusing system for this volume including input sanitation.
focus_initialize(&this_box_volume.geometry, POS_A_COMP_INDEX(INDEX_CURRENT_COMP+target_index), POS_A_CURRENT_COMP, ROT_A_CURRENT_COMP, target_index, target_x, target_y, target_z, focus_aw, focus_ah, focus_xw, focus_xh, focus_r, NAME_CURRENT_COMP);

// Input sanitation for this geometry
if (xwidth <= 0) {
  printf("\nERROR in Union_box named %s, the xwidth is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (yheight <= 0) {
  printf("\nERROR in Union_box named %s, yheight is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (zdepth <= 0) {
  printf("\nERROR in Union_box named %s, zdepth is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (xwidth2 <= 0 && xwidth2 != -1) {
  printf("\nERROR in Union_box named %s, the xwidth2 is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (yheight2 <= 0 && yheight2 != -1) {
  printf("\nERROR in Union_box named %s, yheight2 is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}

// Use sanitation
if (global_material_list.num_elements == 0) {
  printf("\nERROR: Need to define a material using Union_make_material before using a Union geometry component. \n");
  printf("       %s was defined before first use of Union_make_material.\n",NAME_CURRENT_COMP);
  exit(1);
}

this_box_volume.geometry.is_masked_volume = 0;
this_box_volume.geometry.is_exit_volume = 0;
this_box_volume.geometry.is_mask_volume = 0;
// check if the volume is a mask, if it is the material string is irelevant.
if (mask_string && strlen(mask_string) && strcmp(mask_string, "NULL") && strcmp(mask_string, "0")) {
    // A mask volume is used to limit the extend of other volumes, called the masked volumes. These are specified in the mask_string.
    // In order for a ray to enter a masked volume, it needs to be both in the region covered by that volume AND the mask volume.
    // When more than
    this_box_volume.geometry.mask_mode = 1; // Default is mask mode is ALL
    if (mask_setting && strlen(mask_setting) && strcmp(mask_setting, "NULL") && strcmp(mask_setting, "0")) {
        if (strcmp(mask_setting,"ALL") == 0 || strcmp(mask_setting,"All") == 0) this_box_volume.geometry.mask_mode = 1;
        else if (strcmp(mask_setting,"ANY") == 0 || strcmp(mask_setting,"Any") == 0) this_box_volume.geometry.mask_mode = 2;
        else {
            printf("The mask_mode of component %s is set to %s, but must be either ALL or ANY.\n",NAME_CURRENT_COMP,mask_setting);
            exit(1);
        }
    }
    
    for (loop_index=0;loop_index<global_geometry_list.num_elements;loop_index++) {
        // Add mask list
        if (1 == manual_linking_function(global_geometry_list.elements[loop_index].name,mask_string)) {
            add_element_to_int_list(&this_box_volume.geometry.mask_list,global_geometry_list.elements[loop_index].component_index);
            add_element_to_int_list(&global_geometry_list.elements[loop_index].Volume->geometry.masked_by_list,INDEX_CURRENT_COMP);
            global_geometry_list.elements[loop_index].Volume->geometry.is_masked_volume = 1;
            if (this_box_volume.geometry.mask_mode == 2)
                global_geometry_list.elements[loop_index].Volume->geometry.mask_mode = 2;
            if (this_box_volume.geometry.mask_mode == 1) {
                if (global_geometry_list.elements[loop_index].Volume->geometry.is_masked_volume == 1 && global_geometry_list.elements[loop_index].Volume->geometry.mask_mode != 2)
                    // If more than one mask is added to one volume, the ANY mode overwrites the (default) ALL mode.
                    global_geometry_list.elements[loop_index].Volume->geometry.mask_mode = 1;
            }
            
            found_geometries = 1;
        }
    }
    if (found_geometries == 0) {
        printf("The mask_string in geometry: %s did not find any of the specified volumes in the mask_string %s \n",NAME_CURRENT_COMP,mask_string);
        exit(1);
    }
    this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
    this_box_volume.p_physics->is_vacuum = 0; // Makes this volume a vacuum
    this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
    this_box_volume.p_physics->my_a = 0; // Should not be used.
    sprintf(this_box_volume.p_physics->name,"Mask");
    this_box_volume.geometry.is_mask_volume = 1;
    
    
// Read the material input, or if it lacks, use automatic linking.
} else if (material_string && strlen(material_string) && strcmp(material_string, "NULL") && strcmp(material_string, "0")) {
    // A geometry string was given, use it to determine which material
    if (0 == strcmp(material_string,"vacuum") || 0 == strcmp(material_string,"Vacuum")) {
        // One could have a global physics struct for vacuum instead of creating one for each
        this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
        this_box_volume.p_physics->is_vacuum = 1; // Makes this volume a vacuum
        this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
        this_box_volume.p_physics->my_a = 0; // Should not be used.
        sprintf(this_box_volume.p_physics->name,"Vacuum");
    } else if (0 == strcmp(material_string,"exit") || 0 == strcmp(material_string,"Exit")) {
        // One could have a global physics struct for vacuum instead of creating one for each
        this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
        this_box_volume.p_physics->is_vacuum = 1; // Makes this volume a vacuum
        this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
        this_box_volume.p_physics->my_a = 0; // Should not be used.
        this_box_volume.geometry.is_exit_volume = 1;
        sprintf(this_box_volume.p_physics->name,"Exit");
    } else {
        #ifndef MATERIAL_DETECTOR
            printf("Need to define a material before refering to it in a geometry %s.\n",NAME_CURRENT_COMP);
            exit(1);
        #endif
        for (loop_index=0;loop_index<global_material_list.num_elements;loop_index++) {
            if (0 == strcmp(material_string,global_material_list.elements[loop_index].name)) {
                this_box_volume.p_physics = global_material_list.elements[loop_index].physics;
                break;
            }
            if (loop_index == global_material_list.num_elements-1) {
            printf("\n");
            printf("ERROR: The material string \"%s\" in Union geometry \"%s\" did not match a specified material. \n",material_string,NAME_CURRENT_COMP);
            printf("       The materials available at this point (need to be defined before the geometry): \n");
            for (loop_index=0;loop_index<global_material_list.num_elements;loop_index++)
              printf("         %s\n",global_material_list.elements[loop_index].name);
            printf("\n");
            printf("       It is also possible to use one of the defualt materials avaiable: \n");
            printf("           Vacuum (for a Volume without scattering or absorption)\n");
            printf("           Exit (for a Volume where the ray exits the component if it enters)\n");
            printf("           Mask (for a Volume that masks existing volumes specified in the mask_string\n");
            exit(1);
          }
        }
    }
} else {
    // Automatic linking, simply using the last defined material.
    #ifndef MATERIAL_DETECTOR
        printf("Need to define a material before the geometry to use automatic linking %s.\n",NAME_CURRENT_COMP);
        exit(1);
    #endif
    this_box_volume.p_physics = global_material_list.elements[global_material_list.num_elements-1].physics;
}

sprintf(this_box_volume.name,NAME_CURRENT_COMP);
sprintf(this_box_volume.geometry.shape,"box");
this_box_volume.geometry.priority_value = priority;
this_box_volume.geometry.geometry_p_interact = p_interact;
// Currently the coordinates will be in absolute space.
this_box_volume.geometry.center = POS_A_CURRENT_COMP;

this_box_storage.z_depth = zdepth;
this_box_storage.x_width1 = xwidth;
this_box_storage.y_height1 = yheight;

this_box_storage.is_rectangle = 0;
if (xwidth2 < 0 && yheight2 < 0) this_box_storage.is_rectangle = 1;
if (xwidth == xwidth2 && yheight == yheight2) this_box_storage.is_rectangle = 1;

if (xwidth2 < 0) {
    this_box_storage.x_width2 = xwidth;
    xwidth2 = xwidth;
} else this_box_storage.x_width2 = xwidth2;

if (yheight2 < 0) {
    this_box_storage.y_height2 = yheight;
    yheight2 = yheight;
} else this_box_storage.y_height2 = yheight2;


this_box_storage.normal_vectors[0] = coords_set(0,0,1);
this_box_storage.normal_vectors[1] = coords_set(0,0,1);

// for sides with y component = 0
x_component = 2*zdepth/sqrt((xwidth-xwidth2)*(xwidth-xwidth2)+4*zdepth*zdepth);
z_component = (xwidth-xwidth2)/sqrt(4*zdepth*zdepth+(xwidth-xwidth2)*(xwidth-xwidth2));

this_box_storage.normal_vectors[2] = coords_set(x_component,0,z_component);
this_box_storage.normal_vectors[3] = coords_set(-x_component,0,z_component);

// for sides with x component = 0
y_component = 2*zdepth/sqrt((yheight-yheight2)*(yheight-yheight2)+4*zdepth*zdepth);
z_component = (yheight-yheight2)/sqrt(4*zdepth*zdepth+(yheight-yheight2)*(yheight-yheight2));

this_box_storage.normal_vectors[4] = coords_set(0,y_component,z_component);
this_box_storage.normal_vectors[5] = coords_set(0,-y_component,z_component);

this_box_volume.geometry.visualization_on = visualize;

this_box_volume.geometry.geometry_parameters.p_box_storage = &this_box_storage;

// Assign pointers to functions for intersection with the shape, checking if a point is inside the shape
if (this_box_storage.is_rectangle == 1) {
this_box_volume.geometry.intersect_function = &sample_box_intersect_simple;
this_box_volume.geometry.within_function = &r_within_box_simple;
}
else {
this_box_volume.geometry.intersect_function = &sample_box_intersect_advanced;
this_box_volume.geometry.within_function = &r_within_box_advanced;
}

this_box_volume.geometry.shell_points = &box_shell_points;
this_box_volume.geometry.mcdisplay_function = &mcdisplay_box_function;
this_box_volume.geometry.initialize_from_main_function = &initialize_box_geometry_from_main_component;
this_box_volume.geometry.process_rot_allocated = 0;

this_box_volume.geometry.copy_geometry_parameters = &allocate_box_storage_copy;

rot_copy(this_box_volume.geometry.rotation_matrix,ROT_A_CURRENT_COMP); //check how ROT_R_CURRENT_COMP would work
rot_transpose(ROT_A_CURRENT_COMP,this_box_volume.geometry.transpose_rotation_matrix);

// Initialize loggers
this_box_volume.loggers.num_elements = 0;

// packing the information into the global_geometry_element, which is then included in the global_geometry_list.
sprintf(global_geometry_element.name,NAME_CURRENT_COMP);
global_geometry_element.activation_counter = number_of_activations;
global_geometry_element.component_index = INDEX_CURRENT_COMP;
global_geometry_element.Volume = &this_box_volume; // Would be nicer if this m was a pointer, now we have the (small) data two places
add_element_to_geometry_list(&global_geometry_list,global_geometry_element);
}
#line 166853 "MACS_sample_kidney_box.c"
#undef number_of_activations
#undef mask_setting
#undef mask_string
#undef p_interact
#undef focus_r
#undef focus_xh
#undef focus_xw
#undef focus_ah
#undef focus_aw
#undef target_z
#undef target_y
#undef target_x
#undef target_index
#undef visualize
#undef yheight2
#undef xwidth2
#undef zdepth
#undef yheight
#undef xwidth
#undef priority
#undef material_string
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

  /* Initializations for component channel_0_analyzer_1_array_crystal_array_5. */
  SIG_MESSAGE("channel_0_analyzer_1_array_crystal_array_5 (Init)");
#define mccompcurname  channel_0_analyzer_1_array_crystal_array_5
#define mccompcurtype  Union_box
#define mccompcurindex 135
#define loop_index mccchannel_0_analyzer_1_array_crystal_array_5_loop_index
#define this_box_volume mccchannel_0_analyzer_1_array_crystal_array_5_this_box_volume
#define global_geometry_element mccchannel_0_analyzer_1_array_crystal_array_5_global_geometry_element
#define this_box_storage mccchannel_0_analyzer_1_array_crystal_array_5_this_box_storage
#define material_string mccchannel_0_analyzer_1_array_crystal_array_5_material_string
#define priority mccchannel_0_analyzer_1_array_crystal_array_5_priority
#define xwidth mccchannel_0_analyzer_1_array_crystal_array_5_xwidth
#define yheight mccchannel_0_analyzer_1_array_crystal_array_5_yheight
#define zdepth mccchannel_0_analyzer_1_array_crystal_array_5_zdepth
#define xwidth2 mccchannel_0_analyzer_1_array_crystal_array_5_xwidth2
#define yheight2 mccchannel_0_analyzer_1_array_crystal_array_5_yheight2
#define visualize mccchannel_0_analyzer_1_array_crystal_array_5_visualize
#define target_index mccchannel_0_analyzer_1_array_crystal_array_5_target_index
#define target_x mccchannel_0_analyzer_1_array_crystal_array_5_target_x
#define target_y mccchannel_0_analyzer_1_array_crystal_array_5_target_y
#define target_z mccchannel_0_analyzer_1_array_crystal_array_5_target_z
#define focus_aw mccchannel_0_analyzer_1_array_crystal_array_5_focus_aw
#define focus_ah mccchannel_0_analyzer_1_array_crystal_array_5_focus_ah
#define focus_xw mccchannel_0_analyzer_1_array_crystal_array_5_focus_xw
#define focus_xh mccchannel_0_analyzer_1_array_crystal_array_5_focus_xh
#define focus_r mccchannel_0_analyzer_1_array_crystal_array_5_focus_r
#define p_interact mccchannel_0_analyzer_1_array_crystal_array_5_p_interact
#define mask_string mccchannel_0_analyzer_1_array_crystal_array_5_mask_string
#define mask_setting mccchannel_0_analyzer_1_array_crystal_array_5_mask_setting
#define number_of_activations mccchannel_0_analyzer_1_array_crystal_array_5_number_of_activations
#line 224 "Union_box.comp"
{
// Initializes the focusing system for this volume including input sanitation.
focus_initialize(&this_box_volume.geometry, POS_A_COMP_INDEX(INDEX_CURRENT_COMP+target_index), POS_A_CURRENT_COMP, ROT_A_CURRENT_COMP, target_index, target_x, target_y, target_z, focus_aw, focus_ah, focus_xw, focus_xh, focus_r, NAME_CURRENT_COMP);

// Input sanitation for this geometry
if (xwidth <= 0) {
  printf("\nERROR in Union_box named %s, the xwidth is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (yheight <= 0) {
  printf("\nERROR in Union_box named %s, yheight is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (zdepth <= 0) {
  printf("\nERROR in Union_box named %s, zdepth is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (xwidth2 <= 0 && xwidth2 != -1) {
  printf("\nERROR in Union_box named %s, the xwidth2 is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (yheight2 <= 0 && yheight2 != -1) {
  printf("\nERROR in Union_box named %s, yheight2 is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}

// Use sanitation
if (global_material_list.num_elements == 0) {
  printf("\nERROR: Need to define a material using Union_make_material before using a Union geometry component. \n");
  printf("       %s was defined before first use of Union_make_material.\n",NAME_CURRENT_COMP);
  exit(1);
}

this_box_volume.geometry.is_masked_volume = 0;
this_box_volume.geometry.is_exit_volume = 0;
this_box_volume.geometry.is_mask_volume = 0;
// check if the volume is a mask, if it is the material string is irelevant.
if (mask_string && strlen(mask_string) && strcmp(mask_string, "NULL") && strcmp(mask_string, "0")) {
    // A mask volume is used to limit the extend of other volumes, called the masked volumes. These are specified in the mask_string.
    // In order for a ray to enter a masked volume, it needs to be both in the region covered by that volume AND the mask volume.
    // When more than
    this_box_volume.geometry.mask_mode = 1; // Default is mask mode is ALL
    if (mask_setting && strlen(mask_setting) && strcmp(mask_setting, "NULL") && strcmp(mask_setting, "0")) {
        if (strcmp(mask_setting,"ALL") == 0 || strcmp(mask_setting,"All") == 0) this_box_volume.geometry.mask_mode = 1;
        else if (strcmp(mask_setting,"ANY") == 0 || strcmp(mask_setting,"Any") == 0) this_box_volume.geometry.mask_mode = 2;
        else {
            printf("The mask_mode of component %s is set to %s, but must be either ALL or ANY.\n",NAME_CURRENT_COMP,mask_setting);
            exit(1);
        }
    }
    
    for (loop_index=0;loop_index<global_geometry_list.num_elements;loop_index++) {
        // Add mask list
        if (1 == manual_linking_function(global_geometry_list.elements[loop_index].name,mask_string)) {
            add_element_to_int_list(&this_box_volume.geometry.mask_list,global_geometry_list.elements[loop_index].component_index);
            add_element_to_int_list(&global_geometry_list.elements[loop_index].Volume->geometry.masked_by_list,INDEX_CURRENT_COMP);
            global_geometry_list.elements[loop_index].Volume->geometry.is_masked_volume = 1;
            if (this_box_volume.geometry.mask_mode == 2)
                global_geometry_list.elements[loop_index].Volume->geometry.mask_mode = 2;
            if (this_box_volume.geometry.mask_mode == 1) {
                if (global_geometry_list.elements[loop_index].Volume->geometry.is_masked_volume == 1 && global_geometry_list.elements[loop_index].Volume->geometry.mask_mode != 2)
                    // If more than one mask is added to one volume, the ANY mode overwrites the (default) ALL mode.
                    global_geometry_list.elements[loop_index].Volume->geometry.mask_mode = 1;
            }
            
            found_geometries = 1;
        }
    }
    if (found_geometries == 0) {
        printf("The mask_string in geometry: %s did not find any of the specified volumes in the mask_string %s \n",NAME_CURRENT_COMP,mask_string);
        exit(1);
    }
    this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
    this_box_volume.p_physics->is_vacuum = 0; // Makes this volume a vacuum
    this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
    this_box_volume.p_physics->my_a = 0; // Should not be used.
    sprintf(this_box_volume.p_physics->name,"Mask");
    this_box_volume.geometry.is_mask_volume = 1;
    
    
// Read the material input, or if it lacks, use automatic linking.
} else if (material_string && strlen(material_string) && strcmp(material_string, "NULL") && strcmp(material_string, "0")) {
    // A geometry string was given, use it to determine which material
    if (0 == strcmp(material_string,"vacuum") || 0 == strcmp(material_string,"Vacuum")) {
        // One could have a global physics struct for vacuum instead of creating one for each
        this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
        this_box_volume.p_physics->is_vacuum = 1; // Makes this volume a vacuum
        this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
        this_box_volume.p_physics->my_a = 0; // Should not be used.
        sprintf(this_box_volume.p_physics->name,"Vacuum");
    } else if (0 == strcmp(material_string,"exit") || 0 == strcmp(material_string,"Exit")) {
        // One could have a global physics struct for vacuum instead of creating one for each
        this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
        this_box_volume.p_physics->is_vacuum = 1; // Makes this volume a vacuum
        this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
        this_box_volume.p_physics->my_a = 0; // Should not be used.
        this_box_volume.geometry.is_exit_volume = 1;
        sprintf(this_box_volume.p_physics->name,"Exit");
    } else {
        #ifndef MATERIAL_DETECTOR
            printf("Need to define a material before refering to it in a geometry %s.\n",NAME_CURRENT_COMP);
            exit(1);
        #endif
        for (loop_index=0;loop_index<global_material_list.num_elements;loop_index++) {
            if (0 == strcmp(material_string,global_material_list.elements[loop_index].name)) {
                this_box_volume.p_physics = global_material_list.elements[loop_index].physics;
                break;
            }
            if (loop_index == global_material_list.num_elements-1) {
            printf("\n");
            printf("ERROR: The material string \"%s\" in Union geometry \"%s\" did not match a specified material. \n",material_string,NAME_CURRENT_COMP);
            printf("       The materials available at this point (need to be defined before the geometry): \n");
            for (loop_index=0;loop_index<global_material_list.num_elements;loop_index++)
              printf("         %s\n",global_material_list.elements[loop_index].name);
            printf("\n");
            printf("       It is also possible to use one of the defualt materials avaiable: \n");
            printf("           Vacuum (for a Volume without scattering or absorption)\n");
            printf("           Exit (for a Volume where the ray exits the component if it enters)\n");
            printf("           Mask (for a Volume that masks existing volumes specified in the mask_string\n");
            exit(1);
          }
        }
    }
} else {
    // Automatic linking, simply using the last defined material.
    #ifndef MATERIAL_DETECTOR
        printf("Need to define a material before the geometry to use automatic linking %s.\n",NAME_CURRENT_COMP);
        exit(1);
    #endif
    this_box_volume.p_physics = global_material_list.elements[global_material_list.num_elements-1].physics;
}

sprintf(this_box_volume.name,NAME_CURRENT_COMP);
sprintf(this_box_volume.geometry.shape,"box");
this_box_volume.geometry.priority_value = priority;
this_box_volume.geometry.geometry_p_interact = p_interact;
// Currently the coordinates will be in absolute space.
this_box_volume.geometry.center = POS_A_CURRENT_COMP;

this_box_storage.z_depth = zdepth;
this_box_storage.x_width1 = xwidth;
this_box_storage.y_height1 = yheight;

this_box_storage.is_rectangle = 0;
if (xwidth2 < 0 && yheight2 < 0) this_box_storage.is_rectangle = 1;
if (xwidth == xwidth2 && yheight == yheight2) this_box_storage.is_rectangle = 1;

if (xwidth2 < 0) {
    this_box_storage.x_width2 = xwidth;
    xwidth2 = xwidth;
} else this_box_storage.x_width2 = xwidth2;

if (yheight2 < 0) {
    this_box_storage.y_height2 = yheight;
    yheight2 = yheight;
} else this_box_storage.y_height2 = yheight2;


this_box_storage.normal_vectors[0] = coords_set(0,0,1);
this_box_storage.normal_vectors[1] = coords_set(0,0,1);

// for sides with y component = 0
x_component = 2*zdepth/sqrt((xwidth-xwidth2)*(xwidth-xwidth2)+4*zdepth*zdepth);
z_component = (xwidth-xwidth2)/sqrt(4*zdepth*zdepth+(xwidth-xwidth2)*(xwidth-xwidth2));

this_box_storage.normal_vectors[2] = coords_set(x_component,0,z_component);
this_box_storage.normal_vectors[3] = coords_set(-x_component,0,z_component);

// for sides with x component = 0
y_component = 2*zdepth/sqrt((yheight-yheight2)*(yheight-yheight2)+4*zdepth*zdepth);
z_component = (yheight-yheight2)/sqrt(4*zdepth*zdepth+(yheight-yheight2)*(yheight-yheight2));

this_box_storage.normal_vectors[4] = coords_set(0,y_component,z_component);
this_box_storage.normal_vectors[5] = coords_set(0,-y_component,z_component);

this_box_volume.geometry.visualization_on = visualize;

this_box_volume.geometry.geometry_parameters.p_box_storage = &this_box_storage;

// Assign pointers to functions for intersection with the shape, checking if a point is inside the shape
if (this_box_storage.is_rectangle == 1) {
this_box_volume.geometry.intersect_function = &sample_box_intersect_simple;
this_box_volume.geometry.within_function = &r_within_box_simple;
}
else {
this_box_volume.geometry.intersect_function = &sample_box_intersect_advanced;
this_box_volume.geometry.within_function = &r_within_box_advanced;
}

this_box_volume.geometry.shell_points = &box_shell_points;
this_box_volume.geometry.mcdisplay_function = &mcdisplay_box_function;
this_box_volume.geometry.initialize_from_main_function = &initialize_box_geometry_from_main_component;
this_box_volume.geometry.process_rot_allocated = 0;

this_box_volume.geometry.copy_geometry_parameters = &allocate_box_storage_copy;

rot_copy(this_box_volume.geometry.rotation_matrix,ROT_A_CURRENT_COMP); //check how ROT_R_CURRENT_COMP would work
rot_transpose(ROT_A_CURRENT_COMP,this_box_volume.geometry.transpose_rotation_matrix);

// Initialize loggers
this_box_volume.loggers.num_elements = 0;

// packing the information into the global_geometry_element, which is then included in the global_geometry_list.
sprintf(global_geometry_element.name,NAME_CURRENT_COMP);
global_geometry_element.activation_counter = number_of_activations;
global_geometry_element.component_index = INDEX_CURRENT_COMP;
global_geometry_element.Volume = &this_box_volume; // Would be nicer if this m was a pointer, now we have the (small) data two places
add_element_to_geometry_list(&global_geometry_list,global_geometry_element);
}
#line 167123 "MACS_sample_kidney_box.c"
#undef number_of_activations
#undef mask_setting
#undef mask_string
#undef p_interact
#undef focus_r
#undef focus_xh
#undef focus_xw
#undef focus_ah
#undef focus_aw
#undef target_z
#undef target_y
#undef target_x
#undef target_index
#undef visualize
#undef yheight2
#undef xwidth2
#undef zdepth
#undef yheight
#undef xwidth
#undef priority
#undef material_string
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

  /* Initializations for component channel_0_analyzer_1_array_crystal_array_6. */
  SIG_MESSAGE("channel_0_analyzer_1_array_crystal_array_6 (Init)");
#define mccompcurname  channel_0_analyzer_1_array_crystal_array_6
#define mccompcurtype  Union_box
#define mccompcurindex 136
#define loop_index mccchannel_0_analyzer_1_array_crystal_array_6_loop_index
#define this_box_volume mccchannel_0_analyzer_1_array_crystal_array_6_this_box_volume
#define global_geometry_element mccchannel_0_analyzer_1_array_crystal_array_6_global_geometry_element
#define this_box_storage mccchannel_0_analyzer_1_array_crystal_array_6_this_box_storage
#define material_string mccchannel_0_analyzer_1_array_crystal_array_6_material_string
#define priority mccchannel_0_analyzer_1_array_crystal_array_6_priority
#define xwidth mccchannel_0_analyzer_1_array_crystal_array_6_xwidth
#define yheight mccchannel_0_analyzer_1_array_crystal_array_6_yheight
#define zdepth mccchannel_0_analyzer_1_array_crystal_array_6_zdepth
#define xwidth2 mccchannel_0_analyzer_1_array_crystal_array_6_xwidth2
#define yheight2 mccchannel_0_analyzer_1_array_crystal_array_6_yheight2
#define visualize mccchannel_0_analyzer_1_array_crystal_array_6_visualize
#define target_index mccchannel_0_analyzer_1_array_crystal_array_6_target_index
#define target_x mccchannel_0_analyzer_1_array_crystal_array_6_target_x
#define target_y mccchannel_0_analyzer_1_array_crystal_array_6_target_y
#define target_z mccchannel_0_analyzer_1_array_crystal_array_6_target_z
#define focus_aw mccchannel_0_analyzer_1_array_crystal_array_6_focus_aw
#define focus_ah mccchannel_0_analyzer_1_array_crystal_array_6_focus_ah
#define focus_xw mccchannel_0_analyzer_1_array_crystal_array_6_focus_xw
#define focus_xh mccchannel_0_analyzer_1_array_crystal_array_6_focus_xh
#define focus_r mccchannel_0_analyzer_1_array_crystal_array_6_focus_r
#define p_interact mccchannel_0_analyzer_1_array_crystal_array_6_p_interact
#define mask_string mccchannel_0_analyzer_1_array_crystal_array_6_mask_string
#define mask_setting mccchannel_0_analyzer_1_array_crystal_array_6_mask_setting
#define number_of_activations mccchannel_0_analyzer_1_array_crystal_array_6_number_of_activations
#line 224 "Union_box.comp"
{
// Initializes the focusing system for this volume including input sanitation.
focus_initialize(&this_box_volume.geometry, POS_A_COMP_INDEX(INDEX_CURRENT_COMP+target_index), POS_A_CURRENT_COMP, ROT_A_CURRENT_COMP, target_index, target_x, target_y, target_z, focus_aw, focus_ah, focus_xw, focus_xh, focus_r, NAME_CURRENT_COMP);

// Input sanitation for this geometry
if (xwidth <= 0) {
  printf("\nERROR in Union_box named %s, the xwidth is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (yheight <= 0) {
  printf("\nERROR in Union_box named %s, yheight is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (zdepth <= 0) {
  printf("\nERROR in Union_box named %s, zdepth is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (xwidth2 <= 0 && xwidth2 != -1) {
  printf("\nERROR in Union_box named %s, the xwidth2 is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (yheight2 <= 0 && yheight2 != -1) {
  printf("\nERROR in Union_box named %s, yheight2 is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}

// Use sanitation
if (global_material_list.num_elements == 0) {
  printf("\nERROR: Need to define a material using Union_make_material before using a Union geometry component. \n");
  printf("       %s was defined before first use of Union_make_material.\n",NAME_CURRENT_COMP);
  exit(1);
}

this_box_volume.geometry.is_masked_volume = 0;
this_box_volume.geometry.is_exit_volume = 0;
this_box_volume.geometry.is_mask_volume = 0;
// check if the volume is a mask, if it is the material string is irelevant.
if (mask_string && strlen(mask_string) && strcmp(mask_string, "NULL") && strcmp(mask_string, "0")) {
    // A mask volume is used to limit the extend of other volumes, called the masked volumes. These are specified in the mask_string.
    // In order for a ray to enter a masked volume, it needs to be both in the region covered by that volume AND the mask volume.
    // When more than
    this_box_volume.geometry.mask_mode = 1; // Default is mask mode is ALL
    if (mask_setting && strlen(mask_setting) && strcmp(mask_setting, "NULL") && strcmp(mask_setting, "0")) {
        if (strcmp(mask_setting,"ALL") == 0 || strcmp(mask_setting,"All") == 0) this_box_volume.geometry.mask_mode = 1;
        else if (strcmp(mask_setting,"ANY") == 0 || strcmp(mask_setting,"Any") == 0) this_box_volume.geometry.mask_mode = 2;
        else {
            printf("The mask_mode of component %s is set to %s, but must be either ALL or ANY.\n",NAME_CURRENT_COMP,mask_setting);
            exit(1);
        }
    }
    
    for (loop_index=0;loop_index<global_geometry_list.num_elements;loop_index++) {
        // Add mask list
        if (1 == manual_linking_function(global_geometry_list.elements[loop_index].name,mask_string)) {
            add_element_to_int_list(&this_box_volume.geometry.mask_list,global_geometry_list.elements[loop_index].component_index);
            add_element_to_int_list(&global_geometry_list.elements[loop_index].Volume->geometry.masked_by_list,INDEX_CURRENT_COMP);
            global_geometry_list.elements[loop_index].Volume->geometry.is_masked_volume = 1;
            if (this_box_volume.geometry.mask_mode == 2)
                global_geometry_list.elements[loop_index].Volume->geometry.mask_mode = 2;
            if (this_box_volume.geometry.mask_mode == 1) {
                if (global_geometry_list.elements[loop_index].Volume->geometry.is_masked_volume == 1 && global_geometry_list.elements[loop_index].Volume->geometry.mask_mode != 2)
                    // If more than one mask is added to one volume, the ANY mode overwrites the (default) ALL mode.
                    global_geometry_list.elements[loop_index].Volume->geometry.mask_mode = 1;
            }
            
            found_geometries = 1;
        }
    }
    if (found_geometries == 0) {
        printf("The mask_string in geometry: %s did not find any of the specified volumes in the mask_string %s \n",NAME_CURRENT_COMP,mask_string);
        exit(1);
    }
    this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
    this_box_volume.p_physics->is_vacuum = 0; // Makes this volume a vacuum
    this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
    this_box_volume.p_physics->my_a = 0; // Should not be used.
    sprintf(this_box_volume.p_physics->name,"Mask");
    this_box_volume.geometry.is_mask_volume = 1;
    
    
// Read the material input, or if it lacks, use automatic linking.
} else if (material_string && strlen(material_string) && strcmp(material_string, "NULL") && strcmp(material_string, "0")) {
    // A geometry string was given, use it to determine which material
    if (0 == strcmp(material_string,"vacuum") || 0 == strcmp(material_string,"Vacuum")) {
        // One could have a global physics struct for vacuum instead of creating one for each
        this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
        this_box_volume.p_physics->is_vacuum = 1; // Makes this volume a vacuum
        this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
        this_box_volume.p_physics->my_a = 0; // Should not be used.
        sprintf(this_box_volume.p_physics->name,"Vacuum");
    } else if (0 == strcmp(material_string,"exit") || 0 == strcmp(material_string,"Exit")) {
        // One could have a global physics struct for vacuum instead of creating one for each
        this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
        this_box_volume.p_physics->is_vacuum = 1; // Makes this volume a vacuum
        this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
        this_box_volume.p_physics->my_a = 0; // Should not be used.
        this_box_volume.geometry.is_exit_volume = 1;
        sprintf(this_box_volume.p_physics->name,"Exit");
    } else {
        #ifndef MATERIAL_DETECTOR
            printf("Need to define a material before refering to it in a geometry %s.\n",NAME_CURRENT_COMP);
            exit(1);
        #endif
        for (loop_index=0;loop_index<global_material_list.num_elements;loop_index++) {
            if (0 == strcmp(material_string,global_material_list.elements[loop_index].name)) {
                this_box_volume.p_physics = global_material_list.elements[loop_index].physics;
                break;
            }
            if (loop_index == global_material_list.num_elements-1) {
            printf("\n");
            printf("ERROR: The material string \"%s\" in Union geometry \"%s\" did not match a specified material. \n",material_string,NAME_CURRENT_COMP);
            printf("       The materials available at this point (need to be defined before the geometry): \n");
            for (loop_index=0;loop_index<global_material_list.num_elements;loop_index++)
              printf("         %s\n",global_material_list.elements[loop_index].name);
            printf("\n");
            printf("       It is also possible to use one of the defualt materials avaiable: \n");
            printf("           Vacuum (for a Volume without scattering or absorption)\n");
            printf("           Exit (for a Volume where the ray exits the component if it enters)\n");
            printf("           Mask (for a Volume that masks existing volumes specified in the mask_string\n");
            exit(1);
          }
        }
    }
} else {
    // Automatic linking, simply using the last defined material.
    #ifndef MATERIAL_DETECTOR
        printf("Need to define a material before the geometry to use automatic linking %s.\n",NAME_CURRENT_COMP);
        exit(1);
    #endif
    this_box_volume.p_physics = global_material_list.elements[global_material_list.num_elements-1].physics;
}

sprintf(this_box_volume.name,NAME_CURRENT_COMP);
sprintf(this_box_volume.geometry.shape,"box");
this_box_volume.geometry.priority_value = priority;
this_box_volume.geometry.geometry_p_interact = p_interact;
// Currently the coordinates will be in absolute space.
this_box_volume.geometry.center = POS_A_CURRENT_COMP;

this_box_storage.z_depth = zdepth;
this_box_storage.x_width1 = xwidth;
this_box_storage.y_height1 = yheight;

this_box_storage.is_rectangle = 0;
if (xwidth2 < 0 && yheight2 < 0) this_box_storage.is_rectangle = 1;
if (xwidth == xwidth2 && yheight == yheight2) this_box_storage.is_rectangle = 1;

if (xwidth2 < 0) {
    this_box_storage.x_width2 = xwidth;
    xwidth2 = xwidth;
} else this_box_storage.x_width2 = xwidth2;

if (yheight2 < 0) {
    this_box_storage.y_height2 = yheight;
    yheight2 = yheight;
} else this_box_storage.y_height2 = yheight2;


this_box_storage.normal_vectors[0] = coords_set(0,0,1);
this_box_storage.normal_vectors[1] = coords_set(0,0,1);

// for sides with y component = 0
x_component = 2*zdepth/sqrt((xwidth-xwidth2)*(xwidth-xwidth2)+4*zdepth*zdepth);
z_component = (xwidth-xwidth2)/sqrt(4*zdepth*zdepth+(xwidth-xwidth2)*(xwidth-xwidth2));

this_box_storage.normal_vectors[2] = coords_set(x_component,0,z_component);
this_box_storage.normal_vectors[3] = coords_set(-x_component,0,z_component);

// for sides with x component = 0
y_component = 2*zdepth/sqrt((yheight-yheight2)*(yheight-yheight2)+4*zdepth*zdepth);
z_component = (yheight-yheight2)/sqrt(4*zdepth*zdepth+(yheight-yheight2)*(yheight-yheight2));

this_box_storage.normal_vectors[4] = coords_set(0,y_component,z_component);
this_box_storage.normal_vectors[5] = coords_set(0,-y_component,z_component);

this_box_volume.geometry.visualization_on = visualize;

this_box_volume.geometry.geometry_parameters.p_box_storage = &this_box_storage;

// Assign pointers to functions for intersection with the shape, checking if a point is inside the shape
if (this_box_storage.is_rectangle == 1) {
this_box_volume.geometry.intersect_function = &sample_box_intersect_simple;
this_box_volume.geometry.within_function = &r_within_box_simple;
}
else {
this_box_volume.geometry.intersect_function = &sample_box_intersect_advanced;
this_box_volume.geometry.within_function = &r_within_box_advanced;
}

this_box_volume.geometry.shell_points = &box_shell_points;
this_box_volume.geometry.mcdisplay_function = &mcdisplay_box_function;
this_box_volume.geometry.initialize_from_main_function = &initialize_box_geometry_from_main_component;
this_box_volume.geometry.process_rot_allocated = 0;

this_box_volume.geometry.copy_geometry_parameters = &allocate_box_storage_copy;

rot_copy(this_box_volume.geometry.rotation_matrix,ROT_A_CURRENT_COMP); //check how ROT_R_CURRENT_COMP would work
rot_transpose(ROT_A_CURRENT_COMP,this_box_volume.geometry.transpose_rotation_matrix);

// Initialize loggers
this_box_volume.loggers.num_elements = 0;

// packing the information into the global_geometry_element, which is then included in the global_geometry_list.
sprintf(global_geometry_element.name,NAME_CURRENT_COMP);
global_geometry_element.activation_counter = number_of_activations;
global_geometry_element.component_index = INDEX_CURRENT_COMP;
global_geometry_element.Volume = &this_box_volume; // Would be nicer if this m was a pointer, now we have the (small) data two places
add_element_to_geometry_list(&global_geometry_list,global_geometry_element);
}
#line 167393 "MACS_sample_kidney_box.c"
#undef number_of_activations
#undef mask_setting
#undef mask_string
#undef p_interact
#undef focus_r
#undef focus_xh
#undef focus_xw
#undef focus_ah
#undef focus_aw
#undef target_z
#undef target_y
#undef target_x
#undef target_index
#undef visualize
#undef yheight2
#undef xwidth2
#undef zdepth
#undef yheight
#undef xwidth
#undef priority
#undef material_string
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

  /* Initializations for component channel_0_analyzer_1_array_crystal_array_7. */
  SIG_MESSAGE("channel_0_analyzer_1_array_crystal_array_7 (Init)");
#define mccompcurname  channel_0_analyzer_1_array_crystal_array_7
#define mccompcurtype  Union_box
#define mccompcurindex 137
#define loop_index mccchannel_0_analyzer_1_array_crystal_array_7_loop_index
#define this_box_volume mccchannel_0_analyzer_1_array_crystal_array_7_this_box_volume
#define global_geometry_element mccchannel_0_analyzer_1_array_crystal_array_7_global_geometry_element
#define this_box_storage mccchannel_0_analyzer_1_array_crystal_array_7_this_box_storage
#define material_string mccchannel_0_analyzer_1_array_crystal_array_7_material_string
#define priority mccchannel_0_analyzer_1_array_crystal_array_7_priority
#define xwidth mccchannel_0_analyzer_1_array_crystal_array_7_xwidth
#define yheight mccchannel_0_analyzer_1_array_crystal_array_7_yheight
#define zdepth mccchannel_0_analyzer_1_array_crystal_array_7_zdepth
#define xwidth2 mccchannel_0_analyzer_1_array_crystal_array_7_xwidth2
#define yheight2 mccchannel_0_analyzer_1_array_crystal_array_7_yheight2
#define visualize mccchannel_0_analyzer_1_array_crystal_array_7_visualize
#define target_index mccchannel_0_analyzer_1_array_crystal_array_7_target_index
#define target_x mccchannel_0_analyzer_1_array_crystal_array_7_target_x
#define target_y mccchannel_0_analyzer_1_array_crystal_array_7_target_y
#define target_z mccchannel_0_analyzer_1_array_crystal_array_7_target_z
#define focus_aw mccchannel_0_analyzer_1_array_crystal_array_7_focus_aw
#define focus_ah mccchannel_0_analyzer_1_array_crystal_array_7_focus_ah
#define focus_xw mccchannel_0_analyzer_1_array_crystal_array_7_focus_xw
#define focus_xh mccchannel_0_analyzer_1_array_crystal_array_7_focus_xh
#define focus_r mccchannel_0_analyzer_1_array_crystal_array_7_focus_r
#define p_interact mccchannel_0_analyzer_1_array_crystal_array_7_p_interact
#define mask_string mccchannel_0_analyzer_1_array_crystal_array_7_mask_string
#define mask_setting mccchannel_0_analyzer_1_array_crystal_array_7_mask_setting
#define number_of_activations mccchannel_0_analyzer_1_array_crystal_array_7_number_of_activations
#line 224 "Union_box.comp"
{
// Initializes the focusing system for this volume including input sanitation.
focus_initialize(&this_box_volume.geometry, POS_A_COMP_INDEX(INDEX_CURRENT_COMP+target_index), POS_A_CURRENT_COMP, ROT_A_CURRENT_COMP, target_index, target_x, target_y, target_z, focus_aw, focus_ah, focus_xw, focus_xh, focus_r, NAME_CURRENT_COMP);

// Input sanitation for this geometry
if (xwidth <= 0) {
  printf("\nERROR in Union_box named %s, the xwidth is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (yheight <= 0) {
  printf("\nERROR in Union_box named %s, yheight is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (zdepth <= 0) {
  printf("\nERROR in Union_box named %s, zdepth is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (xwidth2 <= 0 && xwidth2 != -1) {
  printf("\nERROR in Union_box named %s, the xwidth2 is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (yheight2 <= 0 && yheight2 != -1) {
  printf("\nERROR in Union_box named %s, yheight2 is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}

// Use sanitation
if (global_material_list.num_elements == 0) {
  printf("\nERROR: Need to define a material using Union_make_material before using a Union geometry component. \n");
  printf("       %s was defined before first use of Union_make_material.\n",NAME_CURRENT_COMP);
  exit(1);
}

this_box_volume.geometry.is_masked_volume = 0;
this_box_volume.geometry.is_exit_volume = 0;
this_box_volume.geometry.is_mask_volume = 0;
// check if the volume is a mask, if it is the material string is irelevant.
if (mask_string && strlen(mask_string) && strcmp(mask_string, "NULL") && strcmp(mask_string, "0")) {
    // A mask volume is used to limit the extend of other volumes, called the masked volumes. These are specified in the mask_string.
    // In order for a ray to enter a masked volume, it needs to be both in the region covered by that volume AND the mask volume.
    // When more than
    this_box_volume.geometry.mask_mode = 1; // Default is mask mode is ALL
    if (mask_setting && strlen(mask_setting) && strcmp(mask_setting, "NULL") && strcmp(mask_setting, "0")) {
        if (strcmp(mask_setting,"ALL") == 0 || strcmp(mask_setting,"All") == 0) this_box_volume.geometry.mask_mode = 1;
        else if (strcmp(mask_setting,"ANY") == 0 || strcmp(mask_setting,"Any") == 0) this_box_volume.geometry.mask_mode = 2;
        else {
            printf("The mask_mode of component %s is set to %s, but must be either ALL or ANY.\n",NAME_CURRENT_COMP,mask_setting);
            exit(1);
        }
    }
    
    for (loop_index=0;loop_index<global_geometry_list.num_elements;loop_index++) {
        // Add mask list
        if (1 == manual_linking_function(global_geometry_list.elements[loop_index].name,mask_string)) {
            add_element_to_int_list(&this_box_volume.geometry.mask_list,global_geometry_list.elements[loop_index].component_index);
            add_element_to_int_list(&global_geometry_list.elements[loop_index].Volume->geometry.masked_by_list,INDEX_CURRENT_COMP);
            global_geometry_list.elements[loop_index].Volume->geometry.is_masked_volume = 1;
            if (this_box_volume.geometry.mask_mode == 2)
                global_geometry_list.elements[loop_index].Volume->geometry.mask_mode = 2;
            if (this_box_volume.geometry.mask_mode == 1) {
                if (global_geometry_list.elements[loop_index].Volume->geometry.is_masked_volume == 1 && global_geometry_list.elements[loop_index].Volume->geometry.mask_mode != 2)
                    // If more than one mask is added to one volume, the ANY mode overwrites the (default) ALL mode.
                    global_geometry_list.elements[loop_index].Volume->geometry.mask_mode = 1;
            }
            
            found_geometries = 1;
        }
    }
    if (found_geometries == 0) {
        printf("The mask_string in geometry: %s did not find any of the specified volumes in the mask_string %s \n",NAME_CURRENT_COMP,mask_string);
        exit(1);
    }
    this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
    this_box_volume.p_physics->is_vacuum = 0; // Makes this volume a vacuum
    this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
    this_box_volume.p_physics->my_a = 0; // Should not be used.
    sprintf(this_box_volume.p_physics->name,"Mask");
    this_box_volume.geometry.is_mask_volume = 1;
    
    
// Read the material input, or if it lacks, use automatic linking.
} else if (material_string && strlen(material_string) && strcmp(material_string, "NULL") && strcmp(material_string, "0")) {
    // A geometry string was given, use it to determine which material
    if (0 == strcmp(material_string,"vacuum") || 0 == strcmp(material_string,"Vacuum")) {
        // One could have a global physics struct for vacuum instead of creating one for each
        this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
        this_box_volume.p_physics->is_vacuum = 1; // Makes this volume a vacuum
        this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
        this_box_volume.p_physics->my_a = 0; // Should not be used.
        sprintf(this_box_volume.p_physics->name,"Vacuum");
    } else if (0 == strcmp(material_string,"exit") || 0 == strcmp(material_string,"Exit")) {
        // One could have a global physics struct for vacuum instead of creating one for each
        this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
        this_box_volume.p_physics->is_vacuum = 1; // Makes this volume a vacuum
        this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
        this_box_volume.p_physics->my_a = 0; // Should not be used.
        this_box_volume.geometry.is_exit_volume = 1;
        sprintf(this_box_volume.p_physics->name,"Exit");
    } else {
        #ifndef MATERIAL_DETECTOR
            printf("Need to define a material before refering to it in a geometry %s.\n",NAME_CURRENT_COMP);
            exit(1);
        #endif
        for (loop_index=0;loop_index<global_material_list.num_elements;loop_index++) {
            if (0 == strcmp(material_string,global_material_list.elements[loop_index].name)) {
                this_box_volume.p_physics = global_material_list.elements[loop_index].physics;
                break;
            }
            if (loop_index == global_material_list.num_elements-1) {
            printf("\n");
            printf("ERROR: The material string \"%s\" in Union geometry \"%s\" did not match a specified material. \n",material_string,NAME_CURRENT_COMP);
            printf("       The materials available at this point (need to be defined before the geometry): \n");
            for (loop_index=0;loop_index<global_material_list.num_elements;loop_index++)
              printf("         %s\n",global_material_list.elements[loop_index].name);
            printf("\n");
            printf("       It is also possible to use one of the defualt materials avaiable: \n");
            printf("           Vacuum (for a Volume without scattering or absorption)\n");
            printf("           Exit (for a Volume where the ray exits the component if it enters)\n");
            printf("           Mask (for a Volume that masks existing volumes specified in the mask_string\n");
            exit(1);
          }
        }
    }
} else {
    // Automatic linking, simply using the last defined material.
    #ifndef MATERIAL_DETECTOR
        printf("Need to define a material before the geometry to use automatic linking %s.\n",NAME_CURRENT_COMP);
        exit(1);
    #endif
    this_box_volume.p_physics = global_material_list.elements[global_material_list.num_elements-1].physics;
}

sprintf(this_box_volume.name,NAME_CURRENT_COMP);
sprintf(this_box_volume.geometry.shape,"box");
this_box_volume.geometry.priority_value = priority;
this_box_volume.geometry.geometry_p_interact = p_interact;
// Currently the coordinates will be in absolute space.
this_box_volume.geometry.center = POS_A_CURRENT_COMP;

this_box_storage.z_depth = zdepth;
this_box_storage.x_width1 = xwidth;
this_box_storage.y_height1 = yheight;

this_box_storage.is_rectangle = 0;
if (xwidth2 < 0 && yheight2 < 0) this_box_storage.is_rectangle = 1;
if (xwidth == xwidth2 && yheight == yheight2) this_box_storage.is_rectangle = 1;

if (xwidth2 < 0) {
    this_box_storage.x_width2 = xwidth;
    xwidth2 = xwidth;
} else this_box_storage.x_width2 = xwidth2;

if (yheight2 < 0) {
    this_box_storage.y_height2 = yheight;
    yheight2 = yheight;
} else this_box_storage.y_height2 = yheight2;


this_box_storage.normal_vectors[0] = coords_set(0,0,1);
this_box_storage.normal_vectors[1] = coords_set(0,0,1);

// for sides with y component = 0
x_component = 2*zdepth/sqrt((xwidth-xwidth2)*(xwidth-xwidth2)+4*zdepth*zdepth);
z_component = (xwidth-xwidth2)/sqrt(4*zdepth*zdepth+(xwidth-xwidth2)*(xwidth-xwidth2));

this_box_storage.normal_vectors[2] = coords_set(x_component,0,z_component);
this_box_storage.normal_vectors[3] = coords_set(-x_component,0,z_component);

// for sides with x component = 0
y_component = 2*zdepth/sqrt((yheight-yheight2)*(yheight-yheight2)+4*zdepth*zdepth);
z_component = (yheight-yheight2)/sqrt(4*zdepth*zdepth+(yheight-yheight2)*(yheight-yheight2));

this_box_storage.normal_vectors[4] = coords_set(0,y_component,z_component);
this_box_storage.normal_vectors[5] = coords_set(0,-y_component,z_component);

this_box_volume.geometry.visualization_on = visualize;

this_box_volume.geometry.geometry_parameters.p_box_storage = &this_box_storage;

// Assign pointers to functions for intersection with the shape, checking if a point is inside the shape
if (this_box_storage.is_rectangle == 1) {
this_box_volume.geometry.intersect_function = &sample_box_intersect_simple;
this_box_volume.geometry.within_function = &r_within_box_simple;
}
else {
this_box_volume.geometry.intersect_function = &sample_box_intersect_advanced;
this_box_volume.geometry.within_function = &r_within_box_advanced;
}

this_box_volume.geometry.shell_points = &box_shell_points;
this_box_volume.geometry.mcdisplay_function = &mcdisplay_box_function;
this_box_volume.geometry.initialize_from_main_function = &initialize_box_geometry_from_main_component;
this_box_volume.geometry.process_rot_allocated = 0;

this_box_volume.geometry.copy_geometry_parameters = &allocate_box_storage_copy;

rot_copy(this_box_volume.geometry.rotation_matrix,ROT_A_CURRENT_COMP); //check how ROT_R_CURRENT_COMP would work
rot_transpose(ROT_A_CURRENT_COMP,this_box_volume.geometry.transpose_rotation_matrix);

// Initialize loggers
this_box_volume.loggers.num_elements = 0;

// packing the information into the global_geometry_element, which is then included in the global_geometry_list.
sprintf(global_geometry_element.name,NAME_CURRENT_COMP);
global_geometry_element.activation_counter = number_of_activations;
global_geometry_element.component_index = INDEX_CURRENT_COMP;
global_geometry_element.Volume = &this_box_volume; // Would be nicer if this m was a pointer, now we have the (small) data two places
add_element_to_geometry_list(&global_geometry_list,global_geometry_element);
}
#line 167663 "MACS_sample_kidney_box.c"
#undef number_of_activations
#undef mask_setting
#undef mask_string
#undef p_interact
#undef focus_r
#undef focus_xh
#undef focus_xw
#undef focus_ah
#undef focus_aw
#undef target_z
#undef target_y
#undef target_x
#undef target_index
#undef visualize
#undef yheight2
#undef xwidth2
#undef zdepth
#undef yheight
#undef xwidth
#undef priority
#undef material_string
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

  /* Initializations for component channel_0_analyzer_1_array_crystal_array_8. */
  SIG_MESSAGE("channel_0_analyzer_1_array_crystal_array_8 (Init)");
#define mccompcurname  channel_0_analyzer_1_array_crystal_array_8
#define mccompcurtype  Union_box
#define mccompcurindex 138
#define loop_index mccchannel_0_analyzer_1_array_crystal_array_8_loop_index
#define this_box_volume mccchannel_0_analyzer_1_array_crystal_array_8_this_box_volume
#define global_geometry_element mccchannel_0_analyzer_1_array_crystal_array_8_global_geometry_element
#define this_box_storage mccchannel_0_analyzer_1_array_crystal_array_8_this_box_storage
#define material_string mccchannel_0_analyzer_1_array_crystal_array_8_material_string
#define priority mccchannel_0_analyzer_1_array_crystal_array_8_priority
#define xwidth mccchannel_0_analyzer_1_array_crystal_array_8_xwidth
#define yheight mccchannel_0_analyzer_1_array_crystal_array_8_yheight
#define zdepth mccchannel_0_analyzer_1_array_crystal_array_8_zdepth
#define xwidth2 mccchannel_0_analyzer_1_array_crystal_array_8_xwidth2
#define yheight2 mccchannel_0_analyzer_1_array_crystal_array_8_yheight2
#define visualize mccchannel_0_analyzer_1_array_crystal_array_8_visualize
#define target_index mccchannel_0_analyzer_1_array_crystal_array_8_target_index
#define target_x mccchannel_0_analyzer_1_array_crystal_array_8_target_x
#define target_y mccchannel_0_analyzer_1_array_crystal_array_8_target_y
#define target_z mccchannel_0_analyzer_1_array_crystal_array_8_target_z
#define focus_aw mccchannel_0_analyzer_1_array_crystal_array_8_focus_aw
#define focus_ah mccchannel_0_analyzer_1_array_crystal_array_8_focus_ah
#define focus_xw mccchannel_0_analyzer_1_array_crystal_array_8_focus_xw
#define focus_xh mccchannel_0_analyzer_1_array_crystal_array_8_focus_xh
#define focus_r mccchannel_0_analyzer_1_array_crystal_array_8_focus_r
#define p_interact mccchannel_0_analyzer_1_array_crystal_array_8_p_interact
#define mask_string mccchannel_0_analyzer_1_array_crystal_array_8_mask_string
#define mask_setting mccchannel_0_analyzer_1_array_crystal_array_8_mask_setting
#define number_of_activations mccchannel_0_analyzer_1_array_crystal_array_8_number_of_activations
#line 224 "Union_box.comp"
{
// Initializes the focusing system for this volume including input sanitation.
focus_initialize(&this_box_volume.geometry, POS_A_COMP_INDEX(INDEX_CURRENT_COMP+target_index), POS_A_CURRENT_COMP, ROT_A_CURRENT_COMP, target_index, target_x, target_y, target_z, focus_aw, focus_ah, focus_xw, focus_xh, focus_r, NAME_CURRENT_COMP);

// Input sanitation for this geometry
if (xwidth <= 0) {
  printf("\nERROR in Union_box named %s, the xwidth is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (yheight <= 0) {
  printf("\nERROR in Union_box named %s, yheight is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (zdepth <= 0) {
  printf("\nERROR in Union_box named %s, zdepth is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (xwidth2 <= 0 && xwidth2 != -1) {
  printf("\nERROR in Union_box named %s, the xwidth2 is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (yheight2 <= 0 && yheight2 != -1) {
  printf("\nERROR in Union_box named %s, yheight2 is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}

// Use sanitation
if (global_material_list.num_elements == 0) {
  printf("\nERROR: Need to define a material using Union_make_material before using a Union geometry component. \n");
  printf("       %s was defined before first use of Union_make_material.\n",NAME_CURRENT_COMP);
  exit(1);
}

this_box_volume.geometry.is_masked_volume = 0;
this_box_volume.geometry.is_exit_volume = 0;
this_box_volume.geometry.is_mask_volume = 0;
// check if the volume is a mask, if it is the material string is irelevant.
if (mask_string && strlen(mask_string) && strcmp(mask_string, "NULL") && strcmp(mask_string, "0")) {
    // A mask volume is used to limit the extend of other volumes, called the masked volumes. These are specified in the mask_string.
    // In order for a ray to enter a masked volume, it needs to be both in the region covered by that volume AND the mask volume.
    // When more than
    this_box_volume.geometry.mask_mode = 1; // Default is mask mode is ALL
    if (mask_setting && strlen(mask_setting) && strcmp(mask_setting, "NULL") && strcmp(mask_setting, "0")) {
        if (strcmp(mask_setting,"ALL") == 0 || strcmp(mask_setting,"All") == 0) this_box_volume.geometry.mask_mode = 1;
        else if (strcmp(mask_setting,"ANY") == 0 || strcmp(mask_setting,"Any") == 0) this_box_volume.geometry.mask_mode = 2;
        else {
            printf("The mask_mode of component %s is set to %s, but must be either ALL or ANY.\n",NAME_CURRENT_COMP,mask_setting);
            exit(1);
        }
    }
    
    for (loop_index=0;loop_index<global_geometry_list.num_elements;loop_index++) {
        // Add mask list
        if (1 == manual_linking_function(global_geometry_list.elements[loop_index].name,mask_string)) {
            add_element_to_int_list(&this_box_volume.geometry.mask_list,global_geometry_list.elements[loop_index].component_index);
            add_element_to_int_list(&global_geometry_list.elements[loop_index].Volume->geometry.masked_by_list,INDEX_CURRENT_COMP);
            global_geometry_list.elements[loop_index].Volume->geometry.is_masked_volume = 1;
            if (this_box_volume.geometry.mask_mode == 2)
                global_geometry_list.elements[loop_index].Volume->geometry.mask_mode = 2;
            if (this_box_volume.geometry.mask_mode == 1) {
                if (global_geometry_list.elements[loop_index].Volume->geometry.is_masked_volume == 1 && global_geometry_list.elements[loop_index].Volume->geometry.mask_mode != 2)
                    // If more than one mask is added to one volume, the ANY mode overwrites the (default) ALL mode.
                    global_geometry_list.elements[loop_index].Volume->geometry.mask_mode = 1;
            }
            
            found_geometries = 1;
        }
    }
    if (found_geometries == 0) {
        printf("The mask_string in geometry: %s did not find any of the specified volumes in the mask_string %s \n",NAME_CURRENT_COMP,mask_string);
        exit(1);
    }
    this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
    this_box_volume.p_physics->is_vacuum = 0; // Makes this volume a vacuum
    this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
    this_box_volume.p_physics->my_a = 0; // Should not be used.
    sprintf(this_box_volume.p_physics->name,"Mask");
    this_box_volume.geometry.is_mask_volume = 1;
    
    
// Read the material input, or if it lacks, use automatic linking.
} else if (material_string && strlen(material_string) && strcmp(material_string, "NULL") && strcmp(material_string, "0")) {
    // A geometry string was given, use it to determine which material
    if (0 == strcmp(material_string,"vacuum") || 0 == strcmp(material_string,"Vacuum")) {
        // One could have a global physics struct for vacuum instead of creating one for each
        this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
        this_box_volume.p_physics->is_vacuum = 1; // Makes this volume a vacuum
        this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
        this_box_volume.p_physics->my_a = 0; // Should not be used.
        sprintf(this_box_volume.p_physics->name,"Vacuum");
    } else if (0 == strcmp(material_string,"exit") || 0 == strcmp(material_string,"Exit")) {
        // One could have a global physics struct for vacuum instead of creating one for each
        this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
        this_box_volume.p_physics->is_vacuum = 1; // Makes this volume a vacuum
        this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
        this_box_volume.p_physics->my_a = 0; // Should not be used.
        this_box_volume.geometry.is_exit_volume = 1;
        sprintf(this_box_volume.p_physics->name,"Exit");
    } else {
        #ifndef MATERIAL_DETECTOR
            printf("Need to define a material before refering to it in a geometry %s.\n",NAME_CURRENT_COMP);
            exit(1);
        #endif
        for (loop_index=0;loop_index<global_material_list.num_elements;loop_index++) {
            if (0 == strcmp(material_string,global_material_list.elements[loop_index].name)) {
                this_box_volume.p_physics = global_material_list.elements[loop_index].physics;
                break;
            }
            if (loop_index == global_material_list.num_elements-1) {
            printf("\n");
            printf("ERROR: The material string \"%s\" in Union geometry \"%s\" did not match a specified material. \n",material_string,NAME_CURRENT_COMP);
            printf("       The materials available at this point (need to be defined before the geometry): \n");
            for (loop_index=0;loop_index<global_material_list.num_elements;loop_index++)
              printf("         %s\n",global_material_list.elements[loop_index].name);
            printf("\n");
            printf("       It is also possible to use one of the defualt materials avaiable: \n");
            printf("           Vacuum (for a Volume without scattering or absorption)\n");
            printf("           Exit (for a Volume where the ray exits the component if it enters)\n");
            printf("           Mask (for a Volume that masks existing volumes specified in the mask_string\n");
            exit(1);
          }
        }
    }
} else {
    // Automatic linking, simply using the last defined material.
    #ifndef MATERIAL_DETECTOR
        printf("Need to define a material before the geometry to use automatic linking %s.\n",NAME_CURRENT_COMP);
        exit(1);
    #endif
    this_box_volume.p_physics = global_material_list.elements[global_material_list.num_elements-1].physics;
}

sprintf(this_box_volume.name,NAME_CURRENT_COMP);
sprintf(this_box_volume.geometry.shape,"box");
this_box_volume.geometry.priority_value = priority;
this_box_volume.geometry.geometry_p_interact = p_interact;
// Currently the coordinates will be in absolute space.
this_box_volume.geometry.center = POS_A_CURRENT_COMP;

this_box_storage.z_depth = zdepth;
this_box_storage.x_width1 = xwidth;
this_box_storage.y_height1 = yheight;

this_box_storage.is_rectangle = 0;
if (xwidth2 < 0 && yheight2 < 0) this_box_storage.is_rectangle = 1;
if (xwidth == xwidth2 && yheight == yheight2) this_box_storage.is_rectangle = 1;

if (xwidth2 < 0) {
    this_box_storage.x_width2 = xwidth;
    xwidth2 = xwidth;
} else this_box_storage.x_width2 = xwidth2;

if (yheight2 < 0) {
    this_box_storage.y_height2 = yheight;
    yheight2 = yheight;
} else this_box_storage.y_height2 = yheight2;


this_box_storage.normal_vectors[0] = coords_set(0,0,1);
this_box_storage.normal_vectors[1] = coords_set(0,0,1);

// for sides with y component = 0
x_component = 2*zdepth/sqrt((xwidth-xwidth2)*(xwidth-xwidth2)+4*zdepth*zdepth);
z_component = (xwidth-xwidth2)/sqrt(4*zdepth*zdepth+(xwidth-xwidth2)*(xwidth-xwidth2));

this_box_storage.normal_vectors[2] = coords_set(x_component,0,z_component);
this_box_storage.normal_vectors[3] = coords_set(-x_component,0,z_component);

// for sides with x component = 0
y_component = 2*zdepth/sqrt((yheight-yheight2)*(yheight-yheight2)+4*zdepth*zdepth);
z_component = (yheight-yheight2)/sqrt(4*zdepth*zdepth+(yheight-yheight2)*(yheight-yheight2));

this_box_storage.normal_vectors[4] = coords_set(0,y_component,z_component);
this_box_storage.normal_vectors[5] = coords_set(0,-y_component,z_component);

this_box_volume.geometry.visualization_on = visualize;

this_box_volume.geometry.geometry_parameters.p_box_storage = &this_box_storage;

// Assign pointers to functions for intersection with the shape, checking if a point is inside the shape
if (this_box_storage.is_rectangle == 1) {
this_box_volume.geometry.intersect_function = &sample_box_intersect_simple;
this_box_volume.geometry.within_function = &r_within_box_simple;
}
else {
this_box_volume.geometry.intersect_function = &sample_box_intersect_advanced;
this_box_volume.geometry.within_function = &r_within_box_advanced;
}

this_box_volume.geometry.shell_points = &box_shell_points;
this_box_volume.geometry.mcdisplay_function = &mcdisplay_box_function;
this_box_volume.geometry.initialize_from_main_function = &initialize_box_geometry_from_main_component;
this_box_volume.geometry.process_rot_allocated = 0;

this_box_volume.geometry.copy_geometry_parameters = &allocate_box_storage_copy;

rot_copy(this_box_volume.geometry.rotation_matrix,ROT_A_CURRENT_COMP); //check how ROT_R_CURRENT_COMP would work
rot_transpose(ROT_A_CURRENT_COMP,this_box_volume.geometry.transpose_rotation_matrix);

// Initialize loggers
this_box_volume.loggers.num_elements = 0;

// packing the information into the global_geometry_element, which is then included in the global_geometry_list.
sprintf(global_geometry_element.name,NAME_CURRENT_COMP);
global_geometry_element.activation_counter = number_of_activations;
global_geometry_element.component_index = INDEX_CURRENT_COMP;
global_geometry_element.Volume = &this_box_volume; // Would be nicer if this m was a pointer, now we have the (small) data two places
add_element_to_geometry_list(&global_geometry_list,global_geometry_element);
}
#line 167933 "MACS_sample_kidney_box.c"
#undef number_of_activations
#undef mask_setting
#undef mask_string
#undef p_interact
#undef focus_r
#undef focus_xh
#undef focus_xw
#undef focus_ah
#undef focus_aw
#undef target_z
#undef target_y
#undef target_x
#undef target_index
#undef visualize
#undef yheight2
#undef xwidth2
#undef zdepth
#undef yheight
#undef xwidth
#undef priority
#undef material_string
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

  /* Initializations for component channel_0_analyzer_2_center. */
  SIG_MESSAGE("channel_0_analyzer_2_center (Init)");

  /* Initializations for component channel_0_analyzer_2_rotated. */
  SIG_MESSAGE("channel_0_analyzer_2_rotated (Init)");

  /* Initializations for component channel_0_analyzer_2_array_crystal_array_0. */
  SIG_MESSAGE("channel_0_analyzer_2_array_crystal_array_0 (Init)");
#define mccompcurname  channel_0_analyzer_2_array_crystal_array_0
#define mccompcurtype  Union_box
#define mccompcurindex 141
#define loop_index mccchannel_0_analyzer_2_array_crystal_array_0_loop_index
#define this_box_volume mccchannel_0_analyzer_2_array_crystal_array_0_this_box_volume
#define global_geometry_element mccchannel_0_analyzer_2_array_crystal_array_0_global_geometry_element
#define this_box_storage mccchannel_0_analyzer_2_array_crystal_array_0_this_box_storage
#define material_string mccchannel_0_analyzer_2_array_crystal_array_0_material_string
#define priority mccchannel_0_analyzer_2_array_crystal_array_0_priority
#define xwidth mccchannel_0_analyzer_2_array_crystal_array_0_xwidth
#define yheight mccchannel_0_analyzer_2_array_crystal_array_0_yheight
#define zdepth mccchannel_0_analyzer_2_array_crystal_array_0_zdepth
#define xwidth2 mccchannel_0_analyzer_2_array_crystal_array_0_xwidth2
#define yheight2 mccchannel_0_analyzer_2_array_crystal_array_0_yheight2
#define visualize mccchannel_0_analyzer_2_array_crystal_array_0_visualize
#define target_index mccchannel_0_analyzer_2_array_crystal_array_0_target_index
#define target_x mccchannel_0_analyzer_2_array_crystal_array_0_target_x
#define target_y mccchannel_0_analyzer_2_array_crystal_array_0_target_y
#define target_z mccchannel_0_analyzer_2_array_crystal_array_0_target_z
#define focus_aw mccchannel_0_analyzer_2_array_crystal_array_0_focus_aw
#define focus_ah mccchannel_0_analyzer_2_array_crystal_array_0_focus_ah
#define focus_xw mccchannel_0_analyzer_2_array_crystal_array_0_focus_xw
#define focus_xh mccchannel_0_analyzer_2_array_crystal_array_0_focus_xh
#define focus_r mccchannel_0_analyzer_2_array_crystal_array_0_focus_r
#define p_interact mccchannel_0_analyzer_2_array_crystal_array_0_p_interact
#define mask_string mccchannel_0_analyzer_2_array_crystal_array_0_mask_string
#define mask_setting mccchannel_0_analyzer_2_array_crystal_array_0_mask_setting
#define number_of_activations mccchannel_0_analyzer_2_array_crystal_array_0_number_of_activations
#line 224 "Union_box.comp"
{
// Initializes the focusing system for this volume including input sanitation.
focus_initialize(&this_box_volume.geometry, POS_A_COMP_INDEX(INDEX_CURRENT_COMP+target_index), POS_A_CURRENT_COMP, ROT_A_CURRENT_COMP, target_index, target_x, target_y, target_z, focus_aw, focus_ah, focus_xw, focus_xh, focus_r, NAME_CURRENT_COMP);

// Input sanitation for this geometry
if (xwidth <= 0) {
  printf("\nERROR in Union_box named %s, the xwidth is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (yheight <= 0) {
  printf("\nERROR in Union_box named %s, yheight is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (zdepth <= 0) {
  printf("\nERROR in Union_box named %s, zdepth is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (xwidth2 <= 0 && xwidth2 != -1) {
  printf("\nERROR in Union_box named %s, the xwidth2 is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (yheight2 <= 0 && yheight2 != -1) {
  printf("\nERROR in Union_box named %s, yheight2 is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}

// Use sanitation
if (global_material_list.num_elements == 0) {
  printf("\nERROR: Need to define a material using Union_make_material before using a Union geometry component. \n");
  printf("       %s was defined before first use of Union_make_material.\n",NAME_CURRENT_COMP);
  exit(1);
}

this_box_volume.geometry.is_masked_volume = 0;
this_box_volume.geometry.is_exit_volume = 0;
this_box_volume.geometry.is_mask_volume = 0;
// check if the volume is a mask, if it is the material string is irelevant.
if (mask_string && strlen(mask_string) && strcmp(mask_string, "NULL") && strcmp(mask_string, "0")) {
    // A mask volume is used to limit the extend of other volumes, called the masked volumes. These are specified in the mask_string.
    // In order for a ray to enter a masked volume, it needs to be both in the region covered by that volume AND the mask volume.
    // When more than
    this_box_volume.geometry.mask_mode = 1; // Default is mask mode is ALL
    if (mask_setting && strlen(mask_setting) && strcmp(mask_setting, "NULL") && strcmp(mask_setting, "0")) {
        if (strcmp(mask_setting,"ALL") == 0 || strcmp(mask_setting,"All") == 0) this_box_volume.geometry.mask_mode = 1;
        else if (strcmp(mask_setting,"ANY") == 0 || strcmp(mask_setting,"Any") == 0) this_box_volume.geometry.mask_mode = 2;
        else {
            printf("The mask_mode of component %s is set to %s, but must be either ALL or ANY.\n",NAME_CURRENT_COMP,mask_setting);
            exit(1);
        }
    }
    
    for (loop_index=0;loop_index<global_geometry_list.num_elements;loop_index++) {
        // Add mask list
        if (1 == manual_linking_function(global_geometry_list.elements[loop_index].name,mask_string)) {
            add_element_to_int_list(&this_box_volume.geometry.mask_list,global_geometry_list.elements[loop_index].component_index);
            add_element_to_int_list(&global_geometry_list.elements[loop_index].Volume->geometry.masked_by_list,INDEX_CURRENT_COMP);
            global_geometry_list.elements[loop_index].Volume->geometry.is_masked_volume = 1;
            if (this_box_volume.geometry.mask_mode == 2)
                global_geometry_list.elements[loop_index].Volume->geometry.mask_mode = 2;
            if (this_box_volume.geometry.mask_mode == 1) {
                if (global_geometry_list.elements[loop_index].Volume->geometry.is_masked_volume == 1 && global_geometry_list.elements[loop_index].Volume->geometry.mask_mode != 2)
                    // If more than one mask is added to one volume, the ANY mode overwrites the (default) ALL mode.
                    global_geometry_list.elements[loop_index].Volume->geometry.mask_mode = 1;
            }
            
            found_geometries = 1;
        }
    }
    if (found_geometries == 0) {
        printf("The mask_string in geometry: %s did not find any of the specified volumes in the mask_string %s \n",NAME_CURRENT_COMP,mask_string);
        exit(1);
    }
    this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
    this_box_volume.p_physics->is_vacuum = 0; // Makes this volume a vacuum
    this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
    this_box_volume.p_physics->my_a = 0; // Should not be used.
    sprintf(this_box_volume.p_physics->name,"Mask");
    this_box_volume.geometry.is_mask_volume = 1;
    
    
// Read the material input, or if it lacks, use automatic linking.
} else if (material_string && strlen(material_string) && strcmp(material_string, "NULL") && strcmp(material_string, "0")) {
    // A geometry string was given, use it to determine which material
    if (0 == strcmp(material_string,"vacuum") || 0 == strcmp(material_string,"Vacuum")) {
        // One could have a global physics struct for vacuum instead of creating one for each
        this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
        this_box_volume.p_physics->is_vacuum = 1; // Makes this volume a vacuum
        this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
        this_box_volume.p_physics->my_a = 0; // Should not be used.
        sprintf(this_box_volume.p_physics->name,"Vacuum");
    } else if (0 == strcmp(material_string,"exit") || 0 == strcmp(material_string,"Exit")) {
        // One could have a global physics struct for vacuum instead of creating one for each
        this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
        this_box_volume.p_physics->is_vacuum = 1; // Makes this volume a vacuum
        this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
        this_box_volume.p_physics->my_a = 0; // Should not be used.
        this_box_volume.geometry.is_exit_volume = 1;
        sprintf(this_box_volume.p_physics->name,"Exit");
    } else {
        #ifndef MATERIAL_DETECTOR
            printf("Need to define a material before refering to it in a geometry %s.\n",NAME_CURRENT_COMP);
            exit(1);
        #endif
        for (loop_index=0;loop_index<global_material_list.num_elements;loop_index++) {
            if (0 == strcmp(material_string,global_material_list.elements[loop_index].name)) {
                this_box_volume.p_physics = global_material_list.elements[loop_index].physics;
                break;
            }
            if (loop_index == global_material_list.num_elements-1) {
            printf("\n");
            printf("ERROR: The material string \"%s\" in Union geometry \"%s\" did not match a specified material. \n",material_string,NAME_CURRENT_COMP);
            printf("       The materials available at this point (need to be defined before the geometry): \n");
            for (loop_index=0;loop_index<global_material_list.num_elements;loop_index++)
              printf("         %s\n",global_material_list.elements[loop_index].name);
            printf("\n");
            printf("       It is also possible to use one of the defualt materials avaiable: \n");
            printf("           Vacuum (for a Volume without scattering or absorption)\n");
            printf("           Exit (for a Volume where the ray exits the component if it enters)\n");
            printf("           Mask (for a Volume that masks existing volumes specified in the mask_string\n");
            exit(1);
          }
        }
    }
} else {
    // Automatic linking, simply using the last defined material.
    #ifndef MATERIAL_DETECTOR
        printf("Need to define a material before the geometry to use automatic linking %s.\n",NAME_CURRENT_COMP);
        exit(1);
    #endif
    this_box_volume.p_physics = global_material_list.elements[global_material_list.num_elements-1].physics;
}

sprintf(this_box_volume.name,NAME_CURRENT_COMP);
sprintf(this_box_volume.geometry.shape,"box");
this_box_volume.geometry.priority_value = priority;
this_box_volume.geometry.geometry_p_interact = p_interact;
// Currently the coordinates will be in absolute space.
this_box_volume.geometry.center = POS_A_CURRENT_COMP;

this_box_storage.z_depth = zdepth;
this_box_storage.x_width1 = xwidth;
this_box_storage.y_height1 = yheight;

this_box_storage.is_rectangle = 0;
if (xwidth2 < 0 && yheight2 < 0) this_box_storage.is_rectangle = 1;
if (xwidth == xwidth2 && yheight == yheight2) this_box_storage.is_rectangle = 1;

if (xwidth2 < 0) {
    this_box_storage.x_width2 = xwidth;
    xwidth2 = xwidth;
} else this_box_storage.x_width2 = xwidth2;

if (yheight2 < 0) {
    this_box_storage.y_height2 = yheight;
    yheight2 = yheight;
} else this_box_storage.y_height2 = yheight2;


this_box_storage.normal_vectors[0] = coords_set(0,0,1);
this_box_storage.normal_vectors[1] = coords_set(0,0,1);

// for sides with y component = 0
x_component = 2*zdepth/sqrt((xwidth-xwidth2)*(xwidth-xwidth2)+4*zdepth*zdepth);
z_component = (xwidth-xwidth2)/sqrt(4*zdepth*zdepth+(xwidth-xwidth2)*(xwidth-xwidth2));

this_box_storage.normal_vectors[2] = coords_set(x_component,0,z_component);
this_box_storage.normal_vectors[3] = coords_set(-x_component,0,z_component);

// for sides with x component = 0
y_component = 2*zdepth/sqrt((yheight-yheight2)*(yheight-yheight2)+4*zdepth*zdepth);
z_component = (yheight-yheight2)/sqrt(4*zdepth*zdepth+(yheight-yheight2)*(yheight-yheight2));

this_box_storage.normal_vectors[4] = coords_set(0,y_component,z_component);
this_box_storage.normal_vectors[5] = coords_set(0,-y_component,z_component);

this_box_volume.geometry.visualization_on = visualize;

this_box_volume.geometry.geometry_parameters.p_box_storage = &this_box_storage;

// Assign pointers to functions for intersection with the shape, checking if a point is inside the shape
if (this_box_storage.is_rectangle == 1) {
this_box_volume.geometry.intersect_function = &sample_box_intersect_simple;
this_box_volume.geometry.within_function = &r_within_box_simple;
}
else {
this_box_volume.geometry.intersect_function = &sample_box_intersect_advanced;
this_box_volume.geometry.within_function = &r_within_box_advanced;
}

this_box_volume.geometry.shell_points = &box_shell_points;
this_box_volume.geometry.mcdisplay_function = &mcdisplay_box_function;
this_box_volume.geometry.initialize_from_main_function = &initialize_box_geometry_from_main_component;
this_box_volume.geometry.process_rot_allocated = 0;

this_box_volume.geometry.copy_geometry_parameters = &allocate_box_storage_copy;

rot_copy(this_box_volume.geometry.rotation_matrix,ROT_A_CURRENT_COMP); //check how ROT_R_CURRENT_COMP would work
rot_transpose(ROT_A_CURRENT_COMP,this_box_volume.geometry.transpose_rotation_matrix);

// Initialize loggers
this_box_volume.loggers.num_elements = 0;

// packing the information into the global_geometry_element, which is then included in the global_geometry_list.
sprintf(global_geometry_element.name,NAME_CURRENT_COMP);
global_geometry_element.activation_counter = number_of_activations;
global_geometry_element.component_index = INDEX_CURRENT_COMP;
global_geometry_element.Volume = &this_box_volume; // Would be nicer if this m was a pointer, now we have the (small) data two places
add_element_to_geometry_list(&global_geometry_list,global_geometry_element);
}
#line 168209 "MACS_sample_kidney_box.c"
#undef number_of_activations
#undef mask_setting
#undef mask_string
#undef p_interact
#undef focus_r
#undef focus_xh
#undef focus_xw
#undef focus_ah
#undef focus_aw
#undef target_z
#undef target_y
#undef target_x
#undef target_index
#undef visualize
#undef yheight2
#undef xwidth2
#undef zdepth
#undef yheight
#undef xwidth
#undef priority
#undef material_string
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

  /* Initializations for component channel_0_analyzer_2_array_crystal_array_1. */
  SIG_MESSAGE("channel_0_analyzer_2_array_crystal_array_1 (Init)");
#define mccompcurname  channel_0_analyzer_2_array_crystal_array_1
#define mccompcurtype  Union_box
#define mccompcurindex 142
#define loop_index mccchannel_0_analyzer_2_array_crystal_array_1_loop_index
#define this_box_volume mccchannel_0_analyzer_2_array_crystal_array_1_this_box_volume
#define global_geometry_element mccchannel_0_analyzer_2_array_crystal_array_1_global_geometry_element
#define this_box_storage mccchannel_0_analyzer_2_array_crystal_array_1_this_box_storage
#define material_string mccchannel_0_analyzer_2_array_crystal_array_1_material_string
#define priority mccchannel_0_analyzer_2_array_crystal_array_1_priority
#define xwidth mccchannel_0_analyzer_2_array_crystal_array_1_xwidth
#define yheight mccchannel_0_analyzer_2_array_crystal_array_1_yheight
#define zdepth mccchannel_0_analyzer_2_array_crystal_array_1_zdepth
#define xwidth2 mccchannel_0_analyzer_2_array_crystal_array_1_xwidth2
#define yheight2 mccchannel_0_analyzer_2_array_crystal_array_1_yheight2
#define visualize mccchannel_0_analyzer_2_array_crystal_array_1_visualize
#define target_index mccchannel_0_analyzer_2_array_crystal_array_1_target_index
#define target_x mccchannel_0_analyzer_2_array_crystal_array_1_target_x
#define target_y mccchannel_0_analyzer_2_array_crystal_array_1_target_y
#define target_z mccchannel_0_analyzer_2_array_crystal_array_1_target_z
#define focus_aw mccchannel_0_analyzer_2_array_crystal_array_1_focus_aw
#define focus_ah mccchannel_0_analyzer_2_array_crystal_array_1_focus_ah
#define focus_xw mccchannel_0_analyzer_2_array_crystal_array_1_focus_xw
#define focus_xh mccchannel_0_analyzer_2_array_crystal_array_1_focus_xh
#define focus_r mccchannel_0_analyzer_2_array_crystal_array_1_focus_r
#define p_interact mccchannel_0_analyzer_2_array_crystal_array_1_p_interact
#define mask_string mccchannel_0_analyzer_2_array_crystal_array_1_mask_string
#define mask_setting mccchannel_0_analyzer_2_array_crystal_array_1_mask_setting
#define number_of_activations mccchannel_0_analyzer_2_array_crystal_array_1_number_of_activations
#line 224 "Union_box.comp"
{
// Initializes the focusing system for this volume including input sanitation.
focus_initialize(&this_box_volume.geometry, POS_A_COMP_INDEX(INDEX_CURRENT_COMP+target_index), POS_A_CURRENT_COMP, ROT_A_CURRENT_COMP, target_index, target_x, target_y, target_z, focus_aw, focus_ah, focus_xw, focus_xh, focus_r, NAME_CURRENT_COMP);

// Input sanitation for this geometry
if (xwidth <= 0) {
  printf("\nERROR in Union_box named %s, the xwidth is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (yheight <= 0) {
  printf("\nERROR in Union_box named %s, yheight is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (zdepth <= 0) {
  printf("\nERROR in Union_box named %s, zdepth is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (xwidth2 <= 0 && xwidth2 != -1) {
  printf("\nERROR in Union_box named %s, the xwidth2 is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (yheight2 <= 0 && yheight2 != -1) {
  printf("\nERROR in Union_box named %s, yheight2 is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}

// Use sanitation
if (global_material_list.num_elements == 0) {
  printf("\nERROR: Need to define a material using Union_make_material before using a Union geometry component. \n");
  printf("       %s was defined before first use of Union_make_material.\n",NAME_CURRENT_COMP);
  exit(1);
}

this_box_volume.geometry.is_masked_volume = 0;
this_box_volume.geometry.is_exit_volume = 0;
this_box_volume.geometry.is_mask_volume = 0;
// check if the volume is a mask, if it is the material string is irelevant.
if (mask_string && strlen(mask_string) && strcmp(mask_string, "NULL") && strcmp(mask_string, "0")) {
    // A mask volume is used to limit the extend of other volumes, called the masked volumes. These are specified in the mask_string.
    // In order for a ray to enter a masked volume, it needs to be both in the region covered by that volume AND the mask volume.
    // When more than
    this_box_volume.geometry.mask_mode = 1; // Default is mask mode is ALL
    if (mask_setting && strlen(mask_setting) && strcmp(mask_setting, "NULL") && strcmp(mask_setting, "0")) {
        if (strcmp(mask_setting,"ALL") == 0 || strcmp(mask_setting,"All") == 0) this_box_volume.geometry.mask_mode = 1;
        else if (strcmp(mask_setting,"ANY") == 0 || strcmp(mask_setting,"Any") == 0) this_box_volume.geometry.mask_mode = 2;
        else {
            printf("The mask_mode of component %s is set to %s, but must be either ALL or ANY.\n",NAME_CURRENT_COMP,mask_setting);
            exit(1);
        }
    }
    
    for (loop_index=0;loop_index<global_geometry_list.num_elements;loop_index++) {
        // Add mask list
        if (1 == manual_linking_function(global_geometry_list.elements[loop_index].name,mask_string)) {
            add_element_to_int_list(&this_box_volume.geometry.mask_list,global_geometry_list.elements[loop_index].component_index);
            add_element_to_int_list(&global_geometry_list.elements[loop_index].Volume->geometry.masked_by_list,INDEX_CURRENT_COMP);
            global_geometry_list.elements[loop_index].Volume->geometry.is_masked_volume = 1;
            if (this_box_volume.geometry.mask_mode == 2)
                global_geometry_list.elements[loop_index].Volume->geometry.mask_mode = 2;
            if (this_box_volume.geometry.mask_mode == 1) {
                if (global_geometry_list.elements[loop_index].Volume->geometry.is_masked_volume == 1 && global_geometry_list.elements[loop_index].Volume->geometry.mask_mode != 2)
                    // If more than one mask is added to one volume, the ANY mode overwrites the (default) ALL mode.
                    global_geometry_list.elements[loop_index].Volume->geometry.mask_mode = 1;
            }
            
            found_geometries = 1;
        }
    }
    if (found_geometries == 0) {
        printf("The mask_string in geometry: %s did not find any of the specified volumes in the mask_string %s \n",NAME_CURRENT_COMP,mask_string);
        exit(1);
    }
    this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
    this_box_volume.p_physics->is_vacuum = 0; // Makes this volume a vacuum
    this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
    this_box_volume.p_physics->my_a = 0; // Should not be used.
    sprintf(this_box_volume.p_physics->name,"Mask");
    this_box_volume.geometry.is_mask_volume = 1;
    
    
// Read the material input, or if it lacks, use automatic linking.
} else if (material_string && strlen(material_string) && strcmp(material_string, "NULL") && strcmp(material_string, "0")) {
    // A geometry string was given, use it to determine which material
    if (0 == strcmp(material_string,"vacuum") || 0 == strcmp(material_string,"Vacuum")) {
        // One could have a global physics struct for vacuum instead of creating one for each
        this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
        this_box_volume.p_physics->is_vacuum = 1; // Makes this volume a vacuum
        this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
        this_box_volume.p_physics->my_a = 0; // Should not be used.
        sprintf(this_box_volume.p_physics->name,"Vacuum");
    } else if (0 == strcmp(material_string,"exit") || 0 == strcmp(material_string,"Exit")) {
        // One could have a global physics struct for vacuum instead of creating one for each
        this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
        this_box_volume.p_physics->is_vacuum = 1; // Makes this volume a vacuum
        this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
        this_box_volume.p_physics->my_a = 0; // Should not be used.
        this_box_volume.geometry.is_exit_volume = 1;
        sprintf(this_box_volume.p_physics->name,"Exit");
    } else {
        #ifndef MATERIAL_DETECTOR
            printf("Need to define a material before refering to it in a geometry %s.\n",NAME_CURRENT_COMP);
            exit(1);
        #endif
        for (loop_index=0;loop_index<global_material_list.num_elements;loop_index++) {
            if (0 == strcmp(material_string,global_material_list.elements[loop_index].name)) {
                this_box_volume.p_physics = global_material_list.elements[loop_index].physics;
                break;
            }
            if (loop_index == global_material_list.num_elements-1) {
            printf("\n");
            printf("ERROR: The material string \"%s\" in Union geometry \"%s\" did not match a specified material. \n",material_string,NAME_CURRENT_COMP);
            printf("       The materials available at this point (need to be defined before the geometry): \n");
            for (loop_index=0;loop_index<global_material_list.num_elements;loop_index++)
              printf("         %s\n",global_material_list.elements[loop_index].name);
            printf("\n");
            printf("       It is also possible to use one of the defualt materials avaiable: \n");
            printf("           Vacuum (for a Volume without scattering or absorption)\n");
            printf("           Exit (for a Volume where the ray exits the component if it enters)\n");
            printf("           Mask (for a Volume that masks existing volumes specified in the mask_string\n");
            exit(1);
          }
        }
    }
} else {
    // Automatic linking, simply using the last defined material.
    #ifndef MATERIAL_DETECTOR
        printf("Need to define a material before the geometry to use automatic linking %s.\n",NAME_CURRENT_COMP);
        exit(1);
    #endif
    this_box_volume.p_physics = global_material_list.elements[global_material_list.num_elements-1].physics;
}

sprintf(this_box_volume.name,NAME_CURRENT_COMP);
sprintf(this_box_volume.geometry.shape,"box");
this_box_volume.geometry.priority_value = priority;
this_box_volume.geometry.geometry_p_interact = p_interact;
// Currently the coordinates will be in absolute space.
this_box_volume.geometry.center = POS_A_CURRENT_COMP;

this_box_storage.z_depth = zdepth;
this_box_storage.x_width1 = xwidth;
this_box_storage.y_height1 = yheight;

this_box_storage.is_rectangle = 0;
if (xwidth2 < 0 && yheight2 < 0) this_box_storage.is_rectangle = 1;
if (xwidth == xwidth2 && yheight == yheight2) this_box_storage.is_rectangle = 1;

if (xwidth2 < 0) {
    this_box_storage.x_width2 = xwidth;
    xwidth2 = xwidth;
} else this_box_storage.x_width2 = xwidth2;

if (yheight2 < 0) {
    this_box_storage.y_height2 = yheight;
    yheight2 = yheight;
} else this_box_storage.y_height2 = yheight2;


this_box_storage.normal_vectors[0] = coords_set(0,0,1);
this_box_storage.normal_vectors[1] = coords_set(0,0,1);

// for sides with y component = 0
x_component = 2*zdepth/sqrt((xwidth-xwidth2)*(xwidth-xwidth2)+4*zdepth*zdepth);
z_component = (xwidth-xwidth2)/sqrt(4*zdepth*zdepth+(xwidth-xwidth2)*(xwidth-xwidth2));

this_box_storage.normal_vectors[2] = coords_set(x_component,0,z_component);
this_box_storage.normal_vectors[3] = coords_set(-x_component,0,z_component);

// for sides with x component = 0
y_component = 2*zdepth/sqrt((yheight-yheight2)*(yheight-yheight2)+4*zdepth*zdepth);
z_component = (yheight-yheight2)/sqrt(4*zdepth*zdepth+(yheight-yheight2)*(yheight-yheight2));

this_box_storage.normal_vectors[4] = coords_set(0,y_component,z_component);
this_box_storage.normal_vectors[5] = coords_set(0,-y_component,z_component);

this_box_volume.geometry.visualization_on = visualize;

this_box_volume.geometry.geometry_parameters.p_box_storage = &this_box_storage;

// Assign pointers to functions for intersection with the shape, checking if a point is inside the shape
if (this_box_storage.is_rectangle == 1) {
this_box_volume.geometry.intersect_function = &sample_box_intersect_simple;
this_box_volume.geometry.within_function = &r_within_box_simple;
}
else {
this_box_volume.geometry.intersect_function = &sample_box_intersect_advanced;
this_box_volume.geometry.within_function = &r_within_box_advanced;
}

this_box_volume.geometry.shell_points = &box_shell_points;
this_box_volume.geometry.mcdisplay_function = &mcdisplay_box_function;
this_box_volume.geometry.initialize_from_main_function = &initialize_box_geometry_from_main_component;
this_box_volume.geometry.process_rot_allocated = 0;

this_box_volume.geometry.copy_geometry_parameters = &allocate_box_storage_copy;

rot_copy(this_box_volume.geometry.rotation_matrix,ROT_A_CURRENT_COMP); //check how ROT_R_CURRENT_COMP would work
rot_transpose(ROT_A_CURRENT_COMP,this_box_volume.geometry.transpose_rotation_matrix);

// Initialize loggers
this_box_volume.loggers.num_elements = 0;

// packing the information into the global_geometry_element, which is then included in the global_geometry_list.
sprintf(global_geometry_element.name,NAME_CURRENT_COMP);
global_geometry_element.activation_counter = number_of_activations;
global_geometry_element.component_index = INDEX_CURRENT_COMP;
global_geometry_element.Volume = &this_box_volume; // Would be nicer if this m was a pointer, now we have the (small) data two places
add_element_to_geometry_list(&global_geometry_list,global_geometry_element);
}
#line 168479 "MACS_sample_kidney_box.c"
#undef number_of_activations
#undef mask_setting
#undef mask_string
#undef p_interact
#undef focus_r
#undef focus_xh
#undef focus_xw
#undef focus_ah
#undef focus_aw
#undef target_z
#undef target_y
#undef target_x
#undef target_index
#undef visualize
#undef yheight2
#undef xwidth2
#undef zdepth
#undef yheight
#undef xwidth
#undef priority
#undef material_string
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

  /* Initializations for component channel_0_analyzer_2_array_crystal_array_2. */
  SIG_MESSAGE("channel_0_analyzer_2_array_crystal_array_2 (Init)");
#define mccompcurname  channel_0_analyzer_2_array_crystal_array_2
#define mccompcurtype  Union_box
#define mccompcurindex 143
#define loop_index mccchannel_0_analyzer_2_array_crystal_array_2_loop_index
#define this_box_volume mccchannel_0_analyzer_2_array_crystal_array_2_this_box_volume
#define global_geometry_element mccchannel_0_analyzer_2_array_crystal_array_2_global_geometry_element
#define this_box_storage mccchannel_0_analyzer_2_array_crystal_array_2_this_box_storage
#define material_string mccchannel_0_analyzer_2_array_crystal_array_2_material_string
#define priority mccchannel_0_analyzer_2_array_crystal_array_2_priority
#define xwidth mccchannel_0_analyzer_2_array_crystal_array_2_xwidth
#define yheight mccchannel_0_analyzer_2_array_crystal_array_2_yheight
#define zdepth mccchannel_0_analyzer_2_array_crystal_array_2_zdepth
#define xwidth2 mccchannel_0_analyzer_2_array_crystal_array_2_xwidth2
#define yheight2 mccchannel_0_analyzer_2_array_crystal_array_2_yheight2
#define visualize mccchannel_0_analyzer_2_array_crystal_array_2_visualize
#define target_index mccchannel_0_analyzer_2_array_crystal_array_2_target_index
#define target_x mccchannel_0_analyzer_2_array_crystal_array_2_target_x
#define target_y mccchannel_0_analyzer_2_array_crystal_array_2_target_y
#define target_z mccchannel_0_analyzer_2_array_crystal_array_2_target_z
#define focus_aw mccchannel_0_analyzer_2_array_crystal_array_2_focus_aw
#define focus_ah mccchannel_0_analyzer_2_array_crystal_array_2_focus_ah
#define focus_xw mccchannel_0_analyzer_2_array_crystal_array_2_focus_xw
#define focus_xh mccchannel_0_analyzer_2_array_crystal_array_2_focus_xh
#define focus_r mccchannel_0_analyzer_2_array_crystal_array_2_focus_r
#define p_interact mccchannel_0_analyzer_2_array_crystal_array_2_p_interact
#define mask_string mccchannel_0_analyzer_2_array_crystal_array_2_mask_string
#define mask_setting mccchannel_0_analyzer_2_array_crystal_array_2_mask_setting
#define number_of_activations mccchannel_0_analyzer_2_array_crystal_array_2_number_of_activations
#line 224 "Union_box.comp"
{
// Initializes the focusing system for this volume including input sanitation.
focus_initialize(&this_box_volume.geometry, POS_A_COMP_INDEX(INDEX_CURRENT_COMP+target_index), POS_A_CURRENT_COMP, ROT_A_CURRENT_COMP, target_index, target_x, target_y, target_z, focus_aw, focus_ah, focus_xw, focus_xh, focus_r, NAME_CURRENT_COMP);

// Input sanitation for this geometry
if (xwidth <= 0) {
  printf("\nERROR in Union_box named %s, the xwidth is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (yheight <= 0) {
  printf("\nERROR in Union_box named %s, yheight is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (zdepth <= 0) {
  printf("\nERROR in Union_box named %s, zdepth is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (xwidth2 <= 0 && xwidth2 != -1) {
  printf("\nERROR in Union_box named %s, the xwidth2 is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (yheight2 <= 0 && yheight2 != -1) {
  printf("\nERROR in Union_box named %s, yheight2 is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}

// Use sanitation
if (global_material_list.num_elements == 0) {
  printf("\nERROR: Need to define a material using Union_make_material before using a Union geometry component. \n");
  printf("       %s was defined before first use of Union_make_material.\n",NAME_CURRENT_COMP);
  exit(1);
}

this_box_volume.geometry.is_masked_volume = 0;
this_box_volume.geometry.is_exit_volume = 0;
this_box_volume.geometry.is_mask_volume = 0;
// check if the volume is a mask, if it is the material string is irelevant.
if (mask_string && strlen(mask_string) && strcmp(mask_string, "NULL") && strcmp(mask_string, "0")) {
    // A mask volume is used to limit the extend of other volumes, called the masked volumes. These are specified in the mask_string.
    // In order for a ray to enter a masked volume, it needs to be both in the region covered by that volume AND the mask volume.
    // When more than
    this_box_volume.geometry.mask_mode = 1; // Default is mask mode is ALL
    if (mask_setting && strlen(mask_setting) && strcmp(mask_setting, "NULL") && strcmp(mask_setting, "0")) {
        if (strcmp(mask_setting,"ALL") == 0 || strcmp(mask_setting,"All") == 0) this_box_volume.geometry.mask_mode = 1;
        else if (strcmp(mask_setting,"ANY") == 0 || strcmp(mask_setting,"Any") == 0) this_box_volume.geometry.mask_mode = 2;
        else {
            printf("The mask_mode of component %s is set to %s, but must be either ALL or ANY.\n",NAME_CURRENT_COMP,mask_setting);
            exit(1);
        }
    }
    
    for (loop_index=0;loop_index<global_geometry_list.num_elements;loop_index++) {
        // Add mask list
        if (1 == manual_linking_function(global_geometry_list.elements[loop_index].name,mask_string)) {
            add_element_to_int_list(&this_box_volume.geometry.mask_list,global_geometry_list.elements[loop_index].component_index);
            add_element_to_int_list(&global_geometry_list.elements[loop_index].Volume->geometry.masked_by_list,INDEX_CURRENT_COMP);
            global_geometry_list.elements[loop_index].Volume->geometry.is_masked_volume = 1;
            if (this_box_volume.geometry.mask_mode == 2)
                global_geometry_list.elements[loop_index].Volume->geometry.mask_mode = 2;
            if (this_box_volume.geometry.mask_mode == 1) {
                if (global_geometry_list.elements[loop_index].Volume->geometry.is_masked_volume == 1 && global_geometry_list.elements[loop_index].Volume->geometry.mask_mode != 2)
                    // If more than one mask is added to one volume, the ANY mode overwrites the (default) ALL mode.
                    global_geometry_list.elements[loop_index].Volume->geometry.mask_mode = 1;
            }
            
            found_geometries = 1;
        }
    }
    if (found_geometries == 0) {
        printf("The mask_string in geometry: %s did not find any of the specified volumes in the mask_string %s \n",NAME_CURRENT_COMP,mask_string);
        exit(1);
    }
    this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
    this_box_volume.p_physics->is_vacuum = 0; // Makes this volume a vacuum
    this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
    this_box_volume.p_physics->my_a = 0; // Should not be used.
    sprintf(this_box_volume.p_physics->name,"Mask");
    this_box_volume.geometry.is_mask_volume = 1;
    
    
// Read the material input, or if it lacks, use automatic linking.
} else if (material_string && strlen(material_string) && strcmp(material_string, "NULL") && strcmp(material_string, "0")) {
    // A geometry string was given, use it to determine which material
    if (0 == strcmp(material_string,"vacuum") || 0 == strcmp(material_string,"Vacuum")) {
        // One could have a global physics struct for vacuum instead of creating one for each
        this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
        this_box_volume.p_physics->is_vacuum = 1; // Makes this volume a vacuum
        this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
        this_box_volume.p_physics->my_a = 0; // Should not be used.
        sprintf(this_box_volume.p_physics->name,"Vacuum");
    } else if (0 == strcmp(material_string,"exit") || 0 == strcmp(material_string,"Exit")) {
        // One could have a global physics struct for vacuum instead of creating one for each
        this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
        this_box_volume.p_physics->is_vacuum = 1; // Makes this volume a vacuum
        this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
        this_box_volume.p_physics->my_a = 0; // Should not be used.
        this_box_volume.geometry.is_exit_volume = 1;
        sprintf(this_box_volume.p_physics->name,"Exit");
    } else {
        #ifndef MATERIAL_DETECTOR
            printf("Need to define a material before refering to it in a geometry %s.\n",NAME_CURRENT_COMP);
            exit(1);
        #endif
        for (loop_index=0;loop_index<global_material_list.num_elements;loop_index++) {
            if (0 == strcmp(material_string,global_material_list.elements[loop_index].name)) {
                this_box_volume.p_physics = global_material_list.elements[loop_index].physics;
                break;
            }
            if (loop_index == global_material_list.num_elements-1) {
            printf("\n");
            printf("ERROR: The material string \"%s\" in Union geometry \"%s\" did not match a specified material. \n",material_string,NAME_CURRENT_COMP);
            printf("       The materials available at this point (need to be defined before the geometry): \n");
            for (loop_index=0;loop_index<global_material_list.num_elements;loop_index++)
              printf("         %s\n",global_material_list.elements[loop_index].name);
            printf("\n");
            printf("       It is also possible to use one of the defualt materials avaiable: \n");
            printf("           Vacuum (for a Volume without scattering or absorption)\n");
            printf("           Exit (for a Volume where the ray exits the component if it enters)\n");
            printf("           Mask (for a Volume that masks existing volumes specified in the mask_string\n");
            exit(1);
          }
        }
    }
} else {
    // Automatic linking, simply using the last defined material.
    #ifndef MATERIAL_DETECTOR
        printf("Need to define a material before the geometry to use automatic linking %s.\n",NAME_CURRENT_COMP);
        exit(1);
    #endif
    this_box_volume.p_physics = global_material_list.elements[global_material_list.num_elements-1].physics;
}

sprintf(this_box_volume.name,NAME_CURRENT_COMP);
sprintf(this_box_volume.geometry.shape,"box");
this_box_volume.geometry.priority_value = priority;
this_box_volume.geometry.geometry_p_interact = p_interact;
// Currently the coordinates will be in absolute space.
this_box_volume.geometry.center = POS_A_CURRENT_COMP;

this_box_storage.z_depth = zdepth;
this_box_storage.x_width1 = xwidth;
this_box_storage.y_height1 = yheight;

this_box_storage.is_rectangle = 0;
if (xwidth2 < 0 && yheight2 < 0) this_box_storage.is_rectangle = 1;
if (xwidth == xwidth2 && yheight == yheight2) this_box_storage.is_rectangle = 1;

if (xwidth2 < 0) {
    this_box_storage.x_width2 = xwidth;
    xwidth2 = xwidth;
} else this_box_storage.x_width2 = xwidth2;

if (yheight2 < 0) {
    this_box_storage.y_height2 = yheight;
    yheight2 = yheight;
} else this_box_storage.y_height2 = yheight2;


this_box_storage.normal_vectors[0] = coords_set(0,0,1);
this_box_storage.normal_vectors[1] = coords_set(0,0,1);

// for sides with y component = 0
x_component = 2*zdepth/sqrt((xwidth-xwidth2)*(xwidth-xwidth2)+4*zdepth*zdepth);
z_component = (xwidth-xwidth2)/sqrt(4*zdepth*zdepth+(xwidth-xwidth2)*(xwidth-xwidth2));

this_box_storage.normal_vectors[2] = coords_set(x_component,0,z_component);
this_box_storage.normal_vectors[3] = coords_set(-x_component,0,z_component);

// for sides with x component = 0
y_component = 2*zdepth/sqrt((yheight-yheight2)*(yheight-yheight2)+4*zdepth*zdepth);
z_component = (yheight-yheight2)/sqrt(4*zdepth*zdepth+(yheight-yheight2)*(yheight-yheight2));

this_box_storage.normal_vectors[4] = coords_set(0,y_component,z_component);
this_box_storage.normal_vectors[5] = coords_set(0,-y_component,z_component);

this_box_volume.geometry.visualization_on = visualize;

this_box_volume.geometry.geometry_parameters.p_box_storage = &this_box_storage;

// Assign pointers to functions for intersection with the shape, checking if a point is inside the shape
if (this_box_storage.is_rectangle == 1) {
this_box_volume.geometry.intersect_function = &sample_box_intersect_simple;
this_box_volume.geometry.within_function = &r_within_box_simple;
}
else {
this_box_volume.geometry.intersect_function = &sample_box_intersect_advanced;
this_box_volume.geometry.within_function = &r_within_box_advanced;
}

this_box_volume.geometry.shell_points = &box_shell_points;
this_box_volume.geometry.mcdisplay_function = &mcdisplay_box_function;
this_box_volume.geometry.initialize_from_main_function = &initialize_box_geometry_from_main_component;
this_box_volume.geometry.process_rot_allocated = 0;

this_box_volume.geometry.copy_geometry_parameters = &allocate_box_storage_copy;

rot_copy(this_box_volume.geometry.rotation_matrix,ROT_A_CURRENT_COMP); //check how ROT_R_CURRENT_COMP would work
rot_transpose(ROT_A_CURRENT_COMP,this_box_volume.geometry.transpose_rotation_matrix);

// Initialize loggers
this_box_volume.loggers.num_elements = 0;

// packing the information into the global_geometry_element, which is then included in the global_geometry_list.
sprintf(global_geometry_element.name,NAME_CURRENT_COMP);
global_geometry_element.activation_counter = number_of_activations;
global_geometry_element.component_index = INDEX_CURRENT_COMP;
global_geometry_element.Volume = &this_box_volume; // Would be nicer if this m was a pointer, now we have the (small) data two places
add_element_to_geometry_list(&global_geometry_list,global_geometry_element);
}
#line 168749 "MACS_sample_kidney_box.c"
#undef number_of_activations
#undef mask_setting
#undef mask_string
#undef p_interact
#undef focus_r
#undef focus_xh
#undef focus_xw
#undef focus_ah
#undef focus_aw
#undef target_z
#undef target_y
#undef target_x
#undef target_index
#undef visualize
#undef yheight2
#undef xwidth2
#undef zdepth
#undef yheight
#undef xwidth
#undef priority
#undef material_string
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

  /* Initializations for component channel_0_analyzer_2_array_crystal_array_3. */
  SIG_MESSAGE("channel_0_analyzer_2_array_crystal_array_3 (Init)");
#define mccompcurname  channel_0_analyzer_2_array_crystal_array_3
#define mccompcurtype  Union_box
#define mccompcurindex 144
#define loop_index mccchannel_0_analyzer_2_array_crystal_array_3_loop_index
#define this_box_volume mccchannel_0_analyzer_2_array_crystal_array_3_this_box_volume
#define global_geometry_element mccchannel_0_analyzer_2_array_crystal_array_3_global_geometry_element
#define this_box_storage mccchannel_0_analyzer_2_array_crystal_array_3_this_box_storage
#define material_string mccchannel_0_analyzer_2_array_crystal_array_3_material_string
#define priority mccchannel_0_analyzer_2_array_crystal_array_3_priority
#define xwidth mccchannel_0_analyzer_2_array_crystal_array_3_xwidth
#define yheight mccchannel_0_analyzer_2_array_crystal_array_3_yheight
#define zdepth mccchannel_0_analyzer_2_array_crystal_array_3_zdepth
#define xwidth2 mccchannel_0_analyzer_2_array_crystal_array_3_xwidth2
#define yheight2 mccchannel_0_analyzer_2_array_crystal_array_3_yheight2
#define visualize mccchannel_0_analyzer_2_array_crystal_array_3_visualize
#define target_index mccchannel_0_analyzer_2_array_crystal_array_3_target_index
#define target_x mccchannel_0_analyzer_2_array_crystal_array_3_target_x
#define target_y mccchannel_0_analyzer_2_array_crystal_array_3_target_y
#define target_z mccchannel_0_analyzer_2_array_crystal_array_3_target_z
#define focus_aw mccchannel_0_analyzer_2_array_crystal_array_3_focus_aw
#define focus_ah mccchannel_0_analyzer_2_array_crystal_array_3_focus_ah
#define focus_xw mccchannel_0_analyzer_2_array_crystal_array_3_focus_xw
#define focus_xh mccchannel_0_analyzer_2_array_crystal_array_3_focus_xh
#define focus_r mccchannel_0_analyzer_2_array_crystal_array_3_focus_r
#define p_interact mccchannel_0_analyzer_2_array_crystal_array_3_p_interact
#define mask_string mccchannel_0_analyzer_2_array_crystal_array_3_mask_string
#define mask_setting mccchannel_0_analyzer_2_array_crystal_array_3_mask_setting
#define number_of_activations mccchannel_0_analyzer_2_array_crystal_array_3_number_of_activations
#line 224 "Union_box.comp"
{
// Initializes the focusing system for this volume including input sanitation.
focus_initialize(&this_box_volume.geometry, POS_A_COMP_INDEX(INDEX_CURRENT_COMP+target_index), POS_A_CURRENT_COMP, ROT_A_CURRENT_COMP, target_index, target_x, target_y, target_z, focus_aw, focus_ah, focus_xw, focus_xh, focus_r, NAME_CURRENT_COMP);

// Input sanitation for this geometry
if (xwidth <= 0) {
  printf("\nERROR in Union_box named %s, the xwidth is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (yheight <= 0) {
  printf("\nERROR in Union_box named %s, yheight is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (zdepth <= 0) {
  printf("\nERROR in Union_box named %s, zdepth is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (xwidth2 <= 0 && xwidth2 != -1) {
  printf("\nERROR in Union_box named %s, the xwidth2 is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (yheight2 <= 0 && yheight2 != -1) {
  printf("\nERROR in Union_box named %s, yheight2 is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}

// Use sanitation
if (global_material_list.num_elements == 0) {
  printf("\nERROR: Need to define a material using Union_make_material before using a Union geometry component. \n");
  printf("       %s was defined before first use of Union_make_material.\n",NAME_CURRENT_COMP);
  exit(1);
}

this_box_volume.geometry.is_masked_volume = 0;
this_box_volume.geometry.is_exit_volume = 0;
this_box_volume.geometry.is_mask_volume = 0;
// check if the volume is a mask, if it is the material string is irelevant.
if (mask_string && strlen(mask_string) && strcmp(mask_string, "NULL") && strcmp(mask_string, "0")) {
    // A mask volume is used to limit the extend of other volumes, called the masked volumes. These are specified in the mask_string.
    // In order for a ray to enter a masked volume, it needs to be both in the region covered by that volume AND the mask volume.
    // When more than
    this_box_volume.geometry.mask_mode = 1; // Default is mask mode is ALL
    if (mask_setting && strlen(mask_setting) && strcmp(mask_setting, "NULL") && strcmp(mask_setting, "0")) {
        if (strcmp(mask_setting,"ALL") == 0 || strcmp(mask_setting,"All") == 0) this_box_volume.geometry.mask_mode = 1;
        else if (strcmp(mask_setting,"ANY") == 0 || strcmp(mask_setting,"Any") == 0) this_box_volume.geometry.mask_mode = 2;
        else {
            printf("The mask_mode of component %s is set to %s, but must be either ALL or ANY.\n",NAME_CURRENT_COMP,mask_setting);
            exit(1);
        }
    }
    
    for (loop_index=0;loop_index<global_geometry_list.num_elements;loop_index++) {
        // Add mask list
        if (1 == manual_linking_function(global_geometry_list.elements[loop_index].name,mask_string)) {
            add_element_to_int_list(&this_box_volume.geometry.mask_list,global_geometry_list.elements[loop_index].component_index);
            add_element_to_int_list(&global_geometry_list.elements[loop_index].Volume->geometry.masked_by_list,INDEX_CURRENT_COMP);
            global_geometry_list.elements[loop_index].Volume->geometry.is_masked_volume = 1;
            if (this_box_volume.geometry.mask_mode == 2)
                global_geometry_list.elements[loop_index].Volume->geometry.mask_mode = 2;
            if (this_box_volume.geometry.mask_mode == 1) {
                if (global_geometry_list.elements[loop_index].Volume->geometry.is_masked_volume == 1 && global_geometry_list.elements[loop_index].Volume->geometry.mask_mode != 2)
                    // If more than one mask is added to one volume, the ANY mode overwrites the (default) ALL mode.
                    global_geometry_list.elements[loop_index].Volume->geometry.mask_mode = 1;
            }
            
            found_geometries = 1;
        }
    }
    if (found_geometries == 0) {
        printf("The mask_string in geometry: %s did not find any of the specified volumes in the mask_string %s \n",NAME_CURRENT_COMP,mask_string);
        exit(1);
    }
    this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
    this_box_volume.p_physics->is_vacuum = 0; // Makes this volume a vacuum
    this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
    this_box_volume.p_physics->my_a = 0; // Should not be used.
    sprintf(this_box_volume.p_physics->name,"Mask");
    this_box_volume.geometry.is_mask_volume = 1;
    
    
// Read the material input, or if it lacks, use automatic linking.
} else if (material_string && strlen(material_string) && strcmp(material_string, "NULL") && strcmp(material_string, "0")) {
    // A geometry string was given, use it to determine which material
    if (0 == strcmp(material_string,"vacuum") || 0 == strcmp(material_string,"Vacuum")) {
        // One could have a global physics struct for vacuum instead of creating one for each
        this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
        this_box_volume.p_physics->is_vacuum = 1; // Makes this volume a vacuum
        this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
        this_box_volume.p_physics->my_a = 0; // Should not be used.
        sprintf(this_box_volume.p_physics->name,"Vacuum");
    } else if (0 == strcmp(material_string,"exit") || 0 == strcmp(material_string,"Exit")) {
        // One could have a global physics struct for vacuum instead of creating one for each
        this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
        this_box_volume.p_physics->is_vacuum = 1; // Makes this volume a vacuum
        this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
        this_box_volume.p_physics->my_a = 0; // Should not be used.
        this_box_volume.geometry.is_exit_volume = 1;
        sprintf(this_box_volume.p_physics->name,"Exit");
    } else {
        #ifndef MATERIAL_DETECTOR
            printf("Need to define a material before refering to it in a geometry %s.\n",NAME_CURRENT_COMP);
            exit(1);
        #endif
        for (loop_index=0;loop_index<global_material_list.num_elements;loop_index++) {
            if (0 == strcmp(material_string,global_material_list.elements[loop_index].name)) {
                this_box_volume.p_physics = global_material_list.elements[loop_index].physics;
                break;
            }
            if (loop_index == global_material_list.num_elements-1) {
            printf("\n");
            printf("ERROR: The material string \"%s\" in Union geometry \"%s\" did not match a specified material. \n",material_string,NAME_CURRENT_COMP);
            printf("       The materials available at this point (need to be defined before the geometry): \n");
            for (loop_index=0;loop_index<global_material_list.num_elements;loop_index++)
              printf("         %s\n",global_material_list.elements[loop_index].name);
            printf("\n");
            printf("       It is also possible to use one of the defualt materials avaiable: \n");
            printf("           Vacuum (for a Volume without scattering or absorption)\n");
            printf("           Exit (for a Volume where the ray exits the component if it enters)\n");
            printf("           Mask (for a Volume that masks existing volumes specified in the mask_string\n");
            exit(1);
          }
        }
    }
} else {
    // Automatic linking, simply using the last defined material.
    #ifndef MATERIAL_DETECTOR
        printf("Need to define a material before the geometry to use automatic linking %s.\n",NAME_CURRENT_COMP);
        exit(1);
    #endif
    this_box_volume.p_physics = global_material_list.elements[global_material_list.num_elements-1].physics;
}

sprintf(this_box_volume.name,NAME_CURRENT_COMP);
sprintf(this_box_volume.geometry.shape,"box");
this_box_volume.geometry.priority_value = priority;
this_box_volume.geometry.geometry_p_interact = p_interact;
// Currently the coordinates will be in absolute space.
this_box_volume.geometry.center = POS_A_CURRENT_COMP;

this_box_storage.z_depth = zdepth;
this_box_storage.x_width1 = xwidth;
this_box_storage.y_height1 = yheight;

this_box_storage.is_rectangle = 0;
if (xwidth2 < 0 && yheight2 < 0) this_box_storage.is_rectangle = 1;
if (xwidth == xwidth2 && yheight == yheight2) this_box_storage.is_rectangle = 1;

if (xwidth2 < 0) {
    this_box_storage.x_width2 = xwidth;
    xwidth2 = xwidth;
} else this_box_storage.x_width2 = xwidth2;

if (yheight2 < 0) {
    this_box_storage.y_height2 = yheight;
    yheight2 = yheight;
} else this_box_storage.y_height2 = yheight2;


this_box_storage.normal_vectors[0] = coords_set(0,0,1);
this_box_storage.normal_vectors[1] = coords_set(0,0,1);

// for sides with y component = 0
x_component = 2*zdepth/sqrt((xwidth-xwidth2)*(xwidth-xwidth2)+4*zdepth*zdepth);
z_component = (xwidth-xwidth2)/sqrt(4*zdepth*zdepth+(xwidth-xwidth2)*(xwidth-xwidth2));

this_box_storage.normal_vectors[2] = coords_set(x_component,0,z_component);
this_box_storage.normal_vectors[3] = coords_set(-x_component,0,z_component);

// for sides with x component = 0
y_component = 2*zdepth/sqrt((yheight-yheight2)*(yheight-yheight2)+4*zdepth*zdepth);
z_component = (yheight-yheight2)/sqrt(4*zdepth*zdepth+(yheight-yheight2)*(yheight-yheight2));

this_box_storage.normal_vectors[4] = coords_set(0,y_component,z_component);
this_box_storage.normal_vectors[5] = coords_set(0,-y_component,z_component);

this_box_volume.geometry.visualization_on = visualize;

this_box_volume.geometry.geometry_parameters.p_box_storage = &this_box_storage;

// Assign pointers to functions for intersection with the shape, checking if a point is inside the shape
if (this_box_storage.is_rectangle == 1) {
this_box_volume.geometry.intersect_function = &sample_box_intersect_simple;
this_box_volume.geometry.within_function = &r_within_box_simple;
}
else {
this_box_volume.geometry.intersect_function = &sample_box_intersect_advanced;
this_box_volume.geometry.within_function = &r_within_box_advanced;
}

this_box_volume.geometry.shell_points = &box_shell_points;
this_box_volume.geometry.mcdisplay_function = &mcdisplay_box_function;
this_box_volume.geometry.initialize_from_main_function = &initialize_box_geometry_from_main_component;
this_box_volume.geometry.process_rot_allocated = 0;

this_box_volume.geometry.copy_geometry_parameters = &allocate_box_storage_copy;

rot_copy(this_box_volume.geometry.rotation_matrix,ROT_A_CURRENT_COMP); //check how ROT_R_CURRENT_COMP would work
rot_transpose(ROT_A_CURRENT_COMP,this_box_volume.geometry.transpose_rotation_matrix);

// Initialize loggers
this_box_volume.loggers.num_elements = 0;

// packing the information into the global_geometry_element, which is then included in the global_geometry_list.
sprintf(global_geometry_element.name,NAME_CURRENT_COMP);
global_geometry_element.activation_counter = number_of_activations;
global_geometry_element.component_index = INDEX_CURRENT_COMP;
global_geometry_element.Volume = &this_box_volume; // Would be nicer if this m was a pointer, now we have the (small) data two places
add_element_to_geometry_list(&global_geometry_list,global_geometry_element);
}
#line 169019 "MACS_sample_kidney_box.c"
#undef number_of_activations
#undef mask_setting
#undef mask_string
#undef p_interact
#undef focus_r
#undef focus_xh
#undef focus_xw
#undef focus_ah
#undef focus_aw
#undef target_z
#undef target_y
#undef target_x
#undef target_index
#undef visualize
#undef yheight2
#undef xwidth2
#undef zdepth
#undef yheight
#undef xwidth
#undef priority
#undef material_string
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

  /* Initializations for component channel_0_analyzer_2_array_crystal_array_4. */
  SIG_MESSAGE("channel_0_analyzer_2_array_crystal_array_4 (Init)");
#define mccompcurname  channel_0_analyzer_2_array_crystal_array_4
#define mccompcurtype  Union_box
#define mccompcurindex 145
#define loop_index mccchannel_0_analyzer_2_array_crystal_array_4_loop_index
#define this_box_volume mccchannel_0_analyzer_2_array_crystal_array_4_this_box_volume
#define global_geometry_element mccchannel_0_analyzer_2_array_crystal_array_4_global_geometry_element
#define this_box_storage mccchannel_0_analyzer_2_array_crystal_array_4_this_box_storage
#define material_string mccchannel_0_analyzer_2_array_crystal_array_4_material_string
#define priority mccchannel_0_analyzer_2_array_crystal_array_4_priority
#define xwidth mccchannel_0_analyzer_2_array_crystal_array_4_xwidth
#define yheight mccchannel_0_analyzer_2_array_crystal_array_4_yheight
#define zdepth mccchannel_0_analyzer_2_array_crystal_array_4_zdepth
#define xwidth2 mccchannel_0_analyzer_2_array_crystal_array_4_xwidth2
#define yheight2 mccchannel_0_analyzer_2_array_crystal_array_4_yheight2
#define visualize mccchannel_0_analyzer_2_array_crystal_array_4_visualize
#define target_index mccchannel_0_analyzer_2_array_crystal_array_4_target_index
#define target_x mccchannel_0_analyzer_2_array_crystal_array_4_target_x
#define target_y mccchannel_0_analyzer_2_array_crystal_array_4_target_y
#define target_z mccchannel_0_analyzer_2_array_crystal_array_4_target_z
#define focus_aw mccchannel_0_analyzer_2_array_crystal_array_4_focus_aw
#define focus_ah mccchannel_0_analyzer_2_array_crystal_array_4_focus_ah
#define focus_xw mccchannel_0_analyzer_2_array_crystal_array_4_focus_xw
#define focus_xh mccchannel_0_analyzer_2_array_crystal_array_4_focus_xh
#define focus_r mccchannel_0_analyzer_2_array_crystal_array_4_focus_r
#define p_interact mccchannel_0_analyzer_2_array_crystal_array_4_p_interact
#define mask_string mccchannel_0_analyzer_2_array_crystal_array_4_mask_string
#define mask_setting mccchannel_0_analyzer_2_array_crystal_array_4_mask_setting
#define number_of_activations mccchannel_0_analyzer_2_array_crystal_array_4_number_of_activations
#line 224 "Union_box.comp"
{
// Initializes the focusing system for this volume including input sanitation.
focus_initialize(&this_box_volume.geometry, POS_A_COMP_INDEX(INDEX_CURRENT_COMP+target_index), POS_A_CURRENT_COMP, ROT_A_CURRENT_COMP, target_index, target_x, target_y, target_z, focus_aw, focus_ah, focus_xw, focus_xh, focus_r, NAME_CURRENT_COMP);

// Input sanitation for this geometry
if (xwidth <= 0) {
  printf("\nERROR in Union_box named %s, the xwidth is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (yheight <= 0) {
  printf("\nERROR in Union_box named %s, yheight is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (zdepth <= 0) {
  printf("\nERROR in Union_box named %s, zdepth is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (xwidth2 <= 0 && xwidth2 != -1) {
  printf("\nERROR in Union_box named %s, the xwidth2 is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (yheight2 <= 0 && yheight2 != -1) {
  printf("\nERROR in Union_box named %s, yheight2 is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}

// Use sanitation
if (global_material_list.num_elements == 0) {
  printf("\nERROR: Need to define a material using Union_make_material before using a Union geometry component. \n");
  printf("       %s was defined before first use of Union_make_material.\n",NAME_CURRENT_COMP);
  exit(1);
}

this_box_volume.geometry.is_masked_volume = 0;
this_box_volume.geometry.is_exit_volume = 0;
this_box_volume.geometry.is_mask_volume = 0;
// check if the volume is a mask, if it is the material string is irelevant.
if (mask_string && strlen(mask_string) && strcmp(mask_string, "NULL") && strcmp(mask_string, "0")) {
    // A mask volume is used to limit the extend of other volumes, called the masked volumes. These are specified in the mask_string.
    // In order for a ray to enter a masked volume, it needs to be both in the region covered by that volume AND the mask volume.
    // When more than
    this_box_volume.geometry.mask_mode = 1; // Default is mask mode is ALL
    if (mask_setting && strlen(mask_setting) && strcmp(mask_setting, "NULL") && strcmp(mask_setting, "0")) {
        if (strcmp(mask_setting,"ALL") == 0 || strcmp(mask_setting,"All") == 0) this_box_volume.geometry.mask_mode = 1;
        else if (strcmp(mask_setting,"ANY") == 0 || strcmp(mask_setting,"Any") == 0) this_box_volume.geometry.mask_mode = 2;
        else {
            printf("The mask_mode of component %s is set to %s, but must be either ALL or ANY.\n",NAME_CURRENT_COMP,mask_setting);
            exit(1);
        }
    }
    
    for (loop_index=0;loop_index<global_geometry_list.num_elements;loop_index++) {
        // Add mask list
        if (1 == manual_linking_function(global_geometry_list.elements[loop_index].name,mask_string)) {
            add_element_to_int_list(&this_box_volume.geometry.mask_list,global_geometry_list.elements[loop_index].component_index);
            add_element_to_int_list(&global_geometry_list.elements[loop_index].Volume->geometry.masked_by_list,INDEX_CURRENT_COMP);
            global_geometry_list.elements[loop_index].Volume->geometry.is_masked_volume = 1;
            if (this_box_volume.geometry.mask_mode == 2)
                global_geometry_list.elements[loop_index].Volume->geometry.mask_mode = 2;
            if (this_box_volume.geometry.mask_mode == 1) {
                if (global_geometry_list.elements[loop_index].Volume->geometry.is_masked_volume == 1 && global_geometry_list.elements[loop_index].Volume->geometry.mask_mode != 2)
                    // If more than one mask is added to one volume, the ANY mode overwrites the (default) ALL mode.
                    global_geometry_list.elements[loop_index].Volume->geometry.mask_mode = 1;
            }
            
            found_geometries = 1;
        }
    }
    if (found_geometries == 0) {
        printf("The mask_string in geometry: %s did not find any of the specified volumes in the mask_string %s \n",NAME_CURRENT_COMP,mask_string);
        exit(1);
    }
    this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
    this_box_volume.p_physics->is_vacuum = 0; // Makes this volume a vacuum
    this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
    this_box_volume.p_physics->my_a = 0; // Should not be used.
    sprintf(this_box_volume.p_physics->name,"Mask");
    this_box_volume.geometry.is_mask_volume = 1;
    
    
// Read the material input, or if it lacks, use automatic linking.
} else if (material_string && strlen(material_string) && strcmp(material_string, "NULL") && strcmp(material_string, "0")) {
    // A geometry string was given, use it to determine which material
    if (0 == strcmp(material_string,"vacuum") || 0 == strcmp(material_string,"Vacuum")) {
        // One could have a global physics struct for vacuum instead of creating one for each
        this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
        this_box_volume.p_physics->is_vacuum = 1; // Makes this volume a vacuum
        this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
        this_box_volume.p_physics->my_a = 0; // Should not be used.
        sprintf(this_box_volume.p_physics->name,"Vacuum");
    } else if (0 == strcmp(material_string,"exit") || 0 == strcmp(material_string,"Exit")) {
        // One could have a global physics struct for vacuum instead of creating one for each
        this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
        this_box_volume.p_physics->is_vacuum = 1; // Makes this volume a vacuum
        this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
        this_box_volume.p_physics->my_a = 0; // Should not be used.
        this_box_volume.geometry.is_exit_volume = 1;
        sprintf(this_box_volume.p_physics->name,"Exit");
    } else {
        #ifndef MATERIAL_DETECTOR
            printf("Need to define a material before refering to it in a geometry %s.\n",NAME_CURRENT_COMP);
            exit(1);
        #endif
        for (loop_index=0;loop_index<global_material_list.num_elements;loop_index++) {
            if (0 == strcmp(material_string,global_material_list.elements[loop_index].name)) {
                this_box_volume.p_physics = global_material_list.elements[loop_index].physics;
                break;
            }
            if (loop_index == global_material_list.num_elements-1) {
            printf("\n");
            printf("ERROR: The material string \"%s\" in Union geometry \"%s\" did not match a specified material. \n",material_string,NAME_CURRENT_COMP);
            printf("       The materials available at this point (need to be defined before the geometry): \n");
            for (loop_index=0;loop_index<global_material_list.num_elements;loop_index++)
              printf("         %s\n",global_material_list.elements[loop_index].name);
            printf("\n");
            printf("       It is also possible to use one of the defualt materials avaiable: \n");
            printf("           Vacuum (for a Volume without scattering or absorption)\n");
            printf("           Exit (for a Volume where the ray exits the component if it enters)\n");
            printf("           Mask (for a Volume that masks existing volumes specified in the mask_string\n");
            exit(1);
          }
        }
    }
} else {
    // Automatic linking, simply using the last defined material.
    #ifndef MATERIAL_DETECTOR
        printf("Need to define a material before the geometry to use automatic linking %s.\n",NAME_CURRENT_COMP);
        exit(1);
    #endif
    this_box_volume.p_physics = global_material_list.elements[global_material_list.num_elements-1].physics;
}

sprintf(this_box_volume.name,NAME_CURRENT_COMP);
sprintf(this_box_volume.geometry.shape,"box");
this_box_volume.geometry.priority_value = priority;
this_box_volume.geometry.geometry_p_interact = p_interact;
// Currently the coordinates will be in absolute space.
this_box_volume.geometry.center = POS_A_CURRENT_COMP;

this_box_storage.z_depth = zdepth;
this_box_storage.x_width1 = xwidth;
this_box_storage.y_height1 = yheight;

this_box_storage.is_rectangle = 0;
if (xwidth2 < 0 && yheight2 < 0) this_box_storage.is_rectangle = 1;
if (xwidth == xwidth2 && yheight == yheight2) this_box_storage.is_rectangle = 1;

if (xwidth2 < 0) {
    this_box_storage.x_width2 = xwidth;
    xwidth2 = xwidth;
} else this_box_storage.x_width2 = xwidth2;

if (yheight2 < 0) {
    this_box_storage.y_height2 = yheight;
    yheight2 = yheight;
} else this_box_storage.y_height2 = yheight2;


this_box_storage.normal_vectors[0] = coords_set(0,0,1);
this_box_storage.normal_vectors[1] = coords_set(0,0,1);

// for sides with y component = 0
x_component = 2*zdepth/sqrt((xwidth-xwidth2)*(xwidth-xwidth2)+4*zdepth*zdepth);
z_component = (xwidth-xwidth2)/sqrt(4*zdepth*zdepth+(xwidth-xwidth2)*(xwidth-xwidth2));

this_box_storage.normal_vectors[2] = coords_set(x_component,0,z_component);
this_box_storage.normal_vectors[3] = coords_set(-x_component,0,z_component);

// for sides with x component = 0
y_component = 2*zdepth/sqrt((yheight-yheight2)*(yheight-yheight2)+4*zdepth*zdepth);
z_component = (yheight-yheight2)/sqrt(4*zdepth*zdepth+(yheight-yheight2)*(yheight-yheight2));

this_box_storage.normal_vectors[4] = coords_set(0,y_component,z_component);
this_box_storage.normal_vectors[5] = coords_set(0,-y_component,z_component);

this_box_volume.geometry.visualization_on = visualize;

this_box_volume.geometry.geometry_parameters.p_box_storage = &this_box_storage;

// Assign pointers to functions for intersection with the shape, checking if a point is inside the shape
if (this_box_storage.is_rectangle == 1) {
this_box_volume.geometry.intersect_function = &sample_box_intersect_simple;
this_box_volume.geometry.within_function = &r_within_box_simple;
}
else {
this_box_volume.geometry.intersect_function = &sample_box_intersect_advanced;
this_box_volume.geometry.within_function = &r_within_box_advanced;
}

this_box_volume.geometry.shell_points = &box_shell_points;
this_box_volume.geometry.mcdisplay_function = &mcdisplay_box_function;
this_box_volume.geometry.initialize_from_main_function = &initialize_box_geometry_from_main_component;
this_box_volume.geometry.process_rot_allocated = 0;

this_box_volume.geometry.copy_geometry_parameters = &allocate_box_storage_copy;

rot_copy(this_box_volume.geometry.rotation_matrix,ROT_A_CURRENT_COMP); //check how ROT_R_CURRENT_COMP would work
rot_transpose(ROT_A_CURRENT_COMP,this_box_volume.geometry.transpose_rotation_matrix);

// Initialize loggers
this_box_volume.loggers.num_elements = 0;

// packing the information into the global_geometry_element, which is then included in the global_geometry_list.
sprintf(global_geometry_element.name,NAME_CURRENT_COMP);
global_geometry_element.activation_counter = number_of_activations;
global_geometry_element.component_index = INDEX_CURRENT_COMP;
global_geometry_element.Volume = &this_box_volume; // Would be nicer if this m was a pointer, now we have the (small) data two places
add_element_to_geometry_list(&global_geometry_list,global_geometry_element);
}
#line 169289 "MACS_sample_kidney_box.c"
#undef number_of_activations
#undef mask_setting
#undef mask_string
#undef p_interact
#undef focus_r
#undef focus_xh
#undef focus_xw
#undef focus_ah
#undef focus_aw
#undef target_z
#undef target_y
#undef target_x
#undef target_index
#undef visualize
#undef yheight2
#undef xwidth2
#undef zdepth
#undef yheight
#undef xwidth
#undef priority
#undef material_string
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

  /* Initializations for component channel_0_analyzer_2_array_crystal_array_5. */
  SIG_MESSAGE("channel_0_analyzer_2_array_crystal_array_5 (Init)");
#define mccompcurname  channel_0_analyzer_2_array_crystal_array_5
#define mccompcurtype  Union_box
#define mccompcurindex 146
#define loop_index mccchannel_0_analyzer_2_array_crystal_array_5_loop_index
#define this_box_volume mccchannel_0_analyzer_2_array_crystal_array_5_this_box_volume
#define global_geometry_element mccchannel_0_analyzer_2_array_crystal_array_5_global_geometry_element
#define this_box_storage mccchannel_0_analyzer_2_array_crystal_array_5_this_box_storage
#define material_string mccchannel_0_analyzer_2_array_crystal_array_5_material_string
#define priority mccchannel_0_analyzer_2_array_crystal_array_5_priority
#define xwidth mccchannel_0_analyzer_2_array_crystal_array_5_xwidth
#define yheight mccchannel_0_analyzer_2_array_crystal_array_5_yheight
#define zdepth mccchannel_0_analyzer_2_array_crystal_array_5_zdepth
#define xwidth2 mccchannel_0_analyzer_2_array_crystal_array_5_xwidth2
#define yheight2 mccchannel_0_analyzer_2_array_crystal_array_5_yheight2
#define visualize mccchannel_0_analyzer_2_array_crystal_array_5_visualize
#define target_index mccchannel_0_analyzer_2_array_crystal_array_5_target_index
#define target_x mccchannel_0_analyzer_2_array_crystal_array_5_target_x
#define target_y mccchannel_0_analyzer_2_array_crystal_array_5_target_y
#define target_z mccchannel_0_analyzer_2_array_crystal_array_5_target_z
#define focus_aw mccchannel_0_analyzer_2_array_crystal_array_5_focus_aw
#define focus_ah mccchannel_0_analyzer_2_array_crystal_array_5_focus_ah
#define focus_xw mccchannel_0_analyzer_2_array_crystal_array_5_focus_xw
#define focus_xh mccchannel_0_analyzer_2_array_crystal_array_5_focus_xh
#define focus_r mccchannel_0_analyzer_2_array_crystal_array_5_focus_r
#define p_interact mccchannel_0_analyzer_2_array_crystal_array_5_p_interact
#define mask_string mccchannel_0_analyzer_2_array_crystal_array_5_mask_string
#define mask_setting mccchannel_0_analyzer_2_array_crystal_array_5_mask_setting
#define number_of_activations mccchannel_0_analyzer_2_array_crystal_array_5_number_of_activations
#line 224 "Union_box.comp"
{
// Initializes the focusing system for this volume including input sanitation.
focus_initialize(&this_box_volume.geometry, POS_A_COMP_INDEX(INDEX_CURRENT_COMP+target_index), POS_A_CURRENT_COMP, ROT_A_CURRENT_COMP, target_index, target_x, target_y, target_z, focus_aw, focus_ah, focus_xw, focus_xh, focus_r, NAME_CURRENT_COMP);

// Input sanitation for this geometry
if (xwidth <= 0) {
  printf("\nERROR in Union_box named %s, the xwidth is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (yheight <= 0) {
  printf("\nERROR in Union_box named %s, yheight is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (zdepth <= 0) {
  printf("\nERROR in Union_box named %s, zdepth is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (xwidth2 <= 0 && xwidth2 != -1) {
  printf("\nERROR in Union_box named %s, the xwidth2 is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (yheight2 <= 0 && yheight2 != -1) {
  printf("\nERROR in Union_box named %s, yheight2 is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}

// Use sanitation
if (global_material_list.num_elements == 0) {
  printf("\nERROR: Need to define a material using Union_make_material before using a Union geometry component. \n");
  printf("       %s was defined before first use of Union_make_material.\n",NAME_CURRENT_COMP);
  exit(1);
}

this_box_volume.geometry.is_masked_volume = 0;
this_box_volume.geometry.is_exit_volume = 0;
this_box_volume.geometry.is_mask_volume = 0;
// check if the volume is a mask, if it is the material string is irelevant.
if (mask_string && strlen(mask_string) && strcmp(mask_string, "NULL") && strcmp(mask_string, "0")) {
    // A mask volume is used to limit the extend of other volumes, called the masked volumes. These are specified in the mask_string.
    // In order for a ray to enter a masked volume, it needs to be both in the region covered by that volume AND the mask volume.
    // When more than
    this_box_volume.geometry.mask_mode = 1; // Default is mask mode is ALL
    if (mask_setting && strlen(mask_setting) && strcmp(mask_setting, "NULL") && strcmp(mask_setting, "0")) {
        if (strcmp(mask_setting,"ALL") == 0 || strcmp(mask_setting,"All") == 0) this_box_volume.geometry.mask_mode = 1;
        else if (strcmp(mask_setting,"ANY") == 0 || strcmp(mask_setting,"Any") == 0) this_box_volume.geometry.mask_mode = 2;
        else {
            printf("The mask_mode of component %s is set to %s, but must be either ALL or ANY.\n",NAME_CURRENT_COMP,mask_setting);
            exit(1);
        }
    }
    
    for (loop_index=0;loop_index<global_geometry_list.num_elements;loop_index++) {
        // Add mask list
        if (1 == manual_linking_function(global_geometry_list.elements[loop_index].name,mask_string)) {
            add_element_to_int_list(&this_box_volume.geometry.mask_list,global_geometry_list.elements[loop_index].component_index);
            add_element_to_int_list(&global_geometry_list.elements[loop_index].Volume->geometry.masked_by_list,INDEX_CURRENT_COMP);
            global_geometry_list.elements[loop_index].Volume->geometry.is_masked_volume = 1;
            if (this_box_volume.geometry.mask_mode == 2)
                global_geometry_list.elements[loop_index].Volume->geometry.mask_mode = 2;
            if (this_box_volume.geometry.mask_mode == 1) {
                if (global_geometry_list.elements[loop_index].Volume->geometry.is_masked_volume == 1 && global_geometry_list.elements[loop_index].Volume->geometry.mask_mode != 2)
                    // If more than one mask is added to one volume, the ANY mode overwrites the (default) ALL mode.
                    global_geometry_list.elements[loop_index].Volume->geometry.mask_mode = 1;
            }
            
            found_geometries = 1;
        }
    }
    if (found_geometries == 0) {
        printf("The mask_string in geometry: %s did not find any of the specified volumes in the mask_string %s \n",NAME_CURRENT_COMP,mask_string);
        exit(1);
    }
    this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
    this_box_volume.p_physics->is_vacuum = 0; // Makes this volume a vacuum
    this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
    this_box_volume.p_physics->my_a = 0; // Should not be used.
    sprintf(this_box_volume.p_physics->name,"Mask");
    this_box_volume.geometry.is_mask_volume = 1;
    
    
// Read the material input, or if it lacks, use automatic linking.
} else if (material_string && strlen(material_string) && strcmp(material_string, "NULL") && strcmp(material_string, "0")) {
    // A geometry string was given, use it to determine which material
    if (0 == strcmp(material_string,"vacuum") || 0 == strcmp(material_string,"Vacuum")) {
        // One could have a global physics struct for vacuum instead of creating one for each
        this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
        this_box_volume.p_physics->is_vacuum = 1; // Makes this volume a vacuum
        this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
        this_box_volume.p_physics->my_a = 0; // Should not be used.
        sprintf(this_box_volume.p_physics->name,"Vacuum");
    } else if (0 == strcmp(material_string,"exit") || 0 == strcmp(material_string,"Exit")) {
        // One could have a global physics struct for vacuum instead of creating one for each
        this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
        this_box_volume.p_physics->is_vacuum = 1; // Makes this volume a vacuum
        this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
        this_box_volume.p_physics->my_a = 0; // Should not be used.
        this_box_volume.geometry.is_exit_volume = 1;
        sprintf(this_box_volume.p_physics->name,"Exit");
    } else {
        #ifndef MATERIAL_DETECTOR
            printf("Need to define a material before refering to it in a geometry %s.\n",NAME_CURRENT_COMP);
            exit(1);
        #endif
        for (loop_index=0;loop_index<global_material_list.num_elements;loop_index++) {
            if (0 == strcmp(material_string,global_material_list.elements[loop_index].name)) {
                this_box_volume.p_physics = global_material_list.elements[loop_index].physics;
                break;
            }
            if (loop_index == global_material_list.num_elements-1) {
            printf("\n");
            printf("ERROR: The material string \"%s\" in Union geometry \"%s\" did not match a specified material. \n",material_string,NAME_CURRENT_COMP);
            printf("       The materials available at this point (need to be defined before the geometry): \n");
            for (loop_index=0;loop_index<global_material_list.num_elements;loop_index++)
              printf("         %s\n",global_material_list.elements[loop_index].name);
            printf("\n");
            printf("       It is also possible to use one of the defualt materials avaiable: \n");
            printf("           Vacuum (for a Volume without scattering or absorption)\n");
            printf("           Exit (for a Volume where the ray exits the component if it enters)\n");
            printf("           Mask (for a Volume that masks existing volumes specified in the mask_string\n");
            exit(1);
          }
        }
    }
} else {
    // Automatic linking, simply using the last defined material.
    #ifndef MATERIAL_DETECTOR
        printf("Need to define a material before the geometry to use automatic linking %s.\n",NAME_CURRENT_COMP);
        exit(1);
    #endif
    this_box_volume.p_physics = global_material_list.elements[global_material_list.num_elements-1].physics;
}

sprintf(this_box_volume.name,NAME_CURRENT_COMP);
sprintf(this_box_volume.geometry.shape,"box");
this_box_volume.geometry.priority_value = priority;
this_box_volume.geometry.geometry_p_interact = p_interact;
// Currently the coordinates will be in absolute space.
this_box_volume.geometry.center = POS_A_CURRENT_COMP;

this_box_storage.z_depth = zdepth;
this_box_storage.x_width1 = xwidth;
this_box_storage.y_height1 = yheight;

this_box_storage.is_rectangle = 0;
if (xwidth2 < 0 && yheight2 < 0) this_box_storage.is_rectangle = 1;
if (xwidth == xwidth2 && yheight == yheight2) this_box_storage.is_rectangle = 1;

if (xwidth2 < 0) {
    this_box_storage.x_width2 = xwidth;
    xwidth2 = xwidth;
} else this_box_storage.x_width2 = xwidth2;

if (yheight2 < 0) {
    this_box_storage.y_height2 = yheight;
    yheight2 = yheight;
} else this_box_storage.y_height2 = yheight2;


this_box_storage.normal_vectors[0] = coords_set(0,0,1);
this_box_storage.normal_vectors[1] = coords_set(0,0,1);

// for sides with y component = 0
x_component = 2*zdepth/sqrt((xwidth-xwidth2)*(xwidth-xwidth2)+4*zdepth*zdepth);
z_component = (xwidth-xwidth2)/sqrt(4*zdepth*zdepth+(xwidth-xwidth2)*(xwidth-xwidth2));

this_box_storage.normal_vectors[2] = coords_set(x_component,0,z_component);
this_box_storage.normal_vectors[3] = coords_set(-x_component,0,z_component);

// for sides with x component = 0
y_component = 2*zdepth/sqrt((yheight-yheight2)*(yheight-yheight2)+4*zdepth*zdepth);
z_component = (yheight-yheight2)/sqrt(4*zdepth*zdepth+(yheight-yheight2)*(yheight-yheight2));

this_box_storage.normal_vectors[4] = coords_set(0,y_component,z_component);
this_box_storage.normal_vectors[5] = coords_set(0,-y_component,z_component);

this_box_volume.geometry.visualization_on = visualize;

this_box_volume.geometry.geometry_parameters.p_box_storage = &this_box_storage;

// Assign pointers to functions for intersection with the shape, checking if a point is inside the shape
if (this_box_storage.is_rectangle == 1) {
this_box_volume.geometry.intersect_function = &sample_box_intersect_simple;
this_box_volume.geometry.within_function = &r_within_box_simple;
}
else {
this_box_volume.geometry.intersect_function = &sample_box_intersect_advanced;
this_box_volume.geometry.within_function = &r_within_box_advanced;
}

this_box_volume.geometry.shell_points = &box_shell_points;
this_box_volume.geometry.mcdisplay_function = &mcdisplay_box_function;
this_box_volume.geometry.initialize_from_main_function = &initialize_box_geometry_from_main_component;
this_box_volume.geometry.process_rot_allocated = 0;

this_box_volume.geometry.copy_geometry_parameters = &allocate_box_storage_copy;

rot_copy(this_box_volume.geometry.rotation_matrix,ROT_A_CURRENT_COMP); //check how ROT_R_CURRENT_COMP would work
rot_transpose(ROT_A_CURRENT_COMP,this_box_volume.geometry.transpose_rotation_matrix);

// Initialize loggers
this_box_volume.loggers.num_elements = 0;

// packing the information into the global_geometry_element, which is then included in the global_geometry_list.
sprintf(global_geometry_element.name,NAME_CURRENT_COMP);
global_geometry_element.activation_counter = number_of_activations;
global_geometry_element.component_index = INDEX_CURRENT_COMP;
global_geometry_element.Volume = &this_box_volume; // Would be nicer if this m was a pointer, now we have the (small) data two places
add_element_to_geometry_list(&global_geometry_list,global_geometry_element);
}
#line 169559 "MACS_sample_kidney_box.c"
#undef number_of_activations
#undef mask_setting
#undef mask_string
#undef p_interact
#undef focus_r
#undef focus_xh
#undef focus_xw
#undef focus_ah
#undef focus_aw
#undef target_z
#undef target_y
#undef target_x
#undef target_index
#undef visualize
#undef yheight2
#undef xwidth2
#undef zdepth
#undef yheight
#undef xwidth
#undef priority
#undef material_string
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

  /* Initializations for component channel_0_analyzer_2_array_crystal_array_6. */
  SIG_MESSAGE("channel_0_analyzer_2_array_crystal_array_6 (Init)");
#define mccompcurname  channel_0_analyzer_2_array_crystal_array_6
#define mccompcurtype  Union_box
#define mccompcurindex 147
#define loop_index mccchannel_0_analyzer_2_array_crystal_array_6_loop_index
#define this_box_volume mccchannel_0_analyzer_2_array_crystal_array_6_this_box_volume
#define global_geometry_element mccchannel_0_analyzer_2_array_crystal_array_6_global_geometry_element
#define this_box_storage mccchannel_0_analyzer_2_array_crystal_array_6_this_box_storage
#define material_string mccchannel_0_analyzer_2_array_crystal_array_6_material_string
#define priority mccchannel_0_analyzer_2_array_crystal_array_6_priority
#define xwidth mccchannel_0_analyzer_2_array_crystal_array_6_xwidth
#define yheight mccchannel_0_analyzer_2_array_crystal_array_6_yheight
#define zdepth mccchannel_0_analyzer_2_array_crystal_array_6_zdepth
#define xwidth2 mccchannel_0_analyzer_2_array_crystal_array_6_xwidth2
#define yheight2 mccchannel_0_analyzer_2_array_crystal_array_6_yheight2
#define visualize mccchannel_0_analyzer_2_array_crystal_array_6_visualize
#define target_index mccchannel_0_analyzer_2_array_crystal_array_6_target_index
#define target_x mccchannel_0_analyzer_2_array_crystal_array_6_target_x
#define target_y mccchannel_0_analyzer_2_array_crystal_array_6_target_y
#define target_z mccchannel_0_analyzer_2_array_crystal_array_6_target_z
#define focus_aw mccchannel_0_analyzer_2_array_crystal_array_6_focus_aw
#define focus_ah mccchannel_0_analyzer_2_array_crystal_array_6_focus_ah
#define focus_xw mccchannel_0_analyzer_2_array_crystal_array_6_focus_xw
#define focus_xh mccchannel_0_analyzer_2_array_crystal_array_6_focus_xh
#define focus_r mccchannel_0_analyzer_2_array_crystal_array_6_focus_r
#define p_interact mccchannel_0_analyzer_2_array_crystal_array_6_p_interact
#define mask_string mccchannel_0_analyzer_2_array_crystal_array_6_mask_string
#define mask_setting mccchannel_0_analyzer_2_array_crystal_array_6_mask_setting
#define number_of_activations mccchannel_0_analyzer_2_array_crystal_array_6_number_of_activations
#line 224 "Union_box.comp"
{
// Initializes the focusing system for this volume including input sanitation.
focus_initialize(&this_box_volume.geometry, POS_A_COMP_INDEX(INDEX_CURRENT_COMP+target_index), POS_A_CURRENT_COMP, ROT_A_CURRENT_COMP, target_index, target_x, target_y, target_z, focus_aw, focus_ah, focus_xw, focus_xh, focus_r, NAME_CURRENT_COMP);

// Input sanitation for this geometry
if (xwidth <= 0) {
  printf("\nERROR in Union_box named %s, the xwidth is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (yheight <= 0) {
  printf("\nERROR in Union_box named %s, yheight is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (zdepth <= 0) {
  printf("\nERROR in Union_box named %s, zdepth is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (xwidth2 <= 0 && xwidth2 != -1) {
  printf("\nERROR in Union_box named %s, the xwidth2 is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (yheight2 <= 0 && yheight2 != -1) {
  printf("\nERROR in Union_box named %s, yheight2 is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}

// Use sanitation
if (global_material_list.num_elements == 0) {
  printf("\nERROR: Need to define a material using Union_make_material before using a Union geometry component. \n");
  printf("       %s was defined before first use of Union_make_material.\n",NAME_CURRENT_COMP);
  exit(1);
}

this_box_volume.geometry.is_masked_volume = 0;
this_box_volume.geometry.is_exit_volume = 0;
this_box_volume.geometry.is_mask_volume = 0;
// check if the volume is a mask, if it is the material string is irelevant.
if (mask_string && strlen(mask_string) && strcmp(mask_string, "NULL") && strcmp(mask_string, "0")) {
    // A mask volume is used to limit the extend of other volumes, called the masked volumes. These are specified in the mask_string.
    // In order for a ray to enter a masked volume, it needs to be both in the region covered by that volume AND the mask volume.
    // When more than
    this_box_volume.geometry.mask_mode = 1; // Default is mask mode is ALL
    if (mask_setting && strlen(mask_setting) && strcmp(mask_setting, "NULL") && strcmp(mask_setting, "0")) {
        if (strcmp(mask_setting,"ALL") == 0 || strcmp(mask_setting,"All") == 0) this_box_volume.geometry.mask_mode = 1;
        else if (strcmp(mask_setting,"ANY") == 0 || strcmp(mask_setting,"Any") == 0) this_box_volume.geometry.mask_mode = 2;
        else {
            printf("The mask_mode of component %s is set to %s, but must be either ALL or ANY.\n",NAME_CURRENT_COMP,mask_setting);
            exit(1);
        }
    }
    
    for (loop_index=0;loop_index<global_geometry_list.num_elements;loop_index++) {
        // Add mask list
        if (1 == manual_linking_function(global_geometry_list.elements[loop_index].name,mask_string)) {
            add_element_to_int_list(&this_box_volume.geometry.mask_list,global_geometry_list.elements[loop_index].component_index);
            add_element_to_int_list(&global_geometry_list.elements[loop_index].Volume->geometry.masked_by_list,INDEX_CURRENT_COMP);
            global_geometry_list.elements[loop_index].Volume->geometry.is_masked_volume = 1;
            if (this_box_volume.geometry.mask_mode == 2)
                global_geometry_list.elements[loop_index].Volume->geometry.mask_mode = 2;
            if (this_box_volume.geometry.mask_mode == 1) {
                if (global_geometry_list.elements[loop_index].Volume->geometry.is_masked_volume == 1 && global_geometry_list.elements[loop_index].Volume->geometry.mask_mode != 2)
                    // If more than one mask is added to one volume, the ANY mode overwrites the (default) ALL mode.
                    global_geometry_list.elements[loop_index].Volume->geometry.mask_mode = 1;
            }
            
            found_geometries = 1;
        }
    }
    if (found_geometries == 0) {
        printf("The mask_string in geometry: %s did not find any of the specified volumes in the mask_string %s \n",NAME_CURRENT_COMP,mask_string);
        exit(1);
    }
    this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
    this_box_volume.p_physics->is_vacuum = 0; // Makes this volume a vacuum
    this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
    this_box_volume.p_physics->my_a = 0; // Should not be used.
    sprintf(this_box_volume.p_physics->name,"Mask");
    this_box_volume.geometry.is_mask_volume = 1;
    
    
// Read the material input, or if it lacks, use automatic linking.
} else if (material_string && strlen(material_string) && strcmp(material_string, "NULL") && strcmp(material_string, "0")) {
    // A geometry string was given, use it to determine which material
    if (0 == strcmp(material_string,"vacuum") || 0 == strcmp(material_string,"Vacuum")) {
        // One could have a global physics struct for vacuum instead of creating one for each
        this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
        this_box_volume.p_physics->is_vacuum = 1; // Makes this volume a vacuum
        this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
        this_box_volume.p_physics->my_a = 0; // Should not be used.
        sprintf(this_box_volume.p_physics->name,"Vacuum");
    } else if (0 == strcmp(material_string,"exit") || 0 == strcmp(material_string,"Exit")) {
        // One could have a global physics struct for vacuum instead of creating one for each
        this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
        this_box_volume.p_physics->is_vacuum = 1; // Makes this volume a vacuum
        this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
        this_box_volume.p_physics->my_a = 0; // Should not be used.
        this_box_volume.geometry.is_exit_volume = 1;
        sprintf(this_box_volume.p_physics->name,"Exit");
    } else {
        #ifndef MATERIAL_DETECTOR
            printf("Need to define a material before refering to it in a geometry %s.\n",NAME_CURRENT_COMP);
            exit(1);
        #endif
        for (loop_index=0;loop_index<global_material_list.num_elements;loop_index++) {
            if (0 == strcmp(material_string,global_material_list.elements[loop_index].name)) {
                this_box_volume.p_physics = global_material_list.elements[loop_index].physics;
                break;
            }
            if (loop_index == global_material_list.num_elements-1) {
            printf("\n");
            printf("ERROR: The material string \"%s\" in Union geometry \"%s\" did not match a specified material. \n",material_string,NAME_CURRENT_COMP);
            printf("       The materials available at this point (need to be defined before the geometry): \n");
            for (loop_index=0;loop_index<global_material_list.num_elements;loop_index++)
              printf("         %s\n",global_material_list.elements[loop_index].name);
            printf("\n");
            printf("       It is also possible to use one of the defualt materials avaiable: \n");
            printf("           Vacuum (for a Volume without scattering or absorption)\n");
            printf("           Exit (for a Volume where the ray exits the component if it enters)\n");
            printf("           Mask (for a Volume that masks existing volumes specified in the mask_string\n");
            exit(1);
          }
        }
    }
} else {
    // Automatic linking, simply using the last defined material.
    #ifndef MATERIAL_DETECTOR
        printf("Need to define a material before the geometry to use automatic linking %s.\n",NAME_CURRENT_COMP);
        exit(1);
    #endif
    this_box_volume.p_physics = global_material_list.elements[global_material_list.num_elements-1].physics;
}

sprintf(this_box_volume.name,NAME_CURRENT_COMP);
sprintf(this_box_volume.geometry.shape,"box");
this_box_volume.geometry.priority_value = priority;
this_box_volume.geometry.geometry_p_interact = p_interact;
// Currently the coordinates will be in absolute space.
this_box_volume.geometry.center = POS_A_CURRENT_COMP;

this_box_storage.z_depth = zdepth;
this_box_storage.x_width1 = xwidth;
this_box_storage.y_height1 = yheight;

this_box_storage.is_rectangle = 0;
if (xwidth2 < 0 && yheight2 < 0) this_box_storage.is_rectangle = 1;
if (xwidth == xwidth2 && yheight == yheight2) this_box_storage.is_rectangle = 1;

if (xwidth2 < 0) {
    this_box_storage.x_width2 = xwidth;
    xwidth2 = xwidth;
} else this_box_storage.x_width2 = xwidth2;

if (yheight2 < 0) {
    this_box_storage.y_height2 = yheight;
    yheight2 = yheight;
} else this_box_storage.y_height2 = yheight2;


this_box_storage.normal_vectors[0] = coords_set(0,0,1);
this_box_storage.normal_vectors[1] = coords_set(0,0,1);

// for sides with y component = 0
x_component = 2*zdepth/sqrt((xwidth-xwidth2)*(xwidth-xwidth2)+4*zdepth*zdepth);
z_component = (xwidth-xwidth2)/sqrt(4*zdepth*zdepth+(xwidth-xwidth2)*(xwidth-xwidth2));

this_box_storage.normal_vectors[2] = coords_set(x_component,0,z_component);
this_box_storage.normal_vectors[3] = coords_set(-x_component,0,z_component);

// for sides with x component = 0
y_component = 2*zdepth/sqrt((yheight-yheight2)*(yheight-yheight2)+4*zdepth*zdepth);
z_component = (yheight-yheight2)/sqrt(4*zdepth*zdepth+(yheight-yheight2)*(yheight-yheight2));

this_box_storage.normal_vectors[4] = coords_set(0,y_component,z_component);
this_box_storage.normal_vectors[5] = coords_set(0,-y_component,z_component);

this_box_volume.geometry.visualization_on = visualize;

this_box_volume.geometry.geometry_parameters.p_box_storage = &this_box_storage;

// Assign pointers to functions for intersection with the shape, checking if a point is inside the shape
if (this_box_storage.is_rectangle == 1) {
this_box_volume.geometry.intersect_function = &sample_box_intersect_simple;
this_box_volume.geometry.within_function = &r_within_box_simple;
}
else {
this_box_volume.geometry.intersect_function = &sample_box_intersect_advanced;
this_box_volume.geometry.within_function = &r_within_box_advanced;
}

this_box_volume.geometry.shell_points = &box_shell_points;
this_box_volume.geometry.mcdisplay_function = &mcdisplay_box_function;
this_box_volume.geometry.initialize_from_main_function = &initialize_box_geometry_from_main_component;
this_box_volume.geometry.process_rot_allocated = 0;

this_box_volume.geometry.copy_geometry_parameters = &allocate_box_storage_copy;

rot_copy(this_box_volume.geometry.rotation_matrix,ROT_A_CURRENT_COMP); //check how ROT_R_CURRENT_COMP would work
rot_transpose(ROT_A_CURRENT_COMP,this_box_volume.geometry.transpose_rotation_matrix);

// Initialize loggers
this_box_volume.loggers.num_elements = 0;

// packing the information into the global_geometry_element, which is then included in the global_geometry_list.
sprintf(global_geometry_element.name,NAME_CURRENT_COMP);
global_geometry_element.activation_counter = number_of_activations;
global_geometry_element.component_index = INDEX_CURRENT_COMP;
global_geometry_element.Volume = &this_box_volume; // Would be nicer if this m was a pointer, now we have the (small) data two places
add_element_to_geometry_list(&global_geometry_list,global_geometry_element);
}
#line 169829 "MACS_sample_kidney_box.c"
#undef number_of_activations
#undef mask_setting
#undef mask_string
#undef p_interact
#undef focus_r
#undef focus_xh
#undef focus_xw
#undef focus_ah
#undef focus_aw
#undef target_z
#undef target_y
#undef target_x
#undef target_index
#undef visualize
#undef yheight2
#undef xwidth2
#undef zdepth
#undef yheight
#undef xwidth
#undef priority
#undef material_string
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

  /* Initializations for component channel_0_analyzer_2_array_crystal_array_7. */
  SIG_MESSAGE("channel_0_analyzer_2_array_crystal_array_7 (Init)");
#define mccompcurname  channel_0_analyzer_2_array_crystal_array_7
#define mccompcurtype  Union_box
#define mccompcurindex 148
#define loop_index mccchannel_0_analyzer_2_array_crystal_array_7_loop_index
#define this_box_volume mccchannel_0_analyzer_2_array_crystal_array_7_this_box_volume
#define global_geometry_element mccchannel_0_analyzer_2_array_crystal_array_7_global_geometry_element
#define this_box_storage mccchannel_0_analyzer_2_array_crystal_array_7_this_box_storage
#define material_string mccchannel_0_analyzer_2_array_crystal_array_7_material_string
#define priority mccchannel_0_analyzer_2_array_crystal_array_7_priority
#define xwidth mccchannel_0_analyzer_2_array_crystal_array_7_xwidth
#define yheight mccchannel_0_analyzer_2_array_crystal_array_7_yheight
#define zdepth mccchannel_0_analyzer_2_array_crystal_array_7_zdepth
#define xwidth2 mccchannel_0_analyzer_2_array_crystal_array_7_xwidth2
#define yheight2 mccchannel_0_analyzer_2_array_crystal_array_7_yheight2
#define visualize mccchannel_0_analyzer_2_array_crystal_array_7_visualize
#define target_index mccchannel_0_analyzer_2_array_crystal_array_7_target_index
#define target_x mccchannel_0_analyzer_2_array_crystal_array_7_target_x
#define target_y mccchannel_0_analyzer_2_array_crystal_array_7_target_y
#define target_z mccchannel_0_analyzer_2_array_crystal_array_7_target_z
#define focus_aw mccchannel_0_analyzer_2_array_crystal_array_7_focus_aw
#define focus_ah mccchannel_0_analyzer_2_array_crystal_array_7_focus_ah
#define focus_xw mccchannel_0_analyzer_2_array_crystal_array_7_focus_xw
#define focus_xh mccchannel_0_analyzer_2_array_crystal_array_7_focus_xh
#define focus_r mccchannel_0_analyzer_2_array_crystal_array_7_focus_r
#define p_interact mccchannel_0_analyzer_2_array_crystal_array_7_p_interact
#define mask_string mccchannel_0_analyzer_2_array_crystal_array_7_mask_string
#define mask_setting mccchannel_0_analyzer_2_array_crystal_array_7_mask_setting
#define number_of_activations mccchannel_0_analyzer_2_array_crystal_array_7_number_of_activations
#line 224 "Union_box.comp"
{
// Initializes the focusing system for this volume including input sanitation.
focus_initialize(&this_box_volume.geometry, POS_A_COMP_INDEX(INDEX_CURRENT_COMP+target_index), POS_A_CURRENT_COMP, ROT_A_CURRENT_COMP, target_index, target_x, target_y, target_z, focus_aw, focus_ah, focus_xw, focus_xh, focus_r, NAME_CURRENT_COMP);

// Input sanitation for this geometry
if (xwidth <= 0) {
  printf("\nERROR in Union_box named %s, the xwidth is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (yheight <= 0) {
  printf("\nERROR in Union_box named %s, yheight is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (zdepth <= 0) {
  printf("\nERROR in Union_box named %s, zdepth is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (xwidth2 <= 0 && xwidth2 != -1) {
  printf("\nERROR in Union_box named %s, the xwidth2 is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (yheight2 <= 0 && yheight2 != -1) {
  printf("\nERROR in Union_box named %s, yheight2 is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}

// Use sanitation
if (global_material_list.num_elements == 0) {
  printf("\nERROR: Need to define a material using Union_make_material before using a Union geometry component. \n");
  printf("       %s was defined before first use of Union_make_material.\n",NAME_CURRENT_COMP);
  exit(1);
}

this_box_volume.geometry.is_masked_volume = 0;
this_box_volume.geometry.is_exit_volume = 0;
this_box_volume.geometry.is_mask_volume = 0;
// check if the volume is a mask, if it is the material string is irelevant.
if (mask_string && strlen(mask_string) && strcmp(mask_string, "NULL") && strcmp(mask_string, "0")) {
    // A mask volume is used to limit the extend of other volumes, called the masked volumes. These are specified in the mask_string.
    // In order for a ray to enter a masked volume, it needs to be both in the region covered by that volume AND the mask volume.
    // When more than
    this_box_volume.geometry.mask_mode = 1; // Default is mask mode is ALL
    if (mask_setting && strlen(mask_setting) && strcmp(mask_setting, "NULL") && strcmp(mask_setting, "0")) {
        if (strcmp(mask_setting,"ALL") == 0 || strcmp(mask_setting,"All") == 0) this_box_volume.geometry.mask_mode = 1;
        else if (strcmp(mask_setting,"ANY") == 0 || strcmp(mask_setting,"Any") == 0) this_box_volume.geometry.mask_mode = 2;
        else {
            printf("The mask_mode of component %s is set to %s, but must be either ALL or ANY.\n",NAME_CURRENT_COMP,mask_setting);
            exit(1);
        }
    }
    
    for (loop_index=0;loop_index<global_geometry_list.num_elements;loop_index++) {
        // Add mask list
        if (1 == manual_linking_function(global_geometry_list.elements[loop_index].name,mask_string)) {
            add_element_to_int_list(&this_box_volume.geometry.mask_list,global_geometry_list.elements[loop_index].component_index);
            add_element_to_int_list(&global_geometry_list.elements[loop_index].Volume->geometry.masked_by_list,INDEX_CURRENT_COMP);
            global_geometry_list.elements[loop_index].Volume->geometry.is_masked_volume = 1;
            if (this_box_volume.geometry.mask_mode == 2)
                global_geometry_list.elements[loop_index].Volume->geometry.mask_mode = 2;
            if (this_box_volume.geometry.mask_mode == 1) {
                if (global_geometry_list.elements[loop_index].Volume->geometry.is_masked_volume == 1 && global_geometry_list.elements[loop_index].Volume->geometry.mask_mode != 2)
                    // If more than one mask is added to one volume, the ANY mode overwrites the (default) ALL mode.
                    global_geometry_list.elements[loop_index].Volume->geometry.mask_mode = 1;
            }
            
            found_geometries = 1;
        }
    }
    if (found_geometries == 0) {
        printf("The mask_string in geometry: %s did not find any of the specified volumes in the mask_string %s \n",NAME_CURRENT_COMP,mask_string);
        exit(1);
    }
    this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
    this_box_volume.p_physics->is_vacuum = 0; // Makes this volume a vacuum
    this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
    this_box_volume.p_physics->my_a = 0; // Should not be used.
    sprintf(this_box_volume.p_physics->name,"Mask");
    this_box_volume.geometry.is_mask_volume = 1;
    
    
// Read the material input, or if it lacks, use automatic linking.
} else if (material_string && strlen(material_string) && strcmp(material_string, "NULL") && strcmp(material_string, "0")) {
    // A geometry string was given, use it to determine which material
    if (0 == strcmp(material_string,"vacuum") || 0 == strcmp(material_string,"Vacuum")) {
        // One could have a global physics struct for vacuum instead of creating one for each
        this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
        this_box_volume.p_physics->is_vacuum = 1; // Makes this volume a vacuum
        this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
        this_box_volume.p_physics->my_a = 0; // Should not be used.
        sprintf(this_box_volume.p_physics->name,"Vacuum");
    } else if (0 == strcmp(material_string,"exit") || 0 == strcmp(material_string,"Exit")) {
        // One could have a global physics struct for vacuum instead of creating one for each
        this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
        this_box_volume.p_physics->is_vacuum = 1; // Makes this volume a vacuum
        this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
        this_box_volume.p_physics->my_a = 0; // Should not be used.
        this_box_volume.geometry.is_exit_volume = 1;
        sprintf(this_box_volume.p_physics->name,"Exit");
    } else {
        #ifndef MATERIAL_DETECTOR
            printf("Need to define a material before refering to it in a geometry %s.\n",NAME_CURRENT_COMP);
            exit(1);
        #endif
        for (loop_index=0;loop_index<global_material_list.num_elements;loop_index++) {
            if (0 == strcmp(material_string,global_material_list.elements[loop_index].name)) {
                this_box_volume.p_physics = global_material_list.elements[loop_index].physics;
                break;
            }
            if (loop_index == global_material_list.num_elements-1) {
            printf("\n");
            printf("ERROR: The material string \"%s\" in Union geometry \"%s\" did not match a specified material. \n",material_string,NAME_CURRENT_COMP);
            printf("       The materials available at this point (need to be defined before the geometry): \n");
            for (loop_index=0;loop_index<global_material_list.num_elements;loop_index++)
              printf("         %s\n",global_material_list.elements[loop_index].name);
            printf("\n");
            printf("       It is also possible to use one of the defualt materials avaiable: \n");
            printf("           Vacuum (for a Volume without scattering or absorption)\n");
            printf("           Exit (for a Volume where the ray exits the component if it enters)\n");
            printf("           Mask (for a Volume that masks existing volumes specified in the mask_string\n");
            exit(1);
          }
        }
    }
} else {
    // Automatic linking, simply using the last defined material.
    #ifndef MATERIAL_DETECTOR
        printf("Need to define a material before the geometry to use automatic linking %s.\n",NAME_CURRENT_COMP);
        exit(1);
    #endif
    this_box_volume.p_physics = global_material_list.elements[global_material_list.num_elements-1].physics;
}

sprintf(this_box_volume.name,NAME_CURRENT_COMP);
sprintf(this_box_volume.geometry.shape,"box");
this_box_volume.geometry.priority_value = priority;
this_box_volume.geometry.geometry_p_interact = p_interact;
// Currently the coordinates will be in absolute space.
this_box_volume.geometry.center = POS_A_CURRENT_COMP;

this_box_storage.z_depth = zdepth;
this_box_storage.x_width1 = xwidth;
this_box_storage.y_height1 = yheight;

this_box_storage.is_rectangle = 0;
if (xwidth2 < 0 && yheight2 < 0) this_box_storage.is_rectangle = 1;
if (xwidth == xwidth2 && yheight == yheight2) this_box_storage.is_rectangle = 1;

if (xwidth2 < 0) {
    this_box_storage.x_width2 = xwidth;
    xwidth2 = xwidth;
} else this_box_storage.x_width2 = xwidth2;

if (yheight2 < 0) {
    this_box_storage.y_height2 = yheight;
    yheight2 = yheight;
} else this_box_storage.y_height2 = yheight2;


this_box_storage.normal_vectors[0] = coords_set(0,0,1);
this_box_storage.normal_vectors[1] = coords_set(0,0,1);

// for sides with y component = 0
x_component = 2*zdepth/sqrt((xwidth-xwidth2)*(xwidth-xwidth2)+4*zdepth*zdepth);
z_component = (xwidth-xwidth2)/sqrt(4*zdepth*zdepth+(xwidth-xwidth2)*(xwidth-xwidth2));

this_box_storage.normal_vectors[2] = coords_set(x_component,0,z_component);
this_box_storage.normal_vectors[3] = coords_set(-x_component,0,z_component);

// for sides with x component = 0
y_component = 2*zdepth/sqrt((yheight-yheight2)*(yheight-yheight2)+4*zdepth*zdepth);
z_component = (yheight-yheight2)/sqrt(4*zdepth*zdepth+(yheight-yheight2)*(yheight-yheight2));

this_box_storage.normal_vectors[4] = coords_set(0,y_component,z_component);
this_box_storage.normal_vectors[5] = coords_set(0,-y_component,z_component);

this_box_volume.geometry.visualization_on = visualize;

this_box_volume.geometry.geometry_parameters.p_box_storage = &this_box_storage;

// Assign pointers to functions for intersection with the shape, checking if a point is inside the shape
if (this_box_storage.is_rectangle == 1) {
this_box_volume.geometry.intersect_function = &sample_box_intersect_simple;
this_box_volume.geometry.within_function = &r_within_box_simple;
}
else {
this_box_volume.geometry.intersect_function = &sample_box_intersect_advanced;
this_box_volume.geometry.within_function = &r_within_box_advanced;
}

this_box_volume.geometry.shell_points = &box_shell_points;
this_box_volume.geometry.mcdisplay_function = &mcdisplay_box_function;
this_box_volume.geometry.initialize_from_main_function = &initialize_box_geometry_from_main_component;
this_box_volume.geometry.process_rot_allocated = 0;

this_box_volume.geometry.copy_geometry_parameters = &allocate_box_storage_copy;

rot_copy(this_box_volume.geometry.rotation_matrix,ROT_A_CURRENT_COMP); //check how ROT_R_CURRENT_COMP would work
rot_transpose(ROT_A_CURRENT_COMP,this_box_volume.geometry.transpose_rotation_matrix);

// Initialize loggers
this_box_volume.loggers.num_elements = 0;

// packing the information into the global_geometry_element, which is then included in the global_geometry_list.
sprintf(global_geometry_element.name,NAME_CURRENT_COMP);
global_geometry_element.activation_counter = number_of_activations;
global_geometry_element.component_index = INDEX_CURRENT_COMP;
global_geometry_element.Volume = &this_box_volume; // Would be nicer if this m was a pointer, now we have the (small) data two places
add_element_to_geometry_list(&global_geometry_list,global_geometry_element);
}
#line 170099 "MACS_sample_kidney_box.c"
#undef number_of_activations
#undef mask_setting
#undef mask_string
#undef p_interact
#undef focus_r
#undef focus_xh
#undef focus_xw
#undef focus_ah
#undef focus_aw
#undef target_z
#undef target_y
#undef target_x
#undef target_index
#undef visualize
#undef yheight2
#undef xwidth2
#undef zdepth
#undef yheight
#undef xwidth
#undef priority
#undef material_string
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

  /* Initializations for component channel_0_analyzer_2_array_crystal_array_8. */
  SIG_MESSAGE("channel_0_analyzer_2_array_crystal_array_8 (Init)");
#define mccompcurname  channel_0_analyzer_2_array_crystal_array_8
#define mccompcurtype  Union_box
#define mccompcurindex 149
#define loop_index mccchannel_0_analyzer_2_array_crystal_array_8_loop_index
#define this_box_volume mccchannel_0_analyzer_2_array_crystal_array_8_this_box_volume
#define global_geometry_element mccchannel_0_analyzer_2_array_crystal_array_8_global_geometry_element
#define this_box_storage mccchannel_0_analyzer_2_array_crystal_array_8_this_box_storage
#define material_string mccchannel_0_analyzer_2_array_crystal_array_8_material_string
#define priority mccchannel_0_analyzer_2_array_crystal_array_8_priority
#define xwidth mccchannel_0_analyzer_2_array_crystal_array_8_xwidth
#define yheight mccchannel_0_analyzer_2_array_crystal_array_8_yheight
#define zdepth mccchannel_0_analyzer_2_array_crystal_array_8_zdepth
#define xwidth2 mccchannel_0_analyzer_2_array_crystal_array_8_xwidth2
#define yheight2 mccchannel_0_analyzer_2_array_crystal_array_8_yheight2
#define visualize mccchannel_0_analyzer_2_array_crystal_array_8_visualize
#define target_index mccchannel_0_analyzer_2_array_crystal_array_8_target_index
#define target_x mccchannel_0_analyzer_2_array_crystal_array_8_target_x
#define target_y mccchannel_0_analyzer_2_array_crystal_array_8_target_y
#define target_z mccchannel_0_analyzer_2_array_crystal_array_8_target_z
#define focus_aw mccchannel_0_analyzer_2_array_crystal_array_8_focus_aw
#define focus_ah mccchannel_0_analyzer_2_array_crystal_array_8_focus_ah
#define focus_xw mccchannel_0_analyzer_2_array_crystal_array_8_focus_xw
#define focus_xh mccchannel_0_analyzer_2_array_crystal_array_8_focus_xh
#define focus_r mccchannel_0_analyzer_2_array_crystal_array_8_focus_r
#define p_interact mccchannel_0_analyzer_2_array_crystal_array_8_p_interact
#define mask_string mccchannel_0_analyzer_2_array_crystal_array_8_mask_string
#define mask_setting mccchannel_0_analyzer_2_array_crystal_array_8_mask_setting
#define number_of_activations mccchannel_0_analyzer_2_array_crystal_array_8_number_of_activations
#line 224 "Union_box.comp"
{
// Initializes the focusing system for this volume including input sanitation.
focus_initialize(&this_box_volume.geometry, POS_A_COMP_INDEX(INDEX_CURRENT_COMP+target_index), POS_A_CURRENT_COMP, ROT_A_CURRENT_COMP, target_index, target_x, target_y, target_z, focus_aw, focus_ah, focus_xw, focus_xh, focus_r, NAME_CURRENT_COMP);

// Input sanitation for this geometry
if (xwidth <= 0) {
  printf("\nERROR in Union_box named %s, the xwidth is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (yheight <= 0) {
  printf("\nERROR in Union_box named %s, yheight is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (zdepth <= 0) {
  printf("\nERROR in Union_box named %s, zdepth is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (xwidth2 <= 0 && xwidth2 != -1) {
  printf("\nERROR in Union_box named %s, the xwidth2 is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (yheight2 <= 0 && yheight2 != -1) {
  printf("\nERROR in Union_box named %s, yheight2 is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}

// Use sanitation
if (global_material_list.num_elements == 0) {
  printf("\nERROR: Need to define a material using Union_make_material before using a Union geometry component. \n");
  printf("       %s was defined before first use of Union_make_material.\n",NAME_CURRENT_COMP);
  exit(1);
}

this_box_volume.geometry.is_masked_volume = 0;
this_box_volume.geometry.is_exit_volume = 0;
this_box_volume.geometry.is_mask_volume = 0;
// check if the volume is a mask, if it is the material string is irelevant.
if (mask_string && strlen(mask_string) && strcmp(mask_string, "NULL") && strcmp(mask_string, "0")) {
    // A mask volume is used to limit the extend of other volumes, called the masked volumes. These are specified in the mask_string.
    // In order for a ray to enter a masked volume, it needs to be both in the region covered by that volume AND the mask volume.
    // When more than
    this_box_volume.geometry.mask_mode = 1; // Default is mask mode is ALL
    if (mask_setting && strlen(mask_setting) && strcmp(mask_setting, "NULL") && strcmp(mask_setting, "0")) {
        if (strcmp(mask_setting,"ALL") == 0 || strcmp(mask_setting,"All") == 0) this_box_volume.geometry.mask_mode = 1;
        else if (strcmp(mask_setting,"ANY") == 0 || strcmp(mask_setting,"Any") == 0) this_box_volume.geometry.mask_mode = 2;
        else {
            printf("The mask_mode of component %s is set to %s, but must be either ALL or ANY.\n",NAME_CURRENT_COMP,mask_setting);
            exit(1);
        }
    }
    
    for (loop_index=0;loop_index<global_geometry_list.num_elements;loop_index++) {
        // Add mask list
        if (1 == manual_linking_function(global_geometry_list.elements[loop_index].name,mask_string)) {
            add_element_to_int_list(&this_box_volume.geometry.mask_list,global_geometry_list.elements[loop_index].component_index);
            add_element_to_int_list(&global_geometry_list.elements[loop_index].Volume->geometry.masked_by_list,INDEX_CURRENT_COMP);
            global_geometry_list.elements[loop_index].Volume->geometry.is_masked_volume = 1;
            if (this_box_volume.geometry.mask_mode == 2)
                global_geometry_list.elements[loop_index].Volume->geometry.mask_mode = 2;
            if (this_box_volume.geometry.mask_mode == 1) {
                if (global_geometry_list.elements[loop_index].Volume->geometry.is_masked_volume == 1 && global_geometry_list.elements[loop_index].Volume->geometry.mask_mode != 2)
                    // If more than one mask is added to one volume, the ANY mode overwrites the (default) ALL mode.
                    global_geometry_list.elements[loop_index].Volume->geometry.mask_mode = 1;
            }
            
            found_geometries = 1;
        }
    }
    if (found_geometries == 0) {
        printf("The mask_string in geometry: %s did not find any of the specified volumes in the mask_string %s \n",NAME_CURRENT_COMP,mask_string);
        exit(1);
    }
    this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
    this_box_volume.p_physics->is_vacuum = 0; // Makes this volume a vacuum
    this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
    this_box_volume.p_physics->my_a = 0; // Should not be used.
    sprintf(this_box_volume.p_physics->name,"Mask");
    this_box_volume.geometry.is_mask_volume = 1;
    
    
// Read the material input, or if it lacks, use automatic linking.
} else if (material_string && strlen(material_string) && strcmp(material_string, "NULL") && strcmp(material_string, "0")) {
    // A geometry string was given, use it to determine which material
    if (0 == strcmp(material_string,"vacuum") || 0 == strcmp(material_string,"Vacuum")) {
        // One could have a global physics struct for vacuum instead of creating one for each
        this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
        this_box_volume.p_physics->is_vacuum = 1; // Makes this volume a vacuum
        this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
        this_box_volume.p_physics->my_a = 0; // Should not be used.
        sprintf(this_box_volume.p_physics->name,"Vacuum");
    } else if (0 == strcmp(material_string,"exit") || 0 == strcmp(material_string,"Exit")) {
        // One could have a global physics struct for vacuum instead of creating one for each
        this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
        this_box_volume.p_physics->is_vacuum = 1; // Makes this volume a vacuum
        this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
        this_box_volume.p_physics->my_a = 0; // Should not be used.
        this_box_volume.geometry.is_exit_volume = 1;
        sprintf(this_box_volume.p_physics->name,"Exit");
    } else {
        #ifndef MATERIAL_DETECTOR
            printf("Need to define a material before refering to it in a geometry %s.\n",NAME_CURRENT_COMP);
            exit(1);
        #endif
        for (loop_index=0;loop_index<global_material_list.num_elements;loop_index++) {
            if (0 == strcmp(material_string,global_material_list.elements[loop_index].name)) {
                this_box_volume.p_physics = global_material_list.elements[loop_index].physics;
                break;
            }
            if (loop_index == global_material_list.num_elements-1) {
            printf("\n");
            printf("ERROR: The material string \"%s\" in Union geometry \"%s\" did not match a specified material. \n",material_string,NAME_CURRENT_COMP);
            printf("       The materials available at this point (need to be defined before the geometry): \n");
            for (loop_index=0;loop_index<global_material_list.num_elements;loop_index++)
              printf("         %s\n",global_material_list.elements[loop_index].name);
            printf("\n");
            printf("       It is also possible to use one of the defualt materials avaiable: \n");
            printf("           Vacuum (for a Volume without scattering or absorption)\n");
            printf("           Exit (for a Volume where the ray exits the component if it enters)\n");
            printf("           Mask (for a Volume that masks existing volumes specified in the mask_string\n");
            exit(1);
          }
        }
    }
} else {
    // Automatic linking, simply using the last defined material.
    #ifndef MATERIAL_DETECTOR
        printf("Need to define a material before the geometry to use automatic linking %s.\n",NAME_CURRENT_COMP);
        exit(1);
    #endif
    this_box_volume.p_physics = global_material_list.elements[global_material_list.num_elements-1].physics;
}

sprintf(this_box_volume.name,NAME_CURRENT_COMP);
sprintf(this_box_volume.geometry.shape,"box");
this_box_volume.geometry.priority_value = priority;
this_box_volume.geometry.geometry_p_interact = p_interact;
// Currently the coordinates will be in absolute space.
this_box_volume.geometry.center = POS_A_CURRENT_COMP;

this_box_storage.z_depth = zdepth;
this_box_storage.x_width1 = xwidth;
this_box_storage.y_height1 = yheight;

this_box_storage.is_rectangle = 0;
if (xwidth2 < 0 && yheight2 < 0) this_box_storage.is_rectangle = 1;
if (xwidth == xwidth2 && yheight == yheight2) this_box_storage.is_rectangle = 1;

if (xwidth2 < 0) {
    this_box_storage.x_width2 = xwidth;
    xwidth2 = xwidth;
} else this_box_storage.x_width2 = xwidth2;

if (yheight2 < 0) {
    this_box_storage.y_height2 = yheight;
    yheight2 = yheight;
} else this_box_storage.y_height2 = yheight2;


this_box_storage.normal_vectors[0] = coords_set(0,0,1);
this_box_storage.normal_vectors[1] = coords_set(0,0,1);

// for sides with y component = 0
x_component = 2*zdepth/sqrt((xwidth-xwidth2)*(xwidth-xwidth2)+4*zdepth*zdepth);
z_component = (xwidth-xwidth2)/sqrt(4*zdepth*zdepth+(xwidth-xwidth2)*(xwidth-xwidth2));

this_box_storage.normal_vectors[2] = coords_set(x_component,0,z_component);
this_box_storage.normal_vectors[3] = coords_set(-x_component,0,z_component);

// for sides with x component = 0
y_component = 2*zdepth/sqrt((yheight-yheight2)*(yheight-yheight2)+4*zdepth*zdepth);
z_component = (yheight-yheight2)/sqrt(4*zdepth*zdepth+(yheight-yheight2)*(yheight-yheight2));

this_box_storage.normal_vectors[4] = coords_set(0,y_component,z_component);
this_box_storage.normal_vectors[5] = coords_set(0,-y_component,z_component);

this_box_volume.geometry.visualization_on = visualize;

this_box_volume.geometry.geometry_parameters.p_box_storage = &this_box_storage;

// Assign pointers to functions for intersection with the shape, checking if a point is inside the shape
if (this_box_storage.is_rectangle == 1) {
this_box_volume.geometry.intersect_function = &sample_box_intersect_simple;
this_box_volume.geometry.within_function = &r_within_box_simple;
}
else {
this_box_volume.geometry.intersect_function = &sample_box_intersect_advanced;
this_box_volume.geometry.within_function = &r_within_box_advanced;
}

this_box_volume.geometry.shell_points = &box_shell_points;
this_box_volume.geometry.mcdisplay_function = &mcdisplay_box_function;
this_box_volume.geometry.initialize_from_main_function = &initialize_box_geometry_from_main_component;
this_box_volume.geometry.process_rot_allocated = 0;

this_box_volume.geometry.copy_geometry_parameters = &allocate_box_storage_copy;

rot_copy(this_box_volume.geometry.rotation_matrix,ROT_A_CURRENT_COMP); //check how ROT_R_CURRENT_COMP would work
rot_transpose(ROT_A_CURRENT_COMP,this_box_volume.geometry.transpose_rotation_matrix);

// Initialize loggers
this_box_volume.loggers.num_elements = 0;

// packing the information into the global_geometry_element, which is then included in the global_geometry_list.
sprintf(global_geometry_element.name,NAME_CURRENT_COMP);
global_geometry_element.activation_counter = number_of_activations;
global_geometry_element.component_index = INDEX_CURRENT_COMP;
global_geometry_element.Volume = &this_box_volume; // Would be nicer if this m was a pointer, now we have the (small) data two places
add_element_to_geometry_list(&global_geometry_list,global_geometry_element);
}
#line 170369 "MACS_sample_kidney_box.c"
#undef number_of_activations
#undef mask_setting
#undef mask_string
#undef p_interact
#undef focus_r
#undef focus_xh
#undef focus_xw
#undef focus_ah
#undef focus_aw
#undef target_z
#undef target_y
#undef target_x
#undef target_index
#undef visualize
#undef yheight2
#undef xwidth2
#undef zdepth
#undef yheight
#undef xwidth
#undef priority
#undef material_string
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

  /* Initializations for component channel_0_cave2_cyl1. */
  SIG_MESSAGE("channel_0_cave2_cyl1 (Init)");
#define mccompcurname  channel_0_cave2_cyl1
#define mccompcurtype  Union_cylinder
#define mccompcurindex 150
#define loop_index mccchannel_0_cave2_cyl1_loop_index
#define this_cylinder_volume mccchannel_0_cave2_cyl1_this_cylinder_volume
#define global_geometry_element mccchannel_0_cave2_cyl1_global_geometry_element
#define this_cylinder_storage mccchannel_0_cave2_cyl1_this_cylinder_storage
#define material_string mccchannel_0_cave2_cyl1_material_string
#define priority mccchannel_0_cave2_cyl1_priority
#define radius mccchannel_0_cave2_cyl1_radius
#define yheight mccchannel_0_cave2_cyl1_yheight
#define visualize mccchannel_0_cave2_cyl1_visualize
#define target_index mccchannel_0_cave2_cyl1_target_index
#define target_x mccchannel_0_cave2_cyl1_target_x
#define target_y mccchannel_0_cave2_cyl1_target_y
#define target_z mccchannel_0_cave2_cyl1_target_z
#define focus_aw mccchannel_0_cave2_cyl1_focus_aw
#define focus_ah mccchannel_0_cave2_cyl1_focus_ah
#define focus_xw mccchannel_0_cave2_cyl1_focus_xw
#define focus_xh mccchannel_0_cave2_cyl1_focus_xh
#define focus_r mccchannel_0_cave2_cyl1_focus_r
#define p_interact mccchannel_0_cave2_cyl1_p_interact
#define mask_string mccchannel_0_cave2_cyl1_mask_string
#define mask_setting mccchannel_0_cave2_cyl1_mask_setting
#define number_of_activations mccchannel_0_cave2_cyl1_number_of_activations
#line 185 "Union_cylinder.comp"
{
// Initializes the focusing system for this volume including input sanitation.
focus_initialize(&this_cylinder_volume.geometry, POS_A_COMP_INDEX(INDEX_CURRENT_COMP+target_index), POS_A_CURRENT_COMP, ROT_A_CURRENT_COMP, target_index, target_x, target_y, target_z, focus_aw, focus_ah, focus_xw, focus_xh, focus_r, NAME_CURRENT_COMP);

// Input sanitation for this geometry
if (radius <= 0) {
  printf("\nERROR in Union_cylinder named %s, the radius is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}

if (yheight <= 0) {
  printf("\nERROR in Union_cylinder named %s, yheight is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}

// Use sanitation
#ifdef MATERIAL_DETECTOR
if (global_material_list.num_elements == 0) {
  // Here if the user have defined a material, but only after this material
  printf("\nERROR: Need to define a material using Union_make_material before using a Union geometry component. \n");
  printf("       %s was defined before first use of Union_make_material.\n",NAME_CURRENT_COMP);
  exit(1);
}
#endif
#ifndef MATERIAL_DETECTOR
  printf("\nERROR: Need to define a material using Union_make_material before using a Union geometry component. \n");
  exit(1);
#endif


this_cylinder_volume.geometry.is_masked_volume = 0;
this_cylinder_volume.geometry.is_exit_volume = 0;
this_cylinder_volume.geometry.is_mask_volume = 0;

// Read the material input, or if it lacks, use automatic linking.
if (mask_string && strlen(mask_string) && strcmp(mask_string, "NULL") && strcmp(mask_string, "0")) {
    // A mask volume is used to limit the extend of other volumes, called the masked volumes. These are specified in the mask_string.
    // In order for a ray to enter a masked volume, it needs to be both in the region covered by that volume AND the mask volume.
    // When more than
    this_cylinder_volume.geometry.mask_mode = 1; // Default is mask mode is ALL
    if (mask_setting && strlen(mask_setting) && strcmp(mask_setting, "NULL") && strcmp(mask_setting, "0")) {
        if (strcmp(mask_setting,"ALL") == 0 || strcmp(mask_setting,"All") == 0) this_cylinder_volume.geometry.mask_mode = 1;
        else if (strcmp(mask_setting,"ANY") == 0 || strcmp(mask_setting,"Any") == 0) this_cylinder_volume.geometry.mask_mode = 2;
        else {
            printf("The mask_mode of component %s is set to %s, but must be either ALL or ANY.\n",NAME_CURRENT_COMP,mask_setting);
            exit(1);
        }
    }
    
    for (loop_index=0;loop_index<global_geometry_list.num_elements;loop_index++) {
        // Add mask list
        if (1 == manual_linking_function(global_geometry_list.elements[loop_index].name,mask_string)) {
            add_element_to_int_list(&this_cylinder_volume.geometry.mask_list,global_geometry_list.elements[loop_index].component_index);
            add_element_to_int_list(&global_geometry_list.elements[loop_index].Volume->geometry.masked_by_list,INDEX_CURRENT_COMP);
            global_geometry_list.elements[loop_index].Volume->geometry.is_masked_volume = 1;
            if (this_cylinder_volume.geometry.mask_mode == 2)
                global_geometry_list.elements[loop_index].Volume->geometry.mask_mode = 2;
            if (this_cylinder_volume.geometry.mask_mode == 1) {
                if (global_geometry_list.elements[loop_index].Volume->geometry.is_masked_volume == 1 && global_geometry_list.elements[loop_index].Volume->geometry.mask_mode != 2)
                    // If more than one mask is added to one volume, the ANY mode overwrites the (default) ALL mode.
                    global_geometry_list.elements[loop_index].Volume->geometry.mask_mode = 1;
            }
            
            found_geometries = 1;
        }
    }
    if (found_geometries == 0) {
        printf("The mask_string in geometry: %s did not find any of the specified volumes in the mask_string %s \n",NAME_CURRENT_COMP,mask_string);
        exit(1);
    }
    this_cylinder_volume.p_physics = malloc(sizeof(struct physics_struct));
    this_cylinder_volume.p_physics->is_vacuum = 0; // Makes this volume a vacuum
    this_cylinder_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
    this_cylinder_volume.p_physics->my_a = 0; // Should not be used.
    sprintf(this_cylinder_volume.p_physics->name,"Mask");
    this_cylinder_volume.geometry.is_mask_volume = 1;
    
    
// Read the material input, or if it lacks, use automatic linking.
} else if (material_string && strlen(material_string) && strcmp(material_string, "NULL") && strcmp(material_string, "0")) {
    // A geometry string was given, use it to determine which material
    if (0 == strcmp(material_string,"vacuum") || 0 == strcmp(material_string,"Vacuum")) {
        // One could have a global physics struct for vacuum instead of creating one for each
        this_cylinder_volume.p_physics = malloc(sizeof(struct physics_struct));
        this_cylinder_volume.p_physics->is_vacuum = 1; // Makes this volume a vacuum
        this_cylinder_volume.p_physics->number_of_processes = (int) 0;
        this_cylinder_volume.p_physics->my_a = 0; // Should not be used.
        sprintf(this_cylinder_volume.p_physics->name,"Vacuum");
    } else if (0 == strcmp(material_string,"exit") || 0 == strcmp(material_string,"Exit")) {
        // One could have a global physics struct for exit instead of creating one for each
        this_cylinder_volume.p_physics = malloc(sizeof(struct physics_struct));
        this_cylinder_volume.p_physics->is_vacuum = 1; // Makes this volume a vacuum
        this_cylinder_volume.p_physics->number_of_processes = (int) 0;
        this_cylinder_volume.p_physics->my_a = 0; // Should not be used.
        this_cylinder_volume.geometry.is_exit_volume = 1;
        sprintf(this_cylinder_volume.p_physics->name,"Exit");
    } else {
        for (loop_index=0;loop_index<global_material_list.num_elements;loop_index++) {
          if (0 == strcmp(material_string,global_material_list.elements[loop_index].name)) {
            this_cylinder_volume.p_physics = global_material_list.elements[loop_index].physics;
            break;
          }
          if (loop_index == global_material_list.num_elements-1) {
            printf("\n");
            printf("ERROR: The material string \"%s\" in Union geometry \"%s\" did not match a specified material. \n",material_string,NAME_CURRENT_COMP);
            printf("       The materials available at this point (need to be defined before the geometry): \n");
            for (loop_index=0;loop_index<global_material_list.num_elements;loop_index++)
              printf("         %s\n",global_material_list.elements[loop_index].name);
            printf("\n");
            printf("       It is also possible to use one of the defualt materials avaiable: \n");
            printf("           Vacuum (for a Volume without scattering or absorption)\n");
            printf("           Exit (for a Volume where the ray exits the component if it enters)\n");
            printf("           Mask (for a Volume that masks existing volumes specified in the mask_string\n");
            exit(1);
          }
        }
    }
} else {
    // Automatic linking, simply using the last defined material.
    #ifndef MATERIAL_DETECTOR
        printf("Need to define a material before the geometry to use automatic linking %s.\n",NAME_CURRENT_COMP);
        exit(1);
    #endif
    this_cylinder_volume.p_physics = global_material_list.elements[global_material_list.num_elements-1].physics;
}

sprintf(this_cylinder_volume.name,NAME_CURRENT_COMP);
sprintf(this_cylinder_volume.geometry.shape,"cylinder");
this_cylinder_volume.geometry.priority_value = priority;
// Currently the coordinates will be in absolute space.
this_cylinder_volume.geometry.center = POS_A_CURRENT_COMP;

this_cylinder_volume.geometry.geometry_p_interact = p_interact;
this_cylinder_storage.cyl_radius = radius;
this_cylinder_storage.height = yheight;
this_cylinder_volume.geometry.visualization_on = visualize;
this_cylinder_volume.geometry.geometry_parameters.p_cylinder_storage = &this_cylinder_storage;
this_cylinder_volume.geometry.within_function = &r_within_cylinder;
this_cylinder_volume.geometry.intersect_function = &sample_cylinder_intersect;
this_cylinder_volume.geometry.mcdisplay_function = &mcdisplay_cylinder_function;
this_cylinder_volume.geometry.shell_points = &cylinder_shell_points;
this_cylinder_volume.geometry.initialize_from_main_function = &initialize_cylinder_geometry_from_main_component;
this_cylinder_volume.geometry.process_rot_allocated = 0;
this_cylinder_volume.geometry.copy_geometry_parameters = &allocate_cylinder_storage_copy;

rot_copy(this_cylinder_volume.geometry.rotation_matrix,ROT_A_CURRENT_COMP);
rot_transpose(ROT_A_CURRENT_COMP,this_cylinder_volume.geometry.transpose_rotation_matrix);

// Initialize loggers
this_cylinder_volume.loggers.num_elements = 0;

// packing the information into the global_geometry_element, which is then included in the global_geometry_list.
sprintf(global_geometry_element.name,NAME_CURRENT_COMP);
global_geometry_element.activation_counter = number_of_activations;
global_geometry_element.component_index = INDEX_CURRENT_COMP;
global_geometry_element.Volume = &this_cylinder_volume; // Would be nicer if this m was a pointer, now we have the (small) data two places
add_element_to_geometry_list(&global_geometry_list,global_geometry_element);
}
#line 170585 "MACS_sample_kidney_box.c"
#undef number_of_activations
#undef mask_setting
#undef mask_string
#undef p_interact
#undef focus_r
#undef focus_xh
#undef focus_xw
#undef focus_ah
#undef focus_aw
#undef target_z
#undef target_y
#undef target_x
#undef target_index
#undef visualize
#undef yheight
#undef radius
#undef priority
#undef material_string
#undef this_cylinder_storage
#undef global_geometry_element
#undef this_cylinder_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

  /* Initializations for component channel_0_cave2_box1. */
  SIG_MESSAGE("channel_0_cave2_box1 (Init)");
#define mccompcurname  channel_0_cave2_box1
#define mccompcurtype  Union_box
#define mccompcurindex 151
#define loop_index mccchannel_0_cave2_box1_loop_index
#define this_box_volume mccchannel_0_cave2_box1_this_box_volume
#define global_geometry_element mccchannel_0_cave2_box1_global_geometry_element
#define this_box_storage mccchannel_0_cave2_box1_this_box_storage
#define material_string mccchannel_0_cave2_box1_material_string
#define priority mccchannel_0_cave2_box1_priority
#define xwidth mccchannel_0_cave2_box1_xwidth
#define yheight mccchannel_0_cave2_box1_yheight
#define zdepth mccchannel_0_cave2_box1_zdepth
#define xwidth2 mccchannel_0_cave2_box1_xwidth2
#define yheight2 mccchannel_0_cave2_box1_yheight2
#define visualize mccchannel_0_cave2_box1_visualize
#define target_index mccchannel_0_cave2_box1_target_index
#define target_x mccchannel_0_cave2_box1_target_x
#define target_y mccchannel_0_cave2_box1_target_y
#define target_z mccchannel_0_cave2_box1_target_z
#define focus_aw mccchannel_0_cave2_box1_focus_aw
#define focus_ah mccchannel_0_cave2_box1_focus_ah
#define focus_xw mccchannel_0_cave2_box1_focus_xw
#define focus_xh mccchannel_0_cave2_box1_focus_xh
#define focus_r mccchannel_0_cave2_box1_focus_r
#define p_interact mccchannel_0_cave2_box1_p_interact
#define mask_string mccchannel_0_cave2_box1_mask_string
#define mask_setting mccchannel_0_cave2_box1_mask_setting
#define number_of_activations mccchannel_0_cave2_box1_number_of_activations
#line 224 "Union_box.comp"
{
// Initializes the focusing system for this volume including input sanitation.
focus_initialize(&this_box_volume.geometry, POS_A_COMP_INDEX(INDEX_CURRENT_COMP+target_index), POS_A_CURRENT_COMP, ROT_A_CURRENT_COMP, target_index, target_x, target_y, target_z, focus_aw, focus_ah, focus_xw, focus_xh, focus_r, NAME_CURRENT_COMP);

// Input sanitation for this geometry
if (xwidth <= 0) {
  printf("\nERROR in Union_box named %s, the xwidth is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (yheight <= 0) {
  printf("\nERROR in Union_box named %s, yheight is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (zdepth <= 0) {
  printf("\nERROR in Union_box named %s, zdepth is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (xwidth2 <= 0 && xwidth2 != -1) {
  printf("\nERROR in Union_box named %s, the xwidth2 is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (yheight2 <= 0 && yheight2 != -1) {
  printf("\nERROR in Union_box named %s, yheight2 is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}

// Use sanitation
if (global_material_list.num_elements == 0) {
  printf("\nERROR: Need to define a material using Union_make_material before using a Union geometry component. \n");
  printf("       %s was defined before first use of Union_make_material.\n",NAME_CURRENT_COMP);
  exit(1);
}

this_box_volume.geometry.is_masked_volume = 0;
this_box_volume.geometry.is_exit_volume = 0;
this_box_volume.geometry.is_mask_volume = 0;
// check if the volume is a mask, if it is the material string is irelevant.
if (mask_string && strlen(mask_string) && strcmp(mask_string, "NULL") && strcmp(mask_string, "0")) {
    // A mask volume is used to limit the extend of other volumes, called the masked volumes. These are specified in the mask_string.
    // In order for a ray to enter a masked volume, it needs to be both in the region covered by that volume AND the mask volume.
    // When more than
    this_box_volume.geometry.mask_mode = 1; // Default is mask mode is ALL
    if (mask_setting && strlen(mask_setting) && strcmp(mask_setting, "NULL") && strcmp(mask_setting, "0")) {
        if (strcmp(mask_setting,"ALL") == 0 || strcmp(mask_setting,"All") == 0) this_box_volume.geometry.mask_mode = 1;
        else if (strcmp(mask_setting,"ANY") == 0 || strcmp(mask_setting,"Any") == 0) this_box_volume.geometry.mask_mode = 2;
        else {
            printf("The mask_mode of component %s is set to %s, but must be either ALL or ANY.\n",NAME_CURRENT_COMP,mask_setting);
            exit(1);
        }
    }
    
    for (loop_index=0;loop_index<global_geometry_list.num_elements;loop_index++) {
        // Add mask list
        if (1 == manual_linking_function(global_geometry_list.elements[loop_index].name,mask_string)) {
            add_element_to_int_list(&this_box_volume.geometry.mask_list,global_geometry_list.elements[loop_index].component_index);
            add_element_to_int_list(&global_geometry_list.elements[loop_index].Volume->geometry.masked_by_list,INDEX_CURRENT_COMP);
            global_geometry_list.elements[loop_index].Volume->geometry.is_masked_volume = 1;
            if (this_box_volume.geometry.mask_mode == 2)
                global_geometry_list.elements[loop_index].Volume->geometry.mask_mode = 2;
            if (this_box_volume.geometry.mask_mode == 1) {
                if (global_geometry_list.elements[loop_index].Volume->geometry.is_masked_volume == 1 && global_geometry_list.elements[loop_index].Volume->geometry.mask_mode != 2)
                    // If more than one mask is added to one volume, the ANY mode overwrites the (default) ALL mode.
                    global_geometry_list.elements[loop_index].Volume->geometry.mask_mode = 1;
            }
            
            found_geometries = 1;
        }
    }
    if (found_geometries == 0) {
        printf("The mask_string in geometry: %s did not find any of the specified volumes in the mask_string %s \n",NAME_CURRENT_COMP,mask_string);
        exit(1);
    }
    this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
    this_box_volume.p_physics->is_vacuum = 0; // Makes this volume a vacuum
    this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
    this_box_volume.p_physics->my_a = 0; // Should not be used.
    sprintf(this_box_volume.p_physics->name,"Mask");
    this_box_volume.geometry.is_mask_volume = 1;
    
    
// Read the material input, or if it lacks, use automatic linking.
} else if (material_string && strlen(material_string) && strcmp(material_string, "NULL") && strcmp(material_string, "0")) {
    // A geometry string was given, use it to determine which material
    if (0 == strcmp(material_string,"vacuum") || 0 == strcmp(material_string,"Vacuum")) {
        // One could have a global physics struct for vacuum instead of creating one for each
        this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
        this_box_volume.p_physics->is_vacuum = 1; // Makes this volume a vacuum
        this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
        this_box_volume.p_physics->my_a = 0; // Should not be used.
        sprintf(this_box_volume.p_physics->name,"Vacuum");
    } else if (0 == strcmp(material_string,"exit") || 0 == strcmp(material_string,"Exit")) {
        // One could have a global physics struct for vacuum instead of creating one for each
        this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
        this_box_volume.p_physics->is_vacuum = 1; // Makes this volume a vacuum
        this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
        this_box_volume.p_physics->my_a = 0; // Should not be used.
        this_box_volume.geometry.is_exit_volume = 1;
        sprintf(this_box_volume.p_physics->name,"Exit");
    } else {
        #ifndef MATERIAL_DETECTOR
            printf("Need to define a material before refering to it in a geometry %s.\n",NAME_CURRENT_COMP);
            exit(1);
        #endif
        for (loop_index=0;loop_index<global_material_list.num_elements;loop_index++) {
            if (0 == strcmp(material_string,global_material_list.elements[loop_index].name)) {
                this_box_volume.p_physics = global_material_list.elements[loop_index].physics;
                break;
            }
            if (loop_index == global_material_list.num_elements-1) {
            printf("\n");
            printf("ERROR: The material string \"%s\" in Union geometry \"%s\" did not match a specified material. \n",material_string,NAME_CURRENT_COMP);
            printf("       The materials available at this point (need to be defined before the geometry): \n");
            for (loop_index=0;loop_index<global_material_list.num_elements;loop_index++)
              printf("         %s\n",global_material_list.elements[loop_index].name);
            printf("\n");
            printf("       It is also possible to use one of the defualt materials avaiable: \n");
            printf("           Vacuum (for a Volume without scattering or absorption)\n");
            printf("           Exit (for a Volume where the ray exits the component if it enters)\n");
            printf("           Mask (for a Volume that masks existing volumes specified in the mask_string\n");
            exit(1);
          }
        }
    }
} else {
    // Automatic linking, simply using the last defined material.
    #ifndef MATERIAL_DETECTOR
        printf("Need to define a material before the geometry to use automatic linking %s.\n",NAME_CURRENT_COMP);
        exit(1);
    #endif
    this_box_volume.p_physics = global_material_list.elements[global_material_list.num_elements-1].physics;
}

sprintf(this_box_volume.name,NAME_CURRENT_COMP);
sprintf(this_box_volume.geometry.shape,"box");
this_box_volume.geometry.priority_value = priority;
this_box_volume.geometry.geometry_p_interact = p_interact;
// Currently the coordinates will be in absolute space.
this_box_volume.geometry.center = POS_A_CURRENT_COMP;

this_box_storage.z_depth = zdepth;
this_box_storage.x_width1 = xwidth;
this_box_storage.y_height1 = yheight;

this_box_storage.is_rectangle = 0;
if (xwidth2 < 0 && yheight2 < 0) this_box_storage.is_rectangle = 1;
if (xwidth == xwidth2 && yheight == yheight2) this_box_storage.is_rectangle = 1;

if (xwidth2 < 0) {
    this_box_storage.x_width2 = xwidth;
    xwidth2 = xwidth;
} else this_box_storage.x_width2 = xwidth2;

if (yheight2 < 0) {
    this_box_storage.y_height2 = yheight;
    yheight2 = yheight;
} else this_box_storage.y_height2 = yheight2;


this_box_storage.normal_vectors[0] = coords_set(0,0,1);
this_box_storage.normal_vectors[1] = coords_set(0,0,1);

// for sides with y component = 0
x_component = 2*zdepth/sqrt((xwidth-xwidth2)*(xwidth-xwidth2)+4*zdepth*zdepth);
z_component = (xwidth-xwidth2)/sqrt(4*zdepth*zdepth+(xwidth-xwidth2)*(xwidth-xwidth2));

this_box_storage.normal_vectors[2] = coords_set(x_component,0,z_component);
this_box_storage.normal_vectors[3] = coords_set(-x_component,0,z_component);

// for sides with x component = 0
y_component = 2*zdepth/sqrt((yheight-yheight2)*(yheight-yheight2)+4*zdepth*zdepth);
z_component = (yheight-yheight2)/sqrt(4*zdepth*zdepth+(yheight-yheight2)*(yheight-yheight2));

this_box_storage.normal_vectors[4] = coords_set(0,y_component,z_component);
this_box_storage.normal_vectors[5] = coords_set(0,-y_component,z_component);

this_box_volume.geometry.visualization_on = visualize;

this_box_volume.geometry.geometry_parameters.p_box_storage = &this_box_storage;

// Assign pointers to functions for intersection with the shape, checking if a point is inside the shape
if (this_box_storage.is_rectangle == 1) {
this_box_volume.geometry.intersect_function = &sample_box_intersect_simple;
this_box_volume.geometry.within_function = &r_within_box_simple;
}
else {
this_box_volume.geometry.intersect_function = &sample_box_intersect_advanced;
this_box_volume.geometry.within_function = &r_within_box_advanced;
}

this_box_volume.geometry.shell_points = &box_shell_points;
this_box_volume.geometry.mcdisplay_function = &mcdisplay_box_function;
this_box_volume.geometry.initialize_from_main_function = &initialize_box_geometry_from_main_component;
this_box_volume.geometry.process_rot_allocated = 0;

this_box_volume.geometry.copy_geometry_parameters = &allocate_box_storage_copy;

rot_copy(this_box_volume.geometry.rotation_matrix,ROT_A_CURRENT_COMP); //check how ROT_R_CURRENT_COMP would work
rot_transpose(ROT_A_CURRENT_COMP,this_box_volume.geometry.transpose_rotation_matrix);

// Initialize loggers
this_box_volume.loggers.num_elements = 0;

// packing the information into the global_geometry_element, which is then included in the global_geometry_list.
sprintf(global_geometry_element.name,NAME_CURRENT_COMP);
global_geometry_element.activation_counter = number_of_activations;
global_geometry_element.component_index = INDEX_CURRENT_COMP;
global_geometry_element.Volume = &this_box_volume; // Would be nicer if this m was a pointer, now we have the (small) data two places
add_element_to_geometry_list(&global_geometry_list,global_geometry_element);
}
#line 170852 "MACS_sample_kidney_box.c"
#undef number_of_activations
#undef mask_setting
#undef mask_string
#undef p_interact
#undef focus_r
#undef focus_xh
#undef focus_xw
#undef focus_ah
#undef focus_aw
#undef target_z
#undef target_y
#undef target_x
#undef target_index
#undef visualize
#undef yheight2
#undef xwidth2
#undef zdepth
#undef yheight
#undef xwidth
#undef priority
#undef material_string
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

  /* Initializations for component channel_0_cave2_box2. */
  SIG_MESSAGE("channel_0_cave2_box2 (Init)");
#define mccompcurname  channel_0_cave2_box2
#define mccompcurtype  Union_box
#define mccompcurindex 152
#define loop_index mccchannel_0_cave2_box2_loop_index
#define this_box_volume mccchannel_0_cave2_box2_this_box_volume
#define global_geometry_element mccchannel_0_cave2_box2_global_geometry_element
#define this_box_storage mccchannel_0_cave2_box2_this_box_storage
#define material_string mccchannel_0_cave2_box2_material_string
#define priority mccchannel_0_cave2_box2_priority
#define xwidth mccchannel_0_cave2_box2_xwidth
#define yheight mccchannel_0_cave2_box2_yheight
#define zdepth mccchannel_0_cave2_box2_zdepth
#define xwidth2 mccchannel_0_cave2_box2_xwidth2
#define yheight2 mccchannel_0_cave2_box2_yheight2
#define visualize mccchannel_0_cave2_box2_visualize
#define target_index mccchannel_0_cave2_box2_target_index
#define target_x mccchannel_0_cave2_box2_target_x
#define target_y mccchannel_0_cave2_box2_target_y
#define target_z mccchannel_0_cave2_box2_target_z
#define focus_aw mccchannel_0_cave2_box2_focus_aw
#define focus_ah mccchannel_0_cave2_box2_focus_ah
#define focus_xw mccchannel_0_cave2_box2_focus_xw
#define focus_xh mccchannel_0_cave2_box2_focus_xh
#define focus_r mccchannel_0_cave2_box2_focus_r
#define p_interact mccchannel_0_cave2_box2_p_interact
#define mask_string mccchannel_0_cave2_box2_mask_string
#define mask_setting mccchannel_0_cave2_box2_mask_setting
#define number_of_activations mccchannel_0_cave2_box2_number_of_activations
#line 224 "Union_box.comp"
{
// Initializes the focusing system for this volume including input sanitation.
focus_initialize(&this_box_volume.geometry, POS_A_COMP_INDEX(INDEX_CURRENT_COMP+target_index), POS_A_CURRENT_COMP, ROT_A_CURRENT_COMP, target_index, target_x, target_y, target_z, focus_aw, focus_ah, focus_xw, focus_xh, focus_r, NAME_CURRENT_COMP);

// Input sanitation for this geometry
if (xwidth <= 0) {
  printf("\nERROR in Union_box named %s, the xwidth is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (yheight <= 0) {
  printf("\nERROR in Union_box named %s, yheight is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (zdepth <= 0) {
  printf("\nERROR in Union_box named %s, zdepth is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (xwidth2 <= 0 && xwidth2 != -1) {
  printf("\nERROR in Union_box named %s, the xwidth2 is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (yheight2 <= 0 && yheight2 != -1) {
  printf("\nERROR in Union_box named %s, yheight2 is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}

// Use sanitation
if (global_material_list.num_elements == 0) {
  printf("\nERROR: Need to define a material using Union_make_material before using a Union geometry component. \n");
  printf("       %s was defined before first use of Union_make_material.\n",NAME_CURRENT_COMP);
  exit(1);
}

this_box_volume.geometry.is_masked_volume = 0;
this_box_volume.geometry.is_exit_volume = 0;
this_box_volume.geometry.is_mask_volume = 0;
// check if the volume is a mask, if it is the material string is irelevant.
if (mask_string && strlen(mask_string) && strcmp(mask_string, "NULL") && strcmp(mask_string, "0")) {
    // A mask volume is used to limit the extend of other volumes, called the masked volumes. These are specified in the mask_string.
    // In order for a ray to enter a masked volume, it needs to be both in the region covered by that volume AND the mask volume.
    // When more than
    this_box_volume.geometry.mask_mode = 1; // Default is mask mode is ALL
    if (mask_setting && strlen(mask_setting) && strcmp(mask_setting, "NULL") && strcmp(mask_setting, "0")) {
        if (strcmp(mask_setting,"ALL") == 0 || strcmp(mask_setting,"All") == 0) this_box_volume.geometry.mask_mode = 1;
        else if (strcmp(mask_setting,"ANY") == 0 || strcmp(mask_setting,"Any") == 0) this_box_volume.geometry.mask_mode = 2;
        else {
            printf("The mask_mode of component %s is set to %s, but must be either ALL or ANY.\n",NAME_CURRENT_COMP,mask_setting);
            exit(1);
        }
    }
    
    for (loop_index=0;loop_index<global_geometry_list.num_elements;loop_index++) {
        // Add mask list
        if (1 == manual_linking_function(global_geometry_list.elements[loop_index].name,mask_string)) {
            add_element_to_int_list(&this_box_volume.geometry.mask_list,global_geometry_list.elements[loop_index].component_index);
            add_element_to_int_list(&global_geometry_list.elements[loop_index].Volume->geometry.masked_by_list,INDEX_CURRENT_COMP);
            global_geometry_list.elements[loop_index].Volume->geometry.is_masked_volume = 1;
            if (this_box_volume.geometry.mask_mode == 2)
                global_geometry_list.elements[loop_index].Volume->geometry.mask_mode = 2;
            if (this_box_volume.geometry.mask_mode == 1) {
                if (global_geometry_list.elements[loop_index].Volume->geometry.is_masked_volume == 1 && global_geometry_list.elements[loop_index].Volume->geometry.mask_mode != 2)
                    // If more than one mask is added to one volume, the ANY mode overwrites the (default) ALL mode.
                    global_geometry_list.elements[loop_index].Volume->geometry.mask_mode = 1;
            }
            
            found_geometries = 1;
        }
    }
    if (found_geometries == 0) {
        printf("The mask_string in geometry: %s did not find any of the specified volumes in the mask_string %s \n",NAME_CURRENT_COMP,mask_string);
        exit(1);
    }
    this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
    this_box_volume.p_physics->is_vacuum = 0; // Makes this volume a vacuum
    this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
    this_box_volume.p_physics->my_a = 0; // Should not be used.
    sprintf(this_box_volume.p_physics->name,"Mask");
    this_box_volume.geometry.is_mask_volume = 1;
    
    
// Read the material input, or if it lacks, use automatic linking.
} else if (material_string && strlen(material_string) && strcmp(material_string, "NULL") && strcmp(material_string, "0")) {
    // A geometry string was given, use it to determine which material
    if (0 == strcmp(material_string,"vacuum") || 0 == strcmp(material_string,"Vacuum")) {
        // One could have a global physics struct for vacuum instead of creating one for each
        this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
        this_box_volume.p_physics->is_vacuum = 1; // Makes this volume a vacuum
        this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
        this_box_volume.p_physics->my_a = 0; // Should not be used.
        sprintf(this_box_volume.p_physics->name,"Vacuum");
    } else if (0 == strcmp(material_string,"exit") || 0 == strcmp(material_string,"Exit")) {
        // One could have a global physics struct for vacuum instead of creating one for each
        this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
        this_box_volume.p_physics->is_vacuum = 1; // Makes this volume a vacuum
        this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
        this_box_volume.p_physics->my_a = 0; // Should not be used.
        this_box_volume.geometry.is_exit_volume = 1;
        sprintf(this_box_volume.p_physics->name,"Exit");
    } else {
        #ifndef MATERIAL_DETECTOR
            printf("Need to define a material before refering to it in a geometry %s.\n",NAME_CURRENT_COMP);
            exit(1);
        #endif
        for (loop_index=0;loop_index<global_material_list.num_elements;loop_index++) {
            if (0 == strcmp(material_string,global_material_list.elements[loop_index].name)) {
                this_box_volume.p_physics = global_material_list.elements[loop_index].physics;
                break;
            }
            if (loop_index == global_material_list.num_elements-1) {
            printf("\n");
            printf("ERROR: The material string \"%s\" in Union geometry \"%s\" did not match a specified material. \n",material_string,NAME_CURRENT_COMP);
            printf("       The materials available at this point (need to be defined before the geometry): \n");
            for (loop_index=0;loop_index<global_material_list.num_elements;loop_index++)
              printf("         %s\n",global_material_list.elements[loop_index].name);
            printf("\n");
            printf("       It is also possible to use one of the defualt materials avaiable: \n");
            printf("           Vacuum (for a Volume without scattering or absorption)\n");
            printf("           Exit (for a Volume where the ray exits the component if it enters)\n");
            printf("           Mask (for a Volume that masks existing volumes specified in the mask_string\n");
            exit(1);
          }
        }
    }
} else {
    // Automatic linking, simply using the last defined material.
    #ifndef MATERIAL_DETECTOR
        printf("Need to define a material before the geometry to use automatic linking %s.\n",NAME_CURRENT_COMP);
        exit(1);
    #endif
    this_box_volume.p_physics = global_material_list.elements[global_material_list.num_elements-1].physics;
}

sprintf(this_box_volume.name,NAME_CURRENT_COMP);
sprintf(this_box_volume.geometry.shape,"box");
this_box_volume.geometry.priority_value = priority;
this_box_volume.geometry.geometry_p_interact = p_interact;
// Currently the coordinates will be in absolute space.
this_box_volume.geometry.center = POS_A_CURRENT_COMP;

this_box_storage.z_depth = zdepth;
this_box_storage.x_width1 = xwidth;
this_box_storage.y_height1 = yheight;

this_box_storage.is_rectangle = 0;
if (xwidth2 < 0 && yheight2 < 0) this_box_storage.is_rectangle = 1;
if (xwidth == xwidth2 && yheight == yheight2) this_box_storage.is_rectangle = 1;

if (xwidth2 < 0) {
    this_box_storage.x_width2 = xwidth;
    xwidth2 = xwidth;
} else this_box_storage.x_width2 = xwidth2;

if (yheight2 < 0) {
    this_box_storage.y_height2 = yheight;
    yheight2 = yheight;
} else this_box_storage.y_height2 = yheight2;


this_box_storage.normal_vectors[0] = coords_set(0,0,1);
this_box_storage.normal_vectors[1] = coords_set(0,0,1);

// for sides with y component = 0
x_component = 2*zdepth/sqrt((xwidth-xwidth2)*(xwidth-xwidth2)+4*zdepth*zdepth);
z_component = (xwidth-xwidth2)/sqrt(4*zdepth*zdepth+(xwidth-xwidth2)*(xwidth-xwidth2));

this_box_storage.normal_vectors[2] = coords_set(x_component,0,z_component);
this_box_storage.normal_vectors[3] = coords_set(-x_component,0,z_component);

// for sides with x component = 0
y_component = 2*zdepth/sqrt((yheight-yheight2)*(yheight-yheight2)+4*zdepth*zdepth);
z_component = (yheight-yheight2)/sqrt(4*zdepth*zdepth+(yheight-yheight2)*(yheight-yheight2));

this_box_storage.normal_vectors[4] = coords_set(0,y_component,z_component);
this_box_storage.normal_vectors[5] = coords_set(0,-y_component,z_component);

this_box_volume.geometry.visualization_on = visualize;

this_box_volume.geometry.geometry_parameters.p_box_storage = &this_box_storage;

// Assign pointers to functions for intersection with the shape, checking if a point is inside the shape
if (this_box_storage.is_rectangle == 1) {
this_box_volume.geometry.intersect_function = &sample_box_intersect_simple;
this_box_volume.geometry.within_function = &r_within_box_simple;
}
else {
this_box_volume.geometry.intersect_function = &sample_box_intersect_advanced;
this_box_volume.geometry.within_function = &r_within_box_advanced;
}

this_box_volume.geometry.shell_points = &box_shell_points;
this_box_volume.geometry.mcdisplay_function = &mcdisplay_box_function;
this_box_volume.geometry.initialize_from_main_function = &initialize_box_geometry_from_main_component;
this_box_volume.geometry.process_rot_allocated = 0;

this_box_volume.geometry.copy_geometry_parameters = &allocate_box_storage_copy;

rot_copy(this_box_volume.geometry.rotation_matrix,ROT_A_CURRENT_COMP); //check how ROT_R_CURRENT_COMP would work
rot_transpose(ROT_A_CURRENT_COMP,this_box_volume.geometry.transpose_rotation_matrix);

// Initialize loggers
this_box_volume.loggers.num_elements = 0;

// packing the information into the global_geometry_element, which is then included in the global_geometry_list.
sprintf(global_geometry_element.name,NAME_CURRENT_COMP);
global_geometry_element.activation_counter = number_of_activations;
global_geometry_element.component_index = INDEX_CURRENT_COMP;
global_geometry_element.Volume = &this_box_volume; // Would be nicer if this m was a pointer, now we have the (small) data two places
add_element_to_geometry_list(&global_geometry_list,global_geometry_element);
}
#line 171122 "MACS_sample_kidney_box.c"
#undef number_of_activations
#undef mask_setting
#undef mask_string
#undef p_interact
#undef focus_r
#undef focus_xh
#undef focus_xw
#undef focus_ah
#undef focus_aw
#undef target_z
#undef target_y
#undef target_x
#undef target_index
#undef visualize
#undef yheight2
#undef xwidth2
#undef zdepth
#undef yheight
#undef xwidth
#undef priority
#undef material_string
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

  /* Initializations for component channel_0_cave2_box3. */
  SIG_MESSAGE("channel_0_cave2_box3 (Init)");
#define mccompcurname  channel_0_cave2_box3
#define mccompcurtype  Union_box
#define mccompcurindex 153
#define loop_index mccchannel_0_cave2_box3_loop_index
#define this_box_volume mccchannel_0_cave2_box3_this_box_volume
#define global_geometry_element mccchannel_0_cave2_box3_global_geometry_element
#define this_box_storage mccchannel_0_cave2_box3_this_box_storage
#define material_string mccchannel_0_cave2_box3_material_string
#define priority mccchannel_0_cave2_box3_priority
#define xwidth mccchannel_0_cave2_box3_xwidth
#define yheight mccchannel_0_cave2_box3_yheight
#define zdepth mccchannel_0_cave2_box3_zdepth
#define xwidth2 mccchannel_0_cave2_box3_xwidth2
#define yheight2 mccchannel_0_cave2_box3_yheight2
#define visualize mccchannel_0_cave2_box3_visualize
#define target_index mccchannel_0_cave2_box3_target_index
#define target_x mccchannel_0_cave2_box3_target_x
#define target_y mccchannel_0_cave2_box3_target_y
#define target_z mccchannel_0_cave2_box3_target_z
#define focus_aw mccchannel_0_cave2_box3_focus_aw
#define focus_ah mccchannel_0_cave2_box3_focus_ah
#define focus_xw mccchannel_0_cave2_box3_focus_xw
#define focus_xh mccchannel_0_cave2_box3_focus_xh
#define focus_r mccchannel_0_cave2_box3_focus_r
#define p_interact mccchannel_0_cave2_box3_p_interact
#define mask_string mccchannel_0_cave2_box3_mask_string
#define mask_setting mccchannel_0_cave2_box3_mask_setting
#define number_of_activations mccchannel_0_cave2_box3_number_of_activations
#line 224 "Union_box.comp"
{
// Initializes the focusing system for this volume including input sanitation.
focus_initialize(&this_box_volume.geometry, POS_A_COMP_INDEX(INDEX_CURRENT_COMP+target_index), POS_A_CURRENT_COMP, ROT_A_CURRENT_COMP, target_index, target_x, target_y, target_z, focus_aw, focus_ah, focus_xw, focus_xh, focus_r, NAME_CURRENT_COMP);

// Input sanitation for this geometry
if (xwidth <= 0) {
  printf("\nERROR in Union_box named %s, the xwidth is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (yheight <= 0) {
  printf("\nERROR in Union_box named %s, yheight is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (zdepth <= 0) {
  printf("\nERROR in Union_box named %s, zdepth is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (xwidth2 <= 0 && xwidth2 != -1) {
  printf("\nERROR in Union_box named %s, the xwidth2 is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (yheight2 <= 0 && yheight2 != -1) {
  printf("\nERROR in Union_box named %s, yheight2 is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}

// Use sanitation
if (global_material_list.num_elements == 0) {
  printf("\nERROR: Need to define a material using Union_make_material before using a Union geometry component. \n");
  printf("       %s was defined before first use of Union_make_material.\n",NAME_CURRENT_COMP);
  exit(1);
}

this_box_volume.geometry.is_masked_volume = 0;
this_box_volume.geometry.is_exit_volume = 0;
this_box_volume.geometry.is_mask_volume = 0;
// check if the volume is a mask, if it is the material string is irelevant.
if (mask_string && strlen(mask_string) && strcmp(mask_string, "NULL") && strcmp(mask_string, "0")) {
    // A mask volume is used to limit the extend of other volumes, called the masked volumes. These are specified in the mask_string.
    // In order for a ray to enter a masked volume, it needs to be both in the region covered by that volume AND the mask volume.
    // When more than
    this_box_volume.geometry.mask_mode = 1; // Default is mask mode is ALL
    if (mask_setting && strlen(mask_setting) && strcmp(mask_setting, "NULL") && strcmp(mask_setting, "0")) {
        if (strcmp(mask_setting,"ALL") == 0 || strcmp(mask_setting,"All") == 0) this_box_volume.geometry.mask_mode = 1;
        else if (strcmp(mask_setting,"ANY") == 0 || strcmp(mask_setting,"Any") == 0) this_box_volume.geometry.mask_mode = 2;
        else {
            printf("The mask_mode of component %s is set to %s, but must be either ALL or ANY.\n",NAME_CURRENT_COMP,mask_setting);
            exit(1);
        }
    }
    
    for (loop_index=0;loop_index<global_geometry_list.num_elements;loop_index++) {
        // Add mask list
        if (1 == manual_linking_function(global_geometry_list.elements[loop_index].name,mask_string)) {
            add_element_to_int_list(&this_box_volume.geometry.mask_list,global_geometry_list.elements[loop_index].component_index);
            add_element_to_int_list(&global_geometry_list.elements[loop_index].Volume->geometry.masked_by_list,INDEX_CURRENT_COMP);
            global_geometry_list.elements[loop_index].Volume->geometry.is_masked_volume = 1;
            if (this_box_volume.geometry.mask_mode == 2)
                global_geometry_list.elements[loop_index].Volume->geometry.mask_mode = 2;
            if (this_box_volume.geometry.mask_mode == 1) {
                if (global_geometry_list.elements[loop_index].Volume->geometry.is_masked_volume == 1 && global_geometry_list.elements[loop_index].Volume->geometry.mask_mode != 2)
                    // If more than one mask is added to one volume, the ANY mode overwrites the (default) ALL mode.
                    global_geometry_list.elements[loop_index].Volume->geometry.mask_mode = 1;
            }
            
            found_geometries = 1;
        }
    }
    if (found_geometries == 0) {
        printf("The mask_string in geometry: %s did not find any of the specified volumes in the mask_string %s \n",NAME_CURRENT_COMP,mask_string);
        exit(1);
    }
    this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
    this_box_volume.p_physics->is_vacuum = 0; // Makes this volume a vacuum
    this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
    this_box_volume.p_physics->my_a = 0; // Should not be used.
    sprintf(this_box_volume.p_physics->name,"Mask");
    this_box_volume.geometry.is_mask_volume = 1;
    
    
// Read the material input, or if it lacks, use automatic linking.
} else if (material_string && strlen(material_string) && strcmp(material_string, "NULL") && strcmp(material_string, "0")) {
    // A geometry string was given, use it to determine which material
    if (0 == strcmp(material_string,"vacuum") || 0 == strcmp(material_string,"Vacuum")) {
        // One could have a global physics struct for vacuum instead of creating one for each
        this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
        this_box_volume.p_physics->is_vacuum = 1; // Makes this volume a vacuum
        this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
        this_box_volume.p_physics->my_a = 0; // Should not be used.
        sprintf(this_box_volume.p_physics->name,"Vacuum");
    } else if (0 == strcmp(material_string,"exit") || 0 == strcmp(material_string,"Exit")) {
        // One could have a global physics struct for vacuum instead of creating one for each
        this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
        this_box_volume.p_physics->is_vacuum = 1; // Makes this volume a vacuum
        this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
        this_box_volume.p_physics->my_a = 0; // Should not be used.
        this_box_volume.geometry.is_exit_volume = 1;
        sprintf(this_box_volume.p_physics->name,"Exit");
    } else {
        #ifndef MATERIAL_DETECTOR
            printf("Need to define a material before refering to it in a geometry %s.\n",NAME_CURRENT_COMP);
            exit(1);
        #endif
        for (loop_index=0;loop_index<global_material_list.num_elements;loop_index++) {
            if (0 == strcmp(material_string,global_material_list.elements[loop_index].name)) {
                this_box_volume.p_physics = global_material_list.elements[loop_index].physics;
                break;
            }
            if (loop_index == global_material_list.num_elements-1) {
            printf("\n");
            printf("ERROR: The material string \"%s\" in Union geometry \"%s\" did not match a specified material. \n",material_string,NAME_CURRENT_COMP);
            printf("       The materials available at this point (need to be defined before the geometry): \n");
            for (loop_index=0;loop_index<global_material_list.num_elements;loop_index++)
              printf("         %s\n",global_material_list.elements[loop_index].name);
            printf("\n");
            printf("       It is also possible to use one of the defualt materials avaiable: \n");
            printf("           Vacuum (for a Volume without scattering or absorption)\n");
            printf("           Exit (for a Volume where the ray exits the component if it enters)\n");
            printf("           Mask (for a Volume that masks existing volumes specified in the mask_string\n");
            exit(1);
          }
        }
    }
} else {
    // Automatic linking, simply using the last defined material.
    #ifndef MATERIAL_DETECTOR
        printf("Need to define a material before the geometry to use automatic linking %s.\n",NAME_CURRENT_COMP);
        exit(1);
    #endif
    this_box_volume.p_physics = global_material_list.elements[global_material_list.num_elements-1].physics;
}

sprintf(this_box_volume.name,NAME_CURRENT_COMP);
sprintf(this_box_volume.geometry.shape,"box");
this_box_volume.geometry.priority_value = priority;
this_box_volume.geometry.geometry_p_interact = p_interact;
// Currently the coordinates will be in absolute space.
this_box_volume.geometry.center = POS_A_CURRENT_COMP;

this_box_storage.z_depth = zdepth;
this_box_storage.x_width1 = xwidth;
this_box_storage.y_height1 = yheight;

this_box_storage.is_rectangle = 0;
if (xwidth2 < 0 && yheight2 < 0) this_box_storage.is_rectangle = 1;
if (xwidth == xwidth2 && yheight == yheight2) this_box_storage.is_rectangle = 1;

if (xwidth2 < 0) {
    this_box_storage.x_width2 = xwidth;
    xwidth2 = xwidth;
} else this_box_storage.x_width2 = xwidth2;

if (yheight2 < 0) {
    this_box_storage.y_height2 = yheight;
    yheight2 = yheight;
} else this_box_storage.y_height2 = yheight2;


this_box_storage.normal_vectors[0] = coords_set(0,0,1);
this_box_storage.normal_vectors[1] = coords_set(0,0,1);

// for sides with y component = 0
x_component = 2*zdepth/sqrt((xwidth-xwidth2)*(xwidth-xwidth2)+4*zdepth*zdepth);
z_component = (xwidth-xwidth2)/sqrt(4*zdepth*zdepth+(xwidth-xwidth2)*(xwidth-xwidth2));

this_box_storage.normal_vectors[2] = coords_set(x_component,0,z_component);
this_box_storage.normal_vectors[3] = coords_set(-x_component,0,z_component);

// for sides with x component = 0
y_component = 2*zdepth/sqrt((yheight-yheight2)*(yheight-yheight2)+4*zdepth*zdepth);
z_component = (yheight-yheight2)/sqrt(4*zdepth*zdepth+(yheight-yheight2)*(yheight-yheight2));

this_box_storage.normal_vectors[4] = coords_set(0,y_component,z_component);
this_box_storage.normal_vectors[5] = coords_set(0,-y_component,z_component);

this_box_volume.geometry.visualization_on = visualize;

this_box_volume.geometry.geometry_parameters.p_box_storage = &this_box_storage;

// Assign pointers to functions for intersection with the shape, checking if a point is inside the shape
if (this_box_storage.is_rectangle == 1) {
this_box_volume.geometry.intersect_function = &sample_box_intersect_simple;
this_box_volume.geometry.within_function = &r_within_box_simple;
}
else {
this_box_volume.geometry.intersect_function = &sample_box_intersect_advanced;
this_box_volume.geometry.within_function = &r_within_box_advanced;
}

this_box_volume.geometry.shell_points = &box_shell_points;
this_box_volume.geometry.mcdisplay_function = &mcdisplay_box_function;
this_box_volume.geometry.initialize_from_main_function = &initialize_box_geometry_from_main_component;
this_box_volume.geometry.process_rot_allocated = 0;

this_box_volume.geometry.copy_geometry_parameters = &allocate_box_storage_copy;

rot_copy(this_box_volume.geometry.rotation_matrix,ROT_A_CURRENT_COMP); //check how ROT_R_CURRENT_COMP would work
rot_transpose(ROT_A_CURRENT_COMP,this_box_volume.geometry.transpose_rotation_matrix);

// Initialize loggers
this_box_volume.loggers.num_elements = 0;

// packing the information into the global_geometry_element, which is then included in the global_geometry_list.
sprintf(global_geometry_element.name,NAME_CURRENT_COMP);
global_geometry_element.activation_counter = number_of_activations;
global_geometry_element.component_index = INDEX_CURRENT_COMP;
global_geometry_element.Volume = &this_box_volume; // Would be nicer if this m was a pointer, now we have the (small) data two places
add_element_to_geometry_list(&global_geometry_list,global_geometry_element);
}
#line 171392 "MACS_sample_kidney_box.c"
#undef number_of_activations
#undef mask_setting
#undef mask_string
#undef p_interact
#undef focus_r
#undef focus_xh
#undef focus_xw
#undef focus_ah
#undef focus_aw
#undef target_z
#undef target_y
#undef target_x
#undef target_index
#undef visualize
#undef yheight2
#undef xwidth2
#undef zdepth
#undef yheight
#undef xwidth
#undef priority
#undef material_string
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

  /* Initializations for component inter_analyzer_colimator_center_0. */
  SIG_MESSAGE("inter_analyzer_colimator_center_0 (Init)");

  /* Initializations for component inter_analyzer_colimator_0_blade_0. */
  SIG_MESSAGE("inter_analyzer_colimator_0_blade_0 (Init)");
#define mccompcurname  inter_analyzer_colimator_0_blade_0
#define mccompcurtype  Union_box
#define mccompcurindex 155
#define loop_index mccinter_analyzer_colimator_0_blade_0_loop_index
#define this_box_volume mccinter_analyzer_colimator_0_blade_0_this_box_volume
#define global_geometry_element mccinter_analyzer_colimator_0_blade_0_global_geometry_element
#define this_box_storage mccinter_analyzer_colimator_0_blade_0_this_box_storage
#define material_string mccinter_analyzer_colimator_0_blade_0_material_string
#define priority mccinter_analyzer_colimator_0_blade_0_priority
#define xwidth mccinter_analyzer_colimator_0_blade_0_xwidth
#define yheight mccinter_analyzer_colimator_0_blade_0_yheight
#define zdepth mccinter_analyzer_colimator_0_blade_0_zdepth
#define xwidth2 mccinter_analyzer_colimator_0_blade_0_xwidth2
#define yheight2 mccinter_analyzer_colimator_0_blade_0_yheight2
#define visualize mccinter_analyzer_colimator_0_blade_0_visualize
#define target_index mccinter_analyzer_colimator_0_blade_0_target_index
#define target_x mccinter_analyzer_colimator_0_blade_0_target_x
#define target_y mccinter_analyzer_colimator_0_blade_0_target_y
#define target_z mccinter_analyzer_colimator_0_blade_0_target_z
#define focus_aw mccinter_analyzer_colimator_0_blade_0_focus_aw
#define focus_ah mccinter_analyzer_colimator_0_blade_0_focus_ah
#define focus_xw mccinter_analyzer_colimator_0_blade_0_focus_xw
#define focus_xh mccinter_analyzer_colimator_0_blade_0_focus_xh
#define focus_r mccinter_analyzer_colimator_0_blade_0_focus_r
#define p_interact mccinter_analyzer_colimator_0_blade_0_p_interact
#define mask_string mccinter_analyzer_colimator_0_blade_0_mask_string
#define mask_setting mccinter_analyzer_colimator_0_blade_0_mask_setting
#define number_of_activations mccinter_analyzer_colimator_0_blade_0_number_of_activations
#line 224 "Union_box.comp"
{
// Initializes the focusing system for this volume including input sanitation.
focus_initialize(&this_box_volume.geometry, POS_A_COMP_INDEX(INDEX_CURRENT_COMP+target_index), POS_A_CURRENT_COMP, ROT_A_CURRENT_COMP, target_index, target_x, target_y, target_z, focus_aw, focus_ah, focus_xw, focus_xh, focus_r, NAME_CURRENT_COMP);

// Input sanitation for this geometry
if (xwidth <= 0) {
  printf("\nERROR in Union_box named %s, the xwidth is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (yheight <= 0) {
  printf("\nERROR in Union_box named %s, yheight is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (zdepth <= 0) {
  printf("\nERROR in Union_box named %s, zdepth is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (xwidth2 <= 0 && xwidth2 != -1) {
  printf("\nERROR in Union_box named %s, the xwidth2 is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (yheight2 <= 0 && yheight2 != -1) {
  printf("\nERROR in Union_box named %s, yheight2 is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}

// Use sanitation
if (global_material_list.num_elements == 0) {
  printf("\nERROR: Need to define a material using Union_make_material before using a Union geometry component. \n");
  printf("       %s was defined before first use of Union_make_material.\n",NAME_CURRENT_COMP);
  exit(1);
}

this_box_volume.geometry.is_masked_volume = 0;
this_box_volume.geometry.is_exit_volume = 0;
this_box_volume.geometry.is_mask_volume = 0;
// check if the volume is a mask, if it is the material string is irelevant.
if (mask_string && strlen(mask_string) && strcmp(mask_string, "NULL") && strcmp(mask_string, "0")) {
    // A mask volume is used to limit the extend of other volumes, called the masked volumes. These are specified in the mask_string.
    // In order for a ray to enter a masked volume, it needs to be both in the region covered by that volume AND the mask volume.
    // When more than
    this_box_volume.geometry.mask_mode = 1; // Default is mask mode is ALL
    if (mask_setting && strlen(mask_setting) && strcmp(mask_setting, "NULL") && strcmp(mask_setting, "0")) {
        if (strcmp(mask_setting,"ALL") == 0 || strcmp(mask_setting,"All") == 0) this_box_volume.geometry.mask_mode = 1;
        else if (strcmp(mask_setting,"ANY") == 0 || strcmp(mask_setting,"Any") == 0) this_box_volume.geometry.mask_mode = 2;
        else {
            printf("The mask_mode of component %s is set to %s, but must be either ALL or ANY.\n",NAME_CURRENT_COMP,mask_setting);
            exit(1);
        }
    }
    
    for (loop_index=0;loop_index<global_geometry_list.num_elements;loop_index++) {
        // Add mask list
        if (1 == manual_linking_function(global_geometry_list.elements[loop_index].name,mask_string)) {
            add_element_to_int_list(&this_box_volume.geometry.mask_list,global_geometry_list.elements[loop_index].component_index);
            add_element_to_int_list(&global_geometry_list.elements[loop_index].Volume->geometry.masked_by_list,INDEX_CURRENT_COMP);
            global_geometry_list.elements[loop_index].Volume->geometry.is_masked_volume = 1;
            if (this_box_volume.geometry.mask_mode == 2)
                global_geometry_list.elements[loop_index].Volume->geometry.mask_mode = 2;
            if (this_box_volume.geometry.mask_mode == 1) {
                if (global_geometry_list.elements[loop_index].Volume->geometry.is_masked_volume == 1 && global_geometry_list.elements[loop_index].Volume->geometry.mask_mode != 2)
                    // If more than one mask is added to one volume, the ANY mode overwrites the (default) ALL mode.
                    global_geometry_list.elements[loop_index].Volume->geometry.mask_mode = 1;
            }
            
            found_geometries = 1;
        }
    }
    if (found_geometries == 0) {
        printf("The mask_string in geometry: %s did not find any of the specified volumes in the mask_string %s \n",NAME_CURRENT_COMP,mask_string);
        exit(1);
    }
    this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
    this_box_volume.p_physics->is_vacuum = 0; // Makes this volume a vacuum
    this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
    this_box_volume.p_physics->my_a = 0; // Should not be used.
    sprintf(this_box_volume.p_physics->name,"Mask");
    this_box_volume.geometry.is_mask_volume = 1;
    
    
// Read the material input, or if it lacks, use automatic linking.
} else if (material_string && strlen(material_string) && strcmp(material_string, "NULL") && strcmp(material_string, "0")) {
    // A geometry string was given, use it to determine which material
    if (0 == strcmp(material_string,"vacuum") || 0 == strcmp(material_string,"Vacuum")) {
        // One could have a global physics struct for vacuum instead of creating one for each
        this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
        this_box_volume.p_physics->is_vacuum = 1; // Makes this volume a vacuum
        this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
        this_box_volume.p_physics->my_a = 0; // Should not be used.
        sprintf(this_box_volume.p_physics->name,"Vacuum");
    } else if (0 == strcmp(material_string,"exit") || 0 == strcmp(material_string,"Exit")) {
        // One could have a global physics struct for vacuum instead of creating one for each
        this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
        this_box_volume.p_physics->is_vacuum = 1; // Makes this volume a vacuum
        this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
        this_box_volume.p_physics->my_a = 0; // Should not be used.
        this_box_volume.geometry.is_exit_volume = 1;
        sprintf(this_box_volume.p_physics->name,"Exit");
    } else {
        #ifndef MATERIAL_DETECTOR
            printf("Need to define a material before refering to it in a geometry %s.\n",NAME_CURRENT_COMP);
            exit(1);
        #endif
        for (loop_index=0;loop_index<global_material_list.num_elements;loop_index++) {
            if (0 == strcmp(material_string,global_material_list.elements[loop_index].name)) {
                this_box_volume.p_physics = global_material_list.elements[loop_index].physics;
                break;
            }
            if (loop_index == global_material_list.num_elements-1) {
            printf("\n");
            printf("ERROR: The material string \"%s\" in Union geometry \"%s\" did not match a specified material. \n",material_string,NAME_CURRENT_COMP);
            printf("       The materials available at this point (need to be defined before the geometry): \n");
            for (loop_index=0;loop_index<global_material_list.num_elements;loop_index++)
              printf("         %s\n",global_material_list.elements[loop_index].name);
            printf("\n");
            printf("       It is also possible to use one of the defualt materials avaiable: \n");
            printf("           Vacuum (for a Volume without scattering or absorption)\n");
            printf("           Exit (for a Volume where the ray exits the component if it enters)\n");
            printf("           Mask (for a Volume that masks existing volumes specified in the mask_string\n");
            exit(1);
          }
        }
    }
} else {
    // Automatic linking, simply using the last defined material.
    #ifndef MATERIAL_DETECTOR
        printf("Need to define a material before the geometry to use automatic linking %s.\n",NAME_CURRENT_COMP);
        exit(1);
    #endif
    this_box_volume.p_physics = global_material_list.elements[global_material_list.num_elements-1].physics;
}

sprintf(this_box_volume.name,NAME_CURRENT_COMP);
sprintf(this_box_volume.geometry.shape,"box");
this_box_volume.geometry.priority_value = priority;
this_box_volume.geometry.geometry_p_interact = p_interact;
// Currently the coordinates will be in absolute space.
this_box_volume.geometry.center = POS_A_CURRENT_COMP;

this_box_storage.z_depth = zdepth;
this_box_storage.x_width1 = xwidth;
this_box_storage.y_height1 = yheight;

this_box_storage.is_rectangle = 0;
if (xwidth2 < 0 && yheight2 < 0) this_box_storage.is_rectangle = 1;
if (xwidth == xwidth2 && yheight == yheight2) this_box_storage.is_rectangle = 1;

if (xwidth2 < 0) {
    this_box_storage.x_width2 = xwidth;
    xwidth2 = xwidth;
} else this_box_storage.x_width2 = xwidth2;

if (yheight2 < 0) {
    this_box_storage.y_height2 = yheight;
    yheight2 = yheight;
} else this_box_storage.y_height2 = yheight2;


this_box_storage.normal_vectors[0] = coords_set(0,0,1);
this_box_storage.normal_vectors[1] = coords_set(0,0,1);

// for sides with y component = 0
x_component = 2*zdepth/sqrt((xwidth-xwidth2)*(xwidth-xwidth2)+4*zdepth*zdepth);
z_component = (xwidth-xwidth2)/sqrt(4*zdepth*zdepth+(xwidth-xwidth2)*(xwidth-xwidth2));

this_box_storage.normal_vectors[2] = coords_set(x_component,0,z_component);
this_box_storage.normal_vectors[3] = coords_set(-x_component,0,z_component);

// for sides with x component = 0
y_component = 2*zdepth/sqrt((yheight-yheight2)*(yheight-yheight2)+4*zdepth*zdepth);
z_component = (yheight-yheight2)/sqrt(4*zdepth*zdepth+(yheight-yheight2)*(yheight-yheight2));

this_box_storage.normal_vectors[4] = coords_set(0,y_component,z_component);
this_box_storage.normal_vectors[5] = coords_set(0,-y_component,z_component);

this_box_volume.geometry.visualization_on = visualize;

this_box_volume.geometry.geometry_parameters.p_box_storage = &this_box_storage;

// Assign pointers to functions for intersection with the shape, checking if a point is inside the shape
if (this_box_storage.is_rectangle == 1) {
this_box_volume.geometry.intersect_function = &sample_box_intersect_simple;
this_box_volume.geometry.within_function = &r_within_box_simple;
}
else {
this_box_volume.geometry.intersect_function = &sample_box_intersect_advanced;
this_box_volume.geometry.within_function = &r_within_box_advanced;
}

this_box_volume.geometry.shell_points = &box_shell_points;
this_box_volume.geometry.mcdisplay_function = &mcdisplay_box_function;
this_box_volume.geometry.initialize_from_main_function = &initialize_box_geometry_from_main_component;
this_box_volume.geometry.process_rot_allocated = 0;

this_box_volume.geometry.copy_geometry_parameters = &allocate_box_storage_copy;

rot_copy(this_box_volume.geometry.rotation_matrix,ROT_A_CURRENT_COMP); //check how ROT_R_CURRENT_COMP would work
rot_transpose(ROT_A_CURRENT_COMP,this_box_volume.geometry.transpose_rotation_matrix);

// Initialize loggers
this_box_volume.loggers.num_elements = 0;

// packing the information into the global_geometry_element, which is then included in the global_geometry_list.
sprintf(global_geometry_element.name,NAME_CURRENT_COMP);
global_geometry_element.activation_counter = number_of_activations;
global_geometry_element.component_index = INDEX_CURRENT_COMP;
global_geometry_element.Volume = &this_box_volume; // Would be nicer if this m was a pointer, now we have the (small) data two places
add_element_to_geometry_list(&global_geometry_list,global_geometry_element);
}
#line 171665 "MACS_sample_kidney_box.c"
#undef number_of_activations
#undef mask_setting
#undef mask_string
#undef p_interact
#undef focus_r
#undef focus_xh
#undef focus_xw
#undef focus_ah
#undef focus_aw
#undef target_z
#undef target_y
#undef target_x
#undef target_index
#undef visualize
#undef yheight2
#undef xwidth2
#undef zdepth
#undef yheight
#undef xwidth
#undef priority
#undef material_string
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

  /* Initializations for component inter_analyzer_colimator_0_blade_1. */
  SIG_MESSAGE("inter_analyzer_colimator_0_blade_1 (Init)");
#define mccompcurname  inter_analyzer_colimator_0_blade_1
#define mccompcurtype  Union_box
#define mccompcurindex 156
#define loop_index mccinter_analyzer_colimator_0_blade_1_loop_index
#define this_box_volume mccinter_analyzer_colimator_0_blade_1_this_box_volume
#define global_geometry_element mccinter_analyzer_colimator_0_blade_1_global_geometry_element
#define this_box_storage mccinter_analyzer_colimator_0_blade_1_this_box_storage
#define material_string mccinter_analyzer_colimator_0_blade_1_material_string
#define priority mccinter_analyzer_colimator_0_blade_1_priority
#define xwidth mccinter_analyzer_colimator_0_blade_1_xwidth
#define yheight mccinter_analyzer_colimator_0_blade_1_yheight
#define zdepth mccinter_analyzer_colimator_0_blade_1_zdepth
#define xwidth2 mccinter_analyzer_colimator_0_blade_1_xwidth2
#define yheight2 mccinter_analyzer_colimator_0_blade_1_yheight2
#define visualize mccinter_analyzer_colimator_0_blade_1_visualize
#define target_index mccinter_analyzer_colimator_0_blade_1_target_index
#define target_x mccinter_analyzer_colimator_0_blade_1_target_x
#define target_y mccinter_analyzer_colimator_0_blade_1_target_y
#define target_z mccinter_analyzer_colimator_0_blade_1_target_z
#define focus_aw mccinter_analyzer_colimator_0_blade_1_focus_aw
#define focus_ah mccinter_analyzer_colimator_0_blade_1_focus_ah
#define focus_xw mccinter_analyzer_colimator_0_blade_1_focus_xw
#define focus_xh mccinter_analyzer_colimator_0_blade_1_focus_xh
#define focus_r mccinter_analyzer_colimator_0_blade_1_focus_r
#define p_interact mccinter_analyzer_colimator_0_blade_1_p_interact
#define mask_string mccinter_analyzer_colimator_0_blade_1_mask_string
#define mask_setting mccinter_analyzer_colimator_0_blade_1_mask_setting
#define number_of_activations mccinter_analyzer_colimator_0_blade_1_number_of_activations
#line 224 "Union_box.comp"
{
// Initializes the focusing system for this volume including input sanitation.
focus_initialize(&this_box_volume.geometry, POS_A_COMP_INDEX(INDEX_CURRENT_COMP+target_index), POS_A_CURRENT_COMP, ROT_A_CURRENT_COMP, target_index, target_x, target_y, target_z, focus_aw, focus_ah, focus_xw, focus_xh, focus_r, NAME_CURRENT_COMP);

// Input sanitation for this geometry
if (xwidth <= 0) {
  printf("\nERROR in Union_box named %s, the xwidth is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (yheight <= 0) {
  printf("\nERROR in Union_box named %s, yheight is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (zdepth <= 0) {
  printf("\nERROR in Union_box named %s, zdepth is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (xwidth2 <= 0 && xwidth2 != -1) {
  printf("\nERROR in Union_box named %s, the xwidth2 is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (yheight2 <= 0 && yheight2 != -1) {
  printf("\nERROR in Union_box named %s, yheight2 is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}

// Use sanitation
if (global_material_list.num_elements == 0) {
  printf("\nERROR: Need to define a material using Union_make_material before using a Union geometry component. \n");
  printf("       %s was defined before first use of Union_make_material.\n",NAME_CURRENT_COMP);
  exit(1);
}

this_box_volume.geometry.is_masked_volume = 0;
this_box_volume.geometry.is_exit_volume = 0;
this_box_volume.geometry.is_mask_volume = 0;
// check if the volume is a mask, if it is the material string is irelevant.
if (mask_string && strlen(mask_string) && strcmp(mask_string, "NULL") && strcmp(mask_string, "0")) {
    // A mask volume is used to limit the extend of other volumes, called the masked volumes. These are specified in the mask_string.
    // In order for a ray to enter a masked volume, it needs to be both in the region covered by that volume AND the mask volume.
    // When more than
    this_box_volume.geometry.mask_mode = 1; // Default is mask mode is ALL
    if (mask_setting && strlen(mask_setting) && strcmp(mask_setting, "NULL") && strcmp(mask_setting, "0")) {
        if (strcmp(mask_setting,"ALL") == 0 || strcmp(mask_setting,"All") == 0) this_box_volume.geometry.mask_mode = 1;
        else if (strcmp(mask_setting,"ANY") == 0 || strcmp(mask_setting,"Any") == 0) this_box_volume.geometry.mask_mode = 2;
        else {
            printf("The mask_mode of component %s is set to %s, but must be either ALL or ANY.\n",NAME_CURRENT_COMP,mask_setting);
            exit(1);
        }
    }
    
    for (loop_index=0;loop_index<global_geometry_list.num_elements;loop_index++) {
        // Add mask list
        if (1 == manual_linking_function(global_geometry_list.elements[loop_index].name,mask_string)) {
            add_element_to_int_list(&this_box_volume.geometry.mask_list,global_geometry_list.elements[loop_index].component_index);
            add_element_to_int_list(&global_geometry_list.elements[loop_index].Volume->geometry.masked_by_list,INDEX_CURRENT_COMP);
            global_geometry_list.elements[loop_index].Volume->geometry.is_masked_volume = 1;
            if (this_box_volume.geometry.mask_mode == 2)
                global_geometry_list.elements[loop_index].Volume->geometry.mask_mode = 2;
            if (this_box_volume.geometry.mask_mode == 1) {
                if (global_geometry_list.elements[loop_index].Volume->geometry.is_masked_volume == 1 && global_geometry_list.elements[loop_index].Volume->geometry.mask_mode != 2)
                    // If more than one mask is added to one volume, the ANY mode overwrites the (default) ALL mode.
                    global_geometry_list.elements[loop_index].Volume->geometry.mask_mode = 1;
            }
            
            found_geometries = 1;
        }
    }
    if (found_geometries == 0) {
        printf("The mask_string in geometry: %s did not find any of the specified volumes in the mask_string %s \n",NAME_CURRENT_COMP,mask_string);
        exit(1);
    }
    this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
    this_box_volume.p_physics->is_vacuum = 0; // Makes this volume a vacuum
    this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
    this_box_volume.p_physics->my_a = 0; // Should not be used.
    sprintf(this_box_volume.p_physics->name,"Mask");
    this_box_volume.geometry.is_mask_volume = 1;
    
    
// Read the material input, or if it lacks, use automatic linking.
} else if (material_string && strlen(material_string) && strcmp(material_string, "NULL") && strcmp(material_string, "0")) {
    // A geometry string was given, use it to determine which material
    if (0 == strcmp(material_string,"vacuum") || 0 == strcmp(material_string,"Vacuum")) {
        // One could have a global physics struct for vacuum instead of creating one for each
        this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
        this_box_volume.p_physics->is_vacuum = 1; // Makes this volume a vacuum
        this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
        this_box_volume.p_physics->my_a = 0; // Should not be used.
        sprintf(this_box_volume.p_physics->name,"Vacuum");
    } else if (0 == strcmp(material_string,"exit") || 0 == strcmp(material_string,"Exit")) {
        // One could have a global physics struct for vacuum instead of creating one for each
        this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
        this_box_volume.p_physics->is_vacuum = 1; // Makes this volume a vacuum
        this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
        this_box_volume.p_physics->my_a = 0; // Should not be used.
        this_box_volume.geometry.is_exit_volume = 1;
        sprintf(this_box_volume.p_physics->name,"Exit");
    } else {
        #ifndef MATERIAL_DETECTOR
            printf("Need to define a material before refering to it in a geometry %s.\n",NAME_CURRENT_COMP);
            exit(1);
        #endif
        for (loop_index=0;loop_index<global_material_list.num_elements;loop_index++) {
            if (0 == strcmp(material_string,global_material_list.elements[loop_index].name)) {
                this_box_volume.p_physics = global_material_list.elements[loop_index].physics;
                break;
            }
            if (loop_index == global_material_list.num_elements-1) {
            printf("\n");
            printf("ERROR: The material string \"%s\" in Union geometry \"%s\" did not match a specified material. \n",material_string,NAME_CURRENT_COMP);
            printf("       The materials available at this point (need to be defined before the geometry): \n");
            for (loop_index=0;loop_index<global_material_list.num_elements;loop_index++)
              printf("         %s\n",global_material_list.elements[loop_index].name);
            printf("\n");
            printf("       It is also possible to use one of the defualt materials avaiable: \n");
            printf("           Vacuum (for a Volume without scattering or absorption)\n");
            printf("           Exit (for a Volume where the ray exits the component if it enters)\n");
            printf("           Mask (for a Volume that masks existing volumes specified in the mask_string\n");
            exit(1);
          }
        }
    }
} else {
    // Automatic linking, simply using the last defined material.
    #ifndef MATERIAL_DETECTOR
        printf("Need to define a material before the geometry to use automatic linking %s.\n",NAME_CURRENT_COMP);
        exit(1);
    #endif
    this_box_volume.p_physics = global_material_list.elements[global_material_list.num_elements-1].physics;
}

sprintf(this_box_volume.name,NAME_CURRENT_COMP);
sprintf(this_box_volume.geometry.shape,"box");
this_box_volume.geometry.priority_value = priority;
this_box_volume.geometry.geometry_p_interact = p_interact;
// Currently the coordinates will be in absolute space.
this_box_volume.geometry.center = POS_A_CURRENT_COMP;

this_box_storage.z_depth = zdepth;
this_box_storage.x_width1 = xwidth;
this_box_storage.y_height1 = yheight;

this_box_storage.is_rectangle = 0;
if (xwidth2 < 0 && yheight2 < 0) this_box_storage.is_rectangle = 1;
if (xwidth == xwidth2 && yheight == yheight2) this_box_storage.is_rectangle = 1;

if (xwidth2 < 0) {
    this_box_storage.x_width2 = xwidth;
    xwidth2 = xwidth;
} else this_box_storage.x_width2 = xwidth2;

if (yheight2 < 0) {
    this_box_storage.y_height2 = yheight;
    yheight2 = yheight;
} else this_box_storage.y_height2 = yheight2;


this_box_storage.normal_vectors[0] = coords_set(0,0,1);
this_box_storage.normal_vectors[1] = coords_set(0,0,1);

// for sides with y component = 0
x_component = 2*zdepth/sqrt((xwidth-xwidth2)*(xwidth-xwidth2)+4*zdepth*zdepth);
z_component = (xwidth-xwidth2)/sqrt(4*zdepth*zdepth+(xwidth-xwidth2)*(xwidth-xwidth2));

this_box_storage.normal_vectors[2] = coords_set(x_component,0,z_component);
this_box_storage.normal_vectors[3] = coords_set(-x_component,0,z_component);

// for sides with x component = 0
y_component = 2*zdepth/sqrt((yheight-yheight2)*(yheight-yheight2)+4*zdepth*zdepth);
z_component = (yheight-yheight2)/sqrt(4*zdepth*zdepth+(yheight-yheight2)*(yheight-yheight2));

this_box_storage.normal_vectors[4] = coords_set(0,y_component,z_component);
this_box_storage.normal_vectors[5] = coords_set(0,-y_component,z_component);

this_box_volume.geometry.visualization_on = visualize;

this_box_volume.geometry.geometry_parameters.p_box_storage = &this_box_storage;

// Assign pointers to functions for intersection with the shape, checking if a point is inside the shape
if (this_box_storage.is_rectangle == 1) {
this_box_volume.geometry.intersect_function = &sample_box_intersect_simple;
this_box_volume.geometry.within_function = &r_within_box_simple;
}
else {
this_box_volume.geometry.intersect_function = &sample_box_intersect_advanced;
this_box_volume.geometry.within_function = &r_within_box_advanced;
}

this_box_volume.geometry.shell_points = &box_shell_points;
this_box_volume.geometry.mcdisplay_function = &mcdisplay_box_function;
this_box_volume.geometry.initialize_from_main_function = &initialize_box_geometry_from_main_component;
this_box_volume.geometry.process_rot_allocated = 0;

this_box_volume.geometry.copy_geometry_parameters = &allocate_box_storage_copy;

rot_copy(this_box_volume.geometry.rotation_matrix,ROT_A_CURRENT_COMP); //check how ROT_R_CURRENT_COMP would work
rot_transpose(ROT_A_CURRENT_COMP,this_box_volume.geometry.transpose_rotation_matrix);

// Initialize loggers
this_box_volume.loggers.num_elements = 0;

// packing the information into the global_geometry_element, which is then included in the global_geometry_list.
sprintf(global_geometry_element.name,NAME_CURRENT_COMP);
global_geometry_element.activation_counter = number_of_activations;
global_geometry_element.component_index = INDEX_CURRENT_COMP;
global_geometry_element.Volume = &this_box_volume; // Would be nicer if this m was a pointer, now we have the (small) data two places
add_element_to_geometry_list(&global_geometry_list,global_geometry_element);
}
#line 171935 "MACS_sample_kidney_box.c"
#undef number_of_activations
#undef mask_setting
#undef mask_string
#undef p_interact
#undef focus_r
#undef focus_xh
#undef focus_xw
#undef focus_ah
#undef focus_aw
#undef target_z
#undef target_y
#undef target_x
#undef target_index
#undef visualize
#undef yheight2
#undef xwidth2
#undef zdepth
#undef yheight
#undef xwidth
#undef priority
#undef material_string
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

  /* Initializations for component inter_analyzer_colimator_0_blade_2. */
  SIG_MESSAGE("inter_analyzer_colimator_0_blade_2 (Init)");
#define mccompcurname  inter_analyzer_colimator_0_blade_2
#define mccompcurtype  Union_box
#define mccompcurindex 157
#define loop_index mccinter_analyzer_colimator_0_blade_2_loop_index
#define this_box_volume mccinter_analyzer_colimator_0_blade_2_this_box_volume
#define global_geometry_element mccinter_analyzer_colimator_0_blade_2_global_geometry_element
#define this_box_storage mccinter_analyzer_colimator_0_blade_2_this_box_storage
#define material_string mccinter_analyzer_colimator_0_blade_2_material_string
#define priority mccinter_analyzer_colimator_0_blade_2_priority
#define xwidth mccinter_analyzer_colimator_0_blade_2_xwidth
#define yheight mccinter_analyzer_colimator_0_blade_2_yheight
#define zdepth mccinter_analyzer_colimator_0_blade_2_zdepth
#define xwidth2 mccinter_analyzer_colimator_0_blade_2_xwidth2
#define yheight2 mccinter_analyzer_colimator_0_blade_2_yheight2
#define visualize mccinter_analyzer_colimator_0_blade_2_visualize
#define target_index mccinter_analyzer_colimator_0_blade_2_target_index
#define target_x mccinter_analyzer_colimator_0_blade_2_target_x
#define target_y mccinter_analyzer_colimator_0_blade_2_target_y
#define target_z mccinter_analyzer_colimator_0_blade_2_target_z
#define focus_aw mccinter_analyzer_colimator_0_blade_2_focus_aw
#define focus_ah mccinter_analyzer_colimator_0_blade_2_focus_ah
#define focus_xw mccinter_analyzer_colimator_0_blade_2_focus_xw
#define focus_xh mccinter_analyzer_colimator_0_blade_2_focus_xh
#define focus_r mccinter_analyzer_colimator_0_blade_2_focus_r
#define p_interact mccinter_analyzer_colimator_0_blade_2_p_interact
#define mask_string mccinter_analyzer_colimator_0_blade_2_mask_string
#define mask_setting mccinter_analyzer_colimator_0_blade_2_mask_setting
#define number_of_activations mccinter_analyzer_colimator_0_blade_2_number_of_activations
#line 224 "Union_box.comp"
{
// Initializes the focusing system for this volume including input sanitation.
focus_initialize(&this_box_volume.geometry, POS_A_COMP_INDEX(INDEX_CURRENT_COMP+target_index), POS_A_CURRENT_COMP, ROT_A_CURRENT_COMP, target_index, target_x, target_y, target_z, focus_aw, focus_ah, focus_xw, focus_xh, focus_r, NAME_CURRENT_COMP);

// Input sanitation for this geometry
if (xwidth <= 0) {
  printf("\nERROR in Union_box named %s, the xwidth is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (yheight <= 0) {
  printf("\nERROR in Union_box named %s, yheight is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (zdepth <= 0) {
  printf("\nERROR in Union_box named %s, zdepth is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (xwidth2 <= 0 && xwidth2 != -1) {
  printf("\nERROR in Union_box named %s, the xwidth2 is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (yheight2 <= 0 && yheight2 != -1) {
  printf("\nERROR in Union_box named %s, yheight2 is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}

// Use sanitation
if (global_material_list.num_elements == 0) {
  printf("\nERROR: Need to define a material using Union_make_material before using a Union geometry component. \n");
  printf("       %s was defined before first use of Union_make_material.\n",NAME_CURRENT_COMP);
  exit(1);
}

this_box_volume.geometry.is_masked_volume = 0;
this_box_volume.geometry.is_exit_volume = 0;
this_box_volume.geometry.is_mask_volume = 0;
// check if the volume is a mask, if it is the material string is irelevant.
if (mask_string && strlen(mask_string) && strcmp(mask_string, "NULL") && strcmp(mask_string, "0")) {
    // A mask volume is used to limit the extend of other volumes, called the masked volumes. These are specified in the mask_string.
    // In order for a ray to enter a masked volume, it needs to be both in the region covered by that volume AND the mask volume.
    // When more than
    this_box_volume.geometry.mask_mode = 1; // Default is mask mode is ALL
    if (mask_setting && strlen(mask_setting) && strcmp(mask_setting, "NULL") && strcmp(mask_setting, "0")) {
        if (strcmp(mask_setting,"ALL") == 0 || strcmp(mask_setting,"All") == 0) this_box_volume.geometry.mask_mode = 1;
        else if (strcmp(mask_setting,"ANY") == 0 || strcmp(mask_setting,"Any") == 0) this_box_volume.geometry.mask_mode = 2;
        else {
            printf("The mask_mode of component %s is set to %s, but must be either ALL or ANY.\n",NAME_CURRENT_COMP,mask_setting);
            exit(1);
        }
    }
    
    for (loop_index=0;loop_index<global_geometry_list.num_elements;loop_index++) {
        // Add mask list
        if (1 == manual_linking_function(global_geometry_list.elements[loop_index].name,mask_string)) {
            add_element_to_int_list(&this_box_volume.geometry.mask_list,global_geometry_list.elements[loop_index].component_index);
            add_element_to_int_list(&global_geometry_list.elements[loop_index].Volume->geometry.masked_by_list,INDEX_CURRENT_COMP);
            global_geometry_list.elements[loop_index].Volume->geometry.is_masked_volume = 1;
            if (this_box_volume.geometry.mask_mode == 2)
                global_geometry_list.elements[loop_index].Volume->geometry.mask_mode = 2;
            if (this_box_volume.geometry.mask_mode == 1) {
                if (global_geometry_list.elements[loop_index].Volume->geometry.is_masked_volume == 1 && global_geometry_list.elements[loop_index].Volume->geometry.mask_mode != 2)
                    // If more than one mask is added to one volume, the ANY mode overwrites the (default) ALL mode.
                    global_geometry_list.elements[loop_index].Volume->geometry.mask_mode = 1;
            }
            
            found_geometries = 1;
        }
    }
    if (found_geometries == 0) {
        printf("The mask_string in geometry: %s did not find any of the specified volumes in the mask_string %s \n",NAME_CURRENT_COMP,mask_string);
        exit(1);
    }
    this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
    this_box_volume.p_physics->is_vacuum = 0; // Makes this volume a vacuum
    this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
    this_box_volume.p_physics->my_a = 0; // Should not be used.
    sprintf(this_box_volume.p_physics->name,"Mask");
    this_box_volume.geometry.is_mask_volume = 1;
    
    
// Read the material input, or if it lacks, use automatic linking.
} else if (material_string && strlen(material_string) && strcmp(material_string, "NULL") && strcmp(material_string, "0")) {
    // A geometry string was given, use it to determine which material
    if (0 == strcmp(material_string,"vacuum") || 0 == strcmp(material_string,"Vacuum")) {
        // One could have a global physics struct for vacuum instead of creating one for each
        this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
        this_box_volume.p_physics->is_vacuum = 1; // Makes this volume a vacuum
        this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
        this_box_volume.p_physics->my_a = 0; // Should not be used.
        sprintf(this_box_volume.p_physics->name,"Vacuum");
    } else if (0 == strcmp(material_string,"exit") || 0 == strcmp(material_string,"Exit")) {
        // One could have a global physics struct for vacuum instead of creating one for each
        this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
        this_box_volume.p_physics->is_vacuum = 1; // Makes this volume a vacuum
        this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
        this_box_volume.p_physics->my_a = 0; // Should not be used.
        this_box_volume.geometry.is_exit_volume = 1;
        sprintf(this_box_volume.p_physics->name,"Exit");
    } else {
        #ifndef MATERIAL_DETECTOR
            printf("Need to define a material before refering to it in a geometry %s.\n",NAME_CURRENT_COMP);
            exit(1);
        #endif
        for (loop_index=0;loop_index<global_material_list.num_elements;loop_index++) {
            if (0 == strcmp(material_string,global_material_list.elements[loop_index].name)) {
                this_box_volume.p_physics = global_material_list.elements[loop_index].physics;
                break;
            }
            if (loop_index == global_material_list.num_elements-1) {
            printf("\n");
            printf("ERROR: The material string \"%s\" in Union geometry \"%s\" did not match a specified material. \n",material_string,NAME_CURRENT_COMP);
            printf("       The materials available at this point (need to be defined before the geometry): \n");
            for (loop_index=0;loop_index<global_material_list.num_elements;loop_index++)
              printf("         %s\n",global_material_list.elements[loop_index].name);
            printf("\n");
            printf("       It is also possible to use one of the defualt materials avaiable: \n");
            printf("           Vacuum (for a Volume without scattering or absorption)\n");
            printf("           Exit (for a Volume where the ray exits the component if it enters)\n");
            printf("           Mask (for a Volume that masks existing volumes specified in the mask_string\n");
            exit(1);
          }
        }
    }
} else {
    // Automatic linking, simply using the last defined material.
    #ifndef MATERIAL_DETECTOR
        printf("Need to define a material before the geometry to use automatic linking %s.\n",NAME_CURRENT_COMP);
        exit(1);
    #endif
    this_box_volume.p_physics = global_material_list.elements[global_material_list.num_elements-1].physics;
}

sprintf(this_box_volume.name,NAME_CURRENT_COMP);
sprintf(this_box_volume.geometry.shape,"box");
this_box_volume.geometry.priority_value = priority;
this_box_volume.geometry.geometry_p_interact = p_interact;
// Currently the coordinates will be in absolute space.
this_box_volume.geometry.center = POS_A_CURRENT_COMP;

this_box_storage.z_depth = zdepth;
this_box_storage.x_width1 = xwidth;
this_box_storage.y_height1 = yheight;

this_box_storage.is_rectangle = 0;
if (xwidth2 < 0 && yheight2 < 0) this_box_storage.is_rectangle = 1;
if (xwidth == xwidth2 && yheight == yheight2) this_box_storage.is_rectangle = 1;

if (xwidth2 < 0) {
    this_box_storage.x_width2 = xwidth;
    xwidth2 = xwidth;
} else this_box_storage.x_width2 = xwidth2;

if (yheight2 < 0) {
    this_box_storage.y_height2 = yheight;
    yheight2 = yheight;
} else this_box_storage.y_height2 = yheight2;


this_box_storage.normal_vectors[0] = coords_set(0,0,1);
this_box_storage.normal_vectors[1] = coords_set(0,0,1);

// for sides with y component = 0
x_component = 2*zdepth/sqrt((xwidth-xwidth2)*(xwidth-xwidth2)+4*zdepth*zdepth);
z_component = (xwidth-xwidth2)/sqrt(4*zdepth*zdepth+(xwidth-xwidth2)*(xwidth-xwidth2));

this_box_storage.normal_vectors[2] = coords_set(x_component,0,z_component);
this_box_storage.normal_vectors[3] = coords_set(-x_component,0,z_component);

// for sides with x component = 0
y_component = 2*zdepth/sqrt((yheight-yheight2)*(yheight-yheight2)+4*zdepth*zdepth);
z_component = (yheight-yheight2)/sqrt(4*zdepth*zdepth+(yheight-yheight2)*(yheight-yheight2));

this_box_storage.normal_vectors[4] = coords_set(0,y_component,z_component);
this_box_storage.normal_vectors[5] = coords_set(0,-y_component,z_component);

this_box_volume.geometry.visualization_on = visualize;

this_box_volume.geometry.geometry_parameters.p_box_storage = &this_box_storage;

// Assign pointers to functions for intersection with the shape, checking if a point is inside the shape
if (this_box_storage.is_rectangle == 1) {
this_box_volume.geometry.intersect_function = &sample_box_intersect_simple;
this_box_volume.geometry.within_function = &r_within_box_simple;
}
else {
this_box_volume.geometry.intersect_function = &sample_box_intersect_advanced;
this_box_volume.geometry.within_function = &r_within_box_advanced;
}

this_box_volume.geometry.shell_points = &box_shell_points;
this_box_volume.geometry.mcdisplay_function = &mcdisplay_box_function;
this_box_volume.geometry.initialize_from_main_function = &initialize_box_geometry_from_main_component;
this_box_volume.geometry.process_rot_allocated = 0;

this_box_volume.geometry.copy_geometry_parameters = &allocate_box_storage_copy;

rot_copy(this_box_volume.geometry.rotation_matrix,ROT_A_CURRENT_COMP); //check how ROT_R_CURRENT_COMP would work
rot_transpose(ROT_A_CURRENT_COMP,this_box_volume.geometry.transpose_rotation_matrix);

// Initialize loggers
this_box_volume.loggers.num_elements = 0;

// packing the information into the global_geometry_element, which is then included in the global_geometry_list.
sprintf(global_geometry_element.name,NAME_CURRENT_COMP);
global_geometry_element.activation_counter = number_of_activations;
global_geometry_element.component_index = INDEX_CURRENT_COMP;
global_geometry_element.Volume = &this_box_volume; // Would be nicer if this m was a pointer, now we have the (small) data two places
add_element_to_geometry_list(&global_geometry_list,global_geometry_element);
}
#line 172205 "MACS_sample_kidney_box.c"
#undef number_of_activations
#undef mask_setting
#undef mask_string
#undef p_interact
#undef focus_r
#undef focus_xh
#undef focus_xw
#undef focus_ah
#undef focus_aw
#undef target_z
#undef target_y
#undef target_x
#undef target_index
#undef visualize
#undef yheight2
#undef xwidth2
#undef zdepth
#undef yheight
#undef xwidth
#undef priority
#undef material_string
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

  /* Initializations for component inter_analyzer_colimator_0_blade_3. */
  SIG_MESSAGE("inter_analyzer_colimator_0_blade_3 (Init)");
#define mccompcurname  inter_analyzer_colimator_0_blade_3
#define mccompcurtype  Union_box
#define mccompcurindex 158
#define loop_index mccinter_analyzer_colimator_0_blade_3_loop_index
#define this_box_volume mccinter_analyzer_colimator_0_blade_3_this_box_volume
#define global_geometry_element mccinter_analyzer_colimator_0_blade_3_global_geometry_element
#define this_box_storage mccinter_analyzer_colimator_0_blade_3_this_box_storage
#define material_string mccinter_analyzer_colimator_0_blade_3_material_string
#define priority mccinter_analyzer_colimator_0_blade_3_priority
#define xwidth mccinter_analyzer_colimator_0_blade_3_xwidth
#define yheight mccinter_analyzer_colimator_0_blade_3_yheight
#define zdepth mccinter_analyzer_colimator_0_blade_3_zdepth
#define xwidth2 mccinter_analyzer_colimator_0_blade_3_xwidth2
#define yheight2 mccinter_analyzer_colimator_0_blade_3_yheight2
#define visualize mccinter_analyzer_colimator_0_blade_3_visualize
#define target_index mccinter_analyzer_colimator_0_blade_3_target_index
#define target_x mccinter_analyzer_colimator_0_blade_3_target_x
#define target_y mccinter_analyzer_colimator_0_blade_3_target_y
#define target_z mccinter_analyzer_colimator_0_blade_3_target_z
#define focus_aw mccinter_analyzer_colimator_0_blade_3_focus_aw
#define focus_ah mccinter_analyzer_colimator_0_blade_3_focus_ah
#define focus_xw mccinter_analyzer_colimator_0_blade_3_focus_xw
#define focus_xh mccinter_analyzer_colimator_0_blade_3_focus_xh
#define focus_r mccinter_analyzer_colimator_0_blade_3_focus_r
#define p_interact mccinter_analyzer_colimator_0_blade_3_p_interact
#define mask_string mccinter_analyzer_colimator_0_blade_3_mask_string
#define mask_setting mccinter_analyzer_colimator_0_blade_3_mask_setting
#define number_of_activations mccinter_analyzer_colimator_0_blade_3_number_of_activations
#line 224 "Union_box.comp"
{
// Initializes the focusing system for this volume including input sanitation.
focus_initialize(&this_box_volume.geometry, POS_A_COMP_INDEX(INDEX_CURRENT_COMP+target_index), POS_A_CURRENT_COMP, ROT_A_CURRENT_COMP, target_index, target_x, target_y, target_z, focus_aw, focus_ah, focus_xw, focus_xh, focus_r, NAME_CURRENT_COMP);

// Input sanitation for this geometry
if (xwidth <= 0) {
  printf("\nERROR in Union_box named %s, the xwidth is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (yheight <= 0) {
  printf("\nERROR in Union_box named %s, yheight is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (zdepth <= 0) {
  printf("\nERROR in Union_box named %s, zdepth is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (xwidth2 <= 0 && xwidth2 != -1) {
  printf("\nERROR in Union_box named %s, the xwidth2 is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (yheight2 <= 0 && yheight2 != -1) {
  printf("\nERROR in Union_box named %s, yheight2 is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}

// Use sanitation
if (global_material_list.num_elements == 0) {
  printf("\nERROR: Need to define a material using Union_make_material before using a Union geometry component. \n");
  printf("       %s was defined before first use of Union_make_material.\n",NAME_CURRENT_COMP);
  exit(1);
}

this_box_volume.geometry.is_masked_volume = 0;
this_box_volume.geometry.is_exit_volume = 0;
this_box_volume.geometry.is_mask_volume = 0;
// check if the volume is a mask, if it is the material string is irelevant.
if (mask_string && strlen(mask_string) && strcmp(mask_string, "NULL") && strcmp(mask_string, "0")) {
    // A mask volume is used to limit the extend of other volumes, called the masked volumes. These are specified in the mask_string.
    // In order for a ray to enter a masked volume, it needs to be both in the region covered by that volume AND the mask volume.
    // When more than
    this_box_volume.geometry.mask_mode = 1; // Default is mask mode is ALL
    if (mask_setting && strlen(mask_setting) && strcmp(mask_setting, "NULL") && strcmp(mask_setting, "0")) {
        if (strcmp(mask_setting,"ALL") == 0 || strcmp(mask_setting,"All") == 0) this_box_volume.geometry.mask_mode = 1;
        else if (strcmp(mask_setting,"ANY") == 0 || strcmp(mask_setting,"Any") == 0) this_box_volume.geometry.mask_mode = 2;
        else {
            printf("The mask_mode of component %s is set to %s, but must be either ALL or ANY.\n",NAME_CURRENT_COMP,mask_setting);
            exit(1);
        }
    }
    
    for (loop_index=0;loop_index<global_geometry_list.num_elements;loop_index++) {
        // Add mask list
        if (1 == manual_linking_function(global_geometry_list.elements[loop_index].name,mask_string)) {
            add_element_to_int_list(&this_box_volume.geometry.mask_list,global_geometry_list.elements[loop_index].component_index);
            add_element_to_int_list(&global_geometry_list.elements[loop_index].Volume->geometry.masked_by_list,INDEX_CURRENT_COMP);
            global_geometry_list.elements[loop_index].Volume->geometry.is_masked_volume = 1;
            if (this_box_volume.geometry.mask_mode == 2)
                global_geometry_list.elements[loop_index].Volume->geometry.mask_mode = 2;
            if (this_box_volume.geometry.mask_mode == 1) {
                if (global_geometry_list.elements[loop_index].Volume->geometry.is_masked_volume == 1 && global_geometry_list.elements[loop_index].Volume->geometry.mask_mode != 2)
                    // If more than one mask is added to one volume, the ANY mode overwrites the (default) ALL mode.
                    global_geometry_list.elements[loop_index].Volume->geometry.mask_mode = 1;
            }
            
            found_geometries = 1;
        }
    }
    if (found_geometries == 0) {
        printf("The mask_string in geometry: %s did not find any of the specified volumes in the mask_string %s \n",NAME_CURRENT_COMP,mask_string);
        exit(1);
    }
    this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
    this_box_volume.p_physics->is_vacuum = 0; // Makes this volume a vacuum
    this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
    this_box_volume.p_physics->my_a = 0; // Should not be used.
    sprintf(this_box_volume.p_physics->name,"Mask");
    this_box_volume.geometry.is_mask_volume = 1;
    
    
// Read the material input, or if it lacks, use automatic linking.
} else if (material_string && strlen(material_string) && strcmp(material_string, "NULL") && strcmp(material_string, "0")) {
    // A geometry string was given, use it to determine which material
    if (0 == strcmp(material_string,"vacuum") || 0 == strcmp(material_string,"Vacuum")) {
        // One could have a global physics struct for vacuum instead of creating one for each
        this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
        this_box_volume.p_physics->is_vacuum = 1; // Makes this volume a vacuum
        this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
        this_box_volume.p_physics->my_a = 0; // Should not be used.
        sprintf(this_box_volume.p_physics->name,"Vacuum");
    } else if (0 == strcmp(material_string,"exit") || 0 == strcmp(material_string,"Exit")) {
        // One could have a global physics struct for vacuum instead of creating one for each
        this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
        this_box_volume.p_physics->is_vacuum = 1; // Makes this volume a vacuum
        this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
        this_box_volume.p_physics->my_a = 0; // Should not be used.
        this_box_volume.geometry.is_exit_volume = 1;
        sprintf(this_box_volume.p_physics->name,"Exit");
    } else {
        #ifndef MATERIAL_DETECTOR
            printf("Need to define a material before refering to it in a geometry %s.\n",NAME_CURRENT_COMP);
            exit(1);
        #endif
        for (loop_index=0;loop_index<global_material_list.num_elements;loop_index++) {
            if (0 == strcmp(material_string,global_material_list.elements[loop_index].name)) {
                this_box_volume.p_physics = global_material_list.elements[loop_index].physics;
                break;
            }
            if (loop_index == global_material_list.num_elements-1) {
            printf("\n");
            printf("ERROR: The material string \"%s\" in Union geometry \"%s\" did not match a specified material. \n",material_string,NAME_CURRENT_COMP);
            printf("       The materials available at this point (need to be defined before the geometry): \n");
            for (loop_index=0;loop_index<global_material_list.num_elements;loop_index++)
              printf("         %s\n",global_material_list.elements[loop_index].name);
            printf("\n");
            printf("       It is also possible to use one of the defualt materials avaiable: \n");
            printf("           Vacuum (for a Volume without scattering or absorption)\n");
            printf("           Exit (for a Volume where the ray exits the component if it enters)\n");
            printf("           Mask (for a Volume that masks existing volumes specified in the mask_string\n");
            exit(1);
          }
        }
    }
} else {
    // Automatic linking, simply using the last defined material.
    #ifndef MATERIAL_DETECTOR
        printf("Need to define a material before the geometry to use automatic linking %s.\n",NAME_CURRENT_COMP);
        exit(1);
    #endif
    this_box_volume.p_physics = global_material_list.elements[global_material_list.num_elements-1].physics;
}

sprintf(this_box_volume.name,NAME_CURRENT_COMP);
sprintf(this_box_volume.geometry.shape,"box");
this_box_volume.geometry.priority_value = priority;
this_box_volume.geometry.geometry_p_interact = p_interact;
// Currently the coordinates will be in absolute space.
this_box_volume.geometry.center = POS_A_CURRENT_COMP;

this_box_storage.z_depth = zdepth;
this_box_storage.x_width1 = xwidth;
this_box_storage.y_height1 = yheight;

this_box_storage.is_rectangle = 0;
if (xwidth2 < 0 && yheight2 < 0) this_box_storage.is_rectangle = 1;
if (xwidth == xwidth2 && yheight == yheight2) this_box_storage.is_rectangle = 1;

if (xwidth2 < 0) {
    this_box_storage.x_width2 = xwidth;
    xwidth2 = xwidth;
} else this_box_storage.x_width2 = xwidth2;

if (yheight2 < 0) {
    this_box_storage.y_height2 = yheight;
    yheight2 = yheight;
} else this_box_storage.y_height2 = yheight2;


this_box_storage.normal_vectors[0] = coords_set(0,0,1);
this_box_storage.normal_vectors[1] = coords_set(0,0,1);

// for sides with y component = 0
x_component = 2*zdepth/sqrt((xwidth-xwidth2)*(xwidth-xwidth2)+4*zdepth*zdepth);
z_component = (xwidth-xwidth2)/sqrt(4*zdepth*zdepth+(xwidth-xwidth2)*(xwidth-xwidth2));

this_box_storage.normal_vectors[2] = coords_set(x_component,0,z_component);
this_box_storage.normal_vectors[3] = coords_set(-x_component,0,z_component);

// for sides with x component = 0
y_component = 2*zdepth/sqrt((yheight-yheight2)*(yheight-yheight2)+4*zdepth*zdepth);
z_component = (yheight-yheight2)/sqrt(4*zdepth*zdepth+(yheight-yheight2)*(yheight-yheight2));

this_box_storage.normal_vectors[4] = coords_set(0,y_component,z_component);
this_box_storage.normal_vectors[5] = coords_set(0,-y_component,z_component);

this_box_volume.geometry.visualization_on = visualize;

this_box_volume.geometry.geometry_parameters.p_box_storage = &this_box_storage;

// Assign pointers to functions for intersection with the shape, checking if a point is inside the shape
if (this_box_storage.is_rectangle == 1) {
this_box_volume.geometry.intersect_function = &sample_box_intersect_simple;
this_box_volume.geometry.within_function = &r_within_box_simple;
}
else {
this_box_volume.geometry.intersect_function = &sample_box_intersect_advanced;
this_box_volume.geometry.within_function = &r_within_box_advanced;
}

this_box_volume.geometry.shell_points = &box_shell_points;
this_box_volume.geometry.mcdisplay_function = &mcdisplay_box_function;
this_box_volume.geometry.initialize_from_main_function = &initialize_box_geometry_from_main_component;
this_box_volume.geometry.process_rot_allocated = 0;

this_box_volume.geometry.copy_geometry_parameters = &allocate_box_storage_copy;

rot_copy(this_box_volume.geometry.rotation_matrix,ROT_A_CURRENT_COMP); //check how ROT_R_CURRENT_COMP would work
rot_transpose(ROT_A_CURRENT_COMP,this_box_volume.geometry.transpose_rotation_matrix);

// Initialize loggers
this_box_volume.loggers.num_elements = 0;

// packing the information into the global_geometry_element, which is then included in the global_geometry_list.
sprintf(global_geometry_element.name,NAME_CURRENT_COMP);
global_geometry_element.activation_counter = number_of_activations;
global_geometry_element.component_index = INDEX_CURRENT_COMP;
global_geometry_element.Volume = &this_box_volume; // Would be nicer if this m was a pointer, now we have the (small) data two places
add_element_to_geometry_list(&global_geometry_list,global_geometry_element);
}
#line 172475 "MACS_sample_kidney_box.c"
#undef number_of_activations
#undef mask_setting
#undef mask_string
#undef p_interact
#undef focus_r
#undef focus_xh
#undef focus_xw
#undef focus_ah
#undef focus_aw
#undef target_z
#undef target_y
#undef target_x
#undef target_index
#undef visualize
#undef yheight2
#undef xwidth2
#undef zdepth
#undef yheight
#undef xwidth
#undef priority
#undef material_string
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

  /* Initializations for component inter_analyzer_colimator_0_blade_4. */
  SIG_MESSAGE("inter_analyzer_colimator_0_blade_4 (Init)");
#define mccompcurname  inter_analyzer_colimator_0_blade_4
#define mccompcurtype  Union_box
#define mccompcurindex 159
#define loop_index mccinter_analyzer_colimator_0_blade_4_loop_index
#define this_box_volume mccinter_analyzer_colimator_0_blade_4_this_box_volume
#define global_geometry_element mccinter_analyzer_colimator_0_blade_4_global_geometry_element
#define this_box_storage mccinter_analyzer_colimator_0_blade_4_this_box_storage
#define material_string mccinter_analyzer_colimator_0_blade_4_material_string
#define priority mccinter_analyzer_colimator_0_blade_4_priority
#define xwidth mccinter_analyzer_colimator_0_blade_4_xwidth
#define yheight mccinter_analyzer_colimator_0_blade_4_yheight
#define zdepth mccinter_analyzer_colimator_0_blade_4_zdepth
#define xwidth2 mccinter_analyzer_colimator_0_blade_4_xwidth2
#define yheight2 mccinter_analyzer_colimator_0_blade_4_yheight2
#define visualize mccinter_analyzer_colimator_0_blade_4_visualize
#define target_index mccinter_analyzer_colimator_0_blade_4_target_index
#define target_x mccinter_analyzer_colimator_0_blade_4_target_x
#define target_y mccinter_analyzer_colimator_0_blade_4_target_y
#define target_z mccinter_analyzer_colimator_0_blade_4_target_z
#define focus_aw mccinter_analyzer_colimator_0_blade_4_focus_aw
#define focus_ah mccinter_analyzer_colimator_0_blade_4_focus_ah
#define focus_xw mccinter_analyzer_colimator_0_blade_4_focus_xw
#define focus_xh mccinter_analyzer_colimator_0_blade_4_focus_xh
#define focus_r mccinter_analyzer_colimator_0_blade_4_focus_r
#define p_interact mccinter_analyzer_colimator_0_blade_4_p_interact
#define mask_string mccinter_analyzer_colimator_0_blade_4_mask_string
#define mask_setting mccinter_analyzer_colimator_0_blade_4_mask_setting
#define number_of_activations mccinter_analyzer_colimator_0_blade_4_number_of_activations
#line 224 "Union_box.comp"
{
// Initializes the focusing system for this volume including input sanitation.
focus_initialize(&this_box_volume.geometry, POS_A_COMP_INDEX(INDEX_CURRENT_COMP+target_index), POS_A_CURRENT_COMP, ROT_A_CURRENT_COMP, target_index, target_x, target_y, target_z, focus_aw, focus_ah, focus_xw, focus_xh, focus_r, NAME_CURRENT_COMP);

// Input sanitation for this geometry
if (xwidth <= 0) {
  printf("\nERROR in Union_box named %s, the xwidth is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (yheight <= 0) {
  printf("\nERROR in Union_box named %s, yheight is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (zdepth <= 0) {
  printf("\nERROR in Union_box named %s, zdepth is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (xwidth2 <= 0 && xwidth2 != -1) {
  printf("\nERROR in Union_box named %s, the xwidth2 is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (yheight2 <= 0 && yheight2 != -1) {
  printf("\nERROR in Union_box named %s, yheight2 is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}

// Use sanitation
if (global_material_list.num_elements == 0) {
  printf("\nERROR: Need to define a material using Union_make_material before using a Union geometry component. \n");
  printf("       %s was defined before first use of Union_make_material.\n",NAME_CURRENT_COMP);
  exit(1);
}

this_box_volume.geometry.is_masked_volume = 0;
this_box_volume.geometry.is_exit_volume = 0;
this_box_volume.geometry.is_mask_volume = 0;
// check if the volume is a mask, if it is the material string is irelevant.
if (mask_string && strlen(mask_string) && strcmp(mask_string, "NULL") && strcmp(mask_string, "0")) {
    // A mask volume is used to limit the extend of other volumes, called the masked volumes. These are specified in the mask_string.
    // In order for a ray to enter a masked volume, it needs to be both in the region covered by that volume AND the mask volume.
    // When more than
    this_box_volume.geometry.mask_mode = 1; // Default is mask mode is ALL
    if (mask_setting && strlen(mask_setting) && strcmp(mask_setting, "NULL") && strcmp(mask_setting, "0")) {
        if (strcmp(mask_setting,"ALL") == 0 || strcmp(mask_setting,"All") == 0) this_box_volume.geometry.mask_mode = 1;
        else if (strcmp(mask_setting,"ANY") == 0 || strcmp(mask_setting,"Any") == 0) this_box_volume.geometry.mask_mode = 2;
        else {
            printf("The mask_mode of component %s is set to %s, but must be either ALL or ANY.\n",NAME_CURRENT_COMP,mask_setting);
            exit(1);
        }
    }
    
    for (loop_index=0;loop_index<global_geometry_list.num_elements;loop_index++) {
        // Add mask list
        if (1 == manual_linking_function(global_geometry_list.elements[loop_index].name,mask_string)) {
            add_element_to_int_list(&this_box_volume.geometry.mask_list,global_geometry_list.elements[loop_index].component_index);
            add_element_to_int_list(&global_geometry_list.elements[loop_index].Volume->geometry.masked_by_list,INDEX_CURRENT_COMP);
            global_geometry_list.elements[loop_index].Volume->geometry.is_masked_volume = 1;
            if (this_box_volume.geometry.mask_mode == 2)
                global_geometry_list.elements[loop_index].Volume->geometry.mask_mode = 2;
            if (this_box_volume.geometry.mask_mode == 1) {
                if (global_geometry_list.elements[loop_index].Volume->geometry.is_masked_volume == 1 && global_geometry_list.elements[loop_index].Volume->geometry.mask_mode != 2)
                    // If more than one mask is added to one volume, the ANY mode overwrites the (default) ALL mode.
                    global_geometry_list.elements[loop_index].Volume->geometry.mask_mode = 1;
            }
            
            found_geometries = 1;
        }
    }
    if (found_geometries == 0) {
        printf("The mask_string in geometry: %s did not find any of the specified volumes in the mask_string %s \n",NAME_CURRENT_COMP,mask_string);
        exit(1);
    }
    this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
    this_box_volume.p_physics->is_vacuum = 0; // Makes this volume a vacuum
    this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
    this_box_volume.p_physics->my_a = 0; // Should not be used.
    sprintf(this_box_volume.p_physics->name,"Mask");
    this_box_volume.geometry.is_mask_volume = 1;
    
    
// Read the material input, or if it lacks, use automatic linking.
} else if (material_string && strlen(material_string) && strcmp(material_string, "NULL") && strcmp(material_string, "0")) {
    // A geometry string was given, use it to determine which material
    if (0 == strcmp(material_string,"vacuum") || 0 == strcmp(material_string,"Vacuum")) {
        // One could have a global physics struct for vacuum instead of creating one for each
        this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
        this_box_volume.p_physics->is_vacuum = 1; // Makes this volume a vacuum
        this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
        this_box_volume.p_physics->my_a = 0; // Should not be used.
        sprintf(this_box_volume.p_physics->name,"Vacuum");
    } else if (0 == strcmp(material_string,"exit") || 0 == strcmp(material_string,"Exit")) {
        // One could have a global physics struct for vacuum instead of creating one for each
        this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
        this_box_volume.p_physics->is_vacuum = 1; // Makes this volume a vacuum
        this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
        this_box_volume.p_physics->my_a = 0; // Should not be used.
        this_box_volume.geometry.is_exit_volume = 1;
        sprintf(this_box_volume.p_physics->name,"Exit");
    } else {
        #ifndef MATERIAL_DETECTOR
            printf("Need to define a material before refering to it in a geometry %s.\n",NAME_CURRENT_COMP);
            exit(1);
        #endif
        for (loop_index=0;loop_index<global_material_list.num_elements;loop_index++) {
            if (0 == strcmp(material_string,global_material_list.elements[loop_index].name)) {
                this_box_volume.p_physics = global_material_list.elements[loop_index].physics;
                break;
            }
            if (loop_index == global_material_list.num_elements-1) {
            printf("\n");
            printf("ERROR: The material string \"%s\" in Union geometry \"%s\" did not match a specified material. \n",material_string,NAME_CURRENT_COMP);
            printf("       The materials available at this point (need to be defined before the geometry): \n");
            for (loop_index=0;loop_index<global_material_list.num_elements;loop_index++)
              printf("         %s\n",global_material_list.elements[loop_index].name);
            printf("\n");
            printf("       It is also possible to use one of the defualt materials avaiable: \n");
            printf("           Vacuum (for a Volume without scattering or absorption)\n");
            printf("           Exit (for a Volume where the ray exits the component if it enters)\n");
            printf("           Mask (for a Volume that masks existing volumes specified in the mask_string\n");
            exit(1);
          }
        }
    }
} else {
    // Automatic linking, simply using the last defined material.
    #ifndef MATERIAL_DETECTOR
        printf("Need to define a material before the geometry to use automatic linking %s.\n",NAME_CURRENT_COMP);
        exit(1);
    #endif
    this_box_volume.p_physics = global_material_list.elements[global_material_list.num_elements-1].physics;
}

sprintf(this_box_volume.name,NAME_CURRENT_COMP);
sprintf(this_box_volume.geometry.shape,"box");
this_box_volume.geometry.priority_value = priority;
this_box_volume.geometry.geometry_p_interact = p_interact;
// Currently the coordinates will be in absolute space.
this_box_volume.geometry.center = POS_A_CURRENT_COMP;

this_box_storage.z_depth = zdepth;
this_box_storage.x_width1 = xwidth;
this_box_storage.y_height1 = yheight;

this_box_storage.is_rectangle = 0;
if (xwidth2 < 0 && yheight2 < 0) this_box_storage.is_rectangle = 1;
if (xwidth == xwidth2 && yheight == yheight2) this_box_storage.is_rectangle = 1;

if (xwidth2 < 0) {
    this_box_storage.x_width2 = xwidth;
    xwidth2 = xwidth;
} else this_box_storage.x_width2 = xwidth2;

if (yheight2 < 0) {
    this_box_storage.y_height2 = yheight;
    yheight2 = yheight;
} else this_box_storage.y_height2 = yheight2;


this_box_storage.normal_vectors[0] = coords_set(0,0,1);
this_box_storage.normal_vectors[1] = coords_set(0,0,1);

// for sides with y component = 0
x_component = 2*zdepth/sqrt((xwidth-xwidth2)*(xwidth-xwidth2)+4*zdepth*zdepth);
z_component = (xwidth-xwidth2)/sqrt(4*zdepth*zdepth+(xwidth-xwidth2)*(xwidth-xwidth2));

this_box_storage.normal_vectors[2] = coords_set(x_component,0,z_component);
this_box_storage.normal_vectors[3] = coords_set(-x_component,0,z_component);

// for sides with x component = 0
y_component = 2*zdepth/sqrt((yheight-yheight2)*(yheight-yheight2)+4*zdepth*zdepth);
z_component = (yheight-yheight2)/sqrt(4*zdepth*zdepth+(yheight-yheight2)*(yheight-yheight2));

this_box_storage.normal_vectors[4] = coords_set(0,y_component,z_component);
this_box_storage.normal_vectors[5] = coords_set(0,-y_component,z_component);

this_box_volume.geometry.visualization_on = visualize;

this_box_volume.geometry.geometry_parameters.p_box_storage = &this_box_storage;

// Assign pointers to functions for intersection with the shape, checking if a point is inside the shape
if (this_box_storage.is_rectangle == 1) {
this_box_volume.geometry.intersect_function = &sample_box_intersect_simple;
this_box_volume.geometry.within_function = &r_within_box_simple;
}
else {
this_box_volume.geometry.intersect_function = &sample_box_intersect_advanced;
this_box_volume.geometry.within_function = &r_within_box_advanced;
}

this_box_volume.geometry.shell_points = &box_shell_points;
this_box_volume.geometry.mcdisplay_function = &mcdisplay_box_function;
this_box_volume.geometry.initialize_from_main_function = &initialize_box_geometry_from_main_component;
this_box_volume.geometry.process_rot_allocated = 0;

this_box_volume.geometry.copy_geometry_parameters = &allocate_box_storage_copy;

rot_copy(this_box_volume.geometry.rotation_matrix,ROT_A_CURRENT_COMP); //check how ROT_R_CURRENT_COMP would work
rot_transpose(ROT_A_CURRENT_COMP,this_box_volume.geometry.transpose_rotation_matrix);

// Initialize loggers
this_box_volume.loggers.num_elements = 0;

// packing the information into the global_geometry_element, which is then included in the global_geometry_list.
sprintf(global_geometry_element.name,NAME_CURRENT_COMP);
global_geometry_element.activation_counter = number_of_activations;
global_geometry_element.component_index = INDEX_CURRENT_COMP;
global_geometry_element.Volume = &this_box_volume; // Would be nicer if this m was a pointer, now we have the (small) data two places
add_element_to_geometry_list(&global_geometry_list,global_geometry_element);
}
#line 172745 "MACS_sample_kidney_box.c"
#undef number_of_activations
#undef mask_setting
#undef mask_string
#undef p_interact
#undef focus_r
#undef focus_xh
#undef focus_xw
#undef focus_ah
#undef focus_aw
#undef target_z
#undef target_y
#undef target_x
#undef target_index
#undef visualize
#undef yheight2
#undef xwidth2
#undef zdepth
#undef yheight
#undef xwidth
#undef priority
#undef material_string
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

  /* Initializations for component diffraction_detector_0_exit_volume. */
  SIG_MESSAGE("diffraction_detector_0_exit_volume (Init)");
#define mccompcurname  diffraction_detector_0_exit_volume
#define mccompcurtype  Union_box
#define mccompcurindex 160
#define loop_index mccdiffraction_detector_0_exit_volume_loop_index
#define this_box_volume mccdiffraction_detector_0_exit_volume_this_box_volume
#define global_geometry_element mccdiffraction_detector_0_exit_volume_global_geometry_element
#define this_box_storage mccdiffraction_detector_0_exit_volume_this_box_storage
#define material_string mccdiffraction_detector_0_exit_volume_material_string
#define priority mccdiffraction_detector_0_exit_volume_priority
#define xwidth mccdiffraction_detector_0_exit_volume_xwidth
#define yheight mccdiffraction_detector_0_exit_volume_yheight
#define zdepth mccdiffraction_detector_0_exit_volume_zdepth
#define xwidth2 mccdiffraction_detector_0_exit_volume_xwidth2
#define yheight2 mccdiffraction_detector_0_exit_volume_yheight2
#define visualize mccdiffraction_detector_0_exit_volume_visualize
#define target_index mccdiffraction_detector_0_exit_volume_target_index
#define target_x mccdiffraction_detector_0_exit_volume_target_x
#define target_y mccdiffraction_detector_0_exit_volume_target_y
#define target_z mccdiffraction_detector_0_exit_volume_target_z
#define focus_aw mccdiffraction_detector_0_exit_volume_focus_aw
#define focus_ah mccdiffraction_detector_0_exit_volume_focus_ah
#define focus_xw mccdiffraction_detector_0_exit_volume_focus_xw
#define focus_xh mccdiffraction_detector_0_exit_volume_focus_xh
#define focus_r mccdiffraction_detector_0_exit_volume_focus_r
#define p_interact mccdiffraction_detector_0_exit_volume_p_interact
#define mask_string mccdiffraction_detector_0_exit_volume_mask_string
#define mask_setting mccdiffraction_detector_0_exit_volume_mask_setting
#define number_of_activations mccdiffraction_detector_0_exit_volume_number_of_activations
#line 224 "Union_box.comp"
{
// Initializes the focusing system for this volume including input sanitation.
focus_initialize(&this_box_volume.geometry, POS_A_COMP_INDEX(INDEX_CURRENT_COMP+target_index), POS_A_CURRENT_COMP, ROT_A_CURRENT_COMP, target_index, target_x, target_y, target_z, focus_aw, focus_ah, focus_xw, focus_xh, focus_r, NAME_CURRENT_COMP);

// Input sanitation for this geometry
if (xwidth <= 0) {
  printf("\nERROR in Union_box named %s, the xwidth is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (yheight <= 0) {
  printf("\nERROR in Union_box named %s, yheight is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (zdepth <= 0) {
  printf("\nERROR in Union_box named %s, zdepth is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (xwidth2 <= 0 && xwidth2 != -1) {
  printf("\nERROR in Union_box named %s, the xwidth2 is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (yheight2 <= 0 && yheight2 != -1) {
  printf("\nERROR in Union_box named %s, yheight2 is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}

// Use sanitation
if (global_material_list.num_elements == 0) {
  printf("\nERROR: Need to define a material using Union_make_material before using a Union geometry component. \n");
  printf("       %s was defined before first use of Union_make_material.\n",NAME_CURRENT_COMP);
  exit(1);
}

this_box_volume.geometry.is_masked_volume = 0;
this_box_volume.geometry.is_exit_volume = 0;
this_box_volume.geometry.is_mask_volume = 0;
// check if the volume is a mask, if it is the material string is irelevant.
if (mask_string && strlen(mask_string) && strcmp(mask_string, "NULL") && strcmp(mask_string, "0")) {
    // A mask volume is used to limit the extend of other volumes, called the masked volumes. These are specified in the mask_string.
    // In order for a ray to enter a masked volume, it needs to be both in the region covered by that volume AND the mask volume.
    // When more than
    this_box_volume.geometry.mask_mode = 1; // Default is mask mode is ALL
    if (mask_setting && strlen(mask_setting) && strcmp(mask_setting, "NULL") && strcmp(mask_setting, "0")) {
        if (strcmp(mask_setting,"ALL") == 0 || strcmp(mask_setting,"All") == 0) this_box_volume.geometry.mask_mode = 1;
        else if (strcmp(mask_setting,"ANY") == 0 || strcmp(mask_setting,"Any") == 0) this_box_volume.geometry.mask_mode = 2;
        else {
            printf("The mask_mode of component %s is set to %s, but must be either ALL or ANY.\n",NAME_CURRENT_COMP,mask_setting);
            exit(1);
        }
    }
    
    for (loop_index=0;loop_index<global_geometry_list.num_elements;loop_index++) {
        // Add mask list
        if (1 == manual_linking_function(global_geometry_list.elements[loop_index].name,mask_string)) {
            add_element_to_int_list(&this_box_volume.geometry.mask_list,global_geometry_list.elements[loop_index].component_index);
            add_element_to_int_list(&global_geometry_list.elements[loop_index].Volume->geometry.masked_by_list,INDEX_CURRENT_COMP);
            global_geometry_list.elements[loop_index].Volume->geometry.is_masked_volume = 1;
            if (this_box_volume.geometry.mask_mode == 2)
                global_geometry_list.elements[loop_index].Volume->geometry.mask_mode = 2;
            if (this_box_volume.geometry.mask_mode == 1) {
                if (global_geometry_list.elements[loop_index].Volume->geometry.is_masked_volume == 1 && global_geometry_list.elements[loop_index].Volume->geometry.mask_mode != 2)
                    // If more than one mask is added to one volume, the ANY mode overwrites the (default) ALL mode.
                    global_geometry_list.elements[loop_index].Volume->geometry.mask_mode = 1;
            }
            
            found_geometries = 1;
        }
    }
    if (found_geometries == 0) {
        printf("The mask_string in geometry: %s did not find any of the specified volumes in the mask_string %s \n",NAME_CURRENT_COMP,mask_string);
        exit(1);
    }
    this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
    this_box_volume.p_physics->is_vacuum = 0; // Makes this volume a vacuum
    this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
    this_box_volume.p_physics->my_a = 0; // Should not be used.
    sprintf(this_box_volume.p_physics->name,"Mask");
    this_box_volume.geometry.is_mask_volume = 1;
    
    
// Read the material input, or if it lacks, use automatic linking.
} else if (material_string && strlen(material_string) && strcmp(material_string, "NULL") && strcmp(material_string, "0")) {
    // A geometry string was given, use it to determine which material
    if (0 == strcmp(material_string,"vacuum") || 0 == strcmp(material_string,"Vacuum")) {
        // One could have a global physics struct for vacuum instead of creating one for each
        this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
        this_box_volume.p_physics->is_vacuum = 1; // Makes this volume a vacuum
        this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
        this_box_volume.p_physics->my_a = 0; // Should not be used.
        sprintf(this_box_volume.p_physics->name,"Vacuum");
    } else if (0 == strcmp(material_string,"exit") || 0 == strcmp(material_string,"Exit")) {
        // One could have a global physics struct for vacuum instead of creating one for each
        this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
        this_box_volume.p_physics->is_vacuum = 1; // Makes this volume a vacuum
        this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
        this_box_volume.p_physics->my_a = 0; // Should not be used.
        this_box_volume.geometry.is_exit_volume = 1;
        sprintf(this_box_volume.p_physics->name,"Exit");
    } else {
        #ifndef MATERIAL_DETECTOR
            printf("Need to define a material before refering to it in a geometry %s.\n",NAME_CURRENT_COMP);
            exit(1);
        #endif
        for (loop_index=0;loop_index<global_material_list.num_elements;loop_index++) {
            if (0 == strcmp(material_string,global_material_list.elements[loop_index].name)) {
                this_box_volume.p_physics = global_material_list.elements[loop_index].physics;
                break;
            }
            if (loop_index == global_material_list.num_elements-1) {
            printf("\n");
            printf("ERROR: The material string \"%s\" in Union geometry \"%s\" did not match a specified material. \n",material_string,NAME_CURRENT_COMP);
            printf("       The materials available at this point (need to be defined before the geometry): \n");
            for (loop_index=0;loop_index<global_material_list.num_elements;loop_index++)
              printf("         %s\n",global_material_list.elements[loop_index].name);
            printf("\n");
            printf("       It is also possible to use one of the defualt materials avaiable: \n");
            printf("           Vacuum (for a Volume without scattering or absorption)\n");
            printf("           Exit (for a Volume where the ray exits the component if it enters)\n");
            printf("           Mask (for a Volume that masks existing volumes specified in the mask_string\n");
            exit(1);
          }
        }
    }
} else {
    // Automatic linking, simply using the last defined material.
    #ifndef MATERIAL_DETECTOR
        printf("Need to define a material before the geometry to use automatic linking %s.\n",NAME_CURRENT_COMP);
        exit(1);
    #endif
    this_box_volume.p_physics = global_material_list.elements[global_material_list.num_elements-1].physics;
}

sprintf(this_box_volume.name,NAME_CURRENT_COMP);
sprintf(this_box_volume.geometry.shape,"box");
this_box_volume.geometry.priority_value = priority;
this_box_volume.geometry.geometry_p_interact = p_interact;
// Currently the coordinates will be in absolute space.
this_box_volume.geometry.center = POS_A_CURRENT_COMP;

this_box_storage.z_depth = zdepth;
this_box_storage.x_width1 = xwidth;
this_box_storage.y_height1 = yheight;

this_box_storage.is_rectangle = 0;
if (xwidth2 < 0 && yheight2 < 0) this_box_storage.is_rectangle = 1;
if (xwidth == xwidth2 && yheight == yheight2) this_box_storage.is_rectangle = 1;

if (xwidth2 < 0) {
    this_box_storage.x_width2 = xwidth;
    xwidth2 = xwidth;
} else this_box_storage.x_width2 = xwidth2;

if (yheight2 < 0) {
    this_box_storage.y_height2 = yheight;
    yheight2 = yheight;
} else this_box_storage.y_height2 = yheight2;


this_box_storage.normal_vectors[0] = coords_set(0,0,1);
this_box_storage.normal_vectors[1] = coords_set(0,0,1);

// for sides with y component = 0
x_component = 2*zdepth/sqrt((xwidth-xwidth2)*(xwidth-xwidth2)+4*zdepth*zdepth);
z_component = (xwidth-xwidth2)/sqrt(4*zdepth*zdepth+(xwidth-xwidth2)*(xwidth-xwidth2));

this_box_storage.normal_vectors[2] = coords_set(x_component,0,z_component);
this_box_storage.normal_vectors[3] = coords_set(-x_component,0,z_component);

// for sides with x component = 0
y_component = 2*zdepth/sqrt((yheight-yheight2)*(yheight-yheight2)+4*zdepth*zdepth);
z_component = (yheight-yheight2)/sqrt(4*zdepth*zdepth+(yheight-yheight2)*(yheight-yheight2));

this_box_storage.normal_vectors[4] = coords_set(0,y_component,z_component);
this_box_storage.normal_vectors[5] = coords_set(0,-y_component,z_component);

this_box_volume.geometry.visualization_on = visualize;

this_box_volume.geometry.geometry_parameters.p_box_storage = &this_box_storage;

// Assign pointers to functions for intersection with the shape, checking if a point is inside the shape
if (this_box_storage.is_rectangle == 1) {
this_box_volume.geometry.intersect_function = &sample_box_intersect_simple;
this_box_volume.geometry.within_function = &r_within_box_simple;
}
else {
this_box_volume.geometry.intersect_function = &sample_box_intersect_advanced;
this_box_volume.geometry.within_function = &r_within_box_advanced;
}

this_box_volume.geometry.shell_points = &box_shell_points;
this_box_volume.geometry.mcdisplay_function = &mcdisplay_box_function;
this_box_volume.geometry.initialize_from_main_function = &initialize_box_geometry_from_main_component;
this_box_volume.geometry.process_rot_allocated = 0;

this_box_volume.geometry.copy_geometry_parameters = &allocate_box_storage_copy;

rot_copy(this_box_volume.geometry.rotation_matrix,ROT_A_CURRENT_COMP); //check how ROT_R_CURRENT_COMP would work
rot_transpose(ROT_A_CURRENT_COMP,this_box_volume.geometry.transpose_rotation_matrix);

// Initialize loggers
this_box_volume.loggers.num_elements = 0;

// packing the information into the global_geometry_element, which is then included in the global_geometry_list.
sprintf(global_geometry_element.name,NAME_CURRENT_COMP);
global_geometry_element.activation_counter = number_of_activations;
global_geometry_element.component_index = INDEX_CURRENT_COMP;
global_geometry_element.Volume = &this_box_volume; // Would be nicer if this m was a pointer, now we have the (small) data two places
add_element_to_geometry_list(&global_geometry_list,global_geometry_element);
}
#line 173015 "MACS_sample_kidney_box.c"
#undef number_of_activations
#undef mask_setting
#undef mask_string
#undef p_interact
#undef focus_r
#undef focus_xh
#undef focus_xw
#undef focus_ah
#undef focus_aw
#undef target_z
#undef target_y
#undef target_x
#undef target_index
#undef visualize
#undef yheight2
#undef xwidth2
#undef zdepth
#undef yheight
#undef xwidth
#undef priority
#undef material_string
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

  /* Initializations for component spec_detector_0_exit_volume. */
  SIG_MESSAGE("spec_detector_0_exit_volume (Init)");
#define mccompcurname  spec_detector_0_exit_volume
#define mccompcurtype  Union_box
#define mccompcurindex 161
#define loop_index mccspec_detector_0_exit_volume_loop_index
#define this_box_volume mccspec_detector_0_exit_volume_this_box_volume
#define global_geometry_element mccspec_detector_0_exit_volume_global_geometry_element
#define this_box_storage mccspec_detector_0_exit_volume_this_box_storage
#define material_string mccspec_detector_0_exit_volume_material_string
#define priority mccspec_detector_0_exit_volume_priority
#define xwidth mccspec_detector_0_exit_volume_xwidth
#define yheight mccspec_detector_0_exit_volume_yheight
#define zdepth mccspec_detector_0_exit_volume_zdepth
#define xwidth2 mccspec_detector_0_exit_volume_xwidth2
#define yheight2 mccspec_detector_0_exit_volume_yheight2
#define visualize mccspec_detector_0_exit_volume_visualize
#define target_index mccspec_detector_0_exit_volume_target_index
#define target_x mccspec_detector_0_exit_volume_target_x
#define target_y mccspec_detector_0_exit_volume_target_y
#define target_z mccspec_detector_0_exit_volume_target_z
#define focus_aw mccspec_detector_0_exit_volume_focus_aw
#define focus_ah mccspec_detector_0_exit_volume_focus_ah
#define focus_xw mccspec_detector_0_exit_volume_focus_xw
#define focus_xh mccspec_detector_0_exit_volume_focus_xh
#define focus_r mccspec_detector_0_exit_volume_focus_r
#define p_interact mccspec_detector_0_exit_volume_p_interact
#define mask_string mccspec_detector_0_exit_volume_mask_string
#define mask_setting mccspec_detector_0_exit_volume_mask_setting
#define number_of_activations mccspec_detector_0_exit_volume_number_of_activations
#line 224 "Union_box.comp"
{
// Initializes the focusing system for this volume including input sanitation.
focus_initialize(&this_box_volume.geometry, POS_A_COMP_INDEX(INDEX_CURRENT_COMP+target_index), POS_A_CURRENT_COMP, ROT_A_CURRENT_COMP, target_index, target_x, target_y, target_z, focus_aw, focus_ah, focus_xw, focus_xh, focus_r, NAME_CURRENT_COMP);

// Input sanitation for this geometry
if (xwidth <= 0) {
  printf("\nERROR in Union_box named %s, the xwidth is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (yheight <= 0) {
  printf("\nERROR in Union_box named %s, yheight is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (zdepth <= 0) {
  printf("\nERROR in Union_box named %s, zdepth is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (xwidth2 <= 0 && xwidth2 != -1) {
  printf("\nERROR in Union_box named %s, the xwidth2 is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (yheight2 <= 0 && yheight2 != -1) {
  printf("\nERROR in Union_box named %s, yheight2 is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}

// Use sanitation
if (global_material_list.num_elements == 0) {
  printf("\nERROR: Need to define a material using Union_make_material before using a Union geometry component. \n");
  printf("       %s was defined before first use of Union_make_material.\n",NAME_CURRENT_COMP);
  exit(1);
}

this_box_volume.geometry.is_masked_volume = 0;
this_box_volume.geometry.is_exit_volume = 0;
this_box_volume.geometry.is_mask_volume = 0;
// check if the volume is a mask, if it is the material string is irelevant.
if (mask_string && strlen(mask_string) && strcmp(mask_string, "NULL") && strcmp(mask_string, "0")) {
    // A mask volume is used to limit the extend of other volumes, called the masked volumes. These are specified in the mask_string.
    // In order for a ray to enter a masked volume, it needs to be both in the region covered by that volume AND the mask volume.
    // When more than
    this_box_volume.geometry.mask_mode = 1; // Default is mask mode is ALL
    if (mask_setting && strlen(mask_setting) && strcmp(mask_setting, "NULL") && strcmp(mask_setting, "0")) {
        if (strcmp(mask_setting,"ALL") == 0 || strcmp(mask_setting,"All") == 0) this_box_volume.geometry.mask_mode = 1;
        else if (strcmp(mask_setting,"ANY") == 0 || strcmp(mask_setting,"Any") == 0) this_box_volume.geometry.mask_mode = 2;
        else {
            printf("The mask_mode of component %s is set to %s, but must be either ALL or ANY.\n",NAME_CURRENT_COMP,mask_setting);
            exit(1);
        }
    }
    
    for (loop_index=0;loop_index<global_geometry_list.num_elements;loop_index++) {
        // Add mask list
        if (1 == manual_linking_function(global_geometry_list.elements[loop_index].name,mask_string)) {
            add_element_to_int_list(&this_box_volume.geometry.mask_list,global_geometry_list.elements[loop_index].component_index);
            add_element_to_int_list(&global_geometry_list.elements[loop_index].Volume->geometry.masked_by_list,INDEX_CURRENT_COMP);
            global_geometry_list.elements[loop_index].Volume->geometry.is_masked_volume = 1;
            if (this_box_volume.geometry.mask_mode == 2)
                global_geometry_list.elements[loop_index].Volume->geometry.mask_mode = 2;
            if (this_box_volume.geometry.mask_mode == 1) {
                if (global_geometry_list.elements[loop_index].Volume->geometry.is_masked_volume == 1 && global_geometry_list.elements[loop_index].Volume->geometry.mask_mode != 2)
                    // If more than one mask is added to one volume, the ANY mode overwrites the (default) ALL mode.
                    global_geometry_list.elements[loop_index].Volume->geometry.mask_mode = 1;
            }
            
            found_geometries = 1;
        }
    }
    if (found_geometries == 0) {
        printf("The mask_string in geometry: %s did not find any of the specified volumes in the mask_string %s \n",NAME_CURRENT_COMP,mask_string);
        exit(1);
    }
    this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
    this_box_volume.p_physics->is_vacuum = 0; // Makes this volume a vacuum
    this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
    this_box_volume.p_physics->my_a = 0; // Should not be used.
    sprintf(this_box_volume.p_physics->name,"Mask");
    this_box_volume.geometry.is_mask_volume = 1;
    
    
// Read the material input, or if it lacks, use automatic linking.
} else if (material_string && strlen(material_string) && strcmp(material_string, "NULL") && strcmp(material_string, "0")) {
    // A geometry string was given, use it to determine which material
    if (0 == strcmp(material_string,"vacuum") || 0 == strcmp(material_string,"Vacuum")) {
        // One could have a global physics struct for vacuum instead of creating one for each
        this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
        this_box_volume.p_physics->is_vacuum = 1; // Makes this volume a vacuum
        this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
        this_box_volume.p_physics->my_a = 0; // Should not be used.
        sprintf(this_box_volume.p_physics->name,"Vacuum");
    } else if (0 == strcmp(material_string,"exit") || 0 == strcmp(material_string,"Exit")) {
        // One could have a global physics struct for vacuum instead of creating one for each
        this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
        this_box_volume.p_physics->is_vacuum = 1; // Makes this volume a vacuum
        this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
        this_box_volume.p_physics->my_a = 0; // Should not be used.
        this_box_volume.geometry.is_exit_volume = 1;
        sprintf(this_box_volume.p_physics->name,"Exit");
    } else {
        #ifndef MATERIAL_DETECTOR
            printf("Need to define a material before refering to it in a geometry %s.\n",NAME_CURRENT_COMP);
            exit(1);
        #endif
        for (loop_index=0;loop_index<global_material_list.num_elements;loop_index++) {
            if (0 == strcmp(material_string,global_material_list.elements[loop_index].name)) {
                this_box_volume.p_physics = global_material_list.elements[loop_index].physics;
                break;
            }
            if (loop_index == global_material_list.num_elements-1) {
            printf("\n");
            printf("ERROR: The material string \"%s\" in Union geometry \"%s\" did not match a specified material. \n",material_string,NAME_CURRENT_COMP);
            printf("       The materials available at this point (need to be defined before the geometry): \n");
            for (loop_index=0;loop_index<global_material_list.num_elements;loop_index++)
              printf("         %s\n",global_material_list.elements[loop_index].name);
            printf("\n");
            printf("       It is also possible to use one of the defualt materials avaiable: \n");
            printf("           Vacuum (for a Volume without scattering or absorption)\n");
            printf("           Exit (for a Volume where the ray exits the component if it enters)\n");
            printf("           Mask (for a Volume that masks existing volumes specified in the mask_string\n");
            exit(1);
          }
        }
    }
} else {
    // Automatic linking, simply using the last defined material.
    #ifndef MATERIAL_DETECTOR
        printf("Need to define a material before the geometry to use automatic linking %s.\n",NAME_CURRENT_COMP);
        exit(1);
    #endif
    this_box_volume.p_physics = global_material_list.elements[global_material_list.num_elements-1].physics;
}

sprintf(this_box_volume.name,NAME_CURRENT_COMP);
sprintf(this_box_volume.geometry.shape,"box");
this_box_volume.geometry.priority_value = priority;
this_box_volume.geometry.geometry_p_interact = p_interact;
// Currently the coordinates will be in absolute space.
this_box_volume.geometry.center = POS_A_CURRENT_COMP;

this_box_storage.z_depth = zdepth;
this_box_storage.x_width1 = xwidth;
this_box_storage.y_height1 = yheight;

this_box_storage.is_rectangle = 0;
if (xwidth2 < 0 && yheight2 < 0) this_box_storage.is_rectangle = 1;
if (xwidth == xwidth2 && yheight == yheight2) this_box_storage.is_rectangle = 1;

if (xwidth2 < 0) {
    this_box_storage.x_width2 = xwidth;
    xwidth2 = xwidth;
} else this_box_storage.x_width2 = xwidth2;

if (yheight2 < 0) {
    this_box_storage.y_height2 = yheight;
    yheight2 = yheight;
} else this_box_storage.y_height2 = yheight2;


this_box_storage.normal_vectors[0] = coords_set(0,0,1);
this_box_storage.normal_vectors[1] = coords_set(0,0,1);

// for sides with y component = 0
x_component = 2*zdepth/sqrt((xwidth-xwidth2)*(xwidth-xwidth2)+4*zdepth*zdepth);
z_component = (xwidth-xwidth2)/sqrt(4*zdepth*zdepth+(xwidth-xwidth2)*(xwidth-xwidth2));

this_box_storage.normal_vectors[2] = coords_set(x_component,0,z_component);
this_box_storage.normal_vectors[3] = coords_set(-x_component,0,z_component);

// for sides with x component = 0
y_component = 2*zdepth/sqrt((yheight-yheight2)*(yheight-yheight2)+4*zdepth*zdepth);
z_component = (yheight-yheight2)/sqrt(4*zdepth*zdepth+(yheight-yheight2)*(yheight-yheight2));

this_box_storage.normal_vectors[4] = coords_set(0,y_component,z_component);
this_box_storage.normal_vectors[5] = coords_set(0,-y_component,z_component);

this_box_volume.geometry.visualization_on = visualize;

this_box_volume.geometry.geometry_parameters.p_box_storage = &this_box_storage;

// Assign pointers to functions for intersection with the shape, checking if a point is inside the shape
if (this_box_storage.is_rectangle == 1) {
this_box_volume.geometry.intersect_function = &sample_box_intersect_simple;
this_box_volume.geometry.within_function = &r_within_box_simple;
}
else {
this_box_volume.geometry.intersect_function = &sample_box_intersect_advanced;
this_box_volume.geometry.within_function = &r_within_box_advanced;
}

this_box_volume.geometry.shell_points = &box_shell_points;
this_box_volume.geometry.mcdisplay_function = &mcdisplay_box_function;
this_box_volume.geometry.initialize_from_main_function = &initialize_box_geometry_from_main_component;
this_box_volume.geometry.process_rot_allocated = 0;

this_box_volume.geometry.copy_geometry_parameters = &allocate_box_storage_copy;

rot_copy(this_box_volume.geometry.rotation_matrix,ROT_A_CURRENT_COMP); //check how ROT_R_CURRENT_COMP would work
rot_transpose(ROT_A_CURRENT_COMP,this_box_volume.geometry.transpose_rotation_matrix);

// Initialize loggers
this_box_volume.loggers.num_elements = 0;

// packing the information into the global_geometry_element, which is then included in the global_geometry_list.
sprintf(global_geometry_element.name,NAME_CURRENT_COMP);
global_geometry_element.activation_counter = number_of_activations;
global_geometry_element.component_index = INDEX_CURRENT_COMP;
global_geometry_element.Volume = &this_box_volume; // Would be nicer if this m was a pointer, now we have the (small) data two places
add_element_to_geometry_list(&global_geometry_list,global_geometry_element);
}
#line 173285 "MACS_sample_kidney_box.c"
#undef number_of_activations
#undef mask_setting
#undef mask_string
#undef p_interact
#undef focus_r
#undef focus_xh
#undef focus_xw
#undef focus_ah
#undef focus_aw
#undef target_z
#undef target_y
#undef target_x
#undef target_index
#undef visualize
#undef yheight2
#undef xwidth2
#undef zdepth
#undef yheight
#undef xwidth
#undef priority
#undef material_string
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

  /* Initializations for component channel_1_cave1_box1. */
  SIG_MESSAGE("channel_1_cave1_box1 (Init)");
#define mccompcurname  channel_1_cave1_box1
#define mccompcurtype  Union_box
#define mccompcurindex 162
#define loop_index mccchannel_1_cave1_box1_loop_index
#define this_box_volume mccchannel_1_cave1_box1_this_box_volume
#define global_geometry_element mccchannel_1_cave1_box1_global_geometry_element
#define this_box_storage mccchannel_1_cave1_box1_this_box_storage
#define material_string mccchannel_1_cave1_box1_material_string
#define priority mccchannel_1_cave1_box1_priority
#define xwidth mccchannel_1_cave1_box1_xwidth
#define yheight mccchannel_1_cave1_box1_yheight
#define zdepth mccchannel_1_cave1_box1_zdepth
#define xwidth2 mccchannel_1_cave1_box1_xwidth2
#define yheight2 mccchannel_1_cave1_box1_yheight2
#define visualize mccchannel_1_cave1_box1_visualize
#define target_index mccchannel_1_cave1_box1_target_index
#define target_x mccchannel_1_cave1_box1_target_x
#define target_y mccchannel_1_cave1_box1_target_y
#define target_z mccchannel_1_cave1_box1_target_z
#define focus_aw mccchannel_1_cave1_box1_focus_aw
#define focus_ah mccchannel_1_cave1_box1_focus_ah
#define focus_xw mccchannel_1_cave1_box1_focus_xw
#define focus_xh mccchannel_1_cave1_box1_focus_xh
#define focus_r mccchannel_1_cave1_box1_focus_r
#define p_interact mccchannel_1_cave1_box1_p_interact
#define mask_string mccchannel_1_cave1_box1_mask_string
#define mask_setting mccchannel_1_cave1_box1_mask_setting
#define number_of_activations mccchannel_1_cave1_box1_number_of_activations
#line 224 "Union_box.comp"
{
// Initializes the focusing system for this volume including input sanitation.
focus_initialize(&this_box_volume.geometry, POS_A_COMP_INDEX(INDEX_CURRENT_COMP+target_index), POS_A_CURRENT_COMP, ROT_A_CURRENT_COMP, target_index, target_x, target_y, target_z, focus_aw, focus_ah, focus_xw, focus_xh, focus_r, NAME_CURRENT_COMP);

// Input sanitation for this geometry
if (xwidth <= 0) {
  printf("\nERROR in Union_box named %s, the xwidth is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (yheight <= 0) {
  printf("\nERROR in Union_box named %s, yheight is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (zdepth <= 0) {
  printf("\nERROR in Union_box named %s, zdepth is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (xwidth2 <= 0 && xwidth2 != -1) {
  printf("\nERROR in Union_box named %s, the xwidth2 is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (yheight2 <= 0 && yheight2 != -1) {
  printf("\nERROR in Union_box named %s, yheight2 is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}

// Use sanitation
if (global_material_list.num_elements == 0) {
  printf("\nERROR: Need to define a material using Union_make_material before using a Union geometry component. \n");
  printf("       %s was defined before first use of Union_make_material.\n",NAME_CURRENT_COMP);
  exit(1);
}

this_box_volume.geometry.is_masked_volume = 0;
this_box_volume.geometry.is_exit_volume = 0;
this_box_volume.geometry.is_mask_volume = 0;
// check if the volume is a mask, if it is the material string is irelevant.
if (mask_string && strlen(mask_string) && strcmp(mask_string, "NULL") && strcmp(mask_string, "0")) {
    // A mask volume is used to limit the extend of other volumes, called the masked volumes. These are specified in the mask_string.
    // In order for a ray to enter a masked volume, it needs to be both in the region covered by that volume AND the mask volume.
    // When more than
    this_box_volume.geometry.mask_mode = 1; // Default is mask mode is ALL
    if (mask_setting && strlen(mask_setting) && strcmp(mask_setting, "NULL") && strcmp(mask_setting, "0")) {
        if (strcmp(mask_setting,"ALL") == 0 || strcmp(mask_setting,"All") == 0) this_box_volume.geometry.mask_mode = 1;
        else if (strcmp(mask_setting,"ANY") == 0 || strcmp(mask_setting,"Any") == 0) this_box_volume.geometry.mask_mode = 2;
        else {
            printf("The mask_mode of component %s is set to %s, but must be either ALL or ANY.\n",NAME_CURRENT_COMP,mask_setting);
            exit(1);
        }
    }
    
    for (loop_index=0;loop_index<global_geometry_list.num_elements;loop_index++) {
        // Add mask list
        if (1 == manual_linking_function(global_geometry_list.elements[loop_index].name,mask_string)) {
            add_element_to_int_list(&this_box_volume.geometry.mask_list,global_geometry_list.elements[loop_index].component_index);
            add_element_to_int_list(&global_geometry_list.elements[loop_index].Volume->geometry.masked_by_list,INDEX_CURRENT_COMP);
            global_geometry_list.elements[loop_index].Volume->geometry.is_masked_volume = 1;
            if (this_box_volume.geometry.mask_mode == 2)
                global_geometry_list.elements[loop_index].Volume->geometry.mask_mode = 2;
            if (this_box_volume.geometry.mask_mode == 1) {
                if (global_geometry_list.elements[loop_index].Volume->geometry.is_masked_volume == 1 && global_geometry_list.elements[loop_index].Volume->geometry.mask_mode != 2)
                    // If more than one mask is added to one volume, the ANY mode overwrites the (default) ALL mode.
                    global_geometry_list.elements[loop_index].Volume->geometry.mask_mode = 1;
            }
            
            found_geometries = 1;
        }
    }
    if (found_geometries == 0) {
        printf("The mask_string in geometry: %s did not find any of the specified volumes in the mask_string %s \n",NAME_CURRENT_COMP,mask_string);
        exit(1);
    }
    this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
    this_box_volume.p_physics->is_vacuum = 0; // Makes this volume a vacuum
    this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
    this_box_volume.p_physics->my_a = 0; // Should not be used.
    sprintf(this_box_volume.p_physics->name,"Mask");
    this_box_volume.geometry.is_mask_volume = 1;
    
    
// Read the material input, or if it lacks, use automatic linking.
} else if (material_string && strlen(material_string) && strcmp(material_string, "NULL") && strcmp(material_string, "0")) {
    // A geometry string was given, use it to determine which material
    if (0 == strcmp(material_string,"vacuum") || 0 == strcmp(material_string,"Vacuum")) {
        // One could have a global physics struct for vacuum instead of creating one for each
        this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
        this_box_volume.p_physics->is_vacuum = 1; // Makes this volume a vacuum
        this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
        this_box_volume.p_physics->my_a = 0; // Should not be used.
        sprintf(this_box_volume.p_physics->name,"Vacuum");
    } else if (0 == strcmp(material_string,"exit") || 0 == strcmp(material_string,"Exit")) {
        // One could have a global physics struct for vacuum instead of creating one for each
        this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
        this_box_volume.p_physics->is_vacuum = 1; // Makes this volume a vacuum
        this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
        this_box_volume.p_physics->my_a = 0; // Should not be used.
        this_box_volume.geometry.is_exit_volume = 1;
        sprintf(this_box_volume.p_physics->name,"Exit");
    } else {
        #ifndef MATERIAL_DETECTOR
            printf("Need to define a material before refering to it in a geometry %s.\n",NAME_CURRENT_COMP);
            exit(1);
        #endif
        for (loop_index=0;loop_index<global_material_list.num_elements;loop_index++) {
            if (0 == strcmp(material_string,global_material_list.elements[loop_index].name)) {
                this_box_volume.p_physics = global_material_list.elements[loop_index].physics;
                break;
            }
            if (loop_index == global_material_list.num_elements-1) {
            printf("\n");
            printf("ERROR: The material string \"%s\" in Union geometry \"%s\" did not match a specified material. \n",material_string,NAME_CURRENT_COMP);
            printf("       The materials available at this point (need to be defined before the geometry): \n");
            for (loop_index=0;loop_index<global_material_list.num_elements;loop_index++)
              printf("         %s\n",global_material_list.elements[loop_index].name);
            printf("\n");
            printf("       It is also possible to use one of the defualt materials avaiable: \n");
            printf("           Vacuum (for a Volume without scattering or absorption)\n");
            printf("           Exit (for a Volume where the ray exits the component if it enters)\n");
            printf("           Mask (for a Volume that masks existing volumes specified in the mask_string\n");
            exit(1);
          }
        }
    }
} else {
    // Automatic linking, simply using the last defined material.
    #ifndef MATERIAL_DETECTOR
        printf("Need to define a material before the geometry to use automatic linking %s.\n",NAME_CURRENT_COMP);
        exit(1);
    #endif
    this_box_volume.p_physics = global_material_list.elements[global_material_list.num_elements-1].physics;
}

sprintf(this_box_volume.name,NAME_CURRENT_COMP);
sprintf(this_box_volume.geometry.shape,"box");
this_box_volume.geometry.priority_value = priority;
this_box_volume.geometry.geometry_p_interact = p_interact;
// Currently the coordinates will be in absolute space.
this_box_volume.geometry.center = POS_A_CURRENT_COMP;

this_box_storage.z_depth = zdepth;
this_box_storage.x_width1 = xwidth;
this_box_storage.y_height1 = yheight;

this_box_storage.is_rectangle = 0;
if (xwidth2 < 0 && yheight2 < 0) this_box_storage.is_rectangle = 1;
if (xwidth == xwidth2 && yheight == yheight2) this_box_storage.is_rectangle = 1;

if (xwidth2 < 0) {
    this_box_storage.x_width2 = xwidth;
    xwidth2 = xwidth;
} else this_box_storage.x_width2 = xwidth2;

if (yheight2 < 0) {
    this_box_storage.y_height2 = yheight;
    yheight2 = yheight;
} else this_box_storage.y_height2 = yheight2;


this_box_storage.normal_vectors[0] = coords_set(0,0,1);
this_box_storage.normal_vectors[1] = coords_set(0,0,1);

// for sides with y component = 0
x_component = 2*zdepth/sqrt((xwidth-xwidth2)*(xwidth-xwidth2)+4*zdepth*zdepth);
z_component = (xwidth-xwidth2)/sqrt(4*zdepth*zdepth+(xwidth-xwidth2)*(xwidth-xwidth2));

this_box_storage.normal_vectors[2] = coords_set(x_component,0,z_component);
this_box_storage.normal_vectors[3] = coords_set(-x_component,0,z_component);

// for sides with x component = 0
y_component = 2*zdepth/sqrt((yheight-yheight2)*(yheight-yheight2)+4*zdepth*zdepth);
z_component = (yheight-yheight2)/sqrt(4*zdepth*zdepth+(yheight-yheight2)*(yheight-yheight2));

this_box_storage.normal_vectors[4] = coords_set(0,y_component,z_component);
this_box_storage.normal_vectors[5] = coords_set(0,-y_component,z_component);

this_box_volume.geometry.visualization_on = visualize;

this_box_volume.geometry.geometry_parameters.p_box_storage = &this_box_storage;

// Assign pointers to functions for intersection with the shape, checking if a point is inside the shape
if (this_box_storage.is_rectangle == 1) {
this_box_volume.geometry.intersect_function = &sample_box_intersect_simple;
this_box_volume.geometry.within_function = &r_within_box_simple;
}
else {
this_box_volume.geometry.intersect_function = &sample_box_intersect_advanced;
this_box_volume.geometry.within_function = &r_within_box_advanced;
}

this_box_volume.geometry.shell_points = &box_shell_points;
this_box_volume.geometry.mcdisplay_function = &mcdisplay_box_function;
this_box_volume.geometry.initialize_from_main_function = &initialize_box_geometry_from_main_component;
this_box_volume.geometry.process_rot_allocated = 0;

this_box_volume.geometry.copy_geometry_parameters = &allocate_box_storage_copy;

rot_copy(this_box_volume.geometry.rotation_matrix,ROT_A_CURRENT_COMP); //check how ROT_R_CURRENT_COMP would work
rot_transpose(ROT_A_CURRENT_COMP,this_box_volume.geometry.transpose_rotation_matrix);

// Initialize loggers
this_box_volume.loggers.num_elements = 0;

// packing the information into the global_geometry_element, which is then included in the global_geometry_list.
sprintf(global_geometry_element.name,NAME_CURRENT_COMP);
global_geometry_element.activation_counter = number_of_activations;
global_geometry_element.component_index = INDEX_CURRENT_COMP;
global_geometry_element.Volume = &this_box_volume; // Would be nicer if this m was a pointer, now we have the (small) data two places
add_element_to_geometry_list(&global_geometry_list,global_geometry_element);
}
#line 173555 "MACS_sample_kidney_box.c"
#undef number_of_activations
#undef mask_setting
#undef mask_string
#undef p_interact
#undef focus_r
#undef focus_xh
#undef focus_xw
#undef focus_ah
#undef focus_aw
#undef target_z
#undef target_y
#undef target_x
#undef target_index
#undef visualize
#undef yheight2
#undef xwidth2
#undef zdepth
#undef yheight
#undef xwidth
#undef priority
#undef material_string
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

  /* Initializations for component channel_1_cave1_box2. */
  SIG_MESSAGE("channel_1_cave1_box2 (Init)");
#define mccompcurname  channel_1_cave1_box2
#define mccompcurtype  Union_box
#define mccompcurindex 163
#define loop_index mccchannel_1_cave1_box2_loop_index
#define this_box_volume mccchannel_1_cave1_box2_this_box_volume
#define global_geometry_element mccchannel_1_cave1_box2_global_geometry_element
#define this_box_storage mccchannel_1_cave1_box2_this_box_storage
#define material_string mccchannel_1_cave1_box2_material_string
#define priority mccchannel_1_cave1_box2_priority
#define xwidth mccchannel_1_cave1_box2_xwidth
#define yheight mccchannel_1_cave1_box2_yheight
#define zdepth mccchannel_1_cave1_box2_zdepth
#define xwidth2 mccchannel_1_cave1_box2_xwidth2
#define yheight2 mccchannel_1_cave1_box2_yheight2
#define visualize mccchannel_1_cave1_box2_visualize
#define target_index mccchannel_1_cave1_box2_target_index
#define target_x mccchannel_1_cave1_box2_target_x
#define target_y mccchannel_1_cave1_box2_target_y
#define target_z mccchannel_1_cave1_box2_target_z
#define focus_aw mccchannel_1_cave1_box2_focus_aw
#define focus_ah mccchannel_1_cave1_box2_focus_ah
#define focus_xw mccchannel_1_cave1_box2_focus_xw
#define focus_xh mccchannel_1_cave1_box2_focus_xh
#define focus_r mccchannel_1_cave1_box2_focus_r
#define p_interact mccchannel_1_cave1_box2_p_interact
#define mask_string mccchannel_1_cave1_box2_mask_string
#define mask_setting mccchannel_1_cave1_box2_mask_setting
#define number_of_activations mccchannel_1_cave1_box2_number_of_activations
#line 224 "Union_box.comp"
{
// Initializes the focusing system for this volume including input sanitation.
focus_initialize(&this_box_volume.geometry, POS_A_COMP_INDEX(INDEX_CURRENT_COMP+target_index), POS_A_CURRENT_COMP, ROT_A_CURRENT_COMP, target_index, target_x, target_y, target_z, focus_aw, focus_ah, focus_xw, focus_xh, focus_r, NAME_CURRENT_COMP);

// Input sanitation for this geometry
if (xwidth <= 0) {
  printf("\nERROR in Union_box named %s, the xwidth is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (yheight <= 0) {
  printf("\nERROR in Union_box named %s, yheight is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (zdepth <= 0) {
  printf("\nERROR in Union_box named %s, zdepth is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (xwidth2 <= 0 && xwidth2 != -1) {
  printf("\nERROR in Union_box named %s, the xwidth2 is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (yheight2 <= 0 && yheight2 != -1) {
  printf("\nERROR in Union_box named %s, yheight2 is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}

// Use sanitation
if (global_material_list.num_elements == 0) {
  printf("\nERROR: Need to define a material using Union_make_material before using a Union geometry component. \n");
  printf("       %s was defined before first use of Union_make_material.\n",NAME_CURRENT_COMP);
  exit(1);
}

this_box_volume.geometry.is_masked_volume = 0;
this_box_volume.geometry.is_exit_volume = 0;
this_box_volume.geometry.is_mask_volume = 0;
// check if the volume is a mask, if it is the material string is irelevant.
if (mask_string && strlen(mask_string) && strcmp(mask_string, "NULL") && strcmp(mask_string, "0")) {
    // A mask volume is used to limit the extend of other volumes, called the masked volumes. These are specified in the mask_string.
    // In order for a ray to enter a masked volume, it needs to be both in the region covered by that volume AND the mask volume.
    // When more than
    this_box_volume.geometry.mask_mode = 1; // Default is mask mode is ALL
    if (mask_setting && strlen(mask_setting) && strcmp(mask_setting, "NULL") && strcmp(mask_setting, "0")) {
        if (strcmp(mask_setting,"ALL") == 0 || strcmp(mask_setting,"All") == 0) this_box_volume.geometry.mask_mode = 1;
        else if (strcmp(mask_setting,"ANY") == 0 || strcmp(mask_setting,"Any") == 0) this_box_volume.geometry.mask_mode = 2;
        else {
            printf("The mask_mode of component %s is set to %s, but must be either ALL or ANY.\n",NAME_CURRENT_COMP,mask_setting);
            exit(1);
        }
    }
    
    for (loop_index=0;loop_index<global_geometry_list.num_elements;loop_index++) {
        // Add mask list
        if (1 == manual_linking_function(global_geometry_list.elements[loop_index].name,mask_string)) {
            add_element_to_int_list(&this_box_volume.geometry.mask_list,global_geometry_list.elements[loop_index].component_index);
            add_element_to_int_list(&global_geometry_list.elements[loop_index].Volume->geometry.masked_by_list,INDEX_CURRENT_COMP);
            global_geometry_list.elements[loop_index].Volume->geometry.is_masked_volume = 1;
            if (this_box_volume.geometry.mask_mode == 2)
                global_geometry_list.elements[loop_index].Volume->geometry.mask_mode = 2;
            if (this_box_volume.geometry.mask_mode == 1) {
                if (global_geometry_list.elements[loop_index].Volume->geometry.is_masked_volume == 1 && global_geometry_list.elements[loop_index].Volume->geometry.mask_mode != 2)
                    // If more than one mask is added to one volume, the ANY mode overwrites the (default) ALL mode.
                    global_geometry_list.elements[loop_index].Volume->geometry.mask_mode = 1;
            }
            
            found_geometries = 1;
        }
    }
    if (found_geometries == 0) {
        printf("The mask_string in geometry: %s did not find any of the specified volumes in the mask_string %s \n",NAME_CURRENT_COMP,mask_string);
        exit(1);
    }
    this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
    this_box_volume.p_physics->is_vacuum = 0; // Makes this volume a vacuum
    this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
    this_box_volume.p_physics->my_a = 0; // Should not be used.
    sprintf(this_box_volume.p_physics->name,"Mask");
    this_box_volume.geometry.is_mask_volume = 1;
    
    
// Read the material input, or if it lacks, use automatic linking.
} else if (material_string && strlen(material_string) && strcmp(material_string, "NULL") && strcmp(material_string, "0")) {
    // A geometry string was given, use it to determine which material
    if (0 == strcmp(material_string,"vacuum") || 0 == strcmp(material_string,"Vacuum")) {
        // One could have a global physics struct for vacuum instead of creating one for each
        this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
        this_box_volume.p_physics->is_vacuum = 1; // Makes this volume a vacuum
        this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
        this_box_volume.p_physics->my_a = 0; // Should not be used.
        sprintf(this_box_volume.p_physics->name,"Vacuum");
    } else if (0 == strcmp(material_string,"exit") || 0 == strcmp(material_string,"Exit")) {
        // One could have a global physics struct for vacuum instead of creating one for each
        this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
        this_box_volume.p_physics->is_vacuum = 1; // Makes this volume a vacuum
        this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
        this_box_volume.p_physics->my_a = 0; // Should not be used.
        this_box_volume.geometry.is_exit_volume = 1;
        sprintf(this_box_volume.p_physics->name,"Exit");
    } else {
        #ifndef MATERIAL_DETECTOR
            printf("Need to define a material before refering to it in a geometry %s.\n",NAME_CURRENT_COMP);
            exit(1);
        #endif
        for (loop_index=0;loop_index<global_material_list.num_elements;loop_index++) {
            if (0 == strcmp(material_string,global_material_list.elements[loop_index].name)) {
                this_box_volume.p_physics = global_material_list.elements[loop_index].physics;
                break;
            }
            if (loop_index == global_material_list.num_elements-1) {
            printf("\n");
            printf("ERROR: The material string \"%s\" in Union geometry \"%s\" did not match a specified material. \n",material_string,NAME_CURRENT_COMP);
            printf("       The materials available at this point (need to be defined before the geometry): \n");
            for (loop_index=0;loop_index<global_material_list.num_elements;loop_index++)
              printf("         %s\n",global_material_list.elements[loop_index].name);
            printf("\n");
            printf("       It is also possible to use one of the defualt materials avaiable: \n");
            printf("           Vacuum (for a Volume without scattering or absorption)\n");
            printf("           Exit (for a Volume where the ray exits the component if it enters)\n");
            printf("           Mask (for a Volume that masks existing volumes specified in the mask_string\n");
            exit(1);
          }
        }
    }
} else {
    // Automatic linking, simply using the last defined material.
    #ifndef MATERIAL_DETECTOR
        printf("Need to define a material before the geometry to use automatic linking %s.\n",NAME_CURRENT_COMP);
        exit(1);
    #endif
    this_box_volume.p_physics = global_material_list.elements[global_material_list.num_elements-1].physics;
}

sprintf(this_box_volume.name,NAME_CURRENT_COMP);
sprintf(this_box_volume.geometry.shape,"box");
this_box_volume.geometry.priority_value = priority;
this_box_volume.geometry.geometry_p_interact = p_interact;
// Currently the coordinates will be in absolute space.
this_box_volume.geometry.center = POS_A_CURRENT_COMP;

this_box_storage.z_depth = zdepth;
this_box_storage.x_width1 = xwidth;
this_box_storage.y_height1 = yheight;

this_box_storage.is_rectangle = 0;
if (xwidth2 < 0 && yheight2 < 0) this_box_storage.is_rectangle = 1;
if (xwidth == xwidth2 && yheight == yheight2) this_box_storage.is_rectangle = 1;

if (xwidth2 < 0) {
    this_box_storage.x_width2 = xwidth;
    xwidth2 = xwidth;
} else this_box_storage.x_width2 = xwidth2;

if (yheight2 < 0) {
    this_box_storage.y_height2 = yheight;
    yheight2 = yheight;
} else this_box_storage.y_height2 = yheight2;


this_box_storage.normal_vectors[0] = coords_set(0,0,1);
this_box_storage.normal_vectors[1] = coords_set(0,0,1);

// for sides with y component = 0
x_component = 2*zdepth/sqrt((xwidth-xwidth2)*(xwidth-xwidth2)+4*zdepth*zdepth);
z_component = (xwidth-xwidth2)/sqrt(4*zdepth*zdepth+(xwidth-xwidth2)*(xwidth-xwidth2));

this_box_storage.normal_vectors[2] = coords_set(x_component,0,z_component);
this_box_storage.normal_vectors[3] = coords_set(-x_component,0,z_component);

// for sides with x component = 0
y_component = 2*zdepth/sqrt((yheight-yheight2)*(yheight-yheight2)+4*zdepth*zdepth);
z_component = (yheight-yheight2)/sqrt(4*zdepth*zdepth+(yheight-yheight2)*(yheight-yheight2));

this_box_storage.normal_vectors[4] = coords_set(0,y_component,z_component);
this_box_storage.normal_vectors[5] = coords_set(0,-y_component,z_component);

this_box_volume.geometry.visualization_on = visualize;

this_box_volume.geometry.geometry_parameters.p_box_storage = &this_box_storage;

// Assign pointers to functions for intersection with the shape, checking if a point is inside the shape
if (this_box_storage.is_rectangle == 1) {
this_box_volume.geometry.intersect_function = &sample_box_intersect_simple;
this_box_volume.geometry.within_function = &r_within_box_simple;
}
else {
this_box_volume.geometry.intersect_function = &sample_box_intersect_advanced;
this_box_volume.geometry.within_function = &r_within_box_advanced;
}

this_box_volume.geometry.shell_points = &box_shell_points;
this_box_volume.geometry.mcdisplay_function = &mcdisplay_box_function;
this_box_volume.geometry.initialize_from_main_function = &initialize_box_geometry_from_main_component;
this_box_volume.geometry.process_rot_allocated = 0;

this_box_volume.geometry.copy_geometry_parameters = &allocate_box_storage_copy;

rot_copy(this_box_volume.geometry.rotation_matrix,ROT_A_CURRENT_COMP); //check how ROT_R_CURRENT_COMP would work
rot_transpose(ROT_A_CURRENT_COMP,this_box_volume.geometry.transpose_rotation_matrix);

// Initialize loggers
this_box_volume.loggers.num_elements = 0;

// packing the information into the global_geometry_element, which is then included in the global_geometry_list.
sprintf(global_geometry_element.name,NAME_CURRENT_COMP);
global_geometry_element.activation_counter = number_of_activations;
global_geometry_element.component_index = INDEX_CURRENT_COMP;
global_geometry_element.Volume = &this_box_volume; // Would be nicer if this m was a pointer, now we have the (small) data two places
add_element_to_geometry_list(&global_geometry_list,global_geometry_element);
}
#line 173825 "MACS_sample_kidney_box.c"
#undef number_of_activations
#undef mask_setting
#undef mask_string
#undef p_interact
#undef focus_r
#undef focus_xh
#undef focus_xw
#undef focus_ah
#undef focus_aw
#undef target_z
#undef target_y
#undef target_x
#undef target_index
#undef visualize
#undef yheight2
#undef xwidth2
#undef zdepth
#undef yheight
#undef xwidth
#undef priority
#undef material_string
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

  /* Initializations for component channel_1_cave1_box3. */
  SIG_MESSAGE("channel_1_cave1_box3 (Init)");
#define mccompcurname  channel_1_cave1_box3
#define mccompcurtype  Union_box
#define mccompcurindex 164
#define loop_index mccchannel_1_cave1_box3_loop_index
#define this_box_volume mccchannel_1_cave1_box3_this_box_volume
#define global_geometry_element mccchannel_1_cave1_box3_global_geometry_element
#define this_box_storage mccchannel_1_cave1_box3_this_box_storage
#define material_string mccchannel_1_cave1_box3_material_string
#define priority mccchannel_1_cave1_box3_priority
#define xwidth mccchannel_1_cave1_box3_xwidth
#define yheight mccchannel_1_cave1_box3_yheight
#define zdepth mccchannel_1_cave1_box3_zdepth
#define xwidth2 mccchannel_1_cave1_box3_xwidth2
#define yheight2 mccchannel_1_cave1_box3_yheight2
#define visualize mccchannel_1_cave1_box3_visualize
#define target_index mccchannel_1_cave1_box3_target_index
#define target_x mccchannel_1_cave1_box3_target_x
#define target_y mccchannel_1_cave1_box3_target_y
#define target_z mccchannel_1_cave1_box3_target_z
#define focus_aw mccchannel_1_cave1_box3_focus_aw
#define focus_ah mccchannel_1_cave1_box3_focus_ah
#define focus_xw mccchannel_1_cave1_box3_focus_xw
#define focus_xh mccchannel_1_cave1_box3_focus_xh
#define focus_r mccchannel_1_cave1_box3_focus_r
#define p_interact mccchannel_1_cave1_box3_p_interact
#define mask_string mccchannel_1_cave1_box3_mask_string
#define mask_setting mccchannel_1_cave1_box3_mask_setting
#define number_of_activations mccchannel_1_cave1_box3_number_of_activations
#line 224 "Union_box.comp"
{
// Initializes the focusing system for this volume including input sanitation.
focus_initialize(&this_box_volume.geometry, POS_A_COMP_INDEX(INDEX_CURRENT_COMP+target_index), POS_A_CURRENT_COMP, ROT_A_CURRENT_COMP, target_index, target_x, target_y, target_z, focus_aw, focus_ah, focus_xw, focus_xh, focus_r, NAME_CURRENT_COMP);

// Input sanitation for this geometry
if (xwidth <= 0) {
  printf("\nERROR in Union_box named %s, the xwidth is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (yheight <= 0) {
  printf("\nERROR in Union_box named %s, yheight is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (zdepth <= 0) {
  printf("\nERROR in Union_box named %s, zdepth is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (xwidth2 <= 0 && xwidth2 != -1) {
  printf("\nERROR in Union_box named %s, the xwidth2 is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (yheight2 <= 0 && yheight2 != -1) {
  printf("\nERROR in Union_box named %s, yheight2 is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}

// Use sanitation
if (global_material_list.num_elements == 0) {
  printf("\nERROR: Need to define a material using Union_make_material before using a Union geometry component. \n");
  printf("       %s was defined before first use of Union_make_material.\n",NAME_CURRENT_COMP);
  exit(1);
}

this_box_volume.geometry.is_masked_volume = 0;
this_box_volume.geometry.is_exit_volume = 0;
this_box_volume.geometry.is_mask_volume = 0;
// check if the volume is a mask, if it is the material string is irelevant.
if (mask_string && strlen(mask_string) && strcmp(mask_string, "NULL") && strcmp(mask_string, "0")) {
    // A mask volume is used to limit the extend of other volumes, called the masked volumes. These are specified in the mask_string.
    // In order for a ray to enter a masked volume, it needs to be both in the region covered by that volume AND the mask volume.
    // When more than
    this_box_volume.geometry.mask_mode = 1; // Default is mask mode is ALL
    if (mask_setting && strlen(mask_setting) && strcmp(mask_setting, "NULL") && strcmp(mask_setting, "0")) {
        if (strcmp(mask_setting,"ALL") == 0 || strcmp(mask_setting,"All") == 0) this_box_volume.geometry.mask_mode = 1;
        else if (strcmp(mask_setting,"ANY") == 0 || strcmp(mask_setting,"Any") == 0) this_box_volume.geometry.mask_mode = 2;
        else {
            printf("The mask_mode of component %s is set to %s, but must be either ALL or ANY.\n",NAME_CURRENT_COMP,mask_setting);
            exit(1);
        }
    }
    
    for (loop_index=0;loop_index<global_geometry_list.num_elements;loop_index++) {
        // Add mask list
        if (1 == manual_linking_function(global_geometry_list.elements[loop_index].name,mask_string)) {
            add_element_to_int_list(&this_box_volume.geometry.mask_list,global_geometry_list.elements[loop_index].component_index);
            add_element_to_int_list(&global_geometry_list.elements[loop_index].Volume->geometry.masked_by_list,INDEX_CURRENT_COMP);
            global_geometry_list.elements[loop_index].Volume->geometry.is_masked_volume = 1;
            if (this_box_volume.geometry.mask_mode == 2)
                global_geometry_list.elements[loop_index].Volume->geometry.mask_mode = 2;
            if (this_box_volume.geometry.mask_mode == 1) {
                if (global_geometry_list.elements[loop_index].Volume->geometry.is_masked_volume == 1 && global_geometry_list.elements[loop_index].Volume->geometry.mask_mode != 2)
                    // If more than one mask is added to one volume, the ANY mode overwrites the (default) ALL mode.
                    global_geometry_list.elements[loop_index].Volume->geometry.mask_mode = 1;
            }
            
            found_geometries = 1;
        }
    }
    if (found_geometries == 0) {
        printf("The mask_string in geometry: %s did not find any of the specified volumes in the mask_string %s \n",NAME_CURRENT_COMP,mask_string);
        exit(1);
    }
    this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
    this_box_volume.p_physics->is_vacuum = 0; // Makes this volume a vacuum
    this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
    this_box_volume.p_physics->my_a = 0; // Should not be used.
    sprintf(this_box_volume.p_physics->name,"Mask");
    this_box_volume.geometry.is_mask_volume = 1;
    
    
// Read the material input, or if it lacks, use automatic linking.
} else if (material_string && strlen(material_string) && strcmp(material_string, "NULL") && strcmp(material_string, "0")) {
    // A geometry string was given, use it to determine which material
    if (0 == strcmp(material_string,"vacuum") || 0 == strcmp(material_string,"Vacuum")) {
        // One could have a global physics struct for vacuum instead of creating one for each
        this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
        this_box_volume.p_physics->is_vacuum = 1; // Makes this volume a vacuum
        this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
        this_box_volume.p_physics->my_a = 0; // Should not be used.
        sprintf(this_box_volume.p_physics->name,"Vacuum");
    } else if (0 == strcmp(material_string,"exit") || 0 == strcmp(material_string,"Exit")) {
        // One could have a global physics struct for vacuum instead of creating one for each
        this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
        this_box_volume.p_physics->is_vacuum = 1; // Makes this volume a vacuum
        this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
        this_box_volume.p_physics->my_a = 0; // Should not be used.
        this_box_volume.geometry.is_exit_volume = 1;
        sprintf(this_box_volume.p_physics->name,"Exit");
    } else {
        #ifndef MATERIAL_DETECTOR
            printf("Need to define a material before refering to it in a geometry %s.\n",NAME_CURRENT_COMP);
            exit(1);
        #endif
        for (loop_index=0;loop_index<global_material_list.num_elements;loop_index++) {
            if (0 == strcmp(material_string,global_material_list.elements[loop_index].name)) {
                this_box_volume.p_physics = global_material_list.elements[loop_index].physics;
                break;
            }
            if (loop_index == global_material_list.num_elements-1) {
            printf("\n");
            printf("ERROR: The material string \"%s\" in Union geometry \"%s\" did not match a specified material. \n",material_string,NAME_CURRENT_COMP);
            printf("       The materials available at this point (need to be defined before the geometry): \n");
            for (loop_index=0;loop_index<global_material_list.num_elements;loop_index++)
              printf("         %s\n",global_material_list.elements[loop_index].name);
            printf("\n");
            printf("       It is also possible to use one of the defualt materials avaiable: \n");
            printf("           Vacuum (for a Volume without scattering or absorption)\n");
            printf("           Exit (for a Volume where the ray exits the component if it enters)\n");
            printf("           Mask (for a Volume that masks existing volumes specified in the mask_string\n");
            exit(1);
          }
        }
    }
} else {
    // Automatic linking, simply using the last defined material.
    #ifndef MATERIAL_DETECTOR
        printf("Need to define a material before the geometry to use automatic linking %s.\n",NAME_CURRENT_COMP);
        exit(1);
    #endif
    this_box_volume.p_physics = global_material_list.elements[global_material_list.num_elements-1].physics;
}

sprintf(this_box_volume.name,NAME_CURRENT_COMP);
sprintf(this_box_volume.geometry.shape,"box");
this_box_volume.geometry.priority_value = priority;
this_box_volume.geometry.geometry_p_interact = p_interact;
// Currently the coordinates will be in absolute space.
this_box_volume.geometry.center = POS_A_CURRENT_COMP;

this_box_storage.z_depth = zdepth;
this_box_storage.x_width1 = xwidth;
this_box_storage.y_height1 = yheight;

this_box_storage.is_rectangle = 0;
if (xwidth2 < 0 && yheight2 < 0) this_box_storage.is_rectangle = 1;
if (xwidth == xwidth2 && yheight == yheight2) this_box_storage.is_rectangle = 1;

if (xwidth2 < 0) {
    this_box_storage.x_width2 = xwidth;
    xwidth2 = xwidth;
} else this_box_storage.x_width2 = xwidth2;

if (yheight2 < 0) {
    this_box_storage.y_height2 = yheight;
    yheight2 = yheight;
} else this_box_storage.y_height2 = yheight2;


this_box_storage.normal_vectors[0] = coords_set(0,0,1);
this_box_storage.normal_vectors[1] = coords_set(0,0,1);

// for sides with y component = 0
x_component = 2*zdepth/sqrt((xwidth-xwidth2)*(xwidth-xwidth2)+4*zdepth*zdepth);
z_component = (xwidth-xwidth2)/sqrt(4*zdepth*zdepth+(xwidth-xwidth2)*(xwidth-xwidth2));

this_box_storage.normal_vectors[2] = coords_set(x_component,0,z_component);
this_box_storage.normal_vectors[3] = coords_set(-x_component,0,z_component);

// for sides with x component = 0
y_component = 2*zdepth/sqrt((yheight-yheight2)*(yheight-yheight2)+4*zdepth*zdepth);
z_component = (yheight-yheight2)/sqrt(4*zdepth*zdepth+(yheight-yheight2)*(yheight-yheight2));

this_box_storage.normal_vectors[4] = coords_set(0,y_component,z_component);
this_box_storage.normal_vectors[5] = coords_set(0,-y_component,z_component);

this_box_volume.geometry.visualization_on = visualize;

this_box_volume.geometry.geometry_parameters.p_box_storage = &this_box_storage;

// Assign pointers to functions for intersection with the shape, checking if a point is inside the shape
if (this_box_storage.is_rectangle == 1) {
this_box_volume.geometry.intersect_function = &sample_box_intersect_simple;
this_box_volume.geometry.within_function = &r_within_box_simple;
}
else {
this_box_volume.geometry.intersect_function = &sample_box_intersect_advanced;
this_box_volume.geometry.within_function = &r_within_box_advanced;
}

this_box_volume.geometry.shell_points = &box_shell_points;
this_box_volume.geometry.mcdisplay_function = &mcdisplay_box_function;
this_box_volume.geometry.initialize_from_main_function = &initialize_box_geometry_from_main_component;
this_box_volume.geometry.process_rot_allocated = 0;

this_box_volume.geometry.copy_geometry_parameters = &allocate_box_storage_copy;

rot_copy(this_box_volume.geometry.rotation_matrix,ROT_A_CURRENT_COMP); //check how ROT_R_CURRENT_COMP would work
rot_transpose(ROT_A_CURRENT_COMP,this_box_volume.geometry.transpose_rotation_matrix);

// Initialize loggers
this_box_volume.loggers.num_elements = 0;

// packing the information into the global_geometry_element, which is then included in the global_geometry_list.
sprintf(global_geometry_element.name,NAME_CURRENT_COMP);
global_geometry_element.activation_counter = number_of_activations;
global_geometry_element.component_index = INDEX_CURRENT_COMP;
global_geometry_element.Volume = &this_box_volume; // Would be nicer if this m was a pointer, now we have the (small) data two places
add_element_to_geometry_list(&global_geometry_list,global_geometry_element);
}
#line 174095 "MACS_sample_kidney_box.c"
#undef number_of_activations
#undef mask_setting
#undef mask_string
#undef p_interact
#undef focus_r
#undef focus_xh
#undef focus_xw
#undef focus_ah
#undef focus_aw
#undef target_z
#undef target_y
#undef target_x
#undef target_index
#undef visualize
#undef yheight2
#undef xwidth2
#undef zdepth
#undef yheight
#undef xwidth
#undef priority
#undef material_string
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

  /* Initializations for component channel_1_cave1_cyl1. */
  SIG_MESSAGE("channel_1_cave1_cyl1 (Init)");
#define mccompcurname  channel_1_cave1_cyl1
#define mccompcurtype  Union_cylinder
#define mccompcurindex 165
#define loop_index mccchannel_1_cave1_cyl1_loop_index
#define this_cylinder_volume mccchannel_1_cave1_cyl1_this_cylinder_volume
#define global_geometry_element mccchannel_1_cave1_cyl1_global_geometry_element
#define this_cylinder_storage mccchannel_1_cave1_cyl1_this_cylinder_storage
#define material_string mccchannel_1_cave1_cyl1_material_string
#define priority mccchannel_1_cave1_cyl1_priority
#define radius mccchannel_1_cave1_cyl1_radius
#define yheight mccchannel_1_cave1_cyl1_yheight
#define visualize mccchannel_1_cave1_cyl1_visualize
#define target_index mccchannel_1_cave1_cyl1_target_index
#define target_x mccchannel_1_cave1_cyl1_target_x
#define target_y mccchannel_1_cave1_cyl1_target_y
#define target_z mccchannel_1_cave1_cyl1_target_z
#define focus_aw mccchannel_1_cave1_cyl1_focus_aw
#define focus_ah mccchannel_1_cave1_cyl1_focus_ah
#define focus_xw mccchannel_1_cave1_cyl1_focus_xw
#define focus_xh mccchannel_1_cave1_cyl1_focus_xh
#define focus_r mccchannel_1_cave1_cyl1_focus_r
#define p_interact mccchannel_1_cave1_cyl1_p_interact
#define mask_string mccchannel_1_cave1_cyl1_mask_string
#define mask_setting mccchannel_1_cave1_cyl1_mask_setting
#define number_of_activations mccchannel_1_cave1_cyl1_number_of_activations
#line 185 "Union_cylinder.comp"
{
// Initializes the focusing system for this volume including input sanitation.
focus_initialize(&this_cylinder_volume.geometry, POS_A_COMP_INDEX(INDEX_CURRENT_COMP+target_index), POS_A_CURRENT_COMP, ROT_A_CURRENT_COMP, target_index, target_x, target_y, target_z, focus_aw, focus_ah, focus_xw, focus_xh, focus_r, NAME_CURRENT_COMP);

// Input sanitation for this geometry
if (radius <= 0) {
  printf("\nERROR in Union_cylinder named %s, the radius is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}

if (yheight <= 0) {
  printf("\nERROR in Union_cylinder named %s, yheight is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}

// Use sanitation
#ifdef MATERIAL_DETECTOR
if (global_material_list.num_elements == 0) {
  // Here if the user have defined a material, but only after this material
  printf("\nERROR: Need to define a material using Union_make_material before using a Union geometry component. \n");
  printf("       %s was defined before first use of Union_make_material.\n",NAME_CURRENT_COMP);
  exit(1);
}
#endif
#ifndef MATERIAL_DETECTOR
  printf("\nERROR: Need to define a material using Union_make_material before using a Union geometry component. \n");
  exit(1);
#endif


this_cylinder_volume.geometry.is_masked_volume = 0;
this_cylinder_volume.geometry.is_exit_volume = 0;
this_cylinder_volume.geometry.is_mask_volume = 0;

// Read the material input, or if it lacks, use automatic linking.
if (mask_string && strlen(mask_string) && strcmp(mask_string, "NULL") && strcmp(mask_string, "0")) {
    // A mask volume is used to limit the extend of other volumes, called the masked volumes. These are specified in the mask_string.
    // In order for a ray to enter a masked volume, it needs to be both in the region covered by that volume AND the mask volume.
    // When more than
    this_cylinder_volume.geometry.mask_mode = 1; // Default is mask mode is ALL
    if (mask_setting && strlen(mask_setting) && strcmp(mask_setting, "NULL") && strcmp(mask_setting, "0")) {
        if (strcmp(mask_setting,"ALL") == 0 || strcmp(mask_setting,"All") == 0) this_cylinder_volume.geometry.mask_mode = 1;
        else if (strcmp(mask_setting,"ANY") == 0 || strcmp(mask_setting,"Any") == 0) this_cylinder_volume.geometry.mask_mode = 2;
        else {
            printf("The mask_mode of component %s is set to %s, but must be either ALL or ANY.\n",NAME_CURRENT_COMP,mask_setting);
            exit(1);
        }
    }
    
    for (loop_index=0;loop_index<global_geometry_list.num_elements;loop_index++) {
        // Add mask list
        if (1 == manual_linking_function(global_geometry_list.elements[loop_index].name,mask_string)) {
            add_element_to_int_list(&this_cylinder_volume.geometry.mask_list,global_geometry_list.elements[loop_index].component_index);
            add_element_to_int_list(&global_geometry_list.elements[loop_index].Volume->geometry.masked_by_list,INDEX_CURRENT_COMP);
            global_geometry_list.elements[loop_index].Volume->geometry.is_masked_volume = 1;
            if (this_cylinder_volume.geometry.mask_mode == 2)
                global_geometry_list.elements[loop_index].Volume->geometry.mask_mode = 2;
            if (this_cylinder_volume.geometry.mask_mode == 1) {
                if (global_geometry_list.elements[loop_index].Volume->geometry.is_masked_volume == 1 && global_geometry_list.elements[loop_index].Volume->geometry.mask_mode != 2)
                    // If more than one mask is added to one volume, the ANY mode overwrites the (default) ALL mode.
                    global_geometry_list.elements[loop_index].Volume->geometry.mask_mode = 1;
            }
            
            found_geometries = 1;
        }
    }
    if (found_geometries == 0) {
        printf("The mask_string in geometry: %s did not find any of the specified volumes in the mask_string %s \n",NAME_CURRENT_COMP,mask_string);
        exit(1);
    }
    this_cylinder_volume.p_physics = malloc(sizeof(struct physics_struct));
    this_cylinder_volume.p_physics->is_vacuum = 0; // Makes this volume a vacuum
    this_cylinder_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
    this_cylinder_volume.p_physics->my_a = 0; // Should not be used.
    sprintf(this_cylinder_volume.p_physics->name,"Mask");
    this_cylinder_volume.geometry.is_mask_volume = 1;
    
    
// Read the material input, or if it lacks, use automatic linking.
} else if (material_string && strlen(material_string) && strcmp(material_string, "NULL") && strcmp(material_string, "0")) {
    // A geometry string was given, use it to determine which material
    if (0 == strcmp(material_string,"vacuum") || 0 == strcmp(material_string,"Vacuum")) {
        // One could have a global physics struct for vacuum instead of creating one for each
        this_cylinder_volume.p_physics = malloc(sizeof(struct physics_struct));
        this_cylinder_volume.p_physics->is_vacuum = 1; // Makes this volume a vacuum
        this_cylinder_volume.p_physics->number_of_processes = (int) 0;
        this_cylinder_volume.p_physics->my_a = 0; // Should not be used.
        sprintf(this_cylinder_volume.p_physics->name,"Vacuum");
    } else if (0 == strcmp(material_string,"exit") || 0 == strcmp(material_string,"Exit")) {
        // One could have a global physics struct for exit instead of creating one for each
        this_cylinder_volume.p_physics = malloc(sizeof(struct physics_struct));
        this_cylinder_volume.p_physics->is_vacuum = 1; // Makes this volume a vacuum
        this_cylinder_volume.p_physics->number_of_processes = (int) 0;
        this_cylinder_volume.p_physics->my_a = 0; // Should not be used.
        this_cylinder_volume.geometry.is_exit_volume = 1;
        sprintf(this_cylinder_volume.p_physics->name,"Exit");
    } else {
        for (loop_index=0;loop_index<global_material_list.num_elements;loop_index++) {
          if (0 == strcmp(material_string,global_material_list.elements[loop_index].name)) {
            this_cylinder_volume.p_physics = global_material_list.elements[loop_index].physics;
            break;
          }
          if (loop_index == global_material_list.num_elements-1) {
            printf("\n");
            printf("ERROR: The material string \"%s\" in Union geometry \"%s\" did not match a specified material. \n",material_string,NAME_CURRENT_COMP);
            printf("       The materials available at this point (need to be defined before the geometry): \n");
            for (loop_index=0;loop_index<global_material_list.num_elements;loop_index++)
              printf("         %s\n",global_material_list.elements[loop_index].name);
            printf("\n");
            printf("       It is also possible to use one of the defualt materials avaiable: \n");
            printf("           Vacuum (for a Volume without scattering or absorption)\n");
            printf("           Exit (for a Volume where the ray exits the component if it enters)\n");
            printf("           Mask (for a Volume that masks existing volumes specified in the mask_string\n");
            exit(1);
          }
        }
    }
} else {
    // Automatic linking, simply using the last defined material.
    #ifndef MATERIAL_DETECTOR
        printf("Need to define a material before the geometry to use automatic linking %s.\n",NAME_CURRENT_COMP);
        exit(1);
    #endif
    this_cylinder_volume.p_physics = global_material_list.elements[global_material_list.num_elements-1].physics;
}

sprintf(this_cylinder_volume.name,NAME_CURRENT_COMP);
sprintf(this_cylinder_volume.geometry.shape,"cylinder");
this_cylinder_volume.geometry.priority_value = priority;
// Currently the coordinates will be in absolute space.
this_cylinder_volume.geometry.center = POS_A_CURRENT_COMP;

this_cylinder_volume.geometry.geometry_p_interact = p_interact;
this_cylinder_storage.cyl_radius = radius;
this_cylinder_storage.height = yheight;
this_cylinder_volume.geometry.visualization_on = visualize;
this_cylinder_volume.geometry.geometry_parameters.p_cylinder_storage = &this_cylinder_storage;
this_cylinder_volume.geometry.within_function = &r_within_cylinder;
this_cylinder_volume.geometry.intersect_function = &sample_cylinder_intersect;
this_cylinder_volume.geometry.mcdisplay_function = &mcdisplay_cylinder_function;
this_cylinder_volume.geometry.shell_points = &cylinder_shell_points;
this_cylinder_volume.geometry.initialize_from_main_function = &initialize_cylinder_geometry_from_main_component;
this_cylinder_volume.geometry.process_rot_allocated = 0;
this_cylinder_volume.geometry.copy_geometry_parameters = &allocate_cylinder_storage_copy;

rot_copy(this_cylinder_volume.geometry.rotation_matrix,ROT_A_CURRENT_COMP);
rot_transpose(ROT_A_CURRENT_COMP,this_cylinder_volume.geometry.transpose_rotation_matrix);

// Initialize loggers
this_cylinder_volume.loggers.num_elements = 0;

// packing the information into the global_geometry_element, which is then included in the global_geometry_list.
sprintf(global_geometry_element.name,NAME_CURRENT_COMP);
global_geometry_element.activation_counter = number_of_activations;
global_geometry_element.component_index = INDEX_CURRENT_COMP;
global_geometry_element.Volume = &this_cylinder_volume; // Would be nicer if this m was a pointer, now we have the (small) data two places
add_element_to_geometry_list(&global_geometry_list,global_geometry_element);
}
#line 174311 "MACS_sample_kidney_box.c"
#undef number_of_activations
#undef mask_setting
#undef mask_string
#undef p_interact
#undef focus_r
#undef focus_xh
#undef focus_xw
#undef focus_ah
#undef focus_aw
#undef target_z
#undef target_y
#undef target_x
#undef target_index
#undef visualize
#undef yheight
#undef radius
#undef priority
#undef material_string
#undef this_cylinder_storage
#undef global_geometry_element
#undef this_cylinder_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

  /* Initializations for component channel_1_analyzer_1_center. */
  SIG_MESSAGE("channel_1_analyzer_1_center (Init)");

  /* Initializations for component channel_1_analyzer_1_rotated. */
  SIG_MESSAGE("channel_1_analyzer_1_rotated (Init)");

  /* Initializations for component channel_1_analyzer_1_array_crystal_array_0. */
  SIG_MESSAGE("channel_1_analyzer_1_array_crystal_array_0 (Init)");
#define mccompcurname  channel_1_analyzer_1_array_crystal_array_0
#define mccompcurtype  Union_box
#define mccompcurindex 168
#define loop_index mccchannel_1_analyzer_1_array_crystal_array_0_loop_index
#define this_box_volume mccchannel_1_analyzer_1_array_crystal_array_0_this_box_volume
#define global_geometry_element mccchannel_1_analyzer_1_array_crystal_array_0_global_geometry_element
#define this_box_storage mccchannel_1_analyzer_1_array_crystal_array_0_this_box_storage
#define material_string mccchannel_1_analyzer_1_array_crystal_array_0_material_string
#define priority mccchannel_1_analyzer_1_array_crystal_array_0_priority
#define xwidth mccchannel_1_analyzer_1_array_crystal_array_0_xwidth
#define yheight mccchannel_1_analyzer_1_array_crystal_array_0_yheight
#define zdepth mccchannel_1_analyzer_1_array_crystal_array_0_zdepth
#define xwidth2 mccchannel_1_analyzer_1_array_crystal_array_0_xwidth2
#define yheight2 mccchannel_1_analyzer_1_array_crystal_array_0_yheight2
#define visualize mccchannel_1_analyzer_1_array_crystal_array_0_visualize
#define target_index mccchannel_1_analyzer_1_array_crystal_array_0_target_index
#define target_x mccchannel_1_analyzer_1_array_crystal_array_0_target_x
#define target_y mccchannel_1_analyzer_1_array_crystal_array_0_target_y
#define target_z mccchannel_1_analyzer_1_array_crystal_array_0_target_z
#define focus_aw mccchannel_1_analyzer_1_array_crystal_array_0_focus_aw
#define focus_ah mccchannel_1_analyzer_1_array_crystal_array_0_focus_ah
#define focus_xw mccchannel_1_analyzer_1_array_crystal_array_0_focus_xw
#define focus_xh mccchannel_1_analyzer_1_array_crystal_array_0_focus_xh
#define focus_r mccchannel_1_analyzer_1_array_crystal_array_0_focus_r
#define p_interact mccchannel_1_analyzer_1_array_crystal_array_0_p_interact
#define mask_string mccchannel_1_analyzer_1_array_crystal_array_0_mask_string
#define mask_setting mccchannel_1_analyzer_1_array_crystal_array_0_mask_setting
#define number_of_activations mccchannel_1_analyzer_1_array_crystal_array_0_number_of_activations
#line 224 "Union_box.comp"
{
// Initializes the focusing system for this volume including input sanitation.
focus_initialize(&this_box_volume.geometry, POS_A_COMP_INDEX(INDEX_CURRENT_COMP+target_index), POS_A_CURRENT_COMP, ROT_A_CURRENT_COMP, target_index, target_x, target_y, target_z, focus_aw, focus_ah, focus_xw, focus_xh, focus_r, NAME_CURRENT_COMP);

// Input sanitation for this geometry
if (xwidth <= 0) {
  printf("\nERROR in Union_box named %s, the xwidth is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (yheight <= 0) {
  printf("\nERROR in Union_box named %s, yheight is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (zdepth <= 0) {
  printf("\nERROR in Union_box named %s, zdepth is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (xwidth2 <= 0 && xwidth2 != -1) {
  printf("\nERROR in Union_box named %s, the xwidth2 is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (yheight2 <= 0 && yheight2 != -1) {
  printf("\nERROR in Union_box named %s, yheight2 is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}

// Use sanitation
if (global_material_list.num_elements == 0) {
  printf("\nERROR: Need to define a material using Union_make_material before using a Union geometry component. \n");
  printf("       %s was defined before first use of Union_make_material.\n",NAME_CURRENT_COMP);
  exit(1);
}

this_box_volume.geometry.is_masked_volume = 0;
this_box_volume.geometry.is_exit_volume = 0;
this_box_volume.geometry.is_mask_volume = 0;
// check if the volume is a mask, if it is the material string is irelevant.
if (mask_string && strlen(mask_string) && strcmp(mask_string, "NULL") && strcmp(mask_string, "0")) {
    // A mask volume is used to limit the extend of other volumes, called the masked volumes. These are specified in the mask_string.
    // In order for a ray to enter a masked volume, it needs to be both in the region covered by that volume AND the mask volume.
    // When more than
    this_box_volume.geometry.mask_mode = 1; // Default is mask mode is ALL
    if (mask_setting && strlen(mask_setting) && strcmp(mask_setting, "NULL") && strcmp(mask_setting, "0")) {
        if (strcmp(mask_setting,"ALL") == 0 || strcmp(mask_setting,"All") == 0) this_box_volume.geometry.mask_mode = 1;
        else if (strcmp(mask_setting,"ANY") == 0 || strcmp(mask_setting,"Any") == 0) this_box_volume.geometry.mask_mode = 2;
        else {
            printf("The mask_mode of component %s is set to %s, but must be either ALL or ANY.\n",NAME_CURRENT_COMP,mask_setting);
            exit(1);
        }
    }
    
    for (loop_index=0;loop_index<global_geometry_list.num_elements;loop_index++) {
        // Add mask list
        if (1 == manual_linking_function(global_geometry_list.elements[loop_index].name,mask_string)) {
            add_element_to_int_list(&this_box_volume.geometry.mask_list,global_geometry_list.elements[loop_index].component_index);
            add_element_to_int_list(&global_geometry_list.elements[loop_index].Volume->geometry.masked_by_list,INDEX_CURRENT_COMP);
            global_geometry_list.elements[loop_index].Volume->geometry.is_masked_volume = 1;
            if (this_box_volume.geometry.mask_mode == 2)
                global_geometry_list.elements[loop_index].Volume->geometry.mask_mode = 2;
            if (this_box_volume.geometry.mask_mode == 1) {
                if (global_geometry_list.elements[loop_index].Volume->geometry.is_masked_volume == 1 && global_geometry_list.elements[loop_index].Volume->geometry.mask_mode != 2)
                    // If more than one mask is added to one volume, the ANY mode overwrites the (default) ALL mode.
                    global_geometry_list.elements[loop_index].Volume->geometry.mask_mode = 1;
            }
            
            found_geometries = 1;
        }
    }
    if (found_geometries == 0) {
        printf("The mask_string in geometry: %s did not find any of the specified volumes in the mask_string %s \n",NAME_CURRENT_COMP,mask_string);
        exit(1);
    }
    this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
    this_box_volume.p_physics->is_vacuum = 0; // Makes this volume a vacuum
    this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
    this_box_volume.p_physics->my_a = 0; // Should not be used.
    sprintf(this_box_volume.p_physics->name,"Mask");
    this_box_volume.geometry.is_mask_volume = 1;
    
    
// Read the material input, or if it lacks, use automatic linking.
} else if (material_string && strlen(material_string) && strcmp(material_string, "NULL") && strcmp(material_string, "0")) {
    // A geometry string was given, use it to determine which material
    if (0 == strcmp(material_string,"vacuum") || 0 == strcmp(material_string,"Vacuum")) {
        // One could have a global physics struct for vacuum instead of creating one for each
        this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
        this_box_volume.p_physics->is_vacuum = 1; // Makes this volume a vacuum
        this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
        this_box_volume.p_physics->my_a = 0; // Should not be used.
        sprintf(this_box_volume.p_physics->name,"Vacuum");
    } else if (0 == strcmp(material_string,"exit") || 0 == strcmp(material_string,"Exit")) {
        // One could have a global physics struct for vacuum instead of creating one for each
        this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
        this_box_volume.p_physics->is_vacuum = 1; // Makes this volume a vacuum
        this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
        this_box_volume.p_physics->my_a = 0; // Should not be used.
        this_box_volume.geometry.is_exit_volume = 1;
        sprintf(this_box_volume.p_physics->name,"Exit");
    } else {
        #ifndef MATERIAL_DETECTOR
            printf("Need to define a material before refering to it in a geometry %s.\n",NAME_CURRENT_COMP);
            exit(1);
        #endif
        for (loop_index=0;loop_index<global_material_list.num_elements;loop_index++) {
            if (0 == strcmp(material_string,global_material_list.elements[loop_index].name)) {
                this_box_volume.p_physics = global_material_list.elements[loop_index].physics;
                break;
            }
            if (loop_index == global_material_list.num_elements-1) {
            printf("\n");
            printf("ERROR: The material string \"%s\" in Union geometry \"%s\" did not match a specified material. \n",material_string,NAME_CURRENT_COMP);
            printf("       The materials available at this point (need to be defined before the geometry): \n");
            for (loop_index=0;loop_index<global_material_list.num_elements;loop_index++)
              printf("         %s\n",global_material_list.elements[loop_index].name);
            printf("\n");
            printf("       It is also possible to use one of the defualt materials avaiable: \n");
            printf("           Vacuum (for a Volume without scattering or absorption)\n");
            printf("           Exit (for a Volume where the ray exits the component if it enters)\n");
            printf("           Mask (for a Volume that masks existing volumes specified in the mask_string\n");
            exit(1);
          }
        }
    }
} else {
    // Automatic linking, simply using the last defined material.
    #ifndef MATERIAL_DETECTOR
        printf("Need to define a material before the geometry to use automatic linking %s.\n",NAME_CURRENT_COMP);
        exit(1);
    #endif
    this_box_volume.p_physics = global_material_list.elements[global_material_list.num_elements-1].physics;
}

sprintf(this_box_volume.name,NAME_CURRENT_COMP);
sprintf(this_box_volume.geometry.shape,"box");
this_box_volume.geometry.priority_value = priority;
this_box_volume.geometry.geometry_p_interact = p_interact;
// Currently the coordinates will be in absolute space.
this_box_volume.geometry.center = POS_A_CURRENT_COMP;

this_box_storage.z_depth = zdepth;
this_box_storage.x_width1 = xwidth;
this_box_storage.y_height1 = yheight;

this_box_storage.is_rectangle = 0;
if (xwidth2 < 0 && yheight2 < 0) this_box_storage.is_rectangle = 1;
if (xwidth == xwidth2 && yheight == yheight2) this_box_storage.is_rectangle = 1;

if (xwidth2 < 0) {
    this_box_storage.x_width2 = xwidth;
    xwidth2 = xwidth;
} else this_box_storage.x_width2 = xwidth2;

if (yheight2 < 0) {
    this_box_storage.y_height2 = yheight;
    yheight2 = yheight;
} else this_box_storage.y_height2 = yheight2;


this_box_storage.normal_vectors[0] = coords_set(0,0,1);
this_box_storage.normal_vectors[1] = coords_set(0,0,1);

// for sides with y component = 0
x_component = 2*zdepth/sqrt((xwidth-xwidth2)*(xwidth-xwidth2)+4*zdepth*zdepth);
z_component = (xwidth-xwidth2)/sqrt(4*zdepth*zdepth+(xwidth-xwidth2)*(xwidth-xwidth2));

this_box_storage.normal_vectors[2] = coords_set(x_component,0,z_component);
this_box_storage.normal_vectors[3] = coords_set(-x_component,0,z_component);

// for sides with x component = 0
y_component = 2*zdepth/sqrt((yheight-yheight2)*(yheight-yheight2)+4*zdepth*zdepth);
z_component = (yheight-yheight2)/sqrt(4*zdepth*zdepth+(yheight-yheight2)*(yheight-yheight2));

this_box_storage.normal_vectors[4] = coords_set(0,y_component,z_component);
this_box_storage.normal_vectors[5] = coords_set(0,-y_component,z_component);

this_box_volume.geometry.visualization_on = visualize;

this_box_volume.geometry.geometry_parameters.p_box_storage = &this_box_storage;

// Assign pointers to functions for intersection with the shape, checking if a point is inside the shape
if (this_box_storage.is_rectangle == 1) {
this_box_volume.geometry.intersect_function = &sample_box_intersect_simple;
this_box_volume.geometry.within_function = &r_within_box_simple;
}
else {
this_box_volume.geometry.intersect_function = &sample_box_intersect_advanced;
this_box_volume.geometry.within_function = &r_within_box_advanced;
}

this_box_volume.geometry.shell_points = &box_shell_points;
this_box_volume.geometry.mcdisplay_function = &mcdisplay_box_function;
this_box_volume.geometry.initialize_from_main_function = &initialize_box_geometry_from_main_component;
this_box_volume.geometry.process_rot_allocated = 0;

this_box_volume.geometry.copy_geometry_parameters = &allocate_box_storage_copy;

rot_copy(this_box_volume.geometry.rotation_matrix,ROT_A_CURRENT_COMP); //check how ROT_R_CURRENT_COMP would work
rot_transpose(ROT_A_CURRENT_COMP,this_box_volume.geometry.transpose_rotation_matrix);

// Initialize loggers
this_box_volume.loggers.num_elements = 0;

// packing the information into the global_geometry_element, which is then included in the global_geometry_list.
sprintf(global_geometry_element.name,NAME_CURRENT_COMP);
global_geometry_element.activation_counter = number_of_activations;
global_geometry_element.component_index = INDEX_CURRENT_COMP;
global_geometry_element.Volume = &this_box_volume; // Would be nicer if this m was a pointer, now we have the (small) data two places
add_element_to_geometry_list(&global_geometry_list,global_geometry_element);
}
#line 174584 "MACS_sample_kidney_box.c"
#undef number_of_activations
#undef mask_setting
#undef mask_string
#undef p_interact
#undef focus_r
#undef focus_xh
#undef focus_xw
#undef focus_ah
#undef focus_aw
#undef target_z
#undef target_y
#undef target_x
#undef target_index
#undef visualize
#undef yheight2
#undef xwidth2
#undef zdepth
#undef yheight
#undef xwidth
#undef priority
#undef material_string
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

  /* Initializations for component channel_1_analyzer_1_array_crystal_array_1. */
  SIG_MESSAGE("channel_1_analyzer_1_array_crystal_array_1 (Init)");
#define mccompcurname  channel_1_analyzer_1_array_crystal_array_1
#define mccompcurtype  Union_box
#define mccompcurindex 169
#define loop_index mccchannel_1_analyzer_1_array_crystal_array_1_loop_index
#define this_box_volume mccchannel_1_analyzer_1_array_crystal_array_1_this_box_volume
#define global_geometry_element mccchannel_1_analyzer_1_array_crystal_array_1_global_geometry_element
#define this_box_storage mccchannel_1_analyzer_1_array_crystal_array_1_this_box_storage
#define material_string mccchannel_1_analyzer_1_array_crystal_array_1_material_string
#define priority mccchannel_1_analyzer_1_array_crystal_array_1_priority
#define xwidth mccchannel_1_analyzer_1_array_crystal_array_1_xwidth
#define yheight mccchannel_1_analyzer_1_array_crystal_array_1_yheight
#define zdepth mccchannel_1_analyzer_1_array_crystal_array_1_zdepth
#define xwidth2 mccchannel_1_analyzer_1_array_crystal_array_1_xwidth2
#define yheight2 mccchannel_1_analyzer_1_array_crystal_array_1_yheight2
#define visualize mccchannel_1_analyzer_1_array_crystal_array_1_visualize
#define target_index mccchannel_1_analyzer_1_array_crystal_array_1_target_index
#define target_x mccchannel_1_analyzer_1_array_crystal_array_1_target_x
#define target_y mccchannel_1_analyzer_1_array_crystal_array_1_target_y
#define target_z mccchannel_1_analyzer_1_array_crystal_array_1_target_z
#define focus_aw mccchannel_1_analyzer_1_array_crystal_array_1_focus_aw
#define focus_ah mccchannel_1_analyzer_1_array_crystal_array_1_focus_ah
#define focus_xw mccchannel_1_analyzer_1_array_crystal_array_1_focus_xw
#define focus_xh mccchannel_1_analyzer_1_array_crystal_array_1_focus_xh
#define focus_r mccchannel_1_analyzer_1_array_crystal_array_1_focus_r
#define p_interact mccchannel_1_analyzer_1_array_crystal_array_1_p_interact
#define mask_string mccchannel_1_analyzer_1_array_crystal_array_1_mask_string
#define mask_setting mccchannel_1_analyzer_1_array_crystal_array_1_mask_setting
#define number_of_activations mccchannel_1_analyzer_1_array_crystal_array_1_number_of_activations
#line 224 "Union_box.comp"
{
// Initializes the focusing system for this volume including input sanitation.
focus_initialize(&this_box_volume.geometry, POS_A_COMP_INDEX(INDEX_CURRENT_COMP+target_index), POS_A_CURRENT_COMP, ROT_A_CURRENT_COMP, target_index, target_x, target_y, target_z, focus_aw, focus_ah, focus_xw, focus_xh, focus_r, NAME_CURRENT_COMP);

// Input sanitation for this geometry
if (xwidth <= 0) {
  printf("\nERROR in Union_box named %s, the xwidth is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (yheight <= 0) {
  printf("\nERROR in Union_box named %s, yheight is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (zdepth <= 0) {
  printf("\nERROR in Union_box named %s, zdepth is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (xwidth2 <= 0 && xwidth2 != -1) {
  printf("\nERROR in Union_box named %s, the xwidth2 is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (yheight2 <= 0 && yheight2 != -1) {
  printf("\nERROR in Union_box named %s, yheight2 is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}

// Use sanitation
if (global_material_list.num_elements == 0) {
  printf("\nERROR: Need to define a material using Union_make_material before using a Union geometry component. \n");
  printf("       %s was defined before first use of Union_make_material.\n",NAME_CURRENT_COMP);
  exit(1);
}

this_box_volume.geometry.is_masked_volume = 0;
this_box_volume.geometry.is_exit_volume = 0;
this_box_volume.geometry.is_mask_volume = 0;
// check if the volume is a mask, if it is the material string is irelevant.
if (mask_string && strlen(mask_string) && strcmp(mask_string, "NULL") && strcmp(mask_string, "0")) {
    // A mask volume is used to limit the extend of other volumes, called the masked volumes. These are specified in the mask_string.
    // In order for a ray to enter a masked volume, it needs to be both in the region covered by that volume AND the mask volume.
    // When more than
    this_box_volume.geometry.mask_mode = 1; // Default is mask mode is ALL
    if (mask_setting && strlen(mask_setting) && strcmp(mask_setting, "NULL") && strcmp(mask_setting, "0")) {
        if (strcmp(mask_setting,"ALL") == 0 || strcmp(mask_setting,"All") == 0) this_box_volume.geometry.mask_mode = 1;
        else if (strcmp(mask_setting,"ANY") == 0 || strcmp(mask_setting,"Any") == 0) this_box_volume.geometry.mask_mode = 2;
        else {
            printf("The mask_mode of component %s is set to %s, but must be either ALL or ANY.\n",NAME_CURRENT_COMP,mask_setting);
            exit(1);
        }
    }
    
    for (loop_index=0;loop_index<global_geometry_list.num_elements;loop_index++) {
        // Add mask list
        if (1 == manual_linking_function(global_geometry_list.elements[loop_index].name,mask_string)) {
            add_element_to_int_list(&this_box_volume.geometry.mask_list,global_geometry_list.elements[loop_index].component_index);
            add_element_to_int_list(&global_geometry_list.elements[loop_index].Volume->geometry.masked_by_list,INDEX_CURRENT_COMP);
            global_geometry_list.elements[loop_index].Volume->geometry.is_masked_volume = 1;
            if (this_box_volume.geometry.mask_mode == 2)
                global_geometry_list.elements[loop_index].Volume->geometry.mask_mode = 2;
            if (this_box_volume.geometry.mask_mode == 1) {
                if (global_geometry_list.elements[loop_index].Volume->geometry.is_masked_volume == 1 && global_geometry_list.elements[loop_index].Volume->geometry.mask_mode != 2)
                    // If more than one mask is added to one volume, the ANY mode overwrites the (default) ALL mode.
                    global_geometry_list.elements[loop_index].Volume->geometry.mask_mode = 1;
            }
            
            found_geometries = 1;
        }
    }
    if (found_geometries == 0) {
        printf("The mask_string in geometry: %s did not find any of the specified volumes in the mask_string %s \n",NAME_CURRENT_COMP,mask_string);
        exit(1);
    }
    this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
    this_box_volume.p_physics->is_vacuum = 0; // Makes this volume a vacuum
    this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
    this_box_volume.p_physics->my_a = 0; // Should not be used.
    sprintf(this_box_volume.p_physics->name,"Mask");
    this_box_volume.geometry.is_mask_volume = 1;
    
    
// Read the material input, or if it lacks, use automatic linking.
} else if (material_string && strlen(material_string) && strcmp(material_string, "NULL") && strcmp(material_string, "0")) {
    // A geometry string was given, use it to determine which material
    if (0 == strcmp(material_string,"vacuum") || 0 == strcmp(material_string,"Vacuum")) {
        // One could have a global physics struct for vacuum instead of creating one for each
        this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
        this_box_volume.p_physics->is_vacuum = 1; // Makes this volume a vacuum
        this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
        this_box_volume.p_physics->my_a = 0; // Should not be used.
        sprintf(this_box_volume.p_physics->name,"Vacuum");
    } else if (0 == strcmp(material_string,"exit") || 0 == strcmp(material_string,"Exit")) {
        // One could have a global physics struct for vacuum instead of creating one for each
        this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
        this_box_volume.p_physics->is_vacuum = 1; // Makes this volume a vacuum
        this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
        this_box_volume.p_physics->my_a = 0; // Should not be used.
        this_box_volume.geometry.is_exit_volume = 1;
        sprintf(this_box_volume.p_physics->name,"Exit");
    } else {
        #ifndef MATERIAL_DETECTOR
            printf("Need to define a material before refering to it in a geometry %s.\n",NAME_CURRENT_COMP);
            exit(1);
        #endif
        for (loop_index=0;loop_index<global_material_list.num_elements;loop_index++) {
            if (0 == strcmp(material_string,global_material_list.elements[loop_index].name)) {
                this_box_volume.p_physics = global_material_list.elements[loop_index].physics;
                break;
            }
            if (loop_index == global_material_list.num_elements-1) {
            printf("\n");
            printf("ERROR: The material string \"%s\" in Union geometry \"%s\" did not match a specified material. \n",material_string,NAME_CURRENT_COMP);
            printf("       The materials available at this point (need to be defined before the geometry): \n");
            for (loop_index=0;loop_index<global_material_list.num_elements;loop_index++)
              printf("         %s\n",global_material_list.elements[loop_index].name);
            printf("\n");
            printf("       It is also possible to use one of the defualt materials avaiable: \n");
            printf("           Vacuum (for a Volume without scattering or absorption)\n");
            printf("           Exit (for a Volume where the ray exits the component if it enters)\n");
            printf("           Mask (for a Volume that masks existing volumes specified in the mask_string\n");
            exit(1);
          }
        }
    }
} else {
    // Automatic linking, simply using the last defined material.
    #ifndef MATERIAL_DETECTOR
        printf("Need to define a material before the geometry to use automatic linking %s.\n",NAME_CURRENT_COMP);
        exit(1);
    #endif
    this_box_volume.p_physics = global_material_list.elements[global_material_list.num_elements-1].physics;
}

sprintf(this_box_volume.name,NAME_CURRENT_COMP);
sprintf(this_box_volume.geometry.shape,"box");
this_box_volume.geometry.priority_value = priority;
this_box_volume.geometry.geometry_p_interact = p_interact;
// Currently the coordinates will be in absolute space.
this_box_volume.geometry.center = POS_A_CURRENT_COMP;

this_box_storage.z_depth = zdepth;
this_box_storage.x_width1 = xwidth;
this_box_storage.y_height1 = yheight;

this_box_storage.is_rectangle = 0;
if (xwidth2 < 0 && yheight2 < 0) this_box_storage.is_rectangle = 1;
if (xwidth == xwidth2 && yheight == yheight2) this_box_storage.is_rectangle = 1;

if (xwidth2 < 0) {
    this_box_storage.x_width2 = xwidth;
    xwidth2 = xwidth;
} else this_box_storage.x_width2 = xwidth2;

if (yheight2 < 0) {
    this_box_storage.y_height2 = yheight;
    yheight2 = yheight;
} else this_box_storage.y_height2 = yheight2;


this_box_storage.normal_vectors[0] = coords_set(0,0,1);
this_box_storage.normal_vectors[1] = coords_set(0,0,1);

// for sides with y component = 0
x_component = 2*zdepth/sqrt((xwidth-xwidth2)*(xwidth-xwidth2)+4*zdepth*zdepth);
z_component = (xwidth-xwidth2)/sqrt(4*zdepth*zdepth+(xwidth-xwidth2)*(xwidth-xwidth2));

this_box_storage.normal_vectors[2] = coords_set(x_component,0,z_component);
this_box_storage.normal_vectors[3] = coords_set(-x_component,0,z_component);

// for sides with x component = 0
y_component = 2*zdepth/sqrt((yheight-yheight2)*(yheight-yheight2)+4*zdepth*zdepth);
z_component = (yheight-yheight2)/sqrt(4*zdepth*zdepth+(yheight-yheight2)*(yheight-yheight2));

this_box_storage.normal_vectors[4] = coords_set(0,y_component,z_component);
this_box_storage.normal_vectors[5] = coords_set(0,-y_component,z_component);

this_box_volume.geometry.visualization_on = visualize;

this_box_volume.geometry.geometry_parameters.p_box_storage = &this_box_storage;

// Assign pointers to functions for intersection with the shape, checking if a point is inside the shape
if (this_box_storage.is_rectangle == 1) {
this_box_volume.geometry.intersect_function = &sample_box_intersect_simple;
this_box_volume.geometry.within_function = &r_within_box_simple;
}
else {
this_box_volume.geometry.intersect_function = &sample_box_intersect_advanced;
this_box_volume.geometry.within_function = &r_within_box_advanced;
}

this_box_volume.geometry.shell_points = &box_shell_points;
this_box_volume.geometry.mcdisplay_function = &mcdisplay_box_function;
this_box_volume.geometry.initialize_from_main_function = &initialize_box_geometry_from_main_component;
this_box_volume.geometry.process_rot_allocated = 0;

this_box_volume.geometry.copy_geometry_parameters = &allocate_box_storage_copy;

rot_copy(this_box_volume.geometry.rotation_matrix,ROT_A_CURRENT_COMP); //check how ROT_R_CURRENT_COMP would work
rot_transpose(ROT_A_CURRENT_COMP,this_box_volume.geometry.transpose_rotation_matrix);

// Initialize loggers
this_box_volume.loggers.num_elements = 0;

// packing the information into the global_geometry_element, which is then included in the global_geometry_list.
sprintf(global_geometry_element.name,NAME_CURRENT_COMP);
global_geometry_element.activation_counter = number_of_activations;
global_geometry_element.component_index = INDEX_CURRENT_COMP;
global_geometry_element.Volume = &this_box_volume; // Would be nicer if this m was a pointer, now we have the (small) data two places
add_element_to_geometry_list(&global_geometry_list,global_geometry_element);
}
#line 174854 "MACS_sample_kidney_box.c"
#undef number_of_activations
#undef mask_setting
#undef mask_string
#undef p_interact
#undef focus_r
#undef focus_xh
#undef focus_xw
#undef focus_ah
#undef focus_aw
#undef target_z
#undef target_y
#undef target_x
#undef target_index
#undef visualize
#undef yheight2
#undef xwidth2
#undef zdepth
#undef yheight
#undef xwidth
#undef priority
#undef material_string
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

  /* Initializations for component channel_1_analyzer_1_array_crystal_array_2. */
  SIG_MESSAGE("channel_1_analyzer_1_array_crystal_array_2 (Init)");
#define mccompcurname  channel_1_analyzer_1_array_crystal_array_2
#define mccompcurtype  Union_box
#define mccompcurindex 170
#define loop_index mccchannel_1_analyzer_1_array_crystal_array_2_loop_index
#define this_box_volume mccchannel_1_analyzer_1_array_crystal_array_2_this_box_volume
#define global_geometry_element mccchannel_1_analyzer_1_array_crystal_array_2_global_geometry_element
#define this_box_storage mccchannel_1_analyzer_1_array_crystal_array_2_this_box_storage
#define material_string mccchannel_1_analyzer_1_array_crystal_array_2_material_string
#define priority mccchannel_1_analyzer_1_array_crystal_array_2_priority
#define xwidth mccchannel_1_analyzer_1_array_crystal_array_2_xwidth
#define yheight mccchannel_1_analyzer_1_array_crystal_array_2_yheight
#define zdepth mccchannel_1_analyzer_1_array_crystal_array_2_zdepth
#define xwidth2 mccchannel_1_analyzer_1_array_crystal_array_2_xwidth2
#define yheight2 mccchannel_1_analyzer_1_array_crystal_array_2_yheight2
#define visualize mccchannel_1_analyzer_1_array_crystal_array_2_visualize
#define target_index mccchannel_1_analyzer_1_array_crystal_array_2_target_index
#define target_x mccchannel_1_analyzer_1_array_crystal_array_2_target_x
#define target_y mccchannel_1_analyzer_1_array_crystal_array_2_target_y
#define target_z mccchannel_1_analyzer_1_array_crystal_array_2_target_z
#define focus_aw mccchannel_1_analyzer_1_array_crystal_array_2_focus_aw
#define focus_ah mccchannel_1_analyzer_1_array_crystal_array_2_focus_ah
#define focus_xw mccchannel_1_analyzer_1_array_crystal_array_2_focus_xw
#define focus_xh mccchannel_1_analyzer_1_array_crystal_array_2_focus_xh
#define focus_r mccchannel_1_analyzer_1_array_crystal_array_2_focus_r
#define p_interact mccchannel_1_analyzer_1_array_crystal_array_2_p_interact
#define mask_string mccchannel_1_analyzer_1_array_crystal_array_2_mask_string
#define mask_setting mccchannel_1_analyzer_1_array_crystal_array_2_mask_setting
#define number_of_activations mccchannel_1_analyzer_1_array_crystal_array_2_number_of_activations
#line 224 "Union_box.comp"
{
// Initializes the focusing system for this volume including input sanitation.
focus_initialize(&this_box_volume.geometry, POS_A_COMP_INDEX(INDEX_CURRENT_COMP+target_index), POS_A_CURRENT_COMP, ROT_A_CURRENT_COMP, target_index, target_x, target_y, target_z, focus_aw, focus_ah, focus_xw, focus_xh, focus_r, NAME_CURRENT_COMP);

// Input sanitation for this geometry
if (xwidth <= 0) {
  printf("\nERROR in Union_box named %s, the xwidth is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (yheight <= 0) {
  printf("\nERROR in Union_box named %s, yheight is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (zdepth <= 0) {
  printf("\nERROR in Union_box named %s, zdepth is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (xwidth2 <= 0 && xwidth2 != -1) {
  printf("\nERROR in Union_box named %s, the xwidth2 is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (yheight2 <= 0 && yheight2 != -1) {
  printf("\nERROR in Union_box named %s, yheight2 is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}

// Use sanitation
if (global_material_list.num_elements == 0) {
  printf("\nERROR: Need to define a material using Union_make_material before using a Union geometry component. \n");
  printf("       %s was defined before first use of Union_make_material.\n",NAME_CURRENT_COMP);
  exit(1);
}

this_box_volume.geometry.is_masked_volume = 0;
this_box_volume.geometry.is_exit_volume = 0;
this_box_volume.geometry.is_mask_volume = 0;
// check if the volume is a mask, if it is the material string is irelevant.
if (mask_string && strlen(mask_string) && strcmp(mask_string, "NULL") && strcmp(mask_string, "0")) {
    // A mask volume is used to limit the extend of other volumes, called the masked volumes. These are specified in the mask_string.
    // In order for a ray to enter a masked volume, it needs to be both in the region covered by that volume AND the mask volume.
    // When more than
    this_box_volume.geometry.mask_mode = 1; // Default is mask mode is ALL
    if (mask_setting && strlen(mask_setting) && strcmp(mask_setting, "NULL") && strcmp(mask_setting, "0")) {
        if (strcmp(mask_setting,"ALL") == 0 || strcmp(mask_setting,"All") == 0) this_box_volume.geometry.mask_mode = 1;
        else if (strcmp(mask_setting,"ANY") == 0 || strcmp(mask_setting,"Any") == 0) this_box_volume.geometry.mask_mode = 2;
        else {
            printf("The mask_mode of component %s is set to %s, but must be either ALL or ANY.\n",NAME_CURRENT_COMP,mask_setting);
            exit(1);
        }
    }
    
    for (loop_index=0;loop_index<global_geometry_list.num_elements;loop_index++) {
        // Add mask list
        if (1 == manual_linking_function(global_geometry_list.elements[loop_index].name,mask_string)) {
            add_element_to_int_list(&this_box_volume.geometry.mask_list,global_geometry_list.elements[loop_index].component_index);
            add_element_to_int_list(&global_geometry_list.elements[loop_index].Volume->geometry.masked_by_list,INDEX_CURRENT_COMP);
            global_geometry_list.elements[loop_index].Volume->geometry.is_masked_volume = 1;
            if (this_box_volume.geometry.mask_mode == 2)
                global_geometry_list.elements[loop_index].Volume->geometry.mask_mode = 2;
            if (this_box_volume.geometry.mask_mode == 1) {
                if (global_geometry_list.elements[loop_index].Volume->geometry.is_masked_volume == 1 && global_geometry_list.elements[loop_index].Volume->geometry.mask_mode != 2)
                    // If more than one mask is added to one volume, the ANY mode overwrites the (default) ALL mode.
                    global_geometry_list.elements[loop_index].Volume->geometry.mask_mode = 1;
            }
            
            found_geometries = 1;
        }
    }
    if (found_geometries == 0) {
        printf("The mask_string in geometry: %s did not find any of the specified volumes in the mask_string %s \n",NAME_CURRENT_COMP,mask_string);
        exit(1);
    }
    this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
    this_box_volume.p_physics->is_vacuum = 0; // Makes this volume a vacuum
    this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
    this_box_volume.p_physics->my_a = 0; // Should not be used.
    sprintf(this_box_volume.p_physics->name,"Mask");
    this_box_volume.geometry.is_mask_volume = 1;
    
    
// Read the material input, or if it lacks, use automatic linking.
} else if (material_string && strlen(material_string) && strcmp(material_string, "NULL") && strcmp(material_string, "0")) {
    // A geometry string was given, use it to determine which material
    if (0 == strcmp(material_string,"vacuum") || 0 == strcmp(material_string,"Vacuum")) {
        // One could have a global physics struct for vacuum instead of creating one for each
        this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
        this_box_volume.p_physics->is_vacuum = 1; // Makes this volume a vacuum
        this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
        this_box_volume.p_physics->my_a = 0; // Should not be used.
        sprintf(this_box_volume.p_physics->name,"Vacuum");
    } else if (0 == strcmp(material_string,"exit") || 0 == strcmp(material_string,"Exit")) {
        // One could have a global physics struct for vacuum instead of creating one for each
        this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
        this_box_volume.p_physics->is_vacuum = 1; // Makes this volume a vacuum
        this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
        this_box_volume.p_physics->my_a = 0; // Should not be used.
        this_box_volume.geometry.is_exit_volume = 1;
        sprintf(this_box_volume.p_physics->name,"Exit");
    } else {
        #ifndef MATERIAL_DETECTOR
            printf("Need to define a material before refering to it in a geometry %s.\n",NAME_CURRENT_COMP);
            exit(1);
        #endif
        for (loop_index=0;loop_index<global_material_list.num_elements;loop_index++) {
            if (0 == strcmp(material_string,global_material_list.elements[loop_index].name)) {
                this_box_volume.p_physics = global_material_list.elements[loop_index].physics;
                break;
            }
            if (loop_index == global_material_list.num_elements-1) {
            printf("\n");
            printf("ERROR: The material string \"%s\" in Union geometry \"%s\" did not match a specified material. \n",material_string,NAME_CURRENT_COMP);
            printf("       The materials available at this point (need to be defined before the geometry): \n");
            for (loop_index=0;loop_index<global_material_list.num_elements;loop_index++)
              printf("         %s\n",global_material_list.elements[loop_index].name);
            printf("\n");
            printf("       It is also possible to use one of the defualt materials avaiable: \n");
            printf("           Vacuum (for a Volume without scattering or absorption)\n");
            printf("           Exit (for a Volume where the ray exits the component if it enters)\n");
            printf("           Mask (for a Volume that masks existing volumes specified in the mask_string\n");
            exit(1);
          }
        }
    }
} else {
    // Automatic linking, simply using the last defined material.
    #ifndef MATERIAL_DETECTOR
        printf("Need to define a material before the geometry to use automatic linking %s.\n",NAME_CURRENT_COMP);
        exit(1);
    #endif
    this_box_volume.p_physics = global_material_list.elements[global_material_list.num_elements-1].physics;
}

sprintf(this_box_volume.name,NAME_CURRENT_COMP);
sprintf(this_box_volume.geometry.shape,"box");
this_box_volume.geometry.priority_value = priority;
this_box_volume.geometry.geometry_p_interact = p_interact;
// Currently the coordinates will be in absolute space.
this_box_volume.geometry.center = POS_A_CURRENT_COMP;

this_box_storage.z_depth = zdepth;
this_box_storage.x_width1 = xwidth;
this_box_storage.y_height1 = yheight;

this_box_storage.is_rectangle = 0;
if (xwidth2 < 0 && yheight2 < 0) this_box_storage.is_rectangle = 1;
if (xwidth == xwidth2 && yheight == yheight2) this_box_storage.is_rectangle = 1;

if (xwidth2 < 0) {
    this_box_storage.x_width2 = xwidth;
    xwidth2 = xwidth;
} else this_box_storage.x_width2 = xwidth2;

if (yheight2 < 0) {
    this_box_storage.y_height2 = yheight;
    yheight2 = yheight;
} else this_box_storage.y_height2 = yheight2;


this_box_storage.normal_vectors[0] = coords_set(0,0,1);
this_box_storage.normal_vectors[1] = coords_set(0,0,1);

// for sides with y component = 0
x_component = 2*zdepth/sqrt((xwidth-xwidth2)*(xwidth-xwidth2)+4*zdepth*zdepth);
z_component = (xwidth-xwidth2)/sqrt(4*zdepth*zdepth+(xwidth-xwidth2)*(xwidth-xwidth2));

this_box_storage.normal_vectors[2] = coords_set(x_component,0,z_component);
this_box_storage.normal_vectors[3] = coords_set(-x_component,0,z_component);

// for sides with x component = 0
y_component = 2*zdepth/sqrt((yheight-yheight2)*(yheight-yheight2)+4*zdepth*zdepth);
z_component = (yheight-yheight2)/sqrt(4*zdepth*zdepth+(yheight-yheight2)*(yheight-yheight2));

this_box_storage.normal_vectors[4] = coords_set(0,y_component,z_component);
this_box_storage.normal_vectors[5] = coords_set(0,-y_component,z_component);

this_box_volume.geometry.visualization_on = visualize;

this_box_volume.geometry.geometry_parameters.p_box_storage = &this_box_storage;

// Assign pointers to functions for intersection with the shape, checking if a point is inside the shape
if (this_box_storage.is_rectangle == 1) {
this_box_volume.geometry.intersect_function = &sample_box_intersect_simple;
this_box_volume.geometry.within_function = &r_within_box_simple;
}
else {
this_box_volume.geometry.intersect_function = &sample_box_intersect_advanced;
this_box_volume.geometry.within_function = &r_within_box_advanced;
}

this_box_volume.geometry.shell_points = &box_shell_points;
this_box_volume.geometry.mcdisplay_function = &mcdisplay_box_function;
this_box_volume.geometry.initialize_from_main_function = &initialize_box_geometry_from_main_component;
this_box_volume.geometry.process_rot_allocated = 0;

this_box_volume.geometry.copy_geometry_parameters = &allocate_box_storage_copy;

rot_copy(this_box_volume.geometry.rotation_matrix,ROT_A_CURRENT_COMP); //check how ROT_R_CURRENT_COMP would work
rot_transpose(ROT_A_CURRENT_COMP,this_box_volume.geometry.transpose_rotation_matrix);

// Initialize loggers
this_box_volume.loggers.num_elements = 0;

// packing the information into the global_geometry_element, which is then included in the global_geometry_list.
sprintf(global_geometry_element.name,NAME_CURRENT_COMP);
global_geometry_element.activation_counter = number_of_activations;
global_geometry_element.component_index = INDEX_CURRENT_COMP;
global_geometry_element.Volume = &this_box_volume; // Would be nicer if this m was a pointer, now we have the (small) data two places
add_element_to_geometry_list(&global_geometry_list,global_geometry_element);
}
#line 175124 "MACS_sample_kidney_box.c"
#undef number_of_activations
#undef mask_setting
#undef mask_string
#undef p_interact
#undef focus_r
#undef focus_xh
#undef focus_xw
#undef focus_ah
#undef focus_aw
#undef target_z
#undef target_y
#undef target_x
#undef target_index
#undef visualize
#undef yheight2
#undef xwidth2
#undef zdepth
#undef yheight
#undef xwidth
#undef priority
#undef material_string
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

  /* Initializations for component channel_1_analyzer_1_array_crystal_array_3. */
  SIG_MESSAGE("channel_1_analyzer_1_array_crystal_array_3 (Init)");
#define mccompcurname  channel_1_analyzer_1_array_crystal_array_3
#define mccompcurtype  Union_box
#define mccompcurindex 171
#define loop_index mccchannel_1_analyzer_1_array_crystal_array_3_loop_index
#define this_box_volume mccchannel_1_analyzer_1_array_crystal_array_3_this_box_volume
#define global_geometry_element mccchannel_1_analyzer_1_array_crystal_array_3_global_geometry_element
#define this_box_storage mccchannel_1_analyzer_1_array_crystal_array_3_this_box_storage
#define material_string mccchannel_1_analyzer_1_array_crystal_array_3_material_string
#define priority mccchannel_1_analyzer_1_array_crystal_array_3_priority
#define xwidth mccchannel_1_analyzer_1_array_crystal_array_3_xwidth
#define yheight mccchannel_1_analyzer_1_array_crystal_array_3_yheight
#define zdepth mccchannel_1_analyzer_1_array_crystal_array_3_zdepth
#define xwidth2 mccchannel_1_analyzer_1_array_crystal_array_3_xwidth2
#define yheight2 mccchannel_1_analyzer_1_array_crystal_array_3_yheight2
#define visualize mccchannel_1_analyzer_1_array_crystal_array_3_visualize
#define target_index mccchannel_1_analyzer_1_array_crystal_array_3_target_index
#define target_x mccchannel_1_analyzer_1_array_crystal_array_3_target_x
#define target_y mccchannel_1_analyzer_1_array_crystal_array_3_target_y
#define target_z mccchannel_1_analyzer_1_array_crystal_array_3_target_z
#define focus_aw mccchannel_1_analyzer_1_array_crystal_array_3_focus_aw
#define focus_ah mccchannel_1_analyzer_1_array_crystal_array_3_focus_ah
#define focus_xw mccchannel_1_analyzer_1_array_crystal_array_3_focus_xw
#define focus_xh mccchannel_1_analyzer_1_array_crystal_array_3_focus_xh
#define focus_r mccchannel_1_analyzer_1_array_crystal_array_3_focus_r
#define p_interact mccchannel_1_analyzer_1_array_crystal_array_3_p_interact
#define mask_string mccchannel_1_analyzer_1_array_crystal_array_3_mask_string
#define mask_setting mccchannel_1_analyzer_1_array_crystal_array_3_mask_setting
#define number_of_activations mccchannel_1_analyzer_1_array_crystal_array_3_number_of_activations
#line 224 "Union_box.comp"
{
// Initializes the focusing system for this volume including input sanitation.
focus_initialize(&this_box_volume.geometry, POS_A_COMP_INDEX(INDEX_CURRENT_COMP+target_index), POS_A_CURRENT_COMP, ROT_A_CURRENT_COMP, target_index, target_x, target_y, target_z, focus_aw, focus_ah, focus_xw, focus_xh, focus_r, NAME_CURRENT_COMP);

// Input sanitation for this geometry
if (xwidth <= 0) {
  printf("\nERROR in Union_box named %s, the xwidth is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (yheight <= 0) {
  printf("\nERROR in Union_box named %s, yheight is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (zdepth <= 0) {
  printf("\nERROR in Union_box named %s, zdepth is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (xwidth2 <= 0 && xwidth2 != -1) {
  printf("\nERROR in Union_box named %s, the xwidth2 is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (yheight2 <= 0 && yheight2 != -1) {
  printf("\nERROR in Union_box named %s, yheight2 is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}

// Use sanitation
if (global_material_list.num_elements == 0) {
  printf("\nERROR: Need to define a material using Union_make_material before using a Union geometry component. \n");
  printf("       %s was defined before first use of Union_make_material.\n",NAME_CURRENT_COMP);
  exit(1);
}

this_box_volume.geometry.is_masked_volume = 0;
this_box_volume.geometry.is_exit_volume = 0;
this_box_volume.geometry.is_mask_volume = 0;
// check if the volume is a mask, if it is the material string is irelevant.
if (mask_string && strlen(mask_string) && strcmp(mask_string, "NULL") && strcmp(mask_string, "0")) {
    // A mask volume is used to limit the extend of other volumes, called the masked volumes. These are specified in the mask_string.
    // In order for a ray to enter a masked volume, it needs to be both in the region covered by that volume AND the mask volume.
    // When more than
    this_box_volume.geometry.mask_mode = 1; // Default is mask mode is ALL
    if (mask_setting && strlen(mask_setting) && strcmp(mask_setting, "NULL") && strcmp(mask_setting, "0")) {
        if (strcmp(mask_setting,"ALL") == 0 || strcmp(mask_setting,"All") == 0) this_box_volume.geometry.mask_mode = 1;
        else if (strcmp(mask_setting,"ANY") == 0 || strcmp(mask_setting,"Any") == 0) this_box_volume.geometry.mask_mode = 2;
        else {
            printf("The mask_mode of component %s is set to %s, but must be either ALL or ANY.\n",NAME_CURRENT_COMP,mask_setting);
            exit(1);
        }
    }
    
    for (loop_index=0;loop_index<global_geometry_list.num_elements;loop_index++) {
        // Add mask list
        if (1 == manual_linking_function(global_geometry_list.elements[loop_index].name,mask_string)) {
            add_element_to_int_list(&this_box_volume.geometry.mask_list,global_geometry_list.elements[loop_index].component_index);
            add_element_to_int_list(&global_geometry_list.elements[loop_index].Volume->geometry.masked_by_list,INDEX_CURRENT_COMP);
            global_geometry_list.elements[loop_index].Volume->geometry.is_masked_volume = 1;
            if (this_box_volume.geometry.mask_mode == 2)
                global_geometry_list.elements[loop_index].Volume->geometry.mask_mode = 2;
            if (this_box_volume.geometry.mask_mode == 1) {
                if (global_geometry_list.elements[loop_index].Volume->geometry.is_masked_volume == 1 && global_geometry_list.elements[loop_index].Volume->geometry.mask_mode != 2)
                    // If more than one mask is added to one volume, the ANY mode overwrites the (default) ALL mode.
                    global_geometry_list.elements[loop_index].Volume->geometry.mask_mode = 1;
            }
            
            found_geometries = 1;
        }
    }
    if (found_geometries == 0) {
        printf("The mask_string in geometry: %s did not find any of the specified volumes in the mask_string %s \n",NAME_CURRENT_COMP,mask_string);
        exit(1);
    }
    this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
    this_box_volume.p_physics->is_vacuum = 0; // Makes this volume a vacuum
    this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
    this_box_volume.p_physics->my_a = 0; // Should not be used.
    sprintf(this_box_volume.p_physics->name,"Mask");
    this_box_volume.geometry.is_mask_volume = 1;
    
    
// Read the material input, or if it lacks, use automatic linking.
} else if (material_string && strlen(material_string) && strcmp(material_string, "NULL") && strcmp(material_string, "0")) {
    // A geometry string was given, use it to determine which material
    if (0 == strcmp(material_string,"vacuum") || 0 == strcmp(material_string,"Vacuum")) {
        // One could have a global physics struct for vacuum instead of creating one for each
        this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
        this_box_volume.p_physics->is_vacuum = 1; // Makes this volume a vacuum
        this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
        this_box_volume.p_physics->my_a = 0; // Should not be used.
        sprintf(this_box_volume.p_physics->name,"Vacuum");
    } else if (0 == strcmp(material_string,"exit") || 0 == strcmp(material_string,"Exit")) {
        // One could have a global physics struct for vacuum instead of creating one for each
        this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
        this_box_volume.p_physics->is_vacuum = 1; // Makes this volume a vacuum
        this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
        this_box_volume.p_physics->my_a = 0; // Should not be used.
        this_box_volume.geometry.is_exit_volume = 1;
        sprintf(this_box_volume.p_physics->name,"Exit");
    } else {
        #ifndef MATERIAL_DETECTOR
            printf("Need to define a material before refering to it in a geometry %s.\n",NAME_CURRENT_COMP);
            exit(1);
        #endif
        for (loop_index=0;loop_index<global_material_list.num_elements;loop_index++) {
            if (0 == strcmp(material_string,global_material_list.elements[loop_index].name)) {
                this_box_volume.p_physics = global_material_list.elements[loop_index].physics;
                break;
            }
            if (loop_index == global_material_list.num_elements-1) {
            printf("\n");
            printf("ERROR: The material string \"%s\" in Union geometry \"%s\" did not match a specified material. \n",material_string,NAME_CURRENT_COMP);
            printf("       The materials available at this point (need to be defined before the geometry): \n");
            for (loop_index=0;loop_index<global_material_list.num_elements;loop_index++)
              printf("         %s\n",global_material_list.elements[loop_index].name);
            printf("\n");
            printf("       It is also possible to use one of the defualt materials avaiable: \n");
            printf("           Vacuum (for a Volume without scattering or absorption)\n");
            printf("           Exit (for a Volume where the ray exits the component if it enters)\n");
            printf("           Mask (for a Volume that masks existing volumes specified in the mask_string\n");
            exit(1);
          }
        }
    }
} else {
    // Automatic linking, simply using the last defined material.
    #ifndef MATERIAL_DETECTOR
        printf("Need to define a material before the geometry to use automatic linking %s.\n",NAME_CURRENT_COMP);
        exit(1);
    #endif
    this_box_volume.p_physics = global_material_list.elements[global_material_list.num_elements-1].physics;
}

sprintf(this_box_volume.name,NAME_CURRENT_COMP);
sprintf(this_box_volume.geometry.shape,"box");
this_box_volume.geometry.priority_value = priority;
this_box_volume.geometry.geometry_p_interact = p_interact;
// Currently the coordinates will be in absolute space.
this_box_volume.geometry.center = POS_A_CURRENT_COMP;

this_box_storage.z_depth = zdepth;
this_box_storage.x_width1 = xwidth;
this_box_storage.y_height1 = yheight;

this_box_storage.is_rectangle = 0;
if (xwidth2 < 0 && yheight2 < 0) this_box_storage.is_rectangle = 1;
if (xwidth == xwidth2 && yheight == yheight2) this_box_storage.is_rectangle = 1;

if (xwidth2 < 0) {
    this_box_storage.x_width2 = xwidth;
    xwidth2 = xwidth;
} else this_box_storage.x_width2 = xwidth2;

if (yheight2 < 0) {
    this_box_storage.y_height2 = yheight;
    yheight2 = yheight;
} else this_box_storage.y_height2 = yheight2;


this_box_storage.normal_vectors[0] = coords_set(0,0,1);
this_box_storage.normal_vectors[1] = coords_set(0,0,1);

// for sides with y component = 0
x_component = 2*zdepth/sqrt((xwidth-xwidth2)*(xwidth-xwidth2)+4*zdepth*zdepth);
z_component = (xwidth-xwidth2)/sqrt(4*zdepth*zdepth+(xwidth-xwidth2)*(xwidth-xwidth2));

this_box_storage.normal_vectors[2] = coords_set(x_component,0,z_component);
this_box_storage.normal_vectors[3] = coords_set(-x_component,0,z_component);

// for sides with x component = 0
y_component = 2*zdepth/sqrt((yheight-yheight2)*(yheight-yheight2)+4*zdepth*zdepth);
z_component = (yheight-yheight2)/sqrt(4*zdepth*zdepth+(yheight-yheight2)*(yheight-yheight2));

this_box_storage.normal_vectors[4] = coords_set(0,y_component,z_component);
this_box_storage.normal_vectors[5] = coords_set(0,-y_component,z_component);

this_box_volume.geometry.visualization_on = visualize;

this_box_volume.geometry.geometry_parameters.p_box_storage = &this_box_storage;

// Assign pointers to functions for intersection with the shape, checking if a point is inside the shape
if (this_box_storage.is_rectangle == 1) {
this_box_volume.geometry.intersect_function = &sample_box_intersect_simple;
this_box_volume.geometry.within_function = &r_within_box_simple;
}
else {
this_box_volume.geometry.intersect_function = &sample_box_intersect_advanced;
this_box_volume.geometry.within_function = &r_within_box_advanced;
}

this_box_volume.geometry.shell_points = &box_shell_points;
this_box_volume.geometry.mcdisplay_function = &mcdisplay_box_function;
this_box_volume.geometry.initialize_from_main_function = &initialize_box_geometry_from_main_component;
this_box_volume.geometry.process_rot_allocated = 0;

this_box_volume.geometry.copy_geometry_parameters = &allocate_box_storage_copy;

rot_copy(this_box_volume.geometry.rotation_matrix,ROT_A_CURRENT_COMP); //check how ROT_R_CURRENT_COMP would work
rot_transpose(ROT_A_CURRENT_COMP,this_box_volume.geometry.transpose_rotation_matrix);

// Initialize loggers
this_box_volume.loggers.num_elements = 0;

// packing the information into the global_geometry_element, which is then included in the global_geometry_list.
sprintf(global_geometry_element.name,NAME_CURRENT_COMP);
global_geometry_element.activation_counter = number_of_activations;
global_geometry_element.component_index = INDEX_CURRENT_COMP;
global_geometry_element.Volume = &this_box_volume; // Would be nicer if this m was a pointer, now we have the (small) data two places
add_element_to_geometry_list(&global_geometry_list,global_geometry_element);
}
#line 175394 "MACS_sample_kidney_box.c"
#undef number_of_activations
#undef mask_setting
#undef mask_string
#undef p_interact
#undef focus_r
#undef focus_xh
#undef focus_xw
#undef focus_ah
#undef focus_aw
#undef target_z
#undef target_y
#undef target_x
#undef target_index
#undef visualize
#undef yheight2
#undef xwidth2
#undef zdepth
#undef yheight
#undef xwidth
#undef priority
#undef material_string
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

  /* Initializations for component channel_1_analyzer_1_array_crystal_array_4. */
  SIG_MESSAGE("channel_1_analyzer_1_array_crystal_array_4 (Init)");
#define mccompcurname  channel_1_analyzer_1_array_crystal_array_4
#define mccompcurtype  Union_box
#define mccompcurindex 172
#define loop_index mccchannel_1_analyzer_1_array_crystal_array_4_loop_index
#define this_box_volume mccchannel_1_analyzer_1_array_crystal_array_4_this_box_volume
#define global_geometry_element mccchannel_1_analyzer_1_array_crystal_array_4_global_geometry_element
#define this_box_storage mccchannel_1_analyzer_1_array_crystal_array_4_this_box_storage
#define material_string mccchannel_1_analyzer_1_array_crystal_array_4_material_string
#define priority mccchannel_1_analyzer_1_array_crystal_array_4_priority
#define xwidth mccchannel_1_analyzer_1_array_crystal_array_4_xwidth
#define yheight mccchannel_1_analyzer_1_array_crystal_array_4_yheight
#define zdepth mccchannel_1_analyzer_1_array_crystal_array_4_zdepth
#define xwidth2 mccchannel_1_analyzer_1_array_crystal_array_4_xwidth2
#define yheight2 mccchannel_1_analyzer_1_array_crystal_array_4_yheight2
#define visualize mccchannel_1_analyzer_1_array_crystal_array_4_visualize
#define target_index mccchannel_1_analyzer_1_array_crystal_array_4_target_index
#define target_x mccchannel_1_analyzer_1_array_crystal_array_4_target_x
#define target_y mccchannel_1_analyzer_1_array_crystal_array_4_target_y
#define target_z mccchannel_1_analyzer_1_array_crystal_array_4_target_z
#define focus_aw mccchannel_1_analyzer_1_array_crystal_array_4_focus_aw
#define focus_ah mccchannel_1_analyzer_1_array_crystal_array_4_focus_ah
#define focus_xw mccchannel_1_analyzer_1_array_crystal_array_4_focus_xw
#define focus_xh mccchannel_1_analyzer_1_array_crystal_array_4_focus_xh
#define focus_r mccchannel_1_analyzer_1_array_crystal_array_4_focus_r
#define p_interact mccchannel_1_analyzer_1_array_crystal_array_4_p_interact
#define mask_string mccchannel_1_analyzer_1_array_crystal_array_4_mask_string
#define mask_setting mccchannel_1_analyzer_1_array_crystal_array_4_mask_setting
#define number_of_activations mccchannel_1_analyzer_1_array_crystal_array_4_number_of_activations
#line 224 "Union_box.comp"
{
// Initializes the focusing system for this volume including input sanitation.
focus_initialize(&this_box_volume.geometry, POS_A_COMP_INDEX(INDEX_CURRENT_COMP+target_index), POS_A_CURRENT_COMP, ROT_A_CURRENT_COMP, target_index, target_x, target_y, target_z, focus_aw, focus_ah, focus_xw, focus_xh, focus_r, NAME_CURRENT_COMP);

// Input sanitation for this geometry
if (xwidth <= 0) {
  printf("\nERROR in Union_box named %s, the xwidth is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (yheight <= 0) {
  printf("\nERROR in Union_box named %s, yheight is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (zdepth <= 0) {
  printf("\nERROR in Union_box named %s, zdepth is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (xwidth2 <= 0 && xwidth2 != -1) {
  printf("\nERROR in Union_box named %s, the xwidth2 is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (yheight2 <= 0 && yheight2 != -1) {
  printf("\nERROR in Union_box named %s, yheight2 is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}

// Use sanitation
if (global_material_list.num_elements == 0) {
  printf("\nERROR: Need to define a material using Union_make_material before using a Union geometry component. \n");
  printf("       %s was defined before first use of Union_make_material.\n",NAME_CURRENT_COMP);
  exit(1);
}

this_box_volume.geometry.is_masked_volume = 0;
this_box_volume.geometry.is_exit_volume = 0;
this_box_volume.geometry.is_mask_volume = 0;
// check if the volume is a mask, if it is the material string is irelevant.
if (mask_string && strlen(mask_string) && strcmp(mask_string, "NULL") && strcmp(mask_string, "0")) {
    // A mask volume is used to limit the extend of other volumes, called the masked volumes. These are specified in the mask_string.
    // In order for a ray to enter a masked volume, it needs to be both in the region covered by that volume AND the mask volume.
    // When more than
    this_box_volume.geometry.mask_mode = 1; // Default is mask mode is ALL
    if (mask_setting && strlen(mask_setting) && strcmp(mask_setting, "NULL") && strcmp(mask_setting, "0")) {
        if (strcmp(mask_setting,"ALL") == 0 || strcmp(mask_setting,"All") == 0) this_box_volume.geometry.mask_mode = 1;
        else if (strcmp(mask_setting,"ANY") == 0 || strcmp(mask_setting,"Any") == 0) this_box_volume.geometry.mask_mode = 2;
        else {
            printf("The mask_mode of component %s is set to %s, but must be either ALL or ANY.\n",NAME_CURRENT_COMP,mask_setting);
            exit(1);
        }
    }
    
    for (loop_index=0;loop_index<global_geometry_list.num_elements;loop_index++) {
        // Add mask list
        if (1 == manual_linking_function(global_geometry_list.elements[loop_index].name,mask_string)) {
            add_element_to_int_list(&this_box_volume.geometry.mask_list,global_geometry_list.elements[loop_index].component_index);
            add_element_to_int_list(&global_geometry_list.elements[loop_index].Volume->geometry.masked_by_list,INDEX_CURRENT_COMP);
            global_geometry_list.elements[loop_index].Volume->geometry.is_masked_volume = 1;
            if (this_box_volume.geometry.mask_mode == 2)
                global_geometry_list.elements[loop_index].Volume->geometry.mask_mode = 2;
            if (this_box_volume.geometry.mask_mode == 1) {
                if (global_geometry_list.elements[loop_index].Volume->geometry.is_masked_volume == 1 && global_geometry_list.elements[loop_index].Volume->geometry.mask_mode != 2)
                    // If more than one mask is added to one volume, the ANY mode overwrites the (default) ALL mode.
                    global_geometry_list.elements[loop_index].Volume->geometry.mask_mode = 1;
            }
            
            found_geometries = 1;
        }
    }
    if (found_geometries == 0) {
        printf("The mask_string in geometry: %s did not find any of the specified volumes in the mask_string %s \n",NAME_CURRENT_COMP,mask_string);
        exit(1);
    }
    this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
    this_box_volume.p_physics->is_vacuum = 0; // Makes this volume a vacuum
    this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
    this_box_volume.p_physics->my_a = 0; // Should not be used.
    sprintf(this_box_volume.p_physics->name,"Mask");
    this_box_volume.geometry.is_mask_volume = 1;
    
    
// Read the material input, or if it lacks, use automatic linking.
} else if (material_string && strlen(material_string) && strcmp(material_string, "NULL") && strcmp(material_string, "0")) {
    // A geometry string was given, use it to determine which material
    if (0 == strcmp(material_string,"vacuum") || 0 == strcmp(material_string,"Vacuum")) {
        // One could have a global physics struct for vacuum instead of creating one for each
        this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
        this_box_volume.p_physics->is_vacuum = 1; // Makes this volume a vacuum
        this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
        this_box_volume.p_physics->my_a = 0; // Should not be used.
        sprintf(this_box_volume.p_physics->name,"Vacuum");
    } else if (0 == strcmp(material_string,"exit") || 0 == strcmp(material_string,"Exit")) {
        // One could have a global physics struct for vacuum instead of creating one for each
        this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
        this_box_volume.p_physics->is_vacuum = 1; // Makes this volume a vacuum
        this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
        this_box_volume.p_physics->my_a = 0; // Should not be used.
        this_box_volume.geometry.is_exit_volume = 1;
        sprintf(this_box_volume.p_physics->name,"Exit");
    } else {
        #ifndef MATERIAL_DETECTOR
            printf("Need to define a material before refering to it in a geometry %s.\n",NAME_CURRENT_COMP);
            exit(1);
        #endif
        for (loop_index=0;loop_index<global_material_list.num_elements;loop_index++) {
            if (0 == strcmp(material_string,global_material_list.elements[loop_index].name)) {
                this_box_volume.p_physics = global_material_list.elements[loop_index].physics;
                break;
            }
            if (loop_index == global_material_list.num_elements-1) {
            printf("\n");
            printf("ERROR: The material string \"%s\" in Union geometry \"%s\" did not match a specified material. \n",material_string,NAME_CURRENT_COMP);
            printf("       The materials available at this point (need to be defined before the geometry): \n");
            for (loop_index=0;loop_index<global_material_list.num_elements;loop_index++)
              printf("         %s\n",global_material_list.elements[loop_index].name);
            printf("\n");
            printf("       It is also possible to use one of the defualt materials avaiable: \n");
            printf("           Vacuum (for a Volume without scattering or absorption)\n");
            printf("           Exit (for a Volume where the ray exits the component if it enters)\n");
            printf("           Mask (for a Volume that masks existing volumes specified in the mask_string\n");
            exit(1);
          }
        }
    }
} else {
    // Automatic linking, simply using the last defined material.
    #ifndef MATERIAL_DETECTOR
        printf("Need to define a material before the geometry to use automatic linking %s.\n",NAME_CURRENT_COMP);
        exit(1);
    #endif
    this_box_volume.p_physics = global_material_list.elements[global_material_list.num_elements-1].physics;
}

sprintf(this_box_volume.name,NAME_CURRENT_COMP);
sprintf(this_box_volume.geometry.shape,"box");
this_box_volume.geometry.priority_value = priority;
this_box_volume.geometry.geometry_p_interact = p_interact;
// Currently the coordinates will be in absolute space.
this_box_volume.geometry.center = POS_A_CURRENT_COMP;

this_box_storage.z_depth = zdepth;
this_box_storage.x_width1 = xwidth;
this_box_storage.y_height1 = yheight;

this_box_storage.is_rectangle = 0;
if (xwidth2 < 0 && yheight2 < 0) this_box_storage.is_rectangle = 1;
if (xwidth == xwidth2 && yheight == yheight2) this_box_storage.is_rectangle = 1;

if (xwidth2 < 0) {
    this_box_storage.x_width2 = xwidth;
    xwidth2 = xwidth;
} else this_box_storage.x_width2 = xwidth2;

if (yheight2 < 0) {
    this_box_storage.y_height2 = yheight;
    yheight2 = yheight;
} else this_box_storage.y_height2 = yheight2;


this_box_storage.normal_vectors[0] = coords_set(0,0,1);
this_box_storage.normal_vectors[1] = coords_set(0,0,1);

// for sides with y component = 0
x_component = 2*zdepth/sqrt((xwidth-xwidth2)*(xwidth-xwidth2)+4*zdepth*zdepth);
z_component = (xwidth-xwidth2)/sqrt(4*zdepth*zdepth+(xwidth-xwidth2)*(xwidth-xwidth2));

this_box_storage.normal_vectors[2] = coords_set(x_component,0,z_component);
this_box_storage.normal_vectors[3] = coords_set(-x_component,0,z_component);

// for sides with x component = 0
y_component = 2*zdepth/sqrt((yheight-yheight2)*(yheight-yheight2)+4*zdepth*zdepth);
z_component = (yheight-yheight2)/sqrt(4*zdepth*zdepth+(yheight-yheight2)*(yheight-yheight2));

this_box_storage.normal_vectors[4] = coords_set(0,y_component,z_component);
this_box_storage.normal_vectors[5] = coords_set(0,-y_component,z_component);

this_box_volume.geometry.visualization_on = visualize;

this_box_volume.geometry.geometry_parameters.p_box_storage = &this_box_storage;

// Assign pointers to functions for intersection with the shape, checking if a point is inside the shape
if (this_box_storage.is_rectangle == 1) {
this_box_volume.geometry.intersect_function = &sample_box_intersect_simple;
this_box_volume.geometry.within_function = &r_within_box_simple;
}
else {
this_box_volume.geometry.intersect_function = &sample_box_intersect_advanced;
this_box_volume.geometry.within_function = &r_within_box_advanced;
}

this_box_volume.geometry.shell_points = &box_shell_points;
this_box_volume.geometry.mcdisplay_function = &mcdisplay_box_function;
this_box_volume.geometry.initialize_from_main_function = &initialize_box_geometry_from_main_component;
this_box_volume.geometry.process_rot_allocated = 0;

this_box_volume.geometry.copy_geometry_parameters = &allocate_box_storage_copy;

rot_copy(this_box_volume.geometry.rotation_matrix,ROT_A_CURRENT_COMP); //check how ROT_R_CURRENT_COMP would work
rot_transpose(ROT_A_CURRENT_COMP,this_box_volume.geometry.transpose_rotation_matrix);

// Initialize loggers
this_box_volume.loggers.num_elements = 0;

// packing the information into the global_geometry_element, which is then included in the global_geometry_list.
sprintf(global_geometry_element.name,NAME_CURRENT_COMP);
global_geometry_element.activation_counter = number_of_activations;
global_geometry_element.component_index = INDEX_CURRENT_COMP;
global_geometry_element.Volume = &this_box_volume; // Would be nicer if this m was a pointer, now we have the (small) data two places
add_element_to_geometry_list(&global_geometry_list,global_geometry_element);
}
#line 175664 "MACS_sample_kidney_box.c"
#undef number_of_activations
#undef mask_setting
#undef mask_string
#undef p_interact
#undef focus_r
#undef focus_xh
#undef focus_xw
#undef focus_ah
#undef focus_aw
#undef target_z
#undef target_y
#undef target_x
#undef target_index
#undef visualize
#undef yheight2
#undef xwidth2
#undef zdepth
#undef yheight
#undef xwidth
#undef priority
#undef material_string
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

  /* Initializations for component channel_1_analyzer_1_array_crystal_array_5. */
  SIG_MESSAGE("channel_1_analyzer_1_array_crystal_array_5 (Init)");
#define mccompcurname  channel_1_analyzer_1_array_crystal_array_5
#define mccompcurtype  Union_box
#define mccompcurindex 173
#define loop_index mccchannel_1_analyzer_1_array_crystal_array_5_loop_index
#define this_box_volume mccchannel_1_analyzer_1_array_crystal_array_5_this_box_volume
#define global_geometry_element mccchannel_1_analyzer_1_array_crystal_array_5_global_geometry_element
#define this_box_storage mccchannel_1_analyzer_1_array_crystal_array_5_this_box_storage
#define material_string mccchannel_1_analyzer_1_array_crystal_array_5_material_string
#define priority mccchannel_1_analyzer_1_array_crystal_array_5_priority
#define xwidth mccchannel_1_analyzer_1_array_crystal_array_5_xwidth
#define yheight mccchannel_1_analyzer_1_array_crystal_array_5_yheight
#define zdepth mccchannel_1_analyzer_1_array_crystal_array_5_zdepth
#define xwidth2 mccchannel_1_analyzer_1_array_crystal_array_5_xwidth2
#define yheight2 mccchannel_1_analyzer_1_array_crystal_array_5_yheight2
#define visualize mccchannel_1_analyzer_1_array_crystal_array_5_visualize
#define target_index mccchannel_1_analyzer_1_array_crystal_array_5_target_index
#define target_x mccchannel_1_analyzer_1_array_crystal_array_5_target_x
#define target_y mccchannel_1_analyzer_1_array_crystal_array_5_target_y
#define target_z mccchannel_1_analyzer_1_array_crystal_array_5_target_z
#define focus_aw mccchannel_1_analyzer_1_array_crystal_array_5_focus_aw
#define focus_ah mccchannel_1_analyzer_1_array_crystal_array_5_focus_ah
#define focus_xw mccchannel_1_analyzer_1_array_crystal_array_5_focus_xw
#define focus_xh mccchannel_1_analyzer_1_array_crystal_array_5_focus_xh
#define focus_r mccchannel_1_analyzer_1_array_crystal_array_5_focus_r
#define p_interact mccchannel_1_analyzer_1_array_crystal_array_5_p_interact
#define mask_string mccchannel_1_analyzer_1_array_crystal_array_5_mask_string
#define mask_setting mccchannel_1_analyzer_1_array_crystal_array_5_mask_setting
#define number_of_activations mccchannel_1_analyzer_1_array_crystal_array_5_number_of_activations
#line 224 "Union_box.comp"
{
// Initializes the focusing system for this volume including input sanitation.
focus_initialize(&this_box_volume.geometry, POS_A_COMP_INDEX(INDEX_CURRENT_COMP+target_index), POS_A_CURRENT_COMP, ROT_A_CURRENT_COMP, target_index, target_x, target_y, target_z, focus_aw, focus_ah, focus_xw, focus_xh, focus_r, NAME_CURRENT_COMP);

// Input sanitation for this geometry
if (xwidth <= 0) {
  printf("\nERROR in Union_box named %s, the xwidth is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (yheight <= 0) {
  printf("\nERROR in Union_box named %s, yheight is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (zdepth <= 0) {
  printf("\nERROR in Union_box named %s, zdepth is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (xwidth2 <= 0 && xwidth2 != -1) {
  printf("\nERROR in Union_box named %s, the xwidth2 is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (yheight2 <= 0 && yheight2 != -1) {
  printf("\nERROR in Union_box named %s, yheight2 is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}

// Use sanitation
if (global_material_list.num_elements == 0) {
  printf("\nERROR: Need to define a material using Union_make_material before using a Union geometry component. \n");
  printf("       %s was defined before first use of Union_make_material.\n",NAME_CURRENT_COMP);
  exit(1);
}

this_box_volume.geometry.is_masked_volume = 0;
this_box_volume.geometry.is_exit_volume = 0;
this_box_volume.geometry.is_mask_volume = 0;
// check if the volume is a mask, if it is the material string is irelevant.
if (mask_string && strlen(mask_string) && strcmp(mask_string, "NULL") && strcmp(mask_string, "0")) {
    // A mask volume is used to limit the extend of other volumes, called the masked volumes. These are specified in the mask_string.
    // In order for a ray to enter a masked volume, it needs to be both in the region covered by that volume AND the mask volume.
    // When more than
    this_box_volume.geometry.mask_mode = 1; // Default is mask mode is ALL
    if (mask_setting && strlen(mask_setting) && strcmp(mask_setting, "NULL") && strcmp(mask_setting, "0")) {
        if (strcmp(mask_setting,"ALL") == 0 || strcmp(mask_setting,"All") == 0) this_box_volume.geometry.mask_mode = 1;
        else if (strcmp(mask_setting,"ANY") == 0 || strcmp(mask_setting,"Any") == 0) this_box_volume.geometry.mask_mode = 2;
        else {
            printf("The mask_mode of component %s is set to %s, but must be either ALL or ANY.\n",NAME_CURRENT_COMP,mask_setting);
            exit(1);
        }
    }
    
    for (loop_index=0;loop_index<global_geometry_list.num_elements;loop_index++) {
        // Add mask list
        if (1 == manual_linking_function(global_geometry_list.elements[loop_index].name,mask_string)) {
            add_element_to_int_list(&this_box_volume.geometry.mask_list,global_geometry_list.elements[loop_index].component_index);
            add_element_to_int_list(&global_geometry_list.elements[loop_index].Volume->geometry.masked_by_list,INDEX_CURRENT_COMP);
            global_geometry_list.elements[loop_index].Volume->geometry.is_masked_volume = 1;
            if (this_box_volume.geometry.mask_mode == 2)
                global_geometry_list.elements[loop_index].Volume->geometry.mask_mode = 2;
            if (this_box_volume.geometry.mask_mode == 1) {
                if (global_geometry_list.elements[loop_index].Volume->geometry.is_masked_volume == 1 && global_geometry_list.elements[loop_index].Volume->geometry.mask_mode != 2)
                    // If more than one mask is added to one volume, the ANY mode overwrites the (default) ALL mode.
                    global_geometry_list.elements[loop_index].Volume->geometry.mask_mode = 1;
            }
            
            found_geometries = 1;
        }
    }
    if (found_geometries == 0) {
        printf("The mask_string in geometry: %s did not find any of the specified volumes in the mask_string %s \n",NAME_CURRENT_COMP,mask_string);
        exit(1);
    }
    this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
    this_box_volume.p_physics->is_vacuum = 0; // Makes this volume a vacuum
    this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
    this_box_volume.p_physics->my_a = 0; // Should not be used.
    sprintf(this_box_volume.p_physics->name,"Mask");
    this_box_volume.geometry.is_mask_volume = 1;
    
    
// Read the material input, or if it lacks, use automatic linking.
} else if (material_string && strlen(material_string) && strcmp(material_string, "NULL") && strcmp(material_string, "0")) {
    // A geometry string was given, use it to determine which material
    if (0 == strcmp(material_string,"vacuum") || 0 == strcmp(material_string,"Vacuum")) {
        // One could have a global physics struct for vacuum instead of creating one for each
        this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
        this_box_volume.p_physics->is_vacuum = 1; // Makes this volume a vacuum
        this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
        this_box_volume.p_physics->my_a = 0; // Should not be used.
        sprintf(this_box_volume.p_physics->name,"Vacuum");
    } else if (0 == strcmp(material_string,"exit") || 0 == strcmp(material_string,"Exit")) {
        // One could have a global physics struct for vacuum instead of creating one for each
        this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
        this_box_volume.p_physics->is_vacuum = 1; // Makes this volume a vacuum
        this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
        this_box_volume.p_physics->my_a = 0; // Should not be used.
        this_box_volume.geometry.is_exit_volume = 1;
        sprintf(this_box_volume.p_physics->name,"Exit");
    } else {
        #ifndef MATERIAL_DETECTOR
            printf("Need to define a material before refering to it in a geometry %s.\n",NAME_CURRENT_COMP);
            exit(1);
        #endif
        for (loop_index=0;loop_index<global_material_list.num_elements;loop_index++) {
            if (0 == strcmp(material_string,global_material_list.elements[loop_index].name)) {
                this_box_volume.p_physics = global_material_list.elements[loop_index].physics;
                break;
            }
            if (loop_index == global_material_list.num_elements-1) {
            printf("\n");
            printf("ERROR: The material string \"%s\" in Union geometry \"%s\" did not match a specified material. \n",material_string,NAME_CURRENT_COMP);
            printf("       The materials available at this point (need to be defined before the geometry): \n");
            for (loop_index=0;loop_index<global_material_list.num_elements;loop_index++)
              printf("         %s\n",global_material_list.elements[loop_index].name);
            printf("\n");
            printf("       It is also possible to use one of the defualt materials avaiable: \n");
            printf("           Vacuum (for a Volume without scattering or absorption)\n");
            printf("           Exit (for a Volume where the ray exits the component if it enters)\n");
            printf("           Mask (for a Volume that masks existing volumes specified in the mask_string\n");
            exit(1);
          }
        }
    }
} else {
    // Automatic linking, simply using the last defined material.
    #ifndef MATERIAL_DETECTOR
        printf("Need to define a material before the geometry to use automatic linking %s.\n",NAME_CURRENT_COMP);
        exit(1);
    #endif
    this_box_volume.p_physics = global_material_list.elements[global_material_list.num_elements-1].physics;
}

sprintf(this_box_volume.name,NAME_CURRENT_COMP);
sprintf(this_box_volume.geometry.shape,"box");
this_box_volume.geometry.priority_value = priority;
this_box_volume.geometry.geometry_p_interact = p_interact;
// Currently the coordinates will be in absolute space.
this_box_volume.geometry.center = POS_A_CURRENT_COMP;

this_box_storage.z_depth = zdepth;
this_box_storage.x_width1 = xwidth;
this_box_storage.y_height1 = yheight;

this_box_storage.is_rectangle = 0;
if (xwidth2 < 0 && yheight2 < 0) this_box_storage.is_rectangle = 1;
if (xwidth == xwidth2 && yheight == yheight2) this_box_storage.is_rectangle = 1;

if (xwidth2 < 0) {
    this_box_storage.x_width2 = xwidth;
    xwidth2 = xwidth;
} else this_box_storage.x_width2 = xwidth2;

if (yheight2 < 0) {
    this_box_storage.y_height2 = yheight;
    yheight2 = yheight;
} else this_box_storage.y_height2 = yheight2;


this_box_storage.normal_vectors[0] = coords_set(0,0,1);
this_box_storage.normal_vectors[1] = coords_set(0,0,1);

// for sides with y component = 0
x_component = 2*zdepth/sqrt((xwidth-xwidth2)*(xwidth-xwidth2)+4*zdepth*zdepth);
z_component = (xwidth-xwidth2)/sqrt(4*zdepth*zdepth+(xwidth-xwidth2)*(xwidth-xwidth2));

this_box_storage.normal_vectors[2] = coords_set(x_component,0,z_component);
this_box_storage.normal_vectors[3] = coords_set(-x_component,0,z_component);

// for sides with x component = 0
y_component = 2*zdepth/sqrt((yheight-yheight2)*(yheight-yheight2)+4*zdepth*zdepth);
z_component = (yheight-yheight2)/sqrt(4*zdepth*zdepth+(yheight-yheight2)*(yheight-yheight2));

this_box_storage.normal_vectors[4] = coords_set(0,y_component,z_component);
this_box_storage.normal_vectors[5] = coords_set(0,-y_component,z_component);

this_box_volume.geometry.visualization_on = visualize;

this_box_volume.geometry.geometry_parameters.p_box_storage = &this_box_storage;

// Assign pointers to functions for intersection with the shape, checking if a point is inside the shape
if (this_box_storage.is_rectangle == 1) {
this_box_volume.geometry.intersect_function = &sample_box_intersect_simple;
this_box_volume.geometry.within_function = &r_within_box_simple;
}
else {
this_box_volume.geometry.intersect_function = &sample_box_intersect_advanced;
this_box_volume.geometry.within_function = &r_within_box_advanced;
}

this_box_volume.geometry.shell_points = &box_shell_points;
this_box_volume.geometry.mcdisplay_function = &mcdisplay_box_function;
this_box_volume.geometry.initialize_from_main_function = &initialize_box_geometry_from_main_component;
this_box_volume.geometry.process_rot_allocated = 0;

this_box_volume.geometry.copy_geometry_parameters = &allocate_box_storage_copy;

rot_copy(this_box_volume.geometry.rotation_matrix,ROT_A_CURRENT_COMP); //check how ROT_R_CURRENT_COMP would work
rot_transpose(ROT_A_CURRENT_COMP,this_box_volume.geometry.transpose_rotation_matrix);

// Initialize loggers
this_box_volume.loggers.num_elements = 0;

// packing the information into the global_geometry_element, which is then included in the global_geometry_list.
sprintf(global_geometry_element.name,NAME_CURRENT_COMP);
global_geometry_element.activation_counter = number_of_activations;
global_geometry_element.component_index = INDEX_CURRENT_COMP;
global_geometry_element.Volume = &this_box_volume; // Would be nicer if this m was a pointer, now we have the (small) data two places
add_element_to_geometry_list(&global_geometry_list,global_geometry_element);
}
#line 175934 "MACS_sample_kidney_box.c"
#undef number_of_activations
#undef mask_setting
#undef mask_string
#undef p_interact
#undef focus_r
#undef focus_xh
#undef focus_xw
#undef focus_ah
#undef focus_aw
#undef target_z
#undef target_y
#undef target_x
#undef target_index
#undef visualize
#undef yheight2
#undef xwidth2
#undef zdepth
#undef yheight
#undef xwidth
#undef priority
#undef material_string
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

  /* Initializations for component channel_1_analyzer_1_array_crystal_array_6. */
  SIG_MESSAGE("channel_1_analyzer_1_array_crystal_array_6 (Init)");
#define mccompcurname  channel_1_analyzer_1_array_crystal_array_6
#define mccompcurtype  Union_box
#define mccompcurindex 174
#define loop_index mccchannel_1_analyzer_1_array_crystal_array_6_loop_index
#define this_box_volume mccchannel_1_analyzer_1_array_crystal_array_6_this_box_volume
#define global_geometry_element mccchannel_1_analyzer_1_array_crystal_array_6_global_geometry_element
#define this_box_storage mccchannel_1_analyzer_1_array_crystal_array_6_this_box_storage
#define material_string mccchannel_1_analyzer_1_array_crystal_array_6_material_string
#define priority mccchannel_1_analyzer_1_array_crystal_array_6_priority
#define xwidth mccchannel_1_analyzer_1_array_crystal_array_6_xwidth
#define yheight mccchannel_1_analyzer_1_array_crystal_array_6_yheight
#define zdepth mccchannel_1_analyzer_1_array_crystal_array_6_zdepth
#define xwidth2 mccchannel_1_analyzer_1_array_crystal_array_6_xwidth2
#define yheight2 mccchannel_1_analyzer_1_array_crystal_array_6_yheight2
#define visualize mccchannel_1_analyzer_1_array_crystal_array_6_visualize
#define target_index mccchannel_1_analyzer_1_array_crystal_array_6_target_index
#define target_x mccchannel_1_analyzer_1_array_crystal_array_6_target_x
#define target_y mccchannel_1_analyzer_1_array_crystal_array_6_target_y
#define target_z mccchannel_1_analyzer_1_array_crystal_array_6_target_z
#define focus_aw mccchannel_1_analyzer_1_array_crystal_array_6_focus_aw
#define focus_ah mccchannel_1_analyzer_1_array_crystal_array_6_focus_ah
#define focus_xw mccchannel_1_analyzer_1_array_crystal_array_6_focus_xw
#define focus_xh mccchannel_1_analyzer_1_array_crystal_array_6_focus_xh
#define focus_r mccchannel_1_analyzer_1_array_crystal_array_6_focus_r
#define p_interact mccchannel_1_analyzer_1_array_crystal_array_6_p_interact
#define mask_string mccchannel_1_analyzer_1_array_crystal_array_6_mask_string
#define mask_setting mccchannel_1_analyzer_1_array_crystal_array_6_mask_setting
#define number_of_activations mccchannel_1_analyzer_1_array_crystal_array_6_number_of_activations
#line 224 "Union_box.comp"
{
// Initializes the focusing system for this volume including input sanitation.
focus_initialize(&this_box_volume.geometry, POS_A_COMP_INDEX(INDEX_CURRENT_COMP+target_index), POS_A_CURRENT_COMP, ROT_A_CURRENT_COMP, target_index, target_x, target_y, target_z, focus_aw, focus_ah, focus_xw, focus_xh, focus_r, NAME_CURRENT_COMP);

// Input sanitation for this geometry
if (xwidth <= 0) {
  printf("\nERROR in Union_box named %s, the xwidth is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (yheight <= 0) {
  printf("\nERROR in Union_box named %s, yheight is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (zdepth <= 0) {
  printf("\nERROR in Union_box named %s, zdepth is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (xwidth2 <= 0 && xwidth2 != -1) {
  printf("\nERROR in Union_box named %s, the xwidth2 is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (yheight2 <= 0 && yheight2 != -1) {
  printf("\nERROR in Union_box named %s, yheight2 is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}

// Use sanitation
if (global_material_list.num_elements == 0) {
  printf("\nERROR: Need to define a material using Union_make_material before using a Union geometry component. \n");
  printf("       %s was defined before first use of Union_make_material.\n",NAME_CURRENT_COMP);
  exit(1);
}

this_box_volume.geometry.is_masked_volume = 0;
this_box_volume.geometry.is_exit_volume = 0;
this_box_volume.geometry.is_mask_volume = 0;
// check if the volume is a mask, if it is the material string is irelevant.
if (mask_string && strlen(mask_string) && strcmp(mask_string, "NULL") && strcmp(mask_string, "0")) {
    // A mask volume is used to limit the extend of other volumes, called the masked volumes. These are specified in the mask_string.
    // In order for a ray to enter a masked volume, it needs to be both in the region covered by that volume AND the mask volume.
    // When more than
    this_box_volume.geometry.mask_mode = 1; // Default is mask mode is ALL
    if (mask_setting && strlen(mask_setting) && strcmp(mask_setting, "NULL") && strcmp(mask_setting, "0")) {
        if (strcmp(mask_setting,"ALL") == 0 || strcmp(mask_setting,"All") == 0) this_box_volume.geometry.mask_mode = 1;
        else if (strcmp(mask_setting,"ANY") == 0 || strcmp(mask_setting,"Any") == 0) this_box_volume.geometry.mask_mode = 2;
        else {
            printf("The mask_mode of component %s is set to %s, but must be either ALL or ANY.\n",NAME_CURRENT_COMP,mask_setting);
            exit(1);
        }
    }
    
    for (loop_index=0;loop_index<global_geometry_list.num_elements;loop_index++) {
        // Add mask list
        if (1 == manual_linking_function(global_geometry_list.elements[loop_index].name,mask_string)) {
            add_element_to_int_list(&this_box_volume.geometry.mask_list,global_geometry_list.elements[loop_index].component_index);
            add_element_to_int_list(&global_geometry_list.elements[loop_index].Volume->geometry.masked_by_list,INDEX_CURRENT_COMP);
            global_geometry_list.elements[loop_index].Volume->geometry.is_masked_volume = 1;
            if (this_box_volume.geometry.mask_mode == 2)
                global_geometry_list.elements[loop_index].Volume->geometry.mask_mode = 2;
            if (this_box_volume.geometry.mask_mode == 1) {
                if (global_geometry_list.elements[loop_index].Volume->geometry.is_masked_volume == 1 && global_geometry_list.elements[loop_index].Volume->geometry.mask_mode != 2)
                    // If more than one mask is added to one volume, the ANY mode overwrites the (default) ALL mode.
                    global_geometry_list.elements[loop_index].Volume->geometry.mask_mode = 1;
            }
            
            found_geometries = 1;
        }
    }
    if (found_geometries == 0) {
        printf("The mask_string in geometry: %s did not find any of the specified volumes in the mask_string %s \n",NAME_CURRENT_COMP,mask_string);
        exit(1);
    }
    this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
    this_box_volume.p_physics->is_vacuum = 0; // Makes this volume a vacuum
    this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
    this_box_volume.p_physics->my_a = 0; // Should not be used.
    sprintf(this_box_volume.p_physics->name,"Mask");
    this_box_volume.geometry.is_mask_volume = 1;
    
    
// Read the material input, or if it lacks, use automatic linking.
} else if (material_string && strlen(material_string) && strcmp(material_string, "NULL") && strcmp(material_string, "0")) {
    // A geometry string was given, use it to determine which material
    if (0 == strcmp(material_string,"vacuum") || 0 == strcmp(material_string,"Vacuum")) {
        // One could have a global physics struct for vacuum instead of creating one for each
        this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
        this_box_volume.p_physics->is_vacuum = 1; // Makes this volume a vacuum
        this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
        this_box_volume.p_physics->my_a = 0; // Should not be used.
        sprintf(this_box_volume.p_physics->name,"Vacuum");
    } else if (0 == strcmp(material_string,"exit") || 0 == strcmp(material_string,"Exit")) {
        // One could have a global physics struct for vacuum instead of creating one for each
        this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
        this_box_volume.p_physics->is_vacuum = 1; // Makes this volume a vacuum
        this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
        this_box_volume.p_physics->my_a = 0; // Should not be used.
        this_box_volume.geometry.is_exit_volume = 1;
        sprintf(this_box_volume.p_physics->name,"Exit");
    } else {
        #ifndef MATERIAL_DETECTOR
            printf("Need to define a material before refering to it in a geometry %s.\n",NAME_CURRENT_COMP);
            exit(1);
        #endif
        for (loop_index=0;loop_index<global_material_list.num_elements;loop_index++) {
            if (0 == strcmp(material_string,global_material_list.elements[loop_index].name)) {
                this_box_volume.p_physics = global_material_list.elements[loop_index].physics;
                break;
            }
            if (loop_index == global_material_list.num_elements-1) {
            printf("\n");
            printf("ERROR: The material string \"%s\" in Union geometry \"%s\" did not match a specified material. \n",material_string,NAME_CURRENT_COMP);
            printf("       The materials available at this point (need to be defined before the geometry): \n");
            for (loop_index=0;loop_index<global_material_list.num_elements;loop_index++)
              printf("         %s\n",global_material_list.elements[loop_index].name);
            printf("\n");
            printf("       It is also possible to use one of the defualt materials avaiable: \n");
            printf("           Vacuum (for a Volume without scattering or absorption)\n");
            printf("           Exit (for a Volume where the ray exits the component if it enters)\n");
            printf("           Mask (for a Volume that masks existing volumes specified in the mask_string\n");
            exit(1);
          }
        }
    }
} else {
    // Automatic linking, simply using the last defined material.
    #ifndef MATERIAL_DETECTOR
        printf("Need to define a material before the geometry to use automatic linking %s.\n",NAME_CURRENT_COMP);
        exit(1);
    #endif
    this_box_volume.p_physics = global_material_list.elements[global_material_list.num_elements-1].physics;
}

sprintf(this_box_volume.name,NAME_CURRENT_COMP);
sprintf(this_box_volume.geometry.shape,"box");
this_box_volume.geometry.priority_value = priority;
this_box_volume.geometry.geometry_p_interact = p_interact;
// Currently the coordinates will be in absolute space.
this_box_volume.geometry.center = POS_A_CURRENT_COMP;

this_box_storage.z_depth = zdepth;
this_box_storage.x_width1 = xwidth;
this_box_storage.y_height1 = yheight;

this_box_storage.is_rectangle = 0;
if (xwidth2 < 0 && yheight2 < 0) this_box_storage.is_rectangle = 1;
if (xwidth == xwidth2 && yheight == yheight2) this_box_storage.is_rectangle = 1;

if (xwidth2 < 0) {
    this_box_storage.x_width2 = xwidth;
    xwidth2 = xwidth;
} else this_box_storage.x_width2 = xwidth2;

if (yheight2 < 0) {
    this_box_storage.y_height2 = yheight;
    yheight2 = yheight;
} else this_box_storage.y_height2 = yheight2;


this_box_storage.normal_vectors[0] = coords_set(0,0,1);
this_box_storage.normal_vectors[1] = coords_set(0,0,1);

// for sides with y component = 0
x_component = 2*zdepth/sqrt((xwidth-xwidth2)*(xwidth-xwidth2)+4*zdepth*zdepth);
z_component = (xwidth-xwidth2)/sqrt(4*zdepth*zdepth+(xwidth-xwidth2)*(xwidth-xwidth2));

this_box_storage.normal_vectors[2] = coords_set(x_component,0,z_component);
this_box_storage.normal_vectors[3] = coords_set(-x_component,0,z_component);

// for sides with x component = 0
y_component = 2*zdepth/sqrt((yheight-yheight2)*(yheight-yheight2)+4*zdepth*zdepth);
z_component = (yheight-yheight2)/sqrt(4*zdepth*zdepth+(yheight-yheight2)*(yheight-yheight2));

this_box_storage.normal_vectors[4] = coords_set(0,y_component,z_component);
this_box_storage.normal_vectors[5] = coords_set(0,-y_component,z_component);

this_box_volume.geometry.visualization_on = visualize;

this_box_volume.geometry.geometry_parameters.p_box_storage = &this_box_storage;

// Assign pointers to functions for intersection with the shape, checking if a point is inside the shape
if (this_box_storage.is_rectangle == 1) {
this_box_volume.geometry.intersect_function = &sample_box_intersect_simple;
this_box_volume.geometry.within_function = &r_within_box_simple;
}
else {
this_box_volume.geometry.intersect_function = &sample_box_intersect_advanced;
this_box_volume.geometry.within_function = &r_within_box_advanced;
}

this_box_volume.geometry.shell_points = &box_shell_points;
this_box_volume.geometry.mcdisplay_function = &mcdisplay_box_function;
this_box_volume.geometry.initialize_from_main_function = &initialize_box_geometry_from_main_component;
this_box_volume.geometry.process_rot_allocated = 0;

this_box_volume.geometry.copy_geometry_parameters = &allocate_box_storage_copy;

rot_copy(this_box_volume.geometry.rotation_matrix,ROT_A_CURRENT_COMP); //check how ROT_R_CURRENT_COMP would work
rot_transpose(ROT_A_CURRENT_COMP,this_box_volume.geometry.transpose_rotation_matrix);

// Initialize loggers
this_box_volume.loggers.num_elements = 0;

// packing the information into the global_geometry_element, which is then included in the global_geometry_list.
sprintf(global_geometry_element.name,NAME_CURRENT_COMP);
global_geometry_element.activation_counter = number_of_activations;
global_geometry_element.component_index = INDEX_CURRENT_COMP;
global_geometry_element.Volume = &this_box_volume; // Would be nicer if this m was a pointer, now we have the (small) data two places
add_element_to_geometry_list(&global_geometry_list,global_geometry_element);
}
#line 176204 "MACS_sample_kidney_box.c"
#undef number_of_activations
#undef mask_setting
#undef mask_string
#undef p_interact
#undef focus_r
#undef focus_xh
#undef focus_xw
#undef focus_ah
#undef focus_aw
#undef target_z
#undef target_y
#undef target_x
#undef target_index
#undef visualize
#undef yheight2
#undef xwidth2
#undef zdepth
#undef yheight
#undef xwidth
#undef priority
#undef material_string
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

  /* Initializations for component channel_1_analyzer_1_array_crystal_array_7. */
  SIG_MESSAGE("channel_1_analyzer_1_array_crystal_array_7 (Init)");
#define mccompcurname  channel_1_analyzer_1_array_crystal_array_7
#define mccompcurtype  Union_box
#define mccompcurindex 175
#define loop_index mccchannel_1_analyzer_1_array_crystal_array_7_loop_index
#define this_box_volume mccchannel_1_analyzer_1_array_crystal_array_7_this_box_volume
#define global_geometry_element mccchannel_1_analyzer_1_array_crystal_array_7_global_geometry_element
#define this_box_storage mccchannel_1_analyzer_1_array_crystal_array_7_this_box_storage
#define material_string mccchannel_1_analyzer_1_array_crystal_array_7_material_string
#define priority mccchannel_1_analyzer_1_array_crystal_array_7_priority
#define xwidth mccchannel_1_analyzer_1_array_crystal_array_7_xwidth
#define yheight mccchannel_1_analyzer_1_array_crystal_array_7_yheight
#define zdepth mccchannel_1_analyzer_1_array_crystal_array_7_zdepth
#define xwidth2 mccchannel_1_analyzer_1_array_crystal_array_7_xwidth2
#define yheight2 mccchannel_1_analyzer_1_array_crystal_array_7_yheight2
#define visualize mccchannel_1_analyzer_1_array_crystal_array_7_visualize
#define target_index mccchannel_1_analyzer_1_array_crystal_array_7_target_index
#define target_x mccchannel_1_analyzer_1_array_crystal_array_7_target_x
#define target_y mccchannel_1_analyzer_1_array_crystal_array_7_target_y
#define target_z mccchannel_1_analyzer_1_array_crystal_array_7_target_z
#define focus_aw mccchannel_1_analyzer_1_array_crystal_array_7_focus_aw
#define focus_ah mccchannel_1_analyzer_1_array_crystal_array_7_focus_ah
#define focus_xw mccchannel_1_analyzer_1_array_crystal_array_7_focus_xw
#define focus_xh mccchannel_1_analyzer_1_array_crystal_array_7_focus_xh
#define focus_r mccchannel_1_analyzer_1_array_crystal_array_7_focus_r
#define p_interact mccchannel_1_analyzer_1_array_crystal_array_7_p_interact
#define mask_string mccchannel_1_analyzer_1_array_crystal_array_7_mask_string
#define mask_setting mccchannel_1_analyzer_1_array_crystal_array_7_mask_setting
#define number_of_activations mccchannel_1_analyzer_1_array_crystal_array_7_number_of_activations
#line 224 "Union_box.comp"
{
// Initializes the focusing system for this volume including input sanitation.
focus_initialize(&this_box_volume.geometry, POS_A_COMP_INDEX(INDEX_CURRENT_COMP+target_index), POS_A_CURRENT_COMP, ROT_A_CURRENT_COMP, target_index, target_x, target_y, target_z, focus_aw, focus_ah, focus_xw, focus_xh, focus_r, NAME_CURRENT_COMP);

// Input sanitation for this geometry
if (xwidth <= 0) {
  printf("\nERROR in Union_box named %s, the xwidth is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (yheight <= 0) {
  printf("\nERROR in Union_box named %s, yheight is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (zdepth <= 0) {
  printf("\nERROR in Union_box named %s, zdepth is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (xwidth2 <= 0 && xwidth2 != -1) {
  printf("\nERROR in Union_box named %s, the xwidth2 is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (yheight2 <= 0 && yheight2 != -1) {
  printf("\nERROR in Union_box named %s, yheight2 is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}

// Use sanitation
if (global_material_list.num_elements == 0) {
  printf("\nERROR: Need to define a material using Union_make_material before using a Union geometry component. \n");
  printf("       %s was defined before first use of Union_make_material.\n",NAME_CURRENT_COMP);
  exit(1);
}

this_box_volume.geometry.is_masked_volume = 0;
this_box_volume.geometry.is_exit_volume = 0;
this_box_volume.geometry.is_mask_volume = 0;
// check if the volume is a mask, if it is the material string is irelevant.
if (mask_string && strlen(mask_string) && strcmp(mask_string, "NULL") && strcmp(mask_string, "0")) {
    // A mask volume is used to limit the extend of other volumes, called the masked volumes. These are specified in the mask_string.
    // In order for a ray to enter a masked volume, it needs to be both in the region covered by that volume AND the mask volume.
    // When more than
    this_box_volume.geometry.mask_mode = 1; // Default is mask mode is ALL
    if (mask_setting && strlen(mask_setting) && strcmp(mask_setting, "NULL") && strcmp(mask_setting, "0")) {
        if (strcmp(mask_setting,"ALL") == 0 || strcmp(mask_setting,"All") == 0) this_box_volume.geometry.mask_mode = 1;
        else if (strcmp(mask_setting,"ANY") == 0 || strcmp(mask_setting,"Any") == 0) this_box_volume.geometry.mask_mode = 2;
        else {
            printf("The mask_mode of component %s is set to %s, but must be either ALL or ANY.\n",NAME_CURRENT_COMP,mask_setting);
            exit(1);
        }
    }
    
    for (loop_index=0;loop_index<global_geometry_list.num_elements;loop_index++) {
        // Add mask list
        if (1 == manual_linking_function(global_geometry_list.elements[loop_index].name,mask_string)) {
            add_element_to_int_list(&this_box_volume.geometry.mask_list,global_geometry_list.elements[loop_index].component_index);
            add_element_to_int_list(&global_geometry_list.elements[loop_index].Volume->geometry.masked_by_list,INDEX_CURRENT_COMP);
            global_geometry_list.elements[loop_index].Volume->geometry.is_masked_volume = 1;
            if (this_box_volume.geometry.mask_mode == 2)
                global_geometry_list.elements[loop_index].Volume->geometry.mask_mode = 2;
            if (this_box_volume.geometry.mask_mode == 1) {
                if (global_geometry_list.elements[loop_index].Volume->geometry.is_masked_volume == 1 && global_geometry_list.elements[loop_index].Volume->geometry.mask_mode != 2)
                    // If more than one mask is added to one volume, the ANY mode overwrites the (default) ALL mode.
                    global_geometry_list.elements[loop_index].Volume->geometry.mask_mode = 1;
            }
            
            found_geometries = 1;
        }
    }
    if (found_geometries == 0) {
        printf("The mask_string in geometry: %s did not find any of the specified volumes in the mask_string %s \n",NAME_CURRENT_COMP,mask_string);
        exit(1);
    }
    this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
    this_box_volume.p_physics->is_vacuum = 0; // Makes this volume a vacuum
    this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
    this_box_volume.p_physics->my_a = 0; // Should not be used.
    sprintf(this_box_volume.p_physics->name,"Mask");
    this_box_volume.geometry.is_mask_volume = 1;
    
    
// Read the material input, or if it lacks, use automatic linking.
} else if (material_string && strlen(material_string) && strcmp(material_string, "NULL") && strcmp(material_string, "0")) {
    // A geometry string was given, use it to determine which material
    if (0 == strcmp(material_string,"vacuum") || 0 == strcmp(material_string,"Vacuum")) {
        // One could have a global physics struct for vacuum instead of creating one for each
        this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
        this_box_volume.p_physics->is_vacuum = 1; // Makes this volume a vacuum
        this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
        this_box_volume.p_physics->my_a = 0; // Should not be used.
        sprintf(this_box_volume.p_physics->name,"Vacuum");
    } else if (0 == strcmp(material_string,"exit") || 0 == strcmp(material_string,"Exit")) {
        // One could have a global physics struct for vacuum instead of creating one for each
        this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
        this_box_volume.p_physics->is_vacuum = 1; // Makes this volume a vacuum
        this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
        this_box_volume.p_physics->my_a = 0; // Should not be used.
        this_box_volume.geometry.is_exit_volume = 1;
        sprintf(this_box_volume.p_physics->name,"Exit");
    } else {
        #ifndef MATERIAL_DETECTOR
            printf("Need to define a material before refering to it in a geometry %s.\n",NAME_CURRENT_COMP);
            exit(1);
        #endif
        for (loop_index=0;loop_index<global_material_list.num_elements;loop_index++) {
            if (0 == strcmp(material_string,global_material_list.elements[loop_index].name)) {
                this_box_volume.p_physics = global_material_list.elements[loop_index].physics;
                break;
            }
            if (loop_index == global_material_list.num_elements-1) {
            printf("\n");
            printf("ERROR: The material string \"%s\" in Union geometry \"%s\" did not match a specified material. \n",material_string,NAME_CURRENT_COMP);
            printf("       The materials available at this point (need to be defined before the geometry): \n");
            for (loop_index=0;loop_index<global_material_list.num_elements;loop_index++)
              printf("         %s\n",global_material_list.elements[loop_index].name);
            printf("\n");
            printf("       It is also possible to use one of the defualt materials avaiable: \n");
            printf("           Vacuum (for a Volume without scattering or absorption)\n");
            printf("           Exit (for a Volume where the ray exits the component if it enters)\n");
            printf("           Mask (for a Volume that masks existing volumes specified in the mask_string\n");
            exit(1);
          }
        }
    }
} else {
    // Automatic linking, simply using the last defined material.
    #ifndef MATERIAL_DETECTOR
        printf("Need to define a material before the geometry to use automatic linking %s.\n",NAME_CURRENT_COMP);
        exit(1);
    #endif
    this_box_volume.p_physics = global_material_list.elements[global_material_list.num_elements-1].physics;
}

sprintf(this_box_volume.name,NAME_CURRENT_COMP);
sprintf(this_box_volume.geometry.shape,"box");
this_box_volume.geometry.priority_value = priority;
this_box_volume.geometry.geometry_p_interact = p_interact;
// Currently the coordinates will be in absolute space.
this_box_volume.geometry.center = POS_A_CURRENT_COMP;

this_box_storage.z_depth = zdepth;
this_box_storage.x_width1 = xwidth;
this_box_storage.y_height1 = yheight;

this_box_storage.is_rectangle = 0;
if (xwidth2 < 0 && yheight2 < 0) this_box_storage.is_rectangle = 1;
if (xwidth == xwidth2 && yheight == yheight2) this_box_storage.is_rectangle = 1;

if (xwidth2 < 0) {
    this_box_storage.x_width2 = xwidth;
    xwidth2 = xwidth;
} else this_box_storage.x_width2 = xwidth2;

if (yheight2 < 0) {
    this_box_storage.y_height2 = yheight;
    yheight2 = yheight;
} else this_box_storage.y_height2 = yheight2;


this_box_storage.normal_vectors[0] = coords_set(0,0,1);
this_box_storage.normal_vectors[1] = coords_set(0,0,1);

// for sides with y component = 0
x_component = 2*zdepth/sqrt((xwidth-xwidth2)*(xwidth-xwidth2)+4*zdepth*zdepth);
z_component = (xwidth-xwidth2)/sqrt(4*zdepth*zdepth+(xwidth-xwidth2)*(xwidth-xwidth2));

this_box_storage.normal_vectors[2] = coords_set(x_component,0,z_component);
this_box_storage.normal_vectors[3] = coords_set(-x_component,0,z_component);

// for sides with x component = 0
y_component = 2*zdepth/sqrt((yheight-yheight2)*(yheight-yheight2)+4*zdepth*zdepth);
z_component = (yheight-yheight2)/sqrt(4*zdepth*zdepth+(yheight-yheight2)*(yheight-yheight2));

this_box_storage.normal_vectors[4] = coords_set(0,y_component,z_component);
this_box_storage.normal_vectors[5] = coords_set(0,-y_component,z_component);

this_box_volume.geometry.visualization_on = visualize;

this_box_volume.geometry.geometry_parameters.p_box_storage = &this_box_storage;

// Assign pointers to functions for intersection with the shape, checking if a point is inside the shape
if (this_box_storage.is_rectangle == 1) {
this_box_volume.geometry.intersect_function = &sample_box_intersect_simple;
this_box_volume.geometry.within_function = &r_within_box_simple;
}
else {
this_box_volume.geometry.intersect_function = &sample_box_intersect_advanced;
this_box_volume.geometry.within_function = &r_within_box_advanced;
}

this_box_volume.geometry.shell_points = &box_shell_points;
this_box_volume.geometry.mcdisplay_function = &mcdisplay_box_function;
this_box_volume.geometry.initialize_from_main_function = &initialize_box_geometry_from_main_component;
this_box_volume.geometry.process_rot_allocated = 0;

this_box_volume.geometry.copy_geometry_parameters = &allocate_box_storage_copy;

rot_copy(this_box_volume.geometry.rotation_matrix,ROT_A_CURRENT_COMP); //check how ROT_R_CURRENT_COMP would work
rot_transpose(ROT_A_CURRENT_COMP,this_box_volume.geometry.transpose_rotation_matrix);

// Initialize loggers
this_box_volume.loggers.num_elements = 0;

// packing the information into the global_geometry_element, which is then included in the global_geometry_list.
sprintf(global_geometry_element.name,NAME_CURRENT_COMP);
global_geometry_element.activation_counter = number_of_activations;
global_geometry_element.component_index = INDEX_CURRENT_COMP;
global_geometry_element.Volume = &this_box_volume; // Would be nicer if this m was a pointer, now we have the (small) data two places
add_element_to_geometry_list(&global_geometry_list,global_geometry_element);
}
#line 176474 "MACS_sample_kidney_box.c"
#undef number_of_activations
#undef mask_setting
#undef mask_string
#undef p_interact
#undef focus_r
#undef focus_xh
#undef focus_xw
#undef focus_ah
#undef focus_aw
#undef target_z
#undef target_y
#undef target_x
#undef target_index
#undef visualize
#undef yheight2
#undef xwidth2
#undef zdepth
#undef yheight
#undef xwidth
#undef priority
#undef material_string
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

  /* Initializations for component channel_1_analyzer_1_array_crystal_array_8. */
  SIG_MESSAGE("channel_1_analyzer_1_array_crystal_array_8 (Init)");
#define mccompcurname  channel_1_analyzer_1_array_crystal_array_8
#define mccompcurtype  Union_box
#define mccompcurindex 176
#define loop_index mccchannel_1_analyzer_1_array_crystal_array_8_loop_index
#define this_box_volume mccchannel_1_analyzer_1_array_crystal_array_8_this_box_volume
#define global_geometry_element mccchannel_1_analyzer_1_array_crystal_array_8_global_geometry_element
#define this_box_storage mccchannel_1_analyzer_1_array_crystal_array_8_this_box_storage
#define material_string mccchannel_1_analyzer_1_array_crystal_array_8_material_string
#define priority mccchannel_1_analyzer_1_array_crystal_array_8_priority
#define xwidth mccchannel_1_analyzer_1_array_crystal_array_8_xwidth
#define yheight mccchannel_1_analyzer_1_array_crystal_array_8_yheight
#define zdepth mccchannel_1_analyzer_1_array_crystal_array_8_zdepth
#define xwidth2 mccchannel_1_analyzer_1_array_crystal_array_8_xwidth2
#define yheight2 mccchannel_1_analyzer_1_array_crystal_array_8_yheight2
#define visualize mccchannel_1_analyzer_1_array_crystal_array_8_visualize
#define target_index mccchannel_1_analyzer_1_array_crystal_array_8_target_index
#define target_x mccchannel_1_analyzer_1_array_crystal_array_8_target_x
#define target_y mccchannel_1_analyzer_1_array_crystal_array_8_target_y
#define target_z mccchannel_1_analyzer_1_array_crystal_array_8_target_z
#define focus_aw mccchannel_1_analyzer_1_array_crystal_array_8_focus_aw
#define focus_ah mccchannel_1_analyzer_1_array_crystal_array_8_focus_ah
#define focus_xw mccchannel_1_analyzer_1_array_crystal_array_8_focus_xw
#define focus_xh mccchannel_1_analyzer_1_array_crystal_array_8_focus_xh
#define focus_r mccchannel_1_analyzer_1_array_crystal_array_8_focus_r
#define p_interact mccchannel_1_analyzer_1_array_crystal_array_8_p_interact
#define mask_string mccchannel_1_analyzer_1_array_crystal_array_8_mask_string
#define mask_setting mccchannel_1_analyzer_1_array_crystal_array_8_mask_setting
#define number_of_activations mccchannel_1_analyzer_1_array_crystal_array_8_number_of_activations
#line 224 "Union_box.comp"
{
// Initializes the focusing system for this volume including input sanitation.
focus_initialize(&this_box_volume.geometry, POS_A_COMP_INDEX(INDEX_CURRENT_COMP+target_index), POS_A_CURRENT_COMP, ROT_A_CURRENT_COMP, target_index, target_x, target_y, target_z, focus_aw, focus_ah, focus_xw, focus_xh, focus_r, NAME_CURRENT_COMP);

// Input sanitation for this geometry
if (xwidth <= 0) {
  printf("\nERROR in Union_box named %s, the xwidth is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (yheight <= 0) {
  printf("\nERROR in Union_box named %s, yheight is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (zdepth <= 0) {
  printf("\nERROR in Union_box named %s, zdepth is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (xwidth2 <= 0 && xwidth2 != -1) {
  printf("\nERROR in Union_box named %s, the xwidth2 is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (yheight2 <= 0 && yheight2 != -1) {
  printf("\nERROR in Union_box named %s, yheight2 is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}

// Use sanitation
if (global_material_list.num_elements == 0) {
  printf("\nERROR: Need to define a material using Union_make_material before using a Union geometry component. \n");
  printf("       %s was defined before first use of Union_make_material.\n",NAME_CURRENT_COMP);
  exit(1);
}

this_box_volume.geometry.is_masked_volume = 0;
this_box_volume.geometry.is_exit_volume = 0;
this_box_volume.geometry.is_mask_volume = 0;
// check if the volume is a mask, if it is the material string is irelevant.
if (mask_string && strlen(mask_string) && strcmp(mask_string, "NULL") && strcmp(mask_string, "0")) {
    // A mask volume is used to limit the extend of other volumes, called the masked volumes. These are specified in the mask_string.
    // In order for a ray to enter a masked volume, it needs to be both in the region covered by that volume AND the mask volume.
    // When more than
    this_box_volume.geometry.mask_mode = 1; // Default is mask mode is ALL
    if (mask_setting && strlen(mask_setting) && strcmp(mask_setting, "NULL") && strcmp(mask_setting, "0")) {
        if (strcmp(mask_setting,"ALL") == 0 || strcmp(mask_setting,"All") == 0) this_box_volume.geometry.mask_mode = 1;
        else if (strcmp(mask_setting,"ANY") == 0 || strcmp(mask_setting,"Any") == 0) this_box_volume.geometry.mask_mode = 2;
        else {
            printf("The mask_mode of component %s is set to %s, but must be either ALL or ANY.\n",NAME_CURRENT_COMP,mask_setting);
            exit(1);
        }
    }
    
    for (loop_index=0;loop_index<global_geometry_list.num_elements;loop_index++) {
        // Add mask list
        if (1 == manual_linking_function(global_geometry_list.elements[loop_index].name,mask_string)) {
            add_element_to_int_list(&this_box_volume.geometry.mask_list,global_geometry_list.elements[loop_index].component_index);
            add_element_to_int_list(&global_geometry_list.elements[loop_index].Volume->geometry.masked_by_list,INDEX_CURRENT_COMP);
            global_geometry_list.elements[loop_index].Volume->geometry.is_masked_volume = 1;
            if (this_box_volume.geometry.mask_mode == 2)
                global_geometry_list.elements[loop_index].Volume->geometry.mask_mode = 2;
            if (this_box_volume.geometry.mask_mode == 1) {
                if (global_geometry_list.elements[loop_index].Volume->geometry.is_masked_volume == 1 && global_geometry_list.elements[loop_index].Volume->geometry.mask_mode != 2)
                    // If more than one mask is added to one volume, the ANY mode overwrites the (default) ALL mode.
                    global_geometry_list.elements[loop_index].Volume->geometry.mask_mode = 1;
            }
            
            found_geometries = 1;
        }
    }
    if (found_geometries == 0) {
        printf("The mask_string in geometry: %s did not find any of the specified volumes in the mask_string %s \n",NAME_CURRENT_COMP,mask_string);
        exit(1);
    }
    this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
    this_box_volume.p_physics->is_vacuum = 0; // Makes this volume a vacuum
    this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
    this_box_volume.p_physics->my_a = 0; // Should not be used.
    sprintf(this_box_volume.p_physics->name,"Mask");
    this_box_volume.geometry.is_mask_volume = 1;
    
    
// Read the material input, or if it lacks, use automatic linking.
} else if (material_string && strlen(material_string) && strcmp(material_string, "NULL") && strcmp(material_string, "0")) {
    // A geometry string was given, use it to determine which material
    if (0 == strcmp(material_string,"vacuum") || 0 == strcmp(material_string,"Vacuum")) {
        // One could have a global physics struct for vacuum instead of creating one for each
        this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
        this_box_volume.p_physics->is_vacuum = 1; // Makes this volume a vacuum
        this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
        this_box_volume.p_physics->my_a = 0; // Should not be used.
        sprintf(this_box_volume.p_physics->name,"Vacuum");
    } else if (0 == strcmp(material_string,"exit") || 0 == strcmp(material_string,"Exit")) {
        // One could have a global physics struct for vacuum instead of creating one for each
        this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
        this_box_volume.p_physics->is_vacuum = 1; // Makes this volume a vacuum
        this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
        this_box_volume.p_physics->my_a = 0; // Should not be used.
        this_box_volume.geometry.is_exit_volume = 1;
        sprintf(this_box_volume.p_physics->name,"Exit");
    } else {
        #ifndef MATERIAL_DETECTOR
            printf("Need to define a material before refering to it in a geometry %s.\n",NAME_CURRENT_COMP);
            exit(1);
        #endif
        for (loop_index=0;loop_index<global_material_list.num_elements;loop_index++) {
            if (0 == strcmp(material_string,global_material_list.elements[loop_index].name)) {
                this_box_volume.p_physics = global_material_list.elements[loop_index].physics;
                break;
            }
            if (loop_index == global_material_list.num_elements-1) {
            printf("\n");
            printf("ERROR: The material string \"%s\" in Union geometry \"%s\" did not match a specified material. \n",material_string,NAME_CURRENT_COMP);
            printf("       The materials available at this point (need to be defined before the geometry): \n");
            for (loop_index=0;loop_index<global_material_list.num_elements;loop_index++)
              printf("         %s\n",global_material_list.elements[loop_index].name);
            printf("\n");
            printf("       It is also possible to use one of the defualt materials avaiable: \n");
            printf("           Vacuum (for a Volume without scattering or absorption)\n");
            printf("           Exit (for a Volume where the ray exits the component if it enters)\n");
            printf("           Mask (for a Volume that masks existing volumes specified in the mask_string\n");
            exit(1);
          }
        }
    }
} else {
    // Automatic linking, simply using the last defined material.
    #ifndef MATERIAL_DETECTOR
        printf("Need to define a material before the geometry to use automatic linking %s.\n",NAME_CURRENT_COMP);
        exit(1);
    #endif
    this_box_volume.p_physics = global_material_list.elements[global_material_list.num_elements-1].physics;
}

sprintf(this_box_volume.name,NAME_CURRENT_COMP);
sprintf(this_box_volume.geometry.shape,"box");
this_box_volume.geometry.priority_value = priority;
this_box_volume.geometry.geometry_p_interact = p_interact;
// Currently the coordinates will be in absolute space.
this_box_volume.geometry.center = POS_A_CURRENT_COMP;

this_box_storage.z_depth = zdepth;
this_box_storage.x_width1 = xwidth;
this_box_storage.y_height1 = yheight;

this_box_storage.is_rectangle = 0;
if (xwidth2 < 0 && yheight2 < 0) this_box_storage.is_rectangle = 1;
if (xwidth == xwidth2 && yheight == yheight2) this_box_storage.is_rectangle = 1;

if (xwidth2 < 0) {
    this_box_storage.x_width2 = xwidth;
    xwidth2 = xwidth;
} else this_box_storage.x_width2 = xwidth2;

if (yheight2 < 0) {
    this_box_storage.y_height2 = yheight;
    yheight2 = yheight;
} else this_box_storage.y_height2 = yheight2;


this_box_storage.normal_vectors[0] = coords_set(0,0,1);
this_box_storage.normal_vectors[1] = coords_set(0,0,1);

// for sides with y component = 0
x_component = 2*zdepth/sqrt((xwidth-xwidth2)*(xwidth-xwidth2)+4*zdepth*zdepth);
z_component = (xwidth-xwidth2)/sqrt(4*zdepth*zdepth+(xwidth-xwidth2)*(xwidth-xwidth2));

this_box_storage.normal_vectors[2] = coords_set(x_component,0,z_component);
this_box_storage.normal_vectors[3] = coords_set(-x_component,0,z_component);

// for sides with x component = 0
y_component = 2*zdepth/sqrt((yheight-yheight2)*(yheight-yheight2)+4*zdepth*zdepth);
z_component = (yheight-yheight2)/sqrt(4*zdepth*zdepth+(yheight-yheight2)*(yheight-yheight2));

this_box_storage.normal_vectors[4] = coords_set(0,y_component,z_component);
this_box_storage.normal_vectors[5] = coords_set(0,-y_component,z_component);

this_box_volume.geometry.visualization_on = visualize;

this_box_volume.geometry.geometry_parameters.p_box_storage = &this_box_storage;

// Assign pointers to functions for intersection with the shape, checking if a point is inside the shape
if (this_box_storage.is_rectangle == 1) {
this_box_volume.geometry.intersect_function = &sample_box_intersect_simple;
this_box_volume.geometry.within_function = &r_within_box_simple;
}
else {
this_box_volume.geometry.intersect_function = &sample_box_intersect_advanced;
this_box_volume.geometry.within_function = &r_within_box_advanced;
}

this_box_volume.geometry.shell_points = &box_shell_points;
this_box_volume.geometry.mcdisplay_function = &mcdisplay_box_function;
this_box_volume.geometry.initialize_from_main_function = &initialize_box_geometry_from_main_component;
this_box_volume.geometry.process_rot_allocated = 0;

this_box_volume.geometry.copy_geometry_parameters = &allocate_box_storage_copy;

rot_copy(this_box_volume.geometry.rotation_matrix,ROT_A_CURRENT_COMP); //check how ROT_R_CURRENT_COMP would work
rot_transpose(ROT_A_CURRENT_COMP,this_box_volume.geometry.transpose_rotation_matrix);

// Initialize loggers
this_box_volume.loggers.num_elements = 0;

// packing the information into the global_geometry_element, which is then included in the global_geometry_list.
sprintf(global_geometry_element.name,NAME_CURRENT_COMP);
global_geometry_element.activation_counter = number_of_activations;
global_geometry_element.component_index = INDEX_CURRENT_COMP;
global_geometry_element.Volume = &this_box_volume; // Would be nicer if this m was a pointer, now we have the (small) data two places
add_element_to_geometry_list(&global_geometry_list,global_geometry_element);
}
#line 176744 "MACS_sample_kidney_box.c"
#undef number_of_activations
#undef mask_setting
#undef mask_string
#undef p_interact
#undef focus_r
#undef focus_xh
#undef focus_xw
#undef focus_ah
#undef focus_aw
#undef target_z
#undef target_y
#undef target_x
#undef target_index
#undef visualize
#undef yheight2
#undef xwidth2
#undef zdepth
#undef yheight
#undef xwidth
#undef priority
#undef material_string
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

  /* Initializations for component channel_1_analyzer_2_center. */
  SIG_MESSAGE("channel_1_analyzer_2_center (Init)");

  /* Initializations for component channel_1_analyzer_2_rotated. */
  SIG_MESSAGE("channel_1_analyzer_2_rotated (Init)");

  /* Initializations for component channel_1_analyzer_2_array_crystal_array_0. */
  SIG_MESSAGE("channel_1_analyzer_2_array_crystal_array_0 (Init)");
#define mccompcurname  channel_1_analyzer_2_array_crystal_array_0
#define mccompcurtype  Union_box
#define mccompcurindex 179
#define loop_index mccchannel_1_analyzer_2_array_crystal_array_0_loop_index
#define this_box_volume mccchannel_1_analyzer_2_array_crystal_array_0_this_box_volume
#define global_geometry_element mccchannel_1_analyzer_2_array_crystal_array_0_global_geometry_element
#define this_box_storage mccchannel_1_analyzer_2_array_crystal_array_0_this_box_storage
#define material_string mccchannel_1_analyzer_2_array_crystal_array_0_material_string
#define priority mccchannel_1_analyzer_2_array_crystal_array_0_priority
#define xwidth mccchannel_1_analyzer_2_array_crystal_array_0_xwidth
#define yheight mccchannel_1_analyzer_2_array_crystal_array_0_yheight
#define zdepth mccchannel_1_analyzer_2_array_crystal_array_0_zdepth
#define xwidth2 mccchannel_1_analyzer_2_array_crystal_array_0_xwidth2
#define yheight2 mccchannel_1_analyzer_2_array_crystal_array_0_yheight2
#define visualize mccchannel_1_analyzer_2_array_crystal_array_0_visualize
#define target_index mccchannel_1_analyzer_2_array_crystal_array_0_target_index
#define target_x mccchannel_1_analyzer_2_array_crystal_array_0_target_x
#define target_y mccchannel_1_analyzer_2_array_crystal_array_0_target_y
#define target_z mccchannel_1_analyzer_2_array_crystal_array_0_target_z
#define focus_aw mccchannel_1_analyzer_2_array_crystal_array_0_focus_aw
#define focus_ah mccchannel_1_analyzer_2_array_crystal_array_0_focus_ah
#define focus_xw mccchannel_1_analyzer_2_array_crystal_array_0_focus_xw
#define focus_xh mccchannel_1_analyzer_2_array_crystal_array_0_focus_xh
#define focus_r mccchannel_1_analyzer_2_array_crystal_array_0_focus_r
#define p_interact mccchannel_1_analyzer_2_array_crystal_array_0_p_interact
#define mask_string mccchannel_1_analyzer_2_array_crystal_array_0_mask_string
#define mask_setting mccchannel_1_analyzer_2_array_crystal_array_0_mask_setting
#define number_of_activations mccchannel_1_analyzer_2_array_crystal_array_0_number_of_activations
#line 224 "Union_box.comp"
{
// Initializes the focusing system for this volume including input sanitation.
focus_initialize(&this_box_volume.geometry, POS_A_COMP_INDEX(INDEX_CURRENT_COMP+target_index), POS_A_CURRENT_COMP, ROT_A_CURRENT_COMP, target_index, target_x, target_y, target_z, focus_aw, focus_ah, focus_xw, focus_xh, focus_r, NAME_CURRENT_COMP);

// Input sanitation for this geometry
if (xwidth <= 0) {
  printf("\nERROR in Union_box named %s, the xwidth is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (yheight <= 0) {
  printf("\nERROR in Union_box named %s, yheight is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (zdepth <= 0) {
  printf("\nERROR in Union_box named %s, zdepth is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (xwidth2 <= 0 && xwidth2 != -1) {
  printf("\nERROR in Union_box named %s, the xwidth2 is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (yheight2 <= 0 && yheight2 != -1) {
  printf("\nERROR in Union_box named %s, yheight2 is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}

// Use sanitation
if (global_material_list.num_elements == 0) {
  printf("\nERROR: Need to define a material using Union_make_material before using a Union geometry component. \n");
  printf("       %s was defined before first use of Union_make_material.\n",NAME_CURRENT_COMP);
  exit(1);
}

this_box_volume.geometry.is_masked_volume = 0;
this_box_volume.geometry.is_exit_volume = 0;
this_box_volume.geometry.is_mask_volume = 0;
// check if the volume is a mask, if it is the material string is irelevant.
if (mask_string && strlen(mask_string) && strcmp(mask_string, "NULL") && strcmp(mask_string, "0")) {
    // A mask volume is used to limit the extend of other volumes, called the masked volumes. These are specified in the mask_string.
    // In order for a ray to enter a masked volume, it needs to be both in the region covered by that volume AND the mask volume.
    // When more than
    this_box_volume.geometry.mask_mode = 1; // Default is mask mode is ALL
    if (mask_setting && strlen(mask_setting) && strcmp(mask_setting, "NULL") && strcmp(mask_setting, "0")) {
        if (strcmp(mask_setting,"ALL") == 0 || strcmp(mask_setting,"All") == 0) this_box_volume.geometry.mask_mode = 1;
        else if (strcmp(mask_setting,"ANY") == 0 || strcmp(mask_setting,"Any") == 0) this_box_volume.geometry.mask_mode = 2;
        else {
            printf("The mask_mode of component %s is set to %s, but must be either ALL or ANY.\n",NAME_CURRENT_COMP,mask_setting);
            exit(1);
        }
    }
    
    for (loop_index=0;loop_index<global_geometry_list.num_elements;loop_index++) {
        // Add mask list
        if (1 == manual_linking_function(global_geometry_list.elements[loop_index].name,mask_string)) {
            add_element_to_int_list(&this_box_volume.geometry.mask_list,global_geometry_list.elements[loop_index].component_index);
            add_element_to_int_list(&global_geometry_list.elements[loop_index].Volume->geometry.masked_by_list,INDEX_CURRENT_COMP);
            global_geometry_list.elements[loop_index].Volume->geometry.is_masked_volume = 1;
            if (this_box_volume.geometry.mask_mode == 2)
                global_geometry_list.elements[loop_index].Volume->geometry.mask_mode = 2;
            if (this_box_volume.geometry.mask_mode == 1) {
                if (global_geometry_list.elements[loop_index].Volume->geometry.is_masked_volume == 1 && global_geometry_list.elements[loop_index].Volume->geometry.mask_mode != 2)
                    // If more than one mask is added to one volume, the ANY mode overwrites the (default) ALL mode.
                    global_geometry_list.elements[loop_index].Volume->geometry.mask_mode = 1;
            }
            
            found_geometries = 1;
        }
    }
    if (found_geometries == 0) {
        printf("The mask_string in geometry: %s did not find any of the specified volumes in the mask_string %s \n",NAME_CURRENT_COMP,mask_string);
        exit(1);
    }
    this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
    this_box_volume.p_physics->is_vacuum = 0; // Makes this volume a vacuum
    this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
    this_box_volume.p_physics->my_a = 0; // Should not be used.
    sprintf(this_box_volume.p_physics->name,"Mask");
    this_box_volume.geometry.is_mask_volume = 1;
    
    
// Read the material input, or if it lacks, use automatic linking.
} else if (material_string && strlen(material_string) && strcmp(material_string, "NULL") && strcmp(material_string, "0")) {
    // A geometry string was given, use it to determine which material
    if (0 == strcmp(material_string,"vacuum") || 0 == strcmp(material_string,"Vacuum")) {
        // One could have a global physics struct for vacuum instead of creating one for each
        this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
        this_box_volume.p_physics->is_vacuum = 1; // Makes this volume a vacuum
        this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
        this_box_volume.p_physics->my_a = 0; // Should not be used.
        sprintf(this_box_volume.p_physics->name,"Vacuum");
    } else if (0 == strcmp(material_string,"exit") || 0 == strcmp(material_string,"Exit")) {
        // One could have a global physics struct for vacuum instead of creating one for each
        this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
        this_box_volume.p_physics->is_vacuum = 1; // Makes this volume a vacuum
        this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
        this_box_volume.p_physics->my_a = 0; // Should not be used.
        this_box_volume.geometry.is_exit_volume = 1;
        sprintf(this_box_volume.p_physics->name,"Exit");
    } else {
        #ifndef MATERIAL_DETECTOR
            printf("Need to define a material before refering to it in a geometry %s.\n",NAME_CURRENT_COMP);
            exit(1);
        #endif
        for (loop_index=0;loop_index<global_material_list.num_elements;loop_index++) {
            if (0 == strcmp(material_string,global_material_list.elements[loop_index].name)) {
                this_box_volume.p_physics = global_material_list.elements[loop_index].physics;
                break;
            }
            if (loop_index == global_material_list.num_elements-1) {
            printf("\n");
            printf("ERROR: The material string \"%s\" in Union geometry \"%s\" did not match a specified material. \n",material_string,NAME_CURRENT_COMP);
            printf("       The materials available at this point (need to be defined before the geometry): \n");
            for (loop_index=0;loop_index<global_material_list.num_elements;loop_index++)
              printf("         %s\n",global_material_list.elements[loop_index].name);
            printf("\n");
            printf("       It is also possible to use one of the defualt materials avaiable: \n");
            printf("           Vacuum (for a Volume without scattering or absorption)\n");
            printf("           Exit (for a Volume where the ray exits the component if it enters)\n");
            printf("           Mask (for a Volume that masks existing volumes specified in the mask_string\n");
            exit(1);
          }
        }
    }
} else {
    // Automatic linking, simply using the last defined material.
    #ifndef MATERIAL_DETECTOR
        printf("Need to define a material before the geometry to use automatic linking %s.\n",NAME_CURRENT_COMP);
        exit(1);
    #endif
    this_box_volume.p_physics = global_material_list.elements[global_material_list.num_elements-1].physics;
}

sprintf(this_box_volume.name,NAME_CURRENT_COMP);
sprintf(this_box_volume.geometry.shape,"box");
this_box_volume.geometry.priority_value = priority;
this_box_volume.geometry.geometry_p_interact = p_interact;
// Currently the coordinates will be in absolute space.
this_box_volume.geometry.center = POS_A_CURRENT_COMP;

this_box_storage.z_depth = zdepth;
this_box_storage.x_width1 = xwidth;
this_box_storage.y_height1 = yheight;

this_box_storage.is_rectangle = 0;
if (xwidth2 < 0 && yheight2 < 0) this_box_storage.is_rectangle = 1;
if (xwidth == xwidth2 && yheight == yheight2) this_box_storage.is_rectangle = 1;

if (xwidth2 < 0) {
    this_box_storage.x_width2 = xwidth;
    xwidth2 = xwidth;
} else this_box_storage.x_width2 = xwidth2;

if (yheight2 < 0) {
    this_box_storage.y_height2 = yheight;
    yheight2 = yheight;
} else this_box_storage.y_height2 = yheight2;


this_box_storage.normal_vectors[0] = coords_set(0,0,1);
this_box_storage.normal_vectors[1] = coords_set(0,0,1);

// for sides with y component = 0
x_component = 2*zdepth/sqrt((xwidth-xwidth2)*(xwidth-xwidth2)+4*zdepth*zdepth);
z_component = (xwidth-xwidth2)/sqrt(4*zdepth*zdepth+(xwidth-xwidth2)*(xwidth-xwidth2));

this_box_storage.normal_vectors[2] = coords_set(x_component,0,z_component);
this_box_storage.normal_vectors[3] = coords_set(-x_component,0,z_component);

// for sides with x component = 0
y_component = 2*zdepth/sqrt((yheight-yheight2)*(yheight-yheight2)+4*zdepth*zdepth);
z_component = (yheight-yheight2)/sqrt(4*zdepth*zdepth+(yheight-yheight2)*(yheight-yheight2));

this_box_storage.normal_vectors[4] = coords_set(0,y_component,z_component);
this_box_storage.normal_vectors[5] = coords_set(0,-y_component,z_component);

this_box_volume.geometry.visualization_on = visualize;

this_box_volume.geometry.geometry_parameters.p_box_storage = &this_box_storage;

// Assign pointers to functions for intersection with the shape, checking if a point is inside the shape
if (this_box_storage.is_rectangle == 1) {
this_box_volume.geometry.intersect_function = &sample_box_intersect_simple;
this_box_volume.geometry.within_function = &r_within_box_simple;
}
else {
this_box_volume.geometry.intersect_function = &sample_box_intersect_advanced;
this_box_volume.geometry.within_function = &r_within_box_advanced;
}

this_box_volume.geometry.shell_points = &box_shell_points;
this_box_volume.geometry.mcdisplay_function = &mcdisplay_box_function;
this_box_volume.geometry.initialize_from_main_function = &initialize_box_geometry_from_main_component;
this_box_volume.geometry.process_rot_allocated = 0;

this_box_volume.geometry.copy_geometry_parameters = &allocate_box_storage_copy;

rot_copy(this_box_volume.geometry.rotation_matrix,ROT_A_CURRENT_COMP); //check how ROT_R_CURRENT_COMP would work
rot_transpose(ROT_A_CURRENT_COMP,this_box_volume.geometry.transpose_rotation_matrix);

// Initialize loggers
this_box_volume.loggers.num_elements = 0;

// packing the information into the global_geometry_element, which is then included in the global_geometry_list.
sprintf(global_geometry_element.name,NAME_CURRENT_COMP);
global_geometry_element.activation_counter = number_of_activations;
global_geometry_element.component_index = INDEX_CURRENT_COMP;
global_geometry_element.Volume = &this_box_volume; // Would be nicer if this m was a pointer, now we have the (small) data two places
add_element_to_geometry_list(&global_geometry_list,global_geometry_element);
}
#line 177020 "MACS_sample_kidney_box.c"
#undef number_of_activations
#undef mask_setting
#undef mask_string
#undef p_interact
#undef focus_r
#undef focus_xh
#undef focus_xw
#undef focus_ah
#undef focus_aw
#undef target_z
#undef target_y
#undef target_x
#undef target_index
#undef visualize
#undef yheight2
#undef xwidth2
#undef zdepth
#undef yheight
#undef xwidth
#undef priority
#undef material_string
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

  /* Initializations for component channel_1_analyzer_2_array_crystal_array_1. */
  SIG_MESSAGE("channel_1_analyzer_2_array_crystal_array_1 (Init)");
#define mccompcurname  channel_1_analyzer_2_array_crystal_array_1
#define mccompcurtype  Union_box
#define mccompcurindex 180
#define loop_index mccchannel_1_analyzer_2_array_crystal_array_1_loop_index
#define this_box_volume mccchannel_1_analyzer_2_array_crystal_array_1_this_box_volume
#define global_geometry_element mccchannel_1_analyzer_2_array_crystal_array_1_global_geometry_element
#define this_box_storage mccchannel_1_analyzer_2_array_crystal_array_1_this_box_storage
#define material_string mccchannel_1_analyzer_2_array_crystal_array_1_material_string
#define priority mccchannel_1_analyzer_2_array_crystal_array_1_priority
#define xwidth mccchannel_1_analyzer_2_array_crystal_array_1_xwidth
#define yheight mccchannel_1_analyzer_2_array_crystal_array_1_yheight
#define zdepth mccchannel_1_analyzer_2_array_crystal_array_1_zdepth
#define xwidth2 mccchannel_1_analyzer_2_array_crystal_array_1_xwidth2
#define yheight2 mccchannel_1_analyzer_2_array_crystal_array_1_yheight2
#define visualize mccchannel_1_analyzer_2_array_crystal_array_1_visualize
#define target_index mccchannel_1_analyzer_2_array_crystal_array_1_target_index
#define target_x mccchannel_1_analyzer_2_array_crystal_array_1_target_x
#define target_y mccchannel_1_analyzer_2_array_crystal_array_1_target_y
#define target_z mccchannel_1_analyzer_2_array_crystal_array_1_target_z
#define focus_aw mccchannel_1_analyzer_2_array_crystal_array_1_focus_aw
#define focus_ah mccchannel_1_analyzer_2_array_crystal_array_1_focus_ah
#define focus_xw mccchannel_1_analyzer_2_array_crystal_array_1_focus_xw
#define focus_xh mccchannel_1_analyzer_2_array_crystal_array_1_focus_xh
#define focus_r mccchannel_1_analyzer_2_array_crystal_array_1_focus_r
#define p_interact mccchannel_1_analyzer_2_array_crystal_array_1_p_interact
#define mask_string mccchannel_1_analyzer_2_array_crystal_array_1_mask_string
#define mask_setting mccchannel_1_analyzer_2_array_crystal_array_1_mask_setting
#define number_of_activations mccchannel_1_analyzer_2_array_crystal_array_1_number_of_activations
#line 224 "Union_box.comp"
{
// Initializes the focusing system for this volume including input sanitation.
focus_initialize(&this_box_volume.geometry, POS_A_COMP_INDEX(INDEX_CURRENT_COMP+target_index), POS_A_CURRENT_COMP, ROT_A_CURRENT_COMP, target_index, target_x, target_y, target_z, focus_aw, focus_ah, focus_xw, focus_xh, focus_r, NAME_CURRENT_COMP);

// Input sanitation for this geometry
if (xwidth <= 0) {
  printf("\nERROR in Union_box named %s, the xwidth is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (yheight <= 0) {
  printf("\nERROR in Union_box named %s, yheight is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (zdepth <= 0) {
  printf("\nERROR in Union_box named %s, zdepth is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (xwidth2 <= 0 && xwidth2 != -1) {
  printf("\nERROR in Union_box named %s, the xwidth2 is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (yheight2 <= 0 && yheight2 != -1) {
  printf("\nERROR in Union_box named %s, yheight2 is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}

// Use sanitation
if (global_material_list.num_elements == 0) {
  printf("\nERROR: Need to define a material using Union_make_material before using a Union geometry component. \n");
  printf("       %s was defined before first use of Union_make_material.\n",NAME_CURRENT_COMP);
  exit(1);
}

this_box_volume.geometry.is_masked_volume = 0;
this_box_volume.geometry.is_exit_volume = 0;
this_box_volume.geometry.is_mask_volume = 0;
// check if the volume is a mask, if it is the material string is irelevant.
if (mask_string && strlen(mask_string) && strcmp(mask_string, "NULL") && strcmp(mask_string, "0")) {
    // A mask volume is used to limit the extend of other volumes, called the masked volumes. These are specified in the mask_string.
    // In order for a ray to enter a masked volume, it needs to be both in the region covered by that volume AND the mask volume.
    // When more than
    this_box_volume.geometry.mask_mode = 1; // Default is mask mode is ALL
    if (mask_setting && strlen(mask_setting) && strcmp(mask_setting, "NULL") && strcmp(mask_setting, "0")) {
        if (strcmp(mask_setting,"ALL") == 0 || strcmp(mask_setting,"All") == 0) this_box_volume.geometry.mask_mode = 1;
        else if (strcmp(mask_setting,"ANY") == 0 || strcmp(mask_setting,"Any") == 0) this_box_volume.geometry.mask_mode = 2;
        else {
            printf("The mask_mode of component %s is set to %s, but must be either ALL or ANY.\n",NAME_CURRENT_COMP,mask_setting);
            exit(1);
        }
    }
    
    for (loop_index=0;loop_index<global_geometry_list.num_elements;loop_index++) {
        // Add mask list
        if (1 == manual_linking_function(global_geometry_list.elements[loop_index].name,mask_string)) {
            add_element_to_int_list(&this_box_volume.geometry.mask_list,global_geometry_list.elements[loop_index].component_index);
            add_element_to_int_list(&global_geometry_list.elements[loop_index].Volume->geometry.masked_by_list,INDEX_CURRENT_COMP);
            global_geometry_list.elements[loop_index].Volume->geometry.is_masked_volume = 1;
            if (this_box_volume.geometry.mask_mode == 2)
                global_geometry_list.elements[loop_index].Volume->geometry.mask_mode = 2;
            if (this_box_volume.geometry.mask_mode == 1) {
                if (global_geometry_list.elements[loop_index].Volume->geometry.is_masked_volume == 1 && global_geometry_list.elements[loop_index].Volume->geometry.mask_mode != 2)
                    // If more than one mask is added to one volume, the ANY mode overwrites the (default) ALL mode.
                    global_geometry_list.elements[loop_index].Volume->geometry.mask_mode = 1;
            }
            
            found_geometries = 1;
        }
    }
    if (found_geometries == 0) {
        printf("The mask_string in geometry: %s did not find any of the specified volumes in the mask_string %s \n",NAME_CURRENT_COMP,mask_string);
        exit(1);
    }
    this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
    this_box_volume.p_physics->is_vacuum = 0; // Makes this volume a vacuum
    this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
    this_box_volume.p_physics->my_a = 0; // Should not be used.
    sprintf(this_box_volume.p_physics->name,"Mask");
    this_box_volume.geometry.is_mask_volume = 1;
    
    
// Read the material input, or if it lacks, use automatic linking.
} else if (material_string && strlen(material_string) && strcmp(material_string, "NULL") && strcmp(material_string, "0")) {
    // A geometry string was given, use it to determine which material
    if (0 == strcmp(material_string,"vacuum") || 0 == strcmp(material_string,"Vacuum")) {
        // One could have a global physics struct for vacuum instead of creating one for each
        this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
        this_box_volume.p_physics->is_vacuum = 1; // Makes this volume a vacuum
        this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
        this_box_volume.p_physics->my_a = 0; // Should not be used.
        sprintf(this_box_volume.p_physics->name,"Vacuum");
    } else if (0 == strcmp(material_string,"exit") || 0 == strcmp(material_string,"Exit")) {
        // One could have a global physics struct for vacuum instead of creating one for each
        this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
        this_box_volume.p_physics->is_vacuum = 1; // Makes this volume a vacuum
        this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
        this_box_volume.p_physics->my_a = 0; // Should not be used.
        this_box_volume.geometry.is_exit_volume = 1;
        sprintf(this_box_volume.p_physics->name,"Exit");
    } else {
        #ifndef MATERIAL_DETECTOR
            printf("Need to define a material before refering to it in a geometry %s.\n",NAME_CURRENT_COMP);
            exit(1);
        #endif
        for (loop_index=0;loop_index<global_material_list.num_elements;loop_index++) {
            if (0 == strcmp(material_string,global_material_list.elements[loop_index].name)) {
                this_box_volume.p_physics = global_material_list.elements[loop_index].physics;
                break;
            }
            if (loop_index == global_material_list.num_elements-1) {
            printf("\n");
            printf("ERROR: The material string \"%s\" in Union geometry \"%s\" did not match a specified material. \n",material_string,NAME_CURRENT_COMP);
            printf("       The materials available at this point (need to be defined before the geometry): \n");
            for (loop_index=0;loop_index<global_material_list.num_elements;loop_index++)
              printf("         %s\n",global_material_list.elements[loop_index].name);
            printf("\n");
            printf("       It is also possible to use one of the defualt materials avaiable: \n");
            printf("           Vacuum (for a Volume without scattering or absorption)\n");
            printf("           Exit (for a Volume where the ray exits the component if it enters)\n");
            printf("           Mask (for a Volume that masks existing volumes specified in the mask_string\n");
            exit(1);
          }
        }
    }
} else {
    // Automatic linking, simply using the last defined material.
    #ifndef MATERIAL_DETECTOR
        printf("Need to define a material before the geometry to use automatic linking %s.\n",NAME_CURRENT_COMP);
        exit(1);
    #endif
    this_box_volume.p_physics = global_material_list.elements[global_material_list.num_elements-1].physics;
}

sprintf(this_box_volume.name,NAME_CURRENT_COMP);
sprintf(this_box_volume.geometry.shape,"box");
this_box_volume.geometry.priority_value = priority;
this_box_volume.geometry.geometry_p_interact = p_interact;
// Currently the coordinates will be in absolute space.
this_box_volume.geometry.center = POS_A_CURRENT_COMP;

this_box_storage.z_depth = zdepth;
this_box_storage.x_width1 = xwidth;
this_box_storage.y_height1 = yheight;

this_box_storage.is_rectangle = 0;
if (xwidth2 < 0 && yheight2 < 0) this_box_storage.is_rectangle = 1;
if (xwidth == xwidth2 && yheight == yheight2) this_box_storage.is_rectangle = 1;

if (xwidth2 < 0) {
    this_box_storage.x_width2 = xwidth;
    xwidth2 = xwidth;
} else this_box_storage.x_width2 = xwidth2;

if (yheight2 < 0) {
    this_box_storage.y_height2 = yheight;
    yheight2 = yheight;
} else this_box_storage.y_height2 = yheight2;


this_box_storage.normal_vectors[0] = coords_set(0,0,1);
this_box_storage.normal_vectors[1] = coords_set(0,0,1);

// for sides with y component = 0
x_component = 2*zdepth/sqrt((xwidth-xwidth2)*(xwidth-xwidth2)+4*zdepth*zdepth);
z_component = (xwidth-xwidth2)/sqrt(4*zdepth*zdepth+(xwidth-xwidth2)*(xwidth-xwidth2));

this_box_storage.normal_vectors[2] = coords_set(x_component,0,z_component);
this_box_storage.normal_vectors[3] = coords_set(-x_component,0,z_component);

// for sides with x component = 0
y_component = 2*zdepth/sqrt((yheight-yheight2)*(yheight-yheight2)+4*zdepth*zdepth);
z_component = (yheight-yheight2)/sqrt(4*zdepth*zdepth+(yheight-yheight2)*(yheight-yheight2));

this_box_storage.normal_vectors[4] = coords_set(0,y_component,z_component);
this_box_storage.normal_vectors[5] = coords_set(0,-y_component,z_component);

this_box_volume.geometry.visualization_on = visualize;

this_box_volume.geometry.geometry_parameters.p_box_storage = &this_box_storage;

// Assign pointers to functions for intersection with the shape, checking if a point is inside the shape
if (this_box_storage.is_rectangle == 1) {
this_box_volume.geometry.intersect_function = &sample_box_intersect_simple;
this_box_volume.geometry.within_function = &r_within_box_simple;
}
else {
this_box_volume.geometry.intersect_function = &sample_box_intersect_advanced;
this_box_volume.geometry.within_function = &r_within_box_advanced;
}

this_box_volume.geometry.shell_points = &box_shell_points;
this_box_volume.geometry.mcdisplay_function = &mcdisplay_box_function;
this_box_volume.geometry.initialize_from_main_function = &initialize_box_geometry_from_main_component;
this_box_volume.geometry.process_rot_allocated = 0;

this_box_volume.geometry.copy_geometry_parameters = &allocate_box_storage_copy;

rot_copy(this_box_volume.geometry.rotation_matrix,ROT_A_CURRENT_COMP); //check how ROT_R_CURRENT_COMP would work
rot_transpose(ROT_A_CURRENT_COMP,this_box_volume.geometry.transpose_rotation_matrix);

// Initialize loggers
this_box_volume.loggers.num_elements = 0;

// packing the information into the global_geometry_element, which is then included in the global_geometry_list.
sprintf(global_geometry_element.name,NAME_CURRENT_COMP);
global_geometry_element.activation_counter = number_of_activations;
global_geometry_element.component_index = INDEX_CURRENT_COMP;
global_geometry_element.Volume = &this_box_volume; // Would be nicer if this m was a pointer, now we have the (small) data two places
add_element_to_geometry_list(&global_geometry_list,global_geometry_element);
}
#line 177290 "MACS_sample_kidney_box.c"
#undef number_of_activations
#undef mask_setting
#undef mask_string
#undef p_interact
#undef focus_r
#undef focus_xh
#undef focus_xw
#undef focus_ah
#undef focus_aw
#undef target_z
#undef target_y
#undef target_x
#undef target_index
#undef visualize
#undef yheight2
#undef xwidth2
#undef zdepth
#undef yheight
#undef xwidth
#undef priority
#undef material_string
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

  /* Initializations for component channel_1_analyzer_2_array_crystal_array_2. */
  SIG_MESSAGE("channel_1_analyzer_2_array_crystal_array_2 (Init)");
#define mccompcurname  channel_1_analyzer_2_array_crystal_array_2
#define mccompcurtype  Union_box
#define mccompcurindex 181
#define loop_index mccchannel_1_analyzer_2_array_crystal_array_2_loop_index
#define this_box_volume mccchannel_1_analyzer_2_array_crystal_array_2_this_box_volume
#define global_geometry_element mccchannel_1_analyzer_2_array_crystal_array_2_global_geometry_element
#define this_box_storage mccchannel_1_analyzer_2_array_crystal_array_2_this_box_storage
#define material_string mccchannel_1_analyzer_2_array_crystal_array_2_material_string
#define priority mccchannel_1_analyzer_2_array_crystal_array_2_priority
#define xwidth mccchannel_1_analyzer_2_array_crystal_array_2_xwidth
#define yheight mccchannel_1_analyzer_2_array_crystal_array_2_yheight
#define zdepth mccchannel_1_analyzer_2_array_crystal_array_2_zdepth
#define xwidth2 mccchannel_1_analyzer_2_array_crystal_array_2_xwidth2
#define yheight2 mccchannel_1_analyzer_2_array_crystal_array_2_yheight2
#define visualize mccchannel_1_analyzer_2_array_crystal_array_2_visualize
#define target_index mccchannel_1_analyzer_2_array_crystal_array_2_target_index
#define target_x mccchannel_1_analyzer_2_array_crystal_array_2_target_x
#define target_y mccchannel_1_analyzer_2_array_crystal_array_2_target_y
#define target_z mccchannel_1_analyzer_2_array_crystal_array_2_target_z
#define focus_aw mccchannel_1_analyzer_2_array_crystal_array_2_focus_aw
#define focus_ah mccchannel_1_analyzer_2_array_crystal_array_2_focus_ah
#define focus_xw mccchannel_1_analyzer_2_array_crystal_array_2_focus_xw
#define focus_xh mccchannel_1_analyzer_2_array_crystal_array_2_focus_xh
#define focus_r mccchannel_1_analyzer_2_array_crystal_array_2_focus_r
#define p_interact mccchannel_1_analyzer_2_array_crystal_array_2_p_interact
#define mask_string mccchannel_1_analyzer_2_array_crystal_array_2_mask_string
#define mask_setting mccchannel_1_analyzer_2_array_crystal_array_2_mask_setting
#define number_of_activations mccchannel_1_analyzer_2_array_crystal_array_2_number_of_activations
#line 224 "Union_box.comp"
{
// Initializes the focusing system for this volume including input sanitation.
focus_initialize(&this_box_volume.geometry, POS_A_COMP_INDEX(INDEX_CURRENT_COMP+target_index), POS_A_CURRENT_COMP, ROT_A_CURRENT_COMP, target_index, target_x, target_y, target_z, focus_aw, focus_ah, focus_xw, focus_xh, focus_r, NAME_CURRENT_COMP);

// Input sanitation for this geometry
if (xwidth <= 0) {
  printf("\nERROR in Union_box named %s, the xwidth is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (yheight <= 0) {
  printf("\nERROR in Union_box named %s, yheight is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (zdepth <= 0) {
  printf("\nERROR in Union_box named %s, zdepth is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (xwidth2 <= 0 && xwidth2 != -1) {
  printf("\nERROR in Union_box named %s, the xwidth2 is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (yheight2 <= 0 && yheight2 != -1) {
  printf("\nERROR in Union_box named %s, yheight2 is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}

// Use sanitation
if (global_material_list.num_elements == 0) {
  printf("\nERROR: Need to define a material using Union_make_material before using a Union geometry component. \n");
  printf("       %s was defined before first use of Union_make_material.\n",NAME_CURRENT_COMP);
  exit(1);
}

this_box_volume.geometry.is_masked_volume = 0;
this_box_volume.geometry.is_exit_volume = 0;
this_box_volume.geometry.is_mask_volume = 0;
// check if the volume is a mask, if it is the material string is irelevant.
if (mask_string && strlen(mask_string) && strcmp(mask_string, "NULL") && strcmp(mask_string, "0")) {
    // A mask volume is used to limit the extend of other volumes, called the masked volumes. These are specified in the mask_string.
    // In order for a ray to enter a masked volume, it needs to be both in the region covered by that volume AND the mask volume.
    // When more than
    this_box_volume.geometry.mask_mode = 1; // Default is mask mode is ALL
    if (mask_setting && strlen(mask_setting) && strcmp(mask_setting, "NULL") && strcmp(mask_setting, "0")) {
        if (strcmp(mask_setting,"ALL") == 0 || strcmp(mask_setting,"All") == 0) this_box_volume.geometry.mask_mode = 1;
        else if (strcmp(mask_setting,"ANY") == 0 || strcmp(mask_setting,"Any") == 0) this_box_volume.geometry.mask_mode = 2;
        else {
            printf("The mask_mode of component %s is set to %s, but must be either ALL or ANY.\n",NAME_CURRENT_COMP,mask_setting);
            exit(1);
        }
    }
    
    for (loop_index=0;loop_index<global_geometry_list.num_elements;loop_index++) {
        // Add mask list
        if (1 == manual_linking_function(global_geometry_list.elements[loop_index].name,mask_string)) {
            add_element_to_int_list(&this_box_volume.geometry.mask_list,global_geometry_list.elements[loop_index].component_index);
            add_element_to_int_list(&global_geometry_list.elements[loop_index].Volume->geometry.masked_by_list,INDEX_CURRENT_COMP);
            global_geometry_list.elements[loop_index].Volume->geometry.is_masked_volume = 1;
            if (this_box_volume.geometry.mask_mode == 2)
                global_geometry_list.elements[loop_index].Volume->geometry.mask_mode = 2;
            if (this_box_volume.geometry.mask_mode == 1) {
                if (global_geometry_list.elements[loop_index].Volume->geometry.is_masked_volume == 1 && global_geometry_list.elements[loop_index].Volume->geometry.mask_mode != 2)
                    // If more than one mask is added to one volume, the ANY mode overwrites the (default) ALL mode.
                    global_geometry_list.elements[loop_index].Volume->geometry.mask_mode = 1;
            }
            
            found_geometries = 1;
        }
    }
    if (found_geometries == 0) {
        printf("The mask_string in geometry: %s did not find any of the specified volumes in the mask_string %s \n",NAME_CURRENT_COMP,mask_string);
        exit(1);
    }
    this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
    this_box_volume.p_physics->is_vacuum = 0; // Makes this volume a vacuum
    this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
    this_box_volume.p_physics->my_a = 0; // Should not be used.
    sprintf(this_box_volume.p_physics->name,"Mask");
    this_box_volume.geometry.is_mask_volume = 1;
    
    
// Read the material input, or if it lacks, use automatic linking.
} else if (material_string && strlen(material_string) && strcmp(material_string, "NULL") && strcmp(material_string, "0")) {
    // A geometry string was given, use it to determine which material
    if (0 == strcmp(material_string,"vacuum") || 0 == strcmp(material_string,"Vacuum")) {
        // One could have a global physics struct for vacuum instead of creating one for each
        this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
        this_box_volume.p_physics->is_vacuum = 1; // Makes this volume a vacuum
        this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
        this_box_volume.p_physics->my_a = 0; // Should not be used.
        sprintf(this_box_volume.p_physics->name,"Vacuum");
    } else if (0 == strcmp(material_string,"exit") || 0 == strcmp(material_string,"Exit")) {
        // One could have a global physics struct for vacuum instead of creating one for each
        this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
        this_box_volume.p_physics->is_vacuum = 1; // Makes this volume a vacuum
        this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
        this_box_volume.p_physics->my_a = 0; // Should not be used.
        this_box_volume.geometry.is_exit_volume = 1;
        sprintf(this_box_volume.p_physics->name,"Exit");
    } else {
        #ifndef MATERIAL_DETECTOR
            printf("Need to define a material before refering to it in a geometry %s.\n",NAME_CURRENT_COMP);
            exit(1);
        #endif
        for (loop_index=0;loop_index<global_material_list.num_elements;loop_index++) {
            if (0 == strcmp(material_string,global_material_list.elements[loop_index].name)) {
                this_box_volume.p_physics = global_material_list.elements[loop_index].physics;
                break;
            }
            if (loop_index == global_material_list.num_elements-1) {
            printf("\n");
            printf("ERROR: The material string \"%s\" in Union geometry \"%s\" did not match a specified material. \n",material_string,NAME_CURRENT_COMP);
            printf("       The materials available at this point (need to be defined before the geometry): \n");
            for (loop_index=0;loop_index<global_material_list.num_elements;loop_index++)
              printf("         %s\n",global_material_list.elements[loop_index].name);
            printf("\n");
            printf("       It is also possible to use one of the defualt materials avaiable: \n");
            printf("           Vacuum (for a Volume without scattering or absorption)\n");
            printf("           Exit (for a Volume where the ray exits the component if it enters)\n");
            printf("           Mask (for a Volume that masks existing volumes specified in the mask_string\n");
            exit(1);
          }
        }
    }
} else {
    // Automatic linking, simply using the last defined material.
    #ifndef MATERIAL_DETECTOR
        printf("Need to define a material before the geometry to use automatic linking %s.\n",NAME_CURRENT_COMP);
        exit(1);
    #endif
    this_box_volume.p_physics = global_material_list.elements[global_material_list.num_elements-1].physics;
}

sprintf(this_box_volume.name,NAME_CURRENT_COMP);
sprintf(this_box_volume.geometry.shape,"box");
this_box_volume.geometry.priority_value = priority;
this_box_volume.geometry.geometry_p_interact = p_interact;
// Currently the coordinates will be in absolute space.
this_box_volume.geometry.center = POS_A_CURRENT_COMP;

this_box_storage.z_depth = zdepth;
this_box_storage.x_width1 = xwidth;
this_box_storage.y_height1 = yheight;

this_box_storage.is_rectangle = 0;
if (xwidth2 < 0 && yheight2 < 0) this_box_storage.is_rectangle = 1;
if (xwidth == xwidth2 && yheight == yheight2) this_box_storage.is_rectangle = 1;

if (xwidth2 < 0) {
    this_box_storage.x_width2 = xwidth;
    xwidth2 = xwidth;
} else this_box_storage.x_width2 = xwidth2;

if (yheight2 < 0) {
    this_box_storage.y_height2 = yheight;
    yheight2 = yheight;
} else this_box_storage.y_height2 = yheight2;


this_box_storage.normal_vectors[0] = coords_set(0,0,1);
this_box_storage.normal_vectors[1] = coords_set(0,0,1);

// for sides with y component = 0
x_component = 2*zdepth/sqrt((xwidth-xwidth2)*(xwidth-xwidth2)+4*zdepth*zdepth);
z_component = (xwidth-xwidth2)/sqrt(4*zdepth*zdepth+(xwidth-xwidth2)*(xwidth-xwidth2));

this_box_storage.normal_vectors[2] = coords_set(x_component,0,z_component);
this_box_storage.normal_vectors[3] = coords_set(-x_component,0,z_component);

// for sides with x component = 0
y_component = 2*zdepth/sqrt((yheight-yheight2)*(yheight-yheight2)+4*zdepth*zdepth);
z_component = (yheight-yheight2)/sqrt(4*zdepth*zdepth+(yheight-yheight2)*(yheight-yheight2));

this_box_storage.normal_vectors[4] = coords_set(0,y_component,z_component);
this_box_storage.normal_vectors[5] = coords_set(0,-y_component,z_component);

this_box_volume.geometry.visualization_on = visualize;

this_box_volume.geometry.geometry_parameters.p_box_storage = &this_box_storage;

// Assign pointers to functions for intersection with the shape, checking if a point is inside the shape
if (this_box_storage.is_rectangle == 1) {
this_box_volume.geometry.intersect_function = &sample_box_intersect_simple;
this_box_volume.geometry.within_function = &r_within_box_simple;
}
else {
this_box_volume.geometry.intersect_function = &sample_box_intersect_advanced;
this_box_volume.geometry.within_function = &r_within_box_advanced;
}

this_box_volume.geometry.shell_points = &box_shell_points;
this_box_volume.geometry.mcdisplay_function = &mcdisplay_box_function;
this_box_volume.geometry.initialize_from_main_function = &initialize_box_geometry_from_main_component;
this_box_volume.geometry.process_rot_allocated = 0;

this_box_volume.geometry.copy_geometry_parameters = &allocate_box_storage_copy;

rot_copy(this_box_volume.geometry.rotation_matrix,ROT_A_CURRENT_COMP); //check how ROT_R_CURRENT_COMP would work
rot_transpose(ROT_A_CURRENT_COMP,this_box_volume.geometry.transpose_rotation_matrix);

// Initialize loggers
this_box_volume.loggers.num_elements = 0;

// packing the information into the global_geometry_element, which is then included in the global_geometry_list.
sprintf(global_geometry_element.name,NAME_CURRENT_COMP);
global_geometry_element.activation_counter = number_of_activations;
global_geometry_element.component_index = INDEX_CURRENT_COMP;
global_geometry_element.Volume = &this_box_volume; // Would be nicer if this m was a pointer, now we have the (small) data two places
add_element_to_geometry_list(&global_geometry_list,global_geometry_element);
}
#line 177560 "MACS_sample_kidney_box.c"
#undef number_of_activations
#undef mask_setting
#undef mask_string
#undef p_interact
#undef focus_r
#undef focus_xh
#undef focus_xw
#undef focus_ah
#undef focus_aw
#undef target_z
#undef target_y
#undef target_x
#undef target_index
#undef visualize
#undef yheight2
#undef xwidth2
#undef zdepth
#undef yheight
#undef xwidth
#undef priority
#undef material_string
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

  /* Initializations for component channel_1_analyzer_2_array_crystal_array_3. */
  SIG_MESSAGE("channel_1_analyzer_2_array_crystal_array_3 (Init)");
#define mccompcurname  channel_1_analyzer_2_array_crystal_array_3
#define mccompcurtype  Union_box
#define mccompcurindex 182
#define loop_index mccchannel_1_analyzer_2_array_crystal_array_3_loop_index
#define this_box_volume mccchannel_1_analyzer_2_array_crystal_array_3_this_box_volume
#define global_geometry_element mccchannel_1_analyzer_2_array_crystal_array_3_global_geometry_element
#define this_box_storage mccchannel_1_analyzer_2_array_crystal_array_3_this_box_storage
#define material_string mccchannel_1_analyzer_2_array_crystal_array_3_material_string
#define priority mccchannel_1_analyzer_2_array_crystal_array_3_priority
#define xwidth mccchannel_1_analyzer_2_array_crystal_array_3_xwidth
#define yheight mccchannel_1_analyzer_2_array_crystal_array_3_yheight
#define zdepth mccchannel_1_analyzer_2_array_crystal_array_3_zdepth
#define xwidth2 mccchannel_1_analyzer_2_array_crystal_array_3_xwidth2
#define yheight2 mccchannel_1_analyzer_2_array_crystal_array_3_yheight2
#define visualize mccchannel_1_analyzer_2_array_crystal_array_3_visualize
#define target_index mccchannel_1_analyzer_2_array_crystal_array_3_target_index
#define target_x mccchannel_1_analyzer_2_array_crystal_array_3_target_x
#define target_y mccchannel_1_analyzer_2_array_crystal_array_3_target_y
#define target_z mccchannel_1_analyzer_2_array_crystal_array_3_target_z
#define focus_aw mccchannel_1_analyzer_2_array_crystal_array_3_focus_aw
#define focus_ah mccchannel_1_analyzer_2_array_crystal_array_3_focus_ah
#define focus_xw mccchannel_1_analyzer_2_array_crystal_array_3_focus_xw
#define focus_xh mccchannel_1_analyzer_2_array_crystal_array_3_focus_xh
#define focus_r mccchannel_1_analyzer_2_array_crystal_array_3_focus_r
#define p_interact mccchannel_1_analyzer_2_array_crystal_array_3_p_interact
#define mask_string mccchannel_1_analyzer_2_array_crystal_array_3_mask_string
#define mask_setting mccchannel_1_analyzer_2_array_crystal_array_3_mask_setting
#define number_of_activations mccchannel_1_analyzer_2_array_crystal_array_3_number_of_activations
#line 224 "Union_box.comp"
{
// Initializes the focusing system for this volume including input sanitation.
focus_initialize(&this_box_volume.geometry, POS_A_COMP_INDEX(INDEX_CURRENT_COMP+target_index), POS_A_CURRENT_COMP, ROT_A_CURRENT_COMP, target_index, target_x, target_y, target_z, focus_aw, focus_ah, focus_xw, focus_xh, focus_r, NAME_CURRENT_COMP);

// Input sanitation for this geometry
if (xwidth <= 0) {
  printf("\nERROR in Union_box named %s, the xwidth is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (yheight <= 0) {
  printf("\nERROR in Union_box named %s, yheight is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (zdepth <= 0) {
  printf("\nERROR in Union_box named %s, zdepth is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (xwidth2 <= 0 && xwidth2 != -1) {
  printf("\nERROR in Union_box named %s, the xwidth2 is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (yheight2 <= 0 && yheight2 != -1) {
  printf("\nERROR in Union_box named %s, yheight2 is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}

// Use sanitation
if (global_material_list.num_elements == 0) {
  printf("\nERROR: Need to define a material using Union_make_material before using a Union geometry component. \n");
  printf("       %s was defined before first use of Union_make_material.\n",NAME_CURRENT_COMP);
  exit(1);
}

this_box_volume.geometry.is_masked_volume = 0;
this_box_volume.geometry.is_exit_volume = 0;
this_box_volume.geometry.is_mask_volume = 0;
// check if the volume is a mask, if it is the material string is irelevant.
if (mask_string && strlen(mask_string) && strcmp(mask_string, "NULL") && strcmp(mask_string, "0")) {
    // A mask volume is used to limit the extend of other volumes, called the masked volumes. These are specified in the mask_string.
    // In order for a ray to enter a masked volume, it needs to be both in the region covered by that volume AND the mask volume.
    // When more than
    this_box_volume.geometry.mask_mode = 1; // Default is mask mode is ALL
    if (mask_setting && strlen(mask_setting) && strcmp(mask_setting, "NULL") && strcmp(mask_setting, "0")) {
        if (strcmp(mask_setting,"ALL") == 0 || strcmp(mask_setting,"All") == 0) this_box_volume.geometry.mask_mode = 1;
        else if (strcmp(mask_setting,"ANY") == 0 || strcmp(mask_setting,"Any") == 0) this_box_volume.geometry.mask_mode = 2;
        else {
            printf("The mask_mode of component %s is set to %s, but must be either ALL or ANY.\n",NAME_CURRENT_COMP,mask_setting);
            exit(1);
        }
    }
    
    for (loop_index=0;loop_index<global_geometry_list.num_elements;loop_index++) {
        // Add mask list
        if (1 == manual_linking_function(global_geometry_list.elements[loop_index].name,mask_string)) {
            add_element_to_int_list(&this_box_volume.geometry.mask_list,global_geometry_list.elements[loop_index].component_index);
            add_element_to_int_list(&global_geometry_list.elements[loop_index].Volume->geometry.masked_by_list,INDEX_CURRENT_COMP);
            global_geometry_list.elements[loop_index].Volume->geometry.is_masked_volume = 1;
            if (this_box_volume.geometry.mask_mode == 2)
                global_geometry_list.elements[loop_index].Volume->geometry.mask_mode = 2;
            if (this_box_volume.geometry.mask_mode == 1) {
                if (global_geometry_list.elements[loop_index].Volume->geometry.is_masked_volume == 1 && global_geometry_list.elements[loop_index].Volume->geometry.mask_mode != 2)
                    // If more than one mask is added to one volume, the ANY mode overwrites the (default) ALL mode.
                    global_geometry_list.elements[loop_index].Volume->geometry.mask_mode = 1;
            }
            
            found_geometries = 1;
        }
    }
    if (found_geometries == 0) {
        printf("The mask_string in geometry: %s did not find any of the specified volumes in the mask_string %s \n",NAME_CURRENT_COMP,mask_string);
        exit(1);
    }
    this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
    this_box_volume.p_physics->is_vacuum = 0; // Makes this volume a vacuum
    this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
    this_box_volume.p_physics->my_a = 0; // Should not be used.
    sprintf(this_box_volume.p_physics->name,"Mask");
    this_box_volume.geometry.is_mask_volume = 1;
    
    
// Read the material input, or if it lacks, use automatic linking.
} else if (material_string && strlen(material_string) && strcmp(material_string, "NULL") && strcmp(material_string, "0")) {
    // A geometry string was given, use it to determine which material
    if (0 == strcmp(material_string,"vacuum") || 0 == strcmp(material_string,"Vacuum")) {
        // One could have a global physics struct for vacuum instead of creating one for each
        this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
        this_box_volume.p_physics->is_vacuum = 1; // Makes this volume a vacuum
        this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
        this_box_volume.p_physics->my_a = 0; // Should not be used.
        sprintf(this_box_volume.p_physics->name,"Vacuum");
    } else if (0 == strcmp(material_string,"exit") || 0 == strcmp(material_string,"Exit")) {
        // One could have a global physics struct for vacuum instead of creating one for each
        this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
        this_box_volume.p_physics->is_vacuum = 1; // Makes this volume a vacuum
        this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
        this_box_volume.p_physics->my_a = 0; // Should not be used.
        this_box_volume.geometry.is_exit_volume = 1;
        sprintf(this_box_volume.p_physics->name,"Exit");
    } else {
        #ifndef MATERIAL_DETECTOR
            printf("Need to define a material before refering to it in a geometry %s.\n",NAME_CURRENT_COMP);
            exit(1);
        #endif
        for (loop_index=0;loop_index<global_material_list.num_elements;loop_index++) {
            if (0 == strcmp(material_string,global_material_list.elements[loop_index].name)) {
                this_box_volume.p_physics = global_material_list.elements[loop_index].physics;
                break;
            }
            if (loop_index == global_material_list.num_elements-1) {
            printf("\n");
            printf("ERROR: The material string \"%s\" in Union geometry \"%s\" did not match a specified material. \n",material_string,NAME_CURRENT_COMP);
            printf("       The materials available at this point (need to be defined before the geometry): \n");
            for (loop_index=0;loop_index<global_material_list.num_elements;loop_index++)
              printf("         %s\n",global_material_list.elements[loop_index].name);
            printf("\n");
            printf("       It is also possible to use one of the defualt materials avaiable: \n");
            printf("           Vacuum (for a Volume without scattering or absorption)\n");
            printf("           Exit (for a Volume where the ray exits the component if it enters)\n");
            printf("           Mask (for a Volume that masks existing volumes specified in the mask_string\n");
            exit(1);
          }
        }
    }
} else {
    // Automatic linking, simply using the last defined material.
    #ifndef MATERIAL_DETECTOR
        printf("Need to define a material before the geometry to use automatic linking %s.\n",NAME_CURRENT_COMP);
        exit(1);
    #endif
    this_box_volume.p_physics = global_material_list.elements[global_material_list.num_elements-1].physics;
}

sprintf(this_box_volume.name,NAME_CURRENT_COMP);
sprintf(this_box_volume.geometry.shape,"box");
this_box_volume.geometry.priority_value = priority;
this_box_volume.geometry.geometry_p_interact = p_interact;
// Currently the coordinates will be in absolute space.
this_box_volume.geometry.center = POS_A_CURRENT_COMP;

this_box_storage.z_depth = zdepth;
this_box_storage.x_width1 = xwidth;
this_box_storage.y_height1 = yheight;

this_box_storage.is_rectangle = 0;
if (xwidth2 < 0 && yheight2 < 0) this_box_storage.is_rectangle = 1;
if (xwidth == xwidth2 && yheight == yheight2) this_box_storage.is_rectangle = 1;

if (xwidth2 < 0) {
    this_box_storage.x_width2 = xwidth;
    xwidth2 = xwidth;
} else this_box_storage.x_width2 = xwidth2;

if (yheight2 < 0) {
    this_box_storage.y_height2 = yheight;
    yheight2 = yheight;
} else this_box_storage.y_height2 = yheight2;


this_box_storage.normal_vectors[0] = coords_set(0,0,1);
this_box_storage.normal_vectors[1] = coords_set(0,0,1);

// for sides with y component = 0
x_component = 2*zdepth/sqrt((xwidth-xwidth2)*(xwidth-xwidth2)+4*zdepth*zdepth);
z_component = (xwidth-xwidth2)/sqrt(4*zdepth*zdepth+(xwidth-xwidth2)*(xwidth-xwidth2));

this_box_storage.normal_vectors[2] = coords_set(x_component,0,z_component);
this_box_storage.normal_vectors[3] = coords_set(-x_component,0,z_component);

// for sides with x component = 0
y_component = 2*zdepth/sqrt((yheight-yheight2)*(yheight-yheight2)+4*zdepth*zdepth);
z_component = (yheight-yheight2)/sqrt(4*zdepth*zdepth+(yheight-yheight2)*(yheight-yheight2));

this_box_storage.normal_vectors[4] = coords_set(0,y_component,z_component);
this_box_storage.normal_vectors[5] = coords_set(0,-y_component,z_component);

this_box_volume.geometry.visualization_on = visualize;

this_box_volume.geometry.geometry_parameters.p_box_storage = &this_box_storage;

// Assign pointers to functions for intersection with the shape, checking if a point is inside the shape
if (this_box_storage.is_rectangle == 1) {
this_box_volume.geometry.intersect_function = &sample_box_intersect_simple;
this_box_volume.geometry.within_function = &r_within_box_simple;
}
else {
this_box_volume.geometry.intersect_function = &sample_box_intersect_advanced;
this_box_volume.geometry.within_function = &r_within_box_advanced;
}

this_box_volume.geometry.shell_points = &box_shell_points;
this_box_volume.geometry.mcdisplay_function = &mcdisplay_box_function;
this_box_volume.geometry.initialize_from_main_function = &initialize_box_geometry_from_main_component;
this_box_volume.geometry.process_rot_allocated = 0;

this_box_volume.geometry.copy_geometry_parameters = &allocate_box_storage_copy;

rot_copy(this_box_volume.geometry.rotation_matrix,ROT_A_CURRENT_COMP); //check how ROT_R_CURRENT_COMP would work
rot_transpose(ROT_A_CURRENT_COMP,this_box_volume.geometry.transpose_rotation_matrix);

// Initialize loggers
this_box_volume.loggers.num_elements = 0;

// packing the information into the global_geometry_element, which is then included in the global_geometry_list.
sprintf(global_geometry_element.name,NAME_CURRENT_COMP);
global_geometry_element.activation_counter = number_of_activations;
global_geometry_element.component_index = INDEX_CURRENT_COMP;
global_geometry_element.Volume = &this_box_volume; // Would be nicer if this m was a pointer, now we have the (small) data two places
add_element_to_geometry_list(&global_geometry_list,global_geometry_element);
}
#line 177830 "MACS_sample_kidney_box.c"
#undef number_of_activations
#undef mask_setting
#undef mask_string
#undef p_interact
#undef focus_r
#undef focus_xh
#undef focus_xw
#undef focus_ah
#undef focus_aw
#undef target_z
#undef target_y
#undef target_x
#undef target_index
#undef visualize
#undef yheight2
#undef xwidth2
#undef zdepth
#undef yheight
#undef xwidth
#undef priority
#undef material_string
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

  /* Initializations for component channel_1_analyzer_2_array_crystal_array_4. */
  SIG_MESSAGE("channel_1_analyzer_2_array_crystal_array_4 (Init)");
#define mccompcurname  channel_1_analyzer_2_array_crystal_array_4
#define mccompcurtype  Union_box
#define mccompcurindex 183
#define loop_index mccchannel_1_analyzer_2_array_crystal_array_4_loop_index
#define this_box_volume mccchannel_1_analyzer_2_array_crystal_array_4_this_box_volume
#define global_geometry_element mccchannel_1_analyzer_2_array_crystal_array_4_global_geometry_element
#define this_box_storage mccchannel_1_analyzer_2_array_crystal_array_4_this_box_storage
#define material_string mccchannel_1_analyzer_2_array_crystal_array_4_material_string
#define priority mccchannel_1_analyzer_2_array_crystal_array_4_priority
#define xwidth mccchannel_1_analyzer_2_array_crystal_array_4_xwidth
#define yheight mccchannel_1_analyzer_2_array_crystal_array_4_yheight
#define zdepth mccchannel_1_analyzer_2_array_crystal_array_4_zdepth
#define xwidth2 mccchannel_1_analyzer_2_array_crystal_array_4_xwidth2
#define yheight2 mccchannel_1_analyzer_2_array_crystal_array_4_yheight2
#define visualize mccchannel_1_analyzer_2_array_crystal_array_4_visualize
#define target_index mccchannel_1_analyzer_2_array_crystal_array_4_target_index
#define target_x mccchannel_1_analyzer_2_array_crystal_array_4_target_x
#define target_y mccchannel_1_analyzer_2_array_crystal_array_4_target_y
#define target_z mccchannel_1_analyzer_2_array_crystal_array_4_target_z
#define focus_aw mccchannel_1_analyzer_2_array_crystal_array_4_focus_aw
#define focus_ah mccchannel_1_analyzer_2_array_crystal_array_4_focus_ah
#define focus_xw mccchannel_1_analyzer_2_array_crystal_array_4_focus_xw
#define focus_xh mccchannel_1_analyzer_2_array_crystal_array_4_focus_xh
#define focus_r mccchannel_1_analyzer_2_array_crystal_array_4_focus_r
#define p_interact mccchannel_1_analyzer_2_array_crystal_array_4_p_interact
#define mask_string mccchannel_1_analyzer_2_array_crystal_array_4_mask_string
#define mask_setting mccchannel_1_analyzer_2_array_crystal_array_4_mask_setting
#define number_of_activations mccchannel_1_analyzer_2_array_crystal_array_4_number_of_activations
#line 224 "Union_box.comp"
{
// Initializes the focusing system for this volume including input sanitation.
focus_initialize(&this_box_volume.geometry, POS_A_COMP_INDEX(INDEX_CURRENT_COMP+target_index), POS_A_CURRENT_COMP, ROT_A_CURRENT_COMP, target_index, target_x, target_y, target_z, focus_aw, focus_ah, focus_xw, focus_xh, focus_r, NAME_CURRENT_COMP);

// Input sanitation for this geometry
if (xwidth <= 0) {
  printf("\nERROR in Union_box named %s, the xwidth is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (yheight <= 0) {
  printf("\nERROR in Union_box named %s, yheight is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (zdepth <= 0) {
  printf("\nERROR in Union_box named %s, zdepth is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (xwidth2 <= 0 && xwidth2 != -1) {
  printf("\nERROR in Union_box named %s, the xwidth2 is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (yheight2 <= 0 && yheight2 != -1) {
  printf("\nERROR in Union_box named %s, yheight2 is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}

// Use sanitation
if (global_material_list.num_elements == 0) {
  printf("\nERROR: Need to define a material using Union_make_material before using a Union geometry component. \n");
  printf("       %s was defined before first use of Union_make_material.\n",NAME_CURRENT_COMP);
  exit(1);
}

this_box_volume.geometry.is_masked_volume = 0;
this_box_volume.geometry.is_exit_volume = 0;
this_box_volume.geometry.is_mask_volume = 0;
// check if the volume is a mask, if it is the material string is irelevant.
if (mask_string && strlen(mask_string) && strcmp(mask_string, "NULL") && strcmp(mask_string, "0")) {
    // A mask volume is used to limit the extend of other volumes, called the masked volumes. These are specified in the mask_string.
    // In order for a ray to enter a masked volume, it needs to be both in the region covered by that volume AND the mask volume.
    // When more than
    this_box_volume.geometry.mask_mode = 1; // Default is mask mode is ALL
    if (mask_setting && strlen(mask_setting) && strcmp(mask_setting, "NULL") && strcmp(mask_setting, "0")) {
        if (strcmp(mask_setting,"ALL") == 0 || strcmp(mask_setting,"All") == 0) this_box_volume.geometry.mask_mode = 1;
        else if (strcmp(mask_setting,"ANY") == 0 || strcmp(mask_setting,"Any") == 0) this_box_volume.geometry.mask_mode = 2;
        else {
            printf("The mask_mode of component %s is set to %s, but must be either ALL or ANY.\n",NAME_CURRENT_COMP,mask_setting);
            exit(1);
        }
    }
    
    for (loop_index=0;loop_index<global_geometry_list.num_elements;loop_index++) {
        // Add mask list
        if (1 == manual_linking_function(global_geometry_list.elements[loop_index].name,mask_string)) {
            add_element_to_int_list(&this_box_volume.geometry.mask_list,global_geometry_list.elements[loop_index].component_index);
            add_element_to_int_list(&global_geometry_list.elements[loop_index].Volume->geometry.masked_by_list,INDEX_CURRENT_COMP);
            global_geometry_list.elements[loop_index].Volume->geometry.is_masked_volume = 1;
            if (this_box_volume.geometry.mask_mode == 2)
                global_geometry_list.elements[loop_index].Volume->geometry.mask_mode = 2;
            if (this_box_volume.geometry.mask_mode == 1) {
                if (global_geometry_list.elements[loop_index].Volume->geometry.is_masked_volume == 1 && global_geometry_list.elements[loop_index].Volume->geometry.mask_mode != 2)
                    // If more than one mask is added to one volume, the ANY mode overwrites the (default) ALL mode.
                    global_geometry_list.elements[loop_index].Volume->geometry.mask_mode = 1;
            }
            
            found_geometries = 1;
        }
    }
    if (found_geometries == 0) {
        printf("The mask_string in geometry: %s did not find any of the specified volumes in the mask_string %s \n",NAME_CURRENT_COMP,mask_string);
        exit(1);
    }
    this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
    this_box_volume.p_physics->is_vacuum = 0; // Makes this volume a vacuum
    this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
    this_box_volume.p_physics->my_a = 0; // Should not be used.
    sprintf(this_box_volume.p_physics->name,"Mask");
    this_box_volume.geometry.is_mask_volume = 1;
    
    
// Read the material input, or if it lacks, use automatic linking.
} else if (material_string && strlen(material_string) && strcmp(material_string, "NULL") && strcmp(material_string, "0")) {
    // A geometry string was given, use it to determine which material
    if (0 == strcmp(material_string,"vacuum") || 0 == strcmp(material_string,"Vacuum")) {
        // One could have a global physics struct for vacuum instead of creating one for each
        this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
        this_box_volume.p_physics->is_vacuum = 1; // Makes this volume a vacuum
        this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
        this_box_volume.p_physics->my_a = 0; // Should not be used.
        sprintf(this_box_volume.p_physics->name,"Vacuum");
    } else if (0 == strcmp(material_string,"exit") || 0 == strcmp(material_string,"Exit")) {
        // One could have a global physics struct for vacuum instead of creating one for each
        this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
        this_box_volume.p_physics->is_vacuum = 1; // Makes this volume a vacuum
        this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
        this_box_volume.p_physics->my_a = 0; // Should not be used.
        this_box_volume.geometry.is_exit_volume = 1;
        sprintf(this_box_volume.p_physics->name,"Exit");
    } else {
        #ifndef MATERIAL_DETECTOR
            printf("Need to define a material before refering to it in a geometry %s.\n",NAME_CURRENT_COMP);
            exit(1);
        #endif
        for (loop_index=0;loop_index<global_material_list.num_elements;loop_index++) {
            if (0 == strcmp(material_string,global_material_list.elements[loop_index].name)) {
                this_box_volume.p_physics = global_material_list.elements[loop_index].physics;
                break;
            }
            if (loop_index == global_material_list.num_elements-1) {
            printf("\n");
            printf("ERROR: The material string \"%s\" in Union geometry \"%s\" did not match a specified material. \n",material_string,NAME_CURRENT_COMP);
            printf("       The materials available at this point (need to be defined before the geometry): \n");
            for (loop_index=0;loop_index<global_material_list.num_elements;loop_index++)
              printf("         %s\n",global_material_list.elements[loop_index].name);
            printf("\n");
            printf("       It is also possible to use one of the defualt materials avaiable: \n");
            printf("           Vacuum (for a Volume without scattering or absorption)\n");
            printf("           Exit (for a Volume where the ray exits the component if it enters)\n");
            printf("           Mask (for a Volume that masks existing volumes specified in the mask_string\n");
            exit(1);
          }
        }
    }
} else {
    // Automatic linking, simply using the last defined material.
    #ifndef MATERIAL_DETECTOR
        printf("Need to define a material before the geometry to use automatic linking %s.\n",NAME_CURRENT_COMP);
        exit(1);
    #endif
    this_box_volume.p_physics = global_material_list.elements[global_material_list.num_elements-1].physics;
}

sprintf(this_box_volume.name,NAME_CURRENT_COMP);
sprintf(this_box_volume.geometry.shape,"box");
this_box_volume.geometry.priority_value = priority;
this_box_volume.geometry.geometry_p_interact = p_interact;
// Currently the coordinates will be in absolute space.
this_box_volume.geometry.center = POS_A_CURRENT_COMP;

this_box_storage.z_depth = zdepth;
this_box_storage.x_width1 = xwidth;
this_box_storage.y_height1 = yheight;

this_box_storage.is_rectangle = 0;
if (xwidth2 < 0 && yheight2 < 0) this_box_storage.is_rectangle = 1;
if (xwidth == xwidth2 && yheight == yheight2) this_box_storage.is_rectangle = 1;

if (xwidth2 < 0) {
    this_box_storage.x_width2 = xwidth;
    xwidth2 = xwidth;
} else this_box_storage.x_width2 = xwidth2;

if (yheight2 < 0) {
    this_box_storage.y_height2 = yheight;
    yheight2 = yheight;
} else this_box_storage.y_height2 = yheight2;


this_box_storage.normal_vectors[0] = coords_set(0,0,1);
this_box_storage.normal_vectors[1] = coords_set(0,0,1);

// for sides with y component = 0
x_component = 2*zdepth/sqrt((xwidth-xwidth2)*(xwidth-xwidth2)+4*zdepth*zdepth);
z_component = (xwidth-xwidth2)/sqrt(4*zdepth*zdepth+(xwidth-xwidth2)*(xwidth-xwidth2));

this_box_storage.normal_vectors[2] = coords_set(x_component,0,z_component);
this_box_storage.normal_vectors[3] = coords_set(-x_component,0,z_component);

// for sides with x component = 0
y_component = 2*zdepth/sqrt((yheight-yheight2)*(yheight-yheight2)+4*zdepth*zdepth);
z_component = (yheight-yheight2)/sqrt(4*zdepth*zdepth+(yheight-yheight2)*(yheight-yheight2));

this_box_storage.normal_vectors[4] = coords_set(0,y_component,z_component);
this_box_storage.normal_vectors[5] = coords_set(0,-y_component,z_component);

this_box_volume.geometry.visualization_on = visualize;

this_box_volume.geometry.geometry_parameters.p_box_storage = &this_box_storage;

// Assign pointers to functions for intersection with the shape, checking if a point is inside the shape
if (this_box_storage.is_rectangle == 1) {
this_box_volume.geometry.intersect_function = &sample_box_intersect_simple;
this_box_volume.geometry.within_function = &r_within_box_simple;
}
else {
this_box_volume.geometry.intersect_function = &sample_box_intersect_advanced;
this_box_volume.geometry.within_function = &r_within_box_advanced;
}

this_box_volume.geometry.shell_points = &box_shell_points;
this_box_volume.geometry.mcdisplay_function = &mcdisplay_box_function;
this_box_volume.geometry.initialize_from_main_function = &initialize_box_geometry_from_main_component;
this_box_volume.geometry.process_rot_allocated = 0;

this_box_volume.geometry.copy_geometry_parameters = &allocate_box_storage_copy;

rot_copy(this_box_volume.geometry.rotation_matrix,ROT_A_CURRENT_COMP); //check how ROT_R_CURRENT_COMP would work
rot_transpose(ROT_A_CURRENT_COMP,this_box_volume.geometry.transpose_rotation_matrix);

// Initialize loggers
this_box_volume.loggers.num_elements = 0;

// packing the information into the global_geometry_element, which is then included in the global_geometry_list.
sprintf(global_geometry_element.name,NAME_CURRENT_COMP);
global_geometry_element.activation_counter = number_of_activations;
global_geometry_element.component_index = INDEX_CURRENT_COMP;
global_geometry_element.Volume = &this_box_volume; // Would be nicer if this m was a pointer, now we have the (small) data two places
add_element_to_geometry_list(&global_geometry_list,global_geometry_element);
}
#line 178100 "MACS_sample_kidney_box.c"
#undef number_of_activations
#undef mask_setting
#undef mask_string
#undef p_interact
#undef focus_r
#undef focus_xh
#undef focus_xw
#undef focus_ah
#undef focus_aw
#undef target_z
#undef target_y
#undef target_x
#undef target_index
#undef visualize
#undef yheight2
#undef xwidth2
#undef zdepth
#undef yheight
#undef xwidth
#undef priority
#undef material_string
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

  /* Initializations for component channel_1_analyzer_2_array_crystal_array_5. */
  SIG_MESSAGE("channel_1_analyzer_2_array_crystal_array_5 (Init)");
#define mccompcurname  channel_1_analyzer_2_array_crystal_array_5
#define mccompcurtype  Union_box
#define mccompcurindex 184
#define loop_index mccchannel_1_analyzer_2_array_crystal_array_5_loop_index
#define this_box_volume mccchannel_1_analyzer_2_array_crystal_array_5_this_box_volume
#define global_geometry_element mccchannel_1_analyzer_2_array_crystal_array_5_global_geometry_element
#define this_box_storage mccchannel_1_analyzer_2_array_crystal_array_5_this_box_storage
#define material_string mccchannel_1_analyzer_2_array_crystal_array_5_material_string
#define priority mccchannel_1_analyzer_2_array_crystal_array_5_priority
#define xwidth mccchannel_1_analyzer_2_array_crystal_array_5_xwidth
#define yheight mccchannel_1_analyzer_2_array_crystal_array_5_yheight
#define zdepth mccchannel_1_analyzer_2_array_crystal_array_5_zdepth
#define xwidth2 mccchannel_1_analyzer_2_array_crystal_array_5_xwidth2
#define yheight2 mccchannel_1_analyzer_2_array_crystal_array_5_yheight2
#define visualize mccchannel_1_analyzer_2_array_crystal_array_5_visualize
#define target_index mccchannel_1_analyzer_2_array_crystal_array_5_target_index
#define target_x mccchannel_1_analyzer_2_array_crystal_array_5_target_x
#define target_y mccchannel_1_analyzer_2_array_crystal_array_5_target_y
#define target_z mccchannel_1_analyzer_2_array_crystal_array_5_target_z
#define focus_aw mccchannel_1_analyzer_2_array_crystal_array_5_focus_aw
#define focus_ah mccchannel_1_analyzer_2_array_crystal_array_5_focus_ah
#define focus_xw mccchannel_1_analyzer_2_array_crystal_array_5_focus_xw
#define focus_xh mccchannel_1_analyzer_2_array_crystal_array_5_focus_xh
#define focus_r mccchannel_1_analyzer_2_array_crystal_array_5_focus_r
#define p_interact mccchannel_1_analyzer_2_array_crystal_array_5_p_interact
#define mask_string mccchannel_1_analyzer_2_array_crystal_array_5_mask_string
#define mask_setting mccchannel_1_analyzer_2_array_crystal_array_5_mask_setting
#define number_of_activations mccchannel_1_analyzer_2_array_crystal_array_5_number_of_activations
#line 224 "Union_box.comp"
{
// Initializes the focusing system for this volume including input sanitation.
focus_initialize(&this_box_volume.geometry, POS_A_COMP_INDEX(INDEX_CURRENT_COMP+target_index), POS_A_CURRENT_COMP, ROT_A_CURRENT_COMP, target_index, target_x, target_y, target_z, focus_aw, focus_ah, focus_xw, focus_xh, focus_r, NAME_CURRENT_COMP);

// Input sanitation for this geometry
if (xwidth <= 0) {
  printf("\nERROR in Union_box named %s, the xwidth is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (yheight <= 0) {
  printf("\nERROR in Union_box named %s, yheight is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (zdepth <= 0) {
  printf("\nERROR in Union_box named %s, zdepth is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (xwidth2 <= 0 && xwidth2 != -1) {
  printf("\nERROR in Union_box named %s, the xwidth2 is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (yheight2 <= 0 && yheight2 != -1) {
  printf("\nERROR in Union_box named %s, yheight2 is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}

// Use sanitation
if (global_material_list.num_elements == 0) {
  printf("\nERROR: Need to define a material using Union_make_material before using a Union geometry component. \n");
  printf("       %s was defined before first use of Union_make_material.\n",NAME_CURRENT_COMP);
  exit(1);
}

this_box_volume.geometry.is_masked_volume = 0;
this_box_volume.geometry.is_exit_volume = 0;
this_box_volume.geometry.is_mask_volume = 0;
// check if the volume is a mask, if it is the material string is irelevant.
if (mask_string && strlen(mask_string) && strcmp(mask_string, "NULL") && strcmp(mask_string, "0")) {
    // A mask volume is used to limit the extend of other volumes, called the masked volumes. These are specified in the mask_string.
    // In order for a ray to enter a masked volume, it needs to be both in the region covered by that volume AND the mask volume.
    // When more than
    this_box_volume.geometry.mask_mode = 1; // Default is mask mode is ALL
    if (mask_setting && strlen(mask_setting) && strcmp(mask_setting, "NULL") && strcmp(mask_setting, "0")) {
        if (strcmp(mask_setting,"ALL") == 0 || strcmp(mask_setting,"All") == 0) this_box_volume.geometry.mask_mode = 1;
        else if (strcmp(mask_setting,"ANY") == 0 || strcmp(mask_setting,"Any") == 0) this_box_volume.geometry.mask_mode = 2;
        else {
            printf("The mask_mode of component %s is set to %s, but must be either ALL or ANY.\n",NAME_CURRENT_COMP,mask_setting);
            exit(1);
        }
    }
    
    for (loop_index=0;loop_index<global_geometry_list.num_elements;loop_index++) {
        // Add mask list
        if (1 == manual_linking_function(global_geometry_list.elements[loop_index].name,mask_string)) {
            add_element_to_int_list(&this_box_volume.geometry.mask_list,global_geometry_list.elements[loop_index].component_index);
            add_element_to_int_list(&global_geometry_list.elements[loop_index].Volume->geometry.masked_by_list,INDEX_CURRENT_COMP);
            global_geometry_list.elements[loop_index].Volume->geometry.is_masked_volume = 1;
            if (this_box_volume.geometry.mask_mode == 2)
                global_geometry_list.elements[loop_index].Volume->geometry.mask_mode = 2;
            if (this_box_volume.geometry.mask_mode == 1) {
                if (global_geometry_list.elements[loop_index].Volume->geometry.is_masked_volume == 1 && global_geometry_list.elements[loop_index].Volume->geometry.mask_mode != 2)
                    // If more than one mask is added to one volume, the ANY mode overwrites the (default) ALL mode.
                    global_geometry_list.elements[loop_index].Volume->geometry.mask_mode = 1;
            }
            
            found_geometries = 1;
        }
    }
    if (found_geometries == 0) {
        printf("The mask_string in geometry: %s did not find any of the specified volumes in the mask_string %s \n",NAME_CURRENT_COMP,mask_string);
        exit(1);
    }
    this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
    this_box_volume.p_physics->is_vacuum = 0; // Makes this volume a vacuum
    this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
    this_box_volume.p_physics->my_a = 0; // Should not be used.
    sprintf(this_box_volume.p_physics->name,"Mask");
    this_box_volume.geometry.is_mask_volume = 1;
    
    
// Read the material input, or if it lacks, use automatic linking.
} else if (material_string && strlen(material_string) && strcmp(material_string, "NULL") && strcmp(material_string, "0")) {
    // A geometry string was given, use it to determine which material
    if (0 == strcmp(material_string,"vacuum") || 0 == strcmp(material_string,"Vacuum")) {
        // One could have a global physics struct for vacuum instead of creating one for each
        this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
        this_box_volume.p_physics->is_vacuum = 1; // Makes this volume a vacuum
        this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
        this_box_volume.p_physics->my_a = 0; // Should not be used.
        sprintf(this_box_volume.p_physics->name,"Vacuum");
    } else if (0 == strcmp(material_string,"exit") || 0 == strcmp(material_string,"Exit")) {
        // One could have a global physics struct for vacuum instead of creating one for each
        this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
        this_box_volume.p_physics->is_vacuum = 1; // Makes this volume a vacuum
        this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
        this_box_volume.p_physics->my_a = 0; // Should not be used.
        this_box_volume.geometry.is_exit_volume = 1;
        sprintf(this_box_volume.p_physics->name,"Exit");
    } else {
        #ifndef MATERIAL_DETECTOR
            printf("Need to define a material before refering to it in a geometry %s.\n",NAME_CURRENT_COMP);
            exit(1);
        #endif
        for (loop_index=0;loop_index<global_material_list.num_elements;loop_index++) {
            if (0 == strcmp(material_string,global_material_list.elements[loop_index].name)) {
                this_box_volume.p_physics = global_material_list.elements[loop_index].physics;
                break;
            }
            if (loop_index == global_material_list.num_elements-1) {
            printf("\n");
            printf("ERROR: The material string \"%s\" in Union geometry \"%s\" did not match a specified material. \n",material_string,NAME_CURRENT_COMP);
            printf("       The materials available at this point (need to be defined before the geometry): \n");
            for (loop_index=0;loop_index<global_material_list.num_elements;loop_index++)
              printf("         %s\n",global_material_list.elements[loop_index].name);
            printf("\n");
            printf("       It is also possible to use one of the defualt materials avaiable: \n");
            printf("           Vacuum (for a Volume without scattering or absorption)\n");
            printf("           Exit (for a Volume where the ray exits the component if it enters)\n");
            printf("           Mask (for a Volume that masks existing volumes specified in the mask_string\n");
            exit(1);
          }
        }
    }
} else {
    // Automatic linking, simply using the last defined material.
    #ifndef MATERIAL_DETECTOR
        printf("Need to define a material before the geometry to use automatic linking %s.\n",NAME_CURRENT_COMP);
        exit(1);
    #endif
    this_box_volume.p_physics = global_material_list.elements[global_material_list.num_elements-1].physics;
}

sprintf(this_box_volume.name,NAME_CURRENT_COMP);
sprintf(this_box_volume.geometry.shape,"box");
this_box_volume.geometry.priority_value = priority;
this_box_volume.geometry.geometry_p_interact = p_interact;
// Currently the coordinates will be in absolute space.
this_box_volume.geometry.center = POS_A_CURRENT_COMP;

this_box_storage.z_depth = zdepth;
this_box_storage.x_width1 = xwidth;
this_box_storage.y_height1 = yheight;

this_box_storage.is_rectangle = 0;
if (xwidth2 < 0 && yheight2 < 0) this_box_storage.is_rectangle = 1;
if (xwidth == xwidth2 && yheight == yheight2) this_box_storage.is_rectangle = 1;

if (xwidth2 < 0) {
    this_box_storage.x_width2 = xwidth;
    xwidth2 = xwidth;
} else this_box_storage.x_width2 = xwidth2;

if (yheight2 < 0) {
    this_box_storage.y_height2 = yheight;
    yheight2 = yheight;
} else this_box_storage.y_height2 = yheight2;


this_box_storage.normal_vectors[0] = coords_set(0,0,1);
this_box_storage.normal_vectors[1] = coords_set(0,0,1);

// for sides with y component = 0
x_component = 2*zdepth/sqrt((xwidth-xwidth2)*(xwidth-xwidth2)+4*zdepth*zdepth);
z_component = (xwidth-xwidth2)/sqrt(4*zdepth*zdepth+(xwidth-xwidth2)*(xwidth-xwidth2));

this_box_storage.normal_vectors[2] = coords_set(x_component,0,z_component);
this_box_storage.normal_vectors[3] = coords_set(-x_component,0,z_component);

// for sides with x component = 0
y_component = 2*zdepth/sqrt((yheight-yheight2)*(yheight-yheight2)+4*zdepth*zdepth);
z_component = (yheight-yheight2)/sqrt(4*zdepth*zdepth+(yheight-yheight2)*(yheight-yheight2));

this_box_storage.normal_vectors[4] = coords_set(0,y_component,z_component);
this_box_storage.normal_vectors[5] = coords_set(0,-y_component,z_component);

this_box_volume.geometry.visualization_on = visualize;

this_box_volume.geometry.geometry_parameters.p_box_storage = &this_box_storage;

// Assign pointers to functions for intersection with the shape, checking if a point is inside the shape
if (this_box_storage.is_rectangle == 1) {
this_box_volume.geometry.intersect_function = &sample_box_intersect_simple;
this_box_volume.geometry.within_function = &r_within_box_simple;
}
else {
this_box_volume.geometry.intersect_function = &sample_box_intersect_advanced;
this_box_volume.geometry.within_function = &r_within_box_advanced;
}

this_box_volume.geometry.shell_points = &box_shell_points;
this_box_volume.geometry.mcdisplay_function = &mcdisplay_box_function;
this_box_volume.geometry.initialize_from_main_function = &initialize_box_geometry_from_main_component;
this_box_volume.geometry.process_rot_allocated = 0;

this_box_volume.geometry.copy_geometry_parameters = &allocate_box_storage_copy;

rot_copy(this_box_volume.geometry.rotation_matrix,ROT_A_CURRENT_COMP); //check how ROT_R_CURRENT_COMP would work
rot_transpose(ROT_A_CURRENT_COMP,this_box_volume.geometry.transpose_rotation_matrix);

// Initialize loggers
this_box_volume.loggers.num_elements = 0;

// packing the information into the global_geometry_element, which is then included in the global_geometry_list.
sprintf(global_geometry_element.name,NAME_CURRENT_COMP);
global_geometry_element.activation_counter = number_of_activations;
global_geometry_element.component_index = INDEX_CURRENT_COMP;
global_geometry_element.Volume = &this_box_volume; // Would be nicer if this m was a pointer, now we have the (small) data two places
add_element_to_geometry_list(&global_geometry_list,global_geometry_element);
}
#line 178370 "MACS_sample_kidney_box.c"
#undef number_of_activations
#undef mask_setting
#undef mask_string
#undef p_interact
#undef focus_r
#undef focus_xh
#undef focus_xw
#undef focus_ah
#undef focus_aw
#undef target_z
#undef target_y
#undef target_x
#undef target_index
#undef visualize
#undef yheight2
#undef xwidth2
#undef zdepth
#undef yheight
#undef xwidth
#undef priority
#undef material_string
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

  /* Initializations for component channel_1_analyzer_2_array_crystal_array_6. */
  SIG_MESSAGE("channel_1_analyzer_2_array_crystal_array_6 (Init)");
#define mccompcurname  channel_1_analyzer_2_array_crystal_array_6
#define mccompcurtype  Union_box
#define mccompcurindex 185
#define loop_index mccchannel_1_analyzer_2_array_crystal_array_6_loop_index
#define this_box_volume mccchannel_1_analyzer_2_array_crystal_array_6_this_box_volume
#define global_geometry_element mccchannel_1_analyzer_2_array_crystal_array_6_global_geometry_element
#define this_box_storage mccchannel_1_analyzer_2_array_crystal_array_6_this_box_storage
#define material_string mccchannel_1_analyzer_2_array_crystal_array_6_material_string
#define priority mccchannel_1_analyzer_2_array_crystal_array_6_priority
#define xwidth mccchannel_1_analyzer_2_array_crystal_array_6_xwidth
#define yheight mccchannel_1_analyzer_2_array_crystal_array_6_yheight
#define zdepth mccchannel_1_analyzer_2_array_crystal_array_6_zdepth
#define xwidth2 mccchannel_1_analyzer_2_array_crystal_array_6_xwidth2
#define yheight2 mccchannel_1_analyzer_2_array_crystal_array_6_yheight2
#define visualize mccchannel_1_analyzer_2_array_crystal_array_6_visualize
#define target_index mccchannel_1_analyzer_2_array_crystal_array_6_target_index
#define target_x mccchannel_1_analyzer_2_array_crystal_array_6_target_x
#define target_y mccchannel_1_analyzer_2_array_crystal_array_6_target_y
#define target_z mccchannel_1_analyzer_2_array_crystal_array_6_target_z
#define focus_aw mccchannel_1_analyzer_2_array_crystal_array_6_focus_aw
#define focus_ah mccchannel_1_analyzer_2_array_crystal_array_6_focus_ah
#define focus_xw mccchannel_1_analyzer_2_array_crystal_array_6_focus_xw
#define focus_xh mccchannel_1_analyzer_2_array_crystal_array_6_focus_xh
#define focus_r mccchannel_1_analyzer_2_array_crystal_array_6_focus_r
#define p_interact mccchannel_1_analyzer_2_array_crystal_array_6_p_interact
#define mask_string mccchannel_1_analyzer_2_array_crystal_array_6_mask_string
#define mask_setting mccchannel_1_analyzer_2_array_crystal_array_6_mask_setting
#define number_of_activations mccchannel_1_analyzer_2_array_crystal_array_6_number_of_activations
#line 224 "Union_box.comp"
{
// Initializes the focusing system for this volume including input sanitation.
focus_initialize(&this_box_volume.geometry, POS_A_COMP_INDEX(INDEX_CURRENT_COMP+target_index), POS_A_CURRENT_COMP, ROT_A_CURRENT_COMP, target_index, target_x, target_y, target_z, focus_aw, focus_ah, focus_xw, focus_xh, focus_r, NAME_CURRENT_COMP);

// Input sanitation for this geometry
if (xwidth <= 0) {
  printf("\nERROR in Union_box named %s, the xwidth is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (yheight <= 0) {
  printf("\nERROR in Union_box named %s, yheight is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (zdepth <= 0) {
  printf("\nERROR in Union_box named %s, zdepth is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (xwidth2 <= 0 && xwidth2 != -1) {
  printf("\nERROR in Union_box named %s, the xwidth2 is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (yheight2 <= 0 && yheight2 != -1) {
  printf("\nERROR in Union_box named %s, yheight2 is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}

// Use sanitation
if (global_material_list.num_elements == 0) {
  printf("\nERROR: Need to define a material using Union_make_material before using a Union geometry component. \n");
  printf("       %s was defined before first use of Union_make_material.\n",NAME_CURRENT_COMP);
  exit(1);
}

this_box_volume.geometry.is_masked_volume = 0;
this_box_volume.geometry.is_exit_volume = 0;
this_box_volume.geometry.is_mask_volume = 0;
// check if the volume is a mask, if it is the material string is irelevant.
if (mask_string && strlen(mask_string) && strcmp(mask_string, "NULL") && strcmp(mask_string, "0")) {
    // A mask volume is used to limit the extend of other volumes, called the masked volumes. These are specified in the mask_string.
    // In order for a ray to enter a masked volume, it needs to be both in the region covered by that volume AND the mask volume.
    // When more than
    this_box_volume.geometry.mask_mode = 1; // Default is mask mode is ALL
    if (mask_setting && strlen(mask_setting) && strcmp(mask_setting, "NULL") && strcmp(mask_setting, "0")) {
        if (strcmp(mask_setting,"ALL") == 0 || strcmp(mask_setting,"All") == 0) this_box_volume.geometry.mask_mode = 1;
        else if (strcmp(mask_setting,"ANY") == 0 || strcmp(mask_setting,"Any") == 0) this_box_volume.geometry.mask_mode = 2;
        else {
            printf("The mask_mode of component %s is set to %s, but must be either ALL or ANY.\n",NAME_CURRENT_COMP,mask_setting);
            exit(1);
        }
    }
    
    for (loop_index=0;loop_index<global_geometry_list.num_elements;loop_index++) {
        // Add mask list
        if (1 == manual_linking_function(global_geometry_list.elements[loop_index].name,mask_string)) {
            add_element_to_int_list(&this_box_volume.geometry.mask_list,global_geometry_list.elements[loop_index].component_index);
            add_element_to_int_list(&global_geometry_list.elements[loop_index].Volume->geometry.masked_by_list,INDEX_CURRENT_COMP);
            global_geometry_list.elements[loop_index].Volume->geometry.is_masked_volume = 1;
            if (this_box_volume.geometry.mask_mode == 2)
                global_geometry_list.elements[loop_index].Volume->geometry.mask_mode = 2;
            if (this_box_volume.geometry.mask_mode == 1) {
                if (global_geometry_list.elements[loop_index].Volume->geometry.is_masked_volume == 1 && global_geometry_list.elements[loop_index].Volume->geometry.mask_mode != 2)
                    // If more than one mask is added to one volume, the ANY mode overwrites the (default) ALL mode.
                    global_geometry_list.elements[loop_index].Volume->geometry.mask_mode = 1;
            }
            
            found_geometries = 1;
        }
    }
    if (found_geometries == 0) {
        printf("The mask_string in geometry: %s did not find any of the specified volumes in the mask_string %s \n",NAME_CURRENT_COMP,mask_string);
        exit(1);
    }
    this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
    this_box_volume.p_physics->is_vacuum = 0; // Makes this volume a vacuum
    this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
    this_box_volume.p_physics->my_a = 0; // Should not be used.
    sprintf(this_box_volume.p_physics->name,"Mask");
    this_box_volume.geometry.is_mask_volume = 1;
    
    
// Read the material input, or if it lacks, use automatic linking.
} else if (material_string && strlen(material_string) && strcmp(material_string, "NULL") && strcmp(material_string, "0")) {
    // A geometry string was given, use it to determine which material
    if (0 == strcmp(material_string,"vacuum") || 0 == strcmp(material_string,"Vacuum")) {
        // One could have a global physics struct for vacuum instead of creating one for each
        this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
        this_box_volume.p_physics->is_vacuum = 1; // Makes this volume a vacuum
        this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
        this_box_volume.p_physics->my_a = 0; // Should not be used.
        sprintf(this_box_volume.p_physics->name,"Vacuum");
    } else if (0 == strcmp(material_string,"exit") || 0 == strcmp(material_string,"Exit")) {
        // One could have a global physics struct for vacuum instead of creating one for each
        this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
        this_box_volume.p_physics->is_vacuum = 1; // Makes this volume a vacuum
        this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
        this_box_volume.p_physics->my_a = 0; // Should not be used.
        this_box_volume.geometry.is_exit_volume = 1;
        sprintf(this_box_volume.p_physics->name,"Exit");
    } else {
        #ifndef MATERIAL_DETECTOR
            printf("Need to define a material before refering to it in a geometry %s.\n",NAME_CURRENT_COMP);
            exit(1);
        #endif
        for (loop_index=0;loop_index<global_material_list.num_elements;loop_index++) {
            if (0 == strcmp(material_string,global_material_list.elements[loop_index].name)) {
                this_box_volume.p_physics = global_material_list.elements[loop_index].physics;
                break;
            }
            if (loop_index == global_material_list.num_elements-1) {
            printf("\n");
            printf("ERROR: The material string \"%s\" in Union geometry \"%s\" did not match a specified material. \n",material_string,NAME_CURRENT_COMP);
            printf("       The materials available at this point (need to be defined before the geometry): \n");
            for (loop_index=0;loop_index<global_material_list.num_elements;loop_index++)
              printf("         %s\n",global_material_list.elements[loop_index].name);
            printf("\n");
            printf("       It is also possible to use one of the defualt materials avaiable: \n");
            printf("           Vacuum (for a Volume without scattering or absorption)\n");
            printf("           Exit (for a Volume where the ray exits the component if it enters)\n");
            printf("           Mask (for a Volume that masks existing volumes specified in the mask_string\n");
            exit(1);
          }
        }
    }
} else {
    // Automatic linking, simply using the last defined material.
    #ifndef MATERIAL_DETECTOR
        printf("Need to define a material before the geometry to use automatic linking %s.\n",NAME_CURRENT_COMP);
        exit(1);
    #endif
    this_box_volume.p_physics = global_material_list.elements[global_material_list.num_elements-1].physics;
}

sprintf(this_box_volume.name,NAME_CURRENT_COMP);
sprintf(this_box_volume.geometry.shape,"box");
this_box_volume.geometry.priority_value = priority;
this_box_volume.geometry.geometry_p_interact = p_interact;
// Currently the coordinates will be in absolute space.
this_box_volume.geometry.center = POS_A_CURRENT_COMP;

this_box_storage.z_depth = zdepth;
this_box_storage.x_width1 = xwidth;
this_box_storage.y_height1 = yheight;

this_box_storage.is_rectangle = 0;
if (xwidth2 < 0 && yheight2 < 0) this_box_storage.is_rectangle = 1;
if (xwidth == xwidth2 && yheight == yheight2) this_box_storage.is_rectangle = 1;

if (xwidth2 < 0) {
    this_box_storage.x_width2 = xwidth;
    xwidth2 = xwidth;
} else this_box_storage.x_width2 = xwidth2;

if (yheight2 < 0) {
    this_box_storage.y_height2 = yheight;
    yheight2 = yheight;
} else this_box_storage.y_height2 = yheight2;


this_box_storage.normal_vectors[0] = coords_set(0,0,1);
this_box_storage.normal_vectors[1] = coords_set(0,0,1);

// for sides with y component = 0
x_component = 2*zdepth/sqrt((xwidth-xwidth2)*(xwidth-xwidth2)+4*zdepth*zdepth);
z_component = (xwidth-xwidth2)/sqrt(4*zdepth*zdepth+(xwidth-xwidth2)*(xwidth-xwidth2));

this_box_storage.normal_vectors[2] = coords_set(x_component,0,z_component);
this_box_storage.normal_vectors[3] = coords_set(-x_component,0,z_component);

// for sides with x component = 0
y_component = 2*zdepth/sqrt((yheight-yheight2)*(yheight-yheight2)+4*zdepth*zdepth);
z_component = (yheight-yheight2)/sqrt(4*zdepth*zdepth+(yheight-yheight2)*(yheight-yheight2));

this_box_storage.normal_vectors[4] = coords_set(0,y_component,z_component);
this_box_storage.normal_vectors[5] = coords_set(0,-y_component,z_component);

this_box_volume.geometry.visualization_on = visualize;

this_box_volume.geometry.geometry_parameters.p_box_storage = &this_box_storage;

// Assign pointers to functions for intersection with the shape, checking if a point is inside the shape
if (this_box_storage.is_rectangle == 1) {
this_box_volume.geometry.intersect_function = &sample_box_intersect_simple;
this_box_volume.geometry.within_function = &r_within_box_simple;
}
else {
this_box_volume.geometry.intersect_function = &sample_box_intersect_advanced;
this_box_volume.geometry.within_function = &r_within_box_advanced;
}

this_box_volume.geometry.shell_points = &box_shell_points;
this_box_volume.geometry.mcdisplay_function = &mcdisplay_box_function;
this_box_volume.geometry.initialize_from_main_function = &initialize_box_geometry_from_main_component;
this_box_volume.geometry.process_rot_allocated = 0;

this_box_volume.geometry.copy_geometry_parameters = &allocate_box_storage_copy;

rot_copy(this_box_volume.geometry.rotation_matrix,ROT_A_CURRENT_COMP); //check how ROT_R_CURRENT_COMP would work
rot_transpose(ROT_A_CURRENT_COMP,this_box_volume.geometry.transpose_rotation_matrix);

// Initialize loggers
this_box_volume.loggers.num_elements = 0;

// packing the information into the global_geometry_element, which is then included in the global_geometry_list.
sprintf(global_geometry_element.name,NAME_CURRENT_COMP);
global_geometry_element.activation_counter = number_of_activations;
global_geometry_element.component_index = INDEX_CURRENT_COMP;
global_geometry_element.Volume = &this_box_volume; // Would be nicer if this m was a pointer, now we have the (small) data two places
add_element_to_geometry_list(&global_geometry_list,global_geometry_element);
}
#line 178640 "MACS_sample_kidney_box.c"
#undef number_of_activations
#undef mask_setting
#undef mask_string
#undef p_interact
#undef focus_r
#undef focus_xh
#undef focus_xw
#undef focus_ah
#undef focus_aw
#undef target_z
#undef target_y
#undef target_x
#undef target_index
#undef visualize
#undef yheight2
#undef xwidth2
#undef zdepth
#undef yheight
#undef xwidth
#undef priority
#undef material_string
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

  /* Initializations for component channel_1_analyzer_2_array_crystal_array_7. */
  SIG_MESSAGE("channel_1_analyzer_2_array_crystal_array_7 (Init)");
#define mccompcurname  channel_1_analyzer_2_array_crystal_array_7
#define mccompcurtype  Union_box
#define mccompcurindex 186
#define loop_index mccchannel_1_analyzer_2_array_crystal_array_7_loop_index
#define this_box_volume mccchannel_1_analyzer_2_array_crystal_array_7_this_box_volume
#define global_geometry_element mccchannel_1_analyzer_2_array_crystal_array_7_global_geometry_element
#define this_box_storage mccchannel_1_analyzer_2_array_crystal_array_7_this_box_storage
#define material_string mccchannel_1_analyzer_2_array_crystal_array_7_material_string
#define priority mccchannel_1_analyzer_2_array_crystal_array_7_priority
#define xwidth mccchannel_1_analyzer_2_array_crystal_array_7_xwidth
#define yheight mccchannel_1_analyzer_2_array_crystal_array_7_yheight
#define zdepth mccchannel_1_analyzer_2_array_crystal_array_7_zdepth
#define xwidth2 mccchannel_1_analyzer_2_array_crystal_array_7_xwidth2
#define yheight2 mccchannel_1_analyzer_2_array_crystal_array_7_yheight2
#define visualize mccchannel_1_analyzer_2_array_crystal_array_7_visualize
#define target_index mccchannel_1_analyzer_2_array_crystal_array_7_target_index
#define target_x mccchannel_1_analyzer_2_array_crystal_array_7_target_x
#define target_y mccchannel_1_analyzer_2_array_crystal_array_7_target_y
#define target_z mccchannel_1_analyzer_2_array_crystal_array_7_target_z
#define focus_aw mccchannel_1_analyzer_2_array_crystal_array_7_focus_aw
#define focus_ah mccchannel_1_analyzer_2_array_crystal_array_7_focus_ah
#define focus_xw mccchannel_1_analyzer_2_array_crystal_array_7_focus_xw
#define focus_xh mccchannel_1_analyzer_2_array_crystal_array_7_focus_xh
#define focus_r mccchannel_1_analyzer_2_array_crystal_array_7_focus_r
#define p_interact mccchannel_1_analyzer_2_array_crystal_array_7_p_interact
#define mask_string mccchannel_1_analyzer_2_array_crystal_array_7_mask_string
#define mask_setting mccchannel_1_analyzer_2_array_crystal_array_7_mask_setting
#define number_of_activations mccchannel_1_analyzer_2_array_crystal_array_7_number_of_activations
#line 224 "Union_box.comp"
{
// Initializes the focusing system for this volume including input sanitation.
focus_initialize(&this_box_volume.geometry, POS_A_COMP_INDEX(INDEX_CURRENT_COMP+target_index), POS_A_CURRENT_COMP, ROT_A_CURRENT_COMP, target_index, target_x, target_y, target_z, focus_aw, focus_ah, focus_xw, focus_xh, focus_r, NAME_CURRENT_COMP);

// Input sanitation for this geometry
if (xwidth <= 0) {
  printf("\nERROR in Union_box named %s, the xwidth is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (yheight <= 0) {
  printf("\nERROR in Union_box named %s, yheight is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (zdepth <= 0) {
  printf("\nERROR in Union_box named %s, zdepth is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (xwidth2 <= 0 && xwidth2 != -1) {
  printf("\nERROR in Union_box named %s, the xwidth2 is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (yheight2 <= 0 && yheight2 != -1) {
  printf("\nERROR in Union_box named %s, yheight2 is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}

// Use sanitation
if (global_material_list.num_elements == 0) {
  printf("\nERROR: Need to define a material using Union_make_material before using a Union geometry component. \n");
  printf("       %s was defined before first use of Union_make_material.\n",NAME_CURRENT_COMP);
  exit(1);
}

this_box_volume.geometry.is_masked_volume = 0;
this_box_volume.geometry.is_exit_volume = 0;
this_box_volume.geometry.is_mask_volume = 0;
// check if the volume is a mask, if it is the material string is irelevant.
if (mask_string && strlen(mask_string) && strcmp(mask_string, "NULL") && strcmp(mask_string, "0")) {
    // A mask volume is used to limit the extend of other volumes, called the masked volumes. These are specified in the mask_string.
    // In order for a ray to enter a masked volume, it needs to be both in the region covered by that volume AND the mask volume.
    // When more than
    this_box_volume.geometry.mask_mode = 1; // Default is mask mode is ALL
    if (mask_setting && strlen(mask_setting) && strcmp(mask_setting, "NULL") && strcmp(mask_setting, "0")) {
        if (strcmp(mask_setting,"ALL") == 0 || strcmp(mask_setting,"All") == 0) this_box_volume.geometry.mask_mode = 1;
        else if (strcmp(mask_setting,"ANY") == 0 || strcmp(mask_setting,"Any") == 0) this_box_volume.geometry.mask_mode = 2;
        else {
            printf("The mask_mode of component %s is set to %s, but must be either ALL or ANY.\n",NAME_CURRENT_COMP,mask_setting);
            exit(1);
        }
    }
    
    for (loop_index=0;loop_index<global_geometry_list.num_elements;loop_index++) {
        // Add mask list
        if (1 == manual_linking_function(global_geometry_list.elements[loop_index].name,mask_string)) {
            add_element_to_int_list(&this_box_volume.geometry.mask_list,global_geometry_list.elements[loop_index].component_index);
            add_element_to_int_list(&global_geometry_list.elements[loop_index].Volume->geometry.masked_by_list,INDEX_CURRENT_COMP);
            global_geometry_list.elements[loop_index].Volume->geometry.is_masked_volume = 1;
            if (this_box_volume.geometry.mask_mode == 2)
                global_geometry_list.elements[loop_index].Volume->geometry.mask_mode = 2;
            if (this_box_volume.geometry.mask_mode == 1) {
                if (global_geometry_list.elements[loop_index].Volume->geometry.is_masked_volume == 1 && global_geometry_list.elements[loop_index].Volume->geometry.mask_mode != 2)
                    // If more than one mask is added to one volume, the ANY mode overwrites the (default) ALL mode.
                    global_geometry_list.elements[loop_index].Volume->geometry.mask_mode = 1;
            }
            
            found_geometries = 1;
        }
    }
    if (found_geometries == 0) {
        printf("The mask_string in geometry: %s did not find any of the specified volumes in the mask_string %s \n",NAME_CURRENT_COMP,mask_string);
        exit(1);
    }
    this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
    this_box_volume.p_physics->is_vacuum = 0; // Makes this volume a vacuum
    this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
    this_box_volume.p_physics->my_a = 0; // Should not be used.
    sprintf(this_box_volume.p_physics->name,"Mask");
    this_box_volume.geometry.is_mask_volume = 1;
    
    
// Read the material input, or if it lacks, use automatic linking.
} else if (material_string && strlen(material_string) && strcmp(material_string, "NULL") && strcmp(material_string, "0")) {
    // A geometry string was given, use it to determine which material
    if (0 == strcmp(material_string,"vacuum") || 0 == strcmp(material_string,"Vacuum")) {
        // One could have a global physics struct for vacuum instead of creating one for each
        this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
        this_box_volume.p_physics->is_vacuum = 1; // Makes this volume a vacuum
        this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
        this_box_volume.p_physics->my_a = 0; // Should not be used.
        sprintf(this_box_volume.p_physics->name,"Vacuum");
    } else if (0 == strcmp(material_string,"exit") || 0 == strcmp(material_string,"Exit")) {
        // One could have a global physics struct for vacuum instead of creating one for each
        this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
        this_box_volume.p_physics->is_vacuum = 1; // Makes this volume a vacuum
        this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
        this_box_volume.p_physics->my_a = 0; // Should not be used.
        this_box_volume.geometry.is_exit_volume = 1;
        sprintf(this_box_volume.p_physics->name,"Exit");
    } else {
        #ifndef MATERIAL_DETECTOR
            printf("Need to define a material before refering to it in a geometry %s.\n",NAME_CURRENT_COMP);
            exit(1);
        #endif
        for (loop_index=0;loop_index<global_material_list.num_elements;loop_index++) {
            if (0 == strcmp(material_string,global_material_list.elements[loop_index].name)) {
                this_box_volume.p_physics = global_material_list.elements[loop_index].physics;
                break;
            }
            if (loop_index == global_material_list.num_elements-1) {
            printf("\n");
            printf("ERROR: The material string \"%s\" in Union geometry \"%s\" did not match a specified material. \n",material_string,NAME_CURRENT_COMP);
            printf("       The materials available at this point (need to be defined before the geometry): \n");
            for (loop_index=0;loop_index<global_material_list.num_elements;loop_index++)
              printf("         %s\n",global_material_list.elements[loop_index].name);
            printf("\n");
            printf("       It is also possible to use one of the defualt materials avaiable: \n");
            printf("           Vacuum (for a Volume without scattering or absorption)\n");
            printf("           Exit (for a Volume where the ray exits the component if it enters)\n");
            printf("           Mask (for a Volume that masks existing volumes specified in the mask_string\n");
            exit(1);
          }
        }
    }
} else {
    // Automatic linking, simply using the last defined material.
    #ifndef MATERIAL_DETECTOR
        printf("Need to define a material before the geometry to use automatic linking %s.\n",NAME_CURRENT_COMP);
        exit(1);
    #endif
    this_box_volume.p_physics = global_material_list.elements[global_material_list.num_elements-1].physics;
}

sprintf(this_box_volume.name,NAME_CURRENT_COMP);
sprintf(this_box_volume.geometry.shape,"box");
this_box_volume.geometry.priority_value = priority;
this_box_volume.geometry.geometry_p_interact = p_interact;
// Currently the coordinates will be in absolute space.
this_box_volume.geometry.center = POS_A_CURRENT_COMP;

this_box_storage.z_depth = zdepth;
this_box_storage.x_width1 = xwidth;
this_box_storage.y_height1 = yheight;

this_box_storage.is_rectangle = 0;
if (xwidth2 < 0 && yheight2 < 0) this_box_storage.is_rectangle = 1;
if (xwidth == xwidth2 && yheight == yheight2) this_box_storage.is_rectangle = 1;

if (xwidth2 < 0) {
    this_box_storage.x_width2 = xwidth;
    xwidth2 = xwidth;
} else this_box_storage.x_width2 = xwidth2;

if (yheight2 < 0) {
    this_box_storage.y_height2 = yheight;
    yheight2 = yheight;
} else this_box_storage.y_height2 = yheight2;


this_box_storage.normal_vectors[0] = coords_set(0,0,1);
this_box_storage.normal_vectors[1] = coords_set(0,0,1);

// for sides with y component = 0
x_component = 2*zdepth/sqrt((xwidth-xwidth2)*(xwidth-xwidth2)+4*zdepth*zdepth);
z_component = (xwidth-xwidth2)/sqrt(4*zdepth*zdepth+(xwidth-xwidth2)*(xwidth-xwidth2));

this_box_storage.normal_vectors[2] = coords_set(x_component,0,z_component);
this_box_storage.normal_vectors[3] = coords_set(-x_component,0,z_component);

// for sides with x component = 0
y_component = 2*zdepth/sqrt((yheight-yheight2)*(yheight-yheight2)+4*zdepth*zdepth);
z_component = (yheight-yheight2)/sqrt(4*zdepth*zdepth+(yheight-yheight2)*(yheight-yheight2));

this_box_storage.normal_vectors[4] = coords_set(0,y_component,z_component);
this_box_storage.normal_vectors[5] = coords_set(0,-y_component,z_component);

this_box_volume.geometry.visualization_on = visualize;

this_box_volume.geometry.geometry_parameters.p_box_storage = &this_box_storage;

// Assign pointers to functions for intersection with the shape, checking if a point is inside the shape
if (this_box_storage.is_rectangle == 1) {
this_box_volume.geometry.intersect_function = &sample_box_intersect_simple;
this_box_volume.geometry.within_function = &r_within_box_simple;
}
else {
this_box_volume.geometry.intersect_function = &sample_box_intersect_advanced;
this_box_volume.geometry.within_function = &r_within_box_advanced;
}

this_box_volume.geometry.shell_points = &box_shell_points;
this_box_volume.geometry.mcdisplay_function = &mcdisplay_box_function;
this_box_volume.geometry.initialize_from_main_function = &initialize_box_geometry_from_main_component;
this_box_volume.geometry.process_rot_allocated = 0;

this_box_volume.geometry.copy_geometry_parameters = &allocate_box_storage_copy;

rot_copy(this_box_volume.geometry.rotation_matrix,ROT_A_CURRENT_COMP); //check how ROT_R_CURRENT_COMP would work
rot_transpose(ROT_A_CURRENT_COMP,this_box_volume.geometry.transpose_rotation_matrix);

// Initialize loggers
this_box_volume.loggers.num_elements = 0;

// packing the information into the global_geometry_element, which is then included in the global_geometry_list.
sprintf(global_geometry_element.name,NAME_CURRENT_COMP);
global_geometry_element.activation_counter = number_of_activations;
global_geometry_element.component_index = INDEX_CURRENT_COMP;
global_geometry_element.Volume = &this_box_volume; // Would be nicer if this m was a pointer, now we have the (small) data two places
add_element_to_geometry_list(&global_geometry_list,global_geometry_element);
}
#line 178910 "MACS_sample_kidney_box.c"
#undef number_of_activations
#undef mask_setting
#undef mask_string
#undef p_interact
#undef focus_r
#undef focus_xh
#undef focus_xw
#undef focus_ah
#undef focus_aw
#undef target_z
#undef target_y
#undef target_x
#undef target_index
#undef visualize
#undef yheight2
#undef xwidth2
#undef zdepth
#undef yheight
#undef xwidth
#undef priority
#undef material_string
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

  /* Initializations for component channel_1_analyzer_2_array_crystal_array_8. */
  SIG_MESSAGE("channel_1_analyzer_2_array_crystal_array_8 (Init)");
#define mccompcurname  channel_1_analyzer_2_array_crystal_array_8
#define mccompcurtype  Union_box
#define mccompcurindex 187
#define loop_index mccchannel_1_analyzer_2_array_crystal_array_8_loop_index
#define this_box_volume mccchannel_1_analyzer_2_array_crystal_array_8_this_box_volume
#define global_geometry_element mccchannel_1_analyzer_2_array_crystal_array_8_global_geometry_element
#define this_box_storage mccchannel_1_analyzer_2_array_crystal_array_8_this_box_storage
#define material_string mccchannel_1_analyzer_2_array_crystal_array_8_material_string
#define priority mccchannel_1_analyzer_2_array_crystal_array_8_priority
#define xwidth mccchannel_1_analyzer_2_array_crystal_array_8_xwidth
#define yheight mccchannel_1_analyzer_2_array_crystal_array_8_yheight
#define zdepth mccchannel_1_analyzer_2_array_crystal_array_8_zdepth
#define xwidth2 mccchannel_1_analyzer_2_array_crystal_array_8_xwidth2
#define yheight2 mccchannel_1_analyzer_2_array_crystal_array_8_yheight2
#define visualize mccchannel_1_analyzer_2_array_crystal_array_8_visualize
#define target_index mccchannel_1_analyzer_2_array_crystal_array_8_target_index
#define target_x mccchannel_1_analyzer_2_array_crystal_array_8_target_x
#define target_y mccchannel_1_analyzer_2_array_crystal_array_8_target_y
#define target_z mccchannel_1_analyzer_2_array_crystal_array_8_target_z
#define focus_aw mccchannel_1_analyzer_2_array_crystal_array_8_focus_aw
#define focus_ah mccchannel_1_analyzer_2_array_crystal_array_8_focus_ah
#define focus_xw mccchannel_1_analyzer_2_array_crystal_array_8_focus_xw
#define focus_xh mccchannel_1_analyzer_2_array_crystal_array_8_focus_xh
#define focus_r mccchannel_1_analyzer_2_array_crystal_array_8_focus_r
#define p_interact mccchannel_1_analyzer_2_array_crystal_array_8_p_interact
#define mask_string mccchannel_1_analyzer_2_array_crystal_array_8_mask_string
#define mask_setting mccchannel_1_analyzer_2_array_crystal_array_8_mask_setting
#define number_of_activations mccchannel_1_analyzer_2_array_crystal_array_8_number_of_activations
#line 224 "Union_box.comp"
{
// Initializes the focusing system for this volume including input sanitation.
focus_initialize(&this_box_volume.geometry, POS_A_COMP_INDEX(INDEX_CURRENT_COMP+target_index), POS_A_CURRENT_COMP, ROT_A_CURRENT_COMP, target_index, target_x, target_y, target_z, focus_aw, focus_ah, focus_xw, focus_xh, focus_r, NAME_CURRENT_COMP);

// Input sanitation for this geometry
if (xwidth <= 0) {
  printf("\nERROR in Union_box named %s, the xwidth is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (yheight <= 0) {
  printf("\nERROR in Union_box named %s, yheight is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (zdepth <= 0) {
  printf("\nERROR in Union_box named %s, zdepth is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (xwidth2 <= 0 && xwidth2 != -1) {
  printf("\nERROR in Union_box named %s, the xwidth2 is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (yheight2 <= 0 && yheight2 != -1) {
  printf("\nERROR in Union_box named %s, yheight2 is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}

// Use sanitation
if (global_material_list.num_elements == 0) {
  printf("\nERROR: Need to define a material using Union_make_material before using a Union geometry component. \n");
  printf("       %s was defined before first use of Union_make_material.\n",NAME_CURRENT_COMP);
  exit(1);
}

this_box_volume.geometry.is_masked_volume = 0;
this_box_volume.geometry.is_exit_volume = 0;
this_box_volume.geometry.is_mask_volume = 0;
// check if the volume is a mask, if it is the material string is irelevant.
if (mask_string && strlen(mask_string) && strcmp(mask_string, "NULL") && strcmp(mask_string, "0")) {
    // A mask volume is used to limit the extend of other volumes, called the masked volumes. These are specified in the mask_string.
    // In order for a ray to enter a masked volume, it needs to be both in the region covered by that volume AND the mask volume.
    // When more than
    this_box_volume.geometry.mask_mode = 1; // Default is mask mode is ALL
    if (mask_setting && strlen(mask_setting) && strcmp(mask_setting, "NULL") && strcmp(mask_setting, "0")) {
        if (strcmp(mask_setting,"ALL") == 0 || strcmp(mask_setting,"All") == 0) this_box_volume.geometry.mask_mode = 1;
        else if (strcmp(mask_setting,"ANY") == 0 || strcmp(mask_setting,"Any") == 0) this_box_volume.geometry.mask_mode = 2;
        else {
            printf("The mask_mode of component %s is set to %s, but must be either ALL or ANY.\n",NAME_CURRENT_COMP,mask_setting);
            exit(1);
        }
    }
    
    for (loop_index=0;loop_index<global_geometry_list.num_elements;loop_index++) {
        // Add mask list
        if (1 == manual_linking_function(global_geometry_list.elements[loop_index].name,mask_string)) {
            add_element_to_int_list(&this_box_volume.geometry.mask_list,global_geometry_list.elements[loop_index].component_index);
            add_element_to_int_list(&global_geometry_list.elements[loop_index].Volume->geometry.masked_by_list,INDEX_CURRENT_COMP);
            global_geometry_list.elements[loop_index].Volume->geometry.is_masked_volume = 1;
            if (this_box_volume.geometry.mask_mode == 2)
                global_geometry_list.elements[loop_index].Volume->geometry.mask_mode = 2;
            if (this_box_volume.geometry.mask_mode == 1) {
                if (global_geometry_list.elements[loop_index].Volume->geometry.is_masked_volume == 1 && global_geometry_list.elements[loop_index].Volume->geometry.mask_mode != 2)
                    // If more than one mask is added to one volume, the ANY mode overwrites the (default) ALL mode.
                    global_geometry_list.elements[loop_index].Volume->geometry.mask_mode = 1;
            }
            
            found_geometries = 1;
        }
    }
    if (found_geometries == 0) {
        printf("The mask_string in geometry: %s did not find any of the specified volumes in the mask_string %s \n",NAME_CURRENT_COMP,mask_string);
        exit(1);
    }
    this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
    this_box_volume.p_physics->is_vacuum = 0; // Makes this volume a vacuum
    this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
    this_box_volume.p_physics->my_a = 0; // Should not be used.
    sprintf(this_box_volume.p_physics->name,"Mask");
    this_box_volume.geometry.is_mask_volume = 1;
    
    
// Read the material input, or if it lacks, use automatic linking.
} else if (material_string && strlen(material_string) && strcmp(material_string, "NULL") && strcmp(material_string, "0")) {
    // A geometry string was given, use it to determine which material
    if (0 == strcmp(material_string,"vacuum") || 0 == strcmp(material_string,"Vacuum")) {
        // One could have a global physics struct for vacuum instead of creating one for each
        this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
        this_box_volume.p_physics->is_vacuum = 1; // Makes this volume a vacuum
        this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
        this_box_volume.p_physics->my_a = 0; // Should not be used.
        sprintf(this_box_volume.p_physics->name,"Vacuum");
    } else if (0 == strcmp(material_string,"exit") || 0 == strcmp(material_string,"Exit")) {
        // One could have a global physics struct for vacuum instead of creating one for each
        this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
        this_box_volume.p_physics->is_vacuum = 1; // Makes this volume a vacuum
        this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
        this_box_volume.p_physics->my_a = 0; // Should not be used.
        this_box_volume.geometry.is_exit_volume = 1;
        sprintf(this_box_volume.p_physics->name,"Exit");
    } else {
        #ifndef MATERIAL_DETECTOR
            printf("Need to define a material before refering to it in a geometry %s.\n",NAME_CURRENT_COMP);
            exit(1);
        #endif
        for (loop_index=0;loop_index<global_material_list.num_elements;loop_index++) {
            if (0 == strcmp(material_string,global_material_list.elements[loop_index].name)) {
                this_box_volume.p_physics = global_material_list.elements[loop_index].physics;
                break;
            }
            if (loop_index == global_material_list.num_elements-1) {
            printf("\n");
            printf("ERROR: The material string \"%s\" in Union geometry \"%s\" did not match a specified material. \n",material_string,NAME_CURRENT_COMP);
            printf("       The materials available at this point (need to be defined before the geometry): \n");
            for (loop_index=0;loop_index<global_material_list.num_elements;loop_index++)
              printf("         %s\n",global_material_list.elements[loop_index].name);
            printf("\n");
            printf("       It is also possible to use one of the defualt materials avaiable: \n");
            printf("           Vacuum (for a Volume without scattering or absorption)\n");
            printf("           Exit (for a Volume where the ray exits the component if it enters)\n");
            printf("           Mask (for a Volume that masks existing volumes specified in the mask_string\n");
            exit(1);
          }
        }
    }
} else {
    // Automatic linking, simply using the last defined material.
    #ifndef MATERIAL_DETECTOR
        printf("Need to define a material before the geometry to use automatic linking %s.\n",NAME_CURRENT_COMP);
        exit(1);
    #endif
    this_box_volume.p_physics = global_material_list.elements[global_material_list.num_elements-1].physics;
}

sprintf(this_box_volume.name,NAME_CURRENT_COMP);
sprintf(this_box_volume.geometry.shape,"box");
this_box_volume.geometry.priority_value = priority;
this_box_volume.geometry.geometry_p_interact = p_interact;
// Currently the coordinates will be in absolute space.
this_box_volume.geometry.center = POS_A_CURRENT_COMP;

this_box_storage.z_depth = zdepth;
this_box_storage.x_width1 = xwidth;
this_box_storage.y_height1 = yheight;

this_box_storage.is_rectangle = 0;
if (xwidth2 < 0 && yheight2 < 0) this_box_storage.is_rectangle = 1;
if (xwidth == xwidth2 && yheight == yheight2) this_box_storage.is_rectangle = 1;

if (xwidth2 < 0) {
    this_box_storage.x_width2 = xwidth;
    xwidth2 = xwidth;
} else this_box_storage.x_width2 = xwidth2;

if (yheight2 < 0) {
    this_box_storage.y_height2 = yheight;
    yheight2 = yheight;
} else this_box_storage.y_height2 = yheight2;


this_box_storage.normal_vectors[0] = coords_set(0,0,1);
this_box_storage.normal_vectors[1] = coords_set(0,0,1);

// for sides with y component = 0
x_component = 2*zdepth/sqrt((xwidth-xwidth2)*(xwidth-xwidth2)+4*zdepth*zdepth);
z_component = (xwidth-xwidth2)/sqrt(4*zdepth*zdepth+(xwidth-xwidth2)*(xwidth-xwidth2));

this_box_storage.normal_vectors[2] = coords_set(x_component,0,z_component);
this_box_storage.normal_vectors[3] = coords_set(-x_component,0,z_component);

// for sides with x component = 0
y_component = 2*zdepth/sqrt((yheight-yheight2)*(yheight-yheight2)+4*zdepth*zdepth);
z_component = (yheight-yheight2)/sqrt(4*zdepth*zdepth+(yheight-yheight2)*(yheight-yheight2));

this_box_storage.normal_vectors[4] = coords_set(0,y_component,z_component);
this_box_storage.normal_vectors[5] = coords_set(0,-y_component,z_component);

this_box_volume.geometry.visualization_on = visualize;

this_box_volume.geometry.geometry_parameters.p_box_storage = &this_box_storage;

// Assign pointers to functions for intersection with the shape, checking if a point is inside the shape
if (this_box_storage.is_rectangle == 1) {
this_box_volume.geometry.intersect_function = &sample_box_intersect_simple;
this_box_volume.geometry.within_function = &r_within_box_simple;
}
else {
this_box_volume.geometry.intersect_function = &sample_box_intersect_advanced;
this_box_volume.geometry.within_function = &r_within_box_advanced;
}

this_box_volume.geometry.shell_points = &box_shell_points;
this_box_volume.geometry.mcdisplay_function = &mcdisplay_box_function;
this_box_volume.geometry.initialize_from_main_function = &initialize_box_geometry_from_main_component;
this_box_volume.geometry.process_rot_allocated = 0;

this_box_volume.geometry.copy_geometry_parameters = &allocate_box_storage_copy;

rot_copy(this_box_volume.geometry.rotation_matrix,ROT_A_CURRENT_COMP); //check how ROT_R_CURRENT_COMP would work
rot_transpose(ROT_A_CURRENT_COMP,this_box_volume.geometry.transpose_rotation_matrix);

// Initialize loggers
this_box_volume.loggers.num_elements = 0;

// packing the information into the global_geometry_element, which is then included in the global_geometry_list.
sprintf(global_geometry_element.name,NAME_CURRENT_COMP);
global_geometry_element.activation_counter = number_of_activations;
global_geometry_element.component_index = INDEX_CURRENT_COMP;
global_geometry_element.Volume = &this_box_volume; // Would be nicer if this m was a pointer, now we have the (small) data two places
add_element_to_geometry_list(&global_geometry_list,global_geometry_element);
}
#line 179180 "MACS_sample_kidney_box.c"
#undef number_of_activations
#undef mask_setting
#undef mask_string
#undef p_interact
#undef focus_r
#undef focus_xh
#undef focus_xw
#undef focus_ah
#undef focus_aw
#undef target_z
#undef target_y
#undef target_x
#undef target_index
#undef visualize
#undef yheight2
#undef xwidth2
#undef zdepth
#undef yheight
#undef xwidth
#undef priority
#undef material_string
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

  /* Initializations for component channel_1_cave2_cyl1. */
  SIG_MESSAGE("channel_1_cave2_cyl1 (Init)");
#define mccompcurname  channel_1_cave2_cyl1
#define mccompcurtype  Union_cylinder
#define mccompcurindex 188
#define loop_index mccchannel_1_cave2_cyl1_loop_index
#define this_cylinder_volume mccchannel_1_cave2_cyl1_this_cylinder_volume
#define global_geometry_element mccchannel_1_cave2_cyl1_global_geometry_element
#define this_cylinder_storage mccchannel_1_cave2_cyl1_this_cylinder_storage
#define material_string mccchannel_1_cave2_cyl1_material_string
#define priority mccchannel_1_cave2_cyl1_priority
#define radius mccchannel_1_cave2_cyl1_radius
#define yheight mccchannel_1_cave2_cyl1_yheight
#define visualize mccchannel_1_cave2_cyl1_visualize
#define target_index mccchannel_1_cave2_cyl1_target_index
#define target_x mccchannel_1_cave2_cyl1_target_x
#define target_y mccchannel_1_cave2_cyl1_target_y
#define target_z mccchannel_1_cave2_cyl1_target_z
#define focus_aw mccchannel_1_cave2_cyl1_focus_aw
#define focus_ah mccchannel_1_cave2_cyl1_focus_ah
#define focus_xw mccchannel_1_cave2_cyl1_focus_xw
#define focus_xh mccchannel_1_cave2_cyl1_focus_xh
#define focus_r mccchannel_1_cave2_cyl1_focus_r
#define p_interact mccchannel_1_cave2_cyl1_p_interact
#define mask_string mccchannel_1_cave2_cyl1_mask_string
#define mask_setting mccchannel_1_cave2_cyl1_mask_setting
#define number_of_activations mccchannel_1_cave2_cyl1_number_of_activations
#line 185 "Union_cylinder.comp"
{
// Initializes the focusing system for this volume including input sanitation.
focus_initialize(&this_cylinder_volume.geometry, POS_A_COMP_INDEX(INDEX_CURRENT_COMP+target_index), POS_A_CURRENT_COMP, ROT_A_CURRENT_COMP, target_index, target_x, target_y, target_z, focus_aw, focus_ah, focus_xw, focus_xh, focus_r, NAME_CURRENT_COMP);

// Input sanitation for this geometry
if (radius <= 0) {
  printf("\nERROR in Union_cylinder named %s, the radius is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}

if (yheight <= 0) {
  printf("\nERROR in Union_cylinder named %s, yheight is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}

// Use sanitation
#ifdef MATERIAL_DETECTOR
if (global_material_list.num_elements == 0) {
  // Here if the user have defined a material, but only after this material
  printf("\nERROR: Need to define a material using Union_make_material before using a Union geometry component. \n");
  printf("       %s was defined before first use of Union_make_material.\n",NAME_CURRENT_COMP);
  exit(1);
}
#endif
#ifndef MATERIAL_DETECTOR
  printf("\nERROR: Need to define a material using Union_make_material before using a Union geometry component. \n");
  exit(1);
#endif


this_cylinder_volume.geometry.is_masked_volume = 0;
this_cylinder_volume.geometry.is_exit_volume = 0;
this_cylinder_volume.geometry.is_mask_volume = 0;

// Read the material input, or if it lacks, use automatic linking.
if (mask_string && strlen(mask_string) && strcmp(mask_string, "NULL") && strcmp(mask_string, "0")) {
    // A mask volume is used to limit the extend of other volumes, called the masked volumes. These are specified in the mask_string.
    // In order for a ray to enter a masked volume, it needs to be both in the region covered by that volume AND the mask volume.
    // When more than
    this_cylinder_volume.geometry.mask_mode = 1; // Default is mask mode is ALL
    if (mask_setting && strlen(mask_setting) && strcmp(mask_setting, "NULL") && strcmp(mask_setting, "0")) {
        if (strcmp(mask_setting,"ALL") == 0 || strcmp(mask_setting,"All") == 0) this_cylinder_volume.geometry.mask_mode = 1;
        else if (strcmp(mask_setting,"ANY") == 0 || strcmp(mask_setting,"Any") == 0) this_cylinder_volume.geometry.mask_mode = 2;
        else {
            printf("The mask_mode of component %s is set to %s, but must be either ALL or ANY.\n",NAME_CURRENT_COMP,mask_setting);
            exit(1);
        }
    }
    
    for (loop_index=0;loop_index<global_geometry_list.num_elements;loop_index++) {
        // Add mask list
        if (1 == manual_linking_function(global_geometry_list.elements[loop_index].name,mask_string)) {
            add_element_to_int_list(&this_cylinder_volume.geometry.mask_list,global_geometry_list.elements[loop_index].component_index);
            add_element_to_int_list(&global_geometry_list.elements[loop_index].Volume->geometry.masked_by_list,INDEX_CURRENT_COMP);
            global_geometry_list.elements[loop_index].Volume->geometry.is_masked_volume = 1;
            if (this_cylinder_volume.geometry.mask_mode == 2)
                global_geometry_list.elements[loop_index].Volume->geometry.mask_mode = 2;
            if (this_cylinder_volume.geometry.mask_mode == 1) {
                if (global_geometry_list.elements[loop_index].Volume->geometry.is_masked_volume == 1 && global_geometry_list.elements[loop_index].Volume->geometry.mask_mode != 2)
                    // If more than one mask is added to one volume, the ANY mode overwrites the (default) ALL mode.
                    global_geometry_list.elements[loop_index].Volume->geometry.mask_mode = 1;
            }
            
            found_geometries = 1;
        }
    }
    if (found_geometries == 0) {
        printf("The mask_string in geometry: %s did not find any of the specified volumes in the mask_string %s \n",NAME_CURRENT_COMP,mask_string);
        exit(1);
    }
    this_cylinder_volume.p_physics = malloc(sizeof(struct physics_struct));
    this_cylinder_volume.p_physics->is_vacuum = 0; // Makes this volume a vacuum
    this_cylinder_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
    this_cylinder_volume.p_physics->my_a = 0; // Should not be used.
    sprintf(this_cylinder_volume.p_physics->name,"Mask");
    this_cylinder_volume.geometry.is_mask_volume = 1;
    
    
// Read the material input, or if it lacks, use automatic linking.
} else if (material_string && strlen(material_string) && strcmp(material_string, "NULL") && strcmp(material_string, "0")) {
    // A geometry string was given, use it to determine which material
    if (0 == strcmp(material_string,"vacuum") || 0 == strcmp(material_string,"Vacuum")) {
        // One could have a global physics struct for vacuum instead of creating one for each
        this_cylinder_volume.p_physics = malloc(sizeof(struct physics_struct));
        this_cylinder_volume.p_physics->is_vacuum = 1; // Makes this volume a vacuum
        this_cylinder_volume.p_physics->number_of_processes = (int) 0;
        this_cylinder_volume.p_physics->my_a = 0; // Should not be used.
        sprintf(this_cylinder_volume.p_physics->name,"Vacuum");
    } else if (0 == strcmp(material_string,"exit") || 0 == strcmp(material_string,"Exit")) {
        // One could have a global physics struct for exit instead of creating one for each
        this_cylinder_volume.p_physics = malloc(sizeof(struct physics_struct));
        this_cylinder_volume.p_physics->is_vacuum = 1; // Makes this volume a vacuum
        this_cylinder_volume.p_physics->number_of_processes = (int) 0;
        this_cylinder_volume.p_physics->my_a = 0; // Should not be used.
        this_cylinder_volume.geometry.is_exit_volume = 1;
        sprintf(this_cylinder_volume.p_physics->name,"Exit");
    } else {
        for (loop_index=0;loop_index<global_material_list.num_elements;loop_index++) {
          if (0 == strcmp(material_string,global_material_list.elements[loop_index].name)) {
            this_cylinder_volume.p_physics = global_material_list.elements[loop_index].physics;
            break;
          }
          if (loop_index == global_material_list.num_elements-1) {
            printf("\n");
            printf("ERROR: The material string \"%s\" in Union geometry \"%s\" did not match a specified material. \n",material_string,NAME_CURRENT_COMP);
            printf("       The materials available at this point (need to be defined before the geometry): \n");
            for (loop_index=0;loop_index<global_material_list.num_elements;loop_index++)
              printf("         %s\n",global_material_list.elements[loop_index].name);
            printf("\n");
            printf("       It is also possible to use one of the defualt materials avaiable: \n");
            printf("           Vacuum (for a Volume without scattering or absorption)\n");
            printf("           Exit (for a Volume where the ray exits the component if it enters)\n");
            printf("           Mask (for a Volume that masks existing volumes specified in the mask_string\n");
            exit(1);
          }
        }
    }
} else {
    // Automatic linking, simply using the last defined material.
    #ifndef MATERIAL_DETECTOR
        printf("Need to define a material before the geometry to use automatic linking %s.\n",NAME_CURRENT_COMP);
        exit(1);
    #endif
    this_cylinder_volume.p_physics = global_material_list.elements[global_material_list.num_elements-1].physics;
}

sprintf(this_cylinder_volume.name,NAME_CURRENT_COMP);
sprintf(this_cylinder_volume.geometry.shape,"cylinder");
this_cylinder_volume.geometry.priority_value = priority;
// Currently the coordinates will be in absolute space.
this_cylinder_volume.geometry.center = POS_A_CURRENT_COMP;

this_cylinder_volume.geometry.geometry_p_interact = p_interact;
this_cylinder_storage.cyl_radius = radius;
this_cylinder_storage.height = yheight;
this_cylinder_volume.geometry.visualization_on = visualize;
this_cylinder_volume.geometry.geometry_parameters.p_cylinder_storage = &this_cylinder_storage;
this_cylinder_volume.geometry.within_function = &r_within_cylinder;
this_cylinder_volume.geometry.intersect_function = &sample_cylinder_intersect;
this_cylinder_volume.geometry.mcdisplay_function = &mcdisplay_cylinder_function;
this_cylinder_volume.geometry.shell_points = &cylinder_shell_points;
this_cylinder_volume.geometry.initialize_from_main_function = &initialize_cylinder_geometry_from_main_component;
this_cylinder_volume.geometry.process_rot_allocated = 0;
this_cylinder_volume.geometry.copy_geometry_parameters = &allocate_cylinder_storage_copy;

rot_copy(this_cylinder_volume.geometry.rotation_matrix,ROT_A_CURRENT_COMP);
rot_transpose(ROT_A_CURRENT_COMP,this_cylinder_volume.geometry.transpose_rotation_matrix);

// Initialize loggers
this_cylinder_volume.loggers.num_elements = 0;

// packing the information into the global_geometry_element, which is then included in the global_geometry_list.
sprintf(global_geometry_element.name,NAME_CURRENT_COMP);
global_geometry_element.activation_counter = number_of_activations;
global_geometry_element.component_index = INDEX_CURRENT_COMP;
global_geometry_element.Volume = &this_cylinder_volume; // Would be nicer if this m was a pointer, now we have the (small) data two places
add_element_to_geometry_list(&global_geometry_list,global_geometry_element);
}
#line 179396 "MACS_sample_kidney_box.c"
#undef number_of_activations
#undef mask_setting
#undef mask_string
#undef p_interact
#undef focus_r
#undef focus_xh
#undef focus_xw
#undef focus_ah
#undef focus_aw
#undef target_z
#undef target_y
#undef target_x
#undef target_index
#undef visualize
#undef yheight
#undef radius
#undef priority
#undef material_string
#undef this_cylinder_storage
#undef global_geometry_element
#undef this_cylinder_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

  /* Initializations for component channel_1_cave2_box1. */
  SIG_MESSAGE("channel_1_cave2_box1 (Init)");
#define mccompcurname  channel_1_cave2_box1
#define mccompcurtype  Union_box
#define mccompcurindex 189
#define loop_index mccchannel_1_cave2_box1_loop_index
#define this_box_volume mccchannel_1_cave2_box1_this_box_volume
#define global_geometry_element mccchannel_1_cave2_box1_global_geometry_element
#define this_box_storage mccchannel_1_cave2_box1_this_box_storage
#define material_string mccchannel_1_cave2_box1_material_string
#define priority mccchannel_1_cave2_box1_priority
#define xwidth mccchannel_1_cave2_box1_xwidth
#define yheight mccchannel_1_cave2_box1_yheight
#define zdepth mccchannel_1_cave2_box1_zdepth
#define xwidth2 mccchannel_1_cave2_box1_xwidth2
#define yheight2 mccchannel_1_cave2_box1_yheight2
#define visualize mccchannel_1_cave2_box1_visualize
#define target_index mccchannel_1_cave2_box1_target_index
#define target_x mccchannel_1_cave2_box1_target_x
#define target_y mccchannel_1_cave2_box1_target_y
#define target_z mccchannel_1_cave2_box1_target_z
#define focus_aw mccchannel_1_cave2_box1_focus_aw
#define focus_ah mccchannel_1_cave2_box1_focus_ah
#define focus_xw mccchannel_1_cave2_box1_focus_xw
#define focus_xh mccchannel_1_cave2_box1_focus_xh
#define focus_r mccchannel_1_cave2_box1_focus_r
#define p_interact mccchannel_1_cave2_box1_p_interact
#define mask_string mccchannel_1_cave2_box1_mask_string
#define mask_setting mccchannel_1_cave2_box1_mask_setting
#define number_of_activations mccchannel_1_cave2_box1_number_of_activations
#line 224 "Union_box.comp"
{
// Initializes the focusing system for this volume including input sanitation.
focus_initialize(&this_box_volume.geometry, POS_A_COMP_INDEX(INDEX_CURRENT_COMP+target_index), POS_A_CURRENT_COMP, ROT_A_CURRENT_COMP, target_index, target_x, target_y, target_z, focus_aw, focus_ah, focus_xw, focus_xh, focus_r, NAME_CURRENT_COMP);

// Input sanitation for this geometry
if (xwidth <= 0) {
  printf("\nERROR in Union_box named %s, the xwidth is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (yheight <= 0) {
  printf("\nERROR in Union_box named %s, yheight is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (zdepth <= 0) {
  printf("\nERROR in Union_box named %s, zdepth is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (xwidth2 <= 0 && xwidth2 != -1) {
  printf("\nERROR in Union_box named %s, the xwidth2 is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (yheight2 <= 0 && yheight2 != -1) {
  printf("\nERROR in Union_box named %s, yheight2 is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}

// Use sanitation
if (global_material_list.num_elements == 0) {
  printf("\nERROR: Need to define a material using Union_make_material before using a Union geometry component. \n");
  printf("       %s was defined before first use of Union_make_material.\n",NAME_CURRENT_COMP);
  exit(1);
}

this_box_volume.geometry.is_masked_volume = 0;
this_box_volume.geometry.is_exit_volume = 0;
this_box_volume.geometry.is_mask_volume = 0;
// check if the volume is a mask, if it is the material string is irelevant.
if (mask_string && strlen(mask_string) && strcmp(mask_string, "NULL") && strcmp(mask_string, "0")) {
    // A mask volume is used to limit the extend of other volumes, called the masked volumes. These are specified in the mask_string.
    // In order for a ray to enter a masked volume, it needs to be both in the region covered by that volume AND the mask volume.
    // When more than
    this_box_volume.geometry.mask_mode = 1; // Default is mask mode is ALL
    if (mask_setting && strlen(mask_setting) && strcmp(mask_setting, "NULL") && strcmp(mask_setting, "0")) {
        if (strcmp(mask_setting,"ALL") == 0 || strcmp(mask_setting,"All") == 0) this_box_volume.geometry.mask_mode = 1;
        else if (strcmp(mask_setting,"ANY") == 0 || strcmp(mask_setting,"Any") == 0) this_box_volume.geometry.mask_mode = 2;
        else {
            printf("The mask_mode of component %s is set to %s, but must be either ALL or ANY.\n",NAME_CURRENT_COMP,mask_setting);
            exit(1);
        }
    }
    
    for (loop_index=0;loop_index<global_geometry_list.num_elements;loop_index++) {
        // Add mask list
        if (1 == manual_linking_function(global_geometry_list.elements[loop_index].name,mask_string)) {
            add_element_to_int_list(&this_box_volume.geometry.mask_list,global_geometry_list.elements[loop_index].component_index);
            add_element_to_int_list(&global_geometry_list.elements[loop_index].Volume->geometry.masked_by_list,INDEX_CURRENT_COMP);
            global_geometry_list.elements[loop_index].Volume->geometry.is_masked_volume = 1;
            if (this_box_volume.geometry.mask_mode == 2)
                global_geometry_list.elements[loop_index].Volume->geometry.mask_mode = 2;
            if (this_box_volume.geometry.mask_mode == 1) {
                if (global_geometry_list.elements[loop_index].Volume->geometry.is_masked_volume == 1 && global_geometry_list.elements[loop_index].Volume->geometry.mask_mode != 2)
                    // If more than one mask is added to one volume, the ANY mode overwrites the (default) ALL mode.
                    global_geometry_list.elements[loop_index].Volume->geometry.mask_mode = 1;
            }
            
            found_geometries = 1;
        }
    }
    if (found_geometries == 0) {
        printf("The mask_string in geometry: %s did not find any of the specified volumes in the mask_string %s \n",NAME_CURRENT_COMP,mask_string);
        exit(1);
    }
    this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
    this_box_volume.p_physics->is_vacuum = 0; // Makes this volume a vacuum
    this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
    this_box_volume.p_physics->my_a = 0; // Should not be used.
    sprintf(this_box_volume.p_physics->name,"Mask");
    this_box_volume.geometry.is_mask_volume = 1;
    
    
// Read the material input, or if it lacks, use automatic linking.
} else if (material_string && strlen(material_string) && strcmp(material_string, "NULL") && strcmp(material_string, "0")) {
    // A geometry string was given, use it to determine which material
    if (0 == strcmp(material_string,"vacuum") || 0 == strcmp(material_string,"Vacuum")) {
        // One could have a global physics struct for vacuum instead of creating one for each
        this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
        this_box_volume.p_physics->is_vacuum = 1; // Makes this volume a vacuum
        this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
        this_box_volume.p_physics->my_a = 0; // Should not be used.
        sprintf(this_box_volume.p_physics->name,"Vacuum");
    } else if (0 == strcmp(material_string,"exit") || 0 == strcmp(material_string,"Exit")) {
        // One could have a global physics struct for vacuum instead of creating one for each
        this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
        this_box_volume.p_physics->is_vacuum = 1; // Makes this volume a vacuum
        this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
        this_box_volume.p_physics->my_a = 0; // Should not be used.
        this_box_volume.geometry.is_exit_volume = 1;
        sprintf(this_box_volume.p_physics->name,"Exit");
    } else {
        #ifndef MATERIAL_DETECTOR
            printf("Need to define a material before refering to it in a geometry %s.\n",NAME_CURRENT_COMP);
            exit(1);
        #endif
        for (loop_index=0;loop_index<global_material_list.num_elements;loop_index++) {
            if (0 == strcmp(material_string,global_material_list.elements[loop_index].name)) {
                this_box_volume.p_physics = global_material_list.elements[loop_index].physics;
                break;
            }
            if (loop_index == global_material_list.num_elements-1) {
            printf("\n");
            printf("ERROR: The material string \"%s\" in Union geometry \"%s\" did not match a specified material. \n",material_string,NAME_CURRENT_COMP);
            printf("       The materials available at this point (need to be defined before the geometry): \n");
            for (loop_index=0;loop_index<global_material_list.num_elements;loop_index++)
              printf("         %s\n",global_material_list.elements[loop_index].name);
            printf("\n");
            printf("       It is also possible to use one of the defualt materials avaiable: \n");
            printf("           Vacuum (for a Volume without scattering or absorption)\n");
            printf("           Exit (for a Volume where the ray exits the component if it enters)\n");
            printf("           Mask (for a Volume that masks existing volumes specified in the mask_string\n");
            exit(1);
          }
        }
    }
} else {
    // Automatic linking, simply using the last defined material.
    #ifndef MATERIAL_DETECTOR
        printf("Need to define a material before the geometry to use automatic linking %s.\n",NAME_CURRENT_COMP);
        exit(1);
    #endif
    this_box_volume.p_physics = global_material_list.elements[global_material_list.num_elements-1].physics;
}

sprintf(this_box_volume.name,NAME_CURRENT_COMP);
sprintf(this_box_volume.geometry.shape,"box");
this_box_volume.geometry.priority_value = priority;
this_box_volume.geometry.geometry_p_interact = p_interact;
// Currently the coordinates will be in absolute space.
this_box_volume.geometry.center = POS_A_CURRENT_COMP;

this_box_storage.z_depth = zdepth;
this_box_storage.x_width1 = xwidth;
this_box_storage.y_height1 = yheight;

this_box_storage.is_rectangle = 0;
if (xwidth2 < 0 && yheight2 < 0) this_box_storage.is_rectangle = 1;
if (xwidth == xwidth2 && yheight == yheight2) this_box_storage.is_rectangle = 1;

if (xwidth2 < 0) {
    this_box_storage.x_width2 = xwidth;
    xwidth2 = xwidth;
} else this_box_storage.x_width2 = xwidth2;

if (yheight2 < 0) {
    this_box_storage.y_height2 = yheight;
    yheight2 = yheight;
} else this_box_storage.y_height2 = yheight2;


this_box_storage.normal_vectors[0] = coords_set(0,0,1);
this_box_storage.normal_vectors[1] = coords_set(0,0,1);

// for sides with y component = 0
x_component = 2*zdepth/sqrt((xwidth-xwidth2)*(xwidth-xwidth2)+4*zdepth*zdepth);
z_component = (xwidth-xwidth2)/sqrt(4*zdepth*zdepth+(xwidth-xwidth2)*(xwidth-xwidth2));

this_box_storage.normal_vectors[2] = coords_set(x_component,0,z_component);
this_box_storage.normal_vectors[3] = coords_set(-x_component,0,z_component);

// for sides with x component = 0
y_component = 2*zdepth/sqrt((yheight-yheight2)*(yheight-yheight2)+4*zdepth*zdepth);
z_component = (yheight-yheight2)/sqrt(4*zdepth*zdepth+(yheight-yheight2)*(yheight-yheight2));

this_box_storage.normal_vectors[4] = coords_set(0,y_component,z_component);
this_box_storage.normal_vectors[5] = coords_set(0,-y_component,z_component);

this_box_volume.geometry.visualization_on = visualize;

this_box_volume.geometry.geometry_parameters.p_box_storage = &this_box_storage;

// Assign pointers to functions for intersection with the shape, checking if a point is inside the shape
if (this_box_storage.is_rectangle == 1) {
this_box_volume.geometry.intersect_function = &sample_box_intersect_simple;
this_box_volume.geometry.within_function = &r_within_box_simple;
}
else {
this_box_volume.geometry.intersect_function = &sample_box_intersect_advanced;
this_box_volume.geometry.within_function = &r_within_box_advanced;
}

this_box_volume.geometry.shell_points = &box_shell_points;
this_box_volume.geometry.mcdisplay_function = &mcdisplay_box_function;
this_box_volume.geometry.initialize_from_main_function = &initialize_box_geometry_from_main_component;
this_box_volume.geometry.process_rot_allocated = 0;

this_box_volume.geometry.copy_geometry_parameters = &allocate_box_storage_copy;

rot_copy(this_box_volume.geometry.rotation_matrix,ROT_A_CURRENT_COMP); //check how ROT_R_CURRENT_COMP would work
rot_transpose(ROT_A_CURRENT_COMP,this_box_volume.geometry.transpose_rotation_matrix);

// Initialize loggers
this_box_volume.loggers.num_elements = 0;

// packing the information into the global_geometry_element, which is then included in the global_geometry_list.
sprintf(global_geometry_element.name,NAME_CURRENT_COMP);
global_geometry_element.activation_counter = number_of_activations;
global_geometry_element.component_index = INDEX_CURRENT_COMP;
global_geometry_element.Volume = &this_box_volume; // Would be nicer if this m was a pointer, now we have the (small) data two places
add_element_to_geometry_list(&global_geometry_list,global_geometry_element);
}
#line 179663 "MACS_sample_kidney_box.c"
#undef number_of_activations
#undef mask_setting
#undef mask_string
#undef p_interact
#undef focus_r
#undef focus_xh
#undef focus_xw
#undef focus_ah
#undef focus_aw
#undef target_z
#undef target_y
#undef target_x
#undef target_index
#undef visualize
#undef yheight2
#undef xwidth2
#undef zdepth
#undef yheight
#undef xwidth
#undef priority
#undef material_string
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

  /* Initializations for component channel_1_cave2_box2. */
  SIG_MESSAGE("channel_1_cave2_box2 (Init)");
#define mccompcurname  channel_1_cave2_box2
#define mccompcurtype  Union_box
#define mccompcurindex 190
#define loop_index mccchannel_1_cave2_box2_loop_index
#define this_box_volume mccchannel_1_cave2_box2_this_box_volume
#define global_geometry_element mccchannel_1_cave2_box2_global_geometry_element
#define this_box_storage mccchannel_1_cave2_box2_this_box_storage
#define material_string mccchannel_1_cave2_box2_material_string
#define priority mccchannel_1_cave2_box2_priority
#define xwidth mccchannel_1_cave2_box2_xwidth
#define yheight mccchannel_1_cave2_box2_yheight
#define zdepth mccchannel_1_cave2_box2_zdepth
#define xwidth2 mccchannel_1_cave2_box2_xwidth2
#define yheight2 mccchannel_1_cave2_box2_yheight2
#define visualize mccchannel_1_cave2_box2_visualize
#define target_index mccchannel_1_cave2_box2_target_index
#define target_x mccchannel_1_cave2_box2_target_x
#define target_y mccchannel_1_cave2_box2_target_y
#define target_z mccchannel_1_cave2_box2_target_z
#define focus_aw mccchannel_1_cave2_box2_focus_aw
#define focus_ah mccchannel_1_cave2_box2_focus_ah
#define focus_xw mccchannel_1_cave2_box2_focus_xw
#define focus_xh mccchannel_1_cave2_box2_focus_xh
#define focus_r mccchannel_1_cave2_box2_focus_r
#define p_interact mccchannel_1_cave2_box2_p_interact
#define mask_string mccchannel_1_cave2_box2_mask_string
#define mask_setting mccchannel_1_cave2_box2_mask_setting
#define number_of_activations mccchannel_1_cave2_box2_number_of_activations
#line 224 "Union_box.comp"
{
// Initializes the focusing system for this volume including input sanitation.
focus_initialize(&this_box_volume.geometry, POS_A_COMP_INDEX(INDEX_CURRENT_COMP+target_index), POS_A_CURRENT_COMP, ROT_A_CURRENT_COMP, target_index, target_x, target_y, target_z, focus_aw, focus_ah, focus_xw, focus_xh, focus_r, NAME_CURRENT_COMP);

// Input sanitation for this geometry
if (xwidth <= 0) {
  printf("\nERROR in Union_box named %s, the xwidth is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (yheight <= 0) {
  printf("\nERROR in Union_box named %s, yheight is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (zdepth <= 0) {
  printf("\nERROR in Union_box named %s, zdepth is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (xwidth2 <= 0 && xwidth2 != -1) {
  printf("\nERROR in Union_box named %s, the xwidth2 is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (yheight2 <= 0 && yheight2 != -1) {
  printf("\nERROR in Union_box named %s, yheight2 is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}

// Use sanitation
if (global_material_list.num_elements == 0) {
  printf("\nERROR: Need to define a material using Union_make_material before using a Union geometry component. \n");
  printf("       %s was defined before first use of Union_make_material.\n",NAME_CURRENT_COMP);
  exit(1);
}

this_box_volume.geometry.is_masked_volume = 0;
this_box_volume.geometry.is_exit_volume = 0;
this_box_volume.geometry.is_mask_volume = 0;
// check if the volume is a mask, if it is the material string is irelevant.
if (mask_string && strlen(mask_string) && strcmp(mask_string, "NULL") && strcmp(mask_string, "0")) {
    // A mask volume is used to limit the extend of other volumes, called the masked volumes. These are specified in the mask_string.
    // In order for a ray to enter a masked volume, it needs to be both in the region covered by that volume AND the mask volume.
    // When more than
    this_box_volume.geometry.mask_mode = 1; // Default is mask mode is ALL
    if (mask_setting && strlen(mask_setting) && strcmp(mask_setting, "NULL") && strcmp(mask_setting, "0")) {
        if (strcmp(mask_setting,"ALL") == 0 || strcmp(mask_setting,"All") == 0) this_box_volume.geometry.mask_mode = 1;
        else if (strcmp(mask_setting,"ANY") == 0 || strcmp(mask_setting,"Any") == 0) this_box_volume.geometry.mask_mode = 2;
        else {
            printf("The mask_mode of component %s is set to %s, but must be either ALL or ANY.\n",NAME_CURRENT_COMP,mask_setting);
            exit(1);
        }
    }
    
    for (loop_index=0;loop_index<global_geometry_list.num_elements;loop_index++) {
        // Add mask list
        if (1 == manual_linking_function(global_geometry_list.elements[loop_index].name,mask_string)) {
            add_element_to_int_list(&this_box_volume.geometry.mask_list,global_geometry_list.elements[loop_index].component_index);
            add_element_to_int_list(&global_geometry_list.elements[loop_index].Volume->geometry.masked_by_list,INDEX_CURRENT_COMP);
            global_geometry_list.elements[loop_index].Volume->geometry.is_masked_volume = 1;
            if (this_box_volume.geometry.mask_mode == 2)
                global_geometry_list.elements[loop_index].Volume->geometry.mask_mode = 2;
            if (this_box_volume.geometry.mask_mode == 1) {
                if (global_geometry_list.elements[loop_index].Volume->geometry.is_masked_volume == 1 && global_geometry_list.elements[loop_index].Volume->geometry.mask_mode != 2)
                    // If more than one mask is added to one volume, the ANY mode overwrites the (default) ALL mode.
                    global_geometry_list.elements[loop_index].Volume->geometry.mask_mode = 1;
            }
            
            found_geometries = 1;
        }
    }
    if (found_geometries == 0) {
        printf("The mask_string in geometry: %s did not find any of the specified volumes in the mask_string %s \n",NAME_CURRENT_COMP,mask_string);
        exit(1);
    }
    this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
    this_box_volume.p_physics->is_vacuum = 0; // Makes this volume a vacuum
    this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
    this_box_volume.p_physics->my_a = 0; // Should not be used.
    sprintf(this_box_volume.p_physics->name,"Mask");
    this_box_volume.geometry.is_mask_volume = 1;
    
    
// Read the material input, or if it lacks, use automatic linking.
} else if (material_string && strlen(material_string) && strcmp(material_string, "NULL") && strcmp(material_string, "0")) {
    // A geometry string was given, use it to determine which material
    if (0 == strcmp(material_string,"vacuum") || 0 == strcmp(material_string,"Vacuum")) {
        // One could have a global physics struct for vacuum instead of creating one for each
        this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
        this_box_volume.p_physics->is_vacuum = 1; // Makes this volume a vacuum
        this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
        this_box_volume.p_physics->my_a = 0; // Should not be used.
        sprintf(this_box_volume.p_physics->name,"Vacuum");
    } else if (0 == strcmp(material_string,"exit") || 0 == strcmp(material_string,"Exit")) {
        // One could have a global physics struct for vacuum instead of creating one for each
        this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
        this_box_volume.p_physics->is_vacuum = 1; // Makes this volume a vacuum
        this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
        this_box_volume.p_physics->my_a = 0; // Should not be used.
        this_box_volume.geometry.is_exit_volume = 1;
        sprintf(this_box_volume.p_physics->name,"Exit");
    } else {
        #ifndef MATERIAL_DETECTOR
            printf("Need to define a material before refering to it in a geometry %s.\n",NAME_CURRENT_COMP);
            exit(1);
        #endif
        for (loop_index=0;loop_index<global_material_list.num_elements;loop_index++) {
            if (0 == strcmp(material_string,global_material_list.elements[loop_index].name)) {
                this_box_volume.p_physics = global_material_list.elements[loop_index].physics;
                break;
            }
            if (loop_index == global_material_list.num_elements-1) {
            printf("\n");
            printf("ERROR: The material string \"%s\" in Union geometry \"%s\" did not match a specified material. \n",material_string,NAME_CURRENT_COMP);
            printf("       The materials available at this point (need to be defined before the geometry): \n");
            for (loop_index=0;loop_index<global_material_list.num_elements;loop_index++)
              printf("         %s\n",global_material_list.elements[loop_index].name);
            printf("\n");
            printf("       It is also possible to use one of the defualt materials avaiable: \n");
            printf("           Vacuum (for a Volume without scattering or absorption)\n");
            printf("           Exit (for a Volume where the ray exits the component if it enters)\n");
            printf("           Mask (for a Volume that masks existing volumes specified in the mask_string\n");
            exit(1);
          }
        }
    }
} else {
    // Automatic linking, simply using the last defined material.
    #ifndef MATERIAL_DETECTOR
        printf("Need to define a material before the geometry to use automatic linking %s.\n",NAME_CURRENT_COMP);
        exit(1);
    #endif
    this_box_volume.p_physics = global_material_list.elements[global_material_list.num_elements-1].physics;
}

sprintf(this_box_volume.name,NAME_CURRENT_COMP);
sprintf(this_box_volume.geometry.shape,"box");
this_box_volume.geometry.priority_value = priority;
this_box_volume.geometry.geometry_p_interact = p_interact;
// Currently the coordinates will be in absolute space.
this_box_volume.geometry.center = POS_A_CURRENT_COMP;

this_box_storage.z_depth = zdepth;
this_box_storage.x_width1 = xwidth;
this_box_storage.y_height1 = yheight;

this_box_storage.is_rectangle = 0;
if (xwidth2 < 0 && yheight2 < 0) this_box_storage.is_rectangle = 1;
if (xwidth == xwidth2 && yheight == yheight2) this_box_storage.is_rectangle = 1;

if (xwidth2 < 0) {
    this_box_storage.x_width2 = xwidth;
    xwidth2 = xwidth;
} else this_box_storage.x_width2 = xwidth2;

if (yheight2 < 0) {
    this_box_storage.y_height2 = yheight;
    yheight2 = yheight;
} else this_box_storage.y_height2 = yheight2;


this_box_storage.normal_vectors[0] = coords_set(0,0,1);
this_box_storage.normal_vectors[1] = coords_set(0,0,1);

// for sides with y component = 0
x_component = 2*zdepth/sqrt((xwidth-xwidth2)*(xwidth-xwidth2)+4*zdepth*zdepth);
z_component = (xwidth-xwidth2)/sqrt(4*zdepth*zdepth+(xwidth-xwidth2)*(xwidth-xwidth2));

this_box_storage.normal_vectors[2] = coords_set(x_component,0,z_component);
this_box_storage.normal_vectors[3] = coords_set(-x_component,0,z_component);

// for sides with x component = 0
y_component = 2*zdepth/sqrt((yheight-yheight2)*(yheight-yheight2)+4*zdepth*zdepth);
z_component = (yheight-yheight2)/sqrt(4*zdepth*zdepth+(yheight-yheight2)*(yheight-yheight2));

this_box_storage.normal_vectors[4] = coords_set(0,y_component,z_component);
this_box_storage.normal_vectors[5] = coords_set(0,-y_component,z_component);

this_box_volume.geometry.visualization_on = visualize;

this_box_volume.geometry.geometry_parameters.p_box_storage = &this_box_storage;

// Assign pointers to functions for intersection with the shape, checking if a point is inside the shape
if (this_box_storage.is_rectangle == 1) {
this_box_volume.geometry.intersect_function = &sample_box_intersect_simple;
this_box_volume.geometry.within_function = &r_within_box_simple;
}
else {
this_box_volume.geometry.intersect_function = &sample_box_intersect_advanced;
this_box_volume.geometry.within_function = &r_within_box_advanced;
}

this_box_volume.geometry.shell_points = &box_shell_points;
this_box_volume.geometry.mcdisplay_function = &mcdisplay_box_function;
this_box_volume.geometry.initialize_from_main_function = &initialize_box_geometry_from_main_component;
this_box_volume.geometry.process_rot_allocated = 0;

this_box_volume.geometry.copy_geometry_parameters = &allocate_box_storage_copy;

rot_copy(this_box_volume.geometry.rotation_matrix,ROT_A_CURRENT_COMP); //check how ROT_R_CURRENT_COMP would work
rot_transpose(ROT_A_CURRENT_COMP,this_box_volume.geometry.transpose_rotation_matrix);

// Initialize loggers
this_box_volume.loggers.num_elements = 0;

// packing the information into the global_geometry_element, which is then included in the global_geometry_list.
sprintf(global_geometry_element.name,NAME_CURRENT_COMP);
global_geometry_element.activation_counter = number_of_activations;
global_geometry_element.component_index = INDEX_CURRENT_COMP;
global_geometry_element.Volume = &this_box_volume; // Would be nicer if this m was a pointer, now we have the (small) data two places
add_element_to_geometry_list(&global_geometry_list,global_geometry_element);
}
#line 179933 "MACS_sample_kidney_box.c"
#undef number_of_activations
#undef mask_setting
#undef mask_string
#undef p_interact
#undef focus_r
#undef focus_xh
#undef focus_xw
#undef focus_ah
#undef focus_aw
#undef target_z
#undef target_y
#undef target_x
#undef target_index
#undef visualize
#undef yheight2
#undef xwidth2
#undef zdepth
#undef yheight
#undef xwidth
#undef priority
#undef material_string
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

  /* Initializations for component channel_1_cave2_box3. */
  SIG_MESSAGE("channel_1_cave2_box3 (Init)");
#define mccompcurname  channel_1_cave2_box3
#define mccompcurtype  Union_box
#define mccompcurindex 191
#define loop_index mccchannel_1_cave2_box3_loop_index
#define this_box_volume mccchannel_1_cave2_box3_this_box_volume
#define global_geometry_element mccchannel_1_cave2_box3_global_geometry_element
#define this_box_storage mccchannel_1_cave2_box3_this_box_storage
#define material_string mccchannel_1_cave2_box3_material_string
#define priority mccchannel_1_cave2_box3_priority
#define xwidth mccchannel_1_cave2_box3_xwidth
#define yheight mccchannel_1_cave2_box3_yheight
#define zdepth mccchannel_1_cave2_box3_zdepth
#define xwidth2 mccchannel_1_cave2_box3_xwidth2
#define yheight2 mccchannel_1_cave2_box3_yheight2
#define visualize mccchannel_1_cave2_box3_visualize
#define target_index mccchannel_1_cave2_box3_target_index
#define target_x mccchannel_1_cave2_box3_target_x
#define target_y mccchannel_1_cave2_box3_target_y
#define target_z mccchannel_1_cave2_box3_target_z
#define focus_aw mccchannel_1_cave2_box3_focus_aw
#define focus_ah mccchannel_1_cave2_box3_focus_ah
#define focus_xw mccchannel_1_cave2_box3_focus_xw
#define focus_xh mccchannel_1_cave2_box3_focus_xh
#define focus_r mccchannel_1_cave2_box3_focus_r
#define p_interact mccchannel_1_cave2_box3_p_interact
#define mask_string mccchannel_1_cave2_box3_mask_string
#define mask_setting mccchannel_1_cave2_box3_mask_setting
#define number_of_activations mccchannel_1_cave2_box3_number_of_activations
#line 224 "Union_box.comp"
{
// Initializes the focusing system for this volume including input sanitation.
focus_initialize(&this_box_volume.geometry, POS_A_COMP_INDEX(INDEX_CURRENT_COMP+target_index), POS_A_CURRENT_COMP, ROT_A_CURRENT_COMP, target_index, target_x, target_y, target_z, focus_aw, focus_ah, focus_xw, focus_xh, focus_r, NAME_CURRENT_COMP);

// Input sanitation for this geometry
if (xwidth <= 0) {
  printf("\nERROR in Union_box named %s, the xwidth is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (yheight <= 0) {
  printf("\nERROR in Union_box named %s, yheight is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (zdepth <= 0) {
  printf("\nERROR in Union_box named %s, zdepth is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (xwidth2 <= 0 && xwidth2 != -1) {
  printf("\nERROR in Union_box named %s, the xwidth2 is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (yheight2 <= 0 && yheight2 != -1) {
  printf("\nERROR in Union_box named %s, yheight2 is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}

// Use sanitation
if (global_material_list.num_elements == 0) {
  printf("\nERROR: Need to define a material using Union_make_material before using a Union geometry component. \n");
  printf("       %s was defined before first use of Union_make_material.\n",NAME_CURRENT_COMP);
  exit(1);
}

this_box_volume.geometry.is_masked_volume = 0;
this_box_volume.geometry.is_exit_volume = 0;
this_box_volume.geometry.is_mask_volume = 0;
// check if the volume is a mask, if it is the material string is irelevant.
if (mask_string && strlen(mask_string) && strcmp(mask_string, "NULL") && strcmp(mask_string, "0")) {
    // A mask volume is used to limit the extend of other volumes, called the masked volumes. These are specified in the mask_string.
    // In order for a ray to enter a masked volume, it needs to be both in the region covered by that volume AND the mask volume.
    // When more than
    this_box_volume.geometry.mask_mode = 1; // Default is mask mode is ALL
    if (mask_setting && strlen(mask_setting) && strcmp(mask_setting, "NULL") && strcmp(mask_setting, "0")) {
        if (strcmp(mask_setting,"ALL") == 0 || strcmp(mask_setting,"All") == 0) this_box_volume.geometry.mask_mode = 1;
        else if (strcmp(mask_setting,"ANY") == 0 || strcmp(mask_setting,"Any") == 0) this_box_volume.geometry.mask_mode = 2;
        else {
            printf("The mask_mode of component %s is set to %s, but must be either ALL or ANY.\n",NAME_CURRENT_COMP,mask_setting);
            exit(1);
        }
    }
    
    for (loop_index=0;loop_index<global_geometry_list.num_elements;loop_index++) {
        // Add mask list
        if (1 == manual_linking_function(global_geometry_list.elements[loop_index].name,mask_string)) {
            add_element_to_int_list(&this_box_volume.geometry.mask_list,global_geometry_list.elements[loop_index].component_index);
            add_element_to_int_list(&global_geometry_list.elements[loop_index].Volume->geometry.masked_by_list,INDEX_CURRENT_COMP);
            global_geometry_list.elements[loop_index].Volume->geometry.is_masked_volume = 1;
            if (this_box_volume.geometry.mask_mode == 2)
                global_geometry_list.elements[loop_index].Volume->geometry.mask_mode = 2;
            if (this_box_volume.geometry.mask_mode == 1) {
                if (global_geometry_list.elements[loop_index].Volume->geometry.is_masked_volume == 1 && global_geometry_list.elements[loop_index].Volume->geometry.mask_mode != 2)
                    // If more than one mask is added to one volume, the ANY mode overwrites the (default) ALL mode.
                    global_geometry_list.elements[loop_index].Volume->geometry.mask_mode = 1;
            }
            
            found_geometries = 1;
        }
    }
    if (found_geometries == 0) {
        printf("The mask_string in geometry: %s did not find any of the specified volumes in the mask_string %s \n",NAME_CURRENT_COMP,mask_string);
        exit(1);
    }
    this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
    this_box_volume.p_physics->is_vacuum = 0; // Makes this volume a vacuum
    this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
    this_box_volume.p_physics->my_a = 0; // Should not be used.
    sprintf(this_box_volume.p_physics->name,"Mask");
    this_box_volume.geometry.is_mask_volume = 1;
    
    
// Read the material input, or if it lacks, use automatic linking.
} else if (material_string && strlen(material_string) && strcmp(material_string, "NULL") && strcmp(material_string, "0")) {
    // A geometry string was given, use it to determine which material
    if (0 == strcmp(material_string,"vacuum") || 0 == strcmp(material_string,"Vacuum")) {
        // One could have a global physics struct for vacuum instead of creating one for each
        this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
        this_box_volume.p_physics->is_vacuum = 1; // Makes this volume a vacuum
        this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
        this_box_volume.p_physics->my_a = 0; // Should not be used.
        sprintf(this_box_volume.p_physics->name,"Vacuum");
    } else if (0 == strcmp(material_string,"exit") || 0 == strcmp(material_string,"Exit")) {
        // One could have a global physics struct for vacuum instead of creating one for each
        this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
        this_box_volume.p_physics->is_vacuum = 1; // Makes this volume a vacuum
        this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
        this_box_volume.p_physics->my_a = 0; // Should not be used.
        this_box_volume.geometry.is_exit_volume = 1;
        sprintf(this_box_volume.p_physics->name,"Exit");
    } else {
        #ifndef MATERIAL_DETECTOR
            printf("Need to define a material before refering to it in a geometry %s.\n",NAME_CURRENT_COMP);
            exit(1);
        #endif
        for (loop_index=0;loop_index<global_material_list.num_elements;loop_index++) {
            if (0 == strcmp(material_string,global_material_list.elements[loop_index].name)) {
                this_box_volume.p_physics = global_material_list.elements[loop_index].physics;
                break;
            }
            if (loop_index == global_material_list.num_elements-1) {
            printf("\n");
            printf("ERROR: The material string \"%s\" in Union geometry \"%s\" did not match a specified material. \n",material_string,NAME_CURRENT_COMP);
            printf("       The materials available at this point (need to be defined before the geometry): \n");
            for (loop_index=0;loop_index<global_material_list.num_elements;loop_index++)
              printf("         %s\n",global_material_list.elements[loop_index].name);
            printf("\n");
            printf("       It is also possible to use one of the defualt materials avaiable: \n");
            printf("           Vacuum (for a Volume without scattering or absorption)\n");
            printf("           Exit (for a Volume where the ray exits the component if it enters)\n");
            printf("           Mask (for a Volume that masks existing volumes specified in the mask_string\n");
            exit(1);
          }
        }
    }
} else {
    // Automatic linking, simply using the last defined material.
    #ifndef MATERIAL_DETECTOR
        printf("Need to define a material before the geometry to use automatic linking %s.\n",NAME_CURRENT_COMP);
        exit(1);
    #endif
    this_box_volume.p_physics = global_material_list.elements[global_material_list.num_elements-1].physics;
}

sprintf(this_box_volume.name,NAME_CURRENT_COMP);
sprintf(this_box_volume.geometry.shape,"box");
this_box_volume.geometry.priority_value = priority;
this_box_volume.geometry.geometry_p_interact = p_interact;
// Currently the coordinates will be in absolute space.
this_box_volume.geometry.center = POS_A_CURRENT_COMP;

this_box_storage.z_depth = zdepth;
this_box_storage.x_width1 = xwidth;
this_box_storage.y_height1 = yheight;

this_box_storage.is_rectangle = 0;
if (xwidth2 < 0 && yheight2 < 0) this_box_storage.is_rectangle = 1;
if (xwidth == xwidth2 && yheight == yheight2) this_box_storage.is_rectangle = 1;

if (xwidth2 < 0) {
    this_box_storage.x_width2 = xwidth;
    xwidth2 = xwidth;
} else this_box_storage.x_width2 = xwidth2;

if (yheight2 < 0) {
    this_box_storage.y_height2 = yheight;
    yheight2 = yheight;
} else this_box_storage.y_height2 = yheight2;


this_box_storage.normal_vectors[0] = coords_set(0,0,1);
this_box_storage.normal_vectors[1] = coords_set(0,0,1);

// for sides with y component = 0
x_component = 2*zdepth/sqrt((xwidth-xwidth2)*(xwidth-xwidth2)+4*zdepth*zdepth);
z_component = (xwidth-xwidth2)/sqrt(4*zdepth*zdepth+(xwidth-xwidth2)*(xwidth-xwidth2));

this_box_storage.normal_vectors[2] = coords_set(x_component,0,z_component);
this_box_storage.normal_vectors[3] = coords_set(-x_component,0,z_component);

// for sides with x component = 0
y_component = 2*zdepth/sqrt((yheight-yheight2)*(yheight-yheight2)+4*zdepth*zdepth);
z_component = (yheight-yheight2)/sqrt(4*zdepth*zdepth+(yheight-yheight2)*(yheight-yheight2));

this_box_storage.normal_vectors[4] = coords_set(0,y_component,z_component);
this_box_storage.normal_vectors[5] = coords_set(0,-y_component,z_component);

this_box_volume.geometry.visualization_on = visualize;

this_box_volume.geometry.geometry_parameters.p_box_storage = &this_box_storage;

// Assign pointers to functions for intersection with the shape, checking if a point is inside the shape
if (this_box_storage.is_rectangle == 1) {
this_box_volume.geometry.intersect_function = &sample_box_intersect_simple;
this_box_volume.geometry.within_function = &r_within_box_simple;
}
else {
this_box_volume.geometry.intersect_function = &sample_box_intersect_advanced;
this_box_volume.geometry.within_function = &r_within_box_advanced;
}

this_box_volume.geometry.shell_points = &box_shell_points;
this_box_volume.geometry.mcdisplay_function = &mcdisplay_box_function;
this_box_volume.geometry.initialize_from_main_function = &initialize_box_geometry_from_main_component;
this_box_volume.geometry.process_rot_allocated = 0;

this_box_volume.geometry.copy_geometry_parameters = &allocate_box_storage_copy;

rot_copy(this_box_volume.geometry.rotation_matrix,ROT_A_CURRENT_COMP); //check how ROT_R_CURRENT_COMP would work
rot_transpose(ROT_A_CURRENT_COMP,this_box_volume.geometry.transpose_rotation_matrix);

// Initialize loggers
this_box_volume.loggers.num_elements = 0;

// packing the information into the global_geometry_element, which is then included in the global_geometry_list.
sprintf(global_geometry_element.name,NAME_CURRENT_COMP);
global_geometry_element.activation_counter = number_of_activations;
global_geometry_element.component_index = INDEX_CURRENT_COMP;
global_geometry_element.Volume = &this_box_volume; // Would be nicer if this m was a pointer, now we have the (small) data two places
add_element_to_geometry_list(&global_geometry_list,global_geometry_element);
}
#line 180203 "MACS_sample_kidney_box.c"
#undef number_of_activations
#undef mask_setting
#undef mask_string
#undef p_interact
#undef focus_r
#undef focus_xh
#undef focus_xw
#undef focus_ah
#undef focus_aw
#undef target_z
#undef target_y
#undef target_x
#undef target_index
#undef visualize
#undef yheight2
#undef xwidth2
#undef zdepth
#undef yheight
#undef xwidth
#undef priority
#undef material_string
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

  /* Initializations for component inter_analyzer_colimator_center_1. */
  SIG_MESSAGE("inter_analyzer_colimator_center_1 (Init)");

  /* Initializations for component inter_analyzer_colimator_1_blade_0. */
  SIG_MESSAGE("inter_analyzer_colimator_1_blade_0 (Init)");
#define mccompcurname  inter_analyzer_colimator_1_blade_0
#define mccompcurtype  Union_box
#define mccompcurindex 193
#define loop_index mccinter_analyzer_colimator_1_blade_0_loop_index
#define this_box_volume mccinter_analyzer_colimator_1_blade_0_this_box_volume
#define global_geometry_element mccinter_analyzer_colimator_1_blade_0_global_geometry_element
#define this_box_storage mccinter_analyzer_colimator_1_blade_0_this_box_storage
#define material_string mccinter_analyzer_colimator_1_blade_0_material_string
#define priority mccinter_analyzer_colimator_1_blade_0_priority
#define xwidth mccinter_analyzer_colimator_1_blade_0_xwidth
#define yheight mccinter_analyzer_colimator_1_blade_0_yheight
#define zdepth mccinter_analyzer_colimator_1_blade_0_zdepth
#define xwidth2 mccinter_analyzer_colimator_1_blade_0_xwidth2
#define yheight2 mccinter_analyzer_colimator_1_blade_0_yheight2
#define visualize mccinter_analyzer_colimator_1_blade_0_visualize
#define target_index mccinter_analyzer_colimator_1_blade_0_target_index
#define target_x mccinter_analyzer_colimator_1_blade_0_target_x
#define target_y mccinter_analyzer_colimator_1_blade_0_target_y
#define target_z mccinter_analyzer_colimator_1_blade_0_target_z
#define focus_aw mccinter_analyzer_colimator_1_blade_0_focus_aw
#define focus_ah mccinter_analyzer_colimator_1_blade_0_focus_ah
#define focus_xw mccinter_analyzer_colimator_1_blade_0_focus_xw
#define focus_xh mccinter_analyzer_colimator_1_blade_0_focus_xh
#define focus_r mccinter_analyzer_colimator_1_blade_0_focus_r
#define p_interact mccinter_analyzer_colimator_1_blade_0_p_interact
#define mask_string mccinter_analyzer_colimator_1_blade_0_mask_string
#define mask_setting mccinter_analyzer_colimator_1_blade_0_mask_setting
#define number_of_activations mccinter_analyzer_colimator_1_blade_0_number_of_activations
#line 224 "Union_box.comp"
{
// Initializes the focusing system for this volume including input sanitation.
focus_initialize(&this_box_volume.geometry, POS_A_COMP_INDEX(INDEX_CURRENT_COMP+target_index), POS_A_CURRENT_COMP, ROT_A_CURRENT_COMP, target_index, target_x, target_y, target_z, focus_aw, focus_ah, focus_xw, focus_xh, focus_r, NAME_CURRENT_COMP);

// Input sanitation for this geometry
if (xwidth <= 0) {
  printf("\nERROR in Union_box named %s, the xwidth is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (yheight <= 0) {
  printf("\nERROR in Union_box named %s, yheight is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (zdepth <= 0) {
  printf("\nERROR in Union_box named %s, zdepth is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (xwidth2 <= 0 && xwidth2 != -1) {
  printf("\nERROR in Union_box named %s, the xwidth2 is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (yheight2 <= 0 && yheight2 != -1) {
  printf("\nERROR in Union_box named %s, yheight2 is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}

// Use sanitation
if (global_material_list.num_elements == 0) {
  printf("\nERROR: Need to define a material using Union_make_material before using a Union geometry component. \n");
  printf("       %s was defined before first use of Union_make_material.\n",NAME_CURRENT_COMP);
  exit(1);
}

this_box_volume.geometry.is_masked_volume = 0;
this_box_volume.geometry.is_exit_volume = 0;
this_box_volume.geometry.is_mask_volume = 0;
// check if the volume is a mask, if it is the material string is irelevant.
if (mask_string && strlen(mask_string) && strcmp(mask_string, "NULL") && strcmp(mask_string, "0")) {
    // A mask volume is used to limit the extend of other volumes, called the masked volumes. These are specified in the mask_string.
    // In order for a ray to enter a masked volume, it needs to be both in the region covered by that volume AND the mask volume.
    // When more than
    this_box_volume.geometry.mask_mode = 1; // Default is mask mode is ALL
    if (mask_setting && strlen(mask_setting) && strcmp(mask_setting, "NULL") && strcmp(mask_setting, "0")) {
        if (strcmp(mask_setting,"ALL") == 0 || strcmp(mask_setting,"All") == 0) this_box_volume.geometry.mask_mode = 1;
        else if (strcmp(mask_setting,"ANY") == 0 || strcmp(mask_setting,"Any") == 0) this_box_volume.geometry.mask_mode = 2;
        else {
            printf("The mask_mode of component %s is set to %s, but must be either ALL or ANY.\n",NAME_CURRENT_COMP,mask_setting);
            exit(1);
        }
    }
    
    for (loop_index=0;loop_index<global_geometry_list.num_elements;loop_index++) {
        // Add mask list
        if (1 == manual_linking_function(global_geometry_list.elements[loop_index].name,mask_string)) {
            add_element_to_int_list(&this_box_volume.geometry.mask_list,global_geometry_list.elements[loop_index].component_index);
            add_element_to_int_list(&global_geometry_list.elements[loop_index].Volume->geometry.masked_by_list,INDEX_CURRENT_COMP);
            global_geometry_list.elements[loop_index].Volume->geometry.is_masked_volume = 1;
            if (this_box_volume.geometry.mask_mode == 2)
                global_geometry_list.elements[loop_index].Volume->geometry.mask_mode = 2;
            if (this_box_volume.geometry.mask_mode == 1) {
                if (global_geometry_list.elements[loop_index].Volume->geometry.is_masked_volume == 1 && global_geometry_list.elements[loop_index].Volume->geometry.mask_mode != 2)
                    // If more than one mask is added to one volume, the ANY mode overwrites the (default) ALL mode.
                    global_geometry_list.elements[loop_index].Volume->geometry.mask_mode = 1;
            }
            
            found_geometries = 1;
        }
    }
    if (found_geometries == 0) {
        printf("The mask_string in geometry: %s did not find any of the specified volumes in the mask_string %s \n",NAME_CURRENT_COMP,mask_string);
        exit(1);
    }
    this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
    this_box_volume.p_physics->is_vacuum = 0; // Makes this volume a vacuum
    this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
    this_box_volume.p_physics->my_a = 0; // Should not be used.
    sprintf(this_box_volume.p_physics->name,"Mask");
    this_box_volume.geometry.is_mask_volume = 1;
    
    
// Read the material input, or if it lacks, use automatic linking.
} else if (material_string && strlen(material_string) && strcmp(material_string, "NULL") && strcmp(material_string, "0")) {
    // A geometry string was given, use it to determine which material
    if (0 == strcmp(material_string,"vacuum") || 0 == strcmp(material_string,"Vacuum")) {
        // One could have a global physics struct for vacuum instead of creating one for each
        this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
        this_box_volume.p_physics->is_vacuum = 1; // Makes this volume a vacuum
        this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
        this_box_volume.p_physics->my_a = 0; // Should not be used.
        sprintf(this_box_volume.p_physics->name,"Vacuum");
    } else if (0 == strcmp(material_string,"exit") || 0 == strcmp(material_string,"Exit")) {
        // One could have a global physics struct for vacuum instead of creating one for each
        this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
        this_box_volume.p_physics->is_vacuum = 1; // Makes this volume a vacuum
        this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
        this_box_volume.p_physics->my_a = 0; // Should not be used.
        this_box_volume.geometry.is_exit_volume = 1;
        sprintf(this_box_volume.p_physics->name,"Exit");
    } else {
        #ifndef MATERIAL_DETECTOR
            printf("Need to define a material before refering to it in a geometry %s.\n",NAME_CURRENT_COMP);
            exit(1);
        #endif
        for (loop_index=0;loop_index<global_material_list.num_elements;loop_index++) {
            if (0 == strcmp(material_string,global_material_list.elements[loop_index].name)) {
                this_box_volume.p_physics = global_material_list.elements[loop_index].physics;
                break;
            }
            if (loop_index == global_material_list.num_elements-1) {
            printf("\n");
            printf("ERROR: The material string \"%s\" in Union geometry \"%s\" did not match a specified material. \n",material_string,NAME_CURRENT_COMP);
            printf("       The materials available at this point (need to be defined before the geometry): \n");
            for (loop_index=0;loop_index<global_material_list.num_elements;loop_index++)
              printf("         %s\n",global_material_list.elements[loop_index].name);
            printf("\n");
            printf("       It is also possible to use one of the defualt materials avaiable: \n");
            printf("           Vacuum (for a Volume without scattering or absorption)\n");
            printf("           Exit (for a Volume where the ray exits the component if it enters)\n");
            printf("           Mask (for a Volume that masks existing volumes specified in the mask_string\n");
            exit(1);
          }
        }
    }
} else {
    // Automatic linking, simply using the last defined material.
    #ifndef MATERIAL_DETECTOR
        printf("Need to define a material before the geometry to use automatic linking %s.\n",NAME_CURRENT_COMP);
        exit(1);
    #endif
    this_box_volume.p_physics = global_material_list.elements[global_material_list.num_elements-1].physics;
}

sprintf(this_box_volume.name,NAME_CURRENT_COMP);
sprintf(this_box_volume.geometry.shape,"box");
this_box_volume.geometry.priority_value = priority;
this_box_volume.geometry.geometry_p_interact = p_interact;
// Currently the coordinates will be in absolute space.
this_box_volume.geometry.center = POS_A_CURRENT_COMP;

this_box_storage.z_depth = zdepth;
this_box_storage.x_width1 = xwidth;
this_box_storage.y_height1 = yheight;

this_box_storage.is_rectangle = 0;
if (xwidth2 < 0 && yheight2 < 0) this_box_storage.is_rectangle = 1;
if (xwidth == xwidth2 && yheight == yheight2) this_box_storage.is_rectangle = 1;

if (xwidth2 < 0) {
    this_box_storage.x_width2 = xwidth;
    xwidth2 = xwidth;
} else this_box_storage.x_width2 = xwidth2;

if (yheight2 < 0) {
    this_box_storage.y_height2 = yheight;
    yheight2 = yheight;
} else this_box_storage.y_height2 = yheight2;


this_box_storage.normal_vectors[0] = coords_set(0,0,1);
this_box_storage.normal_vectors[1] = coords_set(0,0,1);

// for sides with y component = 0
x_component = 2*zdepth/sqrt((xwidth-xwidth2)*(xwidth-xwidth2)+4*zdepth*zdepth);
z_component = (xwidth-xwidth2)/sqrt(4*zdepth*zdepth+(xwidth-xwidth2)*(xwidth-xwidth2));

this_box_storage.normal_vectors[2] = coords_set(x_component,0,z_component);
this_box_storage.normal_vectors[3] = coords_set(-x_component,0,z_component);

// for sides with x component = 0
y_component = 2*zdepth/sqrt((yheight-yheight2)*(yheight-yheight2)+4*zdepth*zdepth);
z_component = (yheight-yheight2)/sqrt(4*zdepth*zdepth+(yheight-yheight2)*(yheight-yheight2));

this_box_storage.normal_vectors[4] = coords_set(0,y_component,z_component);
this_box_storage.normal_vectors[5] = coords_set(0,-y_component,z_component);

this_box_volume.geometry.visualization_on = visualize;

this_box_volume.geometry.geometry_parameters.p_box_storage = &this_box_storage;

// Assign pointers to functions for intersection with the shape, checking if a point is inside the shape
if (this_box_storage.is_rectangle == 1) {
this_box_volume.geometry.intersect_function = &sample_box_intersect_simple;
this_box_volume.geometry.within_function = &r_within_box_simple;
}
else {
this_box_volume.geometry.intersect_function = &sample_box_intersect_advanced;
this_box_volume.geometry.within_function = &r_within_box_advanced;
}

this_box_volume.geometry.shell_points = &box_shell_points;
this_box_volume.geometry.mcdisplay_function = &mcdisplay_box_function;
this_box_volume.geometry.initialize_from_main_function = &initialize_box_geometry_from_main_component;
this_box_volume.geometry.process_rot_allocated = 0;

this_box_volume.geometry.copy_geometry_parameters = &allocate_box_storage_copy;

rot_copy(this_box_volume.geometry.rotation_matrix,ROT_A_CURRENT_COMP); //check how ROT_R_CURRENT_COMP would work
rot_transpose(ROT_A_CURRENT_COMP,this_box_volume.geometry.transpose_rotation_matrix);

// Initialize loggers
this_box_volume.loggers.num_elements = 0;

// packing the information into the global_geometry_element, which is then included in the global_geometry_list.
sprintf(global_geometry_element.name,NAME_CURRENT_COMP);
global_geometry_element.activation_counter = number_of_activations;
global_geometry_element.component_index = INDEX_CURRENT_COMP;
global_geometry_element.Volume = &this_box_volume; // Would be nicer if this m was a pointer, now we have the (small) data two places
add_element_to_geometry_list(&global_geometry_list,global_geometry_element);
}
#line 180476 "MACS_sample_kidney_box.c"
#undef number_of_activations
#undef mask_setting
#undef mask_string
#undef p_interact
#undef focus_r
#undef focus_xh
#undef focus_xw
#undef focus_ah
#undef focus_aw
#undef target_z
#undef target_y
#undef target_x
#undef target_index
#undef visualize
#undef yheight2
#undef xwidth2
#undef zdepth
#undef yheight
#undef xwidth
#undef priority
#undef material_string
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

  /* Initializations for component inter_analyzer_colimator_1_blade_1. */
  SIG_MESSAGE("inter_analyzer_colimator_1_blade_1 (Init)");
#define mccompcurname  inter_analyzer_colimator_1_blade_1
#define mccompcurtype  Union_box
#define mccompcurindex 194
#define loop_index mccinter_analyzer_colimator_1_blade_1_loop_index
#define this_box_volume mccinter_analyzer_colimator_1_blade_1_this_box_volume
#define global_geometry_element mccinter_analyzer_colimator_1_blade_1_global_geometry_element
#define this_box_storage mccinter_analyzer_colimator_1_blade_1_this_box_storage
#define material_string mccinter_analyzer_colimator_1_blade_1_material_string
#define priority mccinter_analyzer_colimator_1_blade_1_priority
#define xwidth mccinter_analyzer_colimator_1_blade_1_xwidth
#define yheight mccinter_analyzer_colimator_1_blade_1_yheight
#define zdepth mccinter_analyzer_colimator_1_blade_1_zdepth
#define xwidth2 mccinter_analyzer_colimator_1_blade_1_xwidth2
#define yheight2 mccinter_analyzer_colimator_1_blade_1_yheight2
#define visualize mccinter_analyzer_colimator_1_blade_1_visualize
#define target_index mccinter_analyzer_colimator_1_blade_1_target_index
#define target_x mccinter_analyzer_colimator_1_blade_1_target_x
#define target_y mccinter_analyzer_colimator_1_blade_1_target_y
#define target_z mccinter_analyzer_colimator_1_blade_1_target_z
#define focus_aw mccinter_analyzer_colimator_1_blade_1_focus_aw
#define focus_ah mccinter_analyzer_colimator_1_blade_1_focus_ah
#define focus_xw mccinter_analyzer_colimator_1_blade_1_focus_xw
#define focus_xh mccinter_analyzer_colimator_1_blade_1_focus_xh
#define focus_r mccinter_analyzer_colimator_1_blade_1_focus_r
#define p_interact mccinter_analyzer_colimator_1_blade_1_p_interact
#define mask_string mccinter_analyzer_colimator_1_blade_1_mask_string
#define mask_setting mccinter_analyzer_colimator_1_blade_1_mask_setting
#define number_of_activations mccinter_analyzer_colimator_1_blade_1_number_of_activations
#line 224 "Union_box.comp"
{
// Initializes the focusing system for this volume including input sanitation.
focus_initialize(&this_box_volume.geometry, POS_A_COMP_INDEX(INDEX_CURRENT_COMP+target_index), POS_A_CURRENT_COMP, ROT_A_CURRENT_COMP, target_index, target_x, target_y, target_z, focus_aw, focus_ah, focus_xw, focus_xh, focus_r, NAME_CURRENT_COMP);

// Input sanitation for this geometry
if (xwidth <= 0) {
  printf("\nERROR in Union_box named %s, the xwidth is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (yheight <= 0) {
  printf("\nERROR in Union_box named %s, yheight is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (zdepth <= 0) {
  printf("\nERROR in Union_box named %s, zdepth is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (xwidth2 <= 0 && xwidth2 != -1) {
  printf("\nERROR in Union_box named %s, the xwidth2 is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (yheight2 <= 0 && yheight2 != -1) {
  printf("\nERROR in Union_box named %s, yheight2 is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}

// Use sanitation
if (global_material_list.num_elements == 0) {
  printf("\nERROR: Need to define a material using Union_make_material before using a Union geometry component. \n");
  printf("       %s was defined before first use of Union_make_material.\n",NAME_CURRENT_COMP);
  exit(1);
}

this_box_volume.geometry.is_masked_volume = 0;
this_box_volume.geometry.is_exit_volume = 0;
this_box_volume.geometry.is_mask_volume = 0;
// check if the volume is a mask, if it is the material string is irelevant.
if (mask_string && strlen(mask_string) && strcmp(mask_string, "NULL") && strcmp(mask_string, "0")) {
    // A mask volume is used to limit the extend of other volumes, called the masked volumes. These are specified in the mask_string.
    // In order for a ray to enter a masked volume, it needs to be both in the region covered by that volume AND the mask volume.
    // When more than
    this_box_volume.geometry.mask_mode = 1; // Default is mask mode is ALL
    if (mask_setting && strlen(mask_setting) && strcmp(mask_setting, "NULL") && strcmp(mask_setting, "0")) {
        if (strcmp(mask_setting,"ALL") == 0 || strcmp(mask_setting,"All") == 0) this_box_volume.geometry.mask_mode = 1;
        else if (strcmp(mask_setting,"ANY") == 0 || strcmp(mask_setting,"Any") == 0) this_box_volume.geometry.mask_mode = 2;
        else {
            printf("The mask_mode of component %s is set to %s, but must be either ALL or ANY.\n",NAME_CURRENT_COMP,mask_setting);
            exit(1);
        }
    }
    
    for (loop_index=0;loop_index<global_geometry_list.num_elements;loop_index++) {
        // Add mask list
        if (1 == manual_linking_function(global_geometry_list.elements[loop_index].name,mask_string)) {
            add_element_to_int_list(&this_box_volume.geometry.mask_list,global_geometry_list.elements[loop_index].component_index);
            add_element_to_int_list(&global_geometry_list.elements[loop_index].Volume->geometry.masked_by_list,INDEX_CURRENT_COMP);
            global_geometry_list.elements[loop_index].Volume->geometry.is_masked_volume = 1;
            if (this_box_volume.geometry.mask_mode == 2)
                global_geometry_list.elements[loop_index].Volume->geometry.mask_mode = 2;
            if (this_box_volume.geometry.mask_mode == 1) {
                if (global_geometry_list.elements[loop_index].Volume->geometry.is_masked_volume == 1 && global_geometry_list.elements[loop_index].Volume->geometry.mask_mode != 2)
                    // If more than one mask is added to one volume, the ANY mode overwrites the (default) ALL mode.
                    global_geometry_list.elements[loop_index].Volume->geometry.mask_mode = 1;
            }
            
            found_geometries = 1;
        }
    }
    if (found_geometries == 0) {
        printf("The mask_string in geometry: %s did not find any of the specified volumes in the mask_string %s \n",NAME_CURRENT_COMP,mask_string);
        exit(1);
    }
    this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
    this_box_volume.p_physics->is_vacuum = 0; // Makes this volume a vacuum
    this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
    this_box_volume.p_physics->my_a = 0; // Should not be used.
    sprintf(this_box_volume.p_physics->name,"Mask");
    this_box_volume.geometry.is_mask_volume = 1;
    
    
// Read the material input, or if it lacks, use automatic linking.
} else if (material_string && strlen(material_string) && strcmp(material_string, "NULL") && strcmp(material_string, "0")) {
    // A geometry string was given, use it to determine which material
    if (0 == strcmp(material_string,"vacuum") || 0 == strcmp(material_string,"Vacuum")) {
        // One could have a global physics struct for vacuum instead of creating one for each
        this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
        this_box_volume.p_physics->is_vacuum = 1; // Makes this volume a vacuum
        this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
        this_box_volume.p_physics->my_a = 0; // Should not be used.
        sprintf(this_box_volume.p_physics->name,"Vacuum");
    } else if (0 == strcmp(material_string,"exit") || 0 == strcmp(material_string,"Exit")) {
        // One could have a global physics struct for vacuum instead of creating one for each
        this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
        this_box_volume.p_physics->is_vacuum = 1; // Makes this volume a vacuum
        this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
        this_box_volume.p_physics->my_a = 0; // Should not be used.
        this_box_volume.geometry.is_exit_volume = 1;
        sprintf(this_box_volume.p_physics->name,"Exit");
    } else {
        #ifndef MATERIAL_DETECTOR
            printf("Need to define a material before refering to it in a geometry %s.\n",NAME_CURRENT_COMP);
            exit(1);
        #endif
        for (loop_index=0;loop_index<global_material_list.num_elements;loop_index++) {
            if (0 == strcmp(material_string,global_material_list.elements[loop_index].name)) {
                this_box_volume.p_physics = global_material_list.elements[loop_index].physics;
                break;
            }
            if (loop_index == global_material_list.num_elements-1) {
            printf("\n");
            printf("ERROR: The material string \"%s\" in Union geometry \"%s\" did not match a specified material. \n",material_string,NAME_CURRENT_COMP);
            printf("       The materials available at this point (need to be defined before the geometry): \n");
            for (loop_index=0;loop_index<global_material_list.num_elements;loop_index++)
              printf("         %s\n",global_material_list.elements[loop_index].name);
            printf("\n");
            printf("       It is also possible to use one of the defualt materials avaiable: \n");
            printf("           Vacuum (for a Volume without scattering or absorption)\n");
            printf("           Exit (for a Volume where the ray exits the component if it enters)\n");
            printf("           Mask (for a Volume that masks existing volumes specified in the mask_string\n");
            exit(1);
          }
        }
    }
} else {
    // Automatic linking, simply using the last defined material.
    #ifndef MATERIAL_DETECTOR
        printf("Need to define a material before the geometry to use automatic linking %s.\n",NAME_CURRENT_COMP);
        exit(1);
    #endif
    this_box_volume.p_physics = global_material_list.elements[global_material_list.num_elements-1].physics;
}

sprintf(this_box_volume.name,NAME_CURRENT_COMP);
sprintf(this_box_volume.geometry.shape,"box");
this_box_volume.geometry.priority_value = priority;
this_box_volume.geometry.geometry_p_interact = p_interact;
// Currently the coordinates will be in absolute space.
this_box_volume.geometry.center = POS_A_CURRENT_COMP;

this_box_storage.z_depth = zdepth;
this_box_storage.x_width1 = xwidth;
this_box_storage.y_height1 = yheight;

this_box_storage.is_rectangle = 0;
if (xwidth2 < 0 && yheight2 < 0) this_box_storage.is_rectangle = 1;
if (xwidth == xwidth2 && yheight == yheight2) this_box_storage.is_rectangle = 1;

if (xwidth2 < 0) {
    this_box_storage.x_width2 = xwidth;
    xwidth2 = xwidth;
} else this_box_storage.x_width2 = xwidth2;

if (yheight2 < 0) {
    this_box_storage.y_height2 = yheight;
    yheight2 = yheight;
} else this_box_storage.y_height2 = yheight2;


this_box_storage.normal_vectors[0] = coords_set(0,0,1);
this_box_storage.normal_vectors[1] = coords_set(0,0,1);

// for sides with y component = 0
x_component = 2*zdepth/sqrt((xwidth-xwidth2)*(xwidth-xwidth2)+4*zdepth*zdepth);
z_component = (xwidth-xwidth2)/sqrt(4*zdepth*zdepth+(xwidth-xwidth2)*(xwidth-xwidth2));

this_box_storage.normal_vectors[2] = coords_set(x_component,0,z_component);
this_box_storage.normal_vectors[3] = coords_set(-x_component,0,z_component);

// for sides with x component = 0
y_component = 2*zdepth/sqrt((yheight-yheight2)*(yheight-yheight2)+4*zdepth*zdepth);
z_component = (yheight-yheight2)/sqrt(4*zdepth*zdepth+(yheight-yheight2)*(yheight-yheight2));

this_box_storage.normal_vectors[4] = coords_set(0,y_component,z_component);
this_box_storage.normal_vectors[5] = coords_set(0,-y_component,z_component);

this_box_volume.geometry.visualization_on = visualize;

this_box_volume.geometry.geometry_parameters.p_box_storage = &this_box_storage;

// Assign pointers to functions for intersection with the shape, checking if a point is inside the shape
if (this_box_storage.is_rectangle == 1) {
this_box_volume.geometry.intersect_function = &sample_box_intersect_simple;
this_box_volume.geometry.within_function = &r_within_box_simple;
}
else {
this_box_volume.geometry.intersect_function = &sample_box_intersect_advanced;
this_box_volume.geometry.within_function = &r_within_box_advanced;
}

this_box_volume.geometry.shell_points = &box_shell_points;
this_box_volume.geometry.mcdisplay_function = &mcdisplay_box_function;
this_box_volume.geometry.initialize_from_main_function = &initialize_box_geometry_from_main_component;
this_box_volume.geometry.process_rot_allocated = 0;

this_box_volume.geometry.copy_geometry_parameters = &allocate_box_storage_copy;

rot_copy(this_box_volume.geometry.rotation_matrix,ROT_A_CURRENT_COMP); //check how ROT_R_CURRENT_COMP would work
rot_transpose(ROT_A_CURRENT_COMP,this_box_volume.geometry.transpose_rotation_matrix);

// Initialize loggers
this_box_volume.loggers.num_elements = 0;

// packing the information into the global_geometry_element, which is then included in the global_geometry_list.
sprintf(global_geometry_element.name,NAME_CURRENT_COMP);
global_geometry_element.activation_counter = number_of_activations;
global_geometry_element.component_index = INDEX_CURRENT_COMP;
global_geometry_element.Volume = &this_box_volume; // Would be nicer if this m was a pointer, now we have the (small) data two places
add_element_to_geometry_list(&global_geometry_list,global_geometry_element);
}
#line 180746 "MACS_sample_kidney_box.c"
#undef number_of_activations
#undef mask_setting
#undef mask_string
#undef p_interact
#undef focus_r
#undef focus_xh
#undef focus_xw
#undef focus_ah
#undef focus_aw
#undef target_z
#undef target_y
#undef target_x
#undef target_index
#undef visualize
#undef yheight2
#undef xwidth2
#undef zdepth
#undef yheight
#undef xwidth
#undef priority
#undef material_string
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

  /* Initializations for component inter_analyzer_colimator_1_blade_2. */
  SIG_MESSAGE("inter_analyzer_colimator_1_blade_2 (Init)");
#define mccompcurname  inter_analyzer_colimator_1_blade_2
#define mccompcurtype  Union_box
#define mccompcurindex 195
#define loop_index mccinter_analyzer_colimator_1_blade_2_loop_index
#define this_box_volume mccinter_analyzer_colimator_1_blade_2_this_box_volume
#define global_geometry_element mccinter_analyzer_colimator_1_blade_2_global_geometry_element
#define this_box_storage mccinter_analyzer_colimator_1_blade_2_this_box_storage
#define material_string mccinter_analyzer_colimator_1_blade_2_material_string
#define priority mccinter_analyzer_colimator_1_blade_2_priority
#define xwidth mccinter_analyzer_colimator_1_blade_2_xwidth
#define yheight mccinter_analyzer_colimator_1_blade_2_yheight
#define zdepth mccinter_analyzer_colimator_1_blade_2_zdepth
#define xwidth2 mccinter_analyzer_colimator_1_blade_2_xwidth2
#define yheight2 mccinter_analyzer_colimator_1_blade_2_yheight2
#define visualize mccinter_analyzer_colimator_1_blade_2_visualize
#define target_index mccinter_analyzer_colimator_1_blade_2_target_index
#define target_x mccinter_analyzer_colimator_1_blade_2_target_x
#define target_y mccinter_analyzer_colimator_1_blade_2_target_y
#define target_z mccinter_analyzer_colimator_1_blade_2_target_z
#define focus_aw mccinter_analyzer_colimator_1_blade_2_focus_aw
#define focus_ah mccinter_analyzer_colimator_1_blade_2_focus_ah
#define focus_xw mccinter_analyzer_colimator_1_blade_2_focus_xw
#define focus_xh mccinter_analyzer_colimator_1_blade_2_focus_xh
#define focus_r mccinter_analyzer_colimator_1_blade_2_focus_r
#define p_interact mccinter_analyzer_colimator_1_blade_2_p_interact
#define mask_string mccinter_analyzer_colimator_1_blade_2_mask_string
#define mask_setting mccinter_analyzer_colimator_1_blade_2_mask_setting
#define number_of_activations mccinter_analyzer_colimator_1_blade_2_number_of_activations
#line 224 "Union_box.comp"
{
// Initializes the focusing system for this volume including input sanitation.
focus_initialize(&this_box_volume.geometry, POS_A_COMP_INDEX(INDEX_CURRENT_COMP+target_index), POS_A_CURRENT_COMP, ROT_A_CURRENT_COMP, target_index, target_x, target_y, target_z, focus_aw, focus_ah, focus_xw, focus_xh, focus_r, NAME_CURRENT_COMP);

// Input sanitation for this geometry
if (xwidth <= 0) {
  printf("\nERROR in Union_box named %s, the xwidth is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (yheight <= 0) {
  printf("\nERROR in Union_box named %s, yheight is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (zdepth <= 0) {
  printf("\nERROR in Union_box named %s, zdepth is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (xwidth2 <= 0 && xwidth2 != -1) {
  printf("\nERROR in Union_box named %s, the xwidth2 is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (yheight2 <= 0 && yheight2 != -1) {
  printf("\nERROR in Union_box named %s, yheight2 is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}

// Use sanitation
if (global_material_list.num_elements == 0) {
  printf("\nERROR: Need to define a material using Union_make_material before using a Union geometry component. \n");
  printf("       %s was defined before first use of Union_make_material.\n",NAME_CURRENT_COMP);
  exit(1);
}

this_box_volume.geometry.is_masked_volume = 0;
this_box_volume.geometry.is_exit_volume = 0;
this_box_volume.geometry.is_mask_volume = 0;
// check if the volume is a mask, if it is the material string is irelevant.
if (mask_string && strlen(mask_string) && strcmp(mask_string, "NULL") && strcmp(mask_string, "0")) {
    // A mask volume is used to limit the extend of other volumes, called the masked volumes. These are specified in the mask_string.
    // In order for a ray to enter a masked volume, it needs to be both in the region covered by that volume AND the mask volume.
    // When more than
    this_box_volume.geometry.mask_mode = 1; // Default is mask mode is ALL
    if (mask_setting && strlen(mask_setting) && strcmp(mask_setting, "NULL") && strcmp(mask_setting, "0")) {
        if (strcmp(mask_setting,"ALL") == 0 || strcmp(mask_setting,"All") == 0) this_box_volume.geometry.mask_mode = 1;
        else if (strcmp(mask_setting,"ANY") == 0 || strcmp(mask_setting,"Any") == 0) this_box_volume.geometry.mask_mode = 2;
        else {
            printf("The mask_mode of component %s is set to %s, but must be either ALL or ANY.\n",NAME_CURRENT_COMP,mask_setting);
            exit(1);
        }
    }
    
    for (loop_index=0;loop_index<global_geometry_list.num_elements;loop_index++) {
        // Add mask list
        if (1 == manual_linking_function(global_geometry_list.elements[loop_index].name,mask_string)) {
            add_element_to_int_list(&this_box_volume.geometry.mask_list,global_geometry_list.elements[loop_index].component_index);
            add_element_to_int_list(&global_geometry_list.elements[loop_index].Volume->geometry.masked_by_list,INDEX_CURRENT_COMP);
            global_geometry_list.elements[loop_index].Volume->geometry.is_masked_volume = 1;
            if (this_box_volume.geometry.mask_mode == 2)
                global_geometry_list.elements[loop_index].Volume->geometry.mask_mode = 2;
            if (this_box_volume.geometry.mask_mode == 1) {
                if (global_geometry_list.elements[loop_index].Volume->geometry.is_masked_volume == 1 && global_geometry_list.elements[loop_index].Volume->geometry.mask_mode != 2)
                    // If more than one mask is added to one volume, the ANY mode overwrites the (default) ALL mode.
                    global_geometry_list.elements[loop_index].Volume->geometry.mask_mode = 1;
            }
            
            found_geometries = 1;
        }
    }
    if (found_geometries == 0) {
        printf("The mask_string in geometry: %s did not find any of the specified volumes in the mask_string %s \n",NAME_CURRENT_COMP,mask_string);
        exit(1);
    }
    this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
    this_box_volume.p_physics->is_vacuum = 0; // Makes this volume a vacuum
    this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
    this_box_volume.p_physics->my_a = 0; // Should not be used.
    sprintf(this_box_volume.p_physics->name,"Mask");
    this_box_volume.geometry.is_mask_volume = 1;
    
    
// Read the material input, or if it lacks, use automatic linking.
} else if (material_string && strlen(material_string) && strcmp(material_string, "NULL") && strcmp(material_string, "0")) {
    // A geometry string was given, use it to determine which material
    if (0 == strcmp(material_string,"vacuum") || 0 == strcmp(material_string,"Vacuum")) {
        // One could have a global physics struct for vacuum instead of creating one for each
        this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
        this_box_volume.p_physics->is_vacuum = 1; // Makes this volume a vacuum
        this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
        this_box_volume.p_physics->my_a = 0; // Should not be used.
        sprintf(this_box_volume.p_physics->name,"Vacuum");
    } else if (0 == strcmp(material_string,"exit") || 0 == strcmp(material_string,"Exit")) {
        // One could have a global physics struct for vacuum instead of creating one for each
        this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
        this_box_volume.p_physics->is_vacuum = 1; // Makes this volume a vacuum
        this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
        this_box_volume.p_physics->my_a = 0; // Should not be used.
        this_box_volume.geometry.is_exit_volume = 1;
        sprintf(this_box_volume.p_physics->name,"Exit");
    } else {
        #ifndef MATERIAL_DETECTOR
            printf("Need to define a material before refering to it in a geometry %s.\n",NAME_CURRENT_COMP);
            exit(1);
        #endif
        for (loop_index=0;loop_index<global_material_list.num_elements;loop_index++) {
            if (0 == strcmp(material_string,global_material_list.elements[loop_index].name)) {
                this_box_volume.p_physics = global_material_list.elements[loop_index].physics;
                break;
            }
            if (loop_index == global_material_list.num_elements-1) {
            printf("\n");
            printf("ERROR: The material string \"%s\" in Union geometry \"%s\" did not match a specified material. \n",material_string,NAME_CURRENT_COMP);
            printf("       The materials available at this point (need to be defined before the geometry): \n");
            for (loop_index=0;loop_index<global_material_list.num_elements;loop_index++)
              printf("         %s\n",global_material_list.elements[loop_index].name);
            printf("\n");
            printf("       It is also possible to use one of the defualt materials avaiable: \n");
            printf("           Vacuum (for a Volume without scattering or absorption)\n");
            printf("           Exit (for a Volume where the ray exits the component if it enters)\n");
            printf("           Mask (for a Volume that masks existing volumes specified in the mask_string\n");
            exit(1);
          }
        }
    }
} else {
    // Automatic linking, simply using the last defined material.
    #ifndef MATERIAL_DETECTOR
        printf("Need to define a material before the geometry to use automatic linking %s.\n",NAME_CURRENT_COMP);
        exit(1);
    #endif
    this_box_volume.p_physics = global_material_list.elements[global_material_list.num_elements-1].physics;
}

sprintf(this_box_volume.name,NAME_CURRENT_COMP);
sprintf(this_box_volume.geometry.shape,"box");
this_box_volume.geometry.priority_value = priority;
this_box_volume.geometry.geometry_p_interact = p_interact;
// Currently the coordinates will be in absolute space.
this_box_volume.geometry.center = POS_A_CURRENT_COMP;

this_box_storage.z_depth = zdepth;
this_box_storage.x_width1 = xwidth;
this_box_storage.y_height1 = yheight;

this_box_storage.is_rectangle = 0;
if (xwidth2 < 0 && yheight2 < 0) this_box_storage.is_rectangle = 1;
if (xwidth == xwidth2 && yheight == yheight2) this_box_storage.is_rectangle = 1;

if (xwidth2 < 0) {
    this_box_storage.x_width2 = xwidth;
    xwidth2 = xwidth;
} else this_box_storage.x_width2 = xwidth2;

if (yheight2 < 0) {
    this_box_storage.y_height2 = yheight;
    yheight2 = yheight;
} else this_box_storage.y_height2 = yheight2;


this_box_storage.normal_vectors[0] = coords_set(0,0,1);
this_box_storage.normal_vectors[1] = coords_set(0,0,1);

// for sides with y component = 0
x_component = 2*zdepth/sqrt((xwidth-xwidth2)*(xwidth-xwidth2)+4*zdepth*zdepth);
z_component = (xwidth-xwidth2)/sqrt(4*zdepth*zdepth+(xwidth-xwidth2)*(xwidth-xwidth2));

this_box_storage.normal_vectors[2] = coords_set(x_component,0,z_component);
this_box_storage.normal_vectors[3] = coords_set(-x_component,0,z_component);

// for sides with x component = 0
y_component = 2*zdepth/sqrt((yheight-yheight2)*(yheight-yheight2)+4*zdepth*zdepth);
z_component = (yheight-yheight2)/sqrt(4*zdepth*zdepth+(yheight-yheight2)*(yheight-yheight2));

this_box_storage.normal_vectors[4] = coords_set(0,y_component,z_component);
this_box_storage.normal_vectors[5] = coords_set(0,-y_component,z_component);

this_box_volume.geometry.visualization_on = visualize;

this_box_volume.geometry.geometry_parameters.p_box_storage = &this_box_storage;

// Assign pointers to functions for intersection with the shape, checking if a point is inside the shape
if (this_box_storage.is_rectangle == 1) {
this_box_volume.geometry.intersect_function = &sample_box_intersect_simple;
this_box_volume.geometry.within_function = &r_within_box_simple;
}
else {
this_box_volume.geometry.intersect_function = &sample_box_intersect_advanced;
this_box_volume.geometry.within_function = &r_within_box_advanced;
}

this_box_volume.geometry.shell_points = &box_shell_points;
this_box_volume.geometry.mcdisplay_function = &mcdisplay_box_function;
this_box_volume.geometry.initialize_from_main_function = &initialize_box_geometry_from_main_component;
this_box_volume.geometry.process_rot_allocated = 0;

this_box_volume.geometry.copy_geometry_parameters = &allocate_box_storage_copy;

rot_copy(this_box_volume.geometry.rotation_matrix,ROT_A_CURRENT_COMP); //check how ROT_R_CURRENT_COMP would work
rot_transpose(ROT_A_CURRENT_COMP,this_box_volume.geometry.transpose_rotation_matrix);

// Initialize loggers
this_box_volume.loggers.num_elements = 0;

// packing the information into the global_geometry_element, which is then included in the global_geometry_list.
sprintf(global_geometry_element.name,NAME_CURRENT_COMP);
global_geometry_element.activation_counter = number_of_activations;
global_geometry_element.component_index = INDEX_CURRENT_COMP;
global_geometry_element.Volume = &this_box_volume; // Would be nicer if this m was a pointer, now we have the (small) data two places
add_element_to_geometry_list(&global_geometry_list,global_geometry_element);
}
#line 181016 "MACS_sample_kidney_box.c"
#undef number_of_activations
#undef mask_setting
#undef mask_string
#undef p_interact
#undef focus_r
#undef focus_xh
#undef focus_xw
#undef focus_ah
#undef focus_aw
#undef target_z
#undef target_y
#undef target_x
#undef target_index
#undef visualize
#undef yheight2
#undef xwidth2
#undef zdepth
#undef yheight
#undef xwidth
#undef priority
#undef material_string
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

  /* Initializations for component inter_analyzer_colimator_1_blade_3. */
  SIG_MESSAGE("inter_analyzer_colimator_1_blade_3 (Init)");
#define mccompcurname  inter_analyzer_colimator_1_blade_3
#define mccompcurtype  Union_box
#define mccompcurindex 196
#define loop_index mccinter_analyzer_colimator_1_blade_3_loop_index
#define this_box_volume mccinter_analyzer_colimator_1_blade_3_this_box_volume
#define global_geometry_element mccinter_analyzer_colimator_1_blade_3_global_geometry_element
#define this_box_storage mccinter_analyzer_colimator_1_blade_3_this_box_storage
#define material_string mccinter_analyzer_colimator_1_blade_3_material_string
#define priority mccinter_analyzer_colimator_1_blade_3_priority
#define xwidth mccinter_analyzer_colimator_1_blade_3_xwidth
#define yheight mccinter_analyzer_colimator_1_blade_3_yheight
#define zdepth mccinter_analyzer_colimator_1_blade_3_zdepth
#define xwidth2 mccinter_analyzer_colimator_1_blade_3_xwidth2
#define yheight2 mccinter_analyzer_colimator_1_blade_3_yheight2
#define visualize mccinter_analyzer_colimator_1_blade_3_visualize
#define target_index mccinter_analyzer_colimator_1_blade_3_target_index
#define target_x mccinter_analyzer_colimator_1_blade_3_target_x
#define target_y mccinter_analyzer_colimator_1_blade_3_target_y
#define target_z mccinter_analyzer_colimator_1_blade_3_target_z
#define focus_aw mccinter_analyzer_colimator_1_blade_3_focus_aw
#define focus_ah mccinter_analyzer_colimator_1_blade_3_focus_ah
#define focus_xw mccinter_analyzer_colimator_1_blade_3_focus_xw
#define focus_xh mccinter_analyzer_colimator_1_blade_3_focus_xh
#define focus_r mccinter_analyzer_colimator_1_blade_3_focus_r
#define p_interact mccinter_analyzer_colimator_1_blade_3_p_interact
#define mask_string mccinter_analyzer_colimator_1_blade_3_mask_string
#define mask_setting mccinter_analyzer_colimator_1_blade_3_mask_setting
#define number_of_activations mccinter_analyzer_colimator_1_blade_3_number_of_activations
#line 224 "Union_box.comp"
{
// Initializes the focusing system for this volume including input sanitation.
focus_initialize(&this_box_volume.geometry, POS_A_COMP_INDEX(INDEX_CURRENT_COMP+target_index), POS_A_CURRENT_COMP, ROT_A_CURRENT_COMP, target_index, target_x, target_y, target_z, focus_aw, focus_ah, focus_xw, focus_xh, focus_r, NAME_CURRENT_COMP);

// Input sanitation for this geometry
if (xwidth <= 0) {
  printf("\nERROR in Union_box named %s, the xwidth is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (yheight <= 0) {
  printf("\nERROR in Union_box named %s, yheight is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (zdepth <= 0) {
  printf("\nERROR in Union_box named %s, zdepth is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (xwidth2 <= 0 && xwidth2 != -1) {
  printf("\nERROR in Union_box named %s, the xwidth2 is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (yheight2 <= 0 && yheight2 != -1) {
  printf("\nERROR in Union_box named %s, yheight2 is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}

// Use sanitation
if (global_material_list.num_elements == 0) {
  printf("\nERROR: Need to define a material using Union_make_material before using a Union geometry component. \n");
  printf("       %s was defined before first use of Union_make_material.\n",NAME_CURRENT_COMP);
  exit(1);
}

this_box_volume.geometry.is_masked_volume = 0;
this_box_volume.geometry.is_exit_volume = 0;
this_box_volume.geometry.is_mask_volume = 0;
// check if the volume is a mask, if it is the material string is irelevant.
if (mask_string && strlen(mask_string) && strcmp(mask_string, "NULL") && strcmp(mask_string, "0")) {
    // A mask volume is used to limit the extend of other volumes, called the masked volumes. These are specified in the mask_string.
    // In order for a ray to enter a masked volume, it needs to be both in the region covered by that volume AND the mask volume.
    // When more than
    this_box_volume.geometry.mask_mode = 1; // Default is mask mode is ALL
    if (mask_setting && strlen(mask_setting) && strcmp(mask_setting, "NULL") && strcmp(mask_setting, "0")) {
        if (strcmp(mask_setting,"ALL") == 0 || strcmp(mask_setting,"All") == 0) this_box_volume.geometry.mask_mode = 1;
        else if (strcmp(mask_setting,"ANY") == 0 || strcmp(mask_setting,"Any") == 0) this_box_volume.geometry.mask_mode = 2;
        else {
            printf("The mask_mode of component %s is set to %s, but must be either ALL or ANY.\n",NAME_CURRENT_COMP,mask_setting);
            exit(1);
        }
    }
    
    for (loop_index=0;loop_index<global_geometry_list.num_elements;loop_index++) {
        // Add mask list
        if (1 == manual_linking_function(global_geometry_list.elements[loop_index].name,mask_string)) {
            add_element_to_int_list(&this_box_volume.geometry.mask_list,global_geometry_list.elements[loop_index].component_index);
            add_element_to_int_list(&global_geometry_list.elements[loop_index].Volume->geometry.masked_by_list,INDEX_CURRENT_COMP);
            global_geometry_list.elements[loop_index].Volume->geometry.is_masked_volume = 1;
            if (this_box_volume.geometry.mask_mode == 2)
                global_geometry_list.elements[loop_index].Volume->geometry.mask_mode = 2;
            if (this_box_volume.geometry.mask_mode == 1) {
                if (global_geometry_list.elements[loop_index].Volume->geometry.is_masked_volume == 1 && global_geometry_list.elements[loop_index].Volume->geometry.mask_mode != 2)
                    // If more than one mask is added to one volume, the ANY mode overwrites the (default) ALL mode.
                    global_geometry_list.elements[loop_index].Volume->geometry.mask_mode = 1;
            }
            
            found_geometries = 1;
        }
    }
    if (found_geometries == 0) {
        printf("The mask_string in geometry: %s did not find any of the specified volumes in the mask_string %s \n",NAME_CURRENT_COMP,mask_string);
        exit(1);
    }
    this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
    this_box_volume.p_physics->is_vacuum = 0; // Makes this volume a vacuum
    this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
    this_box_volume.p_physics->my_a = 0; // Should not be used.
    sprintf(this_box_volume.p_physics->name,"Mask");
    this_box_volume.geometry.is_mask_volume = 1;
    
    
// Read the material input, or if it lacks, use automatic linking.
} else if (material_string && strlen(material_string) && strcmp(material_string, "NULL") && strcmp(material_string, "0")) {
    // A geometry string was given, use it to determine which material
    if (0 == strcmp(material_string,"vacuum") || 0 == strcmp(material_string,"Vacuum")) {
        // One could have a global physics struct for vacuum instead of creating one for each
        this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
        this_box_volume.p_physics->is_vacuum = 1; // Makes this volume a vacuum
        this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
        this_box_volume.p_physics->my_a = 0; // Should not be used.
        sprintf(this_box_volume.p_physics->name,"Vacuum");
    } else if (0 == strcmp(material_string,"exit") || 0 == strcmp(material_string,"Exit")) {
        // One could have a global physics struct for vacuum instead of creating one for each
        this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
        this_box_volume.p_physics->is_vacuum = 1; // Makes this volume a vacuum
        this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
        this_box_volume.p_physics->my_a = 0; // Should not be used.
        this_box_volume.geometry.is_exit_volume = 1;
        sprintf(this_box_volume.p_physics->name,"Exit");
    } else {
        #ifndef MATERIAL_DETECTOR
            printf("Need to define a material before refering to it in a geometry %s.\n",NAME_CURRENT_COMP);
            exit(1);
        #endif
        for (loop_index=0;loop_index<global_material_list.num_elements;loop_index++) {
            if (0 == strcmp(material_string,global_material_list.elements[loop_index].name)) {
                this_box_volume.p_physics = global_material_list.elements[loop_index].physics;
                break;
            }
            if (loop_index == global_material_list.num_elements-1) {
            printf("\n");
            printf("ERROR: The material string \"%s\" in Union geometry \"%s\" did not match a specified material. \n",material_string,NAME_CURRENT_COMP);
            printf("       The materials available at this point (need to be defined before the geometry): \n");
            for (loop_index=0;loop_index<global_material_list.num_elements;loop_index++)
              printf("         %s\n",global_material_list.elements[loop_index].name);
            printf("\n");
            printf("       It is also possible to use one of the defualt materials avaiable: \n");
            printf("           Vacuum (for a Volume without scattering or absorption)\n");
            printf("           Exit (for a Volume where the ray exits the component if it enters)\n");
            printf("           Mask (for a Volume that masks existing volumes specified in the mask_string\n");
            exit(1);
          }
        }
    }
} else {
    // Automatic linking, simply using the last defined material.
    #ifndef MATERIAL_DETECTOR
        printf("Need to define a material before the geometry to use automatic linking %s.\n",NAME_CURRENT_COMP);
        exit(1);
    #endif
    this_box_volume.p_physics = global_material_list.elements[global_material_list.num_elements-1].physics;
}

sprintf(this_box_volume.name,NAME_CURRENT_COMP);
sprintf(this_box_volume.geometry.shape,"box");
this_box_volume.geometry.priority_value = priority;
this_box_volume.geometry.geometry_p_interact = p_interact;
// Currently the coordinates will be in absolute space.
this_box_volume.geometry.center = POS_A_CURRENT_COMP;

this_box_storage.z_depth = zdepth;
this_box_storage.x_width1 = xwidth;
this_box_storage.y_height1 = yheight;

this_box_storage.is_rectangle = 0;
if (xwidth2 < 0 && yheight2 < 0) this_box_storage.is_rectangle = 1;
if (xwidth == xwidth2 && yheight == yheight2) this_box_storage.is_rectangle = 1;

if (xwidth2 < 0) {
    this_box_storage.x_width2 = xwidth;
    xwidth2 = xwidth;
} else this_box_storage.x_width2 = xwidth2;

if (yheight2 < 0) {
    this_box_storage.y_height2 = yheight;
    yheight2 = yheight;
} else this_box_storage.y_height2 = yheight2;


this_box_storage.normal_vectors[0] = coords_set(0,0,1);
this_box_storage.normal_vectors[1] = coords_set(0,0,1);

// for sides with y component = 0
x_component = 2*zdepth/sqrt((xwidth-xwidth2)*(xwidth-xwidth2)+4*zdepth*zdepth);
z_component = (xwidth-xwidth2)/sqrt(4*zdepth*zdepth+(xwidth-xwidth2)*(xwidth-xwidth2));

this_box_storage.normal_vectors[2] = coords_set(x_component,0,z_component);
this_box_storage.normal_vectors[3] = coords_set(-x_component,0,z_component);

// for sides with x component = 0
y_component = 2*zdepth/sqrt((yheight-yheight2)*(yheight-yheight2)+4*zdepth*zdepth);
z_component = (yheight-yheight2)/sqrt(4*zdepth*zdepth+(yheight-yheight2)*(yheight-yheight2));

this_box_storage.normal_vectors[4] = coords_set(0,y_component,z_component);
this_box_storage.normal_vectors[5] = coords_set(0,-y_component,z_component);

this_box_volume.geometry.visualization_on = visualize;

this_box_volume.geometry.geometry_parameters.p_box_storage = &this_box_storage;

// Assign pointers to functions for intersection with the shape, checking if a point is inside the shape
if (this_box_storage.is_rectangle == 1) {
this_box_volume.geometry.intersect_function = &sample_box_intersect_simple;
this_box_volume.geometry.within_function = &r_within_box_simple;
}
else {
this_box_volume.geometry.intersect_function = &sample_box_intersect_advanced;
this_box_volume.geometry.within_function = &r_within_box_advanced;
}

this_box_volume.geometry.shell_points = &box_shell_points;
this_box_volume.geometry.mcdisplay_function = &mcdisplay_box_function;
this_box_volume.geometry.initialize_from_main_function = &initialize_box_geometry_from_main_component;
this_box_volume.geometry.process_rot_allocated = 0;

this_box_volume.geometry.copy_geometry_parameters = &allocate_box_storage_copy;

rot_copy(this_box_volume.geometry.rotation_matrix,ROT_A_CURRENT_COMP); //check how ROT_R_CURRENT_COMP would work
rot_transpose(ROT_A_CURRENT_COMP,this_box_volume.geometry.transpose_rotation_matrix);

// Initialize loggers
this_box_volume.loggers.num_elements = 0;

// packing the information into the global_geometry_element, which is then included in the global_geometry_list.
sprintf(global_geometry_element.name,NAME_CURRENT_COMP);
global_geometry_element.activation_counter = number_of_activations;
global_geometry_element.component_index = INDEX_CURRENT_COMP;
global_geometry_element.Volume = &this_box_volume; // Would be nicer if this m was a pointer, now we have the (small) data two places
add_element_to_geometry_list(&global_geometry_list,global_geometry_element);
}
#line 181286 "MACS_sample_kidney_box.c"
#undef number_of_activations
#undef mask_setting
#undef mask_string
#undef p_interact
#undef focus_r
#undef focus_xh
#undef focus_xw
#undef focus_ah
#undef focus_aw
#undef target_z
#undef target_y
#undef target_x
#undef target_index
#undef visualize
#undef yheight2
#undef xwidth2
#undef zdepth
#undef yheight
#undef xwidth
#undef priority
#undef material_string
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

  /* Initializations for component inter_analyzer_colimator_1_blade_4. */
  SIG_MESSAGE("inter_analyzer_colimator_1_blade_4 (Init)");
#define mccompcurname  inter_analyzer_colimator_1_blade_4
#define mccompcurtype  Union_box
#define mccompcurindex 197
#define loop_index mccinter_analyzer_colimator_1_blade_4_loop_index
#define this_box_volume mccinter_analyzer_colimator_1_blade_4_this_box_volume
#define global_geometry_element mccinter_analyzer_colimator_1_blade_4_global_geometry_element
#define this_box_storage mccinter_analyzer_colimator_1_blade_4_this_box_storage
#define material_string mccinter_analyzer_colimator_1_blade_4_material_string
#define priority mccinter_analyzer_colimator_1_blade_4_priority
#define xwidth mccinter_analyzer_colimator_1_blade_4_xwidth
#define yheight mccinter_analyzer_colimator_1_blade_4_yheight
#define zdepth mccinter_analyzer_colimator_1_blade_4_zdepth
#define xwidth2 mccinter_analyzer_colimator_1_blade_4_xwidth2
#define yheight2 mccinter_analyzer_colimator_1_blade_4_yheight2
#define visualize mccinter_analyzer_colimator_1_blade_4_visualize
#define target_index mccinter_analyzer_colimator_1_blade_4_target_index
#define target_x mccinter_analyzer_colimator_1_blade_4_target_x
#define target_y mccinter_analyzer_colimator_1_blade_4_target_y
#define target_z mccinter_analyzer_colimator_1_blade_4_target_z
#define focus_aw mccinter_analyzer_colimator_1_blade_4_focus_aw
#define focus_ah mccinter_analyzer_colimator_1_blade_4_focus_ah
#define focus_xw mccinter_analyzer_colimator_1_blade_4_focus_xw
#define focus_xh mccinter_analyzer_colimator_1_blade_4_focus_xh
#define focus_r mccinter_analyzer_colimator_1_blade_4_focus_r
#define p_interact mccinter_analyzer_colimator_1_blade_4_p_interact
#define mask_string mccinter_analyzer_colimator_1_blade_4_mask_string
#define mask_setting mccinter_analyzer_colimator_1_blade_4_mask_setting
#define number_of_activations mccinter_analyzer_colimator_1_blade_4_number_of_activations
#line 224 "Union_box.comp"
{
// Initializes the focusing system for this volume including input sanitation.
focus_initialize(&this_box_volume.geometry, POS_A_COMP_INDEX(INDEX_CURRENT_COMP+target_index), POS_A_CURRENT_COMP, ROT_A_CURRENT_COMP, target_index, target_x, target_y, target_z, focus_aw, focus_ah, focus_xw, focus_xh, focus_r, NAME_CURRENT_COMP);

// Input sanitation for this geometry
if (xwidth <= 0) {
  printf("\nERROR in Union_box named %s, the xwidth is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (yheight <= 0) {
  printf("\nERROR in Union_box named %s, yheight is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (zdepth <= 0) {
  printf("\nERROR in Union_box named %s, zdepth is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (xwidth2 <= 0 && xwidth2 != -1) {
  printf("\nERROR in Union_box named %s, the xwidth2 is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (yheight2 <= 0 && yheight2 != -1) {
  printf("\nERROR in Union_box named %s, yheight2 is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}

// Use sanitation
if (global_material_list.num_elements == 0) {
  printf("\nERROR: Need to define a material using Union_make_material before using a Union geometry component. \n");
  printf("       %s was defined before first use of Union_make_material.\n",NAME_CURRENT_COMP);
  exit(1);
}

this_box_volume.geometry.is_masked_volume = 0;
this_box_volume.geometry.is_exit_volume = 0;
this_box_volume.geometry.is_mask_volume = 0;
// check if the volume is a mask, if it is the material string is irelevant.
if (mask_string && strlen(mask_string) && strcmp(mask_string, "NULL") && strcmp(mask_string, "0")) {
    // A mask volume is used to limit the extend of other volumes, called the masked volumes. These are specified in the mask_string.
    // In order for a ray to enter a masked volume, it needs to be both in the region covered by that volume AND the mask volume.
    // When more than
    this_box_volume.geometry.mask_mode = 1; // Default is mask mode is ALL
    if (mask_setting && strlen(mask_setting) && strcmp(mask_setting, "NULL") && strcmp(mask_setting, "0")) {
        if (strcmp(mask_setting,"ALL") == 0 || strcmp(mask_setting,"All") == 0) this_box_volume.geometry.mask_mode = 1;
        else if (strcmp(mask_setting,"ANY") == 0 || strcmp(mask_setting,"Any") == 0) this_box_volume.geometry.mask_mode = 2;
        else {
            printf("The mask_mode of component %s is set to %s, but must be either ALL or ANY.\n",NAME_CURRENT_COMP,mask_setting);
            exit(1);
        }
    }
    
    for (loop_index=0;loop_index<global_geometry_list.num_elements;loop_index++) {
        // Add mask list
        if (1 == manual_linking_function(global_geometry_list.elements[loop_index].name,mask_string)) {
            add_element_to_int_list(&this_box_volume.geometry.mask_list,global_geometry_list.elements[loop_index].component_index);
            add_element_to_int_list(&global_geometry_list.elements[loop_index].Volume->geometry.masked_by_list,INDEX_CURRENT_COMP);
            global_geometry_list.elements[loop_index].Volume->geometry.is_masked_volume = 1;
            if (this_box_volume.geometry.mask_mode == 2)
                global_geometry_list.elements[loop_index].Volume->geometry.mask_mode = 2;
            if (this_box_volume.geometry.mask_mode == 1) {
                if (global_geometry_list.elements[loop_index].Volume->geometry.is_masked_volume == 1 && global_geometry_list.elements[loop_index].Volume->geometry.mask_mode != 2)
                    // If more than one mask is added to one volume, the ANY mode overwrites the (default) ALL mode.
                    global_geometry_list.elements[loop_index].Volume->geometry.mask_mode = 1;
            }
            
            found_geometries = 1;
        }
    }
    if (found_geometries == 0) {
        printf("The mask_string in geometry: %s did not find any of the specified volumes in the mask_string %s \n",NAME_CURRENT_COMP,mask_string);
        exit(1);
    }
    this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
    this_box_volume.p_physics->is_vacuum = 0; // Makes this volume a vacuum
    this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
    this_box_volume.p_physics->my_a = 0; // Should not be used.
    sprintf(this_box_volume.p_physics->name,"Mask");
    this_box_volume.geometry.is_mask_volume = 1;
    
    
// Read the material input, or if it lacks, use automatic linking.
} else if (material_string && strlen(material_string) && strcmp(material_string, "NULL") && strcmp(material_string, "0")) {
    // A geometry string was given, use it to determine which material
    if (0 == strcmp(material_string,"vacuum") || 0 == strcmp(material_string,"Vacuum")) {
        // One could have a global physics struct for vacuum instead of creating one for each
        this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
        this_box_volume.p_physics->is_vacuum = 1; // Makes this volume a vacuum
        this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
        this_box_volume.p_physics->my_a = 0; // Should not be used.
        sprintf(this_box_volume.p_physics->name,"Vacuum");
    } else if (0 == strcmp(material_string,"exit") || 0 == strcmp(material_string,"Exit")) {
        // One could have a global physics struct for vacuum instead of creating one for each
        this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
        this_box_volume.p_physics->is_vacuum = 1; // Makes this volume a vacuum
        this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
        this_box_volume.p_physics->my_a = 0; // Should not be used.
        this_box_volume.geometry.is_exit_volume = 1;
        sprintf(this_box_volume.p_physics->name,"Exit");
    } else {
        #ifndef MATERIAL_DETECTOR
            printf("Need to define a material before refering to it in a geometry %s.\n",NAME_CURRENT_COMP);
            exit(1);
        #endif
        for (loop_index=0;loop_index<global_material_list.num_elements;loop_index++) {
            if (0 == strcmp(material_string,global_material_list.elements[loop_index].name)) {
                this_box_volume.p_physics = global_material_list.elements[loop_index].physics;
                break;
            }
            if (loop_index == global_material_list.num_elements-1) {
            printf("\n");
            printf("ERROR: The material string \"%s\" in Union geometry \"%s\" did not match a specified material. \n",material_string,NAME_CURRENT_COMP);
            printf("       The materials available at this point (need to be defined before the geometry): \n");
            for (loop_index=0;loop_index<global_material_list.num_elements;loop_index++)
              printf("         %s\n",global_material_list.elements[loop_index].name);
            printf("\n");
            printf("       It is also possible to use one of the defualt materials avaiable: \n");
            printf("           Vacuum (for a Volume without scattering or absorption)\n");
            printf("           Exit (for a Volume where the ray exits the component if it enters)\n");
            printf("           Mask (for a Volume that masks existing volumes specified in the mask_string\n");
            exit(1);
          }
        }
    }
} else {
    // Automatic linking, simply using the last defined material.
    #ifndef MATERIAL_DETECTOR
        printf("Need to define a material before the geometry to use automatic linking %s.\n",NAME_CURRENT_COMP);
        exit(1);
    #endif
    this_box_volume.p_physics = global_material_list.elements[global_material_list.num_elements-1].physics;
}

sprintf(this_box_volume.name,NAME_CURRENT_COMP);
sprintf(this_box_volume.geometry.shape,"box");
this_box_volume.geometry.priority_value = priority;
this_box_volume.geometry.geometry_p_interact = p_interact;
// Currently the coordinates will be in absolute space.
this_box_volume.geometry.center = POS_A_CURRENT_COMP;

this_box_storage.z_depth = zdepth;
this_box_storage.x_width1 = xwidth;
this_box_storage.y_height1 = yheight;

this_box_storage.is_rectangle = 0;
if (xwidth2 < 0 && yheight2 < 0) this_box_storage.is_rectangle = 1;
if (xwidth == xwidth2 && yheight == yheight2) this_box_storage.is_rectangle = 1;

if (xwidth2 < 0) {
    this_box_storage.x_width2 = xwidth;
    xwidth2 = xwidth;
} else this_box_storage.x_width2 = xwidth2;

if (yheight2 < 0) {
    this_box_storage.y_height2 = yheight;
    yheight2 = yheight;
} else this_box_storage.y_height2 = yheight2;


this_box_storage.normal_vectors[0] = coords_set(0,0,1);
this_box_storage.normal_vectors[1] = coords_set(0,0,1);

// for sides with y component = 0
x_component = 2*zdepth/sqrt((xwidth-xwidth2)*(xwidth-xwidth2)+4*zdepth*zdepth);
z_component = (xwidth-xwidth2)/sqrt(4*zdepth*zdepth+(xwidth-xwidth2)*(xwidth-xwidth2));

this_box_storage.normal_vectors[2] = coords_set(x_component,0,z_component);
this_box_storage.normal_vectors[3] = coords_set(-x_component,0,z_component);

// for sides with x component = 0
y_component = 2*zdepth/sqrt((yheight-yheight2)*(yheight-yheight2)+4*zdepth*zdepth);
z_component = (yheight-yheight2)/sqrt(4*zdepth*zdepth+(yheight-yheight2)*(yheight-yheight2));

this_box_storage.normal_vectors[4] = coords_set(0,y_component,z_component);
this_box_storage.normal_vectors[5] = coords_set(0,-y_component,z_component);

this_box_volume.geometry.visualization_on = visualize;

this_box_volume.geometry.geometry_parameters.p_box_storage = &this_box_storage;

// Assign pointers to functions for intersection with the shape, checking if a point is inside the shape
if (this_box_storage.is_rectangle == 1) {
this_box_volume.geometry.intersect_function = &sample_box_intersect_simple;
this_box_volume.geometry.within_function = &r_within_box_simple;
}
else {
this_box_volume.geometry.intersect_function = &sample_box_intersect_advanced;
this_box_volume.geometry.within_function = &r_within_box_advanced;
}

this_box_volume.geometry.shell_points = &box_shell_points;
this_box_volume.geometry.mcdisplay_function = &mcdisplay_box_function;
this_box_volume.geometry.initialize_from_main_function = &initialize_box_geometry_from_main_component;
this_box_volume.geometry.process_rot_allocated = 0;

this_box_volume.geometry.copy_geometry_parameters = &allocate_box_storage_copy;

rot_copy(this_box_volume.geometry.rotation_matrix,ROT_A_CURRENT_COMP); //check how ROT_R_CURRENT_COMP would work
rot_transpose(ROT_A_CURRENT_COMP,this_box_volume.geometry.transpose_rotation_matrix);

// Initialize loggers
this_box_volume.loggers.num_elements = 0;

// packing the information into the global_geometry_element, which is then included in the global_geometry_list.
sprintf(global_geometry_element.name,NAME_CURRENT_COMP);
global_geometry_element.activation_counter = number_of_activations;
global_geometry_element.component_index = INDEX_CURRENT_COMP;
global_geometry_element.Volume = &this_box_volume; // Would be nicer if this m was a pointer, now we have the (small) data two places
add_element_to_geometry_list(&global_geometry_list,global_geometry_element);
}
#line 181556 "MACS_sample_kidney_box.c"
#undef number_of_activations
#undef mask_setting
#undef mask_string
#undef p_interact
#undef focus_r
#undef focus_xh
#undef focus_xw
#undef focus_ah
#undef focus_aw
#undef target_z
#undef target_y
#undef target_x
#undef target_index
#undef visualize
#undef yheight2
#undef xwidth2
#undef zdepth
#undef yheight
#undef xwidth
#undef priority
#undef material_string
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

  /* Initializations for component diffraction_detector_1_exit_volume. */
  SIG_MESSAGE("diffraction_detector_1_exit_volume (Init)");
#define mccompcurname  diffraction_detector_1_exit_volume
#define mccompcurtype  Union_box
#define mccompcurindex 198
#define loop_index mccdiffraction_detector_1_exit_volume_loop_index
#define this_box_volume mccdiffraction_detector_1_exit_volume_this_box_volume
#define global_geometry_element mccdiffraction_detector_1_exit_volume_global_geometry_element
#define this_box_storage mccdiffraction_detector_1_exit_volume_this_box_storage
#define material_string mccdiffraction_detector_1_exit_volume_material_string
#define priority mccdiffraction_detector_1_exit_volume_priority
#define xwidth mccdiffraction_detector_1_exit_volume_xwidth
#define yheight mccdiffraction_detector_1_exit_volume_yheight
#define zdepth mccdiffraction_detector_1_exit_volume_zdepth
#define xwidth2 mccdiffraction_detector_1_exit_volume_xwidth2
#define yheight2 mccdiffraction_detector_1_exit_volume_yheight2
#define visualize mccdiffraction_detector_1_exit_volume_visualize
#define target_index mccdiffraction_detector_1_exit_volume_target_index
#define target_x mccdiffraction_detector_1_exit_volume_target_x
#define target_y mccdiffraction_detector_1_exit_volume_target_y
#define target_z mccdiffraction_detector_1_exit_volume_target_z
#define focus_aw mccdiffraction_detector_1_exit_volume_focus_aw
#define focus_ah mccdiffraction_detector_1_exit_volume_focus_ah
#define focus_xw mccdiffraction_detector_1_exit_volume_focus_xw
#define focus_xh mccdiffraction_detector_1_exit_volume_focus_xh
#define focus_r mccdiffraction_detector_1_exit_volume_focus_r
#define p_interact mccdiffraction_detector_1_exit_volume_p_interact
#define mask_string mccdiffraction_detector_1_exit_volume_mask_string
#define mask_setting mccdiffraction_detector_1_exit_volume_mask_setting
#define number_of_activations mccdiffraction_detector_1_exit_volume_number_of_activations
#line 224 "Union_box.comp"
{
// Initializes the focusing system for this volume including input sanitation.
focus_initialize(&this_box_volume.geometry, POS_A_COMP_INDEX(INDEX_CURRENT_COMP+target_index), POS_A_CURRENT_COMP, ROT_A_CURRENT_COMP, target_index, target_x, target_y, target_z, focus_aw, focus_ah, focus_xw, focus_xh, focus_r, NAME_CURRENT_COMP);

// Input sanitation for this geometry
if (xwidth <= 0) {
  printf("\nERROR in Union_box named %s, the xwidth is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (yheight <= 0) {
  printf("\nERROR in Union_box named %s, yheight is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (zdepth <= 0) {
  printf("\nERROR in Union_box named %s, zdepth is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (xwidth2 <= 0 && xwidth2 != -1) {
  printf("\nERROR in Union_box named %s, the xwidth2 is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (yheight2 <= 0 && yheight2 != -1) {
  printf("\nERROR in Union_box named %s, yheight2 is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}

// Use sanitation
if (global_material_list.num_elements == 0) {
  printf("\nERROR: Need to define a material using Union_make_material before using a Union geometry component. \n");
  printf("       %s was defined before first use of Union_make_material.\n",NAME_CURRENT_COMP);
  exit(1);
}

this_box_volume.geometry.is_masked_volume = 0;
this_box_volume.geometry.is_exit_volume = 0;
this_box_volume.geometry.is_mask_volume = 0;
// check if the volume is a mask, if it is the material string is irelevant.
if (mask_string && strlen(mask_string) && strcmp(mask_string, "NULL") && strcmp(mask_string, "0")) {
    // A mask volume is used to limit the extend of other volumes, called the masked volumes. These are specified in the mask_string.
    // In order for a ray to enter a masked volume, it needs to be both in the region covered by that volume AND the mask volume.
    // When more than
    this_box_volume.geometry.mask_mode = 1; // Default is mask mode is ALL
    if (mask_setting && strlen(mask_setting) && strcmp(mask_setting, "NULL") && strcmp(mask_setting, "0")) {
        if (strcmp(mask_setting,"ALL") == 0 || strcmp(mask_setting,"All") == 0) this_box_volume.geometry.mask_mode = 1;
        else if (strcmp(mask_setting,"ANY") == 0 || strcmp(mask_setting,"Any") == 0) this_box_volume.geometry.mask_mode = 2;
        else {
            printf("The mask_mode of component %s is set to %s, but must be either ALL or ANY.\n",NAME_CURRENT_COMP,mask_setting);
            exit(1);
        }
    }
    
    for (loop_index=0;loop_index<global_geometry_list.num_elements;loop_index++) {
        // Add mask list
        if (1 == manual_linking_function(global_geometry_list.elements[loop_index].name,mask_string)) {
            add_element_to_int_list(&this_box_volume.geometry.mask_list,global_geometry_list.elements[loop_index].component_index);
            add_element_to_int_list(&global_geometry_list.elements[loop_index].Volume->geometry.masked_by_list,INDEX_CURRENT_COMP);
            global_geometry_list.elements[loop_index].Volume->geometry.is_masked_volume = 1;
            if (this_box_volume.geometry.mask_mode == 2)
                global_geometry_list.elements[loop_index].Volume->geometry.mask_mode = 2;
            if (this_box_volume.geometry.mask_mode == 1) {
                if (global_geometry_list.elements[loop_index].Volume->geometry.is_masked_volume == 1 && global_geometry_list.elements[loop_index].Volume->geometry.mask_mode != 2)
                    // If more than one mask is added to one volume, the ANY mode overwrites the (default) ALL mode.
                    global_geometry_list.elements[loop_index].Volume->geometry.mask_mode = 1;
            }
            
            found_geometries = 1;
        }
    }
    if (found_geometries == 0) {
        printf("The mask_string in geometry: %s did not find any of the specified volumes in the mask_string %s \n",NAME_CURRENT_COMP,mask_string);
        exit(1);
    }
    this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
    this_box_volume.p_physics->is_vacuum = 0; // Makes this volume a vacuum
    this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
    this_box_volume.p_physics->my_a = 0; // Should not be used.
    sprintf(this_box_volume.p_physics->name,"Mask");
    this_box_volume.geometry.is_mask_volume = 1;
    
    
// Read the material input, or if it lacks, use automatic linking.
} else if (material_string && strlen(material_string) && strcmp(material_string, "NULL") && strcmp(material_string, "0")) {
    // A geometry string was given, use it to determine which material
    if (0 == strcmp(material_string,"vacuum") || 0 == strcmp(material_string,"Vacuum")) {
        // One could have a global physics struct for vacuum instead of creating one for each
        this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
        this_box_volume.p_physics->is_vacuum = 1; // Makes this volume a vacuum
        this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
        this_box_volume.p_physics->my_a = 0; // Should not be used.
        sprintf(this_box_volume.p_physics->name,"Vacuum");
    } else if (0 == strcmp(material_string,"exit") || 0 == strcmp(material_string,"Exit")) {
        // One could have a global physics struct for vacuum instead of creating one for each
        this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
        this_box_volume.p_physics->is_vacuum = 1; // Makes this volume a vacuum
        this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
        this_box_volume.p_physics->my_a = 0; // Should not be used.
        this_box_volume.geometry.is_exit_volume = 1;
        sprintf(this_box_volume.p_physics->name,"Exit");
    } else {
        #ifndef MATERIAL_DETECTOR
            printf("Need to define a material before refering to it in a geometry %s.\n",NAME_CURRENT_COMP);
            exit(1);
        #endif
        for (loop_index=0;loop_index<global_material_list.num_elements;loop_index++) {
            if (0 == strcmp(material_string,global_material_list.elements[loop_index].name)) {
                this_box_volume.p_physics = global_material_list.elements[loop_index].physics;
                break;
            }
            if (loop_index == global_material_list.num_elements-1) {
            printf("\n");
            printf("ERROR: The material string \"%s\" in Union geometry \"%s\" did not match a specified material. \n",material_string,NAME_CURRENT_COMP);
            printf("       The materials available at this point (need to be defined before the geometry): \n");
            for (loop_index=0;loop_index<global_material_list.num_elements;loop_index++)
              printf("         %s\n",global_material_list.elements[loop_index].name);
            printf("\n");
            printf("       It is also possible to use one of the defualt materials avaiable: \n");
            printf("           Vacuum (for a Volume without scattering or absorption)\n");
            printf("           Exit (for a Volume where the ray exits the component if it enters)\n");
            printf("           Mask (for a Volume that masks existing volumes specified in the mask_string\n");
            exit(1);
          }
        }
    }
} else {
    // Automatic linking, simply using the last defined material.
    #ifndef MATERIAL_DETECTOR
        printf("Need to define a material before the geometry to use automatic linking %s.\n",NAME_CURRENT_COMP);
        exit(1);
    #endif
    this_box_volume.p_physics = global_material_list.elements[global_material_list.num_elements-1].physics;
}

sprintf(this_box_volume.name,NAME_CURRENT_COMP);
sprintf(this_box_volume.geometry.shape,"box");
this_box_volume.geometry.priority_value = priority;
this_box_volume.geometry.geometry_p_interact = p_interact;
// Currently the coordinates will be in absolute space.
this_box_volume.geometry.center = POS_A_CURRENT_COMP;

this_box_storage.z_depth = zdepth;
this_box_storage.x_width1 = xwidth;
this_box_storage.y_height1 = yheight;

this_box_storage.is_rectangle = 0;
if (xwidth2 < 0 && yheight2 < 0) this_box_storage.is_rectangle = 1;
if (xwidth == xwidth2 && yheight == yheight2) this_box_storage.is_rectangle = 1;

if (xwidth2 < 0) {
    this_box_storage.x_width2 = xwidth;
    xwidth2 = xwidth;
} else this_box_storage.x_width2 = xwidth2;

if (yheight2 < 0) {
    this_box_storage.y_height2 = yheight;
    yheight2 = yheight;
} else this_box_storage.y_height2 = yheight2;


this_box_storage.normal_vectors[0] = coords_set(0,0,1);
this_box_storage.normal_vectors[1] = coords_set(0,0,1);

// for sides with y component = 0
x_component = 2*zdepth/sqrt((xwidth-xwidth2)*(xwidth-xwidth2)+4*zdepth*zdepth);
z_component = (xwidth-xwidth2)/sqrt(4*zdepth*zdepth+(xwidth-xwidth2)*(xwidth-xwidth2));

this_box_storage.normal_vectors[2] = coords_set(x_component,0,z_component);
this_box_storage.normal_vectors[3] = coords_set(-x_component,0,z_component);

// for sides with x component = 0
y_component = 2*zdepth/sqrt((yheight-yheight2)*(yheight-yheight2)+4*zdepth*zdepth);
z_component = (yheight-yheight2)/sqrt(4*zdepth*zdepth+(yheight-yheight2)*(yheight-yheight2));

this_box_storage.normal_vectors[4] = coords_set(0,y_component,z_component);
this_box_storage.normal_vectors[5] = coords_set(0,-y_component,z_component);

this_box_volume.geometry.visualization_on = visualize;

this_box_volume.geometry.geometry_parameters.p_box_storage = &this_box_storage;

// Assign pointers to functions for intersection with the shape, checking if a point is inside the shape
if (this_box_storage.is_rectangle == 1) {
this_box_volume.geometry.intersect_function = &sample_box_intersect_simple;
this_box_volume.geometry.within_function = &r_within_box_simple;
}
else {
this_box_volume.geometry.intersect_function = &sample_box_intersect_advanced;
this_box_volume.geometry.within_function = &r_within_box_advanced;
}

this_box_volume.geometry.shell_points = &box_shell_points;
this_box_volume.geometry.mcdisplay_function = &mcdisplay_box_function;
this_box_volume.geometry.initialize_from_main_function = &initialize_box_geometry_from_main_component;
this_box_volume.geometry.process_rot_allocated = 0;

this_box_volume.geometry.copy_geometry_parameters = &allocate_box_storage_copy;

rot_copy(this_box_volume.geometry.rotation_matrix,ROT_A_CURRENT_COMP); //check how ROT_R_CURRENT_COMP would work
rot_transpose(ROT_A_CURRENT_COMP,this_box_volume.geometry.transpose_rotation_matrix);

// Initialize loggers
this_box_volume.loggers.num_elements = 0;

// packing the information into the global_geometry_element, which is then included in the global_geometry_list.
sprintf(global_geometry_element.name,NAME_CURRENT_COMP);
global_geometry_element.activation_counter = number_of_activations;
global_geometry_element.component_index = INDEX_CURRENT_COMP;
global_geometry_element.Volume = &this_box_volume; // Would be nicer if this m was a pointer, now we have the (small) data two places
add_element_to_geometry_list(&global_geometry_list,global_geometry_element);
}
#line 181826 "MACS_sample_kidney_box.c"
#undef number_of_activations
#undef mask_setting
#undef mask_string
#undef p_interact
#undef focus_r
#undef focus_xh
#undef focus_xw
#undef focus_ah
#undef focus_aw
#undef target_z
#undef target_y
#undef target_x
#undef target_index
#undef visualize
#undef yheight2
#undef xwidth2
#undef zdepth
#undef yheight
#undef xwidth
#undef priority
#undef material_string
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

  /* Initializations for component spec_detector_1_exit_volume. */
  SIG_MESSAGE("spec_detector_1_exit_volume (Init)");
#define mccompcurname  spec_detector_1_exit_volume
#define mccompcurtype  Union_box
#define mccompcurindex 199
#define loop_index mccspec_detector_1_exit_volume_loop_index
#define this_box_volume mccspec_detector_1_exit_volume_this_box_volume
#define global_geometry_element mccspec_detector_1_exit_volume_global_geometry_element
#define this_box_storage mccspec_detector_1_exit_volume_this_box_storage
#define material_string mccspec_detector_1_exit_volume_material_string
#define priority mccspec_detector_1_exit_volume_priority
#define xwidth mccspec_detector_1_exit_volume_xwidth
#define yheight mccspec_detector_1_exit_volume_yheight
#define zdepth mccspec_detector_1_exit_volume_zdepth
#define xwidth2 mccspec_detector_1_exit_volume_xwidth2
#define yheight2 mccspec_detector_1_exit_volume_yheight2
#define visualize mccspec_detector_1_exit_volume_visualize
#define target_index mccspec_detector_1_exit_volume_target_index
#define target_x mccspec_detector_1_exit_volume_target_x
#define target_y mccspec_detector_1_exit_volume_target_y
#define target_z mccspec_detector_1_exit_volume_target_z
#define focus_aw mccspec_detector_1_exit_volume_focus_aw
#define focus_ah mccspec_detector_1_exit_volume_focus_ah
#define focus_xw mccspec_detector_1_exit_volume_focus_xw
#define focus_xh mccspec_detector_1_exit_volume_focus_xh
#define focus_r mccspec_detector_1_exit_volume_focus_r
#define p_interact mccspec_detector_1_exit_volume_p_interact
#define mask_string mccspec_detector_1_exit_volume_mask_string
#define mask_setting mccspec_detector_1_exit_volume_mask_setting
#define number_of_activations mccspec_detector_1_exit_volume_number_of_activations
#line 224 "Union_box.comp"
{
// Initializes the focusing system for this volume including input sanitation.
focus_initialize(&this_box_volume.geometry, POS_A_COMP_INDEX(INDEX_CURRENT_COMP+target_index), POS_A_CURRENT_COMP, ROT_A_CURRENT_COMP, target_index, target_x, target_y, target_z, focus_aw, focus_ah, focus_xw, focus_xh, focus_r, NAME_CURRENT_COMP);

// Input sanitation for this geometry
if (xwidth <= 0) {
  printf("\nERROR in Union_box named %s, the xwidth is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (yheight <= 0) {
  printf("\nERROR in Union_box named %s, yheight is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (zdepth <= 0) {
  printf("\nERROR in Union_box named %s, zdepth is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (xwidth2 <= 0 && xwidth2 != -1) {
  printf("\nERROR in Union_box named %s, the xwidth2 is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (yheight2 <= 0 && yheight2 != -1) {
  printf("\nERROR in Union_box named %s, yheight2 is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}

// Use sanitation
if (global_material_list.num_elements == 0) {
  printf("\nERROR: Need to define a material using Union_make_material before using a Union geometry component. \n");
  printf("       %s was defined before first use of Union_make_material.\n",NAME_CURRENT_COMP);
  exit(1);
}

this_box_volume.geometry.is_masked_volume = 0;
this_box_volume.geometry.is_exit_volume = 0;
this_box_volume.geometry.is_mask_volume = 0;
// check if the volume is a mask, if it is the material string is irelevant.
if (mask_string && strlen(mask_string) && strcmp(mask_string, "NULL") && strcmp(mask_string, "0")) {
    // A mask volume is used to limit the extend of other volumes, called the masked volumes. These are specified in the mask_string.
    // In order for a ray to enter a masked volume, it needs to be both in the region covered by that volume AND the mask volume.
    // When more than
    this_box_volume.geometry.mask_mode = 1; // Default is mask mode is ALL
    if (mask_setting && strlen(mask_setting) && strcmp(mask_setting, "NULL") && strcmp(mask_setting, "0")) {
        if (strcmp(mask_setting,"ALL") == 0 || strcmp(mask_setting,"All") == 0) this_box_volume.geometry.mask_mode = 1;
        else if (strcmp(mask_setting,"ANY") == 0 || strcmp(mask_setting,"Any") == 0) this_box_volume.geometry.mask_mode = 2;
        else {
            printf("The mask_mode of component %s is set to %s, but must be either ALL or ANY.\n",NAME_CURRENT_COMP,mask_setting);
            exit(1);
        }
    }
    
    for (loop_index=0;loop_index<global_geometry_list.num_elements;loop_index++) {
        // Add mask list
        if (1 == manual_linking_function(global_geometry_list.elements[loop_index].name,mask_string)) {
            add_element_to_int_list(&this_box_volume.geometry.mask_list,global_geometry_list.elements[loop_index].component_index);
            add_element_to_int_list(&global_geometry_list.elements[loop_index].Volume->geometry.masked_by_list,INDEX_CURRENT_COMP);
            global_geometry_list.elements[loop_index].Volume->geometry.is_masked_volume = 1;
            if (this_box_volume.geometry.mask_mode == 2)
                global_geometry_list.elements[loop_index].Volume->geometry.mask_mode = 2;
            if (this_box_volume.geometry.mask_mode == 1) {
                if (global_geometry_list.elements[loop_index].Volume->geometry.is_masked_volume == 1 && global_geometry_list.elements[loop_index].Volume->geometry.mask_mode != 2)
                    // If more than one mask is added to one volume, the ANY mode overwrites the (default) ALL mode.
                    global_geometry_list.elements[loop_index].Volume->geometry.mask_mode = 1;
            }
            
            found_geometries = 1;
        }
    }
    if (found_geometries == 0) {
        printf("The mask_string in geometry: %s did not find any of the specified volumes in the mask_string %s \n",NAME_CURRENT_COMP,mask_string);
        exit(1);
    }
    this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
    this_box_volume.p_physics->is_vacuum = 0; // Makes this volume a vacuum
    this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
    this_box_volume.p_physics->my_a = 0; // Should not be used.
    sprintf(this_box_volume.p_physics->name,"Mask");
    this_box_volume.geometry.is_mask_volume = 1;
    
    
// Read the material input, or if it lacks, use automatic linking.
} else if (material_string && strlen(material_string) && strcmp(material_string, "NULL") && strcmp(material_string, "0")) {
    // A geometry string was given, use it to determine which material
    if (0 == strcmp(material_string,"vacuum") || 0 == strcmp(material_string,"Vacuum")) {
        // One could have a global physics struct for vacuum instead of creating one for each
        this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
        this_box_volume.p_physics->is_vacuum = 1; // Makes this volume a vacuum
        this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
        this_box_volume.p_physics->my_a = 0; // Should not be used.
        sprintf(this_box_volume.p_physics->name,"Vacuum");
    } else if (0 == strcmp(material_string,"exit") || 0 == strcmp(material_string,"Exit")) {
        // One could have a global physics struct for vacuum instead of creating one for each
        this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
        this_box_volume.p_physics->is_vacuum = 1; // Makes this volume a vacuum
        this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
        this_box_volume.p_physics->my_a = 0; // Should not be used.
        this_box_volume.geometry.is_exit_volume = 1;
        sprintf(this_box_volume.p_physics->name,"Exit");
    } else {
        #ifndef MATERIAL_DETECTOR
            printf("Need to define a material before refering to it in a geometry %s.\n",NAME_CURRENT_COMP);
            exit(1);
        #endif
        for (loop_index=0;loop_index<global_material_list.num_elements;loop_index++) {
            if (0 == strcmp(material_string,global_material_list.elements[loop_index].name)) {
                this_box_volume.p_physics = global_material_list.elements[loop_index].physics;
                break;
            }
            if (loop_index == global_material_list.num_elements-1) {
            printf("\n");
            printf("ERROR: The material string \"%s\" in Union geometry \"%s\" did not match a specified material. \n",material_string,NAME_CURRENT_COMP);
            printf("       The materials available at this point (need to be defined before the geometry): \n");
            for (loop_index=0;loop_index<global_material_list.num_elements;loop_index++)
              printf("         %s\n",global_material_list.elements[loop_index].name);
            printf("\n");
            printf("       It is also possible to use one of the defualt materials avaiable: \n");
            printf("           Vacuum (for a Volume without scattering or absorption)\n");
            printf("           Exit (for a Volume where the ray exits the component if it enters)\n");
            printf("           Mask (for a Volume that masks existing volumes specified in the mask_string\n");
            exit(1);
          }
        }
    }
} else {
    // Automatic linking, simply using the last defined material.
    #ifndef MATERIAL_DETECTOR
        printf("Need to define a material before the geometry to use automatic linking %s.\n",NAME_CURRENT_COMP);
        exit(1);
    #endif
    this_box_volume.p_physics = global_material_list.elements[global_material_list.num_elements-1].physics;
}

sprintf(this_box_volume.name,NAME_CURRENT_COMP);
sprintf(this_box_volume.geometry.shape,"box");
this_box_volume.geometry.priority_value = priority;
this_box_volume.geometry.geometry_p_interact = p_interact;
// Currently the coordinates will be in absolute space.
this_box_volume.geometry.center = POS_A_CURRENT_COMP;

this_box_storage.z_depth = zdepth;
this_box_storage.x_width1 = xwidth;
this_box_storage.y_height1 = yheight;

this_box_storage.is_rectangle = 0;
if (xwidth2 < 0 && yheight2 < 0) this_box_storage.is_rectangle = 1;
if (xwidth == xwidth2 && yheight == yheight2) this_box_storage.is_rectangle = 1;

if (xwidth2 < 0) {
    this_box_storage.x_width2 = xwidth;
    xwidth2 = xwidth;
} else this_box_storage.x_width2 = xwidth2;

if (yheight2 < 0) {
    this_box_storage.y_height2 = yheight;
    yheight2 = yheight;
} else this_box_storage.y_height2 = yheight2;


this_box_storage.normal_vectors[0] = coords_set(0,0,1);
this_box_storage.normal_vectors[1] = coords_set(0,0,1);

// for sides with y component = 0
x_component = 2*zdepth/sqrt((xwidth-xwidth2)*(xwidth-xwidth2)+4*zdepth*zdepth);
z_component = (xwidth-xwidth2)/sqrt(4*zdepth*zdepth+(xwidth-xwidth2)*(xwidth-xwidth2));

this_box_storage.normal_vectors[2] = coords_set(x_component,0,z_component);
this_box_storage.normal_vectors[3] = coords_set(-x_component,0,z_component);

// for sides with x component = 0
y_component = 2*zdepth/sqrt((yheight-yheight2)*(yheight-yheight2)+4*zdepth*zdepth);
z_component = (yheight-yheight2)/sqrt(4*zdepth*zdepth+(yheight-yheight2)*(yheight-yheight2));

this_box_storage.normal_vectors[4] = coords_set(0,y_component,z_component);
this_box_storage.normal_vectors[5] = coords_set(0,-y_component,z_component);

this_box_volume.geometry.visualization_on = visualize;

this_box_volume.geometry.geometry_parameters.p_box_storage = &this_box_storage;

// Assign pointers to functions for intersection with the shape, checking if a point is inside the shape
if (this_box_storage.is_rectangle == 1) {
this_box_volume.geometry.intersect_function = &sample_box_intersect_simple;
this_box_volume.geometry.within_function = &r_within_box_simple;
}
else {
this_box_volume.geometry.intersect_function = &sample_box_intersect_advanced;
this_box_volume.geometry.within_function = &r_within_box_advanced;
}

this_box_volume.geometry.shell_points = &box_shell_points;
this_box_volume.geometry.mcdisplay_function = &mcdisplay_box_function;
this_box_volume.geometry.initialize_from_main_function = &initialize_box_geometry_from_main_component;
this_box_volume.geometry.process_rot_allocated = 0;

this_box_volume.geometry.copy_geometry_parameters = &allocate_box_storage_copy;

rot_copy(this_box_volume.geometry.rotation_matrix,ROT_A_CURRENT_COMP); //check how ROT_R_CURRENT_COMP would work
rot_transpose(ROT_A_CURRENT_COMP,this_box_volume.geometry.transpose_rotation_matrix);

// Initialize loggers
this_box_volume.loggers.num_elements = 0;

// packing the information into the global_geometry_element, which is then included in the global_geometry_list.
sprintf(global_geometry_element.name,NAME_CURRENT_COMP);
global_geometry_element.activation_counter = number_of_activations;
global_geometry_element.component_index = INDEX_CURRENT_COMP;
global_geometry_element.Volume = &this_box_volume; // Would be nicer if this m was a pointer, now we have the (small) data two places
add_element_to_geometry_list(&global_geometry_list,global_geometry_element);
}
#line 182096 "MACS_sample_kidney_box.c"
#undef number_of_activations
#undef mask_setting
#undef mask_string
#undef p_interact
#undef focus_r
#undef focus_xh
#undef focus_xw
#undef focus_ah
#undef focus_aw
#undef target_z
#undef target_y
#undef target_x
#undef target_index
#undef visualize
#undef yheight2
#undef xwidth2
#undef zdepth
#undef yheight
#undef xwidth
#undef priority
#undef material_string
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

  /* Initializations for component channel_2_cave1_box1. */
  SIG_MESSAGE("channel_2_cave1_box1 (Init)");
#define mccompcurname  channel_2_cave1_box1
#define mccompcurtype  Union_box
#define mccompcurindex 200
#define loop_index mccchannel_2_cave1_box1_loop_index
#define this_box_volume mccchannel_2_cave1_box1_this_box_volume
#define global_geometry_element mccchannel_2_cave1_box1_global_geometry_element
#define this_box_storage mccchannel_2_cave1_box1_this_box_storage
#define material_string mccchannel_2_cave1_box1_material_string
#define priority mccchannel_2_cave1_box1_priority
#define xwidth mccchannel_2_cave1_box1_xwidth
#define yheight mccchannel_2_cave1_box1_yheight
#define zdepth mccchannel_2_cave1_box1_zdepth
#define xwidth2 mccchannel_2_cave1_box1_xwidth2
#define yheight2 mccchannel_2_cave1_box1_yheight2
#define visualize mccchannel_2_cave1_box1_visualize
#define target_index mccchannel_2_cave1_box1_target_index
#define target_x mccchannel_2_cave1_box1_target_x
#define target_y mccchannel_2_cave1_box1_target_y
#define target_z mccchannel_2_cave1_box1_target_z
#define focus_aw mccchannel_2_cave1_box1_focus_aw
#define focus_ah mccchannel_2_cave1_box1_focus_ah
#define focus_xw mccchannel_2_cave1_box1_focus_xw
#define focus_xh mccchannel_2_cave1_box1_focus_xh
#define focus_r mccchannel_2_cave1_box1_focus_r
#define p_interact mccchannel_2_cave1_box1_p_interact
#define mask_string mccchannel_2_cave1_box1_mask_string
#define mask_setting mccchannel_2_cave1_box1_mask_setting
#define number_of_activations mccchannel_2_cave1_box1_number_of_activations
#line 224 "Union_box.comp"
{
// Initializes the focusing system for this volume including input sanitation.
focus_initialize(&this_box_volume.geometry, POS_A_COMP_INDEX(INDEX_CURRENT_COMP+target_index), POS_A_CURRENT_COMP, ROT_A_CURRENT_COMP, target_index, target_x, target_y, target_z, focus_aw, focus_ah, focus_xw, focus_xh, focus_r, NAME_CURRENT_COMP);

// Input sanitation for this geometry
if (xwidth <= 0) {
  printf("\nERROR in Union_box named %s, the xwidth is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (yheight <= 0) {
  printf("\nERROR in Union_box named %s, yheight is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (zdepth <= 0) {
  printf("\nERROR in Union_box named %s, zdepth is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (xwidth2 <= 0 && xwidth2 != -1) {
  printf("\nERROR in Union_box named %s, the xwidth2 is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (yheight2 <= 0 && yheight2 != -1) {
  printf("\nERROR in Union_box named %s, yheight2 is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}

// Use sanitation
if (global_material_list.num_elements == 0) {
  printf("\nERROR: Need to define a material using Union_make_material before using a Union geometry component. \n");
  printf("       %s was defined before first use of Union_make_material.\n",NAME_CURRENT_COMP);
  exit(1);
}

this_box_volume.geometry.is_masked_volume = 0;
this_box_volume.geometry.is_exit_volume = 0;
this_box_volume.geometry.is_mask_volume = 0;
// check if the volume is a mask, if it is the material string is irelevant.
if (mask_string && strlen(mask_string) && strcmp(mask_string, "NULL") && strcmp(mask_string, "0")) {
    // A mask volume is used to limit the extend of other volumes, called the masked volumes. These are specified in the mask_string.
    // In order for a ray to enter a masked volume, it needs to be both in the region covered by that volume AND the mask volume.
    // When more than
    this_box_volume.geometry.mask_mode = 1; // Default is mask mode is ALL
    if (mask_setting && strlen(mask_setting) && strcmp(mask_setting, "NULL") && strcmp(mask_setting, "0")) {
        if (strcmp(mask_setting,"ALL") == 0 || strcmp(mask_setting,"All") == 0) this_box_volume.geometry.mask_mode = 1;
        else if (strcmp(mask_setting,"ANY") == 0 || strcmp(mask_setting,"Any") == 0) this_box_volume.geometry.mask_mode = 2;
        else {
            printf("The mask_mode of component %s is set to %s, but must be either ALL or ANY.\n",NAME_CURRENT_COMP,mask_setting);
            exit(1);
        }
    }
    
    for (loop_index=0;loop_index<global_geometry_list.num_elements;loop_index++) {
        // Add mask list
        if (1 == manual_linking_function(global_geometry_list.elements[loop_index].name,mask_string)) {
            add_element_to_int_list(&this_box_volume.geometry.mask_list,global_geometry_list.elements[loop_index].component_index);
            add_element_to_int_list(&global_geometry_list.elements[loop_index].Volume->geometry.masked_by_list,INDEX_CURRENT_COMP);
            global_geometry_list.elements[loop_index].Volume->geometry.is_masked_volume = 1;
            if (this_box_volume.geometry.mask_mode == 2)
                global_geometry_list.elements[loop_index].Volume->geometry.mask_mode = 2;
            if (this_box_volume.geometry.mask_mode == 1) {
                if (global_geometry_list.elements[loop_index].Volume->geometry.is_masked_volume == 1 && global_geometry_list.elements[loop_index].Volume->geometry.mask_mode != 2)
                    // If more than one mask is added to one volume, the ANY mode overwrites the (default) ALL mode.
                    global_geometry_list.elements[loop_index].Volume->geometry.mask_mode = 1;
            }
            
            found_geometries = 1;
        }
    }
    if (found_geometries == 0) {
        printf("The mask_string in geometry: %s did not find any of the specified volumes in the mask_string %s \n",NAME_CURRENT_COMP,mask_string);
        exit(1);
    }
    this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
    this_box_volume.p_physics->is_vacuum = 0; // Makes this volume a vacuum
    this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
    this_box_volume.p_physics->my_a = 0; // Should not be used.
    sprintf(this_box_volume.p_physics->name,"Mask");
    this_box_volume.geometry.is_mask_volume = 1;
    
    
// Read the material input, or if it lacks, use automatic linking.
} else if (material_string && strlen(material_string) && strcmp(material_string, "NULL") && strcmp(material_string, "0")) {
    // A geometry string was given, use it to determine which material
    if (0 == strcmp(material_string,"vacuum") || 0 == strcmp(material_string,"Vacuum")) {
        // One could have a global physics struct for vacuum instead of creating one for each
        this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
        this_box_volume.p_physics->is_vacuum = 1; // Makes this volume a vacuum
        this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
        this_box_volume.p_physics->my_a = 0; // Should not be used.
        sprintf(this_box_volume.p_physics->name,"Vacuum");
    } else if (0 == strcmp(material_string,"exit") || 0 == strcmp(material_string,"Exit")) {
        // One could have a global physics struct for vacuum instead of creating one for each
        this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
        this_box_volume.p_physics->is_vacuum = 1; // Makes this volume a vacuum
        this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
        this_box_volume.p_physics->my_a = 0; // Should not be used.
        this_box_volume.geometry.is_exit_volume = 1;
        sprintf(this_box_volume.p_physics->name,"Exit");
    } else {
        #ifndef MATERIAL_DETECTOR
            printf("Need to define a material before refering to it in a geometry %s.\n",NAME_CURRENT_COMP);
            exit(1);
        #endif
        for (loop_index=0;loop_index<global_material_list.num_elements;loop_index++) {
            if (0 == strcmp(material_string,global_material_list.elements[loop_index].name)) {
                this_box_volume.p_physics = global_material_list.elements[loop_index].physics;
                break;
            }
            if (loop_index == global_material_list.num_elements-1) {
            printf("\n");
            printf("ERROR: The material string \"%s\" in Union geometry \"%s\" did not match a specified material. \n",material_string,NAME_CURRENT_COMP);
            printf("       The materials available at this point (need to be defined before the geometry): \n");
            for (loop_index=0;loop_index<global_material_list.num_elements;loop_index++)
              printf("         %s\n",global_material_list.elements[loop_index].name);
            printf("\n");
            printf("       It is also possible to use one of the defualt materials avaiable: \n");
            printf("           Vacuum (for a Volume without scattering or absorption)\n");
            printf("           Exit (for a Volume where the ray exits the component if it enters)\n");
            printf("           Mask (for a Volume that masks existing volumes specified in the mask_string\n");
            exit(1);
          }
        }
    }
} else {
    // Automatic linking, simply using the last defined material.
    #ifndef MATERIAL_DETECTOR
        printf("Need to define a material before the geometry to use automatic linking %s.\n",NAME_CURRENT_COMP);
        exit(1);
    #endif
    this_box_volume.p_physics = global_material_list.elements[global_material_list.num_elements-1].physics;
}

sprintf(this_box_volume.name,NAME_CURRENT_COMP);
sprintf(this_box_volume.geometry.shape,"box");
this_box_volume.geometry.priority_value = priority;
this_box_volume.geometry.geometry_p_interact = p_interact;
// Currently the coordinates will be in absolute space.
this_box_volume.geometry.center = POS_A_CURRENT_COMP;

this_box_storage.z_depth = zdepth;
this_box_storage.x_width1 = xwidth;
this_box_storage.y_height1 = yheight;

this_box_storage.is_rectangle = 0;
if (xwidth2 < 0 && yheight2 < 0) this_box_storage.is_rectangle = 1;
if (xwidth == xwidth2 && yheight == yheight2) this_box_storage.is_rectangle = 1;

if (xwidth2 < 0) {
    this_box_storage.x_width2 = xwidth;
    xwidth2 = xwidth;
} else this_box_storage.x_width2 = xwidth2;

if (yheight2 < 0) {
    this_box_storage.y_height2 = yheight;
    yheight2 = yheight;
} else this_box_storage.y_height2 = yheight2;


this_box_storage.normal_vectors[0] = coords_set(0,0,1);
this_box_storage.normal_vectors[1] = coords_set(0,0,1);

// for sides with y component = 0
x_component = 2*zdepth/sqrt((xwidth-xwidth2)*(xwidth-xwidth2)+4*zdepth*zdepth);
z_component = (xwidth-xwidth2)/sqrt(4*zdepth*zdepth+(xwidth-xwidth2)*(xwidth-xwidth2));

this_box_storage.normal_vectors[2] = coords_set(x_component,0,z_component);
this_box_storage.normal_vectors[3] = coords_set(-x_component,0,z_component);

// for sides with x component = 0
y_component = 2*zdepth/sqrt((yheight-yheight2)*(yheight-yheight2)+4*zdepth*zdepth);
z_component = (yheight-yheight2)/sqrt(4*zdepth*zdepth+(yheight-yheight2)*(yheight-yheight2));

this_box_storage.normal_vectors[4] = coords_set(0,y_component,z_component);
this_box_storage.normal_vectors[5] = coords_set(0,-y_component,z_component);

this_box_volume.geometry.visualization_on = visualize;

this_box_volume.geometry.geometry_parameters.p_box_storage = &this_box_storage;

// Assign pointers to functions for intersection with the shape, checking if a point is inside the shape
if (this_box_storage.is_rectangle == 1) {
this_box_volume.geometry.intersect_function = &sample_box_intersect_simple;
this_box_volume.geometry.within_function = &r_within_box_simple;
}
else {
this_box_volume.geometry.intersect_function = &sample_box_intersect_advanced;
this_box_volume.geometry.within_function = &r_within_box_advanced;
}

this_box_volume.geometry.shell_points = &box_shell_points;
this_box_volume.geometry.mcdisplay_function = &mcdisplay_box_function;
this_box_volume.geometry.initialize_from_main_function = &initialize_box_geometry_from_main_component;
this_box_volume.geometry.process_rot_allocated = 0;

this_box_volume.geometry.copy_geometry_parameters = &allocate_box_storage_copy;

rot_copy(this_box_volume.geometry.rotation_matrix,ROT_A_CURRENT_COMP); //check how ROT_R_CURRENT_COMP would work
rot_transpose(ROT_A_CURRENT_COMP,this_box_volume.geometry.transpose_rotation_matrix);

// Initialize loggers
this_box_volume.loggers.num_elements = 0;

// packing the information into the global_geometry_element, which is then included in the global_geometry_list.
sprintf(global_geometry_element.name,NAME_CURRENT_COMP);
global_geometry_element.activation_counter = number_of_activations;
global_geometry_element.component_index = INDEX_CURRENT_COMP;
global_geometry_element.Volume = &this_box_volume; // Would be nicer if this m was a pointer, now we have the (small) data two places
add_element_to_geometry_list(&global_geometry_list,global_geometry_element);
}
#line 182366 "MACS_sample_kidney_box.c"
#undef number_of_activations
#undef mask_setting
#undef mask_string
#undef p_interact
#undef focus_r
#undef focus_xh
#undef focus_xw
#undef focus_ah
#undef focus_aw
#undef target_z
#undef target_y
#undef target_x
#undef target_index
#undef visualize
#undef yheight2
#undef xwidth2
#undef zdepth
#undef yheight
#undef xwidth
#undef priority
#undef material_string
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

  /* Initializations for component channel_2_cave1_box2. */
  SIG_MESSAGE("channel_2_cave1_box2 (Init)");
#define mccompcurname  channel_2_cave1_box2
#define mccompcurtype  Union_box
#define mccompcurindex 201
#define loop_index mccchannel_2_cave1_box2_loop_index
#define this_box_volume mccchannel_2_cave1_box2_this_box_volume
#define global_geometry_element mccchannel_2_cave1_box2_global_geometry_element
#define this_box_storage mccchannel_2_cave1_box2_this_box_storage
#define material_string mccchannel_2_cave1_box2_material_string
#define priority mccchannel_2_cave1_box2_priority
#define xwidth mccchannel_2_cave1_box2_xwidth
#define yheight mccchannel_2_cave1_box2_yheight
#define zdepth mccchannel_2_cave1_box2_zdepth
#define xwidth2 mccchannel_2_cave1_box2_xwidth2
#define yheight2 mccchannel_2_cave1_box2_yheight2
#define visualize mccchannel_2_cave1_box2_visualize
#define target_index mccchannel_2_cave1_box2_target_index
#define target_x mccchannel_2_cave1_box2_target_x
#define target_y mccchannel_2_cave1_box2_target_y
#define target_z mccchannel_2_cave1_box2_target_z
#define focus_aw mccchannel_2_cave1_box2_focus_aw
#define focus_ah mccchannel_2_cave1_box2_focus_ah
#define focus_xw mccchannel_2_cave1_box2_focus_xw
#define focus_xh mccchannel_2_cave1_box2_focus_xh
#define focus_r mccchannel_2_cave1_box2_focus_r
#define p_interact mccchannel_2_cave1_box2_p_interact
#define mask_string mccchannel_2_cave1_box2_mask_string
#define mask_setting mccchannel_2_cave1_box2_mask_setting
#define number_of_activations mccchannel_2_cave1_box2_number_of_activations
#line 224 "Union_box.comp"
{
// Initializes the focusing system for this volume including input sanitation.
focus_initialize(&this_box_volume.geometry, POS_A_COMP_INDEX(INDEX_CURRENT_COMP+target_index), POS_A_CURRENT_COMP, ROT_A_CURRENT_COMP, target_index, target_x, target_y, target_z, focus_aw, focus_ah, focus_xw, focus_xh, focus_r, NAME_CURRENT_COMP);

// Input sanitation for this geometry
if (xwidth <= 0) {
  printf("\nERROR in Union_box named %s, the xwidth is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (yheight <= 0) {
  printf("\nERROR in Union_box named %s, yheight is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (zdepth <= 0) {
  printf("\nERROR in Union_box named %s, zdepth is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (xwidth2 <= 0 && xwidth2 != -1) {
  printf("\nERROR in Union_box named %s, the xwidth2 is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (yheight2 <= 0 && yheight2 != -1) {
  printf("\nERROR in Union_box named %s, yheight2 is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}

// Use sanitation
if (global_material_list.num_elements == 0) {
  printf("\nERROR: Need to define a material using Union_make_material before using a Union geometry component. \n");
  printf("       %s was defined before first use of Union_make_material.\n",NAME_CURRENT_COMP);
  exit(1);
}

this_box_volume.geometry.is_masked_volume = 0;
this_box_volume.geometry.is_exit_volume = 0;
this_box_volume.geometry.is_mask_volume = 0;
// check if the volume is a mask, if it is the material string is irelevant.
if (mask_string && strlen(mask_string) && strcmp(mask_string, "NULL") && strcmp(mask_string, "0")) {
    // A mask volume is used to limit the extend of other volumes, called the masked volumes. These are specified in the mask_string.
    // In order for a ray to enter a masked volume, it needs to be both in the region covered by that volume AND the mask volume.
    // When more than
    this_box_volume.geometry.mask_mode = 1; // Default is mask mode is ALL
    if (mask_setting && strlen(mask_setting) && strcmp(mask_setting, "NULL") && strcmp(mask_setting, "0")) {
        if (strcmp(mask_setting,"ALL") == 0 || strcmp(mask_setting,"All") == 0) this_box_volume.geometry.mask_mode = 1;
        else if (strcmp(mask_setting,"ANY") == 0 || strcmp(mask_setting,"Any") == 0) this_box_volume.geometry.mask_mode = 2;
        else {
            printf("The mask_mode of component %s is set to %s, but must be either ALL or ANY.\n",NAME_CURRENT_COMP,mask_setting);
            exit(1);
        }
    }
    
    for (loop_index=0;loop_index<global_geometry_list.num_elements;loop_index++) {
        // Add mask list
        if (1 == manual_linking_function(global_geometry_list.elements[loop_index].name,mask_string)) {
            add_element_to_int_list(&this_box_volume.geometry.mask_list,global_geometry_list.elements[loop_index].component_index);
            add_element_to_int_list(&global_geometry_list.elements[loop_index].Volume->geometry.masked_by_list,INDEX_CURRENT_COMP);
            global_geometry_list.elements[loop_index].Volume->geometry.is_masked_volume = 1;
            if (this_box_volume.geometry.mask_mode == 2)
                global_geometry_list.elements[loop_index].Volume->geometry.mask_mode = 2;
            if (this_box_volume.geometry.mask_mode == 1) {
                if (global_geometry_list.elements[loop_index].Volume->geometry.is_masked_volume == 1 && global_geometry_list.elements[loop_index].Volume->geometry.mask_mode != 2)
                    // If more than one mask is added to one volume, the ANY mode overwrites the (default) ALL mode.
                    global_geometry_list.elements[loop_index].Volume->geometry.mask_mode = 1;
            }
            
            found_geometries = 1;
        }
    }
    if (found_geometries == 0) {
        printf("The mask_string in geometry: %s did not find any of the specified volumes in the mask_string %s \n",NAME_CURRENT_COMP,mask_string);
        exit(1);
    }
    this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
    this_box_volume.p_physics->is_vacuum = 0; // Makes this volume a vacuum
    this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
    this_box_volume.p_physics->my_a = 0; // Should not be used.
    sprintf(this_box_volume.p_physics->name,"Mask");
    this_box_volume.geometry.is_mask_volume = 1;
    
    
// Read the material input, or if it lacks, use automatic linking.
} else if (material_string && strlen(material_string) && strcmp(material_string, "NULL") && strcmp(material_string, "0")) {
    // A geometry string was given, use it to determine which material
    if (0 == strcmp(material_string,"vacuum") || 0 == strcmp(material_string,"Vacuum")) {
        // One could have a global physics struct for vacuum instead of creating one for each
        this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
        this_box_volume.p_physics->is_vacuum = 1; // Makes this volume a vacuum
        this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
        this_box_volume.p_physics->my_a = 0; // Should not be used.
        sprintf(this_box_volume.p_physics->name,"Vacuum");
    } else if (0 == strcmp(material_string,"exit") || 0 == strcmp(material_string,"Exit")) {
        // One could have a global physics struct for vacuum instead of creating one for each
        this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
        this_box_volume.p_physics->is_vacuum = 1; // Makes this volume a vacuum
        this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
        this_box_volume.p_physics->my_a = 0; // Should not be used.
        this_box_volume.geometry.is_exit_volume = 1;
        sprintf(this_box_volume.p_physics->name,"Exit");
    } else {
        #ifndef MATERIAL_DETECTOR
            printf("Need to define a material before refering to it in a geometry %s.\n",NAME_CURRENT_COMP);
            exit(1);
        #endif
        for (loop_index=0;loop_index<global_material_list.num_elements;loop_index++) {
            if (0 == strcmp(material_string,global_material_list.elements[loop_index].name)) {
                this_box_volume.p_physics = global_material_list.elements[loop_index].physics;
                break;
            }
            if (loop_index == global_material_list.num_elements-1) {
            printf("\n");
            printf("ERROR: The material string \"%s\" in Union geometry \"%s\" did not match a specified material. \n",material_string,NAME_CURRENT_COMP);
            printf("       The materials available at this point (need to be defined before the geometry): \n");
            for (loop_index=0;loop_index<global_material_list.num_elements;loop_index++)
              printf("         %s\n",global_material_list.elements[loop_index].name);
            printf("\n");
            printf("       It is also possible to use one of the defualt materials avaiable: \n");
            printf("           Vacuum (for a Volume without scattering or absorption)\n");
            printf("           Exit (for a Volume where the ray exits the component if it enters)\n");
            printf("           Mask (for a Volume that masks existing volumes specified in the mask_string\n");
            exit(1);
          }
        }
    }
} else {
    // Automatic linking, simply using the last defined material.
    #ifndef MATERIAL_DETECTOR
        printf("Need to define a material before the geometry to use automatic linking %s.\n",NAME_CURRENT_COMP);
        exit(1);
    #endif
    this_box_volume.p_physics = global_material_list.elements[global_material_list.num_elements-1].physics;
}

sprintf(this_box_volume.name,NAME_CURRENT_COMP);
sprintf(this_box_volume.geometry.shape,"box");
this_box_volume.geometry.priority_value = priority;
this_box_volume.geometry.geometry_p_interact = p_interact;
// Currently the coordinates will be in absolute space.
this_box_volume.geometry.center = POS_A_CURRENT_COMP;

this_box_storage.z_depth = zdepth;
this_box_storage.x_width1 = xwidth;
this_box_storage.y_height1 = yheight;

this_box_storage.is_rectangle = 0;
if (xwidth2 < 0 && yheight2 < 0) this_box_storage.is_rectangle = 1;
if (xwidth == xwidth2 && yheight == yheight2) this_box_storage.is_rectangle = 1;

if (xwidth2 < 0) {
    this_box_storage.x_width2 = xwidth;
    xwidth2 = xwidth;
} else this_box_storage.x_width2 = xwidth2;

if (yheight2 < 0) {
    this_box_storage.y_height2 = yheight;
    yheight2 = yheight;
} else this_box_storage.y_height2 = yheight2;


this_box_storage.normal_vectors[0] = coords_set(0,0,1);
this_box_storage.normal_vectors[1] = coords_set(0,0,1);

// for sides with y component = 0
x_component = 2*zdepth/sqrt((xwidth-xwidth2)*(xwidth-xwidth2)+4*zdepth*zdepth);
z_component = (xwidth-xwidth2)/sqrt(4*zdepth*zdepth+(xwidth-xwidth2)*(xwidth-xwidth2));

this_box_storage.normal_vectors[2] = coords_set(x_component,0,z_component);
this_box_storage.normal_vectors[3] = coords_set(-x_component,0,z_component);

// for sides with x component = 0
y_component = 2*zdepth/sqrt((yheight-yheight2)*(yheight-yheight2)+4*zdepth*zdepth);
z_component = (yheight-yheight2)/sqrt(4*zdepth*zdepth+(yheight-yheight2)*(yheight-yheight2));

this_box_storage.normal_vectors[4] = coords_set(0,y_component,z_component);
this_box_storage.normal_vectors[5] = coords_set(0,-y_component,z_component);

this_box_volume.geometry.visualization_on = visualize;

this_box_volume.geometry.geometry_parameters.p_box_storage = &this_box_storage;

// Assign pointers to functions for intersection with the shape, checking if a point is inside the shape
if (this_box_storage.is_rectangle == 1) {
this_box_volume.geometry.intersect_function = &sample_box_intersect_simple;
this_box_volume.geometry.within_function = &r_within_box_simple;
}
else {
this_box_volume.geometry.intersect_function = &sample_box_intersect_advanced;
this_box_volume.geometry.within_function = &r_within_box_advanced;
}

this_box_volume.geometry.shell_points = &box_shell_points;
this_box_volume.geometry.mcdisplay_function = &mcdisplay_box_function;
this_box_volume.geometry.initialize_from_main_function = &initialize_box_geometry_from_main_component;
this_box_volume.geometry.process_rot_allocated = 0;

this_box_volume.geometry.copy_geometry_parameters = &allocate_box_storage_copy;

rot_copy(this_box_volume.geometry.rotation_matrix,ROT_A_CURRENT_COMP); //check how ROT_R_CURRENT_COMP would work
rot_transpose(ROT_A_CURRENT_COMP,this_box_volume.geometry.transpose_rotation_matrix);

// Initialize loggers
this_box_volume.loggers.num_elements = 0;

// packing the information into the global_geometry_element, which is then included in the global_geometry_list.
sprintf(global_geometry_element.name,NAME_CURRENT_COMP);
global_geometry_element.activation_counter = number_of_activations;
global_geometry_element.component_index = INDEX_CURRENT_COMP;
global_geometry_element.Volume = &this_box_volume; // Would be nicer if this m was a pointer, now we have the (small) data two places
add_element_to_geometry_list(&global_geometry_list,global_geometry_element);
}
#line 182636 "MACS_sample_kidney_box.c"
#undef number_of_activations
#undef mask_setting
#undef mask_string
#undef p_interact
#undef focus_r
#undef focus_xh
#undef focus_xw
#undef focus_ah
#undef focus_aw
#undef target_z
#undef target_y
#undef target_x
#undef target_index
#undef visualize
#undef yheight2
#undef xwidth2
#undef zdepth
#undef yheight
#undef xwidth
#undef priority
#undef material_string
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

  /* Initializations for component channel_2_cave1_box3. */
  SIG_MESSAGE("channel_2_cave1_box3 (Init)");
#define mccompcurname  channel_2_cave1_box3
#define mccompcurtype  Union_box
#define mccompcurindex 202
#define loop_index mccchannel_2_cave1_box3_loop_index
#define this_box_volume mccchannel_2_cave1_box3_this_box_volume
#define global_geometry_element mccchannel_2_cave1_box3_global_geometry_element
#define this_box_storage mccchannel_2_cave1_box3_this_box_storage
#define material_string mccchannel_2_cave1_box3_material_string
#define priority mccchannel_2_cave1_box3_priority
#define xwidth mccchannel_2_cave1_box3_xwidth
#define yheight mccchannel_2_cave1_box3_yheight
#define zdepth mccchannel_2_cave1_box3_zdepth
#define xwidth2 mccchannel_2_cave1_box3_xwidth2
#define yheight2 mccchannel_2_cave1_box3_yheight2
#define visualize mccchannel_2_cave1_box3_visualize
#define target_index mccchannel_2_cave1_box3_target_index
#define target_x mccchannel_2_cave1_box3_target_x
#define target_y mccchannel_2_cave1_box3_target_y
#define target_z mccchannel_2_cave1_box3_target_z
#define focus_aw mccchannel_2_cave1_box3_focus_aw
#define focus_ah mccchannel_2_cave1_box3_focus_ah
#define focus_xw mccchannel_2_cave1_box3_focus_xw
#define focus_xh mccchannel_2_cave1_box3_focus_xh
#define focus_r mccchannel_2_cave1_box3_focus_r
#define p_interact mccchannel_2_cave1_box3_p_interact
#define mask_string mccchannel_2_cave1_box3_mask_string
#define mask_setting mccchannel_2_cave1_box3_mask_setting
#define number_of_activations mccchannel_2_cave1_box3_number_of_activations
#line 224 "Union_box.comp"
{
// Initializes the focusing system for this volume including input sanitation.
focus_initialize(&this_box_volume.geometry, POS_A_COMP_INDEX(INDEX_CURRENT_COMP+target_index), POS_A_CURRENT_COMP, ROT_A_CURRENT_COMP, target_index, target_x, target_y, target_z, focus_aw, focus_ah, focus_xw, focus_xh, focus_r, NAME_CURRENT_COMP);

// Input sanitation for this geometry
if (xwidth <= 0) {
  printf("\nERROR in Union_box named %s, the xwidth is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (yheight <= 0) {
  printf("\nERROR in Union_box named %s, yheight is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (zdepth <= 0) {
  printf("\nERROR in Union_box named %s, zdepth is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (xwidth2 <= 0 && xwidth2 != -1) {
  printf("\nERROR in Union_box named %s, the xwidth2 is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (yheight2 <= 0 && yheight2 != -1) {
  printf("\nERROR in Union_box named %s, yheight2 is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}

// Use sanitation
if (global_material_list.num_elements == 0) {
  printf("\nERROR: Need to define a material using Union_make_material before using a Union geometry component. \n");
  printf("       %s was defined before first use of Union_make_material.\n",NAME_CURRENT_COMP);
  exit(1);
}

this_box_volume.geometry.is_masked_volume = 0;
this_box_volume.geometry.is_exit_volume = 0;
this_box_volume.geometry.is_mask_volume = 0;
// check if the volume is a mask, if it is the material string is irelevant.
if (mask_string && strlen(mask_string) && strcmp(mask_string, "NULL") && strcmp(mask_string, "0")) {
    // A mask volume is used to limit the extend of other volumes, called the masked volumes. These are specified in the mask_string.
    // In order for a ray to enter a masked volume, it needs to be both in the region covered by that volume AND the mask volume.
    // When more than
    this_box_volume.geometry.mask_mode = 1; // Default is mask mode is ALL
    if (mask_setting && strlen(mask_setting) && strcmp(mask_setting, "NULL") && strcmp(mask_setting, "0")) {
        if (strcmp(mask_setting,"ALL") == 0 || strcmp(mask_setting,"All") == 0) this_box_volume.geometry.mask_mode = 1;
        else if (strcmp(mask_setting,"ANY") == 0 || strcmp(mask_setting,"Any") == 0) this_box_volume.geometry.mask_mode = 2;
        else {
            printf("The mask_mode of component %s is set to %s, but must be either ALL or ANY.\n",NAME_CURRENT_COMP,mask_setting);
            exit(1);
        }
    }
    
    for (loop_index=0;loop_index<global_geometry_list.num_elements;loop_index++) {
        // Add mask list
        if (1 == manual_linking_function(global_geometry_list.elements[loop_index].name,mask_string)) {
            add_element_to_int_list(&this_box_volume.geometry.mask_list,global_geometry_list.elements[loop_index].component_index);
            add_element_to_int_list(&global_geometry_list.elements[loop_index].Volume->geometry.masked_by_list,INDEX_CURRENT_COMP);
            global_geometry_list.elements[loop_index].Volume->geometry.is_masked_volume = 1;
            if (this_box_volume.geometry.mask_mode == 2)
                global_geometry_list.elements[loop_index].Volume->geometry.mask_mode = 2;
            if (this_box_volume.geometry.mask_mode == 1) {
                if (global_geometry_list.elements[loop_index].Volume->geometry.is_masked_volume == 1 && global_geometry_list.elements[loop_index].Volume->geometry.mask_mode != 2)
                    // If more than one mask is added to one volume, the ANY mode overwrites the (default) ALL mode.
                    global_geometry_list.elements[loop_index].Volume->geometry.mask_mode = 1;
            }
            
            found_geometries = 1;
        }
    }
    if (found_geometries == 0) {
        printf("The mask_string in geometry: %s did not find any of the specified volumes in the mask_string %s \n",NAME_CURRENT_COMP,mask_string);
        exit(1);
    }
    this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
    this_box_volume.p_physics->is_vacuum = 0; // Makes this volume a vacuum
    this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
    this_box_volume.p_physics->my_a = 0; // Should not be used.
    sprintf(this_box_volume.p_physics->name,"Mask");
    this_box_volume.geometry.is_mask_volume = 1;
    
    
// Read the material input, or if it lacks, use automatic linking.
} else if (material_string && strlen(material_string) && strcmp(material_string, "NULL") && strcmp(material_string, "0")) {
    // A geometry string was given, use it to determine which material
    if (0 == strcmp(material_string,"vacuum") || 0 == strcmp(material_string,"Vacuum")) {
        // One could have a global physics struct for vacuum instead of creating one for each
        this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
        this_box_volume.p_physics->is_vacuum = 1; // Makes this volume a vacuum
        this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
        this_box_volume.p_physics->my_a = 0; // Should not be used.
        sprintf(this_box_volume.p_physics->name,"Vacuum");
    } else if (0 == strcmp(material_string,"exit") || 0 == strcmp(material_string,"Exit")) {
        // One could have a global physics struct for vacuum instead of creating one for each
        this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
        this_box_volume.p_physics->is_vacuum = 1; // Makes this volume a vacuum
        this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
        this_box_volume.p_physics->my_a = 0; // Should not be used.
        this_box_volume.geometry.is_exit_volume = 1;
        sprintf(this_box_volume.p_physics->name,"Exit");
    } else {
        #ifndef MATERIAL_DETECTOR
            printf("Need to define a material before refering to it in a geometry %s.\n",NAME_CURRENT_COMP);
            exit(1);
        #endif
        for (loop_index=0;loop_index<global_material_list.num_elements;loop_index++) {
            if (0 == strcmp(material_string,global_material_list.elements[loop_index].name)) {
                this_box_volume.p_physics = global_material_list.elements[loop_index].physics;
                break;
            }
            if (loop_index == global_material_list.num_elements-1) {
            printf("\n");
            printf("ERROR: The material string \"%s\" in Union geometry \"%s\" did not match a specified material. \n",material_string,NAME_CURRENT_COMP);
            printf("       The materials available at this point (need to be defined before the geometry): \n");
            for (loop_index=0;loop_index<global_material_list.num_elements;loop_index++)
              printf("         %s\n",global_material_list.elements[loop_index].name);
            printf("\n");
            printf("       It is also possible to use one of the defualt materials avaiable: \n");
            printf("           Vacuum (for a Volume without scattering or absorption)\n");
            printf("           Exit (for a Volume where the ray exits the component if it enters)\n");
            printf("           Mask (for a Volume that masks existing volumes specified in the mask_string\n");
            exit(1);
          }
        }
    }
} else {
    // Automatic linking, simply using the last defined material.
    #ifndef MATERIAL_DETECTOR
        printf("Need to define a material before the geometry to use automatic linking %s.\n",NAME_CURRENT_COMP);
        exit(1);
    #endif
    this_box_volume.p_physics = global_material_list.elements[global_material_list.num_elements-1].physics;
}

sprintf(this_box_volume.name,NAME_CURRENT_COMP);
sprintf(this_box_volume.geometry.shape,"box");
this_box_volume.geometry.priority_value = priority;
this_box_volume.geometry.geometry_p_interact = p_interact;
// Currently the coordinates will be in absolute space.
this_box_volume.geometry.center = POS_A_CURRENT_COMP;

this_box_storage.z_depth = zdepth;
this_box_storage.x_width1 = xwidth;
this_box_storage.y_height1 = yheight;

this_box_storage.is_rectangle = 0;
if (xwidth2 < 0 && yheight2 < 0) this_box_storage.is_rectangle = 1;
if (xwidth == xwidth2 && yheight == yheight2) this_box_storage.is_rectangle = 1;

if (xwidth2 < 0) {
    this_box_storage.x_width2 = xwidth;
    xwidth2 = xwidth;
} else this_box_storage.x_width2 = xwidth2;

if (yheight2 < 0) {
    this_box_storage.y_height2 = yheight;
    yheight2 = yheight;
} else this_box_storage.y_height2 = yheight2;


this_box_storage.normal_vectors[0] = coords_set(0,0,1);
this_box_storage.normal_vectors[1] = coords_set(0,0,1);

// for sides with y component = 0
x_component = 2*zdepth/sqrt((xwidth-xwidth2)*(xwidth-xwidth2)+4*zdepth*zdepth);
z_component = (xwidth-xwidth2)/sqrt(4*zdepth*zdepth+(xwidth-xwidth2)*(xwidth-xwidth2));

this_box_storage.normal_vectors[2] = coords_set(x_component,0,z_component);
this_box_storage.normal_vectors[3] = coords_set(-x_component,0,z_component);

// for sides with x component = 0
y_component = 2*zdepth/sqrt((yheight-yheight2)*(yheight-yheight2)+4*zdepth*zdepth);
z_component = (yheight-yheight2)/sqrt(4*zdepth*zdepth+(yheight-yheight2)*(yheight-yheight2));

this_box_storage.normal_vectors[4] = coords_set(0,y_component,z_component);
this_box_storage.normal_vectors[5] = coords_set(0,-y_component,z_component);

this_box_volume.geometry.visualization_on = visualize;

this_box_volume.geometry.geometry_parameters.p_box_storage = &this_box_storage;

// Assign pointers to functions for intersection with the shape, checking if a point is inside the shape
if (this_box_storage.is_rectangle == 1) {
this_box_volume.geometry.intersect_function = &sample_box_intersect_simple;
this_box_volume.geometry.within_function = &r_within_box_simple;
}
else {
this_box_volume.geometry.intersect_function = &sample_box_intersect_advanced;
this_box_volume.geometry.within_function = &r_within_box_advanced;
}

this_box_volume.geometry.shell_points = &box_shell_points;
this_box_volume.geometry.mcdisplay_function = &mcdisplay_box_function;
this_box_volume.geometry.initialize_from_main_function = &initialize_box_geometry_from_main_component;
this_box_volume.geometry.process_rot_allocated = 0;

this_box_volume.geometry.copy_geometry_parameters = &allocate_box_storage_copy;

rot_copy(this_box_volume.geometry.rotation_matrix,ROT_A_CURRENT_COMP); //check how ROT_R_CURRENT_COMP would work
rot_transpose(ROT_A_CURRENT_COMP,this_box_volume.geometry.transpose_rotation_matrix);

// Initialize loggers
this_box_volume.loggers.num_elements = 0;

// packing the information into the global_geometry_element, which is then included in the global_geometry_list.
sprintf(global_geometry_element.name,NAME_CURRENT_COMP);
global_geometry_element.activation_counter = number_of_activations;
global_geometry_element.component_index = INDEX_CURRENT_COMP;
global_geometry_element.Volume = &this_box_volume; // Would be nicer if this m was a pointer, now we have the (small) data two places
add_element_to_geometry_list(&global_geometry_list,global_geometry_element);
}
#line 182906 "MACS_sample_kidney_box.c"
#undef number_of_activations
#undef mask_setting
#undef mask_string
#undef p_interact
#undef focus_r
#undef focus_xh
#undef focus_xw
#undef focus_ah
#undef focus_aw
#undef target_z
#undef target_y
#undef target_x
#undef target_index
#undef visualize
#undef yheight2
#undef xwidth2
#undef zdepth
#undef yheight
#undef xwidth
#undef priority
#undef material_string
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

  /* Initializations for component channel_2_cave1_cyl1. */
  SIG_MESSAGE("channel_2_cave1_cyl1 (Init)");
#define mccompcurname  channel_2_cave1_cyl1
#define mccompcurtype  Union_cylinder
#define mccompcurindex 203
#define loop_index mccchannel_2_cave1_cyl1_loop_index
#define this_cylinder_volume mccchannel_2_cave1_cyl1_this_cylinder_volume
#define global_geometry_element mccchannel_2_cave1_cyl1_global_geometry_element
#define this_cylinder_storage mccchannel_2_cave1_cyl1_this_cylinder_storage
#define material_string mccchannel_2_cave1_cyl1_material_string
#define priority mccchannel_2_cave1_cyl1_priority
#define radius mccchannel_2_cave1_cyl1_radius
#define yheight mccchannel_2_cave1_cyl1_yheight
#define visualize mccchannel_2_cave1_cyl1_visualize
#define target_index mccchannel_2_cave1_cyl1_target_index
#define target_x mccchannel_2_cave1_cyl1_target_x
#define target_y mccchannel_2_cave1_cyl1_target_y
#define target_z mccchannel_2_cave1_cyl1_target_z
#define focus_aw mccchannel_2_cave1_cyl1_focus_aw
#define focus_ah mccchannel_2_cave1_cyl1_focus_ah
#define focus_xw mccchannel_2_cave1_cyl1_focus_xw
#define focus_xh mccchannel_2_cave1_cyl1_focus_xh
#define focus_r mccchannel_2_cave1_cyl1_focus_r
#define p_interact mccchannel_2_cave1_cyl1_p_interact
#define mask_string mccchannel_2_cave1_cyl1_mask_string
#define mask_setting mccchannel_2_cave1_cyl1_mask_setting
#define number_of_activations mccchannel_2_cave1_cyl1_number_of_activations
#line 185 "Union_cylinder.comp"
{
// Initializes the focusing system for this volume including input sanitation.
focus_initialize(&this_cylinder_volume.geometry, POS_A_COMP_INDEX(INDEX_CURRENT_COMP+target_index), POS_A_CURRENT_COMP, ROT_A_CURRENT_COMP, target_index, target_x, target_y, target_z, focus_aw, focus_ah, focus_xw, focus_xh, focus_r, NAME_CURRENT_COMP);

// Input sanitation for this geometry
if (radius <= 0) {
  printf("\nERROR in Union_cylinder named %s, the radius is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}

if (yheight <= 0) {
  printf("\nERROR in Union_cylinder named %s, yheight is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}

// Use sanitation
#ifdef MATERIAL_DETECTOR
if (global_material_list.num_elements == 0) {
  // Here if the user have defined a material, but only after this material
  printf("\nERROR: Need to define a material using Union_make_material before using a Union geometry component. \n");
  printf("       %s was defined before first use of Union_make_material.\n",NAME_CURRENT_COMP);
  exit(1);
}
#endif
#ifndef MATERIAL_DETECTOR
  printf("\nERROR: Need to define a material using Union_make_material before using a Union geometry component. \n");
  exit(1);
#endif


this_cylinder_volume.geometry.is_masked_volume = 0;
this_cylinder_volume.geometry.is_exit_volume = 0;
this_cylinder_volume.geometry.is_mask_volume = 0;

// Read the material input, or if it lacks, use automatic linking.
if (mask_string && strlen(mask_string) && strcmp(mask_string, "NULL") && strcmp(mask_string, "0")) {
    // A mask volume is used to limit the extend of other volumes, called the masked volumes. These are specified in the mask_string.
    // In order for a ray to enter a masked volume, it needs to be both in the region covered by that volume AND the mask volume.
    // When more than
    this_cylinder_volume.geometry.mask_mode = 1; // Default is mask mode is ALL
    if (mask_setting && strlen(mask_setting) && strcmp(mask_setting, "NULL") && strcmp(mask_setting, "0")) {
        if (strcmp(mask_setting,"ALL") == 0 || strcmp(mask_setting,"All") == 0) this_cylinder_volume.geometry.mask_mode = 1;
        else if (strcmp(mask_setting,"ANY") == 0 || strcmp(mask_setting,"Any") == 0) this_cylinder_volume.geometry.mask_mode = 2;
        else {
            printf("The mask_mode of component %s is set to %s, but must be either ALL or ANY.\n",NAME_CURRENT_COMP,mask_setting);
            exit(1);
        }
    }
    
    for (loop_index=0;loop_index<global_geometry_list.num_elements;loop_index++) {
        // Add mask list
        if (1 == manual_linking_function(global_geometry_list.elements[loop_index].name,mask_string)) {
            add_element_to_int_list(&this_cylinder_volume.geometry.mask_list,global_geometry_list.elements[loop_index].component_index);
            add_element_to_int_list(&global_geometry_list.elements[loop_index].Volume->geometry.masked_by_list,INDEX_CURRENT_COMP);
            global_geometry_list.elements[loop_index].Volume->geometry.is_masked_volume = 1;
            if (this_cylinder_volume.geometry.mask_mode == 2)
                global_geometry_list.elements[loop_index].Volume->geometry.mask_mode = 2;
            if (this_cylinder_volume.geometry.mask_mode == 1) {
                if (global_geometry_list.elements[loop_index].Volume->geometry.is_masked_volume == 1 && global_geometry_list.elements[loop_index].Volume->geometry.mask_mode != 2)
                    // If more than one mask is added to one volume, the ANY mode overwrites the (default) ALL mode.
                    global_geometry_list.elements[loop_index].Volume->geometry.mask_mode = 1;
            }
            
            found_geometries = 1;
        }
    }
    if (found_geometries == 0) {
        printf("The mask_string in geometry: %s did not find any of the specified volumes in the mask_string %s \n",NAME_CURRENT_COMP,mask_string);
        exit(1);
    }
    this_cylinder_volume.p_physics = malloc(sizeof(struct physics_struct));
    this_cylinder_volume.p_physics->is_vacuum = 0; // Makes this volume a vacuum
    this_cylinder_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
    this_cylinder_volume.p_physics->my_a = 0; // Should not be used.
    sprintf(this_cylinder_volume.p_physics->name,"Mask");
    this_cylinder_volume.geometry.is_mask_volume = 1;
    
    
// Read the material input, or if it lacks, use automatic linking.
} else if (material_string && strlen(material_string) && strcmp(material_string, "NULL") && strcmp(material_string, "0")) {
    // A geometry string was given, use it to determine which material
    if (0 == strcmp(material_string,"vacuum") || 0 == strcmp(material_string,"Vacuum")) {
        // One could have a global physics struct for vacuum instead of creating one for each
        this_cylinder_volume.p_physics = malloc(sizeof(struct physics_struct));
        this_cylinder_volume.p_physics->is_vacuum = 1; // Makes this volume a vacuum
        this_cylinder_volume.p_physics->number_of_processes = (int) 0;
        this_cylinder_volume.p_physics->my_a = 0; // Should not be used.
        sprintf(this_cylinder_volume.p_physics->name,"Vacuum");
    } else if (0 == strcmp(material_string,"exit") || 0 == strcmp(material_string,"Exit")) {
        // One could have a global physics struct for exit instead of creating one for each
        this_cylinder_volume.p_physics = malloc(sizeof(struct physics_struct));
        this_cylinder_volume.p_physics->is_vacuum = 1; // Makes this volume a vacuum
        this_cylinder_volume.p_physics->number_of_processes = (int) 0;
        this_cylinder_volume.p_physics->my_a = 0; // Should not be used.
        this_cylinder_volume.geometry.is_exit_volume = 1;
        sprintf(this_cylinder_volume.p_physics->name,"Exit");
    } else {
        for (loop_index=0;loop_index<global_material_list.num_elements;loop_index++) {
          if (0 == strcmp(material_string,global_material_list.elements[loop_index].name)) {
            this_cylinder_volume.p_physics = global_material_list.elements[loop_index].physics;
            break;
          }
          if (loop_index == global_material_list.num_elements-1) {
            printf("\n");
            printf("ERROR: The material string \"%s\" in Union geometry \"%s\" did not match a specified material. \n",material_string,NAME_CURRENT_COMP);
            printf("       The materials available at this point (need to be defined before the geometry): \n");
            for (loop_index=0;loop_index<global_material_list.num_elements;loop_index++)
              printf("         %s\n",global_material_list.elements[loop_index].name);
            printf("\n");
            printf("       It is also possible to use one of the defualt materials avaiable: \n");
            printf("           Vacuum (for a Volume without scattering or absorption)\n");
            printf("           Exit (for a Volume where the ray exits the component if it enters)\n");
            printf("           Mask (for a Volume that masks existing volumes specified in the mask_string\n");
            exit(1);
          }
        }
    }
} else {
    // Automatic linking, simply using the last defined material.
    #ifndef MATERIAL_DETECTOR
        printf("Need to define a material before the geometry to use automatic linking %s.\n",NAME_CURRENT_COMP);
        exit(1);
    #endif
    this_cylinder_volume.p_physics = global_material_list.elements[global_material_list.num_elements-1].physics;
}

sprintf(this_cylinder_volume.name,NAME_CURRENT_COMP);
sprintf(this_cylinder_volume.geometry.shape,"cylinder");
this_cylinder_volume.geometry.priority_value = priority;
// Currently the coordinates will be in absolute space.
this_cylinder_volume.geometry.center = POS_A_CURRENT_COMP;

this_cylinder_volume.geometry.geometry_p_interact = p_interact;
this_cylinder_storage.cyl_radius = radius;
this_cylinder_storage.height = yheight;
this_cylinder_volume.geometry.visualization_on = visualize;
this_cylinder_volume.geometry.geometry_parameters.p_cylinder_storage = &this_cylinder_storage;
this_cylinder_volume.geometry.within_function = &r_within_cylinder;
this_cylinder_volume.geometry.intersect_function = &sample_cylinder_intersect;
this_cylinder_volume.geometry.mcdisplay_function = &mcdisplay_cylinder_function;
this_cylinder_volume.geometry.shell_points = &cylinder_shell_points;
this_cylinder_volume.geometry.initialize_from_main_function = &initialize_cylinder_geometry_from_main_component;
this_cylinder_volume.geometry.process_rot_allocated = 0;
this_cylinder_volume.geometry.copy_geometry_parameters = &allocate_cylinder_storage_copy;

rot_copy(this_cylinder_volume.geometry.rotation_matrix,ROT_A_CURRENT_COMP);
rot_transpose(ROT_A_CURRENT_COMP,this_cylinder_volume.geometry.transpose_rotation_matrix);

// Initialize loggers
this_cylinder_volume.loggers.num_elements = 0;

// packing the information into the global_geometry_element, which is then included in the global_geometry_list.
sprintf(global_geometry_element.name,NAME_CURRENT_COMP);
global_geometry_element.activation_counter = number_of_activations;
global_geometry_element.component_index = INDEX_CURRENT_COMP;
global_geometry_element.Volume = &this_cylinder_volume; // Would be nicer if this m was a pointer, now we have the (small) data two places
add_element_to_geometry_list(&global_geometry_list,global_geometry_element);
}
#line 183122 "MACS_sample_kidney_box.c"
#undef number_of_activations
#undef mask_setting
#undef mask_string
#undef p_interact
#undef focus_r
#undef focus_xh
#undef focus_xw
#undef focus_ah
#undef focus_aw
#undef target_z
#undef target_y
#undef target_x
#undef target_index
#undef visualize
#undef yheight
#undef radius
#undef priority
#undef material_string
#undef this_cylinder_storage
#undef global_geometry_element
#undef this_cylinder_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

  /* Initializations for component channel_2_analyzer_1_center. */
  SIG_MESSAGE("channel_2_analyzer_1_center (Init)");

  /* Initializations for component channel_2_analyzer_1_rotated. */
  SIG_MESSAGE("channel_2_analyzer_1_rotated (Init)");

  /* Initializations for component channel_2_analyzer_1_array_crystal_array_0. */
  SIG_MESSAGE("channel_2_analyzer_1_array_crystal_array_0 (Init)");
#define mccompcurname  channel_2_analyzer_1_array_crystal_array_0
#define mccompcurtype  Union_box
#define mccompcurindex 206
#define loop_index mccchannel_2_analyzer_1_array_crystal_array_0_loop_index
#define this_box_volume mccchannel_2_analyzer_1_array_crystal_array_0_this_box_volume
#define global_geometry_element mccchannel_2_analyzer_1_array_crystal_array_0_global_geometry_element
#define this_box_storage mccchannel_2_analyzer_1_array_crystal_array_0_this_box_storage
#define material_string mccchannel_2_analyzer_1_array_crystal_array_0_material_string
#define priority mccchannel_2_analyzer_1_array_crystal_array_0_priority
#define xwidth mccchannel_2_analyzer_1_array_crystal_array_0_xwidth
#define yheight mccchannel_2_analyzer_1_array_crystal_array_0_yheight
#define zdepth mccchannel_2_analyzer_1_array_crystal_array_0_zdepth
#define xwidth2 mccchannel_2_analyzer_1_array_crystal_array_0_xwidth2
#define yheight2 mccchannel_2_analyzer_1_array_crystal_array_0_yheight2
#define visualize mccchannel_2_analyzer_1_array_crystal_array_0_visualize
#define target_index mccchannel_2_analyzer_1_array_crystal_array_0_target_index
#define target_x mccchannel_2_analyzer_1_array_crystal_array_0_target_x
#define target_y mccchannel_2_analyzer_1_array_crystal_array_0_target_y
#define target_z mccchannel_2_analyzer_1_array_crystal_array_0_target_z
#define focus_aw mccchannel_2_analyzer_1_array_crystal_array_0_focus_aw
#define focus_ah mccchannel_2_analyzer_1_array_crystal_array_0_focus_ah
#define focus_xw mccchannel_2_analyzer_1_array_crystal_array_0_focus_xw
#define focus_xh mccchannel_2_analyzer_1_array_crystal_array_0_focus_xh
#define focus_r mccchannel_2_analyzer_1_array_crystal_array_0_focus_r
#define p_interact mccchannel_2_analyzer_1_array_crystal_array_0_p_interact
#define mask_string mccchannel_2_analyzer_1_array_crystal_array_0_mask_string
#define mask_setting mccchannel_2_analyzer_1_array_crystal_array_0_mask_setting
#define number_of_activations mccchannel_2_analyzer_1_array_crystal_array_0_number_of_activations
#line 224 "Union_box.comp"
{
// Initializes the focusing system for this volume including input sanitation.
focus_initialize(&this_box_volume.geometry, POS_A_COMP_INDEX(INDEX_CURRENT_COMP+target_index), POS_A_CURRENT_COMP, ROT_A_CURRENT_COMP, target_index, target_x, target_y, target_z, focus_aw, focus_ah, focus_xw, focus_xh, focus_r, NAME_CURRENT_COMP);

// Input sanitation for this geometry
if (xwidth <= 0) {
  printf("\nERROR in Union_box named %s, the xwidth is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (yheight <= 0) {
  printf("\nERROR in Union_box named %s, yheight is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (zdepth <= 0) {
  printf("\nERROR in Union_box named %s, zdepth is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (xwidth2 <= 0 && xwidth2 != -1) {
  printf("\nERROR in Union_box named %s, the xwidth2 is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (yheight2 <= 0 && yheight2 != -1) {
  printf("\nERROR in Union_box named %s, yheight2 is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}

// Use sanitation
if (global_material_list.num_elements == 0) {
  printf("\nERROR: Need to define a material using Union_make_material before using a Union geometry component. \n");
  printf("       %s was defined before first use of Union_make_material.\n",NAME_CURRENT_COMP);
  exit(1);
}

this_box_volume.geometry.is_masked_volume = 0;
this_box_volume.geometry.is_exit_volume = 0;
this_box_volume.geometry.is_mask_volume = 0;
// check if the volume is a mask, if it is the material string is irelevant.
if (mask_string && strlen(mask_string) && strcmp(mask_string, "NULL") && strcmp(mask_string, "0")) {
    // A mask volume is used to limit the extend of other volumes, called the masked volumes. These are specified in the mask_string.
    // In order for a ray to enter a masked volume, it needs to be both in the region covered by that volume AND the mask volume.
    // When more than
    this_box_volume.geometry.mask_mode = 1; // Default is mask mode is ALL
    if (mask_setting && strlen(mask_setting) && strcmp(mask_setting, "NULL") && strcmp(mask_setting, "0")) {
        if (strcmp(mask_setting,"ALL") == 0 || strcmp(mask_setting,"All") == 0) this_box_volume.geometry.mask_mode = 1;
        else if (strcmp(mask_setting,"ANY") == 0 || strcmp(mask_setting,"Any") == 0) this_box_volume.geometry.mask_mode = 2;
        else {
            printf("The mask_mode of component %s is set to %s, but must be either ALL or ANY.\n",NAME_CURRENT_COMP,mask_setting);
            exit(1);
        }
    }
    
    for (loop_index=0;loop_index<global_geometry_list.num_elements;loop_index++) {
        // Add mask list
        if (1 == manual_linking_function(global_geometry_list.elements[loop_index].name,mask_string)) {
            add_element_to_int_list(&this_box_volume.geometry.mask_list,global_geometry_list.elements[loop_index].component_index);
            add_element_to_int_list(&global_geometry_list.elements[loop_index].Volume->geometry.masked_by_list,INDEX_CURRENT_COMP);
            global_geometry_list.elements[loop_index].Volume->geometry.is_masked_volume = 1;
            if (this_box_volume.geometry.mask_mode == 2)
                global_geometry_list.elements[loop_index].Volume->geometry.mask_mode = 2;
            if (this_box_volume.geometry.mask_mode == 1) {
                if (global_geometry_list.elements[loop_index].Volume->geometry.is_masked_volume == 1 && global_geometry_list.elements[loop_index].Volume->geometry.mask_mode != 2)
                    // If more than one mask is added to one volume, the ANY mode overwrites the (default) ALL mode.
                    global_geometry_list.elements[loop_index].Volume->geometry.mask_mode = 1;
            }
            
            found_geometries = 1;
        }
    }
    if (found_geometries == 0) {
        printf("The mask_string in geometry: %s did not find any of the specified volumes in the mask_string %s \n",NAME_CURRENT_COMP,mask_string);
        exit(1);
    }
    this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
    this_box_volume.p_physics->is_vacuum = 0; // Makes this volume a vacuum
    this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
    this_box_volume.p_physics->my_a = 0; // Should not be used.
    sprintf(this_box_volume.p_physics->name,"Mask");
    this_box_volume.geometry.is_mask_volume = 1;
    
    
// Read the material input, or if it lacks, use automatic linking.
} else if (material_string && strlen(material_string) && strcmp(material_string, "NULL") && strcmp(material_string, "0")) {
    // A geometry string was given, use it to determine which material
    if (0 == strcmp(material_string,"vacuum") || 0 == strcmp(material_string,"Vacuum")) {
        // One could have a global physics struct for vacuum instead of creating one for each
        this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
        this_box_volume.p_physics->is_vacuum = 1; // Makes this volume a vacuum
        this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
        this_box_volume.p_physics->my_a = 0; // Should not be used.
        sprintf(this_box_volume.p_physics->name,"Vacuum");
    } else if (0 == strcmp(material_string,"exit") || 0 == strcmp(material_string,"Exit")) {
        // One could have a global physics struct for vacuum instead of creating one for each
        this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
        this_box_volume.p_physics->is_vacuum = 1; // Makes this volume a vacuum
        this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
        this_box_volume.p_physics->my_a = 0; // Should not be used.
        this_box_volume.geometry.is_exit_volume = 1;
        sprintf(this_box_volume.p_physics->name,"Exit");
    } else {
        #ifndef MATERIAL_DETECTOR
            printf("Need to define a material before refering to it in a geometry %s.\n",NAME_CURRENT_COMP);
            exit(1);
        #endif
        for (loop_index=0;loop_index<global_material_list.num_elements;loop_index++) {
            if (0 == strcmp(material_string,global_material_list.elements[loop_index].name)) {
                this_box_volume.p_physics = global_material_list.elements[loop_index].physics;
                break;
            }
            if (loop_index == global_material_list.num_elements-1) {
            printf("\n");
            printf("ERROR: The material string \"%s\" in Union geometry \"%s\" did not match a specified material. \n",material_string,NAME_CURRENT_COMP);
            printf("       The materials available at this point (need to be defined before the geometry): \n");
            for (loop_index=0;loop_index<global_material_list.num_elements;loop_index++)
              printf("         %s\n",global_material_list.elements[loop_index].name);
            printf("\n");
            printf("       It is also possible to use one of the defualt materials avaiable: \n");
            printf("           Vacuum (for a Volume without scattering or absorption)\n");
            printf("           Exit (for a Volume where the ray exits the component if it enters)\n");
            printf("           Mask (for a Volume that masks existing volumes specified in the mask_string\n");
            exit(1);
          }
        }
    }
} else {
    // Automatic linking, simply using the last defined material.
    #ifndef MATERIAL_DETECTOR
        printf("Need to define a material before the geometry to use automatic linking %s.\n",NAME_CURRENT_COMP);
        exit(1);
    #endif
    this_box_volume.p_physics = global_material_list.elements[global_material_list.num_elements-1].physics;
}

sprintf(this_box_volume.name,NAME_CURRENT_COMP);
sprintf(this_box_volume.geometry.shape,"box");
this_box_volume.geometry.priority_value = priority;
this_box_volume.geometry.geometry_p_interact = p_interact;
// Currently the coordinates will be in absolute space.
this_box_volume.geometry.center = POS_A_CURRENT_COMP;

this_box_storage.z_depth = zdepth;
this_box_storage.x_width1 = xwidth;
this_box_storage.y_height1 = yheight;

this_box_storage.is_rectangle = 0;
if (xwidth2 < 0 && yheight2 < 0) this_box_storage.is_rectangle = 1;
if (xwidth == xwidth2 && yheight == yheight2) this_box_storage.is_rectangle = 1;

if (xwidth2 < 0) {
    this_box_storage.x_width2 = xwidth;
    xwidth2 = xwidth;
} else this_box_storage.x_width2 = xwidth2;

if (yheight2 < 0) {
    this_box_storage.y_height2 = yheight;
    yheight2 = yheight;
} else this_box_storage.y_height2 = yheight2;


this_box_storage.normal_vectors[0] = coords_set(0,0,1);
this_box_storage.normal_vectors[1] = coords_set(0,0,1);

// for sides with y component = 0
x_component = 2*zdepth/sqrt((xwidth-xwidth2)*(xwidth-xwidth2)+4*zdepth*zdepth);
z_component = (xwidth-xwidth2)/sqrt(4*zdepth*zdepth+(xwidth-xwidth2)*(xwidth-xwidth2));

this_box_storage.normal_vectors[2] = coords_set(x_component,0,z_component);
this_box_storage.normal_vectors[3] = coords_set(-x_component,0,z_component);

// for sides with x component = 0
y_component = 2*zdepth/sqrt((yheight-yheight2)*(yheight-yheight2)+4*zdepth*zdepth);
z_component = (yheight-yheight2)/sqrt(4*zdepth*zdepth+(yheight-yheight2)*(yheight-yheight2));

this_box_storage.normal_vectors[4] = coords_set(0,y_component,z_component);
this_box_storage.normal_vectors[5] = coords_set(0,-y_component,z_component);

this_box_volume.geometry.visualization_on = visualize;

this_box_volume.geometry.geometry_parameters.p_box_storage = &this_box_storage;

// Assign pointers to functions for intersection with the shape, checking if a point is inside the shape
if (this_box_storage.is_rectangle == 1) {
this_box_volume.geometry.intersect_function = &sample_box_intersect_simple;
this_box_volume.geometry.within_function = &r_within_box_simple;
}
else {
this_box_volume.geometry.intersect_function = &sample_box_intersect_advanced;
this_box_volume.geometry.within_function = &r_within_box_advanced;
}

this_box_volume.geometry.shell_points = &box_shell_points;
this_box_volume.geometry.mcdisplay_function = &mcdisplay_box_function;
this_box_volume.geometry.initialize_from_main_function = &initialize_box_geometry_from_main_component;
this_box_volume.geometry.process_rot_allocated = 0;

this_box_volume.geometry.copy_geometry_parameters = &allocate_box_storage_copy;

rot_copy(this_box_volume.geometry.rotation_matrix,ROT_A_CURRENT_COMP); //check how ROT_R_CURRENT_COMP would work
rot_transpose(ROT_A_CURRENT_COMP,this_box_volume.geometry.transpose_rotation_matrix);

// Initialize loggers
this_box_volume.loggers.num_elements = 0;

// packing the information into the global_geometry_element, which is then included in the global_geometry_list.
sprintf(global_geometry_element.name,NAME_CURRENT_COMP);
global_geometry_element.activation_counter = number_of_activations;
global_geometry_element.component_index = INDEX_CURRENT_COMP;
global_geometry_element.Volume = &this_box_volume; // Would be nicer if this m was a pointer, now we have the (small) data two places
add_element_to_geometry_list(&global_geometry_list,global_geometry_element);
}
#line 183395 "MACS_sample_kidney_box.c"
#undef number_of_activations
#undef mask_setting
#undef mask_string
#undef p_interact
#undef focus_r
#undef focus_xh
#undef focus_xw
#undef focus_ah
#undef focus_aw
#undef target_z
#undef target_y
#undef target_x
#undef target_index
#undef visualize
#undef yheight2
#undef xwidth2
#undef zdepth
#undef yheight
#undef xwidth
#undef priority
#undef material_string
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

  /* Initializations for component channel_2_analyzer_1_array_crystal_array_1. */
  SIG_MESSAGE("channel_2_analyzer_1_array_crystal_array_1 (Init)");
#define mccompcurname  channel_2_analyzer_1_array_crystal_array_1
#define mccompcurtype  Union_box
#define mccompcurindex 207
#define loop_index mccchannel_2_analyzer_1_array_crystal_array_1_loop_index
#define this_box_volume mccchannel_2_analyzer_1_array_crystal_array_1_this_box_volume
#define global_geometry_element mccchannel_2_analyzer_1_array_crystal_array_1_global_geometry_element
#define this_box_storage mccchannel_2_analyzer_1_array_crystal_array_1_this_box_storage
#define material_string mccchannel_2_analyzer_1_array_crystal_array_1_material_string
#define priority mccchannel_2_analyzer_1_array_crystal_array_1_priority
#define xwidth mccchannel_2_analyzer_1_array_crystal_array_1_xwidth
#define yheight mccchannel_2_analyzer_1_array_crystal_array_1_yheight
#define zdepth mccchannel_2_analyzer_1_array_crystal_array_1_zdepth
#define xwidth2 mccchannel_2_analyzer_1_array_crystal_array_1_xwidth2
#define yheight2 mccchannel_2_analyzer_1_array_crystal_array_1_yheight2
#define visualize mccchannel_2_analyzer_1_array_crystal_array_1_visualize
#define target_index mccchannel_2_analyzer_1_array_crystal_array_1_target_index
#define target_x mccchannel_2_analyzer_1_array_crystal_array_1_target_x
#define target_y mccchannel_2_analyzer_1_array_crystal_array_1_target_y
#define target_z mccchannel_2_analyzer_1_array_crystal_array_1_target_z
#define focus_aw mccchannel_2_analyzer_1_array_crystal_array_1_focus_aw
#define focus_ah mccchannel_2_analyzer_1_array_crystal_array_1_focus_ah
#define focus_xw mccchannel_2_analyzer_1_array_crystal_array_1_focus_xw
#define focus_xh mccchannel_2_analyzer_1_array_crystal_array_1_focus_xh
#define focus_r mccchannel_2_analyzer_1_array_crystal_array_1_focus_r
#define p_interact mccchannel_2_analyzer_1_array_crystal_array_1_p_interact
#define mask_string mccchannel_2_analyzer_1_array_crystal_array_1_mask_string
#define mask_setting mccchannel_2_analyzer_1_array_crystal_array_1_mask_setting
#define number_of_activations mccchannel_2_analyzer_1_array_crystal_array_1_number_of_activations
#line 224 "Union_box.comp"
{
// Initializes the focusing system for this volume including input sanitation.
focus_initialize(&this_box_volume.geometry, POS_A_COMP_INDEX(INDEX_CURRENT_COMP+target_index), POS_A_CURRENT_COMP, ROT_A_CURRENT_COMP, target_index, target_x, target_y, target_z, focus_aw, focus_ah, focus_xw, focus_xh, focus_r, NAME_CURRENT_COMP);

// Input sanitation for this geometry
if (xwidth <= 0) {
  printf("\nERROR in Union_box named %s, the xwidth is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (yheight <= 0) {
  printf("\nERROR in Union_box named %s, yheight is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (zdepth <= 0) {
  printf("\nERROR in Union_box named %s, zdepth is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (xwidth2 <= 0 && xwidth2 != -1) {
  printf("\nERROR in Union_box named %s, the xwidth2 is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (yheight2 <= 0 && yheight2 != -1) {
  printf("\nERROR in Union_box named %s, yheight2 is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}

// Use sanitation
if (global_material_list.num_elements == 0) {
  printf("\nERROR: Need to define a material using Union_make_material before using a Union geometry component. \n");
  printf("       %s was defined before first use of Union_make_material.\n",NAME_CURRENT_COMP);
  exit(1);
}

this_box_volume.geometry.is_masked_volume = 0;
this_box_volume.geometry.is_exit_volume = 0;
this_box_volume.geometry.is_mask_volume = 0;
// check if the volume is a mask, if it is the material string is irelevant.
if (mask_string && strlen(mask_string) && strcmp(mask_string, "NULL") && strcmp(mask_string, "0")) {
    // A mask volume is used to limit the extend of other volumes, called the masked volumes. These are specified in the mask_string.
    // In order for a ray to enter a masked volume, it needs to be both in the region covered by that volume AND the mask volume.
    // When more than
    this_box_volume.geometry.mask_mode = 1; // Default is mask mode is ALL
    if (mask_setting && strlen(mask_setting) && strcmp(mask_setting, "NULL") && strcmp(mask_setting, "0")) {
        if (strcmp(mask_setting,"ALL") == 0 || strcmp(mask_setting,"All") == 0) this_box_volume.geometry.mask_mode = 1;
        else if (strcmp(mask_setting,"ANY") == 0 || strcmp(mask_setting,"Any") == 0) this_box_volume.geometry.mask_mode = 2;
        else {
            printf("The mask_mode of component %s is set to %s, but must be either ALL or ANY.\n",NAME_CURRENT_COMP,mask_setting);
            exit(1);
        }
    }
    
    for (loop_index=0;loop_index<global_geometry_list.num_elements;loop_index++) {
        // Add mask list
        if (1 == manual_linking_function(global_geometry_list.elements[loop_index].name,mask_string)) {
            add_element_to_int_list(&this_box_volume.geometry.mask_list,global_geometry_list.elements[loop_index].component_index);
            add_element_to_int_list(&global_geometry_list.elements[loop_index].Volume->geometry.masked_by_list,INDEX_CURRENT_COMP);
            global_geometry_list.elements[loop_index].Volume->geometry.is_masked_volume = 1;
            if (this_box_volume.geometry.mask_mode == 2)
                global_geometry_list.elements[loop_index].Volume->geometry.mask_mode = 2;
            if (this_box_volume.geometry.mask_mode == 1) {
                if (global_geometry_list.elements[loop_index].Volume->geometry.is_masked_volume == 1 && global_geometry_list.elements[loop_index].Volume->geometry.mask_mode != 2)
                    // If more than one mask is added to one volume, the ANY mode overwrites the (default) ALL mode.
                    global_geometry_list.elements[loop_index].Volume->geometry.mask_mode = 1;
            }
            
            found_geometries = 1;
        }
    }
    if (found_geometries == 0) {
        printf("The mask_string in geometry: %s did not find any of the specified volumes in the mask_string %s \n",NAME_CURRENT_COMP,mask_string);
        exit(1);
    }
    this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
    this_box_volume.p_physics->is_vacuum = 0; // Makes this volume a vacuum
    this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
    this_box_volume.p_physics->my_a = 0; // Should not be used.
    sprintf(this_box_volume.p_physics->name,"Mask");
    this_box_volume.geometry.is_mask_volume = 1;
    
    
// Read the material input, or if it lacks, use automatic linking.
} else if (material_string && strlen(material_string) && strcmp(material_string, "NULL") && strcmp(material_string, "0")) {
    // A geometry string was given, use it to determine which material
    if (0 == strcmp(material_string,"vacuum") || 0 == strcmp(material_string,"Vacuum")) {
        // One could have a global physics struct for vacuum instead of creating one for each
        this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
        this_box_volume.p_physics->is_vacuum = 1; // Makes this volume a vacuum
        this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
        this_box_volume.p_physics->my_a = 0; // Should not be used.
        sprintf(this_box_volume.p_physics->name,"Vacuum");
    } else if (0 == strcmp(material_string,"exit") || 0 == strcmp(material_string,"Exit")) {
        // One could have a global physics struct for vacuum instead of creating one for each
        this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
        this_box_volume.p_physics->is_vacuum = 1; // Makes this volume a vacuum
        this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
        this_box_volume.p_physics->my_a = 0; // Should not be used.
        this_box_volume.geometry.is_exit_volume = 1;
        sprintf(this_box_volume.p_physics->name,"Exit");
    } else {
        #ifndef MATERIAL_DETECTOR
            printf("Need to define a material before refering to it in a geometry %s.\n",NAME_CURRENT_COMP);
            exit(1);
        #endif
        for (loop_index=0;loop_index<global_material_list.num_elements;loop_index++) {
            if (0 == strcmp(material_string,global_material_list.elements[loop_index].name)) {
                this_box_volume.p_physics = global_material_list.elements[loop_index].physics;
                break;
            }
            if (loop_index == global_material_list.num_elements-1) {
            printf("\n");
            printf("ERROR: The material string \"%s\" in Union geometry \"%s\" did not match a specified material. \n",material_string,NAME_CURRENT_COMP);
            printf("       The materials available at this point (need to be defined before the geometry): \n");
            for (loop_index=0;loop_index<global_material_list.num_elements;loop_index++)
              printf("         %s\n",global_material_list.elements[loop_index].name);
            printf("\n");
            printf("       It is also possible to use one of the defualt materials avaiable: \n");
            printf("           Vacuum (for a Volume without scattering or absorption)\n");
            printf("           Exit (for a Volume where the ray exits the component if it enters)\n");
            printf("           Mask (for a Volume that masks existing volumes specified in the mask_string\n");
            exit(1);
          }
        }
    }
} else {
    // Automatic linking, simply using the last defined material.
    #ifndef MATERIAL_DETECTOR
        printf("Need to define a material before the geometry to use automatic linking %s.\n",NAME_CURRENT_COMP);
        exit(1);
    #endif
    this_box_volume.p_physics = global_material_list.elements[global_material_list.num_elements-1].physics;
}

sprintf(this_box_volume.name,NAME_CURRENT_COMP);
sprintf(this_box_volume.geometry.shape,"box");
this_box_volume.geometry.priority_value = priority;
this_box_volume.geometry.geometry_p_interact = p_interact;
// Currently the coordinates will be in absolute space.
this_box_volume.geometry.center = POS_A_CURRENT_COMP;

this_box_storage.z_depth = zdepth;
this_box_storage.x_width1 = xwidth;
this_box_storage.y_height1 = yheight;

this_box_storage.is_rectangle = 0;
if (xwidth2 < 0 && yheight2 < 0) this_box_storage.is_rectangle = 1;
if (xwidth == xwidth2 && yheight == yheight2) this_box_storage.is_rectangle = 1;

if (xwidth2 < 0) {
    this_box_storage.x_width2 = xwidth;
    xwidth2 = xwidth;
} else this_box_storage.x_width2 = xwidth2;

if (yheight2 < 0) {
    this_box_storage.y_height2 = yheight;
    yheight2 = yheight;
} else this_box_storage.y_height2 = yheight2;


this_box_storage.normal_vectors[0] = coords_set(0,0,1);
this_box_storage.normal_vectors[1] = coords_set(0,0,1);

// for sides with y component = 0
x_component = 2*zdepth/sqrt((xwidth-xwidth2)*(xwidth-xwidth2)+4*zdepth*zdepth);
z_component = (xwidth-xwidth2)/sqrt(4*zdepth*zdepth+(xwidth-xwidth2)*(xwidth-xwidth2));

this_box_storage.normal_vectors[2] = coords_set(x_component,0,z_component);
this_box_storage.normal_vectors[3] = coords_set(-x_component,0,z_component);

// for sides with x component = 0
y_component = 2*zdepth/sqrt((yheight-yheight2)*(yheight-yheight2)+4*zdepth*zdepth);
z_component = (yheight-yheight2)/sqrt(4*zdepth*zdepth+(yheight-yheight2)*(yheight-yheight2));

this_box_storage.normal_vectors[4] = coords_set(0,y_component,z_component);
this_box_storage.normal_vectors[5] = coords_set(0,-y_component,z_component);

this_box_volume.geometry.visualization_on = visualize;

this_box_volume.geometry.geometry_parameters.p_box_storage = &this_box_storage;

// Assign pointers to functions for intersection with the shape, checking if a point is inside the shape
if (this_box_storage.is_rectangle == 1) {
this_box_volume.geometry.intersect_function = &sample_box_intersect_simple;
this_box_volume.geometry.within_function = &r_within_box_simple;
}
else {
this_box_volume.geometry.intersect_function = &sample_box_intersect_advanced;
this_box_volume.geometry.within_function = &r_within_box_advanced;
}

this_box_volume.geometry.shell_points = &box_shell_points;
this_box_volume.geometry.mcdisplay_function = &mcdisplay_box_function;
this_box_volume.geometry.initialize_from_main_function = &initialize_box_geometry_from_main_component;
this_box_volume.geometry.process_rot_allocated = 0;

this_box_volume.geometry.copy_geometry_parameters = &allocate_box_storage_copy;

rot_copy(this_box_volume.geometry.rotation_matrix,ROT_A_CURRENT_COMP); //check how ROT_R_CURRENT_COMP would work
rot_transpose(ROT_A_CURRENT_COMP,this_box_volume.geometry.transpose_rotation_matrix);

// Initialize loggers
this_box_volume.loggers.num_elements = 0;

// packing the information into the global_geometry_element, which is then included in the global_geometry_list.
sprintf(global_geometry_element.name,NAME_CURRENT_COMP);
global_geometry_element.activation_counter = number_of_activations;
global_geometry_element.component_index = INDEX_CURRENT_COMP;
global_geometry_element.Volume = &this_box_volume; // Would be nicer if this m was a pointer, now we have the (small) data two places
add_element_to_geometry_list(&global_geometry_list,global_geometry_element);
}
#line 183665 "MACS_sample_kidney_box.c"
#undef number_of_activations
#undef mask_setting
#undef mask_string
#undef p_interact
#undef focus_r
#undef focus_xh
#undef focus_xw
#undef focus_ah
#undef focus_aw
#undef target_z
#undef target_y
#undef target_x
#undef target_index
#undef visualize
#undef yheight2
#undef xwidth2
#undef zdepth
#undef yheight
#undef xwidth
#undef priority
#undef material_string
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

  /* Initializations for component channel_2_analyzer_1_array_crystal_array_2. */
  SIG_MESSAGE("channel_2_analyzer_1_array_crystal_array_2 (Init)");
#define mccompcurname  channel_2_analyzer_1_array_crystal_array_2
#define mccompcurtype  Union_box
#define mccompcurindex 208
#define loop_index mccchannel_2_analyzer_1_array_crystal_array_2_loop_index
#define this_box_volume mccchannel_2_analyzer_1_array_crystal_array_2_this_box_volume
#define global_geometry_element mccchannel_2_analyzer_1_array_crystal_array_2_global_geometry_element
#define this_box_storage mccchannel_2_analyzer_1_array_crystal_array_2_this_box_storage
#define material_string mccchannel_2_analyzer_1_array_crystal_array_2_material_string
#define priority mccchannel_2_analyzer_1_array_crystal_array_2_priority
#define xwidth mccchannel_2_analyzer_1_array_crystal_array_2_xwidth
#define yheight mccchannel_2_analyzer_1_array_crystal_array_2_yheight
#define zdepth mccchannel_2_analyzer_1_array_crystal_array_2_zdepth
#define xwidth2 mccchannel_2_analyzer_1_array_crystal_array_2_xwidth2
#define yheight2 mccchannel_2_analyzer_1_array_crystal_array_2_yheight2
#define visualize mccchannel_2_analyzer_1_array_crystal_array_2_visualize
#define target_index mccchannel_2_analyzer_1_array_crystal_array_2_target_index
#define target_x mccchannel_2_analyzer_1_array_crystal_array_2_target_x
#define target_y mccchannel_2_analyzer_1_array_crystal_array_2_target_y
#define target_z mccchannel_2_analyzer_1_array_crystal_array_2_target_z
#define focus_aw mccchannel_2_analyzer_1_array_crystal_array_2_focus_aw
#define focus_ah mccchannel_2_analyzer_1_array_crystal_array_2_focus_ah
#define focus_xw mccchannel_2_analyzer_1_array_crystal_array_2_focus_xw
#define focus_xh mccchannel_2_analyzer_1_array_crystal_array_2_focus_xh
#define focus_r mccchannel_2_analyzer_1_array_crystal_array_2_focus_r
#define p_interact mccchannel_2_analyzer_1_array_crystal_array_2_p_interact
#define mask_string mccchannel_2_analyzer_1_array_crystal_array_2_mask_string
#define mask_setting mccchannel_2_analyzer_1_array_crystal_array_2_mask_setting
#define number_of_activations mccchannel_2_analyzer_1_array_crystal_array_2_number_of_activations
#line 224 "Union_box.comp"
{
// Initializes the focusing system for this volume including input sanitation.
focus_initialize(&this_box_volume.geometry, POS_A_COMP_INDEX(INDEX_CURRENT_COMP+target_index), POS_A_CURRENT_COMP, ROT_A_CURRENT_COMP, target_index, target_x, target_y, target_z, focus_aw, focus_ah, focus_xw, focus_xh, focus_r, NAME_CURRENT_COMP);

// Input sanitation for this geometry
if (xwidth <= 0) {
  printf("\nERROR in Union_box named %s, the xwidth is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (yheight <= 0) {
  printf("\nERROR in Union_box named %s, yheight is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (zdepth <= 0) {
  printf("\nERROR in Union_box named %s, zdepth is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (xwidth2 <= 0 && xwidth2 != -1) {
  printf("\nERROR in Union_box named %s, the xwidth2 is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (yheight2 <= 0 && yheight2 != -1) {
  printf("\nERROR in Union_box named %s, yheight2 is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}

// Use sanitation
if (global_material_list.num_elements == 0) {
  printf("\nERROR: Need to define a material using Union_make_material before using a Union geometry component. \n");
  printf("       %s was defined before first use of Union_make_material.\n",NAME_CURRENT_COMP);
  exit(1);
}

this_box_volume.geometry.is_masked_volume = 0;
this_box_volume.geometry.is_exit_volume = 0;
this_box_volume.geometry.is_mask_volume = 0;
// check if the volume is a mask, if it is the material string is irelevant.
if (mask_string && strlen(mask_string) && strcmp(mask_string, "NULL") && strcmp(mask_string, "0")) {
    // A mask volume is used to limit the extend of other volumes, called the masked volumes. These are specified in the mask_string.
    // In order for a ray to enter a masked volume, it needs to be both in the region covered by that volume AND the mask volume.
    // When more than
    this_box_volume.geometry.mask_mode = 1; // Default is mask mode is ALL
    if (mask_setting && strlen(mask_setting) && strcmp(mask_setting, "NULL") && strcmp(mask_setting, "0")) {
        if (strcmp(mask_setting,"ALL") == 0 || strcmp(mask_setting,"All") == 0) this_box_volume.geometry.mask_mode = 1;
        else if (strcmp(mask_setting,"ANY") == 0 || strcmp(mask_setting,"Any") == 0) this_box_volume.geometry.mask_mode = 2;
        else {
            printf("The mask_mode of component %s is set to %s, but must be either ALL or ANY.\n",NAME_CURRENT_COMP,mask_setting);
            exit(1);
        }
    }
    
    for (loop_index=0;loop_index<global_geometry_list.num_elements;loop_index++) {
        // Add mask list
        if (1 == manual_linking_function(global_geometry_list.elements[loop_index].name,mask_string)) {
            add_element_to_int_list(&this_box_volume.geometry.mask_list,global_geometry_list.elements[loop_index].component_index);
            add_element_to_int_list(&global_geometry_list.elements[loop_index].Volume->geometry.masked_by_list,INDEX_CURRENT_COMP);
            global_geometry_list.elements[loop_index].Volume->geometry.is_masked_volume = 1;
            if (this_box_volume.geometry.mask_mode == 2)
                global_geometry_list.elements[loop_index].Volume->geometry.mask_mode = 2;
            if (this_box_volume.geometry.mask_mode == 1) {
                if (global_geometry_list.elements[loop_index].Volume->geometry.is_masked_volume == 1 && global_geometry_list.elements[loop_index].Volume->geometry.mask_mode != 2)
                    // If more than one mask is added to one volume, the ANY mode overwrites the (default) ALL mode.
                    global_geometry_list.elements[loop_index].Volume->geometry.mask_mode = 1;
            }
            
            found_geometries = 1;
        }
    }
    if (found_geometries == 0) {
        printf("The mask_string in geometry: %s did not find any of the specified volumes in the mask_string %s \n",NAME_CURRENT_COMP,mask_string);
        exit(1);
    }
    this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
    this_box_volume.p_physics->is_vacuum = 0; // Makes this volume a vacuum
    this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
    this_box_volume.p_physics->my_a = 0; // Should not be used.
    sprintf(this_box_volume.p_physics->name,"Mask");
    this_box_volume.geometry.is_mask_volume = 1;
    
    
// Read the material input, or if it lacks, use automatic linking.
} else if (material_string && strlen(material_string) && strcmp(material_string, "NULL") && strcmp(material_string, "0")) {
    // A geometry string was given, use it to determine which material
    if (0 == strcmp(material_string,"vacuum") || 0 == strcmp(material_string,"Vacuum")) {
        // One could have a global physics struct for vacuum instead of creating one for each
        this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
        this_box_volume.p_physics->is_vacuum = 1; // Makes this volume a vacuum
        this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
        this_box_volume.p_physics->my_a = 0; // Should not be used.
        sprintf(this_box_volume.p_physics->name,"Vacuum");
    } else if (0 == strcmp(material_string,"exit") || 0 == strcmp(material_string,"Exit")) {
        // One could have a global physics struct for vacuum instead of creating one for each
        this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
        this_box_volume.p_physics->is_vacuum = 1; // Makes this volume a vacuum
        this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
        this_box_volume.p_physics->my_a = 0; // Should not be used.
        this_box_volume.geometry.is_exit_volume = 1;
        sprintf(this_box_volume.p_physics->name,"Exit");
    } else {
        #ifndef MATERIAL_DETECTOR
            printf("Need to define a material before refering to it in a geometry %s.\n",NAME_CURRENT_COMP);
            exit(1);
        #endif
        for (loop_index=0;loop_index<global_material_list.num_elements;loop_index++) {
            if (0 == strcmp(material_string,global_material_list.elements[loop_index].name)) {
                this_box_volume.p_physics = global_material_list.elements[loop_index].physics;
                break;
            }
            if (loop_index == global_material_list.num_elements-1) {
            printf("\n");
            printf("ERROR: The material string \"%s\" in Union geometry \"%s\" did not match a specified material. \n",material_string,NAME_CURRENT_COMP);
            printf("       The materials available at this point (need to be defined before the geometry): \n");
            for (loop_index=0;loop_index<global_material_list.num_elements;loop_index++)
              printf("         %s\n",global_material_list.elements[loop_index].name);
            printf("\n");
            printf("       It is also possible to use one of the defualt materials avaiable: \n");
            printf("           Vacuum (for a Volume without scattering or absorption)\n");
            printf("           Exit (for a Volume where the ray exits the component if it enters)\n");
            printf("           Mask (for a Volume that masks existing volumes specified in the mask_string\n");
            exit(1);
          }
        }
    }
} else {
    // Automatic linking, simply using the last defined material.
    #ifndef MATERIAL_DETECTOR
        printf("Need to define a material before the geometry to use automatic linking %s.\n",NAME_CURRENT_COMP);
        exit(1);
    #endif
    this_box_volume.p_physics = global_material_list.elements[global_material_list.num_elements-1].physics;
}

sprintf(this_box_volume.name,NAME_CURRENT_COMP);
sprintf(this_box_volume.geometry.shape,"box");
this_box_volume.geometry.priority_value = priority;
this_box_volume.geometry.geometry_p_interact = p_interact;
// Currently the coordinates will be in absolute space.
this_box_volume.geometry.center = POS_A_CURRENT_COMP;

this_box_storage.z_depth = zdepth;
this_box_storage.x_width1 = xwidth;
this_box_storage.y_height1 = yheight;

this_box_storage.is_rectangle = 0;
if (xwidth2 < 0 && yheight2 < 0) this_box_storage.is_rectangle = 1;
if (xwidth == xwidth2 && yheight == yheight2) this_box_storage.is_rectangle = 1;

if (xwidth2 < 0) {
    this_box_storage.x_width2 = xwidth;
    xwidth2 = xwidth;
} else this_box_storage.x_width2 = xwidth2;

if (yheight2 < 0) {
    this_box_storage.y_height2 = yheight;
    yheight2 = yheight;
} else this_box_storage.y_height2 = yheight2;


this_box_storage.normal_vectors[0] = coords_set(0,0,1);
this_box_storage.normal_vectors[1] = coords_set(0,0,1);

// for sides with y component = 0
x_component = 2*zdepth/sqrt((xwidth-xwidth2)*(xwidth-xwidth2)+4*zdepth*zdepth);
z_component = (xwidth-xwidth2)/sqrt(4*zdepth*zdepth+(xwidth-xwidth2)*(xwidth-xwidth2));

this_box_storage.normal_vectors[2] = coords_set(x_component,0,z_component);
this_box_storage.normal_vectors[3] = coords_set(-x_component,0,z_component);

// for sides with x component = 0
y_component = 2*zdepth/sqrt((yheight-yheight2)*(yheight-yheight2)+4*zdepth*zdepth);
z_component = (yheight-yheight2)/sqrt(4*zdepth*zdepth+(yheight-yheight2)*(yheight-yheight2));

this_box_storage.normal_vectors[4] = coords_set(0,y_component,z_component);
this_box_storage.normal_vectors[5] = coords_set(0,-y_component,z_component);

this_box_volume.geometry.visualization_on = visualize;

this_box_volume.geometry.geometry_parameters.p_box_storage = &this_box_storage;

// Assign pointers to functions for intersection with the shape, checking if a point is inside the shape
if (this_box_storage.is_rectangle == 1) {
this_box_volume.geometry.intersect_function = &sample_box_intersect_simple;
this_box_volume.geometry.within_function = &r_within_box_simple;
}
else {
this_box_volume.geometry.intersect_function = &sample_box_intersect_advanced;
this_box_volume.geometry.within_function = &r_within_box_advanced;
}

this_box_volume.geometry.shell_points = &box_shell_points;
this_box_volume.geometry.mcdisplay_function = &mcdisplay_box_function;
this_box_volume.geometry.initialize_from_main_function = &initialize_box_geometry_from_main_component;
this_box_volume.geometry.process_rot_allocated = 0;

this_box_volume.geometry.copy_geometry_parameters = &allocate_box_storage_copy;

rot_copy(this_box_volume.geometry.rotation_matrix,ROT_A_CURRENT_COMP); //check how ROT_R_CURRENT_COMP would work
rot_transpose(ROT_A_CURRENT_COMP,this_box_volume.geometry.transpose_rotation_matrix);

// Initialize loggers
this_box_volume.loggers.num_elements = 0;

// packing the information into the global_geometry_element, which is then included in the global_geometry_list.
sprintf(global_geometry_element.name,NAME_CURRENT_COMP);
global_geometry_element.activation_counter = number_of_activations;
global_geometry_element.component_index = INDEX_CURRENT_COMP;
global_geometry_element.Volume = &this_box_volume; // Would be nicer if this m was a pointer, now we have the (small) data two places
add_element_to_geometry_list(&global_geometry_list,global_geometry_element);
}
#line 183935 "MACS_sample_kidney_box.c"
#undef number_of_activations
#undef mask_setting
#undef mask_string
#undef p_interact
#undef focus_r
#undef focus_xh
#undef focus_xw
#undef focus_ah
#undef focus_aw
#undef target_z
#undef target_y
#undef target_x
#undef target_index
#undef visualize
#undef yheight2
#undef xwidth2
#undef zdepth
#undef yheight
#undef xwidth
#undef priority
#undef material_string
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

  /* Initializations for component channel_2_analyzer_1_array_crystal_array_3. */
  SIG_MESSAGE("channel_2_analyzer_1_array_crystal_array_3 (Init)");
#define mccompcurname  channel_2_analyzer_1_array_crystal_array_3
#define mccompcurtype  Union_box
#define mccompcurindex 209
#define loop_index mccchannel_2_analyzer_1_array_crystal_array_3_loop_index
#define this_box_volume mccchannel_2_analyzer_1_array_crystal_array_3_this_box_volume
#define global_geometry_element mccchannel_2_analyzer_1_array_crystal_array_3_global_geometry_element
#define this_box_storage mccchannel_2_analyzer_1_array_crystal_array_3_this_box_storage
#define material_string mccchannel_2_analyzer_1_array_crystal_array_3_material_string
#define priority mccchannel_2_analyzer_1_array_crystal_array_3_priority
#define xwidth mccchannel_2_analyzer_1_array_crystal_array_3_xwidth
#define yheight mccchannel_2_analyzer_1_array_crystal_array_3_yheight
#define zdepth mccchannel_2_analyzer_1_array_crystal_array_3_zdepth
#define xwidth2 mccchannel_2_analyzer_1_array_crystal_array_3_xwidth2
#define yheight2 mccchannel_2_analyzer_1_array_crystal_array_3_yheight2
#define visualize mccchannel_2_analyzer_1_array_crystal_array_3_visualize
#define target_index mccchannel_2_analyzer_1_array_crystal_array_3_target_index
#define target_x mccchannel_2_analyzer_1_array_crystal_array_3_target_x
#define target_y mccchannel_2_analyzer_1_array_crystal_array_3_target_y
#define target_z mccchannel_2_analyzer_1_array_crystal_array_3_target_z
#define focus_aw mccchannel_2_analyzer_1_array_crystal_array_3_focus_aw
#define focus_ah mccchannel_2_analyzer_1_array_crystal_array_3_focus_ah
#define focus_xw mccchannel_2_analyzer_1_array_crystal_array_3_focus_xw
#define focus_xh mccchannel_2_analyzer_1_array_crystal_array_3_focus_xh
#define focus_r mccchannel_2_analyzer_1_array_crystal_array_3_focus_r
#define p_interact mccchannel_2_analyzer_1_array_crystal_array_3_p_interact
#define mask_string mccchannel_2_analyzer_1_array_crystal_array_3_mask_string
#define mask_setting mccchannel_2_analyzer_1_array_crystal_array_3_mask_setting
#define number_of_activations mccchannel_2_analyzer_1_array_crystal_array_3_number_of_activations
#line 224 "Union_box.comp"
{
// Initializes the focusing system for this volume including input sanitation.
focus_initialize(&this_box_volume.geometry, POS_A_COMP_INDEX(INDEX_CURRENT_COMP+target_index), POS_A_CURRENT_COMP, ROT_A_CURRENT_COMP, target_index, target_x, target_y, target_z, focus_aw, focus_ah, focus_xw, focus_xh, focus_r, NAME_CURRENT_COMP);

// Input sanitation for this geometry
if (xwidth <= 0) {
  printf("\nERROR in Union_box named %s, the xwidth is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (yheight <= 0) {
  printf("\nERROR in Union_box named %s, yheight is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (zdepth <= 0) {
  printf("\nERROR in Union_box named %s, zdepth is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (xwidth2 <= 0 && xwidth2 != -1) {
  printf("\nERROR in Union_box named %s, the xwidth2 is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (yheight2 <= 0 && yheight2 != -1) {
  printf("\nERROR in Union_box named %s, yheight2 is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}

// Use sanitation
if (global_material_list.num_elements == 0) {
  printf("\nERROR: Need to define a material using Union_make_material before using a Union geometry component. \n");
  printf("       %s was defined before first use of Union_make_material.\n",NAME_CURRENT_COMP);
  exit(1);
}

this_box_volume.geometry.is_masked_volume = 0;
this_box_volume.geometry.is_exit_volume = 0;
this_box_volume.geometry.is_mask_volume = 0;
// check if the volume is a mask, if it is the material string is irelevant.
if (mask_string && strlen(mask_string) && strcmp(mask_string, "NULL") && strcmp(mask_string, "0")) {
    // A mask volume is used to limit the extend of other volumes, called the masked volumes. These are specified in the mask_string.
    // In order for a ray to enter a masked volume, it needs to be both in the region covered by that volume AND the mask volume.
    // When more than
    this_box_volume.geometry.mask_mode = 1; // Default is mask mode is ALL
    if (mask_setting && strlen(mask_setting) && strcmp(mask_setting, "NULL") && strcmp(mask_setting, "0")) {
        if (strcmp(mask_setting,"ALL") == 0 || strcmp(mask_setting,"All") == 0) this_box_volume.geometry.mask_mode = 1;
        else if (strcmp(mask_setting,"ANY") == 0 || strcmp(mask_setting,"Any") == 0) this_box_volume.geometry.mask_mode = 2;
        else {
            printf("The mask_mode of component %s is set to %s, but must be either ALL or ANY.\n",NAME_CURRENT_COMP,mask_setting);
            exit(1);
        }
    }
    
    for (loop_index=0;loop_index<global_geometry_list.num_elements;loop_index++) {
        // Add mask list
        if (1 == manual_linking_function(global_geometry_list.elements[loop_index].name,mask_string)) {
            add_element_to_int_list(&this_box_volume.geometry.mask_list,global_geometry_list.elements[loop_index].component_index);
            add_element_to_int_list(&global_geometry_list.elements[loop_index].Volume->geometry.masked_by_list,INDEX_CURRENT_COMP);
            global_geometry_list.elements[loop_index].Volume->geometry.is_masked_volume = 1;
            if (this_box_volume.geometry.mask_mode == 2)
                global_geometry_list.elements[loop_index].Volume->geometry.mask_mode = 2;
            if (this_box_volume.geometry.mask_mode == 1) {
                if (global_geometry_list.elements[loop_index].Volume->geometry.is_masked_volume == 1 && global_geometry_list.elements[loop_index].Volume->geometry.mask_mode != 2)
                    // If more than one mask is added to one volume, the ANY mode overwrites the (default) ALL mode.
                    global_geometry_list.elements[loop_index].Volume->geometry.mask_mode = 1;
            }
            
            found_geometries = 1;
        }
    }
    if (found_geometries == 0) {
        printf("The mask_string in geometry: %s did not find any of the specified volumes in the mask_string %s \n",NAME_CURRENT_COMP,mask_string);
        exit(1);
    }
    this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
    this_box_volume.p_physics->is_vacuum = 0; // Makes this volume a vacuum
    this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
    this_box_volume.p_physics->my_a = 0; // Should not be used.
    sprintf(this_box_volume.p_physics->name,"Mask");
    this_box_volume.geometry.is_mask_volume = 1;
    
    
// Read the material input, or if it lacks, use automatic linking.
} else if (material_string && strlen(material_string) && strcmp(material_string, "NULL") && strcmp(material_string, "0")) {
    // A geometry string was given, use it to determine which material
    if (0 == strcmp(material_string,"vacuum") || 0 == strcmp(material_string,"Vacuum")) {
        // One could have a global physics struct for vacuum instead of creating one for each
        this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
        this_box_volume.p_physics->is_vacuum = 1; // Makes this volume a vacuum
        this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
        this_box_volume.p_physics->my_a = 0; // Should not be used.
        sprintf(this_box_volume.p_physics->name,"Vacuum");
    } else if (0 == strcmp(material_string,"exit") || 0 == strcmp(material_string,"Exit")) {
        // One could have a global physics struct for vacuum instead of creating one for each
        this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
        this_box_volume.p_physics->is_vacuum = 1; // Makes this volume a vacuum
        this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
        this_box_volume.p_physics->my_a = 0; // Should not be used.
        this_box_volume.geometry.is_exit_volume = 1;
        sprintf(this_box_volume.p_physics->name,"Exit");
    } else {
        #ifndef MATERIAL_DETECTOR
            printf("Need to define a material before refering to it in a geometry %s.\n",NAME_CURRENT_COMP);
            exit(1);
        #endif
        for (loop_index=0;loop_index<global_material_list.num_elements;loop_index++) {
            if (0 == strcmp(material_string,global_material_list.elements[loop_index].name)) {
                this_box_volume.p_physics = global_material_list.elements[loop_index].physics;
                break;
            }
            if (loop_index == global_material_list.num_elements-1) {
            printf("\n");
            printf("ERROR: The material string \"%s\" in Union geometry \"%s\" did not match a specified material. \n",material_string,NAME_CURRENT_COMP);
            printf("       The materials available at this point (need to be defined before the geometry): \n");
            for (loop_index=0;loop_index<global_material_list.num_elements;loop_index++)
              printf("         %s\n",global_material_list.elements[loop_index].name);
            printf("\n");
            printf("       It is also possible to use one of the defualt materials avaiable: \n");
            printf("           Vacuum (for a Volume without scattering or absorption)\n");
            printf("           Exit (for a Volume where the ray exits the component if it enters)\n");
            printf("           Mask (for a Volume that masks existing volumes specified in the mask_string\n");
            exit(1);
          }
        }
    }
} else {
    // Automatic linking, simply using the last defined material.
    #ifndef MATERIAL_DETECTOR
        printf("Need to define a material before the geometry to use automatic linking %s.\n",NAME_CURRENT_COMP);
        exit(1);
    #endif
    this_box_volume.p_physics = global_material_list.elements[global_material_list.num_elements-1].physics;
}

sprintf(this_box_volume.name,NAME_CURRENT_COMP);
sprintf(this_box_volume.geometry.shape,"box");
this_box_volume.geometry.priority_value = priority;
this_box_volume.geometry.geometry_p_interact = p_interact;
// Currently the coordinates will be in absolute space.
this_box_volume.geometry.center = POS_A_CURRENT_COMP;

this_box_storage.z_depth = zdepth;
this_box_storage.x_width1 = xwidth;
this_box_storage.y_height1 = yheight;

this_box_storage.is_rectangle = 0;
if (xwidth2 < 0 && yheight2 < 0) this_box_storage.is_rectangle = 1;
if (xwidth == xwidth2 && yheight == yheight2) this_box_storage.is_rectangle = 1;

if (xwidth2 < 0) {
    this_box_storage.x_width2 = xwidth;
    xwidth2 = xwidth;
} else this_box_storage.x_width2 = xwidth2;

if (yheight2 < 0) {
    this_box_storage.y_height2 = yheight;
    yheight2 = yheight;
} else this_box_storage.y_height2 = yheight2;


this_box_storage.normal_vectors[0] = coords_set(0,0,1);
this_box_storage.normal_vectors[1] = coords_set(0,0,1);

// for sides with y component = 0
x_component = 2*zdepth/sqrt((xwidth-xwidth2)*(xwidth-xwidth2)+4*zdepth*zdepth);
z_component = (xwidth-xwidth2)/sqrt(4*zdepth*zdepth+(xwidth-xwidth2)*(xwidth-xwidth2));

this_box_storage.normal_vectors[2] = coords_set(x_component,0,z_component);
this_box_storage.normal_vectors[3] = coords_set(-x_component,0,z_component);

// for sides with x component = 0
y_component = 2*zdepth/sqrt((yheight-yheight2)*(yheight-yheight2)+4*zdepth*zdepth);
z_component = (yheight-yheight2)/sqrt(4*zdepth*zdepth+(yheight-yheight2)*(yheight-yheight2));

this_box_storage.normal_vectors[4] = coords_set(0,y_component,z_component);
this_box_storage.normal_vectors[5] = coords_set(0,-y_component,z_component);

this_box_volume.geometry.visualization_on = visualize;

this_box_volume.geometry.geometry_parameters.p_box_storage = &this_box_storage;

// Assign pointers to functions for intersection with the shape, checking if a point is inside the shape
if (this_box_storage.is_rectangle == 1) {
this_box_volume.geometry.intersect_function = &sample_box_intersect_simple;
this_box_volume.geometry.within_function = &r_within_box_simple;
}
else {
this_box_volume.geometry.intersect_function = &sample_box_intersect_advanced;
this_box_volume.geometry.within_function = &r_within_box_advanced;
}

this_box_volume.geometry.shell_points = &box_shell_points;
this_box_volume.geometry.mcdisplay_function = &mcdisplay_box_function;
this_box_volume.geometry.initialize_from_main_function = &initialize_box_geometry_from_main_component;
this_box_volume.geometry.process_rot_allocated = 0;

this_box_volume.geometry.copy_geometry_parameters = &allocate_box_storage_copy;

rot_copy(this_box_volume.geometry.rotation_matrix,ROT_A_CURRENT_COMP); //check how ROT_R_CURRENT_COMP would work
rot_transpose(ROT_A_CURRENT_COMP,this_box_volume.geometry.transpose_rotation_matrix);

// Initialize loggers
this_box_volume.loggers.num_elements = 0;

// packing the information into the global_geometry_element, which is then included in the global_geometry_list.
sprintf(global_geometry_element.name,NAME_CURRENT_COMP);
global_geometry_element.activation_counter = number_of_activations;
global_geometry_element.component_index = INDEX_CURRENT_COMP;
global_geometry_element.Volume = &this_box_volume; // Would be nicer if this m was a pointer, now we have the (small) data two places
add_element_to_geometry_list(&global_geometry_list,global_geometry_element);
}
#line 184205 "MACS_sample_kidney_box.c"
#undef number_of_activations
#undef mask_setting
#undef mask_string
#undef p_interact
#undef focus_r
#undef focus_xh
#undef focus_xw
#undef focus_ah
#undef focus_aw
#undef target_z
#undef target_y
#undef target_x
#undef target_index
#undef visualize
#undef yheight2
#undef xwidth2
#undef zdepth
#undef yheight
#undef xwidth
#undef priority
#undef material_string
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

  /* Initializations for component channel_2_analyzer_1_array_crystal_array_4. */
  SIG_MESSAGE("channel_2_analyzer_1_array_crystal_array_4 (Init)");
#define mccompcurname  channel_2_analyzer_1_array_crystal_array_4
#define mccompcurtype  Union_box
#define mccompcurindex 210
#define loop_index mccchannel_2_analyzer_1_array_crystal_array_4_loop_index
#define this_box_volume mccchannel_2_analyzer_1_array_crystal_array_4_this_box_volume
#define global_geometry_element mccchannel_2_analyzer_1_array_crystal_array_4_global_geometry_element
#define this_box_storage mccchannel_2_analyzer_1_array_crystal_array_4_this_box_storage
#define material_string mccchannel_2_analyzer_1_array_crystal_array_4_material_string
#define priority mccchannel_2_analyzer_1_array_crystal_array_4_priority
#define xwidth mccchannel_2_analyzer_1_array_crystal_array_4_xwidth
#define yheight mccchannel_2_analyzer_1_array_crystal_array_4_yheight
#define zdepth mccchannel_2_analyzer_1_array_crystal_array_4_zdepth
#define xwidth2 mccchannel_2_analyzer_1_array_crystal_array_4_xwidth2
#define yheight2 mccchannel_2_analyzer_1_array_crystal_array_4_yheight2
#define visualize mccchannel_2_analyzer_1_array_crystal_array_4_visualize
#define target_index mccchannel_2_analyzer_1_array_crystal_array_4_target_index
#define target_x mccchannel_2_analyzer_1_array_crystal_array_4_target_x
#define target_y mccchannel_2_analyzer_1_array_crystal_array_4_target_y
#define target_z mccchannel_2_analyzer_1_array_crystal_array_4_target_z
#define focus_aw mccchannel_2_analyzer_1_array_crystal_array_4_focus_aw
#define focus_ah mccchannel_2_analyzer_1_array_crystal_array_4_focus_ah
#define focus_xw mccchannel_2_analyzer_1_array_crystal_array_4_focus_xw
#define focus_xh mccchannel_2_analyzer_1_array_crystal_array_4_focus_xh
#define focus_r mccchannel_2_analyzer_1_array_crystal_array_4_focus_r
#define p_interact mccchannel_2_analyzer_1_array_crystal_array_4_p_interact
#define mask_string mccchannel_2_analyzer_1_array_crystal_array_4_mask_string
#define mask_setting mccchannel_2_analyzer_1_array_crystal_array_4_mask_setting
#define number_of_activations mccchannel_2_analyzer_1_array_crystal_array_4_number_of_activations
#line 224 "Union_box.comp"
{
// Initializes the focusing system for this volume including input sanitation.
focus_initialize(&this_box_volume.geometry, POS_A_COMP_INDEX(INDEX_CURRENT_COMP+target_index), POS_A_CURRENT_COMP, ROT_A_CURRENT_COMP, target_index, target_x, target_y, target_z, focus_aw, focus_ah, focus_xw, focus_xh, focus_r, NAME_CURRENT_COMP);

// Input sanitation for this geometry
if (xwidth <= 0) {
  printf("\nERROR in Union_box named %s, the xwidth is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (yheight <= 0) {
  printf("\nERROR in Union_box named %s, yheight is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (zdepth <= 0) {
  printf("\nERROR in Union_box named %s, zdepth is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (xwidth2 <= 0 && xwidth2 != -1) {
  printf("\nERROR in Union_box named %s, the xwidth2 is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (yheight2 <= 0 && yheight2 != -1) {
  printf("\nERROR in Union_box named %s, yheight2 is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}

// Use sanitation
if (global_material_list.num_elements == 0) {
  printf("\nERROR: Need to define a material using Union_make_material before using a Union geometry component. \n");
  printf("       %s was defined before first use of Union_make_material.\n",NAME_CURRENT_COMP);
  exit(1);
}

this_box_volume.geometry.is_masked_volume = 0;
this_box_volume.geometry.is_exit_volume = 0;
this_box_volume.geometry.is_mask_volume = 0;
// check if the volume is a mask, if it is the material string is irelevant.
if (mask_string && strlen(mask_string) && strcmp(mask_string, "NULL") && strcmp(mask_string, "0")) {
    // A mask volume is used to limit the extend of other volumes, called the masked volumes. These are specified in the mask_string.
    // In order for a ray to enter a masked volume, it needs to be both in the region covered by that volume AND the mask volume.
    // When more than
    this_box_volume.geometry.mask_mode = 1; // Default is mask mode is ALL
    if (mask_setting && strlen(mask_setting) && strcmp(mask_setting, "NULL") && strcmp(mask_setting, "0")) {
        if (strcmp(mask_setting,"ALL") == 0 || strcmp(mask_setting,"All") == 0) this_box_volume.geometry.mask_mode = 1;
        else if (strcmp(mask_setting,"ANY") == 0 || strcmp(mask_setting,"Any") == 0) this_box_volume.geometry.mask_mode = 2;
        else {
            printf("The mask_mode of component %s is set to %s, but must be either ALL or ANY.\n",NAME_CURRENT_COMP,mask_setting);
            exit(1);
        }
    }
    
    for (loop_index=0;loop_index<global_geometry_list.num_elements;loop_index++) {
        // Add mask list
        if (1 == manual_linking_function(global_geometry_list.elements[loop_index].name,mask_string)) {
            add_element_to_int_list(&this_box_volume.geometry.mask_list,global_geometry_list.elements[loop_index].component_index);
            add_element_to_int_list(&global_geometry_list.elements[loop_index].Volume->geometry.masked_by_list,INDEX_CURRENT_COMP);
            global_geometry_list.elements[loop_index].Volume->geometry.is_masked_volume = 1;
            if (this_box_volume.geometry.mask_mode == 2)
                global_geometry_list.elements[loop_index].Volume->geometry.mask_mode = 2;
            if (this_box_volume.geometry.mask_mode == 1) {
                if (global_geometry_list.elements[loop_index].Volume->geometry.is_masked_volume == 1 && global_geometry_list.elements[loop_index].Volume->geometry.mask_mode != 2)
                    // If more than one mask is added to one volume, the ANY mode overwrites the (default) ALL mode.
                    global_geometry_list.elements[loop_index].Volume->geometry.mask_mode = 1;
            }
            
            found_geometries = 1;
        }
    }
    if (found_geometries == 0) {
        printf("The mask_string in geometry: %s did not find any of the specified volumes in the mask_string %s \n",NAME_CURRENT_COMP,mask_string);
        exit(1);
    }
    this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
    this_box_volume.p_physics->is_vacuum = 0; // Makes this volume a vacuum
    this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
    this_box_volume.p_physics->my_a = 0; // Should not be used.
    sprintf(this_box_volume.p_physics->name,"Mask");
    this_box_volume.geometry.is_mask_volume = 1;
    
    
// Read the material input, or if it lacks, use automatic linking.
} else if (material_string && strlen(material_string) && strcmp(material_string, "NULL") && strcmp(material_string, "0")) {
    // A geometry string was given, use it to determine which material
    if (0 == strcmp(material_string,"vacuum") || 0 == strcmp(material_string,"Vacuum")) {
        // One could have a global physics struct for vacuum instead of creating one for each
        this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
        this_box_volume.p_physics->is_vacuum = 1; // Makes this volume a vacuum
        this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
        this_box_volume.p_physics->my_a = 0; // Should not be used.
        sprintf(this_box_volume.p_physics->name,"Vacuum");
    } else if (0 == strcmp(material_string,"exit") || 0 == strcmp(material_string,"Exit")) {
        // One could have a global physics struct for vacuum instead of creating one for each
        this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
        this_box_volume.p_physics->is_vacuum = 1; // Makes this volume a vacuum
        this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
        this_box_volume.p_physics->my_a = 0; // Should not be used.
        this_box_volume.geometry.is_exit_volume = 1;
        sprintf(this_box_volume.p_physics->name,"Exit");
    } else {
        #ifndef MATERIAL_DETECTOR
            printf("Need to define a material before refering to it in a geometry %s.\n",NAME_CURRENT_COMP);
            exit(1);
        #endif
        for (loop_index=0;loop_index<global_material_list.num_elements;loop_index++) {
            if (0 == strcmp(material_string,global_material_list.elements[loop_index].name)) {
                this_box_volume.p_physics = global_material_list.elements[loop_index].physics;
                break;
            }
            if (loop_index == global_material_list.num_elements-1) {
            printf("\n");
            printf("ERROR: The material string \"%s\" in Union geometry \"%s\" did not match a specified material. \n",material_string,NAME_CURRENT_COMP);
            printf("       The materials available at this point (need to be defined before the geometry): \n");
            for (loop_index=0;loop_index<global_material_list.num_elements;loop_index++)
              printf("         %s\n",global_material_list.elements[loop_index].name);
            printf("\n");
            printf("       It is also possible to use one of the defualt materials avaiable: \n");
            printf("           Vacuum (for a Volume without scattering or absorption)\n");
            printf("           Exit (for a Volume where the ray exits the component if it enters)\n");
            printf("           Mask (for a Volume that masks existing volumes specified in the mask_string\n");
            exit(1);
          }
        }
    }
} else {
    // Automatic linking, simply using the last defined material.
    #ifndef MATERIAL_DETECTOR
        printf("Need to define a material before the geometry to use automatic linking %s.\n",NAME_CURRENT_COMP);
        exit(1);
    #endif
    this_box_volume.p_physics = global_material_list.elements[global_material_list.num_elements-1].physics;
}

sprintf(this_box_volume.name,NAME_CURRENT_COMP);
sprintf(this_box_volume.geometry.shape,"box");
this_box_volume.geometry.priority_value = priority;
this_box_volume.geometry.geometry_p_interact = p_interact;
// Currently the coordinates will be in absolute space.
this_box_volume.geometry.center = POS_A_CURRENT_COMP;

this_box_storage.z_depth = zdepth;
this_box_storage.x_width1 = xwidth;
this_box_storage.y_height1 = yheight;

this_box_storage.is_rectangle = 0;
if (xwidth2 < 0 && yheight2 < 0) this_box_storage.is_rectangle = 1;
if (xwidth == xwidth2 && yheight == yheight2) this_box_storage.is_rectangle = 1;

if (xwidth2 < 0) {
    this_box_storage.x_width2 = xwidth;
    xwidth2 = xwidth;
} else this_box_storage.x_width2 = xwidth2;

if (yheight2 < 0) {
    this_box_storage.y_height2 = yheight;
    yheight2 = yheight;
} else this_box_storage.y_height2 = yheight2;


this_box_storage.normal_vectors[0] = coords_set(0,0,1);
this_box_storage.normal_vectors[1] = coords_set(0,0,1);

// for sides with y component = 0
x_component = 2*zdepth/sqrt((xwidth-xwidth2)*(xwidth-xwidth2)+4*zdepth*zdepth);
z_component = (xwidth-xwidth2)/sqrt(4*zdepth*zdepth+(xwidth-xwidth2)*(xwidth-xwidth2));

this_box_storage.normal_vectors[2] = coords_set(x_component,0,z_component);
this_box_storage.normal_vectors[3] = coords_set(-x_component,0,z_component);

// for sides with x component = 0
y_component = 2*zdepth/sqrt((yheight-yheight2)*(yheight-yheight2)+4*zdepth*zdepth);
z_component = (yheight-yheight2)/sqrt(4*zdepth*zdepth+(yheight-yheight2)*(yheight-yheight2));

this_box_storage.normal_vectors[4] = coords_set(0,y_component,z_component);
this_box_storage.normal_vectors[5] = coords_set(0,-y_component,z_component);

this_box_volume.geometry.visualization_on = visualize;

this_box_volume.geometry.geometry_parameters.p_box_storage = &this_box_storage;

// Assign pointers to functions for intersection with the shape, checking if a point is inside the shape
if (this_box_storage.is_rectangle == 1) {
this_box_volume.geometry.intersect_function = &sample_box_intersect_simple;
this_box_volume.geometry.within_function = &r_within_box_simple;
}
else {
this_box_volume.geometry.intersect_function = &sample_box_intersect_advanced;
this_box_volume.geometry.within_function = &r_within_box_advanced;
}

this_box_volume.geometry.shell_points = &box_shell_points;
this_box_volume.geometry.mcdisplay_function = &mcdisplay_box_function;
this_box_volume.geometry.initialize_from_main_function = &initialize_box_geometry_from_main_component;
this_box_volume.geometry.process_rot_allocated = 0;

this_box_volume.geometry.copy_geometry_parameters = &allocate_box_storage_copy;

rot_copy(this_box_volume.geometry.rotation_matrix,ROT_A_CURRENT_COMP); //check how ROT_R_CURRENT_COMP would work
rot_transpose(ROT_A_CURRENT_COMP,this_box_volume.geometry.transpose_rotation_matrix);

// Initialize loggers
this_box_volume.loggers.num_elements = 0;

// packing the information into the global_geometry_element, which is then included in the global_geometry_list.
sprintf(global_geometry_element.name,NAME_CURRENT_COMP);
global_geometry_element.activation_counter = number_of_activations;
global_geometry_element.component_index = INDEX_CURRENT_COMP;
global_geometry_element.Volume = &this_box_volume; // Would be nicer if this m was a pointer, now we have the (small) data two places
add_element_to_geometry_list(&global_geometry_list,global_geometry_element);
}
#line 184475 "MACS_sample_kidney_box.c"
#undef number_of_activations
#undef mask_setting
#undef mask_string
#undef p_interact
#undef focus_r
#undef focus_xh
#undef focus_xw
#undef focus_ah
#undef focus_aw
#undef target_z
#undef target_y
#undef target_x
#undef target_index
#undef visualize
#undef yheight2
#undef xwidth2
#undef zdepth
#undef yheight
#undef xwidth
#undef priority
#undef material_string
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

  /* Initializations for component channel_2_analyzer_1_array_crystal_array_5. */
  SIG_MESSAGE("channel_2_analyzer_1_array_crystal_array_5 (Init)");
#define mccompcurname  channel_2_analyzer_1_array_crystal_array_5
#define mccompcurtype  Union_box
#define mccompcurindex 211
#define loop_index mccchannel_2_analyzer_1_array_crystal_array_5_loop_index
#define this_box_volume mccchannel_2_analyzer_1_array_crystal_array_5_this_box_volume
#define global_geometry_element mccchannel_2_analyzer_1_array_crystal_array_5_global_geometry_element
#define this_box_storage mccchannel_2_analyzer_1_array_crystal_array_5_this_box_storage
#define material_string mccchannel_2_analyzer_1_array_crystal_array_5_material_string
#define priority mccchannel_2_analyzer_1_array_crystal_array_5_priority
#define xwidth mccchannel_2_analyzer_1_array_crystal_array_5_xwidth
#define yheight mccchannel_2_analyzer_1_array_crystal_array_5_yheight
#define zdepth mccchannel_2_analyzer_1_array_crystal_array_5_zdepth
#define xwidth2 mccchannel_2_analyzer_1_array_crystal_array_5_xwidth2
#define yheight2 mccchannel_2_analyzer_1_array_crystal_array_5_yheight2
#define visualize mccchannel_2_analyzer_1_array_crystal_array_5_visualize
#define target_index mccchannel_2_analyzer_1_array_crystal_array_5_target_index
#define target_x mccchannel_2_analyzer_1_array_crystal_array_5_target_x
#define target_y mccchannel_2_analyzer_1_array_crystal_array_5_target_y
#define target_z mccchannel_2_analyzer_1_array_crystal_array_5_target_z
#define focus_aw mccchannel_2_analyzer_1_array_crystal_array_5_focus_aw
#define focus_ah mccchannel_2_analyzer_1_array_crystal_array_5_focus_ah
#define focus_xw mccchannel_2_analyzer_1_array_crystal_array_5_focus_xw
#define focus_xh mccchannel_2_analyzer_1_array_crystal_array_5_focus_xh
#define focus_r mccchannel_2_analyzer_1_array_crystal_array_5_focus_r
#define p_interact mccchannel_2_analyzer_1_array_crystal_array_5_p_interact
#define mask_string mccchannel_2_analyzer_1_array_crystal_array_5_mask_string
#define mask_setting mccchannel_2_analyzer_1_array_crystal_array_5_mask_setting
#define number_of_activations mccchannel_2_analyzer_1_array_crystal_array_5_number_of_activations
#line 224 "Union_box.comp"
{
// Initializes the focusing system for this volume including input sanitation.
focus_initialize(&this_box_volume.geometry, POS_A_COMP_INDEX(INDEX_CURRENT_COMP+target_index), POS_A_CURRENT_COMP, ROT_A_CURRENT_COMP, target_index, target_x, target_y, target_z, focus_aw, focus_ah, focus_xw, focus_xh, focus_r, NAME_CURRENT_COMP);

// Input sanitation for this geometry
if (xwidth <= 0) {
  printf("\nERROR in Union_box named %s, the xwidth is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (yheight <= 0) {
  printf("\nERROR in Union_box named %s, yheight is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (zdepth <= 0) {
  printf("\nERROR in Union_box named %s, zdepth is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (xwidth2 <= 0 && xwidth2 != -1) {
  printf("\nERROR in Union_box named %s, the xwidth2 is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (yheight2 <= 0 && yheight2 != -1) {
  printf("\nERROR in Union_box named %s, yheight2 is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}

// Use sanitation
if (global_material_list.num_elements == 0) {
  printf("\nERROR: Need to define a material using Union_make_material before using a Union geometry component. \n");
  printf("       %s was defined before first use of Union_make_material.\n",NAME_CURRENT_COMP);
  exit(1);
}

this_box_volume.geometry.is_masked_volume = 0;
this_box_volume.geometry.is_exit_volume = 0;
this_box_volume.geometry.is_mask_volume = 0;
// check if the volume is a mask, if it is the material string is irelevant.
if (mask_string && strlen(mask_string) && strcmp(mask_string, "NULL") && strcmp(mask_string, "0")) {
    // A mask volume is used to limit the extend of other volumes, called the masked volumes. These are specified in the mask_string.
    // In order for a ray to enter a masked volume, it needs to be both in the region covered by that volume AND the mask volume.
    // When more than
    this_box_volume.geometry.mask_mode = 1; // Default is mask mode is ALL
    if (mask_setting && strlen(mask_setting) && strcmp(mask_setting, "NULL") && strcmp(mask_setting, "0")) {
        if (strcmp(mask_setting,"ALL") == 0 || strcmp(mask_setting,"All") == 0) this_box_volume.geometry.mask_mode = 1;
        else if (strcmp(mask_setting,"ANY") == 0 || strcmp(mask_setting,"Any") == 0) this_box_volume.geometry.mask_mode = 2;
        else {
            printf("The mask_mode of component %s is set to %s, but must be either ALL or ANY.\n",NAME_CURRENT_COMP,mask_setting);
            exit(1);
        }
    }
    
    for (loop_index=0;loop_index<global_geometry_list.num_elements;loop_index++) {
        // Add mask list
        if (1 == manual_linking_function(global_geometry_list.elements[loop_index].name,mask_string)) {
            add_element_to_int_list(&this_box_volume.geometry.mask_list,global_geometry_list.elements[loop_index].component_index);
            add_element_to_int_list(&global_geometry_list.elements[loop_index].Volume->geometry.masked_by_list,INDEX_CURRENT_COMP);
            global_geometry_list.elements[loop_index].Volume->geometry.is_masked_volume = 1;
            if (this_box_volume.geometry.mask_mode == 2)
                global_geometry_list.elements[loop_index].Volume->geometry.mask_mode = 2;
            if (this_box_volume.geometry.mask_mode == 1) {
                if (global_geometry_list.elements[loop_index].Volume->geometry.is_masked_volume == 1 && global_geometry_list.elements[loop_index].Volume->geometry.mask_mode != 2)
                    // If more than one mask is added to one volume, the ANY mode overwrites the (default) ALL mode.
                    global_geometry_list.elements[loop_index].Volume->geometry.mask_mode = 1;
            }
            
            found_geometries = 1;
        }
    }
    if (found_geometries == 0) {
        printf("The mask_string in geometry: %s did not find any of the specified volumes in the mask_string %s \n",NAME_CURRENT_COMP,mask_string);
        exit(1);
    }
    this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
    this_box_volume.p_physics->is_vacuum = 0; // Makes this volume a vacuum
    this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
    this_box_volume.p_physics->my_a = 0; // Should not be used.
    sprintf(this_box_volume.p_physics->name,"Mask");
    this_box_volume.geometry.is_mask_volume = 1;
    
    
// Read the material input, or if it lacks, use automatic linking.
} else if (material_string && strlen(material_string) && strcmp(material_string, "NULL") && strcmp(material_string, "0")) {
    // A geometry string was given, use it to determine which material
    if (0 == strcmp(material_string,"vacuum") || 0 == strcmp(material_string,"Vacuum")) {
        // One could have a global physics struct for vacuum instead of creating one for each
        this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
        this_box_volume.p_physics->is_vacuum = 1; // Makes this volume a vacuum
        this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
        this_box_volume.p_physics->my_a = 0; // Should not be used.
        sprintf(this_box_volume.p_physics->name,"Vacuum");
    } else if (0 == strcmp(material_string,"exit") || 0 == strcmp(material_string,"Exit")) {
        // One could have a global physics struct for vacuum instead of creating one for each
        this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
        this_box_volume.p_physics->is_vacuum = 1; // Makes this volume a vacuum
        this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
        this_box_volume.p_physics->my_a = 0; // Should not be used.
        this_box_volume.geometry.is_exit_volume = 1;
        sprintf(this_box_volume.p_physics->name,"Exit");
    } else {
        #ifndef MATERIAL_DETECTOR
            printf("Need to define a material before refering to it in a geometry %s.\n",NAME_CURRENT_COMP);
            exit(1);
        #endif
        for (loop_index=0;loop_index<global_material_list.num_elements;loop_index++) {
            if (0 == strcmp(material_string,global_material_list.elements[loop_index].name)) {
                this_box_volume.p_physics = global_material_list.elements[loop_index].physics;
                break;
            }
            if (loop_index == global_material_list.num_elements-1) {
            printf("\n");
            printf("ERROR: The material string \"%s\" in Union geometry \"%s\" did not match a specified material. \n",material_string,NAME_CURRENT_COMP);
            printf("       The materials available at this point (need to be defined before the geometry): \n");
            for (loop_index=0;loop_index<global_material_list.num_elements;loop_index++)
              printf("         %s\n",global_material_list.elements[loop_index].name);
            printf("\n");
            printf("       It is also possible to use one of the defualt materials avaiable: \n");
            printf("           Vacuum (for a Volume without scattering or absorption)\n");
            printf("           Exit (for a Volume where the ray exits the component if it enters)\n");
            printf("           Mask (for a Volume that masks existing volumes specified in the mask_string\n");
            exit(1);
          }
        }
    }
} else {
    // Automatic linking, simply using the last defined material.
    #ifndef MATERIAL_DETECTOR
        printf("Need to define a material before the geometry to use automatic linking %s.\n",NAME_CURRENT_COMP);
        exit(1);
    #endif
    this_box_volume.p_physics = global_material_list.elements[global_material_list.num_elements-1].physics;
}

sprintf(this_box_volume.name,NAME_CURRENT_COMP);
sprintf(this_box_volume.geometry.shape,"box");
this_box_volume.geometry.priority_value = priority;
this_box_volume.geometry.geometry_p_interact = p_interact;
// Currently the coordinates will be in absolute space.
this_box_volume.geometry.center = POS_A_CURRENT_COMP;

this_box_storage.z_depth = zdepth;
this_box_storage.x_width1 = xwidth;
this_box_storage.y_height1 = yheight;

this_box_storage.is_rectangle = 0;
if (xwidth2 < 0 && yheight2 < 0) this_box_storage.is_rectangle = 1;
if (xwidth == xwidth2 && yheight == yheight2) this_box_storage.is_rectangle = 1;

if (xwidth2 < 0) {
    this_box_storage.x_width2 = xwidth;
    xwidth2 = xwidth;
} else this_box_storage.x_width2 = xwidth2;

if (yheight2 < 0) {
    this_box_storage.y_height2 = yheight;
    yheight2 = yheight;
} else this_box_storage.y_height2 = yheight2;


this_box_storage.normal_vectors[0] = coords_set(0,0,1);
this_box_storage.normal_vectors[1] = coords_set(0,0,1);

// for sides with y component = 0
x_component = 2*zdepth/sqrt((xwidth-xwidth2)*(xwidth-xwidth2)+4*zdepth*zdepth);
z_component = (xwidth-xwidth2)/sqrt(4*zdepth*zdepth+(xwidth-xwidth2)*(xwidth-xwidth2));

this_box_storage.normal_vectors[2] = coords_set(x_component,0,z_component);
this_box_storage.normal_vectors[3] = coords_set(-x_component,0,z_component);

// for sides with x component = 0
y_component = 2*zdepth/sqrt((yheight-yheight2)*(yheight-yheight2)+4*zdepth*zdepth);
z_component = (yheight-yheight2)/sqrt(4*zdepth*zdepth+(yheight-yheight2)*(yheight-yheight2));

this_box_storage.normal_vectors[4] = coords_set(0,y_component,z_component);
this_box_storage.normal_vectors[5] = coords_set(0,-y_component,z_component);

this_box_volume.geometry.visualization_on = visualize;

this_box_volume.geometry.geometry_parameters.p_box_storage = &this_box_storage;

// Assign pointers to functions for intersection with the shape, checking if a point is inside the shape
if (this_box_storage.is_rectangle == 1) {
this_box_volume.geometry.intersect_function = &sample_box_intersect_simple;
this_box_volume.geometry.within_function = &r_within_box_simple;
}
else {
this_box_volume.geometry.intersect_function = &sample_box_intersect_advanced;
this_box_volume.geometry.within_function = &r_within_box_advanced;
}

this_box_volume.geometry.shell_points = &box_shell_points;
this_box_volume.geometry.mcdisplay_function = &mcdisplay_box_function;
this_box_volume.geometry.initialize_from_main_function = &initialize_box_geometry_from_main_component;
this_box_volume.geometry.process_rot_allocated = 0;

this_box_volume.geometry.copy_geometry_parameters = &allocate_box_storage_copy;

rot_copy(this_box_volume.geometry.rotation_matrix,ROT_A_CURRENT_COMP); //check how ROT_R_CURRENT_COMP would work
rot_transpose(ROT_A_CURRENT_COMP,this_box_volume.geometry.transpose_rotation_matrix);

// Initialize loggers
this_box_volume.loggers.num_elements = 0;

// packing the information into the global_geometry_element, which is then included in the global_geometry_list.
sprintf(global_geometry_element.name,NAME_CURRENT_COMP);
global_geometry_element.activation_counter = number_of_activations;
global_geometry_element.component_index = INDEX_CURRENT_COMP;
global_geometry_element.Volume = &this_box_volume; // Would be nicer if this m was a pointer, now we have the (small) data two places
add_element_to_geometry_list(&global_geometry_list,global_geometry_element);
}
#line 184745 "MACS_sample_kidney_box.c"
#undef number_of_activations
#undef mask_setting
#undef mask_string
#undef p_interact
#undef focus_r
#undef focus_xh
#undef focus_xw
#undef focus_ah
#undef focus_aw
#undef target_z
#undef target_y
#undef target_x
#undef target_index
#undef visualize
#undef yheight2
#undef xwidth2
#undef zdepth
#undef yheight
#undef xwidth
#undef priority
#undef material_string
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

  /* Initializations for component channel_2_analyzer_1_array_crystal_array_6. */
  SIG_MESSAGE("channel_2_analyzer_1_array_crystal_array_6 (Init)");
#define mccompcurname  channel_2_analyzer_1_array_crystal_array_6
#define mccompcurtype  Union_box
#define mccompcurindex 212
#define loop_index mccchannel_2_analyzer_1_array_crystal_array_6_loop_index
#define this_box_volume mccchannel_2_analyzer_1_array_crystal_array_6_this_box_volume
#define global_geometry_element mccchannel_2_analyzer_1_array_crystal_array_6_global_geometry_element
#define this_box_storage mccchannel_2_analyzer_1_array_crystal_array_6_this_box_storage
#define material_string mccchannel_2_analyzer_1_array_crystal_array_6_material_string
#define priority mccchannel_2_analyzer_1_array_crystal_array_6_priority
#define xwidth mccchannel_2_analyzer_1_array_crystal_array_6_xwidth
#define yheight mccchannel_2_analyzer_1_array_crystal_array_6_yheight
#define zdepth mccchannel_2_analyzer_1_array_crystal_array_6_zdepth
#define xwidth2 mccchannel_2_analyzer_1_array_crystal_array_6_xwidth2
#define yheight2 mccchannel_2_analyzer_1_array_crystal_array_6_yheight2
#define visualize mccchannel_2_analyzer_1_array_crystal_array_6_visualize
#define target_index mccchannel_2_analyzer_1_array_crystal_array_6_target_index
#define target_x mccchannel_2_analyzer_1_array_crystal_array_6_target_x
#define target_y mccchannel_2_analyzer_1_array_crystal_array_6_target_y
#define target_z mccchannel_2_analyzer_1_array_crystal_array_6_target_z
#define focus_aw mccchannel_2_analyzer_1_array_crystal_array_6_focus_aw
#define focus_ah mccchannel_2_analyzer_1_array_crystal_array_6_focus_ah
#define focus_xw mccchannel_2_analyzer_1_array_crystal_array_6_focus_xw
#define focus_xh mccchannel_2_analyzer_1_array_crystal_array_6_focus_xh
#define focus_r mccchannel_2_analyzer_1_array_crystal_array_6_focus_r
#define p_interact mccchannel_2_analyzer_1_array_crystal_array_6_p_interact
#define mask_string mccchannel_2_analyzer_1_array_crystal_array_6_mask_string
#define mask_setting mccchannel_2_analyzer_1_array_crystal_array_6_mask_setting
#define number_of_activations mccchannel_2_analyzer_1_array_crystal_array_6_number_of_activations
#line 224 "Union_box.comp"
{
// Initializes the focusing system for this volume including input sanitation.
focus_initialize(&this_box_volume.geometry, POS_A_COMP_INDEX(INDEX_CURRENT_COMP+target_index), POS_A_CURRENT_COMP, ROT_A_CURRENT_COMP, target_index, target_x, target_y, target_z, focus_aw, focus_ah, focus_xw, focus_xh, focus_r, NAME_CURRENT_COMP);

// Input sanitation for this geometry
if (xwidth <= 0) {
  printf("\nERROR in Union_box named %s, the xwidth is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (yheight <= 0) {
  printf("\nERROR in Union_box named %s, yheight is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (zdepth <= 0) {
  printf("\nERROR in Union_box named %s, zdepth is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (xwidth2 <= 0 && xwidth2 != -1) {
  printf("\nERROR in Union_box named %s, the xwidth2 is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (yheight2 <= 0 && yheight2 != -1) {
  printf("\nERROR in Union_box named %s, yheight2 is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}

// Use sanitation
if (global_material_list.num_elements == 0) {
  printf("\nERROR: Need to define a material using Union_make_material before using a Union geometry component. \n");
  printf("       %s was defined before first use of Union_make_material.\n",NAME_CURRENT_COMP);
  exit(1);
}

this_box_volume.geometry.is_masked_volume = 0;
this_box_volume.geometry.is_exit_volume = 0;
this_box_volume.geometry.is_mask_volume = 0;
// check if the volume is a mask, if it is the material string is irelevant.
if (mask_string && strlen(mask_string) && strcmp(mask_string, "NULL") && strcmp(mask_string, "0")) {
    // A mask volume is used to limit the extend of other volumes, called the masked volumes. These are specified in the mask_string.
    // In order for a ray to enter a masked volume, it needs to be both in the region covered by that volume AND the mask volume.
    // When more than
    this_box_volume.geometry.mask_mode = 1; // Default is mask mode is ALL
    if (mask_setting && strlen(mask_setting) && strcmp(mask_setting, "NULL") && strcmp(mask_setting, "0")) {
        if (strcmp(mask_setting,"ALL") == 0 || strcmp(mask_setting,"All") == 0) this_box_volume.geometry.mask_mode = 1;
        else if (strcmp(mask_setting,"ANY") == 0 || strcmp(mask_setting,"Any") == 0) this_box_volume.geometry.mask_mode = 2;
        else {
            printf("The mask_mode of component %s is set to %s, but must be either ALL or ANY.\n",NAME_CURRENT_COMP,mask_setting);
            exit(1);
        }
    }
    
    for (loop_index=0;loop_index<global_geometry_list.num_elements;loop_index++) {
        // Add mask list
        if (1 == manual_linking_function(global_geometry_list.elements[loop_index].name,mask_string)) {
            add_element_to_int_list(&this_box_volume.geometry.mask_list,global_geometry_list.elements[loop_index].component_index);
            add_element_to_int_list(&global_geometry_list.elements[loop_index].Volume->geometry.masked_by_list,INDEX_CURRENT_COMP);
            global_geometry_list.elements[loop_index].Volume->geometry.is_masked_volume = 1;
            if (this_box_volume.geometry.mask_mode == 2)
                global_geometry_list.elements[loop_index].Volume->geometry.mask_mode = 2;
            if (this_box_volume.geometry.mask_mode == 1) {
                if (global_geometry_list.elements[loop_index].Volume->geometry.is_masked_volume == 1 && global_geometry_list.elements[loop_index].Volume->geometry.mask_mode != 2)
                    // If more than one mask is added to one volume, the ANY mode overwrites the (default) ALL mode.
                    global_geometry_list.elements[loop_index].Volume->geometry.mask_mode = 1;
            }
            
            found_geometries = 1;
        }
    }
    if (found_geometries == 0) {
        printf("The mask_string in geometry: %s did not find any of the specified volumes in the mask_string %s \n",NAME_CURRENT_COMP,mask_string);
        exit(1);
    }
    this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
    this_box_volume.p_physics->is_vacuum = 0; // Makes this volume a vacuum
    this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
    this_box_volume.p_physics->my_a = 0; // Should not be used.
    sprintf(this_box_volume.p_physics->name,"Mask");
    this_box_volume.geometry.is_mask_volume = 1;
    
    
// Read the material input, or if it lacks, use automatic linking.
} else if (material_string && strlen(material_string) && strcmp(material_string, "NULL") && strcmp(material_string, "0")) {
    // A geometry string was given, use it to determine which material
    if (0 == strcmp(material_string,"vacuum") || 0 == strcmp(material_string,"Vacuum")) {
        // One could have a global physics struct for vacuum instead of creating one for each
        this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
        this_box_volume.p_physics->is_vacuum = 1; // Makes this volume a vacuum
        this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
        this_box_volume.p_physics->my_a = 0; // Should not be used.
        sprintf(this_box_volume.p_physics->name,"Vacuum");
    } else if (0 == strcmp(material_string,"exit") || 0 == strcmp(material_string,"Exit")) {
        // One could have a global physics struct for vacuum instead of creating one for each
        this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
        this_box_volume.p_physics->is_vacuum = 1; // Makes this volume a vacuum
        this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
        this_box_volume.p_physics->my_a = 0; // Should not be used.
        this_box_volume.geometry.is_exit_volume = 1;
        sprintf(this_box_volume.p_physics->name,"Exit");
    } else {
        #ifndef MATERIAL_DETECTOR
            printf("Need to define a material before refering to it in a geometry %s.\n",NAME_CURRENT_COMP);
            exit(1);
        #endif
        for (loop_index=0;loop_index<global_material_list.num_elements;loop_index++) {
            if (0 == strcmp(material_string,global_material_list.elements[loop_index].name)) {
                this_box_volume.p_physics = global_material_list.elements[loop_index].physics;
                break;
            }
            if (loop_index == global_material_list.num_elements-1) {
            printf("\n");
            printf("ERROR: The material string \"%s\" in Union geometry \"%s\" did not match a specified material. \n",material_string,NAME_CURRENT_COMP);
            printf("       The materials available at this point (need to be defined before the geometry): \n");
            for (loop_index=0;loop_index<global_material_list.num_elements;loop_index++)
              printf("         %s\n",global_material_list.elements[loop_index].name);
            printf("\n");
            printf("       It is also possible to use one of the defualt materials avaiable: \n");
            printf("           Vacuum (for a Volume without scattering or absorption)\n");
            printf("           Exit (for a Volume where the ray exits the component if it enters)\n");
            printf("           Mask (for a Volume that masks existing volumes specified in the mask_string\n");
            exit(1);
          }
        }
    }
} else {
    // Automatic linking, simply using the last defined material.
    #ifndef MATERIAL_DETECTOR
        printf("Need to define a material before the geometry to use automatic linking %s.\n",NAME_CURRENT_COMP);
        exit(1);
    #endif
    this_box_volume.p_physics = global_material_list.elements[global_material_list.num_elements-1].physics;
}

sprintf(this_box_volume.name,NAME_CURRENT_COMP);
sprintf(this_box_volume.geometry.shape,"box");
this_box_volume.geometry.priority_value = priority;
this_box_volume.geometry.geometry_p_interact = p_interact;
// Currently the coordinates will be in absolute space.
this_box_volume.geometry.center = POS_A_CURRENT_COMP;

this_box_storage.z_depth = zdepth;
this_box_storage.x_width1 = xwidth;
this_box_storage.y_height1 = yheight;

this_box_storage.is_rectangle = 0;
if (xwidth2 < 0 && yheight2 < 0) this_box_storage.is_rectangle = 1;
if (xwidth == xwidth2 && yheight == yheight2) this_box_storage.is_rectangle = 1;

if (xwidth2 < 0) {
    this_box_storage.x_width2 = xwidth;
    xwidth2 = xwidth;
} else this_box_storage.x_width2 = xwidth2;

if (yheight2 < 0) {
    this_box_storage.y_height2 = yheight;
    yheight2 = yheight;
} else this_box_storage.y_height2 = yheight2;


this_box_storage.normal_vectors[0] = coords_set(0,0,1);
this_box_storage.normal_vectors[1] = coords_set(0,0,1);

// for sides with y component = 0
x_component = 2*zdepth/sqrt((xwidth-xwidth2)*(xwidth-xwidth2)+4*zdepth*zdepth);
z_component = (xwidth-xwidth2)/sqrt(4*zdepth*zdepth+(xwidth-xwidth2)*(xwidth-xwidth2));

this_box_storage.normal_vectors[2] = coords_set(x_component,0,z_component);
this_box_storage.normal_vectors[3] = coords_set(-x_component,0,z_component);

// for sides with x component = 0
y_component = 2*zdepth/sqrt((yheight-yheight2)*(yheight-yheight2)+4*zdepth*zdepth);
z_component = (yheight-yheight2)/sqrt(4*zdepth*zdepth+(yheight-yheight2)*(yheight-yheight2));

this_box_storage.normal_vectors[4] = coords_set(0,y_component,z_component);
this_box_storage.normal_vectors[5] = coords_set(0,-y_component,z_component);

this_box_volume.geometry.visualization_on = visualize;

this_box_volume.geometry.geometry_parameters.p_box_storage = &this_box_storage;

// Assign pointers to functions for intersection with the shape, checking if a point is inside the shape
if (this_box_storage.is_rectangle == 1) {
this_box_volume.geometry.intersect_function = &sample_box_intersect_simple;
this_box_volume.geometry.within_function = &r_within_box_simple;
}
else {
this_box_volume.geometry.intersect_function = &sample_box_intersect_advanced;
this_box_volume.geometry.within_function = &r_within_box_advanced;
}

this_box_volume.geometry.shell_points = &box_shell_points;
this_box_volume.geometry.mcdisplay_function = &mcdisplay_box_function;
this_box_volume.geometry.initialize_from_main_function = &initialize_box_geometry_from_main_component;
this_box_volume.geometry.process_rot_allocated = 0;

this_box_volume.geometry.copy_geometry_parameters = &allocate_box_storage_copy;

rot_copy(this_box_volume.geometry.rotation_matrix,ROT_A_CURRENT_COMP); //check how ROT_R_CURRENT_COMP would work
rot_transpose(ROT_A_CURRENT_COMP,this_box_volume.geometry.transpose_rotation_matrix);

// Initialize loggers
this_box_volume.loggers.num_elements = 0;

// packing the information into the global_geometry_element, which is then included in the global_geometry_list.
sprintf(global_geometry_element.name,NAME_CURRENT_COMP);
global_geometry_element.activation_counter = number_of_activations;
global_geometry_element.component_index = INDEX_CURRENT_COMP;
global_geometry_element.Volume = &this_box_volume; // Would be nicer if this m was a pointer, now we have the (small) data two places
add_element_to_geometry_list(&global_geometry_list,global_geometry_element);
}
#line 185015 "MACS_sample_kidney_box.c"
#undef number_of_activations
#undef mask_setting
#undef mask_string
#undef p_interact
#undef focus_r
#undef focus_xh
#undef focus_xw
#undef focus_ah
#undef focus_aw
#undef target_z
#undef target_y
#undef target_x
#undef target_index
#undef visualize
#undef yheight2
#undef xwidth2
#undef zdepth
#undef yheight
#undef xwidth
#undef priority
#undef material_string
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

  /* Initializations for component channel_2_analyzer_1_array_crystal_array_7. */
  SIG_MESSAGE("channel_2_analyzer_1_array_crystal_array_7 (Init)");
#define mccompcurname  channel_2_analyzer_1_array_crystal_array_7
#define mccompcurtype  Union_box
#define mccompcurindex 213
#define loop_index mccchannel_2_analyzer_1_array_crystal_array_7_loop_index
#define this_box_volume mccchannel_2_analyzer_1_array_crystal_array_7_this_box_volume
#define global_geometry_element mccchannel_2_analyzer_1_array_crystal_array_7_global_geometry_element
#define this_box_storage mccchannel_2_analyzer_1_array_crystal_array_7_this_box_storage
#define material_string mccchannel_2_analyzer_1_array_crystal_array_7_material_string
#define priority mccchannel_2_analyzer_1_array_crystal_array_7_priority
#define xwidth mccchannel_2_analyzer_1_array_crystal_array_7_xwidth
#define yheight mccchannel_2_analyzer_1_array_crystal_array_7_yheight
#define zdepth mccchannel_2_analyzer_1_array_crystal_array_7_zdepth
#define xwidth2 mccchannel_2_analyzer_1_array_crystal_array_7_xwidth2
#define yheight2 mccchannel_2_analyzer_1_array_crystal_array_7_yheight2
#define visualize mccchannel_2_analyzer_1_array_crystal_array_7_visualize
#define target_index mccchannel_2_analyzer_1_array_crystal_array_7_target_index
#define target_x mccchannel_2_analyzer_1_array_crystal_array_7_target_x
#define target_y mccchannel_2_analyzer_1_array_crystal_array_7_target_y
#define target_z mccchannel_2_analyzer_1_array_crystal_array_7_target_z
#define focus_aw mccchannel_2_analyzer_1_array_crystal_array_7_focus_aw
#define focus_ah mccchannel_2_analyzer_1_array_crystal_array_7_focus_ah
#define focus_xw mccchannel_2_analyzer_1_array_crystal_array_7_focus_xw
#define focus_xh mccchannel_2_analyzer_1_array_crystal_array_7_focus_xh
#define focus_r mccchannel_2_analyzer_1_array_crystal_array_7_focus_r
#define p_interact mccchannel_2_analyzer_1_array_crystal_array_7_p_interact
#define mask_string mccchannel_2_analyzer_1_array_crystal_array_7_mask_string
#define mask_setting mccchannel_2_analyzer_1_array_crystal_array_7_mask_setting
#define number_of_activations mccchannel_2_analyzer_1_array_crystal_array_7_number_of_activations
#line 224 "Union_box.comp"
{
// Initializes the focusing system for this volume including input sanitation.
focus_initialize(&this_box_volume.geometry, POS_A_COMP_INDEX(INDEX_CURRENT_COMP+target_index), POS_A_CURRENT_COMP, ROT_A_CURRENT_COMP, target_index, target_x, target_y, target_z, focus_aw, focus_ah, focus_xw, focus_xh, focus_r, NAME_CURRENT_COMP);

// Input sanitation for this geometry
if (xwidth <= 0) {
  printf("\nERROR in Union_box named %s, the xwidth is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (yheight <= 0) {
  printf("\nERROR in Union_box named %s, yheight is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (zdepth <= 0) {
  printf("\nERROR in Union_box named %s, zdepth is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (xwidth2 <= 0 && xwidth2 != -1) {
  printf("\nERROR in Union_box named %s, the xwidth2 is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (yheight2 <= 0 && yheight2 != -1) {
  printf("\nERROR in Union_box named %s, yheight2 is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}

// Use sanitation
if (global_material_list.num_elements == 0) {
  printf("\nERROR: Need to define a material using Union_make_material before using a Union geometry component. \n");
  printf("       %s was defined before first use of Union_make_material.\n",NAME_CURRENT_COMP);
  exit(1);
}

this_box_volume.geometry.is_masked_volume = 0;
this_box_volume.geometry.is_exit_volume = 0;
this_box_volume.geometry.is_mask_volume = 0;
// check if the volume is a mask, if it is the material string is irelevant.
if (mask_string && strlen(mask_string) && strcmp(mask_string, "NULL") && strcmp(mask_string, "0")) {
    // A mask volume is used to limit the extend of other volumes, called the masked volumes. These are specified in the mask_string.
    // In order for a ray to enter a masked volume, it needs to be both in the region covered by that volume AND the mask volume.
    // When more than
    this_box_volume.geometry.mask_mode = 1; // Default is mask mode is ALL
    if (mask_setting && strlen(mask_setting) && strcmp(mask_setting, "NULL") && strcmp(mask_setting, "0")) {
        if (strcmp(mask_setting,"ALL") == 0 || strcmp(mask_setting,"All") == 0) this_box_volume.geometry.mask_mode = 1;
        else if (strcmp(mask_setting,"ANY") == 0 || strcmp(mask_setting,"Any") == 0) this_box_volume.geometry.mask_mode = 2;
        else {
            printf("The mask_mode of component %s is set to %s, but must be either ALL or ANY.\n",NAME_CURRENT_COMP,mask_setting);
            exit(1);
        }
    }
    
    for (loop_index=0;loop_index<global_geometry_list.num_elements;loop_index++) {
        // Add mask list
        if (1 == manual_linking_function(global_geometry_list.elements[loop_index].name,mask_string)) {
            add_element_to_int_list(&this_box_volume.geometry.mask_list,global_geometry_list.elements[loop_index].component_index);
            add_element_to_int_list(&global_geometry_list.elements[loop_index].Volume->geometry.masked_by_list,INDEX_CURRENT_COMP);
            global_geometry_list.elements[loop_index].Volume->geometry.is_masked_volume = 1;
            if (this_box_volume.geometry.mask_mode == 2)
                global_geometry_list.elements[loop_index].Volume->geometry.mask_mode = 2;
            if (this_box_volume.geometry.mask_mode == 1) {
                if (global_geometry_list.elements[loop_index].Volume->geometry.is_masked_volume == 1 && global_geometry_list.elements[loop_index].Volume->geometry.mask_mode != 2)
                    // If more than one mask is added to one volume, the ANY mode overwrites the (default) ALL mode.
                    global_geometry_list.elements[loop_index].Volume->geometry.mask_mode = 1;
            }
            
            found_geometries = 1;
        }
    }
    if (found_geometries == 0) {
        printf("The mask_string in geometry: %s did not find any of the specified volumes in the mask_string %s \n",NAME_CURRENT_COMP,mask_string);
        exit(1);
    }
    this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
    this_box_volume.p_physics->is_vacuum = 0; // Makes this volume a vacuum
    this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
    this_box_volume.p_physics->my_a = 0; // Should not be used.
    sprintf(this_box_volume.p_physics->name,"Mask");
    this_box_volume.geometry.is_mask_volume = 1;
    
    
// Read the material input, or if it lacks, use automatic linking.
} else if (material_string && strlen(material_string) && strcmp(material_string, "NULL") && strcmp(material_string, "0")) {
    // A geometry string was given, use it to determine which material
    if (0 == strcmp(material_string,"vacuum") || 0 == strcmp(material_string,"Vacuum")) {
        // One could have a global physics struct for vacuum instead of creating one for each
        this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
        this_box_volume.p_physics->is_vacuum = 1; // Makes this volume a vacuum
        this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
        this_box_volume.p_physics->my_a = 0; // Should not be used.
        sprintf(this_box_volume.p_physics->name,"Vacuum");
    } else if (0 == strcmp(material_string,"exit") || 0 == strcmp(material_string,"Exit")) {
        // One could have a global physics struct for vacuum instead of creating one for each
        this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
        this_box_volume.p_physics->is_vacuum = 1; // Makes this volume a vacuum
        this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
        this_box_volume.p_physics->my_a = 0; // Should not be used.
        this_box_volume.geometry.is_exit_volume = 1;
        sprintf(this_box_volume.p_physics->name,"Exit");
    } else {
        #ifndef MATERIAL_DETECTOR
            printf("Need to define a material before refering to it in a geometry %s.\n",NAME_CURRENT_COMP);
            exit(1);
        #endif
        for (loop_index=0;loop_index<global_material_list.num_elements;loop_index++) {
            if (0 == strcmp(material_string,global_material_list.elements[loop_index].name)) {
                this_box_volume.p_physics = global_material_list.elements[loop_index].physics;
                break;
            }
            if (loop_index == global_material_list.num_elements-1) {
            printf("\n");
            printf("ERROR: The material string \"%s\" in Union geometry \"%s\" did not match a specified material. \n",material_string,NAME_CURRENT_COMP);
            printf("       The materials available at this point (need to be defined before the geometry): \n");
            for (loop_index=0;loop_index<global_material_list.num_elements;loop_index++)
              printf("         %s\n",global_material_list.elements[loop_index].name);
            printf("\n");
            printf("       It is also possible to use one of the defualt materials avaiable: \n");
            printf("           Vacuum (for a Volume without scattering or absorption)\n");
            printf("           Exit (for a Volume where the ray exits the component if it enters)\n");
            printf("           Mask (for a Volume that masks existing volumes specified in the mask_string\n");
            exit(1);
          }
        }
    }
} else {
    // Automatic linking, simply using the last defined material.
    #ifndef MATERIAL_DETECTOR
        printf("Need to define a material before the geometry to use automatic linking %s.\n",NAME_CURRENT_COMP);
        exit(1);
    #endif
    this_box_volume.p_physics = global_material_list.elements[global_material_list.num_elements-1].physics;
}

sprintf(this_box_volume.name,NAME_CURRENT_COMP);
sprintf(this_box_volume.geometry.shape,"box");
this_box_volume.geometry.priority_value = priority;
this_box_volume.geometry.geometry_p_interact = p_interact;
// Currently the coordinates will be in absolute space.
this_box_volume.geometry.center = POS_A_CURRENT_COMP;

this_box_storage.z_depth = zdepth;
this_box_storage.x_width1 = xwidth;
this_box_storage.y_height1 = yheight;

this_box_storage.is_rectangle = 0;
if (xwidth2 < 0 && yheight2 < 0) this_box_storage.is_rectangle = 1;
if (xwidth == xwidth2 && yheight == yheight2) this_box_storage.is_rectangle = 1;

if (xwidth2 < 0) {
    this_box_storage.x_width2 = xwidth;
    xwidth2 = xwidth;
} else this_box_storage.x_width2 = xwidth2;

if (yheight2 < 0) {
    this_box_storage.y_height2 = yheight;
    yheight2 = yheight;
} else this_box_storage.y_height2 = yheight2;


this_box_storage.normal_vectors[0] = coords_set(0,0,1);
this_box_storage.normal_vectors[1] = coords_set(0,0,1);

// for sides with y component = 0
x_component = 2*zdepth/sqrt((xwidth-xwidth2)*(xwidth-xwidth2)+4*zdepth*zdepth);
z_component = (xwidth-xwidth2)/sqrt(4*zdepth*zdepth+(xwidth-xwidth2)*(xwidth-xwidth2));

this_box_storage.normal_vectors[2] = coords_set(x_component,0,z_component);
this_box_storage.normal_vectors[3] = coords_set(-x_component,0,z_component);

// for sides with x component = 0
y_component = 2*zdepth/sqrt((yheight-yheight2)*(yheight-yheight2)+4*zdepth*zdepth);
z_component = (yheight-yheight2)/sqrt(4*zdepth*zdepth+(yheight-yheight2)*(yheight-yheight2));

this_box_storage.normal_vectors[4] = coords_set(0,y_component,z_component);
this_box_storage.normal_vectors[5] = coords_set(0,-y_component,z_component);

this_box_volume.geometry.visualization_on = visualize;

this_box_volume.geometry.geometry_parameters.p_box_storage = &this_box_storage;

// Assign pointers to functions for intersection with the shape, checking if a point is inside the shape
if (this_box_storage.is_rectangle == 1) {
this_box_volume.geometry.intersect_function = &sample_box_intersect_simple;
this_box_volume.geometry.within_function = &r_within_box_simple;
}
else {
this_box_volume.geometry.intersect_function = &sample_box_intersect_advanced;
this_box_volume.geometry.within_function = &r_within_box_advanced;
}

this_box_volume.geometry.shell_points = &box_shell_points;
this_box_volume.geometry.mcdisplay_function = &mcdisplay_box_function;
this_box_volume.geometry.initialize_from_main_function = &initialize_box_geometry_from_main_component;
this_box_volume.geometry.process_rot_allocated = 0;

this_box_volume.geometry.copy_geometry_parameters = &allocate_box_storage_copy;

rot_copy(this_box_volume.geometry.rotation_matrix,ROT_A_CURRENT_COMP); //check how ROT_R_CURRENT_COMP would work
rot_transpose(ROT_A_CURRENT_COMP,this_box_volume.geometry.transpose_rotation_matrix);

// Initialize loggers
this_box_volume.loggers.num_elements = 0;

// packing the information into the global_geometry_element, which is then included in the global_geometry_list.
sprintf(global_geometry_element.name,NAME_CURRENT_COMP);
global_geometry_element.activation_counter = number_of_activations;
global_geometry_element.component_index = INDEX_CURRENT_COMP;
global_geometry_element.Volume = &this_box_volume; // Would be nicer if this m was a pointer, now we have the (small) data two places
add_element_to_geometry_list(&global_geometry_list,global_geometry_element);
}
#line 185285 "MACS_sample_kidney_box.c"
#undef number_of_activations
#undef mask_setting
#undef mask_string
#undef p_interact
#undef focus_r
#undef focus_xh
#undef focus_xw
#undef focus_ah
#undef focus_aw
#undef target_z
#undef target_y
#undef target_x
#undef target_index
#undef visualize
#undef yheight2
#undef xwidth2
#undef zdepth
#undef yheight
#undef xwidth
#undef priority
#undef material_string
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

  /* Initializations for component channel_2_analyzer_1_array_crystal_array_8. */
  SIG_MESSAGE("channel_2_analyzer_1_array_crystal_array_8 (Init)");
#define mccompcurname  channel_2_analyzer_1_array_crystal_array_8
#define mccompcurtype  Union_box
#define mccompcurindex 214
#define loop_index mccchannel_2_analyzer_1_array_crystal_array_8_loop_index
#define this_box_volume mccchannel_2_analyzer_1_array_crystal_array_8_this_box_volume
#define global_geometry_element mccchannel_2_analyzer_1_array_crystal_array_8_global_geometry_element
#define this_box_storage mccchannel_2_analyzer_1_array_crystal_array_8_this_box_storage
#define material_string mccchannel_2_analyzer_1_array_crystal_array_8_material_string
#define priority mccchannel_2_analyzer_1_array_crystal_array_8_priority
#define xwidth mccchannel_2_analyzer_1_array_crystal_array_8_xwidth
#define yheight mccchannel_2_analyzer_1_array_crystal_array_8_yheight
#define zdepth mccchannel_2_analyzer_1_array_crystal_array_8_zdepth
#define xwidth2 mccchannel_2_analyzer_1_array_crystal_array_8_xwidth2
#define yheight2 mccchannel_2_analyzer_1_array_crystal_array_8_yheight2
#define visualize mccchannel_2_analyzer_1_array_crystal_array_8_visualize
#define target_index mccchannel_2_analyzer_1_array_crystal_array_8_target_index
#define target_x mccchannel_2_analyzer_1_array_crystal_array_8_target_x
#define target_y mccchannel_2_analyzer_1_array_crystal_array_8_target_y
#define target_z mccchannel_2_analyzer_1_array_crystal_array_8_target_z
#define focus_aw mccchannel_2_analyzer_1_array_crystal_array_8_focus_aw
#define focus_ah mccchannel_2_analyzer_1_array_crystal_array_8_focus_ah
#define focus_xw mccchannel_2_analyzer_1_array_crystal_array_8_focus_xw
#define focus_xh mccchannel_2_analyzer_1_array_crystal_array_8_focus_xh
#define focus_r mccchannel_2_analyzer_1_array_crystal_array_8_focus_r
#define p_interact mccchannel_2_analyzer_1_array_crystal_array_8_p_interact
#define mask_string mccchannel_2_analyzer_1_array_crystal_array_8_mask_string
#define mask_setting mccchannel_2_analyzer_1_array_crystal_array_8_mask_setting
#define number_of_activations mccchannel_2_analyzer_1_array_crystal_array_8_number_of_activations
#line 224 "Union_box.comp"
{
// Initializes the focusing system for this volume including input sanitation.
focus_initialize(&this_box_volume.geometry, POS_A_COMP_INDEX(INDEX_CURRENT_COMP+target_index), POS_A_CURRENT_COMP, ROT_A_CURRENT_COMP, target_index, target_x, target_y, target_z, focus_aw, focus_ah, focus_xw, focus_xh, focus_r, NAME_CURRENT_COMP);

// Input sanitation for this geometry
if (xwidth <= 0) {
  printf("\nERROR in Union_box named %s, the xwidth is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (yheight <= 0) {
  printf("\nERROR in Union_box named %s, yheight is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (zdepth <= 0) {
  printf("\nERROR in Union_box named %s, zdepth is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (xwidth2 <= 0 && xwidth2 != -1) {
  printf("\nERROR in Union_box named %s, the xwidth2 is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (yheight2 <= 0 && yheight2 != -1) {
  printf("\nERROR in Union_box named %s, yheight2 is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}

// Use sanitation
if (global_material_list.num_elements == 0) {
  printf("\nERROR: Need to define a material using Union_make_material before using a Union geometry component. \n");
  printf("       %s was defined before first use of Union_make_material.\n",NAME_CURRENT_COMP);
  exit(1);
}

this_box_volume.geometry.is_masked_volume = 0;
this_box_volume.geometry.is_exit_volume = 0;
this_box_volume.geometry.is_mask_volume = 0;
// check if the volume is a mask, if it is the material string is irelevant.
if (mask_string && strlen(mask_string) && strcmp(mask_string, "NULL") && strcmp(mask_string, "0")) {
    // A mask volume is used to limit the extend of other volumes, called the masked volumes. These are specified in the mask_string.
    // In order for a ray to enter a masked volume, it needs to be both in the region covered by that volume AND the mask volume.
    // When more than
    this_box_volume.geometry.mask_mode = 1; // Default is mask mode is ALL
    if (mask_setting && strlen(mask_setting) && strcmp(mask_setting, "NULL") && strcmp(mask_setting, "0")) {
        if (strcmp(mask_setting,"ALL") == 0 || strcmp(mask_setting,"All") == 0) this_box_volume.geometry.mask_mode = 1;
        else if (strcmp(mask_setting,"ANY") == 0 || strcmp(mask_setting,"Any") == 0) this_box_volume.geometry.mask_mode = 2;
        else {
            printf("The mask_mode of component %s is set to %s, but must be either ALL or ANY.\n",NAME_CURRENT_COMP,mask_setting);
            exit(1);
        }
    }
    
    for (loop_index=0;loop_index<global_geometry_list.num_elements;loop_index++) {
        // Add mask list
        if (1 == manual_linking_function(global_geometry_list.elements[loop_index].name,mask_string)) {
            add_element_to_int_list(&this_box_volume.geometry.mask_list,global_geometry_list.elements[loop_index].component_index);
            add_element_to_int_list(&global_geometry_list.elements[loop_index].Volume->geometry.masked_by_list,INDEX_CURRENT_COMP);
            global_geometry_list.elements[loop_index].Volume->geometry.is_masked_volume = 1;
            if (this_box_volume.geometry.mask_mode == 2)
                global_geometry_list.elements[loop_index].Volume->geometry.mask_mode = 2;
            if (this_box_volume.geometry.mask_mode == 1) {
                if (global_geometry_list.elements[loop_index].Volume->geometry.is_masked_volume == 1 && global_geometry_list.elements[loop_index].Volume->geometry.mask_mode != 2)
                    // If more than one mask is added to one volume, the ANY mode overwrites the (default) ALL mode.
                    global_geometry_list.elements[loop_index].Volume->geometry.mask_mode = 1;
            }
            
            found_geometries = 1;
        }
    }
    if (found_geometries == 0) {
        printf("The mask_string in geometry: %s did not find any of the specified volumes in the mask_string %s \n",NAME_CURRENT_COMP,mask_string);
        exit(1);
    }
    this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
    this_box_volume.p_physics->is_vacuum = 0; // Makes this volume a vacuum
    this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
    this_box_volume.p_physics->my_a = 0; // Should not be used.
    sprintf(this_box_volume.p_physics->name,"Mask");
    this_box_volume.geometry.is_mask_volume = 1;
    
    
// Read the material input, or if it lacks, use automatic linking.
} else if (material_string && strlen(material_string) && strcmp(material_string, "NULL") && strcmp(material_string, "0")) {
    // A geometry string was given, use it to determine which material
    if (0 == strcmp(material_string,"vacuum") || 0 == strcmp(material_string,"Vacuum")) {
        // One could have a global physics struct for vacuum instead of creating one for each
        this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
        this_box_volume.p_physics->is_vacuum = 1; // Makes this volume a vacuum
        this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
        this_box_volume.p_physics->my_a = 0; // Should not be used.
        sprintf(this_box_volume.p_physics->name,"Vacuum");
    } else if (0 == strcmp(material_string,"exit") || 0 == strcmp(material_string,"Exit")) {
        // One could have a global physics struct for vacuum instead of creating one for each
        this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
        this_box_volume.p_physics->is_vacuum = 1; // Makes this volume a vacuum
        this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
        this_box_volume.p_physics->my_a = 0; // Should not be used.
        this_box_volume.geometry.is_exit_volume = 1;
        sprintf(this_box_volume.p_physics->name,"Exit");
    } else {
        #ifndef MATERIAL_DETECTOR
            printf("Need to define a material before refering to it in a geometry %s.\n",NAME_CURRENT_COMP);
            exit(1);
        #endif
        for (loop_index=0;loop_index<global_material_list.num_elements;loop_index++) {
            if (0 == strcmp(material_string,global_material_list.elements[loop_index].name)) {
                this_box_volume.p_physics = global_material_list.elements[loop_index].physics;
                break;
            }
            if (loop_index == global_material_list.num_elements-1) {
            printf("\n");
            printf("ERROR: The material string \"%s\" in Union geometry \"%s\" did not match a specified material. \n",material_string,NAME_CURRENT_COMP);
            printf("       The materials available at this point (need to be defined before the geometry): \n");
            for (loop_index=0;loop_index<global_material_list.num_elements;loop_index++)
              printf("         %s\n",global_material_list.elements[loop_index].name);
            printf("\n");
            printf("       It is also possible to use one of the defualt materials avaiable: \n");
            printf("           Vacuum (for a Volume without scattering or absorption)\n");
            printf("           Exit (for a Volume where the ray exits the component if it enters)\n");
            printf("           Mask (for a Volume that masks existing volumes specified in the mask_string\n");
            exit(1);
          }
        }
    }
} else {
    // Automatic linking, simply using the last defined material.
    #ifndef MATERIAL_DETECTOR
        printf("Need to define a material before the geometry to use automatic linking %s.\n",NAME_CURRENT_COMP);
        exit(1);
    #endif
    this_box_volume.p_physics = global_material_list.elements[global_material_list.num_elements-1].physics;
}

sprintf(this_box_volume.name,NAME_CURRENT_COMP);
sprintf(this_box_volume.geometry.shape,"box");
this_box_volume.geometry.priority_value = priority;
this_box_volume.geometry.geometry_p_interact = p_interact;
// Currently the coordinates will be in absolute space.
this_box_volume.geometry.center = POS_A_CURRENT_COMP;

this_box_storage.z_depth = zdepth;
this_box_storage.x_width1 = xwidth;
this_box_storage.y_height1 = yheight;

this_box_storage.is_rectangle = 0;
if (xwidth2 < 0 && yheight2 < 0) this_box_storage.is_rectangle = 1;
if (xwidth == xwidth2 && yheight == yheight2) this_box_storage.is_rectangle = 1;

if (xwidth2 < 0) {
    this_box_storage.x_width2 = xwidth;
    xwidth2 = xwidth;
} else this_box_storage.x_width2 = xwidth2;

if (yheight2 < 0) {
    this_box_storage.y_height2 = yheight;
    yheight2 = yheight;
} else this_box_storage.y_height2 = yheight2;


this_box_storage.normal_vectors[0] = coords_set(0,0,1);
this_box_storage.normal_vectors[1] = coords_set(0,0,1);

// for sides with y component = 0
x_component = 2*zdepth/sqrt((xwidth-xwidth2)*(xwidth-xwidth2)+4*zdepth*zdepth);
z_component = (xwidth-xwidth2)/sqrt(4*zdepth*zdepth+(xwidth-xwidth2)*(xwidth-xwidth2));

this_box_storage.normal_vectors[2] = coords_set(x_component,0,z_component);
this_box_storage.normal_vectors[3] = coords_set(-x_component,0,z_component);

// for sides with x component = 0
y_component = 2*zdepth/sqrt((yheight-yheight2)*(yheight-yheight2)+4*zdepth*zdepth);
z_component = (yheight-yheight2)/sqrt(4*zdepth*zdepth+(yheight-yheight2)*(yheight-yheight2));

this_box_storage.normal_vectors[4] = coords_set(0,y_component,z_component);
this_box_storage.normal_vectors[5] = coords_set(0,-y_component,z_component);

this_box_volume.geometry.visualization_on = visualize;

this_box_volume.geometry.geometry_parameters.p_box_storage = &this_box_storage;

// Assign pointers to functions for intersection with the shape, checking if a point is inside the shape
if (this_box_storage.is_rectangle == 1) {
this_box_volume.geometry.intersect_function = &sample_box_intersect_simple;
this_box_volume.geometry.within_function = &r_within_box_simple;
}
else {
this_box_volume.geometry.intersect_function = &sample_box_intersect_advanced;
this_box_volume.geometry.within_function = &r_within_box_advanced;
}

this_box_volume.geometry.shell_points = &box_shell_points;
this_box_volume.geometry.mcdisplay_function = &mcdisplay_box_function;
this_box_volume.geometry.initialize_from_main_function = &initialize_box_geometry_from_main_component;
this_box_volume.geometry.process_rot_allocated = 0;

this_box_volume.geometry.copy_geometry_parameters = &allocate_box_storage_copy;

rot_copy(this_box_volume.geometry.rotation_matrix,ROT_A_CURRENT_COMP); //check how ROT_R_CURRENT_COMP would work
rot_transpose(ROT_A_CURRENT_COMP,this_box_volume.geometry.transpose_rotation_matrix);

// Initialize loggers
this_box_volume.loggers.num_elements = 0;

// packing the information into the global_geometry_element, which is then included in the global_geometry_list.
sprintf(global_geometry_element.name,NAME_CURRENT_COMP);
global_geometry_element.activation_counter = number_of_activations;
global_geometry_element.component_index = INDEX_CURRENT_COMP;
global_geometry_element.Volume = &this_box_volume; // Would be nicer if this m was a pointer, now we have the (small) data two places
add_element_to_geometry_list(&global_geometry_list,global_geometry_element);
}
#line 185555 "MACS_sample_kidney_box.c"
#undef number_of_activations
#undef mask_setting
#undef mask_string
#undef p_interact
#undef focus_r
#undef focus_xh
#undef focus_xw
#undef focus_ah
#undef focus_aw
#undef target_z
#undef target_y
#undef target_x
#undef target_index
#undef visualize
#undef yheight2
#undef xwidth2
#undef zdepth
#undef yheight
#undef xwidth
#undef priority
#undef material_string
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

  /* Initializations for component channel_2_analyzer_2_center. */
  SIG_MESSAGE("channel_2_analyzer_2_center (Init)");

  /* Initializations for component channel_2_analyzer_2_rotated. */
  SIG_MESSAGE("channel_2_analyzer_2_rotated (Init)");

  /* Initializations for component channel_2_analyzer_2_array_crystal_array_0. */
  SIG_MESSAGE("channel_2_analyzer_2_array_crystal_array_0 (Init)");
#define mccompcurname  channel_2_analyzer_2_array_crystal_array_0
#define mccompcurtype  Union_box
#define mccompcurindex 217
#define loop_index mccchannel_2_analyzer_2_array_crystal_array_0_loop_index
#define this_box_volume mccchannel_2_analyzer_2_array_crystal_array_0_this_box_volume
#define global_geometry_element mccchannel_2_analyzer_2_array_crystal_array_0_global_geometry_element
#define this_box_storage mccchannel_2_analyzer_2_array_crystal_array_0_this_box_storage
#define material_string mccchannel_2_analyzer_2_array_crystal_array_0_material_string
#define priority mccchannel_2_analyzer_2_array_crystal_array_0_priority
#define xwidth mccchannel_2_analyzer_2_array_crystal_array_0_xwidth
#define yheight mccchannel_2_analyzer_2_array_crystal_array_0_yheight
#define zdepth mccchannel_2_analyzer_2_array_crystal_array_0_zdepth
#define xwidth2 mccchannel_2_analyzer_2_array_crystal_array_0_xwidth2
#define yheight2 mccchannel_2_analyzer_2_array_crystal_array_0_yheight2
#define visualize mccchannel_2_analyzer_2_array_crystal_array_0_visualize
#define target_index mccchannel_2_analyzer_2_array_crystal_array_0_target_index
#define target_x mccchannel_2_analyzer_2_array_crystal_array_0_target_x
#define target_y mccchannel_2_analyzer_2_array_crystal_array_0_target_y
#define target_z mccchannel_2_analyzer_2_array_crystal_array_0_target_z
#define focus_aw mccchannel_2_analyzer_2_array_crystal_array_0_focus_aw
#define focus_ah mccchannel_2_analyzer_2_array_crystal_array_0_focus_ah
#define focus_xw mccchannel_2_analyzer_2_array_crystal_array_0_focus_xw
#define focus_xh mccchannel_2_analyzer_2_array_crystal_array_0_focus_xh
#define focus_r mccchannel_2_analyzer_2_array_crystal_array_0_focus_r
#define p_interact mccchannel_2_analyzer_2_array_crystal_array_0_p_interact
#define mask_string mccchannel_2_analyzer_2_array_crystal_array_0_mask_string
#define mask_setting mccchannel_2_analyzer_2_array_crystal_array_0_mask_setting
#define number_of_activations mccchannel_2_analyzer_2_array_crystal_array_0_number_of_activations
#line 224 "Union_box.comp"
{
// Initializes the focusing system for this volume including input sanitation.
focus_initialize(&this_box_volume.geometry, POS_A_COMP_INDEX(INDEX_CURRENT_COMP+target_index), POS_A_CURRENT_COMP, ROT_A_CURRENT_COMP, target_index, target_x, target_y, target_z, focus_aw, focus_ah, focus_xw, focus_xh, focus_r, NAME_CURRENT_COMP);

// Input sanitation for this geometry
if (xwidth <= 0) {
  printf("\nERROR in Union_box named %s, the xwidth is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (yheight <= 0) {
  printf("\nERROR in Union_box named %s, yheight is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (zdepth <= 0) {
  printf("\nERROR in Union_box named %s, zdepth is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (xwidth2 <= 0 && xwidth2 != -1) {
  printf("\nERROR in Union_box named %s, the xwidth2 is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (yheight2 <= 0 && yheight2 != -1) {
  printf("\nERROR in Union_box named %s, yheight2 is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}

// Use sanitation
if (global_material_list.num_elements == 0) {
  printf("\nERROR: Need to define a material using Union_make_material before using a Union geometry component. \n");
  printf("       %s was defined before first use of Union_make_material.\n",NAME_CURRENT_COMP);
  exit(1);
}

this_box_volume.geometry.is_masked_volume = 0;
this_box_volume.geometry.is_exit_volume = 0;
this_box_volume.geometry.is_mask_volume = 0;
// check if the volume is a mask, if it is the material string is irelevant.
if (mask_string && strlen(mask_string) && strcmp(mask_string, "NULL") && strcmp(mask_string, "0")) {
    // A mask volume is used to limit the extend of other volumes, called the masked volumes. These are specified in the mask_string.
    // In order for a ray to enter a masked volume, it needs to be both in the region covered by that volume AND the mask volume.
    // When more than
    this_box_volume.geometry.mask_mode = 1; // Default is mask mode is ALL
    if (mask_setting && strlen(mask_setting) && strcmp(mask_setting, "NULL") && strcmp(mask_setting, "0")) {
        if (strcmp(mask_setting,"ALL") == 0 || strcmp(mask_setting,"All") == 0) this_box_volume.geometry.mask_mode = 1;
        else if (strcmp(mask_setting,"ANY") == 0 || strcmp(mask_setting,"Any") == 0) this_box_volume.geometry.mask_mode = 2;
        else {
            printf("The mask_mode of component %s is set to %s, but must be either ALL or ANY.\n",NAME_CURRENT_COMP,mask_setting);
            exit(1);
        }
    }
    
    for (loop_index=0;loop_index<global_geometry_list.num_elements;loop_index++) {
        // Add mask list
        if (1 == manual_linking_function(global_geometry_list.elements[loop_index].name,mask_string)) {
            add_element_to_int_list(&this_box_volume.geometry.mask_list,global_geometry_list.elements[loop_index].component_index);
            add_element_to_int_list(&global_geometry_list.elements[loop_index].Volume->geometry.masked_by_list,INDEX_CURRENT_COMP);
            global_geometry_list.elements[loop_index].Volume->geometry.is_masked_volume = 1;
            if (this_box_volume.geometry.mask_mode == 2)
                global_geometry_list.elements[loop_index].Volume->geometry.mask_mode = 2;
            if (this_box_volume.geometry.mask_mode == 1) {
                if (global_geometry_list.elements[loop_index].Volume->geometry.is_masked_volume == 1 && global_geometry_list.elements[loop_index].Volume->geometry.mask_mode != 2)
                    // If more than one mask is added to one volume, the ANY mode overwrites the (default) ALL mode.
                    global_geometry_list.elements[loop_index].Volume->geometry.mask_mode = 1;
            }
            
            found_geometries = 1;
        }
    }
    if (found_geometries == 0) {
        printf("The mask_string in geometry: %s did not find any of the specified volumes in the mask_string %s \n",NAME_CURRENT_COMP,mask_string);
        exit(1);
    }
    this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
    this_box_volume.p_physics->is_vacuum = 0; // Makes this volume a vacuum
    this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
    this_box_volume.p_physics->my_a = 0; // Should not be used.
    sprintf(this_box_volume.p_physics->name,"Mask");
    this_box_volume.geometry.is_mask_volume = 1;
    
    
// Read the material input, or if it lacks, use automatic linking.
} else if (material_string && strlen(material_string) && strcmp(material_string, "NULL") && strcmp(material_string, "0")) {
    // A geometry string was given, use it to determine which material
    if (0 == strcmp(material_string,"vacuum") || 0 == strcmp(material_string,"Vacuum")) {
        // One could have a global physics struct for vacuum instead of creating one for each
        this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
        this_box_volume.p_physics->is_vacuum = 1; // Makes this volume a vacuum
        this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
        this_box_volume.p_physics->my_a = 0; // Should not be used.
        sprintf(this_box_volume.p_physics->name,"Vacuum");
    } else if (0 == strcmp(material_string,"exit") || 0 == strcmp(material_string,"Exit")) {
        // One could have a global physics struct for vacuum instead of creating one for each
        this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
        this_box_volume.p_physics->is_vacuum = 1; // Makes this volume a vacuum
        this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
        this_box_volume.p_physics->my_a = 0; // Should not be used.
        this_box_volume.geometry.is_exit_volume = 1;
        sprintf(this_box_volume.p_physics->name,"Exit");
    } else {
        #ifndef MATERIAL_DETECTOR
            printf("Need to define a material before refering to it in a geometry %s.\n",NAME_CURRENT_COMP);
            exit(1);
        #endif
        for (loop_index=0;loop_index<global_material_list.num_elements;loop_index++) {
            if (0 == strcmp(material_string,global_material_list.elements[loop_index].name)) {
                this_box_volume.p_physics = global_material_list.elements[loop_index].physics;
                break;
            }
            if (loop_index == global_material_list.num_elements-1) {
            printf("\n");
            printf("ERROR: The material string \"%s\" in Union geometry \"%s\" did not match a specified material. \n",material_string,NAME_CURRENT_COMP);
            printf("       The materials available at this point (need to be defined before the geometry): \n");
            for (loop_index=0;loop_index<global_material_list.num_elements;loop_index++)
              printf("         %s\n",global_material_list.elements[loop_index].name);
            printf("\n");
            printf("       It is also possible to use one of the defualt materials avaiable: \n");
            printf("           Vacuum (for a Volume without scattering or absorption)\n");
            printf("           Exit (for a Volume where the ray exits the component if it enters)\n");
            printf("           Mask (for a Volume that masks existing volumes specified in the mask_string\n");
            exit(1);
          }
        }
    }
} else {
    // Automatic linking, simply using the last defined material.
    #ifndef MATERIAL_DETECTOR
        printf("Need to define a material before the geometry to use automatic linking %s.\n",NAME_CURRENT_COMP);
        exit(1);
    #endif
    this_box_volume.p_physics = global_material_list.elements[global_material_list.num_elements-1].physics;
}

sprintf(this_box_volume.name,NAME_CURRENT_COMP);
sprintf(this_box_volume.geometry.shape,"box");
this_box_volume.geometry.priority_value = priority;
this_box_volume.geometry.geometry_p_interact = p_interact;
// Currently the coordinates will be in absolute space.
this_box_volume.geometry.center = POS_A_CURRENT_COMP;

this_box_storage.z_depth = zdepth;
this_box_storage.x_width1 = xwidth;
this_box_storage.y_height1 = yheight;

this_box_storage.is_rectangle = 0;
if (xwidth2 < 0 && yheight2 < 0) this_box_storage.is_rectangle = 1;
if (xwidth == xwidth2 && yheight == yheight2) this_box_storage.is_rectangle = 1;

if (xwidth2 < 0) {
    this_box_storage.x_width2 = xwidth;
    xwidth2 = xwidth;
} else this_box_storage.x_width2 = xwidth2;

if (yheight2 < 0) {
    this_box_storage.y_height2 = yheight;
    yheight2 = yheight;
} else this_box_storage.y_height2 = yheight2;


this_box_storage.normal_vectors[0] = coords_set(0,0,1);
this_box_storage.normal_vectors[1] = coords_set(0,0,1);

// for sides with y component = 0
x_component = 2*zdepth/sqrt((xwidth-xwidth2)*(xwidth-xwidth2)+4*zdepth*zdepth);
z_component = (xwidth-xwidth2)/sqrt(4*zdepth*zdepth+(xwidth-xwidth2)*(xwidth-xwidth2));

this_box_storage.normal_vectors[2] = coords_set(x_component,0,z_component);
this_box_storage.normal_vectors[3] = coords_set(-x_component,0,z_component);

// for sides with x component = 0
y_component = 2*zdepth/sqrt((yheight-yheight2)*(yheight-yheight2)+4*zdepth*zdepth);
z_component = (yheight-yheight2)/sqrt(4*zdepth*zdepth+(yheight-yheight2)*(yheight-yheight2));

this_box_storage.normal_vectors[4] = coords_set(0,y_component,z_component);
this_box_storage.normal_vectors[5] = coords_set(0,-y_component,z_component);

this_box_volume.geometry.visualization_on = visualize;

this_box_volume.geometry.geometry_parameters.p_box_storage = &this_box_storage;

// Assign pointers to functions for intersection with the shape, checking if a point is inside the shape
if (this_box_storage.is_rectangle == 1) {
this_box_volume.geometry.intersect_function = &sample_box_intersect_simple;
this_box_volume.geometry.within_function = &r_within_box_simple;
}
else {
this_box_volume.geometry.intersect_function = &sample_box_intersect_advanced;
this_box_volume.geometry.within_function = &r_within_box_advanced;
}

this_box_volume.geometry.shell_points = &box_shell_points;
this_box_volume.geometry.mcdisplay_function = &mcdisplay_box_function;
this_box_volume.geometry.initialize_from_main_function = &initialize_box_geometry_from_main_component;
this_box_volume.geometry.process_rot_allocated = 0;

this_box_volume.geometry.copy_geometry_parameters = &allocate_box_storage_copy;

rot_copy(this_box_volume.geometry.rotation_matrix,ROT_A_CURRENT_COMP); //check how ROT_R_CURRENT_COMP would work
rot_transpose(ROT_A_CURRENT_COMP,this_box_volume.geometry.transpose_rotation_matrix);

// Initialize loggers
this_box_volume.loggers.num_elements = 0;

// packing the information into the global_geometry_element, which is then included in the global_geometry_list.
sprintf(global_geometry_element.name,NAME_CURRENT_COMP);
global_geometry_element.activation_counter = number_of_activations;
global_geometry_element.component_index = INDEX_CURRENT_COMP;
global_geometry_element.Volume = &this_box_volume; // Would be nicer if this m was a pointer, now we have the (small) data two places
add_element_to_geometry_list(&global_geometry_list,global_geometry_element);
}
#line 185831 "MACS_sample_kidney_box.c"
#undef number_of_activations
#undef mask_setting
#undef mask_string
#undef p_interact
#undef focus_r
#undef focus_xh
#undef focus_xw
#undef focus_ah
#undef focus_aw
#undef target_z
#undef target_y
#undef target_x
#undef target_index
#undef visualize
#undef yheight2
#undef xwidth2
#undef zdepth
#undef yheight
#undef xwidth
#undef priority
#undef material_string
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

  /* Initializations for component channel_2_analyzer_2_array_crystal_array_1. */
  SIG_MESSAGE("channel_2_analyzer_2_array_crystal_array_1 (Init)");
#define mccompcurname  channel_2_analyzer_2_array_crystal_array_1
#define mccompcurtype  Union_box
#define mccompcurindex 218
#define loop_index mccchannel_2_analyzer_2_array_crystal_array_1_loop_index
#define this_box_volume mccchannel_2_analyzer_2_array_crystal_array_1_this_box_volume
#define global_geometry_element mccchannel_2_analyzer_2_array_crystal_array_1_global_geometry_element
#define this_box_storage mccchannel_2_analyzer_2_array_crystal_array_1_this_box_storage
#define material_string mccchannel_2_analyzer_2_array_crystal_array_1_material_string
#define priority mccchannel_2_analyzer_2_array_crystal_array_1_priority
#define xwidth mccchannel_2_analyzer_2_array_crystal_array_1_xwidth
#define yheight mccchannel_2_analyzer_2_array_crystal_array_1_yheight
#define zdepth mccchannel_2_analyzer_2_array_crystal_array_1_zdepth
#define xwidth2 mccchannel_2_analyzer_2_array_crystal_array_1_xwidth2
#define yheight2 mccchannel_2_analyzer_2_array_crystal_array_1_yheight2
#define visualize mccchannel_2_analyzer_2_array_crystal_array_1_visualize
#define target_index mccchannel_2_analyzer_2_array_crystal_array_1_target_index
#define target_x mccchannel_2_analyzer_2_array_crystal_array_1_target_x
#define target_y mccchannel_2_analyzer_2_array_crystal_array_1_target_y
#define target_z mccchannel_2_analyzer_2_array_crystal_array_1_target_z
#define focus_aw mccchannel_2_analyzer_2_array_crystal_array_1_focus_aw
#define focus_ah mccchannel_2_analyzer_2_array_crystal_array_1_focus_ah
#define focus_xw mccchannel_2_analyzer_2_array_crystal_array_1_focus_xw
#define focus_xh mccchannel_2_analyzer_2_array_crystal_array_1_focus_xh
#define focus_r mccchannel_2_analyzer_2_array_crystal_array_1_focus_r
#define p_interact mccchannel_2_analyzer_2_array_crystal_array_1_p_interact
#define mask_string mccchannel_2_analyzer_2_array_crystal_array_1_mask_string
#define mask_setting mccchannel_2_analyzer_2_array_crystal_array_1_mask_setting
#define number_of_activations mccchannel_2_analyzer_2_array_crystal_array_1_number_of_activations
#line 224 "Union_box.comp"
{
// Initializes the focusing system for this volume including input sanitation.
focus_initialize(&this_box_volume.geometry, POS_A_COMP_INDEX(INDEX_CURRENT_COMP+target_index), POS_A_CURRENT_COMP, ROT_A_CURRENT_COMP, target_index, target_x, target_y, target_z, focus_aw, focus_ah, focus_xw, focus_xh, focus_r, NAME_CURRENT_COMP);

// Input sanitation for this geometry
if (xwidth <= 0) {
  printf("\nERROR in Union_box named %s, the xwidth is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (yheight <= 0) {
  printf("\nERROR in Union_box named %s, yheight is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (zdepth <= 0) {
  printf("\nERROR in Union_box named %s, zdepth is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (xwidth2 <= 0 && xwidth2 != -1) {
  printf("\nERROR in Union_box named %s, the xwidth2 is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (yheight2 <= 0 && yheight2 != -1) {
  printf("\nERROR in Union_box named %s, yheight2 is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}

// Use sanitation
if (global_material_list.num_elements == 0) {
  printf("\nERROR: Need to define a material using Union_make_material before using a Union geometry component. \n");
  printf("       %s was defined before first use of Union_make_material.\n",NAME_CURRENT_COMP);
  exit(1);
}

this_box_volume.geometry.is_masked_volume = 0;
this_box_volume.geometry.is_exit_volume = 0;
this_box_volume.geometry.is_mask_volume = 0;
// check if the volume is a mask, if it is the material string is irelevant.
if (mask_string && strlen(mask_string) && strcmp(mask_string, "NULL") && strcmp(mask_string, "0")) {
    // A mask volume is used to limit the extend of other volumes, called the masked volumes. These are specified in the mask_string.
    // In order for a ray to enter a masked volume, it needs to be both in the region covered by that volume AND the mask volume.
    // When more than
    this_box_volume.geometry.mask_mode = 1; // Default is mask mode is ALL
    if (mask_setting && strlen(mask_setting) && strcmp(mask_setting, "NULL") && strcmp(mask_setting, "0")) {
        if (strcmp(mask_setting,"ALL") == 0 || strcmp(mask_setting,"All") == 0) this_box_volume.geometry.mask_mode = 1;
        else if (strcmp(mask_setting,"ANY") == 0 || strcmp(mask_setting,"Any") == 0) this_box_volume.geometry.mask_mode = 2;
        else {
            printf("The mask_mode of component %s is set to %s, but must be either ALL or ANY.\n",NAME_CURRENT_COMP,mask_setting);
            exit(1);
        }
    }
    
    for (loop_index=0;loop_index<global_geometry_list.num_elements;loop_index++) {
        // Add mask list
        if (1 == manual_linking_function(global_geometry_list.elements[loop_index].name,mask_string)) {
            add_element_to_int_list(&this_box_volume.geometry.mask_list,global_geometry_list.elements[loop_index].component_index);
            add_element_to_int_list(&global_geometry_list.elements[loop_index].Volume->geometry.masked_by_list,INDEX_CURRENT_COMP);
            global_geometry_list.elements[loop_index].Volume->geometry.is_masked_volume = 1;
            if (this_box_volume.geometry.mask_mode == 2)
                global_geometry_list.elements[loop_index].Volume->geometry.mask_mode = 2;
            if (this_box_volume.geometry.mask_mode == 1) {
                if (global_geometry_list.elements[loop_index].Volume->geometry.is_masked_volume == 1 && global_geometry_list.elements[loop_index].Volume->geometry.mask_mode != 2)
                    // If more than one mask is added to one volume, the ANY mode overwrites the (default) ALL mode.
                    global_geometry_list.elements[loop_index].Volume->geometry.mask_mode = 1;
            }
            
            found_geometries = 1;
        }
    }
    if (found_geometries == 0) {
        printf("The mask_string in geometry: %s did not find any of the specified volumes in the mask_string %s \n",NAME_CURRENT_COMP,mask_string);
        exit(1);
    }
    this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
    this_box_volume.p_physics->is_vacuum = 0; // Makes this volume a vacuum
    this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
    this_box_volume.p_physics->my_a = 0; // Should not be used.
    sprintf(this_box_volume.p_physics->name,"Mask");
    this_box_volume.geometry.is_mask_volume = 1;
    
    
// Read the material input, or if it lacks, use automatic linking.
} else if (material_string && strlen(material_string) && strcmp(material_string, "NULL") && strcmp(material_string, "0")) {
    // A geometry string was given, use it to determine which material
    if (0 == strcmp(material_string,"vacuum") || 0 == strcmp(material_string,"Vacuum")) {
        // One could have a global physics struct for vacuum instead of creating one for each
        this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
        this_box_volume.p_physics->is_vacuum = 1; // Makes this volume a vacuum
        this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
        this_box_volume.p_physics->my_a = 0; // Should not be used.
        sprintf(this_box_volume.p_physics->name,"Vacuum");
    } else if (0 == strcmp(material_string,"exit") || 0 == strcmp(material_string,"Exit")) {
        // One could have a global physics struct for vacuum instead of creating one for each
        this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
        this_box_volume.p_physics->is_vacuum = 1; // Makes this volume a vacuum
        this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
        this_box_volume.p_physics->my_a = 0; // Should not be used.
        this_box_volume.geometry.is_exit_volume = 1;
        sprintf(this_box_volume.p_physics->name,"Exit");
    } else {
        #ifndef MATERIAL_DETECTOR
            printf("Need to define a material before refering to it in a geometry %s.\n",NAME_CURRENT_COMP);
            exit(1);
        #endif
        for (loop_index=0;loop_index<global_material_list.num_elements;loop_index++) {
            if (0 == strcmp(material_string,global_material_list.elements[loop_index].name)) {
                this_box_volume.p_physics = global_material_list.elements[loop_index].physics;
                break;
            }
            if (loop_index == global_material_list.num_elements-1) {
            printf("\n");
            printf("ERROR: The material string \"%s\" in Union geometry \"%s\" did not match a specified material. \n",material_string,NAME_CURRENT_COMP);
            printf("       The materials available at this point (need to be defined before the geometry): \n");
            for (loop_index=0;loop_index<global_material_list.num_elements;loop_index++)
              printf("         %s\n",global_material_list.elements[loop_index].name);
            printf("\n");
            printf("       It is also possible to use one of the defualt materials avaiable: \n");
            printf("           Vacuum (for a Volume without scattering or absorption)\n");
            printf("           Exit (for a Volume where the ray exits the component if it enters)\n");
            printf("           Mask (for a Volume that masks existing volumes specified in the mask_string\n");
            exit(1);
          }
        }
    }
} else {
    // Automatic linking, simply using the last defined material.
    #ifndef MATERIAL_DETECTOR
        printf("Need to define a material before the geometry to use automatic linking %s.\n",NAME_CURRENT_COMP);
        exit(1);
    #endif
    this_box_volume.p_physics = global_material_list.elements[global_material_list.num_elements-1].physics;
}

sprintf(this_box_volume.name,NAME_CURRENT_COMP);
sprintf(this_box_volume.geometry.shape,"box");
this_box_volume.geometry.priority_value = priority;
this_box_volume.geometry.geometry_p_interact = p_interact;
// Currently the coordinates will be in absolute space.
this_box_volume.geometry.center = POS_A_CURRENT_COMP;

this_box_storage.z_depth = zdepth;
this_box_storage.x_width1 = xwidth;
this_box_storage.y_height1 = yheight;

this_box_storage.is_rectangle = 0;
if (xwidth2 < 0 && yheight2 < 0) this_box_storage.is_rectangle = 1;
if (xwidth == xwidth2 && yheight == yheight2) this_box_storage.is_rectangle = 1;

if (xwidth2 < 0) {
    this_box_storage.x_width2 = xwidth;
    xwidth2 = xwidth;
} else this_box_storage.x_width2 = xwidth2;

if (yheight2 < 0) {
    this_box_storage.y_height2 = yheight;
    yheight2 = yheight;
} else this_box_storage.y_height2 = yheight2;


this_box_storage.normal_vectors[0] = coords_set(0,0,1);
this_box_storage.normal_vectors[1] = coords_set(0,0,1);

// for sides with y component = 0
x_component = 2*zdepth/sqrt((xwidth-xwidth2)*(xwidth-xwidth2)+4*zdepth*zdepth);
z_component = (xwidth-xwidth2)/sqrt(4*zdepth*zdepth+(xwidth-xwidth2)*(xwidth-xwidth2));

this_box_storage.normal_vectors[2] = coords_set(x_component,0,z_component);
this_box_storage.normal_vectors[3] = coords_set(-x_component,0,z_component);

// for sides with x component = 0
y_component = 2*zdepth/sqrt((yheight-yheight2)*(yheight-yheight2)+4*zdepth*zdepth);
z_component = (yheight-yheight2)/sqrt(4*zdepth*zdepth+(yheight-yheight2)*(yheight-yheight2));

this_box_storage.normal_vectors[4] = coords_set(0,y_component,z_component);
this_box_storage.normal_vectors[5] = coords_set(0,-y_component,z_component);

this_box_volume.geometry.visualization_on = visualize;

this_box_volume.geometry.geometry_parameters.p_box_storage = &this_box_storage;

// Assign pointers to functions for intersection with the shape, checking if a point is inside the shape
if (this_box_storage.is_rectangle == 1) {
this_box_volume.geometry.intersect_function = &sample_box_intersect_simple;
this_box_volume.geometry.within_function = &r_within_box_simple;
}
else {
this_box_volume.geometry.intersect_function = &sample_box_intersect_advanced;
this_box_volume.geometry.within_function = &r_within_box_advanced;
}

this_box_volume.geometry.shell_points = &box_shell_points;
this_box_volume.geometry.mcdisplay_function = &mcdisplay_box_function;
this_box_volume.geometry.initialize_from_main_function = &initialize_box_geometry_from_main_component;
this_box_volume.geometry.process_rot_allocated = 0;

this_box_volume.geometry.copy_geometry_parameters = &allocate_box_storage_copy;

rot_copy(this_box_volume.geometry.rotation_matrix,ROT_A_CURRENT_COMP); //check how ROT_R_CURRENT_COMP would work
rot_transpose(ROT_A_CURRENT_COMP,this_box_volume.geometry.transpose_rotation_matrix);

// Initialize loggers
this_box_volume.loggers.num_elements = 0;

// packing the information into the global_geometry_element, which is then included in the global_geometry_list.
sprintf(global_geometry_element.name,NAME_CURRENT_COMP);
global_geometry_element.activation_counter = number_of_activations;
global_geometry_element.component_index = INDEX_CURRENT_COMP;
global_geometry_element.Volume = &this_box_volume; // Would be nicer if this m was a pointer, now we have the (small) data two places
add_element_to_geometry_list(&global_geometry_list,global_geometry_element);
}
#line 186101 "MACS_sample_kidney_box.c"
#undef number_of_activations
#undef mask_setting
#undef mask_string
#undef p_interact
#undef focus_r
#undef focus_xh
#undef focus_xw
#undef focus_ah
#undef focus_aw
#undef target_z
#undef target_y
#undef target_x
#undef target_index
#undef visualize
#undef yheight2
#undef xwidth2
#undef zdepth
#undef yheight
#undef xwidth
#undef priority
#undef material_string
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

  /* Initializations for component channel_2_analyzer_2_array_crystal_array_2. */
  SIG_MESSAGE("channel_2_analyzer_2_array_crystal_array_2 (Init)");
#define mccompcurname  channel_2_analyzer_2_array_crystal_array_2
#define mccompcurtype  Union_box
#define mccompcurindex 219
#define loop_index mccchannel_2_analyzer_2_array_crystal_array_2_loop_index
#define this_box_volume mccchannel_2_analyzer_2_array_crystal_array_2_this_box_volume
#define global_geometry_element mccchannel_2_analyzer_2_array_crystal_array_2_global_geometry_element
#define this_box_storage mccchannel_2_analyzer_2_array_crystal_array_2_this_box_storage
#define material_string mccchannel_2_analyzer_2_array_crystal_array_2_material_string
#define priority mccchannel_2_analyzer_2_array_crystal_array_2_priority
#define xwidth mccchannel_2_analyzer_2_array_crystal_array_2_xwidth
#define yheight mccchannel_2_analyzer_2_array_crystal_array_2_yheight
#define zdepth mccchannel_2_analyzer_2_array_crystal_array_2_zdepth
#define xwidth2 mccchannel_2_analyzer_2_array_crystal_array_2_xwidth2
#define yheight2 mccchannel_2_analyzer_2_array_crystal_array_2_yheight2
#define visualize mccchannel_2_analyzer_2_array_crystal_array_2_visualize
#define target_index mccchannel_2_analyzer_2_array_crystal_array_2_target_index
#define target_x mccchannel_2_analyzer_2_array_crystal_array_2_target_x
#define target_y mccchannel_2_analyzer_2_array_crystal_array_2_target_y
#define target_z mccchannel_2_analyzer_2_array_crystal_array_2_target_z
#define focus_aw mccchannel_2_analyzer_2_array_crystal_array_2_focus_aw
#define focus_ah mccchannel_2_analyzer_2_array_crystal_array_2_focus_ah
#define focus_xw mccchannel_2_analyzer_2_array_crystal_array_2_focus_xw
#define focus_xh mccchannel_2_analyzer_2_array_crystal_array_2_focus_xh
#define focus_r mccchannel_2_analyzer_2_array_crystal_array_2_focus_r
#define p_interact mccchannel_2_analyzer_2_array_crystal_array_2_p_interact
#define mask_string mccchannel_2_analyzer_2_array_crystal_array_2_mask_string
#define mask_setting mccchannel_2_analyzer_2_array_crystal_array_2_mask_setting
#define number_of_activations mccchannel_2_analyzer_2_array_crystal_array_2_number_of_activations
#line 224 "Union_box.comp"
{
// Initializes the focusing system for this volume including input sanitation.
focus_initialize(&this_box_volume.geometry, POS_A_COMP_INDEX(INDEX_CURRENT_COMP+target_index), POS_A_CURRENT_COMP, ROT_A_CURRENT_COMP, target_index, target_x, target_y, target_z, focus_aw, focus_ah, focus_xw, focus_xh, focus_r, NAME_CURRENT_COMP);

// Input sanitation for this geometry
if (xwidth <= 0) {
  printf("\nERROR in Union_box named %s, the xwidth is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (yheight <= 0) {
  printf("\nERROR in Union_box named %s, yheight is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (zdepth <= 0) {
  printf("\nERROR in Union_box named %s, zdepth is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (xwidth2 <= 0 && xwidth2 != -1) {
  printf("\nERROR in Union_box named %s, the xwidth2 is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (yheight2 <= 0 && yheight2 != -1) {
  printf("\nERROR in Union_box named %s, yheight2 is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}

// Use sanitation
if (global_material_list.num_elements == 0) {
  printf("\nERROR: Need to define a material using Union_make_material before using a Union geometry component. \n");
  printf("       %s was defined before first use of Union_make_material.\n",NAME_CURRENT_COMP);
  exit(1);
}

this_box_volume.geometry.is_masked_volume = 0;
this_box_volume.geometry.is_exit_volume = 0;
this_box_volume.geometry.is_mask_volume = 0;
// check if the volume is a mask, if it is the material string is irelevant.
if (mask_string && strlen(mask_string) && strcmp(mask_string, "NULL") && strcmp(mask_string, "0")) {
    // A mask volume is used to limit the extend of other volumes, called the masked volumes. These are specified in the mask_string.
    // In order for a ray to enter a masked volume, it needs to be both in the region covered by that volume AND the mask volume.
    // When more than
    this_box_volume.geometry.mask_mode = 1; // Default is mask mode is ALL
    if (mask_setting && strlen(mask_setting) && strcmp(mask_setting, "NULL") && strcmp(mask_setting, "0")) {
        if (strcmp(mask_setting,"ALL") == 0 || strcmp(mask_setting,"All") == 0) this_box_volume.geometry.mask_mode = 1;
        else if (strcmp(mask_setting,"ANY") == 0 || strcmp(mask_setting,"Any") == 0) this_box_volume.geometry.mask_mode = 2;
        else {
            printf("The mask_mode of component %s is set to %s, but must be either ALL or ANY.\n",NAME_CURRENT_COMP,mask_setting);
            exit(1);
        }
    }
    
    for (loop_index=0;loop_index<global_geometry_list.num_elements;loop_index++) {
        // Add mask list
        if (1 == manual_linking_function(global_geometry_list.elements[loop_index].name,mask_string)) {
            add_element_to_int_list(&this_box_volume.geometry.mask_list,global_geometry_list.elements[loop_index].component_index);
            add_element_to_int_list(&global_geometry_list.elements[loop_index].Volume->geometry.masked_by_list,INDEX_CURRENT_COMP);
            global_geometry_list.elements[loop_index].Volume->geometry.is_masked_volume = 1;
            if (this_box_volume.geometry.mask_mode == 2)
                global_geometry_list.elements[loop_index].Volume->geometry.mask_mode = 2;
            if (this_box_volume.geometry.mask_mode == 1) {
                if (global_geometry_list.elements[loop_index].Volume->geometry.is_masked_volume == 1 && global_geometry_list.elements[loop_index].Volume->geometry.mask_mode != 2)
                    // If more than one mask is added to one volume, the ANY mode overwrites the (default) ALL mode.
                    global_geometry_list.elements[loop_index].Volume->geometry.mask_mode = 1;
            }
            
            found_geometries = 1;
        }
    }
    if (found_geometries == 0) {
        printf("The mask_string in geometry: %s did not find any of the specified volumes in the mask_string %s \n",NAME_CURRENT_COMP,mask_string);
        exit(1);
    }
    this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
    this_box_volume.p_physics->is_vacuum = 0; // Makes this volume a vacuum
    this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
    this_box_volume.p_physics->my_a = 0; // Should not be used.
    sprintf(this_box_volume.p_physics->name,"Mask");
    this_box_volume.geometry.is_mask_volume = 1;
    
    
// Read the material input, or if it lacks, use automatic linking.
} else if (material_string && strlen(material_string) && strcmp(material_string, "NULL") && strcmp(material_string, "0")) {
    // A geometry string was given, use it to determine which material
    if (0 == strcmp(material_string,"vacuum") || 0 == strcmp(material_string,"Vacuum")) {
        // One could have a global physics struct for vacuum instead of creating one for each
        this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
        this_box_volume.p_physics->is_vacuum = 1; // Makes this volume a vacuum
        this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
        this_box_volume.p_physics->my_a = 0; // Should not be used.
        sprintf(this_box_volume.p_physics->name,"Vacuum");
    } else if (0 == strcmp(material_string,"exit") || 0 == strcmp(material_string,"Exit")) {
        // One could have a global physics struct for vacuum instead of creating one for each
        this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
        this_box_volume.p_physics->is_vacuum = 1; // Makes this volume a vacuum
        this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
        this_box_volume.p_physics->my_a = 0; // Should not be used.
        this_box_volume.geometry.is_exit_volume = 1;
        sprintf(this_box_volume.p_physics->name,"Exit");
    } else {
        #ifndef MATERIAL_DETECTOR
            printf("Need to define a material before refering to it in a geometry %s.\n",NAME_CURRENT_COMP);
            exit(1);
        #endif
        for (loop_index=0;loop_index<global_material_list.num_elements;loop_index++) {
            if (0 == strcmp(material_string,global_material_list.elements[loop_index].name)) {
                this_box_volume.p_physics = global_material_list.elements[loop_index].physics;
                break;
            }
            if (loop_index == global_material_list.num_elements-1) {
            printf("\n");
            printf("ERROR: The material string \"%s\" in Union geometry \"%s\" did not match a specified material. \n",material_string,NAME_CURRENT_COMP);
            printf("       The materials available at this point (need to be defined before the geometry): \n");
            for (loop_index=0;loop_index<global_material_list.num_elements;loop_index++)
              printf("         %s\n",global_material_list.elements[loop_index].name);
            printf("\n");
            printf("       It is also possible to use one of the defualt materials avaiable: \n");
            printf("           Vacuum (for a Volume without scattering or absorption)\n");
            printf("           Exit (for a Volume where the ray exits the component if it enters)\n");
            printf("           Mask (for a Volume that masks existing volumes specified in the mask_string\n");
            exit(1);
          }
        }
    }
} else {
    // Automatic linking, simply using the last defined material.
    #ifndef MATERIAL_DETECTOR
        printf("Need to define a material before the geometry to use automatic linking %s.\n",NAME_CURRENT_COMP);
        exit(1);
    #endif
    this_box_volume.p_physics = global_material_list.elements[global_material_list.num_elements-1].physics;
}

sprintf(this_box_volume.name,NAME_CURRENT_COMP);
sprintf(this_box_volume.geometry.shape,"box");
this_box_volume.geometry.priority_value = priority;
this_box_volume.geometry.geometry_p_interact = p_interact;
// Currently the coordinates will be in absolute space.
this_box_volume.geometry.center = POS_A_CURRENT_COMP;

this_box_storage.z_depth = zdepth;
this_box_storage.x_width1 = xwidth;
this_box_storage.y_height1 = yheight;

this_box_storage.is_rectangle = 0;
if (xwidth2 < 0 && yheight2 < 0) this_box_storage.is_rectangle = 1;
if (xwidth == xwidth2 && yheight == yheight2) this_box_storage.is_rectangle = 1;

if (xwidth2 < 0) {
    this_box_storage.x_width2 = xwidth;
    xwidth2 = xwidth;
} else this_box_storage.x_width2 = xwidth2;

if (yheight2 < 0) {
    this_box_storage.y_height2 = yheight;
    yheight2 = yheight;
} else this_box_storage.y_height2 = yheight2;


this_box_storage.normal_vectors[0] = coords_set(0,0,1);
this_box_storage.normal_vectors[1] = coords_set(0,0,1);

// for sides with y component = 0
x_component = 2*zdepth/sqrt((xwidth-xwidth2)*(xwidth-xwidth2)+4*zdepth*zdepth);
z_component = (xwidth-xwidth2)/sqrt(4*zdepth*zdepth+(xwidth-xwidth2)*(xwidth-xwidth2));

this_box_storage.normal_vectors[2] = coords_set(x_component,0,z_component);
this_box_storage.normal_vectors[3] = coords_set(-x_component,0,z_component);

// for sides with x component = 0
y_component = 2*zdepth/sqrt((yheight-yheight2)*(yheight-yheight2)+4*zdepth*zdepth);
z_component = (yheight-yheight2)/sqrt(4*zdepth*zdepth+(yheight-yheight2)*(yheight-yheight2));

this_box_storage.normal_vectors[4] = coords_set(0,y_component,z_component);
this_box_storage.normal_vectors[5] = coords_set(0,-y_component,z_component);

this_box_volume.geometry.visualization_on = visualize;

this_box_volume.geometry.geometry_parameters.p_box_storage = &this_box_storage;

// Assign pointers to functions for intersection with the shape, checking if a point is inside the shape
if (this_box_storage.is_rectangle == 1) {
this_box_volume.geometry.intersect_function = &sample_box_intersect_simple;
this_box_volume.geometry.within_function = &r_within_box_simple;
}
else {
this_box_volume.geometry.intersect_function = &sample_box_intersect_advanced;
this_box_volume.geometry.within_function = &r_within_box_advanced;
}

this_box_volume.geometry.shell_points = &box_shell_points;
this_box_volume.geometry.mcdisplay_function = &mcdisplay_box_function;
this_box_volume.geometry.initialize_from_main_function = &initialize_box_geometry_from_main_component;
this_box_volume.geometry.process_rot_allocated = 0;

this_box_volume.geometry.copy_geometry_parameters = &allocate_box_storage_copy;

rot_copy(this_box_volume.geometry.rotation_matrix,ROT_A_CURRENT_COMP); //check how ROT_R_CURRENT_COMP would work
rot_transpose(ROT_A_CURRENT_COMP,this_box_volume.geometry.transpose_rotation_matrix);

// Initialize loggers
this_box_volume.loggers.num_elements = 0;

// packing the information into the global_geometry_element, which is then included in the global_geometry_list.
sprintf(global_geometry_element.name,NAME_CURRENT_COMP);
global_geometry_element.activation_counter = number_of_activations;
global_geometry_element.component_index = INDEX_CURRENT_COMP;
global_geometry_element.Volume = &this_box_volume; // Would be nicer if this m was a pointer, now we have the (small) data two places
add_element_to_geometry_list(&global_geometry_list,global_geometry_element);
}
#line 186371 "MACS_sample_kidney_box.c"
#undef number_of_activations
#undef mask_setting
#undef mask_string
#undef p_interact
#undef focus_r
#undef focus_xh
#undef focus_xw
#undef focus_ah
#undef focus_aw
#undef target_z
#undef target_y
#undef target_x
#undef target_index
#undef visualize
#undef yheight2
#undef xwidth2
#undef zdepth
#undef yheight
#undef xwidth
#undef priority
#undef material_string
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

  /* Initializations for component channel_2_analyzer_2_array_crystal_array_3. */
  SIG_MESSAGE("channel_2_analyzer_2_array_crystal_array_3 (Init)");
#define mccompcurname  channel_2_analyzer_2_array_crystal_array_3
#define mccompcurtype  Union_box
#define mccompcurindex 220
#define loop_index mccchannel_2_analyzer_2_array_crystal_array_3_loop_index
#define this_box_volume mccchannel_2_analyzer_2_array_crystal_array_3_this_box_volume
#define global_geometry_element mccchannel_2_analyzer_2_array_crystal_array_3_global_geometry_element
#define this_box_storage mccchannel_2_analyzer_2_array_crystal_array_3_this_box_storage
#define material_string mccchannel_2_analyzer_2_array_crystal_array_3_material_string
#define priority mccchannel_2_analyzer_2_array_crystal_array_3_priority
#define xwidth mccchannel_2_analyzer_2_array_crystal_array_3_xwidth
#define yheight mccchannel_2_analyzer_2_array_crystal_array_3_yheight
#define zdepth mccchannel_2_analyzer_2_array_crystal_array_3_zdepth
#define xwidth2 mccchannel_2_analyzer_2_array_crystal_array_3_xwidth2
#define yheight2 mccchannel_2_analyzer_2_array_crystal_array_3_yheight2
#define visualize mccchannel_2_analyzer_2_array_crystal_array_3_visualize
#define target_index mccchannel_2_analyzer_2_array_crystal_array_3_target_index
#define target_x mccchannel_2_analyzer_2_array_crystal_array_3_target_x
#define target_y mccchannel_2_analyzer_2_array_crystal_array_3_target_y
#define target_z mccchannel_2_analyzer_2_array_crystal_array_3_target_z
#define focus_aw mccchannel_2_analyzer_2_array_crystal_array_3_focus_aw
#define focus_ah mccchannel_2_analyzer_2_array_crystal_array_3_focus_ah
#define focus_xw mccchannel_2_analyzer_2_array_crystal_array_3_focus_xw
#define focus_xh mccchannel_2_analyzer_2_array_crystal_array_3_focus_xh
#define focus_r mccchannel_2_analyzer_2_array_crystal_array_3_focus_r
#define p_interact mccchannel_2_analyzer_2_array_crystal_array_3_p_interact
#define mask_string mccchannel_2_analyzer_2_array_crystal_array_3_mask_string
#define mask_setting mccchannel_2_analyzer_2_array_crystal_array_3_mask_setting
#define number_of_activations mccchannel_2_analyzer_2_array_crystal_array_3_number_of_activations
#line 224 "Union_box.comp"
{
// Initializes the focusing system for this volume including input sanitation.
focus_initialize(&this_box_volume.geometry, POS_A_COMP_INDEX(INDEX_CURRENT_COMP+target_index), POS_A_CURRENT_COMP, ROT_A_CURRENT_COMP, target_index, target_x, target_y, target_z, focus_aw, focus_ah, focus_xw, focus_xh, focus_r, NAME_CURRENT_COMP);

// Input sanitation for this geometry
if (xwidth <= 0) {
  printf("\nERROR in Union_box named %s, the xwidth is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (yheight <= 0) {
  printf("\nERROR in Union_box named %s, yheight is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (zdepth <= 0) {
  printf("\nERROR in Union_box named %s, zdepth is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (xwidth2 <= 0 && xwidth2 != -1) {
  printf("\nERROR in Union_box named %s, the xwidth2 is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (yheight2 <= 0 && yheight2 != -1) {
  printf("\nERROR in Union_box named %s, yheight2 is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}

// Use sanitation
if (global_material_list.num_elements == 0) {
  printf("\nERROR: Need to define a material using Union_make_material before using a Union geometry component. \n");
  printf("       %s was defined before first use of Union_make_material.\n",NAME_CURRENT_COMP);
  exit(1);
}

this_box_volume.geometry.is_masked_volume = 0;
this_box_volume.geometry.is_exit_volume = 0;
this_box_volume.geometry.is_mask_volume = 0;
// check if the volume is a mask, if it is the material string is irelevant.
if (mask_string && strlen(mask_string) && strcmp(mask_string, "NULL") && strcmp(mask_string, "0")) {
    // A mask volume is used to limit the extend of other volumes, called the masked volumes. These are specified in the mask_string.
    // In order for a ray to enter a masked volume, it needs to be both in the region covered by that volume AND the mask volume.
    // When more than
    this_box_volume.geometry.mask_mode = 1; // Default is mask mode is ALL
    if (mask_setting && strlen(mask_setting) && strcmp(mask_setting, "NULL") && strcmp(mask_setting, "0")) {
        if (strcmp(mask_setting,"ALL") == 0 || strcmp(mask_setting,"All") == 0) this_box_volume.geometry.mask_mode = 1;
        else if (strcmp(mask_setting,"ANY") == 0 || strcmp(mask_setting,"Any") == 0) this_box_volume.geometry.mask_mode = 2;
        else {
            printf("The mask_mode of component %s is set to %s, but must be either ALL or ANY.\n",NAME_CURRENT_COMP,mask_setting);
            exit(1);
        }
    }
    
    for (loop_index=0;loop_index<global_geometry_list.num_elements;loop_index++) {
        // Add mask list
        if (1 == manual_linking_function(global_geometry_list.elements[loop_index].name,mask_string)) {
            add_element_to_int_list(&this_box_volume.geometry.mask_list,global_geometry_list.elements[loop_index].component_index);
            add_element_to_int_list(&global_geometry_list.elements[loop_index].Volume->geometry.masked_by_list,INDEX_CURRENT_COMP);
            global_geometry_list.elements[loop_index].Volume->geometry.is_masked_volume = 1;
            if (this_box_volume.geometry.mask_mode == 2)
                global_geometry_list.elements[loop_index].Volume->geometry.mask_mode = 2;
            if (this_box_volume.geometry.mask_mode == 1) {
                if (global_geometry_list.elements[loop_index].Volume->geometry.is_masked_volume == 1 && global_geometry_list.elements[loop_index].Volume->geometry.mask_mode != 2)
                    // If more than one mask is added to one volume, the ANY mode overwrites the (default) ALL mode.
                    global_geometry_list.elements[loop_index].Volume->geometry.mask_mode = 1;
            }
            
            found_geometries = 1;
        }
    }
    if (found_geometries == 0) {
        printf("The mask_string in geometry: %s did not find any of the specified volumes in the mask_string %s \n",NAME_CURRENT_COMP,mask_string);
        exit(1);
    }
    this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
    this_box_volume.p_physics->is_vacuum = 0; // Makes this volume a vacuum
    this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
    this_box_volume.p_physics->my_a = 0; // Should not be used.
    sprintf(this_box_volume.p_physics->name,"Mask");
    this_box_volume.geometry.is_mask_volume = 1;
    
    
// Read the material input, or if it lacks, use automatic linking.
} else if (material_string && strlen(material_string) && strcmp(material_string, "NULL") && strcmp(material_string, "0")) {
    // A geometry string was given, use it to determine which material
    if (0 == strcmp(material_string,"vacuum") || 0 == strcmp(material_string,"Vacuum")) {
        // One could have a global physics struct for vacuum instead of creating one for each
        this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
        this_box_volume.p_physics->is_vacuum = 1; // Makes this volume a vacuum
        this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
        this_box_volume.p_physics->my_a = 0; // Should not be used.
        sprintf(this_box_volume.p_physics->name,"Vacuum");
    } else if (0 == strcmp(material_string,"exit") || 0 == strcmp(material_string,"Exit")) {
        // One could have a global physics struct for vacuum instead of creating one for each
        this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
        this_box_volume.p_physics->is_vacuum = 1; // Makes this volume a vacuum
        this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
        this_box_volume.p_physics->my_a = 0; // Should not be used.
        this_box_volume.geometry.is_exit_volume = 1;
        sprintf(this_box_volume.p_physics->name,"Exit");
    } else {
        #ifndef MATERIAL_DETECTOR
            printf("Need to define a material before refering to it in a geometry %s.\n",NAME_CURRENT_COMP);
            exit(1);
        #endif
        for (loop_index=0;loop_index<global_material_list.num_elements;loop_index++) {
            if (0 == strcmp(material_string,global_material_list.elements[loop_index].name)) {
                this_box_volume.p_physics = global_material_list.elements[loop_index].physics;
                break;
            }
            if (loop_index == global_material_list.num_elements-1) {
            printf("\n");
            printf("ERROR: The material string \"%s\" in Union geometry \"%s\" did not match a specified material. \n",material_string,NAME_CURRENT_COMP);
            printf("       The materials available at this point (need to be defined before the geometry): \n");
            for (loop_index=0;loop_index<global_material_list.num_elements;loop_index++)
              printf("         %s\n",global_material_list.elements[loop_index].name);
            printf("\n");
            printf("       It is also possible to use one of the defualt materials avaiable: \n");
            printf("           Vacuum (for a Volume without scattering or absorption)\n");
            printf("           Exit (for a Volume where the ray exits the component if it enters)\n");
            printf("           Mask (for a Volume that masks existing volumes specified in the mask_string\n");
            exit(1);
          }
        }
    }
} else {
    // Automatic linking, simply using the last defined material.
    #ifndef MATERIAL_DETECTOR
        printf("Need to define a material before the geometry to use automatic linking %s.\n",NAME_CURRENT_COMP);
        exit(1);
    #endif
    this_box_volume.p_physics = global_material_list.elements[global_material_list.num_elements-1].physics;
}

sprintf(this_box_volume.name,NAME_CURRENT_COMP);
sprintf(this_box_volume.geometry.shape,"box");
this_box_volume.geometry.priority_value = priority;
this_box_volume.geometry.geometry_p_interact = p_interact;
// Currently the coordinates will be in absolute space.
this_box_volume.geometry.center = POS_A_CURRENT_COMP;

this_box_storage.z_depth = zdepth;
this_box_storage.x_width1 = xwidth;
this_box_storage.y_height1 = yheight;

this_box_storage.is_rectangle = 0;
if (xwidth2 < 0 && yheight2 < 0) this_box_storage.is_rectangle = 1;
if (xwidth == xwidth2 && yheight == yheight2) this_box_storage.is_rectangle = 1;

if (xwidth2 < 0) {
    this_box_storage.x_width2 = xwidth;
    xwidth2 = xwidth;
} else this_box_storage.x_width2 = xwidth2;

if (yheight2 < 0) {
    this_box_storage.y_height2 = yheight;
    yheight2 = yheight;
} else this_box_storage.y_height2 = yheight2;


this_box_storage.normal_vectors[0] = coords_set(0,0,1);
this_box_storage.normal_vectors[1] = coords_set(0,0,1);

// for sides with y component = 0
x_component = 2*zdepth/sqrt((xwidth-xwidth2)*(xwidth-xwidth2)+4*zdepth*zdepth);
z_component = (xwidth-xwidth2)/sqrt(4*zdepth*zdepth+(xwidth-xwidth2)*(xwidth-xwidth2));

this_box_storage.normal_vectors[2] = coords_set(x_component,0,z_component);
this_box_storage.normal_vectors[3] = coords_set(-x_component,0,z_component);

// for sides with x component = 0
y_component = 2*zdepth/sqrt((yheight-yheight2)*(yheight-yheight2)+4*zdepth*zdepth);
z_component = (yheight-yheight2)/sqrt(4*zdepth*zdepth+(yheight-yheight2)*(yheight-yheight2));

this_box_storage.normal_vectors[4] = coords_set(0,y_component,z_component);
this_box_storage.normal_vectors[5] = coords_set(0,-y_component,z_component);

this_box_volume.geometry.visualization_on = visualize;

this_box_volume.geometry.geometry_parameters.p_box_storage = &this_box_storage;

// Assign pointers to functions for intersection with the shape, checking if a point is inside the shape
if (this_box_storage.is_rectangle == 1) {
this_box_volume.geometry.intersect_function = &sample_box_intersect_simple;
this_box_volume.geometry.within_function = &r_within_box_simple;
}
else {
this_box_volume.geometry.intersect_function = &sample_box_intersect_advanced;
this_box_volume.geometry.within_function = &r_within_box_advanced;
}

this_box_volume.geometry.shell_points = &box_shell_points;
this_box_volume.geometry.mcdisplay_function = &mcdisplay_box_function;
this_box_volume.geometry.initialize_from_main_function = &initialize_box_geometry_from_main_component;
this_box_volume.geometry.process_rot_allocated = 0;

this_box_volume.geometry.copy_geometry_parameters = &allocate_box_storage_copy;

rot_copy(this_box_volume.geometry.rotation_matrix,ROT_A_CURRENT_COMP); //check how ROT_R_CURRENT_COMP would work
rot_transpose(ROT_A_CURRENT_COMP,this_box_volume.geometry.transpose_rotation_matrix);

// Initialize loggers
this_box_volume.loggers.num_elements = 0;

// packing the information into the global_geometry_element, which is then included in the global_geometry_list.
sprintf(global_geometry_element.name,NAME_CURRENT_COMP);
global_geometry_element.activation_counter = number_of_activations;
global_geometry_element.component_index = INDEX_CURRENT_COMP;
global_geometry_element.Volume = &this_box_volume; // Would be nicer if this m was a pointer, now we have the (small) data two places
add_element_to_geometry_list(&global_geometry_list,global_geometry_element);
}
#line 186641 "MACS_sample_kidney_box.c"
#undef number_of_activations
#undef mask_setting
#undef mask_string
#undef p_interact
#undef focus_r
#undef focus_xh
#undef focus_xw
#undef focus_ah
#undef focus_aw
#undef target_z
#undef target_y
#undef target_x
#undef target_index
#undef visualize
#undef yheight2
#undef xwidth2
#undef zdepth
#undef yheight
#undef xwidth
#undef priority
#undef material_string
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

  /* Initializations for component channel_2_analyzer_2_array_crystal_array_4. */
  SIG_MESSAGE("channel_2_analyzer_2_array_crystal_array_4 (Init)");
#define mccompcurname  channel_2_analyzer_2_array_crystal_array_4
#define mccompcurtype  Union_box
#define mccompcurindex 221
#define loop_index mccchannel_2_analyzer_2_array_crystal_array_4_loop_index
#define this_box_volume mccchannel_2_analyzer_2_array_crystal_array_4_this_box_volume
#define global_geometry_element mccchannel_2_analyzer_2_array_crystal_array_4_global_geometry_element
#define this_box_storage mccchannel_2_analyzer_2_array_crystal_array_4_this_box_storage
#define material_string mccchannel_2_analyzer_2_array_crystal_array_4_material_string
#define priority mccchannel_2_analyzer_2_array_crystal_array_4_priority
#define xwidth mccchannel_2_analyzer_2_array_crystal_array_4_xwidth
#define yheight mccchannel_2_analyzer_2_array_crystal_array_4_yheight
#define zdepth mccchannel_2_analyzer_2_array_crystal_array_4_zdepth
#define xwidth2 mccchannel_2_analyzer_2_array_crystal_array_4_xwidth2
#define yheight2 mccchannel_2_analyzer_2_array_crystal_array_4_yheight2
#define visualize mccchannel_2_analyzer_2_array_crystal_array_4_visualize
#define target_index mccchannel_2_analyzer_2_array_crystal_array_4_target_index
#define target_x mccchannel_2_analyzer_2_array_crystal_array_4_target_x
#define target_y mccchannel_2_analyzer_2_array_crystal_array_4_target_y
#define target_z mccchannel_2_analyzer_2_array_crystal_array_4_target_z
#define focus_aw mccchannel_2_analyzer_2_array_crystal_array_4_focus_aw
#define focus_ah mccchannel_2_analyzer_2_array_crystal_array_4_focus_ah
#define focus_xw mccchannel_2_analyzer_2_array_crystal_array_4_focus_xw
#define focus_xh mccchannel_2_analyzer_2_array_crystal_array_4_focus_xh
#define focus_r mccchannel_2_analyzer_2_array_crystal_array_4_focus_r
#define p_interact mccchannel_2_analyzer_2_array_crystal_array_4_p_interact
#define mask_string mccchannel_2_analyzer_2_array_crystal_array_4_mask_string
#define mask_setting mccchannel_2_analyzer_2_array_crystal_array_4_mask_setting
#define number_of_activations mccchannel_2_analyzer_2_array_crystal_array_4_number_of_activations
#line 224 "Union_box.comp"
{
// Initializes the focusing system for this volume including input sanitation.
focus_initialize(&this_box_volume.geometry, POS_A_COMP_INDEX(INDEX_CURRENT_COMP+target_index), POS_A_CURRENT_COMP, ROT_A_CURRENT_COMP, target_index, target_x, target_y, target_z, focus_aw, focus_ah, focus_xw, focus_xh, focus_r, NAME_CURRENT_COMP);

// Input sanitation for this geometry
if (xwidth <= 0) {
  printf("\nERROR in Union_box named %s, the xwidth is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (yheight <= 0) {
  printf("\nERROR in Union_box named %s, yheight is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (zdepth <= 0) {
  printf("\nERROR in Union_box named %s, zdepth is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (xwidth2 <= 0 && xwidth2 != -1) {
  printf("\nERROR in Union_box named %s, the xwidth2 is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (yheight2 <= 0 && yheight2 != -1) {
  printf("\nERROR in Union_box named %s, yheight2 is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}

// Use sanitation
if (global_material_list.num_elements == 0) {
  printf("\nERROR: Need to define a material using Union_make_material before using a Union geometry component. \n");
  printf("       %s was defined before first use of Union_make_material.\n",NAME_CURRENT_COMP);
  exit(1);
}

this_box_volume.geometry.is_masked_volume = 0;
this_box_volume.geometry.is_exit_volume = 0;
this_box_volume.geometry.is_mask_volume = 0;
// check if the volume is a mask, if it is the material string is irelevant.
if (mask_string && strlen(mask_string) && strcmp(mask_string, "NULL") && strcmp(mask_string, "0")) {
    // A mask volume is used to limit the extend of other volumes, called the masked volumes. These are specified in the mask_string.
    // In order for a ray to enter a masked volume, it needs to be both in the region covered by that volume AND the mask volume.
    // When more than
    this_box_volume.geometry.mask_mode = 1; // Default is mask mode is ALL
    if (mask_setting && strlen(mask_setting) && strcmp(mask_setting, "NULL") && strcmp(mask_setting, "0")) {
        if (strcmp(mask_setting,"ALL") == 0 || strcmp(mask_setting,"All") == 0) this_box_volume.geometry.mask_mode = 1;
        else if (strcmp(mask_setting,"ANY") == 0 || strcmp(mask_setting,"Any") == 0) this_box_volume.geometry.mask_mode = 2;
        else {
            printf("The mask_mode of component %s is set to %s, but must be either ALL or ANY.\n",NAME_CURRENT_COMP,mask_setting);
            exit(1);
        }
    }
    
    for (loop_index=0;loop_index<global_geometry_list.num_elements;loop_index++) {
        // Add mask list
        if (1 == manual_linking_function(global_geometry_list.elements[loop_index].name,mask_string)) {
            add_element_to_int_list(&this_box_volume.geometry.mask_list,global_geometry_list.elements[loop_index].component_index);
            add_element_to_int_list(&global_geometry_list.elements[loop_index].Volume->geometry.masked_by_list,INDEX_CURRENT_COMP);
            global_geometry_list.elements[loop_index].Volume->geometry.is_masked_volume = 1;
            if (this_box_volume.geometry.mask_mode == 2)
                global_geometry_list.elements[loop_index].Volume->geometry.mask_mode = 2;
            if (this_box_volume.geometry.mask_mode == 1) {
                if (global_geometry_list.elements[loop_index].Volume->geometry.is_masked_volume == 1 && global_geometry_list.elements[loop_index].Volume->geometry.mask_mode != 2)
                    // If more than one mask is added to one volume, the ANY mode overwrites the (default) ALL mode.
                    global_geometry_list.elements[loop_index].Volume->geometry.mask_mode = 1;
            }
            
            found_geometries = 1;
        }
    }
    if (found_geometries == 0) {
        printf("The mask_string in geometry: %s did not find any of the specified volumes in the mask_string %s \n",NAME_CURRENT_COMP,mask_string);
        exit(1);
    }
    this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
    this_box_volume.p_physics->is_vacuum = 0; // Makes this volume a vacuum
    this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
    this_box_volume.p_physics->my_a = 0; // Should not be used.
    sprintf(this_box_volume.p_physics->name,"Mask");
    this_box_volume.geometry.is_mask_volume = 1;
    
    
// Read the material input, or if it lacks, use automatic linking.
} else if (material_string && strlen(material_string) && strcmp(material_string, "NULL") && strcmp(material_string, "0")) {
    // A geometry string was given, use it to determine which material
    if (0 == strcmp(material_string,"vacuum") || 0 == strcmp(material_string,"Vacuum")) {
        // One could have a global physics struct for vacuum instead of creating one for each
        this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
        this_box_volume.p_physics->is_vacuum = 1; // Makes this volume a vacuum
        this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
        this_box_volume.p_physics->my_a = 0; // Should not be used.
        sprintf(this_box_volume.p_physics->name,"Vacuum");
    } else if (0 == strcmp(material_string,"exit") || 0 == strcmp(material_string,"Exit")) {
        // One could have a global physics struct for vacuum instead of creating one for each
        this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
        this_box_volume.p_physics->is_vacuum = 1; // Makes this volume a vacuum
        this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
        this_box_volume.p_physics->my_a = 0; // Should not be used.
        this_box_volume.geometry.is_exit_volume = 1;
        sprintf(this_box_volume.p_physics->name,"Exit");
    } else {
        #ifndef MATERIAL_DETECTOR
            printf("Need to define a material before refering to it in a geometry %s.\n",NAME_CURRENT_COMP);
            exit(1);
        #endif
        for (loop_index=0;loop_index<global_material_list.num_elements;loop_index++) {
            if (0 == strcmp(material_string,global_material_list.elements[loop_index].name)) {
                this_box_volume.p_physics = global_material_list.elements[loop_index].physics;
                break;
            }
            if (loop_index == global_material_list.num_elements-1) {
            printf("\n");
            printf("ERROR: The material string \"%s\" in Union geometry \"%s\" did not match a specified material. \n",material_string,NAME_CURRENT_COMP);
            printf("       The materials available at this point (need to be defined before the geometry): \n");
            for (loop_index=0;loop_index<global_material_list.num_elements;loop_index++)
              printf("         %s\n",global_material_list.elements[loop_index].name);
            printf("\n");
            printf("       It is also possible to use one of the defualt materials avaiable: \n");
            printf("           Vacuum (for a Volume without scattering or absorption)\n");
            printf("           Exit (for a Volume where the ray exits the component if it enters)\n");
            printf("           Mask (for a Volume that masks existing volumes specified in the mask_string\n");
            exit(1);
          }
        }
    }
} else {
    // Automatic linking, simply using the last defined material.
    #ifndef MATERIAL_DETECTOR
        printf("Need to define a material before the geometry to use automatic linking %s.\n",NAME_CURRENT_COMP);
        exit(1);
    #endif
    this_box_volume.p_physics = global_material_list.elements[global_material_list.num_elements-1].physics;
}

sprintf(this_box_volume.name,NAME_CURRENT_COMP);
sprintf(this_box_volume.geometry.shape,"box");
this_box_volume.geometry.priority_value = priority;
this_box_volume.geometry.geometry_p_interact = p_interact;
// Currently the coordinates will be in absolute space.
this_box_volume.geometry.center = POS_A_CURRENT_COMP;

this_box_storage.z_depth = zdepth;
this_box_storage.x_width1 = xwidth;
this_box_storage.y_height1 = yheight;

this_box_storage.is_rectangle = 0;
if (xwidth2 < 0 && yheight2 < 0) this_box_storage.is_rectangle = 1;
if (xwidth == xwidth2 && yheight == yheight2) this_box_storage.is_rectangle = 1;

if (xwidth2 < 0) {
    this_box_storage.x_width2 = xwidth;
    xwidth2 = xwidth;
} else this_box_storage.x_width2 = xwidth2;

if (yheight2 < 0) {
    this_box_storage.y_height2 = yheight;
    yheight2 = yheight;
} else this_box_storage.y_height2 = yheight2;


this_box_storage.normal_vectors[0] = coords_set(0,0,1);
this_box_storage.normal_vectors[1] = coords_set(0,0,1);

// for sides with y component = 0
x_component = 2*zdepth/sqrt((xwidth-xwidth2)*(xwidth-xwidth2)+4*zdepth*zdepth);
z_component = (xwidth-xwidth2)/sqrt(4*zdepth*zdepth+(xwidth-xwidth2)*(xwidth-xwidth2));

this_box_storage.normal_vectors[2] = coords_set(x_component,0,z_component);
this_box_storage.normal_vectors[3] = coords_set(-x_component,0,z_component);

// for sides with x component = 0
y_component = 2*zdepth/sqrt((yheight-yheight2)*(yheight-yheight2)+4*zdepth*zdepth);
z_component = (yheight-yheight2)/sqrt(4*zdepth*zdepth+(yheight-yheight2)*(yheight-yheight2));

this_box_storage.normal_vectors[4] = coords_set(0,y_component,z_component);
this_box_storage.normal_vectors[5] = coords_set(0,-y_component,z_component);

this_box_volume.geometry.visualization_on = visualize;

this_box_volume.geometry.geometry_parameters.p_box_storage = &this_box_storage;

// Assign pointers to functions for intersection with the shape, checking if a point is inside the shape
if (this_box_storage.is_rectangle == 1) {
this_box_volume.geometry.intersect_function = &sample_box_intersect_simple;
this_box_volume.geometry.within_function = &r_within_box_simple;
}
else {
this_box_volume.geometry.intersect_function = &sample_box_intersect_advanced;
this_box_volume.geometry.within_function = &r_within_box_advanced;
}

this_box_volume.geometry.shell_points = &box_shell_points;
this_box_volume.geometry.mcdisplay_function = &mcdisplay_box_function;
this_box_volume.geometry.initialize_from_main_function = &initialize_box_geometry_from_main_component;
this_box_volume.geometry.process_rot_allocated = 0;

this_box_volume.geometry.copy_geometry_parameters = &allocate_box_storage_copy;

rot_copy(this_box_volume.geometry.rotation_matrix,ROT_A_CURRENT_COMP); //check how ROT_R_CURRENT_COMP would work
rot_transpose(ROT_A_CURRENT_COMP,this_box_volume.geometry.transpose_rotation_matrix);

// Initialize loggers
this_box_volume.loggers.num_elements = 0;

// packing the information into the global_geometry_element, which is then included in the global_geometry_list.
sprintf(global_geometry_element.name,NAME_CURRENT_COMP);
global_geometry_element.activation_counter = number_of_activations;
global_geometry_element.component_index = INDEX_CURRENT_COMP;
global_geometry_element.Volume = &this_box_volume; // Would be nicer if this m was a pointer, now we have the (small) data two places
add_element_to_geometry_list(&global_geometry_list,global_geometry_element);
}
#line 186911 "MACS_sample_kidney_box.c"
#undef number_of_activations
#undef mask_setting
#undef mask_string
#undef p_interact
#undef focus_r
#undef focus_xh
#undef focus_xw
#undef focus_ah
#undef focus_aw
#undef target_z
#undef target_y
#undef target_x
#undef target_index
#undef visualize
#undef yheight2
#undef xwidth2
#undef zdepth
#undef yheight
#undef xwidth
#undef priority
#undef material_string
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

  /* Initializations for component channel_2_analyzer_2_array_crystal_array_5. */
  SIG_MESSAGE("channel_2_analyzer_2_array_crystal_array_5 (Init)");
#define mccompcurname  channel_2_analyzer_2_array_crystal_array_5
#define mccompcurtype  Union_box
#define mccompcurindex 222
#define loop_index mccchannel_2_analyzer_2_array_crystal_array_5_loop_index
#define this_box_volume mccchannel_2_analyzer_2_array_crystal_array_5_this_box_volume
#define global_geometry_element mccchannel_2_analyzer_2_array_crystal_array_5_global_geometry_element
#define this_box_storage mccchannel_2_analyzer_2_array_crystal_array_5_this_box_storage
#define material_string mccchannel_2_analyzer_2_array_crystal_array_5_material_string
#define priority mccchannel_2_analyzer_2_array_crystal_array_5_priority
#define xwidth mccchannel_2_analyzer_2_array_crystal_array_5_xwidth
#define yheight mccchannel_2_analyzer_2_array_crystal_array_5_yheight
#define zdepth mccchannel_2_analyzer_2_array_crystal_array_5_zdepth
#define xwidth2 mccchannel_2_analyzer_2_array_crystal_array_5_xwidth2
#define yheight2 mccchannel_2_analyzer_2_array_crystal_array_5_yheight2
#define visualize mccchannel_2_analyzer_2_array_crystal_array_5_visualize
#define target_index mccchannel_2_analyzer_2_array_crystal_array_5_target_index
#define target_x mccchannel_2_analyzer_2_array_crystal_array_5_target_x
#define target_y mccchannel_2_analyzer_2_array_crystal_array_5_target_y
#define target_z mccchannel_2_analyzer_2_array_crystal_array_5_target_z
#define focus_aw mccchannel_2_analyzer_2_array_crystal_array_5_focus_aw
#define focus_ah mccchannel_2_analyzer_2_array_crystal_array_5_focus_ah
#define focus_xw mccchannel_2_analyzer_2_array_crystal_array_5_focus_xw
#define focus_xh mccchannel_2_analyzer_2_array_crystal_array_5_focus_xh
#define focus_r mccchannel_2_analyzer_2_array_crystal_array_5_focus_r
#define p_interact mccchannel_2_analyzer_2_array_crystal_array_5_p_interact
#define mask_string mccchannel_2_analyzer_2_array_crystal_array_5_mask_string
#define mask_setting mccchannel_2_analyzer_2_array_crystal_array_5_mask_setting
#define number_of_activations mccchannel_2_analyzer_2_array_crystal_array_5_number_of_activations
#line 224 "Union_box.comp"
{
// Initializes the focusing system for this volume including input sanitation.
focus_initialize(&this_box_volume.geometry, POS_A_COMP_INDEX(INDEX_CURRENT_COMP+target_index), POS_A_CURRENT_COMP, ROT_A_CURRENT_COMP, target_index, target_x, target_y, target_z, focus_aw, focus_ah, focus_xw, focus_xh, focus_r, NAME_CURRENT_COMP);

// Input sanitation for this geometry
if (xwidth <= 0) {
  printf("\nERROR in Union_box named %s, the xwidth is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (yheight <= 0) {
  printf("\nERROR in Union_box named %s, yheight is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (zdepth <= 0) {
  printf("\nERROR in Union_box named %s, zdepth is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (xwidth2 <= 0 && xwidth2 != -1) {
  printf("\nERROR in Union_box named %s, the xwidth2 is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (yheight2 <= 0 && yheight2 != -1) {
  printf("\nERROR in Union_box named %s, yheight2 is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}

// Use sanitation
if (global_material_list.num_elements == 0) {
  printf("\nERROR: Need to define a material using Union_make_material before using a Union geometry component. \n");
  printf("       %s was defined before first use of Union_make_material.\n",NAME_CURRENT_COMP);
  exit(1);
}

this_box_volume.geometry.is_masked_volume = 0;
this_box_volume.geometry.is_exit_volume = 0;
this_box_volume.geometry.is_mask_volume = 0;
// check if the volume is a mask, if it is the material string is irelevant.
if (mask_string && strlen(mask_string) && strcmp(mask_string, "NULL") && strcmp(mask_string, "0")) {
    // A mask volume is used to limit the extend of other volumes, called the masked volumes. These are specified in the mask_string.
    // In order for a ray to enter a masked volume, it needs to be both in the region covered by that volume AND the mask volume.
    // When more than
    this_box_volume.geometry.mask_mode = 1; // Default is mask mode is ALL
    if (mask_setting && strlen(mask_setting) && strcmp(mask_setting, "NULL") && strcmp(mask_setting, "0")) {
        if (strcmp(mask_setting,"ALL") == 0 || strcmp(mask_setting,"All") == 0) this_box_volume.geometry.mask_mode = 1;
        else if (strcmp(mask_setting,"ANY") == 0 || strcmp(mask_setting,"Any") == 0) this_box_volume.geometry.mask_mode = 2;
        else {
            printf("The mask_mode of component %s is set to %s, but must be either ALL or ANY.\n",NAME_CURRENT_COMP,mask_setting);
            exit(1);
        }
    }
    
    for (loop_index=0;loop_index<global_geometry_list.num_elements;loop_index++) {
        // Add mask list
        if (1 == manual_linking_function(global_geometry_list.elements[loop_index].name,mask_string)) {
            add_element_to_int_list(&this_box_volume.geometry.mask_list,global_geometry_list.elements[loop_index].component_index);
            add_element_to_int_list(&global_geometry_list.elements[loop_index].Volume->geometry.masked_by_list,INDEX_CURRENT_COMP);
            global_geometry_list.elements[loop_index].Volume->geometry.is_masked_volume = 1;
            if (this_box_volume.geometry.mask_mode == 2)
                global_geometry_list.elements[loop_index].Volume->geometry.mask_mode = 2;
            if (this_box_volume.geometry.mask_mode == 1) {
                if (global_geometry_list.elements[loop_index].Volume->geometry.is_masked_volume == 1 && global_geometry_list.elements[loop_index].Volume->geometry.mask_mode != 2)
                    // If more than one mask is added to one volume, the ANY mode overwrites the (default) ALL mode.
                    global_geometry_list.elements[loop_index].Volume->geometry.mask_mode = 1;
            }
            
            found_geometries = 1;
        }
    }
    if (found_geometries == 0) {
        printf("The mask_string in geometry: %s did not find any of the specified volumes in the mask_string %s \n",NAME_CURRENT_COMP,mask_string);
        exit(1);
    }
    this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
    this_box_volume.p_physics->is_vacuum = 0; // Makes this volume a vacuum
    this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
    this_box_volume.p_physics->my_a = 0; // Should not be used.
    sprintf(this_box_volume.p_physics->name,"Mask");
    this_box_volume.geometry.is_mask_volume = 1;
    
    
// Read the material input, or if it lacks, use automatic linking.
} else if (material_string && strlen(material_string) && strcmp(material_string, "NULL") && strcmp(material_string, "0")) {
    // A geometry string was given, use it to determine which material
    if (0 == strcmp(material_string,"vacuum") || 0 == strcmp(material_string,"Vacuum")) {
        // One could have a global physics struct for vacuum instead of creating one for each
        this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
        this_box_volume.p_physics->is_vacuum = 1; // Makes this volume a vacuum
        this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
        this_box_volume.p_physics->my_a = 0; // Should not be used.
        sprintf(this_box_volume.p_physics->name,"Vacuum");
    } else if (0 == strcmp(material_string,"exit") || 0 == strcmp(material_string,"Exit")) {
        // One could have a global physics struct for vacuum instead of creating one for each
        this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
        this_box_volume.p_physics->is_vacuum = 1; // Makes this volume a vacuum
        this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
        this_box_volume.p_physics->my_a = 0; // Should not be used.
        this_box_volume.geometry.is_exit_volume = 1;
        sprintf(this_box_volume.p_physics->name,"Exit");
    } else {
        #ifndef MATERIAL_DETECTOR
            printf("Need to define a material before refering to it in a geometry %s.\n",NAME_CURRENT_COMP);
            exit(1);
        #endif
        for (loop_index=0;loop_index<global_material_list.num_elements;loop_index++) {
            if (0 == strcmp(material_string,global_material_list.elements[loop_index].name)) {
                this_box_volume.p_physics = global_material_list.elements[loop_index].physics;
                break;
            }
            if (loop_index == global_material_list.num_elements-1) {
            printf("\n");
            printf("ERROR: The material string \"%s\" in Union geometry \"%s\" did not match a specified material. \n",material_string,NAME_CURRENT_COMP);
            printf("       The materials available at this point (need to be defined before the geometry): \n");
            for (loop_index=0;loop_index<global_material_list.num_elements;loop_index++)
              printf("         %s\n",global_material_list.elements[loop_index].name);
            printf("\n");
            printf("       It is also possible to use one of the defualt materials avaiable: \n");
            printf("           Vacuum (for a Volume without scattering or absorption)\n");
            printf("           Exit (for a Volume where the ray exits the component if it enters)\n");
            printf("           Mask (for a Volume that masks existing volumes specified in the mask_string\n");
            exit(1);
          }
        }
    }
} else {
    // Automatic linking, simply using the last defined material.
    #ifndef MATERIAL_DETECTOR
        printf("Need to define a material before the geometry to use automatic linking %s.\n",NAME_CURRENT_COMP);
        exit(1);
    #endif
    this_box_volume.p_physics = global_material_list.elements[global_material_list.num_elements-1].physics;
}

sprintf(this_box_volume.name,NAME_CURRENT_COMP);
sprintf(this_box_volume.geometry.shape,"box");
this_box_volume.geometry.priority_value = priority;
this_box_volume.geometry.geometry_p_interact = p_interact;
// Currently the coordinates will be in absolute space.
this_box_volume.geometry.center = POS_A_CURRENT_COMP;

this_box_storage.z_depth = zdepth;
this_box_storage.x_width1 = xwidth;
this_box_storage.y_height1 = yheight;

this_box_storage.is_rectangle = 0;
if (xwidth2 < 0 && yheight2 < 0) this_box_storage.is_rectangle = 1;
if (xwidth == xwidth2 && yheight == yheight2) this_box_storage.is_rectangle = 1;

if (xwidth2 < 0) {
    this_box_storage.x_width2 = xwidth;
    xwidth2 = xwidth;
} else this_box_storage.x_width2 = xwidth2;

if (yheight2 < 0) {
    this_box_storage.y_height2 = yheight;
    yheight2 = yheight;
} else this_box_storage.y_height2 = yheight2;


this_box_storage.normal_vectors[0] = coords_set(0,0,1);
this_box_storage.normal_vectors[1] = coords_set(0,0,1);

// for sides with y component = 0
x_component = 2*zdepth/sqrt((xwidth-xwidth2)*(xwidth-xwidth2)+4*zdepth*zdepth);
z_component = (xwidth-xwidth2)/sqrt(4*zdepth*zdepth+(xwidth-xwidth2)*(xwidth-xwidth2));

this_box_storage.normal_vectors[2] = coords_set(x_component,0,z_component);
this_box_storage.normal_vectors[3] = coords_set(-x_component,0,z_component);

// for sides with x component = 0
y_component = 2*zdepth/sqrt((yheight-yheight2)*(yheight-yheight2)+4*zdepth*zdepth);
z_component = (yheight-yheight2)/sqrt(4*zdepth*zdepth+(yheight-yheight2)*(yheight-yheight2));

this_box_storage.normal_vectors[4] = coords_set(0,y_component,z_component);
this_box_storage.normal_vectors[5] = coords_set(0,-y_component,z_component);

this_box_volume.geometry.visualization_on = visualize;

this_box_volume.geometry.geometry_parameters.p_box_storage = &this_box_storage;

// Assign pointers to functions for intersection with the shape, checking if a point is inside the shape
if (this_box_storage.is_rectangle == 1) {
this_box_volume.geometry.intersect_function = &sample_box_intersect_simple;
this_box_volume.geometry.within_function = &r_within_box_simple;
}
else {
this_box_volume.geometry.intersect_function = &sample_box_intersect_advanced;
this_box_volume.geometry.within_function = &r_within_box_advanced;
}

this_box_volume.geometry.shell_points = &box_shell_points;
this_box_volume.geometry.mcdisplay_function = &mcdisplay_box_function;
this_box_volume.geometry.initialize_from_main_function = &initialize_box_geometry_from_main_component;
this_box_volume.geometry.process_rot_allocated = 0;

this_box_volume.geometry.copy_geometry_parameters = &allocate_box_storage_copy;

rot_copy(this_box_volume.geometry.rotation_matrix,ROT_A_CURRENT_COMP); //check how ROT_R_CURRENT_COMP would work
rot_transpose(ROT_A_CURRENT_COMP,this_box_volume.geometry.transpose_rotation_matrix);

// Initialize loggers
this_box_volume.loggers.num_elements = 0;

// packing the information into the global_geometry_element, which is then included in the global_geometry_list.
sprintf(global_geometry_element.name,NAME_CURRENT_COMP);
global_geometry_element.activation_counter = number_of_activations;
global_geometry_element.component_index = INDEX_CURRENT_COMP;
global_geometry_element.Volume = &this_box_volume; // Would be nicer if this m was a pointer, now we have the (small) data two places
add_element_to_geometry_list(&global_geometry_list,global_geometry_element);
}
#line 187181 "MACS_sample_kidney_box.c"
#undef number_of_activations
#undef mask_setting
#undef mask_string
#undef p_interact
#undef focus_r
#undef focus_xh
#undef focus_xw
#undef focus_ah
#undef focus_aw
#undef target_z
#undef target_y
#undef target_x
#undef target_index
#undef visualize
#undef yheight2
#undef xwidth2
#undef zdepth
#undef yheight
#undef xwidth
#undef priority
#undef material_string
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

  /* Initializations for component channel_2_analyzer_2_array_crystal_array_6. */
  SIG_MESSAGE("channel_2_analyzer_2_array_crystal_array_6 (Init)");
#define mccompcurname  channel_2_analyzer_2_array_crystal_array_6
#define mccompcurtype  Union_box
#define mccompcurindex 223
#define loop_index mccchannel_2_analyzer_2_array_crystal_array_6_loop_index
#define this_box_volume mccchannel_2_analyzer_2_array_crystal_array_6_this_box_volume
#define global_geometry_element mccchannel_2_analyzer_2_array_crystal_array_6_global_geometry_element
#define this_box_storage mccchannel_2_analyzer_2_array_crystal_array_6_this_box_storage
#define material_string mccchannel_2_analyzer_2_array_crystal_array_6_material_string
#define priority mccchannel_2_analyzer_2_array_crystal_array_6_priority
#define xwidth mccchannel_2_analyzer_2_array_crystal_array_6_xwidth
#define yheight mccchannel_2_analyzer_2_array_crystal_array_6_yheight
#define zdepth mccchannel_2_analyzer_2_array_crystal_array_6_zdepth
#define xwidth2 mccchannel_2_analyzer_2_array_crystal_array_6_xwidth2
#define yheight2 mccchannel_2_analyzer_2_array_crystal_array_6_yheight2
#define visualize mccchannel_2_analyzer_2_array_crystal_array_6_visualize
#define target_index mccchannel_2_analyzer_2_array_crystal_array_6_target_index
#define target_x mccchannel_2_analyzer_2_array_crystal_array_6_target_x
#define target_y mccchannel_2_analyzer_2_array_crystal_array_6_target_y
#define target_z mccchannel_2_analyzer_2_array_crystal_array_6_target_z
#define focus_aw mccchannel_2_analyzer_2_array_crystal_array_6_focus_aw
#define focus_ah mccchannel_2_analyzer_2_array_crystal_array_6_focus_ah
#define focus_xw mccchannel_2_analyzer_2_array_crystal_array_6_focus_xw
#define focus_xh mccchannel_2_analyzer_2_array_crystal_array_6_focus_xh
#define focus_r mccchannel_2_analyzer_2_array_crystal_array_6_focus_r
#define p_interact mccchannel_2_analyzer_2_array_crystal_array_6_p_interact
#define mask_string mccchannel_2_analyzer_2_array_crystal_array_6_mask_string
#define mask_setting mccchannel_2_analyzer_2_array_crystal_array_6_mask_setting
#define number_of_activations mccchannel_2_analyzer_2_array_crystal_array_6_number_of_activations
#line 224 "Union_box.comp"
{
// Initializes the focusing system for this volume including input sanitation.
focus_initialize(&this_box_volume.geometry, POS_A_COMP_INDEX(INDEX_CURRENT_COMP+target_index), POS_A_CURRENT_COMP, ROT_A_CURRENT_COMP, target_index, target_x, target_y, target_z, focus_aw, focus_ah, focus_xw, focus_xh, focus_r, NAME_CURRENT_COMP);

// Input sanitation for this geometry
if (xwidth <= 0) {
  printf("\nERROR in Union_box named %s, the xwidth is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (yheight <= 0) {
  printf("\nERROR in Union_box named %s, yheight is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (zdepth <= 0) {
  printf("\nERROR in Union_box named %s, zdepth is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (xwidth2 <= 0 && xwidth2 != -1) {
  printf("\nERROR in Union_box named %s, the xwidth2 is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (yheight2 <= 0 && yheight2 != -1) {
  printf("\nERROR in Union_box named %s, yheight2 is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}

// Use sanitation
if (global_material_list.num_elements == 0) {
  printf("\nERROR: Need to define a material using Union_make_material before using a Union geometry component. \n");
  printf("       %s was defined before first use of Union_make_material.\n",NAME_CURRENT_COMP);
  exit(1);
}

this_box_volume.geometry.is_masked_volume = 0;
this_box_volume.geometry.is_exit_volume = 0;
this_box_volume.geometry.is_mask_volume = 0;
// check if the volume is a mask, if it is the material string is irelevant.
if (mask_string && strlen(mask_string) && strcmp(mask_string, "NULL") && strcmp(mask_string, "0")) {
    // A mask volume is used to limit the extend of other volumes, called the masked volumes. These are specified in the mask_string.
    // In order for a ray to enter a masked volume, it needs to be both in the region covered by that volume AND the mask volume.
    // When more than
    this_box_volume.geometry.mask_mode = 1; // Default is mask mode is ALL
    if (mask_setting && strlen(mask_setting) && strcmp(mask_setting, "NULL") && strcmp(mask_setting, "0")) {
        if (strcmp(mask_setting,"ALL") == 0 || strcmp(mask_setting,"All") == 0) this_box_volume.geometry.mask_mode = 1;
        else if (strcmp(mask_setting,"ANY") == 0 || strcmp(mask_setting,"Any") == 0) this_box_volume.geometry.mask_mode = 2;
        else {
            printf("The mask_mode of component %s is set to %s, but must be either ALL or ANY.\n",NAME_CURRENT_COMP,mask_setting);
            exit(1);
        }
    }
    
    for (loop_index=0;loop_index<global_geometry_list.num_elements;loop_index++) {
        // Add mask list
        if (1 == manual_linking_function(global_geometry_list.elements[loop_index].name,mask_string)) {
            add_element_to_int_list(&this_box_volume.geometry.mask_list,global_geometry_list.elements[loop_index].component_index);
            add_element_to_int_list(&global_geometry_list.elements[loop_index].Volume->geometry.masked_by_list,INDEX_CURRENT_COMP);
            global_geometry_list.elements[loop_index].Volume->geometry.is_masked_volume = 1;
            if (this_box_volume.geometry.mask_mode == 2)
                global_geometry_list.elements[loop_index].Volume->geometry.mask_mode = 2;
            if (this_box_volume.geometry.mask_mode == 1) {
                if (global_geometry_list.elements[loop_index].Volume->geometry.is_masked_volume == 1 && global_geometry_list.elements[loop_index].Volume->geometry.mask_mode != 2)
                    // If more than one mask is added to one volume, the ANY mode overwrites the (default) ALL mode.
                    global_geometry_list.elements[loop_index].Volume->geometry.mask_mode = 1;
            }
            
            found_geometries = 1;
        }
    }
    if (found_geometries == 0) {
        printf("The mask_string in geometry: %s did not find any of the specified volumes in the mask_string %s \n",NAME_CURRENT_COMP,mask_string);
        exit(1);
    }
    this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
    this_box_volume.p_physics->is_vacuum = 0; // Makes this volume a vacuum
    this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
    this_box_volume.p_physics->my_a = 0; // Should not be used.
    sprintf(this_box_volume.p_physics->name,"Mask");
    this_box_volume.geometry.is_mask_volume = 1;
    
    
// Read the material input, or if it lacks, use automatic linking.
} else if (material_string && strlen(material_string) && strcmp(material_string, "NULL") && strcmp(material_string, "0")) {
    // A geometry string was given, use it to determine which material
    if (0 == strcmp(material_string,"vacuum") || 0 == strcmp(material_string,"Vacuum")) {
        // One could have a global physics struct for vacuum instead of creating one for each
        this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
        this_box_volume.p_physics->is_vacuum = 1; // Makes this volume a vacuum
        this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
        this_box_volume.p_physics->my_a = 0; // Should not be used.
        sprintf(this_box_volume.p_physics->name,"Vacuum");
    } else if (0 == strcmp(material_string,"exit") || 0 == strcmp(material_string,"Exit")) {
        // One could have a global physics struct for vacuum instead of creating one for each
        this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
        this_box_volume.p_physics->is_vacuum = 1; // Makes this volume a vacuum
        this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
        this_box_volume.p_physics->my_a = 0; // Should not be used.
        this_box_volume.geometry.is_exit_volume = 1;
        sprintf(this_box_volume.p_physics->name,"Exit");
    } else {
        #ifndef MATERIAL_DETECTOR
            printf("Need to define a material before refering to it in a geometry %s.\n",NAME_CURRENT_COMP);
            exit(1);
        #endif
        for (loop_index=0;loop_index<global_material_list.num_elements;loop_index++) {
            if (0 == strcmp(material_string,global_material_list.elements[loop_index].name)) {
                this_box_volume.p_physics = global_material_list.elements[loop_index].physics;
                break;
            }
            if (loop_index == global_material_list.num_elements-1) {
            printf("\n");
            printf("ERROR: The material string \"%s\" in Union geometry \"%s\" did not match a specified material. \n",material_string,NAME_CURRENT_COMP);
            printf("       The materials available at this point (need to be defined before the geometry): \n");
            for (loop_index=0;loop_index<global_material_list.num_elements;loop_index++)
              printf("         %s\n",global_material_list.elements[loop_index].name);
            printf("\n");
            printf("       It is also possible to use one of the defualt materials avaiable: \n");
            printf("           Vacuum (for a Volume without scattering or absorption)\n");
            printf("           Exit (for a Volume where the ray exits the component if it enters)\n");
            printf("           Mask (for a Volume that masks existing volumes specified in the mask_string\n");
            exit(1);
          }
        }
    }
} else {
    // Automatic linking, simply using the last defined material.
    #ifndef MATERIAL_DETECTOR
        printf("Need to define a material before the geometry to use automatic linking %s.\n",NAME_CURRENT_COMP);
        exit(1);
    #endif
    this_box_volume.p_physics = global_material_list.elements[global_material_list.num_elements-1].physics;
}

sprintf(this_box_volume.name,NAME_CURRENT_COMP);
sprintf(this_box_volume.geometry.shape,"box");
this_box_volume.geometry.priority_value = priority;
this_box_volume.geometry.geometry_p_interact = p_interact;
// Currently the coordinates will be in absolute space.
this_box_volume.geometry.center = POS_A_CURRENT_COMP;

this_box_storage.z_depth = zdepth;
this_box_storage.x_width1 = xwidth;
this_box_storage.y_height1 = yheight;

this_box_storage.is_rectangle = 0;
if (xwidth2 < 0 && yheight2 < 0) this_box_storage.is_rectangle = 1;
if (xwidth == xwidth2 && yheight == yheight2) this_box_storage.is_rectangle = 1;

if (xwidth2 < 0) {
    this_box_storage.x_width2 = xwidth;
    xwidth2 = xwidth;
} else this_box_storage.x_width2 = xwidth2;

if (yheight2 < 0) {
    this_box_storage.y_height2 = yheight;
    yheight2 = yheight;
} else this_box_storage.y_height2 = yheight2;


this_box_storage.normal_vectors[0] = coords_set(0,0,1);
this_box_storage.normal_vectors[1] = coords_set(0,0,1);

// for sides with y component = 0
x_component = 2*zdepth/sqrt((xwidth-xwidth2)*(xwidth-xwidth2)+4*zdepth*zdepth);
z_component = (xwidth-xwidth2)/sqrt(4*zdepth*zdepth+(xwidth-xwidth2)*(xwidth-xwidth2));

this_box_storage.normal_vectors[2] = coords_set(x_component,0,z_component);
this_box_storage.normal_vectors[3] = coords_set(-x_component,0,z_component);

// for sides with x component = 0
y_component = 2*zdepth/sqrt((yheight-yheight2)*(yheight-yheight2)+4*zdepth*zdepth);
z_component = (yheight-yheight2)/sqrt(4*zdepth*zdepth+(yheight-yheight2)*(yheight-yheight2));

this_box_storage.normal_vectors[4] = coords_set(0,y_component,z_component);
this_box_storage.normal_vectors[5] = coords_set(0,-y_component,z_component);

this_box_volume.geometry.visualization_on = visualize;

this_box_volume.geometry.geometry_parameters.p_box_storage = &this_box_storage;

// Assign pointers to functions for intersection with the shape, checking if a point is inside the shape
if (this_box_storage.is_rectangle == 1) {
this_box_volume.geometry.intersect_function = &sample_box_intersect_simple;
this_box_volume.geometry.within_function = &r_within_box_simple;
}
else {
this_box_volume.geometry.intersect_function = &sample_box_intersect_advanced;
this_box_volume.geometry.within_function = &r_within_box_advanced;
}

this_box_volume.geometry.shell_points = &box_shell_points;
this_box_volume.geometry.mcdisplay_function = &mcdisplay_box_function;
this_box_volume.geometry.initialize_from_main_function = &initialize_box_geometry_from_main_component;
this_box_volume.geometry.process_rot_allocated = 0;

this_box_volume.geometry.copy_geometry_parameters = &allocate_box_storage_copy;

rot_copy(this_box_volume.geometry.rotation_matrix,ROT_A_CURRENT_COMP); //check how ROT_R_CURRENT_COMP would work
rot_transpose(ROT_A_CURRENT_COMP,this_box_volume.geometry.transpose_rotation_matrix);

// Initialize loggers
this_box_volume.loggers.num_elements = 0;

// packing the information into the global_geometry_element, which is then included in the global_geometry_list.
sprintf(global_geometry_element.name,NAME_CURRENT_COMP);
global_geometry_element.activation_counter = number_of_activations;
global_geometry_element.component_index = INDEX_CURRENT_COMP;
global_geometry_element.Volume = &this_box_volume; // Would be nicer if this m was a pointer, now we have the (small) data two places
add_element_to_geometry_list(&global_geometry_list,global_geometry_element);
}
#line 187451 "MACS_sample_kidney_box.c"
#undef number_of_activations
#undef mask_setting
#undef mask_string
#undef p_interact
#undef focus_r
#undef focus_xh
#undef focus_xw
#undef focus_ah
#undef focus_aw
#undef target_z
#undef target_y
#undef target_x
#undef target_index
#undef visualize
#undef yheight2
#undef xwidth2
#undef zdepth
#undef yheight
#undef xwidth
#undef priority
#undef material_string
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

  /* Initializations for component channel_2_analyzer_2_array_crystal_array_7. */
  SIG_MESSAGE("channel_2_analyzer_2_array_crystal_array_7 (Init)");
#define mccompcurname  channel_2_analyzer_2_array_crystal_array_7
#define mccompcurtype  Union_box
#define mccompcurindex 224
#define loop_index mccchannel_2_analyzer_2_array_crystal_array_7_loop_index
#define this_box_volume mccchannel_2_analyzer_2_array_crystal_array_7_this_box_volume
#define global_geometry_element mccchannel_2_analyzer_2_array_crystal_array_7_global_geometry_element
#define this_box_storage mccchannel_2_analyzer_2_array_crystal_array_7_this_box_storage
#define material_string mccchannel_2_analyzer_2_array_crystal_array_7_material_string
#define priority mccchannel_2_analyzer_2_array_crystal_array_7_priority
#define xwidth mccchannel_2_analyzer_2_array_crystal_array_7_xwidth
#define yheight mccchannel_2_analyzer_2_array_crystal_array_7_yheight
#define zdepth mccchannel_2_analyzer_2_array_crystal_array_7_zdepth
#define xwidth2 mccchannel_2_analyzer_2_array_crystal_array_7_xwidth2
#define yheight2 mccchannel_2_analyzer_2_array_crystal_array_7_yheight2
#define visualize mccchannel_2_analyzer_2_array_crystal_array_7_visualize
#define target_index mccchannel_2_analyzer_2_array_crystal_array_7_target_index
#define target_x mccchannel_2_analyzer_2_array_crystal_array_7_target_x
#define target_y mccchannel_2_analyzer_2_array_crystal_array_7_target_y
#define target_z mccchannel_2_analyzer_2_array_crystal_array_7_target_z
#define focus_aw mccchannel_2_analyzer_2_array_crystal_array_7_focus_aw
#define focus_ah mccchannel_2_analyzer_2_array_crystal_array_7_focus_ah
#define focus_xw mccchannel_2_analyzer_2_array_crystal_array_7_focus_xw
#define focus_xh mccchannel_2_analyzer_2_array_crystal_array_7_focus_xh
#define focus_r mccchannel_2_analyzer_2_array_crystal_array_7_focus_r
#define p_interact mccchannel_2_analyzer_2_array_crystal_array_7_p_interact
#define mask_string mccchannel_2_analyzer_2_array_crystal_array_7_mask_string
#define mask_setting mccchannel_2_analyzer_2_array_crystal_array_7_mask_setting
#define number_of_activations mccchannel_2_analyzer_2_array_crystal_array_7_number_of_activations
#line 224 "Union_box.comp"
{
// Initializes the focusing system for this volume including input sanitation.
focus_initialize(&this_box_volume.geometry, POS_A_COMP_INDEX(INDEX_CURRENT_COMP+target_index), POS_A_CURRENT_COMP, ROT_A_CURRENT_COMP, target_index, target_x, target_y, target_z, focus_aw, focus_ah, focus_xw, focus_xh, focus_r, NAME_CURRENT_COMP);

// Input sanitation for this geometry
if (xwidth <= 0) {
  printf("\nERROR in Union_box named %s, the xwidth is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (yheight <= 0) {
  printf("\nERROR in Union_box named %s, yheight is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (zdepth <= 0) {
  printf("\nERROR in Union_box named %s, zdepth is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (xwidth2 <= 0 && xwidth2 != -1) {
  printf("\nERROR in Union_box named %s, the xwidth2 is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (yheight2 <= 0 && yheight2 != -1) {
  printf("\nERROR in Union_box named %s, yheight2 is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}

// Use sanitation
if (global_material_list.num_elements == 0) {
  printf("\nERROR: Need to define a material using Union_make_material before using a Union geometry component. \n");
  printf("       %s was defined before first use of Union_make_material.\n",NAME_CURRENT_COMP);
  exit(1);
}

this_box_volume.geometry.is_masked_volume = 0;
this_box_volume.geometry.is_exit_volume = 0;
this_box_volume.geometry.is_mask_volume = 0;
// check if the volume is a mask, if it is the material string is irelevant.
if (mask_string && strlen(mask_string) && strcmp(mask_string, "NULL") && strcmp(mask_string, "0")) {
    // A mask volume is used to limit the extend of other volumes, called the masked volumes. These are specified in the mask_string.
    // In order for a ray to enter a masked volume, it needs to be both in the region covered by that volume AND the mask volume.
    // When more than
    this_box_volume.geometry.mask_mode = 1; // Default is mask mode is ALL
    if (mask_setting && strlen(mask_setting) && strcmp(mask_setting, "NULL") && strcmp(mask_setting, "0")) {
        if (strcmp(mask_setting,"ALL") == 0 || strcmp(mask_setting,"All") == 0) this_box_volume.geometry.mask_mode = 1;
        else if (strcmp(mask_setting,"ANY") == 0 || strcmp(mask_setting,"Any") == 0) this_box_volume.geometry.mask_mode = 2;
        else {
            printf("The mask_mode of component %s is set to %s, but must be either ALL or ANY.\n",NAME_CURRENT_COMP,mask_setting);
            exit(1);
        }
    }
    
    for (loop_index=0;loop_index<global_geometry_list.num_elements;loop_index++) {
        // Add mask list
        if (1 == manual_linking_function(global_geometry_list.elements[loop_index].name,mask_string)) {
            add_element_to_int_list(&this_box_volume.geometry.mask_list,global_geometry_list.elements[loop_index].component_index);
            add_element_to_int_list(&global_geometry_list.elements[loop_index].Volume->geometry.masked_by_list,INDEX_CURRENT_COMP);
            global_geometry_list.elements[loop_index].Volume->geometry.is_masked_volume = 1;
            if (this_box_volume.geometry.mask_mode == 2)
                global_geometry_list.elements[loop_index].Volume->geometry.mask_mode = 2;
            if (this_box_volume.geometry.mask_mode == 1) {
                if (global_geometry_list.elements[loop_index].Volume->geometry.is_masked_volume == 1 && global_geometry_list.elements[loop_index].Volume->geometry.mask_mode != 2)
                    // If more than one mask is added to one volume, the ANY mode overwrites the (default) ALL mode.
                    global_geometry_list.elements[loop_index].Volume->geometry.mask_mode = 1;
            }
            
            found_geometries = 1;
        }
    }
    if (found_geometries == 0) {
        printf("The mask_string in geometry: %s did not find any of the specified volumes in the mask_string %s \n",NAME_CURRENT_COMP,mask_string);
        exit(1);
    }
    this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
    this_box_volume.p_physics->is_vacuum = 0; // Makes this volume a vacuum
    this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
    this_box_volume.p_physics->my_a = 0; // Should not be used.
    sprintf(this_box_volume.p_physics->name,"Mask");
    this_box_volume.geometry.is_mask_volume = 1;
    
    
// Read the material input, or if it lacks, use automatic linking.
} else if (material_string && strlen(material_string) && strcmp(material_string, "NULL") && strcmp(material_string, "0")) {
    // A geometry string was given, use it to determine which material
    if (0 == strcmp(material_string,"vacuum") || 0 == strcmp(material_string,"Vacuum")) {
        // One could have a global physics struct for vacuum instead of creating one for each
        this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
        this_box_volume.p_physics->is_vacuum = 1; // Makes this volume a vacuum
        this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
        this_box_volume.p_physics->my_a = 0; // Should not be used.
        sprintf(this_box_volume.p_physics->name,"Vacuum");
    } else if (0 == strcmp(material_string,"exit") || 0 == strcmp(material_string,"Exit")) {
        // One could have a global physics struct for vacuum instead of creating one for each
        this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
        this_box_volume.p_physics->is_vacuum = 1; // Makes this volume a vacuum
        this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
        this_box_volume.p_physics->my_a = 0; // Should not be used.
        this_box_volume.geometry.is_exit_volume = 1;
        sprintf(this_box_volume.p_physics->name,"Exit");
    } else {
        #ifndef MATERIAL_DETECTOR
            printf("Need to define a material before refering to it in a geometry %s.\n",NAME_CURRENT_COMP);
            exit(1);
        #endif
        for (loop_index=0;loop_index<global_material_list.num_elements;loop_index++) {
            if (0 == strcmp(material_string,global_material_list.elements[loop_index].name)) {
                this_box_volume.p_physics = global_material_list.elements[loop_index].physics;
                break;
            }
            if (loop_index == global_material_list.num_elements-1) {
            printf("\n");
            printf("ERROR: The material string \"%s\" in Union geometry \"%s\" did not match a specified material. \n",material_string,NAME_CURRENT_COMP);
            printf("       The materials available at this point (need to be defined before the geometry): \n");
            for (loop_index=0;loop_index<global_material_list.num_elements;loop_index++)
              printf("         %s\n",global_material_list.elements[loop_index].name);
            printf("\n");
            printf("       It is also possible to use one of the defualt materials avaiable: \n");
            printf("           Vacuum (for a Volume without scattering or absorption)\n");
            printf("           Exit (for a Volume where the ray exits the component if it enters)\n");
            printf("           Mask (for a Volume that masks existing volumes specified in the mask_string\n");
            exit(1);
          }
        }
    }
} else {
    // Automatic linking, simply using the last defined material.
    #ifndef MATERIAL_DETECTOR
        printf("Need to define a material before the geometry to use automatic linking %s.\n",NAME_CURRENT_COMP);
        exit(1);
    #endif
    this_box_volume.p_physics = global_material_list.elements[global_material_list.num_elements-1].physics;
}

sprintf(this_box_volume.name,NAME_CURRENT_COMP);
sprintf(this_box_volume.geometry.shape,"box");
this_box_volume.geometry.priority_value = priority;
this_box_volume.geometry.geometry_p_interact = p_interact;
// Currently the coordinates will be in absolute space.
this_box_volume.geometry.center = POS_A_CURRENT_COMP;

this_box_storage.z_depth = zdepth;
this_box_storage.x_width1 = xwidth;
this_box_storage.y_height1 = yheight;

this_box_storage.is_rectangle = 0;
if (xwidth2 < 0 && yheight2 < 0) this_box_storage.is_rectangle = 1;
if (xwidth == xwidth2 && yheight == yheight2) this_box_storage.is_rectangle = 1;

if (xwidth2 < 0) {
    this_box_storage.x_width2 = xwidth;
    xwidth2 = xwidth;
} else this_box_storage.x_width2 = xwidth2;

if (yheight2 < 0) {
    this_box_storage.y_height2 = yheight;
    yheight2 = yheight;
} else this_box_storage.y_height2 = yheight2;


this_box_storage.normal_vectors[0] = coords_set(0,0,1);
this_box_storage.normal_vectors[1] = coords_set(0,0,1);

// for sides with y component = 0
x_component = 2*zdepth/sqrt((xwidth-xwidth2)*(xwidth-xwidth2)+4*zdepth*zdepth);
z_component = (xwidth-xwidth2)/sqrt(4*zdepth*zdepth+(xwidth-xwidth2)*(xwidth-xwidth2));

this_box_storage.normal_vectors[2] = coords_set(x_component,0,z_component);
this_box_storage.normal_vectors[3] = coords_set(-x_component,0,z_component);

// for sides with x component = 0
y_component = 2*zdepth/sqrt((yheight-yheight2)*(yheight-yheight2)+4*zdepth*zdepth);
z_component = (yheight-yheight2)/sqrt(4*zdepth*zdepth+(yheight-yheight2)*(yheight-yheight2));

this_box_storage.normal_vectors[4] = coords_set(0,y_component,z_component);
this_box_storage.normal_vectors[5] = coords_set(0,-y_component,z_component);

this_box_volume.geometry.visualization_on = visualize;

this_box_volume.geometry.geometry_parameters.p_box_storage = &this_box_storage;

// Assign pointers to functions for intersection with the shape, checking if a point is inside the shape
if (this_box_storage.is_rectangle == 1) {
this_box_volume.geometry.intersect_function = &sample_box_intersect_simple;
this_box_volume.geometry.within_function = &r_within_box_simple;
}
else {
this_box_volume.geometry.intersect_function = &sample_box_intersect_advanced;
this_box_volume.geometry.within_function = &r_within_box_advanced;
}

this_box_volume.geometry.shell_points = &box_shell_points;
this_box_volume.geometry.mcdisplay_function = &mcdisplay_box_function;
this_box_volume.geometry.initialize_from_main_function = &initialize_box_geometry_from_main_component;
this_box_volume.geometry.process_rot_allocated = 0;

this_box_volume.geometry.copy_geometry_parameters = &allocate_box_storage_copy;

rot_copy(this_box_volume.geometry.rotation_matrix,ROT_A_CURRENT_COMP); //check how ROT_R_CURRENT_COMP would work
rot_transpose(ROT_A_CURRENT_COMP,this_box_volume.geometry.transpose_rotation_matrix);

// Initialize loggers
this_box_volume.loggers.num_elements = 0;

// packing the information into the global_geometry_element, which is then included in the global_geometry_list.
sprintf(global_geometry_element.name,NAME_CURRENT_COMP);
global_geometry_element.activation_counter = number_of_activations;
global_geometry_element.component_index = INDEX_CURRENT_COMP;
global_geometry_element.Volume = &this_box_volume; // Would be nicer if this m was a pointer, now we have the (small) data two places
add_element_to_geometry_list(&global_geometry_list,global_geometry_element);
}
#line 187721 "MACS_sample_kidney_box.c"
#undef number_of_activations
#undef mask_setting
#undef mask_string
#undef p_interact
#undef focus_r
#undef focus_xh
#undef focus_xw
#undef focus_ah
#undef focus_aw
#undef target_z
#undef target_y
#undef target_x
#undef target_index
#undef visualize
#undef yheight2
#undef xwidth2
#undef zdepth
#undef yheight
#undef xwidth
#undef priority
#undef material_string
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

  /* Initializations for component channel_2_analyzer_2_array_crystal_array_8. */
  SIG_MESSAGE("channel_2_analyzer_2_array_crystal_array_8 (Init)");
#define mccompcurname  channel_2_analyzer_2_array_crystal_array_8
#define mccompcurtype  Union_box
#define mccompcurindex 225
#define loop_index mccchannel_2_analyzer_2_array_crystal_array_8_loop_index
#define this_box_volume mccchannel_2_analyzer_2_array_crystal_array_8_this_box_volume
#define global_geometry_element mccchannel_2_analyzer_2_array_crystal_array_8_global_geometry_element
#define this_box_storage mccchannel_2_analyzer_2_array_crystal_array_8_this_box_storage
#define material_string mccchannel_2_analyzer_2_array_crystal_array_8_material_string
#define priority mccchannel_2_analyzer_2_array_crystal_array_8_priority
#define xwidth mccchannel_2_analyzer_2_array_crystal_array_8_xwidth
#define yheight mccchannel_2_analyzer_2_array_crystal_array_8_yheight
#define zdepth mccchannel_2_analyzer_2_array_crystal_array_8_zdepth
#define xwidth2 mccchannel_2_analyzer_2_array_crystal_array_8_xwidth2
#define yheight2 mccchannel_2_analyzer_2_array_crystal_array_8_yheight2
#define visualize mccchannel_2_analyzer_2_array_crystal_array_8_visualize
#define target_index mccchannel_2_analyzer_2_array_crystal_array_8_target_index
#define target_x mccchannel_2_analyzer_2_array_crystal_array_8_target_x
#define target_y mccchannel_2_analyzer_2_array_crystal_array_8_target_y
#define target_z mccchannel_2_analyzer_2_array_crystal_array_8_target_z
#define focus_aw mccchannel_2_analyzer_2_array_crystal_array_8_focus_aw
#define focus_ah mccchannel_2_analyzer_2_array_crystal_array_8_focus_ah
#define focus_xw mccchannel_2_analyzer_2_array_crystal_array_8_focus_xw
#define focus_xh mccchannel_2_analyzer_2_array_crystal_array_8_focus_xh
#define focus_r mccchannel_2_analyzer_2_array_crystal_array_8_focus_r
#define p_interact mccchannel_2_analyzer_2_array_crystal_array_8_p_interact
#define mask_string mccchannel_2_analyzer_2_array_crystal_array_8_mask_string
#define mask_setting mccchannel_2_analyzer_2_array_crystal_array_8_mask_setting
#define number_of_activations mccchannel_2_analyzer_2_array_crystal_array_8_number_of_activations
#line 224 "Union_box.comp"
{
// Initializes the focusing system for this volume including input sanitation.
focus_initialize(&this_box_volume.geometry, POS_A_COMP_INDEX(INDEX_CURRENT_COMP+target_index), POS_A_CURRENT_COMP, ROT_A_CURRENT_COMP, target_index, target_x, target_y, target_z, focus_aw, focus_ah, focus_xw, focus_xh, focus_r, NAME_CURRENT_COMP);

// Input sanitation for this geometry
if (xwidth <= 0) {
  printf("\nERROR in Union_box named %s, the xwidth is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (yheight <= 0) {
  printf("\nERROR in Union_box named %s, yheight is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (zdepth <= 0) {
  printf("\nERROR in Union_box named %s, zdepth is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (xwidth2 <= 0 && xwidth2 != -1) {
  printf("\nERROR in Union_box named %s, the xwidth2 is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (yheight2 <= 0 && yheight2 != -1) {
  printf("\nERROR in Union_box named %s, yheight2 is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}

// Use sanitation
if (global_material_list.num_elements == 0) {
  printf("\nERROR: Need to define a material using Union_make_material before using a Union geometry component. \n");
  printf("       %s was defined before first use of Union_make_material.\n",NAME_CURRENT_COMP);
  exit(1);
}

this_box_volume.geometry.is_masked_volume = 0;
this_box_volume.geometry.is_exit_volume = 0;
this_box_volume.geometry.is_mask_volume = 0;
// check if the volume is a mask, if it is the material string is irelevant.
if (mask_string && strlen(mask_string) && strcmp(mask_string, "NULL") && strcmp(mask_string, "0")) {
    // A mask volume is used to limit the extend of other volumes, called the masked volumes. These are specified in the mask_string.
    // In order for a ray to enter a masked volume, it needs to be both in the region covered by that volume AND the mask volume.
    // When more than
    this_box_volume.geometry.mask_mode = 1; // Default is mask mode is ALL
    if (mask_setting && strlen(mask_setting) && strcmp(mask_setting, "NULL") && strcmp(mask_setting, "0")) {
        if (strcmp(mask_setting,"ALL") == 0 || strcmp(mask_setting,"All") == 0) this_box_volume.geometry.mask_mode = 1;
        else if (strcmp(mask_setting,"ANY") == 0 || strcmp(mask_setting,"Any") == 0) this_box_volume.geometry.mask_mode = 2;
        else {
            printf("The mask_mode of component %s is set to %s, but must be either ALL or ANY.\n",NAME_CURRENT_COMP,mask_setting);
            exit(1);
        }
    }
    
    for (loop_index=0;loop_index<global_geometry_list.num_elements;loop_index++) {
        // Add mask list
        if (1 == manual_linking_function(global_geometry_list.elements[loop_index].name,mask_string)) {
            add_element_to_int_list(&this_box_volume.geometry.mask_list,global_geometry_list.elements[loop_index].component_index);
            add_element_to_int_list(&global_geometry_list.elements[loop_index].Volume->geometry.masked_by_list,INDEX_CURRENT_COMP);
            global_geometry_list.elements[loop_index].Volume->geometry.is_masked_volume = 1;
            if (this_box_volume.geometry.mask_mode == 2)
                global_geometry_list.elements[loop_index].Volume->geometry.mask_mode = 2;
            if (this_box_volume.geometry.mask_mode == 1) {
                if (global_geometry_list.elements[loop_index].Volume->geometry.is_masked_volume == 1 && global_geometry_list.elements[loop_index].Volume->geometry.mask_mode != 2)
                    // If more than one mask is added to one volume, the ANY mode overwrites the (default) ALL mode.
                    global_geometry_list.elements[loop_index].Volume->geometry.mask_mode = 1;
            }
            
            found_geometries = 1;
        }
    }
    if (found_geometries == 0) {
        printf("The mask_string in geometry: %s did not find any of the specified volumes in the mask_string %s \n",NAME_CURRENT_COMP,mask_string);
        exit(1);
    }
    this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
    this_box_volume.p_physics->is_vacuum = 0; // Makes this volume a vacuum
    this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
    this_box_volume.p_physics->my_a = 0; // Should not be used.
    sprintf(this_box_volume.p_physics->name,"Mask");
    this_box_volume.geometry.is_mask_volume = 1;
    
    
// Read the material input, or if it lacks, use automatic linking.
} else if (material_string && strlen(material_string) && strcmp(material_string, "NULL") && strcmp(material_string, "0")) {
    // A geometry string was given, use it to determine which material
    if (0 == strcmp(material_string,"vacuum") || 0 == strcmp(material_string,"Vacuum")) {
        // One could have a global physics struct for vacuum instead of creating one for each
        this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
        this_box_volume.p_physics->is_vacuum = 1; // Makes this volume a vacuum
        this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
        this_box_volume.p_physics->my_a = 0; // Should not be used.
        sprintf(this_box_volume.p_physics->name,"Vacuum");
    } else if (0 == strcmp(material_string,"exit") || 0 == strcmp(material_string,"Exit")) {
        // One could have a global physics struct for vacuum instead of creating one for each
        this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
        this_box_volume.p_physics->is_vacuum = 1; // Makes this volume a vacuum
        this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
        this_box_volume.p_physics->my_a = 0; // Should not be used.
        this_box_volume.geometry.is_exit_volume = 1;
        sprintf(this_box_volume.p_physics->name,"Exit");
    } else {
        #ifndef MATERIAL_DETECTOR
            printf("Need to define a material before refering to it in a geometry %s.\n",NAME_CURRENT_COMP);
            exit(1);
        #endif
        for (loop_index=0;loop_index<global_material_list.num_elements;loop_index++) {
            if (0 == strcmp(material_string,global_material_list.elements[loop_index].name)) {
                this_box_volume.p_physics = global_material_list.elements[loop_index].physics;
                break;
            }
            if (loop_index == global_material_list.num_elements-1) {
            printf("\n");
            printf("ERROR: The material string \"%s\" in Union geometry \"%s\" did not match a specified material. \n",material_string,NAME_CURRENT_COMP);
            printf("       The materials available at this point (need to be defined before the geometry): \n");
            for (loop_index=0;loop_index<global_material_list.num_elements;loop_index++)
              printf("         %s\n",global_material_list.elements[loop_index].name);
            printf("\n");
            printf("       It is also possible to use one of the defualt materials avaiable: \n");
            printf("           Vacuum (for a Volume without scattering or absorption)\n");
            printf("           Exit (for a Volume where the ray exits the component if it enters)\n");
            printf("           Mask (for a Volume that masks existing volumes specified in the mask_string\n");
            exit(1);
          }
        }
    }
} else {
    // Automatic linking, simply using the last defined material.
    #ifndef MATERIAL_DETECTOR
        printf("Need to define a material before the geometry to use automatic linking %s.\n",NAME_CURRENT_COMP);
        exit(1);
    #endif
    this_box_volume.p_physics = global_material_list.elements[global_material_list.num_elements-1].physics;
}

sprintf(this_box_volume.name,NAME_CURRENT_COMP);
sprintf(this_box_volume.geometry.shape,"box");
this_box_volume.geometry.priority_value = priority;
this_box_volume.geometry.geometry_p_interact = p_interact;
// Currently the coordinates will be in absolute space.
this_box_volume.geometry.center = POS_A_CURRENT_COMP;

this_box_storage.z_depth = zdepth;
this_box_storage.x_width1 = xwidth;
this_box_storage.y_height1 = yheight;

this_box_storage.is_rectangle = 0;
if (xwidth2 < 0 && yheight2 < 0) this_box_storage.is_rectangle = 1;
if (xwidth == xwidth2 && yheight == yheight2) this_box_storage.is_rectangle = 1;

if (xwidth2 < 0) {
    this_box_storage.x_width2 = xwidth;
    xwidth2 = xwidth;
} else this_box_storage.x_width2 = xwidth2;

if (yheight2 < 0) {
    this_box_storage.y_height2 = yheight;
    yheight2 = yheight;
} else this_box_storage.y_height2 = yheight2;


this_box_storage.normal_vectors[0] = coords_set(0,0,1);
this_box_storage.normal_vectors[1] = coords_set(0,0,1);

// for sides with y component = 0
x_component = 2*zdepth/sqrt((xwidth-xwidth2)*(xwidth-xwidth2)+4*zdepth*zdepth);
z_component = (xwidth-xwidth2)/sqrt(4*zdepth*zdepth+(xwidth-xwidth2)*(xwidth-xwidth2));

this_box_storage.normal_vectors[2] = coords_set(x_component,0,z_component);
this_box_storage.normal_vectors[3] = coords_set(-x_component,0,z_component);

// for sides with x component = 0
y_component = 2*zdepth/sqrt((yheight-yheight2)*(yheight-yheight2)+4*zdepth*zdepth);
z_component = (yheight-yheight2)/sqrt(4*zdepth*zdepth+(yheight-yheight2)*(yheight-yheight2));

this_box_storage.normal_vectors[4] = coords_set(0,y_component,z_component);
this_box_storage.normal_vectors[5] = coords_set(0,-y_component,z_component);

this_box_volume.geometry.visualization_on = visualize;

this_box_volume.geometry.geometry_parameters.p_box_storage = &this_box_storage;

// Assign pointers to functions for intersection with the shape, checking if a point is inside the shape
if (this_box_storage.is_rectangle == 1) {
this_box_volume.geometry.intersect_function = &sample_box_intersect_simple;
this_box_volume.geometry.within_function = &r_within_box_simple;
}
else {
this_box_volume.geometry.intersect_function = &sample_box_intersect_advanced;
this_box_volume.geometry.within_function = &r_within_box_advanced;
}

this_box_volume.geometry.shell_points = &box_shell_points;
this_box_volume.geometry.mcdisplay_function = &mcdisplay_box_function;
this_box_volume.geometry.initialize_from_main_function = &initialize_box_geometry_from_main_component;
this_box_volume.geometry.process_rot_allocated = 0;

this_box_volume.geometry.copy_geometry_parameters = &allocate_box_storage_copy;

rot_copy(this_box_volume.geometry.rotation_matrix,ROT_A_CURRENT_COMP); //check how ROT_R_CURRENT_COMP would work
rot_transpose(ROT_A_CURRENT_COMP,this_box_volume.geometry.transpose_rotation_matrix);

// Initialize loggers
this_box_volume.loggers.num_elements = 0;

// packing the information into the global_geometry_element, which is then included in the global_geometry_list.
sprintf(global_geometry_element.name,NAME_CURRENT_COMP);
global_geometry_element.activation_counter = number_of_activations;
global_geometry_element.component_index = INDEX_CURRENT_COMP;
global_geometry_element.Volume = &this_box_volume; // Would be nicer if this m was a pointer, now we have the (small) data two places
add_element_to_geometry_list(&global_geometry_list,global_geometry_element);
}
#line 187991 "MACS_sample_kidney_box.c"
#undef number_of_activations
#undef mask_setting
#undef mask_string
#undef p_interact
#undef focus_r
#undef focus_xh
#undef focus_xw
#undef focus_ah
#undef focus_aw
#undef target_z
#undef target_y
#undef target_x
#undef target_index
#undef visualize
#undef yheight2
#undef xwidth2
#undef zdepth
#undef yheight
#undef xwidth
#undef priority
#undef material_string
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

  /* Initializations for component channel_2_cave2_cyl1. */
  SIG_MESSAGE("channel_2_cave2_cyl1 (Init)");
#define mccompcurname  channel_2_cave2_cyl1
#define mccompcurtype  Union_cylinder
#define mccompcurindex 226
#define loop_index mccchannel_2_cave2_cyl1_loop_index
#define this_cylinder_volume mccchannel_2_cave2_cyl1_this_cylinder_volume
#define global_geometry_element mccchannel_2_cave2_cyl1_global_geometry_element
#define this_cylinder_storage mccchannel_2_cave2_cyl1_this_cylinder_storage
#define material_string mccchannel_2_cave2_cyl1_material_string
#define priority mccchannel_2_cave2_cyl1_priority
#define radius mccchannel_2_cave2_cyl1_radius
#define yheight mccchannel_2_cave2_cyl1_yheight
#define visualize mccchannel_2_cave2_cyl1_visualize
#define target_index mccchannel_2_cave2_cyl1_target_index
#define target_x mccchannel_2_cave2_cyl1_target_x
#define target_y mccchannel_2_cave2_cyl1_target_y
#define target_z mccchannel_2_cave2_cyl1_target_z
#define focus_aw mccchannel_2_cave2_cyl1_focus_aw
#define focus_ah mccchannel_2_cave2_cyl1_focus_ah
#define focus_xw mccchannel_2_cave2_cyl1_focus_xw
#define focus_xh mccchannel_2_cave2_cyl1_focus_xh
#define focus_r mccchannel_2_cave2_cyl1_focus_r
#define p_interact mccchannel_2_cave2_cyl1_p_interact
#define mask_string mccchannel_2_cave2_cyl1_mask_string
#define mask_setting mccchannel_2_cave2_cyl1_mask_setting
#define number_of_activations mccchannel_2_cave2_cyl1_number_of_activations
#line 185 "Union_cylinder.comp"
{
// Initializes the focusing system for this volume including input sanitation.
focus_initialize(&this_cylinder_volume.geometry, POS_A_COMP_INDEX(INDEX_CURRENT_COMP+target_index), POS_A_CURRENT_COMP, ROT_A_CURRENT_COMP, target_index, target_x, target_y, target_z, focus_aw, focus_ah, focus_xw, focus_xh, focus_r, NAME_CURRENT_COMP);

// Input sanitation for this geometry
if (radius <= 0) {
  printf("\nERROR in Union_cylinder named %s, the radius is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}

if (yheight <= 0) {
  printf("\nERROR in Union_cylinder named %s, yheight is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}

// Use sanitation
#ifdef MATERIAL_DETECTOR
if (global_material_list.num_elements == 0) {
  // Here if the user have defined a material, but only after this material
  printf("\nERROR: Need to define a material using Union_make_material before using a Union geometry component. \n");
  printf("       %s was defined before first use of Union_make_material.\n",NAME_CURRENT_COMP);
  exit(1);
}
#endif
#ifndef MATERIAL_DETECTOR
  printf("\nERROR: Need to define a material using Union_make_material before using a Union geometry component. \n");
  exit(1);
#endif


this_cylinder_volume.geometry.is_masked_volume = 0;
this_cylinder_volume.geometry.is_exit_volume = 0;
this_cylinder_volume.geometry.is_mask_volume = 0;

// Read the material input, or if it lacks, use automatic linking.
if (mask_string && strlen(mask_string) && strcmp(mask_string, "NULL") && strcmp(mask_string, "0")) {
    // A mask volume is used to limit the extend of other volumes, called the masked volumes. These are specified in the mask_string.
    // In order for a ray to enter a masked volume, it needs to be both in the region covered by that volume AND the mask volume.
    // When more than
    this_cylinder_volume.geometry.mask_mode = 1; // Default is mask mode is ALL
    if (mask_setting && strlen(mask_setting) && strcmp(mask_setting, "NULL") && strcmp(mask_setting, "0")) {
        if (strcmp(mask_setting,"ALL") == 0 || strcmp(mask_setting,"All") == 0) this_cylinder_volume.geometry.mask_mode = 1;
        else if (strcmp(mask_setting,"ANY") == 0 || strcmp(mask_setting,"Any") == 0) this_cylinder_volume.geometry.mask_mode = 2;
        else {
            printf("The mask_mode of component %s is set to %s, but must be either ALL or ANY.\n",NAME_CURRENT_COMP,mask_setting);
            exit(1);
        }
    }
    
    for (loop_index=0;loop_index<global_geometry_list.num_elements;loop_index++) {
        // Add mask list
        if (1 == manual_linking_function(global_geometry_list.elements[loop_index].name,mask_string)) {
            add_element_to_int_list(&this_cylinder_volume.geometry.mask_list,global_geometry_list.elements[loop_index].component_index);
            add_element_to_int_list(&global_geometry_list.elements[loop_index].Volume->geometry.masked_by_list,INDEX_CURRENT_COMP);
            global_geometry_list.elements[loop_index].Volume->geometry.is_masked_volume = 1;
            if (this_cylinder_volume.geometry.mask_mode == 2)
                global_geometry_list.elements[loop_index].Volume->geometry.mask_mode = 2;
            if (this_cylinder_volume.geometry.mask_mode == 1) {
                if (global_geometry_list.elements[loop_index].Volume->geometry.is_masked_volume == 1 && global_geometry_list.elements[loop_index].Volume->geometry.mask_mode != 2)
                    // If more than one mask is added to one volume, the ANY mode overwrites the (default) ALL mode.
                    global_geometry_list.elements[loop_index].Volume->geometry.mask_mode = 1;
            }
            
            found_geometries = 1;
        }
    }
    if (found_geometries == 0) {
        printf("The mask_string in geometry: %s did not find any of the specified volumes in the mask_string %s \n",NAME_CURRENT_COMP,mask_string);
        exit(1);
    }
    this_cylinder_volume.p_physics = malloc(sizeof(struct physics_struct));
    this_cylinder_volume.p_physics->is_vacuum = 0; // Makes this volume a vacuum
    this_cylinder_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
    this_cylinder_volume.p_physics->my_a = 0; // Should not be used.
    sprintf(this_cylinder_volume.p_physics->name,"Mask");
    this_cylinder_volume.geometry.is_mask_volume = 1;
    
    
// Read the material input, or if it lacks, use automatic linking.
} else if (material_string && strlen(material_string) && strcmp(material_string, "NULL") && strcmp(material_string, "0")) {
    // A geometry string was given, use it to determine which material
    if (0 == strcmp(material_string,"vacuum") || 0 == strcmp(material_string,"Vacuum")) {
        // One could have a global physics struct for vacuum instead of creating one for each
        this_cylinder_volume.p_physics = malloc(sizeof(struct physics_struct));
        this_cylinder_volume.p_physics->is_vacuum = 1; // Makes this volume a vacuum
        this_cylinder_volume.p_physics->number_of_processes = (int) 0;
        this_cylinder_volume.p_physics->my_a = 0; // Should not be used.
        sprintf(this_cylinder_volume.p_physics->name,"Vacuum");
    } else if (0 == strcmp(material_string,"exit") || 0 == strcmp(material_string,"Exit")) {
        // One could have a global physics struct for exit instead of creating one for each
        this_cylinder_volume.p_physics = malloc(sizeof(struct physics_struct));
        this_cylinder_volume.p_physics->is_vacuum = 1; // Makes this volume a vacuum
        this_cylinder_volume.p_physics->number_of_processes = (int) 0;
        this_cylinder_volume.p_physics->my_a = 0; // Should not be used.
        this_cylinder_volume.geometry.is_exit_volume = 1;
        sprintf(this_cylinder_volume.p_physics->name,"Exit");
    } else {
        for (loop_index=0;loop_index<global_material_list.num_elements;loop_index++) {
          if (0 == strcmp(material_string,global_material_list.elements[loop_index].name)) {
            this_cylinder_volume.p_physics = global_material_list.elements[loop_index].physics;
            break;
          }
          if (loop_index == global_material_list.num_elements-1) {
            printf("\n");
            printf("ERROR: The material string \"%s\" in Union geometry \"%s\" did not match a specified material. \n",material_string,NAME_CURRENT_COMP);
            printf("       The materials available at this point (need to be defined before the geometry): \n");
            for (loop_index=0;loop_index<global_material_list.num_elements;loop_index++)
              printf("         %s\n",global_material_list.elements[loop_index].name);
            printf("\n");
            printf("       It is also possible to use one of the defualt materials avaiable: \n");
            printf("           Vacuum (for a Volume without scattering or absorption)\n");
            printf("           Exit (for a Volume where the ray exits the component if it enters)\n");
            printf("           Mask (for a Volume that masks existing volumes specified in the mask_string\n");
            exit(1);
          }
        }
    }
} else {
    // Automatic linking, simply using the last defined material.
    #ifndef MATERIAL_DETECTOR
        printf("Need to define a material before the geometry to use automatic linking %s.\n",NAME_CURRENT_COMP);
        exit(1);
    #endif
    this_cylinder_volume.p_physics = global_material_list.elements[global_material_list.num_elements-1].physics;
}

sprintf(this_cylinder_volume.name,NAME_CURRENT_COMP);
sprintf(this_cylinder_volume.geometry.shape,"cylinder");
this_cylinder_volume.geometry.priority_value = priority;
// Currently the coordinates will be in absolute space.
this_cylinder_volume.geometry.center = POS_A_CURRENT_COMP;

this_cylinder_volume.geometry.geometry_p_interact = p_interact;
this_cylinder_storage.cyl_radius = radius;
this_cylinder_storage.height = yheight;
this_cylinder_volume.geometry.visualization_on = visualize;
this_cylinder_volume.geometry.geometry_parameters.p_cylinder_storage = &this_cylinder_storage;
this_cylinder_volume.geometry.within_function = &r_within_cylinder;
this_cylinder_volume.geometry.intersect_function = &sample_cylinder_intersect;
this_cylinder_volume.geometry.mcdisplay_function = &mcdisplay_cylinder_function;
this_cylinder_volume.geometry.shell_points = &cylinder_shell_points;
this_cylinder_volume.geometry.initialize_from_main_function = &initialize_cylinder_geometry_from_main_component;
this_cylinder_volume.geometry.process_rot_allocated = 0;
this_cylinder_volume.geometry.copy_geometry_parameters = &allocate_cylinder_storage_copy;

rot_copy(this_cylinder_volume.geometry.rotation_matrix,ROT_A_CURRENT_COMP);
rot_transpose(ROT_A_CURRENT_COMP,this_cylinder_volume.geometry.transpose_rotation_matrix);

// Initialize loggers
this_cylinder_volume.loggers.num_elements = 0;

// packing the information into the global_geometry_element, which is then included in the global_geometry_list.
sprintf(global_geometry_element.name,NAME_CURRENT_COMP);
global_geometry_element.activation_counter = number_of_activations;
global_geometry_element.component_index = INDEX_CURRENT_COMP;
global_geometry_element.Volume = &this_cylinder_volume; // Would be nicer if this m was a pointer, now we have the (small) data two places
add_element_to_geometry_list(&global_geometry_list,global_geometry_element);
}
#line 188207 "MACS_sample_kidney_box.c"
#undef number_of_activations
#undef mask_setting
#undef mask_string
#undef p_interact
#undef focus_r
#undef focus_xh
#undef focus_xw
#undef focus_ah
#undef focus_aw
#undef target_z
#undef target_y
#undef target_x
#undef target_index
#undef visualize
#undef yheight
#undef radius
#undef priority
#undef material_string
#undef this_cylinder_storage
#undef global_geometry_element
#undef this_cylinder_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

  /* Initializations for component channel_2_cave2_box1. */
  SIG_MESSAGE("channel_2_cave2_box1 (Init)");
#define mccompcurname  channel_2_cave2_box1
#define mccompcurtype  Union_box
#define mccompcurindex 227
#define loop_index mccchannel_2_cave2_box1_loop_index
#define this_box_volume mccchannel_2_cave2_box1_this_box_volume
#define global_geometry_element mccchannel_2_cave2_box1_global_geometry_element
#define this_box_storage mccchannel_2_cave2_box1_this_box_storage
#define material_string mccchannel_2_cave2_box1_material_string
#define priority mccchannel_2_cave2_box1_priority
#define xwidth mccchannel_2_cave2_box1_xwidth
#define yheight mccchannel_2_cave2_box1_yheight
#define zdepth mccchannel_2_cave2_box1_zdepth
#define xwidth2 mccchannel_2_cave2_box1_xwidth2
#define yheight2 mccchannel_2_cave2_box1_yheight2
#define visualize mccchannel_2_cave2_box1_visualize
#define target_index mccchannel_2_cave2_box1_target_index
#define target_x mccchannel_2_cave2_box1_target_x
#define target_y mccchannel_2_cave2_box1_target_y
#define target_z mccchannel_2_cave2_box1_target_z
#define focus_aw mccchannel_2_cave2_box1_focus_aw
#define focus_ah mccchannel_2_cave2_box1_focus_ah
#define focus_xw mccchannel_2_cave2_box1_focus_xw
#define focus_xh mccchannel_2_cave2_box1_focus_xh
#define focus_r mccchannel_2_cave2_box1_focus_r
#define p_interact mccchannel_2_cave2_box1_p_interact
#define mask_string mccchannel_2_cave2_box1_mask_string
#define mask_setting mccchannel_2_cave2_box1_mask_setting
#define number_of_activations mccchannel_2_cave2_box1_number_of_activations
#line 224 "Union_box.comp"
{
// Initializes the focusing system for this volume including input sanitation.
focus_initialize(&this_box_volume.geometry, POS_A_COMP_INDEX(INDEX_CURRENT_COMP+target_index), POS_A_CURRENT_COMP, ROT_A_CURRENT_COMP, target_index, target_x, target_y, target_z, focus_aw, focus_ah, focus_xw, focus_xh, focus_r, NAME_CURRENT_COMP);

// Input sanitation for this geometry
if (xwidth <= 0) {
  printf("\nERROR in Union_box named %s, the xwidth is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (yheight <= 0) {
  printf("\nERROR in Union_box named %s, yheight is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (zdepth <= 0) {
  printf("\nERROR in Union_box named %s, zdepth is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (xwidth2 <= 0 && xwidth2 != -1) {
  printf("\nERROR in Union_box named %s, the xwidth2 is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (yheight2 <= 0 && yheight2 != -1) {
  printf("\nERROR in Union_box named %s, yheight2 is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}

// Use sanitation
if (global_material_list.num_elements == 0) {
  printf("\nERROR: Need to define a material using Union_make_material before using a Union geometry component. \n");
  printf("       %s was defined before first use of Union_make_material.\n",NAME_CURRENT_COMP);
  exit(1);
}

this_box_volume.geometry.is_masked_volume = 0;
this_box_volume.geometry.is_exit_volume = 0;
this_box_volume.geometry.is_mask_volume = 0;
// check if the volume is a mask, if it is the material string is irelevant.
if (mask_string && strlen(mask_string) && strcmp(mask_string, "NULL") && strcmp(mask_string, "0")) {
    // A mask volume is used to limit the extend of other volumes, called the masked volumes. These are specified in the mask_string.
    // In order for a ray to enter a masked volume, it needs to be both in the region covered by that volume AND the mask volume.
    // When more than
    this_box_volume.geometry.mask_mode = 1; // Default is mask mode is ALL
    if (mask_setting && strlen(mask_setting) && strcmp(mask_setting, "NULL") && strcmp(mask_setting, "0")) {
        if (strcmp(mask_setting,"ALL") == 0 || strcmp(mask_setting,"All") == 0) this_box_volume.geometry.mask_mode = 1;
        else if (strcmp(mask_setting,"ANY") == 0 || strcmp(mask_setting,"Any") == 0) this_box_volume.geometry.mask_mode = 2;
        else {
            printf("The mask_mode of component %s is set to %s, but must be either ALL or ANY.\n",NAME_CURRENT_COMP,mask_setting);
            exit(1);
        }
    }
    
    for (loop_index=0;loop_index<global_geometry_list.num_elements;loop_index++) {
        // Add mask list
        if (1 == manual_linking_function(global_geometry_list.elements[loop_index].name,mask_string)) {
            add_element_to_int_list(&this_box_volume.geometry.mask_list,global_geometry_list.elements[loop_index].component_index);
            add_element_to_int_list(&global_geometry_list.elements[loop_index].Volume->geometry.masked_by_list,INDEX_CURRENT_COMP);
            global_geometry_list.elements[loop_index].Volume->geometry.is_masked_volume = 1;
            if (this_box_volume.geometry.mask_mode == 2)
                global_geometry_list.elements[loop_index].Volume->geometry.mask_mode = 2;
            if (this_box_volume.geometry.mask_mode == 1) {
                if (global_geometry_list.elements[loop_index].Volume->geometry.is_masked_volume == 1 && global_geometry_list.elements[loop_index].Volume->geometry.mask_mode != 2)
                    // If more than one mask is added to one volume, the ANY mode overwrites the (default) ALL mode.
                    global_geometry_list.elements[loop_index].Volume->geometry.mask_mode = 1;
            }
            
            found_geometries = 1;
        }
    }
    if (found_geometries == 0) {
        printf("The mask_string in geometry: %s did not find any of the specified volumes in the mask_string %s \n",NAME_CURRENT_COMP,mask_string);
        exit(1);
    }
    this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
    this_box_volume.p_physics->is_vacuum = 0; // Makes this volume a vacuum
    this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
    this_box_volume.p_physics->my_a = 0; // Should not be used.
    sprintf(this_box_volume.p_physics->name,"Mask");
    this_box_volume.geometry.is_mask_volume = 1;
    
    
// Read the material input, or if it lacks, use automatic linking.
} else if (material_string && strlen(material_string) && strcmp(material_string, "NULL") && strcmp(material_string, "0")) {
    // A geometry string was given, use it to determine which material
    if (0 == strcmp(material_string,"vacuum") || 0 == strcmp(material_string,"Vacuum")) {
        // One could have a global physics struct for vacuum instead of creating one for each
        this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
        this_box_volume.p_physics->is_vacuum = 1; // Makes this volume a vacuum
        this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
        this_box_volume.p_physics->my_a = 0; // Should not be used.
        sprintf(this_box_volume.p_physics->name,"Vacuum");
    } else if (0 == strcmp(material_string,"exit") || 0 == strcmp(material_string,"Exit")) {
        // One could have a global physics struct for vacuum instead of creating one for each
        this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
        this_box_volume.p_physics->is_vacuum = 1; // Makes this volume a vacuum
        this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
        this_box_volume.p_physics->my_a = 0; // Should not be used.
        this_box_volume.geometry.is_exit_volume = 1;
        sprintf(this_box_volume.p_physics->name,"Exit");
    } else {
        #ifndef MATERIAL_DETECTOR
            printf("Need to define a material before refering to it in a geometry %s.\n",NAME_CURRENT_COMP);
            exit(1);
        #endif
        for (loop_index=0;loop_index<global_material_list.num_elements;loop_index++) {
            if (0 == strcmp(material_string,global_material_list.elements[loop_index].name)) {
                this_box_volume.p_physics = global_material_list.elements[loop_index].physics;
                break;
            }
            if (loop_index == global_material_list.num_elements-1) {
            printf("\n");
            printf("ERROR: The material string \"%s\" in Union geometry \"%s\" did not match a specified material. \n",material_string,NAME_CURRENT_COMP);
            printf("       The materials available at this point (need to be defined before the geometry): \n");
            for (loop_index=0;loop_index<global_material_list.num_elements;loop_index++)
              printf("         %s\n",global_material_list.elements[loop_index].name);
            printf("\n");
            printf("       It is also possible to use one of the defualt materials avaiable: \n");
            printf("           Vacuum (for a Volume without scattering or absorption)\n");
            printf("           Exit (for a Volume where the ray exits the component if it enters)\n");
            printf("           Mask (for a Volume that masks existing volumes specified in the mask_string\n");
            exit(1);
          }
        }
    }
} else {
    // Automatic linking, simply using the last defined material.
    #ifndef MATERIAL_DETECTOR
        printf("Need to define a material before the geometry to use automatic linking %s.\n",NAME_CURRENT_COMP);
        exit(1);
    #endif
    this_box_volume.p_physics = global_material_list.elements[global_material_list.num_elements-1].physics;
}

sprintf(this_box_volume.name,NAME_CURRENT_COMP);
sprintf(this_box_volume.geometry.shape,"box");
this_box_volume.geometry.priority_value = priority;
this_box_volume.geometry.geometry_p_interact = p_interact;
// Currently the coordinates will be in absolute space.
this_box_volume.geometry.center = POS_A_CURRENT_COMP;

this_box_storage.z_depth = zdepth;
this_box_storage.x_width1 = xwidth;
this_box_storage.y_height1 = yheight;

this_box_storage.is_rectangle = 0;
if (xwidth2 < 0 && yheight2 < 0) this_box_storage.is_rectangle = 1;
if (xwidth == xwidth2 && yheight == yheight2) this_box_storage.is_rectangle = 1;

if (xwidth2 < 0) {
    this_box_storage.x_width2 = xwidth;
    xwidth2 = xwidth;
} else this_box_storage.x_width2 = xwidth2;

if (yheight2 < 0) {
    this_box_storage.y_height2 = yheight;
    yheight2 = yheight;
} else this_box_storage.y_height2 = yheight2;


this_box_storage.normal_vectors[0] = coords_set(0,0,1);
this_box_storage.normal_vectors[1] = coords_set(0,0,1);

// for sides with y component = 0
x_component = 2*zdepth/sqrt((xwidth-xwidth2)*(xwidth-xwidth2)+4*zdepth*zdepth);
z_component = (xwidth-xwidth2)/sqrt(4*zdepth*zdepth+(xwidth-xwidth2)*(xwidth-xwidth2));

this_box_storage.normal_vectors[2] = coords_set(x_component,0,z_component);
this_box_storage.normal_vectors[3] = coords_set(-x_component,0,z_component);

// for sides with x component = 0
y_component = 2*zdepth/sqrt((yheight-yheight2)*(yheight-yheight2)+4*zdepth*zdepth);
z_component = (yheight-yheight2)/sqrt(4*zdepth*zdepth+(yheight-yheight2)*(yheight-yheight2));

this_box_storage.normal_vectors[4] = coords_set(0,y_component,z_component);
this_box_storage.normal_vectors[5] = coords_set(0,-y_component,z_component);

this_box_volume.geometry.visualization_on = visualize;

this_box_volume.geometry.geometry_parameters.p_box_storage = &this_box_storage;

// Assign pointers to functions for intersection with the shape, checking if a point is inside the shape
if (this_box_storage.is_rectangle == 1) {
this_box_volume.geometry.intersect_function = &sample_box_intersect_simple;
this_box_volume.geometry.within_function = &r_within_box_simple;
}
else {
this_box_volume.geometry.intersect_function = &sample_box_intersect_advanced;
this_box_volume.geometry.within_function = &r_within_box_advanced;
}

this_box_volume.geometry.shell_points = &box_shell_points;
this_box_volume.geometry.mcdisplay_function = &mcdisplay_box_function;
this_box_volume.geometry.initialize_from_main_function = &initialize_box_geometry_from_main_component;
this_box_volume.geometry.process_rot_allocated = 0;

this_box_volume.geometry.copy_geometry_parameters = &allocate_box_storage_copy;

rot_copy(this_box_volume.geometry.rotation_matrix,ROT_A_CURRENT_COMP); //check how ROT_R_CURRENT_COMP would work
rot_transpose(ROT_A_CURRENT_COMP,this_box_volume.geometry.transpose_rotation_matrix);

// Initialize loggers
this_box_volume.loggers.num_elements = 0;

// packing the information into the global_geometry_element, which is then included in the global_geometry_list.
sprintf(global_geometry_element.name,NAME_CURRENT_COMP);
global_geometry_element.activation_counter = number_of_activations;
global_geometry_element.component_index = INDEX_CURRENT_COMP;
global_geometry_element.Volume = &this_box_volume; // Would be nicer if this m was a pointer, now we have the (small) data two places
add_element_to_geometry_list(&global_geometry_list,global_geometry_element);
}
#line 188474 "MACS_sample_kidney_box.c"
#undef number_of_activations
#undef mask_setting
#undef mask_string
#undef p_interact
#undef focus_r
#undef focus_xh
#undef focus_xw
#undef focus_ah
#undef focus_aw
#undef target_z
#undef target_y
#undef target_x
#undef target_index
#undef visualize
#undef yheight2
#undef xwidth2
#undef zdepth
#undef yheight
#undef xwidth
#undef priority
#undef material_string
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

  /* Initializations for component channel_2_cave2_box2. */
  SIG_MESSAGE("channel_2_cave2_box2 (Init)");
#define mccompcurname  channel_2_cave2_box2
#define mccompcurtype  Union_box
#define mccompcurindex 228
#define loop_index mccchannel_2_cave2_box2_loop_index
#define this_box_volume mccchannel_2_cave2_box2_this_box_volume
#define global_geometry_element mccchannel_2_cave2_box2_global_geometry_element
#define this_box_storage mccchannel_2_cave2_box2_this_box_storage
#define material_string mccchannel_2_cave2_box2_material_string
#define priority mccchannel_2_cave2_box2_priority
#define xwidth mccchannel_2_cave2_box2_xwidth
#define yheight mccchannel_2_cave2_box2_yheight
#define zdepth mccchannel_2_cave2_box2_zdepth
#define xwidth2 mccchannel_2_cave2_box2_xwidth2
#define yheight2 mccchannel_2_cave2_box2_yheight2
#define visualize mccchannel_2_cave2_box2_visualize
#define target_index mccchannel_2_cave2_box2_target_index
#define target_x mccchannel_2_cave2_box2_target_x
#define target_y mccchannel_2_cave2_box2_target_y
#define target_z mccchannel_2_cave2_box2_target_z
#define focus_aw mccchannel_2_cave2_box2_focus_aw
#define focus_ah mccchannel_2_cave2_box2_focus_ah
#define focus_xw mccchannel_2_cave2_box2_focus_xw
#define focus_xh mccchannel_2_cave2_box2_focus_xh
#define focus_r mccchannel_2_cave2_box2_focus_r
#define p_interact mccchannel_2_cave2_box2_p_interact
#define mask_string mccchannel_2_cave2_box2_mask_string
#define mask_setting mccchannel_2_cave2_box2_mask_setting
#define number_of_activations mccchannel_2_cave2_box2_number_of_activations
#line 224 "Union_box.comp"
{
// Initializes the focusing system for this volume including input sanitation.
focus_initialize(&this_box_volume.geometry, POS_A_COMP_INDEX(INDEX_CURRENT_COMP+target_index), POS_A_CURRENT_COMP, ROT_A_CURRENT_COMP, target_index, target_x, target_y, target_z, focus_aw, focus_ah, focus_xw, focus_xh, focus_r, NAME_CURRENT_COMP);

// Input sanitation for this geometry
if (xwidth <= 0) {
  printf("\nERROR in Union_box named %s, the xwidth is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (yheight <= 0) {
  printf("\nERROR in Union_box named %s, yheight is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (zdepth <= 0) {
  printf("\nERROR in Union_box named %s, zdepth is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (xwidth2 <= 0 && xwidth2 != -1) {
  printf("\nERROR in Union_box named %s, the xwidth2 is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (yheight2 <= 0 && yheight2 != -1) {
  printf("\nERROR in Union_box named %s, yheight2 is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}

// Use sanitation
if (global_material_list.num_elements == 0) {
  printf("\nERROR: Need to define a material using Union_make_material before using a Union geometry component. \n");
  printf("       %s was defined before first use of Union_make_material.\n",NAME_CURRENT_COMP);
  exit(1);
}

this_box_volume.geometry.is_masked_volume = 0;
this_box_volume.geometry.is_exit_volume = 0;
this_box_volume.geometry.is_mask_volume = 0;
// check if the volume is a mask, if it is the material string is irelevant.
if (mask_string && strlen(mask_string) && strcmp(mask_string, "NULL") && strcmp(mask_string, "0")) {
    // A mask volume is used to limit the extend of other volumes, called the masked volumes. These are specified in the mask_string.
    // In order for a ray to enter a masked volume, it needs to be both in the region covered by that volume AND the mask volume.
    // When more than
    this_box_volume.geometry.mask_mode = 1; // Default is mask mode is ALL
    if (mask_setting && strlen(mask_setting) && strcmp(mask_setting, "NULL") && strcmp(mask_setting, "0")) {
        if (strcmp(mask_setting,"ALL") == 0 || strcmp(mask_setting,"All") == 0) this_box_volume.geometry.mask_mode = 1;
        else if (strcmp(mask_setting,"ANY") == 0 || strcmp(mask_setting,"Any") == 0) this_box_volume.geometry.mask_mode = 2;
        else {
            printf("The mask_mode of component %s is set to %s, but must be either ALL or ANY.\n",NAME_CURRENT_COMP,mask_setting);
            exit(1);
        }
    }
    
    for (loop_index=0;loop_index<global_geometry_list.num_elements;loop_index++) {
        // Add mask list
        if (1 == manual_linking_function(global_geometry_list.elements[loop_index].name,mask_string)) {
            add_element_to_int_list(&this_box_volume.geometry.mask_list,global_geometry_list.elements[loop_index].component_index);
            add_element_to_int_list(&global_geometry_list.elements[loop_index].Volume->geometry.masked_by_list,INDEX_CURRENT_COMP);
            global_geometry_list.elements[loop_index].Volume->geometry.is_masked_volume = 1;
            if (this_box_volume.geometry.mask_mode == 2)
                global_geometry_list.elements[loop_index].Volume->geometry.mask_mode = 2;
            if (this_box_volume.geometry.mask_mode == 1) {
                if (global_geometry_list.elements[loop_index].Volume->geometry.is_masked_volume == 1 && global_geometry_list.elements[loop_index].Volume->geometry.mask_mode != 2)
                    // If more than one mask is added to one volume, the ANY mode overwrites the (default) ALL mode.
                    global_geometry_list.elements[loop_index].Volume->geometry.mask_mode = 1;
            }
            
            found_geometries = 1;
        }
    }
    if (found_geometries == 0) {
        printf("The mask_string in geometry: %s did not find any of the specified volumes in the mask_string %s \n",NAME_CURRENT_COMP,mask_string);
        exit(1);
    }
    this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
    this_box_volume.p_physics->is_vacuum = 0; // Makes this volume a vacuum
    this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
    this_box_volume.p_physics->my_a = 0; // Should not be used.
    sprintf(this_box_volume.p_physics->name,"Mask");
    this_box_volume.geometry.is_mask_volume = 1;
    
    
// Read the material input, or if it lacks, use automatic linking.
} else if (material_string && strlen(material_string) && strcmp(material_string, "NULL") && strcmp(material_string, "0")) {
    // A geometry string was given, use it to determine which material
    if (0 == strcmp(material_string,"vacuum") || 0 == strcmp(material_string,"Vacuum")) {
        // One could have a global physics struct for vacuum instead of creating one for each
        this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
        this_box_volume.p_physics->is_vacuum = 1; // Makes this volume a vacuum
        this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
        this_box_volume.p_physics->my_a = 0; // Should not be used.
        sprintf(this_box_volume.p_physics->name,"Vacuum");
    } else if (0 == strcmp(material_string,"exit") || 0 == strcmp(material_string,"Exit")) {
        // One could have a global physics struct for vacuum instead of creating one for each
        this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
        this_box_volume.p_physics->is_vacuum = 1; // Makes this volume a vacuum
        this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
        this_box_volume.p_physics->my_a = 0; // Should not be used.
        this_box_volume.geometry.is_exit_volume = 1;
        sprintf(this_box_volume.p_physics->name,"Exit");
    } else {
        #ifndef MATERIAL_DETECTOR
            printf("Need to define a material before refering to it in a geometry %s.\n",NAME_CURRENT_COMP);
            exit(1);
        #endif
        for (loop_index=0;loop_index<global_material_list.num_elements;loop_index++) {
            if (0 == strcmp(material_string,global_material_list.elements[loop_index].name)) {
                this_box_volume.p_physics = global_material_list.elements[loop_index].physics;
                break;
            }
            if (loop_index == global_material_list.num_elements-1) {
            printf("\n");
            printf("ERROR: The material string \"%s\" in Union geometry \"%s\" did not match a specified material. \n",material_string,NAME_CURRENT_COMP);
            printf("       The materials available at this point (need to be defined before the geometry): \n");
            for (loop_index=0;loop_index<global_material_list.num_elements;loop_index++)
              printf("         %s\n",global_material_list.elements[loop_index].name);
            printf("\n");
            printf("       It is also possible to use one of the defualt materials avaiable: \n");
            printf("           Vacuum (for a Volume without scattering or absorption)\n");
            printf("           Exit (for a Volume where the ray exits the component if it enters)\n");
            printf("           Mask (for a Volume that masks existing volumes specified in the mask_string\n");
            exit(1);
          }
        }
    }
} else {
    // Automatic linking, simply using the last defined material.
    #ifndef MATERIAL_DETECTOR
        printf("Need to define a material before the geometry to use automatic linking %s.\n",NAME_CURRENT_COMP);
        exit(1);
    #endif
    this_box_volume.p_physics = global_material_list.elements[global_material_list.num_elements-1].physics;
}

sprintf(this_box_volume.name,NAME_CURRENT_COMP);
sprintf(this_box_volume.geometry.shape,"box");
this_box_volume.geometry.priority_value = priority;
this_box_volume.geometry.geometry_p_interact = p_interact;
// Currently the coordinates will be in absolute space.
this_box_volume.geometry.center = POS_A_CURRENT_COMP;

this_box_storage.z_depth = zdepth;
this_box_storage.x_width1 = xwidth;
this_box_storage.y_height1 = yheight;

this_box_storage.is_rectangle = 0;
if (xwidth2 < 0 && yheight2 < 0) this_box_storage.is_rectangle = 1;
if (xwidth == xwidth2 && yheight == yheight2) this_box_storage.is_rectangle = 1;

if (xwidth2 < 0) {
    this_box_storage.x_width2 = xwidth;
    xwidth2 = xwidth;
} else this_box_storage.x_width2 = xwidth2;

if (yheight2 < 0) {
    this_box_storage.y_height2 = yheight;
    yheight2 = yheight;
} else this_box_storage.y_height2 = yheight2;


this_box_storage.normal_vectors[0] = coords_set(0,0,1);
this_box_storage.normal_vectors[1] = coords_set(0,0,1);

// for sides with y component = 0
x_component = 2*zdepth/sqrt((xwidth-xwidth2)*(xwidth-xwidth2)+4*zdepth*zdepth);
z_component = (xwidth-xwidth2)/sqrt(4*zdepth*zdepth+(xwidth-xwidth2)*(xwidth-xwidth2));

this_box_storage.normal_vectors[2] = coords_set(x_component,0,z_component);
this_box_storage.normal_vectors[3] = coords_set(-x_component,0,z_component);

// for sides with x component = 0
y_component = 2*zdepth/sqrt((yheight-yheight2)*(yheight-yheight2)+4*zdepth*zdepth);
z_component = (yheight-yheight2)/sqrt(4*zdepth*zdepth+(yheight-yheight2)*(yheight-yheight2));

this_box_storage.normal_vectors[4] = coords_set(0,y_component,z_component);
this_box_storage.normal_vectors[5] = coords_set(0,-y_component,z_component);

this_box_volume.geometry.visualization_on = visualize;

this_box_volume.geometry.geometry_parameters.p_box_storage = &this_box_storage;

// Assign pointers to functions for intersection with the shape, checking if a point is inside the shape
if (this_box_storage.is_rectangle == 1) {
this_box_volume.geometry.intersect_function = &sample_box_intersect_simple;
this_box_volume.geometry.within_function = &r_within_box_simple;
}
else {
this_box_volume.geometry.intersect_function = &sample_box_intersect_advanced;
this_box_volume.geometry.within_function = &r_within_box_advanced;
}

this_box_volume.geometry.shell_points = &box_shell_points;
this_box_volume.geometry.mcdisplay_function = &mcdisplay_box_function;
this_box_volume.geometry.initialize_from_main_function = &initialize_box_geometry_from_main_component;
this_box_volume.geometry.process_rot_allocated = 0;

this_box_volume.geometry.copy_geometry_parameters = &allocate_box_storage_copy;

rot_copy(this_box_volume.geometry.rotation_matrix,ROT_A_CURRENT_COMP); //check how ROT_R_CURRENT_COMP would work
rot_transpose(ROT_A_CURRENT_COMP,this_box_volume.geometry.transpose_rotation_matrix);

// Initialize loggers
this_box_volume.loggers.num_elements = 0;

// packing the information into the global_geometry_element, which is then included in the global_geometry_list.
sprintf(global_geometry_element.name,NAME_CURRENT_COMP);
global_geometry_element.activation_counter = number_of_activations;
global_geometry_element.component_index = INDEX_CURRENT_COMP;
global_geometry_element.Volume = &this_box_volume; // Would be nicer if this m was a pointer, now we have the (small) data two places
add_element_to_geometry_list(&global_geometry_list,global_geometry_element);
}
#line 188744 "MACS_sample_kidney_box.c"
#undef number_of_activations
#undef mask_setting
#undef mask_string
#undef p_interact
#undef focus_r
#undef focus_xh
#undef focus_xw
#undef focus_ah
#undef focus_aw
#undef target_z
#undef target_y
#undef target_x
#undef target_index
#undef visualize
#undef yheight2
#undef xwidth2
#undef zdepth
#undef yheight
#undef xwidth
#undef priority
#undef material_string
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

  /* Initializations for component channel_2_cave2_box3. */
  SIG_MESSAGE("channel_2_cave2_box3 (Init)");
#define mccompcurname  channel_2_cave2_box3
#define mccompcurtype  Union_box
#define mccompcurindex 229
#define loop_index mccchannel_2_cave2_box3_loop_index
#define this_box_volume mccchannel_2_cave2_box3_this_box_volume
#define global_geometry_element mccchannel_2_cave2_box3_global_geometry_element
#define this_box_storage mccchannel_2_cave2_box3_this_box_storage
#define material_string mccchannel_2_cave2_box3_material_string
#define priority mccchannel_2_cave2_box3_priority
#define xwidth mccchannel_2_cave2_box3_xwidth
#define yheight mccchannel_2_cave2_box3_yheight
#define zdepth mccchannel_2_cave2_box3_zdepth
#define xwidth2 mccchannel_2_cave2_box3_xwidth2
#define yheight2 mccchannel_2_cave2_box3_yheight2
#define visualize mccchannel_2_cave2_box3_visualize
#define target_index mccchannel_2_cave2_box3_target_index
#define target_x mccchannel_2_cave2_box3_target_x
#define target_y mccchannel_2_cave2_box3_target_y
#define target_z mccchannel_2_cave2_box3_target_z
#define focus_aw mccchannel_2_cave2_box3_focus_aw
#define focus_ah mccchannel_2_cave2_box3_focus_ah
#define focus_xw mccchannel_2_cave2_box3_focus_xw
#define focus_xh mccchannel_2_cave2_box3_focus_xh
#define focus_r mccchannel_2_cave2_box3_focus_r
#define p_interact mccchannel_2_cave2_box3_p_interact
#define mask_string mccchannel_2_cave2_box3_mask_string
#define mask_setting mccchannel_2_cave2_box3_mask_setting
#define number_of_activations mccchannel_2_cave2_box3_number_of_activations
#line 224 "Union_box.comp"
{
// Initializes the focusing system for this volume including input sanitation.
focus_initialize(&this_box_volume.geometry, POS_A_COMP_INDEX(INDEX_CURRENT_COMP+target_index), POS_A_CURRENT_COMP, ROT_A_CURRENT_COMP, target_index, target_x, target_y, target_z, focus_aw, focus_ah, focus_xw, focus_xh, focus_r, NAME_CURRENT_COMP);

// Input sanitation for this geometry
if (xwidth <= 0) {
  printf("\nERROR in Union_box named %s, the xwidth is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (yheight <= 0) {
  printf("\nERROR in Union_box named %s, yheight is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (zdepth <= 0) {
  printf("\nERROR in Union_box named %s, zdepth is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (xwidth2 <= 0 && xwidth2 != -1) {
  printf("\nERROR in Union_box named %s, the xwidth2 is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (yheight2 <= 0 && yheight2 != -1) {
  printf("\nERROR in Union_box named %s, yheight2 is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}

// Use sanitation
if (global_material_list.num_elements == 0) {
  printf("\nERROR: Need to define a material using Union_make_material before using a Union geometry component. \n");
  printf("       %s was defined before first use of Union_make_material.\n",NAME_CURRENT_COMP);
  exit(1);
}

this_box_volume.geometry.is_masked_volume = 0;
this_box_volume.geometry.is_exit_volume = 0;
this_box_volume.geometry.is_mask_volume = 0;
// check if the volume is a mask, if it is the material string is irelevant.
if (mask_string && strlen(mask_string) && strcmp(mask_string, "NULL") && strcmp(mask_string, "0")) {
    // A mask volume is used to limit the extend of other volumes, called the masked volumes. These are specified in the mask_string.
    // In order for a ray to enter a masked volume, it needs to be both in the region covered by that volume AND the mask volume.
    // When more than
    this_box_volume.geometry.mask_mode = 1; // Default is mask mode is ALL
    if (mask_setting && strlen(mask_setting) && strcmp(mask_setting, "NULL") && strcmp(mask_setting, "0")) {
        if (strcmp(mask_setting,"ALL") == 0 || strcmp(mask_setting,"All") == 0) this_box_volume.geometry.mask_mode = 1;
        else if (strcmp(mask_setting,"ANY") == 0 || strcmp(mask_setting,"Any") == 0) this_box_volume.geometry.mask_mode = 2;
        else {
            printf("The mask_mode of component %s is set to %s, but must be either ALL or ANY.\n",NAME_CURRENT_COMP,mask_setting);
            exit(1);
        }
    }
    
    for (loop_index=0;loop_index<global_geometry_list.num_elements;loop_index++) {
        // Add mask list
        if (1 == manual_linking_function(global_geometry_list.elements[loop_index].name,mask_string)) {
            add_element_to_int_list(&this_box_volume.geometry.mask_list,global_geometry_list.elements[loop_index].component_index);
            add_element_to_int_list(&global_geometry_list.elements[loop_index].Volume->geometry.masked_by_list,INDEX_CURRENT_COMP);
            global_geometry_list.elements[loop_index].Volume->geometry.is_masked_volume = 1;
            if (this_box_volume.geometry.mask_mode == 2)
                global_geometry_list.elements[loop_index].Volume->geometry.mask_mode = 2;
            if (this_box_volume.geometry.mask_mode == 1) {
                if (global_geometry_list.elements[loop_index].Volume->geometry.is_masked_volume == 1 && global_geometry_list.elements[loop_index].Volume->geometry.mask_mode != 2)
                    // If more than one mask is added to one volume, the ANY mode overwrites the (default) ALL mode.
                    global_geometry_list.elements[loop_index].Volume->geometry.mask_mode = 1;
            }
            
            found_geometries = 1;
        }
    }
    if (found_geometries == 0) {
        printf("The mask_string in geometry: %s did not find any of the specified volumes in the mask_string %s \n",NAME_CURRENT_COMP,mask_string);
        exit(1);
    }
    this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
    this_box_volume.p_physics->is_vacuum = 0; // Makes this volume a vacuum
    this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
    this_box_volume.p_physics->my_a = 0; // Should not be used.
    sprintf(this_box_volume.p_physics->name,"Mask");
    this_box_volume.geometry.is_mask_volume = 1;
    
    
// Read the material input, or if it lacks, use automatic linking.
} else if (material_string && strlen(material_string) && strcmp(material_string, "NULL") && strcmp(material_string, "0")) {
    // A geometry string was given, use it to determine which material
    if (0 == strcmp(material_string,"vacuum") || 0 == strcmp(material_string,"Vacuum")) {
        // One could have a global physics struct for vacuum instead of creating one for each
        this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
        this_box_volume.p_physics->is_vacuum = 1; // Makes this volume a vacuum
        this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
        this_box_volume.p_physics->my_a = 0; // Should not be used.
        sprintf(this_box_volume.p_physics->name,"Vacuum");
    } else if (0 == strcmp(material_string,"exit") || 0 == strcmp(material_string,"Exit")) {
        // One could have a global physics struct for vacuum instead of creating one for each
        this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
        this_box_volume.p_physics->is_vacuum = 1; // Makes this volume a vacuum
        this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
        this_box_volume.p_physics->my_a = 0; // Should not be used.
        this_box_volume.geometry.is_exit_volume = 1;
        sprintf(this_box_volume.p_physics->name,"Exit");
    } else {
        #ifndef MATERIAL_DETECTOR
            printf("Need to define a material before refering to it in a geometry %s.\n",NAME_CURRENT_COMP);
            exit(1);
        #endif
        for (loop_index=0;loop_index<global_material_list.num_elements;loop_index++) {
            if (0 == strcmp(material_string,global_material_list.elements[loop_index].name)) {
                this_box_volume.p_physics = global_material_list.elements[loop_index].physics;
                break;
            }
            if (loop_index == global_material_list.num_elements-1) {
            printf("\n");
            printf("ERROR: The material string \"%s\" in Union geometry \"%s\" did not match a specified material. \n",material_string,NAME_CURRENT_COMP);
            printf("       The materials available at this point (need to be defined before the geometry): \n");
            for (loop_index=0;loop_index<global_material_list.num_elements;loop_index++)
              printf("         %s\n",global_material_list.elements[loop_index].name);
            printf("\n");
            printf("       It is also possible to use one of the defualt materials avaiable: \n");
            printf("           Vacuum (for a Volume without scattering or absorption)\n");
            printf("           Exit (for a Volume where the ray exits the component if it enters)\n");
            printf("           Mask (for a Volume that masks existing volumes specified in the mask_string\n");
            exit(1);
          }
        }
    }
} else {
    // Automatic linking, simply using the last defined material.
    #ifndef MATERIAL_DETECTOR
        printf("Need to define a material before the geometry to use automatic linking %s.\n",NAME_CURRENT_COMP);
        exit(1);
    #endif
    this_box_volume.p_physics = global_material_list.elements[global_material_list.num_elements-1].physics;
}

sprintf(this_box_volume.name,NAME_CURRENT_COMP);
sprintf(this_box_volume.geometry.shape,"box");
this_box_volume.geometry.priority_value = priority;
this_box_volume.geometry.geometry_p_interact = p_interact;
// Currently the coordinates will be in absolute space.
this_box_volume.geometry.center = POS_A_CURRENT_COMP;

this_box_storage.z_depth = zdepth;
this_box_storage.x_width1 = xwidth;
this_box_storage.y_height1 = yheight;

this_box_storage.is_rectangle = 0;
if (xwidth2 < 0 && yheight2 < 0) this_box_storage.is_rectangle = 1;
if (xwidth == xwidth2 && yheight == yheight2) this_box_storage.is_rectangle = 1;

if (xwidth2 < 0) {
    this_box_storage.x_width2 = xwidth;
    xwidth2 = xwidth;
} else this_box_storage.x_width2 = xwidth2;

if (yheight2 < 0) {
    this_box_storage.y_height2 = yheight;
    yheight2 = yheight;
} else this_box_storage.y_height2 = yheight2;


this_box_storage.normal_vectors[0] = coords_set(0,0,1);
this_box_storage.normal_vectors[1] = coords_set(0,0,1);

// for sides with y component = 0
x_component = 2*zdepth/sqrt((xwidth-xwidth2)*(xwidth-xwidth2)+4*zdepth*zdepth);
z_component = (xwidth-xwidth2)/sqrt(4*zdepth*zdepth+(xwidth-xwidth2)*(xwidth-xwidth2));

this_box_storage.normal_vectors[2] = coords_set(x_component,0,z_component);
this_box_storage.normal_vectors[3] = coords_set(-x_component,0,z_component);

// for sides with x component = 0
y_component = 2*zdepth/sqrt((yheight-yheight2)*(yheight-yheight2)+4*zdepth*zdepth);
z_component = (yheight-yheight2)/sqrt(4*zdepth*zdepth+(yheight-yheight2)*(yheight-yheight2));

this_box_storage.normal_vectors[4] = coords_set(0,y_component,z_component);
this_box_storage.normal_vectors[5] = coords_set(0,-y_component,z_component);

this_box_volume.geometry.visualization_on = visualize;

this_box_volume.geometry.geometry_parameters.p_box_storage = &this_box_storage;

// Assign pointers to functions for intersection with the shape, checking if a point is inside the shape
if (this_box_storage.is_rectangle == 1) {
this_box_volume.geometry.intersect_function = &sample_box_intersect_simple;
this_box_volume.geometry.within_function = &r_within_box_simple;
}
else {
this_box_volume.geometry.intersect_function = &sample_box_intersect_advanced;
this_box_volume.geometry.within_function = &r_within_box_advanced;
}

this_box_volume.geometry.shell_points = &box_shell_points;
this_box_volume.geometry.mcdisplay_function = &mcdisplay_box_function;
this_box_volume.geometry.initialize_from_main_function = &initialize_box_geometry_from_main_component;
this_box_volume.geometry.process_rot_allocated = 0;

this_box_volume.geometry.copy_geometry_parameters = &allocate_box_storage_copy;

rot_copy(this_box_volume.geometry.rotation_matrix,ROT_A_CURRENT_COMP); //check how ROT_R_CURRENT_COMP would work
rot_transpose(ROT_A_CURRENT_COMP,this_box_volume.geometry.transpose_rotation_matrix);

// Initialize loggers
this_box_volume.loggers.num_elements = 0;

// packing the information into the global_geometry_element, which is then included in the global_geometry_list.
sprintf(global_geometry_element.name,NAME_CURRENT_COMP);
global_geometry_element.activation_counter = number_of_activations;
global_geometry_element.component_index = INDEX_CURRENT_COMP;
global_geometry_element.Volume = &this_box_volume; // Would be nicer if this m was a pointer, now we have the (small) data two places
add_element_to_geometry_list(&global_geometry_list,global_geometry_element);
}
#line 189014 "MACS_sample_kidney_box.c"
#undef number_of_activations
#undef mask_setting
#undef mask_string
#undef p_interact
#undef focus_r
#undef focus_xh
#undef focus_xw
#undef focus_ah
#undef focus_aw
#undef target_z
#undef target_y
#undef target_x
#undef target_index
#undef visualize
#undef yheight2
#undef xwidth2
#undef zdepth
#undef yheight
#undef xwidth
#undef priority
#undef material_string
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

  /* Initializations for component inter_analyzer_colimator_center_2. */
  SIG_MESSAGE("inter_analyzer_colimator_center_2 (Init)");

  /* Initializations for component inter_analyzer_colimator_2_blade_0. */
  SIG_MESSAGE("inter_analyzer_colimator_2_blade_0 (Init)");
#define mccompcurname  inter_analyzer_colimator_2_blade_0
#define mccompcurtype  Union_box
#define mccompcurindex 231
#define loop_index mccinter_analyzer_colimator_2_blade_0_loop_index
#define this_box_volume mccinter_analyzer_colimator_2_blade_0_this_box_volume
#define global_geometry_element mccinter_analyzer_colimator_2_blade_0_global_geometry_element
#define this_box_storage mccinter_analyzer_colimator_2_blade_0_this_box_storage
#define material_string mccinter_analyzer_colimator_2_blade_0_material_string
#define priority mccinter_analyzer_colimator_2_blade_0_priority
#define xwidth mccinter_analyzer_colimator_2_blade_0_xwidth
#define yheight mccinter_analyzer_colimator_2_blade_0_yheight
#define zdepth mccinter_analyzer_colimator_2_blade_0_zdepth
#define xwidth2 mccinter_analyzer_colimator_2_blade_0_xwidth2
#define yheight2 mccinter_analyzer_colimator_2_blade_0_yheight2
#define visualize mccinter_analyzer_colimator_2_blade_0_visualize
#define target_index mccinter_analyzer_colimator_2_blade_0_target_index
#define target_x mccinter_analyzer_colimator_2_blade_0_target_x
#define target_y mccinter_analyzer_colimator_2_blade_0_target_y
#define target_z mccinter_analyzer_colimator_2_blade_0_target_z
#define focus_aw mccinter_analyzer_colimator_2_blade_0_focus_aw
#define focus_ah mccinter_analyzer_colimator_2_blade_0_focus_ah
#define focus_xw mccinter_analyzer_colimator_2_blade_0_focus_xw
#define focus_xh mccinter_analyzer_colimator_2_blade_0_focus_xh
#define focus_r mccinter_analyzer_colimator_2_blade_0_focus_r
#define p_interact mccinter_analyzer_colimator_2_blade_0_p_interact
#define mask_string mccinter_analyzer_colimator_2_blade_0_mask_string
#define mask_setting mccinter_analyzer_colimator_2_blade_0_mask_setting
#define number_of_activations mccinter_analyzer_colimator_2_blade_0_number_of_activations
#line 224 "Union_box.comp"
{
// Initializes the focusing system for this volume including input sanitation.
focus_initialize(&this_box_volume.geometry, POS_A_COMP_INDEX(INDEX_CURRENT_COMP+target_index), POS_A_CURRENT_COMP, ROT_A_CURRENT_COMP, target_index, target_x, target_y, target_z, focus_aw, focus_ah, focus_xw, focus_xh, focus_r, NAME_CURRENT_COMP);

// Input sanitation for this geometry
if (xwidth <= 0) {
  printf("\nERROR in Union_box named %s, the xwidth is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (yheight <= 0) {
  printf("\nERROR in Union_box named %s, yheight is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (zdepth <= 0) {
  printf("\nERROR in Union_box named %s, zdepth is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (xwidth2 <= 0 && xwidth2 != -1) {
  printf("\nERROR in Union_box named %s, the xwidth2 is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (yheight2 <= 0 && yheight2 != -1) {
  printf("\nERROR in Union_box named %s, yheight2 is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}

// Use sanitation
if (global_material_list.num_elements == 0) {
  printf("\nERROR: Need to define a material using Union_make_material before using a Union geometry component. \n");
  printf("       %s was defined before first use of Union_make_material.\n",NAME_CURRENT_COMP);
  exit(1);
}

this_box_volume.geometry.is_masked_volume = 0;
this_box_volume.geometry.is_exit_volume = 0;
this_box_volume.geometry.is_mask_volume = 0;
// check if the volume is a mask, if it is the material string is irelevant.
if (mask_string && strlen(mask_string) && strcmp(mask_string, "NULL") && strcmp(mask_string, "0")) {
    // A mask volume is used to limit the extend of other volumes, called the masked volumes. These are specified in the mask_string.
    // In order for a ray to enter a masked volume, it needs to be both in the region covered by that volume AND the mask volume.
    // When more than
    this_box_volume.geometry.mask_mode = 1; // Default is mask mode is ALL
    if (mask_setting && strlen(mask_setting) && strcmp(mask_setting, "NULL") && strcmp(mask_setting, "0")) {
        if (strcmp(mask_setting,"ALL") == 0 || strcmp(mask_setting,"All") == 0) this_box_volume.geometry.mask_mode = 1;
        else if (strcmp(mask_setting,"ANY") == 0 || strcmp(mask_setting,"Any") == 0) this_box_volume.geometry.mask_mode = 2;
        else {
            printf("The mask_mode of component %s is set to %s, but must be either ALL or ANY.\n",NAME_CURRENT_COMP,mask_setting);
            exit(1);
        }
    }
    
    for (loop_index=0;loop_index<global_geometry_list.num_elements;loop_index++) {
        // Add mask list
        if (1 == manual_linking_function(global_geometry_list.elements[loop_index].name,mask_string)) {
            add_element_to_int_list(&this_box_volume.geometry.mask_list,global_geometry_list.elements[loop_index].component_index);
            add_element_to_int_list(&global_geometry_list.elements[loop_index].Volume->geometry.masked_by_list,INDEX_CURRENT_COMP);
            global_geometry_list.elements[loop_index].Volume->geometry.is_masked_volume = 1;
            if (this_box_volume.geometry.mask_mode == 2)
                global_geometry_list.elements[loop_index].Volume->geometry.mask_mode = 2;
            if (this_box_volume.geometry.mask_mode == 1) {
                if (global_geometry_list.elements[loop_index].Volume->geometry.is_masked_volume == 1 && global_geometry_list.elements[loop_index].Volume->geometry.mask_mode != 2)
                    // If more than one mask is added to one volume, the ANY mode overwrites the (default) ALL mode.
                    global_geometry_list.elements[loop_index].Volume->geometry.mask_mode = 1;
            }
            
            found_geometries = 1;
        }
    }
    if (found_geometries == 0) {
        printf("The mask_string in geometry: %s did not find any of the specified volumes in the mask_string %s \n",NAME_CURRENT_COMP,mask_string);
        exit(1);
    }
    this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
    this_box_volume.p_physics->is_vacuum = 0; // Makes this volume a vacuum
    this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
    this_box_volume.p_physics->my_a = 0; // Should not be used.
    sprintf(this_box_volume.p_physics->name,"Mask");
    this_box_volume.geometry.is_mask_volume = 1;
    
    
// Read the material input, or if it lacks, use automatic linking.
} else if (material_string && strlen(material_string) && strcmp(material_string, "NULL") && strcmp(material_string, "0")) {
    // A geometry string was given, use it to determine which material
    if (0 == strcmp(material_string,"vacuum") || 0 == strcmp(material_string,"Vacuum")) {
        // One could have a global physics struct for vacuum instead of creating one for each
        this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
        this_box_volume.p_physics->is_vacuum = 1; // Makes this volume a vacuum
        this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
        this_box_volume.p_physics->my_a = 0; // Should not be used.
        sprintf(this_box_volume.p_physics->name,"Vacuum");
    } else if (0 == strcmp(material_string,"exit") || 0 == strcmp(material_string,"Exit")) {
        // One could have a global physics struct for vacuum instead of creating one for each
        this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
        this_box_volume.p_physics->is_vacuum = 1; // Makes this volume a vacuum
        this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
        this_box_volume.p_physics->my_a = 0; // Should not be used.
        this_box_volume.geometry.is_exit_volume = 1;
        sprintf(this_box_volume.p_physics->name,"Exit");
    } else {
        #ifndef MATERIAL_DETECTOR
            printf("Need to define a material before refering to it in a geometry %s.\n",NAME_CURRENT_COMP);
            exit(1);
        #endif
        for (loop_index=0;loop_index<global_material_list.num_elements;loop_index++) {
            if (0 == strcmp(material_string,global_material_list.elements[loop_index].name)) {
                this_box_volume.p_physics = global_material_list.elements[loop_index].physics;
                break;
            }
            if (loop_index == global_material_list.num_elements-1) {
            printf("\n");
            printf("ERROR: The material string \"%s\" in Union geometry \"%s\" did not match a specified material. \n",material_string,NAME_CURRENT_COMP);
            printf("       The materials available at this point (need to be defined before the geometry): \n");
            for (loop_index=0;loop_index<global_material_list.num_elements;loop_index++)
              printf("         %s\n",global_material_list.elements[loop_index].name);
            printf("\n");
            printf("       It is also possible to use one of the defualt materials avaiable: \n");
            printf("           Vacuum (for a Volume without scattering or absorption)\n");
            printf("           Exit (for a Volume where the ray exits the component if it enters)\n");
            printf("           Mask (for a Volume that masks existing volumes specified in the mask_string\n");
            exit(1);
          }
        }
    }
} else {
    // Automatic linking, simply using the last defined material.
    #ifndef MATERIAL_DETECTOR
        printf("Need to define a material before the geometry to use automatic linking %s.\n",NAME_CURRENT_COMP);
        exit(1);
    #endif
    this_box_volume.p_physics = global_material_list.elements[global_material_list.num_elements-1].physics;
}

sprintf(this_box_volume.name,NAME_CURRENT_COMP);
sprintf(this_box_volume.geometry.shape,"box");
this_box_volume.geometry.priority_value = priority;
this_box_volume.geometry.geometry_p_interact = p_interact;
// Currently the coordinates will be in absolute space.
this_box_volume.geometry.center = POS_A_CURRENT_COMP;

this_box_storage.z_depth = zdepth;
this_box_storage.x_width1 = xwidth;
this_box_storage.y_height1 = yheight;

this_box_storage.is_rectangle = 0;
if (xwidth2 < 0 && yheight2 < 0) this_box_storage.is_rectangle = 1;
if (xwidth == xwidth2 && yheight == yheight2) this_box_storage.is_rectangle = 1;

if (xwidth2 < 0) {
    this_box_storage.x_width2 = xwidth;
    xwidth2 = xwidth;
} else this_box_storage.x_width2 = xwidth2;

if (yheight2 < 0) {
    this_box_storage.y_height2 = yheight;
    yheight2 = yheight;
} else this_box_storage.y_height2 = yheight2;


this_box_storage.normal_vectors[0] = coords_set(0,0,1);
this_box_storage.normal_vectors[1] = coords_set(0,0,1);

// for sides with y component = 0
x_component = 2*zdepth/sqrt((xwidth-xwidth2)*(xwidth-xwidth2)+4*zdepth*zdepth);
z_component = (xwidth-xwidth2)/sqrt(4*zdepth*zdepth+(xwidth-xwidth2)*(xwidth-xwidth2));

this_box_storage.normal_vectors[2] = coords_set(x_component,0,z_component);
this_box_storage.normal_vectors[3] = coords_set(-x_component,0,z_component);

// for sides with x component = 0
y_component = 2*zdepth/sqrt((yheight-yheight2)*(yheight-yheight2)+4*zdepth*zdepth);
z_component = (yheight-yheight2)/sqrt(4*zdepth*zdepth+(yheight-yheight2)*(yheight-yheight2));

this_box_storage.normal_vectors[4] = coords_set(0,y_component,z_component);
this_box_storage.normal_vectors[5] = coords_set(0,-y_component,z_component);

this_box_volume.geometry.visualization_on = visualize;

this_box_volume.geometry.geometry_parameters.p_box_storage = &this_box_storage;

// Assign pointers to functions for intersection with the shape, checking if a point is inside the shape
if (this_box_storage.is_rectangle == 1) {
this_box_volume.geometry.intersect_function = &sample_box_intersect_simple;
this_box_volume.geometry.within_function = &r_within_box_simple;
}
else {
this_box_volume.geometry.intersect_function = &sample_box_intersect_advanced;
this_box_volume.geometry.within_function = &r_within_box_advanced;
}

this_box_volume.geometry.shell_points = &box_shell_points;
this_box_volume.geometry.mcdisplay_function = &mcdisplay_box_function;
this_box_volume.geometry.initialize_from_main_function = &initialize_box_geometry_from_main_component;
this_box_volume.geometry.process_rot_allocated = 0;

this_box_volume.geometry.copy_geometry_parameters = &allocate_box_storage_copy;

rot_copy(this_box_volume.geometry.rotation_matrix,ROT_A_CURRENT_COMP); //check how ROT_R_CURRENT_COMP would work
rot_transpose(ROT_A_CURRENT_COMP,this_box_volume.geometry.transpose_rotation_matrix);

// Initialize loggers
this_box_volume.loggers.num_elements = 0;

// packing the information into the global_geometry_element, which is then included in the global_geometry_list.
sprintf(global_geometry_element.name,NAME_CURRENT_COMP);
global_geometry_element.activation_counter = number_of_activations;
global_geometry_element.component_index = INDEX_CURRENT_COMP;
global_geometry_element.Volume = &this_box_volume; // Would be nicer if this m was a pointer, now we have the (small) data two places
add_element_to_geometry_list(&global_geometry_list,global_geometry_element);
}
#line 189287 "MACS_sample_kidney_box.c"
#undef number_of_activations
#undef mask_setting
#undef mask_string
#undef p_interact
#undef focus_r
#undef focus_xh
#undef focus_xw
#undef focus_ah
#undef focus_aw
#undef target_z
#undef target_y
#undef target_x
#undef target_index
#undef visualize
#undef yheight2
#undef xwidth2
#undef zdepth
#undef yheight
#undef xwidth
#undef priority
#undef material_string
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

  /* Initializations for component inter_analyzer_colimator_2_blade_1. */
  SIG_MESSAGE("inter_analyzer_colimator_2_blade_1 (Init)");
#define mccompcurname  inter_analyzer_colimator_2_blade_1
#define mccompcurtype  Union_box
#define mccompcurindex 232
#define loop_index mccinter_analyzer_colimator_2_blade_1_loop_index
#define this_box_volume mccinter_analyzer_colimator_2_blade_1_this_box_volume
#define global_geometry_element mccinter_analyzer_colimator_2_blade_1_global_geometry_element
#define this_box_storage mccinter_analyzer_colimator_2_blade_1_this_box_storage
#define material_string mccinter_analyzer_colimator_2_blade_1_material_string
#define priority mccinter_analyzer_colimator_2_blade_1_priority
#define xwidth mccinter_analyzer_colimator_2_blade_1_xwidth
#define yheight mccinter_analyzer_colimator_2_blade_1_yheight
#define zdepth mccinter_analyzer_colimator_2_blade_1_zdepth
#define xwidth2 mccinter_analyzer_colimator_2_blade_1_xwidth2
#define yheight2 mccinter_analyzer_colimator_2_blade_1_yheight2
#define visualize mccinter_analyzer_colimator_2_blade_1_visualize
#define target_index mccinter_analyzer_colimator_2_blade_1_target_index
#define target_x mccinter_analyzer_colimator_2_blade_1_target_x
#define target_y mccinter_analyzer_colimator_2_blade_1_target_y
#define target_z mccinter_analyzer_colimator_2_blade_1_target_z
#define focus_aw mccinter_analyzer_colimator_2_blade_1_focus_aw
#define focus_ah mccinter_analyzer_colimator_2_blade_1_focus_ah
#define focus_xw mccinter_analyzer_colimator_2_blade_1_focus_xw
#define focus_xh mccinter_analyzer_colimator_2_blade_1_focus_xh
#define focus_r mccinter_analyzer_colimator_2_blade_1_focus_r
#define p_interact mccinter_analyzer_colimator_2_blade_1_p_interact
#define mask_string mccinter_analyzer_colimator_2_blade_1_mask_string
#define mask_setting mccinter_analyzer_colimator_2_blade_1_mask_setting
#define number_of_activations mccinter_analyzer_colimator_2_blade_1_number_of_activations
#line 224 "Union_box.comp"
{
// Initializes the focusing system for this volume including input sanitation.
focus_initialize(&this_box_volume.geometry, POS_A_COMP_INDEX(INDEX_CURRENT_COMP+target_index), POS_A_CURRENT_COMP, ROT_A_CURRENT_COMP, target_index, target_x, target_y, target_z, focus_aw, focus_ah, focus_xw, focus_xh, focus_r, NAME_CURRENT_COMP);

// Input sanitation for this geometry
if (xwidth <= 0) {
  printf("\nERROR in Union_box named %s, the xwidth is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (yheight <= 0) {
  printf("\nERROR in Union_box named %s, yheight is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (zdepth <= 0) {
  printf("\nERROR in Union_box named %s, zdepth is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (xwidth2 <= 0 && xwidth2 != -1) {
  printf("\nERROR in Union_box named %s, the xwidth2 is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (yheight2 <= 0 && yheight2 != -1) {
  printf("\nERROR in Union_box named %s, yheight2 is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}

// Use sanitation
if (global_material_list.num_elements == 0) {
  printf("\nERROR: Need to define a material using Union_make_material before using a Union geometry component. \n");
  printf("       %s was defined before first use of Union_make_material.\n",NAME_CURRENT_COMP);
  exit(1);
}

this_box_volume.geometry.is_masked_volume = 0;
this_box_volume.geometry.is_exit_volume = 0;
this_box_volume.geometry.is_mask_volume = 0;
// check if the volume is a mask, if it is the material string is irelevant.
if (mask_string && strlen(mask_string) && strcmp(mask_string, "NULL") && strcmp(mask_string, "0")) {
    // A mask volume is used to limit the extend of other volumes, called the masked volumes. These are specified in the mask_string.
    // In order for a ray to enter a masked volume, it needs to be both in the region covered by that volume AND the mask volume.
    // When more than
    this_box_volume.geometry.mask_mode = 1; // Default is mask mode is ALL
    if (mask_setting && strlen(mask_setting) && strcmp(mask_setting, "NULL") && strcmp(mask_setting, "0")) {
        if (strcmp(mask_setting,"ALL") == 0 || strcmp(mask_setting,"All") == 0) this_box_volume.geometry.mask_mode = 1;
        else if (strcmp(mask_setting,"ANY") == 0 || strcmp(mask_setting,"Any") == 0) this_box_volume.geometry.mask_mode = 2;
        else {
            printf("The mask_mode of component %s is set to %s, but must be either ALL or ANY.\n",NAME_CURRENT_COMP,mask_setting);
            exit(1);
        }
    }
    
    for (loop_index=0;loop_index<global_geometry_list.num_elements;loop_index++) {
        // Add mask list
        if (1 == manual_linking_function(global_geometry_list.elements[loop_index].name,mask_string)) {
            add_element_to_int_list(&this_box_volume.geometry.mask_list,global_geometry_list.elements[loop_index].component_index);
            add_element_to_int_list(&global_geometry_list.elements[loop_index].Volume->geometry.masked_by_list,INDEX_CURRENT_COMP);
            global_geometry_list.elements[loop_index].Volume->geometry.is_masked_volume = 1;
            if (this_box_volume.geometry.mask_mode == 2)
                global_geometry_list.elements[loop_index].Volume->geometry.mask_mode = 2;
            if (this_box_volume.geometry.mask_mode == 1) {
                if (global_geometry_list.elements[loop_index].Volume->geometry.is_masked_volume == 1 && global_geometry_list.elements[loop_index].Volume->geometry.mask_mode != 2)
                    // If more than one mask is added to one volume, the ANY mode overwrites the (default) ALL mode.
                    global_geometry_list.elements[loop_index].Volume->geometry.mask_mode = 1;
            }
            
            found_geometries = 1;
        }
    }
    if (found_geometries == 0) {
        printf("The mask_string in geometry: %s did not find any of the specified volumes in the mask_string %s \n",NAME_CURRENT_COMP,mask_string);
        exit(1);
    }
    this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
    this_box_volume.p_physics->is_vacuum = 0; // Makes this volume a vacuum
    this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
    this_box_volume.p_physics->my_a = 0; // Should not be used.
    sprintf(this_box_volume.p_physics->name,"Mask");
    this_box_volume.geometry.is_mask_volume = 1;
    
    
// Read the material input, or if it lacks, use automatic linking.
} else if (material_string && strlen(material_string) && strcmp(material_string, "NULL") && strcmp(material_string, "0")) {
    // A geometry string was given, use it to determine which material
    if (0 == strcmp(material_string,"vacuum") || 0 == strcmp(material_string,"Vacuum")) {
        // One could have a global physics struct for vacuum instead of creating one for each
        this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
        this_box_volume.p_physics->is_vacuum = 1; // Makes this volume a vacuum
        this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
        this_box_volume.p_physics->my_a = 0; // Should not be used.
        sprintf(this_box_volume.p_physics->name,"Vacuum");
    } else if (0 == strcmp(material_string,"exit") || 0 == strcmp(material_string,"Exit")) {
        // One could have a global physics struct for vacuum instead of creating one for each
        this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
        this_box_volume.p_physics->is_vacuum = 1; // Makes this volume a vacuum
        this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
        this_box_volume.p_physics->my_a = 0; // Should not be used.
        this_box_volume.geometry.is_exit_volume = 1;
        sprintf(this_box_volume.p_physics->name,"Exit");
    } else {
        #ifndef MATERIAL_DETECTOR
            printf("Need to define a material before refering to it in a geometry %s.\n",NAME_CURRENT_COMP);
            exit(1);
        #endif
        for (loop_index=0;loop_index<global_material_list.num_elements;loop_index++) {
            if (0 == strcmp(material_string,global_material_list.elements[loop_index].name)) {
                this_box_volume.p_physics = global_material_list.elements[loop_index].physics;
                break;
            }
            if (loop_index == global_material_list.num_elements-1) {
            printf("\n");
            printf("ERROR: The material string \"%s\" in Union geometry \"%s\" did not match a specified material. \n",material_string,NAME_CURRENT_COMP);
            printf("       The materials available at this point (need to be defined before the geometry): \n");
            for (loop_index=0;loop_index<global_material_list.num_elements;loop_index++)
              printf("         %s\n",global_material_list.elements[loop_index].name);
            printf("\n");
            printf("       It is also possible to use one of the defualt materials avaiable: \n");
            printf("           Vacuum (for a Volume without scattering or absorption)\n");
            printf("           Exit (for a Volume where the ray exits the component if it enters)\n");
            printf("           Mask (for a Volume that masks existing volumes specified in the mask_string\n");
            exit(1);
          }
        }
    }
} else {
    // Automatic linking, simply using the last defined material.
    #ifndef MATERIAL_DETECTOR
        printf("Need to define a material before the geometry to use automatic linking %s.\n",NAME_CURRENT_COMP);
        exit(1);
    #endif
    this_box_volume.p_physics = global_material_list.elements[global_material_list.num_elements-1].physics;
}

sprintf(this_box_volume.name,NAME_CURRENT_COMP);
sprintf(this_box_volume.geometry.shape,"box");
this_box_volume.geometry.priority_value = priority;
this_box_volume.geometry.geometry_p_interact = p_interact;
// Currently the coordinates will be in absolute space.
this_box_volume.geometry.center = POS_A_CURRENT_COMP;

this_box_storage.z_depth = zdepth;
this_box_storage.x_width1 = xwidth;
this_box_storage.y_height1 = yheight;

this_box_storage.is_rectangle = 0;
if (xwidth2 < 0 && yheight2 < 0) this_box_storage.is_rectangle = 1;
if (xwidth == xwidth2 && yheight == yheight2) this_box_storage.is_rectangle = 1;

if (xwidth2 < 0) {
    this_box_storage.x_width2 = xwidth;
    xwidth2 = xwidth;
} else this_box_storage.x_width2 = xwidth2;

if (yheight2 < 0) {
    this_box_storage.y_height2 = yheight;
    yheight2 = yheight;
} else this_box_storage.y_height2 = yheight2;


this_box_storage.normal_vectors[0] = coords_set(0,0,1);
this_box_storage.normal_vectors[1] = coords_set(0,0,1);

// for sides with y component = 0
x_component = 2*zdepth/sqrt((xwidth-xwidth2)*(xwidth-xwidth2)+4*zdepth*zdepth);
z_component = (xwidth-xwidth2)/sqrt(4*zdepth*zdepth+(xwidth-xwidth2)*(xwidth-xwidth2));

this_box_storage.normal_vectors[2] = coords_set(x_component,0,z_component);
this_box_storage.normal_vectors[3] = coords_set(-x_component,0,z_component);

// for sides with x component = 0
y_component = 2*zdepth/sqrt((yheight-yheight2)*(yheight-yheight2)+4*zdepth*zdepth);
z_component = (yheight-yheight2)/sqrt(4*zdepth*zdepth+(yheight-yheight2)*(yheight-yheight2));

this_box_storage.normal_vectors[4] = coords_set(0,y_component,z_component);
this_box_storage.normal_vectors[5] = coords_set(0,-y_component,z_component);

this_box_volume.geometry.visualization_on = visualize;

this_box_volume.geometry.geometry_parameters.p_box_storage = &this_box_storage;

// Assign pointers to functions for intersection with the shape, checking if a point is inside the shape
if (this_box_storage.is_rectangle == 1) {
this_box_volume.geometry.intersect_function = &sample_box_intersect_simple;
this_box_volume.geometry.within_function = &r_within_box_simple;
}
else {
this_box_volume.geometry.intersect_function = &sample_box_intersect_advanced;
this_box_volume.geometry.within_function = &r_within_box_advanced;
}

this_box_volume.geometry.shell_points = &box_shell_points;
this_box_volume.geometry.mcdisplay_function = &mcdisplay_box_function;
this_box_volume.geometry.initialize_from_main_function = &initialize_box_geometry_from_main_component;
this_box_volume.geometry.process_rot_allocated = 0;

this_box_volume.geometry.copy_geometry_parameters = &allocate_box_storage_copy;

rot_copy(this_box_volume.geometry.rotation_matrix,ROT_A_CURRENT_COMP); //check how ROT_R_CURRENT_COMP would work
rot_transpose(ROT_A_CURRENT_COMP,this_box_volume.geometry.transpose_rotation_matrix);

// Initialize loggers
this_box_volume.loggers.num_elements = 0;

// packing the information into the global_geometry_element, which is then included in the global_geometry_list.
sprintf(global_geometry_element.name,NAME_CURRENT_COMP);
global_geometry_element.activation_counter = number_of_activations;
global_geometry_element.component_index = INDEX_CURRENT_COMP;
global_geometry_element.Volume = &this_box_volume; // Would be nicer if this m was a pointer, now we have the (small) data two places
add_element_to_geometry_list(&global_geometry_list,global_geometry_element);
}
#line 189557 "MACS_sample_kidney_box.c"
#undef number_of_activations
#undef mask_setting
#undef mask_string
#undef p_interact
#undef focus_r
#undef focus_xh
#undef focus_xw
#undef focus_ah
#undef focus_aw
#undef target_z
#undef target_y
#undef target_x
#undef target_index
#undef visualize
#undef yheight2
#undef xwidth2
#undef zdepth
#undef yheight
#undef xwidth
#undef priority
#undef material_string
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

  /* Initializations for component inter_analyzer_colimator_2_blade_2. */
  SIG_MESSAGE("inter_analyzer_colimator_2_blade_2 (Init)");
#define mccompcurname  inter_analyzer_colimator_2_blade_2
#define mccompcurtype  Union_box
#define mccompcurindex 233
#define loop_index mccinter_analyzer_colimator_2_blade_2_loop_index
#define this_box_volume mccinter_analyzer_colimator_2_blade_2_this_box_volume
#define global_geometry_element mccinter_analyzer_colimator_2_blade_2_global_geometry_element
#define this_box_storage mccinter_analyzer_colimator_2_blade_2_this_box_storage
#define material_string mccinter_analyzer_colimator_2_blade_2_material_string
#define priority mccinter_analyzer_colimator_2_blade_2_priority
#define xwidth mccinter_analyzer_colimator_2_blade_2_xwidth
#define yheight mccinter_analyzer_colimator_2_blade_2_yheight
#define zdepth mccinter_analyzer_colimator_2_blade_2_zdepth
#define xwidth2 mccinter_analyzer_colimator_2_blade_2_xwidth2
#define yheight2 mccinter_analyzer_colimator_2_blade_2_yheight2
#define visualize mccinter_analyzer_colimator_2_blade_2_visualize
#define target_index mccinter_analyzer_colimator_2_blade_2_target_index
#define target_x mccinter_analyzer_colimator_2_blade_2_target_x
#define target_y mccinter_analyzer_colimator_2_blade_2_target_y
#define target_z mccinter_analyzer_colimator_2_blade_2_target_z
#define focus_aw mccinter_analyzer_colimator_2_blade_2_focus_aw
#define focus_ah mccinter_analyzer_colimator_2_blade_2_focus_ah
#define focus_xw mccinter_analyzer_colimator_2_blade_2_focus_xw
#define focus_xh mccinter_analyzer_colimator_2_blade_2_focus_xh
#define focus_r mccinter_analyzer_colimator_2_blade_2_focus_r
#define p_interact mccinter_analyzer_colimator_2_blade_2_p_interact
#define mask_string mccinter_analyzer_colimator_2_blade_2_mask_string
#define mask_setting mccinter_analyzer_colimator_2_blade_2_mask_setting
#define number_of_activations mccinter_analyzer_colimator_2_blade_2_number_of_activations
#line 224 "Union_box.comp"
{
// Initializes the focusing system for this volume including input sanitation.
focus_initialize(&this_box_volume.geometry, POS_A_COMP_INDEX(INDEX_CURRENT_COMP+target_index), POS_A_CURRENT_COMP, ROT_A_CURRENT_COMP, target_index, target_x, target_y, target_z, focus_aw, focus_ah, focus_xw, focus_xh, focus_r, NAME_CURRENT_COMP);

// Input sanitation for this geometry
if (xwidth <= 0) {
  printf("\nERROR in Union_box named %s, the xwidth is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (yheight <= 0) {
  printf("\nERROR in Union_box named %s, yheight is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (zdepth <= 0) {
  printf("\nERROR in Union_box named %s, zdepth is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (xwidth2 <= 0 && xwidth2 != -1) {
  printf("\nERROR in Union_box named %s, the xwidth2 is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (yheight2 <= 0 && yheight2 != -1) {
  printf("\nERROR in Union_box named %s, yheight2 is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}

// Use sanitation
if (global_material_list.num_elements == 0) {
  printf("\nERROR: Need to define a material using Union_make_material before using a Union geometry component. \n");
  printf("       %s was defined before first use of Union_make_material.\n",NAME_CURRENT_COMP);
  exit(1);
}

this_box_volume.geometry.is_masked_volume = 0;
this_box_volume.geometry.is_exit_volume = 0;
this_box_volume.geometry.is_mask_volume = 0;
// check if the volume is a mask, if it is the material string is irelevant.
if (mask_string && strlen(mask_string) && strcmp(mask_string, "NULL") && strcmp(mask_string, "0")) {
    // A mask volume is used to limit the extend of other volumes, called the masked volumes. These are specified in the mask_string.
    // In order for a ray to enter a masked volume, it needs to be both in the region covered by that volume AND the mask volume.
    // When more than
    this_box_volume.geometry.mask_mode = 1; // Default is mask mode is ALL
    if (mask_setting && strlen(mask_setting) && strcmp(mask_setting, "NULL") && strcmp(mask_setting, "0")) {
        if (strcmp(mask_setting,"ALL") == 0 || strcmp(mask_setting,"All") == 0) this_box_volume.geometry.mask_mode = 1;
        else if (strcmp(mask_setting,"ANY") == 0 || strcmp(mask_setting,"Any") == 0) this_box_volume.geometry.mask_mode = 2;
        else {
            printf("The mask_mode of component %s is set to %s, but must be either ALL or ANY.\n",NAME_CURRENT_COMP,mask_setting);
            exit(1);
        }
    }
    
    for (loop_index=0;loop_index<global_geometry_list.num_elements;loop_index++) {
        // Add mask list
        if (1 == manual_linking_function(global_geometry_list.elements[loop_index].name,mask_string)) {
            add_element_to_int_list(&this_box_volume.geometry.mask_list,global_geometry_list.elements[loop_index].component_index);
            add_element_to_int_list(&global_geometry_list.elements[loop_index].Volume->geometry.masked_by_list,INDEX_CURRENT_COMP);
            global_geometry_list.elements[loop_index].Volume->geometry.is_masked_volume = 1;
            if (this_box_volume.geometry.mask_mode == 2)
                global_geometry_list.elements[loop_index].Volume->geometry.mask_mode = 2;
            if (this_box_volume.geometry.mask_mode == 1) {
                if (global_geometry_list.elements[loop_index].Volume->geometry.is_masked_volume == 1 && global_geometry_list.elements[loop_index].Volume->geometry.mask_mode != 2)
                    // If more than one mask is added to one volume, the ANY mode overwrites the (default) ALL mode.
                    global_geometry_list.elements[loop_index].Volume->geometry.mask_mode = 1;
            }
            
            found_geometries = 1;
        }
    }
    if (found_geometries == 0) {
        printf("The mask_string in geometry: %s did not find any of the specified volumes in the mask_string %s \n",NAME_CURRENT_COMP,mask_string);
        exit(1);
    }
    this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
    this_box_volume.p_physics->is_vacuum = 0; // Makes this volume a vacuum
    this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
    this_box_volume.p_physics->my_a = 0; // Should not be used.
    sprintf(this_box_volume.p_physics->name,"Mask");
    this_box_volume.geometry.is_mask_volume = 1;
    
    
// Read the material input, or if it lacks, use automatic linking.
} else if (material_string && strlen(material_string) && strcmp(material_string, "NULL") && strcmp(material_string, "0")) {
    // A geometry string was given, use it to determine which material
    if (0 == strcmp(material_string,"vacuum") || 0 == strcmp(material_string,"Vacuum")) {
        // One could have a global physics struct for vacuum instead of creating one for each
        this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
        this_box_volume.p_physics->is_vacuum = 1; // Makes this volume a vacuum
        this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
        this_box_volume.p_physics->my_a = 0; // Should not be used.
        sprintf(this_box_volume.p_physics->name,"Vacuum");
    } else if (0 == strcmp(material_string,"exit") || 0 == strcmp(material_string,"Exit")) {
        // One could have a global physics struct for vacuum instead of creating one for each
        this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
        this_box_volume.p_physics->is_vacuum = 1; // Makes this volume a vacuum
        this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
        this_box_volume.p_physics->my_a = 0; // Should not be used.
        this_box_volume.geometry.is_exit_volume = 1;
        sprintf(this_box_volume.p_physics->name,"Exit");
    } else {
        #ifndef MATERIAL_DETECTOR
            printf("Need to define a material before refering to it in a geometry %s.\n",NAME_CURRENT_COMP);
            exit(1);
        #endif
        for (loop_index=0;loop_index<global_material_list.num_elements;loop_index++) {
            if (0 == strcmp(material_string,global_material_list.elements[loop_index].name)) {
                this_box_volume.p_physics = global_material_list.elements[loop_index].physics;
                break;
            }
            if (loop_index == global_material_list.num_elements-1) {
            printf("\n");
            printf("ERROR: The material string \"%s\" in Union geometry \"%s\" did not match a specified material. \n",material_string,NAME_CURRENT_COMP);
            printf("       The materials available at this point (need to be defined before the geometry): \n");
            for (loop_index=0;loop_index<global_material_list.num_elements;loop_index++)
              printf("         %s\n",global_material_list.elements[loop_index].name);
            printf("\n");
            printf("       It is also possible to use one of the defualt materials avaiable: \n");
            printf("           Vacuum (for a Volume without scattering or absorption)\n");
            printf("           Exit (for a Volume where the ray exits the component if it enters)\n");
            printf("           Mask (for a Volume that masks existing volumes specified in the mask_string\n");
            exit(1);
          }
        }
    }
} else {
    // Automatic linking, simply using the last defined material.
    #ifndef MATERIAL_DETECTOR
        printf("Need to define a material before the geometry to use automatic linking %s.\n",NAME_CURRENT_COMP);
        exit(1);
    #endif
    this_box_volume.p_physics = global_material_list.elements[global_material_list.num_elements-1].physics;
}

sprintf(this_box_volume.name,NAME_CURRENT_COMP);
sprintf(this_box_volume.geometry.shape,"box");
this_box_volume.geometry.priority_value = priority;
this_box_volume.geometry.geometry_p_interact = p_interact;
// Currently the coordinates will be in absolute space.
this_box_volume.geometry.center = POS_A_CURRENT_COMP;

this_box_storage.z_depth = zdepth;
this_box_storage.x_width1 = xwidth;
this_box_storage.y_height1 = yheight;

this_box_storage.is_rectangle = 0;
if (xwidth2 < 0 && yheight2 < 0) this_box_storage.is_rectangle = 1;
if (xwidth == xwidth2 && yheight == yheight2) this_box_storage.is_rectangle = 1;

if (xwidth2 < 0) {
    this_box_storage.x_width2 = xwidth;
    xwidth2 = xwidth;
} else this_box_storage.x_width2 = xwidth2;

if (yheight2 < 0) {
    this_box_storage.y_height2 = yheight;
    yheight2 = yheight;
} else this_box_storage.y_height2 = yheight2;


this_box_storage.normal_vectors[0] = coords_set(0,0,1);
this_box_storage.normal_vectors[1] = coords_set(0,0,1);

// for sides with y component = 0
x_component = 2*zdepth/sqrt((xwidth-xwidth2)*(xwidth-xwidth2)+4*zdepth*zdepth);
z_component = (xwidth-xwidth2)/sqrt(4*zdepth*zdepth+(xwidth-xwidth2)*(xwidth-xwidth2));

this_box_storage.normal_vectors[2] = coords_set(x_component,0,z_component);
this_box_storage.normal_vectors[3] = coords_set(-x_component,0,z_component);

// for sides with x component = 0
y_component = 2*zdepth/sqrt((yheight-yheight2)*(yheight-yheight2)+4*zdepth*zdepth);
z_component = (yheight-yheight2)/sqrt(4*zdepth*zdepth+(yheight-yheight2)*(yheight-yheight2));

this_box_storage.normal_vectors[4] = coords_set(0,y_component,z_component);
this_box_storage.normal_vectors[5] = coords_set(0,-y_component,z_component);

this_box_volume.geometry.visualization_on = visualize;

this_box_volume.geometry.geometry_parameters.p_box_storage = &this_box_storage;

// Assign pointers to functions for intersection with the shape, checking if a point is inside the shape
if (this_box_storage.is_rectangle == 1) {
this_box_volume.geometry.intersect_function = &sample_box_intersect_simple;
this_box_volume.geometry.within_function = &r_within_box_simple;
}
else {
this_box_volume.geometry.intersect_function = &sample_box_intersect_advanced;
this_box_volume.geometry.within_function = &r_within_box_advanced;
}

this_box_volume.geometry.shell_points = &box_shell_points;
this_box_volume.geometry.mcdisplay_function = &mcdisplay_box_function;
this_box_volume.geometry.initialize_from_main_function = &initialize_box_geometry_from_main_component;
this_box_volume.geometry.process_rot_allocated = 0;

this_box_volume.geometry.copy_geometry_parameters = &allocate_box_storage_copy;

rot_copy(this_box_volume.geometry.rotation_matrix,ROT_A_CURRENT_COMP); //check how ROT_R_CURRENT_COMP would work
rot_transpose(ROT_A_CURRENT_COMP,this_box_volume.geometry.transpose_rotation_matrix);

// Initialize loggers
this_box_volume.loggers.num_elements = 0;

// packing the information into the global_geometry_element, which is then included in the global_geometry_list.
sprintf(global_geometry_element.name,NAME_CURRENT_COMP);
global_geometry_element.activation_counter = number_of_activations;
global_geometry_element.component_index = INDEX_CURRENT_COMP;
global_geometry_element.Volume = &this_box_volume; // Would be nicer if this m was a pointer, now we have the (small) data two places
add_element_to_geometry_list(&global_geometry_list,global_geometry_element);
}
#line 189827 "MACS_sample_kidney_box.c"
#undef number_of_activations
#undef mask_setting
#undef mask_string
#undef p_interact
#undef focus_r
#undef focus_xh
#undef focus_xw
#undef focus_ah
#undef focus_aw
#undef target_z
#undef target_y
#undef target_x
#undef target_index
#undef visualize
#undef yheight2
#undef xwidth2
#undef zdepth
#undef yheight
#undef xwidth
#undef priority
#undef material_string
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

  /* Initializations for component inter_analyzer_colimator_2_blade_3. */
  SIG_MESSAGE("inter_analyzer_colimator_2_blade_3 (Init)");
#define mccompcurname  inter_analyzer_colimator_2_blade_3
#define mccompcurtype  Union_box
#define mccompcurindex 234
#define loop_index mccinter_analyzer_colimator_2_blade_3_loop_index
#define this_box_volume mccinter_analyzer_colimator_2_blade_3_this_box_volume
#define global_geometry_element mccinter_analyzer_colimator_2_blade_3_global_geometry_element
#define this_box_storage mccinter_analyzer_colimator_2_blade_3_this_box_storage
#define material_string mccinter_analyzer_colimator_2_blade_3_material_string
#define priority mccinter_analyzer_colimator_2_blade_3_priority
#define xwidth mccinter_analyzer_colimator_2_blade_3_xwidth
#define yheight mccinter_analyzer_colimator_2_blade_3_yheight
#define zdepth mccinter_analyzer_colimator_2_blade_3_zdepth
#define xwidth2 mccinter_analyzer_colimator_2_blade_3_xwidth2
#define yheight2 mccinter_analyzer_colimator_2_blade_3_yheight2
#define visualize mccinter_analyzer_colimator_2_blade_3_visualize
#define target_index mccinter_analyzer_colimator_2_blade_3_target_index
#define target_x mccinter_analyzer_colimator_2_blade_3_target_x
#define target_y mccinter_analyzer_colimator_2_blade_3_target_y
#define target_z mccinter_analyzer_colimator_2_blade_3_target_z
#define focus_aw mccinter_analyzer_colimator_2_blade_3_focus_aw
#define focus_ah mccinter_analyzer_colimator_2_blade_3_focus_ah
#define focus_xw mccinter_analyzer_colimator_2_blade_3_focus_xw
#define focus_xh mccinter_analyzer_colimator_2_blade_3_focus_xh
#define focus_r mccinter_analyzer_colimator_2_blade_3_focus_r
#define p_interact mccinter_analyzer_colimator_2_blade_3_p_interact
#define mask_string mccinter_analyzer_colimator_2_blade_3_mask_string
#define mask_setting mccinter_analyzer_colimator_2_blade_3_mask_setting
#define number_of_activations mccinter_analyzer_colimator_2_blade_3_number_of_activations
#line 224 "Union_box.comp"
{
// Initializes the focusing system for this volume including input sanitation.
focus_initialize(&this_box_volume.geometry, POS_A_COMP_INDEX(INDEX_CURRENT_COMP+target_index), POS_A_CURRENT_COMP, ROT_A_CURRENT_COMP, target_index, target_x, target_y, target_z, focus_aw, focus_ah, focus_xw, focus_xh, focus_r, NAME_CURRENT_COMP);

// Input sanitation for this geometry
if (xwidth <= 0) {
  printf("\nERROR in Union_box named %s, the xwidth is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (yheight <= 0) {
  printf("\nERROR in Union_box named %s, yheight is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (zdepth <= 0) {
  printf("\nERROR in Union_box named %s, zdepth is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (xwidth2 <= 0 && xwidth2 != -1) {
  printf("\nERROR in Union_box named %s, the xwidth2 is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (yheight2 <= 0 && yheight2 != -1) {
  printf("\nERROR in Union_box named %s, yheight2 is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}

// Use sanitation
if (global_material_list.num_elements == 0) {
  printf("\nERROR: Need to define a material using Union_make_material before using a Union geometry component. \n");
  printf("       %s was defined before first use of Union_make_material.\n",NAME_CURRENT_COMP);
  exit(1);
}

this_box_volume.geometry.is_masked_volume = 0;
this_box_volume.geometry.is_exit_volume = 0;
this_box_volume.geometry.is_mask_volume = 0;
// check if the volume is a mask, if it is the material string is irelevant.
if (mask_string && strlen(mask_string) && strcmp(mask_string, "NULL") && strcmp(mask_string, "0")) {
    // A mask volume is used to limit the extend of other volumes, called the masked volumes. These are specified in the mask_string.
    // In order for a ray to enter a masked volume, it needs to be both in the region covered by that volume AND the mask volume.
    // When more than
    this_box_volume.geometry.mask_mode = 1; // Default is mask mode is ALL
    if (mask_setting && strlen(mask_setting) && strcmp(mask_setting, "NULL") && strcmp(mask_setting, "0")) {
        if (strcmp(mask_setting,"ALL") == 0 || strcmp(mask_setting,"All") == 0) this_box_volume.geometry.mask_mode = 1;
        else if (strcmp(mask_setting,"ANY") == 0 || strcmp(mask_setting,"Any") == 0) this_box_volume.geometry.mask_mode = 2;
        else {
            printf("The mask_mode of component %s is set to %s, but must be either ALL or ANY.\n",NAME_CURRENT_COMP,mask_setting);
            exit(1);
        }
    }
    
    for (loop_index=0;loop_index<global_geometry_list.num_elements;loop_index++) {
        // Add mask list
        if (1 == manual_linking_function(global_geometry_list.elements[loop_index].name,mask_string)) {
            add_element_to_int_list(&this_box_volume.geometry.mask_list,global_geometry_list.elements[loop_index].component_index);
            add_element_to_int_list(&global_geometry_list.elements[loop_index].Volume->geometry.masked_by_list,INDEX_CURRENT_COMP);
            global_geometry_list.elements[loop_index].Volume->geometry.is_masked_volume = 1;
            if (this_box_volume.geometry.mask_mode == 2)
                global_geometry_list.elements[loop_index].Volume->geometry.mask_mode = 2;
            if (this_box_volume.geometry.mask_mode == 1) {
                if (global_geometry_list.elements[loop_index].Volume->geometry.is_masked_volume == 1 && global_geometry_list.elements[loop_index].Volume->geometry.mask_mode != 2)
                    // If more than one mask is added to one volume, the ANY mode overwrites the (default) ALL mode.
                    global_geometry_list.elements[loop_index].Volume->geometry.mask_mode = 1;
            }
            
            found_geometries = 1;
        }
    }
    if (found_geometries == 0) {
        printf("The mask_string in geometry: %s did not find any of the specified volumes in the mask_string %s \n",NAME_CURRENT_COMP,mask_string);
        exit(1);
    }
    this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
    this_box_volume.p_physics->is_vacuum = 0; // Makes this volume a vacuum
    this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
    this_box_volume.p_physics->my_a = 0; // Should not be used.
    sprintf(this_box_volume.p_physics->name,"Mask");
    this_box_volume.geometry.is_mask_volume = 1;
    
    
// Read the material input, or if it lacks, use automatic linking.
} else if (material_string && strlen(material_string) && strcmp(material_string, "NULL") && strcmp(material_string, "0")) {
    // A geometry string was given, use it to determine which material
    if (0 == strcmp(material_string,"vacuum") || 0 == strcmp(material_string,"Vacuum")) {
        // One could have a global physics struct for vacuum instead of creating one for each
        this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
        this_box_volume.p_physics->is_vacuum = 1; // Makes this volume a vacuum
        this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
        this_box_volume.p_physics->my_a = 0; // Should not be used.
        sprintf(this_box_volume.p_physics->name,"Vacuum");
    } else if (0 == strcmp(material_string,"exit") || 0 == strcmp(material_string,"Exit")) {
        // One could have a global physics struct for vacuum instead of creating one for each
        this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
        this_box_volume.p_physics->is_vacuum = 1; // Makes this volume a vacuum
        this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
        this_box_volume.p_physics->my_a = 0; // Should not be used.
        this_box_volume.geometry.is_exit_volume = 1;
        sprintf(this_box_volume.p_physics->name,"Exit");
    } else {
        #ifndef MATERIAL_DETECTOR
            printf("Need to define a material before refering to it in a geometry %s.\n",NAME_CURRENT_COMP);
            exit(1);
        #endif
        for (loop_index=0;loop_index<global_material_list.num_elements;loop_index++) {
            if (0 == strcmp(material_string,global_material_list.elements[loop_index].name)) {
                this_box_volume.p_physics = global_material_list.elements[loop_index].physics;
                break;
            }
            if (loop_index == global_material_list.num_elements-1) {
            printf("\n");
            printf("ERROR: The material string \"%s\" in Union geometry \"%s\" did not match a specified material. \n",material_string,NAME_CURRENT_COMP);
            printf("       The materials available at this point (need to be defined before the geometry): \n");
            for (loop_index=0;loop_index<global_material_list.num_elements;loop_index++)
              printf("         %s\n",global_material_list.elements[loop_index].name);
            printf("\n");
            printf("       It is also possible to use one of the defualt materials avaiable: \n");
            printf("           Vacuum (for a Volume without scattering or absorption)\n");
            printf("           Exit (for a Volume where the ray exits the component if it enters)\n");
            printf("           Mask (for a Volume that masks existing volumes specified in the mask_string\n");
            exit(1);
          }
        }
    }
} else {
    // Automatic linking, simply using the last defined material.
    #ifndef MATERIAL_DETECTOR
        printf("Need to define a material before the geometry to use automatic linking %s.\n",NAME_CURRENT_COMP);
        exit(1);
    #endif
    this_box_volume.p_physics = global_material_list.elements[global_material_list.num_elements-1].physics;
}

sprintf(this_box_volume.name,NAME_CURRENT_COMP);
sprintf(this_box_volume.geometry.shape,"box");
this_box_volume.geometry.priority_value = priority;
this_box_volume.geometry.geometry_p_interact = p_interact;
// Currently the coordinates will be in absolute space.
this_box_volume.geometry.center = POS_A_CURRENT_COMP;

this_box_storage.z_depth = zdepth;
this_box_storage.x_width1 = xwidth;
this_box_storage.y_height1 = yheight;

this_box_storage.is_rectangle = 0;
if (xwidth2 < 0 && yheight2 < 0) this_box_storage.is_rectangle = 1;
if (xwidth == xwidth2 && yheight == yheight2) this_box_storage.is_rectangle = 1;

if (xwidth2 < 0) {
    this_box_storage.x_width2 = xwidth;
    xwidth2 = xwidth;
} else this_box_storage.x_width2 = xwidth2;

if (yheight2 < 0) {
    this_box_storage.y_height2 = yheight;
    yheight2 = yheight;
} else this_box_storage.y_height2 = yheight2;


this_box_storage.normal_vectors[0] = coords_set(0,0,1);
this_box_storage.normal_vectors[1] = coords_set(0,0,1);

// for sides with y component = 0
x_component = 2*zdepth/sqrt((xwidth-xwidth2)*(xwidth-xwidth2)+4*zdepth*zdepth);
z_component = (xwidth-xwidth2)/sqrt(4*zdepth*zdepth+(xwidth-xwidth2)*(xwidth-xwidth2));

this_box_storage.normal_vectors[2] = coords_set(x_component,0,z_component);
this_box_storage.normal_vectors[3] = coords_set(-x_component,0,z_component);

// for sides with x component = 0
y_component = 2*zdepth/sqrt((yheight-yheight2)*(yheight-yheight2)+4*zdepth*zdepth);
z_component = (yheight-yheight2)/sqrt(4*zdepth*zdepth+(yheight-yheight2)*(yheight-yheight2));

this_box_storage.normal_vectors[4] = coords_set(0,y_component,z_component);
this_box_storage.normal_vectors[5] = coords_set(0,-y_component,z_component);

this_box_volume.geometry.visualization_on = visualize;

this_box_volume.geometry.geometry_parameters.p_box_storage = &this_box_storage;

// Assign pointers to functions for intersection with the shape, checking if a point is inside the shape
if (this_box_storage.is_rectangle == 1) {
this_box_volume.geometry.intersect_function = &sample_box_intersect_simple;
this_box_volume.geometry.within_function = &r_within_box_simple;
}
else {
this_box_volume.geometry.intersect_function = &sample_box_intersect_advanced;
this_box_volume.geometry.within_function = &r_within_box_advanced;
}

this_box_volume.geometry.shell_points = &box_shell_points;
this_box_volume.geometry.mcdisplay_function = &mcdisplay_box_function;
this_box_volume.geometry.initialize_from_main_function = &initialize_box_geometry_from_main_component;
this_box_volume.geometry.process_rot_allocated = 0;

this_box_volume.geometry.copy_geometry_parameters = &allocate_box_storage_copy;

rot_copy(this_box_volume.geometry.rotation_matrix,ROT_A_CURRENT_COMP); //check how ROT_R_CURRENT_COMP would work
rot_transpose(ROT_A_CURRENT_COMP,this_box_volume.geometry.transpose_rotation_matrix);

// Initialize loggers
this_box_volume.loggers.num_elements = 0;

// packing the information into the global_geometry_element, which is then included in the global_geometry_list.
sprintf(global_geometry_element.name,NAME_CURRENT_COMP);
global_geometry_element.activation_counter = number_of_activations;
global_geometry_element.component_index = INDEX_CURRENT_COMP;
global_geometry_element.Volume = &this_box_volume; // Would be nicer if this m was a pointer, now we have the (small) data two places
add_element_to_geometry_list(&global_geometry_list,global_geometry_element);
}
#line 190097 "MACS_sample_kidney_box.c"
#undef number_of_activations
#undef mask_setting
#undef mask_string
#undef p_interact
#undef focus_r
#undef focus_xh
#undef focus_xw
#undef focus_ah
#undef focus_aw
#undef target_z
#undef target_y
#undef target_x
#undef target_index
#undef visualize
#undef yheight2
#undef xwidth2
#undef zdepth
#undef yheight
#undef xwidth
#undef priority
#undef material_string
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

  /* Initializations for component inter_analyzer_colimator_2_blade_4. */
  SIG_MESSAGE("inter_analyzer_colimator_2_blade_4 (Init)");
#define mccompcurname  inter_analyzer_colimator_2_blade_4
#define mccompcurtype  Union_box
#define mccompcurindex 235
#define loop_index mccinter_analyzer_colimator_2_blade_4_loop_index
#define this_box_volume mccinter_analyzer_colimator_2_blade_4_this_box_volume
#define global_geometry_element mccinter_analyzer_colimator_2_blade_4_global_geometry_element
#define this_box_storage mccinter_analyzer_colimator_2_blade_4_this_box_storage
#define material_string mccinter_analyzer_colimator_2_blade_4_material_string
#define priority mccinter_analyzer_colimator_2_blade_4_priority
#define xwidth mccinter_analyzer_colimator_2_blade_4_xwidth
#define yheight mccinter_analyzer_colimator_2_blade_4_yheight
#define zdepth mccinter_analyzer_colimator_2_blade_4_zdepth
#define xwidth2 mccinter_analyzer_colimator_2_blade_4_xwidth2
#define yheight2 mccinter_analyzer_colimator_2_blade_4_yheight2
#define visualize mccinter_analyzer_colimator_2_blade_4_visualize
#define target_index mccinter_analyzer_colimator_2_blade_4_target_index
#define target_x mccinter_analyzer_colimator_2_blade_4_target_x
#define target_y mccinter_analyzer_colimator_2_blade_4_target_y
#define target_z mccinter_analyzer_colimator_2_blade_4_target_z
#define focus_aw mccinter_analyzer_colimator_2_blade_4_focus_aw
#define focus_ah mccinter_analyzer_colimator_2_blade_4_focus_ah
#define focus_xw mccinter_analyzer_colimator_2_blade_4_focus_xw
#define focus_xh mccinter_analyzer_colimator_2_blade_4_focus_xh
#define focus_r mccinter_analyzer_colimator_2_blade_4_focus_r
#define p_interact mccinter_analyzer_colimator_2_blade_4_p_interact
#define mask_string mccinter_analyzer_colimator_2_blade_4_mask_string
#define mask_setting mccinter_analyzer_colimator_2_blade_4_mask_setting
#define number_of_activations mccinter_analyzer_colimator_2_blade_4_number_of_activations
#line 224 "Union_box.comp"
{
// Initializes the focusing system for this volume including input sanitation.
focus_initialize(&this_box_volume.geometry, POS_A_COMP_INDEX(INDEX_CURRENT_COMP+target_index), POS_A_CURRENT_COMP, ROT_A_CURRENT_COMP, target_index, target_x, target_y, target_z, focus_aw, focus_ah, focus_xw, focus_xh, focus_r, NAME_CURRENT_COMP);

// Input sanitation for this geometry
if (xwidth <= 0) {
  printf("\nERROR in Union_box named %s, the xwidth is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (yheight <= 0) {
  printf("\nERROR in Union_box named %s, yheight is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (zdepth <= 0) {
  printf("\nERROR in Union_box named %s, zdepth is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (xwidth2 <= 0 && xwidth2 != -1) {
  printf("\nERROR in Union_box named %s, the xwidth2 is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (yheight2 <= 0 && yheight2 != -1) {
  printf("\nERROR in Union_box named %s, yheight2 is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}

// Use sanitation
if (global_material_list.num_elements == 0) {
  printf("\nERROR: Need to define a material using Union_make_material before using a Union geometry component. \n");
  printf("       %s was defined before first use of Union_make_material.\n",NAME_CURRENT_COMP);
  exit(1);
}

this_box_volume.geometry.is_masked_volume = 0;
this_box_volume.geometry.is_exit_volume = 0;
this_box_volume.geometry.is_mask_volume = 0;
// check if the volume is a mask, if it is the material string is irelevant.
if (mask_string && strlen(mask_string) && strcmp(mask_string, "NULL") && strcmp(mask_string, "0")) {
    // A mask volume is used to limit the extend of other volumes, called the masked volumes. These are specified in the mask_string.
    // In order for a ray to enter a masked volume, it needs to be both in the region covered by that volume AND the mask volume.
    // When more than
    this_box_volume.geometry.mask_mode = 1; // Default is mask mode is ALL
    if (mask_setting && strlen(mask_setting) && strcmp(mask_setting, "NULL") && strcmp(mask_setting, "0")) {
        if (strcmp(mask_setting,"ALL") == 0 || strcmp(mask_setting,"All") == 0) this_box_volume.geometry.mask_mode = 1;
        else if (strcmp(mask_setting,"ANY") == 0 || strcmp(mask_setting,"Any") == 0) this_box_volume.geometry.mask_mode = 2;
        else {
            printf("The mask_mode of component %s is set to %s, but must be either ALL or ANY.\n",NAME_CURRENT_COMP,mask_setting);
            exit(1);
        }
    }
    
    for (loop_index=0;loop_index<global_geometry_list.num_elements;loop_index++) {
        // Add mask list
        if (1 == manual_linking_function(global_geometry_list.elements[loop_index].name,mask_string)) {
            add_element_to_int_list(&this_box_volume.geometry.mask_list,global_geometry_list.elements[loop_index].component_index);
            add_element_to_int_list(&global_geometry_list.elements[loop_index].Volume->geometry.masked_by_list,INDEX_CURRENT_COMP);
            global_geometry_list.elements[loop_index].Volume->geometry.is_masked_volume = 1;
            if (this_box_volume.geometry.mask_mode == 2)
                global_geometry_list.elements[loop_index].Volume->geometry.mask_mode = 2;
            if (this_box_volume.geometry.mask_mode == 1) {
                if (global_geometry_list.elements[loop_index].Volume->geometry.is_masked_volume == 1 && global_geometry_list.elements[loop_index].Volume->geometry.mask_mode != 2)
                    // If more than one mask is added to one volume, the ANY mode overwrites the (default) ALL mode.
                    global_geometry_list.elements[loop_index].Volume->geometry.mask_mode = 1;
            }
            
            found_geometries = 1;
        }
    }
    if (found_geometries == 0) {
        printf("The mask_string in geometry: %s did not find any of the specified volumes in the mask_string %s \n",NAME_CURRENT_COMP,mask_string);
        exit(1);
    }
    this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
    this_box_volume.p_physics->is_vacuum = 0; // Makes this volume a vacuum
    this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
    this_box_volume.p_physics->my_a = 0; // Should not be used.
    sprintf(this_box_volume.p_physics->name,"Mask");
    this_box_volume.geometry.is_mask_volume = 1;
    
    
// Read the material input, or if it lacks, use automatic linking.
} else if (material_string && strlen(material_string) && strcmp(material_string, "NULL") && strcmp(material_string, "0")) {
    // A geometry string was given, use it to determine which material
    if (0 == strcmp(material_string,"vacuum") || 0 == strcmp(material_string,"Vacuum")) {
        // One could have a global physics struct for vacuum instead of creating one for each
        this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
        this_box_volume.p_physics->is_vacuum = 1; // Makes this volume a vacuum
        this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
        this_box_volume.p_physics->my_a = 0; // Should not be used.
        sprintf(this_box_volume.p_physics->name,"Vacuum");
    } else if (0 == strcmp(material_string,"exit") || 0 == strcmp(material_string,"Exit")) {
        // One could have a global physics struct for vacuum instead of creating one for each
        this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
        this_box_volume.p_physics->is_vacuum = 1; // Makes this volume a vacuum
        this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
        this_box_volume.p_physics->my_a = 0; // Should not be used.
        this_box_volume.geometry.is_exit_volume = 1;
        sprintf(this_box_volume.p_physics->name,"Exit");
    } else {
        #ifndef MATERIAL_DETECTOR
            printf("Need to define a material before refering to it in a geometry %s.\n",NAME_CURRENT_COMP);
            exit(1);
        #endif
        for (loop_index=0;loop_index<global_material_list.num_elements;loop_index++) {
            if (0 == strcmp(material_string,global_material_list.elements[loop_index].name)) {
                this_box_volume.p_physics = global_material_list.elements[loop_index].physics;
                break;
            }
            if (loop_index == global_material_list.num_elements-1) {
            printf("\n");
            printf("ERROR: The material string \"%s\" in Union geometry \"%s\" did not match a specified material. \n",material_string,NAME_CURRENT_COMP);
            printf("       The materials available at this point (need to be defined before the geometry): \n");
            for (loop_index=0;loop_index<global_material_list.num_elements;loop_index++)
              printf("         %s\n",global_material_list.elements[loop_index].name);
            printf("\n");
            printf("       It is also possible to use one of the defualt materials avaiable: \n");
            printf("           Vacuum (for a Volume without scattering or absorption)\n");
            printf("           Exit (for a Volume where the ray exits the component if it enters)\n");
            printf("           Mask (for a Volume that masks existing volumes specified in the mask_string\n");
            exit(1);
          }
        }
    }
} else {
    // Automatic linking, simply using the last defined material.
    #ifndef MATERIAL_DETECTOR
        printf("Need to define a material before the geometry to use automatic linking %s.\n",NAME_CURRENT_COMP);
        exit(1);
    #endif
    this_box_volume.p_physics = global_material_list.elements[global_material_list.num_elements-1].physics;
}

sprintf(this_box_volume.name,NAME_CURRENT_COMP);
sprintf(this_box_volume.geometry.shape,"box");
this_box_volume.geometry.priority_value = priority;
this_box_volume.geometry.geometry_p_interact = p_interact;
// Currently the coordinates will be in absolute space.
this_box_volume.geometry.center = POS_A_CURRENT_COMP;

this_box_storage.z_depth = zdepth;
this_box_storage.x_width1 = xwidth;
this_box_storage.y_height1 = yheight;

this_box_storage.is_rectangle = 0;
if (xwidth2 < 0 && yheight2 < 0) this_box_storage.is_rectangle = 1;
if (xwidth == xwidth2 && yheight == yheight2) this_box_storage.is_rectangle = 1;

if (xwidth2 < 0) {
    this_box_storage.x_width2 = xwidth;
    xwidth2 = xwidth;
} else this_box_storage.x_width2 = xwidth2;

if (yheight2 < 0) {
    this_box_storage.y_height2 = yheight;
    yheight2 = yheight;
} else this_box_storage.y_height2 = yheight2;


this_box_storage.normal_vectors[0] = coords_set(0,0,1);
this_box_storage.normal_vectors[1] = coords_set(0,0,1);

// for sides with y component = 0
x_component = 2*zdepth/sqrt((xwidth-xwidth2)*(xwidth-xwidth2)+4*zdepth*zdepth);
z_component = (xwidth-xwidth2)/sqrt(4*zdepth*zdepth+(xwidth-xwidth2)*(xwidth-xwidth2));

this_box_storage.normal_vectors[2] = coords_set(x_component,0,z_component);
this_box_storage.normal_vectors[3] = coords_set(-x_component,0,z_component);

// for sides with x component = 0
y_component = 2*zdepth/sqrt((yheight-yheight2)*(yheight-yheight2)+4*zdepth*zdepth);
z_component = (yheight-yheight2)/sqrt(4*zdepth*zdepth+(yheight-yheight2)*(yheight-yheight2));

this_box_storage.normal_vectors[4] = coords_set(0,y_component,z_component);
this_box_storage.normal_vectors[5] = coords_set(0,-y_component,z_component);

this_box_volume.geometry.visualization_on = visualize;

this_box_volume.geometry.geometry_parameters.p_box_storage = &this_box_storage;

// Assign pointers to functions for intersection with the shape, checking if a point is inside the shape
if (this_box_storage.is_rectangle == 1) {
this_box_volume.geometry.intersect_function = &sample_box_intersect_simple;
this_box_volume.geometry.within_function = &r_within_box_simple;
}
else {
this_box_volume.geometry.intersect_function = &sample_box_intersect_advanced;
this_box_volume.geometry.within_function = &r_within_box_advanced;
}

this_box_volume.geometry.shell_points = &box_shell_points;
this_box_volume.geometry.mcdisplay_function = &mcdisplay_box_function;
this_box_volume.geometry.initialize_from_main_function = &initialize_box_geometry_from_main_component;
this_box_volume.geometry.process_rot_allocated = 0;

this_box_volume.geometry.copy_geometry_parameters = &allocate_box_storage_copy;

rot_copy(this_box_volume.geometry.rotation_matrix,ROT_A_CURRENT_COMP); //check how ROT_R_CURRENT_COMP would work
rot_transpose(ROT_A_CURRENT_COMP,this_box_volume.geometry.transpose_rotation_matrix);

// Initialize loggers
this_box_volume.loggers.num_elements = 0;

// packing the information into the global_geometry_element, which is then included in the global_geometry_list.
sprintf(global_geometry_element.name,NAME_CURRENT_COMP);
global_geometry_element.activation_counter = number_of_activations;
global_geometry_element.component_index = INDEX_CURRENT_COMP;
global_geometry_element.Volume = &this_box_volume; // Would be nicer if this m was a pointer, now we have the (small) data two places
add_element_to_geometry_list(&global_geometry_list,global_geometry_element);
}
#line 190367 "MACS_sample_kidney_box.c"
#undef number_of_activations
#undef mask_setting
#undef mask_string
#undef p_interact
#undef focus_r
#undef focus_xh
#undef focus_xw
#undef focus_ah
#undef focus_aw
#undef target_z
#undef target_y
#undef target_x
#undef target_index
#undef visualize
#undef yheight2
#undef xwidth2
#undef zdepth
#undef yheight
#undef xwidth
#undef priority
#undef material_string
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

  /* Initializations for component diffraction_detector_2_exit_volume. */
  SIG_MESSAGE("diffraction_detector_2_exit_volume (Init)");
#define mccompcurname  diffraction_detector_2_exit_volume
#define mccompcurtype  Union_box
#define mccompcurindex 236
#define loop_index mccdiffraction_detector_2_exit_volume_loop_index
#define this_box_volume mccdiffraction_detector_2_exit_volume_this_box_volume
#define global_geometry_element mccdiffraction_detector_2_exit_volume_global_geometry_element
#define this_box_storage mccdiffraction_detector_2_exit_volume_this_box_storage
#define material_string mccdiffraction_detector_2_exit_volume_material_string
#define priority mccdiffraction_detector_2_exit_volume_priority
#define xwidth mccdiffraction_detector_2_exit_volume_xwidth
#define yheight mccdiffraction_detector_2_exit_volume_yheight
#define zdepth mccdiffraction_detector_2_exit_volume_zdepth
#define xwidth2 mccdiffraction_detector_2_exit_volume_xwidth2
#define yheight2 mccdiffraction_detector_2_exit_volume_yheight2
#define visualize mccdiffraction_detector_2_exit_volume_visualize
#define target_index mccdiffraction_detector_2_exit_volume_target_index
#define target_x mccdiffraction_detector_2_exit_volume_target_x
#define target_y mccdiffraction_detector_2_exit_volume_target_y
#define target_z mccdiffraction_detector_2_exit_volume_target_z
#define focus_aw mccdiffraction_detector_2_exit_volume_focus_aw
#define focus_ah mccdiffraction_detector_2_exit_volume_focus_ah
#define focus_xw mccdiffraction_detector_2_exit_volume_focus_xw
#define focus_xh mccdiffraction_detector_2_exit_volume_focus_xh
#define focus_r mccdiffraction_detector_2_exit_volume_focus_r
#define p_interact mccdiffraction_detector_2_exit_volume_p_interact
#define mask_string mccdiffraction_detector_2_exit_volume_mask_string
#define mask_setting mccdiffraction_detector_2_exit_volume_mask_setting
#define number_of_activations mccdiffraction_detector_2_exit_volume_number_of_activations
#line 224 "Union_box.comp"
{
// Initializes the focusing system for this volume including input sanitation.
focus_initialize(&this_box_volume.geometry, POS_A_COMP_INDEX(INDEX_CURRENT_COMP+target_index), POS_A_CURRENT_COMP, ROT_A_CURRENT_COMP, target_index, target_x, target_y, target_z, focus_aw, focus_ah, focus_xw, focus_xh, focus_r, NAME_CURRENT_COMP);

// Input sanitation for this geometry
if (xwidth <= 0) {
  printf("\nERROR in Union_box named %s, the xwidth is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (yheight <= 0) {
  printf("\nERROR in Union_box named %s, yheight is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (zdepth <= 0) {
  printf("\nERROR in Union_box named %s, zdepth is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (xwidth2 <= 0 && xwidth2 != -1) {
  printf("\nERROR in Union_box named %s, the xwidth2 is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (yheight2 <= 0 && yheight2 != -1) {
  printf("\nERROR in Union_box named %s, yheight2 is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}

// Use sanitation
if (global_material_list.num_elements == 0) {
  printf("\nERROR: Need to define a material using Union_make_material before using a Union geometry component. \n");
  printf("       %s was defined before first use of Union_make_material.\n",NAME_CURRENT_COMP);
  exit(1);
}

this_box_volume.geometry.is_masked_volume = 0;
this_box_volume.geometry.is_exit_volume = 0;
this_box_volume.geometry.is_mask_volume = 0;
// check if the volume is a mask, if it is the material string is irelevant.
if (mask_string && strlen(mask_string) && strcmp(mask_string, "NULL") && strcmp(mask_string, "0")) {
    // A mask volume is used to limit the extend of other volumes, called the masked volumes. These are specified in the mask_string.
    // In order for a ray to enter a masked volume, it needs to be both in the region covered by that volume AND the mask volume.
    // When more than
    this_box_volume.geometry.mask_mode = 1; // Default is mask mode is ALL
    if (mask_setting && strlen(mask_setting) && strcmp(mask_setting, "NULL") && strcmp(mask_setting, "0")) {
        if (strcmp(mask_setting,"ALL") == 0 || strcmp(mask_setting,"All") == 0) this_box_volume.geometry.mask_mode = 1;
        else if (strcmp(mask_setting,"ANY") == 0 || strcmp(mask_setting,"Any") == 0) this_box_volume.geometry.mask_mode = 2;
        else {
            printf("The mask_mode of component %s is set to %s, but must be either ALL or ANY.\n",NAME_CURRENT_COMP,mask_setting);
            exit(1);
        }
    }
    
    for (loop_index=0;loop_index<global_geometry_list.num_elements;loop_index++) {
        // Add mask list
        if (1 == manual_linking_function(global_geometry_list.elements[loop_index].name,mask_string)) {
            add_element_to_int_list(&this_box_volume.geometry.mask_list,global_geometry_list.elements[loop_index].component_index);
            add_element_to_int_list(&global_geometry_list.elements[loop_index].Volume->geometry.masked_by_list,INDEX_CURRENT_COMP);
            global_geometry_list.elements[loop_index].Volume->geometry.is_masked_volume = 1;
            if (this_box_volume.geometry.mask_mode == 2)
                global_geometry_list.elements[loop_index].Volume->geometry.mask_mode = 2;
            if (this_box_volume.geometry.mask_mode == 1) {
                if (global_geometry_list.elements[loop_index].Volume->geometry.is_masked_volume == 1 && global_geometry_list.elements[loop_index].Volume->geometry.mask_mode != 2)
                    // If more than one mask is added to one volume, the ANY mode overwrites the (default) ALL mode.
                    global_geometry_list.elements[loop_index].Volume->geometry.mask_mode = 1;
            }
            
            found_geometries = 1;
        }
    }
    if (found_geometries == 0) {
        printf("The mask_string in geometry: %s did not find any of the specified volumes in the mask_string %s \n",NAME_CURRENT_COMP,mask_string);
        exit(1);
    }
    this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
    this_box_volume.p_physics->is_vacuum = 0; // Makes this volume a vacuum
    this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
    this_box_volume.p_physics->my_a = 0; // Should not be used.
    sprintf(this_box_volume.p_physics->name,"Mask");
    this_box_volume.geometry.is_mask_volume = 1;
    
    
// Read the material input, or if it lacks, use automatic linking.
} else if (material_string && strlen(material_string) && strcmp(material_string, "NULL") && strcmp(material_string, "0")) {
    // A geometry string was given, use it to determine which material
    if (0 == strcmp(material_string,"vacuum") || 0 == strcmp(material_string,"Vacuum")) {
        // One could have a global physics struct for vacuum instead of creating one for each
        this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
        this_box_volume.p_physics->is_vacuum = 1; // Makes this volume a vacuum
        this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
        this_box_volume.p_physics->my_a = 0; // Should not be used.
        sprintf(this_box_volume.p_physics->name,"Vacuum");
    } else if (0 == strcmp(material_string,"exit") || 0 == strcmp(material_string,"Exit")) {
        // One could have a global physics struct for vacuum instead of creating one for each
        this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
        this_box_volume.p_physics->is_vacuum = 1; // Makes this volume a vacuum
        this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
        this_box_volume.p_physics->my_a = 0; // Should not be used.
        this_box_volume.geometry.is_exit_volume = 1;
        sprintf(this_box_volume.p_physics->name,"Exit");
    } else {
        #ifndef MATERIAL_DETECTOR
            printf("Need to define a material before refering to it in a geometry %s.\n",NAME_CURRENT_COMP);
            exit(1);
        #endif
        for (loop_index=0;loop_index<global_material_list.num_elements;loop_index++) {
            if (0 == strcmp(material_string,global_material_list.elements[loop_index].name)) {
                this_box_volume.p_physics = global_material_list.elements[loop_index].physics;
                break;
            }
            if (loop_index == global_material_list.num_elements-1) {
            printf("\n");
            printf("ERROR: The material string \"%s\" in Union geometry \"%s\" did not match a specified material. \n",material_string,NAME_CURRENT_COMP);
            printf("       The materials available at this point (need to be defined before the geometry): \n");
            for (loop_index=0;loop_index<global_material_list.num_elements;loop_index++)
              printf("         %s\n",global_material_list.elements[loop_index].name);
            printf("\n");
            printf("       It is also possible to use one of the defualt materials avaiable: \n");
            printf("           Vacuum (for a Volume without scattering or absorption)\n");
            printf("           Exit (for a Volume where the ray exits the component if it enters)\n");
            printf("           Mask (for a Volume that masks existing volumes specified in the mask_string\n");
            exit(1);
          }
        }
    }
} else {
    // Automatic linking, simply using the last defined material.
    #ifndef MATERIAL_DETECTOR
        printf("Need to define a material before the geometry to use automatic linking %s.\n",NAME_CURRENT_COMP);
        exit(1);
    #endif
    this_box_volume.p_physics = global_material_list.elements[global_material_list.num_elements-1].physics;
}

sprintf(this_box_volume.name,NAME_CURRENT_COMP);
sprintf(this_box_volume.geometry.shape,"box");
this_box_volume.geometry.priority_value = priority;
this_box_volume.geometry.geometry_p_interact = p_interact;
// Currently the coordinates will be in absolute space.
this_box_volume.geometry.center = POS_A_CURRENT_COMP;

this_box_storage.z_depth = zdepth;
this_box_storage.x_width1 = xwidth;
this_box_storage.y_height1 = yheight;

this_box_storage.is_rectangle = 0;
if (xwidth2 < 0 && yheight2 < 0) this_box_storage.is_rectangle = 1;
if (xwidth == xwidth2 && yheight == yheight2) this_box_storage.is_rectangle = 1;

if (xwidth2 < 0) {
    this_box_storage.x_width2 = xwidth;
    xwidth2 = xwidth;
} else this_box_storage.x_width2 = xwidth2;

if (yheight2 < 0) {
    this_box_storage.y_height2 = yheight;
    yheight2 = yheight;
} else this_box_storage.y_height2 = yheight2;


this_box_storage.normal_vectors[0] = coords_set(0,0,1);
this_box_storage.normal_vectors[1] = coords_set(0,0,1);

// for sides with y component = 0
x_component = 2*zdepth/sqrt((xwidth-xwidth2)*(xwidth-xwidth2)+4*zdepth*zdepth);
z_component = (xwidth-xwidth2)/sqrt(4*zdepth*zdepth+(xwidth-xwidth2)*(xwidth-xwidth2));

this_box_storage.normal_vectors[2] = coords_set(x_component,0,z_component);
this_box_storage.normal_vectors[3] = coords_set(-x_component,0,z_component);

// for sides with x component = 0
y_component = 2*zdepth/sqrt((yheight-yheight2)*(yheight-yheight2)+4*zdepth*zdepth);
z_component = (yheight-yheight2)/sqrt(4*zdepth*zdepth+(yheight-yheight2)*(yheight-yheight2));

this_box_storage.normal_vectors[4] = coords_set(0,y_component,z_component);
this_box_storage.normal_vectors[5] = coords_set(0,-y_component,z_component);

this_box_volume.geometry.visualization_on = visualize;

this_box_volume.geometry.geometry_parameters.p_box_storage = &this_box_storage;

// Assign pointers to functions for intersection with the shape, checking if a point is inside the shape
if (this_box_storage.is_rectangle == 1) {
this_box_volume.geometry.intersect_function = &sample_box_intersect_simple;
this_box_volume.geometry.within_function = &r_within_box_simple;
}
else {
this_box_volume.geometry.intersect_function = &sample_box_intersect_advanced;
this_box_volume.geometry.within_function = &r_within_box_advanced;
}

this_box_volume.geometry.shell_points = &box_shell_points;
this_box_volume.geometry.mcdisplay_function = &mcdisplay_box_function;
this_box_volume.geometry.initialize_from_main_function = &initialize_box_geometry_from_main_component;
this_box_volume.geometry.process_rot_allocated = 0;

this_box_volume.geometry.copy_geometry_parameters = &allocate_box_storage_copy;

rot_copy(this_box_volume.geometry.rotation_matrix,ROT_A_CURRENT_COMP); //check how ROT_R_CURRENT_COMP would work
rot_transpose(ROT_A_CURRENT_COMP,this_box_volume.geometry.transpose_rotation_matrix);

// Initialize loggers
this_box_volume.loggers.num_elements = 0;

// packing the information into the global_geometry_element, which is then included in the global_geometry_list.
sprintf(global_geometry_element.name,NAME_CURRENT_COMP);
global_geometry_element.activation_counter = number_of_activations;
global_geometry_element.component_index = INDEX_CURRENT_COMP;
global_geometry_element.Volume = &this_box_volume; // Would be nicer if this m was a pointer, now we have the (small) data two places
add_element_to_geometry_list(&global_geometry_list,global_geometry_element);
}
#line 190637 "MACS_sample_kidney_box.c"
#undef number_of_activations
#undef mask_setting
#undef mask_string
#undef p_interact
#undef focus_r
#undef focus_xh
#undef focus_xw
#undef focus_ah
#undef focus_aw
#undef target_z
#undef target_y
#undef target_x
#undef target_index
#undef visualize
#undef yheight2
#undef xwidth2
#undef zdepth
#undef yheight
#undef xwidth
#undef priority
#undef material_string
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

  /* Initializations for component spec_detector_2_exit_volume. */
  SIG_MESSAGE("spec_detector_2_exit_volume (Init)");
#define mccompcurname  spec_detector_2_exit_volume
#define mccompcurtype  Union_box
#define mccompcurindex 237
#define loop_index mccspec_detector_2_exit_volume_loop_index
#define this_box_volume mccspec_detector_2_exit_volume_this_box_volume
#define global_geometry_element mccspec_detector_2_exit_volume_global_geometry_element
#define this_box_storage mccspec_detector_2_exit_volume_this_box_storage
#define material_string mccspec_detector_2_exit_volume_material_string
#define priority mccspec_detector_2_exit_volume_priority
#define xwidth mccspec_detector_2_exit_volume_xwidth
#define yheight mccspec_detector_2_exit_volume_yheight
#define zdepth mccspec_detector_2_exit_volume_zdepth
#define xwidth2 mccspec_detector_2_exit_volume_xwidth2
#define yheight2 mccspec_detector_2_exit_volume_yheight2
#define visualize mccspec_detector_2_exit_volume_visualize
#define target_index mccspec_detector_2_exit_volume_target_index
#define target_x mccspec_detector_2_exit_volume_target_x
#define target_y mccspec_detector_2_exit_volume_target_y
#define target_z mccspec_detector_2_exit_volume_target_z
#define focus_aw mccspec_detector_2_exit_volume_focus_aw
#define focus_ah mccspec_detector_2_exit_volume_focus_ah
#define focus_xw mccspec_detector_2_exit_volume_focus_xw
#define focus_xh mccspec_detector_2_exit_volume_focus_xh
#define focus_r mccspec_detector_2_exit_volume_focus_r
#define p_interact mccspec_detector_2_exit_volume_p_interact
#define mask_string mccspec_detector_2_exit_volume_mask_string
#define mask_setting mccspec_detector_2_exit_volume_mask_setting
#define number_of_activations mccspec_detector_2_exit_volume_number_of_activations
#line 224 "Union_box.comp"
{
// Initializes the focusing system for this volume including input sanitation.
focus_initialize(&this_box_volume.geometry, POS_A_COMP_INDEX(INDEX_CURRENT_COMP+target_index), POS_A_CURRENT_COMP, ROT_A_CURRENT_COMP, target_index, target_x, target_y, target_z, focus_aw, focus_ah, focus_xw, focus_xh, focus_r, NAME_CURRENT_COMP);

// Input sanitation for this geometry
if (xwidth <= 0) {
  printf("\nERROR in Union_box named %s, the xwidth is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (yheight <= 0) {
  printf("\nERROR in Union_box named %s, yheight is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (zdepth <= 0) {
  printf("\nERROR in Union_box named %s, zdepth is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (xwidth2 <= 0 && xwidth2 != -1) {
  printf("\nERROR in Union_box named %s, the xwidth2 is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (yheight2 <= 0 && yheight2 != -1) {
  printf("\nERROR in Union_box named %s, yheight2 is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}

// Use sanitation
if (global_material_list.num_elements == 0) {
  printf("\nERROR: Need to define a material using Union_make_material before using a Union geometry component. \n");
  printf("       %s was defined before first use of Union_make_material.\n",NAME_CURRENT_COMP);
  exit(1);
}

this_box_volume.geometry.is_masked_volume = 0;
this_box_volume.geometry.is_exit_volume = 0;
this_box_volume.geometry.is_mask_volume = 0;
// check if the volume is a mask, if it is the material string is irelevant.
if (mask_string && strlen(mask_string) && strcmp(mask_string, "NULL") && strcmp(mask_string, "0")) {
    // A mask volume is used to limit the extend of other volumes, called the masked volumes. These are specified in the mask_string.
    // In order for a ray to enter a masked volume, it needs to be both in the region covered by that volume AND the mask volume.
    // When more than
    this_box_volume.geometry.mask_mode = 1; // Default is mask mode is ALL
    if (mask_setting && strlen(mask_setting) && strcmp(mask_setting, "NULL") && strcmp(mask_setting, "0")) {
        if (strcmp(mask_setting,"ALL") == 0 || strcmp(mask_setting,"All") == 0) this_box_volume.geometry.mask_mode = 1;
        else if (strcmp(mask_setting,"ANY") == 0 || strcmp(mask_setting,"Any") == 0) this_box_volume.geometry.mask_mode = 2;
        else {
            printf("The mask_mode of component %s is set to %s, but must be either ALL or ANY.\n",NAME_CURRENT_COMP,mask_setting);
            exit(1);
        }
    }
    
    for (loop_index=0;loop_index<global_geometry_list.num_elements;loop_index++) {
        // Add mask list
        if (1 == manual_linking_function(global_geometry_list.elements[loop_index].name,mask_string)) {
            add_element_to_int_list(&this_box_volume.geometry.mask_list,global_geometry_list.elements[loop_index].component_index);
            add_element_to_int_list(&global_geometry_list.elements[loop_index].Volume->geometry.masked_by_list,INDEX_CURRENT_COMP);
            global_geometry_list.elements[loop_index].Volume->geometry.is_masked_volume = 1;
            if (this_box_volume.geometry.mask_mode == 2)
                global_geometry_list.elements[loop_index].Volume->geometry.mask_mode = 2;
            if (this_box_volume.geometry.mask_mode == 1) {
                if (global_geometry_list.elements[loop_index].Volume->geometry.is_masked_volume == 1 && global_geometry_list.elements[loop_index].Volume->geometry.mask_mode != 2)
                    // If more than one mask is added to one volume, the ANY mode overwrites the (default) ALL mode.
                    global_geometry_list.elements[loop_index].Volume->geometry.mask_mode = 1;
            }
            
            found_geometries = 1;
        }
    }
    if (found_geometries == 0) {
        printf("The mask_string in geometry: %s did not find any of the specified volumes in the mask_string %s \n",NAME_CURRENT_COMP,mask_string);
        exit(1);
    }
    this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
    this_box_volume.p_physics->is_vacuum = 0; // Makes this volume a vacuum
    this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
    this_box_volume.p_physics->my_a = 0; // Should not be used.
    sprintf(this_box_volume.p_physics->name,"Mask");
    this_box_volume.geometry.is_mask_volume = 1;
    
    
// Read the material input, or if it lacks, use automatic linking.
} else if (material_string && strlen(material_string) && strcmp(material_string, "NULL") && strcmp(material_string, "0")) {
    // A geometry string was given, use it to determine which material
    if (0 == strcmp(material_string,"vacuum") || 0 == strcmp(material_string,"Vacuum")) {
        // One could have a global physics struct for vacuum instead of creating one for each
        this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
        this_box_volume.p_physics->is_vacuum = 1; // Makes this volume a vacuum
        this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
        this_box_volume.p_physics->my_a = 0; // Should not be used.
        sprintf(this_box_volume.p_physics->name,"Vacuum");
    } else if (0 == strcmp(material_string,"exit") || 0 == strcmp(material_string,"Exit")) {
        // One could have a global physics struct for vacuum instead of creating one for each
        this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
        this_box_volume.p_physics->is_vacuum = 1; // Makes this volume a vacuum
        this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
        this_box_volume.p_physics->my_a = 0; // Should not be used.
        this_box_volume.geometry.is_exit_volume = 1;
        sprintf(this_box_volume.p_physics->name,"Exit");
    } else {
        #ifndef MATERIAL_DETECTOR
            printf("Need to define a material before refering to it in a geometry %s.\n",NAME_CURRENT_COMP);
            exit(1);
        #endif
        for (loop_index=0;loop_index<global_material_list.num_elements;loop_index++) {
            if (0 == strcmp(material_string,global_material_list.elements[loop_index].name)) {
                this_box_volume.p_physics = global_material_list.elements[loop_index].physics;
                break;
            }
            if (loop_index == global_material_list.num_elements-1) {
            printf("\n");
            printf("ERROR: The material string \"%s\" in Union geometry \"%s\" did not match a specified material. \n",material_string,NAME_CURRENT_COMP);
            printf("       The materials available at this point (need to be defined before the geometry): \n");
            for (loop_index=0;loop_index<global_material_list.num_elements;loop_index++)
              printf("         %s\n",global_material_list.elements[loop_index].name);
            printf("\n");
            printf("       It is also possible to use one of the defualt materials avaiable: \n");
            printf("           Vacuum (for a Volume without scattering or absorption)\n");
            printf("           Exit (for a Volume where the ray exits the component if it enters)\n");
            printf("           Mask (for a Volume that masks existing volumes specified in the mask_string\n");
            exit(1);
          }
        }
    }
} else {
    // Automatic linking, simply using the last defined material.
    #ifndef MATERIAL_DETECTOR
        printf("Need to define a material before the geometry to use automatic linking %s.\n",NAME_CURRENT_COMP);
        exit(1);
    #endif
    this_box_volume.p_physics = global_material_list.elements[global_material_list.num_elements-1].physics;
}

sprintf(this_box_volume.name,NAME_CURRENT_COMP);
sprintf(this_box_volume.geometry.shape,"box");
this_box_volume.geometry.priority_value = priority;
this_box_volume.geometry.geometry_p_interact = p_interact;
// Currently the coordinates will be in absolute space.
this_box_volume.geometry.center = POS_A_CURRENT_COMP;

this_box_storage.z_depth = zdepth;
this_box_storage.x_width1 = xwidth;
this_box_storage.y_height1 = yheight;

this_box_storage.is_rectangle = 0;
if (xwidth2 < 0 && yheight2 < 0) this_box_storage.is_rectangle = 1;
if (xwidth == xwidth2 && yheight == yheight2) this_box_storage.is_rectangle = 1;

if (xwidth2 < 0) {
    this_box_storage.x_width2 = xwidth;
    xwidth2 = xwidth;
} else this_box_storage.x_width2 = xwidth2;

if (yheight2 < 0) {
    this_box_storage.y_height2 = yheight;
    yheight2 = yheight;
} else this_box_storage.y_height2 = yheight2;


this_box_storage.normal_vectors[0] = coords_set(0,0,1);
this_box_storage.normal_vectors[1] = coords_set(0,0,1);

// for sides with y component = 0
x_component = 2*zdepth/sqrt((xwidth-xwidth2)*(xwidth-xwidth2)+4*zdepth*zdepth);
z_component = (xwidth-xwidth2)/sqrt(4*zdepth*zdepth+(xwidth-xwidth2)*(xwidth-xwidth2));

this_box_storage.normal_vectors[2] = coords_set(x_component,0,z_component);
this_box_storage.normal_vectors[3] = coords_set(-x_component,0,z_component);

// for sides with x component = 0
y_component = 2*zdepth/sqrt((yheight-yheight2)*(yheight-yheight2)+4*zdepth*zdepth);
z_component = (yheight-yheight2)/sqrt(4*zdepth*zdepth+(yheight-yheight2)*(yheight-yheight2));

this_box_storage.normal_vectors[4] = coords_set(0,y_component,z_component);
this_box_storage.normal_vectors[5] = coords_set(0,-y_component,z_component);

this_box_volume.geometry.visualization_on = visualize;

this_box_volume.geometry.geometry_parameters.p_box_storage = &this_box_storage;

// Assign pointers to functions for intersection with the shape, checking if a point is inside the shape
if (this_box_storage.is_rectangle == 1) {
this_box_volume.geometry.intersect_function = &sample_box_intersect_simple;
this_box_volume.geometry.within_function = &r_within_box_simple;
}
else {
this_box_volume.geometry.intersect_function = &sample_box_intersect_advanced;
this_box_volume.geometry.within_function = &r_within_box_advanced;
}

this_box_volume.geometry.shell_points = &box_shell_points;
this_box_volume.geometry.mcdisplay_function = &mcdisplay_box_function;
this_box_volume.geometry.initialize_from_main_function = &initialize_box_geometry_from_main_component;
this_box_volume.geometry.process_rot_allocated = 0;

this_box_volume.geometry.copy_geometry_parameters = &allocate_box_storage_copy;

rot_copy(this_box_volume.geometry.rotation_matrix,ROT_A_CURRENT_COMP); //check how ROT_R_CURRENT_COMP would work
rot_transpose(ROT_A_CURRENT_COMP,this_box_volume.geometry.transpose_rotation_matrix);

// Initialize loggers
this_box_volume.loggers.num_elements = 0;

// packing the information into the global_geometry_element, which is then included in the global_geometry_list.
sprintf(global_geometry_element.name,NAME_CURRENT_COMP);
global_geometry_element.activation_counter = number_of_activations;
global_geometry_element.component_index = INDEX_CURRENT_COMP;
global_geometry_element.Volume = &this_box_volume; // Would be nicer if this m was a pointer, now we have the (small) data two places
add_element_to_geometry_list(&global_geometry_list,global_geometry_element);
}
#line 190907 "MACS_sample_kidney_box.c"
#undef number_of_activations
#undef mask_setting
#undef mask_string
#undef p_interact
#undef focus_r
#undef focus_xh
#undef focus_xw
#undef focus_ah
#undef focus_aw
#undef target_z
#undef target_y
#undef target_x
#undef target_index
#undef visualize
#undef yheight2
#undef xwidth2
#undef zdepth
#undef yheight
#undef xwidth
#undef priority
#undef material_string
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

  /* Initializations for component channel_3_cave1_box1. */
  SIG_MESSAGE("channel_3_cave1_box1 (Init)");
#define mccompcurname  channel_3_cave1_box1
#define mccompcurtype  Union_box
#define mccompcurindex 238
#define loop_index mccchannel_3_cave1_box1_loop_index
#define this_box_volume mccchannel_3_cave1_box1_this_box_volume
#define global_geometry_element mccchannel_3_cave1_box1_global_geometry_element
#define this_box_storage mccchannel_3_cave1_box1_this_box_storage
#define material_string mccchannel_3_cave1_box1_material_string
#define priority mccchannel_3_cave1_box1_priority
#define xwidth mccchannel_3_cave1_box1_xwidth
#define yheight mccchannel_3_cave1_box1_yheight
#define zdepth mccchannel_3_cave1_box1_zdepth
#define xwidth2 mccchannel_3_cave1_box1_xwidth2
#define yheight2 mccchannel_3_cave1_box1_yheight2
#define visualize mccchannel_3_cave1_box1_visualize
#define target_index mccchannel_3_cave1_box1_target_index
#define target_x mccchannel_3_cave1_box1_target_x
#define target_y mccchannel_3_cave1_box1_target_y
#define target_z mccchannel_3_cave1_box1_target_z
#define focus_aw mccchannel_3_cave1_box1_focus_aw
#define focus_ah mccchannel_3_cave1_box1_focus_ah
#define focus_xw mccchannel_3_cave1_box1_focus_xw
#define focus_xh mccchannel_3_cave1_box1_focus_xh
#define focus_r mccchannel_3_cave1_box1_focus_r
#define p_interact mccchannel_3_cave1_box1_p_interact
#define mask_string mccchannel_3_cave1_box1_mask_string
#define mask_setting mccchannel_3_cave1_box1_mask_setting
#define number_of_activations mccchannel_3_cave1_box1_number_of_activations
#line 224 "Union_box.comp"
{
// Initializes the focusing system for this volume including input sanitation.
focus_initialize(&this_box_volume.geometry, POS_A_COMP_INDEX(INDEX_CURRENT_COMP+target_index), POS_A_CURRENT_COMP, ROT_A_CURRENT_COMP, target_index, target_x, target_y, target_z, focus_aw, focus_ah, focus_xw, focus_xh, focus_r, NAME_CURRENT_COMP);

// Input sanitation for this geometry
if (xwidth <= 0) {
  printf("\nERROR in Union_box named %s, the xwidth is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (yheight <= 0) {
  printf("\nERROR in Union_box named %s, yheight is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (zdepth <= 0) {
  printf("\nERROR in Union_box named %s, zdepth is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (xwidth2 <= 0 && xwidth2 != -1) {
  printf("\nERROR in Union_box named %s, the xwidth2 is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (yheight2 <= 0 && yheight2 != -1) {
  printf("\nERROR in Union_box named %s, yheight2 is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}

// Use sanitation
if (global_material_list.num_elements == 0) {
  printf("\nERROR: Need to define a material using Union_make_material before using a Union geometry component. \n");
  printf("       %s was defined before first use of Union_make_material.\n",NAME_CURRENT_COMP);
  exit(1);
}

this_box_volume.geometry.is_masked_volume = 0;
this_box_volume.geometry.is_exit_volume = 0;
this_box_volume.geometry.is_mask_volume = 0;
// check if the volume is a mask, if it is the material string is irelevant.
if (mask_string && strlen(mask_string) && strcmp(mask_string, "NULL") && strcmp(mask_string, "0")) {
    // A mask volume is used to limit the extend of other volumes, called the masked volumes. These are specified in the mask_string.
    // In order for a ray to enter a masked volume, it needs to be both in the region covered by that volume AND the mask volume.
    // When more than
    this_box_volume.geometry.mask_mode = 1; // Default is mask mode is ALL
    if (mask_setting && strlen(mask_setting) && strcmp(mask_setting, "NULL") && strcmp(mask_setting, "0")) {
        if (strcmp(mask_setting,"ALL") == 0 || strcmp(mask_setting,"All") == 0) this_box_volume.geometry.mask_mode = 1;
        else if (strcmp(mask_setting,"ANY") == 0 || strcmp(mask_setting,"Any") == 0) this_box_volume.geometry.mask_mode = 2;
        else {
            printf("The mask_mode of component %s is set to %s, but must be either ALL or ANY.\n",NAME_CURRENT_COMP,mask_setting);
            exit(1);
        }
    }
    
    for (loop_index=0;loop_index<global_geometry_list.num_elements;loop_index++) {
        // Add mask list
        if (1 == manual_linking_function(global_geometry_list.elements[loop_index].name,mask_string)) {
            add_element_to_int_list(&this_box_volume.geometry.mask_list,global_geometry_list.elements[loop_index].component_index);
            add_element_to_int_list(&global_geometry_list.elements[loop_index].Volume->geometry.masked_by_list,INDEX_CURRENT_COMP);
            global_geometry_list.elements[loop_index].Volume->geometry.is_masked_volume = 1;
            if (this_box_volume.geometry.mask_mode == 2)
                global_geometry_list.elements[loop_index].Volume->geometry.mask_mode = 2;
            if (this_box_volume.geometry.mask_mode == 1) {
                if (global_geometry_list.elements[loop_index].Volume->geometry.is_masked_volume == 1 && global_geometry_list.elements[loop_index].Volume->geometry.mask_mode != 2)
                    // If more than one mask is added to one volume, the ANY mode overwrites the (default) ALL mode.
                    global_geometry_list.elements[loop_index].Volume->geometry.mask_mode = 1;
            }
            
            found_geometries = 1;
        }
    }
    if (found_geometries == 0) {
        printf("The mask_string in geometry: %s did not find any of the specified volumes in the mask_string %s \n",NAME_CURRENT_COMP,mask_string);
        exit(1);
    }
    this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
    this_box_volume.p_physics->is_vacuum = 0; // Makes this volume a vacuum
    this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
    this_box_volume.p_physics->my_a = 0; // Should not be used.
    sprintf(this_box_volume.p_physics->name,"Mask");
    this_box_volume.geometry.is_mask_volume = 1;
    
    
// Read the material input, or if it lacks, use automatic linking.
} else if (material_string && strlen(material_string) && strcmp(material_string, "NULL") && strcmp(material_string, "0")) {
    // A geometry string was given, use it to determine which material
    if (0 == strcmp(material_string,"vacuum") || 0 == strcmp(material_string,"Vacuum")) {
        // One could have a global physics struct for vacuum instead of creating one for each
        this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
        this_box_volume.p_physics->is_vacuum = 1; // Makes this volume a vacuum
        this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
        this_box_volume.p_physics->my_a = 0; // Should not be used.
        sprintf(this_box_volume.p_physics->name,"Vacuum");
    } else if (0 == strcmp(material_string,"exit") || 0 == strcmp(material_string,"Exit")) {
        // One could have a global physics struct for vacuum instead of creating one for each
        this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
        this_box_volume.p_physics->is_vacuum = 1; // Makes this volume a vacuum
        this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
        this_box_volume.p_physics->my_a = 0; // Should not be used.
        this_box_volume.geometry.is_exit_volume = 1;
        sprintf(this_box_volume.p_physics->name,"Exit");
    } else {
        #ifndef MATERIAL_DETECTOR
            printf("Need to define a material before refering to it in a geometry %s.\n",NAME_CURRENT_COMP);
            exit(1);
        #endif
        for (loop_index=0;loop_index<global_material_list.num_elements;loop_index++) {
            if (0 == strcmp(material_string,global_material_list.elements[loop_index].name)) {
                this_box_volume.p_physics = global_material_list.elements[loop_index].physics;
                break;
            }
            if (loop_index == global_material_list.num_elements-1) {
            printf("\n");
            printf("ERROR: The material string \"%s\" in Union geometry \"%s\" did not match a specified material. \n",material_string,NAME_CURRENT_COMP);
            printf("       The materials available at this point (need to be defined before the geometry): \n");
            for (loop_index=0;loop_index<global_material_list.num_elements;loop_index++)
              printf("         %s\n",global_material_list.elements[loop_index].name);
            printf("\n");
            printf("       It is also possible to use one of the defualt materials avaiable: \n");
            printf("           Vacuum (for a Volume without scattering or absorption)\n");
            printf("           Exit (for a Volume where the ray exits the component if it enters)\n");
            printf("           Mask (for a Volume that masks existing volumes specified in the mask_string\n");
            exit(1);
          }
        }
    }
} else {
    // Automatic linking, simply using the last defined material.
    #ifndef MATERIAL_DETECTOR
        printf("Need to define a material before the geometry to use automatic linking %s.\n",NAME_CURRENT_COMP);
        exit(1);
    #endif
    this_box_volume.p_physics = global_material_list.elements[global_material_list.num_elements-1].physics;
}

sprintf(this_box_volume.name,NAME_CURRENT_COMP);
sprintf(this_box_volume.geometry.shape,"box");
this_box_volume.geometry.priority_value = priority;
this_box_volume.geometry.geometry_p_interact = p_interact;
// Currently the coordinates will be in absolute space.
this_box_volume.geometry.center = POS_A_CURRENT_COMP;

this_box_storage.z_depth = zdepth;
this_box_storage.x_width1 = xwidth;
this_box_storage.y_height1 = yheight;

this_box_storage.is_rectangle = 0;
if (xwidth2 < 0 && yheight2 < 0) this_box_storage.is_rectangle = 1;
if (xwidth == xwidth2 && yheight == yheight2) this_box_storage.is_rectangle = 1;

if (xwidth2 < 0) {
    this_box_storage.x_width2 = xwidth;
    xwidth2 = xwidth;
} else this_box_storage.x_width2 = xwidth2;

if (yheight2 < 0) {
    this_box_storage.y_height2 = yheight;
    yheight2 = yheight;
} else this_box_storage.y_height2 = yheight2;


this_box_storage.normal_vectors[0] = coords_set(0,0,1);
this_box_storage.normal_vectors[1] = coords_set(0,0,1);

// for sides with y component = 0
x_component = 2*zdepth/sqrt((xwidth-xwidth2)*(xwidth-xwidth2)+4*zdepth*zdepth);
z_component = (xwidth-xwidth2)/sqrt(4*zdepth*zdepth+(xwidth-xwidth2)*(xwidth-xwidth2));

this_box_storage.normal_vectors[2] = coords_set(x_component,0,z_component);
this_box_storage.normal_vectors[3] = coords_set(-x_component,0,z_component);

// for sides with x component = 0
y_component = 2*zdepth/sqrt((yheight-yheight2)*(yheight-yheight2)+4*zdepth*zdepth);
z_component = (yheight-yheight2)/sqrt(4*zdepth*zdepth+(yheight-yheight2)*(yheight-yheight2));

this_box_storage.normal_vectors[4] = coords_set(0,y_component,z_component);
this_box_storage.normal_vectors[5] = coords_set(0,-y_component,z_component);

this_box_volume.geometry.visualization_on = visualize;

this_box_volume.geometry.geometry_parameters.p_box_storage = &this_box_storage;

// Assign pointers to functions for intersection with the shape, checking if a point is inside the shape
if (this_box_storage.is_rectangle == 1) {
this_box_volume.geometry.intersect_function = &sample_box_intersect_simple;
this_box_volume.geometry.within_function = &r_within_box_simple;
}
else {
this_box_volume.geometry.intersect_function = &sample_box_intersect_advanced;
this_box_volume.geometry.within_function = &r_within_box_advanced;
}

this_box_volume.geometry.shell_points = &box_shell_points;
this_box_volume.geometry.mcdisplay_function = &mcdisplay_box_function;
this_box_volume.geometry.initialize_from_main_function = &initialize_box_geometry_from_main_component;
this_box_volume.geometry.process_rot_allocated = 0;

this_box_volume.geometry.copy_geometry_parameters = &allocate_box_storage_copy;

rot_copy(this_box_volume.geometry.rotation_matrix,ROT_A_CURRENT_COMP); //check how ROT_R_CURRENT_COMP would work
rot_transpose(ROT_A_CURRENT_COMP,this_box_volume.geometry.transpose_rotation_matrix);

// Initialize loggers
this_box_volume.loggers.num_elements = 0;

// packing the information into the global_geometry_element, which is then included in the global_geometry_list.
sprintf(global_geometry_element.name,NAME_CURRENT_COMP);
global_geometry_element.activation_counter = number_of_activations;
global_geometry_element.component_index = INDEX_CURRENT_COMP;
global_geometry_element.Volume = &this_box_volume; // Would be nicer if this m was a pointer, now we have the (small) data two places
add_element_to_geometry_list(&global_geometry_list,global_geometry_element);
}
#line 191177 "MACS_sample_kidney_box.c"
#undef number_of_activations
#undef mask_setting
#undef mask_string
#undef p_interact
#undef focus_r
#undef focus_xh
#undef focus_xw
#undef focus_ah
#undef focus_aw
#undef target_z
#undef target_y
#undef target_x
#undef target_index
#undef visualize
#undef yheight2
#undef xwidth2
#undef zdepth
#undef yheight
#undef xwidth
#undef priority
#undef material_string
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

  /* Initializations for component channel_3_cave1_box2. */
  SIG_MESSAGE("channel_3_cave1_box2 (Init)");
#define mccompcurname  channel_3_cave1_box2
#define mccompcurtype  Union_box
#define mccompcurindex 239
#define loop_index mccchannel_3_cave1_box2_loop_index
#define this_box_volume mccchannel_3_cave1_box2_this_box_volume
#define global_geometry_element mccchannel_3_cave1_box2_global_geometry_element
#define this_box_storage mccchannel_3_cave1_box2_this_box_storage
#define material_string mccchannel_3_cave1_box2_material_string
#define priority mccchannel_3_cave1_box2_priority
#define xwidth mccchannel_3_cave1_box2_xwidth
#define yheight mccchannel_3_cave1_box2_yheight
#define zdepth mccchannel_3_cave1_box2_zdepth
#define xwidth2 mccchannel_3_cave1_box2_xwidth2
#define yheight2 mccchannel_3_cave1_box2_yheight2
#define visualize mccchannel_3_cave1_box2_visualize
#define target_index mccchannel_3_cave1_box2_target_index
#define target_x mccchannel_3_cave1_box2_target_x
#define target_y mccchannel_3_cave1_box2_target_y
#define target_z mccchannel_3_cave1_box2_target_z
#define focus_aw mccchannel_3_cave1_box2_focus_aw
#define focus_ah mccchannel_3_cave1_box2_focus_ah
#define focus_xw mccchannel_3_cave1_box2_focus_xw
#define focus_xh mccchannel_3_cave1_box2_focus_xh
#define focus_r mccchannel_3_cave1_box2_focus_r
#define p_interact mccchannel_3_cave1_box2_p_interact
#define mask_string mccchannel_3_cave1_box2_mask_string
#define mask_setting mccchannel_3_cave1_box2_mask_setting
#define number_of_activations mccchannel_3_cave1_box2_number_of_activations
#line 224 "Union_box.comp"
{
// Initializes the focusing system for this volume including input sanitation.
focus_initialize(&this_box_volume.geometry, POS_A_COMP_INDEX(INDEX_CURRENT_COMP+target_index), POS_A_CURRENT_COMP, ROT_A_CURRENT_COMP, target_index, target_x, target_y, target_z, focus_aw, focus_ah, focus_xw, focus_xh, focus_r, NAME_CURRENT_COMP);

// Input sanitation for this geometry
if (xwidth <= 0) {
  printf("\nERROR in Union_box named %s, the xwidth is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (yheight <= 0) {
  printf("\nERROR in Union_box named %s, yheight is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (zdepth <= 0) {
  printf("\nERROR in Union_box named %s, zdepth is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (xwidth2 <= 0 && xwidth2 != -1) {
  printf("\nERROR in Union_box named %s, the xwidth2 is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (yheight2 <= 0 && yheight2 != -1) {
  printf("\nERROR in Union_box named %s, yheight2 is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}

// Use sanitation
if (global_material_list.num_elements == 0) {
  printf("\nERROR: Need to define a material using Union_make_material before using a Union geometry component. \n");
  printf("       %s was defined before first use of Union_make_material.\n",NAME_CURRENT_COMP);
  exit(1);
}

this_box_volume.geometry.is_masked_volume = 0;
this_box_volume.geometry.is_exit_volume = 0;
this_box_volume.geometry.is_mask_volume = 0;
// check if the volume is a mask, if it is the material string is irelevant.
if (mask_string && strlen(mask_string) && strcmp(mask_string, "NULL") && strcmp(mask_string, "0")) {
    // A mask volume is used to limit the extend of other volumes, called the masked volumes. These are specified in the mask_string.
    // In order for a ray to enter a masked volume, it needs to be both in the region covered by that volume AND the mask volume.
    // When more than
    this_box_volume.geometry.mask_mode = 1; // Default is mask mode is ALL
    if (mask_setting && strlen(mask_setting) && strcmp(mask_setting, "NULL") && strcmp(mask_setting, "0")) {
        if (strcmp(mask_setting,"ALL") == 0 || strcmp(mask_setting,"All") == 0) this_box_volume.geometry.mask_mode = 1;
        else if (strcmp(mask_setting,"ANY") == 0 || strcmp(mask_setting,"Any") == 0) this_box_volume.geometry.mask_mode = 2;
        else {
            printf("The mask_mode of component %s is set to %s, but must be either ALL or ANY.\n",NAME_CURRENT_COMP,mask_setting);
            exit(1);
        }
    }
    
    for (loop_index=0;loop_index<global_geometry_list.num_elements;loop_index++) {
        // Add mask list
        if (1 == manual_linking_function(global_geometry_list.elements[loop_index].name,mask_string)) {
            add_element_to_int_list(&this_box_volume.geometry.mask_list,global_geometry_list.elements[loop_index].component_index);
            add_element_to_int_list(&global_geometry_list.elements[loop_index].Volume->geometry.masked_by_list,INDEX_CURRENT_COMP);
            global_geometry_list.elements[loop_index].Volume->geometry.is_masked_volume = 1;
            if (this_box_volume.geometry.mask_mode == 2)
                global_geometry_list.elements[loop_index].Volume->geometry.mask_mode = 2;
            if (this_box_volume.geometry.mask_mode == 1) {
                if (global_geometry_list.elements[loop_index].Volume->geometry.is_masked_volume == 1 && global_geometry_list.elements[loop_index].Volume->geometry.mask_mode != 2)
                    // If more than one mask is added to one volume, the ANY mode overwrites the (default) ALL mode.
                    global_geometry_list.elements[loop_index].Volume->geometry.mask_mode = 1;
            }
            
            found_geometries = 1;
        }
    }
    if (found_geometries == 0) {
        printf("The mask_string in geometry: %s did not find any of the specified volumes in the mask_string %s \n",NAME_CURRENT_COMP,mask_string);
        exit(1);
    }
    this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
    this_box_volume.p_physics->is_vacuum = 0; // Makes this volume a vacuum
    this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
    this_box_volume.p_physics->my_a = 0; // Should not be used.
    sprintf(this_box_volume.p_physics->name,"Mask");
    this_box_volume.geometry.is_mask_volume = 1;
    
    
// Read the material input, or if it lacks, use automatic linking.
} else if (material_string && strlen(material_string) && strcmp(material_string, "NULL") && strcmp(material_string, "0")) {
    // A geometry string was given, use it to determine which material
    if (0 == strcmp(material_string,"vacuum") || 0 == strcmp(material_string,"Vacuum")) {
        // One could have a global physics struct for vacuum instead of creating one for each
        this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
        this_box_volume.p_physics->is_vacuum = 1; // Makes this volume a vacuum
        this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
        this_box_volume.p_physics->my_a = 0; // Should not be used.
        sprintf(this_box_volume.p_physics->name,"Vacuum");
    } else if (0 == strcmp(material_string,"exit") || 0 == strcmp(material_string,"Exit")) {
        // One could have a global physics struct for vacuum instead of creating one for each
        this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
        this_box_volume.p_physics->is_vacuum = 1; // Makes this volume a vacuum
        this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
        this_box_volume.p_physics->my_a = 0; // Should not be used.
        this_box_volume.geometry.is_exit_volume = 1;
        sprintf(this_box_volume.p_physics->name,"Exit");
    } else {
        #ifndef MATERIAL_DETECTOR
            printf("Need to define a material before refering to it in a geometry %s.\n",NAME_CURRENT_COMP);
            exit(1);
        #endif
        for (loop_index=0;loop_index<global_material_list.num_elements;loop_index++) {
            if (0 == strcmp(material_string,global_material_list.elements[loop_index].name)) {
                this_box_volume.p_physics = global_material_list.elements[loop_index].physics;
                break;
            }
            if (loop_index == global_material_list.num_elements-1) {
            printf("\n");
            printf("ERROR: The material string \"%s\" in Union geometry \"%s\" did not match a specified material. \n",material_string,NAME_CURRENT_COMP);
            printf("       The materials available at this point (need to be defined before the geometry): \n");
            for (loop_index=0;loop_index<global_material_list.num_elements;loop_index++)
              printf("         %s\n",global_material_list.elements[loop_index].name);
            printf("\n");
            printf("       It is also possible to use one of the defualt materials avaiable: \n");
            printf("           Vacuum (for a Volume without scattering or absorption)\n");
            printf("           Exit (for a Volume where the ray exits the component if it enters)\n");
            printf("           Mask (for a Volume that masks existing volumes specified in the mask_string\n");
            exit(1);
          }
        }
    }
} else {
    // Automatic linking, simply using the last defined material.
    #ifndef MATERIAL_DETECTOR
        printf("Need to define a material before the geometry to use automatic linking %s.\n",NAME_CURRENT_COMP);
        exit(1);
    #endif
    this_box_volume.p_physics = global_material_list.elements[global_material_list.num_elements-1].physics;
}

sprintf(this_box_volume.name,NAME_CURRENT_COMP);
sprintf(this_box_volume.geometry.shape,"box");
this_box_volume.geometry.priority_value = priority;
this_box_volume.geometry.geometry_p_interact = p_interact;
// Currently the coordinates will be in absolute space.
this_box_volume.geometry.center = POS_A_CURRENT_COMP;

this_box_storage.z_depth = zdepth;
this_box_storage.x_width1 = xwidth;
this_box_storage.y_height1 = yheight;

this_box_storage.is_rectangle = 0;
if (xwidth2 < 0 && yheight2 < 0) this_box_storage.is_rectangle = 1;
if (xwidth == xwidth2 && yheight == yheight2) this_box_storage.is_rectangle = 1;

if (xwidth2 < 0) {
    this_box_storage.x_width2 = xwidth;
    xwidth2 = xwidth;
} else this_box_storage.x_width2 = xwidth2;

if (yheight2 < 0) {
    this_box_storage.y_height2 = yheight;
    yheight2 = yheight;
} else this_box_storage.y_height2 = yheight2;


this_box_storage.normal_vectors[0] = coords_set(0,0,1);
this_box_storage.normal_vectors[1] = coords_set(0,0,1);

// for sides with y component = 0
x_component = 2*zdepth/sqrt((xwidth-xwidth2)*(xwidth-xwidth2)+4*zdepth*zdepth);
z_component = (xwidth-xwidth2)/sqrt(4*zdepth*zdepth+(xwidth-xwidth2)*(xwidth-xwidth2));

this_box_storage.normal_vectors[2] = coords_set(x_component,0,z_component);
this_box_storage.normal_vectors[3] = coords_set(-x_component,0,z_component);

// for sides with x component = 0
y_component = 2*zdepth/sqrt((yheight-yheight2)*(yheight-yheight2)+4*zdepth*zdepth);
z_component = (yheight-yheight2)/sqrt(4*zdepth*zdepth+(yheight-yheight2)*(yheight-yheight2));

this_box_storage.normal_vectors[4] = coords_set(0,y_component,z_component);
this_box_storage.normal_vectors[5] = coords_set(0,-y_component,z_component);

this_box_volume.geometry.visualization_on = visualize;

this_box_volume.geometry.geometry_parameters.p_box_storage = &this_box_storage;

// Assign pointers to functions for intersection with the shape, checking if a point is inside the shape
if (this_box_storage.is_rectangle == 1) {
this_box_volume.geometry.intersect_function = &sample_box_intersect_simple;
this_box_volume.geometry.within_function = &r_within_box_simple;
}
else {
this_box_volume.geometry.intersect_function = &sample_box_intersect_advanced;
this_box_volume.geometry.within_function = &r_within_box_advanced;
}

this_box_volume.geometry.shell_points = &box_shell_points;
this_box_volume.geometry.mcdisplay_function = &mcdisplay_box_function;
this_box_volume.geometry.initialize_from_main_function = &initialize_box_geometry_from_main_component;
this_box_volume.geometry.process_rot_allocated = 0;

this_box_volume.geometry.copy_geometry_parameters = &allocate_box_storage_copy;

rot_copy(this_box_volume.geometry.rotation_matrix,ROT_A_CURRENT_COMP); //check how ROT_R_CURRENT_COMP would work
rot_transpose(ROT_A_CURRENT_COMP,this_box_volume.geometry.transpose_rotation_matrix);

// Initialize loggers
this_box_volume.loggers.num_elements = 0;

// packing the information into the global_geometry_element, which is then included in the global_geometry_list.
sprintf(global_geometry_element.name,NAME_CURRENT_COMP);
global_geometry_element.activation_counter = number_of_activations;
global_geometry_element.component_index = INDEX_CURRENT_COMP;
global_geometry_element.Volume = &this_box_volume; // Would be nicer if this m was a pointer, now we have the (small) data two places
add_element_to_geometry_list(&global_geometry_list,global_geometry_element);
}
#line 191447 "MACS_sample_kidney_box.c"
#undef number_of_activations
#undef mask_setting
#undef mask_string
#undef p_interact
#undef focus_r
#undef focus_xh
#undef focus_xw
#undef focus_ah
#undef focus_aw
#undef target_z
#undef target_y
#undef target_x
#undef target_index
#undef visualize
#undef yheight2
#undef xwidth2
#undef zdepth
#undef yheight
#undef xwidth
#undef priority
#undef material_string
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

  /* Initializations for component channel_3_cave1_box3. */
  SIG_MESSAGE("channel_3_cave1_box3 (Init)");
#define mccompcurname  channel_3_cave1_box3
#define mccompcurtype  Union_box
#define mccompcurindex 240
#define loop_index mccchannel_3_cave1_box3_loop_index
#define this_box_volume mccchannel_3_cave1_box3_this_box_volume
#define global_geometry_element mccchannel_3_cave1_box3_global_geometry_element
#define this_box_storage mccchannel_3_cave1_box3_this_box_storage
#define material_string mccchannel_3_cave1_box3_material_string
#define priority mccchannel_3_cave1_box3_priority
#define xwidth mccchannel_3_cave1_box3_xwidth
#define yheight mccchannel_3_cave1_box3_yheight
#define zdepth mccchannel_3_cave1_box3_zdepth
#define xwidth2 mccchannel_3_cave1_box3_xwidth2
#define yheight2 mccchannel_3_cave1_box3_yheight2
#define visualize mccchannel_3_cave1_box3_visualize
#define target_index mccchannel_3_cave1_box3_target_index
#define target_x mccchannel_3_cave1_box3_target_x
#define target_y mccchannel_3_cave1_box3_target_y
#define target_z mccchannel_3_cave1_box3_target_z
#define focus_aw mccchannel_3_cave1_box3_focus_aw
#define focus_ah mccchannel_3_cave1_box3_focus_ah
#define focus_xw mccchannel_3_cave1_box3_focus_xw
#define focus_xh mccchannel_3_cave1_box3_focus_xh
#define focus_r mccchannel_3_cave1_box3_focus_r
#define p_interact mccchannel_3_cave1_box3_p_interact
#define mask_string mccchannel_3_cave1_box3_mask_string
#define mask_setting mccchannel_3_cave1_box3_mask_setting
#define number_of_activations mccchannel_3_cave1_box3_number_of_activations
#line 224 "Union_box.comp"
{
// Initializes the focusing system for this volume including input sanitation.
focus_initialize(&this_box_volume.geometry, POS_A_COMP_INDEX(INDEX_CURRENT_COMP+target_index), POS_A_CURRENT_COMP, ROT_A_CURRENT_COMP, target_index, target_x, target_y, target_z, focus_aw, focus_ah, focus_xw, focus_xh, focus_r, NAME_CURRENT_COMP);

// Input sanitation for this geometry
if (xwidth <= 0) {
  printf("\nERROR in Union_box named %s, the xwidth is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (yheight <= 0) {
  printf("\nERROR in Union_box named %s, yheight is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (zdepth <= 0) {
  printf("\nERROR in Union_box named %s, zdepth is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (xwidth2 <= 0 && xwidth2 != -1) {
  printf("\nERROR in Union_box named %s, the xwidth2 is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (yheight2 <= 0 && yheight2 != -1) {
  printf("\nERROR in Union_box named %s, yheight2 is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}

// Use sanitation
if (global_material_list.num_elements == 0) {
  printf("\nERROR: Need to define a material using Union_make_material before using a Union geometry component. \n");
  printf("       %s was defined before first use of Union_make_material.\n",NAME_CURRENT_COMP);
  exit(1);
}

this_box_volume.geometry.is_masked_volume = 0;
this_box_volume.geometry.is_exit_volume = 0;
this_box_volume.geometry.is_mask_volume = 0;
// check if the volume is a mask, if it is the material string is irelevant.
if (mask_string && strlen(mask_string) && strcmp(mask_string, "NULL") && strcmp(mask_string, "0")) {
    // A mask volume is used to limit the extend of other volumes, called the masked volumes. These are specified in the mask_string.
    // In order for a ray to enter a masked volume, it needs to be both in the region covered by that volume AND the mask volume.
    // When more than
    this_box_volume.geometry.mask_mode = 1; // Default is mask mode is ALL
    if (mask_setting && strlen(mask_setting) && strcmp(mask_setting, "NULL") && strcmp(mask_setting, "0")) {
        if (strcmp(mask_setting,"ALL") == 0 || strcmp(mask_setting,"All") == 0) this_box_volume.geometry.mask_mode = 1;
        else if (strcmp(mask_setting,"ANY") == 0 || strcmp(mask_setting,"Any") == 0) this_box_volume.geometry.mask_mode = 2;
        else {
            printf("The mask_mode of component %s is set to %s, but must be either ALL or ANY.\n",NAME_CURRENT_COMP,mask_setting);
            exit(1);
        }
    }
    
    for (loop_index=0;loop_index<global_geometry_list.num_elements;loop_index++) {
        // Add mask list
        if (1 == manual_linking_function(global_geometry_list.elements[loop_index].name,mask_string)) {
            add_element_to_int_list(&this_box_volume.geometry.mask_list,global_geometry_list.elements[loop_index].component_index);
            add_element_to_int_list(&global_geometry_list.elements[loop_index].Volume->geometry.masked_by_list,INDEX_CURRENT_COMP);
            global_geometry_list.elements[loop_index].Volume->geometry.is_masked_volume = 1;
            if (this_box_volume.geometry.mask_mode == 2)
                global_geometry_list.elements[loop_index].Volume->geometry.mask_mode = 2;
            if (this_box_volume.geometry.mask_mode == 1) {
                if (global_geometry_list.elements[loop_index].Volume->geometry.is_masked_volume == 1 && global_geometry_list.elements[loop_index].Volume->geometry.mask_mode != 2)
                    // If more than one mask is added to one volume, the ANY mode overwrites the (default) ALL mode.
                    global_geometry_list.elements[loop_index].Volume->geometry.mask_mode = 1;
            }
            
            found_geometries = 1;
        }
    }
    if (found_geometries == 0) {
        printf("The mask_string in geometry: %s did not find any of the specified volumes in the mask_string %s \n",NAME_CURRENT_COMP,mask_string);
        exit(1);
    }
    this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
    this_box_volume.p_physics->is_vacuum = 0; // Makes this volume a vacuum
    this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
    this_box_volume.p_physics->my_a = 0; // Should not be used.
    sprintf(this_box_volume.p_physics->name,"Mask");
    this_box_volume.geometry.is_mask_volume = 1;
    
    
// Read the material input, or if it lacks, use automatic linking.
} else if (material_string && strlen(material_string) && strcmp(material_string, "NULL") && strcmp(material_string, "0")) {
    // A geometry string was given, use it to determine which material
    if (0 == strcmp(material_string,"vacuum") || 0 == strcmp(material_string,"Vacuum")) {
        // One could have a global physics struct for vacuum instead of creating one for each
        this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
        this_box_volume.p_physics->is_vacuum = 1; // Makes this volume a vacuum
        this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
        this_box_volume.p_physics->my_a = 0; // Should not be used.
        sprintf(this_box_volume.p_physics->name,"Vacuum");
    } else if (0 == strcmp(material_string,"exit") || 0 == strcmp(material_string,"Exit")) {
        // One could have a global physics struct for vacuum instead of creating one for each
        this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
        this_box_volume.p_physics->is_vacuum = 1; // Makes this volume a vacuum
        this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
        this_box_volume.p_physics->my_a = 0; // Should not be used.
        this_box_volume.geometry.is_exit_volume = 1;
        sprintf(this_box_volume.p_physics->name,"Exit");
    } else {
        #ifndef MATERIAL_DETECTOR
            printf("Need to define a material before refering to it in a geometry %s.\n",NAME_CURRENT_COMP);
            exit(1);
        #endif
        for (loop_index=0;loop_index<global_material_list.num_elements;loop_index++) {
            if (0 == strcmp(material_string,global_material_list.elements[loop_index].name)) {
                this_box_volume.p_physics = global_material_list.elements[loop_index].physics;
                break;
            }
            if (loop_index == global_material_list.num_elements-1) {
            printf("\n");
            printf("ERROR: The material string \"%s\" in Union geometry \"%s\" did not match a specified material. \n",material_string,NAME_CURRENT_COMP);
            printf("       The materials available at this point (need to be defined before the geometry): \n");
            for (loop_index=0;loop_index<global_material_list.num_elements;loop_index++)
              printf("         %s\n",global_material_list.elements[loop_index].name);
            printf("\n");
            printf("       It is also possible to use one of the defualt materials avaiable: \n");
            printf("           Vacuum (for a Volume without scattering or absorption)\n");
            printf("           Exit (for a Volume where the ray exits the component if it enters)\n");
            printf("           Mask (for a Volume that masks existing volumes specified in the mask_string\n");
            exit(1);
          }
        }
    }
} else {
    // Automatic linking, simply using the last defined material.
    #ifndef MATERIAL_DETECTOR
        printf("Need to define a material before the geometry to use automatic linking %s.\n",NAME_CURRENT_COMP);
        exit(1);
    #endif
    this_box_volume.p_physics = global_material_list.elements[global_material_list.num_elements-1].physics;
}

sprintf(this_box_volume.name,NAME_CURRENT_COMP);
sprintf(this_box_volume.geometry.shape,"box");
this_box_volume.geometry.priority_value = priority;
this_box_volume.geometry.geometry_p_interact = p_interact;
// Currently the coordinates will be in absolute space.
this_box_volume.geometry.center = POS_A_CURRENT_COMP;

this_box_storage.z_depth = zdepth;
this_box_storage.x_width1 = xwidth;
this_box_storage.y_height1 = yheight;

this_box_storage.is_rectangle = 0;
if (xwidth2 < 0 && yheight2 < 0) this_box_storage.is_rectangle = 1;
if (xwidth == xwidth2 && yheight == yheight2) this_box_storage.is_rectangle = 1;

if (xwidth2 < 0) {
    this_box_storage.x_width2 = xwidth;
    xwidth2 = xwidth;
} else this_box_storage.x_width2 = xwidth2;

if (yheight2 < 0) {
    this_box_storage.y_height2 = yheight;
    yheight2 = yheight;
} else this_box_storage.y_height2 = yheight2;


this_box_storage.normal_vectors[0] = coords_set(0,0,1);
this_box_storage.normal_vectors[1] = coords_set(0,0,1);

// for sides with y component = 0
x_component = 2*zdepth/sqrt((xwidth-xwidth2)*(xwidth-xwidth2)+4*zdepth*zdepth);
z_component = (xwidth-xwidth2)/sqrt(4*zdepth*zdepth+(xwidth-xwidth2)*(xwidth-xwidth2));

this_box_storage.normal_vectors[2] = coords_set(x_component,0,z_component);
this_box_storage.normal_vectors[3] = coords_set(-x_component,0,z_component);

// for sides with x component = 0
y_component = 2*zdepth/sqrt((yheight-yheight2)*(yheight-yheight2)+4*zdepth*zdepth);
z_component = (yheight-yheight2)/sqrt(4*zdepth*zdepth+(yheight-yheight2)*(yheight-yheight2));

this_box_storage.normal_vectors[4] = coords_set(0,y_component,z_component);
this_box_storage.normal_vectors[5] = coords_set(0,-y_component,z_component);

this_box_volume.geometry.visualization_on = visualize;

this_box_volume.geometry.geometry_parameters.p_box_storage = &this_box_storage;

// Assign pointers to functions for intersection with the shape, checking if a point is inside the shape
if (this_box_storage.is_rectangle == 1) {
this_box_volume.geometry.intersect_function = &sample_box_intersect_simple;
this_box_volume.geometry.within_function = &r_within_box_simple;
}
else {
this_box_volume.geometry.intersect_function = &sample_box_intersect_advanced;
this_box_volume.geometry.within_function = &r_within_box_advanced;
}

this_box_volume.geometry.shell_points = &box_shell_points;
this_box_volume.geometry.mcdisplay_function = &mcdisplay_box_function;
this_box_volume.geometry.initialize_from_main_function = &initialize_box_geometry_from_main_component;
this_box_volume.geometry.process_rot_allocated = 0;

this_box_volume.geometry.copy_geometry_parameters = &allocate_box_storage_copy;

rot_copy(this_box_volume.geometry.rotation_matrix,ROT_A_CURRENT_COMP); //check how ROT_R_CURRENT_COMP would work
rot_transpose(ROT_A_CURRENT_COMP,this_box_volume.geometry.transpose_rotation_matrix);

// Initialize loggers
this_box_volume.loggers.num_elements = 0;

// packing the information into the global_geometry_element, which is then included in the global_geometry_list.
sprintf(global_geometry_element.name,NAME_CURRENT_COMP);
global_geometry_element.activation_counter = number_of_activations;
global_geometry_element.component_index = INDEX_CURRENT_COMP;
global_geometry_element.Volume = &this_box_volume; // Would be nicer if this m was a pointer, now we have the (small) data two places
add_element_to_geometry_list(&global_geometry_list,global_geometry_element);
}
#line 191717 "MACS_sample_kidney_box.c"
#undef number_of_activations
#undef mask_setting
#undef mask_string
#undef p_interact
#undef focus_r
#undef focus_xh
#undef focus_xw
#undef focus_ah
#undef focus_aw
#undef target_z
#undef target_y
#undef target_x
#undef target_index
#undef visualize
#undef yheight2
#undef xwidth2
#undef zdepth
#undef yheight
#undef xwidth
#undef priority
#undef material_string
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

  /* Initializations for component channel_3_cave1_cyl1. */
  SIG_MESSAGE("channel_3_cave1_cyl1 (Init)");
#define mccompcurname  channel_3_cave1_cyl1
#define mccompcurtype  Union_cylinder
#define mccompcurindex 241
#define loop_index mccchannel_3_cave1_cyl1_loop_index
#define this_cylinder_volume mccchannel_3_cave1_cyl1_this_cylinder_volume
#define global_geometry_element mccchannel_3_cave1_cyl1_global_geometry_element
#define this_cylinder_storage mccchannel_3_cave1_cyl1_this_cylinder_storage
#define material_string mccchannel_3_cave1_cyl1_material_string
#define priority mccchannel_3_cave1_cyl1_priority
#define radius mccchannel_3_cave1_cyl1_radius
#define yheight mccchannel_3_cave1_cyl1_yheight
#define visualize mccchannel_3_cave1_cyl1_visualize
#define target_index mccchannel_3_cave1_cyl1_target_index
#define target_x mccchannel_3_cave1_cyl1_target_x
#define target_y mccchannel_3_cave1_cyl1_target_y
#define target_z mccchannel_3_cave1_cyl1_target_z
#define focus_aw mccchannel_3_cave1_cyl1_focus_aw
#define focus_ah mccchannel_3_cave1_cyl1_focus_ah
#define focus_xw mccchannel_3_cave1_cyl1_focus_xw
#define focus_xh mccchannel_3_cave1_cyl1_focus_xh
#define focus_r mccchannel_3_cave1_cyl1_focus_r
#define p_interact mccchannel_3_cave1_cyl1_p_interact
#define mask_string mccchannel_3_cave1_cyl1_mask_string
#define mask_setting mccchannel_3_cave1_cyl1_mask_setting
#define number_of_activations mccchannel_3_cave1_cyl1_number_of_activations
#line 185 "Union_cylinder.comp"
{
// Initializes the focusing system for this volume including input sanitation.
focus_initialize(&this_cylinder_volume.geometry, POS_A_COMP_INDEX(INDEX_CURRENT_COMP+target_index), POS_A_CURRENT_COMP, ROT_A_CURRENT_COMP, target_index, target_x, target_y, target_z, focus_aw, focus_ah, focus_xw, focus_xh, focus_r, NAME_CURRENT_COMP);

// Input sanitation for this geometry
if (radius <= 0) {
  printf("\nERROR in Union_cylinder named %s, the radius is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}

if (yheight <= 0) {
  printf("\nERROR in Union_cylinder named %s, yheight is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}

// Use sanitation
#ifdef MATERIAL_DETECTOR
if (global_material_list.num_elements == 0) {
  // Here if the user have defined a material, but only after this material
  printf("\nERROR: Need to define a material using Union_make_material before using a Union geometry component. \n");
  printf("       %s was defined before first use of Union_make_material.\n",NAME_CURRENT_COMP);
  exit(1);
}
#endif
#ifndef MATERIAL_DETECTOR
  printf("\nERROR: Need to define a material using Union_make_material before using a Union geometry component. \n");
  exit(1);
#endif


this_cylinder_volume.geometry.is_masked_volume = 0;
this_cylinder_volume.geometry.is_exit_volume = 0;
this_cylinder_volume.geometry.is_mask_volume = 0;

// Read the material input, or if it lacks, use automatic linking.
if (mask_string && strlen(mask_string) && strcmp(mask_string, "NULL") && strcmp(mask_string, "0")) {
    // A mask volume is used to limit the extend of other volumes, called the masked volumes. These are specified in the mask_string.
    // In order for a ray to enter a masked volume, it needs to be both in the region covered by that volume AND the mask volume.
    // When more than
    this_cylinder_volume.geometry.mask_mode = 1; // Default is mask mode is ALL
    if (mask_setting && strlen(mask_setting) && strcmp(mask_setting, "NULL") && strcmp(mask_setting, "0")) {
        if (strcmp(mask_setting,"ALL") == 0 || strcmp(mask_setting,"All") == 0) this_cylinder_volume.geometry.mask_mode = 1;
        else if (strcmp(mask_setting,"ANY") == 0 || strcmp(mask_setting,"Any") == 0) this_cylinder_volume.geometry.mask_mode = 2;
        else {
            printf("The mask_mode of component %s is set to %s, but must be either ALL or ANY.\n",NAME_CURRENT_COMP,mask_setting);
            exit(1);
        }
    }
    
    for (loop_index=0;loop_index<global_geometry_list.num_elements;loop_index++) {
        // Add mask list
        if (1 == manual_linking_function(global_geometry_list.elements[loop_index].name,mask_string)) {
            add_element_to_int_list(&this_cylinder_volume.geometry.mask_list,global_geometry_list.elements[loop_index].component_index);
            add_element_to_int_list(&global_geometry_list.elements[loop_index].Volume->geometry.masked_by_list,INDEX_CURRENT_COMP);
            global_geometry_list.elements[loop_index].Volume->geometry.is_masked_volume = 1;
            if (this_cylinder_volume.geometry.mask_mode == 2)
                global_geometry_list.elements[loop_index].Volume->geometry.mask_mode = 2;
            if (this_cylinder_volume.geometry.mask_mode == 1) {
                if (global_geometry_list.elements[loop_index].Volume->geometry.is_masked_volume == 1 && global_geometry_list.elements[loop_index].Volume->geometry.mask_mode != 2)
                    // If more than one mask is added to one volume, the ANY mode overwrites the (default) ALL mode.
                    global_geometry_list.elements[loop_index].Volume->geometry.mask_mode = 1;
            }
            
            found_geometries = 1;
        }
    }
    if (found_geometries == 0) {
        printf("The mask_string in geometry: %s did not find any of the specified volumes in the mask_string %s \n",NAME_CURRENT_COMP,mask_string);
        exit(1);
    }
    this_cylinder_volume.p_physics = malloc(sizeof(struct physics_struct));
    this_cylinder_volume.p_physics->is_vacuum = 0; // Makes this volume a vacuum
    this_cylinder_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
    this_cylinder_volume.p_physics->my_a = 0; // Should not be used.
    sprintf(this_cylinder_volume.p_physics->name,"Mask");
    this_cylinder_volume.geometry.is_mask_volume = 1;
    
    
// Read the material input, or if it lacks, use automatic linking.
} else if (material_string && strlen(material_string) && strcmp(material_string, "NULL") && strcmp(material_string, "0")) {
    // A geometry string was given, use it to determine which material
    if (0 == strcmp(material_string,"vacuum") || 0 == strcmp(material_string,"Vacuum")) {
        // One could have a global physics struct for vacuum instead of creating one for each
        this_cylinder_volume.p_physics = malloc(sizeof(struct physics_struct));
        this_cylinder_volume.p_physics->is_vacuum = 1; // Makes this volume a vacuum
        this_cylinder_volume.p_physics->number_of_processes = (int) 0;
        this_cylinder_volume.p_physics->my_a = 0; // Should not be used.
        sprintf(this_cylinder_volume.p_physics->name,"Vacuum");
    } else if (0 == strcmp(material_string,"exit") || 0 == strcmp(material_string,"Exit")) {
        // One could have a global physics struct for exit instead of creating one for each
        this_cylinder_volume.p_physics = malloc(sizeof(struct physics_struct));
        this_cylinder_volume.p_physics->is_vacuum = 1; // Makes this volume a vacuum
        this_cylinder_volume.p_physics->number_of_processes = (int) 0;
        this_cylinder_volume.p_physics->my_a = 0; // Should not be used.
        this_cylinder_volume.geometry.is_exit_volume = 1;
        sprintf(this_cylinder_volume.p_physics->name,"Exit");
    } else {
        for (loop_index=0;loop_index<global_material_list.num_elements;loop_index++) {
          if (0 == strcmp(material_string,global_material_list.elements[loop_index].name)) {
            this_cylinder_volume.p_physics = global_material_list.elements[loop_index].physics;
            break;
          }
          if (loop_index == global_material_list.num_elements-1) {
            printf("\n");
            printf("ERROR: The material string \"%s\" in Union geometry \"%s\" did not match a specified material. \n",material_string,NAME_CURRENT_COMP);
            printf("       The materials available at this point (need to be defined before the geometry): \n");
            for (loop_index=0;loop_index<global_material_list.num_elements;loop_index++)
              printf("         %s\n",global_material_list.elements[loop_index].name);
            printf("\n");
            printf("       It is also possible to use one of the defualt materials avaiable: \n");
            printf("           Vacuum (for a Volume without scattering or absorption)\n");
            printf("           Exit (for a Volume where the ray exits the component if it enters)\n");
            printf("           Mask (for a Volume that masks existing volumes specified in the mask_string\n");
            exit(1);
          }
        }
    }
} else {
    // Automatic linking, simply using the last defined material.
    #ifndef MATERIAL_DETECTOR
        printf("Need to define a material before the geometry to use automatic linking %s.\n",NAME_CURRENT_COMP);
        exit(1);
    #endif
    this_cylinder_volume.p_physics = global_material_list.elements[global_material_list.num_elements-1].physics;
}

sprintf(this_cylinder_volume.name,NAME_CURRENT_COMP);
sprintf(this_cylinder_volume.geometry.shape,"cylinder");
this_cylinder_volume.geometry.priority_value = priority;
// Currently the coordinates will be in absolute space.
this_cylinder_volume.geometry.center = POS_A_CURRENT_COMP;

this_cylinder_volume.geometry.geometry_p_interact = p_interact;
this_cylinder_storage.cyl_radius = radius;
this_cylinder_storage.height = yheight;
this_cylinder_volume.geometry.visualization_on = visualize;
this_cylinder_volume.geometry.geometry_parameters.p_cylinder_storage = &this_cylinder_storage;
this_cylinder_volume.geometry.within_function = &r_within_cylinder;
this_cylinder_volume.geometry.intersect_function = &sample_cylinder_intersect;
this_cylinder_volume.geometry.mcdisplay_function = &mcdisplay_cylinder_function;
this_cylinder_volume.geometry.shell_points = &cylinder_shell_points;
this_cylinder_volume.geometry.initialize_from_main_function = &initialize_cylinder_geometry_from_main_component;
this_cylinder_volume.geometry.process_rot_allocated = 0;
this_cylinder_volume.geometry.copy_geometry_parameters = &allocate_cylinder_storage_copy;

rot_copy(this_cylinder_volume.geometry.rotation_matrix,ROT_A_CURRENT_COMP);
rot_transpose(ROT_A_CURRENT_COMP,this_cylinder_volume.geometry.transpose_rotation_matrix);

// Initialize loggers
this_cylinder_volume.loggers.num_elements = 0;

// packing the information into the global_geometry_element, which is then included in the global_geometry_list.
sprintf(global_geometry_element.name,NAME_CURRENT_COMP);
global_geometry_element.activation_counter = number_of_activations;
global_geometry_element.component_index = INDEX_CURRENT_COMP;
global_geometry_element.Volume = &this_cylinder_volume; // Would be nicer if this m was a pointer, now we have the (small) data two places
add_element_to_geometry_list(&global_geometry_list,global_geometry_element);
}
#line 191933 "MACS_sample_kidney_box.c"
#undef number_of_activations
#undef mask_setting
#undef mask_string
#undef p_interact
#undef focus_r
#undef focus_xh
#undef focus_xw
#undef focus_ah
#undef focus_aw
#undef target_z
#undef target_y
#undef target_x
#undef target_index
#undef visualize
#undef yheight
#undef radius
#undef priority
#undef material_string
#undef this_cylinder_storage
#undef global_geometry_element
#undef this_cylinder_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

  /* Initializations for component channel_3_analyzer_1_center. */
  SIG_MESSAGE("channel_3_analyzer_1_center (Init)");

  /* Initializations for component channel_3_analyzer_1_rotated. */
  SIG_MESSAGE("channel_3_analyzer_1_rotated (Init)");

  /* Initializations for component channel_3_analyzer_1_array_crystal_array_0. */
  SIG_MESSAGE("channel_3_analyzer_1_array_crystal_array_0 (Init)");
#define mccompcurname  channel_3_analyzer_1_array_crystal_array_0
#define mccompcurtype  Union_box
#define mccompcurindex 244
#define loop_index mccchannel_3_analyzer_1_array_crystal_array_0_loop_index
#define this_box_volume mccchannel_3_analyzer_1_array_crystal_array_0_this_box_volume
#define global_geometry_element mccchannel_3_analyzer_1_array_crystal_array_0_global_geometry_element
#define this_box_storage mccchannel_3_analyzer_1_array_crystal_array_0_this_box_storage
#define material_string mccchannel_3_analyzer_1_array_crystal_array_0_material_string
#define priority mccchannel_3_analyzer_1_array_crystal_array_0_priority
#define xwidth mccchannel_3_analyzer_1_array_crystal_array_0_xwidth
#define yheight mccchannel_3_analyzer_1_array_crystal_array_0_yheight
#define zdepth mccchannel_3_analyzer_1_array_crystal_array_0_zdepth
#define xwidth2 mccchannel_3_analyzer_1_array_crystal_array_0_xwidth2
#define yheight2 mccchannel_3_analyzer_1_array_crystal_array_0_yheight2
#define visualize mccchannel_3_analyzer_1_array_crystal_array_0_visualize
#define target_index mccchannel_3_analyzer_1_array_crystal_array_0_target_index
#define target_x mccchannel_3_analyzer_1_array_crystal_array_0_target_x
#define target_y mccchannel_3_analyzer_1_array_crystal_array_0_target_y
#define target_z mccchannel_3_analyzer_1_array_crystal_array_0_target_z
#define focus_aw mccchannel_3_analyzer_1_array_crystal_array_0_focus_aw
#define focus_ah mccchannel_3_analyzer_1_array_crystal_array_0_focus_ah
#define focus_xw mccchannel_3_analyzer_1_array_crystal_array_0_focus_xw
#define focus_xh mccchannel_3_analyzer_1_array_crystal_array_0_focus_xh
#define focus_r mccchannel_3_analyzer_1_array_crystal_array_0_focus_r
#define p_interact mccchannel_3_analyzer_1_array_crystal_array_0_p_interact
#define mask_string mccchannel_3_analyzer_1_array_crystal_array_0_mask_string
#define mask_setting mccchannel_3_analyzer_1_array_crystal_array_0_mask_setting
#define number_of_activations mccchannel_3_analyzer_1_array_crystal_array_0_number_of_activations
#line 224 "Union_box.comp"
{
// Initializes the focusing system for this volume including input sanitation.
focus_initialize(&this_box_volume.geometry, POS_A_COMP_INDEX(INDEX_CURRENT_COMP+target_index), POS_A_CURRENT_COMP, ROT_A_CURRENT_COMP, target_index, target_x, target_y, target_z, focus_aw, focus_ah, focus_xw, focus_xh, focus_r, NAME_CURRENT_COMP);

// Input sanitation for this geometry
if (xwidth <= 0) {
  printf("\nERROR in Union_box named %s, the xwidth is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (yheight <= 0) {
  printf("\nERROR in Union_box named %s, yheight is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (zdepth <= 0) {
  printf("\nERROR in Union_box named %s, zdepth is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (xwidth2 <= 0 && xwidth2 != -1) {
  printf("\nERROR in Union_box named %s, the xwidth2 is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (yheight2 <= 0 && yheight2 != -1) {
  printf("\nERROR in Union_box named %s, yheight2 is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}

// Use sanitation
if (global_material_list.num_elements == 0) {
  printf("\nERROR: Need to define a material using Union_make_material before using a Union geometry component. \n");
  printf("       %s was defined before first use of Union_make_material.\n",NAME_CURRENT_COMP);
  exit(1);
}

this_box_volume.geometry.is_masked_volume = 0;
this_box_volume.geometry.is_exit_volume = 0;
this_box_volume.geometry.is_mask_volume = 0;
// check if the volume is a mask, if it is the material string is irelevant.
if (mask_string && strlen(mask_string) && strcmp(mask_string, "NULL") && strcmp(mask_string, "0")) {
    // A mask volume is used to limit the extend of other volumes, called the masked volumes. These are specified in the mask_string.
    // In order for a ray to enter a masked volume, it needs to be both in the region covered by that volume AND the mask volume.
    // When more than
    this_box_volume.geometry.mask_mode = 1; // Default is mask mode is ALL
    if (mask_setting && strlen(mask_setting) && strcmp(mask_setting, "NULL") && strcmp(mask_setting, "0")) {
        if (strcmp(mask_setting,"ALL") == 0 || strcmp(mask_setting,"All") == 0) this_box_volume.geometry.mask_mode = 1;
        else if (strcmp(mask_setting,"ANY") == 0 || strcmp(mask_setting,"Any") == 0) this_box_volume.geometry.mask_mode = 2;
        else {
            printf("The mask_mode of component %s is set to %s, but must be either ALL or ANY.\n",NAME_CURRENT_COMP,mask_setting);
            exit(1);
        }
    }
    
    for (loop_index=0;loop_index<global_geometry_list.num_elements;loop_index++) {
        // Add mask list
        if (1 == manual_linking_function(global_geometry_list.elements[loop_index].name,mask_string)) {
            add_element_to_int_list(&this_box_volume.geometry.mask_list,global_geometry_list.elements[loop_index].component_index);
            add_element_to_int_list(&global_geometry_list.elements[loop_index].Volume->geometry.masked_by_list,INDEX_CURRENT_COMP);
            global_geometry_list.elements[loop_index].Volume->geometry.is_masked_volume = 1;
            if (this_box_volume.geometry.mask_mode == 2)
                global_geometry_list.elements[loop_index].Volume->geometry.mask_mode = 2;
            if (this_box_volume.geometry.mask_mode == 1) {
                if (global_geometry_list.elements[loop_index].Volume->geometry.is_masked_volume == 1 && global_geometry_list.elements[loop_index].Volume->geometry.mask_mode != 2)
                    // If more than one mask is added to one volume, the ANY mode overwrites the (default) ALL mode.
                    global_geometry_list.elements[loop_index].Volume->geometry.mask_mode = 1;
            }
            
            found_geometries = 1;
        }
    }
    if (found_geometries == 0) {
        printf("The mask_string in geometry: %s did not find any of the specified volumes in the mask_string %s \n",NAME_CURRENT_COMP,mask_string);
        exit(1);
    }
    this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
    this_box_volume.p_physics->is_vacuum = 0; // Makes this volume a vacuum
    this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
    this_box_volume.p_physics->my_a = 0; // Should not be used.
    sprintf(this_box_volume.p_physics->name,"Mask");
    this_box_volume.geometry.is_mask_volume = 1;
    
    
// Read the material input, or if it lacks, use automatic linking.
} else if (material_string && strlen(material_string) && strcmp(material_string, "NULL") && strcmp(material_string, "0")) {
    // A geometry string was given, use it to determine which material
    if (0 == strcmp(material_string,"vacuum") || 0 == strcmp(material_string,"Vacuum")) {
        // One could have a global physics struct for vacuum instead of creating one for each
        this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
        this_box_volume.p_physics->is_vacuum = 1; // Makes this volume a vacuum
        this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
        this_box_volume.p_physics->my_a = 0; // Should not be used.
        sprintf(this_box_volume.p_physics->name,"Vacuum");
    } else if (0 == strcmp(material_string,"exit") || 0 == strcmp(material_string,"Exit")) {
        // One could have a global physics struct for vacuum instead of creating one for each
        this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
        this_box_volume.p_physics->is_vacuum = 1; // Makes this volume a vacuum
        this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
        this_box_volume.p_physics->my_a = 0; // Should not be used.
        this_box_volume.geometry.is_exit_volume = 1;
        sprintf(this_box_volume.p_physics->name,"Exit");
    } else {
        #ifndef MATERIAL_DETECTOR
            printf("Need to define a material before refering to it in a geometry %s.\n",NAME_CURRENT_COMP);
            exit(1);
        #endif
        for (loop_index=0;loop_index<global_material_list.num_elements;loop_index++) {
            if (0 == strcmp(material_string,global_material_list.elements[loop_index].name)) {
                this_box_volume.p_physics = global_material_list.elements[loop_index].physics;
                break;
            }
            if (loop_index == global_material_list.num_elements-1) {
            printf("\n");
            printf("ERROR: The material string \"%s\" in Union geometry \"%s\" did not match a specified material. \n",material_string,NAME_CURRENT_COMP);
            printf("       The materials available at this point (need to be defined before the geometry): \n");
            for (loop_index=0;loop_index<global_material_list.num_elements;loop_index++)
              printf("         %s\n",global_material_list.elements[loop_index].name);
            printf("\n");
            printf("       It is also possible to use one of the defualt materials avaiable: \n");
            printf("           Vacuum (for a Volume without scattering or absorption)\n");
            printf("           Exit (for a Volume where the ray exits the component if it enters)\n");
            printf("           Mask (for a Volume that masks existing volumes specified in the mask_string\n");
            exit(1);
          }
        }
    }
} else {
    // Automatic linking, simply using the last defined material.
    #ifndef MATERIAL_DETECTOR
        printf("Need to define a material before the geometry to use automatic linking %s.\n",NAME_CURRENT_COMP);
        exit(1);
    #endif
    this_box_volume.p_physics = global_material_list.elements[global_material_list.num_elements-1].physics;
}

sprintf(this_box_volume.name,NAME_CURRENT_COMP);
sprintf(this_box_volume.geometry.shape,"box");
this_box_volume.geometry.priority_value = priority;
this_box_volume.geometry.geometry_p_interact = p_interact;
// Currently the coordinates will be in absolute space.
this_box_volume.geometry.center = POS_A_CURRENT_COMP;

this_box_storage.z_depth = zdepth;
this_box_storage.x_width1 = xwidth;
this_box_storage.y_height1 = yheight;

this_box_storage.is_rectangle = 0;
if (xwidth2 < 0 && yheight2 < 0) this_box_storage.is_rectangle = 1;
if (xwidth == xwidth2 && yheight == yheight2) this_box_storage.is_rectangle = 1;

if (xwidth2 < 0) {
    this_box_storage.x_width2 = xwidth;
    xwidth2 = xwidth;
} else this_box_storage.x_width2 = xwidth2;

if (yheight2 < 0) {
    this_box_storage.y_height2 = yheight;
    yheight2 = yheight;
} else this_box_storage.y_height2 = yheight2;


this_box_storage.normal_vectors[0] = coords_set(0,0,1);
this_box_storage.normal_vectors[1] = coords_set(0,0,1);

// for sides with y component = 0
x_component = 2*zdepth/sqrt((xwidth-xwidth2)*(xwidth-xwidth2)+4*zdepth*zdepth);
z_component = (xwidth-xwidth2)/sqrt(4*zdepth*zdepth+(xwidth-xwidth2)*(xwidth-xwidth2));

this_box_storage.normal_vectors[2] = coords_set(x_component,0,z_component);
this_box_storage.normal_vectors[3] = coords_set(-x_component,0,z_component);

// for sides with x component = 0
y_component = 2*zdepth/sqrt((yheight-yheight2)*(yheight-yheight2)+4*zdepth*zdepth);
z_component = (yheight-yheight2)/sqrt(4*zdepth*zdepth+(yheight-yheight2)*(yheight-yheight2));

this_box_storage.normal_vectors[4] = coords_set(0,y_component,z_component);
this_box_storage.normal_vectors[5] = coords_set(0,-y_component,z_component);

this_box_volume.geometry.visualization_on = visualize;

this_box_volume.geometry.geometry_parameters.p_box_storage = &this_box_storage;

// Assign pointers to functions for intersection with the shape, checking if a point is inside the shape
if (this_box_storage.is_rectangle == 1) {
this_box_volume.geometry.intersect_function = &sample_box_intersect_simple;
this_box_volume.geometry.within_function = &r_within_box_simple;
}
else {
this_box_volume.geometry.intersect_function = &sample_box_intersect_advanced;
this_box_volume.geometry.within_function = &r_within_box_advanced;
}

this_box_volume.geometry.shell_points = &box_shell_points;
this_box_volume.geometry.mcdisplay_function = &mcdisplay_box_function;
this_box_volume.geometry.initialize_from_main_function = &initialize_box_geometry_from_main_component;
this_box_volume.geometry.process_rot_allocated = 0;

this_box_volume.geometry.copy_geometry_parameters = &allocate_box_storage_copy;

rot_copy(this_box_volume.geometry.rotation_matrix,ROT_A_CURRENT_COMP); //check how ROT_R_CURRENT_COMP would work
rot_transpose(ROT_A_CURRENT_COMP,this_box_volume.geometry.transpose_rotation_matrix);

// Initialize loggers
this_box_volume.loggers.num_elements = 0;

// packing the information into the global_geometry_element, which is then included in the global_geometry_list.
sprintf(global_geometry_element.name,NAME_CURRENT_COMP);
global_geometry_element.activation_counter = number_of_activations;
global_geometry_element.component_index = INDEX_CURRENT_COMP;
global_geometry_element.Volume = &this_box_volume; // Would be nicer if this m was a pointer, now we have the (small) data two places
add_element_to_geometry_list(&global_geometry_list,global_geometry_element);
}
#line 192206 "MACS_sample_kidney_box.c"
#undef number_of_activations
#undef mask_setting
#undef mask_string
#undef p_interact
#undef focus_r
#undef focus_xh
#undef focus_xw
#undef focus_ah
#undef focus_aw
#undef target_z
#undef target_y
#undef target_x
#undef target_index
#undef visualize
#undef yheight2
#undef xwidth2
#undef zdepth
#undef yheight
#undef xwidth
#undef priority
#undef material_string
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

  /* Initializations for component channel_3_analyzer_1_array_crystal_array_1. */
  SIG_MESSAGE("channel_3_analyzer_1_array_crystal_array_1 (Init)");
#define mccompcurname  channel_3_analyzer_1_array_crystal_array_1
#define mccompcurtype  Union_box
#define mccompcurindex 245
#define loop_index mccchannel_3_analyzer_1_array_crystal_array_1_loop_index
#define this_box_volume mccchannel_3_analyzer_1_array_crystal_array_1_this_box_volume
#define global_geometry_element mccchannel_3_analyzer_1_array_crystal_array_1_global_geometry_element
#define this_box_storage mccchannel_3_analyzer_1_array_crystal_array_1_this_box_storage
#define material_string mccchannel_3_analyzer_1_array_crystal_array_1_material_string
#define priority mccchannel_3_analyzer_1_array_crystal_array_1_priority
#define xwidth mccchannel_3_analyzer_1_array_crystal_array_1_xwidth
#define yheight mccchannel_3_analyzer_1_array_crystal_array_1_yheight
#define zdepth mccchannel_3_analyzer_1_array_crystal_array_1_zdepth
#define xwidth2 mccchannel_3_analyzer_1_array_crystal_array_1_xwidth2
#define yheight2 mccchannel_3_analyzer_1_array_crystal_array_1_yheight2
#define visualize mccchannel_3_analyzer_1_array_crystal_array_1_visualize
#define target_index mccchannel_3_analyzer_1_array_crystal_array_1_target_index
#define target_x mccchannel_3_analyzer_1_array_crystal_array_1_target_x
#define target_y mccchannel_3_analyzer_1_array_crystal_array_1_target_y
#define target_z mccchannel_3_analyzer_1_array_crystal_array_1_target_z
#define focus_aw mccchannel_3_analyzer_1_array_crystal_array_1_focus_aw
#define focus_ah mccchannel_3_analyzer_1_array_crystal_array_1_focus_ah
#define focus_xw mccchannel_3_analyzer_1_array_crystal_array_1_focus_xw
#define focus_xh mccchannel_3_analyzer_1_array_crystal_array_1_focus_xh
#define focus_r mccchannel_3_analyzer_1_array_crystal_array_1_focus_r
#define p_interact mccchannel_3_analyzer_1_array_crystal_array_1_p_interact
#define mask_string mccchannel_3_analyzer_1_array_crystal_array_1_mask_string
#define mask_setting mccchannel_3_analyzer_1_array_crystal_array_1_mask_setting
#define number_of_activations mccchannel_3_analyzer_1_array_crystal_array_1_number_of_activations
#line 224 "Union_box.comp"
{
// Initializes the focusing system for this volume including input sanitation.
focus_initialize(&this_box_volume.geometry, POS_A_COMP_INDEX(INDEX_CURRENT_COMP+target_index), POS_A_CURRENT_COMP, ROT_A_CURRENT_COMP, target_index, target_x, target_y, target_z, focus_aw, focus_ah, focus_xw, focus_xh, focus_r, NAME_CURRENT_COMP);

// Input sanitation for this geometry
if (xwidth <= 0) {
  printf("\nERROR in Union_box named %s, the xwidth is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (yheight <= 0) {
  printf("\nERROR in Union_box named %s, yheight is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (zdepth <= 0) {
  printf("\nERROR in Union_box named %s, zdepth is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (xwidth2 <= 0 && xwidth2 != -1) {
  printf("\nERROR in Union_box named %s, the xwidth2 is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (yheight2 <= 0 && yheight2 != -1) {
  printf("\nERROR in Union_box named %s, yheight2 is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}

// Use sanitation
if (global_material_list.num_elements == 0) {
  printf("\nERROR: Need to define a material using Union_make_material before using a Union geometry component. \n");
  printf("       %s was defined before first use of Union_make_material.\n",NAME_CURRENT_COMP);
  exit(1);
}

this_box_volume.geometry.is_masked_volume = 0;
this_box_volume.geometry.is_exit_volume = 0;
this_box_volume.geometry.is_mask_volume = 0;
// check if the volume is a mask, if it is the material string is irelevant.
if (mask_string && strlen(mask_string) && strcmp(mask_string, "NULL") && strcmp(mask_string, "0")) {
    // A mask volume is used to limit the extend of other volumes, called the masked volumes. These are specified in the mask_string.
    // In order for a ray to enter a masked volume, it needs to be both in the region covered by that volume AND the mask volume.
    // When more than
    this_box_volume.geometry.mask_mode = 1; // Default is mask mode is ALL
    if (mask_setting && strlen(mask_setting) && strcmp(mask_setting, "NULL") && strcmp(mask_setting, "0")) {
        if (strcmp(mask_setting,"ALL") == 0 || strcmp(mask_setting,"All") == 0) this_box_volume.geometry.mask_mode = 1;
        else if (strcmp(mask_setting,"ANY") == 0 || strcmp(mask_setting,"Any") == 0) this_box_volume.geometry.mask_mode = 2;
        else {
            printf("The mask_mode of component %s is set to %s, but must be either ALL or ANY.\n",NAME_CURRENT_COMP,mask_setting);
            exit(1);
        }
    }
    
    for (loop_index=0;loop_index<global_geometry_list.num_elements;loop_index++) {
        // Add mask list
        if (1 == manual_linking_function(global_geometry_list.elements[loop_index].name,mask_string)) {
            add_element_to_int_list(&this_box_volume.geometry.mask_list,global_geometry_list.elements[loop_index].component_index);
            add_element_to_int_list(&global_geometry_list.elements[loop_index].Volume->geometry.masked_by_list,INDEX_CURRENT_COMP);
            global_geometry_list.elements[loop_index].Volume->geometry.is_masked_volume = 1;
            if (this_box_volume.geometry.mask_mode == 2)
                global_geometry_list.elements[loop_index].Volume->geometry.mask_mode = 2;
            if (this_box_volume.geometry.mask_mode == 1) {
                if (global_geometry_list.elements[loop_index].Volume->geometry.is_masked_volume == 1 && global_geometry_list.elements[loop_index].Volume->geometry.mask_mode != 2)
                    // If more than one mask is added to one volume, the ANY mode overwrites the (default) ALL mode.
                    global_geometry_list.elements[loop_index].Volume->geometry.mask_mode = 1;
            }
            
            found_geometries = 1;
        }
    }
    if (found_geometries == 0) {
        printf("The mask_string in geometry: %s did not find any of the specified volumes in the mask_string %s \n",NAME_CURRENT_COMP,mask_string);
        exit(1);
    }
    this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
    this_box_volume.p_physics->is_vacuum = 0; // Makes this volume a vacuum
    this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
    this_box_volume.p_physics->my_a = 0; // Should not be used.
    sprintf(this_box_volume.p_physics->name,"Mask");
    this_box_volume.geometry.is_mask_volume = 1;
    
    
// Read the material input, or if it lacks, use automatic linking.
} else if (material_string && strlen(material_string) && strcmp(material_string, "NULL") && strcmp(material_string, "0")) {
    // A geometry string was given, use it to determine which material
    if (0 == strcmp(material_string,"vacuum") || 0 == strcmp(material_string,"Vacuum")) {
        // One could have a global physics struct for vacuum instead of creating one for each
        this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
        this_box_volume.p_physics->is_vacuum = 1; // Makes this volume a vacuum
        this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
        this_box_volume.p_physics->my_a = 0; // Should not be used.
        sprintf(this_box_volume.p_physics->name,"Vacuum");
    } else if (0 == strcmp(material_string,"exit") || 0 == strcmp(material_string,"Exit")) {
        // One could have a global physics struct for vacuum instead of creating one for each
        this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
        this_box_volume.p_physics->is_vacuum = 1; // Makes this volume a vacuum
        this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
        this_box_volume.p_physics->my_a = 0; // Should not be used.
        this_box_volume.geometry.is_exit_volume = 1;
        sprintf(this_box_volume.p_physics->name,"Exit");
    } else {
        #ifndef MATERIAL_DETECTOR
            printf("Need to define a material before refering to it in a geometry %s.\n",NAME_CURRENT_COMP);
            exit(1);
        #endif
        for (loop_index=0;loop_index<global_material_list.num_elements;loop_index++) {
            if (0 == strcmp(material_string,global_material_list.elements[loop_index].name)) {
                this_box_volume.p_physics = global_material_list.elements[loop_index].physics;
                break;
            }
            if (loop_index == global_material_list.num_elements-1) {
            printf("\n");
            printf("ERROR: The material string \"%s\" in Union geometry \"%s\" did not match a specified material. \n",material_string,NAME_CURRENT_COMP);
            printf("       The materials available at this point (need to be defined before the geometry): \n");
            for (loop_index=0;loop_index<global_material_list.num_elements;loop_index++)
              printf("         %s\n",global_material_list.elements[loop_index].name);
            printf("\n");
            printf("       It is also possible to use one of the defualt materials avaiable: \n");
            printf("           Vacuum (for a Volume without scattering or absorption)\n");
            printf("           Exit (for a Volume where the ray exits the component if it enters)\n");
            printf("           Mask (for a Volume that masks existing volumes specified in the mask_string\n");
            exit(1);
          }
        }
    }
} else {
    // Automatic linking, simply using the last defined material.
    #ifndef MATERIAL_DETECTOR
        printf("Need to define a material before the geometry to use automatic linking %s.\n",NAME_CURRENT_COMP);
        exit(1);
    #endif
    this_box_volume.p_physics = global_material_list.elements[global_material_list.num_elements-1].physics;
}

sprintf(this_box_volume.name,NAME_CURRENT_COMP);
sprintf(this_box_volume.geometry.shape,"box");
this_box_volume.geometry.priority_value = priority;
this_box_volume.geometry.geometry_p_interact = p_interact;
// Currently the coordinates will be in absolute space.
this_box_volume.geometry.center = POS_A_CURRENT_COMP;

this_box_storage.z_depth = zdepth;
this_box_storage.x_width1 = xwidth;
this_box_storage.y_height1 = yheight;

this_box_storage.is_rectangle = 0;
if (xwidth2 < 0 && yheight2 < 0) this_box_storage.is_rectangle = 1;
if (xwidth == xwidth2 && yheight == yheight2) this_box_storage.is_rectangle = 1;

if (xwidth2 < 0) {
    this_box_storage.x_width2 = xwidth;
    xwidth2 = xwidth;
} else this_box_storage.x_width2 = xwidth2;

if (yheight2 < 0) {
    this_box_storage.y_height2 = yheight;
    yheight2 = yheight;
} else this_box_storage.y_height2 = yheight2;


this_box_storage.normal_vectors[0] = coords_set(0,0,1);
this_box_storage.normal_vectors[1] = coords_set(0,0,1);

// for sides with y component = 0
x_component = 2*zdepth/sqrt((xwidth-xwidth2)*(xwidth-xwidth2)+4*zdepth*zdepth);
z_component = (xwidth-xwidth2)/sqrt(4*zdepth*zdepth+(xwidth-xwidth2)*(xwidth-xwidth2));

this_box_storage.normal_vectors[2] = coords_set(x_component,0,z_component);
this_box_storage.normal_vectors[3] = coords_set(-x_component,0,z_component);

// for sides with x component = 0
y_component = 2*zdepth/sqrt((yheight-yheight2)*(yheight-yheight2)+4*zdepth*zdepth);
z_component = (yheight-yheight2)/sqrt(4*zdepth*zdepth+(yheight-yheight2)*(yheight-yheight2));

this_box_storage.normal_vectors[4] = coords_set(0,y_component,z_component);
this_box_storage.normal_vectors[5] = coords_set(0,-y_component,z_component);

this_box_volume.geometry.visualization_on = visualize;

this_box_volume.geometry.geometry_parameters.p_box_storage = &this_box_storage;

// Assign pointers to functions for intersection with the shape, checking if a point is inside the shape
if (this_box_storage.is_rectangle == 1) {
this_box_volume.geometry.intersect_function = &sample_box_intersect_simple;
this_box_volume.geometry.within_function = &r_within_box_simple;
}
else {
this_box_volume.geometry.intersect_function = &sample_box_intersect_advanced;
this_box_volume.geometry.within_function = &r_within_box_advanced;
}

this_box_volume.geometry.shell_points = &box_shell_points;
this_box_volume.geometry.mcdisplay_function = &mcdisplay_box_function;
this_box_volume.geometry.initialize_from_main_function = &initialize_box_geometry_from_main_component;
this_box_volume.geometry.process_rot_allocated = 0;

this_box_volume.geometry.copy_geometry_parameters = &allocate_box_storage_copy;

rot_copy(this_box_volume.geometry.rotation_matrix,ROT_A_CURRENT_COMP); //check how ROT_R_CURRENT_COMP would work
rot_transpose(ROT_A_CURRENT_COMP,this_box_volume.geometry.transpose_rotation_matrix);

// Initialize loggers
this_box_volume.loggers.num_elements = 0;

// packing the information into the global_geometry_element, which is then included in the global_geometry_list.
sprintf(global_geometry_element.name,NAME_CURRENT_COMP);
global_geometry_element.activation_counter = number_of_activations;
global_geometry_element.component_index = INDEX_CURRENT_COMP;
global_geometry_element.Volume = &this_box_volume; // Would be nicer if this m was a pointer, now we have the (small) data two places
add_element_to_geometry_list(&global_geometry_list,global_geometry_element);
}
#line 192476 "MACS_sample_kidney_box.c"
#undef number_of_activations
#undef mask_setting
#undef mask_string
#undef p_interact
#undef focus_r
#undef focus_xh
#undef focus_xw
#undef focus_ah
#undef focus_aw
#undef target_z
#undef target_y
#undef target_x
#undef target_index
#undef visualize
#undef yheight2
#undef xwidth2
#undef zdepth
#undef yheight
#undef xwidth
#undef priority
#undef material_string
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

  /* Initializations for component channel_3_analyzer_1_array_crystal_array_2. */
  SIG_MESSAGE("channel_3_analyzer_1_array_crystal_array_2 (Init)");
#define mccompcurname  channel_3_analyzer_1_array_crystal_array_2
#define mccompcurtype  Union_box
#define mccompcurindex 246
#define loop_index mccchannel_3_analyzer_1_array_crystal_array_2_loop_index
#define this_box_volume mccchannel_3_analyzer_1_array_crystal_array_2_this_box_volume
#define global_geometry_element mccchannel_3_analyzer_1_array_crystal_array_2_global_geometry_element
#define this_box_storage mccchannel_3_analyzer_1_array_crystal_array_2_this_box_storage
#define material_string mccchannel_3_analyzer_1_array_crystal_array_2_material_string
#define priority mccchannel_3_analyzer_1_array_crystal_array_2_priority
#define xwidth mccchannel_3_analyzer_1_array_crystal_array_2_xwidth
#define yheight mccchannel_3_analyzer_1_array_crystal_array_2_yheight
#define zdepth mccchannel_3_analyzer_1_array_crystal_array_2_zdepth
#define xwidth2 mccchannel_3_analyzer_1_array_crystal_array_2_xwidth2
#define yheight2 mccchannel_3_analyzer_1_array_crystal_array_2_yheight2
#define visualize mccchannel_3_analyzer_1_array_crystal_array_2_visualize
#define target_index mccchannel_3_analyzer_1_array_crystal_array_2_target_index
#define target_x mccchannel_3_analyzer_1_array_crystal_array_2_target_x
#define target_y mccchannel_3_analyzer_1_array_crystal_array_2_target_y
#define target_z mccchannel_3_analyzer_1_array_crystal_array_2_target_z
#define focus_aw mccchannel_3_analyzer_1_array_crystal_array_2_focus_aw
#define focus_ah mccchannel_3_analyzer_1_array_crystal_array_2_focus_ah
#define focus_xw mccchannel_3_analyzer_1_array_crystal_array_2_focus_xw
#define focus_xh mccchannel_3_analyzer_1_array_crystal_array_2_focus_xh
#define focus_r mccchannel_3_analyzer_1_array_crystal_array_2_focus_r
#define p_interact mccchannel_3_analyzer_1_array_crystal_array_2_p_interact
#define mask_string mccchannel_3_analyzer_1_array_crystal_array_2_mask_string
#define mask_setting mccchannel_3_analyzer_1_array_crystal_array_2_mask_setting
#define number_of_activations mccchannel_3_analyzer_1_array_crystal_array_2_number_of_activations
#line 224 "Union_box.comp"
{
// Initializes the focusing system for this volume including input sanitation.
focus_initialize(&this_box_volume.geometry, POS_A_COMP_INDEX(INDEX_CURRENT_COMP+target_index), POS_A_CURRENT_COMP, ROT_A_CURRENT_COMP, target_index, target_x, target_y, target_z, focus_aw, focus_ah, focus_xw, focus_xh, focus_r, NAME_CURRENT_COMP);

// Input sanitation for this geometry
if (xwidth <= 0) {
  printf("\nERROR in Union_box named %s, the xwidth is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (yheight <= 0) {
  printf("\nERROR in Union_box named %s, yheight is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (zdepth <= 0) {
  printf("\nERROR in Union_box named %s, zdepth is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (xwidth2 <= 0 && xwidth2 != -1) {
  printf("\nERROR in Union_box named %s, the xwidth2 is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (yheight2 <= 0 && yheight2 != -1) {
  printf("\nERROR in Union_box named %s, yheight2 is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}

// Use sanitation
if (global_material_list.num_elements == 0) {
  printf("\nERROR: Need to define a material using Union_make_material before using a Union geometry component. \n");
  printf("       %s was defined before first use of Union_make_material.\n",NAME_CURRENT_COMP);
  exit(1);
}

this_box_volume.geometry.is_masked_volume = 0;
this_box_volume.geometry.is_exit_volume = 0;
this_box_volume.geometry.is_mask_volume = 0;
// check if the volume is a mask, if it is the material string is irelevant.
if (mask_string && strlen(mask_string) && strcmp(mask_string, "NULL") && strcmp(mask_string, "0")) {
    // A mask volume is used to limit the extend of other volumes, called the masked volumes. These are specified in the mask_string.
    // In order for a ray to enter a masked volume, it needs to be both in the region covered by that volume AND the mask volume.
    // When more than
    this_box_volume.geometry.mask_mode = 1; // Default is mask mode is ALL
    if (mask_setting && strlen(mask_setting) && strcmp(mask_setting, "NULL") && strcmp(mask_setting, "0")) {
        if (strcmp(mask_setting,"ALL") == 0 || strcmp(mask_setting,"All") == 0) this_box_volume.geometry.mask_mode = 1;
        else if (strcmp(mask_setting,"ANY") == 0 || strcmp(mask_setting,"Any") == 0) this_box_volume.geometry.mask_mode = 2;
        else {
            printf("The mask_mode of component %s is set to %s, but must be either ALL or ANY.\n",NAME_CURRENT_COMP,mask_setting);
            exit(1);
        }
    }
    
    for (loop_index=0;loop_index<global_geometry_list.num_elements;loop_index++) {
        // Add mask list
        if (1 == manual_linking_function(global_geometry_list.elements[loop_index].name,mask_string)) {
            add_element_to_int_list(&this_box_volume.geometry.mask_list,global_geometry_list.elements[loop_index].component_index);
            add_element_to_int_list(&global_geometry_list.elements[loop_index].Volume->geometry.masked_by_list,INDEX_CURRENT_COMP);
            global_geometry_list.elements[loop_index].Volume->geometry.is_masked_volume = 1;
            if (this_box_volume.geometry.mask_mode == 2)
                global_geometry_list.elements[loop_index].Volume->geometry.mask_mode = 2;
            if (this_box_volume.geometry.mask_mode == 1) {
                if (global_geometry_list.elements[loop_index].Volume->geometry.is_masked_volume == 1 && global_geometry_list.elements[loop_index].Volume->geometry.mask_mode != 2)
                    // If more than one mask is added to one volume, the ANY mode overwrites the (default) ALL mode.
                    global_geometry_list.elements[loop_index].Volume->geometry.mask_mode = 1;
            }
            
            found_geometries = 1;
        }
    }
    if (found_geometries == 0) {
        printf("The mask_string in geometry: %s did not find any of the specified volumes in the mask_string %s \n",NAME_CURRENT_COMP,mask_string);
        exit(1);
    }
    this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
    this_box_volume.p_physics->is_vacuum = 0; // Makes this volume a vacuum
    this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
    this_box_volume.p_physics->my_a = 0; // Should not be used.
    sprintf(this_box_volume.p_physics->name,"Mask");
    this_box_volume.geometry.is_mask_volume = 1;
    
    
// Read the material input, or if it lacks, use automatic linking.
} else if (material_string && strlen(material_string) && strcmp(material_string, "NULL") && strcmp(material_string, "0")) {
    // A geometry string was given, use it to determine which material
    if (0 == strcmp(material_string,"vacuum") || 0 == strcmp(material_string,"Vacuum")) {
        // One could have a global physics struct for vacuum instead of creating one for each
        this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
        this_box_volume.p_physics->is_vacuum = 1; // Makes this volume a vacuum
        this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
        this_box_volume.p_physics->my_a = 0; // Should not be used.
        sprintf(this_box_volume.p_physics->name,"Vacuum");
    } else if (0 == strcmp(material_string,"exit") || 0 == strcmp(material_string,"Exit")) {
        // One could have a global physics struct for vacuum instead of creating one for each
        this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
        this_box_volume.p_physics->is_vacuum = 1; // Makes this volume a vacuum
        this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
        this_box_volume.p_physics->my_a = 0; // Should not be used.
        this_box_volume.geometry.is_exit_volume = 1;
        sprintf(this_box_volume.p_physics->name,"Exit");
    } else {
        #ifndef MATERIAL_DETECTOR
            printf("Need to define a material before refering to it in a geometry %s.\n",NAME_CURRENT_COMP);
            exit(1);
        #endif
        for (loop_index=0;loop_index<global_material_list.num_elements;loop_index++) {
            if (0 == strcmp(material_string,global_material_list.elements[loop_index].name)) {
                this_box_volume.p_physics = global_material_list.elements[loop_index].physics;
                break;
            }
            if (loop_index == global_material_list.num_elements-1) {
            printf("\n");
            printf("ERROR: The material string \"%s\" in Union geometry \"%s\" did not match a specified material. \n",material_string,NAME_CURRENT_COMP);
            printf("       The materials available at this point (need to be defined before the geometry): \n");
            for (loop_index=0;loop_index<global_material_list.num_elements;loop_index++)
              printf("         %s\n",global_material_list.elements[loop_index].name);
            printf("\n");
            printf("       It is also possible to use one of the defualt materials avaiable: \n");
            printf("           Vacuum (for a Volume without scattering or absorption)\n");
            printf("           Exit (for a Volume where the ray exits the component if it enters)\n");
            printf("           Mask (for a Volume that masks existing volumes specified in the mask_string\n");
            exit(1);
          }
        }
    }
} else {
    // Automatic linking, simply using the last defined material.
    #ifndef MATERIAL_DETECTOR
        printf("Need to define a material before the geometry to use automatic linking %s.\n",NAME_CURRENT_COMP);
        exit(1);
    #endif
    this_box_volume.p_physics = global_material_list.elements[global_material_list.num_elements-1].physics;
}

sprintf(this_box_volume.name,NAME_CURRENT_COMP);
sprintf(this_box_volume.geometry.shape,"box");
this_box_volume.geometry.priority_value = priority;
this_box_volume.geometry.geometry_p_interact = p_interact;
// Currently the coordinates will be in absolute space.
this_box_volume.geometry.center = POS_A_CURRENT_COMP;

this_box_storage.z_depth = zdepth;
this_box_storage.x_width1 = xwidth;
this_box_storage.y_height1 = yheight;

this_box_storage.is_rectangle = 0;
if (xwidth2 < 0 && yheight2 < 0) this_box_storage.is_rectangle = 1;
if (xwidth == xwidth2 && yheight == yheight2) this_box_storage.is_rectangle = 1;

if (xwidth2 < 0) {
    this_box_storage.x_width2 = xwidth;
    xwidth2 = xwidth;
} else this_box_storage.x_width2 = xwidth2;

if (yheight2 < 0) {
    this_box_storage.y_height2 = yheight;
    yheight2 = yheight;
} else this_box_storage.y_height2 = yheight2;


this_box_storage.normal_vectors[0] = coords_set(0,0,1);
this_box_storage.normal_vectors[1] = coords_set(0,0,1);

// for sides with y component = 0
x_component = 2*zdepth/sqrt((xwidth-xwidth2)*(xwidth-xwidth2)+4*zdepth*zdepth);
z_component = (xwidth-xwidth2)/sqrt(4*zdepth*zdepth+(xwidth-xwidth2)*(xwidth-xwidth2));

this_box_storage.normal_vectors[2] = coords_set(x_component,0,z_component);
this_box_storage.normal_vectors[3] = coords_set(-x_component,0,z_component);

// for sides with x component = 0
y_component = 2*zdepth/sqrt((yheight-yheight2)*(yheight-yheight2)+4*zdepth*zdepth);
z_component = (yheight-yheight2)/sqrt(4*zdepth*zdepth+(yheight-yheight2)*(yheight-yheight2));

this_box_storage.normal_vectors[4] = coords_set(0,y_component,z_component);
this_box_storage.normal_vectors[5] = coords_set(0,-y_component,z_component);

this_box_volume.geometry.visualization_on = visualize;

this_box_volume.geometry.geometry_parameters.p_box_storage = &this_box_storage;

// Assign pointers to functions for intersection with the shape, checking if a point is inside the shape
if (this_box_storage.is_rectangle == 1) {
this_box_volume.geometry.intersect_function = &sample_box_intersect_simple;
this_box_volume.geometry.within_function = &r_within_box_simple;
}
else {
this_box_volume.geometry.intersect_function = &sample_box_intersect_advanced;
this_box_volume.geometry.within_function = &r_within_box_advanced;
}

this_box_volume.geometry.shell_points = &box_shell_points;
this_box_volume.geometry.mcdisplay_function = &mcdisplay_box_function;
this_box_volume.geometry.initialize_from_main_function = &initialize_box_geometry_from_main_component;
this_box_volume.geometry.process_rot_allocated = 0;

this_box_volume.geometry.copy_geometry_parameters = &allocate_box_storage_copy;

rot_copy(this_box_volume.geometry.rotation_matrix,ROT_A_CURRENT_COMP); //check how ROT_R_CURRENT_COMP would work
rot_transpose(ROT_A_CURRENT_COMP,this_box_volume.geometry.transpose_rotation_matrix);

// Initialize loggers
this_box_volume.loggers.num_elements = 0;

// packing the information into the global_geometry_element, which is then included in the global_geometry_list.
sprintf(global_geometry_element.name,NAME_CURRENT_COMP);
global_geometry_element.activation_counter = number_of_activations;
global_geometry_element.component_index = INDEX_CURRENT_COMP;
global_geometry_element.Volume = &this_box_volume; // Would be nicer if this m was a pointer, now we have the (small) data two places
add_element_to_geometry_list(&global_geometry_list,global_geometry_element);
}
#line 192746 "MACS_sample_kidney_box.c"
#undef number_of_activations
#undef mask_setting
#undef mask_string
#undef p_interact
#undef focus_r
#undef focus_xh
#undef focus_xw
#undef focus_ah
#undef focus_aw
#undef target_z
#undef target_y
#undef target_x
#undef target_index
#undef visualize
#undef yheight2
#undef xwidth2
#undef zdepth
#undef yheight
#undef xwidth
#undef priority
#undef material_string
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

  /* Initializations for component channel_3_analyzer_1_array_crystal_array_3. */
  SIG_MESSAGE("channel_3_analyzer_1_array_crystal_array_3 (Init)");
#define mccompcurname  channel_3_analyzer_1_array_crystal_array_3
#define mccompcurtype  Union_box
#define mccompcurindex 247
#define loop_index mccchannel_3_analyzer_1_array_crystal_array_3_loop_index
#define this_box_volume mccchannel_3_analyzer_1_array_crystal_array_3_this_box_volume
#define global_geometry_element mccchannel_3_analyzer_1_array_crystal_array_3_global_geometry_element
#define this_box_storage mccchannel_3_analyzer_1_array_crystal_array_3_this_box_storage
#define material_string mccchannel_3_analyzer_1_array_crystal_array_3_material_string
#define priority mccchannel_3_analyzer_1_array_crystal_array_3_priority
#define xwidth mccchannel_3_analyzer_1_array_crystal_array_3_xwidth
#define yheight mccchannel_3_analyzer_1_array_crystal_array_3_yheight
#define zdepth mccchannel_3_analyzer_1_array_crystal_array_3_zdepth
#define xwidth2 mccchannel_3_analyzer_1_array_crystal_array_3_xwidth2
#define yheight2 mccchannel_3_analyzer_1_array_crystal_array_3_yheight2
#define visualize mccchannel_3_analyzer_1_array_crystal_array_3_visualize
#define target_index mccchannel_3_analyzer_1_array_crystal_array_3_target_index
#define target_x mccchannel_3_analyzer_1_array_crystal_array_3_target_x
#define target_y mccchannel_3_analyzer_1_array_crystal_array_3_target_y
#define target_z mccchannel_3_analyzer_1_array_crystal_array_3_target_z
#define focus_aw mccchannel_3_analyzer_1_array_crystal_array_3_focus_aw
#define focus_ah mccchannel_3_analyzer_1_array_crystal_array_3_focus_ah
#define focus_xw mccchannel_3_analyzer_1_array_crystal_array_3_focus_xw
#define focus_xh mccchannel_3_analyzer_1_array_crystal_array_3_focus_xh
#define focus_r mccchannel_3_analyzer_1_array_crystal_array_3_focus_r
#define p_interact mccchannel_3_analyzer_1_array_crystal_array_3_p_interact
#define mask_string mccchannel_3_analyzer_1_array_crystal_array_3_mask_string
#define mask_setting mccchannel_3_analyzer_1_array_crystal_array_3_mask_setting
#define number_of_activations mccchannel_3_analyzer_1_array_crystal_array_3_number_of_activations
#line 224 "Union_box.comp"
{
// Initializes the focusing system for this volume including input sanitation.
focus_initialize(&this_box_volume.geometry, POS_A_COMP_INDEX(INDEX_CURRENT_COMP+target_index), POS_A_CURRENT_COMP, ROT_A_CURRENT_COMP, target_index, target_x, target_y, target_z, focus_aw, focus_ah, focus_xw, focus_xh, focus_r, NAME_CURRENT_COMP);

// Input sanitation for this geometry
if (xwidth <= 0) {
  printf("\nERROR in Union_box named %s, the xwidth is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (yheight <= 0) {
  printf("\nERROR in Union_box named %s, yheight is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (zdepth <= 0) {
  printf("\nERROR in Union_box named %s, zdepth is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (xwidth2 <= 0 && xwidth2 != -1) {
  printf("\nERROR in Union_box named %s, the xwidth2 is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (yheight2 <= 0 && yheight2 != -1) {
  printf("\nERROR in Union_box named %s, yheight2 is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}

// Use sanitation
if (global_material_list.num_elements == 0) {
  printf("\nERROR: Need to define a material using Union_make_material before using a Union geometry component. \n");
  printf("       %s was defined before first use of Union_make_material.\n",NAME_CURRENT_COMP);
  exit(1);
}

this_box_volume.geometry.is_masked_volume = 0;
this_box_volume.geometry.is_exit_volume = 0;
this_box_volume.geometry.is_mask_volume = 0;
// check if the volume is a mask, if it is the material string is irelevant.
if (mask_string && strlen(mask_string) && strcmp(mask_string, "NULL") && strcmp(mask_string, "0")) {
    // A mask volume is used to limit the extend of other volumes, called the masked volumes. These are specified in the mask_string.
    // In order for a ray to enter a masked volume, it needs to be both in the region covered by that volume AND the mask volume.
    // When more than
    this_box_volume.geometry.mask_mode = 1; // Default is mask mode is ALL
    if (mask_setting && strlen(mask_setting) && strcmp(mask_setting, "NULL") && strcmp(mask_setting, "0")) {
        if (strcmp(mask_setting,"ALL") == 0 || strcmp(mask_setting,"All") == 0) this_box_volume.geometry.mask_mode = 1;
        else if (strcmp(mask_setting,"ANY") == 0 || strcmp(mask_setting,"Any") == 0) this_box_volume.geometry.mask_mode = 2;
        else {
            printf("The mask_mode of component %s is set to %s, but must be either ALL or ANY.\n",NAME_CURRENT_COMP,mask_setting);
            exit(1);
        }
    }
    
    for (loop_index=0;loop_index<global_geometry_list.num_elements;loop_index++) {
        // Add mask list
        if (1 == manual_linking_function(global_geometry_list.elements[loop_index].name,mask_string)) {
            add_element_to_int_list(&this_box_volume.geometry.mask_list,global_geometry_list.elements[loop_index].component_index);
            add_element_to_int_list(&global_geometry_list.elements[loop_index].Volume->geometry.masked_by_list,INDEX_CURRENT_COMP);
            global_geometry_list.elements[loop_index].Volume->geometry.is_masked_volume = 1;
            if (this_box_volume.geometry.mask_mode == 2)
                global_geometry_list.elements[loop_index].Volume->geometry.mask_mode = 2;
            if (this_box_volume.geometry.mask_mode == 1) {
                if (global_geometry_list.elements[loop_index].Volume->geometry.is_masked_volume == 1 && global_geometry_list.elements[loop_index].Volume->geometry.mask_mode != 2)
                    // If more than one mask is added to one volume, the ANY mode overwrites the (default) ALL mode.
                    global_geometry_list.elements[loop_index].Volume->geometry.mask_mode = 1;
            }
            
            found_geometries = 1;
        }
    }
    if (found_geometries == 0) {
        printf("The mask_string in geometry: %s did not find any of the specified volumes in the mask_string %s \n",NAME_CURRENT_COMP,mask_string);
        exit(1);
    }
    this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
    this_box_volume.p_physics->is_vacuum = 0; // Makes this volume a vacuum
    this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
    this_box_volume.p_physics->my_a = 0; // Should not be used.
    sprintf(this_box_volume.p_physics->name,"Mask");
    this_box_volume.geometry.is_mask_volume = 1;
    
    
// Read the material input, or if it lacks, use automatic linking.
} else if (material_string && strlen(material_string) && strcmp(material_string, "NULL") && strcmp(material_string, "0")) {
    // A geometry string was given, use it to determine which material
    if (0 == strcmp(material_string,"vacuum") || 0 == strcmp(material_string,"Vacuum")) {
        // One could have a global physics struct for vacuum instead of creating one for each
        this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
        this_box_volume.p_physics->is_vacuum = 1; // Makes this volume a vacuum
        this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
        this_box_volume.p_physics->my_a = 0; // Should not be used.
        sprintf(this_box_volume.p_physics->name,"Vacuum");
    } else if (0 == strcmp(material_string,"exit") || 0 == strcmp(material_string,"Exit")) {
        // One could have a global physics struct for vacuum instead of creating one for each
        this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
        this_box_volume.p_physics->is_vacuum = 1; // Makes this volume a vacuum
        this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
        this_box_volume.p_physics->my_a = 0; // Should not be used.
        this_box_volume.geometry.is_exit_volume = 1;
        sprintf(this_box_volume.p_physics->name,"Exit");
    } else {
        #ifndef MATERIAL_DETECTOR
            printf("Need to define a material before refering to it in a geometry %s.\n",NAME_CURRENT_COMP);
            exit(1);
        #endif
        for (loop_index=0;loop_index<global_material_list.num_elements;loop_index++) {
            if (0 == strcmp(material_string,global_material_list.elements[loop_index].name)) {
                this_box_volume.p_physics = global_material_list.elements[loop_index].physics;
                break;
            }
            if (loop_index == global_material_list.num_elements-1) {
            printf("\n");
            printf("ERROR: The material string \"%s\" in Union geometry \"%s\" did not match a specified material. \n",material_string,NAME_CURRENT_COMP);
            printf("       The materials available at this point (need to be defined before the geometry): \n");
            for (loop_index=0;loop_index<global_material_list.num_elements;loop_index++)
              printf("         %s\n",global_material_list.elements[loop_index].name);
            printf("\n");
            printf("       It is also possible to use one of the defualt materials avaiable: \n");
            printf("           Vacuum (for a Volume without scattering or absorption)\n");
            printf("           Exit (for a Volume where the ray exits the component if it enters)\n");
            printf("           Mask (for a Volume that masks existing volumes specified in the mask_string\n");
            exit(1);
          }
        }
    }
} else {
    // Automatic linking, simply using the last defined material.
    #ifndef MATERIAL_DETECTOR
        printf("Need to define a material before the geometry to use automatic linking %s.\n",NAME_CURRENT_COMP);
        exit(1);
    #endif
    this_box_volume.p_physics = global_material_list.elements[global_material_list.num_elements-1].physics;
}

sprintf(this_box_volume.name,NAME_CURRENT_COMP);
sprintf(this_box_volume.geometry.shape,"box");
this_box_volume.geometry.priority_value = priority;
this_box_volume.geometry.geometry_p_interact = p_interact;
// Currently the coordinates will be in absolute space.
this_box_volume.geometry.center = POS_A_CURRENT_COMP;

this_box_storage.z_depth = zdepth;
this_box_storage.x_width1 = xwidth;
this_box_storage.y_height1 = yheight;

this_box_storage.is_rectangle = 0;
if (xwidth2 < 0 && yheight2 < 0) this_box_storage.is_rectangle = 1;
if (xwidth == xwidth2 && yheight == yheight2) this_box_storage.is_rectangle = 1;

if (xwidth2 < 0) {
    this_box_storage.x_width2 = xwidth;
    xwidth2 = xwidth;
} else this_box_storage.x_width2 = xwidth2;

if (yheight2 < 0) {
    this_box_storage.y_height2 = yheight;
    yheight2 = yheight;
} else this_box_storage.y_height2 = yheight2;


this_box_storage.normal_vectors[0] = coords_set(0,0,1);
this_box_storage.normal_vectors[1] = coords_set(0,0,1);

// for sides with y component = 0
x_component = 2*zdepth/sqrt((xwidth-xwidth2)*(xwidth-xwidth2)+4*zdepth*zdepth);
z_component = (xwidth-xwidth2)/sqrt(4*zdepth*zdepth+(xwidth-xwidth2)*(xwidth-xwidth2));

this_box_storage.normal_vectors[2] = coords_set(x_component,0,z_component);
this_box_storage.normal_vectors[3] = coords_set(-x_component,0,z_component);

// for sides with x component = 0
y_component = 2*zdepth/sqrt((yheight-yheight2)*(yheight-yheight2)+4*zdepth*zdepth);
z_component = (yheight-yheight2)/sqrt(4*zdepth*zdepth+(yheight-yheight2)*(yheight-yheight2));

this_box_storage.normal_vectors[4] = coords_set(0,y_component,z_component);
this_box_storage.normal_vectors[5] = coords_set(0,-y_component,z_component);

this_box_volume.geometry.visualization_on = visualize;

this_box_volume.geometry.geometry_parameters.p_box_storage = &this_box_storage;

// Assign pointers to functions for intersection with the shape, checking if a point is inside the shape
if (this_box_storage.is_rectangle == 1) {
this_box_volume.geometry.intersect_function = &sample_box_intersect_simple;
this_box_volume.geometry.within_function = &r_within_box_simple;
}
else {
this_box_volume.geometry.intersect_function = &sample_box_intersect_advanced;
this_box_volume.geometry.within_function = &r_within_box_advanced;
}

this_box_volume.geometry.shell_points = &box_shell_points;
this_box_volume.geometry.mcdisplay_function = &mcdisplay_box_function;
this_box_volume.geometry.initialize_from_main_function = &initialize_box_geometry_from_main_component;
this_box_volume.geometry.process_rot_allocated = 0;

this_box_volume.geometry.copy_geometry_parameters = &allocate_box_storage_copy;

rot_copy(this_box_volume.geometry.rotation_matrix,ROT_A_CURRENT_COMP); //check how ROT_R_CURRENT_COMP would work
rot_transpose(ROT_A_CURRENT_COMP,this_box_volume.geometry.transpose_rotation_matrix);

// Initialize loggers
this_box_volume.loggers.num_elements = 0;

// packing the information into the global_geometry_element, which is then included in the global_geometry_list.
sprintf(global_geometry_element.name,NAME_CURRENT_COMP);
global_geometry_element.activation_counter = number_of_activations;
global_geometry_element.component_index = INDEX_CURRENT_COMP;
global_geometry_element.Volume = &this_box_volume; // Would be nicer if this m was a pointer, now we have the (small) data two places
add_element_to_geometry_list(&global_geometry_list,global_geometry_element);
}
#line 193016 "MACS_sample_kidney_box.c"
#undef number_of_activations
#undef mask_setting
#undef mask_string
#undef p_interact
#undef focus_r
#undef focus_xh
#undef focus_xw
#undef focus_ah
#undef focus_aw
#undef target_z
#undef target_y
#undef target_x
#undef target_index
#undef visualize
#undef yheight2
#undef xwidth2
#undef zdepth
#undef yheight
#undef xwidth
#undef priority
#undef material_string
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

  /* Initializations for component channel_3_analyzer_1_array_crystal_array_4. */
  SIG_MESSAGE("channel_3_analyzer_1_array_crystal_array_4 (Init)");
#define mccompcurname  channel_3_analyzer_1_array_crystal_array_4
#define mccompcurtype  Union_box
#define mccompcurindex 248
#define loop_index mccchannel_3_analyzer_1_array_crystal_array_4_loop_index
#define this_box_volume mccchannel_3_analyzer_1_array_crystal_array_4_this_box_volume
#define global_geometry_element mccchannel_3_analyzer_1_array_crystal_array_4_global_geometry_element
#define this_box_storage mccchannel_3_analyzer_1_array_crystal_array_4_this_box_storage
#define material_string mccchannel_3_analyzer_1_array_crystal_array_4_material_string
#define priority mccchannel_3_analyzer_1_array_crystal_array_4_priority
#define xwidth mccchannel_3_analyzer_1_array_crystal_array_4_xwidth
#define yheight mccchannel_3_analyzer_1_array_crystal_array_4_yheight
#define zdepth mccchannel_3_analyzer_1_array_crystal_array_4_zdepth
#define xwidth2 mccchannel_3_analyzer_1_array_crystal_array_4_xwidth2
#define yheight2 mccchannel_3_analyzer_1_array_crystal_array_4_yheight2
#define visualize mccchannel_3_analyzer_1_array_crystal_array_4_visualize
#define target_index mccchannel_3_analyzer_1_array_crystal_array_4_target_index
#define target_x mccchannel_3_analyzer_1_array_crystal_array_4_target_x
#define target_y mccchannel_3_analyzer_1_array_crystal_array_4_target_y
#define target_z mccchannel_3_analyzer_1_array_crystal_array_4_target_z
#define focus_aw mccchannel_3_analyzer_1_array_crystal_array_4_focus_aw
#define focus_ah mccchannel_3_analyzer_1_array_crystal_array_4_focus_ah
#define focus_xw mccchannel_3_analyzer_1_array_crystal_array_4_focus_xw
#define focus_xh mccchannel_3_analyzer_1_array_crystal_array_4_focus_xh
#define focus_r mccchannel_3_analyzer_1_array_crystal_array_4_focus_r
#define p_interact mccchannel_3_analyzer_1_array_crystal_array_4_p_interact
#define mask_string mccchannel_3_analyzer_1_array_crystal_array_4_mask_string
#define mask_setting mccchannel_3_analyzer_1_array_crystal_array_4_mask_setting
#define number_of_activations mccchannel_3_analyzer_1_array_crystal_array_4_number_of_activations
#line 224 "Union_box.comp"
{
// Initializes the focusing system for this volume including input sanitation.
focus_initialize(&this_box_volume.geometry, POS_A_COMP_INDEX(INDEX_CURRENT_COMP+target_index), POS_A_CURRENT_COMP, ROT_A_CURRENT_COMP, target_index, target_x, target_y, target_z, focus_aw, focus_ah, focus_xw, focus_xh, focus_r, NAME_CURRENT_COMP);

// Input sanitation for this geometry
if (xwidth <= 0) {
  printf("\nERROR in Union_box named %s, the xwidth is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (yheight <= 0) {
  printf("\nERROR in Union_box named %s, yheight is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (zdepth <= 0) {
  printf("\nERROR in Union_box named %s, zdepth is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (xwidth2 <= 0 && xwidth2 != -1) {
  printf("\nERROR in Union_box named %s, the xwidth2 is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (yheight2 <= 0 && yheight2 != -1) {
  printf("\nERROR in Union_box named %s, yheight2 is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}

// Use sanitation
if (global_material_list.num_elements == 0) {
  printf("\nERROR: Need to define a material using Union_make_material before using a Union geometry component. \n");
  printf("       %s was defined before first use of Union_make_material.\n",NAME_CURRENT_COMP);
  exit(1);
}

this_box_volume.geometry.is_masked_volume = 0;
this_box_volume.geometry.is_exit_volume = 0;
this_box_volume.geometry.is_mask_volume = 0;
// check if the volume is a mask, if it is the material string is irelevant.
if (mask_string && strlen(mask_string) && strcmp(mask_string, "NULL") && strcmp(mask_string, "0")) {
    // A mask volume is used to limit the extend of other volumes, called the masked volumes. These are specified in the mask_string.
    // In order for a ray to enter a masked volume, it needs to be both in the region covered by that volume AND the mask volume.
    // When more than
    this_box_volume.geometry.mask_mode = 1; // Default is mask mode is ALL
    if (mask_setting && strlen(mask_setting) && strcmp(mask_setting, "NULL") && strcmp(mask_setting, "0")) {
        if (strcmp(mask_setting,"ALL") == 0 || strcmp(mask_setting,"All") == 0) this_box_volume.geometry.mask_mode = 1;
        else if (strcmp(mask_setting,"ANY") == 0 || strcmp(mask_setting,"Any") == 0) this_box_volume.geometry.mask_mode = 2;
        else {
            printf("The mask_mode of component %s is set to %s, but must be either ALL or ANY.\n",NAME_CURRENT_COMP,mask_setting);
            exit(1);
        }
    }
    
    for (loop_index=0;loop_index<global_geometry_list.num_elements;loop_index++) {
        // Add mask list
        if (1 == manual_linking_function(global_geometry_list.elements[loop_index].name,mask_string)) {
            add_element_to_int_list(&this_box_volume.geometry.mask_list,global_geometry_list.elements[loop_index].component_index);
            add_element_to_int_list(&global_geometry_list.elements[loop_index].Volume->geometry.masked_by_list,INDEX_CURRENT_COMP);
            global_geometry_list.elements[loop_index].Volume->geometry.is_masked_volume = 1;
            if (this_box_volume.geometry.mask_mode == 2)
                global_geometry_list.elements[loop_index].Volume->geometry.mask_mode = 2;
            if (this_box_volume.geometry.mask_mode == 1) {
                if (global_geometry_list.elements[loop_index].Volume->geometry.is_masked_volume == 1 && global_geometry_list.elements[loop_index].Volume->geometry.mask_mode != 2)
                    // If more than one mask is added to one volume, the ANY mode overwrites the (default) ALL mode.
                    global_geometry_list.elements[loop_index].Volume->geometry.mask_mode = 1;
            }
            
            found_geometries = 1;
        }
    }
    if (found_geometries == 0) {
        printf("The mask_string in geometry: %s did not find any of the specified volumes in the mask_string %s \n",NAME_CURRENT_COMP,mask_string);
        exit(1);
    }
    this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
    this_box_volume.p_physics->is_vacuum = 0; // Makes this volume a vacuum
    this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
    this_box_volume.p_physics->my_a = 0; // Should not be used.
    sprintf(this_box_volume.p_physics->name,"Mask");
    this_box_volume.geometry.is_mask_volume = 1;
    
    
// Read the material input, or if it lacks, use automatic linking.
} else if (material_string && strlen(material_string) && strcmp(material_string, "NULL") && strcmp(material_string, "0")) {
    // A geometry string was given, use it to determine which material
    if (0 == strcmp(material_string,"vacuum") || 0 == strcmp(material_string,"Vacuum")) {
        // One could have a global physics struct for vacuum instead of creating one for each
        this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
        this_box_volume.p_physics->is_vacuum = 1; // Makes this volume a vacuum
        this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
        this_box_volume.p_physics->my_a = 0; // Should not be used.
        sprintf(this_box_volume.p_physics->name,"Vacuum");
    } else if (0 == strcmp(material_string,"exit") || 0 == strcmp(material_string,"Exit")) {
        // One could have a global physics struct for vacuum instead of creating one for each
        this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
        this_box_volume.p_physics->is_vacuum = 1; // Makes this volume a vacuum
        this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
        this_box_volume.p_physics->my_a = 0; // Should not be used.
        this_box_volume.geometry.is_exit_volume = 1;
        sprintf(this_box_volume.p_physics->name,"Exit");
    } else {
        #ifndef MATERIAL_DETECTOR
            printf("Need to define a material before refering to it in a geometry %s.\n",NAME_CURRENT_COMP);
            exit(1);
        #endif
        for (loop_index=0;loop_index<global_material_list.num_elements;loop_index++) {
            if (0 == strcmp(material_string,global_material_list.elements[loop_index].name)) {
                this_box_volume.p_physics = global_material_list.elements[loop_index].physics;
                break;
            }
            if (loop_index == global_material_list.num_elements-1) {
            printf("\n");
            printf("ERROR: The material string \"%s\" in Union geometry \"%s\" did not match a specified material. \n",material_string,NAME_CURRENT_COMP);
            printf("       The materials available at this point (need to be defined before the geometry): \n");
            for (loop_index=0;loop_index<global_material_list.num_elements;loop_index++)
              printf("         %s\n",global_material_list.elements[loop_index].name);
            printf("\n");
            printf("       It is also possible to use one of the defualt materials avaiable: \n");
            printf("           Vacuum (for a Volume without scattering or absorption)\n");
            printf("           Exit (for a Volume where the ray exits the component if it enters)\n");
            printf("           Mask (for a Volume that masks existing volumes specified in the mask_string\n");
            exit(1);
          }
        }
    }
} else {
    // Automatic linking, simply using the last defined material.
    #ifndef MATERIAL_DETECTOR
        printf("Need to define a material before the geometry to use automatic linking %s.\n",NAME_CURRENT_COMP);
        exit(1);
    #endif
    this_box_volume.p_physics = global_material_list.elements[global_material_list.num_elements-1].physics;
}

sprintf(this_box_volume.name,NAME_CURRENT_COMP);
sprintf(this_box_volume.geometry.shape,"box");
this_box_volume.geometry.priority_value = priority;
this_box_volume.geometry.geometry_p_interact = p_interact;
// Currently the coordinates will be in absolute space.
this_box_volume.geometry.center = POS_A_CURRENT_COMP;

this_box_storage.z_depth = zdepth;
this_box_storage.x_width1 = xwidth;
this_box_storage.y_height1 = yheight;

this_box_storage.is_rectangle = 0;
if (xwidth2 < 0 && yheight2 < 0) this_box_storage.is_rectangle = 1;
if (xwidth == xwidth2 && yheight == yheight2) this_box_storage.is_rectangle = 1;

if (xwidth2 < 0) {
    this_box_storage.x_width2 = xwidth;
    xwidth2 = xwidth;
} else this_box_storage.x_width2 = xwidth2;

if (yheight2 < 0) {
    this_box_storage.y_height2 = yheight;
    yheight2 = yheight;
} else this_box_storage.y_height2 = yheight2;


this_box_storage.normal_vectors[0] = coords_set(0,0,1);
this_box_storage.normal_vectors[1] = coords_set(0,0,1);

// for sides with y component = 0
x_component = 2*zdepth/sqrt((xwidth-xwidth2)*(xwidth-xwidth2)+4*zdepth*zdepth);
z_component = (xwidth-xwidth2)/sqrt(4*zdepth*zdepth+(xwidth-xwidth2)*(xwidth-xwidth2));

this_box_storage.normal_vectors[2] = coords_set(x_component,0,z_component);
this_box_storage.normal_vectors[3] = coords_set(-x_component,0,z_component);

// for sides with x component = 0
y_component = 2*zdepth/sqrt((yheight-yheight2)*(yheight-yheight2)+4*zdepth*zdepth);
z_component = (yheight-yheight2)/sqrt(4*zdepth*zdepth+(yheight-yheight2)*(yheight-yheight2));

this_box_storage.normal_vectors[4] = coords_set(0,y_component,z_component);
this_box_storage.normal_vectors[5] = coords_set(0,-y_component,z_component);

this_box_volume.geometry.visualization_on = visualize;

this_box_volume.geometry.geometry_parameters.p_box_storage = &this_box_storage;

// Assign pointers to functions for intersection with the shape, checking if a point is inside the shape
if (this_box_storage.is_rectangle == 1) {
this_box_volume.geometry.intersect_function = &sample_box_intersect_simple;
this_box_volume.geometry.within_function = &r_within_box_simple;
}
else {
this_box_volume.geometry.intersect_function = &sample_box_intersect_advanced;
this_box_volume.geometry.within_function = &r_within_box_advanced;
}

this_box_volume.geometry.shell_points = &box_shell_points;
this_box_volume.geometry.mcdisplay_function = &mcdisplay_box_function;
this_box_volume.geometry.initialize_from_main_function = &initialize_box_geometry_from_main_component;
this_box_volume.geometry.process_rot_allocated = 0;

this_box_volume.geometry.copy_geometry_parameters = &allocate_box_storage_copy;

rot_copy(this_box_volume.geometry.rotation_matrix,ROT_A_CURRENT_COMP); //check how ROT_R_CURRENT_COMP would work
rot_transpose(ROT_A_CURRENT_COMP,this_box_volume.geometry.transpose_rotation_matrix);

// Initialize loggers
this_box_volume.loggers.num_elements = 0;

// packing the information into the global_geometry_element, which is then included in the global_geometry_list.
sprintf(global_geometry_element.name,NAME_CURRENT_COMP);
global_geometry_element.activation_counter = number_of_activations;
global_geometry_element.component_index = INDEX_CURRENT_COMP;
global_geometry_element.Volume = &this_box_volume; // Would be nicer if this m was a pointer, now we have the (small) data two places
add_element_to_geometry_list(&global_geometry_list,global_geometry_element);
}
#line 193286 "MACS_sample_kidney_box.c"
#undef number_of_activations
#undef mask_setting
#undef mask_string
#undef p_interact
#undef focus_r
#undef focus_xh
#undef focus_xw
#undef focus_ah
#undef focus_aw
#undef target_z
#undef target_y
#undef target_x
#undef target_index
#undef visualize
#undef yheight2
#undef xwidth2
#undef zdepth
#undef yheight
#undef xwidth
#undef priority
#undef material_string
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

  /* Initializations for component channel_3_analyzer_1_array_crystal_array_5. */
  SIG_MESSAGE("channel_3_analyzer_1_array_crystal_array_5 (Init)");
#define mccompcurname  channel_3_analyzer_1_array_crystal_array_5
#define mccompcurtype  Union_box
#define mccompcurindex 249
#define loop_index mccchannel_3_analyzer_1_array_crystal_array_5_loop_index
#define this_box_volume mccchannel_3_analyzer_1_array_crystal_array_5_this_box_volume
#define global_geometry_element mccchannel_3_analyzer_1_array_crystal_array_5_global_geometry_element
#define this_box_storage mccchannel_3_analyzer_1_array_crystal_array_5_this_box_storage
#define material_string mccchannel_3_analyzer_1_array_crystal_array_5_material_string
#define priority mccchannel_3_analyzer_1_array_crystal_array_5_priority
#define xwidth mccchannel_3_analyzer_1_array_crystal_array_5_xwidth
#define yheight mccchannel_3_analyzer_1_array_crystal_array_5_yheight
#define zdepth mccchannel_3_analyzer_1_array_crystal_array_5_zdepth
#define xwidth2 mccchannel_3_analyzer_1_array_crystal_array_5_xwidth2
#define yheight2 mccchannel_3_analyzer_1_array_crystal_array_5_yheight2
#define visualize mccchannel_3_analyzer_1_array_crystal_array_5_visualize
#define target_index mccchannel_3_analyzer_1_array_crystal_array_5_target_index
#define target_x mccchannel_3_analyzer_1_array_crystal_array_5_target_x
#define target_y mccchannel_3_analyzer_1_array_crystal_array_5_target_y
#define target_z mccchannel_3_analyzer_1_array_crystal_array_5_target_z
#define focus_aw mccchannel_3_analyzer_1_array_crystal_array_5_focus_aw
#define focus_ah mccchannel_3_analyzer_1_array_crystal_array_5_focus_ah
#define focus_xw mccchannel_3_analyzer_1_array_crystal_array_5_focus_xw
#define focus_xh mccchannel_3_analyzer_1_array_crystal_array_5_focus_xh
#define focus_r mccchannel_3_analyzer_1_array_crystal_array_5_focus_r
#define p_interact mccchannel_3_analyzer_1_array_crystal_array_5_p_interact
#define mask_string mccchannel_3_analyzer_1_array_crystal_array_5_mask_string
#define mask_setting mccchannel_3_analyzer_1_array_crystal_array_5_mask_setting
#define number_of_activations mccchannel_3_analyzer_1_array_crystal_array_5_number_of_activations
#line 224 "Union_box.comp"
{
// Initializes the focusing system for this volume including input sanitation.
focus_initialize(&this_box_volume.geometry, POS_A_COMP_INDEX(INDEX_CURRENT_COMP+target_index), POS_A_CURRENT_COMP, ROT_A_CURRENT_COMP, target_index, target_x, target_y, target_z, focus_aw, focus_ah, focus_xw, focus_xh, focus_r, NAME_CURRENT_COMP);

// Input sanitation for this geometry
if (xwidth <= 0) {
  printf("\nERROR in Union_box named %s, the xwidth is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (yheight <= 0) {
  printf("\nERROR in Union_box named %s, yheight is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (zdepth <= 0) {
  printf("\nERROR in Union_box named %s, zdepth is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (xwidth2 <= 0 && xwidth2 != -1) {
  printf("\nERROR in Union_box named %s, the xwidth2 is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (yheight2 <= 0 && yheight2 != -1) {
  printf("\nERROR in Union_box named %s, yheight2 is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}

// Use sanitation
if (global_material_list.num_elements == 0) {
  printf("\nERROR: Need to define a material using Union_make_material before using a Union geometry component. \n");
  printf("       %s was defined before first use of Union_make_material.\n",NAME_CURRENT_COMP);
  exit(1);
}

this_box_volume.geometry.is_masked_volume = 0;
this_box_volume.geometry.is_exit_volume = 0;
this_box_volume.geometry.is_mask_volume = 0;
// check if the volume is a mask, if it is the material string is irelevant.
if (mask_string && strlen(mask_string) && strcmp(mask_string, "NULL") && strcmp(mask_string, "0")) {
    // A mask volume is used to limit the extend of other volumes, called the masked volumes. These are specified in the mask_string.
    // In order for a ray to enter a masked volume, it needs to be both in the region covered by that volume AND the mask volume.
    // When more than
    this_box_volume.geometry.mask_mode = 1; // Default is mask mode is ALL
    if (mask_setting && strlen(mask_setting) && strcmp(mask_setting, "NULL") && strcmp(mask_setting, "0")) {
        if (strcmp(mask_setting,"ALL") == 0 || strcmp(mask_setting,"All") == 0) this_box_volume.geometry.mask_mode = 1;
        else if (strcmp(mask_setting,"ANY") == 0 || strcmp(mask_setting,"Any") == 0) this_box_volume.geometry.mask_mode = 2;
        else {
            printf("The mask_mode of component %s is set to %s, but must be either ALL or ANY.\n",NAME_CURRENT_COMP,mask_setting);
            exit(1);
        }
    }
    
    for (loop_index=0;loop_index<global_geometry_list.num_elements;loop_index++) {
        // Add mask list
        if (1 == manual_linking_function(global_geometry_list.elements[loop_index].name,mask_string)) {
            add_element_to_int_list(&this_box_volume.geometry.mask_list,global_geometry_list.elements[loop_index].component_index);
            add_element_to_int_list(&global_geometry_list.elements[loop_index].Volume->geometry.masked_by_list,INDEX_CURRENT_COMP);
            global_geometry_list.elements[loop_index].Volume->geometry.is_masked_volume = 1;
            if (this_box_volume.geometry.mask_mode == 2)
                global_geometry_list.elements[loop_index].Volume->geometry.mask_mode = 2;
            if (this_box_volume.geometry.mask_mode == 1) {
                if (global_geometry_list.elements[loop_index].Volume->geometry.is_masked_volume == 1 && global_geometry_list.elements[loop_index].Volume->geometry.mask_mode != 2)
                    // If more than one mask is added to one volume, the ANY mode overwrites the (default) ALL mode.
                    global_geometry_list.elements[loop_index].Volume->geometry.mask_mode = 1;
            }
            
            found_geometries = 1;
        }
    }
    if (found_geometries == 0) {
        printf("The mask_string in geometry: %s did not find any of the specified volumes in the mask_string %s \n",NAME_CURRENT_COMP,mask_string);
        exit(1);
    }
    this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
    this_box_volume.p_physics->is_vacuum = 0; // Makes this volume a vacuum
    this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
    this_box_volume.p_physics->my_a = 0; // Should not be used.
    sprintf(this_box_volume.p_physics->name,"Mask");
    this_box_volume.geometry.is_mask_volume = 1;
    
    
// Read the material input, or if it lacks, use automatic linking.
} else if (material_string && strlen(material_string) && strcmp(material_string, "NULL") && strcmp(material_string, "0")) {
    // A geometry string was given, use it to determine which material
    if (0 == strcmp(material_string,"vacuum") || 0 == strcmp(material_string,"Vacuum")) {
        // One could have a global physics struct for vacuum instead of creating one for each
        this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
        this_box_volume.p_physics->is_vacuum = 1; // Makes this volume a vacuum
        this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
        this_box_volume.p_physics->my_a = 0; // Should not be used.
        sprintf(this_box_volume.p_physics->name,"Vacuum");
    } else if (0 == strcmp(material_string,"exit") || 0 == strcmp(material_string,"Exit")) {
        // One could have a global physics struct for vacuum instead of creating one for each
        this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
        this_box_volume.p_physics->is_vacuum = 1; // Makes this volume a vacuum
        this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
        this_box_volume.p_physics->my_a = 0; // Should not be used.
        this_box_volume.geometry.is_exit_volume = 1;
        sprintf(this_box_volume.p_physics->name,"Exit");
    } else {
        #ifndef MATERIAL_DETECTOR
            printf("Need to define a material before refering to it in a geometry %s.\n",NAME_CURRENT_COMP);
            exit(1);
        #endif
        for (loop_index=0;loop_index<global_material_list.num_elements;loop_index++) {
            if (0 == strcmp(material_string,global_material_list.elements[loop_index].name)) {
                this_box_volume.p_physics = global_material_list.elements[loop_index].physics;
                break;
            }
            if (loop_index == global_material_list.num_elements-1) {
            printf("\n");
            printf("ERROR: The material string \"%s\" in Union geometry \"%s\" did not match a specified material. \n",material_string,NAME_CURRENT_COMP);
            printf("       The materials available at this point (need to be defined before the geometry): \n");
            for (loop_index=0;loop_index<global_material_list.num_elements;loop_index++)
              printf("         %s\n",global_material_list.elements[loop_index].name);
            printf("\n");
            printf("       It is also possible to use one of the defualt materials avaiable: \n");
            printf("           Vacuum (for a Volume without scattering or absorption)\n");
            printf("           Exit (for a Volume where the ray exits the component if it enters)\n");
            printf("           Mask (for a Volume that masks existing volumes specified in the mask_string\n");
            exit(1);
          }
        }
    }
} else {
    // Automatic linking, simply using the last defined material.
    #ifndef MATERIAL_DETECTOR
        printf("Need to define a material before the geometry to use automatic linking %s.\n",NAME_CURRENT_COMP);
        exit(1);
    #endif
    this_box_volume.p_physics = global_material_list.elements[global_material_list.num_elements-1].physics;
}

sprintf(this_box_volume.name,NAME_CURRENT_COMP);
sprintf(this_box_volume.geometry.shape,"box");
this_box_volume.geometry.priority_value = priority;
this_box_volume.geometry.geometry_p_interact = p_interact;
// Currently the coordinates will be in absolute space.
this_box_volume.geometry.center = POS_A_CURRENT_COMP;

this_box_storage.z_depth = zdepth;
this_box_storage.x_width1 = xwidth;
this_box_storage.y_height1 = yheight;

this_box_storage.is_rectangle = 0;
if (xwidth2 < 0 && yheight2 < 0) this_box_storage.is_rectangle = 1;
if (xwidth == xwidth2 && yheight == yheight2) this_box_storage.is_rectangle = 1;

if (xwidth2 < 0) {
    this_box_storage.x_width2 = xwidth;
    xwidth2 = xwidth;
} else this_box_storage.x_width2 = xwidth2;

if (yheight2 < 0) {
    this_box_storage.y_height2 = yheight;
    yheight2 = yheight;
} else this_box_storage.y_height2 = yheight2;


this_box_storage.normal_vectors[0] = coords_set(0,0,1);
this_box_storage.normal_vectors[1] = coords_set(0,0,1);

// for sides with y component = 0
x_component = 2*zdepth/sqrt((xwidth-xwidth2)*(xwidth-xwidth2)+4*zdepth*zdepth);
z_component = (xwidth-xwidth2)/sqrt(4*zdepth*zdepth+(xwidth-xwidth2)*(xwidth-xwidth2));

this_box_storage.normal_vectors[2] = coords_set(x_component,0,z_component);
this_box_storage.normal_vectors[3] = coords_set(-x_component,0,z_component);

// for sides with x component = 0
y_component = 2*zdepth/sqrt((yheight-yheight2)*(yheight-yheight2)+4*zdepth*zdepth);
z_component = (yheight-yheight2)/sqrt(4*zdepth*zdepth+(yheight-yheight2)*(yheight-yheight2));

this_box_storage.normal_vectors[4] = coords_set(0,y_component,z_component);
this_box_storage.normal_vectors[5] = coords_set(0,-y_component,z_component);

this_box_volume.geometry.visualization_on = visualize;

this_box_volume.geometry.geometry_parameters.p_box_storage = &this_box_storage;

// Assign pointers to functions for intersection with the shape, checking if a point is inside the shape
if (this_box_storage.is_rectangle == 1) {
this_box_volume.geometry.intersect_function = &sample_box_intersect_simple;
this_box_volume.geometry.within_function = &r_within_box_simple;
}
else {
this_box_volume.geometry.intersect_function = &sample_box_intersect_advanced;
this_box_volume.geometry.within_function = &r_within_box_advanced;
}

this_box_volume.geometry.shell_points = &box_shell_points;
this_box_volume.geometry.mcdisplay_function = &mcdisplay_box_function;
this_box_volume.geometry.initialize_from_main_function = &initialize_box_geometry_from_main_component;
this_box_volume.geometry.process_rot_allocated = 0;

this_box_volume.geometry.copy_geometry_parameters = &allocate_box_storage_copy;

rot_copy(this_box_volume.geometry.rotation_matrix,ROT_A_CURRENT_COMP); //check how ROT_R_CURRENT_COMP would work
rot_transpose(ROT_A_CURRENT_COMP,this_box_volume.geometry.transpose_rotation_matrix);

// Initialize loggers
this_box_volume.loggers.num_elements = 0;

// packing the information into the global_geometry_element, which is then included in the global_geometry_list.
sprintf(global_geometry_element.name,NAME_CURRENT_COMP);
global_geometry_element.activation_counter = number_of_activations;
global_geometry_element.component_index = INDEX_CURRENT_COMP;
global_geometry_element.Volume = &this_box_volume; // Would be nicer if this m was a pointer, now we have the (small) data two places
add_element_to_geometry_list(&global_geometry_list,global_geometry_element);
}
#line 193556 "MACS_sample_kidney_box.c"
#undef number_of_activations
#undef mask_setting
#undef mask_string
#undef p_interact
#undef focus_r
#undef focus_xh
#undef focus_xw
#undef focus_ah
#undef focus_aw
#undef target_z
#undef target_y
#undef target_x
#undef target_index
#undef visualize
#undef yheight2
#undef xwidth2
#undef zdepth
#undef yheight
#undef xwidth
#undef priority
#undef material_string
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

  /* Initializations for component channel_3_analyzer_1_array_crystal_array_6. */
  SIG_MESSAGE("channel_3_analyzer_1_array_crystal_array_6 (Init)");
#define mccompcurname  channel_3_analyzer_1_array_crystal_array_6
#define mccompcurtype  Union_box
#define mccompcurindex 250
#define loop_index mccchannel_3_analyzer_1_array_crystal_array_6_loop_index
#define this_box_volume mccchannel_3_analyzer_1_array_crystal_array_6_this_box_volume
#define global_geometry_element mccchannel_3_analyzer_1_array_crystal_array_6_global_geometry_element
#define this_box_storage mccchannel_3_analyzer_1_array_crystal_array_6_this_box_storage
#define material_string mccchannel_3_analyzer_1_array_crystal_array_6_material_string
#define priority mccchannel_3_analyzer_1_array_crystal_array_6_priority
#define xwidth mccchannel_3_analyzer_1_array_crystal_array_6_xwidth
#define yheight mccchannel_3_analyzer_1_array_crystal_array_6_yheight
#define zdepth mccchannel_3_analyzer_1_array_crystal_array_6_zdepth
#define xwidth2 mccchannel_3_analyzer_1_array_crystal_array_6_xwidth2
#define yheight2 mccchannel_3_analyzer_1_array_crystal_array_6_yheight2
#define visualize mccchannel_3_analyzer_1_array_crystal_array_6_visualize
#define target_index mccchannel_3_analyzer_1_array_crystal_array_6_target_index
#define target_x mccchannel_3_analyzer_1_array_crystal_array_6_target_x
#define target_y mccchannel_3_analyzer_1_array_crystal_array_6_target_y
#define target_z mccchannel_3_analyzer_1_array_crystal_array_6_target_z
#define focus_aw mccchannel_3_analyzer_1_array_crystal_array_6_focus_aw
#define focus_ah mccchannel_3_analyzer_1_array_crystal_array_6_focus_ah
#define focus_xw mccchannel_3_analyzer_1_array_crystal_array_6_focus_xw
#define focus_xh mccchannel_3_analyzer_1_array_crystal_array_6_focus_xh
#define focus_r mccchannel_3_analyzer_1_array_crystal_array_6_focus_r
#define p_interact mccchannel_3_analyzer_1_array_crystal_array_6_p_interact
#define mask_string mccchannel_3_analyzer_1_array_crystal_array_6_mask_string
#define mask_setting mccchannel_3_analyzer_1_array_crystal_array_6_mask_setting
#define number_of_activations mccchannel_3_analyzer_1_array_crystal_array_6_number_of_activations
#line 224 "Union_box.comp"
{
// Initializes the focusing system for this volume including input sanitation.
focus_initialize(&this_box_volume.geometry, POS_A_COMP_INDEX(INDEX_CURRENT_COMP+target_index), POS_A_CURRENT_COMP, ROT_A_CURRENT_COMP, target_index, target_x, target_y, target_z, focus_aw, focus_ah, focus_xw, focus_xh, focus_r, NAME_CURRENT_COMP);

// Input sanitation for this geometry
if (xwidth <= 0) {
  printf("\nERROR in Union_box named %s, the xwidth is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (yheight <= 0) {
  printf("\nERROR in Union_box named %s, yheight is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (zdepth <= 0) {
  printf("\nERROR in Union_box named %s, zdepth is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (xwidth2 <= 0 && xwidth2 != -1) {
  printf("\nERROR in Union_box named %s, the xwidth2 is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (yheight2 <= 0 && yheight2 != -1) {
  printf("\nERROR in Union_box named %s, yheight2 is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}

// Use sanitation
if (global_material_list.num_elements == 0) {
  printf("\nERROR: Need to define a material using Union_make_material before using a Union geometry component. \n");
  printf("       %s was defined before first use of Union_make_material.\n",NAME_CURRENT_COMP);
  exit(1);
}

this_box_volume.geometry.is_masked_volume = 0;
this_box_volume.geometry.is_exit_volume = 0;
this_box_volume.geometry.is_mask_volume = 0;
// check if the volume is a mask, if it is the material string is irelevant.
if (mask_string && strlen(mask_string) && strcmp(mask_string, "NULL") && strcmp(mask_string, "0")) {
    // A mask volume is used to limit the extend of other volumes, called the masked volumes. These are specified in the mask_string.
    // In order for a ray to enter a masked volume, it needs to be both in the region covered by that volume AND the mask volume.
    // When more than
    this_box_volume.geometry.mask_mode = 1; // Default is mask mode is ALL
    if (mask_setting && strlen(mask_setting) && strcmp(mask_setting, "NULL") && strcmp(mask_setting, "0")) {
        if (strcmp(mask_setting,"ALL") == 0 || strcmp(mask_setting,"All") == 0) this_box_volume.geometry.mask_mode = 1;
        else if (strcmp(mask_setting,"ANY") == 0 || strcmp(mask_setting,"Any") == 0) this_box_volume.geometry.mask_mode = 2;
        else {
            printf("The mask_mode of component %s is set to %s, but must be either ALL or ANY.\n",NAME_CURRENT_COMP,mask_setting);
            exit(1);
        }
    }
    
    for (loop_index=0;loop_index<global_geometry_list.num_elements;loop_index++) {
        // Add mask list
        if (1 == manual_linking_function(global_geometry_list.elements[loop_index].name,mask_string)) {
            add_element_to_int_list(&this_box_volume.geometry.mask_list,global_geometry_list.elements[loop_index].component_index);
            add_element_to_int_list(&global_geometry_list.elements[loop_index].Volume->geometry.masked_by_list,INDEX_CURRENT_COMP);
            global_geometry_list.elements[loop_index].Volume->geometry.is_masked_volume = 1;
            if (this_box_volume.geometry.mask_mode == 2)
                global_geometry_list.elements[loop_index].Volume->geometry.mask_mode = 2;
            if (this_box_volume.geometry.mask_mode == 1) {
                if (global_geometry_list.elements[loop_index].Volume->geometry.is_masked_volume == 1 && global_geometry_list.elements[loop_index].Volume->geometry.mask_mode != 2)
                    // If more than one mask is added to one volume, the ANY mode overwrites the (default) ALL mode.
                    global_geometry_list.elements[loop_index].Volume->geometry.mask_mode = 1;
            }
            
            found_geometries = 1;
        }
    }
    if (found_geometries == 0) {
        printf("The mask_string in geometry: %s did not find any of the specified volumes in the mask_string %s \n",NAME_CURRENT_COMP,mask_string);
        exit(1);
    }
    this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
    this_box_volume.p_physics->is_vacuum = 0; // Makes this volume a vacuum
    this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
    this_box_volume.p_physics->my_a = 0; // Should not be used.
    sprintf(this_box_volume.p_physics->name,"Mask");
    this_box_volume.geometry.is_mask_volume = 1;
    
    
// Read the material input, or if it lacks, use automatic linking.
} else if (material_string && strlen(material_string) && strcmp(material_string, "NULL") && strcmp(material_string, "0")) {
    // A geometry string was given, use it to determine which material
    if (0 == strcmp(material_string,"vacuum") || 0 == strcmp(material_string,"Vacuum")) {
        // One could have a global physics struct for vacuum instead of creating one for each
        this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
        this_box_volume.p_physics->is_vacuum = 1; // Makes this volume a vacuum
        this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
        this_box_volume.p_physics->my_a = 0; // Should not be used.
        sprintf(this_box_volume.p_physics->name,"Vacuum");
    } else if (0 == strcmp(material_string,"exit") || 0 == strcmp(material_string,"Exit")) {
        // One could have a global physics struct for vacuum instead of creating one for each
        this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
        this_box_volume.p_physics->is_vacuum = 1; // Makes this volume a vacuum
        this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
        this_box_volume.p_physics->my_a = 0; // Should not be used.
        this_box_volume.geometry.is_exit_volume = 1;
        sprintf(this_box_volume.p_physics->name,"Exit");
    } else {
        #ifndef MATERIAL_DETECTOR
            printf("Need to define a material before refering to it in a geometry %s.\n",NAME_CURRENT_COMP);
            exit(1);
        #endif
        for (loop_index=0;loop_index<global_material_list.num_elements;loop_index++) {
            if (0 == strcmp(material_string,global_material_list.elements[loop_index].name)) {
                this_box_volume.p_physics = global_material_list.elements[loop_index].physics;
                break;
            }
            if (loop_index == global_material_list.num_elements-1) {
            printf("\n");
            printf("ERROR: The material string \"%s\" in Union geometry \"%s\" did not match a specified material. \n",material_string,NAME_CURRENT_COMP);
            printf("       The materials available at this point (need to be defined before the geometry): \n");
            for (loop_index=0;loop_index<global_material_list.num_elements;loop_index++)
              printf("         %s\n",global_material_list.elements[loop_index].name);
            printf("\n");
            printf("       It is also possible to use one of the defualt materials avaiable: \n");
            printf("           Vacuum (for a Volume without scattering or absorption)\n");
            printf("           Exit (for a Volume where the ray exits the component if it enters)\n");
            printf("           Mask (for a Volume that masks existing volumes specified in the mask_string\n");
            exit(1);
          }
        }
    }
} else {
    // Automatic linking, simply using the last defined material.
    #ifndef MATERIAL_DETECTOR
        printf("Need to define a material before the geometry to use automatic linking %s.\n",NAME_CURRENT_COMP);
        exit(1);
    #endif
    this_box_volume.p_physics = global_material_list.elements[global_material_list.num_elements-1].physics;
}

sprintf(this_box_volume.name,NAME_CURRENT_COMP);
sprintf(this_box_volume.geometry.shape,"box");
this_box_volume.geometry.priority_value = priority;
this_box_volume.geometry.geometry_p_interact = p_interact;
// Currently the coordinates will be in absolute space.
this_box_volume.geometry.center = POS_A_CURRENT_COMP;

this_box_storage.z_depth = zdepth;
this_box_storage.x_width1 = xwidth;
this_box_storage.y_height1 = yheight;

this_box_storage.is_rectangle = 0;
if (xwidth2 < 0 && yheight2 < 0) this_box_storage.is_rectangle = 1;
if (xwidth == xwidth2 && yheight == yheight2) this_box_storage.is_rectangle = 1;

if (xwidth2 < 0) {
    this_box_storage.x_width2 = xwidth;
    xwidth2 = xwidth;
} else this_box_storage.x_width2 = xwidth2;

if (yheight2 < 0) {
    this_box_storage.y_height2 = yheight;
    yheight2 = yheight;
} else this_box_storage.y_height2 = yheight2;


this_box_storage.normal_vectors[0] = coords_set(0,0,1);
this_box_storage.normal_vectors[1] = coords_set(0,0,1);

// for sides with y component = 0
x_component = 2*zdepth/sqrt((xwidth-xwidth2)*(xwidth-xwidth2)+4*zdepth*zdepth);
z_component = (xwidth-xwidth2)/sqrt(4*zdepth*zdepth+(xwidth-xwidth2)*(xwidth-xwidth2));

this_box_storage.normal_vectors[2] = coords_set(x_component,0,z_component);
this_box_storage.normal_vectors[3] = coords_set(-x_component,0,z_component);

// for sides with x component = 0
y_component = 2*zdepth/sqrt((yheight-yheight2)*(yheight-yheight2)+4*zdepth*zdepth);
z_component = (yheight-yheight2)/sqrt(4*zdepth*zdepth+(yheight-yheight2)*(yheight-yheight2));

this_box_storage.normal_vectors[4] = coords_set(0,y_component,z_component);
this_box_storage.normal_vectors[5] = coords_set(0,-y_component,z_component);

this_box_volume.geometry.visualization_on = visualize;

this_box_volume.geometry.geometry_parameters.p_box_storage = &this_box_storage;

// Assign pointers to functions for intersection with the shape, checking if a point is inside the shape
if (this_box_storage.is_rectangle == 1) {
this_box_volume.geometry.intersect_function = &sample_box_intersect_simple;
this_box_volume.geometry.within_function = &r_within_box_simple;
}
else {
this_box_volume.geometry.intersect_function = &sample_box_intersect_advanced;
this_box_volume.geometry.within_function = &r_within_box_advanced;
}

this_box_volume.geometry.shell_points = &box_shell_points;
this_box_volume.geometry.mcdisplay_function = &mcdisplay_box_function;
this_box_volume.geometry.initialize_from_main_function = &initialize_box_geometry_from_main_component;
this_box_volume.geometry.process_rot_allocated = 0;

this_box_volume.geometry.copy_geometry_parameters = &allocate_box_storage_copy;

rot_copy(this_box_volume.geometry.rotation_matrix,ROT_A_CURRENT_COMP); //check how ROT_R_CURRENT_COMP would work
rot_transpose(ROT_A_CURRENT_COMP,this_box_volume.geometry.transpose_rotation_matrix);

// Initialize loggers
this_box_volume.loggers.num_elements = 0;

// packing the information into the global_geometry_element, which is then included in the global_geometry_list.
sprintf(global_geometry_element.name,NAME_CURRENT_COMP);
global_geometry_element.activation_counter = number_of_activations;
global_geometry_element.component_index = INDEX_CURRENT_COMP;
global_geometry_element.Volume = &this_box_volume; // Would be nicer if this m was a pointer, now we have the (small) data two places
add_element_to_geometry_list(&global_geometry_list,global_geometry_element);
}
#line 193826 "MACS_sample_kidney_box.c"
#undef number_of_activations
#undef mask_setting
#undef mask_string
#undef p_interact
#undef focus_r
#undef focus_xh
#undef focus_xw
#undef focus_ah
#undef focus_aw
#undef target_z
#undef target_y
#undef target_x
#undef target_index
#undef visualize
#undef yheight2
#undef xwidth2
#undef zdepth
#undef yheight
#undef xwidth
#undef priority
#undef material_string
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

  /* Initializations for component channel_3_analyzer_1_array_crystal_array_7. */
  SIG_MESSAGE("channel_3_analyzer_1_array_crystal_array_7 (Init)");
#define mccompcurname  channel_3_analyzer_1_array_crystal_array_7
#define mccompcurtype  Union_box
#define mccompcurindex 251
#define loop_index mccchannel_3_analyzer_1_array_crystal_array_7_loop_index
#define this_box_volume mccchannel_3_analyzer_1_array_crystal_array_7_this_box_volume
#define global_geometry_element mccchannel_3_analyzer_1_array_crystal_array_7_global_geometry_element
#define this_box_storage mccchannel_3_analyzer_1_array_crystal_array_7_this_box_storage
#define material_string mccchannel_3_analyzer_1_array_crystal_array_7_material_string
#define priority mccchannel_3_analyzer_1_array_crystal_array_7_priority
#define xwidth mccchannel_3_analyzer_1_array_crystal_array_7_xwidth
#define yheight mccchannel_3_analyzer_1_array_crystal_array_7_yheight
#define zdepth mccchannel_3_analyzer_1_array_crystal_array_7_zdepth
#define xwidth2 mccchannel_3_analyzer_1_array_crystal_array_7_xwidth2
#define yheight2 mccchannel_3_analyzer_1_array_crystal_array_7_yheight2
#define visualize mccchannel_3_analyzer_1_array_crystal_array_7_visualize
#define target_index mccchannel_3_analyzer_1_array_crystal_array_7_target_index
#define target_x mccchannel_3_analyzer_1_array_crystal_array_7_target_x
#define target_y mccchannel_3_analyzer_1_array_crystal_array_7_target_y
#define target_z mccchannel_3_analyzer_1_array_crystal_array_7_target_z
#define focus_aw mccchannel_3_analyzer_1_array_crystal_array_7_focus_aw
#define focus_ah mccchannel_3_analyzer_1_array_crystal_array_7_focus_ah
#define focus_xw mccchannel_3_analyzer_1_array_crystal_array_7_focus_xw
#define focus_xh mccchannel_3_analyzer_1_array_crystal_array_7_focus_xh
#define focus_r mccchannel_3_analyzer_1_array_crystal_array_7_focus_r
#define p_interact mccchannel_3_analyzer_1_array_crystal_array_7_p_interact
#define mask_string mccchannel_3_analyzer_1_array_crystal_array_7_mask_string
#define mask_setting mccchannel_3_analyzer_1_array_crystal_array_7_mask_setting
#define number_of_activations mccchannel_3_analyzer_1_array_crystal_array_7_number_of_activations
#line 224 "Union_box.comp"
{
// Initializes the focusing system for this volume including input sanitation.
focus_initialize(&this_box_volume.geometry, POS_A_COMP_INDEX(INDEX_CURRENT_COMP+target_index), POS_A_CURRENT_COMP, ROT_A_CURRENT_COMP, target_index, target_x, target_y, target_z, focus_aw, focus_ah, focus_xw, focus_xh, focus_r, NAME_CURRENT_COMP);

// Input sanitation for this geometry
if (xwidth <= 0) {
  printf("\nERROR in Union_box named %s, the xwidth is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (yheight <= 0) {
  printf("\nERROR in Union_box named %s, yheight is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (zdepth <= 0) {
  printf("\nERROR in Union_box named %s, zdepth is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (xwidth2 <= 0 && xwidth2 != -1) {
  printf("\nERROR in Union_box named %s, the xwidth2 is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (yheight2 <= 0 && yheight2 != -1) {
  printf("\nERROR in Union_box named %s, yheight2 is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}

// Use sanitation
if (global_material_list.num_elements == 0) {
  printf("\nERROR: Need to define a material using Union_make_material before using a Union geometry component. \n");
  printf("       %s was defined before first use of Union_make_material.\n",NAME_CURRENT_COMP);
  exit(1);
}

this_box_volume.geometry.is_masked_volume = 0;
this_box_volume.geometry.is_exit_volume = 0;
this_box_volume.geometry.is_mask_volume = 0;
// check if the volume is a mask, if it is the material string is irelevant.
if (mask_string && strlen(mask_string) && strcmp(mask_string, "NULL") && strcmp(mask_string, "0")) {
    // A mask volume is used to limit the extend of other volumes, called the masked volumes. These are specified in the mask_string.
    // In order for a ray to enter a masked volume, it needs to be both in the region covered by that volume AND the mask volume.
    // When more than
    this_box_volume.geometry.mask_mode = 1; // Default is mask mode is ALL
    if (mask_setting && strlen(mask_setting) && strcmp(mask_setting, "NULL") && strcmp(mask_setting, "0")) {
        if (strcmp(mask_setting,"ALL") == 0 || strcmp(mask_setting,"All") == 0) this_box_volume.geometry.mask_mode = 1;
        else if (strcmp(mask_setting,"ANY") == 0 || strcmp(mask_setting,"Any") == 0) this_box_volume.geometry.mask_mode = 2;
        else {
            printf("The mask_mode of component %s is set to %s, but must be either ALL or ANY.\n",NAME_CURRENT_COMP,mask_setting);
            exit(1);
        }
    }
    
    for (loop_index=0;loop_index<global_geometry_list.num_elements;loop_index++) {
        // Add mask list
        if (1 == manual_linking_function(global_geometry_list.elements[loop_index].name,mask_string)) {
            add_element_to_int_list(&this_box_volume.geometry.mask_list,global_geometry_list.elements[loop_index].component_index);
            add_element_to_int_list(&global_geometry_list.elements[loop_index].Volume->geometry.masked_by_list,INDEX_CURRENT_COMP);
            global_geometry_list.elements[loop_index].Volume->geometry.is_masked_volume = 1;
            if (this_box_volume.geometry.mask_mode == 2)
                global_geometry_list.elements[loop_index].Volume->geometry.mask_mode = 2;
            if (this_box_volume.geometry.mask_mode == 1) {
                if (global_geometry_list.elements[loop_index].Volume->geometry.is_masked_volume == 1 && global_geometry_list.elements[loop_index].Volume->geometry.mask_mode != 2)
                    // If more than one mask is added to one volume, the ANY mode overwrites the (default) ALL mode.
                    global_geometry_list.elements[loop_index].Volume->geometry.mask_mode = 1;
            }
            
            found_geometries = 1;
        }
    }
    if (found_geometries == 0) {
        printf("The mask_string in geometry: %s did not find any of the specified volumes in the mask_string %s \n",NAME_CURRENT_COMP,mask_string);
        exit(1);
    }
    this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
    this_box_volume.p_physics->is_vacuum = 0; // Makes this volume a vacuum
    this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
    this_box_volume.p_physics->my_a = 0; // Should not be used.
    sprintf(this_box_volume.p_physics->name,"Mask");
    this_box_volume.geometry.is_mask_volume = 1;
    
    
// Read the material input, or if it lacks, use automatic linking.
} else if (material_string && strlen(material_string) && strcmp(material_string, "NULL") && strcmp(material_string, "0")) {
    // A geometry string was given, use it to determine which material
    if (0 == strcmp(material_string,"vacuum") || 0 == strcmp(material_string,"Vacuum")) {
        // One could have a global physics struct for vacuum instead of creating one for each
        this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
        this_box_volume.p_physics->is_vacuum = 1; // Makes this volume a vacuum
        this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
        this_box_volume.p_physics->my_a = 0; // Should not be used.
        sprintf(this_box_volume.p_physics->name,"Vacuum");
    } else if (0 == strcmp(material_string,"exit") || 0 == strcmp(material_string,"Exit")) {
        // One could have a global physics struct for vacuum instead of creating one for each
        this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
        this_box_volume.p_physics->is_vacuum = 1; // Makes this volume a vacuum
        this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
        this_box_volume.p_physics->my_a = 0; // Should not be used.
        this_box_volume.geometry.is_exit_volume = 1;
        sprintf(this_box_volume.p_physics->name,"Exit");
    } else {
        #ifndef MATERIAL_DETECTOR
            printf("Need to define a material before refering to it in a geometry %s.\n",NAME_CURRENT_COMP);
            exit(1);
        #endif
        for (loop_index=0;loop_index<global_material_list.num_elements;loop_index++) {
            if (0 == strcmp(material_string,global_material_list.elements[loop_index].name)) {
                this_box_volume.p_physics = global_material_list.elements[loop_index].physics;
                break;
            }
            if (loop_index == global_material_list.num_elements-1) {
            printf("\n");
            printf("ERROR: The material string \"%s\" in Union geometry \"%s\" did not match a specified material. \n",material_string,NAME_CURRENT_COMP);
            printf("       The materials available at this point (need to be defined before the geometry): \n");
            for (loop_index=0;loop_index<global_material_list.num_elements;loop_index++)
              printf("         %s\n",global_material_list.elements[loop_index].name);
            printf("\n");
            printf("       It is also possible to use one of the defualt materials avaiable: \n");
            printf("           Vacuum (for a Volume without scattering or absorption)\n");
            printf("           Exit (for a Volume where the ray exits the component if it enters)\n");
            printf("           Mask (for a Volume that masks existing volumes specified in the mask_string\n");
            exit(1);
          }
        }
    }
} else {
    // Automatic linking, simply using the last defined material.
    #ifndef MATERIAL_DETECTOR
        printf("Need to define a material before the geometry to use automatic linking %s.\n",NAME_CURRENT_COMP);
        exit(1);
    #endif
    this_box_volume.p_physics = global_material_list.elements[global_material_list.num_elements-1].physics;
}

sprintf(this_box_volume.name,NAME_CURRENT_COMP);
sprintf(this_box_volume.geometry.shape,"box");
this_box_volume.geometry.priority_value = priority;
this_box_volume.geometry.geometry_p_interact = p_interact;
// Currently the coordinates will be in absolute space.
this_box_volume.geometry.center = POS_A_CURRENT_COMP;

this_box_storage.z_depth = zdepth;
this_box_storage.x_width1 = xwidth;
this_box_storage.y_height1 = yheight;

this_box_storage.is_rectangle = 0;
if (xwidth2 < 0 && yheight2 < 0) this_box_storage.is_rectangle = 1;
if (xwidth == xwidth2 && yheight == yheight2) this_box_storage.is_rectangle = 1;

if (xwidth2 < 0) {
    this_box_storage.x_width2 = xwidth;
    xwidth2 = xwidth;
} else this_box_storage.x_width2 = xwidth2;

if (yheight2 < 0) {
    this_box_storage.y_height2 = yheight;
    yheight2 = yheight;
} else this_box_storage.y_height2 = yheight2;


this_box_storage.normal_vectors[0] = coords_set(0,0,1);
this_box_storage.normal_vectors[1] = coords_set(0,0,1);

// for sides with y component = 0
x_component = 2*zdepth/sqrt((xwidth-xwidth2)*(xwidth-xwidth2)+4*zdepth*zdepth);
z_component = (xwidth-xwidth2)/sqrt(4*zdepth*zdepth+(xwidth-xwidth2)*(xwidth-xwidth2));

this_box_storage.normal_vectors[2] = coords_set(x_component,0,z_component);
this_box_storage.normal_vectors[3] = coords_set(-x_component,0,z_component);

// for sides with x component = 0
y_component = 2*zdepth/sqrt((yheight-yheight2)*(yheight-yheight2)+4*zdepth*zdepth);
z_component = (yheight-yheight2)/sqrt(4*zdepth*zdepth+(yheight-yheight2)*(yheight-yheight2));

this_box_storage.normal_vectors[4] = coords_set(0,y_component,z_component);
this_box_storage.normal_vectors[5] = coords_set(0,-y_component,z_component);

this_box_volume.geometry.visualization_on = visualize;

this_box_volume.geometry.geometry_parameters.p_box_storage = &this_box_storage;

// Assign pointers to functions for intersection with the shape, checking if a point is inside the shape
if (this_box_storage.is_rectangle == 1) {
this_box_volume.geometry.intersect_function = &sample_box_intersect_simple;
this_box_volume.geometry.within_function = &r_within_box_simple;
}
else {
this_box_volume.geometry.intersect_function = &sample_box_intersect_advanced;
this_box_volume.geometry.within_function = &r_within_box_advanced;
}

this_box_volume.geometry.shell_points = &box_shell_points;
this_box_volume.geometry.mcdisplay_function = &mcdisplay_box_function;
this_box_volume.geometry.initialize_from_main_function = &initialize_box_geometry_from_main_component;
this_box_volume.geometry.process_rot_allocated = 0;

this_box_volume.geometry.copy_geometry_parameters = &allocate_box_storage_copy;

rot_copy(this_box_volume.geometry.rotation_matrix,ROT_A_CURRENT_COMP); //check how ROT_R_CURRENT_COMP would work
rot_transpose(ROT_A_CURRENT_COMP,this_box_volume.geometry.transpose_rotation_matrix);

// Initialize loggers
this_box_volume.loggers.num_elements = 0;

// packing the information into the global_geometry_element, which is then included in the global_geometry_list.
sprintf(global_geometry_element.name,NAME_CURRENT_COMP);
global_geometry_element.activation_counter = number_of_activations;
global_geometry_element.component_index = INDEX_CURRENT_COMP;
global_geometry_element.Volume = &this_box_volume; // Would be nicer if this m was a pointer, now we have the (small) data two places
add_element_to_geometry_list(&global_geometry_list,global_geometry_element);
}
#line 194096 "MACS_sample_kidney_box.c"
#undef number_of_activations
#undef mask_setting
#undef mask_string
#undef p_interact
#undef focus_r
#undef focus_xh
#undef focus_xw
#undef focus_ah
#undef focus_aw
#undef target_z
#undef target_y
#undef target_x
#undef target_index
#undef visualize
#undef yheight2
#undef xwidth2
#undef zdepth
#undef yheight
#undef xwidth
#undef priority
#undef material_string
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

  /* Initializations for component channel_3_analyzer_1_array_crystal_array_8. */
  SIG_MESSAGE("channel_3_analyzer_1_array_crystal_array_8 (Init)");
#define mccompcurname  channel_3_analyzer_1_array_crystal_array_8
#define mccompcurtype  Union_box
#define mccompcurindex 252
#define loop_index mccchannel_3_analyzer_1_array_crystal_array_8_loop_index
#define this_box_volume mccchannel_3_analyzer_1_array_crystal_array_8_this_box_volume
#define global_geometry_element mccchannel_3_analyzer_1_array_crystal_array_8_global_geometry_element
#define this_box_storage mccchannel_3_analyzer_1_array_crystal_array_8_this_box_storage
#define material_string mccchannel_3_analyzer_1_array_crystal_array_8_material_string
#define priority mccchannel_3_analyzer_1_array_crystal_array_8_priority
#define xwidth mccchannel_3_analyzer_1_array_crystal_array_8_xwidth
#define yheight mccchannel_3_analyzer_1_array_crystal_array_8_yheight
#define zdepth mccchannel_3_analyzer_1_array_crystal_array_8_zdepth
#define xwidth2 mccchannel_3_analyzer_1_array_crystal_array_8_xwidth2
#define yheight2 mccchannel_3_analyzer_1_array_crystal_array_8_yheight2
#define visualize mccchannel_3_analyzer_1_array_crystal_array_8_visualize
#define target_index mccchannel_3_analyzer_1_array_crystal_array_8_target_index
#define target_x mccchannel_3_analyzer_1_array_crystal_array_8_target_x
#define target_y mccchannel_3_analyzer_1_array_crystal_array_8_target_y
#define target_z mccchannel_3_analyzer_1_array_crystal_array_8_target_z
#define focus_aw mccchannel_3_analyzer_1_array_crystal_array_8_focus_aw
#define focus_ah mccchannel_3_analyzer_1_array_crystal_array_8_focus_ah
#define focus_xw mccchannel_3_analyzer_1_array_crystal_array_8_focus_xw
#define focus_xh mccchannel_3_analyzer_1_array_crystal_array_8_focus_xh
#define focus_r mccchannel_3_analyzer_1_array_crystal_array_8_focus_r
#define p_interact mccchannel_3_analyzer_1_array_crystal_array_8_p_interact
#define mask_string mccchannel_3_analyzer_1_array_crystal_array_8_mask_string
#define mask_setting mccchannel_3_analyzer_1_array_crystal_array_8_mask_setting
#define number_of_activations mccchannel_3_analyzer_1_array_crystal_array_8_number_of_activations
#line 224 "Union_box.comp"
{
// Initializes the focusing system for this volume including input sanitation.
focus_initialize(&this_box_volume.geometry, POS_A_COMP_INDEX(INDEX_CURRENT_COMP+target_index), POS_A_CURRENT_COMP, ROT_A_CURRENT_COMP, target_index, target_x, target_y, target_z, focus_aw, focus_ah, focus_xw, focus_xh, focus_r, NAME_CURRENT_COMP);

// Input sanitation for this geometry
if (xwidth <= 0) {
  printf("\nERROR in Union_box named %s, the xwidth is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (yheight <= 0) {
  printf("\nERROR in Union_box named %s, yheight is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (zdepth <= 0) {
  printf("\nERROR in Union_box named %s, zdepth is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (xwidth2 <= 0 && xwidth2 != -1) {
  printf("\nERROR in Union_box named %s, the xwidth2 is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (yheight2 <= 0 && yheight2 != -1) {
  printf("\nERROR in Union_box named %s, yheight2 is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}

// Use sanitation
if (global_material_list.num_elements == 0) {
  printf("\nERROR: Need to define a material using Union_make_material before using a Union geometry component. \n");
  printf("       %s was defined before first use of Union_make_material.\n",NAME_CURRENT_COMP);
  exit(1);
}

this_box_volume.geometry.is_masked_volume = 0;
this_box_volume.geometry.is_exit_volume = 0;
this_box_volume.geometry.is_mask_volume = 0;
// check if the volume is a mask, if it is the material string is irelevant.
if (mask_string && strlen(mask_string) && strcmp(mask_string, "NULL") && strcmp(mask_string, "0")) {
    // A mask volume is used to limit the extend of other volumes, called the masked volumes. These are specified in the mask_string.
    // In order for a ray to enter a masked volume, it needs to be both in the region covered by that volume AND the mask volume.
    // When more than
    this_box_volume.geometry.mask_mode = 1; // Default is mask mode is ALL
    if (mask_setting && strlen(mask_setting) && strcmp(mask_setting, "NULL") && strcmp(mask_setting, "0")) {
        if (strcmp(mask_setting,"ALL") == 0 || strcmp(mask_setting,"All") == 0) this_box_volume.geometry.mask_mode = 1;
        else if (strcmp(mask_setting,"ANY") == 0 || strcmp(mask_setting,"Any") == 0) this_box_volume.geometry.mask_mode = 2;
        else {
            printf("The mask_mode of component %s is set to %s, but must be either ALL or ANY.\n",NAME_CURRENT_COMP,mask_setting);
            exit(1);
        }
    }
    
    for (loop_index=0;loop_index<global_geometry_list.num_elements;loop_index++) {
        // Add mask list
        if (1 == manual_linking_function(global_geometry_list.elements[loop_index].name,mask_string)) {
            add_element_to_int_list(&this_box_volume.geometry.mask_list,global_geometry_list.elements[loop_index].component_index);
            add_element_to_int_list(&global_geometry_list.elements[loop_index].Volume->geometry.masked_by_list,INDEX_CURRENT_COMP);
            global_geometry_list.elements[loop_index].Volume->geometry.is_masked_volume = 1;
            if (this_box_volume.geometry.mask_mode == 2)
                global_geometry_list.elements[loop_index].Volume->geometry.mask_mode = 2;
            if (this_box_volume.geometry.mask_mode == 1) {
                if (global_geometry_list.elements[loop_index].Volume->geometry.is_masked_volume == 1 && global_geometry_list.elements[loop_index].Volume->geometry.mask_mode != 2)
                    // If more than one mask is added to one volume, the ANY mode overwrites the (default) ALL mode.
                    global_geometry_list.elements[loop_index].Volume->geometry.mask_mode = 1;
            }
            
            found_geometries = 1;
        }
    }
    if (found_geometries == 0) {
        printf("The mask_string in geometry: %s did not find any of the specified volumes in the mask_string %s \n",NAME_CURRENT_COMP,mask_string);
        exit(1);
    }
    this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
    this_box_volume.p_physics->is_vacuum = 0; // Makes this volume a vacuum
    this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
    this_box_volume.p_physics->my_a = 0; // Should not be used.
    sprintf(this_box_volume.p_physics->name,"Mask");
    this_box_volume.geometry.is_mask_volume = 1;
    
    
// Read the material input, or if it lacks, use automatic linking.
} else if (material_string && strlen(material_string) && strcmp(material_string, "NULL") && strcmp(material_string, "0")) {
    // A geometry string was given, use it to determine which material
    if (0 == strcmp(material_string,"vacuum") || 0 == strcmp(material_string,"Vacuum")) {
        // One could have a global physics struct for vacuum instead of creating one for each
        this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
        this_box_volume.p_physics->is_vacuum = 1; // Makes this volume a vacuum
        this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
        this_box_volume.p_physics->my_a = 0; // Should not be used.
        sprintf(this_box_volume.p_physics->name,"Vacuum");
    } else if (0 == strcmp(material_string,"exit") || 0 == strcmp(material_string,"Exit")) {
        // One could have a global physics struct for vacuum instead of creating one for each
        this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
        this_box_volume.p_physics->is_vacuum = 1; // Makes this volume a vacuum
        this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
        this_box_volume.p_physics->my_a = 0; // Should not be used.
        this_box_volume.geometry.is_exit_volume = 1;
        sprintf(this_box_volume.p_physics->name,"Exit");
    } else {
        #ifndef MATERIAL_DETECTOR
            printf("Need to define a material before refering to it in a geometry %s.\n",NAME_CURRENT_COMP);
            exit(1);
        #endif
        for (loop_index=0;loop_index<global_material_list.num_elements;loop_index++) {
            if (0 == strcmp(material_string,global_material_list.elements[loop_index].name)) {
                this_box_volume.p_physics = global_material_list.elements[loop_index].physics;
                break;
            }
            if (loop_index == global_material_list.num_elements-1) {
            printf("\n");
            printf("ERROR: The material string \"%s\" in Union geometry \"%s\" did not match a specified material. \n",material_string,NAME_CURRENT_COMP);
            printf("       The materials available at this point (need to be defined before the geometry): \n");
            for (loop_index=0;loop_index<global_material_list.num_elements;loop_index++)
              printf("         %s\n",global_material_list.elements[loop_index].name);
            printf("\n");
            printf("       It is also possible to use one of the defualt materials avaiable: \n");
            printf("           Vacuum (for a Volume without scattering or absorption)\n");
            printf("           Exit (for a Volume where the ray exits the component if it enters)\n");
            printf("           Mask (for a Volume that masks existing volumes specified in the mask_string\n");
            exit(1);
          }
        }
    }
} else {
    // Automatic linking, simply using the last defined material.
    #ifndef MATERIAL_DETECTOR
        printf("Need to define a material before the geometry to use automatic linking %s.\n",NAME_CURRENT_COMP);
        exit(1);
    #endif
    this_box_volume.p_physics = global_material_list.elements[global_material_list.num_elements-1].physics;
}

sprintf(this_box_volume.name,NAME_CURRENT_COMP);
sprintf(this_box_volume.geometry.shape,"box");
this_box_volume.geometry.priority_value = priority;
this_box_volume.geometry.geometry_p_interact = p_interact;
// Currently the coordinates will be in absolute space.
this_box_volume.geometry.center = POS_A_CURRENT_COMP;

this_box_storage.z_depth = zdepth;
this_box_storage.x_width1 = xwidth;
this_box_storage.y_height1 = yheight;

this_box_storage.is_rectangle = 0;
if (xwidth2 < 0 && yheight2 < 0) this_box_storage.is_rectangle = 1;
if (xwidth == xwidth2 && yheight == yheight2) this_box_storage.is_rectangle = 1;

if (xwidth2 < 0) {
    this_box_storage.x_width2 = xwidth;
    xwidth2 = xwidth;
} else this_box_storage.x_width2 = xwidth2;

if (yheight2 < 0) {
    this_box_storage.y_height2 = yheight;
    yheight2 = yheight;
} else this_box_storage.y_height2 = yheight2;


this_box_storage.normal_vectors[0] = coords_set(0,0,1);
this_box_storage.normal_vectors[1] = coords_set(0,0,1);

// for sides with y component = 0
x_component = 2*zdepth/sqrt((xwidth-xwidth2)*(xwidth-xwidth2)+4*zdepth*zdepth);
z_component = (xwidth-xwidth2)/sqrt(4*zdepth*zdepth+(xwidth-xwidth2)*(xwidth-xwidth2));

this_box_storage.normal_vectors[2] = coords_set(x_component,0,z_component);
this_box_storage.normal_vectors[3] = coords_set(-x_component,0,z_component);

// for sides with x component = 0
y_component = 2*zdepth/sqrt((yheight-yheight2)*(yheight-yheight2)+4*zdepth*zdepth);
z_component = (yheight-yheight2)/sqrt(4*zdepth*zdepth+(yheight-yheight2)*(yheight-yheight2));

this_box_storage.normal_vectors[4] = coords_set(0,y_component,z_component);
this_box_storage.normal_vectors[5] = coords_set(0,-y_component,z_component);

this_box_volume.geometry.visualization_on = visualize;

this_box_volume.geometry.geometry_parameters.p_box_storage = &this_box_storage;

// Assign pointers to functions for intersection with the shape, checking if a point is inside the shape
if (this_box_storage.is_rectangle == 1) {
this_box_volume.geometry.intersect_function = &sample_box_intersect_simple;
this_box_volume.geometry.within_function = &r_within_box_simple;
}
else {
this_box_volume.geometry.intersect_function = &sample_box_intersect_advanced;
this_box_volume.geometry.within_function = &r_within_box_advanced;
}

this_box_volume.geometry.shell_points = &box_shell_points;
this_box_volume.geometry.mcdisplay_function = &mcdisplay_box_function;
this_box_volume.geometry.initialize_from_main_function = &initialize_box_geometry_from_main_component;
this_box_volume.geometry.process_rot_allocated = 0;

this_box_volume.geometry.copy_geometry_parameters = &allocate_box_storage_copy;

rot_copy(this_box_volume.geometry.rotation_matrix,ROT_A_CURRENT_COMP); //check how ROT_R_CURRENT_COMP would work
rot_transpose(ROT_A_CURRENT_COMP,this_box_volume.geometry.transpose_rotation_matrix);

// Initialize loggers
this_box_volume.loggers.num_elements = 0;

// packing the information into the global_geometry_element, which is then included in the global_geometry_list.
sprintf(global_geometry_element.name,NAME_CURRENT_COMP);
global_geometry_element.activation_counter = number_of_activations;
global_geometry_element.component_index = INDEX_CURRENT_COMP;
global_geometry_element.Volume = &this_box_volume; // Would be nicer if this m was a pointer, now we have the (small) data two places
add_element_to_geometry_list(&global_geometry_list,global_geometry_element);
}
#line 194366 "MACS_sample_kidney_box.c"
#undef number_of_activations
#undef mask_setting
#undef mask_string
#undef p_interact
#undef focus_r
#undef focus_xh
#undef focus_xw
#undef focus_ah
#undef focus_aw
#undef target_z
#undef target_y
#undef target_x
#undef target_index
#undef visualize
#undef yheight2
#undef xwidth2
#undef zdepth
#undef yheight
#undef xwidth
#undef priority
#undef material_string
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

  /* Initializations for component channel_3_analyzer_2_center. */
  SIG_MESSAGE("channel_3_analyzer_2_center (Init)");

  /* Initializations for component channel_3_analyzer_2_rotated. */
  SIG_MESSAGE("channel_3_analyzer_2_rotated (Init)");

  /* Initializations for component channel_3_analyzer_2_array_crystal_array_0. */
  SIG_MESSAGE("channel_3_analyzer_2_array_crystal_array_0 (Init)");
#define mccompcurname  channel_3_analyzer_2_array_crystal_array_0
#define mccompcurtype  Union_box
#define mccompcurindex 255
#define loop_index mccchannel_3_analyzer_2_array_crystal_array_0_loop_index
#define this_box_volume mccchannel_3_analyzer_2_array_crystal_array_0_this_box_volume
#define global_geometry_element mccchannel_3_analyzer_2_array_crystal_array_0_global_geometry_element
#define this_box_storage mccchannel_3_analyzer_2_array_crystal_array_0_this_box_storage
#define material_string mccchannel_3_analyzer_2_array_crystal_array_0_material_string
#define priority mccchannel_3_analyzer_2_array_crystal_array_0_priority
#define xwidth mccchannel_3_analyzer_2_array_crystal_array_0_xwidth
#define yheight mccchannel_3_analyzer_2_array_crystal_array_0_yheight
#define zdepth mccchannel_3_analyzer_2_array_crystal_array_0_zdepth
#define xwidth2 mccchannel_3_analyzer_2_array_crystal_array_0_xwidth2
#define yheight2 mccchannel_3_analyzer_2_array_crystal_array_0_yheight2
#define visualize mccchannel_3_analyzer_2_array_crystal_array_0_visualize
#define target_index mccchannel_3_analyzer_2_array_crystal_array_0_target_index
#define target_x mccchannel_3_analyzer_2_array_crystal_array_0_target_x
#define target_y mccchannel_3_analyzer_2_array_crystal_array_0_target_y
#define target_z mccchannel_3_analyzer_2_array_crystal_array_0_target_z
#define focus_aw mccchannel_3_analyzer_2_array_crystal_array_0_focus_aw
#define focus_ah mccchannel_3_analyzer_2_array_crystal_array_0_focus_ah
#define focus_xw mccchannel_3_analyzer_2_array_crystal_array_0_focus_xw
#define focus_xh mccchannel_3_analyzer_2_array_crystal_array_0_focus_xh
#define focus_r mccchannel_3_analyzer_2_array_crystal_array_0_focus_r
#define p_interact mccchannel_3_analyzer_2_array_crystal_array_0_p_interact
#define mask_string mccchannel_3_analyzer_2_array_crystal_array_0_mask_string
#define mask_setting mccchannel_3_analyzer_2_array_crystal_array_0_mask_setting
#define number_of_activations mccchannel_3_analyzer_2_array_crystal_array_0_number_of_activations
#line 224 "Union_box.comp"
{
// Initializes the focusing system for this volume including input sanitation.
focus_initialize(&this_box_volume.geometry, POS_A_COMP_INDEX(INDEX_CURRENT_COMP+target_index), POS_A_CURRENT_COMP, ROT_A_CURRENT_COMP, target_index, target_x, target_y, target_z, focus_aw, focus_ah, focus_xw, focus_xh, focus_r, NAME_CURRENT_COMP);

// Input sanitation for this geometry
if (xwidth <= 0) {
  printf("\nERROR in Union_box named %s, the xwidth is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (yheight <= 0) {
  printf("\nERROR in Union_box named %s, yheight is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (zdepth <= 0) {
  printf("\nERROR in Union_box named %s, zdepth is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (xwidth2 <= 0 && xwidth2 != -1) {
  printf("\nERROR in Union_box named %s, the xwidth2 is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (yheight2 <= 0 && yheight2 != -1) {
  printf("\nERROR in Union_box named %s, yheight2 is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}

// Use sanitation
if (global_material_list.num_elements == 0) {
  printf("\nERROR: Need to define a material using Union_make_material before using a Union geometry component. \n");
  printf("       %s was defined before first use of Union_make_material.\n",NAME_CURRENT_COMP);
  exit(1);
}

this_box_volume.geometry.is_masked_volume = 0;
this_box_volume.geometry.is_exit_volume = 0;
this_box_volume.geometry.is_mask_volume = 0;
// check if the volume is a mask, if it is the material string is irelevant.
if (mask_string && strlen(mask_string) && strcmp(mask_string, "NULL") && strcmp(mask_string, "0")) {
    // A mask volume is used to limit the extend of other volumes, called the masked volumes. These are specified in the mask_string.
    // In order for a ray to enter a masked volume, it needs to be both in the region covered by that volume AND the mask volume.
    // When more than
    this_box_volume.geometry.mask_mode = 1; // Default is mask mode is ALL
    if (mask_setting && strlen(mask_setting) && strcmp(mask_setting, "NULL") && strcmp(mask_setting, "0")) {
        if (strcmp(mask_setting,"ALL") == 0 || strcmp(mask_setting,"All") == 0) this_box_volume.geometry.mask_mode = 1;
        else if (strcmp(mask_setting,"ANY") == 0 || strcmp(mask_setting,"Any") == 0) this_box_volume.geometry.mask_mode = 2;
        else {
            printf("The mask_mode of component %s is set to %s, but must be either ALL or ANY.\n",NAME_CURRENT_COMP,mask_setting);
            exit(1);
        }
    }
    
    for (loop_index=0;loop_index<global_geometry_list.num_elements;loop_index++) {
        // Add mask list
        if (1 == manual_linking_function(global_geometry_list.elements[loop_index].name,mask_string)) {
            add_element_to_int_list(&this_box_volume.geometry.mask_list,global_geometry_list.elements[loop_index].component_index);
            add_element_to_int_list(&global_geometry_list.elements[loop_index].Volume->geometry.masked_by_list,INDEX_CURRENT_COMP);
            global_geometry_list.elements[loop_index].Volume->geometry.is_masked_volume = 1;
            if (this_box_volume.geometry.mask_mode == 2)
                global_geometry_list.elements[loop_index].Volume->geometry.mask_mode = 2;
            if (this_box_volume.geometry.mask_mode == 1) {
                if (global_geometry_list.elements[loop_index].Volume->geometry.is_masked_volume == 1 && global_geometry_list.elements[loop_index].Volume->geometry.mask_mode != 2)
                    // If more than one mask is added to one volume, the ANY mode overwrites the (default) ALL mode.
                    global_geometry_list.elements[loop_index].Volume->geometry.mask_mode = 1;
            }
            
            found_geometries = 1;
        }
    }
    if (found_geometries == 0) {
        printf("The mask_string in geometry: %s did not find any of the specified volumes in the mask_string %s \n",NAME_CURRENT_COMP,mask_string);
        exit(1);
    }
    this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
    this_box_volume.p_physics->is_vacuum = 0; // Makes this volume a vacuum
    this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
    this_box_volume.p_physics->my_a = 0; // Should not be used.
    sprintf(this_box_volume.p_physics->name,"Mask");
    this_box_volume.geometry.is_mask_volume = 1;
    
    
// Read the material input, or if it lacks, use automatic linking.
} else if (material_string && strlen(material_string) && strcmp(material_string, "NULL") && strcmp(material_string, "0")) {
    // A geometry string was given, use it to determine which material
    if (0 == strcmp(material_string,"vacuum") || 0 == strcmp(material_string,"Vacuum")) {
        // One could have a global physics struct for vacuum instead of creating one for each
        this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
        this_box_volume.p_physics->is_vacuum = 1; // Makes this volume a vacuum
        this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
        this_box_volume.p_physics->my_a = 0; // Should not be used.
        sprintf(this_box_volume.p_physics->name,"Vacuum");
    } else if (0 == strcmp(material_string,"exit") || 0 == strcmp(material_string,"Exit")) {
        // One could have a global physics struct for vacuum instead of creating one for each
        this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
        this_box_volume.p_physics->is_vacuum = 1; // Makes this volume a vacuum
        this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
        this_box_volume.p_physics->my_a = 0; // Should not be used.
        this_box_volume.geometry.is_exit_volume = 1;
        sprintf(this_box_volume.p_physics->name,"Exit");
    } else {
        #ifndef MATERIAL_DETECTOR
            printf("Need to define a material before refering to it in a geometry %s.\n",NAME_CURRENT_COMP);
            exit(1);
        #endif
        for (loop_index=0;loop_index<global_material_list.num_elements;loop_index++) {
            if (0 == strcmp(material_string,global_material_list.elements[loop_index].name)) {
                this_box_volume.p_physics = global_material_list.elements[loop_index].physics;
                break;
            }
            if (loop_index == global_material_list.num_elements-1) {
            printf("\n");
            printf("ERROR: The material string \"%s\" in Union geometry \"%s\" did not match a specified material. \n",material_string,NAME_CURRENT_COMP);
            printf("       The materials available at this point (need to be defined before the geometry): \n");
            for (loop_index=0;loop_index<global_material_list.num_elements;loop_index++)
              printf("         %s\n",global_material_list.elements[loop_index].name);
            printf("\n");
            printf("       It is also possible to use one of the defualt materials avaiable: \n");
            printf("           Vacuum (for a Volume without scattering or absorption)\n");
            printf("           Exit (for a Volume where the ray exits the component if it enters)\n");
            printf("           Mask (for a Volume that masks existing volumes specified in the mask_string\n");
            exit(1);
          }
        }
    }
} else {
    // Automatic linking, simply using the last defined material.
    #ifndef MATERIAL_DETECTOR
        printf("Need to define a material before the geometry to use automatic linking %s.\n",NAME_CURRENT_COMP);
        exit(1);
    #endif
    this_box_volume.p_physics = global_material_list.elements[global_material_list.num_elements-1].physics;
}

sprintf(this_box_volume.name,NAME_CURRENT_COMP);
sprintf(this_box_volume.geometry.shape,"box");
this_box_volume.geometry.priority_value = priority;
this_box_volume.geometry.geometry_p_interact = p_interact;
// Currently the coordinates will be in absolute space.
this_box_volume.geometry.center = POS_A_CURRENT_COMP;

this_box_storage.z_depth = zdepth;
this_box_storage.x_width1 = xwidth;
this_box_storage.y_height1 = yheight;

this_box_storage.is_rectangle = 0;
if (xwidth2 < 0 && yheight2 < 0) this_box_storage.is_rectangle = 1;
if (xwidth == xwidth2 && yheight == yheight2) this_box_storage.is_rectangle = 1;

if (xwidth2 < 0) {
    this_box_storage.x_width2 = xwidth;
    xwidth2 = xwidth;
} else this_box_storage.x_width2 = xwidth2;

if (yheight2 < 0) {
    this_box_storage.y_height2 = yheight;
    yheight2 = yheight;
} else this_box_storage.y_height2 = yheight2;


this_box_storage.normal_vectors[0] = coords_set(0,0,1);
this_box_storage.normal_vectors[1] = coords_set(0,0,1);

// for sides with y component = 0
x_component = 2*zdepth/sqrt((xwidth-xwidth2)*(xwidth-xwidth2)+4*zdepth*zdepth);
z_component = (xwidth-xwidth2)/sqrt(4*zdepth*zdepth+(xwidth-xwidth2)*(xwidth-xwidth2));

this_box_storage.normal_vectors[2] = coords_set(x_component,0,z_component);
this_box_storage.normal_vectors[3] = coords_set(-x_component,0,z_component);

// for sides with x component = 0
y_component = 2*zdepth/sqrt((yheight-yheight2)*(yheight-yheight2)+4*zdepth*zdepth);
z_component = (yheight-yheight2)/sqrt(4*zdepth*zdepth+(yheight-yheight2)*(yheight-yheight2));

this_box_storage.normal_vectors[4] = coords_set(0,y_component,z_component);
this_box_storage.normal_vectors[5] = coords_set(0,-y_component,z_component);

this_box_volume.geometry.visualization_on = visualize;

this_box_volume.geometry.geometry_parameters.p_box_storage = &this_box_storage;

// Assign pointers to functions for intersection with the shape, checking if a point is inside the shape
if (this_box_storage.is_rectangle == 1) {
this_box_volume.geometry.intersect_function = &sample_box_intersect_simple;
this_box_volume.geometry.within_function = &r_within_box_simple;
}
else {
this_box_volume.geometry.intersect_function = &sample_box_intersect_advanced;
this_box_volume.geometry.within_function = &r_within_box_advanced;
}

this_box_volume.geometry.shell_points = &box_shell_points;
this_box_volume.geometry.mcdisplay_function = &mcdisplay_box_function;
this_box_volume.geometry.initialize_from_main_function = &initialize_box_geometry_from_main_component;
this_box_volume.geometry.process_rot_allocated = 0;

this_box_volume.geometry.copy_geometry_parameters = &allocate_box_storage_copy;

rot_copy(this_box_volume.geometry.rotation_matrix,ROT_A_CURRENT_COMP); //check how ROT_R_CURRENT_COMP would work
rot_transpose(ROT_A_CURRENT_COMP,this_box_volume.geometry.transpose_rotation_matrix);

// Initialize loggers
this_box_volume.loggers.num_elements = 0;

// packing the information into the global_geometry_element, which is then included in the global_geometry_list.
sprintf(global_geometry_element.name,NAME_CURRENT_COMP);
global_geometry_element.activation_counter = number_of_activations;
global_geometry_element.component_index = INDEX_CURRENT_COMP;
global_geometry_element.Volume = &this_box_volume; // Would be nicer if this m was a pointer, now we have the (small) data two places
add_element_to_geometry_list(&global_geometry_list,global_geometry_element);
}
#line 194642 "MACS_sample_kidney_box.c"
#undef number_of_activations
#undef mask_setting
#undef mask_string
#undef p_interact
#undef focus_r
#undef focus_xh
#undef focus_xw
#undef focus_ah
#undef focus_aw
#undef target_z
#undef target_y
#undef target_x
#undef target_index
#undef visualize
#undef yheight2
#undef xwidth2
#undef zdepth
#undef yheight
#undef xwidth
#undef priority
#undef material_string
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

  /* Initializations for component channel_3_analyzer_2_array_crystal_array_1. */
  SIG_MESSAGE("channel_3_analyzer_2_array_crystal_array_1 (Init)");
#define mccompcurname  channel_3_analyzer_2_array_crystal_array_1
#define mccompcurtype  Union_box
#define mccompcurindex 256
#define loop_index mccchannel_3_analyzer_2_array_crystal_array_1_loop_index
#define this_box_volume mccchannel_3_analyzer_2_array_crystal_array_1_this_box_volume
#define global_geometry_element mccchannel_3_analyzer_2_array_crystal_array_1_global_geometry_element
#define this_box_storage mccchannel_3_analyzer_2_array_crystal_array_1_this_box_storage
#define material_string mccchannel_3_analyzer_2_array_crystal_array_1_material_string
#define priority mccchannel_3_analyzer_2_array_crystal_array_1_priority
#define xwidth mccchannel_3_analyzer_2_array_crystal_array_1_xwidth
#define yheight mccchannel_3_analyzer_2_array_crystal_array_1_yheight
#define zdepth mccchannel_3_analyzer_2_array_crystal_array_1_zdepth
#define xwidth2 mccchannel_3_analyzer_2_array_crystal_array_1_xwidth2
#define yheight2 mccchannel_3_analyzer_2_array_crystal_array_1_yheight2
#define visualize mccchannel_3_analyzer_2_array_crystal_array_1_visualize
#define target_index mccchannel_3_analyzer_2_array_crystal_array_1_target_index
#define target_x mccchannel_3_analyzer_2_array_crystal_array_1_target_x
#define target_y mccchannel_3_analyzer_2_array_crystal_array_1_target_y
#define target_z mccchannel_3_analyzer_2_array_crystal_array_1_target_z
#define focus_aw mccchannel_3_analyzer_2_array_crystal_array_1_focus_aw
#define focus_ah mccchannel_3_analyzer_2_array_crystal_array_1_focus_ah
#define focus_xw mccchannel_3_analyzer_2_array_crystal_array_1_focus_xw
#define focus_xh mccchannel_3_analyzer_2_array_crystal_array_1_focus_xh
#define focus_r mccchannel_3_analyzer_2_array_crystal_array_1_focus_r
#define p_interact mccchannel_3_analyzer_2_array_crystal_array_1_p_interact
#define mask_string mccchannel_3_analyzer_2_array_crystal_array_1_mask_string
#define mask_setting mccchannel_3_analyzer_2_array_crystal_array_1_mask_setting
#define number_of_activations mccchannel_3_analyzer_2_array_crystal_array_1_number_of_activations
#line 224 "Union_box.comp"
{
// Initializes the focusing system for this volume including input sanitation.
focus_initialize(&this_box_volume.geometry, POS_A_COMP_INDEX(INDEX_CURRENT_COMP+target_index), POS_A_CURRENT_COMP, ROT_A_CURRENT_COMP, target_index, target_x, target_y, target_z, focus_aw, focus_ah, focus_xw, focus_xh, focus_r, NAME_CURRENT_COMP);

// Input sanitation for this geometry
if (xwidth <= 0) {
  printf("\nERROR in Union_box named %s, the xwidth is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (yheight <= 0) {
  printf("\nERROR in Union_box named %s, yheight is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (zdepth <= 0) {
  printf("\nERROR in Union_box named %s, zdepth is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (xwidth2 <= 0 && xwidth2 != -1) {
  printf("\nERROR in Union_box named %s, the xwidth2 is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (yheight2 <= 0 && yheight2 != -1) {
  printf("\nERROR in Union_box named %s, yheight2 is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}

// Use sanitation
if (global_material_list.num_elements == 0) {
  printf("\nERROR: Need to define a material using Union_make_material before using a Union geometry component. \n");
  printf("       %s was defined before first use of Union_make_material.\n",NAME_CURRENT_COMP);
  exit(1);
}

this_box_volume.geometry.is_masked_volume = 0;
this_box_volume.geometry.is_exit_volume = 0;
this_box_volume.geometry.is_mask_volume = 0;
// check if the volume is a mask, if it is the material string is irelevant.
if (mask_string && strlen(mask_string) && strcmp(mask_string, "NULL") && strcmp(mask_string, "0")) {
    // A mask volume is used to limit the extend of other volumes, called the masked volumes. These are specified in the mask_string.
    // In order for a ray to enter a masked volume, it needs to be both in the region covered by that volume AND the mask volume.
    // When more than
    this_box_volume.geometry.mask_mode = 1; // Default is mask mode is ALL
    if (mask_setting && strlen(mask_setting) && strcmp(mask_setting, "NULL") && strcmp(mask_setting, "0")) {
        if (strcmp(mask_setting,"ALL") == 0 || strcmp(mask_setting,"All") == 0) this_box_volume.geometry.mask_mode = 1;
        else if (strcmp(mask_setting,"ANY") == 0 || strcmp(mask_setting,"Any") == 0) this_box_volume.geometry.mask_mode = 2;
        else {
            printf("The mask_mode of component %s is set to %s, but must be either ALL or ANY.\n",NAME_CURRENT_COMP,mask_setting);
            exit(1);
        }
    }
    
    for (loop_index=0;loop_index<global_geometry_list.num_elements;loop_index++) {
        // Add mask list
        if (1 == manual_linking_function(global_geometry_list.elements[loop_index].name,mask_string)) {
            add_element_to_int_list(&this_box_volume.geometry.mask_list,global_geometry_list.elements[loop_index].component_index);
            add_element_to_int_list(&global_geometry_list.elements[loop_index].Volume->geometry.masked_by_list,INDEX_CURRENT_COMP);
            global_geometry_list.elements[loop_index].Volume->geometry.is_masked_volume = 1;
            if (this_box_volume.geometry.mask_mode == 2)
                global_geometry_list.elements[loop_index].Volume->geometry.mask_mode = 2;
            if (this_box_volume.geometry.mask_mode == 1) {
                if (global_geometry_list.elements[loop_index].Volume->geometry.is_masked_volume == 1 && global_geometry_list.elements[loop_index].Volume->geometry.mask_mode != 2)
                    // If more than one mask is added to one volume, the ANY mode overwrites the (default) ALL mode.
                    global_geometry_list.elements[loop_index].Volume->geometry.mask_mode = 1;
            }
            
            found_geometries = 1;
        }
    }
    if (found_geometries == 0) {
        printf("The mask_string in geometry: %s did not find any of the specified volumes in the mask_string %s \n",NAME_CURRENT_COMP,mask_string);
        exit(1);
    }
    this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
    this_box_volume.p_physics->is_vacuum = 0; // Makes this volume a vacuum
    this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
    this_box_volume.p_physics->my_a = 0; // Should not be used.
    sprintf(this_box_volume.p_physics->name,"Mask");
    this_box_volume.geometry.is_mask_volume = 1;
    
    
// Read the material input, or if it lacks, use automatic linking.
} else if (material_string && strlen(material_string) && strcmp(material_string, "NULL") && strcmp(material_string, "0")) {
    // A geometry string was given, use it to determine which material
    if (0 == strcmp(material_string,"vacuum") || 0 == strcmp(material_string,"Vacuum")) {
        // One could have a global physics struct for vacuum instead of creating one for each
        this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
        this_box_volume.p_physics->is_vacuum = 1; // Makes this volume a vacuum
        this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
        this_box_volume.p_physics->my_a = 0; // Should not be used.
        sprintf(this_box_volume.p_physics->name,"Vacuum");
    } else if (0 == strcmp(material_string,"exit") || 0 == strcmp(material_string,"Exit")) {
        // One could have a global physics struct for vacuum instead of creating one for each
        this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
        this_box_volume.p_physics->is_vacuum = 1; // Makes this volume a vacuum
        this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
        this_box_volume.p_physics->my_a = 0; // Should not be used.
        this_box_volume.geometry.is_exit_volume = 1;
        sprintf(this_box_volume.p_physics->name,"Exit");
    } else {
        #ifndef MATERIAL_DETECTOR
            printf("Need to define a material before refering to it in a geometry %s.\n",NAME_CURRENT_COMP);
            exit(1);
        #endif
        for (loop_index=0;loop_index<global_material_list.num_elements;loop_index++) {
            if (0 == strcmp(material_string,global_material_list.elements[loop_index].name)) {
                this_box_volume.p_physics = global_material_list.elements[loop_index].physics;
                break;
            }
            if (loop_index == global_material_list.num_elements-1) {
            printf("\n");
            printf("ERROR: The material string \"%s\" in Union geometry \"%s\" did not match a specified material. \n",material_string,NAME_CURRENT_COMP);
            printf("       The materials available at this point (need to be defined before the geometry): \n");
            for (loop_index=0;loop_index<global_material_list.num_elements;loop_index++)
              printf("         %s\n",global_material_list.elements[loop_index].name);
            printf("\n");
            printf("       It is also possible to use one of the defualt materials avaiable: \n");
            printf("           Vacuum (for a Volume without scattering or absorption)\n");
            printf("           Exit (for a Volume where the ray exits the component if it enters)\n");
            printf("           Mask (for a Volume that masks existing volumes specified in the mask_string\n");
            exit(1);
          }
        }
    }
} else {
    // Automatic linking, simply using the last defined material.
    #ifndef MATERIAL_DETECTOR
        printf("Need to define a material before the geometry to use automatic linking %s.\n",NAME_CURRENT_COMP);
        exit(1);
    #endif
    this_box_volume.p_physics = global_material_list.elements[global_material_list.num_elements-1].physics;
}

sprintf(this_box_volume.name,NAME_CURRENT_COMP);
sprintf(this_box_volume.geometry.shape,"box");
this_box_volume.geometry.priority_value = priority;
this_box_volume.geometry.geometry_p_interact = p_interact;
// Currently the coordinates will be in absolute space.
this_box_volume.geometry.center = POS_A_CURRENT_COMP;

this_box_storage.z_depth = zdepth;
this_box_storage.x_width1 = xwidth;
this_box_storage.y_height1 = yheight;

this_box_storage.is_rectangle = 0;
if (xwidth2 < 0 && yheight2 < 0) this_box_storage.is_rectangle = 1;
if (xwidth == xwidth2 && yheight == yheight2) this_box_storage.is_rectangle = 1;

if (xwidth2 < 0) {
    this_box_storage.x_width2 = xwidth;
    xwidth2 = xwidth;
} else this_box_storage.x_width2 = xwidth2;

if (yheight2 < 0) {
    this_box_storage.y_height2 = yheight;
    yheight2 = yheight;
} else this_box_storage.y_height2 = yheight2;


this_box_storage.normal_vectors[0] = coords_set(0,0,1);
this_box_storage.normal_vectors[1] = coords_set(0,0,1);

// for sides with y component = 0
x_component = 2*zdepth/sqrt((xwidth-xwidth2)*(xwidth-xwidth2)+4*zdepth*zdepth);
z_component = (xwidth-xwidth2)/sqrt(4*zdepth*zdepth+(xwidth-xwidth2)*(xwidth-xwidth2));

this_box_storage.normal_vectors[2] = coords_set(x_component,0,z_component);
this_box_storage.normal_vectors[3] = coords_set(-x_component,0,z_component);

// for sides with x component = 0
y_component = 2*zdepth/sqrt((yheight-yheight2)*(yheight-yheight2)+4*zdepth*zdepth);
z_component = (yheight-yheight2)/sqrt(4*zdepth*zdepth+(yheight-yheight2)*(yheight-yheight2));

this_box_storage.normal_vectors[4] = coords_set(0,y_component,z_component);
this_box_storage.normal_vectors[5] = coords_set(0,-y_component,z_component);

this_box_volume.geometry.visualization_on = visualize;

this_box_volume.geometry.geometry_parameters.p_box_storage = &this_box_storage;

// Assign pointers to functions for intersection with the shape, checking if a point is inside the shape
if (this_box_storage.is_rectangle == 1) {
this_box_volume.geometry.intersect_function = &sample_box_intersect_simple;
this_box_volume.geometry.within_function = &r_within_box_simple;
}
else {
this_box_volume.geometry.intersect_function = &sample_box_intersect_advanced;
this_box_volume.geometry.within_function = &r_within_box_advanced;
}

this_box_volume.geometry.shell_points = &box_shell_points;
this_box_volume.geometry.mcdisplay_function = &mcdisplay_box_function;
this_box_volume.geometry.initialize_from_main_function = &initialize_box_geometry_from_main_component;
this_box_volume.geometry.process_rot_allocated = 0;

this_box_volume.geometry.copy_geometry_parameters = &allocate_box_storage_copy;

rot_copy(this_box_volume.geometry.rotation_matrix,ROT_A_CURRENT_COMP); //check how ROT_R_CURRENT_COMP would work
rot_transpose(ROT_A_CURRENT_COMP,this_box_volume.geometry.transpose_rotation_matrix);

// Initialize loggers
this_box_volume.loggers.num_elements = 0;

// packing the information into the global_geometry_element, which is then included in the global_geometry_list.
sprintf(global_geometry_element.name,NAME_CURRENT_COMP);
global_geometry_element.activation_counter = number_of_activations;
global_geometry_element.component_index = INDEX_CURRENT_COMP;
global_geometry_element.Volume = &this_box_volume; // Would be nicer if this m was a pointer, now we have the (small) data two places
add_element_to_geometry_list(&global_geometry_list,global_geometry_element);
}
#line 194912 "MACS_sample_kidney_box.c"
#undef number_of_activations
#undef mask_setting
#undef mask_string
#undef p_interact
#undef focus_r
#undef focus_xh
#undef focus_xw
#undef focus_ah
#undef focus_aw
#undef target_z
#undef target_y
#undef target_x
#undef target_index
#undef visualize
#undef yheight2
#undef xwidth2
#undef zdepth
#undef yheight
#undef xwidth
#undef priority
#undef material_string
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

  /* Initializations for component channel_3_analyzer_2_array_crystal_array_2. */
  SIG_MESSAGE("channel_3_analyzer_2_array_crystal_array_2 (Init)");
#define mccompcurname  channel_3_analyzer_2_array_crystal_array_2
#define mccompcurtype  Union_box
#define mccompcurindex 257
#define loop_index mccchannel_3_analyzer_2_array_crystal_array_2_loop_index
#define this_box_volume mccchannel_3_analyzer_2_array_crystal_array_2_this_box_volume
#define global_geometry_element mccchannel_3_analyzer_2_array_crystal_array_2_global_geometry_element
#define this_box_storage mccchannel_3_analyzer_2_array_crystal_array_2_this_box_storage
#define material_string mccchannel_3_analyzer_2_array_crystal_array_2_material_string
#define priority mccchannel_3_analyzer_2_array_crystal_array_2_priority
#define xwidth mccchannel_3_analyzer_2_array_crystal_array_2_xwidth
#define yheight mccchannel_3_analyzer_2_array_crystal_array_2_yheight
#define zdepth mccchannel_3_analyzer_2_array_crystal_array_2_zdepth
#define xwidth2 mccchannel_3_analyzer_2_array_crystal_array_2_xwidth2
#define yheight2 mccchannel_3_analyzer_2_array_crystal_array_2_yheight2
#define visualize mccchannel_3_analyzer_2_array_crystal_array_2_visualize
#define target_index mccchannel_3_analyzer_2_array_crystal_array_2_target_index
#define target_x mccchannel_3_analyzer_2_array_crystal_array_2_target_x
#define target_y mccchannel_3_analyzer_2_array_crystal_array_2_target_y
#define target_z mccchannel_3_analyzer_2_array_crystal_array_2_target_z
#define focus_aw mccchannel_3_analyzer_2_array_crystal_array_2_focus_aw
#define focus_ah mccchannel_3_analyzer_2_array_crystal_array_2_focus_ah
#define focus_xw mccchannel_3_analyzer_2_array_crystal_array_2_focus_xw
#define focus_xh mccchannel_3_analyzer_2_array_crystal_array_2_focus_xh
#define focus_r mccchannel_3_analyzer_2_array_crystal_array_2_focus_r
#define p_interact mccchannel_3_analyzer_2_array_crystal_array_2_p_interact
#define mask_string mccchannel_3_analyzer_2_array_crystal_array_2_mask_string
#define mask_setting mccchannel_3_analyzer_2_array_crystal_array_2_mask_setting
#define number_of_activations mccchannel_3_analyzer_2_array_crystal_array_2_number_of_activations
#line 224 "Union_box.comp"
{
// Initializes the focusing system for this volume including input sanitation.
focus_initialize(&this_box_volume.geometry, POS_A_COMP_INDEX(INDEX_CURRENT_COMP+target_index), POS_A_CURRENT_COMP, ROT_A_CURRENT_COMP, target_index, target_x, target_y, target_z, focus_aw, focus_ah, focus_xw, focus_xh, focus_r, NAME_CURRENT_COMP);

// Input sanitation for this geometry
if (xwidth <= 0) {
  printf("\nERROR in Union_box named %s, the xwidth is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (yheight <= 0) {
  printf("\nERROR in Union_box named %s, yheight is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (zdepth <= 0) {
  printf("\nERROR in Union_box named %s, zdepth is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (xwidth2 <= 0 && xwidth2 != -1) {
  printf("\nERROR in Union_box named %s, the xwidth2 is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (yheight2 <= 0 && yheight2 != -1) {
  printf("\nERROR in Union_box named %s, yheight2 is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}

// Use sanitation
if (global_material_list.num_elements == 0) {
  printf("\nERROR: Need to define a material using Union_make_material before using a Union geometry component. \n");
  printf("       %s was defined before first use of Union_make_material.\n",NAME_CURRENT_COMP);
  exit(1);
}

this_box_volume.geometry.is_masked_volume = 0;
this_box_volume.geometry.is_exit_volume = 0;
this_box_volume.geometry.is_mask_volume = 0;
// check if the volume is a mask, if it is the material string is irelevant.
if (mask_string && strlen(mask_string) && strcmp(mask_string, "NULL") && strcmp(mask_string, "0")) {
    // A mask volume is used to limit the extend of other volumes, called the masked volumes. These are specified in the mask_string.
    // In order for a ray to enter a masked volume, it needs to be both in the region covered by that volume AND the mask volume.
    // When more than
    this_box_volume.geometry.mask_mode = 1; // Default is mask mode is ALL
    if (mask_setting && strlen(mask_setting) && strcmp(mask_setting, "NULL") && strcmp(mask_setting, "0")) {
        if (strcmp(mask_setting,"ALL") == 0 || strcmp(mask_setting,"All") == 0) this_box_volume.geometry.mask_mode = 1;
        else if (strcmp(mask_setting,"ANY") == 0 || strcmp(mask_setting,"Any") == 0) this_box_volume.geometry.mask_mode = 2;
        else {
            printf("The mask_mode of component %s is set to %s, but must be either ALL or ANY.\n",NAME_CURRENT_COMP,mask_setting);
            exit(1);
        }
    }
    
    for (loop_index=0;loop_index<global_geometry_list.num_elements;loop_index++) {
        // Add mask list
        if (1 == manual_linking_function(global_geometry_list.elements[loop_index].name,mask_string)) {
            add_element_to_int_list(&this_box_volume.geometry.mask_list,global_geometry_list.elements[loop_index].component_index);
            add_element_to_int_list(&global_geometry_list.elements[loop_index].Volume->geometry.masked_by_list,INDEX_CURRENT_COMP);
            global_geometry_list.elements[loop_index].Volume->geometry.is_masked_volume = 1;
            if (this_box_volume.geometry.mask_mode == 2)
                global_geometry_list.elements[loop_index].Volume->geometry.mask_mode = 2;
            if (this_box_volume.geometry.mask_mode == 1) {
                if (global_geometry_list.elements[loop_index].Volume->geometry.is_masked_volume == 1 && global_geometry_list.elements[loop_index].Volume->geometry.mask_mode != 2)
                    // If more than one mask is added to one volume, the ANY mode overwrites the (default) ALL mode.
                    global_geometry_list.elements[loop_index].Volume->geometry.mask_mode = 1;
            }
            
            found_geometries = 1;
        }
    }
    if (found_geometries == 0) {
        printf("The mask_string in geometry: %s did not find any of the specified volumes in the mask_string %s \n",NAME_CURRENT_COMP,mask_string);
        exit(1);
    }
    this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
    this_box_volume.p_physics->is_vacuum = 0; // Makes this volume a vacuum
    this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
    this_box_volume.p_physics->my_a = 0; // Should not be used.
    sprintf(this_box_volume.p_physics->name,"Mask");
    this_box_volume.geometry.is_mask_volume = 1;
    
    
// Read the material input, or if it lacks, use automatic linking.
} else if (material_string && strlen(material_string) && strcmp(material_string, "NULL") && strcmp(material_string, "0")) {
    // A geometry string was given, use it to determine which material
    if (0 == strcmp(material_string,"vacuum") || 0 == strcmp(material_string,"Vacuum")) {
        // One could have a global physics struct for vacuum instead of creating one for each
        this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
        this_box_volume.p_physics->is_vacuum = 1; // Makes this volume a vacuum
        this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
        this_box_volume.p_physics->my_a = 0; // Should not be used.
        sprintf(this_box_volume.p_physics->name,"Vacuum");
    } else if (0 == strcmp(material_string,"exit") || 0 == strcmp(material_string,"Exit")) {
        // One could have a global physics struct for vacuum instead of creating one for each
        this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
        this_box_volume.p_physics->is_vacuum = 1; // Makes this volume a vacuum
        this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
        this_box_volume.p_physics->my_a = 0; // Should not be used.
        this_box_volume.geometry.is_exit_volume = 1;
        sprintf(this_box_volume.p_physics->name,"Exit");
    } else {
        #ifndef MATERIAL_DETECTOR
            printf("Need to define a material before refering to it in a geometry %s.\n",NAME_CURRENT_COMP);
            exit(1);
        #endif
        for (loop_index=0;loop_index<global_material_list.num_elements;loop_index++) {
            if (0 == strcmp(material_string,global_material_list.elements[loop_index].name)) {
                this_box_volume.p_physics = global_material_list.elements[loop_index].physics;
                break;
            }
            if (loop_index == global_material_list.num_elements-1) {
            printf("\n");
            printf("ERROR: The material string \"%s\" in Union geometry \"%s\" did not match a specified material. \n",material_string,NAME_CURRENT_COMP);
            printf("       The materials available at this point (need to be defined before the geometry): \n");
            for (loop_index=0;loop_index<global_material_list.num_elements;loop_index++)
              printf("         %s\n",global_material_list.elements[loop_index].name);
            printf("\n");
            printf("       It is also possible to use one of the defualt materials avaiable: \n");
            printf("           Vacuum (for a Volume without scattering or absorption)\n");
            printf("           Exit (for a Volume where the ray exits the component if it enters)\n");
            printf("           Mask (for a Volume that masks existing volumes specified in the mask_string\n");
            exit(1);
          }
        }
    }
} else {
    // Automatic linking, simply using the last defined material.
    #ifndef MATERIAL_DETECTOR
        printf("Need to define a material before the geometry to use automatic linking %s.\n",NAME_CURRENT_COMP);
        exit(1);
    #endif
    this_box_volume.p_physics = global_material_list.elements[global_material_list.num_elements-1].physics;
}

sprintf(this_box_volume.name,NAME_CURRENT_COMP);
sprintf(this_box_volume.geometry.shape,"box");
this_box_volume.geometry.priority_value = priority;
this_box_volume.geometry.geometry_p_interact = p_interact;
// Currently the coordinates will be in absolute space.
this_box_volume.geometry.center = POS_A_CURRENT_COMP;

this_box_storage.z_depth = zdepth;
this_box_storage.x_width1 = xwidth;
this_box_storage.y_height1 = yheight;

this_box_storage.is_rectangle = 0;
if (xwidth2 < 0 && yheight2 < 0) this_box_storage.is_rectangle = 1;
if (xwidth == xwidth2 && yheight == yheight2) this_box_storage.is_rectangle = 1;

if (xwidth2 < 0) {
    this_box_storage.x_width2 = xwidth;
    xwidth2 = xwidth;
} else this_box_storage.x_width2 = xwidth2;

if (yheight2 < 0) {
    this_box_storage.y_height2 = yheight;
    yheight2 = yheight;
} else this_box_storage.y_height2 = yheight2;


this_box_storage.normal_vectors[0] = coords_set(0,0,1);
this_box_storage.normal_vectors[1] = coords_set(0,0,1);

// for sides with y component = 0
x_component = 2*zdepth/sqrt((xwidth-xwidth2)*(xwidth-xwidth2)+4*zdepth*zdepth);
z_component = (xwidth-xwidth2)/sqrt(4*zdepth*zdepth+(xwidth-xwidth2)*(xwidth-xwidth2));

this_box_storage.normal_vectors[2] = coords_set(x_component,0,z_component);
this_box_storage.normal_vectors[3] = coords_set(-x_component,0,z_component);

// for sides with x component = 0
y_component = 2*zdepth/sqrt((yheight-yheight2)*(yheight-yheight2)+4*zdepth*zdepth);
z_component = (yheight-yheight2)/sqrt(4*zdepth*zdepth+(yheight-yheight2)*(yheight-yheight2));

this_box_storage.normal_vectors[4] = coords_set(0,y_component,z_component);
this_box_storage.normal_vectors[5] = coords_set(0,-y_component,z_component);

this_box_volume.geometry.visualization_on = visualize;

this_box_volume.geometry.geometry_parameters.p_box_storage = &this_box_storage;

// Assign pointers to functions for intersection with the shape, checking if a point is inside the shape
if (this_box_storage.is_rectangle == 1) {
this_box_volume.geometry.intersect_function = &sample_box_intersect_simple;
this_box_volume.geometry.within_function = &r_within_box_simple;
}
else {
this_box_volume.geometry.intersect_function = &sample_box_intersect_advanced;
this_box_volume.geometry.within_function = &r_within_box_advanced;
}

this_box_volume.geometry.shell_points = &box_shell_points;
this_box_volume.geometry.mcdisplay_function = &mcdisplay_box_function;
this_box_volume.geometry.initialize_from_main_function = &initialize_box_geometry_from_main_component;
this_box_volume.geometry.process_rot_allocated = 0;

this_box_volume.geometry.copy_geometry_parameters = &allocate_box_storage_copy;

rot_copy(this_box_volume.geometry.rotation_matrix,ROT_A_CURRENT_COMP); //check how ROT_R_CURRENT_COMP would work
rot_transpose(ROT_A_CURRENT_COMP,this_box_volume.geometry.transpose_rotation_matrix);

// Initialize loggers
this_box_volume.loggers.num_elements = 0;

// packing the information into the global_geometry_element, which is then included in the global_geometry_list.
sprintf(global_geometry_element.name,NAME_CURRENT_COMP);
global_geometry_element.activation_counter = number_of_activations;
global_geometry_element.component_index = INDEX_CURRENT_COMP;
global_geometry_element.Volume = &this_box_volume; // Would be nicer if this m was a pointer, now we have the (small) data two places
add_element_to_geometry_list(&global_geometry_list,global_geometry_element);
}
#line 195182 "MACS_sample_kidney_box.c"
#undef number_of_activations
#undef mask_setting
#undef mask_string
#undef p_interact
#undef focus_r
#undef focus_xh
#undef focus_xw
#undef focus_ah
#undef focus_aw
#undef target_z
#undef target_y
#undef target_x
#undef target_index
#undef visualize
#undef yheight2
#undef xwidth2
#undef zdepth
#undef yheight
#undef xwidth
#undef priority
#undef material_string
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

  /* Initializations for component channel_3_analyzer_2_array_crystal_array_3. */
  SIG_MESSAGE("channel_3_analyzer_2_array_crystal_array_3 (Init)");
#define mccompcurname  channel_3_analyzer_2_array_crystal_array_3
#define mccompcurtype  Union_box
#define mccompcurindex 258
#define loop_index mccchannel_3_analyzer_2_array_crystal_array_3_loop_index
#define this_box_volume mccchannel_3_analyzer_2_array_crystal_array_3_this_box_volume
#define global_geometry_element mccchannel_3_analyzer_2_array_crystal_array_3_global_geometry_element
#define this_box_storage mccchannel_3_analyzer_2_array_crystal_array_3_this_box_storage
#define material_string mccchannel_3_analyzer_2_array_crystal_array_3_material_string
#define priority mccchannel_3_analyzer_2_array_crystal_array_3_priority
#define xwidth mccchannel_3_analyzer_2_array_crystal_array_3_xwidth
#define yheight mccchannel_3_analyzer_2_array_crystal_array_3_yheight
#define zdepth mccchannel_3_analyzer_2_array_crystal_array_3_zdepth
#define xwidth2 mccchannel_3_analyzer_2_array_crystal_array_3_xwidth2
#define yheight2 mccchannel_3_analyzer_2_array_crystal_array_3_yheight2
#define visualize mccchannel_3_analyzer_2_array_crystal_array_3_visualize
#define target_index mccchannel_3_analyzer_2_array_crystal_array_3_target_index
#define target_x mccchannel_3_analyzer_2_array_crystal_array_3_target_x
#define target_y mccchannel_3_analyzer_2_array_crystal_array_3_target_y
#define target_z mccchannel_3_analyzer_2_array_crystal_array_3_target_z
#define focus_aw mccchannel_3_analyzer_2_array_crystal_array_3_focus_aw
#define focus_ah mccchannel_3_analyzer_2_array_crystal_array_3_focus_ah
#define focus_xw mccchannel_3_analyzer_2_array_crystal_array_3_focus_xw
#define focus_xh mccchannel_3_analyzer_2_array_crystal_array_3_focus_xh
#define focus_r mccchannel_3_analyzer_2_array_crystal_array_3_focus_r
#define p_interact mccchannel_3_analyzer_2_array_crystal_array_3_p_interact
#define mask_string mccchannel_3_analyzer_2_array_crystal_array_3_mask_string
#define mask_setting mccchannel_3_analyzer_2_array_crystal_array_3_mask_setting
#define number_of_activations mccchannel_3_analyzer_2_array_crystal_array_3_number_of_activations
#line 224 "Union_box.comp"
{
// Initializes the focusing system for this volume including input sanitation.
focus_initialize(&this_box_volume.geometry, POS_A_COMP_INDEX(INDEX_CURRENT_COMP+target_index), POS_A_CURRENT_COMP, ROT_A_CURRENT_COMP, target_index, target_x, target_y, target_z, focus_aw, focus_ah, focus_xw, focus_xh, focus_r, NAME_CURRENT_COMP);

// Input sanitation for this geometry
if (xwidth <= 0) {
  printf("\nERROR in Union_box named %s, the xwidth is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (yheight <= 0) {
  printf("\nERROR in Union_box named %s, yheight is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (zdepth <= 0) {
  printf("\nERROR in Union_box named %s, zdepth is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (xwidth2 <= 0 && xwidth2 != -1) {
  printf("\nERROR in Union_box named %s, the xwidth2 is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (yheight2 <= 0 && yheight2 != -1) {
  printf("\nERROR in Union_box named %s, yheight2 is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}

// Use sanitation
if (global_material_list.num_elements == 0) {
  printf("\nERROR: Need to define a material using Union_make_material before using a Union geometry component. \n");
  printf("       %s was defined before first use of Union_make_material.\n",NAME_CURRENT_COMP);
  exit(1);
}

this_box_volume.geometry.is_masked_volume = 0;
this_box_volume.geometry.is_exit_volume = 0;
this_box_volume.geometry.is_mask_volume = 0;
// check if the volume is a mask, if it is the material string is irelevant.
if (mask_string && strlen(mask_string) && strcmp(mask_string, "NULL") && strcmp(mask_string, "0")) {
    // A mask volume is used to limit the extend of other volumes, called the masked volumes. These are specified in the mask_string.
    // In order for a ray to enter a masked volume, it needs to be both in the region covered by that volume AND the mask volume.
    // When more than
    this_box_volume.geometry.mask_mode = 1; // Default is mask mode is ALL
    if (mask_setting && strlen(mask_setting) && strcmp(mask_setting, "NULL") && strcmp(mask_setting, "0")) {
        if (strcmp(mask_setting,"ALL") == 0 || strcmp(mask_setting,"All") == 0) this_box_volume.geometry.mask_mode = 1;
        else if (strcmp(mask_setting,"ANY") == 0 || strcmp(mask_setting,"Any") == 0) this_box_volume.geometry.mask_mode = 2;
        else {
            printf("The mask_mode of component %s is set to %s, but must be either ALL or ANY.\n",NAME_CURRENT_COMP,mask_setting);
            exit(1);
        }
    }
    
    for (loop_index=0;loop_index<global_geometry_list.num_elements;loop_index++) {
        // Add mask list
        if (1 == manual_linking_function(global_geometry_list.elements[loop_index].name,mask_string)) {
            add_element_to_int_list(&this_box_volume.geometry.mask_list,global_geometry_list.elements[loop_index].component_index);
            add_element_to_int_list(&global_geometry_list.elements[loop_index].Volume->geometry.masked_by_list,INDEX_CURRENT_COMP);
            global_geometry_list.elements[loop_index].Volume->geometry.is_masked_volume = 1;
            if (this_box_volume.geometry.mask_mode == 2)
                global_geometry_list.elements[loop_index].Volume->geometry.mask_mode = 2;
            if (this_box_volume.geometry.mask_mode == 1) {
                if (global_geometry_list.elements[loop_index].Volume->geometry.is_masked_volume == 1 && global_geometry_list.elements[loop_index].Volume->geometry.mask_mode != 2)
                    // If more than one mask is added to one volume, the ANY mode overwrites the (default) ALL mode.
                    global_geometry_list.elements[loop_index].Volume->geometry.mask_mode = 1;
            }
            
            found_geometries = 1;
        }
    }
    if (found_geometries == 0) {
        printf("The mask_string in geometry: %s did not find any of the specified volumes in the mask_string %s \n",NAME_CURRENT_COMP,mask_string);
        exit(1);
    }
    this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
    this_box_volume.p_physics->is_vacuum = 0; // Makes this volume a vacuum
    this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
    this_box_volume.p_physics->my_a = 0; // Should not be used.
    sprintf(this_box_volume.p_physics->name,"Mask");
    this_box_volume.geometry.is_mask_volume = 1;
    
    
// Read the material input, or if it lacks, use automatic linking.
} else if (material_string && strlen(material_string) && strcmp(material_string, "NULL") && strcmp(material_string, "0")) {
    // A geometry string was given, use it to determine which material
    if (0 == strcmp(material_string,"vacuum") || 0 == strcmp(material_string,"Vacuum")) {
        // One could have a global physics struct for vacuum instead of creating one for each
        this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
        this_box_volume.p_physics->is_vacuum = 1; // Makes this volume a vacuum
        this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
        this_box_volume.p_physics->my_a = 0; // Should not be used.
        sprintf(this_box_volume.p_physics->name,"Vacuum");
    } else if (0 == strcmp(material_string,"exit") || 0 == strcmp(material_string,"Exit")) {
        // One could have a global physics struct for vacuum instead of creating one for each
        this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
        this_box_volume.p_physics->is_vacuum = 1; // Makes this volume a vacuum
        this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
        this_box_volume.p_physics->my_a = 0; // Should not be used.
        this_box_volume.geometry.is_exit_volume = 1;
        sprintf(this_box_volume.p_physics->name,"Exit");
    } else {
        #ifndef MATERIAL_DETECTOR
            printf("Need to define a material before refering to it in a geometry %s.\n",NAME_CURRENT_COMP);
            exit(1);
        #endif
        for (loop_index=0;loop_index<global_material_list.num_elements;loop_index++) {
            if (0 == strcmp(material_string,global_material_list.elements[loop_index].name)) {
                this_box_volume.p_physics = global_material_list.elements[loop_index].physics;
                break;
            }
            if (loop_index == global_material_list.num_elements-1) {
            printf("\n");
            printf("ERROR: The material string \"%s\" in Union geometry \"%s\" did not match a specified material. \n",material_string,NAME_CURRENT_COMP);
            printf("       The materials available at this point (need to be defined before the geometry): \n");
            for (loop_index=0;loop_index<global_material_list.num_elements;loop_index++)
              printf("         %s\n",global_material_list.elements[loop_index].name);
            printf("\n");
            printf("       It is also possible to use one of the defualt materials avaiable: \n");
            printf("           Vacuum (for a Volume without scattering or absorption)\n");
            printf("           Exit (for a Volume where the ray exits the component if it enters)\n");
            printf("           Mask (for a Volume that masks existing volumes specified in the mask_string\n");
            exit(1);
          }
        }
    }
} else {
    // Automatic linking, simply using the last defined material.
    #ifndef MATERIAL_DETECTOR
        printf("Need to define a material before the geometry to use automatic linking %s.\n",NAME_CURRENT_COMP);
        exit(1);
    #endif
    this_box_volume.p_physics = global_material_list.elements[global_material_list.num_elements-1].physics;
}

sprintf(this_box_volume.name,NAME_CURRENT_COMP);
sprintf(this_box_volume.geometry.shape,"box");
this_box_volume.geometry.priority_value = priority;
this_box_volume.geometry.geometry_p_interact = p_interact;
// Currently the coordinates will be in absolute space.
this_box_volume.geometry.center = POS_A_CURRENT_COMP;

this_box_storage.z_depth = zdepth;
this_box_storage.x_width1 = xwidth;
this_box_storage.y_height1 = yheight;

this_box_storage.is_rectangle = 0;
if (xwidth2 < 0 && yheight2 < 0) this_box_storage.is_rectangle = 1;
if (xwidth == xwidth2 && yheight == yheight2) this_box_storage.is_rectangle = 1;

if (xwidth2 < 0) {
    this_box_storage.x_width2 = xwidth;
    xwidth2 = xwidth;
} else this_box_storage.x_width2 = xwidth2;

if (yheight2 < 0) {
    this_box_storage.y_height2 = yheight;
    yheight2 = yheight;
} else this_box_storage.y_height2 = yheight2;


this_box_storage.normal_vectors[0] = coords_set(0,0,1);
this_box_storage.normal_vectors[1] = coords_set(0,0,1);

// for sides with y component = 0
x_component = 2*zdepth/sqrt((xwidth-xwidth2)*(xwidth-xwidth2)+4*zdepth*zdepth);
z_component = (xwidth-xwidth2)/sqrt(4*zdepth*zdepth+(xwidth-xwidth2)*(xwidth-xwidth2));

this_box_storage.normal_vectors[2] = coords_set(x_component,0,z_component);
this_box_storage.normal_vectors[3] = coords_set(-x_component,0,z_component);

// for sides with x component = 0
y_component = 2*zdepth/sqrt((yheight-yheight2)*(yheight-yheight2)+4*zdepth*zdepth);
z_component = (yheight-yheight2)/sqrt(4*zdepth*zdepth+(yheight-yheight2)*(yheight-yheight2));

this_box_storage.normal_vectors[4] = coords_set(0,y_component,z_component);
this_box_storage.normal_vectors[5] = coords_set(0,-y_component,z_component);

this_box_volume.geometry.visualization_on = visualize;

this_box_volume.geometry.geometry_parameters.p_box_storage = &this_box_storage;

// Assign pointers to functions for intersection with the shape, checking if a point is inside the shape
if (this_box_storage.is_rectangle == 1) {
this_box_volume.geometry.intersect_function = &sample_box_intersect_simple;
this_box_volume.geometry.within_function = &r_within_box_simple;
}
else {
this_box_volume.geometry.intersect_function = &sample_box_intersect_advanced;
this_box_volume.geometry.within_function = &r_within_box_advanced;
}

this_box_volume.geometry.shell_points = &box_shell_points;
this_box_volume.geometry.mcdisplay_function = &mcdisplay_box_function;
this_box_volume.geometry.initialize_from_main_function = &initialize_box_geometry_from_main_component;
this_box_volume.geometry.process_rot_allocated = 0;

this_box_volume.geometry.copy_geometry_parameters = &allocate_box_storage_copy;

rot_copy(this_box_volume.geometry.rotation_matrix,ROT_A_CURRENT_COMP); //check how ROT_R_CURRENT_COMP would work
rot_transpose(ROT_A_CURRENT_COMP,this_box_volume.geometry.transpose_rotation_matrix);

// Initialize loggers
this_box_volume.loggers.num_elements = 0;

// packing the information into the global_geometry_element, which is then included in the global_geometry_list.
sprintf(global_geometry_element.name,NAME_CURRENT_COMP);
global_geometry_element.activation_counter = number_of_activations;
global_geometry_element.component_index = INDEX_CURRENT_COMP;
global_geometry_element.Volume = &this_box_volume; // Would be nicer if this m was a pointer, now we have the (small) data two places
add_element_to_geometry_list(&global_geometry_list,global_geometry_element);
}
#line 195452 "MACS_sample_kidney_box.c"
#undef number_of_activations
#undef mask_setting
#undef mask_string
#undef p_interact
#undef focus_r
#undef focus_xh
#undef focus_xw
#undef focus_ah
#undef focus_aw
#undef target_z
#undef target_y
#undef target_x
#undef target_index
#undef visualize
#undef yheight2
#undef xwidth2
#undef zdepth
#undef yheight
#undef xwidth
#undef priority
#undef material_string
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

  /* Initializations for component channel_3_analyzer_2_array_crystal_array_4. */
  SIG_MESSAGE("channel_3_analyzer_2_array_crystal_array_4 (Init)");
#define mccompcurname  channel_3_analyzer_2_array_crystal_array_4
#define mccompcurtype  Union_box
#define mccompcurindex 259
#define loop_index mccchannel_3_analyzer_2_array_crystal_array_4_loop_index
#define this_box_volume mccchannel_3_analyzer_2_array_crystal_array_4_this_box_volume
#define global_geometry_element mccchannel_3_analyzer_2_array_crystal_array_4_global_geometry_element
#define this_box_storage mccchannel_3_analyzer_2_array_crystal_array_4_this_box_storage
#define material_string mccchannel_3_analyzer_2_array_crystal_array_4_material_string
#define priority mccchannel_3_analyzer_2_array_crystal_array_4_priority
#define xwidth mccchannel_3_analyzer_2_array_crystal_array_4_xwidth
#define yheight mccchannel_3_analyzer_2_array_crystal_array_4_yheight
#define zdepth mccchannel_3_analyzer_2_array_crystal_array_4_zdepth
#define xwidth2 mccchannel_3_analyzer_2_array_crystal_array_4_xwidth2
#define yheight2 mccchannel_3_analyzer_2_array_crystal_array_4_yheight2
#define visualize mccchannel_3_analyzer_2_array_crystal_array_4_visualize
#define target_index mccchannel_3_analyzer_2_array_crystal_array_4_target_index
#define target_x mccchannel_3_analyzer_2_array_crystal_array_4_target_x
#define target_y mccchannel_3_analyzer_2_array_crystal_array_4_target_y
#define target_z mccchannel_3_analyzer_2_array_crystal_array_4_target_z
#define focus_aw mccchannel_3_analyzer_2_array_crystal_array_4_focus_aw
#define focus_ah mccchannel_3_analyzer_2_array_crystal_array_4_focus_ah
#define focus_xw mccchannel_3_analyzer_2_array_crystal_array_4_focus_xw
#define focus_xh mccchannel_3_analyzer_2_array_crystal_array_4_focus_xh
#define focus_r mccchannel_3_analyzer_2_array_crystal_array_4_focus_r
#define p_interact mccchannel_3_analyzer_2_array_crystal_array_4_p_interact
#define mask_string mccchannel_3_analyzer_2_array_crystal_array_4_mask_string
#define mask_setting mccchannel_3_analyzer_2_array_crystal_array_4_mask_setting
#define number_of_activations mccchannel_3_analyzer_2_array_crystal_array_4_number_of_activations
#line 224 "Union_box.comp"
{
// Initializes the focusing system for this volume including input sanitation.
focus_initialize(&this_box_volume.geometry, POS_A_COMP_INDEX(INDEX_CURRENT_COMP+target_index), POS_A_CURRENT_COMP, ROT_A_CURRENT_COMP, target_index, target_x, target_y, target_z, focus_aw, focus_ah, focus_xw, focus_xh, focus_r, NAME_CURRENT_COMP);

// Input sanitation for this geometry
if (xwidth <= 0) {
  printf("\nERROR in Union_box named %s, the xwidth is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (yheight <= 0) {
  printf("\nERROR in Union_box named %s, yheight is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (zdepth <= 0) {
  printf("\nERROR in Union_box named %s, zdepth is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (xwidth2 <= 0 && xwidth2 != -1) {
  printf("\nERROR in Union_box named %s, the xwidth2 is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (yheight2 <= 0 && yheight2 != -1) {
  printf("\nERROR in Union_box named %s, yheight2 is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}

// Use sanitation
if (global_material_list.num_elements == 0) {
  printf("\nERROR: Need to define a material using Union_make_material before using a Union geometry component. \n");
  printf("       %s was defined before first use of Union_make_material.\n",NAME_CURRENT_COMP);
  exit(1);
}

this_box_volume.geometry.is_masked_volume = 0;
this_box_volume.geometry.is_exit_volume = 0;
this_box_volume.geometry.is_mask_volume = 0;
// check if the volume is a mask, if it is the material string is irelevant.
if (mask_string && strlen(mask_string) && strcmp(mask_string, "NULL") && strcmp(mask_string, "0")) {
    // A mask volume is used to limit the extend of other volumes, called the masked volumes. These are specified in the mask_string.
    // In order for a ray to enter a masked volume, it needs to be both in the region covered by that volume AND the mask volume.
    // When more than
    this_box_volume.geometry.mask_mode = 1; // Default is mask mode is ALL
    if (mask_setting && strlen(mask_setting) && strcmp(mask_setting, "NULL") && strcmp(mask_setting, "0")) {
        if (strcmp(mask_setting,"ALL") == 0 || strcmp(mask_setting,"All") == 0) this_box_volume.geometry.mask_mode = 1;
        else if (strcmp(mask_setting,"ANY") == 0 || strcmp(mask_setting,"Any") == 0) this_box_volume.geometry.mask_mode = 2;
        else {
            printf("The mask_mode of component %s is set to %s, but must be either ALL or ANY.\n",NAME_CURRENT_COMP,mask_setting);
            exit(1);
        }
    }
    
    for (loop_index=0;loop_index<global_geometry_list.num_elements;loop_index++) {
        // Add mask list
        if (1 == manual_linking_function(global_geometry_list.elements[loop_index].name,mask_string)) {
            add_element_to_int_list(&this_box_volume.geometry.mask_list,global_geometry_list.elements[loop_index].component_index);
            add_element_to_int_list(&global_geometry_list.elements[loop_index].Volume->geometry.masked_by_list,INDEX_CURRENT_COMP);
            global_geometry_list.elements[loop_index].Volume->geometry.is_masked_volume = 1;
            if (this_box_volume.geometry.mask_mode == 2)
                global_geometry_list.elements[loop_index].Volume->geometry.mask_mode = 2;
            if (this_box_volume.geometry.mask_mode == 1) {
                if (global_geometry_list.elements[loop_index].Volume->geometry.is_masked_volume == 1 && global_geometry_list.elements[loop_index].Volume->geometry.mask_mode != 2)
                    // If more than one mask is added to one volume, the ANY mode overwrites the (default) ALL mode.
                    global_geometry_list.elements[loop_index].Volume->geometry.mask_mode = 1;
            }
            
            found_geometries = 1;
        }
    }
    if (found_geometries == 0) {
        printf("The mask_string in geometry: %s did not find any of the specified volumes in the mask_string %s \n",NAME_CURRENT_COMP,mask_string);
        exit(1);
    }
    this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
    this_box_volume.p_physics->is_vacuum = 0; // Makes this volume a vacuum
    this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
    this_box_volume.p_physics->my_a = 0; // Should not be used.
    sprintf(this_box_volume.p_physics->name,"Mask");
    this_box_volume.geometry.is_mask_volume = 1;
    
    
// Read the material input, or if it lacks, use automatic linking.
} else if (material_string && strlen(material_string) && strcmp(material_string, "NULL") && strcmp(material_string, "0")) {
    // A geometry string was given, use it to determine which material
    if (0 == strcmp(material_string,"vacuum") || 0 == strcmp(material_string,"Vacuum")) {
        // One could have a global physics struct for vacuum instead of creating one for each
        this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
        this_box_volume.p_physics->is_vacuum = 1; // Makes this volume a vacuum
        this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
        this_box_volume.p_physics->my_a = 0; // Should not be used.
        sprintf(this_box_volume.p_physics->name,"Vacuum");
    } else if (0 == strcmp(material_string,"exit") || 0 == strcmp(material_string,"Exit")) {
        // One could have a global physics struct for vacuum instead of creating one for each
        this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
        this_box_volume.p_physics->is_vacuum = 1; // Makes this volume a vacuum
        this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
        this_box_volume.p_physics->my_a = 0; // Should not be used.
        this_box_volume.geometry.is_exit_volume = 1;
        sprintf(this_box_volume.p_physics->name,"Exit");
    } else {
        #ifndef MATERIAL_DETECTOR
            printf("Need to define a material before refering to it in a geometry %s.\n",NAME_CURRENT_COMP);
            exit(1);
        #endif
        for (loop_index=0;loop_index<global_material_list.num_elements;loop_index++) {
            if (0 == strcmp(material_string,global_material_list.elements[loop_index].name)) {
                this_box_volume.p_physics = global_material_list.elements[loop_index].physics;
                break;
            }
            if (loop_index == global_material_list.num_elements-1) {
            printf("\n");
            printf("ERROR: The material string \"%s\" in Union geometry \"%s\" did not match a specified material. \n",material_string,NAME_CURRENT_COMP);
            printf("       The materials available at this point (need to be defined before the geometry): \n");
            for (loop_index=0;loop_index<global_material_list.num_elements;loop_index++)
              printf("         %s\n",global_material_list.elements[loop_index].name);
            printf("\n");
            printf("       It is also possible to use one of the defualt materials avaiable: \n");
            printf("           Vacuum (for a Volume without scattering or absorption)\n");
            printf("           Exit (for a Volume where the ray exits the component if it enters)\n");
            printf("           Mask (for a Volume that masks existing volumes specified in the mask_string\n");
            exit(1);
          }
        }
    }
} else {
    // Automatic linking, simply using the last defined material.
    #ifndef MATERIAL_DETECTOR
        printf("Need to define a material before the geometry to use automatic linking %s.\n",NAME_CURRENT_COMP);
        exit(1);
    #endif
    this_box_volume.p_physics = global_material_list.elements[global_material_list.num_elements-1].physics;
}

sprintf(this_box_volume.name,NAME_CURRENT_COMP);
sprintf(this_box_volume.geometry.shape,"box");
this_box_volume.geometry.priority_value = priority;
this_box_volume.geometry.geometry_p_interact = p_interact;
// Currently the coordinates will be in absolute space.
this_box_volume.geometry.center = POS_A_CURRENT_COMP;

this_box_storage.z_depth = zdepth;
this_box_storage.x_width1 = xwidth;
this_box_storage.y_height1 = yheight;

this_box_storage.is_rectangle = 0;
if (xwidth2 < 0 && yheight2 < 0) this_box_storage.is_rectangle = 1;
if (xwidth == xwidth2 && yheight == yheight2) this_box_storage.is_rectangle = 1;

if (xwidth2 < 0) {
    this_box_storage.x_width2 = xwidth;
    xwidth2 = xwidth;
} else this_box_storage.x_width2 = xwidth2;

if (yheight2 < 0) {
    this_box_storage.y_height2 = yheight;
    yheight2 = yheight;
} else this_box_storage.y_height2 = yheight2;


this_box_storage.normal_vectors[0] = coords_set(0,0,1);
this_box_storage.normal_vectors[1] = coords_set(0,0,1);

// for sides with y component = 0
x_component = 2*zdepth/sqrt((xwidth-xwidth2)*(xwidth-xwidth2)+4*zdepth*zdepth);
z_component = (xwidth-xwidth2)/sqrt(4*zdepth*zdepth+(xwidth-xwidth2)*(xwidth-xwidth2));

this_box_storage.normal_vectors[2] = coords_set(x_component,0,z_component);
this_box_storage.normal_vectors[3] = coords_set(-x_component,0,z_component);

// for sides with x component = 0
y_component = 2*zdepth/sqrt((yheight-yheight2)*(yheight-yheight2)+4*zdepth*zdepth);
z_component = (yheight-yheight2)/sqrt(4*zdepth*zdepth+(yheight-yheight2)*(yheight-yheight2));

this_box_storage.normal_vectors[4] = coords_set(0,y_component,z_component);
this_box_storage.normal_vectors[5] = coords_set(0,-y_component,z_component);

this_box_volume.geometry.visualization_on = visualize;

this_box_volume.geometry.geometry_parameters.p_box_storage = &this_box_storage;

// Assign pointers to functions for intersection with the shape, checking if a point is inside the shape
if (this_box_storage.is_rectangle == 1) {
this_box_volume.geometry.intersect_function = &sample_box_intersect_simple;
this_box_volume.geometry.within_function = &r_within_box_simple;
}
else {
this_box_volume.geometry.intersect_function = &sample_box_intersect_advanced;
this_box_volume.geometry.within_function = &r_within_box_advanced;
}

this_box_volume.geometry.shell_points = &box_shell_points;
this_box_volume.geometry.mcdisplay_function = &mcdisplay_box_function;
this_box_volume.geometry.initialize_from_main_function = &initialize_box_geometry_from_main_component;
this_box_volume.geometry.process_rot_allocated = 0;

this_box_volume.geometry.copy_geometry_parameters = &allocate_box_storage_copy;

rot_copy(this_box_volume.geometry.rotation_matrix,ROT_A_CURRENT_COMP); //check how ROT_R_CURRENT_COMP would work
rot_transpose(ROT_A_CURRENT_COMP,this_box_volume.geometry.transpose_rotation_matrix);

// Initialize loggers
this_box_volume.loggers.num_elements = 0;

// packing the information into the global_geometry_element, which is then included in the global_geometry_list.
sprintf(global_geometry_element.name,NAME_CURRENT_COMP);
global_geometry_element.activation_counter = number_of_activations;
global_geometry_element.component_index = INDEX_CURRENT_COMP;
global_geometry_element.Volume = &this_box_volume; // Would be nicer if this m was a pointer, now we have the (small) data two places
add_element_to_geometry_list(&global_geometry_list,global_geometry_element);
}
#line 195722 "MACS_sample_kidney_box.c"
#undef number_of_activations
#undef mask_setting
#undef mask_string
#undef p_interact
#undef focus_r
#undef focus_xh
#undef focus_xw
#undef focus_ah
#undef focus_aw
#undef target_z
#undef target_y
#undef target_x
#undef target_index
#undef visualize
#undef yheight2
#undef xwidth2
#undef zdepth
#undef yheight
#undef xwidth
#undef priority
#undef material_string
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

  /* Initializations for component channel_3_analyzer_2_array_crystal_array_5. */
  SIG_MESSAGE("channel_3_analyzer_2_array_crystal_array_5 (Init)");
#define mccompcurname  channel_3_analyzer_2_array_crystal_array_5
#define mccompcurtype  Union_box
#define mccompcurindex 260
#define loop_index mccchannel_3_analyzer_2_array_crystal_array_5_loop_index
#define this_box_volume mccchannel_3_analyzer_2_array_crystal_array_5_this_box_volume
#define global_geometry_element mccchannel_3_analyzer_2_array_crystal_array_5_global_geometry_element
#define this_box_storage mccchannel_3_analyzer_2_array_crystal_array_5_this_box_storage
#define material_string mccchannel_3_analyzer_2_array_crystal_array_5_material_string
#define priority mccchannel_3_analyzer_2_array_crystal_array_5_priority
#define xwidth mccchannel_3_analyzer_2_array_crystal_array_5_xwidth
#define yheight mccchannel_3_analyzer_2_array_crystal_array_5_yheight
#define zdepth mccchannel_3_analyzer_2_array_crystal_array_5_zdepth
#define xwidth2 mccchannel_3_analyzer_2_array_crystal_array_5_xwidth2
#define yheight2 mccchannel_3_analyzer_2_array_crystal_array_5_yheight2
#define visualize mccchannel_3_analyzer_2_array_crystal_array_5_visualize
#define target_index mccchannel_3_analyzer_2_array_crystal_array_5_target_index
#define target_x mccchannel_3_analyzer_2_array_crystal_array_5_target_x
#define target_y mccchannel_3_analyzer_2_array_crystal_array_5_target_y
#define target_z mccchannel_3_analyzer_2_array_crystal_array_5_target_z
#define focus_aw mccchannel_3_analyzer_2_array_crystal_array_5_focus_aw
#define focus_ah mccchannel_3_analyzer_2_array_crystal_array_5_focus_ah
#define focus_xw mccchannel_3_analyzer_2_array_crystal_array_5_focus_xw
#define focus_xh mccchannel_3_analyzer_2_array_crystal_array_5_focus_xh
#define focus_r mccchannel_3_analyzer_2_array_crystal_array_5_focus_r
#define p_interact mccchannel_3_analyzer_2_array_crystal_array_5_p_interact
#define mask_string mccchannel_3_analyzer_2_array_crystal_array_5_mask_string
#define mask_setting mccchannel_3_analyzer_2_array_crystal_array_5_mask_setting
#define number_of_activations mccchannel_3_analyzer_2_array_crystal_array_5_number_of_activations
#line 224 "Union_box.comp"
{
// Initializes the focusing system for this volume including input sanitation.
focus_initialize(&this_box_volume.geometry, POS_A_COMP_INDEX(INDEX_CURRENT_COMP+target_index), POS_A_CURRENT_COMP, ROT_A_CURRENT_COMP, target_index, target_x, target_y, target_z, focus_aw, focus_ah, focus_xw, focus_xh, focus_r, NAME_CURRENT_COMP);

// Input sanitation for this geometry
if (xwidth <= 0) {
  printf("\nERROR in Union_box named %s, the xwidth is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (yheight <= 0) {
  printf("\nERROR in Union_box named %s, yheight is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (zdepth <= 0) {
  printf("\nERROR in Union_box named %s, zdepth is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (xwidth2 <= 0 && xwidth2 != -1) {
  printf("\nERROR in Union_box named %s, the xwidth2 is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (yheight2 <= 0 && yheight2 != -1) {
  printf("\nERROR in Union_box named %s, yheight2 is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}

// Use sanitation
if (global_material_list.num_elements == 0) {
  printf("\nERROR: Need to define a material using Union_make_material before using a Union geometry component. \n");
  printf("       %s was defined before first use of Union_make_material.\n",NAME_CURRENT_COMP);
  exit(1);
}

this_box_volume.geometry.is_masked_volume = 0;
this_box_volume.geometry.is_exit_volume = 0;
this_box_volume.geometry.is_mask_volume = 0;
// check if the volume is a mask, if it is the material string is irelevant.
if (mask_string && strlen(mask_string) && strcmp(mask_string, "NULL") && strcmp(mask_string, "0")) {
    // A mask volume is used to limit the extend of other volumes, called the masked volumes. These are specified in the mask_string.
    // In order for a ray to enter a masked volume, it needs to be both in the region covered by that volume AND the mask volume.
    // When more than
    this_box_volume.geometry.mask_mode = 1; // Default is mask mode is ALL
    if (mask_setting && strlen(mask_setting) && strcmp(mask_setting, "NULL") && strcmp(mask_setting, "0")) {
        if (strcmp(mask_setting,"ALL") == 0 || strcmp(mask_setting,"All") == 0) this_box_volume.geometry.mask_mode = 1;
        else if (strcmp(mask_setting,"ANY") == 0 || strcmp(mask_setting,"Any") == 0) this_box_volume.geometry.mask_mode = 2;
        else {
            printf("The mask_mode of component %s is set to %s, but must be either ALL or ANY.\n",NAME_CURRENT_COMP,mask_setting);
            exit(1);
        }
    }
    
    for (loop_index=0;loop_index<global_geometry_list.num_elements;loop_index++) {
        // Add mask list
        if (1 == manual_linking_function(global_geometry_list.elements[loop_index].name,mask_string)) {
            add_element_to_int_list(&this_box_volume.geometry.mask_list,global_geometry_list.elements[loop_index].component_index);
            add_element_to_int_list(&global_geometry_list.elements[loop_index].Volume->geometry.masked_by_list,INDEX_CURRENT_COMP);
            global_geometry_list.elements[loop_index].Volume->geometry.is_masked_volume = 1;
            if (this_box_volume.geometry.mask_mode == 2)
                global_geometry_list.elements[loop_index].Volume->geometry.mask_mode = 2;
            if (this_box_volume.geometry.mask_mode == 1) {
                if (global_geometry_list.elements[loop_index].Volume->geometry.is_masked_volume == 1 && global_geometry_list.elements[loop_index].Volume->geometry.mask_mode != 2)
                    // If more than one mask is added to one volume, the ANY mode overwrites the (default) ALL mode.
                    global_geometry_list.elements[loop_index].Volume->geometry.mask_mode = 1;
            }
            
            found_geometries = 1;
        }
    }
    if (found_geometries == 0) {
        printf("The mask_string in geometry: %s did not find any of the specified volumes in the mask_string %s \n",NAME_CURRENT_COMP,mask_string);
        exit(1);
    }
    this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
    this_box_volume.p_physics->is_vacuum = 0; // Makes this volume a vacuum
    this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
    this_box_volume.p_physics->my_a = 0; // Should not be used.
    sprintf(this_box_volume.p_physics->name,"Mask");
    this_box_volume.geometry.is_mask_volume = 1;
    
    
// Read the material input, or if it lacks, use automatic linking.
} else if (material_string && strlen(material_string) && strcmp(material_string, "NULL") && strcmp(material_string, "0")) {
    // A geometry string was given, use it to determine which material
    if (0 == strcmp(material_string,"vacuum") || 0 == strcmp(material_string,"Vacuum")) {
        // One could have a global physics struct for vacuum instead of creating one for each
        this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
        this_box_volume.p_physics->is_vacuum = 1; // Makes this volume a vacuum
        this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
        this_box_volume.p_physics->my_a = 0; // Should not be used.
        sprintf(this_box_volume.p_physics->name,"Vacuum");
    } else if (0 == strcmp(material_string,"exit") || 0 == strcmp(material_string,"Exit")) {
        // One could have a global physics struct for vacuum instead of creating one for each
        this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
        this_box_volume.p_physics->is_vacuum = 1; // Makes this volume a vacuum
        this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
        this_box_volume.p_physics->my_a = 0; // Should not be used.
        this_box_volume.geometry.is_exit_volume = 1;
        sprintf(this_box_volume.p_physics->name,"Exit");
    } else {
        #ifndef MATERIAL_DETECTOR
            printf("Need to define a material before refering to it in a geometry %s.\n",NAME_CURRENT_COMP);
            exit(1);
        #endif
        for (loop_index=0;loop_index<global_material_list.num_elements;loop_index++) {
            if (0 == strcmp(material_string,global_material_list.elements[loop_index].name)) {
                this_box_volume.p_physics = global_material_list.elements[loop_index].physics;
                break;
            }
            if (loop_index == global_material_list.num_elements-1) {
            printf("\n");
            printf("ERROR: The material string \"%s\" in Union geometry \"%s\" did not match a specified material. \n",material_string,NAME_CURRENT_COMP);
            printf("       The materials available at this point (need to be defined before the geometry): \n");
            for (loop_index=0;loop_index<global_material_list.num_elements;loop_index++)
              printf("         %s\n",global_material_list.elements[loop_index].name);
            printf("\n");
            printf("       It is also possible to use one of the defualt materials avaiable: \n");
            printf("           Vacuum (for a Volume without scattering or absorption)\n");
            printf("           Exit (for a Volume where the ray exits the component if it enters)\n");
            printf("           Mask (for a Volume that masks existing volumes specified in the mask_string\n");
            exit(1);
          }
        }
    }
} else {
    // Automatic linking, simply using the last defined material.
    #ifndef MATERIAL_DETECTOR
        printf("Need to define a material before the geometry to use automatic linking %s.\n",NAME_CURRENT_COMP);
        exit(1);
    #endif
    this_box_volume.p_physics = global_material_list.elements[global_material_list.num_elements-1].physics;
}

sprintf(this_box_volume.name,NAME_CURRENT_COMP);
sprintf(this_box_volume.geometry.shape,"box");
this_box_volume.geometry.priority_value = priority;
this_box_volume.geometry.geometry_p_interact = p_interact;
// Currently the coordinates will be in absolute space.
this_box_volume.geometry.center = POS_A_CURRENT_COMP;

this_box_storage.z_depth = zdepth;
this_box_storage.x_width1 = xwidth;
this_box_storage.y_height1 = yheight;

this_box_storage.is_rectangle = 0;
if (xwidth2 < 0 && yheight2 < 0) this_box_storage.is_rectangle = 1;
if (xwidth == xwidth2 && yheight == yheight2) this_box_storage.is_rectangle = 1;

if (xwidth2 < 0) {
    this_box_storage.x_width2 = xwidth;
    xwidth2 = xwidth;
} else this_box_storage.x_width2 = xwidth2;

if (yheight2 < 0) {
    this_box_storage.y_height2 = yheight;
    yheight2 = yheight;
} else this_box_storage.y_height2 = yheight2;


this_box_storage.normal_vectors[0] = coords_set(0,0,1);
this_box_storage.normal_vectors[1] = coords_set(0,0,1);

// for sides with y component = 0
x_component = 2*zdepth/sqrt((xwidth-xwidth2)*(xwidth-xwidth2)+4*zdepth*zdepth);
z_component = (xwidth-xwidth2)/sqrt(4*zdepth*zdepth+(xwidth-xwidth2)*(xwidth-xwidth2));

this_box_storage.normal_vectors[2] = coords_set(x_component,0,z_component);
this_box_storage.normal_vectors[3] = coords_set(-x_component,0,z_component);

// for sides with x component = 0
y_component = 2*zdepth/sqrt((yheight-yheight2)*(yheight-yheight2)+4*zdepth*zdepth);
z_component = (yheight-yheight2)/sqrt(4*zdepth*zdepth+(yheight-yheight2)*(yheight-yheight2));

this_box_storage.normal_vectors[4] = coords_set(0,y_component,z_component);
this_box_storage.normal_vectors[5] = coords_set(0,-y_component,z_component);

this_box_volume.geometry.visualization_on = visualize;

this_box_volume.geometry.geometry_parameters.p_box_storage = &this_box_storage;

// Assign pointers to functions for intersection with the shape, checking if a point is inside the shape
if (this_box_storage.is_rectangle == 1) {
this_box_volume.geometry.intersect_function = &sample_box_intersect_simple;
this_box_volume.geometry.within_function = &r_within_box_simple;
}
else {
this_box_volume.geometry.intersect_function = &sample_box_intersect_advanced;
this_box_volume.geometry.within_function = &r_within_box_advanced;
}

this_box_volume.geometry.shell_points = &box_shell_points;
this_box_volume.geometry.mcdisplay_function = &mcdisplay_box_function;
this_box_volume.geometry.initialize_from_main_function = &initialize_box_geometry_from_main_component;
this_box_volume.geometry.process_rot_allocated = 0;

this_box_volume.geometry.copy_geometry_parameters = &allocate_box_storage_copy;

rot_copy(this_box_volume.geometry.rotation_matrix,ROT_A_CURRENT_COMP); //check how ROT_R_CURRENT_COMP would work
rot_transpose(ROT_A_CURRENT_COMP,this_box_volume.geometry.transpose_rotation_matrix);

// Initialize loggers
this_box_volume.loggers.num_elements = 0;

// packing the information into the global_geometry_element, which is then included in the global_geometry_list.
sprintf(global_geometry_element.name,NAME_CURRENT_COMP);
global_geometry_element.activation_counter = number_of_activations;
global_geometry_element.component_index = INDEX_CURRENT_COMP;
global_geometry_element.Volume = &this_box_volume; // Would be nicer if this m was a pointer, now we have the (small) data two places
add_element_to_geometry_list(&global_geometry_list,global_geometry_element);
}
#line 195992 "MACS_sample_kidney_box.c"
#undef number_of_activations
#undef mask_setting
#undef mask_string
#undef p_interact
#undef focus_r
#undef focus_xh
#undef focus_xw
#undef focus_ah
#undef focus_aw
#undef target_z
#undef target_y
#undef target_x
#undef target_index
#undef visualize
#undef yheight2
#undef xwidth2
#undef zdepth
#undef yheight
#undef xwidth
#undef priority
#undef material_string
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

  /* Initializations for component channel_3_analyzer_2_array_crystal_array_6. */
  SIG_MESSAGE("channel_3_analyzer_2_array_crystal_array_6 (Init)");
#define mccompcurname  channel_3_analyzer_2_array_crystal_array_6
#define mccompcurtype  Union_box
#define mccompcurindex 261
#define loop_index mccchannel_3_analyzer_2_array_crystal_array_6_loop_index
#define this_box_volume mccchannel_3_analyzer_2_array_crystal_array_6_this_box_volume
#define global_geometry_element mccchannel_3_analyzer_2_array_crystal_array_6_global_geometry_element
#define this_box_storage mccchannel_3_analyzer_2_array_crystal_array_6_this_box_storage
#define material_string mccchannel_3_analyzer_2_array_crystal_array_6_material_string
#define priority mccchannel_3_analyzer_2_array_crystal_array_6_priority
#define xwidth mccchannel_3_analyzer_2_array_crystal_array_6_xwidth
#define yheight mccchannel_3_analyzer_2_array_crystal_array_6_yheight
#define zdepth mccchannel_3_analyzer_2_array_crystal_array_6_zdepth
#define xwidth2 mccchannel_3_analyzer_2_array_crystal_array_6_xwidth2
#define yheight2 mccchannel_3_analyzer_2_array_crystal_array_6_yheight2
#define visualize mccchannel_3_analyzer_2_array_crystal_array_6_visualize
#define target_index mccchannel_3_analyzer_2_array_crystal_array_6_target_index
#define target_x mccchannel_3_analyzer_2_array_crystal_array_6_target_x
#define target_y mccchannel_3_analyzer_2_array_crystal_array_6_target_y
#define target_z mccchannel_3_analyzer_2_array_crystal_array_6_target_z
#define focus_aw mccchannel_3_analyzer_2_array_crystal_array_6_focus_aw
#define focus_ah mccchannel_3_analyzer_2_array_crystal_array_6_focus_ah
#define focus_xw mccchannel_3_analyzer_2_array_crystal_array_6_focus_xw
#define focus_xh mccchannel_3_analyzer_2_array_crystal_array_6_focus_xh
#define focus_r mccchannel_3_analyzer_2_array_crystal_array_6_focus_r
#define p_interact mccchannel_3_analyzer_2_array_crystal_array_6_p_interact
#define mask_string mccchannel_3_analyzer_2_array_crystal_array_6_mask_string
#define mask_setting mccchannel_3_analyzer_2_array_crystal_array_6_mask_setting
#define number_of_activations mccchannel_3_analyzer_2_array_crystal_array_6_number_of_activations
#line 224 "Union_box.comp"
{
// Initializes the focusing system for this volume including input sanitation.
focus_initialize(&this_box_volume.geometry, POS_A_COMP_INDEX(INDEX_CURRENT_COMP+target_index), POS_A_CURRENT_COMP, ROT_A_CURRENT_COMP, target_index, target_x, target_y, target_z, focus_aw, focus_ah, focus_xw, focus_xh, focus_r, NAME_CURRENT_COMP);

// Input sanitation for this geometry
if (xwidth <= 0) {
  printf("\nERROR in Union_box named %s, the xwidth is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (yheight <= 0) {
  printf("\nERROR in Union_box named %s, yheight is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (zdepth <= 0) {
  printf("\nERROR in Union_box named %s, zdepth is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (xwidth2 <= 0 && xwidth2 != -1) {
  printf("\nERROR in Union_box named %s, the xwidth2 is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (yheight2 <= 0 && yheight2 != -1) {
  printf("\nERROR in Union_box named %s, yheight2 is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}

// Use sanitation
if (global_material_list.num_elements == 0) {
  printf("\nERROR: Need to define a material using Union_make_material before using a Union geometry component. \n");
  printf("       %s was defined before first use of Union_make_material.\n",NAME_CURRENT_COMP);
  exit(1);
}

this_box_volume.geometry.is_masked_volume = 0;
this_box_volume.geometry.is_exit_volume = 0;
this_box_volume.geometry.is_mask_volume = 0;
// check if the volume is a mask, if it is the material string is irelevant.
if (mask_string && strlen(mask_string) && strcmp(mask_string, "NULL") && strcmp(mask_string, "0")) {
    // A mask volume is used to limit the extend of other volumes, called the masked volumes. These are specified in the mask_string.
    // In order for a ray to enter a masked volume, it needs to be both in the region covered by that volume AND the mask volume.
    // When more than
    this_box_volume.geometry.mask_mode = 1; // Default is mask mode is ALL
    if (mask_setting && strlen(mask_setting) && strcmp(mask_setting, "NULL") && strcmp(mask_setting, "0")) {
        if (strcmp(mask_setting,"ALL") == 0 || strcmp(mask_setting,"All") == 0) this_box_volume.geometry.mask_mode = 1;
        else if (strcmp(mask_setting,"ANY") == 0 || strcmp(mask_setting,"Any") == 0) this_box_volume.geometry.mask_mode = 2;
        else {
            printf("The mask_mode of component %s is set to %s, but must be either ALL or ANY.\n",NAME_CURRENT_COMP,mask_setting);
            exit(1);
        }
    }
    
    for (loop_index=0;loop_index<global_geometry_list.num_elements;loop_index++) {
        // Add mask list
        if (1 == manual_linking_function(global_geometry_list.elements[loop_index].name,mask_string)) {
            add_element_to_int_list(&this_box_volume.geometry.mask_list,global_geometry_list.elements[loop_index].component_index);
            add_element_to_int_list(&global_geometry_list.elements[loop_index].Volume->geometry.masked_by_list,INDEX_CURRENT_COMP);
            global_geometry_list.elements[loop_index].Volume->geometry.is_masked_volume = 1;
            if (this_box_volume.geometry.mask_mode == 2)
                global_geometry_list.elements[loop_index].Volume->geometry.mask_mode = 2;
            if (this_box_volume.geometry.mask_mode == 1) {
                if (global_geometry_list.elements[loop_index].Volume->geometry.is_masked_volume == 1 && global_geometry_list.elements[loop_index].Volume->geometry.mask_mode != 2)
                    // If more than one mask is added to one volume, the ANY mode overwrites the (default) ALL mode.
                    global_geometry_list.elements[loop_index].Volume->geometry.mask_mode = 1;
            }
            
            found_geometries = 1;
        }
    }
    if (found_geometries == 0) {
        printf("The mask_string in geometry: %s did not find any of the specified volumes in the mask_string %s \n",NAME_CURRENT_COMP,mask_string);
        exit(1);
    }
    this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
    this_box_volume.p_physics->is_vacuum = 0; // Makes this volume a vacuum
    this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
    this_box_volume.p_physics->my_a = 0; // Should not be used.
    sprintf(this_box_volume.p_physics->name,"Mask");
    this_box_volume.geometry.is_mask_volume = 1;
    
    
// Read the material input, or if it lacks, use automatic linking.
} else if (material_string && strlen(material_string) && strcmp(material_string, "NULL") && strcmp(material_string, "0")) {
    // A geometry string was given, use it to determine which material
    if (0 == strcmp(material_string,"vacuum") || 0 == strcmp(material_string,"Vacuum")) {
        // One could have a global physics struct for vacuum instead of creating one for each
        this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
        this_box_volume.p_physics->is_vacuum = 1; // Makes this volume a vacuum
        this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
        this_box_volume.p_physics->my_a = 0; // Should not be used.
        sprintf(this_box_volume.p_physics->name,"Vacuum");
    } else if (0 == strcmp(material_string,"exit") || 0 == strcmp(material_string,"Exit")) {
        // One could have a global physics struct for vacuum instead of creating one for each
        this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
        this_box_volume.p_physics->is_vacuum = 1; // Makes this volume a vacuum
        this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
        this_box_volume.p_physics->my_a = 0; // Should not be used.
        this_box_volume.geometry.is_exit_volume = 1;
        sprintf(this_box_volume.p_physics->name,"Exit");
    } else {
        #ifndef MATERIAL_DETECTOR
            printf("Need to define a material before refering to it in a geometry %s.\n",NAME_CURRENT_COMP);
            exit(1);
        #endif
        for (loop_index=0;loop_index<global_material_list.num_elements;loop_index++) {
            if (0 == strcmp(material_string,global_material_list.elements[loop_index].name)) {
                this_box_volume.p_physics = global_material_list.elements[loop_index].physics;
                break;
            }
            if (loop_index == global_material_list.num_elements-1) {
            printf("\n");
            printf("ERROR: The material string \"%s\" in Union geometry \"%s\" did not match a specified material. \n",material_string,NAME_CURRENT_COMP);
            printf("       The materials available at this point (need to be defined before the geometry): \n");
            for (loop_index=0;loop_index<global_material_list.num_elements;loop_index++)
              printf("         %s\n",global_material_list.elements[loop_index].name);
            printf("\n");
            printf("       It is also possible to use one of the defualt materials avaiable: \n");
            printf("           Vacuum (for a Volume without scattering or absorption)\n");
            printf("           Exit (for a Volume where the ray exits the component if it enters)\n");
            printf("           Mask (for a Volume that masks existing volumes specified in the mask_string\n");
            exit(1);
          }
        }
    }
} else {
    // Automatic linking, simply using the last defined material.
    #ifndef MATERIAL_DETECTOR
        printf("Need to define a material before the geometry to use automatic linking %s.\n",NAME_CURRENT_COMP);
        exit(1);
    #endif
    this_box_volume.p_physics = global_material_list.elements[global_material_list.num_elements-1].physics;
}

sprintf(this_box_volume.name,NAME_CURRENT_COMP);
sprintf(this_box_volume.geometry.shape,"box");
this_box_volume.geometry.priority_value = priority;
this_box_volume.geometry.geometry_p_interact = p_interact;
// Currently the coordinates will be in absolute space.
this_box_volume.geometry.center = POS_A_CURRENT_COMP;

this_box_storage.z_depth = zdepth;
this_box_storage.x_width1 = xwidth;
this_box_storage.y_height1 = yheight;

this_box_storage.is_rectangle = 0;
if (xwidth2 < 0 && yheight2 < 0) this_box_storage.is_rectangle = 1;
if (xwidth == xwidth2 && yheight == yheight2) this_box_storage.is_rectangle = 1;

if (xwidth2 < 0) {
    this_box_storage.x_width2 = xwidth;
    xwidth2 = xwidth;
} else this_box_storage.x_width2 = xwidth2;

if (yheight2 < 0) {
    this_box_storage.y_height2 = yheight;
    yheight2 = yheight;
} else this_box_storage.y_height2 = yheight2;


this_box_storage.normal_vectors[0] = coords_set(0,0,1);
this_box_storage.normal_vectors[1] = coords_set(0,0,1);

// for sides with y component = 0
x_component = 2*zdepth/sqrt((xwidth-xwidth2)*(xwidth-xwidth2)+4*zdepth*zdepth);
z_component = (xwidth-xwidth2)/sqrt(4*zdepth*zdepth+(xwidth-xwidth2)*(xwidth-xwidth2));

this_box_storage.normal_vectors[2] = coords_set(x_component,0,z_component);
this_box_storage.normal_vectors[3] = coords_set(-x_component,0,z_component);

// for sides with x component = 0
y_component = 2*zdepth/sqrt((yheight-yheight2)*(yheight-yheight2)+4*zdepth*zdepth);
z_component = (yheight-yheight2)/sqrt(4*zdepth*zdepth+(yheight-yheight2)*(yheight-yheight2));

this_box_storage.normal_vectors[4] = coords_set(0,y_component,z_component);
this_box_storage.normal_vectors[5] = coords_set(0,-y_component,z_component);

this_box_volume.geometry.visualization_on = visualize;

this_box_volume.geometry.geometry_parameters.p_box_storage = &this_box_storage;

// Assign pointers to functions for intersection with the shape, checking if a point is inside the shape
if (this_box_storage.is_rectangle == 1) {
this_box_volume.geometry.intersect_function = &sample_box_intersect_simple;
this_box_volume.geometry.within_function = &r_within_box_simple;
}
else {
this_box_volume.geometry.intersect_function = &sample_box_intersect_advanced;
this_box_volume.geometry.within_function = &r_within_box_advanced;
}

this_box_volume.geometry.shell_points = &box_shell_points;
this_box_volume.geometry.mcdisplay_function = &mcdisplay_box_function;
this_box_volume.geometry.initialize_from_main_function = &initialize_box_geometry_from_main_component;
this_box_volume.geometry.process_rot_allocated = 0;

this_box_volume.geometry.copy_geometry_parameters = &allocate_box_storage_copy;

rot_copy(this_box_volume.geometry.rotation_matrix,ROT_A_CURRENT_COMP); //check how ROT_R_CURRENT_COMP would work
rot_transpose(ROT_A_CURRENT_COMP,this_box_volume.geometry.transpose_rotation_matrix);

// Initialize loggers
this_box_volume.loggers.num_elements = 0;

// packing the information into the global_geometry_element, which is then included in the global_geometry_list.
sprintf(global_geometry_element.name,NAME_CURRENT_COMP);
global_geometry_element.activation_counter = number_of_activations;
global_geometry_element.component_index = INDEX_CURRENT_COMP;
global_geometry_element.Volume = &this_box_volume; // Would be nicer if this m was a pointer, now we have the (small) data two places
add_element_to_geometry_list(&global_geometry_list,global_geometry_element);
}
#line 196262 "MACS_sample_kidney_box.c"
#undef number_of_activations
#undef mask_setting
#undef mask_string
#undef p_interact
#undef focus_r
#undef focus_xh
#undef focus_xw
#undef focus_ah
#undef focus_aw
#undef target_z
#undef target_y
#undef target_x
#undef target_index
#undef visualize
#undef yheight2
#undef xwidth2
#undef zdepth
#undef yheight
#undef xwidth
#undef priority
#undef material_string
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

  /* Initializations for component channel_3_analyzer_2_array_crystal_array_7. */
  SIG_MESSAGE("channel_3_analyzer_2_array_crystal_array_7 (Init)");
#define mccompcurname  channel_3_analyzer_2_array_crystal_array_7
#define mccompcurtype  Union_box
#define mccompcurindex 262
#define loop_index mccchannel_3_analyzer_2_array_crystal_array_7_loop_index
#define this_box_volume mccchannel_3_analyzer_2_array_crystal_array_7_this_box_volume
#define global_geometry_element mccchannel_3_analyzer_2_array_crystal_array_7_global_geometry_element
#define this_box_storage mccchannel_3_analyzer_2_array_crystal_array_7_this_box_storage
#define material_string mccchannel_3_analyzer_2_array_crystal_array_7_material_string
#define priority mccchannel_3_analyzer_2_array_crystal_array_7_priority
#define xwidth mccchannel_3_analyzer_2_array_crystal_array_7_xwidth
#define yheight mccchannel_3_analyzer_2_array_crystal_array_7_yheight
#define zdepth mccchannel_3_analyzer_2_array_crystal_array_7_zdepth
#define xwidth2 mccchannel_3_analyzer_2_array_crystal_array_7_xwidth2
#define yheight2 mccchannel_3_analyzer_2_array_crystal_array_7_yheight2
#define visualize mccchannel_3_analyzer_2_array_crystal_array_7_visualize
#define target_index mccchannel_3_analyzer_2_array_crystal_array_7_target_index
#define target_x mccchannel_3_analyzer_2_array_crystal_array_7_target_x
#define target_y mccchannel_3_analyzer_2_array_crystal_array_7_target_y
#define target_z mccchannel_3_analyzer_2_array_crystal_array_7_target_z
#define focus_aw mccchannel_3_analyzer_2_array_crystal_array_7_focus_aw
#define focus_ah mccchannel_3_analyzer_2_array_crystal_array_7_focus_ah
#define focus_xw mccchannel_3_analyzer_2_array_crystal_array_7_focus_xw
#define focus_xh mccchannel_3_analyzer_2_array_crystal_array_7_focus_xh
#define focus_r mccchannel_3_analyzer_2_array_crystal_array_7_focus_r
#define p_interact mccchannel_3_analyzer_2_array_crystal_array_7_p_interact
#define mask_string mccchannel_3_analyzer_2_array_crystal_array_7_mask_string
#define mask_setting mccchannel_3_analyzer_2_array_crystal_array_7_mask_setting
#define number_of_activations mccchannel_3_analyzer_2_array_crystal_array_7_number_of_activations
#line 224 "Union_box.comp"
{
// Initializes the focusing system for this volume including input sanitation.
focus_initialize(&this_box_volume.geometry, POS_A_COMP_INDEX(INDEX_CURRENT_COMP+target_index), POS_A_CURRENT_COMP, ROT_A_CURRENT_COMP, target_index, target_x, target_y, target_z, focus_aw, focus_ah, focus_xw, focus_xh, focus_r, NAME_CURRENT_COMP);

// Input sanitation for this geometry
if (xwidth <= 0) {
  printf("\nERROR in Union_box named %s, the xwidth is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (yheight <= 0) {
  printf("\nERROR in Union_box named %s, yheight is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (zdepth <= 0) {
  printf("\nERROR in Union_box named %s, zdepth is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (xwidth2 <= 0 && xwidth2 != -1) {
  printf("\nERROR in Union_box named %s, the xwidth2 is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (yheight2 <= 0 && yheight2 != -1) {
  printf("\nERROR in Union_box named %s, yheight2 is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}

// Use sanitation
if (global_material_list.num_elements == 0) {
  printf("\nERROR: Need to define a material using Union_make_material before using a Union geometry component. \n");
  printf("       %s was defined before first use of Union_make_material.\n",NAME_CURRENT_COMP);
  exit(1);
}

this_box_volume.geometry.is_masked_volume = 0;
this_box_volume.geometry.is_exit_volume = 0;
this_box_volume.geometry.is_mask_volume = 0;
// check if the volume is a mask, if it is the material string is irelevant.
if (mask_string && strlen(mask_string) && strcmp(mask_string, "NULL") && strcmp(mask_string, "0")) {
    // A mask volume is used to limit the extend of other volumes, called the masked volumes. These are specified in the mask_string.
    // In order for a ray to enter a masked volume, it needs to be both in the region covered by that volume AND the mask volume.
    // When more than
    this_box_volume.geometry.mask_mode = 1; // Default is mask mode is ALL
    if (mask_setting && strlen(mask_setting) && strcmp(mask_setting, "NULL") && strcmp(mask_setting, "0")) {
        if (strcmp(mask_setting,"ALL") == 0 || strcmp(mask_setting,"All") == 0) this_box_volume.geometry.mask_mode = 1;
        else if (strcmp(mask_setting,"ANY") == 0 || strcmp(mask_setting,"Any") == 0) this_box_volume.geometry.mask_mode = 2;
        else {
            printf("The mask_mode of component %s is set to %s, but must be either ALL or ANY.\n",NAME_CURRENT_COMP,mask_setting);
            exit(1);
        }
    }
    
    for (loop_index=0;loop_index<global_geometry_list.num_elements;loop_index++) {
        // Add mask list
        if (1 == manual_linking_function(global_geometry_list.elements[loop_index].name,mask_string)) {
            add_element_to_int_list(&this_box_volume.geometry.mask_list,global_geometry_list.elements[loop_index].component_index);
            add_element_to_int_list(&global_geometry_list.elements[loop_index].Volume->geometry.masked_by_list,INDEX_CURRENT_COMP);
            global_geometry_list.elements[loop_index].Volume->geometry.is_masked_volume = 1;
            if (this_box_volume.geometry.mask_mode == 2)
                global_geometry_list.elements[loop_index].Volume->geometry.mask_mode = 2;
            if (this_box_volume.geometry.mask_mode == 1) {
                if (global_geometry_list.elements[loop_index].Volume->geometry.is_masked_volume == 1 && global_geometry_list.elements[loop_index].Volume->geometry.mask_mode != 2)
                    // If more than one mask is added to one volume, the ANY mode overwrites the (default) ALL mode.
                    global_geometry_list.elements[loop_index].Volume->geometry.mask_mode = 1;
            }
            
            found_geometries = 1;
        }
    }
    if (found_geometries == 0) {
        printf("The mask_string in geometry: %s did not find any of the specified volumes in the mask_string %s \n",NAME_CURRENT_COMP,mask_string);
        exit(1);
    }
    this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
    this_box_volume.p_physics->is_vacuum = 0; // Makes this volume a vacuum
    this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
    this_box_volume.p_physics->my_a = 0; // Should not be used.
    sprintf(this_box_volume.p_physics->name,"Mask");
    this_box_volume.geometry.is_mask_volume = 1;
    
    
// Read the material input, or if it lacks, use automatic linking.
} else if (material_string && strlen(material_string) && strcmp(material_string, "NULL") && strcmp(material_string, "0")) {
    // A geometry string was given, use it to determine which material
    if (0 == strcmp(material_string,"vacuum") || 0 == strcmp(material_string,"Vacuum")) {
        // One could have a global physics struct for vacuum instead of creating one for each
        this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
        this_box_volume.p_physics->is_vacuum = 1; // Makes this volume a vacuum
        this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
        this_box_volume.p_physics->my_a = 0; // Should not be used.
        sprintf(this_box_volume.p_physics->name,"Vacuum");
    } else if (0 == strcmp(material_string,"exit") || 0 == strcmp(material_string,"Exit")) {
        // One could have a global physics struct for vacuum instead of creating one for each
        this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
        this_box_volume.p_physics->is_vacuum = 1; // Makes this volume a vacuum
        this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
        this_box_volume.p_physics->my_a = 0; // Should not be used.
        this_box_volume.geometry.is_exit_volume = 1;
        sprintf(this_box_volume.p_physics->name,"Exit");
    } else {
        #ifndef MATERIAL_DETECTOR
            printf("Need to define a material before refering to it in a geometry %s.\n",NAME_CURRENT_COMP);
            exit(1);
        #endif
        for (loop_index=0;loop_index<global_material_list.num_elements;loop_index++) {
            if (0 == strcmp(material_string,global_material_list.elements[loop_index].name)) {
                this_box_volume.p_physics = global_material_list.elements[loop_index].physics;
                break;
            }
            if (loop_index == global_material_list.num_elements-1) {
            printf("\n");
            printf("ERROR: The material string \"%s\" in Union geometry \"%s\" did not match a specified material. \n",material_string,NAME_CURRENT_COMP);
            printf("       The materials available at this point (need to be defined before the geometry): \n");
            for (loop_index=0;loop_index<global_material_list.num_elements;loop_index++)
              printf("         %s\n",global_material_list.elements[loop_index].name);
            printf("\n");
            printf("       It is also possible to use one of the defualt materials avaiable: \n");
            printf("           Vacuum (for a Volume without scattering or absorption)\n");
            printf("           Exit (for a Volume where the ray exits the component if it enters)\n");
            printf("           Mask (for a Volume that masks existing volumes specified in the mask_string\n");
            exit(1);
          }
        }
    }
} else {
    // Automatic linking, simply using the last defined material.
    #ifndef MATERIAL_DETECTOR
        printf("Need to define a material before the geometry to use automatic linking %s.\n",NAME_CURRENT_COMP);
        exit(1);
    #endif
    this_box_volume.p_physics = global_material_list.elements[global_material_list.num_elements-1].physics;
}

sprintf(this_box_volume.name,NAME_CURRENT_COMP);
sprintf(this_box_volume.geometry.shape,"box");
this_box_volume.geometry.priority_value = priority;
this_box_volume.geometry.geometry_p_interact = p_interact;
// Currently the coordinates will be in absolute space.
this_box_volume.geometry.center = POS_A_CURRENT_COMP;

this_box_storage.z_depth = zdepth;
this_box_storage.x_width1 = xwidth;
this_box_storage.y_height1 = yheight;

this_box_storage.is_rectangle = 0;
if (xwidth2 < 0 && yheight2 < 0) this_box_storage.is_rectangle = 1;
if (xwidth == xwidth2 && yheight == yheight2) this_box_storage.is_rectangle = 1;

if (xwidth2 < 0) {
    this_box_storage.x_width2 = xwidth;
    xwidth2 = xwidth;
} else this_box_storage.x_width2 = xwidth2;

if (yheight2 < 0) {
    this_box_storage.y_height2 = yheight;
    yheight2 = yheight;
} else this_box_storage.y_height2 = yheight2;


this_box_storage.normal_vectors[0] = coords_set(0,0,1);
this_box_storage.normal_vectors[1] = coords_set(0,0,1);

// for sides with y component = 0
x_component = 2*zdepth/sqrt((xwidth-xwidth2)*(xwidth-xwidth2)+4*zdepth*zdepth);
z_component = (xwidth-xwidth2)/sqrt(4*zdepth*zdepth+(xwidth-xwidth2)*(xwidth-xwidth2));

this_box_storage.normal_vectors[2] = coords_set(x_component,0,z_component);
this_box_storage.normal_vectors[3] = coords_set(-x_component,0,z_component);

// for sides with x component = 0
y_component = 2*zdepth/sqrt((yheight-yheight2)*(yheight-yheight2)+4*zdepth*zdepth);
z_component = (yheight-yheight2)/sqrt(4*zdepth*zdepth+(yheight-yheight2)*(yheight-yheight2));

this_box_storage.normal_vectors[4] = coords_set(0,y_component,z_component);
this_box_storage.normal_vectors[5] = coords_set(0,-y_component,z_component);

this_box_volume.geometry.visualization_on = visualize;

this_box_volume.geometry.geometry_parameters.p_box_storage = &this_box_storage;

// Assign pointers to functions for intersection with the shape, checking if a point is inside the shape
if (this_box_storage.is_rectangle == 1) {
this_box_volume.geometry.intersect_function = &sample_box_intersect_simple;
this_box_volume.geometry.within_function = &r_within_box_simple;
}
else {
this_box_volume.geometry.intersect_function = &sample_box_intersect_advanced;
this_box_volume.geometry.within_function = &r_within_box_advanced;
}

this_box_volume.geometry.shell_points = &box_shell_points;
this_box_volume.geometry.mcdisplay_function = &mcdisplay_box_function;
this_box_volume.geometry.initialize_from_main_function = &initialize_box_geometry_from_main_component;
this_box_volume.geometry.process_rot_allocated = 0;

this_box_volume.geometry.copy_geometry_parameters = &allocate_box_storage_copy;

rot_copy(this_box_volume.geometry.rotation_matrix,ROT_A_CURRENT_COMP); //check how ROT_R_CURRENT_COMP would work
rot_transpose(ROT_A_CURRENT_COMP,this_box_volume.geometry.transpose_rotation_matrix);

// Initialize loggers
this_box_volume.loggers.num_elements = 0;

// packing the information into the global_geometry_element, which is then included in the global_geometry_list.
sprintf(global_geometry_element.name,NAME_CURRENT_COMP);
global_geometry_element.activation_counter = number_of_activations;
global_geometry_element.component_index = INDEX_CURRENT_COMP;
global_geometry_element.Volume = &this_box_volume; // Would be nicer if this m was a pointer, now we have the (small) data two places
add_element_to_geometry_list(&global_geometry_list,global_geometry_element);
}
#line 196532 "MACS_sample_kidney_box.c"
#undef number_of_activations
#undef mask_setting
#undef mask_string
#undef p_interact
#undef focus_r
#undef focus_xh
#undef focus_xw
#undef focus_ah
#undef focus_aw
#undef target_z
#undef target_y
#undef target_x
#undef target_index
#undef visualize
#undef yheight2
#undef xwidth2
#undef zdepth
#undef yheight
#undef xwidth
#undef priority
#undef material_string
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

  /* Initializations for component channel_3_analyzer_2_array_crystal_array_8. */
  SIG_MESSAGE("channel_3_analyzer_2_array_crystal_array_8 (Init)");
#define mccompcurname  channel_3_analyzer_2_array_crystal_array_8
#define mccompcurtype  Union_box
#define mccompcurindex 263
#define loop_index mccchannel_3_analyzer_2_array_crystal_array_8_loop_index
#define this_box_volume mccchannel_3_analyzer_2_array_crystal_array_8_this_box_volume
#define global_geometry_element mccchannel_3_analyzer_2_array_crystal_array_8_global_geometry_element
#define this_box_storage mccchannel_3_analyzer_2_array_crystal_array_8_this_box_storage
#define material_string mccchannel_3_analyzer_2_array_crystal_array_8_material_string
#define priority mccchannel_3_analyzer_2_array_crystal_array_8_priority
#define xwidth mccchannel_3_analyzer_2_array_crystal_array_8_xwidth
#define yheight mccchannel_3_analyzer_2_array_crystal_array_8_yheight
#define zdepth mccchannel_3_analyzer_2_array_crystal_array_8_zdepth
#define xwidth2 mccchannel_3_analyzer_2_array_crystal_array_8_xwidth2
#define yheight2 mccchannel_3_analyzer_2_array_crystal_array_8_yheight2
#define visualize mccchannel_3_analyzer_2_array_crystal_array_8_visualize
#define target_index mccchannel_3_analyzer_2_array_crystal_array_8_target_index
#define target_x mccchannel_3_analyzer_2_array_crystal_array_8_target_x
#define target_y mccchannel_3_analyzer_2_array_crystal_array_8_target_y
#define target_z mccchannel_3_analyzer_2_array_crystal_array_8_target_z
#define focus_aw mccchannel_3_analyzer_2_array_crystal_array_8_focus_aw
#define focus_ah mccchannel_3_analyzer_2_array_crystal_array_8_focus_ah
#define focus_xw mccchannel_3_analyzer_2_array_crystal_array_8_focus_xw
#define focus_xh mccchannel_3_analyzer_2_array_crystal_array_8_focus_xh
#define focus_r mccchannel_3_analyzer_2_array_crystal_array_8_focus_r
#define p_interact mccchannel_3_analyzer_2_array_crystal_array_8_p_interact
#define mask_string mccchannel_3_analyzer_2_array_crystal_array_8_mask_string
#define mask_setting mccchannel_3_analyzer_2_array_crystal_array_8_mask_setting
#define number_of_activations mccchannel_3_analyzer_2_array_crystal_array_8_number_of_activations
#line 224 "Union_box.comp"
{
// Initializes the focusing system for this volume including input sanitation.
focus_initialize(&this_box_volume.geometry, POS_A_COMP_INDEX(INDEX_CURRENT_COMP+target_index), POS_A_CURRENT_COMP, ROT_A_CURRENT_COMP, target_index, target_x, target_y, target_z, focus_aw, focus_ah, focus_xw, focus_xh, focus_r, NAME_CURRENT_COMP);

// Input sanitation for this geometry
if (xwidth <= 0) {
  printf("\nERROR in Union_box named %s, the xwidth is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (yheight <= 0) {
  printf("\nERROR in Union_box named %s, yheight is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (zdepth <= 0) {
  printf("\nERROR in Union_box named %s, zdepth is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (xwidth2 <= 0 && xwidth2 != -1) {
  printf("\nERROR in Union_box named %s, the xwidth2 is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (yheight2 <= 0 && yheight2 != -1) {
  printf("\nERROR in Union_box named %s, yheight2 is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}

// Use sanitation
if (global_material_list.num_elements == 0) {
  printf("\nERROR: Need to define a material using Union_make_material before using a Union geometry component. \n");
  printf("       %s was defined before first use of Union_make_material.\n",NAME_CURRENT_COMP);
  exit(1);
}

this_box_volume.geometry.is_masked_volume = 0;
this_box_volume.geometry.is_exit_volume = 0;
this_box_volume.geometry.is_mask_volume = 0;
// check if the volume is a mask, if it is the material string is irelevant.
if (mask_string && strlen(mask_string) && strcmp(mask_string, "NULL") && strcmp(mask_string, "0")) {
    // A mask volume is used to limit the extend of other volumes, called the masked volumes. These are specified in the mask_string.
    // In order for a ray to enter a masked volume, it needs to be both in the region covered by that volume AND the mask volume.
    // When more than
    this_box_volume.geometry.mask_mode = 1; // Default is mask mode is ALL
    if (mask_setting && strlen(mask_setting) && strcmp(mask_setting, "NULL") && strcmp(mask_setting, "0")) {
        if (strcmp(mask_setting,"ALL") == 0 || strcmp(mask_setting,"All") == 0) this_box_volume.geometry.mask_mode = 1;
        else if (strcmp(mask_setting,"ANY") == 0 || strcmp(mask_setting,"Any") == 0) this_box_volume.geometry.mask_mode = 2;
        else {
            printf("The mask_mode of component %s is set to %s, but must be either ALL or ANY.\n",NAME_CURRENT_COMP,mask_setting);
            exit(1);
        }
    }
    
    for (loop_index=0;loop_index<global_geometry_list.num_elements;loop_index++) {
        // Add mask list
        if (1 == manual_linking_function(global_geometry_list.elements[loop_index].name,mask_string)) {
            add_element_to_int_list(&this_box_volume.geometry.mask_list,global_geometry_list.elements[loop_index].component_index);
            add_element_to_int_list(&global_geometry_list.elements[loop_index].Volume->geometry.masked_by_list,INDEX_CURRENT_COMP);
            global_geometry_list.elements[loop_index].Volume->geometry.is_masked_volume = 1;
            if (this_box_volume.geometry.mask_mode == 2)
                global_geometry_list.elements[loop_index].Volume->geometry.mask_mode = 2;
            if (this_box_volume.geometry.mask_mode == 1) {
                if (global_geometry_list.elements[loop_index].Volume->geometry.is_masked_volume == 1 && global_geometry_list.elements[loop_index].Volume->geometry.mask_mode != 2)
                    // If more than one mask is added to one volume, the ANY mode overwrites the (default) ALL mode.
                    global_geometry_list.elements[loop_index].Volume->geometry.mask_mode = 1;
            }
            
            found_geometries = 1;
        }
    }
    if (found_geometries == 0) {
        printf("The mask_string in geometry: %s did not find any of the specified volumes in the mask_string %s \n",NAME_CURRENT_COMP,mask_string);
        exit(1);
    }
    this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
    this_box_volume.p_physics->is_vacuum = 0; // Makes this volume a vacuum
    this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
    this_box_volume.p_physics->my_a = 0; // Should not be used.
    sprintf(this_box_volume.p_physics->name,"Mask");
    this_box_volume.geometry.is_mask_volume = 1;
    
    
// Read the material input, or if it lacks, use automatic linking.
} else if (material_string && strlen(material_string) && strcmp(material_string, "NULL") && strcmp(material_string, "0")) {
    // A geometry string was given, use it to determine which material
    if (0 == strcmp(material_string,"vacuum") || 0 == strcmp(material_string,"Vacuum")) {
        // One could have a global physics struct for vacuum instead of creating one for each
        this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
        this_box_volume.p_physics->is_vacuum = 1; // Makes this volume a vacuum
        this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
        this_box_volume.p_physics->my_a = 0; // Should not be used.
        sprintf(this_box_volume.p_physics->name,"Vacuum");
    } else if (0 == strcmp(material_string,"exit") || 0 == strcmp(material_string,"Exit")) {
        // One could have a global physics struct for vacuum instead of creating one for each
        this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
        this_box_volume.p_physics->is_vacuum = 1; // Makes this volume a vacuum
        this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
        this_box_volume.p_physics->my_a = 0; // Should not be used.
        this_box_volume.geometry.is_exit_volume = 1;
        sprintf(this_box_volume.p_physics->name,"Exit");
    } else {
        #ifndef MATERIAL_DETECTOR
            printf("Need to define a material before refering to it in a geometry %s.\n",NAME_CURRENT_COMP);
            exit(1);
        #endif
        for (loop_index=0;loop_index<global_material_list.num_elements;loop_index++) {
            if (0 == strcmp(material_string,global_material_list.elements[loop_index].name)) {
                this_box_volume.p_physics = global_material_list.elements[loop_index].physics;
                break;
            }
            if (loop_index == global_material_list.num_elements-1) {
            printf("\n");
            printf("ERROR: The material string \"%s\" in Union geometry \"%s\" did not match a specified material. \n",material_string,NAME_CURRENT_COMP);
            printf("       The materials available at this point (need to be defined before the geometry): \n");
            for (loop_index=0;loop_index<global_material_list.num_elements;loop_index++)
              printf("         %s\n",global_material_list.elements[loop_index].name);
            printf("\n");
            printf("       It is also possible to use one of the defualt materials avaiable: \n");
            printf("           Vacuum (for a Volume without scattering or absorption)\n");
            printf("           Exit (for a Volume where the ray exits the component if it enters)\n");
            printf("           Mask (for a Volume that masks existing volumes specified in the mask_string\n");
            exit(1);
          }
        }
    }
} else {
    // Automatic linking, simply using the last defined material.
    #ifndef MATERIAL_DETECTOR
        printf("Need to define a material before the geometry to use automatic linking %s.\n",NAME_CURRENT_COMP);
        exit(1);
    #endif
    this_box_volume.p_physics = global_material_list.elements[global_material_list.num_elements-1].physics;
}

sprintf(this_box_volume.name,NAME_CURRENT_COMP);
sprintf(this_box_volume.geometry.shape,"box");
this_box_volume.geometry.priority_value = priority;
this_box_volume.geometry.geometry_p_interact = p_interact;
// Currently the coordinates will be in absolute space.
this_box_volume.geometry.center = POS_A_CURRENT_COMP;

this_box_storage.z_depth = zdepth;
this_box_storage.x_width1 = xwidth;
this_box_storage.y_height1 = yheight;

this_box_storage.is_rectangle = 0;
if (xwidth2 < 0 && yheight2 < 0) this_box_storage.is_rectangle = 1;
if (xwidth == xwidth2 && yheight == yheight2) this_box_storage.is_rectangle = 1;

if (xwidth2 < 0) {
    this_box_storage.x_width2 = xwidth;
    xwidth2 = xwidth;
} else this_box_storage.x_width2 = xwidth2;

if (yheight2 < 0) {
    this_box_storage.y_height2 = yheight;
    yheight2 = yheight;
} else this_box_storage.y_height2 = yheight2;


this_box_storage.normal_vectors[0] = coords_set(0,0,1);
this_box_storage.normal_vectors[1] = coords_set(0,0,1);

// for sides with y component = 0
x_component = 2*zdepth/sqrt((xwidth-xwidth2)*(xwidth-xwidth2)+4*zdepth*zdepth);
z_component = (xwidth-xwidth2)/sqrt(4*zdepth*zdepth+(xwidth-xwidth2)*(xwidth-xwidth2));

this_box_storage.normal_vectors[2] = coords_set(x_component,0,z_component);
this_box_storage.normal_vectors[3] = coords_set(-x_component,0,z_component);

// for sides with x component = 0
y_component = 2*zdepth/sqrt((yheight-yheight2)*(yheight-yheight2)+4*zdepth*zdepth);
z_component = (yheight-yheight2)/sqrt(4*zdepth*zdepth+(yheight-yheight2)*(yheight-yheight2));

this_box_storage.normal_vectors[4] = coords_set(0,y_component,z_component);
this_box_storage.normal_vectors[5] = coords_set(0,-y_component,z_component);

this_box_volume.geometry.visualization_on = visualize;

this_box_volume.geometry.geometry_parameters.p_box_storage = &this_box_storage;

// Assign pointers to functions for intersection with the shape, checking if a point is inside the shape
if (this_box_storage.is_rectangle == 1) {
this_box_volume.geometry.intersect_function = &sample_box_intersect_simple;
this_box_volume.geometry.within_function = &r_within_box_simple;
}
else {
this_box_volume.geometry.intersect_function = &sample_box_intersect_advanced;
this_box_volume.geometry.within_function = &r_within_box_advanced;
}

this_box_volume.geometry.shell_points = &box_shell_points;
this_box_volume.geometry.mcdisplay_function = &mcdisplay_box_function;
this_box_volume.geometry.initialize_from_main_function = &initialize_box_geometry_from_main_component;
this_box_volume.geometry.process_rot_allocated = 0;

this_box_volume.geometry.copy_geometry_parameters = &allocate_box_storage_copy;

rot_copy(this_box_volume.geometry.rotation_matrix,ROT_A_CURRENT_COMP); //check how ROT_R_CURRENT_COMP would work
rot_transpose(ROT_A_CURRENT_COMP,this_box_volume.geometry.transpose_rotation_matrix);

// Initialize loggers
this_box_volume.loggers.num_elements = 0;

// packing the information into the global_geometry_element, which is then included in the global_geometry_list.
sprintf(global_geometry_element.name,NAME_CURRENT_COMP);
global_geometry_element.activation_counter = number_of_activations;
global_geometry_element.component_index = INDEX_CURRENT_COMP;
global_geometry_element.Volume = &this_box_volume; // Would be nicer if this m was a pointer, now we have the (small) data two places
add_element_to_geometry_list(&global_geometry_list,global_geometry_element);
}
#line 196802 "MACS_sample_kidney_box.c"
#undef number_of_activations
#undef mask_setting
#undef mask_string
#undef p_interact
#undef focus_r
#undef focus_xh
#undef focus_xw
#undef focus_ah
#undef focus_aw
#undef target_z
#undef target_y
#undef target_x
#undef target_index
#undef visualize
#undef yheight2
#undef xwidth2
#undef zdepth
#undef yheight
#undef xwidth
#undef priority
#undef material_string
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

  /* Initializations for component channel_3_cave2_cyl1. */
  SIG_MESSAGE("channel_3_cave2_cyl1 (Init)");
#define mccompcurname  channel_3_cave2_cyl1
#define mccompcurtype  Union_cylinder
#define mccompcurindex 264
#define loop_index mccchannel_3_cave2_cyl1_loop_index
#define this_cylinder_volume mccchannel_3_cave2_cyl1_this_cylinder_volume
#define global_geometry_element mccchannel_3_cave2_cyl1_global_geometry_element
#define this_cylinder_storage mccchannel_3_cave2_cyl1_this_cylinder_storage
#define material_string mccchannel_3_cave2_cyl1_material_string
#define priority mccchannel_3_cave2_cyl1_priority
#define radius mccchannel_3_cave2_cyl1_radius
#define yheight mccchannel_3_cave2_cyl1_yheight
#define visualize mccchannel_3_cave2_cyl1_visualize
#define target_index mccchannel_3_cave2_cyl1_target_index
#define target_x mccchannel_3_cave2_cyl1_target_x
#define target_y mccchannel_3_cave2_cyl1_target_y
#define target_z mccchannel_3_cave2_cyl1_target_z
#define focus_aw mccchannel_3_cave2_cyl1_focus_aw
#define focus_ah mccchannel_3_cave2_cyl1_focus_ah
#define focus_xw mccchannel_3_cave2_cyl1_focus_xw
#define focus_xh mccchannel_3_cave2_cyl1_focus_xh
#define focus_r mccchannel_3_cave2_cyl1_focus_r
#define p_interact mccchannel_3_cave2_cyl1_p_interact
#define mask_string mccchannel_3_cave2_cyl1_mask_string
#define mask_setting mccchannel_3_cave2_cyl1_mask_setting
#define number_of_activations mccchannel_3_cave2_cyl1_number_of_activations
#line 185 "Union_cylinder.comp"
{
// Initializes the focusing system for this volume including input sanitation.
focus_initialize(&this_cylinder_volume.geometry, POS_A_COMP_INDEX(INDEX_CURRENT_COMP+target_index), POS_A_CURRENT_COMP, ROT_A_CURRENT_COMP, target_index, target_x, target_y, target_z, focus_aw, focus_ah, focus_xw, focus_xh, focus_r, NAME_CURRENT_COMP);

// Input sanitation for this geometry
if (radius <= 0) {
  printf("\nERROR in Union_cylinder named %s, the radius is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}

if (yheight <= 0) {
  printf("\nERROR in Union_cylinder named %s, yheight is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}

// Use sanitation
#ifdef MATERIAL_DETECTOR
if (global_material_list.num_elements == 0) {
  // Here if the user have defined a material, but only after this material
  printf("\nERROR: Need to define a material using Union_make_material before using a Union geometry component. \n");
  printf("       %s was defined before first use of Union_make_material.\n",NAME_CURRENT_COMP);
  exit(1);
}
#endif
#ifndef MATERIAL_DETECTOR
  printf("\nERROR: Need to define a material using Union_make_material before using a Union geometry component. \n");
  exit(1);
#endif


this_cylinder_volume.geometry.is_masked_volume = 0;
this_cylinder_volume.geometry.is_exit_volume = 0;
this_cylinder_volume.geometry.is_mask_volume = 0;

// Read the material input, or if it lacks, use automatic linking.
if (mask_string && strlen(mask_string) && strcmp(mask_string, "NULL") && strcmp(mask_string, "0")) {
    // A mask volume is used to limit the extend of other volumes, called the masked volumes. These are specified in the mask_string.
    // In order for a ray to enter a masked volume, it needs to be both in the region covered by that volume AND the mask volume.
    // When more than
    this_cylinder_volume.geometry.mask_mode = 1; // Default is mask mode is ALL
    if (mask_setting && strlen(mask_setting) && strcmp(mask_setting, "NULL") && strcmp(mask_setting, "0")) {
        if (strcmp(mask_setting,"ALL") == 0 || strcmp(mask_setting,"All") == 0) this_cylinder_volume.geometry.mask_mode = 1;
        else if (strcmp(mask_setting,"ANY") == 0 || strcmp(mask_setting,"Any") == 0) this_cylinder_volume.geometry.mask_mode = 2;
        else {
            printf("The mask_mode of component %s is set to %s, but must be either ALL or ANY.\n",NAME_CURRENT_COMP,mask_setting);
            exit(1);
        }
    }
    
    for (loop_index=0;loop_index<global_geometry_list.num_elements;loop_index++) {
        // Add mask list
        if (1 == manual_linking_function(global_geometry_list.elements[loop_index].name,mask_string)) {
            add_element_to_int_list(&this_cylinder_volume.geometry.mask_list,global_geometry_list.elements[loop_index].component_index);
            add_element_to_int_list(&global_geometry_list.elements[loop_index].Volume->geometry.masked_by_list,INDEX_CURRENT_COMP);
            global_geometry_list.elements[loop_index].Volume->geometry.is_masked_volume = 1;
            if (this_cylinder_volume.geometry.mask_mode == 2)
                global_geometry_list.elements[loop_index].Volume->geometry.mask_mode = 2;
            if (this_cylinder_volume.geometry.mask_mode == 1) {
                if (global_geometry_list.elements[loop_index].Volume->geometry.is_masked_volume == 1 && global_geometry_list.elements[loop_index].Volume->geometry.mask_mode != 2)
                    // If more than one mask is added to one volume, the ANY mode overwrites the (default) ALL mode.
                    global_geometry_list.elements[loop_index].Volume->geometry.mask_mode = 1;
            }
            
            found_geometries = 1;
        }
    }
    if (found_geometries == 0) {
        printf("The mask_string in geometry: %s did not find any of the specified volumes in the mask_string %s \n",NAME_CURRENT_COMP,mask_string);
        exit(1);
    }
    this_cylinder_volume.p_physics = malloc(sizeof(struct physics_struct));
    this_cylinder_volume.p_physics->is_vacuum = 0; // Makes this volume a vacuum
    this_cylinder_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
    this_cylinder_volume.p_physics->my_a = 0; // Should not be used.
    sprintf(this_cylinder_volume.p_physics->name,"Mask");
    this_cylinder_volume.geometry.is_mask_volume = 1;
    
    
// Read the material input, or if it lacks, use automatic linking.
} else if (material_string && strlen(material_string) && strcmp(material_string, "NULL") && strcmp(material_string, "0")) {
    // A geometry string was given, use it to determine which material
    if (0 == strcmp(material_string,"vacuum") || 0 == strcmp(material_string,"Vacuum")) {
        // One could have a global physics struct for vacuum instead of creating one for each
        this_cylinder_volume.p_physics = malloc(sizeof(struct physics_struct));
        this_cylinder_volume.p_physics->is_vacuum = 1; // Makes this volume a vacuum
        this_cylinder_volume.p_physics->number_of_processes = (int) 0;
        this_cylinder_volume.p_physics->my_a = 0; // Should not be used.
        sprintf(this_cylinder_volume.p_physics->name,"Vacuum");
    } else if (0 == strcmp(material_string,"exit") || 0 == strcmp(material_string,"Exit")) {
        // One could have a global physics struct for exit instead of creating one for each
        this_cylinder_volume.p_physics = malloc(sizeof(struct physics_struct));
        this_cylinder_volume.p_physics->is_vacuum = 1; // Makes this volume a vacuum
        this_cylinder_volume.p_physics->number_of_processes = (int) 0;
        this_cylinder_volume.p_physics->my_a = 0; // Should not be used.
        this_cylinder_volume.geometry.is_exit_volume = 1;
        sprintf(this_cylinder_volume.p_physics->name,"Exit");
    } else {
        for (loop_index=0;loop_index<global_material_list.num_elements;loop_index++) {
          if (0 == strcmp(material_string,global_material_list.elements[loop_index].name)) {
            this_cylinder_volume.p_physics = global_material_list.elements[loop_index].physics;
            break;
          }
          if (loop_index == global_material_list.num_elements-1) {
            printf("\n");
            printf("ERROR: The material string \"%s\" in Union geometry \"%s\" did not match a specified material. \n",material_string,NAME_CURRENT_COMP);
            printf("       The materials available at this point (need to be defined before the geometry): \n");
            for (loop_index=0;loop_index<global_material_list.num_elements;loop_index++)
              printf("         %s\n",global_material_list.elements[loop_index].name);
            printf("\n");
            printf("       It is also possible to use one of the defualt materials avaiable: \n");
            printf("           Vacuum (for a Volume without scattering or absorption)\n");
            printf("           Exit (for a Volume where the ray exits the component if it enters)\n");
            printf("           Mask (for a Volume that masks existing volumes specified in the mask_string\n");
            exit(1);
          }
        }
    }
} else {
    // Automatic linking, simply using the last defined material.
    #ifndef MATERIAL_DETECTOR
        printf("Need to define a material before the geometry to use automatic linking %s.\n",NAME_CURRENT_COMP);
        exit(1);
    #endif
    this_cylinder_volume.p_physics = global_material_list.elements[global_material_list.num_elements-1].physics;
}

sprintf(this_cylinder_volume.name,NAME_CURRENT_COMP);
sprintf(this_cylinder_volume.geometry.shape,"cylinder");
this_cylinder_volume.geometry.priority_value = priority;
// Currently the coordinates will be in absolute space.
this_cylinder_volume.geometry.center = POS_A_CURRENT_COMP;

this_cylinder_volume.geometry.geometry_p_interact = p_interact;
this_cylinder_storage.cyl_radius = radius;
this_cylinder_storage.height = yheight;
this_cylinder_volume.geometry.visualization_on = visualize;
this_cylinder_volume.geometry.geometry_parameters.p_cylinder_storage = &this_cylinder_storage;
this_cylinder_volume.geometry.within_function = &r_within_cylinder;
this_cylinder_volume.geometry.intersect_function = &sample_cylinder_intersect;
this_cylinder_volume.geometry.mcdisplay_function = &mcdisplay_cylinder_function;
this_cylinder_volume.geometry.shell_points = &cylinder_shell_points;
this_cylinder_volume.geometry.initialize_from_main_function = &initialize_cylinder_geometry_from_main_component;
this_cylinder_volume.geometry.process_rot_allocated = 0;
this_cylinder_volume.geometry.copy_geometry_parameters = &allocate_cylinder_storage_copy;

rot_copy(this_cylinder_volume.geometry.rotation_matrix,ROT_A_CURRENT_COMP);
rot_transpose(ROT_A_CURRENT_COMP,this_cylinder_volume.geometry.transpose_rotation_matrix);

// Initialize loggers
this_cylinder_volume.loggers.num_elements = 0;

// packing the information into the global_geometry_element, which is then included in the global_geometry_list.
sprintf(global_geometry_element.name,NAME_CURRENT_COMP);
global_geometry_element.activation_counter = number_of_activations;
global_geometry_element.component_index = INDEX_CURRENT_COMP;
global_geometry_element.Volume = &this_cylinder_volume; // Would be nicer if this m was a pointer, now we have the (small) data two places
add_element_to_geometry_list(&global_geometry_list,global_geometry_element);
}
#line 197018 "MACS_sample_kidney_box.c"
#undef number_of_activations
#undef mask_setting
#undef mask_string
#undef p_interact
#undef focus_r
#undef focus_xh
#undef focus_xw
#undef focus_ah
#undef focus_aw
#undef target_z
#undef target_y
#undef target_x
#undef target_index
#undef visualize
#undef yheight
#undef radius
#undef priority
#undef material_string
#undef this_cylinder_storage
#undef global_geometry_element
#undef this_cylinder_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

  /* Initializations for component channel_3_cave2_box1. */
  SIG_MESSAGE("channel_3_cave2_box1 (Init)");
#define mccompcurname  channel_3_cave2_box1
#define mccompcurtype  Union_box
#define mccompcurindex 265
#define loop_index mccchannel_3_cave2_box1_loop_index
#define this_box_volume mccchannel_3_cave2_box1_this_box_volume
#define global_geometry_element mccchannel_3_cave2_box1_global_geometry_element
#define this_box_storage mccchannel_3_cave2_box1_this_box_storage
#define material_string mccchannel_3_cave2_box1_material_string
#define priority mccchannel_3_cave2_box1_priority
#define xwidth mccchannel_3_cave2_box1_xwidth
#define yheight mccchannel_3_cave2_box1_yheight
#define zdepth mccchannel_3_cave2_box1_zdepth
#define xwidth2 mccchannel_3_cave2_box1_xwidth2
#define yheight2 mccchannel_3_cave2_box1_yheight2
#define visualize mccchannel_3_cave2_box1_visualize
#define target_index mccchannel_3_cave2_box1_target_index
#define target_x mccchannel_3_cave2_box1_target_x
#define target_y mccchannel_3_cave2_box1_target_y
#define target_z mccchannel_3_cave2_box1_target_z
#define focus_aw mccchannel_3_cave2_box1_focus_aw
#define focus_ah mccchannel_3_cave2_box1_focus_ah
#define focus_xw mccchannel_3_cave2_box1_focus_xw
#define focus_xh mccchannel_3_cave2_box1_focus_xh
#define focus_r mccchannel_3_cave2_box1_focus_r
#define p_interact mccchannel_3_cave2_box1_p_interact
#define mask_string mccchannel_3_cave2_box1_mask_string
#define mask_setting mccchannel_3_cave2_box1_mask_setting
#define number_of_activations mccchannel_3_cave2_box1_number_of_activations
#line 224 "Union_box.comp"
{
// Initializes the focusing system for this volume including input sanitation.
focus_initialize(&this_box_volume.geometry, POS_A_COMP_INDEX(INDEX_CURRENT_COMP+target_index), POS_A_CURRENT_COMP, ROT_A_CURRENT_COMP, target_index, target_x, target_y, target_z, focus_aw, focus_ah, focus_xw, focus_xh, focus_r, NAME_CURRENT_COMP);

// Input sanitation for this geometry
if (xwidth <= 0) {
  printf("\nERROR in Union_box named %s, the xwidth is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (yheight <= 0) {
  printf("\nERROR in Union_box named %s, yheight is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (zdepth <= 0) {
  printf("\nERROR in Union_box named %s, zdepth is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (xwidth2 <= 0 && xwidth2 != -1) {
  printf("\nERROR in Union_box named %s, the xwidth2 is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (yheight2 <= 0 && yheight2 != -1) {
  printf("\nERROR in Union_box named %s, yheight2 is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}

// Use sanitation
if (global_material_list.num_elements == 0) {
  printf("\nERROR: Need to define a material using Union_make_material before using a Union geometry component. \n");
  printf("       %s was defined before first use of Union_make_material.\n",NAME_CURRENT_COMP);
  exit(1);
}

this_box_volume.geometry.is_masked_volume = 0;
this_box_volume.geometry.is_exit_volume = 0;
this_box_volume.geometry.is_mask_volume = 0;
// check if the volume is a mask, if it is the material string is irelevant.
if (mask_string && strlen(mask_string) && strcmp(mask_string, "NULL") && strcmp(mask_string, "0")) {
    // A mask volume is used to limit the extend of other volumes, called the masked volumes. These are specified in the mask_string.
    // In order for a ray to enter a masked volume, it needs to be both in the region covered by that volume AND the mask volume.
    // When more than
    this_box_volume.geometry.mask_mode = 1; // Default is mask mode is ALL
    if (mask_setting && strlen(mask_setting) && strcmp(mask_setting, "NULL") && strcmp(mask_setting, "0")) {
        if (strcmp(mask_setting,"ALL") == 0 || strcmp(mask_setting,"All") == 0) this_box_volume.geometry.mask_mode = 1;
        else if (strcmp(mask_setting,"ANY") == 0 || strcmp(mask_setting,"Any") == 0) this_box_volume.geometry.mask_mode = 2;
        else {
            printf("The mask_mode of component %s is set to %s, but must be either ALL or ANY.\n",NAME_CURRENT_COMP,mask_setting);
            exit(1);
        }
    }
    
    for (loop_index=0;loop_index<global_geometry_list.num_elements;loop_index++) {
        // Add mask list
        if (1 == manual_linking_function(global_geometry_list.elements[loop_index].name,mask_string)) {
            add_element_to_int_list(&this_box_volume.geometry.mask_list,global_geometry_list.elements[loop_index].component_index);
            add_element_to_int_list(&global_geometry_list.elements[loop_index].Volume->geometry.masked_by_list,INDEX_CURRENT_COMP);
            global_geometry_list.elements[loop_index].Volume->geometry.is_masked_volume = 1;
            if (this_box_volume.geometry.mask_mode == 2)
                global_geometry_list.elements[loop_index].Volume->geometry.mask_mode = 2;
            if (this_box_volume.geometry.mask_mode == 1) {
                if (global_geometry_list.elements[loop_index].Volume->geometry.is_masked_volume == 1 && global_geometry_list.elements[loop_index].Volume->geometry.mask_mode != 2)
                    // If more than one mask is added to one volume, the ANY mode overwrites the (default) ALL mode.
                    global_geometry_list.elements[loop_index].Volume->geometry.mask_mode = 1;
            }
            
            found_geometries = 1;
        }
    }
    if (found_geometries == 0) {
        printf("The mask_string in geometry: %s did not find any of the specified volumes in the mask_string %s \n",NAME_CURRENT_COMP,mask_string);
        exit(1);
    }
    this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
    this_box_volume.p_physics->is_vacuum = 0; // Makes this volume a vacuum
    this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
    this_box_volume.p_physics->my_a = 0; // Should not be used.
    sprintf(this_box_volume.p_physics->name,"Mask");
    this_box_volume.geometry.is_mask_volume = 1;
    
    
// Read the material input, or if it lacks, use automatic linking.
} else if (material_string && strlen(material_string) && strcmp(material_string, "NULL") && strcmp(material_string, "0")) {
    // A geometry string was given, use it to determine which material
    if (0 == strcmp(material_string,"vacuum") || 0 == strcmp(material_string,"Vacuum")) {
        // One could have a global physics struct for vacuum instead of creating one for each
        this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
        this_box_volume.p_physics->is_vacuum = 1; // Makes this volume a vacuum
        this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
        this_box_volume.p_physics->my_a = 0; // Should not be used.
        sprintf(this_box_volume.p_physics->name,"Vacuum");
    } else if (0 == strcmp(material_string,"exit") || 0 == strcmp(material_string,"Exit")) {
        // One could have a global physics struct for vacuum instead of creating one for each
        this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
        this_box_volume.p_physics->is_vacuum = 1; // Makes this volume a vacuum
        this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
        this_box_volume.p_physics->my_a = 0; // Should not be used.
        this_box_volume.geometry.is_exit_volume = 1;
        sprintf(this_box_volume.p_physics->name,"Exit");
    } else {
        #ifndef MATERIAL_DETECTOR
            printf("Need to define a material before refering to it in a geometry %s.\n",NAME_CURRENT_COMP);
            exit(1);
        #endif
        for (loop_index=0;loop_index<global_material_list.num_elements;loop_index++) {
            if (0 == strcmp(material_string,global_material_list.elements[loop_index].name)) {
                this_box_volume.p_physics = global_material_list.elements[loop_index].physics;
                break;
            }
            if (loop_index == global_material_list.num_elements-1) {
            printf("\n");
            printf("ERROR: The material string \"%s\" in Union geometry \"%s\" did not match a specified material. \n",material_string,NAME_CURRENT_COMP);
            printf("       The materials available at this point (need to be defined before the geometry): \n");
            for (loop_index=0;loop_index<global_material_list.num_elements;loop_index++)
              printf("         %s\n",global_material_list.elements[loop_index].name);
            printf("\n");
            printf("       It is also possible to use one of the defualt materials avaiable: \n");
            printf("           Vacuum (for a Volume without scattering or absorption)\n");
            printf("           Exit (for a Volume where the ray exits the component if it enters)\n");
            printf("           Mask (for a Volume that masks existing volumes specified in the mask_string\n");
            exit(1);
          }
        }
    }
} else {
    // Automatic linking, simply using the last defined material.
    #ifndef MATERIAL_DETECTOR
        printf("Need to define a material before the geometry to use automatic linking %s.\n",NAME_CURRENT_COMP);
        exit(1);
    #endif
    this_box_volume.p_physics = global_material_list.elements[global_material_list.num_elements-1].physics;
}

sprintf(this_box_volume.name,NAME_CURRENT_COMP);
sprintf(this_box_volume.geometry.shape,"box");
this_box_volume.geometry.priority_value = priority;
this_box_volume.geometry.geometry_p_interact = p_interact;
// Currently the coordinates will be in absolute space.
this_box_volume.geometry.center = POS_A_CURRENT_COMP;

this_box_storage.z_depth = zdepth;
this_box_storage.x_width1 = xwidth;
this_box_storage.y_height1 = yheight;

this_box_storage.is_rectangle = 0;
if (xwidth2 < 0 && yheight2 < 0) this_box_storage.is_rectangle = 1;
if (xwidth == xwidth2 && yheight == yheight2) this_box_storage.is_rectangle = 1;

if (xwidth2 < 0) {
    this_box_storage.x_width2 = xwidth;
    xwidth2 = xwidth;
} else this_box_storage.x_width2 = xwidth2;

if (yheight2 < 0) {
    this_box_storage.y_height2 = yheight;
    yheight2 = yheight;
} else this_box_storage.y_height2 = yheight2;


this_box_storage.normal_vectors[0] = coords_set(0,0,1);
this_box_storage.normal_vectors[1] = coords_set(0,0,1);

// for sides with y component = 0
x_component = 2*zdepth/sqrt((xwidth-xwidth2)*(xwidth-xwidth2)+4*zdepth*zdepth);
z_component = (xwidth-xwidth2)/sqrt(4*zdepth*zdepth+(xwidth-xwidth2)*(xwidth-xwidth2));

this_box_storage.normal_vectors[2] = coords_set(x_component,0,z_component);
this_box_storage.normal_vectors[3] = coords_set(-x_component,0,z_component);

// for sides with x component = 0
y_component = 2*zdepth/sqrt((yheight-yheight2)*(yheight-yheight2)+4*zdepth*zdepth);
z_component = (yheight-yheight2)/sqrt(4*zdepth*zdepth+(yheight-yheight2)*(yheight-yheight2));

this_box_storage.normal_vectors[4] = coords_set(0,y_component,z_component);
this_box_storage.normal_vectors[5] = coords_set(0,-y_component,z_component);

this_box_volume.geometry.visualization_on = visualize;

this_box_volume.geometry.geometry_parameters.p_box_storage = &this_box_storage;

// Assign pointers to functions for intersection with the shape, checking if a point is inside the shape
if (this_box_storage.is_rectangle == 1) {
this_box_volume.geometry.intersect_function = &sample_box_intersect_simple;
this_box_volume.geometry.within_function = &r_within_box_simple;
}
else {
this_box_volume.geometry.intersect_function = &sample_box_intersect_advanced;
this_box_volume.geometry.within_function = &r_within_box_advanced;
}

this_box_volume.geometry.shell_points = &box_shell_points;
this_box_volume.geometry.mcdisplay_function = &mcdisplay_box_function;
this_box_volume.geometry.initialize_from_main_function = &initialize_box_geometry_from_main_component;
this_box_volume.geometry.process_rot_allocated = 0;

this_box_volume.geometry.copy_geometry_parameters = &allocate_box_storage_copy;

rot_copy(this_box_volume.geometry.rotation_matrix,ROT_A_CURRENT_COMP); //check how ROT_R_CURRENT_COMP would work
rot_transpose(ROT_A_CURRENT_COMP,this_box_volume.geometry.transpose_rotation_matrix);

// Initialize loggers
this_box_volume.loggers.num_elements = 0;

// packing the information into the global_geometry_element, which is then included in the global_geometry_list.
sprintf(global_geometry_element.name,NAME_CURRENT_COMP);
global_geometry_element.activation_counter = number_of_activations;
global_geometry_element.component_index = INDEX_CURRENT_COMP;
global_geometry_element.Volume = &this_box_volume; // Would be nicer if this m was a pointer, now we have the (small) data two places
add_element_to_geometry_list(&global_geometry_list,global_geometry_element);
}
#line 197285 "MACS_sample_kidney_box.c"
#undef number_of_activations
#undef mask_setting
#undef mask_string
#undef p_interact
#undef focus_r
#undef focus_xh
#undef focus_xw
#undef focus_ah
#undef focus_aw
#undef target_z
#undef target_y
#undef target_x
#undef target_index
#undef visualize
#undef yheight2
#undef xwidth2
#undef zdepth
#undef yheight
#undef xwidth
#undef priority
#undef material_string
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

  /* Initializations for component channel_3_cave2_box2. */
  SIG_MESSAGE("channel_3_cave2_box2 (Init)");
#define mccompcurname  channel_3_cave2_box2
#define mccompcurtype  Union_box
#define mccompcurindex 266
#define loop_index mccchannel_3_cave2_box2_loop_index
#define this_box_volume mccchannel_3_cave2_box2_this_box_volume
#define global_geometry_element mccchannel_3_cave2_box2_global_geometry_element
#define this_box_storage mccchannel_3_cave2_box2_this_box_storage
#define material_string mccchannel_3_cave2_box2_material_string
#define priority mccchannel_3_cave2_box2_priority
#define xwidth mccchannel_3_cave2_box2_xwidth
#define yheight mccchannel_3_cave2_box2_yheight
#define zdepth mccchannel_3_cave2_box2_zdepth
#define xwidth2 mccchannel_3_cave2_box2_xwidth2
#define yheight2 mccchannel_3_cave2_box2_yheight2
#define visualize mccchannel_3_cave2_box2_visualize
#define target_index mccchannel_3_cave2_box2_target_index
#define target_x mccchannel_3_cave2_box2_target_x
#define target_y mccchannel_3_cave2_box2_target_y
#define target_z mccchannel_3_cave2_box2_target_z
#define focus_aw mccchannel_3_cave2_box2_focus_aw
#define focus_ah mccchannel_3_cave2_box2_focus_ah
#define focus_xw mccchannel_3_cave2_box2_focus_xw
#define focus_xh mccchannel_3_cave2_box2_focus_xh
#define focus_r mccchannel_3_cave2_box2_focus_r
#define p_interact mccchannel_3_cave2_box2_p_interact
#define mask_string mccchannel_3_cave2_box2_mask_string
#define mask_setting mccchannel_3_cave2_box2_mask_setting
#define number_of_activations mccchannel_3_cave2_box2_number_of_activations
#line 224 "Union_box.comp"
{
// Initializes the focusing system for this volume including input sanitation.
focus_initialize(&this_box_volume.geometry, POS_A_COMP_INDEX(INDEX_CURRENT_COMP+target_index), POS_A_CURRENT_COMP, ROT_A_CURRENT_COMP, target_index, target_x, target_y, target_z, focus_aw, focus_ah, focus_xw, focus_xh, focus_r, NAME_CURRENT_COMP);

// Input sanitation for this geometry
if (xwidth <= 0) {
  printf("\nERROR in Union_box named %s, the xwidth is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (yheight <= 0) {
  printf("\nERROR in Union_box named %s, yheight is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (zdepth <= 0) {
  printf("\nERROR in Union_box named %s, zdepth is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (xwidth2 <= 0 && xwidth2 != -1) {
  printf("\nERROR in Union_box named %s, the xwidth2 is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (yheight2 <= 0 && yheight2 != -1) {
  printf("\nERROR in Union_box named %s, yheight2 is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}

// Use sanitation
if (global_material_list.num_elements == 0) {
  printf("\nERROR: Need to define a material using Union_make_material before using a Union geometry component. \n");
  printf("       %s was defined before first use of Union_make_material.\n",NAME_CURRENT_COMP);
  exit(1);
}

this_box_volume.geometry.is_masked_volume = 0;
this_box_volume.geometry.is_exit_volume = 0;
this_box_volume.geometry.is_mask_volume = 0;
// check if the volume is a mask, if it is the material string is irelevant.
if (mask_string && strlen(mask_string) && strcmp(mask_string, "NULL") && strcmp(mask_string, "0")) {
    // A mask volume is used to limit the extend of other volumes, called the masked volumes. These are specified in the mask_string.
    // In order for a ray to enter a masked volume, it needs to be both in the region covered by that volume AND the mask volume.
    // When more than
    this_box_volume.geometry.mask_mode = 1; // Default is mask mode is ALL
    if (mask_setting && strlen(mask_setting) && strcmp(mask_setting, "NULL") && strcmp(mask_setting, "0")) {
        if (strcmp(mask_setting,"ALL") == 0 || strcmp(mask_setting,"All") == 0) this_box_volume.geometry.mask_mode = 1;
        else if (strcmp(mask_setting,"ANY") == 0 || strcmp(mask_setting,"Any") == 0) this_box_volume.geometry.mask_mode = 2;
        else {
            printf("The mask_mode of component %s is set to %s, but must be either ALL or ANY.\n",NAME_CURRENT_COMP,mask_setting);
            exit(1);
        }
    }
    
    for (loop_index=0;loop_index<global_geometry_list.num_elements;loop_index++) {
        // Add mask list
        if (1 == manual_linking_function(global_geometry_list.elements[loop_index].name,mask_string)) {
            add_element_to_int_list(&this_box_volume.geometry.mask_list,global_geometry_list.elements[loop_index].component_index);
            add_element_to_int_list(&global_geometry_list.elements[loop_index].Volume->geometry.masked_by_list,INDEX_CURRENT_COMP);
            global_geometry_list.elements[loop_index].Volume->geometry.is_masked_volume = 1;
            if (this_box_volume.geometry.mask_mode == 2)
                global_geometry_list.elements[loop_index].Volume->geometry.mask_mode = 2;
            if (this_box_volume.geometry.mask_mode == 1) {
                if (global_geometry_list.elements[loop_index].Volume->geometry.is_masked_volume == 1 && global_geometry_list.elements[loop_index].Volume->geometry.mask_mode != 2)
                    // If more than one mask is added to one volume, the ANY mode overwrites the (default) ALL mode.
                    global_geometry_list.elements[loop_index].Volume->geometry.mask_mode = 1;
            }
            
            found_geometries = 1;
        }
    }
    if (found_geometries == 0) {
        printf("The mask_string in geometry: %s did not find any of the specified volumes in the mask_string %s \n",NAME_CURRENT_COMP,mask_string);
        exit(1);
    }
    this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
    this_box_volume.p_physics->is_vacuum = 0; // Makes this volume a vacuum
    this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
    this_box_volume.p_physics->my_a = 0; // Should not be used.
    sprintf(this_box_volume.p_physics->name,"Mask");
    this_box_volume.geometry.is_mask_volume = 1;
    
    
// Read the material input, or if it lacks, use automatic linking.
} else if (material_string && strlen(material_string) && strcmp(material_string, "NULL") && strcmp(material_string, "0")) {
    // A geometry string was given, use it to determine which material
    if (0 == strcmp(material_string,"vacuum") || 0 == strcmp(material_string,"Vacuum")) {
        // One could have a global physics struct for vacuum instead of creating one for each
        this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
        this_box_volume.p_physics->is_vacuum = 1; // Makes this volume a vacuum
        this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
        this_box_volume.p_physics->my_a = 0; // Should not be used.
        sprintf(this_box_volume.p_physics->name,"Vacuum");
    } else if (0 == strcmp(material_string,"exit") || 0 == strcmp(material_string,"Exit")) {
        // One could have a global physics struct for vacuum instead of creating one for each
        this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
        this_box_volume.p_physics->is_vacuum = 1; // Makes this volume a vacuum
        this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
        this_box_volume.p_physics->my_a = 0; // Should not be used.
        this_box_volume.geometry.is_exit_volume = 1;
        sprintf(this_box_volume.p_physics->name,"Exit");
    } else {
        #ifndef MATERIAL_DETECTOR
            printf("Need to define a material before refering to it in a geometry %s.\n",NAME_CURRENT_COMP);
            exit(1);
        #endif
        for (loop_index=0;loop_index<global_material_list.num_elements;loop_index++) {
            if (0 == strcmp(material_string,global_material_list.elements[loop_index].name)) {
                this_box_volume.p_physics = global_material_list.elements[loop_index].physics;
                break;
            }
            if (loop_index == global_material_list.num_elements-1) {
            printf("\n");
            printf("ERROR: The material string \"%s\" in Union geometry \"%s\" did not match a specified material. \n",material_string,NAME_CURRENT_COMP);
            printf("       The materials available at this point (need to be defined before the geometry): \n");
            for (loop_index=0;loop_index<global_material_list.num_elements;loop_index++)
              printf("         %s\n",global_material_list.elements[loop_index].name);
            printf("\n");
            printf("       It is also possible to use one of the defualt materials avaiable: \n");
            printf("           Vacuum (for a Volume without scattering or absorption)\n");
            printf("           Exit (for a Volume where the ray exits the component if it enters)\n");
            printf("           Mask (for a Volume that masks existing volumes specified in the mask_string\n");
            exit(1);
          }
        }
    }
} else {
    // Automatic linking, simply using the last defined material.
    #ifndef MATERIAL_DETECTOR
        printf("Need to define a material before the geometry to use automatic linking %s.\n",NAME_CURRENT_COMP);
        exit(1);
    #endif
    this_box_volume.p_physics = global_material_list.elements[global_material_list.num_elements-1].physics;
}

sprintf(this_box_volume.name,NAME_CURRENT_COMP);
sprintf(this_box_volume.geometry.shape,"box");
this_box_volume.geometry.priority_value = priority;
this_box_volume.geometry.geometry_p_interact = p_interact;
// Currently the coordinates will be in absolute space.
this_box_volume.geometry.center = POS_A_CURRENT_COMP;

this_box_storage.z_depth = zdepth;
this_box_storage.x_width1 = xwidth;
this_box_storage.y_height1 = yheight;

this_box_storage.is_rectangle = 0;
if (xwidth2 < 0 && yheight2 < 0) this_box_storage.is_rectangle = 1;
if (xwidth == xwidth2 && yheight == yheight2) this_box_storage.is_rectangle = 1;

if (xwidth2 < 0) {
    this_box_storage.x_width2 = xwidth;
    xwidth2 = xwidth;
} else this_box_storage.x_width2 = xwidth2;

if (yheight2 < 0) {
    this_box_storage.y_height2 = yheight;
    yheight2 = yheight;
} else this_box_storage.y_height2 = yheight2;


this_box_storage.normal_vectors[0] = coords_set(0,0,1);
this_box_storage.normal_vectors[1] = coords_set(0,0,1);

// for sides with y component = 0
x_component = 2*zdepth/sqrt((xwidth-xwidth2)*(xwidth-xwidth2)+4*zdepth*zdepth);
z_component = (xwidth-xwidth2)/sqrt(4*zdepth*zdepth+(xwidth-xwidth2)*(xwidth-xwidth2));

this_box_storage.normal_vectors[2] = coords_set(x_component,0,z_component);
this_box_storage.normal_vectors[3] = coords_set(-x_component,0,z_component);

// for sides with x component = 0
y_component = 2*zdepth/sqrt((yheight-yheight2)*(yheight-yheight2)+4*zdepth*zdepth);
z_component = (yheight-yheight2)/sqrt(4*zdepth*zdepth+(yheight-yheight2)*(yheight-yheight2));

this_box_storage.normal_vectors[4] = coords_set(0,y_component,z_component);
this_box_storage.normal_vectors[5] = coords_set(0,-y_component,z_component);

this_box_volume.geometry.visualization_on = visualize;

this_box_volume.geometry.geometry_parameters.p_box_storage = &this_box_storage;

// Assign pointers to functions for intersection with the shape, checking if a point is inside the shape
if (this_box_storage.is_rectangle == 1) {
this_box_volume.geometry.intersect_function = &sample_box_intersect_simple;
this_box_volume.geometry.within_function = &r_within_box_simple;
}
else {
this_box_volume.geometry.intersect_function = &sample_box_intersect_advanced;
this_box_volume.geometry.within_function = &r_within_box_advanced;
}

this_box_volume.geometry.shell_points = &box_shell_points;
this_box_volume.geometry.mcdisplay_function = &mcdisplay_box_function;
this_box_volume.geometry.initialize_from_main_function = &initialize_box_geometry_from_main_component;
this_box_volume.geometry.process_rot_allocated = 0;

this_box_volume.geometry.copy_geometry_parameters = &allocate_box_storage_copy;

rot_copy(this_box_volume.geometry.rotation_matrix,ROT_A_CURRENT_COMP); //check how ROT_R_CURRENT_COMP would work
rot_transpose(ROT_A_CURRENT_COMP,this_box_volume.geometry.transpose_rotation_matrix);

// Initialize loggers
this_box_volume.loggers.num_elements = 0;

// packing the information into the global_geometry_element, which is then included in the global_geometry_list.
sprintf(global_geometry_element.name,NAME_CURRENT_COMP);
global_geometry_element.activation_counter = number_of_activations;
global_geometry_element.component_index = INDEX_CURRENT_COMP;
global_geometry_element.Volume = &this_box_volume; // Would be nicer if this m was a pointer, now we have the (small) data two places
add_element_to_geometry_list(&global_geometry_list,global_geometry_element);
}
#line 197555 "MACS_sample_kidney_box.c"
#undef number_of_activations
#undef mask_setting
#undef mask_string
#undef p_interact
#undef focus_r
#undef focus_xh
#undef focus_xw
#undef focus_ah
#undef focus_aw
#undef target_z
#undef target_y
#undef target_x
#undef target_index
#undef visualize
#undef yheight2
#undef xwidth2
#undef zdepth
#undef yheight
#undef xwidth
#undef priority
#undef material_string
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

  /* Initializations for component channel_3_cave2_box3. */
  SIG_MESSAGE("channel_3_cave2_box3 (Init)");
#define mccompcurname  channel_3_cave2_box3
#define mccompcurtype  Union_box
#define mccompcurindex 267
#define loop_index mccchannel_3_cave2_box3_loop_index
#define this_box_volume mccchannel_3_cave2_box3_this_box_volume
#define global_geometry_element mccchannel_3_cave2_box3_global_geometry_element
#define this_box_storage mccchannel_3_cave2_box3_this_box_storage
#define material_string mccchannel_3_cave2_box3_material_string
#define priority mccchannel_3_cave2_box3_priority
#define xwidth mccchannel_3_cave2_box3_xwidth
#define yheight mccchannel_3_cave2_box3_yheight
#define zdepth mccchannel_3_cave2_box3_zdepth
#define xwidth2 mccchannel_3_cave2_box3_xwidth2
#define yheight2 mccchannel_3_cave2_box3_yheight2
#define visualize mccchannel_3_cave2_box3_visualize
#define target_index mccchannel_3_cave2_box3_target_index
#define target_x mccchannel_3_cave2_box3_target_x
#define target_y mccchannel_3_cave2_box3_target_y
#define target_z mccchannel_3_cave2_box3_target_z
#define focus_aw mccchannel_3_cave2_box3_focus_aw
#define focus_ah mccchannel_3_cave2_box3_focus_ah
#define focus_xw mccchannel_3_cave2_box3_focus_xw
#define focus_xh mccchannel_3_cave2_box3_focus_xh
#define focus_r mccchannel_3_cave2_box3_focus_r
#define p_interact mccchannel_3_cave2_box3_p_interact
#define mask_string mccchannel_3_cave2_box3_mask_string
#define mask_setting mccchannel_3_cave2_box3_mask_setting
#define number_of_activations mccchannel_3_cave2_box3_number_of_activations
#line 224 "Union_box.comp"
{
// Initializes the focusing system for this volume including input sanitation.
focus_initialize(&this_box_volume.geometry, POS_A_COMP_INDEX(INDEX_CURRENT_COMP+target_index), POS_A_CURRENT_COMP, ROT_A_CURRENT_COMP, target_index, target_x, target_y, target_z, focus_aw, focus_ah, focus_xw, focus_xh, focus_r, NAME_CURRENT_COMP);

// Input sanitation for this geometry
if (xwidth <= 0) {
  printf("\nERROR in Union_box named %s, the xwidth is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (yheight <= 0) {
  printf("\nERROR in Union_box named %s, yheight is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (zdepth <= 0) {
  printf("\nERROR in Union_box named %s, zdepth is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (xwidth2 <= 0 && xwidth2 != -1) {
  printf("\nERROR in Union_box named %s, the xwidth2 is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (yheight2 <= 0 && yheight2 != -1) {
  printf("\nERROR in Union_box named %s, yheight2 is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}

// Use sanitation
if (global_material_list.num_elements == 0) {
  printf("\nERROR: Need to define a material using Union_make_material before using a Union geometry component. \n");
  printf("       %s was defined before first use of Union_make_material.\n",NAME_CURRENT_COMP);
  exit(1);
}

this_box_volume.geometry.is_masked_volume = 0;
this_box_volume.geometry.is_exit_volume = 0;
this_box_volume.geometry.is_mask_volume = 0;
// check if the volume is a mask, if it is the material string is irelevant.
if (mask_string && strlen(mask_string) && strcmp(mask_string, "NULL") && strcmp(mask_string, "0")) {
    // A mask volume is used to limit the extend of other volumes, called the masked volumes. These are specified in the mask_string.
    // In order for a ray to enter a masked volume, it needs to be both in the region covered by that volume AND the mask volume.
    // When more than
    this_box_volume.geometry.mask_mode = 1; // Default is mask mode is ALL
    if (mask_setting && strlen(mask_setting) && strcmp(mask_setting, "NULL") && strcmp(mask_setting, "0")) {
        if (strcmp(mask_setting,"ALL") == 0 || strcmp(mask_setting,"All") == 0) this_box_volume.geometry.mask_mode = 1;
        else if (strcmp(mask_setting,"ANY") == 0 || strcmp(mask_setting,"Any") == 0) this_box_volume.geometry.mask_mode = 2;
        else {
            printf("The mask_mode of component %s is set to %s, but must be either ALL or ANY.\n",NAME_CURRENT_COMP,mask_setting);
            exit(1);
        }
    }
    
    for (loop_index=0;loop_index<global_geometry_list.num_elements;loop_index++) {
        // Add mask list
        if (1 == manual_linking_function(global_geometry_list.elements[loop_index].name,mask_string)) {
            add_element_to_int_list(&this_box_volume.geometry.mask_list,global_geometry_list.elements[loop_index].component_index);
            add_element_to_int_list(&global_geometry_list.elements[loop_index].Volume->geometry.masked_by_list,INDEX_CURRENT_COMP);
            global_geometry_list.elements[loop_index].Volume->geometry.is_masked_volume = 1;
            if (this_box_volume.geometry.mask_mode == 2)
                global_geometry_list.elements[loop_index].Volume->geometry.mask_mode = 2;
            if (this_box_volume.geometry.mask_mode == 1) {
                if (global_geometry_list.elements[loop_index].Volume->geometry.is_masked_volume == 1 && global_geometry_list.elements[loop_index].Volume->geometry.mask_mode != 2)
                    // If more than one mask is added to one volume, the ANY mode overwrites the (default) ALL mode.
                    global_geometry_list.elements[loop_index].Volume->geometry.mask_mode = 1;
            }
            
            found_geometries = 1;
        }
    }
    if (found_geometries == 0) {
        printf("The mask_string in geometry: %s did not find any of the specified volumes in the mask_string %s \n",NAME_CURRENT_COMP,mask_string);
        exit(1);
    }
    this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
    this_box_volume.p_physics->is_vacuum = 0; // Makes this volume a vacuum
    this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
    this_box_volume.p_physics->my_a = 0; // Should not be used.
    sprintf(this_box_volume.p_physics->name,"Mask");
    this_box_volume.geometry.is_mask_volume = 1;
    
    
// Read the material input, or if it lacks, use automatic linking.
} else if (material_string && strlen(material_string) && strcmp(material_string, "NULL") && strcmp(material_string, "0")) {
    // A geometry string was given, use it to determine which material
    if (0 == strcmp(material_string,"vacuum") || 0 == strcmp(material_string,"Vacuum")) {
        // One could have a global physics struct for vacuum instead of creating one for each
        this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
        this_box_volume.p_physics->is_vacuum = 1; // Makes this volume a vacuum
        this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
        this_box_volume.p_physics->my_a = 0; // Should not be used.
        sprintf(this_box_volume.p_physics->name,"Vacuum");
    } else if (0 == strcmp(material_string,"exit") || 0 == strcmp(material_string,"Exit")) {
        // One could have a global physics struct for vacuum instead of creating one for each
        this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
        this_box_volume.p_physics->is_vacuum = 1; // Makes this volume a vacuum
        this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
        this_box_volume.p_physics->my_a = 0; // Should not be used.
        this_box_volume.geometry.is_exit_volume = 1;
        sprintf(this_box_volume.p_physics->name,"Exit");
    } else {
        #ifndef MATERIAL_DETECTOR
            printf("Need to define a material before refering to it in a geometry %s.\n",NAME_CURRENT_COMP);
            exit(1);
        #endif
        for (loop_index=0;loop_index<global_material_list.num_elements;loop_index++) {
            if (0 == strcmp(material_string,global_material_list.elements[loop_index].name)) {
                this_box_volume.p_physics = global_material_list.elements[loop_index].physics;
                break;
            }
            if (loop_index == global_material_list.num_elements-1) {
            printf("\n");
            printf("ERROR: The material string \"%s\" in Union geometry \"%s\" did not match a specified material. \n",material_string,NAME_CURRENT_COMP);
            printf("       The materials available at this point (need to be defined before the geometry): \n");
            for (loop_index=0;loop_index<global_material_list.num_elements;loop_index++)
              printf("         %s\n",global_material_list.elements[loop_index].name);
            printf("\n");
            printf("       It is also possible to use one of the defualt materials avaiable: \n");
            printf("           Vacuum (for a Volume without scattering or absorption)\n");
            printf("           Exit (for a Volume where the ray exits the component if it enters)\n");
            printf("           Mask (for a Volume that masks existing volumes specified in the mask_string\n");
            exit(1);
          }
        }
    }
} else {
    // Automatic linking, simply using the last defined material.
    #ifndef MATERIAL_DETECTOR
        printf("Need to define a material before the geometry to use automatic linking %s.\n",NAME_CURRENT_COMP);
        exit(1);
    #endif
    this_box_volume.p_physics = global_material_list.elements[global_material_list.num_elements-1].physics;
}

sprintf(this_box_volume.name,NAME_CURRENT_COMP);
sprintf(this_box_volume.geometry.shape,"box");
this_box_volume.geometry.priority_value = priority;
this_box_volume.geometry.geometry_p_interact = p_interact;
// Currently the coordinates will be in absolute space.
this_box_volume.geometry.center = POS_A_CURRENT_COMP;

this_box_storage.z_depth = zdepth;
this_box_storage.x_width1 = xwidth;
this_box_storage.y_height1 = yheight;

this_box_storage.is_rectangle = 0;
if (xwidth2 < 0 && yheight2 < 0) this_box_storage.is_rectangle = 1;
if (xwidth == xwidth2 && yheight == yheight2) this_box_storage.is_rectangle = 1;

if (xwidth2 < 0) {
    this_box_storage.x_width2 = xwidth;
    xwidth2 = xwidth;
} else this_box_storage.x_width2 = xwidth2;

if (yheight2 < 0) {
    this_box_storage.y_height2 = yheight;
    yheight2 = yheight;
} else this_box_storage.y_height2 = yheight2;


this_box_storage.normal_vectors[0] = coords_set(0,0,1);
this_box_storage.normal_vectors[1] = coords_set(0,0,1);

// for sides with y component = 0
x_component = 2*zdepth/sqrt((xwidth-xwidth2)*(xwidth-xwidth2)+4*zdepth*zdepth);
z_component = (xwidth-xwidth2)/sqrt(4*zdepth*zdepth+(xwidth-xwidth2)*(xwidth-xwidth2));

this_box_storage.normal_vectors[2] = coords_set(x_component,0,z_component);
this_box_storage.normal_vectors[3] = coords_set(-x_component,0,z_component);

// for sides with x component = 0
y_component = 2*zdepth/sqrt((yheight-yheight2)*(yheight-yheight2)+4*zdepth*zdepth);
z_component = (yheight-yheight2)/sqrt(4*zdepth*zdepth+(yheight-yheight2)*(yheight-yheight2));

this_box_storage.normal_vectors[4] = coords_set(0,y_component,z_component);
this_box_storage.normal_vectors[5] = coords_set(0,-y_component,z_component);

this_box_volume.geometry.visualization_on = visualize;

this_box_volume.geometry.geometry_parameters.p_box_storage = &this_box_storage;

// Assign pointers to functions for intersection with the shape, checking if a point is inside the shape
if (this_box_storage.is_rectangle == 1) {
this_box_volume.geometry.intersect_function = &sample_box_intersect_simple;
this_box_volume.geometry.within_function = &r_within_box_simple;
}
else {
this_box_volume.geometry.intersect_function = &sample_box_intersect_advanced;
this_box_volume.geometry.within_function = &r_within_box_advanced;
}

this_box_volume.geometry.shell_points = &box_shell_points;
this_box_volume.geometry.mcdisplay_function = &mcdisplay_box_function;
this_box_volume.geometry.initialize_from_main_function = &initialize_box_geometry_from_main_component;
this_box_volume.geometry.process_rot_allocated = 0;

this_box_volume.geometry.copy_geometry_parameters = &allocate_box_storage_copy;

rot_copy(this_box_volume.geometry.rotation_matrix,ROT_A_CURRENT_COMP); //check how ROT_R_CURRENT_COMP would work
rot_transpose(ROT_A_CURRENT_COMP,this_box_volume.geometry.transpose_rotation_matrix);

// Initialize loggers
this_box_volume.loggers.num_elements = 0;

// packing the information into the global_geometry_element, which is then included in the global_geometry_list.
sprintf(global_geometry_element.name,NAME_CURRENT_COMP);
global_geometry_element.activation_counter = number_of_activations;
global_geometry_element.component_index = INDEX_CURRENT_COMP;
global_geometry_element.Volume = &this_box_volume; // Would be nicer if this m was a pointer, now we have the (small) data two places
add_element_to_geometry_list(&global_geometry_list,global_geometry_element);
}
#line 197825 "MACS_sample_kidney_box.c"
#undef number_of_activations
#undef mask_setting
#undef mask_string
#undef p_interact
#undef focus_r
#undef focus_xh
#undef focus_xw
#undef focus_ah
#undef focus_aw
#undef target_z
#undef target_y
#undef target_x
#undef target_index
#undef visualize
#undef yheight2
#undef xwidth2
#undef zdepth
#undef yheight
#undef xwidth
#undef priority
#undef material_string
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

  /* Initializations for component inter_analyzer_colimator_center_3. */
  SIG_MESSAGE("inter_analyzer_colimator_center_3 (Init)");

  /* Initializations for component inter_analyzer_colimator_3_blade_0. */
  SIG_MESSAGE("inter_analyzer_colimator_3_blade_0 (Init)");
#define mccompcurname  inter_analyzer_colimator_3_blade_0
#define mccompcurtype  Union_box
#define mccompcurindex 269
#define loop_index mccinter_analyzer_colimator_3_blade_0_loop_index
#define this_box_volume mccinter_analyzer_colimator_3_blade_0_this_box_volume
#define global_geometry_element mccinter_analyzer_colimator_3_blade_0_global_geometry_element
#define this_box_storage mccinter_analyzer_colimator_3_blade_0_this_box_storage
#define material_string mccinter_analyzer_colimator_3_blade_0_material_string
#define priority mccinter_analyzer_colimator_3_blade_0_priority
#define xwidth mccinter_analyzer_colimator_3_blade_0_xwidth
#define yheight mccinter_analyzer_colimator_3_blade_0_yheight
#define zdepth mccinter_analyzer_colimator_3_blade_0_zdepth
#define xwidth2 mccinter_analyzer_colimator_3_blade_0_xwidth2
#define yheight2 mccinter_analyzer_colimator_3_blade_0_yheight2
#define visualize mccinter_analyzer_colimator_3_blade_0_visualize
#define target_index mccinter_analyzer_colimator_3_blade_0_target_index
#define target_x mccinter_analyzer_colimator_3_blade_0_target_x
#define target_y mccinter_analyzer_colimator_3_blade_0_target_y
#define target_z mccinter_analyzer_colimator_3_blade_0_target_z
#define focus_aw mccinter_analyzer_colimator_3_blade_0_focus_aw
#define focus_ah mccinter_analyzer_colimator_3_blade_0_focus_ah
#define focus_xw mccinter_analyzer_colimator_3_blade_0_focus_xw
#define focus_xh mccinter_analyzer_colimator_3_blade_0_focus_xh
#define focus_r mccinter_analyzer_colimator_3_blade_0_focus_r
#define p_interact mccinter_analyzer_colimator_3_blade_0_p_interact
#define mask_string mccinter_analyzer_colimator_3_blade_0_mask_string
#define mask_setting mccinter_analyzer_colimator_3_blade_0_mask_setting
#define number_of_activations mccinter_analyzer_colimator_3_blade_0_number_of_activations
#line 224 "Union_box.comp"
{
// Initializes the focusing system for this volume including input sanitation.
focus_initialize(&this_box_volume.geometry, POS_A_COMP_INDEX(INDEX_CURRENT_COMP+target_index), POS_A_CURRENT_COMP, ROT_A_CURRENT_COMP, target_index, target_x, target_y, target_z, focus_aw, focus_ah, focus_xw, focus_xh, focus_r, NAME_CURRENT_COMP);

// Input sanitation for this geometry
if (xwidth <= 0) {
  printf("\nERROR in Union_box named %s, the xwidth is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (yheight <= 0) {
  printf("\nERROR in Union_box named %s, yheight is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (zdepth <= 0) {
  printf("\nERROR in Union_box named %s, zdepth is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (xwidth2 <= 0 && xwidth2 != -1) {
  printf("\nERROR in Union_box named %s, the xwidth2 is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (yheight2 <= 0 && yheight2 != -1) {
  printf("\nERROR in Union_box named %s, yheight2 is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}

// Use sanitation
if (global_material_list.num_elements == 0) {
  printf("\nERROR: Need to define a material using Union_make_material before using a Union geometry component. \n");
  printf("       %s was defined before first use of Union_make_material.\n",NAME_CURRENT_COMP);
  exit(1);
}

this_box_volume.geometry.is_masked_volume = 0;
this_box_volume.geometry.is_exit_volume = 0;
this_box_volume.geometry.is_mask_volume = 0;
// check if the volume is a mask, if it is the material string is irelevant.
if (mask_string && strlen(mask_string) && strcmp(mask_string, "NULL") && strcmp(mask_string, "0")) {
    // A mask volume is used to limit the extend of other volumes, called the masked volumes. These are specified in the mask_string.
    // In order for a ray to enter a masked volume, it needs to be both in the region covered by that volume AND the mask volume.
    // When more than
    this_box_volume.geometry.mask_mode = 1; // Default is mask mode is ALL
    if (mask_setting && strlen(mask_setting) && strcmp(mask_setting, "NULL") && strcmp(mask_setting, "0")) {
        if (strcmp(mask_setting,"ALL") == 0 || strcmp(mask_setting,"All") == 0) this_box_volume.geometry.mask_mode = 1;
        else if (strcmp(mask_setting,"ANY") == 0 || strcmp(mask_setting,"Any") == 0) this_box_volume.geometry.mask_mode = 2;
        else {
            printf("The mask_mode of component %s is set to %s, but must be either ALL or ANY.\n",NAME_CURRENT_COMP,mask_setting);
            exit(1);
        }
    }
    
    for (loop_index=0;loop_index<global_geometry_list.num_elements;loop_index++) {
        // Add mask list
        if (1 == manual_linking_function(global_geometry_list.elements[loop_index].name,mask_string)) {
            add_element_to_int_list(&this_box_volume.geometry.mask_list,global_geometry_list.elements[loop_index].component_index);
            add_element_to_int_list(&global_geometry_list.elements[loop_index].Volume->geometry.masked_by_list,INDEX_CURRENT_COMP);
            global_geometry_list.elements[loop_index].Volume->geometry.is_masked_volume = 1;
            if (this_box_volume.geometry.mask_mode == 2)
                global_geometry_list.elements[loop_index].Volume->geometry.mask_mode = 2;
            if (this_box_volume.geometry.mask_mode == 1) {
                if (global_geometry_list.elements[loop_index].Volume->geometry.is_masked_volume == 1 && global_geometry_list.elements[loop_index].Volume->geometry.mask_mode != 2)
                    // If more than one mask is added to one volume, the ANY mode overwrites the (default) ALL mode.
                    global_geometry_list.elements[loop_index].Volume->geometry.mask_mode = 1;
            }
            
            found_geometries = 1;
        }
    }
    if (found_geometries == 0) {
        printf("The mask_string in geometry: %s did not find any of the specified volumes in the mask_string %s \n",NAME_CURRENT_COMP,mask_string);
        exit(1);
    }
    this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
    this_box_volume.p_physics->is_vacuum = 0; // Makes this volume a vacuum
    this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
    this_box_volume.p_physics->my_a = 0; // Should not be used.
    sprintf(this_box_volume.p_physics->name,"Mask");
    this_box_volume.geometry.is_mask_volume = 1;
    
    
// Read the material input, or if it lacks, use automatic linking.
} else if (material_string && strlen(material_string) && strcmp(material_string, "NULL") && strcmp(material_string, "0")) {
    // A geometry string was given, use it to determine which material
    if (0 == strcmp(material_string,"vacuum") || 0 == strcmp(material_string,"Vacuum")) {
        // One could have a global physics struct for vacuum instead of creating one for each
        this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
        this_box_volume.p_physics->is_vacuum = 1; // Makes this volume a vacuum
        this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
        this_box_volume.p_physics->my_a = 0; // Should not be used.
        sprintf(this_box_volume.p_physics->name,"Vacuum");
    } else if (0 == strcmp(material_string,"exit") || 0 == strcmp(material_string,"Exit")) {
        // One could have a global physics struct for vacuum instead of creating one for each
        this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
        this_box_volume.p_physics->is_vacuum = 1; // Makes this volume a vacuum
        this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
        this_box_volume.p_physics->my_a = 0; // Should not be used.
        this_box_volume.geometry.is_exit_volume = 1;
        sprintf(this_box_volume.p_physics->name,"Exit");
    } else {
        #ifndef MATERIAL_DETECTOR
            printf("Need to define a material before refering to it in a geometry %s.\n",NAME_CURRENT_COMP);
            exit(1);
        #endif
        for (loop_index=0;loop_index<global_material_list.num_elements;loop_index++) {
            if (0 == strcmp(material_string,global_material_list.elements[loop_index].name)) {
                this_box_volume.p_physics = global_material_list.elements[loop_index].physics;
                break;
            }
            if (loop_index == global_material_list.num_elements-1) {
            printf("\n");
            printf("ERROR: The material string \"%s\" in Union geometry \"%s\" did not match a specified material. \n",material_string,NAME_CURRENT_COMP);
            printf("       The materials available at this point (need to be defined before the geometry): \n");
            for (loop_index=0;loop_index<global_material_list.num_elements;loop_index++)
              printf("         %s\n",global_material_list.elements[loop_index].name);
            printf("\n");
            printf("       It is also possible to use one of the defualt materials avaiable: \n");
            printf("           Vacuum (for a Volume without scattering or absorption)\n");
            printf("           Exit (for a Volume where the ray exits the component if it enters)\n");
            printf("           Mask (for a Volume that masks existing volumes specified in the mask_string\n");
            exit(1);
          }
        }
    }
} else {
    // Automatic linking, simply using the last defined material.
    #ifndef MATERIAL_DETECTOR
        printf("Need to define a material before the geometry to use automatic linking %s.\n",NAME_CURRENT_COMP);
        exit(1);
    #endif
    this_box_volume.p_physics = global_material_list.elements[global_material_list.num_elements-1].physics;
}

sprintf(this_box_volume.name,NAME_CURRENT_COMP);
sprintf(this_box_volume.geometry.shape,"box");
this_box_volume.geometry.priority_value = priority;
this_box_volume.geometry.geometry_p_interact = p_interact;
// Currently the coordinates will be in absolute space.
this_box_volume.geometry.center = POS_A_CURRENT_COMP;

this_box_storage.z_depth = zdepth;
this_box_storage.x_width1 = xwidth;
this_box_storage.y_height1 = yheight;

this_box_storage.is_rectangle = 0;
if (xwidth2 < 0 && yheight2 < 0) this_box_storage.is_rectangle = 1;
if (xwidth == xwidth2 && yheight == yheight2) this_box_storage.is_rectangle = 1;

if (xwidth2 < 0) {
    this_box_storage.x_width2 = xwidth;
    xwidth2 = xwidth;
} else this_box_storage.x_width2 = xwidth2;

if (yheight2 < 0) {
    this_box_storage.y_height2 = yheight;
    yheight2 = yheight;
} else this_box_storage.y_height2 = yheight2;


this_box_storage.normal_vectors[0] = coords_set(0,0,1);
this_box_storage.normal_vectors[1] = coords_set(0,0,1);

// for sides with y component = 0
x_component = 2*zdepth/sqrt((xwidth-xwidth2)*(xwidth-xwidth2)+4*zdepth*zdepth);
z_component = (xwidth-xwidth2)/sqrt(4*zdepth*zdepth+(xwidth-xwidth2)*(xwidth-xwidth2));

this_box_storage.normal_vectors[2] = coords_set(x_component,0,z_component);
this_box_storage.normal_vectors[3] = coords_set(-x_component,0,z_component);

// for sides with x component = 0
y_component = 2*zdepth/sqrt((yheight-yheight2)*(yheight-yheight2)+4*zdepth*zdepth);
z_component = (yheight-yheight2)/sqrt(4*zdepth*zdepth+(yheight-yheight2)*(yheight-yheight2));

this_box_storage.normal_vectors[4] = coords_set(0,y_component,z_component);
this_box_storage.normal_vectors[5] = coords_set(0,-y_component,z_component);

this_box_volume.geometry.visualization_on = visualize;

this_box_volume.geometry.geometry_parameters.p_box_storage = &this_box_storage;

// Assign pointers to functions for intersection with the shape, checking if a point is inside the shape
if (this_box_storage.is_rectangle == 1) {
this_box_volume.geometry.intersect_function = &sample_box_intersect_simple;
this_box_volume.geometry.within_function = &r_within_box_simple;
}
else {
this_box_volume.geometry.intersect_function = &sample_box_intersect_advanced;
this_box_volume.geometry.within_function = &r_within_box_advanced;
}

this_box_volume.geometry.shell_points = &box_shell_points;
this_box_volume.geometry.mcdisplay_function = &mcdisplay_box_function;
this_box_volume.geometry.initialize_from_main_function = &initialize_box_geometry_from_main_component;
this_box_volume.geometry.process_rot_allocated = 0;

this_box_volume.geometry.copy_geometry_parameters = &allocate_box_storage_copy;

rot_copy(this_box_volume.geometry.rotation_matrix,ROT_A_CURRENT_COMP); //check how ROT_R_CURRENT_COMP would work
rot_transpose(ROT_A_CURRENT_COMP,this_box_volume.geometry.transpose_rotation_matrix);

// Initialize loggers
this_box_volume.loggers.num_elements = 0;

// packing the information into the global_geometry_element, which is then included in the global_geometry_list.
sprintf(global_geometry_element.name,NAME_CURRENT_COMP);
global_geometry_element.activation_counter = number_of_activations;
global_geometry_element.component_index = INDEX_CURRENT_COMP;
global_geometry_element.Volume = &this_box_volume; // Would be nicer if this m was a pointer, now we have the (small) data two places
add_element_to_geometry_list(&global_geometry_list,global_geometry_element);
}
#line 198098 "MACS_sample_kidney_box.c"
#undef number_of_activations
#undef mask_setting
#undef mask_string
#undef p_interact
#undef focus_r
#undef focus_xh
#undef focus_xw
#undef focus_ah
#undef focus_aw
#undef target_z
#undef target_y
#undef target_x
#undef target_index
#undef visualize
#undef yheight2
#undef xwidth2
#undef zdepth
#undef yheight
#undef xwidth
#undef priority
#undef material_string
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

  /* Initializations for component inter_analyzer_colimator_3_blade_1. */
  SIG_MESSAGE("inter_analyzer_colimator_3_blade_1 (Init)");
#define mccompcurname  inter_analyzer_colimator_3_blade_1
#define mccompcurtype  Union_box
#define mccompcurindex 270
#define loop_index mccinter_analyzer_colimator_3_blade_1_loop_index
#define this_box_volume mccinter_analyzer_colimator_3_blade_1_this_box_volume
#define global_geometry_element mccinter_analyzer_colimator_3_blade_1_global_geometry_element
#define this_box_storage mccinter_analyzer_colimator_3_blade_1_this_box_storage
#define material_string mccinter_analyzer_colimator_3_blade_1_material_string
#define priority mccinter_analyzer_colimator_3_blade_1_priority
#define xwidth mccinter_analyzer_colimator_3_blade_1_xwidth
#define yheight mccinter_analyzer_colimator_3_blade_1_yheight
#define zdepth mccinter_analyzer_colimator_3_blade_1_zdepth
#define xwidth2 mccinter_analyzer_colimator_3_blade_1_xwidth2
#define yheight2 mccinter_analyzer_colimator_3_blade_1_yheight2
#define visualize mccinter_analyzer_colimator_3_blade_1_visualize
#define target_index mccinter_analyzer_colimator_3_blade_1_target_index
#define target_x mccinter_analyzer_colimator_3_blade_1_target_x
#define target_y mccinter_analyzer_colimator_3_blade_1_target_y
#define target_z mccinter_analyzer_colimator_3_blade_1_target_z
#define focus_aw mccinter_analyzer_colimator_3_blade_1_focus_aw
#define focus_ah mccinter_analyzer_colimator_3_blade_1_focus_ah
#define focus_xw mccinter_analyzer_colimator_3_blade_1_focus_xw
#define focus_xh mccinter_analyzer_colimator_3_blade_1_focus_xh
#define focus_r mccinter_analyzer_colimator_3_blade_1_focus_r
#define p_interact mccinter_analyzer_colimator_3_blade_1_p_interact
#define mask_string mccinter_analyzer_colimator_3_blade_1_mask_string
#define mask_setting mccinter_analyzer_colimator_3_blade_1_mask_setting
#define number_of_activations mccinter_analyzer_colimator_3_blade_1_number_of_activations
#line 224 "Union_box.comp"
{
// Initializes the focusing system for this volume including input sanitation.
focus_initialize(&this_box_volume.geometry, POS_A_COMP_INDEX(INDEX_CURRENT_COMP+target_index), POS_A_CURRENT_COMP, ROT_A_CURRENT_COMP, target_index, target_x, target_y, target_z, focus_aw, focus_ah, focus_xw, focus_xh, focus_r, NAME_CURRENT_COMP);

// Input sanitation for this geometry
if (xwidth <= 0) {
  printf("\nERROR in Union_box named %s, the xwidth is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (yheight <= 0) {
  printf("\nERROR in Union_box named %s, yheight is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (zdepth <= 0) {
  printf("\nERROR in Union_box named %s, zdepth is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (xwidth2 <= 0 && xwidth2 != -1) {
  printf("\nERROR in Union_box named %s, the xwidth2 is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (yheight2 <= 0 && yheight2 != -1) {
  printf("\nERROR in Union_box named %s, yheight2 is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}

// Use sanitation
if (global_material_list.num_elements == 0) {
  printf("\nERROR: Need to define a material using Union_make_material before using a Union geometry component. \n");
  printf("       %s was defined before first use of Union_make_material.\n",NAME_CURRENT_COMP);
  exit(1);
}

this_box_volume.geometry.is_masked_volume = 0;
this_box_volume.geometry.is_exit_volume = 0;
this_box_volume.geometry.is_mask_volume = 0;
// check if the volume is a mask, if it is the material string is irelevant.
if (mask_string && strlen(mask_string) && strcmp(mask_string, "NULL") && strcmp(mask_string, "0")) {
    // A mask volume is used to limit the extend of other volumes, called the masked volumes. These are specified in the mask_string.
    // In order for a ray to enter a masked volume, it needs to be both in the region covered by that volume AND the mask volume.
    // When more than
    this_box_volume.geometry.mask_mode = 1; // Default is mask mode is ALL
    if (mask_setting && strlen(mask_setting) && strcmp(mask_setting, "NULL") && strcmp(mask_setting, "0")) {
        if (strcmp(mask_setting,"ALL") == 0 || strcmp(mask_setting,"All") == 0) this_box_volume.geometry.mask_mode = 1;
        else if (strcmp(mask_setting,"ANY") == 0 || strcmp(mask_setting,"Any") == 0) this_box_volume.geometry.mask_mode = 2;
        else {
            printf("The mask_mode of component %s is set to %s, but must be either ALL or ANY.\n",NAME_CURRENT_COMP,mask_setting);
            exit(1);
        }
    }
    
    for (loop_index=0;loop_index<global_geometry_list.num_elements;loop_index++) {
        // Add mask list
        if (1 == manual_linking_function(global_geometry_list.elements[loop_index].name,mask_string)) {
            add_element_to_int_list(&this_box_volume.geometry.mask_list,global_geometry_list.elements[loop_index].component_index);
            add_element_to_int_list(&global_geometry_list.elements[loop_index].Volume->geometry.masked_by_list,INDEX_CURRENT_COMP);
            global_geometry_list.elements[loop_index].Volume->geometry.is_masked_volume = 1;
            if (this_box_volume.geometry.mask_mode == 2)
                global_geometry_list.elements[loop_index].Volume->geometry.mask_mode = 2;
            if (this_box_volume.geometry.mask_mode == 1) {
                if (global_geometry_list.elements[loop_index].Volume->geometry.is_masked_volume == 1 && global_geometry_list.elements[loop_index].Volume->geometry.mask_mode != 2)
                    // If more than one mask is added to one volume, the ANY mode overwrites the (default) ALL mode.
                    global_geometry_list.elements[loop_index].Volume->geometry.mask_mode = 1;
            }
            
            found_geometries = 1;
        }
    }
    if (found_geometries == 0) {
        printf("The mask_string in geometry: %s did not find any of the specified volumes in the mask_string %s \n",NAME_CURRENT_COMP,mask_string);
        exit(1);
    }
    this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
    this_box_volume.p_physics->is_vacuum = 0; // Makes this volume a vacuum
    this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
    this_box_volume.p_physics->my_a = 0; // Should not be used.
    sprintf(this_box_volume.p_physics->name,"Mask");
    this_box_volume.geometry.is_mask_volume = 1;
    
    
// Read the material input, or if it lacks, use automatic linking.
} else if (material_string && strlen(material_string) && strcmp(material_string, "NULL") && strcmp(material_string, "0")) {
    // A geometry string was given, use it to determine which material
    if (0 == strcmp(material_string,"vacuum") || 0 == strcmp(material_string,"Vacuum")) {
        // One could have a global physics struct for vacuum instead of creating one for each
        this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
        this_box_volume.p_physics->is_vacuum = 1; // Makes this volume a vacuum
        this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
        this_box_volume.p_physics->my_a = 0; // Should not be used.
        sprintf(this_box_volume.p_physics->name,"Vacuum");
    } else if (0 == strcmp(material_string,"exit") || 0 == strcmp(material_string,"Exit")) {
        // One could have a global physics struct for vacuum instead of creating one for each
        this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
        this_box_volume.p_physics->is_vacuum = 1; // Makes this volume a vacuum
        this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
        this_box_volume.p_physics->my_a = 0; // Should not be used.
        this_box_volume.geometry.is_exit_volume = 1;
        sprintf(this_box_volume.p_physics->name,"Exit");
    } else {
        #ifndef MATERIAL_DETECTOR
            printf("Need to define a material before refering to it in a geometry %s.\n",NAME_CURRENT_COMP);
            exit(1);
        #endif
        for (loop_index=0;loop_index<global_material_list.num_elements;loop_index++) {
            if (0 == strcmp(material_string,global_material_list.elements[loop_index].name)) {
                this_box_volume.p_physics = global_material_list.elements[loop_index].physics;
                break;
            }
            if (loop_index == global_material_list.num_elements-1) {
            printf("\n");
            printf("ERROR: The material string \"%s\" in Union geometry \"%s\" did not match a specified material. \n",material_string,NAME_CURRENT_COMP);
            printf("       The materials available at this point (need to be defined before the geometry): \n");
            for (loop_index=0;loop_index<global_material_list.num_elements;loop_index++)
              printf("         %s\n",global_material_list.elements[loop_index].name);
            printf("\n");
            printf("       It is also possible to use one of the defualt materials avaiable: \n");
            printf("           Vacuum (for a Volume without scattering or absorption)\n");
            printf("           Exit (for a Volume where the ray exits the component if it enters)\n");
            printf("           Mask (for a Volume that masks existing volumes specified in the mask_string\n");
            exit(1);
          }
        }
    }
} else {
    // Automatic linking, simply using the last defined material.
    #ifndef MATERIAL_DETECTOR
        printf("Need to define a material before the geometry to use automatic linking %s.\n",NAME_CURRENT_COMP);
        exit(1);
    #endif
    this_box_volume.p_physics = global_material_list.elements[global_material_list.num_elements-1].physics;
}

sprintf(this_box_volume.name,NAME_CURRENT_COMP);
sprintf(this_box_volume.geometry.shape,"box");
this_box_volume.geometry.priority_value = priority;
this_box_volume.geometry.geometry_p_interact = p_interact;
// Currently the coordinates will be in absolute space.
this_box_volume.geometry.center = POS_A_CURRENT_COMP;

this_box_storage.z_depth = zdepth;
this_box_storage.x_width1 = xwidth;
this_box_storage.y_height1 = yheight;

this_box_storage.is_rectangle = 0;
if (xwidth2 < 0 && yheight2 < 0) this_box_storage.is_rectangle = 1;
if (xwidth == xwidth2 && yheight == yheight2) this_box_storage.is_rectangle = 1;

if (xwidth2 < 0) {
    this_box_storage.x_width2 = xwidth;
    xwidth2 = xwidth;
} else this_box_storage.x_width2 = xwidth2;

if (yheight2 < 0) {
    this_box_storage.y_height2 = yheight;
    yheight2 = yheight;
} else this_box_storage.y_height2 = yheight2;


this_box_storage.normal_vectors[0] = coords_set(0,0,1);
this_box_storage.normal_vectors[1] = coords_set(0,0,1);

// for sides with y component = 0
x_component = 2*zdepth/sqrt((xwidth-xwidth2)*(xwidth-xwidth2)+4*zdepth*zdepth);
z_component = (xwidth-xwidth2)/sqrt(4*zdepth*zdepth+(xwidth-xwidth2)*(xwidth-xwidth2));

this_box_storage.normal_vectors[2] = coords_set(x_component,0,z_component);
this_box_storage.normal_vectors[3] = coords_set(-x_component,0,z_component);

// for sides with x component = 0
y_component = 2*zdepth/sqrt((yheight-yheight2)*(yheight-yheight2)+4*zdepth*zdepth);
z_component = (yheight-yheight2)/sqrt(4*zdepth*zdepth+(yheight-yheight2)*(yheight-yheight2));

this_box_storage.normal_vectors[4] = coords_set(0,y_component,z_component);
this_box_storage.normal_vectors[5] = coords_set(0,-y_component,z_component);

this_box_volume.geometry.visualization_on = visualize;

this_box_volume.geometry.geometry_parameters.p_box_storage = &this_box_storage;

// Assign pointers to functions for intersection with the shape, checking if a point is inside the shape
if (this_box_storage.is_rectangle == 1) {
this_box_volume.geometry.intersect_function = &sample_box_intersect_simple;
this_box_volume.geometry.within_function = &r_within_box_simple;
}
else {
this_box_volume.geometry.intersect_function = &sample_box_intersect_advanced;
this_box_volume.geometry.within_function = &r_within_box_advanced;
}

this_box_volume.geometry.shell_points = &box_shell_points;
this_box_volume.geometry.mcdisplay_function = &mcdisplay_box_function;
this_box_volume.geometry.initialize_from_main_function = &initialize_box_geometry_from_main_component;
this_box_volume.geometry.process_rot_allocated = 0;

this_box_volume.geometry.copy_geometry_parameters = &allocate_box_storage_copy;

rot_copy(this_box_volume.geometry.rotation_matrix,ROT_A_CURRENT_COMP); //check how ROT_R_CURRENT_COMP would work
rot_transpose(ROT_A_CURRENT_COMP,this_box_volume.geometry.transpose_rotation_matrix);

// Initialize loggers
this_box_volume.loggers.num_elements = 0;

// packing the information into the global_geometry_element, which is then included in the global_geometry_list.
sprintf(global_geometry_element.name,NAME_CURRENT_COMP);
global_geometry_element.activation_counter = number_of_activations;
global_geometry_element.component_index = INDEX_CURRENT_COMP;
global_geometry_element.Volume = &this_box_volume; // Would be nicer if this m was a pointer, now we have the (small) data two places
add_element_to_geometry_list(&global_geometry_list,global_geometry_element);
}
#line 198368 "MACS_sample_kidney_box.c"
#undef number_of_activations
#undef mask_setting
#undef mask_string
#undef p_interact
#undef focus_r
#undef focus_xh
#undef focus_xw
#undef focus_ah
#undef focus_aw
#undef target_z
#undef target_y
#undef target_x
#undef target_index
#undef visualize
#undef yheight2
#undef xwidth2
#undef zdepth
#undef yheight
#undef xwidth
#undef priority
#undef material_string
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

  /* Initializations for component inter_analyzer_colimator_3_blade_2. */
  SIG_MESSAGE("inter_analyzer_colimator_3_blade_2 (Init)");
#define mccompcurname  inter_analyzer_colimator_3_blade_2
#define mccompcurtype  Union_box
#define mccompcurindex 271
#define loop_index mccinter_analyzer_colimator_3_blade_2_loop_index
#define this_box_volume mccinter_analyzer_colimator_3_blade_2_this_box_volume
#define global_geometry_element mccinter_analyzer_colimator_3_blade_2_global_geometry_element
#define this_box_storage mccinter_analyzer_colimator_3_blade_2_this_box_storage
#define material_string mccinter_analyzer_colimator_3_blade_2_material_string
#define priority mccinter_analyzer_colimator_3_blade_2_priority
#define xwidth mccinter_analyzer_colimator_3_blade_2_xwidth
#define yheight mccinter_analyzer_colimator_3_blade_2_yheight
#define zdepth mccinter_analyzer_colimator_3_blade_2_zdepth
#define xwidth2 mccinter_analyzer_colimator_3_blade_2_xwidth2
#define yheight2 mccinter_analyzer_colimator_3_blade_2_yheight2
#define visualize mccinter_analyzer_colimator_3_blade_2_visualize
#define target_index mccinter_analyzer_colimator_3_blade_2_target_index
#define target_x mccinter_analyzer_colimator_3_blade_2_target_x
#define target_y mccinter_analyzer_colimator_3_blade_2_target_y
#define target_z mccinter_analyzer_colimator_3_blade_2_target_z
#define focus_aw mccinter_analyzer_colimator_3_blade_2_focus_aw
#define focus_ah mccinter_analyzer_colimator_3_blade_2_focus_ah
#define focus_xw mccinter_analyzer_colimator_3_blade_2_focus_xw
#define focus_xh mccinter_analyzer_colimator_3_blade_2_focus_xh
#define focus_r mccinter_analyzer_colimator_3_blade_2_focus_r
#define p_interact mccinter_analyzer_colimator_3_blade_2_p_interact
#define mask_string mccinter_analyzer_colimator_3_blade_2_mask_string
#define mask_setting mccinter_analyzer_colimator_3_blade_2_mask_setting
#define number_of_activations mccinter_analyzer_colimator_3_blade_2_number_of_activations
#line 224 "Union_box.comp"
{
// Initializes the focusing system for this volume including input sanitation.
focus_initialize(&this_box_volume.geometry, POS_A_COMP_INDEX(INDEX_CURRENT_COMP+target_index), POS_A_CURRENT_COMP, ROT_A_CURRENT_COMP, target_index, target_x, target_y, target_z, focus_aw, focus_ah, focus_xw, focus_xh, focus_r, NAME_CURRENT_COMP);

// Input sanitation for this geometry
if (xwidth <= 0) {
  printf("\nERROR in Union_box named %s, the xwidth is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (yheight <= 0) {
  printf("\nERROR in Union_box named %s, yheight is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (zdepth <= 0) {
  printf("\nERROR in Union_box named %s, zdepth is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (xwidth2 <= 0 && xwidth2 != -1) {
  printf("\nERROR in Union_box named %s, the xwidth2 is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (yheight2 <= 0 && yheight2 != -1) {
  printf("\nERROR in Union_box named %s, yheight2 is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}

// Use sanitation
if (global_material_list.num_elements == 0) {
  printf("\nERROR: Need to define a material using Union_make_material before using a Union geometry component. \n");
  printf("       %s was defined before first use of Union_make_material.\n",NAME_CURRENT_COMP);
  exit(1);
}

this_box_volume.geometry.is_masked_volume = 0;
this_box_volume.geometry.is_exit_volume = 0;
this_box_volume.geometry.is_mask_volume = 0;
// check if the volume is a mask, if it is the material string is irelevant.
if (mask_string && strlen(mask_string) && strcmp(mask_string, "NULL") && strcmp(mask_string, "0")) {
    // A mask volume is used to limit the extend of other volumes, called the masked volumes. These are specified in the mask_string.
    // In order for a ray to enter a masked volume, it needs to be both in the region covered by that volume AND the mask volume.
    // When more than
    this_box_volume.geometry.mask_mode = 1; // Default is mask mode is ALL
    if (mask_setting && strlen(mask_setting) && strcmp(mask_setting, "NULL") && strcmp(mask_setting, "0")) {
        if (strcmp(mask_setting,"ALL") == 0 || strcmp(mask_setting,"All") == 0) this_box_volume.geometry.mask_mode = 1;
        else if (strcmp(mask_setting,"ANY") == 0 || strcmp(mask_setting,"Any") == 0) this_box_volume.geometry.mask_mode = 2;
        else {
            printf("The mask_mode of component %s is set to %s, but must be either ALL or ANY.\n",NAME_CURRENT_COMP,mask_setting);
            exit(1);
        }
    }
    
    for (loop_index=0;loop_index<global_geometry_list.num_elements;loop_index++) {
        // Add mask list
        if (1 == manual_linking_function(global_geometry_list.elements[loop_index].name,mask_string)) {
            add_element_to_int_list(&this_box_volume.geometry.mask_list,global_geometry_list.elements[loop_index].component_index);
            add_element_to_int_list(&global_geometry_list.elements[loop_index].Volume->geometry.masked_by_list,INDEX_CURRENT_COMP);
            global_geometry_list.elements[loop_index].Volume->geometry.is_masked_volume = 1;
            if (this_box_volume.geometry.mask_mode == 2)
                global_geometry_list.elements[loop_index].Volume->geometry.mask_mode = 2;
            if (this_box_volume.geometry.mask_mode == 1) {
                if (global_geometry_list.elements[loop_index].Volume->geometry.is_masked_volume == 1 && global_geometry_list.elements[loop_index].Volume->geometry.mask_mode != 2)
                    // If more than one mask is added to one volume, the ANY mode overwrites the (default) ALL mode.
                    global_geometry_list.elements[loop_index].Volume->geometry.mask_mode = 1;
            }
            
            found_geometries = 1;
        }
    }
    if (found_geometries == 0) {
        printf("The mask_string in geometry: %s did not find any of the specified volumes in the mask_string %s \n",NAME_CURRENT_COMP,mask_string);
        exit(1);
    }
    this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
    this_box_volume.p_physics->is_vacuum = 0; // Makes this volume a vacuum
    this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
    this_box_volume.p_physics->my_a = 0; // Should not be used.
    sprintf(this_box_volume.p_physics->name,"Mask");
    this_box_volume.geometry.is_mask_volume = 1;
    
    
// Read the material input, or if it lacks, use automatic linking.
} else if (material_string && strlen(material_string) && strcmp(material_string, "NULL") && strcmp(material_string, "0")) {
    // A geometry string was given, use it to determine which material
    if (0 == strcmp(material_string,"vacuum") || 0 == strcmp(material_string,"Vacuum")) {
        // One could have a global physics struct for vacuum instead of creating one for each
        this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
        this_box_volume.p_physics->is_vacuum = 1; // Makes this volume a vacuum
        this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
        this_box_volume.p_physics->my_a = 0; // Should not be used.
        sprintf(this_box_volume.p_physics->name,"Vacuum");
    } else if (0 == strcmp(material_string,"exit") || 0 == strcmp(material_string,"Exit")) {
        // One could have a global physics struct for vacuum instead of creating one for each
        this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
        this_box_volume.p_physics->is_vacuum = 1; // Makes this volume a vacuum
        this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
        this_box_volume.p_physics->my_a = 0; // Should not be used.
        this_box_volume.geometry.is_exit_volume = 1;
        sprintf(this_box_volume.p_physics->name,"Exit");
    } else {
        #ifndef MATERIAL_DETECTOR
            printf("Need to define a material before refering to it in a geometry %s.\n",NAME_CURRENT_COMP);
            exit(1);
        #endif
        for (loop_index=0;loop_index<global_material_list.num_elements;loop_index++) {
            if (0 == strcmp(material_string,global_material_list.elements[loop_index].name)) {
                this_box_volume.p_physics = global_material_list.elements[loop_index].physics;
                break;
            }
            if (loop_index == global_material_list.num_elements-1) {
            printf("\n");
            printf("ERROR: The material string \"%s\" in Union geometry \"%s\" did not match a specified material. \n",material_string,NAME_CURRENT_COMP);
            printf("       The materials available at this point (need to be defined before the geometry): \n");
            for (loop_index=0;loop_index<global_material_list.num_elements;loop_index++)
              printf("         %s\n",global_material_list.elements[loop_index].name);
            printf("\n");
            printf("       It is also possible to use one of the defualt materials avaiable: \n");
            printf("           Vacuum (for a Volume without scattering or absorption)\n");
            printf("           Exit (for a Volume where the ray exits the component if it enters)\n");
            printf("           Mask (for a Volume that masks existing volumes specified in the mask_string\n");
            exit(1);
          }
        }
    }
} else {
    // Automatic linking, simply using the last defined material.
    #ifndef MATERIAL_DETECTOR
        printf("Need to define a material before the geometry to use automatic linking %s.\n",NAME_CURRENT_COMP);
        exit(1);
    #endif
    this_box_volume.p_physics = global_material_list.elements[global_material_list.num_elements-1].physics;
}

sprintf(this_box_volume.name,NAME_CURRENT_COMP);
sprintf(this_box_volume.geometry.shape,"box");
this_box_volume.geometry.priority_value = priority;
this_box_volume.geometry.geometry_p_interact = p_interact;
// Currently the coordinates will be in absolute space.
this_box_volume.geometry.center = POS_A_CURRENT_COMP;

this_box_storage.z_depth = zdepth;
this_box_storage.x_width1 = xwidth;
this_box_storage.y_height1 = yheight;

this_box_storage.is_rectangle = 0;
if (xwidth2 < 0 && yheight2 < 0) this_box_storage.is_rectangle = 1;
if (xwidth == xwidth2 && yheight == yheight2) this_box_storage.is_rectangle = 1;

if (xwidth2 < 0) {
    this_box_storage.x_width2 = xwidth;
    xwidth2 = xwidth;
} else this_box_storage.x_width2 = xwidth2;

if (yheight2 < 0) {
    this_box_storage.y_height2 = yheight;
    yheight2 = yheight;
} else this_box_storage.y_height2 = yheight2;


this_box_storage.normal_vectors[0] = coords_set(0,0,1);
this_box_storage.normal_vectors[1] = coords_set(0,0,1);

// for sides with y component = 0
x_component = 2*zdepth/sqrt((xwidth-xwidth2)*(xwidth-xwidth2)+4*zdepth*zdepth);
z_component = (xwidth-xwidth2)/sqrt(4*zdepth*zdepth+(xwidth-xwidth2)*(xwidth-xwidth2));

this_box_storage.normal_vectors[2] = coords_set(x_component,0,z_component);
this_box_storage.normal_vectors[3] = coords_set(-x_component,0,z_component);

// for sides with x component = 0
y_component = 2*zdepth/sqrt((yheight-yheight2)*(yheight-yheight2)+4*zdepth*zdepth);
z_component = (yheight-yheight2)/sqrt(4*zdepth*zdepth+(yheight-yheight2)*(yheight-yheight2));

this_box_storage.normal_vectors[4] = coords_set(0,y_component,z_component);
this_box_storage.normal_vectors[5] = coords_set(0,-y_component,z_component);

this_box_volume.geometry.visualization_on = visualize;

this_box_volume.geometry.geometry_parameters.p_box_storage = &this_box_storage;

// Assign pointers to functions for intersection with the shape, checking if a point is inside the shape
if (this_box_storage.is_rectangle == 1) {
this_box_volume.geometry.intersect_function = &sample_box_intersect_simple;
this_box_volume.geometry.within_function = &r_within_box_simple;
}
else {
this_box_volume.geometry.intersect_function = &sample_box_intersect_advanced;
this_box_volume.geometry.within_function = &r_within_box_advanced;
}

this_box_volume.geometry.shell_points = &box_shell_points;
this_box_volume.geometry.mcdisplay_function = &mcdisplay_box_function;
this_box_volume.geometry.initialize_from_main_function = &initialize_box_geometry_from_main_component;
this_box_volume.geometry.process_rot_allocated = 0;

this_box_volume.geometry.copy_geometry_parameters = &allocate_box_storage_copy;

rot_copy(this_box_volume.geometry.rotation_matrix,ROT_A_CURRENT_COMP); //check how ROT_R_CURRENT_COMP would work
rot_transpose(ROT_A_CURRENT_COMP,this_box_volume.geometry.transpose_rotation_matrix);

// Initialize loggers
this_box_volume.loggers.num_elements = 0;

// packing the information into the global_geometry_element, which is then included in the global_geometry_list.
sprintf(global_geometry_element.name,NAME_CURRENT_COMP);
global_geometry_element.activation_counter = number_of_activations;
global_geometry_element.component_index = INDEX_CURRENT_COMP;
global_geometry_element.Volume = &this_box_volume; // Would be nicer if this m was a pointer, now we have the (small) data two places
add_element_to_geometry_list(&global_geometry_list,global_geometry_element);
}
#line 198638 "MACS_sample_kidney_box.c"
#undef number_of_activations
#undef mask_setting
#undef mask_string
#undef p_interact
#undef focus_r
#undef focus_xh
#undef focus_xw
#undef focus_ah
#undef focus_aw
#undef target_z
#undef target_y
#undef target_x
#undef target_index
#undef visualize
#undef yheight2
#undef xwidth2
#undef zdepth
#undef yheight
#undef xwidth
#undef priority
#undef material_string
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

  /* Initializations for component inter_analyzer_colimator_3_blade_3. */
  SIG_MESSAGE("inter_analyzer_colimator_3_blade_3 (Init)");
#define mccompcurname  inter_analyzer_colimator_3_blade_3
#define mccompcurtype  Union_box
#define mccompcurindex 272
#define loop_index mccinter_analyzer_colimator_3_blade_3_loop_index
#define this_box_volume mccinter_analyzer_colimator_3_blade_3_this_box_volume
#define global_geometry_element mccinter_analyzer_colimator_3_blade_3_global_geometry_element
#define this_box_storage mccinter_analyzer_colimator_3_blade_3_this_box_storage
#define material_string mccinter_analyzer_colimator_3_blade_3_material_string
#define priority mccinter_analyzer_colimator_3_blade_3_priority
#define xwidth mccinter_analyzer_colimator_3_blade_3_xwidth
#define yheight mccinter_analyzer_colimator_3_blade_3_yheight
#define zdepth mccinter_analyzer_colimator_3_blade_3_zdepth
#define xwidth2 mccinter_analyzer_colimator_3_blade_3_xwidth2
#define yheight2 mccinter_analyzer_colimator_3_blade_3_yheight2
#define visualize mccinter_analyzer_colimator_3_blade_3_visualize
#define target_index mccinter_analyzer_colimator_3_blade_3_target_index
#define target_x mccinter_analyzer_colimator_3_blade_3_target_x
#define target_y mccinter_analyzer_colimator_3_blade_3_target_y
#define target_z mccinter_analyzer_colimator_3_blade_3_target_z
#define focus_aw mccinter_analyzer_colimator_3_blade_3_focus_aw
#define focus_ah mccinter_analyzer_colimator_3_blade_3_focus_ah
#define focus_xw mccinter_analyzer_colimator_3_blade_3_focus_xw
#define focus_xh mccinter_analyzer_colimator_3_blade_3_focus_xh
#define focus_r mccinter_analyzer_colimator_3_blade_3_focus_r
#define p_interact mccinter_analyzer_colimator_3_blade_3_p_interact
#define mask_string mccinter_analyzer_colimator_3_blade_3_mask_string
#define mask_setting mccinter_analyzer_colimator_3_blade_3_mask_setting
#define number_of_activations mccinter_analyzer_colimator_3_blade_3_number_of_activations
#line 224 "Union_box.comp"
{
// Initializes the focusing system for this volume including input sanitation.
focus_initialize(&this_box_volume.geometry, POS_A_COMP_INDEX(INDEX_CURRENT_COMP+target_index), POS_A_CURRENT_COMP, ROT_A_CURRENT_COMP, target_index, target_x, target_y, target_z, focus_aw, focus_ah, focus_xw, focus_xh, focus_r, NAME_CURRENT_COMP);

// Input sanitation for this geometry
if (xwidth <= 0) {
  printf("\nERROR in Union_box named %s, the xwidth is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (yheight <= 0) {
  printf("\nERROR in Union_box named %s, yheight is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (zdepth <= 0) {
  printf("\nERROR in Union_box named %s, zdepth is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (xwidth2 <= 0 && xwidth2 != -1) {
  printf("\nERROR in Union_box named %s, the xwidth2 is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (yheight2 <= 0 && yheight2 != -1) {
  printf("\nERROR in Union_box named %s, yheight2 is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}

// Use sanitation
if (global_material_list.num_elements == 0) {
  printf("\nERROR: Need to define a material using Union_make_material before using a Union geometry component. \n");
  printf("       %s was defined before first use of Union_make_material.\n",NAME_CURRENT_COMP);
  exit(1);
}

this_box_volume.geometry.is_masked_volume = 0;
this_box_volume.geometry.is_exit_volume = 0;
this_box_volume.geometry.is_mask_volume = 0;
// check if the volume is a mask, if it is the material string is irelevant.
if (mask_string && strlen(mask_string) && strcmp(mask_string, "NULL") && strcmp(mask_string, "0")) {
    // A mask volume is used to limit the extend of other volumes, called the masked volumes. These are specified in the mask_string.
    // In order for a ray to enter a masked volume, it needs to be both in the region covered by that volume AND the mask volume.
    // When more than
    this_box_volume.geometry.mask_mode = 1; // Default is mask mode is ALL
    if (mask_setting && strlen(mask_setting) && strcmp(mask_setting, "NULL") && strcmp(mask_setting, "0")) {
        if (strcmp(mask_setting,"ALL") == 0 || strcmp(mask_setting,"All") == 0) this_box_volume.geometry.mask_mode = 1;
        else if (strcmp(mask_setting,"ANY") == 0 || strcmp(mask_setting,"Any") == 0) this_box_volume.geometry.mask_mode = 2;
        else {
            printf("The mask_mode of component %s is set to %s, but must be either ALL or ANY.\n",NAME_CURRENT_COMP,mask_setting);
            exit(1);
        }
    }
    
    for (loop_index=0;loop_index<global_geometry_list.num_elements;loop_index++) {
        // Add mask list
        if (1 == manual_linking_function(global_geometry_list.elements[loop_index].name,mask_string)) {
            add_element_to_int_list(&this_box_volume.geometry.mask_list,global_geometry_list.elements[loop_index].component_index);
            add_element_to_int_list(&global_geometry_list.elements[loop_index].Volume->geometry.masked_by_list,INDEX_CURRENT_COMP);
            global_geometry_list.elements[loop_index].Volume->geometry.is_masked_volume = 1;
            if (this_box_volume.geometry.mask_mode == 2)
                global_geometry_list.elements[loop_index].Volume->geometry.mask_mode = 2;
            if (this_box_volume.geometry.mask_mode == 1) {
                if (global_geometry_list.elements[loop_index].Volume->geometry.is_masked_volume == 1 && global_geometry_list.elements[loop_index].Volume->geometry.mask_mode != 2)
                    // If more than one mask is added to one volume, the ANY mode overwrites the (default) ALL mode.
                    global_geometry_list.elements[loop_index].Volume->geometry.mask_mode = 1;
            }
            
            found_geometries = 1;
        }
    }
    if (found_geometries == 0) {
        printf("The mask_string in geometry: %s did not find any of the specified volumes in the mask_string %s \n",NAME_CURRENT_COMP,mask_string);
        exit(1);
    }
    this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
    this_box_volume.p_physics->is_vacuum = 0; // Makes this volume a vacuum
    this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
    this_box_volume.p_physics->my_a = 0; // Should not be used.
    sprintf(this_box_volume.p_physics->name,"Mask");
    this_box_volume.geometry.is_mask_volume = 1;
    
    
// Read the material input, or if it lacks, use automatic linking.
} else if (material_string && strlen(material_string) && strcmp(material_string, "NULL") && strcmp(material_string, "0")) {
    // A geometry string was given, use it to determine which material
    if (0 == strcmp(material_string,"vacuum") || 0 == strcmp(material_string,"Vacuum")) {
        // One could have a global physics struct for vacuum instead of creating one for each
        this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
        this_box_volume.p_physics->is_vacuum = 1; // Makes this volume a vacuum
        this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
        this_box_volume.p_physics->my_a = 0; // Should not be used.
        sprintf(this_box_volume.p_physics->name,"Vacuum");
    } else if (0 == strcmp(material_string,"exit") || 0 == strcmp(material_string,"Exit")) {
        // One could have a global physics struct for vacuum instead of creating one for each
        this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
        this_box_volume.p_physics->is_vacuum = 1; // Makes this volume a vacuum
        this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
        this_box_volume.p_physics->my_a = 0; // Should not be used.
        this_box_volume.geometry.is_exit_volume = 1;
        sprintf(this_box_volume.p_physics->name,"Exit");
    } else {
        #ifndef MATERIAL_DETECTOR
            printf("Need to define a material before refering to it in a geometry %s.\n",NAME_CURRENT_COMP);
            exit(1);
        #endif
        for (loop_index=0;loop_index<global_material_list.num_elements;loop_index++) {
            if (0 == strcmp(material_string,global_material_list.elements[loop_index].name)) {
                this_box_volume.p_physics = global_material_list.elements[loop_index].physics;
                break;
            }
            if (loop_index == global_material_list.num_elements-1) {
            printf("\n");
            printf("ERROR: The material string \"%s\" in Union geometry \"%s\" did not match a specified material. \n",material_string,NAME_CURRENT_COMP);
            printf("       The materials available at this point (need to be defined before the geometry): \n");
            for (loop_index=0;loop_index<global_material_list.num_elements;loop_index++)
              printf("         %s\n",global_material_list.elements[loop_index].name);
            printf("\n");
            printf("       It is also possible to use one of the defualt materials avaiable: \n");
            printf("           Vacuum (for a Volume without scattering or absorption)\n");
            printf("           Exit (for a Volume where the ray exits the component if it enters)\n");
            printf("           Mask (for a Volume that masks existing volumes specified in the mask_string\n");
            exit(1);
          }
        }
    }
} else {
    // Automatic linking, simply using the last defined material.
    #ifndef MATERIAL_DETECTOR
        printf("Need to define a material before the geometry to use automatic linking %s.\n",NAME_CURRENT_COMP);
        exit(1);
    #endif
    this_box_volume.p_physics = global_material_list.elements[global_material_list.num_elements-1].physics;
}

sprintf(this_box_volume.name,NAME_CURRENT_COMP);
sprintf(this_box_volume.geometry.shape,"box");
this_box_volume.geometry.priority_value = priority;
this_box_volume.geometry.geometry_p_interact = p_interact;
// Currently the coordinates will be in absolute space.
this_box_volume.geometry.center = POS_A_CURRENT_COMP;

this_box_storage.z_depth = zdepth;
this_box_storage.x_width1 = xwidth;
this_box_storage.y_height1 = yheight;

this_box_storage.is_rectangle = 0;
if (xwidth2 < 0 && yheight2 < 0) this_box_storage.is_rectangle = 1;
if (xwidth == xwidth2 && yheight == yheight2) this_box_storage.is_rectangle = 1;

if (xwidth2 < 0) {
    this_box_storage.x_width2 = xwidth;
    xwidth2 = xwidth;
} else this_box_storage.x_width2 = xwidth2;

if (yheight2 < 0) {
    this_box_storage.y_height2 = yheight;
    yheight2 = yheight;
} else this_box_storage.y_height2 = yheight2;


this_box_storage.normal_vectors[0] = coords_set(0,0,1);
this_box_storage.normal_vectors[1] = coords_set(0,0,1);

// for sides with y component = 0
x_component = 2*zdepth/sqrt((xwidth-xwidth2)*(xwidth-xwidth2)+4*zdepth*zdepth);
z_component = (xwidth-xwidth2)/sqrt(4*zdepth*zdepth+(xwidth-xwidth2)*(xwidth-xwidth2));

this_box_storage.normal_vectors[2] = coords_set(x_component,0,z_component);
this_box_storage.normal_vectors[3] = coords_set(-x_component,0,z_component);

// for sides with x component = 0
y_component = 2*zdepth/sqrt((yheight-yheight2)*(yheight-yheight2)+4*zdepth*zdepth);
z_component = (yheight-yheight2)/sqrt(4*zdepth*zdepth+(yheight-yheight2)*(yheight-yheight2));

this_box_storage.normal_vectors[4] = coords_set(0,y_component,z_component);
this_box_storage.normal_vectors[5] = coords_set(0,-y_component,z_component);

this_box_volume.geometry.visualization_on = visualize;

this_box_volume.geometry.geometry_parameters.p_box_storage = &this_box_storage;

// Assign pointers to functions for intersection with the shape, checking if a point is inside the shape
if (this_box_storage.is_rectangle == 1) {
this_box_volume.geometry.intersect_function = &sample_box_intersect_simple;
this_box_volume.geometry.within_function = &r_within_box_simple;
}
else {
this_box_volume.geometry.intersect_function = &sample_box_intersect_advanced;
this_box_volume.geometry.within_function = &r_within_box_advanced;
}

this_box_volume.geometry.shell_points = &box_shell_points;
this_box_volume.geometry.mcdisplay_function = &mcdisplay_box_function;
this_box_volume.geometry.initialize_from_main_function = &initialize_box_geometry_from_main_component;
this_box_volume.geometry.process_rot_allocated = 0;

this_box_volume.geometry.copy_geometry_parameters = &allocate_box_storage_copy;

rot_copy(this_box_volume.geometry.rotation_matrix,ROT_A_CURRENT_COMP); //check how ROT_R_CURRENT_COMP would work
rot_transpose(ROT_A_CURRENT_COMP,this_box_volume.geometry.transpose_rotation_matrix);

// Initialize loggers
this_box_volume.loggers.num_elements = 0;

// packing the information into the global_geometry_element, which is then included in the global_geometry_list.
sprintf(global_geometry_element.name,NAME_CURRENT_COMP);
global_geometry_element.activation_counter = number_of_activations;
global_geometry_element.component_index = INDEX_CURRENT_COMP;
global_geometry_element.Volume = &this_box_volume; // Would be nicer if this m was a pointer, now we have the (small) data two places
add_element_to_geometry_list(&global_geometry_list,global_geometry_element);
}
#line 198908 "MACS_sample_kidney_box.c"
#undef number_of_activations
#undef mask_setting
#undef mask_string
#undef p_interact
#undef focus_r
#undef focus_xh
#undef focus_xw
#undef focus_ah
#undef focus_aw
#undef target_z
#undef target_y
#undef target_x
#undef target_index
#undef visualize
#undef yheight2
#undef xwidth2
#undef zdepth
#undef yheight
#undef xwidth
#undef priority
#undef material_string
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

  /* Initializations for component inter_analyzer_colimator_3_blade_4. */
  SIG_MESSAGE("inter_analyzer_colimator_3_blade_4 (Init)");
#define mccompcurname  inter_analyzer_colimator_3_blade_4
#define mccompcurtype  Union_box
#define mccompcurindex 273
#define loop_index mccinter_analyzer_colimator_3_blade_4_loop_index
#define this_box_volume mccinter_analyzer_colimator_3_blade_4_this_box_volume
#define global_geometry_element mccinter_analyzer_colimator_3_blade_4_global_geometry_element
#define this_box_storage mccinter_analyzer_colimator_3_blade_4_this_box_storage
#define material_string mccinter_analyzer_colimator_3_blade_4_material_string
#define priority mccinter_analyzer_colimator_3_blade_4_priority
#define xwidth mccinter_analyzer_colimator_3_blade_4_xwidth
#define yheight mccinter_analyzer_colimator_3_blade_4_yheight
#define zdepth mccinter_analyzer_colimator_3_blade_4_zdepth
#define xwidth2 mccinter_analyzer_colimator_3_blade_4_xwidth2
#define yheight2 mccinter_analyzer_colimator_3_blade_4_yheight2
#define visualize mccinter_analyzer_colimator_3_blade_4_visualize
#define target_index mccinter_analyzer_colimator_3_blade_4_target_index
#define target_x mccinter_analyzer_colimator_3_blade_4_target_x
#define target_y mccinter_analyzer_colimator_3_blade_4_target_y
#define target_z mccinter_analyzer_colimator_3_blade_4_target_z
#define focus_aw mccinter_analyzer_colimator_3_blade_4_focus_aw
#define focus_ah mccinter_analyzer_colimator_3_blade_4_focus_ah
#define focus_xw mccinter_analyzer_colimator_3_blade_4_focus_xw
#define focus_xh mccinter_analyzer_colimator_3_blade_4_focus_xh
#define focus_r mccinter_analyzer_colimator_3_blade_4_focus_r
#define p_interact mccinter_analyzer_colimator_3_blade_4_p_interact
#define mask_string mccinter_analyzer_colimator_3_blade_4_mask_string
#define mask_setting mccinter_analyzer_colimator_3_blade_4_mask_setting
#define number_of_activations mccinter_analyzer_colimator_3_blade_4_number_of_activations
#line 224 "Union_box.comp"
{
// Initializes the focusing system for this volume including input sanitation.
focus_initialize(&this_box_volume.geometry, POS_A_COMP_INDEX(INDEX_CURRENT_COMP+target_index), POS_A_CURRENT_COMP, ROT_A_CURRENT_COMP, target_index, target_x, target_y, target_z, focus_aw, focus_ah, focus_xw, focus_xh, focus_r, NAME_CURRENT_COMP);

// Input sanitation for this geometry
if (xwidth <= 0) {
  printf("\nERROR in Union_box named %s, the xwidth is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (yheight <= 0) {
  printf("\nERROR in Union_box named %s, yheight is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (zdepth <= 0) {
  printf("\nERROR in Union_box named %s, zdepth is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (xwidth2 <= 0 && xwidth2 != -1) {
  printf("\nERROR in Union_box named %s, the xwidth2 is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (yheight2 <= 0 && yheight2 != -1) {
  printf("\nERROR in Union_box named %s, yheight2 is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}

// Use sanitation
if (global_material_list.num_elements == 0) {
  printf("\nERROR: Need to define a material using Union_make_material before using a Union geometry component. \n");
  printf("       %s was defined before first use of Union_make_material.\n",NAME_CURRENT_COMP);
  exit(1);
}

this_box_volume.geometry.is_masked_volume = 0;
this_box_volume.geometry.is_exit_volume = 0;
this_box_volume.geometry.is_mask_volume = 0;
// check if the volume is a mask, if it is the material string is irelevant.
if (mask_string && strlen(mask_string) && strcmp(mask_string, "NULL") && strcmp(mask_string, "0")) {
    // A mask volume is used to limit the extend of other volumes, called the masked volumes. These are specified in the mask_string.
    // In order for a ray to enter a masked volume, it needs to be both in the region covered by that volume AND the mask volume.
    // When more than
    this_box_volume.geometry.mask_mode = 1; // Default is mask mode is ALL
    if (mask_setting && strlen(mask_setting) && strcmp(mask_setting, "NULL") && strcmp(mask_setting, "0")) {
        if (strcmp(mask_setting,"ALL") == 0 || strcmp(mask_setting,"All") == 0) this_box_volume.geometry.mask_mode = 1;
        else if (strcmp(mask_setting,"ANY") == 0 || strcmp(mask_setting,"Any") == 0) this_box_volume.geometry.mask_mode = 2;
        else {
            printf("The mask_mode of component %s is set to %s, but must be either ALL or ANY.\n",NAME_CURRENT_COMP,mask_setting);
            exit(1);
        }
    }
    
    for (loop_index=0;loop_index<global_geometry_list.num_elements;loop_index++) {
        // Add mask list
        if (1 == manual_linking_function(global_geometry_list.elements[loop_index].name,mask_string)) {
            add_element_to_int_list(&this_box_volume.geometry.mask_list,global_geometry_list.elements[loop_index].component_index);
            add_element_to_int_list(&global_geometry_list.elements[loop_index].Volume->geometry.masked_by_list,INDEX_CURRENT_COMP);
            global_geometry_list.elements[loop_index].Volume->geometry.is_masked_volume = 1;
            if (this_box_volume.geometry.mask_mode == 2)
                global_geometry_list.elements[loop_index].Volume->geometry.mask_mode = 2;
            if (this_box_volume.geometry.mask_mode == 1) {
                if (global_geometry_list.elements[loop_index].Volume->geometry.is_masked_volume == 1 && global_geometry_list.elements[loop_index].Volume->geometry.mask_mode != 2)
                    // If more than one mask is added to one volume, the ANY mode overwrites the (default) ALL mode.
                    global_geometry_list.elements[loop_index].Volume->geometry.mask_mode = 1;
            }
            
            found_geometries = 1;
        }
    }
    if (found_geometries == 0) {
        printf("The mask_string in geometry: %s did not find any of the specified volumes in the mask_string %s \n",NAME_CURRENT_COMP,mask_string);
        exit(1);
    }
    this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
    this_box_volume.p_physics->is_vacuum = 0; // Makes this volume a vacuum
    this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
    this_box_volume.p_physics->my_a = 0; // Should not be used.
    sprintf(this_box_volume.p_physics->name,"Mask");
    this_box_volume.geometry.is_mask_volume = 1;
    
    
// Read the material input, or if it lacks, use automatic linking.
} else if (material_string && strlen(material_string) && strcmp(material_string, "NULL") && strcmp(material_string, "0")) {
    // A geometry string was given, use it to determine which material
    if (0 == strcmp(material_string,"vacuum") || 0 == strcmp(material_string,"Vacuum")) {
        // One could have a global physics struct for vacuum instead of creating one for each
        this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
        this_box_volume.p_physics->is_vacuum = 1; // Makes this volume a vacuum
        this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
        this_box_volume.p_physics->my_a = 0; // Should not be used.
        sprintf(this_box_volume.p_physics->name,"Vacuum");
    } else if (0 == strcmp(material_string,"exit") || 0 == strcmp(material_string,"Exit")) {
        // One could have a global physics struct for vacuum instead of creating one for each
        this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
        this_box_volume.p_physics->is_vacuum = 1; // Makes this volume a vacuum
        this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
        this_box_volume.p_physics->my_a = 0; // Should not be used.
        this_box_volume.geometry.is_exit_volume = 1;
        sprintf(this_box_volume.p_physics->name,"Exit");
    } else {
        #ifndef MATERIAL_DETECTOR
            printf("Need to define a material before refering to it in a geometry %s.\n",NAME_CURRENT_COMP);
            exit(1);
        #endif
        for (loop_index=0;loop_index<global_material_list.num_elements;loop_index++) {
            if (0 == strcmp(material_string,global_material_list.elements[loop_index].name)) {
                this_box_volume.p_physics = global_material_list.elements[loop_index].physics;
                break;
            }
            if (loop_index == global_material_list.num_elements-1) {
            printf("\n");
            printf("ERROR: The material string \"%s\" in Union geometry \"%s\" did not match a specified material. \n",material_string,NAME_CURRENT_COMP);
            printf("       The materials available at this point (need to be defined before the geometry): \n");
            for (loop_index=0;loop_index<global_material_list.num_elements;loop_index++)
              printf("         %s\n",global_material_list.elements[loop_index].name);
            printf("\n");
            printf("       It is also possible to use one of the defualt materials avaiable: \n");
            printf("           Vacuum (for a Volume without scattering or absorption)\n");
            printf("           Exit (for a Volume where the ray exits the component if it enters)\n");
            printf("           Mask (for a Volume that masks existing volumes specified in the mask_string\n");
            exit(1);
          }
        }
    }
} else {
    // Automatic linking, simply using the last defined material.
    #ifndef MATERIAL_DETECTOR
        printf("Need to define a material before the geometry to use automatic linking %s.\n",NAME_CURRENT_COMP);
        exit(1);
    #endif
    this_box_volume.p_physics = global_material_list.elements[global_material_list.num_elements-1].physics;
}

sprintf(this_box_volume.name,NAME_CURRENT_COMP);
sprintf(this_box_volume.geometry.shape,"box");
this_box_volume.geometry.priority_value = priority;
this_box_volume.geometry.geometry_p_interact = p_interact;
// Currently the coordinates will be in absolute space.
this_box_volume.geometry.center = POS_A_CURRENT_COMP;

this_box_storage.z_depth = zdepth;
this_box_storage.x_width1 = xwidth;
this_box_storage.y_height1 = yheight;

this_box_storage.is_rectangle = 0;
if (xwidth2 < 0 && yheight2 < 0) this_box_storage.is_rectangle = 1;
if (xwidth == xwidth2 && yheight == yheight2) this_box_storage.is_rectangle = 1;

if (xwidth2 < 0) {
    this_box_storage.x_width2 = xwidth;
    xwidth2 = xwidth;
} else this_box_storage.x_width2 = xwidth2;

if (yheight2 < 0) {
    this_box_storage.y_height2 = yheight;
    yheight2 = yheight;
} else this_box_storage.y_height2 = yheight2;


this_box_storage.normal_vectors[0] = coords_set(0,0,1);
this_box_storage.normal_vectors[1] = coords_set(0,0,1);

// for sides with y component = 0
x_component = 2*zdepth/sqrt((xwidth-xwidth2)*(xwidth-xwidth2)+4*zdepth*zdepth);
z_component = (xwidth-xwidth2)/sqrt(4*zdepth*zdepth+(xwidth-xwidth2)*(xwidth-xwidth2));

this_box_storage.normal_vectors[2] = coords_set(x_component,0,z_component);
this_box_storage.normal_vectors[3] = coords_set(-x_component,0,z_component);

// for sides with x component = 0
y_component = 2*zdepth/sqrt((yheight-yheight2)*(yheight-yheight2)+4*zdepth*zdepth);
z_component = (yheight-yheight2)/sqrt(4*zdepth*zdepth+(yheight-yheight2)*(yheight-yheight2));

this_box_storage.normal_vectors[4] = coords_set(0,y_component,z_component);
this_box_storage.normal_vectors[5] = coords_set(0,-y_component,z_component);

this_box_volume.geometry.visualization_on = visualize;

this_box_volume.geometry.geometry_parameters.p_box_storage = &this_box_storage;

// Assign pointers to functions for intersection with the shape, checking if a point is inside the shape
if (this_box_storage.is_rectangle == 1) {
this_box_volume.geometry.intersect_function = &sample_box_intersect_simple;
this_box_volume.geometry.within_function = &r_within_box_simple;
}
else {
this_box_volume.geometry.intersect_function = &sample_box_intersect_advanced;
this_box_volume.geometry.within_function = &r_within_box_advanced;
}

this_box_volume.geometry.shell_points = &box_shell_points;
this_box_volume.geometry.mcdisplay_function = &mcdisplay_box_function;
this_box_volume.geometry.initialize_from_main_function = &initialize_box_geometry_from_main_component;
this_box_volume.geometry.process_rot_allocated = 0;

this_box_volume.geometry.copy_geometry_parameters = &allocate_box_storage_copy;

rot_copy(this_box_volume.geometry.rotation_matrix,ROT_A_CURRENT_COMP); //check how ROT_R_CURRENT_COMP would work
rot_transpose(ROT_A_CURRENT_COMP,this_box_volume.geometry.transpose_rotation_matrix);

// Initialize loggers
this_box_volume.loggers.num_elements = 0;

// packing the information into the global_geometry_element, which is then included in the global_geometry_list.
sprintf(global_geometry_element.name,NAME_CURRENT_COMP);
global_geometry_element.activation_counter = number_of_activations;
global_geometry_element.component_index = INDEX_CURRENT_COMP;
global_geometry_element.Volume = &this_box_volume; // Would be nicer if this m was a pointer, now we have the (small) data two places
add_element_to_geometry_list(&global_geometry_list,global_geometry_element);
}
#line 199178 "MACS_sample_kidney_box.c"
#undef number_of_activations
#undef mask_setting
#undef mask_string
#undef p_interact
#undef focus_r
#undef focus_xh
#undef focus_xw
#undef focus_ah
#undef focus_aw
#undef target_z
#undef target_y
#undef target_x
#undef target_index
#undef visualize
#undef yheight2
#undef xwidth2
#undef zdepth
#undef yheight
#undef xwidth
#undef priority
#undef material_string
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

  /* Initializations for component diffraction_detector_3_exit_volume. */
  SIG_MESSAGE("diffraction_detector_3_exit_volume (Init)");
#define mccompcurname  diffraction_detector_3_exit_volume
#define mccompcurtype  Union_box
#define mccompcurindex 274
#define loop_index mccdiffraction_detector_3_exit_volume_loop_index
#define this_box_volume mccdiffraction_detector_3_exit_volume_this_box_volume
#define global_geometry_element mccdiffraction_detector_3_exit_volume_global_geometry_element
#define this_box_storage mccdiffraction_detector_3_exit_volume_this_box_storage
#define material_string mccdiffraction_detector_3_exit_volume_material_string
#define priority mccdiffraction_detector_3_exit_volume_priority
#define xwidth mccdiffraction_detector_3_exit_volume_xwidth
#define yheight mccdiffraction_detector_3_exit_volume_yheight
#define zdepth mccdiffraction_detector_3_exit_volume_zdepth
#define xwidth2 mccdiffraction_detector_3_exit_volume_xwidth2
#define yheight2 mccdiffraction_detector_3_exit_volume_yheight2
#define visualize mccdiffraction_detector_3_exit_volume_visualize
#define target_index mccdiffraction_detector_3_exit_volume_target_index
#define target_x mccdiffraction_detector_3_exit_volume_target_x
#define target_y mccdiffraction_detector_3_exit_volume_target_y
#define target_z mccdiffraction_detector_3_exit_volume_target_z
#define focus_aw mccdiffraction_detector_3_exit_volume_focus_aw
#define focus_ah mccdiffraction_detector_3_exit_volume_focus_ah
#define focus_xw mccdiffraction_detector_3_exit_volume_focus_xw
#define focus_xh mccdiffraction_detector_3_exit_volume_focus_xh
#define focus_r mccdiffraction_detector_3_exit_volume_focus_r
#define p_interact mccdiffraction_detector_3_exit_volume_p_interact
#define mask_string mccdiffraction_detector_3_exit_volume_mask_string
#define mask_setting mccdiffraction_detector_3_exit_volume_mask_setting
#define number_of_activations mccdiffraction_detector_3_exit_volume_number_of_activations
#line 224 "Union_box.comp"
{
// Initializes the focusing system for this volume including input sanitation.
focus_initialize(&this_box_volume.geometry, POS_A_COMP_INDEX(INDEX_CURRENT_COMP+target_index), POS_A_CURRENT_COMP, ROT_A_CURRENT_COMP, target_index, target_x, target_y, target_z, focus_aw, focus_ah, focus_xw, focus_xh, focus_r, NAME_CURRENT_COMP);

// Input sanitation for this geometry
if (xwidth <= 0) {
  printf("\nERROR in Union_box named %s, the xwidth is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (yheight <= 0) {
  printf("\nERROR in Union_box named %s, yheight is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (zdepth <= 0) {
  printf("\nERROR in Union_box named %s, zdepth is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (xwidth2 <= 0 && xwidth2 != -1) {
  printf("\nERROR in Union_box named %s, the xwidth2 is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (yheight2 <= 0 && yheight2 != -1) {
  printf("\nERROR in Union_box named %s, yheight2 is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}

// Use sanitation
if (global_material_list.num_elements == 0) {
  printf("\nERROR: Need to define a material using Union_make_material before using a Union geometry component. \n");
  printf("       %s was defined before first use of Union_make_material.\n",NAME_CURRENT_COMP);
  exit(1);
}

this_box_volume.geometry.is_masked_volume = 0;
this_box_volume.geometry.is_exit_volume = 0;
this_box_volume.geometry.is_mask_volume = 0;
// check if the volume is a mask, if it is the material string is irelevant.
if (mask_string && strlen(mask_string) && strcmp(mask_string, "NULL") && strcmp(mask_string, "0")) {
    // A mask volume is used to limit the extend of other volumes, called the masked volumes. These are specified in the mask_string.
    // In order for a ray to enter a masked volume, it needs to be both in the region covered by that volume AND the mask volume.
    // When more than
    this_box_volume.geometry.mask_mode = 1; // Default is mask mode is ALL
    if (mask_setting && strlen(mask_setting) && strcmp(mask_setting, "NULL") && strcmp(mask_setting, "0")) {
        if (strcmp(mask_setting,"ALL") == 0 || strcmp(mask_setting,"All") == 0) this_box_volume.geometry.mask_mode = 1;
        else if (strcmp(mask_setting,"ANY") == 0 || strcmp(mask_setting,"Any") == 0) this_box_volume.geometry.mask_mode = 2;
        else {
            printf("The mask_mode of component %s is set to %s, but must be either ALL or ANY.\n",NAME_CURRENT_COMP,mask_setting);
            exit(1);
        }
    }
    
    for (loop_index=0;loop_index<global_geometry_list.num_elements;loop_index++) {
        // Add mask list
        if (1 == manual_linking_function(global_geometry_list.elements[loop_index].name,mask_string)) {
            add_element_to_int_list(&this_box_volume.geometry.mask_list,global_geometry_list.elements[loop_index].component_index);
            add_element_to_int_list(&global_geometry_list.elements[loop_index].Volume->geometry.masked_by_list,INDEX_CURRENT_COMP);
            global_geometry_list.elements[loop_index].Volume->geometry.is_masked_volume = 1;
            if (this_box_volume.geometry.mask_mode == 2)
                global_geometry_list.elements[loop_index].Volume->geometry.mask_mode = 2;
            if (this_box_volume.geometry.mask_mode == 1) {
                if (global_geometry_list.elements[loop_index].Volume->geometry.is_masked_volume == 1 && global_geometry_list.elements[loop_index].Volume->geometry.mask_mode != 2)
                    // If more than one mask is added to one volume, the ANY mode overwrites the (default) ALL mode.
                    global_geometry_list.elements[loop_index].Volume->geometry.mask_mode = 1;
            }
            
            found_geometries = 1;
        }
    }
    if (found_geometries == 0) {
        printf("The mask_string in geometry: %s did not find any of the specified volumes in the mask_string %s \n",NAME_CURRENT_COMP,mask_string);
        exit(1);
    }
    this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
    this_box_volume.p_physics->is_vacuum = 0; // Makes this volume a vacuum
    this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
    this_box_volume.p_physics->my_a = 0; // Should not be used.
    sprintf(this_box_volume.p_physics->name,"Mask");
    this_box_volume.geometry.is_mask_volume = 1;
    
    
// Read the material input, or if it lacks, use automatic linking.
} else if (material_string && strlen(material_string) && strcmp(material_string, "NULL") && strcmp(material_string, "0")) {
    // A geometry string was given, use it to determine which material
    if (0 == strcmp(material_string,"vacuum") || 0 == strcmp(material_string,"Vacuum")) {
        // One could have a global physics struct for vacuum instead of creating one for each
        this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
        this_box_volume.p_physics->is_vacuum = 1; // Makes this volume a vacuum
        this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
        this_box_volume.p_physics->my_a = 0; // Should not be used.
        sprintf(this_box_volume.p_physics->name,"Vacuum");
    } else if (0 == strcmp(material_string,"exit") || 0 == strcmp(material_string,"Exit")) {
        // One could have a global physics struct for vacuum instead of creating one for each
        this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
        this_box_volume.p_physics->is_vacuum = 1; // Makes this volume a vacuum
        this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
        this_box_volume.p_physics->my_a = 0; // Should not be used.
        this_box_volume.geometry.is_exit_volume = 1;
        sprintf(this_box_volume.p_physics->name,"Exit");
    } else {
        #ifndef MATERIAL_DETECTOR
            printf("Need to define a material before refering to it in a geometry %s.\n",NAME_CURRENT_COMP);
            exit(1);
        #endif
        for (loop_index=0;loop_index<global_material_list.num_elements;loop_index++) {
            if (0 == strcmp(material_string,global_material_list.elements[loop_index].name)) {
                this_box_volume.p_physics = global_material_list.elements[loop_index].physics;
                break;
            }
            if (loop_index == global_material_list.num_elements-1) {
            printf("\n");
            printf("ERROR: The material string \"%s\" in Union geometry \"%s\" did not match a specified material. \n",material_string,NAME_CURRENT_COMP);
            printf("       The materials available at this point (need to be defined before the geometry): \n");
            for (loop_index=0;loop_index<global_material_list.num_elements;loop_index++)
              printf("         %s\n",global_material_list.elements[loop_index].name);
            printf("\n");
            printf("       It is also possible to use one of the defualt materials avaiable: \n");
            printf("           Vacuum (for a Volume without scattering or absorption)\n");
            printf("           Exit (for a Volume where the ray exits the component if it enters)\n");
            printf("           Mask (for a Volume that masks existing volumes specified in the mask_string\n");
            exit(1);
          }
        }
    }
} else {
    // Automatic linking, simply using the last defined material.
    #ifndef MATERIAL_DETECTOR
        printf("Need to define a material before the geometry to use automatic linking %s.\n",NAME_CURRENT_COMP);
        exit(1);
    #endif
    this_box_volume.p_physics = global_material_list.elements[global_material_list.num_elements-1].physics;
}

sprintf(this_box_volume.name,NAME_CURRENT_COMP);
sprintf(this_box_volume.geometry.shape,"box");
this_box_volume.geometry.priority_value = priority;
this_box_volume.geometry.geometry_p_interact = p_interact;
// Currently the coordinates will be in absolute space.
this_box_volume.geometry.center = POS_A_CURRENT_COMP;

this_box_storage.z_depth = zdepth;
this_box_storage.x_width1 = xwidth;
this_box_storage.y_height1 = yheight;

this_box_storage.is_rectangle = 0;
if (xwidth2 < 0 && yheight2 < 0) this_box_storage.is_rectangle = 1;
if (xwidth == xwidth2 && yheight == yheight2) this_box_storage.is_rectangle = 1;

if (xwidth2 < 0) {
    this_box_storage.x_width2 = xwidth;
    xwidth2 = xwidth;
} else this_box_storage.x_width2 = xwidth2;

if (yheight2 < 0) {
    this_box_storage.y_height2 = yheight;
    yheight2 = yheight;
} else this_box_storage.y_height2 = yheight2;


this_box_storage.normal_vectors[0] = coords_set(0,0,1);
this_box_storage.normal_vectors[1] = coords_set(0,0,1);

// for sides with y component = 0
x_component = 2*zdepth/sqrt((xwidth-xwidth2)*(xwidth-xwidth2)+4*zdepth*zdepth);
z_component = (xwidth-xwidth2)/sqrt(4*zdepth*zdepth+(xwidth-xwidth2)*(xwidth-xwidth2));

this_box_storage.normal_vectors[2] = coords_set(x_component,0,z_component);
this_box_storage.normal_vectors[3] = coords_set(-x_component,0,z_component);

// for sides with x component = 0
y_component = 2*zdepth/sqrt((yheight-yheight2)*(yheight-yheight2)+4*zdepth*zdepth);
z_component = (yheight-yheight2)/sqrt(4*zdepth*zdepth+(yheight-yheight2)*(yheight-yheight2));

this_box_storage.normal_vectors[4] = coords_set(0,y_component,z_component);
this_box_storage.normal_vectors[5] = coords_set(0,-y_component,z_component);

this_box_volume.geometry.visualization_on = visualize;

this_box_volume.geometry.geometry_parameters.p_box_storage = &this_box_storage;

// Assign pointers to functions for intersection with the shape, checking if a point is inside the shape
if (this_box_storage.is_rectangle == 1) {
this_box_volume.geometry.intersect_function = &sample_box_intersect_simple;
this_box_volume.geometry.within_function = &r_within_box_simple;
}
else {
this_box_volume.geometry.intersect_function = &sample_box_intersect_advanced;
this_box_volume.geometry.within_function = &r_within_box_advanced;
}

this_box_volume.geometry.shell_points = &box_shell_points;
this_box_volume.geometry.mcdisplay_function = &mcdisplay_box_function;
this_box_volume.geometry.initialize_from_main_function = &initialize_box_geometry_from_main_component;
this_box_volume.geometry.process_rot_allocated = 0;

this_box_volume.geometry.copy_geometry_parameters = &allocate_box_storage_copy;

rot_copy(this_box_volume.geometry.rotation_matrix,ROT_A_CURRENT_COMP); //check how ROT_R_CURRENT_COMP would work
rot_transpose(ROT_A_CURRENT_COMP,this_box_volume.geometry.transpose_rotation_matrix);

// Initialize loggers
this_box_volume.loggers.num_elements = 0;

// packing the information into the global_geometry_element, which is then included in the global_geometry_list.
sprintf(global_geometry_element.name,NAME_CURRENT_COMP);
global_geometry_element.activation_counter = number_of_activations;
global_geometry_element.component_index = INDEX_CURRENT_COMP;
global_geometry_element.Volume = &this_box_volume; // Would be nicer if this m was a pointer, now we have the (small) data two places
add_element_to_geometry_list(&global_geometry_list,global_geometry_element);
}
#line 199448 "MACS_sample_kidney_box.c"
#undef number_of_activations
#undef mask_setting
#undef mask_string
#undef p_interact
#undef focus_r
#undef focus_xh
#undef focus_xw
#undef focus_ah
#undef focus_aw
#undef target_z
#undef target_y
#undef target_x
#undef target_index
#undef visualize
#undef yheight2
#undef xwidth2
#undef zdepth
#undef yheight
#undef xwidth
#undef priority
#undef material_string
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

  /* Initializations for component spec_detector_3_exit_volume. */
  SIG_MESSAGE("spec_detector_3_exit_volume (Init)");
#define mccompcurname  spec_detector_3_exit_volume
#define mccompcurtype  Union_box
#define mccompcurindex 275
#define loop_index mccspec_detector_3_exit_volume_loop_index
#define this_box_volume mccspec_detector_3_exit_volume_this_box_volume
#define global_geometry_element mccspec_detector_3_exit_volume_global_geometry_element
#define this_box_storage mccspec_detector_3_exit_volume_this_box_storage
#define material_string mccspec_detector_3_exit_volume_material_string
#define priority mccspec_detector_3_exit_volume_priority
#define xwidth mccspec_detector_3_exit_volume_xwidth
#define yheight mccspec_detector_3_exit_volume_yheight
#define zdepth mccspec_detector_3_exit_volume_zdepth
#define xwidth2 mccspec_detector_3_exit_volume_xwidth2
#define yheight2 mccspec_detector_3_exit_volume_yheight2
#define visualize mccspec_detector_3_exit_volume_visualize
#define target_index mccspec_detector_3_exit_volume_target_index
#define target_x mccspec_detector_3_exit_volume_target_x
#define target_y mccspec_detector_3_exit_volume_target_y
#define target_z mccspec_detector_3_exit_volume_target_z
#define focus_aw mccspec_detector_3_exit_volume_focus_aw
#define focus_ah mccspec_detector_3_exit_volume_focus_ah
#define focus_xw mccspec_detector_3_exit_volume_focus_xw
#define focus_xh mccspec_detector_3_exit_volume_focus_xh
#define focus_r mccspec_detector_3_exit_volume_focus_r
#define p_interact mccspec_detector_3_exit_volume_p_interact
#define mask_string mccspec_detector_3_exit_volume_mask_string
#define mask_setting mccspec_detector_3_exit_volume_mask_setting
#define number_of_activations mccspec_detector_3_exit_volume_number_of_activations
#line 224 "Union_box.comp"
{
// Initializes the focusing system for this volume including input sanitation.
focus_initialize(&this_box_volume.geometry, POS_A_COMP_INDEX(INDEX_CURRENT_COMP+target_index), POS_A_CURRENT_COMP, ROT_A_CURRENT_COMP, target_index, target_x, target_y, target_z, focus_aw, focus_ah, focus_xw, focus_xh, focus_r, NAME_CURRENT_COMP);

// Input sanitation for this geometry
if (xwidth <= 0) {
  printf("\nERROR in Union_box named %s, the xwidth is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (yheight <= 0) {
  printf("\nERROR in Union_box named %s, yheight is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (zdepth <= 0) {
  printf("\nERROR in Union_box named %s, zdepth is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (xwidth2 <= 0 && xwidth2 != -1) {
  printf("\nERROR in Union_box named %s, the xwidth2 is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (yheight2 <= 0 && yheight2 != -1) {
  printf("\nERROR in Union_box named %s, yheight2 is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}

// Use sanitation
if (global_material_list.num_elements == 0) {
  printf("\nERROR: Need to define a material using Union_make_material before using a Union geometry component. \n");
  printf("       %s was defined before first use of Union_make_material.\n",NAME_CURRENT_COMP);
  exit(1);
}

this_box_volume.geometry.is_masked_volume = 0;
this_box_volume.geometry.is_exit_volume = 0;
this_box_volume.geometry.is_mask_volume = 0;
// check if the volume is a mask, if it is the material string is irelevant.
if (mask_string && strlen(mask_string) && strcmp(mask_string, "NULL") && strcmp(mask_string, "0")) {
    // A mask volume is used to limit the extend of other volumes, called the masked volumes. These are specified in the mask_string.
    // In order for a ray to enter a masked volume, it needs to be both in the region covered by that volume AND the mask volume.
    // When more than
    this_box_volume.geometry.mask_mode = 1; // Default is mask mode is ALL
    if (mask_setting && strlen(mask_setting) && strcmp(mask_setting, "NULL") && strcmp(mask_setting, "0")) {
        if (strcmp(mask_setting,"ALL") == 0 || strcmp(mask_setting,"All") == 0) this_box_volume.geometry.mask_mode = 1;
        else if (strcmp(mask_setting,"ANY") == 0 || strcmp(mask_setting,"Any") == 0) this_box_volume.geometry.mask_mode = 2;
        else {
            printf("The mask_mode of component %s is set to %s, but must be either ALL or ANY.\n",NAME_CURRENT_COMP,mask_setting);
            exit(1);
        }
    }
    
    for (loop_index=0;loop_index<global_geometry_list.num_elements;loop_index++) {
        // Add mask list
        if (1 == manual_linking_function(global_geometry_list.elements[loop_index].name,mask_string)) {
            add_element_to_int_list(&this_box_volume.geometry.mask_list,global_geometry_list.elements[loop_index].component_index);
            add_element_to_int_list(&global_geometry_list.elements[loop_index].Volume->geometry.masked_by_list,INDEX_CURRENT_COMP);
            global_geometry_list.elements[loop_index].Volume->geometry.is_masked_volume = 1;
            if (this_box_volume.geometry.mask_mode == 2)
                global_geometry_list.elements[loop_index].Volume->geometry.mask_mode = 2;
            if (this_box_volume.geometry.mask_mode == 1) {
                if (global_geometry_list.elements[loop_index].Volume->geometry.is_masked_volume == 1 && global_geometry_list.elements[loop_index].Volume->geometry.mask_mode != 2)
                    // If more than one mask is added to one volume, the ANY mode overwrites the (default) ALL mode.
                    global_geometry_list.elements[loop_index].Volume->geometry.mask_mode = 1;
            }
            
            found_geometries = 1;
        }
    }
    if (found_geometries == 0) {
        printf("The mask_string in geometry: %s did not find any of the specified volumes in the mask_string %s \n",NAME_CURRENT_COMP,mask_string);
        exit(1);
    }
    this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
    this_box_volume.p_physics->is_vacuum = 0; // Makes this volume a vacuum
    this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
    this_box_volume.p_physics->my_a = 0; // Should not be used.
    sprintf(this_box_volume.p_physics->name,"Mask");
    this_box_volume.geometry.is_mask_volume = 1;
    
    
// Read the material input, or if it lacks, use automatic linking.
} else if (material_string && strlen(material_string) && strcmp(material_string, "NULL") && strcmp(material_string, "0")) {
    // A geometry string was given, use it to determine which material
    if (0 == strcmp(material_string,"vacuum") || 0 == strcmp(material_string,"Vacuum")) {
        // One could have a global physics struct for vacuum instead of creating one for each
        this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
        this_box_volume.p_physics->is_vacuum = 1; // Makes this volume a vacuum
        this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
        this_box_volume.p_physics->my_a = 0; // Should not be used.
        sprintf(this_box_volume.p_physics->name,"Vacuum");
    } else if (0 == strcmp(material_string,"exit") || 0 == strcmp(material_string,"Exit")) {
        // One could have a global physics struct for vacuum instead of creating one for each
        this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
        this_box_volume.p_physics->is_vacuum = 1; // Makes this volume a vacuum
        this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
        this_box_volume.p_physics->my_a = 0; // Should not be used.
        this_box_volume.geometry.is_exit_volume = 1;
        sprintf(this_box_volume.p_physics->name,"Exit");
    } else {
        #ifndef MATERIAL_DETECTOR
            printf("Need to define a material before refering to it in a geometry %s.\n",NAME_CURRENT_COMP);
            exit(1);
        #endif
        for (loop_index=0;loop_index<global_material_list.num_elements;loop_index++) {
            if (0 == strcmp(material_string,global_material_list.elements[loop_index].name)) {
                this_box_volume.p_physics = global_material_list.elements[loop_index].physics;
                break;
            }
            if (loop_index == global_material_list.num_elements-1) {
            printf("\n");
            printf("ERROR: The material string \"%s\" in Union geometry \"%s\" did not match a specified material. \n",material_string,NAME_CURRENT_COMP);
            printf("       The materials available at this point (need to be defined before the geometry): \n");
            for (loop_index=0;loop_index<global_material_list.num_elements;loop_index++)
              printf("         %s\n",global_material_list.elements[loop_index].name);
            printf("\n");
            printf("       It is also possible to use one of the defualt materials avaiable: \n");
            printf("           Vacuum (for a Volume without scattering or absorption)\n");
            printf("           Exit (for a Volume where the ray exits the component if it enters)\n");
            printf("           Mask (for a Volume that masks existing volumes specified in the mask_string\n");
            exit(1);
          }
        }
    }
} else {
    // Automatic linking, simply using the last defined material.
    #ifndef MATERIAL_DETECTOR
        printf("Need to define a material before the geometry to use automatic linking %s.\n",NAME_CURRENT_COMP);
        exit(1);
    #endif
    this_box_volume.p_physics = global_material_list.elements[global_material_list.num_elements-1].physics;
}

sprintf(this_box_volume.name,NAME_CURRENT_COMP);
sprintf(this_box_volume.geometry.shape,"box");
this_box_volume.geometry.priority_value = priority;
this_box_volume.geometry.geometry_p_interact = p_interact;
// Currently the coordinates will be in absolute space.
this_box_volume.geometry.center = POS_A_CURRENT_COMP;

this_box_storage.z_depth = zdepth;
this_box_storage.x_width1 = xwidth;
this_box_storage.y_height1 = yheight;

this_box_storage.is_rectangle = 0;
if (xwidth2 < 0 && yheight2 < 0) this_box_storage.is_rectangle = 1;
if (xwidth == xwidth2 && yheight == yheight2) this_box_storage.is_rectangle = 1;

if (xwidth2 < 0) {
    this_box_storage.x_width2 = xwidth;
    xwidth2 = xwidth;
} else this_box_storage.x_width2 = xwidth2;

if (yheight2 < 0) {
    this_box_storage.y_height2 = yheight;
    yheight2 = yheight;
} else this_box_storage.y_height2 = yheight2;


this_box_storage.normal_vectors[0] = coords_set(0,0,1);
this_box_storage.normal_vectors[1] = coords_set(0,0,1);

// for sides with y component = 0
x_component = 2*zdepth/sqrt((xwidth-xwidth2)*(xwidth-xwidth2)+4*zdepth*zdepth);
z_component = (xwidth-xwidth2)/sqrt(4*zdepth*zdepth+(xwidth-xwidth2)*(xwidth-xwidth2));

this_box_storage.normal_vectors[2] = coords_set(x_component,0,z_component);
this_box_storage.normal_vectors[3] = coords_set(-x_component,0,z_component);

// for sides with x component = 0
y_component = 2*zdepth/sqrt((yheight-yheight2)*(yheight-yheight2)+4*zdepth*zdepth);
z_component = (yheight-yheight2)/sqrt(4*zdepth*zdepth+(yheight-yheight2)*(yheight-yheight2));

this_box_storage.normal_vectors[4] = coords_set(0,y_component,z_component);
this_box_storage.normal_vectors[5] = coords_set(0,-y_component,z_component);

this_box_volume.geometry.visualization_on = visualize;

this_box_volume.geometry.geometry_parameters.p_box_storage = &this_box_storage;

// Assign pointers to functions for intersection with the shape, checking if a point is inside the shape
if (this_box_storage.is_rectangle == 1) {
this_box_volume.geometry.intersect_function = &sample_box_intersect_simple;
this_box_volume.geometry.within_function = &r_within_box_simple;
}
else {
this_box_volume.geometry.intersect_function = &sample_box_intersect_advanced;
this_box_volume.geometry.within_function = &r_within_box_advanced;
}

this_box_volume.geometry.shell_points = &box_shell_points;
this_box_volume.geometry.mcdisplay_function = &mcdisplay_box_function;
this_box_volume.geometry.initialize_from_main_function = &initialize_box_geometry_from_main_component;
this_box_volume.geometry.process_rot_allocated = 0;

this_box_volume.geometry.copy_geometry_parameters = &allocate_box_storage_copy;

rot_copy(this_box_volume.geometry.rotation_matrix,ROT_A_CURRENT_COMP); //check how ROT_R_CURRENT_COMP would work
rot_transpose(ROT_A_CURRENT_COMP,this_box_volume.geometry.transpose_rotation_matrix);

// Initialize loggers
this_box_volume.loggers.num_elements = 0;

// packing the information into the global_geometry_element, which is then included in the global_geometry_list.
sprintf(global_geometry_element.name,NAME_CURRENT_COMP);
global_geometry_element.activation_counter = number_of_activations;
global_geometry_element.component_index = INDEX_CURRENT_COMP;
global_geometry_element.Volume = &this_box_volume; // Would be nicer if this m was a pointer, now we have the (small) data two places
add_element_to_geometry_list(&global_geometry_list,global_geometry_element);
}
#line 199718 "MACS_sample_kidney_box.c"
#undef number_of_activations
#undef mask_setting
#undef mask_string
#undef p_interact
#undef focus_r
#undef focus_xh
#undef focus_xw
#undef focus_ah
#undef focus_aw
#undef target_z
#undef target_y
#undef target_x
#undef target_index
#undef visualize
#undef yheight2
#undef xwidth2
#undef zdepth
#undef yheight
#undef xwidth
#undef priority
#undef material_string
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

  /* Initializations for component channel_4_cave1_box1. */
  SIG_MESSAGE("channel_4_cave1_box1 (Init)");
#define mccompcurname  channel_4_cave1_box1
#define mccompcurtype  Union_box
#define mccompcurindex 276
#define loop_index mccchannel_4_cave1_box1_loop_index
#define this_box_volume mccchannel_4_cave1_box1_this_box_volume
#define global_geometry_element mccchannel_4_cave1_box1_global_geometry_element
#define this_box_storage mccchannel_4_cave1_box1_this_box_storage
#define material_string mccchannel_4_cave1_box1_material_string
#define priority mccchannel_4_cave1_box1_priority
#define xwidth mccchannel_4_cave1_box1_xwidth
#define yheight mccchannel_4_cave1_box1_yheight
#define zdepth mccchannel_4_cave1_box1_zdepth
#define xwidth2 mccchannel_4_cave1_box1_xwidth2
#define yheight2 mccchannel_4_cave1_box1_yheight2
#define visualize mccchannel_4_cave1_box1_visualize
#define target_index mccchannel_4_cave1_box1_target_index
#define target_x mccchannel_4_cave1_box1_target_x
#define target_y mccchannel_4_cave1_box1_target_y
#define target_z mccchannel_4_cave1_box1_target_z
#define focus_aw mccchannel_4_cave1_box1_focus_aw
#define focus_ah mccchannel_4_cave1_box1_focus_ah
#define focus_xw mccchannel_4_cave1_box1_focus_xw
#define focus_xh mccchannel_4_cave1_box1_focus_xh
#define focus_r mccchannel_4_cave1_box1_focus_r
#define p_interact mccchannel_4_cave1_box1_p_interact
#define mask_string mccchannel_4_cave1_box1_mask_string
#define mask_setting mccchannel_4_cave1_box1_mask_setting
#define number_of_activations mccchannel_4_cave1_box1_number_of_activations
#line 224 "Union_box.comp"
{
// Initializes the focusing system for this volume including input sanitation.
focus_initialize(&this_box_volume.geometry, POS_A_COMP_INDEX(INDEX_CURRENT_COMP+target_index), POS_A_CURRENT_COMP, ROT_A_CURRENT_COMP, target_index, target_x, target_y, target_z, focus_aw, focus_ah, focus_xw, focus_xh, focus_r, NAME_CURRENT_COMP);

// Input sanitation for this geometry
if (xwidth <= 0) {
  printf("\nERROR in Union_box named %s, the xwidth is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (yheight <= 0) {
  printf("\nERROR in Union_box named %s, yheight is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (zdepth <= 0) {
  printf("\nERROR in Union_box named %s, zdepth is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (xwidth2 <= 0 && xwidth2 != -1) {
  printf("\nERROR in Union_box named %s, the xwidth2 is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (yheight2 <= 0 && yheight2 != -1) {
  printf("\nERROR in Union_box named %s, yheight2 is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}

// Use sanitation
if (global_material_list.num_elements == 0) {
  printf("\nERROR: Need to define a material using Union_make_material before using a Union geometry component. \n");
  printf("       %s was defined before first use of Union_make_material.\n",NAME_CURRENT_COMP);
  exit(1);
}

this_box_volume.geometry.is_masked_volume = 0;
this_box_volume.geometry.is_exit_volume = 0;
this_box_volume.geometry.is_mask_volume = 0;
// check if the volume is a mask, if it is the material string is irelevant.
if (mask_string && strlen(mask_string) && strcmp(mask_string, "NULL") && strcmp(mask_string, "0")) {
    // A mask volume is used to limit the extend of other volumes, called the masked volumes. These are specified in the mask_string.
    // In order for a ray to enter a masked volume, it needs to be both in the region covered by that volume AND the mask volume.
    // When more than
    this_box_volume.geometry.mask_mode = 1; // Default is mask mode is ALL
    if (mask_setting && strlen(mask_setting) && strcmp(mask_setting, "NULL") && strcmp(mask_setting, "0")) {
        if (strcmp(mask_setting,"ALL") == 0 || strcmp(mask_setting,"All") == 0) this_box_volume.geometry.mask_mode = 1;
        else if (strcmp(mask_setting,"ANY") == 0 || strcmp(mask_setting,"Any") == 0) this_box_volume.geometry.mask_mode = 2;
        else {
            printf("The mask_mode of component %s is set to %s, but must be either ALL or ANY.\n",NAME_CURRENT_COMP,mask_setting);
            exit(1);
        }
    }
    
    for (loop_index=0;loop_index<global_geometry_list.num_elements;loop_index++) {
        // Add mask list
        if (1 == manual_linking_function(global_geometry_list.elements[loop_index].name,mask_string)) {
            add_element_to_int_list(&this_box_volume.geometry.mask_list,global_geometry_list.elements[loop_index].component_index);
            add_element_to_int_list(&global_geometry_list.elements[loop_index].Volume->geometry.masked_by_list,INDEX_CURRENT_COMP);
            global_geometry_list.elements[loop_index].Volume->geometry.is_masked_volume = 1;
            if (this_box_volume.geometry.mask_mode == 2)
                global_geometry_list.elements[loop_index].Volume->geometry.mask_mode = 2;
            if (this_box_volume.geometry.mask_mode == 1) {
                if (global_geometry_list.elements[loop_index].Volume->geometry.is_masked_volume == 1 && global_geometry_list.elements[loop_index].Volume->geometry.mask_mode != 2)
                    // If more than one mask is added to one volume, the ANY mode overwrites the (default) ALL mode.
                    global_geometry_list.elements[loop_index].Volume->geometry.mask_mode = 1;
            }
            
            found_geometries = 1;
        }
    }
    if (found_geometries == 0) {
        printf("The mask_string in geometry: %s did not find any of the specified volumes in the mask_string %s \n",NAME_CURRENT_COMP,mask_string);
        exit(1);
    }
    this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
    this_box_volume.p_physics->is_vacuum = 0; // Makes this volume a vacuum
    this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
    this_box_volume.p_physics->my_a = 0; // Should not be used.
    sprintf(this_box_volume.p_physics->name,"Mask");
    this_box_volume.geometry.is_mask_volume = 1;
    
    
// Read the material input, or if it lacks, use automatic linking.
} else if (material_string && strlen(material_string) && strcmp(material_string, "NULL") && strcmp(material_string, "0")) {
    // A geometry string was given, use it to determine which material
    if (0 == strcmp(material_string,"vacuum") || 0 == strcmp(material_string,"Vacuum")) {
        // One could have a global physics struct for vacuum instead of creating one for each
        this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
        this_box_volume.p_physics->is_vacuum = 1; // Makes this volume a vacuum
        this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
        this_box_volume.p_physics->my_a = 0; // Should not be used.
        sprintf(this_box_volume.p_physics->name,"Vacuum");
    } else if (0 == strcmp(material_string,"exit") || 0 == strcmp(material_string,"Exit")) {
        // One could have a global physics struct for vacuum instead of creating one for each
        this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
        this_box_volume.p_physics->is_vacuum = 1; // Makes this volume a vacuum
        this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
        this_box_volume.p_physics->my_a = 0; // Should not be used.
        this_box_volume.geometry.is_exit_volume = 1;
        sprintf(this_box_volume.p_physics->name,"Exit");
    } else {
        #ifndef MATERIAL_DETECTOR
            printf("Need to define a material before refering to it in a geometry %s.\n",NAME_CURRENT_COMP);
            exit(1);
        #endif
        for (loop_index=0;loop_index<global_material_list.num_elements;loop_index++) {
            if (0 == strcmp(material_string,global_material_list.elements[loop_index].name)) {
                this_box_volume.p_physics = global_material_list.elements[loop_index].physics;
                break;
            }
            if (loop_index == global_material_list.num_elements-1) {
            printf("\n");
            printf("ERROR: The material string \"%s\" in Union geometry \"%s\" did not match a specified material. \n",material_string,NAME_CURRENT_COMP);
            printf("       The materials available at this point (need to be defined before the geometry): \n");
            for (loop_index=0;loop_index<global_material_list.num_elements;loop_index++)
              printf("         %s\n",global_material_list.elements[loop_index].name);
            printf("\n");
            printf("       It is also possible to use one of the defualt materials avaiable: \n");
            printf("           Vacuum (for a Volume without scattering or absorption)\n");
            printf("           Exit (for a Volume where the ray exits the component if it enters)\n");
            printf("           Mask (for a Volume that masks existing volumes specified in the mask_string\n");
            exit(1);
          }
        }
    }
} else {
    // Automatic linking, simply using the last defined material.
    #ifndef MATERIAL_DETECTOR
        printf("Need to define a material before the geometry to use automatic linking %s.\n",NAME_CURRENT_COMP);
        exit(1);
    #endif
    this_box_volume.p_physics = global_material_list.elements[global_material_list.num_elements-1].physics;
}

sprintf(this_box_volume.name,NAME_CURRENT_COMP);
sprintf(this_box_volume.geometry.shape,"box");
this_box_volume.geometry.priority_value = priority;
this_box_volume.geometry.geometry_p_interact = p_interact;
// Currently the coordinates will be in absolute space.
this_box_volume.geometry.center = POS_A_CURRENT_COMP;

this_box_storage.z_depth = zdepth;
this_box_storage.x_width1 = xwidth;
this_box_storage.y_height1 = yheight;

this_box_storage.is_rectangle = 0;
if (xwidth2 < 0 && yheight2 < 0) this_box_storage.is_rectangle = 1;
if (xwidth == xwidth2 && yheight == yheight2) this_box_storage.is_rectangle = 1;

if (xwidth2 < 0) {
    this_box_storage.x_width2 = xwidth;
    xwidth2 = xwidth;
} else this_box_storage.x_width2 = xwidth2;

if (yheight2 < 0) {
    this_box_storage.y_height2 = yheight;
    yheight2 = yheight;
} else this_box_storage.y_height2 = yheight2;


this_box_storage.normal_vectors[0] = coords_set(0,0,1);
this_box_storage.normal_vectors[1] = coords_set(0,0,1);

// for sides with y component = 0
x_component = 2*zdepth/sqrt((xwidth-xwidth2)*(xwidth-xwidth2)+4*zdepth*zdepth);
z_component = (xwidth-xwidth2)/sqrt(4*zdepth*zdepth+(xwidth-xwidth2)*(xwidth-xwidth2));

this_box_storage.normal_vectors[2] = coords_set(x_component,0,z_component);
this_box_storage.normal_vectors[3] = coords_set(-x_component,0,z_component);

// for sides with x component = 0
y_component = 2*zdepth/sqrt((yheight-yheight2)*(yheight-yheight2)+4*zdepth*zdepth);
z_component = (yheight-yheight2)/sqrt(4*zdepth*zdepth+(yheight-yheight2)*(yheight-yheight2));

this_box_storage.normal_vectors[4] = coords_set(0,y_component,z_component);
this_box_storage.normal_vectors[5] = coords_set(0,-y_component,z_component);

this_box_volume.geometry.visualization_on = visualize;

this_box_volume.geometry.geometry_parameters.p_box_storage = &this_box_storage;

// Assign pointers to functions for intersection with the shape, checking if a point is inside the shape
if (this_box_storage.is_rectangle == 1) {
this_box_volume.geometry.intersect_function = &sample_box_intersect_simple;
this_box_volume.geometry.within_function = &r_within_box_simple;
}
else {
this_box_volume.geometry.intersect_function = &sample_box_intersect_advanced;
this_box_volume.geometry.within_function = &r_within_box_advanced;
}

this_box_volume.geometry.shell_points = &box_shell_points;
this_box_volume.geometry.mcdisplay_function = &mcdisplay_box_function;
this_box_volume.geometry.initialize_from_main_function = &initialize_box_geometry_from_main_component;
this_box_volume.geometry.process_rot_allocated = 0;

this_box_volume.geometry.copy_geometry_parameters = &allocate_box_storage_copy;

rot_copy(this_box_volume.geometry.rotation_matrix,ROT_A_CURRENT_COMP); //check how ROT_R_CURRENT_COMP would work
rot_transpose(ROT_A_CURRENT_COMP,this_box_volume.geometry.transpose_rotation_matrix);

// Initialize loggers
this_box_volume.loggers.num_elements = 0;

// packing the information into the global_geometry_element, which is then included in the global_geometry_list.
sprintf(global_geometry_element.name,NAME_CURRENT_COMP);
global_geometry_element.activation_counter = number_of_activations;
global_geometry_element.component_index = INDEX_CURRENT_COMP;
global_geometry_element.Volume = &this_box_volume; // Would be nicer if this m was a pointer, now we have the (small) data two places
add_element_to_geometry_list(&global_geometry_list,global_geometry_element);
}
#line 199988 "MACS_sample_kidney_box.c"
#undef number_of_activations
#undef mask_setting
#undef mask_string
#undef p_interact
#undef focus_r
#undef focus_xh
#undef focus_xw
#undef focus_ah
#undef focus_aw
#undef target_z
#undef target_y
#undef target_x
#undef target_index
#undef visualize
#undef yheight2
#undef xwidth2
#undef zdepth
#undef yheight
#undef xwidth
#undef priority
#undef material_string
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

  /* Initializations for component channel_4_cave1_box2. */
  SIG_MESSAGE("channel_4_cave1_box2 (Init)");
#define mccompcurname  channel_4_cave1_box2
#define mccompcurtype  Union_box
#define mccompcurindex 277
#define loop_index mccchannel_4_cave1_box2_loop_index
#define this_box_volume mccchannel_4_cave1_box2_this_box_volume
#define global_geometry_element mccchannel_4_cave1_box2_global_geometry_element
#define this_box_storage mccchannel_4_cave1_box2_this_box_storage
#define material_string mccchannel_4_cave1_box2_material_string
#define priority mccchannel_4_cave1_box2_priority
#define xwidth mccchannel_4_cave1_box2_xwidth
#define yheight mccchannel_4_cave1_box2_yheight
#define zdepth mccchannel_4_cave1_box2_zdepth
#define xwidth2 mccchannel_4_cave1_box2_xwidth2
#define yheight2 mccchannel_4_cave1_box2_yheight2
#define visualize mccchannel_4_cave1_box2_visualize
#define target_index mccchannel_4_cave1_box2_target_index
#define target_x mccchannel_4_cave1_box2_target_x
#define target_y mccchannel_4_cave1_box2_target_y
#define target_z mccchannel_4_cave1_box2_target_z
#define focus_aw mccchannel_4_cave1_box2_focus_aw
#define focus_ah mccchannel_4_cave1_box2_focus_ah
#define focus_xw mccchannel_4_cave1_box2_focus_xw
#define focus_xh mccchannel_4_cave1_box2_focus_xh
#define focus_r mccchannel_4_cave1_box2_focus_r
#define p_interact mccchannel_4_cave1_box2_p_interact
#define mask_string mccchannel_4_cave1_box2_mask_string
#define mask_setting mccchannel_4_cave1_box2_mask_setting
#define number_of_activations mccchannel_4_cave1_box2_number_of_activations
#line 224 "Union_box.comp"
{
// Initializes the focusing system for this volume including input sanitation.
focus_initialize(&this_box_volume.geometry, POS_A_COMP_INDEX(INDEX_CURRENT_COMP+target_index), POS_A_CURRENT_COMP, ROT_A_CURRENT_COMP, target_index, target_x, target_y, target_z, focus_aw, focus_ah, focus_xw, focus_xh, focus_r, NAME_CURRENT_COMP);

// Input sanitation for this geometry
if (xwidth <= 0) {
  printf("\nERROR in Union_box named %s, the xwidth is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (yheight <= 0) {
  printf("\nERROR in Union_box named %s, yheight is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (zdepth <= 0) {
  printf("\nERROR in Union_box named %s, zdepth is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (xwidth2 <= 0 && xwidth2 != -1) {
  printf("\nERROR in Union_box named %s, the xwidth2 is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (yheight2 <= 0 && yheight2 != -1) {
  printf("\nERROR in Union_box named %s, yheight2 is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}

// Use sanitation
if (global_material_list.num_elements == 0) {
  printf("\nERROR: Need to define a material using Union_make_material before using a Union geometry component. \n");
  printf("       %s was defined before first use of Union_make_material.\n",NAME_CURRENT_COMP);
  exit(1);
}

this_box_volume.geometry.is_masked_volume = 0;
this_box_volume.geometry.is_exit_volume = 0;
this_box_volume.geometry.is_mask_volume = 0;
// check if the volume is a mask, if it is the material string is irelevant.
if (mask_string && strlen(mask_string) && strcmp(mask_string, "NULL") && strcmp(mask_string, "0")) {
    // A mask volume is used to limit the extend of other volumes, called the masked volumes. These are specified in the mask_string.
    // In order for a ray to enter a masked volume, it needs to be both in the region covered by that volume AND the mask volume.
    // When more than
    this_box_volume.geometry.mask_mode = 1; // Default is mask mode is ALL
    if (mask_setting && strlen(mask_setting) && strcmp(mask_setting, "NULL") && strcmp(mask_setting, "0")) {
        if (strcmp(mask_setting,"ALL") == 0 || strcmp(mask_setting,"All") == 0) this_box_volume.geometry.mask_mode = 1;
        else if (strcmp(mask_setting,"ANY") == 0 || strcmp(mask_setting,"Any") == 0) this_box_volume.geometry.mask_mode = 2;
        else {
            printf("The mask_mode of component %s is set to %s, but must be either ALL or ANY.\n",NAME_CURRENT_COMP,mask_setting);
            exit(1);
        }
    }
    
    for (loop_index=0;loop_index<global_geometry_list.num_elements;loop_index++) {
        // Add mask list
        if (1 == manual_linking_function(global_geometry_list.elements[loop_index].name,mask_string)) {
            add_element_to_int_list(&this_box_volume.geometry.mask_list,global_geometry_list.elements[loop_index].component_index);
            add_element_to_int_list(&global_geometry_list.elements[loop_index].Volume->geometry.masked_by_list,INDEX_CURRENT_COMP);
            global_geometry_list.elements[loop_index].Volume->geometry.is_masked_volume = 1;
            if (this_box_volume.geometry.mask_mode == 2)
                global_geometry_list.elements[loop_index].Volume->geometry.mask_mode = 2;
            if (this_box_volume.geometry.mask_mode == 1) {
                if (global_geometry_list.elements[loop_index].Volume->geometry.is_masked_volume == 1 && global_geometry_list.elements[loop_index].Volume->geometry.mask_mode != 2)
                    // If more than one mask is added to one volume, the ANY mode overwrites the (default) ALL mode.
                    global_geometry_list.elements[loop_index].Volume->geometry.mask_mode = 1;
            }
            
            found_geometries = 1;
        }
    }
    if (found_geometries == 0) {
        printf("The mask_string in geometry: %s did not find any of the specified volumes in the mask_string %s \n",NAME_CURRENT_COMP,mask_string);
        exit(1);
    }
    this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
    this_box_volume.p_physics->is_vacuum = 0; // Makes this volume a vacuum
    this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
    this_box_volume.p_physics->my_a = 0; // Should not be used.
    sprintf(this_box_volume.p_physics->name,"Mask");
    this_box_volume.geometry.is_mask_volume = 1;
    
    
// Read the material input, or if it lacks, use automatic linking.
} else if (material_string && strlen(material_string) && strcmp(material_string, "NULL") && strcmp(material_string, "0")) {
    // A geometry string was given, use it to determine which material
    if (0 == strcmp(material_string,"vacuum") || 0 == strcmp(material_string,"Vacuum")) {
        // One could have a global physics struct for vacuum instead of creating one for each
        this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
        this_box_volume.p_physics->is_vacuum = 1; // Makes this volume a vacuum
        this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
        this_box_volume.p_physics->my_a = 0; // Should not be used.
        sprintf(this_box_volume.p_physics->name,"Vacuum");
    } else if (0 == strcmp(material_string,"exit") || 0 == strcmp(material_string,"Exit")) {
        // One could have a global physics struct for vacuum instead of creating one for each
        this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
        this_box_volume.p_physics->is_vacuum = 1; // Makes this volume a vacuum
        this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
        this_box_volume.p_physics->my_a = 0; // Should not be used.
        this_box_volume.geometry.is_exit_volume = 1;
        sprintf(this_box_volume.p_physics->name,"Exit");
    } else {
        #ifndef MATERIAL_DETECTOR
            printf("Need to define a material before refering to it in a geometry %s.\n",NAME_CURRENT_COMP);
            exit(1);
        #endif
        for (loop_index=0;loop_index<global_material_list.num_elements;loop_index++) {
            if (0 == strcmp(material_string,global_material_list.elements[loop_index].name)) {
                this_box_volume.p_physics = global_material_list.elements[loop_index].physics;
                break;
            }
            if (loop_index == global_material_list.num_elements-1) {
            printf("\n");
            printf("ERROR: The material string \"%s\" in Union geometry \"%s\" did not match a specified material. \n",material_string,NAME_CURRENT_COMP);
            printf("       The materials available at this point (need to be defined before the geometry): \n");
            for (loop_index=0;loop_index<global_material_list.num_elements;loop_index++)
              printf("         %s\n",global_material_list.elements[loop_index].name);
            printf("\n");
            printf("       It is also possible to use one of the defualt materials avaiable: \n");
            printf("           Vacuum (for a Volume without scattering or absorption)\n");
            printf("           Exit (for a Volume where the ray exits the component if it enters)\n");
            printf("           Mask (for a Volume that masks existing volumes specified in the mask_string\n");
            exit(1);
          }
        }
    }
} else {
    // Automatic linking, simply using the last defined material.
    #ifndef MATERIAL_DETECTOR
        printf("Need to define a material before the geometry to use automatic linking %s.\n",NAME_CURRENT_COMP);
        exit(1);
    #endif
    this_box_volume.p_physics = global_material_list.elements[global_material_list.num_elements-1].physics;
}

sprintf(this_box_volume.name,NAME_CURRENT_COMP);
sprintf(this_box_volume.geometry.shape,"box");
this_box_volume.geometry.priority_value = priority;
this_box_volume.geometry.geometry_p_interact = p_interact;
// Currently the coordinates will be in absolute space.
this_box_volume.geometry.center = POS_A_CURRENT_COMP;

this_box_storage.z_depth = zdepth;
this_box_storage.x_width1 = xwidth;
this_box_storage.y_height1 = yheight;

this_box_storage.is_rectangle = 0;
if (xwidth2 < 0 && yheight2 < 0) this_box_storage.is_rectangle = 1;
if (xwidth == xwidth2 && yheight == yheight2) this_box_storage.is_rectangle = 1;

if (xwidth2 < 0) {
    this_box_storage.x_width2 = xwidth;
    xwidth2 = xwidth;
} else this_box_storage.x_width2 = xwidth2;

if (yheight2 < 0) {
    this_box_storage.y_height2 = yheight;
    yheight2 = yheight;
} else this_box_storage.y_height2 = yheight2;


this_box_storage.normal_vectors[0] = coords_set(0,0,1);
this_box_storage.normal_vectors[1] = coords_set(0,0,1);

// for sides with y component = 0
x_component = 2*zdepth/sqrt((xwidth-xwidth2)*(xwidth-xwidth2)+4*zdepth*zdepth);
z_component = (xwidth-xwidth2)/sqrt(4*zdepth*zdepth+(xwidth-xwidth2)*(xwidth-xwidth2));

this_box_storage.normal_vectors[2] = coords_set(x_component,0,z_component);
this_box_storage.normal_vectors[3] = coords_set(-x_component,0,z_component);

// for sides with x component = 0
y_component = 2*zdepth/sqrt((yheight-yheight2)*(yheight-yheight2)+4*zdepth*zdepth);
z_component = (yheight-yheight2)/sqrt(4*zdepth*zdepth+(yheight-yheight2)*(yheight-yheight2));

this_box_storage.normal_vectors[4] = coords_set(0,y_component,z_component);
this_box_storage.normal_vectors[5] = coords_set(0,-y_component,z_component);

this_box_volume.geometry.visualization_on = visualize;

this_box_volume.geometry.geometry_parameters.p_box_storage = &this_box_storage;

// Assign pointers to functions for intersection with the shape, checking if a point is inside the shape
if (this_box_storage.is_rectangle == 1) {
this_box_volume.geometry.intersect_function = &sample_box_intersect_simple;
this_box_volume.geometry.within_function = &r_within_box_simple;
}
else {
this_box_volume.geometry.intersect_function = &sample_box_intersect_advanced;
this_box_volume.geometry.within_function = &r_within_box_advanced;
}

this_box_volume.geometry.shell_points = &box_shell_points;
this_box_volume.geometry.mcdisplay_function = &mcdisplay_box_function;
this_box_volume.geometry.initialize_from_main_function = &initialize_box_geometry_from_main_component;
this_box_volume.geometry.process_rot_allocated = 0;

this_box_volume.geometry.copy_geometry_parameters = &allocate_box_storage_copy;

rot_copy(this_box_volume.geometry.rotation_matrix,ROT_A_CURRENT_COMP); //check how ROT_R_CURRENT_COMP would work
rot_transpose(ROT_A_CURRENT_COMP,this_box_volume.geometry.transpose_rotation_matrix);

// Initialize loggers
this_box_volume.loggers.num_elements = 0;

// packing the information into the global_geometry_element, which is then included in the global_geometry_list.
sprintf(global_geometry_element.name,NAME_CURRENT_COMP);
global_geometry_element.activation_counter = number_of_activations;
global_geometry_element.component_index = INDEX_CURRENT_COMP;
global_geometry_element.Volume = &this_box_volume; // Would be nicer if this m was a pointer, now we have the (small) data two places
add_element_to_geometry_list(&global_geometry_list,global_geometry_element);
}
#line 200258 "MACS_sample_kidney_box.c"
#undef number_of_activations
#undef mask_setting
#undef mask_string
#undef p_interact
#undef focus_r
#undef focus_xh
#undef focus_xw
#undef focus_ah
#undef focus_aw
#undef target_z
#undef target_y
#undef target_x
#undef target_index
#undef visualize
#undef yheight2
#undef xwidth2
#undef zdepth
#undef yheight
#undef xwidth
#undef priority
#undef material_string
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

  /* Initializations for component channel_4_cave1_box3. */
  SIG_MESSAGE("channel_4_cave1_box3 (Init)");
#define mccompcurname  channel_4_cave1_box3
#define mccompcurtype  Union_box
#define mccompcurindex 278
#define loop_index mccchannel_4_cave1_box3_loop_index
#define this_box_volume mccchannel_4_cave1_box3_this_box_volume
#define global_geometry_element mccchannel_4_cave1_box3_global_geometry_element
#define this_box_storage mccchannel_4_cave1_box3_this_box_storage
#define material_string mccchannel_4_cave1_box3_material_string
#define priority mccchannel_4_cave1_box3_priority
#define xwidth mccchannel_4_cave1_box3_xwidth
#define yheight mccchannel_4_cave1_box3_yheight
#define zdepth mccchannel_4_cave1_box3_zdepth
#define xwidth2 mccchannel_4_cave1_box3_xwidth2
#define yheight2 mccchannel_4_cave1_box3_yheight2
#define visualize mccchannel_4_cave1_box3_visualize
#define target_index mccchannel_4_cave1_box3_target_index
#define target_x mccchannel_4_cave1_box3_target_x
#define target_y mccchannel_4_cave1_box3_target_y
#define target_z mccchannel_4_cave1_box3_target_z
#define focus_aw mccchannel_4_cave1_box3_focus_aw
#define focus_ah mccchannel_4_cave1_box3_focus_ah
#define focus_xw mccchannel_4_cave1_box3_focus_xw
#define focus_xh mccchannel_4_cave1_box3_focus_xh
#define focus_r mccchannel_4_cave1_box3_focus_r
#define p_interact mccchannel_4_cave1_box3_p_interact
#define mask_string mccchannel_4_cave1_box3_mask_string
#define mask_setting mccchannel_4_cave1_box3_mask_setting
#define number_of_activations mccchannel_4_cave1_box3_number_of_activations
#line 224 "Union_box.comp"
{
// Initializes the focusing system for this volume including input sanitation.
focus_initialize(&this_box_volume.geometry, POS_A_COMP_INDEX(INDEX_CURRENT_COMP+target_index), POS_A_CURRENT_COMP, ROT_A_CURRENT_COMP, target_index, target_x, target_y, target_z, focus_aw, focus_ah, focus_xw, focus_xh, focus_r, NAME_CURRENT_COMP);

// Input sanitation for this geometry
if (xwidth <= 0) {
  printf("\nERROR in Union_box named %s, the xwidth is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (yheight <= 0) {
  printf("\nERROR in Union_box named %s, yheight is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (zdepth <= 0) {
  printf("\nERROR in Union_box named %s, zdepth is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (xwidth2 <= 0 && xwidth2 != -1) {
  printf("\nERROR in Union_box named %s, the xwidth2 is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (yheight2 <= 0 && yheight2 != -1) {
  printf("\nERROR in Union_box named %s, yheight2 is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}

// Use sanitation
if (global_material_list.num_elements == 0) {
  printf("\nERROR: Need to define a material using Union_make_material before using a Union geometry component. \n");
  printf("       %s was defined before first use of Union_make_material.\n",NAME_CURRENT_COMP);
  exit(1);
}

this_box_volume.geometry.is_masked_volume = 0;
this_box_volume.geometry.is_exit_volume = 0;
this_box_volume.geometry.is_mask_volume = 0;
// check if the volume is a mask, if it is the material string is irelevant.
if (mask_string && strlen(mask_string) && strcmp(mask_string, "NULL") && strcmp(mask_string, "0")) {
    // A mask volume is used to limit the extend of other volumes, called the masked volumes. These are specified in the mask_string.
    // In order for a ray to enter a masked volume, it needs to be both in the region covered by that volume AND the mask volume.
    // When more than
    this_box_volume.geometry.mask_mode = 1; // Default is mask mode is ALL
    if (mask_setting && strlen(mask_setting) && strcmp(mask_setting, "NULL") && strcmp(mask_setting, "0")) {
        if (strcmp(mask_setting,"ALL") == 0 || strcmp(mask_setting,"All") == 0) this_box_volume.geometry.mask_mode = 1;
        else if (strcmp(mask_setting,"ANY") == 0 || strcmp(mask_setting,"Any") == 0) this_box_volume.geometry.mask_mode = 2;
        else {
            printf("The mask_mode of component %s is set to %s, but must be either ALL or ANY.\n",NAME_CURRENT_COMP,mask_setting);
            exit(1);
        }
    }
    
    for (loop_index=0;loop_index<global_geometry_list.num_elements;loop_index++) {
        // Add mask list
        if (1 == manual_linking_function(global_geometry_list.elements[loop_index].name,mask_string)) {
            add_element_to_int_list(&this_box_volume.geometry.mask_list,global_geometry_list.elements[loop_index].component_index);
            add_element_to_int_list(&global_geometry_list.elements[loop_index].Volume->geometry.masked_by_list,INDEX_CURRENT_COMP);
            global_geometry_list.elements[loop_index].Volume->geometry.is_masked_volume = 1;
            if (this_box_volume.geometry.mask_mode == 2)
                global_geometry_list.elements[loop_index].Volume->geometry.mask_mode = 2;
            if (this_box_volume.geometry.mask_mode == 1) {
                if (global_geometry_list.elements[loop_index].Volume->geometry.is_masked_volume == 1 && global_geometry_list.elements[loop_index].Volume->geometry.mask_mode != 2)
                    // If more than one mask is added to one volume, the ANY mode overwrites the (default) ALL mode.
                    global_geometry_list.elements[loop_index].Volume->geometry.mask_mode = 1;
            }
            
            found_geometries = 1;
        }
    }
    if (found_geometries == 0) {
        printf("The mask_string in geometry: %s did not find any of the specified volumes in the mask_string %s \n",NAME_CURRENT_COMP,mask_string);
        exit(1);
    }
    this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
    this_box_volume.p_physics->is_vacuum = 0; // Makes this volume a vacuum
    this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
    this_box_volume.p_physics->my_a = 0; // Should not be used.
    sprintf(this_box_volume.p_physics->name,"Mask");
    this_box_volume.geometry.is_mask_volume = 1;
    
    
// Read the material input, or if it lacks, use automatic linking.
} else if (material_string && strlen(material_string) && strcmp(material_string, "NULL") && strcmp(material_string, "0")) {
    // A geometry string was given, use it to determine which material
    if (0 == strcmp(material_string,"vacuum") || 0 == strcmp(material_string,"Vacuum")) {
        // One could have a global physics struct for vacuum instead of creating one for each
        this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
        this_box_volume.p_physics->is_vacuum = 1; // Makes this volume a vacuum
        this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
        this_box_volume.p_physics->my_a = 0; // Should not be used.
        sprintf(this_box_volume.p_physics->name,"Vacuum");
    } else if (0 == strcmp(material_string,"exit") || 0 == strcmp(material_string,"Exit")) {
        // One could have a global physics struct for vacuum instead of creating one for each
        this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
        this_box_volume.p_physics->is_vacuum = 1; // Makes this volume a vacuum
        this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
        this_box_volume.p_physics->my_a = 0; // Should not be used.
        this_box_volume.geometry.is_exit_volume = 1;
        sprintf(this_box_volume.p_physics->name,"Exit");
    } else {
        #ifndef MATERIAL_DETECTOR
            printf("Need to define a material before refering to it in a geometry %s.\n",NAME_CURRENT_COMP);
            exit(1);
        #endif
        for (loop_index=0;loop_index<global_material_list.num_elements;loop_index++) {
            if (0 == strcmp(material_string,global_material_list.elements[loop_index].name)) {
                this_box_volume.p_physics = global_material_list.elements[loop_index].physics;
                break;
            }
            if (loop_index == global_material_list.num_elements-1) {
            printf("\n");
            printf("ERROR: The material string \"%s\" in Union geometry \"%s\" did not match a specified material. \n",material_string,NAME_CURRENT_COMP);
            printf("       The materials available at this point (need to be defined before the geometry): \n");
            for (loop_index=0;loop_index<global_material_list.num_elements;loop_index++)
              printf("         %s\n",global_material_list.elements[loop_index].name);
            printf("\n");
            printf("       It is also possible to use one of the defualt materials avaiable: \n");
            printf("           Vacuum (for a Volume without scattering or absorption)\n");
            printf("           Exit (for a Volume where the ray exits the component if it enters)\n");
            printf("           Mask (for a Volume that masks existing volumes specified in the mask_string\n");
            exit(1);
          }
        }
    }
} else {
    // Automatic linking, simply using the last defined material.
    #ifndef MATERIAL_DETECTOR
        printf("Need to define a material before the geometry to use automatic linking %s.\n",NAME_CURRENT_COMP);
        exit(1);
    #endif
    this_box_volume.p_physics = global_material_list.elements[global_material_list.num_elements-1].physics;
}

sprintf(this_box_volume.name,NAME_CURRENT_COMP);
sprintf(this_box_volume.geometry.shape,"box");
this_box_volume.geometry.priority_value = priority;
this_box_volume.geometry.geometry_p_interact = p_interact;
// Currently the coordinates will be in absolute space.
this_box_volume.geometry.center = POS_A_CURRENT_COMP;

this_box_storage.z_depth = zdepth;
this_box_storage.x_width1 = xwidth;
this_box_storage.y_height1 = yheight;

this_box_storage.is_rectangle = 0;
if (xwidth2 < 0 && yheight2 < 0) this_box_storage.is_rectangle = 1;
if (xwidth == xwidth2 && yheight == yheight2) this_box_storage.is_rectangle = 1;

if (xwidth2 < 0) {
    this_box_storage.x_width2 = xwidth;
    xwidth2 = xwidth;
} else this_box_storage.x_width2 = xwidth2;

if (yheight2 < 0) {
    this_box_storage.y_height2 = yheight;
    yheight2 = yheight;
} else this_box_storage.y_height2 = yheight2;


this_box_storage.normal_vectors[0] = coords_set(0,0,1);
this_box_storage.normal_vectors[1] = coords_set(0,0,1);

// for sides with y component = 0
x_component = 2*zdepth/sqrt((xwidth-xwidth2)*(xwidth-xwidth2)+4*zdepth*zdepth);
z_component = (xwidth-xwidth2)/sqrt(4*zdepth*zdepth+(xwidth-xwidth2)*(xwidth-xwidth2));

this_box_storage.normal_vectors[2] = coords_set(x_component,0,z_component);
this_box_storage.normal_vectors[3] = coords_set(-x_component,0,z_component);

// for sides with x component = 0
y_component = 2*zdepth/sqrt((yheight-yheight2)*(yheight-yheight2)+4*zdepth*zdepth);
z_component = (yheight-yheight2)/sqrt(4*zdepth*zdepth+(yheight-yheight2)*(yheight-yheight2));

this_box_storage.normal_vectors[4] = coords_set(0,y_component,z_component);
this_box_storage.normal_vectors[5] = coords_set(0,-y_component,z_component);

this_box_volume.geometry.visualization_on = visualize;

this_box_volume.geometry.geometry_parameters.p_box_storage = &this_box_storage;

// Assign pointers to functions for intersection with the shape, checking if a point is inside the shape
if (this_box_storage.is_rectangle == 1) {
this_box_volume.geometry.intersect_function = &sample_box_intersect_simple;
this_box_volume.geometry.within_function = &r_within_box_simple;
}
else {
this_box_volume.geometry.intersect_function = &sample_box_intersect_advanced;
this_box_volume.geometry.within_function = &r_within_box_advanced;
}

this_box_volume.geometry.shell_points = &box_shell_points;
this_box_volume.geometry.mcdisplay_function = &mcdisplay_box_function;
this_box_volume.geometry.initialize_from_main_function = &initialize_box_geometry_from_main_component;
this_box_volume.geometry.process_rot_allocated = 0;

this_box_volume.geometry.copy_geometry_parameters = &allocate_box_storage_copy;

rot_copy(this_box_volume.geometry.rotation_matrix,ROT_A_CURRENT_COMP); //check how ROT_R_CURRENT_COMP would work
rot_transpose(ROT_A_CURRENT_COMP,this_box_volume.geometry.transpose_rotation_matrix);

// Initialize loggers
this_box_volume.loggers.num_elements = 0;

// packing the information into the global_geometry_element, which is then included in the global_geometry_list.
sprintf(global_geometry_element.name,NAME_CURRENT_COMP);
global_geometry_element.activation_counter = number_of_activations;
global_geometry_element.component_index = INDEX_CURRENT_COMP;
global_geometry_element.Volume = &this_box_volume; // Would be nicer if this m was a pointer, now we have the (small) data two places
add_element_to_geometry_list(&global_geometry_list,global_geometry_element);
}
#line 200528 "MACS_sample_kidney_box.c"
#undef number_of_activations
#undef mask_setting
#undef mask_string
#undef p_interact
#undef focus_r
#undef focus_xh
#undef focus_xw
#undef focus_ah
#undef focus_aw
#undef target_z
#undef target_y
#undef target_x
#undef target_index
#undef visualize
#undef yheight2
#undef xwidth2
#undef zdepth
#undef yheight
#undef xwidth
#undef priority
#undef material_string
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

  /* Initializations for component channel_4_cave1_cyl1. */
  SIG_MESSAGE("channel_4_cave1_cyl1 (Init)");
#define mccompcurname  channel_4_cave1_cyl1
#define mccompcurtype  Union_cylinder
#define mccompcurindex 279
#define loop_index mccchannel_4_cave1_cyl1_loop_index
#define this_cylinder_volume mccchannel_4_cave1_cyl1_this_cylinder_volume
#define global_geometry_element mccchannel_4_cave1_cyl1_global_geometry_element
#define this_cylinder_storage mccchannel_4_cave1_cyl1_this_cylinder_storage
#define material_string mccchannel_4_cave1_cyl1_material_string
#define priority mccchannel_4_cave1_cyl1_priority
#define radius mccchannel_4_cave1_cyl1_radius
#define yheight mccchannel_4_cave1_cyl1_yheight
#define visualize mccchannel_4_cave1_cyl1_visualize
#define target_index mccchannel_4_cave1_cyl1_target_index
#define target_x mccchannel_4_cave1_cyl1_target_x
#define target_y mccchannel_4_cave1_cyl1_target_y
#define target_z mccchannel_4_cave1_cyl1_target_z
#define focus_aw mccchannel_4_cave1_cyl1_focus_aw
#define focus_ah mccchannel_4_cave1_cyl1_focus_ah
#define focus_xw mccchannel_4_cave1_cyl1_focus_xw
#define focus_xh mccchannel_4_cave1_cyl1_focus_xh
#define focus_r mccchannel_4_cave1_cyl1_focus_r
#define p_interact mccchannel_4_cave1_cyl1_p_interact
#define mask_string mccchannel_4_cave1_cyl1_mask_string
#define mask_setting mccchannel_4_cave1_cyl1_mask_setting
#define number_of_activations mccchannel_4_cave1_cyl1_number_of_activations
#line 185 "Union_cylinder.comp"
{
// Initializes the focusing system for this volume including input sanitation.
focus_initialize(&this_cylinder_volume.geometry, POS_A_COMP_INDEX(INDEX_CURRENT_COMP+target_index), POS_A_CURRENT_COMP, ROT_A_CURRENT_COMP, target_index, target_x, target_y, target_z, focus_aw, focus_ah, focus_xw, focus_xh, focus_r, NAME_CURRENT_COMP);

// Input sanitation for this geometry
if (radius <= 0) {
  printf("\nERROR in Union_cylinder named %s, the radius is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}

if (yheight <= 0) {
  printf("\nERROR in Union_cylinder named %s, yheight is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}

// Use sanitation
#ifdef MATERIAL_DETECTOR
if (global_material_list.num_elements == 0) {
  // Here if the user have defined a material, but only after this material
  printf("\nERROR: Need to define a material using Union_make_material before using a Union geometry component. \n");
  printf("       %s was defined before first use of Union_make_material.\n",NAME_CURRENT_COMP);
  exit(1);
}
#endif
#ifndef MATERIAL_DETECTOR
  printf("\nERROR: Need to define a material using Union_make_material before using a Union geometry component. \n");
  exit(1);
#endif


this_cylinder_volume.geometry.is_masked_volume = 0;
this_cylinder_volume.geometry.is_exit_volume = 0;
this_cylinder_volume.geometry.is_mask_volume = 0;

// Read the material input, or if it lacks, use automatic linking.
if (mask_string && strlen(mask_string) && strcmp(mask_string, "NULL") && strcmp(mask_string, "0")) {
    // A mask volume is used to limit the extend of other volumes, called the masked volumes. These are specified in the mask_string.
    // In order for a ray to enter a masked volume, it needs to be both in the region covered by that volume AND the mask volume.
    // When more than
    this_cylinder_volume.geometry.mask_mode = 1; // Default is mask mode is ALL
    if (mask_setting && strlen(mask_setting) && strcmp(mask_setting, "NULL") && strcmp(mask_setting, "0")) {
        if (strcmp(mask_setting,"ALL") == 0 || strcmp(mask_setting,"All") == 0) this_cylinder_volume.geometry.mask_mode = 1;
        else if (strcmp(mask_setting,"ANY") == 0 || strcmp(mask_setting,"Any") == 0) this_cylinder_volume.geometry.mask_mode = 2;
        else {
            printf("The mask_mode of component %s is set to %s, but must be either ALL or ANY.\n",NAME_CURRENT_COMP,mask_setting);
            exit(1);
        }
    }
    
    for (loop_index=0;loop_index<global_geometry_list.num_elements;loop_index++) {
        // Add mask list
        if (1 == manual_linking_function(global_geometry_list.elements[loop_index].name,mask_string)) {
            add_element_to_int_list(&this_cylinder_volume.geometry.mask_list,global_geometry_list.elements[loop_index].component_index);
            add_element_to_int_list(&global_geometry_list.elements[loop_index].Volume->geometry.masked_by_list,INDEX_CURRENT_COMP);
            global_geometry_list.elements[loop_index].Volume->geometry.is_masked_volume = 1;
            if (this_cylinder_volume.geometry.mask_mode == 2)
                global_geometry_list.elements[loop_index].Volume->geometry.mask_mode = 2;
            if (this_cylinder_volume.geometry.mask_mode == 1) {
                if (global_geometry_list.elements[loop_index].Volume->geometry.is_masked_volume == 1 && global_geometry_list.elements[loop_index].Volume->geometry.mask_mode != 2)
                    // If more than one mask is added to one volume, the ANY mode overwrites the (default) ALL mode.
                    global_geometry_list.elements[loop_index].Volume->geometry.mask_mode = 1;
            }
            
            found_geometries = 1;
        }
    }
    if (found_geometries == 0) {
        printf("The mask_string in geometry: %s did not find any of the specified volumes in the mask_string %s \n",NAME_CURRENT_COMP,mask_string);
        exit(1);
    }
    this_cylinder_volume.p_physics = malloc(sizeof(struct physics_struct));
    this_cylinder_volume.p_physics->is_vacuum = 0; // Makes this volume a vacuum
    this_cylinder_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
    this_cylinder_volume.p_physics->my_a = 0; // Should not be used.
    sprintf(this_cylinder_volume.p_physics->name,"Mask");
    this_cylinder_volume.geometry.is_mask_volume = 1;
    
    
// Read the material input, or if it lacks, use automatic linking.
} else if (material_string && strlen(material_string) && strcmp(material_string, "NULL") && strcmp(material_string, "0")) {
    // A geometry string was given, use it to determine which material
    if (0 == strcmp(material_string,"vacuum") || 0 == strcmp(material_string,"Vacuum")) {
        // One could have a global physics struct for vacuum instead of creating one for each
        this_cylinder_volume.p_physics = malloc(sizeof(struct physics_struct));
        this_cylinder_volume.p_physics->is_vacuum = 1; // Makes this volume a vacuum
        this_cylinder_volume.p_physics->number_of_processes = (int) 0;
        this_cylinder_volume.p_physics->my_a = 0; // Should not be used.
        sprintf(this_cylinder_volume.p_physics->name,"Vacuum");
    } else if (0 == strcmp(material_string,"exit") || 0 == strcmp(material_string,"Exit")) {
        // One could have a global physics struct for exit instead of creating one for each
        this_cylinder_volume.p_physics = malloc(sizeof(struct physics_struct));
        this_cylinder_volume.p_physics->is_vacuum = 1; // Makes this volume a vacuum
        this_cylinder_volume.p_physics->number_of_processes = (int) 0;
        this_cylinder_volume.p_physics->my_a = 0; // Should not be used.
        this_cylinder_volume.geometry.is_exit_volume = 1;
        sprintf(this_cylinder_volume.p_physics->name,"Exit");
    } else {
        for (loop_index=0;loop_index<global_material_list.num_elements;loop_index++) {
          if (0 == strcmp(material_string,global_material_list.elements[loop_index].name)) {
            this_cylinder_volume.p_physics = global_material_list.elements[loop_index].physics;
            break;
          }
          if (loop_index == global_material_list.num_elements-1) {
            printf("\n");
            printf("ERROR: The material string \"%s\" in Union geometry \"%s\" did not match a specified material. \n",material_string,NAME_CURRENT_COMP);
            printf("       The materials available at this point (need to be defined before the geometry): \n");
            for (loop_index=0;loop_index<global_material_list.num_elements;loop_index++)
              printf("         %s\n",global_material_list.elements[loop_index].name);
            printf("\n");
            printf("       It is also possible to use one of the defualt materials avaiable: \n");
            printf("           Vacuum (for a Volume without scattering or absorption)\n");
            printf("           Exit (for a Volume where the ray exits the component if it enters)\n");
            printf("           Mask (for a Volume that masks existing volumes specified in the mask_string\n");
            exit(1);
          }
        }
    }
} else {
    // Automatic linking, simply using the last defined material.
    #ifndef MATERIAL_DETECTOR
        printf("Need to define a material before the geometry to use automatic linking %s.\n",NAME_CURRENT_COMP);
        exit(1);
    #endif
    this_cylinder_volume.p_physics = global_material_list.elements[global_material_list.num_elements-1].physics;
}

sprintf(this_cylinder_volume.name,NAME_CURRENT_COMP);
sprintf(this_cylinder_volume.geometry.shape,"cylinder");
this_cylinder_volume.geometry.priority_value = priority;
// Currently the coordinates will be in absolute space.
this_cylinder_volume.geometry.center = POS_A_CURRENT_COMP;

this_cylinder_volume.geometry.geometry_p_interact = p_interact;
this_cylinder_storage.cyl_radius = radius;
this_cylinder_storage.height = yheight;
this_cylinder_volume.geometry.visualization_on = visualize;
this_cylinder_volume.geometry.geometry_parameters.p_cylinder_storage = &this_cylinder_storage;
this_cylinder_volume.geometry.within_function = &r_within_cylinder;
this_cylinder_volume.geometry.intersect_function = &sample_cylinder_intersect;
this_cylinder_volume.geometry.mcdisplay_function = &mcdisplay_cylinder_function;
this_cylinder_volume.geometry.shell_points = &cylinder_shell_points;
this_cylinder_volume.geometry.initialize_from_main_function = &initialize_cylinder_geometry_from_main_component;
this_cylinder_volume.geometry.process_rot_allocated = 0;
this_cylinder_volume.geometry.copy_geometry_parameters = &allocate_cylinder_storage_copy;

rot_copy(this_cylinder_volume.geometry.rotation_matrix,ROT_A_CURRENT_COMP);
rot_transpose(ROT_A_CURRENT_COMP,this_cylinder_volume.geometry.transpose_rotation_matrix);

// Initialize loggers
this_cylinder_volume.loggers.num_elements = 0;

// packing the information into the global_geometry_element, which is then included in the global_geometry_list.
sprintf(global_geometry_element.name,NAME_CURRENT_COMP);
global_geometry_element.activation_counter = number_of_activations;
global_geometry_element.component_index = INDEX_CURRENT_COMP;
global_geometry_element.Volume = &this_cylinder_volume; // Would be nicer if this m was a pointer, now we have the (small) data two places
add_element_to_geometry_list(&global_geometry_list,global_geometry_element);
}
#line 200744 "MACS_sample_kidney_box.c"
#undef number_of_activations
#undef mask_setting
#undef mask_string
#undef p_interact
#undef focus_r
#undef focus_xh
#undef focus_xw
#undef focus_ah
#undef focus_aw
#undef target_z
#undef target_y
#undef target_x
#undef target_index
#undef visualize
#undef yheight
#undef radius
#undef priority
#undef material_string
#undef this_cylinder_storage
#undef global_geometry_element
#undef this_cylinder_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

  /* Initializations for component channel_4_analyzer_1_center. */
  SIG_MESSAGE("channel_4_analyzer_1_center (Init)");

  /* Initializations for component channel_4_analyzer_1_rotated. */
  SIG_MESSAGE("channel_4_analyzer_1_rotated (Init)");

  /* Initializations for component channel_4_analyzer_1_array_crystal_array_0. */
  SIG_MESSAGE("channel_4_analyzer_1_array_crystal_array_0 (Init)");
#define mccompcurname  channel_4_analyzer_1_array_crystal_array_0
#define mccompcurtype  Union_box
#define mccompcurindex 282
#define loop_index mccchannel_4_analyzer_1_array_crystal_array_0_loop_index
#define this_box_volume mccchannel_4_analyzer_1_array_crystal_array_0_this_box_volume
#define global_geometry_element mccchannel_4_analyzer_1_array_crystal_array_0_global_geometry_element
#define this_box_storage mccchannel_4_analyzer_1_array_crystal_array_0_this_box_storage
#define material_string mccchannel_4_analyzer_1_array_crystal_array_0_material_string
#define priority mccchannel_4_analyzer_1_array_crystal_array_0_priority
#define xwidth mccchannel_4_analyzer_1_array_crystal_array_0_xwidth
#define yheight mccchannel_4_analyzer_1_array_crystal_array_0_yheight
#define zdepth mccchannel_4_analyzer_1_array_crystal_array_0_zdepth
#define xwidth2 mccchannel_4_analyzer_1_array_crystal_array_0_xwidth2
#define yheight2 mccchannel_4_analyzer_1_array_crystal_array_0_yheight2
#define visualize mccchannel_4_analyzer_1_array_crystal_array_0_visualize
#define target_index mccchannel_4_analyzer_1_array_crystal_array_0_target_index
#define target_x mccchannel_4_analyzer_1_array_crystal_array_0_target_x
#define target_y mccchannel_4_analyzer_1_array_crystal_array_0_target_y
#define target_z mccchannel_4_analyzer_1_array_crystal_array_0_target_z
#define focus_aw mccchannel_4_analyzer_1_array_crystal_array_0_focus_aw
#define focus_ah mccchannel_4_analyzer_1_array_crystal_array_0_focus_ah
#define focus_xw mccchannel_4_analyzer_1_array_crystal_array_0_focus_xw
#define focus_xh mccchannel_4_analyzer_1_array_crystal_array_0_focus_xh
#define focus_r mccchannel_4_analyzer_1_array_crystal_array_0_focus_r
#define p_interact mccchannel_4_analyzer_1_array_crystal_array_0_p_interact
#define mask_string mccchannel_4_analyzer_1_array_crystal_array_0_mask_string
#define mask_setting mccchannel_4_analyzer_1_array_crystal_array_0_mask_setting
#define number_of_activations mccchannel_4_analyzer_1_array_crystal_array_0_number_of_activations
#line 224 "Union_box.comp"
{
// Initializes the focusing system for this volume including input sanitation.
focus_initialize(&this_box_volume.geometry, POS_A_COMP_INDEX(INDEX_CURRENT_COMP+target_index), POS_A_CURRENT_COMP, ROT_A_CURRENT_COMP, target_index, target_x, target_y, target_z, focus_aw, focus_ah, focus_xw, focus_xh, focus_r, NAME_CURRENT_COMP);

// Input sanitation for this geometry
if (xwidth <= 0) {
  printf("\nERROR in Union_box named %s, the xwidth is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (yheight <= 0) {
  printf("\nERROR in Union_box named %s, yheight is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (zdepth <= 0) {
  printf("\nERROR in Union_box named %s, zdepth is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (xwidth2 <= 0 && xwidth2 != -1) {
  printf("\nERROR in Union_box named %s, the xwidth2 is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (yheight2 <= 0 && yheight2 != -1) {
  printf("\nERROR in Union_box named %s, yheight2 is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}

// Use sanitation
if (global_material_list.num_elements == 0) {
  printf("\nERROR: Need to define a material using Union_make_material before using a Union geometry component. \n");
  printf("       %s was defined before first use of Union_make_material.\n",NAME_CURRENT_COMP);
  exit(1);
}

this_box_volume.geometry.is_masked_volume = 0;
this_box_volume.geometry.is_exit_volume = 0;
this_box_volume.geometry.is_mask_volume = 0;
// check if the volume is a mask, if it is the material string is irelevant.
if (mask_string && strlen(mask_string) && strcmp(mask_string, "NULL") && strcmp(mask_string, "0")) {
    // A mask volume is used to limit the extend of other volumes, called the masked volumes. These are specified in the mask_string.
    // In order for a ray to enter a masked volume, it needs to be both in the region covered by that volume AND the mask volume.
    // When more than
    this_box_volume.geometry.mask_mode = 1; // Default is mask mode is ALL
    if (mask_setting && strlen(mask_setting) && strcmp(mask_setting, "NULL") && strcmp(mask_setting, "0")) {
        if (strcmp(mask_setting,"ALL") == 0 || strcmp(mask_setting,"All") == 0) this_box_volume.geometry.mask_mode = 1;
        else if (strcmp(mask_setting,"ANY") == 0 || strcmp(mask_setting,"Any") == 0) this_box_volume.geometry.mask_mode = 2;
        else {
            printf("The mask_mode of component %s is set to %s, but must be either ALL or ANY.\n",NAME_CURRENT_COMP,mask_setting);
            exit(1);
        }
    }
    
    for (loop_index=0;loop_index<global_geometry_list.num_elements;loop_index++) {
        // Add mask list
        if (1 == manual_linking_function(global_geometry_list.elements[loop_index].name,mask_string)) {
            add_element_to_int_list(&this_box_volume.geometry.mask_list,global_geometry_list.elements[loop_index].component_index);
            add_element_to_int_list(&global_geometry_list.elements[loop_index].Volume->geometry.masked_by_list,INDEX_CURRENT_COMP);
            global_geometry_list.elements[loop_index].Volume->geometry.is_masked_volume = 1;
            if (this_box_volume.geometry.mask_mode == 2)
                global_geometry_list.elements[loop_index].Volume->geometry.mask_mode = 2;
            if (this_box_volume.geometry.mask_mode == 1) {
                if (global_geometry_list.elements[loop_index].Volume->geometry.is_masked_volume == 1 && global_geometry_list.elements[loop_index].Volume->geometry.mask_mode != 2)
                    // If more than one mask is added to one volume, the ANY mode overwrites the (default) ALL mode.
                    global_geometry_list.elements[loop_index].Volume->geometry.mask_mode = 1;
            }
            
            found_geometries = 1;
        }
    }
    if (found_geometries == 0) {
        printf("The mask_string in geometry: %s did not find any of the specified volumes in the mask_string %s \n",NAME_CURRENT_COMP,mask_string);
        exit(1);
    }
    this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
    this_box_volume.p_physics->is_vacuum = 0; // Makes this volume a vacuum
    this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
    this_box_volume.p_physics->my_a = 0; // Should not be used.
    sprintf(this_box_volume.p_physics->name,"Mask");
    this_box_volume.geometry.is_mask_volume = 1;
    
    
// Read the material input, or if it lacks, use automatic linking.
} else if (material_string && strlen(material_string) && strcmp(material_string, "NULL") && strcmp(material_string, "0")) {
    // A geometry string was given, use it to determine which material
    if (0 == strcmp(material_string,"vacuum") || 0 == strcmp(material_string,"Vacuum")) {
        // One could have a global physics struct for vacuum instead of creating one for each
        this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
        this_box_volume.p_physics->is_vacuum = 1; // Makes this volume a vacuum
        this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
        this_box_volume.p_physics->my_a = 0; // Should not be used.
        sprintf(this_box_volume.p_physics->name,"Vacuum");
    } else if (0 == strcmp(material_string,"exit") || 0 == strcmp(material_string,"Exit")) {
        // One could have a global physics struct for vacuum instead of creating one for each
        this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
        this_box_volume.p_physics->is_vacuum = 1; // Makes this volume a vacuum
        this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
        this_box_volume.p_physics->my_a = 0; // Should not be used.
        this_box_volume.geometry.is_exit_volume = 1;
        sprintf(this_box_volume.p_physics->name,"Exit");
    } else {
        #ifndef MATERIAL_DETECTOR
            printf("Need to define a material before refering to it in a geometry %s.\n",NAME_CURRENT_COMP);
            exit(1);
        #endif
        for (loop_index=0;loop_index<global_material_list.num_elements;loop_index++) {
            if (0 == strcmp(material_string,global_material_list.elements[loop_index].name)) {
                this_box_volume.p_physics = global_material_list.elements[loop_index].physics;
                break;
            }
            if (loop_index == global_material_list.num_elements-1) {
            printf("\n");
            printf("ERROR: The material string \"%s\" in Union geometry \"%s\" did not match a specified material. \n",material_string,NAME_CURRENT_COMP);
            printf("       The materials available at this point (need to be defined before the geometry): \n");
            for (loop_index=0;loop_index<global_material_list.num_elements;loop_index++)
              printf("         %s\n",global_material_list.elements[loop_index].name);
            printf("\n");
            printf("       It is also possible to use one of the defualt materials avaiable: \n");
            printf("           Vacuum (for a Volume without scattering or absorption)\n");
            printf("           Exit (for a Volume where the ray exits the component if it enters)\n");
            printf("           Mask (for a Volume that masks existing volumes specified in the mask_string\n");
            exit(1);
          }
        }
    }
} else {
    // Automatic linking, simply using the last defined material.
    #ifndef MATERIAL_DETECTOR
        printf("Need to define a material before the geometry to use automatic linking %s.\n",NAME_CURRENT_COMP);
        exit(1);
    #endif
    this_box_volume.p_physics = global_material_list.elements[global_material_list.num_elements-1].physics;
}

sprintf(this_box_volume.name,NAME_CURRENT_COMP);
sprintf(this_box_volume.geometry.shape,"box");
this_box_volume.geometry.priority_value = priority;
this_box_volume.geometry.geometry_p_interact = p_interact;
// Currently the coordinates will be in absolute space.
this_box_volume.geometry.center = POS_A_CURRENT_COMP;

this_box_storage.z_depth = zdepth;
this_box_storage.x_width1 = xwidth;
this_box_storage.y_height1 = yheight;

this_box_storage.is_rectangle = 0;
if (xwidth2 < 0 && yheight2 < 0) this_box_storage.is_rectangle = 1;
if (xwidth == xwidth2 && yheight == yheight2) this_box_storage.is_rectangle = 1;

if (xwidth2 < 0) {
    this_box_storage.x_width2 = xwidth;
    xwidth2 = xwidth;
} else this_box_storage.x_width2 = xwidth2;

if (yheight2 < 0) {
    this_box_storage.y_height2 = yheight;
    yheight2 = yheight;
} else this_box_storage.y_height2 = yheight2;


this_box_storage.normal_vectors[0] = coords_set(0,0,1);
this_box_storage.normal_vectors[1] = coords_set(0,0,1);

// for sides with y component = 0
x_component = 2*zdepth/sqrt((xwidth-xwidth2)*(xwidth-xwidth2)+4*zdepth*zdepth);
z_component = (xwidth-xwidth2)/sqrt(4*zdepth*zdepth+(xwidth-xwidth2)*(xwidth-xwidth2));

this_box_storage.normal_vectors[2] = coords_set(x_component,0,z_component);
this_box_storage.normal_vectors[3] = coords_set(-x_component,0,z_component);

// for sides with x component = 0
y_component = 2*zdepth/sqrt((yheight-yheight2)*(yheight-yheight2)+4*zdepth*zdepth);
z_component = (yheight-yheight2)/sqrt(4*zdepth*zdepth+(yheight-yheight2)*(yheight-yheight2));

this_box_storage.normal_vectors[4] = coords_set(0,y_component,z_component);
this_box_storage.normal_vectors[5] = coords_set(0,-y_component,z_component);

this_box_volume.geometry.visualization_on = visualize;

this_box_volume.geometry.geometry_parameters.p_box_storage = &this_box_storage;

// Assign pointers to functions for intersection with the shape, checking if a point is inside the shape
if (this_box_storage.is_rectangle == 1) {
this_box_volume.geometry.intersect_function = &sample_box_intersect_simple;
this_box_volume.geometry.within_function = &r_within_box_simple;
}
else {
this_box_volume.geometry.intersect_function = &sample_box_intersect_advanced;
this_box_volume.geometry.within_function = &r_within_box_advanced;
}

this_box_volume.geometry.shell_points = &box_shell_points;
this_box_volume.geometry.mcdisplay_function = &mcdisplay_box_function;
this_box_volume.geometry.initialize_from_main_function = &initialize_box_geometry_from_main_component;
this_box_volume.geometry.process_rot_allocated = 0;

this_box_volume.geometry.copy_geometry_parameters = &allocate_box_storage_copy;

rot_copy(this_box_volume.geometry.rotation_matrix,ROT_A_CURRENT_COMP); //check how ROT_R_CURRENT_COMP would work
rot_transpose(ROT_A_CURRENT_COMP,this_box_volume.geometry.transpose_rotation_matrix);

// Initialize loggers
this_box_volume.loggers.num_elements = 0;

// packing the information into the global_geometry_element, which is then included in the global_geometry_list.
sprintf(global_geometry_element.name,NAME_CURRENT_COMP);
global_geometry_element.activation_counter = number_of_activations;
global_geometry_element.component_index = INDEX_CURRENT_COMP;
global_geometry_element.Volume = &this_box_volume; // Would be nicer if this m was a pointer, now we have the (small) data two places
add_element_to_geometry_list(&global_geometry_list,global_geometry_element);
}
#line 201017 "MACS_sample_kidney_box.c"
#undef number_of_activations
#undef mask_setting
#undef mask_string
#undef p_interact
#undef focus_r
#undef focus_xh
#undef focus_xw
#undef focus_ah
#undef focus_aw
#undef target_z
#undef target_y
#undef target_x
#undef target_index
#undef visualize
#undef yheight2
#undef xwidth2
#undef zdepth
#undef yheight
#undef xwidth
#undef priority
#undef material_string
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

  /* Initializations for component channel_4_analyzer_1_array_crystal_array_1. */
  SIG_MESSAGE("channel_4_analyzer_1_array_crystal_array_1 (Init)");
#define mccompcurname  channel_4_analyzer_1_array_crystal_array_1
#define mccompcurtype  Union_box
#define mccompcurindex 283
#define loop_index mccchannel_4_analyzer_1_array_crystal_array_1_loop_index
#define this_box_volume mccchannel_4_analyzer_1_array_crystal_array_1_this_box_volume
#define global_geometry_element mccchannel_4_analyzer_1_array_crystal_array_1_global_geometry_element
#define this_box_storage mccchannel_4_analyzer_1_array_crystal_array_1_this_box_storage
#define material_string mccchannel_4_analyzer_1_array_crystal_array_1_material_string
#define priority mccchannel_4_analyzer_1_array_crystal_array_1_priority
#define xwidth mccchannel_4_analyzer_1_array_crystal_array_1_xwidth
#define yheight mccchannel_4_analyzer_1_array_crystal_array_1_yheight
#define zdepth mccchannel_4_analyzer_1_array_crystal_array_1_zdepth
#define xwidth2 mccchannel_4_analyzer_1_array_crystal_array_1_xwidth2
#define yheight2 mccchannel_4_analyzer_1_array_crystal_array_1_yheight2
#define visualize mccchannel_4_analyzer_1_array_crystal_array_1_visualize
#define target_index mccchannel_4_analyzer_1_array_crystal_array_1_target_index
#define target_x mccchannel_4_analyzer_1_array_crystal_array_1_target_x
#define target_y mccchannel_4_analyzer_1_array_crystal_array_1_target_y
#define target_z mccchannel_4_analyzer_1_array_crystal_array_1_target_z
#define focus_aw mccchannel_4_analyzer_1_array_crystal_array_1_focus_aw
#define focus_ah mccchannel_4_analyzer_1_array_crystal_array_1_focus_ah
#define focus_xw mccchannel_4_analyzer_1_array_crystal_array_1_focus_xw
#define focus_xh mccchannel_4_analyzer_1_array_crystal_array_1_focus_xh
#define focus_r mccchannel_4_analyzer_1_array_crystal_array_1_focus_r
#define p_interact mccchannel_4_analyzer_1_array_crystal_array_1_p_interact
#define mask_string mccchannel_4_analyzer_1_array_crystal_array_1_mask_string
#define mask_setting mccchannel_4_analyzer_1_array_crystal_array_1_mask_setting
#define number_of_activations mccchannel_4_analyzer_1_array_crystal_array_1_number_of_activations
#line 224 "Union_box.comp"
{
// Initializes the focusing system for this volume including input sanitation.
focus_initialize(&this_box_volume.geometry, POS_A_COMP_INDEX(INDEX_CURRENT_COMP+target_index), POS_A_CURRENT_COMP, ROT_A_CURRENT_COMP, target_index, target_x, target_y, target_z, focus_aw, focus_ah, focus_xw, focus_xh, focus_r, NAME_CURRENT_COMP);

// Input sanitation for this geometry
if (xwidth <= 0) {
  printf("\nERROR in Union_box named %s, the xwidth is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (yheight <= 0) {
  printf("\nERROR in Union_box named %s, yheight is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (zdepth <= 0) {
  printf("\nERROR in Union_box named %s, zdepth is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (xwidth2 <= 0 && xwidth2 != -1) {
  printf("\nERROR in Union_box named %s, the xwidth2 is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (yheight2 <= 0 && yheight2 != -1) {
  printf("\nERROR in Union_box named %s, yheight2 is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}

// Use sanitation
if (global_material_list.num_elements == 0) {
  printf("\nERROR: Need to define a material using Union_make_material before using a Union geometry component. \n");
  printf("       %s was defined before first use of Union_make_material.\n",NAME_CURRENT_COMP);
  exit(1);
}

this_box_volume.geometry.is_masked_volume = 0;
this_box_volume.geometry.is_exit_volume = 0;
this_box_volume.geometry.is_mask_volume = 0;
// check if the volume is a mask, if it is the material string is irelevant.
if (mask_string && strlen(mask_string) && strcmp(mask_string, "NULL") && strcmp(mask_string, "0")) {
    // A mask volume is used to limit the extend of other volumes, called the masked volumes. These are specified in the mask_string.
    // In order for a ray to enter a masked volume, it needs to be both in the region covered by that volume AND the mask volume.
    // When more than
    this_box_volume.geometry.mask_mode = 1; // Default is mask mode is ALL
    if (mask_setting && strlen(mask_setting) && strcmp(mask_setting, "NULL") && strcmp(mask_setting, "0")) {
        if (strcmp(mask_setting,"ALL") == 0 || strcmp(mask_setting,"All") == 0) this_box_volume.geometry.mask_mode = 1;
        else if (strcmp(mask_setting,"ANY") == 0 || strcmp(mask_setting,"Any") == 0) this_box_volume.geometry.mask_mode = 2;
        else {
            printf("The mask_mode of component %s is set to %s, but must be either ALL or ANY.\n",NAME_CURRENT_COMP,mask_setting);
            exit(1);
        }
    }
    
    for (loop_index=0;loop_index<global_geometry_list.num_elements;loop_index++) {
        // Add mask list
        if (1 == manual_linking_function(global_geometry_list.elements[loop_index].name,mask_string)) {
            add_element_to_int_list(&this_box_volume.geometry.mask_list,global_geometry_list.elements[loop_index].component_index);
            add_element_to_int_list(&global_geometry_list.elements[loop_index].Volume->geometry.masked_by_list,INDEX_CURRENT_COMP);
            global_geometry_list.elements[loop_index].Volume->geometry.is_masked_volume = 1;
            if (this_box_volume.geometry.mask_mode == 2)
                global_geometry_list.elements[loop_index].Volume->geometry.mask_mode = 2;
            if (this_box_volume.geometry.mask_mode == 1) {
                if (global_geometry_list.elements[loop_index].Volume->geometry.is_masked_volume == 1 && global_geometry_list.elements[loop_index].Volume->geometry.mask_mode != 2)
                    // If more than one mask is added to one volume, the ANY mode overwrites the (default) ALL mode.
                    global_geometry_list.elements[loop_index].Volume->geometry.mask_mode = 1;
            }
            
            found_geometries = 1;
        }
    }
    if (found_geometries == 0) {
        printf("The mask_string in geometry: %s did not find any of the specified volumes in the mask_string %s \n",NAME_CURRENT_COMP,mask_string);
        exit(1);
    }
    this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
    this_box_volume.p_physics->is_vacuum = 0; // Makes this volume a vacuum
    this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
    this_box_volume.p_physics->my_a = 0; // Should not be used.
    sprintf(this_box_volume.p_physics->name,"Mask");
    this_box_volume.geometry.is_mask_volume = 1;
    
    
// Read the material input, or if it lacks, use automatic linking.
} else if (material_string && strlen(material_string) && strcmp(material_string, "NULL") && strcmp(material_string, "0")) {
    // A geometry string was given, use it to determine which material
    if (0 == strcmp(material_string,"vacuum") || 0 == strcmp(material_string,"Vacuum")) {
        // One could have a global physics struct for vacuum instead of creating one for each
        this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
        this_box_volume.p_physics->is_vacuum = 1; // Makes this volume a vacuum
        this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
        this_box_volume.p_physics->my_a = 0; // Should not be used.
        sprintf(this_box_volume.p_physics->name,"Vacuum");
    } else if (0 == strcmp(material_string,"exit") || 0 == strcmp(material_string,"Exit")) {
        // One could have a global physics struct for vacuum instead of creating one for each
        this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
        this_box_volume.p_physics->is_vacuum = 1; // Makes this volume a vacuum
        this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
        this_box_volume.p_physics->my_a = 0; // Should not be used.
        this_box_volume.geometry.is_exit_volume = 1;
        sprintf(this_box_volume.p_physics->name,"Exit");
    } else {
        #ifndef MATERIAL_DETECTOR
            printf("Need to define a material before refering to it in a geometry %s.\n",NAME_CURRENT_COMP);
            exit(1);
        #endif
        for (loop_index=0;loop_index<global_material_list.num_elements;loop_index++) {
            if (0 == strcmp(material_string,global_material_list.elements[loop_index].name)) {
                this_box_volume.p_physics = global_material_list.elements[loop_index].physics;
                break;
            }
            if (loop_index == global_material_list.num_elements-1) {
            printf("\n");
            printf("ERROR: The material string \"%s\" in Union geometry \"%s\" did not match a specified material. \n",material_string,NAME_CURRENT_COMP);
            printf("       The materials available at this point (need to be defined before the geometry): \n");
            for (loop_index=0;loop_index<global_material_list.num_elements;loop_index++)
              printf("         %s\n",global_material_list.elements[loop_index].name);
            printf("\n");
            printf("       It is also possible to use one of the defualt materials avaiable: \n");
            printf("           Vacuum (for a Volume without scattering or absorption)\n");
            printf("           Exit (for a Volume where the ray exits the component if it enters)\n");
            printf("           Mask (for a Volume that masks existing volumes specified in the mask_string\n");
            exit(1);
          }
        }
    }
} else {
    // Automatic linking, simply using the last defined material.
    #ifndef MATERIAL_DETECTOR
        printf("Need to define a material before the geometry to use automatic linking %s.\n",NAME_CURRENT_COMP);
        exit(1);
    #endif
    this_box_volume.p_physics = global_material_list.elements[global_material_list.num_elements-1].physics;
}

sprintf(this_box_volume.name,NAME_CURRENT_COMP);
sprintf(this_box_volume.geometry.shape,"box");
this_box_volume.geometry.priority_value = priority;
this_box_volume.geometry.geometry_p_interact = p_interact;
// Currently the coordinates will be in absolute space.
this_box_volume.geometry.center = POS_A_CURRENT_COMP;

this_box_storage.z_depth = zdepth;
this_box_storage.x_width1 = xwidth;
this_box_storage.y_height1 = yheight;

this_box_storage.is_rectangle = 0;
if (xwidth2 < 0 && yheight2 < 0) this_box_storage.is_rectangle = 1;
if (xwidth == xwidth2 && yheight == yheight2) this_box_storage.is_rectangle = 1;

if (xwidth2 < 0) {
    this_box_storage.x_width2 = xwidth;
    xwidth2 = xwidth;
} else this_box_storage.x_width2 = xwidth2;

if (yheight2 < 0) {
    this_box_storage.y_height2 = yheight;
    yheight2 = yheight;
} else this_box_storage.y_height2 = yheight2;


this_box_storage.normal_vectors[0] = coords_set(0,0,1);
this_box_storage.normal_vectors[1] = coords_set(0,0,1);

// for sides with y component = 0
x_component = 2*zdepth/sqrt((xwidth-xwidth2)*(xwidth-xwidth2)+4*zdepth*zdepth);
z_component = (xwidth-xwidth2)/sqrt(4*zdepth*zdepth+(xwidth-xwidth2)*(xwidth-xwidth2));

this_box_storage.normal_vectors[2] = coords_set(x_component,0,z_component);
this_box_storage.normal_vectors[3] = coords_set(-x_component,0,z_component);

// for sides with x component = 0
y_component = 2*zdepth/sqrt((yheight-yheight2)*(yheight-yheight2)+4*zdepth*zdepth);
z_component = (yheight-yheight2)/sqrt(4*zdepth*zdepth+(yheight-yheight2)*(yheight-yheight2));

this_box_storage.normal_vectors[4] = coords_set(0,y_component,z_component);
this_box_storage.normal_vectors[5] = coords_set(0,-y_component,z_component);

this_box_volume.geometry.visualization_on = visualize;

this_box_volume.geometry.geometry_parameters.p_box_storage = &this_box_storage;

// Assign pointers to functions for intersection with the shape, checking if a point is inside the shape
if (this_box_storage.is_rectangle == 1) {
this_box_volume.geometry.intersect_function = &sample_box_intersect_simple;
this_box_volume.geometry.within_function = &r_within_box_simple;
}
else {
this_box_volume.geometry.intersect_function = &sample_box_intersect_advanced;
this_box_volume.geometry.within_function = &r_within_box_advanced;
}

this_box_volume.geometry.shell_points = &box_shell_points;
this_box_volume.geometry.mcdisplay_function = &mcdisplay_box_function;
this_box_volume.geometry.initialize_from_main_function = &initialize_box_geometry_from_main_component;
this_box_volume.geometry.process_rot_allocated = 0;

this_box_volume.geometry.copy_geometry_parameters = &allocate_box_storage_copy;

rot_copy(this_box_volume.geometry.rotation_matrix,ROT_A_CURRENT_COMP); //check how ROT_R_CURRENT_COMP would work
rot_transpose(ROT_A_CURRENT_COMP,this_box_volume.geometry.transpose_rotation_matrix);

// Initialize loggers
this_box_volume.loggers.num_elements = 0;

// packing the information into the global_geometry_element, which is then included in the global_geometry_list.
sprintf(global_geometry_element.name,NAME_CURRENT_COMP);
global_geometry_element.activation_counter = number_of_activations;
global_geometry_element.component_index = INDEX_CURRENT_COMP;
global_geometry_element.Volume = &this_box_volume; // Would be nicer if this m was a pointer, now we have the (small) data two places
add_element_to_geometry_list(&global_geometry_list,global_geometry_element);
}
#line 201287 "MACS_sample_kidney_box.c"
#undef number_of_activations
#undef mask_setting
#undef mask_string
#undef p_interact
#undef focus_r
#undef focus_xh
#undef focus_xw
#undef focus_ah
#undef focus_aw
#undef target_z
#undef target_y
#undef target_x
#undef target_index
#undef visualize
#undef yheight2
#undef xwidth2
#undef zdepth
#undef yheight
#undef xwidth
#undef priority
#undef material_string
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

  /* Initializations for component channel_4_analyzer_1_array_crystal_array_2. */
  SIG_MESSAGE("channel_4_analyzer_1_array_crystal_array_2 (Init)");
#define mccompcurname  channel_4_analyzer_1_array_crystal_array_2
#define mccompcurtype  Union_box
#define mccompcurindex 284
#define loop_index mccchannel_4_analyzer_1_array_crystal_array_2_loop_index
#define this_box_volume mccchannel_4_analyzer_1_array_crystal_array_2_this_box_volume
#define global_geometry_element mccchannel_4_analyzer_1_array_crystal_array_2_global_geometry_element
#define this_box_storage mccchannel_4_analyzer_1_array_crystal_array_2_this_box_storage
#define material_string mccchannel_4_analyzer_1_array_crystal_array_2_material_string
#define priority mccchannel_4_analyzer_1_array_crystal_array_2_priority
#define xwidth mccchannel_4_analyzer_1_array_crystal_array_2_xwidth
#define yheight mccchannel_4_analyzer_1_array_crystal_array_2_yheight
#define zdepth mccchannel_4_analyzer_1_array_crystal_array_2_zdepth
#define xwidth2 mccchannel_4_analyzer_1_array_crystal_array_2_xwidth2
#define yheight2 mccchannel_4_analyzer_1_array_crystal_array_2_yheight2
#define visualize mccchannel_4_analyzer_1_array_crystal_array_2_visualize
#define target_index mccchannel_4_analyzer_1_array_crystal_array_2_target_index
#define target_x mccchannel_4_analyzer_1_array_crystal_array_2_target_x
#define target_y mccchannel_4_analyzer_1_array_crystal_array_2_target_y
#define target_z mccchannel_4_analyzer_1_array_crystal_array_2_target_z
#define focus_aw mccchannel_4_analyzer_1_array_crystal_array_2_focus_aw
#define focus_ah mccchannel_4_analyzer_1_array_crystal_array_2_focus_ah
#define focus_xw mccchannel_4_analyzer_1_array_crystal_array_2_focus_xw
#define focus_xh mccchannel_4_analyzer_1_array_crystal_array_2_focus_xh
#define focus_r mccchannel_4_analyzer_1_array_crystal_array_2_focus_r
#define p_interact mccchannel_4_analyzer_1_array_crystal_array_2_p_interact
#define mask_string mccchannel_4_analyzer_1_array_crystal_array_2_mask_string
#define mask_setting mccchannel_4_analyzer_1_array_crystal_array_2_mask_setting
#define number_of_activations mccchannel_4_analyzer_1_array_crystal_array_2_number_of_activations
#line 224 "Union_box.comp"
{
// Initializes the focusing system for this volume including input sanitation.
focus_initialize(&this_box_volume.geometry, POS_A_COMP_INDEX(INDEX_CURRENT_COMP+target_index), POS_A_CURRENT_COMP, ROT_A_CURRENT_COMP, target_index, target_x, target_y, target_z, focus_aw, focus_ah, focus_xw, focus_xh, focus_r, NAME_CURRENT_COMP);

// Input sanitation for this geometry
if (xwidth <= 0) {
  printf("\nERROR in Union_box named %s, the xwidth is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (yheight <= 0) {
  printf("\nERROR in Union_box named %s, yheight is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (zdepth <= 0) {
  printf("\nERROR in Union_box named %s, zdepth is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (xwidth2 <= 0 && xwidth2 != -1) {
  printf("\nERROR in Union_box named %s, the xwidth2 is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (yheight2 <= 0 && yheight2 != -1) {
  printf("\nERROR in Union_box named %s, yheight2 is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}

// Use sanitation
if (global_material_list.num_elements == 0) {
  printf("\nERROR: Need to define a material using Union_make_material before using a Union geometry component. \n");
  printf("       %s was defined before first use of Union_make_material.\n",NAME_CURRENT_COMP);
  exit(1);
}

this_box_volume.geometry.is_masked_volume = 0;
this_box_volume.geometry.is_exit_volume = 0;
this_box_volume.geometry.is_mask_volume = 0;
// check if the volume is a mask, if it is the material string is irelevant.
if (mask_string && strlen(mask_string) && strcmp(mask_string, "NULL") && strcmp(mask_string, "0")) {
    // A mask volume is used to limit the extend of other volumes, called the masked volumes. These are specified in the mask_string.
    // In order for a ray to enter a masked volume, it needs to be both in the region covered by that volume AND the mask volume.
    // When more than
    this_box_volume.geometry.mask_mode = 1; // Default is mask mode is ALL
    if (mask_setting && strlen(mask_setting) && strcmp(mask_setting, "NULL") && strcmp(mask_setting, "0")) {
        if (strcmp(mask_setting,"ALL") == 0 || strcmp(mask_setting,"All") == 0) this_box_volume.geometry.mask_mode = 1;
        else if (strcmp(mask_setting,"ANY") == 0 || strcmp(mask_setting,"Any") == 0) this_box_volume.geometry.mask_mode = 2;
        else {
            printf("The mask_mode of component %s is set to %s, but must be either ALL or ANY.\n",NAME_CURRENT_COMP,mask_setting);
            exit(1);
        }
    }
    
    for (loop_index=0;loop_index<global_geometry_list.num_elements;loop_index++) {
        // Add mask list
        if (1 == manual_linking_function(global_geometry_list.elements[loop_index].name,mask_string)) {
            add_element_to_int_list(&this_box_volume.geometry.mask_list,global_geometry_list.elements[loop_index].component_index);
            add_element_to_int_list(&global_geometry_list.elements[loop_index].Volume->geometry.masked_by_list,INDEX_CURRENT_COMP);
            global_geometry_list.elements[loop_index].Volume->geometry.is_masked_volume = 1;
            if (this_box_volume.geometry.mask_mode == 2)
                global_geometry_list.elements[loop_index].Volume->geometry.mask_mode = 2;
            if (this_box_volume.geometry.mask_mode == 1) {
                if (global_geometry_list.elements[loop_index].Volume->geometry.is_masked_volume == 1 && global_geometry_list.elements[loop_index].Volume->geometry.mask_mode != 2)
                    // If more than one mask is added to one volume, the ANY mode overwrites the (default) ALL mode.
                    global_geometry_list.elements[loop_index].Volume->geometry.mask_mode = 1;
            }
            
            found_geometries = 1;
        }
    }
    if (found_geometries == 0) {
        printf("The mask_string in geometry: %s did not find any of the specified volumes in the mask_string %s \n",NAME_CURRENT_COMP,mask_string);
        exit(1);
    }
    this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
    this_box_volume.p_physics->is_vacuum = 0; // Makes this volume a vacuum
    this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
    this_box_volume.p_physics->my_a = 0; // Should not be used.
    sprintf(this_box_volume.p_physics->name,"Mask");
    this_box_volume.geometry.is_mask_volume = 1;
    
    
// Read the material input, or if it lacks, use automatic linking.
} else if (material_string && strlen(material_string) && strcmp(material_string, "NULL") && strcmp(material_string, "0")) {
    // A geometry string was given, use it to determine which material
    if (0 == strcmp(material_string,"vacuum") || 0 == strcmp(material_string,"Vacuum")) {
        // One could have a global physics struct for vacuum instead of creating one for each
        this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
        this_box_volume.p_physics->is_vacuum = 1; // Makes this volume a vacuum
        this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
        this_box_volume.p_physics->my_a = 0; // Should not be used.
        sprintf(this_box_volume.p_physics->name,"Vacuum");
    } else if (0 == strcmp(material_string,"exit") || 0 == strcmp(material_string,"Exit")) {
        // One could have a global physics struct for vacuum instead of creating one for each
        this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
        this_box_volume.p_physics->is_vacuum = 1; // Makes this volume a vacuum
        this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
        this_box_volume.p_physics->my_a = 0; // Should not be used.
        this_box_volume.geometry.is_exit_volume = 1;
        sprintf(this_box_volume.p_physics->name,"Exit");
    } else {
        #ifndef MATERIAL_DETECTOR
            printf("Need to define a material before refering to it in a geometry %s.\n",NAME_CURRENT_COMP);
            exit(1);
        #endif
        for (loop_index=0;loop_index<global_material_list.num_elements;loop_index++) {
            if (0 == strcmp(material_string,global_material_list.elements[loop_index].name)) {
                this_box_volume.p_physics = global_material_list.elements[loop_index].physics;
                break;
            }
            if (loop_index == global_material_list.num_elements-1) {
            printf("\n");
            printf("ERROR: The material string \"%s\" in Union geometry \"%s\" did not match a specified material. \n",material_string,NAME_CURRENT_COMP);
            printf("       The materials available at this point (need to be defined before the geometry): \n");
            for (loop_index=0;loop_index<global_material_list.num_elements;loop_index++)
              printf("         %s\n",global_material_list.elements[loop_index].name);
            printf("\n");
            printf("       It is also possible to use one of the defualt materials avaiable: \n");
            printf("           Vacuum (for a Volume without scattering or absorption)\n");
            printf("           Exit (for a Volume where the ray exits the component if it enters)\n");
            printf("           Mask (for a Volume that masks existing volumes specified in the mask_string\n");
            exit(1);
          }
        }
    }
} else {
    // Automatic linking, simply using the last defined material.
    #ifndef MATERIAL_DETECTOR
        printf("Need to define a material before the geometry to use automatic linking %s.\n",NAME_CURRENT_COMP);
        exit(1);
    #endif
    this_box_volume.p_physics = global_material_list.elements[global_material_list.num_elements-1].physics;
}

sprintf(this_box_volume.name,NAME_CURRENT_COMP);
sprintf(this_box_volume.geometry.shape,"box");
this_box_volume.geometry.priority_value = priority;
this_box_volume.geometry.geometry_p_interact = p_interact;
// Currently the coordinates will be in absolute space.
this_box_volume.geometry.center = POS_A_CURRENT_COMP;

this_box_storage.z_depth = zdepth;
this_box_storage.x_width1 = xwidth;
this_box_storage.y_height1 = yheight;

this_box_storage.is_rectangle = 0;
if (xwidth2 < 0 && yheight2 < 0) this_box_storage.is_rectangle = 1;
if (xwidth == xwidth2 && yheight == yheight2) this_box_storage.is_rectangle = 1;

if (xwidth2 < 0) {
    this_box_storage.x_width2 = xwidth;
    xwidth2 = xwidth;
} else this_box_storage.x_width2 = xwidth2;

if (yheight2 < 0) {
    this_box_storage.y_height2 = yheight;
    yheight2 = yheight;
} else this_box_storage.y_height2 = yheight2;


this_box_storage.normal_vectors[0] = coords_set(0,0,1);
this_box_storage.normal_vectors[1] = coords_set(0,0,1);

// for sides with y component = 0
x_component = 2*zdepth/sqrt((xwidth-xwidth2)*(xwidth-xwidth2)+4*zdepth*zdepth);
z_component = (xwidth-xwidth2)/sqrt(4*zdepth*zdepth+(xwidth-xwidth2)*(xwidth-xwidth2));

this_box_storage.normal_vectors[2] = coords_set(x_component,0,z_component);
this_box_storage.normal_vectors[3] = coords_set(-x_component,0,z_component);

// for sides with x component = 0
y_component = 2*zdepth/sqrt((yheight-yheight2)*(yheight-yheight2)+4*zdepth*zdepth);
z_component = (yheight-yheight2)/sqrt(4*zdepth*zdepth+(yheight-yheight2)*(yheight-yheight2));

this_box_storage.normal_vectors[4] = coords_set(0,y_component,z_component);
this_box_storage.normal_vectors[5] = coords_set(0,-y_component,z_component);

this_box_volume.geometry.visualization_on = visualize;

this_box_volume.geometry.geometry_parameters.p_box_storage = &this_box_storage;

// Assign pointers to functions for intersection with the shape, checking if a point is inside the shape
if (this_box_storage.is_rectangle == 1) {
this_box_volume.geometry.intersect_function = &sample_box_intersect_simple;
this_box_volume.geometry.within_function = &r_within_box_simple;
}
else {
this_box_volume.geometry.intersect_function = &sample_box_intersect_advanced;
this_box_volume.geometry.within_function = &r_within_box_advanced;
}

this_box_volume.geometry.shell_points = &box_shell_points;
this_box_volume.geometry.mcdisplay_function = &mcdisplay_box_function;
this_box_volume.geometry.initialize_from_main_function = &initialize_box_geometry_from_main_component;
this_box_volume.geometry.process_rot_allocated = 0;

this_box_volume.geometry.copy_geometry_parameters = &allocate_box_storage_copy;

rot_copy(this_box_volume.geometry.rotation_matrix,ROT_A_CURRENT_COMP); //check how ROT_R_CURRENT_COMP would work
rot_transpose(ROT_A_CURRENT_COMP,this_box_volume.geometry.transpose_rotation_matrix);

// Initialize loggers
this_box_volume.loggers.num_elements = 0;

// packing the information into the global_geometry_element, which is then included in the global_geometry_list.
sprintf(global_geometry_element.name,NAME_CURRENT_COMP);
global_geometry_element.activation_counter = number_of_activations;
global_geometry_element.component_index = INDEX_CURRENT_COMP;
global_geometry_element.Volume = &this_box_volume; // Would be nicer if this m was a pointer, now we have the (small) data two places
add_element_to_geometry_list(&global_geometry_list,global_geometry_element);
}
#line 201557 "MACS_sample_kidney_box.c"
#undef number_of_activations
#undef mask_setting
#undef mask_string
#undef p_interact
#undef focus_r
#undef focus_xh
#undef focus_xw
#undef focus_ah
#undef focus_aw
#undef target_z
#undef target_y
#undef target_x
#undef target_index
#undef visualize
#undef yheight2
#undef xwidth2
#undef zdepth
#undef yheight
#undef xwidth
#undef priority
#undef material_string
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

  /* Initializations for component channel_4_analyzer_1_array_crystal_array_3. */
  SIG_MESSAGE("channel_4_analyzer_1_array_crystal_array_3 (Init)");
#define mccompcurname  channel_4_analyzer_1_array_crystal_array_3
#define mccompcurtype  Union_box
#define mccompcurindex 285
#define loop_index mccchannel_4_analyzer_1_array_crystal_array_3_loop_index
#define this_box_volume mccchannel_4_analyzer_1_array_crystal_array_3_this_box_volume
#define global_geometry_element mccchannel_4_analyzer_1_array_crystal_array_3_global_geometry_element
#define this_box_storage mccchannel_4_analyzer_1_array_crystal_array_3_this_box_storage
#define material_string mccchannel_4_analyzer_1_array_crystal_array_3_material_string
#define priority mccchannel_4_analyzer_1_array_crystal_array_3_priority
#define xwidth mccchannel_4_analyzer_1_array_crystal_array_3_xwidth
#define yheight mccchannel_4_analyzer_1_array_crystal_array_3_yheight
#define zdepth mccchannel_4_analyzer_1_array_crystal_array_3_zdepth
#define xwidth2 mccchannel_4_analyzer_1_array_crystal_array_3_xwidth2
#define yheight2 mccchannel_4_analyzer_1_array_crystal_array_3_yheight2
#define visualize mccchannel_4_analyzer_1_array_crystal_array_3_visualize
#define target_index mccchannel_4_analyzer_1_array_crystal_array_3_target_index
#define target_x mccchannel_4_analyzer_1_array_crystal_array_3_target_x
#define target_y mccchannel_4_analyzer_1_array_crystal_array_3_target_y
#define target_z mccchannel_4_analyzer_1_array_crystal_array_3_target_z
#define focus_aw mccchannel_4_analyzer_1_array_crystal_array_3_focus_aw
#define focus_ah mccchannel_4_analyzer_1_array_crystal_array_3_focus_ah
#define focus_xw mccchannel_4_analyzer_1_array_crystal_array_3_focus_xw
#define focus_xh mccchannel_4_analyzer_1_array_crystal_array_3_focus_xh
#define focus_r mccchannel_4_analyzer_1_array_crystal_array_3_focus_r
#define p_interact mccchannel_4_analyzer_1_array_crystal_array_3_p_interact
#define mask_string mccchannel_4_analyzer_1_array_crystal_array_3_mask_string
#define mask_setting mccchannel_4_analyzer_1_array_crystal_array_3_mask_setting
#define number_of_activations mccchannel_4_analyzer_1_array_crystal_array_3_number_of_activations
#line 224 "Union_box.comp"
{
// Initializes the focusing system for this volume including input sanitation.
focus_initialize(&this_box_volume.geometry, POS_A_COMP_INDEX(INDEX_CURRENT_COMP+target_index), POS_A_CURRENT_COMP, ROT_A_CURRENT_COMP, target_index, target_x, target_y, target_z, focus_aw, focus_ah, focus_xw, focus_xh, focus_r, NAME_CURRENT_COMP);

// Input sanitation for this geometry
if (xwidth <= 0) {
  printf("\nERROR in Union_box named %s, the xwidth is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (yheight <= 0) {
  printf("\nERROR in Union_box named %s, yheight is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (zdepth <= 0) {
  printf("\nERROR in Union_box named %s, zdepth is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (xwidth2 <= 0 && xwidth2 != -1) {
  printf("\nERROR in Union_box named %s, the xwidth2 is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (yheight2 <= 0 && yheight2 != -1) {
  printf("\nERROR in Union_box named %s, yheight2 is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}

// Use sanitation
if (global_material_list.num_elements == 0) {
  printf("\nERROR: Need to define a material using Union_make_material before using a Union geometry component. \n");
  printf("       %s was defined before first use of Union_make_material.\n",NAME_CURRENT_COMP);
  exit(1);
}

this_box_volume.geometry.is_masked_volume = 0;
this_box_volume.geometry.is_exit_volume = 0;
this_box_volume.geometry.is_mask_volume = 0;
// check if the volume is a mask, if it is the material string is irelevant.
if (mask_string && strlen(mask_string) && strcmp(mask_string, "NULL") && strcmp(mask_string, "0")) {
    // A mask volume is used to limit the extend of other volumes, called the masked volumes. These are specified in the mask_string.
    // In order for a ray to enter a masked volume, it needs to be both in the region covered by that volume AND the mask volume.
    // When more than
    this_box_volume.geometry.mask_mode = 1; // Default is mask mode is ALL
    if (mask_setting && strlen(mask_setting) && strcmp(mask_setting, "NULL") && strcmp(mask_setting, "0")) {
        if (strcmp(mask_setting,"ALL") == 0 || strcmp(mask_setting,"All") == 0) this_box_volume.geometry.mask_mode = 1;
        else if (strcmp(mask_setting,"ANY") == 0 || strcmp(mask_setting,"Any") == 0) this_box_volume.geometry.mask_mode = 2;
        else {
            printf("The mask_mode of component %s is set to %s, but must be either ALL or ANY.\n",NAME_CURRENT_COMP,mask_setting);
            exit(1);
        }
    }
    
    for (loop_index=0;loop_index<global_geometry_list.num_elements;loop_index++) {
        // Add mask list
        if (1 == manual_linking_function(global_geometry_list.elements[loop_index].name,mask_string)) {
            add_element_to_int_list(&this_box_volume.geometry.mask_list,global_geometry_list.elements[loop_index].component_index);
            add_element_to_int_list(&global_geometry_list.elements[loop_index].Volume->geometry.masked_by_list,INDEX_CURRENT_COMP);
            global_geometry_list.elements[loop_index].Volume->geometry.is_masked_volume = 1;
            if (this_box_volume.geometry.mask_mode == 2)
                global_geometry_list.elements[loop_index].Volume->geometry.mask_mode = 2;
            if (this_box_volume.geometry.mask_mode == 1) {
                if (global_geometry_list.elements[loop_index].Volume->geometry.is_masked_volume == 1 && global_geometry_list.elements[loop_index].Volume->geometry.mask_mode != 2)
                    // If more than one mask is added to one volume, the ANY mode overwrites the (default) ALL mode.
                    global_geometry_list.elements[loop_index].Volume->geometry.mask_mode = 1;
            }
            
            found_geometries = 1;
        }
    }
    if (found_geometries == 0) {
        printf("The mask_string in geometry: %s did not find any of the specified volumes in the mask_string %s \n",NAME_CURRENT_COMP,mask_string);
        exit(1);
    }
    this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
    this_box_volume.p_physics->is_vacuum = 0; // Makes this volume a vacuum
    this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
    this_box_volume.p_physics->my_a = 0; // Should not be used.
    sprintf(this_box_volume.p_physics->name,"Mask");
    this_box_volume.geometry.is_mask_volume = 1;
    
    
// Read the material input, or if it lacks, use automatic linking.
} else if (material_string && strlen(material_string) && strcmp(material_string, "NULL") && strcmp(material_string, "0")) {
    // A geometry string was given, use it to determine which material
    if (0 == strcmp(material_string,"vacuum") || 0 == strcmp(material_string,"Vacuum")) {
        // One could have a global physics struct for vacuum instead of creating one for each
        this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
        this_box_volume.p_physics->is_vacuum = 1; // Makes this volume a vacuum
        this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
        this_box_volume.p_physics->my_a = 0; // Should not be used.
        sprintf(this_box_volume.p_physics->name,"Vacuum");
    } else if (0 == strcmp(material_string,"exit") || 0 == strcmp(material_string,"Exit")) {
        // One could have a global physics struct for vacuum instead of creating one for each
        this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
        this_box_volume.p_physics->is_vacuum = 1; // Makes this volume a vacuum
        this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
        this_box_volume.p_physics->my_a = 0; // Should not be used.
        this_box_volume.geometry.is_exit_volume = 1;
        sprintf(this_box_volume.p_physics->name,"Exit");
    } else {
        #ifndef MATERIAL_DETECTOR
            printf("Need to define a material before refering to it in a geometry %s.\n",NAME_CURRENT_COMP);
            exit(1);
        #endif
        for (loop_index=0;loop_index<global_material_list.num_elements;loop_index++) {
            if (0 == strcmp(material_string,global_material_list.elements[loop_index].name)) {
                this_box_volume.p_physics = global_material_list.elements[loop_index].physics;
                break;
            }
            if (loop_index == global_material_list.num_elements-1) {
            printf("\n");
            printf("ERROR: The material string \"%s\" in Union geometry \"%s\" did not match a specified material. \n",material_string,NAME_CURRENT_COMP);
            printf("       The materials available at this point (need to be defined before the geometry): \n");
            for (loop_index=0;loop_index<global_material_list.num_elements;loop_index++)
              printf("         %s\n",global_material_list.elements[loop_index].name);
            printf("\n");
            printf("       It is also possible to use one of the defualt materials avaiable: \n");
            printf("           Vacuum (for a Volume without scattering or absorption)\n");
            printf("           Exit (for a Volume where the ray exits the component if it enters)\n");
            printf("           Mask (for a Volume that masks existing volumes specified in the mask_string\n");
            exit(1);
          }
        }
    }
} else {
    // Automatic linking, simply using the last defined material.
    #ifndef MATERIAL_DETECTOR
        printf("Need to define a material before the geometry to use automatic linking %s.\n",NAME_CURRENT_COMP);
        exit(1);
    #endif
    this_box_volume.p_physics = global_material_list.elements[global_material_list.num_elements-1].physics;
}

sprintf(this_box_volume.name,NAME_CURRENT_COMP);
sprintf(this_box_volume.geometry.shape,"box");
this_box_volume.geometry.priority_value = priority;
this_box_volume.geometry.geometry_p_interact = p_interact;
// Currently the coordinates will be in absolute space.
this_box_volume.geometry.center = POS_A_CURRENT_COMP;

this_box_storage.z_depth = zdepth;
this_box_storage.x_width1 = xwidth;
this_box_storage.y_height1 = yheight;

this_box_storage.is_rectangle = 0;
if (xwidth2 < 0 && yheight2 < 0) this_box_storage.is_rectangle = 1;
if (xwidth == xwidth2 && yheight == yheight2) this_box_storage.is_rectangle = 1;

if (xwidth2 < 0) {
    this_box_storage.x_width2 = xwidth;
    xwidth2 = xwidth;
} else this_box_storage.x_width2 = xwidth2;

if (yheight2 < 0) {
    this_box_storage.y_height2 = yheight;
    yheight2 = yheight;
} else this_box_storage.y_height2 = yheight2;


this_box_storage.normal_vectors[0] = coords_set(0,0,1);
this_box_storage.normal_vectors[1] = coords_set(0,0,1);

// for sides with y component = 0
x_component = 2*zdepth/sqrt((xwidth-xwidth2)*(xwidth-xwidth2)+4*zdepth*zdepth);
z_component = (xwidth-xwidth2)/sqrt(4*zdepth*zdepth+(xwidth-xwidth2)*(xwidth-xwidth2));

this_box_storage.normal_vectors[2] = coords_set(x_component,0,z_component);
this_box_storage.normal_vectors[3] = coords_set(-x_component,0,z_component);

// for sides with x component = 0
y_component = 2*zdepth/sqrt((yheight-yheight2)*(yheight-yheight2)+4*zdepth*zdepth);
z_component = (yheight-yheight2)/sqrt(4*zdepth*zdepth+(yheight-yheight2)*(yheight-yheight2));

this_box_storage.normal_vectors[4] = coords_set(0,y_component,z_component);
this_box_storage.normal_vectors[5] = coords_set(0,-y_component,z_component);

this_box_volume.geometry.visualization_on = visualize;

this_box_volume.geometry.geometry_parameters.p_box_storage = &this_box_storage;

// Assign pointers to functions for intersection with the shape, checking if a point is inside the shape
if (this_box_storage.is_rectangle == 1) {
this_box_volume.geometry.intersect_function = &sample_box_intersect_simple;
this_box_volume.geometry.within_function = &r_within_box_simple;
}
else {
this_box_volume.geometry.intersect_function = &sample_box_intersect_advanced;
this_box_volume.geometry.within_function = &r_within_box_advanced;
}

this_box_volume.geometry.shell_points = &box_shell_points;
this_box_volume.geometry.mcdisplay_function = &mcdisplay_box_function;
this_box_volume.geometry.initialize_from_main_function = &initialize_box_geometry_from_main_component;
this_box_volume.geometry.process_rot_allocated = 0;

this_box_volume.geometry.copy_geometry_parameters = &allocate_box_storage_copy;

rot_copy(this_box_volume.geometry.rotation_matrix,ROT_A_CURRENT_COMP); //check how ROT_R_CURRENT_COMP would work
rot_transpose(ROT_A_CURRENT_COMP,this_box_volume.geometry.transpose_rotation_matrix);

// Initialize loggers
this_box_volume.loggers.num_elements = 0;

// packing the information into the global_geometry_element, which is then included in the global_geometry_list.
sprintf(global_geometry_element.name,NAME_CURRENT_COMP);
global_geometry_element.activation_counter = number_of_activations;
global_geometry_element.component_index = INDEX_CURRENT_COMP;
global_geometry_element.Volume = &this_box_volume; // Would be nicer if this m was a pointer, now we have the (small) data two places
add_element_to_geometry_list(&global_geometry_list,global_geometry_element);
}
#line 201827 "MACS_sample_kidney_box.c"
#undef number_of_activations
#undef mask_setting
#undef mask_string
#undef p_interact
#undef focus_r
#undef focus_xh
#undef focus_xw
#undef focus_ah
#undef focus_aw
#undef target_z
#undef target_y
#undef target_x
#undef target_index
#undef visualize
#undef yheight2
#undef xwidth2
#undef zdepth
#undef yheight
#undef xwidth
#undef priority
#undef material_string
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

  /* Initializations for component channel_4_analyzer_1_array_crystal_array_4. */
  SIG_MESSAGE("channel_4_analyzer_1_array_crystal_array_4 (Init)");
#define mccompcurname  channel_4_analyzer_1_array_crystal_array_4
#define mccompcurtype  Union_box
#define mccompcurindex 286
#define loop_index mccchannel_4_analyzer_1_array_crystal_array_4_loop_index
#define this_box_volume mccchannel_4_analyzer_1_array_crystal_array_4_this_box_volume
#define global_geometry_element mccchannel_4_analyzer_1_array_crystal_array_4_global_geometry_element
#define this_box_storage mccchannel_4_analyzer_1_array_crystal_array_4_this_box_storage
#define material_string mccchannel_4_analyzer_1_array_crystal_array_4_material_string
#define priority mccchannel_4_analyzer_1_array_crystal_array_4_priority
#define xwidth mccchannel_4_analyzer_1_array_crystal_array_4_xwidth
#define yheight mccchannel_4_analyzer_1_array_crystal_array_4_yheight
#define zdepth mccchannel_4_analyzer_1_array_crystal_array_4_zdepth
#define xwidth2 mccchannel_4_analyzer_1_array_crystal_array_4_xwidth2
#define yheight2 mccchannel_4_analyzer_1_array_crystal_array_4_yheight2
#define visualize mccchannel_4_analyzer_1_array_crystal_array_4_visualize
#define target_index mccchannel_4_analyzer_1_array_crystal_array_4_target_index
#define target_x mccchannel_4_analyzer_1_array_crystal_array_4_target_x
#define target_y mccchannel_4_analyzer_1_array_crystal_array_4_target_y
#define target_z mccchannel_4_analyzer_1_array_crystal_array_4_target_z
#define focus_aw mccchannel_4_analyzer_1_array_crystal_array_4_focus_aw
#define focus_ah mccchannel_4_analyzer_1_array_crystal_array_4_focus_ah
#define focus_xw mccchannel_4_analyzer_1_array_crystal_array_4_focus_xw
#define focus_xh mccchannel_4_analyzer_1_array_crystal_array_4_focus_xh
#define focus_r mccchannel_4_analyzer_1_array_crystal_array_4_focus_r
#define p_interact mccchannel_4_analyzer_1_array_crystal_array_4_p_interact
#define mask_string mccchannel_4_analyzer_1_array_crystal_array_4_mask_string
#define mask_setting mccchannel_4_analyzer_1_array_crystal_array_4_mask_setting
#define number_of_activations mccchannel_4_analyzer_1_array_crystal_array_4_number_of_activations
#line 224 "Union_box.comp"
{
// Initializes the focusing system for this volume including input sanitation.
focus_initialize(&this_box_volume.geometry, POS_A_COMP_INDEX(INDEX_CURRENT_COMP+target_index), POS_A_CURRENT_COMP, ROT_A_CURRENT_COMP, target_index, target_x, target_y, target_z, focus_aw, focus_ah, focus_xw, focus_xh, focus_r, NAME_CURRENT_COMP);

// Input sanitation for this geometry
if (xwidth <= 0) {
  printf("\nERROR in Union_box named %s, the xwidth is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (yheight <= 0) {
  printf("\nERROR in Union_box named %s, yheight is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (zdepth <= 0) {
  printf("\nERROR in Union_box named %s, zdepth is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (xwidth2 <= 0 && xwidth2 != -1) {
  printf("\nERROR in Union_box named %s, the xwidth2 is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (yheight2 <= 0 && yheight2 != -1) {
  printf("\nERROR in Union_box named %s, yheight2 is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}

// Use sanitation
if (global_material_list.num_elements == 0) {
  printf("\nERROR: Need to define a material using Union_make_material before using a Union geometry component. \n");
  printf("       %s was defined before first use of Union_make_material.\n",NAME_CURRENT_COMP);
  exit(1);
}

this_box_volume.geometry.is_masked_volume = 0;
this_box_volume.geometry.is_exit_volume = 0;
this_box_volume.geometry.is_mask_volume = 0;
// check if the volume is a mask, if it is the material string is irelevant.
if (mask_string && strlen(mask_string) && strcmp(mask_string, "NULL") && strcmp(mask_string, "0")) {
    // A mask volume is used to limit the extend of other volumes, called the masked volumes. These are specified in the mask_string.
    // In order for a ray to enter a masked volume, it needs to be both in the region covered by that volume AND the mask volume.
    // When more than
    this_box_volume.geometry.mask_mode = 1; // Default is mask mode is ALL
    if (mask_setting && strlen(mask_setting) && strcmp(mask_setting, "NULL") && strcmp(mask_setting, "0")) {
        if (strcmp(mask_setting,"ALL") == 0 || strcmp(mask_setting,"All") == 0) this_box_volume.geometry.mask_mode = 1;
        else if (strcmp(mask_setting,"ANY") == 0 || strcmp(mask_setting,"Any") == 0) this_box_volume.geometry.mask_mode = 2;
        else {
            printf("The mask_mode of component %s is set to %s, but must be either ALL or ANY.\n",NAME_CURRENT_COMP,mask_setting);
            exit(1);
        }
    }
    
    for (loop_index=0;loop_index<global_geometry_list.num_elements;loop_index++) {
        // Add mask list
        if (1 == manual_linking_function(global_geometry_list.elements[loop_index].name,mask_string)) {
            add_element_to_int_list(&this_box_volume.geometry.mask_list,global_geometry_list.elements[loop_index].component_index);
            add_element_to_int_list(&global_geometry_list.elements[loop_index].Volume->geometry.masked_by_list,INDEX_CURRENT_COMP);
            global_geometry_list.elements[loop_index].Volume->geometry.is_masked_volume = 1;
            if (this_box_volume.geometry.mask_mode == 2)
                global_geometry_list.elements[loop_index].Volume->geometry.mask_mode = 2;
            if (this_box_volume.geometry.mask_mode == 1) {
                if (global_geometry_list.elements[loop_index].Volume->geometry.is_masked_volume == 1 && global_geometry_list.elements[loop_index].Volume->geometry.mask_mode != 2)
                    // If more than one mask is added to one volume, the ANY mode overwrites the (default) ALL mode.
                    global_geometry_list.elements[loop_index].Volume->geometry.mask_mode = 1;
            }
            
            found_geometries = 1;
        }
    }
    if (found_geometries == 0) {
        printf("The mask_string in geometry: %s did not find any of the specified volumes in the mask_string %s \n",NAME_CURRENT_COMP,mask_string);
        exit(1);
    }
    this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
    this_box_volume.p_physics->is_vacuum = 0; // Makes this volume a vacuum
    this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
    this_box_volume.p_physics->my_a = 0; // Should not be used.
    sprintf(this_box_volume.p_physics->name,"Mask");
    this_box_volume.geometry.is_mask_volume = 1;
    
    
// Read the material input, or if it lacks, use automatic linking.
} else if (material_string && strlen(material_string) && strcmp(material_string, "NULL") && strcmp(material_string, "0")) {
    // A geometry string was given, use it to determine which material
    if (0 == strcmp(material_string,"vacuum") || 0 == strcmp(material_string,"Vacuum")) {
        // One could have a global physics struct for vacuum instead of creating one for each
        this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
        this_box_volume.p_physics->is_vacuum = 1; // Makes this volume a vacuum
        this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
        this_box_volume.p_physics->my_a = 0; // Should not be used.
        sprintf(this_box_volume.p_physics->name,"Vacuum");
    } else if (0 == strcmp(material_string,"exit") || 0 == strcmp(material_string,"Exit")) {
        // One could have a global physics struct for vacuum instead of creating one for each
        this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
        this_box_volume.p_physics->is_vacuum = 1; // Makes this volume a vacuum
        this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
        this_box_volume.p_physics->my_a = 0; // Should not be used.
        this_box_volume.geometry.is_exit_volume = 1;
        sprintf(this_box_volume.p_physics->name,"Exit");
    } else {
        #ifndef MATERIAL_DETECTOR
            printf("Need to define a material before refering to it in a geometry %s.\n",NAME_CURRENT_COMP);
            exit(1);
        #endif
        for (loop_index=0;loop_index<global_material_list.num_elements;loop_index++) {
            if (0 == strcmp(material_string,global_material_list.elements[loop_index].name)) {
                this_box_volume.p_physics = global_material_list.elements[loop_index].physics;
                break;
            }
            if (loop_index == global_material_list.num_elements-1) {
            printf("\n");
            printf("ERROR: The material string \"%s\" in Union geometry \"%s\" did not match a specified material. \n",material_string,NAME_CURRENT_COMP);
            printf("       The materials available at this point (need to be defined before the geometry): \n");
            for (loop_index=0;loop_index<global_material_list.num_elements;loop_index++)
              printf("         %s\n",global_material_list.elements[loop_index].name);
            printf("\n");
            printf("       It is also possible to use one of the defualt materials avaiable: \n");
            printf("           Vacuum (for a Volume without scattering or absorption)\n");
            printf("           Exit (for a Volume where the ray exits the component if it enters)\n");
            printf("           Mask (for a Volume that masks existing volumes specified in the mask_string\n");
            exit(1);
          }
        }
    }
} else {
    // Automatic linking, simply using the last defined material.
    #ifndef MATERIAL_DETECTOR
        printf("Need to define a material before the geometry to use automatic linking %s.\n",NAME_CURRENT_COMP);
        exit(1);
    #endif
    this_box_volume.p_physics = global_material_list.elements[global_material_list.num_elements-1].physics;
}

sprintf(this_box_volume.name,NAME_CURRENT_COMP);
sprintf(this_box_volume.geometry.shape,"box");
this_box_volume.geometry.priority_value = priority;
this_box_volume.geometry.geometry_p_interact = p_interact;
// Currently the coordinates will be in absolute space.
this_box_volume.geometry.center = POS_A_CURRENT_COMP;

this_box_storage.z_depth = zdepth;
this_box_storage.x_width1 = xwidth;
this_box_storage.y_height1 = yheight;

this_box_storage.is_rectangle = 0;
if (xwidth2 < 0 && yheight2 < 0) this_box_storage.is_rectangle = 1;
if (xwidth == xwidth2 && yheight == yheight2) this_box_storage.is_rectangle = 1;

if (xwidth2 < 0) {
    this_box_storage.x_width2 = xwidth;
    xwidth2 = xwidth;
} else this_box_storage.x_width2 = xwidth2;

if (yheight2 < 0) {
    this_box_storage.y_height2 = yheight;
    yheight2 = yheight;
} else this_box_storage.y_height2 = yheight2;


this_box_storage.normal_vectors[0] = coords_set(0,0,1);
this_box_storage.normal_vectors[1] = coords_set(0,0,1);

// for sides with y component = 0
x_component = 2*zdepth/sqrt((xwidth-xwidth2)*(xwidth-xwidth2)+4*zdepth*zdepth);
z_component = (xwidth-xwidth2)/sqrt(4*zdepth*zdepth+(xwidth-xwidth2)*(xwidth-xwidth2));

this_box_storage.normal_vectors[2] = coords_set(x_component,0,z_component);
this_box_storage.normal_vectors[3] = coords_set(-x_component,0,z_component);

// for sides with x component = 0
y_component = 2*zdepth/sqrt((yheight-yheight2)*(yheight-yheight2)+4*zdepth*zdepth);
z_component = (yheight-yheight2)/sqrt(4*zdepth*zdepth+(yheight-yheight2)*(yheight-yheight2));

this_box_storage.normal_vectors[4] = coords_set(0,y_component,z_component);
this_box_storage.normal_vectors[5] = coords_set(0,-y_component,z_component);

this_box_volume.geometry.visualization_on = visualize;

this_box_volume.geometry.geometry_parameters.p_box_storage = &this_box_storage;

// Assign pointers to functions for intersection with the shape, checking if a point is inside the shape
if (this_box_storage.is_rectangle == 1) {
this_box_volume.geometry.intersect_function = &sample_box_intersect_simple;
this_box_volume.geometry.within_function = &r_within_box_simple;
}
else {
this_box_volume.geometry.intersect_function = &sample_box_intersect_advanced;
this_box_volume.geometry.within_function = &r_within_box_advanced;
}

this_box_volume.geometry.shell_points = &box_shell_points;
this_box_volume.geometry.mcdisplay_function = &mcdisplay_box_function;
this_box_volume.geometry.initialize_from_main_function = &initialize_box_geometry_from_main_component;
this_box_volume.geometry.process_rot_allocated = 0;

this_box_volume.geometry.copy_geometry_parameters = &allocate_box_storage_copy;

rot_copy(this_box_volume.geometry.rotation_matrix,ROT_A_CURRENT_COMP); //check how ROT_R_CURRENT_COMP would work
rot_transpose(ROT_A_CURRENT_COMP,this_box_volume.geometry.transpose_rotation_matrix);

// Initialize loggers
this_box_volume.loggers.num_elements = 0;

// packing the information into the global_geometry_element, which is then included in the global_geometry_list.
sprintf(global_geometry_element.name,NAME_CURRENT_COMP);
global_geometry_element.activation_counter = number_of_activations;
global_geometry_element.component_index = INDEX_CURRENT_COMP;
global_geometry_element.Volume = &this_box_volume; // Would be nicer if this m was a pointer, now we have the (small) data two places
add_element_to_geometry_list(&global_geometry_list,global_geometry_element);
}
#line 202097 "MACS_sample_kidney_box.c"
#undef number_of_activations
#undef mask_setting
#undef mask_string
#undef p_interact
#undef focus_r
#undef focus_xh
#undef focus_xw
#undef focus_ah
#undef focus_aw
#undef target_z
#undef target_y
#undef target_x
#undef target_index
#undef visualize
#undef yheight2
#undef xwidth2
#undef zdepth
#undef yheight
#undef xwidth
#undef priority
#undef material_string
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

  /* Initializations for component channel_4_analyzer_1_array_crystal_array_5. */
  SIG_MESSAGE("channel_4_analyzer_1_array_crystal_array_5 (Init)");
#define mccompcurname  channel_4_analyzer_1_array_crystal_array_5
#define mccompcurtype  Union_box
#define mccompcurindex 287
#define loop_index mccchannel_4_analyzer_1_array_crystal_array_5_loop_index
#define this_box_volume mccchannel_4_analyzer_1_array_crystal_array_5_this_box_volume
#define global_geometry_element mccchannel_4_analyzer_1_array_crystal_array_5_global_geometry_element
#define this_box_storage mccchannel_4_analyzer_1_array_crystal_array_5_this_box_storage
#define material_string mccchannel_4_analyzer_1_array_crystal_array_5_material_string
#define priority mccchannel_4_analyzer_1_array_crystal_array_5_priority
#define xwidth mccchannel_4_analyzer_1_array_crystal_array_5_xwidth
#define yheight mccchannel_4_analyzer_1_array_crystal_array_5_yheight
#define zdepth mccchannel_4_analyzer_1_array_crystal_array_5_zdepth
#define xwidth2 mccchannel_4_analyzer_1_array_crystal_array_5_xwidth2
#define yheight2 mccchannel_4_analyzer_1_array_crystal_array_5_yheight2
#define visualize mccchannel_4_analyzer_1_array_crystal_array_5_visualize
#define target_index mccchannel_4_analyzer_1_array_crystal_array_5_target_index
#define target_x mccchannel_4_analyzer_1_array_crystal_array_5_target_x
#define target_y mccchannel_4_analyzer_1_array_crystal_array_5_target_y
#define target_z mccchannel_4_analyzer_1_array_crystal_array_5_target_z
#define focus_aw mccchannel_4_analyzer_1_array_crystal_array_5_focus_aw
#define focus_ah mccchannel_4_analyzer_1_array_crystal_array_5_focus_ah
#define focus_xw mccchannel_4_analyzer_1_array_crystal_array_5_focus_xw
#define focus_xh mccchannel_4_analyzer_1_array_crystal_array_5_focus_xh
#define focus_r mccchannel_4_analyzer_1_array_crystal_array_5_focus_r
#define p_interact mccchannel_4_analyzer_1_array_crystal_array_5_p_interact
#define mask_string mccchannel_4_analyzer_1_array_crystal_array_5_mask_string
#define mask_setting mccchannel_4_analyzer_1_array_crystal_array_5_mask_setting
#define number_of_activations mccchannel_4_analyzer_1_array_crystal_array_5_number_of_activations
#line 224 "Union_box.comp"
{
// Initializes the focusing system for this volume including input sanitation.
focus_initialize(&this_box_volume.geometry, POS_A_COMP_INDEX(INDEX_CURRENT_COMP+target_index), POS_A_CURRENT_COMP, ROT_A_CURRENT_COMP, target_index, target_x, target_y, target_z, focus_aw, focus_ah, focus_xw, focus_xh, focus_r, NAME_CURRENT_COMP);

// Input sanitation for this geometry
if (xwidth <= 0) {
  printf("\nERROR in Union_box named %s, the xwidth is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (yheight <= 0) {
  printf("\nERROR in Union_box named %s, yheight is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (zdepth <= 0) {
  printf("\nERROR in Union_box named %s, zdepth is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (xwidth2 <= 0 && xwidth2 != -1) {
  printf("\nERROR in Union_box named %s, the xwidth2 is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (yheight2 <= 0 && yheight2 != -1) {
  printf("\nERROR in Union_box named %s, yheight2 is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}

// Use sanitation
if (global_material_list.num_elements == 0) {
  printf("\nERROR: Need to define a material using Union_make_material before using a Union geometry component. \n");
  printf("       %s was defined before first use of Union_make_material.\n",NAME_CURRENT_COMP);
  exit(1);
}

this_box_volume.geometry.is_masked_volume = 0;
this_box_volume.geometry.is_exit_volume = 0;
this_box_volume.geometry.is_mask_volume = 0;
// check if the volume is a mask, if it is the material string is irelevant.
if (mask_string && strlen(mask_string) && strcmp(mask_string, "NULL") && strcmp(mask_string, "0")) {
    // A mask volume is used to limit the extend of other volumes, called the masked volumes. These are specified in the mask_string.
    // In order for a ray to enter a masked volume, it needs to be both in the region covered by that volume AND the mask volume.
    // When more than
    this_box_volume.geometry.mask_mode = 1; // Default is mask mode is ALL
    if (mask_setting && strlen(mask_setting) && strcmp(mask_setting, "NULL") && strcmp(mask_setting, "0")) {
        if (strcmp(mask_setting,"ALL") == 0 || strcmp(mask_setting,"All") == 0) this_box_volume.geometry.mask_mode = 1;
        else if (strcmp(mask_setting,"ANY") == 0 || strcmp(mask_setting,"Any") == 0) this_box_volume.geometry.mask_mode = 2;
        else {
            printf("The mask_mode of component %s is set to %s, but must be either ALL or ANY.\n",NAME_CURRENT_COMP,mask_setting);
            exit(1);
        }
    }
    
    for (loop_index=0;loop_index<global_geometry_list.num_elements;loop_index++) {
        // Add mask list
        if (1 == manual_linking_function(global_geometry_list.elements[loop_index].name,mask_string)) {
            add_element_to_int_list(&this_box_volume.geometry.mask_list,global_geometry_list.elements[loop_index].component_index);
            add_element_to_int_list(&global_geometry_list.elements[loop_index].Volume->geometry.masked_by_list,INDEX_CURRENT_COMP);
            global_geometry_list.elements[loop_index].Volume->geometry.is_masked_volume = 1;
            if (this_box_volume.geometry.mask_mode == 2)
                global_geometry_list.elements[loop_index].Volume->geometry.mask_mode = 2;
            if (this_box_volume.geometry.mask_mode == 1) {
                if (global_geometry_list.elements[loop_index].Volume->geometry.is_masked_volume == 1 && global_geometry_list.elements[loop_index].Volume->geometry.mask_mode != 2)
                    // If more than one mask is added to one volume, the ANY mode overwrites the (default) ALL mode.
                    global_geometry_list.elements[loop_index].Volume->geometry.mask_mode = 1;
            }
            
            found_geometries = 1;
        }
    }
    if (found_geometries == 0) {
        printf("The mask_string in geometry: %s did not find any of the specified volumes in the mask_string %s \n",NAME_CURRENT_COMP,mask_string);
        exit(1);
    }
    this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
    this_box_volume.p_physics->is_vacuum = 0; // Makes this volume a vacuum
    this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
    this_box_volume.p_physics->my_a = 0; // Should not be used.
    sprintf(this_box_volume.p_physics->name,"Mask");
    this_box_volume.geometry.is_mask_volume = 1;
    
    
// Read the material input, or if it lacks, use automatic linking.
} else if (material_string && strlen(material_string) && strcmp(material_string, "NULL") && strcmp(material_string, "0")) {
    // A geometry string was given, use it to determine which material
    if (0 == strcmp(material_string,"vacuum") || 0 == strcmp(material_string,"Vacuum")) {
        // One could have a global physics struct for vacuum instead of creating one for each
        this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
        this_box_volume.p_physics->is_vacuum = 1; // Makes this volume a vacuum
        this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
        this_box_volume.p_physics->my_a = 0; // Should not be used.
        sprintf(this_box_volume.p_physics->name,"Vacuum");
    } else if (0 == strcmp(material_string,"exit") || 0 == strcmp(material_string,"Exit")) {
        // One could have a global physics struct for vacuum instead of creating one for each
        this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
        this_box_volume.p_physics->is_vacuum = 1; // Makes this volume a vacuum
        this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
        this_box_volume.p_physics->my_a = 0; // Should not be used.
        this_box_volume.geometry.is_exit_volume = 1;
        sprintf(this_box_volume.p_physics->name,"Exit");
    } else {
        #ifndef MATERIAL_DETECTOR
            printf("Need to define a material before refering to it in a geometry %s.\n",NAME_CURRENT_COMP);
            exit(1);
        #endif
        for (loop_index=0;loop_index<global_material_list.num_elements;loop_index++) {
            if (0 == strcmp(material_string,global_material_list.elements[loop_index].name)) {
                this_box_volume.p_physics = global_material_list.elements[loop_index].physics;
                break;
            }
            if (loop_index == global_material_list.num_elements-1) {
            printf("\n");
            printf("ERROR: The material string \"%s\" in Union geometry \"%s\" did not match a specified material. \n",material_string,NAME_CURRENT_COMP);
            printf("       The materials available at this point (need to be defined before the geometry): \n");
            for (loop_index=0;loop_index<global_material_list.num_elements;loop_index++)
              printf("         %s\n",global_material_list.elements[loop_index].name);
            printf("\n");
            printf("       It is also possible to use one of the defualt materials avaiable: \n");
            printf("           Vacuum (for a Volume without scattering or absorption)\n");
            printf("           Exit (for a Volume where the ray exits the component if it enters)\n");
            printf("           Mask (for a Volume that masks existing volumes specified in the mask_string\n");
            exit(1);
          }
        }
    }
} else {
    // Automatic linking, simply using the last defined material.
    #ifndef MATERIAL_DETECTOR
        printf("Need to define a material before the geometry to use automatic linking %s.\n",NAME_CURRENT_COMP);
        exit(1);
    #endif
    this_box_volume.p_physics = global_material_list.elements[global_material_list.num_elements-1].physics;
}

sprintf(this_box_volume.name,NAME_CURRENT_COMP);
sprintf(this_box_volume.geometry.shape,"box");
this_box_volume.geometry.priority_value = priority;
this_box_volume.geometry.geometry_p_interact = p_interact;
// Currently the coordinates will be in absolute space.
this_box_volume.geometry.center = POS_A_CURRENT_COMP;

this_box_storage.z_depth = zdepth;
this_box_storage.x_width1 = xwidth;
this_box_storage.y_height1 = yheight;

this_box_storage.is_rectangle = 0;
if (xwidth2 < 0 && yheight2 < 0) this_box_storage.is_rectangle = 1;
if (xwidth == xwidth2 && yheight == yheight2) this_box_storage.is_rectangle = 1;

if (xwidth2 < 0) {
    this_box_storage.x_width2 = xwidth;
    xwidth2 = xwidth;
} else this_box_storage.x_width2 = xwidth2;

if (yheight2 < 0) {
    this_box_storage.y_height2 = yheight;
    yheight2 = yheight;
} else this_box_storage.y_height2 = yheight2;


this_box_storage.normal_vectors[0] = coords_set(0,0,1);
this_box_storage.normal_vectors[1] = coords_set(0,0,1);

// for sides with y component = 0
x_component = 2*zdepth/sqrt((xwidth-xwidth2)*(xwidth-xwidth2)+4*zdepth*zdepth);
z_component = (xwidth-xwidth2)/sqrt(4*zdepth*zdepth+(xwidth-xwidth2)*(xwidth-xwidth2));

this_box_storage.normal_vectors[2] = coords_set(x_component,0,z_component);
this_box_storage.normal_vectors[3] = coords_set(-x_component,0,z_component);

// for sides with x component = 0
y_component = 2*zdepth/sqrt((yheight-yheight2)*(yheight-yheight2)+4*zdepth*zdepth);
z_component = (yheight-yheight2)/sqrt(4*zdepth*zdepth+(yheight-yheight2)*(yheight-yheight2));

this_box_storage.normal_vectors[4] = coords_set(0,y_component,z_component);
this_box_storage.normal_vectors[5] = coords_set(0,-y_component,z_component);

this_box_volume.geometry.visualization_on = visualize;

this_box_volume.geometry.geometry_parameters.p_box_storage = &this_box_storage;

// Assign pointers to functions for intersection with the shape, checking if a point is inside the shape
if (this_box_storage.is_rectangle == 1) {
this_box_volume.geometry.intersect_function = &sample_box_intersect_simple;
this_box_volume.geometry.within_function = &r_within_box_simple;
}
else {
this_box_volume.geometry.intersect_function = &sample_box_intersect_advanced;
this_box_volume.geometry.within_function = &r_within_box_advanced;
}

this_box_volume.geometry.shell_points = &box_shell_points;
this_box_volume.geometry.mcdisplay_function = &mcdisplay_box_function;
this_box_volume.geometry.initialize_from_main_function = &initialize_box_geometry_from_main_component;
this_box_volume.geometry.process_rot_allocated = 0;

this_box_volume.geometry.copy_geometry_parameters = &allocate_box_storage_copy;

rot_copy(this_box_volume.geometry.rotation_matrix,ROT_A_CURRENT_COMP); //check how ROT_R_CURRENT_COMP would work
rot_transpose(ROT_A_CURRENT_COMP,this_box_volume.geometry.transpose_rotation_matrix);

// Initialize loggers
this_box_volume.loggers.num_elements = 0;

// packing the information into the global_geometry_element, which is then included in the global_geometry_list.
sprintf(global_geometry_element.name,NAME_CURRENT_COMP);
global_geometry_element.activation_counter = number_of_activations;
global_geometry_element.component_index = INDEX_CURRENT_COMP;
global_geometry_element.Volume = &this_box_volume; // Would be nicer if this m was a pointer, now we have the (small) data two places
add_element_to_geometry_list(&global_geometry_list,global_geometry_element);
}
#line 202367 "MACS_sample_kidney_box.c"
#undef number_of_activations
#undef mask_setting
#undef mask_string
#undef p_interact
#undef focus_r
#undef focus_xh
#undef focus_xw
#undef focus_ah
#undef focus_aw
#undef target_z
#undef target_y
#undef target_x
#undef target_index
#undef visualize
#undef yheight2
#undef xwidth2
#undef zdepth
#undef yheight
#undef xwidth
#undef priority
#undef material_string
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

  /* Initializations for component channel_4_analyzer_1_array_crystal_array_6. */
  SIG_MESSAGE("channel_4_analyzer_1_array_crystal_array_6 (Init)");
#define mccompcurname  channel_4_analyzer_1_array_crystal_array_6
#define mccompcurtype  Union_box
#define mccompcurindex 288
#define loop_index mccchannel_4_analyzer_1_array_crystal_array_6_loop_index
#define this_box_volume mccchannel_4_analyzer_1_array_crystal_array_6_this_box_volume
#define global_geometry_element mccchannel_4_analyzer_1_array_crystal_array_6_global_geometry_element
#define this_box_storage mccchannel_4_analyzer_1_array_crystal_array_6_this_box_storage
#define material_string mccchannel_4_analyzer_1_array_crystal_array_6_material_string
#define priority mccchannel_4_analyzer_1_array_crystal_array_6_priority
#define xwidth mccchannel_4_analyzer_1_array_crystal_array_6_xwidth
#define yheight mccchannel_4_analyzer_1_array_crystal_array_6_yheight
#define zdepth mccchannel_4_analyzer_1_array_crystal_array_6_zdepth
#define xwidth2 mccchannel_4_analyzer_1_array_crystal_array_6_xwidth2
#define yheight2 mccchannel_4_analyzer_1_array_crystal_array_6_yheight2
#define visualize mccchannel_4_analyzer_1_array_crystal_array_6_visualize
#define target_index mccchannel_4_analyzer_1_array_crystal_array_6_target_index
#define target_x mccchannel_4_analyzer_1_array_crystal_array_6_target_x
#define target_y mccchannel_4_analyzer_1_array_crystal_array_6_target_y
#define target_z mccchannel_4_analyzer_1_array_crystal_array_6_target_z
#define focus_aw mccchannel_4_analyzer_1_array_crystal_array_6_focus_aw
#define focus_ah mccchannel_4_analyzer_1_array_crystal_array_6_focus_ah
#define focus_xw mccchannel_4_analyzer_1_array_crystal_array_6_focus_xw
#define focus_xh mccchannel_4_analyzer_1_array_crystal_array_6_focus_xh
#define focus_r mccchannel_4_analyzer_1_array_crystal_array_6_focus_r
#define p_interact mccchannel_4_analyzer_1_array_crystal_array_6_p_interact
#define mask_string mccchannel_4_analyzer_1_array_crystal_array_6_mask_string
#define mask_setting mccchannel_4_analyzer_1_array_crystal_array_6_mask_setting
#define number_of_activations mccchannel_4_analyzer_1_array_crystal_array_6_number_of_activations
#line 224 "Union_box.comp"
{
// Initializes the focusing system for this volume including input sanitation.
focus_initialize(&this_box_volume.geometry, POS_A_COMP_INDEX(INDEX_CURRENT_COMP+target_index), POS_A_CURRENT_COMP, ROT_A_CURRENT_COMP, target_index, target_x, target_y, target_z, focus_aw, focus_ah, focus_xw, focus_xh, focus_r, NAME_CURRENT_COMP);

// Input sanitation for this geometry
if (xwidth <= 0) {
  printf("\nERROR in Union_box named %s, the xwidth is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (yheight <= 0) {
  printf("\nERROR in Union_box named %s, yheight is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (zdepth <= 0) {
  printf("\nERROR in Union_box named %s, zdepth is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (xwidth2 <= 0 && xwidth2 != -1) {
  printf("\nERROR in Union_box named %s, the xwidth2 is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (yheight2 <= 0 && yheight2 != -1) {
  printf("\nERROR in Union_box named %s, yheight2 is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}

// Use sanitation
if (global_material_list.num_elements == 0) {
  printf("\nERROR: Need to define a material using Union_make_material before using a Union geometry component. \n");
  printf("       %s was defined before first use of Union_make_material.\n",NAME_CURRENT_COMP);
  exit(1);
}

this_box_volume.geometry.is_masked_volume = 0;
this_box_volume.geometry.is_exit_volume = 0;
this_box_volume.geometry.is_mask_volume = 0;
// check if the volume is a mask, if it is the material string is irelevant.
if (mask_string && strlen(mask_string) && strcmp(mask_string, "NULL") && strcmp(mask_string, "0")) {
    // A mask volume is used to limit the extend of other volumes, called the masked volumes. These are specified in the mask_string.
    // In order for a ray to enter a masked volume, it needs to be both in the region covered by that volume AND the mask volume.
    // When more than
    this_box_volume.geometry.mask_mode = 1; // Default is mask mode is ALL
    if (mask_setting && strlen(mask_setting) && strcmp(mask_setting, "NULL") && strcmp(mask_setting, "0")) {
        if (strcmp(mask_setting,"ALL") == 0 || strcmp(mask_setting,"All") == 0) this_box_volume.geometry.mask_mode = 1;
        else if (strcmp(mask_setting,"ANY") == 0 || strcmp(mask_setting,"Any") == 0) this_box_volume.geometry.mask_mode = 2;
        else {
            printf("The mask_mode of component %s is set to %s, but must be either ALL or ANY.\n",NAME_CURRENT_COMP,mask_setting);
            exit(1);
        }
    }
    
    for (loop_index=0;loop_index<global_geometry_list.num_elements;loop_index++) {
        // Add mask list
        if (1 == manual_linking_function(global_geometry_list.elements[loop_index].name,mask_string)) {
            add_element_to_int_list(&this_box_volume.geometry.mask_list,global_geometry_list.elements[loop_index].component_index);
            add_element_to_int_list(&global_geometry_list.elements[loop_index].Volume->geometry.masked_by_list,INDEX_CURRENT_COMP);
            global_geometry_list.elements[loop_index].Volume->geometry.is_masked_volume = 1;
            if (this_box_volume.geometry.mask_mode == 2)
                global_geometry_list.elements[loop_index].Volume->geometry.mask_mode = 2;
            if (this_box_volume.geometry.mask_mode == 1) {
                if (global_geometry_list.elements[loop_index].Volume->geometry.is_masked_volume == 1 && global_geometry_list.elements[loop_index].Volume->geometry.mask_mode != 2)
                    // If more than one mask is added to one volume, the ANY mode overwrites the (default) ALL mode.
                    global_geometry_list.elements[loop_index].Volume->geometry.mask_mode = 1;
            }
            
            found_geometries = 1;
        }
    }
    if (found_geometries == 0) {
        printf("The mask_string in geometry: %s did not find any of the specified volumes in the mask_string %s \n",NAME_CURRENT_COMP,mask_string);
        exit(1);
    }
    this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
    this_box_volume.p_physics->is_vacuum = 0; // Makes this volume a vacuum
    this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
    this_box_volume.p_physics->my_a = 0; // Should not be used.
    sprintf(this_box_volume.p_physics->name,"Mask");
    this_box_volume.geometry.is_mask_volume = 1;
    
    
// Read the material input, or if it lacks, use automatic linking.
} else if (material_string && strlen(material_string) && strcmp(material_string, "NULL") && strcmp(material_string, "0")) {
    // A geometry string was given, use it to determine which material
    if (0 == strcmp(material_string,"vacuum") || 0 == strcmp(material_string,"Vacuum")) {
        // One could have a global physics struct for vacuum instead of creating one for each
        this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
        this_box_volume.p_physics->is_vacuum = 1; // Makes this volume a vacuum
        this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
        this_box_volume.p_physics->my_a = 0; // Should not be used.
        sprintf(this_box_volume.p_physics->name,"Vacuum");
    } else if (0 == strcmp(material_string,"exit") || 0 == strcmp(material_string,"Exit")) {
        // One could have a global physics struct for vacuum instead of creating one for each
        this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
        this_box_volume.p_physics->is_vacuum = 1; // Makes this volume a vacuum
        this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
        this_box_volume.p_physics->my_a = 0; // Should not be used.
        this_box_volume.geometry.is_exit_volume = 1;
        sprintf(this_box_volume.p_physics->name,"Exit");
    } else {
        #ifndef MATERIAL_DETECTOR
            printf("Need to define a material before refering to it in a geometry %s.\n",NAME_CURRENT_COMP);
            exit(1);
        #endif
        for (loop_index=0;loop_index<global_material_list.num_elements;loop_index++) {
            if (0 == strcmp(material_string,global_material_list.elements[loop_index].name)) {
                this_box_volume.p_physics = global_material_list.elements[loop_index].physics;
                break;
            }
            if (loop_index == global_material_list.num_elements-1) {
            printf("\n");
            printf("ERROR: The material string \"%s\" in Union geometry \"%s\" did not match a specified material. \n",material_string,NAME_CURRENT_COMP);
            printf("       The materials available at this point (need to be defined before the geometry): \n");
            for (loop_index=0;loop_index<global_material_list.num_elements;loop_index++)
              printf("         %s\n",global_material_list.elements[loop_index].name);
            printf("\n");
            printf("       It is also possible to use one of the defualt materials avaiable: \n");
            printf("           Vacuum (for a Volume without scattering or absorption)\n");
            printf("           Exit (for a Volume where the ray exits the component if it enters)\n");
            printf("           Mask (for a Volume that masks existing volumes specified in the mask_string\n");
            exit(1);
          }
        }
    }
} else {
    // Automatic linking, simply using the last defined material.
    #ifndef MATERIAL_DETECTOR
        printf("Need to define a material before the geometry to use automatic linking %s.\n",NAME_CURRENT_COMP);
        exit(1);
    #endif
    this_box_volume.p_physics = global_material_list.elements[global_material_list.num_elements-1].physics;
}

sprintf(this_box_volume.name,NAME_CURRENT_COMP);
sprintf(this_box_volume.geometry.shape,"box");
this_box_volume.geometry.priority_value = priority;
this_box_volume.geometry.geometry_p_interact = p_interact;
// Currently the coordinates will be in absolute space.
this_box_volume.geometry.center = POS_A_CURRENT_COMP;

this_box_storage.z_depth = zdepth;
this_box_storage.x_width1 = xwidth;
this_box_storage.y_height1 = yheight;

this_box_storage.is_rectangle = 0;
if (xwidth2 < 0 && yheight2 < 0) this_box_storage.is_rectangle = 1;
if (xwidth == xwidth2 && yheight == yheight2) this_box_storage.is_rectangle = 1;

if (xwidth2 < 0) {
    this_box_storage.x_width2 = xwidth;
    xwidth2 = xwidth;
} else this_box_storage.x_width2 = xwidth2;

if (yheight2 < 0) {
    this_box_storage.y_height2 = yheight;
    yheight2 = yheight;
} else this_box_storage.y_height2 = yheight2;


this_box_storage.normal_vectors[0] = coords_set(0,0,1);
this_box_storage.normal_vectors[1] = coords_set(0,0,1);

// for sides with y component = 0
x_component = 2*zdepth/sqrt((xwidth-xwidth2)*(xwidth-xwidth2)+4*zdepth*zdepth);
z_component = (xwidth-xwidth2)/sqrt(4*zdepth*zdepth+(xwidth-xwidth2)*(xwidth-xwidth2));

this_box_storage.normal_vectors[2] = coords_set(x_component,0,z_component);
this_box_storage.normal_vectors[3] = coords_set(-x_component,0,z_component);

// for sides with x component = 0
y_component = 2*zdepth/sqrt((yheight-yheight2)*(yheight-yheight2)+4*zdepth*zdepth);
z_component = (yheight-yheight2)/sqrt(4*zdepth*zdepth+(yheight-yheight2)*(yheight-yheight2));

this_box_storage.normal_vectors[4] = coords_set(0,y_component,z_component);
this_box_storage.normal_vectors[5] = coords_set(0,-y_component,z_component);

this_box_volume.geometry.visualization_on = visualize;

this_box_volume.geometry.geometry_parameters.p_box_storage = &this_box_storage;

// Assign pointers to functions for intersection with the shape, checking if a point is inside the shape
if (this_box_storage.is_rectangle == 1) {
this_box_volume.geometry.intersect_function = &sample_box_intersect_simple;
this_box_volume.geometry.within_function = &r_within_box_simple;
}
else {
this_box_volume.geometry.intersect_function = &sample_box_intersect_advanced;
this_box_volume.geometry.within_function = &r_within_box_advanced;
}

this_box_volume.geometry.shell_points = &box_shell_points;
this_box_volume.geometry.mcdisplay_function = &mcdisplay_box_function;
this_box_volume.geometry.initialize_from_main_function = &initialize_box_geometry_from_main_component;
this_box_volume.geometry.process_rot_allocated = 0;

this_box_volume.geometry.copy_geometry_parameters = &allocate_box_storage_copy;

rot_copy(this_box_volume.geometry.rotation_matrix,ROT_A_CURRENT_COMP); //check how ROT_R_CURRENT_COMP would work
rot_transpose(ROT_A_CURRENT_COMP,this_box_volume.geometry.transpose_rotation_matrix);

// Initialize loggers
this_box_volume.loggers.num_elements = 0;

// packing the information into the global_geometry_element, which is then included in the global_geometry_list.
sprintf(global_geometry_element.name,NAME_CURRENT_COMP);
global_geometry_element.activation_counter = number_of_activations;
global_geometry_element.component_index = INDEX_CURRENT_COMP;
global_geometry_element.Volume = &this_box_volume; // Would be nicer if this m was a pointer, now we have the (small) data two places
add_element_to_geometry_list(&global_geometry_list,global_geometry_element);
}
#line 202637 "MACS_sample_kidney_box.c"
#undef number_of_activations
#undef mask_setting
#undef mask_string
#undef p_interact
#undef focus_r
#undef focus_xh
#undef focus_xw
#undef focus_ah
#undef focus_aw
#undef target_z
#undef target_y
#undef target_x
#undef target_index
#undef visualize
#undef yheight2
#undef xwidth2
#undef zdepth
#undef yheight
#undef xwidth
#undef priority
#undef material_string
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

  /* Initializations for component channel_4_analyzer_1_array_crystal_array_7. */
  SIG_MESSAGE("channel_4_analyzer_1_array_crystal_array_7 (Init)");
#define mccompcurname  channel_4_analyzer_1_array_crystal_array_7
#define mccompcurtype  Union_box
#define mccompcurindex 289
#define loop_index mccchannel_4_analyzer_1_array_crystal_array_7_loop_index
#define this_box_volume mccchannel_4_analyzer_1_array_crystal_array_7_this_box_volume
#define global_geometry_element mccchannel_4_analyzer_1_array_crystal_array_7_global_geometry_element
#define this_box_storage mccchannel_4_analyzer_1_array_crystal_array_7_this_box_storage
#define material_string mccchannel_4_analyzer_1_array_crystal_array_7_material_string
#define priority mccchannel_4_analyzer_1_array_crystal_array_7_priority
#define xwidth mccchannel_4_analyzer_1_array_crystal_array_7_xwidth
#define yheight mccchannel_4_analyzer_1_array_crystal_array_7_yheight
#define zdepth mccchannel_4_analyzer_1_array_crystal_array_7_zdepth
#define xwidth2 mccchannel_4_analyzer_1_array_crystal_array_7_xwidth2
#define yheight2 mccchannel_4_analyzer_1_array_crystal_array_7_yheight2
#define visualize mccchannel_4_analyzer_1_array_crystal_array_7_visualize
#define target_index mccchannel_4_analyzer_1_array_crystal_array_7_target_index
#define target_x mccchannel_4_analyzer_1_array_crystal_array_7_target_x
#define target_y mccchannel_4_analyzer_1_array_crystal_array_7_target_y
#define target_z mccchannel_4_analyzer_1_array_crystal_array_7_target_z
#define focus_aw mccchannel_4_analyzer_1_array_crystal_array_7_focus_aw
#define focus_ah mccchannel_4_analyzer_1_array_crystal_array_7_focus_ah
#define focus_xw mccchannel_4_analyzer_1_array_crystal_array_7_focus_xw
#define focus_xh mccchannel_4_analyzer_1_array_crystal_array_7_focus_xh
#define focus_r mccchannel_4_analyzer_1_array_crystal_array_7_focus_r
#define p_interact mccchannel_4_analyzer_1_array_crystal_array_7_p_interact
#define mask_string mccchannel_4_analyzer_1_array_crystal_array_7_mask_string
#define mask_setting mccchannel_4_analyzer_1_array_crystal_array_7_mask_setting
#define number_of_activations mccchannel_4_analyzer_1_array_crystal_array_7_number_of_activations
#line 224 "Union_box.comp"
{
// Initializes the focusing system for this volume including input sanitation.
focus_initialize(&this_box_volume.geometry, POS_A_COMP_INDEX(INDEX_CURRENT_COMP+target_index), POS_A_CURRENT_COMP, ROT_A_CURRENT_COMP, target_index, target_x, target_y, target_z, focus_aw, focus_ah, focus_xw, focus_xh, focus_r, NAME_CURRENT_COMP);

// Input sanitation for this geometry
if (xwidth <= 0) {
  printf("\nERROR in Union_box named %s, the xwidth is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (yheight <= 0) {
  printf("\nERROR in Union_box named %s, yheight is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (zdepth <= 0) {
  printf("\nERROR in Union_box named %s, zdepth is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (xwidth2 <= 0 && xwidth2 != -1) {
  printf("\nERROR in Union_box named %s, the xwidth2 is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (yheight2 <= 0 && yheight2 != -1) {
  printf("\nERROR in Union_box named %s, yheight2 is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}

// Use sanitation
if (global_material_list.num_elements == 0) {
  printf("\nERROR: Need to define a material using Union_make_material before using a Union geometry component. \n");
  printf("       %s was defined before first use of Union_make_material.\n",NAME_CURRENT_COMP);
  exit(1);
}

this_box_volume.geometry.is_masked_volume = 0;
this_box_volume.geometry.is_exit_volume = 0;
this_box_volume.geometry.is_mask_volume = 0;
// check if the volume is a mask, if it is the material string is irelevant.
if (mask_string && strlen(mask_string) && strcmp(mask_string, "NULL") && strcmp(mask_string, "0")) {
    // A mask volume is used to limit the extend of other volumes, called the masked volumes. These are specified in the mask_string.
    // In order for a ray to enter a masked volume, it needs to be both in the region covered by that volume AND the mask volume.
    // When more than
    this_box_volume.geometry.mask_mode = 1; // Default is mask mode is ALL
    if (mask_setting && strlen(mask_setting) && strcmp(mask_setting, "NULL") && strcmp(mask_setting, "0")) {
        if (strcmp(mask_setting,"ALL") == 0 || strcmp(mask_setting,"All") == 0) this_box_volume.geometry.mask_mode = 1;
        else if (strcmp(mask_setting,"ANY") == 0 || strcmp(mask_setting,"Any") == 0) this_box_volume.geometry.mask_mode = 2;
        else {
            printf("The mask_mode of component %s is set to %s, but must be either ALL or ANY.\n",NAME_CURRENT_COMP,mask_setting);
            exit(1);
        }
    }
    
    for (loop_index=0;loop_index<global_geometry_list.num_elements;loop_index++) {
        // Add mask list
        if (1 == manual_linking_function(global_geometry_list.elements[loop_index].name,mask_string)) {
            add_element_to_int_list(&this_box_volume.geometry.mask_list,global_geometry_list.elements[loop_index].component_index);
            add_element_to_int_list(&global_geometry_list.elements[loop_index].Volume->geometry.masked_by_list,INDEX_CURRENT_COMP);
            global_geometry_list.elements[loop_index].Volume->geometry.is_masked_volume = 1;
            if (this_box_volume.geometry.mask_mode == 2)
                global_geometry_list.elements[loop_index].Volume->geometry.mask_mode = 2;
            if (this_box_volume.geometry.mask_mode == 1) {
                if (global_geometry_list.elements[loop_index].Volume->geometry.is_masked_volume == 1 && global_geometry_list.elements[loop_index].Volume->geometry.mask_mode != 2)
                    // If more than one mask is added to one volume, the ANY mode overwrites the (default) ALL mode.
                    global_geometry_list.elements[loop_index].Volume->geometry.mask_mode = 1;
            }
            
            found_geometries = 1;
        }
    }
    if (found_geometries == 0) {
        printf("The mask_string in geometry: %s did not find any of the specified volumes in the mask_string %s \n",NAME_CURRENT_COMP,mask_string);
        exit(1);
    }
    this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
    this_box_volume.p_physics->is_vacuum = 0; // Makes this volume a vacuum
    this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
    this_box_volume.p_physics->my_a = 0; // Should not be used.
    sprintf(this_box_volume.p_physics->name,"Mask");
    this_box_volume.geometry.is_mask_volume = 1;
    
    
// Read the material input, or if it lacks, use automatic linking.
} else if (material_string && strlen(material_string) && strcmp(material_string, "NULL") && strcmp(material_string, "0")) {
    // A geometry string was given, use it to determine which material
    if (0 == strcmp(material_string,"vacuum") || 0 == strcmp(material_string,"Vacuum")) {
        // One could have a global physics struct for vacuum instead of creating one for each
        this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
        this_box_volume.p_physics->is_vacuum = 1; // Makes this volume a vacuum
        this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
        this_box_volume.p_physics->my_a = 0; // Should not be used.
        sprintf(this_box_volume.p_physics->name,"Vacuum");
    } else if (0 == strcmp(material_string,"exit") || 0 == strcmp(material_string,"Exit")) {
        // One could have a global physics struct for vacuum instead of creating one for each
        this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
        this_box_volume.p_physics->is_vacuum = 1; // Makes this volume a vacuum
        this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
        this_box_volume.p_physics->my_a = 0; // Should not be used.
        this_box_volume.geometry.is_exit_volume = 1;
        sprintf(this_box_volume.p_physics->name,"Exit");
    } else {
        #ifndef MATERIAL_DETECTOR
            printf("Need to define a material before refering to it in a geometry %s.\n",NAME_CURRENT_COMP);
            exit(1);
        #endif
        for (loop_index=0;loop_index<global_material_list.num_elements;loop_index++) {
            if (0 == strcmp(material_string,global_material_list.elements[loop_index].name)) {
                this_box_volume.p_physics = global_material_list.elements[loop_index].physics;
                break;
            }
            if (loop_index == global_material_list.num_elements-1) {
            printf("\n");
            printf("ERROR: The material string \"%s\" in Union geometry \"%s\" did not match a specified material. \n",material_string,NAME_CURRENT_COMP);
            printf("       The materials available at this point (need to be defined before the geometry): \n");
            for (loop_index=0;loop_index<global_material_list.num_elements;loop_index++)
              printf("         %s\n",global_material_list.elements[loop_index].name);
            printf("\n");
            printf("       It is also possible to use one of the defualt materials avaiable: \n");
            printf("           Vacuum (for a Volume without scattering or absorption)\n");
            printf("           Exit (for a Volume where the ray exits the component if it enters)\n");
            printf("           Mask (for a Volume that masks existing volumes specified in the mask_string\n");
            exit(1);
          }
        }
    }
} else {
    // Automatic linking, simply using the last defined material.
    #ifndef MATERIAL_DETECTOR
        printf("Need to define a material before the geometry to use automatic linking %s.\n",NAME_CURRENT_COMP);
        exit(1);
    #endif
    this_box_volume.p_physics = global_material_list.elements[global_material_list.num_elements-1].physics;
}

sprintf(this_box_volume.name,NAME_CURRENT_COMP);
sprintf(this_box_volume.geometry.shape,"box");
this_box_volume.geometry.priority_value = priority;
this_box_volume.geometry.geometry_p_interact = p_interact;
// Currently the coordinates will be in absolute space.
this_box_volume.geometry.center = POS_A_CURRENT_COMP;

this_box_storage.z_depth = zdepth;
this_box_storage.x_width1 = xwidth;
this_box_storage.y_height1 = yheight;

this_box_storage.is_rectangle = 0;
if (xwidth2 < 0 && yheight2 < 0) this_box_storage.is_rectangle = 1;
if (xwidth == xwidth2 && yheight == yheight2) this_box_storage.is_rectangle = 1;

if (xwidth2 < 0) {
    this_box_storage.x_width2 = xwidth;
    xwidth2 = xwidth;
} else this_box_storage.x_width2 = xwidth2;

if (yheight2 < 0) {
    this_box_storage.y_height2 = yheight;
    yheight2 = yheight;
} else this_box_storage.y_height2 = yheight2;


this_box_storage.normal_vectors[0] = coords_set(0,0,1);
this_box_storage.normal_vectors[1] = coords_set(0,0,1);

// for sides with y component = 0
x_component = 2*zdepth/sqrt((xwidth-xwidth2)*(xwidth-xwidth2)+4*zdepth*zdepth);
z_component = (xwidth-xwidth2)/sqrt(4*zdepth*zdepth+(xwidth-xwidth2)*(xwidth-xwidth2));

this_box_storage.normal_vectors[2] = coords_set(x_component,0,z_component);
this_box_storage.normal_vectors[3] = coords_set(-x_component,0,z_component);

// for sides with x component = 0
y_component = 2*zdepth/sqrt((yheight-yheight2)*(yheight-yheight2)+4*zdepth*zdepth);
z_component = (yheight-yheight2)/sqrt(4*zdepth*zdepth+(yheight-yheight2)*(yheight-yheight2));

this_box_storage.normal_vectors[4] = coords_set(0,y_component,z_component);
this_box_storage.normal_vectors[5] = coords_set(0,-y_component,z_component);

this_box_volume.geometry.visualization_on = visualize;

this_box_volume.geometry.geometry_parameters.p_box_storage = &this_box_storage;

// Assign pointers to functions for intersection with the shape, checking if a point is inside the shape
if (this_box_storage.is_rectangle == 1) {
this_box_volume.geometry.intersect_function = &sample_box_intersect_simple;
this_box_volume.geometry.within_function = &r_within_box_simple;
}
else {
this_box_volume.geometry.intersect_function = &sample_box_intersect_advanced;
this_box_volume.geometry.within_function = &r_within_box_advanced;
}

this_box_volume.geometry.shell_points = &box_shell_points;
this_box_volume.geometry.mcdisplay_function = &mcdisplay_box_function;
this_box_volume.geometry.initialize_from_main_function = &initialize_box_geometry_from_main_component;
this_box_volume.geometry.process_rot_allocated = 0;

this_box_volume.geometry.copy_geometry_parameters = &allocate_box_storage_copy;

rot_copy(this_box_volume.geometry.rotation_matrix,ROT_A_CURRENT_COMP); //check how ROT_R_CURRENT_COMP would work
rot_transpose(ROT_A_CURRENT_COMP,this_box_volume.geometry.transpose_rotation_matrix);

// Initialize loggers
this_box_volume.loggers.num_elements = 0;

// packing the information into the global_geometry_element, which is then included in the global_geometry_list.
sprintf(global_geometry_element.name,NAME_CURRENT_COMP);
global_geometry_element.activation_counter = number_of_activations;
global_geometry_element.component_index = INDEX_CURRENT_COMP;
global_geometry_element.Volume = &this_box_volume; // Would be nicer if this m was a pointer, now we have the (small) data two places
add_element_to_geometry_list(&global_geometry_list,global_geometry_element);
}
#line 202907 "MACS_sample_kidney_box.c"
#undef number_of_activations
#undef mask_setting
#undef mask_string
#undef p_interact
#undef focus_r
#undef focus_xh
#undef focus_xw
#undef focus_ah
#undef focus_aw
#undef target_z
#undef target_y
#undef target_x
#undef target_index
#undef visualize
#undef yheight2
#undef xwidth2
#undef zdepth
#undef yheight
#undef xwidth
#undef priority
#undef material_string
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

  /* Initializations for component channel_4_analyzer_1_array_crystal_array_8. */
  SIG_MESSAGE("channel_4_analyzer_1_array_crystal_array_8 (Init)");
#define mccompcurname  channel_4_analyzer_1_array_crystal_array_8
#define mccompcurtype  Union_box
#define mccompcurindex 290
#define loop_index mccchannel_4_analyzer_1_array_crystal_array_8_loop_index
#define this_box_volume mccchannel_4_analyzer_1_array_crystal_array_8_this_box_volume
#define global_geometry_element mccchannel_4_analyzer_1_array_crystal_array_8_global_geometry_element
#define this_box_storage mccchannel_4_analyzer_1_array_crystal_array_8_this_box_storage
#define material_string mccchannel_4_analyzer_1_array_crystal_array_8_material_string
#define priority mccchannel_4_analyzer_1_array_crystal_array_8_priority
#define xwidth mccchannel_4_analyzer_1_array_crystal_array_8_xwidth
#define yheight mccchannel_4_analyzer_1_array_crystal_array_8_yheight
#define zdepth mccchannel_4_analyzer_1_array_crystal_array_8_zdepth
#define xwidth2 mccchannel_4_analyzer_1_array_crystal_array_8_xwidth2
#define yheight2 mccchannel_4_analyzer_1_array_crystal_array_8_yheight2
#define visualize mccchannel_4_analyzer_1_array_crystal_array_8_visualize
#define target_index mccchannel_4_analyzer_1_array_crystal_array_8_target_index
#define target_x mccchannel_4_analyzer_1_array_crystal_array_8_target_x
#define target_y mccchannel_4_analyzer_1_array_crystal_array_8_target_y
#define target_z mccchannel_4_analyzer_1_array_crystal_array_8_target_z
#define focus_aw mccchannel_4_analyzer_1_array_crystal_array_8_focus_aw
#define focus_ah mccchannel_4_analyzer_1_array_crystal_array_8_focus_ah
#define focus_xw mccchannel_4_analyzer_1_array_crystal_array_8_focus_xw
#define focus_xh mccchannel_4_analyzer_1_array_crystal_array_8_focus_xh
#define focus_r mccchannel_4_analyzer_1_array_crystal_array_8_focus_r
#define p_interact mccchannel_4_analyzer_1_array_crystal_array_8_p_interact
#define mask_string mccchannel_4_analyzer_1_array_crystal_array_8_mask_string
#define mask_setting mccchannel_4_analyzer_1_array_crystal_array_8_mask_setting
#define number_of_activations mccchannel_4_analyzer_1_array_crystal_array_8_number_of_activations
#line 224 "Union_box.comp"
{
// Initializes the focusing system for this volume including input sanitation.
focus_initialize(&this_box_volume.geometry, POS_A_COMP_INDEX(INDEX_CURRENT_COMP+target_index), POS_A_CURRENT_COMP, ROT_A_CURRENT_COMP, target_index, target_x, target_y, target_z, focus_aw, focus_ah, focus_xw, focus_xh, focus_r, NAME_CURRENT_COMP);

// Input sanitation for this geometry
if (xwidth <= 0) {
  printf("\nERROR in Union_box named %s, the xwidth is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (yheight <= 0) {
  printf("\nERROR in Union_box named %s, yheight is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (zdepth <= 0) {
  printf("\nERROR in Union_box named %s, zdepth is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (xwidth2 <= 0 && xwidth2 != -1) {
  printf("\nERROR in Union_box named %s, the xwidth2 is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (yheight2 <= 0 && yheight2 != -1) {
  printf("\nERROR in Union_box named %s, yheight2 is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}

// Use sanitation
if (global_material_list.num_elements == 0) {
  printf("\nERROR: Need to define a material using Union_make_material before using a Union geometry component. \n");
  printf("       %s was defined before first use of Union_make_material.\n",NAME_CURRENT_COMP);
  exit(1);
}

this_box_volume.geometry.is_masked_volume = 0;
this_box_volume.geometry.is_exit_volume = 0;
this_box_volume.geometry.is_mask_volume = 0;
// check if the volume is a mask, if it is the material string is irelevant.
if (mask_string && strlen(mask_string) && strcmp(mask_string, "NULL") && strcmp(mask_string, "0")) {
    // A mask volume is used to limit the extend of other volumes, called the masked volumes. These are specified in the mask_string.
    // In order for a ray to enter a masked volume, it needs to be both in the region covered by that volume AND the mask volume.
    // When more than
    this_box_volume.geometry.mask_mode = 1; // Default is mask mode is ALL
    if (mask_setting && strlen(mask_setting) && strcmp(mask_setting, "NULL") && strcmp(mask_setting, "0")) {
        if (strcmp(mask_setting,"ALL") == 0 || strcmp(mask_setting,"All") == 0) this_box_volume.geometry.mask_mode = 1;
        else if (strcmp(mask_setting,"ANY") == 0 || strcmp(mask_setting,"Any") == 0) this_box_volume.geometry.mask_mode = 2;
        else {
            printf("The mask_mode of component %s is set to %s, but must be either ALL or ANY.\n",NAME_CURRENT_COMP,mask_setting);
            exit(1);
        }
    }
    
    for (loop_index=0;loop_index<global_geometry_list.num_elements;loop_index++) {
        // Add mask list
        if (1 == manual_linking_function(global_geometry_list.elements[loop_index].name,mask_string)) {
            add_element_to_int_list(&this_box_volume.geometry.mask_list,global_geometry_list.elements[loop_index].component_index);
            add_element_to_int_list(&global_geometry_list.elements[loop_index].Volume->geometry.masked_by_list,INDEX_CURRENT_COMP);
            global_geometry_list.elements[loop_index].Volume->geometry.is_masked_volume = 1;
            if (this_box_volume.geometry.mask_mode == 2)
                global_geometry_list.elements[loop_index].Volume->geometry.mask_mode = 2;
            if (this_box_volume.geometry.mask_mode == 1) {
                if (global_geometry_list.elements[loop_index].Volume->geometry.is_masked_volume == 1 && global_geometry_list.elements[loop_index].Volume->geometry.mask_mode != 2)
                    // If more than one mask is added to one volume, the ANY mode overwrites the (default) ALL mode.
                    global_geometry_list.elements[loop_index].Volume->geometry.mask_mode = 1;
            }
            
            found_geometries = 1;
        }
    }
    if (found_geometries == 0) {
        printf("The mask_string in geometry: %s did not find any of the specified volumes in the mask_string %s \n",NAME_CURRENT_COMP,mask_string);
        exit(1);
    }
    this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
    this_box_volume.p_physics->is_vacuum = 0; // Makes this volume a vacuum
    this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
    this_box_volume.p_physics->my_a = 0; // Should not be used.
    sprintf(this_box_volume.p_physics->name,"Mask");
    this_box_volume.geometry.is_mask_volume = 1;
    
    
// Read the material input, or if it lacks, use automatic linking.
} else if (material_string && strlen(material_string) && strcmp(material_string, "NULL") && strcmp(material_string, "0")) {
    // A geometry string was given, use it to determine which material
    if (0 == strcmp(material_string,"vacuum") || 0 == strcmp(material_string,"Vacuum")) {
        // One could have a global physics struct for vacuum instead of creating one for each
        this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
        this_box_volume.p_physics->is_vacuum = 1; // Makes this volume a vacuum
        this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
        this_box_volume.p_physics->my_a = 0; // Should not be used.
        sprintf(this_box_volume.p_physics->name,"Vacuum");
    } else if (0 == strcmp(material_string,"exit") || 0 == strcmp(material_string,"Exit")) {
        // One could have a global physics struct for vacuum instead of creating one for each
        this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
        this_box_volume.p_physics->is_vacuum = 1; // Makes this volume a vacuum
        this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
        this_box_volume.p_physics->my_a = 0; // Should not be used.
        this_box_volume.geometry.is_exit_volume = 1;
        sprintf(this_box_volume.p_physics->name,"Exit");
    } else {
        #ifndef MATERIAL_DETECTOR
            printf("Need to define a material before refering to it in a geometry %s.\n",NAME_CURRENT_COMP);
            exit(1);
        #endif
        for (loop_index=0;loop_index<global_material_list.num_elements;loop_index++) {
            if (0 == strcmp(material_string,global_material_list.elements[loop_index].name)) {
                this_box_volume.p_physics = global_material_list.elements[loop_index].physics;
                break;
            }
            if (loop_index == global_material_list.num_elements-1) {
            printf("\n");
            printf("ERROR: The material string \"%s\" in Union geometry \"%s\" did not match a specified material. \n",material_string,NAME_CURRENT_COMP);
            printf("       The materials available at this point (need to be defined before the geometry): \n");
            for (loop_index=0;loop_index<global_material_list.num_elements;loop_index++)
              printf("         %s\n",global_material_list.elements[loop_index].name);
            printf("\n");
            printf("       It is also possible to use one of the defualt materials avaiable: \n");
            printf("           Vacuum (for a Volume without scattering or absorption)\n");
            printf("           Exit (for a Volume where the ray exits the component if it enters)\n");
            printf("           Mask (for a Volume that masks existing volumes specified in the mask_string\n");
            exit(1);
          }
        }
    }
} else {
    // Automatic linking, simply using the last defined material.
    #ifndef MATERIAL_DETECTOR
        printf("Need to define a material before the geometry to use automatic linking %s.\n",NAME_CURRENT_COMP);
        exit(1);
    #endif
    this_box_volume.p_physics = global_material_list.elements[global_material_list.num_elements-1].physics;
}

sprintf(this_box_volume.name,NAME_CURRENT_COMP);
sprintf(this_box_volume.geometry.shape,"box");
this_box_volume.geometry.priority_value = priority;
this_box_volume.geometry.geometry_p_interact = p_interact;
// Currently the coordinates will be in absolute space.
this_box_volume.geometry.center = POS_A_CURRENT_COMP;

this_box_storage.z_depth = zdepth;
this_box_storage.x_width1 = xwidth;
this_box_storage.y_height1 = yheight;

this_box_storage.is_rectangle = 0;
if (xwidth2 < 0 && yheight2 < 0) this_box_storage.is_rectangle = 1;
if (xwidth == xwidth2 && yheight == yheight2) this_box_storage.is_rectangle = 1;

if (xwidth2 < 0) {
    this_box_storage.x_width2 = xwidth;
    xwidth2 = xwidth;
} else this_box_storage.x_width2 = xwidth2;

if (yheight2 < 0) {
    this_box_storage.y_height2 = yheight;
    yheight2 = yheight;
} else this_box_storage.y_height2 = yheight2;


this_box_storage.normal_vectors[0] = coords_set(0,0,1);
this_box_storage.normal_vectors[1] = coords_set(0,0,1);

// for sides with y component = 0
x_component = 2*zdepth/sqrt((xwidth-xwidth2)*(xwidth-xwidth2)+4*zdepth*zdepth);
z_component = (xwidth-xwidth2)/sqrt(4*zdepth*zdepth+(xwidth-xwidth2)*(xwidth-xwidth2));

this_box_storage.normal_vectors[2] = coords_set(x_component,0,z_component);
this_box_storage.normal_vectors[3] = coords_set(-x_component,0,z_component);

// for sides with x component = 0
y_component = 2*zdepth/sqrt((yheight-yheight2)*(yheight-yheight2)+4*zdepth*zdepth);
z_component = (yheight-yheight2)/sqrt(4*zdepth*zdepth+(yheight-yheight2)*(yheight-yheight2));

this_box_storage.normal_vectors[4] = coords_set(0,y_component,z_component);
this_box_storage.normal_vectors[5] = coords_set(0,-y_component,z_component);

this_box_volume.geometry.visualization_on = visualize;

this_box_volume.geometry.geometry_parameters.p_box_storage = &this_box_storage;

// Assign pointers to functions for intersection with the shape, checking if a point is inside the shape
if (this_box_storage.is_rectangle == 1) {
this_box_volume.geometry.intersect_function = &sample_box_intersect_simple;
this_box_volume.geometry.within_function = &r_within_box_simple;
}
else {
this_box_volume.geometry.intersect_function = &sample_box_intersect_advanced;
this_box_volume.geometry.within_function = &r_within_box_advanced;
}

this_box_volume.geometry.shell_points = &box_shell_points;
this_box_volume.geometry.mcdisplay_function = &mcdisplay_box_function;
this_box_volume.geometry.initialize_from_main_function = &initialize_box_geometry_from_main_component;
this_box_volume.geometry.process_rot_allocated = 0;

this_box_volume.geometry.copy_geometry_parameters = &allocate_box_storage_copy;

rot_copy(this_box_volume.geometry.rotation_matrix,ROT_A_CURRENT_COMP); //check how ROT_R_CURRENT_COMP would work
rot_transpose(ROT_A_CURRENT_COMP,this_box_volume.geometry.transpose_rotation_matrix);

// Initialize loggers
this_box_volume.loggers.num_elements = 0;

// packing the information into the global_geometry_element, which is then included in the global_geometry_list.
sprintf(global_geometry_element.name,NAME_CURRENT_COMP);
global_geometry_element.activation_counter = number_of_activations;
global_geometry_element.component_index = INDEX_CURRENT_COMP;
global_geometry_element.Volume = &this_box_volume; // Would be nicer if this m was a pointer, now we have the (small) data two places
add_element_to_geometry_list(&global_geometry_list,global_geometry_element);
}
#line 203177 "MACS_sample_kidney_box.c"
#undef number_of_activations
#undef mask_setting
#undef mask_string
#undef p_interact
#undef focus_r
#undef focus_xh
#undef focus_xw
#undef focus_ah
#undef focus_aw
#undef target_z
#undef target_y
#undef target_x
#undef target_index
#undef visualize
#undef yheight2
#undef xwidth2
#undef zdepth
#undef yheight
#undef xwidth
#undef priority
#undef material_string
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

  /* Initializations for component channel_4_analyzer_2_center. */
  SIG_MESSAGE("channel_4_analyzer_2_center (Init)");

  /* Initializations for component channel_4_analyzer_2_rotated. */
  SIG_MESSAGE("channel_4_analyzer_2_rotated (Init)");

  /* Initializations for component channel_4_analyzer_2_array_crystal_array_0. */
  SIG_MESSAGE("channel_4_analyzer_2_array_crystal_array_0 (Init)");
#define mccompcurname  channel_4_analyzer_2_array_crystal_array_0
#define mccompcurtype  Union_box
#define mccompcurindex 293
#define loop_index mccchannel_4_analyzer_2_array_crystal_array_0_loop_index
#define this_box_volume mccchannel_4_analyzer_2_array_crystal_array_0_this_box_volume
#define global_geometry_element mccchannel_4_analyzer_2_array_crystal_array_0_global_geometry_element
#define this_box_storage mccchannel_4_analyzer_2_array_crystal_array_0_this_box_storage
#define material_string mccchannel_4_analyzer_2_array_crystal_array_0_material_string
#define priority mccchannel_4_analyzer_2_array_crystal_array_0_priority
#define xwidth mccchannel_4_analyzer_2_array_crystal_array_0_xwidth
#define yheight mccchannel_4_analyzer_2_array_crystal_array_0_yheight
#define zdepth mccchannel_4_analyzer_2_array_crystal_array_0_zdepth
#define xwidth2 mccchannel_4_analyzer_2_array_crystal_array_0_xwidth2
#define yheight2 mccchannel_4_analyzer_2_array_crystal_array_0_yheight2
#define visualize mccchannel_4_analyzer_2_array_crystal_array_0_visualize
#define target_index mccchannel_4_analyzer_2_array_crystal_array_0_target_index
#define target_x mccchannel_4_analyzer_2_array_crystal_array_0_target_x
#define target_y mccchannel_4_analyzer_2_array_crystal_array_0_target_y
#define target_z mccchannel_4_analyzer_2_array_crystal_array_0_target_z
#define focus_aw mccchannel_4_analyzer_2_array_crystal_array_0_focus_aw
#define focus_ah mccchannel_4_analyzer_2_array_crystal_array_0_focus_ah
#define focus_xw mccchannel_4_analyzer_2_array_crystal_array_0_focus_xw
#define focus_xh mccchannel_4_analyzer_2_array_crystal_array_0_focus_xh
#define focus_r mccchannel_4_analyzer_2_array_crystal_array_0_focus_r
#define p_interact mccchannel_4_analyzer_2_array_crystal_array_0_p_interact
#define mask_string mccchannel_4_analyzer_2_array_crystal_array_0_mask_string
#define mask_setting mccchannel_4_analyzer_2_array_crystal_array_0_mask_setting
#define number_of_activations mccchannel_4_analyzer_2_array_crystal_array_0_number_of_activations
#line 224 "Union_box.comp"
{
// Initializes the focusing system for this volume including input sanitation.
focus_initialize(&this_box_volume.geometry, POS_A_COMP_INDEX(INDEX_CURRENT_COMP+target_index), POS_A_CURRENT_COMP, ROT_A_CURRENT_COMP, target_index, target_x, target_y, target_z, focus_aw, focus_ah, focus_xw, focus_xh, focus_r, NAME_CURRENT_COMP);

// Input sanitation for this geometry
if (xwidth <= 0) {
  printf("\nERROR in Union_box named %s, the xwidth is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (yheight <= 0) {
  printf("\nERROR in Union_box named %s, yheight is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (zdepth <= 0) {
  printf("\nERROR in Union_box named %s, zdepth is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (xwidth2 <= 0 && xwidth2 != -1) {
  printf("\nERROR in Union_box named %s, the xwidth2 is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (yheight2 <= 0 && yheight2 != -1) {
  printf("\nERROR in Union_box named %s, yheight2 is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}

// Use sanitation
if (global_material_list.num_elements == 0) {
  printf("\nERROR: Need to define a material using Union_make_material before using a Union geometry component. \n");
  printf("       %s was defined before first use of Union_make_material.\n",NAME_CURRENT_COMP);
  exit(1);
}

this_box_volume.geometry.is_masked_volume = 0;
this_box_volume.geometry.is_exit_volume = 0;
this_box_volume.geometry.is_mask_volume = 0;
// check if the volume is a mask, if it is the material string is irelevant.
if (mask_string && strlen(mask_string) && strcmp(mask_string, "NULL") && strcmp(mask_string, "0")) {
    // A mask volume is used to limit the extend of other volumes, called the masked volumes. These are specified in the mask_string.
    // In order for a ray to enter a masked volume, it needs to be both in the region covered by that volume AND the mask volume.
    // When more than
    this_box_volume.geometry.mask_mode = 1; // Default is mask mode is ALL
    if (mask_setting && strlen(mask_setting) && strcmp(mask_setting, "NULL") && strcmp(mask_setting, "0")) {
        if (strcmp(mask_setting,"ALL") == 0 || strcmp(mask_setting,"All") == 0) this_box_volume.geometry.mask_mode = 1;
        else if (strcmp(mask_setting,"ANY") == 0 || strcmp(mask_setting,"Any") == 0) this_box_volume.geometry.mask_mode = 2;
        else {
            printf("The mask_mode of component %s is set to %s, but must be either ALL or ANY.\n",NAME_CURRENT_COMP,mask_setting);
            exit(1);
        }
    }
    
    for (loop_index=0;loop_index<global_geometry_list.num_elements;loop_index++) {
        // Add mask list
        if (1 == manual_linking_function(global_geometry_list.elements[loop_index].name,mask_string)) {
            add_element_to_int_list(&this_box_volume.geometry.mask_list,global_geometry_list.elements[loop_index].component_index);
            add_element_to_int_list(&global_geometry_list.elements[loop_index].Volume->geometry.masked_by_list,INDEX_CURRENT_COMP);
            global_geometry_list.elements[loop_index].Volume->geometry.is_masked_volume = 1;
            if (this_box_volume.geometry.mask_mode == 2)
                global_geometry_list.elements[loop_index].Volume->geometry.mask_mode = 2;
            if (this_box_volume.geometry.mask_mode == 1) {
                if (global_geometry_list.elements[loop_index].Volume->geometry.is_masked_volume == 1 && global_geometry_list.elements[loop_index].Volume->geometry.mask_mode != 2)
                    // If more than one mask is added to one volume, the ANY mode overwrites the (default) ALL mode.
                    global_geometry_list.elements[loop_index].Volume->geometry.mask_mode = 1;
            }
            
            found_geometries = 1;
        }
    }
    if (found_geometries == 0) {
        printf("The mask_string in geometry: %s did not find any of the specified volumes in the mask_string %s \n",NAME_CURRENT_COMP,mask_string);
        exit(1);
    }
    this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
    this_box_volume.p_physics->is_vacuum = 0; // Makes this volume a vacuum
    this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
    this_box_volume.p_physics->my_a = 0; // Should not be used.
    sprintf(this_box_volume.p_physics->name,"Mask");
    this_box_volume.geometry.is_mask_volume = 1;
    
    
// Read the material input, or if it lacks, use automatic linking.
} else if (material_string && strlen(material_string) && strcmp(material_string, "NULL") && strcmp(material_string, "0")) {
    // A geometry string was given, use it to determine which material
    if (0 == strcmp(material_string,"vacuum") || 0 == strcmp(material_string,"Vacuum")) {
        // One could have a global physics struct for vacuum instead of creating one for each
        this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
        this_box_volume.p_physics->is_vacuum = 1; // Makes this volume a vacuum
        this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
        this_box_volume.p_physics->my_a = 0; // Should not be used.
        sprintf(this_box_volume.p_physics->name,"Vacuum");
    } else if (0 == strcmp(material_string,"exit") || 0 == strcmp(material_string,"Exit")) {
        // One could have a global physics struct for vacuum instead of creating one for each
        this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
        this_box_volume.p_physics->is_vacuum = 1; // Makes this volume a vacuum
        this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
        this_box_volume.p_physics->my_a = 0; // Should not be used.
        this_box_volume.geometry.is_exit_volume = 1;
        sprintf(this_box_volume.p_physics->name,"Exit");
    } else {
        #ifndef MATERIAL_DETECTOR
            printf("Need to define a material before refering to it in a geometry %s.\n",NAME_CURRENT_COMP);
            exit(1);
        #endif
        for (loop_index=0;loop_index<global_material_list.num_elements;loop_index++) {
            if (0 == strcmp(material_string,global_material_list.elements[loop_index].name)) {
                this_box_volume.p_physics = global_material_list.elements[loop_index].physics;
                break;
            }
            if (loop_index == global_material_list.num_elements-1) {
            printf("\n");
            printf("ERROR: The material string \"%s\" in Union geometry \"%s\" did not match a specified material. \n",material_string,NAME_CURRENT_COMP);
            printf("       The materials available at this point (need to be defined before the geometry): \n");
            for (loop_index=0;loop_index<global_material_list.num_elements;loop_index++)
              printf("         %s\n",global_material_list.elements[loop_index].name);
            printf("\n");
            printf("       It is also possible to use one of the defualt materials avaiable: \n");
            printf("           Vacuum (for a Volume without scattering or absorption)\n");
            printf("           Exit (for a Volume where the ray exits the component if it enters)\n");
            printf("           Mask (for a Volume that masks existing volumes specified in the mask_string\n");
            exit(1);
          }
        }
    }
} else {
    // Automatic linking, simply using the last defined material.
    #ifndef MATERIAL_DETECTOR
        printf("Need to define a material before the geometry to use automatic linking %s.\n",NAME_CURRENT_COMP);
        exit(1);
    #endif
    this_box_volume.p_physics = global_material_list.elements[global_material_list.num_elements-1].physics;
}

sprintf(this_box_volume.name,NAME_CURRENT_COMP);
sprintf(this_box_volume.geometry.shape,"box");
this_box_volume.geometry.priority_value = priority;
this_box_volume.geometry.geometry_p_interact = p_interact;
// Currently the coordinates will be in absolute space.
this_box_volume.geometry.center = POS_A_CURRENT_COMP;

this_box_storage.z_depth = zdepth;
this_box_storage.x_width1 = xwidth;
this_box_storage.y_height1 = yheight;

this_box_storage.is_rectangle = 0;
if (xwidth2 < 0 && yheight2 < 0) this_box_storage.is_rectangle = 1;
if (xwidth == xwidth2 && yheight == yheight2) this_box_storage.is_rectangle = 1;

if (xwidth2 < 0) {
    this_box_storage.x_width2 = xwidth;
    xwidth2 = xwidth;
} else this_box_storage.x_width2 = xwidth2;

if (yheight2 < 0) {
    this_box_storage.y_height2 = yheight;
    yheight2 = yheight;
} else this_box_storage.y_height2 = yheight2;


this_box_storage.normal_vectors[0] = coords_set(0,0,1);
this_box_storage.normal_vectors[1] = coords_set(0,0,1);

// for sides with y component = 0
x_component = 2*zdepth/sqrt((xwidth-xwidth2)*(xwidth-xwidth2)+4*zdepth*zdepth);
z_component = (xwidth-xwidth2)/sqrt(4*zdepth*zdepth+(xwidth-xwidth2)*(xwidth-xwidth2));

this_box_storage.normal_vectors[2] = coords_set(x_component,0,z_component);
this_box_storage.normal_vectors[3] = coords_set(-x_component,0,z_component);

// for sides with x component = 0
y_component = 2*zdepth/sqrt((yheight-yheight2)*(yheight-yheight2)+4*zdepth*zdepth);
z_component = (yheight-yheight2)/sqrt(4*zdepth*zdepth+(yheight-yheight2)*(yheight-yheight2));

this_box_storage.normal_vectors[4] = coords_set(0,y_component,z_component);
this_box_storage.normal_vectors[5] = coords_set(0,-y_component,z_component);

this_box_volume.geometry.visualization_on = visualize;

this_box_volume.geometry.geometry_parameters.p_box_storage = &this_box_storage;

// Assign pointers to functions for intersection with the shape, checking if a point is inside the shape
if (this_box_storage.is_rectangle == 1) {
this_box_volume.geometry.intersect_function = &sample_box_intersect_simple;
this_box_volume.geometry.within_function = &r_within_box_simple;
}
else {
this_box_volume.geometry.intersect_function = &sample_box_intersect_advanced;
this_box_volume.geometry.within_function = &r_within_box_advanced;
}

this_box_volume.geometry.shell_points = &box_shell_points;
this_box_volume.geometry.mcdisplay_function = &mcdisplay_box_function;
this_box_volume.geometry.initialize_from_main_function = &initialize_box_geometry_from_main_component;
this_box_volume.geometry.process_rot_allocated = 0;

this_box_volume.geometry.copy_geometry_parameters = &allocate_box_storage_copy;

rot_copy(this_box_volume.geometry.rotation_matrix,ROT_A_CURRENT_COMP); //check how ROT_R_CURRENT_COMP would work
rot_transpose(ROT_A_CURRENT_COMP,this_box_volume.geometry.transpose_rotation_matrix);

// Initialize loggers
this_box_volume.loggers.num_elements = 0;

// packing the information into the global_geometry_element, which is then included in the global_geometry_list.
sprintf(global_geometry_element.name,NAME_CURRENT_COMP);
global_geometry_element.activation_counter = number_of_activations;
global_geometry_element.component_index = INDEX_CURRENT_COMP;
global_geometry_element.Volume = &this_box_volume; // Would be nicer if this m was a pointer, now we have the (small) data two places
add_element_to_geometry_list(&global_geometry_list,global_geometry_element);
}
#line 203453 "MACS_sample_kidney_box.c"
#undef number_of_activations
#undef mask_setting
#undef mask_string
#undef p_interact
#undef focus_r
#undef focus_xh
#undef focus_xw
#undef focus_ah
#undef focus_aw
#undef target_z
#undef target_y
#undef target_x
#undef target_index
#undef visualize
#undef yheight2
#undef xwidth2
#undef zdepth
#undef yheight
#undef xwidth
#undef priority
#undef material_string
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

  /* Initializations for component channel_4_analyzer_2_array_crystal_array_1. */
  SIG_MESSAGE("channel_4_analyzer_2_array_crystal_array_1 (Init)");
#define mccompcurname  channel_4_analyzer_2_array_crystal_array_1
#define mccompcurtype  Union_box
#define mccompcurindex 294
#define loop_index mccchannel_4_analyzer_2_array_crystal_array_1_loop_index
#define this_box_volume mccchannel_4_analyzer_2_array_crystal_array_1_this_box_volume
#define global_geometry_element mccchannel_4_analyzer_2_array_crystal_array_1_global_geometry_element
#define this_box_storage mccchannel_4_analyzer_2_array_crystal_array_1_this_box_storage
#define material_string mccchannel_4_analyzer_2_array_crystal_array_1_material_string
#define priority mccchannel_4_analyzer_2_array_crystal_array_1_priority
#define xwidth mccchannel_4_analyzer_2_array_crystal_array_1_xwidth
#define yheight mccchannel_4_analyzer_2_array_crystal_array_1_yheight
#define zdepth mccchannel_4_analyzer_2_array_crystal_array_1_zdepth
#define xwidth2 mccchannel_4_analyzer_2_array_crystal_array_1_xwidth2
#define yheight2 mccchannel_4_analyzer_2_array_crystal_array_1_yheight2
#define visualize mccchannel_4_analyzer_2_array_crystal_array_1_visualize
#define target_index mccchannel_4_analyzer_2_array_crystal_array_1_target_index
#define target_x mccchannel_4_analyzer_2_array_crystal_array_1_target_x
#define target_y mccchannel_4_analyzer_2_array_crystal_array_1_target_y
#define target_z mccchannel_4_analyzer_2_array_crystal_array_1_target_z
#define focus_aw mccchannel_4_analyzer_2_array_crystal_array_1_focus_aw
#define focus_ah mccchannel_4_analyzer_2_array_crystal_array_1_focus_ah
#define focus_xw mccchannel_4_analyzer_2_array_crystal_array_1_focus_xw
#define focus_xh mccchannel_4_analyzer_2_array_crystal_array_1_focus_xh
#define focus_r mccchannel_4_analyzer_2_array_crystal_array_1_focus_r
#define p_interact mccchannel_4_analyzer_2_array_crystal_array_1_p_interact
#define mask_string mccchannel_4_analyzer_2_array_crystal_array_1_mask_string
#define mask_setting mccchannel_4_analyzer_2_array_crystal_array_1_mask_setting
#define number_of_activations mccchannel_4_analyzer_2_array_crystal_array_1_number_of_activations
#line 224 "Union_box.comp"
{
// Initializes the focusing system for this volume including input sanitation.
focus_initialize(&this_box_volume.geometry, POS_A_COMP_INDEX(INDEX_CURRENT_COMP+target_index), POS_A_CURRENT_COMP, ROT_A_CURRENT_COMP, target_index, target_x, target_y, target_z, focus_aw, focus_ah, focus_xw, focus_xh, focus_r, NAME_CURRENT_COMP);

// Input sanitation for this geometry
if (xwidth <= 0) {
  printf("\nERROR in Union_box named %s, the xwidth is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (yheight <= 0) {
  printf("\nERROR in Union_box named %s, yheight is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (zdepth <= 0) {
  printf("\nERROR in Union_box named %s, zdepth is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (xwidth2 <= 0 && xwidth2 != -1) {
  printf("\nERROR in Union_box named %s, the xwidth2 is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (yheight2 <= 0 && yheight2 != -1) {
  printf("\nERROR in Union_box named %s, yheight2 is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}

// Use sanitation
if (global_material_list.num_elements == 0) {
  printf("\nERROR: Need to define a material using Union_make_material before using a Union geometry component. \n");
  printf("       %s was defined before first use of Union_make_material.\n",NAME_CURRENT_COMP);
  exit(1);
}

this_box_volume.geometry.is_masked_volume = 0;
this_box_volume.geometry.is_exit_volume = 0;
this_box_volume.geometry.is_mask_volume = 0;
// check if the volume is a mask, if it is the material string is irelevant.
if (mask_string && strlen(mask_string) && strcmp(mask_string, "NULL") && strcmp(mask_string, "0")) {
    // A mask volume is used to limit the extend of other volumes, called the masked volumes. These are specified in the mask_string.
    // In order for a ray to enter a masked volume, it needs to be both in the region covered by that volume AND the mask volume.
    // When more than
    this_box_volume.geometry.mask_mode = 1; // Default is mask mode is ALL
    if (mask_setting && strlen(mask_setting) && strcmp(mask_setting, "NULL") && strcmp(mask_setting, "0")) {
        if (strcmp(mask_setting,"ALL") == 0 || strcmp(mask_setting,"All") == 0) this_box_volume.geometry.mask_mode = 1;
        else if (strcmp(mask_setting,"ANY") == 0 || strcmp(mask_setting,"Any") == 0) this_box_volume.geometry.mask_mode = 2;
        else {
            printf("The mask_mode of component %s is set to %s, but must be either ALL or ANY.\n",NAME_CURRENT_COMP,mask_setting);
            exit(1);
        }
    }
    
    for (loop_index=0;loop_index<global_geometry_list.num_elements;loop_index++) {
        // Add mask list
        if (1 == manual_linking_function(global_geometry_list.elements[loop_index].name,mask_string)) {
            add_element_to_int_list(&this_box_volume.geometry.mask_list,global_geometry_list.elements[loop_index].component_index);
            add_element_to_int_list(&global_geometry_list.elements[loop_index].Volume->geometry.masked_by_list,INDEX_CURRENT_COMP);
            global_geometry_list.elements[loop_index].Volume->geometry.is_masked_volume = 1;
            if (this_box_volume.geometry.mask_mode == 2)
                global_geometry_list.elements[loop_index].Volume->geometry.mask_mode = 2;
            if (this_box_volume.geometry.mask_mode == 1) {
                if (global_geometry_list.elements[loop_index].Volume->geometry.is_masked_volume == 1 && global_geometry_list.elements[loop_index].Volume->geometry.mask_mode != 2)
                    // If more than one mask is added to one volume, the ANY mode overwrites the (default) ALL mode.
                    global_geometry_list.elements[loop_index].Volume->geometry.mask_mode = 1;
            }
            
            found_geometries = 1;
        }
    }
    if (found_geometries == 0) {
        printf("The mask_string in geometry: %s did not find any of the specified volumes in the mask_string %s \n",NAME_CURRENT_COMP,mask_string);
        exit(1);
    }
    this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
    this_box_volume.p_physics->is_vacuum = 0; // Makes this volume a vacuum
    this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
    this_box_volume.p_physics->my_a = 0; // Should not be used.
    sprintf(this_box_volume.p_physics->name,"Mask");
    this_box_volume.geometry.is_mask_volume = 1;
    
    
// Read the material input, or if it lacks, use automatic linking.
} else if (material_string && strlen(material_string) && strcmp(material_string, "NULL") && strcmp(material_string, "0")) {
    // A geometry string was given, use it to determine which material
    if (0 == strcmp(material_string,"vacuum") || 0 == strcmp(material_string,"Vacuum")) {
        // One could have a global physics struct for vacuum instead of creating one for each
        this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
        this_box_volume.p_physics->is_vacuum = 1; // Makes this volume a vacuum
        this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
        this_box_volume.p_physics->my_a = 0; // Should not be used.
        sprintf(this_box_volume.p_physics->name,"Vacuum");
    } else if (0 == strcmp(material_string,"exit") || 0 == strcmp(material_string,"Exit")) {
        // One could have a global physics struct for vacuum instead of creating one for each
        this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
        this_box_volume.p_physics->is_vacuum = 1; // Makes this volume a vacuum
        this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
        this_box_volume.p_physics->my_a = 0; // Should not be used.
        this_box_volume.geometry.is_exit_volume = 1;
        sprintf(this_box_volume.p_physics->name,"Exit");
    } else {
        #ifndef MATERIAL_DETECTOR
            printf("Need to define a material before refering to it in a geometry %s.\n",NAME_CURRENT_COMP);
            exit(1);
        #endif
        for (loop_index=0;loop_index<global_material_list.num_elements;loop_index++) {
            if (0 == strcmp(material_string,global_material_list.elements[loop_index].name)) {
                this_box_volume.p_physics = global_material_list.elements[loop_index].physics;
                break;
            }
            if (loop_index == global_material_list.num_elements-1) {
            printf("\n");
            printf("ERROR: The material string \"%s\" in Union geometry \"%s\" did not match a specified material. \n",material_string,NAME_CURRENT_COMP);
            printf("       The materials available at this point (need to be defined before the geometry): \n");
            for (loop_index=0;loop_index<global_material_list.num_elements;loop_index++)
              printf("         %s\n",global_material_list.elements[loop_index].name);
            printf("\n");
            printf("       It is also possible to use one of the defualt materials avaiable: \n");
            printf("           Vacuum (for a Volume without scattering or absorption)\n");
            printf("           Exit (for a Volume where the ray exits the component if it enters)\n");
            printf("           Mask (for a Volume that masks existing volumes specified in the mask_string\n");
            exit(1);
          }
        }
    }
} else {
    // Automatic linking, simply using the last defined material.
    #ifndef MATERIAL_DETECTOR
        printf("Need to define a material before the geometry to use automatic linking %s.\n",NAME_CURRENT_COMP);
        exit(1);
    #endif
    this_box_volume.p_physics = global_material_list.elements[global_material_list.num_elements-1].physics;
}

sprintf(this_box_volume.name,NAME_CURRENT_COMP);
sprintf(this_box_volume.geometry.shape,"box");
this_box_volume.geometry.priority_value = priority;
this_box_volume.geometry.geometry_p_interact = p_interact;
// Currently the coordinates will be in absolute space.
this_box_volume.geometry.center = POS_A_CURRENT_COMP;

this_box_storage.z_depth = zdepth;
this_box_storage.x_width1 = xwidth;
this_box_storage.y_height1 = yheight;

this_box_storage.is_rectangle = 0;
if (xwidth2 < 0 && yheight2 < 0) this_box_storage.is_rectangle = 1;
if (xwidth == xwidth2 && yheight == yheight2) this_box_storage.is_rectangle = 1;

if (xwidth2 < 0) {
    this_box_storage.x_width2 = xwidth;
    xwidth2 = xwidth;
} else this_box_storage.x_width2 = xwidth2;

if (yheight2 < 0) {
    this_box_storage.y_height2 = yheight;
    yheight2 = yheight;
} else this_box_storage.y_height2 = yheight2;


this_box_storage.normal_vectors[0] = coords_set(0,0,1);
this_box_storage.normal_vectors[1] = coords_set(0,0,1);

// for sides with y component = 0
x_component = 2*zdepth/sqrt((xwidth-xwidth2)*(xwidth-xwidth2)+4*zdepth*zdepth);
z_component = (xwidth-xwidth2)/sqrt(4*zdepth*zdepth+(xwidth-xwidth2)*(xwidth-xwidth2));

this_box_storage.normal_vectors[2] = coords_set(x_component,0,z_component);
this_box_storage.normal_vectors[3] = coords_set(-x_component,0,z_component);

// for sides with x component = 0
y_component = 2*zdepth/sqrt((yheight-yheight2)*(yheight-yheight2)+4*zdepth*zdepth);
z_component = (yheight-yheight2)/sqrt(4*zdepth*zdepth+(yheight-yheight2)*(yheight-yheight2));

this_box_storage.normal_vectors[4] = coords_set(0,y_component,z_component);
this_box_storage.normal_vectors[5] = coords_set(0,-y_component,z_component);

this_box_volume.geometry.visualization_on = visualize;

this_box_volume.geometry.geometry_parameters.p_box_storage = &this_box_storage;

// Assign pointers to functions for intersection with the shape, checking if a point is inside the shape
if (this_box_storage.is_rectangle == 1) {
this_box_volume.geometry.intersect_function = &sample_box_intersect_simple;
this_box_volume.geometry.within_function = &r_within_box_simple;
}
else {
this_box_volume.geometry.intersect_function = &sample_box_intersect_advanced;
this_box_volume.geometry.within_function = &r_within_box_advanced;
}

this_box_volume.geometry.shell_points = &box_shell_points;
this_box_volume.geometry.mcdisplay_function = &mcdisplay_box_function;
this_box_volume.geometry.initialize_from_main_function = &initialize_box_geometry_from_main_component;
this_box_volume.geometry.process_rot_allocated = 0;

this_box_volume.geometry.copy_geometry_parameters = &allocate_box_storage_copy;

rot_copy(this_box_volume.geometry.rotation_matrix,ROT_A_CURRENT_COMP); //check how ROT_R_CURRENT_COMP would work
rot_transpose(ROT_A_CURRENT_COMP,this_box_volume.geometry.transpose_rotation_matrix);

// Initialize loggers
this_box_volume.loggers.num_elements = 0;

// packing the information into the global_geometry_element, which is then included in the global_geometry_list.
sprintf(global_geometry_element.name,NAME_CURRENT_COMP);
global_geometry_element.activation_counter = number_of_activations;
global_geometry_element.component_index = INDEX_CURRENT_COMP;
global_geometry_element.Volume = &this_box_volume; // Would be nicer if this m was a pointer, now we have the (small) data two places
add_element_to_geometry_list(&global_geometry_list,global_geometry_element);
}
#line 203723 "MACS_sample_kidney_box.c"
#undef number_of_activations
#undef mask_setting
#undef mask_string
#undef p_interact
#undef focus_r
#undef focus_xh
#undef focus_xw
#undef focus_ah
#undef focus_aw
#undef target_z
#undef target_y
#undef target_x
#undef target_index
#undef visualize
#undef yheight2
#undef xwidth2
#undef zdepth
#undef yheight
#undef xwidth
#undef priority
#undef material_string
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

  /* Initializations for component channel_4_analyzer_2_array_crystal_array_2. */
  SIG_MESSAGE("channel_4_analyzer_2_array_crystal_array_2 (Init)");
#define mccompcurname  channel_4_analyzer_2_array_crystal_array_2
#define mccompcurtype  Union_box
#define mccompcurindex 295
#define loop_index mccchannel_4_analyzer_2_array_crystal_array_2_loop_index
#define this_box_volume mccchannel_4_analyzer_2_array_crystal_array_2_this_box_volume
#define global_geometry_element mccchannel_4_analyzer_2_array_crystal_array_2_global_geometry_element
#define this_box_storage mccchannel_4_analyzer_2_array_crystal_array_2_this_box_storage
#define material_string mccchannel_4_analyzer_2_array_crystal_array_2_material_string
#define priority mccchannel_4_analyzer_2_array_crystal_array_2_priority
#define xwidth mccchannel_4_analyzer_2_array_crystal_array_2_xwidth
#define yheight mccchannel_4_analyzer_2_array_crystal_array_2_yheight
#define zdepth mccchannel_4_analyzer_2_array_crystal_array_2_zdepth
#define xwidth2 mccchannel_4_analyzer_2_array_crystal_array_2_xwidth2
#define yheight2 mccchannel_4_analyzer_2_array_crystal_array_2_yheight2
#define visualize mccchannel_4_analyzer_2_array_crystal_array_2_visualize
#define target_index mccchannel_4_analyzer_2_array_crystal_array_2_target_index
#define target_x mccchannel_4_analyzer_2_array_crystal_array_2_target_x
#define target_y mccchannel_4_analyzer_2_array_crystal_array_2_target_y
#define target_z mccchannel_4_analyzer_2_array_crystal_array_2_target_z
#define focus_aw mccchannel_4_analyzer_2_array_crystal_array_2_focus_aw
#define focus_ah mccchannel_4_analyzer_2_array_crystal_array_2_focus_ah
#define focus_xw mccchannel_4_analyzer_2_array_crystal_array_2_focus_xw
#define focus_xh mccchannel_4_analyzer_2_array_crystal_array_2_focus_xh
#define focus_r mccchannel_4_analyzer_2_array_crystal_array_2_focus_r
#define p_interact mccchannel_4_analyzer_2_array_crystal_array_2_p_interact
#define mask_string mccchannel_4_analyzer_2_array_crystal_array_2_mask_string
#define mask_setting mccchannel_4_analyzer_2_array_crystal_array_2_mask_setting
#define number_of_activations mccchannel_4_analyzer_2_array_crystal_array_2_number_of_activations
#line 224 "Union_box.comp"
{
// Initializes the focusing system for this volume including input sanitation.
focus_initialize(&this_box_volume.geometry, POS_A_COMP_INDEX(INDEX_CURRENT_COMP+target_index), POS_A_CURRENT_COMP, ROT_A_CURRENT_COMP, target_index, target_x, target_y, target_z, focus_aw, focus_ah, focus_xw, focus_xh, focus_r, NAME_CURRENT_COMP);

// Input sanitation for this geometry
if (xwidth <= 0) {
  printf("\nERROR in Union_box named %s, the xwidth is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (yheight <= 0) {
  printf("\nERROR in Union_box named %s, yheight is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (zdepth <= 0) {
  printf("\nERROR in Union_box named %s, zdepth is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (xwidth2 <= 0 && xwidth2 != -1) {
  printf("\nERROR in Union_box named %s, the xwidth2 is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (yheight2 <= 0 && yheight2 != -1) {
  printf("\nERROR in Union_box named %s, yheight2 is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}

// Use sanitation
if (global_material_list.num_elements == 0) {
  printf("\nERROR: Need to define a material using Union_make_material before using a Union geometry component. \n");
  printf("       %s was defined before first use of Union_make_material.\n",NAME_CURRENT_COMP);
  exit(1);
}

this_box_volume.geometry.is_masked_volume = 0;
this_box_volume.geometry.is_exit_volume = 0;
this_box_volume.geometry.is_mask_volume = 0;
// check if the volume is a mask, if it is the material string is irelevant.
if (mask_string && strlen(mask_string) && strcmp(mask_string, "NULL") && strcmp(mask_string, "0")) {
    // A mask volume is used to limit the extend of other volumes, called the masked volumes. These are specified in the mask_string.
    // In order for a ray to enter a masked volume, it needs to be both in the region covered by that volume AND the mask volume.
    // When more than
    this_box_volume.geometry.mask_mode = 1; // Default is mask mode is ALL
    if (mask_setting && strlen(mask_setting) && strcmp(mask_setting, "NULL") && strcmp(mask_setting, "0")) {
        if (strcmp(mask_setting,"ALL") == 0 || strcmp(mask_setting,"All") == 0) this_box_volume.geometry.mask_mode = 1;
        else if (strcmp(mask_setting,"ANY") == 0 || strcmp(mask_setting,"Any") == 0) this_box_volume.geometry.mask_mode = 2;
        else {
            printf("The mask_mode of component %s is set to %s, but must be either ALL or ANY.\n",NAME_CURRENT_COMP,mask_setting);
            exit(1);
        }
    }
    
    for (loop_index=0;loop_index<global_geometry_list.num_elements;loop_index++) {
        // Add mask list
        if (1 == manual_linking_function(global_geometry_list.elements[loop_index].name,mask_string)) {
            add_element_to_int_list(&this_box_volume.geometry.mask_list,global_geometry_list.elements[loop_index].component_index);
            add_element_to_int_list(&global_geometry_list.elements[loop_index].Volume->geometry.masked_by_list,INDEX_CURRENT_COMP);
            global_geometry_list.elements[loop_index].Volume->geometry.is_masked_volume = 1;
            if (this_box_volume.geometry.mask_mode == 2)
                global_geometry_list.elements[loop_index].Volume->geometry.mask_mode = 2;
            if (this_box_volume.geometry.mask_mode == 1) {
                if (global_geometry_list.elements[loop_index].Volume->geometry.is_masked_volume == 1 && global_geometry_list.elements[loop_index].Volume->geometry.mask_mode != 2)
                    // If more than one mask is added to one volume, the ANY mode overwrites the (default) ALL mode.
                    global_geometry_list.elements[loop_index].Volume->geometry.mask_mode = 1;
            }
            
            found_geometries = 1;
        }
    }
    if (found_geometries == 0) {
        printf("The mask_string in geometry: %s did not find any of the specified volumes in the mask_string %s \n",NAME_CURRENT_COMP,mask_string);
        exit(1);
    }
    this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
    this_box_volume.p_physics->is_vacuum = 0; // Makes this volume a vacuum
    this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
    this_box_volume.p_physics->my_a = 0; // Should not be used.
    sprintf(this_box_volume.p_physics->name,"Mask");
    this_box_volume.geometry.is_mask_volume = 1;
    
    
// Read the material input, or if it lacks, use automatic linking.
} else if (material_string && strlen(material_string) && strcmp(material_string, "NULL") && strcmp(material_string, "0")) {
    // A geometry string was given, use it to determine which material
    if (0 == strcmp(material_string,"vacuum") || 0 == strcmp(material_string,"Vacuum")) {
        // One could have a global physics struct for vacuum instead of creating one for each
        this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
        this_box_volume.p_physics->is_vacuum = 1; // Makes this volume a vacuum
        this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
        this_box_volume.p_physics->my_a = 0; // Should not be used.
        sprintf(this_box_volume.p_physics->name,"Vacuum");
    } else if (0 == strcmp(material_string,"exit") || 0 == strcmp(material_string,"Exit")) {
        // One could have a global physics struct for vacuum instead of creating one for each
        this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
        this_box_volume.p_physics->is_vacuum = 1; // Makes this volume a vacuum
        this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
        this_box_volume.p_physics->my_a = 0; // Should not be used.
        this_box_volume.geometry.is_exit_volume = 1;
        sprintf(this_box_volume.p_physics->name,"Exit");
    } else {
        #ifndef MATERIAL_DETECTOR
            printf("Need to define a material before refering to it in a geometry %s.\n",NAME_CURRENT_COMP);
            exit(1);
        #endif
        for (loop_index=0;loop_index<global_material_list.num_elements;loop_index++) {
            if (0 == strcmp(material_string,global_material_list.elements[loop_index].name)) {
                this_box_volume.p_physics = global_material_list.elements[loop_index].physics;
                break;
            }
            if (loop_index == global_material_list.num_elements-1) {
            printf("\n");
            printf("ERROR: The material string \"%s\" in Union geometry \"%s\" did not match a specified material. \n",material_string,NAME_CURRENT_COMP);
            printf("       The materials available at this point (need to be defined before the geometry): \n");
            for (loop_index=0;loop_index<global_material_list.num_elements;loop_index++)
              printf("         %s\n",global_material_list.elements[loop_index].name);
            printf("\n");
            printf("       It is also possible to use one of the defualt materials avaiable: \n");
            printf("           Vacuum (for a Volume without scattering or absorption)\n");
            printf("           Exit (for a Volume where the ray exits the component if it enters)\n");
            printf("           Mask (for a Volume that masks existing volumes specified in the mask_string\n");
            exit(1);
          }
        }
    }
} else {
    // Automatic linking, simply using the last defined material.
    #ifndef MATERIAL_DETECTOR
        printf("Need to define a material before the geometry to use automatic linking %s.\n",NAME_CURRENT_COMP);
        exit(1);
    #endif
    this_box_volume.p_physics = global_material_list.elements[global_material_list.num_elements-1].physics;
}

sprintf(this_box_volume.name,NAME_CURRENT_COMP);
sprintf(this_box_volume.geometry.shape,"box");
this_box_volume.geometry.priority_value = priority;
this_box_volume.geometry.geometry_p_interact = p_interact;
// Currently the coordinates will be in absolute space.
this_box_volume.geometry.center = POS_A_CURRENT_COMP;

this_box_storage.z_depth = zdepth;
this_box_storage.x_width1 = xwidth;
this_box_storage.y_height1 = yheight;

this_box_storage.is_rectangle = 0;
if (xwidth2 < 0 && yheight2 < 0) this_box_storage.is_rectangle = 1;
if (xwidth == xwidth2 && yheight == yheight2) this_box_storage.is_rectangle = 1;

if (xwidth2 < 0) {
    this_box_storage.x_width2 = xwidth;
    xwidth2 = xwidth;
} else this_box_storage.x_width2 = xwidth2;

if (yheight2 < 0) {
    this_box_storage.y_height2 = yheight;
    yheight2 = yheight;
} else this_box_storage.y_height2 = yheight2;


this_box_storage.normal_vectors[0] = coords_set(0,0,1);
this_box_storage.normal_vectors[1] = coords_set(0,0,1);

// for sides with y component = 0
x_component = 2*zdepth/sqrt((xwidth-xwidth2)*(xwidth-xwidth2)+4*zdepth*zdepth);
z_component = (xwidth-xwidth2)/sqrt(4*zdepth*zdepth+(xwidth-xwidth2)*(xwidth-xwidth2));

this_box_storage.normal_vectors[2] = coords_set(x_component,0,z_component);
this_box_storage.normal_vectors[3] = coords_set(-x_component,0,z_component);

// for sides with x component = 0
y_component = 2*zdepth/sqrt((yheight-yheight2)*(yheight-yheight2)+4*zdepth*zdepth);
z_component = (yheight-yheight2)/sqrt(4*zdepth*zdepth+(yheight-yheight2)*(yheight-yheight2));

this_box_storage.normal_vectors[4] = coords_set(0,y_component,z_component);
this_box_storage.normal_vectors[5] = coords_set(0,-y_component,z_component);

this_box_volume.geometry.visualization_on = visualize;

this_box_volume.geometry.geometry_parameters.p_box_storage = &this_box_storage;

// Assign pointers to functions for intersection with the shape, checking if a point is inside the shape
if (this_box_storage.is_rectangle == 1) {
this_box_volume.geometry.intersect_function = &sample_box_intersect_simple;
this_box_volume.geometry.within_function = &r_within_box_simple;
}
else {
this_box_volume.geometry.intersect_function = &sample_box_intersect_advanced;
this_box_volume.geometry.within_function = &r_within_box_advanced;
}

this_box_volume.geometry.shell_points = &box_shell_points;
this_box_volume.geometry.mcdisplay_function = &mcdisplay_box_function;
this_box_volume.geometry.initialize_from_main_function = &initialize_box_geometry_from_main_component;
this_box_volume.geometry.process_rot_allocated = 0;

this_box_volume.geometry.copy_geometry_parameters = &allocate_box_storage_copy;

rot_copy(this_box_volume.geometry.rotation_matrix,ROT_A_CURRENT_COMP); //check how ROT_R_CURRENT_COMP would work
rot_transpose(ROT_A_CURRENT_COMP,this_box_volume.geometry.transpose_rotation_matrix);

// Initialize loggers
this_box_volume.loggers.num_elements = 0;

// packing the information into the global_geometry_element, which is then included in the global_geometry_list.
sprintf(global_geometry_element.name,NAME_CURRENT_COMP);
global_geometry_element.activation_counter = number_of_activations;
global_geometry_element.component_index = INDEX_CURRENT_COMP;
global_geometry_element.Volume = &this_box_volume; // Would be nicer if this m was a pointer, now we have the (small) data two places
add_element_to_geometry_list(&global_geometry_list,global_geometry_element);
}
#line 203993 "MACS_sample_kidney_box.c"
#undef number_of_activations
#undef mask_setting
#undef mask_string
#undef p_interact
#undef focus_r
#undef focus_xh
#undef focus_xw
#undef focus_ah
#undef focus_aw
#undef target_z
#undef target_y
#undef target_x
#undef target_index
#undef visualize
#undef yheight2
#undef xwidth2
#undef zdepth
#undef yheight
#undef xwidth
#undef priority
#undef material_string
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

  /* Initializations for component channel_4_analyzer_2_array_crystal_array_3. */
  SIG_MESSAGE("channel_4_analyzer_2_array_crystal_array_3 (Init)");
#define mccompcurname  channel_4_analyzer_2_array_crystal_array_3
#define mccompcurtype  Union_box
#define mccompcurindex 296
#define loop_index mccchannel_4_analyzer_2_array_crystal_array_3_loop_index
#define this_box_volume mccchannel_4_analyzer_2_array_crystal_array_3_this_box_volume
#define global_geometry_element mccchannel_4_analyzer_2_array_crystal_array_3_global_geometry_element
#define this_box_storage mccchannel_4_analyzer_2_array_crystal_array_3_this_box_storage
#define material_string mccchannel_4_analyzer_2_array_crystal_array_3_material_string
#define priority mccchannel_4_analyzer_2_array_crystal_array_3_priority
#define xwidth mccchannel_4_analyzer_2_array_crystal_array_3_xwidth
#define yheight mccchannel_4_analyzer_2_array_crystal_array_3_yheight
#define zdepth mccchannel_4_analyzer_2_array_crystal_array_3_zdepth
#define xwidth2 mccchannel_4_analyzer_2_array_crystal_array_3_xwidth2
#define yheight2 mccchannel_4_analyzer_2_array_crystal_array_3_yheight2
#define visualize mccchannel_4_analyzer_2_array_crystal_array_3_visualize
#define target_index mccchannel_4_analyzer_2_array_crystal_array_3_target_index
#define target_x mccchannel_4_analyzer_2_array_crystal_array_3_target_x
#define target_y mccchannel_4_analyzer_2_array_crystal_array_3_target_y
#define target_z mccchannel_4_analyzer_2_array_crystal_array_3_target_z
#define focus_aw mccchannel_4_analyzer_2_array_crystal_array_3_focus_aw
#define focus_ah mccchannel_4_analyzer_2_array_crystal_array_3_focus_ah
#define focus_xw mccchannel_4_analyzer_2_array_crystal_array_3_focus_xw
#define focus_xh mccchannel_4_analyzer_2_array_crystal_array_3_focus_xh
#define focus_r mccchannel_4_analyzer_2_array_crystal_array_3_focus_r
#define p_interact mccchannel_4_analyzer_2_array_crystal_array_3_p_interact
#define mask_string mccchannel_4_analyzer_2_array_crystal_array_3_mask_string
#define mask_setting mccchannel_4_analyzer_2_array_crystal_array_3_mask_setting
#define number_of_activations mccchannel_4_analyzer_2_array_crystal_array_3_number_of_activations
#line 224 "Union_box.comp"
{
// Initializes the focusing system for this volume including input sanitation.
focus_initialize(&this_box_volume.geometry, POS_A_COMP_INDEX(INDEX_CURRENT_COMP+target_index), POS_A_CURRENT_COMP, ROT_A_CURRENT_COMP, target_index, target_x, target_y, target_z, focus_aw, focus_ah, focus_xw, focus_xh, focus_r, NAME_CURRENT_COMP);

// Input sanitation for this geometry
if (xwidth <= 0) {
  printf("\nERROR in Union_box named %s, the xwidth is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (yheight <= 0) {
  printf("\nERROR in Union_box named %s, yheight is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (zdepth <= 0) {
  printf("\nERROR in Union_box named %s, zdepth is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (xwidth2 <= 0 && xwidth2 != -1) {
  printf("\nERROR in Union_box named %s, the xwidth2 is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (yheight2 <= 0 && yheight2 != -1) {
  printf("\nERROR in Union_box named %s, yheight2 is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}

// Use sanitation
if (global_material_list.num_elements == 0) {
  printf("\nERROR: Need to define a material using Union_make_material before using a Union geometry component. \n");
  printf("       %s was defined before first use of Union_make_material.\n",NAME_CURRENT_COMP);
  exit(1);
}

this_box_volume.geometry.is_masked_volume = 0;
this_box_volume.geometry.is_exit_volume = 0;
this_box_volume.geometry.is_mask_volume = 0;
// check if the volume is a mask, if it is the material string is irelevant.
if (mask_string && strlen(mask_string) && strcmp(mask_string, "NULL") && strcmp(mask_string, "0")) {
    // A mask volume is used to limit the extend of other volumes, called the masked volumes. These are specified in the mask_string.
    // In order for a ray to enter a masked volume, it needs to be both in the region covered by that volume AND the mask volume.
    // When more than
    this_box_volume.geometry.mask_mode = 1; // Default is mask mode is ALL
    if (mask_setting && strlen(mask_setting) && strcmp(mask_setting, "NULL") && strcmp(mask_setting, "0")) {
        if (strcmp(mask_setting,"ALL") == 0 || strcmp(mask_setting,"All") == 0) this_box_volume.geometry.mask_mode = 1;
        else if (strcmp(mask_setting,"ANY") == 0 || strcmp(mask_setting,"Any") == 0) this_box_volume.geometry.mask_mode = 2;
        else {
            printf("The mask_mode of component %s is set to %s, but must be either ALL or ANY.\n",NAME_CURRENT_COMP,mask_setting);
            exit(1);
        }
    }
    
    for (loop_index=0;loop_index<global_geometry_list.num_elements;loop_index++) {
        // Add mask list
        if (1 == manual_linking_function(global_geometry_list.elements[loop_index].name,mask_string)) {
            add_element_to_int_list(&this_box_volume.geometry.mask_list,global_geometry_list.elements[loop_index].component_index);
            add_element_to_int_list(&global_geometry_list.elements[loop_index].Volume->geometry.masked_by_list,INDEX_CURRENT_COMP);
            global_geometry_list.elements[loop_index].Volume->geometry.is_masked_volume = 1;
            if (this_box_volume.geometry.mask_mode == 2)
                global_geometry_list.elements[loop_index].Volume->geometry.mask_mode = 2;
            if (this_box_volume.geometry.mask_mode == 1) {
                if (global_geometry_list.elements[loop_index].Volume->geometry.is_masked_volume == 1 && global_geometry_list.elements[loop_index].Volume->geometry.mask_mode != 2)
                    // If more than one mask is added to one volume, the ANY mode overwrites the (default) ALL mode.
                    global_geometry_list.elements[loop_index].Volume->geometry.mask_mode = 1;
            }
            
            found_geometries = 1;
        }
    }
    if (found_geometries == 0) {
        printf("The mask_string in geometry: %s did not find any of the specified volumes in the mask_string %s \n",NAME_CURRENT_COMP,mask_string);
        exit(1);
    }
    this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
    this_box_volume.p_physics->is_vacuum = 0; // Makes this volume a vacuum
    this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
    this_box_volume.p_physics->my_a = 0; // Should not be used.
    sprintf(this_box_volume.p_physics->name,"Mask");
    this_box_volume.geometry.is_mask_volume = 1;
    
    
// Read the material input, or if it lacks, use automatic linking.
} else if (material_string && strlen(material_string) && strcmp(material_string, "NULL") && strcmp(material_string, "0")) {
    // A geometry string was given, use it to determine which material
    if (0 == strcmp(material_string,"vacuum") || 0 == strcmp(material_string,"Vacuum")) {
        // One could have a global physics struct for vacuum instead of creating one for each
        this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
        this_box_volume.p_physics->is_vacuum = 1; // Makes this volume a vacuum
        this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
        this_box_volume.p_physics->my_a = 0; // Should not be used.
        sprintf(this_box_volume.p_physics->name,"Vacuum");
    } else if (0 == strcmp(material_string,"exit") || 0 == strcmp(material_string,"Exit")) {
        // One could have a global physics struct for vacuum instead of creating one for each
        this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
        this_box_volume.p_physics->is_vacuum = 1; // Makes this volume a vacuum
        this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
        this_box_volume.p_physics->my_a = 0; // Should not be used.
        this_box_volume.geometry.is_exit_volume = 1;
        sprintf(this_box_volume.p_physics->name,"Exit");
    } else {
        #ifndef MATERIAL_DETECTOR
            printf("Need to define a material before refering to it in a geometry %s.\n",NAME_CURRENT_COMP);
            exit(1);
        #endif
        for (loop_index=0;loop_index<global_material_list.num_elements;loop_index++) {
            if (0 == strcmp(material_string,global_material_list.elements[loop_index].name)) {
                this_box_volume.p_physics = global_material_list.elements[loop_index].physics;
                break;
            }
            if (loop_index == global_material_list.num_elements-1) {
            printf("\n");
            printf("ERROR: The material string \"%s\" in Union geometry \"%s\" did not match a specified material. \n",material_string,NAME_CURRENT_COMP);
            printf("       The materials available at this point (need to be defined before the geometry): \n");
            for (loop_index=0;loop_index<global_material_list.num_elements;loop_index++)
              printf("         %s\n",global_material_list.elements[loop_index].name);
            printf("\n");
            printf("       It is also possible to use one of the defualt materials avaiable: \n");
            printf("           Vacuum (for a Volume without scattering or absorption)\n");
            printf("           Exit (for a Volume where the ray exits the component if it enters)\n");
            printf("           Mask (for a Volume that masks existing volumes specified in the mask_string\n");
            exit(1);
          }
        }
    }
} else {
    // Automatic linking, simply using the last defined material.
    #ifndef MATERIAL_DETECTOR
        printf("Need to define a material before the geometry to use automatic linking %s.\n",NAME_CURRENT_COMP);
        exit(1);
    #endif
    this_box_volume.p_physics = global_material_list.elements[global_material_list.num_elements-1].physics;
}

sprintf(this_box_volume.name,NAME_CURRENT_COMP);
sprintf(this_box_volume.geometry.shape,"box");
this_box_volume.geometry.priority_value = priority;
this_box_volume.geometry.geometry_p_interact = p_interact;
// Currently the coordinates will be in absolute space.
this_box_volume.geometry.center = POS_A_CURRENT_COMP;

this_box_storage.z_depth = zdepth;
this_box_storage.x_width1 = xwidth;
this_box_storage.y_height1 = yheight;

this_box_storage.is_rectangle = 0;
if (xwidth2 < 0 && yheight2 < 0) this_box_storage.is_rectangle = 1;
if (xwidth == xwidth2 && yheight == yheight2) this_box_storage.is_rectangle = 1;

if (xwidth2 < 0) {
    this_box_storage.x_width2 = xwidth;
    xwidth2 = xwidth;
} else this_box_storage.x_width2 = xwidth2;

if (yheight2 < 0) {
    this_box_storage.y_height2 = yheight;
    yheight2 = yheight;
} else this_box_storage.y_height2 = yheight2;


this_box_storage.normal_vectors[0] = coords_set(0,0,1);
this_box_storage.normal_vectors[1] = coords_set(0,0,1);

// for sides with y component = 0
x_component = 2*zdepth/sqrt((xwidth-xwidth2)*(xwidth-xwidth2)+4*zdepth*zdepth);
z_component = (xwidth-xwidth2)/sqrt(4*zdepth*zdepth+(xwidth-xwidth2)*(xwidth-xwidth2));

this_box_storage.normal_vectors[2] = coords_set(x_component,0,z_component);
this_box_storage.normal_vectors[3] = coords_set(-x_component,0,z_component);

// for sides with x component = 0
y_component = 2*zdepth/sqrt((yheight-yheight2)*(yheight-yheight2)+4*zdepth*zdepth);
z_component = (yheight-yheight2)/sqrt(4*zdepth*zdepth+(yheight-yheight2)*(yheight-yheight2));

this_box_storage.normal_vectors[4] = coords_set(0,y_component,z_component);
this_box_storage.normal_vectors[5] = coords_set(0,-y_component,z_component);

this_box_volume.geometry.visualization_on = visualize;

this_box_volume.geometry.geometry_parameters.p_box_storage = &this_box_storage;

// Assign pointers to functions for intersection with the shape, checking if a point is inside the shape
if (this_box_storage.is_rectangle == 1) {
this_box_volume.geometry.intersect_function = &sample_box_intersect_simple;
this_box_volume.geometry.within_function = &r_within_box_simple;
}
else {
this_box_volume.geometry.intersect_function = &sample_box_intersect_advanced;
this_box_volume.geometry.within_function = &r_within_box_advanced;
}

this_box_volume.geometry.shell_points = &box_shell_points;
this_box_volume.geometry.mcdisplay_function = &mcdisplay_box_function;
this_box_volume.geometry.initialize_from_main_function = &initialize_box_geometry_from_main_component;
this_box_volume.geometry.process_rot_allocated = 0;

this_box_volume.geometry.copy_geometry_parameters = &allocate_box_storage_copy;

rot_copy(this_box_volume.geometry.rotation_matrix,ROT_A_CURRENT_COMP); //check how ROT_R_CURRENT_COMP would work
rot_transpose(ROT_A_CURRENT_COMP,this_box_volume.geometry.transpose_rotation_matrix);

// Initialize loggers
this_box_volume.loggers.num_elements = 0;

// packing the information into the global_geometry_element, which is then included in the global_geometry_list.
sprintf(global_geometry_element.name,NAME_CURRENT_COMP);
global_geometry_element.activation_counter = number_of_activations;
global_geometry_element.component_index = INDEX_CURRENT_COMP;
global_geometry_element.Volume = &this_box_volume; // Would be nicer if this m was a pointer, now we have the (small) data two places
add_element_to_geometry_list(&global_geometry_list,global_geometry_element);
}
#line 204263 "MACS_sample_kidney_box.c"
#undef number_of_activations
#undef mask_setting
#undef mask_string
#undef p_interact
#undef focus_r
#undef focus_xh
#undef focus_xw
#undef focus_ah
#undef focus_aw
#undef target_z
#undef target_y
#undef target_x
#undef target_index
#undef visualize
#undef yheight2
#undef xwidth2
#undef zdepth
#undef yheight
#undef xwidth
#undef priority
#undef material_string
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

  /* Initializations for component channel_4_analyzer_2_array_crystal_array_4. */
  SIG_MESSAGE("channel_4_analyzer_2_array_crystal_array_4 (Init)");
#define mccompcurname  channel_4_analyzer_2_array_crystal_array_4
#define mccompcurtype  Union_box
#define mccompcurindex 297
#define loop_index mccchannel_4_analyzer_2_array_crystal_array_4_loop_index
#define this_box_volume mccchannel_4_analyzer_2_array_crystal_array_4_this_box_volume
#define global_geometry_element mccchannel_4_analyzer_2_array_crystal_array_4_global_geometry_element
#define this_box_storage mccchannel_4_analyzer_2_array_crystal_array_4_this_box_storage
#define material_string mccchannel_4_analyzer_2_array_crystal_array_4_material_string
#define priority mccchannel_4_analyzer_2_array_crystal_array_4_priority
#define xwidth mccchannel_4_analyzer_2_array_crystal_array_4_xwidth
#define yheight mccchannel_4_analyzer_2_array_crystal_array_4_yheight
#define zdepth mccchannel_4_analyzer_2_array_crystal_array_4_zdepth
#define xwidth2 mccchannel_4_analyzer_2_array_crystal_array_4_xwidth2
#define yheight2 mccchannel_4_analyzer_2_array_crystal_array_4_yheight2
#define visualize mccchannel_4_analyzer_2_array_crystal_array_4_visualize
#define target_index mccchannel_4_analyzer_2_array_crystal_array_4_target_index
#define target_x mccchannel_4_analyzer_2_array_crystal_array_4_target_x
#define target_y mccchannel_4_analyzer_2_array_crystal_array_4_target_y
#define target_z mccchannel_4_analyzer_2_array_crystal_array_4_target_z
#define focus_aw mccchannel_4_analyzer_2_array_crystal_array_4_focus_aw
#define focus_ah mccchannel_4_analyzer_2_array_crystal_array_4_focus_ah
#define focus_xw mccchannel_4_analyzer_2_array_crystal_array_4_focus_xw
#define focus_xh mccchannel_4_analyzer_2_array_crystal_array_4_focus_xh
#define focus_r mccchannel_4_analyzer_2_array_crystal_array_4_focus_r
#define p_interact mccchannel_4_analyzer_2_array_crystal_array_4_p_interact
#define mask_string mccchannel_4_analyzer_2_array_crystal_array_4_mask_string
#define mask_setting mccchannel_4_analyzer_2_array_crystal_array_4_mask_setting
#define number_of_activations mccchannel_4_analyzer_2_array_crystal_array_4_number_of_activations
#line 224 "Union_box.comp"
{
// Initializes the focusing system for this volume including input sanitation.
focus_initialize(&this_box_volume.geometry, POS_A_COMP_INDEX(INDEX_CURRENT_COMP+target_index), POS_A_CURRENT_COMP, ROT_A_CURRENT_COMP, target_index, target_x, target_y, target_z, focus_aw, focus_ah, focus_xw, focus_xh, focus_r, NAME_CURRENT_COMP);

// Input sanitation for this geometry
if (xwidth <= 0) {
  printf("\nERROR in Union_box named %s, the xwidth is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (yheight <= 0) {
  printf("\nERROR in Union_box named %s, yheight is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (zdepth <= 0) {
  printf("\nERROR in Union_box named %s, zdepth is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (xwidth2 <= 0 && xwidth2 != -1) {
  printf("\nERROR in Union_box named %s, the xwidth2 is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (yheight2 <= 0 && yheight2 != -1) {
  printf("\nERROR in Union_box named %s, yheight2 is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}

// Use sanitation
if (global_material_list.num_elements == 0) {
  printf("\nERROR: Need to define a material using Union_make_material before using a Union geometry component. \n");
  printf("       %s was defined before first use of Union_make_material.\n",NAME_CURRENT_COMP);
  exit(1);
}

this_box_volume.geometry.is_masked_volume = 0;
this_box_volume.geometry.is_exit_volume = 0;
this_box_volume.geometry.is_mask_volume = 0;
// check if the volume is a mask, if it is the material string is irelevant.
if (mask_string && strlen(mask_string) && strcmp(mask_string, "NULL") && strcmp(mask_string, "0")) {
    // A mask volume is used to limit the extend of other volumes, called the masked volumes. These are specified in the mask_string.
    // In order for a ray to enter a masked volume, it needs to be both in the region covered by that volume AND the mask volume.
    // When more than
    this_box_volume.geometry.mask_mode = 1; // Default is mask mode is ALL
    if (mask_setting && strlen(mask_setting) && strcmp(mask_setting, "NULL") && strcmp(mask_setting, "0")) {
        if (strcmp(mask_setting,"ALL") == 0 || strcmp(mask_setting,"All") == 0) this_box_volume.geometry.mask_mode = 1;
        else if (strcmp(mask_setting,"ANY") == 0 || strcmp(mask_setting,"Any") == 0) this_box_volume.geometry.mask_mode = 2;
        else {
            printf("The mask_mode of component %s is set to %s, but must be either ALL or ANY.\n",NAME_CURRENT_COMP,mask_setting);
            exit(1);
        }
    }
    
    for (loop_index=0;loop_index<global_geometry_list.num_elements;loop_index++) {
        // Add mask list
        if (1 == manual_linking_function(global_geometry_list.elements[loop_index].name,mask_string)) {
            add_element_to_int_list(&this_box_volume.geometry.mask_list,global_geometry_list.elements[loop_index].component_index);
            add_element_to_int_list(&global_geometry_list.elements[loop_index].Volume->geometry.masked_by_list,INDEX_CURRENT_COMP);
            global_geometry_list.elements[loop_index].Volume->geometry.is_masked_volume = 1;
            if (this_box_volume.geometry.mask_mode == 2)
                global_geometry_list.elements[loop_index].Volume->geometry.mask_mode = 2;
            if (this_box_volume.geometry.mask_mode == 1) {
                if (global_geometry_list.elements[loop_index].Volume->geometry.is_masked_volume == 1 && global_geometry_list.elements[loop_index].Volume->geometry.mask_mode != 2)
                    // If more than one mask is added to one volume, the ANY mode overwrites the (default) ALL mode.
                    global_geometry_list.elements[loop_index].Volume->geometry.mask_mode = 1;
            }
            
            found_geometries = 1;
        }
    }
    if (found_geometries == 0) {
        printf("The mask_string in geometry: %s did not find any of the specified volumes in the mask_string %s \n",NAME_CURRENT_COMP,mask_string);
        exit(1);
    }
    this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
    this_box_volume.p_physics->is_vacuum = 0; // Makes this volume a vacuum
    this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
    this_box_volume.p_physics->my_a = 0; // Should not be used.
    sprintf(this_box_volume.p_physics->name,"Mask");
    this_box_volume.geometry.is_mask_volume = 1;
    
    
// Read the material input, or if it lacks, use automatic linking.
} else if (material_string && strlen(material_string) && strcmp(material_string, "NULL") && strcmp(material_string, "0")) {
    // A geometry string was given, use it to determine which material
    if (0 == strcmp(material_string,"vacuum") || 0 == strcmp(material_string,"Vacuum")) {
        // One could have a global physics struct for vacuum instead of creating one for each
        this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
        this_box_volume.p_physics->is_vacuum = 1; // Makes this volume a vacuum
        this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
        this_box_volume.p_physics->my_a = 0; // Should not be used.
        sprintf(this_box_volume.p_physics->name,"Vacuum");
    } else if (0 == strcmp(material_string,"exit") || 0 == strcmp(material_string,"Exit")) {
        // One could have a global physics struct for vacuum instead of creating one for each
        this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
        this_box_volume.p_physics->is_vacuum = 1; // Makes this volume a vacuum
        this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
        this_box_volume.p_physics->my_a = 0; // Should not be used.
        this_box_volume.geometry.is_exit_volume = 1;
        sprintf(this_box_volume.p_physics->name,"Exit");
    } else {
        #ifndef MATERIAL_DETECTOR
            printf("Need to define a material before refering to it in a geometry %s.\n",NAME_CURRENT_COMP);
            exit(1);
        #endif
        for (loop_index=0;loop_index<global_material_list.num_elements;loop_index++) {
            if (0 == strcmp(material_string,global_material_list.elements[loop_index].name)) {
                this_box_volume.p_physics = global_material_list.elements[loop_index].physics;
                break;
            }
            if (loop_index == global_material_list.num_elements-1) {
            printf("\n");
            printf("ERROR: The material string \"%s\" in Union geometry \"%s\" did not match a specified material. \n",material_string,NAME_CURRENT_COMP);
            printf("       The materials available at this point (need to be defined before the geometry): \n");
            for (loop_index=0;loop_index<global_material_list.num_elements;loop_index++)
              printf("         %s\n",global_material_list.elements[loop_index].name);
            printf("\n");
            printf("       It is also possible to use one of the defualt materials avaiable: \n");
            printf("           Vacuum (for a Volume without scattering or absorption)\n");
            printf("           Exit (for a Volume where the ray exits the component if it enters)\n");
            printf("           Mask (for a Volume that masks existing volumes specified in the mask_string\n");
            exit(1);
          }
        }
    }
} else {
    // Automatic linking, simply using the last defined material.
    #ifndef MATERIAL_DETECTOR
        printf("Need to define a material before the geometry to use automatic linking %s.\n",NAME_CURRENT_COMP);
        exit(1);
    #endif
    this_box_volume.p_physics = global_material_list.elements[global_material_list.num_elements-1].physics;
}

sprintf(this_box_volume.name,NAME_CURRENT_COMP);
sprintf(this_box_volume.geometry.shape,"box");
this_box_volume.geometry.priority_value = priority;
this_box_volume.geometry.geometry_p_interact = p_interact;
// Currently the coordinates will be in absolute space.
this_box_volume.geometry.center = POS_A_CURRENT_COMP;

this_box_storage.z_depth = zdepth;
this_box_storage.x_width1 = xwidth;
this_box_storage.y_height1 = yheight;

this_box_storage.is_rectangle = 0;
if (xwidth2 < 0 && yheight2 < 0) this_box_storage.is_rectangle = 1;
if (xwidth == xwidth2 && yheight == yheight2) this_box_storage.is_rectangle = 1;

if (xwidth2 < 0) {
    this_box_storage.x_width2 = xwidth;
    xwidth2 = xwidth;
} else this_box_storage.x_width2 = xwidth2;

if (yheight2 < 0) {
    this_box_storage.y_height2 = yheight;
    yheight2 = yheight;
} else this_box_storage.y_height2 = yheight2;


this_box_storage.normal_vectors[0] = coords_set(0,0,1);
this_box_storage.normal_vectors[1] = coords_set(0,0,1);

// for sides with y component = 0
x_component = 2*zdepth/sqrt((xwidth-xwidth2)*(xwidth-xwidth2)+4*zdepth*zdepth);
z_component = (xwidth-xwidth2)/sqrt(4*zdepth*zdepth+(xwidth-xwidth2)*(xwidth-xwidth2));

this_box_storage.normal_vectors[2] = coords_set(x_component,0,z_component);
this_box_storage.normal_vectors[3] = coords_set(-x_component,0,z_component);

// for sides with x component = 0
y_component = 2*zdepth/sqrt((yheight-yheight2)*(yheight-yheight2)+4*zdepth*zdepth);
z_component = (yheight-yheight2)/sqrt(4*zdepth*zdepth+(yheight-yheight2)*(yheight-yheight2));

this_box_storage.normal_vectors[4] = coords_set(0,y_component,z_component);
this_box_storage.normal_vectors[5] = coords_set(0,-y_component,z_component);

this_box_volume.geometry.visualization_on = visualize;

this_box_volume.geometry.geometry_parameters.p_box_storage = &this_box_storage;

// Assign pointers to functions for intersection with the shape, checking if a point is inside the shape
if (this_box_storage.is_rectangle == 1) {
this_box_volume.geometry.intersect_function = &sample_box_intersect_simple;
this_box_volume.geometry.within_function = &r_within_box_simple;
}
else {
this_box_volume.geometry.intersect_function = &sample_box_intersect_advanced;
this_box_volume.geometry.within_function = &r_within_box_advanced;
}

this_box_volume.geometry.shell_points = &box_shell_points;
this_box_volume.geometry.mcdisplay_function = &mcdisplay_box_function;
this_box_volume.geometry.initialize_from_main_function = &initialize_box_geometry_from_main_component;
this_box_volume.geometry.process_rot_allocated = 0;

this_box_volume.geometry.copy_geometry_parameters = &allocate_box_storage_copy;

rot_copy(this_box_volume.geometry.rotation_matrix,ROT_A_CURRENT_COMP); //check how ROT_R_CURRENT_COMP would work
rot_transpose(ROT_A_CURRENT_COMP,this_box_volume.geometry.transpose_rotation_matrix);

// Initialize loggers
this_box_volume.loggers.num_elements = 0;

// packing the information into the global_geometry_element, which is then included in the global_geometry_list.
sprintf(global_geometry_element.name,NAME_CURRENT_COMP);
global_geometry_element.activation_counter = number_of_activations;
global_geometry_element.component_index = INDEX_CURRENT_COMP;
global_geometry_element.Volume = &this_box_volume; // Would be nicer if this m was a pointer, now we have the (small) data two places
add_element_to_geometry_list(&global_geometry_list,global_geometry_element);
}
#line 204533 "MACS_sample_kidney_box.c"
#undef number_of_activations
#undef mask_setting
#undef mask_string
#undef p_interact
#undef focus_r
#undef focus_xh
#undef focus_xw
#undef focus_ah
#undef focus_aw
#undef target_z
#undef target_y
#undef target_x
#undef target_index
#undef visualize
#undef yheight2
#undef xwidth2
#undef zdepth
#undef yheight
#undef xwidth
#undef priority
#undef material_string
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

  /* Initializations for component channel_4_analyzer_2_array_crystal_array_5. */
  SIG_MESSAGE("channel_4_analyzer_2_array_crystal_array_5 (Init)");
#define mccompcurname  channel_4_analyzer_2_array_crystal_array_5
#define mccompcurtype  Union_box
#define mccompcurindex 298
#define loop_index mccchannel_4_analyzer_2_array_crystal_array_5_loop_index
#define this_box_volume mccchannel_4_analyzer_2_array_crystal_array_5_this_box_volume
#define global_geometry_element mccchannel_4_analyzer_2_array_crystal_array_5_global_geometry_element
#define this_box_storage mccchannel_4_analyzer_2_array_crystal_array_5_this_box_storage
#define material_string mccchannel_4_analyzer_2_array_crystal_array_5_material_string
#define priority mccchannel_4_analyzer_2_array_crystal_array_5_priority
#define xwidth mccchannel_4_analyzer_2_array_crystal_array_5_xwidth
#define yheight mccchannel_4_analyzer_2_array_crystal_array_5_yheight
#define zdepth mccchannel_4_analyzer_2_array_crystal_array_5_zdepth
#define xwidth2 mccchannel_4_analyzer_2_array_crystal_array_5_xwidth2
#define yheight2 mccchannel_4_analyzer_2_array_crystal_array_5_yheight2
#define visualize mccchannel_4_analyzer_2_array_crystal_array_5_visualize
#define target_index mccchannel_4_analyzer_2_array_crystal_array_5_target_index
#define target_x mccchannel_4_analyzer_2_array_crystal_array_5_target_x
#define target_y mccchannel_4_analyzer_2_array_crystal_array_5_target_y
#define target_z mccchannel_4_analyzer_2_array_crystal_array_5_target_z
#define focus_aw mccchannel_4_analyzer_2_array_crystal_array_5_focus_aw
#define focus_ah mccchannel_4_analyzer_2_array_crystal_array_5_focus_ah
#define focus_xw mccchannel_4_analyzer_2_array_crystal_array_5_focus_xw
#define focus_xh mccchannel_4_analyzer_2_array_crystal_array_5_focus_xh
#define focus_r mccchannel_4_analyzer_2_array_crystal_array_5_focus_r
#define p_interact mccchannel_4_analyzer_2_array_crystal_array_5_p_interact
#define mask_string mccchannel_4_analyzer_2_array_crystal_array_5_mask_string
#define mask_setting mccchannel_4_analyzer_2_array_crystal_array_5_mask_setting
#define number_of_activations mccchannel_4_analyzer_2_array_crystal_array_5_number_of_activations
#line 224 "Union_box.comp"
{
// Initializes the focusing system for this volume including input sanitation.
focus_initialize(&this_box_volume.geometry, POS_A_COMP_INDEX(INDEX_CURRENT_COMP+target_index), POS_A_CURRENT_COMP, ROT_A_CURRENT_COMP, target_index, target_x, target_y, target_z, focus_aw, focus_ah, focus_xw, focus_xh, focus_r, NAME_CURRENT_COMP);

// Input sanitation for this geometry
if (xwidth <= 0) {
  printf("\nERROR in Union_box named %s, the xwidth is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (yheight <= 0) {
  printf("\nERROR in Union_box named %s, yheight is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (zdepth <= 0) {
  printf("\nERROR in Union_box named %s, zdepth is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (xwidth2 <= 0 && xwidth2 != -1) {
  printf("\nERROR in Union_box named %s, the xwidth2 is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (yheight2 <= 0 && yheight2 != -1) {
  printf("\nERROR in Union_box named %s, yheight2 is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}

// Use sanitation
if (global_material_list.num_elements == 0) {
  printf("\nERROR: Need to define a material using Union_make_material before using a Union geometry component. \n");
  printf("       %s was defined before first use of Union_make_material.\n",NAME_CURRENT_COMP);
  exit(1);
}

this_box_volume.geometry.is_masked_volume = 0;
this_box_volume.geometry.is_exit_volume = 0;
this_box_volume.geometry.is_mask_volume = 0;
// check if the volume is a mask, if it is the material string is irelevant.
if (mask_string && strlen(mask_string) && strcmp(mask_string, "NULL") && strcmp(mask_string, "0")) {
    // A mask volume is used to limit the extend of other volumes, called the masked volumes. These are specified in the mask_string.
    // In order for a ray to enter a masked volume, it needs to be both in the region covered by that volume AND the mask volume.
    // When more than
    this_box_volume.geometry.mask_mode = 1; // Default is mask mode is ALL
    if (mask_setting && strlen(mask_setting) && strcmp(mask_setting, "NULL") && strcmp(mask_setting, "0")) {
        if (strcmp(mask_setting,"ALL") == 0 || strcmp(mask_setting,"All") == 0) this_box_volume.geometry.mask_mode = 1;
        else if (strcmp(mask_setting,"ANY") == 0 || strcmp(mask_setting,"Any") == 0) this_box_volume.geometry.mask_mode = 2;
        else {
            printf("The mask_mode of component %s is set to %s, but must be either ALL or ANY.\n",NAME_CURRENT_COMP,mask_setting);
            exit(1);
        }
    }
    
    for (loop_index=0;loop_index<global_geometry_list.num_elements;loop_index++) {
        // Add mask list
        if (1 == manual_linking_function(global_geometry_list.elements[loop_index].name,mask_string)) {
            add_element_to_int_list(&this_box_volume.geometry.mask_list,global_geometry_list.elements[loop_index].component_index);
            add_element_to_int_list(&global_geometry_list.elements[loop_index].Volume->geometry.masked_by_list,INDEX_CURRENT_COMP);
            global_geometry_list.elements[loop_index].Volume->geometry.is_masked_volume = 1;
            if (this_box_volume.geometry.mask_mode == 2)
                global_geometry_list.elements[loop_index].Volume->geometry.mask_mode = 2;
            if (this_box_volume.geometry.mask_mode == 1) {
                if (global_geometry_list.elements[loop_index].Volume->geometry.is_masked_volume == 1 && global_geometry_list.elements[loop_index].Volume->geometry.mask_mode != 2)
                    // If more than one mask is added to one volume, the ANY mode overwrites the (default) ALL mode.
                    global_geometry_list.elements[loop_index].Volume->geometry.mask_mode = 1;
            }
            
            found_geometries = 1;
        }
    }
    if (found_geometries == 0) {
        printf("The mask_string in geometry: %s did not find any of the specified volumes in the mask_string %s \n",NAME_CURRENT_COMP,mask_string);
        exit(1);
    }
    this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
    this_box_volume.p_physics->is_vacuum = 0; // Makes this volume a vacuum
    this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
    this_box_volume.p_physics->my_a = 0; // Should not be used.
    sprintf(this_box_volume.p_physics->name,"Mask");
    this_box_volume.geometry.is_mask_volume = 1;
    
    
// Read the material input, or if it lacks, use automatic linking.
} else if (material_string && strlen(material_string) && strcmp(material_string, "NULL") && strcmp(material_string, "0")) {
    // A geometry string was given, use it to determine which material
    if (0 == strcmp(material_string,"vacuum") || 0 == strcmp(material_string,"Vacuum")) {
        // One could have a global physics struct for vacuum instead of creating one for each
        this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
        this_box_volume.p_physics->is_vacuum = 1; // Makes this volume a vacuum
        this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
        this_box_volume.p_physics->my_a = 0; // Should not be used.
        sprintf(this_box_volume.p_physics->name,"Vacuum");
    } else if (0 == strcmp(material_string,"exit") || 0 == strcmp(material_string,"Exit")) {
        // One could have a global physics struct for vacuum instead of creating one for each
        this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
        this_box_volume.p_physics->is_vacuum = 1; // Makes this volume a vacuum
        this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
        this_box_volume.p_physics->my_a = 0; // Should not be used.
        this_box_volume.geometry.is_exit_volume = 1;
        sprintf(this_box_volume.p_physics->name,"Exit");
    } else {
        #ifndef MATERIAL_DETECTOR
            printf("Need to define a material before refering to it in a geometry %s.\n",NAME_CURRENT_COMP);
            exit(1);
        #endif
        for (loop_index=0;loop_index<global_material_list.num_elements;loop_index++) {
            if (0 == strcmp(material_string,global_material_list.elements[loop_index].name)) {
                this_box_volume.p_physics = global_material_list.elements[loop_index].physics;
                break;
            }
            if (loop_index == global_material_list.num_elements-1) {
            printf("\n");
            printf("ERROR: The material string \"%s\" in Union geometry \"%s\" did not match a specified material. \n",material_string,NAME_CURRENT_COMP);
            printf("       The materials available at this point (need to be defined before the geometry): \n");
            for (loop_index=0;loop_index<global_material_list.num_elements;loop_index++)
              printf("         %s\n",global_material_list.elements[loop_index].name);
            printf("\n");
            printf("       It is also possible to use one of the defualt materials avaiable: \n");
            printf("           Vacuum (for a Volume without scattering or absorption)\n");
            printf("           Exit (for a Volume where the ray exits the component if it enters)\n");
            printf("           Mask (for a Volume that masks existing volumes specified in the mask_string\n");
            exit(1);
          }
        }
    }
} else {
    // Automatic linking, simply using the last defined material.
    #ifndef MATERIAL_DETECTOR
        printf("Need to define a material before the geometry to use automatic linking %s.\n",NAME_CURRENT_COMP);
        exit(1);
    #endif
    this_box_volume.p_physics = global_material_list.elements[global_material_list.num_elements-1].physics;
}

sprintf(this_box_volume.name,NAME_CURRENT_COMP);
sprintf(this_box_volume.geometry.shape,"box");
this_box_volume.geometry.priority_value = priority;
this_box_volume.geometry.geometry_p_interact = p_interact;
// Currently the coordinates will be in absolute space.
this_box_volume.geometry.center = POS_A_CURRENT_COMP;

this_box_storage.z_depth = zdepth;
this_box_storage.x_width1 = xwidth;
this_box_storage.y_height1 = yheight;

this_box_storage.is_rectangle = 0;
if (xwidth2 < 0 && yheight2 < 0) this_box_storage.is_rectangle = 1;
if (xwidth == xwidth2 && yheight == yheight2) this_box_storage.is_rectangle = 1;

if (xwidth2 < 0) {
    this_box_storage.x_width2 = xwidth;
    xwidth2 = xwidth;
} else this_box_storage.x_width2 = xwidth2;

if (yheight2 < 0) {
    this_box_storage.y_height2 = yheight;
    yheight2 = yheight;
} else this_box_storage.y_height2 = yheight2;


this_box_storage.normal_vectors[0] = coords_set(0,0,1);
this_box_storage.normal_vectors[1] = coords_set(0,0,1);

// for sides with y component = 0
x_component = 2*zdepth/sqrt((xwidth-xwidth2)*(xwidth-xwidth2)+4*zdepth*zdepth);
z_component = (xwidth-xwidth2)/sqrt(4*zdepth*zdepth+(xwidth-xwidth2)*(xwidth-xwidth2));

this_box_storage.normal_vectors[2] = coords_set(x_component,0,z_component);
this_box_storage.normal_vectors[3] = coords_set(-x_component,0,z_component);

// for sides with x component = 0
y_component = 2*zdepth/sqrt((yheight-yheight2)*(yheight-yheight2)+4*zdepth*zdepth);
z_component = (yheight-yheight2)/sqrt(4*zdepth*zdepth+(yheight-yheight2)*(yheight-yheight2));

this_box_storage.normal_vectors[4] = coords_set(0,y_component,z_component);
this_box_storage.normal_vectors[5] = coords_set(0,-y_component,z_component);

this_box_volume.geometry.visualization_on = visualize;

this_box_volume.geometry.geometry_parameters.p_box_storage = &this_box_storage;

// Assign pointers to functions for intersection with the shape, checking if a point is inside the shape
if (this_box_storage.is_rectangle == 1) {
this_box_volume.geometry.intersect_function = &sample_box_intersect_simple;
this_box_volume.geometry.within_function = &r_within_box_simple;
}
else {
this_box_volume.geometry.intersect_function = &sample_box_intersect_advanced;
this_box_volume.geometry.within_function = &r_within_box_advanced;
}

this_box_volume.geometry.shell_points = &box_shell_points;
this_box_volume.geometry.mcdisplay_function = &mcdisplay_box_function;
this_box_volume.geometry.initialize_from_main_function = &initialize_box_geometry_from_main_component;
this_box_volume.geometry.process_rot_allocated = 0;

this_box_volume.geometry.copy_geometry_parameters = &allocate_box_storage_copy;

rot_copy(this_box_volume.geometry.rotation_matrix,ROT_A_CURRENT_COMP); //check how ROT_R_CURRENT_COMP would work
rot_transpose(ROT_A_CURRENT_COMP,this_box_volume.geometry.transpose_rotation_matrix);

// Initialize loggers
this_box_volume.loggers.num_elements = 0;

// packing the information into the global_geometry_element, which is then included in the global_geometry_list.
sprintf(global_geometry_element.name,NAME_CURRENT_COMP);
global_geometry_element.activation_counter = number_of_activations;
global_geometry_element.component_index = INDEX_CURRENT_COMP;
global_geometry_element.Volume = &this_box_volume; // Would be nicer if this m was a pointer, now we have the (small) data two places
add_element_to_geometry_list(&global_geometry_list,global_geometry_element);
}
#line 204803 "MACS_sample_kidney_box.c"
#undef number_of_activations
#undef mask_setting
#undef mask_string
#undef p_interact
#undef focus_r
#undef focus_xh
#undef focus_xw
#undef focus_ah
#undef focus_aw
#undef target_z
#undef target_y
#undef target_x
#undef target_index
#undef visualize
#undef yheight2
#undef xwidth2
#undef zdepth
#undef yheight
#undef xwidth
#undef priority
#undef material_string
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

  /* Initializations for component channel_4_analyzer_2_array_crystal_array_6. */
  SIG_MESSAGE("channel_4_analyzer_2_array_crystal_array_6 (Init)");
#define mccompcurname  channel_4_analyzer_2_array_crystal_array_6
#define mccompcurtype  Union_box
#define mccompcurindex 299
#define loop_index mccchannel_4_analyzer_2_array_crystal_array_6_loop_index
#define this_box_volume mccchannel_4_analyzer_2_array_crystal_array_6_this_box_volume
#define global_geometry_element mccchannel_4_analyzer_2_array_crystal_array_6_global_geometry_element
#define this_box_storage mccchannel_4_analyzer_2_array_crystal_array_6_this_box_storage
#define material_string mccchannel_4_analyzer_2_array_crystal_array_6_material_string
#define priority mccchannel_4_analyzer_2_array_crystal_array_6_priority
#define xwidth mccchannel_4_analyzer_2_array_crystal_array_6_xwidth
#define yheight mccchannel_4_analyzer_2_array_crystal_array_6_yheight
#define zdepth mccchannel_4_analyzer_2_array_crystal_array_6_zdepth
#define xwidth2 mccchannel_4_analyzer_2_array_crystal_array_6_xwidth2
#define yheight2 mccchannel_4_analyzer_2_array_crystal_array_6_yheight2
#define visualize mccchannel_4_analyzer_2_array_crystal_array_6_visualize
#define target_index mccchannel_4_analyzer_2_array_crystal_array_6_target_index
#define target_x mccchannel_4_analyzer_2_array_crystal_array_6_target_x
#define target_y mccchannel_4_analyzer_2_array_crystal_array_6_target_y
#define target_z mccchannel_4_analyzer_2_array_crystal_array_6_target_z
#define focus_aw mccchannel_4_analyzer_2_array_crystal_array_6_focus_aw
#define focus_ah mccchannel_4_analyzer_2_array_crystal_array_6_focus_ah
#define focus_xw mccchannel_4_analyzer_2_array_crystal_array_6_focus_xw
#define focus_xh mccchannel_4_analyzer_2_array_crystal_array_6_focus_xh
#define focus_r mccchannel_4_analyzer_2_array_crystal_array_6_focus_r
#define p_interact mccchannel_4_analyzer_2_array_crystal_array_6_p_interact
#define mask_string mccchannel_4_analyzer_2_array_crystal_array_6_mask_string
#define mask_setting mccchannel_4_analyzer_2_array_crystal_array_6_mask_setting
#define number_of_activations mccchannel_4_analyzer_2_array_crystal_array_6_number_of_activations
#line 224 "Union_box.comp"
{
// Initializes the focusing system for this volume including input sanitation.
focus_initialize(&this_box_volume.geometry, POS_A_COMP_INDEX(INDEX_CURRENT_COMP+target_index), POS_A_CURRENT_COMP, ROT_A_CURRENT_COMP, target_index, target_x, target_y, target_z, focus_aw, focus_ah, focus_xw, focus_xh, focus_r, NAME_CURRENT_COMP);

// Input sanitation for this geometry
if (xwidth <= 0) {
  printf("\nERROR in Union_box named %s, the xwidth is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (yheight <= 0) {
  printf("\nERROR in Union_box named %s, yheight is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (zdepth <= 0) {
  printf("\nERROR in Union_box named %s, zdepth is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (xwidth2 <= 0 && xwidth2 != -1) {
  printf("\nERROR in Union_box named %s, the xwidth2 is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (yheight2 <= 0 && yheight2 != -1) {
  printf("\nERROR in Union_box named %s, yheight2 is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}

// Use sanitation
if (global_material_list.num_elements == 0) {
  printf("\nERROR: Need to define a material using Union_make_material before using a Union geometry component. \n");
  printf("       %s was defined before first use of Union_make_material.\n",NAME_CURRENT_COMP);
  exit(1);
}

this_box_volume.geometry.is_masked_volume = 0;
this_box_volume.geometry.is_exit_volume = 0;
this_box_volume.geometry.is_mask_volume = 0;
// check if the volume is a mask, if it is the material string is irelevant.
if (mask_string && strlen(mask_string) && strcmp(mask_string, "NULL") && strcmp(mask_string, "0")) {
    // A mask volume is used to limit the extend of other volumes, called the masked volumes. These are specified in the mask_string.
    // In order for a ray to enter a masked volume, it needs to be both in the region covered by that volume AND the mask volume.
    // When more than
    this_box_volume.geometry.mask_mode = 1; // Default is mask mode is ALL
    if (mask_setting && strlen(mask_setting) && strcmp(mask_setting, "NULL") && strcmp(mask_setting, "0")) {
        if (strcmp(mask_setting,"ALL") == 0 || strcmp(mask_setting,"All") == 0) this_box_volume.geometry.mask_mode = 1;
        else if (strcmp(mask_setting,"ANY") == 0 || strcmp(mask_setting,"Any") == 0) this_box_volume.geometry.mask_mode = 2;
        else {
            printf("The mask_mode of component %s is set to %s, but must be either ALL or ANY.\n",NAME_CURRENT_COMP,mask_setting);
            exit(1);
        }
    }
    
    for (loop_index=0;loop_index<global_geometry_list.num_elements;loop_index++) {
        // Add mask list
        if (1 == manual_linking_function(global_geometry_list.elements[loop_index].name,mask_string)) {
            add_element_to_int_list(&this_box_volume.geometry.mask_list,global_geometry_list.elements[loop_index].component_index);
            add_element_to_int_list(&global_geometry_list.elements[loop_index].Volume->geometry.masked_by_list,INDEX_CURRENT_COMP);
            global_geometry_list.elements[loop_index].Volume->geometry.is_masked_volume = 1;
            if (this_box_volume.geometry.mask_mode == 2)
                global_geometry_list.elements[loop_index].Volume->geometry.mask_mode = 2;
            if (this_box_volume.geometry.mask_mode == 1) {
                if (global_geometry_list.elements[loop_index].Volume->geometry.is_masked_volume == 1 && global_geometry_list.elements[loop_index].Volume->geometry.mask_mode != 2)
                    // If more than one mask is added to one volume, the ANY mode overwrites the (default) ALL mode.
                    global_geometry_list.elements[loop_index].Volume->geometry.mask_mode = 1;
            }
            
            found_geometries = 1;
        }
    }
    if (found_geometries == 0) {
        printf("The mask_string in geometry: %s did not find any of the specified volumes in the mask_string %s \n",NAME_CURRENT_COMP,mask_string);
        exit(1);
    }
    this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
    this_box_volume.p_physics->is_vacuum = 0; // Makes this volume a vacuum
    this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
    this_box_volume.p_physics->my_a = 0; // Should not be used.
    sprintf(this_box_volume.p_physics->name,"Mask");
    this_box_volume.geometry.is_mask_volume = 1;
    
    
// Read the material input, or if it lacks, use automatic linking.
} else if (material_string && strlen(material_string) && strcmp(material_string, "NULL") && strcmp(material_string, "0")) {
    // A geometry string was given, use it to determine which material
    if (0 == strcmp(material_string,"vacuum") || 0 == strcmp(material_string,"Vacuum")) {
        // One could have a global physics struct for vacuum instead of creating one for each
        this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
        this_box_volume.p_physics->is_vacuum = 1; // Makes this volume a vacuum
        this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
        this_box_volume.p_physics->my_a = 0; // Should not be used.
        sprintf(this_box_volume.p_physics->name,"Vacuum");
    } else if (0 == strcmp(material_string,"exit") || 0 == strcmp(material_string,"Exit")) {
        // One could have a global physics struct for vacuum instead of creating one for each
        this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
        this_box_volume.p_physics->is_vacuum = 1; // Makes this volume a vacuum
        this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
        this_box_volume.p_physics->my_a = 0; // Should not be used.
        this_box_volume.geometry.is_exit_volume = 1;
        sprintf(this_box_volume.p_physics->name,"Exit");
    } else {
        #ifndef MATERIAL_DETECTOR
            printf("Need to define a material before refering to it in a geometry %s.\n",NAME_CURRENT_COMP);
            exit(1);
        #endif
        for (loop_index=0;loop_index<global_material_list.num_elements;loop_index++) {
            if (0 == strcmp(material_string,global_material_list.elements[loop_index].name)) {
                this_box_volume.p_physics = global_material_list.elements[loop_index].physics;
                break;
            }
            if (loop_index == global_material_list.num_elements-1) {
            printf("\n");
            printf("ERROR: The material string \"%s\" in Union geometry \"%s\" did not match a specified material. \n",material_string,NAME_CURRENT_COMP);
            printf("       The materials available at this point (need to be defined before the geometry): \n");
            for (loop_index=0;loop_index<global_material_list.num_elements;loop_index++)
              printf("         %s\n",global_material_list.elements[loop_index].name);
            printf("\n");
            printf("       It is also possible to use one of the defualt materials avaiable: \n");
            printf("           Vacuum (for a Volume without scattering or absorption)\n");
            printf("           Exit (for a Volume where the ray exits the component if it enters)\n");
            printf("           Mask (for a Volume that masks existing volumes specified in the mask_string\n");
            exit(1);
          }
        }
    }
} else {
    // Automatic linking, simply using the last defined material.
    #ifndef MATERIAL_DETECTOR
        printf("Need to define a material before the geometry to use automatic linking %s.\n",NAME_CURRENT_COMP);
        exit(1);
    #endif
    this_box_volume.p_physics = global_material_list.elements[global_material_list.num_elements-1].physics;
}

sprintf(this_box_volume.name,NAME_CURRENT_COMP);
sprintf(this_box_volume.geometry.shape,"box");
this_box_volume.geometry.priority_value = priority;
this_box_volume.geometry.geometry_p_interact = p_interact;
// Currently the coordinates will be in absolute space.
this_box_volume.geometry.center = POS_A_CURRENT_COMP;

this_box_storage.z_depth = zdepth;
this_box_storage.x_width1 = xwidth;
this_box_storage.y_height1 = yheight;

this_box_storage.is_rectangle = 0;
if (xwidth2 < 0 && yheight2 < 0) this_box_storage.is_rectangle = 1;
if (xwidth == xwidth2 && yheight == yheight2) this_box_storage.is_rectangle = 1;

if (xwidth2 < 0) {
    this_box_storage.x_width2 = xwidth;
    xwidth2 = xwidth;
} else this_box_storage.x_width2 = xwidth2;

if (yheight2 < 0) {
    this_box_storage.y_height2 = yheight;
    yheight2 = yheight;
} else this_box_storage.y_height2 = yheight2;


this_box_storage.normal_vectors[0] = coords_set(0,0,1);
this_box_storage.normal_vectors[1] = coords_set(0,0,1);

// for sides with y component = 0
x_component = 2*zdepth/sqrt((xwidth-xwidth2)*(xwidth-xwidth2)+4*zdepth*zdepth);
z_component = (xwidth-xwidth2)/sqrt(4*zdepth*zdepth+(xwidth-xwidth2)*(xwidth-xwidth2));

this_box_storage.normal_vectors[2] = coords_set(x_component,0,z_component);
this_box_storage.normal_vectors[3] = coords_set(-x_component,0,z_component);

// for sides with x component = 0
y_component = 2*zdepth/sqrt((yheight-yheight2)*(yheight-yheight2)+4*zdepth*zdepth);
z_component = (yheight-yheight2)/sqrt(4*zdepth*zdepth+(yheight-yheight2)*(yheight-yheight2));

this_box_storage.normal_vectors[4] = coords_set(0,y_component,z_component);
this_box_storage.normal_vectors[5] = coords_set(0,-y_component,z_component);

this_box_volume.geometry.visualization_on = visualize;

this_box_volume.geometry.geometry_parameters.p_box_storage = &this_box_storage;

// Assign pointers to functions for intersection with the shape, checking if a point is inside the shape
if (this_box_storage.is_rectangle == 1) {
this_box_volume.geometry.intersect_function = &sample_box_intersect_simple;
this_box_volume.geometry.within_function = &r_within_box_simple;
}
else {
this_box_volume.geometry.intersect_function = &sample_box_intersect_advanced;
this_box_volume.geometry.within_function = &r_within_box_advanced;
}

this_box_volume.geometry.shell_points = &box_shell_points;
this_box_volume.geometry.mcdisplay_function = &mcdisplay_box_function;
this_box_volume.geometry.initialize_from_main_function = &initialize_box_geometry_from_main_component;
this_box_volume.geometry.process_rot_allocated = 0;

this_box_volume.geometry.copy_geometry_parameters = &allocate_box_storage_copy;

rot_copy(this_box_volume.geometry.rotation_matrix,ROT_A_CURRENT_COMP); //check how ROT_R_CURRENT_COMP would work
rot_transpose(ROT_A_CURRENT_COMP,this_box_volume.geometry.transpose_rotation_matrix);

// Initialize loggers
this_box_volume.loggers.num_elements = 0;

// packing the information into the global_geometry_element, which is then included in the global_geometry_list.
sprintf(global_geometry_element.name,NAME_CURRENT_COMP);
global_geometry_element.activation_counter = number_of_activations;
global_geometry_element.component_index = INDEX_CURRENT_COMP;
global_geometry_element.Volume = &this_box_volume; // Would be nicer if this m was a pointer, now we have the (small) data two places
add_element_to_geometry_list(&global_geometry_list,global_geometry_element);
}
#line 205073 "MACS_sample_kidney_box.c"
#undef number_of_activations
#undef mask_setting
#undef mask_string
#undef p_interact
#undef focus_r
#undef focus_xh
#undef focus_xw
#undef focus_ah
#undef focus_aw
#undef target_z
#undef target_y
#undef target_x
#undef target_index
#undef visualize
#undef yheight2
#undef xwidth2
#undef zdepth
#undef yheight
#undef xwidth
#undef priority
#undef material_string
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

  /* Initializations for component channel_4_analyzer_2_array_crystal_array_7. */
  SIG_MESSAGE("channel_4_analyzer_2_array_crystal_array_7 (Init)");
#define mccompcurname  channel_4_analyzer_2_array_crystal_array_7
#define mccompcurtype  Union_box
#define mccompcurindex 300
#define loop_index mccchannel_4_analyzer_2_array_crystal_array_7_loop_index
#define this_box_volume mccchannel_4_analyzer_2_array_crystal_array_7_this_box_volume
#define global_geometry_element mccchannel_4_analyzer_2_array_crystal_array_7_global_geometry_element
#define this_box_storage mccchannel_4_analyzer_2_array_crystal_array_7_this_box_storage
#define material_string mccchannel_4_analyzer_2_array_crystal_array_7_material_string
#define priority mccchannel_4_analyzer_2_array_crystal_array_7_priority
#define xwidth mccchannel_4_analyzer_2_array_crystal_array_7_xwidth
#define yheight mccchannel_4_analyzer_2_array_crystal_array_7_yheight
#define zdepth mccchannel_4_analyzer_2_array_crystal_array_7_zdepth
#define xwidth2 mccchannel_4_analyzer_2_array_crystal_array_7_xwidth2
#define yheight2 mccchannel_4_analyzer_2_array_crystal_array_7_yheight2
#define visualize mccchannel_4_analyzer_2_array_crystal_array_7_visualize
#define target_index mccchannel_4_analyzer_2_array_crystal_array_7_target_index
#define target_x mccchannel_4_analyzer_2_array_crystal_array_7_target_x
#define target_y mccchannel_4_analyzer_2_array_crystal_array_7_target_y
#define target_z mccchannel_4_analyzer_2_array_crystal_array_7_target_z
#define focus_aw mccchannel_4_analyzer_2_array_crystal_array_7_focus_aw
#define focus_ah mccchannel_4_analyzer_2_array_crystal_array_7_focus_ah
#define focus_xw mccchannel_4_analyzer_2_array_crystal_array_7_focus_xw
#define focus_xh mccchannel_4_analyzer_2_array_crystal_array_7_focus_xh
#define focus_r mccchannel_4_analyzer_2_array_crystal_array_7_focus_r
#define p_interact mccchannel_4_analyzer_2_array_crystal_array_7_p_interact
#define mask_string mccchannel_4_analyzer_2_array_crystal_array_7_mask_string
#define mask_setting mccchannel_4_analyzer_2_array_crystal_array_7_mask_setting
#define number_of_activations mccchannel_4_analyzer_2_array_crystal_array_7_number_of_activations
#line 224 "Union_box.comp"
{
// Initializes the focusing system for this volume including input sanitation.
focus_initialize(&this_box_volume.geometry, POS_A_COMP_INDEX(INDEX_CURRENT_COMP+target_index), POS_A_CURRENT_COMP, ROT_A_CURRENT_COMP, target_index, target_x, target_y, target_z, focus_aw, focus_ah, focus_xw, focus_xh, focus_r, NAME_CURRENT_COMP);

// Input sanitation for this geometry
if (xwidth <= 0) {
  printf("\nERROR in Union_box named %s, the xwidth is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (yheight <= 0) {
  printf("\nERROR in Union_box named %s, yheight is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (zdepth <= 0) {
  printf("\nERROR in Union_box named %s, zdepth is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (xwidth2 <= 0 && xwidth2 != -1) {
  printf("\nERROR in Union_box named %s, the xwidth2 is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (yheight2 <= 0 && yheight2 != -1) {
  printf("\nERROR in Union_box named %s, yheight2 is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}

// Use sanitation
if (global_material_list.num_elements == 0) {
  printf("\nERROR: Need to define a material using Union_make_material before using a Union geometry component. \n");
  printf("       %s was defined before first use of Union_make_material.\n",NAME_CURRENT_COMP);
  exit(1);
}

this_box_volume.geometry.is_masked_volume = 0;
this_box_volume.geometry.is_exit_volume = 0;
this_box_volume.geometry.is_mask_volume = 0;
// check if the volume is a mask, if it is the material string is irelevant.
if (mask_string && strlen(mask_string) && strcmp(mask_string, "NULL") && strcmp(mask_string, "0")) {
    // A mask volume is used to limit the extend of other volumes, called the masked volumes. These are specified in the mask_string.
    // In order for a ray to enter a masked volume, it needs to be both in the region covered by that volume AND the mask volume.
    // When more than
    this_box_volume.geometry.mask_mode = 1; // Default is mask mode is ALL
    if (mask_setting && strlen(mask_setting) && strcmp(mask_setting, "NULL") && strcmp(mask_setting, "0")) {
        if (strcmp(mask_setting,"ALL") == 0 || strcmp(mask_setting,"All") == 0) this_box_volume.geometry.mask_mode = 1;
        else if (strcmp(mask_setting,"ANY") == 0 || strcmp(mask_setting,"Any") == 0) this_box_volume.geometry.mask_mode = 2;
        else {
            printf("The mask_mode of component %s is set to %s, but must be either ALL or ANY.\n",NAME_CURRENT_COMP,mask_setting);
            exit(1);
        }
    }
    
    for (loop_index=0;loop_index<global_geometry_list.num_elements;loop_index++) {
        // Add mask list
        if (1 == manual_linking_function(global_geometry_list.elements[loop_index].name,mask_string)) {
            add_element_to_int_list(&this_box_volume.geometry.mask_list,global_geometry_list.elements[loop_index].component_index);
            add_element_to_int_list(&global_geometry_list.elements[loop_index].Volume->geometry.masked_by_list,INDEX_CURRENT_COMP);
            global_geometry_list.elements[loop_index].Volume->geometry.is_masked_volume = 1;
            if (this_box_volume.geometry.mask_mode == 2)
                global_geometry_list.elements[loop_index].Volume->geometry.mask_mode = 2;
            if (this_box_volume.geometry.mask_mode == 1) {
                if (global_geometry_list.elements[loop_index].Volume->geometry.is_masked_volume == 1 && global_geometry_list.elements[loop_index].Volume->geometry.mask_mode != 2)
                    // If more than one mask is added to one volume, the ANY mode overwrites the (default) ALL mode.
                    global_geometry_list.elements[loop_index].Volume->geometry.mask_mode = 1;
            }
            
            found_geometries = 1;
        }
    }
    if (found_geometries == 0) {
        printf("The mask_string in geometry: %s did not find any of the specified volumes in the mask_string %s \n",NAME_CURRENT_COMP,mask_string);
        exit(1);
    }
    this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
    this_box_volume.p_physics->is_vacuum = 0; // Makes this volume a vacuum
    this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
    this_box_volume.p_physics->my_a = 0; // Should not be used.
    sprintf(this_box_volume.p_physics->name,"Mask");
    this_box_volume.geometry.is_mask_volume = 1;
    
    
// Read the material input, or if it lacks, use automatic linking.
} else if (material_string && strlen(material_string) && strcmp(material_string, "NULL") && strcmp(material_string, "0")) {
    // A geometry string was given, use it to determine which material
    if (0 == strcmp(material_string,"vacuum") || 0 == strcmp(material_string,"Vacuum")) {
        // One could have a global physics struct for vacuum instead of creating one for each
        this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
        this_box_volume.p_physics->is_vacuum = 1; // Makes this volume a vacuum
        this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
        this_box_volume.p_physics->my_a = 0; // Should not be used.
        sprintf(this_box_volume.p_physics->name,"Vacuum");
    } else if (0 == strcmp(material_string,"exit") || 0 == strcmp(material_string,"Exit")) {
        // One could have a global physics struct for vacuum instead of creating one for each
        this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
        this_box_volume.p_physics->is_vacuum = 1; // Makes this volume a vacuum
        this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
        this_box_volume.p_physics->my_a = 0; // Should not be used.
        this_box_volume.geometry.is_exit_volume = 1;
        sprintf(this_box_volume.p_physics->name,"Exit");
    } else {
        #ifndef MATERIAL_DETECTOR
            printf("Need to define a material before refering to it in a geometry %s.\n",NAME_CURRENT_COMP);
            exit(1);
        #endif
        for (loop_index=0;loop_index<global_material_list.num_elements;loop_index++) {
            if (0 == strcmp(material_string,global_material_list.elements[loop_index].name)) {
                this_box_volume.p_physics = global_material_list.elements[loop_index].physics;
                break;
            }
            if (loop_index == global_material_list.num_elements-1) {
            printf("\n");
            printf("ERROR: The material string \"%s\" in Union geometry \"%s\" did not match a specified material. \n",material_string,NAME_CURRENT_COMP);
            printf("       The materials available at this point (need to be defined before the geometry): \n");
            for (loop_index=0;loop_index<global_material_list.num_elements;loop_index++)
              printf("         %s\n",global_material_list.elements[loop_index].name);
            printf("\n");
            printf("       It is also possible to use one of the defualt materials avaiable: \n");
            printf("           Vacuum (for a Volume without scattering or absorption)\n");
            printf("           Exit (for a Volume where the ray exits the component if it enters)\n");
            printf("           Mask (for a Volume that masks existing volumes specified in the mask_string\n");
            exit(1);
          }
        }
    }
} else {
    // Automatic linking, simply using the last defined material.
    #ifndef MATERIAL_DETECTOR
        printf("Need to define a material before the geometry to use automatic linking %s.\n",NAME_CURRENT_COMP);
        exit(1);
    #endif
    this_box_volume.p_physics = global_material_list.elements[global_material_list.num_elements-1].physics;
}

sprintf(this_box_volume.name,NAME_CURRENT_COMP);
sprintf(this_box_volume.geometry.shape,"box");
this_box_volume.geometry.priority_value = priority;
this_box_volume.geometry.geometry_p_interact = p_interact;
// Currently the coordinates will be in absolute space.
this_box_volume.geometry.center = POS_A_CURRENT_COMP;

this_box_storage.z_depth = zdepth;
this_box_storage.x_width1 = xwidth;
this_box_storage.y_height1 = yheight;

this_box_storage.is_rectangle = 0;
if (xwidth2 < 0 && yheight2 < 0) this_box_storage.is_rectangle = 1;
if (xwidth == xwidth2 && yheight == yheight2) this_box_storage.is_rectangle = 1;

if (xwidth2 < 0) {
    this_box_storage.x_width2 = xwidth;
    xwidth2 = xwidth;
} else this_box_storage.x_width2 = xwidth2;

if (yheight2 < 0) {
    this_box_storage.y_height2 = yheight;
    yheight2 = yheight;
} else this_box_storage.y_height2 = yheight2;


this_box_storage.normal_vectors[0] = coords_set(0,0,1);
this_box_storage.normal_vectors[1] = coords_set(0,0,1);

// for sides with y component = 0
x_component = 2*zdepth/sqrt((xwidth-xwidth2)*(xwidth-xwidth2)+4*zdepth*zdepth);
z_component = (xwidth-xwidth2)/sqrt(4*zdepth*zdepth+(xwidth-xwidth2)*(xwidth-xwidth2));

this_box_storage.normal_vectors[2] = coords_set(x_component,0,z_component);
this_box_storage.normal_vectors[3] = coords_set(-x_component,0,z_component);

// for sides with x component = 0
y_component = 2*zdepth/sqrt((yheight-yheight2)*(yheight-yheight2)+4*zdepth*zdepth);
z_component = (yheight-yheight2)/sqrt(4*zdepth*zdepth+(yheight-yheight2)*(yheight-yheight2));

this_box_storage.normal_vectors[4] = coords_set(0,y_component,z_component);
this_box_storage.normal_vectors[5] = coords_set(0,-y_component,z_component);

this_box_volume.geometry.visualization_on = visualize;

this_box_volume.geometry.geometry_parameters.p_box_storage = &this_box_storage;

// Assign pointers to functions for intersection with the shape, checking if a point is inside the shape
if (this_box_storage.is_rectangle == 1) {
this_box_volume.geometry.intersect_function = &sample_box_intersect_simple;
this_box_volume.geometry.within_function = &r_within_box_simple;
}
else {
this_box_volume.geometry.intersect_function = &sample_box_intersect_advanced;
this_box_volume.geometry.within_function = &r_within_box_advanced;
}

this_box_volume.geometry.shell_points = &box_shell_points;
this_box_volume.geometry.mcdisplay_function = &mcdisplay_box_function;
this_box_volume.geometry.initialize_from_main_function = &initialize_box_geometry_from_main_component;
this_box_volume.geometry.process_rot_allocated = 0;

this_box_volume.geometry.copy_geometry_parameters = &allocate_box_storage_copy;

rot_copy(this_box_volume.geometry.rotation_matrix,ROT_A_CURRENT_COMP); //check how ROT_R_CURRENT_COMP would work
rot_transpose(ROT_A_CURRENT_COMP,this_box_volume.geometry.transpose_rotation_matrix);

// Initialize loggers
this_box_volume.loggers.num_elements = 0;

// packing the information into the global_geometry_element, which is then included in the global_geometry_list.
sprintf(global_geometry_element.name,NAME_CURRENT_COMP);
global_geometry_element.activation_counter = number_of_activations;
global_geometry_element.component_index = INDEX_CURRENT_COMP;
global_geometry_element.Volume = &this_box_volume; // Would be nicer if this m was a pointer, now we have the (small) data two places
add_element_to_geometry_list(&global_geometry_list,global_geometry_element);
}
#line 205343 "MACS_sample_kidney_box.c"
#undef number_of_activations
#undef mask_setting
#undef mask_string
#undef p_interact
#undef focus_r
#undef focus_xh
#undef focus_xw
#undef focus_ah
#undef focus_aw
#undef target_z
#undef target_y
#undef target_x
#undef target_index
#undef visualize
#undef yheight2
#undef xwidth2
#undef zdepth
#undef yheight
#undef xwidth
#undef priority
#undef material_string
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

  /* Initializations for component channel_4_analyzer_2_array_crystal_array_8. */
  SIG_MESSAGE("channel_4_analyzer_2_array_crystal_array_8 (Init)");
#define mccompcurname  channel_4_analyzer_2_array_crystal_array_8
#define mccompcurtype  Union_box
#define mccompcurindex 301
#define loop_index mccchannel_4_analyzer_2_array_crystal_array_8_loop_index
#define this_box_volume mccchannel_4_analyzer_2_array_crystal_array_8_this_box_volume
#define global_geometry_element mccchannel_4_analyzer_2_array_crystal_array_8_global_geometry_element
#define this_box_storage mccchannel_4_analyzer_2_array_crystal_array_8_this_box_storage
#define material_string mccchannel_4_analyzer_2_array_crystal_array_8_material_string
#define priority mccchannel_4_analyzer_2_array_crystal_array_8_priority
#define xwidth mccchannel_4_analyzer_2_array_crystal_array_8_xwidth
#define yheight mccchannel_4_analyzer_2_array_crystal_array_8_yheight
#define zdepth mccchannel_4_analyzer_2_array_crystal_array_8_zdepth
#define xwidth2 mccchannel_4_analyzer_2_array_crystal_array_8_xwidth2
#define yheight2 mccchannel_4_analyzer_2_array_crystal_array_8_yheight2
#define visualize mccchannel_4_analyzer_2_array_crystal_array_8_visualize
#define target_index mccchannel_4_analyzer_2_array_crystal_array_8_target_index
#define target_x mccchannel_4_analyzer_2_array_crystal_array_8_target_x
#define target_y mccchannel_4_analyzer_2_array_crystal_array_8_target_y
#define target_z mccchannel_4_analyzer_2_array_crystal_array_8_target_z
#define focus_aw mccchannel_4_analyzer_2_array_crystal_array_8_focus_aw
#define focus_ah mccchannel_4_analyzer_2_array_crystal_array_8_focus_ah
#define focus_xw mccchannel_4_analyzer_2_array_crystal_array_8_focus_xw
#define focus_xh mccchannel_4_analyzer_2_array_crystal_array_8_focus_xh
#define focus_r mccchannel_4_analyzer_2_array_crystal_array_8_focus_r
#define p_interact mccchannel_4_analyzer_2_array_crystal_array_8_p_interact
#define mask_string mccchannel_4_analyzer_2_array_crystal_array_8_mask_string
#define mask_setting mccchannel_4_analyzer_2_array_crystal_array_8_mask_setting
#define number_of_activations mccchannel_4_analyzer_2_array_crystal_array_8_number_of_activations
#line 224 "Union_box.comp"
{
// Initializes the focusing system for this volume including input sanitation.
focus_initialize(&this_box_volume.geometry, POS_A_COMP_INDEX(INDEX_CURRENT_COMP+target_index), POS_A_CURRENT_COMP, ROT_A_CURRENT_COMP, target_index, target_x, target_y, target_z, focus_aw, focus_ah, focus_xw, focus_xh, focus_r, NAME_CURRENT_COMP);

// Input sanitation for this geometry
if (xwidth <= 0) {
  printf("\nERROR in Union_box named %s, the xwidth is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (yheight <= 0) {
  printf("\nERROR in Union_box named %s, yheight is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (zdepth <= 0) {
  printf("\nERROR in Union_box named %s, zdepth is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (xwidth2 <= 0 && xwidth2 != -1) {
  printf("\nERROR in Union_box named %s, the xwidth2 is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (yheight2 <= 0 && yheight2 != -1) {
  printf("\nERROR in Union_box named %s, yheight2 is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}

// Use sanitation
if (global_material_list.num_elements == 0) {
  printf("\nERROR: Need to define a material using Union_make_material before using a Union geometry component. \n");
  printf("       %s was defined before first use of Union_make_material.\n",NAME_CURRENT_COMP);
  exit(1);
}

this_box_volume.geometry.is_masked_volume = 0;
this_box_volume.geometry.is_exit_volume = 0;
this_box_volume.geometry.is_mask_volume = 0;
// check if the volume is a mask, if it is the material string is irelevant.
if (mask_string && strlen(mask_string) && strcmp(mask_string, "NULL") && strcmp(mask_string, "0")) {
    // A mask volume is used to limit the extend of other volumes, called the masked volumes. These are specified in the mask_string.
    // In order for a ray to enter a masked volume, it needs to be both in the region covered by that volume AND the mask volume.
    // When more than
    this_box_volume.geometry.mask_mode = 1; // Default is mask mode is ALL
    if (mask_setting && strlen(mask_setting) && strcmp(mask_setting, "NULL") && strcmp(mask_setting, "0")) {
        if (strcmp(mask_setting,"ALL") == 0 || strcmp(mask_setting,"All") == 0) this_box_volume.geometry.mask_mode = 1;
        else if (strcmp(mask_setting,"ANY") == 0 || strcmp(mask_setting,"Any") == 0) this_box_volume.geometry.mask_mode = 2;
        else {
            printf("The mask_mode of component %s is set to %s, but must be either ALL or ANY.\n",NAME_CURRENT_COMP,mask_setting);
            exit(1);
        }
    }
    
    for (loop_index=0;loop_index<global_geometry_list.num_elements;loop_index++) {
        // Add mask list
        if (1 == manual_linking_function(global_geometry_list.elements[loop_index].name,mask_string)) {
            add_element_to_int_list(&this_box_volume.geometry.mask_list,global_geometry_list.elements[loop_index].component_index);
            add_element_to_int_list(&global_geometry_list.elements[loop_index].Volume->geometry.masked_by_list,INDEX_CURRENT_COMP);
            global_geometry_list.elements[loop_index].Volume->geometry.is_masked_volume = 1;
            if (this_box_volume.geometry.mask_mode == 2)
                global_geometry_list.elements[loop_index].Volume->geometry.mask_mode = 2;
            if (this_box_volume.geometry.mask_mode == 1) {
                if (global_geometry_list.elements[loop_index].Volume->geometry.is_masked_volume == 1 && global_geometry_list.elements[loop_index].Volume->geometry.mask_mode != 2)
                    // If more than one mask is added to one volume, the ANY mode overwrites the (default) ALL mode.
                    global_geometry_list.elements[loop_index].Volume->geometry.mask_mode = 1;
            }
            
            found_geometries = 1;
        }
    }
    if (found_geometries == 0) {
        printf("The mask_string in geometry: %s did not find any of the specified volumes in the mask_string %s \n",NAME_CURRENT_COMP,mask_string);
        exit(1);
    }
    this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
    this_box_volume.p_physics->is_vacuum = 0; // Makes this volume a vacuum
    this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
    this_box_volume.p_physics->my_a = 0; // Should not be used.
    sprintf(this_box_volume.p_physics->name,"Mask");
    this_box_volume.geometry.is_mask_volume = 1;
    
    
// Read the material input, or if it lacks, use automatic linking.
} else if (material_string && strlen(material_string) && strcmp(material_string, "NULL") && strcmp(material_string, "0")) {
    // A geometry string was given, use it to determine which material
    if (0 == strcmp(material_string,"vacuum") || 0 == strcmp(material_string,"Vacuum")) {
        // One could have a global physics struct for vacuum instead of creating one for each
        this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
        this_box_volume.p_physics->is_vacuum = 1; // Makes this volume a vacuum
        this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
        this_box_volume.p_physics->my_a = 0; // Should not be used.
        sprintf(this_box_volume.p_physics->name,"Vacuum");
    } else if (0 == strcmp(material_string,"exit") || 0 == strcmp(material_string,"Exit")) {
        // One could have a global physics struct for vacuum instead of creating one for each
        this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
        this_box_volume.p_physics->is_vacuum = 1; // Makes this volume a vacuum
        this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
        this_box_volume.p_physics->my_a = 0; // Should not be used.
        this_box_volume.geometry.is_exit_volume = 1;
        sprintf(this_box_volume.p_physics->name,"Exit");
    } else {
        #ifndef MATERIAL_DETECTOR
            printf("Need to define a material before refering to it in a geometry %s.\n",NAME_CURRENT_COMP);
            exit(1);
        #endif
        for (loop_index=0;loop_index<global_material_list.num_elements;loop_index++) {
            if (0 == strcmp(material_string,global_material_list.elements[loop_index].name)) {
                this_box_volume.p_physics = global_material_list.elements[loop_index].physics;
                break;
            }
            if (loop_index == global_material_list.num_elements-1) {
            printf("\n");
            printf("ERROR: The material string \"%s\" in Union geometry \"%s\" did not match a specified material. \n",material_string,NAME_CURRENT_COMP);
            printf("       The materials available at this point (need to be defined before the geometry): \n");
            for (loop_index=0;loop_index<global_material_list.num_elements;loop_index++)
              printf("         %s\n",global_material_list.elements[loop_index].name);
            printf("\n");
            printf("       It is also possible to use one of the defualt materials avaiable: \n");
            printf("           Vacuum (for a Volume without scattering or absorption)\n");
            printf("           Exit (for a Volume where the ray exits the component if it enters)\n");
            printf("           Mask (for a Volume that masks existing volumes specified in the mask_string\n");
            exit(1);
          }
        }
    }
} else {
    // Automatic linking, simply using the last defined material.
    #ifndef MATERIAL_DETECTOR
        printf("Need to define a material before the geometry to use automatic linking %s.\n",NAME_CURRENT_COMP);
        exit(1);
    #endif
    this_box_volume.p_physics = global_material_list.elements[global_material_list.num_elements-1].physics;
}

sprintf(this_box_volume.name,NAME_CURRENT_COMP);
sprintf(this_box_volume.geometry.shape,"box");
this_box_volume.geometry.priority_value = priority;
this_box_volume.geometry.geometry_p_interact = p_interact;
// Currently the coordinates will be in absolute space.
this_box_volume.geometry.center = POS_A_CURRENT_COMP;

this_box_storage.z_depth = zdepth;
this_box_storage.x_width1 = xwidth;
this_box_storage.y_height1 = yheight;

this_box_storage.is_rectangle = 0;
if (xwidth2 < 0 && yheight2 < 0) this_box_storage.is_rectangle = 1;
if (xwidth == xwidth2 && yheight == yheight2) this_box_storage.is_rectangle = 1;

if (xwidth2 < 0) {
    this_box_storage.x_width2 = xwidth;
    xwidth2 = xwidth;
} else this_box_storage.x_width2 = xwidth2;

if (yheight2 < 0) {
    this_box_storage.y_height2 = yheight;
    yheight2 = yheight;
} else this_box_storage.y_height2 = yheight2;


this_box_storage.normal_vectors[0] = coords_set(0,0,1);
this_box_storage.normal_vectors[1] = coords_set(0,0,1);

// for sides with y component = 0
x_component = 2*zdepth/sqrt((xwidth-xwidth2)*(xwidth-xwidth2)+4*zdepth*zdepth);
z_component = (xwidth-xwidth2)/sqrt(4*zdepth*zdepth+(xwidth-xwidth2)*(xwidth-xwidth2));

this_box_storage.normal_vectors[2] = coords_set(x_component,0,z_component);
this_box_storage.normal_vectors[3] = coords_set(-x_component,0,z_component);

// for sides with x component = 0
y_component = 2*zdepth/sqrt((yheight-yheight2)*(yheight-yheight2)+4*zdepth*zdepth);
z_component = (yheight-yheight2)/sqrt(4*zdepth*zdepth+(yheight-yheight2)*(yheight-yheight2));

this_box_storage.normal_vectors[4] = coords_set(0,y_component,z_component);
this_box_storage.normal_vectors[5] = coords_set(0,-y_component,z_component);

this_box_volume.geometry.visualization_on = visualize;

this_box_volume.geometry.geometry_parameters.p_box_storage = &this_box_storage;

// Assign pointers to functions for intersection with the shape, checking if a point is inside the shape
if (this_box_storage.is_rectangle == 1) {
this_box_volume.geometry.intersect_function = &sample_box_intersect_simple;
this_box_volume.geometry.within_function = &r_within_box_simple;
}
else {
this_box_volume.geometry.intersect_function = &sample_box_intersect_advanced;
this_box_volume.geometry.within_function = &r_within_box_advanced;
}

this_box_volume.geometry.shell_points = &box_shell_points;
this_box_volume.geometry.mcdisplay_function = &mcdisplay_box_function;
this_box_volume.geometry.initialize_from_main_function = &initialize_box_geometry_from_main_component;
this_box_volume.geometry.process_rot_allocated = 0;

this_box_volume.geometry.copy_geometry_parameters = &allocate_box_storage_copy;

rot_copy(this_box_volume.geometry.rotation_matrix,ROT_A_CURRENT_COMP); //check how ROT_R_CURRENT_COMP would work
rot_transpose(ROT_A_CURRENT_COMP,this_box_volume.geometry.transpose_rotation_matrix);

// Initialize loggers
this_box_volume.loggers.num_elements = 0;

// packing the information into the global_geometry_element, which is then included in the global_geometry_list.
sprintf(global_geometry_element.name,NAME_CURRENT_COMP);
global_geometry_element.activation_counter = number_of_activations;
global_geometry_element.component_index = INDEX_CURRENT_COMP;
global_geometry_element.Volume = &this_box_volume; // Would be nicer if this m was a pointer, now we have the (small) data two places
add_element_to_geometry_list(&global_geometry_list,global_geometry_element);
}
#line 205613 "MACS_sample_kidney_box.c"
#undef number_of_activations
#undef mask_setting
#undef mask_string
#undef p_interact
#undef focus_r
#undef focus_xh
#undef focus_xw
#undef focus_ah
#undef focus_aw
#undef target_z
#undef target_y
#undef target_x
#undef target_index
#undef visualize
#undef yheight2
#undef xwidth2
#undef zdepth
#undef yheight
#undef xwidth
#undef priority
#undef material_string
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

  /* Initializations for component channel_4_cave2_cyl1. */
  SIG_MESSAGE("channel_4_cave2_cyl1 (Init)");
#define mccompcurname  channel_4_cave2_cyl1
#define mccompcurtype  Union_cylinder
#define mccompcurindex 302
#define loop_index mccchannel_4_cave2_cyl1_loop_index
#define this_cylinder_volume mccchannel_4_cave2_cyl1_this_cylinder_volume
#define global_geometry_element mccchannel_4_cave2_cyl1_global_geometry_element
#define this_cylinder_storage mccchannel_4_cave2_cyl1_this_cylinder_storage
#define material_string mccchannel_4_cave2_cyl1_material_string
#define priority mccchannel_4_cave2_cyl1_priority
#define radius mccchannel_4_cave2_cyl1_radius
#define yheight mccchannel_4_cave2_cyl1_yheight
#define visualize mccchannel_4_cave2_cyl1_visualize
#define target_index mccchannel_4_cave2_cyl1_target_index
#define target_x mccchannel_4_cave2_cyl1_target_x
#define target_y mccchannel_4_cave2_cyl1_target_y
#define target_z mccchannel_4_cave2_cyl1_target_z
#define focus_aw mccchannel_4_cave2_cyl1_focus_aw
#define focus_ah mccchannel_4_cave2_cyl1_focus_ah
#define focus_xw mccchannel_4_cave2_cyl1_focus_xw
#define focus_xh mccchannel_4_cave2_cyl1_focus_xh
#define focus_r mccchannel_4_cave2_cyl1_focus_r
#define p_interact mccchannel_4_cave2_cyl1_p_interact
#define mask_string mccchannel_4_cave2_cyl1_mask_string
#define mask_setting mccchannel_4_cave2_cyl1_mask_setting
#define number_of_activations mccchannel_4_cave2_cyl1_number_of_activations
#line 185 "Union_cylinder.comp"
{
// Initializes the focusing system for this volume including input sanitation.
focus_initialize(&this_cylinder_volume.geometry, POS_A_COMP_INDEX(INDEX_CURRENT_COMP+target_index), POS_A_CURRENT_COMP, ROT_A_CURRENT_COMP, target_index, target_x, target_y, target_z, focus_aw, focus_ah, focus_xw, focus_xh, focus_r, NAME_CURRENT_COMP);

// Input sanitation for this geometry
if (radius <= 0) {
  printf("\nERROR in Union_cylinder named %s, the radius is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}

if (yheight <= 0) {
  printf("\nERROR in Union_cylinder named %s, yheight is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}

// Use sanitation
#ifdef MATERIAL_DETECTOR
if (global_material_list.num_elements == 0) {
  // Here if the user have defined a material, but only after this material
  printf("\nERROR: Need to define a material using Union_make_material before using a Union geometry component. \n");
  printf("       %s was defined before first use of Union_make_material.\n",NAME_CURRENT_COMP);
  exit(1);
}
#endif
#ifndef MATERIAL_DETECTOR
  printf("\nERROR: Need to define a material using Union_make_material before using a Union geometry component. \n");
  exit(1);
#endif


this_cylinder_volume.geometry.is_masked_volume = 0;
this_cylinder_volume.geometry.is_exit_volume = 0;
this_cylinder_volume.geometry.is_mask_volume = 0;

// Read the material input, or if it lacks, use automatic linking.
if (mask_string && strlen(mask_string) && strcmp(mask_string, "NULL") && strcmp(mask_string, "0")) {
    // A mask volume is used to limit the extend of other volumes, called the masked volumes. These are specified in the mask_string.
    // In order for a ray to enter a masked volume, it needs to be both in the region covered by that volume AND the mask volume.
    // When more than
    this_cylinder_volume.geometry.mask_mode = 1; // Default is mask mode is ALL
    if (mask_setting && strlen(mask_setting) && strcmp(mask_setting, "NULL") && strcmp(mask_setting, "0")) {
        if (strcmp(mask_setting,"ALL") == 0 || strcmp(mask_setting,"All") == 0) this_cylinder_volume.geometry.mask_mode = 1;
        else if (strcmp(mask_setting,"ANY") == 0 || strcmp(mask_setting,"Any") == 0) this_cylinder_volume.geometry.mask_mode = 2;
        else {
            printf("The mask_mode of component %s is set to %s, but must be either ALL or ANY.\n",NAME_CURRENT_COMP,mask_setting);
            exit(1);
        }
    }
    
    for (loop_index=0;loop_index<global_geometry_list.num_elements;loop_index++) {
        // Add mask list
        if (1 == manual_linking_function(global_geometry_list.elements[loop_index].name,mask_string)) {
            add_element_to_int_list(&this_cylinder_volume.geometry.mask_list,global_geometry_list.elements[loop_index].component_index);
            add_element_to_int_list(&global_geometry_list.elements[loop_index].Volume->geometry.masked_by_list,INDEX_CURRENT_COMP);
            global_geometry_list.elements[loop_index].Volume->geometry.is_masked_volume = 1;
            if (this_cylinder_volume.geometry.mask_mode == 2)
                global_geometry_list.elements[loop_index].Volume->geometry.mask_mode = 2;
            if (this_cylinder_volume.geometry.mask_mode == 1) {
                if (global_geometry_list.elements[loop_index].Volume->geometry.is_masked_volume == 1 && global_geometry_list.elements[loop_index].Volume->geometry.mask_mode != 2)
                    // If more than one mask is added to one volume, the ANY mode overwrites the (default) ALL mode.
                    global_geometry_list.elements[loop_index].Volume->geometry.mask_mode = 1;
            }
            
            found_geometries = 1;
        }
    }
    if (found_geometries == 0) {
        printf("The mask_string in geometry: %s did not find any of the specified volumes in the mask_string %s \n",NAME_CURRENT_COMP,mask_string);
        exit(1);
    }
    this_cylinder_volume.p_physics = malloc(sizeof(struct physics_struct));
    this_cylinder_volume.p_physics->is_vacuum = 0; // Makes this volume a vacuum
    this_cylinder_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
    this_cylinder_volume.p_physics->my_a = 0; // Should not be used.
    sprintf(this_cylinder_volume.p_physics->name,"Mask");
    this_cylinder_volume.geometry.is_mask_volume = 1;
    
    
// Read the material input, or if it lacks, use automatic linking.
} else if (material_string && strlen(material_string) && strcmp(material_string, "NULL") && strcmp(material_string, "0")) {
    // A geometry string was given, use it to determine which material
    if (0 == strcmp(material_string,"vacuum") || 0 == strcmp(material_string,"Vacuum")) {
        // One could have a global physics struct for vacuum instead of creating one for each
        this_cylinder_volume.p_physics = malloc(sizeof(struct physics_struct));
        this_cylinder_volume.p_physics->is_vacuum = 1; // Makes this volume a vacuum
        this_cylinder_volume.p_physics->number_of_processes = (int) 0;
        this_cylinder_volume.p_physics->my_a = 0; // Should not be used.
        sprintf(this_cylinder_volume.p_physics->name,"Vacuum");
    } else if (0 == strcmp(material_string,"exit") || 0 == strcmp(material_string,"Exit")) {
        // One could have a global physics struct for exit instead of creating one for each
        this_cylinder_volume.p_physics = malloc(sizeof(struct physics_struct));
        this_cylinder_volume.p_physics->is_vacuum = 1; // Makes this volume a vacuum
        this_cylinder_volume.p_physics->number_of_processes = (int) 0;
        this_cylinder_volume.p_physics->my_a = 0; // Should not be used.
        this_cylinder_volume.geometry.is_exit_volume = 1;
        sprintf(this_cylinder_volume.p_physics->name,"Exit");
    } else {
        for (loop_index=0;loop_index<global_material_list.num_elements;loop_index++) {
          if (0 == strcmp(material_string,global_material_list.elements[loop_index].name)) {
            this_cylinder_volume.p_physics = global_material_list.elements[loop_index].physics;
            break;
          }
          if (loop_index == global_material_list.num_elements-1) {
            printf("\n");
            printf("ERROR: The material string \"%s\" in Union geometry \"%s\" did not match a specified material. \n",material_string,NAME_CURRENT_COMP);
            printf("       The materials available at this point (need to be defined before the geometry): \n");
            for (loop_index=0;loop_index<global_material_list.num_elements;loop_index++)
              printf("         %s\n",global_material_list.elements[loop_index].name);
            printf("\n");
            printf("       It is also possible to use one of the defualt materials avaiable: \n");
            printf("           Vacuum (for a Volume without scattering or absorption)\n");
            printf("           Exit (for a Volume where the ray exits the component if it enters)\n");
            printf("           Mask (for a Volume that masks existing volumes specified in the mask_string\n");
            exit(1);
          }
        }
    }
} else {
    // Automatic linking, simply using the last defined material.
    #ifndef MATERIAL_DETECTOR
        printf("Need to define a material before the geometry to use automatic linking %s.\n",NAME_CURRENT_COMP);
        exit(1);
    #endif
    this_cylinder_volume.p_physics = global_material_list.elements[global_material_list.num_elements-1].physics;
}

sprintf(this_cylinder_volume.name,NAME_CURRENT_COMP);
sprintf(this_cylinder_volume.geometry.shape,"cylinder");
this_cylinder_volume.geometry.priority_value = priority;
// Currently the coordinates will be in absolute space.
this_cylinder_volume.geometry.center = POS_A_CURRENT_COMP;

this_cylinder_volume.geometry.geometry_p_interact = p_interact;
this_cylinder_storage.cyl_radius = radius;
this_cylinder_storage.height = yheight;
this_cylinder_volume.geometry.visualization_on = visualize;
this_cylinder_volume.geometry.geometry_parameters.p_cylinder_storage = &this_cylinder_storage;
this_cylinder_volume.geometry.within_function = &r_within_cylinder;
this_cylinder_volume.geometry.intersect_function = &sample_cylinder_intersect;
this_cylinder_volume.geometry.mcdisplay_function = &mcdisplay_cylinder_function;
this_cylinder_volume.geometry.shell_points = &cylinder_shell_points;
this_cylinder_volume.geometry.initialize_from_main_function = &initialize_cylinder_geometry_from_main_component;
this_cylinder_volume.geometry.process_rot_allocated = 0;
this_cylinder_volume.geometry.copy_geometry_parameters = &allocate_cylinder_storage_copy;

rot_copy(this_cylinder_volume.geometry.rotation_matrix,ROT_A_CURRENT_COMP);
rot_transpose(ROT_A_CURRENT_COMP,this_cylinder_volume.geometry.transpose_rotation_matrix);

// Initialize loggers
this_cylinder_volume.loggers.num_elements = 0;

// packing the information into the global_geometry_element, which is then included in the global_geometry_list.
sprintf(global_geometry_element.name,NAME_CURRENT_COMP);
global_geometry_element.activation_counter = number_of_activations;
global_geometry_element.component_index = INDEX_CURRENT_COMP;
global_geometry_element.Volume = &this_cylinder_volume; // Would be nicer if this m was a pointer, now we have the (small) data two places
add_element_to_geometry_list(&global_geometry_list,global_geometry_element);
}
#line 205829 "MACS_sample_kidney_box.c"
#undef number_of_activations
#undef mask_setting
#undef mask_string
#undef p_interact
#undef focus_r
#undef focus_xh
#undef focus_xw
#undef focus_ah
#undef focus_aw
#undef target_z
#undef target_y
#undef target_x
#undef target_index
#undef visualize
#undef yheight
#undef radius
#undef priority
#undef material_string
#undef this_cylinder_storage
#undef global_geometry_element
#undef this_cylinder_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

  /* Initializations for component channel_4_cave2_box1. */
  SIG_MESSAGE("channel_4_cave2_box1 (Init)");
#define mccompcurname  channel_4_cave2_box1
#define mccompcurtype  Union_box
#define mccompcurindex 303
#define loop_index mccchannel_4_cave2_box1_loop_index
#define this_box_volume mccchannel_4_cave2_box1_this_box_volume
#define global_geometry_element mccchannel_4_cave2_box1_global_geometry_element
#define this_box_storage mccchannel_4_cave2_box1_this_box_storage
#define material_string mccchannel_4_cave2_box1_material_string
#define priority mccchannel_4_cave2_box1_priority
#define xwidth mccchannel_4_cave2_box1_xwidth
#define yheight mccchannel_4_cave2_box1_yheight
#define zdepth mccchannel_4_cave2_box1_zdepth
#define xwidth2 mccchannel_4_cave2_box1_xwidth2
#define yheight2 mccchannel_4_cave2_box1_yheight2
#define visualize mccchannel_4_cave2_box1_visualize
#define target_index mccchannel_4_cave2_box1_target_index
#define target_x mccchannel_4_cave2_box1_target_x
#define target_y mccchannel_4_cave2_box1_target_y
#define target_z mccchannel_4_cave2_box1_target_z
#define focus_aw mccchannel_4_cave2_box1_focus_aw
#define focus_ah mccchannel_4_cave2_box1_focus_ah
#define focus_xw mccchannel_4_cave2_box1_focus_xw
#define focus_xh mccchannel_4_cave2_box1_focus_xh
#define focus_r mccchannel_4_cave2_box1_focus_r
#define p_interact mccchannel_4_cave2_box1_p_interact
#define mask_string mccchannel_4_cave2_box1_mask_string
#define mask_setting mccchannel_4_cave2_box1_mask_setting
#define number_of_activations mccchannel_4_cave2_box1_number_of_activations
#line 224 "Union_box.comp"
{
// Initializes the focusing system for this volume including input sanitation.
focus_initialize(&this_box_volume.geometry, POS_A_COMP_INDEX(INDEX_CURRENT_COMP+target_index), POS_A_CURRENT_COMP, ROT_A_CURRENT_COMP, target_index, target_x, target_y, target_z, focus_aw, focus_ah, focus_xw, focus_xh, focus_r, NAME_CURRENT_COMP);

// Input sanitation for this geometry
if (xwidth <= 0) {
  printf("\nERROR in Union_box named %s, the xwidth is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (yheight <= 0) {
  printf("\nERROR in Union_box named %s, yheight is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (zdepth <= 0) {
  printf("\nERROR in Union_box named %s, zdepth is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (xwidth2 <= 0 && xwidth2 != -1) {
  printf("\nERROR in Union_box named %s, the xwidth2 is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (yheight2 <= 0 && yheight2 != -1) {
  printf("\nERROR in Union_box named %s, yheight2 is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}

// Use sanitation
if (global_material_list.num_elements == 0) {
  printf("\nERROR: Need to define a material using Union_make_material before using a Union geometry component. \n");
  printf("       %s was defined before first use of Union_make_material.\n",NAME_CURRENT_COMP);
  exit(1);
}

this_box_volume.geometry.is_masked_volume = 0;
this_box_volume.geometry.is_exit_volume = 0;
this_box_volume.geometry.is_mask_volume = 0;
// check if the volume is a mask, if it is the material string is irelevant.
if (mask_string && strlen(mask_string) && strcmp(mask_string, "NULL") && strcmp(mask_string, "0")) {
    // A mask volume is used to limit the extend of other volumes, called the masked volumes. These are specified in the mask_string.
    // In order for a ray to enter a masked volume, it needs to be both in the region covered by that volume AND the mask volume.
    // When more than
    this_box_volume.geometry.mask_mode = 1; // Default is mask mode is ALL
    if (mask_setting && strlen(mask_setting) && strcmp(mask_setting, "NULL") && strcmp(mask_setting, "0")) {
        if (strcmp(mask_setting,"ALL") == 0 || strcmp(mask_setting,"All") == 0) this_box_volume.geometry.mask_mode = 1;
        else if (strcmp(mask_setting,"ANY") == 0 || strcmp(mask_setting,"Any") == 0) this_box_volume.geometry.mask_mode = 2;
        else {
            printf("The mask_mode of component %s is set to %s, but must be either ALL or ANY.\n",NAME_CURRENT_COMP,mask_setting);
            exit(1);
        }
    }
    
    for (loop_index=0;loop_index<global_geometry_list.num_elements;loop_index++) {
        // Add mask list
        if (1 == manual_linking_function(global_geometry_list.elements[loop_index].name,mask_string)) {
            add_element_to_int_list(&this_box_volume.geometry.mask_list,global_geometry_list.elements[loop_index].component_index);
            add_element_to_int_list(&global_geometry_list.elements[loop_index].Volume->geometry.masked_by_list,INDEX_CURRENT_COMP);
            global_geometry_list.elements[loop_index].Volume->geometry.is_masked_volume = 1;
            if (this_box_volume.geometry.mask_mode == 2)
                global_geometry_list.elements[loop_index].Volume->geometry.mask_mode = 2;
            if (this_box_volume.geometry.mask_mode == 1) {
                if (global_geometry_list.elements[loop_index].Volume->geometry.is_masked_volume == 1 && global_geometry_list.elements[loop_index].Volume->geometry.mask_mode != 2)
                    // If more than one mask is added to one volume, the ANY mode overwrites the (default) ALL mode.
                    global_geometry_list.elements[loop_index].Volume->geometry.mask_mode = 1;
            }
            
            found_geometries = 1;
        }
    }
    if (found_geometries == 0) {
        printf("The mask_string in geometry: %s did not find any of the specified volumes in the mask_string %s \n",NAME_CURRENT_COMP,mask_string);
        exit(1);
    }
    this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
    this_box_volume.p_physics->is_vacuum = 0; // Makes this volume a vacuum
    this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
    this_box_volume.p_physics->my_a = 0; // Should not be used.
    sprintf(this_box_volume.p_physics->name,"Mask");
    this_box_volume.geometry.is_mask_volume = 1;
    
    
// Read the material input, or if it lacks, use automatic linking.
} else if (material_string && strlen(material_string) && strcmp(material_string, "NULL") && strcmp(material_string, "0")) {
    // A geometry string was given, use it to determine which material
    if (0 == strcmp(material_string,"vacuum") || 0 == strcmp(material_string,"Vacuum")) {
        // One could have a global physics struct for vacuum instead of creating one for each
        this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
        this_box_volume.p_physics->is_vacuum = 1; // Makes this volume a vacuum
        this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
        this_box_volume.p_physics->my_a = 0; // Should not be used.
        sprintf(this_box_volume.p_physics->name,"Vacuum");
    } else if (0 == strcmp(material_string,"exit") || 0 == strcmp(material_string,"Exit")) {
        // One could have a global physics struct for vacuum instead of creating one for each
        this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
        this_box_volume.p_physics->is_vacuum = 1; // Makes this volume a vacuum
        this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
        this_box_volume.p_physics->my_a = 0; // Should not be used.
        this_box_volume.geometry.is_exit_volume = 1;
        sprintf(this_box_volume.p_physics->name,"Exit");
    } else {
        #ifndef MATERIAL_DETECTOR
            printf("Need to define a material before refering to it in a geometry %s.\n",NAME_CURRENT_COMP);
            exit(1);
        #endif
        for (loop_index=0;loop_index<global_material_list.num_elements;loop_index++) {
            if (0 == strcmp(material_string,global_material_list.elements[loop_index].name)) {
                this_box_volume.p_physics = global_material_list.elements[loop_index].physics;
                break;
            }
            if (loop_index == global_material_list.num_elements-1) {
            printf("\n");
            printf("ERROR: The material string \"%s\" in Union geometry \"%s\" did not match a specified material. \n",material_string,NAME_CURRENT_COMP);
            printf("       The materials available at this point (need to be defined before the geometry): \n");
            for (loop_index=0;loop_index<global_material_list.num_elements;loop_index++)
              printf("         %s\n",global_material_list.elements[loop_index].name);
            printf("\n");
            printf("       It is also possible to use one of the defualt materials avaiable: \n");
            printf("           Vacuum (for a Volume without scattering or absorption)\n");
            printf("           Exit (for a Volume where the ray exits the component if it enters)\n");
            printf("           Mask (for a Volume that masks existing volumes specified in the mask_string\n");
            exit(1);
          }
        }
    }
} else {
    // Automatic linking, simply using the last defined material.
    #ifndef MATERIAL_DETECTOR
        printf("Need to define a material before the geometry to use automatic linking %s.\n",NAME_CURRENT_COMP);
        exit(1);
    #endif
    this_box_volume.p_physics = global_material_list.elements[global_material_list.num_elements-1].physics;
}

sprintf(this_box_volume.name,NAME_CURRENT_COMP);
sprintf(this_box_volume.geometry.shape,"box");
this_box_volume.geometry.priority_value = priority;
this_box_volume.geometry.geometry_p_interact = p_interact;
// Currently the coordinates will be in absolute space.
this_box_volume.geometry.center = POS_A_CURRENT_COMP;

this_box_storage.z_depth = zdepth;
this_box_storage.x_width1 = xwidth;
this_box_storage.y_height1 = yheight;

this_box_storage.is_rectangle = 0;
if (xwidth2 < 0 && yheight2 < 0) this_box_storage.is_rectangle = 1;
if (xwidth == xwidth2 && yheight == yheight2) this_box_storage.is_rectangle = 1;

if (xwidth2 < 0) {
    this_box_storage.x_width2 = xwidth;
    xwidth2 = xwidth;
} else this_box_storage.x_width2 = xwidth2;

if (yheight2 < 0) {
    this_box_storage.y_height2 = yheight;
    yheight2 = yheight;
} else this_box_storage.y_height2 = yheight2;


this_box_storage.normal_vectors[0] = coords_set(0,0,1);
this_box_storage.normal_vectors[1] = coords_set(0,0,1);

// for sides with y component = 0
x_component = 2*zdepth/sqrt((xwidth-xwidth2)*(xwidth-xwidth2)+4*zdepth*zdepth);
z_component = (xwidth-xwidth2)/sqrt(4*zdepth*zdepth+(xwidth-xwidth2)*(xwidth-xwidth2));

this_box_storage.normal_vectors[2] = coords_set(x_component,0,z_component);
this_box_storage.normal_vectors[3] = coords_set(-x_component,0,z_component);

// for sides with x component = 0
y_component = 2*zdepth/sqrt((yheight-yheight2)*(yheight-yheight2)+4*zdepth*zdepth);
z_component = (yheight-yheight2)/sqrt(4*zdepth*zdepth+(yheight-yheight2)*(yheight-yheight2));

this_box_storage.normal_vectors[4] = coords_set(0,y_component,z_component);
this_box_storage.normal_vectors[5] = coords_set(0,-y_component,z_component);

this_box_volume.geometry.visualization_on = visualize;

this_box_volume.geometry.geometry_parameters.p_box_storage = &this_box_storage;

// Assign pointers to functions for intersection with the shape, checking if a point is inside the shape
if (this_box_storage.is_rectangle == 1) {
this_box_volume.geometry.intersect_function = &sample_box_intersect_simple;
this_box_volume.geometry.within_function = &r_within_box_simple;
}
else {
this_box_volume.geometry.intersect_function = &sample_box_intersect_advanced;
this_box_volume.geometry.within_function = &r_within_box_advanced;
}

this_box_volume.geometry.shell_points = &box_shell_points;
this_box_volume.geometry.mcdisplay_function = &mcdisplay_box_function;
this_box_volume.geometry.initialize_from_main_function = &initialize_box_geometry_from_main_component;
this_box_volume.geometry.process_rot_allocated = 0;

this_box_volume.geometry.copy_geometry_parameters = &allocate_box_storage_copy;

rot_copy(this_box_volume.geometry.rotation_matrix,ROT_A_CURRENT_COMP); //check how ROT_R_CURRENT_COMP would work
rot_transpose(ROT_A_CURRENT_COMP,this_box_volume.geometry.transpose_rotation_matrix);

// Initialize loggers
this_box_volume.loggers.num_elements = 0;

// packing the information into the global_geometry_element, which is then included in the global_geometry_list.
sprintf(global_geometry_element.name,NAME_CURRENT_COMP);
global_geometry_element.activation_counter = number_of_activations;
global_geometry_element.component_index = INDEX_CURRENT_COMP;
global_geometry_element.Volume = &this_box_volume; // Would be nicer if this m was a pointer, now we have the (small) data two places
add_element_to_geometry_list(&global_geometry_list,global_geometry_element);
}
#line 206096 "MACS_sample_kidney_box.c"
#undef number_of_activations
#undef mask_setting
#undef mask_string
#undef p_interact
#undef focus_r
#undef focus_xh
#undef focus_xw
#undef focus_ah
#undef focus_aw
#undef target_z
#undef target_y
#undef target_x
#undef target_index
#undef visualize
#undef yheight2
#undef xwidth2
#undef zdepth
#undef yheight
#undef xwidth
#undef priority
#undef material_string
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

  /* Initializations for component channel_4_cave2_box2. */
  SIG_MESSAGE("channel_4_cave2_box2 (Init)");
#define mccompcurname  channel_4_cave2_box2
#define mccompcurtype  Union_box
#define mccompcurindex 304
#define loop_index mccchannel_4_cave2_box2_loop_index
#define this_box_volume mccchannel_4_cave2_box2_this_box_volume
#define global_geometry_element mccchannel_4_cave2_box2_global_geometry_element
#define this_box_storage mccchannel_4_cave2_box2_this_box_storage
#define material_string mccchannel_4_cave2_box2_material_string
#define priority mccchannel_4_cave2_box2_priority
#define xwidth mccchannel_4_cave2_box2_xwidth
#define yheight mccchannel_4_cave2_box2_yheight
#define zdepth mccchannel_4_cave2_box2_zdepth
#define xwidth2 mccchannel_4_cave2_box2_xwidth2
#define yheight2 mccchannel_4_cave2_box2_yheight2
#define visualize mccchannel_4_cave2_box2_visualize
#define target_index mccchannel_4_cave2_box2_target_index
#define target_x mccchannel_4_cave2_box2_target_x
#define target_y mccchannel_4_cave2_box2_target_y
#define target_z mccchannel_4_cave2_box2_target_z
#define focus_aw mccchannel_4_cave2_box2_focus_aw
#define focus_ah mccchannel_4_cave2_box2_focus_ah
#define focus_xw mccchannel_4_cave2_box2_focus_xw
#define focus_xh mccchannel_4_cave2_box2_focus_xh
#define focus_r mccchannel_4_cave2_box2_focus_r
#define p_interact mccchannel_4_cave2_box2_p_interact
#define mask_string mccchannel_4_cave2_box2_mask_string
#define mask_setting mccchannel_4_cave2_box2_mask_setting
#define number_of_activations mccchannel_4_cave2_box2_number_of_activations
#line 224 "Union_box.comp"
{
// Initializes the focusing system for this volume including input sanitation.
focus_initialize(&this_box_volume.geometry, POS_A_COMP_INDEX(INDEX_CURRENT_COMP+target_index), POS_A_CURRENT_COMP, ROT_A_CURRENT_COMP, target_index, target_x, target_y, target_z, focus_aw, focus_ah, focus_xw, focus_xh, focus_r, NAME_CURRENT_COMP);

// Input sanitation for this geometry
if (xwidth <= 0) {
  printf("\nERROR in Union_box named %s, the xwidth is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (yheight <= 0) {
  printf("\nERROR in Union_box named %s, yheight is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (zdepth <= 0) {
  printf("\nERROR in Union_box named %s, zdepth is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (xwidth2 <= 0 && xwidth2 != -1) {
  printf("\nERROR in Union_box named %s, the xwidth2 is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (yheight2 <= 0 && yheight2 != -1) {
  printf("\nERROR in Union_box named %s, yheight2 is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}

// Use sanitation
if (global_material_list.num_elements == 0) {
  printf("\nERROR: Need to define a material using Union_make_material before using a Union geometry component. \n");
  printf("       %s was defined before first use of Union_make_material.\n",NAME_CURRENT_COMP);
  exit(1);
}

this_box_volume.geometry.is_masked_volume = 0;
this_box_volume.geometry.is_exit_volume = 0;
this_box_volume.geometry.is_mask_volume = 0;
// check if the volume is a mask, if it is the material string is irelevant.
if (mask_string && strlen(mask_string) && strcmp(mask_string, "NULL") && strcmp(mask_string, "0")) {
    // A mask volume is used to limit the extend of other volumes, called the masked volumes. These are specified in the mask_string.
    // In order for a ray to enter a masked volume, it needs to be both in the region covered by that volume AND the mask volume.
    // When more than
    this_box_volume.geometry.mask_mode = 1; // Default is mask mode is ALL
    if (mask_setting && strlen(mask_setting) && strcmp(mask_setting, "NULL") && strcmp(mask_setting, "0")) {
        if (strcmp(mask_setting,"ALL") == 0 || strcmp(mask_setting,"All") == 0) this_box_volume.geometry.mask_mode = 1;
        else if (strcmp(mask_setting,"ANY") == 0 || strcmp(mask_setting,"Any") == 0) this_box_volume.geometry.mask_mode = 2;
        else {
            printf("The mask_mode of component %s is set to %s, but must be either ALL or ANY.\n",NAME_CURRENT_COMP,mask_setting);
            exit(1);
        }
    }
    
    for (loop_index=0;loop_index<global_geometry_list.num_elements;loop_index++) {
        // Add mask list
        if (1 == manual_linking_function(global_geometry_list.elements[loop_index].name,mask_string)) {
            add_element_to_int_list(&this_box_volume.geometry.mask_list,global_geometry_list.elements[loop_index].component_index);
            add_element_to_int_list(&global_geometry_list.elements[loop_index].Volume->geometry.masked_by_list,INDEX_CURRENT_COMP);
            global_geometry_list.elements[loop_index].Volume->geometry.is_masked_volume = 1;
            if (this_box_volume.geometry.mask_mode == 2)
                global_geometry_list.elements[loop_index].Volume->geometry.mask_mode = 2;
            if (this_box_volume.geometry.mask_mode == 1) {
                if (global_geometry_list.elements[loop_index].Volume->geometry.is_masked_volume == 1 && global_geometry_list.elements[loop_index].Volume->geometry.mask_mode != 2)
                    // If more than one mask is added to one volume, the ANY mode overwrites the (default) ALL mode.
                    global_geometry_list.elements[loop_index].Volume->geometry.mask_mode = 1;
            }
            
            found_geometries = 1;
        }
    }
    if (found_geometries == 0) {
        printf("The mask_string in geometry: %s did not find any of the specified volumes in the mask_string %s \n",NAME_CURRENT_COMP,mask_string);
        exit(1);
    }
    this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
    this_box_volume.p_physics->is_vacuum = 0; // Makes this volume a vacuum
    this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
    this_box_volume.p_physics->my_a = 0; // Should not be used.
    sprintf(this_box_volume.p_physics->name,"Mask");
    this_box_volume.geometry.is_mask_volume = 1;
    
    
// Read the material input, or if it lacks, use automatic linking.
} else if (material_string && strlen(material_string) && strcmp(material_string, "NULL") && strcmp(material_string, "0")) {
    // A geometry string was given, use it to determine which material
    if (0 == strcmp(material_string,"vacuum") || 0 == strcmp(material_string,"Vacuum")) {
        // One could have a global physics struct for vacuum instead of creating one for each
        this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
        this_box_volume.p_physics->is_vacuum = 1; // Makes this volume a vacuum
        this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
        this_box_volume.p_physics->my_a = 0; // Should not be used.
        sprintf(this_box_volume.p_physics->name,"Vacuum");
    } else if (0 == strcmp(material_string,"exit") || 0 == strcmp(material_string,"Exit")) {
        // One could have a global physics struct for vacuum instead of creating one for each
        this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
        this_box_volume.p_physics->is_vacuum = 1; // Makes this volume a vacuum
        this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
        this_box_volume.p_physics->my_a = 0; // Should not be used.
        this_box_volume.geometry.is_exit_volume = 1;
        sprintf(this_box_volume.p_physics->name,"Exit");
    } else {
        #ifndef MATERIAL_DETECTOR
            printf("Need to define a material before refering to it in a geometry %s.\n",NAME_CURRENT_COMP);
            exit(1);
        #endif
        for (loop_index=0;loop_index<global_material_list.num_elements;loop_index++) {
            if (0 == strcmp(material_string,global_material_list.elements[loop_index].name)) {
                this_box_volume.p_physics = global_material_list.elements[loop_index].physics;
                break;
            }
            if (loop_index == global_material_list.num_elements-1) {
            printf("\n");
            printf("ERROR: The material string \"%s\" in Union geometry \"%s\" did not match a specified material. \n",material_string,NAME_CURRENT_COMP);
            printf("       The materials available at this point (need to be defined before the geometry): \n");
            for (loop_index=0;loop_index<global_material_list.num_elements;loop_index++)
              printf("         %s\n",global_material_list.elements[loop_index].name);
            printf("\n");
            printf("       It is also possible to use one of the defualt materials avaiable: \n");
            printf("           Vacuum (for a Volume without scattering or absorption)\n");
            printf("           Exit (for a Volume where the ray exits the component if it enters)\n");
            printf("           Mask (for a Volume that masks existing volumes specified in the mask_string\n");
            exit(1);
          }
        }
    }
} else {
    // Automatic linking, simply using the last defined material.
    #ifndef MATERIAL_DETECTOR
        printf("Need to define a material before the geometry to use automatic linking %s.\n",NAME_CURRENT_COMP);
        exit(1);
    #endif
    this_box_volume.p_physics = global_material_list.elements[global_material_list.num_elements-1].physics;
}

sprintf(this_box_volume.name,NAME_CURRENT_COMP);
sprintf(this_box_volume.geometry.shape,"box");
this_box_volume.geometry.priority_value = priority;
this_box_volume.geometry.geometry_p_interact = p_interact;
// Currently the coordinates will be in absolute space.
this_box_volume.geometry.center = POS_A_CURRENT_COMP;

this_box_storage.z_depth = zdepth;
this_box_storage.x_width1 = xwidth;
this_box_storage.y_height1 = yheight;

this_box_storage.is_rectangle = 0;
if (xwidth2 < 0 && yheight2 < 0) this_box_storage.is_rectangle = 1;
if (xwidth == xwidth2 && yheight == yheight2) this_box_storage.is_rectangle = 1;

if (xwidth2 < 0) {
    this_box_storage.x_width2 = xwidth;
    xwidth2 = xwidth;
} else this_box_storage.x_width2 = xwidth2;

if (yheight2 < 0) {
    this_box_storage.y_height2 = yheight;
    yheight2 = yheight;
} else this_box_storage.y_height2 = yheight2;


this_box_storage.normal_vectors[0] = coords_set(0,0,1);
this_box_storage.normal_vectors[1] = coords_set(0,0,1);

// for sides with y component = 0
x_component = 2*zdepth/sqrt((xwidth-xwidth2)*(xwidth-xwidth2)+4*zdepth*zdepth);
z_component = (xwidth-xwidth2)/sqrt(4*zdepth*zdepth+(xwidth-xwidth2)*(xwidth-xwidth2));

this_box_storage.normal_vectors[2] = coords_set(x_component,0,z_component);
this_box_storage.normal_vectors[3] = coords_set(-x_component,0,z_component);

// for sides with x component = 0
y_component = 2*zdepth/sqrt((yheight-yheight2)*(yheight-yheight2)+4*zdepth*zdepth);
z_component = (yheight-yheight2)/sqrt(4*zdepth*zdepth+(yheight-yheight2)*(yheight-yheight2));

this_box_storage.normal_vectors[4] = coords_set(0,y_component,z_component);
this_box_storage.normal_vectors[5] = coords_set(0,-y_component,z_component);

this_box_volume.geometry.visualization_on = visualize;

this_box_volume.geometry.geometry_parameters.p_box_storage = &this_box_storage;

// Assign pointers to functions for intersection with the shape, checking if a point is inside the shape
if (this_box_storage.is_rectangle == 1) {
this_box_volume.geometry.intersect_function = &sample_box_intersect_simple;
this_box_volume.geometry.within_function = &r_within_box_simple;
}
else {
this_box_volume.geometry.intersect_function = &sample_box_intersect_advanced;
this_box_volume.geometry.within_function = &r_within_box_advanced;
}

this_box_volume.geometry.shell_points = &box_shell_points;
this_box_volume.geometry.mcdisplay_function = &mcdisplay_box_function;
this_box_volume.geometry.initialize_from_main_function = &initialize_box_geometry_from_main_component;
this_box_volume.geometry.process_rot_allocated = 0;

this_box_volume.geometry.copy_geometry_parameters = &allocate_box_storage_copy;

rot_copy(this_box_volume.geometry.rotation_matrix,ROT_A_CURRENT_COMP); //check how ROT_R_CURRENT_COMP would work
rot_transpose(ROT_A_CURRENT_COMP,this_box_volume.geometry.transpose_rotation_matrix);

// Initialize loggers
this_box_volume.loggers.num_elements = 0;

// packing the information into the global_geometry_element, which is then included in the global_geometry_list.
sprintf(global_geometry_element.name,NAME_CURRENT_COMP);
global_geometry_element.activation_counter = number_of_activations;
global_geometry_element.component_index = INDEX_CURRENT_COMP;
global_geometry_element.Volume = &this_box_volume; // Would be nicer if this m was a pointer, now we have the (small) data two places
add_element_to_geometry_list(&global_geometry_list,global_geometry_element);
}
#line 206366 "MACS_sample_kidney_box.c"
#undef number_of_activations
#undef mask_setting
#undef mask_string
#undef p_interact
#undef focus_r
#undef focus_xh
#undef focus_xw
#undef focus_ah
#undef focus_aw
#undef target_z
#undef target_y
#undef target_x
#undef target_index
#undef visualize
#undef yheight2
#undef xwidth2
#undef zdepth
#undef yheight
#undef xwidth
#undef priority
#undef material_string
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

  /* Initializations for component channel_4_cave2_box3. */
  SIG_MESSAGE("channel_4_cave2_box3 (Init)");
#define mccompcurname  channel_4_cave2_box3
#define mccompcurtype  Union_box
#define mccompcurindex 305
#define loop_index mccchannel_4_cave2_box3_loop_index
#define this_box_volume mccchannel_4_cave2_box3_this_box_volume
#define global_geometry_element mccchannel_4_cave2_box3_global_geometry_element
#define this_box_storage mccchannel_4_cave2_box3_this_box_storage
#define material_string mccchannel_4_cave2_box3_material_string
#define priority mccchannel_4_cave2_box3_priority
#define xwidth mccchannel_4_cave2_box3_xwidth
#define yheight mccchannel_4_cave2_box3_yheight
#define zdepth mccchannel_4_cave2_box3_zdepth
#define xwidth2 mccchannel_4_cave2_box3_xwidth2
#define yheight2 mccchannel_4_cave2_box3_yheight2
#define visualize mccchannel_4_cave2_box3_visualize
#define target_index mccchannel_4_cave2_box3_target_index
#define target_x mccchannel_4_cave2_box3_target_x
#define target_y mccchannel_4_cave2_box3_target_y
#define target_z mccchannel_4_cave2_box3_target_z
#define focus_aw mccchannel_4_cave2_box3_focus_aw
#define focus_ah mccchannel_4_cave2_box3_focus_ah
#define focus_xw mccchannel_4_cave2_box3_focus_xw
#define focus_xh mccchannel_4_cave2_box3_focus_xh
#define focus_r mccchannel_4_cave2_box3_focus_r
#define p_interact mccchannel_4_cave2_box3_p_interact
#define mask_string mccchannel_4_cave2_box3_mask_string
#define mask_setting mccchannel_4_cave2_box3_mask_setting
#define number_of_activations mccchannel_4_cave2_box3_number_of_activations
#line 224 "Union_box.comp"
{
// Initializes the focusing system for this volume including input sanitation.
focus_initialize(&this_box_volume.geometry, POS_A_COMP_INDEX(INDEX_CURRENT_COMP+target_index), POS_A_CURRENT_COMP, ROT_A_CURRENT_COMP, target_index, target_x, target_y, target_z, focus_aw, focus_ah, focus_xw, focus_xh, focus_r, NAME_CURRENT_COMP);

// Input sanitation for this geometry
if (xwidth <= 0) {
  printf("\nERROR in Union_box named %s, the xwidth is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (yheight <= 0) {
  printf("\nERROR in Union_box named %s, yheight is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (zdepth <= 0) {
  printf("\nERROR in Union_box named %s, zdepth is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (xwidth2 <= 0 && xwidth2 != -1) {
  printf("\nERROR in Union_box named %s, the xwidth2 is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (yheight2 <= 0 && yheight2 != -1) {
  printf("\nERROR in Union_box named %s, yheight2 is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}

// Use sanitation
if (global_material_list.num_elements == 0) {
  printf("\nERROR: Need to define a material using Union_make_material before using a Union geometry component. \n");
  printf("       %s was defined before first use of Union_make_material.\n",NAME_CURRENT_COMP);
  exit(1);
}

this_box_volume.geometry.is_masked_volume = 0;
this_box_volume.geometry.is_exit_volume = 0;
this_box_volume.geometry.is_mask_volume = 0;
// check if the volume is a mask, if it is the material string is irelevant.
if (mask_string && strlen(mask_string) && strcmp(mask_string, "NULL") && strcmp(mask_string, "0")) {
    // A mask volume is used to limit the extend of other volumes, called the masked volumes. These are specified in the mask_string.
    // In order for a ray to enter a masked volume, it needs to be both in the region covered by that volume AND the mask volume.
    // When more than
    this_box_volume.geometry.mask_mode = 1; // Default is mask mode is ALL
    if (mask_setting && strlen(mask_setting) && strcmp(mask_setting, "NULL") && strcmp(mask_setting, "0")) {
        if (strcmp(mask_setting,"ALL") == 0 || strcmp(mask_setting,"All") == 0) this_box_volume.geometry.mask_mode = 1;
        else if (strcmp(mask_setting,"ANY") == 0 || strcmp(mask_setting,"Any") == 0) this_box_volume.geometry.mask_mode = 2;
        else {
            printf("The mask_mode of component %s is set to %s, but must be either ALL or ANY.\n",NAME_CURRENT_COMP,mask_setting);
            exit(1);
        }
    }
    
    for (loop_index=0;loop_index<global_geometry_list.num_elements;loop_index++) {
        // Add mask list
        if (1 == manual_linking_function(global_geometry_list.elements[loop_index].name,mask_string)) {
            add_element_to_int_list(&this_box_volume.geometry.mask_list,global_geometry_list.elements[loop_index].component_index);
            add_element_to_int_list(&global_geometry_list.elements[loop_index].Volume->geometry.masked_by_list,INDEX_CURRENT_COMP);
            global_geometry_list.elements[loop_index].Volume->geometry.is_masked_volume = 1;
            if (this_box_volume.geometry.mask_mode == 2)
                global_geometry_list.elements[loop_index].Volume->geometry.mask_mode = 2;
            if (this_box_volume.geometry.mask_mode == 1) {
                if (global_geometry_list.elements[loop_index].Volume->geometry.is_masked_volume == 1 && global_geometry_list.elements[loop_index].Volume->geometry.mask_mode != 2)
                    // If more than one mask is added to one volume, the ANY mode overwrites the (default) ALL mode.
                    global_geometry_list.elements[loop_index].Volume->geometry.mask_mode = 1;
            }
            
            found_geometries = 1;
        }
    }
    if (found_geometries == 0) {
        printf("The mask_string in geometry: %s did not find any of the specified volumes in the mask_string %s \n",NAME_CURRENT_COMP,mask_string);
        exit(1);
    }
    this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
    this_box_volume.p_physics->is_vacuum = 0; // Makes this volume a vacuum
    this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
    this_box_volume.p_physics->my_a = 0; // Should not be used.
    sprintf(this_box_volume.p_physics->name,"Mask");
    this_box_volume.geometry.is_mask_volume = 1;
    
    
// Read the material input, or if it lacks, use automatic linking.
} else if (material_string && strlen(material_string) && strcmp(material_string, "NULL") && strcmp(material_string, "0")) {
    // A geometry string was given, use it to determine which material
    if (0 == strcmp(material_string,"vacuum") || 0 == strcmp(material_string,"Vacuum")) {
        // One could have a global physics struct for vacuum instead of creating one for each
        this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
        this_box_volume.p_physics->is_vacuum = 1; // Makes this volume a vacuum
        this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
        this_box_volume.p_physics->my_a = 0; // Should not be used.
        sprintf(this_box_volume.p_physics->name,"Vacuum");
    } else if (0 == strcmp(material_string,"exit") || 0 == strcmp(material_string,"Exit")) {
        // One could have a global physics struct for vacuum instead of creating one for each
        this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
        this_box_volume.p_physics->is_vacuum = 1; // Makes this volume a vacuum
        this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
        this_box_volume.p_physics->my_a = 0; // Should not be used.
        this_box_volume.geometry.is_exit_volume = 1;
        sprintf(this_box_volume.p_physics->name,"Exit");
    } else {
        #ifndef MATERIAL_DETECTOR
            printf("Need to define a material before refering to it in a geometry %s.\n",NAME_CURRENT_COMP);
            exit(1);
        #endif
        for (loop_index=0;loop_index<global_material_list.num_elements;loop_index++) {
            if (0 == strcmp(material_string,global_material_list.elements[loop_index].name)) {
                this_box_volume.p_physics = global_material_list.elements[loop_index].physics;
                break;
            }
            if (loop_index == global_material_list.num_elements-1) {
            printf("\n");
            printf("ERROR: The material string \"%s\" in Union geometry \"%s\" did not match a specified material. \n",material_string,NAME_CURRENT_COMP);
            printf("       The materials available at this point (need to be defined before the geometry): \n");
            for (loop_index=0;loop_index<global_material_list.num_elements;loop_index++)
              printf("         %s\n",global_material_list.elements[loop_index].name);
            printf("\n");
            printf("       It is also possible to use one of the defualt materials avaiable: \n");
            printf("           Vacuum (for a Volume without scattering or absorption)\n");
            printf("           Exit (for a Volume where the ray exits the component if it enters)\n");
            printf("           Mask (for a Volume that masks existing volumes specified in the mask_string\n");
            exit(1);
          }
        }
    }
} else {
    // Automatic linking, simply using the last defined material.
    #ifndef MATERIAL_DETECTOR
        printf("Need to define a material before the geometry to use automatic linking %s.\n",NAME_CURRENT_COMP);
        exit(1);
    #endif
    this_box_volume.p_physics = global_material_list.elements[global_material_list.num_elements-1].physics;
}

sprintf(this_box_volume.name,NAME_CURRENT_COMP);
sprintf(this_box_volume.geometry.shape,"box");
this_box_volume.geometry.priority_value = priority;
this_box_volume.geometry.geometry_p_interact = p_interact;
// Currently the coordinates will be in absolute space.
this_box_volume.geometry.center = POS_A_CURRENT_COMP;

this_box_storage.z_depth = zdepth;
this_box_storage.x_width1 = xwidth;
this_box_storage.y_height1 = yheight;

this_box_storage.is_rectangle = 0;
if (xwidth2 < 0 && yheight2 < 0) this_box_storage.is_rectangle = 1;
if (xwidth == xwidth2 && yheight == yheight2) this_box_storage.is_rectangle = 1;

if (xwidth2 < 0) {
    this_box_storage.x_width2 = xwidth;
    xwidth2 = xwidth;
} else this_box_storage.x_width2 = xwidth2;

if (yheight2 < 0) {
    this_box_storage.y_height2 = yheight;
    yheight2 = yheight;
} else this_box_storage.y_height2 = yheight2;


this_box_storage.normal_vectors[0] = coords_set(0,0,1);
this_box_storage.normal_vectors[1] = coords_set(0,0,1);

// for sides with y component = 0
x_component = 2*zdepth/sqrt((xwidth-xwidth2)*(xwidth-xwidth2)+4*zdepth*zdepth);
z_component = (xwidth-xwidth2)/sqrt(4*zdepth*zdepth+(xwidth-xwidth2)*(xwidth-xwidth2));

this_box_storage.normal_vectors[2] = coords_set(x_component,0,z_component);
this_box_storage.normal_vectors[3] = coords_set(-x_component,0,z_component);

// for sides with x component = 0
y_component = 2*zdepth/sqrt((yheight-yheight2)*(yheight-yheight2)+4*zdepth*zdepth);
z_component = (yheight-yheight2)/sqrt(4*zdepth*zdepth+(yheight-yheight2)*(yheight-yheight2));

this_box_storage.normal_vectors[4] = coords_set(0,y_component,z_component);
this_box_storage.normal_vectors[5] = coords_set(0,-y_component,z_component);

this_box_volume.geometry.visualization_on = visualize;

this_box_volume.geometry.geometry_parameters.p_box_storage = &this_box_storage;

// Assign pointers to functions for intersection with the shape, checking if a point is inside the shape
if (this_box_storage.is_rectangle == 1) {
this_box_volume.geometry.intersect_function = &sample_box_intersect_simple;
this_box_volume.geometry.within_function = &r_within_box_simple;
}
else {
this_box_volume.geometry.intersect_function = &sample_box_intersect_advanced;
this_box_volume.geometry.within_function = &r_within_box_advanced;
}

this_box_volume.geometry.shell_points = &box_shell_points;
this_box_volume.geometry.mcdisplay_function = &mcdisplay_box_function;
this_box_volume.geometry.initialize_from_main_function = &initialize_box_geometry_from_main_component;
this_box_volume.geometry.process_rot_allocated = 0;

this_box_volume.geometry.copy_geometry_parameters = &allocate_box_storage_copy;

rot_copy(this_box_volume.geometry.rotation_matrix,ROT_A_CURRENT_COMP); //check how ROT_R_CURRENT_COMP would work
rot_transpose(ROT_A_CURRENT_COMP,this_box_volume.geometry.transpose_rotation_matrix);

// Initialize loggers
this_box_volume.loggers.num_elements = 0;

// packing the information into the global_geometry_element, which is then included in the global_geometry_list.
sprintf(global_geometry_element.name,NAME_CURRENT_COMP);
global_geometry_element.activation_counter = number_of_activations;
global_geometry_element.component_index = INDEX_CURRENT_COMP;
global_geometry_element.Volume = &this_box_volume; // Would be nicer if this m was a pointer, now we have the (small) data two places
add_element_to_geometry_list(&global_geometry_list,global_geometry_element);
}
#line 206636 "MACS_sample_kidney_box.c"
#undef number_of_activations
#undef mask_setting
#undef mask_string
#undef p_interact
#undef focus_r
#undef focus_xh
#undef focus_xw
#undef focus_ah
#undef focus_aw
#undef target_z
#undef target_y
#undef target_x
#undef target_index
#undef visualize
#undef yheight2
#undef xwidth2
#undef zdepth
#undef yheight
#undef xwidth
#undef priority
#undef material_string
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

  /* Initializations for component inter_analyzer_colimator_center_4. */
  SIG_MESSAGE("inter_analyzer_colimator_center_4 (Init)");

  /* Initializations for component inter_analyzer_colimator_4_blade_0. */
  SIG_MESSAGE("inter_analyzer_colimator_4_blade_0 (Init)");
#define mccompcurname  inter_analyzer_colimator_4_blade_0
#define mccompcurtype  Union_box
#define mccompcurindex 307
#define loop_index mccinter_analyzer_colimator_4_blade_0_loop_index
#define this_box_volume mccinter_analyzer_colimator_4_blade_0_this_box_volume
#define global_geometry_element mccinter_analyzer_colimator_4_blade_0_global_geometry_element
#define this_box_storage mccinter_analyzer_colimator_4_blade_0_this_box_storage
#define material_string mccinter_analyzer_colimator_4_blade_0_material_string
#define priority mccinter_analyzer_colimator_4_blade_0_priority
#define xwidth mccinter_analyzer_colimator_4_blade_0_xwidth
#define yheight mccinter_analyzer_colimator_4_blade_0_yheight
#define zdepth mccinter_analyzer_colimator_4_blade_0_zdepth
#define xwidth2 mccinter_analyzer_colimator_4_blade_0_xwidth2
#define yheight2 mccinter_analyzer_colimator_4_blade_0_yheight2
#define visualize mccinter_analyzer_colimator_4_blade_0_visualize
#define target_index mccinter_analyzer_colimator_4_blade_0_target_index
#define target_x mccinter_analyzer_colimator_4_blade_0_target_x
#define target_y mccinter_analyzer_colimator_4_blade_0_target_y
#define target_z mccinter_analyzer_colimator_4_blade_0_target_z
#define focus_aw mccinter_analyzer_colimator_4_blade_0_focus_aw
#define focus_ah mccinter_analyzer_colimator_4_blade_0_focus_ah
#define focus_xw mccinter_analyzer_colimator_4_blade_0_focus_xw
#define focus_xh mccinter_analyzer_colimator_4_blade_0_focus_xh
#define focus_r mccinter_analyzer_colimator_4_blade_0_focus_r
#define p_interact mccinter_analyzer_colimator_4_blade_0_p_interact
#define mask_string mccinter_analyzer_colimator_4_blade_0_mask_string
#define mask_setting mccinter_analyzer_colimator_4_blade_0_mask_setting
#define number_of_activations mccinter_analyzer_colimator_4_blade_0_number_of_activations
#line 224 "Union_box.comp"
{
// Initializes the focusing system for this volume including input sanitation.
focus_initialize(&this_box_volume.geometry, POS_A_COMP_INDEX(INDEX_CURRENT_COMP+target_index), POS_A_CURRENT_COMP, ROT_A_CURRENT_COMP, target_index, target_x, target_y, target_z, focus_aw, focus_ah, focus_xw, focus_xh, focus_r, NAME_CURRENT_COMP);

// Input sanitation for this geometry
if (xwidth <= 0) {
  printf("\nERROR in Union_box named %s, the xwidth is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (yheight <= 0) {
  printf("\nERROR in Union_box named %s, yheight is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (zdepth <= 0) {
  printf("\nERROR in Union_box named %s, zdepth is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (xwidth2 <= 0 && xwidth2 != -1) {
  printf("\nERROR in Union_box named %s, the xwidth2 is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (yheight2 <= 0 && yheight2 != -1) {
  printf("\nERROR in Union_box named %s, yheight2 is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}

// Use sanitation
if (global_material_list.num_elements == 0) {
  printf("\nERROR: Need to define a material using Union_make_material before using a Union geometry component. \n");
  printf("       %s was defined before first use of Union_make_material.\n",NAME_CURRENT_COMP);
  exit(1);
}

this_box_volume.geometry.is_masked_volume = 0;
this_box_volume.geometry.is_exit_volume = 0;
this_box_volume.geometry.is_mask_volume = 0;
// check if the volume is a mask, if it is the material string is irelevant.
if (mask_string && strlen(mask_string) && strcmp(mask_string, "NULL") && strcmp(mask_string, "0")) {
    // A mask volume is used to limit the extend of other volumes, called the masked volumes. These are specified in the mask_string.
    // In order for a ray to enter a masked volume, it needs to be both in the region covered by that volume AND the mask volume.
    // When more than
    this_box_volume.geometry.mask_mode = 1; // Default is mask mode is ALL
    if (mask_setting && strlen(mask_setting) && strcmp(mask_setting, "NULL") && strcmp(mask_setting, "0")) {
        if (strcmp(mask_setting,"ALL") == 0 || strcmp(mask_setting,"All") == 0) this_box_volume.geometry.mask_mode = 1;
        else if (strcmp(mask_setting,"ANY") == 0 || strcmp(mask_setting,"Any") == 0) this_box_volume.geometry.mask_mode = 2;
        else {
            printf("The mask_mode of component %s is set to %s, but must be either ALL or ANY.\n",NAME_CURRENT_COMP,mask_setting);
            exit(1);
        }
    }
    
    for (loop_index=0;loop_index<global_geometry_list.num_elements;loop_index++) {
        // Add mask list
        if (1 == manual_linking_function(global_geometry_list.elements[loop_index].name,mask_string)) {
            add_element_to_int_list(&this_box_volume.geometry.mask_list,global_geometry_list.elements[loop_index].component_index);
            add_element_to_int_list(&global_geometry_list.elements[loop_index].Volume->geometry.masked_by_list,INDEX_CURRENT_COMP);
            global_geometry_list.elements[loop_index].Volume->geometry.is_masked_volume = 1;
            if (this_box_volume.geometry.mask_mode == 2)
                global_geometry_list.elements[loop_index].Volume->geometry.mask_mode = 2;
            if (this_box_volume.geometry.mask_mode == 1) {
                if (global_geometry_list.elements[loop_index].Volume->geometry.is_masked_volume == 1 && global_geometry_list.elements[loop_index].Volume->geometry.mask_mode != 2)
                    // If more than one mask is added to one volume, the ANY mode overwrites the (default) ALL mode.
                    global_geometry_list.elements[loop_index].Volume->geometry.mask_mode = 1;
            }
            
            found_geometries = 1;
        }
    }
    if (found_geometries == 0) {
        printf("The mask_string in geometry: %s did not find any of the specified volumes in the mask_string %s \n",NAME_CURRENT_COMP,mask_string);
        exit(1);
    }
    this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
    this_box_volume.p_physics->is_vacuum = 0; // Makes this volume a vacuum
    this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
    this_box_volume.p_physics->my_a = 0; // Should not be used.
    sprintf(this_box_volume.p_physics->name,"Mask");
    this_box_volume.geometry.is_mask_volume = 1;
    
    
// Read the material input, or if it lacks, use automatic linking.
} else if (material_string && strlen(material_string) && strcmp(material_string, "NULL") && strcmp(material_string, "0")) {
    // A geometry string was given, use it to determine which material
    if (0 == strcmp(material_string,"vacuum") || 0 == strcmp(material_string,"Vacuum")) {
        // One could have a global physics struct for vacuum instead of creating one for each
        this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
        this_box_volume.p_physics->is_vacuum = 1; // Makes this volume a vacuum
        this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
        this_box_volume.p_physics->my_a = 0; // Should not be used.
        sprintf(this_box_volume.p_physics->name,"Vacuum");
    } else if (0 == strcmp(material_string,"exit") || 0 == strcmp(material_string,"Exit")) {
        // One could have a global physics struct for vacuum instead of creating one for each
        this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
        this_box_volume.p_physics->is_vacuum = 1; // Makes this volume a vacuum
        this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
        this_box_volume.p_physics->my_a = 0; // Should not be used.
        this_box_volume.geometry.is_exit_volume = 1;
        sprintf(this_box_volume.p_physics->name,"Exit");
    } else {
        #ifndef MATERIAL_DETECTOR
            printf("Need to define a material before refering to it in a geometry %s.\n",NAME_CURRENT_COMP);
            exit(1);
        #endif
        for (loop_index=0;loop_index<global_material_list.num_elements;loop_index++) {
            if (0 == strcmp(material_string,global_material_list.elements[loop_index].name)) {
                this_box_volume.p_physics = global_material_list.elements[loop_index].physics;
                break;
            }
            if (loop_index == global_material_list.num_elements-1) {
            printf("\n");
            printf("ERROR: The material string \"%s\" in Union geometry \"%s\" did not match a specified material. \n",material_string,NAME_CURRENT_COMP);
            printf("       The materials available at this point (need to be defined before the geometry): \n");
            for (loop_index=0;loop_index<global_material_list.num_elements;loop_index++)
              printf("         %s\n",global_material_list.elements[loop_index].name);
            printf("\n");
            printf("       It is also possible to use one of the defualt materials avaiable: \n");
            printf("           Vacuum (for a Volume without scattering or absorption)\n");
            printf("           Exit (for a Volume where the ray exits the component if it enters)\n");
            printf("           Mask (for a Volume that masks existing volumes specified in the mask_string\n");
            exit(1);
          }
        }
    }
} else {
    // Automatic linking, simply using the last defined material.
    #ifndef MATERIAL_DETECTOR
        printf("Need to define a material before the geometry to use automatic linking %s.\n",NAME_CURRENT_COMP);
        exit(1);
    #endif
    this_box_volume.p_physics = global_material_list.elements[global_material_list.num_elements-1].physics;
}

sprintf(this_box_volume.name,NAME_CURRENT_COMP);
sprintf(this_box_volume.geometry.shape,"box");
this_box_volume.geometry.priority_value = priority;
this_box_volume.geometry.geometry_p_interact = p_interact;
// Currently the coordinates will be in absolute space.
this_box_volume.geometry.center = POS_A_CURRENT_COMP;

this_box_storage.z_depth = zdepth;
this_box_storage.x_width1 = xwidth;
this_box_storage.y_height1 = yheight;

this_box_storage.is_rectangle = 0;
if (xwidth2 < 0 && yheight2 < 0) this_box_storage.is_rectangle = 1;
if (xwidth == xwidth2 && yheight == yheight2) this_box_storage.is_rectangle = 1;

if (xwidth2 < 0) {
    this_box_storage.x_width2 = xwidth;
    xwidth2 = xwidth;
} else this_box_storage.x_width2 = xwidth2;

if (yheight2 < 0) {
    this_box_storage.y_height2 = yheight;
    yheight2 = yheight;
} else this_box_storage.y_height2 = yheight2;


this_box_storage.normal_vectors[0] = coords_set(0,0,1);
this_box_storage.normal_vectors[1] = coords_set(0,0,1);

// for sides with y component = 0
x_component = 2*zdepth/sqrt((xwidth-xwidth2)*(xwidth-xwidth2)+4*zdepth*zdepth);
z_component = (xwidth-xwidth2)/sqrt(4*zdepth*zdepth+(xwidth-xwidth2)*(xwidth-xwidth2));

this_box_storage.normal_vectors[2] = coords_set(x_component,0,z_component);
this_box_storage.normal_vectors[3] = coords_set(-x_component,0,z_component);

// for sides with x component = 0
y_component = 2*zdepth/sqrt((yheight-yheight2)*(yheight-yheight2)+4*zdepth*zdepth);
z_component = (yheight-yheight2)/sqrt(4*zdepth*zdepth+(yheight-yheight2)*(yheight-yheight2));

this_box_storage.normal_vectors[4] = coords_set(0,y_component,z_component);
this_box_storage.normal_vectors[5] = coords_set(0,-y_component,z_component);

this_box_volume.geometry.visualization_on = visualize;

this_box_volume.geometry.geometry_parameters.p_box_storage = &this_box_storage;

// Assign pointers to functions for intersection with the shape, checking if a point is inside the shape
if (this_box_storage.is_rectangle == 1) {
this_box_volume.geometry.intersect_function = &sample_box_intersect_simple;
this_box_volume.geometry.within_function = &r_within_box_simple;
}
else {
this_box_volume.geometry.intersect_function = &sample_box_intersect_advanced;
this_box_volume.geometry.within_function = &r_within_box_advanced;
}

this_box_volume.geometry.shell_points = &box_shell_points;
this_box_volume.geometry.mcdisplay_function = &mcdisplay_box_function;
this_box_volume.geometry.initialize_from_main_function = &initialize_box_geometry_from_main_component;
this_box_volume.geometry.process_rot_allocated = 0;

this_box_volume.geometry.copy_geometry_parameters = &allocate_box_storage_copy;

rot_copy(this_box_volume.geometry.rotation_matrix,ROT_A_CURRENT_COMP); //check how ROT_R_CURRENT_COMP would work
rot_transpose(ROT_A_CURRENT_COMP,this_box_volume.geometry.transpose_rotation_matrix);

// Initialize loggers
this_box_volume.loggers.num_elements = 0;

// packing the information into the global_geometry_element, which is then included in the global_geometry_list.
sprintf(global_geometry_element.name,NAME_CURRENT_COMP);
global_geometry_element.activation_counter = number_of_activations;
global_geometry_element.component_index = INDEX_CURRENT_COMP;
global_geometry_element.Volume = &this_box_volume; // Would be nicer if this m was a pointer, now we have the (small) data two places
add_element_to_geometry_list(&global_geometry_list,global_geometry_element);
}
#line 206909 "MACS_sample_kidney_box.c"
#undef number_of_activations
#undef mask_setting
#undef mask_string
#undef p_interact
#undef focus_r
#undef focus_xh
#undef focus_xw
#undef focus_ah
#undef focus_aw
#undef target_z
#undef target_y
#undef target_x
#undef target_index
#undef visualize
#undef yheight2
#undef xwidth2
#undef zdepth
#undef yheight
#undef xwidth
#undef priority
#undef material_string
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

  /* Initializations for component inter_analyzer_colimator_4_blade_1. */
  SIG_MESSAGE("inter_analyzer_colimator_4_blade_1 (Init)");
#define mccompcurname  inter_analyzer_colimator_4_blade_1
#define mccompcurtype  Union_box
#define mccompcurindex 308
#define loop_index mccinter_analyzer_colimator_4_blade_1_loop_index
#define this_box_volume mccinter_analyzer_colimator_4_blade_1_this_box_volume
#define global_geometry_element mccinter_analyzer_colimator_4_blade_1_global_geometry_element
#define this_box_storage mccinter_analyzer_colimator_4_blade_1_this_box_storage
#define material_string mccinter_analyzer_colimator_4_blade_1_material_string
#define priority mccinter_analyzer_colimator_4_blade_1_priority
#define xwidth mccinter_analyzer_colimator_4_blade_1_xwidth
#define yheight mccinter_analyzer_colimator_4_blade_1_yheight
#define zdepth mccinter_analyzer_colimator_4_blade_1_zdepth
#define xwidth2 mccinter_analyzer_colimator_4_blade_1_xwidth2
#define yheight2 mccinter_analyzer_colimator_4_blade_1_yheight2
#define visualize mccinter_analyzer_colimator_4_blade_1_visualize
#define target_index mccinter_analyzer_colimator_4_blade_1_target_index
#define target_x mccinter_analyzer_colimator_4_blade_1_target_x
#define target_y mccinter_analyzer_colimator_4_blade_1_target_y
#define target_z mccinter_analyzer_colimator_4_blade_1_target_z
#define focus_aw mccinter_analyzer_colimator_4_blade_1_focus_aw
#define focus_ah mccinter_analyzer_colimator_4_blade_1_focus_ah
#define focus_xw mccinter_analyzer_colimator_4_blade_1_focus_xw
#define focus_xh mccinter_analyzer_colimator_4_blade_1_focus_xh
#define focus_r mccinter_analyzer_colimator_4_blade_1_focus_r
#define p_interact mccinter_analyzer_colimator_4_blade_1_p_interact
#define mask_string mccinter_analyzer_colimator_4_blade_1_mask_string
#define mask_setting mccinter_analyzer_colimator_4_blade_1_mask_setting
#define number_of_activations mccinter_analyzer_colimator_4_blade_1_number_of_activations
#line 224 "Union_box.comp"
{
// Initializes the focusing system for this volume including input sanitation.
focus_initialize(&this_box_volume.geometry, POS_A_COMP_INDEX(INDEX_CURRENT_COMP+target_index), POS_A_CURRENT_COMP, ROT_A_CURRENT_COMP, target_index, target_x, target_y, target_z, focus_aw, focus_ah, focus_xw, focus_xh, focus_r, NAME_CURRENT_COMP);

// Input sanitation for this geometry
if (xwidth <= 0) {
  printf("\nERROR in Union_box named %s, the xwidth is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (yheight <= 0) {
  printf("\nERROR in Union_box named %s, yheight is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (zdepth <= 0) {
  printf("\nERROR in Union_box named %s, zdepth is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (xwidth2 <= 0 && xwidth2 != -1) {
  printf("\nERROR in Union_box named %s, the xwidth2 is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (yheight2 <= 0 && yheight2 != -1) {
  printf("\nERROR in Union_box named %s, yheight2 is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}

// Use sanitation
if (global_material_list.num_elements == 0) {
  printf("\nERROR: Need to define a material using Union_make_material before using a Union geometry component. \n");
  printf("       %s was defined before first use of Union_make_material.\n",NAME_CURRENT_COMP);
  exit(1);
}

this_box_volume.geometry.is_masked_volume = 0;
this_box_volume.geometry.is_exit_volume = 0;
this_box_volume.geometry.is_mask_volume = 0;
// check if the volume is a mask, if it is the material string is irelevant.
if (mask_string && strlen(mask_string) && strcmp(mask_string, "NULL") && strcmp(mask_string, "0")) {
    // A mask volume is used to limit the extend of other volumes, called the masked volumes. These are specified in the mask_string.
    // In order for a ray to enter a masked volume, it needs to be both in the region covered by that volume AND the mask volume.
    // When more than
    this_box_volume.geometry.mask_mode = 1; // Default is mask mode is ALL
    if (mask_setting && strlen(mask_setting) && strcmp(mask_setting, "NULL") && strcmp(mask_setting, "0")) {
        if (strcmp(mask_setting,"ALL") == 0 || strcmp(mask_setting,"All") == 0) this_box_volume.geometry.mask_mode = 1;
        else if (strcmp(mask_setting,"ANY") == 0 || strcmp(mask_setting,"Any") == 0) this_box_volume.geometry.mask_mode = 2;
        else {
            printf("The mask_mode of component %s is set to %s, but must be either ALL or ANY.\n",NAME_CURRENT_COMP,mask_setting);
            exit(1);
        }
    }
    
    for (loop_index=0;loop_index<global_geometry_list.num_elements;loop_index++) {
        // Add mask list
        if (1 == manual_linking_function(global_geometry_list.elements[loop_index].name,mask_string)) {
            add_element_to_int_list(&this_box_volume.geometry.mask_list,global_geometry_list.elements[loop_index].component_index);
            add_element_to_int_list(&global_geometry_list.elements[loop_index].Volume->geometry.masked_by_list,INDEX_CURRENT_COMP);
            global_geometry_list.elements[loop_index].Volume->geometry.is_masked_volume = 1;
            if (this_box_volume.geometry.mask_mode == 2)
                global_geometry_list.elements[loop_index].Volume->geometry.mask_mode = 2;
            if (this_box_volume.geometry.mask_mode == 1) {
                if (global_geometry_list.elements[loop_index].Volume->geometry.is_masked_volume == 1 && global_geometry_list.elements[loop_index].Volume->geometry.mask_mode != 2)
                    // If more than one mask is added to one volume, the ANY mode overwrites the (default) ALL mode.
                    global_geometry_list.elements[loop_index].Volume->geometry.mask_mode = 1;
            }
            
            found_geometries = 1;
        }
    }
    if (found_geometries == 0) {
        printf("The mask_string in geometry: %s did not find any of the specified volumes in the mask_string %s \n",NAME_CURRENT_COMP,mask_string);
        exit(1);
    }
    this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
    this_box_volume.p_physics->is_vacuum = 0; // Makes this volume a vacuum
    this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
    this_box_volume.p_physics->my_a = 0; // Should not be used.
    sprintf(this_box_volume.p_physics->name,"Mask");
    this_box_volume.geometry.is_mask_volume = 1;
    
    
// Read the material input, or if it lacks, use automatic linking.
} else if (material_string && strlen(material_string) && strcmp(material_string, "NULL") && strcmp(material_string, "0")) {
    // A geometry string was given, use it to determine which material
    if (0 == strcmp(material_string,"vacuum") || 0 == strcmp(material_string,"Vacuum")) {
        // One could have a global physics struct for vacuum instead of creating one for each
        this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
        this_box_volume.p_physics->is_vacuum = 1; // Makes this volume a vacuum
        this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
        this_box_volume.p_physics->my_a = 0; // Should not be used.
        sprintf(this_box_volume.p_physics->name,"Vacuum");
    } else if (0 == strcmp(material_string,"exit") || 0 == strcmp(material_string,"Exit")) {
        // One could have a global physics struct for vacuum instead of creating one for each
        this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
        this_box_volume.p_physics->is_vacuum = 1; // Makes this volume a vacuum
        this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
        this_box_volume.p_physics->my_a = 0; // Should not be used.
        this_box_volume.geometry.is_exit_volume = 1;
        sprintf(this_box_volume.p_physics->name,"Exit");
    } else {
        #ifndef MATERIAL_DETECTOR
            printf("Need to define a material before refering to it in a geometry %s.\n",NAME_CURRENT_COMP);
            exit(1);
        #endif
        for (loop_index=0;loop_index<global_material_list.num_elements;loop_index++) {
            if (0 == strcmp(material_string,global_material_list.elements[loop_index].name)) {
                this_box_volume.p_physics = global_material_list.elements[loop_index].physics;
                break;
            }
            if (loop_index == global_material_list.num_elements-1) {
            printf("\n");
            printf("ERROR: The material string \"%s\" in Union geometry \"%s\" did not match a specified material. \n",material_string,NAME_CURRENT_COMP);
            printf("       The materials available at this point (need to be defined before the geometry): \n");
            for (loop_index=0;loop_index<global_material_list.num_elements;loop_index++)
              printf("         %s\n",global_material_list.elements[loop_index].name);
            printf("\n");
            printf("       It is also possible to use one of the defualt materials avaiable: \n");
            printf("           Vacuum (for a Volume without scattering or absorption)\n");
            printf("           Exit (for a Volume where the ray exits the component if it enters)\n");
            printf("           Mask (for a Volume that masks existing volumes specified in the mask_string\n");
            exit(1);
          }
        }
    }
} else {
    // Automatic linking, simply using the last defined material.
    #ifndef MATERIAL_DETECTOR
        printf("Need to define a material before the geometry to use automatic linking %s.\n",NAME_CURRENT_COMP);
        exit(1);
    #endif
    this_box_volume.p_physics = global_material_list.elements[global_material_list.num_elements-1].physics;
}

sprintf(this_box_volume.name,NAME_CURRENT_COMP);
sprintf(this_box_volume.geometry.shape,"box");
this_box_volume.geometry.priority_value = priority;
this_box_volume.geometry.geometry_p_interact = p_interact;
// Currently the coordinates will be in absolute space.
this_box_volume.geometry.center = POS_A_CURRENT_COMP;

this_box_storage.z_depth = zdepth;
this_box_storage.x_width1 = xwidth;
this_box_storage.y_height1 = yheight;

this_box_storage.is_rectangle = 0;
if (xwidth2 < 0 && yheight2 < 0) this_box_storage.is_rectangle = 1;
if (xwidth == xwidth2 && yheight == yheight2) this_box_storage.is_rectangle = 1;

if (xwidth2 < 0) {
    this_box_storage.x_width2 = xwidth;
    xwidth2 = xwidth;
} else this_box_storage.x_width2 = xwidth2;

if (yheight2 < 0) {
    this_box_storage.y_height2 = yheight;
    yheight2 = yheight;
} else this_box_storage.y_height2 = yheight2;


this_box_storage.normal_vectors[0] = coords_set(0,0,1);
this_box_storage.normal_vectors[1] = coords_set(0,0,1);

// for sides with y component = 0
x_component = 2*zdepth/sqrt((xwidth-xwidth2)*(xwidth-xwidth2)+4*zdepth*zdepth);
z_component = (xwidth-xwidth2)/sqrt(4*zdepth*zdepth+(xwidth-xwidth2)*(xwidth-xwidth2));

this_box_storage.normal_vectors[2] = coords_set(x_component,0,z_component);
this_box_storage.normal_vectors[3] = coords_set(-x_component,0,z_component);

// for sides with x component = 0
y_component = 2*zdepth/sqrt((yheight-yheight2)*(yheight-yheight2)+4*zdepth*zdepth);
z_component = (yheight-yheight2)/sqrt(4*zdepth*zdepth+(yheight-yheight2)*(yheight-yheight2));

this_box_storage.normal_vectors[4] = coords_set(0,y_component,z_component);
this_box_storage.normal_vectors[5] = coords_set(0,-y_component,z_component);

this_box_volume.geometry.visualization_on = visualize;

this_box_volume.geometry.geometry_parameters.p_box_storage = &this_box_storage;

// Assign pointers to functions for intersection with the shape, checking if a point is inside the shape
if (this_box_storage.is_rectangle == 1) {
this_box_volume.geometry.intersect_function = &sample_box_intersect_simple;
this_box_volume.geometry.within_function = &r_within_box_simple;
}
else {
this_box_volume.geometry.intersect_function = &sample_box_intersect_advanced;
this_box_volume.geometry.within_function = &r_within_box_advanced;
}

this_box_volume.geometry.shell_points = &box_shell_points;
this_box_volume.geometry.mcdisplay_function = &mcdisplay_box_function;
this_box_volume.geometry.initialize_from_main_function = &initialize_box_geometry_from_main_component;
this_box_volume.geometry.process_rot_allocated = 0;

this_box_volume.geometry.copy_geometry_parameters = &allocate_box_storage_copy;

rot_copy(this_box_volume.geometry.rotation_matrix,ROT_A_CURRENT_COMP); //check how ROT_R_CURRENT_COMP would work
rot_transpose(ROT_A_CURRENT_COMP,this_box_volume.geometry.transpose_rotation_matrix);

// Initialize loggers
this_box_volume.loggers.num_elements = 0;

// packing the information into the global_geometry_element, which is then included in the global_geometry_list.
sprintf(global_geometry_element.name,NAME_CURRENT_COMP);
global_geometry_element.activation_counter = number_of_activations;
global_geometry_element.component_index = INDEX_CURRENT_COMP;
global_geometry_element.Volume = &this_box_volume; // Would be nicer if this m was a pointer, now we have the (small) data two places
add_element_to_geometry_list(&global_geometry_list,global_geometry_element);
}
#line 207179 "MACS_sample_kidney_box.c"
#undef number_of_activations
#undef mask_setting
#undef mask_string
#undef p_interact
#undef focus_r
#undef focus_xh
#undef focus_xw
#undef focus_ah
#undef focus_aw
#undef target_z
#undef target_y
#undef target_x
#undef target_index
#undef visualize
#undef yheight2
#undef xwidth2
#undef zdepth
#undef yheight
#undef xwidth
#undef priority
#undef material_string
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

  /* Initializations for component inter_analyzer_colimator_4_blade_2. */
  SIG_MESSAGE("inter_analyzer_colimator_4_blade_2 (Init)");
#define mccompcurname  inter_analyzer_colimator_4_blade_2
#define mccompcurtype  Union_box
#define mccompcurindex 309
#define loop_index mccinter_analyzer_colimator_4_blade_2_loop_index
#define this_box_volume mccinter_analyzer_colimator_4_blade_2_this_box_volume
#define global_geometry_element mccinter_analyzer_colimator_4_blade_2_global_geometry_element
#define this_box_storage mccinter_analyzer_colimator_4_blade_2_this_box_storage
#define material_string mccinter_analyzer_colimator_4_blade_2_material_string
#define priority mccinter_analyzer_colimator_4_blade_2_priority
#define xwidth mccinter_analyzer_colimator_4_blade_2_xwidth
#define yheight mccinter_analyzer_colimator_4_blade_2_yheight
#define zdepth mccinter_analyzer_colimator_4_blade_2_zdepth
#define xwidth2 mccinter_analyzer_colimator_4_blade_2_xwidth2
#define yheight2 mccinter_analyzer_colimator_4_blade_2_yheight2
#define visualize mccinter_analyzer_colimator_4_blade_2_visualize
#define target_index mccinter_analyzer_colimator_4_blade_2_target_index
#define target_x mccinter_analyzer_colimator_4_blade_2_target_x
#define target_y mccinter_analyzer_colimator_4_blade_2_target_y
#define target_z mccinter_analyzer_colimator_4_blade_2_target_z
#define focus_aw mccinter_analyzer_colimator_4_blade_2_focus_aw
#define focus_ah mccinter_analyzer_colimator_4_blade_2_focus_ah
#define focus_xw mccinter_analyzer_colimator_4_blade_2_focus_xw
#define focus_xh mccinter_analyzer_colimator_4_blade_2_focus_xh
#define focus_r mccinter_analyzer_colimator_4_blade_2_focus_r
#define p_interact mccinter_analyzer_colimator_4_blade_2_p_interact
#define mask_string mccinter_analyzer_colimator_4_blade_2_mask_string
#define mask_setting mccinter_analyzer_colimator_4_blade_2_mask_setting
#define number_of_activations mccinter_analyzer_colimator_4_blade_2_number_of_activations
#line 224 "Union_box.comp"
{
// Initializes the focusing system for this volume including input sanitation.
focus_initialize(&this_box_volume.geometry, POS_A_COMP_INDEX(INDEX_CURRENT_COMP+target_index), POS_A_CURRENT_COMP, ROT_A_CURRENT_COMP, target_index, target_x, target_y, target_z, focus_aw, focus_ah, focus_xw, focus_xh, focus_r, NAME_CURRENT_COMP);

// Input sanitation for this geometry
if (xwidth <= 0) {
  printf("\nERROR in Union_box named %s, the xwidth is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (yheight <= 0) {
  printf("\nERROR in Union_box named %s, yheight is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (zdepth <= 0) {
  printf("\nERROR in Union_box named %s, zdepth is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (xwidth2 <= 0 && xwidth2 != -1) {
  printf("\nERROR in Union_box named %s, the xwidth2 is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (yheight2 <= 0 && yheight2 != -1) {
  printf("\nERROR in Union_box named %s, yheight2 is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}

// Use sanitation
if (global_material_list.num_elements == 0) {
  printf("\nERROR: Need to define a material using Union_make_material before using a Union geometry component. \n");
  printf("       %s was defined before first use of Union_make_material.\n",NAME_CURRENT_COMP);
  exit(1);
}

this_box_volume.geometry.is_masked_volume = 0;
this_box_volume.geometry.is_exit_volume = 0;
this_box_volume.geometry.is_mask_volume = 0;
// check if the volume is a mask, if it is the material string is irelevant.
if (mask_string && strlen(mask_string) && strcmp(mask_string, "NULL") && strcmp(mask_string, "0")) {
    // A mask volume is used to limit the extend of other volumes, called the masked volumes. These are specified in the mask_string.
    // In order for a ray to enter a masked volume, it needs to be both in the region covered by that volume AND the mask volume.
    // When more than
    this_box_volume.geometry.mask_mode = 1; // Default is mask mode is ALL
    if (mask_setting && strlen(mask_setting) && strcmp(mask_setting, "NULL") && strcmp(mask_setting, "0")) {
        if (strcmp(mask_setting,"ALL") == 0 || strcmp(mask_setting,"All") == 0) this_box_volume.geometry.mask_mode = 1;
        else if (strcmp(mask_setting,"ANY") == 0 || strcmp(mask_setting,"Any") == 0) this_box_volume.geometry.mask_mode = 2;
        else {
            printf("The mask_mode of component %s is set to %s, but must be either ALL or ANY.\n",NAME_CURRENT_COMP,mask_setting);
            exit(1);
        }
    }
    
    for (loop_index=0;loop_index<global_geometry_list.num_elements;loop_index++) {
        // Add mask list
        if (1 == manual_linking_function(global_geometry_list.elements[loop_index].name,mask_string)) {
            add_element_to_int_list(&this_box_volume.geometry.mask_list,global_geometry_list.elements[loop_index].component_index);
            add_element_to_int_list(&global_geometry_list.elements[loop_index].Volume->geometry.masked_by_list,INDEX_CURRENT_COMP);
            global_geometry_list.elements[loop_index].Volume->geometry.is_masked_volume = 1;
            if (this_box_volume.geometry.mask_mode == 2)
                global_geometry_list.elements[loop_index].Volume->geometry.mask_mode = 2;
            if (this_box_volume.geometry.mask_mode == 1) {
                if (global_geometry_list.elements[loop_index].Volume->geometry.is_masked_volume == 1 && global_geometry_list.elements[loop_index].Volume->geometry.mask_mode != 2)
                    // If more than one mask is added to one volume, the ANY mode overwrites the (default) ALL mode.
                    global_geometry_list.elements[loop_index].Volume->geometry.mask_mode = 1;
            }
            
            found_geometries = 1;
        }
    }
    if (found_geometries == 0) {
        printf("The mask_string in geometry: %s did not find any of the specified volumes in the mask_string %s \n",NAME_CURRENT_COMP,mask_string);
        exit(1);
    }
    this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
    this_box_volume.p_physics->is_vacuum = 0; // Makes this volume a vacuum
    this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
    this_box_volume.p_physics->my_a = 0; // Should not be used.
    sprintf(this_box_volume.p_physics->name,"Mask");
    this_box_volume.geometry.is_mask_volume = 1;
    
    
// Read the material input, or if it lacks, use automatic linking.
} else if (material_string && strlen(material_string) && strcmp(material_string, "NULL") && strcmp(material_string, "0")) {
    // A geometry string was given, use it to determine which material
    if (0 == strcmp(material_string,"vacuum") || 0 == strcmp(material_string,"Vacuum")) {
        // One could have a global physics struct for vacuum instead of creating one for each
        this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
        this_box_volume.p_physics->is_vacuum = 1; // Makes this volume a vacuum
        this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
        this_box_volume.p_physics->my_a = 0; // Should not be used.
        sprintf(this_box_volume.p_physics->name,"Vacuum");
    } else if (0 == strcmp(material_string,"exit") || 0 == strcmp(material_string,"Exit")) {
        // One could have a global physics struct for vacuum instead of creating one for each
        this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
        this_box_volume.p_physics->is_vacuum = 1; // Makes this volume a vacuum
        this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
        this_box_volume.p_physics->my_a = 0; // Should not be used.
        this_box_volume.geometry.is_exit_volume = 1;
        sprintf(this_box_volume.p_physics->name,"Exit");
    } else {
        #ifndef MATERIAL_DETECTOR
            printf("Need to define a material before refering to it in a geometry %s.\n",NAME_CURRENT_COMP);
            exit(1);
        #endif
        for (loop_index=0;loop_index<global_material_list.num_elements;loop_index++) {
            if (0 == strcmp(material_string,global_material_list.elements[loop_index].name)) {
                this_box_volume.p_physics = global_material_list.elements[loop_index].physics;
                break;
            }
            if (loop_index == global_material_list.num_elements-1) {
            printf("\n");
            printf("ERROR: The material string \"%s\" in Union geometry \"%s\" did not match a specified material. \n",material_string,NAME_CURRENT_COMP);
            printf("       The materials available at this point (need to be defined before the geometry): \n");
            for (loop_index=0;loop_index<global_material_list.num_elements;loop_index++)
              printf("         %s\n",global_material_list.elements[loop_index].name);
            printf("\n");
            printf("       It is also possible to use one of the defualt materials avaiable: \n");
            printf("           Vacuum (for a Volume without scattering or absorption)\n");
            printf("           Exit (for a Volume where the ray exits the component if it enters)\n");
            printf("           Mask (for a Volume that masks existing volumes specified in the mask_string\n");
            exit(1);
          }
        }
    }
} else {
    // Automatic linking, simply using the last defined material.
    #ifndef MATERIAL_DETECTOR
        printf("Need to define a material before the geometry to use automatic linking %s.\n",NAME_CURRENT_COMP);
        exit(1);
    #endif
    this_box_volume.p_physics = global_material_list.elements[global_material_list.num_elements-1].physics;
}

sprintf(this_box_volume.name,NAME_CURRENT_COMP);
sprintf(this_box_volume.geometry.shape,"box");
this_box_volume.geometry.priority_value = priority;
this_box_volume.geometry.geometry_p_interact = p_interact;
// Currently the coordinates will be in absolute space.
this_box_volume.geometry.center = POS_A_CURRENT_COMP;

this_box_storage.z_depth = zdepth;
this_box_storage.x_width1 = xwidth;
this_box_storage.y_height1 = yheight;

this_box_storage.is_rectangle = 0;
if (xwidth2 < 0 && yheight2 < 0) this_box_storage.is_rectangle = 1;
if (xwidth == xwidth2 && yheight == yheight2) this_box_storage.is_rectangle = 1;

if (xwidth2 < 0) {
    this_box_storage.x_width2 = xwidth;
    xwidth2 = xwidth;
} else this_box_storage.x_width2 = xwidth2;

if (yheight2 < 0) {
    this_box_storage.y_height2 = yheight;
    yheight2 = yheight;
} else this_box_storage.y_height2 = yheight2;


this_box_storage.normal_vectors[0] = coords_set(0,0,1);
this_box_storage.normal_vectors[1] = coords_set(0,0,1);

// for sides with y component = 0
x_component = 2*zdepth/sqrt((xwidth-xwidth2)*(xwidth-xwidth2)+4*zdepth*zdepth);
z_component = (xwidth-xwidth2)/sqrt(4*zdepth*zdepth+(xwidth-xwidth2)*(xwidth-xwidth2));

this_box_storage.normal_vectors[2] = coords_set(x_component,0,z_component);
this_box_storage.normal_vectors[3] = coords_set(-x_component,0,z_component);

// for sides with x component = 0
y_component = 2*zdepth/sqrt((yheight-yheight2)*(yheight-yheight2)+4*zdepth*zdepth);
z_component = (yheight-yheight2)/sqrt(4*zdepth*zdepth+(yheight-yheight2)*(yheight-yheight2));

this_box_storage.normal_vectors[4] = coords_set(0,y_component,z_component);
this_box_storage.normal_vectors[5] = coords_set(0,-y_component,z_component);

this_box_volume.geometry.visualization_on = visualize;

this_box_volume.geometry.geometry_parameters.p_box_storage = &this_box_storage;

// Assign pointers to functions for intersection with the shape, checking if a point is inside the shape
if (this_box_storage.is_rectangle == 1) {
this_box_volume.geometry.intersect_function = &sample_box_intersect_simple;
this_box_volume.geometry.within_function = &r_within_box_simple;
}
else {
this_box_volume.geometry.intersect_function = &sample_box_intersect_advanced;
this_box_volume.geometry.within_function = &r_within_box_advanced;
}

this_box_volume.geometry.shell_points = &box_shell_points;
this_box_volume.geometry.mcdisplay_function = &mcdisplay_box_function;
this_box_volume.geometry.initialize_from_main_function = &initialize_box_geometry_from_main_component;
this_box_volume.geometry.process_rot_allocated = 0;

this_box_volume.geometry.copy_geometry_parameters = &allocate_box_storage_copy;

rot_copy(this_box_volume.geometry.rotation_matrix,ROT_A_CURRENT_COMP); //check how ROT_R_CURRENT_COMP would work
rot_transpose(ROT_A_CURRENT_COMP,this_box_volume.geometry.transpose_rotation_matrix);

// Initialize loggers
this_box_volume.loggers.num_elements = 0;

// packing the information into the global_geometry_element, which is then included in the global_geometry_list.
sprintf(global_geometry_element.name,NAME_CURRENT_COMP);
global_geometry_element.activation_counter = number_of_activations;
global_geometry_element.component_index = INDEX_CURRENT_COMP;
global_geometry_element.Volume = &this_box_volume; // Would be nicer if this m was a pointer, now we have the (small) data two places
add_element_to_geometry_list(&global_geometry_list,global_geometry_element);
}
#line 207449 "MACS_sample_kidney_box.c"
#undef number_of_activations
#undef mask_setting
#undef mask_string
#undef p_interact
#undef focus_r
#undef focus_xh
#undef focus_xw
#undef focus_ah
#undef focus_aw
#undef target_z
#undef target_y
#undef target_x
#undef target_index
#undef visualize
#undef yheight2
#undef xwidth2
#undef zdepth
#undef yheight
#undef xwidth
#undef priority
#undef material_string
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

  /* Initializations for component inter_analyzer_colimator_4_blade_3. */
  SIG_MESSAGE("inter_analyzer_colimator_4_blade_3 (Init)");
#define mccompcurname  inter_analyzer_colimator_4_blade_3
#define mccompcurtype  Union_box
#define mccompcurindex 310
#define loop_index mccinter_analyzer_colimator_4_blade_3_loop_index
#define this_box_volume mccinter_analyzer_colimator_4_blade_3_this_box_volume
#define global_geometry_element mccinter_analyzer_colimator_4_blade_3_global_geometry_element
#define this_box_storage mccinter_analyzer_colimator_4_blade_3_this_box_storage
#define material_string mccinter_analyzer_colimator_4_blade_3_material_string
#define priority mccinter_analyzer_colimator_4_blade_3_priority
#define xwidth mccinter_analyzer_colimator_4_blade_3_xwidth
#define yheight mccinter_analyzer_colimator_4_blade_3_yheight
#define zdepth mccinter_analyzer_colimator_4_blade_3_zdepth
#define xwidth2 mccinter_analyzer_colimator_4_blade_3_xwidth2
#define yheight2 mccinter_analyzer_colimator_4_blade_3_yheight2
#define visualize mccinter_analyzer_colimator_4_blade_3_visualize
#define target_index mccinter_analyzer_colimator_4_blade_3_target_index
#define target_x mccinter_analyzer_colimator_4_blade_3_target_x
#define target_y mccinter_analyzer_colimator_4_blade_3_target_y
#define target_z mccinter_analyzer_colimator_4_blade_3_target_z
#define focus_aw mccinter_analyzer_colimator_4_blade_3_focus_aw
#define focus_ah mccinter_analyzer_colimator_4_blade_3_focus_ah
#define focus_xw mccinter_analyzer_colimator_4_blade_3_focus_xw
#define focus_xh mccinter_analyzer_colimator_4_blade_3_focus_xh
#define focus_r mccinter_analyzer_colimator_4_blade_3_focus_r
#define p_interact mccinter_analyzer_colimator_4_blade_3_p_interact
#define mask_string mccinter_analyzer_colimator_4_blade_3_mask_string
#define mask_setting mccinter_analyzer_colimator_4_blade_3_mask_setting
#define number_of_activations mccinter_analyzer_colimator_4_blade_3_number_of_activations
#line 224 "Union_box.comp"
{
// Initializes the focusing system for this volume including input sanitation.
focus_initialize(&this_box_volume.geometry, POS_A_COMP_INDEX(INDEX_CURRENT_COMP+target_index), POS_A_CURRENT_COMP, ROT_A_CURRENT_COMP, target_index, target_x, target_y, target_z, focus_aw, focus_ah, focus_xw, focus_xh, focus_r, NAME_CURRENT_COMP);

// Input sanitation for this geometry
if (xwidth <= 0) {
  printf("\nERROR in Union_box named %s, the xwidth is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (yheight <= 0) {
  printf("\nERROR in Union_box named %s, yheight is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (zdepth <= 0) {
  printf("\nERROR in Union_box named %s, zdepth is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (xwidth2 <= 0 && xwidth2 != -1) {
  printf("\nERROR in Union_box named %s, the xwidth2 is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (yheight2 <= 0 && yheight2 != -1) {
  printf("\nERROR in Union_box named %s, yheight2 is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}

// Use sanitation
if (global_material_list.num_elements == 0) {
  printf("\nERROR: Need to define a material using Union_make_material before using a Union geometry component. \n");
  printf("       %s was defined before first use of Union_make_material.\n",NAME_CURRENT_COMP);
  exit(1);
}

this_box_volume.geometry.is_masked_volume = 0;
this_box_volume.geometry.is_exit_volume = 0;
this_box_volume.geometry.is_mask_volume = 0;
// check if the volume is a mask, if it is the material string is irelevant.
if (mask_string && strlen(mask_string) && strcmp(mask_string, "NULL") && strcmp(mask_string, "0")) {
    // A mask volume is used to limit the extend of other volumes, called the masked volumes. These are specified in the mask_string.
    // In order for a ray to enter a masked volume, it needs to be both in the region covered by that volume AND the mask volume.
    // When more than
    this_box_volume.geometry.mask_mode = 1; // Default is mask mode is ALL
    if (mask_setting && strlen(mask_setting) && strcmp(mask_setting, "NULL") && strcmp(mask_setting, "0")) {
        if (strcmp(mask_setting,"ALL") == 0 || strcmp(mask_setting,"All") == 0) this_box_volume.geometry.mask_mode = 1;
        else if (strcmp(mask_setting,"ANY") == 0 || strcmp(mask_setting,"Any") == 0) this_box_volume.geometry.mask_mode = 2;
        else {
            printf("The mask_mode of component %s is set to %s, but must be either ALL or ANY.\n",NAME_CURRENT_COMP,mask_setting);
            exit(1);
        }
    }
    
    for (loop_index=0;loop_index<global_geometry_list.num_elements;loop_index++) {
        // Add mask list
        if (1 == manual_linking_function(global_geometry_list.elements[loop_index].name,mask_string)) {
            add_element_to_int_list(&this_box_volume.geometry.mask_list,global_geometry_list.elements[loop_index].component_index);
            add_element_to_int_list(&global_geometry_list.elements[loop_index].Volume->geometry.masked_by_list,INDEX_CURRENT_COMP);
            global_geometry_list.elements[loop_index].Volume->geometry.is_masked_volume = 1;
            if (this_box_volume.geometry.mask_mode == 2)
                global_geometry_list.elements[loop_index].Volume->geometry.mask_mode = 2;
            if (this_box_volume.geometry.mask_mode == 1) {
                if (global_geometry_list.elements[loop_index].Volume->geometry.is_masked_volume == 1 && global_geometry_list.elements[loop_index].Volume->geometry.mask_mode != 2)
                    // If more than one mask is added to one volume, the ANY mode overwrites the (default) ALL mode.
                    global_geometry_list.elements[loop_index].Volume->geometry.mask_mode = 1;
            }
            
            found_geometries = 1;
        }
    }
    if (found_geometries == 0) {
        printf("The mask_string in geometry: %s did not find any of the specified volumes in the mask_string %s \n",NAME_CURRENT_COMP,mask_string);
        exit(1);
    }
    this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
    this_box_volume.p_physics->is_vacuum = 0; // Makes this volume a vacuum
    this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
    this_box_volume.p_physics->my_a = 0; // Should not be used.
    sprintf(this_box_volume.p_physics->name,"Mask");
    this_box_volume.geometry.is_mask_volume = 1;
    
    
// Read the material input, or if it lacks, use automatic linking.
} else if (material_string && strlen(material_string) && strcmp(material_string, "NULL") && strcmp(material_string, "0")) {
    // A geometry string was given, use it to determine which material
    if (0 == strcmp(material_string,"vacuum") || 0 == strcmp(material_string,"Vacuum")) {
        // One could have a global physics struct for vacuum instead of creating one for each
        this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
        this_box_volume.p_physics->is_vacuum = 1; // Makes this volume a vacuum
        this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
        this_box_volume.p_physics->my_a = 0; // Should not be used.
        sprintf(this_box_volume.p_physics->name,"Vacuum");
    } else if (0 == strcmp(material_string,"exit") || 0 == strcmp(material_string,"Exit")) {
        // One could have a global physics struct for vacuum instead of creating one for each
        this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
        this_box_volume.p_physics->is_vacuum = 1; // Makes this volume a vacuum
        this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
        this_box_volume.p_physics->my_a = 0; // Should not be used.
        this_box_volume.geometry.is_exit_volume = 1;
        sprintf(this_box_volume.p_physics->name,"Exit");
    } else {
        #ifndef MATERIAL_DETECTOR
            printf("Need to define a material before refering to it in a geometry %s.\n",NAME_CURRENT_COMP);
            exit(1);
        #endif
        for (loop_index=0;loop_index<global_material_list.num_elements;loop_index++) {
            if (0 == strcmp(material_string,global_material_list.elements[loop_index].name)) {
                this_box_volume.p_physics = global_material_list.elements[loop_index].physics;
                break;
            }
            if (loop_index == global_material_list.num_elements-1) {
            printf("\n");
            printf("ERROR: The material string \"%s\" in Union geometry \"%s\" did not match a specified material. \n",material_string,NAME_CURRENT_COMP);
            printf("       The materials available at this point (need to be defined before the geometry): \n");
            for (loop_index=0;loop_index<global_material_list.num_elements;loop_index++)
              printf("         %s\n",global_material_list.elements[loop_index].name);
            printf("\n");
            printf("       It is also possible to use one of the defualt materials avaiable: \n");
            printf("           Vacuum (for a Volume without scattering or absorption)\n");
            printf("           Exit (for a Volume where the ray exits the component if it enters)\n");
            printf("           Mask (for a Volume that masks existing volumes specified in the mask_string\n");
            exit(1);
          }
        }
    }
} else {
    // Automatic linking, simply using the last defined material.
    #ifndef MATERIAL_DETECTOR
        printf("Need to define a material before the geometry to use automatic linking %s.\n",NAME_CURRENT_COMP);
        exit(1);
    #endif
    this_box_volume.p_physics = global_material_list.elements[global_material_list.num_elements-1].physics;
}

sprintf(this_box_volume.name,NAME_CURRENT_COMP);
sprintf(this_box_volume.geometry.shape,"box");
this_box_volume.geometry.priority_value = priority;
this_box_volume.geometry.geometry_p_interact = p_interact;
// Currently the coordinates will be in absolute space.
this_box_volume.geometry.center = POS_A_CURRENT_COMP;

this_box_storage.z_depth = zdepth;
this_box_storage.x_width1 = xwidth;
this_box_storage.y_height1 = yheight;

this_box_storage.is_rectangle = 0;
if (xwidth2 < 0 && yheight2 < 0) this_box_storage.is_rectangle = 1;
if (xwidth == xwidth2 && yheight == yheight2) this_box_storage.is_rectangle = 1;

if (xwidth2 < 0) {
    this_box_storage.x_width2 = xwidth;
    xwidth2 = xwidth;
} else this_box_storage.x_width2 = xwidth2;

if (yheight2 < 0) {
    this_box_storage.y_height2 = yheight;
    yheight2 = yheight;
} else this_box_storage.y_height2 = yheight2;


this_box_storage.normal_vectors[0] = coords_set(0,0,1);
this_box_storage.normal_vectors[1] = coords_set(0,0,1);

// for sides with y component = 0
x_component = 2*zdepth/sqrt((xwidth-xwidth2)*(xwidth-xwidth2)+4*zdepth*zdepth);
z_component = (xwidth-xwidth2)/sqrt(4*zdepth*zdepth+(xwidth-xwidth2)*(xwidth-xwidth2));

this_box_storage.normal_vectors[2] = coords_set(x_component,0,z_component);
this_box_storage.normal_vectors[3] = coords_set(-x_component,0,z_component);

// for sides with x component = 0
y_component = 2*zdepth/sqrt((yheight-yheight2)*(yheight-yheight2)+4*zdepth*zdepth);
z_component = (yheight-yheight2)/sqrt(4*zdepth*zdepth+(yheight-yheight2)*(yheight-yheight2));

this_box_storage.normal_vectors[4] = coords_set(0,y_component,z_component);
this_box_storage.normal_vectors[5] = coords_set(0,-y_component,z_component);

this_box_volume.geometry.visualization_on = visualize;

this_box_volume.geometry.geometry_parameters.p_box_storage = &this_box_storage;

// Assign pointers to functions for intersection with the shape, checking if a point is inside the shape
if (this_box_storage.is_rectangle == 1) {
this_box_volume.geometry.intersect_function = &sample_box_intersect_simple;
this_box_volume.geometry.within_function = &r_within_box_simple;
}
else {
this_box_volume.geometry.intersect_function = &sample_box_intersect_advanced;
this_box_volume.geometry.within_function = &r_within_box_advanced;
}

this_box_volume.geometry.shell_points = &box_shell_points;
this_box_volume.geometry.mcdisplay_function = &mcdisplay_box_function;
this_box_volume.geometry.initialize_from_main_function = &initialize_box_geometry_from_main_component;
this_box_volume.geometry.process_rot_allocated = 0;

this_box_volume.geometry.copy_geometry_parameters = &allocate_box_storage_copy;

rot_copy(this_box_volume.geometry.rotation_matrix,ROT_A_CURRENT_COMP); //check how ROT_R_CURRENT_COMP would work
rot_transpose(ROT_A_CURRENT_COMP,this_box_volume.geometry.transpose_rotation_matrix);

// Initialize loggers
this_box_volume.loggers.num_elements = 0;

// packing the information into the global_geometry_element, which is then included in the global_geometry_list.
sprintf(global_geometry_element.name,NAME_CURRENT_COMP);
global_geometry_element.activation_counter = number_of_activations;
global_geometry_element.component_index = INDEX_CURRENT_COMP;
global_geometry_element.Volume = &this_box_volume; // Would be nicer if this m was a pointer, now we have the (small) data two places
add_element_to_geometry_list(&global_geometry_list,global_geometry_element);
}
#line 207719 "MACS_sample_kidney_box.c"
#undef number_of_activations
#undef mask_setting
#undef mask_string
#undef p_interact
#undef focus_r
#undef focus_xh
#undef focus_xw
#undef focus_ah
#undef focus_aw
#undef target_z
#undef target_y
#undef target_x
#undef target_index
#undef visualize
#undef yheight2
#undef xwidth2
#undef zdepth
#undef yheight
#undef xwidth
#undef priority
#undef material_string
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

  /* Initializations for component inter_analyzer_colimator_4_blade_4. */
  SIG_MESSAGE("inter_analyzer_colimator_4_blade_4 (Init)");
#define mccompcurname  inter_analyzer_colimator_4_blade_4
#define mccompcurtype  Union_box
#define mccompcurindex 311
#define loop_index mccinter_analyzer_colimator_4_blade_4_loop_index
#define this_box_volume mccinter_analyzer_colimator_4_blade_4_this_box_volume
#define global_geometry_element mccinter_analyzer_colimator_4_blade_4_global_geometry_element
#define this_box_storage mccinter_analyzer_colimator_4_blade_4_this_box_storage
#define material_string mccinter_analyzer_colimator_4_blade_4_material_string
#define priority mccinter_analyzer_colimator_4_blade_4_priority
#define xwidth mccinter_analyzer_colimator_4_blade_4_xwidth
#define yheight mccinter_analyzer_colimator_4_blade_4_yheight
#define zdepth mccinter_analyzer_colimator_4_blade_4_zdepth
#define xwidth2 mccinter_analyzer_colimator_4_blade_4_xwidth2
#define yheight2 mccinter_analyzer_colimator_4_blade_4_yheight2
#define visualize mccinter_analyzer_colimator_4_blade_4_visualize
#define target_index mccinter_analyzer_colimator_4_blade_4_target_index
#define target_x mccinter_analyzer_colimator_4_blade_4_target_x
#define target_y mccinter_analyzer_colimator_4_blade_4_target_y
#define target_z mccinter_analyzer_colimator_4_blade_4_target_z
#define focus_aw mccinter_analyzer_colimator_4_blade_4_focus_aw
#define focus_ah mccinter_analyzer_colimator_4_blade_4_focus_ah
#define focus_xw mccinter_analyzer_colimator_4_blade_4_focus_xw
#define focus_xh mccinter_analyzer_colimator_4_blade_4_focus_xh
#define focus_r mccinter_analyzer_colimator_4_blade_4_focus_r
#define p_interact mccinter_analyzer_colimator_4_blade_4_p_interact
#define mask_string mccinter_analyzer_colimator_4_blade_4_mask_string
#define mask_setting mccinter_analyzer_colimator_4_blade_4_mask_setting
#define number_of_activations mccinter_analyzer_colimator_4_blade_4_number_of_activations
#line 224 "Union_box.comp"
{
// Initializes the focusing system for this volume including input sanitation.
focus_initialize(&this_box_volume.geometry, POS_A_COMP_INDEX(INDEX_CURRENT_COMP+target_index), POS_A_CURRENT_COMP, ROT_A_CURRENT_COMP, target_index, target_x, target_y, target_z, focus_aw, focus_ah, focus_xw, focus_xh, focus_r, NAME_CURRENT_COMP);

// Input sanitation for this geometry
if (xwidth <= 0) {
  printf("\nERROR in Union_box named %s, the xwidth is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (yheight <= 0) {
  printf("\nERROR in Union_box named %s, yheight is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (zdepth <= 0) {
  printf("\nERROR in Union_box named %s, zdepth is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (xwidth2 <= 0 && xwidth2 != -1) {
  printf("\nERROR in Union_box named %s, the xwidth2 is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (yheight2 <= 0 && yheight2 != -1) {
  printf("\nERROR in Union_box named %s, yheight2 is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}

// Use sanitation
if (global_material_list.num_elements == 0) {
  printf("\nERROR: Need to define a material using Union_make_material before using a Union geometry component. \n");
  printf("       %s was defined before first use of Union_make_material.\n",NAME_CURRENT_COMP);
  exit(1);
}

this_box_volume.geometry.is_masked_volume = 0;
this_box_volume.geometry.is_exit_volume = 0;
this_box_volume.geometry.is_mask_volume = 0;
// check if the volume is a mask, if it is the material string is irelevant.
if (mask_string && strlen(mask_string) && strcmp(mask_string, "NULL") && strcmp(mask_string, "0")) {
    // A mask volume is used to limit the extend of other volumes, called the masked volumes. These are specified in the mask_string.
    // In order for a ray to enter a masked volume, it needs to be both in the region covered by that volume AND the mask volume.
    // When more than
    this_box_volume.geometry.mask_mode = 1; // Default is mask mode is ALL
    if (mask_setting && strlen(mask_setting) && strcmp(mask_setting, "NULL") && strcmp(mask_setting, "0")) {
        if (strcmp(mask_setting,"ALL") == 0 || strcmp(mask_setting,"All") == 0) this_box_volume.geometry.mask_mode = 1;
        else if (strcmp(mask_setting,"ANY") == 0 || strcmp(mask_setting,"Any") == 0) this_box_volume.geometry.mask_mode = 2;
        else {
            printf("The mask_mode of component %s is set to %s, but must be either ALL or ANY.\n",NAME_CURRENT_COMP,mask_setting);
            exit(1);
        }
    }
    
    for (loop_index=0;loop_index<global_geometry_list.num_elements;loop_index++) {
        // Add mask list
        if (1 == manual_linking_function(global_geometry_list.elements[loop_index].name,mask_string)) {
            add_element_to_int_list(&this_box_volume.geometry.mask_list,global_geometry_list.elements[loop_index].component_index);
            add_element_to_int_list(&global_geometry_list.elements[loop_index].Volume->geometry.masked_by_list,INDEX_CURRENT_COMP);
            global_geometry_list.elements[loop_index].Volume->geometry.is_masked_volume = 1;
            if (this_box_volume.geometry.mask_mode == 2)
                global_geometry_list.elements[loop_index].Volume->geometry.mask_mode = 2;
            if (this_box_volume.geometry.mask_mode == 1) {
                if (global_geometry_list.elements[loop_index].Volume->geometry.is_masked_volume == 1 && global_geometry_list.elements[loop_index].Volume->geometry.mask_mode != 2)
                    // If more than one mask is added to one volume, the ANY mode overwrites the (default) ALL mode.
                    global_geometry_list.elements[loop_index].Volume->geometry.mask_mode = 1;
            }
            
            found_geometries = 1;
        }
    }
    if (found_geometries == 0) {
        printf("The mask_string in geometry: %s did not find any of the specified volumes in the mask_string %s \n",NAME_CURRENT_COMP,mask_string);
        exit(1);
    }
    this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
    this_box_volume.p_physics->is_vacuum = 0; // Makes this volume a vacuum
    this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
    this_box_volume.p_physics->my_a = 0; // Should not be used.
    sprintf(this_box_volume.p_physics->name,"Mask");
    this_box_volume.geometry.is_mask_volume = 1;
    
    
// Read the material input, or if it lacks, use automatic linking.
} else if (material_string && strlen(material_string) && strcmp(material_string, "NULL") && strcmp(material_string, "0")) {
    // A geometry string was given, use it to determine which material
    if (0 == strcmp(material_string,"vacuum") || 0 == strcmp(material_string,"Vacuum")) {
        // One could have a global physics struct for vacuum instead of creating one for each
        this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
        this_box_volume.p_physics->is_vacuum = 1; // Makes this volume a vacuum
        this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
        this_box_volume.p_physics->my_a = 0; // Should not be used.
        sprintf(this_box_volume.p_physics->name,"Vacuum");
    } else if (0 == strcmp(material_string,"exit") || 0 == strcmp(material_string,"Exit")) {
        // One could have a global physics struct for vacuum instead of creating one for each
        this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
        this_box_volume.p_physics->is_vacuum = 1; // Makes this volume a vacuum
        this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
        this_box_volume.p_physics->my_a = 0; // Should not be used.
        this_box_volume.geometry.is_exit_volume = 1;
        sprintf(this_box_volume.p_physics->name,"Exit");
    } else {
        #ifndef MATERIAL_DETECTOR
            printf("Need to define a material before refering to it in a geometry %s.\n",NAME_CURRENT_COMP);
            exit(1);
        #endif
        for (loop_index=0;loop_index<global_material_list.num_elements;loop_index++) {
            if (0 == strcmp(material_string,global_material_list.elements[loop_index].name)) {
                this_box_volume.p_physics = global_material_list.elements[loop_index].physics;
                break;
            }
            if (loop_index == global_material_list.num_elements-1) {
            printf("\n");
            printf("ERROR: The material string \"%s\" in Union geometry \"%s\" did not match a specified material. \n",material_string,NAME_CURRENT_COMP);
            printf("       The materials available at this point (need to be defined before the geometry): \n");
            for (loop_index=0;loop_index<global_material_list.num_elements;loop_index++)
              printf("         %s\n",global_material_list.elements[loop_index].name);
            printf("\n");
            printf("       It is also possible to use one of the defualt materials avaiable: \n");
            printf("           Vacuum (for a Volume without scattering or absorption)\n");
            printf("           Exit (for a Volume where the ray exits the component if it enters)\n");
            printf("           Mask (for a Volume that masks existing volumes specified in the mask_string\n");
            exit(1);
          }
        }
    }
} else {
    // Automatic linking, simply using the last defined material.
    #ifndef MATERIAL_DETECTOR
        printf("Need to define a material before the geometry to use automatic linking %s.\n",NAME_CURRENT_COMP);
        exit(1);
    #endif
    this_box_volume.p_physics = global_material_list.elements[global_material_list.num_elements-1].physics;
}

sprintf(this_box_volume.name,NAME_CURRENT_COMP);
sprintf(this_box_volume.geometry.shape,"box");
this_box_volume.geometry.priority_value = priority;
this_box_volume.geometry.geometry_p_interact = p_interact;
// Currently the coordinates will be in absolute space.
this_box_volume.geometry.center = POS_A_CURRENT_COMP;

this_box_storage.z_depth = zdepth;
this_box_storage.x_width1 = xwidth;
this_box_storage.y_height1 = yheight;

this_box_storage.is_rectangle = 0;
if (xwidth2 < 0 && yheight2 < 0) this_box_storage.is_rectangle = 1;
if (xwidth == xwidth2 && yheight == yheight2) this_box_storage.is_rectangle = 1;

if (xwidth2 < 0) {
    this_box_storage.x_width2 = xwidth;
    xwidth2 = xwidth;
} else this_box_storage.x_width2 = xwidth2;

if (yheight2 < 0) {
    this_box_storage.y_height2 = yheight;
    yheight2 = yheight;
} else this_box_storage.y_height2 = yheight2;


this_box_storage.normal_vectors[0] = coords_set(0,0,1);
this_box_storage.normal_vectors[1] = coords_set(0,0,1);

// for sides with y component = 0
x_component = 2*zdepth/sqrt((xwidth-xwidth2)*(xwidth-xwidth2)+4*zdepth*zdepth);
z_component = (xwidth-xwidth2)/sqrt(4*zdepth*zdepth+(xwidth-xwidth2)*(xwidth-xwidth2));

this_box_storage.normal_vectors[2] = coords_set(x_component,0,z_component);
this_box_storage.normal_vectors[3] = coords_set(-x_component,0,z_component);

// for sides with x component = 0
y_component = 2*zdepth/sqrt((yheight-yheight2)*(yheight-yheight2)+4*zdepth*zdepth);
z_component = (yheight-yheight2)/sqrt(4*zdepth*zdepth+(yheight-yheight2)*(yheight-yheight2));

this_box_storage.normal_vectors[4] = coords_set(0,y_component,z_component);
this_box_storage.normal_vectors[5] = coords_set(0,-y_component,z_component);

this_box_volume.geometry.visualization_on = visualize;

this_box_volume.geometry.geometry_parameters.p_box_storage = &this_box_storage;

// Assign pointers to functions for intersection with the shape, checking if a point is inside the shape
if (this_box_storage.is_rectangle == 1) {
this_box_volume.geometry.intersect_function = &sample_box_intersect_simple;
this_box_volume.geometry.within_function = &r_within_box_simple;
}
else {
this_box_volume.geometry.intersect_function = &sample_box_intersect_advanced;
this_box_volume.geometry.within_function = &r_within_box_advanced;
}

this_box_volume.geometry.shell_points = &box_shell_points;
this_box_volume.geometry.mcdisplay_function = &mcdisplay_box_function;
this_box_volume.geometry.initialize_from_main_function = &initialize_box_geometry_from_main_component;
this_box_volume.geometry.process_rot_allocated = 0;

this_box_volume.geometry.copy_geometry_parameters = &allocate_box_storage_copy;

rot_copy(this_box_volume.geometry.rotation_matrix,ROT_A_CURRENT_COMP); //check how ROT_R_CURRENT_COMP would work
rot_transpose(ROT_A_CURRENT_COMP,this_box_volume.geometry.transpose_rotation_matrix);

// Initialize loggers
this_box_volume.loggers.num_elements = 0;

// packing the information into the global_geometry_element, which is then included in the global_geometry_list.
sprintf(global_geometry_element.name,NAME_CURRENT_COMP);
global_geometry_element.activation_counter = number_of_activations;
global_geometry_element.component_index = INDEX_CURRENT_COMP;
global_geometry_element.Volume = &this_box_volume; // Would be nicer if this m was a pointer, now we have the (small) data two places
add_element_to_geometry_list(&global_geometry_list,global_geometry_element);
}
#line 207989 "MACS_sample_kidney_box.c"
#undef number_of_activations
#undef mask_setting
#undef mask_string
#undef p_interact
#undef focus_r
#undef focus_xh
#undef focus_xw
#undef focus_ah
#undef focus_aw
#undef target_z
#undef target_y
#undef target_x
#undef target_index
#undef visualize
#undef yheight2
#undef xwidth2
#undef zdepth
#undef yheight
#undef xwidth
#undef priority
#undef material_string
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

  /* Initializations for component diffraction_detector_4_exit_volume. */
  SIG_MESSAGE("diffraction_detector_4_exit_volume (Init)");
#define mccompcurname  diffraction_detector_4_exit_volume
#define mccompcurtype  Union_box
#define mccompcurindex 312
#define loop_index mccdiffraction_detector_4_exit_volume_loop_index
#define this_box_volume mccdiffraction_detector_4_exit_volume_this_box_volume
#define global_geometry_element mccdiffraction_detector_4_exit_volume_global_geometry_element
#define this_box_storage mccdiffraction_detector_4_exit_volume_this_box_storage
#define material_string mccdiffraction_detector_4_exit_volume_material_string
#define priority mccdiffraction_detector_4_exit_volume_priority
#define xwidth mccdiffraction_detector_4_exit_volume_xwidth
#define yheight mccdiffraction_detector_4_exit_volume_yheight
#define zdepth mccdiffraction_detector_4_exit_volume_zdepth
#define xwidth2 mccdiffraction_detector_4_exit_volume_xwidth2
#define yheight2 mccdiffraction_detector_4_exit_volume_yheight2
#define visualize mccdiffraction_detector_4_exit_volume_visualize
#define target_index mccdiffraction_detector_4_exit_volume_target_index
#define target_x mccdiffraction_detector_4_exit_volume_target_x
#define target_y mccdiffraction_detector_4_exit_volume_target_y
#define target_z mccdiffraction_detector_4_exit_volume_target_z
#define focus_aw mccdiffraction_detector_4_exit_volume_focus_aw
#define focus_ah mccdiffraction_detector_4_exit_volume_focus_ah
#define focus_xw mccdiffraction_detector_4_exit_volume_focus_xw
#define focus_xh mccdiffraction_detector_4_exit_volume_focus_xh
#define focus_r mccdiffraction_detector_4_exit_volume_focus_r
#define p_interact mccdiffraction_detector_4_exit_volume_p_interact
#define mask_string mccdiffraction_detector_4_exit_volume_mask_string
#define mask_setting mccdiffraction_detector_4_exit_volume_mask_setting
#define number_of_activations mccdiffraction_detector_4_exit_volume_number_of_activations
#line 224 "Union_box.comp"
{
// Initializes the focusing system for this volume including input sanitation.
focus_initialize(&this_box_volume.geometry, POS_A_COMP_INDEX(INDEX_CURRENT_COMP+target_index), POS_A_CURRENT_COMP, ROT_A_CURRENT_COMP, target_index, target_x, target_y, target_z, focus_aw, focus_ah, focus_xw, focus_xh, focus_r, NAME_CURRENT_COMP);

// Input sanitation for this geometry
if (xwidth <= 0) {
  printf("\nERROR in Union_box named %s, the xwidth is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (yheight <= 0) {
  printf("\nERROR in Union_box named %s, yheight is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (zdepth <= 0) {
  printf("\nERROR in Union_box named %s, zdepth is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (xwidth2 <= 0 && xwidth2 != -1) {
  printf("\nERROR in Union_box named %s, the xwidth2 is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (yheight2 <= 0 && yheight2 != -1) {
  printf("\nERROR in Union_box named %s, yheight2 is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}

// Use sanitation
if (global_material_list.num_elements == 0) {
  printf("\nERROR: Need to define a material using Union_make_material before using a Union geometry component. \n");
  printf("       %s was defined before first use of Union_make_material.\n",NAME_CURRENT_COMP);
  exit(1);
}

this_box_volume.geometry.is_masked_volume = 0;
this_box_volume.geometry.is_exit_volume = 0;
this_box_volume.geometry.is_mask_volume = 0;
// check if the volume is a mask, if it is the material string is irelevant.
if (mask_string && strlen(mask_string) && strcmp(mask_string, "NULL") && strcmp(mask_string, "0")) {
    // A mask volume is used to limit the extend of other volumes, called the masked volumes. These are specified in the mask_string.
    // In order for a ray to enter a masked volume, it needs to be both in the region covered by that volume AND the mask volume.
    // When more than
    this_box_volume.geometry.mask_mode = 1; // Default is mask mode is ALL
    if (mask_setting && strlen(mask_setting) && strcmp(mask_setting, "NULL") && strcmp(mask_setting, "0")) {
        if (strcmp(mask_setting,"ALL") == 0 || strcmp(mask_setting,"All") == 0) this_box_volume.geometry.mask_mode = 1;
        else if (strcmp(mask_setting,"ANY") == 0 || strcmp(mask_setting,"Any") == 0) this_box_volume.geometry.mask_mode = 2;
        else {
            printf("The mask_mode of component %s is set to %s, but must be either ALL or ANY.\n",NAME_CURRENT_COMP,mask_setting);
            exit(1);
        }
    }
    
    for (loop_index=0;loop_index<global_geometry_list.num_elements;loop_index++) {
        // Add mask list
        if (1 == manual_linking_function(global_geometry_list.elements[loop_index].name,mask_string)) {
            add_element_to_int_list(&this_box_volume.geometry.mask_list,global_geometry_list.elements[loop_index].component_index);
            add_element_to_int_list(&global_geometry_list.elements[loop_index].Volume->geometry.masked_by_list,INDEX_CURRENT_COMP);
            global_geometry_list.elements[loop_index].Volume->geometry.is_masked_volume = 1;
            if (this_box_volume.geometry.mask_mode == 2)
                global_geometry_list.elements[loop_index].Volume->geometry.mask_mode = 2;
            if (this_box_volume.geometry.mask_mode == 1) {
                if (global_geometry_list.elements[loop_index].Volume->geometry.is_masked_volume == 1 && global_geometry_list.elements[loop_index].Volume->geometry.mask_mode != 2)
                    // If more than one mask is added to one volume, the ANY mode overwrites the (default) ALL mode.
                    global_geometry_list.elements[loop_index].Volume->geometry.mask_mode = 1;
            }
            
            found_geometries = 1;
        }
    }
    if (found_geometries == 0) {
        printf("The mask_string in geometry: %s did not find any of the specified volumes in the mask_string %s \n",NAME_CURRENT_COMP,mask_string);
        exit(1);
    }
    this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
    this_box_volume.p_physics->is_vacuum = 0; // Makes this volume a vacuum
    this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
    this_box_volume.p_physics->my_a = 0; // Should not be used.
    sprintf(this_box_volume.p_physics->name,"Mask");
    this_box_volume.geometry.is_mask_volume = 1;
    
    
// Read the material input, or if it lacks, use automatic linking.
} else if (material_string && strlen(material_string) && strcmp(material_string, "NULL") && strcmp(material_string, "0")) {
    // A geometry string was given, use it to determine which material
    if (0 == strcmp(material_string,"vacuum") || 0 == strcmp(material_string,"Vacuum")) {
        // One could have a global physics struct for vacuum instead of creating one for each
        this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
        this_box_volume.p_physics->is_vacuum = 1; // Makes this volume a vacuum
        this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
        this_box_volume.p_physics->my_a = 0; // Should not be used.
        sprintf(this_box_volume.p_physics->name,"Vacuum");
    } else if (0 == strcmp(material_string,"exit") || 0 == strcmp(material_string,"Exit")) {
        // One could have a global physics struct for vacuum instead of creating one for each
        this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
        this_box_volume.p_physics->is_vacuum = 1; // Makes this volume a vacuum
        this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
        this_box_volume.p_physics->my_a = 0; // Should not be used.
        this_box_volume.geometry.is_exit_volume = 1;
        sprintf(this_box_volume.p_physics->name,"Exit");
    } else {
        #ifndef MATERIAL_DETECTOR
            printf("Need to define a material before refering to it in a geometry %s.\n",NAME_CURRENT_COMP);
            exit(1);
        #endif
        for (loop_index=0;loop_index<global_material_list.num_elements;loop_index++) {
            if (0 == strcmp(material_string,global_material_list.elements[loop_index].name)) {
                this_box_volume.p_physics = global_material_list.elements[loop_index].physics;
                break;
            }
            if (loop_index == global_material_list.num_elements-1) {
            printf("\n");
            printf("ERROR: The material string \"%s\" in Union geometry \"%s\" did not match a specified material. \n",material_string,NAME_CURRENT_COMP);
            printf("       The materials available at this point (need to be defined before the geometry): \n");
            for (loop_index=0;loop_index<global_material_list.num_elements;loop_index++)
              printf("         %s\n",global_material_list.elements[loop_index].name);
            printf("\n");
            printf("       It is also possible to use one of the defualt materials avaiable: \n");
            printf("           Vacuum (for a Volume without scattering or absorption)\n");
            printf("           Exit (for a Volume where the ray exits the component if it enters)\n");
            printf("           Mask (for a Volume that masks existing volumes specified in the mask_string\n");
            exit(1);
          }
        }
    }
} else {
    // Automatic linking, simply using the last defined material.
    #ifndef MATERIAL_DETECTOR
        printf("Need to define a material before the geometry to use automatic linking %s.\n",NAME_CURRENT_COMP);
        exit(1);
    #endif
    this_box_volume.p_physics = global_material_list.elements[global_material_list.num_elements-1].physics;
}

sprintf(this_box_volume.name,NAME_CURRENT_COMP);
sprintf(this_box_volume.geometry.shape,"box");
this_box_volume.geometry.priority_value = priority;
this_box_volume.geometry.geometry_p_interact = p_interact;
// Currently the coordinates will be in absolute space.
this_box_volume.geometry.center = POS_A_CURRENT_COMP;

this_box_storage.z_depth = zdepth;
this_box_storage.x_width1 = xwidth;
this_box_storage.y_height1 = yheight;

this_box_storage.is_rectangle = 0;
if (xwidth2 < 0 && yheight2 < 0) this_box_storage.is_rectangle = 1;
if (xwidth == xwidth2 && yheight == yheight2) this_box_storage.is_rectangle = 1;

if (xwidth2 < 0) {
    this_box_storage.x_width2 = xwidth;
    xwidth2 = xwidth;
} else this_box_storage.x_width2 = xwidth2;

if (yheight2 < 0) {
    this_box_storage.y_height2 = yheight;
    yheight2 = yheight;
} else this_box_storage.y_height2 = yheight2;


this_box_storage.normal_vectors[0] = coords_set(0,0,1);
this_box_storage.normal_vectors[1] = coords_set(0,0,1);

// for sides with y component = 0
x_component = 2*zdepth/sqrt((xwidth-xwidth2)*(xwidth-xwidth2)+4*zdepth*zdepth);
z_component = (xwidth-xwidth2)/sqrt(4*zdepth*zdepth+(xwidth-xwidth2)*(xwidth-xwidth2));

this_box_storage.normal_vectors[2] = coords_set(x_component,0,z_component);
this_box_storage.normal_vectors[3] = coords_set(-x_component,0,z_component);

// for sides with x component = 0
y_component = 2*zdepth/sqrt((yheight-yheight2)*(yheight-yheight2)+4*zdepth*zdepth);
z_component = (yheight-yheight2)/sqrt(4*zdepth*zdepth+(yheight-yheight2)*(yheight-yheight2));

this_box_storage.normal_vectors[4] = coords_set(0,y_component,z_component);
this_box_storage.normal_vectors[5] = coords_set(0,-y_component,z_component);

this_box_volume.geometry.visualization_on = visualize;

this_box_volume.geometry.geometry_parameters.p_box_storage = &this_box_storage;

// Assign pointers to functions for intersection with the shape, checking if a point is inside the shape
if (this_box_storage.is_rectangle == 1) {
this_box_volume.geometry.intersect_function = &sample_box_intersect_simple;
this_box_volume.geometry.within_function = &r_within_box_simple;
}
else {
this_box_volume.geometry.intersect_function = &sample_box_intersect_advanced;
this_box_volume.geometry.within_function = &r_within_box_advanced;
}

this_box_volume.geometry.shell_points = &box_shell_points;
this_box_volume.geometry.mcdisplay_function = &mcdisplay_box_function;
this_box_volume.geometry.initialize_from_main_function = &initialize_box_geometry_from_main_component;
this_box_volume.geometry.process_rot_allocated = 0;

this_box_volume.geometry.copy_geometry_parameters = &allocate_box_storage_copy;

rot_copy(this_box_volume.geometry.rotation_matrix,ROT_A_CURRENT_COMP); //check how ROT_R_CURRENT_COMP would work
rot_transpose(ROT_A_CURRENT_COMP,this_box_volume.geometry.transpose_rotation_matrix);

// Initialize loggers
this_box_volume.loggers.num_elements = 0;

// packing the information into the global_geometry_element, which is then included in the global_geometry_list.
sprintf(global_geometry_element.name,NAME_CURRENT_COMP);
global_geometry_element.activation_counter = number_of_activations;
global_geometry_element.component_index = INDEX_CURRENT_COMP;
global_geometry_element.Volume = &this_box_volume; // Would be nicer if this m was a pointer, now we have the (small) data two places
add_element_to_geometry_list(&global_geometry_list,global_geometry_element);
}
#line 208259 "MACS_sample_kidney_box.c"
#undef number_of_activations
#undef mask_setting
#undef mask_string
#undef p_interact
#undef focus_r
#undef focus_xh
#undef focus_xw
#undef focus_ah
#undef focus_aw
#undef target_z
#undef target_y
#undef target_x
#undef target_index
#undef visualize
#undef yheight2
#undef xwidth2
#undef zdepth
#undef yheight
#undef xwidth
#undef priority
#undef material_string
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

  /* Initializations for component spec_detector_4_exit_volume. */
  SIG_MESSAGE("spec_detector_4_exit_volume (Init)");
#define mccompcurname  spec_detector_4_exit_volume
#define mccompcurtype  Union_box
#define mccompcurindex 313
#define loop_index mccspec_detector_4_exit_volume_loop_index
#define this_box_volume mccspec_detector_4_exit_volume_this_box_volume
#define global_geometry_element mccspec_detector_4_exit_volume_global_geometry_element
#define this_box_storage mccspec_detector_4_exit_volume_this_box_storage
#define material_string mccspec_detector_4_exit_volume_material_string
#define priority mccspec_detector_4_exit_volume_priority
#define xwidth mccspec_detector_4_exit_volume_xwidth
#define yheight mccspec_detector_4_exit_volume_yheight
#define zdepth mccspec_detector_4_exit_volume_zdepth
#define xwidth2 mccspec_detector_4_exit_volume_xwidth2
#define yheight2 mccspec_detector_4_exit_volume_yheight2
#define visualize mccspec_detector_4_exit_volume_visualize
#define target_index mccspec_detector_4_exit_volume_target_index
#define target_x mccspec_detector_4_exit_volume_target_x
#define target_y mccspec_detector_4_exit_volume_target_y
#define target_z mccspec_detector_4_exit_volume_target_z
#define focus_aw mccspec_detector_4_exit_volume_focus_aw
#define focus_ah mccspec_detector_4_exit_volume_focus_ah
#define focus_xw mccspec_detector_4_exit_volume_focus_xw
#define focus_xh mccspec_detector_4_exit_volume_focus_xh
#define focus_r mccspec_detector_4_exit_volume_focus_r
#define p_interact mccspec_detector_4_exit_volume_p_interact
#define mask_string mccspec_detector_4_exit_volume_mask_string
#define mask_setting mccspec_detector_4_exit_volume_mask_setting
#define number_of_activations mccspec_detector_4_exit_volume_number_of_activations
#line 224 "Union_box.comp"
{
// Initializes the focusing system for this volume including input sanitation.
focus_initialize(&this_box_volume.geometry, POS_A_COMP_INDEX(INDEX_CURRENT_COMP+target_index), POS_A_CURRENT_COMP, ROT_A_CURRENT_COMP, target_index, target_x, target_y, target_z, focus_aw, focus_ah, focus_xw, focus_xh, focus_r, NAME_CURRENT_COMP);

// Input sanitation for this geometry
if (xwidth <= 0) {
  printf("\nERROR in Union_box named %s, the xwidth is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (yheight <= 0) {
  printf("\nERROR in Union_box named %s, yheight is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (zdepth <= 0) {
  printf("\nERROR in Union_box named %s, zdepth is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (xwidth2 <= 0 && xwidth2 != -1) {
  printf("\nERROR in Union_box named %s, the xwidth2 is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (yheight2 <= 0 && yheight2 != -1) {
  printf("\nERROR in Union_box named %s, yheight2 is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}

// Use sanitation
if (global_material_list.num_elements == 0) {
  printf("\nERROR: Need to define a material using Union_make_material before using a Union geometry component. \n");
  printf("       %s was defined before first use of Union_make_material.\n",NAME_CURRENT_COMP);
  exit(1);
}

this_box_volume.geometry.is_masked_volume = 0;
this_box_volume.geometry.is_exit_volume = 0;
this_box_volume.geometry.is_mask_volume = 0;
// check if the volume is a mask, if it is the material string is irelevant.
if (mask_string && strlen(mask_string) && strcmp(mask_string, "NULL") && strcmp(mask_string, "0")) {
    // A mask volume is used to limit the extend of other volumes, called the masked volumes. These are specified in the mask_string.
    // In order for a ray to enter a masked volume, it needs to be both in the region covered by that volume AND the mask volume.
    // When more than
    this_box_volume.geometry.mask_mode = 1; // Default is mask mode is ALL
    if (mask_setting && strlen(mask_setting) && strcmp(mask_setting, "NULL") && strcmp(mask_setting, "0")) {
        if (strcmp(mask_setting,"ALL") == 0 || strcmp(mask_setting,"All") == 0) this_box_volume.geometry.mask_mode = 1;
        else if (strcmp(mask_setting,"ANY") == 0 || strcmp(mask_setting,"Any") == 0) this_box_volume.geometry.mask_mode = 2;
        else {
            printf("The mask_mode of component %s is set to %s, but must be either ALL or ANY.\n",NAME_CURRENT_COMP,mask_setting);
            exit(1);
        }
    }
    
    for (loop_index=0;loop_index<global_geometry_list.num_elements;loop_index++) {
        // Add mask list
        if (1 == manual_linking_function(global_geometry_list.elements[loop_index].name,mask_string)) {
            add_element_to_int_list(&this_box_volume.geometry.mask_list,global_geometry_list.elements[loop_index].component_index);
            add_element_to_int_list(&global_geometry_list.elements[loop_index].Volume->geometry.masked_by_list,INDEX_CURRENT_COMP);
            global_geometry_list.elements[loop_index].Volume->geometry.is_masked_volume = 1;
            if (this_box_volume.geometry.mask_mode == 2)
                global_geometry_list.elements[loop_index].Volume->geometry.mask_mode = 2;
            if (this_box_volume.geometry.mask_mode == 1) {
                if (global_geometry_list.elements[loop_index].Volume->geometry.is_masked_volume == 1 && global_geometry_list.elements[loop_index].Volume->geometry.mask_mode != 2)
                    // If more than one mask is added to one volume, the ANY mode overwrites the (default) ALL mode.
                    global_geometry_list.elements[loop_index].Volume->geometry.mask_mode = 1;
            }
            
            found_geometries = 1;
        }
    }
    if (found_geometries == 0) {
        printf("The mask_string in geometry: %s did not find any of the specified volumes in the mask_string %s \n",NAME_CURRENT_COMP,mask_string);
        exit(1);
    }
    this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
    this_box_volume.p_physics->is_vacuum = 0; // Makes this volume a vacuum
    this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
    this_box_volume.p_physics->my_a = 0; // Should not be used.
    sprintf(this_box_volume.p_physics->name,"Mask");
    this_box_volume.geometry.is_mask_volume = 1;
    
    
// Read the material input, or if it lacks, use automatic linking.
} else if (material_string && strlen(material_string) && strcmp(material_string, "NULL") && strcmp(material_string, "0")) {
    // A geometry string was given, use it to determine which material
    if (0 == strcmp(material_string,"vacuum") || 0 == strcmp(material_string,"Vacuum")) {
        // One could have a global physics struct for vacuum instead of creating one for each
        this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
        this_box_volume.p_physics->is_vacuum = 1; // Makes this volume a vacuum
        this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
        this_box_volume.p_physics->my_a = 0; // Should not be used.
        sprintf(this_box_volume.p_physics->name,"Vacuum");
    } else if (0 == strcmp(material_string,"exit") || 0 == strcmp(material_string,"Exit")) {
        // One could have a global physics struct for vacuum instead of creating one for each
        this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
        this_box_volume.p_physics->is_vacuum = 1; // Makes this volume a vacuum
        this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
        this_box_volume.p_physics->my_a = 0; // Should not be used.
        this_box_volume.geometry.is_exit_volume = 1;
        sprintf(this_box_volume.p_physics->name,"Exit");
    } else {
        #ifndef MATERIAL_DETECTOR
            printf("Need to define a material before refering to it in a geometry %s.\n",NAME_CURRENT_COMP);
            exit(1);
        #endif
        for (loop_index=0;loop_index<global_material_list.num_elements;loop_index++) {
            if (0 == strcmp(material_string,global_material_list.elements[loop_index].name)) {
                this_box_volume.p_physics = global_material_list.elements[loop_index].physics;
                break;
            }
            if (loop_index == global_material_list.num_elements-1) {
            printf("\n");
            printf("ERROR: The material string \"%s\" in Union geometry \"%s\" did not match a specified material. \n",material_string,NAME_CURRENT_COMP);
            printf("       The materials available at this point (need to be defined before the geometry): \n");
            for (loop_index=0;loop_index<global_material_list.num_elements;loop_index++)
              printf("         %s\n",global_material_list.elements[loop_index].name);
            printf("\n");
            printf("       It is also possible to use one of the defualt materials avaiable: \n");
            printf("           Vacuum (for a Volume without scattering or absorption)\n");
            printf("           Exit (for a Volume where the ray exits the component if it enters)\n");
            printf("           Mask (for a Volume that masks existing volumes specified in the mask_string\n");
            exit(1);
          }
        }
    }
} else {
    // Automatic linking, simply using the last defined material.
    #ifndef MATERIAL_DETECTOR
        printf("Need to define a material before the geometry to use automatic linking %s.\n",NAME_CURRENT_COMP);
        exit(1);
    #endif
    this_box_volume.p_physics = global_material_list.elements[global_material_list.num_elements-1].physics;
}

sprintf(this_box_volume.name,NAME_CURRENT_COMP);
sprintf(this_box_volume.geometry.shape,"box");
this_box_volume.geometry.priority_value = priority;
this_box_volume.geometry.geometry_p_interact = p_interact;
// Currently the coordinates will be in absolute space.
this_box_volume.geometry.center = POS_A_CURRENT_COMP;

this_box_storage.z_depth = zdepth;
this_box_storage.x_width1 = xwidth;
this_box_storage.y_height1 = yheight;

this_box_storage.is_rectangle = 0;
if (xwidth2 < 0 && yheight2 < 0) this_box_storage.is_rectangle = 1;
if (xwidth == xwidth2 && yheight == yheight2) this_box_storage.is_rectangle = 1;

if (xwidth2 < 0) {
    this_box_storage.x_width2 = xwidth;
    xwidth2 = xwidth;
} else this_box_storage.x_width2 = xwidth2;

if (yheight2 < 0) {
    this_box_storage.y_height2 = yheight;
    yheight2 = yheight;
} else this_box_storage.y_height2 = yheight2;


this_box_storage.normal_vectors[0] = coords_set(0,0,1);
this_box_storage.normal_vectors[1] = coords_set(0,0,1);

// for sides with y component = 0
x_component = 2*zdepth/sqrt((xwidth-xwidth2)*(xwidth-xwidth2)+4*zdepth*zdepth);
z_component = (xwidth-xwidth2)/sqrt(4*zdepth*zdepth+(xwidth-xwidth2)*(xwidth-xwidth2));

this_box_storage.normal_vectors[2] = coords_set(x_component,0,z_component);
this_box_storage.normal_vectors[3] = coords_set(-x_component,0,z_component);

// for sides with x component = 0
y_component = 2*zdepth/sqrt((yheight-yheight2)*(yheight-yheight2)+4*zdepth*zdepth);
z_component = (yheight-yheight2)/sqrt(4*zdepth*zdepth+(yheight-yheight2)*(yheight-yheight2));

this_box_storage.normal_vectors[4] = coords_set(0,y_component,z_component);
this_box_storage.normal_vectors[5] = coords_set(0,-y_component,z_component);

this_box_volume.geometry.visualization_on = visualize;

this_box_volume.geometry.geometry_parameters.p_box_storage = &this_box_storage;

// Assign pointers to functions for intersection with the shape, checking if a point is inside the shape
if (this_box_storage.is_rectangle == 1) {
this_box_volume.geometry.intersect_function = &sample_box_intersect_simple;
this_box_volume.geometry.within_function = &r_within_box_simple;
}
else {
this_box_volume.geometry.intersect_function = &sample_box_intersect_advanced;
this_box_volume.geometry.within_function = &r_within_box_advanced;
}

this_box_volume.geometry.shell_points = &box_shell_points;
this_box_volume.geometry.mcdisplay_function = &mcdisplay_box_function;
this_box_volume.geometry.initialize_from_main_function = &initialize_box_geometry_from_main_component;
this_box_volume.geometry.process_rot_allocated = 0;

this_box_volume.geometry.copy_geometry_parameters = &allocate_box_storage_copy;

rot_copy(this_box_volume.geometry.rotation_matrix,ROT_A_CURRENT_COMP); //check how ROT_R_CURRENT_COMP would work
rot_transpose(ROT_A_CURRENT_COMP,this_box_volume.geometry.transpose_rotation_matrix);

// Initialize loggers
this_box_volume.loggers.num_elements = 0;

// packing the information into the global_geometry_element, which is then included in the global_geometry_list.
sprintf(global_geometry_element.name,NAME_CURRENT_COMP);
global_geometry_element.activation_counter = number_of_activations;
global_geometry_element.component_index = INDEX_CURRENT_COMP;
global_geometry_element.Volume = &this_box_volume; // Would be nicer if this m was a pointer, now we have the (small) data two places
add_element_to_geometry_list(&global_geometry_list,global_geometry_element);
}
#line 208529 "MACS_sample_kidney_box.c"
#undef number_of_activations
#undef mask_setting
#undef mask_string
#undef p_interact
#undef focus_r
#undef focus_xh
#undef focus_xw
#undef focus_ah
#undef focus_aw
#undef target_z
#undef target_y
#undef target_x
#undef target_index
#undef visualize
#undef yheight2
#undef xwidth2
#undef zdepth
#undef yheight
#undef xwidth
#undef priority
#undef material_string
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

  /* Initializations for component channel_5_cave1_box1. */
  SIG_MESSAGE("channel_5_cave1_box1 (Init)");
#define mccompcurname  channel_5_cave1_box1
#define mccompcurtype  Union_box
#define mccompcurindex 314
#define loop_index mccchannel_5_cave1_box1_loop_index
#define this_box_volume mccchannel_5_cave1_box1_this_box_volume
#define global_geometry_element mccchannel_5_cave1_box1_global_geometry_element
#define this_box_storage mccchannel_5_cave1_box1_this_box_storage
#define material_string mccchannel_5_cave1_box1_material_string
#define priority mccchannel_5_cave1_box1_priority
#define xwidth mccchannel_5_cave1_box1_xwidth
#define yheight mccchannel_5_cave1_box1_yheight
#define zdepth mccchannel_5_cave1_box1_zdepth
#define xwidth2 mccchannel_5_cave1_box1_xwidth2
#define yheight2 mccchannel_5_cave1_box1_yheight2
#define visualize mccchannel_5_cave1_box1_visualize
#define target_index mccchannel_5_cave1_box1_target_index
#define target_x mccchannel_5_cave1_box1_target_x
#define target_y mccchannel_5_cave1_box1_target_y
#define target_z mccchannel_5_cave1_box1_target_z
#define focus_aw mccchannel_5_cave1_box1_focus_aw
#define focus_ah mccchannel_5_cave1_box1_focus_ah
#define focus_xw mccchannel_5_cave1_box1_focus_xw
#define focus_xh mccchannel_5_cave1_box1_focus_xh
#define focus_r mccchannel_5_cave1_box1_focus_r
#define p_interact mccchannel_5_cave1_box1_p_interact
#define mask_string mccchannel_5_cave1_box1_mask_string
#define mask_setting mccchannel_5_cave1_box1_mask_setting
#define number_of_activations mccchannel_5_cave1_box1_number_of_activations
#line 224 "Union_box.comp"
{
// Initializes the focusing system for this volume including input sanitation.
focus_initialize(&this_box_volume.geometry, POS_A_COMP_INDEX(INDEX_CURRENT_COMP+target_index), POS_A_CURRENT_COMP, ROT_A_CURRENT_COMP, target_index, target_x, target_y, target_z, focus_aw, focus_ah, focus_xw, focus_xh, focus_r, NAME_CURRENT_COMP);

// Input sanitation for this geometry
if (xwidth <= 0) {
  printf("\nERROR in Union_box named %s, the xwidth is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (yheight <= 0) {
  printf("\nERROR in Union_box named %s, yheight is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (zdepth <= 0) {
  printf("\nERROR in Union_box named %s, zdepth is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (xwidth2 <= 0 && xwidth2 != -1) {
  printf("\nERROR in Union_box named %s, the xwidth2 is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (yheight2 <= 0 && yheight2 != -1) {
  printf("\nERROR in Union_box named %s, yheight2 is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}

// Use sanitation
if (global_material_list.num_elements == 0) {
  printf("\nERROR: Need to define a material using Union_make_material before using a Union geometry component. \n");
  printf("       %s was defined before first use of Union_make_material.\n",NAME_CURRENT_COMP);
  exit(1);
}

this_box_volume.geometry.is_masked_volume = 0;
this_box_volume.geometry.is_exit_volume = 0;
this_box_volume.geometry.is_mask_volume = 0;
// check if the volume is a mask, if it is the material string is irelevant.
if (mask_string && strlen(mask_string) && strcmp(mask_string, "NULL") && strcmp(mask_string, "0")) {
    // A mask volume is used to limit the extend of other volumes, called the masked volumes. These are specified in the mask_string.
    // In order for a ray to enter a masked volume, it needs to be both in the region covered by that volume AND the mask volume.
    // When more than
    this_box_volume.geometry.mask_mode = 1; // Default is mask mode is ALL
    if (mask_setting && strlen(mask_setting) && strcmp(mask_setting, "NULL") && strcmp(mask_setting, "0")) {
        if (strcmp(mask_setting,"ALL") == 0 || strcmp(mask_setting,"All") == 0) this_box_volume.geometry.mask_mode = 1;
        else if (strcmp(mask_setting,"ANY") == 0 || strcmp(mask_setting,"Any") == 0) this_box_volume.geometry.mask_mode = 2;
        else {
            printf("The mask_mode of component %s is set to %s, but must be either ALL or ANY.\n",NAME_CURRENT_COMP,mask_setting);
            exit(1);
        }
    }
    
    for (loop_index=0;loop_index<global_geometry_list.num_elements;loop_index++) {
        // Add mask list
        if (1 == manual_linking_function(global_geometry_list.elements[loop_index].name,mask_string)) {
            add_element_to_int_list(&this_box_volume.geometry.mask_list,global_geometry_list.elements[loop_index].component_index);
            add_element_to_int_list(&global_geometry_list.elements[loop_index].Volume->geometry.masked_by_list,INDEX_CURRENT_COMP);
            global_geometry_list.elements[loop_index].Volume->geometry.is_masked_volume = 1;
            if (this_box_volume.geometry.mask_mode == 2)
                global_geometry_list.elements[loop_index].Volume->geometry.mask_mode = 2;
            if (this_box_volume.geometry.mask_mode == 1) {
                if (global_geometry_list.elements[loop_index].Volume->geometry.is_masked_volume == 1 && global_geometry_list.elements[loop_index].Volume->geometry.mask_mode != 2)
                    // If more than one mask is added to one volume, the ANY mode overwrites the (default) ALL mode.
                    global_geometry_list.elements[loop_index].Volume->geometry.mask_mode = 1;
            }
            
            found_geometries = 1;
        }
    }
    if (found_geometries == 0) {
        printf("The mask_string in geometry: %s did not find any of the specified volumes in the mask_string %s \n",NAME_CURRENT_COMP,mask_string);
        exit(1);
    }
    this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
    this_box_volume.p_physics->is_vacuum = 0; // Makes this volume a vacuum
    this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
    this_box_volume.p_physics->my_a = 0; // Should not be used.
    sprintf(this_box_volume.p_physics->name,"Mask");
    this_box_volume.geometry.is_mask_volume = 1;
    
    
// Read the material input, or if it lacks, use automatic linking.
} else if (material_string && strlen(material_string) && strcmp(material_string, "NULL") && strcmp(material_string, "0")) {
    // A geometry string was given, use it to determine which material
    if (0 == strcmp(material_string,"vacuum") || 0 == strcmp(material_string,"Vacuum")) {
        // One could have a global physics struct for vacuum instead of creating one for each
        this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
        this_box_volume.p_physics->is_vacuum = 1; // Makes this volume a vacuum
        this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
        this_box_volume.p_physics->my_a = 0; // Should not be used.
        sprintf(this_box_volume.p_physics->name,"Vacuum");
    } else if (0 == strcmp(material_string,"exit") || 0 == strcmp(material_string,"Exit")) {
        // One could have a global physics struct for vacuum instead of creating one for each
        this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
        this_box_volume.p_physics->is_vacuum = 1; // Makes this volume a vacuum
        this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
        this_box_volume.p_physics->my_a = 0; // Should not be used.
        this_box_volume.geometry.is_exit_volume = 1;
        sprintf(this_box_volume.p_physics->name,"Exit");
    } else {
        #ifndef MATERIAL_DETECTOR
            printf("Need to define a material before refering to it in a geometry %s.\n",NAME_CURRENT_COMP);
            exit(1);
        #endif
        for (loop_index=0;loop_index<global_material_list.num_elements;loop_index++) {
            if (0 == strcmp(material_string,global_material_list.elements[loop_index].name)) {
                this_box_volume.p_physics = global_material_list.elements[loop_index].physics;
                break;
            }
            if (loop_index == global_material_list.num_elements-1) {
            printf("\n");
            printf("ERROR: The material string \"%s\" in Union geometry \"%s\" did not match a specified material. \n",material_string,NAME_CURRENT_COMP);
            printf("       The materials available at this point (need to be defined before the geometry): \n");
            for (loop_index=0;loop_index<global_material_list.num_elements;loop_index++)
              printf("         %s\n",global_material_list.elements[loop_index].name);
            printf("\n");
            printf("       It is also possible to use one of the defualt materials avaiable: \n");
            printf("           Vacuum (for a Volume without scattering or absorption)\n");
            printf("           Exit (for a Volume where the ray exits the component if it enters)\n");
            printf("           Mask (for a Volume that masks existing volumes specified in the mask_string\n");
            exit(1);
          }
        }
    }
} else {
    // Automatic linking, simply using the last defined material.
    #ifndef MATERIAL_DETECTOR
        printf("Need to define a material before the geometry to use automatic linking %s.\n",NAME_CURRENT_COMP);
        exit(1);
    #endif
    this_box_volume.p_physics = global_material_list.elements[global_material_list.num_elements-1].physics;
}

sprintf(this_box_volume.name,NAME_CURRENT_COMP);
sprintf(this_box_volume.geometry.shape,"box");
this_box_volume.geometry.priority_value = priority;
this_box_volume.geometry.geometry_p_interact = p_interact;
// Currently the coordinates will be in absolute space.
this_box_volume.geometry.center = POS_A_CURRENT_COMP;

this_box_storage.z_depth = zdepth;
this_box_storage.x_width1 = xwidth;
this_box_storage.y_height1 = yheight;

this_box_storage.is_rectangle = 0;
if (xwidth2 < 0 && yheight2 < 0) this_box_storage.is_rectangle = 1;
if (xwidth == xwidth2 && yheight == yheight2) this_box_storage.is_rectangle = 1;

if (xwidth2 < 0) {
    this_box_storage.x_width2 = xwidth;
    xwidth2 = xwidth;
} else this_box_storage.x_width2 = xwidth2;

if (yheight2 < 0) {
    this_box_storage.y_height2 = yheight;
    yheight2 = yheight;
} else this_box_storage.y_height2 = yheight2;


this_box_storage.normal_vectors[0] = coords_set(0,0,1);
this_box_storage.normal_vectors[1] = coords_set(0,0,1);

// for sides with y component = 0
x_component = 2*zdepth/sqrt((xwidth-xwidth2)*(xwidth-xwidth2)+4*zdepth*zdepth);
z_component = (xwidth-xwidth2)/sqrt(4*zdepth*zdepth+(xwidth-xwidth2)*(xwidth-xwidth2));

this_box_storage.normal_vectors[2] = coords_set(x_component,0,z_component);
this_box_storage.normal_vectors[3] = coords_set(-x_component,0,z_component);

// for sides with x component = 0
y_component = 2*zdepth/sqrt((yheight-yheight2)*(yheight-yheight2)+4*zdepth*zdepth);
z_component = (yheight-yheight2)/sqrt(4*zdepth*zdepth+(yheight-yheight2)*(yheight-yheight2));

this_box_storage.normal_vectors[4] = coords_set(0,y_component,z_component);
this_box_storage.normal_vectors[5] = coords_set(0,-y_component,z_component);

this_box_volume.geometry.visualization_on = visualize;

this_box_volume.geometry.geometry_parameters.p_box_storage = &this_box_storage;

// Assign pointers to functions for intersection with the shape, checking if a point is inside the shape
if (this_box_storage.is_rectangle == 1) {
this_box_volume.geometry.intersect_function = &sample_box_intersect_simple;
this_box_volume.geometry.within_function = &r_within_box_simple;
}
else {
this_box_volume.geometry.intersect_function = &sample_box_intersect_advanced;
this_box_volume.geometry.within_function = &r_within_box_advanced;
}

this_box_volume.geometry.shell_points = &box_shell_points;
this_box_volume.geometry.mcdisplay_function = &mcdisplay_box_function;
this_box_volume.geometry.initialize_from_main_function = &initialize_box_geometry_from_main_component;
this_box_volume.geometry.process_rot_allocated = 0;

this_box_volume.geometry.copy_geometry_parameters = &allocate_box_storage_copy;

rot_copy(this_box_volume.geometry.rotation_matrix,ROT_A_CURRENT_COMP); //check how ROT_R_CURRENT_COMP would work
rot_transpose(ROT_A_CURRENT_COMP,this_box_volume.geometry.transpose_rotation_matrix);

// Initialize loggers
this_box_volume.loggers.num_elements = 0;

// packing the information into the global_geometry_element, which is then included in the global_geometry_list.
sprintf(global_geometry_element.name,NAME_CURRENT_COMP);
global_geometry_element.activation_counter = number_of_activations;
global_geometry_element.component_index = INDEX_CURRENT_COMP;
global_geometry_element.Volume = &this_box_volume; // Would be nicer if this m was a pointer, now we have the (small) data two places
add_element_to_geometry_list(&global_geometry_list,global_geometry_element);
}
#line 208799 "MACS_sample_kidney_box.c"
#undef number_of_activations
#undef mask_setting
#undef mask_string
#undef p_interact
#undef focus_r
#undef focus_xh
#undef focus_xw
#undef focus_ah
#undef focus_aw
#undef target_z
#undef target_y
#undef target_x
#undef target_index
#undef visualize
#undef yheight2
#undef xwidth2
#undef zdepth
#undef yheight
#undef xwidth
#undef priority
#undef material_string
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

  /* Initializations for component channel_5_cave1_box2. */
  SIG_MESSAGE("channel_5_cave1_box2 (Init)");
#define mccompcurname  channel_5_cave1_box2
#define mccompcurtype  Union_box
#define mccompcurindex 315
#define loop_index mccchannel_5_cave1_box2_loop_index
#define this_box_volume mccchannel_5_cave1_box2_this_box_volume
#define global_geometry_element mccchannel_5_cave1_box2_global_geometry_element
#define this_box_storage mccchannel_5_cave1_box2_this_box_storage
#define material_string mccchannel_5_cave1_box2_material_string
#define priority mccchannel_5_cave1_box2_priority
#define xwidth mccchannel_5_cave1_box2_xwidth
#define yheight mccchannel_5_cave1_box2_yheight
#define zdepth mccchannel_5_cave1_box2_zdepth
#define xwidth2 mccchannel_5_cave1_box2_xwidth2
#define yheight2 mccchannel_5_cave1_box2_yheight2
#define visualize mccchannel_5_cave1_box2_visualize
#define target_index mccchannel_5_cave1_box2_target_index
#define target_x mccchannel_5_cave1_box2_target_x
#define target_y mccchannel_5_cave1_box2_target_y
#define target_z mccchannel_5_cave1_box2_target_z
#define focus_aw mccchannel_5_cave1_box2_focus_aw
#define focus_ah mccchannel_5_cave1_box2_focus_ah
#define focus_xw mccchannel_5_cave1_box2_focus_xw
#define focus_xh mccchannel_5_cave1_box2_focus_xh
#define focus_r mccchannel_5_cave1_box2_focus_r
#define p_interact mccchannel_5_cave1_box2_p_interact
#define mask_string mccchannel_5_cave1_box2_mask_string
#define mask_setting mccchannel_5_cave1_box2_mask_setting
#define number_of_activations mccchannel_5_cave1_box2_number_of_activations
#line 224 "Union_box.comp"
{
// Initializes the focusing system for this volume including input sanitation.
focus_initialize(&this_box_volume.geometry, POS_A_COMP_INDEX(INDEX_CURRENT_COMP+target_index), POS_A_CURRENT_COMP, ROT_A_CURRENT_COMP, target_index, target_x, target_y, target_z, focus_aw, focus_ah, focus_xw, focus_xh, focus_r, NAME_CURRENT_COMP);

// Input sanitation for this geometry
if (xwidth <= 0) {
  printf("\nERROR in Union_box named %s, the xwidth is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (yheight <= 0) {
  printf("\nERROR in Union_box named %s, yheight is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (zdepth <= 0) {
  printf("\nERROR in Union_box named %s, zdepth is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (xwidth2 <= 0 && xwidth2 != -1) {
  printf("\nERROR in Union_box named %s, the xwidth2 is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (yheight2 <= 0 && yheight2 != -1) {
  printf("\nERROR in Union_box named %s, yheight2 is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}

// Use sanitation
if (global_material_list.num_elements == 0) {
  printf("\nERROR: Need to define a material using Union_make_material before using a Union geometry component. \n");
  printf("       %s was defined before first use of Union_make_material.\n",NAME_CURRENT_COMP);
  exit(1);
}

this_box_volume.geometry.is_masked_volume = 0;
this_box_volume.geometry.is_exit_volume = 0;
this_box_volume.geometry.is_mask_volume = 0;
// check if the volume is a mask, if it is the material string is irelevant.
if (mask_string && strlen(mask_string) && strcmp(mask_string, "NULL") && strcmp(mask_string, "0")) {
    // A mask volume is used to limit the extend of other volumes, called the masked volumes. These are specified in the mask_string.
    // In order for a ray to enter a masked volume, it needs to be both in the region covered by that volume AND the mask volume.
    // When more than
    this_box_volume.geometry.mask_mode = 1; // Default is mask mode is ALL
    if (mask_setting && strlen(mask_setting) && strcmp(mask_setting, "NULL") && strcmp(mask_setting, "0")) {
        if (strcmp(mask_setting,"ALL") == 0 || strcmp(mask_setting,"All") == 0) this_box_volume.geometry.mask_mode = 1;
        else if (strcmp(mask_setting,"ANY") == 0 || strcmp(mask_setting,"Any") == 0) this_box_volume.geometry.mask_mode = 2;
        else {
            printf("The mask_mode of component %s is set to %s, but must be either ALL or ANY.\n",NAME_CURRENT_COMP,mask_setting);
            exit(1);
        }
    }
    
    for (loop_index=0;loop_index<global_geometry_list.num_elements;loop_index++) {
        // Add mask list
        if (1 == manual_linking_function(global_geometry_list.elements[loop_index].name,mask_string)) {
            add_element_to_int_list(&this_box_volume.geometry.mask_list,global_geometry_list.elements[loop_index].component_index);
            add_element_to_int_list(&global_geometry_list.elements[loop_index].Volume->geometry.masked_by_list,INDEX_CURRENT_COMP);
            global_geometry_list.elements[loop_index].Volume->geometry.is_masked_volume = 1;
            if (this_box_volume.geometry.mask_mode == 2)
                global_geometry_list.elements[loop_index].Volume->geometry.mask_mode = 2;
            if (this_box_volume.geometry.mask_mode == 1) {
                if (global_geometry_list.elements[loop_index].Volume->geometry.is_masked_volume == 1 && global_geometry_list.elements[loop_index].Volume->geometry.mask_mode != 2)
                    // If more than one mask is added to one volume, the ANY mode overwrites the (default) ALL mode.
                    global_geometry_list.elements[loop_index].Volume->geometry.mask_mode = 1;
            }
            
            found_geometries = 1;
        }
    }
    if (found_geometries == 0) {
        printf("The mask_string in geometry: %s did not find any of the specified volumes in the mask_string %s \n",NAME_CURRENT_COMP,mask_string);
        exit(1);
    }
    this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
    this_box_volume.p_physics->is_vacuum = 0; // Makes this volume a vacuum
    this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
    this_box_volume.p_physics->my_a = 0; // Should not be used.
    sprintf(this_box_volume.p_physics->name,"Mask");
    this_box_volume.geometry.is_mask_volume = 1;
    
    
// Read the material input, or if it lacks, use automatic linking.
} else if (material_string && strlen(material_string) && strcmp(material_string, "NULL") && strcmp(material_string, "0")) {
    // A geometry string was given, use it to determine which material
    if (0 == strcmp(material_string,"vacuum") || 0 == strcmp(material_string,"Vacuum")) {
        // One could have a global physics struct for vacuum instead of creating one for each
        this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
        this_box_volume.p_physics->is_vacuum = 1; // Makes this volume a vacuum
        this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
        this_box_volume.p_physics->my_a = 0; // Should not be used.
        sprintf(this_box_volume.p_physics->name,"Vacuum");
    } else if (0 == strcmp(material_string,"exit") || 0 == strcmp(material_string,"Exit")) {
        // One could have a global physics struct for vacuum instead of creating one for each
        this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
        this_box_volume.p_physics->is_vacuum = 1; // Makes this volume a vacuum
        this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
        this_box_volume.p_physics->my_a = 0; // Should not be used.
        this_box_volume.geometry.is_exit_volume = 1;
        sprintf(this_box_volume.p_physics->name,"Exit");
    } else {
        #ifndef MATERIAL_DETECTOR
            printf("Need to define a material before refering to it in a geometry %s.\n",NAME_CURRENT_COMP);
            exit(1);
        #endif
        for (loop_index=0;loop_index<global_material_list.num_elements;loop_index++) {
            if (0 == strcmp(material_string,global_material_list.elements[loop_index].name)) {
                this_box_volume.p_physics = global_material_list.elements[loop_index].physics;
                break;
            }
            if (loop_index == global_material_list.num_elements-1) {
            printf("\n");
            printf("ERROR: The material string \"%s\" in Union geometry \"%s\" did not match a specified material. \n",material_string,NAME_CURRENT_COMP);
            printf("       The materials available at this point (need to be defined before the geometry): \n");
            for (loop_index=0;loop_index<global_material_list.num_elements;loop_index++)
              printf("         %s\n",global_material_list.elements[loop_index].name);
            printf("\n");
            printf("       It is also possible to use one of the defualt materials avaiable: \n");
            printf("           Vacuum (for a Volume without scattering or absorption)\n");
            printf("           Exit (for a Volume where the ray exits the component if it enters)\n");
            printf("           Mask (for a Volume that masks existing volumes specified in the mask_string\n");
            exit(1);
          }
        }
    }
} else {
    // Automatic linking, simply using the last defined material.
    #ifndef MATERIAL_DETECTOR
        printf("Need to define a material before the geometry to use automatic linking %s.\n",NAME_CURRENT_COMP);
        exit(1);
    #endif
    this_box_volume.p_physics = global_material_list.elements[global_material_list.num_elements-1].physics;
}

sprintf(this_box_volume.name,NAME_CURRENT_COMP);
sprintf(this_box_volume.geometry.shape,"box");
this_box_volume.geometry.priority_value = priority;
this_box_volume.geometry.geometry_p_interact = p_interact;
// Currently the coordinates will be in absolute space.
this_box_volume.geometry.center = POS_A_CURRENT_COMP;

this_box_storage.z_depth = zdepth;
this_box_storage.x_width1 = xwidth;
this_box_storage.y_height1 = yheight;

this_box_storage.is_rectangle = 0;
if (xwidth2 < 0 && yheight2 < 0) this_box_storage.is_rectangle = 1;
if (xwidth == xwidth2 && yheight == yheight2) this_box_storage.is_rectangle = 1;

if (xwidth2 < 0) {
    this_box_storage.x_width2 = xwidth;
    xwidth2 = xwidth;
} else this_box_storage.x_width2 = xwidth2;

if (yheight2 < 0) {
    this_box_storage.y_height2 = yheight;
    yheight2 = yheight;
} else this_box_storage.y_height2 = yheight2;


this_box_storage.normal_vectors[0] = coords_set(0,0,1);
this_box_storage.normal_vectors[1] = coords_set(0,0,1);

// for sides with y component = 0
x_component = 2*zdepth/sqrt((xwidth-xwidth2)*(xwidth-xwidth2)+4*zdepth*zdepth);
z_component = (xwidth-xwidth2)/sqrt(4*zdepth*zdepth+(xwidth-xwidth2)*(xwidth-xwidth2));

this_box_storage.normal_vectors[2] = coords_set(x_component,0,z_component);
this_box_storage.normal_vectors[3] = coords_set(-x_component,0,z_component);

// for sides with x component = 0
y_component = 2*zdepth/sqrt((yheight-yheight2)*(yheight-yheight2)+4*zdepth*zdepth);
z_component = (yheight-yheight2)/sqrt(4*zdepth*zdepth+(yheight-yheight2)*(yheight-yheight2));

this_box_storage.normal_vectors[4] = coords_set(0,y_component,z_component);
this_box_storage.normal_vectors[5] = coords_set(0,-y_component,z_component);

this_box_volume.geometry.visualization_on = visualize;

this_box_volume.geometry.geometry_parameters.p_box_storage = &this_box_storage;

// Assign pointers to functions for intersection with the shape, checking if a point is inside the shape
if (this_box_storage.is_rectangle == 1) {
this_box_volume.geometry.intersect_function = &sample_box_intersect_simple;
this_box_volume.geometry.within_function = &r_within_box_simple;
}
else {
this_box_volume.geometry.intersect_function = &sample_box_intersect_advanced;
this_box_volume.geometry.within_function = &r_within_box_advanced;
}

this_box_volume.geometry.shell_points = &box_shell_points;
this_box_volume.geometry.mcdisplay_function = &mcdisplay_box_function;
this_box_volume.geometry.initialize_from_main_function = &initialize_box_geometry_from_main_component;
this_box_volume.geometry.process_rot_allocated = 0;

this_box_volume.geometry.copy_geometry_parameters = &allocate_box_storage_copy;

rot_copy(this_box_volume.geometry.rotation_matrix,ROT_A_CURRENT_COMP); //check how ROT_R_CURRENT_COMP would work
rot_transpose(ROT_A_CURRENT_COMP,this_box_volume.geometry.transpose_rotation_matrix);

// Initialize loggers
this_box_volume.loggers.num_elements = 0;

// packing the information into the global_geometry_element, which is then included in the global_geometry_list.
sprintf(global_geometry_element.name,NAME_CURRENT_COMP);
global_geometry_element.activation_counter = number_of_activations;
global_geometry_element.component_index = INDEX_CURRENT_COMP;
global_geometry_element.Volume = &this_box_volume; // Would be nicer if this m was a pointer, now we have the (small) data two places
add_element_to_geometry_list(&global_geometry_list,global_geometry_element);
}
#line 209069 "MACS_sample_kidney_box.c"
#undef number_of_activations
#undef mask_setting
#undef mask_string
#undef p_interact
#undef focus_r
#undef focus_xh
#undef focus_xw
#undef focus_ah
#undef focus_aw
#undef target_z
#undef target_y
#undef target_x
#undef target_index
#undef visualize
#undef yheight2
#undef xwidth2
#undef zdepth
#undef yheight
#undef xwidth
#undef priority
#undef material_string
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

  /* Initializations for component channel_5_cave1_box3. */
  SIG_MESSAGE("channel_5_cave1_box3 (Init)");
#define mccompcurname  channel_5_cave1_box3
#define mccompcurtype  Union_box
#define mccompcurindex 316
#define loop_index mccchannel_5_cave1_box3_loop_index
#define this_box_volume mccchannel_5_cave1_box3_this_box_volume
#define global_geometry_element mccchannel_5_cave1_box3_global_geometry_element
#define this_box_storage mccchannel_5_cave1_box3_this_box_storage
#define material_string mccchannel_5_cave1_box3_material_string
#define priority mccchannel_5_cave1_box3_priority
#define xwidth mccchannel_5_cave1_box3_xwidth
#define yheight mccchannel_5_cave1_box3_yheight
#define zdepth mccchannel_5_cave1_box3_zdepth
#define xwidth2 mccchannel_5_cave1_box3_xwidth2
#define yheight2 mccchannel_5_cave1_box3_yheight2
#define visualize mccchannel_5_cave1_box3_visualize
#define target_index mccchannel_5_cave1_box3_target_index
#define target_x mccchannel_5_cave1_box3_target_x
#define target_y mccchannel_5_cave1_box3_target_y
#define target_z mccchannel_5_cave1_box3_target_z
#define focus_aw mccchannel_5_cave1_box3_focus_aw
#define focus_ah mccchannel_5_cave1_box3_focus_ah
#define focus_xw mccchannel_5_cave1_box3_focus_xw
#define focus_xh mccchannel_5_cave1_box3_focus_xh
#define focus_r mccchannel_5_cave1_box3_focus_r
#define p_interact mccchannel_5_cave1_box3_p_interact
#define mask_string mccchannel_5_cave1_box3_mask_string
#define mask_setting mccchannel_5_cave1_box3_mask_setting
#define number_of_activations mccchannel_5_cave1_box3_number_of_activations
#line 224 "Union_box.comp"
{
// Initializes the focusing system for this volume including input sanitation.
focus_initialize(&this_box_volume.geometry, POS_A_COMP_INDEX(INDEX_CURRENT_COMP+target_index), POS_A_CURRENT_COMP, ROT_A_CURRENT_COMP, target_index, target_x, target_y, target_z, focus_aw, focus_ah, focus_xw, focus_xh, focus_r, NAME_CURRENT_COMP);

// Input sanitation for this geometry
if (xwidth <= 0) {
  printf("\nERROR in Union_box named %s, the xwidth is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (yheight <= 0) {
  printf("\nERROR in Union_box named %s, yheight is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (zdepth <= 0) {
  printf("\nERROR in Union_box named %s, zdepth is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (xwidth2 <= 0 && xwidth2 != -1) {
  printf("\nERROR in Union_box named %s, the xwidth2 is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (yheight2 <= 0 && yheight2 != -1) {
  printf("\nERROR in Union_box named %s, yheight2 is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}

// Use sanitation
if (global_material_list.num_elements == 0) {
  printf("\nERROR: Need to define a material using Union_make_material before using a Union geometry component. \n");
  printf("       %s was defined before first use of Union_make_material.\n",NAME_CURRENT_COMP);
  exit(1);
}

this_box_volume.geometry.is_masked_volume = 0;
this_box_volume.geometry.is_exit_volume = 0;
this_box_volume.geometry.is_mask_volume = 0;
// check if the volume is a mask, if it is the material string is irelevant.
if (mask_string && strlen(mask_string) && strcmp(mask_string, "NULL") && strcmp(mask_string, "0")) {
    // A mask volume is used to limit the extend of other volumes, called the masked volumes. These are specified in the mask_string.
    // In order for a ray to enter a masked volume, it needs to be both in the region covered by that volume AND the mask volume.
    // When more than
    this_box_volume.geometry.mask_mode = 1; // Default is mask mode is ALL
    if (mask_setting && strlen(mask_setting) && strcmp(mask_setting, "NULL") && strcmp(mask_setting, "0")) {
        if (strcmp(mask_setting,"ALL") == 0 || strcmp(mask_setting,"All") == 0) this_box_volume.geometry.mask_mode = 1;
        else if (strcmp(mask_setting,"ANY") == 0 || strcmp(mask_setting,"Any") == 0) this_box_volume.geometry.mask_mode = 2;
        else {
            printf("The mask_mode of component %s is set to %s, but must be either ALL or ANY.\n",NAME_CURRENT_COMP,mask_setting);
            exit(1);
        }
    }
    
    for (loop_index=0;loop_index<global_geometry_list.num_elements;loop_index++) {
        // Add mask list
        if (1 == manual_linking_function(global_geometry_list.elements[loop_index].name,mask_string)) {
            add_element_to_int_list(&this_box_volume.geometry.mask_list,global_geometry_list.elements[loop_index].component_index);
            add_element_to_int_list(&global_geometry_list.elements[loop_index].Volume->geometry.masked_by_list,INDEX_CURRENT_COMP);
            global_geometry_list.elements[loop_index].Volume->geometry.is_masked_volume = 1;
            if (this_box_volume.geometry.mask_mode == 2)
                global_geometry_list.elements[loop_index].Volume->geometry.mask_mode = 2;
            if (this_box_volume.geometry.mask_mode == 1) {
                if (global_geometry_list.elements[loop_index].Volume->geometry.is_masked_volume == 1 && global_geometry_list.elements[loop_index].Volume->geometry.mask_mode != 2)
                    // If more than one mask is added to one volume, the ANY mode overwrites the (default) ALL mode.
                    global_geometry_list.elements[loop_index].Volume->geometry.mask_mode = 1;
            }
            
            found_geometries = 1;
        }
    }
    if (found_geometries == 0) {
        printf("The mask_string in geometry: %s did not find any of the specified volumes in the mask_string %s \n",NAME_CURRENT_COMP,mask_string);
        exit(1);
    }
    this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
    this_box_volume.p_physics->is_vacuum = 0; // Makes this volume a vacuum
    this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
    this_box_volume.p_physics->my_a = 0; // Should not be used.
    sprintf(this_box_volume.p_physics->name,"Mask");
    this_box_volume.geometry.is_mask_volume = 1;
    
    
// Read the material input, or if it lacks, use automatic linking.
} else if (material_string && strlen(material_string) && strcmp(material_string, "NULL") && strcmp(material_string, "0")) {
    // A geometry string was given, use it to determine which material
    if (0 == strcmp(material_string,"vacuum") || 0 == strcmp(material_string,"Vacuum")) {
        // One could have a global physics struct for vacuum instead of creating one for each
        this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
        this_box_volume.p_physics->is_vacuum = 1; // Makes this volume a vacuum
        this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
        this_box_volume.p_physics->my_a = 0; // Should not be used.
        sprintf(this_box_volume.p_physics->name,"Vacuum");
    } else if (0 == strcmp(material_string,"exit") || 0 == strcmp(material_string,"Exit")) {
        // One could have a global physics struct for vacuum instead of creating one for each
        this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
        this_box_volume.p_physics->is_vacuum = 1; // Makes this volume a vacuum
        this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
        this_box_volume.p_physics->my_a = 0; // Should not be used.
        this_box_volume.geometry.is_exit_volume = 1;
        sprintf(this_box_volume.p_physics->name,"Exit");
    } else {
        #ifndef MATERIAL_DETECTOR
            printf("Need to define a material before refering to it in a geometry %s.\n",NAME_CURRENT_COMP);
            exit(1);
        #endif
        for (loop_index=0;loop_index<global_material_list.num_elements;loop_index++) {
            if (0 == strcmp(material_string,global_material_list.elements[loop_index].name)) {
                this_box_volume.p_physics = global_material_list.elements[loop_index].physics;
                break;
            }
            if (loop_index == global_material_list.num_elements-1) {
            printf("\n");
            printf("ERROR: The material string \"%s\" in Union geometry \"%s\" did not match a specified material. \n",material_string,NAME_CURRENT_COMP);
            printf("       The materials available at this point (need to be defined before the geometry): \n");
            for (loop_index=0;loop_index<global_material_list.num_elements;loop_index++)
              printf("         %s\n",global_material_list.elements[loop_index].name);
            printf("\n");
            printf("       It is also possible to use one of the defualt materials avaiable: \n");
            printf("           Vacuum (for a Volume without scattering or absorption)\n");
            printf("           Exit (for a Volume where the ray exits the component if it enters)\n");
            printf("           Mask (for a Volume that masks existing volumes specified in the mask_string\n");
            exit(1);
          }
        }
    }
} else {
    // Automatic linking, simply using the last defined material.
    #ifndef MATERIAL_DETECTOR
        printf("Need to define a material before the geometry to use automatic linking %s.\n",NAME_CURRENT_COMP);
        exit(1);
    #endif
    this_box_volume.p_physics = global_material_list.elements[global_material_list.num_elements-1].physics;
}

sprintf(this_box_volume.name,NAME_CURRENT_COMP);
sprintf(this_box_volume.geometry.shape,"box");
this_box_volume.geometry.priority_value = priority;
this_box_volume.geometry.geometry_p_interact = p_interact;
// Currently the coordinates will be in absolute space.
this_box_volume.geometry.center = POS_A_CURRENT_COMP;

this_box_storage.z_depth = zdepth;
this_box_storage.x_width1 = xwidth;
this_box_storage.y_height1 = yheight;

this_box_storage.is_rectangle = 0;
if (xwidth2 < 0 && yheight2 < 0) this_box_storage.is_rectangle = 1;
if (xwidth == xwidth2 && yheight == yheight2) this_box_storage.is_rectangle = 1;

if (xwidth2 < 0) {
    this_box_storage.x_width2 = xwidth;
    xwidth2 = xwidth;
} else this_box_storage.x_width2 = xwidth2;

if (yheight2 < 0) {
    this_box_storage.y_height2 = yheight;
    yheight2 = yheight;
} else this_box_storage.y_height2 = yheight2;


this_box_storage.normal_vectors[0] = coords_set(0,0,1);
this_box_storage.normal_vectors[1] = coords_set(0,0,1);

// for sides with y component = 0
x_component = 2*zdepth/sqrt((xwidth-xwidth2)*(xwidth-xwidth2)+4*zdepth*zdepth);
z_component = (xwidth-xwidth2)/sqrt(4*zdepth*zdepth+(xwidth-xwidth2)*(xwidth-xwidth2));

this_box_storage.normal_vectors[2] = coords_set(x_component,0,z_component);
this_box_storage.normal_vectors[3] = coords_set(-x_component,0,z_component);

// for sides with x component = 0
y_component = 2*zdepth/sqrt((yheight-yheight2)*(yheight-yheight2)+4*zdepth*zdepth);
z_component = (yheight-yheight2)/sqrt(4*zdepth*zdepth+(yheight-yheight2)*(yheight-yheight2));

this_box_storage.normal_vectors[4] = coords_set(0,y_component,z_component);
this_box_storage.normal_vectors[5] = coords_set(0,-y_component,z_component);

this_box_volume.geometry.visualization_on = visualize;

this_box_volume.geometry.geometry_parameters.p_box_storage = &this_box_storage;

// Assign pointers to functions for intersection with the shape, checking if a point is inside the shape
if (this_box_storage.is_rectangle == 1) {
this_box_volume.geometry.intersect_function = &sample_box_intersect_simple;
this_box_volume.geometry.within_function = &r_within_box_simple;
}
else {
this_box_volume.geometry.intersect_function = &sample_box_intersect_advanced;
this_box_volume.geometry.within_function = &r_within_box_advanced;
}

this_box_volume.geometry.shell_points = &box_shell_points;
this_box_volume.geometry.mcdisplay_function = &mcdisplay_box_function;
this_box_volume.geometry.initialize_from_main_function = &initialize_box_geometry_from_main_component;
this_box_volume.geometry.process_rot_allocated = 0;

this_box_volume.geometry.copy_geometry_parameters = &allocate_box_storage_copy;

rot_copy(this_box_volume.geometry.rotation_matrix,ROT_A_CURRENT_COMP); //check how ROT_R_CURRENT_COMP would work
rot_transpose(ROT_A_CURRENT_COMP,this_box_volume.geometry.transpose_rotation_matrix);

// Initialize loggers
this_box_volume.loggers.num_elements = 0;

// packing the information into the global_geometry_element, which is then included in the global_geometry_list.
sprintf(global_geometry_element.name,NAME_CURRENT_COMP);
global_geometry_element.activation_counter = number_of_activations;
global_geometry_element.component_index = INDEX_CURRENT_COMP;
global_geometry_element.Volume = &this_box_volume; // Would be nicer if this m was a pointer, now we have the (small) data two places
add_element_to_geometry_list(&global_geometry_list,global_geometry_element);
}
#line 209339 "MACS_sample_kidney_box.c"
#undef number_of_activations
#undef mask_setting
#undef mask_string
#undef p_interact
#undef focus_r
#undef focus_xh
#undef focus_xw
#undef focus_ah
#undef focus_aw
#undef target_z
#undef target_y
#undef target_x
#undef target_index
#undef visualize
#undef yheight2
#undef xwidth2
#undef zdepth
#undef yheight
#undef xwidth
#undef priority
#undef material_string
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

  /* Initializations for component channel_5_cave1_cyl1. */
  SIG_MESSAGE("channel_5_cave1_cyl1 (Init)");
#define mccompcurname  channel_5_cave1_cyl1
#define mccompcurtype  Union_cylinder
#define mccompcurindex 317
#define loop_index mccchannel_5_cave1_cyl1_loop_index
#define this_cylinder_volume mccchannel_5_cave1_cyl1_this_cylinder_volume
#define global_geometry_element mccchannel_5_cave1_cyl1_global_geometry_element
#define this_cylinder_storage mccchannel_5_cave1_cyl1_this_cylinder_storage
#define material_string mccchannel_5_cave1_cyl1_material_string
#define priority mccchannel_5_cave1_cyl1_priority
#define radius mccchannel_5_cave1_cyl1_radius
#define yheight mccchannel_5_cave1_cyl1_yheight
#define visualize mccchannel_5_cave1_cyl1_visualize
#define target_index mccchannel_5_cave1_cyl1_target_index
#define target_x mccchannel_5_cave1_cyl1_target_x
#define target_y mccchannel_5_cave1_cyl1_target_y
#define target_z mccchannel_5_cave1_cyl1_target_z
#define focus_aw mccchannel_5_cave1_cyl1_focus_aw
#define focus_ah mccchannel_5_cave1_cyl1_focus_ah
#define focus_xw mccchannel_5_cave1_cyl1_focus_xw
#define focus_xh mccchannel_5_cave1_cyl1_focus_xh
#define focus_r mccchannel_5_cave1_cyl1_focus_r
#define p_interact mccchannel_5_cave1_cyl1_p_interact
#define mask_string mccchannel_5_cave1_cyl1_mask_string
#define mask_setting mccchannel_5_cave1_cyl1_mask_setting
#define number_of_activations mccchannel_5_cave1_cyl1_number_of_activations
#line 185 "Union_cylinder.comp"
{
// Initializes the focusing system for this volume including input sanitation.
focus_initialize(&this_cylinder_volume.geometry, POS_A_COMP_INDEX(INDEX_CURRENT_COMP+target_index), POS_A_CURRENT_COMP, ROT_A_CURRENT_COMP, target_index, target_x, target_y, target_z, focus_aw, focus_ah, focus_xw, focus_xh, focus_r, NAME_CURRENT_COMP);

// Input sanitation for this geometry
if (radius <= 0) {
  printf("\nERROR in Union_cylinder named %s, the radius is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}

if (yheight <= 0) {
  printf("\nERROR in Union_cylinder named %s, yheight is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}

// Use sanitation
#ifdef MATERIAL_DETECTOR
if (global_material_list.num_elements == 0) {
  // Here if the user have defined a material, but only after this material
  printf("\nERROR: Need to define a material using Union_make_material before using a Union geometry component. \n");
  printf("       %s was defined before first use of Union_make_material.\n",NAME_CURRENT_COMP);
  exit(1);
}
#endif
#ifndef MATERIAL_DETECTOR
  printf("\nERROR: Need to define a material using Union_make_material before using a Union geometry component. \n");
  exit(1);
#endif


this_cylinder_volume.geometry.is_masked_volume = 0;
this_cylinder_volume.geometry.is_exit_volume = 0;
this_cylinder_volume.geometry.is_mask_volume = 0;

// Read the material input, or if it lacks, use automatic linking.
if (mask_string && strlen(mask_string) && strcmp(mask_string, "NULL") && strcmp(mask_string, "0")) {
    // A mask volume is used to limit the extend of other volumes, called the masked volumes. These are specified in the mask_string.
    // In order for a ray to enter a masked volume, it needs to be both in the region covered by that volume AND the mask volume.
    // When more than
    this_cylinder_volume.geometry.mask_mode = 1; // Default is mask mode is ALL
    if (mask_setting && strlen(mask_setting) && strcmp(mask_setting, "NULL") && strcmp(mask_setting, "0")) {
        if (strcmp(mask_setting,"ALL") == 0 || strcmp(mask_setting,"All") == 0) this_cylinder_volume.geometry.mask_mode = 1;
        else if (strcmp(mask_setting,"ANY") == 0 || strcmp(mask_setting,"Any") == 0) this_cylinder_volume.geometry.mask_mode = 2;
        else {
            printf("The mask_mode of component %s is set to %s, but must be either ALL or ANY.\n",NAME_CURRENT_COMP,mask_setting);
            exit(1);
        }
    }
    
    for (loop_index=0;loop_index<global_geometry_list.num_elements;loop_index++) {
        // Add mask list
        if (1 == manual_linking_function(global_geometry_list.elements[loop_index].name,mask_string)) {
            add_element_to_int_list(&this_cylinder_volume.geometry.mask_list,global_geometry_list.elements[loop_index].component_index);
            add_element_to_int_list(&global_geometry_list.elements[loop_index].Volume->geometry.masked_by_list,INDEX_CURRENT_COMP);
            global_geometry_list.elements[loop_index].Volume->geometry.is_masked_volume = 1;
            if (this_cylinder_volume.geometry.mask_mode == 2)
                global_geometry_list.elements[loop_index].Volume->geometry.mask_mode = 2;
            if (this_cylinder_volume.geometry.mask_mode == 1) {
                if (global_geometry_list.elements[loop_index].Volume->geometry.is_masked_volume == 1 && global_geometry_list.elements[loop_index].Volume->geometry.mask_mode != 2)
                    // If more than one mask is added to one volume, the ANY mode overwrites the (default) ALL mode.
                    global_geometry_list.elements[loop_index].Volume->geometry.mask_mode = 1;
            }
            
            found_geometries = 1;
        }
    }
    if (found_geometries == 0) {
        printf("The mask_string in geometry: %s did not find any of the specified volumes in the mask_string %s \n",NAME_CURRENT_COMP,mask_string);
        exit(1);
    }
    this_cylinder_volume.p_physics = malloc(sizeof(struct physics_struct));
    this_cylinder_volume.p_physics->is_vacuum = 0; // Makes this volume a vacuum
    this_cylinder_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
    this_cylinder_volume.p_physics->my_a = 0; // Should not be used.
    sprintf(this_cylinder_volume.p_physics->name,"Mask");
    this_cylinder_volume.geometry.is_mask_volume = 1;
    
    
// Read the material input, or if it lacks, use automatic linking.
} else if (material_string && strlen(material_string) && strcmp(material_string, "NULL") && strcmp(material_string, "0")) {
    // A geometry string was given, use it to determine which material
    if (0 == strcmp(material_string,"vacuum") || 0 == strcmp(material_string,"Vacuum")) {
        // One could have a global physics struct for vacuum instead of creating one for each
        this_cylinder_volume.p_physics = malloc(sizeof(struct physics_struct));
        this_cylinder_volume.p_physics->is_vacuum = 1; // Makes this volume a vacuum
        this_cylinder_volume.p_physics->number_of_processes = (int) 0;
        this_cylinder_volume.p_physics->my_a = 0; // Should not be used.
        sprintf(this_cylinder_volume.p_physics->name,"Vacuum");
    } else if (0 == strcmp(material_string,"exit") || 0 == strcmp(material_string,"Exit")) {
        // One could have a global physics struct for exit instead of creating one for each
        this_cylinder_volume.p_physics = malloc(sizeof(struct physics_struct));
        this_cylinder_volume.p_physics->is_vacuum = 1; // Makes this volume a vacuum
        this_cylinder_volume.p_physics->number_of_processes = (int) 0;
        this_cylinder_volume.p_physics->my_a = 0; // Should not be used.
        this_cylinder_volume.geometry.is_exit_volume = 1;
        sprintf(this_cylinder_volume.p_physics->name,"Exit");
    } else {
        for (loop_index=0;loop_index<global_material_list.num_elements;loop_index++) {
          if (0 == strcmp(material_string,global_material_list.elements[loop_index].name)) {
            this_cylinder_volume.p_physics = global_material_list.elements[loop_index].physics;
            break;
          }
          if (loop_index == global_material_list.num_elements-1) {
            printf("\n");
            printf("ERROR: The material string \"%s\" in Union geometry \"%s\" did not match a specified material. \n",material_string,NAME_CURRENT_COMP);
            printf("       The materials available at this point (need to be defined before the geometry): \n");
            for (loop_index=0;loop_index<global_material_list.num_elements;loop_index++)
              printf("         %s\n",global_material_list.elements[loop_index].name);
            printf("\n");
            printf("       It is also possible to use one of the defualt materials avaiable: \n");
            printf("           Vacuum (for a Volume without scattering or absorption)\n");
            printf("           Exit (for a Volume where the ray exits the component if it enters)\n");
            printf("           Mask (for a Volume that masks existing volumes specified in the mask_string\n");
            exit(1);
          }
        }
    }
} else {
    // Automatic linking, simply using the last defined material.
    #ifndef MATERIAL_DETECTOR
        printf("Need to define a material before the geometry to use automatic linking %s.\n",NAME_CURRENT_COMP);
        exit(1);
    #endif
    this_cylinder_volume.p_physics = global_material_list.elements[global_material_list.num_elements-1].physics;
}

sprintf(this_cylinder_volume.name,NAME_CURRENT_COMP);
sprintf(this_cylinder_volume.geometry.shape,"cylinder");
this_cylinder_volume.geometry.priority_value = priority;
// Currently the coordinates will be in absolute space.
this_cylinder_volume.geometry.center = POS_A_CURRENT_COMP;

this_cylinder_volume.geometry.geometry_p_interact = p_interact;
this_cylinder_storage.cyl_radius = radius;
this_cylinder_storage.height = yheight;
this_cylinder_volume.geometry.visualization_on = visualize;
this_cylinder_volume.geometry.geometry_parameters.p_cylinder_storage = &this_cylinder_storage;
this_cylinder_volume.geometry.within_function = &r_within_cylinder;
this_cylinder_volume.geometry.intersect_function = &sample_cylinder_intersect;
this_cylinder_volume.geometry.mcdisplay_function = &mcdisplay_cylinder_function;
this_cylinder_volume.geometry.shell_points = &cylinder_shell_points;
this_cylinder_volume.geometry.initialize_from_main_function = &initialize_cylinder_geometry_from_main_component;
this_cylinder_volume.geometry.process_rot_allocated = 0;
this_cylinder_volume.geometry.copy_geometry_parameters = &allocate_cylinder_storage_copy;

rot_copy(this_cylinder_volume.geometry.rotation_matrix,ROT_A_CURRENT_COMP);
rot_transpose(ROT_A_CURRENT_COMP,this_cylinder_volume.geometry.transpose_rotation_matrix);

// Initialize loggers
this_cylinder_volume.loggers.num_elements = 0;

// packing the information into the global_geometry_element, which is then included in the global_geometry_list.
sprintf(global_geometry_element.name,NAME_CURRENT_COMP);
global_geometry_element.activation_counter = number_of_activations;
global_geometry_element.component_index = INDEX_CURRENT_COMP;
global_geometry_element.Volume = &this_cylinder_volume; // Would be nicer if this m was a pointer, now we have the (small) data two places
add_element_to_geometry_list(&global_geometry_list,global_geometry_element);
}
#line 209555 "MACS_sample_kidney_box.c"
#undef number_of_activations
#undef mask_setting
#undef mask_string
#undef p_interact
#undef focus_r
#undef focus_xh
#undef focus_xw
#undef focus_ah
#undef focus_aw
#undef target_z
#undef target_y
#undef target_x
#undef target_index
#undef visualize
#undef yheight
#undef radius
#undef priority
#undef material_string
#undef this_cylinder_storage
#undef global_geometry_element
#undef this_cylinder_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

  /* Initializations for component channel_5_analyzer_1_center. */
  SIG_MESSAGE("channel_5_analyzer_1_center (Init)");

  /* Initializations for component channel_5_analyzer_1_rotated. */
  SIG_MESSAGE("channel_5_analyzer_1_rotated (Init)");

  /* Initializations for component channel_5_analyzer_1_array_crystal_array_0. */
  SIG_MESSAGE("channel_5_analyzer_1_array_crystal_array_0 (Init)");
#define mccompcurname  channel_5_analyzer_1_array_crystal_array_0
#define mccompcurtype  Union_box
#define mccompcurindex 320
#define loop_index mccchannel_5_analyzer_1_array_crystal_array_0_loop_index
#define this_box_volume mccchannel_5_analyzer_1_array_crystal_array_0_this_box_volume
#define global_geometry_element mccchannel_5_analyzer_1_array_crystal_array_0_global_geometry_element
#define this_box_storage mccchannel_5_analyzer_1_array_crystal_array_0_this_box_storage
#define material_string mccchannel_5_analyzer_1_array_crystal_array_0_material_string
#define priority mccchannel_5_analyzer_1_array_crystal_array_0_priority
#define xwidth mccchannel_5_analyzer_1_array_crystal_array_0_xwidth
#define yheight mccchannel_5_analyzer_1_array_crystal_array_0_yheight
#define zdepth mccchannel_5_analyzer_1_array_crystal_array_0_zdepth
#define xwidth2 mccchannel_5_analyzer_1_array_crystal_array_0_xwidth2
#define yheight2 mccchannel_5_analyzer_1_array_crystal_array_0_yheight2
#define visualize mccchannel_5_analyzer_1_array_crystal_array_0_visualize
#define target_index mccchannel_5_analyzer_1_array_crystal_array_0_target_index
#define target_x mccchannel_5_analyzer_1_array_crystal_array_0_target_x
#define target_y mccchannel_5_analyzer_1_array_crystal_array_0_target_y
#define target_z mccchannel_5_analyzer_1_array_crystal_array_0_target_z
#define focus_aw mccchannel_5_analyzer_1_array_crystal_array_0_focus_aw
#define focus_ah mccchannel_5_analyzer_1_array_crystal_array_0_focus_ah
#define focus_xw mccchannel_5_analyzer_1_array_crystal_array_0_focus_xw
#define focus_xh mccchannel_5_analyzer_1_array_crystal_array_0_focus_xh
#define focus_r mccchannel_5_analyzer_1_array_crystal_array_0_focus_r
#define p_interact mccchannel_5_analyzer_1_array_crystal_array_0_p_interact
#define mask_string mccchannel_5_analyzer_1_array_crystal_array_0_mask_string
#define mask_setting mccchannel_5_analyzer_1_array_crystal_array_0_mask_setting
#define number_of_activations mccchannel_5_analyzer_1_array_crystal_array_0_number_of_activations
#line 224 "Union_box.comp"
{
// Initializes the focusing system for this volume including input sanitation.
focus_initialize(&this_box_volume.geometry, POS_A_COMP_INDEX(INDEX_CURRENT_COMP+target_index), POS_A_CURRENT_COMP, ROT_A_CURRENT_COMP, target_index, target_x, target_y, target_z, focus_aw, focus_ah, focus_xw, focus_xh, focus_r, NAME_CURRENT_COMP);

// Input sanitation for this geometry
if (xwidth <= 0) {
  printf("\nERROR in Union_box named %s, the xwidth is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (yheight <= 0) {
  printf("\nERROR in Union_box named %s, yheight is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (zdepth <= 0) {
  printf("\nERROR in Union_box named %s, zdepth is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (xwidth2 <= 0 && xwidth2 != -1) {
  printf("\nERROR in Union_box named %s, the xwidth2 is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (yheight2 <= 0 && yheight2 != -1) {
  printf("\nERROR in Union_box named %s, yheight2 is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}

// Use sanitation
if (global_material_list.num_elements == 0) {
  printf("\nERROR: Need to define a material using Union_make_material before using a Union geometry component. \n");
  printf("       %s was defined before first use of Union_make_material.\n",NAME_CURRENT_COMP);
  exit(1);
}

this_box_volume.geometry.is_masked_volume = 0;
this_box_volume.geometry.is_exit_volume = 0;
this_box_volume.geometry.is_mask_volume = 0;
// check if the volume is a mask, if it is the material string is irelevant.
if (mask_string && strlen(mask_string) && strcmp(mask_string, "NULL") && strcmp(mask_string, "0")) {
    // A mask volume is used to limit the extend of other volumes, called the masked volumes. These are specified in the mask_string.
    // In order for a ray to enter a masked volume, it needs to be both in the region covered by that volume AND the mask volume.
    // When more than
    this_box_volume.geometry.mask_mode = 1; // Default is mask mode is ALL
    if (mask_setting && strlen(mask_setting) && strcmp(mask_setting, "NULL") && strcmp(mask_setting, "0")) {
        if (strcmp(mask_setting,"ALL") == 0 || strcmp(mask_setting,"All") == 0) this_box_volume.geometry.mask_mode = 1;
        else if (strcmp(mask_setting,"ANY") == 0 || strcmp(mask_setting,"Any") == 0) this_box_volume.geometry.mask_mode = 2;
        else {
            printf("The mask_mode of component %s is set to %s, but must be either ALL or ANY.\n",NAME_CURRENT_COMP,mask_setting);
            exit(1);
        }
    }
    
    for (loop_index=0;loop_index<global_geometry_list.num_elements;loop_index++) {
        // Add mask list
        if (1 == manual_linking_function(global_geometry_list.elements[loop_index].name,mask_string)) {
            add_element_to_int_list(&this_box_volume.geometry.mask_list,global_geometry_list.elements[loop_index].component_index);
            add_element_to_int_list(&global_geometry_list.elements[loop_index].Volume->geometry.masked_by_list,INDEX_CURRENT_COMP);
            global_geometry_list.elements[loop_index].Volume->geometry.is_masked_volume = 1;
            if (this_box_volume.geometry.mask_mode == 2)
                global_geometry_list.elements[loop_index].Volume->geometry.mask_mode = 2;
            if (this_box_volume.geometry.mask_mode == 1) {
                if (global_geometry_list.elements[loop_index].Volume->geometry.is_masked_volume == 1 && global_geometry_list.elements[loop_index].Volume->geometry.mask_mode != 2)
                    // If more than one mask is added to one volume, the ANY mode overwrites the (default) ALL mode.
                    global_geometry_list.elements[loop_index].Volume->geometry.mask_mode = 1;
            }
            
            found_geometries = 1;
        }
    }
    if (found_geometries == 0) {
        printf("The mask_string in geometry: %s did not find any of the specified volumes in the mask_string %s \n",NAME_CURRENT_COMP,mask_string);
        exit(1);
    }
    this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
    this_box_volume.p_physics->is_vacuum = 0; // Makes this volume a vacuum
    this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
    this_box_volume.p_physics->my_a = 0; // Should not be used.
    sprintf(this_box_volume.p_physics->name,"Mask");
    this_box_volume.geometry.is_mask_volume = 1;
    
    
// Read the material input, or if it lacks, use automatic linking.
} else if (material_string && strlen(material_string) && strcmp(material_string, "NULL") && strcmp(material_string, "0")) {
    // A geometry string was given, use it to determine which material
    if (0 == strcmp(material_string,"vacuum") || 0 == strcmp(material_string,"Vacuum")) {
        // One could have a global physics struct for vacuum instead of creating one for each
        this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
        this_box_volume.p_physics->is_vacuum = 1; // Makes this volume a vacuum
        this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
        this_box_volume.p_physics->my_a = 0; // Should not be used.
        sprintf(this_box_volume.p_physics->name,"Vacuum");
    } else if (0 == strcmp(material_string,"exit") || 0 == strcmp(material_string,"Exit")) {
        // One could have a global physics struct for vacuum instead of creating one for each
        this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
        this_box_volume.p_physics->is_vacuum = 1; // Makes this volume a vacuum
        this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
        this_box_volume.p_physics->my_a = 0; // Should not be used.
        this_box_volume.geometry.is_exit_volume = 1;
        sprintf(this_box_volume.p_physics->name,"Exit");
    } else {
        #ifndef MATERIAL_DETECTOR
            printf("Need to define a material before refering to it in a geometry %s.\n",NAME_CURRENT_COMP);
            exit(1);
        #endif
        for (loop_index=0;loop_index<global_material_list.num_elements;loop_index++) {
            if (0 == strcmp(material_string,global_material_list.elements[loop_index].name)) {
                this_box_volume.p_physics = global_material_list.elements[loop_index].physics;
                break;
            }
            if (loop_index == global_material_list.num_elements-1) {
            printf("\n");
            printf("ERROR: The material string \"%s\" in Union geometry \"%s\" did not match a specified material. \n",material_string,NAME_CURRENT_COMP);
            printf("       The materials available at this point (need to be defined before the geometry): \n");
            for (loop_index=0;loop_index<global_material_list.num_elements;loop_index++)
              printf("         %s\n",global_material_list.elements[loop_index].name);
            printf("\n");
            printf("       It is also possible to use one of the defualt materials avaiable: \n");
            printf("           Vacuum (for a Volume without scattering or absorption)\n");
            printf("           Exit (for a Volume where the ray exits the component if it enters)\n");
            printf("           Mask (for a Volume that masks existing volumes specified in the mask_string\n");
            exit(1);
          }
        }
    }
} else {
    // Automatic linking, simply using the last defined material.
    #ifndef MATERIAL_DETECTOR
        printf("Need to define a material before the geometry to use automatic linking %s.\n",NAME_CURRENT_COMP);
        exit(1);
    #endif
    this_box_volume.p_physics = global_material_list.elements[global_material_list.num_elements-1].physics;
}

sprintf(this_box_volume.name,NAME_CURRENT_COMP);
sprintf(this_box_volume.geometry.shape,"box");
this_box_volume.geometry.priority_value = priority;
this_box_volume.geometry.geometry_p_interact = p_interact;
// Currently the coordinates will be in absolute space.
this_box_volume.geometry.center = POS_A_CURRENT_COMP;

this_box_storage.z_depth = zdepth;
this_box_storage.x_width1 = xwidth;
this_box_storage.y_height1 = yheight;

this_box_storage.is_rectangle = 0;
if (xwidth2 < 0 && yheight2 < 0) this_box_storage.is_rectangle = 1;
if (xwidth == xwidth2 && yheight == yheight2) this_box_storage.is_rectangle = 1;

if (xwidth2 < 0) {
    this_box_storage.x_width2 = xwidth;
    xwidth2 = xwidth;
} else this_box_storage.x_width2 = xwidth2;

if (yheight2 < 0) {
    this_box_storage.y_height2 = yheight;
    yheight2 = yheight;
} else this_box_storage.y_height2 = yheight2;


this_box_storage.normal_vectors[0] = coords_set(0,0,1);
this_box_storage.normal_vectors[1] = coords_set(0,0,1);

// for sides with y component = 0
x_component = 2*zdepth/sqrt((xwidth-xwidth2)*(xwidth-xwidth2)+4*zdepth*zdepth);
z_component = (xwidth-xwidth2)/sqrt(4*zdepth*zdepth+(xwidth-xwidth2)*(xwidth-xwidth2));

this_box_storage.normal_vectors[2] = coords_set(x_component,0,z_component);
this_box_storage.normal_vectors[3] = coords_set(-x_component,0,z_component);

// for sides with x component = 0
y_component = 2*zdepth/sqrt((yheight-yheight2)*(yheight-yheight2)+4*zdepth*zdepth);
z_component = (yheight-yheight2)/sqrt(4*zdepth*zdepth+(yheight-yheight2)*(yheight-yheight2));

this_box_storage.normal_vectors[4] = coords_set(0,y_component,z_component);
this_box_storage.normal_vectors[5] = coords_set(0,-y_component,z_component);

this_box_volume.geometry.visualization_on = visualize;

this_box_volume.geometry.geometry_parameters.p_box_storage = &this_box_storage;

// Assign pointers to functions for intersection with the shape, checking if a point is inside the shape
if (this_box_storage.is_rectangle == 1) {
this_box_volume.geometry.intersect_function = &sample_box_intersect_simple;
this_box_volume.geometry.within_function = &r_within_box_simple;
}
else {
this_box_volume.geometry.intersect_function = &sample_box_intersect_advanced;
this_box_volume.geometry.within_function = &r_within_box_advanced;
}

this_box_volume.geometry.shell_points = &box_shell_points;
this_box_volume.geometry.mcdisplay_function = &mcdisplay_box_function;
this_box_volume.geometry.initialize_from_main_function = &initialize_box_geometry_from_main_component;
this_box_volume.geometry.process_rot_allocated = 0;

this_box_volume.geometry.copy_geometry_parameters = &allocate_box_storage_copy;

rot_copy(this_box_volume.geometry.rotation_matrix,ROT_A_CURRENT_COMP); //check how ROT_R_CURRENT_COMP would work
rot_transpose(ROT_A_CURRENT_COMP,this_box_volume.geometry.transpose_rotation_matrix);

// Initialize loggers
this_box_volume.loggers.num_elements = 0;

// packing the information into the global_geometry_element, which is then included in the global_geometry_list.
sprintf(global_geometry_element.name,NAME_CURRENT_COMP);
global_geometry_element.activation_counter = number_of_activations;
global_geometry_element.component_index = INDEX_CURRENT_COMP;
global_geometry_element.Volume = &this_box_volume; // Would be nicer if this m was a pointer, now we have the (small) data two places
add_element_to_geometry_list(&global_geometry_list,global_geometry_element);
}
#line 209828 "MACS_sample_kidney_box.c"
#undef number_of_activations
#undef mask_setting
#undef mask_string
#undef p_interact
#undef focus_r
#undef focus_xh
#undef focus_xw
#undef focus_ah
#undef focus_aw
#undef target_z
#undef target_y
#undef target_x
#undef target_index
#undef visualize
#undef yheight2
#undef xwidth2
#undef zdepth
#undef yheight
#undef xwidth
#undef priority
#undef material_string
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

  /* Initializations for component channel_5_analyzer_1_array_crystal_array_1. */
  SIG_MESSAGE("channel_5_analyzer_1_array_crystal_array_1 (Init)");
#define mccompcurname  channel_5_analyzer_1_array_crystal_array_1
#define mccompcurtype  Union_box
#define mccompcurindex 321
#define loop_index mccchannel_5_analyzer_1_array_crystal_array_1_loop_index
#define this_box_volume mccchannel_5_analyzer_1_array_crystal_array_1_this_box_volume
#define global_geometry_element mccchannel_5_analyzer_1_array_crystal_array_1_global_geometry_element
#define this_box_storage mccchannel_5_analyzer_1_array_crystal_array_1_this_box_storage
#define material_string mccchannel_5_analyzer_1_array_crystal_array_1_material_string
#define priority mccchannel_5_analyzer_1_array_crystal_array_1_priority
#define xwidth mccchannel_5_analyzer_1_array_crystal_array_1_xwidth
#define yheight mccchannel_5_analyzer_1_array_crystal_array_1_yheight
#define zdepth mccchannel_5_analyzer_1_array_crystal_array_1_zdepth
#define xwidth2 mccchannel_5_analyzer_1_array_crystal_array_1_xwidth2
#define yheight2 mccchannel_5_analyzer_1_array_crystal_array_1_yheight2
#define visualize mccchannel_5_analyzer_1_array_crystal_array_1_visualize
#define target_index mccchannel_5_analyzer_1_array_crystal_array_1_target_index
#define target_x mccchannel_5_analyzer_1_array_crystal_array_1_target_x
#define target_y mccchannel_5_analyzer_1_array_crystal_array_1_target_y
#define target_z mccchannel_5_analyzer_1_array_crystal_array_1_target_z
#define focus_aw mccchannel_5_analyzer_1_array_crystal_array_1_focus_aw
#define focus_ah mccchannel_5_analyzer_1_array_crystal_array_1_focus_ah
#define focus_xw mccchannel_5_analyzer_1_array_crystal_array_1_focus_xw
#define focus_xh mccchannel_5_analyzer_1_array_crystal_array_1_focus_xh
#define focus_r mccchannel_5_analyzer_1_array_crystal_array_1_focus_r
#define p_interact mccchannel_5_analyzer_1_array_crystal_array_1_p_interact
#define mask_string mccchannel_5_analyzer_1_array_crystal_array_1_mask_string
#define mask_setting mccchannel_5_analyzer_1_array_crystal_array_1_mask_setting
#define number_of_activations mccchannel_5_analyzer_1_array_crystal_array_1_number_of_activations
#line 224 "Union_box.comp"
{
// Initializes the focusing system for this volume including input sanitation.
focus_initialize(&this_box_volume.geometry, POS_A_COMP_INDEX(INDEX_CURRENT_COMP+target_index), POS_A_CURRENT_COMP, ROT_A_CURRENT_COMP, target_index, target_x, target_y, target_z, focus_aw, focus_ah, focus_xw, focus_xh, focus_r, NAME_CURRENT_COMP);

// Input sanitation for this geometry
if (xwidth <= 0) {
  printf("\nERROR in Union_box named %s, the xwidth is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (yheight <= 0) {
  printf("\nERROR in Union_box named %s, yheight is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (zdepth <= 0) {
  printf("\nERROR in Union_box named %s, zdepth is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (xwidth2 <= 0 && xwidth2 != -1) {
  printf("\nERROR in Union_box named %s, the xwidth2 is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (yheight2 <= 0 && yheight2 != -1) {
  printf("\nERROR in Union_box named %s, yheight2 is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}

// Use sanitation
if (global_material_list.num_elements == 0) {
  printf("\nERROR: Need to define a material using Union_make_material before using a Union geometry component. \n");
  printf("       %s was defined before first use of Union_make_material.\n",NAME_CURRENT_COMP);
  exit(1);
}

this_box_volume.geometry.is_masked_volume = 0;
this_box_volume.geometry.is_exit_volume = 0;
this_box_volume.geometry.is_mask_volume = 0;
// check if the volume is a mask, if it is the material string is irelevant.
if (mask_string && strlen(mask_string) && strcmp(mask_string, "NULL") && strcmp(mask_string, "0")) {
    // A mask volume is used to limit the extend of other volumes, called the masked volumes. These are specified in the mask_string.
    // In order for a ray to enter a masked volume, it needs to be both in the region covered by that volume AND the mask volume.
    // When more than
    this_box_volume.geometry.mask_mode = 1; // Default is mask mode is ALL
    if (mask_setting && strlen(mask_setting) && strcmp(mask_setting, "NULL") && strcmp(mask_setting, "0")) {
        if (strcmp(mask_setting,"ALL") == 0 || strcmp(mask_setting,"All") == 0) this_box_volume.geometry.mask_mode = 1;
        else if (strcmp(mask_setting,"ANY") == 0 || strcmp(mask_setting,"Any") == 0) this_box_volume.geometry.mask_mode = 2;
        else {
            printf("The mask_mode of component %s is set to %s, but must be either ALL or ANY.\n",NAME_CURRENT_COMP,mask_setting);
            exit(1);
        }
    }
    
    for (loop_index=0;loop_index<global_geometry_list.num_elements;loop_index++) {
        // Add mask list
        if (1 == manual_linking_function(global_geometry_list.elements[loop_index].name,mask_string)) {
            add_element_to_int_list(&this_box_volume.geometry.mask_list,global_geometry_list.elements[loop_index].component_index);
            add_element_to_int_list(&global_geometry_list.elements[loop_index].Volume->geometry.masked_by_list,INDEX_CURRENT_COMP);
            global_geometry_list.elements[loop_index].Volume->geometry.is_masked_volume = 1;
            if (this_box_volume.geometry.mask_mode == 2)
                global_geometry_list.elements[loop_index].Volume->geometry.mask_mode = 2;
            if (this_box_volume.geometry.mask_mode == 1) {
                if (global_geometry_list.elements[loop_index].Volume->geometry.is_masked_volume == 1 && global_geometry_list.elements[loop_index].Volume->geometry.mask_mode != 2)
                    // If more than one mask is added to one volume, the ANY mode overwrites the (default) ALL mode.
                    global_geometry_list.elements[loop_index].Volume->geometry.mask_mode = 1;
            }
            
            found_geometries = 1;
        }
    }
    if (found_geometries == 0) {
        printf("The mask_string in geometry: %s did not find any of the specified volumes in the mask_string %s \n",NAME_CURRENT_COMP,mask_string);
        exit(1);
    }
    this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
    this_box_volume.p_physics->is_vacuum = 0; // Makes this volume a vacuum
    this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
    this_box_volume.p_physics->my_a = 0; // Should not be used.
    sprintf(this_box_volume.p_physics->name,"Mask");
    this_box_volume.geometry.is_mask_volume = 1;
    
    
// Read the material input, or if it lacks, use automatic linking.
} else if (material_string && strlen(material_string) && strcmp(material_string, "NULL") && strcmp(material_string, "0")) {
    // A geometry string was given, use it to determine which material
    if (0 == strcmp(material_string,"vacuum") || 0 == strcmp(material_string,"Vacuum")) {
        // One could have a global physics struct for vacuum instead of creating one for each
        this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
        this_box_volume.p_physics->is_vacuum = 1; // Makes this volume a vacuum
        this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
        this_box_volume.p_physics->my_a = 0; // Should not be used.
        sprintf(this_box_volume.p_physics->name,"Vacuum");
    } else if (0 == strcmp(material_string,"exit") || 0 == strcmp(material_string,"Exit")) {
        // One could have a global physics struct for vacuum instead of creating one for each
        this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
        this_box_volume.p_physics->is_vacuum = 1; // Makes this volume a vacuum
        this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
        this_box_volume.p_physics->my_a = 0; // Should not be used.
        this_box_volume.geometry.is_exit_volume = 1;
        sprintf(this_box_volume.p_physics->name,"Exit");
    } else {
        #ifndef MATERIAL_DETECTOR
            printf("Need to define a material before refering to it in a geometry %s.\n",NAME_CURRENT_COMP);
            exit(1);
        #endif
        for (loop_index=0;loop_index<global_material_list.num_elements;loop_index++) {
            if (0 == strcmp(material_string,global_material_list.elements[loop_index].name)) {
                this_box_volume.p_physics = global_material_list.elements[loop_index].physics;
                break;
            }
            if (loop_index == global_material_list.num_elements-1) {
            printf("\n");
            printf("ERROR: The material string \"%s\" in Union geometry \"%s\" did not match a specified material. \n",material_string,NAME_CURRENT_COMP);
            printf("       The materials available at this point (need to be defined before the geometry): \n");
            for (loop_index=0;loop_index<global_material_list.num_elements;loop_index++)
              printf("         %s\n",global_material_list.elements[loop_index].name);
            printf("\n");
            printf("       It is also possible to use one of the defualt materials avaiable: \n");
            printf("           Vacuum (for a Volume without scattering or absorption)\n");
            printf("           Exit (for a Volume where the ray exits the component if it enters)\n");
            printf("           Mask (for a Volume that masks existing volumes specified in the mask_string\n");
            exit(1);
          }
        }
    }
} else {
    // Automatic linking, simply using the last defined material.
    #ifndef MATERIAL_DETECTOR
        printf("Need to define a material before the geometry to use automatic linking %s.\n",NAME_CURRENT_COMP);
        exit(1);
    #endif
    this_box_volume.p_physics = global_material_list.elements[global_material_list.num_elements-1].physics;
}

sprintf(this_box_volume.name,NAME_CURRENT_COMP);
sprintf(this_box_volume.geometry.shape,"box");
this_box_volume.geometry.priority_value = priority;
this_box_volume.geometry.geometry_p_interact = p_interact;
// Currently the coordinates will be in absolute space.
this_box_volume.geometry.center = POS_A_CURRENT_COMP;

this_box_storage.z_depth = zdepth;
this_box_storage.x_width1 = xwidth;
this_box_storage.y_height1 = yheight;

this_box_storage.is_rectangle = 0;
if (xwidth2 < 0 && yheight2 < 0) this_box_storage.is_rectangle = 1;
if (xwidth == xwidth2 && yheight == yheight2) this_box_storage.is_rectangle = 1;

if (xwidth2 < 0) {
    this_box_storage.x_width2 = xwidth;
    xwidth2 = xwidth;
} else this_box_storage.x_width2 = xwidth2;

if (yheight2 < 0) {
    this_box_storage.y_height2 = yheight;
    yheight2 = yheight;
} else this_box_storage.y_height2 = yheight2;


this_box_storage.normal_vectors[0] = coords_set(0,0,1);
this_box_storage.normal_vectors[1] = coords_set(0,0,1);

// for sides with y component = 0
x_component = 2*zdepth/sqrt((xwidth-xwidth2)*(xwidth-xwidth2)+4*zdepth*zdepth);
z_component = (xwidth-xwidth2)/sqrt(4*zdepth*zdepth+(xwidth-xwidth2)*(xwidth-xwidth2));

this_box_storage.normal_vectors[2] = coords_set(x_component,0,z_component);
this_box_storage.normal_vectors[3] = coords_set(-x_component,0,z_component);

// for sides with x component = 0
y_component = 2*zdepth/sqrt((yheight-yheight2)*(yheight-yheight2)+4*zdepth*zdepth);
z_component = (yheight-yheight2)/sqrt(4*zdepth*zdepth+(yheight-yheight2)*(yheight-yheight2));

this_box_storage.normal_vectors[4] = coords_set(0,y_component,z_component);
this_box_storage.normal_vectors[5] = coords_set(0,-y_component,z_component);

this_box_volume.geometry.visualization_on = visualize;

this_box_volume.geometry.geometry_parameters.p_box_storage = &this_box_storage;

// Assign pointers to functions for intersection with the shape, checking if a point is inside the shape
if (this_box_storage.is_rectangle == 1) {
this_box_volume.geometry.intersect_function = &sample_box_intersect_simple;
this_box_volume.geometry.within_function = &r_within_box_simple;
}
else {
this_box_volume.geometry.intersect_function = &sample_box_intersect_advanced;
this_box_volume.geometry.within_function = &r_within_box_advanced;
}

this_box_volume.geometry.shell_points = &box_shell_points;
this_box_volume.geometry.mcdisplay_function = &mcdisplay_box_function;
this_box_volume.geometry.initialize_from_main_function = &initialize_box_geometry_from_main_component;
this_box_volume.geometry.process_rot_allocated = 0;

this_box_volume.geometry.copy_geometry_parameters = &allocate_box_storage_copy;

rot_copy(this_box_volume.geometry.rotation_matrix,ROT_A_CURRENT_COMP); //check how ROT_R_CURRENT_COMP would work
rot_transpose(ROT_A_CURRENT_COMP,this_box_volume.geometry.transpose_rotation_matrix);

// Initialize loggers
this_box_volume.loggers.num_elements = 0;

// packing the information into the global_geometry_element, which is then included in the global_geometry_list.
sprintf(global_geometry_element.name,NAME_CURRENT_COMP);
global_geometry_element.activation_counter = number_of_activations;
global_geometry_element.component_index = INDEX_CURRENT_COMP;
global_geometry_element.Volume = &this_box_volume; // Would be nicer if this m was a pointer, now we have the (small) data two places
add_element_to_geometry_list(&global_geometry_list,global_geometry_element);
}
#line 210098 "MACS_sample_kidney_box.c"
#undef number_of_activations
#undef mask_setting
#undef mask_string
#undef p_interact
#undef focus_r
#undef focus_xh
#undef focus_xw
#undef focus_ah
#undef focus_aw
#undef target_z
#undef target_y
#undef target_x
#undef target_index
#undef visualize
#undef yheight2
#undef xwidth2
#undef zdepth
#undef yheight
#undef xwidth
#undef priority
#undef material_string
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

  /* Initializations for component channel_5_analyzer_1_array_crystal_array_2. */
  SIG_MESSAGE("channel_5_analyzer_1_array_crystal_array_2 (Init)");
#define mccompcurname  channel_5_analyzer_1_array_crystal_array_2
#define mccompcurtype  Union_box
#define mccompcurindex 322
#define loop_index mccchannel_5_analyzer_1_array_crystal_array_2_loop_index
#define this_box_volume mccchannel_5_analyzer_1_array_crystal_array_2_this_box_volume
#define global_geometry_element mccchannel_5_analyzer_1_array_crystal_array_2_global_geometry_element
#define this_box_storage mccchannel_5_analyzer_1_array_crystal_array_2_this_box_storage
#define material_string mccchannel_5_analyzer_1_array_crystal_array_2_material_string
#define priority mccchannel_5_analyzer_1_array_crystal_array_2_priority
#define xwidth mccchannel_5_analyzer_1_array_crystal_array_2_xwidth
#define yheight mccchannel_5_analyzer_1_array_crystal_array_2_yheight
#define zdepth mccchannel_5_analyzer_1_array_crystal_array_2_zdepth
#define xwidth2 mccchannel_5_analyzer_1_array_crystal_array_2_xwidth2
#define yheight2 mccchannel_5_analyzer_1_array_crystal_array_2_yheight2
#define visualize mccchannel_5_analyzer_1_array_crystal_array_2_visualize
#define target_index mccchannel_5_analyzer_1_array_crystal_array_2_target_index
#define target_x mccchannel_5_analyzer_1_array_crystal_array_2_target_x
#define target_y mccchannel_5_analyzer_1_array_crystal_array_2_target_y
#define target_z mccchannel_5_analyzer_1_array_crystal_array_2_target_z
#define focus_aw mccchannel_5_analyzer_1_array_crystal_array_2_focus_aw
#define focus_ah mccchannel_5_analyzer_1_array_crystal_array_2_focus_ah
#define focus_xw mccchannel_5_analyzer_1_array_crystal_array_2_focus_xw
#define focus_xh mccchannel_5_analyzer_1_array_crystal_array_2_focus_xh
#define focus_r mccchannel_5_analyzer_1_array_crystal_array_2_focus_r
#define p_interact mccchannel_5_analyzer_1_array_crystal_array_2_p_interact
#define mask_string mccchannel_5_analyzer_1_array_crystal_array_2_mask_string
#define mask_setting mccchannel_5_analyzer_1_array_crystal_array_2_mask_setting
#define number_of_activations mccchannel_5_analyzer_1_array_crystal_array_2_number_of_activations
#line 224 "Union_box.comp"
{
// Initializes the focusing system for this volume including input sanitation.
focus_initialize(&this_box_volume.geometry, POS_A_COMP_INDEX(INDEX_CURRENT_COMP+target_index), POS_A_CURRENT_COMP, ROT_A_CURRENT_COMP, target_index, target_x, target_y, target_z, focus_aw, focus_ah, focus_xw, focus_xh, focus_r, NAME_CURRENT_COMP);

// Input sanitation for this geometry
if (xwidth <= 0) {
  printf("\nERROR in Union_box named %s, the xwidth is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (yheight <= 0) {
  printf("\nERROR in Union_box named %s, yheight is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (zdepth <= 0) {
  printf("\nERROR in Union_box named %s, zdepth is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (xwidth2 <= 0 && xwidth2 != -1) {
  printf("\nERROR in Union_box named %s, the xwidth2 is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (yheight2 <= 0 && yheight2 != -1) {
  printf("\nERROR in Union_box named %s, yheight2 is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}

// Use sanitation
if (global_material_list.num_elements == 0) {
  printf("\nERROR: Need to define a material using Union_make_material before using a Union geometry component. \n");
  printf("       %s was defined before first use of Union_make_material.\n",NAME_CURRENT_COMP);
  exit(1);
}

this_box_volume.geometry.is_masked_volume = 0;
this_box_volume.geometry.is_exit_volume = 0;
this_box_volume.geometry.is_mask_volume = 0;
// check if the volume is a mask, if it is the material string is irelevant.
if (mask_string && strlen(mask_string) && strcmp(mask_string, "NULL") && strcmp(mask_string, "0")) {
    // A mask volume is used to limit the extend of other volumes, called the masked volumes. These are specified in the mask_string.
    // In order for a ray to enter a masked volume, it needs to be both in the region covered by that volume AND the mask volume.
    // When more than
    this_box_volume.geometry.mask_mode = 1; // Default is mask mode is ALL
    if (mask_setting && strlen(mask_setting) && strcmp(mask_setting, "NULL") && strcmp(mask_setting, "0")) {
        if (strcmp(mask_setting,"ALL") == 0 || strcmp(mask_setting,"All") == 0) this_box_volume.geometry.mask_mode = 1;
        else if (strcmp(mask_setting,"ANY") == 0 || strcmp(mask_setting,"Any") == 0) this_box_volume.geometry.mask_mode = 2;
        else {
            printf("The mask_mode of component %s is set to %s, but must be either ALL or ANY.\n",NAME_CURRENT_COMP,mask_setting);
            exit(1);
        }
    }
    
    for (loop_index=0;loop_index<global_geometry_list.num_elements;loop_index++) {
        // Add mask list
        if (1 == manual_linking_function(global_geometry_list.elements[loop_index].name,mask_string)) {
            add_element_to_int_list(&this_box_volume.geometry.mask_list,global_geometry_list.elements[loop_index].component_index);
            add_element_to_int_list(&global_geometry_list.elements[loop_index].Volume->geometry.masked_by_list,INDEX_CURRENT_COMP);
            global_geometry_list.elements[loop_index].Volume->geometry.is_masked_volume = 1;
            if (this_box_volume.geometry.mask_mode == 2)
                global_geometry_list.elements[loop_index].Volume->geometry.mask_mode = 2;
            if (this_box_volume.geometry.mask_mode == 1) {
                if (global_geometry_list.elements[loop_index].Volume->geometry.is_masked_volume == 1 && global_geometry_list.elements[loop_index].Volume->geometry.mask_mode != 2)
                    // If more than one mask is added to one volume, the ANY mode overwrites the (default) ALL mode.
                    global_geometry_list.elements[loop_index].Volume->geometry.mask_mode = 1;
            }
            
            found_geometries = 1;
        }
    }
    if (found_geometries == 0) {
        printf("The mask_string in geometry: %s did not find any of the specified volumes in the mask_string %s \n",NAME_CURRENT_COMP,mask_string);
        exit(1);
    }
    this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
    this_box_volume.p_physics->is_vacuum = 0; // Makes this volume a vacuum
    this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
    this_box_volume.p_physics->my_a = 0; // Should not be used.
    sprintf(this_box_volume.p_physics->name,"Mask");
    this_box_volume.geometry.is_mask_volume = 1;
    
    
// Read the material input, or if it lacks, use automatic linking.
} else if (material_string && strlen(material_string) && strcmp(material_string, "NULL") && strcmp(material_string, "0")) {
    // A geometry string was given, use it to determine which material
    if (0 == strcmp(material_string,"vacuum") || 0 == strcmp(material_string,"Vacuum")) {
        // One could have a global physics struct for vacuum instead of creating one for each
        this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
        this_box_volume.p_physics->is_vacuum = 1; // Makes this volume a vacuum
        this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
        this_box_volume.p_physics->my_a = 0; // Should not be used.
        sprintf(this_box_volume.p_physics->name,"Vacuum");
    } else if (0 == strcmp(material_string,"exit") || 0 == strcmp(material_string,"Exit")) {
        // One could have a global physics struct for vacuum instead of creating one for each
        this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
        this_box_volume.p_physics->is_vacuum = 1; // Makes this volume a vacuum
        this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
        this_box_volume.p_physics->my_a = 0; // Should not be used.
        this_box_volume.geometry.is_exit_volume = 1;
        sprintf(this_box_volume.p_physics->name,"Exit");
    } else {
        #ifndef MATERIAL_DETECTOR
            printf("Need to define a material before refering to it in a geometry %s.\n",NAME_CURRENT_COMP);
            exit(1);
        #endif
        for (loop_index=0;loop_index<global_material_list.num_elements;loop_index++) {
            if (0 == strcmp(material_string,global_material_list.elements[loop_index].name)) {
                this_box_volume.p_physics = global_material_list.elements[loop_index].physics;
                break;
            }
            if (loop_index == global_material_list.num_elements-1) {
            printf("\n");
            printf("ERROR: The material string \"%s\" in Union geometry \"%s\" did not match a specified material. \n",material_string,NAME_CURRENT_COMP);
            printf("       The materials available at this point (need to be defined before the geometry): \n");
            for (loop_index=0;loop_index<global_material_list.num_elements;loop_index++)
              printf("         %s\n",global_material_list.elements[loop_index].name);
            printf("\n");
            printf("       It is also possible to use one of the defualt materials avaiable: \n");
            printf("           Vacuum (for a Volume without scattering or absorption)\n");
            printf("           Exit (for a Volume where the ray exits the component if it enters)\n");
            printf("           Mask (for a Volume that masks existing volumes specified in the mask_string\n");
            exit(1);
          }
        }
    }
} else {
    // Automatic linking, simply using the last defined material.
    #ifndef MATERIAL_DETECTOR
        printf("Need to define a material before the geometry to use automatic linking %s.\n",NAME_CURRENT_COMP);
        exit(1);
    #endif
    this_box_volume.p_physics = global_material_list.elements[global_material_list.num_elements-1].physics;
}

sprintf(this_box_volume.name,NAME_CURRENT_COMP);
sprintf(this_box_volume.geometry.shape,"box");
this_box_volume.geometry.priority_value = priority;
this_box_volume.geometry.geometry_p_interact = p_interact;
// Currently the coordinates will be in absolute space.
this_box_volume.geometry.center = POS_A_CURRENT_COMP;

this_box_storage.z_depth = zdepth;
this_box_storage.x_width1 = xwidth;
this_box_storage.y_height1 = yheight;

this_box_storage.is_rectangle = 0;
if (xwidth2 < 0 && yheight2 < 0) this_box_storage.is_rectangle = 1;
if (xwidth == xwidth2 && yheight == yheight2) this_box_storage.is_rectangle = 1;

if (xwidth2 < 0) {
    this_box_storage.x_width2 = xwidth;
    xwidth2 = xwidth;
} else this_box_storage.x_width2 = xwidth2;

if (yheight2 < 0) {
    this_box_storage.y_height2 = yheight;
    yheight2 = yheight;
} else this_box_storage.y_height2 = yheight2;


this_box_storage.normal_vectors[0] = coords_set(0,0,1);
this_box_storage.normal_vectors[1] = coords_set(0,0,1);

// for sides with y component = 0
x_component = 2*zdepth/sqrt((xwidth-xwidth2)*(xwidth-xwidth2)+4*zdepth*zdepth);
z_component = (xwidth-xwidth2)/sqrt(4*zdepth*zdepth+(xwidth-xwidth2)*(xwidth-xwidth2));

this_box_storage.normal_vectors[2] = coords_set(x_component,0,z_component);
this_box_storage.normal_vectors[3] = coords_set(-x_component,0,z_component);

// for sides with x component = 0
y_component = 2*zdepth/sqrt((yheight-yheight2)*(yheight-yheight2)+4*zdepth*zdepth);
z_component = (yheight-yheight2)/sqrt(4*zdepth*zdepth+(yheight-yheight2)*(yheight-yheight2));

this_box_storage.normal_vectors[4] = coords_set(0,y_component,z_component);
this_box_storage.normal_vectors[5] = coords_set(0,-y_component,z_component);

this_box_volume.geometry.visualization_on = visualize;

this_box_volume.geometry.geometry_parameters.p_box_storage = &this_box_storage;

// Assign pointers to functions for intersection with the shape, checking if a point is inside the shape
if (this_box_storage.is_rectangle == 1) {
this_box_volume.geometry.intersect_function = &sample_box_intersect_simple;
this_box_volume.geometry.within_function = &r_within_box_simple;
}
else {
this_box_volume.geometry.intersect_function = &sample_box_intersect_advanced;
this_box_volume.geometry.within_function = &r_within_box_advanced;
}

this_box_volume.geometry.shell_points = &box_shell_points;
this_box_volume.geometry.mcdisplay_function = &mcdisplay_box_function;
this_box_volume.geometry.initialize_from_main_function = &initialize_box_geometry_from_main_component;
this_box_volume.geometry.process_rot_allocated = 0;

this_box_volume.geometry.copy_geometry_parameters = &allocate_box_storage_copy;

rot_copy(this_box_volume.geometry.rotation_matrix,ROT_A_CURRENT_COMP); //check how ROT_R_CURRENT_COMP would work
rot_transpose(ROT_A_CURRENT_COMP,this_box_volume.geometry.transpose_rotation_matrix);

// Initialize loggers
this_box_volume.loggers.num_elements = 0;

// packing the information into the global_geometry_element, which is then included in the global_geometry_list.
sprintf(global_geometry_element.name,NAME_CURRENT_COMP);
global_geometry_element.activation_counter = number_of_activations;
global_geometry_element.component_index = INDEX_CURRENT_COMP;
global_geometry_element.Volume = &this_box_volume; // Would be nicer if this m was a pointer, now we have the (small) data two places
add_element_to_geometry_list(&global_geometry_list,global_geometry_element);
}
#line 210368 "MACS_sample_kidney_box.c"
#undef number_of_activations
#undef mask_setting
#undef mask_string
#undef p_interact
#undef focus_r
#undef focus_xh
#undef focus_xw
#undef focus_ah
#undef focus_aw
#undef target_z
#undef target_y
#undef target_x
#undef target_index
#undef visualize
#undef yheight2
#undef xwidth2
#undef zdepth
#undef yheight
#undef xwidth
#undef priority
#undef material_string
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

  /* Initializations for component channel_5_analyzer_1_array_crystal_array_3. */
  SIG_MESSAGE("channel_5_analyzer_1_array_crystal_array_3 (Init)");
#define mccompcurname  channel_5_analyzer_1_array_crystal_array_3
#define mccompcurtype  Union_box
#define mccompcurindex 323
#define loop_index mccchannel_5_analyzer_1_array_crystal_array_3_loop_index
#define this_box_volume mccchannel_5_analyzer_1_array_crystal_array_3_this_box_volume
#define global_geometry_element mccchannel_5_analyzer_1_array_crystal_array_3_global_geometry_element
#define this_box_storage mccchannel_5_analyzer_1_array_crystal_array_3_this_box_storage
#define material_string mccchannel_5_analyzer_1_array_crystal_array_3_material_string
#define priority mccchannel_5_analyzer_1_array_crystal_array_3_priority
#define xwidth mccchannel_5_analyzer_1_array_crystal_array_3_xwidth
#define yheight mccchannel_5_analyzer_1_array_crystal_array_3_yheight
#define zdepth mccchannel_5_analyzer_1_array_crystal_array_3_zdepth
#define xwidth2 mccchannel_5_analyzer_1_array_crystal_array_3_xwidth2
#define yheight2 mccchannel_5_analyzer_1_array_crystal_array_3_yheight2
#define visualize mccchannel_5_analyzer_1_array_crystal_array_3_visualize
#define target_index mccchannel_5_analyzer_1_array_crystal_array_3_target_index
#define target_x mccchannel_5_analyzer_1_array_crystal_array_3_target_x
#define target_y mccchannel_5_analyzer_1_array_crystal_array_3_target_y
#define target_z mccchannel_5_analyzer_1_array_crystal_array_3_target_z
#define focus_aw mccchannel_5_analyzer_1_array_crystal_array_3_focus_aw
#define focus_ah mccchannel_5_analyzer_1_array_crystal_array_3_focus_ah
#define focus_xw mccchannel_5_analyzer_1_array_crystal_array_3_focus_xw
#define focus_xh mccchannel_5_analyzer_1_array_crystal_array_3_focus_xh
#define focus_r mccchannel_5_analyzer_1_array_crystal_array_3_focus_r
#define p_interact mccchannel_5_analyzer_1_array_crystal_array_3_p_interact
#define mask_string mccchannel_5_analyzer_1_array_crystal_array_3_mask_string
#define mask_setting mccchannel_5_analyzer_1_array_crystal_array_3_mask_setting
#define number_of_activations mccchannel_5_analyzer_1_array_crystal_array_3_number_of_activations
#line 224 "Union_box.comp"
{
// Initializes the focusing system for this volume including input sanitation.
focus_initialize(&this_box_volume.geometry, POS_A_COMP_INDEX(INDEX_CURRENT_COMP+target_index), POS_A_CURRENT_COMP, ROT_A_CURRENT_COMP, target_index, target_x, target_y, target_z, focus_aw, focus_ah, focus_xw, focus_xh, focus_r, NAME_CURRENT_COMP);

// Input sanitation for this geometry
if (xwidth <= 0) {
  printf("\nERROR in Union_box named %s, the xwidth is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (yheight <= 0) {
  printf("\nERROR in Union_box named %s, yheight is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (zdepth <= 0) {
  printf("\nERROR in Union_box named %s, zdepth is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (xwidth2 <= 0 && xwidth2 != -1) {
  printf("\nERROR in Union_box named %s, the xwidth2 is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (yheight2 <= 0 && yheight2 != -1) {
  printf("\nERROR in Union_box named %s, yheight2 is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}

// Use sanitation
if (global_material_list.num_elements == 0) {
  printf("\nERROR: Need to define a material using Union_make_material before using a Union geometry component. \n");
  printf("       %s was defined before first use of Union_make_material.\n",NAME_CURRENT_COMP);
  exit(1);
}

this_box_volume.geometry.is_masked_volume = 0;
this_box_volume.geometry.is_exit_volume = 0;
this_box_volume.geometry.is_mask_volume = 0;
// check if the volume is a mask, if it is the material string is irelevant.
if (mask_string && strlen(mask_string) && strcmp(mask_string, "NULL") && strcmp(mask_string, "0")) {
    // A mask volume is used to limit the extend of other volumes, called the masked volumes. These are specified in the mask_string.
    // In order for a ray to enter a masked volume, it needs to be both in the region covered by that volume AND the mask volume.
    // When more than
    this_box_volume.geometry.mask_mode = 1; // Default is mask mode is ALL
    if (mask_setting && strlen(mask_setting) && strcmp(mask_setting, "NULL") && strcmp(mask_setting, "0")) {
        if (strcmp(mask_setting,"ALL") == 0 || strcmp(mask_setting,"All") == 0) this_box_volume.geometry.mask_mode = 1;
        else if (strcmp(mask_setting,"ANY") == 0 || strcmp(mask_setting,"Any") == 0) this_box_volume.geometry.mask_mode = 2;
        else {
            printf("The mask_mode of component %s is set to %s, but must be either ALL or ANY.\n",NAME_CURRENT_COMP,mask_setting);
            exit(1);
        }
    }
    
    for (loop_index=0;loop_index<global_geometry_list.num_elements;loop_index++) {
        // Add mask list
        if (1 == manual_linking_function(global_geometry_list.elements[loop_index].name,mask_string)) {
            add_element_to_int_list(&this_box_volume.geometry.mask_list,global_geometry_list.elements[loop_index].component_index);
            add_element_to_int_list(&global_geometry_list.elements[loop_index].Volume->geometry.masked_by_list,INDEX_CURRENT_COMP);
            global_geometry_list.elements[loop_index].Volume->geometry.is_masked_volume = 1;
            if (this_box_volume.geometry.mask_mode == 2)
                global_geometry_list.elements[loop_index].Volume->geometry.mask_mode = 2;
            if (this_box_volume.geometry.mask_mode == 1) {
                if (global_geometry_list.elements[loop_index].Volume->geometry.is_masked_volume == 1 && global_geometry_list.elements[loop_index].Volume->geometry.mask_mode != 2)
                    // If more than one mask is added to one volume, the ANY mode overwrites the (default) ALL mode.
                    global_geometry_list.elements[loop_index].Volume->geometry.mask_mode = 1;
            }
            
            found_geometries = 1;
        }
    }
    if (found_geometries == 0) {
        printf("The mask_string in geometry: %s did not find any of the specified volumes in the mask_string %s \n",NAME_CURRENT_COMP,mask_string);
        exit(1);
    }
    this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
    this_box_volume.p_physics->is_vacuum = 0; // Makes this volume a vacuum
    this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
    this_box_volume.p_physics->my_a = 0; // Should not be used.
    sprintf(this_box_volume.p_physics->name,"Mask");
    this_box_volume.geometry.is_mask_volume = 1;
    
    
// Read the material input, or if it lacks, use automatic linking.
} else if (material_string && strlen(material_string) && strcmp(material_string, "NULL") && strcmp(material_string, "0")) {
    // A geometry string was given, use it to determine which material
    if (0 == strcmp(material_string,"vacuum") || 0 == strcmp(material_string,"Vacuum")) {
        // One could have a global physics struct for vacuum instead of creating one for each
        this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
        this_box_volume.p_physics->is_vacuum = 1; // Makes this volume a vacuum
        this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
        this_box_volume.p_physics->my_a = 0; // Should not be used.
        sprintf(this_box_volume.p_physics->name,"Vacuum");
    } else if (0 == strcmp(material_string,"exit") || 0 == strcmp(material_string,"Exit")) {
        // One could have a global physics struct for vacuum instead of creating one for each
        this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
        this_box_volume.p_physics->is_vacuum = 1; // Makes this volume a vacuum
        this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
        this_box_volume.p_physics->my_a = 0; // Should not be used.
        this_box_volume.geometry.is_exit_volume = 1;
        sprintf(this_box_volume.p_physics->name,"Exit");
    } else {
        #ifndef MATERIAL_DETECTOR
            printf("Need to define a material before refering to it in a geometry %s.\n",NAME_CURRENT_COMP);
            exit(1);
        #endif
        for (loop_index=0;loop_index<global_material_list.num_elements;loop_index++) {
            if (0 == strcmp(material_string,global_material_list.elements[loop_index].name)) {
                this_box_volume.p_physics = global_material_list.elements[loop_index].physics;
                break;
            }
            if (loop_index == global_material_list.num_elements-1) {
            printf("\n");
            printf("ERROR: The material string \"%s\" in Union geometry \"%s\" did not match a specified material. \n",material_string,NAME_CURRENT_COMP);
            printf("       The materials available at this point (need to be defined before the geometry): \n");
            for (loop_index=0;loop_index<global_material_list.num_elements;loop_index++)
              printf("         %s\n",global_material_list.elements[loop_index].name);
            printf("\n");
            printf("       It is also possible to use one of the defualt materials avaiable: \n");
            printf("           Vacuum (for a Volume without scattering or absorption)\n");
            printf("           Exit (for a Volume where the ray exits the component if it enters)\n");
            printf("           Mask (for a Volume that masks existing volumes specified in the mask_string\n");
            exit(1);
          }
        }
    }
} else {
    // Automatic linking, simply using the last defined material.
    #ifndef MATERIAL_DETECTOR
        printf("Need to define a material before the geometry to use automatic linking %s.\n",NAME_CURRENT_COMP);
        exit(1);
    #endif
    this_box_volume.p_physics = global_material_list.elements[global_material_list.num_elements-1].physics;
}

sprintf(this_box_volume.name,NAME_CURRENT_COMP);
sprintf(this_box_volume.geometry.shape,"box");
this_box_volume.geometry.priority_value = priority;
this_box_volume.geometry.geometry_p_interact = p_interact;
// Currently the coordinates will be in absolute space.
this_box_volume.geometry.center = POS_A_CURRENT_COMP;

this_box_storage.z_depth = zdepth;
this_box_storage.x_width1 = xwidth;
this_box_storage.y_height1 = yheight;

this_box_storage.is_rectangle = 0;
if (xwidth2 < 0 && yheight2 < 0) this_box_storage.is_rectangle = 1;
if (xwidth == xwidth2 && yheight == yheight2) this_box_storage.is_rectangle = 1;

if (xwidth2 < 0) {
    this_box_storage.x_width2 = xwidth;
    xwidth2 = xwidth;
} else this_box_storage.x_width2 = xwidth2;

if (yheight2 < 0) {
    this_box_storage.y_height2 = yheight;
    yheight2 = yheight;
} else this_box_storage.y_height2 = yheight2;


this_box_storage.normal_vectors[0] = coords_set(0,0,1);
this_box_storage.normal_vectors[1] = coords_set(0,0,1);

// for sides with y component = 0
x_component = 2*zdepth/sqrt((xwidth-xwidth2)*(xwidth-xwidth2)+4*zdepth*zdepth);
z_component = (xwidth-xwidth2)/sqrt(4*zdepth*zdepth+(xwidth-xwidth2)*(xwidth-xwidth2));

this_box_storage.normal_vectors[2] = coords_set(x_component,0,z_component);
this_box_storage.normal_vectors[3] = coords_set(-x_component,0,z_component);

// for sides with x component = 0
y_component = 2*zdepth/sqrt((yheight-yheight2)*(yheight-yheight2)+4*zdepth*zdepth);
z_component = (yheight-yheight2)/sqrt(4*zdepth*zdepth+(yheight-yheight2)*(yheight-yheight2));

this_box_storage.normal_vectors[4] = coords_set(0,y_component,z_component);
this_box_storage.normal_vectors[5] = coords_set(0,-y_component,z_component);

this_box_volume.geometry.visualization_on = visualize;

this_box_volume.geometry.geometry_parameters.p_box_storage = &this_box_storage;

// Assign pointers to functions for intersection with the shape, checking if a point is inside the shape
if (this_box_storage.is_rectangle == 1) {
this_box_volume.geometry.intersect_function = &sample_box_intersect_simple;
this_box_volume.geometry.within_function = &r_within_box_simple;
}
else {
this_box_volume.geometry.intersect_function = &sample_box_intersect_advanced;
this_box_volume.geometry.within_function = &r_within_box_advanced;
}

this_box_volume.geometry.shell_points = &box_shell_points;
this_box_volume.geometry.mcdisplay_function = &mcdisplay_box_function;
this_box_volume.geometry.initialize_from_main_function = &initialize_box_geometry_from_main_component;
this_box_volume.geometry.process_rot_allocated = 0;

this_box_volume.geometry.copy_geometry_parameters = &allocate_box_storage_copy;

rot_copy(this_box_volume.geometry.rotation_matrix,ROT_A_CURRENT_COMP); //check how ROT_R_CURRENT_COMP would work
rot_transpose(ROT_A_CURRENT_COMP,this_box_volume.geometry.transpose_rotation_matrix);

// Initialize loggers
this_box_volume.loggers.num_elements = 0;

// packing the information into the global_geometry_element, which is then included in the global_geometry_list.
sprintf(global_geometry_element.name,NAME_CURRENT_COMP);
global_geometry_element.activation_counter = number_of_activations;
global_geometry_element.component_index = INDEX_CURRENT_COMP;
global_geometry_element.Volume = &this_box_volume; // Would be nicer if this m was a pointer, now we have the (small) data two places
add_element_to_geometry_list(&global_geometry_list,global_geometry_element);
}
#line 210638 "MACS_sample_kidney_box.c"
#undef number_of_activations
#undef mask_setting
#undef mask_string
#undef p_interact
#undef focus_r
#undef focus_xh
#undef focus_xw
#undef focus_ah
#undef focus_aw
#undef target_z
#undef target_y
#undef target_x
#undef target_index
#undef visualize
#undef yheight2
#undef xwidth2
#undef zdepth
#undef yheight
#undef xwidth
#undef priority
#undef material_string
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

  /* Initializations for component channel_5_analyzer_1_array_crystal_array_4. */
  SIG_MESSAGE("channel_5_analyzer_1_array_crystal_array_4 (Init)");
#define mccompcurname  channel_5_analyzer_1_array_crystal_array_4
#define mccompcurtype  Union_box
#define mccompcurindex 324
#define loop_index mccchannel_5_analyzer_1_array_crystal_array_4_loop_index
#define this_box_volume mccchannel_5_analyzer_1_array_crystal_array_4_this_box_volume
#define global_geometry_element mccchannel_5_analyzer_1_array_crystal_array_4_global_geometry_element
#define this_box_storage mccchannel_5_analyzer_1_array_crystal_array_4_this_box_storage
#define material_string mccchannel_5_analyzer_1_array_crystal_array_4_material_string
#define priority mccchannel_5_analyzer_1_array_crystal_array_4_priority
#define xwidth mccchannel_5_analyzer_1_array_crystal_array_4_xwidth
#define yheight mccchannel_5_analyzer_1_array_crystal_array_4_yheight
#define zdepth mccchannel_5_analyzer_1_array_crystal_array_4_zdepth
#define xwidth2 mccchannel_5_analyzer_1_array_crystal_array_4_xwidth2
#define yheight2 mccchannel_5_analyzer_1_array_crystal_array_4_yheight2
#define visualize mccchannel_5_analyzer_1_array_crystal_array_4_visualize
#define target_index mccchannel_5_analyzer_1_array_crystal_array_4_target_index
#define target_x mccchannel_5_analyzer_1_array_crystal_array_4_target_x
#define target_y mccchannel_5_analyzer_1_array_crystal_array_4_target_y
#define target_z mccchannel_5_analyzer_1_array_crystal_array_4_target_z
#define focus_aw mccchannel_5_analyzer_1_array_crystal_array_4_focus_aw
#define focus_ah mccchannel_5_analyzer_1_array_crystal_array_4_focus_ah
#define focus_xw mccchannel_5_analyzer_1_array_crystal_array_4_focus_xw
#define focus_xh mccchannel_5_analyzer_1_array_crystal_array_4_focus_xh
#define focus_r mccchannel_5_analyzer_1_array_crystal_array_4_focus_r
#define p_interact mccchannel_5_analyzer_1_array_crystal_array_4_p_interact
#define mask_string mccchannel_5_analyzer_1_array_crystal_array_4_mask_string
#define mask_setting mccchannel_5_analyzer_1_array_crystal_array_4_mask_setting
#define number_of_activations mccchannel_5_analyzer_1_array_crystal_array_4_number_of_activations
#line 224 "Union_box.comp"
{
// Initializes the focusing system for this volume including input sanitation.
focus_initialize(&this_box_volume.geometry, POS_A_COMP_INDEX(INDEX_CURRENT_COMP+target_index), POS_A_CURRENT_COMP, ROT_A_CURRENT_COMP, target_index, target_x, target_y, target_z, focus_aw, focus_ah, focus_xw, focus_xh, focus_r, NAME_CURRENT_COMP);

// Input sanitation for this geometry
if (xwidth <= 0) {
  printf("\nERROR in Union_box named %s, the xwidth is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (yheight <= 0) {
  printf("\nERROR in Union_box named %s, yheight is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (zdepth <= 0) {
  printf("\nERROR in Union_box named %s, zdepth is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (xwidth2 <= 0 && xwidth2 != -1) {
  printf("\nERROR in Union_box named %s, the xwidth2 is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (yheight2 <= 0 && yheight2 != -1) {
  printf("\nERROR in Union_box named %s, yheight2 is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}

// Use sanitation
if (global_material_list.num_elements == 0) {
  printf("\nERROR: Need to define a material using Union_make_material before using a Union geometry component. \n");
  printf("       %s was defined before first use of Union_make_material.\n",NAME_CURRENT_COMP);
  exit(1);
}

this_box_volume.geometry.is_masked_volume = 0;
this_box_volume.geometry.is_exit_volume = 0;
this_box_volume.geometry.is_mask_volume = 0;
// check if the volume is a mask, if it is the material string is irelevant.
if (mask_string && strlen(mask_string) && strcmp(mask_string, "NULL") && strcmp(mask_string, "0")) {
    // A mask volume is used to limit the extend of other volumes, called the masked volumes. These are specified in the mask_string.
    // In order for a ray to enter a masked volume, it needs to be both in the region covered by that volume AND the mask volume.
    // When more than
    this_box_volume.geometry.mask_mode = 1; // Default is mask mode is ALL
    if (mask_setting && strlen(mask_setting) && strcmp(mask_setting, "NULL") && strcmp(mask_setting, "0")) {
        if (strcmp(mask_setting,"ALL") == 0 || strcmp(mask_setting,"All") == 0) this_box_volume.geometry.mask_mode = 1;
        else if (strcmp(mask_setting,"ANY") == 0 || strcmp(mask_setting,"Any") == 0) this_box_volume.geometry.mask_mode = 2;
        else {
            printf("The mask_mode of component %s is set to %s, but must be either ALL or ANY.\n",NAME_CURRENT_COMP,mask_setting);
            exit(1);
        }
    }
    
    for (loop_index=0;loop_index<global_geometry_list.num_elements;loop_index++) {
        // Add mask list
        if (1 == manual_linking_function(global_geometry_list.elements[loop_index].name,mask_string)) {
            add_element_to_int_list(&this_box_volume.geometry.mask_list,global_geometry_list.elements[loop_index].component_index);
            add_element_to_int_list(&global_geometry_list.elements[loop_index].Volume->geometry.masked_by_list,INDEX_CURRENT_COMP);
            global_geometry_list.elements[loop_index].Volume->geometry.is_masked_volume = 1;
            if (this_box_volume.geometry.mask_mode == 2)
                global_geometry_list.elements[loop_index].Volume->geometry.mask_mode = 2;
            if (this_box_volume.geometry.mask_mode == 1) {
                if (global_geometry_list.elements[loop_index].Volume->geometry.is_masked_volume == 1 && global_geometry_list.elements[loop_index].Volume->geometry.mask_mode != 2)
                    // If more than one mask is added to one volume, the ANY mode overwrites the (default) ALL mode.
                    global_geometry_list.elements[loop_index].Volume->geometry.mask_mode = 1;
            }
            
            found_geometries = 1;
        }
    }
    if (found_geometries == 0) {
        printf("The mask_string in geometry: %s did not find any of the specified volumes in the mask_string %s \n",NAME_CURRENT_COMP,mask_string);
        exit(1);
    }
    this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
    this_box_volume.p_physics->is_vacuum = 0; // Makes this volume a vacuum
    this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
    this_box_volume.p_physics->my_a = 0; // Should not be used.
    sprintf(this_box_volume.p_physics->name,"Mask");
    this_box_volume.geometry.is_mask_volume = 1;
    
    
// Read the material input, or if it lacks, use automatic linking.
} else if (material_string && strlen(material_string) && strcmp(material_string, "NULL") && strcmp(material_string, "0")) {
    // A geometry string was given, use it to determine which material
    if (0 == strcmp(material_string,"vacuum") || 0 == strcmp(material_string,"Vacuum")) {
        // One could have a global physics struct for vacuum instead of creating one for each
        this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
        this_box_volume.p_physics->is_vacuum = 1; // Makes this volume a vacuum
        this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
        this_box_volume.p_physics->my_a = 0; // Should not be used.
        sprintf(this_box_volume.p_physics->name,"Vacuum");
    } else if (0 == strcmp(material_string,"exit") || 0 == strcmp(material_string,"Exit")) {
        // One could have a global physics struct for vacuum instead of creating one for each
        this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
        this_box_volume.p_physics->is_vacuum = 1; // Makes this volume a vacuum
        this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
        this_box_volume.p_physics->my_a = 0; // Should not be used.
        this_box_volume.geometry.is_exit_volume = 1;
        sprintf(this_box_volume.p_physics->name,"Exit");
    } else {
        #ifndef MATERIAL_DETECTOR
            printf("Need to define a material before refering to it in a geometry %s.\n",NAME_CURRENT_COMP);
            exit(1);
        #endif
        for (loop_index=0;loop_index<global_material_list.num_elements;loop_index++) {
            if (0 == strcmp(material_string,global_material_list.elements[loop_index].name)) {
                this_box_volume.p_physics = global_material_list.elements[loop_index].physics;
                break;
            }
            if (loop_index == global_material_list.num_elements-1) {
            printf("\n");
            printf("ERROR: The material string \"%s\" in Union geometry \"%s\" did not match a specified material. \n",material_string,NAME_CURRENT_COMP);
            printf("       The materials available at this point (need to be defined before the geometry): \n");
            for (loop_index=0;loop_index<global_material_list.num_elements;loop_index++)
              printf("         %s\n",global_material_list.elements[loop_index].name);
            printf("\n");
            printf("       It is also possible to use one of the defualt materials avaiable: \n");
            printf("           Vacuum (for a Volume without scattering or absorption)\n");
            printf("           Exit (for a Volume where the ray exits the component if it enters)\n");
            printf("           Mask (for a Volume that masks existing volumes specified in the mask_string\n");
            exit(1);
          }
        }
    }
} else {
    // Automatic linking, simply using the last defined material.
    #ifndef MATERIAL_DETECTOR
        printf("Need to define a material before the geometry to use automatic linking %s.\n",NAME_CURRENT_COMP);
        exit(1);
    #endif
    this_box_volume.p_physics = global_material_list.elements[global_material_list.num_elements-1].physics;
}

sprintf(this_box_volume.name,NAME_CURRENT_COMP);
sprintf(this_box_volume.geometry.shape,"box");
this_box_volume.geometry.priority_value = priority;
this_box_volume.geometry.geometry_p_interact = p_interact;
// Currently the coordinates will be in absolute space.
this_box_volume.geometry.center = POS_A_CURRENT_COMP;

this_box_storage.z_depth = zdepth;
this_box_storage.x_width1 = xwidth;
this_box_storage.y_height1 = yheight;

this_box_storage.is_rectangle = 0;
if (xwidth2 < 0 && yheight2 < 0) this_box_storage.is_rectangle = 1;
if (xwidth == xwidth2 && yheight == yheight2) this_box_storage.is_rectangle = 1;

if (xwidth2 < 0) {
    this_box_storage.x_width2 = xwidth;
    xwidth2 = xwidth;
} else this_box_storage.x_width2 = xwidth2;

if (yheight2 < 0) {
    this_box_storage.y_height2 = yheight;
    yheight2 = yheight;
} else this_box_storage.y_height2 = yheight2;


this_box_storage.normal_vectors[0] = coords_set(0,0,1);
this_box_storage.normal_vectors[1] = coords_set(0,0,1);

// for sides with y component = 0
x_component = 2*zdepth/sqrt((xwidth-xwidth2)*(xwidth-xwidth2)+4*zdepth*zdepth);
z_component = (xwidth-xwidth2)/sqrt(4*zdepth*zdepth+(xwidth-xwidth2)*(xwidth-xwidth2));

this_box_storage.normal_vectors[2] = coords_set(x_component,0,z_component);
this_box_storage.normal_vectors[3] = coords_set(-x_component,0,z_component);

// for sides with x component = 0
y_component = 2*zdepth/sqrt((yheight-yheight2)*(yheight-yheight2)+4*zdepth*zdepth);
z_component = (yheight-yheight2)/sqrt(4*zdepth*zdepth+(yheight-yheight2)*(yheight-yheight2));

this_box_storage.normal_vectors[4] = coords_set(0,y_component,z_component);
this_box_storage.normal_vectors[5] = coords_set(0,-y_component,z_component);

this_box_volume.geometry.visualization_on = visualize;

this_box_volume.geometry.geometry_parameters.p_box_storage = &this_box_storage;

// Assign pointers to functions for intersection with the shape, checking if a point is inside the shape
if (this_box_storage.is_rectangle == 1) {
this_box_volume.geometry.intersect_function = &sample_box_intersect_simple;
this_box_volume.geometry.within_function = &r_within_box_simple;
}
else {
this_box_volume.geometry.intersect_function = &sample_box_intersect_advanced;
this_box_volume.geometry.within_function = &r_within_box_advanced;
}

this_box_volume.geometry.shell_points = &box_shell_points;
this_box_volume.geometry.mcdisplay_function = &mcdisplay_box_function;
this_box_volume.geometry.initialize_from_main_function = &initialize_box_geometry_from_main_component;
this_box_volume.geometry.process_rot_allocated = 0;

this_box_volume.geometry.copy_geometry_parameters = &allocate_box_storage_copy;

rot_copy(this_box_volume.geometry.rotation_matrix,ROT_A_CURRENT_COMP); //check how ROT_R_CURRENT_COMP would work
rot_transpose(ROT_A_CURRENT_COMP,this_box_volume.geometry.transpose_rotation_matrix);

// Initialize loggers
this_box_volume.loggers.num_elements = 0;

// packing the information into the global_geometry_element, which is then included in the global_geometry_list.
sprintf(global_geometry_element.name,NAME_CURRENT_COMP);
global_geometry_element.activation_counter = number_of_activations;
global_geometry_element.component_index = INDEX_CURRENT_COMP;
global_geometry_element.Volume = &this_box_volume; // Would be nicer if this m was a pointer, now we have the (small) data two places
add_element_to_geometry_list(&global_geometry_list,global_geometry_element);
}
#line 210908 "MACS_sample_kidney_box.c"
#undef number_of_activations
#undef mask_setting
#undef mask_string
#undef p_interact
#undef focus_r
#undef focus_xh
#undef focus_xw
#undef focus_ah
#undef focus_aw
#undef target_z
#undef target_y
#undef target_x
#undef target_index
#undef visualize
#undef yheight2
#undef xwidth2
#undef zdepth
#undef yheight
#undef xwidth
#undef priority
#undef material_string
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

  /* Initializations for component channel_5_analyzer_1_array_crystal_array_5. */
  SIG_MESSAGE("channel_5_analyzer_1_array_crystal_array_5 (Init)");
#define mccompcurname  channel_5_analyzer_1_array_crystal_array_5
#define mccompcurtype  Union_box
#define mccompcurindex 325
#define loop_index mccchannel_5_analyzer_1_array_crystal_array_5_loop_index
#define this_box_volume mccchannel_5_analyzer_1_array_crystal_array_5_this_box_volume
#define global_geometry_element mccchannel_5_analyzer_1_array_crystal_array_5_global_geometry_element
#define this_box_storage mccchannel_5_analyzer_1_array_crystal_array_5_this_box_storage
#define material_string mccchannel_5_analyzer_1_array_crystal_array_5_material_string
#define priority mccchannel_5_analyzer_1_array_crystal_array_5_priority
#define xwidth mccchannel_5_analyzer_1_array_crystal_array_5_xwidth
#define yheight mccchannel_5_analyzer_1_array_crystal_array_5_yheight
#define zdepth mccchannel_5_analyzer_1_array_crystal_array_5_zdepth
#define xwidth2 mccchannel_5_analyzer_1_array_crystal_array_5_xwidth2
#define yheight2 mccchannel_5_analyzer_1_array_crystal_array_5_yheight2
#define visualize mccchannel_5_analyzer_1_array_crystal_array_5_visualize
#define target_index mccchannel_5_analyzer_1_array_crystal_array_5_target_index
#define target_x mccchannel_5_analyzer_1_array_crystal_array_5_target_x
#define target_y mccchannel_5_analyzer_1_array_crystal_array_5_target_y
#define target_z mccchannel_5_analyzer_1_array_crystal_array_5_target_z
#define focus_aw mccchannel_5_analyzer_1_array_crystal_array_5_focus_aw
#define focus_ah mccchannel_5_analyzer_1_array_crystal_array_5_focus_ah
#define focus_xw mccchannel_5_analyzer_1_array_crystal_array_5_focus_xw
#define focus_xh mccchannel_5_analyzer_1_array_crystal_array_5_focus_xh
#define focus_r mccchannel_5_analyzer_1_array_crystal_array_5_focus_r
#define p_interact mccchannel_5_analyzer_1_array_crystal_array_5_p_interact
#define mask_string mccchannel_5_analyzer_1_array_crystal_array_5_mask_string
#define mask_setting mccchannel_5_analyzer_1_array_crystal_array_5_mask_setting
#define number_of_activations mccchannel_5_analyzer_1_array_crystal_array_5_number_of_activations
#line 224 "Union_box.comp"
{
// Initializes the focusing system for this volume including input sanitation.
focus_initialize(&this_box_volume.geometry, POS_A_COMP_INDEX(INDEX_CURRENT_COMP+target_index), POS_A_CURRENT_COMP, ROT_A_CURRENT_COMP, target_index, target_x, target_y, target_z, focus_aw, focus_ah, focus_xw, focus_xh, focus_r, NAME_CURRENT_COMP);

// Input sanitation for this geometry
if (xwidth <= 0) {
  printf("\nERROR in Union_box named %s, the xwidth is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (yheight <= 0) {
  printf("\nERROR in Union_box named %s, yheight is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (zdepth <= 0) {
  printf("\nERROR in Union_box named %s, zdepth is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (xwidth2 <= 0 && xwidth2 != -1) {
  printf("\nERROR in Union_box named %s, the xwidth2 is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (yheight2 <= 0 && yheight2 != -1) {
  printf("\nERROR in Union_box named %s, yheight2 is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}

// Use sanitation
if (global_material_list.num_elements == 0) {
  printf("\nERROR: Need to define a material using Union_make_material before using a Union geometry component. \n");
  printf("       %s was defined before first use of Union_make_material.\n",NAME_CURRENT_COMP);
  exit(1);
}

this_box_volume.geometry.is_masked_volume = 0;
this_box_volume.geometry.is_exit_volume = 0;
this_box_volume.geometry.is_mask_volume = 0;
// check if the volume is a mask, if it is the material string is irelevant.
if (mask_string && strlen(mask_string) && strcmp(mask_string, "NULL") && strcmp(mask_string, "0")) {
    // A mask volume is used to limit the extend of other volumes, called the masked volumes. These are specified in the mask_string.
    // In order for a ray to enter a masked volume, it needs to be both in the region covered by that volume AND the mask volume.
    // When more than
    this_box_volume.geometry.mask_mode = 1; // Default is mask mode is ALL
    if (mask_setting && strlen(mask_setting) && strcmp(mask_setting, "NULL") && strcmp(mask_setting, "0")) {
        if (strcmp(mask_setting,"ALL") == 0 || strcmp(mask_setting,"All") == 0) this_box_volume.geometry.mask_mode = 1;
        else if (strcmp(mask_setting,"ANY") == 0 || strcmp(mask_setting,"Any") == 0) this_box_volume.geometry.mask_mode = 2;
        else {
            printf("The mask_mode of component %s is set to %s, but must be either ALL or ANY.\n",NAME_CURRENT_COMP,mask_setting);
            exit(1);
        }
    }
    
    for (loop_index=0;loop_index<global_geometry_list.num_elements;loop_index++) {
        // Add mask list
        if (1 == manual_linking_function(global_geometry_list.elements[loop_index].name,mask_string)) {
            add_element_to_int_list(&this_box_volume.geometry.mask_list,global_geometry_list.elements[loop_index].component_index);
            add_element_to_int_list(&global_geometry_list.elements[loop_index].Volume->geometry.masked_by_list,INDEX_CURRENT_COMP);
            global_geometry_list.elements[loop_index].Volume->geometry.is_masked_volume = 1;
            if (this_box_volume.geometry.mask_mode == 2)
                global_geometry_list.elements[loop_index].Volume->geometry.mask_mode = 2;
            if (this_box_volume.geometry.mask_mode == 1) {
                if (global_geometry_list.elements[loop_index].Volume->geometry.is_masked_volume == 1 && global_geometry_list.elements[loop_index].Volume->geometry.mask_mode != 2)
                    // If more than one mask is added to one volume, the ANY mode overwrites the (default) ALL mode.
                    global_geometry_list.elements[loop_index].Volume->geometry.mask_mode = 1;
            }
            
            found_geometries = 1;
        }
    }
    if (found_geometries == 0) {
        printf("The mask_string in geometry: %s did not find any of the specified volumes in the mask_string %s \n",NAME_CURRENT_COMP,mask_string);
        exit(1);
    }
    this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
    this_box_volume.p_physics->is_vacuum = 0; // Makes this volume a vacuum
    this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
    this_box_volume.p_physics->my_a = 0; // Should not be used.
    sprintf(this_box_volume.p_physics->name,"Mask");
    this_box_volume.geometry.is_mask_volume = 1;
    
    
// Read the material input, or if it lacks, use automatic linking.
} else if (material_string && strlen(material_string) && strcmp(material_string, "NULL") && strcmp(material_string, "0")) {
    // A geometry string was given, use it to determine which material
    if (0 == strcmp(material_string,"vacuum") || 0 == strcmp(material_string,"Vacuum")) {
        // One could have a global physics struct for vacuum instead of creating one for each
        this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
        this_box_volume.p_physics->is_vacuum = 1; // Makes this volume a vacuum
        this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
        this_box_volume.p_physics->my_a = 0; // Should not be used.
        sprintf(this_box_volume.p_physics->name,"Vacuum");
    } else if (0 == strcmp(material_string,"exit") || 0 == strcmp(material_string,"Exit")) {
        // One could have a global physics struct for vacuum instead of creating one for each
        this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
        this_box_volume.p_physics->is_vacuum = 1; // Makes this volume a vacuum
        this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
        this_box_volume.p_physics->my_a = 0; // Should not be used.
        this_box_volume.geometry.is_exit_volume = 1;
        sprintf(this_box_volume.p_physics->name,"Exit");
    } else {
        #ifndef MATERIAL_DETECTOR
            printf("Need to define a material before refering to it in a geometry %s.\n",NAME_CURRENT_COMP);
            exit(1);
        #endif
        for (loop_index=0;loop_index<global_material_list.num_elements;loop_index++) {
            if (0 == strcmp(material_string,global_material_list.elements[loop_index].name)) {
                this_box_volume.p_physics = global_material_list.elements[loop_index].physics;
                break;
            }
            if (loop_index == global_material_list.num_elements-1) {
            printf("\n");
            printf("ERROR: The material string \"%s\" in Union geometry \"%s\" did not match a specified material. \n",material_string,NAME_CURRENT_COMP);
            printf("       The materials available at this point (need to be defined before the geometry): \n");
            for (loop_index=0;loop_index<global_material_list.num_elements;loop_index++)
              printf("         %s\n",global_material_list.elements[loop_index].name);
            printf("\n");
            printf("       It is also possible to use one of the defualt materials avaiable: \n");
            printf("           Vacuum (for a Volume without scattering or absorption)\n");
            printf("           Exit (for a Volume where the ray exits the component if it enters)\n");
            printf("           Mask (for a Volume that masks existing volumes specified in the mask_string\n");
            exit(1);
          }
        }
    }
} else {
    // Automatic linking, simply using the last defined material.
    #ifndef MATERIAL_DETECTOR
        printf("Need to define a material before the geometry to use automatic linking %s.\n",NAME_CURRENT_COMP);
        exit(1);
    #endif
    this_box_volume.p_physics = global_material_list.elements[global_material_list.num_elements-1].physics;
}

sprintf(this_box_volume.name,NAME_CURRENT_COMP);
sprintf(this_box_volume.geometry.shape,"box");
this_box_volume.geometry.priority_value = priority;
this_box_volume.geometry.geometry_p_interact = p_interact;
// Currently the coordinates will be in absolute space.
this_box_volume.geometry.center = POS_A_CURRENT_COMP;

this_box_storage.z_depth = zdepth;
this_box_storage.x_width1 = xwidth;
this_box_storage.y_height1 = yheight;

this_box_storage.is_rectangle = 0;
if (xwidth2 < 0 && yheight2 < 0) this_box_storage.is_rectangle = 1;
if (xwidth == xwidth2 && yheight == yheight2) this_box_storage.is_rectangle = 1;

if (xwidth2 < 0) {
    this_box_storage.x_width2 = xwidth;
    xwidth2 = xwidth;
} else this_box_storage.x_width2 = xwidth2;

if (yheight2 < 0) {
    this_box_storage.y_height2 = yheight;
    yheight2 = yheight;
} else this_box_storage.y_height2 = yheight2;


this_box_storage.normal_vectors[0] = coords_set(0,0,1);
this_box_storage.normal_vectors[1] = coords_set(0,0,1);

// for sides with y component = 0
x_component = 2*zdepth/sqrt((xwidth-xwidth2)*(xwidth-xwidth2)+4*zdepth*zdepth);
z_component = (xwidth-xwidth2)/sqrt(4*zdepth*zdepth+(xwidth-xwidth2)*(xwidth-xwidth2));

this_box_storage.normal_vectors[2] = coords_set(x_component,0,z_component);
this_box_storage.normal_vectors[3] = coords_set(-x_component,0,z_component);

// for sides with x component = 0
y_component = 2*zdepth/sqrt((yheight-yheight2)*(yheight-yheight2)+4*zdepth*zdepth);
z_component = (yheight-yheight2)/sqrt(4*zdepth*zdepth+(yheight-yheight2)*(yheight-yheight2));

this_box_storage.normal_vectors[4] = coords_set(0,y_component,z_component);
this_box_storage.normal_vectors[5] = coords_set(0,-y_component,z_component);

this_box_volume.geometry.visualization_on = visualize;

this_box_volume.geometry.geometry_parameters.p_box_storage = &this_box_storage;

// Assign pointers to functions for intersection with the shape, checking if a point is inside the shape
if (this_box_storage.is_rectangle == 1) {
this_box_volume.geometry.intersect_function = &sample_box_intersect_simple;
this_box_volume.geometry.within_function = &r_within_box_simple;
}
else {
this_box_volume.geometry.intersect_function = &sample_box_intersect_advanced;
this_box_volume.geometry.within_function = &r_within_box_advanced;
}

this_box_volume.geometry.shell_points = &box_shell_points;
this_box_volume.geometry.mcdisplay_function = &mcdisplay_box_function;
this_box_volume.geometry.initialize_from_main_function = &initialize_box_geometry_from_main_component;
this_box_volume.geometry.process_rot_allocated = 0;

this_box_volume.geometry.copy_geometry_parameters = &allocate_box_storage_copy;

rot_copy(this_box_volume.geometry.rotation_matrix,ROT_A_CURRENT_COMP); //check how ROT_R_CURRENT_COMP would work
rot_transpose(ROT_A_CURRENT_COMP,this_box_volume.geometry.transpose_rotation_matrix);

// Initialize loggers
this_box_volume.loggers.num_elements = 0;

// packing the information into the global_geometry_element, which is then included in the global_geometry_list.
sprintf(global_geometry_element.name,NAME_CURRENT_COMP);
global_geometry_element.activation_counter = number_of_activations;
global_geometry_element.component_index = INDEX_CURRENT_COMP;
global_geometry_element.Volume = &this_box_volume; // Would be nicer if this m was a pointer, now we have the (small) data two places
add_element_to_geometry_list(&global_geometry_list,global_geometry_element);
}
#line 211178 "MACS_sample_kidney_box.c"
#undef number_of_activations
#undef mask_setting
#undef mask_string
#undef p_interact
#undef focus_r
#undef focus_xh
#undef focus_xw
#undef focus_ah
#undef focus_aw
#undef target_z
#undef target_y
#undef target_x
#undef target_index
#undef visualize
#undef yheight2
#undef xwidth2
#undef zdepth
#undef yheight
#undef xwidth
#undef priority
#undef material_string
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

  /* Initializations for component channel_5_analyzer_1_array_crystal_array_6. */
  SIG_MESSAGE("channel_5_analyzer_1_array_crystal_array_6 (Init)");
#define mccompcurname  channel_5_analyzer_1_array_crystal_array_6
#define mccompcurtype  Union_box
#define mccompcurindex 326
#define loop_index mccchannel_5_analyzer_1_array_crystal_array_6_loop_index
#define this_box_volume mccchannel_5_analyzer_1_array_crystal_array_6_this_box_volume
#define global_geometry_element mccchannel_5_analyzer_1_array_crystal_array_6_global_geometry_element
#define this_box_storage mccchannel_5_analyzer_1_array_crystal_array_6_this_box_storage
#define material_string mccchannel_5_analyzer_1_array_crystal_array_6_material_string
#define priority mccchannel_5_analyzer_1_array_crystal_array_6_priority
#define xwidth mccchannel_5_analyzer_1_array_crystal_array_6_xwidth
#define yheight mccchannel_5_analyzer_1_array_crystal_array_6_yheight
#define zdepth mccchannel_5_analyzer_1_array_crystal_array_6_zdepth
#define xwidth2 mccchannel_5_analyzer_1_array_crystal_array_6_xwidth2
#define yheight2 mccchannel_5_analyzer_1_array_crystal_array_6_yheight2
#define visualize mccchannel_5_analyzer_1_array_crystal_array_6_visualize
#define target_index mccchannel_5_analyzer_1_array_crystal_array_6_target_index
#define target_x mccchannel_5_analyzer_1_array_crystal_array_6_target_x
#define target_y mccchannel_5_analyzer_1_array_crystal_array_6_target_y
#define target_z mccchannel_5_analyzer_1_array_crystal_array_6_target_z
#define focus_aw mccchannel_5_analyzer_1_array_crystal_array_6_focus_aw
#define focus_ah mccchannel_5_analyzer_1_array_crystal_array_6_focus_ah
#define focus_xw mccchannel_5_analyzer_1_array_crystal_array_6_focus_xw
#define focus_xh mccchannel_5_analyzer_1_array_crystal_array_6_focus_xh
#define focus_r mccchannel_5_analyzer_1_array_crystal_array_6_focus_r
#define p_interact mccchannel_5_analyzer_1_array_crystal_array_6_p_interact
#define mask_string mccchannel_5_analyzer_1_array_crystal_array_6_mask_string
#define mask_setting mccchannel_5_analyzer_1_array_crystal_array_6_mask_setting
#define number_of_activations mccchannel_5_analyzer_1_array_crystal_array_6_number_of_activations
#line 224 "Union_box.comp"
{
// Initializes the focusing system for this volume including input sanitation.
focus_initialize(&this_box_volume.geometry, POS_A_COMP_INDEX(INDEX_CURRENT_COMP+target_index), POS_A_CURRENT_COMP, ROT_A_CURRENT_COMP, target_index, target_x, target_y, target_z, focus_aw, focus_ah, focus_xw, focus_xh, focus_r, NAME_CURRENT_COMP);

// Input sanitation for this geometry
if (xwidth <= 0) {
  printf("\nERROR in Union_box named %s, the xwidth is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (yheight <= 0) {
  printf("\nERROR in Union_box named %s, yheight is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (zdepth <= 0) {
  printf("\nERROR in Union_box named %s, zdepth is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (xwidth2 <= 0 && xwidth2 != -1) {
  printf("\nERROR in Union_box named %s, the xwidth2 is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (yheight2 <= 0 && yheight2 != -1) {
  printf("\nERROR in Union_box named %s, yheight2 is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}

// Use sanitation
if (global_material_list.num_elements == 0) {
  printf("\nERROR: Need to define a material using Union_make_material before using a Union geometry component. \n");
  printf("       %s was defined before first use of Union_make_material.\n",NAME_CURRENT_COMP);
  exit(1);
}

this_box_volume.geometry.is_masked_volume = 0;
this_box_volume.geometry.is_exit_volume = 0;
this_box_volume.geometry.is_mask_volume = 0;
// check if the volume is a mask, if it is the material string is irelevant.
if (mask_string && strlen(mask_string) && strcmp(mask_string, "NULL") && strcmp(mask_string, "0")) {
    // A mask volume is used to limit the extend of other volumes, called the masked volumes. These are specified in the mask_string.
    // In order for a ray to enter a masked volume, it needs to be both in the region covered by that volume AND the mask volume.
    // When more than
    this_box_volume.geometry.mask_mode = 1; // Default is mask mode is ALL
    if (mask_setting && strlen(mask_setting) && strcmp(mask_setting, "NULL") && strcmp(mask_setting, "0")) {
        if (strcmp(mask_setting,"ALL") == 0 || strcmp(mask_setting,"All") == 0) this_box_volume.geometry.mask_mode = 1;
        else if (strcmp(mask_setting,"ANY") == 0 || strcmp(mask_setting,"Any") == 0) this_box_volume.geometry.mask_mode = 2;
        else {
            printf("The mask_mode of component %s is set to %s, but must be either ALL or ANY.\n",NAME_CURRENT_COMP,mask_setting);
            exit(1);
        }
    }
    
    for (loop_index=0;loop_index<global_geometry_list.num_elements;loop_index++) {
        // Add mask list
        if (1 == manual_linking_function(global_geometry_list.elements[loop_index].name,mask_string)) {
            add_element_to_int_list(&this_box_volume.geometry.mask_list,global_geometry_list.elements[loop_index].component_index);
            add_element_to_int_list(&global_geometry_list.elements[loop_index].Volume->geometry.masked_by_list,INDEX_CURRENT_COMP);
            global_geometry_list.elements[loop_index].Volume->geometry.is_masked_volume = 1;
            if (this_box_volume.geometry.mask_mode == 2)
                global_geometry_list.elements[loop_index].Volume->geometry.mask_mode = 2;
            if (this_box_volume.geometry.mask_mode == 1) {
                if (global_geometry_list.elements[loop_index].Volume->geometry.is_masked_volume == 1 && global_geometry_list.elements[loop_index].Volume->geometry.mask_mode != 2)
                    // If more than one mask is added to one volume, the ANY mode overwrites the (default) ALL mode.
                    global_geometry_list.elements[loop_index].Volume->geometry.mask_mode = 1;
            }
            
            found_geometries = 1;
        }
    }
    if (found_geometries == 0) {
        printf("The mask_string in geometry: %s did not find any of the specified volumes in the mask_string %s \n",NAME_CURRENT_COMP,mask_string);
        exit(1);
    }
    this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
    this_box_volume.p_physics->is_vacuum = 0; // Makes this volume a vacuum
    this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
    this_box_volume.p_physics->my_a = 0; // Should not be used.
    sprintf(this_box_volume.p_physics->name,"Mask");
    this_box_volume.geometry.is_mask_volume = 1;
    
    
// Read the material input, or if it lacks, use automatic linking.
} else if (material_string && strlen(material_string) && strcmp(material_string, "NULL") && strcmp(material_string, "0")) {
    // A geometry string was given, use it to determine which material
    if (0 == strcmp(material_string,"vacuum") || 0 == strcmp(material_string,"Vacuum")) {
        // One could have a global physics struct for vacuum instead of creating one for each
        this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
        this_box_volume.p_physics->is_vacuum = 1; // Makes this volume a vacuum
        this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
        this_box_volume.p_physics->my_a = 0; // Should not be used.
        sprintf(this_box_volume.p_physics->name,"Vacuum");
    } else if (0 == strcmp(material_string,"exit") || 0 == strcmp(material_string,"Exit")) {
        // One could have a global physics struct for vacuum instead of creating one for each
        this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
        this_box_volume.p_physics->is_vacuum = 1; // Makes this volume a vacuum
        this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
        this_box_volume.p_physics->my_a = 0; // Should not be used.
        this_box_volume.geometry.is_exit_volume = 1;
        sprintf(this_box_volume.p_physics->name,"Exit");
    } else {
        #ifndef MATERIAL_DETECTOR
            printf("Need to define a material before refering to it in a geometry %s.\n",NAME_CURRENT_COMP);
            exit(1);
        #endif
        for (loop_index=0;loop_index<global_material_list.num_elements;loop_index++) {
            if (0 == strcmp(material_string,global_material_list.elements[loop_index].name)) {
                this_box_volume.p_physics = global_material_list.elements[loop_index].physics;
                break;
            }
            if (loop_index == global_material_list.num_elements-1) {
            printf("\n");
            printf("ERROR: The material string \"%s\" in Union geometry \"%s\" did not match a specified material. \n",material_string,NAME_CURRENT_COMP);
            printf("       The materials available at this point (need to be defined before the geometry): \n");
            for (loop_index=0;loop_index<global_material_list.num_elements;loop_index++)
              printf("         %s\n",global_material_list.elements[loop_index].name);
            printf("\n");
            printf("       It is also possible to use one of the defualt materials avaiable: \n");
            printf("           Vacuum (for a Volume without scattering or absorption)\n");
            printf("           Exit (for a Volume where the ray exits the component if it enters)\n");
            printf("           Mask (for a Volume that masks existing volumes specified in the mask_string\n");
            exit(1);
          }
        }
    }
} else {
    // Automatic linking, simply using the last defined material.
    #ifndef MATERIAL_DETECTOR
        printf("Need to define a material before the geometry to use automatic linking %s.\n",NAME_CURRENT_COMP);
        exit(1);
    #endif
    this_box_volume.p_physics = global_material_list.elements[global_material_list.num_elements-1].physics;
}

sprintf(this_box_volume.name,NAME_CURRENT_COMP);
sprintf(this_box_volume.geometry.shape,"box");
this_box_volume.geometry.priority_value = priority;
this_box_volume.geometry.geometry_p_interact = p_interact;
// Currently the coordinates will be in absolute space.
this_box_volume.geometry.center = POS_A_CURRENT_COMP;

this_box_storage.z_depth = zdepth;
this_box_storage.x_width1 = xwidth;
this_box_storage.y_height1 = yheight;

this_box_storage.is_rectangle = 0;
if (xwidth2 < 0 && yheight2 < 0) this_box_storage.is_rectangle = 1;
if (xwidth == xwidth2 && yheight == yheight2) this_box_storage.is_rectangle = 1;

if (xwidth2 < 0) {
    this_box_storage.x_width2 = xwidth;
    xwidth2 = xwidth;
} else this_box_storage.x_width2 = xwidth2;

if (yheight2 < 0) {
    this_box_storage.y_height2 = yheight;
    yheight2 = yheight;
} else this_box_storage.y_height2 = yheight2;


this_box_storage.normal_vectors[0] = coords_set(0,0,1);
this_box_storage.normal_vectors[1] = coords_set(0,0,1);

// for sides with y component = 0
x_component = 2*zdepth/sqrt((xwidth-xwidth2)*(xwidth-xwidth2)+4*zdepth*zdepth);
z_component = (xwidth-xwidth2)/sqrt(4*zdepth*zdepth+(xwidth-xwidth2)*(xwidth-xwidth2));

this_box_storage.normal_vectors[2] = coords_set(x_component,0,z_component);
this_box_storage.normal_vectors[3] = coords_set(-x_component,0,z_component);

// for sides with x component = 0
y_component = 2*zdepth/sqrt((yheight-yheight2)*(yheight-yheight2)+4*zdepth*zdepth);
z_component = (yheight-yheight2)/sqrt(4*zdepth*zdepth+(yheight-yheight2)*(yheight-yheight2));

this_box_storage.normal_vectors[4] = coords_set(0,y_component,z_component);
this_box_storage.normal_vectors[5] = coords_set(0,-y_component,z_component);

this_box_volume.geometry.visualization_on = visualize;

this_box_volume.geometry.geometry_parameters.p_box_storage = &this_box_storage;

// Assign pointers to functions for intersection with the shape, checking if a point is inside the shape
if (this_box_storage.is_rectangle == 1) {
this_box_volume.geometry.intersect_function = &sample_box_intersect_simple;
this_box_volume.geometry.within_function = &r_within_box_simple;
}
else {
this_box_volume.geometry.intersect_function = &sample_box_intersect_advanced;
this_box_volume.geometry.within_function = &r_within_box_advanced;
}

this_box_volume.geometry.shell_points = &box_shell_points;
this_box_volume.geometry.mcdisplay_function = &mcdisplay_box_function;
this_box_volume.geometry.initialize_from_main_function = &initialize_box_geometry_from_main_component;
this_box_volume.geometry.process_rot_allocated = 0;

this_box_volume.geometry.copy_geometry_parameters = &allocate_box_storage_copy;

rot_copy(this_box_volume.geometry.rotation_matrix,ROT_A_CURRENT_COMP); //check how ROT_R_CURRENT_COMP would work
rot_transpose(ROT_A_CURRENT_COMP,this_box_volume.geometry.transpose_rotation_matrix);

// Initialize loggers
this_box_volume.loggers.num_elements = 0;

// packing the information into the global_geometry_element, which is then included in the global_geometry_list.
sprintf(global_geometry_element.name,NAME_CURRENT_COMP);
global_geometry_element.activation_counter = number_of_activations;
global_geometry_element.component_index = INDEX_CURRENT_COMP;
global_geometry_element.Volume = &this_box_volume; // Would be nicer if this m was a pointer, now we have the (small) data two places
add_element_to_geometry_list(&global_geometry_list,global_geometry_element);
}
#line 211448 "MACS_sample_kidney_box.c"
#undef number_of_activations
#undef mask_setting
#undef mask_string
#undef p_interact
#undef focus_r
#undef focus_xh
#undef focus_xw
#undef focus_ah
#undef focus_aw
#undef target_z
#undef target_y
#undef target_x
#undef target_index
#undef visualize
#undef yheight2
#undef xwidth2
#undef zdepth
#undef yheight
#undef xwidth
#undef priority
#undef material_string
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

  /* Initializations for component channel_5_analyzer_1_array_crystal_array_7. */
  SIG_MESSAGE("channel_5_analyzer_1_array_crystal_array_7 (Init)");
#define mccompcurname  channel_5_analyzer_1_array_crystal_array_7
#define mccompcurtype  Union_box
#define mccompcurindex 327
#define loop_index mccchannel_5_analyzer_1_array_crystal_array_7_loop_index
#define this_box_volume mccchannel_5_analyzer_1_array_crystal_array_7_this_box_volume
#define global_geometry_element mccchannel_5_analyzer_1_array_crystal_array_7_global_geometry_element
#define this_box_storage mccchannel_5_analyzer_1_array_crystal_array_7_this_box_storage
#define material_string mccchannel_5_analyzer_1_array_crystal_array_7_material_string
#define priority mccchannel_5_analyzer_1_array_crystal_array_7_priority
#define xwidth mccchannel_5_analyzer_1_array_crystal_array_7_xwidth
#define yheight mccchannel_5_analyzer_1_array_crystal_array_7_yheight
#define zdepth mccchannel_5_analyzer_1_array_crystal_array_7_zdepth
#define xwidth2 mccchannel_5_analyzer_1_array_crystal_array_7_xwidth2
#define yheight2 mccchannel_5_analyzer_1_array_crystal_array_7_yheight2
#define visualize mccchannel_5_analyzer_1_array_crystal_array_7_visualize
#define target_index mccchannel_5_analyzer_1_array_crystal_array_7_target_index
#define target_x mccchannel_5_analyzer_1_array_crystal_array_7_target_x
#define target_y mccchannel_5_analyzer_1_array_crystal_array_7_target_y
#define target_z mccchannel_5_analyzer_1_array_crystal_array_7_target_z
#define focus_aw mccchannel_5_analyzer_1_array_crystal_array_7_focus_aw
#define focus_ah mccchannel_5_analyzer_1_array_crystal_array_7_focus_ah
#define focus_xw mccchannel_5_analyzer_1_array_crystal_array_7_focus_xw
#define focus_xh mccchannel_5_analyzer_1_array_crystal_array_7_focus_xh
#define focus_r mccchannel_5_analyzer_1_array_crystal_array_7_focus_r
#define p_interact mccchannel_5_analyzer_1_array_crystal_array_7_p_interact
#define mask_string mccchannel_5_analyzer_1_array_crystal_array_7_mask_string
#define mask_setting mccchannel_5_analyzer_1_array_crystal_array_7_mask_setting
#define number_of_activations mccchannel_5_analyzer_1_array_crystal_array_7_number_of_activations
#line 224 "Union_box.comp"
{
// Initializes the focusing system for this volume including input sanitation.
focus_initialize(&this_box_volume.geometry, POS_A_COMP_INDEX(INDEX_CURRENT_COMP+target_index), POS_A_CURRENT_COMP, ROT_A_CURRENT_COMP, target_index, target_x, target_y, target_z, focus_aw, focus_ah, focus_xw, focus_xh, focus_r, NAME_CURRENT_COMP);

// Input sanitation for this geometry
if (xwidth <= 0) {
  printf("\nERROR in Union_box named %s, the xwidth is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (yheight <= 0) {
  printf("\nERROR in Union_box named %s, yheight is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (zdepth <= 0) {
  printf("\nERROR in Union_box named %s, zdepth is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (xwidth2 <= 0 && xwidth2 != -1) {
  printf("\nERROR in Union_box named %s, the xwidth2 is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (yheight2 <= 0 && yheight2 != -1) {
  printf("\nERROR in Union_box named %s, yheight2 is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}

// Use sanitation
if (global_material_list.num_elements == 0) {
  printf("\nERROR: Need to define a material using Union_make_material before using a Union geometry component. \n");
  printf("       %s was defined before first use of Union_make_material.\n",NAME_CURRENT_COMP);
  exit(1);
}

this_box_volume.geometry.is_masked_volume = 0;
this_box_volume.geometry.is_exit_volume = 0;
this_box_volume.geometry.is_mask_volume = 0;
// check if the volume is a mask, if it is the material string is irelevant.
if (mask_string && strlen(mask_string) && strcmp(mask_string, "NULL") && strcmp(mask_string, "0")) {
    // A mask volume is used to limit the extend of other volumes, called the masked volumes. These are specified in the mask_string.
    // In order for a ray to enter a masked volume, it needs to be both in the region covered by that volume AND the mask volume.
    // When more than
    this_box_volume.geometry.mask_mode = 1; // Default is mask mode is ALL
    if (mask_setting && strlen(mask_setting) && strcmp(mask_setting, "NULL") && strcmp(mask_setting, "0")) {
        if (strcmp(mask_setting,"ALL") == 0 || strcmp(mask_setting,"All") == 0) this_box_volume.geometry.mask_mode = 1;
        else if (strcmp(mask_setting,"ANY") == 0 || strcmp(mask_setting,"Any") == 0) this_box_volume.geometry.mask_mode = 2;
        else {
            printf("The mask_mode of component %s is set to %s, but must be either ALL or ANY.\n",NAME_CURRENT_COMP,mask_setting);
            exit(1);
        }
    }
    
    for (loop_index=0;loop_index<global_geometry_list.num_elements;loop_index++) {
        // Add mask list
        if (1 == manual_linking_function(global_geometry_list.elements[loop_index].name,mask_string)) {
            add_element_to_int_list(&this_box_volume.geometry.mask_list,global_geometry_list.elements[loop_index].component_index);
            add_element_to_int_list(&global_geometry_list.elements[loop_index].Volume->geometry.masked_by_list,INDEX_CURRENT_COMP);
            global_geometry_list.elements[loop_index].Volume->geometry.is_masked_volume = 1;
            if (this_box_volume.geometry.mask_mode == 2)
                global_geometry_list.elements[loop_index].Volume->geometry.mask_mode = 2;
            if (this_box_volume.geometry.mask_mode == 1) {
                if (global_geometry_list.elements[loop_index].Volume->geometry.is_masked_volume == 1 && global_geometry_list.elements[loop_index].Volume->geometry.mask_mode != 2)
                    // If more than one mask is added to one volume, the ANY mode overwrites the (default) ALL mode.
                    global_geometry_list.elements[loop_index].Volume->geometry.mask_mode = 1;
            }
            
            found_geometries = 1;
        }
    }
    if (found_geometries == 0) {
        printf("The mask_string in geometry: %s did not find any of the specified volumes in the mask_string %s \n",NAME_CURRENT_COMP,mask_string);
        exit(1);
    }
    this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
    this_box_volume.p_physics->is_vacuum = 0; // Makes this volume a vacuum
    this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
    this_box_volume.p_physics->my_a = 0; // Should not be used.
    sprintf(this_box_volume.p_physics->name,"Mask");
    this_box_volume.geometry.is_mask_volume = 1;
    
    
// Read the material input, or if it lacks, use automatic linking.
} else if (material_string && strlen(material_string) && strcmp(material_string, "NULL") && strcmp(material_string, "0")) {
    // A geometry string was given, use it to determine which material
    if (0 == strcmp(material_string,"vacuum") || 0 == strcmp(material_string,"Vacuum")) {
        // One could have a global physics struct for vacuum instead of creating one for each
        this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
        this_box_volume.p_physics->is_vacuum = 1; // Makes this volume a vacuum
        this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
        this_box_volume.p_physics->my_a = 0; // Should not be used.
        sprintf(this_box_volume.p_physics->name,"Vacuum");
    } else if (0 == strcmp(material_string,"exit") || 0 == strcmp(material_string,"Exit")) {
        // One could have a global physics struct for vacuum instead of creating one for each
        this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
        this_box_volume.p_physics->is_vacuum = 1; // Makes this volume a vacuum
        this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
        this_box_volume.p_physics->my_a = 0; // Should not be used.
        this_box_volume.geometry.is_exit_volume = 1;
        sprintf(this_box_volume.p_physics->name,"Exit");
    } else {
        #ifndef MATERIAL_DETECTOR
            printf("Need to define a material before refering to it in a geometry %s.\n",NAME_CURRENT_COMP);
            exit(1);
        #endif
        for (loop_index=0;loop_index<global_material_list.num_elements;loop_index++) {
            if (0 == strcmp(material_string,global_material_list.elements[loop_index].name)) {
                this_box_volume.p_physics = global_material_list.elements[loop_index].physics;
                break;
            }
            if (loop_index == global_material_list.num_elements-1) {
            printf("\n");
            printf("ERROR: The material string \"%s\" in Union geometry \"%s\" did not match a specified material. \n",material_string,NAME_CURRENT_COMP);
            printf("       The materials available at this point (need to be defined before the geometry): \n");
            for (loop_index=0;loop_index<global_material_list.num_elements;loop_index++)
              printf("         %s\n",global_material_list.elements[loop_index].name);
            printf("\n");
            printf("       It is also possible to use one of the defualt materials avaiable: \n");
            printf("           Vacuum (for a Volume without scattering or absorption)\n");
            printf("           Exit (for a Volume where the ray exits the component if it enters)\n");
            printf("           Mask (for a Volume that masks existing volumes specified in the mask_string\n");
            exit(1);
          }
        }
    }
} else {
    // Automatic linking, simply using the last defined material.
    #ifndef MATERIAL_DETECTOR
        printf("Need to define a material before the geometry to use automatic linking %s.\n",NAME_CURRENT_COMP);
        exit(1);
    #endif
    this_box_volume.p_physics = global_material_list.elements[global_material_list.num_elements-1].physics;
}

sprintf(this_box_volume.name,NAME_CURRENT_COMP);
sprintf(this_box_volume.geometry.shape,"box");
this_box_volume.geometry.priority_value = priority;
this_box_volume.geometry.geometry_p_interact = p_interact;
// Currently the coordinates will be in absolute space.
this_box_volume.geometry.center = POS_A_CURRENT_COMP;

this_box_storage.z_depth = zdepth;
this_box_storage.x_width1 = xwidth;
this_box_storage.y_height1 = yheight;

this_box_storage.is_rectangle = 0;
if (xwidth2 < 0 && yheight2 < 0) this_box_storage.is_rectangle = 1;
if (xwidth == xwidth2 && yheight == yheight2) this_box_storage.is_rectangle = 1;

if (xwidth2 < 0) {
    this_box_storage.x_width2 = xwidth;
    xwidth2 = xwidth;
} else this_box_storage.x_width2 = xwidth2;

if (yheight2 < 0) {
    this_box_storage.y_height2 = yheight;
    yheight2 = yheight;
} else this_box_storage.y_height2 = yheight2;


this_box_storage.normal_vectors[0] = coords_set(0,0,1);
this_box_storage.normal_vectors[1] = coords_set(0,0,1);

// for sides with y component = 0
x_component = 2*zdepth/sqrt((xwidth-xwidth2)*(xwidth-xwidth2)+4*zdepth*zdepth);
z_component = (xwidth-xwidth2)/sqrt(4*zdepth*zdepth+(xwidth-xwidth2)*(xwidth-xwidth2));

this_box_storage.normal_vectors[2] = coords_set(x_component,0,z_component);
this_box_storage.normal_vectors[3] = coords_set(-x_component,0,z_component);

// for sides with x component = 0
y_component = 2*zdepth/sqrt((yheight-yheight2)*(yheight-yheight2)+4*zdepth*zdepth);
z_component = (yheight-yheight2)/sqrt(4*zdepth*zdepth+(yheight-yheight2)*(yheight-yheight2));

this_box_storage.normal_vectors[4] = coords_set(0,y_component,z_component);
this_box_storage.normal_vectors[5] = coords_set(0,-y_component,z_component);

this_box_volume.geometry.visualization_on = visualize;

this_box_volume.geometry.geometry_parameters.p_box_storage = &this_box_storage;

// Assign pointers to functions for intersection with the shape, checking if a point is inside the shape
if (this_box_storage.is_rectangle == 1) {
this_box_volume.geometry.intersect_function = &sample_box_intersect_simple;
this_box_volume.geometry.within_function = &r_within_box_simple;
}
else {
this_box_volume.geometry.intersect_function = &sample_box_intersect_advanced;
this_box_volume.geometry.within_function = &r_within_box_advanced;
}

this_box_volume.geometry.shell_points = &box_shell_points;
this_box_volume.geometry.mcdisplay_function = &mcdisplay_box_function;
this_box_volume.geometry.initialize_from_main_function = &initialize_box_geometry_from_main_component;
this_box_volume.geometry.process_rot_allocated = 0;

this_box_volume.geometry.copy_geometry_parameters = &allocate_box_storage_copy;

rot_copy(this_box_volume.geometry.rotation_matrix,ROT_A_CURRENT_COMP); //check how ROT_R_CURRENT_COMP would work
rot_transpose(ROT_A_CURRENT_COMP,this_box_volume.geometry.transpose_rotation_matrix);

// Initialize loggers
this_box_volume.loggers.num_elements = 0;

// packing the information into the global_geometry_element, which is then included in the global_geometry_list.
sprintf(global_geometry_element.name,NAME_CURRENT_COMP);
global_geometry_element.activation_counter = number_of_activations;
global_geometry_element.component_index = INDEX_CURRENT_COMP;
global_geometry_element.Volume = &this_box_volume; // Would be nicer if this m was a pointer, now we have the (small) data two places
add_element_to_geometry_list(&global_geometry_list,global_geometry_element);
}
#line 211718 "MACS_sample_kidney_box.c"
#undef number_of_activations
#undef mask_setting
#undef mask_string
#undef p_interact
#undef focus_r
#undef focus_xh
#undef focus_xw
#undef focus_ah
#undef focus_aw
#undef target_z
#undef target_y
#undef target_x
#undef target_index
#undef visualize
#undef yheight2
#undef xwidth2
#undef zdepth
#undef yheight
#undef xwidth
#undef priority
#undef material_string
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

  /* Initializations for component channel_5_analyzer_1_array_crystal_array_8. */
  SIG_MESSAGE("channel_5_analyzer_1_array_crystal_array_8 (Init)");
#define mccompcurname  channel_5_analyzer_1_array_crystal_array_8
#define mccompcurtype  Union_box
#define mccompcurindex 328
#define loop_index mccchannel_5_analyzer_1_array_crystal_array_8_loop_index
#define this_box_volume mccchannel_5_analyzer_1_array_crystal_array_8_this_box_volume
#define global_geometry_element mccchannel_5_analyzer_1_array_crystal_array_8_global_geometry_element
#define this_box_storage mccchannel_5_analyzer_1_array_crystal_array_8_this_box_storage
#define material_string mccchannel_5_analyzer_1_array_crystal_array_8_material_string
#define priority mccchannel_5_analyzer_1_array_crystal_array_8_priority
#define xwidth mccchannel_5_analyzer_1_array_crystal_array_8_xwidth
#define yheight mccchannel_5_analyzer_1_array_crystal_array_8_yheight
#define zdepth mccchannel_5_analyzer_1_array_crystal_array_8_zdepth
#define xwidth2 mccchannel_5_analyzer_1_array_crystal_array_8_xwidth2
#define yheight2 mccchannel_5_analyzer_1_array_crystal_array_8_yheight2
#define visualize mccchannel_5_analyzer_1_array_crystal_array_8_visualize
#define target_index mccchannel_5_analyzer_1_array_crystal_array_8_target_index
#define target_x mccchannel_5_analyzer_1_array_crystal_array_8_target_x
#define target_y mccchannel_5_analyzer_1_array_crystal_array_8_target_y
#define target_z mccchannel_5_analyzer_1_array_crystal_array_8_target_z
#define focus_aw mccchannel_5_analyzer_1_array_crystal_array_8_focus_aw
#define focus_ah mccchannel_5_analyzer_1_array_crystal_array_8_focus_ah
#define focus_xw mccchannel_5_analyzer_1_array_crystal_array_8_focus_xw
#define focus_xh mccchannel_5_analyzer_1_array_crystal_array_8_focus_xh
#define focus_r mccchannel_5_analyzer_1_array_crystal_array_8_focus_r
#define p_interact mccchannel_5_analyzer_1_array_crystal_array_8_p_interact
#define mask_string mccchannel_5_analyzer_1_array_crystal_array_8_mask_string
#define mask_setting mccchannel_5_analyzer_1_array_crystal_array_8_mask_setting
#define number_of_activations mccchannel_5_analyzer_1_array_crystal_array_8_number_of_activations
#line 224 "Union_box.comp"
{
// Initializes the focusing system for this volume including input sanitation.
focus_initialize(&this_box_volume.geometry, POS_A_COMP_INDEX(INDEX_CURRENT_COMP+target_index), POS_A_CURRENT_COMP, ROT_A_CURRENT_COMP, target_index, target_x, target_y, target_z, focus_aw, focus_ah, focus_xw, focus_xh, focus_r, NAME_CURRENT_COMP);

// Input sanitation for this geometry
if (xwidth <= 0) {
  printf("\nERROR in Union_box named %s, the xwidth is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (yheight <= 0) {
  printf("\nERROR in Union_box named %s, yheight is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (zdepth <= 0) {
  printf("\nERROR in Union_box named %s, zdepth is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (xwidth2 <= 0 && xwidth2 != -1) {
  printf("\nERROR in Union_box named %s, the xwidth2 is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (yheight2 <= 0 && yheight2 != -1) {
  printf("\nERROR in Union_box named %s, yheight2 is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}

// Use sanitation
if (global_material_list.num_elements == 0) {
  printf("\nERROR: Need to define a material using Union_make_material before using a Union geometry component. \n");
  printf("       %s was defined before first use of Union_make_material.\n",NAME_CURRENT_COMP);
  exit(1);
}

this_box_volume.geometry.is_masked_volume = 0;
this_box_volume.geometry.is_exit_volume = 0;
this_box_volume.geometry.is_mask_volume = 0;
// check if the volume is a mask, if it is the material string is irelevant.
if (mask_string && strlen(mask_string) && strcmp(mask_string, "NULL") && strcmp(mask_string, "0")) {
    // A mask volume is used to limit the extend of other volumes, called the masked volumes. These are specified in the mask_string.
    // In order for a ray to enter a masked volume, it needs to be both in the region covered by that volume AND the mask volume.
    // When more than
    this_box_volume.geometry.mask_mode = 1; // Default is mask mode is ALL
    if (mask_setting && strlen(mask_setting) && strcmp(mask_setting, "NULL") && strcmp(mask_setting, "0")) {
        if (strcmp(mask_setting,"ALL") == 0 || strcmp(mask_setting,"All") == 0) this_box_volume.geometry.mask_mode = 1;
        else if (strcmp(mask_setting,"ANY") == 0 || strcmp(mask_setting,"Any") == 0) this_box_volume.geometry.mask_mode = 2;
        else {
            printf("The mask_mode of component %s is set to %s, but must be either ALL or ANY.\n",NAME_CURRENT_COMP,mask_setting);
            exit(1);
        }
    }
    
    for (loop_index=0;loop_index<global_geometry_list.num_elements;loop_index++) {
        // Add mask list
        if (1 == manual_linking_function(global_geometry_list.elements[loop_index].name,mask_string)) {
            add_element_to_int_list(&this_box_volume.geometry.mask_list,global_geometry_list.elements[loop_index].component_index);
            add_element_to_int_list(&global_geometry_list.elements[loop_index].Volume->geometry.masked_by_list,INDEX_CURRENT_COMP);
            global_geometry_list.elements[loop_index].Volume->geometry.is_masked_volume = 1;
            if (this_box_volume.geometry.mask_mode == 2)
                global_geometry_list.elements[loop_index].Volume->geometry.mask_mode = 2;
            if (this_box_volume.geometry.mask_mode == 1) {
                if (global_geometry_list.elements[loop_index].Volume->geometry.is_masked_volume == 1 && global_geometry_list.elements[loop_index].Volume->geometry.mask_mode != 2)
                    // If more than one mask is added to one volume, the ANY mode overwrites the (default) ALL mode.
                    global_geometry_list.elements[loop_index].Volume->geometry.mask_mode = 1;
            }
            
            found_geometries = 1;
        }
    }
    if (found_geometries == 0) {
        printf("The mask_string in geometry: %s did not find any of the specified volumes in the mask_string %s \n",NAME_CURRENT_COMP,mask_string);
        exit(1);
    }
    this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
    this_box_volume.p_physics->is_vacuum = 0; // Makes this volume a vacuum
    this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
    this_box_volume.p_physics->my_a = 0; // Should not be used.
    sprintf(this_box_volume.p_physics->name,"Mask");
    this_box_volume.geometry.is_mask_volume = 1;
    
    
// Read the material input, or if it lacks, use automatic linking.
} else if (material_string && strlen(material_string) && strcmp(material_string, "NULL") && strcmp(material_string, "0")) {
    // A geometry string was given, use it to determine which material
    if (0 == strcmp(material_string,"vacuum") || 0 == strcmp(material_string,"Vacuum")) {
        // One could have a global physics struct for vacuum instead of creating one for each
        this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
        this_box_volume.p_physics->is_vacuum = 1; // Makes this volume a vacuum
        this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
        this_box_volume.p_physics->my_a = 0; // Should not be used.
        sprintf(this_box_volume.p_physics->name,"Vacuum");
    } else if (0 == strcmp(material_string,"exit") || 0 == strcmp(material_string,"Exit")) {
        // One could have a global physics struct for vacuum instead of creating one for each
        this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
        this_box_volume.p_physics->is_vacuum = 1; // Makes this volume a vacuum
        this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
        this_box_volume.p_physics->my_a = 0; // Should not be used.
        this_box_volume.geometry.is_exit_volume = 1;
        sprintf(this_box_volume.p_physics->name,"Exit");
    } else {
        #ifndef MATERIAL_DETECTOR
            printf("Need to define a material before refering to it in a geometry %s.\n",NAME_CURRENT_COMP);
            exit(1);
        #endif
        for (loop_index=0;loop_index<global_material_list.num_elements;loop_index++) {
            if (0 == strcmp(material_string,global_material_list.elements[loop_index].name)) {
                this_box_volume.p_physics = global_material_list.elements[loop_index].physics;
                break;
            }
            if (loop_index == global_material_list.num_elements-1) {
            printf("\n");
            printf("ERROR: The material string \"%s\" in Union geometry \"%s\" did not match a specified material. \n",material_string,NAME_CURRENT_COMP);
            printf("       The materials available at this point (need to be defined before the geometry): \n");
            for (loop_index=0;loop_index<global_material_list.num_elements;loop_index++)
              printf("         %s\n",global_material_list.elements[loop_index].name);
            printf("\n");
            printf("       It is also possible to use one of the defualt materials avaiable: \n");
            printf("           Vacuum (for a Volume without scattering or absorption)\n");
            printf("           Exit (for a Volume where the ray exits the component if it enters)\n");
            printf("           Mask (for a Volume that masks existing volumes specified in the mask_string\n");
            exit(1);
          }
        }
    }
} else {
    // Automatic linking, simply using the last defined material.
    #ifndef MATERIAL_DETECTOR
        printf("Need to define a material before the geometry to use automatic linking %s.\n",NAME_CURRENT_COMP);
        exit(1);
    #endif
    this_box_volume.p_physics = global_material_list.elements[global_material_list.num_elements-1].physics;
}

sprintf(this_box_volume.name,NAME_CURRENT_COMP);
sprintf(this_box_volume.geometry.shape,"box");
this_box_volume.geometry.priority_value = priority;
this_box_volume.geometry.geometry_p_interact = p_interact;
// Currently the coordinates will be in absolute space.
this_box_volume.geometry.center = POS_A_CURRENT_COMP;

this_box_storage.z_depth = zdepth;
this_box_storage.x_width1 = xwidth;
this_box_storage.y_height1 = yheight;

this_box_storage.is_rectangle = 0;
if (xwidth2 < 0 && yheight2 < 0) this_box_storage.is_rectangle = 1;
if (xwidth == xwidth2 && yheight == yheight2) this_box_storage.is_rectangle = 1;

if (xwidth2 < 0) {
    this_box_storage.x_width2 = xwidth;
    xwidth2 = xwidth;
} else this_box_storage.x_width2 = xwidth2;

if (yheight2 < 0) {
    this_box_storage.y_height2 = yheight;
    yheight2 = yheight;
} else this_box_storage.y_height2 = yheight2;


this_box_storage.normal_vectors[0] = coords_set(0,0,1);
this_box_storage.normal_vectors[1] = coords_set(0,0,1);

// for sides with y component = 0
x_component = 2*zdepth/sqrt((xwidth-xwidth2)*(xwidth-xwidth2)+4*zdepth*zdepth);
z_component = (xwidth-xwidth2)/sqrt(4*zdepth*zdepth+(xwidth-xwidth2)*(xwidth-xwidth2));

this_box_storage.normal_vectors[2] = coords_set(x_component,0,z_component);
this_box_storage.normal_vectors[3] = coords_set(-x_component,0,z_component);

// for sides with x component = 0
y_component = 2*zdepth/sqrt((yheight-yheight2)*(yheight-yheight2)+4*zdepth*zdepth);
z_component = (yheight-yheight2)/sqrt(4*zdepth*zdepth+(yheight-yheight2)*(yheight-yheight2));

this_box_storage.normal_vectors[4] = coords_set(0,y_component,z_component);
this_box_storage.normal_vectors[5] = coords_set(0,-y_component,z_component);

this_box_volume.geometry.visualization_on = visualize;

this_box_volume.geometry.geometry_parameters.p_box_storage = &this_box_storage;

// Assign pointers to functions for intersection with the shape, checking if a point is inside the shape
if (this_box_storage.is_rectangle == 1) {
this_box_volume.geometry.intersect_function = &sample_box_intersect_simple;
this_box_volume.geometry.within_function = &r_within_box_simple;
}
else {
this_box_volume.geometry.intersect_function = &sample_box_intersect_advanced;
this_box_volume.geometry.within_function = &r_within_box_advanced;
}

this_box_volume.geometry.shell_points = &box_shell_points;
this_box_volume.geometry.mcdisplay_function = &mcdisplay_box_function;
this_box_volume.geometry.initialize_from_main_function = &initialize_box_geometry_from_main_component;
this_box_volume.geometry.process_rot_allocated = 0;

this_box_volume.geometry.copy_geometry_parameters = &allocate_box_storage_copy;

rot_copy(this_box_volume.geometry.rotation_matrix,ROT_A_CURRENT_COMP); //check how ROT_R_CURRENT_COMP would work
rot_transpose(ROT_A_CURRENT_COMP,this_box_volume.geometry.transpose_rotation_matrix);

// Initialize loggers
this_box_volume.loggers.num_elements = 0;

// packing the information into the global_geometry_element, which is then included in the global_geometry_list.
sprintf(global_geometry_element.name,NAME_CURRENT_COMP);
global_geometry_element.activation_counter = number_of_activations;
global_geometry_element.component_index = INDEX_CURRENT_COMP;
global_geometry_element.Volume = &this_box_volume; // Would be nicer if this m was a pointer, now we have the (small) data two places
add_element_to_geometry_list(&global_geometry_list,global_geometry_element);
}
#line 211988 "MACS_sample_kidney_box.c"
#undef number_of_activations
#undef mask_setting
#undef mask_string
#undef p_interact
#undef focus_r
#undef focus_xh
#undef focus_xw
#undef focus_ah
#undef focus_aw
#undef target_z
#undef target_y
#undef target_x
#undef target_index
#undef visualize
#undef yheight2
#undef xwidth2
#undef zdepth
#undef yheight
#undef xwidth
#undef priority
#undef material_string
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

  /* Initializations for component channel_5_analyzer_2_center. */
  SIG_MESSAGE("channel_5_analyzer_2_center (Init)");

  /* Initializations for component channel_5_analyzer_2_rotated. */
  SIG_MESSAGE("channel_5_analyzer_2_rotated (Init)");

  /* Initializations for component channel_5_analyzer_2_array_crystal_array_0. */
  SIG_MESSAGE("channel_5_analyzer_2_array_crystal_array_0 (Init)");
#define mccompcurname  channel_5_analyzer_2_array_crystal_array_0
#define mccompcurtype  Union_box
#define mccompcurindex 331
#define loop_index mccchannel_5_analyzer_2_array_crystal_array_0_loop_index
#define this_box_volume mccchannel_5_analyzer_2_array_crystal_array_0_this_box_volume
#define global_geometry_element mccchannel_5_analyzer_2_array_crystal_array_0_global_geometry_element
#define this_box_storage mccchannel_5_analyzer_2_array_crystal_array_0_this_box_storage
#define material_string mccchannel_5_analyzer_2_array_crystal_array_0_material_string
#define priority mccchannel_5_analyzer_2_array_crystal_array_0_priority
#define xwidth mccchannel_5_analyzer_2_array_crystal_array_0_xwidth
#define yheight mccchannel_5_analyzer_2_array_crystal_array_0_yheight
#define zdepth mccchannel_5_analyzer_2_array_crystal_array_0_zdepth
#define xwidth2 mccchannel_5_analyzer_2_array_crystal_array_0_xwidth2
#define yheight2 mccchannel_5_analyzer_2_array_crystal_array_0_yheight2
#define visualize mccchannel_5_analyzer_2_array_crystal_array_0_visualize
#define target_index mccchannel_5_analyzer_2_array_crystal_array_0_target_index
#define target_x mccchannel_5_analyzer_2_array_crystal_array_0_target_x
#define target_y mccchannel_5_analyzer_2_array_crystal_array_0_target_y
#define target_z mccchannel_5_analyzer_2_array_crystal_array_0_target_z
#define focus_aw mccchannel_5_analyzer_2_array_crystal_array_0_focus_aw
#define focus_ah mccchannel_5_analyzer_2_array_crystal_array_0_focus_ah
#define focus_xw mccchannel_5_analyzer_2_array_crystal_array_0_focus_xw
#define focus_xh mccchannel_5_analyzer_2_array_crystal_array_0_focus_xh
#define focus_r mccchannel_5_analyzer_2_array_crystal_array_0_focus_r
#define p_interact mccchannel_5_analyzer_2_array_crystal_array_0_p_interact
#define mask_string mccchannel_5_analyzer_2_array_crystal_array_0_mask_string
#define mask_setting mccchannel_5_analyzer_2_array_crystal_array_0_mask_setting
#define number_of_activations mccchannel_5_analyzer_2_array_crystal_array_0_number_of_activations
#line 224 "Union_box.comp"
{
// Initializes the focusing system for this volume including input sanitation.
focus_initialize(&this_box_volume.geometry, POS_A_COMP_INDEX(INDEX_CURRENT_COMP+target_index), POS_A_CURRENT_COMP, ROT_A_CURRENT_COMP, target_index, target_x, target_y, target_z, focus_aw, focus_ah, focus_xw, focus_xh, focus_r, NAME_CURRENT_COMP);

// Input sanitation for this geometry
if (xwidth <= 0) {
  printf("\nERROR in Union_box named %s, the xwidth is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (yheight <= 0) {
  printf("\nERROR in Union_box named %s, yheight is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (zdepth <= 0) {
  printf("\nERROR in Union_box named %s, zdepth is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (xwidth2 <= 0 && xwidth2 != -1) {
  printf("\nERROR in Union_box named %s, the xwidth2 is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (yheight2 <= 0 && yheight2 != -1) {
  printf("\nERROR in Union_box named %s, yheight2 is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}

// Use sanitation
if (global_material_list.num_elements == 0) {
  printf("\nERROR: Need to define a material using Union_make_material before using a Union geometry component. \n");
  printf("       %s was defined before first use of Union_make_material.\n",NAME_CURRENT_COMP);
  exit(1);
}

this_box_volume.geometry.is_masked_volume = 0;
this_box_volume.geometry.is_exit_volume = 0;
this_box_volume.geometry.is_mask_volume = 0;
// check if the volume is a mask, if it is the material string is irelevant.
if (mask_string && strlen(mask_string) && strcmp(mask_string, "NULL") && strcmp(mask_string, "0")) {
    // A mask volume is used to limit the extend of other volumes, called the masked volumes. These are specified in the mask_string.
    // In order for a ray to enter a masked volume, it needs to be both in the region covered by that volume AND the mask volume.
    // When more than
    this_box_volume.geometry.mask_mode = 1; // Default is mask mode is ALL
    if (mask_setting && strlen(mask_setting) && strcmp(mask_setting, "NULL") && strcmp(mask_setting, "0")) {
        if (strcmp(mask_setting,"ALL") == 0 || strcmp(mask_setting,"All") == 0) this_box_volume.geometry.mask_mode = 1;
        else if (strcmp(mask_setting,"ANY") == 0 || strcmp(mask_setting,"Any") == 0) this_box_volume.geometry.mask_mode = 2;
        else {
            printf("The mask_mode of component %s is set to %s, but must be either ALL or ANY.\n",NAME_CURRENT_COMP,mask_setting);
            exit(1);
        }
    }
    
    for (loop_index=0;loop_index<global_geometry_list.num_elements;loop_index++) {
        // Add mask list
        if (1 == manual_linking_function(global_geometry_list.elements[loop_index].name,mask_string)) {
            add_element_to_int_list(&this_box_volume.geometry.mask_list,global_geometry_list.elements[loop_index].component_index);
            add_element_to_int_list(&global_geometry_list.elements[loop_index].Volume->geometry.masked_by_list,INDEX_CURRENT_COMP);
            global_geometry_list.elements[loop_index].Volume->geometry.is_masked_volume = 1;
            if (this_box_volume.geometry.mask_mode == 2)
                global_geometry_list.elements[loop_index].Volume->geometry.mask_mode = 2;
            if (this_box_volume.geometry.mask_mode == 1) {
                if (global_geometry_list.elements[loop_index].Volume->geometry.is_masked_volume == 1 && global_geometry_list.elements[loop_index].Volume->geometry.mask_mode != 2)
                    // If more than one mask is added to one volume, the ANY mode overwrites the (default) ALL mode.
                    global_geometry_list.elements[loop_index].Volume->geometry.mask_mode = 1;
            }
            
            found_geometries = 1;
        }
    }
    if (found_geometries == 0) {
        printf("The mask_string in geometry: %s did not find any of the specified volumes in the mask_string %s \n",NAME_CURRENT_COMP,mask_string);
        exit(1);
    }
    this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
    this_box_volume.p_physics->is_vacuum = 0; // Makes this volume a vacuum
    this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
    this_box_volume.p_physics->my_a = 0; // Should not be used.
    sprintf(this_box_volume.p_physics->name,"Mask");
    this_box_volume.geometry.is_mask_volume = 1;
    
    
// Read the material input, or if it lacks, use automatic linking.
} else if (material_string && strlen(material_string) && strcmp(material_string, "NULL") && strcmp(material_string, "0")) {
    // A geometry string was given, use it to determine which material
    if (0 == strcmp(material_string,"vacuum") || 0 == strcmp(material_string,"Vacuum")) {
        // One could have a global physics struct for vacuum instead of creating one for each
        this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
        this_box_volume.p_physics->is_vacuum = 1; // Makes this volume a vacuum
        this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
        this_box_volume.p_physics->my_a = 0; // Should not be used.
        sprintf(this_box_volume.p_physics->name,"Vacuum");
    } else if (0 == strcmp(material_string,"exit") || 0 == strcmp(material_string,"Exit")) {
        // One could have a global physics struct for vacuum instead of creating one for each
        this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
        this_box_volume.p_physics->is_vacuum = 1; // Makes this volume a vacuum
        this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
        this_box_volume.p_physics->my_a = 0; // Should not be used.
        this_box_volume.geometry.is_exit_volume = 1;
        sprintf(this_box_volume.p_physics->name,"Exit");
    } else {
        #ifndef MATERIAL_DETECTOR
            printf("Need to define a material before refering to it in a geometry %s.\n",NAME_CURRENT_COMP);
            exit(1);
        #endif
        for (loop_index=0;loop_index<global_material_list.num_elements;loop_index++) {
            if (0 == strcmp(material_string,global_material_list.elements[loop_index].name)) {
                this_box_volume.p_physics = global_material_list.elements[loop_index].physics;
                break;
            }
            if (loop_index == global_material_list.num_elements-1) {
            printf("\n");
            printf("ERROR: The material string \"%s\" in Union geometry \"%s\" did not match a specified material. \n",material_string,NAME_CURRENT_COMP);
            printf("       The materials available at this point (need to be defined before the geometry): \n");
            for (loop_index=0;loop_index<global_material_list.num_elements;loop_index++)
              printf("         %s\n",global_material_list.elements[loop_index].name);
            printf("\n");
            printf("       It is also possible to use one of the defualt materials avaiable: \n");
            printf("           Vacuum (for a Volume without scattering or absorption)\n");
            printf("           Exit (for a Volume where the ray exits the component if it enters)\n");
            printf("           Mask (for a Volume that masks existing volumes specified in the mask_string\n");
            exit(1);
          }
        }
    }
} else {
    // Automatic linking, simply using the last defined material.
    #ifndef MATERIAL_DETECTOR
        printf("Need to define a material before the geometry to use automatic linking %s.\n",NAME_CURRENT_COMP);
        exit(1);
    #endif
    this_box_volume.p_physics = global_material_list.elements[global_material_list.num_elements-1].physics;
}

sprintf(this_box_volume.name,NAME_CURRENT_COMP);
sprintf(this_box_volume.geometry.shape,"box");
this_box_volume.geometry.priority_value = priority;
this_box_volume.geometry.geometry_p_interact = p_interact;
// Currently the coordinates will be in absolute space.
this_box_volume.geometry.center = POS_A_CURRENT_COMP;

this_box_storage.z_depth = zdepth;
this_box_storage.x_width1 = xwidth;
this_box_storage.y_height1 = yheight;

this_box_storage.is_rectangle = 0;
if (xwidth2 < 0 && yheight2 < 0) this_box_storage.is_rectangle = 1;
if (xwidth == xwidth2 && yheight == yheight2) this_box_storage.is_rectangle = 1;

if (xwidth2 < 0) {
    this_box_storage.x_width2 = xwidth;
    xwidth2 = xwidth;
} else this_box_storage.x_width2 = xwidth2;

if (yheight2 < 0) {
    this_box_storage.y_height2 = yheight;
    yheight2 = yheight;
} else this_box_storage.y_height2 = yheight2;


this_box_storage.normal_vectors[0] = coords_set(0,0,1);
this_box_storage.normal_vectors[1] = coords_set(0,0,1);

// for sides with y component = 0
x_component = 2*zdepth/sqrt((xwidth-xwidth2)*(xwidth-xwidth2)+4*zdepth*zdepth);
z_component = (xwidth-xwidth2)/sqrt(4*zdepth*zdepth+(xwidth-xwidth2)*(xwidth-xwidth2));

this_box_storage.normal_vectors[2] = coords_set(x_component,0,z_component);
this_box_storage.normal_vectors[3] = coords_set(-x_component,0,z_component);

// for sides with x component = 0
y_component = 2*zdepth/sqrt((yheight-yheight2)*(yheight-yheight2)+4*zdepth*zdepth);
z_component = (yheight-yheight2)/sqrt(4*zdepth*zdepth+(yheight-yheight2)*(yheight-yheight2));

this_box_storage.normal_vectors[4] = coords_set(0,y_component,z_component);
this_box_storage.normal_vectors[5] = coords_set(0,-y_component,z_component);

this_box_volume.geometry.visualization_on = visualize;

this_box_volume.geometry.geometry_parameters.p_box_storage = &this_box_storage;

// Assign pointers to functions for intersection with the shape, checking if a point is inside the shape
if (this_box_storage.is_rectangle == 1) {
this_box_volume.geometry.intersect_function = &sample_box_intersect_simple;
this_box_volume.geometry.within_function = &r_within_box_simple;
}
else {
this_box_volume.geometry.intersect_function = &sample_box_intersect_advanced;
this_box_volume.geometry.within_function = &r_within_box_advanced;
}

this_box_volume.geometry.shell_points = &box_shell_points;
this_box_volume.geometry.mcdisplay_function = &mcdisplay_box_function;
this_box_volume.geometry.initialize_from_main_function = &initialize_box_geometry_from_main_component;
this_box_volume.geometry.process_rot_allocated = 0;

this_box_volume.geometry.copy_geometry_parameters = &allocate_box_storage_copy;

rot_copy(this_box_volume.geometry.rotation_matrix,ROT_A_CURRENT_COMP); //check how ROT_R_CURRENT_COMP would work
rot_transpose(ROT_A_CURRENT_COMP,this_box_volume.geometry.transpose_rotation_matrix);

// Initialize loggers
this_box_volume.loggers.num_elements = 0;

// packing the information into the global_geometry_element, which is then included in the global_geometry_list.
sprintf(global_geometry_element.name,NAME_CURRENT_COMP);
global_geometry_element.activation_counter = number_of_activations;
global_geometry_element.component_index = INDEX_CURRENT_COMP;
global_geometry_element.Volume = &this_box_volume; // Would be nicer if this m was a pointer, now we have the (small) data two places
add_element_to_geometry_list(&global_geometry_list,global_geometry_element);
}
#line 212264 "MACS_sample_kidney_box.c"
#undef number_of_activations
#undef mask_setting
#undef mask_string
#undef p_interact
#undef focus_r
#undef focus_xh
#undef focus_xw
#undef focus_ah
#undef focus_aw
#undef target_z
#undef target_y
#undef target_x
#undef target_index
#undef visualize
#undef yheight2
#undef xwidth2
#undef zdepth
#undef yheight
#undef xwidth
#undef priority
#undef material_string
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

  /* Initializations for component channel_5_analyzer_2_array_crystal_array_1. */
  SIG_MESSAGE("channel_5_analyzer_2_array_crystal_array_1 (Init)");
#define mccompcurname  channel_5_analyzer_2_array_crystal_array_1
#define mccompcurtype  Union_box
#define mccompcurindex 332
#define loop_index mccchannel_5_analyzer_2_array_crystal_array_1_loop_index
#define this_box_volume mccchannel_5_analyzer_2_array_crystal_array_1_this_box_volume
#define global_geometry_element mccchannel_5_analyzer_2_array_crystal_array_1_global_geometry_element
#define this_box_storage mccchannel_5_analyzer_2_array_crystal_array_1_this_box_storage
#define material_string mccchannel_5_analyzer_2_array_crystal_array_1_material_string
#define priority mccchannel_5_analyzer_2_array_crystal_array_1_priority
#define xwidth mccchannel_5_analyzer_2_array_crystal_array_1_xwidth
#define yheight mccchannel_5_analyzer_2_array_crystal_array_1_yheight
#define zdepth mccchannel_5_analyzer_2_array_crystal_array_1_zdepth
#define xwidth2 mccchannel_5_analyzer_2_array_crystal_array_1_xwidth2
#define yheight2 mccchannel_5_analyzer_2_array_crystal_array_1_yheight2
#define visualize mccchannel_5_analyzer_2_array_crystal_array_1_visualize
#define target_index mccchannel_5_analyzer_2_array_crystal_array_1_target_index
#define target_x mccchannel_5_analyzer_2_array_crystal_array_1_target_x
#define target_y mccchannel_5_analyzer_2_array_crystal_array_1_target_y
#define target_z mccchannel_5_analyzer_2_array_crystal_array_1_target_z
#define focus_aw mccchannel_5_analyzer_2_array_crystal_array_1_focus_aw
#define focus_ah mccchannel_5_analyzer_2_array_crystal_array_1_focus_ah
#define focus_xw mccchannel_5_analyzer_2_array_crystal_array_1_focus_xw
#define focus_xh mccchannel_5_analyzer_2_array_crystal_array_1_focus_xh
#define focus_r mccchannel_5_analyzer_2_array_crystal_array_1_focus_r
#define p_interact mccchannel_5_analyzer_2_array_crystal_array_1_p_interact
#define mask_string mccchannel_5_analyzer_2_array_crystal_array_1_mask_string
#define mask_setting mccchannel_5_analyzer_2_array_crystal_array_1_mask_setting
#define number_of_activations mccchannel_5_analyzer_2_array_crystal_array_1_number_of_activations
#line 224 "Union_box.comp"
{
// Initializes the focusing system for this volume including input sanitation.
focus_initialize(&this_box_volume.geometry, POS_A_COMP_INDEX(INDEX_CURRENT_COMP+target_index), POS_A_CURRENT_COMP, ROT_A_CURRENT_COMP, target_index, target_x, target_y, target_z, focus_aw, focus_ah, focus_xw, focus_xh, focus_r, NAME_CURRENT_COMP);

// Input sanitation for this geometry
if (xwidth <= 0) {
  printf("\nERROR in Union_box named %s, the xwidth is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (yheight <= 0) {
  printf("\nERROR in Union_box named %s, yheight is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (zdepth <= 0) {
  printf("\nERROR in Union_box named %s, zdepth is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (xwidth2 <= 0 && xwidth2 != -1) {
  printf("\nERROR in Union_box named %s, the xwidth2 is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (yheight2 <= 0 && yheight2 != -1) {
  printf("\nERROR in Union_box named %s, yheight2 is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}

// Use sanitation
if (global_material_list.num_elements == 0) {
  printf("\nERROR: Need to define a material using Union_make_material before using a Union geometry component. \n");
  printf("       %s was defined before first use of Union_make_material.\n",NAME_CURRENT_COMP);
  exit(1);
}

this_box_volume.geometry.is_masked_volume = 0;
this_box_volume.geometry.is_exit_volume = 0;
this_box_volume.geometry.is_mask_volume = 0;
// check if the volume is a mask, if it is the material string is irelevant.
if (mask_string && strlen(mask_string) && strcmp(mask_string, "NULL") && strcmp(mask_string, "0")) {
    // A mask volume is used to limit the extend of other volumes, called the masked volumes. These are specified in the mask_string.
    // In order for a ray to enter a masked volume, it needs to be both in the region covered by that volume AND the mask volume.
    // When more than
    this_box_volume.geometry.mask_mode = 1; // Default is mask mode is ALL
    if (mask_setting && strlen(mask_setting) && strcmp(mask_setting, "NULL") && strcmp(mask_setting, "0")) {
        if (strcmp(mask_setting,"ALL") == 0 || strcmp(mask_setting,"All") == 0) this_box_volume.geometry.mask_mode = 1;
        else if (strcmp(mask_setting,"ANY") == 0 || strcmp(mask_setting,"Any") == 0) this_box_volume.geometry.mask_mode = 2;
        else {
            printf("The mask_mode of component %s is set to %s, but must be either ALL or ANY.\n",NAME_CURRENT_COMP,mask_setting);
            exit(1);
        }
    }
    
    for (loop_index=0;loop_index<global_geometry_list.num_elements;loop_index++) {
        // Add mask list
        if (1 == manual_linking_function(global_geometry_list.elements[loop_index].name,mask_string)) {
            add_element_to_int_list(&this_box_volume.geometry.mask_list,global_geometry_list.elements[loop_index].component_index);
            add_element_to_int_list(&global_geometry_list.elements[loop_index].Volume->geometry.masked_by_list,INDEX_CURRENT_COMP);
            global_geometry_list.elements[loop_index].Volume->geometry.is_masked_volume = 1;
            if (this_box_volume.geometry.mask_mode == 2)
                global_geometry_list.elements[loop_index].Volume->geometry.mask_mode = 2;
            if (this_box_volume.geometry.mask_mode == 1) {
                if (global_geometry_list.elements[loop_index].Volume->geometry.is_masked_volume == 1 && global_geometry_list.elements[loop_index].Volume->geometry.mask_mode != 2)
                    // If more than one mask is added to one volume, the ANY mode overwrites the (default) ALL mode.
                    global_geometry_list.elements[loop_index].Volume->geometry.mask_mode = 1;
            }
            
            found_geometries = 1;
        }
    }
    if (found_geometries == 0) {
        printf("The mask_string in geometry: %s did not find any of the specified volumes in the mask_string %s \n",NAME_CURRENT_COMP,mask_string);
        exit(1);
    }
    this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
    this_box_volume.p_physics->is_vacuum = 0; // Makes this volume a vacuum
    this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
    this_box_volume.p_physics->my_a = 0; // Should not be used.
    sprintf(this_box_volume.p_physics->name,"Mask");
    this_box_volume.geometry.is_mask_volume = 1;
    
    
// Read the material input, or if it lacks, use automatic linking.
} else if (material_string && strlen(material_string) && strcmp(material_string, "NULL") && strcmp(material_string, "0")) {
    // A geometry string was given, use it to determine which material
    if (0 == strcmp(material_string,"vacuum") || 0 == strcmp(material_string,"Vacuum")) {
        // One could have a global physics struct for vacuum instead of creating one for each
        this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
        this_box_volume.p_physics->is_vacuum = 1; // Makes this volume a vacuum
        this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
        this_box_volume.p_physics->my_a = 0; // Should not be used.
        sprintf(this_box_volume.p_physics->name,"Vacuum");
    } else if (0 == strcmp(material_string,"exit") || 0 == strcmp(material_string,"Exit")) {
        // One could have a global physics struct for vacuum instead of creating one for each
        this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
        this_box_volume.p_physics->is_vacuum = 1; // Makes this volume a vacuum
        this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
        this_box_volume.p_physics->my_a = 0; // Should not be used.
        this_box_volume.geometry.is_exit_volume = 1;
        sprintf(this_box_volume.p_physics->name,"Exit");
    } else {
        #ifndef MATERIAL_DETECTOR
            printf("Need to define a material before refering to it in a geometry %s.\n",NAME_CURRENT_COMP);
            exit(1);
        #endif
        for (loop_index=0;loop_index<global_material_list.num_elements;loop_index++) {
            if (0 == strcmp(material_string,global_material_list.elements[loop_index].name)) {
                this_box_volume.p_physics = global_material_list.elements[loop_index].physics;
                break;
            }
            if (loop_index == global_material_list.num_elements-1) {
            printf("\n");
            printf("ERROR: The material string \"%s\" in Union geometry \"%s\" did not match a specified material. \n",material_string,NAME_CURRENT_COMP);
            printf("       The materials available at this point (need to be defined before the geometry): \n");
            for (loop_index=0;loop_index<global_material_list.num_elements;loop_index++)
              printf("         %s\n",global_material_list.elements[loop_index].name);
            printf("\n");
            printf("       It is also possible to use one of the defualt materials avaiable: \n");
            printf("           Vacuum (for a Volume without scattering or absorption)\n");
            printf("           Exit (for a Volume where the ray exits the component if it enters)\n");
            printf("           Mask (for a Volume that masks existing volumes specified in the mask_string\n");
            exit(1);
          }
        }
    }
} else {
    // Automatic linking, simply using the last defined material.
    #ifndef MATERIAL_DETECTOR
        printf("Need to define a material before the geometry to use automatic linking %s.\n",NAME_CURRENT_COMP);
        exit(1);
    #endif
    this_box_volume.p_physics = global_material_list.elements[global_material_list.num_elements-1].physics;
}

sprintf(this_box_volume.name,NAME_CURRENT_COMP);
sprintf(this_box_volume.geometry.shape,"box");
this_box_volume.geometry.priority_value = priority;
this_box_volume.geometry.geometry_p_interact = p_interact;
// Currently the coordinates will be in absolute space.
this_box_volume.geometry.center = POS_A_CURRENT_COMP;

this_box_storage.z_depth = zdepth;
this_box_storage.x_width1 = xwidth;
this_box_storage.y_height1 = yheight;

this_box_storage.is_rectangle = 0;
if (xwidth2 < 0 && yheight2 < 0) this_box_storage.is_rectangle = 1;
if (xwidth == xwidth2 && yheight == yheight2) this_box_storage.is_rectangle = 1;

if (xwidth2 < 0) {
    this_box_storage.x_width2 = xwidth;
    xwidth2 = xwidth;
} else this_box_storage.x_width2 = xwidth2;

if (yheight2 < 0) {
    this_box_storage.y_height2 = yheight;
    yheight2 = yheight;
} else this_box_storage.y_height2 = yheight2;


this_box_storage.normal_vectors[0] = coords_set(0,0,1);
this_box_storage.normal_vectors[1] = coords_set(0,0,1);

// for sides with y component = 0
x_component = 2*zdepth/sqrt((xwidth-xwidth2)*(xwidth-xwidth2)+4*zdepth*zdepth);
z_component = (xwidth-xwidth2)/sqrt(4*zdepth*zdepth+(xwidth-xwidth2)*(xwidth-xwidth2));

this_box_storage.normal_vectors[2] = coords_set(x_component,0,z_component);
this_box_storage.normal_vectors[3] = coords_set(-x_component,0,z_component);

// for sides with x component = 0
y_component = 2*zdepth/sqrt((yheight-yheight2)*(yheight-yheight2)+4*zdepth*zdepth);
z_component = (yheight-yheight2)/sqrt(4*zdepth*zdepth+(yheight-yheight2)*(yheight-yheight2));

this_box_storage.normal_vectors[4] = coords_set(0,y_component,z_component);
this_box_storage.normal_vectors[5] = coords_set(0,-y_component,z_component);

this_box_volume.geometry.visualization_on = visualize;

this_box_volume.geometry.geometry_parameters.p_box_storage = &this_box_storage;

// Assign pointers to functions for intersection with the shape, checking if a point is inside the shape
if (this_box_storage.is_rectangle == 1) {
this_box_volume.geometry.intersect_function = &sample_box_intersect_simple;
this_box_volume.geometry.within_function = &r_within_box_simple;
}
else {
this_box_volume.geometry.intersect_function = &sample_box_intersect_advanced;
this_box_volume.geometry.within_function = &r_within_box_advanced;
}

this_box_volume.geometry.shell_points = &box_shell_points;
this_box_volume.geometry.mcdisplay_function = &mcdisplay_box_function;
this_box_volume.geometry.initialize_from_main_function = &initialize_box_geometry_from_main_component;
this_box_volume.geometry.process_rot_allocated = 0;

this_box_volume.geometry.copy_geometry_parameters = &allocate_box_storage_copy;

rot_copy(this_box_volume.geometry.rotation_matrix,ROT_A_CURRENT_COMP); //check how ROT_R_CURRENT_COMP would work
rot_transpose(ROT_A_CURRENT_COMP,this_box_volume.geometry.transpose_rotation_matrix);

// Initialize loggers
this_box_volume.loggers.num_elements = 0;

// packing the information into the global_geometry_element, which is then included in the global_geometry_list.
sprintf(global_geometry_element.name,NAME_CURRENT_COMP);
global_geometry_element.activation_counter = number_of_activations;
global_geometry_element.component_index = INDEX_CURRENT_COMP;
global_geometry_element.Volume = &this_box_volume; // Would be nicer if this m was a pointer, now we have the (small) data two places
add_element_to_geometry_list(&global_geometry_list,global_geometry_element);
}
#line 212534 "MACS_sample_kidney_box.c"
#undef number_of_activations
#undef mask_setting
#undef mask_string
#undef p_interact
#undef focus_r
#undef focus_xh
#undef focus_xw
#undef focus_ah
#undef focus_aw
#undef target_z
#undef target_y
#undef target_x
#undef target_index
#undef visualize
#undef yheight2
#undef xwidth2
#undef zdepth
#undef yheight
#undef xwidth
#undef priority
#undef material_string
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

  /* Initializations for component channel_5_analyzer_2_array_crystal_array_2. */
  SIG_MESSAGE("channel_5_analyzer_2_array_crystal_array_2 (Init)");
#define mccompcurname  channel_5_analyzer_2_array_crystal_array_2
#define mccompcurtype  Union_box
#define mccompcurindex 333
#define loop_index mccchannel_5_analyzer_2_array_crystal_array_2_loop_index
#define this_box_volume mccchannel_5_analyzer_2_array_crystal_array_2_this_box_volume
#define global_geometry_element mccchannel_5_analyzer_2_array_crystal_array_2_global_geometry_element
#define this_box_storage mccchannel_5_analyzer_2_array_crystal_array_2_this_box_storage
#define material_string mccchannel_5_analyzer_2_array_crystal_array_2_material_string
#define priority mccchannel_5_analyzer_2_array_crystal_array_2_priority
#define xwidth mccchannel_5_analyzer_2_array_crystal_array_2_xwidth
#define yheight mccchannel_5_analyzer_2_array_crystal_array_2_yheight
#define zdepth mccchannel_5_analyzer_2_array_crystal_array_2_zdepth
#define xwidth2 mccchannel_5_analyzer_2_array_crystal_array_2_xwidth2
#define yheight2 mccchannel_5_analyzer_2_array_crystal_array_2_yheight2
#define visualize mccchannel_5_analyzer_2_array_crystal_array_2_visualize
#define target_index mccchannel_5_analyzer_2_array_crystal_array_2_target_index
#define target_x mccchannel_5_analyzer_2_array_crystal_array_2_target_x
#define target_y mccchannel_5_analyzer_2_array_crystal_array_2_target_y
#define target_z mccchannel_5_analyzer_2_array_crystal_array_2_target_z
#define focus_aw mccchannel_5_analyzer_2_array_crystal_array_2_focus_aw
#define focus_ah mccchannel_5_analyzer_2_array_crystal_array_2_focus_ah
#define focus_xw mccchannel_5_analyzer_2_array_crystal_array_2_focus_xw
#define focus_xh mccchannel_5_analyzer_2_array_crystal_array_2_focus_xh
#define focus_r mccchannel_5_analyzer_2_array_crystal_array_2_focus_r
#define p_interact mccchannel_5_analyzer_2_array_crystal_array_2_p_interact
#define mask_string mccchannel_5_analyzer_2_array_crystal_array_2_mask_string
#define mask_setting mccchannel_5_analyzer_2_array_crystal_array_2_mask_setting
#define number_of_activations mccchannel_5_analyzer_2_array_crystal_array_2_number_of_activations
#line 224 "Union_box.comp"
{
// Initializes the focusing system for this volume including input sanitation.
focus_initialize(&this_box_volume.geometry, POS_A_COMP_INDEX(INDEX_CURRENT_COMP+target_index), POS_A_CURRENT_COMP, ROT_A_CURRENT_COMP, target_index, target_x, target_y, target_z, focus_aw, focus_ah, focus_xw, focus_xh, focus_r, NAME_CURRENT_COMP);

// Input sanitation for this geometry
if (xwidth <= 0) {
  printf("\nERROR in Union_box named %s, the xwidth is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (yheight <= 0) {
  printf("\nERROR in Union_box named %s, yheight is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (zdepth <= 0) {
  printf("\nERROR in Union_box named %s, zdepth is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (xwidth2 <= 0 && xwidth2 != -1) {
  printf("\nERROR in Union_box named %s, the xwidth2 is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (yheight2 <= 0 && yheight2 != -1) {
  printf("\nERROR in Union_box named %s, yheight2 is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}

// Use sanitation
if (global_material_list.num_elements == 0) {
  printf("\nERROR: Need to define a material using Union_make_material before using a Union geometry component. \n");
  printf("       %s was defined before first use of Union_make_material.\n",NAME_CURRENT_COMP);
  exit(1);
}

this_box_volume.geometry.is_masked_volume = 0;
this_box_volume.geometry.is_exit_volume = 0;
this_box_volume.geometry.is_mask_volume = 0;
// check if the volume is a mask, if it is the material string is irelevant.
if (mask_string && strlen(mask_string) && strcmp(mask_string, "NULL") && strcmp(mask_string, "0")) {
    // A mask volume is used to limit the extend of other volumes, called the masked volumes. These are specified in the mask_string.
    // In order for a ray to enter a masked volume, it needs to be both in the region covered by that volume AND the mask volume.
    // When more than
    this_box_volume.geometry.mask_mode = 1; // Default is mask mode is ALL
    if (mask_setting && strlen(mask_setting) && strcmp(mask_setting, "NULL") && strcmp(mask_setting, "0")) {
        if (strcmp(mask_setting,"ALL") == 0 || strcmp(mask_setting,"All") == 0) this_box_volume.geometry.mask_mode = 1;
        else if (strcmp(mask_setting,"ANY") == 0 || strcmp(mask_setting,"Any") == 0) this_box_volume.geometry.mask_mode = 2;
        else {
            printf("The mask_mode of component %s is set to %s, but must be either ALL or ANY.\n",NAME_CURRENT_COMP,mask_setting);
            exit(1);
        }
    }
    
    for (loop_index=0;loop_index<global_geometry_list.num_elements;loop_index++) {
        // Add mask list
        if (1 == manual_linking_function(global_geometry_list.elements[loop_index].name,mask_string)) {
            add_element_to_int_list(&this_box_volume.geometry.mask_list,global_geometry_list.elements[loop_index].component_index);
            add_element_to_int_list(&global_geometry_list.elements[loop_index].Volume->geometry.masked_by_list,INDEX_CURRENT_COMP);
            global_geometry_list.elements[loop_index].Volume->geometry.is_masked_volume = 1;
            if (this_box_volume.geometry.mask_mode == 2)
                global_geometry_list.elements[loop_index].Volume->geometry.mask_mode = 2;
            if (this_box_volume.geometry.mask_mode == 1) {
                if (global_geometry_list.elements[loop_index].Volume->geometry.is_masked_volume == 1 && global_geometry_list.elements[loop_index].Volume->geometry.mask_mode != 2)
                    // If more than one mask is added to one volume, the ANY mode overwrites the (default) ALL mode.
                    global_geometry_list.elements[loop_index].Volume->geometry.mask_mode = 1;
            }
            
            found_geometries = 1;
        }
    }
    if (found_geometries == 0) {
        printf("The mask_string in geometry: %s did not find any of the specified volumes in the mask_string %s \n",NAME_CURRENT_COMP,mask_string);
        exit(1);
    }
    this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
    this_box_volume.p_physics->is_vacuum = 0; // Makes this volume a vacuum
    this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
    this_box_volume.p_physics->my_a = 0; // Should not be used.
    sprintf(this_box_volume.p_physics->name,"Mask");
    this_box_volume.geometry.is_mask_volume = 1;
    
    
// Read the material input, or if it lacks, use automatic linking.
} else if (material_string && strlen(material_string) && strcmp(material_string, "NULL") && strcmp(material_string, "0")) {
    // A geometry string was given, use it to determine which material
    if (0 == strcmp(material_string,"vacuum") || 0 == strcmp(material_string,"Vacuum")) {
        // One could have a global physics struct for vacuum instead of creating one for each
        this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
        this_box_volume.p_physics->is_vacuum = 1; // Makes this volume a vacuum
        this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
        this_box_volume.p_physics->my_a = 0; // Should not be used.
        sprintf(this_box_volume.p_physics->name,"Vacuum");
    } else if (0 == strcmp(material_string,"exit") || 0 == strcmp(material_string,"Exit")) {
        // One could have a global physics struct for vacuum instead of creating one for each
        this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
        this_box_volume.p_physics->is_vacuum = 1; // Makes this volume a vacuum
        this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
        this_box_volume.p_physics->my_a = 0; // Should not be used.
        this_box_volume.geometry.is_exit_volume = 1;
        sprintf(this_box_volume.p_physics->name,"Exit");
    } else {
        #ifndef MATERIAL_DETECTOR
            printf("Need to define a material before refering to it in a geometry %s.\n",NAME_CURRENT_COMP);
            exit(1);
        #endif
        for (loop_index=0;loop_index<global_material_list.num_elements;loop_index++) {
            if (0 == strcmp(material_string,global_material_list.elements[loop_index].name)) {
                this_box_volume.p_physics = global_material_list.elements[loop_index].physics;
                break;
            }
            if (loop_index == global_material_list.num_elements-1) {
            printf("\n");
            printf("ERROR: The material string \"%s\" in Union geometry \"%s\" did not match a specified material. \n",material_string,NAME_CURRENT_COMP);
            printf("       The materials available at this point (need to be defined before the geometry): \n");
            for (loop_index=0;loop_index<global_material_list.num_elements;loop_index++)
              printf("         %s\n",global_material_list.elements[loop_index].name);
            printf("\n");
            printf("       It is also possible to use one of the defualt materials avaiable: \n");
            printf("           Vacuum (for a Volume without scattering or absorption)\n");
            printf("           Exit (for a Volume where the ray exits the component if it enters)\n");
            printf("           Mask (for a Volume that masks existing volumes specified in the mask_string\n");
            exit(1);
          }
        }
    }
} else {
    // Automatic linking, simply using the last defined material.
    #ifndef MATERIAL_DETECTOR
        printf("Need to define a material before the geometry to use automatic linking %s.\n",NAME_CURRENT_COMP);
        exit(1);
    #endif
    this_box_volume.p_physics = global_material_list.elements[global_material_list.num_elements-1].physics;
}

sprintf(this_box_volume.name,NAME_CURRENT_COMP);
sprintf(this_box_volume.geometry.shape,"box");
this_box_volume.geometry.priority_value = priority;
this_box_volume.geometry.geometry_p_interact = p_interact;
// Currently the coordinates will be in absolute space.
this_box_volume.geometry.center = POS_A_CURRENT_COMP;

this_box_storage.z_depth = zdepth;
this_box_storage.x_width1 = xwidth;
this_box_storage.y_height1 = yheight;

this_box_storage.is_rectangle = 0;
if (xwidth2 < 0 && yheight2 < 0) this_box_storage.is_rectangle = 1;
if (xwidth == xwidth2 && yheight == yheight2) this_box_storage.is_rectangle = 1;

if (xwidth2 < 0) {
    this_box_storage.x_width2 = xwidth;
    xwidth2 = xwidth;
} else this_box_storage.x_width2 = xwidth2;

if (yheight2 < 0) {
    this_box_storage.y_height2 = yheight;
    yheight2 = yheight;
} else this_box_storage.y_height2 = yheight2;


this_box_storage.normal_vectors[0] = coords_set(0,0,1);
this_box_storage.normal_vectors[1] = coords_set(0,0,1);

// for sides with y component = 0
x_component = 2*zdepth/sqrt((xwidth-xwidth2)*(xwidth-xwidth2)+4*zdepth*zdepth);
z_component = (xwidth-xwidth2)/sqrt(4*zdepth*zdepth+(xwidth-xwidth2)*(xwidth-xwidth2));

this_box_storage.normal_vectors[2] = coords_set(x_component,0,z_component);
this_box_storage.normal_vectors[3] = coords_set(-x_component,0,z_component);

// for sides with x component = 0
y_component = 2*zdepth/sqrt((yheight-yheight2)*(yheight-yheight2)+4*zdepth*zdepth);
z_component = (yheight-yheight2)/sqrt(4*zdepth*zdepth+(yheight-yheight2)*(yheight-yheight2));

this_box_storage.normal_vectors[4] = coords_set(0,y_component,z_component);
this_box_storage.normal_vectors[5] = coords_set(0,-y_component,z_component);

this_box_volume.geometry.visualization_on = visualize;

this_box_volume.geometry.geometry_parameters.p_box_storage = &this_box_storage;

// Assign pointers to functions for intersection with the shape, checking if a point is inside the shape
if (this_box_storage.is_rectangle == 1) {
this_box_volume.geometry.intersect_function = &sample_box_intersect_simple;
this_box_volume.geometry.within_function = &r_within_box_simple;
}
else {
this_box_volume.geometry.intersect_function = &sample_box_intersect_advanced;
this_box_volume.geometry.within_function = &r_within_box_advanced;
}

this_box_volume.geometry.shell_points = &box_shell_points;
this_box_volume.geometry.mcdisplay_function = &mcdisplay_box_function;
this_box_volume.geometry.initialize_from_main_function = &initialize_box_geometry_from_main_component;
this_box_volume.geometry.process_rot_allocated = 0;

this_box_volume.geometry.copy_geometry_parameters = &allocate_box_storage_copy;

rot_copy(this_box_volume.geometry.rotation_matrix,ROT_A_CURRENT_COMP); //check how ROT_R_CURRENT_COMP would work
rot_transpose(ROT_A_CURRENT_COMP,this_box_volume.geometry.transpose_rotation_matrix);

// Initialize loggers
this_box_volume.loggers.num_elements = 0;

// packing the information into the global_geometry_element, which is then included in the global_geometry_list.
sprintf(global_geometry_element.name,NAME_CURRENT_COMP);
global_geometry_element.activation_counter = number_of_activations;
global_geometry_element.component_index = INDEX_CURRENT_COMP;
global_geometry_element.Volume = &this_box_volume; // Would be nicer if this m was a pointer, now we have the (small) data two places
add_element_to_geometry_list(&global_geometry_list,global_geometry_element);
}
#line 212804 "MACS_sample_kidney_box.c"
#undef number_of_activations
#undef mask_setting
#undef mask_string
#undef p_interact
#undef focus_r
#undef focus_xh
#undef focus_xw
#undef focus_ah
#undef focus_aw
#undef target_z
#undef target_y
#undef target_x
#undef target_index
#undef visualize
#undef yheight2
#undef xwidth2
#undef zdepth
#undef yheight
#undef xwidth
#undef priority
#undef material_string
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

  /* Initializations for component channel_5_analyzer_2_array_crystal_array_3. */
  SIG_MESSAGE("channel_5_analyzer_2_array_crystal_array_3 (Init)");
#define mccompcurname  channel_5_analyzer_2_array_crystal_array_3
#define mccompcurtype  Union_box
#define mccompcurindex 334
#define loop_index mccchannel_5_analyzer_2_array_crystal_array_3_loop_index
#define this_box_volume mccchannel_5_analyzer_2_array_crystal_array_3_this_box_volume
#define global_geometry_element mccchannel_5_analyzer_2_array_crystal_array_3_global_geometry_element
#define this_box_storage mccchannel_5_analyzer_2_array_crystal_array_3_this_box_storage
#define material_string mccchannel_5_analyzer_2_array_crystal_array_3_material_string
#define priority mccchannel_5_analyzer_2_array_crystal_array_3_priority
#define xwidth mccchannel_5_analyzer_2_array_crystal_array_3_xwidth
#define yheight mccchannel_5_analyzer_2_array_crystal_array_3_yheight
#define zdepth mccchannel_5_analyzer_2_array_crystal_array_3_zdepth
#define xwidth2 mccchannel_5_analyzer_2_array_crystal_array_3_xwidth2
#define yheight2 mccchannel_5_analyzer_2_array_crystal_array_3_yheight2
#define visualize mccchannel_5_analyzer_2_array_crystal_array_3_visualize
#define target_index mccchannel_5_analyzer_2_array_crystal_array_3_target_index
#define target_x mccchannel_5_analyzer_2_array_crystal_array_3_target_x
#define target_y mccchannel_5_analyzer_2_array_crystal_array_3_target_y
#define target_z mccchannel_5_analyzer_2_array_crystal_array_3_target_z
#define focus_aw mccchannel_5_analyzer_2_array_crystal_array_3_focus_aw
#define focus_ah mccchannel_5_analyzer_2_array_crystal_array_3_focus_ah
#define focus_xw mccchannel_5_analyzer_2_array_crystal_array_3_focus_xw
#define focus_xh mccchannel_5_analyzer_2_array_crystal_array_3_focus_xh
#define focus_r mccchannel_5_analyzer_2_array_crystal_array_3_focus_r
#define p_interact mccchannel_5_analyzer_2_array_crystal_array_3_p_interact
#define mask_string mccchannel_5_analyzer_2_array_crystal_array_3_mask_string
#define mask_setting mccchannel_5_analyzer_2_array_crystal_array_3_mask_setting
#define number_of_activations mccchannel_5_analyzer_2_array_crystal_array_3_number_of_activations
#line 224 "Union_box.comp"
{
// Initializes the focusing system for this volume including input sanitation.
focus_initialize(&this_box_volume.geometry, POS_A_COMP_INDEX(INDEX_CURRENT_COMP+target_index), POS_A_CURRENT_COMP, ROT_A_CURRENT_COMP, target_index, target_x, target_y, target_z, focus_aw, focus_ah, focus_xw, focus_xh, focus_r, NAME_CURRENT_COMP);

// Input sanitation for this geometry
if (xwidth <= 0) {
  printf("\nERROR in Union_box named %s, the xwidth is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (yheight <= 0) {
  printf("\nERROR in Union_box named %s, yheight is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (zdepth <= 0) {
  printf("\nERROR in Union_box named %s, zdepth is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (xwidth2 <= 0 && xwidth2 != -1) {
  printf("\nERROR in Union_box named %s, the xwidth2 is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (yheight2 <= 0 && yheight2 != -1) {
  printf("\nERROR in Union_box named %s, yheight2 is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}

// Use sanitation
if (global_material_list.num_elements == 0) {
  printf("\nERROR: Need to define a material using Union_make_material before using a Union geometry component. \n");
  printf("       %s was defined before first use of Union_make_material.\n",NAME_CURRENT_COMP);
  exit(1);
}

this_box_volume.geometry.is_masked_volume = 0;
this_box_volume.geometry.is_exit_volume = 0;
this_box_volume.geometry.is_mask_volume = 0;
// check if the volume is a mask, if it is the material string is irelevant.
if (mask_string && strlen(mask_string) && strcmp(mask_string, "NULL") && strcmp(mask_string, "0")) {
    // A mask volume is used to limit the extend of other volumes, called the masked volumes. These are specified in the mask_string.
    // In order for a ray to enter a masked volume, it needs to be both in the region covered by that volume AND the mask volume.
    // When more than
    this_box_volume.geometry.mask_mode = 1; // Default is mask mode is ALL
    if (mask_setting && strlen(mask_setting) && strcmp(mask_setting, "NULL") && strcmp(mask_setting, "0")) {
        if (strcmp(mask_setting,"ALL") == 0 || strcmp(mask_setting,"All") == 0) this_box_volume.geometry.mask_mode = 1;
        else if (strcmp(mask_setting,"ANY") == 0 || strcmp(mask_setting,"Any") == 0) this_box_volume.geometry.mask_mode = 2;
        else {
            printf("The mask_mode of component %s is set to %s, but must be either ALL or ANY.\n",NAME_CURRENT_COMP,mask_setting);
            exit(1);
        }
    }
    
    for (loop_index=0;loop_index<global_geometry_list.num_elements;loop_index++) {
        // Add mask list
        if (1 == manual_linking_function(global_geometry_list.elements[loop_index].name,mask_string)) {
            add_element_to_int_list(&this_box_volume.geometry.mask_list,global_geometry_list.elements[loop_index].component_index);
            add_element_to_int_list(&global_geometry_list.elements[loop_index].Volume->geometry.masked_by_list,INDEX_CURRENT_COMP);
            global_geometry_list.elements[loop_index].Volume->geometry.is_masked_volume = 1;
            if (this_box_volume.geometry.mask_mode == 2)
                global_geometry_list.elements[loop_index].Volume->geometry.mask_mode = 2;
            if (this_box_volume.geometry.mask_mode == 1) {
                if (global_geometry_list.elements[loop_index].Volume->geometry.is_masked_volume == 1 && global_geometry_list.elements[loop_index].Volume->geometry.mask_mode != 2)
                    // If more than one mask is added to one volume, the ANY mode overwrites the (default) ALL mode.
                    global_geometry_list.elements[loop_index].Volume->geometry.mask_mode = 1;
            }
            
            found_geometries = 1;
        }
    }
    if (found_geometries == 0) {
        printf("The mask_string in geometry: %s did not find any of the specified volumes in the mask_string %s \n",NAME_CURRENT_COMP,mask_string);
        exit(1);
    }
    this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
    this_box_volume.p_physics->is_vacuum = 0; // Makes this volume a vacuum
    this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
    this_box_volume.p_physics->my_a = 0; // Should not be used.
    sprintf(this_box_volume.p_physics->name,"Mask");
    this_box_volume.geometry.is_mask_volume = 1;
    
    
// Read the material input, or if it lacks, use automatic linking.
} else if (material_string && strlen(material_string) && strcmp(material_string, "NULL") && strcmp(material_string, "0")) {
    // A geometry string was given, use it to determine which material
    if (0 == strcmp(material_string,"vacuum") || 0 == strcmp(material_string,"Vacuum")) {
        // One could have a global physics struct for vacuum instead of creating one for each
        this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
        this_box_volume.p_physics->is_vacuum = 1; // Makes this volume a vacuum
        this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
        this_box_volume.p_physics->my_a = 0; // Should not be used.
        sprintf(this_box_volume.p_physics->name,"Vacuum");
    } else if (0 == strcmp(material_string,"exit") || 0 == strcmp(material_string,"Exit")) {
        // One could have a global physics struct for vacuum instead of creating one for each
        this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
        this_box_volume.p_physics->is_vacuum = 1; // Makes this volume a vacuum
        this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
        this_box_volume.p_physics->my_a = 0; // Should not be used.
        this_box_volume.geometry.is_exit_volume = 1;
        sprintf(this_box_volume.p_physics->name,"Exit");
    } else {
        #ifndef MATERIAL_DETECTOR
            printf("Need to define a material before refering to it in a geometry %s.\n",NAME_CURRENT_COMP);
            exit(1);
        #endif
        for (loop_index=0;loop_index<global_material_list.num_elements;loop_index++) {
            if (0 == strcmp(material_string,global_material_list.elements[loop_index].name)) {
                this_box_volume.p_physics = global_material_list.elements[loop_index].physics;
                break;
            }
            if (loop_index == global_material_list.num_elements-1) {
            printf("\n");
            printf("ERROR: The material string \"%s\" in Union geometry \"%s\" did not match a specified material. \n",material_string,NAME_CURRENT_COMP);
            printf("       The materials available at this point (need to be defined before the geometry): \n");
            for (loop_index=0;loop_index<global_material_list.num_elements;loop_index++)
              printf("         %s\n",global_material_list.elements[loop_index].name);
            printf("\n");
            printf("       It is also possible to use one of the defualt materials avaiable: \n");
            printf("           Vacuum (for a Volume without scattering or absorption)\n");
            printf("           Exit (for a Volume where the ray exits the component if it enters)\n");
            printf("           Mask (for a Volume that masks existing volumes specified in the mask_string\n");
            exit(1);
          }
        }
    }
} else {
    // Automatic linking, simply using the last defined material.
    #ifndef MATERIAL_DETECTOR
        printf("Need to define a material before the geometry to use automatic linking %s.\n",NAME_CURRENT_COMP);
        exit(1);
    #endif
    this_box_volume.p_physics = global_material_list.elements[global_material_list.num_elements-1].physics;
}

sprintf(this_box_volume.name,NAME_CURRENT_COMP);
sprintf(this_box_volume.geometry.shape,"box");
this_box_volume.geometry.priority_value = priority;
this_box_volume.geometry.geometry_p_interact = p_interact;
// Currently the coordinates will be in absolute space.
this_box_volume.geometry.center = POS_A_CURRENT_COMP;

this_box_storage.z_depth = zdepth;
this_box_storage.x_width1 = xwidth;
this_box_storage.y_height1 = yheight;

this_box_storage.is_rectangle = 0;
if (xwidth2 < 0 && yheight2 < 0) this_box_storage.is_rectangle = 1;
if (xwidth == xwidth2 && yheight == yheight2) this_box_storage.is_rectangle = 1;

if (xwidth2 < 0) {
    this_box_storage.x_width2 = xwidth;
    xwidth2 = xwidth;
} else this_box_storage.x_width2 = xwidth2;

if (yheight2 < 0) {
    this_box_storage.y_height2 = yheight;
    yheight2 = yheight;
} else this_box_storage.y_height2 = yheight2;


this_box_storage.normal_vectors[0] = coords_set(0,0,1);
this_box_storage.normal_vectors[1] = coords_set(0,0,1);

// for sides with y component = 0
x_component = 2*zdepth/sqrt((xwidth-xwidth2)*(xwidth-xwidth2)+4*zdepth*zdepth);
z_component = (xwidth-xwidth2)/sqrt(4*zdepth*zdepth+(xwidth-xwidth2)*(xwidth-xwidth2));

this_box_storage.normal_vectors[2] = coords_set(x_component,0,z_component);
this_box_storage.normal_vectors[3] = coords_set(-x_component,0,z_component);

// for sides with x component = 0
y_component = 2*zdepth/sqrt((yheight-yheight2)*(yheight-yheight2)+4*zdepth*zdepth);
z_component = (yheight-yheight2)/sqrt(4*zdepth*zdepth+(yheight-yheight2)*(yheight-yheight2));

this_box_storage.normal_vectors[4] = coords_set(0,y_component,z_component);
this_box_storage.normal_vectors[5] = coords_set(0,-y_component,z_component);

this_box_volume.geometry.visualization_on = visualize;

this_box_volume.geometry.geometry_parameters.p_box_storage = &this_box_storage;

// Assign pointers to functions for intersection with the shape, checking if a point is inside the shape
if (this_box_storage.is_rectangle == 1) {
this_box_volume.geometry.intersect_function = &sample_box_intersect_simple;
this_box_volume.geometry.within_function = &r_within_box_simple;
}
else {
this_box_volume.geometry.intersect_function = &sample_box_intersect_advanced;
this_box_volume.geometry.within_function = &r_within_box_advanced;
}

this_box_volume.geometry.shell_points = &box_shell_points;
this_box_volume.geometry.mcdisplay_function = &mcdisplay_box_function;
this_box_volume.geometry.initialize_from_main_function = &initialize_box_geometry_from_main_component;
this_box_volume.geometry.process_rot_allocated = 0;

this_box_volume.geometry.copy_geometry_parameters = &allocate_box_storage_copy;

rot_copy(this_box_volume.geometry.rotation_matrix,ROT_A_CURRENT_COMP); //check how ROT_R_CURRENT_COMP would work
rot_transpose(ROT_A_CURRENT_COMP,this_box_volume.geometry.transpose_rotation_matrix);

// Initialize loggers
this_box_volume.loggers.num_elements = 0;

// packing the information into the global_geometry_element, which is then included in the global_geometry_list.
sprintf(global_geometry_element.name,NAME_CURRENT_COMP);
global_geometry_element.activation_counter = number_of_activations;
global_geometry_element.component_index = INDEX_CURRENT_COMP;
global_geometry_element.Volume = &this_box_volume; // Would be nicer if this m was a pointer, now we have the (small) data two places
add_element_to_geometry_list(&global_geometry_list,global_geometry_element);
}
#line 213074 "MACS_sample_kidney_box.c"
#undef number_of_activations
#undef mask_setting
#undef mask_string
#undef p_interact
#undef focus_r
#undef focus_xh
#undef focus_xw
#undef focus_ah
#undef focus_aw
#undef target_z
#undef target_y
#undef target_x
#undef target_index
#undef visualize
#undef yheight2
#undef xwidth2
#undef zdepth
#undef yheight
#undef xwidth
#undef priority
#undef material_string
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

  /* Initializations for component channel_5_analyzer_2_array_crystal_array_4. */
  SIG_MESSAGE("channel_5_analyzer_2_array_crystal_array_4 (Init)");
#define mccompcurname  channel_5_analyzer_2_array_crystal_array_4
#define mccompcurtype  Union_box
#define mccompcurindex 335
#define loop_index mccchannel_5_analyzer_2_array_crystal_array_4_loop_index
#define this_box_volume mccchannel_5_analyzer_2_array_crystal_array_4_this_box_volume
#define global_geometry_element mccchannel_5_analyzer_2_array_crystal_array_4_global_geometry_element
#define this_box_storage mccchannel_5_analyzer_2_array_crystal_array_4_this_box_storage
#define material_string mccchannel_5_analyzer_2_array_crystal_array_4_material_string
#define priority mccchannel_5_analyzer_2_array_crystal_array_4_priority
#define xwidth mccchannel_5_analyzer_2_array_crystal_array_4_xwidth
#define yheight mccchannel_5_analyzer_2_array_crystal_array_4_yheight
#define zdepth mccchannel_5_analyzer_2_array_crystal_array_4_zdepth
#define xwidth2 mccchannel_5_analyzer_2_array_crystal_array_4_xwidth2
#define yheight2 mccchannel_5_analyzer_2_array_crystal_array_4_yheight2
#define visualize mccchannel_5_analyzer_2_array_crystal_array_4_visualize
#define target_index mccchannel_5_analyzer_2_array_crystal_array_4_target_index
#define target_x mccchannel_5_analyzer_2_array_crystal_array_4_target_x
#define target_y mccchannel_5_analyzer_2_array_crystal_array_4_target_y
#define target_z mccchannel_5_analyzer_2_array_crystal_array_4_target_z
#define focus_aw mccchannel_5_analyzer_2_array_crystal_array_4_focus_aw
#define focus_ah mccchannel_5_analyzer_2_array_crystal_array_4_focus_ah
#define focus_xw mccchannel_5_analyzer_2_array_crystal_array_4_focus_xw
#define focus_xh mccchannel_5_analyzer_2_array_crystal_array_4_focus_xh
#define focus_r mccchannel_5_analyzer_2_array_crystal_array_4_focus_r
#define p_interact mccchannel_5_analyzer_2_array_crystal_array_4_p_interact
#define mask_string mccchannel_5_analyzer_2_array_crystal_array_4_mask_string
#define mask_setting mccchannel_5_analyzer_2_array_crystal_array_4_mask_setting
#define number_of_activations mccchannel_5_analyzer_2_array_crystal_array_4_number_of_activations
#line 224 "Union_box.comp"
{
// Initializes the focusing system for this volume including input sanitation.
focus_initialize(&this_box_volume.geometry, POS_A_COMP_INDEX(INDEX_CURRENT_COMP+target_index), POS_A_CURRENT_COMP, ROT_A_CURRENT_COMP, target_index, target_x, target_y, target_z, focus_aw, focus_ah, focus_xw, focus_xh, focus_r, NAME_CURRENT_COMP);

// Input sanitation for this geometry
if (xwidth <= 0) {
  printf("\nERROR in Union_box named %s, the xwidth is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (yheight <= 0) {
  printf("\nERROR in Union_box named %s, yheight is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (zdepth <= 0) {
  printf("\nERROR in Union_box named %s, zdepth is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (xwidth2 <= 0 && xwidth2 != -1) {
  printf("\nERROR in Union_box named %s, the xwidth2 is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (yheight2 <= 0 && yheight2 != -1) {
  printf("\nERROR in Union_box named %s, yheight2 is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}

// Use sanitation
if (global_material_list.num_elements == 0) {
  printf("\nERROR: Need to define a material using Union_make_material before using a Union geometry component. \n");
  printf("       %s was defined before first use of Union_make_material.\n",NAME_CURRENT_COMP);
  exit(1);
}

this_box_volume.geometry.is_masked_volume = 0;
this_box_volume.geometry.is_exit_volume = 0;
this_box_volume.geometry.is_mask_volume = 0;
// check if the volume is a mask, if it is the material string is irelevant.
if (mask_string && strlen(mask_string) && strcmp(mask_string, "NULL") && strcmp(mask_string, "0")) {
    // A mask volume is used to limit the extend of other volumes, called the masked volumes. These are specified in the mask_string.
    // In order for a ray to enter a masked volume, it needs to be both in the region covered by that volume AND the mask volume.
    // When more than
    this_box_volume.geometry.mask_mode = 1; // Default is mask mode is ALL
    if (mask_setting && strlen(mask_setting) && strcmp(mask_setting, "NULL") && strcmp(mask_setting, "0")) {
        if (strcmp(mask_setting,"ALL") == 0 || strcmp(mask_setting,"All") == 0) this_box_volume.geometry.mask_mode = 1;
        else if (strcmp(mask_setting,"ANY") == 0 || strcmp(mask_setting,"Any") == 0) this_box_volume.geometry.mask_mode = 2;
        else {
            printf("The mask_mode of component %s is set to %s, but must be either ALL or ANY.\n",NAME_CURRENT_COMP,mask_setting);
            exit(1);
        }
    }
    
    for (loop_index=0;loop_index<global_geometry_list.num_elements;loop_index++) {
        // Add mask list
        if (1 == manual_linking_function(global_geometry_list.elements[loop_index].name,mask_string)) {
            add_element_to_int_list(&this_box_volume.geometry.mask_list,global_geometry_list.elements[loop_index].component_index);
            add_element_to_int_list(&global_geometry_list.elements[loop_index].Volume->geometry.masked_by_list,INDEX_CURRENT_COMP);
            global_geometry_list.elements[loop_index].Volume->geometry.is_masked_volume = 1;
            if (this_box_volume.geometry.mask_mode == 2)
                global_geometry_list.elements[loop_index].Volume->geometry.mask_mode = 2;
            if (this_box_volume.geometry.mask_mode == 1) {
                if (global_geometry_list.elements[loop_index].Volume->geometry.is_masked_volume == 1 && global_geometry_list.elements[loop_index].Volume->geometry.mask_mode != 2)
                    // If more than one mask is added to one volume, the ANY mode overwrites the (default) ALL mode.
                    global_geometry_list.elements[loop_index].Volume->geometry.mask_mode = 1;
            }
            
            found_geometries = 1;
        }
    }
    if (found_geometries == 0) {
        printf("The mask_string in geometry: %s did not find any of the specified volumes in the mask_string %s \n",NAME_CURRENT_COMP,mask_string);
        exit(1);
    }
    this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
    this_box_volume.p_physics->is_vacuum = 0; // Makes this volume a vacuum
    this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
    this_box_volume.p_physics->my_a = 0; // Should not be used.
    sprintf(this_box_volume.p_physics->name,"Mask");
    this_box_volume.geometry.is_mask_volume = 1;
    
    
// Read the material input, or if it lacks, use automatic linking.
} else if (material_string && strlen(material_string) && strcmp(material_string, "NULL") && strcmp(material_string, "0")) {
    // A geometry string was given, use it to determine which material
    if (0 == strcmp(material_string,"vacuum") || 0 == strcmp(material_string,"Vacuum")) {
        // One could have a global physics struct for vacuum instead of creating one for each
        this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
        this_box_volume.p_physics->is_vacuum = 1; // Makes this volume a vacuum
        this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
        this_box_volume.p_physics->my_a = 0; // Should not be used.
        sprintf(this_box_volume.p_physics->name,"Vacuum");
    } else if (0 == strcmp(material_string,"exit") || 0 == strcmp(material_string,"Exit")) {
        // One could have a global physics struct for vacuum instead of creating one for each
        this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
        this_box_volume.p_physics->is_vacuum = 1; // Makes this volume a vacuum
        this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
        this_box_volume.p_physics->my_a = 0; // Should not be used.
        this_box_volume.geometry.is_exit_volume = 1;
        sprintf(this_box_volume.p_physics->name,"Exit");
    } else {
        #ifndef MATERIAL_DETECTOR
            printf("Need to define a material before refering to it in a geometry %s.\n",NAME_CURRENT_COMP);
            exit(1);
        #endif
        for (loop_index=0;loop_index<global_material_list.num_elements;loop_index++) {
            if (0 == strcmp(material_string,global_material_list.elements[loop_index].name)) {
                this_box_volume.p_physics = global_material_list.elements[loop_index].physics;
                break;
            }
            if (loop_index == global_material_list.num_elements-1) {
            printf("\n");
            printf("ERROR: The material string \"%s\" in Union geometry \"%s\" did not match a specified material. \n",material_string,NAME_CURRENT_COMP);
            printf("       The materials available at this point (need to be defined before the geometry): \n");
            for (loop_index=0;loop_index<global_material_list.num_elements;loop_index++)
              printf("         %s\n",global_material_list.elements[loop_index].name);
            printf("\n");
            printf("       It is also possible to use one of the defualt materials avaiable: \n");
            printf("           Vacuum (for a Volume without scattering or absorption)\n");
            printf("           Exit (for a Volume where the ray exits the component if it enters)\n");
            printf("           Mask (for a Volume that masks existing volumes specified in the mask_string\n");
            exit(1);
          }
        }
    }
} else {
    // Automatic linking, simply using the last defined material.
    #ifndef MATERIAL_DETECTOR
        printf("Need to define a material before the geometry to use automatic linking %s.\n",NAME_CURRENT_COMP);
        exit(1);
    #endif
    this_box_volume.p_physics = global_material_list.elements[global_material_list.num_elements-1].physics;
}

sprintf(this_box_volume.name,NAME_CURRENT_COMP);
sprintf(this_box_volume.geometry.shape,"box");
this_box_volume.geometry.priority_value = priority;
this_box_volume.geometry.geometry_p_interact = p_interact;
// Currently the coordinates will be in absolute space.
this_box_volume.geometry.center = POS_A_CURRENT_COMP;

this_box_storage.z_depth = zdepth;
this_box_storage.x_width1 = xwidth;
this_box_storage.y_height1 = yheight;

this_box_storage.is_rectangle = 0;
if (xwidth2 < 0 && yheight2 < 0) this_box_storage.is_rectangle = 1;
if (xwidth == xwidth2 && yheight == yheight2) this_box_storage.is_rectangle = 1;

if (xwidth2 < 0) {
    this_box_storage.x_width2 = xwidth;
    xwidth2 = xwidth;
} else this_box_storage.x_width2 = xwidth2;

if (yheight2 < 0) {
    this_box_storage.y_height2 = yheight;
    yheight2 = yheight;
} else this_box_storage.y_height2 = yheight2;


this_box_storage.normal_vectors[0] = coords_set(0,0,1);
this_box_storage.normal_vectors[1] = coords_set(0,0,1);

// for sides with y component = 0
x_component = 2*zdepth/sqrt((xwidth-xwidth2)*(xwidth-xwidth2)+4*zdepth*zdepth);
z_component = (xwidth-xwidth2)/sqrt(4*zdepth*zdepth+(xwidth-xwidth2)*(xwidth-xwidth2));

this_box_storage.normal_vectors[2] = coords_set(x_component,0,z_component);
this_box_storage.normal_vectors[3] = coords_set(-x_component,0,z_component);

// for sides with x component = 0
y_component = 2*zdepth/sqrt((yheight-yheight2)*(yheight-yheight2)+4*zdepth*zdepth);
z_component = (yheight-yheight2)/sqrt(4*zdepth*zdepth+(yheight-yheight2)*(yheight-yheight2));

this_box_storage.normal_vectors[4] = coords_set(0,y_component,z_component);
this_box_storage.normal_vectors[5] = coords_set(0,-y_component,z_component);

this_box_volume.geometry.visualization_on = visualize;

this_box_volume.geometry.geometry_parameters.p_box_storage = &this_box_storage;

// Assign pointers to functions for intersection with the shape, checking if a point is inside the shape
if (this_box_storage.is_rectangle == 1) {
this_box_volume.geometry.intersect_function = &sample_box_intersect_simple;
this_box_volume.geometry.within_function = &r_within_box_simple;
}
else {
this_box_volume.geometry.intersect_function = &sample_box_intersect_advanced;
this_box_volume.geometry.within_function = &r_within_box_advanced;
}

this_box_volume.geometry.shell_points = &box_shell_points;
this_box_volume.geometry.mcdisplay_function = &mcdisplay_box_function;
this_box_volume.geometry.initialize_from_main_function = &initialize_box_geometry_from_main_component;
this_box_volume.geometry.process_rot_allocated = 0;

this_box_volume.geometry.copy_geometry_parameters = &allocate_box_storage_copy;

rot_copy(this_box_volume.geometry.rotation_matrix,ROT_A_CURRENT_COMP); //check how ROT_R_CURRENT_COMP would work
rot_transpose(ROT_A_CURRENT_COMP,this_box_volume.geometry.transpose_rotation_matrix);

// Initialize loggers
this_box_volume.loggers.num_elements = 0;

// packing the information into the global_geometry_element, which is then included in the global_geometry_list.
sprintf(global_geometry_element.name,NAME_CURRENT_COMP);
global_geometry_element.activation_counter = number_of_activations;
global_geometry_element.component_index = INDEX_CURRENT_COMP;
global_geometry_element.Volume = &this_box_volume; // Would be nicer if this m was a pointer, now we have the (small) data two places
add_element_to_geometry_list(&global_geometry_list,global_geometry_element);
}
#line 213344 "MACS_sample_kidney_box.c"
#undef number_of_activations
#undef mask_setting
#undef mask_string
#undef p_interact
#undef focus_r
#undef focus_xh
#undef focus_xw
#undef focus_ah
#undef focus_aw
#undef target_z
#undef target_y
#undef target_x
#undef target_index
#undef visualize
#undef yheight2
#undef xwidth2
#undef zdepth
#undef yheight
#undef xwidth
#undef priority
#undef material_string
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

  /* Initializations for component channel_5_analyzer_2_array_crystal_array_5. */
  SIG_MESSAGE("channel_5_analyzer_2_array_crystal_array_5 (Init)");
#define mccompcurname  channel_5_analyzer_2_array_crystal_array_5
#define mccompcurtype  Union_box
#define mccompcurindex 336
#define loop_index mccchannel_5_analyzer_2_array_crystal_array_5_loop_index
#define this_box_volume mccchannel_5_analyzer_2_array_crystal_array_5_this_box_volume
#define global_geometry_element mccchannel_5_analyzer_2_array_crystal_array_5_global_geometry_element
#define this_box_storage mccchannel_5_analyzer_2_array_crystal_array_5_this_box_storage
#define material_string mccchannel_5_analyzer_2_array_crystal_array_5_material_string
#define priority mccchannel_5_analyzer_2_array_crystal_array_5_priority
#define xwidth mccchannel_5_analyzer_2_array_crystal_array_5_xwidth
#define yheight mccchannel_5_analyzer_2_array_crystal_array_5_yheight
#define zdepth mccchannel_5_analyzer_2_array_crystal_array_5_zdepth
#define xwidth2 mccchannel_5_analyzer_2_array_crystal_array_5_xwidth2
#define yheight2 mccchannel_5_analyzer_2_array_crystal_array_5_yheight2
#define visualize mccchannel_5_analyzer_2_array_crystal_array_5_visualize
#define target_index mccchannel_5_analyzer_2_array_crystal_array_5_target_index
#define target_x mccchannel_5_analyzer_2_array_crystal_array_5_target_x
#define target_y mccchannel_5_analyzer_2_array_crystal_array_5_target_y
#define target_z mccchannel_5_analyzer_2_array_crystal_array_5_target_z
#define focus_aw mccchannel_5_analyzer_2_array_crystal_array_5_focus_aw
#define focus_ah mccchannel_5_analyzer_2_array_crystal_array_5_focus_ah
#define focus_xw mccchannel_5_analyzer_2_array_crystal_array_5_focus_xw
#define focus_xh mccchannel_5_analyzer_2_array_crystal_array_5_focus_xh
#define focus_r mccchannel_5_analyzer_2_array_crystal_array_5_focus_r
#define p_interact mccchannel_5_analyzer_2_array_crystal_array_5_p_interact
#define mask_string mccchannel_5_analyzer_2_array_crystal_array_5_mask_string
#define mask_setting mccchannel_5_analyzer_2_array_crystal_array_5_mask_setting
#define number_of_activations mccchannel_5_analyzer_2_array_crystal_array_5_number_of_activations
#line 224 "Union_box.comp"
{
// Initializes the focusing system for this volume including input sanitation.
focus_initialize(&this_box_volume.geometry, POS_A_COMP_INDEX(INDEX_CURRENT_COMP+target_index), POS_A_CURRENT_COMP, ROT_A_CURRENT_COMP, target_index, target_x, target_y, target_z, focus_aw, focus_ah, focus_xw, focus_xh, focus_r, NAME_CURRENT_COMP);

// Input sanitation for this geometry
if (xwidth <= 0) {
  printf("\nERROR in Union_box named %s, the xwidth is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (yheight <= 0) {
  printf("\nERROR in Union_box named %s, yheight is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (zdepth <= 0) {
  printf("\nERROR in Union_box named %s, zdepth is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (xwidth2 <= 0 && xwidth2 != -1) {
  printf("\nERROR in Union_box named %s, the xwidth2 is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (yheight2 <= 0 && yheight2 != -1) {
  printf("\nERROR in Union_box named %s, yheight2 is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}

// Use sanitation
if (global_material_list.num_elements == 0) {
  printf("\nERROR: Need to define a material using Union_make_material before using a Union geometry component. \n");
  printf("       %s was defined before first use of Union_make_material.\n",NAME_CURRENT_COMP);
  exit(1);
}

this_box_volume.geometry.is_masked_volume = 0;
this_box_volume.geometry.is_exit_volume = 0;
this_box_volume.geometry.is_mask_volume = 0;
// check if the volume is a mask, if it is the material string is irelevant.
if (mask_string && strlen(mask_string) && strcmp(mask_string, "NULL") && strcmp(mask_string, "0")) {
    // A mask volume is used to limit the extend of other volumes, called the masked volumes. These are specified in the mask_string.
    // In order for a ray to enter a masked volume, it needs to be both in the region covered by that volume AND the mask volume.
    // When more than
    this_box_volume.geometry.mask_mode = 1; // Default is mask mode is ALL
    if (mask_setting && strlen(mask_setting) && strcmp(mask_setting, "NULL") && strcmp(mask_setting, "0")) {
        if (strcmp(mask_setting,"ALL") == 0 || strcmp(mask_setting,"All") == 0) this_box_volume.geometry.mask_mode = 1;
        else if (strcmp(mask_setting,"ANY") == 0 || strcmp(mask_setting,"Any") == 0) this_box_volume.geometry.mask_mode = 2;
        else {
            printf("The mask_mode of component %s is set to %s, but must be either ALL or ANY.\n",NAME_CURRENT_COMP,mask_setting);
            exit(1);
        }
    }
    
    for (loop_index=0;loop_index<global_geometry_list.num_elements;loop_index++) {
        // Add mask list
        if (1 == manual_linking_function(global_geometry_list.elements[loop_index].name,mask_string)) {
            add_element_to_int_list(&this_box_volume.geometry.mask_list,global_geometry_list.elements[loop_index].component_index);
            add_element_to_int_list(&global_geometry_list.elements[loop_index].Volume->geometry.masked_by_list,INDEX_CURRENT_COMP);
            global_geometry_list.elements[loop_index].Volume->geometry.is_masked_volume = 1;
            if (this_box_volume.geometry.mask_mode == 2)
                global_geometry_list.elements[loop_index].Volume->geometry.mask_mode = 2;
            if (this_box_volume.geometry.mask_mode == 1) {
                if (global_geometry_list.elements[loop_index].Volume->geometry.is_masked_volume == 1 && global_geometry_list.elements[loop_index].Volume->geometry.mask_mode != 2)
                    // If more than one mask is added to one volume, the ANY mode overwrites the (default) ALL mode.
                    global_geometry_list.elements[loop_index].Volume->geometry.mask_mode = 1;
            }
            
            found_geometries = 1;
        }
    }
    if (found_geometries == 0) {
        printf("The mask_string in geometry: %s did not find any of the specified volumes in the mask_string %s \n",NAME_CURRENT_COMP,mask_string);
        exit(1);
    }
    this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
    this_box_volume.p_physics->is_vacuum = 0; // Makes this volume a vacuum
    this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
    this_box_volume.p_physics->my_a = 0; // Should not be used.
    sprintf(this_box_volume.p_physics->name,"Mask");
    this_box_volume.geometry.is_mask_volume = 1;
    
    
// Read the material input, or if it lacks, use automatic linking.
} else if (material_string && strlen(material_string) && strcmp(material_string, "NULL") && strcmp(material_string, "0")) {
    // A geometry string was given, use it to determine which material
    if (0 == strcmp(material_string,"vacuum") || 0 == strcmp(material_string,"Vacuum")) {
        // One could have a global physics struct for vacuum instead of creating one for each
        this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
        this_box_volume.p_physics->is_vacuum = 1; // Makes this volume a vacuum
        this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
        this_box_volume.p_physics->my_a = 0; // Should not be used.
        sprintf(this_box_volume.p_physics->name,"Vacuum");
    } else if (0 == strcmp(material_string,"exit") || 0 == strcmp(material_string,"Exit")) {
        // One could have a global physics struct for vacuum instead of creating one for each
        this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
        this_box_volume.p_physics->is_vacuum = 1; // Makes this volume a vacuum
        this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
        this_box_volume.p_physics->my_a = 0; // Should not be used.
        this_box_volume.geometry.is_exit_volume = 1;
        sprintf(this_box_volume.p_physics->name,"Exit");
    } else {
        #ifndef MATERIAL_DETECTOR
            printf("Need to define a material before refering to it in a geometry %s.\n",NAME_CURRENT_COMP);
            exit(1);
        #endif
        for (loop_index=0;loop_index<global_material_list.num_elements;loop_index++) {
            if (0 == strcmp(material_string,global_material_list.elements[loop_index].name)) {
                this_box_volume.p_physics = global_material_list.elements[loop_index].physics;
                break;
            }
            if (loop_index == global_material_list.num_elements-1) {
            printf("\n");
            printf("ERROR: The material string \"%s\" in Union geometry \"%s\" did not match a specified material. \n",material_string,NAME_CURRENT_COMP);
            printf("       The materials available at this point (need to be defined before the geometry): \n");
            for (loop_index=0;loop_index<global_material_list.num_elements;loop_index++)
              printf("         %s\n",global_material_list.elements[loop_index].name);
            printf("\n");
            printf("       It is also possible to use one of the defualt materials avaiable: \n");
            printf("           Vacuum (for a Volume without scattering or absorption)\n");
            printf("           Exit (for a Volume where the ray exits the component if it enters)\n");
            printf("           Mask (for a Volume that masks existing volumes specified in the mask_string\n");
            exit(1);
          }
        }
    }
} else {
    // Automatic linking, simply using the last defined material.
    #ifndef MATERIAL_DETECTOR
        printf("Need to define a material before the geometry to use automatic linking %s.\n",NAME_CURRENT_COMP);
        exit(1);
    #endif
    this_box_volume.p_physics = global_material_list.elements[global_material_list.num_elements-1].physics;
}

sprintf(this_box_volume.name,NAME_CURRENT_COMP);
sprintf(this_box_volume.geometry.shape,"box");
this_box_volume.geometry.priority_value = priority;
this_box_volume.geometry.geometry_p_interact = p_interact;
// Currently the coordinates will be in absolute space.
this_box_volume.geometry.center = POS_A_CURRENT_COMP;

this_box_storage.z_depth = zdepth;
this_box_storage.x_width1 = xwidth;
this_box_storage.y_height1 = yheight;

this_box_storage.is_rectangle = 0;
if (xwidth2 < 0 && yheight2 < 0) this_box_storage.is_rectangle = 1;
if (xwidth == xwidth2 && yheight == yheight2) this_box_storage.is_rectangle = 1;

if (xwidth2 < 0) {
    this_box_storage.x_width2 = xwidth;
    xwidth2 = xwidth;
} else this_box_storage.x_width2 = xwidth2;

if (yheight2 < 0) {
    this_box_storage.y_height2 = yheight;
    yheight2 = yheight;
} else this_box_storage.y_height2 = yheight2;


this_box_storage.normal_vectors[0] = coords_set(0,0,1);
this_box_storage.normal_vectors[1] = coords_set(0,0,1);

// for sides with y component = 0
x_component = 2*zdepth/sqrt((xwidth-xwidth2)*(xwidth-xwidth2)+4*zdepth*zdepth);
z_component = (xwidth-xwidth2)/sqrt(4*zdepth*zdepth+(xwidth-xwidth2)*(xwidth-xwidth2));

this_box_storage.normal_vectors[2] = coords_set(x_component,0,z_component);
this_box_storage.normal_vectors[3] = coords_set(-x_component,0,z_component);

// for sides with x component = 0
y_component = 2*zdepth/sqrt((yheight-yheight2)*(yheight-yheight2)+4*zdepth*zdepth);
z_component = (yheight-yheight2)/sqrt(4*zdepth*zdepth+(yheight-yheight2)*(yheight-yheight2));

this_box_storage.normal_vectors[4] = coords_set(0,y_component,z_component);
this_box_storage.normal_vectors[5] = coords_set(0,-y_component,z_component);

this_box_volume.geometry.visualization_on = visualize;

this_box_volume.geometry.geometry_parameters.p_box_storage = &this_box_storage;

// Assign pointers to functions for intersection with the shape, checking if a point is inside the shape
if (this_box_storage.is_rectangle == 1) {
this_box_volume.geometry.intersect_function = &sample_box_intersect_simple;
this_box_volume.geometry.within_function = &r_within_box_simple;
}
else {
this_box_volume.geometry.intersect_function = &sample_box_intersect_advanced;
this_box_volume.geometry.within_function = &r_within_box_advanced;
}

this_box_volume.geometry.shell_points = &box_shell_points;
this_box_volume.geometry.mcdisplay_function = &mcdisplay_box_function;
this_box_volume.geometry.initialize_from_main_function = &initialize_box_geometry_from_main_component;
this_box_volume.geometry.process_rot_allocated = 0;

this_box_volume.geometry.copy_geometry_parameters = &allocate_box_storage_copy;

rot_copy(this_box_volume.geometry.rotation_matrix,ROT_A_CURRENT_COMP); //check how ROT_R_CURRENT_COMP would work
rot_transpose(ROT_A_CURRENT_COMP,this_box_volume.geometry.transpose_rotation_matrix);

// Initialize loggers
this_box_volume.loggers.num_elements = 0;

// packing the information into the global_geometry_element, which is then included in the global_geometry_list.
sprintf(global_geometry_element.name,NAME_CURRENT_COMP);
global_geometry_element.activation_counter = number_of_activations;
global_geometry_element.component_index = INDEX_CURRENT_COMP;
global_geometry_element.Volume = &this_box_volume; // Would be nicer if this m was a pointer, now we have the (small) data two places
add_element_to_geometry_list(&global_geometry_list,global_geometry_element);
}
#line 213614 "MACS_sample_kidney_box.c"
#undef number_of_activations
#undef mask_setting
#undef mask_string
#undef p_interact
#undef focus_r
#undef focus_xh
#undef focus_xw
#undef focus_ah
#undef focus_aw
#undef target_z
#undef target_y
#undef target_x
#undef target_index
#undef visualize
#undef yheight2
#undef xwidth2
#undef zdepth
#undef yheight
#undef xwidth
#undef priority
#undef material_string
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

  /* Initializations for component channel_5_analyzer_2_array_crystal_array_6. */
  SIG_MESSAGE("channel_5_analyzer_2_array_crystal_array_6 (Init)");
#define mccompcurname  channel_5_analyzer_2_array_crystal_array_6
#define mccompcurtype  Union_box
#define mccompcurindex 337
#define loop_index mccchannel_5_analyzer_2_array_crystal_array_6_loop_index
#define this_box_volume mccchannel_5_analyzer_2_array_crystal_array_6_this_box_volume
#define global_geometry_element mccchannel_5_analyzer_2_array_crystal_array_6_global_geometry_element
#define this_box_storage mccchannel_5_analyzer_2_array_crystal_array_6_this_box_storage
#define material_string mccchannel_5_analyzer_2_array_crystal_array_6_material_string
#define priority mccchannel_5_analyzer_2_array_crystal_array_6_priority
#define xwidth mccchannel_5_analyzer_2_array_crystal_array_6_xwidth
#define yheight mccchannel_5_analyzer_2_array_crystal_array_6_yheight
#define zdepth mccchannel_5_analyzer_2_array_crystal_array_6_zdepth
#define xwidth2 mccchannel_5_analyzer_2_array_crystal_array_6_xwidth2
#define yheight2 mccchannel_5_analyzer_2_array_crystal_array_6_yheight2
#define visualize mccchannel_5_analyzer_2_array_crystal_array_6_visualize
#define target_index mccchannel_5_analyzer_2_array_crystal_array_6_target_index
#define target_x mccchannel_5_analyzer_2_array_crystal_array_6_target_x
#define target_y mccchannel_5_analyzer_2_array_crystal_array_6_target_y
#define target_z mccchannel_5_analyzer_2_array_crystal_array_6_target_z
#define focus_aw mccchannel_5_analyzer_2_array_crystal_array_6_focus_aw
#define focus_ah mccchannel_5_analyzer_2_array_crystal_array_6_focus_ah
#define focus_xw mccchannel_5_analyzer_2_array_crystal_array_6_focus_xw
#define focus_xh mccchannel_5_analyzer_2_array_crystal_array_6_focus_xh
#define focus_r mccchannel_5_analyzer_2_array_crystal_array_6_focus_r
#define p_interact mccchannel_5_analyzer_2_array_crystal_array_6_p_interact
#define mask_string mccchannel_5_analyzer_2_array_crystal_array_6_mask_string
#define mask_setting mccchannel_5_analyzer_2_array_crystal_array_6_mask_setting
#define number_of_activations mccchannel_5_analyzer_2_array_crystal_array_6_number_of_activations
#line 224 "Union_box.comp"
{
// Initializes the focusing system for this volume including input sanitation.
focus_initialize(&this_box_volume.geometry, POS_A_COMP_INDEX(INDEX_CURRENT_COMP+target_index), POS_A_CURRENT_COMP, ROT_A_CURRENT_COMP, target_index, target_x, target_y, target_z, focus_aw, focus_ah, focus_xw, focus_xh, focus_r, NAME_CURRENT_COMP);

// Input sanitation for this geometry
if (xwidth <= 0) {
  printf("\nERROR in Union_box named %s, the xwidth is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (yheight <= 0) {
  printf("\nERROR in Union_box named %s, yheight is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (zdepth <= 0) {
  printf("\nERROR in Union_box named %s, zdepth is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (xwidth2 <= 0 && xwidth2 != -1) {
  printf("\nERROR in Union_box named %s, the xwidth2 is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (yheight2 <= 0 && yheight2 != -1) {
  printf("\nERROR in Union_box named %s, yheight2 is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}

// Use sanitation
if (global_material_list.num_elements == 0) {
  printf("\nERROR: Need to define a material using Union_make_material before using a Union geometry component. \n");
  printf("       %s was defined before first use of Union_make_material.\n",NAME_CURRENT_COMP);
  exit(1);
}

this_box_volume.geometry.is_masked_volume = 0;
this_box_volume.geometry.is_exit_volume = 0;
this_box_volume.geometry.is_mask_volume = 0;
// check if the volume is a mask, if it is the material string is irelevant.
if (mask_string && strlen(mask_string) && strcmp(mask_string, "NULL") && strcmp(mask_string, "0")) {
    // A mask volume is used to limit the extend of other volumes, called the masked volumes. These are specified in the mask_string.
    // In order for a ray to enter a masked volume, it needs to be both in the region covered by that volume AND the mask volume.
    // When more than
    this_box_volume.geometry.mask_mode = 1; // Default is mask mode is ALL
    if (mask_setting && strlen(mask_setting) && strcmp(mask_setting, "NULL") && strcmp(mask_setting, "0")) {
        if (strcmp(mask_setting,"ALL") == 0 || strcmp(mask_setting,"All") == 0) this_box_volume.geometry.mask_mode = 1;
        else if (strcmp(mask_setting,"ANY") == 0 || strcmp(mask_setting,"Any") == 0) this_box_volume.geometry.mask_mode = 2;
        else {
            printf("The mask_mode of component %s is set to %s, but must be either ALL or ANY.\n",NAME_CURRENT_COMP,mask_setting);
            exit(1);
        }
    }
    
    for (loop_index=0;loop_index<global_geometry_list.num_elements;loop_index++) {
        // Add mask list
        if (1 == manual_linking_function(global_geometry_list.elements[loop_index].name,mask_string)) {
            add_element_to_int_list(&this_box_volume.geometry.mask_list,global_geometry_list.elements[loop_index].component_index);
            add_element_to_int_list(&global_geometry_list.elements[loop_index].Volume->geometry.masked_by_list,INDEX_CURRENT_COMP);
            global_geometry_list.elements[loop_index].Volume->geometry.is_masked_volume = 1;
            if (this_box_volume.geometry.mask_mode == 2)
                global_geometry_list.elements[loop_index].Volume->geometry.mask_mode = 2;
            if (this_box_volume.geometry.mask_mode == 1) {
                if (global_geometry_list.elements[loop_index].Volume->geometry.is_masked_volume == 1 && global_geometry_list.elements[loop_index].Volume->geometry.mask_mode != 2)
                    // If more than one mask is added to one volume, the ANY mode overwrites the (default) ALL mode.
                    global_geometry_list.elements[loop_index].Volume->geometry.mask_mode = 1;
            }
            
            found_geometries = 1;
        }
    }
    if (found_geometries == 0) {
        printf("The mask_string in geometry: %s did not find any of the specified volumes in the mask_string %s \n",NAME_CURRENT_COMP,mask_string);
        exit(1);
    }
    this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
    this_box_volume.p_physics->is_vacuum = 0; // Makes this volume a vacuum
    this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
    this_box_volume.p_physics->my_a = 0; // Should not be used.
    sprintf(this_box_volume.p_physics->name,"Mask");
    this_box_volume.geometry.is_mask_volume = 1;
    
    
// Read the material input, or if it lacks, use automatic linking.
} else if (material_string && strlen(material_string) && strcmp(material_string, "NULL") && strcmp(material_string, "0")) {
    // A geometry string was given, use it to determine which material
    if (0 == strcmp(material_string,"vacuum") || 0 == strcmp(material_string,"Vacuum")) {
        // One could have a global physics struct for vacuum instead of creating one for each
        this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
        this_box_volume.p_physics->is_vacuum = 1; // Makes this volume a vacuum
        this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
        this_box_volume.p_physics->my_a = 0; // Should not be used.
        sprintf(this_box_volume.p_physics->name,"Vacuum");
    } else if (0 == strcmp(material_string,"exit") || 0 == strcmp(material_string,"Exit")) {
        // One could have a global physics struct for vacuum instead of creating one for each
        this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
        this_box_volume.p_physics->is_vacuum = 1; // Makes this volume a vacuum
        this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
        this_box_volume.p_physics->my_a = 0; // Should not be used.
        this_box_volume.geometry.is_exit_volume = 1;
        sprintf(this_box_volume.p_physics->name,"Exit");
    } else {
        #ifndef MATERIAL_DETECTOR
            printf("Need to define a material before refering to it in a geometry %s.\n",NAME_CURRENT_COMP);
            exit(1);
        #endif
        for (loop_index=0;loop_index<global_material_list.num_elements;loop_index++) {
            if (0 == strcmp(material_string,global_material_list.elements[loop_index].name)) {
                this_box_volume.p_physics = global_material_list.elements[loop_index].physics;
                break;
            }
            if (loop_index == global_material_list.num_elements-1) {
            printf("\n");
            printf("ERROR: The material string \"%s\" in Union geometry \"%s\" did not match a specified material. \n",material_string,NAME_CURRENT_COMP);
            printf("       The materials available at this point (need to be defined before the geometry): \n");
            for (loop_index=0;loop_index<global_material_list.num_elements;loop_index++)
              printf("         %s\n",global_material_list.elements[loop_index].name);
            printf("\n");
            printf("       It is also possible to use one of the defualt materials avaiable: \n");
            printf("           Vacuum (for a Volume without scattering or absorption)\n");
            printf("           Exit (for a Volume where the ray exits the component if it enters)\n");
            printf("           Mask (for a Volume that masks existing volumes specified in the mask_string\n");
            exit(1);
          }
        }
    }
} else {
    // Automatic linking, simply using the last defined material.
    #ifndef MATERIAL_DETECTOR
        printf("Need to define a material before the geometry to use automatic linking %s.\n",NAME_CURRENT_COMP);
        exit(1);
    #endif
    this_box_volume.p_physics = global_material_list.elements[global_material_list.num_elements-1].physics;
}

sprintf(this_box_volume.name,NAME_CURRENT_COMP);
sprintf(this_box_volume.geometry.shape,"box");
this_box_volume.geometry.priority_value = priority;
this_box_volume.geometry.geometry_p_interact = p_interact;
// Currently the coordinates will be in absolute space.
this_box_volume.geometry.center = POS_A_CURRENT_COMP;

this_box_storage.z_depth = zdepth;
this_box_storage.x_width1 = xwidth;
this_box_storage.y_height1 = yheight;

this_box_storage.is_rectangle = 0;
if (xwidth2 < 0 && yheight2 < 0) this_box_storage.is_rectangle = 1;
if (xwidth == xwidth2 && yheight == yheight2) this_box_storage.is_rectangle = 1;

if (xwidth2 < 0) {
    this_box_storage.x_width2 = xwidth;
    xwidth2 = xwidth;
} else this_box_storage.x_width2 = xwidth2;

if (yheight2 < 0) {
    this_box_storage.y_height2 = yheight;
    yheight2 = yheight;
} else this_box_storage.y_height2 = yheight2;


this_box_storage.normal_vectors[0] = coords_set(0,0,1);
this_box_storage.normal_vectors[1] = coords_set(0,0,1);

// for sides with y component = 0
x_component = 2*zdepth/sqrt((xwidth-xwidth2)*(xwidth-xwidth2)+4*zdepth*zdepth);
z_component = (xwidth-xwidth2)/sqrt(4*zdepth*zdepth+(xwidth-xwidth2)*(xwidth-xwidth2));

this_box_storage.normal_vectors[2] = coords_set(x_component,0,z_component);
this_box_storage.normal_vectors[3] = coords_set(-x_component,0,z_component);

// for sides with x component = 0
y_component = 2*zdepth/sqrt((yheight-yheight2)*(yheight-yheight2)+4*zdepth*zdepth);
z_component = (yheight-yheight2)/sqrt(4*zdepth*zdepth+(yheight-yheight2)*(yheight-yheight2));

this_box_storage.normal_vectors[4] = coords_set(0,y_component,z_component);
this_box_storage.normal_vectors[5] = coords_set(0,-y_component,z_component);

this_box_volume.geometry.visualization_on = visualize;

this_box_volume.geometry.geometry_parameters.p_box_storage = &this_box_storage;

// Assign pointers to functions for intersection with the shape, checking if a point is inside the shape
if (this_box_storage.is_rectangle == 1) {
this_box_volume.geometry.intersect_function = &sample_box_intersect_simple;
this_box_volume.geometry.within_function = &r_within_box_simple;
}
else {
this_box_volume.geometry.intersect_function = &sample_box_intersect_advanced;
this_box_volume.geometry.within_function = &r_within_box_advanced;
}

this_box_volume.geometry.shell_points = &box_shell_points;
this_box_volume.geometry.mcdisplay_function = &mcdisplay_box_function;
this_box_volume.geometry.initialize_from_main_function = &initialize_box_geometry_from_main_component;
this_box_volume.geometry.process_rot_allocated = 0;

this_box_volume.geometry.copy_geometry_parameters = &allocate_box_storage_copy;

rot_copy(this_box_volume.geometry.rotation_matrix,ROT_A_CURRENT_COMP); //check how ROT_R_CURRENT_COMP would work
rot_transpose(ROT_A_CURRENT_COMP,this_box_volume.geometry.transpose_rotation_matrix);

// Initialize loggers
this_box_volume.loggers.num_elements = 0;

// packing the information into the global_geometry_element, which is then included in the global_geometry_list.
sprintf(global_geometry_element.name,NAME_CURRENT_COMP);
global_geometry_element.activation_counter = number_of_activations;
global_geometry_element.component_index = INDEX_CURRENT_COMP;
global_geometry_element.Volume = &this_box_volume; // Would be nicer if this m was a pointer, now we have the (small) data two places
add_element_to_geometry_list(&global_geometry_list,global_geometry_element);
}
#line 213884 "MACS_sample_kidney_box.c"
#undef number_of_activations
#undef mask_setting
#undef mask_string
#undef p_interact
#undef focus_r
#undef focus_xh
#undef focus_xw
#undef focus_ah
#undef focus_aw
#undef target_z
#undef target_y
#undef target_x
#undef target_index
#undef visualize
#undef yheight2
#undef xwidth2
#undef zdepth
#undef yheight
#undef xwidth
#undef priority
#undef material_string
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

  /* Initializations for component channel_5_analyzer_2_array_crystal_array_7. */
  SIG_MESSAGE("channel_5_analyzer_2_array_crystal_array_7 (Init)");
#define mccompcurname  channel_5_analyzer_2_array_crystal_array_7
#define mccompcurtype  Union_box
#define mccompcurindex 338
#define loop_index mccchannel_5_analyzer_2_array_crystal_array_7_loop_index
#define this_box_volume mccchannel_5_analyzer_2_array_crystal_array_7_this_box_volume
#define global_geometry_element mccchannel_5_analyzer_2_array_crystal_array_7_global_geometry_element
#define this_box_storage mccchannel_5_analyzer_2_array_crystal_array_7_this_box_storage
#define material_string mccchannel_5_analyzer_2_array_crystal_array_7_material_string
#define priority mccchannel_5_analyzer_2_array_crystal_array_7_priority
#define xwidth mccchannel_5_analyzer_2_array_crystal_array_7_xwidth
#define yheight mccchannel_5_analyzer_2_array_crystal_array_7_yheight
#define zdepth mccchannel_5_analyzer_2_array_crystal_array_7_zdepth
#define xwidth2 mccchannel_5_analyzer_2_array_crystal_array_7_xwidth2
#define yheight2 mccchannel_5_analyzer_2_array_crystal_array_7_yheight2
#define visualize mccchannel_5_analyzer_2_array_crystal_array_7_visualize
#define target_index mccchannel_5_analyzer_2_array_crystal_array_7_target_index
#define target_x mccchannel_5_analyzer_2_array_crystal_array_7_target_x
#define target_y mccchannel_5_analyzer_2_array_crystal_array_7_target_y
#define target_z mccchannel_5_analyzer_2_array_crystal_array_7_target_z
#define focus_aw mccchannel_5_analyzer_2_array_crystal_array_7_focus_aw
#define focus_ah mccchannel_5_analyzer_2_array_crystal_array_7_focus_ah
#define focus_xw mccchannel_5_analyzer_2_array_crystal_array_7_focus_xw
#define focus_xh mccchannel_5_analyzer_2_array_crystal_array_7_focus_xh
#define focus_r mccchannel_5_analyzer_2_array_crystal_array_7_focus_r
#define p_interact mccchannel_5_analyzer_2_array_crystal_array_7_p_interact
#define mask_string mccchannel_5_analyzer_2_array_crystal_array_7_mask_string
#define mask_setting mccchannel_5_analyzer_2_array_crystal_array_7_mask_setting
#define number_of_activations mccchannel_5_analyzer_2_array_crystal_array_7_number_of_activations
#line 224 "Union_box.comp"
{
// Initializes the focusing system for this volume including input sanitation.
focus_initialize(&this_box_volume.geometry, POS_A_COMP_INDEX(INDEX_CURRENT_COMP+target_index), POS_A_CURRENT_COMP, ROT_A_CURRENT_COMP, target_index, target_x, target_y, target_z, focus_aw, focus_ah, focus_xw, focus_xh, focus_r, NAME_CURRENT_COMP);

// Input sanitation for this geometry
if (xwidth <= 0) {
  printf("\nERROR in Union_box named %s, the xwidth is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (yheight <= 0) {
  printf("\nERROR in Union_box named %s, yheight is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (zdepth <= 0) {
  printf("\nERROR in Union_box named %s, zdepth is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (xwidth2 <= 0 && xwidth2 != -1) {
  printf("\nERROR in Union_box named %s, the xwidth2 is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (yheight2 <= 0 && yheight2 != -1) {
  printf("\nERROR in Union_box named %s, yheight2 is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}

// Use sanitation
if (global_material_list.num_elements == 0) {
  printf("\nERROR: Need to define a material using Union_make_material before using a Union geometry component. \n");
  printf("       %s was defined before first use of Union_make_material.\n",NAME_CURRENT_COMP);
  exit(1);
}

this_box_volume.geometry.is_masked_volume = 0;
this_box_volume.geometry.is_exit_volume = 0;
this_box_volume.geometry.is_mask_volume = 0;
// check if the volume is a mask, if it is the material string is irelevant.
if (mask_string && strlen(mask_string) && strcmp(mask_string, "NULL") && strcmp(mask_string, "0")) {
    // A mask volume is used to limit the extend of other volumes, called the masked volumes. These are specified in the mask_string.
    // In order for a ray to enter a masked volume, it needs to be both in the region covered by that volume AND the mask volume.
    // When more than
    this_box_volume.geometry.mask_mode = 1; // Default is mask mode is ALL
    if (mask_setting && strlen(mask_setting) && strcmp(mask_setting, "NULL") && strcmp(mask_setting, "0")) {
        if (strcmp(mask_setting,"ALL") == 0 || strcmp(mask_setting,"All") == 0) this_box_volume.geometry.mask_mode = 1;
        else if (strcmp(mask_setting,"ANY") == 0 || strcmp(mask_setting,"Any") == 0) this_box_volume.geometry.mask_mode = 2;
        else {
            printf("The mask_mode of component %s is set to %s, but must be either ALL or ANY.\n",NAME_CURRENT_COMP,mask_setting);
            exit(1);
        }
    }
    
    for (loop_index=0;loop_index<global_geometry_list.num_elements;loop_index++) {
        // Add mask list
        if (1 == manual_linking_function(global_geometry_list.elements[loop_index].name,mask_string)) {
            add_element_to_int_list(&this_box_volume.geometry.mask_list,global_geometry_list.elements[loop_index].component_index);
            add_element_to_int_list(&global_geometry_list.elements[loop_index].Volume->geometry.masked_by_list,INDEX_CURRENT_COMP);
            global_geometry_list.elements[loop_index].Volume->geometry.is_masked_volume = 1;
            if (this_box_volume.geometry.mask_mode == 2)
                global_geometry_list.elements[loop_index].Volume->geometry.mask_mode = 2;
            if (this_box_volume.geometry.mask_mode == 1) {
                if (global_geometry_list.elements[loop_index].Volume->geometry.is_masked_volume == 1 && global_geometry_list.elements[loop_index].Volume->geometry.mask_mode != 2)
                    // If more than one mask is added to one volume, the ANY mode overwrites the (default) ALL mode.
                    global_geometry_list.elements[loop_index].Volume->geometry.mask_mode = 1;
            }
            
            found_geometries = 1;
        }
    }
    if (found_geometries == 0) {
        printf("The mask_string in geometry: %s did not find any of the specified volumes in the mask_string %s \n",NAME_CURRENT_COMP,mask_string);
        exit(1);
    }
    this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
    this_box_volume.p_physics->is_vacuum = 0; // Makes this volume a vacuum
    this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
    this_box_volume.p_physics->my_a = 0; // Should not be used.
    sprintf(this_box_volume.p_physics->name,"Mask");
    this_box_volume.geometry.is_mask_volume = 1;
    
    
// Read the material input, or if it lacks, use automatic linking.
} else if (material_string && strlen(material_string) && strcmp(material_string, "NULL") && strcmp(material_string, "0")) {
    // A geometry string was given, use it to determine which material
    if (0 == strcmp(material_string,"vacuum") || 0 == strcmp(material_string,"Vacuum")) {
        // One could have a global physics struct for vacuum instead of creating one for each
        this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
        this_box_volume.p_physics->is_vacuum = 1; // Makes this volume a vacuum
        this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
        this_box_volume.p_physics->my_a = 0; // Should not be used.
        sprintf(this_box_volume.p_physics->name,"Vacuum");
    } else if (0 == strcmp(material_string,"exit") || 0 == strcmp(material_string,"Exit")) {
        // One could have a global physics struct for vacuum instead of creating one for each
        this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
        this_box_volume.p_physics->is_vacuum = 1; // Makes this volume a vacuum
        this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
        this_box_volume.p_physics->my_a = 0; // Should not be used.
        this_box_volume.geometry.is_exit_volume = 1;
        sprintf(this_box_volume.p_physics->name,"Exit");
    } else {
        #ifndef MATERIAL_DETECTOR
            printf("Need to define a material before refering to it in a geometry %s.\n",NAME_CURRENT_COMP);
            exit(1);
        #endif
        for (loop_index=0;loop_index<global_material_list.num_elements;loop_index++) {
            if (0 == strcmp(material_string,global_material_list.elements[loop_index].name)) {
                this_box_volume.p_physics = global_material_list.elements[loop_index].physics;
                break;
            }
            if (loop_index == global_material_list.num_elements-1) {
            printf("\n");
            printf("ERROR: The material string \"%s\" in Union geometry \"%s\" did not match a specified material. \n",material_string,NAME_CURRENT_COMP);
            printf("       The materials available at this point (need to be defined before the geometry): \n");
            for (loop_index=0;loop_index<global_material_list.num_elements;loop_index++)
              printf("         %s\n",global_material_list.elements[loop_index].name);
            printf("\n");
            printf("       It is also possible to use one of the defualt materials avaiable: \n");
            printf("           Vacuum (for a Volume without scattering or absorption)\n");
            printf("           Exit (for a Volume where the ray exits the component if it enters)\n");
            printf("           Mask (for a Volume that masks existing volumes specified in the mask_string\n");
            exit(1);
          }
        }
    }
} else {
    // Automatic linking, simply using the last defined material.
    #ifndef MATERIAL_DETECTOR
        printf("Need to define a material before the geometry to use automatic linking %s.\n",NAME_CURRENT_COMP);
        exit(1);
    #endif
    this_box_volume.p_physics = global_material_list.elements[global_material_list.num_elements-1].physics;
}

sprintf(this_box_volume.name,NAME_CURRENT_COMP);
sprintf(this_box_volume.geometry.shape,"box");
this_box_volume.geometry.priority_value = priority;
this_box_volume.geometry.geometry_p_interact = p_interact;
// Currently the coordinates will be in absolute space.
this_box_volume.geometry.center = POS_A_CURRENT_COMP;

this_box_storage.z_depth = zdepth;
this_box_storage.x_width1 = xwidth;
this_box_storage.y_height1 = yheight;

this_box_storage.is_rectangle = 0;
if (xwidth2 < 0 && yheight2 < 0) this_box_storage.is_rectangle = 1;
if (xwidth == xwidth2 && yheight == yheight2) this_box_storage.is_rectangle = 1;

if (xwidth2 < 0) {
    this_box_storage.x_width2 = xwidth;
    xwidth2 = xwidth;
} else this_box_storage.x_width2 = xwidth2;

if (yheight2 < 0) {
    this_box_storage.y_height2 = yheight;
    yheight2 = yheight;
} else this_box_storage.y_height2 = yheight2;


this_box_storage.normal_vectors[0] = coords_set(0,0,1);
this_box_storage.normal_vectors[1] = coords_set(0,0,1);

// for sides with y component = 0
x_component = 2*zdepth/sqrt((xwidth-xwidth2)*(xwidth-xwidth2)+4*zdepth*zdepth);
z_component = (xwidth-xwidth2)/sqrt(4*zdepth*zdepth+(xwidth-xwidth2)*(xwidth-xwidth2));

this_box_storage.normal_vectors[2] = coords_set(x_component,0,z_component);
this_box_storage.normal_vectors[3] = coords_set(-x_component,0,z_component);

// for sides with x component = 0
y_component = 2*zdepth/sqrt((yheight-yheight2)*(yheight-yheight2)+4*zdepth*zdepth);
z_component = (yheight-yheight2)/sqrt(4*zdepth*zdepth+(yheight-yheight2)*(yheight-yheight2));

this_box_storage.normal_vectors[4] = coords_set(0,y_component,z_component);
this_box_storage.normal_vectors[5] = coords_set(0,-y_component,z_component);

this_box_volume.geometry.visualization_on = visualize;

this_box_volume.geometry.geometry_parameters.p_box_storage = &this_box_storage;

// Assign pointers to functions for intersection with the shape, checking if a point is inside the shape
if (this_box_storage.is_rectangle == 1) {
this_box_volume.geometry.intersect_function = &sample_box_intersect_simple;
this_box_volume.geometry.within_function = &r_within_box_simple;
}
else {
this_box_volume.geometry.intersect_function = &sample_box_intersect_advanced;
this_box_volume.geometry.within_function = &r_within_box_advanced;
}

this_box_volume.geometry.shell_points = &box_shell_points;
this_box_volume.geometry.mcdisplay_function = &mcdisplay_box_function;
this_box_volume.geometry.initialize_from_main_function = &initialize_box_geometry_from_main_component;
this_box_volume.geometry.process_rot_allocated = 0;

this_box_volume.geometry.copy_geometry_parameters = &allocate_box_storage_copy;

rot_copy(this_box_volume.geometry.rotation_matrix,ROT_A_CURRENT_COMP); //check how ROT_R_CURRENT_COMP would work
rot_transpose(ROT_A_CURRENT_COMP,this_box_volume.geometry.transpose_rotation_matrix);

// Initialize loggers
this_box_volume.loggers.num_elements = 0;

// packing the information into the global_geometry_element, which is then included in the global_geometry_list.
sprintf(global_geometry_element.name,NAME_CURRENT_COMP);
global_geometry_element.activation_counter = number_of_activations;
global_geometry_element.component_index = INDEX_CURRENT_COMP;
global_geometry_element.Volume = &this_box_volume; // Would be nicer if this m was a pointer, now we have the (small) data two places
add_element_to_geometry_list(&global_geometry_list,global_geometry_element);
}
#line 214154 "MACS_sample_kidney_box.c"
#undef number_of_activations
#undef mask_setting
#undef mask_string
#undef p_interact
#undef focus_r
#undef focus_xh
#undef focus_xw
#undef focus_ah
#undef focus_aw
#undef target_z
#undef target_y
#undef target_x
#undef target_index
#undef visualize
#undef yheight2
#undef xwidth2
#undef zdepth
#undef yheight
#undef xwidth
#undef priority
#undef material_string
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

  /* Initializations for component channel_5_analyzer_2_array_crystal_array_8. */
  SIG_MESSAGE("channel_5_analyzer_2_array_crystal_array_8 (Init)");
#define mccompcurname  channel_5_analyzer_2_array_crystal_array_8
#define mccompcurtype  Union_box
#define mccompcurindex 339
#define loop_index mccchannel_5_analyzer_2_array_crystal_array_8_loop_index
#define this_box_volume mccchannel_5_analyzer_2_array_crystal_array_8_this_box_volume
#define global_geometry_element mccchannel_5_analyzer_2_array_crystal_array_8_global_geometry_element
#define this_box_storage mccchannel_5_analyzer_2_array_crystal_array_8_this_box_storage
#define material_string mccchannel_5_analyzer_2_array_crystal_array_8_material_string
#define priority mccchannel_5_analyzer_2_array_crystal_array_8_priority
#define xwidth mccchannel_5_analyzer_2_array_crystal_array_8_xwidth
#define yheight mccchannel_5_analyzer_2_array_crystal_array_8_yheight
#define zdepth mccchannel_5_analyzer_2_array_crystal_array_8_zdepth
#define xwidth2 mccchannel_5_analyzer_2_array_crystal_array_8_xwidth2
#define yheight2 mccchannel_5_analyzer_2_array_crystal_array_8_yheight2
#define visualize mccchannel_5_analyzer_2_array_crystal_array_8_visualize
#define target_index mccchannel_5_analyzer_2_array_crystal_array_8_target_index
#define target_x mccchannel_5_analyzer_2_array_crystal_array_8_target_x
#define target_y mccchannel_5_analyzer_2_array_crystal_array_8_target_y
#define target_z mccchannel_5_analyzer_2_array_crystal_array_8_target_z
#define focus_aw mccchannel_5_analyzer_2_array_crystal_array_8_focus_aw
#define focus_ah mccchannel_5_analyzer_2_array_crystal_array_8_focus_ah
#define focus_xw mccchannel_5_analyzer_2_array_crystal_array_8_focus_xw
#define focus_xh mccchannel_5_analyzer_2_array_crystal_array_8_focus_xh
#define focus_r mccchannel_5_analyzer_2_array_crystal_array_8_focus_r
#define p_interact mccchannel_5_analyzer_2_array_crystal_array_8_p_interact
#define mask_string mccchannel_5_analyzer_2_array_crystal_array_8_mask_string
#define mask_setting mccchannel_5_analyzer_2_array_crystal_array_8_mask_setting
#define number_of_activations mccchannel_5_analyzer_2_array_crystal_array_8_number_of_activations
#line 224 "Union_box.comp"
{
// Initializes the focusing system for this volume including input sanitation.
focus_initialize(&this_box_volume.geometry, POS_A_COMP_INDEX(INDEX_CURRENT_COMP+target_index), POS_A_CURRENT_COMP, ROT_A_CURRENT_COMP, target_index, target_x, target_y, target_z, focus_aw, focus_ah, focus_xw, focus_xh, focus_r, NAME_CURRENT_COMP);

// Input sanitation for this geometry
if (xwidth <= 0) {
  printf("\nERROR in Union_box named %s, the xwidth is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (yheight <= 0) {
  printf("\nERROR in Union_box named %s, yheight is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (zdepth <= 0) {
  printf("\nERROR in Union_box named %s, zdepth is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (xwidth2 <= 0 && xwidth2 != -1) {
  printf("\nERROR in Union_box named %s, the xwidth2 is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (yheight2 <= 0 && yheight2 != -1) {
  printf("\nERROR in Union_box named %s, yheight2 is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}

// Use sanitation
if (global_material_list.num_elements == 0) {
  printf("\nERROR: Need to define a material using Union_make_material before using a Union geometry component. \n");
  printf("       %s was defined before first use of Union_make_material.\n",NAME_CURRENT_COMP);
  exit(1);
}

this_box_volume.geometry.is_masked_volume = 0;
this_box_volume.geometry.is_exit_volume = 0;
this_box_volume.geometry.is_mask_volume = 0;
// check if the volume is a mask, if it is the material string is irelevant.
if (mask_string && strlen(mask_string) && strcmp(mask_string, "NULL") && strcmp(mask_string, "0")) {
    // A mask volume is used to limit the extend of other volumes, called the masked volumes. These are specified in the mask_string.
    // In order for a ray to enter a masked volume, it needs to be both in the region covered by that volume AND the mask volume.
    // When more than
    this_box_volume.geometry.mask_mode = 1; // Default is mask mode is ALL
    if (mask_setting && strlen(mask_setting) && strcmp(mask_setting, "NULL") && strcmp(mask_setting, "0")) {
        if (strcmp(mask_setting,"ALL") == 0 || strcmp(mask_setting,"All") == 0) this_box_volume.geometry.mask_mode = 1;
        else if (strcmp(mask_setting,"ANY") == 0 || strcmp(mask_setting,"Any") == 0) this_box_volume.geometry.mask_mode = 2;
        else {
            printf("The mask_mode of component %s is set to %s, but must be either ALL or ANY.\n",NAME_CURRENT_COMP,mask_setting);
            exit(1);
        }
    }
    
    for (loop_index=0;loop_index<global_geometry_list.num_elements;loop_index++) {
        // Add mask list
        if (1 == manual_linking_function(global_geometry_list.elements[loop_index].name,mask_string)) {
            add_element_to_int_list(&this_box_volume.geometry.mask_list,global_geometry_list.elements[loop_index].component_index);
            add_element_to_int_list(&global_geometry_list.elements[loop_index].Volume->geometry.masked_by_list,INDEX_CURRENT_COMP);
            global_geometry_list.elements[loop_index].Volume->geometry.is_masked_volume = 1;
            if (this_box_volume.geometry.mask_mode == 2)
                global_geometry_list.elements[loop_index].Volume->geometry.mask_mode = 2;
            if (this_box_volume.geometry.mask_mode == 1) {
                if (global_geometry_list.elements[loop_index].Volume->geometry.is_masked_volume == 1 && global_geometry_list.elements[loop_index].Volume->geometry.mask_mode != 2)
                    // If more than one mask is added to one volume, the ANY mode overwrites the (default) ALL mode.
                    global_geometry_list.elements[loop_index].Volume->geometry.mask_mode = 1;
            }
            
            found_geometries = 1;
        }
    }
    if (found_geometries == 0) {
        printf("The mask_string in geometry: %s did not find any of the specified volumes in the mask_string %s \n",NAME_CURRENT_COMP,mask_string);
        exit(1);
    }
    this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
    this_box_volume.p_physics->is_vacuum = 0; // Makes this volume a vacuum
    this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
    this_box_volume.p_physics->my_a = 0; // Should not be used.
    sprintf(this_box_volume.p_physics->name,"Mask");
    this_box_volume.geometry.is_mask_volume = 1;
    
    
// Read the material input, or if it lacks, use automatic linking.
} else if (material_string && strlen(material_string) && strcmp(material_string, "NULL") && strcmp(material_string, "0")) {
    // A geometry string was given, use it to determine which material
    if (0 == strcmp(material_string,"vacuum") || 0 == strcmp(material_string,"Vacuum")) {
        // One could have a global physics struct for vacuum instead of creating one for each
        this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
        this_box_volume.p_physics->is_vacuum = 1; // Makes this volume a vacuum
        this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
        this_box_volume.p_physics->my_a = 0; // Should not be used.
        sprintf(this_box_volume.p_physics->name,"Vacuum");
    } else if (0 == strcmp(material_string,"exit") || 0 == strcmp(material_string,"Exit")) {
        // One could have a global physics struct for vacuum instead of creating one for each
        this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
        this_box_volume.p_physics->is_vacuum = 1; // Makes this volume a vacuum
        this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
        this_box_volume.p_physics->my_a = 0; // Should not be used.
        this_box_volume.geometry.is_exit_volume = 1;
        sprintf(this_box_volume.p_physics->name,"Exit");
    } else {
        #ifndef MATERIAL_DETECTOR
            printf("Need to define a material before refering to it in a geometry %s.\n",NAME_CURRENT_COMP);
            exit(1);
        #endif
        for (loop_index=0;loop_index<global_material_list.num_elements;loop_index++) {
            if (0 == strcmp(material_string,global_material_list.elements[loop_index].name)) {
                this_box_volume.p_physics = global_material_list.elements[loop_index].physics;
                break;
            }
            if (loop_index == global_material_list.num_elements-1) {
            printf("\n");
            printf("ERROR: The material string \"%s\" in Union geometry \"%s\" did not match a specified material. \n",material_string,NAME_CURRENT_COMP);
            printf("       The materials available at this point (need to be defined before the geometry): \n");
            for (loop_index=0;loop_index<global_material_list.num_elements;loop_index++)
              printf("         %s\n",global_material_list.elements[loop_index].name);
            printf("\n");
            printf("       It is also possible to use one of the defualt materials avaiable: \n");
            printf("           Vacuum (for a Volume without scattering or absorption)\n");
            printf("           Exit (for a Volume where the ray exits the component if it enters)\n");
            printf("           Mask (for a Volume that masks existing volumes specified in the mask_string\n");
            exit(1);
          }
        }
    }
} else {
    // Automatic linking, simply using the last defined material.
    #ifndef MATERIAL_DETECTOR
        printf("Need to define a material before the geometry to use automatic linking %s.\n",NAME_CURRENT_COMP);
        exit(1);
    #endif
    this_box_volume.p_physics = global_material_list.elements[global_material_list.num_elements-1].physics;
}

sprintf(this_box_volume.name,NAME_CURRENT_COMP);
sprintf(this_box_volume.geometry.shape,"box");
this_box_volume.geometry.priority_value = priority;
this_box_volume.geometry.geometry_p_interact = p_interact;
// Currently the coordinates will be in absolute space.
this_box_volume.geometry.center = POS_A_CURRENT_COMP;

this_box_storage.z_depth = zdepth;
this_box_storage.x_width1 = xwidth;
this_box_storage.y_height1 = yheight;

this_box_storage.is_rectangle = 0;
if (xwidth2 < 0 && yheight2 < 0) this_box_storage.is_rectangle = 1;
if (xwidth == xwidth2 && yheight == yheight2) this_box_storage.is_rectangle = 1;

if (xwidth2 < 0) {
    this_box_storage.x_width2 = xwidth;
    xwidth2 = xwidth;
} else this_box_storage.x_width2 = xwidth2;

if (yheight2 < 0) {
    this_box_storage.y_height2 = yheight;
    yheight2 = yheight;
} else this_box_storage.y_height2 = yheight2;


this_box_storage.normal_vectors[0] = coords_set(0,0,1);
this_box_storage.normal_vectors[1] = coords_set(0,0,1);

// for sides with y component = 0
x_component = 2*zdepth/sqrt((xwidth-xwidth2)*(xwidth-xwidth2)+4*zdepth*zdepth);
z_component = (xwidth-xwidth2)/sqrt(4*zdepth*zdepth+(xwidth-xwidth2)*(xwidth-xwidth2));

this_box_storage.normal_vectors[2] = coords_set(x_component,0,z_component);
this_box_storage.normal_vectors[3] = coords_set(-x_component,0,z_component);

// for sides with x component = 0
y_component = 2*zdepth/sqrt((yheight-yheight2)*(yheight-yheight2)+4*zdepth*zdepth);
z_component = (yheight-yheight2)/sqrt(4*zdepth*zdepth+(yheight-yheight2)*(yheight-yheight2));

this_box_storage.normal_vectors[4] = coords_set(0,y_component,z_component);
this_box_storage.normal_vectors[5] = coords_set(0,-y_component,z_component);

this_box_volume.geometry.visualization_on = visualize;

this_box_volume.geometry.geometry_parameters.p_box_storage = &this_box_storage;

// Assign pointers to functions for intersection with the shape, checking if a point is inside the shape
if (this_box_storage.is_rectangle == 1) {
this_box_volume.geometry.intersect_function = &sample_box_intersect_simple;
this_box_volume.geometry.within_function = &r_within_box_simple;
}
else {
this_box_volume.geometry.intersect_function = &sample_box_intersect_advanced;
this_box_volume.geometry.within_function = &r_within_box_advanced;
}

this_box_volume.geometry.shell_points = &box_shell_points;
this_box_volume.geometry.mcdisplay_function = &mcdisplay_box_function;
this_box_volume.geometry.initialize_from_main_function = &initialize_box_geometry_from_main_component;
this_box_volume.geometry.process_rot_allocated = 0;

this_box_volume.geometry.copy_geometry_parameters = &allocate_box_storage_copy;

rot_copy(this_box_volume.geometry.rotation_matrix,ROT_A_CURRENT_COMP); //check how ROT_R_CURRENT_COMP would work
rot_transpose(ROT_A_CURRENT_COMP,this_box_volume.geometry.transpose_rotation_matrix);

// Initialize loggers
this_box_volume.loggers.num_elements = 0;

// packing the information into the global_geometry_element, which is then included in the global_geometry_list.
sprintf(global_geometry_element.name,NAME_CURRENT_COMP);
global_geometry_element.activation_counter = number_of_activations;
global_geometry_element.component_index = INDEX_CURRENT_COMP;
global_geometry_element.Volume = &this_box_volume; // Would be nicer if this m was a pointer, now we have the (small) data two places
add_element_to_geometry_list(&global_geometry_list,global_geometry_element);
}
#line 214424 "MACS_sample_kidney_box.c"
#undef number_of_activations
#undef mask_setting
#undef mask_string
#undef p_interact
#undef focus_r
#undef focus_xh
#undef focus_xw
#undef focus_ah
#undef focus_aw
#undef target_z
#undef target_y
#undef target_x
#undef target_index
#undef visualize
#undef yheight2
#undef xwidth2
#undef zdepth
#undef yheight
#undef xwidth
#undef priority
#undef material_string
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

  /* Initializations for component channel_5_cave2_cyl1. */
  SIG_MESSAGE("channel_5_cave2_cyl1 (Init)");
#define mccompcurname  channel_5_cave2_cyl1
#define mccompcurtype  Union_cylinder
#define mccompcurindex 340
#define loop_index mccchannel_5_cave2_cyl1_loop_index
#define this_cylinder_volume mccchannel_5_cave2_cyl1_this_cylinder_volume
#define global_geometry_element mccchannel_5_cave2_cyl1_global_geometry_element
#define this_cylinder_storage mccchannel_5_cave2_cyl1_this_cylinder_storage
#define material_string mccchannel_5_cave2_cyl1_material_string
#define priority mccchannel_5_cave2_cyl1_priority
#define radius mccchannel_5_cave2_cyl1_radius
#define yheight mccchannel_5_cave2_cyl1_yheight
#define visualize mccchannel_5_cave2_cyl1_visualize
#define target_index mccchannel_5_cave2_cyl1_target_index
#define target_x mccchannel_5_cave2_cyl1_target_x
#define target_y mccchannel_5_cave2_cyl1_target_y
#define target_z mccchannel_5_cave2_cyl1_target_z
#define focus_aw mccchannel_5_cave2_cyl1_focus_aw
#define focus_ah mccchannel_5_cave2_cyl1_focus_ah
#define focus_xw mccchannel_5_cave2_cyl1_focus_xw
#define focus_xh mccchannel_5_cave2_cyl1_focus_xh
#define focus_r mccchannel_5_cave2_cyl1_focus_r
#define p_interact mccchannel_5_cave2_cyl1_p_interact
#define mask_string mccchannel_5_cave2_cyl1_mask_string
#define mask_setting mccchannel_5_cave2_cyl1_mask_setting
#define number_of_activations mccchannel_5_cave2_cyl1_number_of_activations
#line 185 "Union_cylinder.comp"
{
// Initializes the focusing system for this volume including input sanitation.
focus_initialize(&this_cylinder_volume.geometry, POS_A_COMP_INDEX(INDEX_CURRENT_COMP+target_index), POS_A_CURRENT_COMP, ROT_A_CURRENT_COMP, target_index, target_x, target_y, target_z, focus_aw, focus_ah, focus_xw, focus_xh, focus_r, NAME_CURRENT_COMP);

// Input sanitation for this geometry
if (radius <= 0) {
  printf("\nERROR in Union_cylinder named %s, the radius is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}

if (yheight <= 0) {
  printf("\nERROR in Union_cylinder named %s, yheight is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}

// Use sanitation
#ifdef MATERIAL_DETECTOR
if (global_material_list.num_elements == 0) {
  // Here if the user have defined a material, but only after this material
  printf("\nERROR: Need to define a material using Union_make_material before using a Union geometry component. \n");
  printf("       %s was defined before first use of Union_make_material.\n",NAME_CURRENT_COMP);
  exit(1);
}
#endif
#ifndef MATERIAL_DETECTOR
  printf("\nERROR: Need to define a material using Union_make_material before using a Union geometry component. \n");
  exit(1);
#endif


this_cylinder_volume.geometry.is_masked_volume = 0;
this_cylinder_volume.geometry.is_exit_volume = 0;
this_cylinder_volume.geometry.is_mask_volume = 0;

// Read the material input, or if it lacks, use automatic linking.
if (mask_string && strlen(mask_string) && strcmp(mask_string, "NULL") && strcmp(mask_string, "0")) {
    // A mask volume is used to limit the extend of other volumes, called the masked volumes. These are specified in the mask_string.
    // In order for a ray to enter a masked volume, it needs to be both in the region covered by that volume AND the mask volume.
    // When more than
    this_cylinder_volume.geometry.mask_mode = 1; // Default is mask mode is ALL
    if (mask_setting && strlen(mask_setting) && strcmp(mask_setting, "NULL") && strcmp(mask_setting, "0")) {
        if (strcmp(mask_setting,"ALL") == 0 || strcmp(mask_setting,"All") == 0) this_cylinder_volume.geometry.mask_mode = 1;
        else if (strcmp(mask_setting,"ANY") == 0 || strcmp(mask_setting,"Any") == 0) this_cylinder_volume.geometry.mask_mode = 2;
        else {
            printf("The mask_mode of component %s is set to %s, but must be either ALL or ANY.\n",NAME_CURRENT_COMP,mask_setting);
            exit(1);
        }
    }
    
    for (loop_index=0;loop_index<global_geometry_list.num_elements;loop_index++) {
        // Add mask list
        if (1 == manual_linking_function(global_geometry_list.elements[loop_index].name,mask_string)) {
            add_element_to_int_list(&this_cylinder_volume.geometry.mask_list,global_geometry_list.elements[loop_index].component_index);
            add_element_to_int_list(&global_geometry_list.elements[loop_index].Volume->geometry.masked_by_list,INDEX_CURRENT_COMP);
            global_geometry_list.elements[loop_index].Volume->geometry.is_masked_volume = 1;
            if (this_cylinder_volume.geometry.mask_mode == 2)
                global_geometry_list.elements[loop_index].Volume->geometry.mask_mode = 2;
            if (this_cylinder_volume.geometry.mask_mode == 1) {
                if (global_geometry_list.elements[loop_index].Volume->geometry.is_masked_volume == 1 && global_geometry_list.elements[loop_index].Volume->geometry.mask_mode != 2)
                    // If more than one mask is added to one volume, the ANY mode overwrites the (default) ALL mode.
                    global_geometry_list.elements[loop_index].Volume->geometry.mask_mode = 1;
            }
            
            found_geometries = 1;
        }
    }
    if (found_geometries == 0) {
        printf("The mask_string in geometry: %s did not find any of the specified volumes in the mask_string %s \n",NAME_CURRENT_COMP,mask_string);
        exit(1);
    }
    this_cylinder_volume.p_physics = malloc(sizeof(struct physics_struct));
    this_cylinder_volume.p_physics->is_vacuum = 0; // Makes this volume a vacuum
    this_cylinder_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
    this_cylinder_volume.p_physics->my_a = 0; // Should not be used.
    sprintf(this_cylinder_volume.p_physics->name,"Mask");
    this_cylinder_volume.geometry.is_mask_volume = 1;
    
    
// Read the material input, or if it lacks, use automatic linking.
} else if (material_string && strlen(material_string) && strcmp(material_string, "NULL") && strcmp(material_string, "0")) {
    // A geometry string was given, use it to determine which material
    if (0 == strcmp(material_string,"vacuum") || 0 == strcmp(material_string,"Vacuum")) {
        // One could have a global physics struct for vacuum instead of creating one for each
        this_cylinder_volume.p_physics = malloc(sizeof(struct physics_struct));
        this_cylinder_volume.p_physics->is_vacuum = 1; // Makes this volume a vacuum
        this_cylinder_volume.p_physics->number_of_processes = (int) 0;
        this_cylinder_volume.p_physics->my_a = 0; // Should not be used.
        sprintf(this_cylinder_volume.p_physics->name,"Vacuum");
    } else if (0 == strcmp(material_string,"exit") || 0 == strcmp(material_string,"Exit")) {
        // One could have a global physics struct for exit instead of creating one for each
        this_cylinder_volume.p_physics = malloc(sizeof(struct physics_struct));
        this_cylinder_volume.p_physics->is_vacuum = 1; // Makes this volume a vacuum
        this_cylinder_volume.p_physics->number_of_processes = (int) 0;
        this_cylinder_volume.p_physics->my_a = 0; // Should not be used.
        this_cylinder_volume.geometry.is_exit_volume = 1;
        sprintf(this_cylinder_volume.p_physics->name,"Exit");
    } else {
        for (loop_index=0;loop_index<global_material_list.num_elements;loop_index++) {
          if (0 == strcmp(material_string,global_material_list.elements[loop_index].name)) {
            this_cylinder_volume.p_physics = global_material_list.elements[loop_index].physics;
            break;
          }
          if (loop_index == global_material_list.num_elements-1) {
            printf("\n");
            printf("ERROR: The material string \"%s\" in Union geometry \"%s\" did not match a specified material. \n",material_string,NAME_CURRENT_COMP);
            printf("       The materials available at this point (need to be defined before the geometry): \n");
            for (loop_index=0;loop_index<global_material_list.num_elements;loop_index++)
              printf("         %s\n",global_material_list.elements[loop_index].name);
            printf("\n");
            printf("       It is also possible to use one of the defualt materials avaiable: \n");
            printf("           Vacuum (for a Volume without scattering or absorption)\n");
            printf("           Exit (for a Volume where the ray exits the component if it enters)\n");
            printf("           Mask (for a Volume that masks existing volumes specified in the mask_string\n");
            exit(1);
          }
        }
    }
} else {
    // Automatic linking, simply using the last defined material.
    #ifndef MATERIAL_DETECTOR
        printf("Need to define a material before the geometry to use automatic linking %s.\n",NAME_CURRENT_COMP);
        exit(1);
    #endif
    this_cylinder_volume.p_physics = global_material_list.elements[global_material_list.num_elements-1].physics;
}

sprintf(this_cylinder_volume.name,NAME_CURRENT_COMP);
sprintf(this_cylinder_volume.geometry.shape,"cylinder");
this_cylinder_volume.geometry.priority_value = priority;
// Currently the coordinates will be in absolute space.
this_cylinder_volume.geometry.center = POS_A_CURRENT_COMP;

this_cylinder_volume.geometry.geometry_p_interact = p_interact;
this_cylinder_storage.cyl_radius = radius;
this_cylinder_storage.height = yheight;
this_cylinder_volume.geometry.visualization_on = visualize;
this_cylinder_volume.geometry.geometry_parameters.p_cylinder_storage = &this_cylinder_storage;
this_cylinder_volume.geometry.within_function = &r_within_cylinder;
this_cylinder_volume.geometry.intersect_function = &sample_cylinder_intersect;
this_cylinder_volume.geometry.mcdisplay_function = &mcdisplay_cylinder_function;
this_cylinder_volume.geometry.shell_points = &cylinder_shell_points;
this_cylinder_volume.geometry.initialize_from_main_function = &initialize_cylinder_geometry_from_main_component;
this_cylinder_volume.geometry.process_rot_allocated = 0;
this_cylinder_volume.geometry.copy_geometry_parameters = &allocate_cylinder_storage_copy;

rot_copy(this_cylinder_volume.geometry.rotation_matrix,ROT_A_CURRENT_COMP);
rot_transpose(ROT_A_CURRENT_COMP,this_cylinder_volume.geometry.transpose_rotation_matrix);

// Initialize loggers
this_cylinder_volume.loggers.num_elements = 0;

// packing the information into the global_geometry_element, which is then included in the global_geometry_list.
sprintf(global_geometry_element.name,NAME_CURRENT_COMP);
global_geometry_element.activation_counter = number_of_activations;
global_geometry_element.component_index = INDEX_CURRENT_COMP;
global_geometry_element.Volume = &this_cylinder_volume; // Would be nicer if this m was a pointer, now we have the (small) data two places
add_element_to_geometry_list(&global_geometry_list,global_geometry_element);
}
#line 214640 "MACS_sample_kidney_box.c"
#undef number_of_activations
#undef mask_setting
#undef mask_string
#undef p_interact
#undef focus_r
#undef focus_xh
#undef focus_xw
#undef focus_ah
#undef focus_aw
#undef target_z
#undef target_y
#undef target_x
#undef target_index
#undef visualize
#undef yheight
#undef radius
#undef priority
#undef material_string
#undef this_cylinder_storage
#undef global_geometry_element
#undef this_cylinder_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

  /* Initializations for component channel_5_cave2_box1. */
  SIG_MESSAGE("channel_5_cave2_box1 (Init)");
#define mccompcurname  channel_5_cave2_box1
#define mccompcurtype  Union_box
#define mccompcurindex 341
#define loop_index mccchannel_5_cave2_box1_loop_index
#define this_box_volume mccchannel_5_cave2_box1_this_box_volume
#define global_geometry_element mccchannel_5_cave2_box1_global_geometry_element
#define this_box_storage mccchannel_5_cave2_box1_this_box_storage
#define material_string mccchannel_5_cave2_box1_material_string
#define priority mccchannel_5_cave2_box1_priority
#define xwidth mccchannel_5_cave2_box1_xwidth
#define yheight mccchannel_5_cave2_box1_yheight
#define zdepth mccchannel_5_cave2_box1_zdepth
#define xwidth2 mccchannel_5_cave2_box1_xwidth2
#define yheight2 mccchannel_5_cave2_box1_yheight2
#define visualize mccchannel_5_cave2_box1_visualize
#define target_index mccchannel_5_cave2_box1_target_index
#define target_x mccchannel_5_cave2_box1_target_x
#define target_y mccchannel_5_cave2_box1_target_y
#define target_z mccchannel_5_cave2_box1_target_z
#define focus_aw mccchannel_5_cave2_box1_focus_aw
#define focus_ah mccchannel_5_cave2_box1_focus_ah
#define focus_xw mccchannel_5_cave2_box1_focus_xw
#define focus_xh mccchannel_5_cave2_box1_focus_xh
#define focus_r mccchannel_5_cave2_box1_focus_r
#define p_interact mccchannel_5_cave2_box1_p_interact
#define mask_string mccchannel_5_cave2_box1_mask_string
#define mask_setting mccchannel_5_cave2_box1_mask_setting
#define number_of_activations mccchannel_5_cave2_box1_number_of_activations
#line 224 "Union_box.comp"
{
// Initializes the focusing system for this volume including input sanitation.
focus_initialize(&this_box_volume.geometry, POS_A_COMP_INDEX(INDEX_CURRENT_COMP+target_index), POS_A_CURRENT_COMP, ROT_A_CURRENT_COMP, target_index, target_x, target_y, target_z, focus_aw, focus_ah, focus_xw, focus_xh, focus_r, NAME_CURRENT_COMP);

// Input sanitation for this geometry
if (xwidth <= 0) {
  printf("\nERROR in Union_box named %s, the xwidth is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (yheight <= 0) {
  printf("\nERROR in Union_box named %s, yheight is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (zdepth <= 0) {
  printf("\nERROR in Union_box named %s, zdepth is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (xwidth2 <= 0 && xwidth2 != -1) {
  printf("\nERROR in Union_box named %s, the xwidth2 is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (yheight2 <= 0 && yheight2 != -1) {
  printf("\nERROR in Union_box named %s, yheight2 is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}

// Use sanitation
if (global_material_list.num_elements == 0) {
  printf("\nERROR: Need to define a material using Union_make_material before using a Union geometry component. \n");
  printf("       %s was defined before first use of Union_make_material.\n",NAME_CURRENT_COMP);
  exit(1);
}

this_box_volume.geometry.is_masked_volume = 0;
this_box_volume.geometry.is_exit_volume = 0;
this_box_volume.geometry.is_mask_volume = 0;
// check if the volume is a mask, if it is the material string is irelevant.
if (mask_string && strlen(mask_string) && strcmp(mask_string, "NULL") && strcmp(mask_string, "0")) {
    // A mask volume is used to limit the extend of other volumes, called the masked volumes. These are specified in the mask_string.
    // In order for a ray to enter a masked volume, it needs to be both in the region covered by that volume AND the mask volume.
    // When more than
    this_box_volume.geometry.mask_mode = 1; // Default is mask mode is ALL
    if (mask_setting && strlen(mask_setting) && strcmp(mask_setting, "NULL") && strcmp(mask_setting, "0")) {
        if (strcmp(mask_setting,"ALL") == 0 || strcmp(mask_setting,"All") == 0) this_box_volume.geometry.mask_mode = 1;
        else if (strcmp(mask_setting,"ANY") == 0 || strcmp(mask_setting,"Any") == 0) this_box_volume.geometry.mask_mode = 2;
        else {
            printf("The mask_mode of component %s is set to %s, but must be either ALL or ANY.\n",NAME_CURRENT_COMP,mask_setting);
            exit(1);
        }
    }
    
    for (loop_index=0;loop_index<global_geometry_list.num_elements;loop_index++) {
        // Add mask list
        if (1 == manual_linking_function(global_geometry_list.elements[loop_index].name,mask_string)) {
            add_element_to_int_list(&this_box_volume.geometry.mask_list,global_geometry_list.elements[loop_index].component_index);
            add_element_to_int_list(&global_geometry_list.elements[loop_index].Volume->geometry.masked_by_list,INDEX_CURRENT_COMP);
            global_geometry_list.elements[loop_index].Volume->geometry.is_masked_volume = 1;
            if (this_box_volume.geometry.mask_mode == 2)
                global_geometry_list.elements[loop_index].Volume->geometry.mask_mode = 2;
            if (this_box_volume.geometry.mask_mode == 1) {
                if (global_geometry_list.elements[loop_index].Volume->geometry.is_masked_volume == 1 && global_geometry_list.elements[loop_index].Volume->geometry.mask_mode != 2)
                    // If more than one mask is added to one volume, the ANY mode overwrites the (default) ALL mode.
                    global_geometry_list.elements[loop_index].Volume->geometry.mask_mode = 1;
            }
            
            found_geometries = 1;
        }
    }
    if (found_geometries == 0) {
        printf("The mask_string in geometry: %s did not find any of the specified volumes in the mask_string %s \n",NAME_CURRENT_COMP,mask_string);
        exit(1);
    }
    this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
    this_box_volume.p_physics->is_vacuum = 0; // Makes this volume a vacuum
    this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
    this_box_volume.p_physics->my_a = 0; // Should not be used.
    sprintf(this_box_volume.p_physics->name,"Mask");
    this_box_volume.geometry.is_mask_volume = 1;
    
    
// Read the material input, or if it lacks, use automatic linking.
} else if (material_string && strlen(material_string) && strcmp(material_string, "NULL") && strcmp(material_string, "0")) {
    // A geometry string was given, use it to determine which material
    if (0 == strcmp(material_string,"vacuum") || 0 == strcmp(material_string,"Vacuum")) {
        // One could have a global physics struct for vacuum instead of creating one for each
        this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
        this_box_volume.p_physics->is_vacuum = 1; // Makes this volume a vacuum
        this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
        this_box_volume.p_physics->my_a = 0; // Should not be used.
        sprintf(this_box_volume.p_physics->name,"Vacuum");
    } else if (0 == strcmp(material_string,"exit") || 0 == strcmp(material_string,"Exit")) {
        // One could have a global physics struct for vacuum instead of creating one for each
        this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
        this_box_volume.p_physics->is_vacuum = 1; // Makes this volume a vacuum
        this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
        this_box_volume.p_physics->my_a = 0; // Should not be used.
        this_box_volume.geometry.is_exit_volume = 1;
        sprintf(this_box_volume.p_physics->name,"Exit");
    } else {
        #ifndef MATERIAL_DETECTOR
            printf("Need to define a material before refering to it in a geometry %s.\n",NAME_CURRENT_COMP);
            exit(1);
        #endif
        for (loop_index=0;loop_index<global_material_list.num_elements;loop_index++) {
            if (0 == strcmp(material_string,global_material_list.elements[loop_index].name)) {
                this_box_volume.p_physics = global_material_list.elements[loop_index].physics;
                break;
            }
            if (loop_index == global_material_list.num_elements-1) {
            printf("\n");
            printf("ERROR: The material string \"%s\" in Union geometry \"%s\" did not match a specified material. \n",material_string,NAME_CURRENT_COMP);
            printf("       The materials available at this point (need to be defined before the geometry): \n");
            for (loop_index=0;loop_index<global_material_list.num_elements;loop_index++)
              printf("         %s\n",global_material_list.elements[loop_index].name);
            printf("\n");
            printf("       It is also possible to use one of the defualt materials avaiable: \n");
            printf("           Vacuum (for a Volume without scattering or absorption)\n");
            printf("           Exit (for a Volume where the ray exits the component if it enters)\n");
            printf("           Mask (for a Volume that masks existing volumes specified in the mask_string\n");
            exit(1);
          }
        }
    }
} else {
    // Automatic linking, simply using the last defined material.
    #ifndef MATERIAL_DETECTOR
        printf("Need to define a material before the geometry to use automatic linking %s.\n",NAME_CURRENT_COMP);
        exit(1);
    #endif
    this_box_volume.p_physics = global_material_list.elements[global_material_list.num_elements-1].physics;
}

sprintf(this_box_volume.name,NAME_CURRENT_COMP);
sprintf(this_box_volume.geometry.shape,"box");
this_box_volume.geometry.priority_value = priority;
this_box_volume.geometry.geometry_p_interact = p_interact;
// Currently the coordinates will be in absolute space.
this_box_volume.geometry.center = POS_A_CURRENT_COMP;

this_box_storage.z_depth = zdepth;
this_box_storage.x_width1 = xwidth;
this_box_storage.y_height1 = yheight;

this_box_storage.is_rectangle = 0;
if (xwidth2 < 0 && yheight2 < 0) this_box_storage.is_rectangle = 1;
if (xwidth == xwidth2 && yheight == yheight2) this_box_storage.is_rectangle = 1;

if (xwidth2 < 0) {
    this_box_storage.x_width2 = xwidth;
    xwidth2 = xwidth;
} else this_box_storage.x_width2 = xwidth2;

if (yheight2 < 0) {
    this_box_storage.y_height2 = yheight;
    yheight2 = yheight;
} else this_box_storage.y_height2 = yheight2;


this_box_storage.normal_vectors[0] = coords_set(0,0,1);
this_box_storage.normal_vectors[1] = coords_set(0,0,1);

// for sides with y component = 0
x_component = 2*zdepth/sqrt((xwidth-xwidth2)*(xwidth-xwidth2)+4*zdepth*zdepth);
z_component = (xwidth-xwidth2)/sqrt(4*zdepth*zdepth+(xwidth-xwidth2)*(xwidth-xwidth2));

this_box_storage.normal_vectors[2] = coords_set(x_component,0,z_component);
this_box_storage.normal_vectors[3] = coords_set(-x_component,0,z_component);

// for sides with x component = 0
y_component = 2*zdepth/sqrt((yheight-yheight2)*(yheight-yheight2)+4*zdepth*zdepth);
z_component = (yheight-yheight2)/sqrt(4*zdepth*zdepth+(yheight-yheight2)*(yheight-yheight2));

this_box_storage.normal_vectors[4] = coords_set(0,y_component,z_component);
this_box_storage.normal_vectors[5] = coords_set(0,-y_component,z_component);

this_box_volume.geometry.visualization_on = visualize;

this_box_volume.geometry.geometry_parameters.p_box_storage = &this_box_storage;

// Assign pointers to functions for intersection with the shape, checking if a point is inside the shape
if (this_box_storage.is_rectangle == 1) {
this_box_volume.geometry.intersect_function = &sample_box_intersect_simple;
this_box_volume.geometry.within_function = &r_within_box_simple;
}
else {
this_box_volume.geometry.intersect_function = &sample_box_intersect_advanced;
this_box_volume.geometry.within_function = &r_within_box_advanced;
}

this_box_volume.geometry.shell_points = &box_shell_points;
this_box_volume.geometry.mcdisplay_function = &mcdisplay_box_function;
this_box_volume.geometry.initialize_from_main_function = &initialize_box_geometry_from_main_component;
this_box_volume.geometry.process_rot_allocated = 0;

this_box_volume.geometry.copy_geometry_parameters = &allocate_box_storage_copy;

rot_copy(this_box_volume.geometry.rotation_matrix,ROT_A_CURRENT_COMP); //check how ROT_R_CURRENT_COMP would work
rot_transpose(ROT_A_CURRENT_COMP,this_box_volume.geometry.transpose_rotation_matrix);

// Initialize loggers
this_box_volume.loggers.num_elements = 0;

// packing the information into the global_geometry_element, which is then included in the global_geometry_list.
sprintf(global_geometry_element.name,NAME_CURRENT_COMP);
global_geometry_element.activation_counter = number_of_activations;
global_geometry_element.component_index = INDEX_CURRENT_COMP;
global_geometry_element.Volume = &this_box_volume; // Would be nicer if this m was a pointer, now we have the (small) data two places
add_element_to_geometry_list(&global_geometry_list,global_geometry_element);
}
#line 214907 "MACS_sample_kidney_box.c"
#undef number_of_activations
#undef mask_setting
#undef mask_string
#undef p_interact
#undef focus_r
#undef focus_xh
#undef focus_xw
#undef focus_ah
#undef focus_aw
#undef target_z
#undef target_y
#undef target_x
#undef target_index
#undef visualize
#undef yheight2
#undef xwidth2
#undef zdepth
#undef yheight
#undef xwidth
#undef priority
#undef material_string
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

  /* Initializations for component channel_5_cave2_box2. */
  SIG_MESSAGE("channel_5_cave2_box2 (Init)");
#define mccompcurname  channel_5_cave2_box2
#define mccompcurtype  Union_box
#define mccompcurindex 342
#define loop_index mccchannel_5_cave2_box2_loop_index
#define this_box_volume mccchannel_5_cave2_box2_this_box_volume
#define global_geometry_element mccchannel_5_cave2_box2_global_geometry_element
#define this_box_storage mccchannel_5_cave2_box2_this_box_storage
#define material_string mccchannel_5_cave2_box2_material_string
#define priority mccchannel_5_cave2_box2_priority
#define xwidth mccchannel_5_cave2_box2_xwidth
#define yheight mccchannel_5_cave2_box2_yheight
#define zdepth mccchannel_5_cave2_box2_zdepth
#define xwidth2 mccchannel_5_cave2_box2_xwidth2
#define yheight2 mccchannel_5_cave2_box2_yheight2
#define visualize mccchannel_5_cave2_box2_visualize
#define target_index mccchannel_5_cave2_box2_target_index
#define target_x mccchannel_5_cave2_box2_target_x
#define target_y mccchannel_5_cave2_box2_target_y
#define target_z mccchannel_5_cave2_box2_target_z
#define focus_aw mccchannel_5_cave2_box2_focus_aw
#define focus_ah mccchannel_5_cave2_box2_focus_ah
#define focus_xw mccchannel_5_cave2_box2_focus_xw
#define focus_xh mccchannel_5_cave2_box2_focus_xh
#define focus_r mccchannel_5_cave2_box2_focus_r
#define p_interact mccchannel_5_cave2_box2_p_interact
#define mask_string mccchannel_5_cave2_box2_mask_string
#define mask_setting mccchannel_5_cave2_box2_mask_setting
#define number_of_activations mccchannel_5_cave2_box2_number_of_activations
#line 224 "Union_box.comp"
{
// Initializes the focusing system for this volume including input sanitation.
focus_initialize(&this_box_volume.geometry, POS_A_COMP_INDEX(INDEX_CURRENT_COMP+target_index), POS_A_CURRENT_COMP, ROT_A_CURRENT_COMP, target_index, target_x, target_y, target_z, focus_aw, focus_ah, focus_xw, focus_xh, focus_r, NAME_CURRENT_COMP);

// Input sanitation for this geometry
if (xwidth <= 0) {
  printf("\nERROR in Union_box named %s, the xwidth is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (yheight <= 0) {
  printf("\nERROR in Union_box named %s, yheight is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (zdepth <= 0) {
  printf("\nERROR in Union_box named %s, zdepth is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (xwidth2 <= 0 && xwidth2 != -1) {
  printf("\nERROR in Union_box named %s, the xwidth2 is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (yheight2 <= 0 && yheight2 != -1) {
  printf("\nERROR in Union_box named %s, yheight2 is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}

// Use sanitation
if (global_material_list.num_elements == 0) {
  printf("\nERROR: Need to define a material using Union_make_material before using a Union geometry component. \n");
  printf("       %s was defined before first use of Union_make_material.\n",NAME_CURRENT_COMP);
  exit(1);
}

this_box_volume.geometry.is_masked_volume = 0;
this_box_volume.geometry.is_exit_volume = 0;
this_box_volume.geometry.is_mask_volume = 0;
// check if the volume is a mask, if it is the material string is irelevant.
if (mask_string && strlen(mask_string) && strcmp(mask_string, "NULL") && strcmp(mask_string, "0")) {
    // A mask volume is used to limit the extend of other volumes, called the masked volumes. These are specified in the mask_string.
    // In order for a ray to enter a masked volume, it needs to be both in the region covered by that volume AND the mask volume.
    // When more than
    this_box_volume.geometry.mask_mode = 1; // Default is mask mode is ALL
    if (mask_setting && strlen(mask_setting) && strcmp(mask_setting, "NULL") && strcmp(mask_setting, "0")) {
        if (strcmp(mask_setting,"ALL") == 0 || strcmp(mask_setting,"All") == 0) this_box_volume.geometry.mask_mode = 1;
        else if (strcmp(mask_setting,"ANY") == 0 || strcmp(mask_setting,"Any") == 0) this_box_volume.geometry.mask_mode = 2;
        else {
            printf("The mask_mode of component %s is set to %s, but must be either ALL or ANY.\n",NAME_CURRENT_COMP,mask_setting);
            exit(1);
        }
    }
    
    for (loop_index=0;loop_index<global_geometry_list.num_elements;loop_index++) {
        // Add mask list
        if (1 == manual_linking_function(global_geometry_list.elements[loop_index].name,mask_string)) {
            add_element_to_int_list(&this_box_volume.geometry.mask_list,global_geometry_list.elements[loop_index].component_index);
            add_element_to_int_list(&global_geometry_list.elements[loop_index].Volume->geometry.masked_by_list,INDEX_CURRENT_COMP);
            global_geometry_list.elements[loop_index].Volume->geometry.is_masked_volume = 1;
            if (this_box_volume.geometry.mask_mode == 2)
                global_geometry_list.elements[loop_index].Volume->geometry.mask_mode = 2;
            if (this_box_volume.geometry.mask_mode == 1) {
                if (global_geometry_list.elements[loop_index].Volume->geometry.is_masked_volume == 1 && global_geometry_list.elements[loop_index].Volume->geometry.mask_mode != 2)
                    // If more than one mask is added to one volume, the ANY mode overwrites the (default) ALL mode.
                    global_geometry_list.elements[loop_index].Volume->geometry.mask_mode = 1;
            }
            
            found_geometries = 1;
        }
    }
    if (found_geometries == 0) {
        printf("The mask_string in geometry: %s did not find any of the specified volumes in the mask_string %s \n",NAME_CURRENT_COMP,mask_string);
        exit(1);
    }
    this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
    this_box_volume.p_physics->is_vacuum = 0; // Makes this volume a vacuum
    this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
    this_box_volume.p_physics->my_a = 0; // Should not be used.
    sprintf(this_box_volume.p_physics->name,"Mask");
    this_box_volume.geometry.is_mask_volume = 1;
    
    
// Read the material input, or if it lacks, use automatic linking.
} else if (material_string && strlen(material_string) && strcmp(material_string, "NULL") && strcmp(material_string, "0")) {
    // A geometry string was given, use it to determine which material
    if (0 == strcmp(material_string,"vacuum") || 0 == strcmp(material_string,"Vacuum")) {
        // One could have a global physics struct for vacuum instead of creating one for each
        this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
        this_box_volume.p_physics->is_vacuum = 1; // Makes this volume a vacuum
        this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
        this_box_volume.p_physics->my_a = 0; // Should not be used.
        sprintf(this_box_volume.p_physics->name,"Vacuum");
    } else if (0 == strcmp(material_string,"exit") || 0 == strcmp(material_string,"Exit")) {
        // One could have a global physics struct for vacuum instead of creating one for each
        this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
        this_box_volume.p_physics->is_vacuum = 1; // Makes this volume a vacuum
        this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
        this_box_volume.p_physics->my_a = 0; // Should not be used.
        this_box_volume.geometry.is_exit_volume = 1;
        sprintf(this_box_volume.p_physics->name,"Exit");
    } else {
        #ifndef MATERIAL_DETECTOR
            printf("Need to define a material before refering to it in a geometry %s.\n",NAME_CURRENT_COMP);
            exit(1);
        #endif
        for (loop_index=0;loop_index<global_material_list.num_elements;loop_index++) {
            if (0 == strcmp(material_string,global_material_list.elements[loop_index].name)) {
                this_box_volume.p_physics = global_material_list.elements[loop_index].physics;
                break;
            }
            if (loop_index == global_material_list.num_elements-1) {
            printf("\n");
            printf("ERROR: The material string \"%s\" in Union geometry \"%s\" did not match a specified material. \n",material_string,NAME_CURRENT_COMP);
            printf("       The materials available at this point (need to be defined before the geometry): \n");
            for (loop_index=0;loop_index<global_material_list.num_elements;loop_index++)
              printf("         %s\n",global_material_list.elements[loop_index].name);
            printf("\n");
            printf("       It is also possible to use one of the defualt materials avaiable: \n");
            printf("           Vacuum (for a Volume without scattering or absorption)\n");
            printf("           Exit (for a Volume where the ray exits the component if it enters)\n");
            printf("           Mask (for a Volume that masks existing volumes specified in the mask_string\n");
            exit(1);
          }
        }
    }
} else {
    // Automatic linking, simply using the last defined material.
    #ifndef MATERIAL_DETECTOR
        printf("Need to define a material before the geometry to use automatic linking %s.\n",NAME_CURRENT_COMP);
        exit(1);
    #endif
    this_box_volume.p_physics = global_material_list.elements[global_material_list.num_elements-1].physics;
}

sprintf(this_box_volume.name,NAME_CURRENT_COMP);
sprintf(this_box_volume.geometry.shape,"box");
this_box_volume.geometry.priority_value = priority;
this_box_volume.geometry.geometry_p_interact = p_interact;
// Currently the coordinates will be in absolute space.
this_box_volume.geometry.center = POS_A_CURRENT_COMP;

this_box_storage.z_depth = zdepth;
this_box_storage.x_width1 = xwidth;
this_box_storage.y_height1 = yheight;

this_box_storage.is_rectangle = 0;
if (xwidth2 < 0 && yheight2 < 0) this_box_storage.is_rectangle = 1;
if (xwidth == xwidth2 && yheight == yheight2) this_box_storage.is_rectangle = 1;

if (xwidth2 < 0) {
    this_box_storage.x_width2 = xwidth;
    xwidth2 = xwidth;
} else this_box_storage.x_width2 = xwidth2;

if (yheight2 < 0) {
    this_box_storage.y_height2 = yheight;
    yheight2 = yheight;
} else this_box_storage.y_height2 = yheight2;


this_box_storage.normal_vectors[0] = coords_set(0,0,1);
this_box_storage.normal_vectors[1] = coords_set(0,0,1);

// for sides with y component = 0
x_component = 2*zdepth/sqrt((xwidth-xwidth2)*(xwidth-xwidth2)+4*zdepth*zdepth);
z_component = (xwidth-xwidth2)/sqrt(4*zdepth*zdepth+(xwidth-xwidth2)*(xwidth-xwidth2));

this_box_storage.normal_vectors[2] = coords_set(x_component,0,z_component);
this_box_storage.normal_vectors[3] = coords_set(-x_component,0,z_component);

// for sides with x component = 0
y_component = 2*zdepth/sqrt((yheight-yheight2)*(yheight-yheight2)+4*zdepth*zdepth);
z_component = (yheight-yheight2)/sqrt(4*zdepth*zdepth+(yheight-yheight2)*(yheight-yheight2));

this_box_storage.normal_vectors[4] = coords_set(0,y_component,z_component);
this_box_storage.normal_vectors[5] = coords_set(0,-y_component,z_component);

this_box_volume.geometry.visualization_on = visualize;

this_box_volume.geometry.geometry_parameters.p_box_storage = &this_box_storage;

// Assign pointers to functions for intersection with the shape, checking if a point is inside the shape
if (this_box_storage.is_rectangle == 1) {
this_box_volume.geometry.intersect_function = &sample_box_intersect_simple;
this_box_volume.geometry.within_function = &r_within_box_simple;
}
else {
this_box_volume.geometry.intersect_function = &sample_box_intersect_advanced;
this_box_volume.geometry.within_function = &r_within_box_advanced;
}

this_box_volume.geometry.shell_points = &box_shell_points;
this_box_volume.geometry.mcdisplay_function = &mcdisplay_box_function;
this_box_volume.geometry.initialize_from_main_function = &initialize_box_geometry_from_main_component;
this_box_volume.geometry.process_rot_allocated = 0;

this_box_volume.geometry.copy_geometry_parameters = &allocate_box_storage_copy;

rot_copy(this_box_volume.geometry.rotation_matrix,ROT_A_CURRENT_COMP); //check how ROT_R_CURRENT_COMP would work
rot_transpose(ROT_A_CURRENT_COMP,this_box_volume.geometry.transpose_rotation_matrix);

// Initialize loggers
this_box_volume.loggers.num_elements = 0;

// packing the information into the global_geometry_element, which is then included in the global_geometry_list.
sprintf(global_geometry_element.name,NAME_CURRENT_COMP);
global_geometry_element.activation_counter = number_of_activations;
global_geometry_element.component_index = INDEX_CURRENT_COMP;
global_geometry_element.Volume = &this_box_volume; // Would be nicer if this m was a pointer, now we have the (small) data two places
add_element_to_geometry_list(&global_geometry_list,global_geometry_element);
}
#line 215177 "MACS_sample_kidney_box.c"
#undef number_of_activations
#undef mask_setting
#undef mask_string
#undef p_interact
#undef focus_r
#undef focus_xh
#undef focus_xw
#undef focus_ah
#undef focus_aw
#undef target_z
#undef target_y
#undef target_x
#undef target_index
#undef visualize
#undef yheight2
#undef xwidth2
#undef zdepth
#undef yheight
#undef xwidth
#undef priority
#undef material_string
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

  /* Initializations for component channel_5_cave2_box3. */
  SIG_MESSAGE("channel_5_cave2_box3 (Init)");
#define mccompcurname  channel_5_cave2_box3
#define mccompcurtype  Union_box
#define mccompcurindex 343
#define loop_index mccchannel_5_cave2_box3_loop_index
#define this_box_volume mccchannel_5_cave2_box3_this_box_volume
#define global_geometry_element mccchannel_5_cave2_box3_global_geometry_element
#define this_box_storage mccchannel_5_cave2_box3_this_box_storage
#define material_string mccchannel_5_cave2_box3_material_string
#define priority mccchannel_5_cave2_box3_priority
#define xwidth mccchannel_5_cave2_box3_xwidth
#define yheight mccchannel_5_cave2_box3_yheight
#define zdepth mccchannel_5_cave2_box3_zdepth
#define xwidth2 mccchannel_5_cave2_box3_xwidth2
#define yheight2 mccchannel_5_cave2_box3_yheight2
#define visualize mccchannel_5_cave2_box3_visualize
#define target_index mccchannel_5_cave2_box3_target_index
#define target_x mccchannel_5_cave2_box3_target_x
#define target_y mccchannel_5_cave2_box3_target_y
#define target_z mccchannel_5_cave2_box3_target_z
#define focus_aw mccchannel_5_cave2_box3_focus_aw
#define focus_ah mccchannel_5_cave2_box3_focus_ah
#define focus_xw mccchannel_5_cave2_box3_focus_xw
#define focus_xh mccchannel_5_cave2_box3_focus_xh
#define focus_r mccchannel_5_cave2_box3_focus_r
#define p_interact mccchannel_5_cave2_box3_p_interact
#define mask_string mccchannel_5_cave2_box3_mask_string
#define mask_setting mccchannel_5_cave2_box3_mask_setting
#define number_of_activations mccchannel_5_cave2_box3_number_of_activations
#line 224 "Union_box.comp"
{
// Initializes the focusing system for this volume including input sanitation.
focus_initialize(&this_box_volume.geometry, POS_A_COMP_INDEX(INDEX_CURRENT_COMP+target_index), POS_A_CURRENT_COMP, ROT_A_CURRENT_COMP, target_index, target_x, target_y, target_z, focus_aw, focus_ah, focus_xw, focus_xh, focus_r, NAME_CURRENT_COMP);

// Input sanitation for this geometry
if (xwidth <= 0) {
  printf("\nERROR in Union_box named %s, the xwidth is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (yheight <= 0) {
  printf("\nERROR in Union_box named %s, yheight is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (zdepth <= 0) {
  printf("\nERROR in Union_box named %s, zdepth is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (xwidth2 <= 0 && xwidth2 != -1) {
  printf("\nERROR in Union_box named %s, the xwidth2 is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (yheight2 <= 0 && yheight2 != -1) {
  printf("\nERROR in Union_box named %s, yheight2 is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}

// Use sanitation
if (global_material_list.num_elements == 0) {
  printf("\nERROR: Need to define a material using Union_make_material before using a Union geometry component. \n");
  printf("       %s was defined before first use of Union_make_material.\n",NAME_CURRENT_COMP);
  exit(1);
}

this_box_volume.geometry.is_masked_volume = 0;
this_box_volume.geometry.is_exit_volume = 0;
this_box_volume.geometry.is_mask_volume = 0;
// check if the volume is a mask, if it is the material string is irelevant.
if (mask_string && strlen(mask_string) && strcmp(mask_string, "NULL") && strcmp(mask_string, "0")) {
    // A mask volume is used to limit the extend of other volumes, called the masked volumes. These are specified in the mask_string.
    // In order for a ray to enter a masked volume, it needs to be both in the region covered by that volume AND the mask volume.
    // When more than
    this_box_volume.geometry.mask_mode = 1; // Default is mask mode is ALL
    if (mask_setting && strlen(mask_setting) && strcmp(mask_setting, "NULL") && strcmp(mask_setting, "0")) {
        if (strcmp(mask_setting,"ALL") == 0 || strcmp(mask_setting,"All") == 0) this_box_volume.geometry.mask_mode = 1;
        else if (strcmp(mask_setting,"ANY") == 0 || strcmp(mask_setting,"Any") == 0) this_box_volume.geometry.mask_mode = 2;
        else {
            printf("The mask_mode of component %s is set to %s, but must be either ALL or ANY.\n",NAME_CURRENT_COMP,mask_setting);
            exit(1);
        }
    }
    
    for (loop_index=0;loop_index<global_geometry_list.num_elements;loop_index++) {
        // Add mask list
        if (1 == manual_linking_function(global_geometry_list.elements[loop_index].name,mask_string)) {
            add_element_to_int_list(&this_box_volume.geometry.mask_list,global_geometry_list.elements[loop_index].component_index);
            add_element_to_int_list(&global_geometry_list.elements[loop_index].Volume->geometry.masked_by_list,INDEX_CURRENT_COMP);
            global_geometry_list.elements[loop_index].Volume->geometry.is_masked_volume = 1;
            if (this_box_volume.geometry.mask_mode == 2)
                global_geometry_list.elements[loop_index].Volume->geometry.mask_mode = 2;
            if (this_box_volume.geometry.mask_mode == 1) {
                if (global_geometry_list.elements[loop_index].Volume->geometry.is_masked_volume == 1 && global_geometry_list.elements[loop_index].Volume->geometry.mask_mode != 2)
                    // If more than one mask is added to one volume, the ANY mode overwrites the (default) ALL mode.
                    global_geometry_list.elements[loop_index].Volume->geometry.mask_mode = 1;
            }
            
            found_geometries = 1;
        }
    }
    if (found_geometries == 0) {
        printf("The mask_string in geometry: %s did not find any of the specified volumes in the mask_string %s \n",NAME_CURRENT_COMP,mask_string);
        exit(1);
    }
    this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
    this_box_volume.p_physics->is_vacuum = 0; // Makes this volume a vacuum
    this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
    this_box_volume.p_physics->my_a = 0; // Should not be used.
    sprintf(this_box_volume.p_physics->name,"Mask");
    this_box_volume.geometry.is_mask_volume = 1;
    
    
// Read the material input, or if it lacks, use automatic linking.
} else if (material_string && strlen(material_string) && strcmp(material_string, "NULL") && strcmp(material_string, "0")) {
    // A geometry string was given, use it to determine which material
    if (0 == strcmp(material_string,"vacuum") || 0 == strcmp(material_string,"Vacuum")) {
        // One could have a global physics struct for vacuum instead of creating one for each
        this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
        this_box_volume.p_physics->is_vacuum = 1; // Makes this volume a vacuum
        this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
        this_box_volume.p_physics->my_a = 0; // Should not be used.
        sprintf(this_box_volume.p_physics->name,"Vacuum");
    } else if (0 == strcmp(material_string,"exit") || 0 == strcmp(material_string,"Exit")) {
        // One could have a global physics struct for vacuum instead of creating one for each
        this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
        this_box_volume.p_physics->is_vacuum = 1; // Makes this volume a vacuum
        this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
        this_box_volume.p_physics->my_a = 0; // Should not be used.
        this_box_volume.geometry.is_exit_volume = 1;
        sprintf(this_box_volume.p_physics->name,"Exit");
    } else {
        #ifndef MATERIAL_DETECTOR
            printf("Need to define a material before refering to it in a geometry %s.\n",NAME_CURRENT_COMP);
            exit(1);
        #endif
        for (loop_index=0;loop_index<global_material_list.num_elements;loop_index++) {
            if (0 == strcmp(material_string,global_material_list.elements[loop_index].name)) {
                this_box_volume.p_physics = global_material_list.elements[loop_index].physics;
                break;
            }
            if (loop_index == global_material_list.num_elements-1) {
            printf("\n");
            printf("ERROR: The material string \"%s\" in Union geometry \"%s\" did not match a specified material. \n",material_string,NAME_CURRENT_COMP);
            printf("       The materials available at this point (need to be defined before the geometry): \n");
            for (loop_index=0;loop_index<global_material_list.num_elements;loop_index++)
              printf("         %s\n",global_material_list.elements[loop_index].name);
            printf("\n");
            printf("       It is also possible to use one of the defualt materials avaiable: \n");
            printf("           Vacuum (for a Volume without scattering or absorption)\n");
            printf("           Exit (for a Volume where the ray exits the component if it enters)\n");
            printf("           Mask (for a Volume that masks existing volumes specified in the mask_string\n");
            exit(1);
          }
        }
    }
} else {
    // Automatic linking, simply using the last defined material.
    #ifndef MATERIAL_DETECTOR
        printf("Need to define a material before the geometry to use automatic linking %s.\n",NAME_CURRENT_COMP);
        exit(1);
    #endif
    this_box_volume.p_physics = global_material_list.elements[global_material_list.num_elements-1].physics;
}

sprintf(this_box_volume.name,NAME_CURRENT_COMP);
sprintf(this_box_volume.geometry.shape,"box");
this_box_volume.geometry.priority_value = priority;
this_box_volume.geometry.geometry_p_interact = p_interact;
// Currently the coordinates will be in absolute space.
this_box_volume.geometry.center = POS_A_CURRENT_COMP;

this_box_storage.z_depth = zdepth;
this_box_storage.x_width1 = xwidth;
this_box_storage.y_height1 = yheight;

this_box_storage.is_rectangle = 0;
if (xwidth2 < 0 && yheight2 < 0) this_box_storage.is_rectangle = 1;
if (xwidth == xwidth2 && yheight == yheight2) this_box_storage.is_rectangle = 1;

if (xwidth2 < 0) {
    this_box_storage.x_width2 = xwidth;
    xwidth2 = xwidth;
} else this_box_storage.x_width2 = xwidth2;

if (yheight2 < 0) {
    this_box_storage.y_height2 = yheight;
    yheight2 = yheight;
} else this_box_storage.y_height2 = yheight2;


this_box_storage.normal_vectors[0] = coords_set(0,0,1);
this_box_storage.normal_vectors[1] = coords_set(0,0,1);

// for sides with y component = 0
x_component = 2*zdepth/sqrt((xwidth-xwidth2)*(xwidth-xwidth2)+4*zdepth*zdepth);
z_component = (xwidth-xwidth2)/sqrt(4*zdepth*zdepth+(xwidth-xwidth2)*(xwidth-xwidth2));

this_box_storage.normal_vectors[2] = coords_set(x_component,0,z_component);
this_box_storage.normal_vectors[3] = coords_set(-x_component,0,z_component);

// for sides with x component = 0
y_component = 2*zdepth/sqrt((yheight-yheight2)*(yheight-yheight2)+4*zdepth*zdepth);
z_component = (yheight-yheight2)/sqrt(4*zdepth*zdepth+(yheight-yheight2)*(yheight-yheight2));

this_box_storage.normal_vectors[4] = coords_set(0,y_component,z_component);
this_box_storage.normal_vectors[5] = coords_set(0,-y_component,z_component);

this_box_volume.geometry.visualization_on = visualize;

this_box_volume.geometry.geometry_parameters.p_box_storage = &this_box_storage;

// Assign pointers to functions for intersection with the shape, checking if a point is inside the shape
if (this_box_storage.is_rectangle == 1) {
this_box_volume.geometry.intersect_function = &sample_box_intersect_simple;
this_box_volume.geometry.within_function = &r_within_box_simple;
}
else {
this_box_volume.geometry.intersect_function = &sample_box_intersect_advanced;
this_box_volume.geometry.within_function = &r_within_box_advanced;
}

this_box_volume.geometry.shell_points = &box_shell_points;
this_box_volume.geometry.mcdisplay_function = &mcdisplay_box_function;
this_box_volume.geometry.initialize_from_main_function = &initialize_box_geometry_from_main_component;
this_box_volume.geometry.process_rot_allocated = 0;

this_box_volume.geometry.copy_geometry_parameters = &allocate_box_storage_copy;

rot_copy(this_box_volume.geometry.rotation_matrix,ROT_A_CURRENT_COMP); //check how ROT_R_CURRENT_COMP would work
rot_transpose(ROT_A_CURRENT_COMP,this_box_volume.geometry.transpose_rotation_matrix);

// Initialize loggers
this_box_volume.loggers.num_elements = 0;

// packing the information into the global_geometry_element, which is then included in the global_geometry_list.
sprintf(global_geometry_element.name,NAME_CURRENT_COMP);
global_geometry_element.activation_counter = number_of_activations;
global_geometry_element.component_index = INDEX_CURRENT_COMP;
global_geometry_element.Volume = &this_box_volume; // Would be nicer if this m was a pointer, now we have the (small) data two places
add_element_to_geometry_list(&global_geometry_list,global_geometry_element);
}
#line 215447 "MACS_sample_kidney_box.c"
#undef number_of_activations
#undef mask_setting
#undef mask_string
#undef p_interact
#undef focus_r
#undef focus_xh
#undef focus_xw
#undef focus_ah
#undef focus_aw
#undef target_z
#undef target_y
#undef target_x
#undef target_index
#undef visualize
#undef yheight2
#undef xwidth2
#undef zdepth
#undef yheight
#undef xwidth
#undef priority
#undef material_string
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

  /* Initializations for component inter_analyzer_colimator_center_5. */
  SIG_MESSAGE("inter_analyzer_colimator_center_5 (Init)");

  /* Initializations for component inter_analyzer_colimator_5_blade_0. */
  SIG_MESSAGE("inter_analyzer_colimator_5_blade_0 (Init)");
#define mccompcurname  inter_analyzer_colimator_5_blade_0
#define mccompcurtype  Union_box
#define mccompcurindex 345
#define loop_index mccinter_analyzer_colimator_5_blade_0_loop_index
#define this_box_volume mccinter_analyzer_colimator_5_blade_0_this_box_volume
#define global_geometry_element mccinter_analyzer_colimator_5_blade_0_global_geometry_element
#define this_box_storage mccinter_analyzer_colimator_5_blade_0_this_box_storage
#define material_string mccinter_analyzer_colimator_5_blade_0_material_string
#define priority mccinter_analyzer_colimator_5_blade_0_priority
#define xwidth mccinter_analyzer_colimator_5_blade_0_xwidth
#define yheight mccinter_analyzer_colimator_5_blade_0_yheight
#define zdepth mccinter_analyzer_colimator_5_blade_0_zdepth
#define xwidth2 mccinter_analyzer_colimator_5_blade_0_xwidth2
#define yheight2 mccinter_analyzer_colimator_5_blade_0_yheight2
#define visualize mccinter_analyzer_colimator_5_blade_0_visualize
#define target_index mccinter_analyzer_colimator_5_blade_0_target_index
#define target_x mccinter_analyzer_colimator_5_blade_0_target_x
#define target_y mccinter_analyzer_colimator_5_blade_0_target_y
#define target_z mccinter_analyzer_colimator_5_blade_0_target_z
#define focus_aw mccinter_analyzer_colimator_5_blade_0_focus_aw
#define focus_ah mccinter_analyzer_colimator_5_blade_0_focus_ah
#define focus_xw mccinter_analyzer_colimator_5_blade_0_focus_xw
#define focus_xh mccinter_analyzer_colimator_5_blade_0_focus_xh
#define focus_r mccinter_analyzer_colimator_5_blade_0_focus_r
#define p_interact mccinter_analyzer_colimator_5_blade_0_p_interact
#define mask_string mccinter_analyzer_colimator_5_blade_0_mask_string
#define mask_setting mccinter_analyzer_colimator_5_blade_0_mask_setting
#define number_of_activations mccinter_analyzer_colimator_5_blade_0_number_of_activations
#line 224 "Union_box.comp"
{
// Initializes the focusing system for this volume including input sanitation.
focus_initialize(&this_box_volume.geometry, POS_A_COMP_INDEX(INDEX_CURRENT_COMP+target_index), POS_A_CURRENT_COMP, ROT_A_CURRENT_COMP, target_index, target_x, target_y, target_z, focus_aw, focus_ah, focus_xw, focus_xh, focus_r, NAME_CURRENT_COMP);

// Input sanitation for this geometry
if (xwidth <= 0) {
  printf("\nERROR in Union_box named %s, the xwidth is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (yheight <= 0) {
  printf("\nERROR in Union_box named %s, yheight is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (zdepth <= 0) {
  printf("\nERROR in Union_box named %s, zdepth is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (xwidth2 <= 0 && xwidth2 != -1) {
  printf("\nERROR in Union_box named %s, the xwidth2 is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (yheight2 <= 0 && yheight2 != -1) {
  printf("\nERROR in Union_box named %s, yheight2 is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}

// Use sanitation
if (global_material_list.num_elements == 0) {
  printf("\nERROR: Need to define a material using Union_make_material before using a Union geometry component. \n");
  printf("       %s was defined before first use of Union_make_material.\n",NAME_CURRENT_COMP);
  exit(1);
}

this_box_volume.geometry.is_masked_volume = 0;
this_box_volume.geometry.is_exit_volume = 0;
this_box_volume.geometry.is_mask_volume = 0;
// check if the volume is a mask, if it is the material string is irelevant.
if (mask_string && strlen(mask_string) && strcmp(mask_string, "NULL") && strcmp(mask_string, "0")) {
    // A mask volume is used to limit the extend of other volumes, called the masked volumes. These are specified in the mask_string.
    // In order for a ray to enter a masked volume, it needs to be both in the region covered by that volume AND the mask volume.
    // When more than
    this_box_volume.geometry.mask_mode = 1; // Default is mask mode is ALL
    if (mask_setting && strlen(mask_setting) && strcmp(mask_setting, "NULL") && strcmp(mask_setting, "0")) {
        if (strcmp(mask_setting,"ALL") == 0 || strcmp(mask_setting,"All") == 0) this_box_volume.geometry.mask_mode = 1;
        else if (strcmp(mask_setting,"ANY") == 0 || strcmp(mask_setting,"Any") == 0) this_box_volume.geometry.mask_mode = 2;
        else {
            printf("The mask_mode of component %s is set to %s, but must be either ALL or ANY.\n",NAME_CURRENT_COMP,mask_setting);
            exit(1);
        }
    }
    
    for (loop_index=0;loop_index<global_geometry_list.num_elements;loop_index++) {
        // Add mask list
        if (1 == manual_linking_function(global_geometry_list.elements[loop_index].name,mask_string)) {
            add_element_to_int_list(&this_box_volume.geometry.mask_list,global_geometry_list.elements[loop_index].component_index);
            add_element_to_int_list(&global_geometry_list.elements[loop_index].Volume->geometry.masked_by_list,INDEX_CURRENT_COMP);
            global_geometry_list.elements[loop_index].Volume->geometry.is_masked_volume = 1;
            if (this_box_volume.geometry.mask_mode == 2)
                global_geometry_list.elements[loop_index].Volume->geometry.mask_mode = 2;
            if (this_box_volume.geometry.mask_mode == 1) {
                if (global_geometry_list.elements[loop_index].Volume->geometry.is_masked_volume == 1 && global_geometry_list.elements[loop_index].Volume->geometry.mask_mode != 2)
                    // If more than one mask is added to one volume, the ANY mode overwrites the (default) ALL mode.
                    global_geometry_list.elements[loop_index].Volume->geometry.mask_mode = 1;
            }
            
            found_geometries = 1;
        }
    }
    if (found_geometries == 0) {
        printf("The mask_string in geometry: %s did not find any of the specified volumes in the mask_string %s \n",NAME_CURRENT_COMP,mask_string);
        exit(1);
    }
    this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
    this_box_volume.p_physics->is_vacuum = 0; // Makes this volume a vacuum
    this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
    this_box_volume.p_physics->my_a = 0; // Should not be used.
    sprintf(this_box_volume.p_physics->name,"Mask");
    this_box_volume.geometry.is_mask_volume = 1;
    
    
// Read the material input, or if it lacks, use automatic linking.
} else if (material_string && strlen(material_string) && strcmp(material_string, "NULL") && strcmp(material_string, "0")) {
    // A geometry string was given, use it to determine which material
    if (0 == strcmp(material_string,"vacuum") || 0 == strcmp(material_string,"Vacuum")) {
        // One could have a global physics struct for vacuum instead of creating one for each
        this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
        this_box_volume.p_physics->is_vacuum = 1; // Makes this volume a vacuum
        this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
        this_box_volume.p_physics->my_a = 0; // Should not be used.
        sprintf(this_box_volume.p_physics->name,"Vacuum");
    } else if (0 == strcmp(material_string,"exit") || 0 == strcmp(material_string,"Exit")) {
        // One could have a global physics struct for vacuum instead of creating one for each
        this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
        this_box_volume.p_physics->is_vacuum = 1; // Makes this volume a vacuum
        this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
        this_box_volume.p_physics->my_a = 0; // Should not be used.
        this_box_volume.geometry.is_exit_volume = 1;
        sprintf(this_box_volume.p_physics->name,"Exit");
    } else {
        #ifndef MATERIAL_DETECTOR
            printf("Need to define a material before refering to it in a geometry %s.\n",NAME_CURRENT_COMP);
            exit(1);
        #endif
        for (loop_index=0;loop_index<global_material_list.num_elements;loop_index++) {
            if (0 == strcmp(material_string,global_material_list.elements[loop_index].name)) {
                this_box_volume.p_physics = global_material_list.elements[loop_index].physics;
                break;
            }
            if (loop_index == global_material_list.num_elements-1) {
            printf("\n");
            printf("ERROR: The material string \"%s\" in Union geometry \"%s\" did not match a specified material. \n",material_string,NAME_CURRENT_COMP);
            printf("       The materials available at this point (need to be defined before the geometry): \n");
            for (loop_index=0;loop_index<global_material_list.num_elements;loop_index++)
              printf("         %s\n",global_material_list.elements[loop_index].name);
            printf("\n");
            printf("       It is also possible to use one of the defualt materials avaiable: \n");
            printf("           Vacuum (for a Volume without scattering or absorption)\n");
            printf("           Exit (for a Volume where the ray exits the component if it enters)\n");
            printf("           Mask (for a Volume that masks existing volumes specified in the mask_string\n");
            exit(1);
          }
        }
    }
} else {
    // Automatic linking, simply using the last defined material.
    #ifndef MATERIAL_DETECTOR
        printf("Need to define a material before the geometry to use automatic linking %s.\n",NAME_CURRENT_COMP);
        exit(1);
    #endif
    this_box_volume.p_physics = global_material_list.elements[global_material_list.num_elements-1].physics;
}

sprintf(this_box_volume.name,NAME_CURRENT_COMP);
sprintf(this_box_volume.geometry.shape,"box");
this_box_volume.geometry.priority_value = priority;
this_box_volume.geometry.geometry_p_interact = p_interact;
// Currently the coordinates will be in absolute space.
this_box_volume.geometry.center = POS_A_CURRENT_COMP;

this_box_storage.z_depth = zdepth;
this_box_storage.x_width1 = xwidth;
this_box_storage.y_height1 = yheight;

this_box_storage.is_rectangle = 0;
if (xwidth2 < 0 && yheight2 < 0) this_box_storage.is_rectangle = 1;
if (xwidth == xwidth2 && yheight == yheight2) this_box_storage.is_rectangle = 1;

if (xwidth2 < 0) {
    this_box_storage.x_width2 = xwidth;
    xwidth2 = xwidth;
} else this_box_storage.x_width2 = xwidth2;

if (yheight2 < 0) {
    this_box_storage.y_height2 = yheight;
    yheight2 = yheight;
} else this_box_storage.y_height2 = yheight2;


this_box_storage.normal_vectors[0] = coords_set(0,0,1);
this_box_storage.normal_vectors[1] = coords_set(0,0,1);

// for sides with y component = 0
x_component = 2*zdepth/sqrt((xwidth-xwidth2)*(xwidth-xwidth2)+4*zdepth*zdepth);
z_component = (xwidth-xwidth2)/sqrt(4*zdepth*zdepth+(xwidth-xwidth2)*(xwidth-xwidth2));

this_box_storage.normal_vectors[2] = coords_set(x_component,0,z_component);
this_box_storage.normal_vectors[3] = coords_set(-x_component,0,z_component);

// for sides with x component = 0
y_component = 2*zdepth/sqrt((yheight-yheight2)*(yheight-yheight2)+4*zdepth*zdepth);
z_component = (yheight-yheight2)/sqrt(4*zdepth*zdepth+(yheight-yheight2)*(yheight-yheight2));

this_box_storage.normal_vectors[4] = coords_set(0,y_component,z_component);
this_box_storage.normal_vectors[5] = coords_set(0,-y_component,z_component);

this_box_volume.geometry.visualization_on = visualize;

this_box_volume.geometry.geometry_parameters.p_box_storage = &this_box_storage;

// Assign pointers to functions for intersection with the shape, checking if a point is inside the shape
if (this_box_storage.is_rectangle == 1) {
this_box_volume.geometry.intersect_function = &sample_box_intersect_simple;
this_box_volume.geometry.within_function = &r_within_box_simple;
}
else {
this_box_volume.geometry.intersect_function = &sample_box_intersect_advanced;
this_box_volume.geometry.within_function = &r_within_box_advanced;
}

this_box_volume.geometry.shell_points = &box_shell_points;
this_box_volume.geometry.mcdisplay_function = &mcdisplay_box_function;
this_box_volume.geometry.initialize_from_main_function = &initialize_box_geometry_from_main_component;
this_box_volume.geometry.process_rot_allocated = 0;

this_box_volume.geometry.copy_geometry_parameters = &allocate_box_storage_copy;

rot_copy(this_box_volume.geometry.rotation_matrix,ROT_A_CURRENT_COMP); //check how ROT_R_CURRENT_COMP would work
rot_transpose(ROT_A_CURRENT_COMP,this_box_volume.geometry.transpose_rotation_matrix);

// Initialize loggers
this_box_volume.loggers.num_elements = 0;

// packing the information into the global_geometry_element, which is then included in the global_geometry_list.
sprintf(global_geometry_element.name,NAME_CURRENT_COMP);
global_geometry_element.activation_counter = number_of_activations;
global_geometry_element.component_index = INDEX_CURRENT_COMP;
global_geometry_element.Volume = &this_box_volume; // Would be nicer if this m was a pointer, now we have the (small) data two places
add_element_to_geometry_list(&global_geometry_list,global_geometry_element);
}
#line 215720 "MACS_sample_kidney_box.c"
#undef number_of_activations
#undef mask_setting
#undef mask_string
#undef p_interact
#undef focus_r
#undef focus_xh
#undef focus_xw
#undef focus_ah
#undef focus_aw
#undef target_z
#undef target_y
#undef target_x
#undef target_index
#undef visualize
#undef yheight2
#undef xwidth2
#undef zdepth
#undef yheight
#undef xwidth
#undef priority
#undef material_string
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

  /* Initializations for component inter_analyzer_colimator_5_blade_1. */
  SIG_MESSAGE("inter_analyzer_colimator_5_blade_1 (Init)");
#define mccompcurname  inter_analyzer_colimator_5_blade_1
#define mccompcurtype  Union_box
#define mccompcurindex 346
#define loop_index mccinter_analyzer_colimator_5_blade_1_loop_index
#define this_box_volume mccinter_analyzer_colimator_5_blade_1_this_box_volume
#define global_geometry_element mccinter_analyzer_colimator_5_blade_1_global_geometry_element
#define this_box_storage mccinter_analyzer_colimator_5_blade_1_this_box_storage
#define material_string mccinter_analyzer_colimator_5_blade_1_material_string
#define priority mccinter_analyzer_colimator_5_blade_1_priority
#define xwidth mccinter_analyzer_colimator_5_blade_1_xwidth
#define yheight mccinter_analyzer_colimator_5_blade_1_yheight
#define zdepth mccinter_analyzer_colimator_5_blade_1_zdepth
#define xwidth2 mccinter_analyzer_colimator_5_blade_1_xwidth2
#define yheight2 mccinter_analyzer_colimator_5_blade_1_yheight2
#define visualize mccinter_analyzer_colimator_5_blade_1_visualize
#define target_index mccinter_analyzer_colimator_5_blade_1_target_index
#define target_x mccinter_analyzer_colimator_5_blade_1_target_x
#define target_y mccinter_analyzer_colimator_5_blade_1_target_y
#define target_z mccinter_analyzer_colimator_5_blade_1_target_z
#define focus_aw mccinter_analyzer_colimator_5_blade_1_focus_aw
#define focus_ah mccinter_analyzer_colimator_5_blade_1_focus_ah
#define focus_xw mccinter_analyzer_colimator_5_blade_1_focus_xw
#define focus_xh mccinter_analyzer_colimator_5_blade_1_focus_xh
#define focus_r mccinter_analyzer_colimator_5_blade_1_focus_r
#define p_interact mccinter_analyzer_colimator_5_blade_1_p_interact
#define mask_string mccinter_analyzer_colimator_5_blade_1_mask_string
#define mask_setting mccinter_analyzer_colimator_5_blade_1_mask_setting
#define number_of_activations mccinter_analyzer_colimator_5_blade_1_number_of_activations
#line 224 "Union_box.comp"
{
// Initializes the focusing system for this volume including input sanitation.
focus_initialize(&this_box_volume.geometry, POS_A_COMP_INDEX(INDEX_CURRENT_COMP+target_index), POS_A_CURRENT_COMP, ROT_A_CURRENT_COMP, target_index, target_x, target_y, target_z, focus_aw, focus_ah, focus_xw, focus_xh, focus_r, NAME_CURRENT_COMP);

// Input sanitation for this geometry
if (xwidth <= 0) {
  printf("\nERROR in Union_box named %s, the xwidth is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (yheight <= 0) {
  printf("\nERROR in Union_box named %s, yheight is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (zdepth <= 0) {
  printf("\nERROR in Union_box named %s, zdepth is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (xwidth2 <= 0 && xwidth2 != -1) {
  printf("\nERROR in Union_box named %s, the xwidth2 is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (yheight2 <= 0 && yheight2 != -1) {
  printf("\nERROR in Union_box named %s, yheight2 is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}

// Use sanitation
if (global_material_list.num_elements == 0) {
  printf("\nERROR: Need to define a material using Union_make_material before using a Union geometry component. \n");
  printf("       %s was defined before first use of Union_make_material.\n",NAME_CURRENT_COMP);
  exit(1);
}

this_box_volume.geometry.is_masked_volume = 0;
this_box_volume.geometry.is_exit_volume = 0;
this_box_volume.geometry.is_mask_volume = 0;
// check if the volume is a mask, if it is the material string is irelevant.
if (mask_string && strlen(mask_string) && strcmp(mask_string, "NULL") && strcmp(mask_string, "0")) {
    // A mask volume is used to limit the extend of other volumes, called the masked volumes. These are specified in the mask_string.
    // In order for a ray to enter a masked volume, it needs to be both in the region covered by that volume AND the mask volume.
    // When more than
    this_box_volume.geometry.mask_mode = 1; // Default is mask mode is ALL
    if (mask_setting && strlen(mask_setting) && strcmp(mask_setting, "NULL") && strcmp(mask_setting, "0")) {
        if (strcmp(mask_setting,"ALL") == 0 || strcmp(mask_setting,"All") == 0) this_box_volume.geometry.mask_mode = 1;
        else if (strcmp(mask_setting,"ANY") == 0 || strcmp(mask_setting,"Any") == 0) this_box_volume.geometry.mask_mode = 2;
        else {
            printf("The mask_mode of component %s is set to %s, but must be either ALL or ANY.\n",NAME_CURRENT_COMP,mask_setting);
            exit(1);
        }
    }
    
    for (loop_index=0;loop_index<global_geometry_list.num_elements;loop_index++) {
        // Add mask list
        if (1 == manual_linking_function(global_geometry_list.elements[loop_index].name,mask_string)) {
            add_element_to_int_list(&this_box_volume.geometry.mask_list,global_geometry_list.elements[loop_index].component_index);
            add_element_to_int_list(&global_geometry_list.elements[loop_index].Volume->geometry.masked_by_list,INDEX_CURRENT_COMP);
            global_geometry_list.elements[loop_index].Volume->geometry.is_masked_volume = 1;
            if (this_box_volume.geometry.mask_mode == 2)
                global_geometry_list.elements[loop_index].Volume->geometry.mask_mode = 2;
            if (this_box_volume.geometry.mask_mode == 1) {
                if (global_geometry_list.elements[loop_index].Volume->geometry.is_masked_volume == 1 && global_geometry_list.elements[loop_index].Volume->geometry.mask_mode != 2)
                    // If more than one mask is added to one volume, the ANY mode overwrites the (default) ALL mode.
                    global_geometry_list.elements[loop_index].Volume->geometry.mask_mode = 1;
            }
            
            found_geometries = 1;
        }
    }
    if (found_geometries == 0) {
        printf("The mask_string in geometry: %s did not find any of the specified volumes in the mask_string %s \n",NAME_CURRENT_COMP,mask_string);
        exit(1);
    }
    this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
    this_box_volume.p_physics->is_vacuum = 0; // Makes this volume a vacuum
    this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
    this_box_volume.p_physics->my_a = 0; // Should not be used.
    sprintf(this_box_volume.p_physics->name,"Mask");
    this_box_volume.geometry.is_mask_volume = 1;
    
    
// Read the material input, or if it lacks, use automatic linking.
} else if (material_string && strlen(material_string) && strcmp(material_string, "NULL") && strcmp(material_string, "0")) {
    // A geometry string was given, use it to determine which material
    if (0 == strcmp(material_string,"vacuum") || 0 == strcmp(material_string,"Vacuum")) {
        // One could have a global physics struct for vacuum instead of creating one for each
        this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
        this_box_volume.p_physics->is_vacuum = 1; // Makes this volume a vacuum
        this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
        this_box_volume.p_physics->my_a = 0; // Should not be used.
        sprintf(this_box_volume.p_physics->name,"Vacuum");
    } else if (0 == strcmp(material_string,"exit") || 0 == strcmp(material_string,"Exit")) {
        // One could have a global physics struct for vacuum instead of creating one for each
        this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
        this_box_volume.p_physics->is_vacuum = 1; // Makes this volume a vacuum
        this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
        this_box_volume.p_physics->my_a = 0; // Should not be used.
        this_box_volume.geometry.is_exit_volume = 1;
        sprintf(this_box_volume.p_physics->name,"Exit");
    } else {
        #ifndef MATERIAL_DETECTOR
            printf("Need to define a material before refering to it in a geometry %s.\n",NAME_CURRENT_COMP);
            exit(1);
        #endif
        for (loop_index=0;loop_index<global_material_list.num_elements;loop_index++) {
            if (0 == strcmp(material_string,global_material_list.elements[loop_index].name)) {
                this_box_volume.p_physics = global_material_list.elements[loop_index].physics;
                break;
            }
            if (loop_index == global_material_list.num_elements-1) {
            printf("\n");
            printf("ERROR: The material string \"%s\" in Union geometry \"%s\" did not match a specified material. \n",material_string,NAME_CURRENT_COMP);
            printf("       The materials available at this point (need to be defined before the geometry): \n");
            for (loop_index=0;loop_index<global_material_list.num_elements;loop_index++)
              printf("         %s\n",global_material_list.elements[loop_index].name);
            printf("\n");
            printf("       It is also possible to use one of the defualt materials avaiable: \n");
            printf("           Vacuum (for a Volume without scattering or absorption)\n");
            printf("           Exit (for a Volume where the ray exits the component if it enters)\n");
            printf("           Mask (for a Volume that masks existing volumes specified in the mask_string\n");
            exit(1);
          }
        }
    }
} else {
    // Automatic linking, simply using the last defined material.
    #ifndef MATERIAL_DETECTOR
        printf("Need to define a material before the geometry to use automatic linking %s.\n",NAME_CURRENT_COMP);
        exit(1);
    #endif
    this_box_volume.p_physics = global_material_list.elements[global_material_list.num_elements-1].physics;
}

sprintf(this_box_volume.name,NAME_CURRENT_COMP);
sprintf(this_box_volume.geometry.shape,"box");
this_box_volume.geometry.priority_value = priority;
this_box_volume.geometry.geometry_p_interact = p_interact;
// Currently the coordinates will be in absolute space.
this_box_volume.geometry.center = POS_A_CURRENT_COMP;

this_box_storage.z_depth = zdepth;
this_box_storage.x_width1 = xwidth;
this_box_storage.y_height1 = yheight;

this_box_storage.is_rectangle = 0;
if (xwidth2 < 0 && yheight2 < 0) this_box_storage.is_rectangle = 1;
if (xwidth == xwidth2 && yheight == yheight2) this_box_storage.is_rectangle = 1;

if (xwidth2 < 0) {
    this_box_storage.x_width2 = xwidth;
    xwidth2 = xwidth;
} else this_box_storage.x_width2 = xwidth2;

if (yheight2 < 0) {
    this_box_storage.y_height2 = yheight;
    yheight2 = yheight;
} else this_box_storage.y_height2 = yheight2;


this_box_storage.normal_vectors[0] = coords_set(0,0,1);
this_box_storage.normal_vectors[1] = coords_set(0,0,1);

// for sides with y component = 0
x_component = 2*zdepth/sqrt((xwidth-xwidth2)*(xwidth-xwidth2)+4*zdepth*zdepth);
z_component = (xwidth-xwidth2)/sqrt(4*zdepth*zdepth+(xwidth-xwidth2)*(xwidth-xwidth2));

this_box_storage.normal_vectors[2] = coords_set(x_component,0,z_component);
this_box_storage.normal_vectors[3] = coords_set(-x_component,0,z_component);

// for sides with x component = 0
y_component = 2*zdepth/sqrt((yheight-yheight2)*(yheight-yheight2)+4*zdepth*zdepth);
z_component = (yheight-yheight2)/sqrt(4*zdepth*zdepth+(yheight-yheight2)*(yheight-yheight2));

this_box_storage.normal_vectors[4] = coords_set(0,y_component,z_component);
this_box_storage.normal_vectors[5] = coords_set(0,-y_component,z_component);

this_box_volume.geometry.visualization_on = visualize;

this_box_volume.geometry.geometry_parameters.p_box_storage = &this_box_storage;

// Assign pointers to functions for intersection with the shape, checking if a point is inside the shape
if (this_box_storage.is_rectangle == 1) {
this_box_volume.geometry.intersect_function = &sample_box_intersect_simple;
this_box_volume.geometry.within_function = &r_within_box_simple;
}
else {
this_box_volume.geometry.intersect_function = &sample_box_intersect_advanced;
this_box_volume.geometry.within_function = &r_within_box_advanced;
}

this_box_volume.geometry.shell_points = &box_shell_points;
this_box_volume.geometry.mcdisplay_function = &mcdisplay_box_function;
this_box_volume.geometry.initialize_from_main_function = &initialize_box_geometry_from_main_component;
this_box_volume.geometry.process_rot_allocated = 0;

this_box_volume.geometry.copy_geometry_parameters = &allocate_box_storage_copy;

rot_copy(this_box_volume.geometry.rotation_matrix,ROT_A_CURRENT_COMP); //check how ROT_R_CURRENT_COMP would work
rot_transpose(ROT_A_CURRENT_COMP,this_box_volume.geometry.transpose_rotation_matrix);

// Initialize loggers
this_box_volume.loggers.num_elements = 0;

// packing the information into the global_geometry_element, which is then included in the global_geometry_list.
sprintf(global_geometry_element.name,NAME_CURRENT_COMP);
global_geometry_element.activation_counter = number_of_activations;
global_geometry_element.component_index = INDEX_CURRENT_COMP;
global_geometry_element.Volume = &this_box_volume; // Would be nicer if this m was a pointer, now we have the (small) data two places
add_element_to_geometry_list(&global_geometry_list,global_geometry_element);
}
#line 215990 "MACS_sample_kidney_box.c"
#undef number_of_activations
#undef mask_setting
#undef mask_string
#undef p_interact
#undef focus_r
#undef focus_xh
#undef focus_xw
#undef focus_ah
#undef focus_aw
#undef target_z
#undef target_y
#undef target_x
#undef target_index
#undef visualize
#undef yheight2
#undef xwidth2
#undef zdepth
#undef yheight
#undef xwidth
#undef priority
#undef material_string
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

  /* Initializations for component inter_analyzer_colimator_5_blade_2. */
  SIG_MESSAGE("inter_analyzer_colimator_5_blade_2 (Init)");
#define mccompcurname  inter_analyzer_colimator_5_blade_2
#define mccompcurtype  Union_box
#define mccompcurindex 347
#define loop_index mccinter_analyzer_colimator_5_blade_2_loop_index
#define this_box_volume mccinter_analyzer_colimator_5_blade_2_this_box_volume
#define global_geometry_element mccinter_analyzer_colimator_5_blade_2_global_geometry_element
#define this_box_storage mccinter_analyzer_colimator_5_blade_2_this_box_storage
#define material_string mccinter_analyzer_colimator_5_blade_2_material_string
#define priority mccinter_analyzer_colimator_5_blade_2_priority
#define xwidth mccinter_analyzer_colimator_5_blade_2_xwidth
#define yheight mccinter_analyzer_colimator_5_blade_2_yheight
#define zdepth mccinter_analyzer_colimator_5_blade_2_zdepth
#define xwidth2 mccinter_analyzer_colimator_5_blade_2_xwidth2
#define yheight2 mccinter_analyzer_colimator_5_blade_2_yheight2
#define visualize mccinter_analyzer_colimator_5_blade_2_visualize
#define target_index mccinter_analyzer_colimator_5_blade_2_target_index
#define target_x mccinter_analyzer_colimator_5_blade_2_target_x
#define target_y mccinter_analyzer_colimator_5_blade_2_target_y
#define target_z mccinter_analyzer_colimator_5_blade_2_target_z
#define focus_aw mccinter_analyzer_colimator_5_blade_2_focus_aw
#define focus_ah mccinter_analyzer_colimator_5_blade_2_focus_ah
#define focus_xw mccinter_analyzer_colimator_5_blade_2_focus_xw
#define focus_xh mccinter_analyzer_colimator_5_blade_2_focus_xh
#define focus_r mccinter_analyzer_colimator_5_blade_2_focus_r
#define p_interact mccinter_analyzer_colimator_5_blade_2_p_interact
#define mask_string mccinter_analyzer_colimator_5_blade_2_mask_string
#define mask_setting mccinter_analyzer_colimator_5_blade_2_mask_setting
#define number_of_activations mccinter_analyzer_colimator_5_blade_2_number_of_activations
#line 224 "Union_box.comp"
{
// Initializes the focusing system for this volume including input sanitation.
focus_initialize(&this_box_volume.geometry, POS_A_COMP_INDEX(INDEX_CURRENT_COMP+target_index), POS_A_CURRENT_COMP, ROT_A_CURRENT_COMP, target_index, target_x, target_y, target_z, focus_aw, focus_ah, focus_xw, focus_xh, focus_r, NAME_CURRENT_COMP);

// Input sanitation for this geometry
if (xwidth <= 0) {
  printf("\nERROR in Union_box named %s, the xwidth is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (yheight <= 0) {
  printf("\nERROR in Union_box named %s, yheight is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (zdepth <= 0) {
  printf("\nERROR in Union_box named %s, zdepth is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (xwidth2 <= 0 && xwidth2 != -1) {
  printf("\nERROR in Union_box named %s, the xwidth2 is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (yheight2 <= 0 && yheight2 != -1) {
  printf("\nERROR in Union_box named %s, yheight2 is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}

// Use sanitation
if (global_material_list.num_elements == 0) {
  printf("\nERROR: Need to define a material using Union_make_material before using a Union geometry component. \n");
  printf("       %s was defined before first use of Union_make_material.\n",NAME_CURRENT_COMP);
  exit(1);
}

this_box_volume.geometry.is_masked_volume = 0;
this_box_volume.geometry.is_exit_volume = 0;
this_box_volume.geometry.is_mask_volume = 0;
// check if the volume is a mask, if it is the material string is irelevant.
if (mask_string && strlen(mask_string) && strcmp(mask_string, "NULL") && strcmp(mask_string, "0")) {
    // A mask volume is used to limit the extend of other volumes, called the masked volumes. These are specified in the mask_string.
    // In order for a ray to enter a masked volume, it needs to be both in the region covered by that volume AND the mask volume.
    // When more than
    this_box_volume.geometry.mask_mode = 1; // Default is mask mode is ALL
    if (mask_setting && strlen(mask_setting) && strcmp(mask_setting, "NULL") && strcmp(mask_setting, "0")) {
        if (strcmp(mask_setting,"ALL") == 0 || strcmp(mask_setting,"All") == 0) this_box_volume.geometry.mask_mode = 1;
        else if (strcmp(mask_setting,"ANY") == 0 || strcmp(mask_setting,"Any") == 0) this_box_volume.geometry.mask_mode = 2;
        else {
            printf("The mask_mode of component %s is set to %s, but must be either ALL or ANY.\n",NAME_CURRENT_COMP,mask_setting);
            exit(1);
        }
    }
    
    for (loop_index=0;loop_index<global_geometry_list.num_elements;loop_index++) {
        // Add mask list
        if (1 == manual_linking_function(global_geometry_list.elements[loop_index].name,mask_string)) {
            add_element_to_int_list(&this_box_volume.geometry.mask_list,global_geometry_list.elements[loop_index].component_index);
            add_element_to_int_list(&global_geometry_list.elements[loop_index].Volume->geometry.masked_by_list,INDEX_CURRENT_COMP);
            global_geometry_list.elements[loop_index].Volume->geometry.is_masked_volume = 1;
            if (this_box_volume.geometry.mask_mode == 2)
                global_geometry_list.elements[loop_index].Volume->geometry.mask_mode = 2;
            if (this_box_volume.geometry.mask_mode == 1) {
                if (global_geometry_list.elements[loop_index].Volume->geometry.is_masked_volume == 1 && global_geometry_list.elements[loop_index].Volume->geometry.mask_mode != 2)
                    // If more than one mask is added to one volume, the ANY mode overwrites the (default) ALL mode.
                    global_geometry_list.elements[loop_index].Volume->geometry.mask_mode = 1;
            }
            
            found_geometries = 1;
        }
    }
    if (found_geometries == 0) {
        printf("The mask_string in geometry: %s did not find any of the specified volumes in the mask_string %s \n",NAME_CURRENT_COMP,mask_string);
        exit(1);
    }
    this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
    this_box_volume.p_physics->is_vacuum = 0; // Makes this volume a vacuum
    this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
    this_box_volume.p_physics->my_a = 0; // Should not be used.
    sprintf(this_box_volume.p_physics->name,"Mask");
    this_box_volume.geometry.is_mask_volume = 1;
    
    
// Read the material input, or if it lacks, use automatic linking.
} else if (material_string && strlen(material_string) && strcmp(material_string, "NULL") && strcmp(material_string, "0")) {
    // A geometry string was given, use it to determine which material
    if (0 == strcmp(material_string,"vacuum") || 0 == strcmp(material_string,"Vacuum")) {
        // One could have a global physics struct for vacuum instead of creating one for each
        this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
        this_box_volume.p_physics->is_vacuum = 1; // Makes this volume a vacuum
        this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
        this_box_volume.p_physics->my_a = 0; // Should not be used.
        sprintf(this_box_volume.p_physics->name,"Vacuum");
    } else if (0 == strcmp(material_string,"exit") || 0 == strcmp(material_string,"Exit")) {
        // One could have a global physics struct for vacuum instead of creating one for each
        this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
        this_box_volume.p_physics->is_vacuum = 1; // Makes this volume a vacuum
        this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
        this_box_volume.p_physics->my_a = 0; // Should not be used.
        this_box_volume.geometry.is_exit_volume = 1;
        sprintf(this_box_volume.p_physics->name,"Exit");
    } else {
        #ifndef MATERIAL_DETECTOR
            printf("Need to define a material before refering to it in a geometry %s.\n",NAME_CURRENT_COMP);
            exit(1);
        #endif
        for (loop_index=0;loop_index<global_material_list.num_elements;loop_index++) {
            if (0 == strcmp(material_string,global_material_list.elements[loop_index].name)) {
                this_box_volume.p_physics = global_material_list.elements[loop_index].physics;
                break;
            }
            if (loop_index == global_material_list.num_elements-1) {
            printf("\n");
            printf("ERROR: The material string \"%s\" in Union geometry \"%s\" did not match a specified material. \n",material_string,NAME_CURRENT_COMP);
            printf("       The materials available at this point (need to be defined before the geometry): \n");
            for (loop_index=0;loop_index<global_material_list.num_elements;loop_index++)
              printf("         %s\n",global_material_list.elements[loop_index].name);
            printf("\n");
            printf("       It is also possible to use one of the defualt materials avaiable: \n");
            printf("           Vacuum (for a Volume without scattering or absorption)\n");
            printf("           Exit (for a Volume where the ray exits the component if it enters)\n");
            printf("           Mask (for a Volume that masks existing volumes specified in the mask_string\n");
            exit(1);
          }
        }
    }
} else {
    // Automatic linking, simply using the last defined material.
    #ifndef MATERIAL_DETECTOR
        printf("Need to define a material before the geometry to use automatic linking %s.\n",NAME_CURRENT_COMP);
        exit(1);
    #endif
    this_box_volume.p_physics = global_material_list.elements[global_material_list.num_elements-1].physics;
}

sprintf(this_box_volume.name,NAME_CURRENT_COMP);
sprintf(this_box_volume.geometry.shape,"box");
this_box_volume.geometry.priority_value = priority;
this_box_volume.geometry.geometry_p_interact = p_interact;
// Currently the coordinates will be in absolute space.
this_box_volume.geometry.center = POS_A_CURRENT_COMP;

this_box_storage.z_depth = zdepth;
this_box_storage.x_width1 = xwidth;
this_box_storage.y_height1 = yheight;

this_box_storage.is_rectangle = 0;
if (xwidth2 < 0 && yheight2 < 0) this_box_storage.is_rectangle = 1;
if (xwidth == xwidth2 && yheight == yheight2) this_box_storage.is_rectangle = 1;

if (xwidth2 < 0) {
    this_box_storage.x_width2 = xwidth;
    xwidth2 = xwidth;
} else this_box_storage.x_width2 = xwidth2;

if (yheight2 < 0) {
    this_box_storage.y_height2 = yheight;
    yheight2 = yheight;
} else this_box_storage.y_height2 = yheight2;


this_box_storage.normal_vectors[0] = coords_set(0,0,1);
this_box_storage.normal_vectors[1] = coords_set(0,0,1);

// for sides with y component = 0
x_component = 2*zdepth/sqrt((xwidth-xwidth2)*(xwidth-xwidth2)+4*zdepth*zdepth);
z_component = (xwidth-xwidth2)/sqrt(4*zdepth*zdepth+(xwidth-xwidth2)*(xwidth-xwidth2));

this_box_storage.normal_vectors[2] = coords_set(x_component,0,z_component);
this_box_storage.normal_vectors[3] = coords_set(-x_component,0,z_component);

// for sides with x component = 0
y_component = 2*zdepth/sqrt((yheight-yheight2)*(yheight-yheight2)+4*zdepth*zdepth);
z_component = (yheight-yheight2)/sqrt(4*zdepth*zdepth+(yheight-yheight2)*(yheight-yheight2));

this_box_storage.normal_vectors[4] = coords_set(0,y_component,z_component);
this_box_storage.normal_vectors[5] = coords_set(0,-y_component,z_component);

this_box_volume.geometry.visualization_on = visualize;

this_box_volume.geometry.geometry_parameters.p_box_storage = &this_box_storage;

// Assign pointers to functions for intersection with the shape, checking if a point is inside the shape
if (this_box_storage.is_rectangle == 1) {
this_box_volume.geometry.intersect_function = &sample_box_intersect_simple;
this_box_volume.geometry.within_function = &r_within_box_simple;
}
else {
this_box_volume.geometry.intersect_function = &sample_box_intersect_advanced;
this_box_volume.geometry.within_function = &r_within_box_advanced;
}

this_box_volume.geometry.shell_points = &box_shell_points;
this_box_volume.geometry.mcdisplay_function = &mcdisplay_box_function;
this_box_volume.geometry.initialize_from_main_function = &initialize_box_geometry_from_main_component;
this_box_volume.geometry.process_rot_allocated = 0;

this_box_volume.geometry.copy_geometry_parameters = &allocate_box_storage_copy;

rot_copy(this_box_volume.geometry.rotation_matrix,ROT_A_CURRENT_COMP); //check how ROT_R_CURRENT_COMP would work
rot_transpose(ROT_A_CURRENT_COMP,this_box_volume.geometry.transpose_rotation_matrix);

// Initialize loggers
this_box_volume.loggers.num_elements = 0;

// packing the information into the global_geometry_element, which is then included in the global_geometry_list.
sprintf(global_geometry_element.name,NAME_CURRENT_COMP);
global_geometry_element.activation_counter = number_of_activations;
global_geometry_element.component_index = INDEX_CURRENT_COMP;
global_geometry_element.Volume = &this_box_volume; // Would be nicer if this m was a pointer, now we have the (small) data two places
add_element_to_geometry_list(&global_geometry_list,global_geometry_element);
}
#line 216260 "MACS_sample_kidney_box.c"
#undef number_of_activations
#undef mask_setting
#undef mask_string
#undef p_interact
#undef focus_r
#undef focus_xh
#undef focus_xw
#undef focus_ah
#undef focus_aw
#undef target_z
#undef target_y
#undef target_x
#undef target_index
#undef visualize
#undef yheight2
#undef xwidth2
#undef zdepth
#undef yheight
#undef xwidth
#undef priority
#undef material_string
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

  /* Initializations for component inter_analyzer_colimator_5_blade_3. */
  SIG_MESSAGE("inter_analyzer_colimator_5_blade_3 (Init)");
#define mccompcurname  inter_analyzer_colimator_5_blade_3
#define mccompcurtype  Union_box
#define mccompcurindex 348
#define loop_index mccinter_analyzer_colimator_5_blade_3_loop_index
#define this_box_volume mccinter_analyzer_colimator_5_blade_3_this_box_volume
#define global_geometry_element mccinter_analyzer_colimator_5_blade_3_global_geometry_element
#define this_box_storage mccinter_analyzer_colimator_5_blade_3_this_box_storage
#define material_string mccinter_analyzer_colimator_5_blade_3_material_string
#define priority mccinter_analyzer_colimator_5_blade_3_priority
#define xwidth mccinter_analyzer_colimator_5_blade_3_xwidth
#define yheight mccinter_analyzer_colimator_5_blade_3_yheight
#define zdepth mccinter_analyzer_colimator_5_blade_3_zdepth
#define xwidth2 mccinter_analyzer_colimator_5_blade_3_xwidth2
#define yheight2 mccinter_analyzer_colimator_5_blade_3_yheight2
#define visualize mccinter_analyzer_colimator_5_blade_3_visualize
#define target_index mccinter_analyzer_colimator_5_blade_3_target_index
#define target_x mccinter_analyzer_colimator_5_blade_3_target_x
#define target_y mccinter_analyzer_colimator_5_blade_3_target_y
#define target_z mccinter_analyzer_colimator_5_blade_3_target_z
#define focus_aw mccinter_analyzer_colimator_5_blade_3_focus_aw
#define focus_ah mccinter_analyzer_colimator_5_blade_3_focus_ah
#define focus_xw mccinter_analyzer_colimator_5_blade_3_focus_xw
#define focus_xh mccinter_analyzer_colimator_5_blade_3_focus_xh
#define focus_r mccinter_analyzer_colimator_5_blade_3_focus_r
#define p_interact mccinter_analyzer_colimator_5_blade_3_p_interact
#define mask_string mccinter_analyzer_colimator_5_blade_3_mask_string
#define mask_setting mccinter_analyzer_colimator_5_blade_3_mask_setting
#define number_of_activations mccinter_analyzer_colimator_5_blade_3_number_of_activations
#line 224 "Union_box.comp"
{
// Initializes the focusing system for this volume including input sanitation.
focus_initialize(&this_box_volume.geometry, POS_A_COMP_INDEX(INDEX_CURRENT_COMP+target_index), POS_A_CURRENT_COMP, ROT_A_CURRENT_COMP, target_index, target_x, target_y, target_z, focus_aw, focus_ah, focus_xw, focus_xh, focus_r, NAME_CURRENT_COMP);

// Input sanitation for this geometry
if (xwidth <= 0) {
  printf("\nERROR in Union_box named %s, the xwidth is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (yheight <= 0) {
  printf("\nERROR in Union_box named %s, yheight is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (zdepth <= 0) {
  printf("\nERROR in Union_box named %s, zdepth is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (xwidth2 <= 0 && xwidth2 != -1) {
  printf("\nERROR in Union_box named %s, the xwidth2 is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (yheight2 <= 0 && yheight2 != -1) {
  printf("\nERROR in Union_box named %s, yheight2 is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}

// Use sanitation
if (global_material_list.num_elements == 0) {
  printf("\nERROR: Need to define a material using Union_make_material before using a Union geometry component. \n");
  printf("       %s was defined before first use of Union_make_material.\n",NAME_CURRENT_COMP);
  exit(1);
}

this_box_volume.geometry.is_masked_volume = 0;
this_box_volume.geometry.is_exit_volume = 0;
this_box_volume.geometry.is_mask_volume = 0;
// check if the volume is a mask, if it is the material string is irelevant.
if (mask_string && strlen(mask_string) && strcmp(mask_string, "NULL") && strcmp(mask_string, "0")) {
    // A mask volume is used to limit the extend of other volumes, called the masked volumes. These are specified in the mask_string.
    // In order for a ray to enter a masked volume, it needs to be both in the region covered by that volume AND the mask volume.
    // When more than
    this_box_volume.geometry.mask_mode = 1; // Default is mask mode is ALL
    if (mask_setting && strlen(mask_setting) && strcmp(mask_setting, "NULL") && strcmp(mask_setting, "0")) {
        if (strcmp(mask_setting,"ALL") == 0 || strcmp(mask_setting,"All") == 0) this_box_volume.geometry.mask_mode = 1;
        else if (strcmp(mask_setting,"ANY") == 0 || strcmp(mask_setting,"Any") == 0) this_box_volume.geometry.mask_mode = 2;
        else {
            printf("The mask_mode of component %s is set to %s, but must be either ALL or ANY.\n",NAME_CURRENT_COMP,mask_setting);
            exit(1);
        }
    }
    
    for (loop_index=0;loop_index<global_geometry_list.num_elements;loop_index++) {
        // Add mask list
        if (1 == manual_linking_function(global_geometry_list.elements[loop_index].name,mask_string)) {
            add_element_to_int_list(&this_box_volume.geometry.mask_list,global_geometry_list.elements[loop_index].component_index);
            add_element_to_int_list(&global_geometry_list.elements[loop_index].Volume->geometry.masked_by_list,INDEX_CURRENT_COMP);
            global_geometry_list.elements[loop_index].Volume->geometry.is_masked_volume = 1;
            if (this_box_volume.geometry.mask_mode == 2)
                global_geometry_list.elements[loop_index].Volume->geometry.mask_mode = 2;
            if (this_box_volume.geometry.mask_mode == 1) {
                if (global_geometry_list.elements[loop_index].Volume->geometry.is_masked_volume == 1 && global_geometry_list.elements[loop_index].Volume->geometry.mask_mode != 2)
                    // If more than one mask is added to one volume, the ANY mode overwrites the (default) ALL mode.
                    global_geometry_list.elements[loop_index].Volume->geometry.mask_mode = 1;
            }
            
            found_geometries = 1;
        }
    }
    if (found_geometries == 0) {
        printf("The mask_string in geometry: %s did not find any of the specified volumes in the mask_string %s \n",NAME_CURRENT_COMP,mask_string);
        exit(1);
    }
    this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
    this_box_volume.p_physics->is_vacuum = 0; // Makes this volume a vacuum
    this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
    this_box_volume.p_physics->my_a = 0; // Should not be used.
    sprintf(this_box_volume.p_physics->name,"Mask");
    this_box_volume.geometry.is_mask_volume = 1;
    
    
// Read the material input, or if it lacks, use automatic linking.
} else if (material_string && strlen(material_string) && strcmp(material_string, "NULL") && strcmp(material_string, "0")) {
    // A geometry string was given, use it to determine which material
    if (0 == strcmp(material_string,"vacuum") || 0 == strcmp(material_string,"Vacuum")) {
        // One could have a global physics struct for vacuum instead of creating one for each
        this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
        this_box_volume.p_physics->is_vacuum = 1; // Makes this volume a vacuum
        this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
        this_box_volume.p_physics->my_a = 0; // Should not be used.
        sprintf(this_box_volume.p_physics->name,"Vacuum");
    } else if (0 == strcmp(material_string,"exit") || 0 == strcmp(material_string,"Exit")) {
        // One could have a global physics struct for vacuum instead of creating one for each
        this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
        this_box_volume.p_physics->is_vacuum = 1; // Makes this volume a vacuum
        this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
        this_box_volume.p_physics->my_a = 0; // Should not be used.
        this_box_volume.geometry.is_exit_volume = 1;
        sprintf(this_box_volume.p_physics->name,"Exit");
    } else {
        #ifndef MATERIAL_DETECTOR
            printf("Need to define a material before refering to it in a geometry %s.\n",NAME_CURRENT_COMP);
            exit(1);
        #endif
        for (loop_index=0;loop_index<global_material_list.num_elements;loop_index++) {
            if (0 == strcmp(material_string,global_material_list.elements[loop_index].name)) {
                this_box_volume.p_physics = global_material_list.elements[loop_index].physics;
                break;
            }
            if (loop_index == global_material_list.num_elements-1) {
            printf("\n");
            printf("ERROR: The material string \"%s\" in Union geometry \"%s\" did not match a specified material. \n",material_string,NAME_CURRENT_COMP);
            printf("       The materials available at this point (need to be defined before the geometry): \n");
            for (loop_index=0;loop_index<global_material_list.num_elements;loop_index++)
              printf("         %s\n",global_material_list.elements[loop_index].name);
            printf("\n");
            printf("       It is also possible to use one of the defualt materials avaiable: \n");
            printf("           Vacuum (for a Volume without scattering or absorption)\n");
            printf("           Exit (for a Volume where the ray exits the component if it enters)\n");
            printf("           Mask (for a Volume that masks existing volumes specified in the mask_string\n");
            exit(1);
          }
        }
    }
} else {
    // Automatic linking, simply using the last defined material.
    #ifndef MATERIAL_DETECTOR
        printf("Need to define a material before the geometry to use automatic linking %s.\n",NAME_CURRENT_COMP);
        exit(1);
    #endif
    this_box_volume.p_physics = global_material_list.elements[global_material_list.num_elements-1].physics;
}

sprintf(this_box_volume.name,NAME_CURRENT_COMP);
sprintf(this_box_volume.geometry.shape,"box");
this_box_volume.geometry.priority_value = priority;
this_box_volume.geometry.geometry_p_interact = p_interact;
// Currently the coordinates will be in absolute space.
this_box_volume.geometry.center = POS_A_CURRENT_COMP;

this_box_storage.z_depth = zdepth;
this_box_storage.x_width1 = xwidth;
this_box_storage.y_height1 = yheight;

this_box_storage.is_rectangle = 0;
if (xwidth2 < 0 && yheight2 < 0) this_box_storage.is_rectangle = 1;
if (xwidth == xwidth2 && yheight == yheight2) this_box_storage.is_rectangle = 1;

if (xwidth2 < 0) {
    this_box_storage.x_width2 = xwidth;
    xwidth2 = xwidth;
} else this_box_storage.x_width2 = xwidth2;

if (yheight2 < 0) {
    this_box_storage.y_height2 = yheight;
    yheight2 = yheight;
} else this_box_storage.y_height2 = yheight2;


this_box_storage.normal_vectors[0] = coords_set(0,0,1);
this_box_storage.normal_vectors[1] = coords_set(0,0,1);

// for sides with y component = 0
x_component = 2*zdepth/sqrt((xwidth-xwidth2)*(xwidth-xwidth2)+4*zdepth*zdepth);
z_component = (xwidth-xwidth2)/sqrt(4*zdepth*zdepth+(xwidth-xwidth2)*(xwidth-xwidth2));

this_box_storage.normal_vectors[2] = coords_set(x_component,0,z_component);
this_box_storage.normal_vectors[3] = coords_set(-x_component,0,z_component);

// for sides with x component = 0
y_component = 2*zdepth/sqrt((yheight-yheight2)*(yheight-yheight2)+4*zdepth*zdepth);
z_component = (yheight-yheight2)/sqrt(4*zdepth*zdepth+(yheight-yheight2)*(yheight-yheight2));

this_box_storage.normal_vectors[4] = coords_set(0,y_component,z_component);
this_box_storage.normal_vectors[5] = coords_set(0,-y_component,z_component);

this_box_volume.geometry.visualization_on = visualize;

this_box_volume.geometry.geometry_parameters.p_box_storage = &this_box_storage;

// Assign pointers to functions for intersection with the shape, checking if a point is inside the shape
if (this_box_storage.is_rectangle == 1) {
this_box_volume.geometry.intersect_function = &sample_box_intersect_simple;
this_box_volume.geometry.within_function = &r_within_box_simple;
}
else {
this_box_volume.geometry.intersect_function = &sample_box_intersect_advanced;
this_box_volume.geometry.within_function = &r_within_box_advanced;
}

this_box_volume.geometry.shell_points = &box_shell_points;
this_box_volume.geometry.mcdisplay_function = &mcdisplay_box_function;
this_box_volume.geometry.initialize_from_main_function = &initialize_box_geometry_from_main_component;
this_box_volume.geometry.process_rot_allocated = 0;

this_box_volume.geometry.copy_geometry_parameters = &allocate_box_storage_copy;

rot_copy(this_box_volume.geometry.rotation_matrix,ROT_A_CURRENT_COMP); //check how ROT_R_CURRENT_COMP would work
rot_transpose(ROT_A_CURRENT_COMP,this_box_volume.geometry.transpose_rotation_matrix);

// Initialize loggers
this_box_volume.loggers.num_elements = 0;

// packing the information into the global_geometry_element, which is then included in the global_geometry_list.
sprintf(global_geometry_element.name,NAME_CURRENT_COMP);
global_geometry_element.activation_counter = number_of_activations;
global_geometry_element.component_index = INDEX_CURRENT_COMP;
global_geometry_element.Volume = &this_box_volume; // Would be nicer if this m was a pointer, now we have the (small) data two places
add_element_to_geometry_list(&global_geometry_list,global_geometry_element);
}
#line 216530 "MACS_sample_kidney_box.c"
#undef number_of_activations
#undef mask_setting
#undef mask_string
#undef p_interact
#undef focus_r
#undef focus_xh
#undef focus_xw
#undef focus_ah
#undef focus_aw
#undef target_z
#undef target_y
#undef target_x
#undef target_index
#undef visualize
#undef yheight2
#undef xwidth2
#undef zdepth
#undef yheight
#undef xwidth
#undef priority
#undef material_string
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

  /* Initializations for component inter_analyzer_colimator_5_blade_4. */
  SIG_MESSAGE("inter_analyzer_colimator_5_blade_4 (Init)");
#define mccompcurname  inter_analyzer_colimator_5_blade_4
#define mccompcurtype  Union_box
#define mccompcurindex 349
#define loop_index mccinter_analyzer_colimator_5_blade_4_loop_index
#define this_box_volume mccinter_analyzer_colimator_5_blade_4_this_box_volume
#define global_geometry_element mccinter_analyzer_colimator_5_blade_4_global_geometry_element
#define this_box_storage mccinter_analyzer_colimator_5_blade_4_this_box_storage
#define material_string mccinter_analyzer_colimator_5_blade_4_material_string
#define priority mccinter_analyzer_colimator_5_blade_4_priority
#define xwidth mccinter_analyzer_colimator_5_blade_4_xwidth
#define yheight mccinter_analyzer_colimator_5_blade_4_yheight
#define zdepth mccinter_analyzer_colimator_5_blade_4_zdepth
#define xwidth2 mccinter_analyzer_colimator_5_blade_4_xwidth2
#define yheight2 mccinter_analyzer_colimator_5_blade_4_yheight2
#define visualize mccinter_analyzer_colimator_5_blade_4_visualize
#define target_index mccinter_analyzer_colimator_5_blade_4_target_index
#define target_x mccinter_analyzer_colimator_5_blade_4_target_x
#define target_y mccinter_analyzer_colimator_5_blade_4_target_y
#define target_z mccinter_analyzer_colimator_5_blade_4_target_z
#define focus_aw mccinter_analyzer_colimator_5_blade_4_focus_aw
#define focus_ah mccinter_analyzer_colimator_5_blade_4_focus_ah
#define focus_xw mccinter_analyzer_colimator_5_blade_4_focus_xw
#define focus_xh mccinter_analyzer_colimator_5_blade_4_focus_xh
#define focus_r mccinter_analyzer_colimator_5_blade_4_focus_r
#define p_interact mccinter_analyzer_colimator_5_blade_4_p_interact
#define mask_string mccinter_analyzer_colimator_5_blade_4_mask_string
#define mask_setting mccinter_analyzer_colimator_5_blade_4_mask_setting
#define number_of_activations mccinter_analyzer_colimator_5_blade_4_number_of_activations
#line 224 "Union_box.comp"
{
// Initializes the focusing system for this volume including input sanitation.
focus_initialize(&this_box_volume.geometry, POS_A_COMP_INDEX(INDEX_CURRENT_COMP+target_index), POS_A_CURRENT_COMP, ROT_A_CURRENT_COMP, target_index, target_x, target_y, target_z, focus_aw, focus_ah, focus_xw, focus_xh, focus_r, NAME_CURRENT_COMP);

// Input sanitation for this geometry
if (xwidth <= 0) {
  printf("\nERROR in Union_box named %s, the xwidth is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (yheight <= 0) {
  printf("\nERROR in Union_box named %s, yheight is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (zdepth <= 0) {
  printf("\nERROR in Union_box named %s, zdepth is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (xwidth2 <= 0 && xwidth2 != -1) {
  printf("\nERROR in Union_box named %s, the xwidth2 is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (yheight2 <= 0 && yheight2 != -1) {
  printf("\nERROR in Union_box named %s, yheight2 is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}

// Use sanitation
if (global_material_list.num_elements == 0) {
  printf("\nERROR: Need to define a material using Union_make_material before using a Union geometry component. \n");
  printf("       %s was defined before first use of Union_make_material.\n",NAME_CURRENT_COMP);
  exit(1);
}

this_box_volume.geometry.is_masked_volume = 0;
this_box_volume.geometry.is_exit_volume = 0;
this_box_volume.geometry.is_mask_volume = 0;
// check if the volume is a mask, if it is the material string is irelevant.
if (mask_string && strlen(mask_string) && strcmp(mask_string, "NULL") && strcmp(mask_string, "0")) {
    // A mask volume is used to limit the extend of other volumes, called the masked volumes. These are specified in the mask_string.
    // In order for a ray to enter a masked volume, it needs to be both in the region covered by that volume AND the mask volume.
    // When more than
    this_box_volume.geometry.mask_mode = 1; // Default is mask mode is ALL
    if (mask_setting && strlen(mask_setting) && strcmp(mask_setting, "NULL") && strcmp(mask_setting, "0")) {
        if (strcmp(mask_setting,"ALL") == 0 || strcmp(mask_setting,"All") == 0) this_box_volume.geometry.mask_mode = 1;
        else if (strcmp(mask_setting,"ANY") == 0 || strcmp(mask_setting,"Any") == 0) this_box_volume.geometry.mask_mode = 2;
        else {
            printf("The mask_mode of component %s is set to %s, but must be either ALL or ANY.\n",NAME_CURRENT_COMP,mask_setting);
            exit(1);
        }
    }
    
    for (loop_index=0;loop_index<global_geometry_list.num_elements;loop_index++) {
        // Add mask list
        if (1 == manual_linking_function(global_geometry_list.elements[loop_index].name,mask_string)) {
            add_element_to_int_list(&this_box_volume.geometry.mask_list,global_geometry_list.elements[loop_index].component_index);
            add_element_to_int_list(&global_geometry_list.elements[loop_index].Volume->geometry.masked_by_list,INDEX_CURRENT_COMP);
            global_geometry_list.elements[loop_index].Volume->geometry.is_masked_volume = 1;
            if (this_box_volume.geometry.mask_mode == 2)
                global_geometry_list.elements[loop_index].Volume->geometry.mask_mode = 2;
            if (this_box_volume.geometry.mask_mode == 1) {
                if (global_geometry_list.elements[loop_index].Volume->geometry.is_masked_volume == 1 && global_geometry_list.elements[loop_index].Volume->geometry.mask_mode != 2)
                    // If more than one mask is added to one volume, the ANY mode overwrites the (default) ALL mode.
                    global_geometry_list.elements[loop_index].Volume->geometry.mask_mode = 1;
            }
            
            found_geometries = 1;
        }
    }
    if (found_geometries == 0) {
        printf("The mask_string in geometry: %s did not find any of the specified volumes in the mask_string %s \n",NAME_CURRENT_COMP,mask_string);
        exit(1);
    }
    this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
    this_box_volume.p_physics->is_vacuum = 0; // Makes this volume a vacuum
    this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
    this_box_volume.p_physics->my_a = 0; // Should not be used.
    sprintf(this_box_volume.p_physics->name,"Mask");
    this_box_volume.geometry.is_mask_volume = 1;
    
    
// Read the material input, or if it lacks, use automatic linking.
} else if (material_string && strlen(material_string) && strcmp(material_string, "NULL") && strcmp(material_string, "0")) {
    // A geometry string was given, use it to determine which material
    if (0 == strcmp(material_string,"vacuum") || 0 == strcmp(material_string,"Vacuum")) {
        // One could have a global physics struct for vacuum instead of creating one for each
        this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
        this_box_volume.p_physics->is_vacuum = 1; // Makes this volume a vacuum
        this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
        this_box_volume.p_physics->my_a = 0; // Should not be used.
        sprintf(this_box_volume.p_physics->name,"Vacuum");
    } else if (0 == strcmp(material_string,"exit") || 0 == strcmp(material_string,"Exit")) {
        // One could have a global physics struct for vacuum instead of creating one for each
        this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
        this_box_volume.p_physics->is_vacuum = 1; // Makes this volume a vacuum
        this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
        this_box_volume.p_physics->my_a = 0; // Should not be used.
        this_box_volume.geometry.is_exit_volume = 1;
        sprintf(this_box_volume.p_physics->name,"Exit");
    } else {
        #ifndef MATERIAL_DETECTOR
            printf("Need to define a material before refering to it in a geometry %s.\n",NAME_CURRENT_COMP);
            exit(1);
        #endif
        for (loop_index=0;loop_index<global_material_list.num_elements;loop_index++) {
            if (0 == strcmp(material_string,global_material_list.elements[loop_index].name)) {
                this_box_volume.p_physics = global_material_list.elements[loop_index].physics;
                break;
            }
            if (loop_index == global_material_list.num_elements-1) {
            printf("\n");
            printf("ERROR: The material string \"%s\" in Union geometry \"%s\" did not match a specified material. \n",material_string,NAME_CURRENT_COMP);
            printf("       The materials available at this point (need to be defined before the geometry): \n");
            for (loop_index=0;loop_index<global_material_list.num_elements;loop_index++)
              printf("         %s\n",global_material_list.elements[loop_index].name);
            printf("\n");
            printf("       It is also possible to use one of the defualt materials avaiable: \n");
            printf("           Vacuum (for a Volume without scattering or absorption)\n");
            printf("           Exit (for a Volume where the ray exits the component if it enters)\n");
            printf("           Mask (for a Volume that masks existing volumes specified in the mask_string\n");
            exit(1);
          }
        }
    }
} else {
    // Automatic linking, simply using the last defined material.
    #ifndef MATERIAL_DETECTOR
        printf("Need to define a material before the geometry to use automatic linking %s.\n",NAME_CURRENT_COMP);
        exit(1);
    #endif
    this_box_volume.p_physics = global_material_list.elements[global_material_list.num_elements-1].physics;
}

sprintf(this_box_volume.name,NAME_CURRENT_COMP);
sprintf(this_box_volume.geometry.shape,"box");
this_box_volume.geometry.priority_value = priority;
this_box_volume.geometry.geometry_p_interact = p_interact;
// Currently the coordinates will be in absolute space.
this_box_volume.geometry.center = POS_A_CURRENT_COMP;

this_box_storage.z_depth = zdepth;
this_box_storage.x_width1 = xwidth;
this_box_storage.y_height1 = yheight;

this_box_storage.is_rectangle = 0;
if (xwidth2 < 0 && yheight2 < 0) this_box_storage.is_rectangle = 1;
if (xwidth == xwidth2 && yheight == yheight2) this_box_storage.is_rectangle = 1;

if (xwidth2 < 0) {
    this_box_storage.x_width2 = xwidth;
    xwidth2 = xwidth;
} else this_box_storage.x_width2 = xwidth2;

if (yheight2 < 0) {
    this_box_storage.y_height2 = yheight;
    yheight2 = yheight;
} else this_box_storage.y_height2 = yheight2;


this_box_storage.normal_vectors[0] = coords_set(0,0,1);
this_box_storage.normal_vectors[1] = coords_set(0,0,1);

// for sides with y component = 0
x_component = 2*zdepth/sqrt((xwidth-xwidth2)*(xwidth-xwidth2)+4*zdepth*zdepth);
z_component = (xwidth-xwidth2)/sqrt(4*zdepth*zdepth+(xwidth-xwidth2)*(xwidth-xwidth2));

this_box_storage.normal_vectors[2] = coords_set(x_component,0,z_component);
this_box_storage.normal_vectors[3] = coords_set(-x_component,0,z_component);

// for sides with x component = 0
y_component = 2*zdepth/sqrt((yheight-yheight2)*(yheight-yheight2)+4*zdepth*zdepth);
z_component = (yheight-yheight2)/sqrt(4*zdepth*zdepth+(yheight-yheight2)*(yheight-yheight2));

this_box_storage.normal_vectors[4] = coords_set(0,y_component,z_component);
this_box_storage.normal_vectors[5] = coords_set(0,-y_component,z_component);

this_box_volume.geometry.visualization_on = visualize;

this_box_volume.geometry.geometry_parameters.p_box_storage = &this_box_storage;

// Assign pointers to functions for intersection with the shape, checking if a point is inside the shape
if (this_box_storage.is_rectangle == 1) {
this_box_volume.geometry.intersect_function = &sample_box_intersect_simple;
this_box_volume.geometry.within_function = &r_within_box_simple;
}
else {
this_box_volume.geometry.intersect_function = &sample_box_intersect_advanced;
this_box_volume.geometry.within_function = &r_within_box_advanced;
}

this_box_volume.geometry.shell_points = &box_shell_points;
this_box_volume.geometry.mcdisplay_function = &mcdisplay_box_function;
this_box_volume.geometry.initialize_from_main_function = &initialize_box_geometry_from_main_component;
this_box_volume.geometry.process_rot_allocated = 0;

this_box_volume.geometry.copy_geometry_parameters = &allocate_box_storage_copy;

rot_copy(this_box_volume.geometry.rotation_matrix,ROT_A_CURRENT_COMP); //check how ROT_R_CURRENT_COMP would work
rot_transpose(ROT_A_CURRENT_COMP,this_box_volume.geometry.transpose_rotation_matrix);

// Initialize loggers
this_box_volume.loggers.num_elements = 0;

// packing the information into the global_geometry_element, which is then included in the global_geometry_list.
sprintf(global_geometry_element.name,NAME_CURRENT_COMP);
global_geometry_element.activation_counter = number_of_activations;
global_geometry_element.component_index = INDEX_CURRENT_COMP;
global_geometry_element.Volume = &this_box_volume; // Would be nicer if this m was a pointer, now we have the (small) data two places
add_element_to_geometry_list(&global_geometry_list,global_geometry_element);
}
#line 216800 "MACS_sample_kidney_box.c"
#undef number_of_activations
#undef mask_setting
#undef mask_string
#undef p_interact
#undef focus_r
#undef focus_xh
#undef focus_xw
#undef focus_ah
#undef focus_aw
#undef target_z
#undef target_y
#undef target_x
#undef target_index
#undef visualize
#undef yheight2
#undef xwidth2
#undef zdepth
#undef yheight
#undef xwidth
#undef priority
#undef material_string
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

  /* Initializations for component diffraction_detector_5_exit_volume. */
  SIG_MESSAGE("diffraction_detector_5_exit_volume (Init)");
#define mccompcurname  diffraction_detector_5_exit_volume
#define mccompcurtype  Union_box
#define mccompcurindex 350
#define loop_index mccdiffraction_detector_5_exit_volume_loop_index
#define this_box_volume mccdiffraction_detector_5_exit_volume_this_box_volume
#define global_geometry_element mccdiffraction_detector_5_exit_volume_global_geometry_element
#define this_box_storage mccdiffraction_detector_5_exit_volume_this_box_storage
#define material_string mccdiffraction_detector_5_exit_volume_material_string
#define priority mccdiffraction_detector_5_exit_volume_priority
#define xwidth mccdiffraction_detector_5_exit_volume_xwidth
#define yheight mccdiffraction_detector_5_exit_volume_yheight
#define zdepth mccdiffraction_detector_5_exit_volume_zdepth
#define xwidth2 mccdiffraction_detector_5_exit_volume_xwidth2
#define yheight2 mccdiffraction_detector_5_exit_volume_yheight2
#define visualize mccdiffraction_detector_5_exit_volume_visualize
#define target_index mccdiffraction_detector_5_exit_volume_target_index
#define target_x mccdiffraction_detector_5_exit_volume_target_x
#define target_y mccdiffraction_detector_5_exit_volume_target_y
#define target_z mccdiffraction_detector_5_exit_volume_target_z
#define focus_aw mccdiffraction_detector_5_exit_volume_focus_aw
#define focus_ah mccdiffraction_detector_5_exit_volume_focus_ah
#define focus_xw mccdiffraction_detector_5_exit_volume_focus_xw
#define focus_xh mccdiffraction_detector_5_exit_volume_focus_xh
#define focus_r mccdiffraction_detector_5_exit_volume_focus_r
#define p_interact mccdiffraction_detector_5_exit_volume_p_interact
#define mask_string mccdiffraction_detector_5_exit_volume_mask_string
#define mask_setting mccdiffraction_detector_5_exit_volume_mask_setting
#define number_of_activations mccdiffraction_detector_5_exit_volume_number_of_activations
#line 224 "Union_box.comp"
{
// Initializes the focusing system for this volume including input sanitation.
focus_initialize(&this_box_volume.geometry, POS_A_COMP_INDEX(INDEX_CURRENT_COMP+target_index), POS_A_CURRENT_COMP, ROT_A_CURRENT_COMP, target_index, target_x, target_y, target_z, focus_aw, focus_ah, focus_xw, focus_xh, focus_r, NAME_CURRENT_COMP);

// Input sanitation for this geometry
if (xwidth <= 0) {
  printf("\nERROR in Union_box named %s, the xwidth is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (yheight <= 0) {
  printf("\nERROR in Union_box named %s, yheight is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (zdepth <= 0) {
  printf("\nERROR in Union_box named %s, zdepth is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (xwidth2 <= 0 && xwidth2 != -1) {
  printf("\nERROR in Union_box named %s, the xwidth2 is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (yheight2 <= 0 && yheight2 != -1) {
  printf("\nERROR in Union_box named %s, yheight2 is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}

// Use sanitation
if (global_material_list.num_elements == 0) {
  printf("\nERROR: Need to define a material using Union_make_material before using a Union geometry component. \n");
  printf("       %s was defined before first use of Union_make_material.\n",NAME_CURRENT_COMP);
  exit(1);
}

this_box_volume.geometry.is_masked_volume = 0;
this_box_volume.geometry.is_exit_volume = 0;
this_box_volume.geometry.is_mask_volume = 0;
// check if the volume is a mask, if it is the material string is irelevant.
if (mask_string && strlen(mask_string) && strcmp(mask_string, "NULL") && strcmp(mask_string, "0")) {
    // A mask volume is used to limit the extend of other volumes, called the masked volumes. These are specified in the mask_string.
    // In order for a ray to enter a masked volume, it needs to be both in the region covered by that volume AND the mask volume.
    // When more than
    this_box_volume.geometry.mask_mode = 1; // Default is mask mode is ALL
    if (mask_setting && strlen(mask_setting) && strcmp(mask_setting, "NULL") && strcmp(mask_setting, "0")) {
        if (strcmp(mask_setting,"ALL") == 0 || strcmp(mask_setting,"All") == 0) this_box_volume.geometry.mask_mode = 1;
        else if (strcmp(mask_setting,"ANY") == 0 || strcmp(mask_setting,"Any") == 0) this_box_volume.geometry.mask_mode = 2;
        else {
            printf("The mask_mode of component %s is set to %s, but must be either ALL or ANY.\n",NAME_CURRENT_COMP,mask_setting);
            exit(1);
        }
    }
    
    for (loop_index=0;loop_index<global_geometry_list.num_elements;loop_index++) {
        // Add mask list
        if (1 == manual_linking_function(global_geometry_list.elements[loop_index].name,mask_string)) {
            add_element_to_int_list(&this_box_volume.geometry.mask_list,global_geometry_list.elements[loop_index].component_index);
            add_element_to_int_list(&global_geometry_list.elements[loop_index].Volume->geometry.masked_by_list,INDEX_CURRENT_COMP);
            global_geometry_list.elements[loop_index].Volume->geometry.is_masked_volume = 1;
            if (this_box_volume.geometry.mask_mode == 2)
                global_geometry_list.elements[loop_index].Volume->geometry.mask_mode = 2;
            if (this_box_volume.geometry.mask_mode == 1) {
                if (global_geometry_list.elements[loop_index].Volume->geometry.is_masked_volume == 1 && global_geometry_list.elements[loop_index].Volume->geometry.mask_mode != 2)
                    // If more than one mask is added to one volume, the ANY mode overwrites the (default) ALL mode.
                    global_geometry_list.elements[loop_index].Volume->geometry.mask_mode = 1;
            }
            
            found_geometries = 1;
        }
    }
    if (found_geometries == 0) {
        printf("The mask_string in geometry: %s did not find any of the specified volumes in the mask_string %s \n",NAME_CURRENT_COMP,mask_string);
        exit(1);
    }
    this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
    this_box_volume.p_physics->is_vacuum = 0; // Makes this volume a vacuum
    this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
    this_box_volume.p_physics->my_a = 0; // Should not be used.
    sprintf(this_box_volume.p_physics->name,"Mask");
    this_box_volume.geometry.is_mask_volume = 1;
    
    
// Read the material input, or if it lacks, use automatic linking.
} else if (material_string && strlen(material_string) && strcmp(material_string, "NULL") && strcmp(material_string, "0")) {
    // A geometry string was given, use it to determine which material
    if (0 == strcmp(material_string,"vacuum") || 0 == strcmp(material_string,"Vacuum")) {
        // One could have a global physics struct for vacuum instead of creating one for each
        this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
        this_box_volume.p_physics->is_vacuum = 1; // Makes this volume a vacuum
        this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
        this_box_volume.p_physics->my_a = 0; // Should not be used.
        sprintf(this_box_volume.p_physics->name,"Vacuum");
    } else if (0 == strcmp(material_string,"exit") || 0 == strcmp(material_string,"Exit")) {
        // One could have a global physics struct for vacuum instead of creating one for each
        this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
        this_box_volume.p_physics->is_vacuum = 1; // Makes this volume a vacuum
        this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
        this_box_volume.p_physics->my_a = 0; // Should not be used.
        this_box_volume.geometry.is_exit_volume = 1;
        sprintf(this_box_volume.p_physics->name,"Exit");
    } else {
        #ifndef MATERIAL_DETECTOR
            printf("Need to define a material before refering to it in a geometry %s.\n",NAME_CURRENT_COMP);
            exit(1);
        #endif
        for (loop_index=0;loop_index<global_material_list.num_elements;loop_index++) {
            if (0 == strcmp(material_string,global_material_list.elements[loop_index].name)) {
                this_box_volume.p_physics = global_material_list.elements[loop_index].physics;
                break;
            }
            if (loop_index == global_material_list.num_elements-1) {
            printf("\n");
            printf("ERROR: The material string \"%s\" in Union geometry \"%s\" did not match a specified material. \n",material_string,NAME_CURRENT_COMP);
            printf("       The materials available at this point (need to be defined before the geometry): \n");
            for (loop_index=0;loop_index<global_material_list.num_elements;loop_index++)
              printf("         %s\n",global_material_list.elements[loop_index].name);
            printf("\n");
            printf("       It is also possible to use one of the defualt materials avaiable: \n");
            printf("           Vacuum (for a Volume without scattering or absorption)\n");
            printf("           Exit (for a Volume where the ray exits the component if it enters)\n");
            printf("           Mask (for a Volume that masks existing volumes specified in the mask_string\n");
            exit(1);
          }
        }
    }
} else {
    // Automatic linking, simply using the last defined material.
    #ifndef MATERIAL_DETECTOR
        printf("Need to define a material before the geometry to use automatic linking %s.\n",NAME_CURRENT_COMP);
        exit(1);
    #endif
    this_box_volume.p_physics = global_material_list.elements[global_material_list.num_elements-1].physics;
}

sprintf(this_box_volume.name,NAME_CURRENT_COMP);
sprintf(this_box_volume.geometry.shape,"box");
this_box_volume.geometry.priority_value = priority;
this_box_volume.geometry.geometry_p_interact = p_interact;
// Currently the coordinates will be in absolute space.
this_box_volume.geometry.center = POS_A_CURRENT_COMP;

this_box_storage.z_depth = zdepth;
this_box_storage.x_width1 = xwidth;
this_box_storage.y_height1 = yheight;

this_box_storage.is_rectangle = 0;
if (xwidth2 < 0 && yheight2 < 0) this_box_storage.is_rectangle = 1;
if (xwidth == xwidth2 && yheight == yheight2) this_box_storage.is_rectangle = 1;

if (xwidth2 < 0) {
    this_box_storage.x_width2 = xwidth;
    xwidth2 = xwidth;
} else this_box_storage.x_width2 = xwidth2;

if (yheight2 < 0) {
    this_box_storage.y_height2 = yheight;
    yheight2 = yheight;
} else this_box_storage.y_height2 = yheight2;


this_box_storage.normal_vectors[0] = coords_set(0,0,1);
this_box_storage.normal_vectors[1] = coords_set(0,0,1);

// for sides with y component = 0
x_component = 2*zdepth/sqrt((xwidth-xwidth2)*(xwidth-xwidth2)+4*zdepth*zdepth);
z_component = (xwidth-xwidth2)/sqrt(4*zdepth*zdepth+(xwidth-xwidth2)*(xwidth-xwidth2));

this_box_storage.normal_vectors[2] = coords_set(x_component,0,z_component);
this_box_storage.normal_vectors[3] = coords_set(-x_component,0,z_component);

// for sides with x component = 0
y_component = 2*zdepth/sqrt((yheight-yheight2)*(yheight-yheight2)+4*zdepth*zdepth);
z_component = (yheight-yheight2)/sqrt(4*zdepth*zdepth+(yheight-yheight2)*(yheight-yheight2));

this_box_storage.normal_vectors[4] = coords_set(0,y_component,z_component);
this_box_storage.normal_vectors[5] = coords_set(0,-y_component,z_component);

this_box_volume.geometry.visualization_on = visualize;

this_box_volume.geometry.geometry_parameters.p_box_storage = &this_box_storage;

// Assign pointers to functions for intersection with the shape, checking if a point is inside the shape
if (this_box_storage.is_rectangle == 1) {
this_box_volume.geometry.intersect_function = &sample_box_intersect_simple;
this_box_volume.geometry.within_function = &r_within_box_simple;
}
else {
this_box_volume.geometry.intersect_function = &sample_box_intersect_advanced;
this_box_volume.geometry.within_function = &r_within_box_advanced;
}

this_box_volume.geometry.shell_points = &box_shell_points;
this_box_volume.geometry.mcdisplay_function = &mcdisplay_box_function;
this_box_volume.geometry.initialize_from_main_function = &initialize_box_geometry_from_main_component;
this_box_volume.geometry.process_rot_allocated = 0;

this_box_volume.geometry.copy_geometry_parameters = &allocate_box_storage_copy;

rot_copy(this_box_volume.geometry.rotation_matrix,ROT_A_CURRENT_COMP); //check how ROT_R_CURRENT_COMP would work
rot_transpose(ROT_A_CURRENT_COMP,this_box_volume.geometry.transpose_rotation_matrix);

// Initialize loggers
this_box_volume.loggers.num_elements = 0;

// packing the information into the global_geometry_element, which is then included in the global_geometry_list.
sprintf(global_geometry_element.name,NAME_CURRENT_COMP);
global_geometry_element.activation_counter = number_of_activations;
global_geometry_element.component_index = INDEX_CURRENT_COMP;
global_geometry_element.Volume = &this_box_volume; // Would be nicer if this m was a pointer, now we have the (small) data two places
add_element_to_geometry_list(&global_geometry_list,global_geometry_element);
}
#line 217070 "MACS_sample_kidney_box.c"
#undef number_of_activations
#undef mask_setting
#undef mask_string
#undef p_interact
#undef focus_r
#undef focus_xh
#undef focus_xw
#undef focus_ah
#undef focus_aw
#undef target_z
#undef target_y
#undef target_x
#undef target_index
#undef visualize
#undef yheight2
#undef xwidth2
#undef zdepth
#undef yheight
#undef xwidth
#undef priority
#undef material_string
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

  /* Initializations for component spec_detector_5_exit_volume. */
  SIG_MESSAGE("spec_detector_5_exit_volume (Init)");
#define mccompcurname  spec_detector_5_exit_volume
#define mccompcurtype  Union_box
#define mccompcurindex 351
#define loop_index mccspec_detector_5_exit_volume_loop_index
#define this_box_volume mccspec_detector_5_exit_volume_this_box_volume
#define global_geometry_element mccspec_detector_5_exit_volume_global_geometry_element
#define this_box_storage mccspec_detector_5_exit_volume_this_box_storage
#define material_string mccspec_detector_5_exit_volume_material_string
#define priority mccspec_detector_5_exit_volume_priority
#define xwidth mccspec_detector_5_exit_volume_xwidth
#define yheight mccspec_detector_5_exit_volume_yheight
#define zdepth mccspec_detector_5_exit_volume_zdepth
#define xwidth2 mccspec_detector_5_exit_volume_xwidth2
#define yheight2 mccspec_detector_5_exit_volume_yheight2
#define visualize mccspec_detector_5_exit_volume_visualize
#define target_index mccspec_detector_5_exit_volume_target_index
#define target_x mccspec_detector_5_exit_volume_target_x
#define target_y mccspec_detector_5_exit_volume_target_y
#define target_z mccspec_detector_5_exit_volume_target_z
#define focus_aw mccspec_detector_5_exit_volume_focus_aw
#define focus_ah mccspec_detector_5_exit_volume_focus_ah
#define focus_xw mccspec_detector_5_exit_volume_focus_xw
#define focus_xh mccspec_detector_5_exit_volume_focus_xh
#define focus_r mccspec_detector_5_exit_volume_focus_r
#define p_interact mccspec_detector_5_exit_volume_p_interact
#define mask_string mccspec_detector_5_exit_volume_mask_string
#define mask_setting mccspec_detector_5_exit_volume_mask_setting
#define number_of_activations mccspec_detector_5_exit_volume_number_of_activations
#line 224 "Union_box.comp"
{
// Initializes the focusing system for this volume including input sanitation.
focus_initialize(&this_box_volume.geometry, POS_A_COMP_INDEX(INDEX_CURRENT_COMP+target_index), POS_A_CURRENT_COMP, ROT_A_CURRENT_COMP, target_index, target_x, target_y, target_z, focus_aw, focus_ah, focus_xw, focus_xh, focus_r, NAME_CURRENT_COMP);

// Input sanitation for this geometry
if (xwidth <= 0) {
  printf("\nERROR in Union_box named %s, the xwidth is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (yheight <= 0) {
  printf("\nERROR in Union_box named %s, yheight is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (zdepth <= 0) {
  printf("\nERROR in Union_box named %s, zdepth is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (xwidth2 <= 0 && xwidth2 != -1) {
  printf("\nERROR in Union_box named %s, the xwidth2 is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (yheight2 <= 0 && yheight2 != -1) {
  printf("\nERROR in Union_box named %s, yheight2 is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}

// Use sanitation
if (global_material_list.num_elements == 0) {
  printf("\nERROR: Need to define a material using Union_make_material before using a Union geometry component. \n");
  printf("       %s was defined before first use of Union_make_material.\n",NAME_CURRENT_COMP);
  exit(1);
}

this_box_volume.geometry.is_masked_volume = 0;
this_box_volume.geometry.is_exit_volume = 0;
this_box_volume.geometry.is_mask_volume = 0;
// check if the volume is a mask, if it is the material string is irelevant.
if (mask_string && strlen(mask_string) && strcmp(mask_string, "NULL") && strcmp(mask_string, "0")) {
    // A mask volume is used to limit the extend of other volumes, called the masked volumes. These are specified in the mask_string.
    // In order for a ray to enter a masked volume, it needs to be both in the region covered by that volume AND the mask volume.
    // When more than
    this_box_volume.geometry.mask_mode = 1; // Default is mask mode is ALL
    if (mask_setting && strlen(mask_setting) && strcmp(mask_setting, "NULL") && strcmp(mask_setting, "0")) {
        if (strcmp(mask_setting,"ALL") == 0 || strcmp(mask_setting,"All") == 0) this_box_volume.geometry.mask_mode = 1;
        else if (strcmp(mask_setting,"ANY") == 0 || strcmp(mask_setting,"Any") == 0) this_box_volume.geometry.mask_mode = 2;
        else {
            printf("The mask_mode of component %s is set to %s, but must be either ALL or ANY.\n",NAME_CURRENT_COMP,mask_setting);
            exit(1);
        }
    }
    
    for (loop_index=0;loop_index<global_geometry_list.num_elements;loop_index++) {
        // Add mask list
        if (1 == manual_linking_function(global_geometry_list.elements[loop_index].name,mask_string)) {
            add_element_to_int_list(&this_box_volume.geometry.mask_list,global_geometry_list.elements[loop_index].component_index);
            add_element_to_int_list(&global_geometry_list.elements[loop_index].Volume->geometry.masked_by_list,INDEX_CURRENT_COMP);
            global_geometry_list.elements[loop_index].Volume->geometry.is_masked_volume = 1;
            if (this_box_volume.geometry.mask_mode == 2)
                global_geometry_list.elements[loop_index].Volume->geometry.mask_mode = 2;
            if (this_box_volume.geometry.mask_mode == 1) {
                if (global_geometry_list.elements[loop_index].Volume->geometry.is_masked_volume == 1 && global_geometry_list.elements[loop_index].Volume->geometry.mask_mode != 2)
                    // If more than one mask is added to one volume, the ANY mode overwrites the (default) ALL mode.
                    global_geometry_list.elements[loop_index].Volume->geometry.mask_mode = 1;
            }
            
            found_geometries = 1;
        }
    }
    if (found_geometries == 0) {
        printf("The mask_string in geometry: %s did not find any of the specified volumes in the mask_string %s \n",NAME_CURRENT_COMP,mask_string);
        exit(1);
    }
    this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
    this_box_volume.p_physics->is_vacuum = 0; // Makes this volume a vacuum
    this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
    this_box_volume.p_physics->my_a = 0; // Should not be used.
    sprintf(this_box_volume.p_physics->name,"Mask");
    this_box_volume.geometry.is_mask_volume = 1;
    
    
// Read the material input, or if it lacks, use automatic linking.
} else if (material_string && strlen(material_string) && strcmp(material_string, "NULL") && strcmp(material_string, "0")) {
    // A geometry string was given, use it to determine which material
    if (0 == strcmp(material_string,"vacuum") || 0 == strcmp(material_string,"Vacuum")) {
        // One could have a global physics struct for vacuum instead of creating one for each
        this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
        this_box_volume.p_physics->is_vacuum = 1; // Makes this volume a vacuum
        this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
        this_box_volume.p_physics->my_a = 0; // Should not be used.
        sprintf(this_box_volume.p_physics->name,"Vacuum");
    } else if (0 == strcmp(material_string,"exit") || 0 == strcmp(material_string,"Exit")) {
        // One could have a global physics struct for vacuum instead of creating one for each
        this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
        this_box_volume.p_physics->is_vacuum = 1; // Makes this volume a vacuum
        this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
        this_box_volume.p_physics->my_a = 0; // Should not be used.
        this_box_volume.geometry.is_exit_volume = 1;
        sprintf(this_box_volume.p_physics->name,"Exit");
    } else {
        #ifndef MATERIAL_DETECTOR
            printf("Need to define a material before refering to it in a geometry %s.\n",NAME_CURRENT_COMP);
            exit(1);
        #endif
        for (loop_index=0;loop_index<global_material_list.num_elements;loop_index++) {
            if (0 == strcmp(material_string,global_material_list.elements[loop_index].name)) {
                this_box_volume.p_physics = global_material_list.elements[loop_index].physics;
                break;
            }
            if (loop_index == global_material_list.num_elements-1) {
            printf("\n");
            printf("ERROR: The material string \"%s\" in Union geometry \"%s\" did not match a specified material. \n",material_string,NAME_CURRENT_COMP);
            printf("       The materials available at this point (need to be defined before the geometry): \n");
            for (loop_index=0;loop_index<global_material_list.num_elements;loop_index++)
              printf("         %s\n",global_material_list.elements[loop_index].name);
            printf("\n");
            printf("       It is also possible to use one of the defualt materials avaiable: \n");
            printf("           Vacuum (for a Volume without scattering or absorption)\n");
            printf("           Exit (for a Volume where the ray exits the component if it enters)\n");
            printf("           Mask (for a Volume that masks existing volumes specified in the mask_string\n");
            exit(1);
          }
        }
    }
} else {
    // Automatic linking, simply using the last defined material.
    #ifndef MATERIAL_DETECTOR
        printf("Need to define a material before the geometry to use automatic linking %s.\n",NAME_CURRENT_COMP);
        exit(1);
    #endif
    this_box_volume.p_physics = global_material_list.elements[global_material_list.num_elements-1].physics;
}

sprintf(this_box_volume.name,NAME_CURRENT_COMP);
sprintf(this_box_volume.geometry.shape,"box");
this_box_volume.geometry.priority_value = priority;
this_box_volume.geometry.geometry_p_interact = p_interact;
// Currently the coordinates will be in absolute space.
this_box_volume.geometry.center = POS_A_CURRENT_COMP;

this_box_storage.z_depth = zdepth;
this_box_storage.x_width1 = xwidth;
this_box_storage.y_height1 = yheight;

this_box_storage.is_rectangle = 0;
if (xwidth2 < 0 && yheight2 < 0) this_box_storage.is_rectangle = 1;
if (xwidth == xwidth2 && yheight == yheight2) this_box_storage.is_rectangle = 1;

if (xwidth2 < 0) {
    this_box_storage.x_width2 = xwidth;
    xwidth2 = xwidth;
} else this_box_storage.x_width2 = xwidth2;

if (yheight2 < 0) {
    this_box_storage.y_height2 = yheight;
    yheight2 = yheight;
} else this_box_storage.y_height2 = yheight2;


this_box_storage.normal_vectors[0] = coords_set(0,0,1);
this_box_storage.normal_vectors[1] = coords_set(0,0,1);

// for sides with y component = 0
x_component = 2*zdepth/sqrt((xwidth-xwidth2)*(xwidth-xwidth2)+4*zdepth*zdepth);
z_component = (xwidth-xwidth2)/sqrt(4*zdepth*zdepth+(xwidth-xwidth2)*(xwidth-xwidth2));

this_box_storage.normal_vectors[2] = coords_set(x_component,0,z_component);
this_box_storage.normal_vectors[3] = coords_set(-x_component,0,z_component);

// for sides with x component = 0
y_component = 2*zdepth/sqrt((yheight-yheight2)*(yheight-yheight2)+4*zdepth*zdepth);
z_component = (yheight-yheight2)/sqrt(4*zdepth*zdepth+(yheight-yheight2)*(yheight-yheight2));

this_box_storage.normal_vectors[4] = coords_set(0,y_component,z_component);
this_box_storage.normal_vectors[5] = coords_set(0,-y_component,z_component);

this_box_volume.geometry.visualization_on = visualize;

this_box_volume.geometry.geometry_parameters.p_box_storage = &this_box_storage;

// Assign pointers to functions for intersection with the shape, checking if a point is inside the shape
if (this_box_storage.is_rectangle == 1) {
this_box_volume.geometry.intersect_function = &sample_box_intersect_simple;
this_box_volume.geometry.within_function = &r_within_box_simple;
}
else {
this_box_volume.geometry.intersect_function = &sample_box_intersect_advanced;
this_box_volume.geometry.within_function = &r_within_box_advanced;
}

this_box_volume.geometry.shell_points = &box_shell_points;
this_box_volume.geometry.mcdisplay_function = &mcdisplay_box_function;
this_box_volume.geometry.initialize_from_main_function = &initialize_box_geometry_from_main_component;
this_box_volume.geometry.process_rot_allocated = 0;

this_box_volume.geometry.copy_geometry_parameters = &allocate_box_storage_copy;

rot_copy(this_box_volume.geometry.rotation_matrix,ROT_A_CURRENT_COMP); //check how ROT_R_CURRENT_COMP would work
rot_transpose(ROT_A_CURRENT_COMP,this_box_volume.geometry.transpose_rotation_matrix);

// Initialize loggers
this_box_volume.loggers.num_elements = 0;

// packing the information into the global_geometry_element, which is then included in the global_geometry_list.
sprintf(global_geometry_element.name,NAME_CURRENT_COMP);
global_geometry_element.activation_counter = number_of_activations;
global_geometry_element.component_index = INDEX_CURRENT_COMP;
global_geometry_element.Volume = &this_box_volume; // Would be nicer if this m was a pointer, now we have the (small) data two places
add_element_to_geometry_list(&global_geometry_list,global_geometry_element);
}
#line 217340 "MACS_sample_kidney_box.c"
#undef number_of_activations
#undef mask_setting
#undef mask_string
#undef p_interact
#undef focus_r
#undef focus_xh
#undef focus_xw
#undef focus_ah
#undef focus_aw
#undef target_z
#undef target_y
#undef target_x
#undef target_index
#undef visualize
#undef yheight2
#undef xwidth2
#undef zdepth
#undef yheight
#undef xwidth
#undef priority
#undef material_string
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

  /* Initializations for component channel_6_cave1_box1. */
  SIG_MESSAGE("channel_6_cave1_box1 (Init)");
#define mccompcurname  channel_6_cave1_box1
#define mccompcurtype  Union_box
#define mccompcurindex 352
#define loop_index mccchannel_6_cave1_box1_loop_index
#define this_box_volume mccchannel_6_cave1_box1_this_box_volume
#define global_geometry_element mccchannel_6_cave1_box1_global_geometry_element
#define this_box_storage mccchannel_6_cave1_box1_this_box_storage
#define material_string mccchannel_6_cave1_box1_material_string
#define priority mccchannel_6_cave1_box1_priority
#define xwidth mccchannel_6_cave1_box1_xwidth
#define yheight mccchannel_6_cave1_box1_yheight
#define zdepth mccchannel_6_cave1_box1_zdepth
#define xwidth2 mccchannel_6_cave1_box1_xwidth2
#define yheight2 mccchannel_6_cave1_box1_yheight2
#define visualize mccchannel_6_cave1_box1_visualize
#define target_index mccchannel_6_cave1_box1_target_index
#define target_x mccchannel_6_cave1_box1_target_x
#define target_y mccchannel_6_cave1_box1_target_y
#define target_z mccchannel_6_cave1_box1_target_z
#define focus_aw mccchannel_6_cave1_box1_focus_aw
#define focus_ah mccchannel_6_cave1_box1_focus_ah
#define focus_xw mccchannel_6_cave1_box1_focus_xw
#define focus_xh mccchannel_6_cave1_box1_focus_xh
#define focus_r mccchannel_6_cave1_box1_focus_r
#define p_interact mccchannel_6_cave1_box1_p_interact
#define mask_string mccchannel_6_cave1_box1_mask_string
#define mask_setting mccchannel_6_cave1_box1_mask_setting
#define number_of_activations mccchannel_6_cave1_box1_number_of_activations
#line 224 "Union_box.comp"
{
// Initializes the focusing system for this volume including input sanitation.
focus_initialize(&this_box_volume.geometry, POS_A_COMP_INDEX(INDEX_CURRENT_COMP+target_index), POS_A_CURRENT_COMP, ROT_A_CURRENT_COMP, target_index, target_x, target_y, target_z, focus_aw, focus_ah, focus_xw, focus_xh, focus_r, NAME_CURRENT_COMP);

// Input sanitation for this geometry
if (xwidth <= 0) {
  printf("\nERROR in Union_box named %s, the xwidth is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (yheight <= 0) {
  printf("\nERROR in Union_box named %s, yheight is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (zdepth <= 0) {
  printf("\nERROR in Union_box named %s, zdepth is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (xwidth2 <= 0 && xwidth2 != -1) {
  printf("\nERROR in Union_box named %s, the xwidth2 is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (yheight2 <= 0 && yheight2 != -1) {
  printf("\nERROR in Union_box named %s, yheight2 is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}

// Use sanitation
if (global_material_list.num_elements == 0) {
  printf("\nERROR: Need to define a material using Union_make_material before using a Union geometry component. \n");
  printf("       %s was defined before first use of Union_make_material.\n",NAME_CURRENT_COMP);
  exit(1);
}

this_box_volume.geometry.is_masked_volume = 0;
this_box_volume.geometry.is_exit_volume = 0;
this_box_volume.geometry.is_mask_volume = 0;
// check if the volume is a mask, if it is the material string is irelevant.
if (mask_string && strlen(mask_string) && strcmp(mask_string, "NULL") && strcmp(mask_string, "0")) {
    // A mask volume is used to limit the extend of other volumes, called the masked volumes. These are specified in the mask_string.
    // In order for a ray to enter a masked volume, it needs to be both in the region covered by that volume AND the mask volume.
    // When more than
    this_box_volume.geometry.mask_mode = 1; // Default is mask mode is ALL
    if (mask_setting && strlen(mask_setting) && strcmp(mask_setting, "NULL") && strcmp(mask_setting, "0")) {
        if (strcmp(mask_setting,"ALL") == 0 || strcmp(mask_setting,"All") == 0) this_box_volume.geometry.mask_mode = 1;
        else if (strcmp(mask_setting,"ANY") == 0 || strcmp(mask_setting,"Any") == 0) this_box_volume.geometry.mask_mode = 2;
        else {
            printf("The mask_mode of component %s is set to %s, but must be either ALL or ANY.\n",NAME_CURRENT_COMP,mask_setting);
            exit(1);
        }
    }
    
    for (loop_index=0;loop_index<global_geometry_list.num_elements;loop_index++) {
        // Add mask list
        if (1 == manual_linking_function(global_geometry_list.elements[loop_index].name,mask_string)) {
            add_element_to_int_list(&this_box_volume.geometry.mask_list,global_geometry_list.elements[loop_index].component_index);
            add_element_to_int_list(&global_geometry_list.elements[loop_index].Volume->geometry.masked_by_list,INDEX_CURRENT_COMP);
            global_geometry_list.elements[loop_index].Volume->geometry.is_masked_volume = 1;
            if (this_box_volume.geometry.mask_mode == 2)
                global_geometry_list.elements[loop_index].Volume->geometry.mask_mode = 2;
            if (this_box_volume.geometry.mask_mode == 1) {
                if (global_geometry_list.elements[loop_index].Volume->geometry.is_masked_volume == 1 && global_geometry_list.elements[loop_index].Volume->geometry.mask_mode != 2)
                    // If more than one mask is added to one volume, the ANY mode overwrites the (default) ALL mode.
                    global_geometry_list.elements[loop_index].Volume->geometry.mask_mode = 1;
            }
            
            found_geometries = 1;
        }
    }
    if (found_geometries == 0) {
        printf("The mask_string in geometry: %s did not find any of the specified volumes in the mask_string %s \n",NAME_CURRENT_COMP,mask_string);
        exit(1);
    }
    this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
    this_box_volume.p_physics->is_vacuum = 0; // Makes this volume a vacuum
    this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
    this_box_volume.p_physics->my_a = 0; // Should not be used.
    sprintf(this_box_volume.p_physics->name,"Mask");
    this_box_volume.geometry.is_mask_volume = 1;
    
    
// Read the material input, or if it lacks, use automatic linking.
} else if (material_string && strlen(material_string) && strcmp(material_string, "NULL") && strcmp(material_string, "0")) {
    // A geometry string was given, use it to determine which material
    if (0 == strcmp(material_string,"vacuum") || 0 == strcmp(material_string,"Vacuum")) {
        // One could have a global physics struct for vacuum instead of creating one for each
        this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
        this_box_volume.p_physics->is_vacuum = 1; // Makes this volume a vacuum
        this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
        this_box_volume.p_physics->my_a = 0; // Should not be used.
        sprintf(this_box_volume.p_physics->name,"Vacuum");
    } else if (0 == strcmp(material_string,"exit") || 0 == strcmp(material_string,"Exit")) {
        // One could have a global physics struct for vacuum instead of creating one for each
        this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
        this_box_volume.p_physics->is_vacuum = 1; // Makes this volume a vacuum
        this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
        this_box_volume.p_physics->my_a = 0; // Should not be used.
        this_box_volume.geometry.is_exit_volume = 1;
        sprintf(this_box_volume.p_physics->name,"Exit");
    } else {
        #ifndef MATERIAL_DETECTOR
            printf("Need to define a material before refering to it in a geometry %s.\n",NAME_CURRENT_COMP);
            exit(1);
        #endif
        for (loop_index=0;loop_index<global_material_list.num_elements;loop_index++) {
            if (0 == strcmp(material_string,global_material_list.elements[loop_index].name)) {
                this_box_volume.p_physics = global_material_list.elements[loop_index].physics;
                break;
            }
            if (loop_index == global_material_list.num_elements-1) {
            printf("\n");
            printf("ERROR: The material string \"%s\" in Union geometry \"%s\" did not match a specified material. \n",material_string,NAME_CURRENT_COMP);
            printf("       The materials available at this point (need to be defined before the geometry): \n");
            for (loop_index=0;loop_index<global_material_list.num_elements;loop_index++)
              printf("         %s\n",global_material_list.elements[loop_index].name);
            printf("\n");
            printf("       It is also possible to use one of the defualt materials avaiable: \n");
            printf("           Vacuum (for a Volume without scattering or absorption)\n");
            printf("           Exit (for a Volume where the ray exits the component if it enters)\n");
            printf("           Mask (for a Volume that masks existing volumes specified in the mask_string\n");
            exit(1);
          }
        }
    }
} else {
    // Automatic linking, simply using the last defined material.
    #ifndef MATERIAL_DETECTOR
        printf("Need to define a material before the geometry to use automatic linking %s.\n",NAME_CURRENT_COMP);
        exit(1);
    #endif
    this_box_volume.p_physics = global_material_list.elements[global_material_list.num_elements-1].physics;
}

sprintf(this_box_volume.name,NAME_CURRENT_COMP);
sprintf(this_box_volume.geometry.shape,"box");
this_box_volume.geometry.priority_value = priority;
this_box_volume.geometry.geometry_p_interact = p_interact;
// Currently the coordinates will be in absolute space.
this_box_volume.geometry.center = POS_A_CURRENT_COMP;

this_box_storage.z_depth = zdepth;
this_box_storage.x_width1 = xwidth;
this_box_storage.y_height1 = yheight;

this_box_storage.is_rectangle = 0;
if (xwidth2 < 0 && yheight2 < 0) this_box_storage.is_rectangle = 1;
if (xwidth == xwidth2 && yheight == yheight2) this_box_storage.is_rectangle = 1;

if (xwidth2 < 0) {
    this_box_storage.x_width2 = xwidth;
    xwidth2 = xwidth;
} else this_box_storage.x_width2 = xwidth2;

if (yheight2 < 0) {
    this_box_storage.y_height2 = yheight;
    yheight2 = yheight;
} else this_box_storage.y_height2 = yheight2;


this_box_storage.normal_vectors[0] = coords_set(0,0,1);
this_box_storage.normal_vectors[1] = coords_set(0,0,1);

// for sides with y component = 0
x_component = 2*zdepth/sqrt((xwidth-xwidth2)*(xwidth-xwidth2)+4*zdepth*zdepth);
z_component = (xwidth-xwidth2)/sqrt(4*zdepth*zdepth+(xwidth-xwidth2)*(xwidth-xwidth2));

this_box_storage.normal_vectors[2] = coords_set(x_component,0,z_component);
this_box_storage.normal_vectors[3] = coords_set(-x_component,0,z_component);

// for sides with x component = 0
y_component = 2*zdepth/sqrt((yheight-yheight2)*(yheight-yheight2)+4*zdepth*zdepth);
z_component = (yheight-yheight2)/sqrt(4*zdepth*zdepth+(yheight-yheight2)*(yheight-yheight2));

this_box_storage.normal_vectors[4] = coords_set(0,y_component,z_component);
this_box_storage.normal_vectors[5] = coords_set(0,-y_component,z_component);

this_box_volume.geometry.visualization_on = visualize;

this_box_volume.geometry.geometry_parameters.p_box_storage = &this_box_storage;

// Assign pointers to functions for intersection with the shape, checking if a point is inside the shape
if (this_box_storage.is_rectangle == 1) {
this_box_volume.geometry.intersect_function = &sample_box_intersect_simple;
this_box_volume.geometry.within_function = &r_within_box_simple;
}
else {
this_box_volume.geometry.intersect_function = &sample_box_intersect_advanced;
this_box_volume.geometry.within_function = &r_within_box_advanced;
}

this_box_volume.geometry.shell_points = &box_shell_points;
this_box_volume.geometry.mcdisplay_function = &mcdisplay_box_function;
this_box_volume.geometry.initialize_from_main_function = &initialize_box_geometry_from_main_component;
this_box_volume.geometry.process_rot_allocated = 0;

this_box_volume.geometry.copy_geometry_parameters = &allocate_box_storage_copy;

rot_copy(this_box_volume.geometry.rotation_matrix,ROT_A_CURRENT_COMP); //check how ROT_R_CURRENT_COMP would work
rot_transpose(ROT_A_CURRENT_COMP,this_box_volume.geometry.transpose_rotation_matrix);

// Initialize loggers
this_box_volume.loggers.num_elements = 0;

// packing the information into the global_geometry_element, which is then included in the global_geometry_list.
sprintf(global_geometry_element.name,NAME_CURRENT_COMP);
global_geometry_element.activation_counter = number_of_activations;
global_geometry_element.component_index = INDEX_CURRENT_COMP;
global_geometry_element.Volume = &this_box_volume; // Would be nicer if this m was a pointer, now we have the (small) data two places
add_element_to_geometry_list(&global_geometry_list,global_geometry_element);
}
#line 217610 "MACS_sample_kidney_box.c"
#undef number_of_activations
#undef mask_setting
#undef mask_string
#undef p_interact
#undef focus_r
#undef focus_xh
#undef focus_xw
#undef focus_ah
#undef focus_aw
#undef target_z
#undef target_y
#undef target_x
#undef target_index
#undef visualize
#undef yheight2
#undef xwidth2
#undef zdepth
#undef yheight
#undef xwidth
#undef priority
#undef material_string
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

  /* Initializations for component channel_6_cave1_box2. */
  SIG_MESSAGE("channel_6_cave1_box2 (Init)");
#define mccompcurname  channel_6_cave1_box2
#define mccompcurtype  Union_box
#define mccompcurindex 353
#define loop_index mccchannel_6_cave1_box2_loop_index
#define this_box_volume mccchannel_6_cave1_box2_this_box_volume
#define global_geometry_element mccchannel_6_cave1_box2_global_geometry_element
#define this_box_storage mccchannel_6_cave1_box2_this_box_storage
#define material_string mccchannel_6_cave1_box2_material_string
#define priority mccchannel_6_cave1_box2_priority
#define xwidth mccchannel_6_cave1_box2_xwidth
#define yheight mccchannel_6_cave1_box2_yheight
#define zdepth mccchannel_6_cave1_box2_zdepth
#define xwidth2 mccchannel_6_cave1_box2_xwidth2
#define yheight2 mccchannel_6_cave1_box2_yheight2
#define visualize mccchannel_6_cave1_box2_visualize
#define target_index mccchannel_6_cave1_box2_target_index
#define target_x mccchannel_6_cave1_box2_target_x
#define target_y mccchannel_6_cave1_box2_target_y
#define target_z mccchannel_6_cave1_box2_target_z
#define focus_aw mccchannel_6_cave1_box2_focus_aw
#define focus_ah mccchannel_6_cave1_box2_focus_ah
#define focus_xw mccchannel_6_cave1_box2_focus_xw
#define focus_xh mccchannel_6_cave1_box2_focus_xh
#define focus_r mccchannel_6_cave1_box2_focus_r
#define p_interact mccchannel_6_cave1_box2_p_interact
#define mask_string mccchannel_6_cave1_box2_mask_string
#define mask_setting mccchannel_6_cave1_box2_mask_setting
#define number_of_activations mccchannel_6_cave1_box2_number_of_activations
#line 224 "Union_box.comp"
{
// Initializes the focusing system for this volume including input sanitation.
focus_initialize(&this_box_volume.geometry, POS_A_COMP_INDEX(INDEX_CURRENT_COMP+target_index), POS_A_CURRENT_COMP, ROT_A_CURRENT_COMP, target_index, target_x, target_y, target_z, focus_aw, focus_ah, focus_xw, focus_xh, focus_r, NAME_CURRENT_COMP);

// Input sanitation for this geometry
if (xwidth <= 0) {
  printf("\nERROR in Union_box named %s, the xwidth is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (yheight <= 0) {
  printf("\nERROR in Union_box named %s, yheight is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (zdepth <= 0) {
  printf("\nERROR in Union_box named %s, zdepth is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (xwidth2 <= 0 && xwidth2 != -1) {
  printf("\nERROR in Union_box named %s, the xwidth2 is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (yheight2 <= 0 && yheight2 != -1) {
  printf("\nERROR in Union_box named %s, yheight2 is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}

// Use sanitation
if (global_material_list.num_elements == 0) {
  printf("\nERROR: Need to define a material using Union_make_material before using a Union geometry component. \n");
  printf("       %s was defined before first use of Union_make_material.\n",NAME_CURRENT_COMP);
  exit(1);
}

this_box_volume.geometry.is_masked_volume = 0;
this_box_volume.geometry.is_exit_volume = 0;
this_box_volume.geometry.is_mask_volume = 0;
// check if the volume is a mask, if it is the material string is irelevant.
if (mask_string && strlen(mask_string) && strcmp(mask_string, "NULL") && strcmp(mask_string, "0")) {
    // A mask volume is used to limit the extend of other volumes, called the masked volumes. These are specified in the mask_string.
    // In order for a ray to enter a masked volume, it needs to be both in the region covered by that volume AND the mask volume.
    // When more than
    this_box_volume.geometry.mask_mode = 1; // Default is mask mode is ALL
    if (mask_setting && strlen(mask_setting) && strcmp(mask_setting, "NULL") && strcmp(mask_setting, "0")) {
        if (strcmp(mask_setting,"ALL") == 0 || strcmp(mask_setting,"All") == 0) this_box_volume.geometry.mask_mode = 1;
        else if (strcmp(mask_setting,"ANY") == 0 || strcmp(mask_setting,"Any") == 0) this_box_volume.geometry.mask_mode = 2;
        else {
            printf("The mask_mode of component %s is set to %s, but must be either ALL or ANY.\n",NAME_CURRENT_COMP,mask_setting);
            exit(1);
        }
    }
    
    for (loop_index=0;loop_index<global_geometry_list.num_elements;loop_index++) {
        // Add mask list
        if (1 == manual_linking_function(global_geometry_list.elements[loop_index].name,mask_string)) {
            add_element_to_int_list(&this_box_volume.geometry.mask_list,global_geometry_list.elements[loop_index].component_index);
            add_element_to_int_list(&global_geometry_list.elements[loop_index].Volume->geometry.masked_by_list,INDEX_CURRENT_COMP);
            global_geometry_list.elements[loop_index].Volume->geometry.is_masked_volume = 1;
            if (this_box_volume.geometry.mask_mode == 2)
                global_geometry_list.elements[loop_index].Volume->geometry.mask_mode = 2;
            if (this_box_volume.geometry.mask_mode == 1) {
                if (global_geometry_list.elements[loop_index].Volume->geometry.is_masked_volume == 1 && global_geometry_list.elements[loop_index].Volume->geometry.mask_mode != 2)
                    // If more than one mask is added to one volume, the ANY mode overwrites the (default) ALL mode.
                    global_geometry_list.elements[loop_index].Volume->geometry.mask_mode = 1;
            }
            
            found_geometries = 1;
        }
    }
    if (found_geometries == 0) {
        printf("The mask_string in geometry: %s did not find any of the specified volumes in the mask_string %s \n",NAME_CURRENT_COMP,mask_string);
        exit(1);
    }
    this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
    this_box_volume.p_physics->is_vacuum = 0; // Makes this volume a vacuum
    this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
    this_box_volume.p_physics->my_a = 0; // Should not be used.
    sprintf(this_box_volume.p_physics->name,"Mask");
    this_box_volume.geometry.is_mask_volume = 1;
    
    
// Read the material input, or if it lacks, use automatic linking.
} else if (material_string && strlen(material_string) && strcmp(material_string, "NULL") && strcmp(material_string, "0")) {
    // A geometry string was given, use it to determine which material
    if (0 == strcmp(material_string,"vacuum") || 0 == strcmp(material_string,"Vacuum")) {
        // One could have a global physics struct for vacuum instead of creating one for each
        this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
        this_box_volume.p_physics->is_vacuum = 1; // Makes this volume a vacuum
        this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
        this_box_volume.p_physics->my_a = 0; // Should not be used.
        sprintf(this_box_volume.p_physics->name,"Vacuum");
    } else if (0 == strcmp(material_string,"exit") || 0 == strcmp(material_string,"Exit")) {
        // One could have a global physics struct for vacuum instead of creating one for each
        this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
        this_box_volume.p_physics->is_vacuum = 1; // Makes this volume a vacuum
        this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
        this_box_volume.p_physics->my_a = 0; // Should not be used.
        this_box_volume.geometry.is_exit_volume = 1;
        sprintf(this_box_volume.p_physics->name,"Exit");
    } else {
        #ifndef MATERIAL_DETECTOR
            printf("Need to define a material before refering to it in a geometry %s.\n",NAME_CURRENT_COMP);
            exit(1);
        #endif
        for (loop_index=0;loop_index<global_material_list.num_elements;loop_index++) {
            if (0 == strcmp(material_string,global_material_list.elements[loop_index].name)) {
                this_box_volume.p_physics = global_material_list.elements[loop_index].physics;
                break;
            }
            if (loop_index == global_material_list.num_elements-1) {
            printf("\n");
            printf("ERROR: The material string \"%s\" in Union geometry \"%s\" did not match a specified material. \n",material_string,NAME_CURRENT_COMP);
            printf("       The materials available at this point (need to be defined before the geometry): \n");
            for (loop_index=0;loop_index<global_material_list.num_elements;loop_index++)
              printf("         %s\n",global_material_list.elements[loop_index].name);
            printf("\n");
            printf("       It is also possible to use one of the defualt materials avaiable: \n");
            printf("           Vacuum (for a Volume without scattering or absorption)\n");
            printf("           Exit (for a Volume where the ray exits the component if it enters)\n");
            printf("           Mask (for a Volume that masks existing volumes specified in the mask_string\n");
            exit(1);
          }
        }
    }
} else {
    // Automatic linking, simply using the last defined material.
    #ifndef MATERIAL_DETECTOR
        printf("Need to define a material before the geometry to use automatic linking %s.\n",NAME_CURRENT_COMP);
        exit(1);
    #endif
    this_box_volume.p_physics = global_material_list.elements[global_material_list.num_elements-1].physics;
}

sprintf(this_box_volume.name,NAME_CURRENT_COMP);
sprintf(this_box_volume.geometry.shape,"box");
this_box_volume.geometry.priority_value = priority;
this_box_volume.geometry.geometry_p_interact = p_interact;
// Currently the coordinates will be in absolute space.
this_box_volume.geometry.center = POS_A_CURRENT_COMP;

this_box_storage.z_depth = zdepth;
this_box_storage.x_width1 = xwidth;
this_box_storage.y_height1 = yheight;

this_box_storage.is_rectangle = 0;
if (xwidth2 < 0 && yheight2 < 0) this_box_storage.is_rectangle = 1;
if (xwidth == xwidth2 && yheight == yheight2) this_box_storage.is_rectangle = 1;

if (xwidth2 < 0) {
    this_box_storage.x_width2 = xwidth;
    xwidth2 = xwidth;
} else this_box_storage.x_width2 = xwidth2;

if (yheight2 < 0) {
    this_box_storage.y_height2 = yheight;
    yheight2 = yheight;
} else this_box_storage.y_height2 = yheight2;


this_box_storage.normal_vectors[0] = coords_set(0,0,1);
this_box_storage.normal_vectors[1] = coords_set(0,0,1);

// for sides with y component = 0
x_component = 2*zdepth/sqrt((xwidth-xwidth2)*(xwidth-xwidth2)+4*zdepth*zdepth);
z_component = (xwidth-xwidth2)/sqrt(4*zdepth*zdepth+(xwidth-xwidth2)*(xwidth-xwidth2));

this_box_storage.normal_vectors[2] = coords_set(x_component,0,z_component);
this_box_storage.normal_vectors[3] = coords_set(-x_component,0,z_component);

// for sides with x component = 0
y_component = 2*zdepth/sqrt((yheight-yheight2)*(yheight-yheight2)+4*zdepth*zdepth);
z_component = (yheight-yheight2)/sqrt(4*zdepth*zdepth+(yheight-yheight2)*(yheight-yheight2));

this_box_storage.normal_vectors[4] = coords_set(0,y_component,z_component);
this_box_storage.normal_vectors[5] = coords_set(0,-y_component,z_component);

this_box_volume.geometry.visualization_on = visualize;

this_box_volume.geometry.geometry_parameters.p_box_storage = &this_box_storage;

// Assign pointers to functions for intersection with the shape, checking if a point is inside the shape
if (this_box_storage.is_rectangle == 1) {
this_box_volume.geometry.intersect_function = &sample_box_intersect_simple;
this_box_volume.geometry.within_function = &r_within_box_simple;
}
else {
this_box_volume.geometry.intersect_function = &sample_box_intersect_advanced;
this_box_volume.geometry.within_function = &r_within_box_advanced;
}

this_box_volume.geometry.shell_points = &box_shell_points;
this_box_volume.geometry.mcdisplay_function = &mcdisplay_box_function;
this_box_volume.geometry.initialize_from_main_function = &initialize_box_geometry_from_main_component;
this_box_volume.geometry.process_rot_allocated = 0;

this_box_volume.geometry.copy_geometry_parameters = &allocate_box_storage_copy;

rot_copy(this_box_volume.geometry.rotation_matrix,ROT_A_CURRENT_COMP); //check how ROT_R_CURRENT_COMP would work
rot_transpose(ROT_A_CURRENT_COMP,this_box_volume.geometry.transpose_rotation_matrix);

// Initialize loggers
this_box_volume.loggers.num_elements = 0;

// packing the information into the global_geometry_element, which is then included in the global_geometry_list.
sprintf(global_geometry_element.name,NAME_CURRENT_COMP);
global_geometry_element.activation_counter = number_of_activations;
global_geometry_element.component_index = INDEX_CURRENT_COMP;
global_geometry_element.Volume = &this_box_volume; // Would be nicer if this m was a pointer, now we have the (small) data two places
add_element_to_geometry_list(&global_geometry_list,global_geometry_element);
}
#line 217880 "MACS_sample_kidney_box.c"
#undef number_of_activations
#undef mask_setting
#undef mask_string
#undef p_interact
#undef focus_r
#undef focus_xh
#undef focus_xw
#undef focus_ah
#undef focus_aw
#undef target_z
#undef target_y
#undef target_x
#undef target_index
#undef visualize
#undef yheight2
#undef xwidth2
#undef zdepth
#undef yheight
#undef xwidth
#undef priority
#undef material_string
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

  /* Initializations for component channel_6_cave1_box3. */
  SIG_MESSAGE("channel_6_cave1_box3 (Init)");
#define mccompcurname  channel_6_cave1_box3
#define mccompcurtype  Union_box
#define mccompcurindex 354
#define loop_index mccchannel_6_cave1_box3_loop_index
#define this_box_volume mccchannel_6_cave1_box3_this_box_volume
#define global_geometry_element mccchannel_6_cave1_box3_global_geometry_element
#define this_box_storage mccchannel_6_cave1_box3_this_box_storage
#define material_string mccchannel_6_cave1_box3_material_string
#define priority mccchannel_6_cave1_box3_priority
#define xwidth mccchannel_6_cave1_box3_xwidth
#define yheight mccchannel_6_cave1_box3_yheight
#define zdepth mccchannel_6_cave1_box3_zdepth
#define xwidth2 mccchannel_6_cave1_box3_xwidth2
#define yheight2 mccchannel_6_cave1_box3_yheight2
#define visualize mccchannel_6_cave1_box3_visualize
#define target_index mccchannel_6_cave1_box3_target_index
#define target_x mccchannel_6_cave1_box3_target_x
#define target_y mccchannel_6_cave1_box3_target_y
#define target_z mccchannel_6_cave1_box3_target_z
#define focus_aw mccchannel_6_cave1_box3_focus_aw
#define focus_ah mccchannel_6_cave1_box3_focus_ah
#define focus_xw mccchannel_6_cave1_box3_focus_xw
#define focus_xh mccchannel_6_cave1_box3_focus_xh
#define focus_r mccchannel_6_cave1_box3_focus_r
#define p_interact mccchannel_6_cave1_box3_p_interact
#define mask_string mccchannel_6_cave1_box3_mask_string
#define mask_setting mccchannel_6_cave1_box3_mask_setting
#define number_of_activations mccchannel_6_cave1_box3_number_of_activations
#line 224 "Union_box.comp"
{
// Initializes the focusing system for this volume including input sanitation.
focus_initialize(&this_box_volume.geometry, POS_A_COMP_INDEX(INDEX_CURRENT_COMP+target_index), POS_A_CURRENT_COMP, ROT_A_CURRENT_COMP, target_index, target_x, target_y, target_z, focus_aw, focus_ah, focus_xw, focus_xh, focus_r, NAME_CURRENT_COMP);

// Input sanitation for this geometry
if (xwidth <= 0) {
  printf("\nERROR in Union_box named %s, the xwidth is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (yheight <= 0) {
  printf("\nERROR in Union_box named %s, yheight is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (zdepth <= 0) {
  printf("\nERROR in Union_box named %s, zdepth is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (xwidth2 <= 0 && xwidth2 != -1) {
  printf("\nERROR in Union_box named %s, the xwidth2 is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (yheight2 <= 0 && yheight2 != -1) {
  printf("\nERROR in Union_box named %s, yheight2 is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}

// Use sanitation
if (global_material_list.num_elements == 0) {
  printf("\nERROR: Need to define a material using Union_make_material before using a Union geometry component. \n");
  printf("       %s was defined before first use of Union_make_material.\n",NAME_CURRENT_COMP);
  exit(1);
}

this_box_volume.geometry.is_masked_volume = 0;
this_box_volume.geometry.is_exit_volume = 0;
this_box_volume.geometry.is_mask_volume = 0;
// check if the volume is a mask, if it is the material string is irelevant.
if (mask_string && strlen(mask_string) && strcmp(mask_string, "NULL") && strcmp(mask_string, "0")) {
    // A mask volume is used to limit the extend of other volumes, called the masked volumes. These are specified in the mask_string.
    // In order for a ray to enter a masked volume, it needs to be both in the region covered by that volume AND the mask volume.
    // When more than
    this_box_volume.geometry.mask_mode = 1; // Default is mask mode is ALL
    if (mask_setting && strlen(mask_setting) && strcmp(mask_setting, "NULL") && strcmp(mask_setting, "0")) {
        if (strcmp(mask_setting,"ALL") == 0 || strcmp(mask_setting,"All") == 0) this_box_volume.geometry.mask_mode = 1;
        else if (strcmp(mask_setting,"ANY") == 0 || strcmp(mask_setting,"Any") == 0) this_box_volume.geometry.mask_mode = 2;
        else {
            printf("The mask_mode of component %s is set to %s, but must be either ALL or ANY.\n",NAME_CURRENT_COMP,mask_setting);
            exit(1);
        }
    }
    
    for (loop_index=0;loop_index<global_geometry_list.num_elements;loop_index++) {
        // Add mask list
        if (1 == manual_linking_function(global_geometry_list.elements[loop_index].name,mask_string)) {
            add_element_to_int_list(&this_box_volume.geometry.mask_list,global_geometry_list.elements[loop_index].component_index);
            add_element_to_int_list(&global_geometry_list.elements[loop_index].Volume->geometry.masked_by_list,INDEX_CURRENT_COMP);
            global_geometry_list.elements[loop_index].Volume->geometry.is_masked_volume = 1;
            if (this_box_volume.geometry.mask_mode == 2)
                global_geometry_list.elements[loop_index].Volume->geometry.mask_mode = 2;
            if (this_box_volume.geometry.mask_mode == 1) {
                if (global_geometry_list.elements[loop_index].Volume->geometry.is_masked_volume == 1 && global_geometry_list.elements[loop_index].Volume->geometry.mask_mode != 2)
                    // If more than one mask is added to one volume, the ANY mode overwrites the (default) ALL mode.
                    global_geometry_list.elements[loop_index].Volume->geometry.mask_mode = 1;
            }
            
            found_geometries = 1;
        }
    }
    if (found_geometries == 0) {
        printf("The mask_string in geometry: %s did not find any of the specified volumes in the mask_string %s \n",NAME_CURRENT_COMP,mask_string);
        exit(1);
    }
    this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
    this_box_volume.p_physics->is_vacuum = 0; // Makes this volume a vacuum
    this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
    this_box_volume.p_physics->my_a = 0; // Should not be used.
    sprintf(this_box_volume.p_physics->name,"Mask");
    this_box_volume.geometry.is_mask_volume = 1;
    
    
// Read the material input, or if it lacks, use automatic linking.
} else if (material_string && strlen(material_string) && strcmp(material_string, "NULL") && strcmp(material_string, "0")) {
    // A geometry string was given, use it to determine which material
    if (0 == strcmp(material_string,"vacuum") || 0 == strcmp(material_string,"Vacuum")) {
        // One could have a global physics struct for vacuum instead of creating one for each
        this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
        this_box_volume.p_physics->is_vacuum = 1; // Makes this volume a vacuum
        this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
        this_box_volume.p_physics->my_a = 0; // Should not be used.
        sprintf(this_box_volume.p_physics->name,"Vacuum");
    } else if (0 == strcmp(material_string,"exit") || 0 == strcmp(material_string,"Exit")) {
        // One could have a global physics struct for vacuum instead of creating one for each
        this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
        this_box_volume.p_physics->is_vacuum = 1; // Makes this volume a vacuum
        this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
        this_box_volume.p_physics->my_a = 0; // Should not be used.
        this_box_volume.geometry.is_exit_volume = 1;
        sprintf(this_box_volume.p_physics->name,"Exit");
    } else {
        #ifndef MATERIAL_DETECTOR
            printf("Need to define a material before refering to it in a geometry %s.\n",NAME_CURRENT_COMP);
            exit(1);
        #endif
        for (loop_index=0;loop_index<global_material_list.num_elements;loop_index++) {
            if (0 == strcmp(material_string,global_material_list.elements[loop_index].name)) {
                this_box_volume.p_physics = global_material_list.elements[loop_index].physics;
                break;
            }
            if (loop_index == global_material_list.num_elements-1) {
            printf("\n");
            printf("ERROR: The material string \"%s\" in Union geometry \"%s\" did not match a specified material. \n",material_string,NAME_CURRENT_COMP);
            printf("       The materials available at this point (need to be defined before the geometry): \n");
            for (loop_index=0;loop_index<global_material_list.num_elements;loop_index++)
              printf("         %s\n",global_material_list.elements[loop_index].name);
            printf("\n");
            printf("       It is also possible to use one of the defualt materials avaiable: \n");
            printf("           Vacuum (for a Volume without scattering or absorption)\n");
            printf("           Exit (for a Volume where the ray exits the component if it enters)\n");
            printf("           Mask (for a Volume that masks existing volumes specified in the mask_string\n");
            exit(1);
          }
        }
    }
} else {
    // Automatic linking, simply using the last defined material.
    #ifndef MATERIAL_DETECTOR
        printf("Need to define a material before the geometry to use automatic linking %s.\n",NAME_CURRENT_COMP);
        exit(1);
    #endif
    this_box_volume.p_physics = global_material_list.elements[global_material_list.num_elements-1].physics;
}

sprintf(this_box_volume.name,NAME_CURRENT_COMP);
sprintf(this_box_volume.geometry.shape,"box");
this_box_volume.geometry.priority_value = priority;
this_box_volume.geometry.geometry_p_interact = p_interact;
// Currently the coordinates will be in absolute space.
this_box_volume.geometry.center = POS_A_CURRENT_COMP;

this_box_storage.z_depth = zdepth;
this_box_storage.x_width1 = xwidth;
this_box_storage.y_height1 = yheight;

this_box_storage.is_rectangle = 0;
if (xwidth2 < 0 && yheight2 < 0) this_box_storage.is_rectangle = 1;
if (xwidth == xwidth2 && yheight == yheight2) this_box_storage.is_rectangle = 1;

if (xwidth2 < 0) {
    this_box_storage.x_width2 = xwidth;
    xwidth2 = xwidth;
} else this_box_storage.x_width2 = xwidth2;

if (yheight2 < 0) {
    this_box_storage.y_height2 = yheight;
    yheight2 = yheight;
} else this_box_storage.y_height2 = yheight2;


this_box_storage.normal_vectors[0] = coords_set(0,0,1);
this_box_storage.normal_vectors[1] = coords_set(0,0,1);

// for sides with y component = 0
x_component = 2*zdepth/sqrt((xwidth-xwidth2)*(xwidth-xwidth2)+4*zdepth*zdepth);
z_component = (xwidth-xwidth2)/sqrt(4*zdepth*zdepth+(xwidth-xwidth2)*(xwidth-xwidth2));

this_box_storage.normal_vectors[2] = coords_set(x_component,0,z_component);
this_box_storage.normal_vectors[3] = coords_set(-x_component,0,z_component);

// for sides with x component = 0
y_component = 2*zdepth/sqrt((yheight-yheight2)*(yheight-yheight2)+4*zdepth*zdepth);
z_component = (yheight-yheight2)/sqrt(4*zdepth*zdepth+(yheight-yheight2)*(yheight-yheight2));

this_box_storage.normal_vectors[4] = coords_set(0,y_component,z_component);
this_box_storage.normal_vectors[5] = coords_set(0,-y_component,z_component);

this_box_volume.geometry.visualization_on = visualize;

this_box_volume.geometry.geometry_parameters.p_box_storage = &this_box_storage;

// Assign pointers to functions for intersection with the shape, checking if a point is inside the shape
if (this_box_storage.is_rectangle == 1) {
this_box_volume.geometry.intersect_function = &sample_box_intersect_simple;
this_box_volume.geometry.within_function = &r_within_box_simple;
}
else {
this_box_volume.geometry.intersect_function = &sample_box_intersect_advanced;
this_box_volume.geometry.within_function = &r_within_box_advanced;
}

this_box_volume.geometry.shell_points = &box_shell_points;
this_box_volume.geometry.mcdisplay_function = &mcdisplay_box_function;
this_box_volume.geometry.initialize_from_main_function = &initialize_box_geometry_from_main_component;
this_box_volume.geometry.process_rot_allocated = 0;

this_box_volume.geometry.copy_geometry_parameters = &allocate_box_storage_copy;

rot_copy(this_box_volume.geometry.rotation_matrix,ROT_A_CURRENT_COMP); //check how ROT_R_CURRENT_COMP would work
rot_transpose(ROT_A_CURRENT_COMP,this_box_volume.geometry.transpose_rotation_matrix);

// Initialize loggers
this_box_volume.loggers.num_elements = 0;

// packing the information into the global_geometry_element, which is then included in the global_geometry_list.
sprintf(global_geometry_element.name,NAME_CURRENT_COMP);
global_geometry_element.activation_counter = number_of_activations;
global_geometry_element.component_index = INDEX_CURRENT_COMP;
global_geometry_element.Volume = &this_box_volume; // Would be nicer if this m was a pointer, now we have the (small) data two places
add_element_to_geometry_list(&global_geometry_list,global_geometry_element);
}
#line 218150 "MACS_sample_kidney_box.c"
#undef number_of_activations
#undef mask_setting
#undef mask_string
#undef p_interact
#undef focus_r
#undef focus_xh
#undef focus_xw
#undef focus_ah
#undef focus_aw
#undef target_z
#undef target_y
#undef target_x
#undef target_index
#undef visualize
#undef yheight2
#undef xwidth2
#undef zdepth
#undef yheight
#undef xwidth
#undef priority
#undef material_string
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

  /* Initializations for component channel_6_cave1_cyl1. */
  SIG_MESSAGE("channel_6_cave1_cyl1 (Init)");
#define mccompcurname  channel_6_cave1_cyl1
#define mccompcurtype  Union_cylinder
#define mccompcurindex 355
#define loop_index mccchannel_6_cave1_cyl1_loop_index
#define this_cylinder_volume mccchannel_6_cave1_cyl1_this_cylinder_volume
#define global_geometry_element mccchannel_6_cave1_cyl1_global_geometry_element
#define this_cylinder_storage mccchannel_6_cave1_cyl1_this_cylinder_storage
#define material_string mccchannel_6_cave1_cyl1_material_string
#define priority mccchannel_6_cave1_cyl1_priority
#define radius mccchannel_6_cave1_cyl1_radius
#define yheight mccchannel_6_cave1_cyl1_yheight
#define visualize mccchannel_6_cave1_cyl1_visualize
#define target_index mccchannel_6_cave1_cyl1_target_index
#define target_x mccchannel_6_cave1_cyl1_target_x
#define target_y mccchannel_6_cave1_cyl1_target_y
#define target_z mccchannel_6_cave1_cyl1_target_z
#define focus_aw mccchannel_6_cave1_cyl1_focus_aw
#define focus_ah mccchannel_6_cave1_cyl1_focus_ah
#define focus_xw mccchannel_6_cave1_cyl1_focus_xw
#define focus_xh mccchannel_6_cave1_cyl1_focus_xh
#define focus_r mccchannel_6_cave1_cyl1_focus_r
#define p_interact mccchannel_6_cave1_cyl1_p_interact
#define mask_string mccchannel_6_cave1_cyl1_mask_string
#define mask_setting mccchannel_6_cave1_cyl1_mask_setting
#define number_of_activations mccchannel_6_cave1_cyl1_number_of_activations
#line 185 "Union_cylinder.comp"
{
// Initializes the focusing system for this volume including input sanitation.
focus_initialize(&this_cylinder_volume.geometry, POS_A_COMP_INDEX(INDEX_CURRENT_COMP+target_index), POS_A_CURRENT_COMP, ROT_A_CURRENT_COMP, target_index, target_x, target_y, target_z, focus_aw, focus_ah, focus_xw, focus_xh, focus_r, NAME_CURRENT_COMP);

// Input sanitation for this geometry
if (radius <= 0) {
  printf("\nERROR in Union_cylinder named %s, the radius is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}

if (yheight <= 0) {
  printf("\nERROR in Union_cylinder named %s, yheight is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}

// Use sanitation
#ifdef MATERIAL_DETECTOR
if (global_material_list.num_elements == 0) {
  // Here if the user have defined a material, but only after this material
  printf("\nERROR: Need to define a material using Union_make_material before using a Union geometry component. \n");
  printf("       %s was defined before first use of Union_make_material.\n",NAME_CURRENT_COMP);
  exit(1);
}
#endif
#ifndef MATERIAL_DETECTOR
  printf("\nERROR: Need to define a material using Union_make_material before using a Union geometry component. \n");
  exit(1);
#endif


this_cylinder_volume.geometry.is_masked_volume = 0;
this_cylinder_volume.geometry.is_exit_volume = 0;
this_cylinder_volume.geometry.is_mask_volume = 0;

// Read the material input, or if it lacks, use automatic linking.
if (mask_string && strlen(mask_string) && strcmp(mask_string, "NULL") && strcmp(mask_string, "0")) {
    // A mask volume is used to limit the extend of other volumes, called the masked volumes. These are specified in the mask_string.
    // In order for a ray to enter a masked volume, it needs to be both in the region covered by that volume AND the mask volume.
    // When more than
    this_cylinder_volume.geometry.mask_mode = 1; // Default is mask mode is ALL
    if (mask_setting && strlen(mask_setting) && strcmp(mask_setting, "NULL") && strcmp(mask_setting, "0")) {
        if (strcmp(mask_setting,"ALL") == 0 || strcmp(mask_setting,"All") == 0) this_cylinder_volume.geometry.mask_mode = 1;
        else if (strcmp(mask_setting,"ANY") == 0 || strcmp(mask_setting,"Any") == 0) this_cylinder_volume.geometry.mask_mode = 2;
        else {
            printf("The mask_mode of component %s is set to %s, but must be either ALL or ANY.\n",NAME_CURRENT_COMP,mask_setting);
            exit(1);
        }
    }
    
    for (loop_index=0;loop_index<global_geometry_list.num_elements;loop_index++) {
        // Add mask list
        if (1 == manual_linking_function(global_geometry_list.elements[loop_index].name,mask_string)) {
            add_element_to_int_list(&this_cylinder_volume.geometry.mask_list,global_geometry_list.elements[loop_index].component_index);
            add_element_to_int_list(&global_geometry_list.elements[loop_index].Volume->geometry.masked_by_list,INDEX_CURRENT_COMP);
            global_geometry_list.elements[loop_index].Volume->geometry.is_masked_volume = 1;
            if (this_cylinder_volume.geometry.mask_mode == 2)
                global_geometry_list.elements[loop_index].Volume->geometry.mask_mode = 2;
            if (this_cylinder_volume.geometry.mask_mode == 1) {
                if (global_geometry_list.elements[loop_index].Volume->geometry.is_masked_volume == 1 && global_geometry_list.elements[loop_index].Volume->geometry.mask_mode != 2)
                    // If more than one mask is added to one volume, the ANY mode overwrites the (default) ALL mode.
                    global_geometry_list.elements[loop_index].Volume->geometry.mask_mode = 1;
            }
            
            found_geometries = 1;
        }
    }
    if (found_geometries == 0) {
        printf("The mask_string in geometry: %s did not find any of the specified volumes in the mask_string %s \n",NAME_CURRENT_COMP,mask_string);
        exit(1);
    }
    this_cylinder_volume.p_physics = malloc(sizeof(struct physics_struct));
    this_cylinder_volume.p_physics->is_vacuum = 0; // Makes this volume a vacuum
    this_cylinder_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
    this_cylinder_volume.p_physics->my_a = 0; // Should not be used.
    sprintf(this_cylinder_volume.p_physics->name,"Mask");
    this_cylinder_volume.geometry.is_mask_volume = 1;
    
    
// Read the material input, or if it lacks, use automatic linking.
} else if (material_string && strlen(material_string) && strcmp(material_string, "NULL") && strcmp(material_string, "0")) {
    // A geometry string was given, use it to determine which material
    if (0 == strcmp(material_string,"vacuum") || 0 == strcmp(material_string,"Vacuum")) {
        // One could have a global physics struct for vacuum instead of creating one for each
        this_cylinder_volume.p_physics = malloc(sizeof(struct physics_struct));
        this_cylinder_volume.p_physics->is_vacuum = 1; // Makes this volume a vacuum
        this_cylinder_volume.p_physics->number_of_processes = (int) 0;
        this_cylinder_volume.p_physics->my_a = 0; // Should not be used.
        sprintf(this_cylinder_volume.p_physics->name,"Vacuum");
    } else if (0 == strcmp(material_string,"exit") || 0 == strcmp(material_string,"Exit")) {
        // One could have a global physics struct for exit instead of creating one for each
        this_cylinder_volume.p_physics = malloc(sizeof(struct physics_struct));
        this_cylinder_volume.p_physics->is_vacuum = 1; // Makes this volume a vacuum
        this_cylinder_volume.p_physics->number_of_processes = (int) 0;
        this_cylinder_volume.p_physics->my_a = 0; // Should not be used.
        this_cylinder_volume.geometry.is_exit_volume = 1;
        sprintf(this_cylinder_volume.p_physics->name,"Exit");
    } else {
        for (loop_index=0;loop_index<global_material_list.num_elements;loop_index++) {
          if (0 == strcmp(material_string,global_material_list.elements[loop_index].name)) {
            this_cylinder_volume.p_physics = global_material_list.elements[loop_index].physics;
            break;
          }
          if (loop_index == global_material_list.num_elements-1) {
            printf("\n");
            printf("ERROR: The material string \"%s\" in Union geometry \"%s\" did not match a specified material. \n",material_string,NAME_CURRENT_COMP);
            printf("       The materials available at this point (need to be defined before the geometry): \n");
            for (loop_index=0;loop_index<global_material_list.num_elements;loop_index++)
              printf("         %s\n",global_material_list.elements[loop_index].name);
            printf("\n");
            printf("       It is also possible to use one of the defualt materials avaiable: \n");
            printf("           Vacuum (for a Volume without scattering or absorption)\n");
            printf("           Exit (for a Volume where the ray exits the component if it enters)\n");
            printf("           Mask (for a Volume that masks existing volumes specified in the mask_string\n");
            exit(1);
          }
        }
    }
} else {
    // Automatic linking, simply using the last defined material.
    #ifndef MATERIAL_DETECTOR
        printf("Need to define a material before the geometry to use automatic linking %s.\n",NAME_CURRENT_COMP);
        exit(1);
    #endif
    this_cylinder_volume.p_physics = global_material_list.elements[global_material_list.num_elements-1].physics;
}

sprintf(this_cylinder_volume.name,NAME_CURRENT_COMP);
sprintf(this_cylinder_volume.geometry.shape,"cylinder");
this_cylinder_volume.geometry.priority_value = priority;
// Currently the coordinates will be in absolute space.
this_cylinder_volume.geometry.center = POS_A_CURRENT_COMP;

this_cylinder_volume.geometry.geometry_p_interact = p_interact;
this_cylinder_storage.cyl_radius = radius;
this_cylinder_storage.height = yheight;
this_cylinder_volume.geometry.visualization_on = visualize;
this_cylinder_volume.geometry.geometry_parameters.p_cylinder_storage = &this_cylinder_storage;
this_cylinder_volume.geometry.within_function = &r_within_cylinder;
this_cylinder_volume.geometry.intersect_function = &sample_cylinder_intersect;
this_cylinder_volume.geometry.mcdisplay_function = &mcdisplay_cylinder_function;
this_cylinder_volume.geometry.shell_points = &cylinder_shell_points;
this_cylinder_volume.geometry.initialize_from_main_function = &initialize_cylinder_geometry_from_main_component;
this_cylinder_volume.geometry.process_rot_allocated = 0;
this_cylinder_volume.geometry.copy_geometry_parameters = &allocate_cylinder_storage_copy;

rot_copy(this_cylinder_volume.geometry.rotation_matrix,ROT_A_CURRENT_COMP);
rot_transpose(ROT_A_CURRENT_COMP,this_cylinder_volume.geometry.transpose_rotation_matrix);

// Initialize loggers
this_cylinder_volume.loggers.num_elements = 0;

// packing the information into the global_geometry_element, which is then included in the global_geometry_list.
sprintf(global_geometry_element.name,NAME_CURRENT_COMP);
global_geometry_element.activation_counter = number_of_activations;
global_geometry_element.component_index = INDEX_CURRENT_COMP;
global_geometry_element.Volume = &this_cylinder_volume; // Would be nicer if this m was a pointer, now we have the (small) data two places
add_element_to_geometry_list(&global_geometry_list,global_geometry_element);
}
#line 218366 "MACS_sample_kidney_box.c"
#undef number_of_activations
#undef mask_setting
#undef mask_string
#undef p_interact
#undef focus_r
#undef focus_xh
#undef focus_xw
#undef focus_ah
#undef focus_aw
#undef target_z
#undef target_y
#undef target_x
#undef target_index
#undef visualize
#undef yheight
#undef radius
#undef priority
#undef material_string
#undef this_cylinder_storage
#undef global_geometry_element
#undef this_cylinder_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

  /* Initializations for component channel_6_analyzer_1_center. */
  SIG_MESSAGE("channel_6_analyzer_1_center (Init)");

  /* Initializations for component channel_6_analyzer_1_rotated. */
  SIG_MESSAGE("channel_6_analyzer_1_rotated (Init)");

  /* Initializations for component channel_6_analyzer_1_array_crystal_array_0. */
  SIG_MESSAGE("channel_6_analyzer_1_array_crystal_array_0 (Init)");
#define mccompcurname  channel_6_analyzer_1_array_crystal_array_0
#define mccompcurtype  Union_box
#define mccompcurindex 358
#define loop_index mccchannel_6_analyzer_1_array_crystal_array_0_loop_index
#define this_box_volume mccchannel_6_analyzer_1_array_crystal_array_0_this_box_volume
#define global_geometry_element mccchannel_6_analyzer_1_array_crystal_array_0_global_geometry_element
#define this_box_storage mccchannel_6_analyzer_1_array_crystal_array_0_this_box_storage
#define material_string mccchannel_6_analyzer_1_array_crystal_array_0_material_string
#define priority mccchannel_6_analyzer_1_array_crystal_array_0_priority
#define xwidth mccchannel_6_analyzer_1_array_crystal_array_0_xwidth
#define yheight mccchannel_6_analyzer_1_array_crystal_array_0_yheight
#define zdepth mccchannel_6_analyzer_1_array_crystal_array_0_zdepth
#define xwidth2 mccchannel_6_analyzer_1_array_crystal_array_0_xwidth2
#define yheight2 mccchannel_6_analyzer_1_array_crystal_array_0_yheight2
#define visualize mccchannel_6_analyzer_1_array_crystal_array_0_visualize
#define target_index mccchannel_6_analyzer_1_array_crystal_array_0_target_index
#define target_x mccchannel_6_analyzer_1_array_crystal_array_0_target_x
#define target_y mccchannel_6_analyzer_1_array_crystal_array_0_target_y
#define target_z mccchannel_6_analyzer_1_array_crystal_array_0_target_z
#define focus_aw mccchannel_6_analyzer_1_array_crystal_array_0_focus_aw
#define focus_ah mccchannel_6_analyzer_1_array_crystal_array_0_focus_ah
#define focus_xw mccchannel_6_analyzer_1_array_crystal_array_0_focus_xw
#define focus_xh mccchannel_6_analyzer_1_array_crystal_array_0_focus_xh
#define focus_r mccchannel_6_analyzer_1_array_crystal_array_0_focus_r
#define p_interact mccchannel_6_analyzer_1_array_crystal_array_0_p_interact
#define mask_string mccchannel_6_analyzer_1_array_crystal_array_0_mask_string
#define mask_setting mccchannel_6_analyzer_1_array_crystal_array_0_mask_setting
#define number_of_activations mccchannel_6_analyzer_1_array_crystal_array_0_number_of_activations
#line 224 "Union_box.comp"
{
// Initializes the focusing system for this volume including input sanitation.
focus_initialize(&this_box_volume.geometry, POS_A_COMP_INDEX(INDEX_CURRENT_COMP+target_index), POS_A_CURRENT_COMP, ROT_A_CURRENT_COMP, target_index, target_x, target_y, target_z, focus_aw, focus_ah, focus_xw, focus_xh, focus_r, NAME_CURRENT_COMP);

// Input sanitation for this geometry
if (xwidth <= 0) {
  printf("\nERROR in Union_box named %s, the xwidth is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (yheight <= 0) {
  printf("\nERROR in Union_box named %s, yheight is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (zdepth <= 0) {
  printf("\nERROR in Union_box named %s, zdepth is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (xwidth2 <= 0 && xwidth2 != -1) {
  printf("\nERROR in Union_box named %s, the xwidth2 is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (yheight2 <= 0 && yheight2 != -1) {
  printf("\nERROR in Union_box named %s, yheight2 is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}

// Use sanitation
if (global_material_list.num_elements == 0) {
  printf("\nERROR: Need to define a material using Union_make_material before using a Union geometry component. \n");
  printf("       %s was defined before first use of Union_make_material.\n",NAME_CURRENT_COMP);
  exit(1);
}

this_box_volume.geometry.is_masked_volume = 0;
this_box_volume.geometry.is_exit_volume = 0;
this_box_volume.geometry.is_mask_volume = 0;
// check if the volume is a mask, if it is the material string is irelevant.
if (mask_string && strlen(mask_string) && strcmp(mask_string, "NULL") && strcmp(mask_string, "0")) {
    // A mask volume is used to limit the extend of other volumes, called the masked volumes. These are specified in the mask_string.
    // In order for a ray to enter a masked volume, it needs to be both in the region covered by that volume AND the mask volume.
    // When more than
    this_box_volume.geometry.mask_mode = 1; // Default is mask mode is ALL
    if (mask_setting && strlen(mask_setting) && strcmp(mask_setting, "NULL") && strcmp(mask_setting, "0")) {
        if (strcmp(mask_setting,"ALL") == 0 || strcmp(mask_setting,"All") == 0) this_box_volume.geometry.mask_mode = 1;
        else if (strcmp(mask_setting,"ANY") == 0 || strcmp(mask_setting,"Any") == 0) this_box_volume.geometry.mask_mode = 2;
        else {
            printf("The mask_mode of component %s is set to %s, but must be either ALL or ANY.\n",NAME_CURRENT_COMP,mask_setting);
            exit(1);
        }
    }
    
    for (loop_index=0;loop_index<global_geometry_list.num_elements;loop_index++) {
        // Add mask list
        if (1 == manual_linking_function(global_geometry_list.elements[loop_index].name,mask_string)) {
            add_element_to_int_list(&this_box_volume.geometry.mask_list,global_geometry_list.elements[loop_index].component_index);
            add_element_to_int_list(&global_geometry_list.elements[loop_index].Volume->geometry.masked_by_list,INDEX_CURRENT_COMP);
            global_geometry_list.elements[loop_index].Volume->geometry.is_masked_volume = 1;
            if (this_box_volume.geometry.mask_mode == 2)
                global_geometry_list.elements[loop_index].Volume->geometry.mask_mode = 2;
            if (this_box_volume.geometry.mask_mode == 1) {
                if (global_geometry_list.elements[loop_index].Volume->geometry.is_masked_volume == 1 && global_geometry_list.elements[loop_index].Volume->geometry.mask_mode != 2)
                    // If more than one mask is added to one volume, the ANY mode overwrites the (default) ALL mode.
                    global_geometry_list.elements[loop_index].Volume->geometry.mask_mode = 1;
            }
            
            found_geometries = 1;
        }
    }
    if (found_geometries == 0) {
        printf("The mask_string in geometry: %s did not find any of the specified volumes in the mask_string %s \n",NAME_CURRENT_COMP,mask_string);
        exit(1);
    }
    this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
    this_box_volume.p_physics->is_vacuum = 0; // Makes this volume a vacuum
    this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
    this_box_volume.p_physics->my_a = 0; // Should not be used.
    sprintf(this_box_volume.p_physics->name,"Mask");
    this_box_volume.geometry.is_mask_volume = 1;
    
    
// Read the material input, or if it lacks, use automatic linking.
} else if (material_string && strlen(material_string) && strcmp(material_string, "NULL") && strcmp(material_string, "0")) {
    // A geometry string was given, use it to determine which material
    if (0 == strcmp(material_string,"vacuum") || 0 == strcmp(material_string,"Vacuum")) {
        // One could have a global physics struct for vacuum instead of creating one for each
        this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
        this_box_volume.p_physics->is_vacuum = 1; // Makes this volume a vacuum
        this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
        this_box_volume.p_physics->my_a = 0; // Should not be used.
        sprintf(this_box_volume.p_physics->name,"Vacuum");
    } else if (0 == strcmp(material_string,"exit") || 0 == strcmp(material_string,"Exit")) {
        // One could have a global physics struct for vacuum instead of creating one for each
        this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
        this_box_volume.p_physics->is_vacuum = 1; // Makes this volume a vacuum
        this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
        this_box_volume.p_physics->my_a = 0; // Should not be used.
        this_box_volume.geometry.is_exit_volume = 1;
        sprintf(this_box_volume.p_physics->name,"Exit");
    } else {
        #ifndef MATERIAL_DETECTOR
            printf("Need to define a material before refering to it in a geometry %s.\n",NAME_CURRENT_COMP);
            exit(1);
        #endif
        for (loop_index=0;loop_index<global_material_list.num_elements;loop_index++) {
            if (0 == strcmp(material_string,global_material_list.elements[loop_index].name)) {
                this_box_volume.p_physics = global_material_list.elements[loop_index].physics;
                break;
            }
            if (loop_index == global_material_list.num_elements-1) {
            printf("\n");
            printf("ERROR: The material string \"%s\" in Union geometry \"%s\" did not match a specified material. \n",material_string,NAME_CURRENT_COMP);
            printf("       The materials available at this point (need to be defined before the geometry): \n");
            for (loop_index=0;loop_index<global_material_list.num_elements;loop_index++)
              printf("         %s\n",global_material_list.elements[loop_index].name);
            printf("\n");
            printf("       It is also possible to use one of the defualt materials avaiable: \n");
            printf("           Vacuum (for a Volume without scattering or absorption)\n");
            printf("           Exit (for a Volume where the ray exits the component if it enters)\n");
            printf("           Mask (for a Volume that masks existing volumes specified in the mask_string\n");
            exit(1);
          }
        }
    }
} else {
    // Automatic linking, simply using the last defined material.
    #ifndef MATERIAL_DETECTOR
        printf("Need to define a material before the geometry to use automatic linking %s.\n",NAME_CURRENT_COMP);
        exit(1);
    #endif
    this_box_volume.p_physics = global_material_list.elements[global_material_list.num_elements-1].physics;
}

sprintf(this_box_volume.name,NAME_CURRENT_COMP);
sprintf(this_box_volume.geometry.shape,"box");
this_box_volume.geometry.priority_value = priority;
this_box_volume.geometry.geometry_p_interact = p_interact;
// Currently the coordinates will be in absolute space.
this_box_volume.geometry.center = POS_A_CURRENT_COMP;

this_box_storage.z_depth = zdepth;
this_box_storage.x_width1 = xwidth;
this_box_storage.y_height1 = yheight;

this_box_storage.is_rectangle = 0;
if (xwidth2 < 0 && yheight2 < 0) this_box_storage.is_rectangle = 1;
if (xwidth == xwidth2 && yheight == yheight2) this_box_storage.is_rectangle = 1;

if (xwidth2 < 0) {
    this_box_storage.x_width2 = xwidth;
    xwidth2 = xwidth;
} else this_box_storage.x_width2 = xwidth2;

if (yheight2 < 0) {
    this_box_storage.y_height2 = yheight;
    yheight2 = yheight;
} else this_box_storage.y_height2 = yheight2;


this_box_storage.normal_vectors[0] = coords_set(0,0,1);
this_box_storage.normal_vectors[1] = coords_set(0,0,1);

// for sides with y component = 0
x_component = 2*zdepth/sqrt((xwidth-xwidth2)*(xwidth-xwidth2)+4*zdepth*zdepth);
z_component = (xwidth-xwidth2)/sqrt(4*zdepth*zdepth+(xwidth-xwidth2)*(xwidth-xwidth2));

this_box_storage.normal_vectors[2] = coords_set(x_component,0,z_component);
this_box_storage.normal_vectors[3] = coords_set(-x_component,0,z_component);

// for sides with x component = 0
y_component = 2*zdepth/sqrt((yheight-yheight2)*(yheight-yheight2)+4*zdepth*zdepth);
z_component = (yheight-yheight2)/sqrt(4*zdepth*zdepth+(yheight-yheight2)*(yheight-yheight2));

this_box_storage.normal_vectors[4] = coords_set(0,y_component,z_component);
this_box_storage.normal_vectors[5] = coords_set(0,-y_component,z_component);

this_box_volume.geometry.visualization_on = visualize;

this_box_volume.geometry.geometry_parameters.p_box_storage = &this_box_storage;

// Assign pointers to functions for intersection with the shape, checking if a point is inside the shape
if (this_box_storage.is_rectangle == 1) {
this_box_volume.geometry.intersect_function = &sample_box_intersect_simple;
this_box_volume.geometry.within_function = &r_within_box_simple;
}
else {
this_box_volume.geometry.intersect_function = &sample_box_intersect_advanced;
this_box_volume.geometry.within_function = &r_within_box_advanced;
}

this_box_volume.geometry.shell_points = &box_shell_points;
this_box_volume.geometry.mcdisplay_function = &mcdisplay_box_function;
this_box_volume.geometry.initialize_from_main_function = &initialize_box_geometry_from_main_component;
this_box_volume.geometry.process_rot_allocated = 0;

this_box_volume.geometry.copy_geometry_parameters = &allocate_box_storage_copy;

rot_copy(this_box_volume.geometry.rotation_matrix,ROT_A_CURRENT_COMP); //check how ROT_R_CURRENT_COMP would work
rot_transpose(ROT_A_CURRENT_COMP,this_box_volume.geometry.transpose_rotation_matrix);

// Initialize loggers
this_box_volume.loggers.num_elements = 0;

// packing the information into the global_geometry_element, which is then included in the global_geometry_list.
sprintf(global_geometry_element.name,NAME_CURRENT_COMP);
global_geometry_element.activation_counter = number_of_activations;
global_geometry_element.component_index = INDEX_CURRENT_COMP;
global_geometry_element.Volume = &this_box_volume; // Would be nicer if this m was a pointer, now we have the (small) data two places
add_element_to_geometry_list(&global_geometry_list,global_geometry_element);
}
#line 218639 "MACS_sample_kidney_box.c"
#undef number_of_activations
#undef mask_setting
#undef mask_string
#undef p_interact
#undef focus_r
#undef focus_xh
#undef focus_xw
#undef focus_ah
#undef focus_aw
#undef target_z
#undef target_y
#undef target_x
#undef target_index
#undef visualize
#undef yheight2
#undef xwidth2
#undef zdepth
#undef yheight
#undef xwidth
#undef priority
#undef material_string
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

  /* Initializations for component channel_6_analyzer_1_array_crystal_array_1. */
  SIG_MESSAGE("channel_6_analyzer_1_array_crystal_array_1 (Init)");
#define mccompcurname  channel_6_analyzer_1_array_crystal_array_1
#define mccompcurtype  Union_box
#define mccompcurindex 359
#define loop_index mccchannel_6_analyzer_1_array_crystal_array_1_loop_index
#define this_box_volume mccchannel_6_analyzer_1_array_crystal_array_1_this_box_volume
#define global_geometry_element mccchannel_6_analyzer_1_array_crystal_array_1_global_geometry_element
#define this_box_storage mccchannel_6_analyzer_1_array_crystal_array_1_this_box_storage
#define material_string mccchannel_6_analyzer_1_array_crystal_array_1_material_string
#define priority mccchannel_6_analyzer_1_array_crystal_array_1_priority
#define xwidth mccchannel_6_analyzer_1_array_crystal_array_1_xwidth
#define yheight mccchannel_6_analyzer_1_array_crystal_array_1_yheight
#define zdepth mccchannel_6_analyzer_1_array_crystal_array_1_zdepth
#define xwidth2 mccchannel_6_analyzer_1_array_crystal_array_1_xwidth2
#define yheight2 mccchannel_6_analyzer_1_array_crystal_array_1_yheight2
#define visualize mccchannel_6_analyzer_1_array_crystal_array_1_visualize
#define target_index mccchannel_6_analyzer_1_array_crystal_array_1_target_index
#define target_x mccchannel_6_analyzer_1_array_crystal_array_1_target_x
#define target_y mccchannel_6_analyzer_1_array_crystal_array_1_target_y
#define target_z mccchannel_6_analyzer_1_array_crystal_array_1_target_z
#define focus_aw mccchannel_6_analyzer_1_array_crystal_array_1_focus_aw
#define focus_ah mccchannel_6_analyzer_1_array_crystal_array_1_focus_ah
#define focus_xw mccchannel_6_analyzer_1_array_crystal_array_1_focus_xw
#define focus_xh mccchannel_6_analyzer_1_array_crystal_array_1_focus_xh
#define focus_r mccchannel_6_analyzer_1_array_crystal_array_1_focus_r
#define p_interact mccchannel_6_analyzer_1_array_crystal_array_1_p_interact
#define mask_string mccchannel_6_analyzer_1_array_crystal_array_1_mask_string
#define mask_setting mccchannel_6_analyzer_1_array_crystal_array_1_mask_setting
#define number_of_activations mccchannel_6_analyzer_1_array_crystal_array_1_number_of_activations
#line 224 "Union_box.comp"
{
// Initializes the focusing system for this volume including input sanitation.
focus_initialize(&this_box_volume.geometry, POS_A_COMP_INDEX(INDEX_CURRENT_COMP+target_index), POS_A_CURRENT_COMP, ROT_A_CURRENT_COMP, target_index, target_x, target_y, target_z, focus_aw, focus_ah, focus_xw, focus_xh, focus_r, NAME_CURRENT_COMP);

// Input sanitation for this geometry
if (xwidth <= 0) {
  printf("\nERROR in Union_box named %s, the xwidth is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (yheight <= 0) {
  printf("\nERROR in Union_box named %s, yheight is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (zdepth <= 0) {
  printf("\nERROR in Union_box named %s, zdepth is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (xwidth2 <= 0 && xwidth2 != -1) {
  printf("\nERROR in Union_box named %s, the xwidth2 is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (yheight2 <= 0 && yheight2 != -1) {
  printf("\nERROR in Union_box named %s, yheight2 is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}

// Use sanitation
if (global_material_list.num_elements == 0) {
  printf("\nERROR: Need to define a material using Union_make_material before using a Union geometry component. \n");
  printf("       %s was defined before first use of Union_make_material.\n",NAME_CURRENT_COMP);
  exit(1);
}

this_box_volume.geometry.is_masked_volume = 0;
this_box_volume.geometry.is_exit_volume = 0;
this_box_volume.geometry.is_mask_volume = 0;
// check if the volume is a mask, if it is the material string is irelevant.
if (mask_string && strlen(mask_string) && strcmp(mask_string, "NULL") && strcmp(mask_string, "0")) {
    // A mask volume is used to limit the extend of other volumes, called the masked volumes. These are specified in the mask_string.
    // In order for a ray to enter a masked volume, it needs to be both in the region covered by that volume AND the mask volume.
    // When more than
    this_box_volume.geometry.mask_mode = 1; // Default is mask mode is ALL
    if (mask_setting && strlen(mask_setting) && strcmp(mask_setting, "NULL") && strcmp(mask_setting, "0")) {
        if (strcmp(mask_setting,"ALL") == 0 || strcmp(mask_setting,"All") == 0) this_box_volume.geometry.mask_mode = 1;
        else if (strcmp(mask_setting,"ANY") == 0 || strcmp(mask_setting,"Any") == 0) this_box_volume.geometry.mask_mode = 2;
        else {
            printf("The mask_mode of component %s is set to %s, but must be either ALL or ANY.\n",NAME_CURRENT_COMP,mask_setting);
            exit(1);
        }
    }
    
    for (loop_index=0;loop_index<global_geometry_list.num_elements;loop_index++) {
        // Add mask list
        if (1 == manual_linking_function(global_geometry_list.elements[loop_index].name,mask_string)) {
            add_element_to_int_list(&this_box_volume.geometry.mask_list,global_geometry_list.elements[loop_index].component_index);
            add_element_to_int_list(&global_geometry_list.elements[loop_index].Volume->geometry.masked_by_list,INDEX_CURRENT_COMP);
            global_geometry_list.elements[loop_index].Volume->geometry.is_masked_volume = 1;
            if (this_box_volume.geometry.mask_mode == 2)
                global_geometry_list.elements[loop_index].Volume->geometry.mask_mode = 2;
            if (this_box_volume.geometry.mask_mode == 1) {
                if (global_geometry_list.elements[loop_index].Volume->geometry.is_masked_volume == 1 && global_geometry_list.elements[loop_index].Volume->geometry.mask_mode != 2)
                    // If more than one mask is added to one volume, the ANY mode overwrites the (default) ALL mode.
                    global_geometry_list.elements[loop_index].Volume->geometry.mask_mode = 1;
            }
            
            found_geometries = 1;
        }
    }
    if (found_geometries == 0) {
        printf("The mask_string in geometry: %s did not find any of the specified volumes in the mask_string %s \n",NAME_CURRENT_COMP,mask_string);
        exit(1);
    }
    this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
    this_box_volume.p_physics->is_vacuum = 0; // Makes this volume a vacuum
    this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
    this_box_volume.p_physics->my_a = 0; // Should not be used.
    sprintf(this_box_volume.p_physics->name,"Mask");
    this_box_volume.geometry.is_mask_volume = 1;
    
    
// Read the material input, or if it lacks, use automatic linking.
} else if (material_string && strlen(material_string) && strcmp(material_string, "NULL") && strcmp(material_string, "0")) {
    // A geometry string was given, use it to determine which material
    if (0 == strcmp(material_string,"vacuum") || 0 == strcmp(material_string,"Vacuum")) {
        // One could have a global physics struct for vacuum instead of creating one for each
        this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
        this_box_volume.p_physics->is_vacuum = 1; // Makes this volume a vacuum
        this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
        this_box_volume.p_physics->my_a = 0; // Should not be used.
        sprintf(this_box_volume.p_physics->name,"Vacuum");
    } else if (0 == strcmp(material_string,"exit") || 0 == strcmp(material_string,"Exit")) {
        // One could have a global physics struct for vacuum instead of creating one for each
        this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
        this_box_volume.p_physics->is_vacuum = 1; // Makes this volume a vacuum
        this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
        this_box_volume.p_physics->my_a = 0; // Should not be used.
        this_box_volume.geometry.is_exit_volume = 1;
        sprintf(this_box_volume.p_physics->name,"Exit");
    } else {
        #ifndef MATERIAL_DETECTOR
            printf("Need to define a material before refering to it in a geometry %s.\n",NAME_CURRENT_COMP);
            exit(1);
        #endif
        for (loop_index=0;loop_index<global_material_list.num_elements;loop_index++) {
            if (0 == strcmp(material_string,global_material_list.elements[loop_index].name)) {
                this_box_volume.p_physics = global_material_list.elements[loop_index].physics;
                break;
            }
            if (loop_index == global_material_list.num_elements-1) {
            printf("\n");
            printf("ERROR: The material string \"%s\" in Union geometry \"%s\" did not match a specified material. \n",material_string,NAME_CURRENT_COMP);
            printf("       The materials available at this point (need to be defined before the geometry): \n");
            for (loop_index=0;loop_index<global_material_list.num_elements;loop_index++)
              printf("         %s\n",global_material_list.elements[loop_index].name);
            printf("\n");
            printf("       It is also possible to use one of the defualt materials avaiable: \n");
            printf("           Vacuum (for a Volume without scattering or absorption)\n");
            printf("           Exit (for a Volume where the ray exits the component if it enters)\n");
            printf("           Mask (for a Volume that masks existing volumes specified in the mask_string\n");
            exit(1);
          }
        }
    }
} else {
    // Automatic linking, simply using the last defined material.
    #ifndef MATERIAL_DETECTOR
        printf("Need to define a material before the geometry to use automatic linking %s.\n",NAME_CURRENT_COMP);
        exit(1);
    #endif
    this_box_volume.p_physics = global_material_list.elements[global_material_list.num_elements-1].physics;
}

sprintf(this_box_volume.name,NAME_CURRENT_COMP);
sprintf(this_box_volume.geometry.shape,"box");
this_box_volume.geometry.priority_value = priority;
this_box_volume.geometry.geometry_p_interact = p_interact;
// Currently the coordinates will be in absolute space.
this_box_volume.geometry.center = POS_A_CURRENT_COMP;

this_box_storage.z_depth = zdepth;
this_box_storage.x_width1 = xwidth;
this_box_storage.y_height1 = yheight;

this_box_storage.is_rectangle = 0;
if (xwidth2 < 0 && yheight2 < 0) this_box_storage.is_rectangle = 1;
if (xwidth == xwidth2 && yheight == yheight2) this_box_storage.is_rectangle = 1;

if (xwidth2 < 0) {
    this_box_storage.x_width2 = xwidth;
    xwidth2 = xwidth;
} else this_box_storage.x_width2 = xwidth2;

if (yheight2 < 0) {
    this_box_storage.y_height2 = yheight;
    yheight2 = yheight;
} else this_box_storage.y_height2 = yheight2;


this_box_storage.normal_vectors[0] = coords_set(0,0,1);
this_box_storage.normal_vectors[1] = coords_set(0,0,1);

// for sides with y component = 0
x_component = 2*zdepth/sqrt((xwidth-xwidth2)*(xwidth-xwidth2)+4*zdepth*zdepth);
z_component = (xwidth-xwidth2)/sqrt(4*zdepth*zdepth+(xwidth-xwidth2)*(xwidth-xwidth2));

this_box_storage.normal_vectors[2] = coords_set(x_component,0,z_component);
this_box_storage.normal_vectors[3] = coords_set(-x_component,0,z_component);

// for sides with x component = 0
y_component = 2*zdepth/sqrt((yheight-yheight2)*(yheight-yheight2)+4*zdepth*zdepth);
z_component = (yheight-yheight2)/sqrt(4*zdepth*zdepth+(yheight-yheight2)*(yheight-yheight2));

this_box_storage.normal_vectors[4] = coords_set(0,y_component,z_component);
this_box_storage.normal_vectors[5] = coords_set(0,-y_component,z_component);

this_box_volume.geometry.visualization_on = visualize;

this_box_volume.geometry.geometry_parameters.p_box_storage = &this_box_storage;

// Assign pointers to functions for intersection with the shape, checking if a point is inside the shape
if (this_box_storage.is_rectangle == 1) {
this_box_volume.geometry.intersect_function = &sample_box_intersect_simple;
this_box_volume.geometry.within_function = &r_within_box_simple;
}
else {
this_box_volume.geometry.intersect_function = &sample_box_intersect_advanced;
this_box_volume.geometry.within_function = &r_within_box_advanced;
}

this_box_volume.geometry.shell_points = &box_shell_points;
this_box_volume.geometry.mcdisplay_function = &mcdisplay_box_function;
this_box_volume.geometry.initialize_from_main_function = &initialize_box_geometry_from_main_component;
this_box_volume.geometry.process_rot_allocated = 0;

this_box_volume.geometry.copy_geometry_parameters = &allocate_box_storage_copy;

rot_copy(this_box_volume.geometry.rotation_matrix,ROT_A_CURRENT_COMP); //check how ROT_R_CURRENT_COMP would work
rot_transpose(ROT_A_CURRENT_COMP,this_box_volume.geometry.transpose_rotation_matrix);

// Initialize loggers
this_box_volume.loggers.num_elements = 0;

// packing the information into the global_geometry_element, which is then included in the global_geometry_list.
sprintf(global_geometry_element.name,NAME_CURRENT_COMP);
global_geometry_element.activation_counter = number_of_activations;
global_geometry_element.component_index = INDEX_CURRENT_COMP;
global_geometry_element.Volume = &this_box_volume; // Would be nicer if this m was a pointer, now we have the (small) data two places
add_element_to_geometry_list(&global_geometry_list,global_geometry_element);
}
#line 218909 "MACS_sample_kidney_box.c"
#undef number_of_activations
#undef mask_setting
#undef mask_string
#undef p_interact
#undef focus_r
#undef focus_xh
#undef focus_xw
#undef focus_ah
#undef focus_aw
#undef target_z
#undef target_y
#undef target_x
#undef target_index
#undef visualize
#undef yheight2
#undef xwidth2
#undef zdepth
#undef yheight
#undef xwidth
#undef priority
#undef material_string
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

  /* Initializations for component channel_6_analyzer_1_array_crystal_array_2. */
  SIG_MESSAGE("channel_6_analyzer_1_array_crystal_array_2 (Init)");
#define mccompcurname  channel_6_analyzer_1_array_crystal_array_2
#define mccompcurtype  Union_box
#define mccompcurindex 360
#define loop_index mccchannel_6_analyzer_1_array_crystal_array_2_loop_index
#define this_box_volume mccchannel_6_analyzer_1_array_crystal_array_2_this_box_volume
#define global_geometry_element mccchannel_6_analyzer_1_array_crystal_array_2_global_geometry_element
#define this_box_storage mccchannel_6_analyzer_1_array_crystal_array_2_this_box_storage
#define material_string mccchannel_6_analyzer_1_array_crystal_array_2_material_string
#define priority mccchannel_6_analyzer_1_array_crystal_array_2_priority
#define xwidth mccchannel_6_analyzer_1_array_crystal_array_2_xwidth
#define yheight mccchannel_6_analyzer_1_array_crystal_array_2_yheight
#define zdepth mccchannel_6_analyzer_1_array_crystal_array_2_zdepth
#define xwidth2 mccchannel_6_analyzer_1_array_crystal_array_2_xwidth2
#define yheight2 mccchannel_6_analyzer_1_array_crystal_array_2_yheight2
#define visualize mccchannel_6_analyzer_1_array_crystal_array_2_visualize
#define target_index mccchannel_6_analyzer_1_array_crystal_array_2_target_index
#define target_x mccchannel_6_analyzer_1_array_crystal_array_2_target_x
#define target_y mccchannel_6_analyzer_1_array_crystal_array_2_target_y
#define target_z mccchannel_6_analyzer_1_array_crystal_array_2_target_z
#define focus_aw mccchannel_6_analyzer_1_array_crystal_array_2_focus_aw
#define focus_ah mccchannel_6_analyzer_1_array_crystal_array_2_focus_ah
#define focus_xw mccchannel_6_analyzer_1_array_crystal_array_2_focus_xw
#define focus_xh mccchannel_6_analyzer_1_array_crystal_array_2_focus_xh
#define focus_r mccchannel_6_analyzer_1_array_crystal_array_2_focus_r
#define p_interact mccchannel_6_analyzer_1_array_crystal_array_2_p_interact
#define mask_string mccchannel_6_analyzer_1_array_crystal_array_2_mask_string
#define mask_setting mccchannel_6_analyzer_1_array_crystal_array_2_mask_setting
#define number_of_activations mccchannel_6_analyzer_1_array_crystal_array_2_number_of_activations
#line 224 "Union_box.comp"
{
// Initializes the focusing system for this volume including input sanitation.
focus_initialize(&this_box_volume.geometry, POS_A_COMP_INDEX(INDEX_CURRENT_COMP+target_index), POS_A_CURRENT_COMP, ROT_A_CURRENT_COMP, target_index, target_x, target_y, target_z, focus_aw, focus_ah, focus_xw, focus_xh, focus_r, NAME_CURRENT_COMP);

// Input sanitation for this geometry
if (xwidth <= 0) {
  printf("\nERROR in Union_box named %s, the xwidth is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (yheight <= 0) {
  printf("\nERROR in Union_box named %s, yheight is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (zdepth <= 0) {
  printf("\nERROR in Union_box named %s, zdepth is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (xwidth2 <= 0 && xwidth2 != -1) {
  printf("\nERROR in Union_box named %s, the xwidth2 is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (yheight2 <= 0 && yheight2 != -1) {
  printf("\nERROR in Union_box named %s, yheight2 is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}

// Use sanitation
if (global_material_list.num_elements == 0) {
  printf("\nERROR: Need to define a material using Union_make_material before using a Union geometry component. \n");
  printf("       %s was defined before first use of Union_make_material.\n",NAME_CURRENT_COMP);
  exit(1);
}

this_box_volume.geometry.is_masked_volume = 0;
this_box_volume.geometry.is_exit_volume = 0;
this_box_volume.geometry.is_mask_volume = 0;
// check if the volume is a mask, if it is the material string is irelevant.
if (mask_string && strlen(mask_string) && strcmp(mask_string, "NULL") && strcmp(mask_string, "0")) {
    // A mask volume is used to limit the extend of other volumes, called the masked volumes. These are specified in the mask_string.
    // In order for a ray to enter a masked volume, it needs to be both in the region covered by that volume AND the mask volume.
    // When more than
    this_box_volume.geometry.mask_mode = 1; // Default is mask mode is ALL
    if (mask_setting && strlen(mask_setting) && strcmp(mask_setting, "NULL") && strcmp(mask_setting, "0")) {
        if (strcmp(mask_setting,"ALL") == 0 || strcmp(mask_setting,"All") == 0) this_box_volume.geometry.mask_mode = 1;
        else if (strcmp(mask_setting,"ANY") == 0 || strcmp(mask_setting,"Any") == 0) this_box_volume.geometry.mask_mode = 2;
        else {
            printf("The mask_mode of component %s is set to %s, but must be either ALL or ANY.\n",NAME_CURRENT_COMP,mask_setting);
            exit(1);
        }
    }
    
    for (loop_index=0;loop_index<global_geometry_list.num_elements;loop_index++) {
        // Add mask list
        if (1 == manual_linking_function(global_geometry_list.elements[loop_index].name,mask_string)) {
            add_element_to_int_list(&this_box_volume.geometry.mask_list,global_geometry_list.elements[loop_index].component_index);
            add_element_to_int_list(&global_geometry_list.elements[loop_index].Volume->geometry.masked_by_list,INDEX_CURRENT_COMP);
            global_geometry_list.elements[loop_index].Volume->geometry.is_masked_volume = 1;
            if (this_box_volume.geometry.mask_mode == 2)
                global_geometry_list.elements[loop_index].Volume->geometry.mask_mode = 2;
            if (this_box_volume.geometry.mask_mode == 1) {
                if (global_geometry_list.elements[loop_index].Volume->geometry.is_masked_volume == 1 && global_geometry_list.elements[loop_index].Volume->geometry.mask_mode != 2)
                    // If more than one mask is added to one volume, the ANY mode overwrites the (default) ALL mode.
                    global_geometry_list.elements[loop_index].Volume->geometry.mask_mode = 1;
            }
            
            found_geometries = 1;
        }
    }
    if (found_geometries == 0) {
        printf("The mask_string in geometry: %s did not find any of the specified volumes in the mask_string %s \n",NAME_CURRENT_COMP,mask_string);
        exit(1);
    }
    this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
    this_box_volume.p_physics->is_vacuum = 0; // Makes this volume a vacuum
    this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
    this_box_volume.p_physics->my_a = 0; // Should not be used.
    sprintf(this_box_volume.p_physics->name,"Mask");
    this_box_volume.geometry.is_mask_volume = 1;
    
    
// Read the material input, or if it lacks, use automatic linking.
} else if (material_string && strlen(material_string) && strcmp(material_string, "NULL") && strcmp(material_string, "0")) {
    // A geometry string was given, use it to determine which material
    if (0 == strcmp(material_string,"vacuum") || 0 == strcmp(material_string,"Vacuum")) {
        // One could have a global physics struct for vacuum instead of creating one for each
        this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
        this_box_volume.p_physics->is_vacuum = 1; // Makes this volume a vacuum
        this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
        this_box_volume.p_physics->my_a = 0; // Should not be used.
        sprintf(this_box_volume.p_physics->name,"Vacuum");
    } else if (0 == strcmp(material_string,"exit") || 0 == strcmp(material_string,"Exit")) {
        // One could have a global physics struct for vacuum instead of creating one for each
        this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
        this_box_volume.p_physics->is_vacuum = 1; // Makes this volume a vacuum
        this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
        this_box_volume.p_physics->my_a = 0; // Should not be used.
        this_box_volume.geometry.is_exit_volume = 1;
        sprintf(this_box_volume.p_physics->name,"Exit");
    } else {
        #ifndef MATERIAL_DETECTOR
            printf("Need to define a material before refering to it in a geometry %s.\n",NAME_CURRENT_COMP);
            exit(1);
        #endif
        for (loop_index=0;loop_index<global_material_list.num_elements;loop_index++) {
            if (0 == strcmp(material_string,global_material_list.elements[loop_index].name)) {
                this_box_volume.p_physics = global_material_list.elements[loop_index].physics;
                break;
            }
            if (loop_index == global_material_list.num_elements-1) {
            printf("\n");
            printf("ERROR: The material string \"%s\" in Union geometry \"%s\" did not match a specified material. \n",material_string,NAME_CURRENT_COMP);
            printf("       The materials available at this point (need to be defined before the geometry): \n");
            for (loop_index=0;loop_index<global_material_list.num_elements;loop_index++)
              printf("         %s\n",global_material_list.elements[loop_index].name);
            printf("\n");
            printf("       It is also possible to use one of the defualt materials avaiable: \n");
            printf("           Vacuum (for a Volume without scattering or absorption)\n");
            printf("           Exit (for a Volume where the ray exits the component if it enters)\n");
            printf("           Mask (for a Volume that masks existing volumes specified in the mask_string\n");
            exit(1);
          }
        }
    }
} else {
    // Automatic linking, simply using the last defined material.
    #ifndef MATERIAL_DETECTOR
        printf("Need to define a material before the geometry to use automatic linking %s.\n",NAME_CURRENT_COMP);
        exit(1);
    #endif
    this_box_volume.p_physics = global_material_list.elements[global_material_list.num_elements-1].physics;
}

sprintf(this_box_volume.name,NAME_CURRENT_COMP);
sprintf(this_box_volume.geometry.shape,"box");
this_box_volume.geometry.priority_value = priority;
this_box_volume.geometry.geometry_p_interact = p_interact;
// Currently the coordinates will be in absolute space.
this_box_volume.geometry.center = POS_A_CURRENT_COMP;

this_box_storage.z_depth = zdepth;
this_box_storage.x_width1 = xwidth;
this_box_storage.y_height1 = yheight;

this_box_storage.is_rectangle = 0;
if (xwidth2 < 0 && yheight2 < 0) this_box_storage.is_rectangle = 1;
if (xwidth == xwidth2 && yheight == yheight2) this_box_storage.is_rectangle = 1;

if (xwidth2 < 0) {
    this_box_storage.x_width2 = xwidth;
    xwidth2 = xwidth;
} else this_box_storage.x_width2 = xwidth2;

if (yheight2 < 0) {
    this_box_storage.y_height2 = yheight;
    yheight2 = yheight;
} else this_box_storage.y_height2 = yheight2;


this_box_storage.normal_vectors[0] = coords_set(0,0,1);
this_box_storage.normal_vectors[1] = coords_set(0,0,1);

// for sides with y component = 0
x_component = 2*zdepth/sqrt((xwidth-xwidth2)*(xwidth-xwidth2)+4*zdepth*zdepth);
z_component = (xwidth-xwidth2)/sqrt(4*zdepth*zdepth+(xwidth-xwidth2)*(xwidth-xwidth2));

this_box_storage.normal_vectors[2] = coords_set(x_component,0,z_component);
this_box_storage.normal_vectors[3] = coords_set(-x_component,0,z_component);

// for sides with x component = 0
y_component = 2*zdepth/sqrt((yheight-yheight2)*(yheight-yheight2)+4*zdepth*zdepth);
z_component = (yheight-yheight2)/sqrt(4*zdepth*zdepth+(yheight-yheight2)*(yheight-yheight2));

this_box_storage.normal_vectors[4] = coords_set(0,y_component,z_component);
this_box_storage.normal_vectors[5] = coords_set(0,-y_component,z_component);

this_box_volume.geometry.visualization_on = visualize;

this_box_volume.geometry.geometry_parameters.p_box_storage = &this_box_storage;

// Assign pointers to functions for intersection with the shape, checking if a point is inside the shape
if (this_box_storage.is_rectangle == 1) {
this_box_volume.geometry.intersect_function = &sample_box_intersect_simple;
this_box_volume.geometry.within_function = &r_within_box_simple;
}
else {
this_box_volume.geometry.intersect_function = &sample_box_intersect_advanced;
this_box_volume.geometry.within_function = &r_within_box_advanced;
}

this_box_volume.geometry.shell_points = &box_shell_points;
this_box_volume.geometry.mcdisplay_function = &mcdisplay_box_function;
this_box_volume.geometry.initialize_from_main_function = &initialize_box_geometry_from_main_component;
this_box_volume.geometry.process_rot_allocated = 0;

this_box_volume.geometry.copy_geometry_parameters = &allocate_box_storage_copy;

rot_copy(this_box_volume.geometry.rotation_matrix,ROT_A_CURRENT_COMP); //check how ROT_R_CURRENT_COMP would work
rot_transpose(ROT_A_CURRENT_COMP,this_box_volume.geometry.transpose_rotation_matrix);

// Initialize loggers
this_box_volume.loggers.num_elements = 0;

// packing the information into the global_geometry_element, which is then included in the global_geometry_list.
sprintf(global_geometry_element.name,NAME_CURRENT_COMP);
global_geometry_element.activation_counter = number_of_activations;
global_geometry_element.component_index = INDEX_CURRENT_COMP;
global_geometry_element.Volume = &this_box_volume; // Would be nicer if this m was a pointer, now we have the (small) data two places
add_element_to_geometry_list(&global_geometry_list,global_geometry_element);
}
#line 219179 "MACS_sample_kidney_box.c"
#undef number_of_activations
#undef mask_setting
#undef mask_string
#undef p_interact
#undef focus_r
#undef focus_xh
#undef focus_xw
#undef focus_ah
#undef focus_aw
#undef target_z
#undef target_y
#undef target_x
#undef target_index
#undef visualize
#undef yheight2
#undef xwidth2
#undef zdepth
#undef yheight
#undef xwidth
#undef priority
#undef material_string
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

  /* Initializations for component channel_6_analyzer_1_array_crystal_array_3. */
  SIG_MESSAGE("channel_6_analyzer_1_array_crystal_array_3 (Init)");
#define mccompcurname  channel_6_analyzer_1_array_crystal_array_3
#define mccompcurtype  Union_box
#define mccompcurindex 361
#define loop_index mccchannel_6_analyzer_1_array_crystal_array_3_loop_index
#define this_box_volume mccchannel_6_analyzer_1_array_crystal_array_3_this_box_volume
#define global_geometry_element mccchannel_6_analyzer_1_array_crystal_array_3_global_geometry_element
#define this_box_storage mccchannel_6_analyzer_1_array_crystal_array_3_this_box_storage
#define material_string mccchannel_6_analyzer_1_array_crystal_array_3_material_string
#define priority mccchannel_6_analyzer_1_array_crystal_array_3_priority
#define xwidth mccchannel_6_analyzer_1_array_crystal_array_3_xwidth
#define yheight mccchannel_6_analyzer_1_array_crystal_array_3_yheight
#define zdepth mccchannel_6_analyzer_1_array_crystal_array_3_zdepth
#define xwidth2 mccchannel_6_analyzer_1_array_crystal_array_3_xwidth2
#define yheight2 mccchannel_6_analyzer_1_array_crystal_array_3_yheight2
#define visualize mccchannel_6_analyzer_1_array_crystal_array_3_visualize
#define target_index mccchannel_6_analyzer_1_array_crystal_array_3_target_index
#define target_x mccchannel_6_analyzer_1_array_crystal_array_3_target_x
#define target_y mccchannel_6_analyzer_1_array_crystal_array_3_target_y
#define target_z mccchannel_6_analyzer_1_array_crystal_array_3_target_z
#define focus_aw mccchannel_6_analyzer_1_array_crystal_array_3_focus_aw
#define focus_ah mccchannel_6_analyzer_1_array_crystal_array_3_focus_ah
#define focus_xw mccchannel_6_analyzer_1_array_crystal_array_3_focus_xw
#define focus_xh mccchannel_6_analyzer_1_array_crystal_array_3_focus_xh
#define focus_r mccchannel_6_analyzer_1_array_crystal_array_3_focus_r
#define p_interact mccchannel_6_analyzer_1_array_crystal_array_3_p_interact
#define mask_string mccchannel_6_analyzer_1_array_crystal_array_3_mask_string
#define mask_setting mccchannel_6_analyzer_1_array_crystal_array_3_mask_setting
#define number_of_activations mccchannel_6_analyzer_1_array_crystal_array_3_number_of_activations
#line 224 "Union_box.comp"
{
// Initializes the focusing system for this volume including input sanitation.
focus_initialize(&this_box_volume.geometry, POS_A_COMP_INDEX(INDEX_CURRENT_COMP+target_index), POS_A_CURRENT_COMP, ROT_A_CURRENT_COMP, target_index, target_x, target_y, target_z, focus_aw, focus_ah, focus_xw, focus_xh, focus_r, NAME_CURRENT_COMP);

// Input sanitation for this geometry
if (xwidth <= 0) {
  printf("\nERROR in Union_box named %s, the xwidth is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (yheight <= 0) {
  printf("\nERROR in Union_box named %s, yheight is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (zdepth <= 0) {
  printf("\nERROR in Union_box named %s, zdepth is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (xwidth2 <= 0 && xwidth2 != -1) {
  printf("\nERROR in Union_box named %s, the xwidth2 is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (yheight2 <= 0 && yheight2 != -1) {
  printf("\nERROR in Union_box named %s, yheight2 is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}

// Use sanitation
if (global_material_list.num_elements == 0) {
  printf("\nERROR: Need to define a material using Union_make_material before using a Union geometry component. \n");
  printf("       %s was defined before first use of Union_make_material.\n",NAME_CURRENT_COMP);
  exit(1);
}

this_box_volume.geometry.is_masked_volume = 0;
this_box_volume.geometry.is_exit_volume = 0;
this_box_volume.geometry.is_mask_volume = 0;
// check if the volume is a mask, if it is the material string is irelevant.
if (mask_string && strlen(mask_string) && strcmp(mask_string, "NULL") && strcmp(mask_string, "0")) {
    // A mask volume is used to limit the extend of other volumes, called the masked volumes. These are specified in the mask_string.
    // In order for a ray to enter a masked volume, it needs to be both in the region covered by that volume AND the mask volume.
    // When more than
    this_box_volume.geometry.mask_mode = 1; // Default is mask mode is ALL
    if (mask_setting && strlen(mask_setting) && strcmp(mask_setting, "NULL") && strcmp(mask_setting, "0")) {
        if (strcmp(mask_setting,"ALL") == 0 || strcmp(mask_setting,"All") == 0) this_box_volume.geometry.mask_mode = 1;
        else if (strcmp(mask_setting,"ANY") == 0 || strcmp(mask_setting,"Any") == 0) this_box_volume.geometry.mask_mode = 2;
        else {
            printf("The mask_mode of component %s is set to %s, but must be either ALL or ANY.\n",NAME_CURRENT_COMP,mask_setting);
            exit(1);
        }
    }
    
    for (loop_index=0;loop_index<global_geometry_list.num_elements;loop_index++) {
        // Add mask list
        if (1 == manual_linking_function(global_geometry_list.elements[loop_index].name,mask_string)) {
            add_element_to_int_list(&this_box_volume.geometry.mask_list,global_geometry_list.elements[loop_index].component_index);
            add_element_to_int_list(&global_geometry_list.elements[loop_index].Volume->geometry.masked_by_list,INDEX_CURRENT_COMP);
            global_geometry_list.elements[loop_index].Volume->geometry.is_masked_volume = 1;
            if (this_box_volume.geometry.mask_mode == 2)
                global_geometry_list.elements[loop_index].Volume->geometry.mask_mode = 2;
            if (this_box_volume.geometry.mask_mode == 1) {
                if (global_geometry_list.elements[loop_index].Volume->geometry.is_masked_volume == 1 && global_geometry_list.elements[loop_index].Volume->geometry.mask_mode != 2)
                    // If more than one mask is added to one volume, the ANY mode overwrites the (default) ALL mode.
                    global_geometry_list.elements[loop_index].Volume->geometry.mask_mode = 1;
            }
            
            found_geometries = 1;
        }
    }
    if (found_geometries == 0) {
        printf("The mask_string in geometry: %s did not find any of the specified volumes in the mask_string %s \n",NAME_CURRENT_COMP,mask_string);
        exit(1);
    }
    this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
    this_box_volume.p_physics->is_vacuum = 0; // Makes this volume a vacuum
    this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
    this_box_volume.p_physics->my_a = 0; // Should not be used.
    sprintf(this_box_volume.p_physics->name,"Mask");
    this_box_volume.geometry.is_mask_volume = 1;
    
    
// Read the material input, or if it lacks, use automatic linking.
} else if (material_string && strlen(material_string) && strcmp(material_string, "NULL") && strcmp(material_string, "0")) {
    // A geometry string was given, use it to determine which material
    if (0 == strcmp(material_string,"vacuum") || 0 == strcmp(material_string,"Vacuum")) {
        // One could have a global physics struct for vacuum instead of creating one for each
        this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
        this_box_volume.p_physics->is_vacuum = 1; // Makes this volume a vacuum
        this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
        this_box_volume.p_physics->my_a = 0; // Should not be used.
        sprintf(this_box_volume.p_physics->name,"Vacuum");
    } else if (0 == strcmp(material_string,"exit") || 0 == strcmp(material_string,"Exit")) {
        // One could have a global physics struct for vacuum instead of creating one for each
        this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
        this_box_volume.p_physics->is_vacuum = 1; // Makes this volume a vacuum
        this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
        this_box_volume.p_physics->my_a = 0; // Should not be used.
        this_box_volume.geometry.is_exit_volume = 1;
        sprintf(this_box_volume.p_physics->name,"Exit");
    } else {
        #ifndef MATERIAL_DETECTOR
            printf("Need to define a material before refering to it in a geometry %s.\n",NAME_CURRENT_COMP);
            exit(1);
        #endif
        for (loop_index=0;loop_index<global_material_list.num_elements;loop_index++) {
            if (0 == strcmp(material_string,global_material_list.elements[loop_index].name)) {
                this_box_volume.p_physics = global_material_list.elements[loop_index].physics;
                break;
            }
            if (loop_index == global_material_list.num_elements-1) {
            printf("\n");
            printf("ERROR: The material string \"%s\" in Union geometry \"%s\" did not match a specified material. \n",material_string,NAME_CURRENT_COMP);
            printf("       The materials available at this point (need to be defined before the geometry): \n");
            for (loop_index=0;loop_index<global_material_list.num_elements;loop_index++)
              printf("         %s\n",global_material_list.elements[loop_index].name);
            printf("\n");
            printf("       It is also possible to use one of the defualt materials avaiable: \n");
            printf("           Vacuum (for a Volume without scattering or absorption)\n");
            printf("           Exit (for a Volume where the ray exits the component if it enters)\n");
            printf("           Mask (for a Volume that masks existing volumes specified in the mask_string\n");
            exit(1);
          }
        }
    }
} else {
    // Automatic linking, simply using the last defined material.
    #ifndef MATERIAL_DETECTOR
        printf("Need to define a material before the geometry to use automatic linking %s.\n",NAME_CURRENT_COMP);
        exit(1);
    #endif
    this_box_volume.p_physics = global_material_list.elements[global_material_list.num_elements-1].physics;
}

sprintf(this_box_volume.name,NAME_CURRENT_COMP);
sprintf(this_box_volume.geometry.shape,"box");
this_box_volume.geometry.priority_value = priority;
this_box_volume.geometry.geometry_p_interact = p_interact;
// Currently the coordinates will be in absolute space.
this_box_volume.geometry.center = POS_A_CURRENT_COMP;

this_box_storage.z_depth = zdepth;
this_box_storage.x_width1 = xwidth;
this_box_storage.y_height1 = yheight;

this_box_storage.is_rectangle = 0;
if (xwidth2 < 0 && yheight2 < 0) this_box_storage.is_rectangle = 1;
if (xwidth == xwidth2 && yheight == yheight2) this_box_storage.is_rectangle = 1;

if (xwidth2 < 0) {
    this_box_storage.x_width2 = xwidth;
    xwidth2 = xwidth;
} else this_box_storage.x_width2 = xwidth2;

if (yheight2 < 0) {
    this_box_storage.y_height2 = yheight;
    yheight2 = yheight;
} else this_box_storage.y_height2 = yheight2;


this_box_storage.normal_vectors[0] = coords_set(0,0,1);
this_box_storage.normal_vectors[1] = coords_set(0,0,1);

// for sides with y component = 0
x_component = 2*zdepth/sqrt((xwidth-xwidth2)*(xwidth-xwidth2)+4*zdepth*zdepth);
z_component = (xwidth-xwidth2)/sqrt(4*zdepth*zdepth+(xwidth-xwidth2)*(xwidth-xwidth2));

this_box_storage.normal_vectors[2] = coords_set(x_component,0,z_component);
this_box_storage.normal_vectors[3] = coords_set(-x_component,0,z_component);

// for sides with x component = 0
y_component = 2*zdepth/sqrt((yheight-yheight2)*(yheight-yheight2)+4*zdepth*zdepth);
z_component = (yheight-yheight2)/sqrt(4*zdepth*zdepth+(yheight-yheight2)*(yheight-yheight2));

this_box_storage.normal_vectors[4] = coords_set(0,y_component,z_component);
this_box_storage.normal_vectors[5] = coords_set(0,-y_component,z_component);

this_box_volume.geometry.visualization_on = visualize;

this_box_volume.geometry.geometry_parameters.p_box_storage = &this_box_storage;

// Assign pointers to functions for intersection with the shape, checking if a point is inside the shape
if (this_box_storage.is_rectangle == 1) {
this_box_volume.geometry.intersect_function = &sample_box_intersect_simple;
this_box_volume.geometry.within_function = &r_within_box_simple;
}
else {
this_box_volume.geometry.intersect_function = &sample_box_intersect_advanced;
this_box_volume.geometry.within_function = &r_within_box_advanced;
}

this_box_volume.geometry.shell_points = &box_shell_points;
this_box_volume.geometry.mcdisplay_function = &mcdisplay_box_function;
this_box_volume.geometry.initialize_from_main_function = &initialize_box_geometry_from_main_component;
this_box_volume.geometry.process_rot_allocated = 0;

this_box_volume.geometry.copy_geometry_parameters = &allocate_box_storage_copy;

rot_copy(this_box_volume.geometry.rotation_matrix,ROT_A_CURRENT_COMP); //check how ROT_R_CURRENT_COMP would work
rot_transpose(ROT_A_CURRENT_COMP,this_box_volume.geometry.transpose_rotation_matrix);

// Initialize loggers
this_box_volume.loggers.num_elements = 0;

// packing the information into the global_geometry_element, which is then included in the global_geometry_list.
sprintf(global_geometry_element.name,NAME_CURRENT_COMP);
global_geometry_element.activation_counter = number_of_activations;
global_geometry_element.component_index = INDEX_CURRENT_COMP;
global_geometry_element.Volume = &this_box_volume; // Would be nicer if this m was a pointer, now we have the (small) data two places
add_element_to_geometry_list(&global_geometry_list,global_geometry_element);
}
#line 219449 "MACS_sample_kidney_box.c"
#undef number_of_activations
#undef mask_setting
#undef mask_string
#undef p_interact
#undef focus_r
#undef focus_xh
#undef focus_xw
#undef focus_ah
#undef focus_aw
#undef target_z
#undef target_y
#undef target_x
#undef target_index
#undef visualize
#undef yheight2
#undef xwidth2
#undef zdepth
#undef yheight
#undef xwidth
#undef priority
#undef material_string
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

  /* Initializations for component channel_6_analyzer_1_array_crystal_array_4. */
  SIG_MESSAGE("channel_6_analyzer_1_array_crystal_array_4 (Init)");
#define mccompcurname  channel_6_analyzer_1_array_crystal_array_4
#define mccompcurtype  Union_box
#define mccompcurindex 362
#define loop_index mccchannel_6_analyzer_1_array_crystal_array_4_loop_index
#define this_box_volume mccchannel_6_analyzer_1_array_crystal_array_4_this_box_volume
#define global_geometry_element mccchannel_6_analyzer_1_array_crystal_array_4_global_geometry_element
#define this_box_storage mccchannel_6_analyzer_1_array_crystal_array_4_this_box_storage
#define material_string mccchannel_6_analyzer_1_array_crystal_array_4_material_string
#define priority mccchannel_6_analyzer_1_array_crystal_array_4_priority
#define xwidth mccchannel_6_analyzer_1_array_crystal_array_4_xwidth
#define yheight mccchannel_6_analyzer_1_array_crystal_array_4_yheight
#define zdepth mccchannel_6_analyzer_1_array_crystal_array_4_zdepth
#define xwidth2 mccchannel_6_analyzer_1_array_crystal_array_4_xwidth2
#define yheight2 mccchannel_6_analyzer_1_array_crystal_array_4_yheight2
#define visualize mccchannel_6_analyzer_1_array_crystal_array_4_visualize
#define target_index mccchannel_6_analyzer_1_array_crystal_array_4_target_index
#define target_x mccchannel_6_analyzer_1_array_crystal_array_4_target_x
#define target_y mccchannel_6_analyzer_1_array_crystal_array_4_target_y
#define target_z mccchannel_6_analyzer_1_array_crystal_array_4_target_z
#define focus_aw mccchannel_6_analyzer_1_array_crystal_array_4_focus_aw
#define focus_ah mccchannel_6_analyzer_1_array_crystal_array_4_focus_ah
#define focus_xw mccchannel_6_analyzer_1_array_crystal_array_4_focus_xw
#define focus_xh mccchannel_6_analyzer_1_array_crystal_array_4_focus_xh
#define focus_r mccchannel_6_analyzer_1_array_crystal_array_4_focus_r
#define p_interact mccchannel_6_analyzer_1_array_crystal_array_4_p_interact
#define mask_string mccchannel_6_analyzer_1_array_crystal_array_4_mask_string
#define mask_setting mccchannel_6_analyzer_1_array_crystal_array_4_mask_setting
#define number_of_activations mccchannel_6_analyzer_1_array_crystal_array_4_number_of_activations
#line 224 "Union_box.comp"
{
// Initializes the focusing system for this volume including input sanitation.
focus_initialize(&this_box_volume.geometry, POS_A_COMP_INDEX(INDEX_CURRENT_COMP+target_index), POS_A_CURRENT_COMP, ROT_A_CURRENT_COMP, target_index, target_x, target_y, target_z, focus_aw, focus_ah, focus_xw, focus_xh, focus_r, NAME_CURRENT_COMP);

// Input sanitation for this geometry
if (xwidth <= 0) {
  printf("\nERROR in Union_box named %s, the xwidth is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (yheight <= 0) {
  printf("\nERROR in Union_box named %s, yheight is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (zdepth <= 0) {
  printf("\nERROR in Union_box named %s, zdepth is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (xwidth2 <= 0 && xwidth2 != -1) {
  printf("\nERROR in Union_box named %s, the xwidth2 is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (yheight2 <= 0 && yheight2 != -1) {
  printf("\nERROR in Union_box named %s, yheight2 is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}

// Use sanitation
if (global_material_list.num_elements == 0) {
  printf("\nERROR: Need to define a material using Union_make_material before using a Union geometry component. \n");
  printf("       %s was defined before first use of Union_make_material.\n",NAME_CURRENT_COMP);
  exit(1);
}

this_box_volume.geometry.is_masked_volume = 0;
this_box_volume.geometry.is_exit_volume = 0;
this_box_volume.geometry.is_mask_volume = 0;
// check if the volume is a mask, if it is the material string is irelevant.
if (mask_string && strlen(mask_string) && strcmp(mask_string, "NULL") && strcmp(mask_string, "0")) {
    // A mask volume is used to limit the extend of other volumes, called the masked volumes. These are specified in the mask_string.
    // In order for a ray to enter a masked volume, it needs to be both in the region covered by that volume AND the mask volume.
    // When more than
    this_box_volume.geometry.mask_mode = 1; // Default is mask mode is ALL
    if (mask_setting && strlen(mask_setting) && strcmp(mask_setting, "NULL") && strcmp(mask_setting, "0")) {
        if (strcmp(mask_setting,"ALL") == 0 || strcmp(mask_setting,"All") == 0) this_box_volume.geometry.mask_mode = 1;
        else if (strcmp(mask_setting,"ANY") == 0 || strcmp(mask_setting,"Any") == 0) this_box_volume.geometry.mask_mode = 2;
        else {
            printf("The mask_mode of component %s is set to %s, but must be either ALL or ANY.\n",NAME_CURRENT_COMP,mask_setting);
            exit(1);
        }
    }
    
    for (loop_index=0;loop_index<global_geometry_list.num_elements;loop_index++) {
        // Add mask list
        if (1 == manual_linking_function(global_geometry_list.elements[loop_index].name,mask_string)) {
            add_element_to_int_list(&this_box_volume.geometry.mask_list,global_geometry_list.elements[loop_index].component_index);
            add_element_to_int_list(&global_geometry_list.elements[loop_index].Volume->geometry.masked_by_list,INDEX_CURRENT_COMP);
            global_geometry_list.elements[loop_index].Volume->geometry.is_masked_volume = 1;
            if (this_box_volume.geometry.mask_mode == 2)
                global_geometry_list.elements[loop_index].Volume->geometry.mask_mode = 2;
            if (this_box_volume.geometry.mask_mode == 1) {
                if (global_geometry_list.elements[loop_index].Volume->geometry.is_masked_volume == 1 && global_geometry_list.elements[loop_index].Volume->geometry.mask_mode != 2)
                    // If more than one mask is added to one volume, the ANY mode overwrites the (default) ALL mode.
                    global_geometry_list.elements[loop_index].Volume->geometry.mask_mode = 1;
            }
            
            found_geometries = 1;
        }
    }
    if (found_geometries == 0) {
        printf("The mask_string in geometry: %s did not find any of the specified volumes in the mask_string %s \n",NAME_CURRENT_COMP,mask_string);
        exit(1);
    }
    this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
    this_box_volume.p_physics->is_vacuum = 0; // Makes this volume a vacuum
    this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
    this_box_volume.p_physics->my_a = 0; // Should not be used.
    sprintf(this_box_volume.p_physics->name,"Mask");
    this_box_volume.geometry.is_mask_volume = 1;
    
    
// Read the material input, or if it lacks, use automatic linking.
} else if (material_string && strlen(material_string) && strcmp(material_string, "NULL") && strcmp(material_string, "0")) {
    // A geometry string was given, use it to determine which material
    if (0 == strcmp(material_string,"vacuum") || 0 == strcmp(material_string,"Vacuum")) {
        // One could have a global physics struct for vacuum instead of creating one for each
        this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
        this_box_volume.p_physics->is_vacuum = 1; // Makes this volume a vacuum
        this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
        this_box_volume.p_physics->my_a = 0; // Should not be used.
        sprintf(this_box_volume.p_physics->name,"Vacuum");
    } else if (0 == strcmp(material_string,"exit") || 0 == strcmp(material_string,"Exit")) {
        // One could have a global physics struct for vacuum instead of creating one for each
        this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
        this_box_volume.p_physics->is_vacuum = 1; // Makes this volume a vacuum
        this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
        this_box_volume.p_physics->my_a = 0; // Should not be used.
        this_box_volume.geometry.is_exit_volume = 1;
        sprintf(this_box_volume.p_physics->name,"Exit");
    } else {
        #ifndef MATERIAL_DETECTOR
            printf("Need to define a material before refering to it in a geometry %s.\n",NAME_CURRENT_COMP);
            exit(1);
        #endif
        for (loop_index=0;loop_index<global_material_list.num_elements;loop_index++) {
            if (0 == strcmp(material_string,global_material_list.elements[loop_index].name)) {
                this_box_volume.p_physics = global_material_list.elements[loop_index].physics;
                break;
            }
            if (loop_index == global_material_list.num_elements-1) {
            printf("\n");
            printf("ERROR: The material string \"%s\" in Union geometry \"%s\" did not match a specified material. \n",material_string,NAME_CURRENT_COMP);
            printf("       The materials available at this point (need to be defined before the geometry): \n");
            for (loop_index=0;loop_index<global_material_list.num_elements;loop_index++)
              printf("         %s\n",global_material_list.elements[loop_index].name);
            printf("\n");
            printf("       It is also possible to use one of the defualt materials avaiable: \n");
            printf("           Vacuum (for a Volume without scattering or absorption)\n");
            printf("           Exit (for a Volume where the ray exits the component if it enters)\n");
            printf("           Mask (for a Volume that masks existing volumes specified in the mask_string\n");
            exit(1);
          }
        }
    }
} else {
    // Automatic linking, simply using the last defined material.
    #ifndef MATERIAL_DETECTOR
        printf("Need to define a material before the geometry to use automatic linking %s.\n",NAME_CURRENT_COMP);
        exit(1);
    #endif
    this_box_volume.p_physics = global_material_list.elements[global_material_list.num_elements-1].physics;
}

sprintf(this_box_volume.name,NAME_CURRENT_COMP);
sprintf(this_box_volume.geometry.shape,"box");
this_box_volume.geometry.priority_value = priority;
this_box_volume.geometry.geometry_p_interact = p_interact;
// Currently the coordinates will be in absolute space.
this_box_volume.geometry.center = POS_A_CURRENT_COMP;

this_box_storage.z_depth = zdepth;
this_box_storage.x_width1 = xwidth;
this_box_storage.y_height1 = yheight;

this_box_storage.is_rectangle = 0;
if (xwidth2 < 0 && yheight2 < 0) this_box_storage.is_rectangle = 1;
if (xwidth == xwidth2 && yheight == yheight2) this_box_storage.is_rectangle = 1;

if (xwidth2 < 0) {
    this_box_storage.x_width2 = xwidth;
    xwidth2 = xwidth;
} else this_box_storage.x_width2 = xwidth2;

if (yheight2 < 0) {
    this_box_storage.y_height2 = yheight;
    yheight2 = yheight;
} else this_box_storage.y_height2 = yheight2;


this_box_storage.normal_vectors[0] = coords_set(0,0,1);
this_box_storage.normal_vectors[1] = coords_set(0,0,1);

// for sides with y component = 0
x_component = 2*zdepth/sqrt((xwidth-xwidth2)*(xwidth-xwidth2)+4*zdepth*zdepth);
z_component = (xwidth-xwidth2)/sqrt(4*zdepth*zdepth+(xwidth-xwidth2)*(xwidth-xwidth2));

this_box_storage.normal_vectors[2] = coords_set(x_component,0,z_component);
this_box_storage.normal_vectors[3] = coords_set(-x_component,0,z_component);

// for sides with x component = 0
y_component = 2*zdepth/sqrt((yheight-yheight2)*(yheight-yheight2)+4*zdepth*zdepth);
z_component = (yheight-yheight2)/sqrt(4*zdepth*zdepth+(yheight-yheight2)*(yheight-yheight2));

this_box_storage.normal_vectors[4] = coords_set(0,y_component,z_component);
this_box_storage.normal_vectors[5] = coords_set(0,-y_component,z_component);

this_box_volume.geometry.visualization_on = visualize;

this_box_volume.geometry.geometry_parameters.p_box_storage = &this_box_storage;

// Assign pointers to functions for intersection with the shape, checking if a point is inside the shape
if (this_box_storage.is_rectangle == 1) {
this_box_volume.geometry.intersect_function = &sample_box_intersect_simple;
this_box_volume.geometry.within_function = &r_within_box_simple;
}
else {
this_box_volume.geometry.intersect_function = &sample_box_intersect_advanced;
this_box_volume.geometry.within_function = &r_within_box_advanced;
}

this_box_volume.geometry.shell_points = &box_shell_points;
this_box_volume.geometry.mcdisplay_function = &mcdisplay_box_function;
this_box_volume.geometry.initialize_from_main_function = &initialize_box_geometry_from_main_component;
this_box_volume.geometry.process_rot_allocated = 0;

this_box_volume.geometry.copy_geometry_parameters = &allocate_box_storage_copy;

rot_copy(this_box_volume.geometry.rotation_matrix,ROT_A_CURRENT_COMP); //check how ROT_R_CURRENT_COMP would work
rot_transpose(ROT_A_CURRENT_COMP,this_box_volume.geometry.transpose_rotation_matrix);

// Initialize loggers
this_box_volume.loggers.num_elements = 0;

// packing the information into the global_geometry_element, which is then included in the global_geometry_list.
sprintf(global_geometry_element.name,NAME_CURRENT_COMP);
global_geometry_element.activation_counter = number_of_activations;
global_geometry_element.component_index = INDEX_CURRENT_COMP;
global_geometry_element.Volume = &this_box_volume; // Would be nicer if this m was a pointer, now we have the (small) data two places
add_element_to_geometry_list(&global_geometry_list,global_geometry_element);
}
#line 219719 "MACS_sample_kidney_box.c"
#undef number_of_activations
#undef mask_setting
#undef mask_string
#undef p_interact
#undef focus_r
#undef focus_xh
#undef focus_xw
#undef focus_ah
#undef focus_aw
#undef target_z
#undef target_y
#undef target_x
#undef target_index
#undef visualize
#undef yheight2
#undef xwidth2
#undef zdepth
#undef yheight
#undef xwidth
#undef priority
#undef material_string
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

  /* Initializations for component channel_6_analyzer_1_array_crystal_array_5. */
  SIG_MESSAGE("channel_6_analyzer_1_array_crystal_array_5 (Init)");
#define mccompcurname  channel_6_analyzer_1_array_crystal_array_5
#define mccompcurtype  Union_box
#define mccompcurindex 363
#define loop_index mccchannel_6_analyzer_1_array_crystal_array_5_loop_index
#define this_box_volume mccchannel_6_analyzer_1_array_crystal_array_5_this_box_volume
#define global_geometry_element mccchannel_6_analyzer_1_array_crystal_array_5_global_geometry_element
#define this_box_storage mccchannel_6_analyzer_1_array_crystal_array_5_this_box_storage
#define material_string mccchannel_6_analyzer_1_array_crystal_array_5_material_string
#define priority mccchannel_6_analyzer_1_array_crystal_array_5_priority
#define xwidth mccchannel_6_analyzer_1_array_crystal_array_5_xwidth
#define yheight mccchannel_6_analyzer_1_array_crystal_array_5_yheight
#define zdepth mccchannel_6_analyzer_1_array_crystal_array_5_zdepth
#define xwidth2 mccchannel_6_analyzer_1_array_crystal_array_5_xwidth2
#define yheight2 mccchannel_6_analyzer_1_array_crystal_array_5_yheight2
#define visualize mccchannel_6_analyzer_1_array_crystal_array_5_visualize
#define target_index mccchannel_6_analyzer_1_array_crystal_array_5_target_index
#define target_x mccchannel_6_analyzer_1_array_crystal_array_5_target_x
#define target_y mccchannel_6_analyzer_1_array_crystal_array_5_target_y
#define target_z mccchannel_6_analyzer_1_array_crystal_array_5_target_z
#define focus_aw mccchannel_6_analyzer_1_array_crystal_array_5_focus_aw
#define focus_ah mccchannel_6_analyzer_1_array_crystal_array_5_focus_ah
#define focus_xw mccchannel_6_analyzer_1_array_crystal_array_5_focus_xw
#define focus_xh mccchannel_6_analyzer_1_array_crystal_array_5_focus_xh
#define focus_r mccchannel_6_analyzer_1_array_crystal_array_5_focus_r
#define p_interact mccchannel_6_analyzer_1_array_crystal_array_5_p_interact
#define mask_string mccchannel_6_analyzer_1_array_crystal_array_5_mask_string
#define mask_setting mccchannel_6_analyzer_1_array_crystal_array_5_mask_setting
#define number_of_activations mccchannel_6_analyzer_1_array_crystal_array_5_number_of_activations
#line 224 "Union_box.comp"
{
// Initializes the focusing system for this volume including input sanitation.
focus_initialize(&this_box_volume.geometry, POS_A_COMP_INDEX(INDEX_CURRENT_COMP+target_index), POS_A_CURRENT_COMP, ROT_A_CURRENT_COMP, target_index, target_x, target_y, target_z, focus_aw, focus_ah, focus_xw, focus_xh, focus_r, NAME_CURRENT_COMP);

// Input sanitation for this geometry
if (xwidth <= 0) {
  printf("\nERROR in Union_box named %s, the xwidth is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (yheight <= 0) {
  printf("\nERROR in Union_box named %s, yheight is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (zdepth <= 0) {
  printf("\nERROR in Union_box named %s, zdepth is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (xwidth2 <= 0 && xwidth2 != -1) {
  printf("\nERROR in Union_box named %s, the xwidth2 is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (yheight2 <= 0 && yheight2 != -1) {
  printf("\nERROR in Union_box named %s, yheight2 is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}

// Use sanitation
if (global_material_list.num_elements == 0) {
  printf("\nERROR: Need to define a material using Union_make_material before using a Union geometry component. \n");
  printf("       %s was defined before first use of Union_make_material.\n",NAME_CURRENT_COMP);
  exit(1);
}

this_box_volume.geometry.is_masked_volume = 0;
this_box_volume.geometry.is_exit_volume = 0;
this_box_volume.geometry.is_mask_volume = 0;
// check if the volume is a mask, if it is the material string is irelevant.
if (mask_string && strlen(mask_string) && strcmp(mask_string, "NULL") && strcmp(mask_string, "0")) {
    // A mask volume is used to limit the extend of other volumes, called the masked volumes. These are specified in the mask_string.
    // In order for a ray to enter a masked volume, it needs to be both in the region covered by that volume AND the mask volume.
    // When more than
    this_box_volume.geometry.mask_mode = 1; // Default is mask mode is ALL
    if (mask_setting && strlen(mask_setting) && strcmp(mask_setting, "NULL") && strcmp(mask_setting, "0")) {
        if (strcmp(mask_setting,"ALL") == 0 || strcmp(mask_setting,"All") == 0) this_box_volume.geometry.mask_mode = 1;
        else if (strcmp(mask_setting,"ANY") == 0 || strcmp(mask_setting,"Any") == 0) this_box_volume.geometry.mask_mode = 2;
        else {
            printf("The mask_mode of component %s is set to %s, but must be either ALL or ANY.\n",NAME_CURRENT_COMP,mask_setting);
            exit(1);
        }
    }
    
    for (loop_index=0;loop_index<global_geometry_list.num_elements;loop_index++) {
        // Add mask list
        if (1 == manual_linking_function(global_geometry_list.elements[loop_index].name,mask_string)) {
            add_element_to_int_list(&this_box_volume.geometry.mask_list,global_geometry_list.elements[loop_index].component_index);
            add_element_to_int_list(&global_geometry_list.elements[loop_index].Volume->geometry.masked_by_list,INDEX_CURRENT_COMP);
            global_geometry_list.elements[loop_index].Volume->geometry.is_masked_volume = 1;
            if (this_box_volume.geometry.mask_mode == 2)
                global_geometry_list.elements[loop_index].Volume->geometry.mask_mode = 2;
            if (this_box_volume.geometry.mask_mode == 1) {
                if (global_geometry_list.elements[loop_index].Volume->geometry.is_masked_volume == 1 && global_geometry_list.elements[loop_index].Volume->geometry.mask_mode != 2)
                    // If more than one mask is added to one volume, the ANY mode overwrites the (default) ALL mode.
                    global_geometry_list.elements[loop_index].Volume->geometry.mask_mode = 1;
            }
            
            found_geometries = 1;
        }
    }
    if (found_geometries == 0) {
        printf("The mask_string in geometry: %s did not find any of the specified volumes in the mask_string %s \n",NAME_CURRENT_COMP,mask_string);
        exit(1);
    }
    this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
    this_box_volume.p_physics->is_vacuum = 0; // Makes this volume a vacuum
    this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
    this_box_volume.p_physics->my_a = 0; // Should not be used.
    sprintf(this_box_volume.p_physics->name,"Mask");
    this_box_volume.geometry.is_mask_volume = 1;
    
    
// Read the material input, or if it lacks, use automatic linking.
} else if (material_string && strlen(material_string) && strcmp(material_string, "NULL") && strcmp(material_string, "0")) {
    // A geometry string was given, use it to determine which material
    if (0 == strcmp(material_string,"vacuum") || 0 == strcmp(material_string,"Vacuum")) {
        // One could have a global physics struct for vacuum instead of creating one for each
        this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
        this_box_volume.p_physics->is_vacuum = 1; // Makes this volume a vacuum
        this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
        this_box_volume.p_physics->my_a = 0; // Should not be used.
        sprintf(this_box_volume.p_physics->name,"Vacuum");
    } else if (0 == strcmp(material_string,"exit") || 0 == strcmp(material_string,"Exit")) {
        // One could have a global physics struct for vacuum instead of creating one for each
        this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
        this_box_volume.p_physics->is_vacuum = 1; // Makes this volume a vacuum
        this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
        this_box_volume.p_physics->my_a = 0; // Should not be used.
        this_box_volume.geometry.is_exit_volume = 1;
        sprintf(this_box_volume.p_physics->name,"Exit");
    } else {
        #ifndef MATERIAL_DETECTOR
            printf("Need to define a material before refering to it in a geometry %s.\n",NAME_CURRENT_COMP);
            exit(1);
        #endif
        for (loop_index=0;loop_index<global_material_list.num_elements;loop_index++) {
            if (0 == strcmp(material_string,global_material_list.elements[loop_index].name)) {
                this_box_volume.p_physics = global_material_list.elements[loop_index].physics;
                break;
            }
            if (loop_index == global_material_list.num_elements-1) {
            printf("\n");
            printf("ERROR: The material string \"%s\" in Union geometry \"%s\" did not match a specified material. \n",material_string,NAME_CURRENT_COMP);
            printf("       The materials available at this point (need to be defined before the geometry): \n");
            for (loop_index=0;loop_index<global_material_list.num_elements;loop_index++)
              printf("         %s\n",global_material_list.elements[loop_index].name);
            printf("\n");
            printf("       It is also possible to use one of the defualt materials avaiable: \n");
            printf("           Vacuum (for a Volume without scattering or absorption)\n");
            printf("           Exit (for a Volume where the ray exits the component if it enters)\n");
            printf("           Mask (for a Volume that masks existing volumes specified in the mask_string\n");
            exit(1);
          }
        }
    }
} else {
    // Automatic linking, simply using the last defined material.
    #ifndef MATERIAL_DETECTOR
        printf("Need to define a material before the geometry to use automatic linking %s.\n",NAME_CURRENT_COMP);
        exit(1);
    #endif
    this_box_volume.p_physics = global_material_list.elements[global_material_list.num_elements-1].physics;
}

sprintf(this_box_volume.name,NAME_CURRENT_COMP);
sprintf(this_box_volume.geometry.shape,"box");
this_box_volume.geometry.priority_value = priority;
this_box_volume.geometry.geometry_p_interact = p_interact;
// Currently the coordinates will be in absolute space.
this_box_volume.geometry.center = POS_A_CURRENT_COMP;

this_box_storage.z_depth = zdepth;
this_box_storage.x_width1 = xwidth;
this_box_storage.y_height1 = yheight;

this_box_storage.is_rectangle = 0;
if (xwidth2 < 0 && yheight2 < 0) this_box_storage.is_rectangle = 1;
if (xwidth == xwidth2 && yheight == yheight2) this_box_storage.is_rectangle = 1;

if (xwidth2 < 0) {
    this_box_storage.x_width2 = xwidth;
    xwidth2 = xwidth;
} else this_box_storage.x_width2 = xwidth2;

if (yheight2 < 0) {
    this_box_storage.y_height2 = yheight;
    yheight2 = yheight;
} else this_box_storage.y_height2 = yheight2;


this_box_storage.normal_vectors[0] = coords_set(0,0,1);
this_box_storage.normal_vectors[1] = coords_set(0,0,1);

// for sides with y component = 0
x_component = 2*zdepth/sqrt((xwidth-xwidth2)*(xwidth-xwidth2)+4*zdepth*zdepth);
z_component = (xwidth-xwidth2)/sqrt(4*zdepth*zdepth+(xwidth-xwidth2)*(xwidth-xwidth2));

this_box_storage.normal_vectors[2] = coords_set(x_component,0,z_component);
this_box_storage.normal_vectors[3] = coords_set(-x_component,0,z_component);

// for sides with x component = 0
y_component = 2*zdepth/sqrt((yheight-yheight2)*(yheight-yheight2)+4*zdepth*zdepth);
z_component = (yheight-yheight2)/sqrt(4*zdepth*zdepth+(yheight-yheight2)*(yheight-yheight2));

this_box_storage.normal_vectors[4] = coords_set(0,y_component,z_component);
this_box_storage.normal_vectors[5] = coords_set(0,-y_component,z_component);

this_box_volume.geometry.visualization_on = visualize;

this_box_volume.geometry.geometry_parameters.p_box_storage = &this_box_storage;

// Assign pointers to functions for intersection with the shape, checking if a point is inside the shape
if (this_box_storage.is_rectangle == 1) {
this_box_volume.geometry.intersect_function = &sample_box_intersect_simple;
this_box_volume.geometry.within_function = &r_within_box_simple;
}
else {
this_box_volume.geometry.intersect_function = &sample_box_intersect_advanced;
this_box_volume.geometry.within_function = &r_within_box_advanced;
}

this_box_volume.geometry.shell_points = &box_shell_points;
this_box_volume.geometry.mcdisplay_function = &mcdisplay_box_function;
this_box_volume.geometry.initialize_from_main_function = &initialize_box_geometry_from_main_component;
this_box_volume.geometry.process_rot_allocated = 0;

this_box_volume.geometry.copy_geometry_parameters = &allocate_box_storage_copy;

rot_copy(this_box_volume.geometry.rotation_matrix,ROT_A_CURRENT_COMP); //check how ROT_R_CURRENT_COMP would work
rot_transpose(ROT_A_CURRENT_COMP,this_box_volume.geometry.transpose_rotation_matrix);

// Initialize loggers
this_box_volume.loggers.num_elements = 0;

// packing the information into the global_geometry_element, which is then included in the global_geometry_list.
sprintf(global_geometry_element.name,NAME_CURRENT_COMP);
global_geometry_element.activation_counter = number_of_activations;
global_geometry_element.component_index = INDEX_CURRENT_COMP;
global_geometry_element.Volume = &this_box_volume; // Would be nicer if this m was a pointer, now we have the (small) data two places
add_element_to_geometry_list(&global_geometry_list,global_geometry_element);
}
#line 219989 "MACS_sample_kidney_box.c"
#undef number_of_activations
#undef mask_setting
#undef mask_string
#undef p_interact
#undef focus_r
#undef focus_xh
#undef focus_xw
#undef focus_ah
#undef focus_aw
#undef target_z
#undef target_y
#undef target_x
#undef target_index
#undef visualize
#undef yheight2
#undef xwidth2
#undef zdepth
#undef yheight
#undef xwidth
#undef priority
#undef material_string
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

  /* Initializations for component channel_6_analyzer_1_array_crystal_array_6. */
  SIG_MESSAGE("channel_6_analyzer_1_array_crystal_array_6 (Init)");
#define mccompcurname  channel_6_analyzer_1_array_crystal_array_6
#define mccompcurtype  Union_box
#define mccompcurindex 364
#define loop_index mccchannel_6_analyzer_1_array_crystal_array_6_loop_index
#define this_box_volume mccchannel_6_analyzer_1_array_crystal_array_6_this_box_volume
#define global_geometry_element mccchannel_6_analyzer_1_array_crystal_array_6_global_geometry_element
#define this_box_storage mccchannel_6_analyzer_1_array_crystal_array_6_this_box_storage
#define material_string mccchannel_6_analyzer_1_array_crystal_array_6_material_string
#define priority mccchannel_6_analyzer_1_array_crystal_array_6_priority
#define xwidth mccchannel_6_analyzer_1_array_crystal_array_6_xwidth
#define yheight mccchannel_6_analyzer_1_array_crystal_array_6_yheight
#define zdepth mccchannel_6_analyzer_1_array_crystal_array_6_zdepth
#define xwidth2 mccchannel_6_analyzer_1_array_crystal_array_6_xwidth2
#define yheight2 mccchannel_6_analyzer_1_array_crystal_array_6_yheight2
#define visualize mccchannel_6_analyzer_1_array_crystal_array_6_visualize
#define target_index mccchannel_6_analyzer_1_array_crystal_array_6_target_index
#define target_x mccchannel_6_analyzer_1_array_crystal_array_6_target_x
#define target_y mccchannel_6_analyzer_1_array_crystal_array_6_target_y
#define target_z mccchannel_6_analyzer_1_array_crystal_array_6_target_z
#define focus_aw mccchannel_6_analyzer_1_array_crystal_array_6_focus_aw
#define focus_ah mccchannel_6_analyzer_1_array_crystal_array_6_focus_ah
#define focus_xw mccchannel_6_analyzer_1_array_crystal_array_6_focus_xw
#define focus_xh mccchannel_6_analyzer_1_array_crystal_array_6_focus_xh
#define focus_r mccchannel_6_analyzer_1_array_crystal_array_6_focus_r
#define p_interact mccchannel_6_analyzer_1_array_crystal_array_6_p_interact
#define mask_string mccchannel_6_analyzer_1_array_crystal_array_6_mask_string
#define mask_setting mccchannel_6_analyzer_1_array_crystal_array_6_mask_setting
#define number_of_activations mccchannel_6_analyzer_1_array_crystal_array_6_number_of_activations
#line 224 "Union_box.comp"
{
// Initializes the focusing system for this volume including input sanitation.
focus_initialize(&this_box_volume.geometry, POS_A_COMP_INDEX(INDEX_CURRENT_COMP+target_index), POS_A_CURRENT_COMP, ROT_A_CURRENT_COMP, target_index, target_x, target_y, target_z, focus_aw, focus_ah, focus_xw, focus_xh, focus_r, NAME_CURRENT_COMP);

// Input sanitation for this geometry
if (xwidth <= 0) {
  printf("\nERROR in Union_box named %s, the xwidth is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (yheight <= 0) {
  printf("\nERROR in Union_box named %s, yheight is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (zdepth <= 0) {
  printf("\nERROR in Union_box named %s, zdepth is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (xwidth2 <= 0 && xwidth2 != -1) {
  printf("\nERROR in Union_box named %s, the xwidth2 is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (yheight2 <= 0 && yheight2 != -1) {
  printf("\nERROR in Union_box named %s, yheight2 is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}

// Use sanitation
if (global_material_list.num_elements == 0) {
  printf("\nERROR: Need to define a material using Union_make_material before using a Union geometry component. \n");
  printf("       %s was defined before first use of Union_make_material.\n",NAME_CURRENT_COMP);
  exit(1);
}

this_box_volume.geometry.is_masked_volume = 0;
this_box_volume.geometry.is_exit_volume = 0;
this_box_volume.geometry.is_mask_volume = 0;
// check if the volume is a mask, if it is the material string is irelevant.
if (mask_string && strlen(mask_string) && strcmp(mask_string, "NULL") && strcmp(mask_string, "0")) {
    // A mask volume is used to limit the extend of other volumes, called the masked volumes. These are specified in the mask_string.
    // In order for a ray to enter a masked volume, it needs to be both in the region covered by that volume AND the mask volume.
    // When more than
    this_box_volume.geometry.mask_mode = 1; // Default is mask mode is ALL
    if (mask_setting && strlen(mask_setting) && strcmp(mask_setting, "NULL") && strcmp(mask_setting, "0")) {
        if (strcmp(mask_setting,"ALL") == 0 || strcmp(mask_setting,"All") == 0) this_box_volume.geometry.mask_mode = 1;
        else if (strcmp(mask_setting,"ANY") == 0 || strcmp(mask_setting,"Any") == 0) this_box_volume.geometry.mask_mode = 2;
        else {
            printf("The mask_mode of component %s is set to %s, but must be either ALL or ANY.\n",NAME_CURRENT_COMP,mask_setting);
            exit(1);
        }
    }
    
    for (loop_index=0;loop_index<global_geometry_list.num_elements;loop_index++) {
        // Add mask list
        if (1 == manual_linking_function(global_geometry_list.elements[loop_index].name,mask_string)) {
            add_element_to_int_list(&this_box_volume.geometry.mask_list,global_geometry_list.elements[loop_index].component_index);
            add_element_to_int_list(&global_geometry_list.elements[loop_index].Volume->geometry.masked_by_list,INDEX_CURRENT_COMP);
            global_geometry_list.elements[loop_index].Volume->geometry.is_masked_volume = 1;
            if (this_box_volume.geometry.mask_mode == 2)
                global_geometry_list.elements[loop_index].Volume->geometry.mask_mode = 2;
            if (this_box_volume.geometry.mask_mode == 1) {
                if (global_geometry_list.elements[loop_index].Volume->geometry.is_masked_volume == 1 && global_geometry_list.elements[loop_index].Volume->geometry.mask_mode != 2)
                    // If more than one mask is added to one volume, the ANY mode overwrites the (default) ALL mode.
                    global_geometry_list.elements[loop_index].Volume->geometry.mask_mode = 1;
            }
            
            found_geometries = 1;
        }
    }
    if (found_geometries == 0) {
        printf("The mask_string in geometry: %s did not find any of the specified volumes in the mask_string %s \n",NAME_CURRENT_COMP,mask_string);
        exit(1);
    }
    this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
    this_box_volume.p_physics->is_vacuum = 0; // Makes this volume a vacuum
    this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
    this_box_volume.p_physics->my_a = 0; // Should not be used.
    sprintf(this_box_volume.p_physics->name,"Mask");
    this_box_volume.geometry.is_mask_volume = 1;
    
    
// Read the material input, or if it lacks, use automatic linking.
} else if (material_string && strlen(material_string) && strcmp(material_string, "NULL") && strcmp(material_string, "0")) {
    // A geometry string was given, use it to determine which material
    if (0 == strcmp(material_string,"vacuum") || 0 == strcmp(material_string,"Vacuum")) {
        // One could have a global physics struct for vacuum instead of creating one for each
        this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
        this_box_volume.p_physics->is_vacuum = 1; // Makes this volume a vacuum
        this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
        this_box_volume.p_physics->my_a = 0; // Should not be used.
        sprintf(this_box_volume.p_physics->name,"Vacuum");
    } else if (0 == strcmp(material_string,"exit") || 0 == strcmp(material_string,"Exit")) {
        // One could have a global physics struct for vacuum instead of creating one for each
        this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
        this_box_volume.p_physics->is_vacuum = 1; // Makes this volume a vacuum
        this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
        this_box_volume.p_physics->my_a = 0; // Should not be used.
        this_box_volume.geometry.is_exit_volume = 1;
        sprintf(this_box_volume.p_physics->name,"Exit");
    } else {
        #ifndef MATERIAL_DETECTOR
            printf("Need to define a material before refering to it in a geometry %s.\n",NAME_CURRENT_COMP);
            exit(1);
        #endif
        for (loop_index=0;loop_index<global_material_list.num_elements;loop_index++) {
            if (0 == strcmp(material_string,global_material_list.elements[loop_index].name)) {
                this_box_volume.p_physics = global_material_list.elements[loop_index].physics;
                break;
            }
            if (loop_index == global_material_list.num_elements-1) {
            printf("\n");
            printf("ERROR: The material string \"%s\" in Union geometry \"%s\" did not match a specified material. \n",material_string,NAME_CURRENT_COMP);
            printf("       The materials available at this point (need to be defined before the geometry): \n");
            for (loop_index=0;loop_index<global_material_list.num_elements;loop_index++)
              printf("         %s\n",global_material_list.elements[loop_index].name);
            printf("\n");
            printf("       It is also possible to use one of the defualt materials avaiable: \n");
            printf("           Vacuum (for a Volume without scattering or absorption)\n");
            printf("           Exit (for a Volume where the ray exits the component if it enters)\n");
            printf("           Mask (for a Volume that masks existing volumes specified in the mask_string\n");
            exit(1);
          }
        }
    }
} else {
    // Automatic linking, simply using the last defined material.
    #ifndef MATERIAL_DETECTOR
        printf("Need to define a material before the geometry to use automatic linking %s.\n",NAME_CURRENT_COMP);
        exit(1);
    #endif
    this_box_volume.p_physics = global_material_list.elements[global_material_list.num_elements-1].physics;
}

sprintf(this_box_volume.name,NAME_CURRENT_COMP);
sprintf(this_box_volume.geometry.shape,"box");
this_box_volume.geometry.priority_value = priority;
this_box_volume.geometry.geometry_p_interact = p_interact;
// Currently the coordinates will be in absolute space.
this_box_volume.geometry.center = POS_A_CURRENT_COMP;

this_box_storage.z_depth = zdepth;
this_box_storage.x_width1 = xwidth;
this_box_storage.y_height1 = yheight;

this_box_storage.is_rectangle = 0;
if (xwidth2 < 0 && yheight2 < 0) this_box_storage.is_rectangle = 1;
if (xwidth == xwidth2 && yheight == yheight2) this_box_storage.is_rectangle = 1;

if (xwidth2 < 0) {
    this_box_storage.x_width2 = xwidth;
    xwidth2 = xwidth;
} else this_box_storage.x_width2 = xwidth2;

if (yheight2 < 0) {
    this_box_storage.y_height2 = yheight;
    yheight2 = yheight;
} else this_box_storage.y_height2 = yheight2;


this_box_storage.normal_vectors[0] = coords_set(0,0,1);
this_box_storage.normal_vectors[1] = coords_set(0,0,1);

// for sides with y component = 0
x_component = 2*zdepth/sqrt((xwidth-xwidth2)*(xwidth-xwidth2)+4*zdepth*zdepth);
z_component = (xwidth-xwidth2)/sqrt(4*zdepth*zdepth+(xwidth-xwidth2)*(xwidth-xwidth2));

this_box_storage.normal_vectors[2] = coords_set(x_component,0,z_component);
this_box_storage.normal_vectors[3] = coords_set(-x_component,0,z_component);

// for sides with x component = 0
y_component = 2*zdepth/sqrt((yheight-yheight2)*(yheight-yheight2)+4*zdepth*zdepth);
z_component = (yheight-yheight2)/sqrt(4*zdepth*zdepth+(yheight-yheight2)*(yheight-yheight2));

this_box_storage.normal_vectors[4] = coords_set(0,y_component,z_component);
this_box_storage.normal_vectors[5] = coords_set(0,-y_component,z_component);

this_box_volume.geometry.visualization_on = visualize;

this_box_volume.geometry.geometry_parameters.p_box_storage = &this_box_storage;

// Assign pointers to functions for intersection with the shape, checking if a point is inside the shape
if (this_box_storage.is_rectangle == 1) {
this_box_volume.geometry.intersect_function = &sample_box_intersect_simple;
this_box_volume.geometry.within_function = &r_within_box_simple;
}
else {
this_box_volume.geometry.intersect_function = &sample_box_intersect_advanced;
this_box_volume.geometry.within_function = &r_within_box_advanced;
}

this_box_volume.geometry.shell_points = &box_shell_points;
this_box_volume.geometry.mcdisplay_function = &mcdisplay_box_function;
this_box_volume.geometry.initialize_from_main_function = &initialize_box_geometry_from_main_component;
this_box_volume.geometry.process_rot_allocated = 0;

this_box_volume.geometry.copy_geometry_parameters = &allocate_box_storage_copy;

rot_copy(this_box_volume.geometry.rotation_matrix,ROT_A_CURRENT_COMP); //check how ROT_R_CURRENT_COMP would work
rot_transpose(ROT_A_CURRENT_COMP,this_box_volume.geometry.transpose_rotation_matrix);

// Initialize loggers
this_box_volume.loggers.num_elements = 0;

// packing the information into the global_geometry_element, which is then included in the global_geometry_list.
sprintf(global_geometry_element.name,NAME_CURRENT_COMP);
global_geometry_element.activation_counter = number_of_activations;
global_geometry_element.component_index = INDEX_CURRENT_COMP;
global_geometry_element.Volume = &this_box_volume; // Would be nicer if this m was a pointer, now we have the (small) data two places
add_element_to_geometry_list(&global_geometry_list,global_geometry_element);
}
#line 220259 "MACS_sample_kidney_box.c"
#undef number_of_activations
#undef mask_setting
#undef mask_string
#undef p_interact
#undef focus_r
#undef focus_xh
#undef focus_xw
#undef focus_ah
#undef focus_aw
#undef target_z
#undef target_y
#undef target_x
#undef target_index
#undef visualize
#undef yheight2
#undef xwidth2
#undef zdepth
#undef yheight
#undef xwidth
#undef priority
#undef material_string
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

  /* Initializations for component channel_6_analyzer_1_array_crystal_array_7. */
  SIG_MESSAGE("channel_6_analyzer_1_array_crystal_array_7 (Init)");
#define mccompcurname  channel_6_analyzer_1_array_crystal_array_7
#define mccompcurtype  Union_box
#define mccompcurindex 365
#define loop_index mccchannel_6_analyzer_1_array_crystal_array_7_loop_index
#define this_box_volume mccchannel_6_analyzer_1_array_crystal_array_7_this_box_volume
#define global_geometry_element mccchannel_6_analyzer_1_array_crystal_array_7_global_geometry_element
#define this_box_storage mccchannel_6_analyzer_1_array_crystal_array_7_this_box_storage
#define material_string mccchannel_6_analyzer_1_array_crystal_array_7_material_string
#define priority mccchannel_6_analyzer_1_array_crystal_array_7_priority
#define xwidth mccchannel_6_analyzer_1_array_crystal_array_7_xwidth
#define yheight mccchannel_6_analyzer_1_array_crystal_array_7_yheight
#define zdepth mccchannel_6_analyzer_1_array_crystal_array_7_zdepth
#define xwidth2 mccchannel_6_analyzer_1_array_crystal_array_7_xwidth2
#define yheight2 mccchannel_6_analyzer_1_array_crystal_array_7_yheight2
#define visualize mccchannel_6_analyzer_1_array_crystal_array_7_visualize
#define target_index mccchannel_6_analyzer_1_array_crystal_array_7_target_index
#define target_x mccchannel_6_analyzer_1_array_crystal_array_7_target_x
#define target_y mccchannel_6_analyzer_1_array_crystal_array_7_target_y
#define target_z mccchannel_6_analyzer_1_array_crystal_array_7_target_z
#define focus_aw mccchannel_6_analyzer_1_array_crystal_array_7_focus_aw
#define focus_ah mccchannel_6_analyzer_1_array_crystal_array_7_focus_ah
#define focus_xw mccchannel_6_analyzer_1_array_crystal_array_7_focus_xw
#define focus_xh mccchannel_6_analyzer_1_array_crystal_array_7_focus_xh
#define focus_r mccchannel_6_analyzer_1_array_crystal_array_7_focus_r
#define p_interact mccchannel_6_analyzer_1_array_crystal_array_7_p_interact
#define mask_string mccchannel_6_analyzer_1_array_crystal_array_7_mask_string
#define mask_setting mccchannel_6_analyzer_1_array_crystal_array_7_mask_setting
#define number_of_activations mccchannel_6_analyzer_1_array_crystal_array_7_number_of_activations
#line 224 "Union_box.comp"
{
// Initializes the focusing system for this volume including input sanitation.
focus_initialize(&this_box_volume.geometry, POS_A_COMP_INDEX(INDEX_CURRENT_COMP+target_index), POS_A_CURRENT_COMP, ROT_A_CURRENT_COMP, target_index, target_x, target_y, target_z, focus_aw, focus_ah, focus_xw, focus_xh, focus_r, NAME_CURRENT_COMP);

// Input sanitation for this geometry
if (xwidth <= 0) {
  printf("\nERROR in Union_box named %s, the xwidth is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (yheight <= 0) {
  printf("\nERROR in Union_box named %s, yheight is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (zdepth <= 0) {
  printf("\nERROR in Union_box named %s, zdepth is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (xwidth2 <= 0 && xwidth2 != -1) {
  printf("\nERROR in Union_box named %s, the xwidth2 is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (yheight2 <= 0 && yheight2 != -1) {
  printf("\nERROR in Union_box named %s, yheight2 is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}

// Use sanitation
if (global_material_list.num_elements == 0) {
  printf("\nERROR: Need to define a material using Union_make_material before using a Union geometry component. \n");
  printf("       %s was defined before first use of Union_make_material.\n",NAME_CURRENT_COMP);
  exit(1);
}

this_box_volume.geometry.is_masked_volume = 0;
this_box_volume.geometry.is_exit_volume = 0;
this_box_volume.geometry.is_mask_volume = 0;
// check if the volume is a mask, if it is the material string is irelevant.
if (mask_string && strlen(mask_string) && strcmp(mask_string, "NULL") && strcmp(mask_string, "0")) {
    // A mask volume is used to limit the extend of other volumes, called the masked volumes. These are specified in the mask_string.
    // In order for a ray to enter a masked volume, it needs to be both in the region covered by that volume AND the mask volume.
    // When more than
    this_box_volume.geometry.mask_mode = 1; // Default is mask mode is ALL
    if (mask_setting && strlen(mask_setting) && strcmp(mask_setting, "NULL") && strcmp(mask_setting, "0")) {
        if (strcmp(mask_setting,"ALL") == 0 || strcmp(mask_setting,"All") == 0) this_box_volume.geometry.mask_mode = 1;
        else if (strcmp(mask_setting,"ANY") == 0 || strcmp(mask_setting,"Any") == 0) this_box_volume.geometry.mask_mode = 2;
        else {
            printf("The mask_mode of component %s is set to %s, but must be either ALL or ANY.\n",NAME_CURRENT_COMP,mask_setting);
            exit(1);
        }
    }
    
    for (loop_index=0;loop_index<global_geometry_list.num_elements;loop_index++) {
        // Add mask list
        if (1 == manual_linking_function(global_geometry_list.elements[loop_index].name,mask_string)) {
            add_element_to_int_list(&this_box_volume.geometry.mask_list,global_geometry_list.elements[loop_index].component_index);
            add_element_to_int_list(&global_geometry_list.elements[loop_index].Volume->geometry.masked_by_list,INDEX_CURRENT_COMP);
            global_geometry_list.elements[loop_index].Volume->geometry.is_masked_volume = 1;
            if (this_box_volume.geometry.mask_mode == 2)
                global_geometry_list.elements[loop_index].Volume->geometry.mask_mode = 2;
            if (this_box_volume.geometry.mask_mode == 1) {
                if (global_geometry_list.elements[loop_index].Volume->geometry.is_masked_volume == 1 && global_geometry_list.elements[loop_index].Volume->geometry.mask_mode != 2)
                    // If more than one mask is added to one volume, the ANY mode overwrites the (default) ALL mode.
                    global_geometry_list.elements[loop_index].Volume->geometry.mask_mode = 1;
            }
            
            found_geometries = 1;
        }
    }
    if (found_geometries == 0) {
        printf("The mask_string in geometry: %s did not find any of the specified volumes in the mask_string %s \n",NAME_CURRENT_COMP,mask_string);
        exit(1);
    }
    this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
    this_box_volume.p_physics->is_vacuum = 0; // Makes this volume a vacuum
    this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
    this_box_volume.p_physics->my_a = 0; // Should not be used.
    sprintf(this_box_volume.p_physics->name,"Mask");
    this_box_volume.geometry.is_mask_volume = 1;
    
    
// Read the material input, or if it lacks, use automatic linking.
} else if (material_string && strlen(material_string) && strcmp(material_string, "NULL") && strcmp(material_string, "0")) {
    // A geometry string was given, use it to determine which material
    if (0 == strcmp(material_string,"vacuum") || 0 == strcmp(material_string,"Vacuum")) {
        // One could have a global physics struct for vacuum instead of creating one for each
        this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
        this_box_volume.p_physics->is_vacuum = 1; // Makes this volume a vacuum
        this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
        this_box_volume.p_physics->my_a = 0; // Should not be used.
        sprintf(this_box_volume.p_physics->name,"Vacuum");
    } else if (0 == strcmp(material_string,"exit") || 0 == strcmp(material_string,"Exit")) {
        // One could have a global physics struct for vacuum instead of creating one for each
        this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
        this_box_volume.p_physics->is_vacuum = 1; // Makes this volume a vacuum
        this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
        this_box_volume.p_physics->my_a = 0; // Should not be used.
        this_box_volume.geometry.is_exit_volume = 1;
        sprintf(this_box_volume.p_physics->name,"Exit");
    } else {
        #ifndef MATERIAL_DETECTOR
            printf("Need to define a material before refering to it in a geometry %s.\n",NAME_CURRENT_COMP);
            exit(1);
        #endif
        for (loop_index=0;loop_index<global_material_list.num_elements;loop_index++) {
            if (0 == strcmp(material_string,global_material_list.elements[loop_index].name)) {
                this_box_volume.p_physics = global_material_list.elements[loop_index].physics;
                break;
            }
            if (loop_index == global_material_list.num_elements-1) {
            printf("\n");
            printf("ERROR: The material string \"%s\" in Union geometry \"%s\" did not match a specified material. \n",material_string,NAME_CURRENT_COMP);
            printf("       The materials available at this point (need to be defined before the geometry): \n");
            for (loop_index=0;loop_index<global_material_list.num_elements;loop_index++)
              printf("         %s\n",global_material_list.elements[loop_index].name);
            printf("\n");
            printf("       It is also possible to use one of the defualt materials avaiable: \n");
            printf("           Vacuum (for a Volume without scattering or absorption)\n");
            printf("           Exit (for a Volume where the ray exits the component if it enters)\n");
            printf("           Mask (for a Volume that masks existing volumes specified in the mask_string\n");
            exit(1);
          }
        }
    }
} else {
    // Automatic linking, simply using the last defined material.
    #ifndef MATERIAL_DETECTOR
        printf("Need to define a material before the geometry to use automatic linking %s.\n",NAME_CURRENT_COMP);
        exit(1);
    #endif
    this_box_volume.p_physics = global_material_list.elements[global_material_list.num_elements-1].physics;
}

sprintf(this_box_volume.name,NAME_CURRENT_COMP);
sprintf(this_box_volume.geometry.shape,"box");
this_box_volume.geometry.priority_value = priority;
this_box_volume.geometry.geometry_p_interact = p_interact;
// Currently the coordinates will be in absolute space.
this_box_volume.geometry.center = POS_A_CURRENT_COMP;

this_box_storage.z_depth = zdepth;
this_box_storage.x_width1 = xwidth;
this_box_storage.y_height1 = yheight;

this_box_storage.is_rectangle = 0;
if (xwidth2 < 0 && yheight2 < 0) this_box_storage.is_rectangle = 1;
if (xwidth == xwidth2 && yheight == yheight2) this_box_storage.is_rectangle = 1;

if (xwidth2 < 0) {
    this_box_storage.x_width2 = xwidth;
    xwidth2 = xwidth;
} else this_box_storage.x_width2 = xwidth2;

if (yheight2 < 0) {
    this_box_storage.y_height2 = yheight;
    yheight2 = yheight;
} else this_box_storage.y_height2 = yheight2;


this_box_storage.normal_vectors[0] = coords_set(0,0,1);
this_box_storage.normal_vectors[1] = coords_set(0,0,1);

// for sides with y component = 0
x_component = 2*zdepth/sqrt((xwidth-xwidth2)*(xwidth-xwidth2)+4*zdepth*zdepth);
z_component = (xwidth-xwidth2)/sqrt(4*zdepth*zdepth+(xwidth-xwidth2)*(xwidth-xwidth2));

this_box_storage.normal_vectors[2] = coords_set(x_component,0,z_component);
this_box_storage.normal_vectors[3] = coords_set(-x_component,0,z_component);

// for sides with x component = 0
y_component = 2*zdepth/sqrt((yheight-yheight2)*(yheight-yheight2)+4*zdepth*zdepth);
z_component = (yheight-yheight2)/sqrt(4*zdepth*zdepth+(yheight-yheight2)*(yheight-yheight2));

this_box_storage.normal_vectors[4] = coords_set(0,y_component,z_component);
this_box_storage.normal_vectors[5] = coords_set(0,-y_component,z_component);

this_box_volume.geometry.visualization_on = visualize;

this_box_volume.geometry.geometry_parameters.p_box_storage = &this_box_storage;

// Assign pointers to functions for intersection with the shape, checking if a point is inside the shape
if (this_box_storage.is_rectangle == 1) {
this_box_volume.geometry.intersect_function = &sample_box_intersect_simple;
this_box_volume.geometry.within_function = &r_within_box_simple;
}
else {
this_box_volume.geometry.intersect_function = &sample_box_intersect_advanced;
this_box_volume.geometry.within_function = &r_within_box_advanced;
}

this_box_volume.geometry.shell_points = &box_shell_points;
this_box_volume.geometry.mcdisplay_function = &mcdisplay_box_function;
this_box_volume.geometry.initialize_from_main_function = &initialize_box_geometry_from_main_component;
this_box_volume.geometry.process_rot_allocated = 0;

this_box_volume.geometry.copy_geometry_parameters = &allocate_box_storage_copy;

rot_copy(this_box_volume.geometry.rotation_matrix,ROT_A_CURRENT_COMP); //check how ROT_R_CURRENT_COMP would work
rot_transpose(ROT_A_CURRENT_COMP,this_box_volume.geometry.transpose_rotation_matrix);

// Initialize loggers
this_box_volume.loggers.num_elements = 0;

// packing the information into the global_geometry_element, which is then included in the global_geometry_list.
sprintf(global_geometry_element.name,NAME_CURRENT_COMP);
global_geometry_element.activation_counter = number_of_activations;
global_geometry_element.component_index = INDEX_CURRENT_COMP;
global_geometry_element.Volume = &this_box_volume; // Would be nicer if this m was a pointer, now we have the (small) data two places
add_element_to_geometry_list(&global_geometry_list,global_geometry_element);
}
#line 220529 "MACS_sample_kidney_box.c"
#undef number_of_activations
#undef mask_setting
#undef mask_string
#undef p_interact
#undef focus_r
#undef focus_xh
#undef focus_xw
#undef focus_ah
#undef focus_aw
#undef target_z
#undef target_y
#undef target_x
#undef target_index
#undef visualize
#undef yheight2
#undef xwidth2
#undef zdepth
#undef yheight
#undef xwidth
#undef priority
#undef material_string
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

  /* Initializations for component channel_6_analyzer_1_array_crystal_array_8. */
  SIG_MESSAGE("channel_6_analyzer_1_array_crystal_array_8 (Init)");
#define mccompcurname  channel_6_analyzer_1_array_crystal_array_8
#define mccompcurtype  Union_box
#define mccompcurindex 366
#define loop_index mccchannel_6_analyzer_1_array_crystal_array_8_loop_index
#define this_box_volume mccchannel_6_analyzer_1_array_crystal_array_8_this_box_volume
#define global_geometry_element mccchannel_6_analyzer_1_array_crystal_array_8_global_geometry_element
#define this_box_storage mccchannel_6_analyzer_1_array_crystal_array_8_this_box_storage
#define material_string mccchannel_6_analyzer_1_array_crystal_array_8_material_string
#define priority mccchannel_6_analyzer_1_array_crystal_array_8_priority
#define xwidth mccchannel_6_analyzer_1_array_crystal_array_8_xwidth
#define yheight mccchannel_6_analyzer_1_array_crystal_array_8_yheight
#define zdepth mccchannel_6_analyzer_1_array_crystal_array_8_zdepth
#define xwidth2 mccchannel_6_analyzer_1_array_crystal_array_8_xwidth2
#define yheight2 mccchannel_6_analyzer_1_array_crystal_array_8_yheight2
#define visualize mccchannel_6_analyzer_1_array_crystal_array_8_visualize
#define target_index mccchannel_6_analyzer_1_array_crystal_array_8_target_index
#define target_x mccchannel_6_analyzer_1_array_crystal_array_8_target_x
#define target_y mccchannel_6_analyzer_1_array_crystal_array_8_target_y
#define target_z mccchannel_6_analyzer_1_array_crystal_array_8_target_z
#define focus_aw mccchannel_6_analyzer_1_array_crystal_array_8_focus_aw
#define focus_ah mccchannel_6_analyzer_1_array_crystal_array_8_focus_ah
#define focus_xw mccchannel_6_analyzer_1_array_crystal_array_8_focus_xw
#define focus_xh mccchannel_6_analyzer_1_array_crystal_array_8_focus_xh
#define focus_r mccchannel_6_analyzer_1_array_crystal_array_8_focus_r
#define p_interact mccchannel_6_analyzer_1_array_crystal_array_8_p_interact
#define mask_string mccchannel_6_analyzer_1_array_crystal_array_8_mask_string
#define mask_setting mccchannel_6_analyzer_1_array_crystal_array_8_mask_setting
#define number_of_activations mccchannel_6_analyzer_1_array_crystal_array_8_number_of_activations
#line 224 "Union_box.comp"
{
// Initializes the focusing system for this volume including input sanitation.
focus_initialize(&this_box_volume.geometry, POS_A_COMP_INDEX(INDEX_CURRENT_COMP+target_index), POS_A_CURRENT_COMP, ROT_A_CURRENT_COMP, target_index, target_x, target_y, target_z, focus_aw, focus_ah, focus_xw, focus_xh, focus_r, NAME_CURRENT_COMP);

// Input sanitation for this geometry
if (xwidth <= 0) {
  printf("\nERROR in Union_box named %s, the xwidth is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (yheight <= 0) {
  printf("\nERROR in Union_box named %s, yheight is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (zdepth <= 0) {
  printf("\nERROR in Union_box named %s, zdepth is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (xwidth2 <= 0 && xwidth2 != -1) {
  printf("\nERROR in Union_box named %s, the xwidth2 is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (yheight2 <= 0 && yheight2 != -1) {
  printf("\nERROR in Union_box named %s, yheight2 is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}

// Use sanitation
if (global_material_list.num_elements == 0) {
  printf("\nERROR: Need to define a material using Union_make_material before using a Union geometry component. \n");
  printf("       %s was defined before first use of Union_make_material.\n",NAME_CURRENT_COMP);
  exit(1);
}

this_box_volume.geometry.is_masked_volume = 0;
this_box_volume.geometry.is_exit_volume = 0;
this_box_volume.geometry.is_mask_volume = 0;
// check if the volume is a mask, if it is the material string is irelevant.
if (mask_string && strlen(mask_string) && strcmp(mask_string, "NULL") && strcmp(mask_string, "0")) {
    // A mask volume is used to limit the extend of other volumes, called the masked volumes. These are specified in the mask_string.
    // In order for a ray to enter a masked volume, it needs to be both in the region covered by that volume AND the mask volume.
    // When more than
    this_box_volume.geometry.mask_mode = 1; // Default is mask mode is ALL
    if (mask_setting && strlen(mask_setting) && strcmp(mask_setting, "NULL") && strcmp(mask_setting, "0")) {
        if (strcmp(mask_setting,"ALL") == 0 || strcmp(mask_setting,"All") == 0) this_box_volume.geometry.mask_mode = 1;
        else if (strcmp(mask_setting,"ANY") == 0 || strcmp(mask_setting,"Any") == 0) this_box_volume.geometry.mask_mode = 2;
        else {
            printf("The mask_mode of component %s is set to %s, but must be either ALL or ANY.\n",NAME_CURRENT_COMP,mask_setting);
            exit(1);
        }
    }
    
    for (loop_index=0;loop_index<global_geometry_list.num_elements;loop_index++) {
        // Add mask list
        if (1 == manual_linking_function(global_geometry_list.elements[loop_index].name,mask_string)) {
            add_element_to_int_list(&this_box_volume.geometry.mask_list,global_geometry_list.elements[loop_index].component_index);
            add_element_to_int_list(&global_geometry_list.elements[loop_index].Volume->geometry.masked_by_list,INDEX_CURRENT_COMP);
            global_geometry_list.elements[loop_index].Volume->geometry.is_masked_volume = 1;
            if (this_box_volume.geometry.mask_mode == 2)
                global_geometry_list.elements[loop_index].Volume->geometry.mask_mode = 2;
            if (this_box_volume.geometry.mask_mode == 1) {
                if (global_geometry_list.elements[loop_index].Volume->geometry.is_masked_volume == 1 && global_geometry_list.elements[loop_index].Volume->geometry.mask_mode != 2)
                    // If more than one mask is added to one volume, the ANY mode overwrites the (default) ALL mode.
                    global_geometry_list.elements[loop_index].Volume->geometry.mask_mode = 1;
            }
            
            found_geometries = 1;
        }
    }
    if (found_geometries == 0) {
        printf("The mask_string in geometry: %s did not find any of the specified volumes in the mask_string %s \n",NAME_CURRENT_COMP,mask_string);
        exit(1);
    }
    this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
    this_box_volume.p_physics->is_vacuum = 0; // Makes this volume a vacuum
    this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
    this_box_volume.p_physics->my_a = 0; // Should not be used.
    sprintf(this_box_volume.p_physics->name,"Mask");
    this_box_volume.geometry.is_mask_volume = 1;
    
    
// Read the material input, or if it lacks, use automatic linking.
} else if (material_string && strlen(material_string) && strcmp(material_string, "NULL") && strcmp(material_string, "0")) {
    // A geometry string was given, use it to determine which material
    if (0 == strcmp(material_string,"vacuum") || 0 == strcmp(material_string,"Vacuum")) {
        // One could have a global physics struct for vacuum instead of creating one for each
        this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
        this_box_volume.p_physics->is_vacuum = 1; // Makes this volume a vacuum
        this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
        this_box_volume.p_physics->my_a = 0; // Should not be used.
        sprintf(this_box_volume.p_physics->name,"Vacuum");
    } else if (0 == strcmp(material_string,"exit") || 0 == strcmp(material_string,"Exit")) {
        // One could have a global physics struct for vacuum instead of creating one for each
        this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
        this_box_volume.p_physics->is_vacuum = 1; // Makes this volume a vacuum
        this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
        this_box_volume.p_physics->my_a = 0; // Should not be used.
        this_box_volume.geometry.is_exit_volume = 1;
        sprintf(this_box_volume.p_physics->name,"Exit");
    } else {
        #ifndef MATERIAL_DETECTOR
            printf("Need to define a material before refering to it in a geometry %s.\n",NAME_CURRENT_COMP);
            exit(1);
        #endif
        for (loop_index=0;loop_index<global_material_list.num_elements;loop_index++) {
            if (0 == strcmp(material_string,global_material_list.elements[loop_index].name)) {
                this_box_volume.p_physics = global_material_list.elements[loop_index].physics;
                break;
            }
            if (loop_index == global_material_list.num_elements-1) {
            printf("\n");
            printf("ERROR: The material string \"%s\" in Union geometry \"%s\" did not match a specified material. \n",material_string,NAME_CURRENT_COMP);
            printf("       The materials available at this point (need to be defined before the geometry): \n");
            for (loop_index=0;loop_index<global_material_list.num_elements;loop_index++)
              printf("         %s\n",global_material_list.elements[loop_index].name);
            printf("\n");
            printf("       It is also possible to use one of the defualt materials avaiable: \n");
            printf("           Vacuum (for a Volume without scattering or absorption)\n");
            printf("           Exit (for a Volume where the ray exits the component if it enters)\n");
            printf("           Mask (for a Volume that masks existing volumes specified in the mask_string\n");
            exit(1);
          }
        }
    }
} else {
    // Automatic linking, simply using the last defined material.
    #ifndef MATERIAL_DETECTOR
        printf("Need to define a material before the geometry to use automatic linking %s.\n",NAME_CURRENT_COMP);
        exit(1);
    #endif
    this_box_volume.p_physics = global_material_list.elements[global_material_list.num_elements-1].physics;
}

sprintf(this_box_volume.name,NAME_CURRENT_COMP);
sprintf(this_box_volume.geometry.shape,"box");
this_box_volume.geometry.priority_value = priority;
this_box_volume.geometry.geometry_p_interact = p_interact;
// Currently the coordinates will be in absolute space.
this_box_volume.geometry.center = POS_A_CURRENT_COMP;

this_box_storage.z_depth = zdepth;
this_box_storage.x_width1 = xwidth;
this_box_storage.y_height1 = yheight;

this_box_storage.is_rectangle = 0;
if (xwidth2 < 0 && yheight2 < 0) this_box_storage.is_rectangle = 1;
if (xwidth == xwidth2 && yheight == yheight2) this_box_storage.is_rectangle = 1;

if (xwidth2 < 0) {
    this_box_storage.x_width2 = xwidth;
    xwidth2 = xwidth;
} else this_box_storage.x_width2 = xwidth2;

if (yheight2 < 0) {
    this_box_storage.y_height2 = yheight;
    yheight2 = yheight;
} else this_box_storage.y_height2 = yheight2;


this_box_storage.normal_vectors[0] = coords_set(0,0,1);
this_box_storage.normal_vectors[1] = coords_set(0,0,1);

// for sides with y component = 0
x_component = 2*zdepth/sqrt((xwidth-xwidth2)*(xwidth-xwidth2)+4*zdepth*zdepth);
z_component = (xwidth-xwidth2)/sqrt(4*zdepth*zdepth+(xwidth-xwidth2)*(xwidth-xwidth2));

this_box_storage.normal_vectors[2] = coords_set(x_component,0,z_component);
this_box_storage.normal_vectors[3] = coords_set(-x_component,0,z_component);

// for sides with x component = 0
y_component = 2*zdepth/sqrt((yheight-yheight2)*(yheight-yheight2)+4*zdepth*zdepth);
z_component = (yheight-yheight2)/sqrt(4*zdepth*zdepth+(yheight-yheight2)*(yheight-yheight2));

this_box_storage.normal_vectors[4] = coords_set(0,y_component,z_component);
this_box_storage.normal_vectors[5] = coords_set(0,-y_component,z_component);

this_box_volume.geometry.visualization_on = visualize;

this_box_volume.geometry.geometry_parameters.p_box_storage = &this_box_storage;

// Assign pointers to functions for intersection with the shape, checking if a point is inside the shape
if (this_box_storage.is_rectangle == 1) {
this_box_volume.geometry.intersect_function = &sample_box_intersect_simple;
this_box_volume.geometry.within_function = &r_within_box_simple;
}
else {
this_box_volume.geometry.intersect_function = &sample_box_intersect_advanced;
this_box_volume.geometry.within_function = &r_within_box_advanced;
}

this_box_volume.geometry.shell_points = &box_shell_points;
this_box_volume.geometry.mcdisplay_function = &mcdisplay_box_function;
this_box_volume.geometry.initialize_from_main_function = &initialize_box_geometry_from_main_component;
this_box_volume.geometry.process_rot_allocated = 0;

this_box_volume.geometry.copy_geometry_parameters = &allocate_box_storage_copy;

rot_copy(this_box_volume.geometry.rotation_matrix,ROT_A_CURRENT_COMP); //check how ROT_R_CURRENT_COMP would work
rot_transpose(ROT_A_CURRENT_COMP,this_box_volume.geometry.transpose_rotation_matrix);

// Initialize loggers
this_box_volume.loggers.num_elements = 0;

// packing the information into the global_geometry_element, which is then included in the global_geometry_list.
sprintf(global_geometry_element.name,NAME_CURRENT_COMP);
global_geometry_element.activation_counter = number_of_activations;
global_geometry_element.component_index = INDEX_CURRENT_COMP;
global_geometry_element.Volume = &this_box_volume; // Would be nicer if this m was a pointer, now we have the (small) data two places
add_element_to_geometry_list(&global_geometry_list,global_geometry_element);
}
#line 220799 "MACS_sample_kidney_box.c"
#undef number_of_activations
#undef mask_setting
#undef mask_string
#undef p_interact
#undef focus_r
#undef focus_xh
#undef focus_xw
#undef focus_ah
#undef focus_aw
#undef target_z
#undef target_y
#undef target_x
#undef target_index
#undef visualize
#undef yheight2
#undef xwidth2
#undef zdepth
#undef yheight
#undef xwidth
#undef priority
#undef material_string
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

  /* Initializations for component channel_6_analyzer_2_center. */
  SIG_MESSAGE("channel_6_analyzer_2_center (Init)");

  /* Initializations for component channel_6_analyzer_2_rotated. */
  SIG_MESSAGE("channel_6_analyzer_2_rotated (Init)");

  /* Initializations for component channel_6_analyzer_2_array_crystal_array_0. */
  SIG_MESSAGE("channel_6_analyzer_2_array_crystal_array_0 (Init)");
#define mccompcurname  channel_6_analyzer_2_array_crystal_array_0
#define mccompcurtype  Union_box
#define mccompcurindex 369
#define loop_index mccchannel_6_analyzer_2_array_crystal_array_0_loop_index
#define this_box_volume mccchannel_6_analyzer_2_array_crystal_array_0_this_box_volume
#define global_geometry_element mccchannel_6_analyzer_2_array_crystal_array_0_global_geometry_element
#define this_box_storage mccchannel_6_analyzer_2_array_crystal_array_0_this_box_storage
#define material_string mccchannel_6_analyzer_2_array_crystal_array_0_material_string
#define priority mccchannel_6_analyzer_2_array_crystal_array_0_priority
#define xwidth mccchannel_6_analyzer_2_array_crystal_array_0_xwidth
#define yheight mccchannel_6_analyzer_2_array_crystal_array_0_yheight
#define zdepth mccchannel_6_analyzer_2_array_crystal_array_0_zdepth
#define xwidth2 mccchannel_6_analyzer_2_array_crystal_array_0_xwidth2
#define yheight2 mccchannel_6_analyzer_2_array_crystal_array_0_yheight2
#define visualize mccchannel_6_analyzer_2_array_crystal_array_0_visualize
#define target_index mccchannel_6_analyzer_2_array_crystal_array_0_target_index
#define target_x mccchannel_6_analyzer_2_array_crystal_array_0_target_x
#define target_y mccchannel_6_analyzer_2_array_crystal_array_0_target_y
#define target_z mccchannel_6_analyzer_2_array_crystal_array_0_target_z
#define focus_aw mccchannel_6_analyzer_2_array_crystal_array_0_focus_aw
#define focus_ah mccchannel_6_analyzer_2_array_crystal_array_0_focus_ah
#define focus_xw mccchannel_6_analyzer_2_array_crystal_array_0_focus_xw
#define focus_xh mccchannel_6_analyzer_2_array_crystal_array_0_focus_xh
#define focus_r mccchannel_6_analyzer_2_array_crystal_array_0_focus_r
#define p_interact mccchannel_6_analyzer_2_array_crystal_array_0_p_interact
#define mask_string mccchannel_6_analyzer_2_array_crystal_array_0_mask_string
#define mask_setting mccchannel_6_analyzer_2_array_crystal_array_0_mask_setting
#define number_of_activations mccchannel_6_analyzer_2_array_crystal_array_0_number_of_activations
#line 224 "Union_box.comp"
{
// Initializes the focusing system for this volume including input sanitation.
focus_initialize(&this_box_volume.geometry, POS_A_COMP_INDEX(INDEX_CURRENT_COMP+target_index), POS_A_CURRENT_COMP, ROT_A_CURRENT_COMP, target_index, target_x, target_y, target_z, focus_aw, focus_ah, focus_xw, focus_xh, focus_r, NAME_CURRENT_COMP);

// Input sanitation for this geometry
if (xwidth <= 0) {
  printf("\nERROR in Union_box named %s, the xwidth is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (yheight <= 0) {
  printf("\nERROR in Union_box named %s, yheight is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (zdepth <= 0) {
  printf("\nERROR in Union_box named %s, zdepth is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (xwidth2 <= 0 && xwidth2 != -1) {
  printf("\nERROR in Union_box named %s, the xwidth2 is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (yheight2 <= 0 && yheight2 != -1) {
  printf("\nERROR in Union_box named %s, yheight2 is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}

// Use sanitation
if (global_material_list.num_elements == 0) {
  printf("\nERROR: Need to define a material using Union_make_material before using a Union geometry component. \n");
  printf("       %s was defined before first use of Union_make_material.\n",NAME_CURRENT_COMP);
  exit(1);
}

this_box_volume.geometry.is_masked_volume = 0;
this_box_volume.geometry.is_exit_volume = 0;
this_box_volume.geometry.is_mask_volume = 0;
// check if the volume is a mask, if it is the material string is irelevant.
if (mask_string && strlen(mask_string) && strcmp(mask_string, "NULL") && strcmp(mask_string, "0")) {
    // A mask volume is used to limit the extend of other volumes, called the masked volumes. These are specified in the mask_string.
    // In order for a ray to enter a masked volume, it needs to be both in the region covered by that volume AND the mask volume.
    // When more than
    this_box_volume.geometry.mask_mode = 1; // Default is mask mode is ALL
    if (mask_setting && strlen(mask_setting) && strcmp(mask_setting, "NULL") && strcmp(mask_setting, "0")) {
        if (strcmp(mask_setting,"ALL") == 0 || strcmp(mask_setting,"All") == 0) this_box_volume.geometry.mask_mode = 1;
        else if (strcmp(mask_setting,"ANY") == 0 || strcmp(mask_setting,"Any") == 0) this_box_volume.geometry.mask_mode = 2;
        else {
            printf("The mask_mode of component %s is set to %s, but must be either ALL or ANY.\n",NAME_CURRENT_COMP,mask_setting);
            exit(1);
        }
    }
    
    for (loop_index=0;loop_index<global_geometry_list.num_elements;loop_index++) {
        // Add mask list
        if (1 == manual_linking_function(global_geometry_list.elements[loop_index].name,mask_string)) {
            add_element_to_int_list(&this_box_volume.geometry.mask_list,global_geometry_list.elements[loop_index].component_index);
            add_element_to_int_list(&global_geometry_list.elements[loop_index].Volume->geometry.masked_by_list,INDEX_CURRENT_COMP);
            global_geometry_list.elements[loop_index].Volume->geometry.is_masked_volume = 1;
            if (this_box_volume.geometry.mask_mode == 2)
                global_geometry_list.elements[loop_index].Volume->geometry.mask_mode = 2;
            if (this_box_volume.geometry.mask_mode == 1) {
                if (global_geometry_list.elements[loop_index].Volume->geometry.is_masked_volume == 1 && global_geometry_list.elements[loop_index].Volume->geometry.mask_mode != 2)
                    // If more than one mask is added to one volume, the ANY mode overwrites the (default) ALL mode.
                    global_geometry_list.elements[loop_index].Volume->geometry.mask_mode = 1;
            }
            
            found_geometries = 1;
        }
    }
    if (found_geometries == 0) {
        printf("The mask_string in geometry: %s did not find any of the specified volumes in the mask_string %s \n",NAME_CURRENT_COMP,mask_string);
        exit(1);
    }
    this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
    this_box_volume.p_physics->is_vacuum = 0; // Makes this volume a vacuum
    this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
    this_box_volume.p_physics->my_a = 0; // Should not be used.
    sprintf(this_box_volume.p_physics->name,"Mask");
    this_box_volume.geometry.is_mask_volume = 1;
    
    
// Read the material input, or if it lacks, use automatic linking.
} else if (material_string && strlen(material_string) && strcmp(material_string, "NULL") && strcmp(material_string, "0")) {
    // A geometry string was given, use it to determine which material
    if (0 == strcmp(material_string,"vacuum") || 0 == strcmp(material_string,"Vacuum")) {
        // One could have a global physics struct for vacuum instead of creating one for each
        this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
        this_box_volume.p_physics->is_vacuum = 1; // Makes this volume a vacuum
        this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
        this_box_volume.p_physics->my_a = 0; // Should not be used.
        sprintf(this_box_volume.p_physics->name,"Vacuum");
    } else if (0 == strcmp(material_string,"exit") || 0 == strcmp(material_string,"Exit")) {
        // One could have a global physics struct for vacuum instead of creating one for each
        this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
        this_box_volume.p_physics->is_vacuum = 1; // Makes this volume a vacuum
        this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
        this_box_volume.p_physics->my_a = 0; // Should not be used.
        this_box_volume.geometry.is_exit_volume = 1;
        sprintf(this_box_volume.p_physics->name,"Exit");
    } else {
        #ifndef MATERIAL_DETECTOR
            printf("Need to define a material before refering to it in a geometry %s.\n",NAME_CURRENT_COMP);
            exit(1);
        #endif
        for (loop_index=0;loop_index<global_material_list.num_elements;loop_index++) {
            if (0 == strcmp(material_string,global_material_list.elements[loop_index].name)) {
                this_box_volume.p_physics = global_material_list.elements[loop_index].physics;
                break;
            }
            if (loop_index == global_material_list.num_elements-1) {
            printf("\n");
            printf("ERROR: The material string \"%s\" in Union geometry \"%s\" did not match a specified material. \n",material_string,NAME_CURRENT_COMP);
            printf("       The materials available at this point (need to be defined before the geometry): \n");
            for (loop_index=0;loop_index<global_material_list.num_elements;loop_index++)
              printf("         %s\n",global_material_list.elements[loop_index].name);
            printf("\n");
            printf("       It is also possible to use one of the defualt materials avaiable: \n");
            printf("           Vacuum (for a Volume without scattering or absorption)\n");
            printf("           Exit (for a Volume where the ray exits the component if it enters)\n");
            printf("           Mask (for a Volume that masks existing volumes specified in the mask_string\n");
            exit(1);
          }
        }
    }
} else {
    // Automatic linking, simply using the last defined material.
    #ifndef MATERIAL_DETECTOR
        printf("Need to define a material before the geometry to use automatic linking %s.\n",NAME_CURRENT_COMP);
        exit(1);
    #endif
    this_box_volume.p_physics = global_material_list.elements[global_material_list.num_elements-1].physics;
}

sprintf(this_box_volume.name,NAME_CURRENT_COMP);
sprintf(this_box_volume.geometry.shape,"box");
this_box_volume.geometry.priority_value = priority;
this_box_volume.geometry.geometry_p_interact = p_interact;
// Currently the coordinates will be in absolute space.
this_box_volume.geometry.center = POS_A_CURRENT_COMP;

this_box_storage.z_depth = zdepth;
this_box_storage.x_width1 = xwidth;
this_box_storage.y_height1 = yheight;

this_box_storage.is_rectangle = 0;
if (xwidth2 < 0 && yheight2 < 0) this_box_storage.is_rectangle = 1;
if (xwidth == xwidth2 && yheight == yheight2) this_box_storage.is_rectangle = 1;

if (xwidth2 < 0) {
    this_box_storage.x_width2 = xwidth;
    xwidth2 = xwidth;
} else this_box_storage.x_width2 = xwidth2;

if (yheight2 < 0) {
    this_box_storage.y_height2 = yheight;
    yheight2 = yheight;
} else this_box_storage.y_height2 = yheight2;


this_box_storage.normal_vectors[0] = coords_set(0,0,1);
this_box_storage.normal_vectors[1] = coords_set(0,0,1);

// for sides with y component = 0
x_component = 2*zdepth/sqrt((xwidth-xwidth2)*(xwidth-xwidth2)+4*zdepth*zdepth);
z_component = (xwidth-xwidth2)/sqrt(4*zdepth*zdepth+(xwidth-xwidth2)*(xwidth-xwidth2));

this_box_storage.normal_vectors[2] = coords_set(x_component,0,z_component);
this_box_storage.normal_vectors[3] = coords_set(-x_component,0,z_component);

// for sides with x component = 0
y_component = 2*zdepth/sqrt((yheight-yheight2)*(yheight-yheight2)+4*zdepth*zdepth);
z_component = (yheight-yheight2)/sqrt(4*zdepth*zdepth+(yheight-yheight2)*(yheight-yheight2));

this_box_storage.normal_vectors[4] = coords_set(0,y_component,z_component);
this_box_storage.normal_vectors[5] = coords_set(0,-y_component,z_component);

this_box_volume.geometry.visualization_on = visualize;

this_box_volume.geometry.geometry_parameters.p_box_storage = &this_box_storage;

// Assign pointers to functions for intersection with the shape, checking if a point is inside the shape
if (this_box_storage.is_rectangle == 1) {
this_box_volume.geometry.intersect_function = &sample_box_intersect_simple;
this_box_volume.geometry.within_function = &r_within_box_simple;
}
else {
this_box_volume.geometry.intersect_function = &sample_box_intersect_advanced;
this_box_volume.geometry.within_function = &r_within_box_advanced;
}

this_box_volume.geometry.shell_points = &box_shell_points;
this_box_volume.geometry.mcdisplay_function = &mcdisplay_box_function;
this_box_volume.geometry.initialize_from_main_function = &initialize_box_geometry_from_main_component;
this_box_volume.geometry.process_rot_allocated = 0;

this_box_volume.geometry.copy_geometry_parameters = &allocate_box_storage_copy;

rot_copy(this_box_volume.geometry.rotation_matrix,ROT_A_CURRENT_COMP); //check how ROT_R_CURRENT_COMP would work
rot_transpose(ROT_A_CURRENT_COMP,this_box_volume.geometry.transpose_rotation_matrix);

// Initialize loggers
this_box_volume.loggers.num_elements = 0;

// packing the information into the global_geometry_element, which is then included in the global_geometry_list.
sprintf(global_geometry_element.name,NAME_CURRENT_COMP);
global_geometry_element.activation_counter = number_of_activations;
global_geometry_element.component_index = INDEX_CURRENT_COMP;
global_geometry_element.Volume = &this_box_volume; // Would be nicer if this m was a pointer, now we have the (small) data two places
add_element_to_geometry_list(&global_geometry_list,global_geometry_element);
}
#line 221075 "MACS_sample_kidney_box.c"
#undef number_of_activations
#undef mask_setting
#undef mask_string
#undef p_interact
#undef focus_r
#undef focus_xh
#undef focus_xw
#undef focus_ah
#undef focus_aw
#undef target_z
#undef target_y
#undef target_x
#undef target_index
#undef visualize
#undef yheight2
#undef xwidth2
#undef zdepth
#undef yheight
#undef xwidth
#undef priority
#undef material_string
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

  /* Initializations for component channel_6_analyzer_2_array_crystal_array_1. */
  SIG_MESSAGE("channel_6_analyzer_2_array_crystal_array_1 (Init)");
#define mccompcurname  channel_6_analyzer_2_array_crystal_array_1
#define mccompcurtype  Union_box
#define mccompcurindex 370
#define loop_index mccchannel_6_analyzer_2_array_crystal_array_1_loop_index
#define this_box_volume mccchannel_6_analyzer_2_array_crystal_array_1_this_box_volume
#define global_geometry_element mccchannel_6_analyzer_2_array_crystal_array_1_global_geometry_element
#define this_box_storage mccchannel_6_analyzer_2_array_crystal_array_1_this_box_storage
#define material_string mccchannel_6_analyzer_2_array_crystal_array_1_material_string
#define priority mccchannel_6_analyzer_2_array_crystal_array_1_priority
#define xwidth mccchannel_6_analyzer_2_array_crystal_array_1_xwidth
#define yheight mccchannel_6_analyzer_2_array_crystal_array_1_yheight
#define zdepth mccchannel_6_analyzer_2_array_crystal_array_1_zdepth
#define xwidth2 mccchannel_6_analyzer_2_array_crystal_array_1_xwidth2
#define yheight2 mccchannel_6_analyzer_2_array_crystal_array_1_yheight2
#define visualize mccchannel_6_analyzer_2_array_crystal_array_1_visualize
#define target_index mccchannel_6_analyzer_2_array_crystal_array_1_target_index
#define target_x mccchannel_6_analyzer_2_array_crystal_array_1_target_x
#define target_y mccchannel_6_analyzer_2_array_crystal_array_1_target_y
#define target_z mccchannel_6_analyzer_2_array_crystal_array_1_target_z
#define focus_aw mccchannel_6_analyzer_2_array_crystal_array_1_focus_aw
#define focus_ah mccchannel_6_analyzer_2_array_crystal_array_1_focus_ah
#define focus_xw mccchannel_6_analyzer_2_array_crystal_array_1_focus_xw
#define focus_xh mccchannel_6_analyzer_2_array_crystal_array_1_focus_xh
#define focus_r mccchannel_6_analyzer_2_array_crystal_array_1_focus_r
#define p_interact mccchannel_6_analyzer_2_array_crystal_array_1_p_interact
#define mask_string mccchannel_6_analyzer_2_array_crystal_array_1_mask_string
#define mask_setting mccchannel_6_analyzer_2_array_crystal_array_1_mask_setting
#define number_of_activations mccchannel_6_analyzer_2_array_crystal_array_1_number_of_activations
#line 224 "Union_box.comp"
{
// Initializes the focusing system for this volume including input sanitation.
focus_initialize(&this_box_volume.geometry, POS_A_COMP_INDEX(INDEX_CURRENT_COMP+target_index), POS_A_CURRENT_COMP, ROT_A_CURRENT_COMP, target_index, target_x, target_y, target_z, focus_aw, focus_ah, focus_xw, focus_xh, focus_r, NAME_CURRENT_COMP);

// Input sanitation for this geometry
if (xwidth <= 0) {
  printf("\nERROR in Union_box named %s, the xwidth is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (yheight <= 0) {
  printf("\nERROR in Union_box named %s, yheight is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (zdepth <= 0) {
  printf("\nERROR in Union_box named %s, zdepth is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (xwidth2 <= 0 && xwidth2 != -1) {
  printf("\nERROR in Union_box named %s, the xwidth2 is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (yheight2 <= 0 && yheight2 != -1) {
  printf("\nERROR in Union_box named %s, yheight2 is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}

// Use sanitation
if (global_material_list.num_elements == 0) {
  printf("\nERROR: Need to define a material using Union_make_material before using a Union geometry component. \n");
  printf("       %s was defined before first use of Union_make_material.\n",NAME_CURRENT_COMP);
  exit(1);
}

this_box_volume.geometry.is_masked_volume = 0;
this_box_volume.geometry.is_exit_volume = 0;
this_box_volume.geometry.is_mask_volume = 0;
// check if the volume is a mask, if it is the material string is irelevant.
if (mask_string && strlen(mask_string) && strcmp(mask_string, "NULL") && strcmp(mask_string, "0")) {
    // A mask volume is used to limit the extend of other volumes, called the masked volumes. These are specified in the mask_string.
    // In order for a ray to enter a masked volume, it needs to be both in the region covered by that volume AND the mask volume.
    // When more than
    this_box_volume.geometry.mask_mode = 1; // Default is mask mode is ALL
    if (mask_setting && strlen(mask_setting) && strcmp(mask_setting, "NULL") && strcmp(mask_setting, "0")) {
        if (strcmp(mask_setting,"ALL") == 0 || strcmp(mask_setting,"All") == 0) this_box_volume.geometry.mask_mode = 1;
        else if (strcmp(mask_setting,"ANY") == 0 || strcmp(mask_setting,"Any") == 0) this_box_volume.geometry.mask_mode = 2;
        else {
            printf("The mask_mode of component %s is set to %s, but must be either ALL or ANY.\n",NAME_CURRENT_COMP,mask_setting);
            exit(1);
        }
    }
    
    for (loop_index=0;loop_index<global_geometry_list.num_elements;loop_index++) {
        // Add mask list
        if (1 == manual_linking_function(global_geometry_list.elements[loop_index].name,mask_string)) {
            add_element_to_int_list(&this_box_volume.geometry.mask_list,global_geometry_list.elements[loop_index].component_index);
            add_element_to_int_list(&global_geometry_list.elements[loop_index].Volume->geometry.masked_by_list,INDEX_CURRENT_COMP);
            global_geometry_list.elements[loop_index].Volume->geometry.is_masked_volume = 1;
            if (this_box_volume.geometry.mask_mode == 2)
                global_geometry_list.elements[loop_index].Volume->geometry.mask_mode = 2;
            if (this_box_volume.geometry.mask_mode == 1) {
                if (global_geometry_list.elements[loop_index].Volume->geometry.is_masked_volume == 1 && global_geometry_list.elements[loop_index].Volume->geometry.mask_mode != 2)
                    // If more than one mask is added to one volume, the ANY mode overwrites the (default) ALL mode.
                    global_geometry_list.elements[loop_index].Volume->geometry.mask_mode = 1;
            }
            
            found_geometries = 1;
        }
    }
    if (found_geometries == 0) {
        printf("The mask_string in geometry: %s did not find any of the specified volumes in the mask_string %s \n",NAME_CURRENT_COMP,mask_string);
        exit(1);
    }
    this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
    this_box_volume.p_physics->is_vacuum = 0; // Makes this volume a vacuum
    this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
    this_box_volume.p_physics->my_a = 0; // Should not be used.
    sprintf(this_box_volume.p_physics->name,"Mask");
    this_box_volume.geometry.is_mask_volume = 1;
    
    
// Read the material input, or if it lacks, use automatic linking.
} else if (material_string && strlen(material_string) && strcmp(material_string, "NULL") && strcmp(material_string, "0")) {
    // A geometry string was given, use it to determine which material
    if (0 == strcmp(material_string,"vacuum") || 0 == strcmp(material_string,"Vacuum")) {
        // One could have a global physics struct for vacuum instead of creating one for each
        this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
        this_box_volume.p_physics->is_vacuum = 1; // Makes this volume a vacuum
        this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
        this_box_volume.p_physics->my_a = 0; // Should not be used.
        sprintf(this_box_volume.p_physics->name,"Vacuum");
    } else if (0 == strcmp(material_string,"exit") || 0 == strcmp(material_string,"Exit")) {
        // One could have a global physics struct for vacuum instead of creating one for each
        this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
        this_box_volume.p_physics->is_vacuum = 1; // Makes this volume a vacuum
        this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
        this_box_volume.p_physics->my_a = 0; // Should not be used.
        this_box_volume.geometry.is_exit_volume = 1;
        sprintf(this_box_volume.p_physics->name,"Exit");
    } else {
        #ifndef MATERIAL_DETECTOR
            printf("Need to define a material before refering to it in a geometry %s.\n",NAME_CURRENT_COMP);
            exit(1);
        #endif
        for (loop_index=0;loop_index<global_material_list.num_elements;loop_index++) {
            if (0 == strcmp(material_string,global_material_list.elements[loop_index].name)) {
                this_box_volume.p_physics = global_material_list.elements[loop_index].physics;
                break;
            }
            if (loop_index == global_material_list.num_elements-1) {
            printf("\n");
            printf("ERROR: The material string \"%s\" in Union geometry \"%s\" did not match a specified material. \n",material_string,NAME_CURRENT_COMP);
            printf("       The materials available at this point (need to be defined before the geometry): \n");
            for (loop_index=0;loop_index<global_material_list.num_elements;loop_index++)
              printf("         %s\n",global_material_list.elements[loop_index].name);
            printf("\n");
            printf("       It is also possible to use one of the defualt materials avaiable: \n");
            printf("           Vacuum (for a Volume without scattering or absorption)\n");
            printf("           Exit (for a Volume where the ray exits the component if it enters)\n");
            printf("           Mask (for a Volume that masks existing volumes specified in the mask_string\n");
            exit(1);
          }
        }
    }
} else {
    // Automatic linking, simply using the last defined material.
    #ifndef MATERIAL_DETECTOR
        printf("Need to define a material before the geometry to use automatic linking %s.\n",NAME_CURRENT_COMP);
        exit(1);
    #endif
    this_box_volume.p_physics = global_material_list.elements[global_material_list.num_elements-1].physics;
}

sprintf(this_box_volume.name,NAME_CURRENT_COMP);
sprintf(this_box_volume.geometry.shape,"box");
this_box_volume.geometry.priority_value = priority;
this_box_volume.geometry.geometry_p_interact = p_interact;
// Currently the coordinates will be in absolute space.
this_box_volume.geometry.center = POS_A_CURRENT_COMP;

this_box_storage.z_depth = zdepth;
this_box_storage.x_width1 = xwidth;
this_box_storage.y_height1 = yheight;

this_box_storage.is_rectangle = 0;
if (xwidth2 < 0 && yheight2 < 0) this_box_storage.is_rectangle = 1;
if (xwidth == xwidth2 && yheight == yheight2) this_box_storage.is_rectangle = 1;

if (xwidth2 < 0) {
    this_box_storage.x_width2 = xwidth;
    xwidth2 = xwidth;
} else this_box_storage.x_width2 = xwidth2;

if (yheight2 < 0) {
    this_box_storage.y_height2 = yheight;
    yheight2 = yheight;
} else this_box_storage.y_height2 = yheight2;


this_box_storage.normal_vectors[0] = coords_set(0,0,1);
this_box_storage.normal_vectors[1] = coords_set(0,0,1);

// for sides with y component = 0
x_component = 2*zdepth/sqrt((xwidth-xwidth2)*(xwidth-xwidth2)+4*zdepth*zdepth);
z_component = (xwidth-xwidth2)/sqrt(4*zdepth*zdepth+(xwidth-xwidth2)*(xwidth-xwidth2));

this_box_storage.normal_vectors[2] = coords_set(x_component,0,z_component);
this_box_storage.normal_vectors[3] = coords_set(-x_component,0,z_component);

// for sides with x component = 0
y_component = 2*zdepth/sqrt((yheight-yheight2)*(yheight-yheight2)+4*zdepth*zdepth);
z_component = (yheight-yheight2)/sqrt(4*zdepth*zdepth+(yheight-yheight2)*(yheight-yheight2));

this_box_storage.normal_vectors[4] = coords_set(0,y_component,z_component);
this_box_storage.normal_vectors[5] = coords_set(0,-y_component,z_component);

this_box_volume.geometry.visualization_on = visualize;

this_box_volume.geometry.geometry_parameters.p_box_storage = &this_box_storage;

// Assign pointers to functions for intersection with the shape, checking if a point is inside the shape
if (this_box_storage.is_rectangle == 1) {
this_box_volume.geometry.intersect_function = &sample_box_intersect_simple;
this_box_volume.geometry.within_function = &r_within_box_simple;
}
else {
this_box_volume.geometry.intersect_function = &sample_box_intersect_advanced;
this_box_volume.geometry.within_function = &r_within_box_advanced;
}

this_box_volume.geometry.shell_points = &box_shell_points;
this_box_volume.geometry.mcdisplay_function = &mcdisplay_box_function;
this_box_volume.geometry.initialize_from_main_function = &initialize_box_geometry_from_main_component;
this_box_volume.geometry.process_rot_allocated = 0;

this_box_volume.geometry.copy_geometry_parameters = &allocate_box_storage_copy;

rot_copy(this_box_volume.geometry.rotation_matrix,ROT_A_CURRENT_COMP); //check how ROT_R_CURRENT_COMP would work
rot_transpose(ROT_A_CURRENT_COMP,this_box_volume.geometry.transpose_rotation_matrix);

// Initialize loggers
this_box_volume.loggers.num_elements = 0;

// packing the information into the global_geometry_element, which is then included in the global_geometry_list.
sprintf(global_geometry_element.name,NAME_CURRENT_COMP);
global_geometry_element.activation_counter = number_of_activations;
global_geometry_element.component_index = INDEX_CURRENT_COMP;
global_geometry_element.Volume = &this_box_volume; // Would be nicer if this m was a pointer, now we have the (small) data two places
add_element_to_geometry_list(&global_geometry_list,global_geometry_element);
}
#line 221345 "MACS_sample_kidney_box.c"
#undef number_of_activations
#undef mask_setting
#undef mask_string
#undef p_interact
#undef focus_r
#undef focus_xh
#undef focus_xw
#undef focus_ah
#undef focus_aw
#undef target_z
#undef target_y
#undef target_x
#undef target_index
#undef visualize
#undef yheight2
#undef xwidth2
#undef zdepth
#undef yheight
#undef xwidth
#undef priority
#undef material_string
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

  /* Initializations for component channel_6_analyzer_2_array_crystal_array_2. */
  SIG_MESSAGE("channel_6_analyzer_2_array_crystal_array_2 (Init)");
#define mccompcurname  channel_6_analyzer_2_array_crystal_array_2
#define mccompcurtype  Union_box
#define mccompcurindex 371
#define loop_index mccchannel_6_analyzer_2_array_crystal_array_2_loop_index
#define this_box_volume mccchannel_6_analyzer_2_array_crystal_array_2_this_box_volume
#define global_geometry_element mccchannel_6_analyzer_2_array_crystal_array_2_global_geometry_element
#define this_box_storage mccchannel_6_analyzer_2_array_crystal_array_2_this_box_storage
#define material_string mccchannel_6_analyzer_2_array_crystal_array_2_material_string
#define priority mccchannel_6_analyzer_2_array_crystal_array_2_priority
#define xwidth mccchannel_6_analyzer_2_array_crystal_array_2_xwidth
#define yheight mccchannel_6_analyzer_2_array_crystal_array_2_yheight
#define zdepth mccchannel_6_analyzer_2_array_crystal_array_2_zdepth
#define xwidth2 mccchannel_6_analyzer_2_array_crystal_array_2_xwidth2
#define yheight2 mccchannel_6_analyzer_2_array_crystal_array_2_yheight2
#define visualize mccchannel_6_analyzer_2_array_crystal_array_2_visualize
#define target_index mccchannel_6_analyzer_2_array_crystal_array_2_target_index
#define target_x mccchannel_6_analyzer_2_array_crystal_array_2_target_x
#define target_y mccchannel_6_analyzer_2_array_crystal_array_2_target_y
#define target_z mccchannel_6_analyzer_2_array_crystal_array_2_target_z
#define focus_aw mccchannel_6_analyzer_2_array_crystal_array_2_focus_aw
#define focus_ah mccchannel_6_analyzer_2_array_crystal_array_2_focus_ah
#define focus_xw mccchannel_6_analyzer_2_array_crystal_array_2_focus_xw
#define focus_xh mccchannel_6_analyzer_2_array_crystal_array_2_focus_xh
#define focus_r mccchannel_6_analyzer_2_array_crystal_array_2_focus_r
#define p_interact mccchannel_6_analyzer_2_array_crystal_array_2_p_interact
#define mask_string mccchannel_6_analyzer_2_array_crystal_array_2_mask_string
#define mask_setting mccchannel_6_analyzer_2_array_crystal_array_2_mask_setting
#define number_of_activations mccchannel_6_analyzer_2_array_crystal_array_2_number_of_activations
#line 224 "Union_box.comp"
{
// Initializes the focusing system for this volume including input sanitation.
focus_initialize(&this_box_volume.geometry, POS_A_COMP_INDEX(INDEX_CURRENT_COMP+target_index), POS_A_CURRENT_COMP, ROT_A_CURRENT_COMP, target_index, target_x, target_y, target_z, focus_aw, focus_ah, focus_xw, focus_xh, focus_r, NAME_CURRENT_COMP);

// Input sanitation for this geometry
if (xwidth <= 0) {
  printf("\nERROR in Union_box named %s, the xwidth is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (yheight <= 0) {
  printf("\nERROR in Union_box named %s, yheight is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (zdepth <= 0) {
  printf("\nERROR in Union_box named %s, zdepth is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (xwidth2 <= 0 && xwidth2 != -1) {
  printf("\nERROR in Union_box named %s, the xwidth2 is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (yheight2 <= 0 && yheight2 != -1) {
  printf("\nERROR in Union_box named %s, yheight2 is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}

// Use sanitation
if (global_material_list.num_elements == 0) {
  printf("\nERROR: Need to define a material using Union_make_material before using a Union geometry component. \n");
  printf("       %s was defined before first use of Union_make_material.\n",NAME_CURRENT_COMP);
  exit(1);
}

this_box_volume.geometry.is_masked_volume = 0;
this_box_volume.geometry.is_exit_volume = 0;
this_box_volume.geometry.is_mask_volume = 0;
// check if the volume is a mask, if it is the material string is irelevant.
if (mask_string && strlen(mask_string) && strcmp(mask_string, "NULL") && strcmp(mask_string, "0")) {
    // A mask volume is used to limit the extend of other volumes, called the masked volumes. These are specified in the mask_string.
    // In order for a ray to enter a masked volume, it needs to be both in the region covered by that volume AND the mask volume.
    // When more than
    this_box_volume.geometry.mask_mode = 1; // Default is mask mode is ALL
    if (mask_setting && strlen(mask_setting) && strcmp(mask_setting, "NULL") && strcmp(mask_setting, "0")) {
        if (strcmp(mask_setting,"ALL") == 0 || strcmp(mask_setting,"All") == 0) this_box_volume.geometry.mask_mode = 1;
        else if (strcmp(mask_setting,"ANY") == 0 || strcmp(mask_setting,"Any") == 0) this_box_volume.geometry.mask_mode = 2;
        else {
            printf("The mask_mode of component %s is set to %s, but must be either ALL or ANY.\n",NAME_CURRENT_COMP,mask_setting);
            exit(1);
        }
    }
    
    for (loop_index=0;loop_index<global_geometry_list.num_elements;loop_index++) {
        // Add mask list
        if (1 == manual_linking_function(global_geometry_list.elements[loop_index].name,mask_string)) {
            add_element_to_int_list(&this_box_volume.geometry.mask_list,global_geometry_list.elements[loop_index].component_index);
            add_element_to_int_list(&global_geometry_list.elements[loop_index].Volume->geometry.masked_by_list,INDEX_CURRENT_COMP);
            global_geometry_list.elements[loop_index].Volume->geometry.is_masked_volume = 1;
            if (this_box_volume.geometry.mask_mode == 2)
                global_geometry_list.elements[loop_index].Volume->geometry.mask_mode = 2;
            if (this_box_volume.geometry.mask_mode == 1) {
                if (global_geometry_list.elements[loop_index].Volume->geometry.is_masked_volume == 1 && global_geometry_list.elements[loop_index].Volume->geometry.mask_mode != 2)
                    // If more than one mask is added to one volume, the ANY mode overwrites the (default) ALL mode.
                    global_geometry_list.elements[loop_index].Volume->geometry.mask_mode = 1;
            }
            
            found_geometries = 1;
        }
    }
    if (found_geometries == 0) {
        printf("The mask_string in geometry: %s did not find any of the specified volumes in the mask_string %s \n",NAME_CURRENT_COMP,mask_string);
        exit(1);
    }
    this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
    this_box_volume.p_physics->is_vacuum = 0; // Makes this volume a vacuum
    this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
    this_box_volume.p_physics->my_a = 0; // Should not be used.
    sprintf(this_box_volume.p_physics->name,"Mask");
    this_box_volume.geometry.is_mask_volume = 1;
    
    
// Read the material input, or if it lacks, use automatic linking.
} else if (material_string && strlen(material_string) && strcmp(material_string, "NULL") && strcmp(material_string, "0")) {
    // A geometry string was given, use it to determine which material
    if (0 == strcmp(material_string,"vacuum") || 0 == strcmp(material_string,"Vacuum")) {
        // One could have a global physics struct for vacuum instead of creating one for each
        this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
        this_box_volume.p_physics->is_vacuum = 1; // Makes this volume a vacuum
        this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
        this_box_volume.p_physics->my_a = 0; // Should not be used.
        sprintf(this_box_volume.p_physics->name,"Vacuum");
    } else if (0 == strcmp(material_string,"exit") || 0 == strcmp(material_string,"Exit")) {
        // One could have a global physics struct for vacuum instead of creating one for each
        this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
        this_box_volume.p_physics->is_vacuum = 1; // Makes this volume a vacuum
        this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
        this_box_volume.p_physics->my_a = 0; // Should not be used.
        this_box_volume.geometry.is_exit_volume = 1;
        sprintf(this_box_volume.p_physics->name,"Exit");
    } else {
        #ifndef MATERIAL_DETECTOR
            printf("Need to define a material before refering to it in a geometry %s.\n",NAME_CURRENT_COMP);
            exit(1);
        #endif
        for (loop_index=0;loop_index<global_material_list.num_elements;loop_index++) {
            if (0 == strcmp(material_string,global_material_list.elements[loop_index].name)) {
                this_box_volume.p_physics = global_material_list.elements[loop_index].physics;
                break;
            }
            if (loop_index == global_material_list.num_elements-1) {
            printf("\n");
            printf("ERROR: The material string \"%s\" in Union geometry \"%s\" did not match a specified material. \n",material_string,NAME_CURRENT_COMP);
            printf("       The materials available at this point (need to be defined before the geometry): \n");
            for (loop_index=0;loop_index<global_material_list.num_elements;loop_index++)
              printf("         %s\n",global_material_list.elements[loop_index].name);
            printf("\n");
            printf("       It is also possible to use one of the defualt materials avaiable: \n");
            printf("           Vacuum (for a Volume without scattering or absorption)\n");
            printf("           Exit (for a Volume where the ray exits the component if it enters)\n");
            printf("           Mask (for a Volume that masks existing volumes specified in the mask_string\n");
            exit(1);
          }
        }
    }
} else {
    // Automatic linking, simply using the last defined material.
    #ifndef MATERIAL_DETECTOR
        printf("Need to define a material before the geometry to use automatic linking %s.\n",NAME_CURRENT_COMP);
        exit(1);
    #endif
    this_box_volume.p_physics = global_material_list.elements[global_material_list.num_elements-1].physics;
}

sprintf(this_box_volume.name,NAME_CURRENT_COMP);
sprintf(this_box_volume.geometry.shape,"box");
this_box_volume.geometry.priority_value = priority;
this_box_volume.geometry.geometry_p_interact = p_interact;
// Currently the coordinates will be in absolute space.
this_box_volume.geometry.center = POS_A_CURRENT_COMP;

this_box_storage.z_depth = zdepth;
this_box_storage.x_width1 = xwidth;
this_box_storage.y_height1 = yheight;

this_box_storage.is_rectangle = 0;
if (xwidth2 < 0 && yheight2 < 0) this_box_storage.is_rectangle = 1;
if (xwidth == xwidth2 && yheight == yheight2) this_box_storage.is_rectangle = 1;

if (xwidth2 < 0) {
    this_box_storage.x_width2 = xwidth;
    xwidth2 = xwidth;
} else this_box_storage.x_width2 = xwidth2;

if (yheight2 < 0) {
    this_box_storage.y_height2 = yheight;
    yheight2 = yheight;
} else this_box_storage.y_height2 = yheight2;


this_box_storage.normal_vectors[0] = coords_set(0,0,1);
this_box_storage.normal_vectors[1] = coords_set(0,0,1);

// for sides with y component = 0
x_component = 2*zdepth/sqrt((xwidth-xwidth2)*(xwidth-xwidth2)+4*zdepth*zdepth);
z_component = (xwidth-xwidth2)/sqrt(4*zdepth*zdepth+(xwidth-xwidth2)*(xwidth-xwidth2));

this_box_storage.normal_vectors[2] = coords_set(x_component,0,z_component);
this_box_storage.normal_vectors[3] = coords_set(-x_component,0,z_component);

// for sides with x component = 0
y_component = 2*zdepth/sqrt((yheight-yheight2)*(yheight-yheight2)+4*zdepth*zdepth);
z_component = (yheight-yheight2)/sqrt(4*zdepth*zdepth+(yheight-yheight2)*(yheight-yheight2));

this_box_storage.normal_vectors[4] = coords_set(0,y_component,z_component);
this_box_storage.normal_vectors[5] = coords_set(0,-y_component,z_component);

this_box_volume.geometry.visualization_on = visualize;

this_box_volume.geometry.geometry_parameters.p_box_storage = &this_box_storage;

// Assign pointers to functions for intersection with the shape, checking if a point is inside the shape
if (this_box_storage.is_rectangle == 1) {
this_box_volume.geometry.intersect_function = &sample_box_intersect_simple;
this_box_volume.geometry.within_function = &r_within_box_simple;
}
else {
this_box_volume.geometry.intersect_function = &sample_box_intersect_advanced;
this_box_volume.geometry.within_function = &r_within_box_advanced;
}

this_box_volume.geometry.shell_points = &box_shell_points;
this_box_volume.geometry.mcdisplay_function = &mcdisplay_box_function;
this_box_volume.geometry.initialize_from_main_function = &initialize_box_geometry_from_main_component;
this_box_volume.geometry.process_rot_allocated = 0;

this_box_volume.geometry.copy_geometry_parameters = &allocate_box_storage_copy;

rot_copy(this_box_volume.geometry.rotation_matrix,ROT_A_CURRENT_COMP); //check how ROT_R_CURRENT_COMP would work
rot_transpose(ROT_A_CURRENT_COMP,this_box_volume.geometry.transpose_rotation_matrix);

// Initialize loggers
this_box_volume.loggers.num_elements = 0;

// packing the information into the global_geometry_element, which is then included in the global_geometry_list.
sprintf(global_geometry_element.name,NAME_CURRENT_COMP);
global_geometry_element.activation_counter = number_of_activations;
global_geometry_element.component_index = INDEX_CURRENT_COMP;
global_geometry_element.Volume = &this_box_volume; // Would be nicer if this m was a pointer, now we have the (small) data two places
add_element_to_geometry_list(&global_geometry_list,global_geometry_element);
}
#line 221615 "MACS_sample_kidney_box.c"
#undef number_of_activations
#undef mask_setting
#undef mask_string
#undef p_interact
#undef focus_r
#undef focus_xh
#undef focus_xw
#undef focus_ah
#undef focus_aw
#undef target_z
#undef target_y
#undef target_x
#undef target_index
#undef visualize
#undef yheight2
#undef xwidth2
#undef zdepth
#undef yheight
#undef xwidth
#undef priority
#undef material_string
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

  /* Initializations for component channel_6_analyzer_2_array_crystal_array_3. */
  SIG_MESSAGE("channel_6_analyzer_2_array_crystal_array_3 (Init)");
#define mccompcurname  channel_6_analyzer_2_array_crystal_array_3
#define mccompcurtype  Union_box
#define mccompcurindex 372
#define loop_index mccchannel_6_analyzer_2_array_crystal_array_3_loop_index
#define this_box_volume mccchannel_6_analyzer_2_array_crystal_array_3_this_box_volume
#define global_geometry_element mccchannel_6_analyzer_2_array_crystal_array_3_global_geometry_element
#define this_box_storage mccchannel_6_analyzer_2_array_crystal_array_3_this_box_storage
#define material_string mccchannel_6_analyzer_2_array_crystal_array_3_material_string
#define priority mccchannel_6_analyzer_2_array_crystal_array_3_priority
#define xwidth mccchannel_6_analyzer_2_array_crystal_array_3_xwidth
#define yheight mccchannel_6_analyzer_2_array_crystal_array_3_yheight
#define zdepth mccchannel_6_analyzer_2_array_crystal_array_3_zdepth
#define xwidth2 mccchannel_6_analyzer_2_array_crystal_array_3_xwidth2
#define yheight2 mccchannel_6_analyzer_2_array_crystal_array_3_yheight2
#define visualize mccchannel_6_analyzer_2_array_crystal_array_3_visualize
#define target_index mccchannel_6_analyzer_2_array_crystal_array_3_target_index
#define target_x mccchannel_6_analyzer_2_array_crystal_array_3_target_x
#define target_y mccchannel_6_analyzer_2_array_crystal_array_3_target_y
#define target_z mccchannel_6_analyzer_2_array_crystal_array_3_target_z
#define focus_aw mccchannel_6_analyzer_2_array_crystal_array_3_focus_aw
#define focus_ah mccchannel_6_analyzer_2_array_crystal_array_3_focus_ah
#define focus_xw mccchannel_6_analyzer_2_array_crystal_array_3_focus_xw
#define focus_xh mccchannel_6_analyzer_2_array_crystal_array_3_focus_xh
#define focus_r mccchannel_6_analyzer_2_array_crystal_array_3_focus_r
#define p_interact mccchannel_6_analyzer_2_array_crystal_array_3_p_interact
#define mask_string mccchannel_6_analyzer_2_array_crystal_array_3_mask_string
#define mask_setting mccchannel_6_analyzer_2_array_crystal_array_3_mask_setting
#define number_of_activations mccchannel_6_analyzer_2_array_crystal_array_3_number_of_activations
#line 224 "Union_box.comp"
{
// Initializes the focusing system for this volume including input sanitation.
focus_initialize(&this_box_volume.geometry, POS_A_COMP_INDEX(INDEX_CURRENT_COMP+target_index), POS_A_CURRENT_COMP, ROT_A_CURRENT_COMP, target_index, target_x, target_y, target_z, focus_aw, focus_ah, focus_xw, focus_xh, focus_r, NAME_CURRENT_COMP);

// Input sanitation for this geometry
if (xwidth <= 0) {
  printf("\nERROR in Union_box named %s, the xwidth is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (yheight <= 0) {
  printf("\nERROR in Union_box named %s, yheight is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (zdepth <= 0) {
  printf("\nERROR in Union_box named %s, zdepth is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (xwidth2 <= 0 && xwidth2 != -1) {
  printf("\nERROR in Union_box named %s, the xwidth2 is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (yheight2 <= 0 && yheight2 != -1) {
  printf("\nERROR in Union_box named %s, yheight2 is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}

// Use sanitation
if (global_material_list.num_elements == 0) {
  printf("\nERROR: Need to define a material using Union_make_material before using a Union geometry component. \n");
  printf("       %s was defined before first use of Union_make_material.\n",NAME_CURRENT_COMP);
  exit(1);
}

this_box_volume.geometry.is_masked_volume = 0;
this_box_volume.geometry.is_exit_volume = 0;
this_box_volume.geometry.is_mask_volume = 0;
// check if the volume is a mask, if it is the material string is irelevant.
if (mask_string && strlen(mask_string) && strcmp(mask_string, "NULL") && strcmp(mask_string, "0")) {
    // A mask volume is used to limit the extend of other volumes, called the masked volumes. These are specified in the mask_string.
    // In order for a ray to enter a masked volume, it needs to be both in the region covered by that volume AND the mask volume.
    // When more than
    this_box_volume.geometry.mask_mode = 1; // Default is mask mode is ALL
    if (mask_setting && strlen(mask_setting) && strcmp(mask_setting, "NULL") && strcmp(mask_setting, "0")) {
        if (strcmp(mask_setting,"ALL") == 0 || strcmp(mask_setting,"All") == 0) this_box_volume.geometry.mask_mode = 1;
        else if (strcmp(mask_setting,"ANY") == 0 || strcmp(mask_setting,"Any") == 0) this_box_volume.geometry.mask_mode = 2;
        else {
            printf("The mask_mode of component %s is set to %s, but must be either ALL or ANY.\n",NAME_CURRENT_COMP,mask_setting);
            exit(1);
        }
    }
    
    for (loop_index=0;loop_index<global_geometry_list.num_elements;loop_index++) {
        // Add mask list
        if (1 == manual_linking_function(global_geometry_list.elements[loop_index].name,mask_string)) {
            add_element_to_int_list(&this_box_volume.geometry.mask_list,global_geometry_list.elements[loop_index].component_index);
            add_element_to_int_list(&global_geometry_list.elements[loop_index].Volume->geometry.masked_by_list,INDEX_CURRENT_COMP);
            global_geometry_list.elements[loop_index].Volume->geometry.is_masked_volume = 1;
            if (this_box_volume.geometry.mask_mode == 2)
                global_geometry_list.elements[loop_index].Volume->geometry.mask_mode = 2;
            if (this_box_volume.geometry.mask_mode == 1) {
                if (global_geometry_list.elements[loop_index].Volume->geometry.is_masked_volume == 1 && global_geometry_list.elements[loop_index].Volume->geometry.mask_mode != 2)
                    // If more than one mask is added to one volume, the ANY mode overwrites the (default) ALL mode.
                    global_geometry_list.elements[loop_index].Volume->geometry.mask_mode = 1;
            }
            
            found_geometries = 1;
        }
    }
    if (found_geometries == 0) {
        printf("The mask_string in geometry: %s did not find any of the specified volumes in the mask_string %s \n",NAME_CURRENT_COMP,mask_string);
        exit(1);
    }
    this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
    this_box_volume.p_physics->is_vacuum = 0; // Makes this volume a vacuum
    this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
    this_box_volume.p_physics->my_a = 0; // Should not be used.
    sprintf(this_box_volume.p_physics->name,"Mask");
    this_box_volume.geometry.is_mask_volume = 1;
    
    
// Read the material input, or if it lacks, use automatic linking.
} else if (material_string && strlen(material_string) && strcmp(material_string, "NULL") && strcmp(material_string, "0")) {
    // A geometry string was given, use it to determine which material
    if (0 == strcmp(material_string,"vacuum") || 0 == strcmp(material_string,"Vacuum")) {
        // One could have a global physics struct for vacuum instead of creating one for each
        this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
        this_box_volume.p_physics->is_vacuum = 1; // Makes this volume a vacuum
        this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
        this_box_volume.p_physics->my_a = 0; // Should not be used.
        sprintf(this_box_volume.p_physics->name,"Vacuum");
    } else if (0 == strcmp(material_string,"exit") || 0 == strcmp(material_string,"Exit")) {
        // One could have a global physics struct for vacuum instead of creating one for each
        this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
        this_box_volume.p_physics->is_vacuum = 1; // Makes this volume a vacuum
        this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
        this_box_volume.p_physics->my_a = 0; // Should not be used.
        this_box_volume.geometry.is_exit_volume = 1;
        sprintf(this_box_volume.p_physics->name,"Exit");
    } else {
        #ifndef MATERIAL_DETECTOR
            printf("Need to define a material before refering to it in a geometry %s.\n",NAME_CURRENT_COMP);
            exit(1);
        #endif
        for (loop_index=0;loop_index<global_material_list.num_elements;loop_index++) {
            if (0 == strcmp(material_string,global_material_list.elements[loop_index].name)) {
                this_box_volume.p_physics = global_material_list.elements[loop_index].physics;
                break;
            }
            if (loop_index == global_material_list.num_elements-1) {
            printf("\n");
            printf("ERROR: The material string \"%s\" in Union geometry \"%s\" did not match a specified material. \n",material_string,NAME_CURRENT_COMP);
            printf("       The materials available at this point (need to be defined before the geometry): \n");
            for (loop_index=0;loop_index<global_material_list.num_elements;loop_index++)
              printf("         %s\n",global_material_list.elements[loop_index].name);
            printf("\n");
            printf("       It is also possible to use one of the defualt materials avaiable: \n");
            printf("           Vacuum (for a Volume without scattering or absorption)\n");
            printf("           Exit (for a Volume where the ray exits the component if it enters)\n");
            printf("           Mask (for a Volume that masks existing volumes specified in the mask_string\n");
            exit(1);
          }
        }
    }
} else {
    // Automatic linking, simply using the last defined material.
    #ifndef MATERIAL_DETECTOR
        printf("Need to define a material before the geometry to use automatic linking %s.\n",NAME_CURRENT_COMP);
        exit(1);
    #endif
    this_box_volume.p_physics = global_material_list.elements[global_material_list.num_elements-1].physics;
}

sprintf(this_box_volume.name,NAME_CURRENT_COMP);
sprintf(this_box_volume.geometry.shape,"box");
this_box_volume.geometry.priority_value = priority;
this_box_volume.geometry.geometry_p_interact = p_interact;
// Currently the coordinates will be in absolute space.
this_box_volume.geometry.center = POS_A_CURRENT_COMP;

this_box_storage.z_depth = zdepth;
this_box_storage.x_width1 = xwidth;
this_box_storage.y_height1 = yheight;

this_box_storage.is_rectangle = 0;
if (xwidth2 < 0 && yheight2 < 0) this_box_storage.is_rectangle = 1;
if (xwidth == xwidth2 && yheight == yheight2) this_box_storage.is_rectangle = 1;

if (xwidth2 < 0) {
    this_box_storage.x_width2 = xwidth;
    xwidth2 = xwidth;
} else this_box_storage.x_width2 = xwidth2;

if (yheight2 < 0) {
    this_box_storage.y_height2 = yheight;
    yheight2 = yheight;
} else this_box_storage.y_height2 = yheight2;


this_box_storage.normal_vectors[0] = coords_set(0,0,1);
this_box_storage.normal_vectors[1] = coords_set(0,0,1);

// for sides with y component = 0
x_component = 2*zdepth/sqrt((xwidth-xwidth2)*(xwidth-xwidth2)+4*zdepth*zdepth);
z_component = (xwidth-xwidth2)/sqrt(4*zdepth*zdepth+(xwidth-xwidth2)*(xwidth-xwidth2));

this_box_storage.normal_vectors[2] = coords_set(x_component,0,z_component);
this_box_storage.normal_vectors[3] = coords_set(-x_component,0,z_component);

// for sides with x component = 0
y_component = 2*zdepth/sqrt((yheight-yheight2)*(yheight-yheight2)+4*zdepth*zdepth);
z_component = (yheight-yheight2)/sqrt(4*zdepth*zdepth+(yheight-yheight2)*(yheight-yheight2));

this_box_storage.normal_vectors[4] = coords_set(0,y_component,z_component);
this_box_storage.normal_vectors[5] = coords_set(0,-y_component,z_component);

this_box_volume.geometry.visualization_on = visualize;

this_box_volume.geometry.geometry_parameters.p_box_storage = &this_box_storage;

// Assign pointers to functions for intersection with the shape, checking if a point is inside the shape
if (this_box_storage.is_rectangle == 1) {
this_box_volume.geometry.intersect_function = &sample_box_intersect_simple;
this_box_volume.geometry.within_function = &r_within_box_simple;
}
else {
this_box_volume.geometry.intersect_function = &sample_box_intersect_advanced;
this_box_volume.geometry.within_function = &r_within_box_advanced;
}

this_box_volume.geometry.shell_points = &box_shell_points;
this_box_volume.geometry.mcdisplay_function = &mcdisplay_box_function;
this_box_volume.geometry.initialize_from_main_function = &initialize_box_geometry_from_main_component;
this_box_volume.geometry.process_rot_allocated = 0;

this_box_volume.geometry.copy_geometry_parameters = &allocate_box_storage_copy;

rot_copy(this_box_volume.geometry.rotation_matrix,ROT_A_CURRENT_COMP); //check how ROT_R_CURRENT_COMP would work
rot_transpose(ROT_A_CURRENT_COMP,this_box_volume.geometry.transpose_rotation_matrix);

// Initialize loggers
this_box_volume.loggers.num_elements = 0;

// packing the information into the global_geometry_element, which is then included in the global_geometry_list.
sprintf(global_geometry_element.name,NAME_CURRENT_COMP);
global_geometry_element.activation_counter = number_of_activations;
global_geometry_element.component_index = INDEX_CURRENT_COMP;
global_geometry_element.Volume = &this_box_volume; // Would be nicer if this m was a pointer, now we have the (small) data two places
add_element_to_geometry_list(&global_geometry_list,global_geometry_element);
}
#line 221885 "MACS_sample_kidney_box.c"
#undef number_of_activations
#undef mask_setting
#undef mask_string
#undef p_interact
#undef focus_r
#undef focus_xh
#undef focus_xw
#undef focus_ah
#undef focus_aw
#undef target_z
#undef target_y
#undef target_x
#undef target_index
#undef visualize
#undef yheight2
#undef xwidth2
#undef zdepth
#undef yheight
#undef xwidth
#undef priority
#undef material_string
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

  /* Initializations for component channel_6_analyzer_2_array_crystal_array_4. */
  SIG_MESSAGE("channel_6_analyzer_2_array_crystal_array_4 (Init)");
#define mccompcurname  channel_6_analyzer_2_array_crystal_array_4
#define mccompcurtype  Union_box
#define mccompcurindex 373
#define loop_index mccchannel_6_analyzer_2_array_crystal_array_4_loop_index
#define this_box_volume mccchannel_6_analyzer_2_array_crystal_array_4_this_box_volume
#define global_geometry_element mccchannel_6_analyzer_2_array_crystal_array_4_global_geometry_element
#define this_box_storage mccchannel_6_analyzer_2_array_crystal_array_4_this_box_storage
#define material_string mccchannel_6_analyzer_2_array_crystal_array_4_material_string
#define priority mccchannel_6_analyzer_2_array_crystal_array_4_priority
#define xwidth mccchannel_6_analyzer_2_array_crystal_array_4_xwidth
#define yheight mccchannel_6_analyzer_2_array_crystal_array_4_yheight
#define zdepth mccchannel_6_analyzer_2_array_crystal_array_4_zdepth
#define xwidth2 mccchannel_6_analyzer_2_array_crystal_array_4_xwidth2
#define yheight2 mccchannel_6_analyzer_2_array_crystal_array_4_yheight2
#define visualize mccchannel_6_analyzer_2_array_crystal_array_4_visualize
#define target_index mccchannel_6_analyzer_2_array_crystal_array_4_target_index
#define target_x mccchannel_6_analyzer_2_array_crystal_array_4_target_x
#define target_y mccchannel_6_analyzer_2_array_crystal_array_4_target_y
#define target_z mccchannel_6_analyzer_2_array_crystal_array_4_target_z
#define focus_aw mccchannel_6_analyzer_2_array_crystal_array_4_focus_aw
#define focus_ah mccchannel_6_analyzer_2_array_crystal_array_4_focus_ah
#define focus_xw mccchannel_6_analyzer_2_array_crystal_array_4_focus_xw
#define focus_xh mccchannel_6_analyzer_2_array_crystal_array_4_focus_xh
#define focus_r mccchannel_6_analyzer_2_array_crystal_array_4_focus_r
#define p_interact mccchannel_6_analyzer_2_array_crystal_array_4_p_interact
#define mask_string mccchannel_6_analyzer_2_array_crystal_array_4_mask_string
#define mask_setting mccchannel_6_analyzer_2_array_crystal_array_4_mask_setting
#define number_of_activations mccchannel_6_analyzer_2_array_crystal_array_4_number_of_activations
#line 224 "Union_box.comp"
{
// Initializes the focusing system for this volume including input sanitation.
focus_initialize(&this_box_volume.geometry, POS_A_COMP_INDEX(INDEX_CURRENT_COMP+target_index), POS_A_CURRENT_COMP, ROT_A_CURRENT_COMP, target_index, target_x, target_y, target_z, focus_aw, focus_ah, focus_xw, focus_xh, focus_r, NAME_CURRENT_COMP);

// Input sanitation for this geometry
if (xwidth <= 0) {
  printf("\nERROR in Union_box named %s, the xwidth is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (yheight <= 0) {
  printf("\nERROR in Union_box named %s, yheight is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (zdepth <= 0) {
  printf("\nERROR in Union_box named %s, zdepth is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (xwidth2 <= 0 && xwidth2 != -1) {
  printf("\nERROR in Union_box named %s, the xwidth2 is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (yheight2 <= 0 && yheight2 != -1) {
  printf("\nERROR in Union_box named %s, yheight2 is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}

// Use sanitation
if (global_material_list.num_elements == 0) {
  printf("\nERROR: Need to define a material using Union_make_material before using a Union geometry component. \n");
  printf("       %s was defined before first use of Union_make_material.\n",NAME_CURRENT_COMP);
  exit(1);
}

this_box_volume.geometry.is_masked_volume = 0;
this_box_volume.geometry.is_exit_volume = 0;
this_box_volume.geometry.is_mask_volume = 0;
// check if the volume is a mask, if it is the material string is irelevant.
if (mask_string && strlen(mask_string) && strcmp(mask_string, "NULL") && strcmp(mask_string, "0")) {
    // A mask volume is used to limit the extend of other volumes, called the masked volumes. These are specified in the mask_string.
    // In order for a ray to enter a masked volume, it needs to be both in the region covered by that volume AND the mask volume.
    // When more than
    this_box_volume.geometry.mask_mode = 1; // Default is mask mode is ALL
    if (mask_setting && strlen(mask_setting) && strcmp(mask_setting, "NULL") && strcmp(mask_setting, "0")) {
        if (strcmp(mask_setting,"ALL") == 0 || strcmp(mask_setting,"All") == 0) this_box_volume.geometry.mask_mode = 1;
        else if (strcmp(mask_setting,"ANY") == 0 || strcmp(mask_setting,"Any") == 0) this_box_volume.geometry.mask_mode = 2;
        else {
            printf("The mask_mode of component %s is set to %s, but must be either ALL or ANY.\n",NAME_CURRENT_COMP,mask_setting);
            exit(1);
        }
    }
    
    for (loop_index=0;loop_index<global_geometry_list.num_elements;loop_index++) {
        // Add mask list
        if (1 == manual_linking_function(global_geometry_list.elements[loop_index].name,mask_string)) {
            add_element_to_int_list(&this_box_volume.geometry.mask_list,global_geometry_list.elements[loop_index].component_index);
            add_element_to_int_list(&global_geometry_list.elements[loop_index].Volume->geometry.masked_by_list,INDEX_CURRENT_COMP);
            global_geometry_list.elements[loop_index].Volume->geometry.is_masked_volume = 1;
            if (this_box_volume.geometry.mask_mode == 2)
                global_geometry_list.elements[loop_index].Volume->geometry.mask_mode = 2;
            if (this_box_volume.geometry.mask_mode == 1) {
                if (global_geometry_list.elements[loop_index].Volume->geometry.is_masked_volume == 1 && global_geometry_list.elements[loop_index].Volume->geometry.mask_mode != 2)
                    // If more than one mask is added to one volume, the ANY mode overwrites the (default) ALL mode.
                    global_geometry_list.elements[loop_index].Volume->geometry.mask_mode = 1;
            }
            
            found_geometries = 1;
        }
    }
    if (found_geometries == 0) {
        printf("The mask_string in geometry: %s did not find any of the specified volumes in the mask_string %s \n",NAME_CURRENT_COMP,mask_string);
        exit(1);
    }
    this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
    this_box_volume.p_physics->is_vacuum = 0; // Makes this volume a vacuum
    this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
    this_box_volume.p_physics->my_a = 0; // Should not be used.
    sprintf(this_box_volume.p_physics->name,"Mask");
    this_box_volume.geometry.is_mask_volume = 1;
    
    
// Read the material input, or if it lacks, use automatic linking.
} else if (material_string && strlen(material_string) && strcmp(material_string, "NULL") && strcmp(material_string, "0")) {
    // A geometry string was given, use it to determine which material
    if (0 == strcmp(material_string,"vacuum") || 0 == strcmp(material_string,"Vacuum")) {
        // One could have a global physics struct for vacuum instead of creating one for each
        this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
        this_box_volume.p_physics->is_vacuum = 1; // Makes this volume a vacuum
        this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
        this_box_volume.p_physics->my_a = 0; // Should not be used.
        sprintf(this_box_volume.p_physics->name,"Vacuum");
    } else if (0 == strcmp(material_string,"exit") || 0 == strcmp(material_string,"Exit")) {
        // One could have a global physics struct for vacuum instead of creating one for each
        this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
        this_box_volume.p_physics->is_vacuum = 1; // Makes this volume a vacuum
        this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
        this_box_volume.p_physics->my_a = 0; // Should not be used.
        this_box_volume.geometry.is_exit_volume = 1;
        sprintf(this_box_volume.p_physics->name,"Exit");
    } else {
        #ifndef MATERIAL_DETECTOR
            printf("Need to define a material before refering to it in a geometry %s.\n",NAME_CURRENT_COMP);
            exit(1);
        #endif
        for (loop_index=0;loop_index<global_material_list.num_elements;loop_index++) {
            if (0 == strcmp(material_string,global_material_list.elements[loop_index].name)) {
                this_box_volume.p_physics = global_material_list.elements[loop_index].physics;
                break;
            }
            if (loop_index == global_material_list.num_elements-1) {
            printf("\n");
            printf("ERROR: The material string \"%s\" in Union geometry \"%s\" did not match a specified material. \n",material_string,NAME_CURRENT_COMP);
            printf("       The materials available at this point (need to be defined before the geometry): \n");
            for (loop_index=0;loop_index<global_material_list.num_elements;loop_index++)
              printf("         %s\n",global_material_list.elements[loop_index].name);
            printf("\n");
            printf("       It is also possible to use one of the defualt materials avaiable: \n");
            printf("           Vacuum (for a Volume without scattering or absorption)\n");
            printf("           Exit (for a Volume where the ray exits the component if it enters)\n");
            printf("           Mask (for a Volume that masks existing volumes specified in the mask_string\n");
            exit(1);
          }
        }
    }
} else {
    // Automatic linking, simply using the last defined material.
    #ifndef MATERIAL_DETECTOR
        printf("Need to define a material before the geometry to use automatic linking %s.\n",NAME_CURRENT_COMP);
        exit(1);
    #endif
    this_box_volume.p_physics = global_material_list.elements[global_material_list.num_elements-1].physics;
}

sprintf(this_box_volume.name,NAME_CURRENT_COMP);
sprintf(this_box_volume.geometry.shape,"box");
this_box_volume.geometry.priority_value = priority;
this_box_volume.geometry.geometry_p_interact = p_interact;
// Currently the coordinates will be in absolute space.
this_box_volume.geometry.center = POS_A_CURRENT_COMP;

this_box_storage.z_depth = zdepth;
this_box_storage.x_width1 = xwidth;
this_box_storage.y_height1 = yheight;

this_box_storage.is_rectangle = 0;
if (xwidth2 < 0 && yheight2 < 0) this_box_storage.is_rectangle = 1;
if (xwidth == xwidth2 && yheight == yheight2) this_box_storage.is_rectangle = 1;

if (xwidth2 < 0) {
    this_box_storage.x_width2 = xwidth;
    xwidth2 = xwidth;
} else this_box_storage.x_width2 = xwidth2;

if (yheight2 < 0) {
    this_box_storage.y_height2 = yheight;
    yheight2 = yheight;
} else this_box_storage.y_height2 = yheight2;


this_box_storage.normal_vectors[0] = coords_set(0,0,1);
this_box_storage.normal_vectors[1] = coords_set(0,0,1);

// for sides with y component = 0
x_component = 2*zdepth/sqrt((xwidth-xwidth2)*(xwidth-xwidth2)+4*zdepth*zdepth);
z_component = (xwidth-xwidth2)/sqrt(4*zdepth*zdepth+(xwidth-xwidth2)*(xwidth-xwidth2));

this_box_storage.normal_vectors[2] = coords_set(x_component,0,z_component);
this_box_storage.normal_vectors[3] = coords_set(-x_component,0,z_component);

// for sides with x component = 0
y_component = 2*zdepth/sqrt((yheight-yheight2)*(yheight-yheight2)+4*zdepth*zdepth);
z_component = (yheight-yheight2)/sqrt(4*zdepth*zdepth+(yheight-yheight2)*(yheight-yheight2));

this_box_storage.normal_vectors[4] = coords_set(0,y_component,z_component);
this_box_storage.normal_vectors[5] = coords_set(0,-y_component,z_component);

this_box_volume.geometry.visualization_on = visualize;

this_box_volume.geometry.geometry_parameters.p_box_storage = &this_box_storage;

// Assign pointers to functions for intersection with the shape, checking if a point is inside the shape
if (this_box_storage.is_rectangle == 1) {
this_box_volume.geometry.intersect_function = &sample_box_intersect_simple;
this_box_volume.geometry.within_function = &r_within_box_simple;
}
else {
this_box_volume.geometry.intersect_function = &sample_box_intersect_advanced;
this_box_volume.geometry.within_function = &r_within_box_advanced;
}

this_box_volume.geometry.shell_points = &box_shell_points;
this_box_volume.geometry.mcdisplay_function = &mcdisplay_box_function;
this_box_volume.geometry.initialize_from_main_function = &initialize_box_geometry_from_main_component;
this_box_volume.geometry.process_rot_allocated = 0;

this_box_volume.geometry.copy_geometry_parameters = &allocate_box_storage_copy;

rot_copy(this_box_volume.geometry.rotation_matrix,ROT_A_CURRENT_COMP); //check how ROT_R_CURRENT_COMP would work
rot_transpose(ROT_A_CURRENT_COMP,this_box_volume.geometry.transpose_rotation_matrix);

// Initialize loggers
this_box_volume.loggers.num_elements = 0;

// packing the information into the global_geometry_element, which is then included in the global_geometry_list.
sprintf(global_geometry_element.name,NAME_CURRENT_COMP);
global_geometry_element.activation_counter = number_of_activations;
global_geometry_element.component_index = INDEX_CURRENT_COMP;
global_geometry_element.Volume = &this_box_volume; // Would be nicer if this m was a pointer, now we have the (small) data two places
add_element_to_geometry_list(&global_geometry_list,global_geometry_element);
}
#line 222155 "MACS_sample_kidney_box.c"
#undef number_of_activations
#undef mask_setting
#undef mask_string
#undef p_interact
#undef focus_r
#undef focus_xh
#undef focus_xw
#undef focus_ah
#undef focus_aw
#undef target_z
#undef target_y
#undef target_x
#undef target_index
#undef visualize
#undef yheight2
#undef xwidth2
#undef zdepth
#undef yheight
#undef xwidth
#undef priority
#undef material_string
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

  /* Initializations for component channel_6_analyzer_2_array_crystal_array_5. */
  SIG_MESSAGE("channel_6_analyzer_2_array_crystal_array_5 (Init)");
#define mccompcurname  channel_6_analyzer_2_array_crystal_array_5
#define mccompcurtype  Union_box
#define mccompcurindex 374
#define loop_index mccchannel_6_analyzer_2_array_crystal_array_5_loop_index
#define this_box_volume mccchannel_6_analyzer_2_array_crystal_array_5_this_box_volume
#define global_geometry_element mccchannel_6_analyzer_2_array_crystal_array_5_global_geometry_element
#define this_box_storage mccchannel_6_analyzer_2_array_crystal_array_5_this_box_storage
#define material_string mccchannel_6_analyzer_2_array_crystal_array_5_material_string
#define priority mccchannel_6_analyzer_2_array_crystal_array_5_priority
#define xwidth mccchannel_6_analyzer_2_array_crystal_array_5_xwidth
#define yheight mccchannel_6_analyzer_2_array_crystal_array_5_yheight
#define zdepth mccchannel_6_analyzer_2_array_crystal_array_5_zdepth
#define xwidth2 mccchannel_6_analyzer_2_array_crystal_array_5_xwidth2
#define yheight2 mccchannel_6_analyzer_2_array_crystal_array_5_yheight2
#define visualize mccchannel_6_analyzer_2_array_crystal_array_5_visualize
#define target_index mccchannel_6_analyzer_2_array_crystal_array_5_target_index
#define target_x mccchannel_6_analyzer_2_array_crystal_array_5_target_x
#define target_y mccchannel_6_analyzer_2_array_crystal_array_5_target_y
#define target_z mccchannel_6_analyzer_2_array_crystal_array_5_target_z
#define focus_aw mccchannel_6_analyzer_2_array_crystal_array_5_focus_aw
#define focus_ah mccchannel_6_analyzer_2_array_crystal_array_5_focus_ah
#define focus_xw mccchannel_6_analyzer_2_array_crystal_array_5_focus_xw
#define focus_xh mccchannel_6_analyzer_2_array_crystal_array_5_focus_xh
#define focus_r mccchannel_6_analyzer_2_array_crystal_array_5_focus_r
#define p_interact mccchannel_6_analyzer_2_array_crystal_array_5_p_interact
#define mask_string mccchannel_6_analyzer_2_array_crystal_array_5_mask_string
#define mask_setting mccchannel_6_analyzer_2_array_crystal_array_5_mask_setting
#define number_of_activations mccchannel_6_analyzer_2_array_crystal_array_5_number_of_activations
#line 224 "Union_box.comp"
{
// Initializes the focusing system for this volume including input sanitation.
focus_initialize(&this_box_volume.geometry, POS_A_COMP_INDEX(INDEX_CURRENT_COMP+target_index), POS_A_CURRENT_COMP, ROT_A_CURRENT_COMP, target_index, target_x, target_y, target_z, focus_aw, focus_ah, focus_xw, focus_xh, focus_r, NAME_CURRENT_COMP);

// Input sanitation for this geometry
if (xwidth <= 0) {
  printf("\nERROR in Union_box named %s, the xwidth is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (yheight <= 0) {
  printf("\nERROR in Union_box named %s, yheight is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (zdepth <= 0) {
  printf("\nERROR in Union_box named %s, zdepth is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (xwidth2 <= 0 && xwidth2 != -1) {
  printf("\nERROR in Union_box named %s, the xwidth2 is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (yheight2 <= 0 && yheight2 != -1) {
  printf("\nERROR in Union_box named %s, yheight2 is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}

// Use sanitation
if (global_material_list.num_elements == 0) {
  printf("\nERROR: Need to define a material using Union_make_material before using a Union geometry component. \n");
  printf("       %s was defined before first use of Union_make_material.\n",NAME_CURRENT_COMP);
  exit(1);
}

this_box_volume.geometry.is_masked_volume = 0;
this_box_volume.geometry.is_exit_volume = 0;
this_box_volume.geometry.is_mask_volume = 0;
// check if the volume is a mask, if it is the material string is irelevant.
if (mask_string && strlen(mask_string) && strcmp(mask_string, "NULL") && strcmp(mask_string, "0")) {
    // A mask volume is used to limit the extend of other volumes, called the masked volumes. These are specified in the mask_string.
    // In order for a ray to enter a masked volume, it needs to be both in the region covered by that volume AND the mask volume.
    // When more than
    this_box_volume.geometry.mask_mode = 1; // Default is mask mode is ALL
    if (mask_setting && strlen(mask_setting) && strcmp(mask_setting, "NULL") && strcmp(mask_setting, "0")) {
        if (strcmp(mask_setting,"ALL") == 0 || strcmp(mask_setting,"All") == 0) this_box_volume.geometry.mask_mode = 1;
        else if (strcmp(mask_setting,"ANY") == 0 || strcmp(mask_setting,"Any") == 0) this_box_volume.geometry.mask_mode = 2;
        else {
            printf("The mask_mode of component %s is set to %s, but must be either ALL or ANY.\n",NAME_CURRENT_COMP,mask_setting);
            exit(1);
        }
    }
    
    for (loop_index=0;loop_index<global_geometry_list.num_elements;loop_index++) {
        // Add mask list
        if (1 == manual_linking_function(global_geometry_list.elements[loop_index].name,mask_string)) {
            add_element_to_int_list(&this_box_volume.geometry.mask_list,global_geometry_list.elements[loop_index].component_index);
            add_element_to_int_list(&global_geometry_list.elements[loop_index].Volume->geometry.masked_by_list,INDEX_CURRENT_COMP);
            global_geometry_list.elements[loop_index].Volume->geometry.is_masked_volume = 1;
            if (this_box_volume.geometry.mask_mode == 2)
                global_geometry_list.elements[loop_index].Volume->geometry.mask_mode = 2;
            if (this_box_volume.geometry.mask_mode == 1) {
                if (global_geometry_list.elements[loop_index].Volume->geometry.is_masked_volume == 1 && global_geometry_list.elements[loop_index].Volume->geometry.mask_mode != 2)
                    // If more than one mask is added to one volume, the ANY mode overwrites the (default) ALL mode.
                    global_geometry_list.elements[loop_index].Volume->geometry.mask_mode = 1;
            }
            
            found_geometries = 1;
        }
    }
    if (found_geometries == 0) {
        printf("The mask_string in geometry: %s did not find any of the specified volumes in the mask_string %s \n",NAME_CURRENT_COMP,mask_string);
        exit(1);
    }
    this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
    this_box_volume.p_physics->is_vacuum = 0; // Makes this volume a vacuum
    this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
    this_box_volume.p_physics->my_a = 0; // Should not be used.
    sprintf(this_box_volume.p_physics->name,"Mask");
    this_box_volume.geometry.is_mask_volume = 1;
    
    
// Read the material input, or if it lacks, use automatic linking.
} else if (material_string && strlen(material_string) && strcmp(material_string, "NULL") && strcmp(material_string, "0")) {
    // A geometry string was given, use it to determine which material
    if (0 == strcmp(material_string,"vacuum") || 0 == strcmp(material_string,"Vacuum")) {
        // One could have a global physics struct for vacuum instead of creating one for each
        this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
        this_box_volume.p_physics->is_vacuum = 1; // Makes this volume a vacuum
        this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
        this_box_volume.p_physics->my_a = 0; // Should not be used.
        sprintf(this_box_volume.p_physics->name,"Vacuum");
    } else if (0 == strcmp(material_string,"exit") || 0 == strcmp(material_string,"Exit")) {
        // One could have a global physics struct for vacuum instead of creating one for each
        this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
        this_box_volume.p_physics->is_vacuum = 1; // Makes this volume a vacuum
        this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
        this_box_volume.p_physics->my_a = 0; // Should not be used.
        this_box_volume.geometry.is_exit_volume = 1;
        sprintf(this_box_volume.p_physics->name,"Exit");
    } else {
        #ifndef MATERIAL_DETECTOR
            printf("Need to define a material before refering to it in a geometry %s.\n",NAME_CURRENT_COMP);
            exit(1);
        #endif
        for (loop_index=0;loop_index<global_material_list.num_elements;loop_index++) {
            if (0 == strcmp(material_string,global_material_list.elements[loop_index].name)) {
                this_box_volume.p_physics = global_material_list.elements[loop_index].physics;
                break;
            }
            if (loop_index == global_material_list.num_elements-1) {
            printf("\n");
            printf("ERROR: The material string \"%s\" in Union geometry \"%s\" did not match a specified material. \n",material_string,NAME_CURRENT_COMP);
            printf("       The materials available at this point (need to be defined before the geometry): \n");
            for (loop_index=0;loop_index<global_material_list.num_elements;loop_index++)
              printf("         %s\n",global_material_list.elements[loop_index].name);
            printf("\n");
            printf("       It is also possible to use one of the defualt materials avaiable: \n");
            printf("           Vacuum (for a Volume without scattering or absorption)\n");
            printf("           Exit (for a Volume where the ray exits the component if it enters)\n");
            printf("           Mask (for a Volume that masks existing volumes specified in the mask_string\n");
            exit(1);
          }
        }
    }
} else {
    // Automatic linking, simply using the last defined material.
    #ifndef MATERIAL_DETECTOR
        printf("Need to define a material before the geometry to use automatic linking %s.\n",NAME_CURRENT_COMP);
        exit(1);
    #endif
    this_box_volume.p_physics = global_material_list.elements[global_material_list.num_elements-1].physics;
}

sprintf(this_box_volume.name,NAME_CURRENT_COMP);
sprintf(this_box_volume.geometry.shape,"box");
this_box_volume.geometry.priority_value = priority;
this_box_volume.geometry.geometry_p_interact = p_interact;
// Currently the coordinates will be in absolute space.
this_box_volume.geometry.center = POS_A_CURRENT_COMP;

this_box_storage.z_depth = zdepth;
this_box_storage.x_width1 = xwidth;
this_box_storage.y_height1 = yheight;

this_box_storage.is_rectangle = 0;
if (xwidth2 < 0 && yheight2 < 0) this_box_storage.is_rectangle = 1;
if (xwidth == xwidth2 && yheight == yheight2) this_box_storage.is_rectangle = 1;

if (xwidth2 < 0) {
    this_box_storage.x_width2 = xwidth;
    xwidth2 = xwidth;
} else this_box_storage.x_width2 = xwidth2;

if (yheight2 < 0) {
    this_box_storage.y_height2 = yheight;
    yheight2 = yheight;
} else this_box_storage.y_height2 = yheight2;


this_box_storage.normal_vectors[0] = coords_set(0,0,1);
this_box_storage.normal_vectors[1] = coords_set(0,0,1);

// for sides with y component = 0
x_component = 2*zdepth/sqrt((xwidth-xwidth2)*(xwidth-xwidth2)+4*zdepth*zdepth);
z_component = (xwidth-xwidth2)/sqrt(4*zdepth*zdepth+(xwidth-xwidth2)*(xwidth-xwidth2));

this_box_storage.normal_vectors[2] = coords_set(x_component,0,z_component);
this_box_storage.normal_vectors[3] = coords_set(-x_component,0,z_component);

// for sides with x component = 0
y_component = 2*zdepth/sqrt((yheight-yheight2)*(yheight-yheight2)+4*zdepth*zdepth);
z_component = (yheight-yheight2)/sqrt(4*zdepth*zdepth+(yheight-yheight2)*(yheight-yheight2));

this_box_storage.normal_vectors[4] = coords_set(0,y_component,z_component);
this_box_storage.normal_vectors[5] = coords_set(0,-y_component,z_component);

this_box_volume.geometry.visualization_on = visualize;

this_box_volume.geometry.geometry_parameters.p_box_storage = &this_box_storage;

// Assign pointers to functions for intersection with the shape, checking if a point is inside the shape
if (this_box_storage.is_rectangle == 1) {
this_box_volume.geometry.intersect_function = &sample_box_intersect_simple;
this_box_volume.geometry.within_function = &r_within_box_simple;
}
else {
this_box_volume.geometry.intersect_function = &sample_box_intersect_advanced;
this_box_volume.geometry.within_function = &r_within_box_advanced;
}

this_box_volume.geometry.shell_points = &box_shell_points;
this_box_volume.geometry.mcdisplay_function = &mcdisplay_box_function;
this_box_volume.geometry.initialize_from_main_function = &initialize_box_geometry_from_main_component;
this_box_volume.geometry.process_rot_allocated = 0;

this_box_volume.geometry.copy_geometry_parameters = &allocate_box_storage_copy;

rot_copy(this_box_volume.geometry.rotation_matrix,ROT_A_CURRENT_COMP); //check how ROT_R_CURRENT_COMP would work
rot_transpose(ROT_A_CURRENT_COMP,this_box_volume.geometry.transpose_rotation_matrix);

// Initialize loggers
this_box_volume.loggers.num_elements = 0;

// packing the information into the global_geometry_element, which is then included in the global_geometry_list.
sprintf(global_geometry_element.name,NAME_CURRENT_COMP);
global_geometry_element.activation_counter = number_of_activations;
global_geometry_element.component_index = INDEX_CURRENT_COMP;
global_geometry_element.Volume = &this_box_volume; // Would be nicer if this m was a pointer, now we have the (small) data two places
add_element_to_geometry_list(&global_geometry_list,global_geometry_element);
}
#line 222425 "MACS_sample_kidney_box.c"
#undef number_of_activations
#undef mask_setting
#undef mask_string
#undef p_interact
#undef focus_r
#undef focus_xh
#undef focus_xw
#undef focus_ah
#undef focus_aw
#undef target_z
#undef target_y
#undef target_x
#undef target_index
#undef visualize
#undef yheight2
#undef xwidth2
#undef zdepth
#undef yheight
#undef xwidth
#undef priority
#undef material_string
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

  /* Initializations for component channel_6_analyzer_2_array_crystal_array_6. */
  SIG_MESSAGE("channel_6_analyzer_2_array_crystal_array_6 (Init)");
#define mccompcurname  channel_6_analyzer_2_array_crystal_array_6
#define mccompcurtype  Union_box
#define mccompcurindex 375
#define loop_index mccchannel_6_analyzer_2_array_crystal_array_6_loop_index
#define this_box_volume mccchannel_6_analyzer_2_array_crystal_array_6_this_box_volume
#define global_geometry_element mccchannel_6_analyzer_2_array_crystal_array_6_global_geometry_element
#define this_box_storage mccchannel_6_analyzer_2_array_crystal_array_6_this_box_storage
#define material_string mccchannel_6_analyzer_2_array_crystal_array_6_material_string
#define priority mccchannel_6_analyzer_2_array_crystal_array_6_priority
#define xwidth mccchannel_6_analyzer_2_array_crystal_array_6_xwidth
#define yheight mccchannel_6_analyzer_2_array_crystal_array_6_yheight
#define zdepth mccchannel_6_analyzer_2_array_crystal_array_6_zdepth
#define xwidth2 mccchannel_6_analyzer_2_array_crystal_array_6_xwidth2
#define yheight2 mccchannel_6_analyzer_2_array_crystal_array_6_yheight2
#define visualize mccchannel_6_analyzer_2_array_crystal_array_6_visualize
#define target_index mccchannel_6_analyzer_2_array_crystal_array_6_target_index
#define target_x mccchannel_6_analyzer_2_array_crystal_array_6_target_x
#define target_y mccchannel_6_analyzer_2_array_crystal_array_6_target_y
#define target_z mccchannel_6_analyzer_2_array_crystal_array_6_target_z
#define focus_aw mccchannel_6_analyzer_2_array_crystal_array_6_focus_aw
#define focus_ah mccchannel_6_analyzer_2_array_crystal_array_6_focus_ah
#define focus_xw mccchannel_6_analyzer_2_array_crystal_array_6_focus_xw
#define focus_xh mccchannel_6_analyzer_2_array_crystal_array_6_focus_xh
#define focus_r mccchannel_6_analyzer_2_array_crystal_array_6_focus_r
#define p_interact mccchannel_6_analyzer_2_array_crystal_array_6_p_interact
#define mask_string mccchannel_6_analyzer_2_array_crystal_array_6_mask_string
#define mask_setting mccchannel_6_analyzer_2_array_crystal_array_6_mask_setting
#define number_of_activations mccchannel_6_analyzer_2_array_crystal_array_6_number_of_activations
#line 224 "Union_box.comp"
{
// Initializes the focusing system for this volume including input sanitation.
focus_initialize(&this_box_volume.geometry, POS_A_COMP_INDEX(INDEX_CURRENT_COMP+target_index), POS_A_CURRENT_COMP, ROT_A_CURRENT_COMP, target_index, target_x, target_y, target_z, focus_aw, focus_ah, focus_xw, focus_xh, focus_r, NAME_CURRENT_COMP);

// Input sanitation for this geometry
if (xwidth <= 0) {
  printf("\nERROR in Union_box named %s, the xwidth is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (yheight <= 0) {
  printf("\nERROR in Union_box named %s, yheight is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (zdepth <= 0) {
  printf("\nERROR in Union_box named %s, zdepth is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (xwidth2 <= 0 && xwidth2 != -1) {
  printf("\nERROR in Union_box named %s, the xwidth2 is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (yheight2 <= 0 && yheight2 != -1) {
  printf("\nERROR in Union_box named %s, yheight2 is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}

// Use sanitation
if (global_material_list.num_elements == 0) {
  printf("\nERROR: Need to define a material using Union_make_material before using a Union geometry component. \n");
  printf("       %s was defined before first use of Union_make_material.\n",NAME_CURRENT_COMP);
  exit(1);
}

this_box_volume.geometry.is_masked_volume = 0;
this_box_volume.geometry.is_exit_volume = 0;
this_box_volume.geometry.is_mask_volume = 0;
// check if the volume is a mask, if it is the material string is irelevant.
if (mask_string && strlen(mask_string) && strcmp(mask_string, "NULL") && strcmp(mask_string, "0")) {
    // A mask volume is used to limit the extend of other volumes, called the masked volumes. These are specified in the mask_string.
    // In order for a ray to enter a masked volume, it needs to be both in the region covered by that volume AND the mask volume.
    // When more than
    this_box_volume.geometry.mask_mode = 1; // Default is mask mode is ALL
    if (mask_setting && strlen(mask_setting) && strcmp(mask_setting, "NULL") && strcmp(mask_setting, "0")) {
        if (strcmp(mask_setting,"ALL") == 0 || strcmp(mask_setting,"All") == 0) this_box_volume.geometry.mask_mode = 1;
        else if (strcmp(mask_setting,"ANY") == 0 || strcmp(mask_setting,"Any") == 0) this_box_volume.geometry.mask_mode = 2;
        else {
            printf("The mask_mode of component %s is set to %s, but must be either ALL or ANY.\n",NAME_CURRENT_COMP,mask_setting);
            exit(1);
        }
    }
    
    for (loop_index=0;loop_index<global_geometry_list.num_elements;loop_index++) {
        // Add mask list
        if (1 == manual_linking_function(global_geometry_list.elements[loop_index].name,mask_string)) {
            add_element_to_int_list(&this_box_volume.geometry.mask_list,global_geometry_list.elements[loop_index].component_index);
            add_element_to_int_list(&global_geometry_list.elements[loop_index].Volume->geometry.masked_by_list,INDEX_CURRENT_COMP);
            global_geometry_list.elements[loop_index].Volume->geometry.is_masked_volume = 1;
            if (this_box_volume.geometry.mask_mode == 2)
                global_geometry_list.elements[loop_index].Volume->geometry.mask_mode = 2;
            if (this_box_volume.geometry.mask_mode == 1) {
                if (global_geometry_list.elements[loop_index].Volume->geometry.is_masked_volume == 1 && global_geometry_list.elements[loop_index].Volume->geometry.mask_mode != 2)
                    // If more than one mask is added to one volume, the ANY mode overwrites the (default) ALL mode.
                    global_geometry_list.elements[loop_index].Volume->geometry.mask_mode = 1;
            }
            
            found_geometries = 1;
        }
    }
    if (found_geometries == 0) {
        printf("The mask_string in geometry: %s did not find any of the specified volumes in the mask_string %s \n",NAME_CURRENT_COMP,mask_string);
        exit(1);
    }
    this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
    this_box_volume.p_physics->is_vacuum = 0; // Makes this volume a vacuum
    this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
    this_box_volume.p_physics->my_a = 0; // Should not be used.
    sprintf(this_box_volume.p_physics->name,"Mask");
    this_box_volume.geometry.is_mask_volume = 1;
    
    
// Read the material input, or if it lacks, use automatic linking.
} else if (material_string && strlen(material_string) && strcmp(material_string, "NULL") && strcmp(material_string, "0")) {
    // A geometry string was given, use it to determine which material
    if (0 == strcmp(material_string,"vacuum") || 0 == strcmp(material_string,"Vacuum")) {
        // One could have a global physics struct for vacuum instead of creating one for each
        this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
        this_box_volume.p_physics->is_vacuum = 1; // Makes this volume a vacuum
        this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
        this_box_volume.p_physics->my_a = 0; // Should not be used.
        sprintf(this_box_volume.p_physics->name,"Vacuum");
    } else if (0 == strcmp(material_string,"exit") || 0 == strcmp(material_string,"Exit")) {
        // One could have a global physics struct for vacuum instead of creating one for each
        this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
        this_box_volume.p_physics->is_vacuum = 1; // Makes this volume a vacuum
        this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
        this_box_volume.p_physics->my_a = 0; // Should not be used.
        this_box_volume.geometry.is_exit_volume = 1;
        sprintf(this_box_volume.p_physics->name,"Exit");
    } else {
        #ifndef MATERIAL_DETECTOR
            printf("Need to define a material before refering to it in a geometry %s.\n",NAME_CURRENT_COMP);
            exit(1);
        #endif
        for (loop_index=0;loop_index<global_material_list.num_elements;loop_index++) {
            if (0 == strcmp(material_string,global_material_list.elements[loop_index].name)) {
                this_box_volume.p_physics = global_material_list.elements[loop_index].physics;
                break;
            }
            if (loop_index == global_material_list.num_elements-1) {
            printf("\n");
            printf("ERROR: The material string \"%s\" in Union geometry \"%s\" did not match a specified material. \n",material_string,NAME_CURRENT_COMP);
            printf("       The materials available at this point (need to be defined before the geometry): \n");
            for (loop_index=0;loop_index<global_material_list.num_elements;loop_index++)
              printf("         %s\n",global_material_list.elements[loop_index].name);
            printf("\n");
            printf("       It is also possible to use one of the defualt materials avaiable: \n");
            printf("           Vacuum (for a Volume without scattering or absorption)\n");
            printf("           Exit (for a Volume where the ray exits the component if it enters)\n");
            printf("           Mask (for a Volume that masks existing volumes specified in the mask_string\n");
            exit(1);
          }
        }
    }
} else {
    // Automatic linking, simply using the last defined material.
    #ifndef MATERIAL_DETECTOR
        printf("Need to define a material before the geometry to use automatic linking %s.\n",NAME_CURRENT_COMP);
        exit(1);
    #endif
    this_box_volume.p_physics = global_material_list.elements[global_material_list.num_elements-1].physics;
}

sprintf(this_box_volume.name,NAME_CURRENT_COMP);
sprintf(this_box_volume.geometry.shape,"box");
this_box_volume.geometry.priority_value = priority;
this_box_volume.geometry.geometry_p_interact = p_interact;
// Currently the coordinates will be in absolute space.
this_box_volume.geometry.center = POS_A_CURRENT_COMP;

this_box_storage.z_depth = zdepth;
this_box_storage.x_width1 = xwidth;
this_box_storage.y_height1 = yheight;

this_box_storage.is_rectangle = 0;
if (xwidth2 < 0 && yheight2 < 0) this_box_storage.is_rectangle = 1;
if (xwidth == xwidth2 && yheight == yheight2) this_box_storage.is_rectangle = 1;

if (xwidth2 < 0) {
    this_box_storage.x_width2 = xwidth;
    xwidth2 = xwidth;
} else this_box_storage.x_width2 = xwidth2;

if (yheight2 < 0) {
    this_box_storage.y_height2 = yheight;
    yheight2 = yheight;
} else this_box_storage.y_height2 = yheight2;


this_box_storage.normal_vectors[0] = coords_set(0,0,1);
this_box_storage.normal_vectors[1] = coords_set(0,0,1);

// for sides with y component = 0
x_component = 2*zdepth/sqrt((xwidth-xwidth2)*(xwidth-xwidth2)+4*zdepth*zdepth);
z_component = (xwidth-xwidth2)/sqrt(4*zdepth*zdepth+(xwidth-xwidth2)*(xwidth-xwidth2));

this_box_storage.normal_vectors[2] = coords_set(x_component,0,z_component);
this_box_storage.normal_vectors[3] = coords_set(-x_component,0,z_component);

// for sides with x component = 0
y_component = 2*zdepth/sqrt((yheight-yheight2)*(yheight-yheight2)+4*zdepth*zdepth);
z_component = (yheight-yheight2)/sqrt(4*zdepth*zdepth+(yheight-yheight2)*(yheight-yheight2));

this_box_storage.normal_vectors[4] = coords_set(0,y_component,z_component);
this_box_storage.normal_vectors[5] = coords_set(0,-y_component,z_component);

this_box_volume.geometry.visualization_on = visualize;

this_box_volume.geometry.geometry_parameters.p_box_storage = &this_box_storage;

// Assign pointers to functions for intersection with the shape, checking if a point is inside the shape
if (this_box_storage.is_rectangle == 1) {
this_box_volume.geometry.intersect_function = &sample_box_intersect_simple;
this_box_volume.geometry.within_function = &r_within_box_simple;
}
else {
this_box_volume.geometry.intersect_function = &sample_box_intersect_advanced;
this_box_volume.geometry.within_function = &r_within_box_advanced;
}

this_box_volume.geometry.shell_points = &box_shell_points;
this_box_volume.geometry.mcdisplay_function = &mcdisplay_box_function;
this_box_volume.geometry.initialize_from_main_function = &initialize_box_geometry_from_main_component;
this_box_volume.geometry.process_rot_allocated = 0;

this_box_volume.geometry.copy_geometry_parameters = &allocate_box_storage_copy;

rot_copy(this_box_volume.geometry.rotation_matrix,ROT_A_CURRENT_COMP); //check how ROT_R_CURRENT_COMP would work
rot_transpose(ROT_A_CURRENT_COMP,this_box_volume.geometry.transpose_rotation_matrix);

// Initialize loggers
this_box_volume.loggers.num_elements = 0;

// packing the information into the global_geometry_element, which is then included in the global_geometry_list.
sprintf(global_geometry_element.name,NAME_CURRENT_COMP);
global_geometry_element.activation_counter = number_of_activations;
global_geometry_element.component_index = INDEX_CURRENT_COMP;
global_geometry_element.Volume = &this_box_volume; // Would be nicer if this m was a pointer, now we have the (small) data two places
add_element_to_geometry_list(&global_geometry_list,global_geometry_element);
}
#line 222695 "MACS_sample_kidney_box.c"
#undef number_of_activations
#undef mask_setting
#undef mask_string
#undef p_interact
#undef focus_r
#undef focus_xh
#undef focus_xw
#undef focus_ah
#undef focus_aw
#undef target_z
#undef target_y
#undef target_x
#undef target_index
#undef visualize
#undef yheight2
#undef xwidth2
#undef zdepth
#undef yheight
#undef xwidth
#undef priority
#undef material_string
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

  /* Initializations for component channel_6_analyzer_2_array_crystal_array_7. */
  SIG_MESSAGE("channel_6_analyzer_2_array_crystal_array_7 (Init)");
#define mccompcurname  channel_6_analyzer_2_array_crystal_array_7
#define mccompcurtype  Union_box
#define mccompcurindex 376
#define loop_index mccchannel_6_analyzer_2_array_crystal_array_7_loop_index
#define this_box_volume mccchannel_6_analyzer_2_array_crystal_array_7_this_box_volume
#define global_geometry_element mccchannel_6_analyzer_2_array_crystal_array_7_global_geometry_element
#define this_box_storage mccchannel_6_analyzer_2_array_crystal_array_7_this_box_storage
#define material_string mccchannel_6_analyzer_2_array_crystal_array_7_material_string
#define priority mccchannel_6_analyzer_2_array_crystal_array_7_priority
#define xwidth mccchannel_6_analyzer_2_array_crystal_array_7_xwidth
#define yheight mccchannel_6_analyzer_2_array_crystal_array_7_yheight
#define zdepth mccchannel_6_analyzer_2_array_crystal_array_7_zdepth
#define xwidth2 mccchannel_6_analyzer_2_array_crystal_array_7_xwidth2
#define yheight2 mccchannel_6_analyzer_2_array_crystal_array_7_yheight2
#define visualize mccchannel_6_analyzer_2_array_crystal_array_7_visualize
#define target_index mccchannel_6_analyzer_2_array_crystal_array_7_target_index
#define target_x mccchannel_6_analyzer_2_array_crystal_array_7_target_x
#define target_y mccchannel_6_analyzer_2_array_crystal_array_7_target_y
#define target_z mccchannel_6_analyzer_2_array_crystal_array_7_target_z
#define focus_aw mccchannel_6_analyzer_2_array_crystal_array_7_focus_aw
#define focus_ah mccchannel_6_analyzer_2_array_crystal_array_7_focus_ah
#define focus_xw mccchannel_6_analyzer_2_array_crystal_array_7_focus_xw
#define focus_xh mccchannel_6_analyzer_2_array_crystal_array_7_focus_xh
#define focus_r mccchannel_6_analyzer_2_array_crystal_array_7_focus_r
#define p_interact mccchannel_6_analyzer_2_array_crystal_array_7_p_interact
#define mask_string mccchannel_6_analyzer_2_array_crystal_array_7_mask_string
#define mask_setting mccchannel_6_analyzer_2_array_crystal_array_7_mask_setting
#define number_of_activations mccchannel_6_analyzer_2_array_crystal_array_7_number_of_activations
#line 224 "Union_box.comp"
{
// Initializes the focusing system for this volume including input sanitation.
focus_initialize(&this_box_volume.geometry, POS_A_COMP_INDEX(INDEX_CURRENT_COMP+target_index), POS_A_CURRENT_COMP, ROT_A_CURRENT_COMP, target_index, target_x, target_y, target_z, focus_aw, focus_ah, focus_xw, focus_xh, focus_r, NAME_CURRENT_COMP);

// Input sanitation for this geometry
if (xwidth <= 0) {
  printf("\nERROR in Union_box named %s, the xwidth is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (yheight <= 0) {
  printf("\nERROR in Union_box named %s, yheight is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (zdepth <= 0) {
  printf("\nERROR in Union_box named %s, zdepth is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (xwidth2 <= 0 && xwidth2 != -1) {
  printf("\nERROR in Union_box named %s, the xwidth2 is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (yheight2 <= 0 && yheight2 != -1) {
  printf("\nERROR in Union_box named %s, yheight2 is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}

// Use sanitation
if (global_material_list.num_elements == 0) {
  printf("\nERROR: Need to define a material using Union_make_material before using a Union geometry component. \n");
  printf("       %s was defined before first use of Union_make_material.\n",NAME_CURRENT_COMP);
  exit(1);
}

this_box_volume.geometry.is_masked_volume = 0;
this_box_volume.geometry.is_exit_volume = 0;
this_box_volume.geometry.is_mask_volume = 0;
// check if the volume is a mask, if it is the material string is irelevant.
if (mask_string && strlen(mask_string) && strcmp(mask_string, "NULL") && strcmp(mask_string, "0")) {
    // A mask volume is used to limit the extend of other volumes, called the masked volumes. These are specified in the mask_string.
    // In order for a ray to enter a masked volume, it needs to be both in the region covered by that volume AND the mask volume.
    // When more than
    this_box_volume.geometry.mask_mode = 1; // Default is mask mode is ALL
    if (mask_setting && strlen(mask_setting) && strcmp(mask_setting, "NULL") && strcmp(mask_setting, "0")) {
        if (strcmp(mask_setting,"ALL") == 0 || strcmp(mask_setting,"All") == 0) this_box_volume.geometry.mask_mode = 1;
        else if (strcmp(mask_setting,"ANY") == 0 || strcmp(mask_setting,"Any") == 0) this_box_volume.geometry.mask_mode = 2;
        else {
            printf("The mask_mode of component %s is set to %s, but must be either ALL or ANY.\n",NAME_CURRENT_COMP,mask_setting);
            exit(1);
        }
    }
    
    for (loop_index=0;loop_index<global_geometry_list.num_elements;loop_index++) {
        // Add mask list
        if (1 == manual_linking_function(global_geometry_list.elements[loop_index].name,mask_string)) {
            add_element_to_int_list(&this_box_volume.geometry.mask_list,global_geometry_list.elements[loop_index].component_index);
            add_element_to_int_list(&global_geometry_list.elements[loop_index].Volume->geometry.masked_by_list,INDEX_CURRENT_COMP);
            global_geometry_list.elements[loop_index].Volume->geometry.is_masked_volume = 1;
            if (this_box_volume.geometry.mask_mode == 2)
                global_geometry_list.elements[loop_index].Volume->geometry.mask_mode = 2;
            if (this_box_volume.geometry.mask_mode == 1) {
                if (global_geometry_list.elements[loop_index].Volume->geometry.is_masked_volume == 1 && global_geometry_list.elements[loop_index].Volume->geometry.mask_mode != 2)
                    // If more than one mask is added to one volume, the ANY mode overwrites the (default) ALL mode.
                    global_geometry_list.elements[loop_index].Volume->geometry.mask_mode = 1;
            }
            
            found_geometries = 1;
        }
    }
    if (found_geometries == 0) {
        printf("The mask_string in geometry: %s did not find any of the specified volumes in the mask_string %s \n",NAME_CURRENT_COMP,mask_string);
        exit(1);
    }
    this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
    this_box_volume.p_physics->is_vacuum = 0; // Makes this volume a vacuum
    this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
    this_box_volume.p_physics->my_a = 0; // Should not be used.
    sprintf(this_box_volume.p_physics->name,"Mask");
    this_box_volume.geometry.is_mask_volume = 1;
    
    
// Read the material input, or if it lacks, use automatic linking.
} else if (material_string && strlen(material_string) && strcmp(material_string, "NULL") && strcmp(material_string, "0")) {
    // A geometry string was given, use it to determine which material
    if (0 == strcmp(material_string,"vacuum") || 0 == strcmp(material_string,"Vacuum")) {
        // One could have a global physics struct for vacuum instead of creating one for each
        this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
        this_box_volume.p_physics->is_vacuum = 1; // Makes this volume a vacuum
        this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
        this_box_volume.p_physics->my_a = 0; // Should not be used.
        sprintf(this_box_volume.p_physics->name,"Vacuum");
    } else if (0 == strcmp(material_string,"exit") || 0 == strcmp(material_string,"Exit")) {
        // One could have a global physics struct for vacuum instead of creating one for each
        this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
        this_box_volume.p_physics->is_vacuum = 1; // Makes this volume a vacuum
        this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
        this_box_volume.p_physics->my_a = 0; // Should not be used.
        this_box_volume.geometry.is_exit_volume = 1;
        sprintf(this_box_volume.p_physics->name,"Exit");
    } else {
        #ifndef MATERIAL_DETECTOR
            printf("Need to define a material before refering to it in a geometry %s.\n",NAME_CURRENT_COMP);
            exit(1);
        #endif
        for (loop_index=0;loop_index<global_material_list.num_elements;loop_index++) {
            if (0 == strcmp(material_string,global_material_list.elements[loop_index].name)) {
                this_box_volume.p_physics = global_material_list.elements[loop_index].physics;
                break;
            }
            if (loop_index == global_material_list.num_elements-1) {
            printf("\n");
            printf("ERROR: The material string \"%s\" in Union geometry \"%s\" did not match a specified material. \n",material_string,NAME_CURRENT_COMP);
            printf("       The materials available at this point (need to be defined before the geometry): \n");
            for (loop_index=0;loop_index<global_material_list.num_elements;loop_index++)
              printf("         %s\n",global_material_list.elements[loop_index].name);
            printf("\n");
            printf("       It is also possible to use one of the defualt materials avaiable: \n");
            printf("           Vacuum (for a Volume without scattering or absorption)\n");
            printf("           Exit (for a Volume where the ray exits the component if it enters)\n");
            printf("           Mask (for a Volume that masks existing volumes specified in the mask_string\n");
            exit(1);
          }
        }
    }
} else {
    // Automatic linking, simply using the last defined material.
    #ifndef MATERIAL_DETECTOR
        printf("Need to define a material before the geometry to use automatic linking %s.\n",NAME_CURRENT_COMP);
        exit(1);
    #endif
    this_box_volume.p_physics = global_material_list.elements[global_material_list.num_elements-1].physics;
}

sprintf(this_box_volume.name,NAME_CURRENT_COMP);
sprintf(this_box_volume.geometry.shape,"box");
this_box_volume.geometry.priority_value = priority;
this_box_volume.geometry.geometry_p_interact = p_interact;
// Currently the coordinates will be in absolute space.
this_box_volume.geometry.center = POS_A_CURRENT_COMP;

this_box_storage.z_depth = zdepth;
this_box_storage.x_width1 = xwidth;
this_box_storage.y_height1 = yheight;

this_box_storage.is_rectangle = 0;
if (xwidth2 < 0 && yheight2 < 0) this_box_storage.is_rectangle = 1;
if (xwidth == xwidth2 && yheight == yheight2) this_box_storage.is_rectangle = 1;

if (xwidth2 < 0) {
    this_box_storage.x_width2 = xwidth;
    xwidth2 = xwidth;
} else this_box_storage.x_width2 = xwidth2;

if (yheight2 < 0) {
    this_box_storage.y_height2 = yheight;
    yheight2 = yheight;
} else this_box_storage.y_height2 = yheight2;


this_box_storage.normal_vectors[0] = coords_set(0,0,1);
this_box_storage.normal_vectors[1] = coords_set(0,0,1);

// for sides with y component = 0
x_component = 2*zdepth/sqrt((xwidth-xwidth2)*(xwidth-xwidth2)+4*zdepth*zdepth);
z_component = (xwidth-xwidth2)/sqrt(4*zdepth*zdepth+(xwidth-xwidth2)*(xwidth-xwidth2));

this_box_storage.normal_vectors[2] = coords_set(x_component,0,z_component);
this_box_storage.normal_vectors[3] = coords_set(-x_component,0,z_component);

// for sides with x component = 0
y_component = 2*zdepth/sqrt((yheight-yheight2)*(yheight-yheight2)+4*zdepth*zdepth);
z_component = (yheight-yheight2)/sqrt(4*zdepth*zdepth+(yheight-yheight2)*(yheight-yheight2));

this_box_storage.normal_vectors[4] = coords_set(0,y_component,z_component);
this_box_storage.normal_vectors[5] = coords_set(0,-y_component,z_component);

this_box_volume.geometry.visualization_on = visualize;

this_box_volume.geometry.geometry_parameters.p_box_storage = &this_box_storage;

// Assign pointers to functions for intersection with the shape, checking if a point is inside the shape
if (this_box_storage.is_rectangle == 1) {
this_box_volume.geometry.intersect_function = &sample_box_intersect_simple;
this_box_volume.geometry.within_function = &r_within_box_simple;
}
else {
this_box_volume.geometry.intersect_function = &sample_box_intersect_advanced;
this_box_volume.geometry.within_function = &r_within_box_advanced;
}

this_box_volume.geometry.shell_points = &box_shell_points;
this_box_volume.geometry.mcdisplay_function = &mcdisplay_box_function;
this_box_volume.geometry.initialize_from_main_function = &initialize_box_geometry_from_main_component;
this_box_volume.geometry.process_rot_allocated = 0;

this_box_volume.geometry.copy_geometry_parameters = &allocate_box_storage_copy;

rot_copy(this_box_volume.geometry.rotation_matrix,ROT_A_CURRENT_COMP); //check how ROT_R_CURRENT_COMP would work
rot_transpose(ROT_A_CURRENT_COMP,this_box_volume.geometry.transpose_rotation_matrix);

// Initialize loggers
this_box_volume.loggers.num_elements = 0;

// packing the information into the global_geometry_element, which is then included in the global_geometry_list.
sprintf(global_geometry_element.name,NAME_CURRENT_COMP);
global_geometry_element.activation_counter = number_of_activations;
global_geometry_element.component_index = INDEX_CURRENT_COMP;
global_geometry_element.Volume = &this_box_volume; // Would be nicer if this m was a pointer, now we have the (small) data two places
add_element_to_geometry_list(&global_geometry_list,global_geometry_element);
}
#line 222965 "MACS_sample_kidney_box.c"
#undef number_of_activations
#undef mask_setting
#undef mask_string
#undef p_interact
#undef focus_r
#undef focus_xh
#undef focus_xw
#undef focus_ah
#undef focus_aw
#undef target_z
#undef target_y
#undef target_x
#undef target_index
#undef visualize
#undef yheight2
#undef xwidth2
#undef zdepth
#undef yheight
#undef xwidth
#undef priority
#undef material_string
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

  /* Initializations for component channel_6_analyzer_2_array_crystal_array_8. */
  SIG_MESSAGE("channel_6_analyzer_2_array_crystal_array_8 (Init)");
#define mccompcurname  channel_6_analyzer_2_array_crystal_array_8
#define mccompcurtype  Union_box
#define mccompcurindex 377
#define loop_index mccchannel_6_analyzer_2_array_crystal_array_8_loop_index
#define this_box_volume mccchannel_6_analyzer_2_array_crystal_array_8_this_box_volume
#define global_geometry_element mccchannel_6_analyzer_2_array_crystal_array_8_global_geometry_element
#define this_box_storage mccchannel_6_analyzer_2_array_crystal_array_8_this_box_storage
#define material_string mccchannel_6_analyzer_2_array_crystal_array_8_material_string
#define priority mccchannel_6_analyzer_2_array_crystal_array_8_priority
#define xwidth mccchannel_6_analyzer_2_array_crystal_array_8_xwidth
#define yheight mccchannel_6_analyzer_2_array_crystal_array_8_yheight
#define zdepth mccchannel_6_analyzer_2_array_crystal_array_8_zdepth
#define xwidth2 mccchannel_6_analyzer_2_array_crystal_array_8_xwidth2
#define yheight2 mccchannel_6_analyzer_2_array_crystal_array_8_yheight2
#define visualize mccchannel_6_analyzer_2_array_crystal_array_8_visualize
#define target_index mccchannel_6_analyzer_2_array_crystal_array_8_target_index
#define target_x mccchannel_6_analyzer_2_array_crystal_array_8_target_x
#define target_y mccchannel_6_analyzer_2_array_crystal_array_8_target_y
#define target_z mccchannel_6_analyzer_2_array_crystal_array_8_target_z
#define focus_aw mccchannel_6_analyzer_2_array_crystal_array_8_focus_aw
#define focus_ah mccchannel_6_analyzer_2_array_crystal_array_8_focus_ah
#define focus_xw mccchannel_6_analyzer_2_array_crystal_array_8_focus_xw
#define focus_xh mccchannel_6_analyzer_2_array_crystal_array_8_focus_xh
#define focus_r mccchannel_6_analyzer_2_array_crystal_array_8_focus_r
#define p_interact mccchannel_6_analyzer_2_array_crystal_array_8_p_interact
#define mask_string mccchannel_6_analyzer_2_array_crystal_array_8_mask_string
#define mask_setting mccchannel_6_analyzer_2_array_crystal_array_8_mask_setting
#define number_of_activations mccchannel_6_analyzer_2_array_crystal_array_8_number_of_activations
#line 224 "Union_box.comp"
{
// Initializes the focusing system for this volume including input sanitation.
focus_initialize(&this_box_volume.geometry, POS_A_COMP_INDEX(INDEX_CURRENT_COMP+target_index), POS_A_CURRENT_COMP, ROT_A_CURRENT_COMP, target_index, target_x, target_y, target_z, focus_aw, focus_ah, focus_xw, focus_xh, focus_r, NAME_CURRENT_COMP);

// Input sanitation for this geometry
if (xwidth <= 0) {
  printf("\nERROR in Union_box named %s, the xwidth is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (yheight <= 0) {
  printf("\nERROR in Union_box named %s, yheight is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (zdepth <= 0) {
  printf("\nERROR in Union_box named %s, zdepth is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (xwidth2 <= 0 && xwidth2 != -1) {
  printf("\nERROR in Union_box named %s, the xwidth2 is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (yheight2 <= 0 && yheight2 != -1) {
  printf("\nERROR in Union_box named %s, yheight2 is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}

// Use sanitation
if (global_material_list.num_elements == 0) {
  printf("\nERROR: Need to define a material using Union_make_material before using a Union geometry component. \n");
  printf("       %s was defined before first use of Union_make_material.\n",NAME_CURRENT_COMP);
  exit(1);
}

this_box_volume.geometry.is_masked_volume = 0;
this_box_volume.geometry.is_exit_volume = 0;
this_box_volume.geometry.is_mask_volume = 0;
// check if the volume is a mask, if it is the material string is irelevant.
if (mask_string && strlen(mask_string) && strcmp(mask_string, "NULL") && strcmp(mask_string, "0")) {
    // A mask volume is used to limit the extend of other volumes, called the masked volumes. These are specified in the mask_string.
    // In order for a ray to enter a masked volume, it needs to be both in the region covered by that volume AND the mask volume.
    // When more than
    this_box_volume.geometry.mask_mode = 1; // Default is mask mode is ALL
    if (mask_setting && strlen(mask_setting) && strcmp(mask_setting, "NULL") && strcmp(mask_setting, "0")) {
        if (strcmp(mask_setting,"ALL") == 0 || strcmp(mask_setting,"All") == 0) this_box_volume.geometry.mask_mode = 1;
        else if (strcmp(mask_setting,"ANY") == 0 || strcmp(mask_setting,"Any") == 0) this_box_volume.geometry.mask_mode = 2;
        else {
            printf("The mask_mode of component %s is set to %s, but must be either ALL or ANY.\n",NAME_CURRENT_COMP,mask_setting);
            exit(1);
        }
    }
    
    for (loop_index=0;loop_index<global_geometry_list.num_elements;loop_index++) {
        // Add mask list
        if (1 == manual_linking_function(global_geometry_list.elements[loop_index].name,mask_string)) {
            add_element_to_int_list(&this_box_volume.geometry.mask_list,global_geometry_list.elements[loop_index].component_index);
            add_element_to_int_list(&global_geometry_list.elements[loop_index].Volume->geometry.masked_by_list,INDEX_CURRENT_COMP);
            global_geometry_list.elements[loop_index].Volume->geometry.is_masked_volume = 1;
            if (this_box_volume.geometry.mask_mode == 2)
                global_geometry_list.elements[loop_index].Volume->geometry.mask_mode = 2;
            if (this_box_volume.geometry.mask_mode == 1) {
                if (global_geometry_list.elements[loop_index].Volume->geometry.is_masked_volume == 1 && global_geometry_list.elements[loop_index].Volume->geometry.mask_mode != 2)
                    // If more than one mask is added to one volume, the ANY mode overwrites the (default) ALL mode.
                    global_geometry_list.elements[loop_index].Volume->geometry.mask_mode = 1;
            }
            
            found_geometries = 1;
        }
    }
    if (found_geometries == 0) {
        printf("The mask_string in geometry: %s did not find any of the specified volumes in the mask_string %s \n",NAME_CURRENT_COMP,mask_string);
        exit(1);
    }
    this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
    this_box_volume.p_physics->is_vacuum = 0; // Makes this volume a vacuum
    this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
    this_box_volume.p_physics->my_a = 0; // Should not be used.
    sprintf(this_box_volume.p_physics->name,"Mask");
    this_box_volume.geometry.is_mask_volume = 1;
    
    
// Read the material input, or if it lacks, use automatic linking.
} else if (material_string && strlen(material_string) && strcmp(material_string, "NULL") && strcmp(material_string, "0")) {
    // A geometry string was given, use it to determine which material
    if (0 == strcmp(material_string,"vacuum") || 0 == strcmp(material_string,"Vacuum")) {
        // One could have a global physics struct for vacuum instead of creating one for each
        this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
        this_box_volume.p_physics->is_vacuum = 1; // Makes this volume a vacuum
        this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
        this_box_volume.p_physics->my_a = 0; // Should not be used.
        sprintf(this_box_volume.p_physics->name,"Vacuum");
    } else if (0 == strcmp(material_string,"exit") || 0 == strcmp(material_string,"Exit")) {
        // One could have a global physics struct for vacuum instead of creating one for each
        this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
        this_box_volume.p_physics->is_vacuum = 1; // Makes this volume a vacuum
        this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
        this_box_volume.p_physics->my_a = 0; // Should not be used.
        this_box_volume.geometry.is_exit_volume = 1;
        sprintf(this_box_volume.p_physics->name,"Exit");
    } else {
        #ifndef MATERIAL_DETECTOR
            printf("Need to define a material before refering to it in a geometry %s.\n",NAME_CURRENT_COMP);
            exit(1);
        #endif
        for (loop_index=0;loop_index<global_material_list.num_elements;loop_index++) {
            if (0 == strcmp(material_string,global_material_list.elements[loop_index].name)) {
                this_box_volume.p_physics = global_material_list.elements[loop_index].physics;
                break;
            }
            if (loop_index == global_material_list.num_elements-1) {
            printf("\n");
            printf("ERROR: The material string \"%s\" in Union geometry \"%s\" did not match a specified material. \n",material_string,NAME_CURRENT_COMP);
            printf("       The materials available at this point (need to be defined before the geometry): \n");
            for (loop_index=0;loop_index<global_material_list.num_elements;loop_index++)
              printf("         %s\n",global_material_list.elements[loop_index].name);
            printf("\n");
            printf("       It is also possible to use one of the defualt materials avaiable: \n");
            printf("           Vacuum (for a Volume without scattering or absorption)\n");
            printf("           Exit (for a Volume where the ray exits the component if it enters)\n");
            printf("           Mask (for a Volume that masks existing volumes specified in the mask_string\n");
            exit(1);
          }
        }
    }
} else {
    // Automatic linking, simply using the last defined material.
    #ifndef MATERIAL_DETECTOR
        printf("Need to define a material before the geometry to use automatic linking %s.\n",NAME_CURRENT_COMP);
        exit(1);
    #endif
    this_box_volume.p_physics = global_material_list.elements[global_material_list.num_elements-1].physics;
}

sprintf(this_box_volume.name,NAME_CURRENT_COMP);
sprintf(this_box_volume.geometry.shape,"box");
this_box_volume.geometry.priority_value = priority;
this_box_volume.geometry.geometry_p_interact = p_interact;
// Currently the coordinates will be in absolute space.
this_box_volume.geometry.center = POS_A_CURRENT_COMP;

this_box_storage.z_depth = zdepth;
this_box_storage.x_width1 = xwidth;
this_box_storage.y_height1 = yheight;

this_box_storage.is_rectangle = 0;
if (xwidth2 < 0 && yheight2 < 0) this_box_storage.is_rectangle = 1;
if (xwidth == xwidth2 && yheight == yheight2) this_box_storage.is_rectangle = 1;

if (xwidth2 < 0) {
    this_box_storage.x_width2 = xwidth;
    xwidth2 = xwidth;
} else this_box_storage.x_width2 = xwidth2;

if (yheight2 < 0) {
    this_box_storage.y_height2 = yheight;
    yheight2 = yheight;
} else this_box_storage.y_height2 = yheight2;


this_box_storage.normal_vectors[0] = coords_set(0,0,1);
this_box_storage.normal_vectors[1] = coords_set(0,0,1);

// for sides with y component = 0
x_component = 2*zdepth/sqrt((xwidth-xwidth2)*(xwidth-xwidth2)+4*zdepth*zdepth);
z_component = (xwidth-xwidth2)/sqrt(4*zdepth*zdepth+(xwidth-xwidth2)*(xwidth-xwidth2));

this_box_storage.normal_vectors[2] = coords_set(x_component,0,z_component);
this_box_storage.normal_vectors[3] = coords_set(-x_component,0,z_component);

// for sides with x component = 0
y_component = 2*zdepth/sqrt((yheight-yheight2)*(yheight-yheight2)+4*zdepth*zdepth);
z_component = (yheight-yheight2)/sqrt(4*zdepth*zdepth+(yheight-yheight2)*(yheight-yheight2));

this_box_storage.normal_vectors[4] = coords_set(0,y_component,z_component);
this_box_storage.normal_vectors[5] = coords_set(0,-y_component,z_component);

this_box_volume.geometry.visualization_on = visualize;

this_box_volume.geometry.geometry_parameters.p_box_storage = &this_box_storage;

// Assign pointers to functions for intersection with the shape, checking if a point is inside the shape
if (this_box_storage.is_rectangle == 1) {
this_box_volume.geometry.intersect_function = &sample_box_intersect_simple;
this_box_volume.geometry.within_function = &r_within_box_simple;
}
else {
this_box_volume.geometry.intersect_function = &sample_box_intersect_advanced;
this_box_volume.geometry.within_function = &r_within_box_advanced;
}

this_box_volume.geometry.shell_points = &box_shell_points;
this_box_volume.geometry.mcdisplay_function = &mcdisplay_box_function;
this_box_volume.geometry.initialize_from_main_function = &initialize_box_geometry_from_main_component;
this_box_volume.geometry.process_rot_allocated = 0;

this_box_volume.geometry.copy_geometry_parameters = &allocate_box_storage_copy;

rot_copy(this_box_volume.geometry.rotation_matrix,ROT_A_CURRENT_COMP); //check how ROT_R_CURRENT_COMP would work
rot_transpose(ROT_A_CURRENT_COMP,this_box_volume.geometry.transpose_rotation_matrix);

// Initialize loggers
this_box_volume.loggers.num_elements = 0;

// packing the information into the global_geometry_element, which is then included in the global_geometry_list.
sprintf(global_geometry_element.name,NAME_CURRENT_COMP);
global_geometry_element.activation_counter = number_of_activations;
global_geometry_element.component_index = INDEX_CURRENT_COMP;
global_geometry_element.Volume = &this_box_volume; // Would be nicer if this m was a pointer, now we have the (small) data two places
add_element_to_geometry_list(&global_geometry_list,global_geometry_element);
}
#line 223235 "MACS_sample_kidney_box.c"
#undef number_of_activations
#undef mask_setting
#undef mask_string
#undef p_interact
#undef focus_r
#undef focus_xh
#undef focus_xw
#undef focus_ah
#undef focus_aw
#undef target_z
#undef target_y
#undef target_x
#undef target_index
#undef visualize
#undef yheight2
#undef xwidth2
#undef zdepth
#undef yheight
#undef xwidth
#undef priority
#undef material_string
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

  /* Initializations for component channel_6_cave2_cyl1. */
  SIG_MESSAGE("channel_6_cave2_cyl1 (Init)");
#define mccompcurname  channel_6_cave2_cyl1
#define mccompcurtype  Union_cylinder
#define mccompcurindex 378
#define loop_index mccchannel_6_cave2_cyl1_loop_index
#define this_cylinder_volume mccchannel_6_cave2_cyl1_this_cylinder_volume
#define global_geometry_element mccchannel_6_cave2_cyl1_global_geometry_element
#define this_cylinder_storage mccchannel_6_cave2_cyl1_this_cylinder_storage
#define material_string mccchannel_6_cave2_cyl1_material_string
#define priority mccchannel_6_cave2_cyl1_priority
#define radius mccchannel_6_cave2_cyl1_radius
#define yheight mccchannel_6_cave2_cyl1_yheight
#define visualize mccchannel_6_cave2_cyl1_visualize
#define target_index mccchannel_6_cave2_cyl1_target_index
#define target_x mccchannel_6_cave2_cyl1_target_x
#define target_y mccchannel_6_cave2_cyl1_target_y
#define target_z mccchannel_6_cave2_cyl1_target_z
#define focus_aw mccchannel_6_cave2_cyl1_focus_aw
#define focus_ah mccchannel_6_cave2_cyl1_focus_ah
#define focus_xw mccchannel_6_cave2_cyl1_focus_xw
#define focus_xh mccchannel_6_cave2_cyl1_focus_xh
#define focus_r mccchannel_6_cave2_cyl1_focus_r
#define p_interact mccchannel_6_cave2_cyl1_p_interact
#define mask_string mccchannel_6_cave2_cyl1_mask_string
#define mask_setting mccchannel_6_cave2_cyl1_mask_setting
#define number_of_activations mccchannel_6_cave2_cyl1_number_of_activations
#line 185 "Union_cylinder.comp"
{
// Initializes the focusing system for this volume including input sanitation.
focus_initialize(&this_cylinder_volume.geometry, POS_A_COMP_INDEX(INDEX_CURRENT_COMP+target_index), POS_A_CURRENT_COMP, ROT_A_CURRENT_COMP, target_index, target_x, target_y, target_z, focus_aw, focus_ah, focus_xw, focus_xh, focus_r, NAME_CURRENT_COMP);

// Input sanitation for this geometry
if (radius <= 0) {
  printf("\nERROR in Union_cylinder named %s, the radius is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}

if (yheight <= 0) {
  printf("\nERROR in Union_cylinder named %s, yheight is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}

// Use sanitation
#ifdef MATERIAL_DETECTOR
if (global_material_list.num_elements == 0) {
  // Here if the user have defined a material, but only after this material
  printf("\nERROR: Need to define a material using Union_make_material before using a Union geometry component. \n");
  printf("       %s was defined before first use of Union_make_material.\n",NAME_CURRENT_COMP);
  exit(1);
}
#endif
#ifndef MATERIAL_DETECTOR
  printf("\nERROR: Need to define a material using Union_make_material before using a Union geometry component. \n");
  exit(1);
#endif


this_cylinder_volume.geometry.is_masked_volume = 0;
this_cylinder_volume.geometry.is_exit_volume = 0;
this_cylinder_volume.geometry.is_mask_volume = 0;

// Read the material input, or if it lacks, use automatic linking.
if (mask_string && strlen(mask_string) && strcmp(mask_string, "NULL") && strcmp(mask_string, "0")) {
    // A mask volume is used to limit the extend of other volumes, called the masked volumes. These are specified in the mask_string.
    // In order for a ray to enter a masked volume, it needs to be both in the region covered by that volume AND the mask volume.
    // When more than
    this_cylinder_volume.geometry.mask_mode = 1; // Default is mask mode is ALL
    if (mask_setting && strlen(mask_setting) && strcmp(mask_setting, "NULL") && strcmp(mask_setting, "0")) {
        if (strcmp(mask_setting,"ALL") == 0 || strcmp(mask_setting,"All") == 0) this_cylinder_volume.geometry.mask_mode = 1;
        else if (strcmp(mask_setting,"ANY") == 0 || strcmp(mask_setting,"Any") == 0) this_cylinder_volume.geometry.mask_mode = 2;
        else {
            printf("The mask_mode of component %s is set to %s, but must be either ALL or ANY.\n",NAME_CURRENT_COMP,mask_setting);
            exit(1);
        }
    }
    
    for (loop_index=0;loop_index<global_geometry_list.num_elements;loop_index++) {
        // Add mask list
        if (1 == manual_linking_function(global_geometry_list.elements[loop_index].name,mask_string)) {
            add_element_to_int_list(&this_cylinder_volume.geometry.mask_list,global_geometry_list.elements[loop_index].component_index);
            add_element_to_int_list(&global_geometry_list.elements[loop_index].Volume->geometry.masked_by_list,INDEX_CURRENT_COMP);
            global_geometry_list.elements[loop_index].Volume->geometry.is_masked_volume = 1;
            if (this_cylinder_volume.geometry.mask_mode == 2)
                global_geometry_list.elements[loop_index].Volume->geometry.mask_mode = 2;
            if (this_cylinder_volume.geometry.mask_mode == 1) {
                if (global_geometry_list.elements[loop_index].Volume->geometry.is_masked_volume == 1 && global_geometry_list.elements[loop_index].Volume->geometry.mask_mode != 2)
                    // If more than one mask is added to one volume, the ANY mode overwrites the (default) ALL mode.
                    global_geometry_list.elements[loop_index].Volume->geometry.mask_mode = 1;
            }
            
            found_geometries = 1;
        }
    }
    if (found_geometries == 0) {
        printf("The mask_string in geometry: %s did not find any of the specified volumes in the mask_string %s \n",NAME_CURRENT_COMP,mask_string);
        exit(1);
    }
    this_cylinder_volume.p_physics = malloc(sizeof(struct physics_struct));
    this_cylinder_volume.p_physics->is_vacuum = 0; // Makes this volume a vacuum
    this_cylinder_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
    this_cylinder_volume.p_physics->my_a = 0; // Should not be used.
    sprintf(this_cylinder_volume.p_physics->name,"Mask");
    this_cylinder_volume.geometry.is_mask_volume = 1;
    
    
// Read the material input, or if it lacks, use automatic linking.
} else if (material_string && strlen(material_string) && strcmp(material_string, "NULL") && strcmp(material_string, "0")) {
    // A geometry string was given, use it to determine which material
    if (0 == strcmp(material_string,"vacuum") || 0 == strcmp(material_string,"Vacuum")) {
        // One could have a global physics struct for vacuum instead of creating one for each
        this_cylinder_volume.p_physics = malloc(sizeof(struct physics_struct));
        this_cylinder_volume.p_physics->is_vacuum = 1; // Makes this volume a vacuum
        this_cylinder_volume.p_physics->number_of_processes = (int) 0;
        this_cylinder_volume.p_physics->my_a = 0; // Should not be used.
        sprintf(this_cylinder_volume.p_physics->name,"Vacuum");
    } else if (0 == strcmp(material_string,"exit") || 0 == strcmp(material_string,"Exit")) {
        // One could have a global physics struct for exit instead of creating one for each
        this_cylinder_volume.p_physics = malloc(sizeof(struct physics_struct));
        this_cylinder_volume.p_physics->is_vacuum = 1; // Makes this volume a vacuum
        this_cylinder_volume.p_physics->number_of_processes = (int) 0;
        this_cylinder_volume.p_physics->my_a = 0; // Should not be used.
        this_cylinder_volume.geometry.is_exit_volume = 1;
        sprintf(this_cylinder_volume.p_physics->name,"Exit");
    } else {
        for (loop_index=0;loop_index<global_material_list.num_elements;loop_index++) {
          if (0 == strcmp(material_string,global_material_list.elements[loop_index].name)) {
            this_cylinder_volume.p_physics = global_material_list.elements[loop_index].physics;
            break;
          }
          if (loop_index == global_material_list.num_elements-1) {
            printf("\n");
            printf("ERROR: The material string \"%s\" in Union geometry \"%s\" did not match a specified material. \n",material_string,NAME_CURRENT_COMP);
            printf("       The materials available at this point (need to be defined before the geometry): \n");
            for (loop_index=0;loop_index<global_material_list.num_elements;loop_index++)
              printf("         %s\n",global_material_list.elements[loop_index].name);
            printf("\n");
            printf("       It is also possible to use one of the defualt materials avaiable: \n");
            printf("           Vacuum (for a Volume without scattering or absorption)\n");
            printf("           Exit (for a Volume where the ray exits the component if it enters)\n");
            printf("           Mask (for a Volume that masks existing volumes specified in the mask_string\n");
            exit(1);
          }
        }
    }
} else {
    // Automatic linking, simply using the last defined material.
    #ifndef MATERIAL_DETECTOR
        printf("Need to define a material before the geometry to use automatic linking %s.\n",NAME_CURRENT_COMP);
        exit(1);
    #endif
    this_cylinder_volume.p_physics = global_material_list.elements[global_material_list.num_elements-1].physics;
}

sprintf(this_cylinder_volume.name,NAME_CURRENT_COMP);
sprintf(this_cylinder_volume.geometry.shape,"cylinder");
this_cylinder_volume.geometry.priority_value = priority;
// Currently the coordinates will be in absolute space.
this_cylinder_volume.geometry.center = POS_A_CURRENT_COMP;

this_cylinder_volume.geometry.geometry_p_interact = p_interact;
this_cylinder_storage.cyl_radius = radius;
this_cylinder_storage.height = yheight;
this_cylinder_volume.geometry.visualization_on = visualize;
this_cylinder_volume.geometry.geometry_parameters.p_cylinder_storage = &this_cylinder_storage;
this_cylinder_volume.geometry.within_function = &r_within_cylinder;
this_cylinder_volume.geometry.intersect_function = &sample_cylinder_intersect;
this_cylinder_volume.geometry.mcdisplay_function = &mcdisplay_cylinder_function;
this_cylinder_volume.geometry.shell_points = &cylinder_shell_points;
this_cylinder_volume.geometry.initialize_from_main_function = &initialize_cylinder_geometry_from_main_component;
this_cylinder_volume.geometry.process_rot_allocated = 0;
this_cylinder_volume.geometry.copy_geometry_parameters = &allocate_cylinder_storage_copy;

rot_copy(this_cylinder_volume.geometry.rotation_matrix,ROT_A_CURRENT_COMP);
rot_transpose(ROT_A_CURRENT_COMP,this_cylinder_volume.geometry.transpose_rotation_matrix);

// Initialize loggers
this_cylinder_volume.loggers.num_elements = 0;

// packing the information into the global_geometry_element, which is then included in the global_geometry_list.
sprintf(global_geometry_element.name,NAME_CURRENT_COMP);
global_geometry_element.activation_counter = number_of_activations;
global_geometry_element.component_index = INDEX_CURRENT_COMP;
global_geometry_element.Volume = &this_cylinder_volume; // Would be nicer if this m was a pointer, now we have the (small) data two places
add_element_to_geometry_list(&global_geometry_list,global_geometry_element);
}
#line 223451 "MACS_sample_kidney_box.c"
#undef number_of_activations
#undef mask_setting
#undef mask_string
#undef p_interact
#undef focus_r
#undef focus_xh
#undef focus_xw
#undef focus_ah
#undef focus_aw
#undef target_z
#undef target_y
#undef target_x
#undef target_index
#undef visualize
#undef yheight
#undef radius
#undef priority
#undef material_string
#undef this_cylinder_storage
#undef global_geometry_element
#undef this_cylinder_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

  /* Initializations for component channel_6_cave2_box1. */
  SIG_MESSAGE("channel_6_cave2_box1 (Init)");
#define mccompcurname  channel_6_cave2_box1
#define mccompcurtype  Union_box
#define mccompcurindex 379
#define loop_index mccchannel_6_cave2_box1_loop_index
#define this_box_volume mccchannel_6_cave2_box1_this_box_volume
#define global_geometry_element mccchannel_6_cave2_box1_global_geometry_element
#define this_box_storage mccchannel_6_cave2_box1_this_box_storage
#define material_string mccchannel_6_cave2_box1_material_string
#define priority mccchannel_6_cave2_box1_priority
#define xwidth mccchannel_6_cave2_box1_xwidth
#define yheight mccchannel_6_cave2_box1_yheight
#define zdepth mccchannel_6_cave2_box1_zdepth
#define xwidth2 mccchannel_6_cave2_box1_xwidth2
#define yheight2 mccchannel_6_cave2_box1_yheight2
#define visualize mccchannel_6_cave2_box1_visualize
#define target_index mccchannel_6_cave2_box1_target_index
#define target_x mccchannel_6_cave2_box1_target_x
#define target_y mccchannel_6_cave2_box1_target_y
#define target_z mccchannel_6_cave2_box1_target_z
#define focus_aw mccchannel_6_cave2_box1_focus_aw
#define focus_ah mccchannel_6_cave2_box1_focus_ah
#define focus_xw mccchannel_6_cave2_box1_focus_xw
#define focus_xh mccchannel_6_cave2_box1_focus_xh
#define focus_r mccchannel_6_cave2_box1_focus_r
#define p_interact mccchannel_6_cave2_box1_p_interact
#define mask_string mccchannel_6_cave2_box1_mask_string
#define mask_setting mccchannel_6_cave2_box1_mask_setting
#define number_of_activations mccchannel_6_cave2_box1_number_of_activations
#line 224 "Union_box.comp"
{
// Initializes the focusing system for this volume including input sanitation.
focus_initialize(&this_box_volume.geometry, POS_A_COMP_INDEX(INDEX_CURRENT_COMP+target_index), POS_A_CURRENT_COMP, ROT_A_CURRENT_COMP, target_index, target_x, target_y, target_z, focus_aw, focus_ah, focus_xw, focus_xh, focus_r, NAME_CURRENT_COMP);

// Input sanitation for this geometry
if (xwidth <= 0) {
  printf("\nERROR in Union_box named %s, the xwidth is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (yheight <= 0) {
  printf("\nERROR in Union_box named %s, yheight is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (zdepth <= 0) {
  printf("\nERROR in Union_box named %s, zdepth is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (xwidth2 <= 0 && xwidth2 != -1) {
  printf("\nERROR in Union_box named %s, the xwidth2 is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (yheight2 <= 0 && yheight2 != -1) {
  printf("\nERROR in Union_box named %s, yheight2 is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}

// Use sanitation
if (global_material_list.num_elements == 0) {
  printf("\nERROR: Need to define a material using Union_make_material before using a Union geometry component. \n");
  printf("       %s was defined before first use of Union_make_material.\n",NAME_CURRENT_COMP);
  exit(1);
}

this_box_volume.geometry.is_masked_volume = 0;
this_box_volume.geometry.is_exit_volume = 0;
this_box_volume.geometry.is_mask_volume = 0;
// check if the volume is a mask, if it is the material string is irelevant.
if (mask_string && strlen(mask_string) && strcmp(mask_string, "NULL") && strcmp(mask_string, "0")) {
    // A mask volume is used to limit the extend of other volumes, called the masked volumes. These are specified in the mask_string.
    // In order for a ray to enter a masked volume, it needs to be both in the region covered by that volume AND the mask volume.
    // When more than
    this_box_volume.geometry.mask_mode = 1; // Default is mask mode is ALL
    if (mask_setting && strlen(mask_setting) && strcmp(mask_setting, "NULL") && strcmp(mask_setting, "0")) {
        if (strcmp(mask_setting,"ALL") == 0 || strcmp(mask_setting,"All") == 0) this_box_volume.geometry.mask_mode = 1;
        else if (strcmp(mask_setting,"ANY") == 0 || strcmp(mask_setting,"Any") == 0) this_box_volume.geometry.mask_mode = 2;
        else {
            printf("The mask_mode of component %s is set to %s, but must be either ALL or ANY.\n",NAME_CURRENT_COMP,mask_setting);
            exit(1);
        }
    }
    
    for (loop_index=0;loop_index<global_geometry_list.num_elements;loop_index++) {
        // Add mask list
        if (1 == manual_linking_function(global_geometry_list.elements[loop_index].name,mask_string)) {
            add_element_to_int_list(&this_box_volume.geometry.mask_list,global_geometry_list.elements[loop_index].component_index);
            add_element_to_int_list(&global_geometry_list.elements[loop_index].Volume->geometry.masked_by_list,INDEX_CURRENT_COMP);
            global_geometry_list.elements[loop_index].Volume->geometry.is_masked_volume = 1;
            if (this_box_volume.geometry.mask_mode == 2)
                global_geometry_list.elements[loop_index].Volume->geometry.mask_mode = 2;
            if (this_box_volume.geometry.mask_mode == 1) {
                if (global_geometry_list.elements[loop_index].Volume->geometry.is_masked_volume == 1 && global_geometry_list.elements[loop_index].Volume->geometry.mask_mode != 2)
                    // If more than one mask is added to one volume, the ANY mode overwrites the (default) ALL mode.
                    global_geometry_list.elements[loop_index].Volume->geometry.mask_mode = 1;
            }
            
            found_geometries = 1;
        }
    }
    if (found_geometries == 0) {
        printf("The mask_string in geometry: %s did not find any of the specified volumes in the mask_string %s \n",NAME_CURRENT_COMP,mask_string);
        exit(1);
    }
    this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
    this_box_volume.p_physics->is_vacuum = 0; // Makes this volume a vacuum
    this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
    this_box_volume.p_physics->my_a = 0; // Should not be used.
    sprintf(this_box_volume.p_physics->name,"Mask");
    this_box_volume.geometry.is_mask_volume = 1;
    
    
// Read the material input, or if it lacks, use automatic linking.
} else if (material_string && strlen(material_string) && strcmp(material_string, "NULL") && strcmp(material_string, "0")) {
    // A geometry string was given, use it to determine which material
    if (0 == strcmp(material_string,"vacuum") || 0 == strcmp(material_string,"Vacuum")) {
        // One could have a global physics struct for vacuum instead of creating one for each
        this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
        this_box_volume.p_physics->is_vacuum = 1; // Makes this volume a vacuum
        this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
        this_box_volume.p_physics->my_a = 0; // Should not be used.
        sprintf(this_box_volume.p_physics->name,"Vacuum");
    } else if (0 == strcmp(material_string,"exit") || 0 == strcmp(material_string,"Exit")) {
        // One could have a global physics struct for vacuum instead of creating one for each
        this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
        this_box_volume.p_physics->is_vacuum = 1; // Makes this volume a vacuum
        this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
        this_box_volume.p_physics->my_a = 0; // Should not be used.
        this_box_volume.geometry.is_exit_volume = 1;
        sprintf(this_box_volume.p_physics->name,"Exit");
    } else {
        #ifndef MATERIAL_DETECTOR
            printf("Need to define a material before refering to it in a geometry %s.\n",NAME_CURRENT_COMP);
            exit(1);
        #endif
        for (loop_index=0;loop_index<global_material_list.num_elements;loop_index++) {
            if (0 == strcmp(material_string,global_material_list.elements[loop_index].name)) {
                this_box_volume.p_physics = global_material_list.elements[loop_index].physics;
                break;
            }
            if (loop_index == global_material_list.num_elements-1) {
            printf("\n");
            printf("ERROR: The material string \"%s\" in Union geometry \"%s\" did not match a specified material. \n",material_string,NAME_CURRENT_COMP);
            printf("       The materials available at this point (need to be defined before the geometry): \n");
            for (loop_index=0;loop_index<global_material_list.num_elements;loop_index++)
              printf("         %s\n",global_material_list.elements[loop_index].name);
            printf("\n");
            printf("       It is also possible to use one of the defualt materials avaiable: \n");
            printf("           Vacuum (for a Volume without scattering or absorption)\n");
            printf("           Exit (for a Volume where the ray exits the component if it enters)\n");
            printf("           Mask (for a Volume that masks existing volumes specified in the mask_string\n");
            exit(1);
          }
        }
    }
} else {
    // Automatic linking, simply using the last defined material.
    #ifndef MATERIAL_DETECTOR
        printf("Need to define a material before the geometry to use automatic linking %s.\n",NAME_CURRENT_COMP);
        exit(1);
    #endif
    this_box_volume.p_physics = global_material_list.elements[global_material_list.num_elements-1].physics;
}

sprintf(this_box_volume.name,NAME_CURRENT_COMP);
sprintf(this_box_volume.geometry.shape,"box");
this_box_volume.geometry.priority_value = priority;
this_box_volume.geometry.geometry_p_interact = p_interact;
// Currently the coordinates will be in absolute space.
this_box_volume.geometry.center = POS_A_CURRENT_COMP;

this_box_storage.z_depth = zdepth;
this_box_storage.x_width1 = xwidth;
this_box_storage.y_height1 = yheight;

this_box_storage.is_rectangle = 0;
if (xwidth2 < 0 && yheight2 < 0) this_box_storage.is_rectangle = 1;
if (xwidth == xwidth2 && yheight == yheight2) this_box_storage.is_rectangle = 1;

if (xwidth2 < 0) {
    this_box_storage.x_width2 = xwidth;
    xwidth2 = xwidth;
} else this_box_storage.x_width2 = xwidth2;

if (yheight2 < 0) {
    this_box_storage.y_height2 = yheight;
    yheight2 = yheight;
} else this_box_storage.y_height2 = yheight2;


this_box_storage.normal_vectors[0] = coords_set(0,0,1);
this_box_storage.normal_vectors[1] = coords_set(0,0,1);

// for sides with y component = 0
x_component = 2*zdepth/sqrt((xwidth-xwidth2)*(xwidth-xwidth2)+4*zdepth*zdepth);
z_component = (xwidth-xwidth2)/sqrt(4*zdepth*zdepth+(xwidth-xwidth2)*(xwidth-xwidth2));

this_box_storage.normal_vectors[2] = coords_set(x_component,0,z_component);
this_box_storage.normal_vectors[3] = coords_set(-x_component,0,z_component);

// for sides with x component = 0
y_component = 2*zdepth/sqrt((yheight-yheight2)*(yheight-yheight2)+4*zdepth*zdepth);
z_component = (yheight-yheight2)/sqrt(4*zdepth*zdepth+(yheight-yheight2)*(yheight-yheight2));

this_box_storage.normal_vectors[4] = coords_set(0,y_component,z_component);
this_box_storage.normal_vectors[5] = coords_set(0,-y_component,z_component);

this_box_volume.geometry.visualization_on = visualize;

this_box_volume.geometry.geometry_parameters.p_box_storage = &this_box_storage;

// Assign pointers to functions for intersection with the shape, checking if a point is inside the shape
if (this_box_storage.is_rectangle == 1) {
this_box_volume.geometry.intersect_function = &sample_box_intersect_simple;
this_box_volume.geometry.within_function = &r_within_box_simple;
}
else {
this_box_volume.geometry.intersect_function = &sample_box_intersect_advanced;
this_box_volume.geometry.within_function = &r_within_box_advanced;
}

this_box_volume.geometry.shell_points = &box_shell_points;
this_box_volume.geometry.mcdisplay_function = &mcdisplay_box_function;
this_box_volume.geometry.initialize_from_main_function = &initialize_box_geometry_from_main_component;
this_box_volume.geometry.process_rot_allocated = 0;

this_box_volume.geometry.copy_geometry_parameters = &allocate_box_storage_copy;

rot_copy(this_box_volume.geometry.rotation_matrix,ROT_A_CURRENT_COMP); //check how ROT_R_CURRENT_COMP would work
rot_transpose(ROT_A_CURRENT_COMP,this_box_volume.geometry.transpose_rotation_matrix);

// Initialize loggers
this_box_volume.loggers.num_elements = 0;

// packing the information into the global_geometry_element, which is then included in the global_geometry_list.
sprintf(global_geometry_element.name,NAME_CURRENT_COMP);
global_geometry_element.activation_counter = number_of_activations;
global_geometry_element.component_index = INDEX_CURRENT_COMP;
global_geometry_element.Volume = &this_box_volume; // Would be nicer if this m was a pointer, now we have the (small) data two places
add_element_to_geometry_list(&global_geometry_list,global_geometry_element);
}
#line 223718 "MACS_sample_kidney_box.c"
#undef number_of_activations
#undef mask_setting
#undef mask_string
#undef p_interact
#undef focus_r
#undef focus_xh
#undef focus_xw
#undef focus_ah
#undef focus_aw
#undef target_z
#undef target_y
#undef target_x
#undef target_index
#undef visualize
#undef yheight2
#undef xwidth2
#undef zdepth
#undef yheight
#undef xwidth
#undef priority
#undef material_string
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

  /* Initializations for component channel_6_cave2_box2. */
  SIG_MESSAGE("channel_6_cave2_box2 (Init)");
#define mccompcurname  channel_6_cave2_box2
#define mccompcurtype  Union_box
#define mccompcurindex 380
#define loop_index mccchannel_6_cave2_box2_loop_index
#define this_box_volume mccchannel_6_cave2_box2_this_box_volume
#define global_geometry_element mccchannel_6_cave2_box2_global_geometry_element
#define this_box_storage mccchannel_6_cave2_box2_this_box_storage
#define material_string mccchannel_6_cave2_box2_material_string
#define priority mccchannel_6_cave2_box2_priority
#define xwidth mccchannel_6_cave2_box2_xwidth
#define yheight mccchannel_6_cave2_box2_yheight
#define zdepth mccchannel_6_cave2_box2_zdepth
#define xwidth2 mccchannel_6_cave2_box2_xwidth2
#define yheight2 mccchannel_6_cave2_box2_yheight2
#define visualize mccchannel_6_cave2_box2_visualize
#define target_index mccchannel_6_cave2_box2_target_index
#define target_x mccchannel_6_cave2_box2_target_x
#define target_y mccchannel_6_cave2_box2_target_y
#define target_z mccchannel_6_cave2_box2_target_z
#define focus_aw mccchannel_6_cave2_box2_focus_aw
#define focus_ah mccchannel_6_cave2_box2_focus_ah
#define focus_xw mccchannel_6_cave2_box2_focus_xw
#define focus_xh mccchannel_6_cave2_box2_focus_xh
#define focus_r mccchannel_6_cave2_box2_focus_r
#define p_interact mccchannel_6_cave2_box2_p_interact
#define mask_string mccchannel_6_cave2_box2_mask_string
#define mask_setting mccchannel_6_cave2_box2_mask_setting
#define number_of_activations mccchannel_6_cave2_box2_number_of_activations
#line 224 "Union_box.comp"
{
// Initializes the focusing system for this volume including input sanitation.
focus_initialize(&this_box_volume.geometry, POS_A_COMP_INDEX(INDEX_CURRENT_COMP+target_index), POS_A_CURRENT_COMP, ROT_A_CURRENT_COMP, target_index, target_x, target_y, target_z, focus_aw, focus_ah, focus_xw, focus_xh, focus_r, NAME_CURRENT_COMP);

// Input sanitation for this geometry
if (xwidth <= 0) {
  printf("\nERROR in Union_box named %s, the xwidth is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (yheight <= 0) {
  printf("\nERROR in Union_box named %s, yheight is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (zdepth <= 0) {
  printf("\nERROR in Union_box named %s, zdepth is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (xwidth2 <= 0 && xwidth2 != -1) {
  printf("\nERROR in Union_box named %s, the xwidth2 is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (yheight2 <= 0 && yheight2 != -1) {
  printf("\nERROR in Union_box named %s, yheight2 is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}

// Use sanitation
if (global_material_list.num_elements == 0) {
  printf("\nERROR: Need to define a material using Union_make_material before using a Union geometry component. \n");
  printf("       %s was defined before first use of Union_make_material.\n",NAME_CURRENT_COMP);
  exit(1);
}

this_box_volume.geometry.is_masked_volume = 0;
this_box_volume.geometry.is_exit_volume = 0;
this_box_volume.geometry.is_mask_volume = 0;
// check if the volume is a mask, if it is the material string is irelevant.
if (mask_string && strlen(mask_string) && strcmp(mask_string, "NULL") && strcmp(mask_string, "0")) {
    // A mask volume is used to limit the extend of other volumes, called the masked volumes. These are specified in the mask_string.
    // In order for a ray to enter a masked volume, it needs to be both in the region covered by that volume AND the mask volume.
    // When more than
    this_box_volume.geometry.mask_mode = 1; // Default is mask mode is ALL
    if (mask_setting && strlen(mask_setting) && strcmp(mask_setting, "NULL") && strcmp(mask_setting, "0")) {
        if (strcmp(mask_setting,"ALL") == 0 || strcmp(mask_setting,"All") == 0) this_box_volume.geometry.mask_mode = 1;
        else if (strcmp(mask_setting,"ANY") == 0 || strcmp(mask_setting,"Any") == 0) this_box_volume.geometry.mask_mode = 2;
        else {
            printf("The mask_mode of component %s is set to %s, but must be either ALL or ANY.\n",NAME_CURRENT_COMP,mask_setting);
            exit(1);
        }
    }
    
    for (loop_index=0;loop_index<global_geometry_list.num_elements;loop_index++) {
        // Add mask list
        if (1 == manual_linking_function(global_geometry_list.elements[loop_index].name,mask_string)) {
            add_element_to_int_list(&this_box_volume.geometry.mask_list,global_geometry_list.elements[loop_index].component_index);
            add_element_to_int_list(&global_geometry_list.elements[loop_index].Volume->geometry.masked_by_list,INDEX_CURRENT_COMP);
            global_geometry_list.elements[loop_index].Volume->geometry.is_masked_volume = 1;
            if (this_box_volume.geometry.mask_mode == 2)
                global_geometry_list.elements[loop_index].Volume->geometry.mask_mode = 2;
            if (this_box_volume.geometry.mask_mode == 1) {
                if (global_geometry_list.elements[loop_index].Volume->geometry.is_masked_volume == 1 && global_geometry_list.elements[loop_index].Volume->geometry.mask_mode != 2)
                    // If more than one mask is added to one volume, the ANY mode overwrites the (default) ALL mode.
                    global_geometry_list.elements[loop_index].Volume->geometry.mask_mode = 1;
            }
            
            found_geometries = 1;
        }
    }
    if (found_geometries == 0) {
        printf("The mask_string in geometry: %s did not find any of the specified volumes in the mask_string %s \n",NAME_CURRENT_COMP,mask_string);
        exit(1);
    }
    this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
    this_box_volume.p_physics->is_vacuum = 0; // Makes this volume a vacuum
    this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
    this_box_volume.p_physics->my_a = 0; // Should not be used.
    sprintf(this_box_volume.p_physics->name,"Mask");
    this_box_volume.geometry.is_mask_volume = 1;
    
    
// Read the material input, or if it lacks, use automatic linking.
} else if (material_string && strlen(material_string) && strcmp(material_string, "NULL") && strcmp(material_string, "0")) {
    // A geometry string was given, use it to determine which material
    if (0 == strcmp(material_string,"vacuum") || 0 == strcmp(material_string,"Vacuum")) {
        // One could have a global physics struct for vacuum instead of creating one for each
        this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
        this_box_volume.p_physics->is_vacuum = 1; // Makes this volume a vacuum
        this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
        this_box_volume.p_physics->my_a = 0; // Should not be used.
        sprintf(this_box_volume.p_physics->name,"Vacuum");
    } else if (0 == strcmp(material_string,"exit") || 0 == strcmp(material_string,"Exit")) {
        // One could have a global physics struct for vacuum instead of creating one for each
        this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
        this_box_volume.p_physics->is_vacuum = 1; // Makes this volume a vacuum
        this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
        this_box_volume.p_physics->my_a = 0; // Should not be used.
        this_box_volume.geometry.is_exit_volume = 1;
        sprintf(this_box_volume.p_physics->name,"Exit");
    } else {
        #ifndef MATERIAL_DETECTOR
            printf("Need to define a material before refering to it in a geometry %s.\n",NAME_CURRENT_COMP);
            exit(1);
        #endif
        for (loop_index=0;loop_index<global_material_list.num_elements;loop_index++) {
            if (0 == strcmp(material_string,global_material_list.elements[loop_index].name)) {
                this_box_volume.p_physics = global_material_list.elements[loop_index].physics;
                break;
            }
            if (loop_index == global_material_list.num_elements-1) {
            printf("\n");
            printf("ERROR: The material string \"%s\" in Union geometry \"%s\" did not match a specified material. \n",material_string,NAME_CURRENT_COMP);
            printf("       The materials available at this point (need to be defined before the geometry): \n");
            for (loop_index=0;loop_index<global_material_list.num_elements;loop_index++)
              printf("         %s\n",global_material_list.elements[loop_index].name);
            printf("\n");
            printf("       It is also possible to use one of the defualt materials avaiable: \n");
            printf("           Vacuum (for a Volume without scattering or absorption)\n");
            printf("           Exit (for a Volume where the ray exits the component if it enters)\n");
            printf("           Mask (for a Volume that masks existing volumes specified in the mask_string\n");
            exit(1);
          }
        }
    }
} else {
    // Automatic linking, simply using the last defined material.
    #ifndef MATERIAL_DETECTOR
        printf("Need to define a material before the geometry to use automatic linking %s.\n",NAME_CURRENT_COMP);
        exit(1);
    #endif
    this_box_volume.p_physics = global_material_list.elements[global_material_list.num_elements-1].physics;
}

sprintf(this_box_volume.name,NAME_CURRENT_COMP);
sprintf(this_box_volume.geometry.shape,"box");
this_box_volume.geometry.priority_value = priority;
this_box_volume.geometry.geometry_p_interact = p_interact;
// Currently the coordinates will be in absolute space.
this_box_volume.geometry.center = POS_A_CURRENT_COMP;

this_box_storage.z_depth = zdepth;
this_box_storage.x_width1 = xwidth;
this_box_storage.y_height1 = yheight;

this_box_storage.is_rectangle = 0;
if (xwidth2 < 0 && yheight2 < 0) this_box_storage.is_rectangle = 1;
if (xwidth == xwidth2 && yheight == yheight2) this_box_storage.is_rectangle = 1;

if (xwidth2 < 0) {
    this_box_storage.x_width2 = xwidth;
    xwidth2 = xwidth;
} else this_box_storage.x_width2 = xwidth2;

if (yheight2 < 0) {
    this_box_storage.y_height2 = yheight;
    yheight2 = yheight;
} else this_box_storage.y_height2 = yheight2;


this_box_storage.normal_vectors[0] = coords_set(0,0,1);
this_box_storage.normal_vectors[1] = coords_set(0,0,1);

// for sides with y component = 0
x_component = 2*zdepth/sqrt((xwidth-xwidth2)*(xwidth-xwidth2)+4*zdepth*zdepth);
z_component = (xwidth-xwidth2)/sqrt(4*zdepth*zdepth+(xwidth-xwidth2)*(xwidth-xwidth2));

this_box_storage.normal_vectors[2] = coords_set(x_component,0,z_component);
this_box_storage.normal_vectors[3] = coords_set(-x_component,0,z_component);

// for sides with x component = 0
y_component = 2*zdepth/sqrt((yheight-yheight2)*(yheight-yheight2)+4*zdepth*zdepth);
z_component = (yheight-yheight2)/sqrt(4*zdepth*zdepth+(yheight-yheight2)*(yheight-yheight2));

this_box_storage.normal_vectors[4] = coords_set(0,y_component,z_component);
this_box_storage.normal_vectors[5] = coords_set(0,-y_component,z_component);

this_box_volume.geometry.visualization_on = visualize;

this_box_volume.geometry.geometry_parameters.p_box_storage = &this_box_storage;

// Assign pointers to functions for intersection with the shape, checking if a point is inside the shape
if (this_box_storage.is_rectangle == 1) {
this_box_volume.geometry.intersect_function = &sample_box_intersect_simple;
this_box_volume.geometry.within_function = &r_within_box_simple;
}
else {
this_box_volume.geometry.intersect_function = &sample_box_intersect_advanced;
this_box_volume.geometry.within_function = &r_within_box_advanced;
}

this_box_volume.geometry.shell_points = &box_shell_points;
this_box_volume.geometry.mcdisplay_function = &mcdisplay_box_function;
this_box_volume.geometry.initialize_from_main_function = &initialize_box_geometry_from_main_component;
this_box_volume.geometry.process_rot_allocated = 0;

this_box_volume.geometry.copy_geometry_parameters = &allocate_box_storage_copy;

rot_copy(this_box_volume.geometry.rotation_matrix,ROT_A_CURRENT_COMP); //check how ROT_R_CURRENT_COMP would work
rot_transpose(ROT_A_CURRENT_COMP,this_box_volume.geometry.transpose_rotation_matrix);

// Initialize loggers
this_box_volume.loggers.num_elements = 0;

// packing the information into the global_geometry_element, which is then included in the global_geometry_list.
sprintf(global_geometry_element.name,NAME_CURRENT_COMP);
global_geometry_element.activation_counter = number_of_activations;
global_geometry_element.component_index = INDEX_CURRENT_COMP;
global_geometry_element.Volume = &this_box_volume; // Would be nicer if this m was a pointer, now we have the (small) data two places
add_element_to_geometry_list(&global_geometry_list,global_geometry_element);
}
#line 223988 "MACS_sample_kidney_box.c"
#undef number_of_activations
#undef mask_setting
#undef mask_string
#undef p_interact
#undef focus_r
#undef focus_xh
#undef focus_xw
#undef focus_ah
#undef focus_aw
#undef target_z
#undef target_y
#undef target_x
#undef target_index
#undef visualize
#undef yheight2
#undef xwidth2
#undef zdepth
#undef yheight
#undef xwidth
#undef priority
#undef material_string
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

  /* Initializations for component channel_6_cave2_box3. */
  SIG_MESSAGE("channel_6_cave2_box3 (Init)");
#define mccompcurname  channel_6_cave2_box3
#define mccompcurtype  Union_box
#define mccompcurindex 381
#define loop_index mccchannel_6_cave2_box3_loop_index
#define this_box_volume mccchannel_6_cave2_box3_this_box_volume
#define global_geometry_element mccchannel_6_cave2_box3_global_geometry_element
#define this_box_storage mccchannel_6_cave2_box3_this_box_storage
#define material_string mccchannel_6_cave2_box3_material_string
#define priority mccchannel_6_cave2_box3_priority
#define xwidth mccchannel_6_cave2_box3_xwidth
#define yheight mccchannel_6_cave2_box3_yheight
#define zdepth mccchannel_6_cave2_box3_zdepth
#define xwidth2 mccchannel_6_cave2_box3_xwidth2
#define yheight2 mccchannel_6_cave2_box3_yheight2
#define visualize mccchannel_6_cave2_box3_visualize
#define target_index mccchannel_6_cave2_box3_target_index
#define target_x mccchannel_6_cave2_box3_target_x
#define target_y mccchannel_6_cave2_box3_target_y
#define target_z mccchannel_6_cave2_box3_target_z
#define focus_aw mccchannel_6_cave2_box3_focus_aw
#define focus_ah mccchannel_6_cave2_box3_focus_ah
#define focus_xw mccchannel_6_cave2_box3_focus_xw
#define focus_xh mccchannel_6_cave2_box3_focus_xh
#define focus_r mccchannel_6_cave2_box3_focus_r
#define p_interact mccchannel_6_cave2_box3_p_interact
#define mask_string mccchannel_6_cave2_box3_mask_string
#define mask_setting mccchannel_6_cave2_box3_mask_setting
#define number_of_activations mccchannel_6_cave2_box3_number_of_activations
#line 224 "Union_box.comp"
{
// Initializes the focusing system for this volume including input sanitation.
focus_initialize(&this_box_volume.geometry, POS_A_COMP_INDEX(INDEX_CURRENT_COMP+target_index), POS_A_CURRENT_COMP, ROT_A_CURRENT_COMP, target_index, target_x, target_y, target_z, focus_aw, focus_ah, focus_xw, focus_xh, focus_r, NAME_CURRENT_COMP);

// Input sanitation for this geometry
if (xwidth <= 0) {
  printf("\nERROR in Union_box named %s, the xwidth is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (yheight <= 0) {
  printf("\nERROR in Union_box named %s, yheight is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (zdepth <= 0) {
  printf("\nERROR in Union_box named %s, zdepth is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (xwidth2 <= 0 && xwidth2 != -1) {
  printf("\nERROR in Union_box named %s, the xwidth2 is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (yheight2 <= 0 && yheight2 != -1) {
  printf("\nERROR in Union_box named %s, yheight2 is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}

// Use sanitation
if (global_material_list.num_elements == 0) {
  printf("\nERROR: Need to define a material using Union_make_material before using a Union geometry component. \n");
  printf("       %s was defined before first use of Union_make_material.\n",NAME_CURRENT_COMP);
  exit(1);
}

this_box_volume.geometry.is_masked_volume = 0;
this_box_volume.geometry.is_exit_volume = 0;
this_box_volume.geometry.is_mask_volume = 0;
// check if the volume is a mask, if it is the material string is irelevant.
if (mask_string && strlen(mask_string) && strcmp(mask_string, "NULL") && strcmp(mask_string, "0")) {
    // A mask volume is used to limit the extend of other volumes, called the masked volumes. These are specified in the mask_string.
    // In order for a ray to enter a masked volume, it needs to be both in the region covered by that volume AND the mask volume.
    // When more than
    this_box_volume.geometry.mask_mode = 1; // Default is mask mode is ALL
    if (mask_setting && strlen(mask_setting) && strcmp(mask_setting, "NULL") && strcmp(mask_setting, "0")) {
        if (strcmp(mask_setting,"ALL") == 0 || strcmp(mask_setting,"All") == 0) this_box_volume.geometry.mask_mode = 1;
        else if (strcmp(mask_setting,"ANY") == 0 || strcmp(mask_setting,"Any") == 0) this_box_volume.geometry.mask_mode = 2;
        else {
            printf("The mask_mode of component %s is set to %s, but must be either ALL or ANY.\n",NAME_CURRENT_COMP,mask_setting);
            exit(1);
        }
    }
    
    for (loop_index=0;loop_index<global_geometry_list.num_elements;loop_index++) {
        // Add mask list
        if (1 == manual_linking_function(global_geometry_list.elements[loop_index].name,mask_string)) {
            add_element_to_int_list(&this_box_volume.geometry.mask_list,global_geometry_list.elements[loop_index].component_index);
            add_element_to_int_list(&global_geometry_list.elements[loop_index].Volume->geometry.masked_by_list,INDEX_CURRENT_COMP);
            global_geometry_list.elements[loop_index].Volume->geometry.is_masked_volume = 1;
            if (this_box_volume.geometry.mask_mode == 2)
                global_geometry_list.elements[loop_index].Volume->geometry.mask_mode = 2;
            if (this_box_volume.geometry.mask_mode == 1) {
                if (global_geometry_list.elements[loop_index].Volume->geometry.is_masked_volume == 1 && global_geometry_list.elements[loop_index].Volume->geometry.mask_mode != 2)
                    // If more than one mask is added to one volume, the ANY mode overwrites the (default) ALL mode.
                    global_geometry_list.elements[loop_index].Volume->geometry.mask_mode = 1;
            }
            
            found_geometries = 1;
        }
    }
    if (found_geometries == 0) {
        printf("The mask_string in geometry: %s did not find any of the specified volumes in the mask_string %s \n",NAME_CURRENT_COMP,mask_string);
        exit(1);
    }
    this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
    this_box_volume.p_physics->is_vacuum = 0; // Makes this volume a vacuum
    this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
    this_box_volume.p_physics->my_a = 0; // Should not be used.
    sprintf(this_box_volume.p_physics->name,"Mask");
    this_box_volume.geometry.is_mask_volume = 1;
    
    
// Read the material input, or if it lacks, use automatic linking.
} else if (material_string && strlen(material_string) && strcmp(material_string, "NULL") && strcmp(material_string, "0")) {
    // A geometry string was given, use it to determine which material
    if (0 == strcmp(material_string,"vacuum") || 0 == strcmp(material_string,"Vacuum")) {
        // One could have a global physics struct for vacuum instead of creating one for each
        this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
        this_box_volume.p_physics->is_vacuum = 1; // Makes this volume a vacuum
        this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
        this_box_volume.p_physics->my_a = 0; // Should not be used.
        sprintf(this_box_volume.p_physics->name,"Vacuum");
    } else if (0 == strcmp(material_string,"exit") || 0 == strcmp(material_string,"Exit")) {
        // One could have a global physics struct for vacuum instead of creating one for each
        this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
        this_box_volume.p_physics->is_vacuum = 1; // Makes this volume a vacuum
        this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
        this_box_volume.p_physics->my_a = 0; // Should not be used.
        this_box_volume.geometry.is_exit_volume = 1;
        sprintf(this_box_volume.p_physics->name,"Exit");
    } else {
        #ifndef MATERIAL_DETECTOR
            printf("Need to define a material before refering to it in a geometry %s.\n",NAME_CURRENT_COMP);
            exit(1);
        #endif
        for (loop_index=0;loop_index<global_material_list.num_elements;loop_index++) {
            if (0 == strcmp(material_string,global_material_list.elements[loop_index].name)) {
                this_box_volume.p_physics = global_material_list.elements[loop_index].physics;
                break;
            }
            if (loop_index == global_material_list.num_elements-1) {
            printf("\n");
            printf("ERROR: The material string \"%s\" in Union geometry \"%s\" did not match a specified material. \n",material_string,NAME_CURRENT_COMP);
            printf("       The materials available at this point (need to be defined before the geometry): \n");
            for (loop_index=0;loop_index<global_material_list.num_elements;loop_index++)
              printf("         %s\n",global_material_list.elements[loop_index].name);
            printf("\n");
            printf("       It is also possible to use one of the defualt materials avaiable: \n");
            printf("           Vacuum (for a Volume without scattering or absorption)\n");
            printf("           Exit (for a Volume where the ray exits the component if it enters)\n");
            printf("           Mask (for a Volume that masks existing volumes specified in the mask_string\n");
            exit(1);
          }
        }
    }
} else {
    // Automatic linking, simply using the last defined material.
    #ifndef MATERIAL_DETECTOR
        printf("Need to define a material before the geometry to use automatic linking %s.\n",NAME_CURRENT_COMP);
        exit(1);
    #endif
    this_box_volume.p_physics = global_material_list.elements[global_material_list.num_elements-1].physics;
}

sprintf(this_box_volume.name,NAME_CURRENT_COMP);
sprintf(this_box_volume.geometry.shape,"box");
this_box_volume.geometry.priority_value = priority;
this_box_volume.geometry.geometry_p_interact = p_interact;
// Currently the coordinates will be in absolute space.
this_box_volume.geometry.center = POS_A_CURRENT_COMP;

this_box_storage.z_depth = zdepth;
this_box_storage.x_width1 = xwidth;
this_box_storage.y_height1 = yheight;

this_box_storage.is_rectangle = 0;
if (xwidth2 < 0 && yheight2 < 0) this_box_storage.is_rectangle = 1;
if (xwidth == xwidth2 && yheight == yheight2) this_box_storage.is_rectangle = 1;

if (xwidth2 < 0) {
    this_box_storage.x_width2 = xwidth;
    xwidth2 = xwidth;
} else this_box_storage.x_width2 = xwidth2;

if (yheight2 < 0) {
    this_box_storage.y_height2 = yheight;
    yheight2 = yheight;
} else this_box_storage.y_height2 = yheight2;


this_box_storage.normal_vectors[0] = coords_set(0,0,1);
this_box_storage.normal_vectors[1] = coords_set(0,0,1);

// for sides with y component = 0
x_component = 2*zdepth/sqrt((xwidth-xwidth2)*(xwidth-xwidth2)+4*zdepth*zdepth);
z_component = (xwidth-xwidth2)/sqrt(4*zdepth*zdepth+(xwidth-xwidth2)*(xwidth-xwidth2));

this_box_storage.normal_vectors[2] = coords_set(x_component,0,z_component);
this_box_storage.normal_vectors[3] = coords_set(-x_component,0,z_component);

// for sides with x component = 0
y_component = 2*zdepth/sqrt((yheight-yheight2)*(yheight-yheight2)+4*zdepth*zdepth);
z_component = (yheight-yheight2)/sqrt(4*zdepth*zdepth+(yheight-yheight2)*(yheight-yheight2));

this_box_storage.normal_vectors[4] = coords_set(0,y_component,z_component);
this_box_storage.normal_vectors[5] = coords_set(0,-y_component,z_component);

this_box_volume.geometry.visualization_on = visualize;

this_box_volume.geometry.geometry_parameters.p_box_storage = &this_box_storage;

// Assign pointers to functions for intersection with the shape, checking if a point is inside the shape
if (this_box_storage.is_rectangle == 1) {
this_box_volume.geometry.intersect_function = &sample_box_intersect_simple;
this_box_volume.geometry.within_function = &r_within_box_simple;
}
else {
this_box_volume.geometry.intersect_function = &sample_box_intersect_advanced;
this_box_volume.geometry.within_function = &r_within_box_advanced;
}

this_box_volume.geometry.shell_points = &box_shell_points;
this_box_volume.geometry.mcdisplay_function = &mcdisplay_box_function;
this_box_volume.geometry.initialize_from_main_function = &initialize_box_geometry_from_main_component;
this_box_volume.geometry.process_rot_allocated = 0;

this_box_volume.geometry.copy_geometry_parameters = &allocate_box_storage_copy;

rot_copy(this_box_volume.geometry.rotation_matrix,ROT_A_CURRENT_COMP); //check how ROT_R_CURRENT_COMP would work
rot_transpose(ROT_A_CURRENT_COMP,this_box_volume.geometry.transpose_rotation_matrix);

// Initialize loggers
this_box_volume.loggers.num_elements = 0;

// packing the information into the global_geometry_element, which is then included in the global_geometry_list.
sprintf(global_geometry_element.name,NAME_CURRENT_COMP);
global_geometry_element.activation_counter = number_of_activations;
global_geometry_element.component_index = INDEX_CURRENT_COMP;
global_geometry_element.Volume = &this_box_volume; // Would be nicer if this m was a pointer, now we have the (small) data two places
add_element_to_geometry_list(&global_geometry_list,global_geometry_element);
}
#line 224258 "MACS_sample_kidney_box.c"
#undef number_of_activations
#undef mask_setting
#undef mask_string
#undef p_interact
#undef focus_r
#undef focus_xh
#undef focus_xw
#undef focus_ah
#undef focus_aw
#undef target_z
#undef target_y
#undef target_x
#undef target_index
#undef visualize
#undef yheight2
#undef xwidth2
#undef zdepth
#undef yheight
#undef xwidth
#undef priority
#undef material_string
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

  /* Initializations for component inter_analyzer_colimator_center_6. */
  SIG_MESSAGE("inter_analyzer_colimator_center_6 (Init)");

  /* Initializations for component inter_analyzer_colimator_6_blade_0. */
  SIG_MESSAGE("inter_analyzer_colimator_6_blade_0 (Init)");
#define mccompcurname  inter_analyzer_colimator_6_blade_0
#define mccompcurtype  Union_box
#define mccompcurindex 383
#define loop_index mccinter_analyzer_colimator_6_blade_0_loop_index
#define this_box_volume mccinter_analyzer_colimator_6_blade_0_this_box_volume
#define global_geometry_element mccinter_analyzer_colimator_6_blade_0_global_geometry_element
#define this_box_storage mccinter_analyzer_colimator_6_blade_0_this_box_storage
#define material_string mccinter_analyzer_colimator_6_blade_0_material_string
#define priority mccinter_analyzer_colimator_6_blade_0_priority
#define xwidth mccinter_analyzer_colimator_6_blade_0_xwidth
#define yheight mccinter_analyzer_colimator_6_blade_0_yheight
#define zdepth mccinter_analyzer_colimator_6_blade_0_zdepth
#define xwidth2 mccinter_analyzer_colimator_6_blade_0_xwidth2
#define yheight2 mccinter_analyzer_colimator_6_blade_0_yheight2
#define visualize mccinter_analyzer_colimator_6_blade_0_visualize
#define target_index mccinter_analyzer_colimator_6_blade_0_target_index
#define target_x mccinter_analyzer_colimator_6_blade_0_target_x
#define target_y mccinter_analyzer_colimator_6_blade_0_target_y
#define target_z mccinter_analyzer_colimator_6_blade_0_target_z
#define focus_aw mccinter_analyzer_colimator_6_blade_0_focus_aw
#define focus_ah mccinter_analyzer_colimator_6_blade_0_focus_ah
#define focus_xw mccinter_analyzer_colimator_6_blade_0_focus_xw
#define focus_xh mccinter_analyzer_colimator_6_blade_0_focus_xh
#define focus_r mccinter_analyzer_colimator_6_blade_0_focus_r
#define p_interact mccinter_analyzer_colimator_6_blade_0_p_interact
#define mask_string mccinter_analyzer_colimator_6_blade_0_mask_string
#define mask_setting mccinter_analyzer_colimator_6_blade_0_mask_setting
#define number_of_activations mccinter_analyzer_colimator_6_blade_0_number_of_activations
#line 224 "Union_box.comp"
{
// Initializes the focusing system for this volume including input sanitation.
focus_initialize(&this_box_volume.geometry, POS_A_COMP_INDEX(INDEX_CURRENT_COMP+target_index), POS_A_CURRENT_COMP, ROT_A_CURRENT_COMP, target_index, target_x, target_y, target_z, focus_aw, focus_ah, focus_xw, focus_xh, focus_r, NAME_CURRENT_COMP);

// Input sanitation for this geometry
if (xwidth <= 0) {
  printf("\nERROR in Union_box named %s, the xwidth is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (yheight <= 0) {
  printf("\nERROR in Union_box named %s, yheight is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (zdepth <= 0) {
  printf("\nERROR in Union_box named %s, zdepth is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (xwidth2 <= 0 && xwidth2 != -1) {
  printf("\nERROR in Union_box named %s, the xwidth2 is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (yheight2 <= 0 && yheight2 != -1) {
  printf("\nERROR in Union_box named %s, yheight2 is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}

// Use sanitation
if (global_material_list.num_elements == 0) {
  printf("\nERROR: Need to define a material using Union_make_material before using a Union geometry component. \n");
  printf("       %s was defined before first use of Union_make_material.\n",NAME_CURRENT_COMP);
  exit(1);
}

this_box_volume.geometry.is_masked_volume = 0;
this_box_volume.geometry.is_exit_volume = 0;
this_box_volume.geometry.is_mask_volume = 0;
// check if the volume is a mask, if it is the material string is irelevant.
if (mask_string && strlen(mask_string) && strcmp(mask_string, "NULL") && strcmp(mask_string, "0")) {
    // A mask volume is used to limit the extend of other volumes, called the masked volumes. These are specified in the mask_string.
    // In order for a ray to enter a masked volume, it needs to be both in the region covered by that volume AND the mask volume.
    // When more than
    this_box_volume.geometry.mask_mode = 1; // Default is mask mode is ALL
    if (mask_setting && strlen(mask_setting) && strcmp(mask_setting, "NULL") && strcmp(mask_setting, "0")) {
        if (strcmp(mask_setting,"ALL") == 0 || strcmp(mask_setting,"All") == 0) this_box_volume.geometry.mask_mode = 1;
        else if (strcmp(mask_setting,"ANY") == 0 || strcmp(mask_setting,"Any") == 0) this_box_volume.geometry.mask_mode = 2;
        else {
            printf("The mask_mode of component %s is set to %s, but must be either ALL or ANY.\n",NAME_CURRENT_COMP,mask_setting);
            exit(1);
        }
    }
    
    for (loop_index=0;loop_index<global_geometry_list.num_elements;loop_index++) {
        // Add mask list
        if (1 == manual_linking_function(global_geometry_list.elements[loop_index].name,mask_string)) {
            add_element_to_int_list(&this_box_volume.geometry.mask_list,global_geometry_list.elements[loop_index].component_index);
            add_element_to_int_list(&global_geometry_list.elements[loop_index].Volume->geometry.masked_by_list,INDEX_CURRENT_COMP);
            global_geometry_list.elements[loop_index].Volume->geometry.is_masked_volume = 1;
            if (this_box_volume.geometry.mask_mode == 2)
                global_geometry_list.elements[loop_index].Volume->geometry.mask_mode = 2;
            if (this_box_volume.geometry.mask_mode == 1) {
                if (global_geometry_list.elements[loop_index].Volume->geometry.is_masked_volume == 1 && global_geometry_list.elements[loop_index].Volume->geometry.mask_mode != 2)
                    // If more than one mask is added to one volume, the ANY mode overwrites the (default) ALL mode.
                    global_geometry_list.elements[loop_index].Volume->geometry.mask_mode = 1;
            }
            
            found_geometries = 1;
        }
    }
    if (found_geometries == 0) {
        printf("The mask_string in geometry: %s did not find any of the specified volumes in the mask_string %s \n",NAME_CURRENT_COMP,mask_string);
        exit(1);
    }
    this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
    this_box_volume.p_physics->is_vacuum = 0; // Makes this volume a vacuum
    this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
    this_box_volume.p_physics->my_a = 0; // Should not be used.
    sprintf(this_box_volume.p_physics->name,"Mask");
    this_box_volume.geometry.is_mask_volume = 1;
    
    
// Read the material input, or if it lacks, use automatic linking.
} else if (material_string && strlen(material_string) && strcmp(material_string, "NULL") && strcmp(material_string, "0")) {
    // A geometry string was given, use it to determine which material
    if (0 == strcmp(material_string,"vacuum") || 0 == strcmp(material_string,"Vacuum")) {
        // One could have a global physics struct for vacuum instead of creating one for each
        this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
        this_box_volume.p_physics->is_vacuum = 1; // Makes this volume a vacuum
        this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
        this_box_volume.p_physics->my_a = 0; // Should not be used.
        sprintf(this_box_volume.p_physics->name,"Vacuum");
    } else if (0 == strcmp(material_string,"exit") || 0 == strcmp(material_string,"Exit")) {
        // One could have a global physics struct for vacuum instead of creating one for each
        this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
        this_box_volume.p_physics->is_vacuum = 1; // Makes this volume a vacuum
        this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
        this_box_volume.p_physics->my_a = 0; // Should not be used.
        this_box_volume.geometry.is_exit_volume = 1;
        sprintf(this_box_volume.p_physics->name,"Exit");
    } else {
        #ifndef MATERIAL_DETECTOR
            printf("Need to define a material before refering to it in a geometry %s.\n",NAME_CURRENT_COMP);
            exit(1);
        #endif
        for (loop_index=0;loop_index<global_material_list.num_elements;loop_index++) {
            if (0 == strcmp(material_string,global_material_list.elements[loop_index].name)) {
                this_box_volume.p_physics = global_material_list.elements[loop_index].physics;
                break;
            }
            if (loop_index == global_material_list.num_elements-1) {
            printf("\n");
            printf("ERROR: The material string \"%s\" in Union geometry \"%s\" did not match a specified material. \n",material_string,NAME_CURRENT_COMP);
            printf("       The materials available at this point (need to be defined before the geometry): \n");
            for (loop_index=0;loop_index<global_material_list.num_elements;loop_index++)
              printf("         %s\n",global_material_list.elements[loop_index].name);
            printf("\n");
            printf("       It is also possible to use one of the defualt materials avaiable: \n");
            printf("           Vacuum (for a Volume without scattering or absorption)\n");
            printf("           Exit (for a Volume where the ray exits the component if it enters)\n");
            printf("           Mask (for a Volume that masks existing volumes specified in the mask_string\n");
            exit(1);
          }
        }
    }
} else {
    // Automatic linking, simply using the last defined material.
    #ifndef MATERIAL_DETECTOR
        printf("Need to define a material before the geometry to use automatic linking %s.\n",NAME_CURRENT_COMP);
        exit(1);
    #endif
    this_box_volume.p_physics = global_material_list.elements[global_material_list.num_elements-1].physics;
}

sprintf(this_box_volume.name,NAME_CURRENT_COMP);
sprintf(this_box_volume.geometry.shape,"box");
this_box_volume.geometry.priority_value = priority;
this_box_volume.geometry.geometry_p_interact = p_interact;
// Currently the coordinates will be in absolute space.
this_box_volume.geometry.center = POS_A_CURRENT_COMP;

this_box_storage.z_depth = zdepth;
this_box_storage.x_width1 = xwidth;
this_box_storage.y_height1 = yheight;

this_box_storage.is_rectangle = 0;
if (xwidth2 < 0 && yheight2 < 0) this_box_storage.is_rectangle = 1;
if (xwidth == xwidth2 && yheight == yheight2) this_box_storage.is_rectangle = 1;

if (xwidth2 < 0) {
    this_box_storage.x_width2 = xwidth;
    xwidth2 = xwidth;
} else this_box_storage.x_width2 = xwidth2;

if (yheight2 < 0) {
    this_box_storage.y_height2 = yheight;
    yheight2 = yheight;
} else this_box_storage.y_height2 = yheight2;


this_box_storage.normal_vectors[0] = coords_set(0,0,1);
this_box_storage.normal_vectors[1] = coords_set(0,0,1);

// for sides with y component = 0
x_component = 2*zdepth/sqrt((xwidth-xwidth2)*(xwidth-xwidth2)+4*zdepth*zdepth);
z_component = (xwidth-xwidth2)/sqrt(4*zdepth*zdepth+(xwidth-xwidth2)*(xwidth-xwidth2));

this_box_storage.normal_vectors[2] = coords_set(x_component,0,z_component);
this_box_storage.normal_vectors[3] = coords_set(-x_component,0,z_component);

// for sides with x component = 0
y_component = 2*zdepth/sqrt((yheight-yheight2)*(yheight-yheight2)+4*zdepth*zdepth);
z_component = (yheight-yheight2)/sqrt(4*zdepth*zdepth+(yheight-yheight2)*(yheight-yheight2));

this_box_storage.normal_vectors[4] = coords_set(0,y_component,z_component);
this_box_storage.normal_vectors[5] = coords_set(0,-y_component,z_component);

this_box_volume.geometry.visualization_on = visualize;

this_box_volume.geometry.geometry_parameters.p_box_storage = &this_box_storage;

// Assign pointers to functions for intersection with the shape, checking if a point is inside the shape
if (this_box_storage.is_rectangle == 1) {
this_box_volume.geometry.intersect_function = &sample_box_intersect_simple;
this_box_volume.geometry.within_function = &r_within_box_simple;
}
else {
this_box_volume.geometry.intersect_function = &sample_box_intersect_advanced;
this_box_volume.geometry.within_function = &r_within_box_advanced;
}

this_box_volume.geometry.shell_points = &box_shell_points;
this_box_volume.geometry.mcdisplay_function = &mcdisplay_box_function;
this_box_volume.geometry.initialize_from_main_function = &initialize_box_geometry_from_main_component;
this_box_volume.geometry.process_rot_allocated = 0;

this_box_volume.geometry.copy_geometry_parameters = &allocate_box_storage_copy;

rot_copy(this_box_volume.geometry.rotation_matrix,ROT_A_CURRENT_COMP); //check how ROT_R_CURRENT_COMP would work
rot_transpose(ROT_A_CURRENT_COMP,this_box_volume.geometry.transpose_rotation_matrix);

// Initialize loggers
this_box_volume.loggers.num_elements = 0;

// packing the information into the global_geometry_element, which is then included in the global_geometry_list.
sprintf(global_geometry_element.name,NAME_CURRENT_COMP);
global_geometry_element.activation_counter = number_of_activations;
global_geometry_element.component_index = INDEX_CURRENT_COMP;
global_geometry_element.Volume = &this_box_volume; // Would be nicer if this m was a pointer, now we have the (small) data two places
add_element_to_geometry_list(&global_geometry_list,global_geometry_element);
}
#line 224531 "MACS_sample_kidney_box.c"
#undef number_of_activations
#undef mask_setting
#undef mask_string
#undef p_interact
#undef focus_r
#undef focus_xh
#undef focus_xw
#undef focus_ah
#undef focus_aw
#undef target_z
#undef target_y
#undef target_x
#undef target_index
#undef visualize
#undef yheight2
#undef xwidth2
#undef zdepth
#undef yheight
#undef xwidth
#undef priority
#undef material_string
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

  /* Initializations for component inter_analyzer_colimator_6_blade_1. */
  SIG_MESSAGE("inter_analyzer_colimator_6_blade_1 (Init)");
#define mccompcurname  inter_analyzer_colimator_6_blade_1
#define mccompcurtype  Union_box
#define mccompcurindex 384
#define loop_index mccinter_analyzer_colimator_6_blade_1_loop_index
#define this_box_volume mccinter_analyzer_colimator_6_blade_1_this_box_volume
#define global_geometry_element mccinter_analyzer_colimator_6_blade_1_global_geometry_element
#define this_box_storage mccinter_analyzer_colimator_6_blade_1_this_box_storage
#define material_string mccinter_analyzer_colimator_6_blade_1_material_string
#define priority mccinter_analyzer_colimator_6_blade_1_priority
#define xwidth mccinter_analyzer_colimator_6_blade_1_xwidth
#define yheight mccinter_analyzer_colimator_6_blade_1_yheight
#define zdepth mccinter_analyzer_colimator_6_blade_1_zdepth
#define xwidth2 mccinter_analyzer_colimator_6_blade_1_xwidth2
#define yheight2 mccinter_analyzer_colimator_6_blade_1_yheight2
#define visualize mccinter_analyzer_colimator_6_blade_1_visualize
#define target_index mccinter_analyzer_colimator_6_blade_1_target_index
#define target_x mccinter_analyzer_colimator_6_blade_1_target_x
#define target_y mccinter_analyzer_colimator_6_blade_1_target_y
#define target_z mccinter_analyzer_colimator_6_blade_1_target_z
#define focus_aw mccinter_analyzer_colimator_6_blade_1_focus_aw
#define focus_ah mccinter_analyzer_colimator_6_blade_1_focus_ah
#define focus_xw mccinter_analyzer_colimator_6_blade_1_focus_xw
#define focus_xh mccinter_analyzer_colimator_6_blade_1_focus_xh
#define focus_r mccinter_analyzer_colimator_6_blade_1_focus_r
#define p_interact mccinter_analyzer_colimator_6_blade_1_p_interact
#define mask_string mccinter_analyzer_colimator_6_blade_1_mask_string
#define mask_setting mccinter_analyzer_colimator_6_blade_1_mask_setting
#define number_of_activations mccinter_analyzer_colimator_6_blade_1_number_of_activations
#line 224 "Union_box.comp"
{
// Initializes the focusing system for this volume including input sanitation.
focus_initialize(&this_box_volume.geometry, POS_A_COMP_INDEX(INDEX_CURRENT_COMP+target_index), POS_A_CURRENT_COMP, ROT_A_CURRENT_COMP, target_index, target_x, target_y, target_z, focus_aw, focus_ah, focus_xw, focus_xh, focus_r, NAME_CURRENT_COMP);

// Input sanitation for this geometry
if (xwidth <= 0) {
  printf("\nERROR in Union_box named %s, the xwidth is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (yheight <= 0) {
  printf("\nERROR in Union_box named %s, yheight is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (zdepth <= 0) {
  printf("\nERROR in Union_box named %s, zdepth is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (xwidth2 <= 0 && xwidth2 != -1) {
  printf("\nERROR in Union_box named %s, the xwidth2 is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (yheight2 <= 0 && yheight2 != -1) {
  printf("\nERROR in Union_box named %s, yheight2 is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}

// Use sanitation
if (global_material_list.num_elements == 0) {
  printf("\nERROR: Need to define a material using Union_make_material before using a Union geometry component. \n");
  printf("       %s was defined before first use of Union_make_material.\n",NAME_CURRENT_COMP);
  exit(1);
}

this_box_volume.geometry.is_masked_volume = 0;
this_box_volume.geometry.is_exit_volume = 0;
this_box_volume.geometry.is_mask_volume = 0;
// check if the volume is a mask, if it is the material string is irelevant.
if (mask_string && strlen(mask_string) && strcmp(mask_string, "NULL") && strcmp(mask_string, "0")) {
    // A mask volume is used to limit the extend of other volumes, called the masked volumes. These are specified in the mask_string.
    // In order for a ray to enter a masked volume, it needs to be both in the region covered by that volume AND the mask volume.
    // When more than
    this_box_volume.geometry.mask_mode = 1; // Default is mask mode is ALL
    if (mask_setting && strlen(mask_setting) && strcmp(mask_setting, "NULL") && strcmp(mask_setting, "0")) {
        if (strcmp(mask_setting,"ALL") == 0 || strcmp(mask_setting,"All") == 0) this_box_volume.geometry.mask_mode = 1;
        else if (strcmp(mask_setting,"ANY") == 0 || strcmp(mask_setting,"Any") == 0) this_box_volume.geometry.mask_mode = 2;
        else {
            printf("The mask_mode of component %s is set to %s, but must be either ALL or ANY.\n",NAME_CURRENT_COMP,mask_setting);
            exit(1);
        }
    }
    
    for (loop_index=0;loop_index<global_geometry_list.num_elements;loop_index++) {
        // Add mask list
        if (1 == manual_linking_function(global_geometry_list.elements[loop_index].name,mask_string)) {
            add_element_to_int_list(&this_box_volume.geometry.mask_list,global_geometry_list.elements[loop_index].component_index);
            add_element_to_int_list(&global_geometry_list.elements[loop_index].Volume->geometry.masked_by_list,INDEX_CURRENT_COMP);
            global_geometry_list.elements[loop_index].Volume->geometry.is_masked_volume = 1;
            if (this_box_volume.geometry.mask_mode == 2)
                global_geometry_list.elements[loop_index].Volume->geometry.mask_mode = 2;
            if (this_box_volume.geometry.mask_mode == 1) {
                if (global_geometry_list.elements[loop_index].Volume->geometry.is_masked_volume == 1 && global_geometry_list.elements[loop_index].Volume->geometry.mask_mode != 2)
                    // If more than one mask is added to one volume, the ANY mode overwrites the (default) ALL mode.
                    global_geometry_list.elements[loop_index].Volume->geometry.mask_mode = 1;
            }
            
            found_geometries = 1;
        }
    }
    if (found_geometries == 0) {
        printf("The mask_string in geometry: %s did not find any of the specified volumes in the mask_string %s \n",NAME_CURRENT_COMP,mask_string);
        exit(1);
    }
    this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
    this_box_volume.p_physics->is_vacuum = 0; // Makes this volume a vacuum
    this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
    this_box_volume.p_physics->my_a = 0; // Should not be used.
    sprintf(this_box_volume.p_physics->name,"Mask");
    this_box_volume.geometry.is_mask_volume = 1;
    
    
// Read the material input, or if it lacks, use automatic linking.
} else if (material_string && strlen(material_string) && strcmp(material_string, "NULL") && strcmp(material_string, "0")) {
    // A geometry string was given, use it to determine which material
    if (0 == strcmp(material_string,"vacuum") || 0 == strcmp(material_string,"Vacuum")) {
        // One could have a global physics struct for vacuum instead of creating one for each
        this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
        this_box_volume.p_physics->is_vacuum = 1; // Makes this volume a vacuum
        this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
        this_box_volume.p_physics->my_a = 0; // Should not be used.
        sprintf(this_box_volume.p_physics->name,"Vacuum");
    } else if (0 == strcmp(material_string,"exit") || 0 == strcmp(material_string,"Exit")) {
        // One could have a global physics struct for vacuum instead of creating one for each
        this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
        this_box_volume.p_physics->is_vacuum = 1; // Makes this volume a vacuum
        this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
        this_box_volume.p_physics->my_a = 0; // Should not be used.
        this_box_volume.geometry.is_exit_volume = 1;
        sprintf(this_box_volume.p_physics->name,"Exit");
    } else {
        #ifndef MATERIAL_DETECTOR
            printf("Need to define a material before refering to it in a geometry %s.\n",NAME_CURRENT_COMP);
            exit(1);
        #endif
        for (loop_index=0;loop_index<global_material_list.num_elements;loop_index++) {
            if (0 == strcmp(material_string,global_material_list.elements[loop_index].name)) {
                this_box_volume.p_physics = global_material_list.elements[loop_index].physics;
                break;
            }
            if (loop_index == global_material_list.num_elements-1) {
            printf("\n");
            printf("ERROR: The material string \"%s\" in Union geometry \"%s\" did not match a specified material. \n",material_string,NAME_CURRENT_COMP);
            printf("       The materials available at this point (need to be defined before the geometry): \n");
            for (loop_index=0;loop_index<global_material_list.num_elements;loop_index++)
              printf("         %s\n",global_material_list.elements[loop_index].name);
            printf("\n");
            printf("       It is also possible to use one of the defualt materials avaiable: \n");
            printf("           Vacuum (for a Volume without scattering or absorption)\n");
            printf("           Exit (for a Volume where the ray exits the component if it enters)\n");
            printf("           Mask (for a Volume that masks existing volumes specified in the mask_string\n");
            exit(1);
          }
        }
    }
} else {
    // Automatic linking, simply using the last defined material.
    #ifndef MATERIAL_DETECTOR
        printf("Need to define a material before the geometry to use automatic linking %s.\n",NAME_CURRENT_COMP);
        exit(1);
    #endif
    this_box_volume.p_physics = global_material_list.elements[global_material_list.num_elements-1].physics;
}

sprintf(this_box_volume.name,NAME_CURRENT_COMP);
sprintf(this_box_volume.geometry.shape,"box");
this_box_volume.geometry.priority_value = priority;
this_box_volume.geometry.geometry_p_interact = p_interact;
// Currently the coordinates will be in absolute space.
this_box_volume.geometry.center = POS_A_CURRENT_COMP;

this_box_storage.z_depth = zdepth;
this_box_storage.x_width1 = xwidth;
this_box_storage.y_height1 = yheight;

this_box_storage.is_rectangle = 0;
if (xwidth2 < 0 && yheight2 < 0) this_box_storage.is_rectangle = 1;
if (xwidth == xwidth2 && yheight == yheight2) this_box_storage.is_rectangle = 1;

if (xwidth2 < 0) {
    this_box_storage.x_width2 = xwidth;
    xwidth2 = xwidth;
} else this_box_storage.x_width2 = xwidth2;

if (yheight2 < 0) {
    this_box_storage.y_height2 = yheight;
    yheight2 = yheight;
} else this_box_storage.y_height2 = yheight2;


this_box_storage.normal_vectors[0] = coords_set(0,0,1);
this_box_storage.normal_vectors[1] = coords_set(0,0,1);

// for sides with y component = 0
x_component = 2*zdepth/sqrt((xwidth-xwidth2)*(xwidth-xwidth2)+4*zdepth*zdepth);
z_component = (xwidth-xwidth2)/sqrt(4*zdepth*zdepth+(xwidth-xwidth2)*(xwidth-xwidth2));

this_box_storage.normal_vectors[2] = coords_set(x_component,0,z_component);
this_box_storage.normal_vectors[3] = coords_set(-x_component,0,z_component);

// for sides with x component = 0
y_component = 2*zdepth/sqrt((yheight-yheight2)*(yheight-yheight2)+4*zdepth*zdepth);
z_component = (yheight-yheight2)/sqrt(4*zdepth*zdepth+(yheight-yheight2)*(yheight-yheight2));

this_box_storage.normal_vectors[4] = coords_set(0,y_component,z_component);
this_box_storage.normal_vectors[5] = coords_set(0,-y_component,z_component);

this_box_volume.geometry.visualization_on = visualize;

this_box_volume.geometry.geometry_parameters.p_box_storage = &this_box_storage;

// Assign pointers to functions for intersection with the shape, checking if a point is inside the shape
if (this_box_storage.is_rectangle == 1) {
this_box_volume.geometry.intersect_function = &sample_box_intersect_simple;
this_box_volume.geometry.within_function = &r_within_box_simple;
}
else {
this_box_volume.geometry.intersect_function = &sample_box_intersect_advanced;
this_box_volume.geometry.within_function = &r_within_box_advanced;
}

this_box_volume.geometry.shell_points = &box_shell_points;
this_box_volume.geometry.mcdisplay_function = &mcdisplay_box_function;
this_box_volume.geometry.initialize_from_main_function = &initialize_box_geometry_from_main_component;
this_box_volume.geometry.process_rot_allocated = 0;

this_box_volume.geometry.copy_geometry_parameters = &allocate_box_storage_copy;

rot_copy(this_box_volume.geometry.rotation_matrix,ROT_A_CURRENT_COMP); //check how ROT_R_CURRENT_COMP would work
rot_transpose(ROT_A_CURRENT_COMP,this_box_volume.geometry.transpose_rotation_matrix);

// Initialize loggers
this_box_volume.loggers.num_elements = 0;

// packing the information into the global_geometry_element, which is then included in the global_geometry_list.
sprintf(global_geometry_element.name,NAME_CURRENT_COMP);
global_geometry_element.activation_counter = number_of_activations;
global_geometry_element.component_index = INDEX_CURRENT_COMP;
global_geometry_element.Volume = &this_box_volume; // Would be nicer if this m was a pointer, now we have the (small) data two places
add_element_to_geometry_list(&global_geometry_list,global_geometry_element);
}
#line 224801 "MACS_sample_kidney_box.c"
#undef number_of_activations
#undef mask_setting
#undef mask_string
#undef p_interact
#undef focus_r
#undef focus_xh
#undef focus_xw
#undef focus_ah
#undef focus_aw
#undef target_z
#undef target_y
#undef target_x
#undef target_index
#undef visualize
#undef yheight2
#undef xwidth2
#undef zdepth
#undef yheight
#undef xwidth
#undef priority
#undef material_string
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

  /* Initializations for component inter_analyzer_colimator_6_blade_2. */
  SIG_MESSAGE("inter_analyzer_colimator_6_blade_2 (Init)");
#define mccompcurname  inter_analyzer_colimator_6_blade_2
#define mccompcurtype  Union_box
#define mccompcurindex 385
#define loop_index mccinter_analyzer_colimator_6_blade_2_loop_index
#define this_box_volume mccinter_analyzer_colimator_6_blade_2_this_box_volume
#define global_geometry_element mccinter_analyzer_colimator_6_blade_2_global_geometry_element
#define this_box_storage mccinter_analyzer_colimator_6_blade_2_this_box_storage
#define material_string mccinter_analyzer_colimator_6_blade_2_material_string
#define priority mccinter_analyzer_colimator_6_blade_2_priority
#define xwidth mccinter_analyzer_colimator_6_blade_2_xwidth
#define yheight mccinter_analyzer_colimator_6_blade_2_yheight
#define zdepth mccinter_analyzer_colimator_6_blade_2_zdepth
#define xwidth2 mccinter_analyzer_colimator_6_blade_2_xwidth2
#define yheight2 mccinter_analyzer_colimator_6_blade_2_yheight2
#define visualize mccinter_analyzer_colimator_6_blade_2_visualize
#define target_index mccinter_analyzer_colimator_6_blade_2_target_index
#define target_x mccinter_analyzer_colimator_6_blade_2_target_x
#define target_y mccinter_analyzer_colimator_6_blade_2_target_y
#define target_z mccinter_analyzer_colimator_6_blade_2_target_z
#define focus_aw mccinter_analyzer_colimator_6_blade_2_focus_aw
#define focus_ah mccinter_analyzer_colimator_6_blade_2_focus_ah
#define focus_xw mccinter_analyzer_colimator_6_blade_2_focus_xw
#define focus_xh mccinter_analyzer_colimator_6_blade_2_focus_xh
#define focus_r mccinter_analyzer_colimator_6_blade_2_focus_r
#define p_interact mccinter_analyzer_colimator_6_blade_2_p_interact
#define mask_string mccinter_analyzer_colimator_6_blade_2_mask_string
#define mask_setting mccinter_analyzer_colimator_6_blade_2_mask_setting
#define number_of_activations mccinter_analyzer_colimator_6_blade_2_number_of_activations
#line 224 "Union_box.comp"
{
// Initializes the focusing system for this volume including input sanitation.
focus_initialize(&this_box_volume.geometry, POS_A_COMP_INDEX(INDEX_CURRENT_COMP+target_index), POS_A_CURRENT_COMP, ROT_A_CURRENT_COMP, target_index, target_x, target_y, target_z, focus_aw, focus_ah, focus_xw, focus_xh, focus_r, NAME_CURRENT_COMP);

// Input sanitation for this geometry
if (xwidth <= 0) {
  printf("\nERROR in Union_box named %s, the xwidth is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (yheight <= 0) {
  printf("\nERROR in Union_box named %s, yheight is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (zdepth <= 0) {
  printf("\nERROR in Union_box named %s, zdepth is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (xwidth2 <= 0 && xwidth2 != -1) {
  printf("\nERROR in Union_box named %s, the xwidth2 is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (yheight2 <= 0 && yheight2 != -1) {
  printf("\nERROR in Union_box named %s, yheight2 is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}

// Use sanitation
if (global_material_list.num_elements == 0) {
  printf("\nERROR: Need to define a material using Union_make_material before using a Union geometry component. \n");
  printf("       %s was defined before first use of Union_make_material.\n",NAME_CURRENT_COMP);
  exit(1);
}

this_box_volume.geometry.is_masked_volume = 0;
this_box_volume.geometry.is_exit_volume = 0;
this_box_volume.geometry.is_mask_volume = 0;
// check if the volume is a mask, if it is the material string is irelevant.
if (mask_string && strlen(mask_string) && strcmp(mask_string, "NULL") && strcmp(mask_string, "0")) {
    // A mask volume is used to limit the extend of other volumes, called the masked volumes. These are specified in the mask_string.
    // In order for a ray to enter a masked volume, it needs to be both in the region covered by that volume AND the mask volume.
    // When more than
    this_box_volume.geometry.mask_mode = 1; // Default is mask mode is ALL
    if (mask_setting && strlen(mask_setting) && strcmp(mask_setting, "NULL") && strcmp(mask_setting, "0")) {
        if (strcmp(mask_setting,"ALL") == 0 || strcmp(mask_setting,"All") == 0) this_box_volume.geometry.mask_mode = 1;
        else if (strcmp(mask_setting,"ANY") == 0 || strcmp(mask_setting,"Any") == 0) this_box_volume.geometry.mask_mode = 2;
        else {
            printf("The mask_mode of component %s is set to %s, but must be either ALL or ANY.\n",NAME_CURRENT_COMP,mask_setting);
            exit(1);
        }
    }
    
    for (loop_index=0;loop_index<global_geometry_list.num_elements;loop_index++) {
        // Add mask list
        if (1 == manual_linking_function(global_geometry_list.elements[loop_index].name,mask_string)) {
            add_element_to_int_list(&this_box_volume.geometry.mask_list,global_geometry_list.elements[loop_index].component_index);
            add_element_to_int_list(&global_geometry_list.elements[loop_index].Volume->geometry.masked_by_list,INDEX_CURRENT_COMP);
            global_geometry_list.elements[loop_index].Volume->geometry.is_masked_volume = 1;
            if (this_box_volume.geometry.mask_mode == 2)
                global_geometry_list.elements[loop_index].Volume->geometry.mask_mode = 2;
            if (this_box_volume.geometry.mask_mode == 1) {
                if (global_geometry_list.elements[loop_index].Volume->geometry.is_masked_volume == 1 && global_geometry_list.elements[loop_index].Volume->geometry.mask_mode != 2)
                    // If more than one mask is added to one volume, the ANY mode overwrites the (default) ALL mode.
                    global_geometry_list.elements[loop_index].Volume->geometry.mask_mode = 1;
            }
            
            found_geometries = 1;
        }
    }
    if (found_geometries == 0) {
        printf("The mask_string in geometry: %s did not find any of the specified volumes in the mask_string %s \n",NAME_CURRENT_COMP,mask_string);
        exit(1);
    }
    this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
    this_box_volume.p_physics->is_vacuum = 0; // Makes this volume a vacuum
    this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
    this_box_volume.p_physics->my_a = 0; // Should not be used.
    sprintf(this_box_volume.p_physics->name,"Mask");
    this_box_volume.geometry.is_mask_volume = 1;
    
    
// Read the material input, or if it lacks, use automatic linking.
} else if (material_string && strlen(material_string) && strcmp(material_string, "NULL") && strcmp(material_string, "0")) {
    // A geometry string was given, use it to determine which material
    if (0 == strcmp(material_string,"vacuum") || 0 == strcmp(material_string,"Vacuum")) {
        // One could have a global physics struct for vacuum instead of creating one for each
        this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
        this_box_volume.p_physics->is_vacuum = 1; // Makes this volume a vacuum
        this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
        this_box_volume.p_physics->my_a = 0; // Should not be used.
        sprintf(this_box_volume.p_physics->name,"Vacuum");
    } else if (0 == strcmp(material_string,"exit") || 0 == strcmp(material_string,"Exit")) {
        // One could have a global physics struct for vacuum instead of creating one for each
        this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
        this_box_volume.p_physics->is_vacuum = 1; // Makes this volume a vacuum
        this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
        this_box_volume.p_physics->my_a = 0; // Should not be used.
        this_box_volume.geometry.is_exit_volume = 1;
        sprintf(this_box_volume.p_physics->name,"Exit");
    } else {
        #ifndef MATERIAL_DETECTOR
            printf("Need to define a material before refering to it in a geometry %s.\n",NAME_CURRENT_COMP);
            exit(1);
        #endif
        for (loop_index=0;loop_index<global_material_list.num_elements;loop_index++) {
            if (0 == strcmp(material_string,global_material_list.elements[loop_index].name)) {
                this_box_volume.p_physics = global_material_list.elements[loop_index].physics;
                break;
            }
            if (loop_index == global_material_list.num_elements-1) {
            printf("\n");
            printf("ERROR: The material string \"%s\" in Union geometry \"%s\" did not match a specified material. \n",material_string,NAME_CURRENT_COMP);
            printf("       The materials available at this point (need to be defined before the geometry): \n");
            for (loop_index=0;loop_index<global_material_list.num_elements;loop_index++)
              printf("         %s\n",global_material_list.elements[loop_index].name);
            printf("\n");
            printf("       It is also possible to use one of the defualt materials avaiable: \n");
            printf("           Vacuum (for a Volume without scattering or absorption)\n");
            printf("           Exit (for a Volume where the ray exits the component if it enters)\n");
            printf("           Mask (for a Volume that masks existing volumes specified in the mask_string\n");
            exit(1);
          }
        }
    }
} else {
    // Automatic linking, simply using the last defined material.
    #ifndef MATERIAL_DETECTOR
        printf("Need to define a material before the geometry to use automatic linking %s.\n",NAME_CURRENT_COMP);
        exit(1);
    #endif
    this_box_volume.p_physics = global_material_list.elements[global_material_list.num_elements-1].physics;
}

sprintf(this_box_volume.name,NAME_CURRENT_COMP);
sprintf(this_box_volume.geometry.shape,"box");
this_box_volume.geometry.priority_value = priority;
this_box_volume.geometry.geometry_p_interact = p_interact;
// Currently the coordinates will be in absolute space.
this_box_volume.geometry.center = POS_A_CURRENT_COMP;

this_box_storage.z_depth = zdepth;
this_box_storage.x_width1 = xwidth;
this_box_storage.y_height1 = yheight;

this_box_storage.is_rectangle = 0;
if (xwidth2 < 0 && yheight2 < 0) this_box_storage.is_rectangle = 1;
if (xwidth == xwidth2 && yheight == yheight2) this_box_storage.is_rectangle = 1;

if (xwidth2 < 0) {
    this_box_storage.x_width2 = xwidth;
    xwidth2 = xwidth;
} else this_box_storage.x_width2 = xwidth2;

if (yheight2 < 0) {
    this_box_storage.y_height2 = yheight;
    yheight2 = yheight;
} else this_box_storage.y_height2 = yheight2;


this_box_storage.normal_vectors[0] = coords_set(0,0,1);
this_box_storage.normal_vectors[1] = coords_set(0,0,1);

// for sides with y component = 0
x_component = 2*zdepth/sqrt((xwidth-xwidth2)*(xwidth-xwidth2)+4*zdepth*zdepth);
z_component = (xwidth-xwidth2)/sqrt(4*zdepth*zdepth+(xwidth-xwidth2)*(xwidth-xwidth2));

this_box_storage.normal_vectors[2] = coords_set(x_component,0,z_component);
this_box_storage.normal_vectors[3] = coords_set(-x_component,0,z_component);

// for sides with x component = 0
y_component = 2*zdepth/sqrt((yheight-yheight2)*(yheight-yheight2)+4*zdepth*zdepth);
z_component = (yheight-yheight2)/sqrt(4*zdepth*zdepth+(yheight-yheight2)*(yheight-yheight2));

this_box_storage.normal_vectors[4] = coords_set(0,y_component,z_component);
this_box_storage.normal_vectors[5] = coords_set(0,-y_component,z_component);

this_box_volume.geometry.visualization_on = visualize;

this_box_volume.geometry.geometry_parameters.p_box_storage = &this_box_storage;

// Assign pointers to functions for intersection with the shape, checking if a point is inside the shape
if (this_box_storage.is_rectangle == 1) {
this_box_volume.geometry.intersect_function = &sample_box_intersect_simple;
this_box_volume.geometry.within_function = &r_within_box_simple;
}
else {
this_box_volume.geometry.intersect_function = &sample_box_intersect_advanced;
this_box_volume.geometry.within_function = &r_within_box_advanced;
}

this_box_volume.geometry.shell_points = &box_shell_points;
this_box_volume.geometry.mcdisplay_function = &mcdisplay_box_function;
this_box_volume.geometry.initialize_from_main_function = &initialize_box_geometry_from_main_component;
this_box_volume.geometry.process_rot_allocated = 0;

this_box_volume.geometry.copy_geometry_parameters = &allocate_box_storage_copy;

rot_copy(this_box_volume.geometry.rotation_matrix,ROT_A_CURRENT_COMP); //check how ROT_R_CURRENT_COMP would work
rot_transpose(ROT_A_CURRENT_COMP,this_box_volume.geometry.transpose_rotation_matrix);

// Initialize loggers
this_box_volume.loggers.num_elements = 0;

// packing the information into the global_geometry_element, which is then included in the global_geometry_list.
sprintf(global_geometry_element.name,NAME_CURRENT_COMP);
global_geometry_element.activation_counter = number_of_activations;
global_geometry_element.component_index = INDEX_CURRENT_COMP;
global_geometry_element.Volume = &this_box_volume; // Would be nicer if this m was a pointer, now we have the (small) data two places
add_element_to_geometry_list(&global_geometry_list,global_geometry_element);
}
#line 225071 "MACS_sample_kidney_box.c"
#undef number_of_activations
#undef mask_setting
#undef mask_string
#undef p_interact
#undef focus_r
#undef focus_xh
#undef focus_xw
#undef focus_ah
#undef focus_aw
#undef target_z
#undef target_y
#undef target_x
#undef target_index
#undef visualize
#undef yheight2
#undef xwidth2
#undef zdepth
#undef yheight
#undef xwidth
#undef priority
#undef material_string
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

  /* Initializations for component inter_analyzer_colimator_6_blade_3. */
  SIG_MESSAGE("inter_analyzer_colimator_6_blade_3 (Init)");
#define mccompcurname  inter_analyzer_colimator_6_blade_3
#define mccompcurtype  Union_box
#define mccompcurindex 386
#define loop_index mccinter_analyzer_colimator_6_blade_3_loop_index
#define this_box_volume mccinter_analyzer_colimator_6_blade_3_this_box_volume
#define global_geometry_element mccinter_analyzer_colimator_6_blade_3_global_geometry_element
#define this_box_storage mccinter_analyzer_colimator_6_blade_3_this_box_storage
#define material_string mccinter_analyzer_colimator_6_blade_3_material_string
#define priority mccinter_analyzer_colimator_6_blade_3_priority
#define xwidth mccinter_analyzer_colimator_6_blade_3_xwidth
#define yheight mccinter_analyzer_colimator_6_blade_3_yheight
#define zdepth mccinter_analyzer_colimator_6_blade_3_zdepth
#define xwidth2 mccinter_analyzer_colimator_6_blade_3_xwidth2
#define yheight2 mccinter_analyzer_colimator_6_blade_3_yheight2
#define visualize mccinter_analyzer_colimator_6_blade_3_visualize
#define target_index mccinter_analyzer_colimator_6_blade_3_target_index
#define target_x mccinter_analyzer_colimator_6_blade_3_target_x
#define target_y mccinter_analyzer_colimator_6_blade_3_target_y
#define target_z mccinter_analyzer_colimator_6_blade_3_target_z
#define focus_aw mccinter_analyzer_colimator_6_blade_3_focus_aw
#define focus_ah mccinter_analyzer_colimator_6_blade_3_focus_ah
#define focus_xw mccinter_analyzer_colimator_6_blade_3_focus_xw
#define focus_xh mccinter_analyzer_colimator_6_blade_3_focus_xh
#define focus_r mccinter_analyzer_colimator_6_blade_3_focus_r
#define p_interact mccinter_analyzer_colimator_6_blade_3_p_interact
#define mask_string mccinter_analyzer_colimator_6_blade_3_mask_string
#define mask_setting mccinter_analyzer_colimator_6_blade_3_mask_setting
#define number_of_activations mccinter_analyzer_colimator_6_blade_3_number_of_activations
#line 224 "Union_box.comp"
{
// Initializes the focusing system for this volume including input sanitation.
focus_initialize(&this_box_volume.geometry, POS_A_COMP_INDEX(INDEX_CURRENT_COMP+target_index), POS_A_CURRENT_COMP, ROT_A_CURRENT_COMP, target_index, target_x, target_y, target_z, focus_aw, focus_ah, focus_xw, focus_xh, focus_r, NAME_CURRENT_COMP);

// Input sanitation for this geometry
if (xwidth <= 0) {
  printf("\nERROR in Union_box named %s, the xwidth is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (yheight <= 0) {
  printf("\nERROR in Union_box named %s, yheight is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (zdepth <= 0) {
  printf("\nERROR in Union_box named %s, zdepth is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (xwidth2 <= 0 && xwidth2 != -1) {
  printf("\nERROR in Union_box named %s, the xwidth2 is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (yheight2 <= 0 && yheight2 != -1) {
  printf("\nERROR in Union_box named %s, yheight2 is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}

// Use sanitation
if (global_material_list.num_elements == 0) {
  printf("\nERROR: Need to define a material using Union_make_material before using a Union geometry component. \n");
  printf("       %s was defined before first use of Union_make_material.\n",NAME_CURRENT_COMP);
  exit(1);
}

this_box_volume.geometry.is_masked_volume = 0;
this_box_volume.geometry.is_exit_volume = 0;
this_box_volume.geometry.is_mask_volume = 0;
// check if the volume is a mask, if it is the material string is irelevant.
if (mask_string && strlen(mask_string) && strcmp(mask_string, "NULL") && strcmp(mask_string, "0")) {
    // A mask volume is used to limit the extend of other volumes, called the masked volumes. These are specified in the mask_string.
    // In order for a ray to enter a masked volume, it needs to be both in the region covered by that volume AND the mask volume.
    // When more than
    this_box_volume.geometry.mask_mode = 1; // Default is mask mode is ALL
    if (mask_setting && strlen(mask_setting) && strcmp(mask_setting, "NULL") && strcmp(mask_setting, "0")) {
        if (strcmp(mask_setting,"ALL") == 0 || strcmp(mask_setting,"All") == 0) this_box_volume.geometry.mask_mode = 1;
        else if (strcmp(mask_setting,"ANY") == 0 || strcmp(mask_setting,"Any") == 0) this_box_volume.geometry.mask_mode = 2;
        else {
            printf("The mask_mode of component %s is set to %s, but must be either ALL or ANY.\n",NAME_CURRENT_COMP,mask_setting);
            exit(1);
        }
    }
    
    for (loop_index=0;loop_index<global_geometry_list.num_elements;loop_index++) {
        // Add mask list
        if (1 == manual_linking_function(global_geometry_list.elements[loop_index].name,mask_string)) {
            add_element_to_int_list(&this_box_volume.geometry.mask_list,global_geometry_list.elements[loop_index].component_index);
            add_element_to_int_list(&global_geometry_list.elements[loop_index].Volume->geometry.masked_by_list,INDEX_CURRENT_COMP);
            global_geometry_list.elements[loop_index].Volume->geometry.is_masked_volume = 1;
            if (this_box_volume.geometry.mask_mode == 2)
                global_geometry_list.elements[loop_index].Volume->geometry.mask_mode = 2;
            if (this_box_volume.geometry.mask_mode == 1) {
                if (global_geometry_list.elements[loop_index].Volume->geometry.is_masked_volume == 1 && global_geometry_list.elements[loop_index].Volume->geometry.mask_mode != 2)
                    // If more than one mask is added to one volume, the ANY mode overwrites the (default) ALL mode.
                    global_geometry_list.elements[loop_index].Volume->geometry.mask_mode = 1;
            }
            
            found_geometries = 1;
        }
    }
    if (found_geometries == 0) {
        printf("The mask_string in geometry: %s did not find any of the specified volumes in the mask_string %s \n",NAME_CURRENT_COMP,mask_string);
        exit(1);
    }
    this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
    this_box_volume.p_physics->is_vacuum = 0; // Makes this volume a vacuum
    this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
    this_box_volume.p_physics->my_a = 0; // Should not be used.
    sprintf(this_box_volume.p_physics->name,"Mask");
    this_box_volume.geometry.is_mask_volume = 1;
    
    
// Read the material input, or if it lacks, use automatic linking.
} else if (material_string && strlen(material_string) && strcmp(material_string, "NULL") && strcmp(material_string, "0")) {
    // A geometry string was given, use it to determine which material
    if (0 == strcmp(material_string,"vacuum") || 0 == strcmp(material_string,"Vacuum")) {
        // One could have a global physics struct for vacuum instead of creating one for each
        this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
        this_box_volume.p_physics->is_vacuum = 1; // Makes this volume a vacuum
        this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
        this_box_volume.p_physics->my_a = 0; // Should not be used.
        sprintf(this_box_volume.p_physics->name,"Vacuum");
    } else if (0 == strcmp(material_string,"exit") || 0 == strcmp(material_string,"Exit")) {
        // One could have a global physics struct for vacuum instead of creating one for each
        this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
        this_box_volume.p_physics->is_vacuum = 1; // Makes this volume a vacuum
        this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
        this_box_volume.p_physics->my_a = 0; // Should not be used.
        this_box_volume.geometry.is_exit_volume = 1;
        sprintf(this_box_volume.p_physics->name,"Exit");
    } else {
        #ifndef MATERIAL_DETECTOR
            printf("Need to define a material before refering to it in a geometry %s.\n",NAME_CURRENT_COMP);
            exit(1);
        #endif
        for (loop_index=0;loop_index<global_material_list.num_elements;loop_index++) {
            if (0 == strcmp(material_string,global_material_list.elements[loop_index].name)) {
                this_box_volume.p_physics = global_material_list.elements[loop_index].physics;
                break;
            }
            if (loop_index == global_material_list.num_elements-1) {
            printf("\n");
            printf("ERROR: The material string \"%s\" in Union geometry \"%s\" did not match a specified material. \n",material_string,NAME_CURRENT_COMP);
            printf("       The materials available at this point (need to be defined before the geometry): \n");
            for (loop_index=0;loop_index<global_material_list.num_elements;loop_index++)
              printf("         %s\n",global_material_list.elements[loop_index].name);
            printf("\n");
            printf("       It is also possible to use one of the defualt materials avaiable: \n");
            printf("           Vacuum (for a Volume without scattering or absorption)\n");
            printf("           Exit (for a Volume where the ray exits the component if it enters)\n");
            printf("           Mask (for a Volume that masks existing volumes specified in the mask_string\n");
            exit(1);
          }
        }
    }
} else {
    // Automatic linking, simply using the last defined material.
    #ifndef MATERIAL_DETECTOR
        printf("Need to define a material before the geometry to use automatic linking %s.\n",NAME_CURRENT_COMP);
        exit(1);
    #endif
    this_box_volume.p_physics = global_material_list.elements[global_material_list.num_elements-1].physics;
}

sprintf(this_box_volume.name,NAME_CURRENT_COMP);
sprintf(this_box_volume.geometry.shape,"box");
this_box_volume.geometry.priority_value = priority;
this_box_volume.geometry.geometry_p_interact = p_interact;
// Currently the coordinates will be in absolute space.
this_box_volume.geometry.center = POS_A_CURRENT_COMP;

this_box_storage.z_depth = zdepth;
this_box_storage.x_width1 = xwidth;
this_box_storage.y_height1 = yheight;

this_box_storage.is_rectangle = 0;
if (xwidth2 < 0 && yheight2 < 0) this_box_storage.is_rectangle = 1;
if (xwidth == xwidth2 && yheight == yheight2) this_box_storage.is_rectangle = 1;

if (xwidth2 < 0) {
    this_box_storage.x_width2 = xwidth;
    xwidth2 = xwidth;
} else this_box_storage.x_width2 = xwidth2;

if (yheight2 < 0) {
    this_box_storage.y_height2 = yheight;
    yheight2 = yheight;
} else this_box_storage.y_height2 = yheight2;


this_box_storage.normal_vectors[0] = coords_set(0,0,1);
this_box_storage.normal_vectors[1] = coords_set(0,0,1);

// for sides with y component = 0
x_component = 2*zdepth/sqrt((xwidth-xwidth2)*(xwidth-xwidth2)+4*zdepth*zdepth);
z_component = (xwidth-xwidth2)/sqrt(4*zdepth*zdepth+(xwidth-xwidth2)*(xwidth-xwidth2));

this_box_storage.normal_vectors[2] = coords_set(x_component,0,z_component);
this_box_storage.normal_vectors[3] = coords_set(-x_component,0,z_component);

// for sides with x component = 0
y_component = 2*zdepth/sqrt((yheight-yheight2)*(yheight-yheight2)+4*zdepth*zdepth);
z_component = (yheight-yheight2)/sqrt(4*zdepth*zdepth+(yheight-yheight2)*(yheight-yheight2));

this_box_storage.normal_vectors[4] = coords_set(0,y_component,z_component);
this_box_storage.normal_vectors[5] = coords_set(0,-y_component,z_component);

this_box_volume.geometry.visualization_on = visualize;

this_box_volume.geometry.geometry_parameters.p_box_storage = &this_box_storage;

// Assign pointers to functions for intersection with the shape, checking if a point is inside the shape
if (this_box_storage.is_rectangle == 1) {
this_box_volume.geometry.intersect_function = &sample_box_intersect_simple;
this_box_volume.geometry.within_function = &r_within_box_simple;
}
else {
this_box_volume.geometry.intersect_function = &sample_box_intersect_advanced;
this_box_volume.geometry.within_function = &r_within_box_advanced;
}

this_box_volume.geometry.shell_points = &box_shell_points;
this_box_volume.geometry.mcdisplay_function = &mcdisplay_box_function;
this_box_volume.geometry.initialize_from_main_function = &initialize_box_geometry_from_main_component;
this_box_volume.geometry.process_rot_allocated = 0;

this_box_volume.geometry.copy_geometry_parameters = &allocate_box_storage_copy;

rot_copy(this_box_volume.geometry.rotation_matrix,ROT_A_CURRENT_COMP); //check how ROT_R_CURRENT_COMP would work
rot_transpose(ROT_A_CURRENT_COMP,this_box_volume.geometry.transpose_rotation_matrix);

// Initialize loggers
this_box_volume.loggers.num_elements = 0;

// packing the information into the global_geometry_element, which is then included in the global_geometry_list.
sprintf(global_geometry_element.name,NAME_CURRENT_COMP);
global_geometry_element.activation_counter = number_of_activations;
global_geometry_element.component_index = INDEX_CURRENT_COMP;
global_geometry_element.Volume = &this_box_volume; // Would be nicer if this m was a pointer, now we have the (small) data two places
add_element_to_geometry_list(&global_geometry_list,global_geometry_element);
}
#line 225341 "MACS_sample_kidney_box.c"
#undef number_of_activations
#undef mask_setting
#undef mask_string
#undef p_interact
#undef focus_r
#undef focus_xh
#undef focus_xw
#undef focus_ah
#undef focus_aw
#undef target_z
#undef target_y
#undef target_x
#undef target_index
#undef visualize
#undef yheight2
#undef xwidth2
#undef zdepth
#undef yheight
#undef xwidth
#undef priority
#undef material_string
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

  /* Initializations for component inter_analyzer_colimator_6_blade_4. */
  SIG_MESSAGE("inter_analyzer_colimator_6_blade_4 (Init)");
#define mccompcurname  inter_analyzer_colimator_6_blade_4
#define mccompcurtype  Union_box
#define mccompcurindex 387
#define loop_index mccinter_analyzer_colimator_6_blade_4_loop_index
#define this_box_volume mccinter_analyzer_colimator_6_blade_4_this_box_volume
#define global_geometry_element mccinter_analyzer_colimator_6_blade_4_global_geometry_element
#define this_box_storage mccinter_analyzer_colimator_6_blade_4_this_box_storage
#define material_string mccinter_analyzer_colimator_6_blade_4_material_string
#define priority mccinter_analyzer_colimator_6_blade_4_priority
#define xwidth mccinter_analyzer_colimator_6_blade_4_xwidth
#define yheight mccinter_analyzer_colimator_6_blade_4_yheight
#define zdepth mccinter_analyzer_colimator_6_blade_4_zdepth
#define xwidth2 mccinter_analyzer_colimator_6_blade_4_xwidth2
#define yheight2 mccinter_analyzer_colimator_6_blade_4_yheight2
#define visualize mccinter_analyzer_colimator_6_blade_4_visualize
#define target_index mccinter_analyzer_colimator_6_blade_4_target_index
#define target_x mccinter_analyzer_colimator_6_blade_4_target_x
#define target_y mccinter_analyzer_colimator_6_blade_4_target_y
#define target_z mccinter_analyzer_colimator_6_blade_4_target_z
#define focus_aw mccinter_analyzer_colimator_6_blade_4_focus_aw
#define focus_ah mccinter_analyzer_colimator_6_blade_4_focus_ah
#define focus_xw mccinter_analyzer_colimator_6_blade_4_focus_xw
#define focus_xh mccinter_analyzer_colimator_6_blade_4_focus_xh
#define focus_r mccinter_analyzer_colimator_6_blade_4_focus_r
#define p_interact mccinter_analyzer_colimator_6_blade_4_p_interact
#define mask_string mccinter_analyzer_colimator_6_blade_4_mask_string
#define mask_setting mccinter_analyzer_colimator_6_blade_4_mask_setting
#define number_of_activations mccinter_analyzer_colimator_6_blade_4_number_of_activations
#line 224 "Union_box.comp"
{
// Initializes the focusing system for this volume including input sanitation.
focus_initialize(&this_box_volume.geometry, POS_A_COMP_INDEX(INDEX_CURRENT_COMP+target_index), POS_A_CURRENT_COMP, ROT_A_CURRENT_COMP, target_index, target_x, target_y, target_z, focus_aw, focus_ah, focus_xw, focus_xh, focus_r, NAME_CURRENT_COMP);

// Input sanitation for this geometry
if (xwidth <= 0) {
  printf("\nERROR in Union_box named %s, the xwidth is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (yheight <= 0) {
  printf("\nERROR in Union_box named %s, yheight is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (zdepth <= 0) {
  printf("\nERROR in Union_box named %s, zdepth is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (xwidth2 <= 0 && xwidth2 != -1) {
  printf("\nERROR in Union_box named %s, the xwidth2 is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (yheight2 <= 0 && yheight2 != -1) {
  printf("\nERROR in Union_box named %s, yheight2 is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}

// Use sanitation
if (global_material_list.num_elements == 0) {
  printf("\nERROR: Need to define a material using Union_make_material before using a Union geometry component. \n");
  printf("       %s was defined before first use of Union_make_material.\n",NAME_CURRENT_COMP);
  exit(1);
}

this_box_volume.geometry.is_masked_volume = 0;
this_box_volume.geometry.is_exit_volume = 0;
this_box_volume.geometry.is_mask_volume = 0;
// check if the volume is a mask, if it is the material string is irelevant.
if (mask_string && strlen(mask_string) && strcmp(mask_string, "NULL") && strcmp(mask_string, "0")) {
    // A mask volume is used to limit the extend of other volumes, called the masked volumes. These are specified in the mask_string.
    // In order for a ray to enter a masked volume, it needs to be both in the region covered by that volume AND the mask volume.
    // When more than
    this_box_volume.geometry.mask_mode = 1; // Default is mask mode is ALL
    if (mask_setting && strlen(mask_setting) && strcmp(mask_setting, "NULL") && strcmp(mask_setting, "0")) {
        if (strcmp(mask_setting,"ALL") == 0 || strcmp(mask_setting,"All") == 0) this_box_volume.geometry.mask_mode = 1;
        else if (strcmp(mask_setting,"ANY") == 0 || strcmp(mask_setting,"Any") == 0) this_box_volume.geometry.mask_mode = 2;
        else {
            printf("The mask_mode of component %s is set to %s, but must be either ALL or ANY.\n",NAME_CURRENT_COMP,mask_setting);
            exit(1);
        }
    }
    
    for (loop_index=0;loop_index<global_geometry_list.num_elements;loop_index++) {
        // Add mask list
        if (1 == manual_linking_function(global_geometry_list.elements[loop_index].name,mask_string)) {
            add_element_to_int_list(&this_box_volume.geometry.mask_list,global_geometry_list.elements[loop_index].component_index);
            add_element_to_int_list(&global_geometry_list.elements[loop_index].Volume->geometry.masked_by_list,INDEX_CURRENT_COMP);
            global_geometry_list.elements[loop_index].Volume->geometry.is_masked_volume = 1;
            if (this_box_volume.geometry.mask_mode == 2)
                global_geometry_list.elements[loop_index].Volume->geometry.mask_mode = 2;
            if (this_box_volume.geometry.mask_mode == 1) {
                if (global_geometry_list.elements[loop_index].Volume->geometry.is_masked_volume == 1 && global_geometry_list.elements[loop_index].Volume->geometry.mask_mode != 2)
                    // If more than one mask is added to one volume, the ANY mode overwrites the (default) ALL mode.
                    global_geometry_list.elements[loop_index].Volume->geometry.mask_mode = 1;
            }
            
            found_geometries = 1;
        }
    }
    if (found_geometries == 0) {
        printf("The mask_string in geometry: %s did not find any of the specified volumes in the mask_string %s \n",NAME_CURRENT_COMP,mask_string);
        exit(1);
    }
    this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
    this_box_volume.p_physics->is_vacuum = 0; // Makes this volume a vacuum
    this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
    this_box_volume.p_physics->my_a = 0; // Should not be used.
    sprintf(this_box_volume.p_physics->name,"Mask");
    this_box_volume.geometry.is_mask_volume = 1;
    
    
// Read the material input, or if it lacks, use automatic linking.
} else if (material_string && strlen(material_string) && strcmp(material_string, "NULL") && strcmp(material_string, "0")) {
    // A geometry string was given, use it to determine which material
    if (0 == strcmp(material_string,"vacuum") || 0 == strcmp(material_string,"Vacuum")) {
        // One could have a global physics struct for vacuum instead of creating one for each
        this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
        this_box_volume.p_physics->is_vacuum = 1; // Makes this volume a vacuum
        this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
        this_box_volume.p_physics->my_a = 0; // Should not be used.
        sprintf(this_box_volume.p_physics->name,"Vacuum");
    } else if (0 == strcmp(material_string,"exit") || 0 == strcmp(material_string,"Exit")) {
        // One could have a global physics struct for vacuum instead of creating one for each
        this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
        this_box_volume.p_physics->is_vacuum = 1; // Makes this volume a vacuum
        this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
        this_box_volume.p_physics->my_a = 0; // Should not be used.
        this_box_volume.geometry.is_exit_volume = 1;
        sprintf(this_box_volume.p_physics->name,"Exit");
    } else {
        #ifndef MATERIAL_DETECTOR
            printf("Need to define a material before refering to it in a geometry %s.\n",NAME_CURRENT_COMP);
            exit(1);
        #endif
        for (loop_index=0;loop_index<global_material_list.num_elements;loop_index++) {
            if (0 == strcmp(material_string,global_material_list.elements[loop_index].name)) {
                this_box_volume.p_physics = global_material_list.elements[loop_index].physics;
                break;
            }
            if (loop_index == global_material_list.num_elements-1) {
            printf("\n");
            printf("ERROR: The material string \"%s\" in Union geometry \"%s\" did not match a specified material. \n",material_string,NAME_CURRENT_COMP);
            printf("       The materials available at this point (need to be defined before the geometry): \n");
            for (loop_index=0;loop_index<global_material_list.num_elements;loop_index++)
              printf("         %s\n",global_material_list.elements[loop_index].name);
            printf("\n");
            printf("       It is also possible to use one of the defualt materials avaiable: \n");
            printf("           Vacuum (for a Volume without scattering or absorption)\n");
            printf("           Exit (for a Volume where the ray exits the component if it enters)\n");
            printf("           Mask (for a Volume that masks existing volumes specified in the mask_string\n");
            exit(1);
          }
        }
    }
} else {
    // Automatic linking, simply using the last defined material.
    #ifndef MATERIAL_DETECTOR
        printf("Need to define a material before the geometry to use automatic linking %s.\n",NAME_CURRENT_COMP);
        exit(1);
    #endif
    this_box_volume.p_physics = global_material_list.elements[global_material_list.num_elements-1].physics;
}

sprintf(this_box_volume.name,NAME_CURRENT_COMP);
sprintf(this_box_volume.geometry.shape,"box");
this_box_volume.geometry.priority_value = priority;
this_box_volume.geometry.geometry_p_interact = p_interact;
// Currently the coordinates will be in absolute space.
this_box_volume.geometry.center = POS_A_CURRENT_COMP;

this_box_storage.z_depth = zdepth;
this_box_storage.x_width1 = xwidth;
this_box_storage.y_height1 = yheight;

this_box_storage.is_rectangle = 0;
if (xwidth2 < 0 && yheight2 < 0) this_box_storage.is_rectangle = 1;
if (xwidth == xwidth2 && yheight == yheight2) this_box_storage.is_rectangle = 1;

if (xwidth2 < 0) {
    this_box_storage.x_width2 = xwidth;
    xwidth2 = xwidth;
} else this_box_storage.x_width2 = xwidth2;

if (yheight2 < 0) {
    this_box_storage.y_height2 = yheight;
    yheight2 = yheight;
} else this_box_storage.y_height2 = yheight2;


this_box_storage.normal_vectors[0] = coords_set(0,0,1);
this_box_storage.normal_vectors[1] = coords_set(0,0,1);

// for sides with y component = 0
x_component = 2*zdepth/sqrt((xwidth-xwidth2)*(xwidth-xwidth2)+4*zdepth*zdepth);
z_component = (xwidth-xwidth2)/sqrt(4*zdepth*zdepth+(xwidth-xwidth2)*(xwidth-xwidth2));

this_box_storage.normal_vectors[2] = coords_set(x_component,0,z_component);
this_box_storage.normal_vectors[3] = coords_set(-x_component,0,z_component);

// for sides with x component = 0
y_component = 2*zdepth/sqrt((yheight-yheight2)*(yheight-yheight2)+4*zdepth*zdepth);
z_component = (yheight-yheight2)/sqrt(4*zdepth*zdepth+(yheight-yheight2)*(yheight-yheight2));

this_box_storage.normal_vectors[4] = coords_set(0,y_component,z_component);
this_box_storage.normal_vectors[5] = coords_set(0,-y_component,z_component);

this_box_volume.geometry.visualization_on = visualize;

this_box_volume.geometry.geometry_parameters.p_box_storage = &this_box_storage;

// Assign pointers to functions for intersection with the shape, checking if a point is inside the shape
if (this_box_storage.is_rectangle == 1) {
this_box_volume.geometry.intersect_function = &sample_box_intersect_simple;
this_box_volume.geometry.within_function = &r_within_box_simple;
}
else {
this_box_volume.geometry.intersect_function = &sample_box_intersect_advanced;
this_box_volume.geometry.within_function = &r_within_box_advanced;
}

this_box_volume.geometry.shell_points = &box_shell_points;
this_box_volume.geometry.mcdisplay_function = &mcdisplay_box_function;
this_box_volume.geometry.initialize_from_main_function = &initialize_box_geometry_from_main_component;
this_box_volume.geometry.process_rot_allocated = 0;

this_box_volume.geometry.copy_geometry_parameters = &allocate_box_storage_copy;

rot_copy(this_box_volume.geometry.rotation_matrix,ROT_A_CURRENT_COMP); //check how ROT_R_CURRENT_COMP would work
rot_transpose(ROT_A_CURRENT_COMP,this_box_volume.geometry.transpose_rotation_matrix);

// Initialize loggers
this_box_volume.loggers.num_elements = 0;

// packing the information into the global_geometry_element, which is then included in the global_geometry_list.
sprintf(global_geometry_element.name,NAME_CURRENT_COMP);
global_geometry_element.activation_counter = number_of_activations;
global_geometry_element.component_index = INDEX_CURRENT_COMP;
global_geometry_element.Volume = &this_box_volume; // Would be nicer if this m was a pointer, now we have the (small) data two places
add_element_to_geometry_list(&global_geometry_list,global_geometry_element);
}
#line 225611 "MACS_sample_kidney_box.c"
#undef number_of_activations
#undef mask_setting
#undef mask_string
#undef p_interact
#undef focus_r
#undef focus_xh
#undef focus_xw
#undef focus_ah
#undef focus_aw
#undef target_z
#undef target_y
#undef target_x
#undef target_index
#undef visualize
#undef yheight2
#undef xwidth2
#undef zdepth
#undef yheight
#undef xwidth
#undef priority
#undef material_string
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

  /* Initializations for component diffraction_detector_6_exit_volume. */
  SIG_MESSAGE("diffraction_detector_6_exit_volume (Init)");
#define mccompcurname  diffraction_detector_6_exit_volume
#define mccompcurtype  Union_box
#define mccompcurindex 388
#define loop_index mccdiffraction_detector_6_exit_volume_loop_index
#define this_box_volume mccdiffraction_detector_6_exit_volume_this_box_volume
#define global_geometry_element mccdiffraction_detector_6_exit_volume_global_geometry_element
#define this_box_storage mccdiffraction_detector_6_exit_volume_this_box_storage
#define material_string mccdiffraction_detector_6_exit_volume_material_string
#define priority mccdiffraction_detector_6_exit_volume_priority
#define xwidth mccdiffraction_detector_6_exit_volume_xwidth
#define yheight mccdiffraction_detector_6_exit_volume_yheight
#define zdepth mccdiffraction_detector_6_exit_volume_zdepth
#define xwidth2 mccdiffraction_detector_6_exit_volume_xwidth2
#define yheight2 mccdiffraction_detector_6_exit_volume_yheight2
#define visualize mccdiffraction_detector_6_exit_volume_visualize
#define target_index mccdiffraction_detector_6_exit_volume_target_index
#define target_x mccdiffraction_detector_6_exit_volume_target_x
#define target_y mccdiffraction_detector_6_exit_volume_target_y
#define target_z mccdiffraction_detector_6_exit_volume_target_z
#define focus_aw mccdiffraction_detector_6_exit_volume_focus_aw
#define focus_ah mccdiffraction_detector_6_exit_volume_focus_ah
#define focus_xw mccdiffraction_detector_6_exit_volume_focus_xw
#define focus_xh mccdiffraction_detector_6_exit_volume_focus_xh
#define focus_r mccdiffraction_detector_6_exit_volume_focus_r
#define p_interact mccdiffraction_detector_6_exit_volume_p_interact
#define mask_string mccdiffraction_detector_6_exit_volume_mask_string
#define mask_setting mccdiffraction_detector_6_exit_volume_mask_setting
#define number_of_activations mccdiffraction_detector_6_exit_volume_number_of_activations
#line 224 "Union_box.comp"
{
// Initializes the focusing system for this volume including input sanitation.
focus_initialize(&this_box_volume.geometry, POS_A_COMP_INDEX(INDEX_CURRENT_COMP+target_index), POS_A_CURRENT_COMP, ROT_A_CURRENT_COMP, target_index, target_x, target_y, target_z, focus_aw, focus_ah, focus_xw, focus_xh, focus_r, NAME_CURRENT_COMP);

// Input sanitation for this geometry
if (xwidth <= 0) {
  printf("\nERROR in Union_box named %s, the xwidth is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (yheight <= 0) {
  printf("\nERROR in Union_box named %s, yheight is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (zdepth <= 0) {
  printf("\nERROR in Union_box named %s, zdepth is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (xwidth2 <= 0 && xwidth2 != -1) {
  printf("\nERROR in Union_box named %s, the xwidth2 is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (yheight2 <= 0 && yheight2 != -1) {
  printf("\nERROR in Union_box named %s, yheight2 is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}

// Use sanitation
if (global_material_list.num_elements == 0) {
  printf("\nERROR: Need to define a material using Union_make_material before using a Union geometry component. \n");
  printf("       %s was defined before first use of Union_make_material.\n",NAME_CURRENT_COMP);
  exit(1);
}

this_box_volume.geometry.is_masked_volume = 0;
this_box_volume.geometry.is_exit_volume = 0;
this_box_volume.geometry.is_mask_volume = 0;
// check if the volume is a mask, if it is the material string is irelevant.
if (mask_string && strlen(mask_string) && strcmp(mask_string, "NULL") && strcmp(mask_string, "0")) {
    // A mask volume is used to limit the extend of other volumes, called the masked volumes. These are specified in the mask_string.
    // In order for a ray to enter a masked volume, it needs to be both in the region covered by that volume AND the mask volume.
    // When more than
    this_box_volume.geometry.mask_mode = 1; // Default is mask mode is ALL
    if (mask_setting && strlen(mask_setting) && strcmp(mask_setting, "NULL") && strcmp(mask_setting, "0")) {
        if (strcmp(mask_setting,"ALL") == 0 || strcmp(mask_setting,"All") == 0) this_box_volume.geometry.mask_mode = 1;
        else if (strcmp(mask_setting,"ANY") == 0 || strcmp(mask_setting,"Any") == 0) this_box_volume.geometry.mask_mode = 2;
        else {
            printf("The mask_mode of component %s is set to %s, but must be either ALL or ANY.\n",NAME_CURRENT_COMP,mask_setting);
            exit(1);
        }
    }
    
    for (loop_index=0;loop_index<global_geometry_list.num_elements;loop_index++) {
        // Add mask list
        if (1 == manual_linking_function(global_geometry_list.elements[loop_index].name,mask_string)) {
            add_element_to_int_list(&this_box_volume.geometry.mask_list,global_geometry_list.elements[loop_index].component_index);
            add_element_to_int_list(&global_geometry_list.elements[loop_index].Volume->geometry.masked_by_list,INDEX_CURRENT_COMP);
            global_geometry_list.elements[loop_index].Volume->geometry.is_masked_volume = 1;
            if (this_box_volume.geometry.mask_mode == 2)
                global_geometry_list.elements[loop_index].Volume->geometry.mask_mode = 2;
            if (this_box_volume.geometry.mask_mode == 1) {
                if (global_geometry_list.elements[loop_index].Volume->geometry.is_masked_volume == 1 && global_geometry_list.elements[loop_index].Volume->geometry.mask_mode != 2)
                    // If more than one mask is added to one volume, the ANY mode overwrites the (default) ALL mode.
                    global_geometry_list.elements[loop_index].Volume->geometry.mask_mode = 1;
            }
            
            found_geometries = 1;
        }
    }
    if (found_geometries == 0) {
        printf("The mask_string in geometry: %s did not find any of the specified volumes in the mask_string %s \n",NAME_CURRENT_COMP,mask_string);
        exit(1);
    }
    this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
    this_box_volume.p_physics->is_vacuum = 0; // Makes this volume a vacuum
    this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
    this_box_volume.p_physics->my_a = 0; // Should not be used.
    sprintf(this_box_volume.p_physics->name,"Mask");
    this_box_volume.geometry.is_mask_volume = 1;
    
    
// Read the material input, or if it lacks, use automatic linking.
} else if (material_string && strlen(material_string) && strcmp(material_string, "NULL") && strcmp(material_string, "0")) {
    // A geometry string was given, use it to determine which material
    if (0 == strcmp(material_string,"vacuum") || 0 == strcmp(material_string,"Vacuum")) {
        // One could have a global physics struct for vacuum instead of creating one for each
        this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
        this_box_volume.p_physics->is_vacuum = 1; // Makes this volume a vacuum
        this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
        this_box_volume.p_physics->my_a = 0; // Should not be used.
        sprintf(this_box_volume.p_physics->name,"Vacuum");
    } else if (0 == strcmp(material_string,"exit") || 0 == strcmp(material_string,"Exit")) {
        // One could have a global physics struct for vacuum instead of creating one for each
        this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
        this_box_volume.p_physics->is_vacuum = 1; // Makes this volume a vacuum
        this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
        this_box_volume.p_physics->my_a = 0; // Should not be used.
        this_box_volume.geometry.is_exit_volume = 1;
        sprintf(this_box_volume.p_physics->name,"Exit");
    } else {
        #ifndef MATERIAL_DETECTOR
            printf("Need to define a material before refering to it in a geometry %s.\n",NAME_CURRENT_COMP);
            exit(1);
        #endif
        for (loop_index=0;loop_index<global_material_list.num_elements;loop_index++) {
            if (0 == strcmp(material_string,global_material_list.elements[loop_index].name)) {
                this_box_volume.p_physics = global_material_list.elements[loop_index].physics;
                break;
            }
            if (loop_index == global_material_list.num_elements-1) {
            printf("\n");
            printf("ERROR: The material string \"%s\" in Union geometry \"%s\" did not match a specified material. \n",material_string,NAME_CURRENT_COMP);
            printf("       The materials available at this point (need to be defined before the geometry): \n");
            for (loop_index=0;loop_index<global_material_list.num_elements;loop_index++)
              printf("         %s\n",global_material_list.elements[loop_index].name);
            printf("\n");
            printf("       It is also possible to use one of the defualt materials avaiable: \n");
            printf("           Vacuum (for a Volume without scattering or absorption)\n");
            printf("           Exit (for a Volume where the ray exits the component if it enters)\n");
            printf("           Mask (for a Volume that masks existing volumes specified in the mask_string\n");
            exit(1);
          }
        }
    }
} else {
    // Automatic linking, simply using the last defined material.
    #ifndef MATERIAL_DETECTOR
        printf("Need to define a material before the geometry to use automatic linking %s.\n",NAME_CURRENT_COMP);
        exit(1);
    #endif
    this_box_volume.p_physics = global_material_list.elements[global_material_list.num_elements-1].physics;
}

sprintf(this_box_volume.name,NAME_CURRENT_COMP);
sprintf(this_box_volume.geometry.shape,"box");
this_box_volume.geometry.priority_value = priority;
this_box_volume.geometry.geometry_p_interact = p_interact;
// Currently the coordinates will be in absolute space.
this_box_volume.geometry.center = POS_A_CURRENT_COMP;

this_box_storage.z_depth = zdepth;
this_box_storage.x_width1 = xwidth;
this_box_storage.y_height1 = yheight;

this_box_storage.is_rectangle = 0;
if (xwidth2 < 0 && yheight2 < 0) this_box_storage.is_rectangle = 1;
if (xwidth == xwidth2 && yheight == yheight2) this_box_storage.is_rectangle = 1;

if (xwidth2 < 0) {
    this_box_storage.x_width2 = xwidth;
    xwidth2 = xwidth;
} else this_box_storage.x_width2 = xwidth2;

if (yheight2 < 0) {
    this_box_storage.y_height2 = yheight;
    yheight2 = yheight;
} else this_box_storage.y_height2 = yheight2;


this_box_storage.normal_vectors[0] = coords_set(0,0,1);
this_box_storage.normal_vectors[1] = coords_set(0,0,1);

// for sides with y component = 0
x_component = 2*zdepth/sqrt((xwidth-xwidth2)*(xwidth-xwidth2)+4*zdepth*zdepth);
z_component = (xwidth-xwidth2)/sqrt(4*zdepth*zdepth+(xwidth-xwidth2)*(xwidth-xwidth2));

this_box_storage.normal_vectors[2] = coords_set(x_component,0,z_component);
this_box_storage.normal_vectors[3] = coords_set(-x_component,0,z_component);

// for sides with x component = 0
y_component = 2*zdepth/sqrt((yheight-yheight2)*(yheight-yheight2)+4*zdepth*zdepth);
z_component = (yheight-yheight2)/sqrt(4*zdepth*zdepth+(yheight-yheight2)*(yheight-yheight2));

this_box_storage.normal_vectors[4] = coords_set(0,y_component,z_component);
this_box_storage.normal_vectors[5] = coords_set(0,-y_component,z_component);

this_box_volume.geometry.visualization_on = visualize;

this_box_volume.geometry.geometry_parameters.p_box_storage = &this_box_storage;

// Assign pointers to functions for intersection with the shape, checking if a point is inside the shape
if (this_box_storage.is_rectangle == 1) {
this_box_volume.geometry.intersect_function = &sample_box_intersect_simple;
this_box_volume.geometry.within_function = &r_within_box_simple;
}
else {
this_box_volume.geometry.intersect_function = &sample_box_intersect_advanced;
this_box_volume.geometry.within_function = &r_within_box_advanced;
}

this_box_volume.geometry.shell_points = &box_shell_points;
this_box_volume.geometry.mcdisplay_function = &mcdisplay_box_function;
this_box_volume.geometry.initialize_from_main_function = &initialize_box_geometry_from_main_component;
this_box_volume.geometry.process_rot_allocated = 0;

this_box_volume.geometry.copy_geometry_parameters = &allocate_box_storage_copy;

rot_copy(this_box_volume.geometry.rotation_matrix,ROT_A_CURRENT_COMP); //check how ROT_R_CURRENT_COMP would work
rot_transpose(ROT_A_CURRENT_COMP,this_box_volume.geometry.transpose_rotation_matrix);

// Initialize loggers
this_box_volume.loggers.num_elements = 0;

// packing the information into the global_geometry_element, which is then included in the global_geometry_list.
sprintf(global_geometry_element.name,NAME_CURRENT_COMP);
global_geometry_element.activation_counter = number_of_activations;
global_geometry_element.component_index = INDEX_CURRENT_COMP;
global_geometry_element.Volume = &this_box_volume; // Would be nicer if this m was a pointer, now we have the (small) data two places
add_element_to_geometry_list(&global_geometry_list,global_geometry_element);
}
#line 225881 "MACS_sample_kidney_box.c"
#undef number_of_activations
#undef mask_setting
#undef mask_string
#undef p_interact
#undef focus_r
#undef focus_xh
#undef focus_xw
#undef focus_ah
#undef focus_aw
#undef target_z
#undef target_y
#undef target_x
#undef target_index
#undef visualize
#undef yheight2
#undef xwidth2
#undef zdepth
#undef yheight
#undef xwidth
#undef priority
#undef material_string
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

  /* Initializations for component spec_detector_6_exit_volume. */
  SIG_MESSAGE("spec_detector_6_exit_volume (Init)");
#define mccompcurname  spec_detector_6_exit_volume
#define mccompcurtype  Union_box
#define mccompcurindex 389
#define loop_index mccspec_detector_6_exit_volume_loop_index
#define this_box_volume mccspec_detector_6_exit_volume_this_box_volume
#define global_geometry_element mccspec_detector_6_exit_volume_global_geometry_element
#define this_box_storage mccspec_detector_6_exit_volume_this_box_storage
#define material_string mccspec_detector_6_exit_volume_material_string
#define priority mccspec_detector_6_exit_volume_priority
#define xwidth mccspec_detector_6_exit_volume_xwidth
#define yheight mccspec_detector_6_exit_volume_yheight
#define zdepth mccspec_detector_6_exit_volume_zdepth
#define xwidth2 mccspec_detector_6_exit_volume_xwidth2
#define yheight2 mccspec_detector_6_exit_volume_yheight2
#define visualize mccspec_detector_6_exit_volume_visualize
#define target_index mccspec_detector_6_exit_volume_target_index
#define target_x mccspec_detector_6_exit_volume_target_x
#define target_y mccspec_detector_6_exit_volume_target_y
#define target_z mccspec_detector_6_exit_volume_target_z
#define focus_aw mccspec_detector_6_exit_volume_focus_aw
#define focus_ah mccspec_detector_6_exit_volume_focus_ah
#define focus_xw mccspec_detector_6_exit_volume_focus_xw
#define focus_xh mccspec_detector_6_exit_volume_focus_xh
#define focus_r mccspec_detector_6_exit_volume_focus_r
#define p_interact mccspec_detector_6_exit_volume_p_interact
#define mask_string mccspec_detector_6_exit_volume_mask_string
#define mask_setting mccspec_detector_6_exit_volume_mask_setting
#define number_of_activations mccspec_detector_6_exit_volume_number_of_activations
#line 224 "Union_box.comp"
{
// Initializes the focusing system for this volume including input sanitation.
focus_initialize(&this_box_volume.geometry, POS_A_COMP_INDEX(INDEX_CURRENT_COMP+target_index), POS_A_CURRENT_COMP, ROT_A_CURRENT_COMP, target_index, target_x, target_y, target_z, focus_aw, focus_ah, focus_xw, focus_xh, focus_r, NAME_CURRENT_COMP);

// Input sanitation for this geometry
if (xwidth <= 0) {
  printf("\nERROR in Union_box named %s, the xwidth is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (yheight <= 0) {
  printf("\nERROR in Union_box named %s, yheight is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (zdepth <= 0) {
  printf("\nERROR in Union_box named %s, zdepth is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (xwidth2 <= 0 && xwidth2 != -1) {
  printf("\nERROR in Union_box named %s, the xwidth2 is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (yheight2 <= 0 && yheight2 != -1) {
  printf("\nERROR in Union_box named %s, yheight2 is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}

// Use sanitation
if (global_material_list.num_elements == 0) {
  printf("\nERROR: Need to define a material using Union_make_material before using a Union geometry component. \n");
  printf("       %s was defined before first use of Union_make_material.\n",NAME_CURRENT_COMP);
  exit(1);
}

this_box_volume.geometry.is_masked_volume = 0;
this_box_volume.geometry.is_exit_volume = 0;
this_box_volume.geometry.is_mask_volume = 0;
// check if the volume is a mask, if it is the material string is irelevant.
if (mask_string && strlen(mask_string) && strcmp(mask_string, "NULL") && strcmp(mask_string, "0")) {
    // A mask volume is used to limit the extend of other volumes, called the masked volumes. These are specified in the mask_string.
    // In order for a ray to enter a masked volume, it needs to be both in the region covered by that volume AND the mask volume.
    // When more than
    this_box_volume.geometry.mask_mode = 1; // Default is mask mode is ALL
    if (mask_setting && strlen(mask_setting) && strcmp(mask_setting, "NULL") && strcmp(mask_setting, "0")) {
        if (strcmp(mask_setting,"ALL") == 0 || strcmp(mask_setting,"All") == 0) this_box_volume.geometry.mask_mode = 1;
        else if (strcmp(mask_setting,"ANY") == 0 || strcmp(mask_setting,"Any") == 0) this_box_volume.geometry.mask_mode = 2;
        else {
            printf("The mask_mode of component %s is set to %s, but must be either ALL or ANY.\n",NAME_CURRENT_COMP,mask_setting);
            exit(1);
        }
    }
    
    for (loop_index=0;loop_index<global_geometry_list.num_elements;loop_index++) {
        // Add mask list
        if (1 == manual_linking_function(global_geometry_list.elements[loop_index].name,mask_string)) {
            add_element_to_int_list(&this_box_volume.geometry.mask_list,global_geometry_list.elements[loop_index].component_index);
            add_element_to_int_list(&global_geometry_list.elements[loop_index].Volume->geometry.masked_by_list,INDEX_CURRENT_COMP);
            global_geometry_list.elements[loop_index].Volume->geometry.is_masked_volume = 1;
            if (this_box_volume.geometry.mask_mode == 2)
                global_geometry_list.elements[loop_index].Volume->geometry.mask_mode = 2;
            if (this_box_volume.geometry.mask_mode == 1) {
                if (global_geometry_list.elements[loop_index].Volume->geometry.is_masked_volume == 1 && global_geometry_list.elements[loop_index].Volume->geometry.mask_mode != 2)
                    // If more than one mask is added to one volume, the ANY mode overwrites the (default) ALL mode.
                    global_geometry_list.elements[loop_index].Volume->geometry.mask_mode = 1;
            }
            
            found_geometries = 1;
        }
    }
    if (found_geometries == 0) {
        printf("The mask_string in geometry: %s did not find any of the specified volumes in the mask_string %s \n",NAME_CURRENT_COMP,mask_string);
        exit(1);
    }
    this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
    this_box_volume.p_physics->is_vacuum = 0; // Makes this volume a vacuum
    this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
    this_box_volume.p_physics->my_a = 0; // Should not be used.
    sprintf(this_box_volume.p_physics->name,"Mask");
    this_box_volume.geometry.is_mask_volume = 1;
    
    
// Read the material input, or if it lacks, use automatic linking.
} else if (material_string && strlen(material_string) && strcmp(material_string, "NULL") && strcmp(material_string, "0")) {
    // A geometry string was given, use it to determine which material
    if (0 == strcmp(material_string,"vacuum") || 0 == strcmp(material_string,"Vacuum")) {
        // One could have a global physics struct for vacuum instead of creating one for each
        this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
        this_box_volume.p_physics->is_vacuum = 1; // Makes this volume a vacuum
        this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
        this_box_volume.p_physics->my_a = 0; // Should not be used.
        sprintf(this_box_volume.p_physics->name,"Vacuum");
    } else if (0 == strcmp(material_string,"exit") || 0 == strcmp(material_string,"Exit")) {
        // One could have a global physics struct for vacuum instead of creating one for each
        this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
        this_box_volume.p_physics->is_vacuum = 1; // Makes this volume a vacuum
        this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
        this_box_volume.p_physics->my_a = 0; // Should not be used.
        this_box_volume.geometry.is_exit_volume = 1;
        sprintf(this_box_volume.p_physics->name,"Exit");
    } else {
        #ifndef MATERIAL_DETECTOR
            printf("Need to define a material before refering to it in a geometry %s.\n",NAME_CURRENT_COMP);
            exit(1);
        #endif
        for (loop_index=0;loop_index<global_material_list.num_elements;loop_index++) {
            if (0 == strcmp(material_string,global_material_list.elements[loop_index].name)) {
                this_box_volume.p_physics = global_material_list.elements[loop_index].physics;
                break;
            }
            if (loop_index == global_material_list.num_elements-1) {
            printf("\n");
            printf("ERROR: The material string \"%s\" in Union geometry \"%s\" did not match a specified material. \n",material_string,NAME_CURRENT_COMP);
            printf("       The materials available at this point (need to be defined before the geometry): \n");
            for (loop_index=0;loop_index<global_material_list.num_elements;loop_index++)
              printf("         %s\n",global_material_list.elements[loop_index].name);
            printf("\n");
            printf("       It is also possible to use one of the defualt materials avaiable: \n");
            printf("           Vacuum (for a Volume without scattering or absorption)\n");
            printf("           Exit (for a Volume where the ray exits the component if it enters)\n");
            printf("           Mask (for a Volume that masks existing volumes specified in the mask_string\n");
            exit(1);
          }
        }
    }
} else {
    // Automatic linking, simply using the last defined material.
    #ifndef MATERIAL_DETECTOR
        printf("Need to define a material before the geometry to use automatic linking %s.\n",NAME_CURRENT_COMP);
        exit(1);
    #endif
    this_box_volume.p_physics = global_material_list.elements[global_material_list.num_elements-1].physics;
}

sprintf(this_box_volume.name,NAME_CURRENT_COMP);
sprintf(this_box_volume.geometry.shape,"box");
this_box_volume.geometry.priority_value = priority;
this_box_volume.geometry.geometry_p_interact = p_interact;
// Currently the coordinates will be in absolute space.
this_box_volume.geometry.center = POS_A_CURRENT_COMP;

this_box_storage.z_depth = zdepth;
this_box_storage.x_width1 = xwidth;
this_box_storage.y_height1 = yheight;

this_box_storage.is_rectangle = 0;
if (xwidth2 < 0 && yheight2 < 0) this_box_storage.is_rectangle = 1;
if (xwidth == xwidth2 && yheight == yheight2) this_box_storage.is_rectangle = 1;

if (xwidth2 < 0) {
    this_box_storage.x_width2 = xwidth;
    xwidth2 = xwidth;
} else this_box_storage.x_width2 = xwidth2;

if (yheight2 < 0) {
    this_box_storage.y_height2 = yheight;
    yheight2 = yheight;
} else this_box_storage.y_height2 = yheight2;


this_box_storage.normal_vectors[0] = coords_set(0,0,1);
this_box_storage.normal_vectors[1] = coords_set(0,0,1);

// for sides with y component = 0
x_component = 2*zdepth/sqrt((xwidth-xwidth2)*(xwidth-xwidth2)+4*zdepth*zdepth);
z_component = (xwidth-xwidth2)/sqrt(4*zdepth*zdepth+(xwidth-xwidth2)*(xwidth-xwidth2));

this_box_storage.normal_vectors[2] = coords_set(x_component,0,z_component);
this_box_storage.normal_vectors[3] = coords_set(-x_component,0,z_component);

// for sides with x component = 0
y_component = 2*zdepth/sqrt((yheight-yheight2)*(yheight-yheight2)+4*zdepth*zdepth);
z_component = (yheight-yheight2)/sqrt(4*zdepth*zdepth+(yheight-yheight2)*(yheight-yheight2));

this_box_storage.normal_vectors[4] = coords_set(0,y_component,z_component);
this_box_storage.normal_vectors[5] = coords_set(0,-y_component,z_component);

this_box_volume.geometry.visualization_on = visualize;

this_box_volume.geometry.geometry_parameters.p_box_storage = &this_box_storage;

// Assign pointers to functions for intersection with the shape, checking if a point is inside the shape
if (this_box_storage.is_rectangle == 1) {
this_box_volume.geometry.intersect_function = &sample_box_intersect_simple;
this_box_volume.geometry.within_function = &r_within_box_simple;
}
else {
this_box_volume.geometry.intersect_function = &sample_box_intersect_advanced;
this_box_volume.geometry.within_function = &r_within_box_advanced;
}

this_box_volume.geometry.shell_points = &box_shell_points;
this_box_volume.geometry.mcdisplay_function = &mcdisplay_box_function;
this_box_volume.geometry.initialize_from_main_function = &initialize_box_geometry_from_main_component;
this_box_volume.geometry.process_rot_allocated = 0;

this_box_volume.geometry.copy_geometry_parameters = &allocate_box_storage_copy;

rot_copy(this_box_volume.geometry.rotation_matrix,ROT_A_CURRENT_COMP); //check how ROT_R_CURRENT_COMP would work
rot_transpose(ROT_A_CURRENT_COMP,this_box_volume.geometry.transpose_rotation_matrix);

// Initialize loggers
this_box_volume.loggers.num_elements = 0;

// packing the information into the global_geometry_element, which is then included in the global_geometry_list.
sprintf(global_geometry_element.name,NAME_CURRENT_COMP);
global_geometry_element.activation_counter = number_of_activations;
global_geometry_element.component_index = INDEX_CURRENT_COMP;
global_geometry_element.Volume = &this_box_volume; // Would be nicer if this m was a pointer, now we have the (small) data two places
add_element_to_geometry_list(&global_geometry_list,global_geometry_element);
}
#line 226151 "MACS_sample_kidney_box.c"
#undef number_of_activations
#undef mask_setting
#undef mask_string
#undef p_interact
#undef focus_r
#undef focus_xh
#undef focus_xw
#undef focus_ah
#undef focus_aw
#undef target_z
#undef target_y
#undef target_x
#undef target_index
#undef visualize
#undef yheight2
#undef xwidth2
#undef zdepth
#undef yheight
#undef xwidth
#undef priority
#undef material_string
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

  /* Initializations for component channel_7_cave1_box1. */
  SIG_MESSAGE("channel_7_cave1_box1 (Init)");
#define mccompcurname  channel_7_cave1_box1
#define mccompcurtype  Union_box
#define mccompcurindex 390
#define loop_index mccchannel_7_cave1_box1_loop_index
#define this_box_volume mccchannel_7_cave1_box1_this_box_volume
#define global_geometry_element mccchannel_7_cave1_box1_global_geometry_element
#define this_box_storage mccchannel_7_cave1_box1_this_box_storage
#define material_string mccchannel_7_cave1_box1_material_string
#define priority mccchannel_7_cave1_box1_priority
#define xwidth mccchannel_7_cave1_box1_xwidth
#define yheight mccchannel_7_cave1_box1_yheight
#define zdepth mccchannel_7_cave1_box1_zdepth
#define xwidth2 mccchannel_7_cave1_box1_xwidth2
#define yheight2 mccchannel_7_cave1_box1_yheight2
#define visualize mccchannel_7_cave1_box1_visualize
#define target_index mccchannel_7_cave1_box1_target_index
#define target_x mccchannel_7_cave1_box1_target_x
#define target_y mccchannel_7_cave1_box1_target_y
#define target_z mccchannel_7_cave1_box1_target_z
#define focus_aw mccchannel_7_cave1_box1_focus_aw
#define focus_ah mccchannel_7_cave1_box1_focus_ah
#define focus_xw mccchannel_7_cave1_box1_focus_xw
#define focus_xh mccchannel_7_cave1_box1_focus_xh
#define focus_r mccchannel_7_cave1_box1_focus_r
#define p_interact mccchannel_7_cave1_box1_p_interact
#define mask_string mccchannel_7_cave1_box1_mask_string
#define mask_setting mccchannel_7_cave1_box1_mask_setting
#define number_of_activations mccchannel_7_cave1_box1_number_of_activations
#line 224 "Union_box.comp"
{
// Initializes the focusing system for this volume including input sanitation.
focus_initialize(&this_box_volume.geometry, POS_A_COMP_INDEX(INDEX_CURRENT_COMP+target_index), POS_A_CURRENT_COMP, ROT_A_CURRENT_COMP, target_index, target_x, target_y, target_z, focus_aw, focus_ah, focus_xw, focus_xh, focus_r, NAME_CURRENT_COMP);

// Input sanitation for this geometry
if (xwidth <= 0) {
  printf("\nERROR in Union_box named %s, the xwidth is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (yheight <= 0) {
  printf("\nERROR in Union_box named %s, yheight is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (zdepth <= 0) {
  printf("\nERROR in Union_box named %s, zdepth is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (xwidth2 <= 0 && xwidth2 != -1) {
  printf("\nERROR in Union_box named %s, the xwidth2 is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (yheight2 <= 0 && yheight2 != -1) {
  printf("\nERROR in Union_box named %s, yheight2 is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}

// Use sanitation
if (global_material_list.num_elements == 0) {
  printf("\nERROR: Need to define a material using Union_make_material before using a Union geometry component. \n");
  printf("       %s was defined before first use of Union_make_material.\n",NAME_CURRENT_COMP);
  exit(1);
}

this_box_volume.geometry.is_masked_volume = 0;
this_box_volume.geometry.is_exit_volume = 0;
this_box_volume.geometry.is_mask_volume = 0;
// check if the volume is a mask, if it is the material string is irelevant.
if (mask_string && strlen(mask_string) && strcmp(mask_string, "NULL") && strcmp(mask_string, "0")) {
    // A mask volume is used to limit the extend of other volumes, called the masked volumes. These are specified in the mask_string.
    // In order for a ray to enter a masked volume, it needs to be both in the region covered by that volume AND the mask volume.
    // When more than
    this_box_volume.geometry.mask_mode = 1; // Default is mask mode is ALL
    if (mask_setting && strlen(mask_setting) && strcmp(mask_setting, "NULL") && strcmp(mask_setting, "0")) {
        if (strcmp(mask_setting,"ALL") == 0 || strcmp(mask_setting,"All") == 0) this_box_volume.geometry.mask_mode = 1;
        else if (strcmp(mask_setting,"ANY") == 0 || strcmp(mask_setting,"Any") == 0) this_box_volume.geometry.mask_mode = 2;
        else {
            printf("The mask_mode of component %s is set to %s, but must be either ALL or ANY.\n",NAME_CURRENT_COMP,mask_setting);
            exit(1);
        }
    }
    
    for (loop_index=0;loop_index<global_geometry_list.num_elements;loop_index++) {
        // Add mask list
        if (1 == manual_linking_function(global_geometry_list.elements[loop_index].name,mask_string)) {
            add_element_to_int_list(&this_box_volume.geometry.mask_list,global_geometry_list.elements[loop_index].component_index);
            add_element_to_int_list(&global_geometry_list.elements[loop_index].Volume->geometry.masked_by_list,INDEX_CURRENT_COMP);
            global_geometry_list.elements[loop_index].Volume->geometry.is_masked_volume = 1;
            if (this_box_volume.geometry.mask_mode == 2)
                global_geometry_list.elements[loop_index].Volume->geometry.mask_mode = 2;
            if (this_box_volume.geometry.mask_mode == 1) {
                if (global_geometry_list.elements[loop_index].Volume->geometry.is_masked_volume == 1 && global_geometry_list.elements[loop_index].Volume->geometry.mask_mode != 2)
                    // If more than one mask is added to one volume, the ANY mode overwrites the (default) ALL mode.
                    global_geometry_list.elements[loop_index].Volume->geometry.mask_mode = 1;
            }
            
            found_geometries = 1;
        }
    }
    if (found_geometries == 0) {
        printf("The mask_string in geometry: %s did not find any of the specified volumes in the mask_string %s \n",NAME_CURRENT_COMP,mask_string);
        exit(1);
    }
    this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
    this_box_volume.p_physics->is_vacuum = 0; // Makes this volume a vacuum
    this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
    this_box_volume.p_physics->my_a = 0; // Should not be used.
    sprintf(this_box_volume.p_physics->name,"Mask");
    this_box_volume.geometry.is_mask_volume = 1;
    
    
// Read the material input, or if it lacks, use automatic linking.
} else if (material_string && strlen(material_string) && strcmp(material_string, "NULL") && strcmp(material_string, "0")) {
    // A geometry string was given, use it to determine which material
    if (0 == strcmp(material_string,"vacuum") || 0 == strcmp(material_string,"Vacuum")) {
        // One could have a global physics struct for vacuum instead of creating one for each
        this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
        this_box_volume.p_physics->is_vacuum = 1; // Makes this volume a vacuum
        this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
        this_box_volume.p_physics->my_a = 0; // Should not be used.
        sprintf(this_box_volume.p_physics->name,"Vacuum");
    } else if (0 == strcmp(material_string,"exit") || 0 == strcmp(material_string,"Exit")) {
        // One could have a global physics struct for vacuum instead of creating one for each
        this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
        this_box_volume.p_physics->is_vacuum = 1; // Makes this volume a vacuum
        this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
        this_box_volume.p_physics->my_a = 0; // Should not be used.
        this_box_volume.geometry.is_exit_volume = 1;
        sprintf(this_box_volume.p_physics->name,"Exit");
    } else {
        #ifndef MATERIAL_DETECTOR
            printf("Need to define a material before refering to it in a geometry %s.\n",NAME_CURRENT_COMP);
            exit(1);
        #endif
        for (loop_index=0;loop_index<global_material_list.num_elements;loop_index++) {
            if (0 == strcmp(material_string,global_material_list.elements[loop_index].name)) {
                this_box_volume.p_physics = global_material_list.elements[loop_index].physics;
                break;
            }
            if (loop_index == global_material_list.num_elements-1) {
            printf("\n");
            printf("ERROR: The material string \"%s\" in Union geometry \"%s\" did not match a specified material. \n",material_string,NAME_CURRENT_COMP);
            printf("       The materials available at this point (need to be defined before the geometry): \n");
            for (loop_index=0;loop_index<global_material_list.num_elements;loop_index++)
              printf("         %s\n",global_material_list.elements[loop_index].name);
            printf("\n");
            printf("       It is also possible to use one of the defualt materials avaiable: \n");
            printf("           Vacuum (for a Volume without scattering or absorption)\n");
            printf("           Exit (for a Volume where the ray exits the component if it enters)\n");
            printf("           Mask (for a Volume that masks existing volumes specified in the mask_string\n");
            exit(1);
          }
        }
    }
} else {
    // Automatic linking, simply using the last defined material.
    #ifndef MATERIAL_DETECTOR
        printf("Need to define a material before the geometry to use automatic linking %s.\n",NAME_CURRENT_COMP);
        exit(1);
    #endif
    this_box_volume.p_physics = global_material_list.elements[global_material_list.num_elements-1].physics;
}

sprintf(this_box_volume.name,NAME_CURRENT_COMP);
sprintf(this_box_volume.geometry.shape,"box");
this_box_volume.geometry.priority_value = priority;
this_box_volume.geometry.geometry_p_interact = p_interact;
// Currently the coordinates will be in absolute space.
this_box_volume.geometry.center = POS_A_CURRENT_COMP;

this_box_storage.z_depth = zdepth;
this_box_storage.x_width1 = xwidth;
this_box_storage.y_height1 = yheight;

this_box_storage.is_rectangle = 0;
if (xwidth2 < 0 && yheight2 < 0) this_box_storage.is_rectangle = 1;
if (xwidth == xwidth2 && yheight == yheight2) this_box_storage.is_rectangle = 1;

if (xwidth2 < 0) {
    this_box_storage.x_width2 = xwidth;
    xwidth2 = xwidth;
} else this_box_storage.x_width2 = xwidth2;

if (yheight2 < 0) {
    this_box_storage.y_height2 = yheight;
    yheight2 = yheight;
} else this_box_storage.y_height2 = yheight2;


this_box_storage.normal_vectors[0] = coords_set(0,0,1);
this_box_storage.normal_vectors[1] = coords_set(0,0,1);

// for sides with y component = 0
x_component = 2*zdepth/sqrt((xwidth-xwidth2)*(xwidth-xwidth2)+4*zdepth*zdepth);
z_component = (xwidth-xwidth2)/sqrt(4*zdepth*zdepth+(xwidth-xwidth2)*(xwidth-xwidth2));

this_box_storage.normal_vectors[2] = coords_set(x_component,0,z_component);
this_box_storage.normal_vectors[3] = coords_set(-x_component,0,z_component);

// for sides with x component = 0
y_component = 2*zdepth/sqrt((yheight-yheight2)*(yheight-yheight2)+4*zdepth*zdepth);
z_component = (yheight-yheight2)/sqrt(4*zdepth*zdepth+(yheight-yheight2)*(yheight-yheight2));

this_box_storage.normal_vectors[4] = coords_set(0,y_component,z_component);
this_box_storage.normal_vectors[5] = coords_set(0,-y_component,z_component);

this_box_volume.geometry.visualization_on = visualize;

this_box_volume.geometry.geometry_parameters.p_box_storage = &this_box_storage;

// Assign pointers to functions for intersection with the shape, checking if a point is inside the shape
if (this_box_storage.is_rectangle == 1) {
this_box_volume.geometry.intersect_function = &sample_box_intersect_simple;
this_box_volume.geometry.within_function = &r_within_box_simple;
}
else {
this_box_volume.geometry.intersect_function = &sample_box_intersect_advanced;
this_box_volume.geometry.within_function = &r_within_box_advanced;
}

this_box_volume.geometry.shell_points = &box_shell_points;
this_box_volume.geometry.mcdisplay_function = &mcdisplay_box_function;
this_box_volume.geometry.initialize_from_main_function = &initialize_box_geometry_from_main_component;
this_box_volume.geometry.process_rot_allocated = 0;

this_box_volume.geometry.copy_geometry_parameters = &allocate_box_storage_copy;

rot_copy(this_box_volume.geometry.rotation_matrix,ROT_A_CURRENT_COMP); //check how ROT_R_CURRENT_COMP would work
rot_transpose(ROT_A_CURRENT_COMP,this_box_volume.geometry.transpose_rotation_matrix);

// Initialize loggers
this_box_volume.loggers.num_elements = 0;

// packing the information into the global_geometry_element, which is then included in the global_geometry_list.
sprintf(global_geometry_element.name,NAME_CURRENT_COMP);
global_geometry_element.activation_counter = number_of_activations;
global_geometry_element.component_index = INDEX_CURRENT_COMP;
global_geometry_element.Volume = &this_box_volume; // Would be nicer if this m was a pointer, now we have the (small) data two places
add_element_to_geometry_list(&global_geometry_list,global_geometry_element);
}
#line 226421 "MACS_sample_kidney_box.c"
#undef number_of_activations
#undef mask_setting
#undef mask_string
#undef p_interact
#undef focus_r
#undef focus_xh
#undef focus_xw
#undef focus_ah
#undef focus_aw
#undef target_z
#undef target_y
#undef target_x
#undef target_index
#undef visualize
#undef yheight2
#undef xwidth2
#undef zdepth
#undef yheight
#undef xwidth
#undef priority
#undef material_string
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

  /* Initializations for component channel_7_cave1_box2. */
  SIG_MESSAGE("channel_7_cave1_box2 (Init)");
#define mccompcurname  channel_7_cave1_box2
#define mccompcurtype  Union_box
#define mccompcurindex 391
#define loop_index mccchannel_7_cave1_box2_loop_index
#define this_box_volume mccchannel_7_cave1_box2_this_box_volume
#define global_geometry_element mccchannel_7_cave1_box2_global_geometry_element
#define this_box_storage mccchannel_7_cave1_box2_this_box_storage
#define material_string mccchannel_7_cave1_box2_material_string
#define priority mccchannel_7_cave1_box2_priority
#define xwidth mccchannel_7_cave1_box2_xwidth
#define yheight mccchannel_7_cave1_box2_yheight
#define zdepth mccchannel_7_cave1_box2_zdepth
#define xwidth2 mccchannel_7_cave1_box2_xwidth2
#define yheight2 mccchannel_7_cave1_box2_yheight2
#define visualize mccchannel_7_cave1_box2_visualize
#define target_index mccchannel_7_cave1_box2_target_index
#define target_x mccchannel_7_cave1_box2_target_x
#define target_y mccchannel_7_cave1_box2_target_y
#define target_z mccchannel_7_cave1_box2_target_z
#define focus_aw mccchannel_7_cave1_box2_focus_aw
#define focus_ah mccchannel_7_cave1_box2_focus_ah
#define focus_xw mccchannel_7_cave1_box2_focus_xw
#define focus_xh mccchannel_7_cave1_box2_focus_xh
#define focus_r mccchannel_7_cave1_box2_focus_r
#define p_interact mccchannel_7_cave1_box2_p_interact
#define mask_string mccchannel_7_cave1_box2_mask_string
#define mask_setting mccchannel_7_cave1_box2_mask_setting
#define number_of_activations mccchannel_7_cave1_box2_number_of_activations
#line 224 "Union_box.comp"
{
// Initializes the focusing system for this volume including input sanitation.
focus_initialize(&this_box_volume.geometry, POS_A_COMP_INDEX(INDEX_CURRENT_COMP+target_index), POS_A_CURRENT_COMP, ROT_A_CURRENT_COMP, target_index, target_x, target_y, target_z, focus_aw, focus_ah, focus_xw, focus_xh, focus_r, NAME_CURRENT_COMP);

// Input sanitation for this geometry
if (xwidth <= 0) {
  printf("\nERROR in Union_box named %s, the xwidth is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (yheight <= 0) {
  printf("\nERROR in Union_box named %s, yheight is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (zdepth <= 0) {
  printf("\nERROR in Union_box named %s, zdepth is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (xwidth2 <= 0 && xwidth2 != -1) {
  printf("\nERROR in Union_box named %s, the xwidth2 is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (yheight2 <= 0 && yheight2 != -1) {
  printf("\nERROR in Union_box named %s, yheight2 is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}

// Use sanitation
if (global_material_list.num_elements == 0) {
  printf("\nERROR: Need to define a material using Union_make_material before using a Union geometry component. \n");
  printf("       %s was defined before first use of Union_make_material.\n",NAME_CURRENT_COMP);
  exit(1);
}

this_box_volume.geometry.is_masked_volume = 0;
this_box_volume.geometry.is_exit_volume = 0;
this_box_volume.geometry.is_mask_volume = 0;
// check if the volume is a mask, if it is the material string is irelevant.
if (mask_string && strlen(mask_string) && strcmp(mask_string, "NULL") && strcmp(mask_string, "0")) {
    // A mask volume is used to limit the extend of other volumes, called the masked volumes. These are specified in the mask_string.
    // In order for a ray to enter a masked volume, it needs to be both in the region covered by that volume AND the mask volume.
    // When more than
    this_box_volume.geometry.mask_mode = 1; // Default is mask mode is ALL
    if (mask_setting && strlen(mask_setting) && strcmp(mask_setting, "NULL") && strcmp(mask_setting, "0")) {
        if (strcmp(mask_setting,"ALL") == 0 || strcmp(mask_setting,"All") == 0) this_box_volume.geometry.mask_mode = 1;
        else if (strcmp(mask_setting,"ANY") == 0 || strcmp(mask_setting,"Any") == 0) this_box_volume.geometry.mask_mode = 2;
        else {
            printf("The mask_mode of component %s is set to %s, but must be either ALL or ANY.\n",NAME_CURRENT_COMP,mask_setting);
            exit(1);
        }
    }
    
    for (loop_index=0;loop_index<global_geometry_list.num_elements;loop_index++) {
        // Add mask list
        if (1 == manual_linking_function(global_geometry_list.elements[loop_index].name,mask_string)) {
            add_element_to_int_list(&this_box_volume.geometry.mask_list,global_geometry_list.elements[loop_index].component_index);
            add_element_to_int_list(&global_geometry_list.elements[loop_index].Volume->geometry.masked_by_list,INDEX_CURRENT_COMP);
            global_geometry_list.elements[loop_index].Volume->geometry.is_masked_volume = 1;
            if (this_box_volume.geometry.mask_mode == 2)
                global_geometry_list.elements[loop_index].Volume->geometry.mask_mode = 2;
            if (this_box_volume.geometry.mask_mode == 1) {
                if (global_geometry_list.elements[loop_index].Volume->geometry.is_masked_volume == 1 && global_geometry_list.elements[loop_index].Volume->geometry.mask_mode != 2)
                    // If more than one mask is added to one volume, the ANY mode overwrites the (default) ALL mode.
                    global_geometry_list.elements[loop_index].Volume->geometry.mask_mode = 1;
            }
            
            found_geometries = 1;
        }
    }
    if (found_geometries == 0) {
        printf("The mask_string in geometry: %s did not find any of the specified volumes in the mask_string %s \n",NAME_CURRENT_COMP,mask_string);
        exit(1);
    }
    this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
    this_box_volume.p_physics->is_vacuum = 0; // Makes this volume a vacuum
    this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
    this_box_volume.p_physics->my_a = 0; // Should not be used.
    sprintf(this_box_volume.p_physics->name,"Mask");
    this_box_volume.geometry.is_mask_volume = 1;
    
    
// Read the material input, or if it lacks, use automatic linking.
} else if (material_string && strlen(material_string) && strcmp(material_string, "NULL") && strcmp(material_string, "0")) {
    // A geometry string was given, use it to determine which material
    if (0 == strcmp(material_string,"vacuum") || 0 == strcmp(material_string,"Vacuum")) {
        // One could have a global physics struct for vacuum instead of creating one for each
        this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
        this_box_volume.p_physics->is_vacuum = 1; // Makes this volume a vacuum
        this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
        this_box_volume.p_physics->my_a = 0; // Should not be used.
        sprintf(this_box_volume.p_physics->name,"Vacuum");
    } else if (0 == strcmp(material_string,"exit") || 0 == strcmp(material_string,"Exit")) {
        // One could have a global physics struct for vacuum instead of creating one for each
        this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
        this_box_volume.p_physics->is_vacuum = 1; // Makes this volume a vacuum
        this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
        this_box_volume.p_physics->my_a = 0; // Should not be used.
        this_box_volume.geometry.is_exit_volume = 1;
        sprintf(this_box_volume.p_physics->name,"Exit");
    } else {
        #ifndef MATERIAL_DETECTOR
            printf("Need to define a material before refering to it in a geometry %s.\n",NAME_CURRENT_COMP);
            exit(1);
        #endif
        for (loop_index=0;loop_index<global_material_list.num_elements;loop_index++) {
            if (0 == strcmp(material_string,global_material_list.elements[loop_index].name)) {
                this_box_volume.p_physics = global_material_list.elements[loop_index].physics;
                break;
            }
            if (loop_index == global_material_list.num_elements-1) {
            printf("\n");
            printf("ERROR: The material string \"%s\" in Union geometry \"%s\" did not match a specified material. \n",material_string,NAME_CURRENT_COMP);
            printf("       The materials available at this point (need to be defined before the geometry): \n");
            for (loop_index=0;loop_index<global_material_list.num_elements;loop_index++)
              printf("         %s\n",global_material_list.elements[loop_index].name);
            printf("\n");
            printf("       It is also possible to use one of the defualt materials avaiable: \n");
            printf("           Vacuum (for a Volume without scattering or absorption)\n");
            printf("           Exit (for a Volume where the ray exits the component if it enters)\n");
            printf("           Mask (for a Volume that masks existing volumes specified in the mask_string\n");
            exit(1);
          }
        }
    }
} else {
    // Automatic linking, simply using the last defined material.
    #ifndef MATERIAL_DETECTOR
        printf("Need to define a material before the geometry to use automatic linking %s.\n",NAME_CURRENT_COMP);
        exit(1);
    #endif
    this_box_volume.p_physics = global_material_list.elements[global_material_list.num_elements-1].physics;
}

sprintf(this_box_volume.name,NAME_CURRENT_COMP);
sprintf(this_box_volume.geometry.shape,"box");
this_box_volume.geometry.priority_value = priority;
this_box_volume.geometry.geometry_p_interact = p_interact;
// Currently the coordinates will be in absolute space.
this_box_volume.geometry.center = POS_A_CURRENT_COMP;

this_box_storage.z_depth = zdepth;
this_box_storage.x_width1 = xwidth;
this_box_storage.y_height1 = yheight;

this_box_storage.is_rectangle = 0;
if (xwidth2 < 0 && yheight2 < 0) this_box_storage.is_rectangle = 1;
if (xwidth == xwidth2 && yheight == yheight2) this_box_storage.is_rectangle = 1;

if (xwidth2 < 0) {
    this_box_storage.x_width2 = xwidth;
    xwidth2 = xwidth;
} else this_box_storage.x_width2 = xwidth2;

if (yheight2 < 0) {
    this_box_storage.y_height2 = yheight;
    yheight2 = yheight;
} else this_box_storage.y_height2 = yheight2;


this_box_storage.normal_vectors[0] = coords_set(0,0,1);
this_box_storage.normal_vectors[1] = coords_set(0,0,1);

// for sides with y component = 0
x_component = 2*zdepth/sqrt((xwidth-xwidth2)*(xwidth-xwidth2)+4*zdepth*zdepth);
z_component = (xwidth-xwidth2)/sqrt(4*zdepth*zdepth+(xwidth-xwidth2)*(xwidth-xwidth2));

this_box_storage.normal_vectors[2] = coords_set(x_component,0,z_component);
this_box_storage.normal_vectors[3] = coords_set(-x_component,0,z_component);

// for sides with x component = 0
y_component = 2*zdepth/sqrt((yheight-yheight2)*(yheight-yheight2)+4*zdepth*zdepth);
z_component = (yheight-yheight2)/sqrt(4*zdepth*zdepth+(yheight-yheight2)*(yheight-yheight2));

this_box_storage.normal_vectors[4] = coords_set(0,y_component,z_component);
this_box_storage.normal_vectors[5] = coords_set(0,-y_component,z_component);

this_box_volume.geometry.visualization_on = visualize;

this_box_volume.geometry.geometry_parameters.p_box_storage = &this_box_storage;

// Assign pointers to functions for intersection with the shape, checking if a point is inside the shape
if (this_box_storage.is_rectangle == 1) {
this_box_volume.geometry.intersect_function = &sample_box_intersect_simple;
this_box_volume.geometry.within_function = &r_within_box_simple;
}
else {
this_box_volume.geometry.intersect_function = &sample_box_intersect_advanced;
this_box_volume.geometry.within_function = &r_within_box_advanced;
}

this_box_volume.geometry.shell_points = &box_shell_points;
this_box_volume.geometry.mcdisplay_function = &mcdisplay_box_function;
this_box_volume.geometry.initialize_from_main_function = &initialize_box_geometry_from_main_component;
this_box_volume.geometry.process_rot_allocated = 0;

this_box_volume.geometry.copy_geometry_parameters = &allocate_box_storage_copy;

rot_copy(this_box_volume.geometry.rotation_matrix,ROT_A_CURRENT_COMP); //check how ROT_R_CURRENT_COMP would work
rot_transpose(ROT_A_CURRENT_COMP,this_box_volume.geometry.transpose_rotation_matrix);

// Initialize loggers
this_box_volume.loggers.num_elements = 0;

// packing the information into the global_geometry_element, which is then included in the global_geometry_list.
sprintf(global_geometry_element.name,NAME_CURRENT_COMP);
global_geometry_element.activation_counter = number_of_activations;
global_geometry_element.component_index = INDEX_CURRENT_COMP;
global_geometry_element.Volume = &this_box_volume; // Would be nicer if this m was a pointer, now we have the (small) data two places
add_element_to_geometry_list(&global_geometry_list,global_geometry_element);
}
#line 226691 "MACS_sample_kidney_box.c"
#undef number_of_activations
#undef mask_setting
#undef mask_string
#undef p_interact
#undef focus_r
#undef focus_xh
#undef focus_xw
#undef focus_ah
#undef focus_aw
#undef target_z
#undef target_y
#undef target_x
#undef target_index
#undef visualize
#undef yheight2
#undef xwidth2
#undef zdepth
#undef yheight
#undef xwidth
#undef priority
#undef material_string
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

  /* Initializations for component channel_7_cave1_box3. */
  SIG_MESSAGE("channel_7_cave1_box3 (Init)");
#define mccompcurname  channel_7_cave1_box3
#define mccompcurtype  Union_box
#define mccompcurindex 392
#define loop_index mccchannel_7_cave1_box3_loop_index
#define this_box_volume mccchannel_7_cave1_box3_this_box_volume
#define global_geometry_element mccchannel_7_cave1_box3_global_geometry_element
#define this_box_storage mccchannel_7_cave1_box3_this_box_storage
#define material_string mccchannel_7_cave1_box3_material_string
#define priority mccchannel_7_cave1_box3_priority
#define xwidth mccchannel_7_cave1_box3_xwidth
#define yheight mccchannel_7_cave1_box3_yheight
#define zdepth mccchannel_7_cave1_box3_zdepth
#define xwidth2 mccchannel_7_cave1_box3_xwidth2
#define yheight2 mccchannel_7_cave1_box3_yheight2
#define visualize mccchannel_7_cave1_box3_visualize
#define target_index mccchannel_7_cave1_box3_target_index
#define target_x mccchannel_7_cave1_box3_target_x
#define target_y mccchannel_7_cave1_box3_target_y
#define target_z mccchannel_7_cave1_box3_target_z
#define focus_aw mccchannel_7_cave1_box3_focus_aw
#define focus_ah mccchannel_7_cave1_box3_focus_ah
#define focus_xw mccchannel_7_cave1_box3_focus_xw
#define focus_xh mccchannel_7_cave1_box3_focus_xh
#define focus_r mccchannel_7_cave1_box3_focus_r
#define p_interact mccchannel_7_cave1_box3_p_interact
#define mask_string mccchannel_7_cave1_box3_mask_string
#define mask_setting mccchannel_7_cave1_box3_mask_setting
#define number_of_activations mccchannel_7_cave1_box3_number_of_activations
#line 224 "Union_box.comp"
{
// Initializes the focusing system for this volume including input sanitation.
focus_initialize(&this_box_volume.geometry, POS_A_COMP_INDEX(INDEX_CURRENT_COMP+target_index), POS_A_CURRENT_COMP, ROT_A_CURRENT_COMP, target_index, target_x, target_y, target_z, focus_aw, focus_ah, focus_xw, focus_xh, focus_r, NAME_CURRENT_COMP);

// Input sanitation for this geometry
if (xwidth <= 0) {
  printf("\nERROR in Union_box named %s, the xwidth is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (yheight <= 0) {
  printf("\nERROR in Union_box named %s, yheight is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (zdepth <= 0) {
  printf("\nERROR in Union_box named %s, zdepth is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (xwidth2 <= 0 && xwidth2 != -1) {
  printf("\nERROR in Union_box named %s, the xwidth2 is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (yheight2 <= 0 && yheight2 != -1) {
  printf("\nERROR in Union_box named %s, yheight2 is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}

// Use sanitation
if (global_material_list.num_elements == 0) {
  printf("\nERROR: Need to define a material using Union_make_material before using a Union geometry component. \n");
  printf("       %s was defined before first use of Union_make_material.\n",NAME_CURRENT_COMP);
  exit(1);
}

this_box_volume.geometry.is_masked_volume = 0;
this_box_volume.geometry.is_exit_volume = 0;
this_box_volume.geometry.is_mask_volume = 0;
// check if the volume is a mask, if it is the material string is irelevant.
if (mask_string && strlen(mask_string) && strcmp(mask_string, "NULL") && strcmp(mask_string, "0")) {
    // A mask volume is used to limit the extend of other volumes, called the masked volumes. These are specified in the mask_string.
    // In order for a ray to enter a masked volume, it needs to be both in the region covered by that volume AND the mask volume.
    // When more than
    this_box_volume.geometry.mask_mode = 1; // Default is mask mode is ALL
    if (mask_setting && strlen(mask_setting) && strcmp(mask_setting, "NULL") && strcmp(mask_setting, "0")) {
        if (strcmp(mask_setting,"ALL") == 0 || strcmp(mask_setting,"All") == 0) this_box_volume.geometry.mask_mode = 1;
        else if (strcmp(mask_setting,"ANY") == 0 || strcmp(mask_setting,"Any") == 0) this_box_volume.geometry.mask_mode = 2;
        else {
            printf("The mask_mode of component %s is set to %s, but must be either ALL or ANY.\n",NAME_CURRENT_COMP,mask_setting);
            exit(1);
        }
    }
    
    for (loop_index=0;loop_index<global_geometry_list.num_elements;loop_index++) {
        // Add mask list
        if (1 == manual_linking_function(global_geometry_list.elements[loop_index].name,mask_string)) {
            add_element_to_int_list(&this_box_volume.geometry.mask_list,global_geometry_list.elements[loop_index].component_index);
            add_element_to_int_list(&global_geometry_list.elements[loop_index].Volume->geometry.masked_by_list,INDEX_CURRENT_COMP);
            global_geometry_list.elements[loop_index].Volume->geometry.is_masked_volume = 1;
            if (this_box_volume.geometry.mask_mode == 2)
                global_geometry_list.elements[loop_index].Volume->geometry.mask_mode = 2;
            if (this_box_volume.geometry.mask_mode == 1) {
                if (global_geometry_list.elements[loop_index].Volume->geometry.is_masked_volume == 1 && global_geometry_list.elements[loop_index].Volume->geometry.mask_mode != 2)
                    // If more than one mask is added to one volume, the ANY mode overwrites the (default) ALL mode.
                    global_geometry_list.elements[loop_index].Volume->geometry.mask_mode = 1;
            }
            
            found_geometries = 1;
        }
    }
    if (found_geometries == 0) {
        printf("The mask_string in geometry: %s did not find any of the specified volumes in the mask_string %s \n",NAME_CURRENT_COMP,mask_string);
        exit(1);
    }
    this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
    this_box_volume.p_physics->is_vacuum = 0; // Makes this volume a vacuum
    this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
    this_box_volume.p_physics->my_a = 0; // Should not be used.
    sprintf(this_box_volume.p_physics->name,"Mask");
    this_box_volume.geometry.is_mask_volume = 1;
    
    
// Read the material input, or if it lacks, use automatic linking.
} else if (material_string && strlen(material_string) && strcmp(material_string, "NULL") && strcmp(material_string, "0")) {
    // A geometry string was given, use it to determine which material
    if (0 == strcmp(material_string,"vacuum") || 0 == strcmp(material_string,"Vacuum")) {
        // One could have a global physics struct for vacuum instead of creating one for each
        this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
        this_box_volume.p_physics->is_vacuum = 1; // Makes this volume a vacuum
        this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
        this_box_volume.p_physics->my_a = 0; // Should not be used.
        sprintf(this_box_volume.p_physics->name,"Vacuum");
    } else if (0 == strcmp(material_string,"exit") || 0 == strcmp(material_string,"Exit")) {
        // One could have a global physics struct for vacuum instead of creating one for each
        this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
        this_box_volume.p_physics->is_vacuum = 1; // Makes this volume a vacuum
        this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
        this_box_volume.p_physics->my_a = 0; // Should not be used.
        this_box_volume.geometry.is_exit_volume = 1;
        sprintf(this_box_volume.p_physics->name,"Exit");
    } else {
        #ifndef MATERIAL_DETECTOR
            printf("Need to define a material before refering to it in a geometry %s.\n",NAME_CURRENT_COMP);
            exit(1);
        #endif
        for (loop_index=0;loop_index<global_material_list.num_elements;loop_index++) {
            if (0 == strcmp(material_string,global_material_list.elements[loop_index].name)) {
                this_box_volume.p_physics = global_material_list.elements[loop_index].physics;
                break;
            }
            if (loop_index == global_material_list.num_elements-1) {
            printf("\n");
            printf("ERROR: The material string \"%s\" in Union geometry \"%s\" did not match a specified material. \n",material_string,NAME_CURRENT_COMP);
            printf("       The materials available at this point (need to be defined before the geometry): \n");
            for (loop_index=0;loop_index<global_material_list.num_elements;loop_index++)
              printf("         %s\n",global_material_list.elements[loop_index].name);
            printf("\n");
            printf("       It is also possible to use one of the defualt materials avaiable: \n");
            printf("           Vacuum (for a Volume without scattering or absorption)\n");
            printf("           Exit (for a Volume where the ray exits the component if it enters)\n");
            printf("           Mask (for a Volume that masks existing volumes specified in the mask_string\n");
            exit(1);
          }
        }
    }
} else {
    // Automatic linking, simply using the last defined material.
    #ifndef MATERIAL_DETECTOR
        printf("Need to define a material before the geometry to use automatic linking %s.\n",NAME_CURRENT_COMP);
        exit(1);
    #endif
    this_box_volume.p_physics = global_material_list.elements[global_material_list.num_elements-1].physics;
}

sprintf(this_box_volume.name,NAME_CURRENT_COMP);
sprintf(this_box_volume.geometry.shape,"box");
this_box_volume.geometry.priority_value = priority;
this_box_volume.geometry.geometry_p_interact = p_interact;
// Currently the coordinates will be in absolute space.
this_box_volume.geometry.center = POS_A_CURRENT_COMP;

this_box_storage.z_depth = zdepth;
this_box_storage.x_width1 = xwidth;
this_box_storage.y_height1 = yheight;

this_box_storage.is_rectangle = 0;
if (xwidth2 < 0 && yheight2 < 0) this_box_storage.is_rectangle = 1;
if (xwidth == xwidth2 && yheight == yheight2) this_box_storage.is_rectangle = 1;

if (xwidth2 < 0) {
    this_box_storage.x_width2 = xwidth;
    xwidth2 = xwidth;
} else this_box_storage.x_width2 = xwidth2;

if (yheight2 < 0) {
    this_box_storage.y_height2 = yheight;
    yheight2 = yheight;
} else this_box_storage.y_height2 = yheight2;


this_box_storage.normal_vectors[0] = coords_set(0,0,1);
this_box_storage.normal_vectors[1] = coords_set(0,0,1);

// for sides with y component = 0
x_component = 2*zdepth/sqrt((xwidth-xwidth2)*(xwidth-xwidth2)+4*zdepth*zdepth);
z_component = (xwidth-xwidth2)/sqrt(4*zdepth*zdepth+(xwidth-xwidth2)*(xwidth-xwidth2));

this_box_storage.normal_vectors[2] = coords_set(x_component,0,z_component);
this_box_storage.normal_vectors[3] = coords_set(-x_component,0,z_component);

// for sides with x component = 0
y_component = 2*zdepth/sqrt((yheight-yheight2)*(yheight-yheight2)+4*zdepth*zdepth);
z_component = (yheight-yheight2)/sqrt(4*zdepth*zdepth+(yheight-yheight2)*(yheight-yheight2));

this_box_storage.normal_vectors[4] = coords_set(0,y_component,z_component);
this_box_storage.normal_vectors[5] = coords_set(0,-y_component,z_component);

this_box_volume.geometry.visualization_on = visualize;

this_box_volume.geometry.geometry_parameters.p_box_storage = &this_box_storage;

// Assign pointers to functions for intersection with the shape, checking if a point is inside the shape
if (this_box_storage.is_rectangle == 1) {
this_box_volume.geometry.intersect_function = &sample_box_intersect_simple;
this_box_volume.geometry.within_function = &r_within_box_simple;
}
else {
this_box_volume.geometry.intersect_function = &sample_box_intersect_advanced;
this_box_volume.geometry.within_function = &r_within_box_advanced;
}

this_box_volume.geometry.shell_points = &box_shell_points;
this_box_volume.geometry.mcdisplay_function = &mcdisplay_box_function;
this_box_volume.geometry.initialize_from_main_function = &initialize_box_geometry_from_main_component;
this_box_volume.geometry.process_rot_allocated = 0;

this_box_volume.geometry.copy_geometry_parameters = &allocate_box_storage_copy;

rot_copy(this_box_volume.geometry.rotation_matrix,ROT_A_CURRENT_COMP); //check how ROT_R_CURRENT_COMP would work
rot_transpose(ROT_A_CURRENT_COMP,this_box_volume.geometry.transpose_rotation_matrix);

// Initialize loggers
this_box_volume.loggers.num_elements = 0;

// packing the information into the global_geometry_element, which is then included in the global_geometry_list.
sprintf(global_geometry_element.name,NAME_CURRENT_COMP);
global_geometry_element.activation_counter = number_of_activations;
global_geometry_element.component_index = INDEX_CURRENT_COMP;
global_geometry_element.Volume = &this_box_volume; // Would be nicer if this m was a pointer, now we have the (small) data two places
add_element_to_geometry_list(&global_geometry_list,global_geometry_element);
}
#line 226961 "MACS_sample_kidney_box.c"
#undef number_of_activations
#undef mask_setting
#undef mask_string
#undef p_interact
#undef focus_r
#undef focus_xh
#undef focus_xw
#undef focus_ah
#undef focus_aw
#undef target_z
#undef target_y
#undef target_x
#undef target_index
#undef visualize
#undef yheight2
#undef xwidth2
#undef zdepth
#undef yheight
#undef xwidth
#undef priority
#undef material_string
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

  /* Initializations for component channel_7_cave1_cyl1. */
  SIG_MESSAGE("channel_7_cave1_cyl1 (Init)");
#define mccompcurname  channel_7_cave1_cyl1
#define mccompcurtype  Union_cylinder
#define mccompcurindex 393
#define loop_index mccchannel_7_cave1_cyl1_loop_index
#define this_cylinder_volume mccchannel_7_cave1_cyl1_this_cylinder_volume
#define global_geometry_element mccchannel_7_cave1_cyl1_global_geometry_element
#define this_cylinder_storage mccchannel_7_cave1_cyl1_this_cylinder_storage
#define material_string mccchannel_7_cave1_cyl1_material_string
#define priority mccchannel_7_cave1_cyl1_priority
#define radius mccchannel_7_cave1_cyl1_radius
#define yheight mccchannel_7_cave1_cyl1_yheight
#define visualize mccchannel_7_cave1_cyl1_visualize
#define target_index mccchannel_7_cave1_cyl1_target_index
#define target_x mccchannel_7_cave1_cyl1_target_x
#define target_y mccchannel_7_cave1_cyl1_target_y
#define target_z mccchannel_7_cave1_cyl1_target_z
#define focus_aw mccchannel_7_cave1_cyl1_focus_aw
#define focus_ah mccchannel_7_cave1_cyl1_focus_ah
#define focus_xw mccchannel_7_cave1_cyl1_focus_xw
#define focus_xh mccchannel_7_cave1_cyl1_focus_xh
#define focus_r mccchannel_7_cave1_cyl1_focus_r
#define p_interact mccchannel_7_cave1_cyl1_p_interact
#define mask_string mccchannel_7_cave1_cyl1_mask_string
#define mask_setting mccchannel_7_cave1_cyl1_mask_setting
#define number_of_activations mccchannel_7_cave1_cyl1_number_of_activations
#line 185 "Union_cylinder.comp"
{
// Initializes the focusing system for this volume including input sanitation.
focus_initialize(&this_cylinder_volume.geometry, POS_A_COMP_INDEX(INDEX_CURRENT_COMP+target_index), POS_A_CURRENT_COMP, ROT_A_CURRENT_COMP, target_index, target_x, target_y, target_z, focus_aw, focus_ah, focus_xw, focus_xh, focus_r, NAME_CURRENT_COMP);

// Input sanitation for this geometry
if (radius <= 0) {
  printf("\nERROR in Union_cylinder named %s, the radius is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}

if (yheight <= 0) {
  printf("\nERROR in Union_cylinder named %s, yheight is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}

// Use sanitation
#ifdef MATERIAL_DETECTOR
if (global_material_list.num_elements == 0) {
  // Here if the user have defined a material, but only after this material
  printf("\nERROR: Need to define a material using Union_make_material before using a Union geometry component. \n");
  printf("       %s was defined before first use of Union_make_material.\n",NAME_CURRENT_COMP);
  exit(1);
}
#endif
#ifndef MATERIAL_DETECTOR
  printf("\nERROR: Need to define a material using Union_make_material before using a Union geometry component. \n");
  exit(1);
#endif


this_cylinder_volume.geometry.is_masked_volume = 0;
this_cylinder_volume.geometry.is_exit_volume = 0;
this_cylinder_volume.geometry.is_mask_volume = 0;

// Read the material input, or if it lacks, use automatic linking.
if (mask_string && strlen(mask_string) && strcmp(mask_string, "NULL") && strcmp(mask_string, "0")) {
    // A mask volume is used to limit the extend of other volumes, called the masked volumes. These are specified in the mask_string.
    // In order for a ray to enter a masked volume, it needs to be both in the region covered by that volume AND the mask volume.
    // When more than
    this_cylinder_volume.geometry.mask_mode = 1; // Default is mask mode is ALL
    if (mask_setting && strlen(mask_setting) && strcmp(mask_setting, "NULL") && strcmp(mask_setting, "0")) {
        if (strcmp(mask_setting,"ALL") == 0 || strcmp(mask_setting,"All") == 0) this_cylinder_volume.geometry.mask_mode = 1;
        else if (strcmp(mask_setting,"ANY") == 0 || strcmp(mask_setting,"Any") == 0) this_cylinder_volume.geometry.mask_mode = 2;
        else {
            printf("The mask_mode of component %s is set to %s, but must be either ALL or ANY.\n",NAME_CURRENT_COMP,mask_setting);
            exit(1);
        }
    }
    
    for (loop_index=0;loop_index<global_geometry_list.num_elements;loop_index++) {
        // Add mask list
        if (1 == manual_linking_function(global_geometry_list.elements[loop_index].name,mask_string)) {
            add_element_to_int_list(&this_cylinder_volume.geometry.mask_list,global_geometry_list.elements[loop_index].component_index);
            add_element_to_int_list(&global_geometry_list.elements[loop_index].Volume->geometry.masked_by_list,INDEX_CURRENT_COMP);
            global_geometry_list.elements[loop_index].Volume->geometry.is_masked_volume = 1;
            if (this_cylinder_volume.geometry.mask_mode == 2)
                global_geometry_list.elements[loop_index].Volume->geometry.mask_mode = 2;
            if (this_cylinder_volume.geometry.mask_mode == 1) {
                if (global_geometry_list.elements[loop_index].Volume->geometry.is_masked_volume == 1 && global_geometry_list.elements[loop_index].Volume->geometry.mask_mode != 2)
                    // If more than one mask is added to one volume, the ANY mode overwrites the (default) ALL mode.
                    global_geometry_list.elements[loop_index].Volume->geometry.mask_mode = 1;
            }
            
            found_geometries = 1;
        }
    }
    if (found_geometries == 0) {
        printf("The mask_string in geometry: %s did not find any of the specified volumes in the mask_string %s \n",NAME_CURRENT_COMP,mask_string);
        exit(1);
    }
    this_cylinder_volume.p_physics = malloc(sizeof(struct physics_struct));
    this_cylinder_volume.p_physics->is_vacuum = 0; // Makes this volume a vacuum
    this_cylinder_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
    this_cylinder_volume.p_physics->my_a = 0; // Should not be used.
    sprintf(this_cylinder_volume.p_physics->name,"Mask");
    this_cylinder_volume.geometry.is_mask_volume = 1;
    
    
// Read the material input, or if it lacks, use automatic linking.
} else if (material_string && strlen(material_string) && strcmp(material_string, "NULL") && strcmp(material_string, "0")) {
    // A geometry string was given, use it to determine which material
    if (0 == strcmp(material_string,"vacuum") || 0 == strcmp(material_string,"Vacuum")) {
        // One could have a global physics struct for vacuum instead of creating one for each
        this_cylinder_volume.p_physics = malloc(sizeof(struct physics_struct));
        this_cylinder_volume.p_physics->is_vacuum = 1; // Makes this volume a vacuum
        this_cylinder_volume.p_physics->number_of_processes = (int) 0;
        this_cylinder_volume.p_physics->my_a = 0; // Should not be used.
        sprintf(this_cylinder_volume.p_physics->name,"Vacuum");
    } else if (0 == strcmp(material_string,"exit") || 0 == strcmp(material_string,"Exit")) {
        // One could have a global physics struct for exit instead of creating one for each
        this_cylinder_volume.p_physics = malloc(sizeof(struct physics_struct));
        this_cylinder_volume.p_physics->is_vacuum = 1; // Makes this volume a vacuum
        this_cylinder_volume.p_physics->number_of_processes = (int) 0;
        this_cylinder_volume.p_physics->my_a = 0; // Should not be used.
        this_cylinder_volume.geometry.is_exit_volume = 1;
        sprintf(this_cylinder_volume.p_physics->name,"Exit");
    } else {
        for (loop_index=0;loop_index<global_material_list.num_elements;loop_index++) {
          if (0 == strcmp(material_string,global_material_list.elements[loop_index].name)) {
            this_cylinder_volume.p_physics = global_material_list.elements[loop_index].physics;
            break;
          }
          if (loop_index == global_material_list.num_elements-1) {
            printf("\n");
            printf("ERROR: The material string \"%s\" in Union geometry \"%s\" did not match a specified material. \n",material_string,NAME_CURRENT_COMP);
            printf("       The materials available at this point (need to be defined before the geometry): \n");
            for (loop_index=0;loop_index<global_material_list.num_elements;loop_index++)
              printf("         %s\n",global_material_list.elements[loop_index].name);
            printf("\n");
            printf("       It is also possible to use one of the defualt materials avaiable: \n");
            printf("           Vacuum (for a Volume without scattering or absorption)\n");
            printf("           Exit (for a Volume where the ray exits the component if it enters)\n");
            printf("           Mask (for a Volume that masks existing volumes specified in the mask_string\n");
            exit(1);
          }
        }
    }
} else {
    // Automatic linking, simply using the last defined material.
    #ifndef MATERIAL_DETECTOR
        printf("Need to define a material before the geometry to use automatic linking %s.\n",NAME_CURRENT_COMP);
        exit(1);
    #endif
    this_cylinder_volume.p_physics = global_material_list.elements[global_material_list.num_elements-1].physics;
}

sprintf(this_cylinder_volume.name,NAME_CURRENT_COMP);
sprintf(this_cylinder_volume.geometry.shape,"cylinder");
this_cylinder_volume.geometry.priority_value = priority;
// Currently the coordinates will be in absolute space.
this_cylinder_volume.geometry.center = POS_A_CURRENT_COMP;

this_cylinder_volume.geometry.geometry_p_interact = p_interact;
this_cylinder_storage.cyl_radius = radius;
this_cylinder_storage.height = yheight;
this_cylinder_volume.geometry.visualization_on = visualize;
this_cylinder_volume.geometry.geometry_parameters.p_cylinder_storage = &this_cylinder_storage;
this_cylinder_volume.geometry.within_function = &r_within_cylinder;
this_cylinder_volume.geometry.intersect_function = &sample_cylinder_intersect;
this_cylinder_volume.geometry.mcdisplay_function = &mcdisplay_cylinder_function;
this_cylinder_volume.geometry.shell_points = &cylinder_shell_points;
this_cylinder_volume.geometry.initialize_from_main_function = &initialize_cylinder_geometry_from_main_component;
this_cylinder_volume.geometry.process_rot_allocated = 0;
this_cylinder_volume.geometry.copy_geometry_parameters = &allocate_cylinder_storage_copy;

rot_copy(this_cylinder_volume.geometry.rotation_matrix,ROT_A_CURRENT_COMP);
rot_transpose(ROT_A_CURRENT_COMP,this_cylinder_volume.geometry.transpose_rotation_matrix);

// Initialize loggers
this_cylinder_volume.loggers.num_elements = 0;

// packing the information into the global_geometry_element, which is then included in the global_geometry_list.
sprintf(global_geometry_element.name,NAME_CURRENT_COMP);
global_geometry_element.activation_counter = number_of_activations;
global_geometry_element.component_index = INDEX_CURRENT_COMP;
global_geometry_element.Volume = &this_cylinder_volume; // Would be nicer if this m was a pointer, now we have the (small) data two places
add_element_to_geometry_list(&global_geometry_list,global_geometry_element);
}
#line 227177 "MACS_sample_kidney_box.c"
#undef number_of_activations
#undef mask_setting
#undef mask_string
#undef p_interact
#undef focus_r
#undef focus_xh
#undef focus_xw
#undef focus_ah
#undef focus_aw
#undef target_z
#undef target_y
#undef target_x
#undef target_index
#undef visualize
#undef yheight
#undef radius
#undef priority
#undef material_string
#undef this_cylinder_storage
#undef global_geometry_element
#undef this_cylinder_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

  /* Initializations for component channel_7_analyzer_1_center. */
  SIG_MESSAGE("channel_7_analyzer_1_center (Init)");

  /* Initializations for component channel_7_analyzer_1_rotated. */
  SIG_MESSAGE("channel_7_analyzer_1_rotated (Init)");

  /* Initializations for component channel_7_analyzer_1_array_crystal_array_0. */
  SIG_MESSAGE("channel_7_analyzer_1_array_crystal_array_0 (Init)");
#define mccompcurname  channel_7_analyzer_1_array_crystal_array_0
#define mccompcurtype  Union_box
#define mccompcurindex 396
#define loop_index mccchannel_7_analyzer_1_array_crystal_array_0_loop_index
#define this_box_volume mccchannel_7_analyzer_1_array_crystal_array_0_this_box_volume
#define global_geometry_element mccchannel_7_analyzer_1_array_crystal_array_0_global_geometry_element
#define this_box_storage mccchannel_7_analyzer_1_array_crystal_array_0_this_box_storage
#define material_string mccchannel_7_analyzer_1_array_crystal_array_0_material_string
#define priority mccchannel_7_analyzer_1_array_crystal_array_0_priority
#define xwidth mccchannel_7_analyzer_1_array_crystal_array_0_xwidth
#define yheight mccchannel_7_analyzer_1_array_crystal_array_0_yheight
#define zdepth mccchannel_7_analyzer_1_array_crystal_array_0_zdepth
#define xwidth2 mccchannel_7_analyzer_1_array_crystal_array_0_xwidth2
#define yheight2 mccchannel_7_analyzer_1_array_crystal_array_0_yheight2
#define visualize mccchannel_7_analyzer_1_array_crystal_array_0_visualize
#define target_index mccchannel_7_analyzer_1_array_crystal_array_0_target_index
#define target_x mccchannel_7_analyzer_1_array_crystal_array_0_target_x
#define target_y mccchannel_7_analyzer_1_array_crystal_array_0_target_y
#define target_z mccchannel_7_analyzer_1_array_crystal_array_0_target_z
#define focus_aw mccchannel_7_analyzer_1_array_crystal_array_0_focus_aw
#define focus_ah mccchannel_7_analyzer_1_array_crystal_array_0_focus_ah
#define focus_xw mccchannel_7_analyzer_1_array_crystal_array_0_focus_xw
#define focus_xh mccchannel_7_analyzer_1_array_crystal_array_0_focus_xh
#define focus_r mccchannel_7_analyzer_1_array_crystal_array_0_focus_r
#define p_interact mccchannel_7_analyzer_1_array_crystal_array_0_p_interact
#define mask_string mccchannel_7_analyzer_1_array_crystal_array_0_mask_string
#define mask_setting mccchannel_7_analyzer_1_array_crystal_array_0_mask_setting
#define number_of_activations mccchannel_7_analyzer_1_array_crystal_array_0_number_of_activations
#line 224 "Union_box.comp"
{
// Initializes the focusing system for this volume including input sanitation.
focus_initialize(&this_box_volume.geometry, POS_A_COMP_INDEX(INDEX_CURRENT_COMP+target_index), POS_A_CURRENT_COMP, ROT_A_CURRENT_COMP, target_index, target_x, target_y, target_z, focus_aw, focus_ah, focus_xw, focus_xh, focus_r, NAME_CURRENT_COMP);

// Input sanitation for this geometry
if (xwidth <= 0) {
  printf("\nERROR in Union_box named %s, the xwidth is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (yheight <= 0) {
  printf("\nERROR in Union_box named %s, yheight is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (zdepth <= 0) {
  printf("\nERROR in Union_box named %s, zdepth is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (xwidth2 <= 0 && xwidth2 != -1) {
  printf("\nERROR in Union_box named %s, the xwidth2 is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (yheight2 <= 0 && yheight2 != -1) {
  printf("\nERROR in Union_box named %s, yheight2 is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}

// Use sanitation
if (global_material_list.num_elements == 0) {
  printf("\nERROR: Need to define a material using Union_make_material before using a Union geometry component. \n");
  printf("       %s was defined before first use of Union_make_material.\n",NAME_CURRENT_COMP);
  exit(1);
}

this_box_volume.geometry.is_masked_volume = 0;
this_box_volume.geometry.is_exit_volume = 0;
this_box_volume.geometry.is_mask_volume = 0;
// check if the volume is a mask, if it is the material string is irelevant.
if (mask_string && strlen(mask_string) && strcmp(mask_string, "NULL") && strcmp(mask_string, "0")) {
    // A mask volume is used to limit the extend of other volumes, called the masked volumes. These are specified in the mask_string.
    // In order for a ray to enter a masked volume, it needs to be both in the region covered by that volume AND the mask volume.
    // When more than
    this_box_volume.geometry.mask_mode = 1; // Default is mask mode is ALL
    if (mask_setting && strlen(mask_setting) && strcmp(mask_setting, "NULL") && strcmp(mask_setting, "0")) {
        if (strcmp(mask_setting,"ALL") == 0 || strcmp(mask_setting,"All") == 0) this_box_volume.geometry.mask_mode = 1;
        else if (strcmp(mask_setting,"ANY") == 0 || strcmp(mask_setting,"Any") == 0) this_box_volume.geometry.mask_mode = 2;
        else {
            printf("The mask_mode of component %s is set to %s, but must be either ALL or ANY.\n",NAME_CURRENT_COMP,mask_setting);
            exit(1);
        }
    }
    
    for (loop_index=0;loop_index<global_geometry_list.num_elements;loop_index++) {
        // Add mask list
        if (1 == manual_linking_function(global_geometry_list.elements[loop_index].name,mask_string)) {
            add_element_to_int_list(&this_box_volume.geometry.mask_list,global_geometry_list.elements[loop_index].component_index);
            add_element_to_int_list(&global_geometry_list.elements[loop_index].Volume->geometry.masked_by_list,INDEX_CURRENT_COMP);
            global_geometry_list.elements[loop_index].Volume->geometry.is_masked_volume = 1;
            if (this_box_volume.geometry.mask_mode == 2)
                global_geometry_list.elements[loop_index].Volume->geometry.mask_mode = 2;
            if (this_box_volume.geometry.mask_mode == 1) {
                if (global_geometry_list.elements[loop_index].Volume->geometry.is_masked_volume == 1 && global_geometry_list.elements[loop_index].Volume->geometry.mask_mode != 2)
                    // If more than one mask is added to one volume, the ANY mode overwrites the (default) ALL mode.
                    global_geometry_list.elements[loop_index].Volume->geometry.mask_mode = 1;
            }
            
            found_geometries = 1;
        }
    }
    if (found_geometries == 0) {
        printf("The mask_string in geometry: %s did not find any of the specified volumes in the mask_string %s \n",NAME_CURRENT_COMP,mask_string);
        exit(1);
    }
    this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
    this_box_volume.p_physics->is_vacuum = 0; // Makes this volume a vacuum
    this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
    this_box_volume.p_physics->my_a = 0; // Should not be used.
    sprintf(this_box_volume.p_physics->name,"Mask");
    this_box_volume.geometry.is_mask_volume = 1;
    
    
// Read the material input, or if it lacks, use automatic linking.
} else if (material_string && strlen(material_string) && strcmp(material_string, "NULL") && strcmp(material_string, "0")) {
    // A geometry string was given, use it to determine which material
    if (0 == strcmp(material_string,"vacuum") || 0 == strcmp(material_string,"Vacuum")) {
        // One could have a global physics struct for vacuum instead of creating one for each
        this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
        this_box_volume.p_physics->is_vacuum = 1; // Makes this volume a vacuum
        this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
        this_box_volume.p_physics->my_a = 0; // Should not be used.
        sprintf(this_box_volume.p_physics->name,"Vacuum");
    } else if (0 == strcmp(material_string,"exit") || 0 == strcmp(material_string,"Exit")) {
        // One could have a global physics struct for vacuum instead of creating one for each
        this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
        this_box_volume.p_physics->is_vacuum = 1; // Makes this volume a vacuum
        this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
        this_box_volume.p_physics->my_a = 0; // Should not be used.
        this_box_volume.geometry.is_exit_volume = 1;
        sprintf(this_box_volume.p_physics->name,"Exit");
    } else {
        #ifndef MATERIAL_DETECTOR
            printf("Need to define a material before refering to it in a geometry %s.\n",NAME_CURRENT_COMP);
            exit(1);
        #endif
        for (loop_index=0;loop_index<global_material_list.num_elements;loop_index++) {
            if (0 == strcmp(material_string,global_material_list.elements[loop_index].name)) {
                this_box_volume.p_physics = global_material_list.elements[loop_index].physics;
                break;
            }
            if (loop_index == global_material_list.num_elements-1) {
            printf("\n");
            printf("ERROR: The material string \"%s\" in Union geometry \"%s\" did not match a specified material. \n",material_string,NAME_CURRENT_COMP);
            printf("       The materials available at this point (need to be defined before the geometry): \n");
            for (loop_index=0;loop_index<global_material_list.num_elements;loop_index++)
              printf("         %s\n",global_material_list.elements[loop_index].name);
            printf("\n");
            printf("       It is also possible to use one of the defualt materials avaiable: \n");
            printf("           Vacuum (for a Volume without scattering or absorption)\n");
            printf("           Exit (for a Volume where the ray exits the component if it enters)\n");
            printf("           Mask (for a Volume that masks existing volumes specified in the mask_string\n");
            exit(1);
          }
        }
    }
} else {
    // Automatic linking, simply using the last defined material.
    #ifndef MATERIAL_DETECTOR
        printf("Need to define a material before the geometry to use automatic linking %s.\n",NAME_CURRENT_COMP);
        exit(1);
    #endif
    this_box_volume.p_physics = global_material_list.elements[global_material_list.num_elements-1].physics;
}

sprintf(this_box_volume.name,NAME_CURRENT_COMP);
sprintf(this_box_volume.geometry.shape,"box");
this_box_volume.geometry.priority_value = priority;
this_box_volume.geometry.geometry_p_interact = p_interact;
// Currently the coordinates will be in absolute space.
this_box_volume.geometry.center = POS_A_CURRENT_COMP;

this_box_storage.z_depth = zdepth;
this_box_storage.x_width1 = xwidth;
this_box_storage.y_height1 = yheight;

this_box_storage.is_rectangle = 0;
if (xwidth2 < 0 && yheight2 < 0) this_box_storage.is_rectangle = 1;
if (xwidth == xwidth2 && yheight == yheight2) this_box_storage.is_rectangle = 1;

if (xwidth2 < 0) {
    this_box_storage.x_width2 = xwidth;
    xwidth2 = xwidth;
} else this_box_storage.x_width2 = xwidth2;

if (yheight2 < 0) {
    this_box_storage.y_height2 = yheight;
    yheight2 = yheight;
} else this_box_storage.y_height2 = yheight2;


this_box_storage.normal_vectors[0] = coords_set(0,0,1);
this_box_storage.normal_vectors[1] = coords_set(0,0,1);

// for sides with y component = 0
x_component = 2*zdepth/sqrt((xwidth-xwidth2)*(xwidth-xwidth2)+4*zdepth*zdepth);
z_component = (xwidth-xwidth2)/sqrt(4*zdepth*zdepth+(xwidth-xwidth2)*(xwidth-xwidth2));

this_box_storage.normal_vectors[2] = coords_set(x_component,0,z_component);
this_box_storage.normal_vectors[3] = coords_set(-x_component,0,z_component);

// for sides with x component = 0
y_component = 2*zdepth/sqrt((yheight-yheight2)*(yheight-yheight2)+4*zdepth*zdepth);
z_component = (yheight-yheight2)/sqrt(4*zdepth*zdepth+(yheight-yheight2)*(yheight-yheight2));

this_box_storage.normal_vectors[4] = coords_set(0,y_component,z_component);
this_box_storage.normal_vectors[5] = coords_set(0,-y_component,z_component);

this_box_volume.geometry.visualization_on = visualize;

this_box_volume.geometry.geometry_parameters.p_box_storage = &this_box_storage;

// Assign pointers to functions for intersection with the shape, checking if a point is inside the shape
if (this_box_storage.is_rectangle == 1) {
this_box_volume.geometry.intersect_function = &sample_box_intersect_simple;
this_box_volume.geometry.within_function = &r_within_box_simple;
}
else {
this_box_volume.geometry.intersect_function = &sample_box_intersect_advanced;
this_box_volume.geometry.within_function = &r_within_box_advanced;
}

this_box_volume.geometry.shell_points = &box_shell_points;
this_box_volume.geometry.mcdisplay_function = &mcdisplay_box_function;
this_box_volume.geometry.initialize_from_main_function = &initialize_box_geometry_from_main_component;
this_box_volume.geometry.process_rot_allocated = 0;

this_box_volume.geometry.copy_geometry_parameters = &allocate_box_storage_copy;

rot_copy(this_box_volume.geometry.rotation_matrix,ROT_A_CURRENT_COMP); //check how ROT_R_CURRENT_COMP would work
rot_transpose(ROT_A_CURRENT_COMP,this_box_volume.geometry.transpose_rotation_matrix);

// Initialize loggers
this_box_volume.loggers.num_elements = 0;

// packing the information into the global_geometry_element, which is then included in the global_geometry_list.
sprintf(global_geometry_element.name,NAME_CURRENT_COMP);
global_geometry_element.activation_counter = number_of_activations;
global_geometry_element.component_index = INDEX_CURRENT_COMP;
global_geometry_element.Volume = &this_box_volume; // Would be nicer if this m was a pointer, now we have the (small) data two places
add_element_to_geometry_list(&global_geometry_list,global_geometry_element);
}
#line 227450 "MACS_sample_kidney_box.c"
#undef number_of_activations
#undef mask_setting
#undef mask_string
#undef p_interact
#undef focus_r
#undef focus_xh
#undef focus_xw
#undef focus_ah
#undef focus_aw
#undef target_z
#undef target_y
#undef target_x
#undef target_index
#undef visualize
#undef yheight2
#undef xwidth2
#undef zdepth
#undef yheight
#undef xwidth
#undef priority
#undef material_string
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

  /* Initializations for component channel_7_analyzer_1_array_crystal_array_1. */
  SIG_MESSAGE("channel_7_analyzer_1_array_crystal_array_1 (Init)");
#define mccompcurname  channel_7_analyzer_1_array_crystal_array_1
#define mccompcurtype  Union_box
#define mccompcurindex 397
#define loop_index mccchannel_7_analyzer_1_array_crystal_array_1_loop_index
#define this_box_volume mccchannel_7_analyzer_1_array_crystal_array_1_this_box_volume
#define global_geometry_element mccchannel_7_analyzer_1_array_crystal_array_1_global_geometry_element
#define this_box_storage mccchannel_7_analyzer_1_array_crystal_array_1_this_box_storage
#define material_string mccchannel_7_analyzer_1_array_crystal_array_1_material_string
#define priority mccchannel_7_analyzer_1_array_crystal_array_1_priority
#define xwidth mccchannel_7_analyzer_1_array_crystal_array_1_xwidth
#define yheight mccchannel_7_analyzer_1_array_crystal_array_1_yheight
#define zdepth mccchannel_7_analyzer_1_array_crystal_array_1_zdepth
#define xwidth2 mccchannel_7_analyzer_1_array_crystal_array_1_xwidth2
#define yheight2 mccchannel_7_analyzer_1_array_crystal_array_1_yheight2
#define visualize mccchannel_7_analyzer_1_array_crystal_array_1_visualize
#define target_index mccchannel_7_analyzer_1_array_crystal_array_1_target_index
#define target_x mccchannel_7_analyzer_1_array_crystal_array_1_target_x
#define target_y mccchannel_7_analyzer_1_array_crystal_array_1_target_y
#define target_z mccchannel_7_analyzer_1_array_crystal_array_1_target_z
#define focus_aw mccchannel_7_analyzer_1_array_crystal_array_1_focus_aw
#define focus_ah mccchannel_7_analyzer_1_array_crystal_array_1_focus_ah
#define focus_xw mccchannel_7_analyzer_1_array_crystal_array_1_focus_xw
#define focus_xh mccchannel_7_analyzer_1_array_crystal_array_1_focus_xh
#define focus_r mccchannel_7_analyzer_1_array_crystal_array_1_focus_r
#define p_interact mccchannel_7_analyzer_1_array_crystal_array_1_p_interact
#define mask_string mccchannel_7_analyzer_1_array_crystal_array_1_mask_string
#define mask_setting mccchannel_7_analyzer_1_array_crystal_array_1_mask_setting
#define number_of_activations mccchannel_7_analyzer_1_array_crystal_array_1_number_of_activations
#line 224 "Union_box.comp"
{
// Initializes the focusing system for this volume including input sanitation.
focus_initialize(&this_box_volume.geometry, POS_A_COMP_INDEX(INDEX_CURRENT_COMP+target_index), POS_A_CURRENT_COMP, ROT_A_CURRENT_COMP, target_index, target_x, target_y, target_z, focus_aw, focus_ah, focus_xw, focus_xh, focus_r, NAME_CURRENT_COMP);

// Input sanitation for this geometry
if (xwidth <= 0) {
  printf("\nERROR in Union_box named %s, the xwidth is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (yheight <= 0) {
  printf("\nERROR in Union_box named %s, yheight is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (zdepth <= 0) {
  printf("\nERROR in Union_box named %s, zdepth is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (xwidth2 <= 0 && xwidth2 != -1) {
  printf("\nERROR in Union_box named %s, the xwidth2 is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (yheight2 <= 0 && yheight2 != -1) {
  printf("\nERROR in Union_box named %s, yheight2 is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}

// Use sanitation
if (global_material_list.num_elements == 0) {
  printf("\nERROR: Need to define a material using Union_make_material before using a Union geometry component. \n");
  printf("       %s was defined before first use of Union_make_material.\n",NAME_CURRENT_COMP);
  exit(1);
}

this_box_volume.geometry.is_masked_volume = 0;
this_box_volume.geometry.is_exit_volume = 0;
this_box_volume.geometry.is_mask_volume = 0;
// check if the volume is a mask, if it is the material string is irelevant.
if (mask_string && strlen(mask_string) && strcmp(mask_string, "NULL") && strcmp(mask_string, "0")) {
    // A mask volume is used to limit the extend of other volumes, called the masked volumes. These are specified in the mask_string.
    // In order for a ray to enter a masked volume, it needs to be both in the region covered by that volume AND the mask volume.
    // When more than
    this_box_volume.geometry.mask_mode = 1; // Default is mask mode is ALL
    if (mask_setting && strlen(mask_setting) && strcmp(mask_setting, "NULL") && strcmp(mask_setting, "0")) {
        if (strcmp(mask_setting,"ALL") == 0 || strcmp(mask_setting,"All") == 0) this_box_volume.geometry.mask_mode = 1;
        else if (strcmp(mask_setting,"ANY") == 0 || strcmp(mask_setting,"Any") == 0) this_box_volume.geometry.mask_mode = 2;
        else {
            printf("The mask_mode of component %s is set to %s, but must be either ALL or ANY.\n",NAME_CURRENT_COMP,mask_setting);
            exit(1);
        }
    }
    
    for (loop_index=0;loop_index<global_geometry_list.num_elements;loop_index++) {
        // Add mask list
        if (1 == manual_linking_function(global_geometry_list.elements[loop_index].name,mask_string)) {
            add_element_to_int_list(&this_box_volume.geometry.mask_list,global_geometry_list.elements[loop_index].component_index);
            add_element_to_int_list(&global_geometry_list.elements[loop_index].Volume->geometry.masked_by_list,INDEX_CURRENT_COMP);
            global_geometry_list.elements[loop_index].Volume->geometry.is_masked_volume = 1;
            if (this_box_volume.geometry.mask_mode == 2)
                global_geometry_list.elements[loop_index].Volume->geometry.mask_mode = 2;
            if (this_box_volume.geometry.mask_mode == 1) {
                if (global_geometry_list.elements[loop_index].Volume->geometry.is_masked_volume == 1 && global_geometry_list.elements[loop_index].Volume->geometry.mask_mode != 2)
                    // If more than one mask is added to one volume, the ANY mode overwrites the (default) ALL mode.
                    global_geometry_list.elements[loop_index].Volume->geometry.mask_mode = 1;
            }
            
            found_geometries = 1;
        }
    }
    if (found_geometries == 0) {
        printf("The mask_string in geometry: %s did not find any of the specified volumes in the mask_string %s \n",NAME_CURRENT_COMP,mask_string);
        exit(1);
    }
    this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
    this_box_volume.p_physics->is_vacuum = 0; // Makes this volume a vacuum
    this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
    this_box_volume.p_physics->my_a = 0; // Should not be used.
    sprintf(this_box_volume.p_physics->name,"Mask");
    this_box_volume.geometry.is_mask_volume = 1;
    
    
// Read the material input, or if it lacks, use automatic linking.
} else if (material_string && strlen(material_string) && strcmp(material_string, "NULL") && strcmp(material_string, "0")) {
    // A geometry string was given, use it to determine which material
    if (0 == strcmp(material_string,"vacuum") || 0 == strcmp(material_string,"Vacuum")) {
        // One could have a global physics struct for vacuum instead of creating one for each
        this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
        this_box_volume.p_physics->is_vacuum = 1; // Makes this volume a vacuum
        this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
        this_box_volume.p_physics->my_a = 0; // Should not be used.
        sprintf(this_box_volume.p_physics->name,"Vacuum");
    } else if (0 == strcmp(material_string,"exit") || 0 == strcmp(material_string,"Exit")) {
        // One could have a global physics struct for vacuum instead of creating one for each
        this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
        this_box_volume.p_physics->is_vacuum = 1; // Makes this volume a vacuum
        this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
        this_box_volume.p_physics->my_a = 0; // Should not be used.
        this_box_volume.geometry.is_exit_volume = 1;
        sprintf(this_box_volume.p_physics->name,"Exit");
    } else {
        #ifndef MATERIAL_DETECTOR
            printf("Need to define a material before refering to it in a geometry %s.\n",NAME_CURRENT_COMP);
            exit(1);
        #endif
        for (loop_index=0;loop_index<global_material_list.num_elements;loop_index++) {
            if (0 == strcmp(material_string,global_material_list.elements[loop_index].name)) {
                this_box_volume.p_physics = global_material_list.elements[loop_index].physics;
                break;
            }
            if (loop_index == global_material_list.num_elements-1) {
            printf("\n");
            printf("ERROR: The material string \"%s\" in Union geometry \"%s\" did not match a specified material. \n",material_string,NAME_CURRENT_COMP);
            printf("       The materials available at this point (need to be defined before the geometry): \n");
            for (loop_index=0;loop_index<global_material_list.num_elements;loop_index++)
              printf("         %s\n",global_material_list.elements[loop_index].name);
            printf("\n");
            printf("       It is also possible to use one of the defualt materials avaiable: \n");
            printf("           Vacuum (for a Volume without scattering or absorption)\n");
            printf("           Exit (for a Volume where the ray exits the component if it enters)\n");
            printf("           Mask (for a Volume that masks existing volumes specified in the mask_string\n");
            exit(1);
          }
        }
    }
} else {
    // Automatic linking, simply using the last defined material.
    #ifndef MATERIAL_DETECTOR
        printf("Need to define a material before the geometry to use automatic linking %s.\n",NAME_CURRENT_COMP);
        exit(1);
    #endif
    this_box_volume.p_physics = global_material_list.elements[global_material_list.num_elements-1].physics;
}

sprintf(this_box_volume.name,NAME_CURRENT_COMP);
sprintf(this_box_volume.geometry.shape,"box");
this_box_volume.geometry.priority_value = priority;
this_box_volume.geometry.geometry_p_interact = p_interact;
// Currently the coordinates will be in absolute space.
this_box_volume.geometry.center = POS_A_CURRENT_COMP;

this_box_storage.z_depth = zdepth;
this_box_storage.x_width1 = xwidth;
this_box_storage.y_height1 = yheight;

this_box_storage.is_rectangle = 0;
if (xwidth2 < 0 && yheight2 < 0) this_box_storage.is_rectangle = 1;
if (xwidth == xwidth2 && yheight == yheight2) this_box_storage.is_rectangle = 1;

if (xwidth2 < 0) {
    this_box_storage.x_width2 = xwidth;
    xwidth2 = xwidth;
} else this_box_storage.x_width2 = xwidth2;

if (yheight2 < 0) {
    this_box_storage.y_height2 = yheight;
    yheight2 = yheight;
} else this_box_storage.y_height2 = yheight2;


this_box_storage.normal_vectors[0] = coords_set(0,0,1);
this_box_storage.normal_vectors[1] = coords_set(0,0,1);

// for sides with y component = 0
x_component = 2*zdepth/sqrt((xwidth-xwidth2)*(xwidth-xwidth2)+4*zdepth*zdepth);
z_component = (xwidth-xwidth2)/sqrt(4*zdepth*zdepth+(xwidth-xwidth2)*(xwidth-xwidth2));

this_box_storage.normal_vectors[2] = coords_set(x_component,0,z_component);
this_box_storage.normal_vectors[3] = coords_set(-x_component,0,z_component);

// for sides with x component = 0
y_component = 2*zdepth/sqrt((yheight-yheight2)*(yheight-yheight2)+4*zdepth*zdepth);
z_component = (yheight-yheight2)/sqrt(4*zdepth*zdepth+(yheight-yheight2)*(yheight-yheight2));

this_box_storage.normal_vectors[4] = coords_set(0,y_component,z_component);
this_box_storage.normal_vectors[5] = coords_set(0,-y_component,z_component);

this_box_volume.geometry.visualization_on = visualize;

this_box_volume.geometry.geometry_parameters.p_box_storage = &this_box_storage;

// Assign pointers to functions for intersection with the shape, checking if a point is inside the shape
if (this_box_storage.is_rectangle == 1) {
this_box_volume.geometry.intersect_function = &sample_box_intersect_simple;
this_box_volume.geometry.within_function = &r_within_box_simple;
}
else {
this_box_volume.geometry.intersect_function = &sample_box_intersect_advanced;
this_box_volume.geometry.within_function = &r_within_box_advanced;
}

this_box_volume.geometry.shell_points = &box_shell_points;
this_box_volume.geometry.mcdisplay_function = &mcdisplay_box_function;
this_box_volume.geometry.initialize_from_main_function = &initialize_box_geometry_from_main_component;
this_box_volume.geometry.process_rot_allocated = 0;

this_box_volume.geometry.copy_geometry_parameters = &allocate_box_storage_copy;

rot_copy(this_box_volume.geometry.rotation_matrix,ROT_A_CURRENT_COMP); //check how ROT_R_CURRENT_COMP would work
rot_transpose(ROT_A_CURRENT_COMP,this_box_volume.geometry.transpose_rotation_matrix);

// Initialize loggers
this_box_volume.loggers.num_elements = 0;

// packing the information into the global_geometry_element, which is then included in the global_geometry_list.
sprintf(global_geometry_element.name,NAME_CURRENT_COMP);
global_geometry_element.activation_counter = number_of_activations;
global_geometry_element.component_index = INDEX_CURRENT_COMP;
global_geometry_element.Volume = &this_box_volume; // Would be nicer if this m was a pointer, now we have the (small) data two places
add_element_to_geometry_list(&global_geometry_list,global_geometry_element);
}
#line 227720 "MACS_sample_kidney_box.c"
#undef number_of_activations
#undef mask_setting
#undef mask_string
#undef p_interact
#undef focus_r
#undef focus_xh
#undef focus_xw
#undef focus_ah
#undef focus_aw
#undef target_z
#undef target_y
#undef target_x
#undef target_index
#undef visualize
#undef yheight2
#undef xwidth2
#undef zdepth
#undef yheight
#undef xwidth
#undef priority
#undef material_string
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

  /* Initializations for component channel_7_analyzer_1_array_crystal_array_2. */
  SIG_MESSAGE("channel_7_analyzer_1_array_crystal_array_2 (Init)");
#define mccompcurname  channel_7_analyzer_1_array_crystal_array_2
#define mccompcurtype  Union_box
#define mccompcurindex 398
#define loop_index mccchannel_7_analyzer_1_array_crystal_array_2_loop_index
#define this_box_volume mccchannel_7_analyzer_1_array_crystal_array_2_this_box_volume
#define global_geometry_element mccchannel_7_analyzer_1_array_crystal_array_2_global_geometry_element
#define this_box_storage mccchannel_7_analyzer_1_array_crystal_array_2_this_box_storage
#define material_string mccchannel_7_analyzer_1_array_crystal_array_2_material_string
#define priority mccchannel_7_analyzer_1_array_crystal_array_2_priority
#define xwidth mccchannel_7_analyzer_1_array_crystal_array_2_xwidth
#define yheight mccchannel_7_analyzer_1_array_crystal_array_2_yheight
#define zdepth mccchannel_7_analyzer_1_array_crystal_array_2_zdepth
#define xwidth2 mccchannel_7_analyzer_1_array_crystal_array_2_xwidth2
#define yheight2 mccchannel_7_analyzer_1_array_crystal_array_2_yheight2
#define visualize mccchannel_7_analyzer_1_array_crystal_array_2_visualize
#define target_index mccchannel_7_analyzer_1_array_crystal_array_2_target_index
#define target_x mccchannel_7_analyzer_1_array_crystal_array_2_target_x
#define target_y mccchannel_7_analyzer_1_array_crystal_array_2_target_y
#define target_z mccchannel_7_analyzer_1_array_crystal_array_2_target_z
#define focus_aw mccchannel_7_analyzer_1_array_crystal_array_2_focus_aw
#define focus_ah mccchannel_7_analyzer_1_array_crystal_array_2_focus_ah
#define focus_xw mccchannel_7_analyzer_1_array_crystal_array_2_focus_xw
#define focus_xh mccchannel_7_analyzer_1_array_crystal_array_2_focus_xh
#define focus_r mccchannel_7_analyzer_1_array_crystal_array_2_focus_r
#define p_interact mccchannel_7_analyzer_1_array_crystal_array_2_p_interact
#define mask_string mccchannel_7_analyzer_1_array_crystal_array_2_mask_string
#define mask_setting mccchannel_7_analyzer_1_array_crystal_array_2_mask_setting
#define number_of_activations mccchannel_7_analyzer_1_array_crystal_array_2_number_of_activations
#line 224 "Union_box.comp"
{
// Initializes the focusing system for this volume including input sanitation.
focus_initialize(&this_box_volume.geometry, POS_A_COMP_INDEX(INDEX_CURRENT_COMP+target_index), POS_A_CURRENT_COMP, ROT_A_CURRENT_COMP, target_index, target_x, target_y, target_z, focus_aw, focus_ah, focus_xw, focus_xh, focus_r, NAME_CURRENT_COMP);

// Input sanitation for this geometry
if (xwidth <= 0) {
  printf("\nERROR in Union_box named %s, the xwidth is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (yheight <= 0) {
  printf("\nERROR in Union_box named %s, yheight is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (zdepth <= 0) {
  printf("\nERROR in Union_box named %s, zdepth is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (xwidth2 <= 0 && xwidth2 != -1) {
  printf("\nERROR in Union_box named %s, the xwidth2 is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (yheight2 <= 0 && yheight2 != -1) {
  printf("\nERROR in Union_box named %s, yheight2 is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}

// Use sanitation
if (global_material_list.num_elements == 0) {
  printf("\nERROR: Need to define a material using Union_make_material before using a Union geometry component. \n");
  printf("       %s was defined before first use of Union_make_material.\n",NAME_CURRENT_COMP);
  exit(1);
}

this_box_volume.geometry.is_masked_volume = 0;
this_box_volume.geometry.is_exit_volume = 0;
this_box_volume.geometry.is_mask_volume = 0;
// check if the volume is a mask, if it is the material string is irelevant.
if (mask_string && strlen(mask_string) && strcmp(mask_string, "NULL") && strcmp(mask_string, "0")) {
    // A mask volume is used to limit the extend of other volumes, called the masked volumes. These are specified in the mask_string.
    // In order for a ray to enter a masked volume, it needs to be both in the region covered by that volume AND the mask volume.
    // When more than
    this_box_volume.geometry.mask_mode = 1; // Default is mask mode is ALL
    if (mask_setting && strlen(mask_setting) && strcmp(mask_setting, "NULL") && strcmp(mask_setting, "0")) {
        if (strcmp(mask_setting,"ALL") == 0 || strcmp(mask_setting,"All") == 0) this_box_volume.geometry.mask_mode = 1;
        else if (strcmp(mask_setting,"ANY") == 0 || strcmp(mask_setting,"Any") == 0) this_box_volume.geometry.mask_mode = 2;
        else {
            printf("The mask_mode of component %s is set to %s, but must be either ALL or ANY.\n",NAME_CURRENT_COMP,mask_setting);
            exit(1);
        }
    }
    
    for (loop_index=0;loop_index<global_geometry_list.num_elements;loop_index++) {
        // Add mask list
        if (1 == manual_linking_function(global_geometry_list.elements[loop_index].name,mask_string)) {
            add_element_to_int_list(&this_box_volume.geometry.mask_list,global_geometry_list.elements[loop_index].component_index);
            add_element_to_int_list(&global_geometry_list.elements[loop_index].Volume->geometry.masked_by_list,INDEX_CURRENT_COMP);
            global_geometry_list.elements[loop_index].Volume->geometry.is_masked_volume = 1;
            if (this_box_volume.geometry.mask_mode == 2)
                global_geometry_list.elements[loop_index].Volume->geometry.mask_mode = 2;
            if (this_box_volume.geometry.mask_mode == 1) {
                if (global_geometry_list.elements[loop_index].Volume->geometry.is_masked_volume == 1 && global_geometry_list.elements[loop_index].Volume->geometry.mask_mode != 2)
                    // If more than one mask is added to one volume, the ANY mode overwrites the (default) ALL mode.
                    global_geometry_list.elements[loop_index].Volume->geometry.mask_mode = 1;
            }
            
            found_geometries = 1;
        }
    }
    if (found_geometries == 0) {
        printf("The mask_string in geometry: %s did not find any of the specified volumes in the mask_string %s \n",NAME_CURRENT_COMP,mask_string);
        exit(1);
    }
    this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
    this_box_volume.p_physics->is_vacuum = 0; // Makes this volume a vacuum
    this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
    this_box_volume.p_physics->my_a = 0; // Should not be used.
    sprintf(this_box_volume.p_physics->name,"Mask");
    this_box_volume.geometry.is_mask_volume = 1;
    
    
// Read the material input, or if it lacks, use automatic linking.
} else if (material_string && strlen(material_string) && strcmp(material_string, "NULL") && strcmp(material_string, "0")) {
    // A geometry string was given, use it to determine which material
    if (0 == strcmp(material_string,"vacuum") || 0 == strcmp(material_string,"Vacuum")) {
        // One could have a global physics struct for vacuum instead of creating one for each
        this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
        this_box_volume.p_physics->is_vacuum = 1; // Makes this volume a vacuum
        this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
        this_box_volume.p_physics->my_a = 0; // Should not be used.
        sprintf(this_box_volume.p_physics->name,"Vacuum");
    } else if (0 == strcmp(material_string,"exit") || 0 == strcmp(material_string,"Exit")) {
        // One could have a global physics struct for vacuum instead of creating one for each
        this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
        this_box_volume.p_physics->is_vacuum = 1; // Makes this volume a vacuum
        this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
        this_box_volume.p_physics->my_a = 0; // Should not be used.
        this_box_volume.geometry.is_exit_volume = 1;
        sprintf(this_box_volume.p_physics->name,"Exit");
    } else {
        #ifndef MATERIAL_DETECTOR
            printf("Need to define a material before refering to it in a geometry %s.\n",NAME_CURRENT_COMP);
            exit(1);
        #endif
        for (loop_index=0;loop_index<global_material_list.num_elements;loop_index++) {
            if (0 == strcmp(material_string,global_material_list.elements[loop_index].name)) {
                this_box_volume.p_physics = global_material_list.elements[loop_index].physics;
                break;
            }
            if (loop_index == global_material_list.num_elements-1) {
            printf("\n");
            printf("ERROR: The material string \"%s\" in Union geometry \"%s\" did not match a specified material. \n",material_string,NAME_CURRENT_COMP);
            printf("       The materials available at this point (need to be defined before the geometry): \n");
            for (loop_index=0;loop_index<global_material_list.num_elements;loop_index++)
              printf("         %s\n",global_material_list.elements[loop_index].name);
            printf("\n");
            printf("       It is also possible to use one of the defualt materials avaiable: \n");
            printf("           Vacuum (for a Volume without scattering or absorption)\n");
            printf("           Exit (for a Volume where the ray exits the component if it enters)\n");
            printf("           Mask (for a Volume that masks existing volumes specified in the mask_string\n");
            exit(1);
          }
        }
    }
} else {
    // Automatic linking, simply using the last defined material.
    #ifndef MATERIAL_DETECTOR
        printf("Need to define a material before the geometry to use automatic linking %s.\n",NAME_CURRENT_COMP);
        exit(1);
    #endif
    this_box_volume.p_physics = global_material_list.elements[global_material_list.num_elements-1].physics;
}

sprintf(this_box_volume.name,NAME_CURRENT_COMP);
sprintf(this_box_volume.geometry.shape,"box");
this_box_volume.geometry.priority_value = priority;
this_box_volume.geometry.geometry_p_interact = p_interact;
// Currently the coordinates will be in absolute space.
this_box_volume.geometry.center = POS_A_CURRENT_COMP;

this_box_storage.z_depth = zdepth;
this_box_storage.x_width1 = xwidth;
this_box_storage.y_height1 = yheight;

this_box_storage.is_rectangle = 0;
if (xwidth2 < 0 && yheight2 < 0) this_box_storage.is_rectangle = 1;
if (xwidth == xwidth2 && yheight == yheight2) this_box_storage.is_rectangle = 1;

if (xwidth2 < 0) {
    this_box_storage.x_width2 = xwidth;
    xwidth2 = xwidth;
} else this_box_storage.x_width2 = xwidth2;

if (yheight2 < 0) {
    this_box_storage.y_height2 = yheight;
    yheight2 = yheight;
} else this_box_storage.y_height2 = yheight2;


this_box_storage.normal_vectors[0] = coords_set(0,0,1);
this_box_storage.normal_vectors[1] = coords_set(0,0,1);

// for sides with y component = 0
x_component = 2*zdepth/sqrt((xwidth-xwidth2)*(xwidth-xwidth2)+4*zdepth*zdepth);
z_component = (xwidth-xwidth2)/sqrt(4*zdepth*zdepth+(xwidth-xwidth2)*(xwidth-xwidth2));

this_box_storage.normal_vectors[2] = coords_set(x_component,0,z_component);
this_box_storage.normal_vectors[3] = coords_set(-x_component,0,z_component);

// for sides with x component = 0
y_component = 2*zdepth/sqrt((yheight-yheight2)*(yheight-yheight2)+4*zdepth*zdepth);
z_component = (yheight-yheight2)/sqrt(4*zdepth*zdepth+(yheight-yheight2)*(yheight-yheight2));

this_box_storage.normal_vectors[4] = coords_set(0,y_component,z_component);
this_box_storage.normal_vectors[5] = coords_set(0,-y_component,z_component);

this_box_volume.geometry.visualization_on = visualize;

this_box_volume.geometry.geometry_parameters.p_box_storage = &this_box_storage;

// Assign pointers to functions for intersection with the shape, checking if a point is inside the shape
if (this_box_storage.is_rectangle == 1) {
this_box_volume.geometry.intersect_function = &sample_box_intersect_simple;
this_box_volume.geometry.within_function = &r_within_box_simple;
}
else {
this_box_volume.geometry.intersect_function = &sample_box_intersect_advanced;
this_box_volume.geometry.within_function = &r_within_box_advanced;
}

this_box_volume.geometry.shell_points = &box_shell_points;
this_box_volume.geometry.mcdisplay_function = &mcdisplay_box_function;
this_box_volume.geometry.initialize_from_main_function = &initialize_box_geometry_from_main_component;
this_box_volume.geometry.process_rot_allocated = 0;

this_box_volume.geometry.copy_geometry_parameters = &allocate_box_storage_copy;

rot_copy(this_box_volume.geometry.rotation_matrix,ROT_A_CURRENT_COMP); //check how ROT_R_CURRENT_COMP would work
rot_transpose(ROT_A_CURRENT_COMP,this_box_volume.geometry.transpose_rotation_matrix);

// Initialize loggers
this_box_volume.loggers.num_elements = 0;

// packing the information into the global_geometry_element, which is then included in the global_geometry_list.
sprintf(global_geometry_element.name,NAME_CURRENT_COMP);
global_geometry_element.activation_counter = number_of_activations;
global_geometry_element.component_index = INDEX_CURRENT_COMP;
global_geometry_element.Volume = &this_box_volume; // Would be nicer if this m was a pointer, now we have the (small) data two places
add_element_to_geometry_list(&global_geometry_list,global_geometry_element);
}
#line 227990 "MACS_sample_kidney_box.c"
#undef number_of_activations
#undef mask_setting
#undef mask_string
#undef p_interact
#undef focus_r
#undef focus_xh
#undef focus_xw
#undef focus_ah
#undef focus_aw
#undef target_z
#undef target_y
#undef target_x
#undef target_index
#undef visualize
#undef yheight2
#undef xwidth2
#undef zdepth
#undef yheight
#undef xwidth
#undef priority
#undef material_string
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

  /* Initializations for component channel_7_analyzer_1_array_crystal_array_3. */
  SIG_MESSAGE("channel_7_analyzer_1_array_crystal_array_3 (Init)");
#define mccompcurname  channel_7_analyzer_1_array_crystal_array_3
#define mccompcurtype  Union_box
#define mccompcurindex 399
#define loop_index mccchannel_7_analyzer_1_array_crystal_array_3_loop_index
#define this_box_volume mccchannel_7_analyzer_1_array_crystal_array_3_this_box_volume
#define global_geometry_element mccchannel_7_analyzer_1_array_crystal_array_3_global_geometry_element
#define this_box_storage mccchannel_7_analyzer_1_array_crystal_array_3_this_box_storage
#define material_string mccchannel_7_analyzer_1_array_crystal_array_3_material_string
#define priority mccchannel_7_analyzer_1_array_crystal_array_3_priority
#define xwidth mccchannel_7_analyzer_1_array_crystal_array_3_xwidth
#define yheight mccchannel_7_analyzer_1_array_crystal_array_3_yheight
#define zdepth mccchannel_7_analyzer_1_array_crystal_array_3_zdepth
#define xwidth2 mccchannel_7_analyzer_1_array_crystal_array_3_xwidth2
#define yheight2 mccchannel_7_analyzer_1_array_crystal_array_3_yheight2
#define visualize mccchannel_7_analyzer_1_array_crystal_array_3_visualize
#define target_index mccchannel_7_analyzer_1_array_crystal_array_3_target_index
#define target_x mccchannel_7_analyzer_1_array_crystal_array_3_target_x
#define target_y mccchannel_7_analyzer_1_array_crystal_array_3_target_y
#define target_z mccchannel_7_analyzer_1_array_crystal_array_3_target_z
#define focus_aw mccchannel_7_analyzer_1_array_crystal_array_3_focus_aw
#define focus_ah mccchannel_7_analyzer_1_array_crystal_array_3_focus_ah
#define focus_xw mccchannel_7_analyzer_1_array_crystal_array_3_focus_xw
#define focus_xh mccchannel_7_analyzer_1_array_crystal_array_3_focus_xh
#define focus_r mccchannel_7_analyzer_1_array_crystal_array_3_focus_r
#define p_interact mccchannel_7_analyzer_1_array_crystal_array_3_p_interact
#define mask_string mccchannel_7_analyzer_1_array_crystal_array_3_mask_string
#define mask_setting mccchannel_7_analyzer_1_array_crystal_array_3_mask_setting
#define number_of_activations mccchannel_7_analyzer_1_array_crystal_array_3_number_of_activations
#line 224 "Union_box.comp"
{
// Initializes the focusing system for this volume including input sanitation.
focus_initialize(&this_box_volume.geometry, POS_A_COMP_INDEX(INDEX_CURRENT_COMP+target_index), POS_A_CURRENT_COMP, ROT_A_CURRENT_COMP, target_index, target_x, target_y, target_z, focus_aw, focus_ah, focus_xw, focus_xh, focus_r, NAME_CURRENT_COMP);

// Input sanitation for this geometry
if (xwidth <= 0) {
  printf("\nERROR in Union_box named %s, the xwidth is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (yheight <= 0) {
  printf("\nERROR in Union_box named %s, yheight is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (zdepth <= 0) {
  printf("\nERROR in Union_box named %s, zdepth is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (xwidth2 <= 0 && xwidth2 != -1) {
  printf("\nERROR in Union_box named %s, the xwidth2 is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (yheight2 <= 0 && yheight2 != -1) {
  printf("\nERROR in Union_box named %s, yheight2 is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}

// Use sanitation
if (global_material_list.num_elements == 0) {
  printf("\nERROR: Need to define a material using Union_make_material before using a Union geometry component. \n");
  printf("       %s was defined before first use of Union_make_material.\n",NAME_CURRENT_COMP);
  exit(1);
}

this_box_volume.geometry.is_masked_volume = 0;
this_box_volume.geometry.is_exit_volume = 0;
this_box_volume.geometry.is_mask_volume = 0;
// check if the volume is a mask, if it is the material string is irelevant.
if (mask_string && strlen(mask_string) && strcmp(mask_string, "NULL") && strcmp(mask_string, "0")) {
    // A mask volume is used to limit the extend of other volumes, called the masked volumes. These are specified in the mask_string.
    // In order for a ray to enter a masked volume, it needs to be both in the region covered by that volume AND the mask volume.
    // When more than
    this_box_volume.geometry.mask_mode = 1; // Default is mask mode is ALL
    if (mask_setting && strlen(mask_setting) && strcmp(mask_setting, "NULL") && strcmp(mask_setting, "0")) {
        if (strcmp(mask_setting,"ALL") == 0 || strcmp(mask_setting,"All") == 0) this_box_volume.geometry.mask_mode = 1;
        else if (strcmp(mask_setting,"ANY") == 0 || strcmp(mask_setting,"Any") == 0) this_box_volume.geometry.mask_mode = 2;
        else {
            printf("The mask_mode of component %s is set to %s, but must be either ALL or ANY.\n",NAME_CURRENT_COMP,mask_setting);
            exit(1);
        }
    }
    
    for (loop_index=0;loop_index<global_geometry_list.num_elements;loop_index++) {
        // Add mask list
        if (1 == manual_linking_function(global_geometry_list.elements[loop_index].name,mask_string)) {
            add_element_to_int_list(&this_box_volume.geometry.mask_list,global_geometry_list.elements[loop_index].component_index);
            add_element_to_int_list(&global_geometry_list.elements[loop_index].Volume->geometry.masked_by_list,INDEX_CURRENT_COMP);
            global_geometry_list.elements[loop_index].Volume->geometry.is_masked_volume = 1;
            if (this_box_volume.geometry.mask_mode == 2)
                global_geometry_list.elements[loop_index].Volume->geometry.mask_mode = 2;
            if (this_box_volume.geometry.mask_mode == 1) {
                if (global_geometry_list.elements[loop_index].Volume->geometry.is_masked_volume == 1 && global_geometry_list.elements[loop_index].Volume->geometry.mask_mode != 2)
                    // If more than one mask is added to one volume, the ANY mode overwrites the (default) ALL mode.
                    global_geometry_list.elements[loop_index].Volume->geometry.mask_mode = 1;
            }
            
            found_geometries = 1;
        }
    }
    if (found_geometries == 0) {
        printf("The mask_string in geometry: %s did not find any of the specified volumes in the mask_string %s \n",NAME_CURRENT_COMP,mask_string);
        exit(1);
    }
    this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
    this_box_volume.p_physics->is_vacuum = 0; // Makes this volume a vacuum
    this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
    this_box_volume.p_physics->my_a = 0; // Should not be used.
    sprintf(this_box_volume.p_physics->name,"Mask");
    this_box_volume.geometry.is_mask_volume = 1;
    
    
// Read the material input, or if it lacks, use automatic linking.
} else if (material_string && strlen(material_string) && strcmp(material_string, "NULL") && strcmp(material_string, "0")) {
    // A geometry string was given, use it to determine which material
    if (0 == strcmp(material_string,"vacuum") || 0 == strcmp(material_string,"Vacuum")) {
        // One could have a global physics struct for vacuum instead of creating one for each
        this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
        this_box_volume.p_physics->is_vacuum = 1; // Makes this volume a vacuum
        this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
        this_box_volume.p_physics->my_a = 0; // Should not be used.
        sprintf(this_box_volume.p_physics->name,"Vacuum");
    } else if (0 == strcmp(material_string,"exit") || 0 == strcmp(material_string,"Exit")) {
        // One could have a global physics struct for vacuum instead of creating one for each
        this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
        this_box_volume.p_physics->is_vacuum = 1; // Makes this volume a vacuum
        this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
        this_box_volume.p_physics->my_a = 0; // Should not be used.
        this_box_volume.geometry.is_exit_volume = 1;
        sprintf(this_box_volume.p_physics->name,"Exit");
    } else {
        #ifndef MATERIAL_DETECTOR
            printf("Need to define a material before refering to it in a geometry %s.\n",NAME_CURRENT_COMP);
            exit(1);
        #endif
        for (loop_index=0;loop_index<global_material_list.num_elements;loop_index++) {
            if (0 == strcmp(material_string,global_material_list.elements[loop_index].name)) {
                this_box_volume.p_physics = global_material_list.elements[loop_index].physics;
                break;
            }
            if (loop_index == global_material_list.num_elements-1) {
            printf("\n");
            printf("ERROR: The material string \"%s\" in Union geometry \"%s\" did not match a specified material. \n",material_string,NAME_CURRENT_COMP);
            printf("       The materials available at this point (need to be defined before the geometry): \n");
            for (loop_index=0;loop_index<global_material_list.num_elements;loop_index++)
              printf("         %s\n",global_material_list.elements[loop_index].name);
            printf("\n");
            printf("       It is also possible to use one of the defualt materials avaiable: \n");
            printf("           Vacuum (for a Volume without scattering or absorption)\n");
            printf("           Exit (for a Volume where the ray exits the component if it enters)\n");
            printf("           Mask (for a Volume that masks existing volumes specified in the mask_string\n");
            exit(1);
          }
        }
    }
} else {
    // Automatic linking, simply using the last defined material.
    #ifndef MATERIAL_DETECTOR
        printf("Need to define a material before the geometry to use automatic linking %s.\n",NAME_CURRENT_COMP);
        exit(1);
    #endif
    this_box_volume.p_physics = global_material_list.elements[global_material_list.num_elements-1].physics;
}

sprintf(this_box_volume.name,NAME_CURRENT_COMP);
sprintf(this_box_volume.geometry.shape,"box");
this_box_volume.geometry.priority_value = priority;
this_box_volume.geometry.geometry_p_interact = p_interact;
// Currently the coordinates will be in absolute space.
this_box_volume.geometry.center = POS_A_CURRENT_COMP;

this_box_storage.z_depth = zdepth;
this_box_storage.x_width1 = xwidth;
this_box_storage.y_height1 = yheight;

this_box_storage.is_rectangle = 0;
if (xwidth2 < 0 && yheight2 < 0) this_box_storage.is_rectangle = 1;
if (xwidth == xwidth2 && yheight == yheight2) this_box_storage.is_rectangle = 1;

if (xwidth2 < 0) {
    this_box_storage.x_width2 = xwidth;
    xwidth2 = xwidth;
} else this_box_storage.x_width2 = xwidth2;

if (yheight2 < 0) {
    this_box_storage.y_height2 = yheight;
    yheight2 = yheight;
} else this_box_storage.y_height2 = yheight2;


this_box_storage.normal_vectors[0] = coords_set(0,0,1);
this_box_storage.normal_vectors[1] = coords_set(0,0,1);

// for sides with y component = 0
x_component = 2*zdepth/sqrt((xwidth-xwidth2)*(xwidth-xwidth2)+4*zdepth*zdepth);
z_component = (xwidth-xwidth2)/sqrt(4*zdepth*zdepth+(xwidth-xwidth2)*(xwidth-xwidth2));

this_box_storage.normal_vectors[2] = coords_set(x_component,0,z_component);
this_box_storage.normal_vectors[3] = coords_set(-x_component,0,z_component);

// for sides with x component = 0
y_component = 2*zdepth/sqrt((yheight-yheight2)*(yheight-yheight2)+4*zdepth*zdepth);
z_component = (yheight-yheight2)/sqrt(4*zdepth*zdepth+(yheight-yheight2)*(yheight-yheight2));

this_box_storage.normal_vectors[4] = coords_set(0,y_component,z_component);
this_box_storage.normal_vectors[5] = coords_set(0,-y_component,z_component);

this_box_volume.geometry.visualization_on = visualize;

this_box_volume.geometry.geometry_parameters.p_box_storage = &this_box_storage;

// Assign pointers to functions for intersection with the shape, checking if a point is inside the shape
if (this_box_storage.is_rectangle == 1) {
this_box_volume.geometry.intersect_function = &sample_box_intersect_simple;
this_box_volume.geometry.within_function = &r_within_box_simple;
}
else {
this_box_volume.geometry.intersect_function = &sample_box_intersect_advanced;
this_box_volume.geometry.within_function = &r_within_box_advanced;
}

this_box_volume.geometry.shell_points = &box_shell_points;
this_box_volume.geometry.mcdisplay_function = &mcdisplay_box_function;
this_box_volume.geometry.initialize_from_main_function = &initialize_box_geometry_from_main_component;
this_box_volume.geometry.process_rot_allocated = 0;

this_box_volume.geometry.copy_geometry_parameters = &allocate_box_storage_copy;

rot_copy(this_box_volume.geometry.rotation_matrix,ROT_A_CURRENT_COMP); //check how ROT_R_CURRENT_COMP would work
rot_transpose(ROT_A_CURRENT_COMP,this_box_volume.geometry.transpose_rotation_matrix);

// Initialize loggers
this_box_volume.loggers.num_elements = 0;

// packing the information into the global_geometry_element, which is then included in the global_geometry_list.
sprintf(global_geometry_element.name,NAME_CURRENT_COMP);
global_geometry_element.activation_counter = number_of_activations;
global_geometry_element.component_index = INDEX_CURRENT_COMP;
global_geometry_element.Volume = &this_box_volume; // Would be nicer if this m was a pointer, now we have the (small) data two places
add_element_to_geometry_list(&global_geometry_list,global_geometry_element);
}
#line 228260 "MACS_sample_kidney_box.c"
#undef number_of_activations
#undef mask_setting
#undef mask_string
#undef p_interact
#undef focus_r
#undef focus_xh
#undef focus_xw
#undef focus_ah
#undef focus_aw
#undef target_z
#undef target_y
#undef target_x
#undef target_index
#undef visualize
#undef yheight2
#undef xwidth2
#undef zdepth
#undef yheight
#undef xwidth
#undef priority
#undef material_string
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

  /* Initializations for component channel_7_analyzer_1_array_crystal_array_4. */
  SIG_MESSAGE("channel_7_analyzer_1_array_crystal_array_4 (Init)");
#define mccompcurname  channel_7_analyzer_1_array_crystal_array_4
#define mccompcurtype  Union_box
#define mccompcurindex 400
#define loop_index mccchannel_7_analyzer_1_array_crystal_array_4_loop_index
#define this_box_volume mccchannel_7_analyzer_1_array_crystal_array_4_this_box_volume
#define global_geometry_element mccchannel_7_analyzer_1_array_crystal_array_4_global_geometry_element
#define this_box_storage mccchannel_7_analyzer_1_array_crystal_array_4_this_box_storage
#define material_string mccchannel_7_analyzer_1_array_crystal_array_4_material_string
#define priority mccchannel_7_analyzer_1_array_crystal_array_4_priority
#define xwidth mccchannel_7_analyzer_1_array_crystal_array_4_xwidth
#define yheight mccchannel_7_analyzer_1_array_crystal_array_4_yheight
#define zdepth mccchannel_7_analyzer_1_array_crystal_array_4_zdepth
#define xwidth2 mccchannel_7_analyzer_1_array_crystal_array_4_xwidth2
#define yheight2 mccchannel_7_analyzer_1_array_crystal_array_4_yheight2
#define visualize mccchannel_7_analyzer_1_array_crystal_array_4_visualize
#define target_index mccchannel_7_analyzer_1_array_crystal_array_4_target_index
#define target_x mccchannel_7_analyzer_1_array_crystal_array_4_target_x
#define target_y mccchannel_7_analyzer_1_array_crystal_array_4_target_y
#define target_z mccchannel_7_analyzer_1_array_crystal_array_4_target_z
#define focus_aw mccchannel_7_analyzer_1_array_crystal_array_4_focus_aw
#define focus_ah mccchannel_7_analyzer_1_array_crystal_array_4_focus_ah
#define focus_xw mccchannel_7_analyzer_1_array_crystal_array_4_focus_xw
#define focus_xh mccchannel_7_analyzer_1_array_crystal_array_4_focus_xh
#define focus_r mccchannel_7_analyzer_1_array_crystal_array_4_focus_r
#define p_interact mccchannel_7_analyzer_1_array_crystal_array_4_p_interact
#define mask_string mccchannel_7_analyzer_1_array_crystal_array_4_mask_string
#define mask_setting mccchannel_7_analyzer_1_array_crystal_array_4_mask_setting
#define number_of_activations mccchannel_7_analyzer_1_array_crystal_array_4_number_of_activations
#line 224 "Union_box.comp"
{
// Initializes the focusing system for this volume including input sanitation.
focus_initialize(&this_box_volume.geometry, POS_A_COMP_INDEX(INDEX_CURRENT_COMP+target_index), POS_A_CURRENT_COMP, ROT_A_CURRENT_COMP, target_index, target_x, target_y, target_z, focus_aw, focus_ah, focus_xw, focus_xh, focus_r, NAME_CURRENT_COMP);

// Input sanitation for this geometry
if (xwidth <= 0) {
  printf("\nERROR in Union_box named %s, the xwidth is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (yheight <= 0) {
  printf("\nERROR in Union_box named %s, yheight is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (zdepth <= 0) {
  printf("\nERROR in Union_box named %s, zdepth is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (xwidth2 <= 0 && xwidth2 != -1) {
  printf("\nERROR in Union_box named %s, the xwidth2 is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (yheight2 <= 0 && yheight2 != -1) {
  printf("\nERROR in Union_box named %s, yheight2 is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}

// Use sanitation
if (global_material_list.num_elements == 0) {
  printf("\nERROR: Need to define a material using Union_make_material before using a Union geometry component. \n");
  printf("       %s was defined before first use of Union_make_material.\n",NAME_CURRENT_COMP);
  exit(1);
}

this_box_volume.geometry.is_masked_volume = 0;
this_box_volume.geometry.is_exit_volume = 0;
this_box_volume.geometry.is_mask_volume = 0;
// check if the volume is a mask, if it is the material string is irelevant.
if (mask_string && strlen(mask_string) && strcmp(mask_string, "NULL") && strcmp(mask_string, "0")) {
    // A mask volume is used to limit the extend of other volumes, called the masked volumes. These are specified in the mask_string.
    // In order for a ray to enter a masked volume, it needs to be both in the region covered by that volume AND the mask volume.
    // When more than
    this_box_volume.geometry.mask_mode = 1; // Default is mask mode is ALL
    if (mask_setting && strlen(mask_setting) && strcmp(mask_setting, "NULL") && strcmp(mask_setting, "0")) {
        if (strcmp(mask_setting,"ALL") == 0 || strcmp(mask_setting,"All") == 0) this_box_volume.geometry.mask_mode = 1;
        else if (strcmp(mask_setting,"ANY") == 0 || strcmp(mask_setting,"Any") == 0) this_box_volume.geometry.mask_mode = 2;
        else {
            printf("The mask_mode of component %s is set to %s, but must be either ALL or ANY.\n",NAME_CURRENT_COMP,mask_setting);
            exit(1);
        }
    }
    
    for (loop_index=0;loop_index<global_geometry_list.num_elements;loop_index++) {
        // Add mask list
        if (1 == manual_linking_function(global_geometry_list.elements[loop_index].name,mask_string)) {
            add_element_to_int_list(&this_box_volume.geometry.mask_list,global_geometry_list.elements[loop_index].component_index);
            add_element_to_int_list(&global_geometry_list.elements[loop_index].Volume->geometry.masked_by_list,INDEX_CURRENT_COMP);
            global_geometry_list.elements[loop_index].Volume->geometry.is_masked_volume = 1;
            if (this_box_volume.geometry.mask_mode == 2)
                global_geometry_list.elements[loop_index].Volume->geometry.mask_mode = 2;
            if (this_box_volume.geometry.mask_mode == 1) {
                if (global_geometry_list.elements[loop_index].Volume->geometry.is_masked_volume == 1 && global_geometry_list.elements[loop_index].Volume->geometry.mask_mode != 2)
                    // If more than one mask is added to one volume, the ANY mode overwrites the (default) ALL mode.
                    global_geometry_list.elements[loop_index].Volume->geometry.mask_mode = 1;
            }
            
            found_geometries = 1;
        }
    }
    if (found_geometries == 0) {
        printf("The mask_string in geometry: %s did not find any of the specified volumes in the mask_string %s \n",NAME_CURRENT_COMP,mask_string);
        exit(1);
    }
    this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
    this_box_volume.p_physics->is_vacuum = 0; // Makes this volume a vacuum
    this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
    this_box_volume.p_physics->my_a = 0; // Should not be used.
    sprintf(this_box_volume.p_physics->name,"Mask");
    this_box_volume.geometry.is_mask_volume = 1;
    
    
// Read the material input, or if it lacks, use automatic linking.
} else if (material_string && strlen(material_string) && strcmp(material_string, "NULL") && strcmp(material_string, "0")) {
    // A geometry string was given, use it to determine which material
    if (0 == strcmp(material_string,"vacuum") || 0 == strcmp(material_string,"Vacuum")) {
        // One could have a global physics struct for vacuum instead of creating one for each
        this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
        this_box_volume.p_physics->is_vacuum = 1; // Makes this volume a vacuum
        this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
        this_box_volume.p_physics->my_a = 0; // Should not be used.
        sprintf(this_box_volume.p_physics->name,"Vacuum");
    } else if (0 == strcmp(material_string,"exit") || 0 == strcmp(material_string,"Exit")) {
        // One could have a global physics struct for vacuum instead of creating one for each
        this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
        this_box_volume.p_physics->is_vacuum = 1; // Makes this volume a vacuum
        this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
        this_box_volume.p_physics->my_a = 0; // Should not be used.
        this_box_volume.geometry.is_exit_volume = 1;
        sprintf(this_box_volume.p_physics->name,"Exit");
    } else {
        #ifndef MATERIAL_DETECTOR
            printf("Need to define a material before refering to it in a geometry %s.\n",NAME_CURRENT_COMP);
            exit(1);
        #endif
        for (loop_index=0;loop_index<global_material_list.num_elements;loop_index++) {
            if (0 == strcmp(material_string,global_material_list.elements[loop_index].name)) {
                this_box_volume.p_physics = global_material_list.elements[loop_index].physics;
                break;
            }
            if (loop_index == global_material_list.num_elements-1) {
            printf("\n");
            printf("ERROR: The material string \"%s\" in Union geometry \"%s\" did not match a specified material. \n",material_string,NAME_CURRENT_COMP);
            printf("       The materials available at this point (need to be defined before the geometry): \n");
            for (loop_index=0;loop_index<global_material_list.num_elements;loop_index++)
              printf("         %s\n",global_material_list.elements[loop_index].name);
            printf("\n");
            printf("       It is also possible to use one of the defualt materials avaiable: \n");
            printf("           Vacuum (for a Volume without scattering or absorption)\n");
            printf("           Exit (for a Volume where the ray exits the component if it enters)\n");
            printf("           Mask (for a Volume that masks existing volumes specified in the mask_string\n");
            exit(1);
          }
        }
    }
} else {
    // Automatic linking, simply using the last defined material.
    #ifndef MATERIAL_DETECTOR
        printf("Need to define a material before the geometry to use automatic linking %s.\n",NAME_CURRENT_COMP);
        exit(1);
    #endif
    this_box_volume.p_physics = global_material_list.elements[global_material_list.num_elements-1].physics;
}

sprintf(this_box_volume.name,NAME_CURRENT_COMP);
sprintf(this_box_volume.geometry.shape,"box");
this_box_volume.geometry.priority_value = priority;
this_box_volume.geometry.geometry_p_interact = p_interact;
// Currently the coordinates will be in absolute space.
this_box_volume.geometry.center = POS_A_CURRENT_COMP;

this_box_storage.z_depth = zdepth;
this_box_storage.x_width1 = xwidth;
this_box_storage.y_height1 = yheight;

this_box_storage.is_rectangle = 0;
if (xwidth2 < 0 && yheight2 < 0) this_box_storage.is_rectangle = 1;
if (xwidth == xwidth2 && yheight == yheight2) this_box_storage.is_rectangle = 1;

if (xwidth2 < 0) {
    this_box_storage.x_width2 = xwidth;
    xwidth2 = xwidth;
} else this_box_storage.x_width2 = xwidth2;

if (yheight2 < 0) {
    this_box_storage.y_height2 = yheight;
    yheight2 = yheight;
} else this_box_storage.y_height2 = yheight2;


this_box_storage.normal_vectors[0] = coords_set(0,0,1);
this_box_storage.normal_vectors[1] = coords_set(0,0,1);

// for sides with y component = 0
x_component = 2*zdepth/sqrt((xwidth-xwidth2)*(xwidth-xwidth2)+4*zdepth*zdepth);
z_component = (xwidth-xwidth2)/sqrt(4*zdepth*zdepth+(xwidth-xwidth2)*(xwidth-xwidth2));

this_box_storage.normal_vectors[2] = coords_set(x_component,0,z_component);
this_box_storage.normal_vectors[3] = coords_set(-x_component,0,z_component);

// for sides with x component = 0
y_component = 2*zdepth/sqrt((yheight-yheight2)*(yheight-yheight2)+4*zdepth*zdepth);
z_component = (yheight-yheight2)/sqrt(4*zdepth*zdepth+(yheight-yheight2)*(yheight-yheight2));

this_box_storage.normal_vectors[4] = coords_set(0,y_component,z_component);
this_box_storage.normal_vectors[5] = coords_set(0,-y_component,z_component);

this_box_volume.geometry.visualization_on = visualize;

this_box_volume.geometry.geometry_parameters.p_box_storage = &this_box_storage;

// Assign pointers to functions for intersection with the shape, checking if a point is inside the shape
if (this_box_storage.is_rectangle == 1) {
this_box_volume.geometry.intersect_function = &sample_box_intersect_simple;
this_box_volume.geometry.within_function = &r_within_box_simple;
}
else {
this_box_volume.geometry.intersect_function = &sample_box_intersect_advanced;
this_box_volume.geometry.within_function = &r_within_box_advanced;
}

this_box_volume.geometry.shell_points = &box_shell_points;
this_box_volume.geometry.mcdisplay_function = &mcdisplay_box_function;
this_box_volume.geometry.initialize_from_main_function = &initialize_box_geometry_from_main_component;
this_box_volume.geometry.process_rot_allocated = 0;

this_box_volume.geometry.copy_geometry_parameters = &allocate_box_storage_copy;

rot_copy(this_box_volume.geometry.rotation_matrix,ROT_A_CURRENT_COMP); //check how ROT_R_CURRENT_COMP would work
rot_transpose(ROT_A_CURRENT_COMP,this_box_volume.geometry.transpose_rotation_matrix);

// Initialize loggers
this_box_volume.loggers.num_elements = 0;

// packing the information into the global_geometry_element, which is then included in the global_geometry_list.
sprintf(global_geometry_element.name,NAME_CURRENT_COMP);
global_geometry_element.activation_counter = number_of_activations;
global_geometry_element.component_index = INDEX_CURRENT_COMP;
global_geometry_element.Volume = &this_box_volume; // Would be nicer if this m was a pointer, now we have the (small) data two places
add_element_to_geometry_list(&global_geometry_list,global_geometry_element);
}
#line 228530 "MACS_sample_kidney_box.c"
#undef number_of_activations
#undef mask_setting
#undef mask_string
#undef p_interact
#undef focus_r
#undef focus_xh
#undef focus_xw
#undef focus_ah
#undef focus_aw
#undef target_z
#undef target_y
#undef target_x
#undef target_index
#undef visualize
#undef yheight2
#undef xwidth2
#undef zdepth
#undef yheight
#undef xwidth
#undef priority
#undef material_string
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

  /* Initializations for component channel_7_analyzer_1_array_crystal_array_5. */
  SIG_MESSAGE("channel_7_analyzer_1_array_crystal_array_5 (Init)");
#define mccompcurname  channel_7_analyzer_1_array_crystal_array_5
#define mccompcurtype  Union_box
#define mccompcurindex 401
#define loop_index mccchannel_7_analyzer_1_array_crystal_array_5_loop_index
#define this_box_volume mccchannel_7_analyzer_1_array_crystal_array_5_this_box_volume
#define global_geometry_element mccchannel_7_analyzer_1_array_crystal_array_5_global_geometry_element
#define this_box_storage mccchannel_7_analyzer_1_array_crystal_array_5_this_box_storage
#define material_string mccchannel_7_analyzer_1_array_crystal_array_5_material_string
#define priority mccchannel_7_analyzer_1_array_crystal_array_5_priority
#define xwidth mccchannel_7_analyzer_1_array_crystal_array_5_xwidth
#define yheight mccchannel_7_analyzer_1_array_crystal_array_5_yheight
#define zdepth mccchannel_7_analyzer_1_array_crystal_array_5_zdepth
#define xwidth2 mccchannel_7_analyzer_1_array_crystal_array_5_xwidth2
#define yheight2 mccchannel_7_analyzer_1_array_crystal_array_5_yheight2
#define visualize mccchannel_7_analyzer_1_array_crystal_array_5_visualize
#define target_index mccchannel_7_analyzer_1_array_crystal_array_5_target_index
#define target_x mccchannel_7_analyzer_1_array_crystal_array_5_target_x
#define target_y mccchannel_7_analyzer_1_array_crystal_array_5_target_y
#define target_z mccchannel_7_analyzer_1_array_crystal_array_5_target_z
#define focus_aw mccchannel_7_analyzer_1_array_crystal_array_5_focus_aw
#define focus_ah mccchannel_7_analyzer_1_array_crystal_array_5_focus_ah
#define focus_xw mccchannel_7_analyzer_1_array_crystal_array_5_focus_xw
#define focus_xh mccchannel_7_analyzer_1_array_crystal_array_5_focus_xh
#define focus_r mccchannel_7_analyzer_1_array_crystal_array_5_focus_r
#define p_interact mccchannel_7_analyzer_1_array_crystal_array_5_p_interact
#define mask_string mccchannel_7_analyzer_1_array_crystal_array_5_mask_string
#define mask_setting mccchannel_7_analyzer_1_array_crystal_array_5_mask_setting
#define number_of_activations mccchannel_7_analyzer_1_array_crystal_array_5_number_of_activations
#line 224 "Union_box.comp"
{
// Initializes the focusing system for this volume including input sanitation.
focus_initialize(&this_box_volume.geometry, POS_A_COMP_INDEX(INDEX_CURRENT_COMP+target_index), POS_A_CURRENT_COMP, ROT_A_CURRENT_COMP, target_index, target_x, target_y, target_z, focus_aw, focus_ah, focus_xw, focus_xh, focus_r, NAME_CURRENT_COMP);

// Input sanitation for this geometry
if (xwidth <= 0) {
  printf("\nERROR in Union_box named %s, the xwidth is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (yheight <= 0) {
  printf("\nERROR in Union_box named %s, yheight is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (zdepth <= 0) {
  printf("\nERROR in Union_box named %s, zdepth is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (xwidth2 <= 0 && xwidth2 != -1) {
  printf("\nERROR in Union_box named %s, the xwidth2 is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (yheight2 <= 0 && yheight2 != -1) {
  printf("\nERROR in Union_box named %s, yheight2 is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}

// Use sanitation
if (global_material_list.num_elements == 0) {
  printf("\nERROR: Need to define a material using Union_make_material before using a Union geometry component. \n");
  printf("       %s was defined before first use of Union_make_material.\n",NAME_CURRENT_COMP);
  exit(1);
}

this_box_volume.geometry.is_masked_volume = 0;
this_box_volume.geometry.is_exit_volume = 0;
this_box_volume.geometry.is_mask_volume = 0;
// check if the volume is a mask, if it is the material string is irelevant.
if (mask_string && strlen(mask_string) && strcmp(mask_string, "NULL") && strcmp(mask_string, "0")) {
    // A mask volume is used to limit the extend of other volumes, called the masked volumes. These are specified in the mask_string.
    // In order for a ray to enter a masked volume, it needs to be both in the region covered by that volume AND the mask volume.
    // When more than
    this_box_volume.geometry.mask_mode = 1; // Default is mask mode is ALL
    if (mask_setting && strlen(mask_setting) && strcmp(mask_setting, "NULL") && strcmp(mask_setting, "0")) {
        if (strcmp(mask_setting,"ALL") == 0 || strcmp(mask_setting,"All") == 0) this_box_volume.geometry.mask_mode = 1;
        else if (strcmp(mask_setting,"ANY") == 0 || strcmp(mask_setting,"Any") == 0) this_box_volume.geometry.mask_mode = 2;
        else {
            printf("The mask_mode of component %s is set to %s, but must be either ALL or ANY.\n",NAME_CURRENT_COMP,mask_setting);
            exit(1);
        }
    }
    
    for (loop_index=0;loop_index<global_geometry_list.num_elements;loop_index++) {
        // Add mask list
        if (1 == manual_linking_function(global_geometry_list.elements[loop_index].name,mask_string)) {
            add_element_to_int_list(&this_box_volume.geometry.mask_list,global_geometry_list.elements[loop_index].component_index);
            add_element_to_int_list(&global_geometry_list.elements[loop_index].Volume->geometry.masked_by_list,INDEX_CURRENT_COMP);
            global_geometry_list.elements[loop_index].Volume->geometry.is_masked_volume = 1;
            if (this_box_volume.geometry.mask_mode == 2)
                global_geometry_list.elements[loop_index].Volume->geometry.mask_mode = 2;
            if (this_box_volume.geometry.mask_mode == 1) {
                if (global_geometry_list.elements[loop_index].Volume->geometry.is_masked_volume == 1 && global_geometry_list.elements[loop_index].Volume->geometry.mask_mode != 2)
                    // If more than one mask is added to one volume, the ANY mode overwrites the (default) ALL mode.
                    global_geometry_list.elements[loop_index].Volume->geometry.mask_mode = 1;
            }
            
            found_geometries = 1;
        }
    }
    if (found_geometries == 0) {
        printf("The mask_string in geometry: %s did not find any of the specified volumes in the mask_string %s \n",NAME_CURRENT_COMP,mask_string);
        exit(1);
    }
    this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
    this_box_volume.p_physics->is_vacuum = 0; // Makes this volume a vacuum
    this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
    this_box_volume.p_physics->my_a = 0; // Should not be used.
    sprintf(this_box_volume.p_physics->name,"Mask");
    this_box_volume.geometry.is_mask_volume = 1;
    
    
// Read the material input, or if it lacks, use automatic linking.
} else if (material_string && strlen(material_string) && strcmp(material_string, "NULL") && strcmp(material_string, "0")) {
    // A geometry string was given, use it to determine which material
    if (0 == strcmp(material_string,"vacuum") || 0 == strcmp(material_string,"Vacuum")) {
        // One could have a global physics struct for vacuum instead of creating one for each
        this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
        this_box_volume.p_physics->is_vacuum = 1; // Makes this volume a vacuum
        this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
        this_box_volume.p_physics->my_a = 0; // Should not be used.
        sprintf(this_box_volume.p_physics->name,"Vacuum");
    } else if (0 == strcmp(material_string,"exit") || 0 == strcmp(material_string,"Exit")) {
        // One could have a global physics struct for vacuum instead of creating one for each
        this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
        this_box_volume.p_physics->is_vacuum = 1; // Makes this volume a vacuum
        this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
        this_box_volume.p_physics->my_a = 0; // Should not be used.
        this_box_volume.geometry.is_exit_volume = 1;
        sprintf(this_box_volume.p_physics->name,"Exit");
    } else {
        #ifndef MATERIAL_DETECTOR
            printf("Need to define a material before refering to it in a geometry %s.\n",NAME_CURRENT_COMP);
            exit(1);
        #endif
        for (loop_index=0;loop_index<global_material_list.num_elements;loop_index++) {
            if (0 == strcmp(material_string,global_material_list.elements[loop_index].name)) {
                this_box_volume.p_physics = global_material_list.elements[loop_index].physics;
                break;
            }
            if (loop_index == global_material_list.num_elements-1) {
            printf("\n");
            printf("ERROR: The material string \"%s\" in Union geometry \"%s\" did not match a specified material. \n",material_string,NAME_CURRENT_COMP);
            printf("       The materials available at this point (need to be defined before the geometry): \n");
            for (loop_index=0;loop_index<global_material_list.num_elements;loop_index++)
              printf("         %s\n",global_material_list.elements[loop_index].name);
            printf("\n");
            printf("       It is also possible to use one of the defualt materials avaiable: \n");
            printf("           Vacuum (for a Volume without scattering or absorption)\n");
            printf("           Exit (for a Volume where the ray exits the component if it enters)\n");
            printf("           Mask (for a Volume that masks existing volumes specified in the mask_string\n");
            exit(1);
          }
        }
    }
} else {
    // Automatic linking, simply using the last defined material.
    #ifndef MATERIAL_DETECTOR
        printf("Need to define a material before the geometry to use automatic linking %s.\n",NAME_CURRENT_COMP);
        exit(1);
    #endif
    this_box_volume.p_physics = global_material_list.elements[global_material_list.num_elements-1].physics;
}

sprintf(this_box_volume.name,NAME_CURRENT_COMP);
sprintf(this_box_volume.geometry.shape,"box");
this_box_volume.geometry.priority_value = priority;
this_box_volume.geometry.geometry_p_interact = p_interact;
// Currently the coordinates will be in absolute space.
this_box_volume.geometry.center = POS_A_CURRENT_COMP;

this_box_storage.z_depth = zdepth;
this_box_storage.x_width1 = xwidth;
this_box_storage.y_height1 = yheight;

this_box_storage.is_rectangle = 0;
if (xwidth2 < 0 && yheight2 < 0) this_box_storage.is_rectangle = 1;
if (xwidth == xwidth2 && yheight == yheight2) this_box_storage.is_rectangle = 1;

if (xwidth2 < 0) {
    this_box_storage.x_width2 = xwidth;
    xwidth2 = xwidth;
} else this_box_storage.x_width2 = xwidth2;

if (yheight2 < 0) {
    this_box_storage.y_height2 = yheight;
    yheight2 = yheight;
} else this_box_storage.y_height2 = yheight2;


this_box_storage.normal_vectors[0] = coords_set(0,0,1);
this_box_storage.normal_vectors[1] = coords_set(0,0,1);

// for sides with y component = 0
x_component = 2*zdepth/sqrt((xwidth-xwidth2)*(xwidth-xwidth2)+4*zdepth*zdepth);
z_component = (xwidth-xwidth2)/sqrt(4*zdepth*zdepth+(xwidth-xwidth2)*(xwidth-xwidth2));

this_box_storage.normal_vectors[2] = coords_set(x_component,0,z_component);
this_box_storage.normal_vectors[3] = coords_set(-x_component,0,z_component);

// for sides with x component = 0
y_component = 2*zdepth/sqrt((yheight-yheight2)*(yheight-yheight2)+4*zdepth*zdepth);
z_component = (yheight-yheight2)/sqrt(4*zdepth*zdepth+(yheight-yheight2)*(yheight-yheight2));

this_box_storage.normal_vectors[4] = coords_set(0,y_component,z_component);
this_box_storage.normal_vectors[5] = coords_set(0,-y_component,z_component);

this_box_volume.geometry.visualization_on = visualize;

this_box_volume.geometry.geometry_parameters.p_box_storage = &this_box_storage;

// Assign pointers to functions for intersection with the shape, checking if a point is inside the shape
if (this_box_storage.is_rectangle == 1) {
this_box_volume.geometry.intersect_function = &sample_box_intersect_simple;
this_box_volume.geometry.within_function = &r_within_box_simple;
}
else {
this_box_volume.geometry.intersect_function = &sample_box_intersect_advanced;
this_box_volume.geometry.within_function = &r_within_box_advanced;
}

this_box_volume.geometry.shell_points = &box_shell_points;
this_box_volume.geometry.mcdisplay_function = &mcdisplay_box_function;
this_box_volume.geometry.initialize_from_main_function = &initialize_box_geometry_from_main_component;
this_box_volume.geometry.process_rot_allocated = 0;

this_box_volume.geometry.copy_geometry_parameters = &allocate_box_storage_copy;

rot_copy(this_box_volume.geometry.rotation_matrix,ROT_A_CURRENT_COMP); //check how ROT_R_CURRENT_COMP would work
rot_transpose(ROT_A_CURRENT_COMP,this_box_volume.geometry.transpose_rotation_matrix);

// Initialize loggers
this_box_volume.loggers.num_elements = 0;

// packing the information into the global_geometry_element, which is then included in the global_geometry_list.
sprintf(global_geometry_element.name,NAME_CURRENT_COMP);
global_geometry_element.activation_counter = number_of_activations;
global_geometry_element.component_index = INDEX_CURRENT_COMP;
global_geometry_element.Volume = &this_box_volume; // Would be nicer if this m was a pointer, now we have the (small) data two places
add_element_to_geometry_list(&global_geometry_list,global_geometry_element);
}
#line 228800 "MACS_sample_kidney_box.c"
#undef number_of_activations
#undef mask_setting
#undef mask_string
#undef p_interact
#undef focus_r
#undef focus_xh
#undef focus_xw
#undef focus_ah
#undef focus_aw
#undef target_z
#undef target_y
#undef target_x
#undef target_index
#undef visualize
#undef yheight2
#undef xwidth2
#undef zdepth
#undef yheight
#undef xwidth
#undef priority
#undef material_string
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

  /* Initializations for component channel_7_analyzer_1_array_crystal_array_6. */
  SIG_MESSAGE("channel_7_analyzer_1_array_crystal_array_6 (Init)");
#define mccompcurname  channel_7_analyzer_1_array_crystal_array_6
#define mccompcurtype  Union_box
#define mccompcurindex 402
#define loop_index mccchannel_7_analyzer_1_array_crystal_array_6_loop_index
#define this_box_volume mccchannel_7_analyzer_1_array_crystal_array_6_this_box_volume
#define global_geometry_element mccchannel_7_analyzer_1_array_crystal_array_6_global_geometry_element
#define this_box_storage mccchannel_7_analyzer_1_array_crystal_array_6_this_box_storage
#define material_string mccchannel_7_analyzer_1_array_crystal_array_6_material_string
#define priority mccchannel_7_analyzer_1_array_crystal_array_6_priority
#define xwidth mccchannel_7_analyzer_1_array_crystal_array_6_xwidth
#define yheight mccchannel_7_analyzer_1_array_crystal_array_6_yheight
#define zdepth mccchannel_7_analyzer_1_array_crystal_array_6_zdepth
#define xwidth2 mccchannel_7_analyzer_1_array_crystal_array_6_xwidth2
#define yheight2 mccchannel_7_analyzer_1_array_crystal_array_6_yheight2
#define visualize mccchannel_7_analyzer_1_array_crystal_array_6_visualize
#define target_index mccchannel_7_analyzer_1_array_crystal_array_6_target_index
#define target_x mccchannel_7_analyzer_1_array_crystal_array_6_target_x
#define target_y mccchannel_7_analyzer_1_array_crystal_array_6_target_y
#define target_z mccchannel_7_analyzer_1_array_crystal_array_6_target_z
#define focus_aw mccchannel_7_analyzer_1_array_crystal_array_6_focus_aw
#define focus_ah mccchannel_7_analyzer_1_array_crystal_array_6_focus_ah
#define focus_xw mccchannel_7_analyzer_1_array_crystal_array_6_focus_xw
#define focus_xh mccchannel_7_analyzer_1_array_crystal_array_6_focus_xh
#define focus_r mccchannel_7_analyzer_1_array_crystal_array_6_focus_r
#define p_interact mccchannel_7_analyzer_1_array_crystal_array_6_p_interact
#define mask_string mccchannel_7_analyzer_1_array_crystal_array_6_mask_string
#define mask_setting mccchannel_7_analyzer_1_array_crystal_array_6_mask_setting
#define number_of_activations mccchannel_7_analyzer_1_array_crystal_array_6_number_of_activations
#line 224 "Union_box.comp"
{
// Initializes the focusing system for this volume including input sanitation.
focus_initialize(&this_box_volume.geometry, POS_A_COMP_INDEX(INDEX_CURRENT_COMP+target_index), POS_A_CURRENT_COMP, ROT_A_CURRENT_COMP, target_index, target_x, target_y, target_z, focus_aw, focus_ah, focus_xw, focus_xh, focus_r, NAME_CURRENT_COMP);

// Input sanitation for this geometry
if (xwidth <= 0) {
  printf("\nERROR in Union_box named %s, the xwidth is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (yheight <= 0) {
  printf("\nERROR in Union_box named %s, yheight is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (zdepth <= 0) {
  printf("\nERROR in Union_box named %s, zdepth is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (xwidth2 <= 0 && xwidth2 != -1) {
  printf("\nERROR in Union_box named %s, the xwidth2 is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (yheight2 <= 0 && yheight2 != -1) {
  printf("\nERROR in Union_box named %s, yheight2 is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}

// Use sanitation
if (global_material_list.num_elements == 0) {
  printf("\nERROR: Need to define a material using Union_make_material before using a Union geometry component. \n");
  printf("       %s was defined before first use of Union_make_material.\n",NAME_CURRENT_COMP);
  exit(1);
}

this_box_volume.geometry.is_masked_volume = 0;
this_box_volume.geometry.is_exit_volume = 0;
this_box_volume.geometry.is_mask_volume = 0;
// check if the volume is a mask, if it is the material string is irelevant.
if (mask_string && strlen(mask_string) && strcmp(mask_string, "NULL") && strcmp(mask_string, "0")) {
    // A mask volume is used to limit the extend of other volumes, called the masked volumes. These are specified in the mask_string.
    // In order for a ray to enter a masked volume, it needs to be both in the region covered by that volume AND the mask volume.
    // When more than
    this_box_volume.geometry.mask_mode = 1; // Default is mask mode is ALL
    if (mask_setting && strlen(mask_setting) && strcmp(mask_setting, "NULL") && strcmp(mask_setting, "0")) {
        if (strcmp(mask_setting,"ALL") == 0 || strcmp(mask_setting,"All") == 0) this_box_volume.geometry.mask_mode = 1;
        else if (strcmp(mask_setting,"ANY") == 0 || strcmp(mask_setting,"Any") == 0) this_box_volume.geometry.mask_mode = 2;
        else {
            printf("The mask_mode of component %s is set to %s, but must be either ALL or ANY.\n",NAME_CURRENT_COMP,mask_setting);
            exit(1);
        }
    }
    
    for (loop_index=0;loop_index<global_geometry_list.num_elements;loop_index++) {
        // Add mask list
        if (1 == manual_linking_function(global_geometry_list.elements[loop_index].name,mask_string)) {
            add_element_to_int_list(&this_box_volume.geometry.mask_list,global_geometry_list.elements[loop_index].component_index);
            add_element_to_int_list(&global_geometry_list.elements[loop_index].Volume->geometry.masked_by_list,INDEX_CURRENT_COMP);
            global_geometry_list.elements[loop_index].Volume->geometry.is_masked_volume = 1;
            if (this_box_volume.geometry.mask_mode == 2)
                global_geometry_list.elements[loop_index].Volume->geometry.mask_mode = 2;
            if (this_box_volume.geometry.mask_mode == 1) {
                if (global_geometry_list.elements[loop_index].Volume->geometry.is_masked_volume == 1 && global_geometry_list.elements[loop_index].Volume->geometry.mask_mode != 2)
                    // If more than one mask is added to one volume, the ANY mode overwrites the (default) ALL mode.
                    global_geometry_list.elements[loop_index].Volume->geometry.mask_mode = 1;
            }
            
            found_geometries = 1;
        }
    }
    if (found_geometries == 0) {
        printf("The mask_string in geometry: %s did not find any of the specified volumes in the mask_string %s \n",NAME_CURRENT_COMP,mask_string);
        exit(1);
    }
    this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
    this_box_volume.p_physics->is_vacuum = 0; // Makes this volume a vacuum
    this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
    this_box_volume.p_physics->my_a = 0; // Should not be used.
    sprintf(this_box_volume.p_physics->name,"Mask");
    this_box_volume.geometry.is_mask_volume = 1;
    
    
// Read the material input, or if it lacks, use automatic linking.
} else if (material_string && strlen(material_string) && strcmp(material_string, "NULL") && strcmp(material_string, "0")) {
    // A geometry string was given, use it to determine which material
    if (0 == strcmp(material_string,"vacuum") || 0 == strcmp(material_string,"Vacuum")) {
        // One could have a global physics struct for vacuum instead of creating one for each
        this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
        this_box_volume.p_physics->is_vacuum = 1; // Makes this volume a vacuum
        this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
        this_box_volume.p_physics->my_a = 0; // Should not be used.
        sprintf(this_box_volume.p_physics->name,"Vacuum");
    } else if (0 == strcmp(material_string,"exit") || 0 == strcmp(material_string,"Exit")) {
        // One could have a global physics struct for vacuum instead of creating one for each
        this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
        this_box_volume.p_physics->is_vacuum = 1; // Makes this volume a vacuum
        this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
        this_box_volume.p_physics->my_a = 0; // Should not be used.
        this_box_volume.geometry.is_exit_volume = 1;
        sprintf(this_box_volume.p_physics->name,"Exit");
    } else {
        #ifndef MATERIAL_DETECTOR
            printf("Need to define a material before refering to it in a geometry %s.\n",NAME_CURRENT_COMP);
            exit(1);
        #endif
        for (loop_index=0;loop_index<global_material_list.num_elements;loop_index++) {
            if (0 == strcmp(material_string,global_material_list.elements[loop_index].name)) {
                this_box_volume.p_physics = global_material_list.elements[loop_index].physics;
                break;
            }
            if (loop_index == global_material_list.num_elements-1) {
            printf("\n");
            printf("ERROR: The material string \"%s\" in Union geometry \"%s\" did not match a specified material. \n",material_string,NAME_CURRENT_COMP);
            printf("       The materials available at this point (need to be defined before the geometry): \n");
            for (loop_index=0;loop_index<global_material_list.num_elements;loop_index++)
              printf("         %s\n",global_material_list.elements[loop_index].name);
            printf("\n");
            printf("       It is also possible to use one of the defualt materials avaiable: \n");
            printf("           Vacuum (for a Volume without scattering or absorption)\n");
            printf("           Exit (for a Volume where the ray exits the component if it enters)\n");
            printf("           Mask (for a Volume that masks existing volumes specified in the mask_string\n");
            exit(1);
          }
        }
    }
} else {
    // Automatic linking, simply using the last defined material.
    #ifndef MATERIAL_DETECTOR
        printf("Need to define a material before the geometry to use automatic linking %s.\n",NAME_CURRENT_COMP);
        exit(1);
    #endif
    this_box_volume.p_physics = global_material_list.elements[global_material_list.num_elements-1].physics;
}

sprintf(this_box_volume.name,NAME_CURRENT_COMP);
sprintf(this_box_volume.geometry.shape,"box");
this_box_volume.geometry.priority_value = priority;
this_box_volume.geometry.geometry_p_interact = p_interact;
// Currently the coordinates will be in absolute space.
this_box_volume.geometry.center = POS_A_CURRENT_COMP;

this_box_storage.z_depth = zdepth;
this_box_storage.x_width1 = xwidth;
this_box_storage.y_height1 = yheight;

this_box_storage.is_rectangle = 0;
if (xwidth2 < 0 && yheight2 < 0) this_box_storage.is_rectangle = 1;
if (xwidth == xwidth2 && yheight == yheight2) this_box_storage.is_rectangle = 1;

if (xwidth2 < 0) {
    this_box_storage.x_width2 = xwidth;
    xwidth2 = xwidth;
} else this_box_storage.x_width2 = xwidth2;

if (yheight2 < 0) {
    this_box_storage.y_height2 = yheight;
    yheight2 = yheight;
} else this_box_storage.y_height2 = yheight2;


this_box_storage.normal_vectors[0] = coords_set(0,0,1);
this_box_storage.normal_vectors[1] = coords_set(0,0,1);

// for sides with y component = 0
x_component = 2*zdepth/sqrt((xwidth-xwidth2)*(xwidth-xwidth2)+4*zdepth*zdepth);
z_component = (xwidth-xwidth2)/sqrt(4*zdepth*zdepth+(xwidth-xwidth2)*(xwidth-xwidth2));

this_box_storage.normal_vectors[2] = coords_set(x_component,0,z_component);
this_box_storage.normal_vectors[3] = coords_set(-x_component,0,z_component);

// for sides with x component = 0
y_component = 2*zdepth/sqrt((yheight-yheight2)*(yheight-yheight2)+4*zdepth*zdepth);
z_component = (yheight-yheight2)/sqrt(4*zdepth*zdepth+(yheight-yheight2)*(yheight-yheight2));

this_box_storage.normal_vectors[4] = coords_set(0,y_component,z_component);
this_box_storage.normal_vectors[5] = coords_set(0,-y_component,z_component);

this_box_volume.geometry.visualization_on = visualize;

this_box_volume.geometry.geometry_parameters.p_box_storage = &this_box_storage;

// Assign pointers to functions for intersection with the shape, checking if a point is inside the shape
if (this_box_storage.is_rectangle == 1) {
this_box_volume.geometry.intersect_function = &sample_box_intersect_simple;
this_box_volume.geometry.within_function = &r_within_box_simple;
}
else {
this_box_volume.geometry.intersect_function = &sample_box_intersect_advanced;
this_box_volume.geometry.within_function = &r_within_box_advanced;
}

this_box_volume.geometry.shell_points = &box_shell_points;
this_box_volume.geometry.mcdisplay_function = &mcdisplay_box_function;
this_box_volume.geometry.initialize_from_main_function = &initialize_box_geometry_from_main_component;
this_box_volume.geometry.process_rot_allocated = 0;

this_box_volume.geometry.copy_geometry_parameters = &allocate_box_storage_copy;

rot_copy(this_box_volume.geometry.rotation_matrix,ROT_A_CURRENT_COMP); //check how ROT_R_CURRENT_COMP would work
rot_transpose(ROT_A_CURRENT_COMP,this_box_volume.geometry.transpose_rotation_matrix);

// Initialize loggers
this_box_volume.loggers.num_elements = 0;

// packing the information into the global_geometry_element, which is then included in the global_geometry_list.
sprintf(global_geometry_element.name,NAME_CURRENT_COMP);
global_geometry_element.activation_counter = number_of_activations;
global_geometry_element.component_index = INDEX_CURRENT_COMP;
global_geometry_element.Volume = &this_box_volume; // Would be nicer if this m was a pointer, now we have the (small) data two places
add_element_to_geometry_list(&global_geometry_list,global_geometry_element);
}
#line 229070 "MACS_sample_kidney_box.c"
#undef number_of_activations
#undef mask_setting
#undef mask_string
#undef p_interact
#undef focus_r
#undef focus_xh
#undef focus_xw
#undef focus_ah
#undef focus_aw
#undef target_z
#undef target_y
#undef target_x
#undef target_index
#undef visualize
#undef yheight2
#undef xwidth2
#undef zdepth
#undef yheight
#undef xwidth
#undef priority
#undef material_string
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

  /* Initializations for component channel_7_analyzer_1_array_crystal_array_7. */
  SIG_MESSAGE("channel_7_analyzer_1_array_crystal_array_7 (Init)");
#define mccompcurname  channel_7_analyzer_1_array_crystal_array_7
#define mccompcurtype  Union_box
#define mccompcurindex 403
#define loop_index mccchannel_7_analyzer_1_array_crystal_array_7_loop_index
#define this_box_volume mccchannel_7_analyzer_1_array_crystal_array_7_this_box_volume
#define global_geometry_element mccchannel_7_analyzer_1_array_crystal_array_7_global_geometry_element
#define this_box_storage mccchannel_7_analyzer_1_array_crystal_array_7_this_box_storage
#define material_string mccchannel_7_analyzer_1_array_crystal_array_7_material_string
#define priority mccchannel_7_analyzer_1_array_crystal_array_7_priority
#define xwidth mccchannel_7_analyzer_1_array_crystal_array_7_xwidth
#define yheight mccchannel_7_analyzer_1_array_crystal_array_7_yheight
#define zdepth mccchannel_7_analyzer_1_array_crystal_array_7_zdepth
#define xwidth2 mccchannel_7_analyzer_1_array_crystal_array_7_xwidth2
#define yheight2 mccchannel_7_analyzer_1_array_crystal_array_7_yheight2
#define visualize mccchannel_7_analyzer_1_array_crystal_array_7_visualize
#define target_index mccchannel_7_analyzer_1_array_crystal_array_7_target_index
#define target_x mccchannel_7_analyzer_1_array_crystal_array_7_target_x
#define target_y mccchannel_7_analyzer_1_array_crystal_array_7_target_y
#define target_z mccchannel_7_analyzer_1_array_crystal_array_7_target_z
#define focus_aw mccchannel_7_analyzer_1_array_crystal_array_7_focus_aw
#define focus_ah mccchannel_7_analyzer_1_array_crystal_array_7_focus_ah
#define focus_xw mccchannel_7_analyzer_1_array_crystal_array_7_focus_xw
#define focus_xh mccchannel_7_analyzer_1_array_crystal_array_7_focus_xh
#define focus_r mccchannel_7_analyzer_1_array_crystal_array_7_focus_r
#define p_interact mccchannel_7_analyzer_1_array_crystal_array_7_p_interact
#define mask_string mccchannel_7_analyzer_1_array_crystal_array_7_mask_string
#define mask_setting mccchannel_7_analyzer_1_array_crystal_array_7_mask_setting
#define number_of_activations mccchannel_7_analyzer_1_array_crystal_array_7_number_of_activations
#line 224 "Union_box.comp"
{
// Initializes the focusing system for this volume including input sanitation.
focus_initialize(&this_box_volume.geometry, POS_A_COMP_INDEX(INDEX_CURRENT_COMP+target_index), POS_A_CURRENT_COMP, ROT_A_CURRENT_COMP, target_index, target_x, target_y, target_z, focus_aw, focus_ah, focus_xw, focus_xh, focus_r, NAME_CURRENT_COMP);

// Input sanitation for this geometry
if (xwidth <= 0) {
  printf("\nERROR in Union_box named %s, the xwidth is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (yheight <= 0) {
  printf("\nERROR in Union_box named %s, yheight is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (zdepth <= 0) {
  printf("\nERROR in Union_box named %s, zdepth is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (xwidth2 <= 0 && xwidth2 != -1) {
  printf("\nERROR in Union_box named %s, the xwidth2 is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (yheight2 <= 0 && yheight2 != -1) {
  printf("\nERROR in Union_box named %s, yheight2 is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}

// Use sanitation
if (global_material_list.num_elements == 0) {
  printf("\nERROR: Need to define a material using Union_make_material before using a Union geometry component. \n");
  printf("       %s was defined before first use of Union_make_material.\n",NAME_CURRENT_COMP);
  exit(1);
}

this_box_volume.geometry.is_masked_volume = 0;
this_box_volume.geometry.is_exit_volume = 0;
this_box_volume.geometry.is_mask_volume = 0;
// check if the volume is a mask, if it is the material string is irelevant.
if (mask_string && strlen(mask_string) && strcmp(mask_string, "NULL") && strcmp(mask_string, "0")) {
    // A mask volume is used to limit the extend of other volumes, called the masked volumes. These are specified in the mask_string.
    // In order for a ray to enter a masked volume, it needs to be both in the region covered by that volume AND the mask volume.
    // When more than
    this_box_volume.geometry.mask_mode = 1; // Default is mask mode is ALL
    if (mask_setting && strlen(mask_setting) && strcmp(mask_setting, "NULL") && strcmp(mask_setting, "0")) {
        if (strcmp(mask_setting,"ALL") == 0 || strcmp(mask_setting,"All") == 0) this_box_volume.geometry.mask_mode = 1;
        else if (strcmp(mask_setting,"ANY") == 0 || strcmp(mask_setting,"Any") == 0) this_box_volume.geometry.mask_mode = 2;
        else {
            printf("The mask_mode of component %s is set to %s, but must be either ALL or ANY.\n",NAME_CURRENT_COMP,mask_setting);
            exit(1);
        }
    }
    
    for (loop_index=0;loop_index<global_geometry_list.num_elements;loop_index++) {
        // Add mask list
        if (1 == manual_linking_function(global_geometry_list.elements[loop_index].name,mask_string)) {
            add_element_to_int_list(&this_box_volume.geometry.mask_list,global_geometry_list.elements[loop_index].component_index);
            add_element_to_int_list(&global_geometry_list.elements[loop_index].Volume->geometry.masked_by_list,INDEX_CURRENT_COMP);
            global_geometry_list.elements[loop_index].Volume->geometry.is_masked_volume = 1;
            if (this_box_volume.geometry.mask_mode == 2)
                global_geometry_list.elements[loop_index].Volume->geometry.mask_mode = 2;
            if (this_box_volume.geometry.mask_mode == 1) {
                if (global_geometry_list.elements[loop_index].Volume->geometry.is_masked_volume == 1 && global_geometry_list.elements[loop_index].Volume->geometry.mask_mode != 2)
                    // If more than one mask is added to one volume, the ANY mode overwrites the (default) ALL mode.
                    global_geometry_list.elements[loop_index].Volume->geometry.mask_mode = 1;
            }
            
            found_geometries = 1;
        }
    }
    if (found_geometries == 0) {
        printf("The mask_string in geometry: %s did not find any of the specified volumes in the mask_string %s \n",NAME_CURRENT_COMP,mask_string);
        exit(1);
    }
    this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
    this_box_volume.p_physics->is_vacuum = 0; // Makes this volume a vacuum
    this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
    this_box_volume.p_physics->my_a = 0; // Should not be used.
    sprintf(this_box_volume.p_physics->name,"Mask");
    this_box_volume.geometry.is_mask_volume = 1;
    
    
// Read the material input, or if it lacks, use automatic linking.
} else if (material_string && strlen(material_string) && strcmp(material_string, "NULL") && strcmp(material_string, "0")) {
    // A geometry string was given, use it to determine which material
    if (0 == strcmp(material_string,"vacuum") || 0 == strcmp(material_string,"Vacuum")) {
        // One could have a global physics struct for vacuum instead of creating one for each
        this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
        this_box_volume.p_physics->is_vacuum = 1; // Makes this volume a vacuum
        this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
        this_box_volume.p_physics->my_a = 0; // Should not be used.
        sprintf(this_box_volume.p_physics->name,"Vacuum");
    } else if (0 == strcmp(material_string,"exit") || 0 == strcmp(material_string,"Exit")) {
        // One could have a global physics struct for vacuum instead of creating one for each
        this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
        this_box_volume.p_physics->is_vacuum = 1; // Makes this volume a vacuum
        this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
        this_box_volume.p_physics->my_a = 0; // Should not be used.
        this_box_volume.geometry.is_exit_volume = 1;
        sprintf(this_box_volume.p_physics->name,"Exit");
    } else {
        #ifndef MATERIAL_DETECTOR
            printf("Need to define a material before refering to it in a geometry %s.\n",NAME_CURRENT_COMP);
            exit(1);
        #endif
        for (loop_index=0;loop_index<global_material_list.num_elements;loop_index++) {
            if (0 == strcmp(material_string,global_material_list.elements[loop_index].name)) {
                this_box_volume.p_physics = global_material_list.elements[loop_index].physics;
                break;
            }
            if (loop_index == global_material_list.num_elements-1) {
            printf("\n");
            printf("ERROR: The material string \"%s\" in Union geometry \"%s\" did not match a specified material. \n",material_string,NAME_CURRENT_COMP);
            printf("       The materials available at this point (need to be defined before the geometry): \n");
            for (loop_index=0;loop_index<global_material_list.num_elements;loop_index++)
              printf("         %s\n",global_material_list.elements[loop_index].name);
            printf("\n");
            printf("       It is also possible to use one of the defualt materials avaiable: \n");
            printf("           Vacuum (for a Volume without scattering or absorption)\n");
            printf("           Exit (for a Volume where the ray exits the component if it enters)\n");
            printf("           Mask (for a Volume that masks existing volumes specified in the mask_string\n");
            exit(1);
          }
        }
    }
} else {
    // Automatic linking, simply using the last defined material.
    #ifndef MATERIAL_DETECTOR
        printf("Need to define a material before the geometry to use automatic linking %s.\n",NAME_CURRENT_COMP);
        exit(1);
    #endif
    this_box_volume.p_physics = global_material_list.elements[global_material_list.num_elements-1].physics;
}

sprintf(this_box_volume.name,NAME_CURRENT_COMP);
sprintf(this_box_volume.geometry.shape,"box");
this_box_volume.geometry.priority_value = priority;
this_box_volume.geometry.geometry_p_interact = p_interact;
// Currently the coordinates will be in absolute space.
this_box_volume.geometry.center = POS_A_CURRENT_COMP;

this_box_storage.z_depth = zdepth;
this_box_storage.x_width1 = xwidth;
this_box_storage.y_height1 = yheight;

this_box_storage.is_rectangle = 0;
if (xwidth2 < 0 && yheight2 < 0) this_box_storage.is_rectangle = 1;
if (xwidth == xwidth2 && yheight == yheight2) this_box_storage.is_rectangle = 1;

if (xwidth2 < 0) {
    this_box_storage.x_width2 = xwidth;
    xwidth2 = xwidth;
} else this_box_storage.x_width2 = xwidth2;

if (yheight2 < 0) {
    this_box_storage.y_height2 = yheight;
    yheight2 = yheight;
} else this_box_storage.y_height2 = yheight2;


this_box_storage.normal_vectors[0] = coords_set(0,0,1);
this_box_storage.normal_vectors[1] = coords_set(0,0,1);

// for sides with y component = 0
x_component = 2*zdepth/sqrt((xwidth-xwidth2)*(xwidth-xwidth2)+4*zdepth*zdepth);
z_component = (xwidth-xwidth2)/sqrt(4*zdepth*zdepth+(xwidth-xwidth2)*(xwidth-xwidth2));

this_box_storage.normal_vectors[2] = coords_set(x_component,0,z_component);
this_box_storage.normal_vectors[3] = coords_set(-x_component,0,z_component);

// for sides with x component = 0
y_component = 2*zdepth/sqrt((yheight-yheight2)*(yheight-yheight2)+4*zdepth*zdepth);
z_component = (yheight-yheight2)/sqrt(4*zdepth*zdepth+(yheight-yheight2)*(yheight-yheight2));

this_box_storage.normal_vectors[4] = coords_set(0,y_component,z_component);
this_box_storage.normal_vectors[5] = coords_set(0,-y_component,z_component);

this_box_volume.geometry.visualization_on = visualize;

this_box_volume.geometry.geometry_parameters.p_box_storage = &this_box_storage;

// Assign pointers to functions for intersection with the shape, checking if a point is inside the shape
if (this_box_storage.is_rectangle == 1) {
this_box_volume.geometry.intersect_function = &sample_box_intersect_simple;
this_box_volume.geometry.within_function = &r_within_box_simple;
}
else {
this_box_volume.geometry.intersect_function = &sample_box_intersect_advanced;
this_box_volume.geometry.within_function = &r_within_box_advanced;
}

this_box_volume.geometry.shell_points = &box_shell_points;
this_box_volume.geometry.mcdisplay_function = &mcdisplay_box_function;
this_box_volume.geometry.initialize_from_main_function = &initialize_box_geometry_from_main_component;
this_box_volume.geometry.process_rot_allocated = 0;

this_box_volume.geometry.copy_geometry_parameters = &allocate_box_storage_copy;

rot_copy(this_box_volume.geometry.rotation_matrix,ROT_A_CURRENT_COMP); //check how ROT_R_CURRENT_COMP would work
rot_transpose(ROT_A_CURRENT_COMP,this_box_volume.geometry.transpose_rotation_matrix);

// Initialize loggers
this_box_volume.loggers.num_elements = 0;

// packing the information into the global_geometry_element, which is then included in the global_geometry_list.
sprintf(global_geometry_element.name,NAME_CURRENT_COMP);
global_geometry_element.activation_counter = number_of_activations;
global_geometry_element.component_index = INDEX_CURRENT_COMP;
global_geometry_element.Volume = &this_box_volume; // Would be nicer if this m was a pointer, now we have the (small) data two places
add_element_to_geometry_list(&global_geometry_list,global_geometry_element);
}
#line 229340 "MACS_sample_kidney_box.c"
#undef number_of_activations
#undef mask_setting
#undef mask_string
#undef p_interact
#undef focus_r
#undef focus_xh
#undef focus_xw
#undef focus_ah
#undef focus_aw
#undef target_z
#undef target_y
#undef target_x
#undef target_index
#undef visualize
#undef yheight2
#undef xwidth2
#undef zdepth
#undef yheight
#undef xwidth
#undef priority
#undef material_string
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

  /* Initializations for component channel_7_analyzer_1_array_crystal_array_8. */
  SIG_MESSAGE("channel_7_analyzer_1_array_crystal_array_8 (Init)");
#define mccompcurname  channel_7_analyzer_1_array_crystal_array_8
#define mccompcurtype  Union_box
#define mccompcurindex 404
#define loop_index mccchannel_7_analyzer_1_array_crystal_array_8_loop_index
#define this_box_volume mccchannel_7_analyzer_1_array_crystal_array_8_this_box_volume
#define global_geometry_element mccchannel_7_analyzer_1_array_crystal_array_8_global_geometry_element
#define this_box_storage mccchannel_7_analyzer_1_array_crystal_array_8_this_box_storage
#define material_string mccchannel_7_analyzer_1_array_crystal_array_8_material_string
#define priority mccchannel_7_analyzer_1_array_crystal_array_8_priority
#define xwidth mccchannel_7_analyzer_1_array_crystal_array_8_xwidth
#define yheight mccchannel_7_analyzer_1_array_crystal_array_8_yheight
#define zdepth mccchannel_7_analyzer_1_array_crystal_array_8_zdepth
#define xwidth2 mccchannel_7_analyzer_1_array_crystal_array_8_xwidth2
#define yheight2 mccchannel_7_analyzer_1_array_crystal_array_8_yheight2
#define visualize mccchannel_7_analyzer_1_array_crystal_array_8_visualize
#define target_index mccchannel_7_analyzer_1_array_crystal_array_8_target_index
#define target_x mccchannel_7_analyzer_1_array_crystal_array_8_target_x
#define target_y mccchannel_7_analyzer_1_array_crystal_array_8_target_y
#define target_z mccchannel_7_analyzer_1_array_crystal_array_8_target_z
#define focus_aw mccchannel_7_analyzer_1_array_crystal_array_8_focus_aw
#define focus_ah mccchannel_7_analyzer_1_array_crystal_array_8_focus_ah
#define focus_xw mccchannel_7_analyzer_1_array_crystal_array_8_focus_xw
#define focus_xh mccchannel_7_analyzer_1_array_crystal_array_8_focus_xh
#define focus_r mccchannel_7_analyzer_1_array_crystal_array_8_focus_r
#define p_interact mccchannel_7_analyzer_1_array_crystal_array_8_p_interact
#define mask_string mccchannel_7_analyzer_1_array_crystal_array_8_mask_string
#define mask_setting mccchannel_7_analyzer_1_array_crystal_array_8_mask_setting
#define number_of_activations mccchannel_7_analyzer_1_array_crystal_array_8_number_of_activations
#line 224 "Union_box.comp"
{
// Initializes the focusing system for this volume including input sanitation.
focus_initialize(&this_box_volume.geometry, POS_A_COMP_INDEX(INDEX_CURRENT_COMP+target_index), POS_A_CURRENT_COMP, ROT_A_CURRENT_COMP, target_index, target_x, target_y, target_z, focus_aw, focus_ah, focus_xw, focus_xh, focus_r, NAME_CURRENT_COMP);

// Input sanitation for this geometry
if (xwidth <= 0) {
  printf("\nERROR in Union_box named %s, the xwidth is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (yheight <= 0) {
  printf("\nERROR in Union_box named %s, yheight is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (zdepth <= 0) {
  printf("\nERROR in Union_box named %s, zdepth is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (xwidth2 <= 0 && xwidth2 != -1) {
  printf("\nERROR in Union_box named %s, the xwidth2 is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (yheight2 <= 0 && yheight2 != -1) {
  printf("\nERROR in Union_box named %s, yheight2 is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}

// Use sanitation
if (global_material_list.num_elements == 0) {
  printf("\nERROR: Need to define a material using Union_make_material before using a Union geometry component. \n");
  printf("       %s was defined before first use of Union_make_material.\n",NAME_CURRENT_COMP);
  exit(1);
}

this_box_volume.geometry.is_masked_volume = 0;
this_box_volume.geometry.is_exit_volume = 0;
this_box_volume.geometry.is_mask_volume = 0;
// check if the volume is a mask, if it is the material string is irelevant.
if (mask_string && strlen(mask_string) && strcmp(mask_string, "NULL") && strcmp(mask_string, "0")) {
    // A mask volume is used to limit the extend of other volumes, called the masked volumes. These are specified in the mask_string.
    // In order for a ray to enter a masked volume, it needs to be both in the region covered by that volume AND the mask volume.
    // When more than
    this_box_volume.geometry.mask_mode = 1; // Default is mask mode is ALL
    if (mask_setting && strlen(mask_setting) && strcmp(mask_setting, "NULL") && strcmp(mask_setting, "0")) {
        if (strcmp(mask_setting,"ALL") == 0 || strcmp(mask_setting,"All") == 0) this_box_volume.geometry.mask_mode = 1;
        else if (strcmp(mask_setting,"ANY") == 0 || strcmp(mask_setting,"Any") == 0) this_box_volume.geometry.mask_mode = 2;
        else {
            printf("The mask_mode of component %s is set to %s, but must be either ALL or ANY.\n",NAME_CURRENT_COMP,mask_setting);
            exit(1);
        }
    }
    
    for (loop_index=0;loop_index<global_geometry_list.num_elements;loop_index++) {
        // Add mask list
        if (1 == manual_linking_function(global_geometry_list.elements[loop_index].name,mask_string)) {
            add_element_to_int_list(&this_box_volume.geometry.mask_list,global_geometry_list.elements[loop_index].component_index);
            add_element_to_int_list(&global_geometry_list.elements[loop_index].Volume->geometry.masked_by_list,INDEX_CURRENT_COMP);
            global_geometry_list.elements[loop_index].Volume->geometry.is_masked_volume = 1;
            if (this_box_volume.geometry.mask_mode == 2)
                global_geometry_list.elements[loop_index].Volume->geometry.mask_mode = 2;
            if (this_box_volume.geometry.mask_mode == 1) {
                if (global_geometry_list.elements[loop_index].Volume->geometry.is_masked_volume == 1 && global_geometry_list.elements[loop_index].Volume->geometry.mask_mode != 2)
                    // If more than one mask is added to one volume, the ANY mode overwrites the (default) ALL mode.
                    global_geometry_list.elements[loop_index].Volume->geometry.mask_mode = 1;
            }
            
            found_geometries = 1;
        }
    }
    if (found_geometries == 0) {
        printf("The mask_string in geometry: %s did not find any of the specified volumes in the mask_string %s \n",NAME_CURRENT_COMP,mask_string);
        exit(1);
    }
    this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
    this_box_volume.p_physics->is_vacuum = 0; // Makes this volume a vacuum
    this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
    this_box_volume.p_physics->my_a = 0; // Should not be used.
    sprintf(this_box_volume.p_physics->name,"Mask");
    this_box_volume.geometry.is_mask_volume = 1;
    
    
// Read the material input, or if it lacks, use automatic linking.
} else if (material_string && strlen(material_string) && strcmp(material_string, "NULL") && strcmp(material_string, "0")) {
    // A geometry string was given, use it to determine which material
    if (0 == strcmp(material_string,"vacuum") || 0 == strcmp(material_string,"Vacuum")) {
        // One could have a global physics struct for vacuum instead of creating one for each
        this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
        this_box_volume.p_physics->is_vacuum = 1; // Makes this volume a vacuum
        this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
        this_box_volume.p_physics->my_a = 0; // Should not be used.
        sprintf(this_box_volume.p_physics->name,"Vacuum");
    } else if (0 == strcmp(material_string,"exit") || 0 == strcmp(material_string,"Exit")) {
        // One could have a global physics struct for vacuum instead of creating one for each
        this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
        this_box_volume.p_physics->is_vacuum = 1; // Makes this volume a vacuum
        this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
        this_box_volume.p_physics->my_a = 0; // Should not be used.
        this_box_volume.geometry.is_exit_volume = 1;
        sprintf(this_box_volume.p_physics->name,"Exit");
    } else {
        #ifndef MATERIAL_DETECTOR
            printf("Need to define a material before refering to it in a geometry %s.\n",NAME_CURRENT_COMP);
            exit(1);
        #endif
        for (loop_index=0;loop_index<global_material_list.num_elements;loop_index++) {
            if (0 == strcmp(material_string,global_material_list.elements[loop_index].name)) {
                this_box_volume.p_physics = global_material_list.elements[loop_index].physics;
                break;
            }
            if (loop_index == global_material_list.num_elements-1) {
            printf("\n");
            printf("ERROR: The material string \"%s\" in Union geometry \"%s\" did not match a specified material. \n",material_string,NAME_CURRENT_COMP);
            printf("       The materials available at this point (need to be defined before the geometry): \n");
            for (loop_index=0;loop_index<global_material_list.num_elements;loop_index++)
              printf("         %s\n",global_material_list.elements[loop_index].name);
            printf("\n");
            printf("       It is also possible to use one of the defualt materials avaiable: \n");
            printf("           Vacuum (for a Volume without scattering or absorption)\n");
            printf("           Exit (for a Volume where the ray exits the component if it enters)\n");
            printf("           Mask (for a Volume that masks existing volumes specified in the mask_string\n");
            exit(1);
          }
        }
    }
} else {
    // Automatic linking, simply using the last defined material.
    #ifndef MATERIAL_DETECTOR
        printf("Need to define a material before the geometry to use automatic linking %s.\n",NAME_CURRENT_COMP);
        exit(1);
    #endif
    this_box_volume.p_physics = global_material_list.elements[global_material_list.num_elements-1].physics;
}

sprintf(this_box_volume.name,NAME_CURRENT_COMP);
sprintf(this_box_volume.geometry.shape,"box");
this_box_volume.geometry.priority_value = priority;
this_box_volume.geometry.geometry_p_interact = p_interact;
// Currently the coordinates will be in absolute space.
this_box_volume.geometry.center = POS_A_CURRENT_COMP;

this_box_storage.z_depth = zdepth;
this_box_storage.x_width1 = xwidth;
this_box_storage.y_height1 = yheight;

this_box_storage.is_rectangle = 0;
if (xwidth2 < 0 && yheight2 < 0) this_box_storage.is_rectangle = 1;
if (xwidth == xwidth2 && yheight == yheight2) this_box_storage.is_rectangle = 1;

if (xwidth2 < 0) {
    this_box_storage.x_width2 = xwidth;
    xwidth2 = xwidth;
} else this_box_storage.x_width2 = xwidth2;

if (yheight2 < 0) {
    this_box_storage.y_height2 = yheight;
    yheight2 = yheight;
} else this_box_storage.y_height2 = yheight2;


this_box_storage.normal_vectors[0] = coords_set(0,0,1);
this_box_storage.normal_vectors[1] = coords_set(0,0,1);

// for sides with y component = 0
x_component = 2*zdepth/sqrt((xwidth-xwidth2)*(xwidth-xwidth2)+4*zdepth*zdepth);
z_component = (xwidth-xwidth2)/sqrt(4*zdepth*zdepth+(xwidth-xwidth2)*(xwidth-xwidth2));

this_box_storage.normal_vectors[2] = coords_set(x_component,0,z_component);
this_box_storage.normal_vectors[3] = coords_set(-x_component,0,z_component);

// for sides with x component = 0
y_component = 2*zdepth/sqrt((yheight-yheight2)*(yheight-yheight2)+4*zdepth*zdepth);
z_component = (yheight-yheight2)/sqrt(4*zdepth*zdepth+(yheight-yheight2)*(yheight-yheight2));

this_box_storage.normal_vectors[4] = coords_set(0,y_component,z_component);
this_box_storage.normal_vectors[5] = coords_set(0,-y_component,z_component);

this_box_volume.geometry.visualization_on = visualize;

this_box_volume.geometry.geometry_parameters.p_box_storage = &this_box_storage;

// Assign pointers to functions for intersection with the shape, checking if a point is inside the shape
if (this_box_storage.is_rectangle == 1) {
this_box_volume.geometry.intersect_function = &sample_box_intersect_simple;
this_box_volume.geometry.within_function = &r_within_box_simple;
}
else {
this_box_volume.geometry.intersect_function = &sample_box_intersect_advanced;
this_box_volume.geometry.within_function = &r_within_box_advanced;
}

this_box_volume.geometry.shell_points = &box_shell_points;
this_box_volume.geometry.mcdisplay_function = &mcdisplay_box_function;
this_box_volume.geometry.initialize_from_main_function = &initialize_box_geometry_from_main_component;
this_box_volume.geometry.process_rot_allocated = 0;

this_box_volume.geometry.copy_geometry_parameters = &allocate_box_storage_copy;

rot_copy(this_box_volume.geometry.rotation_matrix,ROT_A_CURRENT_COMP); //check how ROT_R_CURRENT_COMP would work
rot_transpose(ROT_A_CURRENT_COMP,this_box_volume.geometry.transpose_rotation_matrix);

// Initialize loggers
this_box_volume.loggers.num_elements = 0;

// packing the information into the global_geometry_element, which is then included in the global_geometry_list.
sprintf(global_geometry_element.name,NAME_CURRENT_COMP);
global_geometry_element.activation_counter = number_of_activations;
global_geometry_element.component_index = INDEX_CURRENT_COMP;
global_geometry_element.Volume = &this_box_volume; // Would be nicer if this m was a pointer, now we have the (small) data two places
add_element_to_geometry_list(&global_geometry_list,global_geometry_element);
}
#line 229610 "MACS_sample_kidney_box.c"
#undef number_of_activations
#undef mask_setting
#undef mask_string
#undef p_interact
#undef focus_r
#undef focus_xh
#undef focus_xw
#undef focus_ah
#undef focus_aw
#undef target_z
#undef target_y
#undef target_x
#undef target_index
#undef visualize
#undef yheight2
#undef xwidth2
#undef zdepth
#undef yheight
#undef xwidth
#undef priority
#undef material_string
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

  /* Initializations for component channel_7_analyzer_2_center. */
  SIG_MESSAGE("channel_7_analyzer_2_center (Init)");

  /* Initializations for component channel_7_analyzer_2_rotated. */
  SIG_MESSAGE("channel_7_analyzer_2_rotated (Init)");

  /* Initializations for component channel_7_analyzer_2_array_crystal_array_0. */
  SIG_MESSAGE("channel_7_analyzer_2_array_crystal_array_0 (Init)");
#define mccompcurname  channel_7_analyzer_2_array_crystal_array_0
#define mccompcurtype  Union_box
#define mccompcurindex 407
#define loop_index mccchannel_7_analyzer_2_array_crystal_array_0_loop_index
#define this_box_volume mccchannel_7_analyzer_2_array_crystal_array_0_this_box_volume
#define global_geometry_element mccchannel_7_analyzer_2_array_crystal_array_0_global_geometry_element
#define this_box_storage mccchannel_7_analyzer_2_array_crystal_array_0_this_box_storage
#define material_string mccchannel_7_analyzer_2_array_crystal_array_0_material_string
#define priority mccchannel_7_analyzer_2_array_crystal_array_0_priority
#define xwidth mccchannel_7_analyzer_2_array_crystal_array_0_xwidth
#define yheight mccchannel_7_analyzer_2_array_crystal_array_0_yheight
#define zdepth mccchannel_7_analyzer_2_array_crystal_array_0_zdepth
#define xwidth2 mccchannel_7_analyzer_2_array_crystal_array_0_xwidth2
#define yheight2 mccchannel_7_analyzer_2_array_crystal_array_0_yheight2
#define visualize mccchannel_7_analyzer_2_array_crystal_array_0_visualize
#define target_index mccchannel_7_analyzer_2_array_crystal_array_0_target_index
#define target_x mccchannel_7_analyzer_2_array_crystal_array_0_target_x
#define target_y mccchannel_7_analyzer_2_array_crystal_array_0_target_y
#define target_z mccchannel_7_analyzer_2_array_crystal_array_0_target_z
#define focus_aw mccchannel_7_analyzer_2_array_crystal_array_0_focus_aw
#define focus_ah mccchannel_7_analyzer_2_array_crystal_array_0_focus_ah
#define focus_xw mccchannel_7_analyzer_2_array_crystal_array_0_focus_xw
#define focus_xh mccchannel_7_analyzer_2_array_crystal_array_0_focus_xh
#define focus_r mccchannel_7_analyzer_2_array_crystal_array_0_focus_r
#define p_interact mccchannel_7_analyzer_2_array_crystal_array_0_p_interact
#define mask_string mccchannel_7_analyzer_2_array_crystal_array_0_mask_string
#define mask_setting mccchannel_7_analyzer_2_array_crystal_array_0_mask_setting
#define number_of_activations mccchannel_7_analyzer_2_array_crystal_array_0_number_of_activations
#line 224 "Union_box.comp"
{
// Initializes the focusing system for this volume including input sanitation.
focus_initialize(&this_box_volume.geometry, POS_A_COMP_INDEX(INDEX_CURRENT_COMP+target_index), POS_A_CURRENT_COMP, ROT_A_CURRENT_COMP, target_index, target_x, target_y, target_z, focus_aw, focus_ah, focus_xw, focus_xh, focus_r, NAME_CURRENT_COMP);

// Input sanitation for this geometry
if (xwidth <= 0) {
  printf("\nERROR in Union_box named %s, the xwidth is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (yheight <= 0) {
  printf("\nERROR in Union_box named %s, yheight is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (zdepth <= 0) {
  printf("\nERROR in Union_box named %s, zdepth is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (xwidth2 <= 0 && xwidth2 != -1) {
  printf("\nERROR in Union_box named %s, the xwidth2 is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (yheight2 <= 0 && yheight2 != -1) {
  printf("\nERROR in Union_box named %s, yheight2 is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}

// Use sanitation
if (global_material_list.num_elements == 0) {
  printf("\nERROR: Need to define a material using Union_make_material before using a Union geometry component. \n");
  printf("       %s was defined before first use of Union_make_material.\n",NAME_CURRENT_COMP);
  exit(1);
}

this_box_volume.geometry.is_masked_volume = 0;
this_box_volume.geometry.is_exit_volume = 0;
this_box_volume.geometry.is_mask_volume = 0;
// check if the volume is a mask, if it is the material string is irelevant.
if (mask_string && strlen(mask_string) && strcmp(mask_string, "NULL") && strcmp(mask_string, "0")) {
    // A mask volume is used to limit the extend of other volumes, called the masked volumes. These are specified in the mask_string.
    // In order for a ray to enter a masked volume, it needs to be both in the region covered by that volume AND the mask volume.
    // When more than
    this_box_volume.geometry.mask_mode = 1; // Default is mask mode is ALL
    if (mask_setting && strlen(mask_setting) && strcmp(mask_setting, "NULL") && strcmp(mask_setting, "0")) {
        if (strcmp(mask_setting,"ALL") == 0 || strcmp(mask_setting,"All") == 0) this_box_volume.geometry.mask_mode = 1;
        else if (strcmp(mask_setting,"ANY") == 0 || strcmp(mask_setting,"Any") == 0) this_box_volume.geometry.mask_mode = 2;
        else {
            printf("The mask_mode of component %s is set to %s, but must be either ALL or ANY.\n",NAME_CURRENT_COMP,mask_setting);
            exit(1);
        }
    }
    
    for (loop_index=0;loop_index<global_geometry_list.num_elements;loop_index++) {
        // Add mask list
        if (1 == manual_linking_function(global_geometry_list.elements[loop_index].name,mask_string)) {
            add_element_to_int_list(&this_box_volume.geometry.mask_list,global_geometry_list.elements[loop_index].component_index);
            add_element_to_int_list(&global_geometry_list.elements[loop_index].Volume->geometry.masked_by_list,INDEX_CURRENT_COMP);
            global_geometry_list.elements[loop_index].Volume->geometry.is_masked_volume = 1;
            if (this_box_volume.geometry.mask_mode == 2)
                global_geometry_list.elements[loop_index].Volume->geometry.mask_mode = 2;
            if (this_box_volume.geometry.mask_mode == 1) {
                if (global_geometry_list.elements[loop_index].Volume->geometry.is_masked_volume == 1 && global_geometry_list.elements[loop_index].Volume->geometry.mask_mode != 2)
                    // If more than one mask is added to one volume, the ANY mode overwrites the (default) ALL mode.
                    global_geometry_list.elements[loop_index].Volume->geometry.mask_mode = 1;
            }
            
            found_geometries = 1;
        }
    }
    if (found_geometries == 0) {
        printf("The mask_string in geometry: %s did not find any of the specified volumes in the mask_string %s \n",NAME_CURRENT_COMP,mask_string);
        exit(1);
    }
    this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
    this_box_volume.p_physics->is_vacuum = 0; // Makes this volume a vacuum
    this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
    this_box_volume.p_physics->my_a = 0; // Should not be used.
    sprintf(this_box_volume.p_physics->name,"Mask");
    this_box_volume.geometry.is_mask_volume = 1;
    
    
// Read the material input, or if it lacks, use automatic linking.
} else if (material_string && strlen(material_string) && strcmp(material_string, "NULL") && strcmp(material_string, "0")) {
    // A geometry string was given, use it to determine which material
    if (0 == strcmp(material_string,"vacuum") || 0 == strcmp(material_string,"Vacuum")) {
        // One could have a global physics struct for vacuum instead of creating one for each
        this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
        this_box_volume.p_physics->is_vacuum = 1; // Makes this volume a vacuum
        this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
        this_box_volume.p_physics->my_a = 0; // Should not be used.
        sprintf(this_box_volume.p_physics->name,"Vacuum");
    } else if (0 == strcmp(material_string,"exit") || 0 == strcmp(material_string,"Exit")) {
        // One could have a global physics struct for vacuum instead of creating one for each
        this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
        this_box_volume.p_physics->is_vacuum = 1; // Makes this volume a vacuum
        this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
        this_box_volume.p_physics->my_a = 0; // Should not be used.
        this_box_volume.geometry.is_exit_volume = 1;
        sprintf(this_box_volume.p_physics->name,"Exit");
    } else {
        #ifndef MATERIAL_DETECTOR
            printf("Need to define a material before refering to it in a geometry %s.\n",NAME_CURRENT_COMP);
            exit(1);
        #endif
        for (loop_index=0;loop_index<global_material_list.num_elements;loop_index++) {
            if (0 == strcmp(material_string,global_material_list.elements[loop_index].name)) {
                this_box_volume.p_physics = global_material_list.elements[loop_index].physics;
                break;
            }
            if (loop_index == global_material_list.num_elements-1) {
            printf("\n");
            printf("ERROR: The material string \"%s\" in Union geometry \"%s\" did not match a specified material. \n",material_string,NAME_CURRENT_COMP);
            printf("       The materials available at this point (need to be defined before the geometry): \n");
            for (loop_index=0;loop_index<global_material_list.num_elements;loop_index++)
              printf("         %s\n",global_material_list.elements[loop_index].name);
            printf("\n");
            printf("       It is also possible to use one of the defualt materials avaiable: \n");
            printf("           Vacuum (for a Volume without scattering or absorption)\n");
            printf("           Exit (for a Volume where the ray exits the component if it enters)\n");
            printf("           Mask (for a Volume that masks existing volumes specified in the mask_string\n");
            exit(1);
          }
        }
    }
} else {
    // Automatic linking, simply using the last defined material.
    #ifndef MATERIAL_DETECTOR
        printf("Need to define a material before the geometry to use automatic linking %s.\n",NAME_CURRENT_COMP);
        exit(1);
    #endif
    this_box_volume.p_physics = global_material_list.elements[global_material_list.num_elements-1].physics;
}

sprintf(this_box_volume.name,NAME_CURRENT_COMP);
sprintf(this_box_volume.geometry.shape,"box");
this_box_volume.geometry.priority_value = priority;
this_box_volume.geometry.geometry_p_interact = p_interact;
// Currently the coordinates will be in absolute space.
this_box_volume.geometry.center = POS_A_CURRENT_COMP;

this_box_storage.z_depth = zdepth;
this_box_storage.x_width1 = xwidth;
this_box_storage.y_height1 = yheight;

this_box_storage.is_rectangle = 0;
if (xwidth2 < 0 && yheight2 < 0) this_box_storage.is_rectangle = 1;
if (xwidth == xwidth2 && yheight == yheight2) this_box_storage.is_rectangle = 1;

if (xwidth2 < 0) {
    this_box_storage.x_width2 = xwidth;
    xwidth2 = xwidth;
} else this_box_storage.x_width2 = xwidth2;

if (yheight2 < 0) {
    this_box_storage.y_height2 = yheight;
    yheight2 = yheight;
} else this_box_storage.y_height2 = yheight2;


this_box_storage.normal_vectors[0] = coords_set(0,0,1);
this_box_storage.normal_vectors[1] = coords_set(0,0,1);

// for sides with y component = 0
x_component = 2*zdepth/sqrt((xwidth-xwidth2)*(xwidth-xwidth2)+4*zdepth*zdepth);
z_component = (xwidth-xwidth2)/sqrt(4*zdepth*zdepth+(xwidth-xwidth2)*(xwidth-xwidth2));

this_box_storage.normal_vectors[2] = coords_set(x_component,0,z_component);
this_box_storage.normal_vectors[3] = coords_set(-x_component,0,z_component);

// for sides with x component = 0
y_component = 2*zdepth/sqrt((yheight-yheight2)*(yheight-yheight2)+4*zdepth*zdepth);
z_component = (yheight-yheight2)/sqrt(4*zdepth*zdepth+(yheight-yheight2)*(yheight-yheight2));

this_box_storage.normal_vectors[4] = coords_set(0,y_component,z_component);
this_box_storage.normal_vectors[5] = coords_set(0,-y_component,z_component);

this_box_volume.geometry.visualization_on = visualize;

this_box_volume.geometry.geometry_parameters.p_box_storage = &this_box_storage;

// Assign pointers to functions for intersection with the shape, checking if a point is inside the shape
if (this_box_storage.is_rectangle == 1) {
this_box_volume.geometry.intersect_function = &sample_box_intersect_simple;
this_box_volume.geometry.within_function = &r_within_box_simple;
}
else {
this_box_volume.geometry.intersect_function = &sample_box_intersect_advanced;
this_box_volume.geometry.within_function = &r_within_box_advanced;
}

this_box_volume.geometry.shell_points = &box_shell_points;
this_box_volume.geometry.mcdisplay_function = &mcdisplay_box_function;
this_box_volume.geometry.initialize_from_main_function = &initialize_box_geometry_from_main_component;
this_box_volume.geometry.process_rot_allocated = 0;

this_box_volume.geometry.copy_geometry_parameters = &allocate_box_storage_copy;

rot_copy(this_box_volume.geometry.rotation_matrix,ROT_A_CURRENT_COMP); //check how ROT_R_CURRENT_COMP would work
rot_transpose(ROT_A_CURRENT_COMP,this_box_volume.geometry.transpose_rotation_matrix);

// Initialize loggers
this_box_volume.loggers.num_elements = 0;

// packing the information into the global_geometry_element, which is then included in the global_geometry_list.
sprintf(global_geometry_element.name,NAME_CURRENT_COMP);
global_geometry_element.activation_counter = number_of_activations;
global_geometry_element.component_index = INDEX_CURRENT_COMP;
global_geometry_element.Volume = &this_box_volume; // Would be nicer if this m was a pointer, now we have the (small) data two places
add_element_to_geometry_list(&global_geometry_list,global_geometry_element);
}
#line 229886 "MACS_sample_kidney_box.c"
#undef number_of_activations
#undef mask_setting
#undef mask_string
#undef p_interact
#undef focus_r
#undef focus_xh
#undef focus_xw
#undef focus_ah
#undef focus_aw
#undef target_z
#undef target_y
#undef target_x
#undef target_index
#undef visualize
#undef yheight2
#undef xwidth2
#undef zdepth
#undef yheight
#undef xwidth
#undef priority
#undef material_string
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

  /* Initializations for component channel_7_analyzer_2_array_crystal_array_1. */
  SIG_MESSAGE("channel_7_analyzer_2_array_crystal_array_1 (Init)");
#define mccompcurname  channel_7_analyzer_2_array_crystal_array_1
#define mccompcurtype  Union_box
#define mccompcurindex 408
#define loop_index mccchannel_7_analyzer_2_array_crystal_array_1_loop_index
#define this_box_volume mccchannel_7_analyzer_2_array_crystal_array_1_this_box_volume
#define global_geometry_element mccchannel_7_analyzer_2_array_crystal_array_1_global_geometry_element
#define this_box_storage mccchannel_7_analyzer_2_array_crystal_array_1_this_box_storage
#define material_string mccchannel_7_analyzer_2_array_crystal_array_1_material_string
#define priority mccchannel_7_analyzer_2_array_crystal_array_1_priority
#define xwidth mccchannel_7_analyzer_2_array_crystal_array_1_xwidth
#define yheight mccchannel_7_analyzer_2_array_crystal_array_1_yheight
#define zdepth mccchannel_7_analyzer_2_array_crystal_array_1_zdepth
#define xwidth2 mccchannel_7_analyzer_2_array_crystal_array_1_xwidth2
#define yheight2 mccchannel_7_analyzer_2_array_crystal_array_1_yheight2
#define visualize mccchannel_7_analyzer_2_array_crystal_array_1_visualize
#define target_index mccchannel_7_analyzer_2_array_crystal_array_1_target_index
#define target_x mccchannel_7_analyzer_2_array_crystal_array_1_target_x
#define target_y mccchannel_7_analyzer_2_array_crystal_array_1_target_y
#define target_z mccchannel_7_analyzer_2_array_crystal_array_1_target_z
#define focus_aw mccchannel_7_analyzer_2_array_crystal_array_1_focus_aw
#define focus_ah mccchannel_7_analyzer_2_array_crystal_array_1_focus_ah
#define focus_xw mccchannel_7_analyzer_2_array_crystal_array_1_focus_xw
#define focus_xh mccchannel_7_analyzer_2_array_crystal_array_1_focus_xh
#define focus_r mccchannel_7_analyzer_2_array_crystal_array_1_focus_r
#define p_interact mccchannel_7_analyzer_2_array_crystal_array_1_p_interact
#define mask_string mccchannel_7_analyzer_2_array_crystal_array_1_mask_string
#define mask_setting mccchannel_7_analyzer_2_array_crystal_array_1_mask_setting
#define number_of_activations mccchannel_7_analyzer_2_array_crystal_array_1_number_of_activations
#line 224 "Union_box.comp"
{
// Initializes the focusing system for this volume including input sanitation.
focus_initialize(&this_box_volume.geometry, POS_A_COMP_INDEX(INDEX_CURRENT_COMP+target_index), POS_A_CURRENT_COMP, ROT_A_CURRENT_COMP, target_index, target_x, target_y, target_z, focus_aw, focus_ah, focus_xw, focus_xh, focus_r, NAME_CURRENT_COMP);

// Input sanitation for this geometry
if (xwidth <= 0) {
  printf("\nERROR in Union_box named %s, the xwidth is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (yheight <= 0) {
  printf("\nERROR in Union_box named %s, yheight is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (zdepth <= 0) {
  printf("\nERROR in Union_box named %s, zdepth is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (xwidth2 <= 0 && xwidth2 != -1) {
  printf("\nERROR in Union_box named %s, the xwidth2 is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (yheight2 <= 0 && yheight2 != -1) {
  printf("\nERROR in Union_box named %s, yheight2 is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}

// Use sanitation
if (global_material_list.num_elements == 0) {
  printf("\nERROR: Need to define a material using Union_make_material before using a Union geometry component. \n");
  printf("       %s was defined before first use of Union_make_material.\n",NAME_CURRENT_COMP);
  exit(1);
}

this_box_volume.geometry.is_masked_volume = 0;
this_box_volume.geometry.is_exit_volume = 0;
this_box_volume.geometry.is_mask_volume = 0;
// check if the volume is a mask, if it is the material string is irelevant.
if (mask_string && strlen(mask_string) && strcmp(mask_string, "NULL") && strcmp(mask_string, "0")) {
    // A mask volume is used to limit the extend of other volumes, called the masked volumes. These are specified in the mask_string.
    // In order for a ray to enter a masked volume, it needs to be both in the region covered by that volume AND the mask volume.
    // When more than
    this_box_volume.geometry.mask_mode = 1; // Default is mask mode is ALL
    if (mask_setting && strlen(mask_setting) && strcmp(mask_setting, "NULL") && strcmp(mask_setting, "0")) {
        if (strcmp(mask_setting,"ALL") == 0 || strcmp(mask_setting,"All") == 0) this_box_volume.geometry.mask_mode = 1;
        else if (strcmp(mask_setting,"ANY") == 0 || strcmp(mask_setting,"Any") == 0) this_box_volume.geometry.mask_mode = 2;
        else {
            printf("The mask_mode of component %s is set to %s, but must be either ALL or ANY.\n",NAME_CURRENT_COMP,mask_setting);
            exit(1);
        }
    }
    
    for (loop_index=0;loop_index<global_geometry_list.num_elements;loop_index++) {
        // Add mask list
        if (1 == manual_linking_function(global_geometry_list.elements[loop_index].name,mask_string)) {
            add_element_to_int_list(&this_box_volume.geometry.mask_list,global_geometry_list.elements[loop_index].component_index);
            add_element_to_int_list(&global_geometry_list.elements[loop_index].Volume->geometry.masked_by_list,INDEX_CURRENT_COMP);
            global_geometry_list.elements[loop_index].Volume->geometry.is_masked_volume = 1;
            if (this_box_volume.geometry.mask_mode == 2)
                global_geometry_list.elements[loop_index].Volume->geometry.mask_mode = 2;
            if (this_box_volume.geometry.mask_mode == 1) {
                if (global_geometry_list.elements[loop_index].Volume->geometry.is_masked_volume == 1 && global_geometry_list.elements[loop_index].Volume->geometry.mask_mode != 2)
                    // If more than one mask is added to one volume, the ANY mode overwrites the (default) ALL mode.
                    global_geometry_list.elements[loop_index].Volume->geometry.mask_mode = 1;
            }
            
            found_geometries = 1;
        }
    }
    if (found_geometries == 0) {
        printf("The mask_string in geometry: %s did not find any of the specified volumes in the mask_string %s \n",NAME_CURRENT_COMP,mask_string);
        exit(1);
    }
    this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
    this_box_volume.p_physics->is_vacuum = 0; // Makes this volume a vacuum
    this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
    this_box_volume.p_physics->my_a = 0; // Should not be used.
    sprintf(this_box_volume.p_physics->name,"Mask");
    this_box_volume.geometry.is_mask_volume = 1;
    
    
// Read the material input, or if it lacks, use automatic linking.
} else if (material_string && strlen(material_string) && strcmp(material_string, "NULL") && strcmp(material_string, "0")) {
    // A geometry string was given, use it to determine which material
    if (0 == strcmp(material_string,"vacuum") || 0 == strcmp(material_string,"Vacuum")) {
        // One could have a global physics struct for vacuum instead of creating one for each
        this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
        this_box_volume.p_physics->is_vacuum = 1; // Makes this volume a vacuum
        this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
        this_box_volume.p_physics->my_a = 0; // Should not be used.
        sprintf(this_box_volume.p_physics->name,"Vacuum");
    } else if (0 == strcmp(material_string,"exit") || 0 == strcmp(material_string,"Exit")) {
        // One could have a global physics struct for vacuum instead of creating one for each
        this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
        this_box_volume.p_physics->is_vacuum = 1; // Makes this volume a vacuum
        this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
        this_box_volume.p_physics->my_a = 0; // Should not be used.
        this_box_volume.geometry.is_exit_volume = 1;
        sprintf(this_box_volume.p_physics->name,"Exit");
    } else {
        #ifndef MATERIAL_DETECTOR
            printf("Need to define a material before refering to it in a geometry %s.\n",NAME_CURRENT_COMP);
            exit(1);
        #endif
        for (loop_index=0;loop_index<global_material_list.num_elements;loop_index++) {
            if (0 == strcmp(material_string,global_material_list.elements[loop_index].name)) {
                this_box_volume.p_physics = global_material_list.elements[loop_index].physics;
                break;
            }
            if (loop_index == global_material_list.num_elements-1) {
            printf("\n");
            printf("ERROR: The material string \"%s\" in Union geometry \"%s\" did not match a specified material. \n",material_string,NAME_CURRENT_COMP);
            printf("       The materials available at this point (need to be defined before the geometry): \n");
            for (loop_index=0;loop_index<global_material_list.num_elements;loop_index++)
              printf("         %s\n",global_material_list.elements[loop_index].name);
            printf("\n");
            printf("       It is also possible to use one of the defualt materials avaiable: \n");
            printf("           Vacuum (for a Volume without scattering or absorption)\n");
            printf("           Exit (for a Volume where the ray exits the component if it enters)\n");
            printf("           Mask (for a Volume that masks existing volumes specified in the mask_string\n");
            exit(1);
          }
        }
    }
} else {
    // Automatic linking, simply using the last defined material.
    #ifndef MATERIAL_DETECTOR
        printf("Need to define a material before the geometry to use automatic linking %s.\n",NAME_CURRENT_COMP);
        exit(1);
    #endif
    this_box_volume.p_physics = global_material_list.elements[global_material_list.num_elements-1].physics;
}

sprintf(this_box_volume.name,NAME_CURRENT_COMP);
sprintf(this_box_volume.geometry.shape,"box");
this_box_volume.geometry.priority_value = priority;
this_box_volume.geometry.geometry_p_interact = p_interact;
// Currently the coordinates will be in absolute space.
this_box_volume.geometry.center = POS_A_CURRENT_COMP;

this_box_storage.z_depth = zdepth;
this_box_storage.x_width1 = xwidth;
this_box_storage.y_height1 = yheight;

this_box_storage.is_rectangle = 0;
if (xwidth2 < 0 && yheight2 < 0) this_box_storage.is_rectangle = 1;
if (xwidth == xwidth2 && yheight == yheight2) this_box_storage.is_rectangle = 1;

if (xwidth2 < 0) {
    this_box_storage.x_width2 = xwidth;
    xwidth2 = xwidth;
} else this_box_storage.x_width2 = xwidth2;

if (yheight2 < 0) {
    this_box_storage.y_height2 = yheight;
    yheight2 = yheight;
} else this_box_storage.y_height2 = yheight2;


this_box_storage.normal_vectors[0] = coords_set(0,0,1);
this_box_storage.normal_vectors[1] = coords_set(0,0,1);

// for sides with y component = 0
x_component = 2*zdepth/sqrt((xwidth-xwidth2)*(xwidth-xwidth2)+4*zdepth*zdepth);
z_component = (xwidth-xwidth2)/sqrt(4*zdepth*zdepth+(xwidth-xwidth2)*(xwidth-xwidth2));

this_box_storage.normal_vectors[2] = coords_set(x_component,0,z_component);
this_box_storage.normal_vectors[3] = coords_set(-x_component,0,z_component);

// for sides with x component = 0
y_component = 2*zdepth/sqrt((yheight-yheight2)*(yheight-yheight2)+4*zdepth*zdepth);
z_component = (yheight-yheight2)/sqrt(4*zdepth*zdepth+(yheight-yheight2)*(yheight-yheight2));

this_box_storage.normal_vectors[4] = coords_set(0,y_component,z_component);
this_box_storage.normal_vectors[5] = coords_set(0,-y_component,z_component);

this_box_volume.geometry.visualization_on = visualize;

this_box_volume.geometry.geometry_parameters.p_box_storage = &this_box_storage;

// Assign pointers to functions for intersection with the shape, checking if a point is inside the shape
if (this_box_storage.is_rectangle == 1) {
this_box_volume.geometry.intersect_function = &sample_box_intersect_simple;
this_box_volume.geometry.within_function = &r_within_box_simple;
}
else {
this_box_volume.geometry.intersect_function = &sample_box_intersect_advanced;
this_box_volume.geometry.within_function = &r_within_box_advanced;
}

this_box_volume.geometry.shell_points = &box_shell_points;
this_box_volume.geometry.mcdisplay_function = &mcdisplay_box_function;
this_box_volume.geometry.initialize_from_main_function = &initialize_box_geometry_from_main_component;
this_box_volume.geometry.process_rot_allocated = 0;

this_box_volume.geometry.copy_geometry_parameters = &allocate_box_storage_copy;

rot_copy(this_box_volume.geometry.rotation_matrix,ROT_A_CURRENT_COMP); //check how ROT_R_CURRENT_COMP would work
rot_transpose(ROT_A_CURRENT_COMP,this_box_volume.geometry.transpose_rotation_matrix);

// Initialize loggers
this_box_volume.loggers.num_elements = 0;

// packing the information into the global_geometry_element, which is then included in the global_geometry_list.
sprintf(global_geometry_element.name,NAME_CURRENT_COMP);
global_geometry_element.activation_counter = number_of_activations;
global_geometry_element.component_index = INDEX_CURRENT_COMP;
global_geometry_element.Volume = &this_box_volume; // Would be nicer if this m was a pointer, now we have the (small) data two places
add_element_to_geometry_list(&global_geometry_list,global_geometry_element);
}
#line 230156 "MACS_sample_kidney_box.c"
#undef number_of_activations
#undef mask_setting
#undef mask_string
#undef p_interact
#undef focus_r
#undef focus_xh
#undef focus_xw
#undef focus_ah
#undef focus_aw
#undef target_z
#undef target_y
#undef target_x
#undef target_index
#undef visualize
#undef yheight2
#undef xwidth2
#undef zdepth
#undef yheight
#undef xwidth
#undef priority
#undef material_string
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

  /* Initializations for component channel_7_analyzer_2_array_crystal_array_2. */
  SIG_MESSAGE("channel_7_analyzer_2_array_crystal_array_2 (Init)");
#define mccompcurname  channel_7_analyzer_2_array_crystal_array_2
#define mccompcurtype  Union_box
#define mccompcurindex 409
#define loop_index mccchannel_7_analyzer_2_array_crystal_array_2_loop_index
#define this_box_volume mccchannel_7_analyzer_2_array_crystal_array_2_this_box_volume
#define global_geometry_element mccchannel_7_analyzer_2_array_crystal_array_2_global_geometry_element
#define this_box_storage mccchannel_7_analyzer_2_array_crystal_array_2_this_box_storage
#define material_string mccchannel_7_analyzer_2_array_crystal_array_2_material_string
#define priority mccchannel_7_analyzer_2_array_crystal_array_2_priority
#define xwidth mccchannel_7_analyzer_2_array_crystal_array_2_xwidth
#define yheight mccchannel_7_analyzer_2_array_crystal_array_2_yheight
#define zdepth mccchannel_7_analyzer_2_array_crystal_array_2_zdepth
#define xwidth2 mccchannel_7_analyzer_2_array_crystal_array_2_xwidth2
#define yheight2 mccchannel_7_analyzer_2_array_crystal_array_2_yheight2
#define visualize mccchannel_7_analyzer_2_array_crystal_array_2_visualize
#define target_index mccchannel_7_analyzer_2_array_crystal_array_2_target_index
#define target_x mccchannel_7_analyzer_2_array_crystal_array_2_target_x
#define target_y mccchannel_7_analyzer_2_array_crystal_array_2_target_y
#define target_z mccchannel_7_analyzer_2_array_crystal_array_2_target_z
#define focus_aw mccchannel_7_analyzer_2_array_crystal_array_2_focus_aw
#define focus_ah mccchannel_7_analyzer_2_array_crystal_array_2_focus_ah
#define focus_xw mccchannel_7_analyzer_2_array_crystal_array_2_focus_xw
#define focus_xh mccchannel_7_analyzer_2_array_crystal_array_2_focus_xh
#define focus_r mccchannel_7_analyzer_2_array_crystal_array_2_focus_r
#define p_interact mccchannel_7_analyzer_2_array_crystal_array_2_p_interact
#define mask_string mccchannel_7_analyzer_2_array_crystal_array_2_mask_string
#define mask_setting mccchannel_7_analyzer_2_array_crystal_array_2_mask_setting
#define number_of_activations mccchannel_7_analyzer_2_array_crystal_array_2_number_of_activations
#line 224 "Union_box.comp"
{
// Initializes the focusing system for this volume including input sanitation.
focus_initialize(&this_box_volume.geometry, POS_A_COMP_INDEX(INDEX_CURRENT_COMP+target_index), POS_A_CURRENT_COMP, ROT_A_CURRENT_COMP, target_index, target_x, target_y, target_z, focus_aw, focus_ah, focus_xw, focus_xh, focus_r, NAME_CURRENT_COMP);

// Input sanitation for this geometry
if (xwidth <= 0) {
  printf("\nERROR in Union_box named %s, the xwidth is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (yheight <= 0) {
  printf("\nERROR in Union_box named %s, yheight is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (zdepth <= 0) {
  printf("\nERROR in Union_box named %s, zdepth is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (xwidth2 <= 0 && xwidth2 != -1) {
  printf("\nERROR in Union_box named %s, the xwidth2 is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (yheight2 <= 0 && yheight2 != -1) {
  printf("\nERROR in Union_box named %s, yheight2 is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}

// Use sanitation
if (global_material_list.num_elements == 0) {
  printf("\nERROR: Need to define a material using Union_make_material before using a Union geometry component. \n");
  printf("       %s was defined before first use of Union_make_material.\n",NAME_CURRENT_COMP);
  exit(1);
}

this_box_volume.geometry.is_masked_volume = 0;
this_box_volume.geometry.is_exit_volume = 0;
this_box_volume.geometry.is_mask_volume = 0;
// check if the volume is a mask, if it is the material string is irelevant.
if (mask_string && strlen(mask_string) && strcmp(mask_string, "NULL") && strcmp(mask_string, "0")) {
    // A mask volume is used to limit the extend of other volumes, called the masked volumes. These are specified in the mask_string.
    // In order for a ray to enter a masked volume, it needs to be both in the region covered by that volume AND the mask volume.
    // When more than
    this_box_volume.geometry.mask_mode = 1; // Default is mask mode is ALL
    if (mask_setting && strlen(mask_setting) && strcmp(mask_setting, "NULL") && strcmp(mask_setting, "0")) {
        if (strcmp(mask_setting,"ALL") == 0 || strcmp(mask_setting,"All") == 0) this_box_volume.geometry.mask_mode = 1;
        else if (strcmp(mask_setting,"ANY") == 0 || strcmp(mask_setting,"Any") == 0) this_box_volume.geometry.mask_mode = 2;
        else {
            printf("The mask_mode of component %s is set to %s, but must be either ALL or ANY.\n",NAME_CURRENT_COMP,mask_setting);
            exit(1);
        }
    }
    
    for (loop_index=0;loop_index<global_geometry_list.num_elements;loop_index++) {
        // Add mask list
        if (1 == manual_linking_function(global_geometry_list.elements[loop_index].name,mask_string)) {
            add_element_to_int_list(&this_box_volume.geometry.mask_list,global_geometry_list.elements[loop_index].component_index);
            add_element_to_int_list(&global_geometry_list.elements[loop_index].Volume->geometry.masked_by_list,INDEX_CURRENT_COMP);
            global_geometry_list.elements[loop_index].Volume->geometry.is_masked_volume = 1;
            if (this_box_volume.geometry.mask_mode == 2)
                global_geometry_list.elements[loop_index].Volume->geometry.mask_mode = 2;
            if (this_box_volume.geometry.mask_mode == 1) {
                if (global_geometry_list.elements[loop_index].Volume->geometry.is_masked_volume == 1 && global_geometry_list.elements[loop_index].Volume->geometry.mask_mode != 2)
                    // If more than one mask is added to one volume, the ANY mode overwrites the (default) ALL mode.
                    global_geometry_list.elements[loop_index].Volume->geometry.mask_mode = 1;
            }
            
            found_geometries = 1;
        }
    }
    if (found_geometries == 0) {
        printf("The mask_string in geometry: %s did not find any of the specified volumes in the mask_string %s \n",NAME_CURRENT_COMP,mask_string);
        exit(1);
    }
    this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
    this_box_volume.p_physics->is_vacuum = 0; // Makes this volume a vacuum
    this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
    this_box_volume.p_physics->my_a = 0; // Should not be used.
    sprintf(this_box_volume.p_physics->name,"Mask");
    this_box_volume.geometry.is_mask_volume = 1;
    
    
// Read the material input, or if it lacks, use automatic linking.
} else if (material_string && strlen(material_string) && strcmp(material_string, "NULL") && strcmp(material_string, "0")) {
    // A geometry string was given, use it to determine which material
    if (0 == strcmp(material_string,"vacuum") || 0 == strcmp(material_string,"Vacuum")) {
        // One could have a global physics struct for vacuum instead of creating one for each
        this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
        this_box_volume.p_physics->is_vacuum = 1; // Makes this volume a vacuum
        this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
        this_box_volume.p_physics->my_a = 0; // Should not be used.
        sprintf(this_box_volume.p_physics->name,"Vacuum");
    } else if (0 == strcmp(material_string,"exit") || 0 == strcmp(material_string,"Exit")) {
        // One could have a global physics struct for vacuum instead of creating one for each
        this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
        this_box_volume.p_physics->is_vacuum = 1; // Makes this volume a vacuum
        this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
        this_box_volume.p_physics->my_a = 0; // Should not be used.
        this_box_volume.geometry.is_exit_volume = 1;
        sprintf(this_box_volume.p_physics->name,"Exit");
    } else {
        #ifndef MATERIAL_DETECTOR
            printf("Need to define a material before refering to it in a geometry %s.\n",NAME_CURRENT_COMP);
            exit(1);
        #endif
        for (loop_index=0;loop_index<global_material_list.num_elements;loop_index++) {
            if (0 == strcmp(material_string,global_material_list.elements[loop_index].name)) {
                this_box_volume.p_physics = global_material_list.elements[loop_index].physics;
                break;
            }
            if (loop_index == global_material_list.num_elements-1) {
            printf("\n");
            printf("ERROR: The material string \"%s\" in Union geometry \"%s\" did not match a specified material. \n",material_string,NAME_CURRENT_COMP);
            printf("       The materials available at this point (need to be defined before the geometry): \n");
            for (loop_index=0;loop_index<global_material_list.num_elements;loop_index++)
              printf("         %s\n",global_material_list.elements[loop_index].name);
            printf("\n");
            printf("       It is also possible to use one of the defualt materials avaiable: \n");
            printf("           Vacuum (for a Volume without scattering or absorption)\n");
            printf("           Exit (for a Volume where the ray exits the component if it enters)\n");
            printf("           Mask (for a Volume that masks existing volumes specified in the mask_string\n");
            exit(1);
          }
        }
    }
} else {
    // Automatic linking, simply using the last defined material.
    #ifndef MATERIAL_DETECTOR
        printf("Need to define a material before the geometry to use automatic linking %s.\n",NAME_CURRENT_COMP);
        exit(1);
    #endif
    this_box_volume.p_physics = global_material_list.elements[global_material_list.num_elements-1].physics;
}

sprintf(this_box_volume.name,NAME_CURRENT_COMP);
sprintf(this_box_volume.geometry.shape,"box");
this_box_volume.geometry.priority_value = priority;
this_box_volume.geometry.geometry_p_interact = p_interact;
// Currently the coordinates will be in absolute space.
this_box_volume.geometry.center = POS_A_CURRENT_COMP;

this_box_storage.z_depth = zdepth;
this_box_storage.x_width1 = xwidth;
this_box_storage.y_height1 = yheight;

this_box_storage.is_rectangle = 0;
if (xwidth2 < 0 && yheight2 < 0) this_box_storage.is_rectangle = 1;
if (xwidth == xwidth2 && yheight == yheight2) this_box_storage.is_rectangle = 1;

if (xwidth2 < 0) {
    this_box_storage.x_width2 = xwidth;
    xwidth2 = xwidth;
} else this_box_storage.x_width2 = xwidth2;

if (yheight2 < 0) {
    this_box_storage.y_height2 = yheight;
    yheight2 = yheight;
} else this_box_storage.y_height2 = yheight2;


this_box_storage.normal_vectors[0] = coords_set(0,0,1);
this_box_storage.normal_vectors[1] = coords_set(0,0,1);

// for sides with y component = 0
x_component = 2*zdepth/sqrt((xwidth-xwidth2)*(xwidth-xwidth2)+4*zdepth*zdepth);
z_component = (xwidth-xwidth2)/sqrt(4*zdepth*zdepth+(xwidth-xwidth2)*(xwidth-xwidth2));

this_box_storage.normal_vectors[2] = coords_set(x_component,0,z_component);
this_box_storage.normal_vectors[3] = coords_set(-x_component,0,z_component);

// for sides with x component = 0
y_component = 2*zdepth/sqrt((yheight-yheight2)*(yheight-yheight2)+4*zdepth*zdepth);
z_component = (yheight-yheight2)/sqrt(4*zdepth*zdepth+(yheight-yheight2)*(yheight-yheight2));

this_box_storage.normal_vectors[4] = coords_set(0,y_component,z_component);
this_box_storage.normal_vectors[5] = coords_set(0,-y_component,z_component);

this_box_volume.geometry.visualization_on = visualize;

this_box_volume.geometry.geometry_parameters.p_box_storage = &this_box_storage;

// Assign pointers to functions for intersection with the shape, checking if a point is inside the shape
if (this_box_storage.is_rectangle == 1) {
this_box_volume.geometry.intersect_function = &sample_box_intersect_simple;
this_box_volume.geometry.within_function = &r_within_box_simple;
}
else {
this_box_volume.geometry.intersect_function = &sample_box_intersect_advanced;
this_box_volume.geometry.within_function = &r_within_box_advanced;
}

this_box_volume.geometry.shell_points = &box_shell_points;
this_box_volume.geometry.mcdisplay_function = &mcdisplay_box_function;
this_box_volume.geometry.initialize_from_main_function = &initialize_box_geometry_from_main_component;
this_box_volume.geometry.process_rot_allocated = 0;

this_box_volume.geometry.copy_geometry_parameters = &allocate_box_storage_copy;

rot_copy(this_box_volume.geometry.rotation_matrix,ROT_A_CURRENT_COMP); //check how ROT_R_CURRENT_COMP would work
rot_transpose(ROT_A_CURRENT_COMP,this_box_volume.geometry.transpose_rotation_matrix);

// Initialize loggers
this_box_volume.loggers.num_elements = 0;

// packing the information into the global_geometry_element, which is then included in the global_geometry_list.
sprintf(global_geometry_element.name,NAME_CURRENT_COMP);
global_geometry_element.activation_counter = number_of_activations;
global_geometry_element.component_index = INDEX_CURRENT_COMP;
global_geometry_element.Volume = &this_box_volume; // Would be nicer if this m was a pointer, now we have the (small) data two places
add_element_to_geometry_list(&global_geometry_list,global_geometry_element);
}
#line 230426 "MACS_sample_kidney_box.c"
#undef number_of_activations
#undef mask_setting
#undef mask_string
#undef p_interact
#undef focus_r
#undef focus_xh
#undef focus_xw
#undef focus_ah
#undef focus_aw
#undef target_z
#undef target_y
#undef target_x
#undef target_index
#undef visualize
#undef yheight2
#undef xwidth2
#undef zdepth
#undef yheight
#undef xwidth
#undef priority
#undef material_string
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

  /* Initializations for component channel_7_analyzer_2_array_crystal_array_3. */
  SIG_MESSAGE("channel_7_analyzer_2_array_crystal_array_3 (Init)");
#define mccompcurname  channel_7_analyzer_2_array_crystal_array_3
#define mccompcurtype  Union_box
#define mccompcurindex 410
#define loop_index mccchannel_7_analyzer_2_array_crystal_array_3_loop_index
#define this_box_volume mccchannel_7_analyzer_2_array_crystal_array_3_this_box_volume
#define global_geometry_element mccchannel_7_analyzer_2_array_crystal_array_3_global_geometry_element
#define this_box_storage mccchannel_7_analyzer_2_array_crystal_array_3_this_box_storage
#define material_string mccchannel_7_analyzer_2_array_crystal_array_3_material_string
#define priority mccchannel_7_analyzer_2_array_crystal_array_3_priority
#define xwidth mccchannel_7_analyzer_2_array_crystal_array_3_xwidth
#define yheight mccchannel_7_analyzer_2_array_crystal_array_3_yheight
#define zdepth mccchannel_7_analyzer_2_array_crystal_array_3_zdepth
#define xwidth2 mccchannel_7_analyzer_2_array_crystal_array_3_xwidth2
#define yheight2 mccchannel_7_analyzer_2_array_crystal_array_3_yheight2
#define visualize mccchannel_7_analyzer_2_array_crystal_array_3_visualize
#define target_index mccchannel_7_analyzer_2_array_crystal_array_3_target_index
#define target_x mccchannel_7_analyzer_2_array_crystal_array_3_target_x
#define target_y mccchannel_7_analyzer_2_array_crystal_array_3_target_y
#define target_z mccchannel_7_analyzer_2_array_crystal_array_3_target_z
#define focus_aw mccchannel_7_analyzer_2_array_crystal_array_3_focus_aw
#define focus_ah mccchannel_7_analyzer_2_array_crystal_array_3_focus_ah
#define focus_xw mccchannel_7_analyzer_2_array_crystal_array_3_focus_xw
#define focus_xh mccchannel_7_analyzer_2_array_crystal_array_3_focus_xh
#define focus_r mccchannel_7_analyzer_2_array_crystal_array_3_focus_r
#define p_interact mccchannel_7_analyzer_2_array_crystal_array_3_p_interact
#define mask_string mccchannel_7_analyzer_2_array_crystal_array_3_mask_string
#define mask_setting mccchannel_7_analyzer_2_array_crystal_array_3_mask_setting
#define number_of_activations mccchannel_7_analyzer_2_array_crystal_array_3_number_of_activations
#line 224 "Union_box.comp"
{
// Initializes the focusing system for this volume including input sanitation.
focus_initialize(&this_box_volume.geometry, POS_A_COMP_INDEX(INDEX_CURRENT_COMP+target_index), POS_A_CURRENT_COMP, ROT_A_CURRENT_COMP, target_index, target_x, target_y, target_z, focus_aw, focus_ah, focus_xw, focus_xh, focus_r, NAME_CURRENT_COMP);

// Input sanitation for this geometry
if (xwidth <= 0) {
  printf("\nERROR in Union_box named %s, the xwidth is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (yheight <= 0) {
  printf("\nERROR in Union_box named %s, yheight is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (zdepth <= 0) {
  printf("\nERROR in Union_box named %s, zdepth is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (xwidth2 <= 0 && xwidth2 != -1) {
  printf("\nERROR in Union_box named %s, the xwidth2 is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (yheight2 <= 0 && yheight2 != -1) {
  printf("\nERROR in Union_box named %s, yheight2 is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}

// Use sanitation
if (global_material_list.num_elements == 0) {
  printf("\nERROR: Need to define a material using Union_make_material before using a Union geometry component. \n");
  printf("       %s was defined before first use of Union_make_material.\n",NAME_CURRENT_COMP);
  exit(1);
}

this_box_volume.geometry.is_masked_volume = 0;
this_box_volume.geometry.is_exit_volume = 0;
this_box_volume.geometry.is_mask_volume = 0;
// check if the volume is a mask, if it is the material string is irelevant.
if (mask_string && strlen(mask_string) && strcmp(mask_string, "NULL") && strcmp(mask_string, "0")) {
    // A mask volume is used to limit the extend of other volumes, called the masked volumes. These are specified in the mask_string.
    // In order for a ray to enter a masked volume, it needs to be both in the region covered by that volume AND the mask volume.
    // When more than
    this_box_volume.geometry.mask_mode = 1; // Default is mask mode is ALL
    if (mask_setting && strlen(mask_setting) && strcmp(mask_setting, "NULL") && strcmp(mask_setting, "0")) {
        if (strcmp(mask_setting,"ALL") == 0 || strcmp(mask_setting,"All") == 0) this_box_volume.geometry.mask_mode = 1;
        else if (strcmp(mask_setting,"ANY") == 0 || strcmp(mask_setting,"Any") == 0) this_box_volume.geometry.mask_mode = 2;
        else {
            printf("The mask_mode of component %s is set to %s, but must be either ALL or ANY.\n",NAME_CURRENT_COMP,mask_setting);
            exit(1);
        }
    }
    
    for (loop_index=0;loop_index<global_geometry_list.num_elements;loop_index++) {
        // Add mask list
        if (1 == manual_linking_function(global_geometry_list.elements[loop_index].name,mask_string)) {
            add_element_to_int_list(&this_box_volume.geometry.mask_list,global_geometry_list.elements[loop_index].component_index);
            add_element_to_int_list(&global_geometry_list.elements[loop_index].Volume->geometry.masked_by_list,INDEX_CURRENT_COMP);
            global_geometry_list.elements[loop_index].Volume->geometry.is_masked_volume = 1;
            if (this_box_volume.geometry.mask_mode == 2)
                global_geometry_list.elements[loop_index].Volume->geometry.mask_mode = 2;
            if (this_box_volume.geometry.mask_mode == 1) {
                if (global_geometry_list.elements[loop_index].Volume->geometry.is_masked_volume == 1 && global_geometry_list.elements[loop_index].Volume->geometry.mask_mode != 2)
                    // If more than one mask is added to one volume, the ANY mode overwrites the (default) ALL mode.
                    global_geometry_list.elements[loop_index].Volume->geometry.mask_mode = 1;
            }
            
            found_geometries = 1;
        }
    }
    if (found_geometries == 0) {
        printf("The mask_string in geometry: %s did not find any of the specified volumes in the mask_string %s \n",NAME_CURRENT_COMP,mask_string);
        exit(1);
    }
    this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
    this_box_volume.p_physics->is_vacuum = 0; // Makes this volume a vacuum
    this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
    this_box_volume.p_physics->my_a = 0; // Should not be used.
    sprintf(this_box_volume.p_physics->name,"Mask");
    this_box_volume.geometry.is_mask_volume = 1;
    
    
// Read the material input, or if it lacks, use automatic linking.
} else if (material_string && strlen(material_string) && strcmp(material_string, "NULL") && strcmp(material_string, "0")) {
    // A geometry string was given, use it to determine which material
    if (0 == strcmp(material_string,"vacuum") || 0 == strcmp(material_string,"Vacuum")) {
        // One could have a global physics struct for vacuum instead of creating one for each
        this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
        this_box_volume.p_physics->is_vacuum = 1; // Makes this volume a vacuum
        this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
        this_box_volume.p_physics->my_a = 0; // Should not be used.
        sprintf(this_box_volume.p_physics->name,"Vacuum");
    } else if (0 == strcmp(material_string,"exit") || 0 == strcmp(material_string,"Exit")) {
        // One could have a global physics struct for vacuum instead of creating one for each
        this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
        this_box_volume.p_physics->is_vacuum = 1; // Makes this volume a vacuum
        this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
        this_box_volume.p_physics->my_a = 0; // Should not be used.
        this_box_volume.geometry.is_exit_volume = 1;
        sprintf(this_box_volume.p_physics->name,"Exit");
    } else {
        #ifndef MATERIAL_DETECTOR
            printf("Need to define a material before refering to it in a geometry %s.\n",NAME_CURRENT_COMP);
            exit(1);
        #endif
        for (loop_index=0;loop_index<global_material_list.num_elements;loop_index++) {
            if (0 == strcmp(material_string,global_material_list.elements[loop_index].name)) {
                this_box_volume.p_physics = global_material_list.elements[loop_index].physics;
                break;
            }
            if (loop_index == global_material_list.num_elements-1) {
            printf("\n");
            printf("ERROR: The material string \"%s\" in Union geometry \"%s\" did not match a specified material. \n",material_string,NAME_CURRENT_COMP);
            printf("       The materials available at this point (need to be defined before the geometry): \n");
            for (loop_index=0;loop_index<global_material_list.num_elements;loop_index++)
              printf("         %s\n",global_material_list.elements[loop_index].name);
            printf("\n");
            printf("       It is also possible to use one of the defualt materials avaiable: \n");
            printf("           Vacuum (for a Volume without scattering or absorption)\n");
            printf("           Exit (for a Volume where the ray exits the component if it enters)\n");
            printf("           Mask (for a Volume that masks existing volumes specified in the mask_string\n");
            exit(1);
          }
        }
    }
} else {
    // Automatic linking, simply using the last defined material.
    #ifndef MATERIAL_DETECTOR
        printf("Need to define a material before the geometry to use automatic linking %s.\n",NAME_CURRENT_COMP);
        exit(1);
    #endif
    this_box_volume.p_physics = global_material_list.elements[global_material_list.num_elements-1].physics;
}

sprintf(this_box_volume.name,NAME_CURRENT_COMP);
sprintf(this_box_volume.geometry.shape,"box");
this_box_volume.geometry.priority_value = priority;
this_box_volume.geometry.geometry_p_interact = p_interact;
// Currently the coordinates will be in absolute space.
this_box_volume.geometry.center = POS_A_CURRENT_COMP;

this_box_storage.z_depth = zdepth;
this_box_storage.x_width1 = xwidth;
this_box_storage.y_height1 = yheight;

this_box_storage.is_rectangle = 0;
if (xwidth2 < 0 && yheight2 < 0) this_box_storage.is_rectangle = 1;
if (xwidth == xwidth2 && yheight == yheight2) this_box_storage.is_rectangle = 1;

if (xwidth2 < 0) {
    this_box_storage.x_width2 = xwidth;
    xwidth2 = xwidth;
} else this_box_storage.x_width2 = xwidth2;

if (yheight2 < 0) {
    this_box_storage.y_height2 = yheight;
    yheight2 = yheight;
} else this_box_storage.y_height2 = yheight2;


this_box_storage.normal_vectors[0] = coords_set(0,0,1);
this_box_storage.normal_vectors[1] = coords_set(0,0,1);

// for sides with y component = 0
x_component = 2*zdepth/sqrt((xwidth-xwidth2)*(xwidth-xwidth2)+4*zdepth*zdepth);
z_component = (xwidth-xwidth2)/sqrt(4*zdepth*zdepth+(xwidth-xwidth2)*(xwidth-xwidth2));

this_box_storage.normal_vectors[2] = coords_set(x_component,0,z_component);
this_box_storage.normal_vectors[3] = coords_set(-x_component,0,z_component);

// for sides with x component = 0
y_component = 2*zdepth/sqrt((yheight-yheight2)*(yheight-yheight2)+4*zdepth*zdepth);
z_component = (yheight-yheight2)/sqrt(4*zdepth*zdepth+(yheight-yheight2)*(yheight-yheight2));

this_box_storage.normal_vectors[4] = coords_set(0,y_component,z_component);
this_box_storage.normal_vectors[5] = coords_set(0,-y_component,z_component);

this_box_volume.geometry.visualization_on = visualize;

this_box_volume.geometry.geometry_parameters.p_box_storage = &this_box_storage;

// Assign pointers to functions for intersection with the shape, checking if a point is inside the shape
if (this_box_storage.is_rectangle == 1) {
this_box_volume.geometry.intersect_function = &sample_box_intersect_simple;
this_box_volume.geometry.within_function = &r_within_box_simple;
}
else {
this_box_volume.geometry.intersect_function = &sample_box_intersect_advanced;
this_box_volume.geometry.within_function = &r_within_box_advanced;
}

this_box_volume.geometry.shell_points = &box_shell_points;
this_box_volume.geometry.mcdisplay_function = &mcdisplay_box_function;
this_box_volume.geometry.initialize_from_main_function = &initialize_box_geometry_from_main_component;
this_box_volume.geometry.process_rot_allocated = 0;

this_box_volume.geometry.copy_geometry_parameters = &allocate_box_storage_copy;

rot_copy(this_box_volume.geometry.rotation_matrix,ROT_A_CURRENT_COMP); //check how ROT_R_CURRENT_COMP would work
rot_transpose(ROT_A_CURRENT_COMP,this_box_volume.geometry.transpose_rotation_matrix);

// Initialize loggers
this_box_volume.loggers.num_elements = 0;

// packing the information into the global_geometry_element, which is then included in the global_geometry_list.
sprintf(global_geometry_element.name,NAME_CURRENT_COMP);
global_geometry_element.activation_counter = number_of_activations;
global_geometry_element.component_index = INDEX_CURRENT_COMP;
global_geometry_element.Volume = &this_box_volume; // Would be nicer if this m was a pointer, now we have the (small) data two places
add_element_to_geometry_list(&global_geometry_list,global_geometry_element);
}
#line 230696 "MACS_sample_kidney_box.c"
#undef number_of_activations
#undef mask_setting
#undef mask_string
#undef p_interact
#undef focus_r
#undef focus_xh
#undef focus_xw
#undef focus_ah
#undef focus_aw
#undef target_z
#undef target_y
#undef target_x
#undef target_index
#undef visualize
#undef yheight2
#undef xwidth2
#undef zdepth
#undef yheight
#undef xwidth
#undef priority
#undef material_string
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

  /* Initializations for component channel_7_analyzer_2_array_crystal_array_4. */
  SIG_MESSAGE("channel_7_analyzer_2_array_crystal_array_4 (Init)");
#define mccompcurname  channel_7_analyzer_2_array_crystal_array_4
#define mccompcurtype  Union_box
#define mccompcurindex 411
#define loop_index mccchannel_7_analyzer_2_array_crystal_array_4_loop_index
#define this_box_volume mccchannel_7_analyzer_2_array_crystal_array_4_this_box_volume
#define global_geometry_element mccchannel_7_analyzer_2_array_crystal_array_4_global_geometry_element
#define this_box_storage mccchannel_7_analyzer_2_array_crystal_array_4_this_box_storage
#define material_string mccchannel_7_analyzer_2_array_crystal_array_4_material_string
#define priority mccchannel_7_analyzer_2_array_crystal_array_4_priority
#define xwidth mccchannel_7_analyzer_2_array_crystal_array_4_xwidth
#define yheight mccchannel_7_analyzer_2_array_crystal_array_4_yheight
#define zdepth mccchannel_7_analyzer_2_array_crystal_array_4_zdepth
#define xwidth2 mccchannel_7_analyzer_2_array_crystal_array_4_xwidth2
#define yheight2 mccchannel_7_analyzer_2_array_crystal_array_4_yheight2
#define visualize mccchannel_7_analyzer_2_array_crystal_array_4_visualize
#define target_index mccchannel_7_analyzer_2_array_crystal_array_4_target_index
#define target_x mccchannel_7_analyzer_2_array_crystal_array_4_target_x
#define target_y mccchannel_7_analyzer_2_array_crystal_array_4_target_y
#define target_z mccchannel_7_analyzer_2_array_crystal_array_4_target_z
#define focus_aw mccchannel_7_analyzer_2_array_crystal_array_4_focus_aw
#define focus_ah mccchannel_7_analyzer_2_array_crystal_array_4_focus_ah
#define focus_xw mccchannel_7_analyzer_2_array_crystal_array_4_focus_xw
#define focus_xh mccchannel_7_analyzer_2_array_crystal_array_4_focus_xh
#define focus_r mccchannel_7_analyzer_2_array_crystal_array_4_focus_r
#define p_interact mccchannel_7_analyzer_2_array_crystal_array_4_p_interact
#define mask_string mccchannel_7_analyzer_2_array_crystal_array_4_mask_string
#define mask_setting mccchannel_7_analyzer_2_array_crystal_array_4_mask_setting
#define number_of_activations mccchannel_7_analyzer_2_array_crystal_array_4_number_of_activations
#line 224 "Union_box.comp"
{
// Initializes the focusing system for this volume including input sanitation.
focus_initialize(&this_box_volume.geometry, POS_A_COMP_INDEX(INDEX_CURRENT_COMP+target_index), POS_A_CURRENT_COMP, ROT_A_CURRENT_COMP, target_index, target_x, target_y, target_z, focus_aw, focus_ah, focus_xw, focus_xh, focus_r, NAME_CURRENT_COMP);

// Input sanitation for this geometry
if (xwidth <= 0) {
  printf("\nERROR in Union_box named %s, the xwidth is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (yheight <= 0) {
  printf("\nERROR in Union_box named %s, yheight is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (zdepth <= 0) {
  printf("\nERROR in Union_box named %s, zdepth is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (xwidth2 <= 0 && xwidth2 != -1) {
  printf("\nERROR in Union_box named %s, the xwidth2 is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (yheight2 <= 0 && yheight2 != -1) {
  printf("\nERROR in Union_box named %s, yheight2 is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}

// Use sanitation
if (global_material_list.num_elements == 0) {
  printf("\nERROR: Need to define a material using Union_make_material before using a Union geometry component. \n");
  printf("       %s was defined before first use of Union_make_material.\n",NAME_CURRENT_COMP);
  exit(1);
}

this_box_volume.geometry.is_masked_volume = 0;
this_box_volume.geometry.is_exit_volume = 0;
this_box_volume.geometry.is_mask_volume = 0;
// check if the volume is a mask, if it is the material string is irelevant.
if (mask_string && strlen(mask_string) && strcmp(mask_string, "NULL") && strcmp(mask_string, "0")) {
    // A mask volume is used to limit the extend of other volumes, called the masked volumes. These are specified in the mask_string.
    // In order for a ray to enter a masked volume, it needs to be both in the region covered by that volume AND the mask volume.
    // When more than
    this_box_volume.geometry.mask_mode = 1; // Default is mask mode is ALL
    if (mask_setting && strlen(mask_setting) && strcmp(mask_setting, "NULL") && strcmp(mask_setting, "0")) {
        if (strcmp(mask_setting,"ALL") == 0 || strcmp(mask_setting,"All") == 0) this_box_volume.geometry.mask_mode = 1;
        else if (strcmp(mask_setting,"ANY") == 0 || strcmp(mask_setting,"Any") == 0) this_box_volume.geometry.mask_mode = 2;
        else {
            printf("The mask_mode of component %s is set to %s, but must be either ALL or ANY.\n",NAME_CURRENT_COMP,mask_setting);
            exit(1);
        }
    }
    
    for (loop_index=0;loop_index<global_geometry_list.num_elements;loop_index++) {
        // Add mask list
        if (1 == manual_linking_function(global_geometry_list.elements[loop_index].name,mask_string)) {
            add_element_to_int_list(&this_box_volume.geometry.mask_list,global_geometry_list.elements[loop_index].component_index);
            add_element_to_int_list(&global_geometry_list.elements[loop_index].Volume->geometry.masked_by_list,INDEX_CURRENT_COMP);
            global_geometry_list.elements[loop_index].Volume->geometry.is_masked_volume = 1;
            if (this_box_volume.geometry.mask_mode == 2)
                global_geometry_list.elements[loop_index].Volume->geometry.mask_mode = 2;
            if (this_box_volume.geometry.mask_mode == 1) {
                if (global_geometry_list.elements[loop_index].Volume->geometry.is_masked_volume == 1 && global_geometry_list.elements[loop_index].Volume->geometry.mask_mode != 2)
                    // If more than one mask is added to one volume, the ANY mode overwrites the (default) ALL mode.
                    global_geometry_list.elements[loop_index].Volume->geometry.mask_mode = 1;
            }
            
            found_geometries = 1;
        }
    }
    if (found_geometries == 0) {
        printf("The mask_string in geometry: %s did not find any of the specified volumes in the mask_string %s \n",NAME_CURRENT_COMP,mask_string);
        exit(1);
    }
    this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
    this_box_volume.p_physics->is_vacuum = 0; // Makes this volume a vacuum
    this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
    this_box_volume.p_physics->my_a = 0; // Should not be used.
    sprintf(this_box_volume.p_physics->name,"Mask");
    this_box_volume.geometry.is_mask_volume = 1;
    
    
// Read the material input, or if it lacks, use automatic linking.
} else if (material_string && strlen(material_string) && strcmp(material_string, "NULL") && strcmp(material_string, "0")) {
    // A geometry string was given, use it to determine which material
    if (0 == strcmp(material_string,"vacuum") || 0 == strcmp(material_string,"Vacuum")) {
        // One could have a global physics struct for vacuum instead of creating one for each
        this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
        this_box_volume.p_physics->is_vacuum = 1; // Makes this volume a vacuum
        this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
        this_box_volume.p_physics->my_a = 0; // Should not be used.
        sprintf(this_box_volume.p_physics->name,"Vacuum");
    } else if (0 == strcmp(material_string,"exit") || 0 == strcmp(material_string,"Exit")) {
        // One could have a global physics struct for vacuum instead of creating one for each
        this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
        this_box_volume.p_physics->is_vacuum = 1; // Makes this volume a vacuum
        this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
        this_box_volume.p_physics->my_a = 0; // Should not be used.
        this_box_volume.geometry.is_exit_volume = 1;
        sprintf(this_box_volume.p_physics->name,"Exit");
    } else {
        #ifndef MATERIAL_DETECTOR
            printf("Need to define a material before refering to it in a geometry %s.\n",NAME_CURRENT_COMP);
            exit(1);
        #endif
        for (loop_index=0;loop_index<global_material_list.num_elements;loop_index++) {
            if (0 == strcmp(material_string,global_material_list.elements[loop_index].name)) {
                this_box_volume.p_physics = global_material_list.elements[loop_index].physics;
                break;
            }
            if (loop_index == global_material_list.num_elements-1) {
            printf("\n");
            printf("ERROR: The material string \"%s\" in Union geometry \"%s\" did not match a specified material. \n",material_string,NAME_CURRENT_COMP);
            printf("       The materials available at this point (need to be defined before the geometry): \n");
            for (loop_index=0;loop_index<global_material_list.num_elements;loop_index++)
              printf("         %s\n",global_material_list.elements[loop_index].name);
            printf("\n");
            printf("       It is also possible to use one of the defualt materials avaiable: \n");
            printf("           Vacuum (for a Volume without scattering or absorption)\n");
            printf("           Exit (for a Volume where the ray exits the component if it enters)\n");
            printf("           Mask (for a Volume that masks existing volumes specified in the mask_string\n");
            exit(1);
          }
        }
    }
} else {
    // Automatic linking, simply using the last defined material.
    #ifndef MATERIAL_DETECTOR
        printf("Need to define a material before the geometry to use automatic linking %s.\n",NAME_CURRENT_COMP);
        exit(1);
    #endif
    this_box_volume.p_physics = global_material_list.elements[global_material_list.num_elements-1].physics;
}

sprintf(this_box_volume.name,NAME_CURRENT_COMP);
sprintf(this_box_volume.geometry.shape,"box");
this_box_volume.geometry.priority_value = priority;
this_box_volume.geometry.geometry_p_interact = p_interact;
// Currently the coordinates will be in absolute space.
this_box_volume.geometry.center = POS_A_CURRENT_COMP;

this_box_storage.z_depth = zdepth;
this_box_storage.x_width1 = xwidth;
this_box_storage.y_height1 = yheight;

this_box_storage.is_rectangle = 0;
if (xwidth2 < 0 && yheight2 < 0) this_box_storage.is_rectangle = 1;
if (xwidth == xwidth2 && yheight == yheight2) this_box_storage.is_rectangle = 1;

if (xwidth2 < 0) {
    this_box_storage.x_width2 = xwidth;
    xwidth2 = xwidth;
} else this_box_storage.x_width2 = xwidth2;

if (yheight2 < 0) {
    this_box_storage.y_height2 = yheight;
    yheight2 = yheight;
} else this_box_storage.y_height2 = yheight2;


this_box_storage.normal_vectors[0] = coords_set(0,0,1);
this_box_storage.normal_vectors[1] = coords_set(0,0,1);

// for sides with y component = 0
x_component = 2*zdepth/sqrt((xwidth-xwidth2)*(xwidth-xwidth2)+4*zdepth*zdepth);
z_component = (xwidth-xwidth2)/sqrt(4*zdepth*zdepth+(xwidth-xwidth2)*(xwidth-xwidth2));

this_box_storage.normal_vectors[2] = coords_set(x_component,0,z_component);
this_box_storage.normal_vectors[3] = coords_set(-x_component,0,z_component);

// for sides with x component = 0
y_component = 2*zdepth/sqrt((yheight-yheight2)*(yheight-yheight2)+4*zdepth*zdepth);
z_component = (yheight-yheight2)/sqrt(4*zdepth*zdepth+(yheight-yheight2)*(yheight-yheight2));

this_box_storage.normal_vectors[4] = coords_set(0,y_component,z_component);
this_box_storage.normal_vectors[5] = coords_set(0,-y_component,z_component);

this_box_volume.geometry.visualization_on = visualize;

this_box_volume.geometry.geometry_parameters.p_box_storage = &this_box_storage;

// Assign pointers to functions for intersection with the shape, checking if a point is inside the shape
if (this_box_storage.is_rectangle == 1) {
this_box_volume.geometry.intersect_function = &sample_box_intersect_simple;
this_box_volume.geometry.within_function = &r_within_box_simple;
}
else {
this_box_volume.geometry.intersect_function = &sample_box_intersect_advanced;
this_box_volume.geometry.within_function = &r_within_box_advanced;
}

this_box_volume.geometry.shell_points = &box_shell_points;
this_box_volume.geometry.mcdisplay_function = &mcdisplay_box_function;
this_box_volume.geometry.initialize_from_main_function = &initialize_box_geometry_from_main_component;
this_box_volume.geometry.process_rot_allocated = 0;

this_box_volume.geometry.copy_geometry_parameters = &allocate_box_storage_copy;

rot_copy(this_box_volume.geometry.rotation_matrix,ROT_A_CURRENT_COMP); //check how ROT_R_CURRENT_COMP would work
rot_transpose(ROT_A_CURRENT_COMP,this_box_volume.geometry.transpose_rotation_matrix);

// Initialize loggers
this_box_volume.loggers.num_elements = 0;

// packing the information into the global_geometry_element, which is then included in the global_geometry_list.
sprintf(global_geometry_element.name,NAME_CURRENT_COMP);
global_geometry_element.activation_counter = number_of_activations;
global_geometry_element.component_index = INDEX_CURRENT_COMP;
global_geometry_element.Volume = &this_box_volume; // Would be nicer if this m was a pointer, now we have the (small) data two places
add_element_to_geometry_list(&global_geometry_list,global_geometry_element);
}
#line 230966 "MACS_sample_kidney_box.c"
#undef number_of_activations
#undef mask_setting
#undef mask_string
#undef p_interact
#undef focus_r
#undef focus_xh
#undef focus_xw
#undef focus_ah
#undef focus_aw
#undef target_z
#undef target_y
#undef target_x
#undef target_index
#undef visualize
#undef yheight2
#undef xwidth2
#undef zdepth
#undef yheight
#undef xwidth
#undef priority
#undef material_string
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

  /* Initializations for component channel_7_analyzer_2_array_crystal_array_5. */
  SIG_MESSAGE("channel_7_analyzer_2_array_crystal_array_5 (Init)");
#define mccompcurname  channel_7_analyzer_2_array_crystal_array_5
#define mccompcurtype  Union_box
#define mccompcurindex 412
#define loop_index mccchannel_7_analyzer_2_array_crystal_array_5_loop_index
#define this_box_volume mccchannel_7_analyzer_2_array_crystal_array_5_this_box_volume
#define global_geometry_element mccchannel_7_analyzer_2_array_crystal_array_5_global_geometry_element
#define this_box_storage mccchannel_7_analyzer_2_array_crystal_array_5_this_box_storage
#define material_string mccchannel_7_analyzer_2_array_crystal_array_5_material_string
#define priority mccchannel_7_analyzer_2_array_crystal_array_5_priority
#define xwidth mccchannel_7_analyzer_2_array_crystal_array_5_xwidth
#define yheight mccchannel_7_analyzer_2_array_crystal_array_5_yheight
#define zdepth mccchannel_7_analyzer_2_array_crystal_array_5_zdepth
#define xwidth2 mccchannel_7_analyzer_2_array_crystal_array_5_xwidth2
#define yheight2 mccchannel_7_analyzer_2_array_crystal_array_5_yheight2
#define visualize mccchannel_7_analyzer_2_array_crystal_array_5_visualize
#define target_index mccchannel_7_analyzer_2_array_crystal_array_5_target_index
#define target_x mccchannel_7_analyzer_2_array_crystal_array_5_target_x
#define target_y mccchannel_7_analyzer_2_array_crystal_array_5_target_y
#define target_z mccchannel_7_analyzer_2_array_crystal_array_5_target_z
#define focus_aw mccchannel_7_analyzer_2_array_crystal_array_5_focus_aw
#define focus_ah mccchannel_7_analyzer_2_array_crystal_array_5_focus_ah
#define focus_xw mccchannel_7_analyzer_2_array_crystal_array_5_focus_xw
#define focus_xh mccchannel_7_analyzer_2_array_crystal_array_5_focus_xh
#define focus_r mccchannel_7_analyzer_2_array_crystal_array_5_focus_r
#define p_interact mccchannel_7_analyzer_2_array_crystal_array_5_p_interact
#define mask_string mccchannel_7_analyzer_2_array_crystal_array_5_mask_string
#define mask_setting mccchannel_7_analyzer_2_array_crystal_array_5_mask_setting
#define number_of_activations mccchannel_7_analyzer_2_array_crystal_array_5_number_of_activations
#line 224 "Union_box.comp"
{
// Initializes the focusing system for this volume including input sanitation.
focus_initialize(&this_box_volume.geometry, POS_A_COMP_INDEX(INDEX_CURRENT_COMP+target_index), POS_A_CURRENT_COMP, ROT_A_CURRENT_COMP, target_index, target_x, target_y, target_z, focus_aw, focus_ah, focus_xw, focus_xh, focus_r, NAME_CURRENT_COMP);

// Input sanitation for this geometry
if (xwidth <= 0) {
  printf("\nERROR in Union_box named %s, the xwidth is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (yheight <= 0) {
  printf("\nERROR in Union_box named %s, yheight is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (zdepth <= 0) {
  printf("\nERROR in Union_box named %s, zdepth is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (xwidth2 <= 0 && xwidth2 != -1) {
  printf("\nERROR in Union_box named %s, the xwidth2 is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (yheight2 <= 0 && yheight2 != -1) {
  printf("\nERROR in Union_box named %s, yheight2 is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}

// Use sanitation
if (global_material_list.num_elements == 0) {
  printf("\nERROR: Need to define a material using Union_make_material before using a Union geometry component. \n");
  printf("       %s was defined before first use of Union_make_material.\n",NAME_CURRENT_COMP);
  exit(1);
}

this_box_volume.geometry.is_masked_volume = 0;
this_box_volume.geometry.is_exit_volume = 0;
this_box_volume.geometry.is_mask_volume = 0;
// check if the volume is a mask, if it is the material string is irelevant.
if (mask_string && strlen(mask_string) && strcmp(mask_string, "NULL") && strcmp(mask_string, "0")) {
    // A mask volume is used to limit the extend of other volumes, called the masked volumes. These are specified in the mask_string.
    // In order for a ray to enter a masked volume, it needs to be both in the region covered by that volume AND the mask volume.
    // When more than
    this_box_volume.geometry.mask_mode = 1; // Default is mask mode is ALL
    if (mask_setting && strlen(mask_setting) && strcmp(mask_setting, "NULL") && strcmp(mask_setting, "0")) {
        if (strcmp(mask_setting,"ALL") == 0 || strcmp(mask_setting,"All") == 0) this_box_volume.geometry.mask_mode = 1;
        else if (strcmp(mask_setting,"ANY") == 0 || strcmp(mask_setting,"Any") == 0) this_box_volume.geometry.mask_mode = 2;
        else {
            printf("The mask_mode of component %s is set to %s, but must be either ALL or ANY.\n",NAME_CURRENT_COMP,mask_setting);
            exit(1);
        }
    }
    
    for (loop_index=0;loop_index<global_geometry_list.num_elements;loop_index++) {
        // Add mask list
        if (1 == manual_linking_function(global_geometry_list.elements[loop_index].name,mask_string)) {
            add_element_to_int_list(&this_box_volume.geometry.mask_list,global_geometry_list.elements[loop_index].component_index);
            add_element_to_int_list(&global_geometry_list.elements[loop_index].Volume->geometry.masked_by_list,INDEX_CURRENT_COMP);
            global_geometry_list.elements[loop_index].Volume->geometry.is_masked_volume = 1;
            if (this_box_volume.geometry.mask_mode == 2)
                global_geometry_list.elements[loop_index].Volume->geometry.mask_mode = 2;
            if (this_box_volume.geometry.mask_mode == 1) {
                if (global_geometry_list.elements[loop_index].Volume->geometry.is_masked_volume == 1 && global_geometry_list.elements[loop_index].Volume->geometry.mask_mode != 2)
                    // If more than one mask is added to one volume, the ANY mode overwrites the (default) ALL mode.
                    global_geometry_list.elements[loop_index].Volume->geometry.mask_mode = 1;
            }
            
            found_geometries = 1;
        }
    }
    if (found_geometries == 0) {
        printf("The mask_string in geometry: %s did not find any of the specified volumes in the mask_string %s \n",NAME_CURRENT_COMP,mask_string);
        exit(1);
    }
    this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
    this_box_volume.p_physics->is_vacuum = 0; // Makes this volume a vacuum
    this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
    this_box_volume.p_physics->my_a = 0; // Should not be used.
    sprintf(this_box_volume.p_physics->name,"Mask");
    this_box_volume.geometry.is_mask_volume = 1;
    
    
// Read the material input, or if it lacks, use automatic linking.
} else if (material_string && strlen(material_string) && strcmp(material_string, "NULL") && strcmp(material_string, "0")) {
    // A geometry string was given, use it to determine which material
    if (0 == strcmp(material_string,"vacuum") || 0 == strcmp(material_string,"Vacuum")) {
        // One could have a global physics struct for vacuum instead of creating one for each
        this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
        this_box_volume.p_physics->is_vacuum = 1; // Makes this volume a vacuum
        this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
        this_box_volume.p_physics->my_a = 0; // Should not be used.
        sprintf(this_box_volume.p_physics->name,"Vacuum");
    } else if (0 == strcmp(material_string,"exit") || 0 == strcmp(material_string,"Exit")) {
        // One could have a global physics struct for vacuum instead of creating one for each
        this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
        this_box_volume.p_physics->is_vacuum = 1; // Makes this volume a vacuum
        this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
        this_box_volume.p_physics->my_a = 0; // Should not be used.
        this_box_volume.geometry.is_exit_volume = 1;
        sprintf(this_box_volume.p_physics->name,"Exit");
    } else {
        #ifndef MATERIAL_DETECTOR
            printf("Need to define a material before refering to it in a geometry %s.\n",NAME_CURRENT_COMP);
            exit(1);
        #endif
        for (loop_index=0;loop_index<global_material_list.num_elements;loop_index++) {
            if (0 == strcmp(material_string,global_material_list.elements[loop_index].name)) {
                this_box_volume.p_physics = global_material_list.elements[loop_index].physics;
                break;
            }
            if (loop_index == global_material_list.num_elements-1) {
            printf("\n");
            printf("ERROR: The material string \"%s\" in Union geometry \"%s\" did not match a specified material. \n",material_string,NAME_CURRENT_COMP);
            printf("       The materials available at this point (need to be defined before the geometry): \n");
            for (loop_index=0;loop_index<global_material_list.num_elements;loop_index++)
              printf("         %s\n",global_material_list.elements[loop_index].name);
            printf("\n");
            printf("       It is also possible to use one of the defualt materials avaiable: \n");
            printf("           Vacuum (for a Volume without scattering or absorption)\n");
            printf("           Exit (for a Volume where the ray exits the component if it enters)\n");
            printf("           Mask (for a Volume that masks existing volumes specified in the mask_string\n");
            exit(1);
          }
        }
    }
} else {
    // Automatic linking, simply using the last defined material.
    #ifndef MATERIAL_DETECTOR
        printf("Need to define a material before the geometry to use automatic linking %s.\n",NAME_CURRENT_COMP);
        exit(1);
    #endif
    this_box_volume.p_physics = global_material_list.elements[global_material_list.num_elements-1].physics;
}

sprintf(this_box_volume.name,NAME_CURRENT_COMP);
sprintf(this_box_volume.geometry.shape,"box");
this_box_volume.geometry.priority_value = priority;
this_box_volume.geometry.geometry_p_interact = p_interact;
// Currently the coordinates will be in absolute space.
this_box_volume.geometry.center = POS_A_CURRENT_COMP;

this_box_storage.z_depth = zdepth;
this_box_storage.x_width1 = xwidth;
this_box_storage.y_height1 = yheight;

this_box_storage.is_rectangle = 0;
if (xwidth2 < 0 && yheight2 < 0) this_box_storage.is_rectangle = 1;
if (xwidth == xwidth2 && yheight == yheight2) this_box_storage.is_rectangle = 1;

if (xwidth2 < 0) {
    this_box_storage.x_width2 = xwidth;
    xwidth2 = xwidth;
} else this_box_storage.x_width2 = xwidth2;

if (yheight2 < 0) {
    this_box_storage.y_height2 = yheight;
    yheight2 = yheight;
} else this_box_storage.y_height2 = yheight2;


this_box_storage.normal_vectors[0] = coords_set(0,0,1);
this_box_storage.normal_vectors[1] = coords_set(0,0,1);

// for sides with y component = 0
x_component = 2*zdepth/sqrt((xwidth-xwidth2)*(xwidth-xwidth2)+4*zdepth*zdepth);
z_component = (xwidth-xwidth2)/sqrt(4*zdepth*zdepth+(xwidth-xwidth2)*(xwidth-xwidth2));

this_box_storage.normal_vectors[2] = coords_set(x_component,0,z_component);
this_box_storage.normal_vectors[3] = coords_set(-x_component,0,z_component);

// for sides with x component = 0
y_component = 2*zdepth/sqrt((yheight-yheight2)*(yheight-yheight2)+4*zdepth*zdepth);
z_component = (yheight-yheight2)/sqrt(4*zdepth*zdepth+(yheight-yheight2)*(yheight-yheight2));

this_box_storage.normal_vectors[4] = coords_set(0,y_component,z_component);
this_box_storage.normal_vectors[5] = coords_set(0,-y_component,z_component);

this_box_volume.geometry.visualization_on = visualize;

this_box_volume.geometry.geometry_parameters.p_box_storage = &this_box_storage;

// Assign pointers to functions for intersection with the shape, checking if a point is inside the shape
if (this_box_storage.is_rectangle == 1) {
this_box_volume.geometry.intersect_function = &sample_box_intersect_simple;
this_box_volume.geometry.within_function = &r_within_box_simple;
}
else {
this_box_volume.geometry.intersect_function = &sample_box_intersect_advanced;
this_box_volume.geometry.within_function = &r_within_box_advanced;
}

this_box_volume.geometry.shell_points = &box_shell_points;
this_box_volume.geometry.mcdisplay_function = &mcdisplay_box_function;
this_box_volume.geometry.initialize_from_main_function = &initialize_box_geometry_from_main_component;
this_box_volume.geometry.process_rot_allocated = 0;

this_box_volume.geometry.copy_geometry_parameters = &allocate_box_storage_copy;

rot_copy(this_box_volume.geometry.rotation_matrix,ROT_A_CURRENT_COMP); //check how ROT_R_CURRENT_COMP would work
rot_transpose(ROT_A_CURRENT_COMP,this_box_volume.geometry.transpose_rotation_matrix);

// Initialize loggers
this_box_volume.loggers.num_elements = 0;

// packing the information into the global_geometry_element, which is then included in the global_geometry_list.
sprintf(global_geometry_element.name,NAME_CURRENT_COMP);
global_geometry_element.activation_counter = number_of_activations;
global_geometry_element.component_index = INDEX_CURRENT_COMP;
global_geometry_element.Volume = &this_box_volume; // Would be nicer if this m was a pointer, now we have the (small) data two places
add_element_to_geometry_list(&global_geometry_list,global_geometry_element);
}
#line 231236 "MACS_sample_kidney_box.c"
#undef number_of_activations
#undef mask_setting
#undef mask_string
#undef p_interact
#undef focus_r
#undef focus_xh
#undef focus_xw
#undef focus_ah
#undef focus_aw
#undef target_z
#undef target_y
#undef target_x
#undef target_index
#undef visualize
#undef yheight2
#undef xwidth2
#undef zdepth
#undef yheight
#undef xwidth
#undef priority
#undef material_string
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

  /* Initializations for component channel_7_analyzer_2_array_crystal_array_6. */
  SIG_MESSAGE("channel_7_analyzer_2_array_crystal_array_6 (Init)");
#define mccompcurname  channel_7_analyzer_2_array_crystal_array_6
#define mccompcurtype  Union_box
#define mccompcurindex 413
#define loop_index mccchannel_7_analyzer_2_array_crystal_array_6_loop_index
#define this_box_volume mccchannel_7_analyzer_2_array_crystal_array_6_this_box_volume
#define global_geometry_element mccchannel_7_analyzer_2_array_crystal_array_6_global_geometry_element
#define this_box_storage mccchannel_7_analyzer_2_array_crystal_array_6_this_box_storage
#define material_string mccchannel_7_analyzer_2_array_crystal_array_6_material_string
#define priority mccchannel_7_analyzer_2_array_crystal_array_6_priority
#define xwidth mccchannel_7_analyzer_2_array_crystal_array_6_xwidth
#define yheight mccchannel_7_analyzer_2_array_crystal_array_6_yheight
#define zdepth mccchannel_7_analyzer_2_array_crystal_array_6_zdepth
#define xwidth2 mccchannel_7_analyzer_2_array_crystal_array_6_xwidth2
#define yheight2 mccchannel_7_analyzer_2_array_crystal_array_6_yheight2
#define visualize mccchannel_7_analyzer_2_array_crystal_array_6_visualize
#define target_index mccchannel_7_analyzer_2_array_crystal_array_6_target_index
#define target_x mccchannel_7_analyzer_2_array_crystal_array_6_target_x
#define target_y mccchannel_7_analyzer_2_array_crystal_array_6_target_y
#define target_z mccchannel_7_analyzer_2_array_crystal_array_6_target_z
#define focus_aw mccchannel_7_analyzer_2_array_crystal_array_6_focus_aw
#define focus_ah mccchannel_7_analyzer_2_array_crystal_array_6_focus_ah
#define focus_xw mccchannel_7_analyzer_2_array_crystal_array_6_focus_xw
#define focus_xh mccchannel_7_analyzer_2_array_crystal_array_6_focus_xh
#define focus_r mccchannel_7_analyzer_2_array_crystal_array_6_focus_r
#define p_interact mccchannel_7_analyzer_2_array_crystal_array_6_p_interact
#define mask_string mccchannel_7_analyzer_2_array_crystal_array_6_mask_string
#define mask_setting mccchannel_7_analyzer_2_array_crystal_array_6_mask_setting
#define number_of_activations mccchannel_7_analyzer_2_array_crystal_array_6_number_of_activations
#line 224 "Union_box.comp"
{
// Initializes the focusing system for this volume including input sanitation.
focus_initialize(&this_box_volume.geometry, POS_A_COMP_INDEX(INDEX_CURRENT_COMP+target_index), POS_A_CURRENT_COMP, ROT_A_CURRENT_COMP, target_index, target_x, target_y, target_z, focus_aw, focus_ah, focus_xw, focus_xh, focus_r, NAME_CURRENT_COMP);

// Input sanitation for this geometry
if (xwidth <= 0) {
  printf("\nERROR in Union_box named %s, the xwidth is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (yheight <= 0) {
  printf("\nERROR in Union_box named %s, yheight is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (zdepth <= 0) {
  printf("\nERROR in Union_box named %s, zdepth is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (xwidth2 <= 0 && xwidth2 != -1) {
  printf("\nERROR in Union_box named %s, the xwidth2 is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (yheight2 <= 0 && yheight2 != -1) {
  printf("\nERROR in Union_box named %s, yheight2 is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}

// Use sanitation
if (global_material_list.num_elements == 0) {
  printf("\nERROR: Need to define a material using Union_make_material before using a Union geometry component. \n");
  printf("       %s was defined before first use of Union_make_material.\n",NAME_CURRENT_COMP);
  exit(1);
}

this_box_volume.geometry.is_masked_volume = 0;
this_box_volume.geometry.is_exit_volume = 0;
this_box_volume.geometry.is_mask_volume = 0;
// check if the volume is a mask, if it is the material string is irelevant.
if (mask_string && strlen(mask_string) && strcmp(mask_string, "NULL") && strcmp(mask_string, "0")) {
    // A mask volume is used to limit the extend of other volumes, called the masked volumes. These are specified in the mask_string.
    // In order for a ray to enter a masked volume, it needs to be both in the region covered by that volume AND the mask volume.
    // When more than
    this_box_volume.geometry.mask_mode = 1; // Default is mask mode is ALL
    if (mask_setting && strlen(mask_setting) && strcmp(mask_setting, "NULL") && strcmp(mask_setting, "0")) {
        if (strcmp(mask_setting,"ALL") == 0 || strcmp(mask_setting,"All") == 0) this_box_volume.geometry.mask_mode = 1;
        else if (strcmp(mask_setting,"ANY") == 0 || strcmp(mask_setting,"Any") == 0) this_box_volume.geometry.mask_mode = 2;
        else {
            printf("The mask_mode of component %s is set to %s, but must be either ALL or ANY.\n",NAME_CURRENT_COMP,mask_setting);
            exit(1);
        }
    }
    
    for (loop_index=0;loop_index<global_geometry_list.num_elements;loop_index++) {
        // Add mask list
        if (1 == manual_linking_function(global_geometry_list.elements[loop_index].name,mask_string)) {
            add_element_to_int_list(&this_box_volume.geometry.mask_list,global_geometry_list.elements[loop_index].component_index);
            add_element_to_int_list(&global_geometry_list.elements[loop_index].Volume->geometry.masked_by_list,INDEX_CURRENT_COMP);
            global_geometry_list.elements[loop_index].Volume->geometry.is_masked_volume = 1;
            if (this_box_volume.geometry.mask_mode == 2)
                global_geometry_list.elements[loop_index].Volume->geometry.mask_mode = 2;
            if (this_box_volume.geometry.mask_mode == 1) {
                if (global_geometry_list.elements[loop_index].Volume->geometry.is_masked_volume == 1 && global_geometry_list.elements[loop_index].Volume->geometry.mask_mode != 2)
                    // If more than one mask is added to one volume, the ANY mode overwrites the (default) ALL mode.
                    global_geometry_list.elements[loop_index].Volume->geometry.mask_mode = 1;
            }
            
            found_geometries = 1;
        }
    }
    if (found_geometries == 0) {
        printf("The mask_string in geometry: %s did not find any of the specified volumes in the mask_string %s \n",NAME_CURRENT_COMP,mask_string);
        exit(1);
    }
    this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
    this_box_volume.p_physics->is_vacuum = 0; // Makes this volume a vacuum
    this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
    this_box_volume.p_physics->my_a = 0; // Should not be used.
    sprintf(this_box_volume.p_physics->name,"Mask");
    this_box_volume.geometry.is_mask_volume = 1;
    
    
// Read the material input, or if it lacks, use automatic linking.
} else if (material_string && strlen(material_string) && strcmp(material_string, "NULL") && strcmp(material_string, "0")) {
    // A geometry string was given, use it to determine which material
    if (0 == strcmp(material_string,"vacuum") || 0 == strcmp(material_string,"Vacuum")) {
        // One could have a global physics struct for vacuum instead of creating one for each
        this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
        this_box_volume.p_physics->is_vacuum = 1; // Makes this volume a vacuum
        this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
        this_box_volume.p_physics->my_a = 0; // Should not be used.
        sprintf(this_box_volume.p_physics->name,"Vacuum");
    } else if (0 == strcmp(material_string,"exit") || 0 == strcmp(material_string,"Exit")) {
        // One could have a global physics struct for vacuum instead of creating one for each
        this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
        this_box_volume.p_physics->is_vacuum = 1; // Makes this volume a vacuum
        this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
        this_box_volume.p_physics->my_a = 0; // Should not be used.
        this_box_volume.geometry.is_exit_volume = 1;
        sprintf(this_box_volume.p_physics->name,"Exit");
    } else {
        #ifndef MATERIAL_DETECTOR
            printf("Need to define a material before refering to it in a geometry %s.\n",NAME_CURRENT_COMP);
            exit(1);
        #endif
        for (loop_index=0;loop_index<global_material_list.num_elements;loop_index++) {
            if (0 == strcmp(material_string,global_material_list.elements[loop_index].name)) {
                this_box_volume.p_physics = global_material_list.elements[loop_index].physics;
                break;
            }
            if (loop_index == global_material_list.num_elements-1) {
            printf("\n");
            printf("ERROR: The material string \"%s\" in Union geometry \"%s\" did not match a specified material. \n",material_string,NAME_CURRENT_COMP);
            printf("       The materials available at this point (need to be defined before the geometry): \n");
            for (loop_index=0;loop_index<global_material_list.num_elements;loop_index++)
              printf("         %s\n",global_material_list.elements[loop_index].name);
            printf("\n");
            printf("       It is also possible to use one of the defualt materials avaiable: \n");
            printf("           Vacuum (for a Volume without scattering or absorption)\n");
            printf("           Exit (for a Volume where the ray exits the component if it enters)\n");
            printf("           Mask (for a Volume that masks existing volumes specified in the mask_string\n");
            exit(1);
          }
        }
    }
} else {
    // Automatic linking, simply using the last defined material.
    #ifndef MATERIAL_DETECTOR
        printf("Need to define a material before the geometry to use automatic linking %s.\n",NAME_CURRENT_COMP);
        exit(1);
    #endif
    this_box_volume.p_physics = global_material_list.elements[global_material_list.num_elements-1].physics;
}

sprintf(this_box_volume.name,NAME_CURRENT_COMP);
sprintf(this_box_volume.geometry.shape,"box");
this_box_volume.geometry.priority_value = priority;
this_box_volume.geometry.geometry_p_interact = p_interact;
// Currently the coordinates will be in absolute space.
this_box_volume.geometry.center = POS_A_CURRENT_COMP;

this_box_storage.z_depth = zdepth;
this_box_storage.x_width1 = xwidth;
this_box_storage.y_height1 = yheight;

this_box_storage.is_rectangle = 0;
if (xwidth2 < 0 && yheight2 < 0) this_box_storage.is_rectangle = 1;
if (xwidth == xwidth2 && yheight == yheight2) this_box_storage.is_rectangle = 1;

if (xwidth2 < 0) {
    this_box_storage.x_width2 = xwidth;
    xwidth2 = xwidth;
} else this_box_storage.x_width2 = xwidth2;

if (yheight2 < 0) {
    this_box_storage.y_height2 = yheight;
    yheight2 = yheight;
} else this_box_storage.y_height2 = yheight2;


this_box_storage.normal_vectors[0] = coords_set(0,0,1);
this_box_storage.normal_vectors[1] = coords_set(0,0,1);

// for sides with y component = 0
x_component = 2*zdepth/sqrt((xwidth-xwidth2)*(xwidth-xwidth2)+4*zdepth*zdepth);
z_component = (xwidth-xwidth2)/sqrt(4*zdepth*zdepth+(xwidth-xwidth2)*(xwidth-xwidth2));

this_box_storage.normal_vectors[2] = coords_set(x_component,0,z_component);
this_box_storage.normal_vectors[3] = coords_set(-x_component,0,z_component);

// for sides with x component = 0
y_component = 2*zdepth/sqrt((yheight-yheight2)*(yheight-yheight2)+4*zdepth*zdepth);
z_component = (yheight-yheight2)/sqrt(4*zdepth*zdepth+(yheight-yheight2)*(yheight-yheight2));

this_box_storage.normal_vectors[4] = coords_set(0,y_component,z_component);
this_box_storage.normal_vectors[5] = coords_set(0,-y_component,z_component);

this_box_volume.geometry.visualization_on = visualize;

this_box_volume.geometry.geometry_parameters.p_box_storage = &this_box_storage;

// Assign pointers to functions for intersection with the shape, checking if a point is inside the shape
if (this_box_storage.is_rectangle == 1) {
this_box_volume.geometry.intersect_function = &sample_box_intersect_simple;
this_box_volume.geometry.within_function = &r_within_box_simple;
}
else {
this_box_volume.geometry.intersect_function = &sample_box_intersect_advanced;
this_box_volume.geometry.within_function = &r_within_box_advanced;
}

this_box_volume.geometry.shell_points = &box_shell_points;
this_box_volume.geometry.mcdisplay_function = &mcdisplay_box_function;
this_box_volume.geometry.initialize_from_main_function = &initialize_box_geometry_from_main_component;
this_box_volume.geometry.process_rot_allocated = 0;

this_box_volume.geometry.copy_geometry_parameters = &allocate_box_storage_copy;

rot_copy(this_box_volume.geometry.rotation_matrix,ROT_A_CURRENT_COMP); //check how ROT_R_CURRENT_COMP would work
rot_transpose(ROT_A_CURRENT_COMP,this_box_volume.geometry.transpose_rotation_matrix);

// Initialize loggers
this_box_volume.loggers.num_elements = 0;

// packing the information into the global_geometry_element, which is then included in the global_geometry_list.
sprintf(global_geometry_element.name,NAME_CURRENT_COMP);
global_geometry_element.activation_counter = number_of_activations;
global_geometry_element.component_index = INDEX_CURRENT_COMP;
global_geometry_element.Volume = &this_box_volume; // Would be nicer if this m was a pointer, now we have the (small) data two places
add_element_to_geometry_list(&global_geometry_list,global_geometry_element);
}
#line 231506 "MACS_sample_kidney_box.c"
#undef number_of_activations
#undef mask_setting
#undef mask_string
#undef p_interact
#undef focus_r
#undef focus_xh
#undef focus_xw
#undef focus_ah
#undef focus_aw
#undef target_z
#undef target_y
#undef target_x
#undef target_index
#undef visualize
#undef yheight2
#undef xwidth2
#undef zdepth
#undef yheight
#undef xwidth
#undef priority
#undef material_string
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

  /* Initializations for component channel_7_analyzer_2_array_crystal_array_7. */
  SIG_MESSAGE("channel_7_analyzer_2_array_crystal_array_7 (Init)");
#define mccompcurname  channel_7_analyzer_2_array_crystal_array_7
#define mccompcurtype  Union_box
#define mccompcurindex 414
#define loop_index mccchannel_7_analyzer_2_array_crystal_array_7_loop_index
#define this_box_volume mccchannel_7_analyzer_2_array_crystal_array_7_this_box_volume
#define global_geometry_element mccchannel_7_analyzer_2_array_crystal_array_7_global_geometry_element
#define this_box_storage mccchannel_7_analyzer_2_array_crystal_array_7_this_box_storage
#define material_string mccchannel_7_analyzer_2_array_crystal_array_7_material_string
#define priority mccchannel_7_analyzer_2_array_crystal_array_7_priority
#define xwidth mccchannel_7_analyzer_2_array_crystal_array_7_xwidth
#define yheight mccchannel_7_analyzer_2_array_crystal_array_7_yheight
#define zdepth mccchannel_7_analyzer_2_array_crystal_array_7_zdepth
#define xwidth2 mccchannel_7_analyzer_2_array_crystal_array_7_xwidth2
#define yheight2 mccchannel_7_analyzer_2_array_crystal_array_7_yheight2
#define visualize mccchannel_7_analyzer_2_array_crystal_array_7_visualize
#define target_index mccchannel_7_analyzer_2_array_crystal_array_7_target_index
#define target_x mccchannel_7_analyzer_2_array_crystal_array_7_target_x
#define target_y mccchannel_7_analyzer_2_array_crystal_array_7_target_y
#define target_z mccchannel_7_analyzer_2_array_crystal_array_7_target_z
#define focus_aw mccchannel_7_analyzer_2_array_crystal_array_7_focus_aw
#define focus_ah mccchannel_7_analyzer_2_array_crystal_array_7_focus_ah
#define focus_xw mccchannel_7_analyzer_2_array_crystal_array_7_focus_xw
#define focus_xh mccchannel_7_analyzer_2_array_crystal_array_7_focus_xh
#define focus_r mccchannel_7_analyzer_2_array_crystal_array_7_focus_r
#define p_interact mccchannel_7_analyzer_2_array_crystal_array_7_p_interact
#define mask_string mccchannel_7_analyzer_2_array_crystal_array_7_mask_string
#define mask_setting mccchannel_7_analyzer_2_array_crystal_array_7_mask_setting
#define number_of_activations mccchannel_7_analyzer_2_array_crystal_array_7_number_of_activations
#line 224 "Union_box.comp"
{
// Initializes the focusing system for this volume including input sanitation.
focus_initialize(&this_box_volume.geometry, POS_A_COMP_INDEX(INDEX_CURRENT_COMP+target_index), POS_A_CURRENT_COMP, ROT_A_CURRENT_COMP, target_index, target_x, target_y, target_z, focus_aw, focus_ah, focus_xw, focus_xh, focus_r, NAME_CURRENT_COMP);

// Input sanitation for this geometry
if (xwidth <= 0) {
  printf("\nERROR in Union_box named %s, the xwidth is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (yheight <= 0) {
  printf("\nERROR in Union_box named %s, yheight is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (zdepth <= 0) {
  printf("\nERROR in Union_box named %s, zdepth is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (xwidth2 <= 0 && xwidth2 != -1) {
  printf("\nERROR in Union_box named %s, the xwidth2 is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (yheight2 <= 0 && yheight2 != -1) {
  printf("\nERROR in Union_box named %s, yheight2 is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}

// Use sanitation
if (global_material_list.num_elements == 0) {
  printf("\nERROR: Need to define a material using Union_make_material before using a Union geometry component. \n");
  printf("       %s was defined before first use of Union_make_material.\n",NAME_CURRENT_COMP);
  exit(1);
}

this_box_volume.geometry.is_masked_volume = 0;
this_box_volume.geometry.is_exit_volume = 0;
this_box_volume.geometry.is_mask_volume = 0;
// check if the volume is a mask, if it is the material string is irelevant.
if (mask_string && strlen(mask_string) && strcmp(mask_string, "NULL") && strcmp(mask_string, "0")) {
    // A mask volume is used to limit the extend of other volumes, called the masked volumes. These are specified in the mask_string.
    // In order for a ray to enter a masked volume, it needs to be both in the region covered by that volume AND the mask volume.
    // When more than
    this_box_volume.geometry.mask_mode = 1; // Default is mask mode is ALL
    if (mask_setting && strlen(mask_setting) && strcmp(mask_setting, "NULL") && strcmp(mask_setting, "0")) {
        if (strcmp(mask_setting,"ALL") == 0 || strcmp(mask_setting,"All") == 0) this_box_volume.geometry.mask_mode = 1;
        else if (strcmp(mask_setting,"ANY") == 0 || strcmp(mask_setting,"Any") == 0) this_box_volume.geometry.mask_mode = 2;
        else {
            printf("The mask_mode of component %s is set to %s, but must be either ALL or ANY.\n",NAME_CURRENT_COMP,mask_setting);
            exit(1);
        }
    }
    
    for (loop_index=0;loop_index<global_geometry_list.num_elements;loop_index++) {
        // Add mask list
        if (1 == manual_linking_function(global_geometry_list.elements[loop_index].name,mask_string)) {
            add_element_to_int_list(&this_box_volume.geometry.mask_list,global_geometry_list.elements[loop_index].component_index);
            add_element_to_int_list(&global_geometry_list.elements[loop_index].Volume->geometry.masked_by_list,INDEX_CURRENT_COMP);
            global_geometry_list.elements[loop_index].Volume->geometry.is_masked_volume = 1;
            if (this_box_volume.geometry.mask_mode == 2)
                global_geometry_list.elements[loop_index].Volume->geometry.mask_mode = 2;
            if (this_box_volume.geometry.mask_mode == 1) {
                if (global_geometry_list.elements[loop_index].Volume->geometry.is_masked_volume == 1 && global_geometry_list.elements[loop_index].Volume->geometry.mask_mode != 2)
                    // If more than one mask is added to one volume, the ANY mode overwrites the (default) ALL mode.
                    global_geometry_list.elements[loop_index].Volume->geometry.mask_mode = 1;
            }
            
            found_geometries = 1;
        }
    }
    if (found_geometries == 0) {
        printf("The mask_string in geometry: %s did not find any of the specified volumes in the mask_string %s \n",NAME_CURRENT_COMP,mask_string);
        exit(1);
    }
    this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
    this_box_volume.p_physics->is_vacuum = 0; // Makes this volume a vacuum
    this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
    this_box_volume.p_physics->my_a = 0; // Should not be used.
    sprintf(this_box_volume.p_physics->name,"Mask");
    this_box_volume.geometry.is_mask_volume = 1;
    
    
// Read the material input, or if it lacks, use automatic linking.
} else if (material_string && strlen(material_string) && strcmp(material_string, "NULL") && strcmp(material_string, "0")) {
    // A geometry string was given, use it to determine which material
    if (0 == strcmp(material_string,"vacuum") || 0 == strcmp(material_string,"Vacuum")) {
        // One could have a global physics struct for vacuum instead of creating one for each
        this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
        this_box_volume.p_physics->is_vacuum = 1; // Makes this volume a vacuum
        this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
        this_box_volume.p_physics->my_a = 0; // Should not be used.
        sprintf(this_box_volume.p_physics->name,"Vacuum");
    } else if (0 == strcmp(material_string,"exit") || 0 == strcmp(material_string,"Exit")) {
        // One could have a global physics struct for vacuum instead of creating one for each
        this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
        this_box_volume.p_physics->is_vacuum = 1; // Makes this volume a vacuum
        this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
        this_box_volume.p_physics->my_a = 0; // Should not be used.
        this_box_volume.geometry.is_exit_volume = 1;
        sprintf(this_box_volume.p_physics->name,"Exit");
    } else {
        #ifndef MATERIAL_DETECTOR
            printf("Need to define a material before refering to it in a geometry %s.\n",NAME_CURRENT_COMP);
            exit(1);
        #endif
        for (loop_index=0;loop_index<global_material_list.num_elements;loop_index++) {
            if (0 == strcmp(material_string,global_material_list.elements[loop_index].name)) {
                this_box_volume.p_physics = global_material_list.elements[loop_index].physics;
                break;
            }
            if (loop_index == global_material_list.num_elements-1) {
            printf("\n");
            printf("ERROR: The material string \"%s\" in Union geometry \"%s\" did not match a specified material. \n",material_string,NAME_CURRENT_COMP);
            printf("       The materials available at this point (need to be defined before the geometry): \n");
            for (loop_index=0;loop_index<global_material_list.num_elements;loop_index++)
              printf("         %s\n",global_material_list.elements[loop_index].name);
            printf("\n");
            printf("       It is also possible to use one of the defualt materials avaiable: \n");
            printf("           Vacuum (for a Volume without scattering or absorption)\n");
            printf("           Exit (for a Volume where the ray exits the component if it enters)\n");
            printf("           Mask (for a Volume that masks existing volumes specified in the mask_string\n");
            exit(1);
          }
        }
    }
} else {
    // Automatic linking, simply using the last defined material.
    #ifndef MATERIAL_DETECTOR
        printf("Need to define a material before the geometry to use automatic linking %s.\n",NAME_CURRENT_COMP);
        exit(1);
    #endif
    this_box_volume.p_physics = global_material_list.elements[global_material_list.num_elements-1].physics;
}

sprintf(this_box_volume.name,NAME_CURRENT_COMP);
sprintf(this_box_volume.geometry.shape,"box");
this_box_volume.geometry.priority_value = priority;
this_box_volume.geometry.geometry_p_interact = p_interact;
// Currently the coordinates will be in absolute space.
this_box_volume.geometry.center = POS_A_CURRENT_COMP;

this_box_storage.z_depth = zdepth;
this_box_storage.x_width1 = xwidth;
this_box_storage.y_height1 = yheight;

this_box_storage.is_rectangle = 0;
if (xwidth2 < 0 && yheight2 < 0) this_box_storage.is_rectangle = 1;
if (xwidth == xwidth2 && yheight == yheight2) this_box_storage.is_rectangle = 1;

if (xwidth2 < 0) {
    this_box_storage.x_width2 = xwidth;
    xwidth2 = xwidth;
} else this_box_storage.x_width2 = xwidth2;

if (yheight2 < 0) {
    this_box_storage.y_height2 = yheight;
    yheight2 = yheight;
} else this_box_storage.y_height2 = yheight2;


this_box_storage.normal_vectors[0] = coords_set(0,0,1);
this_box_storage.normal_vectors[1] = coords_set(0,0,1);

// for sides with y component = 0
x_component = 2*zdepth/sqrt((xwidth-xwidth2)*(xwidth-xwidth2)+4*zdepth*zdepth);
z_component = (xwidth-xwidth2)/sqrt(4*zdepth*zdepth+(xwidth-xwidth2)*(xwidth-xwidth2));

this_box_storage.normal_vectors[2] = coords_set(x_component,0,z_component);
this_box_storage.normal_vectors[3] = coords_set(-x_component,0,z_component);

// for sides with x component = 0
y_component = 2*zdepth/sqrt((yheight-yheight2)*(yheight-yheight2)+4*zdepth*zdepth);
z_component = (yheight-yheight2)/sqrt(4*zdepth*zdepth+(yheight-yheight2)*(yheight-yheight2));

this_box_storage.normal_vectors[4] = coords_set(0,y_component,z_component);
this_box_storage.normal_vectors[5] = coords_set(0,-y_component,z_component);

this_box_volume.geometry.visualization_on = visualize;

this_box_volume.geometry.geometry_parameters.p_box_storage = &this_box_storage;

// Assign pointers to functions for intersection with the shape, checking if a point is inside the shape
if (this_box_storage.is_rectangle == 1) {
this_box_volume.geometry.intersect_function = &sample_box_intersect_simple;
this_box_volume.geometry.within_function = &r_within_box_simple;
}
else {
this_box_volume.geometry.intersect_function = &sample_box_intersect_advanced;
this_box_volume.geometry.within_function = &r_within_box_advanced;
}

this_box_volume.geometry.shell_points = &box_shell_points;
this_box_volume.geometry.mcdisplay_function = &mcdisplay_box_function;
this_box_volume.geometry.initialize_from_main_function = &initialize_box_geometry_from_main_component;
this_box_volume.geometry.process_rot_allocated = 0;

this_box_volume.geometry.copy_geometry_parameters = &allocate_box_storage_copy;

rot_copy(this_box_volume.geometry.rotation_matrix,ROT_A_CURRENT_COMP); //check how ROT_R_CURRENT_COMP would work
rot_transpose(ROT_A_CURRENT_COMP,this_box_volume.geometry.transpose_rotation_matrix);

// Initialize loggers
this_box_volume.loggers.num_elements = 0;

// packing the information into the global_geometry_element, which is then included in the global_geometry_list.
sprintf(global_geometry_element.name,NAME_CURRENT_COMP);
global_geometry_element.activation_counter = number_of_activations;
global_geometry_element.component_index = INDEX_CURRENT_COMP;
global_geometry_element.Volume = &this_box_volume; // Would be nicer if this m was a pointer, now we have the (small) data two places
add_element_to_geometry_list(&global_geometry_list,global_geometry_element);
}
#line 231776 "MACS_sample_kidney_box.c"
#undef number_of_activations
#undef mask_setting
#undef mask_string
#undef p_interact
#undef focus_r
#undef focus_xh
#undef focus_xw
#undef focus_ah
#undef focus_aw
#undef target_z
#undef target_y
#undef target_x
#undef target_index
#undef visualize
#undef yheight2
#undef xwidth2
#undef zdepth
#undef yheight
#undef xwidth
#undef priority
#undef material_string
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

  /* Initializations for component channel_7_analyzer_2_array_crystal_array_8. */
  SIG_MESSAGE("channel_7_analyzer_2_array_crystal_array_8 (Init)");
#define mccompcurname  channel_7_analyzer_2_array_crystal_array_8
#define mccompcurtype  Union_box
#define mccompcurindex 415
#define loop_index mccchannel_7_analyzer_2_array_crystal_array_8_loop_index
#define this_box_volume mccchannel_7_analyzer_2_array_crystal_array_8_this_box_volume
#define global_geometry_element mccchannel_7_analyzer_2_array_crystal_array_8_global_geometry_element
#define this_box_storage mccchannel_7_analyzer_2_array_crystal_array_8_this_box_storage
#define material_string mccchannel_7_analyzer_2_array_crystal_array_8_material_string
#define priority mccchannel_7_analyzer_2_array_crystal_array_8_priority
#define xwidth mccchannel_7_analyzer_2_array_crystal_array_8_xwidth
#define yheight mccchannel_7_analyzer_2_array_crystal_array_8_yheight
#define zdepth mccchannel_7_analyzer_2_array_crystal_array_8_zdepth
#define xwidth2 mccchannel_7_analyzer_2_array_crystal_array_8_xwidth2
#define yheight2 mccchannel_7_analyzer_2_array_crystal_array_8_yheight2
#define visualize mccchannel_7_analyzer_2_array_crystal_array_8_visualize
#define target_index mccchannel_7_analyzer_2_array_crystal_array_8_target_index
#define target_x mccchannel_7_analyzer_2_array_crystal_array_8_target_x
#define target_y mccchannel_7_analyzer_2_array_crystal_array_8_target_y
#define target_z mccchannel_7_analyzer_2_array_crystal_array_8_target_z
#define focus_aw mccchannel_7_analyzer_2_array_crystal_array_8_focus_aw
#define focus_ah mccchannel_7_analyzer_2_array_crystal_array_8_focus_ah
#define focus_xw mccchannel_7_analyzer_2_array_crystal_array_8_focus_xw
#define focus_xh mccchannel_7_analyzer_2_array_crystal_array_8_focus_xh
#define focus_r mccchannel_7_analyzer_2_array_crystal_array_8_focus_r
#define p_interact mccchannel_7_analyzer_2_array_crystal_array_8_p_interact
#define mask_string mccchannel_7_analyzer_2_array_crystal_array_8_mask_string
#define mask_setting mccchannel_7_analyzer_2_array_crystal_array_8_mask_setting
#define number_of_activations mccchannel_7_analyzer_2_array_crystal_array_8_number_of_activations
#line 224 "Union_box.comp"
{
// Initializes the focusing system for this volume including input sanitation.
focus_initialize(&this_box_volume.geometry, POS_A_COMP_INDEX(INDEX_CURRENT_COMP+target_index), POS_A_CURRENT_COMP, ROT_A_CURRENT_COMP, target_index, target_x, target_y, target_z, focus_aw, focus_ah, focus_xw, focus_xh, focus_r, NAME_CURRENT_COMP);

// Input sanitation for this geometry
if (xwidth <= 0) {
  printf("\nERROR in Union_box named %s, the xwidth is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (yheight <= 0) {
  printf("\nERROR in Union_box named %s, yheight is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (zdepth <= 0) {
  printf("\nERROR in Union_box named %s, zdepth is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (xwidth2 <= 0 && xwidth2 != -1) {
  printf("\nERROR in Union_box named %s, the xwidth2 is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (yheight2 <= 0 && yheight2 != -1) {
  printf("\nERROR in Union_box named %s, yheight2 is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}

// Use sanitation
if (global_material_list.num_elements == 0) {
  printf("\nERROR: Need to define a material using Union_make_material before using a Union geometry component. \n");
  printf("       %s was defined before first use of Union_make_material.\n",NAME_CURRENT_COMP);
  exit(1);
}

this_box_volume.geometry.is_masked_volume = 0;
this_box_volume.geometry.is_exit_volume = 0;
this_box_volume.geometry.is_mask_volume = 0;
// check if the volume is a mask, if it is the material string is irelevant.
if (mask_string && strlen(mask_string) && strcmp(mask_string, "NULL") && strcmp(mask_string, "0")) {
    // A mask volume is used to limit the extend of other volumes, called the masked volumes. These are specified in the mask_string.
    // In order for a ray to enter a masked volume, it needs to be both in the region covered by that volume AND the mask volume.
    // When more than
    this_box_volume.geometry.mask_mode = 1; // Default is mask mode is ALL
    if (mask_setting && strlen(mask_setting) && strcmp(mask_setting, "NULL") && strcmp(mask_setting, "0")) {
        if (strcmp(mask_setting,"ALL") == 0 || strcmp(mask_setting,"All") == 0) this_box_volume.geometry.mask_mode = 1;
        else if (strcmp(mask_setting,"ANY") == 0 || strcmp(mask_setting,"Any") == 0) this_box_volume.geometry.mask_mode = 2;
        else {
            printf("The mask_mode of component %s is set to %s, but must be either ALL or ANY.\n",NAME_CURRENT_COMP,mask_setting);
            exit(1);
        }
    }
    
    for (loop_index=0;loop_index<global_geometry_list.num_elements;loop_index++) {
        // Add mask list
        if (1 == manual_linking_function(global_geometry_list.elements[loop_index].name,mask_string)) {
            add_element_to_int_list(&this_box_volume.geometry.mask_list,global_geometry_list.elements[loop_index].component_index);
            add_element_to_int_list(&global_geometry_list.elements[loop_index].Volume->geometry.masked_by_list,INDEX_CURRENT_COMP);
            global_geometry_list.elements[loop_index].Volume->geometry.is_masked_volume = 1;
            if (this_box_volume.geometry.mask_mode == 2)
                global_geometry_list.elements[loop_index].Volume->geometry.mask_mode = 2;
            if (this_box_volume.geometry.mask_mode == 1) {
                if (global_geometry_list.elements[loop_index].Volume->geometry.is_masked_volume == 1 && global_geometry_list.elements[loop_index].Volume->geometry.mask_mode != 2)
                    // If more than one mask is added to one volume, the ANY mode overwrites the (default) ALL mode.
                    global_geometry_list.elements[loop_index].Volume->geometry.mask_mode = 1;
            }
            
            found_geometries = 1;
        }
    }
    if (found_geometries == 0) {
        printf("The mask_string in geometry: %s did not find any of the specified volumes in the mask_string %s \n",NAME_CURRENT_COMP,mask_string);
        exit(1);
    }
    this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
    this_box_volume.p_physics->is_vacuum = 0; // Makes this volume a vacuum
    this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
    this_box_volume.p_physics->my_a = 0; // Should not be used.
    sprintf(this_box_volume.p_physics->name,"Mask");
    this_box_volume.geometry.is_mask_volume = 1;
    
    
// Read the material input, or if it lacks, use automatic linking.
} else if (material_string && strlen(material_string) && strcmp(material_string, "NULL") && strcmp(material_string, "0")) {
    // A geometry string was given, use it to determine which material
    if (0 == strcmp(material_string,"vacuum") || 0 == strcmp(material_string,"Vacuum")) {
        // One could have a global physics struct for vacuum instead of creating one for each
        this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
        this_box_volume.p_physics->is_vacuum = 1; // Makes this volume a vacuum
        this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
        this_box_volume.p_physics->my_a = 0; // Should not be used.
        sprintf(this_box_volume.p_physics->name,"Vacuum");
    } else if (0 == strcmp(material_string,"exit") || 0 == strcmp(material_string,"Exit")) {
        // One could have a global physics struct for vacuum instead of creating one for each
        this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
        this_box_volume.p_physics->is_vacuum = 1; // Makes this volume a vacuum
        this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
        this_box_volume.p_physics->my_a = 0; // Should not be used.
        this_box_volume.geometry.is_exit_volume = 1;
        sprintf(this_box_volume.p_physics->name,"Exit");
    } else {
        #ifndef MATERIAL_DETECTOR
            printf("Need to define a material before refering to it in a geometry %s.\n",NAME_CURRENT_COMP);
            exit(1);
        #endif
        for (loop_index=0;loop_index<global_material_list.num_elements;loop_index++) {
            if (0 == strcmp(material_string,global_material_list.elements[loop_index].name)) {
                this_box_volume.p_physics = global_material_list.elements[loop_index].physics;
                break;
            }
            if (loop_index == global_material_list.num_elements-1) {
            printf("\n");
            printf("ERROR: The material string \"%s\" in Union geometry \"%s\" did not match a specified material. \n",material_string,NAME_CURRENT_COMP);
            printf("       The materials available at this point (need to be defined before the geometry): \n");
            for (loop_index=0;loop_index<global_material_list.num_elements;loop_index++)
              printf("         %s\n",global_material_list.elements[loop_index].name);
            printf("\n");
            printf("       It is also possible to use one of the defualt materials avaiable: \n");
            printf("           Vacuum (for a Volume without scattering or absorption)\n");
            printf("           Exit (for a Volume where the ray exits the component if it enters)\n");
            printf("           Mask (for a Volume that masks existing volumes specified in the mask_string\n");
            exit(1);
          }
        }
    }
} else {
    // Automatic linking, simply using the last defined material.
    #ifndef MATERIAL_DETECTOR
        printf("Need to define a material before the geometry to use automatic linking %s.\n",NAME_CURRENT_COMP);
        exit(1);
    #endif
    this_box_volume.p_physics = global_material_list.elements[global_material_list.num_elements-1].physics;
}

sprintf(this_box_volume.name,NAME_CURRENT_COMP);
sprintf(this_box_volume.geometry.shape,"box");
this_box_volume.geometry.priority_value = priority;
this_box_volume.geometry.geometry_p_interact = p_interact;
// Currently the coordinates will be in absolute space.
this_box_volume.geometry.center = POS_A_CURRENT_COMP;

this_box_storage.z_depth = zdepth;
this_box_storage.x_width1 = xwidth;
this_box_storage.y_height1 = yheight;

this_box_storage.is_rectangle = 0;
if (xwidth2 < 0 && yheight2 < 0) this_box_storage.is_rectangle = 1;
if (xwidth == xwidth2 && yheight == yheight2) this_box_storage.is_rectangle = 1;

if (xwidth2 < 0) {
    this_box_storage.x_width2 = xwidth;
    xwidth2 = xwidth;
} else this_box_storage.x_width2 = xwidth2;

if (yheight2 < 0) {
    this_box_storage.y_height2 = yheight;
    yheight2 = yheight;
} else this_box_storage.y_height2 = yheight2;


this_box_storage.normal_vectors[0] = coords_set(0,0,1);
this_box_storage.normal_vectors[1] = coords_set(0,0,1);

// for sides with y component = 0
x_component = 2*zdepth/sqrt((xwidth-xwidth2)*(xwidth-xwidth2)+4*zdepth*zdepth);
z_component = (xwidth-xwidth2)/sqrt(4*zdepth*zdepth+(xwidth-xwidth2)*(xwidth-xwidth2));

this_box_storage.normal_vectors[2] = coords_set(x_component,0,z_component);
this_box_storage.normal_vectors[3] = coords_set(-x_component,0,z_component);

// for sides with x component = 0
y_component = 2*zdepth/sqrt((yheight-yheight2)*(yheight-yheight2)+4*zdepth*zdepth);
z_component = (yheight-yheight2)/sqrt(4*zdepth*zdepth+(yheight-yheight2)*(yheight-yheight2));

this_box_storage.normal_vectors[4] = coords_set(0,y_component,z_component);
this_box_storage.normal_vectors[5] = coords_set(0,-y_component,z_component);

this_box_volume.geometry.visualization_on = visualize;

this_box_volume.geometry.geometry_parameters.p_box_storage = &this_box_storage;

// Assign pointers to functions for intersection with the shape, checking if a point is inside the shape
if (this_box_storage.is_rectangle == 1) {
this_box_volume.geometry.intersect_function = &sample_box_intersect_simple;
this_box_volume.geometry.within_function = &r_within_box_simple;
}
else {
this_box_volume.geometry.intersect_function = &sample_box_intersect_advanced;
this_box_volume.geometry.within_function = &r_within_box_advanced;
}

this_box_volume.geometry.shell_points = &box_shell_points;
this_box_volume.geometry.mcdisplay_function = &mcdisplay_box_function;
this_box_volume.geometry.initialize_from_main_function = &initialize_box_geometry_from_main_component;
this_box_volume.geometry.process_rot_allocated = 0;

this_box_volume.geometry.copy_geometry_parameters = &allocate_box_storage_copy;

rot_copy(this_box_volume.geometry.rotation_matrix,ROT_A_CURRENT_COMP); //check how ROT_R_CURRENT_COMP would work
rot_transpose(ROT_A_CURRENT_COMP,this_box_volume.geometry.transpose_rotation_matrix);

// Initialize loggers
this_box_volume.loggers.num_elements = 0;

// packing the information into the global_geometry_element, which is then included in the global_geometry_list.
sprintf(global_geometry_element.name,NAME_CURRENT_COMP);
global_geometry_element.activation_counter = number_of_activations;
global_geometry_element.component_index = INDEX_CURRENT_COMP;
global_geometry_element.Volume = &this_box_volume; // Would be nicer if this m was a pointer, now we have the (small) data two places
add_element_to_geometry_list(&global_geometry_list,global_geometry_element);
}
#line 232046 "MACS_sample_kidney_box.c"
#undef number_of_activations
#undef mask_setting
#undef mask_string
#undef p_interact
#undef focus_r
#undef focus_xh
#undef focus_xw
#undef focus_ah
#undef focus_aw
#undef target_z
#undef target_y
#undef target_x
#undef target_index
#undef visualize
#undef yheight2
#undef xwidth2
#undef zdepth
#undef yheight
#undef xwidth
#undef priority
#undef material_string
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

  /* Initializations for component channel_7_cave2_cyl1. */
  SIG_MESSAGE("channel_7_cave2_cyl1 (Init)");
#define mccompcurname  channel_7_cave2_cyl1
#define mccompcurtype  Union_cylinder
#define mccompcurindex 416
#define loop_index mccchannel_7_cave2_cyl1_loop_index
#define this_cylinder_volume mccchannel_7_cave2_cyl1_this_cylinder_volume
#define global_geometry_element mccchannel_7_cave2_cyl1_global_geometry_element
#define this_cylinder_storage mccchannel_7_cave2_cyl1_this_cylinder_storage
#define material_string mccchannel_7_cave2_cyl1_material_string
#define priority mccchannel_7_cave2_cyl1_priority
#define radius mccchannel_7_cave2_cyl1_radius
#define yheight mccchannel_7_cave2_cyl1_yheight
#define visualize mccchannel_7_cave2_cyl1_visualize
#define target_index mccchannel_7_cave2_cyl1_target_index
#define target_x mccchannel_7_cave2_cyl1_target_x
#define target_y mccchannel_7_cave2_cyl1_target_y
#define target_z mccchannel_7_cave2_cyl1_target_z
#define focus_aw mccchannel_7_cave2_cyl1_focus_aw
#define focus_ah mccchannel_7_cave2_cyl1_focus_ah
#define focus_xw mccchannel_7_cave2_cyl1_focus_xw
#define focus_xh mccchannel_7_cave2_cyl1_focus_xh
#define focus_r mccchannel_7_cave2_cyl1_focus_r
#define p_interact mccchannel_7_cave2_cyl1_p_interact
#define mask_string mccchannel_7_cave2_cyl1_mask_string
#define mask_setting mccchannel_7_cave2_cyl1_mask_setting
#define number_of_activations mccchannel_7_cave2_cyl1_number_of_activations
#line 185 "Union_cylinder.comp"
{
// Initializes the focusing system for this volume including input sanitation.
focus_initialize(&this_cylinder_volume.geometry, POS_A_COMP_INDEX(INDEX_CURRENT_COMP+target_index), POS_A_CURRENT_COMP, ROT_A_CURRENT_COMP, target_index, target_x, target_y, target_z, focus_aw, focus_ah, focus_xw, focus_xh, focus_r, NAME_CURRENT_COMP);

// Input sanitation for this geometry
if (radius <= 0) {
  printf("\nERROR in Union_cylinder named %s, the radius is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}

if (yheight <= 0) {
  printf("\nERROR in Union_cylinder named %s, yheight is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}

// Use sanitation
#ifdef MATERIAL_DETECTOR
if (global_material_list.num_elements == 0) {
  // Here if the user have defined a material, but only after this material
  printf("\nERROR: Need to define a material using Union_make_material before using a Union geometry component. \n");
  printf("       %s was defined before first use of Union_make_material.\n",NAME_CURRENT_COMP);
  exit(1);
}
#endif
#ifndef MATERIAL_DETECTOR
  printf("\nERROR: Need to define a material using Union_make_material before using a Union geometry component. \n");
  exit(1);
#endif


this_cylinder_volume.geometry.is_masked_volume = 0;
this_cylinder_volume.geometry.is_exit_volume = 0;
this_cylinder_volume.geometry.is_mask_volume = 0;

// Read the material input, or if it lacks, use automatic linking.
if (mask_string && strlen(mask_string) && strcmp(mask_string, "NULL") && strcmp(mask_string, "0")) {
    // A mask volume is used to limit the extend of other volumes, called the masked volumes. These are specified in the mask_string.
    // In order for a ray to enter a masked volume, it needs to be both in the region covered by that volume AND the mask volume.
    // When more than
    this_cylinder_volume.geometry.mask_mode = 1; // Default is mask mode is ALL
    if (mask_setting && strlen(mask_setting) && strcmp(mask_setting, "NULL") && strcmp(mask_setting, "0")) {
        if (strcmp(mask_setting,"ALL") == 0 || strcmp(mask_setting,"All") == 0) this_cylinder_volume.geometry.mask_mode = 1;
        else if (strcmp(mask_setting,"ANY") == 0 || strcmp(mask_setting,"Any") == 0) this_cylinder_volume.geometry.mask_mode = 2;
        else {
            printf("The mask_mode of component %s is set to %s, but must be either ALL or ANY.\n",NAME_CURRENT_COMP,mask_setting);
            exit(1);
        }
    }
    
    for (loop_index=0;loop_index<global_geometry_list.num_elements;loop_index++) {
        // Add mask list
        if (1 == manual_linking_function(global_geometry_list.elements[loop_index].name,mask_string)) {
            add_element_to_int_list(&this_cylinder_volume.geometry.mask_list,global_geometry_list.elements[loop_index].component_index);
            add_element_to_int_list(&global_geometry_list.elements[loop_index].Volume->geometry.masked_by_list,INDEX_CURRENT_COMP);
            global_geometry_list.elements[loop_index].Volume->geometry.is_masked_volume = 1;
            if (this_cylinder_volume.geometry.mask_mode == 2)
                global_geometry_list.elements[loop_index].Volume->geometry.mask_mode = 2;
            if (this_cylinder_volume.geometry.mask_mode == 1) {
                if (global_geometry_list.elements[loop_index].Volume->geometry.is_masked_volume == 1 && global_geometry_list.elements[loop_index].Volume->geometry.mask_mode != 2)
                    // If more than one mask is added to one volume, the ANY mode overwrites the (default) ALL mode.
                    global_geometry_list.elements[loop_index].Volume->geometry.mask_mode = 1;
            }
            
            found_geometries = 1;
        }
    }
    if (found_geometries == 0) {
        printf("The mask_string in geometry: %s did not find any of the specified volumes in the mask_string %s \n",NAME_CURRENT_COMP,mask_string);
        exit(1);
    }
    this_cylinder_volume.p_physics = malloc(sizeof(struct physics_struct));
    this_cylinder_volume.p_physics->is_vacuum = 0; // Makes this volume a vacuum
    this_cylinder_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
    this_cylinder_volume.p_physics->my_a = 0; // Should not be used.
    sprintf(this_cylinder_volume.p_physics->name,"Mask");
    this_cylinder_volume.geometry.is_mask_volume = 1;
    
    
// Read the material input, or if it lacks, use automatic linking.
} else if (material_string && strlen(material_string) && strcmp(material_string, "NULL") && strcmp(material_string, "0")) {
    // A geometry string was given, use it to determine which material
    if (0 == strcmp(material_string,"vacuum") || 0 == strcmp(material_string,"Vacuum")) {
        // One could have a global physics struct for vacuum instead of creating one for each
        this_cylinder_volume.p_physics = malloc(sizeof(struct physics_struct));
        this_cylinder_volume.p_physics->is_vacuum = 1; // Makes this volume a vacuum
        this_cylinder_volume.p_physics->number_of_processes = (int) 0;
        this_cylinder_volume.p_physics->my_a = 0; // Should not be used.
        sprintf(this_cylinder_volume.p_physics->name,"Vacuum");
    } else if (0 == strcmp(material_string,"exit") || 0 == strcmp(material_string,"Exit")) {
        // One could have a global physics struct for exit instead of creating one for each
        this_cylinder_volume.p_physics = malloc(sizeof(struct physics_struct));
        this_cylinder_volume.p_physics->is_vacuum = 1; // Makes this volume a vacuum
        this_cylinder_volume.p_physics->number_of_processes = (int) 0;
        this_cylinder_volume.p_physics->my_a = 0; // Should not be used.
        this_cylinder_volume.geometry.is_exit_volume = 1;
        sprintf(this_cylinder_volume.p_physics->name,"Exit");
    } else {
        for (loop_index=0;loop_index<global_material_list.num_elements;loop_index++) {
          if (0 == strcmp(material_string,global_material_list.elements[loop_index].name)) {
            this_cylinder_volume.p_physics = global_material_list.elements[loop_index].physics;
            break;
          }
          if (loop_index == global_material_list.num_elements-1) {
            printf("\n");
            printf("ERROR: The material string \"%s\" in Union geometry \"%s\" did not match a specified material. \n",material_string,NAME_CURRENT_COMP);
            printf("       The materials available at this point (need to be defined before the geometry): \n");
            for (loop_index=0;loop_index<global_material_list.num_elements;loop_index++)
              printf("         %s\n",global_material_list.elements[loop_index].name);
            printf("\n");
            printf("       It is also possible to use one of the defualt materials avaiable: \n");
            printf("           Vacuum (for a Volume without scattering or absorption)\n");
            printf("           Exit (for a Volume where the ray exits the component if it enters)\n");
            printf("           Mask (for a Volume that masks existing volumes specified in the mask_string\n");
            exit(1);
          }
        }
    }
} else {
    // Automatic linking, simply using the last defined material.
    #ifndef MATERIAL_DETECTOR
        printf("Need to define a material before the geometry to use automatic linking %s.\n",NAME_CURRENT_COMP);
        exit(1);
    #endif
    this_cylinder_volume.p_physics = global_material_list.elements[global_material_list.num_elements-1].physics;
}

sprintf(this_cylinder_volume.name,NAME_CURRENT_COMP);
sprintf(this_cylinder_volume.geometry.shape,"cylinder");
this_cylinder_volume.geometry.priority_value = priority;
// Currently the coordinates will be in absolute space.
this_cylinder_volume.geometry.center = POS_A_CURRENT_COMP;

this_cylinder_volume.geometry.geometry_p_interact = p_interact;
this_cylinder_storage.cyl_radius = radius;
this_cylinder_storage.height = yheight;
this_cylinder_volume.geometry.visualization_on = visualize;
this_cylinder_volume.geometry.geometry_parameters.p_cylinder_storage = &this_cylinder_storage;
this_cylinder_volume.geometry.within_function = &r_within_cylinder;
this_cylinder_volume.geometry.intersect_function = &sample_cylinder_intersect;
this_cylinder_volume.geometry.mcdisplay_function = &mcdisplay_cylinder_function;
this_cylinder_volume.geometry.shell_points = &cylinder_shell_points;
this_cylinder_volume.geometry.initialize_from_main_function = &initialize_cylinder_geometry_from_main_component;
this_cylinder_volume.geometry.process_rot_allocated = 0;
this_cylinder_volume.geometry.copy_geometry_parameters = &allocate_cylinder_storage_copy;

rot_copy(this_cylinder_volume.geometry.rotation_matrix,ROT_A_CURRENT_COMP);
rot_transpose(ROT_A_CURRENT_COMP,this_cylinder_volume.geometry.transpose_rotation_matrix);

// Initialize loggers
this_cylinder_volume.loggers.num_elements = 0;

// packing the information into the global_geometry_element, which is then included in the global_geometry_list.
sprintf(global_geometry_element.name,NAME_CURRENT_COMP);
global_geometry_element.activation_counter = number_of_activations;
global_geometry_element.component_index = INDEX_CURRENT_COMP;
global_geometry_element.Volume = &this_cylinder_volume; // Would be nicer if this m was a pointer, now we have the (small) data two places
add_element_to_geometry_list(&global_geometry_list,global_geometry_element);
}
#line 232262 "MACS_sample_kidney_box.c"
#undef number_of_activations
#undef mask_setting
#undef mask_string
#undef p_interact
#undef focus_r
#undef focus_xh
#undef focus_xw
#undef focus_ah
#undef focus_aw
#undef target_z
#undef target_y
#undef target_x
#undef target_index
#undef visualize
#undef yheight
#undef radius
#undef priority
#undef material_string
#undef this_cylinder_storage
#undef global_geometry_element
#undef this_cylinder_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

  /* Initializations for component channel_7_cave2_box1. */
  SIG_MESSAGE("channel_7_cave2_box1 (Init)");
#define mccompcurname  channel_7_cave2_box1
#define mccompcurtype  Union_box
#define mccompcurindex 417
#define loop_index mccchannel_7_cave2_box1_loop_index
#define this_box_volume mccchannel_7_cave2_box1_this_box_volume
#define global_geometry_element mccchannel_7_cave2_box1_global_geometry_element
#define this_box_storage mccchannel_7_cave2_box1_this_box_storage
#define material_string mccchannel_7_cave2_box1_material_string
#define priority mccchannel_7_cave2_box1_priority
#define xwidth mccchannel_7_cave2_box1_xwidth
#define yheight mccchannel_7_cave2_box1_yheight
#define zdepth mccchannel_7_cave2_box1_zdepth
#define xwidth2 mccchannel_7_cave2_box1_xwidth2
#define yheight2 mccchannel_7_cave2_box1_yheight2
#define visualize mccchannel_7_cave2_box1_visualize
#define target_index mccchannel_7_cave2_box1_target_index
#define target_x mccchannel_7_cave2_box1_target_x
#define target_y mccchannel_7_cave2_box1_target_y
#define target_z mccchannel_7_cave2_box1_target_z
#define focus_aw mccchannel_7_cave2_box1_focus_aw
#define focus_ah mccchannel_7_cave2_box1_focus_ah
#define focus_xw mccchannel_7_cave2_box1_focus_xw
#define focus_xh mccchannel_7_cave2_box1_focus_xh
#define focus_r mccchannel_7_cave2_box1_focus_r
#define p_interact mccchannel_7_cave2_box1_p_interact
#define mask_string mccchannel_7_cave2_box1_mask_string
#define mask_setting mccchannel_7_cave2_box1_mask_setting
#define number_of_activations mccchannel_7_cave2_box1_number_of_activations
#line 224 "Union_box.comp"
{
// Initializes the focusing system for this volume including input sanitation.
focus_initialize(&this_box_volume.geometry, POS_A_COMP_INDEX(INDEX_CURRENT_COMP+target_index), POS_A_CURRENT_COMP, ROT_A_CURRENT_COMP, target_index, target_x, target_y, target_z, focus_aw, focus_ah, focus_xw, focus_xh, focus_r, NAME_CURRENT_COMP);

// Input sanitation for this geometry
if (xwidth <= 0) {
  printf("\nERROR in Union_box named %s, the xwidth is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (yheight <= 0) {
  printf("\nERROR in Union_box named %s, yheight is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (zdepth <= 0) {
  printf("\nERROR in Union_box named %s, zdepth is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (xwidth2 <= 0 && xwidth2 != -1) {
  printf("\nERROR in Union_box named %s, the xwidth2 is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (yheight2 <= 0 && yheight2 != -1) {
  printf("\nERROR in Union_box named %s, yheight2 is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}

// Use sanitation
if (global_material_list.num_elements == 0) {
  printf("\nERROR: Need to define a material using Union_make_material before using a Union geometry component. \n");
  printf("       %s was defined before first use of Union_make_material.\n",NAME_CURRENT_COMP);
  exit(1);
}

this_box_volume.geometry.is_masked_volume = 0;
this_box_volume.geometry.is_exit_volume = 0;
this_box_volume.geometry.is_mask_volume = 0;
// check if the volume is a mask, if it is the material string is irelevant.
if (mask_string && strlen(mask_string) && strcmp(mask_string, "NULL") && strcmp(mask_string, "0")) {
    // A mask volume is used to limit the extend of other volumes, called the masked volumes. These are specified in the mask_string.
    // In order for a ray to enter a masked volume, it needs to be both in the region covered by that volume AND the mask volume.
    // When more than
    this_box_volume.geometry.mask_mode = 1; // Default is mask mode is ALL
    if (mask_setting && strlen(mask_setting) && strcmp(mask_setting, "NULL") && strcmp(mask_setting, "0")) {
        if (strcmp(mask_setting,"ALL") == 0 || strcmp(mask_setting,"All") == 0) this_box_volume.geometry.mask_mode = 1;
        else if (strcmp(mask_setting,"ANY") == 0 || strcmp(mask_setting,"Any") == 0) this_box_volume.geometry.mask_mode = 2;
        else {
            printf("The mask_mode of component %s is set to %s, but must be either ALL or ANY.\n",NAME_CURRENT_COMP,mask_setting);
            exit(1);
        }
    }
    
    for (loop_index=0;loop_index<global_geometry_list.num_elements;loop_index++) {
        // Add mask list
        if (1 == manual_linking_function(global_geometry_list.elements[loop_index].name,mask_string)) {
            add_element_to_int_list(&this_box_volume.geometry.mask_list,global_geometry_list.elements[loop_index].component_index);
            add_element_to_int_list(&global_geometry_list.elements[loop_index].Volume->geometry.masked_by_list,INDEX_CURRENT_COMP);
            global_geometry_list.elements[loop_index].Volume->geometry.is_masked_volume = 1;
            if (this_box_volume.geometry.mask_mode == 2)
                global_geometry_list.elements[loop_index].Volume->geometry.mask_mode = 2;
            if (this_box_volume.geometry.mask_mode == 1) {
                if (global_geometry_list.elements[loop_index].Volume->geometry.is_masked_volume == 1 && global_geometry_list.elements[loop_index].Volume->geometry.mask_mode != 2)
                    // If more than one mask is added to one volume, the ANY mode overwrites the (default) ALL mode.
                    global_geometry_list.elements[loop_index].Volume->geometry.mask_mode = 1;
            }
            
            found_geometries = 1;
        }
    }
    if (found_geometries == 0) {
        printf("The mask_string in geometry: %s did not find any of the specified volumes in the mask_string %s \n",NAME_CURRENT_COMP,mask_string);
        exit(1);
    }
    this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
    this_box_volume.p_physics->is_vacuum = 0; // Makes this volume a vacuum
    this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
    this_box_volume.p_physics->my_a = 0; // Should not be used.
    sprintf(this_box_volume.p_physics->name,"Mask");
    this_box_volume.geometry.is_mask_volume = 1;
    
    
// Read the material input, or if it lacks, use automatic linking.
} else if (material_string && strlen(material_string) && strcmp(material_string, "NULL") && strcmp(material_string, "0")) {
    // A geometry string was given, use it to determine which material
    if (0 == strcmp(material_string,"vacuum") || 0 == strcmp(material_string,"Vacuum")) {
        // One could have a global physics struct for vacuum instead of creating one for each
        this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
        this_box_volume.p_physics->is_vacuum = 1; // Makes this volume a vacuum
        this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
        this_box_volume.p_physics->my_a = 0; // Should not be used.
        sprintf(this_box_volume.p_physics->name,"Vacuum");
    } else if (0 == strcmp(material_string,"exit") || 0 == strcmp(material_string,"Exit")) {
        // One could have a global physics struct for vacuum instead of creating one for each
        this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
        this_box_volume.p_physics->is_vacuum = 1; // Makes this volume a vacuum
        this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
        this_box_volume.p_physics->my_a = 0; // Should not be used.
        this_box_volume.geometry.is_exit_volume = 1;
        sprintf(this_box_volume.p_physics->name,"Exit");
    } else {
        #ifndef MATERIAL_DETECTOR
            printf("Need to define a material before refering to it in a geometry %s.\n",NAME_CURRENT_COMP);
            exit(1);
        #endif
        for (loop_index=0;loop_index<global_material_list.num_elements;loop_index++) {
            if (0 == strcmp(material_string,global_material_list.elements[loop_index].name)) {
                this_box_volume.p_physics = global_material_list.elements[loop_index].physics;
                break;
            }
            if (loop_index == global_material_list.num_elements-1) {
            printf("\n");
            printf("ERROR: The material string \"%s\" in Union geometry \"%s\" did not match a specified material. \n",material_string,NAME_CURRENT_COMP);
            printf("       The materials available at this point (need to be defined before the geometry): \n");
            for (loop_index=0;loop_index<global_material_list.num_elements;loop_index++)
              printf("         %s\n",global_material_list.elements[loop_index].name);
            printf("\n");
            printf("       It is also possible to use one of the defualt materials avaiable: \n");
            printf("           Vacuum (for a Volume without scattering or absorption)\n");
            printf("           Exit (for a Volume where the ray exits the component if it enters)\n");
            printf("           Mask (for a Volume that masks existing volumes specified in the mask_string\n");
            exit(1);
          }
        }
    }
} else {
    // Automatic linking, simply using the last defined material.
    #ifndef MATERIAL_DETECTOR
        printf("Need to define a material before the geometry to use automatic linking %s.\n",NAME_CURRENT_COMP);
        exit(1);
    #endif
    this_box_volume.p_physics = global_material_list.elements[global_material_list.num_elements-1].physics;
}

sprintf(this_box_volume.name,NAME_CURRENT_COMP);
sprintf(this_box_volume.geometry.shape,"box");
this_box_volume.geometry.priority_value = priority;
this_box_volume.geometry.geometry_p_interact = p_interact;
// Currently the coordinates will be in absolute space.
this_box_volume.geometry.center = POS_A_CURRENT_COMP;

this_box_storage.z_depth = zdepth;
this_box_storage.x_width1 = xwidth;
this_box_storage.y_height1 = yheight;

this_box_storage.is_rectangle = 0;
if (xwidth2 < 0 && yheight2 < 0) this_box_storage.is_rectangle = 1;
if (xwidth == xwidth2 && yheight == yheight2) this_box_storage.is_rectangle = 1;

if (xwidth2 < 0) {
    this_box_storage.x_width2 = xwidth;
    xwidth2 = xwidth;
} else this_box_storage.x_width2 = xwidth2;

if (yheight2 < 0) {
    this_box_storage.y_height2 = yheight;
    yheight2 = yheight;
} else this_box_storage.y_height2 = yheight2;


this_box_storage.normal_vectors[0] = coords_set(0,0,1);
this_box_storage.normal_vectors[1] = coords_set(0,0,1);

// for sides with y component = 0
x_component = 2*zdepth/sqrt((xwidth-xwidth2)*(xwidth-xwidth2)+4*zdepth*zdepth);
z_component = (xwidth-xwidth2)/sqrt(4*zdepth*zdepth+(xwidth-xwidth2)*(xwidth-xwidth2));

this_box_storage.normal_vectors[2] = coords_set(x_component,0,z_component);
this_box_storage.normal_vectors[3] = coords_set(-x_component,0,z_component);

// for sides with x component = 0
y_component = 2*zdepth/sqrt((yheight-yheight2)*(yheight-yheight2)+4*zdepth*zdepth);
z_component = (yheight-yheight2)/sqrt(4*zdepth*zdepth+(yheight-yheight2)*(yheight-yheight2));

this_box_storage.normal_vectors[4] = coords_set(0,y_component,z_component);
this_box_storage.normal_vectors[5] = coords_set(0,-y_component,z_component);

this_box_volume.geometry.visualization_on = visualize;

this_box_volume.geometry.geometry_parameters.p_box_storage = &this_box_storage;

// Assign pointers to functions for intersection with the shape, checking if a point is inside the shape
if (this_box_storage.is_rectangle == 1) {
this_box_volume.geometry.intersect_function = &sample_box_intersect_simple;
this_box_volume.geometry.within_function = &r_within_box_simple;
}
else {
this_box_volume.geometry.intersect_function = &sample_box_intersect_advanced;
this_box_volume.geometry.within_function = &r_within_box_advanced;
}

this_box_volume.geometry.shell_points = &box_shell_points;
this_box_volume.geometry.mcdisplay_function = &mcdisplay_box_function;
this_box_volume.geometry.initialize_from_main_function = &initialize_box_geometry_from_main_component;
this_box_volume.geometry.process_rot_allocated = 0;

this_box_volume.geometry.copy_geometry_parameters = &allocate_box_storage_copy;

rot_copy(this_box_volume.geometry.rotation_matrix,ROT_A_CURRENT_COMP); //check how ROT_R_CURRENT_COMP would work
rot_transpose(ROT_A_CURRENT_COMP,this_box_volume.geometry.transpose_rotation_matrix);

// Initialize loggers
this_box_volume.loggers.num_elements = 0;

// packing the information into the global_geometry_element, which is then included in the global_geometry_list.
sprintf(global_geometry_element.name,NAME_CURRENT_COMP);
global_geometry_element.activation_counter = number_of_activations;
global_geometry_element.component_index = INDEX_CURRENT_COMP;
global_geometry_element.Volume = &this_box_volume; // Would be nicer if this m was a pointer, now we have the (small) data two places
add_element_to_geometry_list(&global_geometry_list,global_geometry_element);
}
#line 232529 "MACS_sample_kidney_box.c"
#undef number_of_activations
#undef mask_setting
#undef mask_string
#undef p_interact
#undef focus_r
#undef focus_xh
#undef focus_xw
#undef focus_ah
#undef focus_aw
#undef target_z
#undef target_y
#undef target_x
#undef target_index
#undef visualize
#undef yheight2
#undef xwidth2
#undef zdepth
#undef yheight
#undef xwidth
#undef priority
#undef material_string
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

  /* Initializations for component channel_7_cave2_box2. */
  SIG_MESSAGE("channel_7_cave2_box2 (Init)");
#define mccompcurname  channel_7_cave2_box2
#define mccompcurtype  Union_box
#define mccompcurindex 418
#define loop_index mccchannel_7_cave2_box2_loop_index
#define this_box_volume mccchannel_7_cave2_box2_this_box_volume
#define global_geometry_element mccchannel_7_cave2_box2_global_geometry_element
#define this_box_storage mccchannel_7_cave2_box2_this_box_storage
#define material_string mccchannel_7_cave2_box2_material_string
#define priority mccchannel_7_cave2_box2_priority
#define xwidth mccchannel_7_cave2_box2_xwidth
#define yheight mccchannel_7_cave2_box2_yheight
#define zdepth mccchannel_7_cave2_box2_zdepth
#define xwidth2 mccchannel_7_cave2_box2_xwidth2
#define yheight2 mccchannel_7_cave2_box2_yheight2
#define visualize mccchannel_7_cave2_box2_visualize
#define target_index mccchannel_7_cave2_box2_target_index
#define target_x mccchannel_7_cave2_box2_target_x
#define target_y mccchannel_7_cave2_box2_target_y
#define target_z mccchannel_7_cave2_box2_target_z
#define focus_aw mccchannel_7_cave2_box2_focus_aw
#define focus_ah mccchannel_7_cave2_box2_focus_ah
#define focus_xw mccchannel_7_cave2_box2_focus_xw
#define focus_xh mccchannel_7_cave2_box2_focus_xh
#define focus_r mccchannel_7_cave2_box2_focus_r
#define p_interact mccchannel_7_cave2_box2_p_interact
#define mask_string mccchannel_7_cave2_box2_mask_string
#define mask_setting mccchannel_7_cave2_box2_mask_setting
#define number_of_activations mccchannel_7_cave2_box2_number_of_activations
#line 224 "Union_box.comp"
{
// Initializes the focusing system for this volume including input sanitation.
focus_initialize(&this_box_volume.geometry, POS_A_COMP_INDEX(INDEX_CURRENT_COMP+target_index), POS_A_CURRENT_COMP, ROT_A_CURRENT_COMP, target_index, target_x, target_y, target_z, focus_aw, focus_ah, focus_xw, focus_xh, focus_r, NAME_CURRENT_COMP);

// Input sanitation for this geometry
if (xwidth <= 0) {
  printf("\nERROR in Union_box named %s, the xwidth is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (yheight <= 0) {
  printf("\nERROR in Union_box named %s, yheight is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (zdepth <= 0) {
  printf("\nERROR in Union_box named %s, zdepth is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (xwidth2 <= 0 && xwidth2 != -1) {
  printf("\nERROR in Union_box named %s, the xwidth2 is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (yheight2 <= 0 && yheight2 != -1) {
  printf("\nERROR in Union_box named %s, yheight2 is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}

// Use sanitation
if (global_material_list.num_elements == 0) {
  printf("\nERROR: Need to define a material using Union_make_material before using a Union geometry component. \n");
  printf("       %s was defined before first use of Union_make_material.\n",NAME_CURRENT_COMP);
  exit(1);
}

this_box_volume.geometry.is_masked_volume = 0;
this_box_volume.geometry.is_exit_volume = 0;
this_box_volume.geometry.is_mask_volume = 0;
// check if the volume is a mask, if it is the material string is irelevant.
if (mask_string && strlen(mask_string) && strcmp(mask_string, "NULL") && strcmp(mask_string, "0")) {
    // A mask volume is used to limit the extend of other volumes, called the masked volumes. These are specified in the mask_string.
    // In order for a ray to enter a masked volume, it needs to be both in the region covered by that volume AND the mask volume.
    // When more than
    this_box_volume.geometry.mask_mode = 1; // Default is mask mode is ALL
    if (mask_setting && strlen(mask_setting) && strcmp(mask_setting, "NULL") && strcmp(mask_setting, "0")) {
        if (strcmp(mask_setting,"ALL") == 0 || strcmp(mask_setting,"All") == 0) this_box_volume.geometry.mask_mode = 1;
        else if (strcmp(mask_setting,"ANY") == 0 || strcmp(mask_setting,"Any") == 0) this_box_volume.geometry.mask_mode = 2;
        else {
            printf("The mask_mode of component %s is set to %s, but must be either ALL or ANY.\n",NAME_CURRENT_COMP,mask_setting);
            exit(1);
        }
    }
    
    for (loop_index=0;loop_index<global_geometry_list.num_elements;loop_index++) {
        // Add mask list
        if (1 == manual_linking_function(global_geometry_list.elements[loop_index].name,mask_string)) {
            add_element_to_int_list(&this_box_volume.geometry.mask_list,global_geometry_list.elements[loop_index].component_index);
            add_element_to_int_list(&global_geometry_list.elements[loop_index].Volume->geometry.masked_by_list,INDEX_CURRENT_COMP);
            global_geometry_list.elements[loop_index].Volume->geometry.is_masked_volume = 1;
            if (this_box_volume.geometry.mask_mode == 2)
                global_geometry_list.elements[loop_index].Volume->geometry.mask_mode = 2;
            if (this_box_volume.geometry.mask_mode == 1) {
                if (global_geometry_list.elements[loop_index].Volume->geometry.is_masked_volume == 1 && global_geometry_list.elements[loop_index].Volume->geometry.mask_mode != 2)
                    // If more than one mask is added to one volume, the ANY mode overwrites the (default) ALL mode.
                    global_geometry_list.elements[loop_index].Volume->geometry.mask_mode = 1;
            }
            
            found_geometries = 1;
        }
    }
    if (found_geometries == 0) {
        printf("The mask_string in geometry: %s did not find any of the specified volumes in the mask_string %s \n",NAME_CURRENT_COMP,mask_string);
        exit(1);
    }
    this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
    this_box_volume.p_physics->is_vacuum = 0; // Makes this volume a vacuum
    this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
    this_box_volume.p_physics->my_a = 0; // Should not be used.
    sprintf(this_box_volume.p_physics->name,"Mask");
    this_box_volume.geometry.is_mask_volume = 1;
    
    
// Read the material input, or if it lacks, use automatic linking.
} else if (material_string && strlen(material_string) && strcmp(material_string, "NULL") && strcmp(material_string, "0")) {
    // A geometry string was given, use it to determine which material
    if (0 == strcmp(material_string,"vacuum") || 0 == strcmp(material_string,"Vacuum")) {
        // One could have a global physics struct for vacuum instead of creating one for each
        this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
        this_box_volume.p_physics->is_vacuum = 1; // Makes this volume a vacuum
        this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
        this_box_volume.p_physics->my_a = 0; // Should not be used.
        sprintf(this_box_volume.p_physics->name,"Vacuum");
    } else if (0 == strcmp(material_string,"exit") || 0 == strcmp(material_string,"Exit")) {
        // One could have a global physics struct for vacuum instead of creating one for each
        this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
        this_box_volume.p_physics->is_vacuum = 1; // Makes this volume a vacuum
        this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
        this_box_volume.p_physics->my_a = 0; // Should not be used.
        this_box_volume.geometry.is_exit_volume = 1;
        sprintf(this_box_volume.p_physics->name,"Exit");
    } else {
        #ifndef MATERIAL_DETECTOR
            printf("Need to define a material before refering to it in a geometry %s.\n",NAME_CURRENT_COMP);
            exit(1);
        #endif
        for (loop_index=0;loop_index<global_material_list.num_elements;loop_index++) {
            if (0 == strcmp(material_string,global_material_list.elements[loop_index].name)) {
                this_box_volume.p_physics = global_material_list.elements[loop_index].physics;
                break;
            }
            if (loop_index == global_material_list.num_elements-1) {
            printf("\n");
            printf("ERROR: The material string \"%s\" in Union geometry \"%s\" did not match a specified material. \n",material_string,NAME_CURRENT_COMP);
            printf("       The materials available at this point (need to be defined before the geometry): \n");
            for (loop_index=0;loop_index<global_material_list.num_elements;loop_index++)
              printf("         %s\n",global_material_list.elements[loop_index].name);
            printf("\n");
            printf("       It is also possible to use one of the defualt materials avaiable: \n");
            printf("           Vacuum (for a Volume without scattering or absorption)\n");
            printf("           Exit (for a Volume where the ray exits the component if it enters)\n");
            printf("           Mask (for a Volume that masks existing volumes specified in the mask_string\n");
            exit(1);
          }
        }
    }
} else {
    // Automatic linking, simply using the last defined material.
    #ifndef MATERIAL_DETECTOR
        printf("Need to define a material before the geometry to use automatic linking %s.\n",NAME_CURRENT_COMP);
        exit(1);
    #endif
    this_box_volume.p_physics = global_material_list.elements[global_material_list.num_elements-1].physics;
}

sprintf(this_box_volume.name,NAME_CURRENT_COMP);
sprintf(this_box_volume.geometry.shape,"box");
this_box_volume.geometry.priority_value = priority;
this_box_volume.geometry.geometry_p_interact = p_interact;
// Currently the coordinates will be in absolute space.
this_box_volume.geometry.center = POS_A_CURRENT_COMP;

this_box_storage.z_depth = zdepth;
this_box_storage.x_width1 = xwidth;
this_box_storage.y_height1 = yheight;

this_box_storage.is_rectangle = 0;
if (xwidth2 < 0 && yheight2 < 0) this_box_storage.is_rectangle = 1;
if (xwidth == xwidth2 && yheight == yheight2) this_box_storage.is_rectangle = 1;

if (xwidth2 < 0) {
    this_box_storage.x_width2 = xwidth;
    xwidth2 = xwidth;
} else this_box_storage.x_width2 = xwidth2;

if (yheight2 < 0) {
    this_box_storage.y_height2 = yheight;
    yheight2 = yheight;
} else this_box_storage.y_height2 = yheight2;


this_box_storage.normal_vectors[0] = coords_set(0,0,1);
this_box_storage.normal_vectors[1] = coords_set(0,0,1);

// for sides with y component = 0
x_component = 2*zdepth/sqrt((xwidth-xwidth2)*(xwidth-xwidth2)+4*zdepth*zdepth);
z_component = (xwidth-xwidth2)/sqrt(4*zdepth*zdepth+(xwidth-xwidth2)*(xwidth-xwidth2));

this_box_storage.normal_vectors[2] = coords_set(x_component,0,z_component);
this_box_storage.normal_vectors[3] = coords_set(-x_component,0,z_component);

// for sides with x component = 0
y_component = 2*zdepth/sqrt((yheight-yheight2)*(yheight-yheight2)+4*zdepth*zdepth);
z_component = (yheight-yheight2)/sqrt(4*zdepth*zdepth+(yheight-yheight2)*(yheight-yheight2));

this_box_storage.normal_vectors[4] = coords_set(0,y_component,z_component);
this_box_storage.normal_vectors[5] = coords_set(0,-y_component,z_component);

this_box_volume.geometry.visualization_on = visualize;

this_box_volume.geometry.geometry_parameters.p_box_storage = &this_box_storage;

// Assign pointers to functions for intersection with the shape, checking if a point is inside the shape
if (this_box_storage.is_rectangle == 1) {
this_box_volume.geometry.intersect_function = &sample_box_intersect_simple;
this_box_volume.geometry.within_function = &r_within_box_simple;
}
else {
this_box_volume.geometry.intersect_function = &sample_box_intersect_advanced;
this_box_volume.geometry.within_function = &r_within_box_advanced;
}

this_box_volume.geometry.shell_points = &box_shell_points;
this_box_volume.geometry.mcdisplay_function = &mcdisplay_box_function;
this_box_volume.geometry.initialize_from_main_function = &initialize_box_geometry_from_main_component;
this_box_volume.geometry.process_rot_allocated = 0;

this_box_volume.geometry.copy_geometry_parameters = &allocate_box_storage_copy;

rot_copy(this_box_volume.geometry.rotation_matrix,ROT_A_CURRENT_COMP); //check how ROT_R_CURRENT_COMP would work
rot_transpose(ROT_A_CURRENT_COMP,this_box_volume.geometry.transpose_rotation_matrix);

// Initialize loggers
this_box_volume.loggers.num_elements = 0;

// packing the information into the global_geometry_element, which is then included in the global_geometry_list.
sprintf(global_geometry_element.name,NAME_CURRENT_COMP);
global_geometry_element.activation_counter = number_of_activations;
global_geometry_element.component_index = INDEX_CURRENT_COMP;
global_geometry_element.Volume = &this_box_volume; // Would be nicer if this m was a pointer, now we have the (small) data two places
add_element_to_geometry_list(&global_geometry_list,global_geometry_element);
}
#line 232799 "MACS_sample_kidney_box.c"
#undef number_of_activations
#undef mask_setting
#undef mask_string
#undef p_interact
#undef focus_r
#undef focus_xh
#undef focus_xw
#undef focus_ah
#undef focus_aw
#undef target_z
#undef target_y
#undef target_x
#undef target_index
#undef visualize
#undef yheight2
#undef xwidth2
#undef zdepth
#undef yheight
#undef xwidth
#undef priority
#undef material_string
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

  /* Initializations for component channel_7_cave2_box3. */
  SIG_MESSAGE("channel_7_cave2_box3 (Init)");
#define mccompcurname  channel_7_cave2_box3
#define mccompcurtype  Union_box
#define mccompcurindex 419
#define loop_index mccchannel_7_cave2_box3_loop_index
#define this_box_volume mccchannel_7_cave2_box3_this_box_volume
#define global_geometry_element mccchannel_7_cave2_box3_global_geometry_element
#define this_box_storage mccchannel_7_cave2_box3_this_box_storage
#define material_string mccchannel_7_cave2_box3_material_string
#define priority mccchannel_7_cave2_box3_priority
#define xwidth mccchannel_7_cave2_box3_xwidth
#define yheight mccchannel_7_cave2_box3_yheight
#define zdepth mccchannel_7_cave2_box3_zdepth
#define xwidth2 mccchannel_7_cave2_box3_xwidth2
#define yheight2 mccchannel_7_cave2_box3_yheight2
#define visualize mccchannel_7_cave2_box3_visualize
#define target_index mccchannel_7_cave2_box3_target_index
#define target_x mccchannel_7_cave2_box3_target_x
#define target_y mccchannel_7_cave2_box3_target_y
#define target_z mccchannel_7_cave2_box3_target_z
#define focus_aw mccchannel_7_cave2_box3_focus_aw
#define focus_ah mccchannel_7_cave2_box3_focus_ah
#define focus_xw mccchannel_7_cave2_box3_focus_xw
#define focus_xh mccchannel_7_cave2_box3_focus_xh
#define focus_r mccchannel_7_cave2_box3_focus_r
#define p_interact mccchannel_7_cave2_box3_p_interact
#define mask_string mccchannel_7_cave2_box3_mask_string
#define mask_setting mccchannel_7_cave2_box3_mask_setting
#define number_of_activations mccchannel_7_cave2_box3_number_of_activations
#line 224 "Union_box.comp"
{
// Initializes the focusing system for this volume including input sanitation.
focus_initialize(&this_box_volume.geometry, POS_A_COMP_INDEX(INDEX_CURRENT_COMP+target_index), POS_A_CURRENT_COMP, ROT_A_CURRENT_COMP, target_index, target_x, target_y, target_z, focus_aw, focus_ah, focus_xw, focus_xh, focus_r, NAME_CURRENT_COMP);

// Input sanitation for this geometry
if (xwidth <= 0) {
  printf("\nERROR in Union_box named %s, the xwidth is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (yheight <= 0) {
  printf("\nERROR in Union_box named %s, yheight is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (zdepth <= 0) {
  printf("\nERROR in Union_box named %s, zdepth is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (xwidth2 <= 0 && xwidth2 != -1) {
  printf("\nERROR in Union_box named %s, the xwidth2 is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (yheight2 <= 0 && yheight2 != -1) {
  printf("\nERROR in Union_box named %s, yheight2 is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}

// Use sanitation
if (global_material_list.num_elements == 0) {
  printf("\nERROR: Need to define a material using Union_make_material before using a Union geometry component. \n");
  printf("       %s was defined before first use of Union_make_material.\n",NAME_CURRENT_COMP);
  exit(1);
}

this_box_volume.geometry.is_masked_volume = 0;
this_box_volume.geometry.is_exit_volume = 0;
this_box_volume.geometry.is_mask_volume = 0;
// check if the volume is a mask, if it is the material string is irelevant.
if (mask_string && strlen(mask_string) && strcmp(mask_string, "NULL") && strcmp(mask_string, "0")) {
    // A mask volume is used to limit the extend of other volumes, called the masked volumes. These are specified in the mask_string.
    // In order for a ray to enter a masked volume, it needs to be both in the region covered by that volume AND the mask volume.
    // When more than
    this_box_volume.geometry.mask_mode = 1; // Default is mask mode is ALL
    if (mask_setting && strlen(mask_setting) && strcmp(mask_setting, "NULL") && strcmp(mask_setting, "0")) {
        if (strcmp(mask_setting,"ALL") == 0 || strcmp(mask_setting,"All") == 0) this_box_volume.geometry.mask_mode = 1;
        else if (strcmp(mask_setting,"ANY") == 0 || strcmp(mask_setting,"Any") == 0) this_box_volume.geometry.mask_mode = 2;
        else {
            printf("The mask_mode of component %s is set to %s, but must be either ALL or ANY.\n",NAME_CURRENT_COMP,mask_setting);
            exit(1);
        }
    }
    
    for (loop_index=0;loop_index<global_geometry_list.num_elements;loop_index++) {
        // Add mask list
        if (1 == manual_linking_function(global_geometry_list.elements[loop_index].name,mask_string)) {
            add_element_to_int_list(&this_box_volume.geometry.mask_list,global_geometry_list.elements[loop_index].component_index);
            add_element_to_int_list(&global_geometry_list.elements[loop_index].Volume->geometry.masked_by_list,INDEX_CURRENT_COMP);
            global_geometry_list.elements[loop_index].Volume->geometry.is_masked_volume = 1;
            if (this_box_volume.geometry.mask_mode == 2)
                global_geometry_list.elements[loop_index].Volume->geometry.mask_mode = 2;
            if (this_box_volume.geometry.mask_mode == 1) {
                if (global_geometry_list.elements[loop_index].Volume->geometry.is_masked_volume == 1 && global_geometry_list.elements[loop_index].Volume->geometry.mask_mode != 2)
                    // If more than one mask is added to one volume, the ANY mode overwrites the (default) ALL mode.
                    global_geometry_list.elements[loop_index].Volume->geometry.mask_mode = 1;
            }
            
            found_geometries = 1;
        }
    }
    if (found_geometries == 0) {
        printf("The mask_string in geometry: %s did not find any of the specified volumes in the mask_string %s \n",NAME_CURRENT_COMP,mask_string);
        exit(1);
    }
    this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
    this_box_volume.p_physics->is_vacuum = 0; // Makes this volume a vacuum
    this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
    this_box_volume.p_physics->my_a = 0; // Should not be used.
    sprintf(this_box_volume.p_physics->name,"Mask");
    this_box_volume.geometry.is_mask_volume = 1;
    
    
// Read the material input, or if it lacks, use automatic linking.
} else if (material_string && strlen(material_string) && strcmp(material_string, "NULL") && strcmp(material_string, "0")) {
    // A geometry string was given, use it to determine which material
    if (0 == strcmp(material_string,"vacuum") || 0 == strcmp(material_string,"Vacuum")) {
        // One could have a global physics struct for vacuum instead of creating one for each
        this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
        this_box_volume.p_physics->is_vacuum = 1; // Makes this volume a vacuum
        this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
        this_box_volume.p_physics->my_a = 0; // Should not be used.
        sprintf(this_box_volume.p_physics->name,"Vacuum");
    } else if (0 == strcmp(material_string,"exit") || 0 == strcmp(material_string,"Exit")) {
        // One could have a global physics struct for vacuum instead of creating one for each
        this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
        this_box_volume.p_physics->is_vacuum = 1; // Makes this volume a vacuum
        this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
        this_box_volume.p_physics->my_a = 0; // Should not be used.
        this_box_volume.geometry.is_exit_volume = 1;
        sprintf(this_box_volume.p_physics->name,"Exit");
    } else {
        #ifndef MATERIAL_DETECTOR
            printf("Need to define a material before refering to it in a geometry %s.\n",NAME_CURRENT_COMP);
            exit(1);
        #endif
        for (loop_index=0;loop_index<global_material_list.num_elements;loop_index++) {
            if (0 == strcmp(material_string,global_material_list.elements[loop_index].name)) {
                this_box_volume.p_physics = global_material_list.elements[loop_index].physics;
                break;
            }
            if (loop_index == global_material_list.num_elements-1) {
            printf("\n");
            printf("ERROR: The material string \"%s\" in Union geometry \"%s\" did not match a specified material. \n",material_string,NAME_CURRENT_COMP);
            printf("       The materials available at this point (need to be defined before the geometry): \n");
            for (loop_index=0;loop_index<global_material_list.num_elements;loop_index++)
              printf("         %s\n",global_material_list.elements[loop_index].name);
            printf("\n");
            printf("       It is also possible to use one of the defualt materials avaiable: \n");
            printf("           Vacuum (for a Volume without scattering or absorption)\n");
            printf("           Exit (for a Volume where the ray exits the component if it enters)\n");
            printf("           Mask (for a Volume that masks existing volumes specified in the mask_string\n");
            exit(1);
          }
        }
    }
} else {
    // Automatic linking, simply using the last defined material.
    #ifndef MATERIAL_DETECTOR
        printf("Need to define a material before the geometry to use automatic linking %s.\n",NAME_CURRENT_COMP);
        exit(1);
    #endif
    this_box_volume.p_physics = global_material_list.elements[global_material_list.num_elements-1].physics;
}

sprintf(this_box_volume.name,NAME_CURRENT_COMP);
sprintf(this_box_volume.geometry.shape,"box");
this_box_volume.geometry.priority_value = priority;
this_box_volume.geometry.geometry_p_interact = p_interact;
// Currently the coordinates will be in absolute space.
this_box_volume.geometry.center = POS_A_CURRENT_COMP;

this_box_storage.z_depth = zdepth;
this_box_storage.x_width1 = xwidth;
this_box_storage.y_height1 = yheight;

this_box_storage.is_rectangle = 0;
if (xwidth2 < 0 && yheight2 < 0) this_box_storage.is_rectangle = 1;
if (xwidth == xwidth2 && yheight == yheight2) this_box_storage.is_rectangle = 1;

if (xwidth2 < 0) {
    this_box_storage.x_width2 = xwidth;
    xwidth2 = xwidth;
} else this_box_storage.x_width2 = xwidth2;

if (yheight2 < 0) {
    this_box_storage.y_height2 = yheight;
    yheight2 = yheight;
} else this_box_storage.y_height2 = yheight2;


this_box_storage.normal_vectors[0] = coords_set(0,0,1);
this_box_storage.normal_vectors[1] = coords_set(0,0,1);

// for sides with y component = 0
x_component = 2*zdepth/sqrt((xwidth-xwidth2)*(xwidth-xwidth2)+4*zdepth*zdepth);
z_component = (xwidth-xwidth2)/sqrt(4*zdepth*zdepth+(xwidth-xwidth2)*(xwidth-xwidth2));

this_box_storage.normal_vectors[2] = coords_set(x_component,0,z_component);
this_box_storage.normal_vectors[3] = coords_set(-x_component,0,z_component);

// for sides with x component = 0
y_component = 2*zdepth/sqrt((yheight-yheight2)*(yheight-yheight2)+4*zdepth*zdepth);
z_component = (yheight-yheight2)/sqrt(4*zdepth*zdepth+(yheight-yheight2)*(yheight-yheight2));

this_box_storage.normal_vectors[4] = coords_set(0,y_component,z_component);
this_box_storage.normal_vectors[5] = coords_set(0,-y_component,z_component);

this_box_volume.geometry.visualization_on = visualize;

this_box_volume.geometry.geometry_parameters.p_box_storage = &this_box_storage;

// Assign pointers to functions for intersection with the shape, checking if a point is inside the shape
if (this_box_storage.is_rectangle == 1) {
this_box_volume.geometry.intersect_function = &sample_box_intersect_simple;
this_box_volume.geometry.within_function = &r_within_box_simple;
}
else {
this_box_volume.geometry.intersect_function = &sample_box_intersect_advanced;
this_box_volume.geometry.within_function = &r_within_box_advanced;
}

this_box_volume.geometry.shell_points = &box_shell_points;
this_box_volume.geometry.mcdisplay_function = &mcdisplay_box_function;
this_box_volume.geometry.initialize_from_main_function = &initialize_box_geometry_from_main_component;
this_box_volume.geometry.process_rot_allocated = 0;

this_box_volume.geometry.copy_geometry_parameters = &allocate_box_storage_copy;

rot_copy(this_box_volume.geometry.rotation_matrix,ROT_A_CURRENT_COMP); //check how ROT_R_CURRENT_COMP would work
rot_transpose(ROT_A_CURRENT_COMP,this_box_volume.geometry.transpose_rotation_matrix);

// Initialize loggers
this_box_volume.loggers.num_elements = 0;

// packing the information into the global_geometry_element, which is then included in the global_geometry_list.
sprintf(global_geometry_element.name,NAME_CURRENT_COMP);
global_geometry_element.activation_counter = number_of_activations;
global_geometry_element.component_index = INDEX_CURRENT_COMP;
global_geometry_element.Volume = &this_box_volume; // Would be nicer if this m was a pointer, now we have the (small) data two places
add_element_to_geometry_list(&global_geometry_list,global_geometry_element);
}
#line 233069 "MACS_sample_kidney_box.c"
#undef number_of_activations
#undef mask_setting
#undef mask_string
#undef p_interact
#undef focus_r
#undef focus_xh
#undef focus_xw
#undef focus_ah
#undef focus_aw
#undef target_z
#undef target_y
#undef target_x
#undef target_index
#undef visualize
#undef yheight2
#undef xwidth2
#undef zdepth
#undef yheight
#undef xwidth
#undef priority
#undef material_string
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

  /* Initializations for component inter_analyzer_colimator_center_7. */
  SIG_MESSAGE("inter_analyzer_colimator_center_7 (Init)");

  /* Initializations for component inter_analyzer_colimator_7_blade_0. */
  SIG_MESSAGE("inter_analyzer_colimator_7_blade_0 (Init)");
#define mccompcurname  inter_analyzer_colimator_7_blade_0
#define mccompcurtype  Union_box
#define mccompcurindex 421
#define loop_index mccinter_analyzer_colimator_7_blade_0_loop_index
#define this_box_volume mccinter_analyzer_colimator_7_blade_0_this_box_volume
#define global_geometry_element mccinter_analyzer_colimator_7_blade_0_global_geometry_element
#define this_box_storage mccinter_analyzer_colimator_7_blade_0_this_box_storage
#define material_string mccinter_analyzer_colimator_7_blade_0_material_string
#define priority mccinter_analyzer_colimator_7_blade_0_priority
#define xwidth mccinter_analyzer_colimator_7_blade_0_xwidth
#define yheight mccinter_analyzer_colimator_7_blade_0_yheight
#define zdepth mccinter_analyzer_colimator_7_blade_0_zdepth
#define xwidth2 mccinter_analyzer_colimator_7_blade_0_xwidth2
#define yheight2 mccinter_analyzer_colimator_7_blade_0_yheight2
#define visualize mccinter_analyzer_colimator_7_blade_0_visualize
#define target_index mccinter_analyzer_colimator_7_blade_0_target_index
#define target_x mccinter_analyzer_colimator_7_blade_0_target_x
#define target_y mccinter_analyzer_colimator_7_blade_0_target_y
#define target_z mccinter_analyzer_colimator_7_blade_0_target_z
#define focus_aw mccinter_analyzer_colimator_7_blade_0_focus_aw
#define focus_ah mccinter_analyzer_colimator_7_blade_0_focus_ah
#define focus_xw mccinter_analyzer_colimator_7_blade_0_focus_xw
#define focus_xh mccinter_analyzer_colimator_7_blade_0_focus_xh
#define focus_r mccinter_analyzer_colimator_7_blade_0_focus_r
#define p_interact mccinter_analyzer_colimator_7_blade_0_p_interact
#define mask_string mccinter_analyzer_colimator_7_blade_0_mask_string
#define mask_setting mccinter_analyzer_colimator_7_blade_0_mask_setting
#define number_of_activations mccinter_analyzer_colimator_7_blade_0_number_of_activations
#line 224 "Union_box.comp"
{
// Initializes the focusing system for this volume including input sanitation.
focus_initialize(&this_box_volume.geometry, POS_A_COMP_INDEX(INDEX_CURRENT_COMP+target_index), POS_A_CURRENT_COMP, ROT_A_CURRENT_COMP, target_index, target_x, target_y, target_z, focus_aw, focus_ah, focus_xw, focus_xh, focus_r, NAME_CURRENT_COMP);

// Input sanitation for this geometry
if (xwidth <= 0) {
  printf("\nERROR in Union_box named %s, the xwidth is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (yheight <= 0) {
  printf("\nERROR in Union_box named %s, yheight is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (zdepth <= 0) {
  printf("\nERROR in Union_box named %s, zdepth is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (xwidth2 <= 0 && xwidth2 != -1) {
  printf("\nERROR in Union_box named %s, the xwidth2 is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (yheight2 <= 0 && yheight2 != -1) {
  printf("\nERROR in Union_box named %s, yheight2 is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}

// Use sanitation
if (global_material_list.num_elements == 0) {
  printf("\nERROR: Need to define a material using Union_make_material before using a Union geometry component. \n");
  printf("       %s was defined before first use of Union_make_material.\n",NAME_CURRENT_COMP);
  exit(1);
}

this_box_volume.geometry.is_masked_volume = 0;
this_box_volume.geometry.is_exit_volume = 0;
this_box_volume.geometry.is_mask_volume = 0;
// check if the volume is a mask, if it is the material string is irelevant.
if (mask_string && strlen(mask_string) && strcmp(mask_string, "NULL") && strcmp(mask_string, "0")) {
    // A mask volume is used to limit the extend of other volumes, called the masked volumes. These are specified in the mask_string.
    // In order for a ray to enter a masked volume, it needs to be both in the region covered by that volume AND the mask volume.
    // When more than
    this_box_volume.geometry.mask_mode = 1; // Default is mask mode is ALL
    if (mask_setting && strlen(mask_setting) && strcmp(mask_setting, "NULL") && strcmp(mask_setting, "0")) {
        if (strcmp(mask_setting,"ALL") == 0 || strcmp(mask_setting,"All") == 0) this_box_volume.geometry.mask_mode = 1;
        else if (strcmp(mask_setting,"ANY") == 0 || strcmp(mask_setting,"Any") == 0) this_box_volume.geometry.mask_mode = 2;
        else {
            printf("The mask_mode of component %s is set to %s, but must be either ALL or ANY.\n",NAME_CURRENT_COMP,mask_setting);
            exit(1);
        }
    }
    
    for (loop_index=0;loop_index<global_geometry_list.num_elements;loop_index++) {
        // Add mask list
        if (1 == manual_linking_function(global_geometry_list.elements[loop_index].name,mask_string)) {
            add_element_to_int_list(&this_box_volume.geometry.mask_list,global_geometry_list.elements[loop_index].component_index);
            add_element_to_int_list(&global_geometry_list.elements[loop_index].Volume->geometry.masked_by_list,INDEX_CURRENT_COMP);
            global_geometry_list.elements[loop_index].Volume->geometry.is_masked_volume = 1;
            if (this_box_volume.geometry.mask_mode == 2)
                global_geometry_list.elements[loop_index].Volume->geometry.mask_mode = 2;
            if (this_box_volume.geometry.mask_mode == 1) {
                if (global_geometry_list.elements[loop_index].Volume->geometry.is_masked_volume == 1 && global_geometry_list.elements[loop_index].Volume->geometry.mask_mode != 2)
                    // If more than one mask is added to one volume, the ANY mode overwrites the (default) ALL mode.
                    global_geometry_list.elements[loop_index].Volume->geometry.mask_mode = 1;
            }
            
            found_geometries = 1;
        }
    }
    if (found_geometries == 0) {
        printf("The mask_string in geometry: %s did not find any of the specified volumes in the mask_string %s \n",NAME_CURRENT_COMP,mask_string);
        exit(1);
    }
    this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
    this_box_volume.p_physics->is_vacuum = 0; // Makes this volume a vacuum
    this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
    this_box_volume.p_physics->my_a = 0; // Should not be used.
    sprintf(this_box_volume.p_physics->name,"Mask");
    this_box_volume.geometry.is_mask_volume = 1;
    
    
// Read the material input, or if it lacks, use automatic linking.
} else if (material_string && strlen(material_string) && strcmp(material_string, "NULL") && strcmp(material_string, "0")) {
    // A geometry string was given, use it to determine which material
    if (0 == strcmp(material_string,"vacuum") || 0 == strcmp(material_string,"Vacuum")) {
        // One could have a global physics struct for vacuum instead of creating one for each
        this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
        this_box_volume.p_physics->is_vacuum = 1; // Makes this volume a vacuum
        this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
        this_box_volume.p_physics->my_a = 0; // Should not be used.
        sprintf(this_box_volume.p_physics->name,"Vacuum");
    } else if (0 == strcmp(material_string,"exit") || 0 == strcmp(material_string,"Exit")) {
        // One could have a global physics struct for vacuum instead of creating one for each
        this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
        this_box_volume.p_physics->is_vacuum = 1; // Makes this volume a vacuum
        this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
        this_box_volume.p_physics->my_a = 0; // Should not be used.
        this_box_volume.geometry.is_exit_volume = 1;
        sprintf(this_box_volume.p_physics->name,"Exit");
    } else {
        #ifndef MATERIAL_DETECTOR
            printf("Need to define a material before refering to it in a geometry %s.\n",NAME_CURRENT_COMP);
            exit(1);
        #endif
        for (loop_index=0;loop_index<global_material_list.num_elements;loop_index++) {
            if (0 == strcmp(material_string,global_material_list.elements[loop_index].name)) {
                this_box_volume.p_physics = global_material_list.elements[loop_index].physics;
                break;
            }
            if (loop_index == global_material_list.num_elements-1) {
            printf("\n");
            printf("ERROR: The material string \"%s\" in Union geometry \"%s\" did not match a specified material. \n",material_string,NAME_CURRENT_COMP);
            printf("       The materials available at this point (need to be defined before the geometry): \n");
            for (loop_index=0;loop_index<global_material_list.num_elements;loop_index++)
              printf("         %s\n",global_material_list.elements[loop_index].name);
            printf("\n");
            printf("       It is also possible to use one of the defualt materials avaiable: \n");
            printf("           Vacuum (for a Volume without scattering or absorption)\n");
            printf("           Exit (for a Volume where the ray exits the component if it enters)\n");
            printf("           Mask (for a Volume that masks existing volumes specified in the mask_string\n");
            exit(1);
          }
        }
    }
} else {
    // Automatic linking, simply using the last defined material.
    #ifndef MATERIAL_DETECTOR
        printf("Need to define a material before the geometry to use automatic linking %s.\n",NAME_CURRENT_COMP);
        exit(1);
    #endif
    this_box_volume.p_physics = global_material_list.elements[global_material_list.num_elements-1].physics;
}

sprintf(this_box_volume.name,NAME_CURRENT_COMP);
sprintf(this_box_volume.geometry.shape,"box");
this_box_volume.geometry.priority_value = priority;
this_box_volume.geometry.geometry_p_interact = p_interact;
// Currently the coordinates will be in absolute space.
this_box_volume.geometry.center = POS_A_CURRENT_COMP;

this_box_storage.z_depth = zdepth;
this_box_storage.x_width1 = xwidth;
this_box_storage.y_height1 = yheight;

this_box_storage.is_rectangle = 0;
if (xwidth2 < 0 && yheight2 < 0) this_box_storage.is_rectangle = 1;
if (xwidth == xwidth2 && yheight == yheight2) this_box_storage.is_rectangle = 1;

if (xwidth2 < 0) {
    this_box_storage.x_width2 = xwidth;
    xwidth2 = xwidth;
} else this_box_storage.x_width2 = xwidth2;

if (yheight2 < 0) {
    this_box_storage.y_height2 = yheight;
    yheight2 = yheight;
} else this_box_storage.y_height2 = yheight2;


this_box_storage.normal_vectors[0] = coords_set(0,0,1);
this_box_storage.normal_vectors[1] = coords_set(0,0,1);

// for sides with y component = 0
x_component = 2*zdepth/sqrt((xwidth-xwidth2)*(xwidth-xwidth2)+4*zdepth*zdepth);
z_component = (xwidth-xwidth2)/sqrt(4*zdepth*zdepth+(xwidth-xwidth2)*(xwidth-xwidth2));

this_box_storage.normal_vectors[2] = coords_set(x_component,0,z_component);
this_box_storage.normal_vectors[3] = coords_set(-x_component,0,z_component);

// for sides with x component = 0
y_component = 2*zdepth/sqrt((yheight-yheight2)*(yheight-yheight2)+4*zdepth*zdepth);
z_component = (yheight-yheight2)/sqrt(4*zdepth*zdepth+(yheight-yheight2)*(yheight-yheight2));

this_box_storage.normal_vectors[4] = coords_set(0,y_component,z_component);
this_box_storage.normal_vectors[5] = coords_set(0,-y_component,z_component);

this_box_volume.geometry.visualization_on = visualize;

this_box_volume.geometry.geometry_parameters.p_box_storage = &this_box_storage;

// Assign pointers to functions for intersection with the shape, checking if a point is inside the shape
if (this_box_storage.is_rectangle == 1) {
this_box_volume.geometry.intersect_function = &sample_box_intersect_simple;
this_box_volume.geometry.within_function = &r_within_box_simple;
}
else {
this_box_volume.geometry.intersect_function = &sample_box_intersect_advanced;
this_box_volume.geometry.within_function = &r_within_box_advanced;
}

this_box_volume.geometry.shell_points = &box_shell_points;
this_box_volume.geometry.mcdisplay_function = &mcdisplay_box_function;
this_box_volume.geometry.initialize_from_main_function = &initialize_box_geometry_from_main_component;
this_box_volume.geometry.process_rot_allocated = 0;

this_box_volume.geometry.copy_geometry_parameters = &allocate_box_storage_copy;

rot_copy(this_box_volume.geometry.rotation_matrix,ROT_A_CURRENT_COMP); //check how ROT_R_CURRENT_COMP would work
rot_transpose(ROT_A_CURRENT_COMP,this_box_volume.geometry.transpose_rotation_matrix);

// Initialize loggers
this_box_volume.loggers.num_elements = 0;

// packing the information into the global_geometry_element, which is then included in the global_geometry_list.
sprintf(global_geometry_element.name,NAME_CURRENT_COMP);
global_geometry_element.activation_counter = number_of_activations;
global_geometry_element.component_index = INDEX_CURRENT_COMP;
global_geometry_element.Volume = &this_box_volume; // Would be nicer if this m was a pointer, now we have the (small) data two places
add_element_to_geometry_list(&global_geometry_list,global_geometry_element);
}
#line 233342 "MACS_sample_kidney_box.c"
#undef number_of_activations
#undef mask_setting
#undef mask_string
#undef p_interact
#undef focus_r
#undef focus_xh
#undef focus_xw
#undef focus_ah
#undef focus_aw
#undef target_z
#undef target_y
#undef target_x
#undef target_index
#undef visualize
#undef yheight2
#undef xwidth2
#undef zdepth
#undef yheight
#undef xwidth
#undef priority
#undef material_string
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

  /* Initializations for component inter_analyzer_colimator_7_blade_1. */
  SIG_MESSAGE("inter_analyzer_colimator_7_blade_1 (Init)");
#define mccompcurname  inter_analyzer_colimator_7_blade_1
#define mccompcurtype  Union_box
#define mccompcurindex 422
#define loop_index mccinter_analyzer_colimator_7_blade_1_loop_index
#define this_box_volume mccinter_analyzer_colimator_7_blade_1_this_box_volume
#define global_geometry_element mccinter_analyzer_colimator_7_blade_1_global_geometry_element
#define this_box_storage mccinter_analyzer_colimator_7_blade_1_this_box_storage
#define material_string mccinter_analyzer_colimator_7_blade_1_material_string
#define priority mccinter_analyzer_colimator_7_blade_1_priority
#define xwidth mccinter_analyzer_colimator_7_blade_1_xwidth
#define yheight mccinter_analyzer_colimator_7_blade_1_yheight
#define zdepth mccinter_analyzer_colimator_7_blade_1_zdepth
#define xwidth2 mccinter_analyzer_colimator_7_blade_1_xwidth2
#define yheight2 mccinter_analyzer_colimator_7_blade_1_yheight2
#define visualize mccinter_analyzer_colimator_7_blade_1_visualize
#define target_index mccinter_analyzer_colimator_7_blade_1_target_index
#define target_x mccinter_analyzer_colimator_7_blade_1_target_x
#define target_y mccinter_analyzer_colimator_7_blade_1_target_y
#define target_z mccinter_analyzer_colimator_7_blade_1_target_z
#define focus_aw mccinter_analyzer_colimator_7_blade_1_focus_aw
#define focus_ah mccinter_analyzer_colimator_7_blade_1_focus_ah
#define focus_xw mccinter_analyzer_colimator_7_blade_1_focus_xw
#define focus_xh mccinter_analyzer_colimator_7_blade_1_focus_xh
#define focus_r mccinter_analyzer_colimator_7_blade_1_focus_r
#define p_interact mccinter_analyzer_colimator_7_blade_1_p_interact
#define mask_string mccinter_analyzer_colimator_7_blade_1_mask_string
#define mask_setting mccinter_analyzer_colimator_7_blade_1_mask_setting
#define number_of_activations mccinter_analyzer_colimator_7_blade_1_number_of_activations
#line 224 "Union_box.comp"
{
// Initializes the focusing system for this volume including input sanitation.
focus_initialize(&this_box_volume.geometry, POS_A_COMP_INDEX(INDEX_CURRENT_COMP+target_index), POS_A_CURRENT_COMP, ROT_A_CURRENT_COMP, target_index, target_x, target_y, target_z, focus_aw, focus_ah, focus_xw, focus_xh, focus_r, NAME_CURRENT_COMP);

// Input sanitation for this geometry
if (xwidth <= 0) {
  printf("\nERROR in Union_box named %s, the xwidth is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (yheight <= 0) {
  printf("\nERROR in Union_box named %s, yheight is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (zdepth <= 0) {
  printf("\nERROR in Union_box named %s, zdepth is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (xwidth2 <= 0 && xwidth2 != -1) {
  printf("\nERROR in Union_box named %s, the xwidth2 is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (yheight2 <= 0 && yheight2 != -1) {
  printf("\nERROR in Union_box named %s, yheight2 is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}

// Use sanitation
if (global_material_list.num_elements == 0) {
  printf("\nERROR: Need to define a material using Union_make_material before using a Union geometry component. \n");
  printf("       %s was defined before first use of Union_make_material.\n",NAME_CURRENT_COMP);
  exit(1);
}

this_box_volume.geometry.is_masked_volume = 0;
this_box_volume.geometry.is_exit_volume = 0;
this_box_volume.geometry.is_mask_volume = 0;
// check if the volume is a mask, if it is the material string is irelevant.
if (mask_string && strlen(mask_string) && strcmp(mask_string, "NULL") && strcmp(mask_string, "0")) {
    // A mask volume is used to limit the extend of other volumes, called the masked volumes. These are specified in the mask_string.
    // In order for a ray to enter a masked volume, it needs to be both in the region covered by that volume AND the mask volume.
    // When more than
    this_box_volume.geometry.mask_mode = 1; // Default is mask mode is ALL
    if (mask_setting && strlen(mask_setting) && strcmp(mask_setting, "NULL") && strcmp(mask_setting, "0")) {
        if (strcmp(mask_setting,"ALL") == 0 || strcmp(mask_setting,"All") == 0) this_box_volume.geometry.mask_mode = 1;
        else if (strcmp(mask_setting,"ANY") == 0 || strcmp(mask_setting,"Any") == 0) this_box_volume.geometry.mask_mode = 2;
        else {
            printf("The mask_mode of component %s is set to %s, but must be either ALL or ANY.\n",NAME_CURRENT_COMP,mask_setting);
            exit(1);
        }
    }
    
    for (loop_index=0;loop_index<global_geometry_list.num_elements;loop_index++) {
        // Add mask list
        if (1 == manual_linking_function(global_geometry_list.elements[loop_index].name,mask_string)) {
            add_element_to_int_list(&this_box_volume.geometry.mask_list,global_geometry_list.elements[loop_index].component_index);
            add_element_to_int_list(&global_geometry_list.elements[loop_index].Volume->geometry.masked_by_list,INDEX_CURRENT_COMP);
            global_geometry_list.elements[loop_index].Volume->geometry.is_masked_volume = 1;
            if (this_box_volume.geometry.mask_mode == 2)
                global_geometry_list.elements[loop_index].Volume->geometry.mask_mode = 2;
            if (this_box_volume.geometry.mask_mode == 1) {
                if (global_geometry_list.elements[loop_index].Volume->geometry.is_masked_volume == 1 && global_geometry_list.elements[loop_index].Volume->geometry.mask_mode != 2)
                    // If more than one mask is added to one volume, the ANY mode overwrites the (default) ALL mode.
                    global_geometry_list.elements[loop_index].Volume->geometry.mask_mode = 1;
            }
            
            found_geometries = 1;
        }
    }
    if (found_geometries == 0) {
        printf("The mask_string in geometry: %s did not find any of the specified volumes in the mask_string %s \n",NAME_CURRENT_COMP,mask_string);
        exit(1);
    }
    this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
    this_box_volume.p_physics->is_vacuum = 0; // Makes this volume a vacuum
    this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
    this_box_volume.p_physics->my_a = 0; // Should not be used.
    sprintf(this_box_volume.p_physics->name,"Mask");
    this_box_volume.geometry.is_mask_volume = 1;
    
    
// Read the material input, or if it lacks, use automatic linking.
} else if (material_string && strlen(material_string) && strcmp(material_string, "NULL") && strcmp(material_string, "0")) {
    // A geometry string was given, use it to determine which material
    if (0 == strcmp(material_string,"vacuum") || 0 == strcmp(material_string,"Vacuum")) {
        // One could have a global physics struct for vacuum instead of creating one for each
        this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
        this_box_volume.p_physics->is_vacuum = 1; // Makes this volume a vacuum
        this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
        this_box_volume.p_physics->my_a = 0; // Should not be used.
        sprintf(this_box_volume.p_physics->name,"Vacuum");
    } else if (0 == strcmp(material_string,"exit") || 0 == strcmp(material_string,"Exit")) {
        // One could have a global physics struct for vacuum instead of creating one for each
        this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
        this_box_volume.p_physics->is_vacuum = 1; // Makes this volume a vacuum
        this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
        this_box_volume.p_physics->my_a = 0; // Should not be used.
        this_box_volume.geometry.is_exit_volume = 1;
        sprintf(this_box_volume.p_physics->name,"Exit");
    } else {
        #ifndef MATERIAL_DETECTOR
            printf("Need to define a material before refering to it in a geometry %s.\n",NAME_CURRENT_COMP);
            exit(1);
        #endif
        for (loop_index=0;loop_index<global_material_list.num_elements;loop_index++) {
            if (0 == strcmp(material_string,global_material_list.elements[loop_index].name)) {
                this_box_volume.p_physics = global_material_list.elements[loop_index].physics;
                break;
            }
            if (loop_index == global_material_list.num_elements-1) {
            printf("\n");
            printf("ERROR: The material string \"%s\" in Union geometry \"%s\" did not match a specified material. \n",material_string,NAME_CURRENT_COMP);
            printf("       The materials available at this point (need to be defined before the geometry): \n");
            for (loop_index=0;loop_index<global_material_list.num_elements;loop_index++)
              printf("         %s\n",global_material_list.elements[loop_index].name);
            printf("\n");
            printf("       It is also possible to use one of the defualt materials avaiable: \n");
            printf("           Vacuum (for a Volume without scattering or absorption)\n");
            printf("           Exit (for a Volume where the ray exits the component if it enters)\n");
            printf("           Mask (for a Volume that masks existing volumes specified in the mask_string\n");
            exit(1);
          }
        }
    }
} else {
    // Automatic linking, simply using the last defined material.
    #ifndef MATERIAL_DETECTOR
        printf("Need to define a material before the geometry to use automatic linking %s.\n",NAME_CURRENT_COMP);
        exit(1);
    #endif
    this_box_volume.p_physics = global_material_list.elements[global_material_list.num_elements-1].physics;
}

sprintf(this_box_volume.name,NAME_CURRENT_COMP);
sprintf(this_box_volume.geometry.shape,"box");
this_box_volume.geometry.priority_value = priority;
this_box_volume.geometry.geometry_p_interact = p_interact;
// Currently the coordinates will be in absolute space.
this_box_volume.geometry.center = POS_A_CURRENT_COMP;

this_box_storage.z_depth = zdepth;
this_box_storage.x_width1 = xwidth;
this_box_storage.y_height1 = yheight;

this_box_storage.is_rectangle = 0;
if (xwidth2 < 0 && yheight2 < 0) this_box_storage.is_rectangle = 1;
if (xwidth == xwidth2 && yheight == yheight2) this_box_storage.is_rectangle = 1;

if (xwidth2 < 0) {
    this_box_storage.x_width2 = xwidth;
    xwidth2 = xwidth;
} else this_box_storage.x_width2 = xwidth2;

if (yheight2 < 0) {
    this_box_storage.y_height2 = yheight;
    yheight2 = yheight;
} else this_box_storage.y_height2 = yheight2;


this_box_storage.normal_vectors[0] = coords_set(0,0,1);
this_box_storage.normal_vectors[1] = coords_set(0,0,1);

// for sides with y component = 0
x_component = 2*zdepth/sqrt((xwidth-xwidth2)*(xwidth-xwidth2)+4*zdepth*zdepth);
z_component = (xwidth-xwidth2)/sqrt(4*zdepth*zdepth+(xwidth-xwidth2)*(xwidth-xwidth2));

this_box_storage.normal_vectors[2] = coords_set(x_component,0,z_component);
this_box_storage.normal_vectors[3] = coords_set(-x_component,0,z_component);

// for sides with x component = 0
y_component = 2*zdepth/sqrt((yheight-yheight2)*(yheight-yheight2)+4*zdepth*zdepth);
z_component = (yheight-yheight2)/sqrt(4*zdepth*zdepth+(yheight-yheight2)*(yheight-yheight2));

this_box_storage.normal_vectors[4] = coords_set(0,y_component,z_component);
this_box_storage.normal_vectors[5] = coords_set(0,-y_component,z_component);

this_box_volume.geometry.visualization_on = visualize;

this_box_volume.geometry.geometry_parameters.p_box_storage = &this_box_storage;

// Assign pointers to functions for intersection with the shape, checking if a point is inside the shape
if (this_box_storage.is_rectangle == 1) {
this_box_volume.geometry.intersect_function = &sample_box_intersect_simple;
this_box_volume.geometry.within_function = &r_within_box_simple;
}
else {
this_box_volume.geometry.intersect_function = &sample_box_intersect_advanced;
this_box_volume.geometry.within_function = &r_within_box_advanced;
}

this_box_volume.geometry.shell_points = &box_shell_points;
this_box_volume.geometry.mcdisplay_function = &mcdisplay_box_function;
this_box_volume.geometry.initialize_from_main_function = &initialize_box_geometry_from_main_component;
this_box_volume.geometry.process_rot_allocated = 0;

this_box_volume.geometry.copy_geometry_parameters = &allocate_box_storage_copy;

rot_copy(this_box_volume.geometry.rotation_matrix,ROT_A_CURRENT_COMP); //check how ROT_R_CURRENT_COMP would work
rot_transpose(ROT_A_CURRENT_COMP,this_box_volume.geometry.transpose_rotation_matrix);

// Initialize loggers
this_box_volume.loggers.num_elements = 0;

// packing the information into the global_geometry_element, which is then included in the global_geometry_list.
sprintf(global_geometry_element.name,NAME_CURRENT_COMP);
global_geometry_element.activation_counter = number_of_activations;
global_geometry_element.component_index = INDEX_CURRENT_COMP;
global_geometry_element.Volume = &this_box_volume; // Would be nicer if this m was a pointer, now we have the (small) data two places
add_element_to_geometry_list(&global_geometry_list,global_geometry_element);
}
#line 233612 "MACS_sample_kidney_box.c"
#undef number_of_activations
#undef mask_setting
#undef mask_string
#undef p_interact
#undef focus_r
#undef focus_xh
#undef focus_xw
#undef focus_ah
#undef focus_aw
#undef target_z
#undef target_y
#undef target_x
#undef target_index
#undef visualize
#undef yheight2
#undef xwidth2
#undef zdepth
#undef yheight
#undef xwidth
#undef priority
#undef material_string
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

  /* Initializations for component inter_analyzer_colimator_7_blade_2. */
  SIG_MESSAGE("inter_analyzer_colimator_7_blade_2 (Init)");
#define mccompcurname  inter_analyzer_colimator_7_blade_2
#define mccompcurtype  Union_box
#define mccompcurindex 423
#define loop_index mccinter_analyzer_colimator_7_blade_2_loop_index
#define this_box_volume mccinter_analyzer_colimator_7_blade_2_this_box_volume
#define global_geometry_element mccinter_analyzer_colimator_7_blade_2_global_geometry_element
#define this_box_storage mccinter_analyzer_colimator_7_blade_2_this_box_storage
#define material_string mccinter_analyzer_colimator_7_blade_2_material_string
#define priority mccinter_analyzer_colimator_7_blade_2_priority
#define xwidth mccinter_analyzer_colimator_7_blade_2_xwidth
#define yheight mccinter_analyzer_colimator_7_blade_2_yheight
#define zdepth mccinter_analyzer_colimator_7_blade_2_zdepth
#define xwidth2 mccinter_analyzer_colimator_7_blade_2_xwidth2
#define yheight2 mccinter_analyzer_colimator_7_blade_2_yheight2
#define visualize mccinter_analyzer_colimator_7_blade_2_visualize
#define target_index mccinter_analyzer_colimator_7_blade_2_target_index
#define target_x mccinter_analyzer_colimator_7_blade_2_target_x
#define target_y mccinter_analyzer_colimator_7_blade_2_target_y
#define target_z mccinter_analyzer_colimator_7_blade_2_target_z
#define focus_aw mccinter_analyzer_colimator_7_blade_2_focus_aw
#define focus_ah mccinter_analyzer_colimator_7_blade_2_focus_ah
#define focus_xw mccinter_analyzer_colimator_7_blade_2_focus_xw
#define focus_xh mccinter_analyzer_colimator_7_blade_2_focus_xh
#define focus_r mccinter_analyzer_colimator_7_blade_2_focus_r
#define p_interact mccinter_analyzer_colimator_7_blade_2_p_interact
#define mask_string mccinter_analyzer_colimator_7_blade_2_mask_string
#define mask_setting mccinter_analyzer_colimator_7_blade_2_mask_setting
#define number_of_activations mccinter_analyzer_colimator_7_blade_2_number_of_activations
#line 224 "Union_box.comp"
{
// Initializes the focusing system for this volume including input sanitation.
focus_initialize(&this_box_volume.geometry, POS_A_COMP_INDEX(INDEX_CURRENT_COMP+target_index), POS_A_CURRENT_COMP, ROT_A_CURRENT_COMP, target_index, target_x, target_y, target_z, focus_aw, focus_ah, focus_xw, focus_xh, focus_r, NAME_CURRENT_COMP);

// Input sanitation for this geometry
if (xwidth <= 0) {
  printf("\nERROR in Union_box named %s, the xwidth is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (yheight <= 0) {
  printf("\nERROR in Union_box named %s, yheight is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (zdepth <= 0) {
  printf("\nERROR in Union_box named %s, zdepth is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (xwidth2 <= 0 && xwidth2 != -1) {
  printf("\nERROR in Union_box named %s, the xwidth2 is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (yheight2 <= 0 && yheight2 != -1) {
  printf("\nERROR in Union_box named %s, yheight2 is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}

// Use sanitation
if (global_material_list.num_elements == 0) {
  printf("\nERROR: Need to define a material using Union_make_material before using a Union geometry component. \n");
  printf("       %s was defined before first use of Union_make_material.\n",NAME_CURRENT_COMP);
  exit(1);
}

this_box_volume.geometry.is_masked_volume = 0;
this_box_volume.geometry.is_exit_volume = 0;
this_box_volume.geometry.is_mask_volume = 0;
// check if the volume is a mask, if it is the material string is irelevant.
if (mask_string && strlen(mask_string) && strcmp(mask_string, "NULL") && strcmp(mask_string, "0")) {
    // A mask volume is used to limit the extend of other volumes, called the masked volumes. These are specified in the mask_string.
    // In order for a ray to enter a masked volume, it needs to be both in the region covered by that volume AND the mask volume.
    // When more than
    this_box_volume.geometry.mask_mode = 1; // Default is mask mode is ALL
    if (mask_setting && strlen(mask_setting) && strcmp(mask_setting, "NULL") && strcmp(mask_setting, "0")) {
        if (strcmp(mask_setting,"ALL") == 0 || strcmp(mask_setting,"All") == 0) this_box_volume.geometry.mask_mode = 1;
        else if (strcmp(mask_setting,"ANY") == 0 || strcmp(mask_setting,"Any") == 0) this_box_volume.geometry.mask_mode = 2;
        else {
            printf("The mask_mode of component %s is set to %s, but must be either ALL or ANY.\n",NAME_CURRENT_COMP,mask_setting);
            exit(1);
        }
    }
    
    for (loop_index=0;loop_index<global_geometry_list.num_elements;loop_index++) {
        // Add mask list
        if (1 == manual_linking_function(global_geometry_list.elements[loop_index].name,mask_string)) {
            add_element_to_int_list(&this_box_volume.geometry.mask_list,global_geometry_list.elements[loop_index].component_index);
            add_element_to_int_list(&global_geometry_list.elements[loop_index].Volume->geometry.masked_by_list,INDEX_CURRENT_COMP);
            global_geometry_list.elements[loop_index].Volume->geometry.is_masked_volume = 1;
            if (this_box_volume.geometry.mask_mode == 2)
                global_geometry_list.elements[loop_index].Volume->geometry.mask_mode = 2;
            if (this_box_volume.geometry.mask_mode == 1) {
                if (global_geometry_list.elements[loop_index].Volume->geometry.is_masked_volume == 1 && global_geometry_list.elements[loop_index].Volume->geometry.mask_mode != 2)
                    // If more than one mask is added to one volume, the ANY mode overwrites the (default) ALL mode.
                    global_geometry_list.elements[loop_index].Volume->geometry.mask_mode = 1;
            }
            
            found_geometries = 1;
        }
    }
    if (found_geometries == 0) {
        printf("The mask_string in geometry: %s did not find any of the specified volumes in the mask_string %s \n",NAME_CURRENT_COMP,mask_string);
        exit(1);
    }
    this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
    this_box_volume.p_physics->is_vacuum = 0; // Makes this volume a vacuum
    this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
    this_box_volume.p_physics->my_a = 0; // Should not be used.
    sprintf(this_box_volume.p_physics->name,"Mask");
    this_box_volume.geometry.is_mask_volume = 1;
    
    
// Read the material input, or if it lacks, use automatic linking.
} else if (material_string && strlen(material_string) && strcmp(material_string, "NULL") && strcmp(material_string, "0")) {
    // A geometry string was given, use it to determine which material
    if (0 == strcmp(material_string,"vacuum") || 0 == strcmp(material_string,"Vacuum")) {
        // One could have a global physics struct for vacuum instead of creating one for each
        this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
        this_box_volume.p_physics->is_vacuum = 1; // Makes this volume a vacuum
        this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
        this_box_volume.p_physics->my_a = 0; // Should not be used.
        sprintf(this_box_volume.p_physics->name,"Vacuum");
    } else if (0 == strcmp(material_string,"exit") || 0 == strcmp(material_string,"Exit")) {
        // One could have a global physics struct for vacuum instead of creating one for each
        this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
        this_box_volume.p_physics->is_vacuum = 1; // Makes this volume a vacuum
        this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
        this_box_volume.p_physics->my_a = 0; // Should not be used.
        this_box_volume.geometry.is_exit_volume = 1;
        sprintf(this_box_volume.p_physics->name,"Exit");
    } else {
        #ifndef MATERIAL_DETECTOR
            printf("Need to define a material before refering to it in a geometry %s.\n",NAME_CURRENT_COMP);
            exit(1);
        #endif
        for (loop_index=0;loop_index<global_material_list.num_elements;loop_index++) {
            if (0 == strcmp(material_string,global_material_list.elements[loop_index].name)) {
                this_box_volume.p_physics = global_material_list.elements[loop_index].physics;
                break;
            }
            if (loop_index == global_material_list.num_elements-1) {
            printf("\n");
            printf("ERROR: The material string \"%s\" in Union geometry \"%s\" did not match a specified material. \n",material_string,NAME_CURRENT_COMP);
            printf("       The materials available at this point (need to be defined before the geometry): \n");
            for (loop_index=0;loop_index<global_material_list.num_elements;loop_index++)
              printf("         %s\n",global_material_list.elements[loop_index].name);
            printf("\n");
            printf("       It is also possible to use one of the defualt materials avaiable: \n");
            printf("           Vacuum (for a Volume without scattering or absorption)\n");
            printf("           Exit (for a Volume where the ray exits the component if it enters)\n");
            printf("           Mask (for a Volume that masks existing volumes specified in the mask_string\n");
            exit(1);
          }
        }
    }
} else {
    // Automatic linking, simply using the last defined material.
    #ifndef MATERIAL_DETECTOR
        printf("Need to define a material before the geometry to use automatic linking %s.\n",NAME_CURRENT_COMP);
        exit(1);
    #endif
    this_box_volume.p_physics = global_material_list.elements[global_material_list.num_elements-1].physics;
}

sprintf(this_box_volume.name,NAME_CURRENT_COMP);
sprintf(this_box_volume.geometry.shape,"box");
this_box_volume.geometry.priority_value = priority;
this_box_volume.geometry.geometry_p_interact = p_interact;
// Currently the coordinates will be in absolute space.
this_box_volume.geometry.center = POS_A_CURRENT_COMP;

this_box_storage.z_depth = zdepth;
this_box_storage.x_width1 = xwidth;
this_box_storage.y_height1 = yheight;

this_box_storage.is_rectangle = 0;
if (xwidth2 < 0 && yheight2 < 0) this_box_storage.is_rectangle = 1;
if (xwidth == xwidth2 && yheight == yheight2) this_box_storage.is_rectangle = 1;

if (xwidth2 < 0) {
    this_box_storage.x_width2 = xwidth;
    xwidth2 = xwidth;
} else this_box_storage.x_width2 = xwidth2;

if (yheight2 < 0) {
    this_box_storage.y_height2 = yheight;
    yheight2 = yheight;
} else this_box_storage.y_height2 = yheight2;


this_box_storage.normal_vectors[0] = coords_set(0,0,1);
this_box_storage.normal_vectors[1] = coords_set(0,0,1);

// for sides with y component = 0
x_component = 2*zdepth/sqrt((xwidth-xwidth2)*(xwidth-xwidth2)+4*zdepth*zdepth);
z_component = (xwidth-xwidth2)/sqrt(4*zdepth*zdepth+(xwidth-xwidth2)*(xwidth-xwidth2));

this_box_storage.normal_vectors[2] = coords_set(x_component,0,z_component);
this_box_storage.normal_vectors[3] = coords_set(-x_component,0,z_component);

// for sides with x component = 0
y_component = 2*zdepth/sqrt((yheight-yheight2)*(yheight-yheight2)+4*zdepth*zdepth);
z_component = (yheight-yheight2)/sqrt(4*zdepth*zdepth+(yheight-yheight2)*(yheight-yheight2));

this_box_storage.normal_vectors[4] = coords_set(0,y_component,z_component);
this_box_storage.normal_vectors[5] = coords_set(0,-y_component,z_component);

this_box_volume.geometry.visualization_on = visualize;

this_box_volume.geometry.geometry_parameters.p_box_storage = &this_box_storage;

// Assign pointers to functions for intersection with the shape, checking if a point is inside the shape
if (this_box_storage.is_rectangle == 1) {
this_box_volume.geometry.intersect_function = &sample_box_intersect_simple;
this_box_volume.geometry.within_function = &r_within_box_simple;
}
else {
this_box_volume.geometry.intersect_function = &sample_box_intersect_advanced;
this_box_volume.geometry.within_function = &r_within_box_advanced;
}

this_box_volume.geometry.shell_points = &box_shell_points;
this_box_volume.geometry.mcdisplay_function = &mcdisplay_box_function;
this_box_volume.geometry.initialize_from_main_function = &initialize_box_geometry_from_main_component;
this_box_volume.geometry.process_rot_allocated = 0;

this_box_volume.geometry.copy_geometry_parameters = &allocate_box_storage_copy;

rot_copy(this_box_volume.geometry.rotation_matrix,ROT_A_CURRENT_COMP); //check how ROT_R_CURRENT_COMP would work
rot_transpose(ROT_A_CURRENT_COMP,this_box_volume.geometry.transpose_rotation_matrix);

// Initialize loggers
this_box_volume.loggers.num_elements = 0;

// packing the information into the global_geometry_element, which is then included in the global_geometry_list.
sprintf(global_geometry_element.name,NAME_CURRENT_COMP);
global_geometry_element.activation_counter = number_of_activations;
global_geometry_element.component_index = INDEX_CURRENT_COMP;
global_geometry_element.Volume = &this_box_volume; // Would be nicer if this m was a pointer, now we have the (small) data two places
add_element_to_geometry_list(&global_geometry_list,global_geometry_element);
}
#line 233882 "MACS_sample_kidney_box.c"
#undef number_of_activations
#undef mask_setting
#undef mask_string
#undef p_interact
#undef focus_r
#undef focus_xh
#undef focus_xw
#undef focus_ah
#undef focus_aw
#undef target_z
#undef target_y
#undef target_x
#undef target_index
#undef visualize
#undef yheight2
#undef xwidth2
#undef zdepth
#undef yheight
#undef xwidth
#undef priority
#undef material_string
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

  /* Initializations for component inter_analyzer_colimator_7_blade_3. */
  SIG_MESSAGE("inter_analyzer_colimator_7_blade_3 (Init)");
#define mccompcurname  inter_analyzer_colimator_7_blade_3
#define mccompcurtype  Union_box
#define mccompcurindex 424
#define loop_index mccinter_analyzer_colimator_7_blade_3_loop_index
#define this_box_volume mccinter_analyzer_colimator_7_blade_3_this_box_volume
#define global_geometry_element mccinter_analyzer_colimator_7_blade_3_global_geometry_element
#define this_box_storage mccinter_analyzer_colimator_7_blade_3_this_box_storage
#define material_string mccinter_analyzer_colimator_7_blade_3_material_string
#define priority mccinter_analyzer_colimator_7_blade_3_priority
#define xwidth mccinter_analyzer_colimator_7_blade_3_xwidth
#define yheight mccinter_analyzer_colimator_7_blade_3_yheight
#define zdepth mccinter_analyzer_colimator_7_blade_3_zdepth
#define xwidth2 mccinter_analyzer_colimator_7_blade_3_xwidth2
#define yheight2 mccinter_analyzer_colimator_7_blade_3_yheight2
#define visualize mccinter_analyzer_colimator_7_blade_3_visualize
#define target_index mccinter_analyzer_colimator_7_blade_3_target_index
#define target_x mccinter_analyzer_colimator_7_blade_3_target_x
#define target_y mccinter_analyzer_colimator_7_blade_3_target_y
#define target_z mccinter_analyzer_colimator_7_blade_3_target_z
#define focus_aw mccinter_analyzer_colimator_7_blade_3_focus_aw
#define focus_ah mccinter_analyzer_colimator_7_blade_3_focus_ah
#define focus_xw mccinter_analyzer_colimator_7_blade_3_focus_xw
#define focus_xh mccinter_analyzer_colimator_7_blade_3_focus_xh
#define focus_r mccinter_analyzer_colimator_7_blade_3_focus_r
#define p_interact mccinter_analyzer_colimator_7_blade_3_p_interact
#define mask_string mccinter_analyzer_colimator_7_blade_3_mask_string
#define mask_setting mccinter_analyzer_colimator_7_blade_3_mask_setting
#define number_of_activations mccinter_analyzer_colimator_7_blade_3_number_of_activations
#line 224 "Union_box.comp"
{
// Initializes the focusing system for this volume including input sanitation.
focus_initialize(&this_box_volume.geometry, POS_A_COMP_INDEX(INDEX_CURRENT_COMP+target_index), POS_A_CURRENT_COMP, ROT_A_CURRENT_COMP, target_index, target_x, target_y, target_z, focus_aw, focus_ah, focus_xw, focus_xh, focus_r, NAME_CURRENT_COMP);

// Input sanitation for this geometry
if (xwidth <= 0) {
  printf("\nERROR in Union_box named %s, the xwidth is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (yheight <= 0) {
  printf("\nERROR in Union_box named %s, yheight is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (zdepth <= 0) {
  printf("\nERROR in Union_box named %s, zdepth is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (xwidth2 <= 0 && xwidth2 != -1) {
  printf("\nERROR in Union_box named %s, the xwidth2 is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (yheight2 <= 0 && yheight2 != -1) {
  printf("\nERROR in Union_box named %s, yheight2 is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}

// Use sanitation
if (global_material_list.num_elements == 0) {
  printf("\nERROR: Need to define a material using Union_make_material before using a Union geometry component. \n");
  printf("       %s was defined before first use of Union_make_material.\n",NAME_CURRENT_COMP);
  exit(1);
}

this_box_volume.geometry.is_masked_volume = 0;
this_box_volume.geometry.is_exit_volume = 0;
this_box_volume.geometry.is_mask_volume = 0;
// check if the volume is a mask, if it is the material string is irelevant.
if (mask_string && strlen(mask_string) && strcmp(mask_string, "NULL") && strcmp(mask_string, "0")) {
    // A mask volume is used to limit the extend of other volumes, called the masked volumes. These are specified in the mask_string.
    // In order for a ray to enter a masked volume, it needs to be both in the region covered by that volume AND the mask volume.
    // When more than
    this_box_volume.geometry.mask_mode = 1; // Default is mask mode is ALL
    if (mask_setting && strlen(mask_setting) && strcmp(mask_setting, "NULL") && strcmp(mask_setting, "0")) {
        if (strcmp(mask_setting,"ALL") == 0 || strcmp(mask_setting,"All") == 0) this_box_volume.geometry.mask_mode = 1;
        else if (strcmp(mask_setting,"ANY") == 0 || strcmp(mask_setting,"Any") == 0) this_box_volume.geometry.mask_mode = 2;
        else {
            printf("The mask_mode of component %s is set to %s, but must be either ALL or ANY.\n",NAME_CURRENT_COMP,mask_setting);
            exit(1);
        }
    }
    
    for (loop_index=0;loop_index<global_geometry_list.num_elements;loop_index++) {
        // Add mask list
        if (1 == manual_linking_function(global_geometry_list.elements[loop_index].name,mask_string)) {
            add_element_to_int_list(&this_box_volume.geometry.mask_list,global_geometry_list.elements[loop_index].component_index);
            add_element_to_int_list(&global_geometry_list.elements[loop_index].Volume->geometry.masked_by_list,INDEX_CURRENT_COMP);
            global_geometry_list.elements[loop_index].Volume->geometry.is_masked_volume = 1;
            if (this_box_volume.geometry.mask_mode == 2)
                global_geometry_list.elements[loop_index].Volume->geometry.mask_mode = 2;
            if (this_box_volume.geometry.mask_mode == 1) {
                if (global_geometry_list.elements[loop_index].Volume->geometry.is_masked_volume == 1 && global_geometry_list.elements[loop_index].Volume->geometry.mask_mode != 2)
                    // If more than one mask is added to one volume, the ANY mode overwrites the (default) ALL mode.
                    global_geometry_list.elements[loop_index].Volume->geometry.mask_mode = 1;
            }
            
            found_geometries = 1;
        }
    }
    if (found_geometries == 0) {
        printf("The mask_string in geometry: %s did not find any of the specified volumes in the mask_string %s \n",NAME_CURRENT_COMP,mask_string);
        exit(1);
    }
    this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
    this_box_volume.p_physics->is_vacuum = 0; // Makes this volume a vacuum
    this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
    this_box_volume.p_physics->my_a = 0; // Should not be used.
    sprintf(this_box_volume.p_physics->name,"Mask");
    this_box_volume.geometry.is_mask_volume = 1;
    
    
// Read the material input, or if it lacks, use automatic linking.
} else if (material_string && strlen(material_string) && strcmp(material_string, "NULL") && strcmp(material_string, "0")) {
    // A geometry string was given, use it to determine which material
    if (0 == strcmp(material_string,"vacuum") || 0 == strcmp(material_string,"Vacuum")) {
        // One could have a global physics struct for vacuum instead of creating one for each
        this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
        this_box_volume.p_physics->is_vacuum = 1; // Makes this volume a vacuum
        this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
        this_box_volume.p_physics->my_a = 0; // Should not be used.
        sprintf(this_box_volume.p_physics->name,"Vacuum");
    } else if (0 == strcmp(material_string,"exit") || 0 == strcmp(material_string,"Exit")) {
        // One could have a global physics struct for vacuum instead of creating one for each
        this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
        this_box_volume.p_physics->is_vacuum = 1; // Makes this volume a vacuum
        this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
        this_box_volume.p_physics->my_a = 0; // Should not be used.
        this_box_volume.geometry.is_exit_volume = 1;
        sprintf(this_box_volume.p_physics->name,"Exit");
    } else {
        #ifndef MATERIAL_DETECTOR
            printf("Need to define a material before refering to it in a geometry %s.\n",NAME_CURRENT_COMP);
            exit(1);
        #endif
        for (loop_index=0;loop_index<global_material_list.num_elements;loop_index++) {
            if (0 == strcmp(material_string,global_material_list.elements[loop_index].name)) {
                this_box_volume.p_physics = global_material_list.elements[loop_index].physics;
                break;
            }
            if (loop_index == global_material_list.num_elements-1) {
            printf("\n");
            printf("ERROR: The material string \"%s\" in Union geometry \"%s\" did not match a specified material. \n",material_string,NAME_CURRENT_COMP);
            printf("       The materials available at this point (need to be defined before the geometry): \n");
            for (loop_index=0;loop_index<global_material_list.num_elements;loop_index++)
              printf("         %s\n",global_material_list.elements[loop_index].name);
            printf("\n");
            printf("       It is also possible to use one of the defualt materials avaiable: \n");
            printf("           Vacuum (for a Volume without scattering or absorption)\n");
            printf("           Exit (for a Volume where the ray exits the component if it enters)\n");
            printf("           Mask (for a Volume that masks existing volumes specified in the mask_string\n");
            exit(1);
          }
        }
    }
} else {
    // Automatic linking, simply using the last defined material.
    #ifndef MATERIAL_DETECTOR
        printf("Need to define a material before the geometry to use automatic linking %s.\n",NAME_CURRENT_COMP);
        exit(1);
    #endif
    this_box_volume.p_physics = global_material_list.elements[global_material_list.num_elements-1].physics;
}

sprintf(this_box_volume.name,NAME_CURRENT_COMP);
sprintf(this_box_volume.geometry.shape,"box");
this_box_volume.geometry.priority_value = priority;
this_box_volume.geometry.geometry_p_interact = p_interact;
// Currently the coordinates will be in absolute space.
this_box_volume.geometry.center = POS_A_CURRENT_COMP;

this_box_storage.z_depth = zdepth;
this_box_storage.x_width1 = xwidth;
this_box_storage.y_height1 = yheight;

this_box_storage.is_rectangle = 0;
if (xwidth2 < 0 && yheight2 < 0) this_box_storage.is_rectangle = 1;
if (xwidth == xwidth2 && yheight == yheight2) this_box_storage.is_rectangle = 1;

if (xwidth2 < 0) {
    this_box_storage.x_width2 = xwidth;
    xwidth2 = xwidth;
} else this_box_storage.x_width2 = xwidth2;

if (yheight2 < 0) {
    this_box_storage.y_height2 = yheight;
    yheight2 = yheight;
} else this_box_storage.y_height2 = yheight2;


this_box_storage.normal_vectors[0] = coords_set(0,0,1);
this_box_storage.normal_vectors[1] = coords_set(0,0,1);

// for sides with y component = 0
x_component = 2*zdepth/sqrt((xwidth-xwidth2)*(xwidth-xwidth2)+4*zdepth*zdepth);
z_component = (xwidth-xwidth2)/sqrt(4*zdepth*zdepth+(xwidth-xwidth2)*(xwidth-xwidth2));

this_box_storage.normal_vectors[2] = coords_set(x_component,0,z_component);
this_box_storage.normal_vectors[3] = coords_set(-x_component,0,z_component);

// for sides with x component = 0
y_component = 2*zdepth/sqrt((yheight-yheight2)*(yheight-yheight2)+4*zdepth*zdepth);
z_component = (yheight-yheight2)/sqrt(4*zdepth*zdepth+(yheight-yheight2)*(yheight-yheight2));

this_box_storage.normal_vectors[4] = coords_set(0,y_component,z_component);
this_box_storage.normal_vectors[5] = coords_set(0,-y_component,z_component);

this_box_volume.geometry.visualization_on = visualize;

this_box_volume.geometry.geometry_parameters.p_box_storage = &this_box_storage;

// Assign pointers to functions for intersection with the shape, checking if a point is inside the shape
if (this_box_storage.is_rectangle == 1) {
this_box_volume.geometry.intersect_function = &sample_box_intersect_simple;
this_box_volume.geometry.within_function = &r_within_box_simple;
}
else {
this_box_volume.geometry.intersect_function = &sample_box_intersect_advanced;
this_box_volume.geometry.within_function = &r_within_box_advanced;
}

this_box_volume.geometry.shell_points = &box_shell_points;
this_box_volume.geometry.mcdisplay_function = &mcdisplay_box_function;
this_box_volume.geometry.initialize_from_main_function = &initialize_box_geometry_from_main_component;
this_box_volume.geometry.process_rot_allocated = 0;

this_box_volume.geometry.copy_geometry_parameters = &allocate_box_storage_copy;

rot_copy(this_box_volume.geometry.rotation_matrix,ROT_A_CURRENT_COMP); //check how ROT_R_CURRENT_COMP would work
rot_transpose(ROT_A_CURRENT_COMP,this_box_volume.geometry.transpose_rotation_matrix);

// Initialize loggers
this_box_volume.loggers.num_elements = 0;

// packing the information into the global_geometry_element, which is then included in the global_geometry_list.
sprintf(global_geometry_element.name,NAME_CURRENT_COMP);
global_geometry_element.activation_counter = number_of_activations;
global_geometry_element.component_index = INDEX_CURRENT_COMP;
global_geometry_element.Volume = &this_box_volume; // Would be nicer if this m was a pointer, now we have the (small) data two places
add_element_to_geometry_list(&global_geometry_list,global_geometry_element);
}
#line 234152 "MACS_sample_kidney_box.c"
#undef number_of_activations
#undef mask_setting
#undef mask_string
#undef p_interact
#undef focus_r
#undef focus_xh
#undef focus_xw
#undef focus_ah
#undef focus_aw
#undef target_z
#undef target_y
#undef target_x
#undef target_index
#undef visualize
#undef yheight2
#undef xwidth2
#undef zdepth
#undef yheight
#undef xwidth
#undef priority
#undef material_string
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

  /* Initializations for component inter_analyzer_colimator_7_blade_4. */
  SIG_MESSAGE("inter_analyzer_colimator_7_blade_4 (Init)");
#define mccompcurname  inter_analyzer_colimator_7_blade_4
#define mccompcurtype  Union_box
#define mccompcurindex 425
#define loop_index mccinter_analyzer_colimator_7_blade_4_loop_index
#define this_box_volume mccinter_analyzer_colimator_7_blade_4_this_box_volume
#define global_geometry_element mccinter_analyzer_colimator_7_blade_4_global_geometry_element
#define this_box_storage mccinter_analyzer_colimator_7_blade_4_this_box_storage
#define material_string mccinter_analyzer_colimator_7_blade_4_material_string
#define priority mccinter_analyzer_colimator_7_blade_4_priority
#define xwidth mccinter_analyzer_colimator_7_blade_4_xwidth
#define yheight mccinter_analyzer_colimator_7_blade_4_yheight
#define zdepth mccinter_analyzer_colimator_7_blade_4_zdepth
#define xwidth2 mccinter_analyzer_colimator_7_blade_4_xwidth2
#define yheight2 mccinter_analyzer_colimator_7_blade_4_yheight2
#define visualize mccinter_analyzer_colimator_7_blade_4_visualize
#define target_index mccinter_analyzer_colimator_7_blade_4_target_index
#define target_x mccinter_analyzer_colimator_7_blade_4_target_x
#define target_y mccinter_analyzer_colimator_7_blade_4_target_y
#define target_z mccinter_analyzer_colimator_7_blade_4_target_z
#define focus_aw mccinter_analyzer_colimator_7_blade_4_focus_aw
#define focus_ah mccinter_analyzer_colimator_7_blade_4_focus_ah
#define focus_xw mccinter_analyzer_colimator_7_blade_4_focus_xw
#define focus_xh mccinter_analyzer_colimator_7_blade_4_focus_xh
#define focus_r mccinter_analyzer_colimator_7_blade_4_focus_r
#define p_interact mccinter_analyzer_colimator_7_blade_4_p_interact
#define mask_string mccinter_analyzer_colimator_7_blade_4_mask_string
#define mask_setting mccinter_analyzer_colimator_7_blade_4_mask_setting
#define number_of_activations mccinter_analyzer_colimator_7_blade_4_number_of_activations
#line 224 "Union_box.comp"
{
// Initializes the focusing system for this volume including input sanitation.
focus_initialize(&this_box_volume.geometry, POS_A_COMP_INDEX(INDEX_CURRENT_COMP+target_index), POS_A_CURRENT_COMP, ROT_A_CURRENT_COMP, target_index, target_x, target_y, target_z, focus_aw, focus_ah, focus_xw, focus_xh, focus_r, NAME_CURRENT_COMP);

// Input sanitation for this geometry
if (xwidth <= 0) {
  printf("\nERROR in Union_box named %s, the xwidth is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (yheight <= 0) {
  printf("\nERROR in Union_box named %s, yheight is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (zdepth <= 0) {
  printf("\nERROR in Union_box named %s, zdepth is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (xwidth2 <= 0 && xwidth2 != -1) {
  printf("\nERROR in Union_box named %s, the xwidth2 is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (yheight2 <= 0 && yheight2 != -1) {
  printf("\nERROR in Union_box named %s, yheight2 is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}

// Use sanitation
if (global_material_list.num_elements == 0) {
  printf("\nERROR: Need to define a material using Union_make_material before using a Union geometry component. \n");
  printf("       %s was defined before first use of Union_make_material.\n",NAME_CURRENT_COMP);
  exit(1);
}

this_box_volume.geometry.is_masked_volume = 0;
this_box_volume.geometry.is_exit_volume = 0;
this_box_volume.geometry.is_mask_volume = 0;
// check if the volume is a mask, if it is the material string is irelevant.
if (mask_string && strlen(mask_string) && strcmp(mask_string, "NULL") && strcmp(mask_string, "0")) {
    // A mask volume is used to limit the extend of other volumes, called the masked volumes. These are specified in the mask_string.
    // In order for a ray to enter a masked volume, it needs to be both in the region covered by that volume AND the mask volume.
    // When more than
    this_box_volume.geometry.mask_mode = 1; // Default is mask mode is ALL
    if (mask_setting && strlen(mask_setting) && strcmp(mask_setting, "NULL") && strcmp(mask_setting, "0")) {
        if (strcmp(mask_setting,"ALL") == 0 || strcmp(mask_setting,"All") == 0) this_box_volume.geometry.mask_mode = 1;
        else if (strcmp(mask_setting,"ANY") == 0 || strcmp(mask_setting,"Any") == 0) this_box_volume.geometry.mask_mode = 2;
        else {
            printf("The mask_mode of component %s is set to %s, but must be either ALL or ANY.\n",NAME_CURRENT_COMP,mask_setting);
            exit(1);
        }
    }
    
    for (loop_index=0;loop_index<global_geometry_list.num_elements;loop_index++) {
        // Add mask list
        if (1 == manual_linking_function(global_geometry_list.elements[loop_index].name,mask_string)) {
            add_element_to_int_list(&this_box_volume.geometry.mask_list,global_geometry_list.elements[loop_index].component_index);
            add_element_to_int_list(&global_geometry_list.elements[loop_index].Volume->geometry.masked_by_list,INDEX_CURRENT_COMP);
            global_geometry_list.elements[loop_index].Volume->geometry.is_masked_volume = 1;
            if (this_box_volume.geometry.mask_mode == 2)
                global_geometry_list.elements[loop_index].Volume->geometry.mask_mode = 2;
            if (this_box_volume.geometry.mask_mode == 1) {
                if (global_geometry_list.elements[loop_index].Volume->geometry.is_masked_volume == 1 && global_geometry_list.elements[loop_index].Volume->geometry.mask_mode != 2)
                    // If more than one mask is added to one volume, the ANY mode overwrites the (default) ALL mode.
                    global_geometry_list.elements[loop_index].Volume->geometry.mask_mode = 1;
            }
            
            found_geometries = 1;
        }
    }
    if (found_geometries == 0) {
        printf("The mask_string in geometry: %s did not find any of the specified volumes in the mask_string %s \n",NAME_CURRENT_COMP,mask_string);
        exit(1);
    }
    this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
    this_box_volume.p_physics->is_vacuum = 0; // Makes this volume a vacuum
    this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
    this_box_volume.p_physics->my_a = 0; // Should not be used.
    sprintf(this_box_volume.p_physics->name,"Mask");
    this_box_volume.geometry.is_mask_volume = 1;
    
    
// Read the material input, or if it lacks, use automatic linking.
} else if (material_string && strlen(material_string) && strcmp(material_string, "NULL") && strcmp(material_string, "0")) {
    // A geometry string was given, use it to determine which material
    if (0 == strcmp(material_string,"vacuum") || 0 == strcmp(material_string,"Vacuum")) {
        // One could have a global physics struct for vacuum instead of creating one for each
        this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
        this_box_volume.p_physics->is_vacuum = 1; // Makes this volume a vacuum
        this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
        this_box_volume.p_physics->my_a = 0; // Should not be used.
        sprintf(this_box_volume.p_physics->name,"Vacuum");
    } else if (0 == strcmp(material_string,"exit") || 0 == strcmp(material_string,"Exit")) {
        // One could have a global physics struct for vacuum instead of creating one for each
        this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
        this_box_volume.p_physics->is_vacuum = 1; // Makes this volume a vacuum
        this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
        this_box_volume.p_physics->my_a = 0; // Should not be used.
        this_box_volume.geometry.is_exit_volume = 1;
        sprintf(this_box_volume.p_physics->name,"Exit");
    } else {
        #ifndef MATERIAL_DETECTOR
            printf("Need to define a material before refering to it in a geometry %s.\n",NAME_CURRENT_COMP);
            exit(1);
        #endif
        for (loop_index=0;loop_index<global_material_list.num_elements;loop_index++) {
            if (0 == strcmp(material_string,global_material_list.elements[loop_index].name)) {
                this_box_volume.p_physics = global_material_list.elements[loop_index].physics;
                break;
            }
            if (loop_index == global_material_list.num_elements-1) {
            printf("\n");
            printf("ERROR: The material string \"%s\" in Union geometry \"%s\" did not match a specified material. \n",material_string,NAME_CURRENT_COMP);
            printf("       The materials available at this point (need to be defined before the geometry): \n");
            for (loop_index=0;loop_index<global_material_list.num_elements;loop_index++)
              printf("         %s\n",global_material_list.elements[loop_index].name);
            printf("\n");
            printf("       It is also possible to use one of the defualt materials avaiable: \n");
            printf("           Vacuum (for a Volume without scattering or absorption)\n");
            printf("           Exit (for a Volume where the ray exits the component if it enters)\n");
            printf("           Mask (for a Volume that masks existing volumes specified in the mask_string\n");
            exit(1);
          }
        }
    }
} else {
    // Automatic linking, simply using the last defined material.
    #ifndef MATERIAL_DETECTOR
        printf("Need to define a material before the geometry to use automatic linking %s.\n",NAME_CURRENT_COMP);
        exit(1);
    #endif
    this_box_volume.p_physics = global_material_list.elements[global_material_list.num_elements-1].physics;
}

sprintf(this_box_volume.name,NAME_CURRENT_COMP);
sprintf(this_box_volume.geometry.shape,"box");
this_box_volume.geometry.priority_value = priority;
this_box_volume.geometry.geometry_p_interact = p_interact;
// Currently the coordinates will be in absolute space.
this_box_volume.geometry.center = POS_A_CURRENT_COMP;

this_box_storage.z_depth = zdepth;
this_box_storage.x_width1 = xwidth;
this_box_storage.y_height1 = yheight;

this_box_storage.is_rectangle = 0;
if (xwidth2 < 0 && yheight2 < 0) this_box_storage.is_rectangle = 1;
if (xwidth == xwidth2 && yheight == yheight2) this_box_storage.is_rectangle = 1;

if (xwidth2 < 0) {
    this_box_storage.x_width2 = xwidth;
    xwidth2 = xwidth;
} else this_box_storage.x_width2 = xwidth2;

if (yheight2 < 0) {
    this_box_storage.y_height2 = yheight;
    yheight2 = yheight;
} else this_box_storage.y_height2 = yheight2;


this_box_storage.normal_vectors[0] = coords_set(0,0,1);
this_box_storage.normal_vectors[1] = coords_set(0,0,1);

// for sides with y component = 0
x_component = 2*zdepth/sqrt((xwidth-xwidth2)*(xwidth-xwidth2)+4*zdepth*zdepth);
z_component = (xwidth-xwidth2)/sqrt(4*zdepth*zdepth+(xwidth-xwidth2)*(xwidth-xwidth2));

this_box_storage.normal_vectors[2] = coords_set(x_component,0,z_component);
this_box_storage.normal_vectors[3] = coords_set(-x_component,0,z_component);

// for sides with x component = 0
y_component = 2*zdepth/sqrt((yheight-yheight2)*(yheight-yheight2)+4*zdepth*zdepth);
z_component = (yheight-yheight2)/sqrt(4*zdepth*zdepth+(yheight-yheight2)*(yheight-yheight2));

this_box_storage.normal_vectors[4] = coords_set(0,y_component,z_component);
this_box_storage.normal_vectors[5] = coords_set(0,-y_component,z_component);

this_box_volume.geometry.visualization_on = visualize;

this_box_volume.geometry.geometry_parameters.p_box_storage = &this_box_storage;

// Assign pointers to functions for intersection with the shape, checking if a point is inside the shape
if (this_box_storage.is_rectangle == 1) {
this_box_volume.geometry.intersect_function = &sample_box_intersect_simple;
this_box_volume.geometry.within_function = &r_within_box_simple;
}
else {
this_box_volume.geometry.intersect_function = &sample_box_intersect_advanced;
this_box_volume.geometry.within_function = &r_within_box_advanced;
}

this_box_volume.geometry.shell_points = &box_shell_points;
this_box_volume.geometry.mcdisplay_function = &mcdisplay_box_function;
this_box_volume.geometry.initialize_from_main_function = &initialize_box_geometry_from_main_component;
this_box_volume.geometry.process_rot_allocated = 0;

this_box_volume.geometry.copy_geometry_parameters = &allocate_box_storage_copy;

rot_copy(this_box_volume.geometry.rotation_matrix,ROT_A_CURRENT_COMP); //check how ROT_R_CURRENT_COMP would work
rot_transpose(ROT_A_CURRENT_COMP,this_box_volume.geometry.transpose_rotation_matrix);

// Initialize loggers
this_box_volume.loggers.num_elements = 0;

// packing the information into the global_geometry_element, which is then included in the global_geometry_list.
sprintf(global_geometry_element.name,NAME_CURRENT_COMP);
global_geometry_element.activation_counter = number_of_activations;
global_geometry_element.component_index = INDEX_CURRENT_COMP;
global_geometry_element.Volume = &this_box_volume; // Would be nicer if this m was a pointer, now we have the (small) data two places
add_element_to_geometry_list(&global_geometry_list,global_geometry_element);
}
#line 234422 "MACS_sample_kidney_box.c"
#undef number_of_activations
#undef mask_setting
#undef mask_string
#undef p_interact
#undef focus_r
#undef focus_xh
#undef focus_xw
#undef focus_ah
#undef focus_aw
#undef target_z
#undef target_y
#undef target_x
#undef target_index
#undef visualize
#undef yheight2
#undef xwidth2
#undef zdepth
#undef yheight
#undef xwidth
#undef priority
#undef material_string
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

  /* Initializations for component diffraction_detector_7_exit_volume. */
  SIG_MESSAGE("diffraction_detector_7_exit_volume (Init)");
#define mccompcurname  diffraction_detector_7_exit_volume
#define mccompcurtype  Union_box
#define mccompcurindex 426
#define loop_index mccdiffraction_detector_7_exit_volume_loop_index
#define this_box_volume mccdiffraction_detector_7_exit_volume_this_box_volume
#define global_geometry_element mccdiffraction_detector_7_exit_volume_global_geometry_element
#define this_box_storage mccdiffraction_detector_7_exit_volume_this_box_storage
#define material_string mccdiffraction_detector_7_exit_volume_material_string
#define priority mccdiffraction_detector_7_exit_volume_priority
#define xwidth mccdiffraction_detector_7_exit_volume_xwidth
#define yheight mccdiffraction_detector_7_exit_volume_yheight
#define zdepth mccdiffraction_detector_7_exit_volume_zdepth
#define xwidth2 mccdiffraction_detector_7_exit_volume_xwidth2
#define yheight2 mccdiffraction_detector_7_exit_volume_yheight2
#define visualize mccdiffraction_detector_7_exit_volume_visualize
#define target_index mccdiffraction_detector_7_exit_volume_target_index
#define target_x mccdiffraction_detector_7_exit_volume_target_x
#define target_y mccdiffraction_detector_7_exit_volume_target_y
#define target_z mccdiffraction_detector_7_exit_volume_target_z
#define focus_aw mccdiffraction_detector_7_exit_volume_focus_aw
#define focus_ah mccdiffraction_detector_7_exit_volume_focus_ah
#define focus_xw mccdiffraction_detector_7_exit_volume_focus_xw
#define focus_xh mccdiffraction_detector_7_exit_volume_focus_xh
#define focus_r mccdiffraction_detector_7_exit_volume_focus_r
#define p_interact mccdiffraction_detector_7_exit_volume_p_interact
#define mask_string mccdiffraction_detector_7_exit_volume_mask_string
#define mask_setting mccdiffraction_detector_7_exit_volume_mask_setting
#define number_of_activations mccdiffraction_detector_7_exit_volume_number_of_activations
#line 224 "Union_box.comp"
{
// Initializes the focusing system for this volume including input sanitation.
focus_initialize(&this_box_volume.geometry, POS_A_COMP_INDEX(INDEX_CURRENT_COMP+target_index), POS_A_CURRENT_COMP, ROT_A_CURRENT_COMP, target_index, target_x, target_y, target_z, focus_aw, focus_ah, focus_xw, focus_xh, focus_r, NAME_CURRENT_COMP);

// Input sanitation for this geometry
if (xwidth <= 0) {
  printf("\nERROR in Union_box named %s, the xwidth is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (yheight <= 0) {
  printf("\nERROR in Union_box named %s, yheight is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (zdepth <= 0) {
  printf("\nERROR in Union_box named %s, zdepth is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (xwidth2 <= 0 && xwidth2 != -1) {
  printf("\nERROR in Union_box named %s, the xwidth2 is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (yheight2 <= 0 && yheight2 != -1) {
  printf("\nERROR in Union_box named %s, yheight2 is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}

// Use sanitation
if (global_material_list.num_elements == 0) {
  printf("\nERROR: Need to define a material using Union_make_material before using a Union geometry component. \n");
  printf("       %s was defined before first use of Union_make_material.\n",NAME_CURRENT_COMP);
  exit(1);
}

this_box_volume.geometry.is_masked_volume = 0;
this_box_volume.geometry.is_exit_volume = 0;
this_box_volume.geometry.is_mask_volume = 0;
// check if the volume is a mask, if it is the material string is irelevant.
if (mask_string && strlen(mask_string) && strcmp(mask_string, "NULL") && strcmp(mask_string, "0")) {
    // A mask volume is used to limit the extend of other volumes, called the masked volumes. These are specified in the mask_string.
    // In order for a ray to enter a masked volume, it needs to be both in the region covered by that volume AND the mask volume.
    // When more than
    this_box_volume.geometry.mask_mode = 1; // Default is mask mode is ALL
    if (mask_setting && strlen(mask_setting) && strcmp(mask_setting, "NULL") && strcmp(mask_setting, "0")) {
        if (strcmp(mask_setting,"ALL") == 0 || strcmp(mask_setting,"All") == 0) this_box_volume.geometry.mask_mode = 1;
        else if (strcmp(mask_setting,"ANY") == 0 || strcmp(mask_setting,"Any") == 0) this_box_volume.geometry.mask_mode = 2;
        else {
            printf("The mask_mode of component %s is set to %s, but must be either ALL or ANY.\n",NAME_CURRENT_COMP,mask_setting);
            exit(1);
        }
    }
    
    for (loop_index=0;loop_index<global_geometry_list.num_elements;loop_index++) {
        // Add mask list
        if (1 == manual_linking_function(global_geometry_list.elements[loop_index].name,mask_string)) {
            add_element_to_int_list(&this_box_volume.geometry.mask_list,global_geometry_list.elements[loop_index].component_index);
            add_element_to_int_list(&global_geometry_list.elements[loop_index].Volume->geometry.masked_by_list,INDEX_CURRENT_COMP);
            global_geometry_list.elements[loop_index].Volume->geometry.is_masked_volume = 1;
            if (this_box_volume.geometry.mask_mode == 2)
                global_geometry_list.elements[loop_index].Volume->geometry.mask_mode = 2;
            if (this_box_volume.geometry.mask_mode == 1) {
                if (global_geometry_list.elements[loop_index].Volume->geometry.is_masked_volume == 1 && global_geometry_list.elements[loop_index].Volume->geometry.mask_mode != 2)
                    // If more than one mask is added to one volume, the ANY mode overwrites the (default) ALL mode.
                    global_geometry_list.elements[loop_index].Volume->geometry.mask_mode = 1;
            }
            
            found_geometries = 1;
        }
    }
    if (found_geometries == 0) {
        printf("The mask_string in geometry: %s did not find any of the specified volumes in the mask_string %s \n",NAME_CURRENT_COMP,mask_string);
        exit(1);
    }
    this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
    this_box_volume.p_physics->is_vacuum = 0; // Makes this volume a vacuum
    this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
    this_box_volume.p_physics->my_a = 0; // Should not be used.
    sprintf(this_box_volume.p_physics->name,"Mask");
    this_box_volume.geometry.is_mask_volume = 1;
    
    
// Read the material input, or if it lacks, use automatic linking.
} else if (material_string && strlen(material_string) && strcmp(material_string, "NULL") && strcmp(material_string, "0")) {
    // A geometry string was given, use it to determine which material
    if (0 == strcmp(material_string,"vacuum") || 0 == strcmp(material_string,"Vacuum")) {
        // One could have a global physics struct for vacuum instead of creating one for each
        this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
        this_box_volume.p_physics->is_vacuum = 1; // Makes this volume a vacuum
        this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
        this_box_volume.p_physics->my_a = 0; // Should not be used.
        sprintf(this_box_volume.p_physics->name,"Vacuum");
    } else if (0 == strcmp(material_string,"exit") || 0 == strcmp(material_string,"Exit")) {
        // One could have a global physics struct for vacuum instead of creating one for each
        this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
        this_box_volume.p_physics->is_vacuum = 1; // Makes this volume a vacuum
        this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
        this_box_volume.p_physics->my_a = 0; // Should not be used.
        this_box_volume.geometry.is_exit_volume = 1;
        sprintf(this_box_volume.p_physics->name,"Exit");
    } else {
        #ifndef MATERIAL_DETECTOR
            printf("Need to define a material before refering to it in a geometry %s.\n",NAME_CURRENT_COMP);
            exit(1);
        #endif
        for (loop_index=0;loop_index<global_material_list.num_elements;loop_index++) {
            if (0 == strcmp(material_string,global_material_list.elements[loop_index].name)) {
                this_box_volume.p_physics = global_material_list.elements[loop_index].physics;
                break;
            }
            if (loop_index == global_material_list.num_elements-1) {
            printf("\n");
            printf("ERROR: The material string \"%s\" in Union geometry \"%s\" did not match a specified material. \n",material_string,NAME_CURRENT_COMP);
            printf("       The materials available at this point (need to be defined before the geometry): \n");
            for (loop_index=0;loop_index<global_material_list.num_elements;loop_index++)
              printf("         %s\n",global_material_list.elements[loop_index].name);
            printf("\n");
            printf("       It is also possible to use one of the defualt materials avaiable: \n");
            printf("           Vacuum (for a Volume without scattering or absorption)\n");
            printf("           Exit (for a Volume where the ray exits the component if it enters)\n");
            printf("           Mask (for a Volume that masks existing volumes specified in the mask_string\n");
            exit(1);
          }
        }
    }
} else {
    // Automatic linking, simply using the last defined material.
    #ifndef MATERIAL_DETECTOR
        printf("Need to define a material before the geometry to use automatic linking %s.\n",NAME_CURRENT_COMP);
        exit(1);
    #endif
    this_box_volume.p_physics = global_material_list.elements[global_material_list.num_elements-1].physics;
}

sprintf(this_box_volume.name,NAME_CURRENT_COMP);
sprintf(this_box_volume.geometry.shape,"box");
this_box_volume.geometry.priority_value = priority;
this_box_volume.geometry.geometry_p_interact = p_interact;
// Currently the coordinates will be in absolute space.
this_box_volume.geometry.center = POS_A_CURRENT_COMP;

this_box_storage.z_depth = zdepth;
this_box_storage.x_width1 = xwidth;
this_box_storage.y_height1 = yheight;

this_box_storage.is_rectangle = 0;
if (xwidth2 < 0 && yheight2 < 0) this_box_storage.is_rectangle = 1;
if (xwidth == xwidth2 && yheight == yheight2) this_box_storage.is_rectangle = 1;

if (xwidth2 < 0) {
    this_box_storage.x_width2 = xwidth;
    xwidth2 = xwidth;
} else this_box_storage.x_width2 = xwidth2;

if (yheight2 < 0) {
    this_box_storage.y_height2 = yheight;
    yheight2 = yheight;
} else this_box_storage.y_height2 = yheight2;


this_box_storage.normal_vectors[0] = coords_set(0,0,1);
this_box_storage.normal_vectors[1] = coords_set(0,0,1);

// for sides with y component = 0
x_component = 2*zdepth/sqrt((xwidth-xwidth2)*(xwidth-xwidth2)+4*zdepth*zdepth);
z_component = (xwidth-xwidth2)/sqrt(4*zdepth*zdepth+(xwidth-xwidth2)*(xwidth-xwidth2));

this_box_storage.normal_vectors[2] = coords_set(x_component,0,z_component);
this_box_storage.normal_vectors[3] = coords_set(-x_component,0,z_component);

// for sides with x component = 0
y_component = 2*zdepth/sqrt((yheight-yheight2)*(yheight-yheight2)+4*zdepth*zdepth);
z_component = (yheight-yheight2)/sqrt(4*zdepth*zdepth+(yheight-yheight2)*(yheight-yheight2));

this_box_storage.normal_vectors[4] = coords_set(0,y_component,z_component);
this_box_storage.normal_vectors[5] = coords_set(0,-y_component,z_component);

this_box_volume.geometry.visualization_on = visualize;

this_box_volume.geometry.geometry_parameters.p_box_storage = &this_box_storage;

// Assign pointers to functions for intersection with the shape, checking if a point is inside the shape
if (this_box_storage.is_rectangle == 1) {
this_box_volume.geometry.intersect_function = &sample_box_intersect_simple;
this_box_volume.geometry.within_function = &r_within_box_simple;
}
else {
this_box_volume.geometry.intersect_function = &sample_box_intersect_advanced;
this_box_volume.geometry.within_function = &r_within_box_advanced;
}

this_box_volume.geometry.shell_points = &box_shell_points;
this_box_volume.geometry.mcdisplay_function = &mcdisplay_box_function;
this_box_volume.geometry.initialize_from_main_function = &initialize_box_geometry_from_main_component;
this_box_volume.geometry.process_rot_allocated = 0;

this_box_volume.geometry.copy_geometry_parameters = &allocate_box_storage_copy;

rot_copy(this_box_volume.geometry.rotation_matrix,ROT_A_CURRENT_COMP); //check how ROT_R_CURRENT_COMP would work
rot_transpose(ROT_A_CURRENT_COMP,this_box_volume.geometry.transpose_rotation_matrix);

// Initialize loggers
this_box_volume.loggers.num_elements = 0;

// packing the information into the global_geometry_element, which is then included in the global_geometry_list.
sprintf(global_geometry_element.name,NAME_CURRENT_COMP);
global_geometry_element.activation_counter = number_of_activations;
global_geometry_element.component_index = INDEX_CURRENT_COMP;
global_geometry_element.Volume = &this_box_volume; // Would be nicer if this m was a pointer, now we have the (small) data two places
add_element_to_geometry_list(&global_geometry_list,global_geometry_element);
}
#line 234692 "MACS_sample_kidney_box.c"
#undef number_of_activations
#undef mask_setting
#undef mask_string
#undef p_interact
#undef focus_r
#undef focus_xh
#undef focus_xw
#undef focus_ah
#undef focus_aw
#undef target_z
#undef target_y
#undef target_x
#undef target_index
#undef visualize
#undef yheight2
#undef xwidth2
#undef zdepth
#undef yheight
#undef xwidth
#undef priority
#undef material_string
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

  /* Initializations for component spec_detector_7_exit_volume. */
  SIG_MESSAGE("spec_detector_7_exit_volume (Init)");
#define mccompcurname  spec_detector_7_exit_volume
#define mccompcurtype  Union_box
#define mccompcurindex 427
#define loop_index mccspec_detector_7_exit_volume_loop_index
#define this_box_volume mccspec_detector_7_exit_volume_this_box_volume
#define global_geometry_element mccspec_detector_7_exit_volume_global_geometry_element
#define this_box_storage mccspec_detector_7_exit_volume_this_box_storage
#define material_string mccspec_detector_7_exit_volume_material_string
#define priority mccspec_detector_7_exit_volume_priority
#define xwidth mccspec_detector_7_exit_volume_xwidth
#define yheight mccspec_detector_7_exit_volume_yheight
#define zdepth mccspec_detector_7_exit_volume_zdepth
#define xwidth2 mccspec_detector_7_exit_volume_xwidth2
#define yheight2 mccspec_detector_7_exit_volume_yheight2
#define visualize mccspec_detector_7_exit_volume_visualize
#define target_index mccspec_detector_7_exit_volume_target_index
#define target_x mccspec_detector_7_exit_volume_target_x
#define target_y mccspec_detector_7_exit_volume_target_y
#define target_z mccspec_detector_7_exit_volume_target_z
#define focus_aw mccspec_detector_7_exit_volume_focus_aw
#define focus_ah mccspec_detector_7_exit_volume_focus_ah
#define focus_xw mccspec_detector_7_exit_volume_focus_xw
#define focus_xh mccspec_detector_7_exit_volume_focus_xh
#define focus_r mccspec_detector_7_exit_volume_focus_r
#define p_interact mccspec_detector_7_exit_volume_p_interact
#define mask_string mccspec_detector_7_exit_volume_mask_string
#define mask_setting mccspec_detector_7_exit_volume_mask_setting
#define number_of_activations mccspec_detector_7_exit_volume_number_of_activations
#line 224 "Union_box.comp"
{
// Initializes the focusing system for this volume including input sanitation.
focus_initialize(&this_box_volume.geometry, POS_A_COMP_INDEX(INDEX_CURRENT_COMP+target_index), POS_A_CURRENT_COMP, ROT_A_CURRENT_COMP, target_index, target_x, target_y, target_z, focus_aw, focus_ah, focus_xw, focus_xh, focus_r, NAME_CURRENT_COMP);

// Input sanitation for this geometry
if (xwidth <= 0) {
  printf("\nERROR in Union_box named %s, the xwidth is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (yheight <= 0) {
  printf("\nERROR in Union_box named %s, yheight is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (zdepth <= 0) {
  printf("\nERROR in Union_box named %s, zdepth is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (xwidth2 <= 0 && xwidth2 != -1) {
  printf("\nERROR in Union_box named %s, the xwidth2 is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (yheight2 <= 0 && yheight2 != -1) {
  printf("\nERROR in Union_box named %s, yheight2 is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}

// Use sanitation
if (global_material_list.num_elements == 0) {
  printf("\nERROR: Need to define a material using Union_make_material before using a Union geometry component. \n");
  printf("       %s was defined before first use of Union_make_material.\n",NAME_CURRENT_COMP);
  exit(1);
}

this_box_volume.geometry.is_masked_volume = 0;
this_box_volume.geometry.is_exit_volume = 0;
this_box_volume.geometry.is_mask_volume = 0;
// check if the volume is a mask, if it is the material string is irelevant.
if (mask_string && strlen(mask_string) && strcmp(mask_string, "NULL") && strcmp(mask_string, "0")) {
    // A mask volume is used to limit the extend of other volumes, called the masked volumes. These are specified in the mask_string.
    // In order for a ray to enter a masked volume, it needs to be both in the region covered by that volume AND the mask volume.
    // When more than
    this_box_volume.geometry.mask_mode = 1; // Default is mask mode is ALL
    if (mask_setting && strlen(mask_setting) && strcmp(mask_setting, "NULL") && strcmp(mask_setting, "0")) {
        if (strcmp(mask_setting,"ALL") == 0 || strcmp(mask_setting,"All") == 0) this_box_volume.geometry.mask_mode = 1;
        else if (strcmp(mask_setting,"ANY") == 0 || strcmp(mask_setting,"Any") == 0) this_box_volume.geometry.mask_mode = 2;
        else {
            printf("The mask_mode of component %s is set to %s, but must be either ALL or ANY.\n",NAME_CURRENT_COMP,mask_setting);
            exit(1);
        }
    }
    
    for (loop_index=0;loop_index<global_geometry_list.num_elements;loop_index++) {
        // Add mask list
        if (1 == manual_linking_function(global_geometry_list.elements[loop_index].name,mask_string)) {
            add_element_to_int_list(&this_box_volume.geometry.mask_list,global_geometry_list.elements[loop_index].component_index);
            add_element_to_int_list(&global_geometry_list.elements[loop_index].Volume->geometry.masked_by_list,INDEX_CURRENT_COMP);
            global_geometry_list.elements[loop_index].Volume->geometry.is_masked_volume = 1;
            if (this_box_volume.geometry.mask_mode == 2)
                global_geometry_list.elements[loop_index].Volume->geometry.mask_mode = 2;
            if (this_box_volume.geometry.mask_mode == 1) {
                if (global_geometry_list.elements[loop_index].Volume->geometry.is_masked_volume == 1 && global_geometry_list.elements[loop_index].Volume->geometry.mask_mode != 2)
                    // If more than one mask is added to one volume, the ANY mode overwrites the (default) ALL mode.
                    global_geometry_list.elements[loop_index].Volume->geometry.mask_mode = 1;
            }
            
            found_geometries = 1;
        }
    }
    if (found_geometries == 0) {
        printf("The mask_string in geometry: %s did not find any of the specified volumes in the mask_string %s \n",NAME_CURRENT_COMP,mask_string);
        exit(1);
    }
    this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
    this_box_volume.p_physics->is_vacuum = 0; // Makes this volume a vacuum
    this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
    this_box_volume.p_physics->my_a = 0; // Should not be used.
    sprintf(this_box_volume.p_physics->name,"Mask");
    this_box_volume.geometry.is_mask_volume = 1;
    
    
// Read the material input, or if it lacks, use automatic linking.
} else if (material_string && strlen(material_string) && strcmp(material_string, "NULL") && strcmp(material_string, "0")) {
    // A geometry string was given, use it to determine which material
    if (0 == strcmp(material_string,"vacuum") || 0 == strcmp(material_string,"Vacuum")) {
        // One could have a global physics struct for vacuum instead of creating one for each
        this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
        this_box_volume.p_physics->is_vacuum = 1; // Makes this volume a vacuum
        this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
        this_box_volume.p_physics->my_a = 0; // Should not be used.
        sprintf(this_box_volume.p_physics->name,"Vacuum");
    } else if (0 == strcmp(material_string,"exit") || 0 == strcmp(material_string,"Exit")) {
        // One could have a global physics struct for vacuum instead of creating one for each
        this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
        this_box_volume.p_physics->is_vacuum = 1; // Makes this volume a vacuum
        this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
        this_box_volume.p_physics->my_a = 0; // Should not be used.
        this_box_volume.geometry.is_exit_volume = 1;
        sprintf(this_box_volume.p_physics->name,"Exit");
    } else {
        #ifndef MATERIAL_DETECTOR
            printf("Need to define a material before refering to it in a geometry %s.\n",NAME_CURRENT_COMP);
            exit(1);
        #endif
        for (loop_index=0;loop_index<global_material_list.num_elements;loop_index++) {
            if (0 == strcmp(material_string,global_material_list.elements[loop_index].name)) {
                this_box_volume.p_physics = global_material_list.elements[loop_index].physics;
                break;
            }
            if (loop_index == global_material_list.num_elements-1) {
            printf("\n");
            printf("ERROR: The material string \"%s\" in Union geometry \"%s\" did not match a specified material. \n",material_string,NAME_CURRENT_COMP);
            printf("       The materials available at this point (need to be defined before the geometry): \n");
            for (loop_index=0;loop_index<global_material_list.num_elements;loop_index++)
              printf("         %s\n",global_material_list.elements[loop_index].name);
            printf("\n");
            printf("       It is also possible to use one of the defualt materials avaiable: \n");
            printf("           Vacuum (for a Volume without scattering or absorption)\n");
            printf("           Exit (for a Volume where the ray exits the component if it enters)\n");
            printf("           Mask (for a Volume that masks existing volumes specified in the mask_string\n");
            exit(1);
          }
        }
    }
} else {
    // Automatic linking, simply using the last defined material.
    #ifndef MATERIAL_DETECTOR
        printf("Need to define a material before the geometry to use automatic linking %s.\n",NAME_CURRENT_COMP);
        exit(1);
    #endif
    this_box_volume.p_physics = global_material_list.elements[global_material_list.num_elements-1].physics;
}

sprintf(this_box_volume.name,NAME_CURRENT_COMP);
sprintf(this_box_volume.geometry.shape,"box");
this_box_volume.geometry.priority_value = priority;
this_box_volume.geometry.geometry_p_interact = p_interact;
// Currently the coordinates will be in absolute space.
this_box_volume.geometry.center = POS_A_CURRENT_COMP;

this_box_storage.z_depth = zdepth;
this_box_storage.x_width1 = xwidth;
this_box_storage.y_height1 = yheight;

this_box_storage.is_rectangle = 0;
if (xwidth2 < 0 && yheight2 < 0) this_box_storage.is_rectangle = 1;
if (xwidth == xwidth2 && yheight == yheight2) this_box_storage.is_rectangle = 1;

if (xwidth2 < 0) {
    this_box_storage.x_width2 = xwidth;
    xwidth2 = xwidth;
} else this_box_storage.x_width2 = xwidth2;

if (yheight2 < 0) {
    this_box_storage.y_height2 = yheight;
    yheight2 = yheight;
} else this_box_storage.y_height2 = yheight2;


this_box_storage.normal_vectors[0] = coords_set(0,0,1);
this_box_storage.normal_vectors[1] = coords_set(0,0,1);

// for sides with y component = 0
x_component = 2*zdepth/sqrt((xwidth-xwidth2)*(xwidth-xwidth2)+4*zdepth*zdepth);
z_component = (xwidth-xwidth2)/sqrt(4*zdepth*zdepth+(xwidth-xwidth2)*(xwidth-xwidth2));

this_box_storage.normal_vectors[2] = coords_set(x_component,0,z_component);
this_box_storage.normal_vectors[3] = coords_set(-x_component,0,z_component);

// for sides with x component = 0
y_component = 2*zdepth/sqrt((yheight-yheight2)*(yheight-yheight2)+4*zdepth*zdepth);
z_component = (yheight-yheight2)/sqrt(4*zdepth*zdepth+(yheight-yheight2)*(yheight-yheight2));

this_box_storage.normal_vectors[4] = coords_set(0,y_component,z_component);
this_box_storage.normal_vectors[5] = coords_set(0,-y_component,z_component);

this_box_volume.geometry.visualization_on = visualize;

this_box_volume.geometry.geometry_parameters.p_box_storage = &this_box_storage;

// Assign pointers to functions for intersection with the shape, checking if a point is inside the shape
if (this_box_storage.is_rectangle == 1) {
this_box_volume.geometry.intersect_function = &sample_box_intersect_simple;
this_box_volume.geometry.within_function = &r_within_box_simple;
}
else {
this_box_volume.geometry.intersect_function = &sample_box_intersect_advanced;
this_box_volume.geometry.within_function = &r_within_box_advanced;
}

this_box_volume.geometry.shell_points = &box_shell_points;
this_box_volume.geometry.mcdisplay_function = &mcdisplay_box_function;
this_box_volume.geometry.initialize_from_main_function = &initialize_box_geometry_from_main_component;
this_box_volume.geometry.process_rot_allocated = 0;

this_box_volume.geometry.copy_geometry_parameters = &allocate_box_storage_copy;

rot_copy(this_box_volume.geometry.rotation_matrix,ROT_A_CURRENT_COMP); //check how ROT_R_CURRENT_COMP would work
rot_transpose(ROT_A_CURRENT_COMP,this_box_volume.geometry.transpose_rotation_matrix);

// Initialize loggers
this_box_volume.loggers.num_elements = 0;

// packing the information into the global_geometry_element, which is then included in the global_geometry_list.
sprintf(global_geometry_element.name,NAME_CURRENT_COMP);
global_geometry_element.activation_counter = number_of_activations;
global_geometry_element.component_index = INDEX_CURRENT_COMP;
global_geometry_element.Volume = &this_box_volume; // Would be nicer if this m was a pointer, now we have the (small) data two places
add_element_to_geometry_list(&global_geometry_list,global_geometry_element);
}
#line 234962 "MACS_sample_kidney_box.c"
#undef number_of_activations
#undef mask_setting
#undef mask_string
#undef p_interact
#undef focus_r
#undef focus_xh
#undef focus_xw
#undef focus_ah
#undef focus_aw
#undef target_z
#undef target_y
#undef target_x
#undef target_index
#undef visualize
#undef yheight2
#undef xwidth2
#undef zdepth
#undef yheight
#undef xwidth
#undef priority
#undef material_string
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

  /* Initializations for component channel_8_cave1_box1. */
  SIG_MESSAGE("channel_8_cave1_box1 (Init)");
#define mccompcurname  channel_8_cave1_box1
#define mccompcurtype  Union_box
#define mccompcurindex 428
#define loop_index mccchannel_8_cave1_box1_loop_index
#define this_box_volume mccchannel_8_cave1_box1_this_box_volume
#define global_geometry_element mccchannel_8_cave1_box1_global_geometry_element
#define this_box_storage mccchannel_8_cave1_box1_this_box_storage
#define material_string mccchannel_8_cave1_box1_material_string
#define priority mccchannel_8_cave1_box1_priority
#define xwidth mccchannel_8_cave1_box1_xwidth
#define yheight mccchannel_8_cave1_box1_yheight
#define zdepth mccchannel_8_cave1_box1_zdepth
#define xwidth2 mccchannel_8_cave1_box1_xwidth2
#define yheight2 mccchannel_8_cave1_box1_yheight2
#define visualize mccchannel_8_cave1_box1_visualize
#define target_index mccchannel_8_cave1_box1_target_index
#define target_x mccchannel_8_cave1_box1_target_x
#define target_y mccchannel_8_cave1_box1_target_y
#define target_z mccchannel_8_cave1_box1_target_z
#define focus_aw mccchannel_8_cave1_box1_focus_aw
#define focus_ah mccchannel_8_cave1_box1_focus_ah
#define focus_xw mccchannel_8_cave1_box1_focus_xw
#define focus_xh mccchannel_8_cave1_box1_focus_xh
#define focus_r mccchannel_8_cave1_box1_focus_r
#define p_interact mccchannel_8_cave1_box1_p_interact
#define mask_string mccchannel_8_cave1_box1_mask_string
#define mask_setting mccchannel_8_cave1_box1_mask_setting
#define number_of_activations mccchannel_8_cave1_box1_number_of_activations
#line 224 "Union_box.comp"
{
// Initializes the focusing system for this volume including input sanitation.
focus_initialize(&this_box_volume.geometry, POS_A_COMP_INDEX(INDEX_CURRENT_COMP+target_index), POS_A_CURRENT_COMP, ROT_A_CURRENT_COMP, target_index, target_x, target_y, target_z, focus_aw, focus_ah, focus_xw, focus_xh, focus_r, NAME_CURRENT_COMP);

// Input sanitation for this geometry
if (xwidth <= 0) {
  printf("\nERROR in Union_box named %s, the xwidth is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (yheight <= 0) {
  printf("\nERROR in Union_box named %s, yheight is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (zdepth <= 0) {
  printf("\nERROR in Union_box named %s, zdepth is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (xwidth2 <= 0 && xwidth2 != -1) {
  printf("\nERROR in Union_box named %s, the xwidth2 is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (yheight2 <= 0 && yheight2 != -1) {
  printf("\nERROR in Union_box named %s, yheight2 is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}

// Use sanitation
if (global_material_list.num_elements == 0) {
  printf("\nERROR: Need to define a material using Union_make_material before using a Union geometry component. \n");
  printf("       %s was defined before first use of Union_make_material.\n",NAME_CURRENT_COMP);
  exit(1);
}

this_box_volume.geometry.is_masked_volume = 0;
this_box_volume.geometry.is_exit_volume = 0;
this_box_volume.geometry.is_mask_volume = 0;
// check if the volume is a mask, if it is the material string is irelevant.
if (mask_string && strlen(mask_string) && strcmp(mask_string, "NULL") && strcmp(mask_string, "0")) {
    // A mask volume is used to limit the extend of other volumes, called the masked volumes. These are specified in the mask_string.
    // In order for a ray to enter a masked volume, it needs to be both in the region covered by that volume AND the mask volume.
    // When more than
    this_box_volume.geometry.mask_mode = 1; // Default is mask mode is ALL
    if (mask_setting && strlen(mask_setting) && strcmp(mask_setting, "NULL") && strcmp(mask_setting, "0")) {
        if (strcmp(mask_setting,"ALL") == 0 || strcmp(mask_setting,"All") == 0) this_box_volume.geometry.mask_mode = 1;
        else if (strcmp(mask_setting,"ANY") == 0 || strcmp(mask_setting,"Any") == 0) this_box_volume.geometry.mask_mode = 2;
        else {
            printf("The mask_mode of component %s is set to %s, but must be either ALL or ANY.\n",NAME_CURRENT_COMP,mask_setting);
            exit(1);
        }
    }
    
    for (loop_index=0;loop_index<global_geometry_list.num_elements;loop_index++) {
        // Add mask list
        if (1 == manual_linking_function(global_geometry_list.elements[loop_index].name,mask_string)) {
            add_element_to_int_list(&this_box_volume.geometry.mask_list,global_geometry_list.elements[loop_index].component_index);
            add_element_to_int_list(&global_geometry_list.elements[loop_index].Volume->geometry.masked_by_list,INDEX_CURRENT_COMP);
            global_geometry_list.elements[loop_index].Volume->geometry.is_masked_volume = 1;
            if (this_box_volume.geometry.mask_mode == 2)
                global_geometry_list.elements[loop_index].Volume->geometry.mask_mode = 2;
            if (this_box_volume.geometry.mask_mode == 1) {
                if (global_geometry_list.elements[loop_index].Volume->geometry.is_masked_volume == 1 && global_geometry_list.elements[loop_index].Volume->geometry.mask_mode != 2)
                    // If more than one mask is added to one volume, the ANY mode overwrites the (default) ALL mode.
                    global_geometry_list.elements[loop_index].Volume->geometry.mask_mode = 1;
            }
            
            found_geometries = 1;
        }
    }
    if (found_geometries == 0) {
        printf("The mask_string in geometry: %s did not find any of the specified volumes in the mask_string %s \n",NAME_CURRENT_COMP,mask_string);
        exit(1);
    }
    this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
    this_box_volume.p_physics->is_vacuum = 0; // Makes this volume a vacuum
    this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
    this_box_volume.p_physics->my_a = 0; // Should not be used.
    sprintf(this_box_volume.p_physics->name,"Mask");
    this_box_volume.geometry.is_mask_volume = 1;
    
    
// Read the material input, or if it lacks, use automatic linking.
} else if (material_string && strlen(material_string) && strcmp(material_string, "NULL") && strcmp(material_string, "0")) {
    // A geometry string was given, use it to determine which material
    if (0 == strcmp(material_string,"vacuum") || 0 == strcmp(material_string,"Vacuum")) {
        // One could have a global physics struct for vacuum instead of creating one for each
        this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
        this_box_volume.p_physics->is_vacuum = 1; // Makes this volume a vacuum
        this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
        this_box_volume.p_physics->my_a = 0; // Should not be used.
        sprintf(this_box_volume.p_physics->name,"Vacuum");
    } else if (0 == strcmp(material_string,"exit") || 0 == strcmp(material_string,"Exit")) {
        // One could have a global physics struct for vacuum instead of creating one for each
        this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
        this_box_volume.p_physics->is_vacuum = 1; // Makes this volume a vacuum
        this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
        this_box_volume.p_physics->my_a = 0; // Should not be used.
        this_box_volume.geometry.is_exit_volume = 1;
        sprintf(this_box_volume.p_physics->name,"Exit");
    } else {
        #ifndef MATERIAL_DETECTOR
            printf("Need to define a material before refering to it in a geometry %s.\n",NAME_CURRENT_COMP);
            exit(1);
        #endif
        for (loop_index=0;loop_index<global_material_list.num_elements;loop_index++) {
            if (0 == strcmp(material_string,global_material_list.elements[loop_index].name)) {
                this_box_volume.p_physics = global_material_list.elements[loop_index].physics;
                break;
            }
            if (loop_index == global_material_list.num_elements-1) {
            printf("\n");
            printf("ERROR: The material string \"%s\" in Union geometry \"%s\" did not match a specified material. \n",material_string,NAME_CURRENT_COMP);
            printf("       The materials available at this point (need to be defined before the geometry): \n");
            for (loop_index=0;loop_index<global_material_list.num_elements;loop_index++)
              printf("         %s\n",global_material_list.elements[loop_index].name);
            printf("\n");
            printf("       It is also possible to use one of the defualt materials avaiable: \n");
            printf("           Vacuum (for a Volume without scattering or absorption)\n");
            printf("           Exit (for a Volume where the ray exits the component if it enters)\n");
            printf("           Mask (for a Volume that masks existing volumes specified in the mask_string\n");
            exit(1);
          }
        }
    }
} else {
    // Automatic linking, simply using the last defined material.
    #ifndef MATERIAL_DETECTOR
        printf("Need to define a material before the geometry to use automatic linking %s.\n",NAME_CURRENT_COMP);
        exit(1);
    #endif
    this_box_volume.p_physics = global_material_list.elements[global_material_list.num_elements-1].physics;
}

sprintf(this_box_volume.name,NAME_CURRENT_COMP);
sprintf(this_box_volume.geometry.shape,"box");
this_box_volume.geometry.priority_value = priority;
this_box_volume.geometry.geometry_p_interact = p_interact;
// Currently the coordinates will be in absolute space.
this_box_volume.geometry.center = POS_A_CURRENT_COMP;

this_box_storage.z_depth = zdepth;
this_box_storage.x_width1 = xwidth;
this_box_storage.y_height1 = yheight;

this_box_storage.is_rectangle = 0;
if (xwidth2 < 0 && yheight2 < 0) this_box_storage.is_rectangle = 1;
if (xwidth == xwidth2 && yheight == yheight2) this_box_storage.is_rectangle = 1;

if (xwidth2 < 0) {
    this_box_storage.x_width2 = xwidth;
    xwidth2 = xwidth;
} else this_box_storage.x_width2 = xwidth2;

if (yheight2 < 0) {
    this_box_storage.y_height2 = yheight;
    yheight2 = yheight;
} else this_box_storage.y_height2 = yheight2;


this_box_storage.normal_vectors[0] = coords_set(0,0,1);
this_box_storage.normal_vectors[1] = coords_set(0,0,1);

// for sides with y component = 0
x_component = 2*zdepth/sqrt((xwidth-xwidth2)*(xwidth-xwidth2)+4*zdepth*zdepth);
z_component = (xwidth-xwidth2)/sqrt(4*zdepth*zdepth+(xwidth-xwidth2)*(xwidth-xwidth2));

this_box_storage.normal_vectors[2] = coords_set(x_component,0,z_component);
this_box_storage.normal_vectors[3] = coords_set(-x_component,0,z_component);

// for sides with x component = 0
y_component = 2*zdepth/sqrt((yheight-yheight2)*(yheight-yheight2)+4*zdepth*zdepth);
z_component = (yheight-yheight2)/sqrt(4*zdepth*zdepth+(yheight-yheight2)*(yheight-yheight2));

this_box_storage.normal_vectors[4] = coords_set(0,y_component,z_component);
this_box_storage.normal_vectors[5] = coords_set(0,-y_component,z_component);

this_box_volume.geometry.visualization_on = visualize;

this_box_volume.geometry.geometry_parameters.p_box_storage = &this_box_storage;

// Assign pointers to functions for intersection with the shape, checking if a point is inside the shape
if (this_box_storage.is_rectangle == 1) {
this_box_volume.geometry.intersect_function = &sample_box_intersect_simple;
this_box_volume.geometry.within_function = &r_within_box_simple;
}
else {
this_box_volume.geometry.intersect_function = &sample_box_intersect_advanced;
this_box_volume.geometry.within_function = &r_within_box_advanced;
}

this_box_volume.geometry.shell_points = &box_shell_points;
this_box_volume.geometry.mcdisplay_function = &mcdisplay_box_function;
this_box_volume.geometry.initialize_from_main_function = &initialize_box_geometry_from_main_component;
this_box_volume.geometry.process_rot_allocated = 0;

this_box_volume.geometry.copy_geometry_parameters = &allocate_box_storage_copy;

rot_copy(this_box_volume.geometry.rotation_matrix,ROT_A_CURRENT_COMP); //check how ROT_R_CURRENT_COMP would work
rot_transpose(ROT_A_CURRENT_COMP,this_box_volume.geometry.transpose_rotation_matrix);

// Initialize loggers
this_box_volume.loggers.num_elements = 0;

// packing the information into the global_geometry_element, which is then included in the global_geometry_list.
sprintf(global_geometry_element.name,NAME_CURRENT_COMP);
global_geometry_element.activation_counter = number_of_activations;
global_geometry_element.component_index = INDEX_CURRENT_COMP;
global_geometry_element.Volume = &this_box_volume; // Would be nicer if this m was a pointer, now we have the (small) data two places
add_element_to_geometry_list(&global_geometry_list,global_geometry_element);
}
#line 235232 "MACS_sample_kidney_box.c"
#undef number_of_activations
#undef mask_setting
#undef mask_string
#undef p_interact
#undef focus_r
#undef focus_xh
#undef focus_xw
#undef focus_ah
#undef focus_aw
#undef target_z
#undef target_y
#undef target_x
#undef target_index
#undef visualize
#undef yheight2
#undef xwidth2
#undef zdepth
#undef yheight
#undef xwidth
#undef priority
#undef material_string
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

  /* Initializations for component channel_8_cave1_box2. */
  SIG_MESSAGE("channel_8_cave1_box2 (Init)");
#define mccompcurname  channel_8_cave1_box2
#define mccompcurtype  Union_box
#define mccompcurindex 429
#define loop_index mccchannel_8_cave1_box2_loop_index
#define this_box_volume mccchannel_8_cave1_box2_this_box_volume
#define global_geometry_element mccchannel_8_cave1_box2_global_geometry_element
#define this_box_storage mccchannel_8_cave1_box2_this_box_storage
#define material_string mccchannel_8_cave1_box2_material_string
#define priority mccchannel_8_cave1_box2_priority
#define xwidth mccchannel_8_cave1_box2_xwidth
#define yheight mccchannel_8_cave1_box2_yheight
#define zdepth mccchannel_8_cave1_box2_zdepth
#define xwidth2 mccchannel_8_cave1_box2_xwidth2
#define yheight2 mccchannel_8_cave1_box2_yheight2
#define visualize mccchannel_8_cave1_box2_visualize
#define target_index mccchannel_8_cave1_box2_target_index
#define target_x mccchannel_8_cave1_box2_target_x
#define target_y mccchannel_8_cave1_box2_target_y
#define target_z mccchannel_8_cave1_box2_target_z
#define focus_aw mccchannel_8_cave1_box2_focus_aw
#define focus_ah mccchannel_8_cave1_box2_focus_ah
#define focus_xw mccchannel_8_cave1_box2_focus_xw
#define focus_xh mccchannel_8_cave1_box2_focus_xh
#define focus_r mccchannel_8_cave1_box2_focus_r
#define p_interact mccchannel_8_cave1_box2_p_interact
#define mask_string mccchannel_8_cave1_box2_mask_string
#define mask_setting mccchannel_8_cave1_box2_mask_setting
#define number_of_activations mccchannel_8_cave1_box2_number_of_activations
#line 224 "Union_box.comp"
{
// Initializes the focusing system for this volume including input sanitation.
focus_initialize(&this_box_volume.geometry, POS_A_COMP_INDEX(INDEX_CURRENT_COMP+target_index), POS_A_CURRENT_COMP, ROT_A_CURRENT_COMP, target_index, target_x, target_y, target_z, focus_aw, focus_ah, focus_xw, focus_xh, focus_r, NAME_CURRENT_COMP);

// Input sanitation for this geometry
if (xwidth <= 0) {
  printf("\nERROR in Union_box named %s, the xwidth is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (yheight <= 0) {
  printf("\nERROR in Union_box named %s, yheight is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (zdepth <= 0) {
  printf("\nERROR in Union_box named %s, zdepth is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (xwidth2 <= 0 && xwidth2 != -1) {
  printf("\nERROR in Union_box named %s, the xwidth2 is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (yheight2 <= 0 && yheight2 != -1) {
  printf("\nERROR in Union_box named %s, yheight2 is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}

// Use sanitation
if (global_material_list.num_elements == 0) {
  printf("\nERROR: Need to define a material using Union_make_material before using a Union geometry component. \n");
  printf("       %s was defined before first use of Union_make_material.\n",NAME_CURRENT_COMP);
  exit(1);
}

this_box_volume.geometry.is_masked_volume = 0;
this_box_volume.geometry.is_exit_volume = 0;
this_box_volume.geometry.is_mask_volume = 0;
// check if the volume is a mask, if it is the material string is irelevant.
if (mask_string && strlen(mask_string) && strcmp(mask_string, "NULL") && strcmp(mask_string, "0")) {
    // A mask volume is used to limit the extend of other volumes, called the masked volumes. These are specified in the mask_string.
    // In order for a ray to enter a masked volume, it needs to be both in the region covered by that volume AND the mask volume.
    // When more than
    this_box_volume.geometry.mask_mode = 1; // Default is mask mode is ALL
    if (mask_setting && strlen(mask_setting) && strcmp(mask_setting, "NULL") && strcmp(mask_setting, "0")) {
        if (strcmp(mask_setting,"ALL") == 0 || strcmp(mask_setting,"All") == 0) this_box_volume.geometry.mask_mode = 1;
        else if (strcmp(mask_setting,"ANY") == 0 || strcmp(mask_setting,"Any") == 0) this_box_volume.geometry.mask_mode = 2;
        else {
            printf("The mask_mode of component %s is set to %s, but must be either ALL or ANY.\n",NAME_CURRENT_COMP,mask_setting);
            exit(1);
        }
    }
    
    for (loop_index=0;loop_index<global_geometry_list.num_elements;loop_index++) {
        // Add mask list
        if (1 == manual_linking_function(global_geometry_list.elements[loop_index].name,mask_string)) {
            add_element_to_int_list(&this_box_volume.geometry.mask_list,global_geometry_list.elements[loop_index].component_index);
            add_element_to_int_list(&global_geometry_list.elements[loop_index].Volume->geometry.masked_by_list,INDEX_CURRENT_COMP);
            global_geometry_list.elements[loop_index].Volume->geometry.is_masked_volume = 1;
            if (this_box_volume.geometry.mask_mode == 2)
                global_geometry_list.elements[loop_index].Volume->geometry.mask_mode = 2;
            if (this_box_volume.geometry.mask_mode == 1) {
                if (global_geometry_list.elements[loop_index].Volume->geometry.is_masked_volume == 1 && global_geometry_list.elements[loop_index].Volume->geometry.mask_mode != 2)
                    // If more than one mask is added to one volume, the ANY mode overwrites the (default) ALL mode.
                    global_geometry_list.elements[loop_index].Volume->geometry.mask_mode = 1;
            }
            
            found_geometries = 1;
        }
    }
    if (found_geometries == 0) {
        printf("The mask_string in geometry: %s did not find any of the specified volumes in the mask_string %s \n",NAME_CURRENT_COMP,mask_string);
        exit(1);
    }
    this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
    this_box_volume.p_physics->is_vacuum = 0; // Makes this volume a vacuum
    this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
    this_box_volume.p_physics->my_a = 0; // Should not be used.
    sprintf(this_box_volume.p_physics->name,"Mask");
    this_box_volume.geometry.is_mask_volume = 1;
    
    
// Read the material input, or if it lacks, use automatic linking.
} else if (material_string && strlen(material_string) && strcmp(material_string, "NULL") && strcmp(material_string, "0")) {
    // A geometry string was given, use it to determine which material
    if (0 == strcmp(material_string,"vacuum") || 0 == strcmp(material_string,"Vacuum")) {
        // One could have a global physics struct for vacuum instead of creating one for each
        this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
        this_box_volume.p_physics->is_vacuum = 1; // Makes this volume a vacuum
        this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
        this_box_volume.p_physics->my_a = 0; // Should not be used.
        sprintf(this_box_volume.p_physics->name,"Vacuum");
    } else if (0 == strcmp(material_string,"exit") || 0 == strcmp(material_string,"Exit")) {
        // One could have a global physics struct for vacuum instead of creating one for each
        this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
        this_box_volume.p_physics->is_vacuum = 1; // Makes this volume a vacuum
        this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
        this_box_volume.p_physics->my_a = 0; // Should not be used.
        this_box_volume.geometry.is_exit_volume = 1;
        sprintf(this_box_volume.p_physics->name,"Exit");
    } else {
        #ifndef MATERIAL_DETECTOR
            printf("Need to define a material before refering to it in a geometry %s.\n",NAME_CURRENT_COMP);
            exit(1);
        #endif
        for (loop_index=0;loop_index<global_material_list.num_elements;loop_index++) {
            if (0 == strcmp(material_string,global_material_list.elements[loop_index].name)) {
                this_box_volume.p_physics = global_material_list.elements[loop_index].physics;
                break;
            }
            if (loop_index == global_material_list.num_elements-1) {
            printf("\n");
            printf("ERROR: The material string \"%s\" in Union geometry \"%s\" did not match a specified material. \n",material_string,NAME_CURRENT_COMP);
            printf("       The materials available at this point (need to be defined before the geometry): \n");
            for (loop_index=0;loop_index<global_material_list.num_elements;loop_index++)
              printf("         %s\n",global_material_list.elements[loop_index].name);
            printf("\n");
            printf("       It is also possible to use one of the defualt materials avaiable: \n");
            printf("           Vacuum (for a Volume without scattering or absorption)\n");
            printf("           Exit (for a Volume where the ray exits the component if it enters)\n");
            printf("           Mask (for a Volume that masks existing volumes specified in the mask_string\n");
            exit(1);
          }
        }
    }
} else {
    // Automatic linking, simply using the last defined material.
    #ifndef MATERIAL_DETECTOR
        printf("Need to define a material before the geometry to use automatic linking %s.\n",NAME_CURRENT_COMP);
        exit(1);
    #endif
    this_box_volume.p_physics = global_material_list.elements[global_material_list.num_elements-1].physics;
}

sprintf(this_box_volume.name,NAME_CURRENT_COMP);
sprintf(this_box_volume.geometry.shape,"box");
this_box_volume.geometry.priority_value = priority;
this_box_volume.geometry.geometry_p_interact = p_interact;
// Currently the coordinates will be in absolute space.
this_box_volume.geometry.center = POS_A_CURRENT_COMP;

this_box_storage.z_depth = zdepth;
this_box_storage.x_width1 = xwidth;
this_box_storage.y_height1 = yheight;

this_box_storage.is_rectangle = 0;
if (xwidth2 < 0 && yheight2 < 0) this_box_storage.is_rectangle = 1;
if (xwidth == xwidth2 && yheight == yheight2) this_box_storage.is_rectangle = 1;

if (xwidth2 < 0) {
    this_box_storage.x_width2 = xwidth;
    xwidth2 = xwidth;
} else this_box_storage.x_width2 = xwidth2;

if (yheight2 < 0) {
    this_box_storage.y_height2 = yheight;
    yheight2 = yheight;
} else this_box_storage.y_height2 = yheight2;


this_box_storage.normal_vectors[0] = coords_set(0,0,1);
this_box_storage.normal_vectors[1] = coords_set(0,0,1);

// for sides with y component = 0
x_component = 2*zdepth/sqrt((xwidth-xwidth2)*(xwidth-xwidth2)+4*zdepth*zdepth);
z_component = (xwidth-xwidth2)/sqrt(4*zdepth*zdepth+(xwidth-xwidth2)*(xwidth-xwidth2));

this_box_storage.normal_vectors[2] = coords_set(x_component,0,z_component);
this_box_storage.normal_vectors[3] = coords_set(-x_component,0,z_component);

// for sides with x component = 0
y_component = 2*zdepth/sqrt((yheight-yheight2)*(yheight-yheight2)+4*zdepth*zdepth);
z_component = (yheight-yheight2)/sqrt(4*zdepth*zdepth+(yheight-yheight2)*(yheight-yheight2));

this_box_storage.normal_vectors[4] = coords_set(0,y_component,z_component);
this_box_storage.normal_vectors[5] = coords_set(0,-y_component,z_component);

this_box_volume.geometry.visualization_on = visualize;

this_box_volume.geometry.geometry_parameters.p_box_storage = &this_box_storage;

// Assign pointers to functions for intersection with the shape, checking if a point is inside the shape
if (this_box_storage.is_rectangle == 1) {
this_box_volume.geometry.intersect_function = &sample_box_intersect_simple;
this_box_volume.geometry.within_function = &r_within_box_simple;
}
else {
this_box_volume.geometry.intersect_function = &sample_box_intersect_advanced;
this_box_volume.geometry.within_function = &r_within_box_advanced;
}

this_box_volume.geometry.shell_points = &box_shell_points;
this_box_volume.geometry.mcdisplay_function = &mcdisplay_box_function;
this_box_volume.geometry.initialize_from_main_function = &initialize_box_geometry_from_main_component;
this_box_volume.geometry.process_rot_allocated = 0;

this_box_volume.geometry.copy_geometry_parameters = &allocate_box_storage_copy;

rot_copy(this_box_volume.geometry.rotation_matrix,ROT_A_CURRENT_COMP); //check how ROT_R_CURRENT_COMP would work
rot_transpose(ROT_A_CURRENT_COMP,this_box_volume.geometry.transpose_rotation_matrix);

// Initialize loggers
this_box_volume.loggers.num_elements = 0;

// packing the information into the global_geometry_element, which is then included in the global_geometry_list.
sprintf(global_geometry_element.name,NAME_CURRENT_COMP);
global_geometry_element.activation_counter = number_of_activations;
global_geometry_element.component_index = INDEX_CURRENT_COMP;
global_geometry_element.Volume = &this_box_volume; // Would be nicer if this m was a pointer, now we have the (small) data two places
add_element_to_geometry_list(&global_geometry_list,global_geometry_element);
}
#line 235502 "MACS_sample_kidney_box.c"
#undef number_of_activations
#undef mask_setting
#undef mask_string
#undef p_interact
#undef focus_r
#undef focus_xh
#undef focus_xw
#undef focus_ah
#undef focus_aw
#undef target_z
#undef target_y
#undef target_x
#undef target_index
#undef visualize
#undef yheight2
#undef xwidth2
#undef zdepth
#undef yheight
#undef xwidth
#undef priority
#undef material_string
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

  /* Initializations for component channel_8_cave1_box3. */
  SIG_MESSAGE("channel_8_cave1_box3 (Init)");
#define mccompcurname  channel_8_cave1_box3
#define mccompcurtype  Union_box
#define mccompcurindex 430
#define loop_index mccchannel_8_cave1_box3_loop_index
#define this_box_volume mccchannel_8_cave1_box3_this_box_volume
#define global_geometry_element mccchannel_8_cave1_box3_global_geometry_element
#define this_box_storage mccchannel_8_cave1_box3_this_box_storage
#define material_string mccchannel_8_cave1_box3_material_string
#define priority mccchannel_8_cave1_box3_priority
#define xwidth mccchannel_8_cave1_box3_xwidth
#define yheight mccchannel_8_cave1_box3_yheight
#define zdepth mccchannel_8_cave1_box3_zdepth
#define xwidth2 mccchannel_8_cave1_box3_xwidth2
#define yheight2 mccchannel_8_cave1_box3_yheight2
#define visualize mccchannel_8_cave1_box3_visualize
#define target_index mccchannel_8_cave1_box3_target_index
#define target_x mccchannel_8_cave1_box3_target_x
#define target_y mccchannel_8_cave1_box3_target_y
#define target_z mccchannel_8_cave1_box3_target_z
#define focus_aw mccchannel_8_cave1_box3_focus_aw
#define focus_ah mccchannel_8_cave1_box3_focus_ah
#define focus_xw mccchannel_8_cave1_box3_focus_xw
#define focus_xh mccchannel_8_cave1_box3_focus_xh
#define focus_r mccchannel_8_cave1_box3_focus_r
#define p_interact mccchannel_8_cave1_box3_p_interact
#define mask_string mccchannel_8_cave1_box3_mask_string
#define mask_setting mccchannel_8_cave1_box3_mask_setting
#define number_of_activations mccchannel_8_cave1_box3_number_of_activations
#line 224 "Union_box.comp"
{
// Initializes the focusing system for this volume including input sanitation.
focus_initialize(&this_box_volume.geometry, POS_A_COMP_INDEX(INDEX_CURRENT_COMP+target_index), POS_A_CURRENT_COMP, ROT_A_CURRENT_COMP, target_index, target_x, target_y, target_z, focus_aw, focus_ah, focus_xw, focus_xh, focus_r, NAME_CURRENT_COMP);

// Input sanitation for this geometry
if (xwidth <= 0) {
  printf("\nERROR in Union_box named %s, the xwidth is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (yheight <= 0) {
  printf("\nERROR in Union_box named %s, yheight is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (zdepth <= 0) {
  printf("\nERROR in Union_box named %s, zdepth is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (xwidth2 <= 0 && xwidth2 != -1) {
  printf("\nERROR in Union_box named %s, the xwidth2 is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (yheight2 <= 0 && yheight2 != -1) {
  printf("\nERROR in Union_box named %s, yheight2 is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}

// Use sanitation
if (global_material_list.num_elements == 0) {
  printf("\nERROR: Need to define a material using Union_make_material before using a Union geometry component. \n");
  printf("       %s was defined before first use of Union_make_material.\n",NAME_CURRENT_COMP);
  exit(1);
}

this_box_volume.geometry.is_masked_volume = 0;
this_box_volume.geometry.is_exit_volume = 0;
this_box_volume.geometry.is_mask_volume = 0;
// check if the volume is a mask, if it is the material string is irelevant.
if (mask_string && strlen(mask_string) && strcmp(mask_string, "NULL") && strcmp(mask_string, "0")) {
    // A mask volume is used to limit the extend of other volumes, called the masked volumes. These are specified in the mask_string.
    // In order for a ray to enter a masked volume, it needs to be both in the region covered by that volume AND the mask volume.
    // When more than
    this_box_volume.geometry.mask_mode = 1; // Default is mask mode is ALL
    if (mask_setting && strlen(mask_setting) && strcmp(mask_setting, "NULL") && strcmp(mask_setting, "0")) {
        if (strcmp(mask_setting,"ALL") == 0 || strcmp(mask_setting,"All") == 0) this_box_volume.geometry.mask_mode = 1;
        else if (strcmp(mask_setting,"ANY") == 0 || strcmp(mask_setting,"Any") == 0) this_box_volume.geometry.mask_mode = 2;
        else {
            printf("The mask_mode of component %s is set to %s, but must be either ALL or ANY.\n",NAME_CURRENT_COMP,mask_setting);
            exit(1);
        }
    }
    
    for (loop_index=0;loop_index<global_geometry_list.num_elements;loop_index++) {
        // Add mask list
        if (1 == manual_linking_function(global_geometry_list.elements[loop_index].name,mask_string)) {
            add_element_to_int_list(&this_box_volume.geometry.mask_list,global_geometry_list.elements[loop_index].component_index);
            add_element_to_int_list(&global_geometry_list.elements[loop_index].Volume->geometry.masked_by_list,INDEX_CURRENT_COMP);
            global_geometry_list.elements[loop_index].Volume->geometry.is_masked_volume = 1;
            if (this_box_volume.geometry.mask_mode == 2)
                global_geometry_list.elements[loop_index].Volume->geometry.mask_mode = 2;
            if (this_box_volume.geometry.mask_mode == 1) {
                if (global_geometry_list.elements[loop_index].Volume->geometry.is_masked_volume == 1 && global_geometry_list.elements[loop_index].Volume->geometry.mask_mode != 2)
                    // If more than one mask is added to one volume, the ANY mode overwrites the (default) ALL mode.
                    global_geometry_list.elements[loop_index].Volume->geometry.mask_mode = 1;
            }
            
            found_geometries = 1;
        }
    }
    if (found_geometries == 0) {
        printf("The mask_string in geometry: %s did not find any of the specified volumes in the mask_string %s \n",NAME_CURRENT_COMP,mask_string);
        exit(1);
    }
    this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
    this_box_volume.p_physics->is_vacuum = 0; // Makes this volume a vacuum
    this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
    this_box_volume.p_physics->my_a = 0; // Should not be used.
    sprintf(this_box_volume.p_physics->name,"Mask");
    this_box_volume.geometry.is_mask_volume = 1;
    
    
// Read the material input, or if it lacks, use automatic linking.
} else if (material_string && strlen(material_string) && strcmp(material_string, "NULL") && strcmp(material_string, "0")) {
    // A geometry string was given, use it to determine which material
    if (0 == strcmp(material_string,"vacuum") || 0 == strcmp(material_string,"Vacuum")) {
        // One could have a global physics struct for vacuum instead of creating one for each
        this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
        this_box_volume.p_physics->is_vacuum = 1; // Makes this volume a vacuum
        this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
        this_box_volume.p_physics->my_a = 0; // Should not be used.
        sprintf(this_box_volume.p_physics->name,"Vacuum");
    } else if (0 == strcmp(material_string,"exit") || 0 == strcmp(material_string,"Exit")) {
        // One could have a global physics struct for vacuum instead of creating one for each
        this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
        this_box_volume.p_physics->is_vacuum = 1; // Makes this volume a vacuum
        this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
        this_box_volume.p_physics->my_a = 0; // Should not be used.
        this_box_volume.geometry.is_exit_volume = 1;
        sprintf(this_box_volume.p_physics->name,"Exit");
    } else {
        #ifndef MATERIAL_DETECTOR
            printf("Need to define a material before refering to it in a geometry %s.\n",NAME_CURRENT_COMP);
            exit(1);
        #endif
        for (loop_index=0;loop_index<global_material_list.num_elements;loop_index++) {
            if (0 == strcmp(material_string,global_material_list.elements[loop_index].name)) {
                this_box_volume.p_physics = global_material_list.elements[loop_index].physics;
                break;
            }
            if (loop_index == global_material_list.num_elements-1) {
            printf("\n");
            printf("ERROR: The material string \"%s\" in Union geometry \"%s\" did not match a specified material. \n",material_string,NAME_CURRENT_COMP);
            printf("       The materials available at this point (need to be defined before the geometry): \n");
            for (loop_index=0;loop_index<global_material_list.num_elements;loop_index++)
              printf("         %s\n",global_material_list.elements[loop_index].name);
            printf("\n");
            printf("       It is also possible to use one of the defualt materials avaiable: \n");
            printf("           Vacuum (for a Volume without scattering or absorption)\n");
            printf("           Exit (for a Volume where the ray exits the component if it enters)\n");
            printf("           Mask (for a Volume that masks existing volumes specified in the mask_string\n");
            exit(1);
          }
        }
    }
} else {
    // Automatic linking, simply using the last defined material.
    #ifndef MATERIAL_DETECTOR
        printf("Need to define a material before the geometry to use automatic linking %s.\n",NAME_CURRENT_COMP);
        exit(1);
    #endif
    this_box_volume.p_physics = global_material_list.elements[global_material_list.num_elements-1].physics;
}

sprintf(this_box_volume.name,NAME_CURRENT_COMP);
sprintf(this_box_volume.geometry.shape,"box");
this_box_volume.geometry.priority_value = priority;
this_box_volume.geometry.geometry_p_interact = p_interact;
// Currently the coordinates will be in absolute space.
this_box_volume.geometry.center = POS_A_CURRENT_COMP;

this_box_storage.z_depth = zdepth;
this_box_storage.x_width1 = xwidth;
this_box_storage.y_height1 = yheight;

this_box_storage.is_rectangle = 0;
if (xwidth2 < 0 && yheight2 < 0) this_box_storage.is_rectangle = 1;
if (xwidth == xwidth2 && yheight == yheight2) this_box_storage.is_rectangle = 1;

if (xwidth2 < 0) {
    this_box_storage.x_width2 = xwidth;
    xwidth2 = xwidth;
} else this_box_storage.x_width2 = xwidth2;

if (yheight2 < 0) {
    this_box_storage.y_height2 = yheight;
    yheight2 = yheight;
} else this_box_storage.y_height2 = yheight2;


this_box_storage.normal_vectors[0] = coords_set(0,0,1);
this_box_storage.normal_vectors[1] = coords_set(0,0,1);

// for sides with y component = 0
x_component = 2*zdepth/sqrt((xwidth-xwidth2)*(xwidth-xwidth2)+4*zdepth*zdepth);
z_component = (xwidth-xwidth2)/sqrt(4*zdepth*zdepth+(xwidth-xwidth2)*(xwidth-xwidth2));

this_box_storage.normal_vectors[2] = coords_set(x_component,0,z_component);
this_box_storage.normal_vectors[3] = coords_set(-x_component,0,z_component);

// for sides with x component = 0
y_component = 2*zdepth/sqrt((yheight-yheight2)*(yheight-yheight2)+4*zdepth*zdepth);
z_component = (yheight-yheight2)/sqrt(4*zdepth*zdepth+(yheight-yheight2)*(yheight-yheight2));

this_box_storage.normal_vectors[4] = coords_set(0,y_component,z_component);
this_box_storage.normal_vectors[5] = coords_set(0,-y_component,z_component);

this_box_volume.geometry.visualization_on = visualize;

this_box_volume.geometry.geometry_parameters.p_box_storage = &this_box_storage;

// Assign pointers to functions for intersection with the shape, checking if a point is inside the shape
if (this_box_storage.is_rectangle == 1) {
this_box_volume.geometry.intersect_function = &sample_box_intersect_simple;
this_box_volume.geometry.within_function = &r_within_box_simple;
}
else {
this_box_volume.geometry.intersect_function = &sample_box_intersect_advanced;
this_box_volume.geometry.within_function = &r_within_box_advanced;
}

this_box_volume.geometry.shell_points = &box_shell_points;
this_box_volume.geometry.mcdisplay_function = &mcdisplay_box_function;
this_box_volume.geometry.initialize_from_main_function = &initialize_box_geometry_from_main_component;
this_box_volume.geometry.process_rot_allocated = 0;

this_box_volume.geometry.copy_geometry_parameters = &allocate_box_storage_copy;

rot_copy(this_box_volume.geometry.rotation_matrix,ROT_A_CURRENT_COMP); //check how ROT_R_CURRENT_COMP would work
rot_transpose(ROT_A_CURRENT_COMP,this_box_volume.geometry.transpose_rotation_matrix);

// Initialize loggers
this_box_volume.loggers.num_elements = 0;

// packing the information into the global_geometry_element, which is then included in the global_geometry_list.
sprintf(global_geometry_element.name,NAME_CURRENT_COMP);
global_geometry_element.activation_counter = number_of_activations;
global_geometry_element.component_index = INDEX_CURRENT_COMP;
global_geometry_element.Volume = &this_box_volume; // Would be nicer if this m was a pointer, now we have the (small) data two places
add_element_to_geometry_list(&global_geometry_list,global_geometry_element);
}
#line 235772 "MACS_sample_kidney_box.c"
#undef number_of_activations
#undef mask_setting
#undef mask_string
#undef p_interact
#undef focus_r
#undef focus_xh
#undef focus_xw
#undef focus_ah
#undef focus_aw
#undef target_z
#undef target_y
#undef target_x
#undef target_index
#undef visualize
#undef yheight2
#undef xwidth2
#undef zdepth
#undef yheight
#undef xwidth
#undef priority
#undef material_string
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

  /* Initializations for component channel_8_cave1_cyl1. */
  SIG_MESSAGE("channel_8_cave1_cyl1 (Init)");
#define mccompcurname  channel_8_cave1_cyl1
#define mccompcurtype  Union_cylinder
#define mccompcurindex 431
#define loop_index mccchannel_8_cave1_cyl1_loop_index
#define this_cylinder_volume mccchannel_8_cave1_cyl1_this_cylinder_volume
#define global_geometry_element mccchannel_8_cave1_cyl1_global_geometry_element
#define this_cylinder_storage mccchannel_8_cave1_cyl1_this_cylinder_storage
#define material_string mccchannel_8_cave1_cyl1_material_string
#define priority mccchannel_8_cave1_cyl1_priority
#define radius mccchannel_8_cave1_cyl1_radius
#define yheight mccchannel_8_cave1_cyl1_yheight
#define visualize mccchannel_8_cave1_cyl1_visualize
#define target_index mccchannel_8_cave1_cyl1_target_index
#define target_x mccchannel_8_cave1_cyl1_target_x
#define target_y mccchannel_8_cave1_cyl1_target_y
#define target_z mccchannel_8_cave1_cyl1_target_z
#define focus_aw mccchannel_8_cave1_cyl1_focus_aw
#define focus_ah mccchannel_8_cave1_cyl1_focus_ah
#define focus_xw mccchannel_8_cave1_cyl1_focus_xw
#define focus_xh mccchannel_8_cave1_cyl1_focus_xh
#define focus_r mccchannel_8_cave1_cyl1_focus_r
#define p_interact mccchannel_8_cave1_cyl1_p_interact
#define mask_string mccchannel_8_cave1_cyl1_mask_string
#define mask_setting mccchannel_8_cave1_cyl1_mask_setting
#define number_of_activations mccchannel_8_cave1_cyl1_number_of_activations
#line 185 "Union_cylinder.comp"
{
// Initializes the focusing system for this volume including input sanitation.
focus_initialize(&this_cylinder_volume.geometry, POS_A_COMP_INDEX(INDEX_CURRENT_COMP+target_index), POS_A_CURRENT_COMP, ROT_A_CURRENT_COMP, target_index, target_x, target_y, target_z, focus_aw, focus_ah, focus_xw, focus_xh, focus_r, NAME_CURRENT_COMP);

// Input sanitation for this geometry
if (radius <= 0) {
  printf("\nERROR in Union_cylinder named %s, the radius is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}

if (yheight <= 0) {
  printf("\nERROR in Union_cylinder named %s, yheight is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}

// Use sanitation
#ifdef MATERIAL_DETECTOR
if (global_material_list.num_elements == 0) {
  // Here if the user have defined a material, but only after this material
  printf("\nERROR: Need to define a material using Union_make_material before using a Union geometry component. \n");
  printf("       %s was defined before first use of Union_make_material.\n",NAME_CURRENT_COMP);
  exit(1);
}
#endif
#ifndef MATERIAL_DETECTOR
  printf("\nERROR: Need to define a material using Union_make_material before using a Union geometry component. \n");
  exit(1);
#endif


this_cylinder_volume.geometry.is_masked_volume = 0;
this_cylinder_volume.geometry.is_exit_volume = 0;
this_cylinder_volume.geometry.is_mask_volume = 0;

// Read the material input, or if it lacks, use automatic linking.
if (mask_string && strlen(mask_string) && strcmp(mask_string, "NULL") && strcmp(mask_string, "0")) {
    // A mask volume is used to limit the extend of other volumes, called the masked volumes. These are specified in the mask_string.
    // In order for a ray to enter a masked volume, it needs to be both in the region covered by that volume AND the mask volume.
    // When more than
    this_cylinder_volume.geometry.mask_mode = 1; // Default is mask mode is ALL
    if (mask_setting && strlen(mask_setting) && strcmp(mask_setting, "NULL") && strcmp(mask_setting, "0")) {
        if (strcmp(mask_setting,"ALL") == 0 || strcmp(mask_setting,"All") == 0) this_cylinder_volume.geometry.mask_mode = 1;
        else if (strcmp(mask_setting,"ANY") == 0 || strcmp(mask_setting,"Any") == 0) this_cylinder_volume.geometry.mask_mode = 2;
        else {
            printf("The mask_mode of component %s is set to %s, but must be either ALL or ANY.\n",NAME_CURRENT_COMP,mask_setting);
            exit(1);
        }
    }
    
    for (loop_index=0;loop_index<global_geometry_list.num_elements;loop_index++) {
        // Add mask list
        if (1 == manual_linking_function(global_geometry_list.elements[loop_index].name,mask_string)) {
            add_element_to_int_list(&this_cylinder_volume.geometry.mask_list,global_geometry_list.elements[loop_index].component_index);
            add_element_to_int_list(&global_geometry_list.elements[loop_index].Volume->geometry.masked_by_list,INDEX_CURRENT_COMP);
            global_geometry_list.elements[loop_index].Volume->geometry.is_masked_volume = 1;
            if (this_cylinder_volume.geometry.mask_mode == 2)
                global_geometry_list.elements[loop_index].Volume->geometry.mask_mode = 2;
            if (this_cylinder_volume.geometry.mask_mode == 1) {
                if (global_geometry_list.elements[loop_index].Volume->geometry.is_masked_volume == 1 && global_geometry_list.elements[loop_index].Volume->geometry.mask_mode != 2)
                    // If more than one mask is added to one volume, the ANY mode overwrites the (default) ALL mode.
                    global_geometry_list.elements[loop_index].Volume->geometry.mask_mode = 1;
            }
            
            found_geometries = 1;
        }
    }
    if (found_geometries == 0) {
        printf("The mask_string in geometry: %s did not find any of the specified volumes in the mask_string %s \n",NAME_CURRENT_COMP,mask_string);
        exit(1);
    }
    this_cylinder_volume.p_physics = malloc(sizeof(struct physics_struct));
    this_cylinder_volume.p_physics->is_vacuum = 0; // Makes this volume a vacuum
    this_cylinder_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
    this_cylinder_volume.p_physics->my_a = 0; // Should not be used.
    sprintf(this_cylinder_volume.p_physics->name,"Mask");
    this_cylinder_volume.geometry.is_mask_volume = 1;
    
    
// Read the material input, or if it lacks, use automatic linking.
} else if (material_string && strlen(material_string) && strcmp(material_string, "NULL") && strcmp(material_string, "0")) {
    // A geometry string was given, use it to determine which material
    if (0 == strcmp(material_string,"vacuum") || 0 == strcmp(material_string,"Vacuum")) {
        // One could have a global physics struct for vacuum instead of creating one for each
        this_cylinder_volume.p_physics = malloc(sizeof(struct physics_struct));
        this_cylinder_volume.p_physics->is_vacuum = 1; // Makes this volume a vacuum
        this_cylinder_volume.p_physics->number_of_processes = (int) 0;
        this_cylinder_volume.p_physics->my_a = 0; // Should not be used.
        sprintf(this_cylinder_volume.p_physics->name,"Vacuum");
    } else if (0 == strcmp(material_string,"exit") || 0 == strcmp(material_string,"Exit")) {
        // One could have a global physics struct for exit instead of creating one for each
        this_cylinder_volume.p_physics = malloc(sizeof(struct physics_struct));
        this_cylinder_volume.p_physics->is_vacuum = 1; // Makes this volume a vacuum
        this_cylinder_volume.p_physics->number_of_processes = (int) 0;
        this_cylinder_volume.p_physics->my_a = 0; // Should not be used.
        this_cylinder_volume.geometry.is_exit_volume = 1;
        sprintf(this_cylinder_volume.p_physics->name,"Exit");
    } else {
        for (loop_index=0;loop_index<global_material_list.num_elements;loop_index++) {
          if (0 == strcmp(material_string,global_material_list.elements[loop_index].name)) {
            this_cylinder_volume.p_physics = global_material_list.elements[loop_index].physics;
            break;
          }
          if (loop_index == global_material_list.num_elements-1) {
            printf("\n");
            printf("ERROR: The material string \"%s\" in Union geometry \"%s\" did not match a specified material. \n",material_string,NAME_CURRENT_COMP);
            printf("       The materials available at this point (need to be defined before the geometry): \n");
            for (loop_index=0;loop_index<global_material_list.num_elements;loop_index++)
              printf("         %s\n",global_material_list.elements[loop_index].name);
            printf("\n");
            printf("       It is also possible to use one of the defualt materials avaiable: \n");
            printf("           Vacuum (for a Volume without scattering or absorption)\n");
            printf("           Exit (for a Volume where the ray exits the component if it enters)\n");
            printf("           Mask (for a Volume that masks existing volumes specified in the mask_string\n");
            exit(1);
          }
        }
    }
} else {
    // Automatic linking, simply using the last defined material.
    #ifndef MATERIAL_DETECTOR
        printf("Need to define a material before the geometry to use automatic linking %s.\n",NAME_CURRENT_COMP);
        exit(1);
    #endif
    this_cylinder_volume.p_physics = global_material_list.elements[global_material_list.num_elements-1].physics;
}

sprintf(this_cylinder_volume.name,NAME_CURRENT_COMP);
sprintf(this_cylinder_volume.geometry.shape,"cylinder");
this_cylinder_volume.geometry.priority_value = priority;
// Currently the coordinates will be in absolute space.
this_cylinder_volume.geometry.center = POS_A_CURRENT_COMP;

this_cylinder_volume.geometry.geometry_p_interact = p_interact;
this_cylinder_storage.cyl_radius = radius;
this_cylinder_storage.height = yheight;
this_cylinder_volume.geometry.visualization_on = visualize;
this_cylinder_volume.geometry.geometry_parameters.p_cylinder_storage = &this_cylinder_storage;
this_cylinder_volume.geometry.within_function = &r_within_cylinder;
this_cylinder_volume.geometry.intersect_function = &sample_cylinder_intersect;
this_cylinder_volume.geometry.mcdisplay_function = &mcdisplay_cylinder_function;
this_cylinder_volume.geometry.shell_points = &cylinder_shell_points;
this_cylinder_volume.geometry.initialize_from_main_function = &initialize_cylinder_geometry_from_main_component;
this_cylinder_volume.geometry.process_rot_allocated = 0;
this_cylinder_volume.geometry.copy_geometry_parameters = &allocate_cylinder_storage_copy;

rot_copy(this_cylinder_volume.geometry.rotation_matrix,ROT_A_CURRENT_COMP);
rot_transpose(ROT_A_CURRENT_COMP,this_cylinder_volume.geometry.transpose_rotation_matrix);

// Initialize loggers
this_cylinder_volume.loggers.num_elements = 0;

// packing the information into the global_geometry_element, which is then included in the global_geometry_list.
sprintf(global_geometry_element.name,NAME_CURRENT_COMP);
global_geometry_element.activation_counter = number_of_activations;
global_geometry_element.component_index = INDEX_CURRENT_COMP;
global_geometry_element.Volume = &this_cylinder_volume; // Would be nicer if this m was a pointer, now we have the (small) data two places
add_element_to_geometry_list(&global_geometry_list,global_geometry_element);
}
#line 235988 "MACS_sample_kidney_box.c"
#undef number_of_activations
#undef mask_setting
#undef mask_string
#undef p_interact
#undef focus_r
#undef focus_xh
#undef focus_xw
#undef focus_ah
#undef focus_aw
#undef target_z
#undef target_y
#undef target_x
#undef target_index
#undef visualize
#undef yheight
#undef radius
#undef priority
#undef material_string
#undef this_cylinder_storage
#undef global_geometry_element
#undef this_cylinder_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

  /* Initializations for component channel_8_analyzer_1_center. */
  SIG_MESSAGE("channel_8_analyzer_1_center (Init)");

  /* Initializations for component channel_8_analyzer_1_rotated. */
  SIG_MESSAGE("channel_8_analyzer_1_rotated (Init)");

  /* Initializations for component channel_8_analyzer_1_array_crystal_array_0. */
  SIG_MESSAGE("channel_8_analyzer_1_array_crystal_array_0 (Init)");
#define mccompcurname  channel_8_analyzer_1_array_crystal_array_0
#define mccompcurtype  Union_box
#define mccompcurindex 434
#define loop_index mccchannel_8_analyzer_1_array_crystal_array_0_loop_index
#define this_box_volume mccchannel_8_analyzer_1_array_crystal_array_0_this_box_volume
#define global_geometry_element mccchannel_8_analyzer_1_array_crystal_array_0_global_geometry_element
#define this_box_storage mccchannel_8_analyzer_1_array_crystal_array_0_this_box_storage
#define material_string mccchannel_8_analyzer_1_array_crystal_array_0_material_string
#define priority mccchannel_8_analyzer_1_array_crystal_array_0_priority
#define xwidth mccchannel_8_analyzer_1_array_crystal_array_0_xwidth
#define yheight mccchannel_8_analyzer_1_array_crystal_array_0_yheight
#define zdepth mccchannel_8_analyzer_1_array_crystal_array_0_zdepth
#define xwidth2 mccchannel_8_analyzer_1_array_crystal_array_0_xwidth2
#define yheight2 mccchannel_8_analyzer_1_array_crystal_array_0_yheight2
#define visualize mccchannel_8_analyzer_1_array_crystal_array_0_visualize
#define target_index mccchannel_8_analyzer_1_array_crystal_array_0_target_index
#define target_x mccchannel_8_analyzer_1_array_crystal_array_0_target_x
#define target_y mccchannel_8_analyzer_1_array_crystal_array_0_target_y
#define target_z mccchannel_8_analyzer_1_array_crystal_array_0_target_z
#define focus_aw mccchannel_8_analyzer_1_array_crystal_array_0_focus_aw
#define focus_ah mccchannel_8_analyzer_1_array_crystal_array_0_focus_ah
#define focus_xw mccchannel_8_analyzer_1_array_crystal_array_0_focus_xw
#define focus_xh mccchannel_8_analyzer_1_array_crystal_array_0_focus_xh
#define focus_r mccchannel_8_analyzer_1_array_crystal_array_0_focus_r
#define p_interact mccchannel_8_analyzer_1_array_crystal_array_0_p_interact
#define mask_string mccchannel_8_analyzer_1_array_crystal_array_0_mask_string
#define mask_setting mccchannel_8_analyzer_1_array_crystal_array_0_mask_setting
#define number_of_activations mccchannel_8_analyzer_1_array_crystal_array_0_number_of_activations
#line 224 "Union_box.comp"
{
// Initializes the focusing system for this volume including input sanitation.
focus_initialize(&this_box_volume.geometry, POS_A_COMP_INDEX(INDEX_CURRENT_COMP+target_index), POS_A_CURRENT_COMP, ROT_A_CURRENT_COMP, target_index, target_x, target_y, target_z, focus_aw, focus_ah, focus_xw, focus_xh, focus_r, NAME_CURRENT_COMP);

// Input sanitation for this geometry
if (xwidth <= 0) {
  printf("\nERROR in Union_box named %s, the xwidth is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (yheight <= 0) {
  printf("\nERROR in Union_box named %s, yheight is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (zdepth <= 0) {
  printf("\nERROR in Union_box named %s, zdepth is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (xwidth2 <= 0 && xwidth2 != -1) {
  printf("\nERROR in Union_box named %s, the xwidth2 is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (yheight2 <= 0 && yheight2 != -1) {
  printf("\nERROR in Union_box named %s, yheight2 is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}

// Use sanitation
if (global_material_list.num_elements == 0) {
  printf("\nERROR: Need to define a material using Union_make_material before using a Union geometry component. \n");
  printf("       %s was defined before first use of Union_make_material.\n",NAME_CURRENT_COMP);
  exit(1);
}

this_box_volume.geometry.is_masked_volume = 0;
this_box_volume.geometry.is_exit_volume = 0;
this_box_volume.geometry.is_mask_volume = 0;
// check if the volume is a mask, if it is the material string is irelevant.
if (mask_string && strlen(mask_string) && strcmp(mask_string, "NULL") && strcmp(mask_string, "0")) {
    // A mask volume is used to limit the extend of other volumes, called the masked volumes. These are specified in the mask_string.
    // In order for a ray to enter a masked volume, it needs to be both in the region covered by that volume AND the mask volume.
    // When more than
    this_box_volume.geometry.mask_mode = 1; // Default is mask mode is ALL
    if (mask_setting && strlen(mask_setting) && strcmp(mask_setting, "NULL") && strcmp(mask_setting, "0")) {
        if (strcmp(mask_setting,"ALL") == 0 || strcmp(mask_setting,"All") == 0) this_box_volume.geometry.mask_mode = 1;
        else if (strcmp(mask_setting,"ANY") == 0 || strcmp(mask_setting,"Any") == 0) this_box_volume.geometry.mask_mode = 2;
        else {
            printf("The mask_mode of component %s is set to %s, but must be either ALL or ANY.\n",NAME_CURRENT_COMP,mask_setting);
            exit(1);
        }
    }
    
    for (loop_index=0;loop_index<global_geometry_list.num_elements;loop_index++) {
        // Add mask list
        if (1 == manual_linking_function(global_geometry_list.elements[loop_index].name,mask_string)) {
            add_element_to_int_list(&this_box_volume.geometry.mask_list,global_geometry_list.elements[loop_index].component_index);
            add_element_to_int_list(&global_geometry_list.elements[loop_index].Volume->geometry.masked_by_list,INDEX_CURRENT_COMP);
            global_geometry_list.elements[loop_index].Volume->geometry.is_masked_volume = 1;
            if (this_box_volume.geometry.mask_mode == 2)
                global_geometry_list.elements[loop_index].Volume->geometry.mask_mode = 2;
            if (this_box_volume.geometry.mask_mode == 1) {
                if (global_geometry_list.elements[loop_index].Volume->geometry.is_masked_volume == 1 && global_geometry_list.elements[loop_index].Volume->geometry.mask_mode != 2)
                    // If more than one mask is added to one volume, the ANY mode overwrites the (default) ALL mode.
                    global_geometry_list.elements[loop_index].Volume->geometry.mask_mode = 1;
            }
            
            found_geometries = 1;
        }
    }
    if (found_geometries == 0) {
        printf("The mask_string in geometry: %s did not find any of the specified volumes in the mask_string %s \n",NAME_CURRENT_COMP,mask_string);
        exit(1);
    }
    this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
    this_box_volume.p_physics->is_vacuum = 0; // Makes this volume a vacuum
    this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
    this_box_volume.p_physics->my_a = 0; // Should not be used.
    sprintf(this_box_volume.p_physics->name,"Mask");
    this_box_volume.geometry.is_mask_volume = 1;
    
    
// Read the material input, or if it lacks, use automatic linking.
} else if (material_string && strlen(material_string) && strcmp(material_string, "NULL") && strcmp(material_string, "0")) {
    // A geometry string was given, use it to determine which material
    if (0 == strcmp(material_string,"vacuum") || 0 == strcmp(material_string,"Vacuum")) {
        // One could have a global physics struct for vacuum instead of creating one for each
        this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
        this_box_volume.p_physics->is_vacuum = 1; // Makes this volume a vacuum
        this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
        this_box_volume.p_physics->my_a = 0; // Should not be used.
        sprintf(this_box_volume.p_physics->name,"Vacuum");
    } else if (0 == strcmp(material_string,"exit") || 0 == strcmp(material_string,"Exit")) {
        // One could have a global physics struct for vacuum instead of creating one for each
        this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
        this_box_volume.p_physics->is_vacuum = 1; // Makes this volume a vacuum
        this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
        this_box_volume.p_physics->my_a = 0; // Should not be used.
        this_box_volume.geometry.is_exit_volume = 1;
        sprintf(this_box_volume.p_physics->name,"Exit");
    } else {
        #ifndef MATERIAL_DETECTOR
            printf("Need to define a material before refering to it in a geometry %s.\n",NAME_CURRENT_COMP);
            exit(1);
        #endif
        for (loop_index=0;loop_index<global_material_list.num_elements;loop_index++) {
            if (0 == strcmp(material_string,global_material_list.elements[loop_index].name)) {
                this_box_volume.p_physics = global_material_list.elements[loop_index].physics;
                break;
            }
            if (loop_index == global_material_list.num_elements-1) {
            printf("\n");
            printf("ERROR: The material string \"%s\" in Union geometry \"%s\" did not match a specified material. \n",material_string,NAME_CURRENT_COMP);
            printf("       The materials available at this point (need to be defined before the geometry): \n");
            for (loop_index=0;loop_index<global_material_list.num_elements;loop_index++)
              printf("         %s\n",global_material_list.elements[loop_index].name);
            printf("\n");
            printf("       It is also possible to use one of the defualt materials avaiable: \n");
            printf("           Vacuum (for a Volume without scattering or absorption)\n");
            printf("           Exit (for a Volume where the ray exits the component if it enters)\n");
            printf("           Mask (for a Volume that masks existing volumes specified in the mask_string\n");
            exit(1);
          }
        }
    }
} else {
    // Automatic linking, simply using the last defined material.
    #ifndef MATERIAL_DETECTOR
        printf("Need to define a material before the geometry to use automatic linking %s.\n",NAME_CURRENT_COMP);
        exit(1);
    #endif
    this_box_volume.p_physics = global_material_list.elements[global_material_list.num_elements-1].physics;
}

sprintf(this_box_volume.name,NAME_CURRENT_COMP);
sprintf(this_box_volume.geometry.shape,"box");
this_box_volume.geometry.priority_value = priority;
this_box_volume.geometry.geometry_p_interact = p_interact;
// Currently the coordinates will be in absolute space.
this_box_volume.geometry.center = POS_A_CURRENT_COMP;

this_box_storage.z_depth = zdepth;
this_box_storage.x_width1 = xwidth;
this_box_storage.y_height1 = yheight;

this_box_storage.is_rectangle = 0;
if (xwidth2 < 0 && yheight2 < 0) this_box_storage.is_rectangle = 1;
if (xwidth == xwidth2 && yheight == yheight2) this_box_storage.is_rectangle = 1;

if (xwidth2 < 0) {
    this_box_storage.x_width2 = xwidth;
    xwidth2 = xwidth;
} else this_box_storage.x_width2 = xwidth2;

if (yheight2 < 0) {
    this_box_storage.y_height2 = yheight;
    yheight2 = yheight;
} else this_box_storage.y_height2 = yheight2;


this_box_storage.normal_vectors[0] = coords_set(0,0,1);
this_box_storage.normal_vectors[1] = coords_set(0,0,1);

// for sides with y component = 0
x_component = 2*zdepth/sqrt((xwidth-xwidth2)*(xwidth-xwidth2)+4*zdepth*zdepth);
z_component = (xwidth-xwidth2)/sqrt(4*zdepth*zdepth+(xwidth-xwidth2)*(xwidth-xwidth2));

this_box_storage.normal_vectors[2] = coords_set(x_component,0,z_component);
this_box_storage.normal_vectors[3] = coords_set(-x_component,0,z_component);

// for sides with x component = 0
y_component = 2*zdepth/sqrt((yheight-yheight2)*(yheight-yheight2)+4*zdepth*zdepth);
z_component = (yheight-yheight2)/sqrt(4*zdepth*zdepth+(yheight-yheight2)*(yheight-yheight2));

this_box_storage.normal_vectors[4] = coords_set(0,y_component,z_component);
this_box_storage.normal_vectors[5] = coords_set(0,-y_component,z_component);

this_box_volume.geometry.visualization_on = visualize;

this_box_volume.geometry.geometry_parameters.p_box_storage = &this_box_storage;

// Assign pointers to functions for intersection with the shape, checking if a point is inside the shape
if (this_box_storage.is_rectangle == 1) {
this_box_volume.geometry.intersect_function = &sample_box_intersect_simple;
this_box_volume.geometry.within_function = &r_within_box_simple;
}
else {
this_box_volume.geometry.intersect_function = &sample_box_intersect_advanced;
this_box_volume.geometry.within_function = &r_within_box_advanced;
}

this_box_volume.geometry.shell_points = &box_shell_points;
this_box_volume.geometry.mcdisplay_function = &mcdisplay_box_function;
this_box_volume.geometry.initialize_from_main_function = &initialize_box_geometry_from_main_component;
this_box_volume.geometry.process_rot_allocated = 0;

this_box_volume.geometry.copy_geometry_parameters = &allocate_box_storage_copy;

rot_copy(this_box_volume.geometry.rotation_matrix,ROT_A_CURRENT_COMP); //check how ROT_R_CURRENT_COMP would work
rot_transpose(ROT_A_CURRENT_COMP,this_box_volume.geometry.transpose_rotation_matrix);

// Initialize loggers
this_box_volume.loggers.num_elements = 0;

// packing the information into the global_geometry_element, which is then included in the global_geometry_list.
sprintf(global_geometry_element.name,NAME_CURRENT_COMP);
global_geometry_element.activation_counter = number_of_activations;
global_geometry_element.component_index = INDEX_CURRENT_COMP;
global_geometry_element.Volume = &this_box_volume; // Would be nicer if this m was a pointer, now we have the (small) data two places
add_element_to_geometry_list(&global_geometry_list,global_geometry_element);
}
#line 236261 "MACS_sample_kidney_box.c"
#undef number_of_activations
#undef mask_setting
#undef mask_string
#undef p_interact
#undef focus_r
#undef focus_xh
#undef focus_xw
#undef focus_ah
#undef focus_aw
#undef target_z
#undef target_y
#undef target_x
#undef target_index
#undef visualize
#undef yheight2
#undef xwidth2
#undef zdepth
#undef yheight
#undef xwidth
#undef priority
#undef material_string
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

  /* Initializations for component channel_8_analyzer_1_array_crystal_array_1. */
  SIG_MESSAGE("channel_8_analyzer_1_array_crystal_array_1 (Init)");
#define mccompcurname  channel_8_analyzer_1_array_crystal_array_1
#define mccompcurtype  Union_box
#define mccompcurindex 435
#define loop_index mccchannel_8_analyzer_1_array_crystal_array_1_loop_index
#define this_box_volume mccchannel_8_analyzer_1_array_crystal_array_1_this_box_volume
#define global_geometry_element mccchannel_8_analyzer_1_array_crystal_array_1_global_geometry_element
#define this_box_storage mccchannel_8_analyzer_1_array_crystal_array_1_this_box_storage
#define material_string mccchannel_8_analyzer_1_array_crystal_array_1_material_string
#define priority mccchannel_8_analyzer_1_array_crystal_array_1_priority
#define xwidth mccchannel_8_analyzer_1_array_crystal_array_1_xwidth
#define yheight mccchannel_8_analyzer_1_array_crystal_array_1_yheight
#define zdepth mccchannel_8_analyzer_1_array_crystal_array_1_zdepth
#define xwidth2 mccchannel_8_analyzer_1_array_crystal_array_1_xwidth2
#define yheight2 mccchannel_8_analyzer_1_array_crystal_array_1_yheight2
#define visualize mccchannel_8_analyzer_1_array_crystal_array_1_visualize
#define target_index mccchannel_8_analyzer_1_array_crystal_array_1_target_index
#define target_x mccchannel_8_analyzer_1_array_crystal_array_1_target_x
#define target_y mccchannel_8_analyzer_1_array_crystal_array_1_target_y
#define target_z mccchannel_8_analyzer_1_array_crystal_array_1_target_z
#define focus_aw mccchannel_8_analyzer_1_array_crystal_array_1_focus_aw
#define focus_ah mccchannel_8_analyzer_1_array_crystal_array_1_focus_ah
#define focus_xw mccchannel_8_analyzer_1_array_crystal_array_1_focus_xw
#define focus_xh mccchannel_8_analyzer_1_array_crystal_array_1_focus_xh
#define focus_r mccchannel_8_analyzer_1_array_crystal_array_1_focus_r
#define p_interact mccchannel_8_analyzer_1_array_crystal_array_1_p_interact
#define mask_string mccchannel_8_analyzer_1_array_crystal_array_1_mask_string
#define mask_setting mccchannel_8_analyzer_1_array_crystal_array_1_mask_setting
#define number_of_activations mccchannel_8_analyzer_1_array_crystal_array_1_number_of_activations
#line 224 "Union_box.comp"
{
// Initializes the focusing system for this volume including input sanitation.
focus_initialize(&this_box_volume.geometry, POS_A_COMP_INDEX(INDEX_CURRENT_COMP+target_index), POS_A_CURRENT_COMP, ROT_A_CURRENT_COMP, target_index, target_x, target_y, target_z, focus_aw, focus_ah, focus_xw, focus_xh, focus_r, NAME_CURRENT_COMP);

// Input sanitation for this geometry
if (xwidth <= 0) {
  printf("\nERROR in Union_box named %s, the xwidth is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (yheight <= 0) {
  printf("\nERROR in Union_box named %s, yheight is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (zdepth <= 0) {
  printf("\nERROR in Union_box named %s, zdepth is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (xwidth2 <= 0 && xwidth2 != -1) {
  printf("\nERROR in Union_box named %s, the xwidth2 is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (yheight2 <= 0 && yheight2 != -1) {
  printf("\nERROR in Union_box named %s, yheight2 is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}

// Use sanitation
if (global_material_list.num_elements == 0) {
  printf("\nERROR: Need to define a material using Union_make_material before using a Union geometry component. \n");
  printf("       %s was defined before first use of Union_make_material.\n",NAME_CURRENT_COMP);
  exit(1);
}

this_box_volume.geometry.is_masked_volume = 0;
this_box_volume.geometry.is_exit_volume = 0;
this_box_volume.geometry.is_mask_volume = 0;
// check if the volume is a mask, if it is the material string is irelevant.
if (mask_string && strlen(mask_string) && strcmp(mask_string, "NULL") && strcmp(mask_string, "0")) {
    // A mask volume is used to limit the extend of other volumes, called the masked volumes. These are specified in the mask_string.
    // In order for a ray to enter a masked volume, it needs to be both in the region covered by that volume AND the mask volume.
    // When more than
    this_box_volume.geometry.mask_mode = 1; // Default is mask mode is ALL
    if (mask_setting && strlen(mask_setting) && strcmp(mask_setting, "NULL") && strcmp(mask_setting, "0")) {
        if (strcmp(mask_setting,"ALL") == 0 || strcmp(mask_setting,"All") == 0) this_box_volume.geometry.mask_mode = 1;
        else if (strcmp(mask_setting,"ANY") == 0 || strcmp(mask_setting,"Any") == 0) this_box_volume.geometry.mask_mode = 2;
        else {
            printf("The mask_mode of component %s is set to %s, but must be either ALL or ANY.\n",NAME_CURRENT_COMP,mask_setting);
            exit(1);
        }
    }
    
    for (loop_index=0;loop_index<global_geometry_list.num_elements;loop_index++) {
        // Add mask list
        if (1 == manual_linking_function(global_geometry_list.elements[loop_index].name,mask_string)) {
            add_element_to_int_list(&this_box_volume.geometry.mask_list,global_geometry_list.elements[loop_index].component_index);
            add_element_to_int_list(&global_geometry_list.elements[loop_index].Volume->geometry.masked_by_list,INDEX_CURRENT_COMP);
            global_geometry_list.elements[loop_index].Volume->geometry.is_masked_volume = 1;
            if (this_box_volume.geometry.mask_mode == 2)
                global_geometry_list.elements[loop_index].Volume->geometry.mask_mode = 2;
            if (this_box_volume.geometry.mask_mode == 1) {
                if (global_geometry_list.elements[loop_index].Volume->geometry.is_masked_volume == 1 && global_geometry_list.elements[loop_index].Volume->geometry.mask_mode != 2)
                    // If more than one mask is added to one volume, the ANY mode overwrites the (default) ALL mode.
                    global_geometry_list.elements[loop_index].Volume->geometry.mask_mode = 1;
            }
            
            found_geometries = 1;
        }
    }
    if (found_geometries == 0) {
        printf("The mask_string in geometry: %s did not find any of the specified volumes in the mask_string %s \n",NAME_CURRENT_COMP,mask_string);
        exit(1);
    }
    this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
    this_box_volume.p_physics->is_vacuum = 0; // Makes this volume a vacuum
    this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
    this_box_volume.p_physics->my_a = 0; // Should not be used.
    sprintf(this_box_volume.p_physics->name,"Mask");
    this_box_volume.geometry.is_mask_volume = 1;
    
    
// Read the material input, or if it lacks, use automatic linking.
} else if (material_string && strlen(material_string) && strcmp(material_string, "NULL") && strcmp(material_string, "0")) {
    // A geometry string was given, use it to determine which material
    if (0 == strcmp(material_string,"vacuum") || 0 == strcmp(material_string,"Vacuum")) {
        // One could have a global physics struct for vacuum instead of creating one for each
        this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
        this_box_volume.p_physics->is_vacuum = 1; // Makes this volume a vacuum
        this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
        this_box_volume.p_physics->my_a = 0; // Should not be used.
        sprintf(this_box_volume.p_physics->name,"Vacuum");
    } else if (0 == strcmp(material_string,"exit") || 0 == strcmp(material_string,"Exit")) {
        // One could have a global physics struct for vacuum instead of creating one for each
        this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
        this_box_volume.p_physics->is_vacuum = 1; // Makes this volume a vacuum
        this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
        this_box_volume.p_physics->my_a = 0; // Should not be used.
        this_box_volume.geometry.is_exit_volume = 1;
        sprintf(this_box_volume.p_physics->name,"Exit");
    } else {
        #ifndef MATERIAL_DETECTOR
            printf("Need to define a material before refering to it in a geometry %s.\n",NAME_CURRENT_COMP);
            exit(1);
        #endif
        for (loop_index=0;loop_index<global_material_list.num_elements;loop_index++) {
            if (0 == strcmp(material_string,global_material_list.elements[loop_index].name)) {
                this_box_volume.p_physics = global_material_list.elements[loop_index].physics;
                break;
            }
            if (loop_index == global_material_list.num_elements-1) {
            printf("\n");
            printf("ERROR: The material string \"%s\" in Union geometry \"%s\" did not match a specified material. \n",material_string,NAME_CURRENT_COMP);
            printf("       The materials available at this point (need to be defined before the geometry): \n");
            for (loop_index=0;loop_index<global_material_list.num_elements;loop_index++)
              printf("         %s\n",global_material_list.elements[loop_index].name);
            printf("\n");
            printf("       It is also possible to use one of the defualt materials avaiable: \n");
            printf("           Vacuum (for a Volume without scattering or absorption)\n");
            printf("           Exit (for a Volume where the ray exits the component if it enters)\n");
            printf("           Mask (for a Volume that masks existing volumes specified in the mask_string\n");
            exit(1);
          }
        }
    }
} else {
    // Automatic linking, simply using the last defined material.
    #ifndef MATERIAL_DETECTOR
        printf("Need to define a material before the geometry to use automatic linking %s.\n",NAME_CURRENT_COMP);
        exit(1);
    #endif
    this_box_volume.p_physics = global_material_list.elements[global_material_list.num_elements-1].physics;
}

sprintf(this_box_volume.name,NAME_CURRENT_COMP);
sprintf(this_box_volume.geometry.shape,"box");
this_box_volume.geometry.priority_value = priority;
this_box_volume.geometry.geometry_p_interact = p_interact;
// Currently the coordinates will be in absolute space.
this_box_volume.geometry.center = POS_A_CURRENT_COMP;

this_box_storage.z_depth = zdepth;
this_box_storage.x_width1 = xwidth;
this_box_storage.y_height1 = yheight;

this_box_storage.is_rectangle = 0;
if (xwidth2 < 0 && yheight2 < 0) this_box_storage.is_rectangle = 1;
if (xwidth == xwidth2 && yheight == yheight2) this_box_storage.is_rectangle = 1;

if (xwidth2 < 0) {
    this_box_storage.x_width2 = xwidth;
    xwidth2 = xwidth;
} else this_box_storage.x_width2 = xwidth2;

if (yheight2 < 0) {
    this_box_storage.y_height2 = yheight;
    yheight2 = yheight;
} else this_box_storage.y_height2 = yheight2;


this_box_storage.normal_vectors[0] = coords_set(0,0,1);
this_box_storage.normal_vectors[1] = coords_set(0,0,1);

// for sides with y component = 0
x_component = 2*zdepth/sqrt((xwidth-xwidth2)*(xwidth-xwidth2)+4*zdepth*zdepth);
z_component = (xwidth-xwidth2)/sqrt(4*zdepth*zdepth+(xwidth-xwidth2)*(xwidth-xwidth2));

this_box_storage.normal_vectors[2] = coords_set(x_component,0,z_component);
this_box_storage.normal_vectors[3] = coords_set(-x_component,0,z_component);

// for sides with x component = 0
y_component = 2*zdepth/sqrt((yheight-yheight2)*(yheight-yheight2)+4*zdepth*zdepth);
z_component = (yheight-yheight2)/sqrt(4*zdepth*zdepth+(yheight-yheight2)*(yheight-yheight2));

this_box_storage.normal_vectors[4] = coords_set(0,y_component,z_component);
this_box_storage.normal_vectors[5] = coords_set(0,-y_component,z_component);

this_box_volume.geometry.visualization_on = visualize;

this_box_volume.geometry.geometry_parameters.p_box_storage = &this_box_storage;

// Assign pointers to functions for intersection with the shape, checking if a point is inside the shape
if (this_box_storage.is_rectangle == 1) {
this_box_volume.geometry.intersect_function = &sample_box_intersect_simple;
this_box_volume.geometry.within_function = &r_within_box_simple;
}
else {
this_box_volume.geometry.intersect_function = &sample_box_intersect_advanced;
this_box_volume.geometry.within_function = &r_within_box_advanced;
}

this_box_volume.geometry.shell_points = &box_shell_points;
this_box_volume.geometry.mcdisplay_function = &mcdisplay_box_function;
this_box_volume.geometry.initialize_from_main_function = &initialize_box_geometry_from_main_component;
this_box_volume.geometry.process_rot_allocated = 0;

this_box_volume.geometry.copy_geometry_parameters = &allocate_box_storage_copy;

rot_copy(this_box_volume.geometry.rotation_matrix,ROT_A_CURRENT_COMP); //check how ROT_R_CURRENT_COMP would work
rot_transpose(ROT_A_CURRENT_COMP,this_box_volume.geometry.transpose_rotation_matrix);

// Initialize loggers
this_box_volume.loggers.num_elements = 0;

// packing the information into the global_geometry_element, which is then included in the global_geometry_list.
sprintf(global_geometry_element.name,NAME_CURRENT_COMP);
global_geometry_element.activation_counter = number_of_activations;
global_geometry_element.component_index = INDEX_CURRENT_COMP;
global_geometry_element.Volume = &this_box_volume; // Would be nicer if this m was a pointer, now we have the (small) data two places
add_element_to_geometry_list(&global_geometry_list,global_geometry_element);
}
#line 236531 "MACS_sample_kidney_box.c"
#undef number_of_activations
#undef mask_setting
#undef mask_string
#undef p_interact
#undef focus_r
#undef focus_xh
#undef focus_xw
#undef focus_ah
#undef focus_aw
#undef target_z
#undef target_y
#undef target_x
#undef target_index
#undef visualize
#undef yheight2
#undef xwidth2
#undef zdepth
#undef yheight
#undef xwidth
#undef priority
#undef material_string
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

  /* Initializations for component channel_8_analyzer_1_array_crystal_array_2. */
  SIG_MESSAGE("channel_8_analyzer_1_array_crystal_array_2 (Init)");
#define mccompcurname  channel_8_analyzer_1_array_crystal_array_2
#define mccompcurtype  Union_box
#define mccompcurindex 436
#define loop_index mccchannel_8_analyzer_1_array_crystal_array_2_loop_index
#define this_box_volume mccchannel_8_analyzer_1_array_crystal_array_2_this_box_volume
#define global_geometry_element mccchannel_8_analyzer_1_array_crystal_array_2_global_geometry_element
#define this_box_storage mccchannel_8_analyzer_1_array_crystal_array_2_this_box_storage
#define material_string mccchannel_8_analyzer_1_array_crystal_array_2_material_string
#define priority mccchannel_8_analyzer_1_array_crystal_array_2_priority
#define xwidth mccchannel_8_analyzer_1_array_crystal_array_2_xwidth
#define yheight mccchannel_8_analyzer_1_array_crystal_array_2_yheight
#define zdepth mccchannel_8_analyzer_1_array_crystal_array_2_zdepth
#define xwidth2 mccchannel_8_analyzer_1_array_crystal_array_2_xwidth2
#define yheight2 mccchannel_8_analyzer_1_array_crystal_array_2_yheight2
#define visualize mccchannel_8_analyzer_1_array_crystal_array_2_visualize
#define target_index mccchannel_8_analyzer_1_array_crystal_array_2_target_index
#define target_x mccchannel_8_analyzer_1_array_crystal_array_2_target_x
#define target_y mccchannel_8_analyzer_1_array_crystal_array_2_target_y
#define target_z mccchannel_8_analyzer_1_array_crystal_array_2_target_z
#define focus_aw mccchannel_8_analyzer_1_array_crystal_array_2_focus_aw
#define focus_ah mccchannel_8_analyzer_1_array_crystal_array_2_focus_ah
#define focus_xw mccchannel_8_analyzer_1_array_crystal_array_2_focus_xw
#define focus_xh mccchannel_8_analyzer_1_array_crystal_array_2_focus_xh
#define focus_r mccchannel_8_analyzer_1_array_crystal_array_2_focus_r
#define p_interact mccchannel_8_analyzer_1_array_crystal_array_2_p_interact
#define mask_string mccchannel_8_analyzer_1_array_crystal_array_2_mask_string
#define mask_setting mccchannel_8_analyzer_1_array_crystal_array_2_mask_setting
#define number_of_activations mccchannel_8_analyzer_1_array_crystal_array_2_number_of_activations
#line 224 "Union_box.comp"
{
// Initializes the focusing system for this volume including input sanitation.
focus_initialize(&this_box_volume.geometry, POS_A_COMP_INDEX(INDEX_CURRENT_COMP+target_index), POS_A_CURRENT_COMP, ROT_A_CURRENT_COMP, target_index, target_x, target_y, target_z, focus_aw, focus_ah, focus_xw, focus_xh, focus_r, NAME_CURRENT_COMP);

// Input sanitation for this geometry
if (xwidth <= 0) {
  printf("\nERROR in Union_box named %s, the xwidth is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (yheight <= 0) {
  printf("\nERROR in Union_box named %s, yheight is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (zdepth <= 0) {
  printf("\nERROR in Union_box named %s, zdepth is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (xwidth2 <= 0 && xwidth2 != -1) {
  printf("\nERROR in Union_box named %s, the xwidth2 is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (yheight2 <= 0 && yheight2 != -1) {
  printf("\nERROR in Union_box named %s, yheight2 is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}

// Use sanitation
if (global_material_list.num_elements == 0) {
  printf("\nERROR: Need to define a material using Union_make_material before using a Union geometry component. \n");
  printf("       %s was defined before first use of Union_make_material.\n",NAME_CURRENT_COMP);
  exit(1);
}

this_box_volume.geometry.is_masked_volume = 0;
this_box_volume.geometry.is_exit_volume = 0;
this_box_volume.geometry.is_mask_volume = 0;
// check if the volume is a mask, if it is the material string is irelevant.
if (mask_string && strlen(mask_string) && strcmp(mask_string, "NULL") && strcmp(mask_string, "0")) {
    // A mask volume is used to limit the extend of other volumes, called the masked volumes. These are specified in the mask_string.
    // In order for a ray to enter a masked volume, it needs to be both in the region covered by that volume AND the mask volume.
    // When more than
    this_box_volume.geometry.mask_mode = 1; // Default is mask mode is ALL
    if (mask_setting && strlen(mask_setting) && strcmp(mask_setting, "NULL") && strcmp(mask_setting, "0")) {
        if (strcmp(mask_setting,"ALL") == 0 || strcmp(mask_setting,"All") == 0) this_box_volume.geometry.mask_mode = 1;
        else if (strcmp(mask_setting,"ANY") == 0 || strcmp(mask_setting,"Any") == 0) this_box_volume.geometry.mask_mode = 2;
        else {
            printf("The mask_mode of component %s is set to %s, but must be either ALL or ANY.\n",NAME_CURRENT_COMP,mask_setting);
            exit(1);
        }
    }
    
    for (loop_index=0;loop_index<global_geometry_list.num_elements;loop_index++) {
        // Add mask list
        if (1 == manual_linking_function(global_geometry_list.elements[loop_index].name,mask_string)) {
            add_element_to_int_list(&this_box_volume.geometry.mask_list,global_geometry_list.elements[loop_index].component_index);
            add_element_to_int_list(&global_geometry_list.elements[loop_index].Volume->geometry.masked_by_list,INDEX_CURRENT_COMP);
            global_geometry_list.elements[loop_index].Volume->geometry.is_masked_volume = 1;
            if (this_box_volume.geometry.mask_mode == 2)
                global_geometry_list.elements[loop_index].Volume->geometry.mask_mode = 2;
            if (this_box_volume.geometry.mask_mode == 1) {
                if (global_geometry_list.elements[loop_index].Volume->geometry.is_masked_volume == 1 && global_geometry_list.elements[loop_index].Volume->geometry.mask_mode != 2)
                    // If more than one mask is added to one volume, the ANY mode overwrites the (default) ALL mode.
                    global_geometry_list.elements[loop_index].Volume->geometry.mask_mode = 1;
            }
            
            found_geometries = 1;
        }
    }
    if (found_geometries == 0) {
        printf("The mask_string in geometry: %s did not find any of the specified volumes in the mask_string %s \n",NAME_CURRENT_COMP,mask_string);
        exit(1);
    }
    this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
    this_box_volume.p_physics->is_vacuum = 0; // Makes this volume a vacuum
    this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
    this_box_volume.p_physics->my_a = 0; // Should not be used.
    sprintf(this_box_volume.p_physics->name,"Mask");
    this_box_volume.geometry.is_mask_volume = 1;
    
    
// Read the material input, or if it lacks, use automatic linking.
} else if (material_string && strlen(material_string) && strcmp(material_string, "NULL") && strcmp(material_string, "0")) {
    // A geometry string was given, use it to determine which material
    if (0 == strcmp(material_string,"vacuum") || 0 == strcmp(material_string,"Vacuum")) {
        // One could have a global physics struct for vacuum instead of creating one for each
        this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
        this_box_volume.p_physics->is_vacuum = 1; // Makes this volume a vacuum
        this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
        this_box_volume.p_physics->my_a = 0; // Should not be used.
        sprintf(this_box_volume.p_physics->name,"Vacuum");
    } else if (0 == strcmp(material_string,"exit") || 0 == strcmp(material_string,"Exit")) {
        // One could have a global physics struct for vacuum instead of creating one for each
        this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
        this_box_volume.p_physics->is_vacuum = 1; // Makes this volume a vacuum
        this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
        this_box_volume.p_physics->my_a = 0; // Should not be used.
        this_box_volume.geometry.is_exit_volume = 1;
        sprintf(this_box_volume.p_physics->name,"Exit");
    } else {
        #ifndef MATERIAL_DETECTOR
            printf("Need to define a material before refering to it in a geometry %s.\n",NAME_CURRENT_COMP);
            exit(1);
        #endif
        for (loop_index=0;loop_index<global_material_list.num_elements;loop_index++) {
            if (0 == strcmp(material_string,global_material_list.elements[loop_index].name)) {
                this_box_volume.p_physics = global_material_list.elements[loop_index].physics;
                break;
            }
            if (loop_index == global_material_list.num_elements-1) {
            printf("\n");
            printf("ERROR: The material string \"%s\" in Union geometry \"%s\" did not match a specified material. \n",material_string,NAME_CURRENT_COMP);
            printf("       The materials available at this point (need to be defined before the geometry): \n");
            for (loop_index=0;loop_index<global_material_list.num_elements;loop_index++)
              printf("         %s\n",global_material_list.elements[loop_index].name);
            printf("\n");
            printf("       It is also possible to use one of the defualt materials avaiable: \n");
            printf("           Vacuum (for a Volume without scattering or absorption)\n");
            printf("           Exit (for a Volume where the ray exits the component if it enters)\n");
            printf("           Mask (for a Volume that masks existing volumes specified in the mask_string\n");
            exit(1);
          }
        }
    }
} else {
    // Automatic linking, simply using the last defined material.
    #ifndef MATERIAL_DETECTOR
        printf("Need to define a material before the geometry to use automatic linking %s.\n",NAME_CURRENT_COMP);
        exit(1);
    #endif
    this_box_volume.p_physics = global_material_list.elements[global_material_list.num_elements-1].physics;
}

sprintf(this_box_volume.name,NAME_CURRENT_COMP);
sprintf(this_box_volume.geometry.shape,"box");
this_box_volume.geometry.priority_value = priority;
this_box_volume.geometry.geometry_p_interact = p_interact;
// Currently the coordinates will be in absolute space.
this_box_volume.geometry.center = POS_A_CURRENT_COMP;

this_box_storage.z_depth = zdepth;
this_box_storage.x_width1 = xwidth;
this_box_storage.y_height1 = yheight;

this_box_storage.is_rectangle = 0;
if (xwidth2 < 0 && yheight2 < 0) this_box_storage.is_rectangle = 1;
if (xwidth == xwidth2 && yheight == yheight2) this_box_storage.is_rectangle = 1;

if (xwidth2 < 0) {
    this_box_storage.x_width2 = xwidth;
    xwidth2 = xwidth;
} else this_box_storage.x_width2 = xwidth2;

if (yheight2 < 0) {
    this_box_storage.y_height2 = yheight;
    yheight2 = yheight;
} else this_box_storage.y_height2 = yheight2;


this_box_storage.normal_vectors[0] = coords_set(0,0,1);
this_box_storage.normal_vectors[1] = coords_set(0,0,1);

// for sides with y component = 0
x_component = 2*zdepth/sqrt((xwidth-xwidth2)*(xwidth-xwidth2)+4*zdepth*zdepth);
z_component = (xwidth-xwidth2)/sqrt(4*zdepth*zdepth+(xwidth-xwidth2)*(xwidth-xwidth2));

this_box_storage.normal_vectors[2] = coords_set(x_component,0,z_component);
this_box_storage.normal_vectors[3] = coords_set(-x_component,0,z_component);

// for sides with x component = 0
y_component = 2*zdepth/sqrt((yheight-yheight2)*(yheight-yheight2)+4*zdepth*zdepth);
z_component = (yheight-yheight2)/sqrt(4*zdepth*zdepth+(yheight-yheight2)*(yheight-yheight2));

this_box_storage.normal_vectors[4] = coords_set(0,y_component,z_component);
this_box_storage.normal_vectors[5] = coords_set(0,-y_component,z_component);

this_box_volume.geometry.visualization_on = visualize;

this_box_volume.geometry.geometry_parameters.p_box_storage = &this_box_storage;

// Assign pointers to functions for intersection with the shape, checking if a point is inside the shape
if (this_box_storage.is_rectangle == 1) {
this_box_volume.geometry.intersect_function = &sample_box_intersect_simple;
this_box_volume.geometry.within_function = &r_within_box_simple;
}
else {
this_box_volume.geometry.intersect_function = &sample_box_intersect_advanced;
this_box_volume.geometry.within_function = &r_within_box_advanced;
}

this_box_volume.geometry.shell_points = &box_shell_points;
this_box_volume.geometry.mcdisplay_function = &mcdisplay_box_function;
this_box_volume.geometry.initialize_from_main_function = &initialize_box_geometry_from_main_component;
this_box_volume.geometry.process_rot_allocated = 0;

this_box_volume.geometry.copy_geometry_parameters = &allocate_box_storage_copy;

rot_copy(this_box_volume.geometry.rotation_matrix,ROT_A_CURRENT_COMP); //check how ROT_R_CURRENT_COMP would work
rot_transpose(ROT_A_CURRENT_COMP,this_box_volume.geometry.transpose_rotation_matrix);

// Initialize loggers
this_box_volume.loggers.num_elements = 0;

// packing the information into the global_geometry_element, which is then included in the global_geometry_list.
sprintf(global_geometry_element.name,NAME_CURRENT_COMP);
global_geometry_element.activation_counter = number_of_activations;
global_geometry_element.component_index = INDEX_CURRENT_COMP;
global_geometry_element.Volume = &this_box_volume; // Would be nicer if this m was a pointer, now we have the (small) data two places
add_element_to_geometry_list(&global_geometry_list,global_geometry_element);
}
#line 236801 "MACS_sample_kidney_box.c"
#undef number_of_activations
#undef mask_setting
#undef mask_string
#undef p_interact
#undef focus_r
#undef focus_xh
#undef focus_xw
#undef focus_ah
#undef focus_aw
#undef target_z
#undef target_y
#undef target_x
#undef target_index
#undef visualize
#undef yheight2
#undef xwidth2
#undef zdepth
#undef yheight
#undef xwidth
#undef priority
#undef material_string
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

  /* Initializations for component channel_8_analyzer_1_array_crystal_array_3. */
  SIG_MESSAGE("channel_8_analyzer_1_array_crystal_array_3 (Init)");
#define mccompcurname  channel_8_analyzer_1_array_crystal_array_3
#define mccompcurtype  Union_box
#define mccompcurindex 437
#define loop_index mccchannel_8_analyzer_1_array_crystal_array_3_loop_index
#define this_box_volume mccchannel_8_analyzer_1_array_crystal_array_3_this_box_volume
#define global_geometry_element mccchannel_8_analyzer_1_array_crystal_array_3_global_geometry_element
#define this_box_storage mccchannel_8_analyzer_1_array_crystal_array_3_this_box_storage
#define material_string mccchannel_8_analyzer_1_array_crystal_array_3_material_string
#define priority mccchannel_8_analyzer_1_array_crystal_array_3_priority
#define xwidth mccchannel_8_analyzer_1_array_crystal_array_3_xwidth
#define yheight mccchannel_8_analyzer_1_array_crystal_array_3_yheight
#define zdepth mccchannel_8_analyzer_1_array_crystal_array_3_zdepth
#define xwidth2 mccchannel_8_analyzer_1_array_crystal_array_3_xwidth2
#define yheight2 mccchannel_8_analyzer_1_array_crystal_array_3_yheight2
#define visualize mccchannel_8_analyzer_1_array_crystal_array_3_visualize
#define target_index mccchannel_8_analyzer_1_array_crystal_array_3_target_index
#define target_x mccchannel_8_analyzer_1_array_crystal_array_3_target_x
#define target_y mccchannel_8_analyzer_1_array_crystal_array_3_target_y
#define target_z mccchannel_8_analyzer_1_array_crystal_array_3_target_z
#define focus_aw mccchannel_8_analyzer_1_array_crystal_array_3_focus_aw
#define focus_ah mccchannel_8_analyzer_1_array_crystal_array_3_focus_ah
#define focus_xw mccchannel_8_analyzer_1_array_crystal_array_3_focus_xw
#define focus_xh mccchannel_8_analyzer_1_array_crystal_array_3_focus_xh
#define focus_r mccchannel_8_analyzer_1_array_crystal_array_3_focus_r
#define p_interact mccchannel_8_analyzer_1_array_crystal_array_3_p_interact
#define mask_string mccchannel_8_analyzer_1_array_crystal_array_3_mask_string
#define mask_setting mccchannel_8_analyzer_1_array_crystal_array_3_mask_setting
#define number_of_activations mccchannel_8_analyzer_1_array_crystal_array_3_number_of_activations
#line 224 "Union_box.comp"
{
// Initializes the focusing system for this volume including input sanitation.
focus_initialize(&this_box_volume.geometry, POS_A_COMP_INDEX(INDEX_CURRENT_COMP+target_index), POS_A_CURRENT_COMP, ROT_A_CURRENT_COMP, target_index, target_x, target_y, target_z, focus_aw, focus_ah, focus_xw, focus_xh, focus_r, NAME_CURRENT_COMP);

// Input sanitation for this geometry
if (xwidth <= 0) {
  printf("\nERROR in Union_box named %s, the xwidth is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (yheight <= 0) {
  printf("\nERROR in Union_box named %s, yheight is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (zdepth <= 0) {
  printf("\nERROR in Union_box named %s, zdepth is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (xwidth2 <= 0 && xwidth2 != -1) {
  printf("\nERROR in Union_box named %s, the xwidth2 is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (yheight2 <= 0 && yheight2 != -1) {
  printf("\nERROR in Union_box named %s, yheight2 is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}

// Use sanitation
if (global_material_list.num_elements == 0) {
  printf("\nERROR: Need to define a material using Union_make_material before using a Union geometry component. \n");
  printf("       %s was defined before first use of Union_make_material.\n",NAME_CURRENT_COMP);
  exit(1);
}

this_box_volume.geometry.is_masked_volume = 0;
this_box_volume.geometry.is_exit_volume = 0;
this_box_volume.geometry.is_mask_volume = 0;
// check if the volume is a mask, if it is the material string is irelevant.
if (mask_string && strlen(mask_string) && strcmp(mask_string, "NULL") && strcmp(mask_string, "0")) {
    // A mask volume is used to limit the extend of other volumes, called the masked volumes. These are specified in the mask_string.
    // In order for a ray to enter a masked volume, it needs to be both in the region covered by that volume AND the mask volume.
    // When more than
    this_box_volume.geometry.mask_mode = 1; // Default is mask mode is ALL
    if (mask_setting && strlen(mask_setting) && strcmp(mask_setting, "NULL") && strcmp(mask_setting, "0")) {
        if (strcmp(mask_setting,"ALL") == 0 || strcmp(mask_setting,"All") == 0) this_box_volume.geometry.mask_mode = 1;
        else if (strcmp(mask_setting,"ANY") == 0 || strcmp(mask_setting,"Any") == 0) this_box_volume.geometry.mask_mode = 2;
        else {
            printf("The mask_mode of component %s is set to %s, but must be either ALL or ANY.\n",NAME_CURRENT_COMP,mask_setting);
            exit(1);
        }
    }
    
    for (loop_index=0;loop_index<global_geometry_list.num_elements;loop_index++) {
        // Add mask list
        if (1 == manual_linking_function(global_geometry_list.elements[loop_index].name,mask_string)) {
            add_element_to_int_list(&this_box_volume.geometry.mask_list,global_geometry_list.elements[loop_index].component_index);
            add_element_to_int_list(&global_geometry_list.elements[loop_index].Volume->geometry.masked_by_list,INDEX_CURRENT_COMP);
            global_geometry_list.elements[loop_index].Volume->geometry.is_masked_volume = 1;
            if (this_box_volume.geometry.mask_mode == 2)
                global_geometry_list.elements[loop_index].Volume->geometry.mask_mode = 2;
            if (this_box_volume.geometry.mask_mode == 1) {
                if (global_geometry_list.elements[loop_index].Volume->geometry.is_masked_volume == 1 && global_geometry_list.elements[loop_index].Volume->geometry.mask_mode != 2)
                    // If more than one mask is added to one volume, the ANY mode overwrites the (default) ALL mode.
                    global_geometry_list.elements[loop_index].Volume->geometry.mask_mode = 1;
            }
            
            found_geometries = 1;
        }
    }
    if (found_geometries == 0) {
        printf("The mask_string in geometry: %s did not find any of the specified volumes in the mask_string %s \n",NAME_CURRENT_COMP,mask_string);
        exit(1);
    }
    this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
    this_box_volume.p_physics->is_vacuum = 0; // Makes this volume a vacuum
    this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
    this_box_volume.p_physics->my_a = 0; // Should not be used.
    sprintf(this_box_volume.p_physics->name,"Mask");
    this_box_volume.geometry.is_mask_volume = 1;
    
    
// Read the material input, or if it lacks, use automatic linking.
} else if (material_string && strlen(material_string) && strcmp(material_string, "NULL") && strcmp(material_string, "0")) {
    // A geometry string was given, use it to determine which material
    if (0 == strcmp(material_string,"vacuum") || 0 == strcmp(material_string,"Vacuum")) {
        // One could have a global physics struct for vacuum instead of creating one for each
        this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
        this_box_volume.p_physics->is_vacuum = 1; // Makes this volume a vacuum
        this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
        this_box_volume.p_physics->my_a = 0; // Should not be used.
        sprintf(this_box_volume.p_physics->name,"Vacuum");
    } else if (0 == strcmp(material_string,"exit") || 0 == strcmp(material_string,"Exit")) {
        // One could have a global physics struct for vacuum instead of creating one for each
        this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
        this_box_volume.p_physics->is_vacuum = 1; // Makes this volume a vacuum
        this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
        this_box_volume.p_physics->my_a = 0; // Should not be used.
        this_box_volume.geometry.is_exit_volume = 1;
        sprintf(this_box_volume.p_physics->name,"Exit");
    } else {
        #ifndef MATERIAL_DETECTOR
            printf("Need to define a material before refering to it in a geometry %s.\n",NAME_CURRENT_COMP);
            exit(1);
        #endif
        for (loop_index=0;loop_index<global_material_list.num_elements;loop_index++) {
            if (0 == strcmp(material_string,global_material_list.elements[loop_index].name)) {
                this_box_volume.p_physics = global_material_list.elements[loop_index].physics;
                break;
            }
            if (loop_index == global_material_list.num_elements-1) {
            printf("\n");
            printf("ERROR: The material string \"%s\" in Union geometry \"%s\" did not match a specified material. \n",material_string,NAME_CURRENT_COMP);
            printf("       The materials available at this point (need to be defined before the geometry): \n");
            for (loop_index=0;loop_index<global_material_list.num_elements;loop_index++)
              printf("         %s\n",global_material_list.elements[loop_index].name);
            printf("\n");
            printf("       It is also possible to use one of the defualt materials avaiable: \n");
            printf("           Vacuum (for a Volume without scattering or absorption)\n");
            printf("           Exit (for a Volume where the ray exits the component if it enters)\n");
            printf("           Mask (for a Volume that masks existing volumes specified in the mask_string\n");
            exit(1);
          }
        }
    }
} else {
    // Automatic linking, simply using the last defined material.
    #ifndef MATERIAL_DETECTOR
        printf("Need to define a material before the geometry to use automatic linking %s.\n",NAME_CURRENT_COMP);
        exit(1);
    #endif
    this_box_volume.p_physics = global_material_list.elements[global_material_list.num_elements-1].physics;
}

sprintf(this_box_volume.name,NAME_CURRENT_COMP);
sprintf(this_box_volume.geometry.shape,"box");
this_box_volume.geometry.priority_value = priority;
this_box_volume.geometry.geometry_p_interact = p_interact;
// Currently the coordinates will be in absolute space.
this_box_volume.geometry.center = POS_A_CURRENT_COMP;

this_box_storage.z_depth = zdepth;
this_box_storage.x_width1 = xwidth;
this_box_storage.y_height1 = yheight;

this_box_storage.is_rectangle = 0;
if (xwidth2 < 0 && yheight2 < 0) this_box_storage.is_rectangle = 1;
if (xwidth == xwidth2 && yheight == yheight2) this_box_storage.is_rectangle = 1;

if (xwidth2 < 0) {
    this_box_storage.x_width2 = xwidth;
    xwidth2 = xwidth;
} else this_box_storage.x_width2 = xwidth2;

if (yheight2 < 0) {
    this_box_storage.y_height2 = yheight;
    yheight2 = yheight;
} else this_box_storage.y_height2 = yheight2;


this_box_storage.normal_vectors[0] = coords_set(0,0,1);
this_box_storage.normal_vectors[1] = coords_set(0,0,1);

// for sides with y component = 0
x_component = 2*zdepth/sqrt((xwidth-xwidth2)*(xwidth-xwidth2)+4*zdepth*zdepth);
z_component = (xwidth-xwidth2)/sqrt(4*zdepth*zdepth+(xwidth-xwidth2)*(xwidth-xwidth2));

this_box_storage.normal_vectors[2] = coords_set(x_component,0,z_component);
this_box_storage.normal_vectors[3] = coords_set(-x_component,0,z_component);

// for sides with x component = 0
y_component = 2*zdepth/sqrt((yheight-yheight2)*(yheight-yheight2)+4*zdepth*zdepth);
z_component = (yheight-yheight2)/sqrt(4*zdepth*zdepth+(yheight-yheight2)*(yheight-yheight2));

this_box_storage.normal_vectors[4] = coords_set(0,y_component,z_component);
this_box_storage.normal_vectors[5] = coords_set(0,-y_component,z_component);

this_box_volume.geometry.visualization_on = visualize;

this_box_volume.geometry.geometry_parameters.p_box_storage = &this_box_storage;

// Assign pointers to functions for intersection with the shape, checking if a point is inside the shape
if (this_box_storage.is_rectangle == 1) {
this_box_volume.geometry.intersect_function = &sample_box_intersect_simple;
this_box_volume.geometry.within_function = &r_within_box_simple;
}
else {
this_box_volume.geometry.intersect_function = &sample_box_intersect_advanced;
this_box_volume.geometry.within_function = &r_within_box_advanced;
}

this_box_volume.geometry.shell_points = &box_shell_points;
this_box_volume.geometry.mcdisplay_function = &mcdisplay_box_function;
this_box_volume.geometry.initialize_from_main_function = &initialize_box_geometry_from_main_component;
this_box_volume.geometry.process_rot_allocated = 0;

this_box_volume.geometry.copy_geometry_parameters = &allocate_box_storage_copy;

rot_copy(this_box_volume.geometry.rotation_matrix,ROT_A_CURRENT_COMP); //check how ROT_R_CURRENT_COMP would work
rot_transpose(ROT_A_CURRENT_COMP,this_box_volume.geometry.transpose_rotation_matrix);

// Initialize loggers
this_box_volume.loggers.num_elements = 0;

// packing the information into the global_geometry_element, which is then included in the global_geometry_list.
sprintf(global_geometry_element.name,NAME_CURRENT_COMP);
global_geometry_element.activation_counter = number_of_activations;
global_geometry_element.component_index = INDEX_CURRENT_COMP;
global_geometry_element.Volume = &this_box_volume; // Would be nicer if this m was a pointer, now we have the (small) data two places
add_element_to_geometry_list(&global_geometry_list,global_geometry_element);
}
#line 237071 "MACS_sample_kidney_box.c"
#undef number_of_activations
#undef mask_setting
#undef mask_string
#undef p_interact
#undef focus_r
#undef focus_xh
#undef focus_xw
#undef focus_ah
#undef focus_aw
#undef target_z
#undef target_y
#undef target_x
#undef target_index
#undef visualize
#undef yheight2
#undef xwidth2
#undef zdepth
#undef yheight
#undef xwidth
#undef priority
#undef material_string
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

  /* Initializations for component channel_8_analyzer_1_array_crystal_array_4. */
  SIG_MESSAGE("channel_8_analyzer_1_array_crystal_array_4 (Init)");
#define mccompcurname  channel_8_analyzer_1_array_crystal_array_4
#define mccompcurtype  Union_box
#define mccompcurindex 438
#define loop_index mccchannel_8_analyzer_1_array_crystal_array_4_loop_index
#define this_box_volume mccchannel_8_analyzer_1_array_crystal_array_4_this_box_volume
#define global_geometry_element mccchannel_8_analyzer_1_array_crystal_array_4_global_geometry_element
#define this_box_storage mccchannel_8_analyzer_1_array_crystal_array_4_this_box_storage
#define material_string mccchannel_8_analyzer_1_array_crystal_array_4_material_string
#define priority mccchannel_8_analyzer_1_array_crystal_array_4_priority
#define xwidth mccchannel_8_analyzer_1_array_crystal_array_4_xwidth
#define yheight mccchannel_8_analyzer_1_array_crystal_array_4_yheight
#define zdepth mccchannel_8_analyzer_1_array_crystal_array_4_zdepth
#define xwidth2 mccchannel_8_analyzer_1_array_crystal_array_4_xwidth2
#define yheight2 mccchannel_8_analyzer_1_array_crystal_array_4_yheight2
#define visualize mccchannel_8_analyzer_1_array_crystal_array_4_visualize
#define target_index mccchannel_8_analyzer_1_array_crystal_array_4_target_index
#define target_x mccchannel_8_analyzer_1_array_crystal_array_4_target_x
#define target_y mccchannel_8_analyzer_1_array_crystal_array_4_target_y
#define target_z mccchannel_8_analyzer_1_array_crystal_array_4_target_z
#define focus_aw mccchannel_8_analyzer_1_array_crystal_array_4_focus_aw
#define focus_ah mccchannel_8_analyzer_1_array_crystal_array_4_focus_ah
#define focus_xw mccchannel_8_analyzer_1_array_crystal_array_4_focus_xw
#define focus_xh mccchannel_8_analyzer_1_array_crystal_array_4_focus_xh
#define focus_r mccchannel_8_analyzer_1_array_crystal_array_4_focus_r
#define p_interact mccchannel_8_analyzer_1_array_crystal_array_4_p_interact
#define mask_string mccchannel_8_analyzer_1_array_crystal_array_4_mask_string
#define mask_setting mccchannel_8_analyzer_1_array_crystal_array_4_mask_setting
#define number_of_activations mccchannel_8_analyzer_1_array_crystal_array_4_number_of_activations
#line 224 "Union_box.comp"
{
// Initializes the focusing system for this volume including input sanitation.
focus_initialize(&this_box_volume.geometry, POS_A_COMP_INDEX(INDEX_CURRENT_COMP+target_index), POS_A_CURRENT_COMP, ROT_A_CURRENT_COMP, target_index, target_x, target_y, target_z, focus_aw, focus_ah, focus_xw, focus_xh, focus_r, NAME_CURRENT_COMP);

// Input sanitation for this geometry
if (xwidth <= 0) {
  printf("\nERROR in Union_box named %s, the xwidth is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (yheight <= 0) {
  printf("\nERROR in Union_box named %s, yheight is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (zdepth <= 0) {
  printf("\nERROR in Union_box named %s, zdepth is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (xwidth2 <= 0 && xwidth2 != -1) {
  printf("\nERROR in Union_box named %s, the xwidth2 is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (yheight2 <= 0 && yheight2 != -1) {
  printf("\nERROR in Union_box named %s, yheight2 is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}

// Use sanitation
if (global_material_list.num_elements == 0) {
  printf("\nERROR: Need to define a material using Union_make_material before using a Union geometry component. \n");
  printf("       %s was defined before first use of Union_make_material.\n",NAME_CURRENT_COMP);
  exit(1);
}

this_box_volume.geometry.is_masked_volume = 0;
this_box_volume.geometry.is_exit_volume = 0;
this_box_volume.geometry.is_mask_volume = 0;
// check if the volume is a mask, if it is the material string is irelevant.
if (mask_string && strlen(mask_string) && strcmp(mask_string, "NULL") && strcmp(mask_string, "0")) {
    // A mask volume is used to limit the extend of other volumes, called the masked volumes. These are specified in the mask_string.
    // In order for a ray to enter a masked volume, it needs to be both in the region covered by that volume AND the mask volume.
    // When more than
    this_box_volume.geometry.mask_mode = 1; // Default is mask mode is ALL
    if (mask_setting && strlen(mask_setting) && strcmp(mask_setting, "NULL") && strcmp(mask_setting, "0")) {
        if (strcmp(mask_setting,"ALL") == 0 || strcmp(mask_setting,"All") == 0) this_box_volume.geometry.mask_mode = 1;
        else if (strcmp(mask_setting,"ANY") == 0 || strcmp(mask_setting,"Any") == 0) this_box_volume.geometry.mask_mode = 2;
        else {
            printf("The mask_mode of component %s is set to %s, but must be either ALL or ANY.\n",NAME_CURRENT_COMP,mask_setting);
            exit(1);
        }
    }
    
    for (loop_index=0;loop_index<global_geometry_list.num_elements;loop_index++) {
        // Add mask list
        if (1 == manual_linking_function(global_geometry_list.elements[loop_index].name,mask_string)) {
            add_element_to_int_list(&this_box_volume.geometry.mask_list,global_geometry_list.elements[loop_index].component_index);
            add_element_to_int_list(&global_geometry_list.elements[loop_index].Volume->geometry.masked_by_list,INDEX_CURRENT_COMP);
            global_geometry_list.elements[loop_index].Volume->geometry.is_masked_volume = 1;
            if (this_box_volume.geometry.mask_mode == 2)
                global_geometry_list.elements[loop_index].Volume->geometry.mask_mode = 2;
            if (this_box_volume.geometry.mask_mode == 1) {
                if (global_geometry_list.elements[loop_index].Volume->geometry.is_masked_volume == 1 && global_geometry_list.elements[loop_index].Volume->geometry.mask_mode != 2)
                    // If more than one mask is added to one volume, the ANY mode overwrites the (default) ALL mode.
                    global_geometry_list.elements[loop_index].Volume->geometry.mask_mode = 1;
            }
            
            found_geometries = 1;
        }
    }
    if (found_geometries == 0) {
        printf("The mask_string in geometry: %s did not find any of the specified volumes in the mask_string %s \n",NAME_CURRENT_COMP,mask_string);
        exit(1);
    }
    this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
    this_box_volume.p_physics->is_vacuum = 0; // Makes this volume a vacuum
    this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
    this_box_volume.p_physics->my_a = 0; // Should not be used.
    sprintf(this_box_volume.p_physics->name,"Mask");
    this_box_volume.geometry.is_mask_volume = 1;
    
    
// Read the material input, or if it lacks, use automatic linking.
} else if (material_string && strlen(material_string) && strcmp(material_string, "NULL") && strcmp(material_string, "0")) {
    // A geometry string was given, use it to determine which material
    if (0 == strcmp(material_string,"vacuum") || 0 == strcmp(material_string,"Vacuum")) {
        // One could have a global physics struct for vacuum instead of creating one for each
        this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
        this_box_volume.p_physics->is_vacuum = 1; // Makes this volume a vacuum
        this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
        this_box_volume.p_physics->my_a = 0; // Should not be used.
        sprintf(this_box_volume.p_physics->name,"Vacuum");
    } else if (0 == strcmp(material_string,"exit") || 0 == strcmp(material_string,"Exit")) {
        // One could have a global physics struct for vacuum instead of creating one for each
        this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
        this_box_volume.p_physics->is_vacuum = 1; // Makes this volume a vacuum
        this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
        this_box_volume.p_physics->my_a = 0; // Should not be used.
        this_box_volume.geometry.is_exit_volume = 1;
        sprintf(this_box_volume.p_physics->name,"Exit");
    } else {
        #ifndef MATERIAL_DETECTOR
            printf("Need to define a material before refering to it in a geometry %s.\n",NAME_CURRENT_COMP);
            exit(1);
        #endif
        for (loop_index=0;loop_index<global_material_list.num_elements;loop_index++) {
            if (0 == strcmp(material_string,global_material_list.elements[loop_index].name)) {
                this_box_volume.p_physics = global_material_list.elements[loop_index].physics;
                break;
            }
            if (loop_index == global_material_list.num_elements-1) {
            printf("\n");
            printf("ERROR: The material string \"%s\" in Union geometry \"%s\" did not match a specified material. \n",material_string,NAME_CURRENT_COMP);
            printf("       The materials available at this point (need to be defined before the geometry): \n");
            for (loop_index=0;loop_index<global_material_list.num_elements;loop_index++)
              printf("         %s\n",global_material_list.elements[loop_index].name);
            printf("\n");
            printf("       It is also possible to use one of the defualt materials avaiable: \n");
            printf("           Vacuum (for a Volume without scattering or absorption)\n");
            printf("           Exit (for a Volume where the ray exits the component if it enters)\n");
            printf("           Mask (for a Volume that masks existing volumes specified in the mask_string\n");
            exit(1);
          }
        }
    }
} else {
    // Automatic linking, simply using the last defined material.
    #ifndef MATERIAL_DETECTOR
        printf("Need to define a material before the geometry to use automatic linking %s.\n",NAME_CURRENT_COMP);
        exit(1);
    #endif
    this_box_volume.p_physics = global_material_list.elements[global_material_list.num_elements-1].physics;
}

sprintf(this_box_volume.name,NAME_CURRENT_COMP);
sprintf(this_box_volume.geometry.shape,"box");
this_box_volume.geometry.priority_value = priority;
this_box_volume.geometry.geometry_p_interact = p_interact;
// Currently the coordinates will be in absolute space.
this_box_volume.geometry.center = POS_A_CURRENT_COMP;

this_box_storage.z_depth = zdepth;
this_box_storage.x_width1 = xwidth;
this_box_storage.y_height1 = yheight;

this_box_storage.is_rectangle = 0;
if (xwidth2 < 0 && yheight2 < 0) this_box_storage.is_rectangle = 1;
if (xwidth == xwidth2 && yheight == yheight2) this_box_storage.is_rectangle = 1;

if (xwidth2 < 0) {
    this_box_storage.x_width2 = xwidth;
    xwidth2 = xwidth;
} else this_box_storage.x_width2 = xwidth2;

if (yheight2 < 0) {
    this_box_storage.y_height2 = yheight;
    yheight2 = yheight;
} else this_box_storage.y_height2 = yheight2;


this_box_storage.normal_vectors[0] = coords_set(0,0,1);
this_box_storage.normal_vectors[1] = coords_set(0,0,1);

// for sides with y component = 0
x_component = 2*zdepth/sqrt((xwidth-xwidth2)*(xwidth-xwidth2)+4*zdepth*zdepth);
z_component = (xwidth-xwidth2)/sqrt(4*zdepth*zdepth+(xwidth-xwidth2)*(xwidth-xwidth2));

this_box_storage.normal_vectors[2] = coords_set(x_component,0,z_component);
this_box_storage.normal_vectors[3] = coords_set(-x_component,0,z_component);

// for sides with x component = 0
y_component = 2*zdepth/sqrt((yheight-yheight2)*(yheight-yheight2)+4*zdepth*zdepth);
z_component = (yheight-yheight2)/sqrt(4*zdepth*zdepth+(yheight-yheight2)*(yheight-yheight2));

this_box_storage.normal_vectors[4] = coords_set(0,y_component,z_component);
this_box_storage.normal_vectors[5] = coords_set(0,-y_component,z_component);

this_box_volume.geometry.visualization_on = visualize;

this_box_volume.geometry.geometry_parameters.p_box_storage = &this_box_storage;

// Assign pointers to functions for intersection with the shape, checking if a point is inside the shape
if (this_box_storage.is_rectangle == 1) {
this_box_volume.geometry.intersect_function = &sample_box_intersect_simple;
this_box_volume.geometry.within_function = &r_within_box_simple;
}
else {
this_box_volume.geometry.intersect_function = &sample_box_intersect_advanced;
this_box_volume.geometry.within_function = &r_within_box_advanced;
}

this_box_volume.geometry.shell_points = &box_shell_points;
this_box_volume.geometry.mcdisplay_function = &mcdisplay_box_function;
this_box_volume.geometry.initialize_from_main_function = &initialize_box_geometry_from_main_component;
this_box_volume.geometry.process_rot_allocated = 0;

this_box_volume.geometry.copy_geometry_parameters = &allocate_box_storage_copy;

rot_copy(this_box_volume.geometry.rotation_matrix,ROT_A_CURRENT_COMP); //check how ROT_R_CURRENT_COMP would work
rot_transpose(ROT_A_CURRENT_COMP,this_box_volume.geometry.transpose_rotation_matrix);

// Initialize loggers
this_box_volume.loggers.num_elements = 0;

// packing the information into the global_geometry_element, which is then included in the global_geometry_list.
sprintf(global_geometry_element.name,NAME_CURRENT_COMP);
global_geometry_element.activation_counter = number_of_activations;
global_geometry_element.component_index = INDEX_CURRENT_COMP;
global_geometry_element.Volume = &this_box_volume; // Would be nicer if this m was a pointer, now we have the (small) data two places
add_element_to_geometry_list(&global_geometry_list,global_geometry_element);
}
#line 237341 "MACS_sample_kidney_box.c"
#undef number_of_activations
#undef mask_setting
#undef mask_string
#undef p_interact
#undef focus_r
#undef focus_xh
#undef focus_xw
#undef focus_ah
#undef focus_aw
#undef target_z
#undef target_y
#undef target_x
#undef target_index
#undef visualize
#undef yheight2
#undef xwidth2
#undef zdepth
#undef yheight
#undef xwidth
#undef priority
#undef material_string
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

  /* Initializations for component channel_8_analyzer_1_array_crystal_array_5. */
  SIG_MESSAGE("channel_8_analyzer_1_array_crystal_array_5 (Init)");
#define mccompcurname  channel_8_analyzer_1_array_crystal_array_5
#define mccompcurtype  Union_box
#define mccompcurindex 439
#define loop_index mccchannel_8_analyzer_1_array_crystal_array_5_loop_index
#define this_box_volume mccchannel_8_analyzer_1_array_crystal_array_5_this_box_volume
#define global_geometry_element mccchannel_8_analyzer_1_array_crystal_array_5_global_geometry_element
#define this_box_storage mccchannel_8_analyzer_1_array_crystal_array_5_this_box_storage
#define material_string mccchannel_8_analyzer_1_array_crystal_array_5_material_string
#define priority mccchannel_8_analyzer_1_array_crystal_array_5_priority
#define xwidth mccchannel_8_analyzer_1_array_crystal_array_5_xwidth
#define yheight mccchannel_8_analyzer_1_array_crystal_array_5_yheight
#define zdepth mccchannel_8_analyzer_1_array_crystal_array_5_zdepth
#define xwidth2 mccchannel_8_analyzer_1_array_crystal_array_5_xwidth2
#define yheight2 mccchannel_8_analyzer_1_array_crystal_array_5_yheight2
#define visualize mccchannel_8_analyzer_1_array_crystal_array_5_visualize
#define target_index mccchannel_8_analyzer_1_array_crystal_array_5_target_index
#define target_x mccchannel_8_analyzer_1_array_crystal_array_5_target_x
#define target_y mccchannel_8_analyzer_1_array_crystal_array_5_target_y
#define target_z mccchannel_8_analyzer_1_array_crystal_array_5_target_z
#define focus_aw mccchannel_8_analyzer_1_array_crystal_array_5_focus_aw
#define focus_ah mccchannel_8_analyzer_1_array_crystal_array_5_focus_ah
#define focus_xw mccchannel_8_analyzer_1_array_crystal_array_5_focus_xw
#define focus_xh mccchannel_8_analyzer_1_array_crystal_array_5_focus_xh
#define focus_r mccchannel_8_analyzer_1_array_crystal_array_5_focus_r
#define p_interact mccchannel_8_analyzer_1_array_crystal_array_5_p_interact
#define mask_string mccchannel_8_analyzer_1_array_crystal_array_5_mask_string
#define mask_setting mccchannel_8_analyzer_1_array_crystal_array_5_mask_setting
#define number_of_activations mccchannel_8_analyzer_1_array_crystal_array_5_number_of_activations
#line 224 "Union_box.comp"
{
// Initializes the focusing system for this volume including input sanitation.
focus_initialize(&this_box_volume.geometry, POS_A_COMP_INDEX(INDEX_CURRENT_COMP+target_index), POS_A_CURRENT_COMP, ROT_A_CURRENT_COMP, target_index, target_x, target_y, target_z, focus_aw, focus_ah, focus_xw, focus_xh, focus_r, NAME_CURRENT_COMP);

// Input sanitation for this geometry
if (xwidth <= 0) {
  printf("\nERROR in Union_box named %s, the xwidth is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (yheight <= 0) {
  printf("\nERROR in Union_box named %s, yheight is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (zdepth <= 0) {
  printf("\nERROR in Union_box named %s, zdepth is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (xwidth2 <= 0 && xwidth2 != -1) {
  printf("\nERROR in Union_box named %s, the xwidth2 is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (yheight2 <= 0 && yheight2 != -1) {
  printf("\nERROR in Union_box named %s, yheight2 is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}

// Use sanitation
if (global_material_list.num_elements == 0) {
  printf("\nERROR: Need to define a material using Union_make_material before using a Union geometry component. \n");
  printf("       %s was defined before first use of Union_make_material.\n",NAME_CURRENT_COMP);
  exit(1);
}

this_box_volume.geometry.is_masked_volume = 0;
this_box_volume.geometry.is_exit_volume = 0;
this_box_volume.geometry.is_mask_volume = 0;
// check if the volume is a mask, if it is the material string is irelevant.
if (mask_string && strlen(mask_string) && strcmp(mask_string, "NULL") && strcmp(mask_string, "0")) {
    // A mask volume is used to limit the extend of other volumes, called the masked volumes. These are specified in the mask_string.
    // In order for a ray to enter a masked volume, it needs to be both in the region covered by that volume AND the mask volume.
    // When more than
    this_box_volume.geometry.mask_mode = 1; // Default is mask mode is ALL
    if (mask_setting && strlen(mask_setting) && strcmp(mask_setting, "NULL") && strcmp(mask_setting, "0")) {
        if (strcmp(mask_setting,"ALL") == 0 || strcmp(mask_setting,"All") == 0) this_box_volume.geometry.mask_mode = 1;
        else if (strcmp(mask_setting,"ANY") == 0 || strcmp(mask_setting,"Any") == 0) this_box_volume.geometry.mask_mode = 2;
        else {
            printf("The mask_mode of component %s is set to %s, but must be either ALL or ANY.\n",NAME_CURRENT_COMP,mask_setting);
            exit(1);
        }
    }
    
    for (loop_index=0;loop_index<global_geometry_list.num_elements;loop_index++) {
        // Add mask list
        if (1 == manual_linking_function(global_geometry_list.elements[loop_index].name,mask_string)) {
            add_element_to_int_list(&this_box_volume.geometry.mask_list,global_geometry_list.elements[loop_index].component_index);
            add_element_to_int_list(&global_geometry_list.elements[loop_index].Volume->geometry.masked_by_list,INDEX_CURRENT_COMP);
            global_geometry_list.elements[loop_index].Volume->geometry.is_masked_volume = 1;
            if (this_box_volume.geometry.mask_mode == 2)
                global_geometry_list.elements[loop_index].Volume->geometry.mask_mode = 2;
            if (this_box_volume.geometry.mask_mode == 1) {
                if (global_geometry_list.elements[loop_index].Volume->geometry.is_masked_volume == 1 && global_geometry_list.elements[loop_index].Volume->geometry.mask_mode != 2)
                    // If more than one mask is added to one volume, the ANY mode overwrites the (default) ALL mode.
                    global_geometry_list.elements[loop_index].Volume->geometry.mask_mode = 1;
            }
            
            found_geometries = 1;
        }
    }
    if (found_geometries == 0) {
        printf("The mask_string in geometry: %s did not find any of the specified volumes in the mask_string %s \n",NAME_CURRENT_COMP,mask_string);
        exit(1);
    }
    this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
    this_box_volume.p_physics->is_vacuum = 0; // Makes this volume a vacuum
    this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
    this_box_volume.p_physics->my_a = 0; // Should not be used.
    sprintf(this_box_volume.p_physics->name,"Mask");
    this_box_volume.geometry.is_mask_volume = 1;
    
    
// Read the material input, or if it lacks, use automatic linking.
} else if (material_string && strlen(material_string) && strcmp(material_string, "NULL") && strcmp(material_string, "0")) {
    // A geometry string was given, use it to determine which material
    if (0 == strcmp(material_string,"vacuum") || 0 == strcmp(material_string,"Vacuum")) {
        // One could have a global physics struct for vacuum instead of creating one for each
        this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
        this_box_volume.p_physics->is_vacuum = 1; // Makes this volume a vacuum
        this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
        this_box_volume.p_physics->my_a = 0; // Should not be used.
        sprintf(this_box_volume.p_physics->name,"Vacuum");
    } else if (0 == strcmp(material_string,"exit") || 0 == strcmp(material_string,"Exit")) {
        // One could have a global physics struct for vacuum instead of creating one for each
        this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
        this_box_volume.p_physics->is_vacuum = 1; // Makes this volume a vacuum
        this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
        this_box_volume.p_physics->my_a = 0; // Should not be used.
        this_box_volume.geometry.is_exit_volume = 1;
        sprintf(this_box_volume.p_physics->name,"Exit");
    } else {
        #ifndef MATERIAL_DETECTOR
            printf("Need to define a material before refering to it in a geometry %s.\n",NAME_CURRENT_COMP);
            exit(1);
        #endif
        for (loop_index=0;loop_index<global_material_list.num_elements;loop_index++) {
            if (0 == strcmp(material_string,global_material_list.elements[loop_index].name)) {
                this_box_volume.p_physics = global_material_list.elements[loop_index].physics;
                break;
            }
            if (loop_index == global_material_list.num_elements-1) {
            printf("\n");
            printf("ERROR: The material string \"%s\" in Union geometry \"%s\" did not match a specified material. \n",material_string,NAME_CURRENT_COMP);
            printf("       The materials available at this point (need to be defined before the geometry): \n");
            for (loop_index=0;loop_index<global_material_list.num_elements;loop_index++)
              printf("         %s\n",global_material_list.elements[loop_index].name);
            printf("\n");
            printf("       It is also possible to use one of the defualt materials avaiable: \n");
            printf("           Vacuum (for a Volume without scattering or absorption)\n");
            printf("           Exit (for a Volume where the ray exits the component if it enters)\n");
            printf("           Mask (for a Volume that masks existing volumes specified in the mask_string\n");
            exit(1);
          }
        }
    }
} else {
    // Automatic linking, simply using the last defined material.
    #ifndef MATERIAL_DETECTOR
        printf("Need to define a material before the geometry to use automatic linking %s.\n",NAME_CURRENT_COMP);
        exit(1);
    #endif
    this_box_volume.p_physics = global_material_list.elements[global_material_list.num_elements-1].physics;
}

sprintf(this_box_volume.name,NAME_CURRENT_COMP);
sprintf(this_box_volume.geometry.shape,"box");
this_box_volume.geometry.priority_value = priority;
this_box_volume.geometry.geometry_p_interact = p_interact;
// Currently the coordinates will be in absolute space.
this_box_volume.geometry.center = POS_A_CURRENT_COMP;

this_box_storage.z_depth = zdepth;
this_box_storage.x_width1 = xwidth;
this_box_storage.y_height1 = yheight;

this_box_storage.is_rectangle = 0;
if (xwidth2 < 0 && yheight2 < 0) this_box_storage.is_rectangle = 1;
if (xwidth == xwidth2 && yheight == yheight2) this_box_storage.is_rectangle = 1;

if (xwidth2 < 0) {
    this_box_storage.x_width2 = xwidth;
    xwidth2 = xwidth;
} else this_box_storage.x_width2 = xwidth2;

if (yheight2 < 0) {
    this_box_storage.y_height2 = yheight;
    yheight2 = yheight;
} else this_box_storage.y_height2 = yheight2;


this_box_storage.normal_vectors[0] = coords_set(0,0,1);
this_box_storage.normal_vectors[1] = coords_set(0,0,1);

// for sides with y component = 0
x_component = 2*zdepth/sqrt((xwidth-xwidth2)*(xwidth-xwidth2)+4*zdepth*zdepth);
z_component = (xwidth-xwidth2)/sqrt(4*zdepth*zdepth+(xwidth-xwidth2)*(xwidth-xwidth2));

this_box_storage.normal_vectors[2] = coords_set(x_component,0,z_component);
this_box_storage.normal_vectors[3] = coords_set(-x_component,0,z_component);

// for sides with x component = 0
y_component = 2*zdepth/sqrt((yheight-yheight2)*(yheight-yheight2)+4*zdepth*zdepth);
z_component = (yheight-yheight2)/sqrt(4*zdepth*zdepth+(yheight-yheight2)*(yheight-yheight2));

this_box_storage.normal_vectors[4] = coords_set(0,y_component,z_component);
this_box_storage.normal_vectors[5] = coords_set(0,-y_component,z_component);

this_box_volume.geometry.visualization_on = visualize;

this_box_volume.geometry.geometry_parameters.p_box_storage = &this_box_storage;

// Assign pointers to functions for intersection with the shape, checking if a point is inside the shape
if (this_box_storage.is_rectangle == 1) {
this_box_volume.geometry.intersect_function = &sample_box_intersect_simple;
this_box_volume.geometry.within_function = &r_within_box_simple;
}
else {
this_box_volume.geometry.intersect_function = &sample_box_intersect_advanced;
this_box_volume.geometry.within_function = &r_within_box_advanced;
}

this_box_volume.geometry.shell_points = &box_shell_points;
this_box_volume.geometry.mcdisplay_function = &mcdisplay_box_function;
this_box_volume.geometry.initialize_from_main_function = &initialize_box_geometry_from_main_component;
this_box_volume.geometry.process_rot_allocated = 0;

this_box_volume.geometry.copy_geometry_parameters = &allocate_box_storage_copy;

rot_copy(this_box_volume.geometry.rotation_matrix,ROT_A_CURRENT_COMP); //check how ROT_R_CURRENT_COMP would work
rot_transpose(ROT_A_CURRENT_COMP,this_box_volume.geometry.transpose_rotation_matrix);

// Initialize loggers
this_box_volume.loggers.num_elements = 0;

// packing the information into the global_geometry_element, which is then included in the global_geometry_list.
sprintf(global_geometry_element.name,NAME_CURRENT_COMP);
global_geometry_element.activation_counter = number_of_activations;
global_geometry_element.component_index = INDEX_CURRENT_COMP;
global_geometry_element.Volume = &this_box_volume; // Would be nicer if this m was a pointer, now we have the (small) data two places
add_element_to_geometry_list(&global_geometry_list,global_geometry_element);
}
#line 237611 "MACS_sample_kidney_box.c"
#undef number_of_activations
#undef mask_setting
#undef mask_string
#undef p_interact
#undef focus_r
#undef focus_xh
#undef focus_xw
#undef focus_ah
#undef focus_aw
#undef target_z
#undef target_y
#undef target_x
#undef target_index
#undef visualize
#undef yheight2
#undef xwidth2
#undef zdepth
#undef yheight
#undef xwidth
#undef priority
#undef material_string
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

  /* Initializations for component channel_8_analyzer_1_array_crystal_array_6. */
  SIG_MESSAGE("channel_8_analyzer_1_array_crystal_array_6 (Init)");
#define mccompcurname  channel_8_analyzer_1_array_crystal_array_6
#define mccompcurtype  Union_box
#define mccompcurindex 440
#define loop_index mccchannel_8_analyzer_1_array_crystal_array_6_loop_index
#define this_box_volume mccchannel_8_analyzer_1_array_crystal_array_6_this_box_volume
#define global_geometry_element mccchannel_8_analyzer_1_array_crystal_array_6_global_geometry_element
#define this_box_storage mccchannel_8_analyzer_1_array_crystal_array_6_this_box_storage
#define material_string mccchannel_8_analyzer_1_array_crystal_array_6_material_string
#define priority mccchannel_8_analyzer_1_array_crystal_array_6_priority
#define xwidth mccchannel_8_analyzer_1_array_crystal_array_6_xwidth
#define yheight mccchannel_8_analyzer_1_array_crystal_array_6_yheight
#define zdepth mccchannel_8_analyzer_1_array_crystal_array_6_zdepth
#define xwidth2 mccchannel_8_analyzer_1_array_crystal_array_6_xwidth2
#define yheight2 mccchannel_8_analyzer_1_array_crystal_array_6_yheight2
#define visualize mccchannel_8_analyzer_1_array_crystal_array_6_visualize
#define target_index mccchannel_8_analyzer_1_array_crystal_array_6_target_index
#define target_x mccchannel_8_analyzer_1_array_crystal_array_6_target_x
#define target_y mccchannel_8_analyzer_1_array_crystal_array_6_target_y
#define target_z mccchannel_8_analyzer_1_array_crystal_array_6_target_z
#define focus_aw mccchannel_8_analyzer_1_array_crystal_array_6_focus_aw
#define focus_ah mccchannel_8_analyzer_1_array_crystal_array_6_focus_ah
#define focus_xw mccchannel_8_analyzer_1_array_crystal_array_6_focus_xw
#define focus_xh mccchannel_8_analyzer_1_array_crystal_array_6_focus_xh
#define focus_r mccchannel_8_analyzer_1_array_crystal_array_6_focus_r
#define p_interact mccchannel_8_analyzer_1_array_crystal_array_6_p_interact
#define mask_string mccchannel_8_analyzer_1_array_crystal_array_6_mask_string
#define mask_setting mccchannel_8_analyzer_1_array_crystal_array_6_mask_setting
#define number_of_activations mccchannel_8_analyzer_1_array_crystal_array_6_number_of_activations
#line 224 "Union_box.comp"
{
// Initializes the focusing system for this volume including input sanitation.
focus_initialize(&this_box_volume.geometry, POS_A_COMP_INDEX(INDEX_CURRENT_COMP+target_index), POS_A_CURRENT_COMP, ROT_A_CURRENT_COMP, target_index, target_x, target_y, target_z, focus_aw, focus_ah, focus_xw, focus_xh, focus_r, NAME_CURRENT_COMP);

// Input sanitation for this geometry
if (xwidth <= 0) {
  printf("\nERROR in Union_box named %s, the xwidth is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (yheight <= 0) {
  printf("\nERROR in Union_box named %s, yheight is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (zdepth <= 0) {
  printf("\nERROR in Union_box named %s, zdepth is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (xwidth2 <= 0 && xwidth2 != -1) {
  printf("\nERROR in Union_box named %s, the xwidth2 is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (yheight2 <= 0 && yheight2 != -1) {
  printf("\nERROR in Union_box named %s, yheight2 is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}

// Use sanitation
if (global_material_list.num_elements == 0) {
  printf("\nERROR: Need to define a material using Union_make_material before using a Union geometry component. \n");
  printf("       %s was defined before first use of Union_make_material.\n",NAME_CURRENT_COMP);
  exit(1);
}

this_box_volume.geometry.is_masked_volume = 0;
this_box_volume.geometry.is_exit_volume = 0;
this_box_volume.geometry.is_mask_volume = 0;
// check if the volume is a mask, if it is the material string is irelevant.
if (mask_string && strlen(mask_string) && strcmp(mask_string, "NULL") && strcmp(mask_string, "0")) {
    // A mask volume is used to limit the extend of other volumes, called the masked volumes. These are specified in the mask_string.
    // In order for a ray to enter a masked volume, it needs to be both in the region covered by that volume AND the mask volume.
    // When more than
    this_box_volume.geometry.mask_mode = 1; // Default is mask mode is ALL
    if (mask_setting && strlen(mask_setting) && strcmp(mask_setting, "NULL") && strcmp(mask_setting, "0")) {
        if (strcmp(mask_setting,"ALL") == 0 || strcmp(mask_setting,"All") == 0) this_box_volume.geometry.mask_mode = 1;
        else if (strcmp(mask_setting,"ANY") == 0 || strcmp(mask_setting,"Any") == 0) this_box_volume.geometry.mask_mode = 2;
        else {
            printf("The mask_mode of component %s is set to %s, but must be either ALL or ANY.\n",NAME_CURRENT_COMP,mask_setting);
            exit(1);
        }
    }
    
    for (loop_index=0;loop_index<global_geometry_list.num_elements;loop_index++) {
        // Add mask list
        if (1 == manual_linking_function(global_geometry_list.elements[loop_index].name,mask_string)) {
            add_element_to_int_list(&this_box_volume.geometry.mask_list,global_geometry_list.elements[loop_index].component_index);
            add_element_to_int_list(&global_geometry_list.elements[loop_index].Volume->geometry.masked_by_list,INDEX_CURRENT_COMP);
            global_geometry_list.elements[loop_index].Volume->geometry.is_masked_volume = 1;
            if (this_box_volume.geometry.mask_mode == 2)
                global_geometry_list.elements[loop_index].Volume->geometry.mask_mode = 2;
            if (this_box_volume.geometry.mask_mode == 1) {
                if (global_geometry_list.elements[loop_index].Volume->geometry.is_masked_volume == 1 && global_geometry_list.elements[loop_index].Volume->geometry.mask_mode != 2)
                    // If more than one mask is added to one volume, the ANY mode overwrites the (default) ALL mode.
                    global_geometry_list.elements[loop_index].Volume->geometry.mask_mode = 1;
            }
            
            found_geometries = 1;
        }
    }
    if (found_geometries == 0) {
        printf("The mask_string in geometry: %s did not find any of the specified volumes in the mask_string %s \n",NAME_CURRENT_COMP,mask_string);
        exit(1);
    }
    this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
    this_box_volume.p_physics->is_vacuum = 0; // Makes this volume a vacuum
    this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
    this_box_volume.p_physics->my_a = 0; // Should not be used.
    sprintf(this_box_volume.p_physics->name,"Mask");
    this_box_volume.geometry.is_mask_volume = 1;
    
    
// Read the material input, or if it lacks, use automatic linking.
} else if (material_string && strlen(material_string) && strcmp(material_string, "NULL") && strcmp(material_string, "0")) {
    // A geometry string was given, use it to determine which material
    if (0 == strcmp(material_string,"vacuum") || 0 == strcmp(material_string,"Vacuum")) {
        // One could have a global physics struct for vacuum instead of creating one for each
        this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
        this_box_volume.p_physics->is_vacuum = 1; // Makes this volume a vacuum
        this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
        this_box_volume.p_physics->my_a = 0; // Should not be used.
        sprintf(this_box_volume.p_physics->name,"Vacuum");
    } else if (0 == strcmp(material_string,"exit") || 0 == strcmp(material_string,"Exit")) {
        // One could have a global physics struct for vacuum instead of creating one for each
        this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
        this_box_volume.p_physics->is_vacuum = 1; // Makes this volume a vacuum
        this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
        this_box_volume.p_physics->my_a = 0; // Should not be used.
        this_box_volume.geometry.is_exit_volume = 1;
        sprintf(this_box_volume.p_physics->name,"Exit");
    } else {
        #ifndef MATERIAL_DETECTOR
            printf("Need to define a material before refering to it in a geometry %s.\n",NAME_CURRENT_COMP);
            exit(1);
        #endif
        for (loop_index=0;loop_index<global_material_list.num_elements;loop_index++) {
            if (0 == strcmp(material_string,global_material_list.elements[loop_index].name)) {
                this_box_volume.p_physics = global_material_list.elements[loop_index].physics;
                break;
            }
            if (loop_index == global_material_list.num_elements-1) {
            printf("\n");
            printf("ERROR: The material string \"%s\" in Union geometry \"%s\" did not match a specified material. \n",material_string,NAME_CURRENT_COMP);
            printf("       The materials available at this point (need to be defined before the geometry): \n");
            for (loop_index=0;loop_index<global_material_list.num_elements;loop_index++)
              printf("         %s\n",global_material_list.elements[loop_index].name);
            printf("\n");
            printf("       It is also possible to use one of the defualt materials avaiable: \n");
            printf("           Vacuum (for a Volume without scattering or absorption)\n");
            printf("           Exit (for a Volume where the ray exits the component if it enters)\n");
            printf("           Mask (for a Volume that masks existing volumes specified in the mask_string\n");
            exit(1);
          }
        }
    }
} else {
    // Automatic linking, simply using the last defined material.
    #ifndef MATERIAL_DETECTOR
        printf("Need to define a material before the geometry to use automatic linking %s.\n",NAME_CURRENT_COMP);
        exit(1);
    #endif
    this_box_volume.p_physics = global_material_list.elements[global_material_list.num_elements-1].physics;
}

sprintf(this_box_volume.name,NAME_CURRENT_COMP);
sprintf(this_box_volume.geometry.shape,"box");
this_box_volume.geometry.priority_value = priority;
this_box_volume.geometry.geometry_p_interact = p_interact;
// Currently the coordinates will be in absolute space.
this_box_volume.geometry.center = POS_A_CURRENT_COMP;

this_box_storage.z_depth = zdepth;
this_box_storage.x_width1 = xwidth;
this_box_storage.y_height1 = yheight;

this_box_storage.is_rectangle = 0;
if (xwidth2 < 0 && yheight2 < 0) this_box_storage.is_rectangle = 1;
if (xwidth == xwidth2 && yheight == yheight2) this_box_storage.is_rectangle = 1;

if (xwidth2 < 0) {
    this_box_storage.x_width2 = xwidth;
    xwidth2 = xwidth;
} else this_box_storage.x_width2 = xwidth2;

if (yheight2 < 0) {
    this_box_storage.y_height2 = yheight;
    yheight2 = yheight;
} else this_box_storage.y_height2 = yheight2;


this_box_storage.normal_vectors[0] = coords_set(0,0,1);
this_box_storage.normal_vectors[1] = coords_set(0,0,1);

// for sides with y component = 0
x_component = 2*zdepth/sqrt((xwidth-xwidth2)*(xwidth-xwidth2)+4*zdepth*zdepth);
z_component = (xwidth-xwidth2)/sqrt(4*zdepth*zdepth+(xwidth-xwidth2)*(xwidth-xwidth2));

this_box_storage.normal_vectors[2] = coords_set(x_component,0,z_component);
this_box_storage.normal_vectors[3] = coords_set(-x_component,0,z_component);

// for sides with x component = 0
y_component = 2*zdepth/sqrt((yheight-yheight2)*(yheight-yheight2)+4*zdepth*zdepth);
z_component = (yheight-yheight2)/sqrt(4*zdepth*zdepth+(yheight-yheight2)*(yheight-yheight2));

this_box_storage.normal_vectors[4] = coords_set(0,y_component,z_component);
this_box_storage.normal_vectors[5] = coords_set(0,-y_component,z_component);

this_box_volume.geometry.visualization_on = visualize;

this_box_volume.geometry.geometry_parameters.p_box_storage = &this_box_storage;

// Assign pointers to functions for intersection with the shape, checking if a point is inside the shape
if (this_box_storage.is_rectangle == 1) {
this_box_volume.geometry.intersect_function = &sample_box_intersect_simple;
this_box_volume.geometry.within_function = &r_within_box_simple;
}
else {
this_box_volume.geometry.intersect_function = &sample_box_intersect_advanced;
this_box_volume.geometry.within_function = &r_within_box_advanced;
}

this_box_volume.geometry.shell_points = &box_shell_points;
this_box_volume.geometry.mcdisplay_function = &mcdisplay_box_function;
this_box_volume.geometry.initialize_from_main_function = &initialize_box_geometry_from_main_component;
this_box_volume.geometry.process_rot_allocated = 0;

this_box_volume.geometry.copy_geometry_parameters = &allocate_box_storage_copy;

rot_copy(this_box_volume.geometry.rotation_matrix,ROT_A_CURRENT_COMP); //check how ROT_R_CURRENT_COMP would work
rot_transpose(ROT_A_CURRENT_COMP,this_box_volume.geometry.transpose_rotation_matrix);

// Initialize loggers
this_box_volume.loggers.num_elements = 0;

// packing the information into the global_geometry_element, which is then included in the global_geometry_list.
sprintf(global_geometry_element.name,NAME_CURRENT_COMP);
global_geometry_element.activation_counter = number_of_activations;
global_geometry_element.component_index = INDEX_CURRENT_COMP;
global_geometry_element.Volume = &this_box_volume; // Would be nicer if this m was a pointer, now we have the (small) data two places
add_element_to_geometry_list(&global_geometry_list,global_geometry_element);
}
#line 237881 "MACS_sample_kidney_box.c"
#undef number_of_activations
#undef mask_setting
#undef mask_string
#undef p_interact
#undef focus_r
#undef focus_xh
#undef focus_xw
#undef focus_ah
#undef focus_aw
#undef target_z
#undef target_y
#undef target_x
#undef target_index
#undef visualize
#undef yheight2
#undef xwidth2
#undef zdepth
#undef yheight
#undef xwidth
#undef priority
#undef material_string
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

  /* Initializations for component channel_8_analyzer_1_array_crystal_array_7. */
  SIG_MESSAGE("channel_8_analyzer_1_array_crystal_array_7 (Init)");
#define mccompcurname  channel_8_analyzer_1_array_crystal_array_7
#define mccompcurtype  Union_box
#define mccompcurindex 441
#define loop_index mccchannel_8_analyzer_1_array_crystal_array_7_loop_index
#define this_box_volume mccchannel_8_analyzer_1_array_crystal_array_7_this_box_volume
#define global_geometry_element mccchannel_8_analyzer_1_array_crystal_array_7_global_geometry_element
#define this_box_storage mccchannel_8_analyzer_1_array_crystal_array_7_this_box_storage
#define material_string mccchannel_8_analyzer_1_array_crystal_array_7_material_string
#define priority mccchannel_8_analyzer_1_array_crystal_array_7_priority
#define xwidth mccchannel_8_analyzer_1_array_crystal_array_7_xwidth
#define yheight mccchannel_8_analyzer_1_array_crystal_array_7_yheight
#define zdepth mccchannel_8_analyzer_1_array_crystal_array_7_zdepth
#define xwidth2 mccchannel_8_analyzer_1_array_crystal_array_7_xwidth2
#define yheight2 mccchannel_8_analyzer_1_array_crystal_array_7_yheight2
#define visualize mccchannel_8_analyzer_1_array_crystal_array_7_visualize
#define target_index mccchannel_8_analyzer_1_array_crystal_array_7_target_index
#define target_x mccchannel_8_analyzer_1_array_crystal_array_7_target_x
#define target_y mccchannel_8_analyzer_1_array_crystal_array_7_target_y
#define target_z mccchannel_8_analyzer_1_array_crystal_array_7_target_z
#define focus_aw mccchannel_8_analyzer_1_array_crystal_array_7_focus_aw
#define focus_ah mccchannel_8_analyzer_1_array_crystal_array_7_focus_ah
#define focus_xw mccchannel_8_analyzer_1_array_crystal_array_7_focus_xw
#define focus_xh mccchannel_8_analyzer_1_array_crystal_array_7_focus_xh
#define focus_r mccchannel_8_analyzer_1_array_crystal_array_7_focus_r
#define p_interact mccchannel_8_analyzer_1_array_crystal_array_7_p_interact
#define mask_string mccchannel_8_analyzer_1_array_crystal_array_7_mask_string
#define mask_setting mccchannel_8_analyzer_1_array_crystal_array_7_mask_setting
#define number_of_activations mccchannel_8_analyzer_1_array_crystal_array_7_number_of_activations
#line 224 "Union_box.comp"
{
// Initializes the focusing system for this volume including input sanitation.
focus_initialize(&this_box_volume.geometry, POS_A_COMP_INDEX(INDEX_CURRENT_COMP+target_index), POS_A_CURRENT_COMP, ROT_A_CURRENT_COMP, target_index, target_x, target_y, target_z, focus_aw, focus_ah, focus_xw, focus_xh, focus_r, NAME_CURRENT_COMP);

// Input sanitation for this geometry
if (xwidth <= 0) {
  printf("\nERROR in Union_box named %s, the xwidth is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (yheight <= 0) {
  printf("\nERROR in Union_box named %s, yheight is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (zdepth <= 0) {
  printf("\nERROR in Union_box named %s, zdepth is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (xwidth2 <= 0 && xwidth2 != -1) {
  printf("\nERROR in Union_box named %s, the xwidth2 is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (yheight2 <= 0 && yheight2 != -1) {
  printf("\nERROR in Union_box named %s, yheight2 is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}

// Use sanitation
if (global_material_list.num_elements == 0) {
  printf("\nERROR: Need to define a material using Union_make_material before using a Union geometry component. \n");
  printf("       %s was defined before first use of Union_make_material.\n",NAME_CURRENT_COMP);
  exit(1);
}

this_box_volume.geometry.is_masked_volume = 0;
this_box_volume.geometry.is_exit_volume = 0;
this_box_volume.geometry.is_mask_volume = 0;
// check if the volume is a mask, if it is the material string is irelevant.
if (mask_string && strlen(mask_string) && strcmp(mask_string, "NULL") && strcmp(mask_string, "0")) {
    // A mask volume is used to limit the extend of other volumes, called the masked volumes. These are specified in the mask_string.
    // In order for a ray to enter a masked volume, it needs to be both in the region covered by that volume AND the mask volume.
    // When more than
    this_box_volume.geometry.mask_mode = 1; // Default is mask mode is ALL
    if (mask_setting && strlen(mask_setting) && strcmp(mask_setting, "NULL") && strcmp(mask_setting, "0")) {
        if (strcmp(mask_setting,"ALL") == 0 || strcmp(mask_setting,"All") == 0) this_box_volume.geometry.mask_mode = 1;
        else if (strcmp(mask_setting,"ANY") == 0 || strcmp(mask_setting,"Any") == 0) this_box_volume.geometry.mask_mode = 2;
        else {
            printf("The mask_mode of component %s is set to %s, but must be either ALL or ANY.\n",NAME_CURRENT_COMP,mask_setting);
            exit(1);
        }
    }
    
    for (loop_index=0;loop_index<global_geometry_list.num_elements;loop_index++) {
        // Add mask list
        if (1 == manual_linking_function(global_geometry_list.elements[loop_index].name,mask_string)) {
            add_element_to_int_list(&this_box_volume.geometry.mask_list,global_geometry_list.elements[loop_index].component_index);
            add_element_to_int_list(&global_geometry_list.elements[loop_index].Volume->geometry.masked_by_list,INDEX_CURRENT_COMP);
            global_geometry_list.elements[loop_index].Volume->geometry.is_masked_volume = 1;
            if (this_box_volume.geometry.mask_mode == 2)
                global_geometry_list.elements[loop_index].Volume->geometry.mask_mode = 2;
            if (this_box_volume.geometry.mask_mode == 1) {
                if (global_geometry_list.elements[loop_index].Volume->geometry.is_masked_volume == 1 && global_geometry_list.elements[loop_index].Volume->geometry.mask_mode != 2)
                    // If more than one mask is added to one volume, the ANY mode overwrites the (default) ALL mode.
                    global_geometry_list.elements[loop_index].Volume->geometry.mask_mode = 1;
            }
            
            found_geometries = 1;
        }
    }
    if (found_geometries == 0) {
        printf("The mask_string in geometry: %s did not find any of the specified volumes in the mask_string %s \n",NAME_CURRENT_COMP,mask_string);
        exit(1);
    }
    this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
    this_box_volume.p_physics->is_vacuum = 0; // Makes this volume a vacuum
    this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
    this_box_volume.p_physics->my_a = 0; // Should not be used.
    sprintf(this_box_volume.p_physics->name,"Mask");
    this_box_volume.geometry.is_mask_volume = 1;
    
    
// Read the material input, or if it lacks, use automatic linking.
} else if (material_string && strlen(material_string) && strcmp(material_string, "NULL") && strcmp(material_string, "0")) {
    // A geometry string was given, use it to determine which material
    if (0 == strcmp(material_string,"vacuum") || 0 == strcmp(material_string,"Vacuum")) {
        // One could have a global physics struct for vacuum instead of creating one for each
        this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
        this_box_volume.p_physics->is_vacuum = 1; // Makes this volume a vacuum
        this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
        this_box_volume.p_physics->my_a = 0; // Should not be used.
        sprintf(this_box_volume.p_physics->name,"Vacuum");
    } else if (0 == strcmp(material_string,"exit") || 0 == strcmp(material_string,"Exit")) {
        // One could have a global physics struct for vacuum instead of creating one for each
        this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
        this_box_volume.p_physics->is_vacuum = 1; // Makes this volume a vacuum
        this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
        this_box_volume.p_physics->my_a = 0; // Should not be used.
        this_box_volume.geometry.is_exit_volume = 1;
        sprintf(this_box_volume.p_physics->name,"Exit");
    } else {
        #ifndef MATERIAL_DETECTOR
            printf("Need to define a material before refering to it in a geometry %s.\n",NAME_CURRENT_COMP);
            exit(1);
        #endif
        for (loop_index=0;loop_index<global_material_list.num_elements;loop_index++) {
            if (0 == strcmp(material_string,global_material_list.elements[loop_index].name)) {
                this_box_volume.p_physics = global_material_list.elements[loop_index].physics;
                break;
            }
            if (loop_index == global_material_list.num_elements-1) {
            printf("\n");
            printf("ERROR: The material string \"%s\" in Union geometry \"%s\" did not match a specified material. \n",material_string,NAME_CURRENT_COMP);
            printf("       The materials available at this point (need to be defined before the geometry): \n");
            for (loop_index=0;loop_index<global_material_list.num_elements;loop_index++)
              printf("         %s\n",global_material_list.elements[loop_index].name);
            printf("\n");
            printf("       It is also possible to use one of the defualt materials avaiable: \n");
            printf("           Vacuum (for a Volume without scattering or absorption)\n");
            printf("           Exit (for a Volume where the ray exits the component if it enters)\n");
            printf("           Mask (for a Volume that masks existing volumes specified in the mask_string\n");
            exit(1);
          }
        }
    }
} else {
    // Automatic linking, simply using the last defined material.
    #ifndef MATERIAL_DETECTOR
        printf("Need to define a material before the geometry to use automatic linking %s.\n",NAME_CURRENT_COMP);
        exit(1);
    #endif
    this_box_volume.p_physics = global_material_list.elements[global_material_list.num_elements-1].physics;
}

sprintf(this_box_volume.name,NAME_CURRENT_COMP);
sprintf(this_box_volume.geometry.shape,"box");
this_box_volume.geometry.priority_value = priority;
this_box_volume.geometry.geometry_p_interact = p_interact;
// Currently the coordinates will be in absolute space.
this_box_volume.geometry.center = POS_A_CURRENT_COMP;

this_box_storage.z_depth = zdepth;
this_box_storage.x_width1 = xwidth;
this_box_storage.y_height1 = yheight;

this_box_storage.is_rectangle = 0;
if (xwidth2 < 0 && yheight2 < 0) this_box_storage.is_rectangle = 1;
if (xwidth == xwidth2 && yheight == yheight2) this_box_storage.is_rectangle = 1;

if (xwidth2 < 0) {
    this_box_storage.x_width2 = xwidth;
    xwidth2 = xwidth;
} else this_box_storage.x_width2 = xwidth2;

if (yheight2 < 0) {
    this_box_storage.y_height2 = yheight;
    yheight2 = yheight;
} else this_box_storage.y_height2 = yheight2;


this_box_storage.normal_vectors[0] = coords_set(0,0,1);
this_box_storage.normal_vectors[1] = coords_set(0,0,1);

// for sides with y component = 0
x_component = 2*zdepth/sqrt((xwidth-xwidth2)*(xwidth-xwidth2)+4*zdepth*zdepth);
z_component = (xwidth-xwidth2)/sqrt(4*zdepth*zdepth+(xwidth-xwidth2)*(xwidth-xwidth2));

this_box_storage.normal_vectors[2] = coords_set(x_component,0,z_component);
this_box_storage.normal_vectors[3] = coords_set(-x_component,0,z_component);

// for sides with x component = 0
y_component = 2*zdepth/sqrt((yheight-yheight2)*(yheight-yheight2)+4*zdepth*zdepth);
z_component = (yheight-yheight2)/sqrt(4*zdepth*zdepth+(yheight-yheight2)*(yheight-yheight2));

this_box_storage.normal_vectors[4] = coords_set(0,y_component,z_component);
this_box_storage.normal_vectors[5] = coords_set(0,-y_component,z_component);

this_box_volume.geometry.visualization_on = visualize;

this_box_volume.geometry.geometry_parameters.p_box_storage = &this_box_storage;

// Assign pointers to functions for intersection with the shape, checking if a point is inside the shape
if (this_box_storage.is_rectangle == 1) {
this_box_volume.geometry.intersect_function = &sample_box_intersect_simple;
this_box_volume.geometry.within_function = &r_within_box_simple;
}
else {
this_box_volume.geometry.intersect_function = &sample_box_intersect_advanced;
this_box_volume.geometry.within_function = &r_within_box_advanced;
}

this_box_volume.geometry.shell_points = &box_shell_points;
this_box_volume.geometry.mcdisplay_function = &mcdisplay_box_function;
this_box_volume.geometry.initialize_from_main_function = &initialize_box_geometry_from_main_component;
this_box_volume.geometry.process_rot_allocated = 0;

this_box_volume.geometry.copy_geometry_parameters = &allocate_box_storage_copy;

rot_copy(this_box_volume.geometry.rotation_matrix,ROT_A_CURRENT_COMP); //check how ROT_R_CURRENT_COMP would work
rot_transpose(ROT_A_CURRENT_COMP,this_box_volume.geometry.transpose_rotation_matrix);

// Initialize loggers
this_box_volume.loggers.num_elements = 0;

// packing the information into the global_geometry_element, which is then included in the global_geometry_list.
sprintf(global_geometry_element.name,NAME_CURRENT_COMP);
global_geometry_element.activation_counter = number_of_activations;
global_geometry_element.component_index = INDEX_CURRENT_COMP;
global_geometry_element.Volume = &this_box_volume; // Would be nicer if this m was a pointer, now we have the (small) data two places
add_element_to_geometry_list(&global_geometry_list,global_geometry_element);
}
#line 238151 "MACS_sample_kidney_box.c"
#undef number_of_activations
#undef mask_setting
#undef mask_string
#undef p_interact
#undef focus_r
#undef focus_xh
#undef focus_xw
#undef focus_ah
#undef focus_aw
#undef target_z
#undef target_y
#undef target_x
#undef target_index
#undef visualize
#undef yheight2
#undef xwidth2
#undef zdepth
#undef yheight
#undef xwidth
#undef priority
#undef material_string
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

  /* Initializations for component channel_8_analyzer_1_array_crystal_array_8. */
  SIG_MESSAGE("channel_8_analyzer_1_array_crystal_array_8 (Init)");
#define mccompcurname  channel_8_analyzer_1_array_crystal_array_8
#define mccompcurtype  Union_box
#define mccompcurindex 442
#define loop_index mccchannel_8_analyzer_1_array_crystal_array_8_loop_index
#define this_box_volume mccchannel_8_analyzer_1_array_crystal_array_8_this_box_volume
#define global_geometry_element mccchannel_8_analyzer_1_array_crystal_array_8_global_geometry_element
#define this_box_storage mccchannel_8_analyzer_1_array_crystal_array_8_this_box_storage
#define material_string mccchannel_8_analyzer_1_array_crystal_array_8_material_string
#define priority mccchannel_8_analyzer_1_array_crystal_array_8_priority
#define xwidth mccchannel_8_analyzer_1_array_crystal_array_8_xwidth
#define yheight mccchannel_8_analyzer_1_array_crystal_array_8_yheight
#define zdepth mccchannel_8_analyzer_1_array_crystal_array_8_zdepth
#define xwidth2 mccchannel_8_analyzer_1_array_crystal_array_8_xwidth2
#define yheight2 mccchannel_8_analyzer_1_array_crystal_array_8_yheight2
#define visualize mccchannel_8_analyzer_1_array_crystal_array_8_visualize
#define target_index mccchannel_8_analyzer_1_array_crystal_array_8_target_index
#define target_x mccchannel_8_analyzer_1_array_crystal_array_8_target_x
#define target_y mccchannel_8_analyzer_1_array_crystal_array_8_target_y
#define target_z mccchannel_8_analyzer_1_array_crystal_array_8_target_z
#define focus_aw mccchannel_8_analyzer_1_array_crystal_array_8_focus_aw
#define focus_ah mccchannel_8_analyzer_1_array_crystal_array_8_focus_ah
#define focus_xw mccchannel_8_analyzer_1_array_crystal_array_8_focus_xw
#define focus_xh mccchannel_8_analyzer_1_array_crystal_array_8_focus_xh
#define focus_r mccchannel_8_analyzer_1_array_crystal_array_8_focus_r
#define p_interact mccchannel_8_analyzer_1_array_crystal_array_8_p_interact
#define mask_string mccchannel_8_analyzer_1_array_crystal_array_8_mask_string
#define mask_setting mccchannel_8_analyzer_1_array_crystal_array_8_mask_setting
#define number_of_activations mccchannel_8_analyzer_1_array_crystal_array_8_number_of_activations
#line 224 "Union_box.comp"
{
// Initializes the focusing system for this volume including input sanitation.
focus_initialize(&this_box_volume.geometry, POS_A_COMP_INDEX(INDEX_CURRENT_COMP+target_index), POS_A_CURRENT_COMP, ROT_A_CURRENT_COMP, target_index, target_x, target_y, target_z, focus_aw, focus_ah, focus_xw, focus_xh, focus_r, NAME_CURRENT_COMP);

// Input sanitation for this geometry
if (xwidth <= 0) {
  printf("\nERROR in Union_box named %s, the xwidth is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (yheight <= 0) {
  printf("\nERROR in Union_box named %s, yheight is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (zdepth <= 0) {
  printf("\nERROR in Union_box named %s, zdepth is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (xwidth2 <= 0 && xwidth2 != -1) {
  printf("\nERROR in Union_box named %s, the xwidth2 is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (yheight2 <= 0 && yheight2 != -1) {
  printf("\nERROR in Union_box named %s, yheight2 is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}

// Use sanitation
if (global_material_list.num_elements == 0) {
  printf("\nERROR: Need to define a material using Union_make_material before using a Union geometry component. \n");
  printf("       %s was defined before first use of Union_make_material.\n",NAME_CURRENT_COMP);
  exit(1);
}

this_box_volume.geometry.is_masked_volume = 0;
this_box_volume.geometry.is_exit_volume = 0;
this_box_volume.geometry.is_mask_volume = 0;
// check if the volume is a mask, if it is the material string is irelevant.
if (mask_string && strlen(mask_string) && strcmp(mask_string, "NULL") && strcmp(mask_string, "0")) {
    // A mask volume is used to limit the extend of other volumes, called the masked volumes. These are specified in the mask_string.
    // In order for a ray to enter a masked volume, it needs to be both in the region covered by that volume AND the mask volume.
    // When more than
    this_box_volume.geometry.mask_mode = 1; // Default is mask mode is ALL
    if (mask_setting && strlen(mask_setting) && strcmp(mask_setting, "NULL") && strcmp(mask_setting, "0")) {
        if (strcmp(mask_setting,"ALL") == 0 || strcmp(mask_setting,"All") == 0) this_box_volume.geometry.mask_mode = 1;
        else if (strcmp(mask_setting,"ANY") == 0 || strcmp(mask_setting,"Any") == 0) this_box_volume.geometry.mask_mode = 2;
        else {
            printf("The mask_mode of component %s is set to %s, but must be either ALL or ANY.\n",NAME_CURRENT_COMP,mask_setting);
            exit(1);
        }
    }
    
    for (loop_index=0;loop_index<global_geometry_list.num_elements;loop_index++) {
        // Add mask list
        if (1 == manual_linking_function(global_geometry_list.elements[loop_index].name,mask_string)) {
            add_element_to_int_list(&this_box_volume.geometry.mask_list,global_geometry_list.elements[loop_index].component_index);
            add_element_to_int_list(&global_geometry_list.elements[loop_index].Volume->geometry.masked_by_list,INDEX_CURRENT_COMP);
            global_geometry_list.elements[loop_index].Volume->geometry.is_masked_volume = 1;
            if (this_box_volume.geometry.mask_mode == 2)
                global_geometry_list.elements[loop_index].Volume->geometry.mask_mode = 2;
            if (this_box_volume.geometry.mask_mode == 1) {
                if (global_geometry_list.elements[loop_index].Volume->geometry.is_masked_volume == 1 && global_geometry_list.elements[loop_index].Volume->geometry.mask_mode != 2)
                    // If more than one mask is added to one volume, the ANY mode overwrites the (default) ALL mode.
                    global_geometry_list.elements[loop_index].Volume->geometry.mask_mode = 1;
            }
            
            found_geometries = 1;
        }
    }
    if (found_geometries == 0) {
        printf("The mask_string in geometry: %s did not find any of the specified volumes in the mask_string %s \n",NAME_CURRENT_COMP,mask_string);
        exit(1);
    }
    this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
    this_box_volume.p_physics->is_vacuum = 0; // Makes this volume a vacuum
    this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
    this_box_volume.p_physics->my_a = 0; // Should not be used.
    sprintf(this_box_volume.p_physics->name,"Mask");
    this_box_volume.geometry.is_mask_volume = 1;
    
    
// Read the material input, or if it lacks, use automatic linking.
} else if (material_string && strlen(material_string) && strcmp(material_string, "NULL") && strcmp(material_string, "0")) {
    // A geometry string was given, use it to determine which material
    if (0 == strcmp(material_string,"vacuum") || 0 == strcmp(material_string,"Vacuum")) {
        // One could have a global physics struct for vacuum instead of creating one for each
        this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
        this_box_volume.p_physics->is_vacuum = 1; // Makes this volume a vacuum
        this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
        this_box_volume.p_physics->my_a = 0; // Should not be used.
        sprintf(this_box_volume.p_physics->name,"Vacuum");
    } else if (0 == strcmp(material_string,"exit") || 0 == strcmp(material_string,"Exit")) {
        // One could have a global physics struct for vacuum instead of creating one for each
        this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
        this_box_volume.p_physics->is_vacuum = 1; // Makes this volume a vacuum
        this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
        this_box_volume.p_physics->my_a = 0; // Should not be used.
        this_box_volume.geometry.is_exit_volume = 1;
        sprintf(this_box_volume.p_physics->name,"Exit");
    } else {
        #ifndef MATERIAL_DETECTOR
            printf("Need to define a material before refering to it in a geometry %s.\n",NAME_CURRENT_COMP);
            exit(1);
        #endif
        for (loop_index=0;loop_index<global_material_list.num_elements;loop_index++) {
            if (0 == strcmp(material_string,global_material_list.elements[loop_index].name)) {
                this_box_volume.p_physics = global_material_list.elements[loop_index].physics;
                break;
            }
            if (loop_index == global_material_list.num_elements-1) {
            printf("\n");
            printf("ERROR: The material string \"%s\" in Union geometry \"%s\" did not match a specified material. \n",material_string,NAME_CURRENT_COMP);
            printf("       The materials available at this point (need to be defined before the geometry): \n");
            for (loop_index=0;loop_index<global_material_list.num_elements;loop_index++)
              printf("         %s\n",global_material_list.elements[loop_index].name);
            printf("\n");
            printf("       It is also possible to use one of the defualt materials avaiable: \n");
            printf("           Vacuum (for a Volume without scattering or absorption)\n");
            printf("           Exit (for a Volume where the ray exits the component if it enters)\n");
            printf("           Mask (for a Volume that masks existing volumes specified in the mask_string\n");
            exit(1);
          }
        }
    }
} else {
    // Automatic linking, simply using the last defined material.
    #ifndef MATERIAL_DETECTOR
        printf("Need to define a material before the geometry to use automatic linking %s.\n",NAME_CURRENT_COMP);
        exit(1);
    #endif
    this_box_volume.p_physics = global_material_list.elements[global_material_list.num_elements-1].physics;
}

sprintf(this_box_volume.name,NAME_CURRENT_COMP);
sprintf(this_box_volume.geometry.shape,"box");
this_box_volume.geometry.priority_value = priority;
this_box_volume.geometry.geometry_p_interact = p_interact;
// Currently the coordinates will be in absolute space.
this_box_volume.geometry.center = POS_A_CURRENT_COMP;

this_box_storage.z_depth = zdepth;
this_box_storage.x_width1 = xwidth;
this_box_storage.y_height1 = yheight;

this_box_storage.is_rectangle = 0;
if (xwidth2 < 0 && yheight2 < 0) this_box_storage.is_rectangle = 1;
if (xwidth == xwidth2 && yheight == yheight2) this_box_storage.is_rectangle = 1;

if (xwidth2 < 0) {
    this_box_storage.x_width2 = xwidth;
    xwidth2 = xwidth;
} else this_box_storage.x_width2 = xwidth2;

if (yheight2 < 0) {
    this_box_storage.y_height2 = yheight;
    yheight2 = yheight;
} else this_box_storage.y_height2 = yheight2;


this_box_storage.normal_vectors[0] = coords_set(0,0,1);
this_box_storage.normal_vectors[1] = coords_set(0,0,1);

// for sides with y component = 0
x_component = 2*zdepth/sqrt((xwidth-xwidth2)*(xwidth-xwidth2)+4*zdepth*zdepth);
z_component = (xwidth-xwidth2)/sqrt(4*zdepth*zdepth+(xwidth-xwidth2)*(xwidth-xwidth2));

this_box_storage.normal_vectors[2] = coords_set(x_component,0,z_component);
this_box_storage.normal_vectors[3] = coords_set(-x_component,0,z_component);

// for sides with x component = 0
y_component = 2*zdepth/sqrt((yheight-yheight2)*(yheight-yheight2)+4*zdepth*zdepth);
z_component = (yheight-yheight2)/sqrt(4*zdepth*zdepth+(yheight-yheight2)*(yheight-yheight2));

this_box_storage.normal_vectors[4] = coords_set(0,y_component,z_component);
this_box_storage.normal_vectors[5] = coords_set(0,-y_component,z_component);

this_box_volume.geometry.visualization_on = visualize;

this_box_volume.geometry.geometry_parameters.p_box_storage = &this_box_storage;

// Assign pointers to functions for intersection with the shape, checking if a point is inside the shape
if (this_box_storage.is_rectangle == 1) {
this_box_volume.geometry.intersect_function = &sample_box_intersect_simple;
this_box_volume.geometry.within_function = &r_within_box_simple;
}
else {
this_box_volume.geometry.intersect_function = &sample_box_intersect_advanced;
this_box_volume.geometry.within_function = &r_within_box_advanced;
}

this_box_volume.geometry.shell_points = &box_shell_points;
this_box_volume.geometry.mcdisplay_function = &mcdisplay_box_function;
this_box_volume.geometry.initialize_from_main_function = &initialize_box_geometry_from_main_component;
this_box_volume.geometry.process_rot_allocated = 0;

this_box_volume.geometry.copy_geometry_parameters = &allocate_box_storage_copy;

rot_copy(this_box_volume.geometry.rotation_matrix,ROT_A_CURRENT_COMP); //check how ROT_R_CURRENT_COMP would work
rot_transpose(ROT_A_CURRENT_COMP,this_box_volume.geometry.transpose_rotation_matrix);

// Initialize loggers
this_box_volume.loggers.num_elements = 0;

// packing the information into the global_geometry_element, which is then included in the global_geometry_list.
sprintf(global_geometry_element.name,NAME_CURRENT_COMP);
global_geometry_element.activation_counter = number_of_activations;
global_geometry_element.component_index = INDEX_CURRENT_COMP;
global_geometry_element.Volume = &this_box_volume; // Would be nicer if this m was a pointer, now we have the (small) data two places
add_element_to_geometry_list(&global_geometry_list,global_geometry_element);
}
#line 238421 "MACS_sample_kidney_box.c"
#undef number_of_activations
#undef mask_setting
#undef mask_string
#undef p_interact
#undef focus_r
#undef focus_xh
#undef focus_xw
#undef focus_ah
#undef focus_aw
#undef target_z
#undef target_y
#undef target_x
#undef target_index
#undef visualize
#undef yheight2
#undef xwidth2
#undef zdepth
#undef yheight
#undef xwidth
#undef priority
#undef material_string
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

  /* Initializations for component channel_8_analyzer_2_center. */
  SIG_MESSAGE("channel_8_analyzer_2_center (Init)");

  /* Initializations for component channel_8_analyzer_2_rotated. */
  SIG_MESSAGE("channel_8_analyzer_2_rotated (Init)");

  /* Initializations for component channel_8_analyzer_2_array_crystal_array_0. */
  SIG_MESSAGE("channel_8_analyzer_2_array_crystal_array_0 (Init)");
#define mccompcurname  channel_8_analyzer_2_array_crystal_array_0
#define mccompcurtype  Union_box
#define mccompcurindex 445
#define loop_index mccchannel_8_analyzer_2_array_crystal_array_0_loop_index
#define this_box_volume mccchannel_8_analyzer_2_array_crystal_array_0_this_box_volume
#define global_geometry_element mccchannel_8_analyzer_2_array_crystal_array_0_global_geometry_element
#define this_box_storage mccchannel_8_analyzer_2_array_crystal_array_0_this_box_storage
#define material_string mccchannel_8_analyzer_2_array_crystal_array_0_material_string
#define priority mccchannel_8_analyzer_2_array_crystal_array_0_priority
#define xwidth mccchannel_8_analyzer_2_array_crystal_array_0_xwidth
#define yheight mccchannel_8_analyzer_2_array_crystal_array_0_yheight
#define zdepth mccchannel_8_analyzer_2_array_crystal_array_0_zdepth
#define xwidth2 mccchannel_8_analyzer_2_array_crystal_array_0_xwidth2
#define yheight2 mccchannel_8_analyzer_2_array_crystal_array_0_yheight2
#define visualize mccchannel_8_analyzer_2_array_crystal_array_0_visualize
#define target_index mccchannel_8_analyzer_2_array_crystal_array_0_target_index
#define target_x mccchannel_8_analyzer_2_array_crystal_array_0_target_x
#define target_y mccchannel_8_analyzer_2_array_crystal_array_0_target_y
#define target_z mccchannel_8_analyzer_2_array_crystal_array_0_target_z
#define focus_aw mccchannel_8_analyzer_2_array_crystal_array_0_focus_aw
#define focus_ah mccchannel_8_analyzer_2_array_crystal_array_0_focus_ah
#define focus_xw mccchannel_8_analyzer_2_array_crystal_array_0_focus_xw
#define focus_xh mccchannel_8_analyzer_2_array_crystal_array_0_focus_xh
#define focus_r mccchannel_8_analyzer_2_array_crystal_array_0_focus_r
#define p_interact mccchannel_8_analyzer_2_array_crystal_array_0_p_interact
#define mask_string mccchannel_8_analyzer_2_array_crystal_array_0_mask_string
#define mask_setting mccchannel_8_analyzer_2_array_crystal_array_0_mask_setting
#define number_of_activations mccchannel_8_analyzer_2_array_crystal_array_0_number_of_activations
#line 224 "Union_box.comp"
{
// Initializes the focusing system for this volume including input sanitation.
focus_initialize(&this_box_volume.geometry, POS_A_COMP_INDEX(INDEX_CURRENT_COMP+target_index), POS_A_CURRENT_COMP, ROT_A_CURRENT_COMP, target_index, target_x, target_y, target_z, focus_aw, focus_ah, focus_xw, focus_xh, focus_r, NAME_CURRENT_COMP);

// Input sanitation for this geometry
if (xwidth <= 0) {
  printf("\nERROR in Union_box named %s, the xwidth is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (yheight <= 0) {
  printf("\nERROR in Union_box named %s, yheight is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (zdepth <= 0) {
  printf("\nERROR in Union_box named %s, zdepth is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (xwidth2 <= 0 && xwidth2 != -1) {
  printf("\nERROR in Union_box named %s, the xwidth2 is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (yheight2 <= 0 && yheight2 != -1) {
  printf("\nERROR in Union_box named %s, yheight2 is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}

// Use sanitation
if (global_material_list.num_elements == 0) {
  printf("\nERROR: Need to define a material using Union_make_material before using a Union geometry component. \n");
  printf("       %s was defined before first use of Union_make_material.\n",NAME_CURRENT_COMP);
  exit(1);
}

this_box_volume.geometry.is_masked_volume = 0;
this_box_volume.geometry.is_exit_volume = 0;
this_box_volume.geometry.is_mask_volume = 0;
// check if the volume is a mask, if it is the material string is irelevant.
if (mask_string && strlen(mask_string) && strcmp(mask_string, "NULL") && strcmp(mask_string, "0")) {
    // A mask volume is used to limit the extend of other volumes, called the masked volumes. These are specified in the mask_string.
    // In order for a ray to enter a masked volume, it needs to be both in the region covered by that volume AND the mask volume.
    // When more than
    this_box_volume.geometry.mask_mode = 1; // Default is mask mode is ALL
    if (mask_setting && strlen(mask_setting) && strcmp(mask_setting, "NULL") && strcmp(mask_setting, "0")) {
        if (strcmp(mask_setting,"ALL") == 0 || strcmp(mask_setting,"All") == 0) this_box_volume.geometry.mask_mode = 1;
        else if (strcmp(mask_setting,"ANY") == 0 || strcmp(mask_setting,"Any") == 0) this_box_volume.geometry.mask_mode = 2;
        else {
            printf("The mask_mode of component %s is set to %s, but must be either ALL or ANY.\n",NAME_CURRENT_COMP,mask_setting);
            exit(1);
        }
    }
    
    for (loop_index=0;loop_index<global_geometry_list.num_elements;loop_index++) {
        // Add mask list
        if (1 == manual_linking_function(global_geometry_list.elements[loop_index].name,mask_string)) {
            add_element_to_int_list(&this_box_volume.geometry.mask_list,global_geometry_list.elements[loop_index].component_index);
            add_element_to_int_list(&global_geometry_list.elements[loop_index].Volume->geometry.masked_by_list,INDEX_CURRENT_COMP);
            global_geometry_list.elements[loop_index].Volume->geometry.is_masked_volume = 1;
            if (this_box_volume.geometry.mask_mode == 2)
                global_geometry_list.elements[loop_index].Volume->geometry.mask_mode = 2;
            if (this_box_volume.geometry.mask_mode == 1) {
                if (global_geometry_list.elements[loop_index].Volume->geometry.is_masked_volume == 1 && global_geometry_list.elements[loop_index].Volume->geometry.mask_mode != 2)
                    // If more than one mask is added to one volume, the ANY mode overwrites the (default) ALL mode.
                    global_geometry_list.elements[loop_index].Volume->geometry.mask_mode = 1;
            }
            
            found_geometries = 1;
        }
    }
    if (found_geometries == 0) {
        printf("The mask_string in geometry: %s did not find any of the specified volumes in the mask_string %s \n",NAME_CURRENT_COMP,mask_string);
        exit(1);
    }
    this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
    this_box_volume.p_physics->is_vacuum = 0; // Makes this volume a vacuum
    this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
    this_box_volume.p_physics->my_a = 0; // Should not be used.
    sprintf(this_box_volume.p_physics->name,"Mask");
    this_box_volume.geometry.is_mask_volume = 1;
    
    
// Read the material input, or if it lacks, use automatic linking.
} else if (material_string && strlen(material_string) && strcmp(material_string, "NULL") && strcmp(material_string, "0")) {
    // A geometry string was given, use it to determine which material
    if (0 == strcmp(material_string,"vacuum") || 0 == strcmp(material_string,"Vacuum")) {
        // One could have a global physics struct for vacuum instead of creating one for each
        this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
        this_box_volume.p_physics->is_vacuum = 1; // Makes this volume a vacuum
        this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
        this_box_volume.p_physics->my_a = 0; // Should not be used.
        sprintf(this_box_volume.p_physics->name,"Vacuum");
    } else if (0 == strcmp(material_string,"exit") || 0 == strcmp(material_string,"Exit")) {
        // One could have a global physics struct for vacuum instead of creating one for each
        this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
        this_box_volume.p_physics->is_vacuum = 1; // Makes this volume a vacuum
        this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
        this_box_volume.p_physics->my_a = 0; // Should not be used.
        this_box_volume.geometry.is_exit_volume = 1;
        sprintf(this_box_volume.p_physics->name,"Exit");
    } else {
        #ifndef MATERIAL_DETECTOR
            printf("Need to define a material before refering to it in a geometry %s.\n",NAME_CURRENT_COMP);
            exit(1);
        #endif
        for (loop_index=0;loop_index<global_material_list.num_elements;loop_index++) {
            if (0 == strcmp(material_string,global_material_list.elements[loop_index].name)) {
                this_box_volume.p_physics = global_material_list.elements[loop_index].physics;
                break;
            }
            if (loop_index == global_material_list.num_elements-1) {
            printf("\n");
            printf("ERROR: The material string \"%s\" in Union geometry \"%s\" did not match a specified material. \n",material_string,NAME_CURRENT_COMP);
            printf("       The materials available at this point (need to be defined before the geometry): \n");
            for (loop_index=0;loop_index<global_material_list.num_elements;loop_index++)
              printf("         %s\n",global_material_list.elements[loop_index].name);
            printf("\n");
            printf("       It is also possible to use one of the defualt materials avaiable: \n");
            printf("           Vacuum (for a Volume without scattering or absorption)\n");
            printf("           Exit (for a Volume where the ray exits the component if it enters)\n");
            printf("           Mask (for a Volume that masks existing volumes specified in the mask_string\n");
            exit(1);
          }
        }
    }
} else {
    // Automatic linking, simply using the last defined material.
    #ifndef MATERIAL_DETECTOR
        printf("Need to define a material before the geometry to use automatic linking %s.\n",NAME_CURRENT_COMP);
        exit(1);
    #endif
    this_box_volume.p_physics = global_material_list.elements[global_material_list.num_elements-1].physics;
}

sprintf(this_box_volume.name,NAME_CURRENT_COMP);
sprintf(this_box_volume.geometry.shape,"box");
this_box_volume.geometry.priority_value = priority;
this_box_volume.geometry.geometry_p_interact = p_interact;
// Currently the coordinates will be in absolute space.
this_box_volume.geometry.center = POS_A_CURRENT_COMP;

this_box_storage.z_depth = zdepth;
this_box_storage.x_width1 = xwidth;
this_box_storage.y_height1 = yheight;

this_box_storage.is_rectangle = 0;
if (xwidth2 < 0 && yheight2 < 0) this_box_storage.is_rectangle = 1;
if (xwidth == xwidth2 && yheight == yheight2) this_box_storage.is_rectangle = 1;

if (xwidth2 < 0) {
    this_box_storage.x_width2 = xwidth;
    xwidth2 = xwidth;
} else this_box_storage.x_width2 = xwidth2;

if (yheight2 < 0) {
    this_box_storage.y_height2 = yheight;
    yheight2 = yheight;
} else this_box_storage.y_height2 = yheight2;


this_box_storage.normal_vectors[0] = coords_set(0,0,1);
this_box_storage.normal_vectors[1] = coords_set(0,0,1);

// for sides with y component = 0
x_component = 2*zdepth/sqrt((xwidth-xwidth2)*(xwidth-xwidth2)+4*zdepth*zdepth);
z_component = (xwidth-xwidth2)/sqrt(4*zdepth*zdepth+(xwidth-xwidth2)*(xwidth-xwidth2));

this_box_storage.normal_vectors[2] = coords_set(x_component,0,z_component);
this_box_storage.normal_vectors[3] = coords_set(-x_component,0,z_component);

// for sides with x component = 0
y_component = 2*zdepth/sqrt((yheight-yheight2)*(yheight-yheight2)+4*zdepth*zdepth);
z_component = (yheight-yheight2)/sqrt(4*zdepth*zdepth+(yheight-yheight2)*(yheight-yheight2));

this_box_storage.normal_vectors[4] = coords_set(0,y_component,z_component);
this_box_storage.normal_vectors[5] = coords_set(0,-y_component,z_component);

this_box_volume.geometry.visualization_on = visualize;

this_box_volume.geometry.geometry_parameters.p_box_storage = &this_box_storage;

// Assign pointers to functions for intersection with the shape, checking if a point is inside the shape
if (this_box_storage.is_rectangle == 1) {
this_box_volume.geometry.intersect_function = &sample_box_intersect_simple;
this_box_volume.geometry.within_function = &r_within_box_simple;
}
else {
this_box_volume.geometry.intersect_function = &sample_box_intersect_advanced;
this_box_volume.geometry.within_function = &r_within_box_advanced;
}

this_box_volume.geometry.shell_points = &box_shell_points;
this_box_volume.geometry.mcdisplay_function = &mcdisplay_box_function;
this_box_volume.geometry.initialize_from_main_function = &initialize_box_geometry_from_main_component;
this_box_volume.geometry.process_rot_allocated = 0;

this_box_volume.geometry.copy_geometry_parameters = &allocate_box_storage_copy;

rot_copy(this_box_volume.geometry.rotation_matrix,ROT_A_CURRENT_COMP); //check how ROT_R_CURRENT_COMP would work
rot_transpose(ROT_A_CURRENT_COMP,this_box_volume.geometry.transpose_rotation_matrix);

// Initialize loggers
this_box_volume.loggers.num_elements = 0;

// packing the information into the global_geometry_element, which is then included in the global_geometry_list.
sprintf(global_geometry_element.name,NAME_CURRENT_COMP);
global_geometry_element.activation_counter = number_of_activations;
global_geometry_element.component_index = INDEX_CURRENT_COMP;
global_geometry_element.Volume = &this_box_volume; // Would be nicer if this m was a pointer, now we have the (small) data two places
add_element_to_geometry_list(&global_geometry_list,global_geometry_element);
}
#line 238697 "MACS_sample_kidney_box.c"
#undef number_of_activations
#undef mask_setting
#undef mask_string
#undef p_interact
#undef focus_r
#undef focus_xh
#undef focus_xw
#undef focus_ah
#undef focus_aw
#undef target_z
#undef target_y
#undef target_x
#undef target_index
#undef visualize
#undef yheight2
#undef xwidth2
#undef zdepth
#undef yheight
#undef xwidth
#undef priority
#undef material_string
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

  /* Initializations for component channel_8_analyzer_2_array_crystal_array_1. */
  SIG_MESSAGE("channel_8_analyzer_2_array_crystal_array_1 (Init)");
#define mccompcurname  channel_8_analyzer_2_array_crystal_array_1
#define mccompcurtype  Union_box
#define mccompcurindex 446
#define loop_index mccchannel_8_analyzer_2_array_crystal_array_1_loop_index
#define this_box_volume mccchannel_8_analyzer_2_array_crystal_array_1_this_box_volume
#define global_geometry_element mccchannel_8_analyzer_2_array_crystal_array_1_global_geometry_element
#define this_box_storage mccchannel_8_analyzer_2_array_crystal_array_1_this_box_storage
#define material_string mccchannel_8_analyzer_2_array_crystal_array_1_material_string
#define priority mccchannel_8_analyzer_2_array_crystal_array_1_priority
#define xwidth mccchannel_8_analyzer_2_array_crystal_array_1_xwidth
#define yheight mccchannel_8_analyzer_2_array_crystal_array_1_yheight
#define zdepth mccchannel_8_analyzer_2_array_crystal_array_1_zdepth
#define xwidth2 mccchannel_8_analyzer_2_array_crystal_array_1_xwidth2
#define yheight2 mccchannel_8_analyzer_2_array_crystal_array_1_yheight2
#define visualize mccchannel_8_analyzer_2_array_crystal_array_1_visualize
#define target_index mccchannel_8_analyzer_2_array_crystal_array_1_target_index
#define target_x mccchannel_8_analyzer_2_array_crystal_array_1_target_x
#define target_y mccchannel_8_analyzer_2_array_crystal_array_1_target_y
#define target_z mccchannel_8_analyzer_2_array_crystal_array_1_target_z
#define focus_aw mccchannel_8_analyzer_2_array_crystal_array_1_focus_aw
#define focus_ah mccchannel_8_analyzer_2_array_crystal_array_1_focus_ah
#define focus_xw mccchannel_8_analyzer_2_array_crystal_array_1_focus_xw
#define focus_xh mccchannel_8_analyzer_2_array_crystal_array_1_focus_xh
#define focus_r mccchannel_8_analyzer_2_array_crystal_array_1_focus_r
#define p_interact mccchannel_8_analyzer_2_array_crystal_array_1_p_interact
#define mask_string mccchannel_8_analyzer_2_array_crystal_array_1_mask_string
#define mask_setting mccchannel_8_analyzer_2_array_crystal_array_1_mask_setting
#define number_of_activations mccchannel_8_analyzer_2_array_crystal_array_1_number_of_activations
#line 224 "Union_box.comp"
{
// Initializes the focusing system for this volume including input sanitation.
focus_initialize(&this_box_volume.geometry, POS_A_COMP_INDEX(INDEX_CURRENT_COMP+target_index), POS_A_CURRENT_COMP, ROT_A_CURRENT_COMP, target_index, target_x, target_y, target_z, focus_aw, focus_ah, focus_xw, focus_xh, focus_r, NAME_CURRENT_COMP);

// Input sanitation for this geometry
if (xwidth <= 0) {
  printf("\nERROR in Union_box named %s, the xwidth is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (yheight <= 0) {
  printf("\nERROR in Union_box named %s, yheight is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (zdepth <= 0) {
  printf("\nERROR in Union_box named %s, zdepth is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (xwidth2 <= 0 && xwidth2 != -1) {
  printf("\nERROR in Union_box named %s, the xwidth2 is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (yheight2 <= 0 && yheight2 != -1) {
  printf("\nERROR in Union_box named %s, yheight2 is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}

// Use sanitation
if (global_material_list.num_elements == 0) {
  printf("\nERROR: Need to define a material using Union_make_material before using a Union geometry component. \n");
  printf("       %s was defined before first use of Union_make_material.\n",NAME_CURRENT_COMP);
  exit(1);
}

this_box_volume.geometry.is_masked_volume = 0;
this_box_volume.geometry.is_exit_volume = 0;
this_box_volume.geometry.is_mask_volume = 0;
// check if the volume is a mask, if it is the material string is irelevant.
if (mask_string && strlen(mask_string) && strcmp(mask_string, "NULL") && strcmp(mask_string, "0")) {
    // A mask volume is used to limit the extend of other volumes, called the masked volumes. These are specified in the mask_string.
    // In order for a ray to enter a masked volume, it needs to be both in the region covered by that volume AND the mask volume.
    // When more than
    this_box_volume.geometry.mask_mode = 1; // Default is mask mode is ALL
    if (mask_setting && strlen(mask_setting) && strcmp(mask_setting, "NULL") && strcmp(mask_setting, "0")) {
        if (strcmp(mask_setting,"ALL") == 0 || strcmp(mask_setting,"All") == 0) this_box_volume.geometry.mask_mode = 1;
        else if (strcmp(mask_setting,"ANY") == 0 || strcmp(mask_setting,"Any") == 0) this_box_volume.geometry.mask_mode = 2;
        else {
            printf("The mask_mode of component %s is set to %s, but must be either ALL or ANY.\n",NAME_CURRENT_COMP,mask_setting);
            exit(1);
        }
    }
    
    for (loop_index=0;loop_index<global_geometry_list.num_elements;loop_index++) {
        // Add mask list
        if (1 == manual_linking_function(global_geometry_list.elements[loop_index].name,mask_string)) {
            add_element_to_int_list(&this_box_volume.geometry.mask_list,global_geometry_list.elements[loop_index].component_index);
            add_element_to_int_list(&global_geometry_list.elements[loop_index].Volume->geometry.masked_by_list,INDEX_CURRENT_COMP);
            global_geometry_list.elements[loop_index].Volume->geometry.is_masked_volume = 1;
            if (this_box_volume.geometry.mask_mode == 2)
                global_geometry_list.elements[loop_index].Volume->geometry.mask_mode = 2;
            if (this_box_volume.geometry.mask_mode == 1) {
                if (global_geometry_list.elements[loop_index].Volume->geometry.is_masked_volume == 1 && global_geometry_list.elements[loop_index].Volume->geometry.mask_mode != 2)
                    // If more than one mask is added to one volume, the ANY mode overwrites the (default) ALL mode.
                    global_geometry_list.elements[loop_index].Volume->geometry.mask_mode = 1;
            }
            
            found_geometries = 1;
        }
    }
    if (found_geometries == 0) {
        printf("The mask_string in geometry: %s did not find any of the specified volumes in the mask_string %s \n",NAME_CURRENT_COMP,mask_string);
        exit(1);
    }
    this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
    this_box_volume.p_physics->is_vacuum = 0; // Makes this volume a vacuum
    this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
    this_box_volume.p_physics->my_a = 0; // Should not be used.
    sprintf(this_box_volume.p_physics->name,"Mask");
    this_box_volume.geometry.is_mask_volume = 1;
    
    
// Read the material input, or if it lacks, use automatic linking.
} else if (material_string && strlen(material_string) && strcmp(material_string, "NULL") && strcmp(material_string, "0")) {
    // A geometry string was given, use it to determine which material
    if (0 == strcmp(material_string,"vacuum") || 0 == strcmp(material_string,"Vacuum")) {
        // One could have a global physics struct for vacuum instead of creating one for each
        this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
        this_box_volume.p_physics->is_vacuum = 1; // Makes this volume a vacuum
        this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
        this_box_volume.p_physics->my_a = 0; // Should not be used.
        sprintf(this_box_volume.p_physics->name,"Vacuum");
    } else if (0 == strcmp(material_string,"exit") || 0 == strcmp(material_string,"Exit")) {
        // One could have a global physics struct for vacuum instead of creating one for each
        this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
        this_box_volume.p_physics->is_vacuum = 1; // Makes this volume a vacuum
        this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
        this_box_volume.p_physics->my_a = 0; // Should not be used.
        this_box_volume.geometry.is_exit_volume = 1;
        sprintf(this_box_volume.p_physics->name,"Exit");
    } else {
        #ifndef MATERIAL_DETECTOR
            printf("Need to define a material before refering to it in a geometry %s.\n",NAME_CURRENT_COMP);
            exit(1);
        #endif
        for (loop_index=0;loop_index<global_material_list.num_elements;loop_index++) {
            if (0 == strcmp(material_string,global_material_list.elements[loop_index].name)) {
                this_box_volume.p_physics = global_material_list.elements[loop_index].physics;
                break;
            }
            if (loop_index == global_material_list.num_elements-1) {
            printf("\n");
            printf("ERROR: The material string \"%s\" in Union geometry \"%s\" did not match a specified material. \n",material_string,NAME_CURRENT_COMP);
            printf("       The materials available at this point (need to be defined before the geometry): \n");
            for (loop_index=0;loop_index<global_material_list.num_elements;loop_index++)
              printf("         %s\n",global_material_list.elements[loop_index].name);
            printf("\n");
            printf("       It is also possible to use one of the defualt materials avaiable: \n");
            printf("           Vacuum (for a Volume without scattering or absorption)\n");
            printf("           Exit (for a Volume where the ray exits the component if it enters)\n");
            printf("           Mask (for a Volume that masks existing volumes specified in the mask_string\n");
            exit(1);
          }
        }
    }
} else {
    // Automatic linking, simply using the last defined material.
    #ifndef MATERIAL_DETECTOR
        printf("Need to define a material before the geometry to use automatic linking %s.\n",NAME_CURRENT_COMP);
        exit(1);
    #endif
    this_box_volume.p_physics = global_material_list.elements[global_material_list.num_elements-1].physics;
}

sprintf(this_box_volume.name,NAME_CURRENT_COMP);
sprintf(this_box_volume.geometry.shape,"box");
this_box_volume.geometry.priority_value = priority;
this_box_volume.geometry.geometry_p_interact = p_interact;
// Currently the coordinates will be in absolute space.
this_box_volume.geometry.center = POS_A_CURRENT_COMP;

this_box_storage.z_depth = zdepth;
this_box_storage.x_width1 = xwidth;
this_box_storage.y_height1 = yheight;

this_box_storage.is_rectangle = 0;
if (xwidth2 < 0 && yheight2 < 0) this_box_storage.is_rectangle = 1;
if (xwidth == xwidth2 && yheight == yheight2) this_box_storage.is_rectangle = 1;

if (xwidth2 < 0) {
    this_box_storage.x_width2 = xwidth;
    xwidth2 = xwidth;
} else this_box_storage.x_width2 = xwidth2;

if (yheight2 < 0) {
    this_box_storage.y_height2 = yheight;
    yheight2 = yheight;
} else this_box_storage.y_height2 = yheight2;


this_box_storage.normal_vectors[0] = coords_set(0,0,1);
this_box_storage.normal_vectors[1] = coords_set(0,0,1);

// for sides with y component = 0
x_component = 2*zdepth/sqrt((xwidth-xwidth2)*(xwidth-xwidth2)+4*zdepth*zdepth);
z_component = (xwidth-xwidth2)/sqrt(4*zdepth*zdepth+(xwidth-xwidth2)*(xwidth-xwidth2));

this_box_storage.normal_vectors[2] = coords_set(x_component,0,z_component);
this_box_storage.normal_vectors[3] = coords_set(-x_component,0,z_component);

// for sides with x component = 0
y_component = 2*zdepth/sqrt((yheight-yheight2)*(yheight-yheight2)+4*zdepth*zdepth);
z_component = (yheight-yheight2)/sqrt(4*zdepth*zdepth+(yheight-yheight2)*(yheight-yheight2));

this_box_storage.normal_vectors[4] = coords_set(0,y_component,z_component);
this_box_storage.normal_vectors[5] = coords_set(0,-y_component,z_component);

this_box_volume.geometry.visualization_on = visualize;

this_box_volume.geometry.geometry_parameters.p_box_storage = &this_box_storage;

// Assign pointers to functions for intersection with the shape, checking if a point is inside the shape
if (this_box_storage.is_rectangle == 1) {
this_box_volume.geometry.intersect_function = &sample_box_intersect_simple;
this_box_volume.geometry.within_function = &r_within_box_simple;
}
else {
this_box_volume.geometry.intersect_function = &sample_box_intersect_advanced;
this_box_volume.geometry.within_function = &r_within_box_advanced;
}

this_box_volume.geometry.shell_points = &box_shell_points;
this_box_volume.geometry.mcdisplay_function = &mcdisplay_box_function;
this_box_volume.geometry.initialize_from_main_function = &initialize_box_geometry_from_main_component;
this_box_volume.geometry.process_rot_allocated = 0;

this_box_volume.geometry.copy_geometry_parameters = &allocate_box_storage_copy;

rot_copy(this_box_volume.geometry.rotation_matrix,ROT_A_CURRENT_COMP); //check how ROT_R_CURRENT_COMP would work
rot_transpose(ROT_A_CURRENT_COMP,this_box_volume.geometry.transpose_rotation_matrix);

// Initialize loggers
this_box_volume.loggers.num_elements = 0;

// packing the information into the global_geometry_element, which is then included in the global_geometry_list.
sprintf(global_geometry_element.name,NAME_CURRENT_COMP);
global_geometry_element.activation_counter = number_of_activations;
global_geometry_element.component_index = INDEX_CURRENT_COMP;
global_geometry_element.Volume = &this_box_volume; // Would be nicer if this m was a pointer, now we have the (small) data two places
add_element_to_geometry_list(&global_geometry_list,global_geometry_element);
}
#line 238967 "MACS_sample_kidney_box.c"
#undef number_of_activations
#undef mask_setting
#undef mask_string
#undef p_interact
#undef focus_r
#undef focus_xh
#undef focus_xw
#undef focus_ah
#undef focus_aw
#undef target_z
#undef target_y
#undef target_x
#undef target_index
#undef visualize
#undef yheight2
#undef xwidth2
#undef zdepth
#undef yheight
#undef xwidth
#undef priority
#undef material_string
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

  /* Initializations for component channel_8_analyzer_2_array_crystal_array_2. */
  SIG_MESSAGE("channel_8_analyzer_2_array_crystal_array_2 (Init)");
#define mccompcurname  channel_8_analyzer_2_array_crystal_array_2
#define mccompcurtype  Union_box
#define mccompcurindex 447
#define loop_index mccchannel_8_analyzer_2_array_crystal_array_2_loop_index
#define this_box_volume mccchannel_8_analyzer_2_array_crystal_array_2_this_box_volume
#define global_geometry_element mccchannel_8_analyzer_2_array_crystal_array_2_global_geometry_element
#define this_box_storage mccchannel_8_analyzer_2_array_crystal_array_2_this_box_storage
#define material_string mccchannel_8_analyzer_2_array_crystal_array_2_material_string
#define priority mccchannel_8_analyzer_2_array_crystal_array_2_priority
#define xwidth mccchannel_8_analyzer_2_array_crystal_array_2_xwidth
#define yheight mccchannel_8_analyzer_2_array_crystal_array_2_yheight
#define zdepth mccchannel_8_analyzer_2_array_crystal_array_2_zdepth
#define xwidth2 mccchannel_8_analyzer_2_array_crystal_array_2_xwidth2
#define yheight2 mccchannel_8_analyzer_2_array_crystal_array_2_yheight2
#define visualize mccchannel_8_analyzer_2_array_crystal_array_2_visualize
#define target_index mccchannel_8_analyzer_2_array_crystal_array_2_target_index
#define target_x mccchannel_8_analyzer_2_array_crystal_array_2_target_x
#define target_y mccchannel_8_analyzer_2_array_crystal_array_2_target_y
#define target_z mccchannel_8_analyzer_2_array_crystal_array_2_target_z
#define focus_aw mccchannel_8_analyzer_2_array_crystal_array_2_focus_aw
#define focus_ah mccchannel_8_analyzer_2_array_crystal_array_2_focus_ah
#define focus_xw mccchannel_8_analyzer_2_array_crystal_array_2_focus_xw
#define focus_xh mccchannel_8_analyzer_2_array_crystal_array_2_focus_xh
#define focus_r mccchannel_8_analyzer_2_array_crystal_array_2_focus_r
#define p_interact mccchannel_8_analyzer_2_array_crystal_array_2_p_interact
#define mask_string mccchannel_8_analyzer_2_array_crystal_array_2_mask_string
#define mask_setting mccchannel_8_analyzer_2_array_crystal_array_2_mask_setting
#define number_of_activations mccchannel_8_analyzer_2_array_crystal_array_2_number_of_activations
#line 224 "Union_box.comp"
{
// Initializes the focusing system for this volume including input sanitation.
focus_initialize(&this_box_volume.geometry, POS_A_COMP_INDEX(INDEX_CURRENT_COMP+target_index), POS_A_CURRENT_COMP, ROT_A_CURRENT_COMP, target_index, target_x, target_y, target_z, focus_aw, focus_ah, focus_xw, focus_xh, focus_r, NAME_CURRENT_COMP);

// Input sanitation for this geometry
if (xwidth <= 0) {
  printf("\nERROR in Union_box named %s, the xwidth is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (yheight <= 0) {
  printf("\nERROR in Union_box named %s, yheight is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (zdepth <= 0) {
  printf("\nERROR in Union_box named %s, zdepth is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (xwidth2 <= 0 && xwidth2 != -1) {
  printf("\nERROR in Union_box named %s, the xwidth2 is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (yheight2 <= 0 && yheight2 != -1) {
  printf("\nERROR in Union_box named %s, yheight2 is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}

// Use sanitation
if (global_material_list.num_elements == 0) {
  printf("\nERROR: Need to define a material using Union_make_material before using a Union geometry component. \n");
  printf("       %s was defined before first use of Union_make_material.\n",NAME_CURRENT_COMP);
  exit(1);
}

this_box_volume.geometry.is_masked_volume = 0;
this_box_volume.geometry.is_exit_volume = 0;
this_box_volume.geometry.is_mask_volume = 0;
// check if the volume is a mask, if it is the material string is irelevant.
if (mask_string && strlen(mask_string) && strcmp(mask_string, "NULL") && strcmp(mask_string, "0")) {
    // A mask volume is used to limit the extend of other volumes, called the masked volumes. These are specified in the mask_string.
    // In order for a ray to enter a masked volume, it needs to be both in the region covered by that volume AND the mask volume.
    // When more than
    this_box_volume.geometry.mask_mode = 1; // Default is mask mode is ALL
    if (mask_setting && strlen(mask_setting) && strcmp(mask_setting, "NULL") && strcmp(mask_setting, "0")) {
        if (strcmp(mask_setting,"ALL") == 0 || strcmp(mask_setting,"All") == 0) this_box_volume.geometry.mask_mode = 1;
        else if (strcmp(mask_setting,"ANY") == 0 || strcmp(mask_setting,"Any") == 0) this_box_volume.geometry.mask_mode = 2;
        else {
            printf("The mask_mode of component %s is set to %s, but must be either ALL or ANY.\n",NAME_CURRENT_COMP,mask_setting);
            exit(1);
        }
    }
    
    for (loop_index=0;loop_index<global_geometry_list.num_elements;loop_index++) {
        // Add mask list
        if (1 == manual_linking_function(global_geometry_list.elements[loop_index].name,mask_string)) {
            add_element_to_int_list(&this_box_volume.geometry.mask_list,global_geometry_list.elements[loop_index].component_index);
            add_element_to_int_list(&global_geometry_list.elements[loop_index].Volume->geometry.masked_by_list,INDEX_CURRENT_COMP);
            global_geometry_list.elements[loop_index].Volume->geometry.is_masked_volume = 1;
            if (this_box_volume.geometry.mask_mode == 2)
                global_geometry_list.elements[loop_index].Volume->geometry.mask_mode = 2;
            if (this_box_volume.geometry.mask_mode == 1) {
                if (global_geometry_list.elements[loop_index].Volume->geometry.is_masked_volume == 1 && global_geometry_list.elements[loop_index].Volume->geometry.mask_mode != 2)
                    // If more than one mask is added to one volume, the ANY mode overwrites the (default) ALL mode.
                    global_geometry_list.elements[loop_index].Volume->geometry.mask_mode = 1;
            }
            
            found_geometries = 1;
        }
    }
    if (found_geometries == 0) {
        printf("The mask_string in geometry: %s did not find any of the specified volumes in the mask_string %s \n",NAME_CURRENT_COMP,mask_string);
        exit(1);
    }
    this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
    this_box_volume.p_physics->is_vacuum = 0; // Makes this volume a vacuum
    this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
    this_box_volume.p_physics->my_a = 0; // Should not be used.
    sprintf(this_box_volume.p_physics->name,"Mask");
    this_box_volume.geometry.is_mask_volume = 1;
    
    
// Read the material input, or if it lacks, use automatic linking.
} else if (material_string && strlen(material_string) && strcmp(material_string, "NULL") && strcmp(material_string, "0")) {
    // A geometry string was given, use it to determine which material
    if (0 == strcmp(material_string,"vacuum") || 0 == strcmp(material_string,"Vacuum")) {
        // One could have a global physics struct for vacuum instead of creating one for each
        this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
        this_box_volume.p_physics->is_vacuum = 1; // Makes this volume a vacuum
        this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
        this_box_volume.p_physics->my_a = 0; // Should not be used.
        sprintf(this_box_volume.p_physics->name,"Vacuum");
    } else if (0 == strcmp(material_string,"exit") || 0 == strcmp(material_string,"Exit")) {
        // One could have a global physics struct for vacuum instead of creating one for each
        this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
        this_box_volume.p_physics->is_vacuum = 1; // Makes this volume a vacuum
        this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
        this_box_volume.p_physics->my_a = 0; // Should not be used.
        this_box_volume.geometry.is_exit_volume = 1;
        sprintf(this_box_volume.p_physics->name,"Exit");
    } else {
        #ifndef MATERIAL_DETECTOR
            printf("Need to define a material before refering to it in a geometry %s.\n",NAME_CURRENT_COMP);
            exit(1);
        #endif
        for (loop_index=0;loop_index<global_material_list.num_elements;loop_index++) {
            if (0 == strcmp(material_string,global_material_list.elements[loop_index].name)) {
                this_box_volume.p_physics = global_material_list.elements[loop_index].physics;
                break;
            }
            if (loop_index == global_material_list.num_elements-1) {
            printf("\n");
            printf("ERROR: The material string \"%s\" in Union geometry \"%s\" did not match a specified material. \n",material_string,NAME_CURRENT_COMP);
            printf("       The materials available at this point (need to be defined before the geometry): \n");
            for (loop_index=0;loop_index<global_material_list.num_elements;loop_index++)
              printf("         %s\n",global_material_list.elements[loop_index].name);
            printf("\n");
            printf("       It is also possible to use one of the defualt materials avaiable: \n");
            printf("           Vacuum (for a Volume without scattering or absorption)\n");
            printf("           Exit (for a Volume where the ray exits the component if it enters)\n");
            printf("           Mask (for a Volume that masks existing volumes specified in the mask_string\n");
            exit(1);
          }
        }
    }
} else {
    // Automatic linking, simply using the last defined material.
    #ifndef MATERIAL_DETECTOR
        printf("Need to define a material before the geometry to use automatic linking %s.\n",NAME_CURRENT_COMP);
        exit(1);
    #endif
    this_box_volume.p_physics = global_material_list.elements[global_material_list.num_elements-1].physics;
}

sprintf(this_box_volume.name,NAME_CURRENT_COMP);
sprintf(this_box_volume.geometry.shape,"box");
this_box_volume.geometry.priority_value = priority;
this_box_volume.geometry.geometry_p_interact = p_interact;
// Currently the coordinates will be in absolute space.
this_box_volume.geometry.center = POS_A_CURRENT_COMP;

this_box_storage.z_depth = zdepth;
this_box_storage.x_width1 = xwidth;
this_box_storage.y_height1 = yheight;

this_box_storage.is_rectangle = 0;
if (xwidth2 < 0 && yheight2 < 0) this_box_storage.is_rectangle = 1;
if (xwidth == xwidth2 && yheight == yheight2) this_box_storage.is_rectangle = 1;

if (xwidth2 < 0) {
    this_box_storage.x_width2 = xwidth;
    xwidth2 = xwidth;
} else this_box_storage.x_width2 = xwidth2;

if (yheight2 < 0) {
    this_box_storage.y_height2 = yheight;
    yheight2 = yheight;
} else this_box_storage.y_height2 = yheight2;


this_box_storage.normal_vectors[0] = coords_set(0,0,1);
this_box_storage.normal_vectors[1] = coords_set(0,0,1);

// for sides with y component = 0
x_component = 2*zdepth/sqrt((xwidth-xwidth2)*(xwidth-xwidth2)+4*zdepth*zdepth);
z_component = (xwidth-xwidth2)/sqrt(4*zdepth*zdepth+(xwidth-xwidth2)*(xwidth-xwidth2));

this_box_storage.normal_vectors[2] = coords_set(x_component,0,z_component);
this_box_storage.normal_vectors[3] = coords_set(-x_component,0,z_component);

// for sides with x component = 0
y_component = 2*zdepth/sqrt((yheight-yheight2)*(yheight-yheight2)+4*zdepth*zdepth);
z_component = (yheight-yheight2)/sqrt(4*zdepth*zdepth+(yheight-yheight2)*(yheight-yheight2));

this_box_storage.normal_vectors[4] = coords_set(0,y_component,z_component);
this_box_storage.normal_vectors[5] = coords_set(0,-y_component,z_component);

this_box_volume.geometry.visualization_on = visualize;

this_box_volume.geometry.geometry_parameters.p_box_storage = &this_box_storage;

// Assign pointers to functions for intersection with the shape, checking if a point is inside the shape
if (this_box_storage.is_rectangle == 1) {
this_box_volume.geometry.intersect_function = &sample_box_intersect_simple;
this_box_volume.geometry.within_function = &r_within_box_simple;
}
else {
this_box_volume.geometry.intersect_function = &sample_box_intersect_advanced;
this_box_volume.geometry.within_function = &r_within_box_advanced;
}

this_box_volume.geometry.shell_points = &box_shell_points;
this_box_volume.geometry.mcdisplay_function = &mcdisplay_box_function;
this_box_volume.geometry.initialize_from_main_function = &initialize_box_geometry_from_main_component;
this_box_volume.geometry.process_rot_allocated = 0;

this_box_volume.geometry.copy_geometry_parameters = &allocate_box_storage_copy;

rot_copy(this_box_volume.geometry.rotation_matrix,ROT_A_CURRENT_COMP); //check how ROT_R_CURRENT_COMP would work
rot_transpose(ROT_A_CURRENT_COMP,this_box_volume.geometry.transpose_rotation_matrix);

// Initialize loggers
this_box_volume.loggers.num_elements = 0;

// packing the information into the global_geometry_element, which is then included in the global_geometry_list.
sprintf(global_geometry_element.name,NAME_CURRENT_COMP);
global_geometry_element.activation_counter = number_of_activations;
global_geometry_element.component_index = INDEX_CURRENT_COMP;
global_geometry_element.Volume = &this_box_volume; // Would be nicer if this m was a pointer, now we have the (small) data two places
add_element_to_geometry_list(&global_geometry_list,global_geometry_element);
}
#line 239237 "MACS_sample_kidney_box.c"
#undef number_of_activations
#undef mask_setting
#undef mask_string
#undef p_interact
#undef focus_r
#undef focus_xh
#undef focus_xw
#undef focus_ah
#undef focus_aw
#undef target_z
#undef target_y
#undef target_x
#undef target_index
#undef visualize
#undef yheight2
#undef xwidth2
#undef zdepth
#undef yheight
#undef xwidth
#undef priority
#undef material_string
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

  /* Initializations for component channel_8_analyzer_2_array_crystal_array_3. */
  SIG_MESSAGE("channel_8_analyzer_2_array_crystal_array_3 (Init)");
#define mccompcurname  channel_8_analyzer_2_array_crystal_array_3
#define mccompcurtype  Union_box
#define mccompcurindex 448
#define loop_index mccchannel_8_analyzer_2_array_crystal_array_3_loop_index
#define this_box_volume mccchannel_8_analyzer_2_array_crystal_array_3_this_box_volume
#define global_geometry_element mccchannel_8_analyzer_2_array_crystal_array_3_global_geometry_element
#define this_box_storage mccchannel_8_analyzer_2_array_crystal_array_3_this_box_storage
#define material_string mccchannel_8_analyzer_2_array_crystal_array_3_material_string
#define priority mccchannel_8_analyzer_2_array_crystal_array_3_priority
#define xwidth mccchannel_8_analyzer_2_array_crystal_array_3_xwidth
#define yheight mccchannel_8_analyzer_2_array_crystal_array_3_yheight
#define zdepth mccchannel_8_analyzer_2_array_crystal_array_3_zdepth
#define xwidth2 mccchannel_8_analyzer_2_array_crystal_array_3_xwidth2
#define yheight2 mccchannel_8_analyzer_2_array_crystal_array_3_yheight2
#define visualize mccchannel_8_analyzer_2_array_crystal_array_3_visualize
#define target_index mccchannel_8_analyzer_2_array_crystal_array_3_target_index
#define target_x mccchannel_8_analyzer_2_array_crystal_array_3_target_x
#define target_y mccchannel_8_analyzer_2_array_crystal_array_3_target_y
#define target_z mccchannel_8_analyzer_2_array_crystal_array_3_target_z
#define focus_aw mccchannel_8_analyzer_2_array_crystal_array_3_focus_aw
#define focus_ah mccchannel_8_analyzer_2_array_crystal_array_3_focus_ah
#define focus_xw mccchannel_8_analyzer_2_array_crystal_array_3_focus_xw
#define focus_xh mccchannel_8_analyzer_2_array_crystal_array_3_focus_xh
#define focus_r mccchannel_8_analyzer_2_array_crystal_array_3_focus_r
#define p_interact mccchannel_8_analyzer_2_array_crystal_array_3_p_interact
#define mask_string mccchannel_8_analyzer_2_array_crystal_array_3_mask_string
#define mask_setting mccchannel_8_analyzer_2_array_crystal_array_3_mask_setting
#define number_of_activations mccchannel_8_analyzer_2_array_crystal_array_3_number_of_activations
#line 224 "Union_box.comp"
{
// Initializes the focusing system for this volume including input sanitation.
focus_initialize(&this_box_volume.geometry, POS_A_COMP_INDEX(INDEX_CURRENT_COMP+target_index), POS_A_CURRENT_COMP, ROT_A_CURRENT_COMP, target_index, target_x, target_y, target_z, focus_aw, focus_ah, focus_xw, focus_xh, focus_r, NAME_CURRENT_COMP);

// Input sanitation for this geometry
if (xwidth <= 0) {
  printf("\nERROR in Union_box named %s, the xwidth is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (yheight <= 0) {
  printf("\nERROR in Union_box named %s, yheight is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (zdepth <= 0) {
  printf("\nERROR in Union_box named %s, zdepth is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (xwidth2 <= 0 && xwidth2 != -1) {
  printf("\nERROR in Union_box named %s, the xwidth2 is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (yheight2 <= 0 && yheight2 != -1) {
  printf("\nERROR in Union_box named %s, yheight2 is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}

// Use sanitation
if (global_material_list.num_elements == 0) {
  printf("\nERROR: Need to define a material using Union_make_material before using a Union geometry component. \n");
  printf("       %s was defined before first use of Union_make_material.\n",NAME_CURRENT_COMP);
  exit(1);
}

this_box_volume.geometry.is_masked_volume = 0;
this_box_volume.geometry.is_exit_volume = 0;
this_box_volume.geometry.is_mask_volume = 0;
// check if the volume is a mask, if it is the material string is irelevant.
if (mask_string && strlen(mask_string) && strcmp(mask_string, "NULL") && strcmp(mask_string, "0")) {
    // A mask volume is used to limit the extend of other volumes, called the masked volumes. These are specified in the mask_string.
    // In order for a ray to enter a masked volume, it needs to be both in the region covered by that volume AND the mask volume.
    // When more than
    this_box_volume.geometry.mask_mode = 1; // Default is mask mode is ALL
    if (mask_setting && strlen(mask_setting) && strcmp(mask_setting, "NULL") && strcmp(mask_setting, "0")) {
        if (strcmp(mask_setting,"ALL") == 0 || strcmp(mask_setting,"All") == 0) this_box_volume.geometry.mask_mode = 1;
        else if (strcmp(mask_setting,"ANY") == 0 || strcmp(mask_setting,"Any") == 0) this_box_volume.geometry.mask_mode = 2;
        else {
            printf("The mask_mode of component %s is set to %s, but must be either ALL or ANY.\n",NAME_CURRENT_COMP,mask_setting);
            exit(1);
        }
    }
    
    for (loop_index=0;loop_index<global_geometry_list.num_elements;loop_index++) {
        // Add mask list
        if (1 == manual_linking_function(global_geometry_list.elements[loop_index].name,mask_string)) {
            add_element_to_int_list(&this_box_volume.geometry.mask_list,global_geometry_list.elements[loop_index].component_index);
            add_element_to_int_list(&global_geometry_list.elements[loop_index].Volume->geometry.masked_by_list,INDEX_CURRENT_COMP);
            global_geometry_list.elements[loop_index].Volume->geometry.is_masked_volume = 1;
            if (this_box_volume.geometry.mask_mode == 2)
                global_geometry_list.elements[loop_index].Volume->geometry.mask_mode = 2;
            if (this_box_volume.geometry.mask_mode == 1) {
                if (global_geometry_list.elements[loop_index].Volume->geometry.is_masked_volume == 1 && global_geometry_list.elements[loop_index].Volume->geometry.mask_mode != 2)
                    // If more than one mask is added to one volume, the ANY mode overwrites the (default) ALL mode.
                    global_geometry_list.elements[loop_index].Volume->geometry.mask_mode = 1;
            }
            
            found_geometries = 1;
        }
    }
    if (found_geometries == 0) {
        printf("The mask_string in geometry: %s did not find any of the specified volumes in the mask_string %s \n",NAME_CURRENT_COMP,mask_string);
        exit(1);
    }
    this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
    this_box_volume.p_physics->is_vacuum = 0; // Makes this volume a vacuum
    this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
    this_box_volume.p_physics->my_a = 0; // Should not be used.
    sprintf(this_box_volume.p_physics->name,"Mask");
    this_box_volume.geometry.is_mask_volume = 1;
    
    
// Read the material input, or if it lacks, use automatic linking.
} else if (material_string && strlen(material_string) && strcmp(material_string, "NULL") && strcmp(material_string, "0")) {
    // A geometry string was given, use it to determine which material
    if (0 == strcmp(material_string,"vacuum") || 0 == strcmp(material_string,"Vacuum")) {
        // One could have a global physics struct for vacuum instead of creating one for each
        this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
        this_box_volume.p_physics->is_vacuum = 1; // Makes this volume a vacuum
        this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
        this_box_volume.p_physics->my_a = 0; // Should not be used.
        sprintf(this_box_volume.p_physics->name,"Vacuum");
    } else if (0 == strcmp(material_string,"exit") || 0 == strcmp(material_string,"Exit")) {
        // One could have a global physics struct for vacuum instead of creating one for each
        this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
        this_box_volume.p_physics->is_vacuum = 1; // Makes this volume a vacuum
        this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
        this_box_volume.p_physics->my_a = 0; // Should not be used.
        this_box_volume.geometry.is_exit_volume = 1;
        sprintf(this_box_volume.p_physics->name,"Exit");
    } else {
        #ifndef MATERIAL_DETECTOR
            printf("Need to define a material before refering to it in a geometry %s.\n",NAME_CURRENT_COMP);
            exit(1);
        #endif
        for (loop_index=0;loop_index<global_material_list.num_elements;loop_index++) {
            if (0 == strcmp(material_string,global_material_list.elements[loop_index].name)) {
                this_box_volume.p_physics = global_material_list.elements[loop_index].physics;
                break;
            }
            if (loop_index == global_material_list.num_elements-1) {
            printf("\n");
            printf("ERROR: The material string \"%s\" in Union geometry \"%s\" did not match a specified material. \n",material_string,NAME_CURRENT_COMP);
            printf("       The materials available at this point (need to be defined before the geometry): \n");
            for (loop_index=0;loop_index<global_material_list.num_elements;loop_index++)
              printf("         %s\n",global_material_list.elements[loop_index].name);
            printf("\n");
            printf("       It is also possible to use one of the defualt materials avaiable: \n");
            printf("           Vacuum (for a Volume without scattering or absorption)\n");
            printf("           Exit (for a Volume where the ray exits the component if it enters)\n");
            printf("           Mask (for a Volume that masks existing volumes specified in the mask_string\n");
            exit(1);
          }
        }
    }
} else {
    // Automatic linking, simply using the last defined material.
    #ifndef MATERIAL_DETECTOR
        printf("Need to define a material before the geometry to use automatic linking %s.\n",NAME_CURRENT_COMP);
        exit(1);
    #endif
    this_box_volume.p_physics = global_material_list.elements[global_material_list.num_elements-1].physics;
}

sprintf(this_box_volume.name,NAME_CURRENT_COMP);
sprintf(this_box_volume.geometry.shape,"box");
this_box_volume.geometry.priority_value = priority;
this_box_volume.geometry.geometry_p_interact = p_interact;
// Currently the coordinates will be in absolute space.
this_box_volume.geometry.center = POS_A_CURRENT_COMP;

this_box_storage.z_depth = zdepth;
this_box_storage.x_width1 = xwidth;
this_box_storage.y_height1 = yheight;

this_box_storage.is_rectangle = 0;
if (xwidth2 < 0 && yheight2 < 0) this_box_storage.is_rectangle = 1;
if (xwidth == xwidth2 && yheight == yheight2) this_box_storage.is_rectangle = 1;

if (xwidth2 < 0) {
    this_box_storage.x_width2 = xwidth;
    xwidth2 = xwidth;
} else this_box_storage.x_width2 = xwidth2;

if (yheight2 < 0) {
    this_box_storage.y_height2 = yheight;
    yheight2 = yheight;
} else this_box_storage.y_height2 = yheight2;


this_box_storage.normal_vectors[0] = coords_set(0,0,1);
this_box_storage.normal_vectors[1] = coords_set(0,0,1);

// for sides with y component = 0
x_component = 2*zdepth/sqrt((xwidth-xwidth2)*(xwidth-xwidth2)+4*zdepth*zdepth);
z_component = (xwidth-xwidth2)/sqrt(4*zdepth*zdepth+(xwidth-xwidth2)*(xwidth-xwidth2));

this_box_storage.normal_vectors[2] = coords_set(x_component,0,z_component);
this_box_storage.normal_vectors[3] = coords_set(-x_component,0,z_component);

// for sides with x component = 0
y_component = 2*zdepth/sqrt((yheight-yheight2)*(yheight-yheight2)+4*zdepth*zdepth);
z_component = (yheight-yheight2)/sqrt(4*zdepth*zdepth+(yheight-yheight2)*(yheight-yheight2));

this_box_storage.normal_vectors[4] = coords_set(0,y_component,z_component);
this_box_storage.normal_vectors[5] = coords_set(0,-y_component,z_component);

this_box_volume.geometry.visualization_on = visualize;

this_box_volume.geometry.geometry_parameters.p_box_storage = &this_box_storage;

// Assign pointers to functions for intersection with the shape, checking if a point is inside the shape
if (this_box_storage.is_rectangle == 1) {
this_box_volume.geometry.intersect_function = &sample_box_intersect_simple;
this_box_volume.geometry.within_function = &r_within_box_simple;
}
else {
this_box_volume.geometry.intersect_function = &sample_box_intersect_advanced;
this_box_volume.geometry.within_function = &r_within_box_advanced;
}

this_box_volume.geometry.shell_points = &box_shell_points;
this_box_volume.geometry.mcdisplay_function = &mcdisplay_box_function;
this_box_volume.geometry.initialize_from_main_function = &initialize_box_geometry_from_main_component;
this_box_volume.geometry.process_rot_allocated = 0;

this_box_volume.geometry.copy_geometry_parameters = &allocate_box_storage_copy;

rot_copy(this_box_volume.geometry.rotation_matrix,ROT_A_CURRENT_COMP); //check how ROT_R_CURRENT_COMP would work
rot_transpose(ROT_A_CURRENT_COMP,this_box_volume.geometry.transpose_rotation_matrix);

// Initialize loggers
this_box_volume.loggers.num_elements = 0;

// packing the information into the global_geometry_element, which is then included in the global_geometry_list.
sprintf(global_geometry_element.name,NAME_CURRENT_COMP);
global_geometry_element.activation_counter = number_of_activations;
global_geometry_element.component_index = INDEX_CURRENT_COMP;
global_geometry_element.Volume = &this_box_volume; // Would be nicer if this m was a pointer, now we have the (small) data two places
add_element_to_geometry_list(&global_geometry_list,global_geometry_element);
}
#line 239507 "MACS_sample_kidney_box.c"
#undef number_of_activations
#undef mask_setting
#undef mask_string
#undef p_interact
#undef focus_r
#undef focus_xh
#undef focus_xw
#undef focus_ah
#undef focus_aw
#undef target_z
#undef target_y
#undef target_x
#undef target_index
#undef visualize
#undef yheight2
#undef xwidth2
#undef zdepth
#undef yheight
#undef xwidth
#undef priority
#undef material_string
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

  /* Initializations for component channel_8_analyzer_2_array_crystal_array_4. */
  SIG_MESSAGE("channel_8_analyzer_2_array_crystal_array_4 (Init)");
#define mccompcurname  channel_8_analyzer_2_array_crystal_array_4
#define mccompcurtype  Union_box
#define mccompcurindex 449
#define loop_index mccchannel_8_analyzer_2_array_crystal_array_4_loop_index
#define this_box_volume mccchannel_8_analyzer_2_array_crystal_array_4_this_box_volume
#define global_geometry_element mccchannel_8_analyzer_2_array_crystal_array_4_global_geometry_element
#define this_box_storage mccchannel_8_analyzer_2_array_crystal_array_4_this_box_storage
#define material_string mccchannel_8_analyzer_2_array_crystal_array_4_material_string
#define priority mccchannel_8_analyzer_2_array_crystal_array_4_priority
#define xwidth mccchannel_8_analyzer_2_array_crystal_array_4_xwidth
#define yheight mccchannel_8_analyzer_2_array_crystal_array_4_yheight
#define zdepth mccchannel_8_analyzer_2_array_crystal_array_4_zdepth
#define xwidth2 mccchannel_8_analyzer_2_array_crystal_array_4_xwidth2
#define yheight2 mccchannel_8_analyzer_2_array_crystal_array_4_yheight2
#define visualize mccchannel_8_analyzer_2_array_crystal_array_4_visualize
#define target_index mccchannel_8_analyzer_2_array_crystal_array_4_target_index
#define target_x mccchannel_8_analyzer_2_array_crystal_array_4_target_x
#define target_y mccchannel_8_analyzer_2_array_crystal_array_4_target_y
#define target_z mccchannel_8_analyzer_2_array_crystal_array_4_target_z
#define focus_aw mccchannel_8_analyzer_2_array_crystal_array_4_focus_aw
#define focus_ah mccchannel_8_analyzer_2_array_crystal_array_4_focus_ah
#define focus_xw mccchannel_8_analyzer_2_array_crystal_array_4_focus_xw
#define focus_xh mccchannel_8_analyzer_2_array_crystal_array_4_focus_xh
#define focus_r mccchannel_8_analyzer_2_array_crystal_array_4_focus_r
#define p_interact mccchannel_8_analyzer_2_array_crystal_array_4_p_interact
#define mask_string mccchannel_8_analyzer_2_array_crystal_array_4_mask_string
#define mask_setting mccchannel_8_analyzer_2_array_crystal_array_4_mask_setting
#define number_of_activations mccchannel_8_analyzer_2_array_crystal_array_4_number_of_activations
#line 224 "Union_box.comp"
{
// Initializes the focusing system for this volume including input sanitation.
focus_initialize(&this_box_volume.geometry, POS_A_COMP_INDEX(INDEX_CURRENT_COMP+target_index), POS_A_CURRENT_COMP, ROT_A_CURRENT_COMP, target_index, target_x, target_y, target_z, focus_aw, focus_ah, focus_xw, focus_xh, focus_r, NAME_CURRENT_COMP);

// Input sanitation for this geometry
if (xwidth <= 0) {
  printf("\nERROR in Union_box named %s, the xwidth is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (yheight <= 0) {
  printf("\nERROR in Union_box named %s, yheight is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (zdepth <= 0) {
  printf("\nERROR in Union_box named %s, zdepth is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (xwidth2 <= 0 && xwidth2 != -1) {
  printf("\nERROR in Union_box named %s, the xwidth2 is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (yheight2 <= 0 && yheight2 != -1) {
  printf("\nERROR in Union_box named %s, yheight2 is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}

// Use sanitation
if (global_material_list.num_elements == 0) {
  printf("\nERROR: Need to define a material using Union_make_material before using a Union geometry component. \n");
  printf("       %s was defined before first use of Union_make_material.\n",NAME_CURRENT_COMP);
  exit(1);
}

this_box_volume.geometry.is_masked_volume = 0;
this_box_volume.geometry.is_exit_volume = 0;
this_box_volume.geometry.is_mask_volume = 0;
// check if the volume is a mask, if it is the material string is irelevant.
if (mask_string && strlen(mask_string) && strcmp(mask_string, "NULL") && strcmp(mask_string, "0")) {
    // A mask volume is used to limit the extend of other volumes, called the masked volumes. These are specified in the mask_string.
    // In order for a ray to enter a masked volume, it needs to be both in the region covered by that volume AND the mask volume.
    // When more than
    this_box_volume.geometry.mask_mode = 1; // Default is mask mode is ALL
    if (mask_setting && strlen(mask_setting) && strcmp(mask_setting, "NULL") && strcmp(mask_setting, "0")) {
        if (strcmp(mask_setting,"ALL") == 0 || strcmp(mask_setting,"All") == 0) this_box_volume.geometry.mask_mode = 1;
        else if (strcmp(mask_setting,"ANY") == 0 || strcmp(mask_setting,"Any") == 0) this_box_volume.geometry.mask_mode = 2;
        else {
            printf("The mask_mode of component %s is set to %s, but must be either ALL or ANY.\n",NAME_CURRENT_COMP,mask_setting);
            exit(1);
        }
    }
    
    for (loop_index=0;loop_index<global_geometry_list.num_elements;loop_index++) {
        // Add mask list
        if (1 == manual_linking_function(global_geometry_list.elements[loop_index].name,mask_string)) {
            add_element_to_int_list(&this_box_volume.geometry.mask_list,global_geometry_list.elements[loop_index].component_index);
            add_element_to_int_list(&global_geometry_list.elements[loop_index].Volume->geometry.masked_by_list,INDEX_CURRENT_COMP);
            global_geometry_list.elements[loop_index].Volume->geometry.is_masked_volume = 1;
            if (this_box_volume.geometry.mask_mode == 2)
                global_geometry_list.elements[loop_index].Volume->geometry.mask_mode = 2;
            if (this_box_volume.geometry.mask_mode == 1) {
                if (global_geometry_list.elements[loop_index].Volume->geometry.is_masked_volume == 1 && global_geometry_list.elements[loop_index].Volume->geometry.mask_mode != 2)
                    // If more than one mask is added to one volume, the ANY mode overwrites the (default) ALL mode.
                    global_geometry_list.elements[loop_index].Volume->geometry.mask_mode = 1;
            }
            
            found_geometries = 1;
        }
    }
    if (found_geometries == 0) {
        printf("The mask_string in geometry: %s did not find any of the specified volumes in the mask_string %s \n",NAME_CURRENT_COMP,mask_string);
        exit(1);
    }
    this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
    this_box_volume.p_physics->is_vacuum = 0; // Makes this volume a vacuum
    this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
    this_box_volume.p_physics->my_a = 0; // Should not be used.
    sprintf(this_box_volume.p_physics->name,"Mask");
    this_box_volume.geometry.is_mask_volume = 1;
    
    
// Read the material input, or if it lacks, use automatic linking.
} else if (material_string && strlen(material_string) && strcmp(material_string, "NULL") && strcmp(material_string, "0")) {
    // A geometry string was given, use it to determine which material
    if (0 == strcmp(material_string,"vacuum") || 0 == strcmp(material_string,"Vacuum")) {
        // One could have a global physics struct for vacuum instead of creating one for each
        this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
        this_box_volume.p_physics->is_vacuum = 1; // Makes this volume a vacuum
        this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
        this_box_volume.p_physics->my_a = 0; // Should not be used.
        sprintf(this_box_volume.p_physics->name,"Vacuum");
    } else if (0 == strcmp(material_string,"exit") || 0 == strcmp(material_string,"Exit")) {
        // One could have a global physics struct for vacuum instead of creating one for each
        this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
        this_box_volume.p_physics->is_vacuum = 1; // Makes this volume a vacuum
        this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
        this_box_volume.p_physics->my_a = 0; // Should not be used.
        this_box_volume.geometry.is_exit_volume = 1;
        sprintf(this_box_volume.p_physics->name,"Exit");
    } else {
        #ifndef MATERIAL_DETECTOR
            printf("Need to define a material before refering to it in a geometry %s.\n",NAME_CURRENT_COMP);
            exit(1);
        #endif
        for (loop_index=0;loop_index<global_material_list.num_elements;loop_index++) {
            if (0 == strcmp(material_string,global_material_list.elements[loop_index].name)) {
                this_box_volume.p_physics = global_material_list.elements[loop_index].physics;
                break;
            }
            if (loop_index == global_material_list.num_elements-1) {
            printf("\n");
            printf("ERROR: The material string \"%s\" in Union geometry \"%s\" did not match a specified material. \n",material_string,NAME_CURRENT_COMP);
            printf("       The materials available at this point (need to be defined before the geometry): \n");
            for (loop_index=0;loop_index<global_material_list.num_elements;loop_index++)
              printf("         %s\n",global_material_list.elements[loop_index].name);
            printf("\n");
            printf("       It is also possible to use one of the defualt materials avaiable: \n");
            printf("           Vacuum (for a Volume without scattering or absorption)\n");
            printf("           Exit (for a Volume where the ray exits the component if it enters)\n");
            printf("           Mask (for a Volume that masks existing volumes specified in the mask_string\n");
            exit(1);
          }
        }
    }
} else {
    // Automatic linking, simply using the last defined material.
    #ifndef MATERIAL_DETECTOR
        printf("Need to define a material before the geometry to use automatic linking %s.\n",NAME_CURRENT_COMP);
        exit(1);
    #endif
    this_box_volume.p_physics = global_material_list.elements[global_material_list.num_elements-1].physics;
}

sprintf(this_box_volume.name,NAME_CURRENT_COMP);
sprintf(this_box_volume.geometry.shape,"box");
this_box_volume.geometry.priority_value = priority;
this_box_volume.geometry.geometry_p_interact = p_interact;
// Currently the coordinates will be in absolute space.
this_box_volume.geometry.center = POS_A_CURRENT_COMP;

this_box_storage.z_depth = zdepth;
this_box_storage.x_width1 = xwidth;
this_box_storage.y_height1 = yheight;

this_box_storage.is_rectangle = 0;
if (xwidth2 < 0 && yheight2 < 0) this_box_storage.is_rectangle = 1;
if (xwidth == xwidth2 && yheight == yheight2) this_box_storage.is_rectangle = 1;

if (xwidth2 < 0) {
    this_box_storage.x_width2 = xwidth;
    xwidth2 = xwidth;
} else this_box_storage.x_width2 = xwidth2;

if (yheight2 < 0) {
    this_box_storage.y_height2 = yheight;
    yheight2 = yheight;
} else this_box_storage.y_height2 = yheight2;


this_box_storage.normal_vectors[0] = coords_set(0,0,1);
this_box_storage.normal_vectors[1] = coords_set(0,0,1);

// for sides with y component = 0
x_component = 2*zdepth/sqrt((xwidth-xwidth2)*(xwidth-xwidth2)+4*zdepth*zdepth);
z_component = (xwidth-xwidth2)/sqrt(4*zdepth*zdepth+(xwidth-xwidth2)*(xwidth-xwidth2));

this_box_storage.normal_vectors[2] = coords_set(x_component,0,z_component);
this_box_storage.normal_vectors[3] = coords_set(-x_component,0,z_component);

// for sides with x component = 0
y_component = 2*zdepth/sqrt((yheight-yheight2)*(yheight-yheight2)+4*zdepth*zdepth);
z_component = (yheight-yheight2)/sqrt(4*zdepth*zdepth+(yheight-yheight2)*(yheight-yheight2));

this_box_storage.normal_vectors[4] = coords_set(0,y_component,z_component);
this_box_storage.normal_vectors[5] = coords_set(0,-y_component,z_component);

this_box_volume.geometry.visualization_on = visualize;

this_box_volume.geometry.geometry_parameters.p_box_storage = &this_box_storage;

// Assign pointers to functions for intersection with the shape, checking if a point is inside the shape
if (this_box_storage.is_rectangle == 1) {
this_box_volume.geometry.intersect_function = &sample_box_intersect_simple;
this_box_volume.geometry.within_function = &r_within_box_simple;
}
else {
this_box_volume.geometry.intersect_function = &sample_box_intersect_advanced;
this_box_volume.geometry.within_function = &r_within_box_advanced;
}

this_box_volume.geometry.shell_points = &box_shell_points;
this_box_volume.geometry.mcdisplay_function = &mcdisplay_box_function;
this_box_volume.geometry.initialize_from_main_function = &initialize_box_geometry_from_main_component;
this_box_volume.geometry.process_rot_allocated = 0;

this_box_volume.geometry.copy_geometry_parameters = &allocate_box_storage_copy;

rot_copy(this_box_volume.geometry.rotation_matrix,ROT_A_CURRENT_COMP); //check how ROT_R_CURRENT_COMP would work
rot_transpose(ROT_A_CURRENT_COMP,this_box_volume.geometry.transpose_rotation_matrix);

// Initialize loggers
this_box_volume.loggers.num_elements = 0;

// packing the information into the global_geometry_element, which is then included in the global_geometry_list.
sprintf(global_geometry_element.name,NAME_CURRENT_COMP);
global_geometry_element.activation_counter = number_of_activations;
global_geometry_element.component_index = INDEX_CURRENT_COMP;
global_geometry_element.Volume = &this_box_volume; // Would be nicer if this m was a pointer, now we have the (small) data two places
add_element_to_geometry_list(&global_geometry_list,global_geometry_element);
}
#line 239777 "MACS_sample_kidney_box.c"
#undef number_of_activations
#undef mask_setting
#undef mask_string
#undef p_interact
#undef focus_r
#undef focus_xh
#undef focus_xw
#undef focus_ah
#undef focus_aw
#undef target_z
#undef target_y
#undef target_x
#undef target_index
#undef visualize
#undef yheight2
#undef xwidth2
#undef zdepth
#undef yheight
#undef xwidth
#undef priority
#undef material_string
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

  /* Initializations for component channel_8_analyzer_2_array_crystal_array_5. */
  SIG_MESSAGE("channel_8_analyzer_2_array_crystal_array_5 (Init)");
#define mccompcurname  channel_8_analyzer_2_array_crystal_array_5
#define mccompcurtype  Union_box
#define mccompcurindex 450
#define loop_index mccchannel_8_analyzer_2_array_crystal_array_5_loop_index
#define this_box_volume mccchannel_8_analyzer_2_array_crystal_array_5_this_box_volume
#define global_geometry_element mccchannel_8_analyzer_2_array_crystal_array_5_global_geometry_element
#define this_box_storage mccchannel_8_analyzer_2_array_crystal_array_5_this_box_storage
#define material_string mccchannel_8_analyzer_2_array_crystal_array_5_material_string
#define priority mccchannel_8_analyzer_2_array_crystal_array_5_priority
#define xwidth mccchannel_8_analyzer_2_array_crystal_array_5_xwidth
#define yheight mccchannel_8_analyzer_2_array_crystal_array_5_yheight
#define zdepth mccchannel_8_analyzer_2_array_crystal_array_5_zdepth
#define xwidth2 mccchannel_8_analyzer_2_array_crystal_array_5_xwidth2
#define yheight2 mccchannel_8_analyzer_2_array_crystal_array_5_yheight2
#define visualize mccchannel_8_analyzer_2_array_crystal_array_5_visualize
#define target_index mccchannel_8_analyzer_2_array_crystal_array_5_target_index
#define target_x mccchannel_8_analyzer_2_array_crystal_array_5_target_x
#define target_y mccchannel_8_analyzer_2_array_crystal_array_5_target_y
#define target_z mccchannel_8_analyzer_2_array_crystal_array_5_target_z
#define focus_aw mccchannel_8_analyzer_2_array_crystal_array_5_focus_aw
#define focus_ah mccchannel_8_analyzer_2_array_crystal_array_5_focus_ah
#define focus_xw mccchannel_8_analyzer_2_array_crystal_array_5_focus_xw
#define focus_xh mccchannel_8_analyzer_2_array_crystal_array_5_focus_xh
#define focus_r mccchannel_8_analyzer_2_array_crystal_array_5_focus_r
#define p_interact mccchannel_8_analyzer_2_array_crystal_array_5_p_interact
#define mask_string mccchannel_8_analyzer_2_array_crystal_array_5_mask_string
#define mask_setting mccchannel_8_analyzer_2_array_crystal_array_5_mask_setting
#define number_of_activations mccchannel_8_analyzer_2_array_crystal_array_5_number_of_activations
#line 224 "Union_box.comp"
{
// Initializes the focusing system for this volume including input sanitation.
focus_initialize(&this_box_volume.geometry, POS_A_COMP_INDEX(INDEX_CURRENT_COMP+target_index), POS_A_CURRENT_COMP, ROT_A_CURRENT_COMP, target_index, target_x, target_y, target_z, focus_aw, focus_ah, focus_xw, focus_xh, focus_r, NAME_CURRENT_COMP);

// Input sanitation for this geometry
if (xwidth <= 0) {
  printf("\nERROR in Union_box named %s, the xwidth is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (yheight <= 0) {
  printf("\nERROR in Union_box named %s, yheight is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (zdepth <= 0) {
  printf("\nERROR in Union_box named %s, zdepth is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (xwidth2 <= 0 && xwidth2 != -1) {
  printf("\nERROR in Union_box named %s, the xwidth2 is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (yheight2 <= 0 && yheight2 != -1) {
  printf("\nERROR in Union_box named %s, yheight2 is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}

// Use sanitation
if (global_material_list.num_elements == 0) {
  printf("\nERROR: Need to define a material using Union_make_material before using a Union geometry component. \n");
  printf("       %s was defined before first use of Union_make_material.\n",NAME_CURRENT_COMP);
  exit(1);
}

this_box_volume.geometry.is_masked_volume = 0;
this_box_volume.geometry.is_exit_volume = 0;
this_box_volume.geometry.is_mask_volume = 0;
// check if the volume is a mask, if it is the material string is irelevant.
if (mask_string && strlen(mask_string) && strcmp(mask_string, "NULL") && strcmp(mask_string, "0")) {
    // A mask volume is used to limit the extend of other volumes, called the masked volumes. These are specified in the mask_string.
    // In order for a ray to enter a masked volume, it needs to be both in the region covered by that volume AND the mask volume.
    // When more than
    this_box_volume.geometry.mask_mode = 1; // Default is mask mode is ALL
    if (mask_setting && strlen(mask_setting) && strcmp(mask_setting, "NULL") && strcmp(mask_setting, "0")) {
        if (strcmp(mask_setting,"ALL") == 0 || strcmp(mask_setting,"All") == 0) this_box_volume.geometry.mask_mode = 1;
        else if (strcmp(mask_setting,"ANY") == 0 || strcmp(mask_setting,"Any") == 0) this_box_volume.geometry.mask_mode = 2;
        else {
            printf("The mask_mode of component %s is set to %s, but must be either ALL or ANY.\n",NAME_CURRENT_COMP,mask_setting);
            exit(1);
        }
    }
    
    for (loop_index=0;loop_index<global_geometry_list.num_elements;loop_index++) {
        // Add mask list
        if (1 == manual_linking_function(global_geometry_list.elements[loop_index].name,mask_string)) {
            add_element_to_int_list(&this_box_volume.geometry.mask_list,global_geometry_list.elements[loop_index].component_index);
            add_element_to_int_list(&global_geometry_list.elements[loop_index].Volume->geometry.masked_by_list,INDEX_CURRENT_COMP);
            global_geometry_list.elements[loop_index].Volume->geometry.is_masked_volume = 1;
            if (this_box_volume.geometry.mask_mode == 2)
                global_geometry_list.elements[loop_index].Volume->geometry.mask_mode = 2;
            if (this_box_volume.geometry.mask_mode == 1) {
                if (global_geometry_list.elements[loop_index].Volume->geometry.is_masked_volume == 1 && global_geometry_list.elements[loop_index].Volume->geometry.mask_mode != 2)
                    // If more than one mask is added to one volume, the ANY mode overwrites the (default) ALL mode.
                    global_geometry_list.elements[loop_index].Volume->geometry.mask_mode = 1;
            }
            
            found_geometries = 1;
        }
    }
    if (found_geometries == 0) {
        printf("The mask_string in geometry: %s did not find any of the specified volumes in the mask_string %s \n",NAME_CURRENT_COMP,mask_string);
        exit(1);
    }
    this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
    this_box_volume.p_physics->is_vacuum = 0; // Makes this volume a vacuum
    this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
    this_box_volume.p_physics->my_a = 0; // Should not be used.
    sprintf(this_box_volume.p_physics->name,"Mask");
    this_box_volume.geometry.is_mask_volume = 1;
    
    
// Read the material input, or if it lacks, use automatic linking.
} else if (material_string && strlen(material_string) && strcmp(material_string, "NULL") && strcmp(material_string, "0")) {
    // A geometry string was given, use it to determine which material
    if (0 == strcmp(material_string,"vacuum") || 0 == strcmp(material_string,"Vacuum")) {
        // One could have a global physics struct for vacuum instead of creating one for each
        this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
        this_box_volume.p_physics->is_vacuum = 1; // Makes this volume a vacuum
        this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
        this_box_volume.p_physics->my_a = 0; // Should not be used.
        sprintf(this_box_volume.p_physics->name,"Vacuum");
    } else if (0 == strcmp(material_string,"exit") || 0 == strcmp(material_string,"Exit")) {
        // One could have a global physics struct for vacuum instead of creating one for each
        this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
        this_box_volume.p_physics->is_vacuum = 1; // Makes this volume a vacuum
        this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
        this_box_volume.p_physics->my_a = 0; // Should not be used.
        this_box_volume.geometry.is_exit_volume = 1;
        sprintf(this_box_volume.p_physics->name,"Exit");
    } else {
        #ifndef MATERIAL_DETECTOR
            printf("Need to define a material before refering to it in a geometry %s.\n",NAME_CURRENT_COMP);
            exit(1);
        #endif
        for (loop_index=0;loop_index<global_material_list.num_elements;loop_index++) {
            if (0 == strcmp(material_string,global_material_list.elements[loop_index].name)) {
                this_box_volume.p_physics = global_material_list.elements[loop_index].physics;
                break;
            }
            if (loop_index == global_material_list.num_elements-1) {
            printf("\n");
            printf("ERROR: The material string \"%s\" in Union geometry \"%s\" did not match a specified material. \n",material_string,NAME_CURRENT_COMP);
            printf("       The materials available at this point (need to be defined before the geometry): \n");
            for (loop_index=0;loop_index<global_material_list.num_elements;loop_index++)
              printf("         %s\n",global_material_list.elements[loop_index].name);
            printf("\n");
            printf("       It is also possible to use one of the defualt materials avaiable: \n");
            printf("           Vacuum (for a Volume without scattering or absorption)\n");
            printf("           Exit (for a Volume where the ray exits the component if it enters)\n");
            printf("           Mask (for a Volume that masks existing volumes specified in the mask_string\n");
            exit(1);
          }
        }
    }
} else {
    // Automatic linking, simply using the last defined material.
    #ifndef MATERIAL_DETECTOR
        printf("Need to define a material before the geometry to use automatic linking %s.\n",NAME_CURRENT_COMP);
        exit(1);
    #endif
    this_box_volume.p_physics = global_material_list.elements[global_material_list.num_elements-1].physics;
}

sprintf(this_box_volume.name,NAME_CURRENT_COMP);
sprintf(this_box_volume.geometry.shape,"box");
this_box_volume.geometry.priority_value = priority;
this_box_volume.geometry.geometry_p_interact = p_interact;
// Currently the coordinates will be in absolute space.
this_box_volume.geometry.center = POS_A_CURRENT_COMP;

this_box_storage.z_depth = zdepth;
this_box_storage.x_width1 = xwidth;
this_box_storage.y_height1 = yheight;

this_box_storage.is_rectangle = 0;
if (xwidth2 < 0 && yheight2 < 0) this_box_storage.is_rectangle = 1;
if (xwidth == xwidth2 && yheight == yheight2) this_box_storage.is_rectangle = 1;

if (xwidth2 < 0) {
    this_box_storage.x_width2 = xwidth;
    xwidth2 = xwidth;
} else this_box_storage.x_width2 = xwidth2;

if (yheight2 < 0) {
    this_box_storage.y_height2 = yheight;
    yheight2 = yheight;
} else this_box_storage.y_height2 = yheight2;


this_box_storage.normal_vectors[0] = coords_set(0,0,1);
this_box_storage.normal_vectors[1] = coords_set(0,0,1);

// for sides with y component = 0
x_component = 2*zdepth/sqrt((xwidth-xwidth2)*(xwidth-xwidth2)+4*zdepth*zdepth);
z_component = (xwidth-xwidth2)/sqrt(4*zdepth*zdepth+(xwidth-xwidth2)*(xwidth-xwidth2));

this_box_storage.normal_vectors[2] = coords_set(x_component,0,z_component);
this_box_storage.normal_vectors[3] = coords_set(-x_component,0,z_component);

// for sides with x component = 0
y_component = 2*zdepth/sqrt((yheight-yheight2)*(yheight-yheight2)+4*zdepth*zdepth);
z_component = (yheight-yheight2)/sqrt(4*zdepth*zdepth+(yheight-yheight2)*(yheight-yheight2));

this_box_storage.normal_vectors[4] = coords_set(0,y_component,z_component);
this_box_storage.normal_vectors[5] = coords_set(0,-y_component,z_component);

this_box_volume.geometry.visualization_on = visualize;

this_box_volume.geometry.geometry_parameters.p_box_storage = &this_box_storage;

// Assign pointers to functions for intersection with the shape, checking if a point is inside the shape
if (this_box_storage.is_rectangle == 1) {
this_box_volume.geometry.intersect_function = &sample_box_intersect_simple;
this_box_volume.geometry.within_function = &r_within_box_simple;
}
else {
this_box_volume.geometry.intersect_function = &sample_box_intersect_advanced;
this_box_volume.geometry.within_function = &r_within_box_advanced;
}

this_box_volume.geometry.shell_points = &box_shell_points;
this_box_volume.geometry.mcdisplay_function = &mcdisplay_box_function;
this_box_volume.geometry.initialize_from_main_function = &initialize_box_geometry_from_main_component;
this_box_volume.geometry.process_rot_allocated = 0;

this_box_volume.geometry.copy_geometry_parameters = &allocate_box_storage_copy;

rot_copy(this_box_volume.geometry.rotation_matrix,ROT_A_CURRENT_COMP); //check how ROT_R_CURRENT_COMP would work
rot_transpose(ROT_A_CURRENT_COMP,this_box_volume.geometry.transpose_rotation_matrix);

// Initialize loggers
this_box_volume.loggers.num_elements = 0;

// packing the information into the global_geometry_element, which is then included in the global_geometry_list.
sprintf(global_geometry_element.name,NAME_CURRENT_COMP);
global_geometry_element.activation_counter = number_of_activations;
global_geometry_element.component_index = INDEX_CURRENT_COMP;
global_geometry_element.Volume = &this_box_volume; // Would be nicer if this m was a pointer, now we have the (small) data two places
add_element_to_geometry_list(&global_geometry_list,global_geometry_element);
}
#line 240047 "MACS_sample_kidney_box.c"
#undef number_of_activations
#undef mask_setting
#undef mask_string
#undef p_interact
#undef focus_r
#undef focus_xh
#undef focus_xw
#undef focus_ah
#undef focus_aw
#undef target_z
#undef target_y
#undef target_x
#undef target_index
#undef visualize
#undef yheight2
#undef xwidth2
#undef zdepth
#undef yheight
#undef xwidth
#undef priority
#undef material_string
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

  /* Initializations for component channel_8_analyzer_2_array_crystal_array_6. */
  SIG_MESSAGE("channel_8_analyzer_2_array_crystal_array_6 (Init)");
#define mccompcurname  channel_8_analyzer_2_array_crystal_array_6
#define mccompcurtype  Union_box
#define mccompcurindex 451
#define loop_index mccchannel_8_analyzer_2_array_crystal_array_6_loop_index
#define this_box_volume mccchannel_8_analyzer_2_array_crystal_array_6_this_box_volume
#define global_geometry_element mccchannel_8_analyzer_2_array_crystal_array_6_global_geometry_element
#define this_box_storage mccchannel_8_analyzer_2_array_crystal_array_6_this_box_storage
#define material_string mccchannel_8_analyzer_2_array_crystal_array_6_material_string
#define priority mccchannel_8_analyzer_2_array_crystal_array_6_priority
#define xwidth mccchannel_8_analyzer_2_array_crystal_array_6_xwidth
#define yheight mccchannel_8_analyzer_2_array_crystal_array_6_yheight
#define zdepth mccchannel_8_analyzer_2_array_crystal_array_6_zdepth
#define xwidth2 mccchannel_8_analyzer_2_array_crystal_array_6_xwidth2
#define yheight2 mccchannel_8_analyzer_2_array_crystal_array_6_yheight2
#define visualize mccchannel_8_analyzer_2_array_crystal_array_6_visualize
#define target_index mccchannel_8_analyzer_2_array_crystal_array_6_target_index
#define target_x mccchannel_8_analyzer_2_array_crystal_array_6_target_x
#define target_y mccchannel_8_analyzer_2_array_crystal_array_6_target_y
#define target_z mccchannel_8_analyzer_2_array_crystal_array_6_target_z
#define focus_aw mccchannel_8_analyzer_2_array_crystal_array_6_focus_aw
#define focus_ah mccchannel_8_analyzer_2_array_crystal_array_6_focus_ah
#define focus_xw mccchannel_8_analyzer_2_array_crystal_array_6_focus_xw
#define focus_xh mccchannel_8_analyzer_2_array_crystal_array_6_focus_xh
#define focus_r mccchannel_8_analyzer_2_array_crystal_array_6_focus_r
#define p_interact mccchannel_8_analyzer_2_array_crystal_array_6_p_interact
#define mask_string mccchannel_8_analyzer_2_array_crystal_array_6_mask_string
#define mask_setting mccchannel_8_analyzer_2_array_crystal_array_6_mask_setting
#define number_of_activations mccchannel_8_analyzer_2_array_crystal_array_6_number_of_activations
#line 224 "Union_box.comp"
{
// Initializes the focusing system for this volume including input sanitation.
focus_initialize(&this_box_volume.geometry, POS_A_COMP_INDEX(INDEX_CURRENT_COMP+target_index), POS_A_CURRENT_COMP, ROT_A_CURRENT_COMP, target_index, target_x, target_y, target_z, focus_aw, focus_ah, focus_xw, focus_xh, focus_r, NAME_CURRENT_COMP);

// Input sanitation for this geometry
if (xwidth <= 0) {
  printf("\nERROR in Union_box named %s, the xwidth is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (yheight <= 0) {
  printf("\nERROR in Union_box named %s, yheight is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (zdepth <= 0) {
  printf("\nERROR in Union_box named %s, zdepth is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (xwidth2 <= 0 && xwidth2 != -1) {
  printf("\nERROR in Union_box named %s, the xwidth2 is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (yheight2 <= 0 && yheight2 != -1) {
  printf("\nERROR in Union_box named %s, yheight2 is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}

// Use sanitation
if (global_material_list.num_elements == 0) {
  printf("\nERROR: Need to define a material using Union_make_material before using a Union geometry component. \n");
  printf("       %s was defined before first use of Union_make_material.\n",NAME_CURRENT_COMP);
  exit(1);
}

this_box_volume.geometry.is_masked_volume = 0;
this_box_volume.geometry.is_exit_volume = 0;
this_box_volume.geometry.is_mask_volume = 0;
// check if the volume is a mask, if it is the material string is irelevant.
if (mask_string && strlen(mask_string) && strcmp(mask_string, "NULL") && strcmp(mask_string, "0")) {
    // A mask volume is used to limit the extend of other volumes, called the masked volumes. These are specified in the mask_string.
    // In order for a ray to enter a masked volume, it needs to be both in the region covered by that volume AND the mask volume.
    // When more than
    this_box_volume.geometry.mask_mode = 1; // Default is mask mode is ALL
    if (mask_setting && strlen(mask_setting) && strcmp(mask_setting, "NULL") && strcmp(mask_setting, "0")) {
        if (strcmp(mask_setting,"ALL") == 0 || strcmp(mask_setting,"All") == 0) this_box_volume.geometry.mask_mode = 1;
        else if (strcmp(mask_setting,"ANY") == 0 || strcmp(mask_setting,"Any") == 0) this_box_volume.geometry.mask_mode = 2;
        else {
            printf("The mask_mode of component %s is set to %s, but must be either ALL or ANY.\n",NAME_CURRENT_COMP,mask_setting);
            exit(1);
        }
    }
    
    for (loop_index=0;loop_index<global_geometry_list.num_elements;loop_index++) {
        // Add mask list
        if (1 == manual_linking_function(global_geometry_list.elements[loop_index].name,mask_string)) {
            add_element_to_int_list(&this_box_volume.geometry.mask_list,global_geometry_list.elements[loop_index].component_index);
            add_element_to_int_list(&global_geometry_list.elements[loop_index].Volume->geometry.masked_by_list,INDEX_CURRENT_COMP);
            global_geometry_list.elements[loop_index].Volume->geometry.is_masked_volume = 1;
            if (this_box_volume.geometry.mask_mode == 2)
                global_geometry_list.elements[loop_index].Volume->geometry.mask_mode = 2;
            if (this_box_volume.geometry.mask_mode == 1) {
                if (global_geometry_list.elements[loop_index].Volume->geometry.is_masked_volume == 1 && global_geometry_list.elements[loop_index].Volume->geometry.mask_mode != 2)
                    // If more than one mask is added to one volume, the ANY mode overwrites the (default) ALL mode.
                    global_geometry_list.elements[loop_index].Volume->geometry.mask_mode = 1;
            }
            
            found_geometries = 1;
        }
    }
    if (found_geometries == 0) {
        printf("The mask_string in geometry: %s did not find any of the specified volumes in the mask_string %s \n",NAME_CURRENT_COMP,mask_string);
        exit(1);
    }
    this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
    this_box_volume.p_physics->is_vacuum = 0; // Makes this volume a vacuum
    this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
    this_box_volume.p_physics->my_a = 0; // Should not be used.
    sprintf(this_box_volume.p_physics->name,"Mask");
    this_box_volume.geometry.is_mask_volume = 1;
    
    
// Read the material input, or if it lacks, use automatic linking.
} else if (material_string && strlen(material_string) && strcmp(material_string, "NULL") && strcmp(material_string, "0")) {
    // A geometry string was given, use it to determine which material
    if (0 == strcmp(material_string,"vacuum") || 0 == strcmp(material_string,"Vacuum")) {
        // One could have a global physics struct for vacuum instead of creating one for each
        this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
        this_box_volume.p_physics->is_vacuum = 1; // Makes this volume a vacuum
        this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
        this_box_volume.p_physics->my_a = 0; // Should not be used.
        sprintf(this_box_volume.p_physics->name,"Vacuum");
    } else if (0 == strcmp(material_string,"exit") || 0 == strcmp(material_string,"Exit")) {
        // One could have a global physics struct for vacuum instead of creating one for each
        this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
        this_box_volume.p_physics->is_vacuum = 1; // Makes this volume a vacuum
        this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
        this_box_volume.p_physics->my_a = 0; // Should not be used.
        this_box_volume.geometry.is_exit_volume = 1;
        sprintf(this_box_volume.p_physics->name,"Exit");
    } else {
        #ifndef MATERIAL_DETECTOR
            printf("Need to define a material before refering to it in a geometry %s.\n",NAME_CURRENT_COMP);
            exit(1);
        #endif
        for (loop_index=0;loop_index<global_material_list.num_elements;loop_index++) {
            if (0 == strcmp(material_string,global_material_list.elements[loop_index].name)) {
                this_box_volume.p_physics = global_material_list.elements[loop_index].physics;
                break;
            }
            if (loop_index == global_material_list.num_elements-1) {
            printf("\n");
            printf("ERROR: The material string \"%s\" in Union geometry \"%s\" did not match a specified material. \n",material_string,NAME_CURRENT_COMP);
            printf("       The materials available at this point (need to be defined before the geometry): \n");
            for (loop_index=0;loop_index<global_material_list.num_elements;loop_index++)
              printf("         %s\n",global_material_list.elements[loop_index].name);
            printf("\n");
            printf("       It is also possible to use one of the defualt materials avaiable: \n");
            printf("           Vacuum (for a Volume without scattering or absorption)\n");
            printf("           Exit (for a Volume where the ray exits the component if it enters)\n");
            printf("           Mask (for a Volume that masks existing volumes specified in the mask_string\n");
            exit(1);
          }
        }
    }
} else {
    // Automatic linking, simply using the last defined material.
    #ifndef MATERIAL_DETECTOR
        printf("Need to define a material before the geometry to use automatic linking %s.\n",NAME_CURRENT_COMP);
        exit(1);
    #endif
    this_box_volume.p_physics = global_material_list.elements[global_material_list.num_elements-1].physics;
}

sprintf(this_box_volume.name,NAME_CURRENT_COMP);
sprintf(this_box_volume.geometry.shape,"box");
this_box_volume.geometry.priority_value = priority;
this_box_volume.geometry.geometry_p_interact = p_interact;
// Currently the coordinates will be in absolute space.
this_box_volume.geometry.center = POS_A_CURRENT_COMP;

this_box_storage.z_depth = zdepth;
this_box_storage.x_width1 = xwidth;
this_box_storage.y_height1 = yheight;

this_box_storage.is_rectangle = 0;
if (xwidth2 < 0 && yheight2 < 0) this_box_storage.is_rectangle = 1;
if (xwidth == xwidth2 && yheight == yheight2) this_box_storage.is_rectangle = 1;

if (xwidth2 < 0) {
    this_box_storage.x_width2 = xwidth;
    xwidth2 = xwidth;
} else this_box_storage.x_width2 = xwidth2;

if (yheight2 < 0) {
    this_box_storage.y_height2 = yheight;
    yheight2 = yheight;
} else this_box_storage.y_height2 = yheight2;


this_box_storage.normal_vectors[0] = coords_set(0,0,1);
this_box_storage.normal_vectors[1] = coords_set(0,0,1);

// for sides with y component = 0
x_component = 2*zdepth/sqrt((xwidth-xwidth2)*(xwidth-xwidth2)+4*zdepth*zdepth);
z_component = (xwidth-xwidth2)/sqrt(4*zdepth*zdepth+(xwidth-xwidth2)*(xwidth-xwidth2));

this_box_storage.normal_vectors[2] = coords_set(x_component,0,z_component);
this_box_storage.normal_vectors[3] = coords_set(-x_component,0,z_component);

// for sides with x component = 0
y_component = 2*zdepth/sqrt((yheight-yheight2)*(yheight-yheight2)+4*zdepth*zdepth);
z_component = (yheight-yheight2)/sqrt(4*zdepth*zdepth+(yheight-yheight2)*(yheight-yheight2));

this_box_storage.normal_vectors[4] = coords_set(0,y_component,z_component);
this_box_storage.normal_vectors[5] = coords_set(0,-y_component,z_component);

this_box_volume.geometry.visualization_on = visualize;

this_box_volume.geometry.geometry_parameters.p_box_storage = &this_box_storage;

// Assign pointers to functions for intersection with the shape, checking if a point is inside the shape
if (this_box_storage.is_rectangle == 1) {
this_box_volume.geometry.intersect_function = &sample_box_intersect_simple;
this_box_volume.geometry.within_function = &r_within_box_simple;
}
else {
this_box_volume.geometry.intersect_function = &sample_box_intersect_advanced;
this_box_volume.geometry.within_function = &r_within_box_advanced;
}

this_box_volume.geometry.shell_points = &box_shell_points;
this_box_volume.geometry.mcdisplay_function = &mcdisplay_box_function;
this_box_volume.geometry.initialize_from_main_function = &initialize_box_geometry_from_main_component;
this_box_volume.geometry.process_rot_allocated = 0;

this_box_volume.geometry.copy_geometry_parameters = &allocate_box_storage_copy;

rot_copy(this_box_volume.geometry.rotation_matrix,ROT_A_CURRENT_COMP); //check how ROT_R_CURRENT_COMP would work
rot_transpose(ROT_A_CURRENT_COMP,this_box_volume.geometry.transpose_rotation_matrix);

// Initialize loggers
this_box_volume.loggers.num_elements = 0;

// packing the information into the global_geometry_element, which is then included in the global_geometry_list.
sprintf(global_geometry_element.name,NAME_CURRENT_COMP);
global_geometry_element.activation_counter = number_of_activations;
global_geometry_element.component_index = INDEX_CURRENT_COMP;
global_geometry_element.Volume = &this_box_volume; // Would be nicer if this m was a pointer, now we have the (small) data two places
add_element_to_geometry_list(&global_geometry_list,global_geometry_element);
}
#line 240317 "MACS_sample_kidney_box.c"
#undef number_of_activations
#undef mask_setting
#undef mask_string
#undef p_interact
#undef focus_r
#undef focus_xh
#undef focus_xw
#undef focus_ah
#undef focus_aw
#undef target_z
#undef target_y
#undef target_x
#undef target_index
#undef visualize
#undef yheight2
#undef xwidth2
#undef zdepth
#undef yheight
#undef xwidth
#undef priority
#undef material_string
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

  /* Initializations for component channel_8_analyzer_2_array_crystal_array_7. */
  SIG_MESSAGE("channel_8_analyzer_2_array_crystal_array_7 (Init)");
#define mccompcurname  channel_8_analyzer_2_array_crystal_array_7
#define mccompcurtype  Union_box
#define mccompcurindex 452
#define loop_index mccchannel_8_analyzer_2_array_crystal_array_7_loop_index
#define this_box_volume mccchannel_8_analyzer_2_array_crystal_array_7_this_box_volume
#define global_geometry_element mccchannel_8_analyzer_2_array_crystal_array_7_global_geometry_element
#define this_box_storage mccchannel_8_analyzer_2_array_crystal_array_7_this_box_storage
#define material_string mccchannel_8_analyzer_2_array_crystal_array_7_material_string
#define priority mccchannel_8_analyzer_2_array_crystal_array_7_priority
#define xwidth mccchannel_8_analyzer_2_array_crystal_array_7_xwidth
#define yheight mccchannel_8_analyzer_2_array_crystal_array_7_yheight
#define zdepth mccchannel_8_analyzer_2_array_crystal_array_7_zdepth
#define xwidth2 mccchannel_8_analyzer_2_array_crystal_array_7_xwidth2
#define yheight2 mccchannel_8_analyzer_2_array_crystal_array_7_yheight2
#define visualize mccchannel_8_analyzer_2_array_crystal_array_7_visualize
#define target_index mccchannel_8_analyzer_2_array_crystal_array_7_target_index
#define target_x mccchannel_8_analyzer_2_array_crystal_array_7_target_x
#define target_y mccchannel_8_analyzer_2_array_crystal_array_7_target_y
#define target_z mccchannel_8_analyzer_2_array_crystal_array_7_target_z
#define focus_aw mccchannel_8_analyzer_2_array_crystal_array_7_focus_aw
#define focus_ah mccchannel_8_analyzer_2_array_crystal_array_7_focus_ah
#define focus_xw mccchannel_8_analyzer_2_array_crystal_array_7_focus_xw
#define focus_xh mccchannel_8_analyzer_2_array_crystal_array_7_focus_xh
#define focus_r mccchannel_8_analyzer_2_array_crystal_array_7_focus_r
#define p_interact mccchannel_8_analyzer_2_array_crystal_array_7_p_interact
#define mask_string mccchannel_8_analyzer_2_array_crystal_array_7_mask_string
#define mask_setting mccchannel_8_analyzer_2_array_crystal_array_7_mask_setting
#define number_of_activations mccchannel_8_analyzer_2_array_crystal_array_7_number_of_activations
#line 224 "Union_box.comp"
{
// Initializes the focusing system for this volume including input sanitation.
focus_initialize(&this_box_volume.geometry, POS_A_COMP_INDEX(INDEX_CURRENT_COMP+target_index), POS_A_CURRENT_COMP, ROT_A_CURRENT_COMP, target_index, target_x, target_y, target_z, focus_aw, focus_ah, focus_xw, focus_xh, focus_r, NAME_CURRENT_COMP);

// Input sanitation for this geometry
if (xwidth <= 0) {
  printf("\nERROR in Union_box named %s, the xwidth is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (yheight <= 0) {
  printf("\nERROR in Union_box named %s, yheight is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (zdepth <= 0) {
  printf("\nERROR in Union_box named %s, zdepth is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (xwidth2 <= 0 && xwidth2 != -1) {
  printf("\nERROR in Union_box named %s, the xwidth2 is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (yheight2 <= 0 && yheight2 != -1) {
  printf("\nERROR in Union_box named %s, yheight2 is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}

// Use sanitation
if (global_material_list.num_elements == 0) {
  printf("\nERROR: Need to define a material using Union_make_material before using a Union geometry component. \n");
  printf("       %s was defined before first use of Union_make_material.\n",NAME_CURRENT_COMP);
  exit(1);
}

this_box_volume.geometry.is_masked_volume = 0;
this_box_volume.geometry.is_exit_volume = 0;
this_box_volume.geometry.is_mask_volume = 0;
// check if the volume is a mask, if it is the material string is irelevant.
if (mask_string && strlen(mask_string) && strcmp(mask_string, "NULL") && strcmp(mask_string, "0")) {
    // A mask volume is used to limit the extend of other volumes, called the masked volumes. These are specified in the mask_string.
    // In order for a ray to enter a masked volume, it needs to be both in the region covered by that volume AND the mask volume.
    // When more than
    this_box_volume.geometry.mask_mode = 1; // Default is mask mode is ALL
    if (mask_setting && strlen(mask_setting) && strcmp(mask_setting, "NULL") && strcmp(mask_setting, "0")) {
        if (strcmp(mask_setting,"ALL") == 0 || strcmp(mask_setting,"All") == 0) this_box_volume.geometry.mask_mode = 1;
        else if (strcmp(mask_setting,"ANY") == 0 || strcmp(mask_setting,"Any") == 0) this_box_volume.geometry.mask_mode = 2;
        else {
            printf("The mask_mode of component %s is set to %s, but must be either ALL or ANY.\n",NAME_CURRENT_COMP,mask_setting);
            exit(1);
        }
    }
    
    for (loop_index=0;loop_index<global_geometry_list.num_elements;loop_index++) {
        // Add mask list
        if (1 == manual_linking_function(global_geometry_list.elements[loop_index].name,mask_string)) {
            add_element_to_int_list(&this_box_volume.geometry.mask_list,global_geometry_list.elements[loop_index].component_index);
            add_element_to_int_list(&global_geometry_list.elements[loop_index].Volume->geometry.masked_by_list,INDEX_CURRENT_COMP);
            global_geometry_list.elements[loop_index].Volume->geometry.is_masked_volume = 1;
            if (this_box_volume.geometry.mask_mode == 2)
                global_geometry_list.elements[loop_index].Volume->geometry.mask_mode = 2;
            if (this_box_volume.geometry.mask_mode == 1) {
                if (global_geometry_list.elements[loop_index].Volume->geometry.is_masked_volume == 1 && global_geometry_list.elements[loop_index].Volume->geometry.mask_mode != 2)
                    // If more than one mask is added to one volume, the ANY mode overwrites the (default) ALL mode.
                    global_geometry_list.elements[loop_index].Volume->geometry.mask_mode = 1;
            }
            
            found_geometries = 1;
        }
    }
    if (found_geometries == 0) {
        printf("The mask_string in geometry: %s did not find any of the specified volumes in the mask_string %s \n",NAME_CURRENT_COMP,mask_string);
        exit(1);
    }
    this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
    this_box_volume.p_physics->is_vacuum = 0; // Makes this volume a vacuum
    this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
    this_box_volume.p_physics->my_a = 0; // Should not be used.
    sprintf(this_box_volume.p_physics->name,"Mask");
    this_box_volume.geometry.is_mask_volume = 1;
    
    
// Read the material input, or if it lacks, use automatic linking.
} else if (material_string && strlen(material_string) && strcmp(material_string, "NULL") && strcmp(material_string, "0")) {
    // A geometry string was given, use it to determine which material
    if (0 == strcmp(material_string,"vacuum") || 0 == strcmp(material_string,"Vacuum")) {
        // One could have a global physics struct for vacuum instead of creating one for each
        this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
        this_box_volume.p_physics->is_vacuum = 1; // Makes this volume a vacuum
        this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
        this_box_volume.p_physics->my_a = 0; // Should not be used.
        sprintf(this_box_volume.p_physics->name,"Vacuum");
    } else if (0 == strcmp(material_string,"exit") || 0 == strcmp(material_string,"Exit")) {
        // One could have a global physics struct for vacuum instead of creating one for each
        this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
        this_box_volume.p_physics->is_vacuum = 1; // Makes this volume a vacuum
        this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
        this_box_volume.p_physics->my_a = 0; // Should not be used.
        this_box_volume.geometry.is_exit_volume = 1;
        sprintf(this_box_volume.p_physics->name,"Exit");
    } else {
        #ifndef MATERIAL_DETECTOR
            printf("Need to define a material before refering to it in a geometry %s.\n",NAME_CURRENT_COMP);
            exit(1);
        #endif
        for (loop_index=0;loop_index<global_material_list.num_elements;loop_index++) {
            if (0 == strcmp(material_string,global_material_list.elements[loop_index].name)) {
                this_box_volume.p_physics = global_material_list.elements[loop_index].physics;
                break;
            }
            if (loop_index == global_material_list.num_elements-1) {
            printf("\n");
            printf("ERROR: The material string \"%s\" in Union geometry \"%s\" did not match a specified material. \n",material_string,NAME_CURRENT_COMP);
            printf("       The materials available at this point (need to be defined before the geometry): \n");
            for (loop_index=0;loop_index<global_material_list.num_elements;loop_index++)
              printf("         %s\n",global_material_list.elements[loop_index].name);
            printf("\n");
            printf("       It is also possible to use one of the defualt materials avaiable: \n");
            printf("           Vacuum (for a Volume without scattering or absorption)\n");
            printf("           Exit (for a Volume where the ray exits the component if it enters)\n");
            printf("           Mask (for a Volume that masks existing volumes specified in the mask_string\n");
            exit(1);
          }
        }
    }
} else {
    // Automatic linking, simply using the last defined material.
    #ifndef MATERIAL_DETECTOR
        printf("Need to define a material before the geometry to use automatic linking %s.\n",NAME_CURRENT_COMP);
        exit(1);
    #endif
    this_box_volume.p_physics = global_material_list.elements[global_material_list.num_elements-1].physics;
}

sprintf(this_box_volume.name,NAME_CURRENT_COMP);
sprintf(this_box_volume.geometry.shape,"box");
this_box_volume.geometry.priority_value = priority;
this_box_volume.geometry.geometry_p_interact = p_interact;
// Currently the coordinates will be in absolute space.
this_box_volume.geometry.center = POS_A_CURRENT_COMP;

this_box_storage.z_depth = zdepth;
this_box_storage.x_width1 = xwidth;
this_box_storage.y_height1 = yheight;

this_box_storage.is_rectangle = 0;
if (xwidth2 < 0 && yheight2 < 0) this_box_storage.is_rectangle = 1;
if (xwidth == xwidth2 && yheight == yheight2) this_box_storage.is_rectangle = 1;

if (xwidth2 < 0) {
    this_box_storage.x_width2 = xwidth;
    xwidth2 = xwidth;
} else this_box_storage.x_width2 = xwidth2;

if (yheight2 < 0) {
    this_box_storage.y_height2 = yheight;
    yheight2 = yheight;
} else this_box_storage.y_height2 = yheight2;


this_box_storage.normal_vectors[0] = coords_set(0,0,1);
this_box_storage.normal_vectors[1] = coords_set(0,0,1);

// for sides with y component = 0
x_component = 2*zdepth/sqrt((xwidth-xwidth2)*(xwidth-xwidth2)+4*zdepth*zdepth);
z_component = (xwidth-xwidth2)/sqrt(4*zdepth*zdepth+(xwidth-xwidth2)*(xwidth-xwidth2));

this_box_storage.normal_vectors[2] = coords_set(x_component,0,z_component);
this_box_storage.normal_vectors[3] = coords_set(-x_component,0,z_component);

// for sides with x component = 0
y_component = 2*zdepth/sqrt((yheight-yheight2)*(yheight-yheight2)+4*zdepth*zdepth);
z_component = (yheight-yheight2)/sqrt(4*zdepth*zdepth+(yheight-yheight2)*(yheight-yheight2));

this_box_storage.normal_vectors[4] = coords_set(0,y_component,z_component);
this_box_storage.normal_vectors[5] = coords_set(0,-y_component,z_component);

this_box_volume.geometry.visualization_on = visualize;

this_box_volume.geometry.geometry_parameters.p_box_storage = &this_box_storage;

// Assign pointers to functions for intersection with the shape, checking if a point is inside the shape
if (this_box_storage.is_rectangle == 1) {
this_box_volume.geometry.intersect_function = &sample_box_intersect_simple;
this_box_volume.geometry.within_function = &r_within_box_simple;
}
else {
this_box_volume.geometry.intersect_function = &sample_box_intersect_advanced;
this_box_volume.geometry.within_function = &r_within_box_advanced;
}

this_box_volume.geometry.shell_points = &box_shell_points;
this_box_volume.geometry.mcdisplay_function = &mcdisplay_box_function;
this_box_volume.geometry.initialize_from_main_function = &initialize_box_geometry_from_main_component;
this_box_volume.geometry.process_rot_allocated = 0;

this_box_volume.geometry.copy_geometry_parameters = &allocate_box_storage_copy;

rot_copy(this_box_volume.geometry.rotation_matrix,ROT_A_CURRENT_COMP); //check how ROT_R_CURRENT_COMP would work
rot_transpose(ROT_A_CURRENT_COMP,this_box_volume.geometry.transpose_rotation_matrix);

// Initialize loggers
this_box_volume.loggers.num_elements = 0;

// packing the information into the global_geometry_element, which is then included in the global_geometry_list.
sprintf(global_geometry_element.name,NAME_CURRENT_COMP);
global_geometry_element.activation_counter = number_of_activations;
global_geometry_element.component_index = INDEX_CURRENT_COMP;
global_geometry_element.Volume = &this_box_volume; // Would be nicer if this m was a pointer, now we have the (small) data two places
add_element_to_geometry_list(&global_geometry_list,global_geometry_element);
}
#line 240587 "MACS_sample_kidney_box.c"
#undef number_of_activations
#undef mask_setting
#undef mask_string
#undef p_interact
#undef focus_r
#undef focus_xh
#undef focus_xw
#undef focus_ah
#undef focus_aw
#undef target_z
#undef target_y
#undef target_x
#undef target_index
#undef visualize
#undef yheight2
#undef xwidth2
#undef zdepth
#undef yheight
#undef xwidth
#undef priority
#undef material_string
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

  /* Initializations for component channel_8_analyzer_2_array_crystal_array_8. */
  SIG_MESSAGE("channel_8_analyzer_2_array_crystal_array_8 (Init)");
#define mccompcurname  channel_8_analyzer_2_array_crystal_array_8
#define mccompcurtype  Union_box
#define mccompcurindex 453
#define loop_index mccchannel_8_analyzer_2_array_crystal_array_8_loop_index
#define this_box_volume mccchannel_8_analyzer_2_array_crystal_array_8_this_box_volume
#define global_geometry_element mccchannel_8_analyzer_2_array_crystal_array_8_global_geometry_element
#define this_box_storage mccchannel_8_analyzer_2_array_crystal_array_8_this_box_storage
#define material_string mccchannel_8_analyzer_2_array_crystal_array_8_material_string
#define priority mccchannel_8_analyzer_2_array_crystal_array_8_priority
#define xwidth mccchannel_8_analyzer_2_array_crystal_array_8_xwidth
#define yheight mccchannel_8_analyzer_2_array_crystal_array_8_yheight
#define zdepth mccchannel_8_analyzer_2_array_crystal_array_8_zdepth
#define xwidth2 mccchannel_8_analyzer_2_array_crystal_array_8_xwidth2
#define yheight2 mccchannel_8_analyzer_2_array_crystal_array_8_yheight2
#define visualize mccchannel_8_analyzer_2_array_crystal_array_8_visualize
#define target_index mccchannel_8_analyzer_2_array_crystal_array_8_target_index
#define target_x mccchannel_8_analyzer_2_array_crystal_array_8_target_x
#define target_y mccchannel_8_analyzer_2_array_crystal_array_8_target_y
#define target_z mccchannel_8_analyzer_2_array_crystal_array_8_target_z
#define focus_aw mccchannel_8_analyzer_2_array_crystal_array_8_focus_aw
#define focus_ah mccchannel_8_analyzer_2_array_crystal_array_8_focus_ah
#define focus_xw mccchannel_8_analyzer_2_array_crystal_array_8_focus_xw
#define focus_xh mccchannel_8_analyzer_2_array_crystal_array_8_focus_xh
#define focus_r mccchannel_8_analyzer_2_array_crystal_array_8_focus_r
#define p_interact mccchannel_8_analyzer_2_array_crystal_array_8_p_interact
#define mask_string mccchannel_8_analyzer_2_array_crystal_array_8_mask_string
#define mask_setting mccchannel_8_analyzer_2_array_crystal_array_8_mask_setting
#define number_of_activations mccchannel_8_analyzer_2_array_crystal_array_8_number_of_activations
#line 224 "Union_box.comp"
{
// Initializes the focusing system for this volume including input sanitation.
focus_initialize(&this_box_volume.geometry, POS_A_COMP_INDEX(INDEX_CURRENT_COMP+target_index), POS_A_CURRENT_COMP, ROT_A_CURRENT_COMP, target_index, target_x, target_y, target_z, focus_aw, focus_ah, focus_xw, focus_xh, focus_r, NAME_CURRENT_COMP);

// Input sanitation for this geometry
if (xwidth <= 0) {
  printf("\nERROR in Union_box named %s, the xwidth is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (yheight <= 0) {
  printf("\nERROR in Union_box named %s, yheight is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (zdepth <= 0) {
  printf("\nERROR in Union_box named %s, zdepth is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (xwidth2 <= 0 && xwidth2 != -1) {
  printf("\nERROR in Union_box named %s, the xwidth2 is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (yheight2 <= 0 && yheight2 != -1) {
  printf("\nERROR in Union_box named %s, yheight2 is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}

// Use sanitation
if (global_material_list.num_elements == 0) {
  printf("\nERROR: Need to define a material using Union_make_material before using a Union geometry component. \n");
  printf("       %s was defined before first use of Union_make_material.\n",NAME_CURRENT_COMP);
  exit(1);
}

this_box_volume.geometry.is_masked_volume = 0;
this_box_volume.geometry.is_exit_volume = 0;
this_box_volume.geometry.is_mask_volume = 0;
// check if the volume is a mask, if it is the material string is irelevant.
if (mask_string && strlen(mask_string) && strcmp(mask_string, "NULL") && strcmp(mask_string, "0")) {
    // A mask volume is used to limit the extend of other volumes, called the masked volumes. These are specified in the mask_string.
    // In order for a ray to enter a masked volume, it needs to be both in the region covered by that volume AND the mask volume.
    // When more than
    this_box_volume.geometry.mask_mode = 1; // Default is mask mode is ALL
    if (mask_setting && strlen(mask_setting) && strcmp(mask_setting, "NULL") && strcmp(mask_setting, "0")) {
        if (strcmp(mask_setting,"ALL") == 0 || strcmp(mask_setting,"All") == 0) this_box_volume.geometry.mask_mode = 1;
        else if (strcmp(mask_setting,"ANY") == 0 || strcmp(mask_setting,"Any") == 0) this_box_volume.geometry.mask_mode = 2;
        else {
            printf("The mask_mode of component %s is set to %s, but must be either ALL or ANY.\n",NAME_CURRENT_COMP,mask_setting);
            exit(1);
        }
    }
    
    for (loop_index=0;loop_index<global_geometry_list.num_elements;loop_index++) {
        // Add mask list
        if (1 == manual_linking_function(global_geometry_list.elements[loop_index].name,mask_string)) {
            add_element_to_int_list(&this_box_volume.geometry.mask_list,global_geometry_list.elements[loop_index].component_index);
            add_element_to_int_list(&global_geometry_list.elements[loop_index].Volume->geometry.masked_by_list,INDEX_CURRENT_COMP);
            global_geometry_list.elements[loop_index].Volume->geometry.is_masked_volume = 1;
            if (this_box_volume.geometry.mask_mode == 2)
                global_geometry_list.elements[loop_index].Volume->geometry.mask_mode = 2;
            if (this_box_volume.geometry.mask_mode == 1) {
                if (global_geometry_list.elements[loop_index].Volume->geometry.is_masked_volume == 1 && global_geometry_list.elements[loop_index].Volume->geometry.mask_mode != 2)
                    // If more than one mask is added to one volume, the ANY mode overwrites the (default) ALL mode.
                    global_geometry_list.elements[loop_index].Volume->geometry.mask_mode = 1;
            }
            
            found_geometries = 1;
        }
    }
    if (found_geometries == 0) {
        printf("The mask_string in geometry: %s did not find any of the specified volumes in the mask_string %s \n",NAME_CURRENT_COMP,mask_string);
        exit(1);
    }
    this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
    this_box_volume.p_physics->is_vacuum = 0; // Makes this volume a vacuum
    this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
    this_box_volume.p_physics->my_a = 0; // Should not be used.
    sprintf(this_box_volume.p_physics->name,"Mask");
    this_box_volume.geometry.is_mask_volume = 1;
    
    
// Read the material input, or if it lacks, use automatic linking.
} else if (material_string && strlen(material_string) && strcmp(material_string, "NULL") && strcmp(material_string, "0")) {
    // A geometry string was given, use it to determine which material
    if (0 == strcmp(material_string,"vacuum") || 0 == strcmp(material_string,"Vacuum")) {
        // One could have a global physics struct for vacuum instead of creating one for each
        this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
        this_box_volume.p_physics->is_vacuum = 1; // Makes this volume a vacuum
        this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
        this_box_volume.p_physics->my_a = 0; // Should not be used.
        sprintf(this_box_volume.p_physics->name,"Vacuum");
    } else if (0 == strcmp(material_string,"exit") || 0 == strcmp(material_string,"Exit")) {
        // One could have a global physics struct for vacuum instead of creating one for each
        this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
        this_box_volume.p_physics->is_vacuum = 1; // Makes this volume a vacuum
        this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
        this_box_volume.p_physics->my_a = 0; // Should not be used.
        this_box_volume.geometry.is_exit_volume = 1;
        sprintf(this_box_volume.p_physics->name,"Exit");
    } else {
        #ifndef MATERIAL_DETECTOR
            printf("Need to define a material before refering to it in a geometry %s.\n",NAME_CURRENT_COMP);
            exit(1);
        #endif
        for (loop_index=0;loop_index<global_material_list.num_elements;loop_index++) {
            if (0 == strcmp(material_string,global_material_list.elements[loop_index].name)) {
                this_box_volume.p_physics = global_material_list.elements[loop_index].physics;
                break;
            }
            if (loop_index == global_material_list.num_elements-1) {
            printf("\n");
            printf("ERROR: The material string \"%s\" in Union geometry \"%s\" did not match a specified material. \n",material_string,NAME_CURRENT_COMP);
            printf("       The materials available at this point (need to be defined before the geometry): \n");
            for (loop_index=0;loop_index<global_material_list.num_elements;loop_index++)
              printf("         %s\n",global_material_list.elements[loop_index].name);
            printf("\n");
            printf("       It is also possible to use one of the defualt materials avaiable: \n");
            printf("           Vacuum (for a Volume without scattering or absorption)\n");
            printf("           Exit (for a Volume where the ray exits the component if it enters)\n");
            printf("           Mask (for a Volume that masks existing volumes specified in the mask_string\n");
            exit(1);
          }
        }
    }
} else {
    // Automatic linking, simply using the last defined material.
    #ifndef MATERIAL_DETECTOR
        printf("Need to define a material before the geometry to use automatic linking %s.\n",NAME_CURRENT_COMP);
        exit(1);
    #endif
    this_box_volume.p_physics = global_material_list.elements[global_material_list.num_elements-1].physics;
}

sprintf(this_box_volume.name,NAME_CURRENT_COMP);
sprintf(this_box_volume.geometry.shape,"box");
this_box_volume.geometry.priority_value = priority;
this_box_volume.geometry.geometry_p_interact = p_interact;
// Currently the coordinates will be in absolute space.
this_box_volume.geometry.center = POS_A_CURRENT_COMP;

this_box_storage.z_depth = zdepth;
this_box_storage.x_width1 = xwidth;
this_box_storage.y_height1 = yheight;

this_box_storage.is_rectangle = 0;
if (xwidth2 < 0 && yheight2 < 0) this_box_storage.is_rectangle = 1;
if (xwidth == xwidth2 && yheight == yheight2) this_box_storage.is_rectangle = 1;

if (xwidth2 < 0) {
    this_box_storage.x_width2 = xwidth;
    xwidth2 = xwidth;
} else this_box_storage.x_width2 = xwidth2;

if (yheight2 < 0) {
    this_box_storage.y_height2 = yheight;
    yheight2 = yheight;
} else this_box_storage.y_height2 = yheight2;


this_box_storage.normal_vectors[0] = coords_set(0,0,1);
this_box_storage.normal_vectors[1] = coords_set(0,0,1);

// for sides with y component = 0
x_component = 2*zdepth/sqrt((xwidth-xwidth2)*(xwidth-xwidth2)+4*zdepth*zdepth);
z_component = (xwidth-xwidth2)/sqrt(4*zdepth*zdepth+(xwidth-xwidth2)*(xwidth-xwidth2));

this_box_storage.normal_vectors[2] = coords_set(x_component,0,z_component);
this_box_storage.normal_vectors[3] = coords_set(-x_component,0,z_component);

// for sides with x component = 0
y_component = 2*zdepth/sqrt((yheight-yheight2)*(yheight-yheight2)+4*zdepth*zdepth);
z_component = (yheight-yheight2)/sqrt(4*zdepth*zdepth+(yheight-yheight2)*(yheight-yheight2));

this_box_storage.normal_vectors[4] = coords_set(0,y_component,z_component);
this_box_storage.normal_vectors[5] = coords_set(0,-y_component,z_component);

this_box_volume.geometry.visualization_on = visualize;

this_box_volume.geometry.geometry_parameters.p_box_storage = &this_box_storage;

// Assign pointers to functions for intersection with the shape, checking if a point is inside the shape
if (this_box_storage.is_rectangle == 1) {
this_box_volume.geometry.intersect_function = &sample_box_intersect_simple;
this_box_volume.geometry.within_function = &r_within_box_simple;
}
else {
this_box_volume.geometry.intersect_function = &sample_box_intersect_advanced;
this_box_volume.geometry.within_function = &r_within_box_advanced;
}

this_box_volume.geometry.shell_points = &box_shell_points;
this_box_volume.geometry.mcdisplay_function = &mcdisplay_box_function;
this_box_volume.geometry.initialize_from_main_function = &initialize_box_geometry_from_main_component;
this_box_volume.geometry.process_rot_allocated = 0;

this_box_volume.geometry.copy_geometry_parameters = &allocate_box_storage_copy;

rot_copy(this_box_volume.geometry.rotation_matrix,ROT_A_CURRENT_COMP); //check how ROT_R_CURRENT_COMP would work
rot_transpose(ROT_A_CURRENT_COMP,this_box_volume.geometry.transpose_rotation_matrix);

// Initialize loggers
this_box_volume.loggers.num_elements = 0;

// packing the information into the global_geometry_element, which is then included in the global_geometry_list.
sprintf(global_geometry_element.name,NAME_CURRENT_COMP);
global_geometry_element.activation_counter = number_of_activations;
global_geometry_element.component_index = INDEX_CURRENT_COMP;
global_geometry_element.Volume = &this_box_volume; // Would be nicer if this m was a pointer, now we have the (small) data two places
add_element_to_geometry_list(&global_geometry_list,global_geometry_element);
}
#line 240857 "MACS_sample_kidney_box.c"
#undef number_of_activations
#undef mask_setting
#undef mask_string
#undef p_interact
#undef focus_r
#undef focus_xh
#undef focus_xw
#undef focus_ah
#undef focus_aw
#undef target_z
#undef target_y
#undef target_x
#undef target_index
#undef visualize
#undef yheight2
#undef xwidth2
#undef zdepth
#undef yheight
#undef xwidth
#undef priority
#undef material_string
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

  /* Initializations for component channel_8_cave2_cyl1. */
  SIG_MESSAGE("channel_8_cave2_cyl1 (Init)");
#define mccompcurname  channel_8_cave2_cyl1
#define mccompcurtype  Union_cylinder
#define mccompcurindex 454
#define loop_index mccchannel_8_cave2_cyl1_loop_index
#define this_cylinder_volume mccchannel_8_cave2_cyl1_this_cylinder_volume
#define global_geometry_element mccchannel_8_cave2_cyl1_global_geometry_element
#define this_cylinder_storage mccchannel_8_cave2_cyl1_this_cylinder_storage
#define material_string mccchannel_8_cave2_cyl1_material_string
#define priority mccchannel_8_cave2_cyl1_priority
#define radius mccchannel_8_cave2_cyl1_radius
#define yheight mccchannel_8_cave2_cyl1_yheight
#define visualize mccchannel_8_cave2_cyl1_visualize
#define target_index mccchannel_8_cave2_cyl1_target_index
#define target_x mccchannel_8_cave2_cyl1_target_x
#define target_y mccchannel_8_cave2_cyl1_target_y
#define target_z mccchannel_8_cave2_cyl1_target_z
#define focus_aw mccchannel_8_cave2_cyl1_focus_aw
#define focus_ah mccchannel_8_cave2_cyl1_focus_ah
#define focus_xw mccchannel_8_cave2_cyl1_focus_xw
#define focus_xh mccchannel_8_cave2_cyl1_focus_xh
#define focus_r mccchannel_8_cave2_cyl1_focus_r
#define p_interact mccchannel_8_cave2_cyl1_p_interact
#define mask_string mccchannel_8_cave2_cyl1_mask_string
#define mask_setting mccchannel_8_cave2_cyl1_mask_setting
#define number_of_activations mccchannel_8_cave2_cyl1_number_of_activations
#line 185 "Union_cylinder.comp"
{
// Initializes the focusing system for this volume including input sanitation.
focus_initialize(&this_cylinder_volume.geometry, POS_A_COMP_INDEX(INDEX_CURRENT_COMP+target_index), POS_A_CURRENT_COMP, ROT_A_CURRENT_COMP, target_index, target_x, target_y, target_z, focus_aw, focus_ah, focus_xw, focus_xh, focus_r, NAME_CURRENT_COMP);

// Input sanitation for this geometry
if (radius <= 0) {
  printf("\nERROR in Union_cylinder named %s, the radius is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}

if (yheight <= 0) {
  printf("\nERROR in Union_cylinder named %s, yheight is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}

// Use sanitation
#ifdef MATERIAL_DETECTOR
if (global_material_list.num_elements == 0) {
  // Here if the user have defined a material, but only after this material
  printf("\nERROR: Need to define a material using Union_make_material before using a Union geometry component. \n");
  printf("       %s was defined before first use of Union_make_material.\n",NAME_CURRENT_COMP);
  exit(1);
}
#endif
#ifndef MATERIAL_DETECTOR
  printf("\nERROR: Need to define a material using Union_make_material before using a Union geometry component. \n");
  exit(1);
#endif


this_cylinder_volume.geometry.is_masked_volume = 0;
this_cylinder_volume.geometry.is_exit_volume = 0;
this_cylinder_volume.geometry.is_mask_volume = 0;

// Read the material input, or if it lacks, use automatic linking.
if (mask_string && strlen(mask_string) && strcmp(mask_string, "NULL") && strcmp(mask_string, "0")) {
    // A mask volume is used to limit the extend of other volumes, called the masked volumes. These are specified in the mask_string.
    // In order for a ray to enter a masked volume, it needs to be both in the region covered by that volume AND the mask volume.
    // When more than
    this_cylinder_volume.geometry.mask_mode = 1; // Default is mask mode is ALL
    if (mask_setting && strlen(mask_setting) && strcmp(mask_setting, "NULL") && strcmp(mask_setting, "0")) {
        if (strcmp(mask_setting,"ALL") == 0 || strcmp(mask_setting,"All") == 0) this_cylinder_volume.geometry.mask_mode = 1;
        else if (strcmp(mask_setting,"ANY") == 0 || strcmp(mask_setting,"Any") == 0) this_cylinder_volume.geometry.mask_mode = 2;
        else {
            printf("The mask_mode of component %s is set to %s, but must be either ALL or ANY.\n",NAME_CURRENT_COMP,mask_setting);
            exit(1);
        }
    }
    
    for (loop_index=0;loop_index<global_geometry_list.num_elements;loop_index++) {
        // Add mask list
        if (1 == manual_linking_function(global_geometry_list.elements[loop_index].name,mask_string)) {
            add_element_to_int_list(&this_cylinder_volume.geometry.mask_list,global_geometry_list.elements[loop_index].component_index);
            add_element_to_int_list(&global_geometry_list.elements[loop_index].Volume->geometry.masked_by_list,INDEX_CURRENT_COMP);
            global_geometry_list.elements[loop_index].Volume->geometry.is_masked_volume = 1;
            if (this_cylinder_volume.geometry.mask_mode == 2)
                global_geometry_list.elements[loop_index].Volume->geometry.mask_mode = 2;
            if (this_cylinder_volume.geometry.mask_mode == 1) {
                if (global_geometry_list.elements[loop_index].Volume->geometry.is_masked_volume == 1 && global_geometry_list.elements[loop_index].Volume->geometry.mask_mode != 2)
                    // If more than one mask is added to one volume, the ANY mode overwrites the (default) ALL mode.
                    global_geometry_list.elements[loop_index].Volume->geometry.mask_mode = 1;
            }
            
            found_geometries = 1;
        }
    }
    if (found_geometries == 0) {
        printf("The mask_string in geometry: %s did not find any of the specified volumes in the mask_string %s \n",NAME_CURRENT_COMP,mask_string);
        exit(1);
    }
    this_cylinder_volume.p_physics = malloc(sizeof(struct physics_struct));
    this_cylinder_volume.p_physics->is_vacuum = 0; // Makes this volume a vacuum
    this_cylinder_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
    this_cylinder_volume.p_physics->my_a = 0; // Should not be used.
    sprintf(this_cylinder_volume.p_physics->name,"Mask");
    this_cylinder_volume.geometry.is_mask_volume = 1;
    
    
// Read the material input, or if it lacks, use automatic linking.
} else if (material_string && strlen(material_string) && strcmp(material_string, "NULL") && strcmp(material_string, "0")) {
    // A geometry string was given, use it to determine which material
    if (0 == strcmp(material_string,"vacuum") || 0 == strcmp(material_string,"Vacuum")) {
        // One could have a global physics struct for vacuum instead of creating one for each
        this_cylinder_volume.p_physics = malloc(sizeof(struct physics_struct));
        this_cylinder_volume.p_physics->is_vacuum = 1; // Makes this volume a vacuum
        this_cylinder_volume.p_physics->number_of_processes = (int) 0;
        this_cylinder_volume.p_physics->my_a = 0; // Should not be used.
        sprintf(this_cylinder_volume.p_physics->name,"Vacuum");
    } else if (0 == strcmp(material_string,"exit") || 0 == strcmp(material_string,"Exit")) {
        // One could have a global physics struct for exit instead of creating one for each
        this_cylinder_volume.p_physics = malloc(sizeof(struct physics_struct));
        this_cylinder_volume.p_physics->is_vacuum = 1; // Makes this volume a vacuum
        this_cylinder_volume.p_physics->number_of_processes = (int) 0;
        this_cylinder_volume.p_physics->my_a = 0; // Should not be used.
        this_cylinder_volume.geometry.is_exit_volume = 1;
        sprintf(this_cylinder_volume.p_physics->name,"Exit");
    } else {
        for (loop_index=0;loop_index<global_material_list.num_elements;loop_index++) {
          if (0 == strcmp(material_string,global_material_list.elements[loop_index].name)) {
            this_cylinder_volume.p_physics = global_material_list.elements[loop_index].physics;
            break;
          }
          if (loop_index == global_material_list.num_elements-1) {
            printf("\n");
            printf("ERROR: The material string \"%s\" in Union geometry \"%s\" did not match a specified material. \n",material_string,NAME_CURRENT_COMP);
            printf("       The materials available at this point (need to be defined before the geometry): \n");
            for (loop_index=0;loop_index<global_material_list.num_elements;loop_index++)
              printf("         %s\n",global_material_list.elements[loop_index].name);
            printf("\n");
            printf("       It is also possible to use one of the defualt materials avaiable: \n");
            printf("           Vacuum (for a Volume without scattering or absorption)\n");
            printf("           Exit (for a Volume where the ray exits the component if it enters)\n");
            printf("           Mask (for a Volume that masks existing volumes specified in the mask_string\n");
            exit(1);
          }
        }
    }
} else {
    // Automatic linking, simply using the last defined material.
    #ifndef MATERIAL_DETECTOR
        printf("Need to define a material before the geometry to use automatic linking %s.\n",NAME_CURRENT_COMP);
        exit(1);
    #endif
    this_cylinder_volume.p_physics = global_material_list.elements[global_material_list.num_elements-1].physics;
}

sprintf(this_cylinder_volume.name,NAME_CURRENT_COMP);
sprintf(this_cylinder_volume.geometry.shape,"cylinder");
this_cylinder_volume.geometry.priority_value = priority;
// Currently the coordinates will be in absolute space.
this_cylinder_volume.geometry.center = POS_A_CURRENT_COMP;

this_cylinder_volume.geometry.geometry_p_interact = p_interact;
this_cylinder_storage.cyl_radius = radius;
this_cylinder_storage.height = yheight;
this_cylinder_volume.geometry.visualization_on = visualize;
this_cylinder_volume.geometry.geometry_parameters.p_cylinder_storage = &this_cylinder_storage;
this_cylinder_volume.geometry.within_function = &r_within_cylinder;
this_cylinder_volume.geometry.intersect_function = &sample_cylinder_intersect;
this_cylinder_volume.geometry.mcdisplay_function = &mcdisplay_cylinder_function;
this_cylinder_volume.geometry.shell_points = &cylinder_shell_points;
this_cylinder_volume.geometry.initialize_from_main_function = &initialize_cylinder_geometry_from_main_component;
this_cylinder_volume.geometry.process_rot_allocated = 0;
this_cylinder_volume.geometry.copy_geometry_parameters = &allocate_cylinder_storage_copy;

rot_copy(this_cylinder_volume.geometry.rotation_matrix,ROT_A_CURRENT_COMP);
rot_transpose(ROT_A_CURRENT_COMP,this_cylinder_volume.geometry.transpose_rotation_matrix);

// Initialize loggers
this_cylinder_volume.loggers.num_elements = 0;

// packing the information into the global_geometry_element, which is then included in the global_geometry_list.
sprintf(global_geometry_element.name,NAME_CURRENT_COMP);
global_geometry_element.activation_counter = number_of_activations;
global_geometry_element.component_index = INDEX_CURRENT_COMP;
global_geometry_element.Volume = &this_cylinder_volume; // Would be nicer if this m was a pointer, now we have the (small) data two places
add_element_to_geometry_list(&global_geometry_list,global_geometry_element);
}
#line 241073 "MACS_sample_kidney_box.c"
#undef number_of_activations
#undef mask_setting
#undef mask_string
#undef p_interact
#undef focus_r
#undef focus_xh
#undef focus_xw
#undef focus_ah
#undef focus_aw
#undef target_z
#undef target_y
#undef target_x
#undef target_index
#undef visualize
#undef yheight
#undef radius
#undef priority
#undef material_string
#undef this_cylinder_storage
#undef global_geometry_element
#undef this_cylinder_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

  /* Initializations for component channel_8_cave2_box1. */
  SIG_MESSAGE("channel_8_cave2_box1 (Init)");
#define mccompcurname  channel_8_cave2_box1
#define mccompcurtype  Union_box
#define mccompcurindex 455
#define loop_index mccchannel_8_cave2_box1_loop_index
#define this_box_volume mccchannel_8_cave2_box1_this_box_volume
#define global_geometry_element mccchannel_8_cave2_box1_global_geometry_element
#define this_box_storage mccchannel_8_cave2_box1_this_box_storage
#define material_string mccchannel_8_cave2_box1_material_string
#define priority mccchannel_8_cave2_box1_priority
#define xwidth mccchannel_8_cave2_box1_xwidth
#define yheight mccchannel_8_cave2_box1_yheight
#define zdepth mccchannel_8_cave2_box1_zdepth
#define xwidth2 mccchannel_8_cave2_box1_xwidth2
#define yheight2 mccchannel_8_cave2_box1_yheight2
#define visualize mccchannel_8_cave2_box1_visualize
#define target_index mccchannel_8_cave2_box1_target_index
#define target_x mccchannel_8_cave2_box1_target_x
#define target_y mccchannel_8_cave2_box1_target_y
#define target_z mccchannel_8_cave2_box1_target_z
#define focus_aw mccchannel_8_cave2_box1_focus_aw
#define focus_ah mccchannel_8_cave2_box1_focus_ah
#define focus_xw mccchannel_8_cave2_box1_focus_xw
#define focus_xh mccchannel_8_cave2_box1_focus_xh
#define focus_r mccchannel_8_cave2_box1_focus_r
#define p_interact mccchannel_8_cave2_box1_p_interact
#define mask_string mccchannel_8_cave2_box1_mask_string
#define mask_setting mccchannel_8_cave2_box1_mask_setting
#define number_of_activations mccchannel_8_cave2_box1_number_of_activations
#line 224 "Union_box.comp"
{
// Initializes the focusing system for this volume including input sanitation.
focus_initialize(&this_box_volume.geometry, POS_A_COMP_INDEX(INDEX_CURRENT_COMP+target_index), POS_A_CURRENT_COMP, ROT_A_CURRENT_COMP, target_index, target_x, target_y, target_z, focus_aw, focus_ah, focus_xw, focus_xh, focus_r, NAME_CURRENT_COMP);

// Input sanitation for this geometry
if (xwidth <= 0) {
  printf("\nERROR in Union_box named %s, the xwidth is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (yheight <= 0) {
  printf("\nERROR in Union_box named %s, yheight is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (zdepth <= 0) {
  printf("\nERROR in Union_box named %s, zdepth is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (xwidth2 <= 0 && xwidth2 != -1) {
  printf("\nERROR in Union_box named %s, the xwidth2 is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (yheight2 <= 0 && yheight2 != -1) {
  printf("\nERROR in Union_box named %s, yheight2 is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}

// Use sanitation
if (global_material_list.num_elements == 0) {
  printf("\nERROR: Need to define a material using Union_make_material before using a Union geometry component. \n");
  printf("       %s was defined before first use of Union_make_material.\n",NAME_CURRENT_COMP);
  exit(1);
}

this_box_volume.geometry.is_masked_volume = 0;
this_box_volume.geometry.is_exit_volume = 0;
this_box_volume.geometry.is_mask_volume = 0;
// check if the volume is a mask, if it is the material string is irelevant.
if (mask_string && strlen(mask_string) && strcmp(mask_string, "NULL") && strcmp(mask_string, "0")) {
    // A mask volume is used to limit the extend of other volumes, called the masked volumes. These are specified in the mask_string.
    // In order for a ray to enter a masked volume, it needs to be both in the region covered by that volume AND the mask volume.
    // When more than
    this_box_volume.geometry.mask_mode = 1; // Default is mask mode is ALL
    if (mask_setting && strlen(mask_setting) && strcmp(mask_setting, "NULL") && strcmp(mask_setting, "0")) {
        if (strcmp(mask_setting,"ALL") == 0 || strcmp(mask_setting,"All") == 0) this_box_volume.geometry.mask_mode = 1;
        else if (strcmp(mask_setting,"ANY") == 0 || strcmp(mask_setting,"Any") == 0) this_box_volume.geometry.mask_mode = 2;
        else {
            printf("The mask_mode of component %s is set to %s, but must be either ALL or ANY.\n",NAME_CURRENT_COMP,mask_setting);
            exit(1);
        }
    }
    
    for (loop_index=0;loop_index<global_geometry_list.num_elements;loop_index++) {
        // Add mask list
        if (1 == manual_linking_function(global_geometry_list.elements[loop_index].name,mask_string)) {
            add_element_to_int_list(&this_box_volume.geometry.mask_list,global_geometry_list.elements[loop_index].component_index);
            add_element_to_int_list(&global_geometry_list.elements[loop_index].Volume->geometry.masked_by_list,INDEX_CURRENT_COMP);
            global_geometry_list.elements[loop_index].Volume->geometry.is_masked_volume = 1;
            if (this_box_volume.geometry.mask_mode == 2)
                global_geometry_list.elements[loop_index].Volume->geometry.mask_mode = 2;
            if (this_box_volume.geometry.mask_mode == 1) {
                if (global_geometry_list.elements[loop_index].Volume->geometry.is_masked_volume == 1 && global_geometry_list.elements[loop_index].Volume->geometry.mask_mode != 2)
                    // If more than one mask is added to one volume, the ANY mode overwrites the (default) ALL mode.
                    global_geometry_list.elements[loop_index].Volume->geometry.mask_mode = 1;
            }
            
            found_geometries = 1;
        }
    }
    if (found_geometries == 0) {
        printf("The mask_string in geometry: %s did not find any of the specified volumes in the mask_string %s \n",NAME_CURRENT_COMP,mask_string);
        exit(1);
    }
    this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
    this_box_volume.p_physics->is_vacuum = 0; // Makes this volume a vacuum
    this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
    this_box_volume.p_physics->my_a = 0; // Should not be used.
    sprintf(this_box_volume.p_physics->name,"Mask");
    this_box_volume.geometry.is_mask_volume = 1;
    
    
// Read the material input, or if it lacks, use automatic linking.
} else if (material_string && strlen(material_string) && strcmp(material_string, "NULL") && strcmp(material_string, "0")) {
    // A geometry string was given, use it to determine which material
    if (0 == strcmp(material_string,"vacuum") || 0 == strcmp(material_string,"Vacuum")) {
        // One could have a global physics struct for vacuum instead of creating one for each
        this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
        this_box_volume.p_physics->is_vacuum = 1; // Makes this volume a vacuum
        this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
        this_box_volume.p_physics->my_a = 0; // Should not be used.
        sprintf(this_box_volume.p_physics->name,"Vacuum");
    } else if (0 == strcmp(material_string,"exit") || 0 == strcmp(material_string,"Exit")) {
        // One could have a global physics struct for vacuum instead of creating one for each
        this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
        this_box_volume.p_physics->is_vacuum = 1; // Makes this volume a vacuum
        this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
        this_box_volume.p_physics->my_a = 0; // Should not be used.
        this_box_volume.geometry.is_exit_volume = 1;
        sprintf(this_box_volume.p_physics->name,"Exit");
    } else {
        #ifndef MATERIAL_DETECTOR
            printf("Need to define a material before refering to it in a geometry %s.\n",NAME_CURRENT_COMP);
            exit(1);
        #endif
        for (loop_index=0;loop_index<global_material_list.num_elements;loop_index++) {
            if (0 == strcmp(material_string,global_material_list.elements[loop_index].name)) {
                this_box_volume.p_physics = global_material_list.elements[loop_index].physics;
                break;
            }
            if (loop_index == global_material_list.num_elements-1) {
            printf("\n");
            printf("ERROR: The material string \"%s\" in Union geometry \"%s\" did not match a specified material. \n",material_string,NAME_CURRENT_COMP);
            printf("       The materials available at this point (need to be defined before the geometry): \n");
            for (loop_index=0;loop_index<global_material_list.num_elements;loop_index++)
              printf("         %s\n",global_material_list.elements[loop_index].name);
            printf("\n");
            printf("       It is also possible to use one of the defualt materials avaiable: \n");
            printf("           Vacuum (for a Volume without scattering or absorption)\n");
            printf("           Exit (for a Volume where the ray exits the component if it enters)\n");
            printf("           Mask (for a Volume that masks existing volumes specified in the mask_string\n");
            exit(1);
          }
        }
    }
} else {
    // Automatic linking, simply using the last defined material.
    #ifndef MATERIAL_DETECTOR
        printf("Need to define a material before the geometry to use automatic linking %s.\n",NAME_CURRENT_COMP);
        exit(1);
    #endif
    this_box_volume.p_physics = global_material_list.elements[global_material_list.num_elements-1].physics;
}

sprintf(this_box_volume.name,NAME_CURRENT_COMP);
sprintf(this_box_volume.geometry.shape,"box");
this_box_volume.geometry.priority_value = priority;
this_box_volume.geometry.geometry_p_interact = p_interact;
// Currently the coordinates will be in absolute space.
this_box_volume.geometry.center = POS_A_CURRENT_COMP;

this_box_storage.z_depth = zdepth;
this_box_storage.x_width1 = xwidth;
this_box_storage.y_height1 = yheight;

this_box_storage.is_rectangle = 0;
if (xwidth2 < 0 && yheight2 < 0) this_box_storage.is_rectangle = 1;
if (xwidth == xwidth2 && yheight == yheight2) this_box_storage.is_rectangle = 1;

if (xwidth2 < 0) {
    this_box_storage.x_width2 = xwidth;
    xwidth2 = xwidth;
} else this_box_storage.x_width2 = xwidth2;

if (yheight2 < 0) {
    this_box_storage.y_height2 = yheight;
    yheight2 = yheight;
} else this_box_storage.y_height2 = yheight2;


this_box_storage.normal_vectors[0] = coords_set(0,0,1);
this_box_storage.normal_vectors[1] = coords_set(0,0,1);

// for sides with y component = 0
x_component = 2*zdepth/sqrt((xwidth-xwidth2)*(xwidth-xwidth2)+4*zdepth*zdepth);
z_component = (xwidth-xwidth2)/sqrt(4*zdepth*zdepth+(xwidth-xwidth2)*(xwidth-xwidth2));

this_box_storage.normal_vectors[2] = coords_set(x_component,0,z_component);
this_box_storage.normal_vectors[3] = coords_set(-x_component,0,z_component);

// for sides with x component = 0
y_component = 2*zdepth/sqrt((yheight-yheight2)*(yheight-yheight2)+4*zdepth*zdepth);
z_component = (yheight-yheight2)/sqrt(4*zdepth*zdepth+(yheight-yheight2)*(yheight-yheight2));

this_box_storage.normal_vectors[4] = coords_set(0,y_component,z_component);
this_box_storage.normal_vectors[5] = coords_set(0,-y_component,z_component);

this_box_volume.geometry.visualization_on = visualize;

this_box_volume.geometry.geometry_parameters.p_box_storage = &this_box_storage;

// Assign pointers to functions for intersection with the shape, checking if a point is inside the shape
if (this_box_storage.is_rectangle == 1) {
this_box_volume.geometry.intersect_function = &sample_box_intersect_simple;
this_box_volume.geometry.within_function = &r_within_box_simple;
}
else {
this_box_volume.geometry.intersect_function = &sample_box_intersect_advanced;
this_box_volume.geometry.within_function = &r_within_box_advanced;
}

this_box_volume.geometry.shell_points = &box_shell_points;
this_box_volume.geometry.mcdisplay_function = &mcdisplay_box_function;
this_box_volume.geometry.initialize_from_main_function = &initialize_box_geometry_from_main_component;
this_box_volume.geometry.process_rot_allocated = 0;

this_box_volume.geometry.copy_geometry_parameters = &allocate_box_storage_copy;

rot_copy(this_box_volume.geometry.rotation_matrix,ROT_A_CURRENT_COMP); //check how ROT_R_CURRENT_COMP would work
rot_transpose(ROT_A_CURRENT_COMP,this_box_volume.geometry.transpose_rotation_matrix);

// Initialize loggers
this_box_volume.loggers.num_elements = 0;

// packing the information into the global_geometry_element, which is then included in the global_geometry_list.
sprintf(global_geometry_element.name,NAME_CURRENT_COMP);
global_geometry_element.activation_counter = number_of_activations;
global_geometry_element.component_index = INDEX_CURRENT_COMP;
global_geometry_element.Volume = &this_box_volume; // Would be nicer if this m was a pointer, now we have the (small) data two places
add_element_to_geometry_list(&global_geometry_list,global_geometry_element);
}
#line 241340 "MACS_sample_kidney_box.c"
#undef number_of_activations
#undef mask_setting
#undef mask_string
#undef p_interact
#undef focus_r
#undef focus_xh
#undef focus_xw
#undef focus_ah
#undef focus_aw
#undef target_z
#undef target_y
#undef target_x
#undef target_index
#undef visualize
#undef yheight2
#undef xwidth2
#undef zdepth
#undef yheight
#undef xwidth
#undef priority
#undef material_string
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

  /* Initializations for component channel_8_cave2_box2. */
  SIG_MESSAGE("channel_8_cave2_box2 (Init)");
#define mccompcurname  channel_8_cave2_box2
#define mccompcurtype  Union_box
#define mccompcurindex 456
#define loop_index mccchannel_8_cave2_box2_loop_index
#define this_box_volume mccchannel_8_cave2_box2_this_box_volume
#define global_geometry_element mccchannel_8_cave2_box2_global_geometry_element
#define this_box_storage mccchannel_8_cave2_box2_this_box_storage
#define material_string mccchannel_8_cave2_box2_material_string
#define priority mccchannel_8_cave2_box2_priority
#define xwidth mccchannel_8_cave2_box2_xwidth
#define yheight mccchannel_8_cave2_box2_yheight
#define zdepth mccchannel_8_cave2_box2_zdepth
#define xwidth2 mccchannel_8_cave2_box2_xwidth2
#define yheight2 mccchannel_8_cave2_box2_yheight2
#define visualize mccchannel_8_cave2_box2_visualize
#define target_index mccchannel_8_cave2_box2_target_index
#define target_x mccchannel_8_cave2_box2_target_x
#define target_y mccchannel_8_cave2_box2_target_y
#define target_z mccchannel_8_cave2_box2_target_z
#define focus_aw mccchannel_8_cave2_box2_focus_aw
#define focus_ah mccchannel_8_cave2_box2_focus_ah
#define focus_xw mccchannel_8_cave2_box2_focus_xw
#define focus_xh mccchannel_8_cave2_box2_focus_xh
#define focus_r mccchannel_8_cave2_box2_focus_r
#define p_interact mccchannel_8_cave2_box2_p_interact
#define mask_string mccchannel_8_cave2_box2_mask_string
#define mask_setting mccchannel_8_cave2_box2_mask_setting
#define number_of_activations mccchannel_8_cave2_box2_number_of_activations
#line 224 "Union_box.comp"
{
// Initializes the focusing system for this volume including input sanitation.
focus_initialize(&this_box_volume.geometry, POS_A_COMP_INDEX(INDEX_CURRENT_COMP+target_index), POS_A_CURRENT_COMP, ROT_A_CURRENT_COMP, target_index, target_x, target_y, target_z, focus_aw, focus_ah, focus_xw, focus_xh, focus_r, NAME_CURRENT_COMP);

// Input sanitation for this geometry
if (xwidth <= 0) {
  printf("\nERROR in Union_box named %s, the xwidth is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (yheight <= 0) {
  printf("\nERROR in Union_box named %s, yheight is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (zdepth <= 0) {
  printf("\nERROR in Union_box named %s, zdepth is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (xwidth2 <= 0 && xwidth2 != -1) {
  printf("\nERROR in Union_box named %s, the xwidth2 is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (yheight2 <= 0 && yheight2 != -1) {
  printf("\nERROR in Union_box named %s, yheight2 is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}

// Use sanitation
if (global_material_list.num_elements == 0) {
  printf("\nERROR: Need to define a material using Union_make_material before using a Union geometry component. \n");
  printf("       %s was defined before first use of Union_make_material.\n",NAME_CURRENT_COMP);
  exit(1);
}

this_box_volume.geometry.is_masked_volume = 0;
this_box_volume.geometry.is_exit_volume = 0;
this_box_volume.geometry.is_mask_volume = 0;
// check if the volume is a mask, if it is the material string is irelevant.
if (mask_string && strlen(mask_string) && strcmp(mask_string, "NULL") && strcmp(mask_string, "0")) {
    // A mask volume is used to limit the extend of other volumes, called the masked volumes. These are specified in the mask_string.
    // In order for a ray to enter a masked volume, it needs to be both in the region covered by that volume AND the mask volume.
    // When more than
    this_box_volume.geometry.mask_mode = 1; // Default is mask mode is ALL
    if (mask_setting && strlen(mask_setting) && strcmp(mask_setting, "NULL") && strcmp(mask_setting, "0")) {
        if (strcmp(mask_setting,"ALL") == 0 || strcmp(mask_setting,"All") == 0) this_box_volume.geometry.mask_mode = 1;
        else if (strcmp(mask_setting,"ANY") == 0 || strcmp(mask_setting,"Any") == 0) this_box_volume.geometry.mask_mode = 2;
        else {
            printf("The mask_mode of component %s is set to %s, but must be either ALL or ANY.\n",NAME_CURRENT_COMP,mask_setting);
            exit(1);
        }
    }
    
    for (loop_index=0;loop_index<global_geometry_list.num_elements;loop_index++) {
        // Add mask list
        if (1 == manual_linking_function(global_geometry_list.elements[loop_index].name,mask_string)) {
            add_element_to_int_list(&this_box_volume.geometry.mask_list,global_geometry_list.elements[loop_index].component_index);
            add_element_to_int_list(&global_geometry_list.elements[loop_index].Volume->geometry.masked_by_list,INDEX_CURRENT_COMP);
            global_geometry_list.elements[loop_index].Volume->geometry.is_masked_volume = 1;
            if (this_box_volume.geometry.mask_mode == 2)
                global_geometry_list.elements[loop_index].Volume->geometry.mask_mode = 2;
            if (this_box_volume.geometry.mask_mode == 1) {
                if (global_geometry_list.elements[loop_index].Volume->geometry.is_masked_volume == 1 && global_geometry_list.elements[loop_index].Volume->geometry.mask_mode != 2)
                    // If more than one mask is added to one volume, the ANY mode overwrites the (default) ALL mode.
                    global_geometry_list.elements[loop_index].Volume->geometry.mask_mode = 1;
            }
            
            found_geometries = 1;
        }
    }
    if (found_geometries == 0) {
        printf("The mask_string in geometry: %s did not find any of the specified volumes in the mask_string %s \n",NAME_CURRENT_COMP,mask_string);
        exit(1);
    }
    this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
    this_box_volume.p_physics->is_vacuum = 0; // Makes this volume a vacuum
    this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
    this_box_volume.p_physics->my_a = 0; // Should not be used.
    sprintf(this_box_volume.p_physics->name,"Mask");
    this_box_volume.geometry.is_mask_volume = 1;
    
    
// Read the material input, or if it lacks, use automatic linking.
} else if (material_string && strlen(material_string) && strcmp(material_string, "NULL") && strcmp(material_string, "0")) {
    // A geometry string was given, use it to determine which material
    if (0 == strcmp(material_string,"vacuum") || 0 == strcmp(material_string,"Vacuum")) {
        // One could have a global physics struct for vacuum instead of creating one for each
        this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
        this_box_volume.p_physics->is_vacuum = 1; // Makes this volume a vacuum
        this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
        this_box_volume.p_physics->my_a = 0; // Should not be used.
        sprintf(this_box_volume.p_physics->name,"Vacuum");
    } else if (0 == strcmp(material_string,"exit") || 0 == strcmp(material_string,"Exit")) {
        // One could have a global physics struct for vacuum instead of creating one for each
        this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
        this_box_volume.p_physics->is_vacuum = 1; // Makes this volume a vacuum
        this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
        this_box_volume.p_physics->my_a = 0; // Should not be used.
        this_box_volume.geometry.is_exit_volume = 1;
        sprintf(this_box_volume.p_physics->name,"Exit");
    } else {
        #ifndef MATERIAL_DETECTOR
            printf("Need to define a material before refering to it in a geometry %s.\n",NAME_CURRENT_COMP);
            exit(1);
        #endif
        for (loop_index=0;loop_index<global_material_list.num_elements;loop_index++) {
            if (0 == strcmp(material_string,global_material_list.elements[loop_index].name)) {
                this_box_volume.p_physics = global_material_list.elements[loop_index].physics;
                break;
            }
            if (loop_index == global_material_list.num_elements-1) {
            printf("\n");
            printf("ERROR: The material string \"%s\" in Union geometry \"%s\" did not match a specified material. \n",material_string,NAME_CURRENT_COMP);
            printf("       The materials available at this point (need to be defined before the geometry): \n");
            for (loop_index=0;loop_index<global_material_list.num_elements;loop_index++)
              printf("         %s\n",global_material_list.elements[loop_index].name);
            printf("\n");
            printf("       It is also possible to use one of the defualt materials avaiable: \n");
            printf("           Vacuum (for a Volume without scattering or absorption)\n");
            printf("           Exit (for a Volume where the ray exits the component if it enters)\n");
            printf("           Mask (for a Volume that masks existing volumes specified in the mask_string\n");
            exit(1);
          }
        }
    }
} else {
    // Automatic linking, simply using the last defined material.
    #ifndef MATERIAL_DETECTOR
        printf("Need to define a material before the geometry to use automatic linking %s.\n",NAME_CURRENT_COMP);
        exit(1);
    #endif
    this_box_volume.p_physics = global_material_list.elements[global_material_list.num_elements-1].physics;
}

sprintf(this_box_volume.name,NAME_CURRENT_COMP);
sprintf(this_box_volume.geometry.shape,"box");
this_box_volume.geometry.priority_value = priority;
this_box_volume.geometry.geometry_p_interact = p_interact;
// Currently the coordinates will be in absolute space.
this_box_volume.geometry.center = POS_A_CURRENT_COMP;

this_box_storage.z_depth = zdepth;
this_box_storage.x_width1 = xwidth;
this_box_storage.y_height1 = yheight;

this_box_storage.is_rectangle = 0;
if (xwidth2 < 0 && yheight2 < 0) this_box_storage.is_rectangle = 1;
if (xwidth == xwidth2 && yheight == yheight2) this_box_storage.is_rectangle = 1;

if (xwidth2 < 0) {
    this_box_storage.x_width2 = xwidth;
    xwidth2 = xwidth;
} else this_box_storage.x_width2 = xwidth2;

if (yheight2 < 0) {
    this_box_storage.y_height2 = yheight;
    yheight2 = yheight;
} else this_box_storage.y_height2 = yheight2;


this_box_storage.normal_vectors[0] = coords_set(0,0,1);
this_box_storage.normal_vectors[1] = coords_set(0,0,1);

// for sides with y component = 0
x_component = 2*zdepth/sqrt((xwidth-xwidth2)*(xwidth-xwidth2)+4*zdepth*zdepth);
z_component = (xwidth-xwidth2)/sqrt(4*zdepth*zdepth+(xwidth-xwidth2)*(xwidth-xwidth2));

this_box_storage.normal_vectors[2] = coords_set(x_component,0,z_component);
this_box_storage.normal_vectors[3] = coords_set(-x_component,0,z_component);

// for sides with x component = 0
y_component = 2*zdepth/sqrt((yheight-yheight2)*(yheight-yheight2)+4*zdepth*zdepth);
z_component = (yheight-yheight2)/sqrt(4*zdepth*zdepth+(yheight-yheight2)*(yheight-yheight2));

this_box_storage.normal_vectors[4] = coords_set(0,y_component,z_component);
this_box_storage.normal_vectors[5] = coords_set(0,-y_component,z_component);

this_box_volume.geometry.visualization_on = visualize;

this_box_volume.geometry.geometry_parameters.p_box_storage = &this_box_storage;

// Assign pointers to functions for intersection with the shape, checking if a point is inside the shape
if (this_box_storage.is_rectangle == 1) {
this_box_volume.geometry.intersect_function = &sample_box_intersect_simple;
this_box_volume.geometry.within_function = &r_within_box_simple;
}
else {
this_box_volume.geometry.intersect_function = &sample_box_intersect_advanced;
this_box_volume.geometry.within_function = &r_within_box_advanced;
}

this_box_volume.geometry.shell_points = &box_shell_points;
this_box_volume.geometry.mcdisplay_function = &mcdisplay_box_function;
this_box_volume.geometry.initialize_from_main_function = &initialize_box_geometry_from_main_component;
this_box_volume.geometry.process_rot_allocated = 0;

this_box_volume.geometry.copy_geometry_parameters = &allocate_box_storage_copy;

rot_copy(this_box_volume.geometry.rotation_matrix,ROT_A_CURRENT_COMP); //check how ROT_R_CURRENT_COMP would work
rot_transpose(ROT_A_CURRENT_COMP,this_box_volume.geometry.transpose_rotation_matrix);

// Initialize loggers
this_box_volume.loggers.num_elements = 0;

// packing the information into the global_geometry_element, which is then included in the global_geometry_list.
sprintf(global_geometry_element.name,NAME_CURRENT_COMP);
global_geometry_element.activation_counter = number_of_activations;
global_geometry_element.component_index = INDEX_CURRENT_COMP;
global_geometry_element.Volume = &this_box_volume; // Would be nicer if this m was a pointer, now we have the (small) data two places
add_element_to_geometry_list(&global_geometry_list,global_geometry_element);
}
#line 241610 "MACS_sample_kidney_box.c"
#undef number_of_activations
#undef mask_setting
#undef mask_string
#undef p_interact
#undef focus_r
#undef focus_xh
#undef focus_xw
#undef focus_ah
#undef focus_aw
#undef target_z
#undef target_y
#undef target_x
#undef target_index
#undef visualize
#undef yheight2
#undef xwidth2
#undef zdepth
#undef yheight
#undef xwidth
#undef priority
#undef material_string
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

  /* Initializations for component channel_8_cave2_box3. */
  SIG_MESSAGE("channel_8_cave2_box3 (Init)");
#define mccompcurname  channel_8_cave2_box3
#define mccompcurtype  Union_box
#define mccompcurindex 457
#define loop_index mccchannel_8_cave2_box3_loop_index
#define this_box_volume mccchannel_8_cave2_box3_this_box_volume
#define global_geometry_element mccchannel_8_cave2_box3_global_geometry_element
#define this_box_storage mccchannel_8_cave2_box3_this_box_storage
#define material_string mccchannel_8_cave2_box3_material_string
#define priority mccchannel_8_cave2_box3_priority
#define xwidth mccchannel_8_cave2_box3_xwidth
#define yheight mccchannel_8_cave2_box3_yheight
#define zdepth mccchannel_8_cave2_box3_zdepth
#define xwidth2 mccchannel_8_cave2_box3_xwidth2
#define yheight2 mccchannel_8_cave2_box3_yheight2
#define visualize mccchannel_8_cave2_box3_visualize
#define target_index mccchannel_8_cave2_box3_target_index
#define target_x mccchannel_8_cave2_box3_target_x
#define target_y mccchannel_8_cave2_box3_target_y
#define target_z mccchannel_8_cave2_box3_target_z
#define focus_aw mccchannel_8_cave2_box3_focus_aw
#define focus_ah mccchannel_8_cave2_box3_focus_ah
#define focus_xw mccchannel_8_cave2_box3_focus_xw
#define focus_xh mccchannel_8_cave2_box3_focus_xh
#define focus_r mccchannel_8_cave2_box3_focus_r
#define p_interact mccchannel_8_cave2_box3_p_interact
#define mask_string mccchannel_8_cave2_box3_mask_string
#define mask_setting mccchannel_8_cave2_box3_mask_setting
#define number_of_activations mccchannel_8_cave2_box3_number_of_activations
#line 224 "Union_box.comp"
{
// Initializes the focusing system for this volume including input sanitation.
focus_initialize(&this_box_volume.geometry, POS_A_COMP_INDEX(INDEX_CURRENT_COMP+target_index), POS_A_CURRENT_COMP, ROT_A_CURRENT_COMP, target_index, target_x, target_y, target_z, focus_aw, focus_ah, focus_xw, focus_xh, focus_r, NAME_CURRENT_COMP);

// Input sanitation for this geometry
if (xwidth <= 0) {
  printf("\nERROR in Union_box named %s, the xwidth is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (yheight <= 0) {
  printf("\nERROR in Union_box named %s, yheight is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (zdepth <= 0) {
  printf("\nERROR in Union_box named %s, zdepth is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (xwidth2 <= 0 && xwidth2 != -1) {
  printf("\nERROR in Union_box named %s, the xwidth2 is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (yheight2 <= 0 && yheight2 != -1) {
  printf("\nERROR in Union_box named %s, yheight2 is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}

// Use sanitation
if (global_material_list.num_elements == 0) {
  printf("\nERROR: Need to define a material using Union_make_material before using a Union geometry component. \n");
  printf("       %s was defined before first use of Union_make_material.\n",NAME_CURRENT_COMP);
  exit(1);
}

this_box_volume.geometry.is_masked_volume = 0;
this_box_volume.geometry.is_exit_volume = 0;
this_box_volume.geometry.is_mask_volume = 0;
// check if the volume is a mask, if it is the material string is irelevant.
if (mask_string && strlen(mask_string) && strcmp(mask_string, "NULL") && strcmp(mask_string, "0")) {
    // A mask volume is used to limit the extend of other volumes, called the masked volumes. These are specified in the mask_string.
    // In order for a ray to enter a masked volume, it needs to be both in the region covered by that volume AND the mask volume.
    // When more than
    this_box_volume.geometry.mask_mode = 1; // Default is mask mode is ALL
    if (mask_setting && strlen(mask_setting) && strcmp(mask_setting, "NULL") && strcmp(mask_setting, "0")) {
        if (strcmp(mask_setting,"ALL") == 0 || strcmp(mask_setting,"All") == 0) this_box_volume.geometry.mask_mode = 1;
        else if (strcmp(mask_setting,"ANY") == 0 || strcmp(mask_setting,"Any") == 0) this_box_volume.geometry.mask_mode = 2;
        else {
            printf("The mask_mode of component %s is set to %s, but must be either ALL or ANY.\n",NAME_CURRENT_COMP,mask_setting);
            exit(1);
        }
    }
    
    for (loop_index=0;loop_index<global_geometry_list.num_elements;loop_index++) {
        // Add mask list
        if (1 == manual_linking_function(global_geometry_list.elements[loop_index].name,mask_string)) {
            add_element_to_int_list(&this_box_volume.geometry.mask_list,global_geometry_list.elements[loop_index].component_index);
            add_element_to_int_list(&global_geometry_list.elements[loop_index].Volume->geometry.masked_by_list,INDEX_CURRENT_COMP);
            global_geometry_list.elements[loop_index].Volume->geometry.is_masked_volume = 1;
            if (this_box_volume.geometry.mask_mode == 2)
                global_geometry_list.elements[loop_index].Volume->geometry.mask_mode = 2;
            if (this_box_volume.geometry.mask_mode == 1) {
                if (global_geometry_list.elements[loop_index].Volume->geometry.is_masked_volume == 1 && global_geometry_list.elements[loop_index].Volume->geometry.mask_mode != 2)
                    // If more than one mask is added to one volume, the ANY mode overwrites the (default) ALL mode.
                    global_geometry_list.elements[loop_index].Volume->geometry.mask_mode = 1;
            }
            
            found_geometries = 1;
        }
    }
    if (found_geometries == 0) {
        printf("The mask_string in geometry: %s did not find any of the specified volumes in the mask_string %s \n",NAME_CURRENT_COMP,mask_string);
        exit(1);
    }
    this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
    this_box_volume.p_physics->is_vacuum = 0; // Makes this volume a vacuum
    this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
    this_box_volume.p_physics->my_a = 0; // Should not be used.
    sprintf(this_box_volume.p_physics->name,"Mask");
    this_box_volume.geometry.is_mask_volume = 1;
    
    
// Read the material input, or if it lacks, use automatic linking.
} else if (material_string && strlen(material_string) && strcmp(material_string, "NULL") && strcmp(material_string, "0")) {
    // A geometry string was given, use it to determine which material
    if (0 == strcmp(material_string,"vacuum") || 0 == strcmp(material_string,"Vacuum")) {
        // One could have a global physics struct for vacuum instead of creating one for each
        this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
        this_box_volume.p_physics->is_vacuum = 1; // Makes this volume a vacuum
        this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
        this_box_volume.p_physics->my_a = 0; // Should not be used.
        sprintf(this_box_volume.p_physics->name,"Vacuum");
    } else if (0 == strcmp(material_string,"exit") || 0 == strcmp(material_string,"Exit")) {
        // One could have a global physics struct for vacuum instead of creating one for each
        this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
        this_box_volume.p_physics->is_vacuum = 1; // Makes this volume a vacuum
        this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
        this_box_volume.p_physics->my_a = 0; // Should not be used.
        this_box_volume.geometry.is_exit_volume = 1;
        sprintf(this_box_volume.p_physics->name,"Exit");
    } else {
        #ifndef MATERIAL_DETECTOR
            printf("Need to define a material before refering to it in a geometry %s.\n",NAME_CURRENT_COMP);
            exit(1);
        #endif
        for (loop_index=0;loop_index<global_material_list.num_elements;loop_index++) {
            if (0 == strcmp(material_string,global_material_list.elements[loop_index].name)) {
                this_box_volume.p_physics = global_material_list.elements[loop_index].physics;
                break;
            }
            if (loop_index == global_material_list.num_elements-1) {
            printf("\n");
            printf("ERROR: The material string \"%s\" in Union geometry \"%s\" did not match a specified material. \n",material_string,NAME_CURRENT_COMP);
            printf("       The materials available at this point (need to be defined before the geometry): \n");
            for (loop_index=0;loop_index<global_material_list.num_elements;loop_index++)
              printf("         %s\n",global_material_list.elements[loop_index].name);
            printf("\n");
            printf("       It is also possible to use one of the defualt materials avaiable: \n");
            printf("           Vacuum (for a Volume without scattering or absorption)\n");
            printf("           Exit (for a Volume where the ray exits the component if it enters)\n");
            printf("           Mask (for a Volume that masks existing volumes specified in the mask_string\n");
            exit(1);
          }
        }
    }
} else {
    // Automatic linking, simply using the last defined material.
    #ifndef MATERIAL_DETECTOR
        printf("Need to define a material before the geometry to use automatic linking %s.\n",NAME_CURRENT_COMP);
        exit(1);
    #endif
    this_box_volume.p_physics = global_material_list.elements[global_material_list.num_elements-1].physics;
}

sprintf(this_box_volume.name,NAME_CURRENT_COMP);
sprintf(this_box_volume.geometry.shape,"box");
this_box_volume.geometry.priority_value = priority;
this_box_volume.geometry.geometry_p_interact = p_interact;
// Currently the coordinates will be in absolute space.
this_box_volume.geometry.center = POS_A_CURRENT_COMP;

this_box_storage.z_depth = zdepth;
this_box_storage.x_width1 = xwidth;
this_box_storage.y_height1 = yheight;

this_box_storage.is_rectangle = 0;
if (xwidth2 < 0 && yheight2 < 0) this_box_storage.is_rectangle = 1;
if (xwidth == xwidth2 && yheight == yheight2) this_box_storage.is_rectangle = 1;

if (xwidth2 < 0) {
    this_box_storage.x_width2 = xwidth;
    xwidth2 = xwidth;
} else this_box_storage.x_width2 = xwidth2;

if (yheight2 < 0) {
    this_box_storage.y_height2 = yheight;
    yheight2 = yheight;
} else this_box_storage.y_height2 = yheight2;


this_box_storage.normal_vectors[0] = coords_set(0,0,1);
this_box_storage.normal_vectors[1] = coords_set(0,0,1);

// for sides with y component = 0
x_component = 2*zdepth/sqrt((xwidth-xwidth2)*(xwidth-xwidth2)+4*zdepth*zdepth);
z_component = (xwidth-xwidth2)/sqrt(4*zdepth*zdepth+(xwidth-xwidth2)*(xwidth-xwidth2));

this_box_storage.normal_vectors[2] = coords_set(x_component,0,z_component);
this_box_storage.normal_vectors[3] = coords_set(-x_component,0,z_component);

// for sides with x component = 0
y_component = 2*zdepth/sqrt((yheight-yheight2)*(yheight-yheight2)+4*zdepth*zdepth);
z_component = (yheight-yheight2)/sqrt(4*zdepth*zdepth+(yheight-yheight2)*(yheight-yheight2));

this_box_storage.normal_vectors[4] = coords_set(0,y_component,z_component);
this_box_storage.normal_vectors[5] = coords_set(0,-y_component,z_component);

this_box_volume.geometry.visualization_on = visualize;

this_box_volume.geometry.geometry_parameters.p_box_storage = &this_box_storage;

// Assign pointers to functions for intersection with the shape, checking if a point is inside the shape
if (this_box_storage.is_rectangle == 1) {
this_box_volume.geometry.intersect_function = &sample_box_intersect_simple;
this_box_volume.geometry.within_function = &r_within_box_simple;
}
else {
this_box_volume.geometry.intersect_function = &sample_box_intersect_advanced;
this_box_volume.geometry.within_function = &r_within_box_advanced;
}

this_box_volume.geometry.shell_points = &box_shell_points;
this_box_volume.geometry.mcdisplay_function = &mcdisplay_box_function;
this_box_volume.geometry.initialize_from_main_function = &initialize_box_geometry_from_main_component;
this_box_volume.geometry.process_rot_allocated = 0;

this_box_volume.geometry.copy_geometry_parameters = &allocate_box_storage_copy;

rot_copy(this_box_volume.geometry.rotation_matrix,ROT_A_CURRENT_COMP); //check how ROT_R_CURRENT_COMP would work
rot_transpose(ROT_A_CURRENT_COMP,this_box_volume.geometry.transpose_rotation_matrix);

// Initialize loggers
this_box_volume.loggers.num_elements = 0;

// packing the information into the global_geometry_element, which is then included in the global_geometry_list.
sprintf(global_geometry_element.name,NAME_CURRENT_COMP);
global_geometry_element.activation_counter = number_of_activations;
global_geometry_element.component_index = INDEX_CURRENT_COMP;
global_geometry_element.Volume = &this_box_volume; // Would be nicer if this m was a pointer, now we have the (small) data two places
add_element_to_geometry_list(&global_geometry_list,global_geometry_element);
}
#line 241880 "MACS_sample_kidney_box.c"
#undef number_of_activations
#undef mask_setting
#undef mask_string
#undef p_interact
#undef focus_r
#undef focus_xh
#undef focus_xw
#undef focus_ah
#undef focus_aw
#undef target_z
#undef target_y
#undef target_x
#undef target_index
#undef visualize
#undef yheight2
#undef xwidth2
#undef zdepth
#undef yheight
#undef xwidth
#undef priority
#undef material_string
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

  /* Initializations for component inter_analyzer_colimator_center_8. */
  SIG_MESSAGE("inter_analyzer_colimator_center_8 (Init)");

  /* Initializations for component inter_analyzer_colimator_8_blade_0. */
  SIG_MESSAGE("inter_analyzer_colimator_8_blade_0 (Init)");
#define mccompcurname  inter_analyzer_colimator_8_blade_0
#define mccompcurtype  Union_box
#define mccompcurindex 459
#define loop_index mccinter_analyzer_colimator_8_blade_0_loop_index
#define this_box_volume mccinter_analyzer_colimator_8_blade_0_this_box_volume
#define global_geometry_element mccinter_analyzer_colimator_8_blade_0_global_geometry_element
#define this_box_storage mccinter_analyzer_colimator_8_blade_0_this_box_storage
#define material_string mccinter_analyzer_colimator_8_blade_0_material_string
#define priority mccinter_analyzer_colimator_8_blade_0_priority
#define xwidth mccinter_analyzer_colimator_8_blade_0_xwidth
#define yheight mccinter_analyzer_colimator_8_blade_0_yheight
#define zdepth mccinter_analyzer_colimator_8_blade_0_zdepth
#define xwidth2 mccinter_analyzer_colimator_8_blade_0_xwidth2
#define yheight2 mccinter_analyzer_colimator_8_blade_0_yheight2
#define visualize mccinter_analyzer_colimator_8_blade_0_visualize
#define target_index mccinter_analyzer_colimator_8_blade_0_target_index
#define target_x mccinter_analyzer_colimator_8_blade_0_target_x
#define target_y mccinter_analyzer_colimator_8_blade_0_target_y
#define target_z mccinter_analyzer_colimator_8_blade_0_target_z
#define focus_aw mccinter_analyzer_colimator_8_blade_0_focus_aw
#define focus_ah mccinter_analyzer_colimator_8_blade_0_focus_ah
#define focus_xw mccinter_analyzer_colimator_8_blade_0_focus_xw
#define focus_xh mccinter_analyzer_colimator_8_blade_0_focus_xh
#define focus_r mccinter_analyzer_colimator_8_blade_0_focus_r
#define p_interact mccinter_analyzer_colimator_8_blade_0_p_interact
#define mask_string mccinter_analyzer_colimator_8_blade_0_mask_string
#define mask_setting mccinter_analyzer_colimator_8_blade_0_mask_setting
#define number_of_activations mccinter_analyzer_colimator_8_blade_0_number_of_activations
#line 224 "Union_box.comp"
{
// Initializes the focusing system for this volume including input sanitation.
focus_initialize(&this_box_volume.geometry, POS_A_COMP_INDEX(INDEX_CURRENT_COMP+target_index), POS_A_CURRENT_COMP, ROT_A_CURRENT_COMP, target_index, target_x, target_y, target_z, focus_aw, focus_ah, focus_xw, focus_xh, focus_r, NAME_CURRENT_COMP);

// Input sanitation for this geometry
if (xwidth <= 0) {
  printf("\nERROR in Union_box named %s, the xwidth is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (yheight <= 0) {
  printf("\nERROR in Union_box named %s, yheight is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (zdepth <= 0) {
  printf("\nERROR in Union_box named %s, zdepth is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (xwidth2 <= 0 && xwidth2 != -1) {
  printf("\nERROR in Union_box named %s, the xwidth2 is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (yheight2 <= 0 && yheight2 != -1) {
  printf("\nERROR in Union_box named %s, yheight2 is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}

// Use sanitation
if (global_material_list.num_elements == 0) {
  printf("\nERROR: Need to define a material using Union_make_material before using a Union geometry component. \n");
  printf("       %s was defined before first use of Union_make_material.\n",NAME_CURRENT_COMP);
  exit(1);
}

this_box_volume.geometry.is_masked_volume = 0;
this_box_volume.geometry.is_exit_volume = 0;
this_box_volume.geometry.is_mask_volume = 0;
// check if the volume is a mask, if it is the material string is irelevant.
if (mask_string && strlen(mask_string) && strcmp(mask_string, "NULL") && strcmp(mask_string, "0")) {
    // A mask volume is used to limit the extend of other volumes, called the masked volumes. These are specified in the mask_string.
    // In order for a ray to enter a masked volume, it needs to be both in the region covered by that volume AND the mask volume.
    // When more than
    this_box_volume.geometry.mask_mode = 1; // Default is mask mode is ALL
    if (mask_setting && strlen(mask_setting) && strcmp(mask_setting, "NULL") && strcmp(mask_setting, "0")) {
        if (strcmp(mask_setting,"ALL") == 0 || strcmp(mask_setting,"All") == 0) this_box_volume.geometry.mask_mode = 1;
        else if (strcmp(mask_setting,"ANY") == 0 || strcmp(mask_setting,"Any") == 0) this_box_volume.geometry.mask_mode = 2;
        else {
            printf("The mask_mode of component %s is set to %s, but must be either ALL or ANY.\n",NAME_CURRENT_COMP,mask_setting);
            exit(1);
        }
    }
    
    for (loop_index=0;loop_index<global_geometry_list.num_elements;loop_index++) {
        // Add mask list
        if (1 == manual_linking_function(global_geometry_list.elements[loop_index].name,mask_string)) {
            add_element_to_int_list(&this_box_volume.geometry.mask_list,global_geometry_list.elements[loop_index].component_index);
            add_element_to_int_list(&global_geometry_list.elements[loop_index].Volume->geometry.masked_by_list,INDEX_CURRENT_COMP);
            global_geometry_list.elements[loop_index].Volume->geometry.is_masked_volume = 1;
            if (this_box_volume.geometry.mask_mode == 2)
                global_geometry_list.elements[loop_index].Volume->geometry.mask_mode = 2;
            if (this_box_volume.geometry.mask_mode == 1) {
                if (global_geometry_list.elements[loop_index].Volume->geometry.is_masked_volume == 1 && global_geometry_list.elements[loop_index].Volume->geometry.mask_mode != 2)
                    // If more than one mask is added to one volume, the ANY mode overwrites the (default) ALL mode.
                    global_geometry_list.elements[loop_index].Volume->geometry.mask_mode = 1;
            }
            
            found_geometries = 1;
        }
    }
    if (found_geometries == 0) {
        printf("The mask_string in geometry: %s did not find any of the specified volumes in the mask_string %s \n",NAME_CURRENT_COMP,mask_string);
        exit(1);
    }
    this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
    this_box_volume.p_physics->is_vacuum = 0; // Makes this volume a vacuum
    this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
    this_box_volume.p_physics->my_a = 0; // Should not be used.
    sprintf(this_box_volume.p_physics->name,"Mask");
    this_box_volume.geometry.is_mask_volume = 1;
    
    
// Read the material input, or if it lacks, use automatic linking.
} else if (material_string && strlen(material_string) && strcmp(material_string, "NULL") && strcmp(material_string, "0")) {
    // A geometry string was given, use it to determine which material
    if (0 == strcmp(material_string,"vacuum") || 0 == strcmp(material_string,"Vacuum")) {
        // One could have a global physics struct for vacuum instead of creating one for each
        this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
        this_box_volume.p_physics->is_vacuum = 1; // Makes this volume a vacuum
        this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
        this_box_volume.p_physics->my_a = 0; // Should not be used.
        sprintf(this_box_volume.p_physics->name,"Vacuum");
    } else if (0 == strcmp(material_string,"exit") || 0 == strcmp(material_string,"Exit")) {
        // One could have a global physics struct for vacuum instead of creating one for each
        this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
        this_box_volume.p_physics->is_vacuum = 1; // Makes this volume a vacuum
        this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
        this_box_volume.p_physics->my_a = 0; // Should not be used.
        this_box_volume.geometry.is_exit_volume = 1;
        sprintf(this_box_volume.p_physics->name,"Exit");
    } else {
        #ifndef MATERIAL_DETECTOR
            printf("Need to define a material before refering to it in a geometry %s.\n",NAME_CURRENT_COMP);
            exit(1);
        #endif
        for (loop_index=0;loop_index<global_material_list.num_elements;loop_index++) {
            if (0 == strcmp(material_string,global_material_list.elements[loop_index].name)) {
                this_box_volume.p_physics = global_material_list.elements[loop_index].physics;
                break;
            }
            if (loop_index == global_material_list.num_elements-1) {
            printf("\n");
            printf("ERROR: The material string \"%s\" in Union geometry \"%s\" did not match a specified material. \n",material_string,NAME_CURRENT_COMP);
            printf("       The materials available at this point (need to be defined before the geometry): \n");
            for (loop_index=0;loop_index<global_material_list.num_elements;loop_index++)
              printf("         %s\n",global_material_list.elements[loop_index].name);
            printf("\n");
            printf("       It is also possible to use one of the defualt materials avaiable: \n");
            printf("           Vacuum (for a Volume without scattering or absorption)\n");
            printf("           Exit (for a Volume where the ray exits the component if it enters)\n");
            printf("           Mask (for a Volume that masks existing volumes specified in the mask_string\n");
            exit(1);
          }
        }
    }
} else {
    // Automatic linking, simply using the last defined material.
    #ifndef MATERIAL_DETECTOR
        printf("Need to define a material before the geometry to use automatic linking %s.\n",NAME_CURRENT_COMP);
        exit(1);
    #endif
    this_box_volume.p_physics = global_material_list.elements[global_material_list.num_elements-1].physics;
}

sprintf(this_box_volume.name,NAME_CURRENT_COMP);
sprintf(this_box_volume.geometry.shape,"box");
this_box_volume.geometry.priority_value = priority;
this_box_volume.geometry.geometry_p_interact = p_interact;
// Currently the coordinates will be in absolute space.
this_box_volume.geometry.center = POS_A_CURRENT_COMP;

this_box_storage.z_depth = zdepth;
this_box_storage.x_width1 = xwidth;
this_box_storage.y_height1 = yheight;

this_box_storage.is_rectangle = 0;
if (xwidth2 < 0 && yheight2 < 0) this_box_storage.is_rectangle = 1;
if (xwidth == xwidth2 && yheight == yheight2) this_box_storage.is_rectangle = 1;

if (xwidth2 < 0) {
    this_box_storage.x_width2 = xwidth;
    xwidth2 = xwidth;
} else this_box_storage.x_width2 = xwidth2;

if (yheight2 < 0) {
    this_box_storage.y_height2 = yheight;
    yheight2 = yheight;
} else this_box_storage.y_height2 = yheight2;


this_box_storage.normal_vectors[0] = coords_set(0,0,1);
this_box_storage.normal_vectors[1] = coords_set(0,0,1);

// for sides with y component = 0
x_component = 2*zdepth/sqrt((xwidth-xwidth2)*(xwidth-xwidth2)+4*zdepth*zdepth);
z_component = (xwidth-xwidth2)/sqrt(4*zdepth*zdepth+(xwidth-xwidth2)*(xwidth-xwidth2));

this_box_storage.normal_vectors[2] = coords_set(x_component,0,z_component);
this_box_storage.normal_vectors[3] = coords_set(-x_component,0,z_component);

// for sides with x component = 0
y_component = 2*zdepth/sqrt((yheight-yheight2)*(yheight-yheight2)+4*zdepth*zdepth);
z_component = (yheight-yheight2)/sqrt(4*zdepth*zdepth+(yheight-yheight2)*(yheight-yheight2));

this_box_storage.normal_vectors[4] = coords_set(0,y_component,z_component);
this_box_storage.normal_vectors[5] = coords_set(0,-y_component,z_component);

this_box_volume.geometry.visualization_on = visualize;

this_box_volume.geometry.geometry_parameters.p_box_storage = &this_box_storage;

// Assign pointers to functions for intersection with the shape, checking if a point is inside the shape
if (this_box_storage.is_rectangle == 1) {
this_box_volume.geometry.intersect_function = &sample_box_intersect_simple;
this_box_volume.geometry.within_function = &r_within_box_simple;
}
else {
this_box_volume.geometry.intersect_function = &sample_box_intersect_advanced;
this_box_volume.geometry.within_function = &r_within_box_advanced;
}

this_box_volume.geometry.shell_points = &box_shell_points;
this_box_volume.geometry.mcdisplay_function = &mcdisplay_box_function;
this_box_volume.geometry.initialize_from_main_function = &initialize_box_geometry_from_main_component;
this_box_volume.geometry.process_rot_allocated = 0;

this_box_volume.geometry.copy_geometry_parameters = &allocate_box_storage_copy;

rot_copy(this_box_volume.geometry.rotation_matrix,ROT_A_CURRENT_COMP); //check how ROT_R_CURRENT_COMP would work
rot_transpose(ROT_A_CURRENT_COMP,this_box_volume.geometry.transpose_rotation_matrix);

// Initialize loggers
this_box_volume.loggers.num_elements = 0;

// packing the information into the global_geometry_element, which is then included in the global_geometry_list.
sprintf(global_geometry_element.name,NAME_CURRENT_COMP);
global_geometry_element.activation_counter = number_of_activations;
global_geometry_element.component_index = INDEX_CURRENT_COMP;
global_geometry_element.Volume = &this_box_volume; // Would be nicer if this m was a pointer, now we have the (small) data two places
add_element_to_geometry_list(&global_geometry_list,global_geometry_element);
}
#line 242153 "MACS_sample_kidney_box.c"
#undef number_of_activations
#undef mask_setting
#undef mask_string
#undef p_interact
#undef focus_r
#undef focus_xh
#undef focus_xw
#undef focus_ah
#undef focus_aw
#undef target_z
#undef target_y
#undef target_x
#undef target_index
#undef visualize
#undef yheight2
#undef xwidth2
#undef zdepth
#undef yheight
#undef xwidth
#undef priority
#undef material_string
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

  /* Initializations for component inter_analyzer_colimator_8_blade_1. */
  SIG_MESSAGE("inter_analyzer_colimator_8_blade_1 (Init)");
#define mccompcurname  inter_analyzer_colimator_8_blade_1
#define mccompcurtype  Union_box
#define mccompcurindex 460
#define loop_index mccinter_analyzer_colimator_8_blade_1_loop_index
#define this_box_volume mccinter_analyzer_colimator_8_blade_1_this_box_volume
#define global_geometry_element mccinter_analyzer_colimator_8_blade_1_global_geometry_element
#define this_box_storage mccinter_analyzer_colimator_8_blade_1_this_box_storage
#define material_string mccinter_analyzer_colimator_8_blade_1_material_string
#define priority mccinter_analyzer_colimator_8_blade_1_priority
#define xwidth mccinter_analyzer_colimator_8_blade_1_xwidth
#define yheight mccinter_analyzer_colimator_8_blade_1_yheight
#define zdepth mccinter_analyzer_colimator_8_blade_1_zdepth
#define xwidth2 mccinter_analyzer_colimator_8_blade_1_xwidth2
#define yheight2 mccinter_analyzer_colimator_8_blade_1_yheight2
#define visualize mccinter_analyzer_colimator_8_blade_1_visualize
#define target_index mccinter_analyzer_colimator_8_blade_1_target_index
#define target_x mccinter_analyzer_colimator_8_blade_1_target_x
#define target_y mccinter_analyzer_colimator_8_blade_1_target_y
#define target_z mccinter_analyzer_colimator_8_blade_1_target_z
#define focus_aw mccinter_analyzer_colimator_8_blade_1_focus_aw
#define focus_ah mccinter_analyzer_colimator_8_blade_1_focus_ah
#define focus_xw mccinter_analyzer_colimator_8_blade_1_focus_xw
#define focus_xh mccinter_analyzer_colimator_8_blade_1_focus_xh
#define focus_r mccinter_analyzer_colimator_8_blade_1_focus_r
#define p_interact mccinter_analyzer_colimator_8_blade_1_p_interact
#define mask_string mccinter_analyzer_colimator_8_blade_1_mask_string
#define mask_setting mccinter_analyzer_colimator_8_blade_1_mask_setting
#define number_of_activations mccinter_analyzer_colimator_8_blade_1_number_of_activations
#line 224 "Union_box.comp"
{
// Initializes the focusing system for this volume including input sanitation.
focus_initialize(&this_box_volume.geometry, POS_A_COMP_INDEX(INDEX_CURRENT_COMP+target_index), POS_A_CURRENT_COMP, ROT_A_CURRENT_COMP, target_index, target_x, target_y, target_z, focus_aw, focus_ah, focus_xw, focus_xh, focus_r, NAME_CURRENT_COMP);

// Input sanitation for this geometry
if (xwidth <= 0) {
  printf("\nERROR in Union_box named %s, the xwidth is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (yheight <= 0) {
  printf("\nERROR in Union_box named %s, yheight is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (zdepth <= 0) {
  printf("\nERROR in Union_box named %s, zdepth is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (xwidth2 <= 0 && xwidth2 != -1) {
  printf("\nERROR in Union_box named %s, the xwidth2 is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (yheight2 <= 0 && yheight2 != -1) {
  printf("\nERROR in Union_box named %s, yheight2 is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}

// Use sanitation
if (global_material_list.num_elements == 0) {
  printf("\nERROR: Need to define a material using Union_make_material before using a Union geometry component. \n");
  printf("       %s was defined before first use of Union_make_material.\n",NAME_CURRENT_COMP);
  exit(1);
}

this_box_volume.geometry.is_masked_volume = 0;
this_box_volume.geometry.is_exit_volume = 0;
this_box_volume.geometry.is_mask_volume = 0;
// check if the volume is a mask, if it is the material string is irelevant.
if (mask_string && strlen(mask_string) && strcmp(mask_string, "NULL") && strcmp(mask_string, "0")) {
    // A mask volume is used to limit the extend of other volumes, called the masked volumes. These are specified in the mask_string.
    // In order for a ray to enter a masked volume, it needs to be both in the region covered by that volume AND the mask volume.
    // When more than
    this_box_volume.geometry.mask_mode = 1; // Default is mask mode is ALL
    if (mask_setting && strlen(mask_setting) && strcmp(mask_setting, "NULL") && strcmp(mask_setting, "0")) {
        if (strcmp(mask_setting,"ALL") == 0 || strcmp(mask_setting,"All") == 0) this_box_volume.geometry.mask_mode = 1;
        else if (strcmp(mask_setting,"ANY") == 0 || strcmp(mask_setting,"Any") == 0) this_box_volume.geometry.mask_mode = 2;
        else {
            printf("The mask_mode of component %s is set to %s, but must be either ALL or ANY.\n",NAME_CURRENT_COMP,mask_setting);
            exit(1);
        }
    }
    
    for (loop_index=0;loop_index<global_geometry_list.num_elements;loop_index++) {
        // Add mask list
        if (1 == manual_linking_function(global_geometry_list.elements[loop_index].name,mask_string)) {
            add_element_to_int_list(&this_box_volume.geometry.mask_list,global_geometry_list.elements[loop_index].component_index);
            add_element_to_int_list(&global_geometry_list.elements[loop_index].Volume->geometry.masked_by_list,INDEX_CURRENT_COMP);
            global_geometry_list.elements[loop_index].Volume->geometry.is_masked_volume = 1;
            if (this_box_volume.geometry.mask_mode == 2)
                global_geometry_list.elements[loop_index].Volume->geometry.mask_mode = 2;
            if (this_box_volume.geometry.mask_mode == 1) {
                if (global_geometry_list.elements[loop_index].Volume->geometry.is_masked_volume == 1 && global_geometry_list.elements[loop_index].Volume->geometry.mask_mode != 2)
                    // If more than one mask is added to one volume, the ANY mode overwrites the (default) ALL mode.
                    global_geometry_list.elements[loop_index].Volume->geometry.mask_mode = 1;
            }
            
            found_geometries = 1;
        }
    }
    if (found_geometries == 0) {
        printf("The mask_string in geometry: %s did not find any of the specified volumes in the mask_string %s \n",NAME_CURRENT_COMP,mask_string);
        exit(1);
    }
    this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
    this_box_volume.p_physics->is_vacuum = 0; // Makes this volume a vacuum
    this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
    this_box_volume.p_physics->my_a = 0; // Should not be used.
    sprintf(this_box_volume.p_physics->name,"Mask");
    this_box_volume.geometry.is_mask_volume = 1;
    
    
// Read the material input, or if it lacks, use automatic linking.
} else if (material_string && strlen(material_string) && strcmp(material_string, "NULL") && strcmp(material_string, "0")) {
    // A geometry string was given, use it to determine which material
    if (0 == strcmp(material_string,"vacuum") || 0 == strcmp(material_string,"Vacuum")) {
        // One could have a global physics struct for vacuum instead of creating one for each
        this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
        this_box_volume.p_physics->is_vacuum = 1; // Makes this volume a vacuum
        this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
        this_box_volume.p_physics->my_a = 0; // Should not be used.
        sprintf(this_box_volume.p_physics->name,"Vacuum");
    } else if (0 == strcmp(material_string,"exit") || 0 == strcmp(material_string,"Exit")) {
        // One could have a global physics struct for vacuum instead of creating one for each
        this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
        this_box_volume.p_physics->is_vacuum = 1; // Makes this volume a vacuum
        this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
        this_box_volume.p_physics->my_a = 0; // Should not be used.
        this_box_volume.geometry.is_exit_volume = 1;
        sprintf(this_box_volume.p_physics->name,"Exit");
    } else {
        #ifndef MATERIAL_DETECTOR
            printf("Need to define a material before refering to it in a geometry %s.\n",NAME_CURRENT_COMP);
            exit(1);
        #endif
        for (loop_index=0;loop_index<global_material_list.num_elements;loop_index++) {
            if (0 == strcmp(material_string,global_material_list.elements[loop_index].name)) {
                this_box_volume.p_physics = global_material_list.elements[loop_index].physics;
                break;
            }
            if (loop_index == global_material_list.num_elements-1) {
            printf("\n");
            printf("ERROR: The material string \"%s\" in Union geometry \"%s\" did not match a specified material. \n",material_string,NAME_CURRENT_COMP);
            printf("       The materials available at this point (need to be defined before the geometry): \n");
            for (loop_index=0;loop_index<global_material_list.num_elements;loop_index++)
              printf("         %s\n",global_material_list.elements[loop_index].name);
            printf("\n");
            printf("       It is also possible to use one of the defualt materials avaiable: \n");
            printf("           Vacuum (for a Volume without scattering or absorption)\n");
            printf("           Exit (for a Volume where the ray exits the component if it enters)\n");
            printf("           Mask (for a Volume that masks existing volumes specified in the mask_string\n");
            exit(1);
          }
        }
    }
} else {
    // Automatic linking, simply using the last defined material.
    #ifndef MATERIAL_DETECTOR
        printf("Need to define a material before the geometry to use automatic linking %s.\n",NAME_CURRENT_COMP);
        exit(1);
    #endif
    this_box_volume.p_physics = global_material_list.elements[global_material_list.num_elements-1].physics;
}

sprintf(this_box_volume.name,NAME_CURRENT_COMP);
sprintf(this_box_volume.geometry.shape,"box");
this_box_volume.geometry.priority_value = priority;
this_box_volume.geometry.geometry_p_interact = p_interact;
// Currently the coordinates will be in absolute space.
this_box_volume.geometry.center = POS_A_CURRENT_COMP;

this_box_storage.z_depth = zdepth;
this_box_storage.x_width1 = xwidth;
this_box_storage.y_height1 = yheight;

this_box_storage.is_rectangle = 0;
if (xwidth2 < 0 && yheight2 < 0) this_box_storage.is_rectangle = 1;
if (xwidth == xwidth2 && yheight == yheight2) this_box_storage.is_rectangle = 1;

if (xwidth2 < 0) {
    this_box_storage.x_width2 = xwidth;
    xwidth2 = xwidth;
} else this_box_storage.x_width2 = xwidth2;

if (yheight2 < 0) {
    this_box_storage.y_height2 = yheight;
    yheight2 = yheight;
} else this_box_storage.y_height2 = yheight2;


this_box_storage.normal_vectors[0] = coords_set(0,0,1);
this_box_storage.normal_vectors[1] = coords_set(0,0,1);

// for sides with y component = 0
x_component = 2*zdepth/sqrt((xwidth-xwidth2)*(xwidth-xwidth2)+4*zdepth*zdepth);
z_component = (xwidth-xwidth2)/sqrt(4*zdepth*zdepth+(xwidth-xwidth2)*(xwidth-xwidth2));

this_box_storage.normal_vectors[2] = coords_set(x_component,0,z_component);
this_box_storage.normal_vectors[3] = coords_set(-x_component,0,z_component);

// for sides with x component = 0
y_component = 2*zdepth/sqrt((yheight-yheight2)*(yheight-yheight2)+4*zdepth*zdepth);
z_component = (yheight-yheight2)/sqrt(4*zdepth*zdepth+(yheight-yheight2)*(yheight-yheight2));

this_box_storage.normal_vectors[4] = coords_set(0,y_component,z_component);
this_box_storage.normal_vectors[5] = coords_set(0,-y_component,z_component);

this_box_volume.geometry.visualization_on = visualize;

this_box_volume.geometry.geometry_parameters.p_box_storage = &this_box_storage;

// Assign pointers to functions for intersection with the shape, checking if a point is inside the shape
if (this_box_storage.is_rectangle == 1) {
this_box_volume.geometry.intersect_function = &sample_box_intersect_simple;
this_box_volume.geometry.within_function = &r_within_box_simple;
}
else {
this_box_volume.geometry.intersect_function = &sample_box_intersect_advanced;
this_box_volume.geometry.within_function = &r_within_box_advanced;
}

this_box_volume.geometry.shell_points = &box_shell_points;
this_box_volume.geometry.mcdisplay_function = &mcdisplay_box_function;
this_box_volume.geometry.initialize_from_main_function = &initialize_box_geometry_from_main_component;
this_box_volume.geometry.process_rot_allocated = 0;

this_box_volume.geometry.copy_geometry_parameters = &allocate_box_storage_copy;

rot_copy(this_box_volume.geometry.rotation_matrix,ROT_A_CURRENT_COMP); //check how ROT_R_CURRENT_COMP would work
rot_transpose(ROT_A_CURRENT_COMP,this_box_volume.geometry.transpose_rotation_matrix);

// Initialize loggers
this_box_volume.loggers.num_elements = 0;

// packing the information into the global_geometry_element, which is then included in the global_geometry_list.
sprintf(global_geometry_element.name,NAME_CURRENT_COMP);
global_geometry_element.activation_counter = number_of_activations;
global_geometry_element.component_index = INDEX_CURRENT_COMP;
global_geometry_element.Volume = &this_box_volume; // Would be nicer if this m was a pointer, now we have the (small) data two places
add_element_to_geometry_list(&global_geometry_list,global_geometry_element);
}
#line 242423 "MACS_sample_kidney_box.c"
#undef number_of_activations
#undef mask_setting
#undef mask_string
#undef p_interact
#undef focus_r
#undef focus_xh
#undef focus_xw
#undef focus_ah
#undef focus_aw
#undef target_z
#undef target_y
#undef target_x
#undef target_index
#undef visualize
#undef yheight2
#undef xwidth2
#undef zdepth
#undef yheight
#undef xwidth
#undef priority
#undef material_string
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

  /* Initializations for component inter_analyzer_colimator_8_blade_2. */
  SIG_MESSAGE("inter_analyzer_colimator_8_blade_2 (Init)");
#define mccompcurname  inter_analyzer_colimator_8_blade_2
#define mccompcurtype  Union_box
#define mccompcurindex 461
#define loop_index mccinter_analyzer_colimator_8_blade_2_loop_index
#define this_box_volume mccinter_analyzer_colimator_8_blade_2_this_box_volume
#define global_geometry_element mccinter_analyzer_colimator_8_blade_2_global_geometry_element
#define this_box_storage mccinter_analyzer_colimator_8_blade_2_this_box_storage
#define material_string mccinter_analyzer_colimator_8_blade_2_material_string
#define priority mccinter_analyzer_colimator_8_blade_2_priority
#define xwidth mccinter_analyzer_colimator_8_blade_2_xwidth
#define yheight mccinter_analyzer_colimator_8_blade_2_yheight
#define zdepth mccinter_analyzer_colimator_8_blade_2_zdepth
#define xwidth2 mccinter_analyzer_colimator_8_blade_2_xwidth2
#define yheight2 mccinter_analyzer_colimator_8_blade_2_yheight2
#define visualize mccinter_analyzer_colimator_8_blade_2_visualize
#define target_index mccinter_analyzer_colimator_8_blade_2_target_index
#define target_x mccinter_analyzer_colimator_8_blade_2_target_x
#define target_y mccinter_analyzer_colimator_8_blade_2_target_y
#define target_z mccinter_analyzer_colimator_8_blade_2_target_z
#define focus_aw mccinter_analyzer_colimator_8_blade_2_focus_aw
#define focus_ah mccinter_analyzer_colimator_8_blade_2_focus_ah
#define focus_xw mccinter_analyzer_colimator_8_blade_2_focus_xw
#define focus_xh mccinter_analyzer_colimator_8_blade_2_focus_xh
#define focus_r mccinter_analyzer_colimator_8_blade_2_focus_r
#define p_interact mccinter_analyzer_colimator_8_blade_2_p_interact
#define mask_string mccinter_analyzer_colimator_8_blade_2_mask_string
#define mask_setting mccinter_analyzer_colimator_8_blade_2_mask_setting
#define number_of_activations mccinter_analyzer_colimator_8_blade_2_number_of_activations
#line 224 "Union_box.comp"
{
// Initializes the focusing system for this volume including input sanitation.
focus_initialize(&this_box_volume.geometry, POS_A_COMP_INDEX(INDEX_CURRENT_COMP+target_index), POS_A_CURRENT_COMP, ROT_A_CURRENT_COMP, target_index, target_x, target_y, target_z, focus_aw, focus_ah, focus_xw, focus_xh, focus_r, NAME_CURRENT_COMP);

// Input sanitation for this geometry
if (xwidth <= 0) {
  printf("\nERROR in Union_box named %s, the xwidth is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (yheight <= 0) {
  printf("\nERROR in Union_box named %s, yheight is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (zdepth <= 0) {
  printf("\nERROR in Union_box named %s, zdepth is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (xwidth2 <= 0 && xwidth2 != -1) {
  printf("\nERROR in Union_box named %s, the xwidth2 is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (yheight2 <= 0 && yheight2 != -1) {
  printf("\nERROR in Union_box named %s, yheight2 is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}

// Use sanitation
if (global_material_list.num_elements == 0) {
  printf("\nERROR: Need to define a material using Union_make_material before using a Union geometry component. \n");
  printf("       %s was defined before first use of Union_make_material.\n",NAME_CURRENT_COMP);
  exit(1);
}

this_box_volume.geometry.is_masked_volume = 0;
this_box_volume.geometry.is_exit_volume = 0;
this_box_volume.geometry.is_mask_volume = 0;
// check if the volume is a mask, if it is the material string is irelevant.
if (mask_string && strlen(mask_string) && strcmp(mask_string, "NULL") && strcmp(mask_string, "0")) {
    // A mask volume is used to limit the extend of other volumes, called the masked volumes. These are specified in the mask_string.
    // In order for a ray to enter a masked volume, it needs to be both in the region covered by that volume AND the mask volume.
    // When more than
    this_box_volume.geometry.mask_mode = 1; // Default is mask mode is ALL
    if (mask_setting && strlen(mask_setting) && strcmp(mask_setting, "NULL") && strcmp(mask_setting, "0")) {
        if (strcmp(mask_setting,"ALL") == 0 || strcmp(mask_setting,"All") == 0) this_box_volume.geometry.mask_mode = 1;
        else if (strcmp(mask_setting,"ANY") == 0 || strcmp(mask_setting,"Any") == 0) this_box_volume.geometry.mask_mode = 2;
        else {
            printf("The mask_mode of component %s is set to %s, but must be either ALL or ANY.\n",NAME_CURRENT_COMP,mask_setting);
            exit(1);
        }
    }
    
    for (loop_index=0;loop_index<global_geometry_list.num_elements;loop_index++) {
        // Add mask list
        if (1 == manual_linking_function(global_geometry_list.elements[loop_index].name,mask_string)) {
            add_element_to_int_list(&this_box_volume.geometry.mask_list,global_geometry_list.elements[loop_index].component_index);
            add_element_to_int_list(&global_geometry_list.elements[loop_index].Volume->geometry.masked_by_list,INDEX_CURRENT_COMP);
            global_geometry_list.elements[loop_index].Volume->geometry.is_masked_volume = 1;
            if (this_box_volume.geometry.mask_mode == 2)
                global_geometry_list.elements[loop_index].Volume->geometry.mask_mode = 2;
            if (this_box_volume.geometry.mask_mode == 1) {
                if (global_geometry_list.elements[loop_index].Volume->geometry.is_masked_volume == 1 && global_geometry_list.elements[loop_index].Volume->geometry.mask_mode != 2)
                    // If more than one mask is added to one volume, the ANY mode overwrites the (default) ALL mode.
                    global_geometry_list.elements[loop_index].Volume->geometry.mask_mode = 1;
            }
            
            found_geometries = 1;
        }
    }
    if (found_geometries == 0) {
        printf("The mask_string in geometry: %s did not find any of the specified volumes in the mask_string %s \n",NAME_CURRENT_COMP,mask_string);
        exit(1);
    }
    this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
    this_box_volume.p_physics->is_vacuum = 0; // Makes this volume a vacuum
    this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
    this_box_volume.p_physics->my_a = 0; // Should not be used.
    sprintf(this_box_volume.p_physics->name,"Mask");
    this_box_volume.geometry.is_mask_volume = 1;
    
    
// Read the material input, or if it lacks, use automatic linking.
} else if (material_string && strlen(material_string) && strcmp(material_string, "NULL") && strcmp(material_string, "0")) {
    // A geometry string was given, use it to determine which material
    if (0 == strcmp(material_string,"vacuum") || 0 == strcmp(material_string,"Vacuum")) {
        // One could have a global physics struct for vacuum instead of creating one for each
        this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
        this_box_volume.p_physics->is_vacuum = 1; // Makes this volume a vacuum
        this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
        this_box_volume.p_physics->my_a = 0; // Should not be used.
        sprintf(this_box_volume.p_physics->name,"Vacuum");
    } else if (0 == strcmp(material_string,"exit") || 0 == strcmp(material_string,"Exit")) {
        // One could have a global physics struct for vacuum instead of creating one for each
        this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
        this_box_volume.p_physics->is_vacuum = 1; // Makes this volume a vacuum
        this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
        this_box_volume.p_physics->my_a = 0; // Should not be used.
        this_box_volume.geometry.is_exit_volume = 1;
        sprintf(this_box_volume.p_physics->name,"Exit");
    } else {
        #ifndef MATERIAL_DETECTOR
            printf("Need to define a material before refering to it in a geometry %s.\n",NAME_CURRENT_COMP);
            exit(1);
        #endif
        for (loop_index=0;loop_index<global_material_list.num_elements;loop_index++) {
            if (0 == strcmp(material_string,global_material_list.elements[loop_index].name)) {
                this_box_volume.p_physics = global_material_list.elements[loop_index].physics;
                break;
            }
            if (loop_index == global_material_list.num_elements-1) {
            printf("\n");
            printf("ERROR: The material string \"%s\" in Union geometry \"%s\" did not match a specified material. \n",material_string,NAME_CURRENT_COMP);
            printf("       The materials available at this point (need to be defined before the geometry): \n");
            for (loop_index=0;loop_index<global_material_list.num_elements;loop_index++)
              printf("         %s\n",global_material_list.elements[loop_index].name);
            printf("\n");
            printf("       It is also possible to use one of the defualt materials avaiable: \n");
            printf("           Vacuum (for a Volume without scattering or absorption)\n");
            printf("           Exit (for a Volume where the ray exits the component if it enters)\n");
            printf("           Mask (for a Volume that masks existing volumes specified in the mask_string\n");
            exit(1);
          }
        }
    }
} else {
    // Automatic linking, simply using the last defined material.
    #ifndef MATERIAL_DETECTOR
        printf("Need to define a material before the geometry to use automatic linking %s.\n",NAME_CURRENT_COMP);
        exit(1);
    #endif
    this_box_volume.p_physics = global_material_list.elements[global_material_list.num_elements-1].physics;
}

sprintf(this_box_volume.name,NAME_CURRENT_COMP);
sprintf(this_box_volume.geometry.shape,"box");
this_box_volume.geometry.priority_value = priority;
this_box_volume.geometry.geometry_p_interact = p_interact;
// Currently the coordinates will be in absolute space.
this_box_volume.geometry.center = POS_A_CURRENT_COMP;

this_box_storage.z_depth = zdepth;
this_box_storage.x_width1 = xwidth;
this_box_storage.y_height1 = yheight;

this_box_storage.is_rectangle = 0;
if (xwidth2 < 0 && yheight2 < 0) this_box_storage.is_rectangle = 1;
if (xwidth == xwidth2 && yheight == yheight2) this_box_storage.is_rectangle = 1;

if (xwidth2 < 0) {
    this_box_storage.x_width2 = xwidth;
    xwidth2 = xwidth;
} else this_box_storage.x_width2 = xwidth2;

if (yheight2 < 0) {
    this_box_storage.y_height2 = yheight;
    yheight2 = yheight;
} else this_box_storage.y_height2 = yheight2;


this_box_storage.normal_vectors[0] = coords_set(0,0,1);
this_box_storage.normal_vectors[1] = coords_set(0,0,1);

// for sides with y component = 0
x_component = 2*zdepth/sqrt((xwidth-xwidth2)*(xwidth-xwidth2)+4*zdepth*zdepth);
z_component = (xwidth-xwidth2)/sqrt(4*zdepth*zdepth+(xwidth-xwidth2)*(xwidth-xwidth2));

this_box_storage.normal_vectors[2] = coords_set(x_component,0,z_component);
this_box_storage.normal_vectors[3] = coords_set(-x_component,0,z_component);

// for sides with x component = 0
y_component = 2*zdepth/sqrt((yheight-yheight2)*(yheight-yheight2)+4*zdepth*zdepth);
z_component = (yheight-yheight2)/sqrt(4*zdepth*zdepth+(yheight-yheight2)*(yheight-yheight2));

this_box_storage.normal_vectors[4] = coords_set(0,y_component,z_component);
this_box_storage.normal_vectors[5] = coords_set(0,-y_component,z_component);

this_box_volume.geometry.visualization_on = visualize;

this_box_volume.geometry.geometry_parameters.p_box_storage = &this_box_storage;

// Assign pointers to functions for intersection with the shape, checking if a point is inside the shape
if (this_box_storage.is_rectangle == 1) {
this_box_volume.geometry.intersect_function = &sample_box_intersect_simple;
this_box_volume.geometry.within_function = &r_within_box_simple;
}
else {
this_box_volume.geometry.intersect_function = &sample_box_intersect_advanced;
this_box_volume.geometry.within_function = &r_within_box_advanced;
}

this_box_volume.geometry.shell_points = &box_shell_points;
this_box_volume.geometry.mcdisplay_function = &mcdisplay_box_function;
this_box_volume.geometry.initialize_from_main_function = &initialize_box_geometry_from_main_component;
this_box_volume.geometry.process_rot_allocated = 0;

this_box_volume.geometry.copy_geometry_parameters = &allocate_box_storage_copy;

rot_copy(this_box_volume.geometry.rotation_matrix,ROT_A_CURRENT_COMP); //check how ROT_R_CURRENT_COMP would work
rot_transpose(ROT_A_CURRENT_COMP,this_box_volume.geometry.transpose_rotation_matrix);

// Initialize loggers
this_box_volume.loggers.num_elements = 0;

// packing the information into the global_geometry_element, which is then included in the global_geometry_list.
sprintf(global_geometry_element.name,NAME_CURRENT_COMP);
global_geometry_element.activation_counter = number_of_activations;
global_geometry_element.component_index = INDEX_CURRENT_COMP;
global_geometry_element.Volume = &this_box_volume; // Would be nicer if this m was a pointer, now we have the (small) data two places
add_element_to_geometry_list(&global_geometry_list,global_geometry_element);
}
#line 242693 "MACS_sample_kidney_box.c"
#undef number_of_activations
#undef mask_setting
#undef mask_string
#undef p_interact
#undef focus_r
#undef focus_xh
#undef focus_xw
#undef focus_ah
#undef focus_aw
#undef target_z
#undef target_y
#undef target_x
#undef target_index
#undef visualize
#undef yheight2
#undef xwidth2
#undef zdepth
#undef yheight
#undef xwidth
#undef priority
#undef material_string
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

  /* Initializations for component inter_analyzer_colimator_8_blade_3. */
  SIG_MESSAGE("inter_analyzer_colimator_8_blade_3 (Init)");
#define mccompcurname  inter_analyzer_colimator_8_blade_3
#define mccompcurtype  Union_box
#define mccompcurindex 462
#define loop_index mccinter_analyzer_colimator_8_blade_3_loop_index
#define this_box_volume mccinter_analyzer_colimator_8_blade_3_this_box_volume
#define global_geometry_element mccinter_analyzer_colimator_8_blade_3_global_geometry_element
#define this_box_storage mccinter_analyzer_colimator_8_blade_3_this_box_storage
#define material_string mccinter_analyzer_colimator_8_blade_3_material_string
#define priority mccinter_analyzer_colimator_8_blade_3_priority
#define xwidth mccinter_analyzer_colimator_8_blade_3_xwidth
#define yheight mccinter_analyzer_colimator_8_blade_3_yheight
#define zdepth mccinter_analyzer_colimator_8_blade_3_zdepth
#define xwidth2 mccinter_analyzer_colimator_8_blade_3_xwidth2
#define yheight2 mccinter_analyzer_colimator_8_blade_3_yheight2
#define visualize mccinter_analyzer_colimator_8_blade_3_visualize
#define target_index mccinter_analyzer_colimator_8_blade_3_target_index
#define target_x mccinter_analyzer_colimator_8_blade_3_target_x
#define target_y mccinter_analyzer_colimator_8_blade_3_target_y
#define target_z mccinter_analyzer_colimator_8_blade_3_target_z
#define focus_aw mccinter_analyzer_colimator_8_blade_3_focus_aw
#define focus_ah mccinter_analyzer_colimator_8_blade_3_focus_ah
#define focus_xw mccinter_analyzer_colimator_8_blade_3_focus_xw
#define focus_xh mccinter_analyzer_colimator_8_blade_3_focus_xh
#define focus_r mccinter_analyzer_colimator_8_blade_3_focus_r
#define p_interact mccinter_analyzer_colimator_8_blade_3_p_interact
#define mask_string mccinter_analyzer_colimator_8_blade_3_mask_string
#define mask_setting mccinter_analyzer_colimator_8_blade_3_mask_setting
#define number_of_activations mccinter_analyzer_colimator_8_blade_3_number_of_activations
#line 224 "Union_box.comp"
{
// Initializes the focusing system for this volume including input sanitation.
focus_initialize(&this_box_volume.geometry, POS_A_COMP_INDEX(INDEX_CURRENT_COMP+target_index), POS_A_CURRENT_COMP, ROT_A_CURRENT_COMP, target_index, target_x, target_y, target_z, focus_aw, focus_ah, focus_xw, focus_xh, focus_r, NAME_CURRENT_COMP);

// Input sanitation for this geometry
if (xwidth <= 0) {
  printf("\nERROR in Union_box named %s, the xwidth is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (yheight <= 0) {
  printf("\nERROR in Union_box named %s, yheight is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (zdepth <= 0) {
  printf("\nERROR in Union_box named %s, zdepth is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (xwidth2 <= 0 && xwidth2 != -1) {
  printf("\nERROR in Union_box named %s, the xwidth2 is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (yheight2 <= 0 && yheight2 != -1) {
  printf("\nERROR in Union_box named %s, yheight2 is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}

// Use sanitation
if (global_material_list.num_elements == 0) {
  printf("\nERROR: Need to define a material using Union_make_material before using a Union geometry component. \n");
  printf("       %s was defined before first use of Union_make_material.\n",NAME_CURRENT_COMP);
  exit(1);
}

this_box_volume.geometry.is_masked_volume = 0;
this_box_volume.geometry.is_exit_volume = 0;
this_box_volume.geometry.is_mask_volume = 0;
// check if the volume is a mask, if it is the material string is irelevant.
if (mask_string && strlen(mask_string) && strcmp(mask_string, "NULL") && strcmp(mask_string, "0")) {
    // A mask volume is used to limit the extend of other volumes, called the masked volumes. These are specified in the mask_string.
    // In order for a ray to enter a masked volume, it needs to be both in the region covered by that volume AND the mask volume.
    // When more than
    this_box_volume.geometry.mask_mode = 1; // Default is mask mode is ALL
    if (mask_setting && strlen(mask_setting) && strcmp(mask_setting, "NULL") && strcmp(mask_setting, "0")) {
        if (strcmp(mask_setting,"ALL") == 0 || strcmp(mask_setting,"All") == 0) this_box_volume.geometry.mask_mode = 1;
        else if (strcmp(mask_setting,"ANY") == 0 || strcmp(mask_setting,"Any") == 0) this_box_volume.geometry.mask_mode = 2;
        else {
            printf("The mask_mode of component %s is set to %s, but must be either ALL or ANY.\n",NAME_CURRENT_COMP,mask_setting);
            exit(1);
        }
    }
    
    for (loop_index=0;loop_index<global_geometry_list.num_elements;loop_index++) {
        // Add mask list
        if (1 == manual_linking_function(global_geometry_list.elements[loop_index].name,mask_string)) {
            add_element_to_int_list(&this_box_volume.geometry.mask_list,global_geometry_list.elements[loop_index].component_index);
            add_element_to_int_list(&global_geometry_list.elements[loop_index].Volume->geometry.masked_by_list,INDEX_CURRENT_COMP);
            global_geometry_list.elements[loop_index].Volume->geometry.is_masked_volume = 1;
            if (this_box_volume.geometry.mask_mode == 2)
                global_geometry_list.elements[loop_index].Volume->geometry.mask_mode = 2;
            if (this_box_volume.geometry.mask_mode == 1) {
                if (global_geometry_list.elements[loop_index].Volume->geometry.is_masked_volume == 1 && global_geometry_list.elements[loop_index].Volume->geometry.mask_mode != 2)
                    // If more than one mask is added to one volume, the ANY mode overwrites the (default) ALL mode.
                    global_geometry_list.elements[loop_index].Volume->geometry.mask_mode = 1;
            }
            
            found_geometries = 1;
        }
    }
    if (found_geometries == 0) {
        printf("The mask_string in geometry: %s did not find any of the specified volumes in the mask_string %s \n",NAME_CURRENT_COMP,mask_string);
        exit(1);
    }
    this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
    this_box_volume.p_physics->is_vacuum = 0; // Makes this volume a vacuum
    this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
    this_box_volume.p_physics->my_a = 0; // Should not be used.
    sprintf(this_box_volume.p_physics->name,"Mask");
    this_box_volume.geometry.is_mask_volume = 1;
    
    
// Read the material input, or if it lacks, use automatic linking.
} else if (material_string && strlen(material_string) && strcmp(material_string, "NULL") && strcmp(material_string, "0")) {
    // A geometry string was given, use it to determine which material
    if (0 == strcmp(material_string,"vacuum") || 0 == strcmp(material_string,"Vacuum")) {
        // One could have a global physics struct for vacuum instead of creating one for each
        this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
        this_box_volume.p_physics->is_vacuum = 1; // Makes this volume a vacuum
        this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
        this_box_volume.p_physics->my_a = 0; // Should not be used.
        sprintf(this_box_volume.p_physics->name,"Vacuum");
    } else if (0 == strcmp(material_string,"exit") || 0 == strcmp(material_string,"Exit")) {
        // One could have a global physics struct for vacuum instead of creating one for each
        this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
        this_box_volume.p_physics->is_vacuum = 1; // Makes this volume a vacuum
        this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
        this_box_volume.p_physics->my_a = 0; // Should not be used.
        this_box_volume.geometry.is_exit_volume = 1;
        sprintf(this_box_volume.p_physics->name,"Exit");
    } else {
        #ifndef MATERIAL_DETECTOR
            printf("Need to define a material before refering to it in a geometry %s.\n",NAME_CURRENT_COMP);
            exit(1);
        #endif
        for (loop_index=0;loop_index<global_material_list.num_elements;loop_index++) {
            if (0 == strcmp(material_string,global_material_list.elements[loop_index].name)) {
                this_box_volume.p_physics = global_material_list.elements[loop_index].physics;
                break;
            }
            if (loop_index == global_material_list.num_elements-1) {
            printf("\n");
            printf("ERROR: The material string \"%s\" in Union geometry \"%s\" did not match a specified material. \n",material_string,NAME_CURRENT_COMP);
            printf("       The materials available at this point (need to be defined before the geometry): \n");
            for (loop_index=0;loop_index<global_material_list.num_elements;loop_index++)
              printf("         %s\n",global_material_list.elements[loop_index].name);
            printf("\n");
            printf("       It is also possible to use one of the defualt materials avaiable: \n");
            printf("           Vacuum (for a Volume without scattering or absorption)\n");
            printf("           Exit (for a Volume where the ray exits the component if it enters)\n");
            printf("           Mask (for a Volume that masks existing volumes specified in the mask_string\n");
            exit(1);
          }
        }
    }
} else {
    // Automatic linking, simply using the last defined material.
    #ifndef MATERIAL_DETECTOR
        printf("Need to define a material before the geometry to use automatic linking %s.\n",NAME_CURRENT_COMP);
        exit(1);
    #endif
    this_box_volume.p_physics = global_material_list.elements[global_material_list.num_elements-1].physics;
}

sprintf(this_box_volume.name,NAME_CURRENT_COMP);
sprintf(this_box_volume.geometry.shape,"box");
this_box_volume.geometry.priority_value = priority;
this_box_volume.geometry.geometry_p_interact = p_interact;
// Currently the coordinates will be in absolute space.
this_box_volume.geometry.center = POS_A_CURRENT_COMP;

this_box_storage.z_depth = zdepth;
this_box_storage.x_width1 = xwidth;
this_box_storage.y_height1 = yheight;

this_box_storage.is_rectangle = 0;
if (xwidth2 < 0 && yheight2 < 0) this_box_storage.is_rectangle = 1;
if (xwidth == xwidth2 && yheight == yheight2) this_box_storage.is_rectangle = 1;

if (xwidth2 < 0) {
    this_box_storage.x_width2 = xwidth;
    xwidth2 = xwidth;
} else this_box_storage.x_width2 = xwidth2;

if (yheight2 < 0) {
    this_box_storage.y_height2 = yheight;
    yheight2 = yheight;
} else this_box_storage.y_height2 = yheight2;


this_box_storage.normal_vectors[0] = coords_set(0,0,1);
this_box_storage.normal_vectors[1] = coords_set(0,0,1);

// for sides with y component = 0
x_component = 2*zdepth/sqrt((xwidth-xwidth2)*(xwidth-xwidth2)+4*zdepth*zdepth);
z_component = (xwidth-xwidth2)/sqrt(4*zdepth*zdepth+(xwidth-xwidth2)*(xwidth-xwidth2));

this_box_storage.normal_vectors[2] = coords_set(x_component,0,z_component);
this_box_storage.normal_vectors[3] = coords_set(-x_component,0,z_component);

// for sides with x component = 0
y_component = 2*zdepth/sqrt((yheight-yheight2)*(yheight-yheight2)+4*zdepth*zdepth);
z_component = (yheight-yheight2)/sqrt(4*zdepth*zdepth+(yheight-yheight2)*(yheight-yheight2));

this_box_storage.normal_vectors[4] = coords_set(0,y_component,z_component);
this_box_storage.normal_vectors[5] = coords_set(0,-y_component,z_component);

this_box_volume.geometry.visualization_on = visualize;

this_box_volume.geometry.geometry_parameters.p_box_storage = &this_box_storage;

// Assign pointers to functions for intersection with the shape, checking if a point is inside the shape
if (this_box_storage.is_rectangle == 1) {
this_box_volume.geometry.intersect_function = &sample_box_intersect_simple;
this_box_volume.geometry.within_function = &r_within_box_simple;
}
else {
this_box_volume.geometry.intersect_function = &sample_box_intersect_advanced;
this_box_volume.geometry.within_function = &r_within_box_advanced;
}

this_box_volume.geometry.shell_points = &box_shell_points;
this_box_volume.geometry.mcdisplay_function = &mcdisplay_box_function;
this_box_volume.geometry.initialize_from_main_function = &initialize_box_geometry_from_main_component;
this_box_volume.geometry.process_rot_allocated = 0;

this_box_volume.geometry.copy_geometry_parameters = &allocate_box_storage_copy;

rot_copy(this_box_volume.geometry.rotation_matrix,ROT_A_CURRENT_COMP); //check how ROT_R_CURRENT_COMP would work
rot_transpose(ROT_A_CURRENT_COMP,this_box_volume.geometry.transpose_rotation_matrix);

// Initialize loggers
this_box_volume.loggers.num_elements = 0;

// packing the information into the global_geometry_element, which is then included in the global_geometry_list.
sprintf(global_geometry_element.name,NAME_CURRENT_COMP);
global_geometry_element.activation_counter = number_of_activations;
global_geometry_element.component_index = INDEX_CURRENT_COMP;
global_geometry_element.Volume = &this_box_volume; // Would be nicer if this m was a pointer, now we have the (small) data two places
add_element_to_geometry_list(&global_geometry_list,global_geometry_element);
}
#line 242963 "MACS_sample_kidney_box.c"
#undef number_of_activations
#undef mask_setting
#undef mask_string
#undef p_interact
#undef focus_r
#undef focus_xh
#undef focus_xw
#undef focus_ah
#undef focus_aw
#undef target_z
#undef target_y
#undef target_x
#undef target_index
#undef visualize
#undef yheight2
#undef xwidth2
#undef zdepth
#undef yheight
#undef xwidth
#undef priority
#undef material_string
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

  /* Initializations for component inter_analyzer_colimator_8_blade_4. */
  SIG_MESSAGE("inter_analyzer_colimator_8_blade_4 (Init)");
#define mccompcurname  inter_analyzer_colimator_8_blade_4
#define mccompcurtype  Union_box
#define mccompcurindex 463
#define loop_index mccinter_analyzer_colimator_8_blade_4_loop_index
#define this_box_volume mccinter_analyzer_colimator_8_blade_4_this_box_volume
#define global_geometry_element mccinter_analyzer_colimator_8_blade_4_global_geometry_element
#define this_box_storage mccinter_analyzer_colimator_8_blade_4_this_box_storage
#define material_string mccinter_analyzer_colimator_8_blade_4_material_string
#define priority mccinter_analyzer_colimator_8_blade_4_priority
#define xwidth mccinter_analyzer_colimator_8_blade_4_xwidth
#define yheight mccinter_analyzer_colimator_8_blade_4_yheight
#define zdepth mccinter_analyzer_colimator_8_blade_4_zdepth
#define xwidth2 mccinter_analyzer_colimator_8_blade_4_xwidth2
#define yheight2 mccinter_analyzer_colimator_8_blade_4_yheight2
#define visualize mccinter_analyzer_colimator_8_blade_4_visualize
#define target_index mccinter_analyzer_colimator_8_blade_4_target_index
#define target_x mccinter_analyzer_colimator_8_blade_4_target_x
#define target_y mccinter_analyzer_colimator_8_blade_4_target_y
#define target_z mccinter_analyzer_colimator_8_blade_4_target_z
#define focus_aw mccinter_analyzer_colimator_8_blade_4_focus_aw
#define focus_ah mccinter_analyzer_colimator_8_blade_4_focus_ah
#define focus_xw mccinter_analyzer_colimator_8_blade_4_focus_xw
#define focus_xh mccinter_analyzer_colimator_8_blade_4_focus_xh
#define focus_r mccinter_analyzer_colimator_8_blade_4_focus_r
#define p_interact mccinter_analyzer_colimator_8_blade_4_p_interact
#define mask_string mccinter_analyzer_colimator_8_blade_4_mask_string
#define mask_setting mccinter_analyzer_colimator_8_blade_4_mask_setting
#define number_of_activations mccinter_analyzer_colimator_8_blade_4_number_of_activations
#line 224 "Union_box.comp"
{
// Initializes the focusing system for this volume including input sanitation.
focus_initialize(&this_box_volume.geometry, POS_A_COMP_INDEX(INDEX_CURRENT_COMP+target_index), POS_A_CURRENT_COMP, ROT_A_CURRENT_COMP, target_index, target_x, target_y, target_z, focus_aw, focus_ah, focus_xw, focus_xh, focus_r, NAME_CURRENT_COMP);

// Input sanitation for this geometry
if (xwidth <= 0) {
  printf("\nERROR in Union_box named %s, the xwidth is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (yheight <= 0) {
  printf("\nERROR in Union_box named %s, yheight is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (zdepth <= 0) {
  printf("\nERROR in Union_box named %s, zdepth is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (xwidth2 <= 0 && xwidth2 != -1) {
  printf("\nERROR in Union_box named %s, the xwidth2 is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (yheight2 <= 0 && yheight2 != -1) {
  printf("\nERROR in Union_box named %s, yheight2 is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}

// Use sanitation
if (global_material_list.num_elements == 0) {
  printf("\nERROR: Need to define a material using Union_make_material before using a Union geometry component. \n");
  printf("       %s was defined before first use of Union_make_material.\n",NAME_CURRENT_COMP);
  exit(1);
}

this_box_volume.geometry.is_masked_volume = 0;
this_box_volume.geometry.is_exit_volume = 0;
this_box_volume.geometry.is_mask_volume = 0;
// check if the volume is a mask, if it is the material string is irelevant.
if (mask_string && strlen(mask_string) && strcmp(mask_string, "NULL") && strcmp(mask_string, "0")) {
    // A mask volume is used to limit the extend of other volumes, called the masked volumes. These are specified in the mask_string.
    // In order for a ray to enter a masked volume, it needs to be both in the region covered by that volume AND the mask volume.
    // When more than
    this_box_volume.geometry.mask_mode = 1; // Default is mask mode is ALL
    if (mask_setting && strlen(mask_setting) && strcmp(mask_setting, "NULL") && strcmp(mask_setting, "0")) {
        if (strcmp(mask_setting,"ALL") == 0 || strcmp(mask_setting,"All") == 0) this_box_volume.geometry.mask_mode = 1;
        else if (strcmp(mask_setting,"ANY") == 0 || strcmp(mask_setting,"Any") == 0) this_box_volume.geometry.mask_mode = 2;
        else {
            printf("The mask_mode of component %s is set to %s, but must be either ALL or ANY.\n",NAME_CURRENT_COMP,mask_setting);
            exit(1);
        }
    }
    
    for (loop_index=0;loop_index<global_geometry_list.num_elements;loop_index++) {
        // Add mask list
        if (1 == manual_linking_function(global_geometry_list.elements[loop_index].name,mask_string)) {
            add_element_to_int_list(&this_box_volume.geometry.mask_list,global_geometry_list.elements[loop_index].component_index);
            add_element_to_int_list(&global_geometry_list.elements[loop_index].Volume->geometry.masked_by_list,INDEX_CURRENT_COMP);
            global_geometry_list.elements[loop_index].Volume->geometry.is_masked_volume = 1;
            if (this_box_volume.geometry.mask_mode == 2)
                global_geometry_list.elements[loop_index].Volume->geometry.mask_mode = 2;
            if (this_box_volume.geometry.mask_mode == 1) {
                if (global_geometry_list.elements[loop_index].Volume->geometry.is_masked_volume == 1 && global_geometry_list.elements[loop_index].Volume->geometry.mask_mode != 2)
                    // If more than one mask is added to one volume, the ANY mode overwrites the (default) ALL mode.
                    global_geometry_list.elements[loop_index].Volume->geometry.mask_mode = 1;
            }
            
            found_geometries = 1;
        }
    }
    if (found_geometries == 0) {
        printf("The mask_string in geometry: %s did not find any of the specified volumes in the mask_string %s \n",NAME_CURRENT_COMP,mask_string);
        exit(1);
    }
    this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
    this_box_volume.p_physics->is_vacuum = 0; // Makes this volume a vacuum
    this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
    this_box_volume.p_physics->my_a = 0; // Should not be used.
    sprintf(this_box_volume.p_physics->name,"Mask");
    this_box_volume.geometry.is_mask_volume = 1;
    
    
// Read the material input, or if it lacks, use automatic linking.
} else if (material_string && strlen(material_string) && strcmp(material_string, "NULL") && strcmp(material_string, "0")) {
    // A geometry string was given, use it to determine which material
    if (0 == strcmp(material_string,"vacuum") || 0 == strcmp(material_string,"Vacuum")) {
        // One could have a global physics struct for vacuum instead of creating one for each
        this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
        this_box_volume.p_physics->is_vacuum = 1; // Makes this volume a vacuum
        this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
        this_box_volume.p_physics->my_a = 0; // Should not be used.
        sprintf(this_box_volume.p_physics->name,"Vacuum");
    } else if (0 == strcmp(material_string,"exit") || 0 == strcmp(material_string,"Exit")) {
        // One could have a global physics struct for vacuum instead of creating one for each
        this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
        this_box_volume.p_physics->is_vacuum = 1; // Makes this volume a vacuum
        this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
        this_box_volume.p_physics->my_a = 0; // Should not be used.
        this_box_volume.geometry.is_exit_volume = 1;
        sprintf(this_box_volume.p_physics->name,"Exit");
    } else {
        #ifndef MATERIAL_DETECTOR
            printf("Need to define a material before refering to it in a geometry %s.\n",NAME_CURRENT_COMP);
            exit(1);
        #endif
        for (loop_index=0;loop_index<global_material_list.num_elements;loop_index++) {
            if (0 == strcmp(material_string,global_material_list.elements[loop_index].name)) {
                this_box_volume.p_physics = global_material_list.elements[loop_index].physics;
                break;
            }
            if (loop_index == global_material_list.num_elements-1) {
            printf("\n");
            printf("ERROR: The material string \"%s\" in Union geometry \"%s\" did not match a specified material. \n",material_string,NAME_CURRENT_COMP);
            printf("       The materials available at this point (need to be defined before the geometry): \n");
            for (loop_index=0;loop_index<global_material_list.num_elements;loop_index++)
              printf("         %s\n",global_material_list.elements[loop_index].name);
            printf("\n");
            printf("       It is also possible to use one of the defualt materials avaiable: \n");
            printf("           Vacuum (for a Volume without scattering or absorption)\n");
            printf("           Exit (for a Volume where the ray exits the component if it enters)\n");
            printf("           Mask (for a Volume that masks existing volumes specified in the mask_string\n");
            exit(1);
          }
        }
    }
} else {
    // Automatic linking, simply using the last defined material.
    #ifndef MATERIAL_DETECTOR
        printf("Need to define a material before the geometry to use automatic linking %s.\n",NAME_CURRENT_COMP);
        exit(1);
    #endif
    this_box_volume.p_physics = global_material_list.elements[global_material_list.num_elements-1].physics;
}

sprintf(this_box_volume.name,NAME_CURRENT_COMP);
sprintf(this_box_volume.geometry.shape,"box");
this_box_volume.geometry.priority_value = priority;
this_box_volume.geometry.geometry_p_interact = p_interact;
// Currently the coordinates will be in absolute space.
this_box_volume.geometry.center = POS_A_CURRENT_COMP;

this_box_storage.z_depth = zdepth;
this_box_storage.x_width1 = xwidth;
this_box_storage.y_height1 = yheight;

this_box_storage.is_rectangle = 0;
if (xwidth2 < 0 && yheight2 < 0) this_box_storage.is_rectangle = 1;
if (xwidth == xwidth2 && yheight == yheight2) this_box_storage.is_rectangle = 1;

if (xwidth2 < 0) {
    this_box_storage.x_width2 = xwidth;
    xwidth2 = xwidth;
} else this_box_storage.x_width2 = xwidth2;

if (yheight2 < 0) {
    this_box_storage.y_height2 = yheight;
    yheight2 = yheight;
} else this_box_storage.y_height2 = yheight2;


this_box_storage.normal_vectors[0] = coords_set(0,0,1);
this_box_storage.normal_vectors[1] = coords_set(0,0,1);

// for sides with y component = 0
x_component = 2*zdepth/sqrt((xwidth-xwidth2)*(xwidth-xwidth2)+4*zdepth*zdepth);
z_component = (xwidth-xwidth2)/sqrt(4*zdepth*zdepth+(xwidth-xwidth2)*(xwidth-xwidth2));

this_box_storage.normal_vectors[2] = coords_set(x_component,0,z_component);
this_box_storage.normal_vectors[3] = coords_set(-x_component,0,z_component);

// for sides with x component = 0
y_component = 2*zdepth/sqrt((yheight-yheight2)*(yheight-yheight2)+4*zdepth*zdepth);
z_component = (yheight-yheight2)/sqrt(4*zdepth*zdepth+(yheight-yheight2)*(yheight-yheight2));

this_box_storage.normal_vectors[4] = coords_set(0,y_component,z_component);
this_box_storage.normal_vectors[5] = coords_set(0,-y_component,z_component);

this_box_volume.geometry.visualization_on = visualize;

this_box_volume.geometry.geometry_parameters.p_box_storage = &this_box_storage;

// Assign pointers to functions for intersection with the shape, checking if a point is inside the shape
if (this_box_storage.is_rectangle == 1) {
this_box_volume.geometry.intersect_function = &sample_box_intersect_simple;
this_box_volume.geometry.within_function = &r_within_box_simple;
}
else {
this_box_volume.geometry.intersect_function = &sample_box_intersect_advanced;
this_box_volume.geometry.within_function = &r_within_box_advanced;
}

this_box_volume.geometry.shell_points = &box_shell_points;
this_box_volume.geometry.mcdisplay_function = &mcdisplay_box_function;
this_box_volume.geometry.initialize_from_main_function = &initialize_box_geometry_from_main_component;
this_box_volume.geometry.process_rot_allocated = 0;

this_box_volume.geometry.copy_geometry_parameters = &allocate_box_storage_copy;

rot_copy(this_box_volume.geometry.rotation_matrix,ROT_A_CURRENT_COMP); //check how ROT_R_CURRENT_COMP would work
rot_transpose(ROT_A_CURRENT_COMP,this_box_volume.geometry.transpose_rotation_matrix);

// Initialize loggers
this_box_volume.loggers.num_elements = 0;

// packing the information into the global_geometry_element, which is then included in the global_geometry_list.
sprintf(global_geometry_element.name,NAME_CURRENT_COMP);
global_geometry_element.activation_counter = number_of_activations;
global_geometry_element.component_index = INDEX_CURRENT_COMP;
global_geometry_element.Volume = &this_box_volume; // Would be nicer if this m was a pointer, now we have the (small) data two places
add_element_to_geometry_list(&global_geometry_list,global_geometry_element);
}
#line 243233 "MACS_sample_kidney_box.c"
#undef number_of_activations
#undef mask_setting
#undef mask_string
#undef p_interact
#undef focus_r
#undef focus_xh
#undef focus_xw
#undef focus_ah
#undef focus_aw
#undef target_z
#undef target_y
#undef target_x
#undef target_index
#undef visualize
#undef yheight2
#undef xwidth2
#undef zdepth
#undef yheight
#undef xwidth
#undef priority
#undef material_string
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

  /* Initializations for component diffraction_detector_8_exit_volume. */
  SIG_MESSAGE("diffraction_detector_8_exit_volume (Init)");
#define mccompcurname  diffraction_detector_8_exit_volume
#define mccompcurtype  Union_box
#define mccompcurindex 464
#define loop_index mccdiffraction_detector_8_exit_volume_loop_index
#define this_box_volume mccdiffraction_detector_8_exit_volume_this_box_volume
#define global_geometry_element mccdiffraction_detector_8_exit_volume_global_geometry_element
#define this_box_storage mccdiffraction_detector_8_exit_volume_this_box_storage
#define material_string mccdiffraction_detector_8_exit_volume_material_string
#define priority mccdiffraction_detector_8_exit_volume_priority
#define xwidth mccdiffraction_detector_8_exit_volume_xwidth
#define yheight mccdiffraction_detector_8_exit_volume_yheight
#define zdepth mccdiffraction_detector_8_exit_volume_zdepth
#define xwidth2 mccdiffraction_detector_8_exit_volume_xwidth2
#define yheight2 mccdiffraction_detector_8_exit_volume_yheight2
#define visualize mccdiffraction_detector_8_exit_volume_visualize
#define target_index mccdiffraction_detector_8_exit_volume_target_index
#define target_x mccdiffraction_detector_8_exit_volume_target_x
#define target_y mccdiffraction_detector_8_exit_volume_target_y
#define target_z mccdiffraction_detector_8_exit_volume_target_z
#define focus_aw mccdiffraction_detector_8_exit_volume_focus_aw
#define focus_ah mccdiffraction_detector_8_exit_volume_focus_ah
#define focus_xw mccdiffraction_detector_8_exit_volume_focus_xw
#define focus_xh mccdiffraction_detector_8_exit_volume_focus_xh
#define focus_r mccdiffraction_detector_8_exit_volume_focus_r
#define p_interact mccdiffraction_detector_8_exit_volume_p_interact
#define mask_string mccdiffraction_detector_8_exit_volume_mask_string
#define mask_setting mccdiffraction_detector_8_exit_volume_mask_setting
#define number_of_activations mccdiffraction_detector_8_exit_volume_number_of_activations
#line 224 "Union_box.comp"
{
// Initializes the focusing system for this volume including input sanitation.
focus_initialize(&this_box_volume.geometry, POS_A_COMP_INDEX(INDEX_CURRENT_COMP+target_index), POS_A_CURRENT_COMP, ROT_A_CURRENT_COMP, target_index, target_x, target_y, target_z, focus_aw, focus_ah, focus_xw, focus_xh, focus_r, NAME_CURRENT_COMP);

// Input sanitation for this geometry
if (xwidth <= 0) {
  printf("\nERROR in Union_box named %s, the xwidth is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (yheight <= 0) {
  printf("\nERROR in Union_box named %s, yheight is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (zdepth <= 0) {
  printf("\nERROR in Union_box named %s, zdepth is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (xwidth2 <= 0 && xwidth2 != -1) {
  printf("\nERROR in Union_box named %s, the xwidth2 is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (yheight2 <= 0 && yheight2 != -1) {
  printf("\nERROR in Union_box named %s, yheight2 is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}

// Use sanitation
if (global_material_list.num_elements == 0) {
  printf("\nERROR: Need to define a material using Union_make_material before using a Union geometry component. \n");
  printf("       %s was defined before first use of Union_make_material.\n",NAME_CURRENT_COMP);
  exit(1);
}

this_box_volume.geometry.is_masked_volume = 0;
this_box_volume.geometry.is_exit_volume = 0;
this_box_volume.geometry.is_mask_volume = 0;
// check if the volume is a mask, if it is the material string is irelevant.
if (mask_string && strlen(mask_string) && strcmp(mask_string, "NULL") && strcmp(mask_string, "0")) {
    // A mask volume is used to limit the extend of other volumes, called the masked volumes. These are specified in the mask_string.
    // In order for a ray to enter a masked volume, it needs to be both in the region covered by that volume AND the mask volume.
    // When more than
    this_box_volume.geometry.mask_mode = 1; // Default is mask mode is ALL
    if (mask_setting && strlen(mask_setting) && strcmp(mask_setting, "NULL") && strcmp(mask_setting, "0")) {
        if (strcmp(mask_setting,"ALL") == 0 || strcmp(mask_setting,"All") == 0) this_box_volume.geometry.mask_mode = 1;
        else if (strcmp(mask_setting,"ANY") == 0 || strcmp(mask_setting,"Any") == 0) this_box_volume.geometry.mask_mode = 2;
        else {
            printf("The mask_mode of component %s is set to %s, but must be either ALL or ANY.\n",NAME_CURRENT_COMP,mask_setting);
            exit(1);
        }
    }
    
    for (loop_index=0;loop_index<global_geometry_list.num_elements;loop_index++) {
        // Add mask list
        if (1 == manual_linking_function(global_geometry_list.elements[loop_index].name,mask_string)) {
            add_element_to_int_list(&this_box_volume.geometry.mask_list,global_geometry_list.elements[loop_index].component_index);
            add_element_to_int_list(&global_geometry_list.elements[loop_index].Volume->geometry.masked_by_list,INDEX_CURRENT_COMP);
            global_geometry_list.elements[loop_index].Volume->geometry.is_masked_volume = 1;
            if (this_box_volume.geometry.mask_mode == 2)
                global_geometry_list.elements[loop_index].Volume->geometry.mask_mode = 2;
            if (this_box_volume.geometry.mask_mode == 1) {
                if (global_geometry_list.elements[loop_index].Volume->geometry.is_masked_volume == 1 && global_geometry_list.elements[loop_index].Volume->geometry.mask_mode != 2)
                    // If more than one mask is added to one volume, the ANY mode overwrites the (default) ALL mode.
                    global_geometry_list.elements[loop_index].Volume->geometry.mask_mode = 1;
            }
            
            found_geometries = 1;
        }
    }
    if (found_geometries == 0) {
        printf("The mask_string in geometry: %s did not find any of the specified volumes in the mask_string %s \n",NAME_CURRENT_COMP,mask_string);
        exit(1);
    }
    this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
    this_box_volume.p_physics->is_vacuum = 0; // Makes this volume a vacuum
    this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
    this_box_volume.p_physics->my_a = 0; // Should not be used.
    sprintf(this_box_volume.p_physics->name,"Mask");
    this_box_volume.geometry.is_mask_volume = 1;
    
    
// Read the material input, or if it lacks, use automatic linking.
} else if (material_string && strlen(material_string) && strcmp(material_string, "NULL") && strcmp(material_string, "0")) {
    // A geometry string was given, use it to determine which material
    if (0 == strcmp(material_string,"vacuum") || 0 == strcmp(material_string,"Vacuum")) {
        // One could have a global physics struct for vacuum instead of creating one for each
        this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
        this_box_volume.p_physics->is_vacuum = 1; // Makes this volume a vacuum
        this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
        this_box_volume.p_physics->my_a = 0; // Should not be used.
        sprintf(this_box_volume.p_physics->name,"Vacuum");
    } else if (0 == strcmp(material_string,"exit") || 0 == strcmp(material_string,"Exit")) {
        // One could have a global physics struct for vacuum instead of creating one for each
        this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
        this_box_volume.p_physics->is_vacuum = 1; // Makes this volume a vacuum
        this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
        this_box_volume.p_physics->my_a = 0; // Should not be used.
        this_box_volume.geometry.is_exit_volume = 1;
        sprintf(this_box_volume.p_physics->name,"Exit");
    } else {
        #ifndef MATERIAL_DETECTOR
            printf("Need to define a material before refering to it in a geometry %s.\n",NAME_CURRENT_COMP);
            exit(1);
        #endif
        for (loop_index=0;loop_index<global_material_list.num_elements;loop_index++) {
            if (0 == strcmp(material_string,global_material_list.elements[loop_index].name)) {
                this_box_volume.p_physics = global_material_list.elements[loop_index].physics;
                break;
            }
            if (loop_index == global_material_list.num_elements-1) {
            printf("\n");
            printf("ERROR: The material string \"%s\" in Union geometry \"%s\" did not match a specified material. \n",material_string,NAME_CURRENT_COMP);
            printf("       The materials available at this point (need to be defined before the geometry): \n");
            for (loop_index=0;loop_index<global_material_list.num_elements;loop_index++)
              printf("         %s\n",global_material_list.elements[loop_index].name);
            printf("\n");
            printf("       It is also possible to use one of the defualt materials avaiable: \n");
            printf("           Vacuum (for a Volume without scattering or absorption)\n");
            printf("           Exit (for a Volume where the ray exits the component if it enters)\n");
            printf("           Mask (for a Volume that masks existing volumes specified in the mask_string\n");
            exit(1);
          }
        }
    }
} else {
    // Automatic linking, simply using the last defined material.
    #ifndef MATERIAL_DETECTOR
        printf("Need to define a material before the geometry to use automatic linking %s.\n",NAME_CURRENT_COMP);
        exit(1);
    #endif
    this_box_volume.p_physics = global_material_list.elements[global_material_list.num_elements-1].physics;
}

sprintf(this_box_volume.name,NAME_CURRENT_COMP);
sprintf(this_box_volume.geometry.shape,"box");
this_box_volume.geometry.priority_value = priority;
this_box_volume.geometry.geometry_p_interact = p_interact;
// Currently the coordinates will be in absolute space.
this_box_volume.geometry.center = POS_A_CURRENT_COMP;

this_box_storage.z_depth = zdepth;
this_box_storage.x_width1 = xwidth;
this_box_storage.y_height1 = yheight;

this_box_storage.is_rectangle = 0;
if (xwidth2 < 0 && yheight2 < 0) this_box_storage.is_rectangle = 1;
if (xwidth == xwidth2 && yheight == yheight2) this_box_storage.is_rectangle = 1;

if (xwidth2 < 0) {
    this_box_storage.x_width2 = xwidth;
    xwidth2 = xwidth;
} else this_box_storage.x_width2 = xwidth2;

if (yheight2 < 0) {
    this_box_storage.y_height2 = yheight;
    yheight2 = yheight;
} else this_box_storage.y_height2 = yheight2;


this_box_storage.normal_vectors[0] = coords_set(0,0,1);
this_box_storage.normal_vectors[1] = coords_set(0,0,1);

// for sides with y component = 0
x_component = 2*zdepth/sqrt((xwidth-xwidth2)*(xwidth-xwidth2)+4*zdepth*zdepth);
z_component = (xwidth-xwidth2)/sqrt(4*zdepth*zdepth+(xwidth-xwidth2)*(xwidth-xwidth2));

this_box_storage.normal_vectors[2] = coords_set(x_component,0,z_component);
this_box_storage.normal_vectors[3] = coords_set(-x_component,0,z_component);

// for sides with x component = 0
y_component = 2*zdepth/sqrt((yheight-yheight2)*(yheight-yheight2)+4*zdepth*zdepth);
z_component = (yheight-yheight2)/sqrt(4*zdepth*zdepth+(yheight-yheight2)*(yheight-yheight2));

this_box_storage.normal_vectors[4] = coords_set(0,y_component,z_component);
this_box_storage.normal_vectors[5] = coords_set(0,-y_component,z_component);

this_box_volume.geometry.visualization_on = visualize;

this_box_volume.geometry.geometry_parameters.p_box_storage = &this_box_storage;

// Assign pointers to functions for intersection with the shape, checking if a point is inside the shape
if (this_box_storage.is_rectangle == 1) {
this_box_volume.geometry.intersect_function = &sample_box_intersect_simple;
this_box_volume.geometry.within_function = &r_within_box_simple;
}
else {
this_box_volume.geometry.intersect_function = &sample_box_intersect_advanced;
this_box_volume.geometry.within_function = &r_within_box_advanced;
}

this_box_volume.geometry.shell_points = &box_shell_points;
this_box_volume.geometry.mcdisplay_function = &mcdisplay_box_function;
this_box_volume.geometry.initialize_from_main_function = &initialize_box_geometry_from_main_component;
this_box_volume.geometry.process_rot_allocated = 0;

this_box_volume.geometry.copy_geometry_parameters = &allocate_box_storage_copy;

rot_copy(this_box_volume.geometry.rotation_matrix,ROT_A_CURRENT_COMP); //check how ROT_R_CURRENT_COMP would work
rot_transpose(ROT_A_CURRENT_COMP,this_box_volume.geometry.transpose_rotation_matrix);

// Initialize loggers
this_box_volume.loggers.num_elements = 0;

// packing the information into the global_geometry_element, which is then included in the global_geometry_list.
sprintf(global_geometry_element.name,NAME_CURRENT_COMP);
global_geometry_element.activation_counter = number_of_activations;
global_geometry_element.component_index = INDEX_CURRENT_COMP;
global_geometry_element.Volume = &this_box_volume; // Would be nicer if this m was a pointer, now we have the (small) data two places
add_element_to_geometry_list(&global_geometry_list,global_geometry_element);
}
#line 243503 "MACS_sample_kidney_box.c"
#undef number_of_activations
#undef mask_setting
#undef mask_string
#undef p_interact
#undef focus_r
#undef focus_xh
#undef focus_xw
#undef focus_ah
#undef focus_aw
#undef target_z
#undef target_y
#undef target_x
#undef target_index
#undef visualize
#undef yheight2
#undef xwidth2
#undef zdepth
#undef yheight
#undef xwidth
#undef priority
#undef material_string
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

  /* Initializations for component spec_detector_8_exit_volume. */
  SIG_MESSAGE("spec_detector_8_exit_volume (Init)");
#define mccompcurname  spec_detector_8_exit_volume
#define mccompcurtype  Union_box
#define mccompcurindex 465
#define loop_index mccspec_detector_8_exit_volume_loop_index
#define this_box_volume mccspec_detector_8_exit_volume_this_box_volume
#define global_geometry_element mccspec_detector_8_exit_volume_global_geometry_element
#define this_box_storage mccspec_detector_8_exit_volume_this_box_storage
#define material_string mccspec_detector_8_exit_volume_material_string
#define priority mccspec_detector_8_exit_volume_priority
#define xwidth mccspec_detector_8_exit_volume_xwidth
#define yheight mccspec_detector_8_exit_volume_yheight
#define zdepth mccspec_detector_8_exit_volume_zdepth
#define xwidth2 mccspec_detector_8_exit_volume_xwidth2
#define yheight2 mccspec_detector_8_exit_volume_yheight2
#define visualize mccspec_detector_8_exit_volume_visualize
#define target_index mccspec_detector_8_exit_volume_target_index
#define target_x mccspec_detector_8_exit_volume_target_x
#define target_y mccspec_detector_8_exit_volume_target_y
#define target_z mccspec_detector_8_exit_volume_target_z
#define focus_aw mccspec_detector_8_exit_volume_focus_aw
#define focus_ah mccspec_detector_8_exit_volume_focus_ah
#define focus_xw mccspec_detector_8_exit_volume_focus_xw
#define focus_xh mccspec_detector_8_exit_volume_focus_xh
#define focus_r mccspec_detector_8_exit_volume_focus_r
#define p_interact mccspec_detector_8_exit_volume_p_interact
#define mask_string mccspec_detector_8_exit_volume_mask_string
#define mask_setting mccspec_detector_8_exit_volume_mask_setting
#define number_of_activations mccspec_detector_8_exit_volume_number_of_activations
#line 224 "Union_box.comp"
{
// Initializes the focusing system for this volume including input sanitation.
focus_initialize(&this_box_volume.geometry, POS_A_COMP_INDEX(INDEX_CURRENT_COMP+target_index), POS_A_CURRENT_COMP, ROT_A_CURRENT_COMP, target_index, target_x, target_y, target_z, focus_aw, focus_ah, focus_xw, focus_xh, focus_r, NAME_CURRENT_COMP);

// Input sanitation for this geometry
if (xwidth <= 0) {
  printf("\nERROR in Union_box named %s, the xwidth is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (yheight <= 0) {
  printf("\nERROR in Union_box named %s, yheight is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (zdepth <= 0) {
  printf("\nERROR in Union_box named %s, zdepth is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (xwidth2 <= 0 && xwidth2 != -1) {
  printf("\nERROR in Union_box named %s, the xwidth2 is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (yheight2 <= 0 && yheight2 != -1) {
  printf("\nERROR in Union_box named %s, yheight2 is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}

// Use sanitation
if (global_material_list.num_elements == 0) {
  printf("\nERROR: Need to define a material using Union_make_material before using a Union geometry component. \n");
  printf("       %s was defined before first use of Union_make_material.\n",NAME_CURRENT_COMP);
  exit(1);
}

this_box_volume.geometry.is_masked_volume = 0;
this_box_volume.geometry.is_exit_volume = 0;
this_box_volume.geometry.is_mask_volume = 0;
// check if the volume is a mask, if it is the material string is irelevant.
if (mask_string && strlen(mask_string) && strcmp(mask_string, "NULL") && strcmp(mask_string, "0")) {
    // A mask volume is used to limit the extend of other volumes, called the masked volumes. These are specified in the mask_string.
    // In order for a ray to enter a masked volume, it needs to be both in the region covered by that volume AND the mask volume.
    // When more than
    this_box_volume.geometry.mask_mode = 1; // Default is mask mode is ALL
    if (mask_setting && strlen(mask_setting) && strcmp(mask_setting, "NULL") && strcmp(mask_setting, "0")) {
        if (strcmp(mask_setting,"ALL") == 0 || strcmp(mask_setting,"All") == 0) this_box_volume.geometry.mask_mode = 1;
        else if (strcmp(mask_setting,"ANY") == 0 || strcmp(mask_setting,"Any") == 0) this_box_volume.geometry.mask_mode = 2;
        else {
            printf("The mask_mode of component %s is set to %s, but must be either ALL or ANY.\n",NAME_CURRENT_COMP,mask_setting);
            exit(1);
        }
    }
    
    for (loop_index=0;loop_index<global_geometry_list.num_elements;loop_index++) {
        // Add mask list
        if (1 == manual_linking_function(global_geometry_list.elements[loop_index].name,mask_string)) {
            add_element_to_int_list(&this_box_volume.geometry.mask_list,global_geometry_list.elements[loop_index].component_index);
            add_element_to_int_list(&global_geometry_list.elements[loop_index].Volume->geometry.masked_by_list,INDEX_CURRENT_COMP);
            global_geometry_list.elements[loop_index].Volume->geometry.is_masked_volume = 1;
            if (this_box_volume.geometry.mask_mode == 2)
                global_geometry_list.elements[loop_index].Volume->geometry.mask_mode = 2;
            if (this_box_volume.geometry.mask_mode == 1) {
                if (global_geometry_list.elements[loop_index].Volume->geometry.is_masked_volume == 1 && global_geometry_list.elements[loop_index].Volume->geometry.mask_mode != 2)
                    // If more than one mask is added to one volume, the ANY mode overwrites the (default) ALL mode.
                    global_geometry_list.elements[loop_index].Volume->geometry.mask_mode = 1;
            }
            
            found_geometries = 1;
        }
    }
    if (found_geometries == 0) {
        printf("The mask_string in geometry: %s did not find any of the specified volumes in the mask_string %s \n",NAME_CURRENT_COMP,mask_string);
        exit(1);
    }
    this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
    this_box_volume.p_physics->is_vacuum = 0; // Makes this volume a vacuum
    this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
    this_box_volume.p_physics->my_a = 0; // Should not be used.
    sprintf(this_box_volume.p_physics->name,"Mask");
    this_box_volume.geometry.is_mask_volume = 1;
    
    
// Read the material input, or if it lacks, use automatic linking.
} else if (material_string && strlen(material_string) && strcmp(material_string, "NULL") && strcmp(material_string, "0")) {
    // A geometry string was given, use it to determine which material
    if (0 == strcmp(material_string,"vacuum") || 0 == strcmp(material_string,"Vacuum")) {
        // One could have a global physics struct for vacuum instead of creating one for each
        this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
        this_box_volume.p_physics->is_vacuum = 1; // Makes this volume a vacuum
        this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
        this_box_volume.p_physics->my_a = 0; // Should not be used.
        sprintf(this_box_volume.p_physics->name,"Vacuum");
    } else if (0 == strcmp(material_string,"exit") || 0 == strcmp(material_string,"Exit")) {
        // One could have a global physics struct for vacuum instead of creating one for each
        this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
        this_box_volume.p_physics->is_vacuum = 1; // Makes this volume a vacuum
        this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
        this_box_volume.p_physics->my_a = 0; // Should not be used.
        this_box_volume.geometry.is_exit_volume = 1;
        sprintf(this_box_volume.p_physics->name,"Exit");
    } else {
        #ifndef MATERIAL_DETECTOR
            printf("Need to define a material before refering to it in a geometry %s.\n",NAME_CURRENT_COMP);
            exit(1);
        #endif
        for (loop_index=0;loop_index<global_material_list.num_elements;loop_index++) {
            if (0 == strcmp(material_string,global_material_list.elements[loop_index].name)) {
                this_box_volume.p_physics = global_material_list.elements[loop_index].physics;
                break;
            }
            if (loop_index == global_material_list.num_elements-1) {
            printf("\n");
            printf("ERROR: The material string \"%s\" in Union geometry \"%s\" did not match a specified material. \n",material_string,NAME_CURRENT_COMP);
            printf("       The materials available at this point (need to be defined before the geometry): \n");
            for (loop_index=0;loop_index<global_material_list.num_elements;loop_index++)
              printf("         %s\n",global_material_list.elements[loop_index].name);
            printf("\n");
            printf("       It is also possible to use one of the defualt materials avaiable: \n");
            printf("           Vacuum (for a Volume without scattering or absorption)\n");
            printf("           Exit (for a Volume where the ray exits the component if it enters)\n");
            printf("           Mask (for a Volume that masks existing volumes specified in the mask_string\n");
            exit(1);
          }
        }
    }
} else {
    // Automatic linking, simply using the last defined material.
    #ifndef MATERIAL_DETECTOR
        printf("Need to define a material before the geometry to use automatic linking %s.\n",NAME_CURRENT_COMP);
        exit(1);
    #endif
    this_box_volume.p_physics = global_material_list.elements[global_material_list.num_elements-1].physics;
}

sprintf(this_box_volume.name,NAME_CURRENT_COMP);
sprintf(this_box_volume.geometry.shape,"box");
this_box_volume.geometry.priority_value = priority;
this_box_volume.geometry.geometry_p_interact = p_interact;
// Currently the coordinates will be in absolute space.
this_box_volume.geometry.center = POS_A_CURRENT_COMP;

this_box_storage.z_depth = zdepth;
this_box_storage.x_width1 = xwidth;
this_box_storage.y_height1 = yheight;

this_box_storage.is_rectangle = 0;
if (xwidth2 < 0 && yheight2 < 0) this_box_storage.is_rectangle = 1;
if (xwidth == xwidth2 && yheight == yheight2) this_box_storage.is_rectangle = 1;

if (xwidth2 < 0) {
    this_box_storage.x_width2 = xwidth;
    xwidth2 = xwidth;
} else this_box_storage.x_width2 = xwidth2;

if (yheight2 < 0) {
    this_box_storage.y_height2 = yheight;
    yheight2 = yheight;
} else this_box_storage.y_height2 = yheight2;


this_box_storage.normal_vectors[0] = coords_set(0,0,1);
this_box_storage.normal_vectors[1] = coords_set(0,0,1);

// for sides with y component = 0
x_component = 2*zdepth/sqrt((xwidth-xwidth2)*(xwidth-xwidth2)+4*zdepth*zdepth);
z_component = (xwidth-xwidth2)/sqrt(4*zdepth*zdepth+(xwidth-xwidth2)*(xwidth-xwidth2));

this_box_storage.normal_vectors[2] = coords_set(x_component,0,z_component);
this_box_storage.normal_vectors[3] = coords_set(-x_component,0,z_component);

// for sides with x component = 0
y_component = 2*zdepth/sqrt((yheight-yheight2)*(yheight-yheight2)+4*zdepth*zdepth);
z_component = (yheight-yheight2)/sqrt(4*zdepth*zdepth+(yheight-yheight2)*(yheight-yheight2));

this_box_storage.normal_vectors[4] = coords_set(0,y_component,z_component);
this_box_storage.normal_vectors[5] = coords_set(0,-y_component,z_component);

this_box_volume.geometry.visualization_on = visualize;

this_box_volume.geometry.geometry_parameters.p_box_storage = &this_box_storage;

// Assign pointers to functions for intersection with the shape, checking if a point is inside the shape
if (this_box_storage.is_rectangle == 1) {
this_box_volume.geometry.intersect_function = &sample_box_intersect_simple;
this_box_volume.geometry.within_function = &r_within_box_simple;
}
else {
this_box_volume.geometry.intersect_function = &sample_box_intersect_advanced;
this_box_volume.geometry.within_function = &r_within_box_advanced;
}

this_box_volume.geometry.shell_points = &box_shell_points;
this_box_volume.geometry.mcdisplay_function = &mcdisplay_box_function;
this_box_volume.geometry.initialize_from_main_function = &initialize_box_geometry_from_main_component;
this_box_volume.geometry.process_rot_allocated = 0;

this_box_volume.geometry.copy_geometry_parameters = &allocate_box_storage_copy;

rot_copy(this_box_volume.geometry.rotation_matrix,ROT_A_CURRENT_COMP); //check how ROT_R_CURRENT_COMP would work
rot_transpose(ROT_A_CURRENT_COMP,this_box_volume.geometry.transpose_rotation_matrix);

// Initialize loggers
this_box_volume.loggers.num_elements = 0;

// packing the information into the global_geometry_element, which is then included in the global_geometry_list.
sprintf(global_geometry_element.name,NAME_CURRENT_COMP);
global_geometry_element.activation_counter = number_of_activations;
global_geometry_element.component_index = INDEX_CURRENT_COMP;
global_geometry_element.Volume = &this_box_volume; // Would be nicer if this m was a pointer, now we have the (small) data two places
add_element_to_geometry_list(&global_geometry_list,global_geometry_element);
}
#line 243773 "MACS_sample_kidney_box.c"
#undef number_of_activations
#undef mask_setting
#undef mask_string
#undef p_interact
#undef focus_r
#undef focus_xh
#undef focus_xw
#undef focus_ah
#undef focus_aw
#undef target_z
#undef target_y
#undef target_x
#undef target_index
#undef visualize
#undef yheight2
#undef xwidth2
#undef zdepth
#undef yheight
#undef xwidth
#undef priority
#undef material_string
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

  /* Initializations for component channel_9_cave1_box1. */
  SIG_MESSAGE("channel_9_cave1_box1 (Init)");
#define mccompcurname  channel_9_cave1_box1
#define mccompcurtype  Union_box
#define mccompcurindex 466
#define loop_index mccchannel_9_cave1_box1_loop_index
#define this_box_volume mccchannel_9_cave1_box1_this_box_volume
#define global_geometry_element mccchannel_9_cave1_box1_global_geometry_element
#define this_box_storage mccchannel_9_cave1_box1_this_box_storage
#define material_string mccchannel_9_cave1_box1_material_string
#define priority mccchannel_9_cave1_box1_priority
#define xwidth mccchannel_9_cave1_box1_xwidth
#define yheight mccchannel_9_cave1_box1_yheight
#define zdepth mccchannel_9_cave1_box1_zdepth
#define xwidth2 mccchannel_9_cave1_box1_xwidth2
#define yheight2 mccchannel_9_cave1_box1_yheight2
#define visualize mccchannel_9_cave1_box1_visualize
#define target_index mccchannel_9_cave1_box1_target_index
#define target_x mccchannel_9_cave1_box1_target_x
#define target_y mccchannel_9_cave1_box1_target_y
#define target_z mccchannel_9_cave1_box1_target_z
#define focus_aw mccchannel_9_cave1_box1_focus_aw
#define focus_ah mccchannel_9_cave1_box1_focus_ah
#define focus_xw mccchannel_9_cave1_box1_focus_xw
#define focus_xh mccchannel_9_cave1_box1_focus_xh
#define focus_r mccchannel_9_cave1_box1_focus_r
#define p_interact mccchannel_9_cave1_box1_p_interact
#define mask_string mccchannel_9_cave1_box1_mask_string
#define mask_setting mccchannel_9_cave1_box1_mask_setting
#define number_of_activations mccchannel_9_cave1_box1_number_of_activations
#line 224 "Union_box.comp"
{
// Initializes the focusing system for this volume including input sanitation.
focus_initialize(&this_box_volume.geometry, POS_A_COMP_INDEX(INDEX_CURRENT_COMP+target_index), POS_A_CURRENT_COMP, ROT_A_CURRENT_COMP, target_index, target_x, target_y, target_z, focus_aw, focus_ah, focus_xw, focus_xh, focus_r, NAME_CURRENT_COMP);

// Input sanitation for this geometry
if (xwidth <= 0) {
  printf("\nERROR in Union_box named %s, the xwidth is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (yheight <= 0) {
  printf("\nERROR in Union_box named %s, yheight is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (zdepth <= 0) {
  printf("\nERROR in Union_box named %s, zdepth is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (xwidth2 <= 0 && xwidth2 != -1) {
  printf("\nERROR in Union_box named %s, the xwidth2 is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (yheight2 <= 0 && yheight2 != -1) {
  printf("\nERROR in Union_box named %s, yheight2 is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}

// Use sanitation
if (global_material_list.num_elements == 0) {
  printf("\nERROR: Need to define a material using Union_make_material before using a Union geometry component. \n");
  printf("       %s was defined before first use of Union_make_material.\n",NAME_CURRENT_COMP);
  exit(1);
}

this_box_volume.geometry.is_masked_volume = 0;
this_box_volume.geometry.is_exit_volume = 0;
this_box_volume.geometry.is_mask_volume = 0;
// check if the volume is a mask, if it is the material string is irelevant.
if (mask_string && strlen(mask_string) && strcmp(mask_string, "NULL") && strcmp(mask_string, "0")) {
    // A mask volume is used to limit the extend of other volumes, called the masked volumes. These are specified in the mask_string.
    // In order for a ray to enter a masked volume, it needs to be both in the region covered by that volume AND the mask volume.
    // When more than
    this_box_volume.geometry.mask_mode = 1; // Default is mask mode is ALL
    if (mask_setting && strlen(mask_setting) && strcmp(mask_setting, "NULL") && strcmp(mask_setting, "0")) {
        if (strcmp(mask_setting,"ALL") == 0 || strcmp(mask_setting,"All") == 0) this_box_volume.geometry.mask_mode = 1;
        else if (strcmp(mask_setting,"ANY") == 0 || strcmp(mask_setting,"Any") == 0) this_box_volume.geometry.mask_mode = 2;
        else {
            printf("The mask_mode of component %s is set to %s, but must be either ALL or ANY.\n",NAME_CURRENT_COMP,mask_setting);
            exit(1);
        }
    }
    
    for (loop_index=0;loop_index<global_geometry_list.num_elements;loop_index++) {
        // Add mask list
        if (1 == manual_linking_function(global_geometry_list.elements[loop_index].name,mask_string)) {
            add_element_to_int_list(&this_box_volume.geometry.mask_list,global_geometry_list.elements[loop_index].component_index);
            add_element_to_int_list(&global_geometry_list.elements[loop_index].Volume->geometry.masked_by_list,INDEX_CURRENT_COMP);
            global_geometry_list.elements[loop_index].Volume->geometry.is_masked_volume = 1;
            if (this_box_volume.geometry.mask_mode == 2)
                global_geometry_list.elements[loop_index].Volume->geometry.mask_mode = 2;
            if (this_box_volume.geometry.mask_mode == 1) {
                if (global_geometry_list.elements[loop_index].Volume->geometry.is_masked_volume == 1 && global_geometry_list.elements[loop_index].Volume->geometry.mask_mode != 2)
                    // If more than one mask is added to one volume, the ANY mode overwrites the (default) ALL mode.
                    global_geometry_list.elements[loop_index].Volume->geometry.mask_mode = 1;
            }
            
            found_geometries = 1;
        }
    }
    if (found_geometries == 0) {
        printf("The mask_string in geometry: %s did not find any of the specified volumes in the mask_string %s \n",NAME_CURRENT_COMP,mask_string);
        exit(1);
    }
    this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
    this_box_volume.p_physics->is_vacuum = 0; // Makes this volume a vacuum
    this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
    this_box_volume.p_physics->my_a = 0; // Should not be used.
    sprintf(this_box_volume.p_physics->name,"Mask");
    this_box_volume.geometry.is_mask_volume = 1;
    
    
// Read the material input, or if it lacks, use automatic linking.
} else if (material_string && strlen(material_string) && strcmp(material_string, "NULL") && strcmp(material_string, "0")) {
    // A geometry string was given, use it to determine which material
    if (0 == strcmp(material_string,"vacuum") || 0 == strcmp(material_string,"Vacuum")) {
        // One could have a global physics struct for vacuum instead of creating one for each
        this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
        this_box_volume.p_physics->is_vacuum = 1; // Makes this volume a vacuum
        this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
        this_box_volume.p_physics->my_a = 0; // Should not be used.
        sprintf(this_box_volume.p_physics->name,"Vacuum");
    } else if (0 == strcmp(material_string,"exit") || 0 == strcmp(material_string,"Exit")) {
        // One could have a global physics struct for vacuum instead of creating one for each
        this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
        this_box_volume.p_physics->is_vacuum = 1; // Makes this volume a vacuum
        this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
        this_box_volume.p_physics->my_a = 0; // Should not be used.
        this_box_volume.geometry.is_exit_volume = 1;
        sprintf(this_box_volume.p_physics->name,"Exit");
    } else {
        #ifndef MATERIAL_DETECTOR
            printf("Need to define a material before refering to it in a geometry %s.\n",NAME_CURRENT_COMP);
            exit(1);
        #endif
        for (loop_index=0;loop_index<global_material_list.num_elements;loop_index++) {
            if (0 == strcmp(material_string,global_material_list.elements[loop_index].name)) {
                this_box_volume.p_physics = global_material_list.elements[loop_index].physics;
                break;
            }
            if (loop_index == global_material_list.num_elements-1) {
            printf("\n");
            printf("ERROR: The material string \"%s\" in Union geometry \"%s\" did not match a specified material. \n",material_string,NAME_CURRENT_COMP);
            printf("       The materials available at this point (need to be defined before the geometry): \n");
            for (loop_index=0;loop_index<global_material_list.num_elements;loop_index++)
              printf("         %s\n",global_material_list.elements[loop_index].name);
            printf("\n");
            printf("       It is also possible to use one of the defualt materials avaiable: \n");
            printf("           Vacuum (for a Volume without scattering or absorption)\n");
            printf("           Exit (for a Volume where the ray exits the component if it enters)\n");
            printf("           Mask (for a Volume that masks existing volumes specified in the mask_string\n");
            exit(1);
          }
        }
    }
} else {
    // Automatic linking, simply using the last defined material.
    #ifndef MATERIAL_DETECTOR
        printf("Need to define a material before the geometry to use automatic linking %s.\n",NAME_CURRENT_COMP);
        exit(1);
    #endif
    this_box_volume.p_physics = global_material_list.elements[global_material_list.num_elements-1].physics;
}

sprintf(this_box_volume.name,NAME_CURRENT_COMP);
sprintf(this_box_volume.geometry.shape,"box");
this_box_volume.geometry.priority_value = priority;
this_box_volume.geometry.geometry_p_interact = p_interact;
// Currently the coordinates will be in absolute space.
this_box_volume.geometry.center = POS_A_CURRENT_COMP;

this_box_storage.z_depth = zdepth;
this_box_storage.x_width1 = xwidth;
this_box_storage.y_height1 = yheight;

this_box_storage.is_rectangle = 0;
if (xwidth2 < 0 && yheight2 < 0) this_box_storage.is_rectangle = 1;
if (xwidth == xwidth2 && yheight == yheight2) this_box_storage.is_rectangle = 1;

if (xwidth2 < 0) {
    this_box_storage.x_width2 = xwidth;
    xwidth2 = xwidth;
} else this_box_storage.x_width2 = xwidth2;

if (yheight2 < 0) {
    this_box_storage.y_height2 = yheight;
    yheight2 = yheight;
} else this_box_storage.y_height2 = yheight2;


this_box_storage.normal_vectors[0] = coords_set(0,0,1);
this_box_storage.normal_vectors[1] = coords_set(0,0,1);

// for sides with y component = 0
x_component = 2*zdepth/sqrt((xwidth-xwidth2)*(xwidth-xwidth2)+4*zdepth*zdepth);
z_component = (xwidth-xwidth2)/sqrt(4*zdepth*zdepth+(xwidth-xwidth2)*(xwidth-xwidth2));

this_box_storage.normal_vectors[2] = coords_set(x_component,0,z_component);
this_box_storage.normal_vectors[3] = coords_set(-x_component,0,z_component);

// for sides with x component = 0
y_component = 2*zdepth/sqrt((yheight-yheight2)*(yheight-yheight2)+4*zdepth*zdepth);
z_component = (yheight-yheight2)/sqrt(4*zdepth*zdepth+(yheight-yheight2)*(yheight-yheight2));

this_box_storage.normal_vectors[4] = coords_set(0,y_component,z_component);
this_box_storage.normal_vectors[5] = coords_set(0,-y_component,z_component);

this_box_volume.geometry.visualization_on = visualize;

this_box_volume.geometry.geometry_parameters.p_box_storage = &this_box_storage;

// Assign pointers to functions for intersection with the shape, checking if a point is inside the shape
if (this_box_storage.is_rectangle == 1) {
this_box_volume.geometry.intersect_function = &sample_box_intersect_simple;
this_box_volume.geometry.within_function = &r_within_box_simple;
}
else {
this_box_volume.geometry.intersect_function = &sample_box_intersect_advanced;
this_box_volume.geometry.within_function = &r_within_box_advanced;
}

this_box_volume.geometry.shell_points = &box_shell_points;
this_box_volume.geometry.mcdisplay_function = &mcdisplay_box_function;
this_box_volume.geometry.initialize_from_main_function = &initialize_box_geometry_from_main_component;
this_box_volume.geometry.process_rot_allocated = 0;

this_box_volume.geometry.copy_geometry_parameters = &allocate_box_storage_copy;

rot_copy(this_box_volume.geometry.rotation_matrix,ROT_A_CURRENT_COMP); //check how ROT_R_CURRENT_COMP would work
rot_transpose(ROT_A_CURRENT_COMP,this_box_volume.geometry.transpose_rotation_matrix);

// Initialize loggers
this_box_volume.loggers.num_elements = 0;

// packing the information into the global_geometry_element, which is then included in the global_geometry_list.
sprintf(global_geometry_element.name,NAME_CURRENT_COMP);
global_geometry_element.activation_counter = number_of_activations;
global_geometry_element.component_index = INDEX_CURRENT_COMP;
global_geometry_element.Volume = &this_box_volume; // Would be nicer if this m was a pointer, now we have the (small) data two places
add_element_to_geometry_list(&global_geometry_list,global_geometry_element);
}
#line 244043 "MACS_sample_kidney_box.c"
#undef number_of_activations
#undef mask_setting
#undef mask_string
#undef p_interact
#undef focus_r
#undef focus_xh
#undef focus_xw
#undef focus_ah
#undef focus_aw
#undef target_z
#undef target_y
#undef target_x
#undef target_index
#undef visualize
#undef yheight2
#undef xwidth2
#undef zdepth
#undef yheight
#undef xwidth
#undef priority
#undef material_string
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

  /* Initializations for component channel_9_cave1_box2. */
  SIG_MESSAGE("channel_9_cave1_box2 (Init)");
#define mccompcurname  channel_9_cave1_box2
#define mccompcurtype  Union_box
#define mccompcurindex 467
#define loop_index mccchannel_9_cave1_box2_loop_index
#define this_box_volume mccchannel_9_cave1_box2_this_box_volume
#define global_geometry_element mccchannel_9_cave1_box2_global_geometry_element
#define this_box_storage mccchannel_9_cave1_box2_this_box_storage
#define material_string mccchannel_9_cave1_box2_material_string
#define priority mccchannel_9_cave1_box2_priority
#define xwidth mccchannel_9_cave1_box2_xwidth
#define yheight mccchannel_9_cave1_box2_yheight
#define zdepth mccchannel_9_cave1_box2_zdepth
#define xwidth2 mccchannel_9_cave1_box2_xwidth2
#define yheight2 mccchannel_9_cave1_box2_yheight2
#define visualize mccchannel_9_cave1_box2_visualize
#define target_index mccchannel_9_cave1_box2_target_index
#define target_x mccchannel_9_cave1_box2_target_x
#define target_y mccchannel_9_cave1_box2_target_y
#define target_z mccchannel_9_cave1_box2_target_z
#define focus_aw mccchannel_9_cave1_box2_focus_aw
#define focus_ah mccchannel_9_cave1_box2_focus_ah
#define focus_xw mccchannel_9_cave1_box2_focus_xw
#define focus_xh mccchannel_9_cave1_box2_focus_xh
#define focus_r mccchannel_9_cave1_box2_focus_r
#define p_interact mccchannel_9_cave1_box2_p_interact
#define mask_string mccchannel_9_cave1_box2_mask_string
#define mask_setting mccchannel_9_cave1_box2_mask_setting
#define number_of_activations mccchannel_9_cave1_box2_number_of_activations
#line 224 "Union_box.comp"
{
// Initializes the focusing system for this volume including input sanitation.
focus_initialize(&this_box_volume.geometry, POS_A_COMP_INDEX(INDEX_CURRENT_COMP+target_index), POS_A_CURRENT_COMP, ROT_A_CURRENT_COMP, target_index, target_x, target_y, target_z, focus_aw, focus_ah, focus_xw, focus_xh, focus_r, NAME_CURRENT_COMP);

// Input sanitation for this geometry
if (xwidth <= 0) {
  printf("\nERROR in Union_box named %s, the xwidth is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (yheight <= 0) {
  printf("\nERROR in Union_box named %s, yheight is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (zdepth <= 0) {
  printf("\nERROR in Union_box named %s, zdepth is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (xwidth2 <= 0 && xwidth2 != -1) {
  printf("\nERROR in Union_box named %s, the xwidth2 is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (yheight2 <= 0 && yheight2 != -1) {
  printf("\nERROR in Union_box named %s, yheight2 is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}

// Use sanitation
if (global_material_list.num_elements == 0) {
  printf("\nERROR: Need to define a material using Union_make_material before using a Union geometry component. \n");
  printf("       %s was defined before first use of Union_make_material.\n",NAME_CURRENT_COMP);
  exit(1);
}

this_box_volume.geometry.is_masked_volume = 0;
this_box_volume.geometry.is_exit_volume = 0;
this_box_volume.geometry.is_mask_volume = 0;
// check if the volume is a mask, if it is the material string is irelevant.
if (mask_string && strlen(mask_string) && strcmp(mask_string, "NULL") && strcmp(mask_string, "0")) {
    // A mask volume is used to limit the extend of other volumes, called the masked volumes. These are specified in the mask_string.
    // In order for a ray to enter a masked volume, it needs to be both in the region covered by that volume AND the mask volume.
    // When more than
    this_box_volume.geometry.mask_mode = 1; // Default is mask mode is ALL
    if (mask_setting && strlen(mask_setting) && strcmp(mask_setting, "NULL") && strcmp(mask_setting, "0")) {
        if (strcmp(mask_setting,"ALL") == 0 || strcmp(mask_setting,"All") == 0) this_box_volume.geometry.mask_mode = 1;
        else if (strcmp(mask_setting,"ANY") == 0 || strcmp(mask_setting,"Any") == 0) this_box_volume.geometry.mask_mode = 2;
        else {
            printf("The mask_mode of component %s is set to %s, but must be either ALL or ANY.\n",NAME_CURRENT_COMP,mask_setting);
            exit(1);
        }
    }
    
    for (loop_index=0;loop_index<global_geometry_list.num_elements;loop_index++) {
        // Add mask list
        if (1 == manual_linking_function(global_geometry_list.elements[loop_index].name,mask_string)) {
            add_element_to_int_list(&this_box_volume.geometry.mask_list,global_geometry_list.elements[loop_index].component_index);
            add_element_to_int_list(&global_geometry_list.elements[loop_index].Volume->geometry.masked_by_list,INDEX_CURRENT_COMP);
            global_geometry_list.elements[loop_index].Volume->geometry.is_masked_volume = 1;
            if (this_box_volume.geometry.mask_mode == 2)
                global_geometry_list.elements[loop_index].Volume->geometry.mask_mode = 2;
            if (this_box_volume.geometry.mask_mode == 1) {
                if (global_geometry_list.elements[loop_index].Volume->geometry.is_masked_volume == 1 && global_geometry_list.elements[loop_index].Volume->geometry.mask_mode != 2)
                    // If more than one mask is added to one volume, the ANY mode overwrites the (default) ALL mode.
                    global_geometry_list.elements[loop_index].Volume->geometry.mask_mode = 1;
            }
            
            found_geometries = 1;
        }
    }
    if (found_geometries == 0) {
        printf("The mask_string in geometry: %s did not find any of the specified volumes in the mask_string %s \n",NAME_CURRENT_COMP,mask_string);
        exit(1);
    }
    this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
    this_box_volume.p_physics->is_vacuum = 0; // Makes this volume a vacuum
    this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
    this_box_volume.p_physics->my_a = 0; // Should not be used.
    sprintf(this_box_volume.p_physics->name,"Mask");
    this_box_volume.geometry.is_mask_volume = 1;
    
    
// Read the material input, or if it lacks, use automatic linking.
} else if (material_string && strlen(material_string) && strcmp(material_string, "NULL") && strcmp(material_string, "0")) {
    // A geometry string was given, use it to determine which material
    if (0 == strcmp(material_string,"vacuum") || 0 == strcmp(material_string,"Vacuum")) {
        // One could have a global physics struct for vacuum instead of creating one for each
        this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
        this_box_volume.p_physics->is_vacuum = 1; // Makes this volume a vacuum
        this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
        this_box_volume.p_physics->my_a = 0; // Should not be used.
        sprintf(this_box_volume.p_physics->name,"Vacuum");
    } else if (0 == strcmp(material_string,"exit") || 0 == strcmp(material_string,"Exit")) {
        // One could have a global physics struct for vacuum instead of creating one for each
        this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
        this_box_volume.p_physics->is_vacuum = 1; // Makes this volume a vacuum
        this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
        this_box_volume.p_physics->my_a = 0; // Should not be used.
        this_box_volume.geometry.is_exit_volume = 1;
        sprintf(this_box_volume.p_physics->name,"Exit");
    } else {
        #ifndef MATERIAL_DETECTOR
            printf("Need to define a material before refering to it in a geometry %s.\n",NAME_CURRENT_COMP);
            exit(1);
        #endif
        for (loop_index=0;loop_index<global_material_list.num_elements;loop_index++) {
            if (0 == strcmp(material_string,global_material_list.elements[loop_index].name)) {
                this_box_volume.p_physics = global_material_list.elements[loop_index].physics;
                break;
            }
            if (loop_index == global_material_list.num_elements-1) {
            printf("\n");
            printf("ERROR: The material string \"%s\" in Union geometry \"%s\" did not match a specified material. \n",material_string,NAME_CURRENT_COMP);
            printf("       The materials available at this point (need to be defined before the geometry): \n");
            for (loop_index=0;loop_index<global_material_list.num_elements;loop_index++)
              printf("         %s\n",global_material_list.elements[loop_index].name);
            printf("\n");
            printf("       It is also possible to use one of the defualt materials avaiable: \n");
            printf("           Vacuum (for a Volume without scattering or absorption)\n");
            printf("           Exit (for a Volume where the ray exits the component if it enters)\n");
            printf("           Mask (for a Volume that masks existing volumes specified in the mask_string\n");
            exit(1);
          }
        }
    }
} else {
    // Automatic linking, simply using the last defined material.
    #ifndef MATERIAL_DETECTOR
        printf("Need to define a material before the geometry to use automatic linking %s.\n",NAME_CURRENT_COMP);
        exit(1);
    #endif
    this_box_volume.p_physics = global_material_list.elements[global_material_list.num_elements-1].physics;
}

sprintf(this_box_volume.name,NAME_CURRENT_COMP);
sprintf(this_box_volume.geometry.shape,"box");
this_box_volume.geometry.priority_value = priority;
this_box_volume.geometry.geometry_p_interact = p_interact;
// Currently the coordinates will be in absolute space.
this_box_volume.geometry.center = POS_A_CURRENT_COMP;

this_box_storage.z_depth = zdepth;
this_box_storage.x_width1 = xwidth;
this_box_storage.y_height1 = yheight;

this_box_storage.is_rectangle = 0;
if (xwidth2 < 0 && yheight2 < 0) this_box_storage.is_rectangle = 1;
if (xwidth == xwidth2 && yheight == yheight2) this_box_storage.is_rectangle = 1;

if (xwidth2 < 0) {
    this_box_storage.x_width2 = xwidth;
    xwidth2 = xwidth;
} else this_box_storage.x_width2 = xwidth2;

if (yheight2 < 0) {
    this_box_storage.y_height2 = yheight;
    yheight2 = yheight;
} else this_box_storage.y_height2 = yheight2;


this_box_storage.normal_vectors[0] = coords_set(0,0,1);
this_box_storage.normal_vectors[1] = coords_set(0,0,1);

// for sides with y component = 0
x_component = 2*zdepth/sqrt((xwidth-xwidth2)*(xwidth-xwidth2)+4*zdepth*zdepth);
z_component = (xwidth-xwidth2)/sqrt(4*zdepth*zdepth+(xwidth-xwidth2)*(xwidth-xwidth2));

this_box_storage.normal_vectors[2] = coords_set(x_component,0,z_component);
this_box_storage.normal_vectors[3] = coords_set(-x_component,0,z_component);

// for sides with x component = 0
y_component = 2*zdepth/sqrt((yheight-yheight2)*(yheight-yheight2)+4*zdepth*zdepth);
z_component = (yheight-yheight2)/sqrt(4*zdepth*zdepth+(yheight-yheight2)*(yheight-yheight2));

this_box_storage.normal_vectors[4] = coords_set(0,y_component,z_component);
this_box_storage.normal_vectors[5] = coords_set(0,-y_component,z_component);

this_box_volume.geometry.visualization_on = visualize;

this_box_volume.geometry.geometry_parameters.p_box_storage = &this_box_storage;

// Assign pointers to functions for intersection with the shape, checking if a point is inside the shape
if (this_box_storage.is_rectangle == 1) {
this_box_volume.geometry.intersect_function = &sample_box_intersect_simple;
this_box_volume.geometry.within_function = &r_within_box_simple;
}
else {
this_box_volume.geometry.intersect_function = &sample_box_intersect_advanced;
this_box_volume.geometry.within_function = &r_within_box_advanced;
}

this_box_volume.geometry.shell_points = &box_shell_points;
this_box_volume.geometry.mcdisplay_function = &mcdisplay_box_function;
this_box_volume.geometry.initialize_from_main_function = &initialize_box_geometry_from_main_component;
this_box_volume.geometry.process_rot_allocated = 0;

this_box_volume.geometry.copy_geometry_parameters = &allocate_box_storage_copy;

rot_copy(this_box_volume.geometry.rotation_matrix,ROT_A_CURRENT_COMP); //check how ROT_R_CURRENT_COMP would work
rot_transpose(ROT_A_CURRENT_COMP,this_box_volume.geometry.transpose_rotation_matrix);

// Initialize loggers
this_box_volume.loggers.num_elements = 0;

// packing the information into the global_geometry_element, which is then included in the global_geometry_list.
sprintf(global_geometry_element.name,NAME_CURRENT_COMP);
global_geometry_element.activation_counter = number_of_activations;
global_geometry_element.component_index = INDEX_CURRENT_COMP;
global_geometry_element.Volume = &this_box_volume; // Would be nicer if this m was a pointer, now we have the (small) data two places
add_element_to_geometry_list(&global_geometry_list,global_geometry_element);
}
#line 244313 "MACS_sample_kidney_box.c"
#undef number_of_activations
#undef mask_setting
#undef mask_string
#undef p_interact
#undef focus_r
#undef focus_xh
#undef focus_xw
#undef focus_ah
#undef focus_aw
#undef target_z
#undef target_y
#undef target_x
#undef target_index
#undef visualize
#undef yheight2
#undef xwidth2
#undef zdepth
#undef yheight
#undef xwidth
#undef priority
#undef material_string
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

  /* Initializations for component channel_9_cave1_box3. */
  SIG_MESSAGE("channel_9_cave1_box3 (Init)");
#define mccompcurname  channel_9_cave1_box3
#define mccompcurtype  Union_box
#define mccompcurindex 468
#define loop_index mccchannel_9_cave1_box3_loop_index
#define this_box_volume mccchannel_9_cave1_box3_this_box_volume
#define global_geometry_element mccchannel_9_cave1_box3_global_geometry_element
#define this_box_storage mccchannel_9_cave1_box3_this_box_storage
#define material_string mccchannel_9_cave1_box3_material_string
#define priority mccchannel_9_cave1_box3_priority
#define xwidth mccchannel_9_cave1_box3_xwidth
#define yheight mccchannel_9_cave1_box3_yheight
#define zdepth mccchannel_9_cave1_box3_zdepth
#define xwidth2 mccchannel_9_cave1_box3_xwidth2
#define yheight2 mccchannel_9_cave1_box3_yheight2
#define visualize mccchannel_9_cave1_box3_visualize
#define target_index mccchannel_9_cave1_box3_target_index
#define target_x mccchannel_9_cave1_box3_target_x
#define target_y mccchannel_9_cave1_box3_target_y
#define target_z mccchannel_9_cave1_box3_target_z
#define focus_aw mccchannel_9_cave1_box3_focus_aw
#define focus_ah mccchannel_9_cave1_box3_focus_ah
#define focus_xw mccchannel_9_cave1_box3_focus_xw
#define focus_xh mccchannel_9_cave1_box3_focus_xh
#define focus_r mccchannel_9_cave1_box3_focus_r
#define p_interact mccchannel_9_cave1_box3_p_interact
#define mask_string mccchannel_9_cave1_box3_mask_string
#define mask_setting mccchannel_9_cave1_box3_mask_setting
#define number_of_activations mccchannel_9_cave1_box3_number_of_activations
#line 224 "Union_box.comp"
{
// Initializes the focusing system for this volume including input sanitation.
focus_initialize(&this_box_volume.geometry, POS_A_COMP_INDEX(INDEX_CURRENT_COMP+target_index), POS_A_CURRENT_COMP, ROT_A_CURRENT_COMP, target_index, target_x, target_y, target_z, focus_aw, focus_ah, focus_xw, focus_xh, focus_r, NAME_CURRENT_COMP);

// Input sanitation for this geometry
if (xwidth <= 0) {
  printf("\nERROR in Union_box named %s, the xwidth is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (yheight <= 0) {
  printf("\nERROR in Union_box named %s, yheight is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (zdepth <= 0) {
  printf("\nERROR in Union_box named %s, zdepth is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (xwidth2 <= 0 && xwidth2 != -1) {
  printf("\nERROR in Union_box named %s, the xwidth2 is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (yheight2 <= 0 && yheight2 != -1) {
  printf("\nERROR in Union_box named %s, yheight2 is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}

// Use sanitation
if (global_material_list.num_elements == 0) {
  printf("\nERROR: Need to define a material using Union_make_material before using a Union geometry component. \n");
  printf("       %s was defined before first use of Union_make_material.\n",NAME_CURRENT_COMP);
  exit(1);
}

this_box_volume.geometry.is_masked_volume = 0;
this_box_volume.geometry.is_exit_volume = 0;
this_box_volume.geometry.is_mask_volume = 0;
// check if the volume is a mask, if it is the material string is irelevant.
if (mask_string && strlen(mask_string) && strcmp(mask_string, "NULL") && strcmp(mask_string, "0")) {
    // A mask volume is used to limit the extend of other volumes, called the masked volumes. These are specified in the mask_string.
    // In order for a ray to enter a masked volume, it needs to be both in the region covered by that volume AND the mask volume.
    // When more than
    this_box_volume.geometry.mask_mode = 1; // Default is mask mode is ALL
    if (mask_setting && strlen(mask_setting) && strcmp(mask_setting, "NULL") && strcmp(mask_setting, "0")) {
        if (strcmp(mask_setting,"ALL") == 0 || strcmp(mask_setting,"All") == 0) this_box_volume.geometry.mask_mode = 1;
        else if (strcmp(mask_setting,"ANY") == 0 || strcmp(mask_setting,"Any") == 0) this_box_volume.geometry.mask_mode = 2;
        else {
            printf("The mask_mode of component %s is set to %s, but must be either ALL or ANY.\n",NAME_CURRENT_COMP,mask_setting);
            exit(1);
        }
    }
    
    for (loop_index=0;loop_index<global_geometry_list.num_elements;loop_index++) {
        // Add mask list
        if (1 == manual_linking_function(global_geometry_list.elements[loop_index].name,mask_string)) {
            add_element_to_int_list(&this_box_volume.geometry.mask_list,global_geometry_list.elements[loop_index].component_index);
            add_element_to_int_list(&global_geometry_list.elements[loop_index].Volume->geometry.masked_by_list,INDEX_CURRENT_COMP);
            global_geometry_list.elements[loop_index].Volume->geometry.is_masked_volume = 1;
            if (this_box_volume.geometry.mask_mode == 2)
                global_geometry_list.elements[loop_index].Volume->geometry.mask_mode = 2;
            if (this_box_volume.geometry.mask_mode == 1) {
                if (global_geometry_list.elements[loop_index].Volume->geometry.is_masked_volume == 1 && global_geometry_list.elements[loop_index].Volume->geometry.mask_mode != 2)
                    // If more than one mask is added to one volume, the ANY mode overwrites the (default) ALL mode.
                    global_geometry_list.elements[loop_index].Volume->geometry.mask_mode = 1;
            }
            
            found_geometries = 1;
        }
    }
    if (found_geometries == 0) {
        printf("The mask_string in geometry: %s did not find any of the specified volumes in the mask_string %s \n",NAME_CURRENT_COMP,mask_string);
        exit(1);
    }
    this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
    this_box_volume.p_physics->is_vacuum = 0; // Makes this volume a vacuum
    this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
    this_box_volume.p_physics->my_a = 0; // Should not be used.
    sprintf(this_box_volume.p_physics->name,"Mask");
    this_box_volume.geometry.is_mask_volume = 1;
    
    
// Read the material input, or if it lacks, use automatic linking.
} else if (material_string && strlen(material_string) && strcmp(material_string, "NULL") && strcmp(material_string, "0")) {
    // A geometry string was given, use it to determine which material
    if (0 == strcmp(material_string,"vacuum") || 0 == strcmp(material_string,"Vacuum")) {
        // One could have a global physics struct for vacuum instead of creating one for each
        this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
        this_box_volume.p_physics->is_vacuum = 1; // Makes this volume a vacuum
        this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
        this_box_volume.p_physics->my_a = 0; // Should not be used.
        sprintf(this_box_volume.p_physics->name,"Vacuum");
    } else if (0 == strcmp(material_string,"exit") || 0 == strcmp(material_string,"Exit")) {
        // One could have a global physics struct for vacuum instead of creating one for each
        this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
        this_box_volume.p_physics->is_vacuum = 1; // Makes this volume a vacuum
        this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
        this_box_volume.p_physics->my_a = 0; // Should not be used.
        this_box_volume.geometry.is_exit_volume = 1;
        sprintf(this_box_volume.p_physics->name,"Exit");
    } else {
        #ifndef MATERIAL_DETECTOR
            printf("Need to define a material before refering to it in a geometry %s.\n",NAME_CURRENT_COMP);
            exit(1);
        #endif
        for (loop_index=0;loop_index<global_material_list.num_elements;loop_index++) {
            if (0 == strcmp(material_string,global_material_list.elements[loop_index].name)) {
                this_box_volume.p_physics = global_material_list.elements[loop_index].physics;
                break;
            }
            if (loop_index == global_material_list.num_elements-1) {
            printf("\n");
            printf("ERROR: The material string \"%s\" in Union geometry \"%s\" did not match a specified material. \n",material_string,NAME_CURRENT_COMP);
            printf("       The materials available at this point (need to be defined before the geometry): \n");
            for (loop_index=0;loop_index<global_material_list.num_elements;loop_index++)
              printf("         %s\n",global_material_list.elements[loop_index].name);
            printf("\n");
            printf("       It is also possible to use one of the defualt materials avaiable: \n");
            printf("           Vacuum (for a Volume without scattering or absorption)\n");
            printf("           Exit (for a Volume where the ray exits the component if it enters)\n");
            printf("           Mask (for a Volume that masks existing volumes specified in the mask_string\n");
            exit(1);
          }
        }
    }
} else {
    // Automatic linking, simply using the last defined material.
    #ifndef MATERIAL_DETECTOR
        printf("Need to define a material before the geometry to use automatic linking %s.\n",NAME_CURRENT_COMP);
        exit(1);
    #endif
    this_box_volume.p_physics = global_material_list.elements[global_material_list.num_elements-1].physics;
}

sprintf(this_box_volume.name,NAME_CURRENT_COMP);
sprintf(this_box_volume.geometry.shape,"box");
this_box_volume.geometry.priority_value = priority;
this_box_volume.geometry.geometry_p_interact = p_interact;
// Currently the coordinates will be in absolute space.
this_box_volume.geometry.center = POS_A_CURRENT_COMP;

this_box_storage.z_depth = zdepth;
this_box_storage.x_width1 = xwidth;
this_box_storage.y_height1 = yheight;

this_box_storage.is_rectangle = 0;
if (xwidth2 < 0 && yheight2 < 0) this_box_storage.is_rectangle = 1;
if (xwidth == xwidth2 && yheight == yheight2) this_box_storage.is_rectangle = 1;

if (xwidth2 < 0) {
    this_box_storage.x_width2 = xwidth;
    xwidth2 = xwidth;
} else this_box_storage.x_width2 = xwidth2;

if (yheight2 < 0) {
    this_box_storage.y_height2 = yheight;
    yheight2 = yheight;
} else this_box_storage.y_height2 = yheight2;


this_box_storage.normal_vectors[0] = coords_set(0,0,1);
this_box_storage.normal_vectors[1] = coords_set(0,0,1);

// for sides with y component = 0
x_component = 2*zdepth/sqrt((xwidth-xwidth2)*(xwidth-xwidth2)+4*zdepth*zdepth);
z_component = (xwidth-xwidth2)/sqrt(4*zdepth*zdepth+(xwidth-xwidth2)*(xwidth-xwidth2));

this_box_storage.normal_vectors[2] = coords_set(x_component,0,z_component);
this_box_storage.normal_vectors[3] = coords_set(-x_component,0,z_component);

// for sides with x component = 0
y_component = 2*zdepth/sqrt((yheight-yheight2)*(yheight-yheight2)+4*zdepth*zdepth);
z_component = (yheight-yheight2)/sqrt(4*zdepth*zdepth+(yheight-yheight2)*(yheight-yheight2));

this_box_storage.normal_vectors[4] = coords_set(0,y_component,z_component);
this_box_storage.normal_vectors[5] = coords_set(0,-y_component,z_component);

this_box_volume.geometry.visualization_on = visualize;

this_box_volume.geometry.geometry_parameters.p_box_storage = &this_box_storage;

// Assign pointers to functions for intersection with the shape, checking if a point is inside the shape
if (this_box_storage.is_rectangle == 1) {
this_box_volume.geometry.intersect_function = &sample_box_intersect_simple;
this_box_volume.geometry.within_function = &r_within_box_simple;
}
else {
this_box_volume.geometry.intersect_function = &sample_box_intersect_advanced;
this_box_volume.geometry.within_function = &r_within_box_advanced;
}

this_box_volume.geometry.shell_points = &box_shell_points;
this_box_volume.geometry.mcdisplay_function = &mcdisplay_box_function;
this_box_volume.geometry.initialize_from_main_function = &initialize_box_geometry_from_main_component;
this_box_volume.geometry.process_rot_allocated = 0;

this_box_volume.geometry.copy_geometry_parameters = &allocate_box_storage_copy;

rot_copy(this_box_volume.geometry.rotation_matrix,ROT_A_CURRENT_COMP); //check how ROT_R_CURRENT_COMP would work
rot_transpose(ROT_A_CURRENT_COMP,this_box_volume.geometry.transpose_rotation_matrix);

// Initialize loggers
this_box_volume.loggers.num_elements = 0;

// packing the information into the global_geometry_element, which is then included in the global_geometry_list.
sprintf(global_geometry_element.name,NAME_CURRENT_COMP);
global_geometry_element.activation_counter = number_of_activations;
global_geometry_element.component_index = INDEX_CURRENT_COMP;
global_geometry_element.Volume = &this_box_volume; // Would be nicer if this m was a pointer, now we have the (small) data two places
add_element_to_geometry_list(&global_geometry_list,global_geometry_element);
}
#line 244583 "MACS_sample_kidney_box.c"
#undef number_of_activations
#undef mask_setting
#undef mask_string
#undef p_interact
#undef focus_r
#undef focus_xh
#undef focus_xw
#undef focus_ah
#undef focus_aw
#undef target_z
#undef target_y
#undef target_x
#undef target_index
#undef visualize
#undef yheight2
#undef xwidth2
#undef zdepth
#undef yheight
#undef xwidth
#undef priority
#undef material_string
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

  /* Initializations for component channel_9_cave1_cyl1. */
  SIG_MESSAGE("channel_9_cave1_cyl1 (Init)");
#define mccompcurname  channel_9_cave1_cyl1
#define mccompcurtype  Union_cylinder
#define mccompcurindex 469
#define loop_index mccchannel_9_cave1_cyl1_loop_index
#define this_cylinder_volume mccchannel_9_cave1_cyl1_this_cylinder_volume
#define global_geometry_element mccchannel_9_cave1_cyl1_global_geometry_element
#define this_cylinder_storage mccchannel_9_cave1_cyl1_this_cylinder_storage
#define material_string mccchannel_9_cave1_cyl1_material_string
#define priority mccchannel_9_cave1_cyl1_priority
#define radius mccchannel_9_cave1_cyl1_radius
#define yheight mccchannel_9_cave1_cyl1_yheight
#define visualize mccchannel_9_cave1_cyl1_visualize
#define target_index mccchannel_9_cave1_cyl1_target_index
#define target_x mccchannel_9_cave1_cyl1_target_x
#define target_y mccchannel_9_cave1_cyl1_target_y
#define target_z mccchannel_9_cave1_cyl1_target_z
#define focus_aw mccchannel_9_cave1_cyl1_focus_aw
#define focus_ah mccchannel_9_cave1_cyl1_focus_ah
#define focus_xw mccchannel_9_cave1_cyl1_focus_xw
#define focus_xh mccchannel_9_cave1_cyl1_focus_xh
#define focus_r mccchannel_9_cave1_cyl1_focus_r
#define p_interact mccchannel_9_cave1_cyl1_p_interact
#define mask_string mccchannel_9_cave1_cyl1_mask_string
#define mask_setting mccchannel_9_cave1_cyl1_mask_setting
#define number_of_activations mccchannel_9_cave1_cyl1_number_of_activations
#line 185 "Union_cylinder.comp"
{
// Initializes the focusing system for this volume including input sanitation.
focus_initialize(&this_cylinder_volume.geometry, POS_A_COMP_INDEX(INDEX_CURRENT_COMP+target_index), POS_A_CURRENT_COMP, ROT_A_CURRENT_COMP, target_index, target_x, target_y, target_z, focus_aw, focus_ah, focus_xw, focus_xh, focus_r, NAME_CURRENT_COMP);

// Input sanitation for this geometry
if (radius <= 0) {
  printf("\nERROR in Union_cylinder named %s, the radius is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}

if (yheight <= 0) {
  printf("\nERROR in Union_cylinder named %s, yheight is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}

// Use sanitation
#ifdef MATERIAL_DETECTOR
if (global_material_list.num_elements == 0) {
  // Here if the user have defined a material, but only after this material
  printf("\nERROR: Need to define a material using Union_make_material before using a Union geometry component. \n");
  printf("       %s was defined before first use of Union_make_material.\n",NAME_CURRENT_COMP);
  exit(1);
}
#endif
#ifndef MATERIAL_DETECTOR
  printf("\nERROR: Need to define a material using Union_make_material before using a Union geometry component. \n");
  exit(1);
#endif


this_cylinder_volume.geometry.is_masked_volume = 0;
this_cylinder_volume.geometry.is_exit_volume = 0;
this_cylinder_volume.geometry.is_mask_volume = 0;

// Read the material input, or if it lacks, use automatic linking.
if (mask_string && strlen(mask_string) && strcmp(mask_string, "NULL") && strcmp(mask_string, "0")) {
    // A mask volume is used to limit the extend of other volumes, called the masked volumes. These are specified in the mask_string.
    // In order for a ray to enter a masked volume, it needs to be both in the region covered by that volume AND the mask volume.
    // When more than
    this_cylinder_volume.geometry.mask_mode = 1; // Default is mask mode is ALL
    if (mask_setting && strlen(mask_setting) && strcmp(mask_setting, "NULL") && strcmp(mask_setting, "0")) {
        if (strcmp(mask_setting,"ALL") == 0 || strcmp(mask_setting,"All") == 0) this_cylinder_volume.geometry.mask_mode = 1;
        else if (strcmp(mask_setting,"ANY") == 0 || strcmp(mask_setting,"Any") == 0) this_cylinder_volume.geometry.mask_mode = 2;
        else {
            printf("The mask_mode of component %s is set to %s, but must be either ALL or ANY.\n",NAME_CURRENT_COMP,mask_setting);
            exit(1);
        }
    }
    
    for (loop_index=0;loop_index<global_geometry_list.num_elements;loop_index++) {
        // Add mask list
        if (1 == manual_linking_function(global_geometry_list.elements[loop_index].name,mask_string)) {
            add_element_to_int_list(&this_cylinder_volume.geometry.mask_list,global_geometry_list.elements[loop_index].component_index);
            add_element_to_int_list(&global_geometry_list.elements[loop_index].Volume->geometry.masked_by_list,INDEX_CURRENT_COMP);
            global_geometry_list.elements[loop_index].Volume->geometry.is_masked_volume = 1;
            if (this_cylinder_volume.geometry.mask_mode == 2)
                global_geometry_list.elements[loop_index].Volume->geometry.mask_mode = 2;
            if (this_cylinder_volume.geometry.mask_mode == 1) {
                if (global_geometry_list.elements[loop_index].Volume->geometry.is_masked_volume == 1 && global_geometry_list.elements[loop_index].Volume->geometry.mask_mode != 2)
                    // If more than one mask is added to one volume, the ANY mode overwrites the (default) ALL mode.
                    global_geometry_list.elements[loop_index].Volume->geometry.mask_mode = 1;
            }
            
            found_geometries = 1;
        }
    }
    if (found_geometries == 0) {
        printf("The mask_string in geometry: %s did not find any of the specified volumes in the mask_string %s \n",NAME_CURRENT_COMP,mask_string);
        exit(1);
    }
    this_cylinder_volume.p_physics = malloc(sizeof(struct physics_struct));
    this_cylinder_volume.p_physics->is_vacuum = 0; // Makes this volume a vacuum
    this_cylinder_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
    this_cylinder_volume.p_physics->my_a = 0; // Should not be used.
    sprintf(this_cylinder_volume.p_physics->name,"Mask");
    this_cylinder_volume.geometry.is_mask_volume = 1;
    
    
// Read the material input, or if it lacks, use automatic linking.
} else if (material_string && strlen(material_string) && strcmp(material_string, "NULL") && strcmp(material_string, "0")) {
    // A geometry string was given, use it to determine which material
    if (0 == strcmp(material_string,"vacuum") || 0 == strcmp(material_string,"Vacuum")) {
        // One could have a global physics struct for vacuum instead of creating one for each
        this_cylinder_volume.p_physics = malloc(sizeof(struct physics_struct));
        this_cylinder_volume.p_physics->is_vacuum = 1; // Makes this volume a vacuum
        this_cylinder_volume.p_physics->number_of_processes = (int) 0;
        this_cylinder_volume.p_physics->my_a = 0; // Should not be used.
        sprintf(this_cylinder_volume.p_physics->name,"Vacuum");
    } else if (0 == strcmp(material_string,"exit") || 0 == strcmp(material_string,"Exit")) {
        // One could have a global physics struct for exit instead of creating one for each
        this_cylinder_volume.p_physics = malloc(sizeof(struct physics_struct));
        this_cylinder_volume.p_physics->is_vacuum = 1; // Makes this volume a vacuum
        this_cylinder_volume.p_physics->number_of_processes = (int) 0;
        this_cylinder_volume.p_physics->my_a = 0; // Should not be used.
        this_cylinder_volume.geometry.is_exit_volume = 1;
        sprintf(this_cylinder_volume.p_physics->name,"Exit");
    } else {
        for (loop_index=0;loop_index<global_material_list.num_elements;loop_index++) {
          if (0 == strcmp(material_string,global_material_list.elements[loop_index].name)) {
            this_cylinder_volume.p_physics = global_material_list.elements[loop_index].physics;
            break;
          }
          if (loop_index == global_material_list.num_elements-1) {
            printf("\n");
            printf("ERROR: The material string \"%s\" in Union geometry \"%s\" did not match a specified material. \n",material_string,NAME_CURRENT_COMP);
            printf("       The materials available at this point (need to be defined before the geometry): \n");
            for (loop_index=0;loop_index<global_material_list.num_elements;loop_index++)
              printf("         %s\n",global_material_list.elements[loop_index].name);
            printf("\n");
            printf("       It is also possible to use one of the defualt materials avaiable: \n");
            printf("           Vacuum (for a Volume without scattering or absorption)\n");
            printf("           Exit (for a Volume where the ray exits the component if it enters)\n");
            printf("           Mask (for a Volume that masks existing volumes specified in the mask_string\n");
            exit(1);
          }
        }
    }
} else {
    // Automatic linking, simply using the last defined material.
    #ifndef MATERIAL_DETECTOR
        printf("Need to define a material before the geometry to use automatic linking %s.\n",NAME_CURRENT_COMP);
        exit(1);
    #endif
    this_cylinder_volume.p_physics = global_material_list.elements[global_material_list.num_elements-1].physics;
}

sprintf(this_cylinder_volume.name,NAME_CURRENT_COMP);
sprintf(this_cylinder_volume.geometry.shape,"cylinder");
this_cylinder_volume.geometry.priority_value = priority;
// Currently the coordinates will be in absolute space.
this_cylinder_volume.geometry.center = POS_A_CURRENT_COMP;

this_cylinder_volume.geometry.geometry_p_interact = p_interact;
this_cylinder_storage.cyl_radius = radius;
this_cylinder_storage.height = yheight;
this_cylinder_volume.geometry.visualization_on = visualize;
this_cylinder_volume.geometry.geometry_parameters.p_cylinder_storage = &this_cylinder_storage;
this_cylinder_volume.geometry.within_function = &r_within_cylinder;
this_cylinder_volume.geometry.intersect_function = &sample_cylinder_intersect;
this_cylinder_volume.geometry.mcdisplay_function = &mcdisplay_cylinder_function;
this_cylinder_volume.geometry.shell_points = &cylinder_shell_points;
this_cylinder_volume.geometry.initialize_from_main_function = &initialize_cylinder_geometry_from_main_component;
this_cylinder_volume.geometry.process_rot_allocated = 0;
this_cylinder_volume.geometry.copy_geometry_parameters = &allocate_cylinder_storage_copy;

rot_copy(this_cylinder_volume.geometry.rotation_matrix,ROT_A_CURRENT_COMP);
rot_transpose(ROT_A_CURRENT_COMP,this_cylinder_volume.geometry.transpose_rotation_matrix);

// Initialize loggers
this_cylinder_volume.loggers.num_elements = 0;

// packing the information into the global_geometry_element, which is then included in the global_geometry_list.
sprintf(global_geometry_element.name,NAME_CURRENT_COMP);
global_geometry_element.activation_counter = number_of_activations;
global_geometry_element.component_index = INDEX_CURRENT_COMP;
global_geometry_element.Volume = &this_cylinder_volume; // Would be nicer if this m was a pointer, now we have the (small) data two places
add_element_to_geometry_list(&global_geometry_list,global_geometry_element);
}
#line 244799 "MACS_sample_kidney_box.c"
#undef number_of_activations
#undef mask_setting
#undef mask_string
#undef p_interact
#undef focus_r
#undef focus_xh
#undef focus_xw
#undef focus_ah
#undef focus_aw
#undef target_z
#undef target_y
#undef target_x
#undef target_index
#undef visualize
#undef yheight
#undef radius
#undef priority
#undef material_string
#undef this_cylinder_storage
#undef global_geometry_element
#undef this_cylinder_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

  /* Initializations for component channel_9_analyzer_1_center. */
  SIG_MESSAGE("channel_9_analyzer_1_center (Init)");

  /* Initializations for component channel_9_analyzer_1_rotated. */
  SIG_MESSAGE("channel_9_analyzer_1_rotated (Init)");

  /* Initializations for component channel_9_analyzer_1_array_crystal_array_0. */
  SIG_MESSAGE("channel_9_analyzer_1_array_crystal_array_0 (Init)");
#define mccompcurname  channel_9_analyzer_1_array_crystal_array_0
#define mccompcurtype  Union_box
#define mccompcurindex 472
#define loop_index mccchannel_9_analyzer_1_array_crystal_array_0_loop_index
#define this_box_volume mccchannel_9_analyzer_1_array_crystal_array_0_this_box_volume
#define global_geometry_element mccchannel_9_analyzer_1_array_crystal_array_0_global_geometry_element
#define this_box_storage mccchannel_9_analyzer_1_array_crystal_array_0_this_box_storage
#define material_string mccchannel_9_analyzer_1_array_crystal_array_0_material_string
#define priority mccchannel_9_analyzer_1_array_crystal_array_0_priority
#define xwidth mccchannel_9_analyzer_1_array_crystal_array_0_xwidth
#define yheight mccchannel_9_analyzer_1_array_crystal_array_0_yheight
#define zdepth mccchannel_9_analyzer_1_array_crystal_array_0_zdepth
#define xwidth2 mccchannel_9_analyzer_1_array_crystal_array_0_xwidth2
#define yheight2 mccchannel_9_analyzer_1_array_crystal_array_0_yheight2
#define visualize mccchannel_9_analyzer_1_array_crystal_array_0_visualize
#define target_index mccchannel_9_analyzer_1_array_crystal_array_0_target_index
#define target_x mccchannel_9_analyzer_1_array_crystal_array_0_target_x
#define target_y mccchannel_9_analyzer_1_array_crystal_array_0_target_y
#define target_z mccchannel_9_analyzer_1_array_crystal_array_0_target_z
#define focus_aw mccchannel_9_analyzer_1_array_crystal_array_0_focus_aw
#define focus_ah mccchannel_9_analyzer_1_array_crystal_array_0_focus_ah
#define focus_xw mccchannel_9_analyzer_1_array_crystal_array_0_focus_xw
#define focus_xh mccchannel_9_analyzer_1_array_crystal_array_0_focus_xh
#define focus_r mccchannel_9_analyzer_1_array_crystal_array_0_focus_r
#define p_interact mccchannel_9_analyzer_1_array_crystal_array_0_p_interact
#define mask_string mccchannel_9_analyzer_1_array_crystal_array_0_mask_string
#define mask_setting mccchannel_9_analyzer_1_array_crystal_array_0_mask_setting
#define number_of_activations mccchannel_9_analyzer_1_array_crystal_array_0_number_of_activations
#line 224 "Union_box.comp"
{
// Initializes the focusing system for this volume including input sanitation.
focus_initialize(&this_box_volume.geometry, POS_A_COMP_INDEX(INDEX_CURRENT_COMP+target_index), POS_A_CURRENT_COMP, ROT_A_CURRENT_COMP, target_index, target_x, target_y, target_z, focus_aw, focus_ah, focus_xw, focus_xh, focus_r, NAME_CURRENT_COMP);

// Input sanitation for this geometry
if (xwidth <= 0) {
  printf("\nERROR in Union_box named %s, the xwidth is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (yheight <= 0) {
  printf("\nERROR in Union_box named %s, yheight is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (zdepth <= 0) {
  printf("\nERROR in Union_box named %s, zdepth is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (xwidth2 <= 0 && xwidth2 != -1) {
  printf("\nERROR in Union_box named %s, the xwidth2 is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (yheight2 <= 0 && yheight2 != -1) {
  printf("\nERROR in Union_box named %s, yheight2 is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}

// Use sanitation
if (global_material_list.num_elements == 0) {
  printf("\nERROR: Need to define a material using Union_make_material before using a Union geometry component. \n");
  printf("       %s was defined before first use of Union_make_material.\n",NAME_CURRENT_COMP);
  exit(1);
}

this_box_volume.geometry.is_masked_volume = 0;
this_box_volume.geometry.is_exit_volume = 0;
this_box_volume.geometry.is_mask_volume = 0;
// check if the volume is a mask, if it is the material string is irelevant.
if (mask_string && strlen(mask_string) && strcmp(mask_string, "NULL") && strcmp(mask_string, "0")) {
    // A mask volume is used to limit the extend of other volumes, called the masked volumes. These are specified in the mask_string.
    // In order for a ray to enter a masked volume, it needs to be both in the region covered by that volume AND the mask volume.
    // When more than
    this_box_volume.geometry.mask_mode = 1; // Default is mask mode is ALL
    if (mask_setting && strlen(mask_setting) && strcmp(mask_setting, "NULL") && strcmp(mask_setting, "0")) {
        if (strcmp(mask_setting,"ALL") == 0 || strcmp(mask_setting,"All") == 0) this_box_volume.geometry.mask_mode = 1;
        else if (strcmp(mask_setting,"ANY") == 0 || strcmp(mask_setting,"Any") == 0) this_box_volume.geometry.mask_mode = 2;
        else {
            printf("The mask_mode of component %s is set to %s, but must be either ALL or ANY.\n",NAME_CURRENT_COMP,mask_setting);
            exit(1);
        }
    }
    
    for (loop_index=0;loop_index<global_geometry_list.num_elements;loop_index++) {
        // Add mask list
        if (1 == manual_linking_function(global_geometry_list.elements[loop_index].name,mask_string)) {
            add_element_to_int_list(&this_box_volume.geometry.mask_list,global_geometry_list.elements[loop_index].component_index);
            add_element_to_int_list(&global_geometry_list.elements[loop_index].Volume->geometry.masked_by_list,INDEX_CURRENT_COMP);
            global_geometry_list.elements[loop_index].Volume->geometry.is_masked_volume = 1;
            if (this_box_volume.geometry.mask_mode == 2)
                global_geometry_list.elements[loop_index].Volume->geometry.mask_mode = 2;
            if (this_box_volume.geometry.mask_mode == 1) {
                if (global_geometry_list.elements[loop_index].Volume->geometry.is_masked_volume == 1 && global_geometry_list.elements[loop_index].Volume->geometry.mask_mode != 2)
                    // If more than one mask is added to one volume, the ANY mode overwrites the (default) ALL mode.
                    global_geometry_list.elements[loop_index].Volume->geometry.mask_mode = 1;
            }
            
            found_geometries = 1;
        }
    }
    if (found_geometries == 0) {
        printf("The mask_string in geometry: %s did not find any of the specified volumes in the mask_string %s \n",NAME_CURRENT_COMP,mask_string);
        exit(1);
    }
    this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
    this_box_volume.p_physics->is_vacuum = 0; // Makes this volume a vacuum
    this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
    this_box_volume.p_physics->my_a = 0; // Should not be used.
    sprintf(this_box_volume.p_physics->name,"Mask");
    this_box_volume.geometry.is_mask_volume = 1;
    
    
// Read the material input, or if it lacks, use automatic linking.
} else if (material_string && strlen(material_string) && strcmp(material_string, "NULL") && strcmp(material_string, "0")) {
    // A geometry string was given, use it to determine which material
    if (0 == strcmp(material_string,"vacuum") || 0 == strcmp(material_string,"Vacuum")) {
        // One could have a global physics struct for vacuum instead of creating one for each
        this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
        this_box_volume.p_physics->is_vacuum = 1; // Makes this volume a vacuum
        this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
        this_box_volume.p_physics->my_a = 0; // Should not be used.
        sprintf(this_box_volume.p_physics->name,"Vacuum");
    } else if (0 == strcmp(material_string,"exit") || 0 == strcmp(material_string,"Exit")) {
        // One could have a global physics struct for vacuum instead of creating one for each
        this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
        this_box_volume.p_physics->is_vacuum = 1; // Makes this volume a vacuum
        this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
        this_box_volume.p_physics->my_a = 0; // Should not be used.
        this_box_volume.geometry.is_exit_volume = 1;
        sprintf(this_box_volume.p_physics->name,"Exit");
    } else {
        #ifndef MATERIAL_DETECTOR
            printf("Need to define a material before refering to it in a geometry %s.\n",NAME_CURRENT_COMP);
            exit(1);
        #endif
        for (loop_index=0;loop_index<global_material_list.num_elements;loop_index++) {
            if (0 == strcmp(material_string,global_material_list.elements[loop_index].name)) {
                this_box_volume.p_physics = global_material_list.elements[loop_index].physics;
                break;
            }
            if (loop_index == global_material_list.num_elements-1) {
            printf("\n");
            printf("ERROR: The material string \"%s\" in Union geometry \"%s\" did not match a specified material. \n",material_string,NAME_CURRENT_COMP);
            printf("       The materials available at this point (need to be defined before the geometry): \n");
            for (loop_index=0;loop_index<global_material_list.num_elements;loop_index++)
              printf("         %s\n",global_material_list.elements[loop_index].name);
            printf("\n");
            printf("       It is also possible to use one of the defualt materials avaiable: \n");
            printf("           Vacuum (for a Volume without scattering or absorption)\n");
            printf("           Exit (for a Volume where the ray exits the component if it enters)\n");
            printf("           Mask (for a Volume that masks existing volumes specified in the mask_string\n");
            exit(1);
          }
        }
    }
} else {
    // Automatic linking, simply using the last defined material.
    #ifndef MATERIAL_DETECTOR
        printf("Need to define a material before the geometry to use automatic linking %s.\n",NAME_CURRENT_COMP);
        exit(1);
    #endif
    this_box_volume.p_physics = global_material_list.elements[global_material_list.num_elements-1].physics;
}

sprintf(this_box_volume.name,NAME_CURRENT_COMP);
sprintf(this_box_volume.geometry.shape,"box");
this_box_volume.geometry.priority_value = priority;
this_box_volume.geometry.geometry_p_interact = p_interact;
// Currently the coordinates will be in absolute space.
this_box_volume.geometry.center = POS_A_CURRENT_COMP;

this_box_storage.z_depth = zdepth;
this_box_storage.x_width1 = xwidth;
this_box_storage.y_height1 = yheight;

this_box_storage.is_rectangle = 0;
if (xwidth2 < 0 && yheight2 < 0) this_box_storage.is_rectangle = 1;
if (xwidth == xwidth2 && yheight == yheight2) this_box_storage.is_rectangle = 1;

if (xwidth2 < 0) {
    this_box_storage.x_width2 = xwidth;
    xwidth2 = xwidth;
} else this_box_storage.x_width2 = xwidth2;

if (yheight2 < 0) {
    this_box_storage.y_height2 = yheight;
    yheight2 = yheight;
} else this_box_storage.y_height2 = yheight2;


this_box_storage.normal_vectors[0] = coords_set(0,0,1);
this_box_storage.normal_vectors[1] = coords_set(0,0,1);

// for sides with y component = 0
x_component = 2*zdepth/sqrt((xwidth-xwidth2)*(xwidth-xwidth2)+4*zdepth*zdepth);
z_component = (xwidth-xwidth2)/sqrt(4*zdepth*zdepth+(xwidth-xwidth2)*(xwidth-xwidth2));

this_box_storage.normal_vectors[2] = coords_set(x_component,0,z_component);
this_box_storage.normal_vectors[3] = coords_set(-x_component,0,z_component);

// for sides with x component = 0
y_component = 2*zdepth/sqrt((yheight-yheight2)*(yheight-yheight2)+4*zdepth*zdepth);
z_component = (yheight-yheight2)/sqrt(4*zdepth*zdepth+(yheight-yheight2)*(yheight-yheight2));

this_box_storage.normal_vectors[4] = coords_set(0,y_component,z_component);
this_box_storage.normal_vectors[5] = coords_set(0,-y_component,z_component);

this_box_volume.geometry.visualization_on = visualize;

this_box_volume.geometry.geometry_parameters.p_box_storage = &this_box_storage;

// Assign pointers to functions for intersection with the shape, checking if a point is inside the shape
if (this_box_storage.is_rectangle == 1) {
this_box_volume.geometry.intersect_function = &sample_box_intersect_simple;
this_box_volume.geometry.within_function = &r_within_box_simple;
}
else {
this_box_volume.geometry.intersect_function = &sample_box_intersect_advanced;
this_box_volume.geometry.within_function = &r_within_box_advanced;
}

this_box_volume.geometry.shell_points = &box_shell_points;
this_box_volume.geometry.mcdisplay_function = &mcdisplay_box_function;
this_box_volume.geometry.initialize_from_main_function = &initialize_box_geometry_from_main_component;
this_box_volume.geometry.process_rot_allocated = 0;

this_box_volume.geometry.copy_geometry_parameters = &allocate_box_storage_copy;

rot_copy(this_box_volume.geometry.rotation_matrix,ROT_A_CURRENT_COMP); //check how ROT_R_CURRENT_COMP would work
rot_transpose(ROT_A_CURRENT_COMP,this_box_volume.geometry.transpose_rotation_matrix);

// Initialize loggers
this_box_volume.loggers.num_elements = 0;

// packing the information into the global_geometry_element, which is then included in the global_geometry_list.
sprintf(global_geometry_element.name,NAME_CURRENT_COMP);
global_geometry_element.activation_counter = number_of_activations;
global_geometry_element.component_index = INDEX_CURRENT_COMP;
global_geometry_element.Volume = &this_box_volume; // Would be nicer if this m was a pointer, now we have the (small) data two places
add_element_to_geometry_list(&global_geometry_list,global_geometry_element);
}
#line 245072 "MACS_sample_kidney_box.c"
#undef number_of_activations
#undef mask_setting
#undef mask_string
#undef p_interact
#undef focus_r
#undef focus_xh
#undef focus_xw
#undef focus_ah
#undef focus_aw
#undef target_z
#undef target_y
#undef target_x
#undef target_index
#undef visualize
#undef yheight2
#undef xwidth2
#undef zdepth
#undef yheight
#undef xwidth
#undef priority
#undef material_string
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

  /* Initializations for component channel_9_analyzer_1_array_crystal_array_1. */
  SIG_MESSAGE("channel_9_analyzer_1_array_crystal_array_1 (Init)");
#define mccompcurname  channel_9_analyzer_1_array_crystal_array_1
#define mccompcurtype  Union_box
#define mccompcurindex 473
#define loop_index mccchannel_9_analyzer_1_array_crystal_array_1_loop_index
#define this_box_volume mccchannel_9_analyzer_1_array_crystal_array_1_this_box_volume
#define global_geometry_element mccchannel_9_analyzer_1_array_crystal_array_1_global_geometry_element
#define this_box_storage mccchannel_9_analyzer_1_array_crystal_array_1_this_box_storage
#define material_string mccchannel_9_analyzer_1_array_crystal_array_1_material_string
#define priority mccchannel_9_analyzer_1_array_crystal_array_1_priority
#define xwidth mccchannel_9_analyzer_1_array_crystal_array_1_xwidth
#define yheight mccchannel_9_analyzer_1_array_crystal_array_1_yheight
#define zdepth mccchannel_9_analyzer_1_array_crystal_array_1_zdepth
#define xwidth2 mccchannel_9_analyzer_1_array_crystal_array_1_xwidth2
#define yheight2 mccchannel_9_analyzer_1_array_crystal_array_1_yheight2
#define visualize mccchannel_9_analyzer_1_array_crystal_array_1_visualize
#define target_index mccchannel_9_analyzer_1_array_crystal_array_1_target_index
#define target_x mccchannel_9_analyzer_1_array_crystal_array_1_target_x
#define target_y mccchannel_9_analyzer_1_array_crystal_array_1_target_y
#define target_z mccchannel_9_analyzer_1_array_crystal_array_1_target_z
#define focus_aw mccchannel_9_analyzer_1_array_crystal_array_1_focus_aw
#define focus_ah mccchannel_9_analyzer_1_array_crystal_array_1_focus_ah
#define focus_xw mccchannel_9_analyzer_1_array_crystal_array_1_focus_xw
#define focus_xh mccchannel_9_analyzer_1_array_crystal_array_1_focus_xh
#define focus_r mccchannel_9_analyzer_1_array_crystal_array_1_focus_r
#define p_interact mccchannel_9_analyzer_1_array_crystal_array_1_p_interact
#define mask_string mccchannel_9_analyzer_1_array_crystal_array_1_mask_string
#define mask_setting mccchannel_9_analyzer_1_array_crystal_array_1_mask_setting
#define number_of_activations mccchannel_9_analyzer_1_array_crystal_array_1_number_of_activations
#line 224 "Union_box.comp"
{
// Initializes the focusing system for this volume including input sanitation.
focus_initialize(&this_box_volume.geometry, POS_A_COMP_INDEX(INDEX_CURRENT_COMP+target_index), POS_A_CURRENT_COMP, ROT_A_CURRENT_COMP, target_index, target_x, target_y, target_z, focus_aw, focus_ah, focus_xw, focus_xh, focus_r, NAME_CURRENT_COMP);

// Input sanitation for this geometry
if (xwidth <= 0) {
  printf("\nERROR in Union_box named %s, the xwidth is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (yheight <= 0) {
  printf("\nERROR in Union_box named %s, yheight is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (zdepth <= 0) {
  printf("\nERROR in Union_box named %s, zdepth is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (xwidth2 <= 0 && xwidth2 != -1) {
  printf("\nERROR in Union_box named %s, the xwidth2 is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (yheight2 <= 0 && yheight2 != -1) {
  printf("\nERROR in Union_box named %s, yheight2 is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}

// Use sanitation
if (global_material_list.num_elements == 0) {
  printf("\nERROR: Need to define a material using Union_make_material before using a Union geometry component. \n");
  printf("       %s was defined before first use of Union_make_material.\n",NAME_CURRENT_COMP);
  exit(1);
}

this_box_volume.geometry.is_masked_volume = 0;
this_box_volume.geometry.is_exit_volume = 0;
this_box_volume.geometry.is_mask_volume = 0;
// check if the volume is a mask, if it is the material string is irelevant.
if (mask_string && strlen(mask_string) && strcmp(mask_string, "NULL") && strcmp(mask_string, "0")) {
    // A mask volume is used to limit the extend of other volumes, called the masked volumes. These are specified in the mask_string.
    // In order for a ray to enter a masked volume, it needs to be both in the region covered by that volume AND the mask volume.
    // When more than
    this_box_volume.geometry.mask_mode = 1; // Default is mask mode is ALL
    if (mask_setting && strlen(mask_setting) && strcmp(mask_setting, "NULL") && strcmp(mask_setting, "0")) {
        if (strcmp(mask_setting,"ALL") == 0 || strcmp(mask_setting,"All") == 0) this_box_volume.geometry.mask_mode = 1;
        else if (strcmp(mask_setting,"ANY") == 0 || strcmp(mask_setting,"Any") == 0) this_box_volume.geometry.mask_mode = 2;
        else {
            printf("The mask_mode of component %s is set to %s, but must be either ALL or ANY.\n",NAME_CURRENT_COMP,mask_setting);
            exit(1);
        }
    }
    
    for (loop_index=0;loop_index<global_geometry_list.num_elements;loop_index++) {
        // Add mask list
        if (1 == manual_linking_function(global_geometry_list.elements[loop_index].name,mask_string)) {
            add_element_to_int_list(&this_box_volume.geometry.mask_list,global_geometry_list.elements[loop_index].component_index);
            add_element_to_int_list(&global_geometry_list.elements[loop_index].Volume->geometry.masked_by_list,INDEX_CURRENT_COMP);
            global_geometry_list.elements[loop_index].Volume->geometry.is_masked_volume = 1;
            if (this_box_volume.geometry.mask_mode == 2)
                global_geometry_list.elements[loop_index].Volume->geometry.mask_mode = 2;
            if (this_box_volume.geometry.mask_mode == 1) {
                if (global_geometry_list.elements[loop_index].Volume->geometry.is_masked_volume == 1 && global_geometry_list.elements[loop_index].Volume->geometry.mask_mode != 2)
                    // If more than one mask is added to one volume, the ANY mode overwrites the (default) ALL mode.
                    global_geometry_list.elements[loop_index].Volume->geometry.mask_mode = 1;
            }
            
            found_geometries = 1;
        }
    }
    if (found_geometries == 0) {
        printf("The mask_string in geometry: %s did not find any of the specified volumes in the mask_string %s \n",NAME_CURRENT_COMP,mask_string);
        exit(1);
    }
    this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
    this_box_volume.p_physics->is_vacuum = 0; // Makes this volume a vacuum
    this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
    this_box_volume.p_physics->my_a = 0; // Should not be used.
    sprintf(this_box_volume.p_physics->name,"Mask");
    this_box_volume.geometry.is_mask_volume = 1;
    
    
// Read the material input, or if it lacks, use automatic linking.
} else if (material_string && strlen(material_string) && strcmp(material_string, "NULL") && strcmp(material_string, "0")) {
    // A geometry string was given, use it to determine which material
    if (0 == strcmp(material_string,"vacuum") || 0 == strcmp(material_string,"Vacuum")) {
        // One could have a global physics struct for vacuum instead of creating one for each
        this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
        this_box_volume.p_physics->is_vacuum = 1; // Makes this volume a vacuum
        this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
        this_box_volume.p_physics->my_a = 0; // Should not be used.
        sprintf(this_box_volume.p_physics->name,"Vacuum");
    } else if (0 == strcmp(material_string,"exit") || 0 == strcmp(material_string,"Exit")) {
        // One could have a global physics struct for vacuum instead of creating one for each
        this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
        this_box_volume.p_physics->is_vacuum = 1; // Makes this volume a vacuum
        this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
        this_box_volume.p_physics->my_a = 0; // Should not be used.
        this_box_volume.geometry.is_exit_volume = 1;
        sprintf(this_box_volume.p_physics->name,"Exit");
    } else {
        #ifndef MATERIAL_DETECTOR
            printf("Need to define a material before refering to it in a geometry %s.\n",NAME_CURRENT_COMP);
            exit(1);
        #endif
        for (loop_index=0;loop_index<global_material_list.num_elements;loop_index++) {
            if (0 == strcmp(material_string,global_material_list.elements[loop_index].name)) {
                this_box_volume.p_physics = global_material_list.elements[loop_index].physics;
                break;
            }
            if (loop_index == global_material_list.num_elements-1) {
            printf("\n");
            printf("ERROR: The material string \"%s\" in Union geometry \"%s\" did not match a specified material. \n",material_string,NAME_CURRENT_COMP);
            printf("       The materials available at this point (need to be defined before the geometry): \n");
            for (loop_index=0;loop_index<global_material_list.num_elements;loop_index++)
              printf("         %s\n",global_material_list.elements[loop_index].name);
            printf("\n");
            printf("       It is also possible to use one of the defualt materials avaiable: \n");
            printf("           Vacuum (for a Volume without scattering or absorption)\n");
            printf("           Exit (for a Volume where the ray exits the component if it enters)\n");
            printf("           Mask (for a Volume that masks existing volumes specified in the mask_string\n");
            exit(1);
          }
        }
    }
} else {
    // Automatic linking, simply using the last defined material.
    #ifndef MATERIAL_DETECTOR
        printf("Need to define a material before the geometry to use automatic linking %s.\n",NAME_CURRENT_COMP);
        exit(1);
    #endif
    this_box_volume.p_physics = global_material_list.elements[global_material_list.num_elements-1].physics;
}

sprintf(this_box_volume.name,NAME_CURRENT_COMP);
sprintf(this_box_volume.geometry.shape,"box");
this_box_volume.geometry.priority_value = priority;
this_box_volume.geometry.geometry_p_interact = p_interact;
// Currently the coordinates will be in absolute space.
this_box_volume.geometry.center = POS_A_CURRENT_COMP;

this_box_storage.z_depth = zdepth;
this_box_storage.x_width1 = xwidth;
this_box_storage.y_height1 = yheight;

this_box_storage.is_rectangle = 0;
if (xwidth2 < 0 && yheight2 < 0) this_box_storage.is_rectangle = 1;
if (xwidth == xwidth2 && yheight == yheight2) this_box_storage.is_rectangle = 1;

if (xwidth2 < 0) {
    this_box_storage.x_width2 = xwidth;
    xwidth2 = xwidth;
} else this_box_storage.x_width2 = xwidth2;

if (yheight2 < 0) {
    this_box_storage.y_height2 = yheight;
    yheight2 = yheight;
} else this_box_storage.y_height2 = yheight2;


this_box_storage.normal_vectors[0] = coords_set(0,0,1);
this_box_storage.normal_vectors[1] = coords_set(0,0,1);

// for sides with y component = 0
x_component = 2*zdepth/sqrt((xwidth-xwidth2)*(xwidth-xwidth2)+4*zdepth*zdepth);
z_component = (xwidth-xwidth2)/sqrt(4*zdepth*zdepth+(xwidth-xwidth2)*(xwidth-xwidth2));

this_box_storage.normal_vectors[2] = coords_set(x_component,0,z_component);
this_box_storage.normal_vectors[3] = coords_set(-x_component,0,z_component);

// for sides with x component = 0
y_component = 2*zdepth/sqrt((yheight-yheight2)*(yheight-yheight2)+4*zdepth*zdepth);
z_component = (yheight-yheight2)/sqrt(4*zdepth*zdepth+(yheight-yheight2)*(yheight-yheight2));

this_box_storage.normal_vectors[4] = coords_set(0,y_component,z_component);
this_box_storage.normal_vectors[5] = coords_set(0,-y_component,z_component);

this_box_volume.geometry.visualization_on = visualize;

this_box_volume.geometry.geometry_parameters.p_box_storage = &this_box_storage;

// Assign pointers to functions for intersection with the shape, checking if a point is inside the shape
if (this_box_storage.is_rectangle == 1) {
this_box_volume.geometry.intersect_function = &sample_box_intersect_simple;
this_box_volume.geometry.within_function = &r_within_box_simple;
}
else {
this_box_volume.geometry.intersect_function = &sample_box_intersect_advanced;
this_box_volume.geometry.within_function = &r_within_box_advanced;
}

this_box_volume.geometry.shell_points = &box_shell_points;
this_box_volume.geometry.mcdisplay_function = &mcdisplay_box_function;
this_box_volume.geometry.initialize_from_main_function = &initialize_box_geometry_from_main_component;
this_box_volume.geometry.process_rot_allocated = 0;

this_box_volume.geometry.copy_geometry_parameters = &allocate_box_storage_copy;

rot_copy(this_box_volume.geometry.rotation_matrix,ROT_A_CURRENT_COMP); //check how ROT_R_CURRENT_COMP would work
rot_transpose(ROT_A_CURRENT_COMP,this_box_volume.geometry.transpose_rotation_matrix);

// Initialize loggers
this_box_volume.loggers.num_elements = 0;

// packing the information into the global_geometry_element, which is then included in the global_geometry_list.
sprintf(global_geometry_element.name,NAME_CURRENT_COMP);
global_geometry_element.activation_counter = number_of_activations;
global_geometry_element.component_index = INDEX_CURRENT_COMP;
global_geometry_element.Volume = &this_box_volume; // Would be nicer if this m was a pointer, now we have the (small) data two places
add_element_to_geometry_list(&global_geometry_list,global_geometry_element);
}
#line 245342 "MACS_sample_kidney_box.c"
#undef number_of_activations
#undef mask_setting
#undef mask_string
#undef p_interact
#undef focus_r
#undef focus_xh
#undef focus_xw
#undef focus_ah
#undef focus_aw
#undef target_z
#undef target_y
#undef target_x
#undef target_index
#undef visualize
#undef yheight2
#undef xwidth2
#undef zdepth
#undef yheight
#undef xwidth
#undef priority
#undef material_string
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

  /* Initializations for component channel_9_analyzer_1_array_crystal_array_2. */
  SIG_MESSAGE("channel_9_analyzer_1_array_crystal_array_2 (Init)");
#define mccompcurname  channel_9_analyzer_1_array_crystal_array_2
#define mccompcurtype  Union_box
#define mccompcurindex 474
#define loop_index mccchannel_9_analyzer_1_array_crystal_array_2_loop_index
#define this_box_volume mccchannel_9_analyzer_1_array_crystal_array_2_this_box_volume
#define global_geometry_element mccchannel_9_analyzer_1_array_crystal_array_2_global_geometry_element
#define this_box_storage mccchannel_9_analyzer_1_array_crystal_array_2_this_box_storage
#define material_string mccchannel_9_analyzer_1_array_crystal_array_2_material_string
#define priority mccchannel_9_analyzer_1_array_crystal_array_2_priority
#define xwidth mccchannel_9_analyzer_1_array_crystal_array_2_xwidth
#define yheight mccchannel_9_analyzer_1_array_crystal_array_2_yheight
#define zdepth mccchannel_9_analyzer_1_array_crystal_array_2_zdepth
#define xwidth2 mccchannel_9_analyzer_1_array_crystal_array_2_xwidth2
#define yheight2 mccchannel_9_analyzer_1_array_crystal_array_2_yheight2
#define visualize mccchannel_9_analyzer_1_array_crystal_array_2_visualize
#define target_index mccchannel_9_analyzer_1_array_crystal_array_2_target_index
#define target_x mccchannel_9_analyzer_1_array_crystal_array_2_target_x
#define target_y mccchannel_9_analyzer_1_array_crystal_array_2_target_y
#define target_z mccchannel_9_analyzer_1_array_crystal_array_2_target_z
#define focus_aw mccchannel_9_analyzer_1_array_crystal_array_2_focus_aw
#define focus_ah mccchannel_9_analyzer_1_array_crystal_array_2_focus_ah
#define focus_xw mccchannel_9_analyzer_1_array_crystal_array_2_focus_xw
#define focus_xh mccchannel_9_analyzer_1_array_crystal_array_2_focus_xh
#define focus_r mccchannel_9_analyzer_1_array_crystal_array_2_focus_r
#define p_interact mccchannel_9_analyzer_1_array_crystal_array_2_p_interact
#define mask_string mccchannel_9_analyzer_1_array_crystal_array_2_mask_string
#define mask_setting mccchannel_9_analyzer_1_array_crystal_array_2_mask_setting
#define number_of_activations mccchannel_9_analyzer_1_array_crystal_array_2_number_of_activations
#line 224 "Union_box.comp"
{
// Initializes the focusing system for this volume including input sanitation.
focus_initialize(&this_box_volume.geometry, POS_A_COMP_INDEX(INDEX_CURRENT_COMP+target_index), POS_A_CURRENT_COMP, ROT_A_CURRENT_COMP, target_index, target_x, target_y, target_z, focus_aw, focus_ah, focus_xw, focus_xh, focus_r, NAME_CURRENT_COMP);

// Input sanitation for this geometry
if (xwidth <= 0) {
  printf("\nERROR in Union_box named %s, the xwidth is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (yheight <= 0) {
  printf("\nERROR in Union_box named %s, yheight is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (zdepth <= 0) {
  printf("\nERROR in Union_box named %s, zdepth is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (xwidth2 <= 0 && xwidth2 != -1) {
  printf("\nERROR in Union_box named %s, the xwidth2 is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (yheight2 <= 0 && yheight2 != -1) {
  printf("\nERROR in Union_box named %s, yheight2 is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}

// Use sanitation
if (global_material_list.num_elements == 0) {
  printf("\nERROR: Need to define a material using Union_make_material before using a Union geometry component. \n");
  printf("       %s was defined before first use of Union_make_material.\n",NAME_CURRENT_COMP);
  exit(1);
}

this_box_volume.geometry.is_masked_volume = 0;
this_box_volume.geometry.is_exit_volume = 0;
this_box_volume.geometry.is_mask_volume = 0;
// check if the volume is a mask, if it is the material string is irelevant.
if (mask_string && strlen(mask_string) && strcmp(mask_string, "NULL") && strcmp(mask_string, "0")) {
    // A mask volume is used to limit the extend of other volumes, called the masked volumes. These are specified in the mask_string.
    // In order for a ray to enter a masked volume, it needs to be both in the region covered by that volume AND the mask volume.
    // When more than
    this_box_volume.geometry.mask_mode = 1; // Default is mask mode is ALL
    if (mask_setting && strlen(mask_setting) && strcmp(mask_setting, "NULL") && strcmp(mask_setting, "0")) {
        if (strcmp(mask_setting,"ALL") == 0 || strcmp(mask_setting,"All") == 0) this_box_volume.geometry.mask_mode = 1;
        else if (strcmp(mask_setting,"ANY") == 0 || strcmp(mask_setting,"Any") == 0) this_box_volume.geometry.mask_mode = 2;
        else {
            printf("The mask_mode of component %s is set to %s, but must be either ALL or ANY.\n",NAME_CURRENT_COMP,mask_setting);
            exit(1);
        }
    }
    
    for (loop_index=0;loop_index<global_geometry_list.num_elements;loop_index++) {
        // Add mask list
        if (1 == manual_linking_function(global_geometry_list.elements[loop_index].name,mask_string)) {
            add_element_to_int_list(&this_box_volume.geometry.mask_list,global_geometry_list.elements[loop_index].component_index);
            add_element_to_int_list(&global_geometry_list.elements[loop_index].Volume->geometry.masked_by_list,INDEX_CURRENT_COMP);
            global_geometry_list.elements[loop_index].Volume->geometry.is_masked_volume = 1;
            if (this_box_volume.geometry.mask_mode == 2)
                global_geometry_list.elements[loop_index].Volume->geometry.mask_mode = 2;
            if (this_box_volume.geometry.mask_mode == 1) {
                if (global_geometry_list.elements[loop_index].Volume->geometry.is_masked_volume == 1 && global_geometry_list.elements[loop_index].Volume->geometry.mask_mode != 2)
                    // If more than one mask is added to one volume, the ANY mode overwrites the (default) ALL mode.
                    global_geometry_list.elements[loop_index].Volume->geometry.mask_mode = 1;
            }
            
            found_geometries = 1;
        }
    }
    if (found_geometries == 0) {
        printf("The mask_string in geometry: %s did not find any of the specified volumes in the mask_string %s \n",NAME_CURRENT_COMP,mask_string);
        exit(1);
    }
    this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
    this_box_volume.p_physics->is_vacuum = 0; // Makes this volume a vacuum
    this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
    this_box_volume.p_physics->my_a = 0; // Should not be used.
    sprintf(this_box_volume.p_physics->name,"Mask");
    this_box_volume.geometry.is_mask_volume = 1;
    
    
// Read the material input, or if it lacks, use automatic linking.
} else if (material_string && strlen(material_string) && strcmp(material_string, "NULL") && strcmp(material_string, "0")) {
    // A geometry string was given, use it to determine which material
    if (0 == strcmp(material_string,"vacuum") || 0 == strcmp(material_string,"Vacuum")) {
        // One could have a global physics struct for vacuum instead of creating one for each
        this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
        this_box_volume.p_physics->is_vacuum = 1; // Makes this volume a vacuum
        this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
        this_box_volume.p_physics->my_a = 0; // Should not be used.
        sprintf(this_box_volume.p_physics->name,"Vacuum");
    } else if (0 == strcmp(material_string,"exit") || 0 == strcmp(material_string,"Exit")) {
        // One could have a global physics struct for vacuum instead of creating one for each
        this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
        this_box_volume.p_physics->is_vacuum = 1; // Makes this volume a vacuum
        this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
        this_box_volume.p_physics->my_a = 0; // Should not be used.
        this_box_volume.geometry.is_exit_volume = 1;
        sprintf(this_box_volume.p_physics->name,"Exit");
    } else {
        #ifndef MATERIAL_DETECTOR
            printf("Need to define a material before refering to it in a geometry %s.\n",NAME_CURRENT_COMP);
            exit(1);
        #endif
        for (loop_index=0;loop_index<global_material_list.num_elements;loop_index++) {
            if (0 == strcmp(material_string,global_material_list.elements[loop_index].name)) {
                this_box_volume.p_physics = global_material_list.elements[loop_index].physics;
                break;
            }
            if (loop_index == global_material_list.num_elements-1) {
            printf("\n");
            printf("ERROR: The material string \"%s\" in Union geometry \"%s\" did not match a specified material. \n",material_string,NAME_CURRENT_COMP);
            printf("       The materials available at this point (need to be defined before the geometry): \n");
            for (loop_index=0;loop_index<global_material_list.num_elements;loop_index++)
              printf("         %s\n",global_material_list.elements[loop_index].name);
            printf("\n");
            printf("       It is also possible to use one of the defualt materials avaiable: \n");
            printf("           Vacuum (for a Volume without scattering or absorption)\n");
            printf("           Exit (for a Volume where the ray exits the component if it enters)\n");
            printf("           Mask (for a Volume that masks existing volumes specified in the mask_string\n");
            exit(1);
          }
        }
    }
} else {
    // Automatic linking, simply using the last defined material.
    #ifndef MATERIAL_DETECTOR
        printf("Need to define a material before the geometry to use automatic linking %s.\n",NAME_CURRENT_COMP);
        exit(1);
    #endif
    this_box_volume.p_physics = global_material_list.elements[global_material_list.num_elements-1].physics;
}

sprintf(this_box_volume.name,NAME_CURRENT_COMP);
sprintf(this_box_volume.geometry.shape,"box");
this_box_volume.geometry.priority_value = priority;
this_box_volume.geometry.geometry_p_interact = p_interact;
// Currently the coordinates will be in absolute space.
this_box_volume.geometry.center = POS_A_CURRENT_COMP;

this_box_storage.z_depth = zdepth;
this_box_storage.x_width1 = xwidth;
this_box_storage.y_height1 = yheight;

this_box_storage.is_rectangle = 0;
if (xwidth2 < 0 && yheight2 < 0) this_box_storage.is_rectangle = 1;
if (xwidth == xwidth2 && yheight == yheight2) this_box_storage.is_rectangle = 1;

if (xwidth2 < 0) {
    this_box_storage.x_width2 = xwidth;
    xwidth2 = xwidth;
} else this_box_storage.x_width2 = xwidth2;

if (yheight2 < 0) {
    this_box_storage.y_height2 = yheight;
    yheight2 = yheight;
} else this_box_storage.y_height2 = yheight2;


this_box_storage.normal_vectors[0] = coords_set(0,0,1);
this_box_storage.normal_vectors[1] = coords_set(0,0,1);

// for sides with y component = 0
x_component = 2*zdepth/sqrt((xwidth-xwidth2)*(xwidth-xwidth2)+4*zdepth*zdepth);
z_component = (xwidth-xwidth2)/sqrt(4*zdepth*zdepth+(xwidth-xwidth2)*(xwidth-xwidth2));

this_box_storage.normal_vectors[2] = coords_set(x_component,0,z_component);
this_box_storage.normal_vectors[3] = coords_set(-x_component,0,z_component);

// for sides with x component = 0
y_component = 2*zdepth/sqrt((yheight-yheight2)*(yheight-yheight2)+4*zdepth*zdepth);
z_component = (yheight-yheight2)/sqrt(4*zdepth*zdepth+(yheight-yheight2)*(yheight-yheight2));

this_box_storage.normal_vectors[4] = coords_set(0,y_component,z_component);
this_box_storage.normal_vectors[5] = coords_set(0,-y_component,z_component);

this_box_volume.geometry.visualization_on = visualize;

this_box_volume.geometry.geometry_parameters.p_box_storage = &this_box_storage;

// Assign pointers to functions for intersection with the shape, checking if a point is inside the shape
if (this_box_storage.is_rectangle == 1) {
this_box_volume.geometry.intersect_function = &sample_box_intersect_simple;
this_box_volume.geometry.within_function = &r_within_box_simple;
}
else {
this_box_volume.geometry.intersect_function = &sample_box_intersect_advanced;
this_box_volume.geometry.within_function = &r_within_box_advanced;
}

this_box_volume.geometry.shell_points = &box_shell_points;
this_box_volume.geometry.mcdisplay_function = &mcdisplay_box_function;
this_box_volume.geometry.initialize_from_main_function = &initialize_box_geometry_from_main_component;
this_box_volume.geometry.process_rot_allocated = 0;

this_box_volume.geometry.copy_geometry_parameters = &allocate_box_storage_copy;

rot_copy(this_box_volume.geometry.rotation_matrix,ROT_A_CURRENT_COMP); //check how ROT_R_CURRENT_COMP would work
rot_transpose(ROT_A_CURRENT_COMP,this_box_volume.geometry.transpose_rotation_matrix);

// Initialize loggers
this_box_volume.loggers.num_elements = 0;

// packing the information into the global_geometry_element, which is then included in the global_geometry_list.
sprintf(global_geometry_element.name,NAME_CURRENT_COMP);
global_geometry_element.activation_counter = number_of_activations;
global_geometry_element.component_index = INDEX_CURRENT_COMP;
global_geometry_element.Volume = &this_box_volume; // Would be nicer if this m was a pointer, now we have the (small) data two places
add_element_to_geometry_list(&global_geometry_list,global_geometry_element);
}
#line 245612 "MACS_sample_kidney_box.c"
#undef number_of_activations
#undef mask_setting
#undef mask_string
#undef p_interact
#undef focus_r
#undef focus_xh
#undef focus_xw
#undef focus_ah
#undef focus_aw
#undef target_z
#undef target_y
#undef target_x
#undef target_index
#undef visualize
#undef yheight2
#undef xwidth2
#undef zdepth
#undef yheight
#undef xwidth
#undef priority
#undef material_string
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

  /* Initializations for component channel_9_analyzer_1_array_crystal_array_3. */
  SIG_MESSAGE("channel_9_analyzer_1_array_crystal_array_3 (Init)");
#define mccompcurname  channel_9_analyzer_1_array_crystal_array_3
#define mccompcurtype  Union_box
#define mccompcurindex 475
#define loop_index mccchannel_9_analyzer_1_array_crystal_array_3_loop_index
#define this_box_volume mccchannel_9_analyzer_1_array_crystal_array_3_this_box_volume
#define global_geometry_element mccchannel_9_analyzer_1_array_crystal_array_3_global_geometry_element
#define this_box_storage mccchannel_9_analyzer_1_array_crystal_array_3_this_box_storage
#define material_string mccchannel_9_analyzer_1_array_crystal_array_3_material_string
#define priority mccchannel_9_analyzer_1_array_crystal_array_3_priority
#define xwidth mccchannel_9_analyzer_1_array_crystal_array_3_xwidth
#define yheight mccchannel_9_analyzer_1_array_crystal_array_3_yheight
#define zdepth mccchannel_9_analyzer_1_array_crystal_array_3_zdepth
#define xwidth2 mccchannel_9_analyzer_1_array_crystal_array_3_xwidth2
#define yheight2 mccchannel_9_analyzer_1_array_crystal_array_3_yheight2
#define visualize mccchannel_9_analyzer_1_array_crystal_array_3_visualize
#define target_index mccchannel_9_analyzer_1_array_crystal_array_3_target_index
#define target_x mccchannel_9_analyzer_1_array_crystal_array_3_target_x
#define target_y mccchannel_9_analyzer_1_array_crystal_array_3_target_y
#define target_z mccchannel_9_analyzer_1_array_crystal_array_3_target_z
#define focus_aw mccchannel_9_analyzer_1_array_crystal_array_3_focus_aw
#define focus_ah mccchannel_9_analyzer_1_array_crystal_array_3_focus_ah
#define focus_xw mccchannel_9_analyzer_1_array_crystal_array_3_focus_xw
#define focus_xh mccchannel_9_analyzer_1_array_crystal_array_3_focus_xh
#define focus_r mccchannel_9_analyzer_1_array_crystal_array_3_focus_r
#define p_interact mccchannel_9_analyzer_1_array_crystal_array_3_p_interact
#define mask_string mccchannel_9_analyzer_1_array_crystal_array_3_mask_string
#define mask_setting mccchannel_9_analyzer_1_array_crystal_array_3_mask_setting
#define number_of_activations mccchannel_9_analyzer_1_array_crystal_array_3_number_of_activations
#line 224 "Union_box.comp"
{
// Initializes the focusing system for this volume including input sanitation.
focus_initialize(&this_box_volume.geometry, POS_A_COMP_INDEX(INDEX_CURRENT_COMP+target_index), POS_A_CURRENT_COMP, ROT_A_CURRENT_COMP, target_index, target_x, target_y, target_z, focus_aw, focus_ah, focus_xw, focus_xh, focus_r, NAME_CURRENT_COMP);

// Input sanitation for this geometry
if (xwidth <= 0) {
  printf("\nERROR in Union_box named %s, the xwidth is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (yheight <= 0) {
  printf("\nERROR in Union_box named %s, yheight is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (zdepth <= 0) {
  printf("\nERROR in Union_box named %s, zdepth is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (xwidth2 <= 0 && xwidth2 != -1) {
  printf("\nERROR in Union_box named %s, the xwidth2 is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (yheight2 <= 0 && yheight2 != -1) {
  printf("\nERROR in Union_box named %s, yheight2 is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}

// Use sanitation
if (global_material_list.num_elements == 0) {
  printf("\nERROR: Need to define a material using Union_make_material before using a Union geometry component. \n");
  printf("       %s was defined before first use of Union_make_material.\n",NAME_CURRENT_COMP);
  exit(1);
}

this_box_volume.geometry.is_masked_volume = 0;
this_box_volume.geometry.is_exit_volume = 0;
this_box_volume.geometry.is_mask_volume = 0;
// check if the volume is a mask, if it is the material string is irelevant.
if (mask_string && strlen(mask_string) && strcmp(mask_string, "NULL") && strcmp(mask_string, "0")) {
    // A mask volume is used to limit the extend of other volumes, called the masked volumes. These are specified in the mask_string.
    // In order for a ray to enter a masked volume, it needs to be both in the region covered by that volume AND the mask volume.
    // When more than
    this_box_volume.geometry.mask_mode = 1; // Default is mask mode is ALL
    if (mask_setting && strlen(mask_setting) && strcmp(mask_setting, "NULL") && strcmp(mask_setting, "0")) {
        if (strcmp(mask_setting,"ALL") == 0 || strcmp(mask_setting,"All") == 0) this_box_volume.geometry.mask_mode = 1;
        else if (strcmp(mask_setting,"ANY") == 0 || strcmp(mask_setting,"Any") == 0) this_box_volume.geometry.mask_mode = 2;
        else {
            printf("The mask_mode of component %s is set to %s, but must be either ALL or ANY.\n",NAME_CURRENT_COMP,mask_setting);
            exit(1);
        }
    }
    
    for (loop_index=0;loop_index<global_geometry_list.num_elements;loop_index++) {
        // Add mask list
        if (1 == manual_linking_function(global_geometry_list.elements[loop_index].name,mask_string)) {
            add_element_to_int_list(&this_box_volume.geometry.mask_list,global_geometry_list.elements[loop_index].component_index);
            add_element_to_int_list(&global_geometry_list.elements[loop_index].Volume->geometry.masked_by_list,INDEX_CURRENT_COMP);
            global_geometry_list.elements[loop_index].Volume->geometry.is_masked_volume = 1;
            if (this_box_volume.geometry.mask_mode == 2)
                global_geometry_list.elements[loop_index].Volume->geometry.mask_mode = 2;
            if (this_box_volume.geometry.mask_mode == 1) {
                if (global_geometry_list.elements[loop_index].Volume->geometry.is_masked_volume == 1 && global_geometry_list.elements[loop_index].Volume->geometry.mask_mode != 2)
                    // If more than one mask is added to one volume, the ANY mode overwrites the (default) ALL mode.
                    global_geometry_list.elements[loop_index].Volume->geometry.mask_mode = 1;
            }
            
            found_geometries = 1;
        }
    }
    if (found_geometries == 0) {
        printf("The mask_string in geometry: %s did not find any of the specified volumes in the mask_string %s \n",NAME_CURRENT_COMP,mask_string);
        exit(1);
    }
    this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
    this_box_volume.p_physics->is_vacuum = 0; // Makes this volume a vacuum
    this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
    this_box_volume.p_physics->my_a = 0; // Should not be used.
    sprintf(this_box_volume.p_physics->name,"Mask");
    this_box_volume.geometry.is_mask_volume = 1;
    
    
// Read the material input, or if it lacks, use automatic linking.
} else if (material_string && strlen(material_string) && strcmp(material_string, "NULL") && strcmp(material_string, "0")) {
    // A geometry string was given, use it to determine which material
    if (0 == strcmp(material_string,"vacuum") || 0 == strcmp(material_string,"Vacuum")) {
        // One could have a global physics struct for vacuum instead of creating one for each
        this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
        this_box_volume.p_physics->is_vacuum = 1; // Makes this volume a vacuum
        this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
        this_box_volume.p_physics->my_a = 0; // Should not be used.
        sprintf(this_box_volume.p_physics->name,"Vacuum");
    } else if (0 == strcmp(material_string,"exit") || 0 == strcmp(material_string,"Exit")) {
        // One could have a global physics struct for vacuum instead of creating one for each
        this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
        this_box_volume.p_physics->is_vacuum = 1; // Makes this volume a vacuum
        this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
        this_box_volume.p_physics->my_a = 0; // Should not be used.
        this_box_volume.geometry.is_exit_volume = 1;
        sprintf(this_box_volume.p_physics->name,"Exit");
    } else {
        #ifndef MATERIAL_DETECTOR
            printf("Need to define a material before refering to it in a geometry %s.\n",NAME_CURRENT_COMP);
            exit(1);
        #endif
        for (loop_index=0;loop_index<global_material_list.num_elements;loop_index++) {
            if (0 == strcmp(material_string,global_material_list.elements[loop_index].name)) {
                this_box_volume.p_physics = global_material_list.elements[loop_index].physics;
                break;
            }
            if (loop_index == global_material_list.num_elements-1) {
            printf("\n");
            printf("ERROR: The material string \"%s\" in Union geometry \"%s\" did not match a specified material. \n",material_string,NAME_CURRENT_COMP);
            printf("       The materials available at this point (need to be defined before the geometry): \n");
            for (loop_index=0;loop_index<global_material_list.num_elements;loop_index++)
              printf("         %s\n",global_material_list.elements[loop_index].name);
            printf("\n");
            printf("       It is also possible to use one of the defualt materials avaiable: \n");
            printf("           Vacuum (for a Volume without scattering or absorption)\n");
            printf("           Exit (for a Volume where the ray exits the component if it enters)\n");
            printf("           Mask (for a Volume that masks existing volumes specified in the mask_string\n");
            exit(1);
          }
        }
    }
} else {
    // Automatic linking, simply using the last defined material.
    #ifndef MATERIAL_DETECTOR
        printf("Need to define a material before the geometry to use automatic linking %s.\n",NAME_CURRENT_COMP);
        exit(1);
    #endif
    this_box_volume.p_physics = global_material_list.elements[global_material_list.num_elements-1].physics;
}

sprintf(this_box_volume.name,NAME_CURRENT_COMP);
sprintf(this_box_volume.geometry.shape,"box");
this_box_volume.geometry.priority_value = priority;
this_box_volume.geometry.geometry_p_interact = p_interact;
// Currently the coordinates will be in absolute space.
this_box_volume.geometry.center = POS_A_CURRENT_COMP;

this_box_storage.z_depth = zdepth;
this_box_storage.x_width1 = xwidth;
this_box_storage.y_height1 = yheight;

this_box_storage.is_rectangle = 0;
if (xwidth2 < 0 && yheight2 < 0) this_box_storage.is_rectangle = 1;
if (xwidth == xwidth2 && yheight == yheight2) this_box_storage.is_rectangle = 1;

if (xwidth2 < 0) {
    this_box_storage.x_width2 = xwidth;
    xwidth2 = xwidth;
} else this_box_storage.x_width2 = xwidth2;

if (yheight2 < 0) {
    this_box_storage.y_height2 = yheight;
    yheight2 = yheight;
} else this_box_storage.y_height2 = yheight2;


this_box_storage.normal_vectors[0] = coords_set(0,0,1);
this_box_storage.normal_vectors[1] = coords_set(0,0,1);

// for sides with y component = 0
x_component = 2*zdepth/sqrt((xwidth-xwidth2)*(xwidth-xwidth2)+4*zdepth*zdepth);
z_component = (xwidth-xwidth2)/sqrt(4*zdepth*zdepth+(xwidth-xwidth2)*(xwidth-xwidth2));

this_box_storage.normal_vectors[2] = coords_set(x_component,0,z_component);
this_box_storage.normal_vectors[3] = coords_set(-x_component,0,z_component);

// for sides with x component = 0
y_component = 2*zdepth/sqrt((yheight-yheight2)*(yheight-yheight2)+4*zdepth*zdepth);
z_component = (yheight-yheight2)/sqrt(4*zdepth*zdepth+(yheight-yheight2)*(yheight-yheight2));

this_box_storage.normal_vectors[4] = coords_set(0,y_component,z_component);
this_box_storage.normal_vectors[5] = coords_set(0,-y_component,z_component);

this_box_volume.geometry.visualization_on = visualize;

this_box_volume.geometry.geometry_parameters.p_box_storage = &this_box_storage;

// Assign pointers to functions for intersection with the shape, checking if a point is inside the shape
if (this_box_storage.is_rectangle == 1) {
this_box_volume.geometry.intersect_function = &sample_box_intersect_simple;
this_box_volume.geometry.within_function = &r_within_box_simple;
}
else {
this_box_volume.geometry.intersect_function = &sample_box_intersect_advanced;
this_box_volume.geometry.within_function = &r_within_box_advanced;
}

this_box_volume.geometry.shell_points = &box_shell_points;
this_box_volume.geometry.mcdisplay_function = &mcdisplay_box_function;
this_box_volume.geometry.initialize_from_main_function = &initialize_box_geometry_from_main_component;
this_box_volume.geometry.process_rot_allocated = 0;

this_box_volume.geometry.copy_geometry_parameters = &allocate_box_storage_copy;

rot_copy(this_box_volume.geometry.rotation_matrix,ROT_A_CURRENT_COMP); //check how ROT_R_CURRENT_COMP would work
rot_transpose(ROT_A_CURRENT_COMP,this_box_volume.geometry.transpose_rotation_matrix);

// Initialize loggers
this_box_volume.loggers.num_elements = 0;

// packing the information into the global_geometry_element, which is then included in the global_geometry_list.
sprintf(global_geometry_element.name,NAME_CURRENT_COMP);
global_geometry_element.activation_counter = number_of_activations;
global_geometry_element.component_index = INDEX_CURRENT_COMP;
global_geometry_element.Volume = &this_box_volume; // Would be nicer if this m was a pointer, now we have the (small) data two places
add_element_to_geometry_list(&global_geometry_list,global_geometry_element);
}
#line 245882 "MACS_sample_kidney_box.c"
#undef number_of_activations
#undef mask_setting
#undef mask_string
#undef p_interact
#undef focus_r
#undef focus_xh
#undef focus_xw
#undef focus_ah
#undef focus_aw
#undef target_z
#undef target_y
#undef target_x
#undef target_index
#undef visualize
#undef yheight2
#undef xwidth2
#undef zdepth
#undef yheight
#undef xwidth
#undef priority
#undef material_string
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

  /* Initializations for component channel_9_analyzer_1_array_crystal_array_4. */
  SIG_MESSAGE("channel_9_analyzer_1_array_crystal_array_4 (Init)");
#define mccompcurname  channel_9_analyzer_1_array_crystal_array_4
#define mccompcurtype  Union_box
#define mccompcurindex 476
#define loop_index mccchannel_9_analyzer_1_array_crystal_array_4_loop_index
#define this_box_volume mccchannel_9_analyzer_1_array_crystal_array_4_this_box_volume
#define global_geometry_element mccchannel_9_analyzer_1_array_crystal_array_4_global_geometry_element
#define this_box_storage mccchannel_9_analyzer_1_array_crystal_array_4_this_box_storage
#define material_string mccchannel_9_analyzer_1_array_crystal_array_4_material_string
#define priority mccchannel_9_analyzer_1_array_crystal_array_4_priority
#define xwidth mccchannel_9_analyzer_1_array_crystal_array_4_xwidth
#define yheight mccchannel_9_analyzer_1_array_crystal_array_4_yheight
#define zdepth mccchannel_9_analyzer_1_array_crystal_array_4_zdepth
#define xwidth2 mccchannel_9_analyzer_1_array_crystal_array_4_xwidth2
#define yheight2 mccchannel_9_analyzer_1_array_crystal_array_4_yheight2
#define visualize mccchannel_9_analyzer_1_array_crystal_array_4_visualize
#define target_index mccchannel_9_analyzer_1_array_crystal_array_4_target_index
#define target_x mccchannel_9_analyzer_1_array_crystal_array_4_target_x
#define target_y mccchannel_9_analyzer_1_array_crystal_array_4_target_y
#define target_z mccchannel_9_analyzer_1_array_crystal_array_4_target_z
#define focus_aw mccchannel_9_analyzer_1_array_crystal_array_4_focus_aw
#define focus_ah mccchannel_9_analyzer_1_array_crystal_array_4_focus_ah
#define focus_xw mccchannel_9_analyzer_1_array_crystal_array_4_focus_xw
#define focus_xh mccchannel_9_analyzer_1_array_crystal_array_4_focus_xh
#define focus_r mccchannel_9_analyzer_1_array_crystal_array_4_focus_r
#define p_interact mccchannel_9_analyzer_1_array_crystal_array_4_p_interact
#define mask_string mccchannel_9_analyzer_1_array_crystal_array_4_mask_string
#define mask_setting mccchannel_9_analyzer_1_array_crystal_array_4_mask_setting
#define number_of_activations mccchannel_9_analyzer_1_array_crystal_array_4_number_of_activations
#line 224 "Union_box.comp"
{
// Initializes the focusing system for this volume including input sanitation.
focus_initialize(&this_box_volume.geometry, POS_A_COMP_INDEX(INDEX_CURRENT_COMP+target_index), POS_A_CURRENT_COMP, ROT_A_CURRENT_COMP, target_index, target_x, target_y, target_z, focus_aw, focus_ah, focus_xw, focus_xh, focus_r, NAME_CURRENT_COMP);

// Input sanitation for this geometry
if (xwidth <= 0) {
  printf("\nERROR in Union_box named %s, the xwidth is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (yheight <= 0) {
  printf("\nERROR in Union_box named %s, yheight is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (zdepth <= 0) {
  printf("\nERROR in Union_box named %s, zdepth is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (xwidth2 <= 0 && xwidth2 != -1) {
  printf("\nERROR in Union_box named %s, the xwidth2 is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (yheight2 <= 0 && yheight2 != -1) {
  printf("\nERROR in Union_box named %s, yheight2 is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}

// Use sanitation
if (global_material_list.num_elements == 0) {
  printf("\nERROR: Need to define a material using Union_make_material before using a Union geometry component. \n");
  printf("       %s was defined before first use of Union_make_material.\n",NAME_CURRENT_COMP);
  exit(1);
}

this_box_volume.geometry.is_masked_volume = 0;
this_box_volume.geometry.is_exit_volume = 0;
this_box_volume.geometry.is_mask_volume = 0;
// check if the volume is a mask, if it is the material string is irelevant.
if (mask_string && strlen(mask_string) && strcmp(mask_string, "NULL") && strcmp(mask_string, "0")) {
    // A mask volume is used to limit the extend of other volumes, called the masked volumes. These are specified in the mask_string.
    // In order for a ray to enter a masked volume, it needs to be both in the region covered by that volume AND the mask volume.
    // When more than
    this_box_volume.geometry.mask_mode = 1; // Default is mask mode is ALL
    if (mask_setting && strlen(mask_setting) && strcmp(mask_setting, "NULL") && strcmp(mask_setting, "0")) {
        if (strcmp(mask_setting,"ALL") == 0 || strcmp(mask_setting,"All") == 0) this_box_volume.geometry.mask_mode = 1;
        else if (strcmp(mask_setting,"ANY") == 0 || strcmp(mask_setting,"Any") == 0) this_box_volume.geometry.mask_mode = 2;
        else {
            printf("The mask_mode of component %s is set to %s, but must be either ALL or ANY.\n",NAME_CURRENT_COMP,mask_setting);
            exit(1);
        }
    }
    
    for (loop_index=0;loop_index<global_geometry_list.num_elements;loop_index++) {
        // Add mask list
        if (1 == manual_linking_function(global_geometry_list.elements[loop_index].name,mask_string)) {
            add_element_to_int_list(&this_box_volume.geometry.mask_list,global_geometry_list.elements[loop_index].component_index);
            add_element_to_int_list(&global_geometry_list.elements[loop_index].Volume->geometry.masked_by_list,INDEX_CURRENT_COMP);
            global_geometry_list.elements[loop_index].Volume->geometry.is_masked_volume = 1;
            if (this_box_volume.geometry.mask_mode == 2)
                global_geometry_list.elements[loop_index].Volume->geometry.mask_mode = 2;
            if (this_box_volume.geometry.mask_mode == 1) {
                if (global_geometry_list.elements[loop_index].Volume->geometry.is_masked_volume == 1 && global_geometry_list.elements[loop_index].Volume->geometry.mask_mode != 2)
                    // If more than one mask is added to one volume, the ANY mode overwrites the (default) ALL mode.
                    global_geometry_list.elements[loop_index].Volume->geometry.mask_mode = 1;
            }
            
            found_geometries = 1;
        }
    }
    if (found_geometries == 0) {
        printf("The mask_string in geometry: %s did not find any of the specified volumes in the mask_string %s \n",NAME_CURRENT_COMP,mask_string);
        exit(1);
    }
    this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
    this_box_volume.p_physics->is_vacuum = 0; // Makes this volume a vacuum
    this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
    this_box_volume.p_physics->my_a = 0; // Should not be used.
    sprintf(this_box_volume.p_physics->name,"Mask");
    this_box_volume.geometry.is_mask_volume = 1;
    
    
// Read the material input, or if it lacks, use automatic linking.
} else if (material_string && strlen(material_string) && strcmp(material_string, "NULL") && strcmp(material_string, "0")) {
    // A geometry string was given, use it to determine which material
    if (0 == strcmp(material_string,"vacuum") || 0 == strcmp(material_string,"Vacuum")) {
        // One could have a global physics struct for vacuum instead of creating one for each
        this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
        this_box_volume.p_physics->is_vacuum = 1; // Makes this volume a vacuum
        this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
        this_box_volume.p_physics->my_a = 0; // Should not be used.
        sprintf(this_box_volume.p_physics->name,"Vacuum");
    } else if (0 == strcmp(material_string,"exit") || 0 == strcmp(material_string,"Exit")) {
        // One could have a global physics struct for vacuum instead of creating one for each
        this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
        this_box_volume.p_physics->is_vacuum = 1; // Makes this volume a vacuum
        this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
        this_box_volume.p_physics->my_a = 0; // Should not be used.
        this_box_volume.geometry.is_exit_volume = 1;
        sprintf(this_box_volume.p_physics->name,"Exit");
    } else {
        #ifndef MATERIAL_DETECTOR
            printf("Need to define a material before refering to it in a geometry %s.\n",NAME_CURRENT_COMP);
            exit(1);
        #endif
        for (loop_index=0;loop_index<global_material_list.num_elements;loop_index++) {
            if (0 == strcmp(material_string,global_material_list.elements[loop_index].name)) {
                this_box_volume.p_physics = global_material_list.elements[loop_index].physics;
                break;
            }
            if (loop_index == global_material_list.num_elements-1) {
            printf("\n");
            printf("ERROR: The material string \"%s\" in Union geometry \"%s\" did not match a specified material. \n",material_string,NAME_CURRENT_COMP);
            printf("       The materials available at this point (need to be defined before the geometry): \n");
            for (loop_index=0;loop_index<global_material_list.num_elements;loop_index++)
              printf("         %s\n",global_material_list.elements[loop_index].name);
            printf("\n");
            printf("       It is also possible to use one of the defualt materials avaiable: \n");
            printf("           Vacuum (for a Volume without scattering or absorption)\n");
            printf("           Exit (for a Volume where the ray exits the component if it enters)\n");
            printf("           Mask (for a Volume that masks existing volumes specified in the mask_string\n");
            exit(1);
          }
        }
    }
} else {
    // Automatic linking, simply using the last defined material.
    #ifndef MATERIAL_DETECTOR
        printf("Need to define a material before the geometry to use automatic linking %s.\n",NAME_CURRENT_COMP);
        exit(1);
    #endif
    this_box_volume.p_physics = global_material_list.elements[global_material_list.num_elements-1].physics;
}

sprintf(this_box_volume.name,NAME_CURRENT_COMP);
sprintf(this_box_volume.geometry.shape,"box");
this_box_volume.geometry.priority_value = priority;
this_box_volume.geometry.geometry_p_interact = p_interact;
// Currently the coordinates will be in absolute space.
this_box_volume.geometry.center = POS_A_CURRENT_COMP;

this_box_storage.z_depth = zdepth;
this_box_storage.x_width1 = xwidth;
this_box_storage.y_height1 = yheight;

this_box_storage.is_rectangle = 0;
if (xwidth2 < 0 && yheight2 < 0) this_box_storage.is_rectangle = 1;
if (xwidth == xwidth2 && yheight == yheight2) this_box_storage.is_rectangle = 1;

if (xwidth2 < 0) {
    this_box_storage.x_width2 = xwidth;
    xwidth2 = xwidth;
} else this_box_storage.x_width2 = xwidth2;

if (yheight2 < 0) {
    this_box_storage.y_height2 = yheight;
    yheight2 = yheight;
} else this_box_storage.y_height2 = yheight2;


this_box_storage.normal_vectors[0] = coords_set(0,0,1);
this_box_storage.normal_vectors[1] = coords_set(0,0,1);

// for sides with y component = 0
x_component = 2*zdepth/sqrt((xwidth-xwidth2)*(xwidth-xwidth2)+4*zdepth*zdepth);
z_component = (xwidth-xwidth2)/sqrt(4*zdepth*zdepth+(xwidth-xwidth2)*(xwidth-xwidth2));

this_box_storage.normal_vectors[2] = coords_set(x_component,0,z_component);
this_box_storage.normal_vectors[3] = coords_set(-x_component,0,z_component);

// for sides with x component = 0
y_component = 2*zdepth/sqrt((yheight-yheight2)*(yheight-yheight2)+4*zdepth*zdepth);
z_component = (yheight-yheight2)/sqrt(4*zdepth*zdepth+(yheight-yheight2)*(yheight-yheight2));

this_box_storage.normal_vectors[4] = coords_set(0,y_component,z_component);
this_box_storage.normal_vectors[5] = coords_set(0,-y_component,z_component);

this_box_volume.geometry.visualization_on = visualize;

this_box_volume.geometry.geometry_parameters.p_box_storage = &this_box_storage;

// Assign pointers to functions for intersection with the shape, checking if a point is inside the shape
if (this_box_storage.is_rectangle == 1) {
this_box_volume.geometry.intersect_function = &sample_box_intersect_simple;
this_box_volume.geometry.within_function = &r_within_box_simple;
}
else {
this_box_volume.geometry.intersect_function = &sample_box_intersect_advanced;
this_box_volume.geometry.within_function = &r_within_box_advanced;
}

this_box_volume.geometry.shell_points = &box_shell_points;
this_box_volume.geometry.mcdisplay_function = &mcdisplay_box_function;
this_box_volume.geometry.initialize_from_main_function = &initialize_box_geometry_from_main_component;
this_box_volume.geometry.process_rot_allocated = 0;

this_box_volume.geometry.copy_geometry_parameters = &allocate_box_storage_copy;

rot_copy(this_box_volume.geometry.rotation_matrix,ROT_A_CURRENT_COMP); //check how ROT_R_CURRENT_COMP would work
rot_transpose(ROT_A_CURRENT_COMP,this_box_volume.geometry.transpose_rotation_matrix);

// Initialize loggers
this_box_volume.loggers.num_elements = 0;

// packing the information into the global_geometry_element, which is then included in the global_geometry_list.
sprintf(global_geometry_element.name,NAME_CURRENT_COMP);
global_geometry_element.activation_counter = number_of_activations;
global_geometry_element.component_index = INDEX_CURRENT_COMP;
global_geometry_element.Volume = &this_box_volume; // Would be nicer if this m was a pointer, now we have the (small) data two places
add_element_to_geometry_list(&global_geometry_list,global_geometry_element);
}
#line 246152 "MACS_sample_kidney_box.c"
#undef number_of_activations
#undef mask_setting
#undef mask_string
#undef p_interact
#undef focus_r
#undef focus_xh
#undef focus_xw
#undef focus_ah
#undef focus_aw
#undef target_z
#undef target_y
#undef target_x
#undef target_index
#undef visualize
#undef yheight2
#undef xwidth2
#undef zdepth
#undef yheight
#undef xwidth
#undef priority
#undef material_string
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

  /* Initializations for component channel_9_analyzer_1_array_crystal_array_5. */
  SIG_MESSAGE("channel_9_analyzer_1_array_crystal_array_5 (Init)");
#define mccompcurname  channel_9_analyzer_1_array_crystal_array_5
#define mccompcurtype  Union_box
#define mccompcurindex 477
#define loop_index mccchannel_9_analyzer_1_array_crystal_array_5_loop_index
#define this_box_volume mccchannel_9_analyzer_1_array_crystal_array_5_this_box_volume
#define global_geometry_element mccchannel_9_analyzer_1_array_crystal_array_5_global_geometry_element
#define this_box_storage mccchannel_9_analyzer_1_array_crystal_array_5_this_box_storage
#define material_string mccchannel_9_analyzer_1_array_crystal_array_5_material_string
#define priority mccchannel_9_analyzer_1_array_crystal_array_5_priority
#define xwidth mccchannel_9_analyzer_1_array_crystal_array_5_xwidth
#define yheight mccchannel_9_analyzer_1_array_crystal_array_5_yheight
#define zdepth mccchannel_9_analyzer_1_array_crystal_array_5_zdepth
#define xwidth2 mccchannel_9_analyzer_1_array_crystal_array_5_xwidth2
#define yheight2 mccchannel_9_analyzer_1_array_crystal_array_5_yheight2
#define visualize mccchannel_9_analyzer_1_array_crystal_array_5_visualize
#define target_index mccchannel_9_analyzer_1_array_crystal_array_5_target_index
#define target_x mccchannel_9_analyzer_1_array_crystal_array_5_target_x
#define target_y mccchannel_9_analyzer_1_array_crystal_array_5_target_y
#define target_z mccchannel_9_analyzer_1_array_crystal_array_5_target_z
#define focus_aw mccchannel_9_analyzer_1_array_crystal_array_5_focus_aw
#define focus_ah mccchannel_9_analyzer_1_array_crystal_array_5_focus_ah
#define focus_xw mccchannel_9_analyzer_1_array_crystal_array_5_focus_xw
#define focus_xh mccchannel_9_analyzer_1_array_crystal_array_5_focus_xh
#define focus_r mccchannel_9_analyzer_1_array_crystal_array_5_focus_r
#define p_interact mccchannel_9_analyzer_1_array_crystal_array_5_p_interact
#define mask_string mccchannel_9_analyzer_1_array_crystal_array_5_mask_string
#define mask_setting mccchannel_9_analyzer_1_array_crystal_array_5_mask_setting
#define number_of_activations mccchannel_9_analyzer_1_array_crystal_array_5_number_of_activations
#line 224 "Union_box.comp"
{
// Initializes the focusing system for this volume including input sanitation.
focus_initialize(&this_box_volume.geometry, POS_A_COMP_INDEX(INDEX_CURRENT_COMP+target_index), POS_A_CURRENT_COMP, ROT_A_CURRENT_COMP, target_index, target_x, target_y, target_z, focus_aw, focus_ah, focus_xw, focus_xh, focus_r, NAME_CURRENT_COMP);

// Input sanitation for this geometry
if (xwidth <= 0) {
  printf("\nERROR in Union_box named %s, the xwidth is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (yheight <= 0) {
  printf("\nERROR in Union_box named %s, yheight is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (zdepth <= 0) {
  printf("\nERROR in Union_box named %s, zdepth is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (xwidth2 <= 0 && xwidth2 != -1) {
  printf("\nERROR in Union_box named %s, the xwidth2 is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (yheight2 <= 0 && yheight2 != -1) {
  printf("\nERROR in Union_box named %s, yheight2 is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}

// Use sanitation
if (global_material_list.num_elements == 0) {
  printf("\nERROR: Need to define a material using Union_make_material before using a Union geometry component. \n");
  printf("       %s was defined before first use of Union_make_material.\n",NAME_CURRENT_COMP);
  exit(1);
}

this_box_volume.geometry.is_masked_volume = 0;
this_box_volume.geometry.is_exit_volume = 0;
this_box_volume.geometry.is_mask_volume = 0;
// check if the volume is a mask, if it is the material string is irelevant.
if (mask_string && strlen(mask_string) && strcmp(mask_string, "NULL") && strcmp(mask_string, "0")) {
    // A mask volume is used to limit the extend of other volumes, called the masked volumes. These are specified in the mask_string.
    // In order for a ray to enter a masked volume, it needs to be both in the region covered by that volume AND the mask volume.
    // When more than
    this_box_volume.geometry.mask_mode = 1; // Default is mask mode is ALL
    if (mask_setting && strlen(mask_setting) && strcmp(mask_setting, "NULL") && strcmp(mask_setting, "0")) {
        if (strcmp(mask_setting,"ALL") == 0 || strcmp(mask_setting,"All") == 0) this_box_volume.geometry.mask_mode = 1;
        else if (strcmp(mask_setting,"ANY") == 0 || strcmp(mask_setting,"Any") == 0) this_box_volume.geometry.mask_mode = 2;
        else {
            printf("The mask_mode of component %s is set to %s, but must be either ALL or ANY.\n",NAME_CURRENT_COMP,mask_setting);
            exit(1);
        }
    }
    
    for (loop_index=0;loop_index<global_geometry_list.num_elements;loop_index++) {
        // Add mask list
        if (1 == manual_linking_function(global_geometry_list.elements[loop_index].name,mask_string)) {
            add_element_to_int_list(&this_box_volume.geometry.mask_list,global_geometry_list.elements[loop_index].component_index);
            add_element_to_int_list(&global_geometry_list.elements[loop_index].Volume->geometry.masked_by_list,INDEX_CURRENT_COMP);
            global_geometry_list.elements[loop_index].Volume->geometry.is_masked_volume = 1;
            if (this_box_volume.geometry.mask_mode == 2)
                global_geometry_list.elements[loop_index].Volume->geometry.mask_mode = 2;
            if (this_box_volume.geometry.mask_mode == 1) {
                if (global_geometry_list.elements[loop_index].Volume->geometry.is_masked_volume == 1 && global_geometry_list.elements[loop_index].Volume->geometry.mask_mode != 2)
                    // If more than one mask is added to one volume, the ANY mode overwrites the (default) ALL mode.
                    global_geometry_list.elements[loop_index].Volume->geometry.mask_mode = 1;
            }
            
            found_geometries = 1;
        }
    }
    if (found_geometries == 0) {
        printf("The mask_string in geometry: %s did not find any of the specified volumes in the mask_string %s \n",NAME_CURRENT_COMP,mask_string);
        exit(1);
    }
    this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
    this_box_volume.p_physics->is_vacuum = 0; // Makes this volume a vacuum
    this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
    this_box_volume.p_physics->my_a = 0; // Should not be used.
    sprintf(this_box_volume.p_physics->name,"Mask");
    this_box_volume.geometry.is_mask_volume = 1;
    
    
// Read the material input, or if it lacks, use automatic linking.
} else if (material_string && strlen(material_string) && strcmp(material_string, "NULL") && strcmp(material_string, "0")) {
    // A geometry string was given, use it to determine which material
    if (0 == strcmp(material_string,"vacuum") || 0 == strcmp(material_string,"Vacuum")) {
        // One could have a global physics struct for vacuum instead of creating one for each
        this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
        this_box_volume.p_physics->is_vacuum = 1; // Makes this volume a vacuum
        this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
        this_box_volume.p_physics->my_a = 0; // Should not be used.
        sprintf(this_box_volume.p_physics->name,"Vacuum");
    } else if (0 == strcmp(material_string,"exit") || 0 == strcmp(material_string,"Exit")) {
        // One could have a global physics struct for vacuum instead of creating one for each
        this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
        this_box_volume.p_physics->is_vacuum = 1; // Makes this volume a vacuum
        this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
        this_box_volume.p_physics->my_a = 0; // Should not be used.
        this_box_volume.geometry.is_exit_volume = 1;
        sprintf(this_box_volume.p_physics->name,"Exit");
    } else {
        #ifndef MATERIAL_DETECTOR
            printf("Need to define a material before refering to it in a geometry %s.\n",NAME_CURRENT_COMP);
            exit(1);
        #endif
        for (loop_index=0;loop_index<global_material_list.num_elements;loop_index++) {
            if (0 == strcmp(material_string,global_material_list.elements[loop_index].name)) {
                this_box_volume.p_physics = global_material_list.elements[loop_index].physics;
                break;
            }
            if (loop_index == global_material_list.num_elements-1) {
            printf("\n");
            printf("ERROR: The material string \"%s\" in Union geometry \"%s\" did not match a specified material. \n",material_string,NAME_CURRENT_COMP);
            printf("       The materials available at this point (need to be defined before the geometry): \n");
            for (loop_index=0;loop_index<global_material_list.num_elements;loop_index++)
              printf("         %s\n",global_material_list.elements[loop_index].name);
            printf("\n");
            printf("       It is also possible to use one of the defualt materials avaiable: \n");
            printf("           Vacuum (for a Volume without scattering or absorption)\n");
            printf("           Exit (for a Volume where the ray exits the component if it enters)\n");
            printf("           Mask (for a Volume that masks existing volumes specified in the mask_string\n");
            exit(1);
          }
        }
    }
} else {
    // Automatic linking, simply using the last defined material.
    #ifndef MATERIAL_DETECTOR
        printf("Need to define a material before the geometry to use automatic linking %s.\n",NAME_CURRENT_COMP);
        exit(1);
    #endif
    this_box_volume.p_physics = global_material_list.elements[global_material_list.num_elements-1].physics;
}

sprintf(this_box_volume.name,NAME_CURRENT_COMP);
sprintf(this_box_volume.geometry.shape,"box");
this_box_volume.geometry.priority_value = priority;
this_box_volume.geometry.geometry_p_interact = p_interact;
// Currently the coordinates will be in absolute space.
this_box_volume.geometry.center = POS_A_CURRENT_COMP;

this_box_storage.z_depth = zdepth;
this_box_storage.x_width1 = xwidth;
this_box_storage.y_height1 = yheight;

this_box_storage.is_rectangle = 0;
if (xwidth2 < 0 && yheight2 < 0) this_box_storage.is_rectangle = 1;
if (xwidth == xwidth2 && yheight == yheight2) this_box_storage.is_rectangle = 1;

if (xwidth2 < 0) {
    this_box_storage.x_width2 = xwidth;
    xwidth2 = xwidth;
} else this_box_storage.x_width2 = xwidth2;

if (yheight2 < 0) {
    this_box_storage.y_height2 = yheight;
    yheight2 = yheight;
} else this_box_storage.y_height2 = yheight2;


this_box_storage.normal_vectors[0] = coords_set(0,0,1);
this_box_storage.normal_vectors[1] = coords_set(0,0,1);

// for sides with y component = 0
x_component = 2*zdepth/sqrt((xwidth-xwidth2)*(xwidth-xwidth2)+4*zdepth*zdepth);
z_component = (xwidth-xwidth2)/sqrt(4*zdepth*zdepth+(xwidth-xwidth2)*(xwidth-xwidth2));

this_box_storage.normal_vectors[2] = coords_set(x_component,0,z_component);
this_box_storage.normal_vectors[3] = coords_set(-x_component,0,z_component);

// for sides with x component = 0
y_component = 2*zdepth/sqrt((yheight-yheight2)*(yheight-yheight2)+4*zdepth*zdepth);
z_component = (yheight-yheight2)/sqrt(4*zdepth*zdepth+(yheight-yheight2)*(yheight-yheight2));

this_box_storage.normal_vectors[4] = coords_set(0,y_component,z_component);
this_box_storage.normal_vectors[5] = coords_set(0,-y_component,z_component);

this_box_volume.geometry.visualization_on = visualize;

this_box_volume.geometry.geometry_parameters.p_box_storage = &this_box_storage;

// Assign pointers to functions for intersection with the shape, checking if a point is inside the shape
if (this_box_storage.is_rectangle == 1) {
this_box_volume.geometry.intersect_function = &sample_box_intersect_simple;
this_box_volume.geometry.within_function = &r_within_box_simple;
}
else {
this_box_volume.geometry.intersect_function = &sample_box_intersect_advanced;
this_box_volume.geometry.within_function = &r_within_box_advanced;
}

this_box_volume.geometry.shell_points = &box_shell_points;
this_box_volume.geometry.mcdisplay_function = &mcdisplay_box_function;
this_box_volume.geometry.initialize_from_main_function = &initialize_box_geometry_from_main_component;
this_box_volume.geometry.process_rot_allocated = 0;

this_box_volume.geometry.copy_geometry_parameters = &allocate_box_storage_copy;

rot_copy(this_box_volume.geometry.rotation_matrix,ROT_A_CURRENT_COMP); //check how ROT_R_CURRENT_COMP would work
rot_transpose(ROT_A_CURRENT_COMP,this_box_volume.geometry.transpose_rotation_matrix);

// Initialize loggers
this_box_volume.loggers.num_elements = 0;

// packing the information into the global_geometry_element, which is then included in the global_geometry_list.
sprintf(global_geometry_element.name,NAME_CURRENT_COMP);
global_geometry_element.activation_counter = number_of_activations;
global_geometry_element.component_index = INDEX_CURRENT_COMP;
global_geometry_element.Volume = &this_box_volume; // Would be nicer if this m was a pointer, now we have the (small) data two places
add_element_to_geometry_list(&global_geometry_list,global_geometry_element);
}
#line 246422 "MACS_sample_kidney_box.c"
#undef number_of_activations
#undef mask_setting
#undef mask_string
#undef p_interact
#undef focus_r
#undef focus_xh
#undef focus_xw
#undef focus_ah
#undef focus_aw
#undef target_z
#undef target_y
#undef target_x
#undef target_index
#undef visualize
#undef yheight2
#undef xwidth2
#undef zdepth
#undef yheight
#undef xwidth
#undef priority
#undef material_string
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

  /* Initializations for component channel_9_analyzer_1_array_crystal_array_6. */
  SIG_MESSAGE("channel_9_analyzer_1_array_crystal_array_6 (Init)");
#define mccompcurname  channel_9_analyzer_1_array_crystal_array_6
#define mccompcurtype  Union_box
#define mccompcurindex 478
#define loop_index mccchannel_9_analyzer_1_array_crystal_array_6_loop_index
#define this_box_volume mccchannel_9_analyzer_1_array_crystal_array_6_this_box_volume
#define global_geometry_element mccchannel_9_analyzer_1_array_crystal_array_6_global_geometry_element
#define this_box_storage mccchannel_9_analyzer_1_array_crystal_array_6_this_box_storage
#define material_string mccchannel_9_analyzer_1_array_crystal_array_6_material_string
#define priority mccchannel_9_analyzer_1_array_crystal_array_6_priority
#define xwidth mccchannel_9_analyzer_1_array_crystal_array_6_xwidth
#define yheight mccchannel_9_analyzer_1_array_crystal_array_6_yheight
#define zdepth mccchannel_9_analyzer_1_array_crystal_array_6_zdepth
#define xwidth2 mccchannel_9_analyzer_1_array_crystal_array_6_xwidth2
#define yheight2 mccchannel_9_analyzer_1_array_crystal_array_6_yheight2
#define visualize mccchannel_9_analyzer_1_array_crystal_array_6_visualize
#define target_index mccchannel_9_analyzer_1_array_crystal_array_6_target_index
#define target_x mccchannel_9_analyzer_1_array_crystal_array_6_target_x
#define target_y mccchannel_9_analyzer_1_array_crystal_array_6_target_y
#define target_z mccchannel_9_analyzer_1_array_crystal_array_6_target_z
#define focus_aw mccchannel_9_analyzer_1_array_crystal_array_6_focus_aw
#define focus_ah mccchannel_9_analyzer_1_array_crystal_array_6_focus_ah
#define focus_xw mccchannel_9_analyzer_1_array_crystal_array_6_focus_xw
#define focus_xh mccchannel_9_analyzer_1_array_crystal_array_6_focus_xh
#define focus_r mccchannel_9_analyzer_1_array_crystal_array_6_focus_r
#define p_interact mccchannel_9_analyzer_1_array_crystal_array_6_p_interact
#define mask_string mccchannel_9_analyzer_1_array_crystal_array_6_mask_string
#define mask_setting mccchannel_9_analyzer_1_array_crystal_array_6_mask_setting
#define number_of_activations mccchannel_9_analyzer_1_array_crystal_array_6_number_of_activations
#line 224 "Union_box.comp"
{
// Initializes the focusing system for this volume including input sanitation.
focus_initialize(&this_box_volume.geometry, POS_A_COMP_INDEX(INDEX_CURRENT_COMP+target_index), POS_A_CURRENT_COMP, ROT_A_CURRENT_COMP, target_index, target_x, target_y, target_z, focus_aw, focus_ah, focus_xw, focus_xh, focus_r, NAME_CURRENT_COMP);

// Input sanitation for this geometry
if (xwidth <= 0) {
  printf("\nERROR in Union_box named %s, the xwidth is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (yheight <= 0) {
  printf("\nERROR in Union_box named %s, yheight is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (zdepth <= 0) {
  printf("\nERROR in Union_box named %s, zdepth is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (xwidth2 <= 0 && xwidth2 != -1) {
  printf("\nERROR in Union_box named %s, the xwidth2 is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (yheight2 <= 0 && yheight2 != -1) {
  printf("\nERROR in Union_box named %s, yheight2 is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}

// Use sanitation
if (global_material_list.num_elements == 0) {
  printf("\nERROR: Need to define a material using Union_make_material before using a Union geometry component. \n");
  printf("       %s was defined before first use of Union_make_material.\n",NAME_CURRENT_COMP);
  exit(1);
}

this_box_volume.geometry.is_masked_volume = 0;
this_box_volume.geometry.is_exit_volume = 0;
this_box_volume.geometry.is_mask_volume = 0;
// check if the volume is a mask, if it is the material string is irelevant.
if (mask_string && strlen(mask_string) && strcmp(mask_string, "NULL") && strcmp(mask_string, "0")) {
    // A mask volume is used to limit the extend of other volumes, called the masked volumes. These are specified in the mask_string.
    // In order for a ray to enter a masked volume, it needs to be both in the region covered by that volume AND the mask volume.
    // When more than
    this_box_volume.geometry.mask_mode = 1; // Default is mask mode is ALL
    if (mask_setting && strlen(mask_setting) && strcmp(mask_setting, "NULL") && strcmp(mask_setting, "0")) {
        if (strcmp(mask_setting,"ALL") == 0 || strcmp(mask_setting,"All") == 0) this_box_volume.geometry.mask_mode = 1;
        else if (strcmp(mask_setting,"ANY") == 0 || strcmp(mask_setting,"Any") == 0) this_box_volume.geometry.mask_mode = 2;
        else {
            printf("The mask_mode of component %s is set to %s, but must be either ALL or ANY.\n",NAME_CURRENT_COMP,mask_setting);
            exit(1);
        }
    }
    
    for (loop_index=0;loop_index<global_geometry_list.num_elements;loop_index++) {
        // Add mask list
        if (1 == manual_linking_function(global_geometry_list.elements[loop_index].name,mask_string)) {
            add_element_to_int_list(&this_box_volume.geometry.mask_list,global_geometry_list.elements[loop_index].component_index);
            add_element_to_int_list(&global_geometry_list.elements[loop_index].Volume->geometry.masked_by_list,INDEX_CURRENT_COMP);
            global_geometry_list.elements[loop_index].Volume->geometry.is_masked_volume = 1;
            if (this_box_volume.geometry.mask_mode == 2)
                global_geometry_list.elements[loop_index].Volume->geometry.mask_mode = 2;
            if (this_box_volume.geometry.mask_mode == 1) {
                if (global_geometry_list.elements[loop_index].Volume->geometry.is_masked_volume == 1 && global_geometry_list.elements[loop_index].Volume->geometry.mask_mode != 2)
                    // If more than one mask is added to one volume, the ANY mode overwrites the (default) ALL mode.
                    global_geometry_list.elements[loop_index].Volume->geometry.mask_mode = 1;
            }
            
            found_geometries = 1;
        }
    }
    if (found_geometries == 0) {
        printf("The mask_string in geometry: %s did not find any of the specified volumes in the mask_string %s \n",NAME_CURRENT_COMP,mask_string);
        exit(1);
    }
    this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
    this_box_volume.p_physics->is_vacuum = 0; // Makes this volume a vacuum
    this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
    this_box_volume.p_physics->my_a = 0; // Should not be used.
    sprintf(this_box_volume.p_physics->name,"Mask");
    this_box_volume.geometry.is_mask_volume = 1;
    
    
// Read the material input, or if it lacks, use automatic linking.
} else if (material_string && strlen(material_string) && strcmp(material_string, "NULL") && strcmp(material_string, "0")) {
    // A geometry string was given, use it to determine which material
    if (0 == strcmp(material_string,"vacuum") || 0 == strcmp(material_string,"Vacuum")) {
        // One could have a global physics struct for vacuum instead of creating one for each
        this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
        this_box_volume.p_physics->is_vacuum = 1; // Makes this volume a vacuum
        this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
        this_box_volume.p_physics->my_a = 0; // Should not be used.
        sprintf(this_box_volume.p_physics->name,"Vacuum");
    } else if (0 == strcmp(material_string,"exit") || 0 == strcmp(material_string,"Exit")) {
        // One could have a global physics struct for vacuum instead of creating one for each
        this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
        this_box_volume.p_physics->is_vacuum = 1; // Makes this volume a vacuum
        this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
        this_box_volume.p_physics->my_a = 0; // Should not be used.
        this_box_volume.geometry.is_exit_volume = 1;
        sprintf(this_box_volume.p_physics->name,"Exit");
    } else {
        #ifndef MATERIAL_DETECTOR
            printf("Need to define a material before refering to it in a geometry %s.\n",NAME_CURRENT_COMP);
            exit(1);
        #endif
        for (loop_index=0;loop_index<global_material_list.num_elements;loop_index++) {
            if (0 == strcmp(material_string,global_material_list.elements[loop_index].name)) {
                this_box_volume.p_physics = global_material_list.elements[loop_index].physics;
                break;
            }
            if (loop_index == global_material_list.num_elements-1) {
            printf("\n");
            printf("ERROR: The material string \"%s\" in Union geometry \"%s\" did not match a specified material. \n",material_string,NAME_CURRENT_COMP);
            printf("       The materials available at this point (need to be defined before the geometry): \n");
            for (loop_index=0;loop_index<global_material_list.num_elements;loop_index++)
              printf("         %s\n",global_material_list.elements[loop_index].name);
            printf("\n");
            printf("       It is also possible to use one of the defualt materials avaiable: \n");
            printf("           Vacuum (for a Volume without scattering or absorption)\n");
            printf("           Exit (for a Volume where the ray exits the component if it enters)\n");
            printf("           Mask (for a Volume that masks existing volumes specified in the mask_string\n");
            exit(1);
          }
        }
    }
} else {
    // Automatic linking, simply using the last defined material.
    #ifndef MATERIAL_DETECTOR
        printf("Need to define a material before the geometry to use automatic linking %s.\n",NAME_CURRENT_COMP);
        exit(1);
    #endif
    this_box_volume.p_physics = global_material_list.elements[global_material_list.num_elements-1].physics;
}

sprintf(this_box_volume.name,NAME_CURRENT_COMP);
sprintf(this_box_volume.geometry.shape,"box");
this_box_volume.geometry.priority_value = priority;
this_box_volume.geometry.geometry_p_interact = p_interact;
// Currently the coordinates will be in absolute space.
this_box_volume.geometry.center = POS_A_CURRENT_COMP;

this_box_storage.z_depth = zdepth;
this_box_storage.x_width1 = xwidth;
this_box_storage.y_height1 = yheight;

this_box_storage.is_rectangle = 0;
if (xwidth2 < 0 && yheight2 < 0) this_box_storage.is_rectangle = 1;
if (xwidth == xwidth2 && yheight == yheight2) this_box_storage.is_rectangle = 1;

if (xwidth2 < 0) {
    this_box_storage.x_width2 = xwidth;
    xwidth2 = xwidth;
} else this_box_storage.x_width2 = xwidth2;

if (yheight2 < 0) {
    this_box_storage.y_height2 = yheight;
    yheight2 = yheight;
} else this_box_storage.y_height2 = yheight2;


this_box_storage.normal_vectors[0] = coords_set(0,0,1);
this_box_storage.normal_vectors[1] = coords_set(0,0,1);

// for sides with y component = 0
x_component = 2*zdepth/sqrt((xwidth-xwidth2)*(xwidth-xwidth2)+4*zdepth*zdepth);
z_component = (xwidth-xwidth2)/sqrt(4*zdepth*zdepth+(xwidth-xwidth2)*(xwidth-xwidth2));

this_box_storage.normal_vectors[2] = coords_set(x_component,0,z_component);
this_box_storage.normal_vectors[3] = coords_set(-x_component,0,z_component);

// for sides with x component = 0
y_component = 2*zdepth/sqrt((yheight-yheight2)*(yheight-yheight2)+4*zdepth*zdepth);
z_component = (yheight-yheight2)/sqrt(4*zdepth*zdepth+(yheight-yheight2)*(yheight-yheight2));

this_box_storage.normal_vectors[4] = coords_set(0,y_component,z_component);
this_box_storage.normal_vectors[5] = coords_set(0,-y_component,z_component);

this_box_volume.geometry.visualization_on = visualize;

this_box_volume.geometry.geometry_parameters.p_box_storage = &this_box_storage;

// Assign pointers to functions for intersection with the shape, checking if a point is inside the shape
if (this_box_storage.is_rectangle == 1) {
this_box_volume.geometry.intersect_function = &sample_box_intersect_simple;
this_box_volume.geometry.within_function = &r_within_box_simple;
}
else {
this_box_volume.geometry.intersect_function = &sample_box_intersect_advanced;
this_box_volume.geometry.within_function = &r_within_box_advanced;
}

this_box_volume.geometry.shell_points = &box_shell_points;
this_box_volume.geometry.mcdisplay_function = &mcdisplay_box_function;
this_box_volume.geometry.initialize_from_main_function = &initialize_box_geometry_from_main_component;
this_box_volume.geometry.process_rot_allocated = 0;

this_box_volume.geometry.copy_geometry_parameters = &allocate_box_storage_copy;

rot_copy(this_box_volume.geometry.rotation_matrix,ROT_A_CURRENT_COMP); //check how ROT_R_CURRENT_COMP would work
rot_transpose(ROT_A_CURRENT_COMP,this_box_volume.geometry.transpose_rotation_matrix);

// Initialize loggers
this_box_volume.loggers.num_elements = 0;

// packing the information into the global_geometry_element, which is then included in the global_geometry_list.
sprintf(global_geometry_element.name,NAME_CURRENT_COMP);
global_geometry_element.activation_counter = number_of_activations;
global_geometry_element.component_index = INDEX_CURRENT_COMP;
global_geometry_element.Volume = &this_box_volume; // Would be nicer if this m was a pointer, now we have the (small) data two places
add_element_to_geometry_list(&global_geometry_list,global_geometry_element);
}
#line 246692 "MACS_sample_kidney_box.c"
#undef number_of_activations
#undef mask_setting
#undef mask_string
#undef p_interact
#undef focus_r
#undef focus_xh
#undef focus_xw
#undef focus_ah
#undef focus_aw
#undef target_z
#undef target_y
#undef target_x
#undef target_index
#undef visualize
#undef yheight2
#undef xwidth2
#undef zdepth
#undef yheight
#undef xwidth
#undef priority
#undef material_string
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

  /* Initializations for component channel_9_analyzer_1_array_crystal_array_7. */
  SIG_MESSAGE("channel_9_analyzer_1_array_crystal_array_7 (Init)");
#define mccompcurname  channel_9_analyzer_1_array_crystal_array_7
#define mccompcurtype  Union_box
#define mccompcurindex 479
#define loop_index mccchannel_9_analyzer_1_array_crystal_array_7_loop_index
#define this_box_volume mccchannel_9_analyzer_1_array_crystal_array_7_this_box_volume
#define global_geometry_element mccchannel_9_analyzer_1_array_crystal_array_7_global_geometry_element
#define this_box_storage mccchannel_9_analyzer_1_array_crystal_array_7_this_box_storage
#define material_string mccchannel_9_analyzer_1_array_crystal_array_7_material_string
#define priority mccchannel_9_analyzer_1_array_crystal_array_7_priority
#define xwidth mccchannel_9_analyzer_1_array_crystal_array_7_xwidth
#define yheight mccchannel_9_analyzer_1_array_crystal_array_7_yheight
#define zdepth mccchannel_9_analyzer_1_array_crystal_array_7_zdepth
#define xwidth2 mccchannel_9_analyzer_1_array_crystal_array_7_xwidth2
#define yheight2 mccchannel_9_analyzer_1_array_crystal_array_7_yheight2
#define visualize mccchannel_9_analyzer_1_array_crystal_array_7_visualize
#define target_index mccchannel_9_analyzer_1_array_crystal_array_7_target_index
#define target_x mccchannel_9_analyzer_1_array_crystal_array_7_target_x
#define target_y mccchannel_9_analyzer_1_array_crystal_array_7_target_y
#define target_z mccchannel_9_analyzer_1_array_crystal_array_7_target_z
#define focus_aw mccchannel_9_analyzer_1_array_crystal_array_7_focus_aw
#define focus_ah mccchannel_9_analyzer_1_array_crystal_array_7_focus_ah
#define focus_xw mccchannel_9_analyzer_1_array_crystal_array_7_focus_xw
#define focus_xh mccchannel_9_analyzer_1_array_crystal_array_7_focus_xh
#define focus_r mccchannel_9_analyzer_1_array_crystal_array_7_focus_r
#define p_interact mccchannel_9_analyzer_1_array_crystal_array_7_p_interact
#define mask_string mccchannel_9_analyzer_1_array_crystal_array_7_mask_string
#define mask_setting mccchannel_9_analyzer_1_array_crystal_array_7_mask_setting
#define number_of_activations mccchannel_9_analyzer_1_array_crystal_array_7_number_of_activations
#line 224 "Union_box.comp"
{
// Initializes the focusing system for this volume including input sanitation.
focus_initialize(&this_box_volume.geometry, POS_A_COMP_INDEX(INDEX_CURRENT_COMP+target_index), POS_A_CURRENT_COMP, ROT_A_CURRENT_COMP, target_index, target_x, target_y, target_z, focus_aw, focus_ah, focus_xw, focus_xh, focus_r, NAME_CURRENT_COMP);

// Input sanitation for this geometry
if (xwidth <= 0) {
  printf("\nERROR in Union_box named %s, the xwidth is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (yheight <= 0) {
  printf("\nERROR in Union_box named %s, yheight is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (zdepth <= 0) {
  printf("\nERROR in Union_box named %s, zdepth is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (xwidth2 <= 0 && xwidth2 != -1) {
  printf("\nERROR in Union_box named %s, the xwidth2 is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (yheight2 <= 0 && yheight2 != -1) {
  printf("\nERROR in Union_box named %s, yheight2 is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}

// Use sanitation
if (global_material_list.num_elements == 0) {
  printf("\nERROR: Need to define a material using Union_make_material before using a Union geometry component. \n");
  printf("       %s was defined before first use of Union_make_material.\n",NAME_CURRENT_COMP);
  exit(1);
}

this_box_volume.geometry.is_masked_volume = 0;
this_box_volume.geometry.is_exit_volume = 0;
this_box_volume.geometry.is_mask_volume = 0;
// check if the volume is a mask, if it is the material string is irelevant.
if (mask_string && strlen(mask_string) && strcmp(mask_string, "NULL") && strcmp(mask_string, "0")) {
    // A mask volume is used to limit the extend of other volumes, called the masked volumes. These are specified in the mask_string.
    // In order for a ray to enter a masked volume, it needs to be both in the region covered by that volume AND the mask volume.
    // When more than
    this_box_volume.geometry.mask_mode = 1; // Default is mask mode is ALL
    if (mask_setting && strlen(mask_setting) && strcmp(mask_setting, "NULL") && strcmp(mask_setting, "0")) {
        if (strcmp(mask_setting,"ALL") == 0 || strcmp(mask_setting,"All") == 0) this_box_volume.geometry.mask_mode = 1;
        else if (strcmp(mask_setting,"ANY") == 0 || strcmp(mask_setting,"Any") == 0) this_box_volume.geometry.mask_mode = 2;
        else {
            printf("The mask_mode of component %s is set to %s, but must be either ALL or ANY.\n",NAME_CURRENT_COMP,mask_setting);
            exit(1);
        }
    }
    
    for (loop_index=0;loop_index<global_geometry_list.num_elements;loop_index++) {
        // Add mask list
        if (1 == manual_linking_function(global_geometry_list.elements[loop_index].name,mask_string)) {
            add_element_to_int_list(&this_box_volume.geometry.mask_list,global_geometry_list.elements[loop_index].component_index);
            add_element_to_int_list(&global_geometry_list.elements[loop_index].Volume->geometry.masked_by_list,INDEX_CURRENT_COMP);
            global_geometry_list.elements[loop_index].Volume->geometry.is_masked_volume = 1;
            if (this_box_volume.geometry.mask_mode == 2)
                global_geometry_list.elements[loop_index].Volume->geometry.mask_mode = 2;
            if (this_box_volume.geometry.mask_mode == 1) {
                if (global_geometry_list.elements[loop_index].Volume->geometry.is_masked_volume == 1 && global_geometry_list.elements[loop_index].Volume->geometry.mask_mode != 2)
                    // If more than one mask is added to one volume, the ANY mode overwrites the (default) ALL mode.
                    global_geometry_list.elements[loop_index].Volume->geometry.mask_mode = 1;
            }
            
            found_geometries = 1;
        }
    }
    if (found_geometries == 0) {
        printf("The mask_string in geometry: %s did not find any of the specified volumes in the mask_string %s \n",NAME_CURRENT_COMP,mask_string);
        exit(1);
    }
    this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
    this_box_volume.p_physics->is_vacuum = 0; // Makes this volume a vacuum
    this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
    this_box_volume.p_physics->my_a = 0; // Should not be used.
    sprintf(this_box_volume.p_physics->name,"Mask");
    this_box_volume.geometry.is_mask_volume = 1;
    
    
// Read the material input, or if it lacks, use automatic linking.
} else if (material_string && strlen(material_string) && strcmp(material_string, "NULL") && strcmp(material_string, "0")) {
    // A geometry string was given, use it to determine which material
    if (0 == strcmp(material_string,"vacuum") || 0 == strcmp(material_string,"Vacuum")) {
        // One could have a global physics struct for vacuum instead of creating one for each
        this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
        this_box_volume.p_physics->is_vacuum = 1; // Makes this volume a vacuum
        this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
        this_box_volume.p_physics->my_a = 0; // Should not be used.
        sprintf(this_box_volume.p_physics->name,"Vacuum");
    } else if (0 == strcmp(material_string,"exit") || 0 == strcmp(material_string,"Exit")) {
        // One could have a global physics struct for vacuum instead of creating one for each
        this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
        this_box_volume.p_physics->is_vacuum = 1; // Makes this volume a vacuum
        this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
        this_box_volume.p_physics->my_a = 0; // Should not be used.
        this_box_volume.geometry.is_exit_volume = 1;
        sprintf(this_box_volume.p_physics->name,"Exit");
    } else {
        #ifndef MATERIAL_DETECTOR
            printf("Need to define a material before refering to it in a geometry %s.\n",NAME_CURRENT_COMP);
            exit(1);
        #endif
        for (loop_index=0;loop_index<global_material_list.num_elements;loop_index++) {
            if (0 == strcmp(material_string,global_material_list.elements[loop_index].name)) {
                this_box_volume.p_physics = global_material_list.elements[loop_index].physics;
                break;
            }
            if (loop_index == global_material_list.num_elements-1) {
            printf("\n");
            printf("ERROR: The material string \"%s\" in Union geometry \"%s\" did not match a specified material. \n",material_string,NAME_CURRENT_COMP);
            printf("       The materials available at this point (need to be defined before the geometry): \n");
            for (loop_index=0;loop_index<global_material_list.num_elements;loop_index++)
              printf("         %s\n",global_material_list.elements[loop_index].name);
            printf("\n");
            printf("       It is also possible to use one of the defualt materials avaiable: \n");
            printf("           Vacuum (for a Volume without scattering or absorption)\n");
            printf("           Exit (for a Volume where the ray exits the component if it enters)\n");
            printf("           Mask (for a Volume that masks existing volumes specified in the mask_string\n");
            exit(1);
          }
        }
    }
} else {
    // Automatic linking, simply using the last defined material.
    #ifndef MATERIAL_DETECTOR
        printf("Need to define a material before the geometry to use automatic linking %s.\n",NAME_CURRENT_COMP);
        exit(1);
    #endif
    this_box_volume.p_physics = global_material_list.elements[global_material_list.num_elements-1].physics;
}

sprintf(this_box_volume.name,NAME_CURRENT_COMP);
sprintf(this_box_volume.geometry.shape,"box");
this_box_volume.geometry.priority_value = priority;
this_box_volume.geometry.geometry_p_interact = p_interact;
// Currently the coordinates will be in absolute space.
this_box_volume.geometry.center = POS_A_CURRENT_COMP;

this_box_storage.z_depth = zdepth;
this_box_storage.x_width1 = xwidth;
this_box_storage.y_height1 = yheight;

this_box_storage.is_rectangle = 0;
if (xwidth2 < 0 && yheight2 < 0) this_box_storage.is_rectangle = 1;
if (xwidth == xwidth2 && yheight == yheight2) this_box_storage.is_rectangle = 1;

if (xwidth2 < 0) {
    this_box_storage.x_width2 = xwidth;
    xwidth2 = xwidth;
} else this_box_storage.x_width2 = xwidth2;

if (yheight2 < 0) {
    this_box_storage.y_height2 = yheight;
    yheight2 = yheight;
} else this_box_storage.y_height2 = yheight2;


this_box_storage.normal_vectors[0] = coords_set(0,0,1);
this_box_storage.normal_vectors[1] = coords_set(0,0,1);

// for sides with y component = 0
x_component = 2*zdepth/sqrt((xwidth-xwidth2)*(xwidth-xwidth2)+4*zdepth*zdepth);
z_component = (xwidth-xwidth2)/sqrt(4*zdepth*zdepth+(xwidth-xwidth2)*(xwidth-xwidth2));

this_box_storage.normal_vectors[2] = coords_set(x_component,0,z_component);
this_box_storage.normal_vectors[3] = coords_set(-x_component,0,z_component);

// for sides with x component = 0
y_component = 2*zdepth/sqrt((yheight-yheight2)*(yheight-yheight2)+4*zdepth*zdepth);
z_component = (yheight-yheight2)/sqrt(4*zdepth*zdepth+(yheight-yheight2)*(yheight-yheight2));

this_box_storage.normal_vectors[4] = coords_set(0,y_component,z_component);
this_box_storage.normal_vectors[5] = coords_set(0,-y_component,z_component);

this_box_volume.geometry.visualization_on = visualize;

this_box_volume.geometry.geometry_parameters.p_box_storage = &this_box_storage;

// Assign pointers to functions for intersection with the shape, checking if a point is inside the shape
if (this_box_storage.is_rectangle == 1) {
this_box_volume.geometry.intersect_function = &sample_box_intersect_simple;
this_box_volume.geometry.within_function = &r_within_box_simple;
}
else {
this_box_volume.geometry.intersect_function = &sample_box_intersect_advanced;
this_box_volume.geometry.within_function = &r_within_box_advanced;
}

this_box_volume.geometry.shell_points = &box_shell_points;
this_box_volume.geometry.mcdisplay_function = &mcdisplay_box_function;
this_box_volume.geometry.initialize_from_main_function = &initialize_box_geometry_from_main_component;
this_box_volume.geometry.process_rot_allocated = 0;

this_box_volume.geometry.copy_geometry_parameters = &allocate_box_storage_copy;

rot_copy(this_box_volume.geometry.rotation_matrix,ROT_A_CURRENT_COMP); //check how ROT_R_CURRENT_COMP would work
rot_transpose(ROT_A_CURRENT_COMP,this_box_volume.geometry.transpose_rotation_matrix);

// Initialize loggers
this_box_volume.loggers.num_elements = 0;

// packing the information into the global_geometry_element, which is then included in the global_geometry_list.
sprintf(global_geometry_element.name,NAME_CURRENT_COMP);
global_geometry_element.activation_counter = number_of_activations;
global_geometry_element.component_index = INDEX_CURRENT_COMP;
global_geometry_element.Volume = &this_box_volume; // Would be nicer if this m was a pointer, now we have the (small) data two places
add_element_to_geometry_list(&global_geometry_list,global_geometry_element);
}
#line 246962 "MACS_sample_kidney_box.c"
#undef number_of_activations
#undef mask_setting
#undef mask_string
#undef p_interact
#undef focus_r
#undef focus_xh
#undef focus_xw
#undef focus_ah
#undef focus_aw
#undef target_z
#undef target_y
#undef target_x
#undef target_index
#undef visualize
#undef yheight2
#undef xwidth2
#undef zdepth
#undef yheight
#undef xwidth
#undef priority
#undef material_string
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

  /* Initializations for component channel_9_analyzer_1_array_crystal_array_8. */
  SIG_MESSAGE("channel_9_analyzer_1_array_crystal_array_8 (Init)");
#define mccompcurname  channel_9_analyzer_1_array_crystal_array_8
#define mccompcurtype  Union_box
#define mccompcurindex 480
#define loop_index mccchannel_9_analyzer_1_array_crystal_array_8_loop_index
#define this_box_volume mccchannel_9_analyzer_1_array_crystal_array_8_this_box_volume
#define global_geometry_element mccchannel_9_analyzer_1_array_crystal_array_8_global_geometry_element
#define this_box_storage mccchannel_9_analyzer_1_array_crystal_array_8_this_box_storage
#define material_string mccchannel_9_analyzer_1_array_crystal_array_8_material_string
#define priority mccchannel_9_analyzer_1_array_crystal_array_8_priority
#define xwidth mccchannel_9_analyzer_1_array_crystal_array_8_xwidth
#define yheight mccchannel_9_analyzer_1_array_crystal_array_8_yheight
#define zdepth mccchannel_9_analyzer_1_array_crystal_array_8_zdepth
#define xwidth2 mccchannel_9_analyzer_1_array_crystal_array_8_xwidth2
#define yheight2 mccchannel_9_analyzer_1_array_crystal_array_8_yheight2
#define visualize mccchannel_9_analyzer_1_array_crystal_array_8_visualize
#define target_index mccchannel_9_analyzer_1_array_crystal_array_8_target_index
#define target_x mccchannel_9_analyzer_1_array_crystal_array_8_target_x
#define target_y mccchannel_9_analyzer_1_array_crystal_array_8_target_y
#define target_z mccchannel_9_analyzer_1_array_crystal_array_8_target_z
#define focus_aw mccchannel_9_analyzer_1_array_crystal_array_8_focus_aw
#define focus_ah mccchannel_9_analyzer_1_array_crystal_array_8_focus_ah
#define focus_xw mccchannel_9_analyzer_1_array_crystal_array_8_focus_xw
#define focus_xh mccchannel_9_analyzer_1_array_crystal_array_8_focus_xh
#define focus_r mccchannel_9_analyzer_1_array_crystal_array_8_focus_r
#define p_interact mccchannel_9_analyzer_1_array_crystal_array_8_p_interact
#define mask_string mccchannel_9_analyzer_1_array_crystal_array_8_mask_string
#define mask_setting mccchannel_9_analyzer_1_array_crystal_array_8_mask_setting
#define number_of_activations mccchannel_9_analyzer_1_array_crystal_array_8_number_of_activations
#line 224 "Union_box.comp"
{
// Initializes the focusing system for this volume including input sanitation.
focus_initialize(&this_box_volume.geometry, POS_A_COMP_INDEX(INDEX_CURRENT_COMP+target_index), POS_A_CURRENT_COMP, ROT_A_CURRENT_COMP, target_index, target_x, target_y, target_z, focus_aw, focus_ah, focus_xw, focus_xh, focus_r, NAME_CURRENT_COMP);

// Input sanitation for this geometry
if (xwidth <= 0) {
  printf("\nERROR in Union_box named %s, the xwidth is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (yheight <= 0) {
  printf("\nERROR in Union_box named %s, yheight is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (zdepth <= 0) {
  printf("\nERROR in Union_box named %s, zdepth is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (xwidth2 <= 0 && xwidth2 != -1) {
  printf("\nERROR in Union_box named %s, the xwidth2 is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (yheight2 <= 0 && yheight2 != -1) {
  printf("\nERROR in Union_box named %s, yheight2 is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}

// Use sanitation
if (global_material_list.num_elements == 0) {
  printf("\nERROR: Need to define a material using Union_make_material before using a Union geometry component. \n");
  printf("       %s was defined before first use of Union_make_material.\n",NAME_CURRENT_COMP);
  exit(1);
}

this_box_volume.geometry.is_masked_volume = 0;
this_box_volume.geometry.is_exit_volume = 0;
this_box_volume.geometry.is_mask_volume = 0;
// check if the volume is a mask, if it is the material string is irelevant.
if (mask_string && strlen(mask_string) && strcmp(mask_string, "NULL") && strcmp(mask_string, "0")) {
    // A mask volume is used to limit the extend of other volumes, called the masked volumes. These are specified in the mask_string.
    // In order for a ray to enter a masked volume, it needs to be both in the region covered by that volume AND the mask volume.
    // When more than
    this_box_volume.geometry.mask_mode = 1; // Default is mask mode is ALL
    if (mask_setting && strlen(mask_setting) && strcmp(mask_setting, "NULL") && strcmp(mask_setting, "0")) {
        if (strcmp(mask_setting,"ALL") == 0 || strcmp(mask_setting,"All") == 0) this_box_volume.geometry.mask_mode = 1;
        else if (strcmp(mask_setting,"ANY") == 0 || strcmp(mask_setting,"Any") == 0) this_box_volume.geometry.mask_mode = 2;
        else {
            printf("The mask_mode of component %s is set to %s, but must be either ALL or ANY.\n",NAME_CURRENT_COMP,mask_setting);
            exit(1);
        }
    }
    
    for (loop_index=0;loop_index<global_geometry_list.num_elements;loop_index++) {
        // Add mask list
        if (1 == manual_linking_function(global_geometry_list.elements[loop_index].name,mask_string)) {
            add_element_to_int_list(&this_box_volume.geometry.mask_list,global_geometry_list.elements[loop_index].component_index);
            add_element_to_int_list(&global_geometry_list.elements[loop_index].Volume->geometry.masked_by_list,INDEX_CURRENT_COMP);
            global_geometry_list.elements[loop_index].Volume->geometry.is_masked_volume = 1;
            if (this_box_volume.geometry.mask_mode == 2)
                global_geometry_list.elements[loop_index].Volume->geometry.mask_mode = 2;
            if (this_box_volume.geometry.mask_mode == 1) {
                if (global_geometry_list.elements[loop_index].Volume->geometry.is_masked_volume == 1 && global_geometry_list.elements[loop_index].Volume->geometry.mask_mode != 2)
                    // If more than one mask is added to one volume, the ANY mode overwrites the (default) ALL mode.
                    global_geometry_list.elements[loop_index].Volume->geometry.mask_mode = 1;
            }
            
            found_geometries = 1;
        }
    }
    if (found_geometries == 0) {
        printf("The mask_string in geometry: %s did not find any of the specified volumes in the mask_string %s \n",NAME_CURRENT_COMP,mask_string);
        exit(1);
    }
    this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
    this_box_volume.p_physics->is_vacuum = 0; // Makes this volume a vacuum
    this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
    this_box_volume.p_physics->my_a = 0; // Should not be used.
    sprintf(this_box_volume.p_physics->name,"Mask");
    this_box_volume.geometry.is_mask_volume = 1;
    
    
// Read the material input, or if it lacks, use automatic linking.
} else if (material_string && strlen(material_string) && strcmp(material_string, "NULL") && strcmp(material_string, "0")) {
    // A geometry string was given, use it to determine which material
    if (0 == strcmp(material_string,"vacuum") || 0 == strcmp(material_string,"Vacuum")) {
        // One could have a global physics struct for vacuum instead of creating one for each
        this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
        this_box_volume.p_physics->is_vacuum = 1; // Makes this volume a vacuum
        this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
        this_box_volume.p_physics->my_a = 0; // Should not be used.
        sprintf(this_box_volume.p_physics->name,"Vacuum");
    } else if (0 == strcmp(material_string,"exit") || 0 == strcmp(material_string,"Exit")) {
        // One could have a global physics struct for vacuum instead of creating one for each
        this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
        this_box_volume.p_physics->is_vacuum = 1; // Makes this volume a vacuum
        this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
        this_box_volume.p_physics->my_a = 0; // Should not be used.
        this_box_volume.geometry.is_exit_volume = 1;
        sprintf(this_box_volume.p_physics->name,"Exit");
    } else {
        #ifndef MATERIAL_DETECTOR
            printf("Need to define a material before refering to it in a geometry %s.\n",NAME_CURRENT_COMP);
            exit(1);
        #endif
        for (loop_index=0;loop_index<global_material_list.num_elements;loop_index++) {
            if (0 == strcmp(material_string,global_material_list.elements[loop_index].name)) {
                this_box_volume.p_physics = global_material_list.elements[loop_index].physics;
                break;
            }
            if (loop_index == global_material_list.num_elements-1) {
            printf("\n");
            printf("ERROR: The material string \"%s\" in Union geometry \"%s\" did not match a specified material. \n",material_string,NAME_CURRENT_COMP);
            printf("       The materials available at this point (need to be defined before the geometry): \n");
            for (loop_index=0;loop_index<global_material_list.num_elements;loop_index++)
              printf("         %s\n",global_material_list.elements[loop_index].name);
            printf("\n");
            printf("       It is also possible to use one of the defualt materials avaiable: \n");
            printf("           Vacuum (for a Volume without scattering or absorption)\n");
            printf("           Exit (for a Volume where the ray exits the component if it enters)\n");
            printf("           Mask (for a Volume that masks existing volumes specified in the mask_string\n");
            exit(1);
          }
        }
    }
} else {
    // Automatic linking, simply using the last defined material.
    #ifndef MATERIAL_DETECTOR
        printf("Need to define a material before the geometry to use automatic linking %s.\n",NAME_CURRENT_COMP);
        exit(1);
    #endif
    this_box_volume.p_physics = global_material_list.elements[global_material_list.num_elements-1].physics;
}

sprintf(this_box_volume.name,NAME_CURRENT_COMP);
sprintf(this_box_volume.geometry.shape,"box");
this_box_volume.geometry.priority_value = priority;
this_box_volume.geometry.geometry_p_interact = p_interact;
// Currently the coordinates will be in absolute space.
this_box_volume.geometry.center = POS_A_CURRENT_COMP;

this_box_storage.z_depth = zdepth;
this_box_storage.x_width1 = xwidth;
this_box_storage.y_height1 = yheight;

this_box_storage.is_rectangle = 0;
if (xwidth2 < 0 && yheight2 < 0) this_box_storage.is_rectangle = 1;
if (xwidth == xwidth2 && yheight == yheight2) this_box_storage.is_rectangle = 1;

if (xwidth2 < 0) {
    this_box_storage.x_width2 = xwidth;
    xwidth2 = xwidth;
} else this_box_storage.x_width2 = xwidth2;

if (yheight2 < 0) {
    this_box_storage.y_height2 = yheight;
    yheight2 = yheight;
} else this_box_storage.y_height2 = yheight2;


this_box_storage.normal_vectors[0] = coords_set(0,0,1);
this_box_storage.normal_vectors[1] = coords_set(0,0,1);

// for sides with y component = 0
x_component = 2*zdepth/sqrt((xwidth-xwidth2)*(xwidth-xwidth2)+4*zdepth*zdepth);
z_component = (xwidth-xwidth2)/sqrt(4*zdepth*zdepth+(xwidth-xwidth2)*(xwidth-xwidth2));

this_box_storage.normal_vectors[2] = coords_set(x_component,0,z_component);
this_box_storage.normal_vectors[3] = coords_set(-x_component,0,z_component);

// for sides with x component = 0
y_component = 2*zdepth/sqrt((yheight-yheight2)*(yheight-yheight2)+4*zdepth*zdepth);
z_component = (yheight-yheight2)/sqrt(4*zdepth*zdepth+(yheight-yheight2)*(yheight-yheight2));

this_box_storage.normal_vectors[4] = coords_set(0,y_component,z_component);
this_box_storage.normal_vectors[5] = coords_set(0,-y_component,z_component);

this_box_volume.geometry.visualization_on = visualize;

this_box_volume.geometry.geometry_parameters.p_box_storage = &this_box_storage;

// Assign pointers to functions for intersection with the shape, checking if a point is inside the shape
if (this_box_storage.is_rectangle == 1) {
this_box_volume.geometry.intersect_function = &sample_box_intersect_simple;
this_box_volume.geometry.within_function = &r_within_box_simple;
}
else {
this_box_volume.geometry.intersect_function = &sample_box_intersect_advanced;
this_box_volume.geometry.within_function = &r_within_box_advanced;
}

this_box_volume.geometry.shell_points = &box_shell_points;
this_box_volume.geometry.mcdisplay_function = &mcdisplay_box_function;
this_box_volume.geometry.initialize_from_main_function = &initialize_box_geometry_from_main_component;
this_box_volume.geometry.process_rot_allocated = 0;

this_box_volume.geometry.copy_geometry_parameters = &allocate_box_storage_copy;

rot_copy(this_box_volume.geometry.rotation_matrix,ROT_A_CURRENT_COMP); //check how ROT_R_CURRENT_COMP would work
rot_transpose(ROT_A_CURRENT_COMP,this_box_volume.geometry.transpose_rotation_matrix);

// Initialize loggers
this_box_volume.loggers.num_elements = 0;

// packing the information into the global_geometry_element, which is then included in the global_geometry_list.
sprintf(global_geometry_element.name,NAME_CURRENT_COMP);
global_geometry_element.activation_counter = number_of_activations;
global_geometry_element.component_index = INDEX_CURRENT_COMP;
global_geometry_element.Volume = &this_box_volume; // Would be nicer if this m was a pointer, now we have the (small) data two places
add_element_to_geometry_list(&global_geometry_list,global_geometry_element);
}
#line 247232 "MACS_sample_kidney_box.c"
#undef number_of_activations
#undef mask_setting
#undef mask_string
#undef p_interact
#undef focus_r
#undef focus_xh
#undef focus_xw
#undef focus_ah
#undef focus_aw
#undef target_z
#undef target_y
#undef target_x
#undef target_index
#undef visualize
#undef yheight2
#undef xwidth2
#undef zdepth
#undef yheight
#undef xwidth
#undef priority
#undef material_string
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

  /* Initializations for component channel_9_analyzer_2_center. */
  SIG_MESSAGE("channel_9_analyzer_2_center (Init)");

  /* Initializations for component channel_9_analyzer_2_rotated. */
  SIG_MESSAGE("channel_9_analyzer_2_rotated (Init)");

  /* Initializations for component channel_9_analyzer_2_array_crystal_array_0. */
  SIG_MESSAGE("channel_9_analyzer_2_array_crystal_array_0 (Init)");
#define mccompcurname  channel_9_analyzer_2_array_crystal_array_0
#define mccompcurtype  Union_box
#define mccompcurindex 483
#define loop_index mccchannel_9_analyzer_2_array_crystal_array_0_loop_index
#define this_box_volume mccchannel_9_analyzer_2_array_crystal_array_0_this_box_volume
#define global_geometry_element mccchannel_9_analyzer_2_array_crystal_array_0_global_geometry_element
#define this_box_storage mccchannel_9_analyzer_2_array_crystal_array_0_this_box_storage
#define material_string mccchannel_9_analyzer_2_array_crystal_array_0_material_string
#define priority mccchannel_9_analyzer_2_array_crystal_array_0_priority
#define xwidth mccchannel_9_analyzer_2_array_crystal_array_0_xwidth
#define yheight mccchannel_9_analyzer_2_array_crystal_array_0_yheight
#define zdepth mccchannel_9_analyzer_2_array_crystal_array_0_zdepth
#define xwidth2 mccchannel_9_analyzer_2_array_crystal_array_0_xwidth2
#define yheight2 mccchannel_9_analyzer_2_array_crystal_array_0_yheight2
#define visualize mccchannel_9_analyzer_2_array_crystal_array_0_visualize
#define target_index mccchannel_9_analyzer_2_array_crystal_array_0_target_index
#define target_x mccchannel_9_analyzer_2_array_crystal_array_0_target_x
#define target_y mccchannel_9_analyzer_2_array_crystal_array_0_target_y
#define target_z mccchannel_9_analyzer_2_array_crystal_array_0_target_z
#define focus_aw mccchannel_9_analyzer_2_array_crystal_array_0_focus_aw
#define focus_ah mccchannel_9_analyzer_2_array_crystal_array_0_focus_ah
#define focus_xw mccchannel_9_analyzer_2_array_crystal_array_0_focus_xw
#define focus_xh mccchannel_9_analyzer_2_array_crystal_array_0_focus_xh
#define focus_r mccchannel_9_analyzer_2_array_crystal_array_0_focus_r
#define p_interact mccchannel_9_analyzer_2_array_crystal_array_0_p_interact
#define mask_string mccchannel_9_analyzer_2_array_crystal_array_0_mask_string
#define mask_setting mccchannel_9_analyzer_2_array_crystal_array_0_mask_setting
#define number_of_activations mccchannel_9_analyzer_2_array_crystal_array_0_number_of_activations
#line 224 "Union_box.comp"
{
// Initializes the focusing system for this volume including input sanitation.
focus_initialize(&this_box_volume.geometry, POS_A_COMP_INDEX(INDEX_CURRENT_COMP+target_index), POS_A_CURRENT_COMP, ROT_A_CURRENT_COMP, target_index, target_x, target_y, target_z, focus_aw, focus_ah, focus_xw, focus_xh, focus_r, NAME_CURRENT_COMP);

// Input sanitation for this geometry
if (xwidth <= 0) {
  printf("\nERROR in Union_box named %s, the xwidth is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (yheight <= 0) {
  printf("\nERROR in Union_box named %s, yheight is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (zdepth <= 0) {
  printf("\nERROR in Union_box named %s, zdepth is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (xwidth2 <= 0 && xwidth2 != -1) {
  printf("\nERROR in Union_box named %s, the xwidth2 is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (yheight2 <= 0 && yheight2 != -1) {
  printf("\nERROR in Union_box named %s, yheight2 is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}

// Use sanitation
if (global_material_list.num_elements == 0) {
  printf("\nERROR: Need to define a material using Union_make_material before using a Union geometry component. \n");
  printf("       %s was defined before first use of Union_make_material.\n",NAME_CURRENT_COMP);
  exit(1);
}

this_box_volume.geometry.is_masked_volume = 0;
this_box_volume.geometry.is_exit_volume = 0;
this_box_volume.geometry.is_mask_volume = 0;
// check if the volume is a mask, if it is the material string is irelevant.
if (mask_string && strlen(mask_string) && strcmp(mask_string, "NULL") && strcmp(mask_string, "0")) {
    // A mask volume is used to limit the extend of other volumes, called the masked volumes. These are specified in the mask_string.
    // In order for a ray to enter a masked volume, it needs to be both in the region covered by that volume AND the mask volume.
    // When more than
    this_box_volume.geometry.mask_mode = 1; // Default is mask mode is ALL
    if (mask_setting && strlen(mask_setting) && strcmp(mask_setting, "NULL") && strcmp(mask_setting, "0")) {
        if (strcmp(mask_setting,"ALL") == 0 || strcmp(mask_setting,"All") == 0) this_box_volume.geometry.mask_mode = 1;
        else if (strcmp(mask_setting,"ANY") == 0 || strcmp(mask_setting,"Any") == 0) this_box_volume.geometry.mask_mode = 2;
        else {
            printf("The mask_mode of component %s is set to %s, but must be either ALL or ANY.\n",NAME_CURRENT_COMP,mask_setting);
            exit(1);
        }
    }
    
    for (loop_index=0;loop_index<global_geometry_list.num_elements;loop_index++) {
        // Add mask list
        if (1 == manual_linking_function(global_geometry_list.elements[loop_index].name,mask_string)) {
            add_element_to_int_list(&this_box_volume.geometry.mask_list,global_geometry_list.elements[loop_index].component_index);
            add_element_to_int_list(&global_geometry_list.elements[loop_index].Volume->geometry.masked_by_list,INDEX_CURRENT_COMP);
            global_geometry_list.elements[loop_index].Volume->geometry.is_masked_volume = 1;
            if (this_box_volume.geometry.mask_mode == 2)
                global_geometry_list.elements[loop_index].Volume->geometry.mask_mode = 2;
            if (this_box_volume.geometry.mask_mode == 1) {
                if (global_geometry_list.elements[loop_index].Volume->geometry.is_masked_volume == 1 && global_geometry_list.elements[loop_index].Volume->geometry.mask_mode != 2)
                    // If more than one mask is added to one volume, the ANY mode overwrites the (default) ALL mode.
                    global_geometry_list.elements[loop_index].Volume->geometry.mask_mode = 1;
            }
            
            found_geometries = 1;
        }
    }
    if (found_geometries == 0) {
        printf("The mask_string in geometry: %s did not find any of the specified volumes in the mask_string %s \n",NAME_CURRENT_COMP,mask_string);
        exit(1);
    }
    this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
    this_box_volume.p_physics->is_vacuum = 0; // Makes this volume a vacuum
    this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
    this_box_volume.p_physics->my_a = 0; // Should not be used.
    sprintf(this_box_volume.p_physics->name,"Mask");
    this_box_volume.geometry.is_mask_volume = 1;
    
    
// Read the material input, or if it lacks, use automatic linking.
} else if (material_string && strlen(material_string) && strcmp(material_string, "NULL") && strcmp(material_string, "0")) {
    // A geometry string was given, use it to determine which material
    if (0 == strcmp(material_string,"vacuum") || 0 == strcmp(material_string,"Vacuum")) {
        // One could have a global physics struct for vacuum instead of creating one for each
        this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
        this_box_volume.p_physics->is_vacuum = 1; // Makes this volume a vacuum
        this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
        this_box_volume.p_physics->my_a = 0; // Should not be used.
        sprintf(this_box_volume.p_physics->name,"Vacuum");
    } else if (0 == strcmp(material_string,"exit") || 0 == strcmp(material_string,"Exit")) {
        // One could have a global physics struct for vacuum instead of creating one for each
        this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
        this_box_volume.p_physics->is_vacuum = 1; // Makes this volume a vacuum
        this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
        this_box_volume.p_physics->my_a = 0; // Should not be used.
        this_box_volume.geometry.is_exit_volume = 1;
        sprintf(this_box_volume.p_physics->name,"Exit");
    } else {
        #ifndef MATERIAL_DETECTOR
            printf("Need to define a material before refering to it in a geometry %s.\n",NAME_CURRENT_COMP);
            exit(1);
        #endif
        for (loop_index=0;loop_index<global_material_list.num_elements;loop_index++) {
            if (0 == strcmp(material_string,global_material_list.elements[loop_index].name)) {
                this_box_volume.p_physics = global_material_list.elements[loop_index].physics;
                break;
            }
            if (loop_index == global_material_list.num_elements-1) {
            printf("\n");
            printf("ERROR: The material string \"%s\" in Union geometry \"%s\" did not match a specified material. \n",material_string,NAME_CURRENT_COMP);
            printf("       The materials available at this point (need to be defined before the geometry): \n");
            for (loop_index=0;loop_index<global_material_list.num_elements;loop_index++)
              printf("         %s\n",global_material_list.elements[loop_index].name);
            printf("\n");
            printf("       It is also possible to use one of the defualt materials avaiable: \n");
            printf("           Vacuum (for a Volume without scattering or absorption)\n");
            printf("           Exit (for a Volume where the ray exits the component if it enters)\n");
            printf("           Mask (for a Volume that masks existing volumes specified in the mask_string\n");
            exit(1);
          }
        }
    }
} else {
    // Automatic linking, simply using the last defined material.
    #ifndef MATERIAL_DETECTOR
        printf("Need to define a material before the geometry to use automatic linking %s.\n",NAME_CURRENT_COMP);
        exit(1);
    #endif
    this_box_volume.p_physics = global_material_list.elements[global_material_list.num_elements-1].physics;
}

sprintf(this_box_volume.name,NAME_CURRENT_COMP);
sprintf(this_box_volume.geometry.shape,"box");
this_box_volume.geometry.priority_value = priority;
this_box_volume.geometry.geometry_p_interact = p_interact;
// Currently the coordinates will be in absolute space.
this_box_volume.geometry.center = POS_A_CURRENT_COMP;

this_box_storage.z_depth = zdepth;
this_box_storage.x_width1 = xwidth;
this_box_storage.y_height1 = yheight;

this_box_storage.is_rectangle = 0;
if (xwidth2 < 0 && yheight2 < 0) this_box_storage.is_rectangle = 1;
if (xwidth == xwidth2 && yheight == yheight2) this_box_storage.is_rectangle = 1;

if (xwidth2 < 0) {
    this_box_storage.x_width2 = xwidth;
    xwidth2 = xwidth;
} else this_box_storage.x_width2 = xwidth2;

if (yheight2 < 0) {
    this_box_storage.y_height2 = yheight;
    yheight2 = yheight;
} else this_box_storage.y_height2 = yheight2;


this_box_storage.normal_vectors[0] = coords_set(0,0,1);
this_box_storage.normal_vectors[1] = coords_set(0,0,1);

// for sides with y component = 0
x_component = 2*zdepth/sqrt((xwidth-xwidth2)*(xwidth-xwidth2)+4*zdepth*zdepth);
z_component = (xwidth-xwidth2)/sqrt(4*zdepth*zdepth+(xwidth-xwidth2)*(xwidth-xwidth2));

this_box_storage.normal_vectors[2] = coords_set(x_component,0,z_component);
this_box_storage.normal_vectors[3] = coords_set(-x_component,0,z_component);

// for sides with x component = 0
y_component = 2*zdepth/sqrt((yheight-yheight2)*(yheight-yheight2)+4*zdepth*zdepth);
z_component = (yheight-yheight2)/sqrt(4*zdepth*zdepth+(yheight-yheight2)*(yheight-yheight2));

this_box_storage.normal_vectors[4] = coords_set(0,y_component,z_component);
this_box_storage.normal_vectors[5] = coords_set(0,-y_component,z_component);

this_box_volume.geometry.visualization_on = visualize;

this_box_volume.geometry.geometry_parameters.p_box_storage = &this_box_storage;

// Assign pointers to functions for intersection with the shape, checking if a point is inside the shape
if (this_box_storage.is_rectangle == 1) {
this_box_volume.geometry.intersect_function = &sample_box_intersect_simple;
this_box_volume.geometry.within_function = &r_within_box_simple;
}
else {
this_box_volume.geometry.intersect_function = &sample_box_intersect_advanced;
this_box_volume.geometry.within_function = &r_within_box_advanced;
}

this_box_volume.geometry.shell_points = &box_shell_points;
this_box_volume.geometry.mcdisplay_function = &mcdisplay_box_function;
this_box_volume.geometry.initialize_from_main_function = &initialize_box_geometry_from_main_component;
this_box_volume.geometry.process_rot_allocated = 0;

this_box_volume.geometry.copy_geometry_parameters = &allocate_box_storage_copy;

rot_copy(this_box_volume.geometry.rotation_matrix,ROT_A_CURRENT_COMP); //check how ROT_R_CURRENT_COMP would work
rot_transpose(ROT_A_CURRENT_COMP,this_box_volume.geometry.transpose_rotation_matrix);

// Initialize loggers
this_box_volume.loggers.num_elements = 0;

// packing the information into the global_geometry_element, which is then included in the global_geometry_list.
sprintf(global_geometry_element.name,NAME_CURRENT_COMP);
global_geometry_element.activation_counter = number_of_activations;
global_geometry_element.component_index = INDEX_CURRENT_COMP;
global_geometry_element.Volume = &this_box_volume; // Would be nicer if this m was a pointer, now we have the (small) data two places
add_element_to_geometry_list(&global_geometry_list,global_geometry_element);
}
#line 247508 "MACS_sample_kidney_box.c"
#undef number_of_activations
#undef mask_setting
#undef mask_string
#undef p_interact
#undef focus_r
#undef focus_xh
#undef focus_xw
#undef focus_ah
#undef focus_aw
#undef target_z
#undef target_y
#undef target_x
#undef target_index
#undef visualize
#undef yheight2
#undef xwidth2
#undef zdepth
#undef yheight
#undef xwidth
#undef priority
#undef material_string
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

  /* Initializations for component channel_9_analyzer_2_array_crystal_array_1. */
  SIG_MESSAGE("channel_9_analyzer_2_array_crystal_array_1 (Init)");
#define mccompcurname  channel_9_analyzer_2_array_crystal_array_1
#define mccompcurtype  Union_box
#define mccompcurindex 484
#define loop_index mccchannel_9_analyzer_2_array_crystal_array_1_loop_index
#define this_box_volume mccchannel_9_analyzer_2_array_crystal_array_1_this_box_volume
#define global_geometry_element mccchannel_9_analyzer_2_array_crystal_array_1_global_geometry_element
#define this_box_storage mccchannel_9_analyzer_2_array_crystal_array_1_this_box_storage
#define material_string mccchannel_9_analyzer_2_array_crystal_array_1_material_string
#define priority mccchannel_9_analyzer_2_array_crystal_array_1_priority
#define xwidth mccchannel_9_analyzer_2_array_crystal_array_1_xwidth
#define yheight mccchannel_9_analyzer_2_array_crystal_array_1_yheight
#define zdepth mccchannel_9_analyzer_2_array_crystal_array_1_zdepth
#define xwidth2 mccchannel_9_analyzer_2_array_crystal_array_1_xwidth2
#define yheight2 mccchannel_9_analyzer_2_array_crystal_array_1_yheight2
#define visualize mccchannel_9_analyzer_2_array_crystal_array_1_visualize
#define target_index mccchannel_9_analyzer_2_array_crystal_array_1_target_index
#define target_x mccchannel_9_analyzer_2_array_crystal_array_1_target_x
#define target_y mccchannel_9_analyzer_2_array_crystal_array_1_target_y
#define target_z mccchannel_9_analyzer_2_array_crystal_array_1_target_z
#define focus_aw mccchannel_9_analyzer_2_array_crystal_array_1_focus_aw
#define focus_ah mccchannel_9_analyzer_2_array_crystal_array_1_focus_ah
#define focus_xw mccchannel_9_analyzer_2_array_crystal_array_1_focus_xw
#define focus_xh mccchannel_9_analyzer_2_array_crystal_array_1_focus_xh
#define focus_r mccchannel_9_analyzer_2_array_crystal_array_1_focus_r
#define p_interact mccchannel_9_analyzer_2_array_crystal_array_1_p_interact
#define mask_string mccchannel_9_analyzer_2_array_crystal_array_1_mask_string
#define mask_setting mccchannel_9_analyzer_2_array_crystal_array_1_mask_setting
#define number_of_activations mccchannel_9_analyzer_2_array_crystal_array_1_number_of_activations
#line 224 "Union_box.comp"
{
// Initializes the focusing system for this volume including input sanitation.
focus_initialize(&this_box_volume.geometry, POS_A_COMP_INDEX(INDEX_CURRENT_COMP+target_index), POS_A_CURRENT_COMP, ROT_A_CURRENT_COMP, target_index, target_x, target_y, target_z, focus_aw, focus_ah, focus_xw, focus_xh, focus_r, NAME_CURRENT_COMP);

// Input sanitation for this geometry
if (xwidth <= 0) {
  printf("\nERROR in Union_box named %s, the xwidth is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (yheight <= 0) {
  printf("\nERROR in Union_box named %s, yheight is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (zdepth <= 0) {
  printf("\nERROR in Union_box named %s, zdepth is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (xwidth2 <= 0 && xwidth2 != -1) {
  printf("\nERROR in Union_box named %s, the xwidth2 is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (yheight2 <= 0 && yheight2 != -1) {
  printf("\nERROR in Union_box named %s, yheight2 is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}

// Use sanitation
if (global_material_list.num_elements == 0) {
  printf("\nERROR: Need to define a material using Union_make_material before using a Union geometry component. \n");
  printf("       %s was defined before first use of Union_make_material.\n",NAME_CURRENT_COMP);
  exit(1);
}

this_box_volume.geometry.is_masked_volume = 0;
this_box_volume.geometry.is_exit_volume = 0;
this_box_volume.geometry.is_mask_volume = 0;
// check if the volume is a mask, if it is the material string is irelevant.
if (mask_string && strlen(mask_string) && strcmp(mask_string, "NULL") && strcmp(mask_string, "0")) {
    // A mask volume is used to limit the extend of other volumes, called the masked volumes. These are specified in the mask_string.
    // In order for a ray to enter a masked volume, it needs to be both in the region covered by that volume AND the mask volume.
    // When more than
    this_box_volume.geometry.mask_mode = 1; // Default is mask mode is ALL
    if (mask_setting && strlen(mask_setting) && strcmp(mask_setting, "NULL") && strcmp(mask_setting, "0")) {
        if (strcmp(mask_setting,"ALL") == 0 || strcmp(mask_setting,"All") == 0) this_box_volume.geometry.mask_mode = 1;
        else if (strcmp(mask_setting,"ANY") == 0 || strcmp(mask_setting,"Any") == 0) this_box_volume.geometry.mask_mode = 2;
        else {
            printf("The mask_mode of component %s is set to %s, but must be either ALL or ANY.\n",NAME_CURRENT_COMP,mask_setting);
            exit(1);
        }
    }
    
    for (loop_index=0;loop_index<global_geometry_list.num_elements;loop_index++) {
        // Add mask list
        if (1 == manual_linking_function(global_geometry_list.elements[loop_index].name,mask_string)) {
            add_element_to_int_list(&this_box_volume.geometry.mask_list,global_geometry_list.elements[loop_index].component_index);
            add_element_to_int_list(&global_geometry_list.elements[loop_index].Volume->geometry.masked_by_list,INDEX_CURRENT_COMP);
            global_geometry_list.elements[loop_index].Volume->geometry.is_masked_volume = 1;
            if (this_box_volume.geometry.mask_mode == 2)
                global_geometry_list.elements[loop_index].Volume->geometry.mask_mode = 2;
            if (this_box_volume.geometry.mask_mode == 1) {
                if (global_geometry_list.elements[loop_index].Volume->geometry.is_masked_volume == 1 && global_geometry_list.elements[loop_index].Volume->geometry.mask_mode != 2)
                    // If more than one mask is added to one volume, the ANY mode overwrites the (default) ALL mode.
                    global_geometry_list.elements[loop_index].Volume->geometry.mask_mode = 1;
            }
            
            found_geometries = 1;
        }
    }
    if (found_geometries == 0) {
        printf("The mask_string in geometry: %s did not find any of the specified volumes in the mask_string %s \n",NAME_CURRENT_COMP,mask_string);
        exit(1);
    }
    this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
    this_box_volume.p_physics->is_vacuum = 0; // Makes this volume a vacuum
    this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
    this_box_volume.p_physics->my_a = 0; // Should not be used.
    sprintf(this_box_volume.p_physics->name,"Mask");
    this_box_volume.geometry.is_mask_volume = 1;
    
    
// Read the material input, or if it lacks, use automatic linking.
} else if (material_string && strlen(material_string) && strcmp(material_string, "NULL") && strcmp(material_string, "0")) {
    // A geometry string was given, use it to determine which material
    if (0 == strcmp(material_string,"vacuum") || 0 == strcmp(material_string,"Vacuum")) {
        // One could have a global physics struct for vacuum instead of creating one for each
        this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
        this_box_volume.p_physics->is_vacuum = 1; // Makes this volume a vacuum
        this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
        this_box_volume.p_physics->my_a = 0; // Should not be used.
        sprintf(this_box_volume.p_physics->name,"Vacuum");
    } else if (0 == strcmp(material_string,"exit") || 0 == strcmp(material_string,"Exit")) {
        // One could have a global physics struct for vacuum instead of creating one for each
        this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
        this_box_volume.p_physics->is_vacuum = 1; // Makes this volume a vacuum
        this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
        this_box_volume.p_physics->my_a = 0; // Should not be used.
        this_box_volume.geometry.is_exit_volume = 1;
        sprintf(this_box_volume.p_physics->name,"Exit");
    } else {
        #ifndef MATERIAL_DETECTOR
            printf("Need to define a material before refering to it in a geometry %s.\n",NAME_CURRENT_COMP);
            exit(1);
        #endif
        for (loop_index=0;loop_index<global_material_list.num_elements;loop_index++) {
            if (0 == strcmp(material_string,global_material_list.elements[loop_index].name)) {
                this_box_volume.p_physics = global_material_list.elements[loop_index].physics;
                break;
            }
            if (loop_index == global_material_list.num_elements-1) {
            printf("\n");
            printf("ERROR: The material string \"%s\" in Union geometry \"%s\" did not match a specified material. \n",material_string,NAME_CURRENT_COMP);
            printf("       The materials available at this point (need to be defined before the geometry): \n");
            for (loop_index=0;loop_index<global_material_list.num_elements;loop_index++)
              printf("         %s\n",global_material_list.elements[loop_index].name);
            printf("\n");
            printf("       It is also possible to use one of the defualt materials avaiable: \n");
            printf("           Vacuum (for a Volume without scattering or absorption)\n");
            printf("           Exit (for a Volume where the ray exits the component if it enters)\n");
            printf("           Mask (for a Volume that masks existing volumes specified in the mask_string\n");
            exit(1);
          }
        }
    }
} else {
    // Automatic linking, simply using the last defined material.
    #ifndef MATERIAL_DETECTOR
        printf("Need to define a material before the geometry to use automatic linking %s.\n",NAME_CURRENT_COMP);
        exit(1);
    #endif
    this_box_volume.p_physics = global_material_list.elements[global_material_list.num_elements-1].physics;
}

sprintf(this_box_volume.name,NAME_CURRENT_COMP);
sprintf(this_box_volume.geometry.shape,"box");
this_box_volume.geometry.priority_value = priority;
this_box_volume.geometry.geometry_p_interact = p_interact;
// Currently the coordinates will be in absolute space.
this_box_volume.geometry.center = POS_A_CURRENT_COMP;

this_box_storage.z_depth = zdepth;
this_box_storage.x_width1 = xwidth;
this_box_storage.y_height1 = yheight;

this_box_storage.is_rectangle = 0;
if (xwidth2 < 0 && yheight2 < 0) this_box_storage.is_rectangle = 1;
if (xwidth == xwidth2 && yheight == yheight2) this_box_storage.is_rectangle = 1;

if (xwidth2 < 0) {
    this_box_storage.x_width2 = xwidth;
    xwidth2 = xwidth;
} else this_box_storage.x_width2 = xwidth2;

if (yheight2 < 0) {
    this_box_storage.y_height2 = yheight;
    yheight2 = yheight;
} else this_box_storage.y_height2 = yheight2;


this_box_storage.normal_vectors[0] = coords_set(0,0,1);
this_box_storage.normal_vectors[1] = coords_set(0,0,1);

// for sides with y component = 0
x_component = 2*zdepth/sqrt((xwidth-xwidth2)*(xwidth-xwidth2)+4*zdepth*zdepth);
z_component = (xwidth-xwidth2)/sqrt(4*zdepth*zdepth+(xwidth-xwidth2)*(xwidth-xwidth2));

this_box_storage.normal_vectors[2] = coords_set(x_component,0,z_component);
this_box_storage.normal_vectors[3] = coords_set(-x_component,0,z_component);

// for sides with x component = 0
y_component = 2*zdepth/sqrt((yheight-yheight2)*(yheight-yheight2)+4*zdepth*zdepth);
z_component = (yheight-yheight2)/sqrt(4*zdepth*zdepth+(yheight-yheight2)*(yheight-yheight2));

this_box_storage.normal_vectors[4] = coords_set(0,y_component,z_component);
this_box_storage.normal_vectors[5] = coords_set(0,-y_component,z_component);

this_box_volume.geometry.visualization_on = visualize;

this_box_volume.geometry.geometry_parameters.p_box_storage = &this_box_storage;

// Assign pointers to functions for intersection with the shape, checking if a point is inside the shape
if (this_box_storage.is_rectangle == 1) {
this_box_volume.geometry.intersect_function = &sample_box_intersect_simple;
this_box_volume.geometry.within_function = &r_within_box_simple;
}
else {
this_box_volume.geometry.intersect_function = &sample_box_intersect_advanced;
this_box_volume.geometry.within_function = &r_within_box_advanced;
}

this_box_volume.geometry.shell_points = &box_shell_points;
this_box_volume.geometry.mcdisplay_function = &mcdisplay_box_function;
this_box_volume.geometry.initialize_from_main_function = &initialize_box_geometry_from_main_component;
this_box_volume.geometry.process_rot_allocated = 0;

this_box_volume.geometry.copy_geometry_parameters = &allocate_box_storage_copy;

rot_copy(this_box_volume.geometry.rotation_matrix,ROT_A_CURRENT_COMP); //check how ROT_R_CURRENT_COMP would work
rot_transpose(ROT_A_CURRENT_COMP,this_box_volume.geometry.transpose_rotation_matrix);

// Initialize loggers
this_box_volume.loggers.num_elements = 0;

// packing the information into the global_geometry_element, which is then included in the global_geometry_list.
sprintf(global_geometry_element.name,NAME_CURRENT_COMP);
global_geometry_element.activation_counter = number_of_activations;
global_geometry_element.component_index = INDEX_CURRENT_COMP;
global_geometry_element.Volume = &this_box_volume; // Would be nicer if this m was a pointer, now we have the (small) data two places
add_element_to_geometry_list(&global_geometry_list,global_geometry_element);
}
#line 247778 "MACS_sample_kidney_box.c"
#undef number_of_activations
#undef mask_setting
#undef mask_string
#undef p_interact
#undef focus_r
#undef focus_xh
#undef focus_xw
#undef focus_ah
#undef focus_aw
#undef target_z
#undef target_y
#undef target_x
#undef target_index
#undef visualize
#undef yheight2
#undef xwidth2
#undef zdepth
#undef yheight
#undef xwidth
#undef priority
#undef material_string
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

  /* Initializations for component channel_9_analyzer_2_array_crystal_array_2. */
  SIG_MESSAGE("channel_9_analyzer_2_array_crystal_array_2 (Init)");
#define mccompcurname  channel_9_analyzer_2_array_crystal_array_2
#define mccompcurtype  Union_box
#define mccompcurindex 485
#define loop_index mccchannel_9_analyzer_2_array_crystal_array_2_loop_index
#define this_box_volume mccchannel_9_analyzer_2_array_crystal_array_2_this_box_volume
#define global_geometry_element mccchannel_9_analyzer_2_array_crystal_array_2_global_geometry_element
#define this_box_storage mccchannel_9_analyzer_2_array_crystal_array_2_this_box_storage
#define material_string mccchannel_9_analyzer_2_array_crystal_array_2_material_string
#define priority mccchannel_9_analyzer_2_array_crystal_array_2_priority
#define xwidth mccchannel_9_analyzer_2_array_crystal_array_2_xwidth
#define yheight mccchannel_9_analyzer_2_array_crystal_array_2_yheight
#define zdepth mccchannel_9_analyzer_2_array_crystal_array_2_zdepth
#define xwidth2 mccchannel_9_analyzer_2_array_crystal_array_2_xwidth2
#define yheight2 mccchannel_9_analyzer_2_array_crystal_array_2_yheight2
#define visualize mccchannel_9_analyzer_2_array_crystal_array_2_visualize
#define target_index mccchannel_9_analyzer_2_array_crystal_array_2_target_index
#define target_x mccchannel_9_analyzer_2_array_crystal_array_2_target_x
#define target_y mccchannel_9_analyzer_2_array_crystal_array_2_target_y
#define target_z mccchannel_9_analyzer_2_array_crystal_array_2_target_z
#define focus_aw mccchannel_9_analyzer_2_array_crystal_array_2_focus_aw
#define focus_ah mccchannel_9_analyzer_2_array_crystal_array_2_focus_ah
#define focus_xw mccchannel_9_analyzer_2_array_crystal_array_2_focus_xw
#define focus_xh mccchannel_9_analyzer_2_array_crystal_array_2_focus_xh
#define focus_r mccchannel_9_analyzer_2_array_crystal_array_2_focus_r
#define p_interact mccchannel_9_analyzer_2_array_crystal_array_2_p_interact
#define mask_string mccchannel_9_analyzer_2_array_crystal_array_2_mask_string
#define mask_setting mccchannel_9_analyzer_2_array_crystal_array_2_mask_setting
#define number_of_activations mccchannel_9_analyzer_2_array_crystal_array_2_number_of_activations
#line 224 "Union_box.comp"
{
// Initializes the focusing system for this volume including input sanitation.
focus_initialize(&this_box_volume.geometry, POS_A_COMP_INDEX(INDEX_CURRENT_COMP+target_index), POS_A_CURRENT_COMP, ROT_A_CURRENT_COMP, target_index, target_x, target_y, target_z, focus_aw, focus_ah, focus_xw, focus_xh, focus_r, NAME_CURRENT_COMP);

// Input sanitation for this geometry
if (xwidth <= 0) {
  printf("\nERROR in Union_box named %s, the xwidth is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (yheight <= 0) {
  printf("\nERROR in Union_box named %s, yheight is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (zdepth <= 0) {
  printf("\nERROR in Union_box named %s, zdepth is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (xwidth2 <= 0 && xwidth2 != -1) {
  printf("\nERROR in Union_box named %s, the xwidth2 is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (yheight2 <= 0 && yheight2 != -1) {
  printf("\nERROR in Union_box named %s, yheight2 is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}

// Use sanitation
if (global_material_list.num_elements == 0) {
  printf("\nERROR: Need to define a material using Union_make_material before using a Union geometry component. \n");
  printf("       %s was defined before first use of Union_make_material.\n",NAME_CURRENT_COMP);
  exit(1);
}

this_box_volume.geometry.is_masked_volume = 0;
this_box_volume.geometry.is_exit_volume = 0;
this_box_volume.geometry.is_mask_volume = 0;
// check if the volume is a mask, if it is the material string is irelevant.
if (mask_string && strlen(mask_string) && strcmp(mask_string, "NULL") && strcmp(mask_string, "0")) {
    // A mask volume is used to limit the extend of other volumes, called the masked volumes. These are specified in the mask_string.
    // In order for a ray to enter a masked volume, it needs to be both in the region covered by that volume AND the mask volume.
    // When more than
    this_box_volume.geometry.mask_mode = 1; // Default is mask mode is ALL
    if (mask_setting && strlen(mask_setting) && strcmp(mask_setting, "NULL") && strcmp(mask_setting, "0")) {
        if (strcmp(mask_setting,"ALL") == 0 || strcmp(mask_setting,"All") == 0) this_box_volume.geometry.mask_mode = 1;
        else if (strcmp(mask_setting,"ANY") == 0 || strcmp(mask_setting,"Any") == 0) this_box_volume.geometry.mask_mode = 2;
        else {
            printf("The mask_mode of component %s is set to %s, but must be either ALL or ANY.\n",NAME_CURRENT_COMP,mask_setting);
            exit(1);
        }
    }
    
    for (loop_index=0;loop_index<global_geometry_list.num_elements;loop_index++) {
        // Add mask list
        if (1 == manual_linking_function(global_geometry_list.elements[loop_index].name,mask_string)) {
            add_element_to_int_list(&this_box_volume.geometry.mask_list,global_geometry_list.elements[loop_index].component_index);
            add_element_to_int_list(&global_geometry_list.elements[loop_index].Volume->geometry.masked_by_list,INDEX_CURRENT_COMP);
            global_geometry_list.elements[loop_index].Volume->geometry.is_masked_volume = 1;
            if (this_box_volume.geometry.mask_mode == 2)
                global_geometry_list.elements[loop_index].Volume->geometry.mask_mode = 2;
            if (this_box_volume.geometry.mask_mode == 1) {
                if (global_geometry_list.elements[loop_index].Volume->geometry.is_masked_volume == 1 && global_geometry_list.elements[loop_index].Volume->geometry.mask_mode != 2)
                    // If more than one mask is added to one volume, the ANY mode overwrites the (default) ALL mode.
                    global_geometry_list.elements[loop_index].Volume->geometry.mask_mode = 1;
            }
            
            found_geometries = 1;
        }
    }
    if (found_geometries == 0) {
        printf("The mask_string in geometry: %s did not find any of the specified volumes in the mask_string %s \n",NAME_CURRENT_COMP,mask_string);
        exit(1);
    }
    this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
    this_box_volume.p_physics->is_vacuum = 0; // Makes this volume a vacuum
    this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
    this_box_volume.p_physics->my_a = 0; // Should not be used.
    sprintf(this_box_volume.p_physics->name,"Mask");
    this_box_volume.geometry.is_mask_volume = 1;
    
    
// Read the material input, or if it lacks, use automatic linking.
} else if (material_string && strlen(material_string) && strcmp(material_string, "NULL") && strcmp(material_string, "0")) {
    // A geometry string was given, use it to determine which material
    if (0 == strcmp(material_string,"vacuum") || 0 == strcmp(material_string,"Vacuum")) {
        // One could have a global physics struct for vacuum instead of creating one for each
        this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
        this_box_volume.p_physics->is_vacuum = 1; // Makes this volume a vacuum
        this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
        this_box_volume.p_physics->my_a = 0; // Should not be used.
        sprintf(this_box_volume.p_physics->name,"Vacuum");
    } else if (0 == strcmp(material_string,"exit") || 0 == strcmp(material_string,"Exit")) {
        // One could have a global physics struct for vacuum instead of creating one for each
        this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
        this_box_volume.p_physics->is_vacuum = 1; // Makes this volume a vacuum
        this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
        this_box_volume.p_physics->my_a = 0; // Should not be used.
        this_box_volume.geometry.is_exit_volume = 1;
        sprintf(this_box_volume.p_physics->name,"Exit");
    } else {
        #ifndef MATERIAL_DETECTOR
            printf("Need to define a material before refering to it in a geometry %s.\n",NAME_CURRENT_COMP);
            exit(1);
        #endif
        for (loop_index=0;loop_index<global_material_list.num_elements;loop_index++) {
            if (0 == strcmp(material_string,global_material_list.elements[loop_index].name)) {
                this_box_volume.p_physics = global_material_list.elements[loop_index].physics;
                break;
            }
            if (loop_index == global_material_list.num_elements-1) {
            printf("\n");
            printf("ERROR: The material string \"%s\" in Union geometry \"%s\" did not match a specified material. \n",material_string,NAME_CURRENT_COMP);
            printf("       The materials available at this point (need to be defined before the geometry): \n");
            for (loop_index=0;loop_index<global_material_list.num_elements;loop_index++)
              printf("         %s\n",global_material_list.elements[loop_index].name);
            printf("\n");
            printf("       It is also possible to use one of the defualt materials avaiable: \n");
            printf("           Vacuum (for a Volume without scattering or absorption)\n");
            printf("           Exit (for a Volume where the ray exits the component if it enters)\n");
            printf("           Mask (for a Volume that masks existing volumes specified in the mask_string\n");
            exit(1);
          }
        }
    }
} else {
    // Automatic linking, simply using the last defined material.
    #ifndef MATERIAL_DETECTOR
        printf("Need to define a material before the geometry to use automatic linking %s.\n",NAME_CURRENT_COMP);
        exit(1);
    #endif
    this_box_volume.p_physics = global_material_list.elements[global_material_list.num_elements-1].physics;
}

sprintf(this_box_volume.name,NAME_CURRENT_COMP);
sprintf(this_box_volume.geometry.shape,"box");
this_box_volume.geometry.priority_value = priority;
this_box_volume.geometry.geometry_p_interact = p_interact;
// Currently the coordinates will be in absolute space.
this_box_volume.geometry.center = POS_A_CURRENT_COMP;

this_box_storage.z_depth = zdepth;
this_box_storage.x_width1 = xwidth;
this_box_storage.y_height1 = yheight;

this_box_storage.is_rectangle = 0;
if (xwidth2 < 0 && yheight2 < 0) this_box_storage.is_rectangle = 1;
if (xwidth == xwidth2 && yheight == yheight2) this_box_storage.is_rectangle = 1;

if (xwidth2 < 0) {
    this_box_storage.x_width2 = xwidth;
    xwidth2 = xwidth;
} else this_box_storage.x_width2 = xwidth2;

if (yheight2 < 0) {
    this_box_storage.y_height2 = yheight;
    yheight2 = yheight;
} else this_box_storage.y_height2 = yheight2;


this_box_storage.normal_vectors[0] = coords_set(0,0,1);
this_box_storage.normal_vectors[1] = coords_set(0,0,1);

// for sides with y component = 0
x_component = 2*zdepth/sqrt((xwidth-xwidth2)*(xwidth-xwidth2)+4*zdepth*zdepth);
z_component = (xwidth-xwidth2)/sqrt(4*zdepth*zdepth+(xwidth-xwidth2)*(xwidth-xwidth2));

this_box_storage.normal_vectors[2] = coords_set(x_component,0,z_component);
this_box_storage.normal_vectors[3] = coords_set(-x_component,0,z_component);

// for sides with x component = 0
y_component = 2*zdepth/sqrt((yheight-yheight2)*(yheight-yheight2)+4*zdepth*zdepth);
z_component = (yheight-yheight2)/sqrt(4*zdepth*zdepth+(yheight-yheight2)*(yheight-yheight2));

this_box_storage.normal_vectors[4] = coords_set(0,y_component,z_component);
this_box_storage.normal_vectors[5] = coords_set(0,-y_component,z_component);

this_box_volume.geometry.visualization_on = visualize;

this_box_volume.geometry.geometry_parameters.p_box_storage = &this_box_storage;

// Assign pointers to functions for intersection with the shape, checking if a point is inside the shape
if (this_box_storage.is_rectangle == 1) {
this_box_volume.geometry.intersect_function = &sample_box_intersect_simple;
this_box_volume.geometry.within_function = &r_within_box_simple;
}
else {
this_box_volume.geometry.intersect_function = &sample_box_intersect_advanced;
this_box_volume.geometry.within_function = &r_within_box_advanced;
}

this_box_volume.geometry.shell_points = &box_shell_points;
this_box_volume.geometry.mcdisplay_function = &mcdisplay_box_function;
this_box_volume.geometry.initialize_from_main_function = &initialize_box_geometry_from_main_component;
this_box_volume.geometry.process_rot_allocated = 0;

this_box_volume.geometry.copy_geometry_parameters = &allocate_box_storage_copy;

rot_copy(this_box_volume.geometry.rotation_matrix,ROT_A_CURRENT_COMP); //check how ROT_R_CURRENT_COMP would work
rot_transpose(ROT_A_CURRENT_COMP,this_box_volume.geometry.transpose_rotation_matrix);

// Initialize loggers
this_box_volume.loggers.num_elements = 0;

// packing the information into the global_geometry_element, which is then included in the global_geometry_list.
sprintf(global_geometry_element.name,NAME_CURRENT_COMP);
global_geometry_element.activation_counter = number_of_activations;
global_geometry_element.component_index = INDEX_CURRENT_COMP;
global_geometry_element.Volume = &this_box_volume; // Would be nicer if this m was a pointer, now we have the (small) data two places
add_element_to_geometry_list(&global_geometry_list,global_geometry_element);
}
#line 248048 "MACS_sample_kidney_box.c"
#undef number_of_activations
#undef mask_setting
#undef mask_string
#undef p_interact
#undef focus_r
#undef focus_xh
#undef focus_xw
#undef focus_ah
#undef focus_aw
#undef target_z
#undef target_y
#undef target_x
#undef target_index
#undef visualize
#undef yheight2
#undef xwidth2
#undef zdepth
#undef yheight
#undef xwidth
#undef priority
#undef material_string
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

  /* Initializations for component channel_9_analyzer_2_array_crystal_array_3. */
  SIG_MESSAGE("channel_9_analyzer_2_array_crystal_array_3 (Init)");
#define mccompcurname  channel_9_analyzer_2_array_crystal_array_3
#define mccompcurtype  Union_box
#define mccompcurindex 486
#define loop_index mccchannel_9_analyzer_2_array_crystal_array_3_loop_index
#define this_box_volume mccchannel_9_analyzer_2_array_crystal_array_3_this_box_volume
#define global_geometry_element mccchannel_9_analyzer_2_array_crystal_array_3_global_geometry_element
#define this_box_storage mccchannel_9_analyzer_2_array_crystal_array_3_this_box_storage
#define material_string mccchannel_9_analyzer_2_array_crystal_array_3_material_string
#define priority mccchannel_9_analyzer_2_array_crystal_array_3_priority
#define xwidth mccchannel_9_analyzer_2_array_crystal_array_3_xwidth
#define yheight mccchannel_9_analyzer_2_array_crystal_array_3_yheight
#define zdepth mccchannel_9_analyzer_2_array_crystal_array_3_zdepth
#define xwidth2 mccchannel_9_analyzer_2_array_crystal_array_3_xwidth2
#define yheight2 mccchannel_9_analyzer_2_array_crystal_array_3_yheight2
#define visualize mccchannel_9_analyzer_2_array_crystal_array_3_visualize
#define target_index mccchannel_9_analyzer_2_array_crystal_array_3_target_index
#define target_x mccchannel_9_analyzer_2_array_crystal_array_3_target_x
#define target_y mccchannel_9_analyzer_2_array_crystal_array_3_target_y
#define target_z mccchannel_9_analyzer_2_array_crystal_array_3_target_z
#define focus_aw mccchannel_9_analyzer_2_array_crystal_array_3_focus_aw
#define focus_ah mccchannel_9_analyzer_2_array_crystal_array_3_focus_ah
#define focus_xw mccchannel_9_analyzer_2_array_crystal_array_3_focus_xw
#define focus_xh mccchannel_9_analyzer_2_array_crystal_array_3_focus_xh
#define focus_r mccchannel_9_analyzer_2_array_crystal_array_3_focus_r
#define p_interact mccchannel_9_analyzer_2_array_crystal_array_3_p_interact
#define mask_string mccchannel_9_analyzer_2_array_crystal_array_3_mask_string
#define mask_setting mccchannel_9_analyzer_2_array_crystal_array_3_mask_setting
#define number_of_activations mccchannel_9_analyzer_2_array_crystal_array_3_number_of_activations
#line 224 "Union_box.comp"
{
// Initializes the focusing system for this volume including input sanitation.
focus_initialize(&this_box_volume.geometry, POS_A_COMP_INDEX(INDEX_CURRENT_COMP+target_index), POS_A_CURRENT_COMP, ROT_A_CURRENT_COMP, target_index, target_x, target_y, target_z, focus_aw, focus_ah, focus_xw, focus_xh, focus_r, NAME_CURRENT_COMP);

// Input sanitation for this geometry
if (xwidth <= 0) {
  printf("\nERROR in Union_box named %s, the xwidth is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (yheight <= 0) {
  printf("\nERROR in Union_box named %s, yheight is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (zdepth <= 0) {
  printf("\nERROR in Union_box named %s, zdepth is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (xwidth2 <= 0 && xwidth2 != -1) {
  printf("\nERROR in Union_box named %s, the xwidth2 is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (yheight2 <= 0 && yheight2 != -1) {
  printf("\nERROR in Union_box named %s, yheight2 is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}

// Use sanitation
if (global_material_list.num_elements == 0) {
  printf("\nERROR: Need to define a material using Union_make_material before using a Union geometry component. \n");
  printf("       %s was defined before first use of Union_make_material.\n",NAME_CURRENT_COMP);
  exit(1);
}

this_box_volume.geometry.is_masked_volume = 0;
this_box_volume.geometry.is_exit_volume = 0;
this_box_volume.geometry.is_mask_volume = 0;
// check if the volume is a mask, if it is the material string is irelevant.
if (mask_string && strlen(mask_string) && strcmp(mask_string, "NULL") && strcmp(mask_string, "0")) {
    // A mask volume is used to limit the extend of other volumes, called the masked volumes. These are specified in the mask_string.
    // In order for a ray to enter a masked volume, it needs to be both in the region covered by that volume AND the mask volume.
    // When more than
    this_box_volume.geometry.mask_mode = 1; // Default is mask mode is ALL
    if (mask_setting && strlen(mask_setting) && strcmp(mask_setting, "NULL") && strcmp(mask_setting, "0")) {
        if (strcmp(mask_setting,"ALL") == 0 || strcmp(mask_setting,"All") == 0) this_box_volume.geometry.mask_mode = 1;
        else if (strcmp(mask_setting,"ANY") == 0 || strcmp(mask_setting,"Any") == 0) this_box_volume.geometry.mask_mode = 2;
        else {
            printf("The mask_mode of component %s is set to %s, but must be either ALL or ANY.\n",NAME_CURRENT_COMP,mask_setting);
            exit(1);
        }
    }
    
    for (loop_index=0;loop_index<global_geometry_list.num_elements;loop_index++) {
        // Add mask list
        if (1 == manual_linking_function(global_geometry_list.elements[loop_index].name,mask_string)) {
            add_element_to_int_list(&this_box_volume.geometry.mask_list,global_geometry_list.elements[loop_index].component_index);
            add_element_to_int_list(&global_geometry_list.elements[loop_index].Volume->geometry.masked_by_list,INDEX_CURRENT_COMP);
            global_geometry_list.elements[loop_index].Volume->geometry.is_masked_volume = 1;
            if (this_box_volume.geometry.mask_mode == 2)
                global_geometry_list.elements[loop_index].Volume->geometry.mask_mode = 2;
            if (this_box_volume.geometry.mask_mode == 1) {
                if (global_geometry_list.elements[loop_index].Volume->geometry.is_masked_volume == 1 && global_geometry_list.elements[loop_index].Volume->geometry.mask_mode != 2)
                    // If more than one mask is added to one volume, the ANY mode overwrites the (default) ALL mode.
                    global_geometry_list.elements[loop_index].Volume->geometry.mask_mode = 1;
            }
            
            found_geometries = 1;
        }
    }
    if (found_geometries == 0) {
        printf("The mask_string in geometry: %s did not find any of the specified volumes in the mask_string %s \n",NAME_CURRENT_COMP,mask_string);
        exit(1);
    }
    this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
    this_box_volume.p_physics->is_vacuum = 0; // Makes this volume a vacuum
    this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
    this_box_volume.p_physics->my_a = 0; // Should not be used.
    sprintf(this_box_volume.p_physics->name,"Mask");
    this_box_volume.geometry.is_mask_volume = 1;
    
    
// Read the material input, or if it lacks, use automatic linking.
} else if (material_string && strlen(material_string) && strcmp(material_string, "NULL") && strcmp(material_string, "0")) {
    // A geometry string was given, use it to determine which material
    if (0 == strcmp(material_string,"vacuum") || 0 == strcmp(material_string,"Vacuum")) {
        // One could have a global physics struct for vacuum instead of creating one for each
        this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
        this_box_volume.p_physics->is_vacuum = 1; // Makes this volume a vacuum
        this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
        this_box_volume.p_physics->my_a = 0; // Should not be used.
        sprintf(this_box_volume.p_physics->name,"Vacuum");
    } else if (0 == strcmp(material_string,"exit") || 0 == strcmp(material_string,"Exit")) {
        // One could have a global physics struct for vacuum instead of creating one for each
        this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
        this_box_volume.p_physics->is_vacuum = 1; // Makes this volume a vacuum
        this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
        this_box_volume.p_physics->my_a = 0; // Should not be used.
        this_box_volume.geometry.is_exit_volume = 1;
        sprintf(this_box_volume.p_physics->name,"Exit");
    } else {
        #ifndef MATERIAL_DETECTOR
            printf("Need to define a material before refering to it in a geometry %s.\n",NAME_CURRENT_COMP);
            exit(1);
        #endif
        for (loop_index=0;loop_index<global_material_list.num_elements;loop_index++) {
            if (0 == strcmp(material_string,global_material_list.elements[loop_index].name)) {
                this_box_volume.p_physics = global_material_list.elements[loop_index].physics;
                break;
            }
            if (loop_index == global_material_list.num_elements-1) {
            printf("\n");
            printf("ERROR: The material string \"%s\" in Union geometry \"%s\" did not match a specified material. \n",material_string,NAME_CURRENT_COMP);
            printf("       The materials available at this point (need to be defined before the geometry): \n");
            for (loop_index=0;loop_index<global_material_list.num_elements;loop_index++)
              printf("         %s\n",global_material_list.elements[loop_index].name);
            printf("\n");
            printf("       It is also possible to use one of the defualt materials avaiable: \n");
            printf("           Vacuum (for a Volume without scattering or absorption)\n");
            printf("           Exit (for a Volume where the ray exits the component if it enters)\n");
            printf("           Mask (for a Volume that masks existing volumes specified in the mask_string\n");
            exit(1);
          }
        }
    }
} else {
    // Automatic linking, simply using the last defined material.
    #ifndef MATERIAL_DETECTOR
        printf("Need to define a material before the geometry to use automatic linking %s.\n",NAME_CURRENT_COMP);
        exit(1);
    #endif
    this_box_volume.p_physics = global_material_list.elements[global_material_list.num_elements-1].physics;
}

sprintf(this_box_volume.name,NAME_CURRENT_COMP);
sprintf(this_box_volume.geometry.shape,"box");
this_box_volume.geometry.priority_value = priority;
this_box_volume.geometry.geometry_p_interact = p_interact;
// Currently the coordinates will be in absolute space.
this_box_volume.geometry.center = POS_A_CURRENT_COMP;

this_box_storage.z_depth = zdepth;
this_box_storage.x_width1 = xwidth;
this_box_storage.y_height1 = yheight;

this_box_storage.is_rectangle = 0;
if (xwidth2 < 0 && yheight2 < 0) this_box_storage.is_rectangle = 1;
if (xwidth == xwidth2 && yheight == yheight2) this_box_storage.is_rectangle = 1;

if (xwidth2 < 0) {
    this_box_storage.x_width2 = xwidth;
    xwidth2 = xwidth;
} else this_box_storage.x_width2 = xwidth2;

if (yheight2 < 0) {
    this_box_storage.y_height2 = yheight;
    yheight2 = yheight;
} else this_box_storage.y_height2 = yheight2;


this_box_storage.normal_vectors[0] = coords_set(0,0,1);
this_box_storage.normal_vectors[1] = coords_set(0,0,1);

// for sides with y component = 0
x_component = 2*zdepth/sqrt((xwidth-xwidth2)*(xwidth-xwidth2)+4*zdepth*zdepth);
z_component = (xwidth-xwidth2)/sqrt(4*zdepth*zdepth+(xwidth-xwidth2)*(xwidth-xwidth2));

this_box_storage.normal_vectors[2] = coords_set(x_component,0,z_component);
this_box_storage.normal_vectors[3] = coords_set(-x_component,0,z_component);

// for sides with x component = 0
y_component = 2*zdepth/sqrt((yheight-yheight2)*(yheight-yheight2)+4*zdepth*zdepth);
z_component = (yheight-yheight2)/sqrt(4*zdepth*zdepth+(yheight-yheight2)*(yheight-yheight2));

this_box_storage.normal_vectors[4] = coords_set(0,y_component,z_component);
this_box_storage.normal_vectors[5] = coords_set(0,-y_component,z_component);

this_box_volume.geometry.visualization_on = visualize;

this_box_volume.geometry.geometry_parameters.p_box_storage = &this_box_storage;

// Assign pointers to functions for intersection with the shape, checking if a point is inside the shape
if (this_box_storage.is_rectangle == 1) {
this_box_volume.geometry.intersect_function = &sample_box_intersect_simple;
this_box_volume.geometry.within_function = &r_within_box_simple;
}
else {
this_box_volume.geometry.intersect_function = &sample_box_intersect_advanced;
this_box_volume.geometry.within_function = &r_within_box_advanced;
}

this_box_volume.geometry.shell_points = &box_shell_points;
this_box_volume.geometry.mcdisplay_function = &mcdisplay_box_function;
this_box_volume.geometry.initialize_from_main_function = &initialize_box_geometry_from_main_component;
this_box_volume.geometry.process_rot_allocated = 0;

this_box_volume.geometry.copy_geometry_parameters = &allocate_box_storage_copy;

rot_copy(this_box_volume.geometry.rotation_matrix,ROT_A_CURRENT_COMP); //check how ROT_R_CURRENT_COMP would work
rot_transpose(ROT_A_CURRENT_COMP,this_box_volume.geometry.transpose_rotation_matrix);

// Initialize loggers
this_box_volume.loggers.num_elements = 0;

// packing the information into the global_geometry_element, which is then included in the global_geometry_list.
sprintf(global_geometry_element.name,NAME_CURRENT_COMP);
global_geometry_element.activation_counter = number_of_activations;
global_geometry_element.component_index = INDEX_CURRENT_COMP;
global_geometry_element.Volume = &this_box_volume; // Would be nicer if this m was a pointer, now we have the (small) data two places
add_element_to_geometry_list(&global_geometry_list,global_geometry_element);
}
#line 248318 "MACS_sample_kidney_box.c"
#undef number_of_activations
#undef mask_setting
#undef mask_string
#undef p_interact
#undef focus_r
#undef focus_xh
#undef focus_xw
#undef focus_ah
#undef focus_aw
#undef target_z
#undef target_y
#undef target_x
#undef target_index
#undef visualize
#undef yheight2
#undef xwidth2
#undef zdepth
#undef yheight
#undef xwidth
#undef priority
#undef material_string
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

  /* Initializations for component channel_9_analyzer_2_array_crystal_array_4. */
  SIG_MESSAGE("channel_9_analyzer_2_array_crystal_array_4 (Init)");
#define mccompcurname  channel_9_analyzer_2_array_crystal_array_4
#define mccompcurtype  Union_box
#define mccompcurindex 487
#define loop_index mccchannel_9_analyzer_2_array_crystal_array_4_loop_index
#define this_box_volume mccchannel_9_analyzer_2_array_crystal_array_4_this_box_volume
#define global_geometry_element mccchannel_9_analyzer_2_array_crystal_array_4_global_geometry_element
#define this_box_storage mccchannel_9_analyzer_2_array_crystal_array_4_this_box_storage
#define material_string mccchannel_9_analyzer_2_array_crystal_array_4_material_string
#define priority mccchannel_9_analyzer_2_array_crystal_array_4_priority
#define xwidth mccchannel_9_analyzer_2_array_crystal_array_4_xwidth
#define yheight mccchannel_9_analyzer_2_array_crystal_array_4_yheight
#define zdepth mccchannel_9_analyzer_2_array_crystal_array_4_zdepth
#define xwidth2 mccchannel_9_analyzer_2_array_crystal_array_4_xwidth2
#define yheight2 mccchannel_9_analyzer_2_array_crystal_array_4_yheight2
#define visualize mccchannel_9_analyzer_2_array_crystal_array_4_visualize
#define target_index mccchannel_9_analyzer_2_array_crystal_array_4_target_index
#define target_x mccchannel_9_analyzer_2_array_crystal_array_4_target_x
#define target_y mccchannel_9_analyzer_2_array_crystal_array_4_target_y
#define target_z mccchannel_9_analyzer_2_array_crystal_array_4_target_z
#define focus_aw mccchannel_9_analyzer_2_array_crystal_array_4_focus_aw
#define focus_ah mccchannel_9_analyzer_2_array_crystal_array_4_focus_ah
#define focus_xw mccchannel_9_analyzer_2_array_crystal_array_4_focus_xw
#define focus_xh mccchannel_9_analyzer_2_array_crystal_array_4_focus_xh
#define focus_r mccchannel_9_analyzer_2_array_crystal_array_4_focus_r
#define p_interact mccchannel_9_analyzer_2_array_crystal_array_4_p_interact
#define mask_string mccchannel_9_analyzer_2_array_crystal_array_4_mask_string
#define mask_setting mccchannel_9_analyzer_2_array_crystal_array_4_mask_setting
#define number_of_activations mccchannel_9_analyzer_2_array_crystal_array_4_number_of_activations
#line 224 "Union_box.comp"
{
// Initializes the focusing system for this volume including input sanitation.
focus_initialize(&this_box_volume.geometry, POS_A_COMP_INDEX(INDEX_CURRENT_COMP+target_index), POS_A_CURRENT_COMP, ROT_A_CURRENT_COMP, target_index, target_x, target_y, target_z, focus_aw, focus_ah, focus_xw, focus_xh, focus_r, NAME_CURRENT_COMP);

// Input sanitation for this geometry
if (xwidth <= 0) {
  printf("\nERROR in Union_box named %s, the xwidth is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (yheight <= 0) {
  printf("\nERROR in Union_box named %s, yheight is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (zdepth <= 0) {
  printf("\nERROR in Union_box named %s, zdepth is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (xwidth2 <= 0 && xwidth2 != -1) {
  printf("\nERROR in Union_box named %s, the xwidth2 is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (yheight2 <= 0 && yheight2 != -1) {
  printf("\nERROR in Union_box named %s, yheight2 is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}

// Use sanitation
if (global_material_list.num_elements == 0) {
  printf("\nERROR: Need to define a material using Union_make_material before using a Union geometry component. \n");
  printf("       %s was defined before first use of Union_make_material.\n",NAME_CURRENT_COMP);
  exit(1);
}

this_box_volume.geometry.is_masked_volume = 0;
this_box_volume.geometry.is_exit_volume = 0;
this_box_volume.geometry.is_mask_volume = 0;
// check if the volume is a mask, if it is the material string is irelevant.
if (mask_string && strlen(mask_string) && strcmp(mask_string, "NULL") && strcmp(mask_string, "0")) {
    // A mask volume is used to limit the extend of other volumes, called the masked volumes. These are specified in the mask_string.
    // In order for a ray to enter a masked volume, it needs to be both in the region covered by that volume AND the mask volume.
    // When more than
    this_box_volume.geometry.mask_mode = 1; // Default is mask mode is ALL
    if (mask_setting && strlen(mask_setting) && strcmp(mask_setting, "NULL") && strcmp(mask_setting, "0")) {
        if (strcmp(mask_setting,"ALL") == 0 || strcmp(mask_setting,"All") == 0) this_box_volume.geometry.mask_mode = 1;
        else if (strcmp(mask_setting,"ANY") == 0 || strcmp(mask_setting,"Any") == 0) this_box_volume.geometry.mask_mode = 2;
        else {
            printf("The mask_mode of component %s is set to %s, but must be either ALL or ANY.\n",NAME_CURRENT_COMP,mask_setting);
            exit(1);
        }
    }
    
    for (loop_index=0;loop_index<global_geometry_list.num_elements;loop_index++) {
        // Add mask list
        if (1 == manual_linking_function(global_geometry_list.elements[loop_index].name,mask_string)) {
            add_element_to_int_list(&this_box_volume.geometry.mask_list,global_geometry_list.elements[loop_index].component_index);
            add_element_to_int_list(&global_geometry_list.elements[loop_index].Volume->geometry.masked_by_list,INDEX_CURRENT_COMP);
            global_geometry_list.elements[loop_index].Volume->geometry.is_masked_volume = 1;
            if (this_box_volume.geometry.mask_mode == 2)
                global_geometry_list.elements[loop_index].Volume->geometry.mask_mode = 2;
            if (this_box_volume.geometry.mask_mode == 1) {
                if (global_geometry_list.elements[loop_index].Volume->geometry.is_masked_volume == 1 && global_geometry_list.elements[loop_index].Volume->geometry.mask_mode != 2)
                    // If more than one mask is added to one volume, the ANY mode overwrites the (default) ALL mode.
                    global_geometry_list.elements[loop_index].Volume->geometry.mask_mode = 1;
            }
            
            found_geometries = 1;
        }
    }
    if (found_geometries == 0) {
        printf("The mask_string in geometry: %s did not find any of the specified volumes in the mask_string %s \n",NAME_CURRENT_COMP,mask_string);
        exit(1);
    }
    this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
    this_box_volume.p_physics->is_vacuum = 0; // Makes this volume a vacuum
    this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
    this_box_volume.p_physics->my_a = 0; // Should not be used.
    sprintf(this_box_volume.p_physics->name,"Mask");
    this_box_volume.geometry.is_mask_volume = 1;
    
    
// Read the material input, or if it lacks, use automatic linking.
} else if (material_string && strlen(material_string) && strcmp(material_string, "NULL") && strcmp(material_string, "0")) {
    // A geometry string was given, use it to determine which material
    if (0 == strcmp(material_string,"vacuum") || 0 == strcmp(material_string,"Vacuum")) {
        // One could have a global physics struct for vacuum instead of creating one for each
        this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
        this_box_volume.p_physics->is_vacuum = 1; // Makes this volume a vacuum
        this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
        this_box_volume.p_physics->my_a = 0; // Should not be used.
        sprintf(this_box_volume.p_physics->name,"Vacuum");
    } else if (0 == strcmp(material_string,"exit") || 0 == strcmp(material_string,"Exit")) {
        // One could have a global physics struct for vacuum instead of creating one for each
        this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
        this_box_volume.p_physics->is_vacuum = 1; // Makes this volume a vacuum
        this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
        this_box_volume.p_physics->my_a = 0; // Should not be used.
        this_box_volume.geometry.is_exit_volume = 1;
        sprintf(this_box_volume.p_physics->name,"Exit");
    } else {
        #ifndef MATERIAL_DETECTOR
            printf("Need to define a material before refering to it in a geometry %s.\n",NAME_CURRENT_COMP);
            exit(1);
        #endif
        for (loop_index=0;loop_index<global_material_list.num_elements;loop_index++) {
            if (0 == strcmp(material_string,global_material_list.elements[loop_index].name)) {
                this_box_volume.p_physics = global_material_list.elements[loop_index].physics;
                break;
            }
            if (loop_index == global_material_list.num_elements-1) {
            printf("\n");
            printf("ERROR: The material string \"%s\" in Union geometry \"%s\" did not match a specified material. \n",material_string,NAME_CURRENT_COMP);
            printf("       The materials available at this point (need to be defined before the geometry): \n");
            for (loop_index=0;loop_index<global_material_list.num_elements;loop_index++)
              printf("         %s\n",global_material_list.elements[loop_index].name);
            printf("\n");
            printf("       It is also possible to use one of the defualt materials avaiable: \n");
            printf("           Vacuum (for a Volume without scattering or absorption)\n");
            printf("           Exit (for a Volume where the ray exits the component if it enters)\n");
            printf("           Mask (for a Volume that masks existing volumes specified in the mask_string\n");
            exit(1);
          }
        }
    }
} else {
    // Automatic linking, simply using the last defined material.
    #ifndef MATERIAL_DETECTOR
        printf("Need to define a material before the geometry to use automatic linking %s.\n",NAME_CURRENT_COMP);
        exit(1);
    #endif
    this_box_volume.p_physics = global_material_list.elements[global_material_list.num_elements-1].physics;
}

sprintf(this_box_volume.name,NAME_CURRENT_COMP);
sprintf(this_box_volume.geometry.shape,"box");
this_box_volume.geometry.priority_value = priority;
this_box_volume.geometry.geometry_p_interact = p_interact;
// Currently the coordinates will be in absolute space.
this_box_volume.geometry.center = POS_A_CURRENT_COMP;

this_box_storage.z_depth = zdepth;
this_box_storage.x_width1 = xwidth;
this_box_storage.y_height1 = yheight;

this_box_storage.is_rectangle = 0;
if (xwidth2 < 0 && yheight2 < 0) this_box_storage.is_rectangle = 1;
if (xwidth == xwidth2 && yheight == yheight2) this_box_storage.is_rectangle = 1;

if (xwidth2 < 0) {
    this_box_storage.x_width2 = xwidth;
    xwidth2 = xwidth;
} else this_box_storage.x_width2 = xwidth2;

if (yheight2 < 0) {
    this_box_storage.y_height2 = yheight;
    yheight2 = yheight;
} else this_box_storage.y_height2 = yheight2;


this_box_storage.normal_vectors[0] = coords_set(0,0,1);
this_box_storage.normal_vectors[1] = coords_set(0,0,1);

// for sides with y component = 0
x_component = 2*zdepth/sqrt((xwidth-xwidth2)*(xwidth-xwidth2)+4*zdepth*zdepth);
z_component = (xwidth-xwidth2)/sqrt(4*zdepth*zdepth+(xwidth-xwidth2)*(xwidth-xwidth2));

this_box_storage.normal_vectors[2] = coords_set(x_component,0,z_component);
this_box_storage.normal_vectors[3] = coords_set(-x_component,0,z_component);

// for sides with x component = 0
y_component = 2*zdepth/sqrt((yheight-yheight2)*(yheight-yheight2)+4*zdepth*zdepth);
z_component = (yheight-yheight2)/sqrt(4*zdepth*zdepth+(yheight-yheight2)*(yheight-yheight2));

this_box_storage.normal_vectors[4] = coords_set(0,y_component,z_component);
this_box_storage.normal_vectors[5] = coords_set(0,-y_component,z_component);

this_box_volume.geometry.visualization_on = visualize;

this_box_volume.geometry.geometry_parameters.p_box_storage = &this_box_storage;

// Assign pointers to functions for intersection with the shape, checking if a point is inside the shape
if (this_box_storage.is_rectangle == 1) {
this_box_volume.geometry.intersect_function = &sample_box_intersect_simple;
this_box_volume.geometry.within_function = &r_within_box_simple;
}
else {
this_box_volume.geometry.intersect_function = &sample_box_intersect_advanced;
this_box_volume.geometry.within_function = &r_within_box_advanced;
}

this_box_volume.geometry.shell_points = &box_shell_points;
this_box_volume.geometry.mcdisplay_function = &mcdisplay_box_function;
this_box_volume.geometry.initialize_from_main_function = &initialize_box_geometry_from_main_component;
this_box_volume.geometry.process_rot_allocated = 0;

this_box_volume.geometry.copy_geometry_parameters = &allocate_box_storage_copy;

rot_copy(this_box_volume.geometry.rotation_matrix,ROT_A_CURRENT_COMP); //check how ROT_R_CURRENT_COMP would work
rot_transpose(ROT_A_CURRENT_COMP,this_box_volume.geometry.transpose_rotation_matrix);

// Initialize loggers
this_box_volume.loggers.num_elements = 0;

// packing the information into the global_geometry_element, which is then included in the global_geometry_list.
sprintf(global_geometry_element.name,NAME_CURRENT_COMP);
global_geometry_element.activation_counter = number_of_activations;
global_geometry_element.component_index = INDEX_CURRENT_COMP;
global_geometry_element.Volume = &this_box_volume; // Would be nicer if this m was a pointer, now we have the (small) data two places
add_element_to_geometry_list(&global_geometry_list,global_geometry_element);
}
#line 248588 "MACS_sample_kidney_box.c"
#undef number_of_activations
#undef mask_setting
#undef mask_string
#undef p_interact
#undef focus_r
#undef focus_xh
#undef focus_xw
#undef focus_ah
#undef focus_aw
#undef target_z
#undef target_y
#undef target_x
#undef target_index
#undef visualize
#undef yheight2
#undef xwidth2
#undef zdepth
#undef yheight
#undef xwidth
#undef priority
#undef material_string
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

  /* Initializations for component channel_9_analyzer_2_array_crystal_array_5. */
  SIG_MESSAGE("channel_9_analyzer_2_array_crystal_array_5 (Init)");
#define mccompcurname  channel_9_analyzer_2_array_crystal_array_5
#define mccompcurtype  Union_box
#define mccompcurindex 488
#define loop_index mccchannel_9_analyzer_2_array_crystal_array_5_loop_index
#define this_box_volume mccchannel_9_analyzer_2_array_crystal_array_5_this_box_volume
#define global_geometry_element mccchannel_9_analyzer_2_array_crystal_array_5_global_geometry_element
#define this_box_storage mccchannel_9_analyzer_2_array_crystal_array_5_this_box_storage
#define material_string mccchannel_9_analyzer_2_array_crystal_array_5_material_string
#define priority mccchannel_9_analyzer_2_array_crystal_array_5_priority
#define xwidth mccchannel_9_analyzer_2_array_crystal_array_5_xwidth
#define yheight mccchannel_9_analyzer_2_array_crystal_array_5_yheight
#define zdepth mccchannel_9_analyzer_2_array_crystal_array_5_zdepth
#define xwidth2 mccchannel_9_analyzer_2_array_crystal_array_5_xwidth2
#define yheight2 mccchannel_9_analyzer_2_array_crystal_array_5_yheight2
#define visualize mccchannel_9_analyzer_2_array_crystal_array_5_visualize
#define target_index mccchannel_9_analyzer_2_array_crystal_array_5_target_index
#define target_x mccchannel_9_analyzer_2_array_crystal_array_5_target_x
#define target_y mccchannel_9_analyzer_2_array_crystal_array_5_target_y
#define target_z mccchannel_9_analyzer_2_array_crystal_array_5_target_z
#define focus_aw mccchannel_9_analyzer_2_array_crystal_array_5_focus_aw
#define focus_ah mccchannel_9_analyzer_2_array_crystal_array_5_focus_ah
#define focus_xw mccchannel_9_analyzer_2_array_crystal_array_5_focus_xw
#define focus_xh mccchannel_9_analyzer_2_array_crystal_array_5_focus_xh
#define focus_r mccchannel_9_analyzer_2_array_crystal_array_5_focus_r
#define p_interact mccchannel_9_analyzer_2_array_crystal_array_5_p_interact
#define mask_string mccchannel_9_analyzer_2_array_crystal_array_5_mask_string
#define mask_setting mccchannel_9_analyzer_2_array_crystal_array_5_mask_setting
#define number_of_activations mccchannel_9_analyzer_2_array_crystal_array_5_number_of_activations
#line 224 "Union_box.comp"
{
// Initializes the focusing system for this volume including input sanitation.
focus_initialize(&this_box_volume.geometry, POS_A_COMP_INDEX(INDEX_CURRENT_COMP+target_index), POS_A_CURRENT_COMP, ROT_A_CURRENT_COMP, target_index, target_x, target_y, target_z, focus_aw, focus_ah, focus_xw, focus_xh, focus_r, NAME_CURRENT_COMP);

// Input sanitation for this geometry
if (xwidth <= 0) {
  printf("\nERROR in Union_box named %s, the xwidth is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (yheight <= 0) {
  printf("\nERROR in Union_box named %s, yheight is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (zdepth <= 0) {
  printf("\nERROR in Union_box named %s, zdepth is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (xwidth2 <= 0 && xwidth2 != -1) {
  printf("\nERROR in Union_box named %s, the xwidth2 is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (yheight2 <= 0 && yheight2 != -1) {
  printf("\nERROR in Union_box named %s, yheight2 is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}

// Use sanitation
if (global_material_list.num_elements == 0) {
  printf("\nERROR: Need to define a material using Union_make_material before using a Union geometry component. \n");
  printf("       %s was defined before first use of Union_make_material.\n",NAME_CURRENT_COMP);
  exit(1);
}

this_box_volume.geometry.is_masked_volume = 0;
this_box_volume.geometry.is_exit_volume = 0;
this_box_volume.geometry.is_mask_volume = 0;
// check if the volume is a mask, if it is the material string is irelevant.
if (mask_string && strlen(mask_string) && strcmp(mask_string, "NULL") && strcmp(mask_string, "0")) {
    // A mask volume is used to limit the extend of other volumes, called the masked volumes. These are specified in the mask_string.
    // In order for a ray to enter a masked volume, it needs to be both in the region covered by that volume AND the mask volume.
    // When more than
    this_box_volume.geometry.mask_mode = 1; // Default is mask mode is ALL
    if (mask_setting && strlen(mask_setting) && strcmp(mask_setting, "NULL") && strcmp(mask_setting, "0")) {
        if (strcmp(mask_setting,"ALL") == 0 || strcmp(mask_setting,"All") == 0) this_box_volume.geometry.mask_mode = 1;
        else if (strcmp(mask_setting,"ANY") == 0 || strcmp(mask_setting,"Any") == 0) this_box_volume.geometry.mask_mode = 2;
        else {
            printf("The mask_mode of component %s is set to %s, but must be either ALL or ANY.\n",NAME_CURRENT_COMP,mask_setting);
            exit(1);
        }
    }
    
    for (loop_index=0;loop_index<global_geometry_list.num_elements;loop_index++) {
        // Add mask list
        if (1 == manual_linking_function(global_geometry_list.elements[loop_index].name,mask_string)) {
            add_element_to_int_list(&this_box_volume.geometry.mask_list,global_geometry_list.elements[loop_index].component_index);
            add_element_to_int_list(&global_geometry_list.elements[loop_index].Volume->geometry.masked_by_list,INDEX_CURRENT_COMP);
            global_geometry_list.elements[loop_index].Volume->geometry.is_masked_volume = 1;
            if (this_box_volume.geometry.mask_mode == 2)
                global_geometry_list.elements[loop_index].Volume->geometry.mask_mode = 2;
            if (this_box_volume.geometry.mask_mode == 1) {
                if (global_geometry_list.elements[loop_index].Volume->geometry.is_masked_volume == 1 && global_geometry_list.elements[loop_index].Volume->geometry.mask_mode != 2)
                    // If more than one mask is added to one volume, the ANY mode overwrites the (default) ALL mode.
                    global_geometry_list.elements[loop_index].Volume->geometry.mask_mode = 1;
            }
            
            found_geometries = 1;
        }
    }
    if (found_geometries == 0) {
        printf("The mask_string in geometry: %s did not find any of the specified volumes in the mask_string %s \n",NAME_CURRENT_COMP,mask_string);
        exit(1);
    }
    this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
    this_box_volume.p_physics->is_vacuum = 0; // Makes this volume a vacuum
    this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
    this_box_volume.p_physics->my_a = 0; // Should not be used.
    sprintf(this_box_volume.p_physics->name,"Mask");
    this_box_volume.geometry.is_mask_volume = 1;
    
    
// Read the material input, or if it lacks, use automatic linking.
} else if (material_string && strlen(material_string) && strcmp(material_string, "NULL") && strcmp(material_string, "0")) {
    // A geometry string was given, use it to determine which material
    if (0 == strcmp(material_string,"vacuum") || 0 == strcmp(material_string,"Vacuum")) {
        // One could have a global physics struct for vacuum instead of creating one for each
        this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
        this_box_volume.p_physics->is_vacuum = 1; // Makes this volume a vacuum
        this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
        this_box_volume.p_physics->my_a = 0; // Should not be used.
        sprintf(this_box_volume.p_physics->name,"Vacuum");
    } else if (0 == strcmp(material_string,"exit") || 0 == strcmp(material_string,"Exit")) {
        // One could have a global physics struct for vacuum instead of creating one for each
        this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
        this_box_volume.p_physics->is_vacuum = 1; // Makes this volume a vacuum
        this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
        this_box_volume.p_physics->my_a = 0; // Should not be used.
        this_box_volume.geometry.is_exit_volume = 1;
        sprintf(this_box_volume.p_physics->name,"Exit");
    } else {
        #ifndef MATERIAL_DETECTOR
            printf("Need to define a material before refering to it in a geometry %s.\n",NAME_CURRENT_COMP);
            exit(1);
        #endif
        for (loop_index=0;loop_index<global_material_list.num_elements;loop_index++) {
            if (0 == strcmp(material_string,global_material_list.elements[loop_index].name)) {
                this_box_volume.p_physics = global_material_list.elements[loop_index].physics;
                break;
            }
            if (loop_index == global_material_list.num_elements-1) {
            printf("\n");
            printf("ERROR: The material string \"%s\" in Union geometry \"%s\" did not match a specified material. \n",material_string,NAME_CURRENT_COMP);
            printf("       The materials available at this point (need to be defined before the geometry): \n");
            for (loop_index=0;loop_index<global_material_list.num_elements;loop_index++)
              printf("         %s\n",global_material_list.elements[loop_index].name);
            printf("\n");
            printf("       It is also possible to use one of the defualt materials avaiable: \n");
            printf("           Vacuum (for a Volume without scattering or absorption)\n");
            printf("           Exit (for a Volume where the ray exits the component if it enters)\n");
            printf("           Mask (for a Volume that masks existing volumes specified in the mask_string\n");
            exit(1);
          }
        }
    }
} else {
    // Automatic linking, simply using the last defined material.
    #ifndef MATERIAL_DETECTOR
        printf("Need to define a material before the geometry to use automatic linking %s.\n",NAME_CURRENT_COMP);
        exit(1);
    #endif
    this_box_volume.p_physics = global_material_list.elements[global_material_list.num_elements-1].physics;
}

sprintf(this_box_volume.name,NAME_CURRENT_COMP);
sprintf(this_box_volume.geometry.shape,"box");
this_box_volume.geometry.priority_value = priority;
this_box_volume.geometry.geometry_p_interact = p_interact;
// Currently the coordinates will be in absolute space.
this_box_volume.geometry.center = POS_A_CURRENT_COMP;

this_box_storage.z_depth = zdepth;
this_box_storage.x_width1 = xwidth;
this_box_storage.y_height1 = yheight;

this_box_storage.is_rectangle = 0;
if (xwidth2 < 0 && yheight2 < 0) this_box_storage.is_rectangle = 1;
if (xwidth == xwidth2 && yheight == yheight2) this_box_storage.is_rectangle = 1;

if (xwidth2 < 0) {
    this_box_storage.x_width2 = xwidth;
    xwidth2 = xwidth;
} else this_box_storage.x_width2 = xwidth2;

if (yheight2 < 0) {
    this_box_storage.y_height2 = yheight;
    yheight2 = yheight;
} else this_box_storage.y_height2 = yheight2;


this_box_storage.normal_vectors[0] = coords_set(0,0,1);
this_box_storage.normal_vectors[1] = coords_set(0,0,1);

// for sides with y component = 0
x_component = 2*zdepth/sqrt((xwidth-xwidth2)*(xwidth-xwidth2)+4*zdepth*zdepth);
z_component = (xwidth-xwidth2)/sqrt(4*zdepth*zdepth+(xwidth-xwidth2)*(xwidth-xwidth2));

this_box_storage.normal_vectors[2] = coords_set(x_component,0,z_component);
this_box_storage.normal_vectors[3] = coords_set(-x_component,0,z_component);

// for sides with x component = 0
y_component = 2*zdepth/sqrt((yheight-yheight2)*(yheight-yheight2)+4*zdepth*zdepth);
z_component = (yheight-yheight2)/sqrt(4*zdepth*zdepth+(yheight-yheight2)*(yheight-yheight2));

this_box_storage.normal_vectors[4] = coords_set(0,y_component,z_component);
this_box_storage.normal_vectors[5] = coords_set(0,-y_component,z_component);

this_box_volume.geometry.visualization_on = visualize;

this_box_volume.geometry.geometry_parameters.p_box_storage = &this_box_storage;

// Assign pointers to functions for intersection with the shape, checking if a point is inside the shape
if (this_box_storage.is_rectangle == 1) {
this_box_volume.geometry.intersect_function = &sample_box_intersect_simple;
this_box_volume.geometry.within_function = &r_within_box_simple;
}
else {
this_box_volume.geometry.intersect_function = &sample_box_intersect_advanced;
this_box_volume.geometry.within_function = &r_within_box_advanced;
}

this_box_volume.geometry.shell_points = &box_shell_points;
this_box_volume.geometry.mcdisplay_function = &mcdisplay_box_function;
this_box_volume.geometry.initialize_from_main_function = &initialize_box_geometry_from_main_component;
this_box_volume.geometry.process_rot_allocated = 0;

this_box_volume.geometry.copy_geometry_parameters = &allocate_box_storage_copy;

rot_copy(this_box_volume.geometry.rotation_matrix,ROT_A_CURRENT_COMP); //check how ROT_R_CURRENT_COMP would work
rot_transpose(ROT_A_CURRENT_COMP,this_box_volume.geometry.transpose_rotation_matrix);

// Initialize loggers
this_box_volume.loggers.num_elements = 0;

// packing the information into the global_geometry_element, which is then included in the global_geometry_list.
sprintf(global_geometry_element.name,NAME_CURRENT_COMP);
global_geometry_element.activation_counter = number_of_activations;
global_geometry_element.component_index = INDEX_CURRENT_COMP;
global_geometry_element.Volume = &this_box_volume; // Would be nicer if this m was a pointer, now we have the (small) data two places
add_element_to_geometry_list(&global_geometry_list,global_geometry_element);
}
#line 248858 "MACS_sample_kidney_box.c"
#undef number_of_activations
#undef mask_setting
#undef mask_string
#undef p_interact
#undef focus_r
#undef focus_xh
#undef focus_xw
#undef focus_ah
#undef focus_aw
#undef target_z
#undef target_y
#undef target_x
#undef target_index
#undef visualize
#undef yheight2
#undef xwidth2
#undef zdepth
#undef yheight
#undef xwidth
#undef priority
#undef material_string
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

  /* Initializations for component channel_9_analyzer_2_array_crystal_array_6. */
  SIG_MESSAGE("channel_9_analyzer_2_array_crystal_array_6 (Init)");
#define mccompcurname  channel_9_analyzer_2_array_crystal_array_6
#define mccompcurtype  Union_box
#define mccompcurindex 489
#define loop_index mccchannel_9_analyzer_2_array_crystal_array_6_loop_index
#define this_box_volume mccchannel_9_analyzer_2_array_crystal_array_6_this_box_volume
#define global_geometry_element mccchannel_9_analyzer_2_array_crystal_array_6_global_geometry_element
#define this_box_storage mccchannel_9_analyzer_2_array_crystal_array_6_this_box_storage
#define material_string mccchannel_9_analyzer_2_array_crystal_array_6_material_string
#define priority mccchannel_9_analyzer_2_array_crystal_array_6_priority
#define xwidth mccchannel_9_analyzer_2_array_crystal_array_6_xwidth
#define yheight mccchannel_9_analyzer_2_array_crystal_array_6_yheight
#define zdepth mccchannel_9_analyzer_2_array_crystal_array_6_zdepth
#define xwidth2 mccchannel_9_analyzer_2_array_crystal_array_6_xwidth2
#define yheight2 mccchannel_9_analyzer_2_array_crystal_array_6_yheight2
#define visualize mccchannel_9_analyzer_2_array_crystal_array_6_visualize
#define target_index mccchannel_9_analyzer_2_array_crystal_array_6_target_index
#define target_x mccchannel_9_analyzer_2_array_crystal_array_6_target_x
#define target_y mccchannel_9_analyzer_2_array_crystal_array_6_target_y
#define target_z mccchannel_9_analyzer_2_array_crystal_array_6_target_z
#define focus_aw mccchannel_9_analyzer_2_array_crystal_array_6_focus_aw
#define focus_ah mccchannel_9_analyzer_2_array_crystal_array_6_focus_ah
#define focus_xw mccchannel_9_analyzer_2_array_crystal_array_6_focus_xw
#define focus_xh mccchannel_9_analyzer_2_array_crystal_array_6_focus_xh
#define focus_r mccchannel_9_analyzer_2_array_crystal_array_6_focus_r
#define p_interact mccchannel_9_analyzer_2_array_crystal_array_6_p_interact
#define mask_string mccchannel_9_analyzer_2_array_crystal_array_6_mask_string
#define mask_setting mccchannel_9_analyzer_2_array_crystal_array_6_mask_setting
#define number_of_activations mccchannel_9_analyzer_2_array_crystal_array_6_number_of_activations
#line 224 "Union_box.comp"
{
// Initializes the focusing system for this volume including input sanitation.
focus_initialize(&this_box_volume.geometry, POS_A_COMP_INDEX(INDEX_CURRENT_COMP+target_index), POS_A_CURRENT_COMP, ROT_A_CURRENT_COMP, target_index, target_x, target_y, target_z, focus_aw, focus_ah, focus_xw, focus_xh, focus_r, NAME_CURRENT_COMP);

// Input sanitation for this geometry
if (xwidth <= 0) {
  printf("\nERROR in Union_box named %s, the xwidth is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (yheight <= 0) {
  printf("\nERROR in Union_box named %s, yheight is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (zdepth <= 0) {
  printf("\nERROR in Union_box named %s, zdepth is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (xwidth2 <= 0 && xwidth2 != -1) {
  printf("\nERROR in Union_box named %s, the xwidth2 is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (yheight2 <= 0 && yheight2 != -1) {
  printf("\nERROR in Union_box named %s, yheight2 is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}

// Use sanitation
if (global_material_list.num_elements == 0) {
  printf("\nERROR: Need to define a material using Union_make_material before using a Union geometry component. \n");
  printf("       %s was defined before first use of Union_make_material.\n",NAME_CURRENT_COMP);
  exit(1);
}

this_box_volume.geometry.is_masked_volume = 0;
this_box_volume.geometry.is_exit_volume = 0;
this_box_volume.geometry.is_mask_volume = 0;
// check if the volume is a mask, if it is the material string is irelevant.
if (mask_string && strlen(mask_string) && strcmp(mask_string, "NULL") && strcmp(mask_string, "0")) {
    // A mask volume is used to limit the extend of other volumes, called the masked volumes. These are specified in the mask_string.
    // In order for a ray to enter a masked volume, it needs to be both in the region covered by that volume AND the mask volume.
    // When more than
    this_box_volume.geometry.mask_mode = 1; // Default is mask mode is ALL
    if (mask_setting && strlen(mask_setting) && strcmp(mask_setting, "NULL") && strcmp(mask_setting, "0")) {
        if (strcmp(mask_setting,"ALL") == 0 || strcmp(mask_setting,"All") == 0) this_box_volume.geometry.mask_mode = 1;
        else if (strcmp(mask_setting,"ANY") == 0 || strcmp(mask_setting,"Any") == 0) this_box_volume.geometry.mask_mode = 2;
        else {
            printf("The mask_mode of component %s is set to %s, but must be either ALL or ANY.\n",NAME_CURRENT_COMP,mask_setting);
            exit(1);
        }
    }
    
    for (loop_index=0;loop_index<global_geometry_list.num_elements;loop_index++) {
        // Add mask list
        if (1 == manual_linking_function(global_geometry_list.elements[loop_index].name,mask_string)) {
            add_element_to_int_list(&this_box_volume.geometry.mask_list,global_geometry_list.elements[loop_index].component_index);
            add_element_to_int_list(&global_geometry_list.elements[loop_index].Volume->geometry.masked_by_list,INDEX_CURRENT_COMP);
            global_geometry_list.elements[loop_index].Volume->geometry.is_masked_volume = 1;
            if (this_box_volume.geometry.mask_mode == 2)
                global_geometry_list.elements[loop_index].Volume->geometry.mask_mode = 2;
            if (this_box_volume.geometry.mask_mode == 1) {
                if (global_geometry_list.elements[loop_index].Volume->geometry.is_masked_volume == 1 && global_geometry_list.elements[loop_index].Volume->geometry.mask_mode != 2)
                    // If more than one mask is added to one volume, the ANY mode overwrites the (default) ALL mode.
                    global_geometry_list.elements[loop_index].Volume->geometry.mask_mode = 1;
            }
            
            found_geometries = 1;
        }
    }
    if (found_geometries == 0) {
        printf("The mask_string in geometry: %s did not find any of the specified volumes in the mask_string %s \n",NAME_CURRENT_COMP,mask_string);
        exit(1);
    }
    this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
    this_box_volume.p_physics->is_vacuum = 0; // Makes this volume a vacuum
    this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
    this_box_volume.p_physics->my_a = 0; // Should not be used.
    sprintf(this_box_volume.p_physics->name,"Mask");
    this_box_volume.geometry.is_mask_volume = 1;
    
    
// Read the material input, or if it lacks, use automatic linking.
} else if (material_string && strlen(material_string) && strcmp(material_string, "NULL") && strcmp(material_string, "0")) {
    // A geometry string was given, use it to determine which material
    if (0 == strcmp(material_string,"vacuum") || 0 == strcmp(material_string,"Vacuum")) {
        // One could have a global physics struct for vacuum instead of creating one for each
        this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
        this_box_volume.p_physics->is_vacuum = 1; // Makes this volume a vacuum
        this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
        this_box_volume.p_physics->my_a = 0; // Should not be used.
        sprintf(this_box_volume.p_physics->name,"Vacuum");
    } else if (0 == strcmp(material_string,"exit") || 0 == strcmp(material_string,"Exit")) {
        // One could have a global physics struct for vacuum instead of creating one for each
        this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
        this_box_volume.p_physics->is_vacuum = 1; // Makes this volume a vacuum
        this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
        this_box_volume.p_physics->my_a = 0; // Should not be used.
        this_box_volume.geometry.is_exit_volume = 1;
        sprintf(this_box_volume.p_physics->name,"Exit");
    } else {
        #ifndef MATERIAL_DETECTOR
            printf("Need to define a material before refering to it in a geometry %s.\n",NAME_CURRENT_COMP);
            exit(1);
        #endif
        for (loop_index=0;loop_index<global_material_list.num_elements;loop_index++) {
            if (0 == strcmp(material_string,global_material_list.elements[loop_index].name)) {
                this_box_volume.p_physics = global_material_list.elements[loop_index].physics;
                break;
            }
            if (loop_index == global_material_list.num_elements-1) {
            printf("\n");
            printf("ERROR: The material string \"%s\" in Union geometry \"%s\" did not match a specified material. \n",material_string,NAME_CURRENT_COMP);
            printf("       The materials available at this point (need to be defined before the geometry): \n");
            for (loop_index=0;loop_index<global_material_list.num_elements;loop_index++)
              printf("         %s\n",global_material_list.elements[loop_index].name);
            printf("\n");
            printf("       It is also possible to use one of the defualt materials avaiable: \n");
            printf("           Vacuum (for a Volume without scattering or absorption)\n");
            printf("           Exit (for a Volume where the ray exits the component if it enters)\n");
            printf("           Mask (for a Volume that masks existing volumes specified in the mask_string\n");
            exit(1);
          }
        }
    }
} else {
    // Automatic linking, simply using the last defined material.
    #ifndef MATERIAL_DETECTOR
        printf("Need to define a material before the geometry to use automatic linking %s.\n",NAME_CURRENT_COMP);
        exit(1);
    #endif
    this_box_volume.p_physics = global_material_list.elements[global_material_list.num_elements-1].physics;
}

sprintf(this_box_volume.name,NAME_CURRENT_COMP);
sprintf(this_box_volume.geometry.shape,"box");
this_box_volume.geometry.priority_value = priority;
this_box_volume.geometry.geometry_p_interact = p_interact;
// Currently the coordinates will be in absolute space.
this_box_volume.geometry.center = POS_A_CURRENT_COMP;

this_box_storage.z_depth = zdepth;
this_box_storage.x_width1 = xwidth;
this_box_storage.y_height1 = yheight;

this_box_storage.is_rectangle = 0;
if (xwidth2 < 0 && yheight2 < 0) this_box_storage.is_rectangle = 1;
if (xwidth == xwidth2 && yheight == yheight2) this_box_storage.is_rectangle = 1;

if (xwidth2 < 0) {
    this_box_storage.x_width2 = xwidth;
    xwidth2 = xwidth;
} else this_box_storage.x_width2 = xwidth2;

if (yheight2 < 0) {
    this_box_storage.y_height2 = yheight;
    yheight2 = yheight;
} else this_box_storage.y_height2 = yheight2;


this_box_storage.normal_vectors[0] = coords_set(0,0,1);
this_box_storage.normal_vectors[1] = coords_set(0,0,1);

// for sides with y component = 0
x_component = 2*zdepth/sqrt((xwidth-xwidth2)*(xwidth-xwidth2)+4*zdepth*zdepth);
z_component = (xwidth-xwidth2)/sqrt(4*zdepth*zdepth+(xwidth-xwidth2)*(xwidth-xwidth2));

this_box_storage.normal_vectors[2] = coords_set(x_component,0,z_component);
this_box_storage.normal_vectors[3] = coords_set(-x_component,0,z_component);

// for sides with x component = 0
y_component = 2*zdepth/sqrt((yheight-yheight2)*(yheight-yheight2)+4*zdepth*zdepth);
z_component = (yheight-yheight2)/sqrt(4*zdepth*zdepth+(yheight-yheight2)*(yheight-yheight2));

this_box_storage.normal_vectors[4] = coords_set(0,y_component,z_component);
this_box_storage.normal_vectors[5] = coords_set(0,-y_component,z_component);

this_box_volume.geometry.visualization_on = visualize;

this_box_volume.geometry.geometry_parameters.p_box_storage = &this_box_storage;

// Assign pointers to functions for intersection with the shape, checking if a point is inside the shape
if (this_box_storage.is_rectangle == 1) {
this_box_volume.geometry.intersect_function = &sample_box_intersect_simple;
this_box_volume.geometry.within_function = &r_within_box_simple;
}
else {
this_box_volume.geometry.intersect_function = &sample_box_intersect_advanced;
this_box_volume.geometry.within_function = &r_within_box_advanced;
}

this_box_volume.geometry.shell_points = &box_shell_points;
this_box_volume.geometry.mcdisplay_function = &mcdisplay_box_function;
this_box_volume.geometry.initialize_from_main_function = &initialize_box_geometry_from_main_component;
this_box_volume.geometry.process_rot_allocated = 0;

this_box_volume.geometry.copy_geometry_parameters = &allocate_box_storage_copy;

rot_copy(this_box_volume.geometry.rotation_matrix,ROT_A_CURRENT_COMP); //check how ROT_R_CURRENT_COMP would work
rot_transpose(ROT_A_CURRENT_COMP,this_box_volume.geometry.transpose_rotation_matrix);

// Initialize loggers
this_box_volume.loggers.num_elements = 0;

// packing the information into the global_geometry_element, which is then included in the global_geometry_list.
sprintf(global_geometry_element.name,NAME_CURRENT_COMP);
global_geometry_element.activation_counter = number_of_activations;
global_geometry_element.component_index = INDEX_CURRENT_COMP;
global_geometry_element.Volume = &this_box_volume; // Would be nicer if this m was a pointer, now we have the (small) data two places
add_element_to_geometry_list(&global_geometry_list,global_geometry_element);
}
#line 249128 "MACS_sample_kidney_box.c"
#undef number_of_activations
#undef mask_setting
#undef mask_string
#undef p_interact
#undef focus_r
#undef focus_xh
#undef focus_xw
#undef focus_ah
#undef focus_aw
#undef target_z
#undef target_y
#undef target_x
#undef target_index
#undef visualize
#undef yheight2
#undef xwidth2
#undef zdepth
#undef yheight
#undef xwidth
#undef priority
#undef material_string
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

  /* Initializations for component channel_9_analyzer_2_array_crystal_array_7. */
  SIG_MESSAGE("channel_9_analyzer_2_array_crystal_array_7 (Init)");
#define mccompcurname  channel_9_analyzer_2_array_crystal_array_7
#define mccompcurtype  Union_box
#define mccompcurindex 490
#define loop_index mccchannel_9_analyzer_2_array_crystal_array_7_loop_index
#define this_box_volume mccchannel_9_analyzer_2_array_crystal_array_7_this_box_volume
#define global_geometry_element mccchannel_9_analyzer_2_array_crystal_array_7_global_geometry_element
#define this_box_storage mccchannel_9_analyzer_2_array_crystal_array_7_this_box_storage
#define material_string mccchannel_9_analyzer_2_array_crystal_array_7_material_string
#define priority mccchannel_9_analyzer_2_array_crystal_array_7_priority
#define xwidth mccchannel_9_analyzer_2_array_crystal_array_7_xwidth
#define yheight mccchannel_9_analyzer_2_array_crystal_array_7_yheight
#define zdepth mccchannel_9_analyzer_2_array_crystal_array_7_zdepth
#define xwidth2 mccchannel_9_analyzer_2_array_crystal_array_7_xwidth2
#define yheight2 mccchannel_9_analyzer_2_array_crystal_array_7_yheight2
#define visualize mccchannel_9_analyzer_2_array_crystal_array_7_visualize
#define target_index mccchannel_9_analyzer_2_array_crystal_array_7_target_index
#define target_x mccchannel_9_analyzer_2_array_crystal_array_7_target_x
#define target_y mccchannel_9_analyzer_2_array_crystal_array_7_target_y
#define target_z mccchannel_9_analyzer_2_array_crystal_array_7_target_z
#define focus_aw mccchannel_9_analyzer_2_array_crystal_array_7_focus_aw
#define focus_ah mccchannel_9_analyzer_2_array_crystal_array_7_focus_ah
#define focus_xw mccchannel_9_analyzer_2_array_crystal_array_7_focus_xw
#define focus_xh mccchannel_9_analyzer_2_array_crystal_array_7_focus_xh
#define focus_r mccchannel_9_analyzer_2_array_crystal_array_7_focus_r
#define p_interact mccchannel_9_analyzer_2_array_crystal_array_7_p_interact
#define mask_string mccchannel_9_analyzer_2_array_crystal_array_7_mask_string
#define mask_setting mccchannel_9_analyzer_2_array_crystal_array_7_mask_setting
#define number_of_activations mccchannel_9_analyzer_2_array_crystal_array_7_number_of_activations
#line 224 "Union_box.comp"
{
// Initializes the focusing system for this volume including input sanitation.
focus_initialize(&this_box_volume.geometry, POS_A_COMP_INDEX(INDEX_CURRENT_COMP+target_index), POS_A_CURRENT_COMP, ROT_A_CURRENT_COMP, target_index, target_x, target_y, target_z, focus_aw, focus_ah, focus_xw, focus_xh, focus_r, NAME_CURRENT_COMP);

// Input sanitation for this geometry
if (xwidth <= 0) {
  printf("\nERROR in Union_box named %s, the xwidth is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (yheight <= 0) {
  printf("\nERROR in Union_box named %s, yheight is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (zdepth <= 0) {
  printf("\nERROR in Union_box named %s, zdepth is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (xwidth2 <= 0 && xwidth2 != -1) {
  printf("\nERROR in Union_box named %s, the xwidth2 is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (yheight2 <= 0 && yheight2 != -1) {
  printf("\nERROR in Union_box named %s, yheight2 is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}

// Use sanitation
if (global_material_list.num_elements == 0) {
  printf("\nERROR: Need to define a material using Union_make_material before using a Union geometry component. \n");
  printf("       %s was defined before first use of Union_make_material.\n",NAME_CURRENT_COMP);
  exit(1);
}

this_box_volume.geometry.is_masked_volume = 0;
this_box_volume.geometry.is_exit_volume = 0;
this_box_volume.geometry.is_mask_volume = 0;
// check if the volume is a mask, if it is the material string is irelevant.
if (mask_string && strlen(mask_string) && strcmp(mask_string, "NULL") && strcmp(mask_string, "0")) {
    // A mask volume is used to limit the extend of other volumes, called the masked volumes. These are specified in the mask_string.
    // In order for a ray to enter a masked volume, it needs to be both in the region covered by that volume AND the mask volume.
    // When more than
    this_box_volume.geometry.mask_mode = 1; // Default is mask mode is ALL
    if (mask_setting && strlen(mask_setting) && strcmp(mask_setting, "NULL") && strcmp(mask_setting, "0")) {
        if (strcmp(mask_setting,"ALL") == 0 || strcmp(mask_setting,"All") == 0) this_box_volume.geometry.mask_mode = 1;
        else if (strcmp(mask_setting,"ANY") == 0 || strcmp(mask_setting,"Any") == 0) this_box_volume.geometry.mask_mode = 2;
        else {
            printf("The mask_mode of component %s is set to %s, but must be either ALL or ANY.\n",NAME_CURRENT_COMP,mask_setting);
            exit(1);
        }
    }
    
    for (loop_index=0;loop_index<global_geometry_list.num_elements;loop_index++) {
        // Add mask list
        if (1 == manual_linking_function(global_geometry_list.elements[loop_index].name,mask_string)) {
            add_element_to_int_list(&this_box_volume.geometry.mask_list,global_geometry_list.elements[loop_index].component_index);
            add_element_to_int_list(&global_geometry_list.elements[loop_index].Volume->geometry.masked_by_list,INDEX_CURRENT_COMP);
            global_geometry_list.elements[loop_index].Volume->geometry.is_masked_volume = 1;
            if (this_box_volume.geometry.mask_mode == 2)
                global_geometry_list.elements[loop_index].Volume->geometry.mask_mode = 2;
            if (this_box_volume.geometry.mask_mode == 1) {
                if (global_geometry_list.elements[loop_index].Volume->geometry.is_masked_volume == 1 && global_geometry_list.elements[loop_index].Volume->geometry.mask_mode != 2)
                    // If more than one mask is added to one volume, the ANY mode overwrites the (default) ALL mode.
                    global_geometry_list.elements[loop_index].Volume->geometry.mask_mode = 1;
            }
            
            found_geometries = 1;
        }
    }
    if (found_geometries == 0) {
        printf("The mask_string in geometry: %s did not find any of the specified volumes in the mask_string %s \n",NAME_CURRENT_COMP,mask_string);
        exit(1);
    }
    this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
    this_box_volume.p_physics->is_vacuum = 0; // Makes this volume a vacuum
    this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
    this_box_volume.p_physics->my_a = 0; // Should not be used.
    sprintf(this_box_volume.p_physics->name,"Mask");
    this_box_volume.geometry.is_mask_volume = 1;
    
    
// Read the material input, or if it lacks, use automatic linking.
} else if (material_string && strlen(material_string) && strcmp(material_string, "NULL") && strcmp(material_string, "0")) {
    // A geometry string was given, use it to determine which material
    if (0 == strcmp(material_string,"vacuum") || 0 == strcmp(material_string,"Vacuum")) {
        // One could have a global physics struct for vacuum instead of creating one for each
        this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
        this_box_volume.p_physics->is_vacuum = 1; // Makes this volume a vacuum
        this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
        this_box_volume.p_physics->my_a = 0; // Should not be used.
        sprintf(this_box_volume.p_physics->name,"Vacuum");
    } else if (0 == strcmp(material_string,"exit") || 0 == strcmp(material_string,"Exit")) {
        // One could have a global physics struct for vacuum instead of creating one for each
        this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
        this_box_volume.p_physics->is_vacuum = 1; // Makes this volume a vacuum
        this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
        this_box_volume.p_physics->my_a = 0; // Should not be used.
        this_box_volume.geometry.is_exit_volume = 1;
        sprintf(this_box_volume.p_physics->name,"Exit");
    } else {
        #ifndef MATERIAL_DETECTOR
            printf("Need to define a material before refering to it in a geometry %s.\n",NAME_CURRENT_COMP);
            exit(1);
        #endif
        for (loop_index=0;loop_index<global_material_list.num_elements;loop_index++) {
            if (0 == strcmp(material_string,global_material_list.elements[loop_index].name)) {
                this_box_volume.p_physics = global_material_list.elements[loop_index].physics;
                break;
            }
            if (loop_index == global_material_list.num_elements-1) {
            printf("\n");
            printf("ERROR: The material string \"%s\" in Union geometry \"%s\" did not match a specified material. \n",material_string,NAME_CURRENT_COMP);
            printf("       The materials available at this point (need to be defined before the geometry): \n");
            for (loop_index=0;loop_index<global_material_list.num_elements;loop_index++)
              printf("         %s\n",global_material_list.elements[loop_index].name);
            printf("\n");
            printf("       It is also possible to use one of the defualt materials avaiable: \n");
            printf("           Vacuum (for a Volume without scattering or absorption)\n");
            printf("           Exit (for a Volume where the ray exits the component if it enters)\n");
            printf("           Mask (for a Volume that masks existing volumes specified in the mask_string\n");
            exit(1);
          }
        }
    }
} else {
    // Automatic linking, simply using the last defined material.
    #ifndef MATERIAL_DETECTOR
        printf("Need to define a material before the geometry to use automatic linking %s.\n",NAME_CURRENT_COMP);
        exit(1);
    #endif
    this_box_volume.p_physics = global_material_list.elements[global_material_list.num_elements-1].physics;
}

sprintf(this_box_volume.name,NAME_CURRENT_COMP);
sprintf(this_box_volume.geometry.shape,"box");
this_box_volume.geometry.priority_value = priority;
this_box_volume.geometry.geometry_p_interact = p_interact;
// Currently the coordinates will be in absolute space.
this_box_volume.geometry.center = POS_A_CURRENT_COMP;

this_box_storage.z_depth = zdepth;
this_box_storage.x_width1 = xwidth;
this_box_storage.y_height1 = yheight;

this_box_storage.is_rectangle = 0;
if (xwidth2 < 0 && yheight2 < 0) this_box_storage.is_rectangle = 1;
if (xwidth == xwidth2 && yheight == yheight2) this_box_storage.is_rectangle = 1;

if (xwidth2 < 0) {
    this_box_storage.x_width2 = xwidth;
    xwidth2 = xwidth;
} else this_box_storage.x_width2 = xwidth2;

if (yheight2 < 0) {
    this_box_storage.y_height2 = yheight;
    yheight2 = yheight;
} else this_box_storage.y_height2 = yheight2;


this_box_storage.normal_vectors[0] = coords_set(0,0,1);
this_box_storage.normal_vectors[1] = coords_set(0,0,1);

// for sides with y component = 0
x_component = 2*zdepth/sqrt((xwidth-xwidth2)*(xwidth-xwidth2)+4*zdepth*zdepth);
z_component = (xwidth-xwidth2)/sqrt(4*zdepth*zdepth+(xwidth-xwidth2)*(xwidth-xwidth2));

this_box_storage.normal_vectors[2] = coords_set(x_component,0,z_component);
this_box_storage.normal_vectors[3] = coords_set(-x_component,0,z_component);

// for sides with x component = 0
y_component = 2*zdepth/sqrt((yheight-yheight2)*(yheight-yheight2)+4*zdepth*zdepth);
z_component = (yheight-yheight2)/sqrt(4*zdepth*zdepth+(yheight-yheight2)*(yheight-yheight2));

this_box_storage.normal_vectors[4] = coords_set(0,y_component,z_component);
this_box_storage.normal_vectors[5] = coords_set(0,-y_component,z_component);

this_box_volume.geometry.visualization_on = visualize;

this_box_volume.geometry.geometry_parameters.p_box_storage = &this_box_storage;

// Assign pointers to functions for intersection with the shape, checking if a point is inside the shape
if (this_box_storage.is_rectangle == 1) {
this_box_volume.geometry.intersect_function = &sample_box_intersect_simple;
this_box_volume.geometry.within_function = &r_within_box_simple;
}
else {
this_box_volume.geometry.intersect_function = &sample_box_intersect_advanced;
this_box_volume.geometry.within_function = &r_within_box_advanced;
}

this_box_volume.geometry.shell_points = &box_shell_points;
this_box_volume.geometry.mcdisplay_function = &mcdisplay_box_function;
this_box_volume.geometry.initialize_from_main_function = &initialize_box_geometry_from_main_component;
this_box_volume.geometry.process_rot_allocated = 0;

this_box_volume.geometry.copy_geometry_parameters = &allocate_box_storage_copy;

rot_copy(this_box_volume.geometry.rotation_matrix,ROT_A_CURRENT_COMP); //check how ROT_R_CURRENT_COMP would work
rot_transpose(ROT_A_CURRENT_COMP,this_box_volume.geometry.transpose_rotation_matrix);

// Initialize loggers
this_box_volume.loggers.num_elements = 0;

// packing the information into the global_geometry_element, which is then included in the global_geometry_list.
sprintf(global_geometry_element.name,NAME_CURRENT_COMP);
global_geometry_element.activation_counter = number_of_activations;
global_geometry_element.component_index = INDEX_CURRENT_COMP;
global_geometry_element.Volume = &this_box_volume; // Would be nicer if this m was a pointer, now we have the (small) data two places
add_element_to_geometry_list(&global_geometry_list,global_geometry_element);
}
#line 249398 "MACS_sample_kidney_box.c"
#undef number_of_activations
#undef mask_setting
#undef mask_string
#undef p_interact
#undef focus_r
#undef focus_xh
#undef focus_xw
#undef focus_ah
#undef focus_aw
#undef target_z
#undef target_y
#undef target_x
#undef target_index
#undef visualize
#undef yheight2
#undef xwidth2
#undef zdepth
#undef yheight
#undef xwidth
#undef priority
#undef material_string
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

  /* Initializations for component channel_9_analyzer_2_array_crystal_array_8. */
  SIG_MESSAGE("channel_9_analyzer_2_array_crystal_array_8 (Init)");
#define mccompcurname  channel_9_analyzer_2_array_crystal_array_8
#define mccompcurtype  Union_box
#define mccompcurindex 491
#define loop_index mccchannel_9_analyzer_2_array_crystal_array_8_loop_index
#define this_box_volume mccchannel_9_analyzer_2_array_crystal_array_8_this_box_volume
#define global_geometry_element mccchannel_9_analyzer_2_array_crystal_array_8_global_geometry_element
#define this_box_storage mccchannel_9_analyzer_2_array_crystal_array_8_this_box_storage
#define material_string mccchannel_9_analyzer_2_array_crystal_array_8_material_string
#define priority mccchannel_9_analyzer_2_array_crystal_array_8_priority
#define xwidth mccchannel_9_analyzer_2_array_crystal_array_8_xwidth
#define yheight mccchannel_9_analyzer_2_array_crystal_array_8_yheight
#define zdepth mccchannel_9_analyzer_2_array_crystal_array_8_zdepth
#define xwidth2 mccchannel_9_analyzer_2_array_crystal_array_8_xwidth2
#define yheight2 mccchannel_9_analyzer_2_array_crystal_array_8_yheight2
#define visualize mccchannel_9_analyzer_2_array_crystal_array_8_visualize
#define target_index mccchannel_9_analyzer_2_array_crystal_array_8_target_index
#define target_x mccchannel_9_analyzer_2_array_crystal_array_8_target_x
#define target_y mccchannel_9_analyzer_2_array_crystal_array_8_target_y
#define target_z mccchannel_9_analyzer_2_array_crystal_array_8_target_z
#define focus_aw mccchannel_9_analyzer_2_array_crystal_array_8_focus_aw
#define focus_ah mccchannel_9_analyzer_2_array_crystal_array_8_focus_ah
#define focus_xw mccchannel_9_analyzer_2_array_crystal_array_8_focus_xw
#define focus_xh mccchannel_9_analyzer_2_array_crystal_array_8_focus_xh
#define focus_r mccchannel_9_analyzer_2_array_crystal_array_8_focus_r
#define p_interact mccchannel_9_analyzer_2_array_crystal_array_8_p_interact
#define mask_string mccchannel_9_analyzer_2_array_crystal_array_8_mask_string
#define mask_setting mccchannel_9_analyzer_2_array_crystal_array_8_mask_setting
#define number_of_activations mccchannel_9_analyzer_2_array_crystal_array_8_number_of_activations
#line 224 "Union_box.comp"
{
// Initializes the focusing system for this volume including input sanitation.
focus_initialize(&this_box_volume.geometry, POS_A_COMP_INDEX(INDEX_CURRENT_COMP+target_index), POS_A_CURRENT_COMP, ROT_A_CURRENT_COMP, target_index, target_x, target_y, target_z, focus_aw, focus_ah, focus_xw, focus_xh, focus_r, NAME_CURRENT_COMP);

// Input sanitation for this geometry
if (xwidth <= 0) {
  printf("\nERROR in Union_box named %s, the xwidth is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (yheight <= 0) {
  printf("\nERROR in Union_box named %s, yheight is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (zdepth <= 0) {
  printf("\nERROR in Union_box named %s, zdepth is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (xwidth2 <= 0 && xwidth2 != -1) {
  printf("\nERROR in Union_box named %s, the xwidth2 is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (yheight2 <= 0 && yheight2 != -1) {
  printf("\nERROR in Union_box named %s, yheight2 is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}

// Use sanitation
if (global_material_list.num_elements == 0) {
  printf("\nERROR: Need to define a material using Union_make_material before using a Union geometry component. \n");
  printf("       %s was defined before first use of Union_make_material.\n",NAME_CURRENT_COMP);
  exit(1);
}

this_box_volume.geometry.is_masked_volume = 0;
this_box_volume.geometry.is_exit_volume = 0;
this_box_volume.geometry.is_mask_volume = 0;
// check if the volume is a mask, if it is the material string is irelevant.
if (mask_string && strlen(mask_string) && strcmp(mask_string, "NULL") && strcmp(mask_string, "0")) {
    // A mask volume is used to limit the extend of other volumes, called the masked volumes. These are specified in the mask_string.
    // In order for a ray to enter a masked volume, it needs to be both in the region covered by that volume AND the mask volume.
    // When more than
    this_box_volume.geometry.mask_mode = 1; // Default is mask mode is ALL
    if (mask_setting && strlen(mask_setting) && strcmp(mask_setting, "NULL") && strcmp(mask_setting, "0")) {
        if (strcmp(mask_setting,"ALL") == 0 || strcmp(mask_setting,"All") == 0) this_box_volume.geometry.mask_mode = 1;
        else if (strcmp(mask_setting,"ANY") == 0 || strcmp(mask_setting,"Any") == 0) this_box_volume.geometry.mask_mode = 2;
        else {
            printf("The mask_mode of component %s is set to %s, but must be either ALL or ANY.\n",NAME_CURRENT_COMP,mask_setting);
            exit(1);
        }
    }
    
    for (loop_index=0;loop_index<global_geometry_list.num_elements;loop_index++) {
        // Add mask list
        if (1 == manual_linking_function(global_geometry_list.elements[loop_index].name,mask_string)) {
            add_element_to_int_list(&this_box_volume.geometry.mask_list,global_geometry_list.elements[loop_index].component_index);
            add_element_to_int_list(&global_geometry_list.elements[loop_index].Volume->geometry.masked_by_list,INDEX_CURRENT_COMP);
            global_geometry_list.elements[loop_index].Volume->geometry.is_masked_volume = 1;
            if (this_box_volume.geometry.mask_mode == 2)
                global_geometry_list.elements[loop_index].Volume->geometry.mask_mode = 2;
            if (this_box_volume.geometry.mask_mode == 1) {
                if (global_geometry_list.elements[loop_index].Volume->geometry.is_masked_volume == 1 && global_geometry_list.elements[loop_index].Volume->geometry.mask_mode != 2)
                    // If more than one mask is added to one volume, the ANY mode overwrites the (default) ALL mode.
                    global_geometry_list.elements[loop_index].Volume->geometry.mask_mode = 1;
            }
            
            found_geometries = 1;
        }
    }
    if (found_geometries == 0) {
        printf("The mask_string in geometry: %s did not find any of the specified volumes in the mask_string %s \n",NAME_CURRENT_COMP,mask_string);
        exit(1);
    }
    this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
    this_box_volume.p_physics->is_vacuum = 0; // Makes this volume a vacuum
    this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
    this_box_volume.p_physics->my_a = 0; // Should not be used.
    sprintf(this_box_volume.p_physics->name,"Mask");
    this_box_volume.geometry.is_mask_volume = 1;
    
    
// Read the material input, or if it lacks, use automatic linking.
} else if (material_string && strlen(material_string) && strcmp(material_string, "NULL") && strcmp(material_string, "0")) {
    // A geometry string was given, use it to determine which material
    if (0 == strcmp(material_string,"vacuum") || 0 == strcmp(material_string,"Vacuum")) {
        // One could have a global physics struct for vacuum instead of creating one for each
        this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
        this_box_volume.p_physics->is_vacuum = 1; // Makes this volume a vacuum
        this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
        this_box_volume.p_physics->my_a = 0; // Should not be used.
        sprintf(this_box_volume.p_physics->name,"Vacuum");
    } else if (0 == strcmp(material_string,"exit") || 0 == strcmp(material_string,"Exit")) {
        // One could have a global physics struct for vacuum instead of creating one for each
        this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
        this_box_volume.p_physics->is_vacuum = 1; // Makes this volume a vacuum
        this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
        this_box_volume.p_physics->my_a = 0; // Should not be used.
        this_box_volume.geometry.is_exit_volume = 1;
        sprintf(this_box_volume.p_physics->name,"Exit");
    } else {
        #ifndef MATERIAL_DETECTOR
            printf("Need to define a material before refering to it in a geometry %s.\n",NAME_CURRENT_COMP);
            exit(1);
        #endif
        for (loop_index=0;loop_index<global_material_list.num_elements;loop_index++) {
            if (0 == strcmp(material_string,global_material_list.elements[loop_index].name)) {
                this_box_volume.p_physics = global_material_list.elements[loop_index].physics;
                break;
            }
            if (loop_index == global_material_list.num_elements-1) {
            printf("\n");
            printf("ERROR: The material string \"%s\" in Union geometry \"%s\" did not match a specified material. \n",material_string,NAME_CURRENT_COMP);
            printf("       The materials available at this point (need to be defined before the geometry): \n");
            for (loop_index=0;loop_index<global_material_list.num_elements;loop_index++)
              printf("         %s\n",global_material_list.elements[loop_index].name);
            printf("\n");
            printf("       It is also possible to use one of the defualt materials avaiable: \n");
            printf("           Vacuum (for a Volume without scattering or absorption)\n");
            printf("           Exit (for a Volume where the ray exits the component if it enters)\n");
            printf("           Mask (for a Volume that masks existing volumes specified in the mask_string\n");
            exit(1);
          }
        }
    }
} else {
    // Automatic linking, simply using the last defined material.
    #ifndef MATERIAL_DETECTOR
        printf("Need to define a material before the geometry to use automatic linking %s.\n",NAME_CURRENT_COMP);
        exit(1);
    #endif
    this_box_volume.p_physics = global_material_list.elements[global_material_list.num_elements-1].physics;
}

sprintf(this_box_volume.name,NAME_CURRENT_COMP);
sprintf(this_box_volume.geometry.shape,"box");
this_box_volume.geometry.priority_value = priority;
this_box_volume.geometry.geometry_p_interact = p_interact;
// Currently the coordinates will be in absolute space.
this_box_volume.geometry.center = POS_A_CURRENT_COMP;

this_box_storage.z_depth = zdepth;
this_box_storage.x_width1 = xwidth;
this_box_storage.y_height1 = yheight;

this_box_storage.is_rectangle = 0;
if (xwidth2 < 0 && yheight2 < 0) this_box_storage.is_rectangle = 1;
if (xwidth == xwidth2 && yheight == yheight2) this_box_storage.is_rectangle = 1;

if (xwidth2 < 0) {
    this_box_storage.x_width2 = xwidth;
    xwidth2 = xwidth;
} else this_box_storage.x_width2 = xwidth2;

if (yheight2 < 0) {
    this_box_storage.y_height2 = yheight;
    yheight2 = yheight;
} else this_box_storage.y_height2 = yheight2;


this_box_storage.normal_vectors[0] = coords_set(0,0,1);
this_box_storage.normal_vectors[1] = coords_set(0,0,1);

// for sides with y component = 0
x_component = 2*zdepth/sqrt((xwidth-xwidth2)*(xwidth-xwidth2)+4*zdepth*zdepth);
z_component = (xwidth-xwidth2)/sqrt(4*zdepth*zdepth+(xwidth-xwidth2)*(xwidth-xwidth2));

this_box_storage.normal_vectors[2] = coords_set(x_component,0,z_component);
this_box_storage.normal_vectors[3] = coords_set(-x_component,0,z_component);

// for sides with x component = 0
y_component = 2*zdepth/sqrt((yheight-yheight2)*(yheight-yheight2)+4*zdepth*zdepth);
z_component = (yheight-yheight2)/sqrt(4*zdepth*zdepth+(yheight-yheight2)*(yheight-yheight2));

this_box_storage.normal_vectors[4] = coords_set(0,y_component,z_component);
this_box_storage.normal_vectors[5] = coords_set(0,-y_component,z_component);

this_box_volume.geometry.visualization_on = visualize;

this_box_volume.geometry.geometry_parameters.p_box_storage = &this_box_storage;

// Assign pointers to functions for intersection with the shape, checking if a point is inside the shape
if (this_box_storage.is_rectangle == 1) {
this_box_volume.geometry.intersect_function = &sample_box_intersect_simple;
this_box_volume.geometry.within_function = &r_within_box_simple;
}
else {
this_box_volume.geometry.intersect_function = &sample_box_intersect_advanced;
this_box_volume.geometry.within_function = &r_within_box_advanced;
}

this_box_volume.geometry.shell_points = &box_shell_points;
this_box_volume.geometry.mcdisplay_function = &mcdisplay_box_function;
this_box_volume.geometry.initialize_from_main_function = &initialize_box_geometry_from_main_component;
this_box_volume.geometry.process_rot_allocated = 0;

this_box_volume.geometry.copy_geometry_parameters = &allocate_box_storage_copy;

rot_copy(this_box_volume.geometry.rotation_matrix,ROT_A_CURRENT_COMP); //check how ROT_R_CURRENT_COMP would work
rot_transpose(ROT_A_CURRENT_COMP,this_box_volume.geometry.transpose_rotation_matrix);

// Initialize loggers
this_box_volume.loggers.num_elements = 0;

// packing the information into the global_geometry_element, which is then included in the global_geometry_list.
sprintf(global_geometry_element.name,NAME_CURRENT_COMP);
global_geometry_element.activation_counter = number_of_activations;
global_geometry_element.component_index = INDEX_CURRENT_COMP;
global_geometry_element.Volume = &this_box_volume; // Would be nicer if this m was a pointer, now we have the (small) data two places
add_element_to_geometry_list(&global_geometry_list,global_geometry_element);
}
#line 249668 "MACS_sample_kidney_box.c"
#undef number_of_activations
#undef mask_setting
#undef mask_string
#undef p_interact
#undef focus_r
#undef focus_xh
#undef focus_xw
#undef focus_ah
#undef focus_aw
#undef target_z
#undef target_y
#undef target_x
#undef target_index
#undef visualize
#undef yheight2
#undef xwidth2
#undef zdepth
#undef yheight
#undef xwidth
#undef priority
#undef material_string
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

  /* Initializations for component channel_9_cave2_cyl1. */
  SIG_MESSAGE("channel_9_cave2_cyl1 (Init)");
#define mccompcurname  channel_9_cave2_cyl1
#define mccompcurtype  Union_cylinder
#define mccompcurindex 492
#define loop_index mccchannel_9_cave2_cyl1_loop_index
#define this_cylinder_volume mccchannel_9_cave2_cyl1_this_cylinder_volume
#define global_geometry_element mccchannel_9_cave2_cyl1_global_geometry_element
#define this_cylinder_storage mccchannel_9_cave2_cyl1_this_cylinder_storage
#define material_string mccchannel_9_cave2_cyl1_material_string
#define priority mccchannel_9_cave2_cyl1_priority
#define radius mccchannel_9_cave2_cyl1_radius
#define yheight mccchannel_9_cave2_cyl1_yheight
#define visualize mccchannel_9_cave2_cyl1_visualize
#define target_index mccchannel_9_cave2_cyl1_target_index
#define target_x mccchannel_9_cave2_cyl1_target_x
#define target_y mccchannel_9_cave2_cyl1_target_y
#define target_z mccchannel_9_cave2_cyl1_target_z
#define focus_aw mccchannel_9_cave2_cyl1_focus_aw
#define focus_ah mccchannel_9_cave2_cyl1_focus_ah
#define focus_xw mccchannel_9_cave2_cyl1_focus_xw
#define focus_xh mccchannel_9_cave2_cyl1_focus_xh
#define focus_r mccchannel_9_cave2_cyl1_focus_r
#define p_interact mccchannel_9_cave2_cyl1_p_interact
#define mask_string mccchannel_9_cave2_cyl1_mask_string
#define mask_setting mccchannel_9_cave2_cyl1_mask_setting
#define number_of_activations mccchannel_9_cave2_cyl1_number_of_activations
#line 185 "Union_cylinder.comp"
{
// Initializes the focusing system for this volume including input sanitation.
focus_initialize(&this_cylinder_volume.geometry, POS_A_COMP_INDEX(INDEX_CURRENT_COMP+target_index), POS_A_CURRENT_COMP, ROT_A_CURRENT_COMP, target_index, target_x, target_y, target_z, focus_aw, focus_ah, focus_xw, focus_xh, focus_r, NAME_CURRENT_COMP);

// Input sanitation for this geometry
if (radius <= 0) {
  printf("\nERROR in Union_cylinder named %s, the radius is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}

if (yheight <= 0) {
  printf("\nERROR in Union_cylinder named %s, yheight is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}

// Use sanitation
#ifdef MATERIAL_DETECTOR
if (global_material_list.num_elements == 0) {
  // Here if the user have defined a material, but only after this material
  printf("\nERROR: Need to define a material using Union_make_material before using a Union geometry component. \n");
  printf("       %s was defined before first use of Union_make_material.\n",NAME_CURRENT_COMP);
  exit(1);
}
#endif
#ifndef MATERIAL_DETECTOR
  printf("\nERROR: Need to define a material using Union_make_material before using a Union geometry component. \n");
  exit(1);
#endif


this_cylinder_volume.geometry.is_masked_volume = 0;
this_cylinder_volume.geometry.is_exit_volume = 0;
this_cylinder_volume.geometry.is_mask_volume = 0;

// Read the material input, or if it lacks, use automatic linking.
if (mask_string && strlen(mask_string) && strcmp(mask_string, "NULL") && strcmp(mask_string, "0")) {
    // A mask volume is used to limit the extend of other volumes, called the masked volumes. These are specified in the mask_string.
    // In order for a ray to enter a masked volume, it needs to be both in the region covered by that volume AND the mask volume.
    // When more than
    this_cylinder_volume.geometry.mask_mode = 1; // Default is mask mode is ALL
    if (mask_setting && strlen(mask_setting) && strcmp(mask_setting, "NULL") && strcmp(mask_setting, "0")) {
        if (strcmp(mask_setting,"ALL") == 0 || strcmp(mask_setting,"All") == 0) this_cylinder_volume.geometry.mask_mode = 1;
        else if (strcmp(mask_setting,"ANY") == 0 || strcmp(mask_setting,"Any") == 0) this_cylinder_volume.geometry.mask_mode = 2;
        else {
            printf("The mask_mode of component %s is set to %s, but must be either ALL or ANY.\n",NAME_CURRENT_COMP,mask_setting);
            exit(1);
        }
    }
    
    for (loop_index=0;loop_index<global_geometry_list.num_elements;loop_index++) {
        // Add mask list
        if (1 == manual_linking_function(global_geometry_list.elements[loop_index].name,mask_string)) {
            add_element_to_int_list(&this_cylinder_volume.geometry.mask_list,global_geometry_list.elements[loop_index].component_index);
            add_element_to_int_list(&global_geometry_list.elements[loop_index].Volume->geometry.masked_by_list,INDEX_CURRENT_COMP);
            global_geometry_list.elements[loop_index].Volume->geometry.is_masked_volume = 1;
            if (this_cylinder_volume.geometry.mask_mode == 2)
                global_geometry_list.elements[loop_index].Volume->geometry.mask_mode = 2;
            if (this_cylinder_volume.geometry.mask_mode == 1) {
                if (global_geometry_list.elements[loop_index].Volume->geometry.is_masked_volume == 1 && global_geometry_list.elements[loop_index].Volume->geometry.mask_mode != 2)
                    // If more than one mask is added to one volume, the ANY mode overwrites the (default) ALL mode.
                    global_geometry_list.elements[loop_index].Volume->geometry.mask_mode = 1;
            }
            
            found_geometries = 1;
        }
    }
    if (found_geometries == 0) {
        printf("The mask_string in geometry: %s did not find any of the specified volumes in the mask_string %s \n",NAME_CURRENT_COMP,mask_string);
        exit(1);
    }
    this_cylinder_volume.p_physics = malloc(sizeof(struct physics_struct));
    this_cylinder_volume.p_physics->is_vacuum = 0; // Makes this volume a vacuum
    this_cylinder_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
    this_cylinder_volume.p_physics->my_a = 0; // Should not be used.
    sprintf(this_cylinder_volume.p_physics->name,"Mask");
    this_cylinder_volume.geometry.is_mask_volume = 1;
    
    
// Read the material input, or if it lacks, use automatic linking.
} else if (material_string && strlen(material_string) && strcmp(material_string, "NULL") && strcmp(material_string, "0")) {
    // A geometry string was given, use it to determine which material
    if (0 == strcmp(material_string,"vacuum") || 0 == strcmp(material_string,"Vacuum")) {
        // One could have a global physics struct for vacuum instead of creating one for each
        this_cylinder_volume.p_physics = malloc(sizeof(struct physics_struct));
        this_cylinder_volume.p_physics->is_vacuum = 1; // Makes this volume a vacuum
        this_cylinder_volume.p_physics->number_of_processes = (int) 0;
        this_cylinder_volume.p_physics->my_a = 0; // Should not be used.
        sprintf(this_cylinder_volume.p_physics->name,"Vacuum");
    } else if (0 == strcmp(material_string,"exit") || 0 == strcmp(material_string,"Exit")) {
        // One could have a global physics struct for exit instead of creating one for each
        this_cylinder_volume.p_physics = malloc(sizeof(struct physics_struct));
        this_cylinder_volume.p_physics->is_vacuum = 1; // Makes this volume a vacuum
        this_cylinder_volume.p_physics->number_of_processes = (int) 0;
        this_cylinder_volume.p_physics->my_a = 0; // Should not be used.
        this_cylinder_volume.geometry.is_exit_volume = 1;
        sprintf(this_cylinder_volume.p_physics->name,"Exit");
    } else {
        for (loop_index=0;loop_index<global_material_list.num_elements;loop_index++) {
          if (0 == strcmp(material_string,global_material_list.elements[loop_index].name)) {
            this_cylinder_volume.p_physics = global_material_list.elements[loop_index].physics;
            break;
          }
          if (loop_index == global_material_list.num_elements-1) {
            printf("\n");
            printf("ERROR: The material string \"%s\" in Union geometry \"%s\" did not match a specified material. \n",material_string,NAME_CURRENT_COMP);
            printf("       The materials available at this point (need to be defined before the geometry): \n");
            for (loop_index=0;loop_index<global_material_list.num_elements;loop_index++)
              printf("         %s\n",global_material_list.elements[loop_index].name);
            printf("\n");
            printf("       It is also possible to use one of the defualt materials avaiable: \n");
            printf("           Vacuum (for a Volume without scattering or absorption)\n");
            printf("           Exit (for a Volume where the ray exits the component if it enters)\n");
            printf("           Mask (for a Volume that masks existing volumes specified in the mask_string\n");
            exit(1);
          }
        }
    }
} else {
    // Automatic linking, simply using the last defined material.
    #ifndef MATERIAL_DETECTOR
        printf("Need to define a material before the geometry to use automatic linking %s.\n",NAME_CURRENT_COMP);
        exit(1);
    #endif
    this_cylinder_volume.p_physics = global_material_list.elements[global_material_list.num_elements-1].physics;
}

sprintf(this_cylinder_volume.name,NAME_CURRENT_COMP);
sprintf(this_cylinder_volume.geometry.shape,"cylinder");
this_cylinder_volume.geometry.priority_value = priority;
// Currently the coordinates will be in absolute space.
this_cylinder_volume.geometry.center = POS_A_CURRENT_COMP;

this_cylinder_volume.geometry.geometry_p_interact = p_interact;
this_cylinder_storage.cyl_radius = radius;
this_cylinder_storage.height = yheight;
this_cylinder_volume.geometry.visualization_on = visualize;
this_cylinder_volume.geometry.geometry_parameters.p_cylinder_storage = &this_cylinder_storage;
this_cylinder_volume.geometry.within_function = &r_within_cylinder;
this_cylinder_volume.geometry.intersect_function = &sample_cylinder_intersect;
this_cylinder_volume.geometry.mcdisplay_function = &mcdisplay_cylinder_function;
this_cylinder_volume.geometry.shell_points = &cylinder_shell_points;
this_cylinder_volume.geometry.initialize_from_main_function = &initialize_cylinder_geometry_from_main_component;
this_cylinder_volume.geometry.process_rot_allocated = 0;
this_cylinder_volume.geometry.copy_geometry_parameters = &allocate_cylinder_storage_copy;

rot_copy(this_cylinder_volume.geometry.rotation_matrix,ROT_A_CURRENT_COMP);
rot_transpose(ROT_A_CURRENT_COMP,this_cylinder_volume.geometry.transpose_rotation_matrix);

// Initialize loggers
this_cylinder_volume.loggers.num_elements = 0;

// packing the information into the global_geometry_element, which is then included in the global_geometry_list.
sprintf(global_geometry_element.name,NAME_CURRENT_COMP);
global_geometry_element.activation_counter = number_of_activations;
global_geometry_element.component_index = INDEX_CURRENT_COMP;
global_geometry_element.Volume = &this_cylinder_volume; // Would be nicer if this m was a pointer, now we have the (small) data two places
add_element_to_geometry_list(&global_geometry_list,global_geometry_element);
}
#line 249884 "MACS_sample_kidney_box.c"
#undef number_of_activations
#undef mask_setting
#undef mask_string
#undef p_interact
#undef focus_r
#undef focus_xh
#undef focus_xw
#undef focus_ah
#undef focus_aw
#undef target_z
#undef target_y
#undef target_x
#undef target_index
#undef visualize
#undef yheight
#undef radius
#undef priority
#undef material_string
#undef this_cylinder_storage
#undef global_geometry_element
#undef this_cylinder_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

  /* Initializations for component channel_9_cave2_box1. */
  SIG_MESSAGE("channel_9_cave2_box1 (Init)");
#define mccompcurname  channel_9_cave2_box1
#define mccompcurtype  Union_box
#define mccompcurindex 493
#define loop_index mccchannel_9_cave2_box1_loop_index
#define this_box_volume mccchannel_9_cave2_box1_this_box_volume
#define global_geometry_element mccchannel_9_cave2_box1_global_geometry_element
#define this_box_storage mccchannel_9_cave2_box1_this_box_storage
#define material_string mccchannel_9_cave2_box1_material_string
#define priority mccchannel_9_cave2_box1_priority
#define xwidth mccchannel_9_cave2_box1_xwidth
#define yheight mccchannel_9_cave2_box1_yheight
#define zdepth mccchannel_9_cave2_box1_zdepth
#define xwidth2 mccchannel_9_cave2_box1_xwidth2
#define yheight2 mccchannel_9_cave2_box1_yheight2
#define visualize mccchannel_9_cave2_box1_visualize
#define target_index mccchannel_9_cave2_box1_target_index
#define target_x mccchannel_9_cave2_box1_target_x
#define target_y mccchannel_9_cave2_box1_target_y
#define target_z mccchannel_9_cave2_box1_target_z
#define focus_aw mccchannel_9_cave2_box1_focus_aw
#define focus_ah mccchannel_9_cave2_box1_focus_ah
#define focus_xw mccchannel_9_cave2_box1_focus_xw
#define focus_xh mccchannel_9_cave2_box1_focus_xh
#define focus_r mccchannel_9_cave2_box1_focus_r
#define p_interact mccchannel_9_cave2_box1_p_interact
#define mask_string mccchannel_9_cave2_box1_mask_string
#define mask_setting mccchannel_9_cave2_box1_mask_setting
#define number_of_activations mccchannel_9_cave2_box1_number_of_activations
#line 224 "Union_box.comp"
{
// Initializes the focusing system for this volume including input sanitation.
focus_initialize(&this_box_volume.geometry, POS_A_COMP_INDEX(INDEX_CURRENT_COMP+target_index), POS_A_CURRENT_COMP, ROT_A_CURRENT_COMP, target_index, target_x, target_y, target_z, focus_aw, focus_ah, focus_xw, focus_xh, focus_r, NAME_CURRENT_COMP);

// Input sanitation for this geometry
if (xwidth <= 0) {
  printf("\nERROR in Union_box named %s, the xwidth is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (yheight <= 0) {
  printf("\nERROR in Union_box named %s, yheight is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (zdepth <= 0) {
  printf("\nERROR in Union_box named %s, zdepth is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (xwidth2 <= 0 && xwidth2 != -1) {
  printf("\nERROR in Union_box named %s, the xwidth2 is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (yheight2 <= 0 && yheight2 != -1) {
  printf("\nERROR in Union_box named %s, yheight2 is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}

// Use sanitation
if (global_material_list.num_elements == 0) {
  printf("\nERROR: Need to define a material using Union_make_material before using a Union geometry component. \n");
  printf("       %s was defined before first use of Union_make_material.\n",NAME_CURRENT_COMP);
  exit(1);
}

this_box_volume.geometry.is_masked_volume = 0;
this_box_volume.geometry.is_exit_volume = 0;
this_box_volume.geometry.is_mask_volume = 0;
// check if the volume is a mask, if it is the material string is irelevant.
if (mask_string && strlen(mask_string) && strcmp(mask_string, "NULL") && strcmp(mask_string, "0")) {
    // A mask volume is used to limit the extend of other volumes, called the masked volumes. These are specified in the mask_string.
    // In order for a ray to enter a masked volume, it needs to be both in the region covered by that volume AND the mask volume.
    // When more than
    this_box_volume.geometry.mask_mode = 1; // Default is mask mode is ALL
    if (mask_setting && strlen(mask_setting) && strcmp(mask_setting, "NULL") && strcmp(mask_setting, "0")) {
        if (strcmp(mask_setting,"ALL") == 0 || strcmp(mask_setting,"All") == 0) this_box_volume.geometry.mask_mode = 1;
        else if (strcmp(mask_setting,"ANY") == 0 || strcmp(mask_setting,"Any") == 0) this_box_volume.geometry.mask_mode = 2;
        else {
            printf("The mask_mode of component %s is set to %s, but must be either ALL or ANY.\n",NAME_CURRENT_COMP,mask_setting);
            exit(1);
        }
    }
    
    for (loop_index=0;loop_index<global_geometry_list.num_elements;loop_index++) {
        // Add mask list
        if (1 == manual_linking_function(global_geometry_list.elements[loop_index].name,mask_string)) {
            add_element_to_int_list(&this_box_volume.geometry.mask_list,global_geometry_list.elements[loop_index].component_index);
            add_element_to_int_list(&global_geometry_list.elements[loop_index].Volume->geometry.masked_by_list,INDEX_CURRENT_COMP);
            global_geometry_list.elements[loop_index].Volume->geometry.is_masked_volume = 1;
            if (this_box_volume.geometry.mask_mode == 2)
                global_geometry_list.elements[loop_index].Volume->geometry.mask_mode = 2;
            if (this_box_volume.geometry.mask_mode == 1) {
                if (global_geometry_list.elements[loop_index].Volume->geometry.is_masked_volume == 1 && global_geometry_list.elements[loop_index].Volume->geometry.mask_mode != 2)
                    // If more than one mask is added to one volume, the ANY mode overwrites the (default) ALL mode.
                    global_geometry_list.elements[loop_index].Volume->geometry.mask_mode = 1;
            }
            
            found_geometries = 1;
        }
    }
    if (found_geometries == 0) {
        printf("The mask_string in geometry: %s did not find any of the specified volumes in the mask_string %s \n",NAME_CURRENT_COMP,mask_string);
        exit(1);
    }
    this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
    this_box_volume.p_physics->is_vacuum = 0; // Makes this volume a vacuum
    this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
    this_box_volume.p_physics->my_a = 0; // Should not be used.
    sprintf(this_box_volume.p_physics->name,"Mask");
    this_box_volume.geometry.is_mask_volume = 1;
    
    
// Read the material input, or if it lacks, use automatic linking.
} else if (material_string && strlen(material_string) && strcmp(material_string, "NULL") && strcmp(material_string, "0")) {
    // A geometry string was given, use it to determine which material
    if (0 == strcmp(material_string,"vacuum") || 0 == strcmp(material_string,"Vacuum")) {
        // One could have a global physics struct for vacuum instead of creating one for each
        this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
        this_box_volume.p_physics->is_vacuum = 1; // Makes this volume a vacuum
        this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
        this_box_volume.p_physics->my_a = 0; // Should not be used.
        sprintf(this_box_volume.p_physics->name,"Vacuum");
    } else if (0 == strcmp(material_string,"exit") || 0 == strcmp(material_string,"Exit")) {
        // One could have a global physics struct for vacuum instead of creating one for each
        this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
        this_box_volume.p_physics->is_vacuum = 1; // Makes this volume a vacuum
        this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
        this_box_volume.p_physics->my_a = 0; // Should not be used.
        this_box_volume.geometry.is_exit_volume = 1;
        sprintf(this_box_volume.p_physics->name,"Exit");
    } else {
        #ifndef MATERIAL_DETECTOR
            printf("Need to define a material before refering to it in a geometry %s.\n",NAME_CURRENT_COMP);
            exit(1);
        #endif
        for (loop_index=0;loop_index<global_material_list.num_elements;loop_index++) {
            if (0 == strcmp(material_string,global_material_list.elements[loop_index].name)) {
                this_box_volume.p_physics = global_material_list.elements[loop_index].physics;
                break;
            }
            if (loop_index == global_material_list.num_elements-1) {
            printf("\n");
            printf("ERROR: The material string \"%s\" in Union geometry \"%s\" did not match a specified material. \n",material_string,NAME_CURRENT_COMP);
            printf("       The materials available at this point (need to be defined before the geometry): \n");
            for (loop_index=0;loop_index<global_material_list.num_elements;loop_index++)
              printf("         %s\n",global_material_list.elements[loop_index].name);
            printf("\n");
            printf("       It is also possible to use one of the defualt materials avaiable: \n");
            printf("           Vacuum (for a Volume without scattering or absorption)\n");
            printf("           Exit (for a Volume where the ray exits the component if it enters)\n");
            printf("           Mask (for a Volume that masks existing volumes specified in the mask_string\n");
            exit(1);
          }
        }
    }
} else {
    // Automatic linking, simply using the last defined material.
    #ifndef MATERIAL_DETECTOR
        printf("Need to define a material before the geometry to use automatic linking %s.\n",NAME_CURRENT_COMP);
        exit(1);
    #endif
    this_box_volume.p_physics = global_material_list.elements[global_material_list.num_elements-1].physics;
}

sprintf(this_box_volume.name,NAME_CURRENT_COMP);
sprintf(this_box_volume.geometry.shape,"box");
this_box_volume.geometry.priority_value = priority;
this_box_volume.geometry.geometry_p_interact = p_interact;
// Currently the coordinates will be in absolute space.
this_box_volume.geometry.center = POS_A_CURRENT_COMP;

this_box_storage.z_depth = zdepth;
this_box_storage.x_width1 = xwidth;
this_box_storage.y_height1 = yheight;

this_box_storage.is_rectangle = 0;
if (xwidth2 < 0 && yheight2 < 0) this_box_storage.is_rectangle = 1;
if (xwidth == xwidth2 && yheight == yheight2) this_box_storage.is_rectangle = 1;

if (xwidth2 < 0) {
    this_box_storage.x_width2 = xwidth;
    xwidth2 = xwidth;
} else this_box_storage.x_width2 = xwidth2;

if (yheight2 < 0) {
    this_box_storage.y_height2 = yheight;
    yheight2 = yheight;
} else this_box_storage.y_height2 = yheight2;


this_box_storage.normal_vectors[0] = coords_set(0,0,1);
this_box_storage.normal_vectors[1] = coords_set(0,0,1);

// for sides with y component = 0
x_component = 2*zdepth/sqrt((xwidth-xwidth2)*(xwidth-xwidth2)+4*zdepth*zdepth);
z_component = (xwidth-xwidth2)/sqrt(4*zdepth*zdepth+(xwidth-xwidth2)*(xwidth-xwidth2));

this_box_storage.normal_vectors[2] = coords_set(x_component,0,z_component);
this_box_storage.normal_vectors[3] = coords_set(-x_component,0,z_component);

// for sides with x component = 0
y_component = 2*zdepth/sqrt((yheight-yheight2)*(yheight-yheight2)+4*zdepth*zdepth);
z_component = (yheight-yheight2)/sqrt(4*zdepth*zdepth+(yheight-yheight2)*(yheight-yheight2));

this_box_storage.normal_vectors[4] = coords_set(0,y_component,z_component);
this_box_storage.normal_vectors[5] = coords_set(0,-y_component,z_component);

this_box_volume.geometry.visualization_on = visualize;

this_box_volume.geometry.geometry_parameters.p_box_storage = &this_box_storage;

// Assign pointers to functions for intersection with the shape, checking if a point is inside the shape
if (this_box_storage.is_rectangle == 1) {
this_box_volume.geometry.intersect_function = &sample_box_intersect_simple;
this_box_volume.geometry.within_function = &r_within_box_simple;
}
else {
this_box_volume.geometry.intersect_function = &sample_box_intersect_advanced;
this_box_volume.geometry.within_function = &r_within_box_advanced;
}

this_box_volume.geometry.shell_points = &box_shell_points;
this_box_volume.geometry.mcdisplay_function = &mcdisplay_box_function;
this_box_volume.geometry.initialize_from_main_function = &initialize_box_geometry_from_main_component;
this_box_volume.geometry.process_rot_allocated = 0;

this_box_volume.geometry.copy_geometry_parameters = &allocate_box_storage_copy;

rot_copy(this_box_volume.geometry.rotation_matrix,ROT_A_CURRENT_COMP); //check how ROT_R_CURRENT_COMP would work
rot_transpose(ROT_A_CURRENT_COMP,this_box_volume.geometry.transpose_rotation_matrix);

// Initialize loggers
this_box_volume.loggers.num_elements = 0;

// packing the information into the global_geometry_element, which is then included in the global_geometry_list.
sprintf(global_geometry_element.name,NAME_CURRENT_COMP);
global_geometry_element.activation_counter = number_of_activations;
global_geometry_element.component_index = INDEX_CURRENT_COMP;
global_geometry_element.Volume = &this_box_volume; // Would be nicer if this m was a pointer, now we have the (small) data two places
add_element_to_geometry_list(&global_geometry_list,global_geometry_element);
}
#line 250151 "MACS_sample_kidney_box.c"
#undef number_of_activations
#undef mask_setting
#undef mask_string
#undef p_interact
#undef focus_r
#undef focus_xh
#undef focus_xw
#undef focus_ah
#undef focus_aw
#undef target_z
#undef target_y
#undef target_x
#undef target_index
#undef visualize
#undef yheight2
#undef xwidth2
#undef zdepth
#undef yheight
#undef xwidth
#undef priority
#undef material_string
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

  /* Initializations for component channel_9_cave2_box2. */
  SIG_MESSAGE("channel_9_cave2_box2 (Init)");
#define mccompcurname  channel_9_cave2_box2
#define mccompcurtype  Union_box
#define mccompcurindex 494
#define loop_index mccchannel_9_cave2_box2_loop_index
#define this_box_volume mccchannel_9_cave2_box2_this_box_volume
#define global_geometry_element mccchannel_9_cave2_box2_global_geometry_element
#define this_box_storage mccchannel_9_cave2_box2_this_box_storage
#define material_string mccchannel_9_cave2_box2_material_string
#define priority mccchannel_9_cave2_box2_priority
#define xwidth mccchannel_9_cave2_box2_xwidth
#define yheight mccchannel_9_cave2_box2_yheight
#define zdepth mccchannel_9_cave2_box2_zdepth
#define xwidth2 mccchannel_9_cave2_box2_xwidth2
#define yheight2 mccchannel_9_cave2_box2_yheight2
#define visualize mccchannel_9_cave2_box2_visualize
#define target_index mccchannel_9_cave2_box2_target_index
#define target_x mccchannel_9_cave2_box2_target_x
#define target_y mccchannel_9_cave2_box2_target_y
#define target_z mccchannel_9_cave2_box2_target_z
#define focus_aw mccchannel_9_cave2_box2_focus_aw
#define focus_ah mccchannel_9_cave2_box2_focus_ah
#define focus_xw mccchannel_9_cave2_box2_focus_xw
#define focus_xh mccchannel_9_cave2_box2_focus_xh
#define focus_r mccchannel_9_cave2_box2_focus_r
#define p_interact mccchannel_9_cave2_box2_p_interact
#define mask_string mccchannel_9_cave2_box2_mask_string
#define mask_setting mccchannel_9_cave2_box2_mask_setting
#define number_of_activations mccchannel_9_cave2_box2_number_of_activations
#line 224 "Union_box.comp"
{
// Initializes the focusing system for this volume including input sanitation.
focus_initialize(&this_box_volume.geometry, POS_A_COMP_INDEX(INDEX_CURRENT_COMP+target_index), POS_A_CURRENT_COMP, ROT_A_CURRENT_COMP, target_index, target_x, target_y, target_z, focus_aw, focus_ah, focus_xw, focus_xh, focus_r, NAME_CURRENT_COMP);

// Input sanitation for this geometry
if (xwidth <= 0) {
  printf("\nERROR in Union_box named %s, the xwidth is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (yheight <= 0) {
  printf("\nERROR in Union_box named %s, yheight is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (zdepth <= 0) {
  printf("\nERROR in Union_box named %s, zdepth is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (xwidth2 <= 0 && xwidth2 != -1) {
  printf("\nERROR in Union_box named %s, the xwidth2 is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (yheight2 <= 0 && yheight2 != -1) {
  printf("\nERROR in Union_box named %s, yheight2 is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}

// Use sanitation
if (global_material_list.num_elements == 0) {
  printf("\nERROR: Need to define a material using Union_make_material before using a Union geometry component. \n");
  printf("       %s was defined before first use of Union_make_material.\n",NAME_CURRENT_COMP);
  exit(1);
}

this_box_volume.geometry.is_masked_volume = 0;
this_box_volume.geometry.is_exit_volume = 0;
this_box_volume.geometry.is_mask_volume = 0;
// check if the volume is a mask, if it is the material string is irelevant.
if (mask_string && strlen(mask_string) && strcmp(mask_string, "NULL") && strcmp(mask_string, "0")) {
    // A mask volume is used to limit the extend of other volumes, called the masked volumes. These are specified in the mask_string.
    // In order for a ray to enter a masked volume, it needs to be both in the region covered by that volume AND the mask volume.
    // When more than
    this_box_volume.geometry.mask_mode = 1; // Default is mask mode is ALL
    if (mask_setting && strlen(mask_setting) && strcmp(mask_setting, "NULL") && strcmp(mask_setting, "0")) {
        if (strcmp(mask_setting,"ALL") == 0 || strcmp(mask_setting,"All") == 0) this_box_volume.geometry.mask_mode = 1;
        else if (strcmp(mask_setting,"ANY") == 0 || strcmp(mask_setting,"Any") == 0) this_box_volume.geometry.mask_mode = 2;
        else {
            printf("The mask_mode of component %s is set to %s, but must be either ALL or ANY.\n",NAME_CURRENT_COMP,mask_setting);
            exit(1);
        }
    }
    
    for (loop_index=0;loop_index<global_geometry_list.num_elements;loop_index++) {
        // Add mask list
        if (1 == manual_linking_function(global_geometry_list.elements[loop_index].name,mask_string)) {
            add_element_to_int_list(&this_box_volume.geometry.mask_list,global_geometry_list.elements[loop_index].component_index);
            add_element_to_int_list(&global_geometry_list.elements[loop_index].Volume->geometry.masked_by_list,INDEX_CURRENT_COMP);
            global_geometry_list.elements[loop_index].Volume->geometry.is_masked_volume = 1;
            if (this_box_volume.geometry.mask_mode == 2)
                global_geometry_list.elements[loop_index].Volume->geometry.mask_mode = 2;
            if (this_box_volume.geometry.mask_mode == 1) {
                if (global_geometry_list.elements[loop_index].Volume->geometry.is_masked_volume == 1 && global_geometry_list.elements[loop_index].Volume->geometry.mask_mode != 2)
                    // If more than one mask is added to one volume, the ANY mode overwrites the (default) ALL mode.
                    global_geometry_list.elements[loop_index].Volume->geometry.mask_mode = 1;
            }
            
            found_geometries = 1;
        }
    }
    if (found_geometries == 0) {
        printf("The mask_string in geometry: %s did not find any of the specified volumes in the mask_string %s \n",NAME_CURRENT_COMP,mask_string);
        exit(1);
    }
    this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
    this_box_volume.p_physics->is_vacuum = 0; // Makes this volume a vacuum
    this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
    this_box_volume.p_physics->my_a = 0; // Should not be used.
    sprintf(this_box_volume.p_physics->name,"Mask");
    this_box_volume.geometry.is_mask_volume = 1;
    
    
// Read the material input, or if it lacks, use automatic linking.
} else if (material_string && strlen(material_string) && strcmp(material_string, "NULL") && strcmp(material_string, "0")) {
    // A geometry string was given, use it to determine which material
    if (0 == strcmp(material_string,"vacuum") || 0 == strcmp(material_string,"Vacuum")) {
        // One could have a global physics struct for vacuum instead of creating one for each
        this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
        this_box_volume.p_physics->is_vacuum = 1; // Makes this volume a vacuum
        this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
        this_box_volume.p_physics->my_a = 0; // Should not be used.
        sprintf(this_box_volume.p_physics->name,"Vacuum");
    } else if (0 == strcmp(material_string,"exit") || 0 == strcmp(material_string,"Exit")) {
        // One could have a global physics struct for vacuum instead of creating one for each
        this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
        this_box_volume.p_physics->is_vacuum = 1; // Makes this volume a vacuum
        this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
        this_box_volume.p_physics->my_a = 0; // Should not be used.
        this_box_volume.geometry.is_exit_volume = 1;
        sprintf(this_box_volume.p_physics->name,"Exit");
    } else {
        #ifndef MATERIAL_DETECTOR
            printf("Need to define a material before refering to it in a geometry %s.\n",NAME_CURRENT_COMP);
            exit(1);
        #endif
        for (loop_index=0;loop_index<global_material_list.num_elements;loop_index++) {
            if (0 == strcmp(material_string,global_material_list.elements[loop_index].name)) {
                this_box_volume.p_physics = global_material_list.elements[loop_index].physics;
                break;
            }
            if (loop_index == global_material_list.num_elements-1) {
            printf("\n");
            printf("ERROR: The material string \"%s\" in Union geometry \"%s\" did not match a specified material. \n",material_string,NAME_CURRENT_COMP);
            printf("       The materials available at this point (need to be defined before the geometry): \n");
            for (loop_index=0;loop_index<global_material_list.num_elements;loop_index++)
              printf("         %s\n",global_material_list.elements[loop_index].name);
            printf("\n");
            printf("       It is also possible to use one of the defualt materials avaiable: \n");
            printf("           Vacuum (for a Volume without scattering or absorption)\n");
            printf("           Exit (for a Volume where the ray exits the component if it enters)\n");
            printf("           Mask (for a Volume that masks existing volumes specified in the mask_string\n");
            exit(1);
          }
        }
    }
} else {
    // Automatic linking, simply using the last defined material.
    #ifndef MATERIAL_DETECTOR
        printf("Need to define a material before the geometry to use automatic linking %s.\n",NAME_CURRENT_COMP);
        exit(1);
    #endif
    this_box_volume.p_physics = global_material_list.elements[global_material_list.num_elements-1].physics;
}

sprintf(this_box_volume.name,NAME_CURRENT_COMP);
sprintf(this_box_volume.geometry.shape,"box");
this_box_volume.geometry.priority_value = priority;
this_box_volume.geometry.geometry_p_interact = p_interact;
// Currently the coordinates will be in absolute space.
this_box_volume.geometry.center = POS_A_CURRENT_COMP;

this_box_storage.z_depth = zdepth;
this_box_storage.x_width1 = xwidth;
this_box_storage.y_height1 = yheight;

this_box_storage.is_rectangle = 0;
if (xwidth2 < 0 && yheight2 < 0) this_box_storage.is_rectangle = 1;
if (xwidth == xwidth2 && yheight == yheight2) this_box_storage.is_rectangle = 1;

if (xwidth2 < 0) {
    this_box_storage.x_width2 = xwidth;
    xwidth2 = xwidth;
} else this_box_storage.x_width2 = xwidth2;

if (yheight2 < 0) {
    this_box_storage.y_height2 = yheight;
    yheight2 = yheight;
} else this_box_storage.y_height2 = yheight2;


this_box_storage.normal_vectors[0] = coords_set(0,0,1);
this_box_storage.normal_vectors[1] = coords_set(0,0,1);

// for sides with y component = 0
x_component = 2*zdepth/sqrt((xwidth-xwidth2)*(xwidth-xwidth2)+4*zdepth*zdepth);
z_component = (xwidth-xwidth2)/sqrt(4*zdepth*zdepth+(xwidth-xwidth2)*(xwidth-xwidth2));

this_box_storage.normal_vectors[2] = coords_set(x_component,0,z_component);
this_box_storage.normal_vectors[3] = coords_set(-x_component,0,z_component);

// for sides with x component = 0
y_component = 2*zdepth/sqrt((yheight-yheight2)*(yheight-yheight2)+4*zdepth*zdepth);
z_component = (yheight-yheight2)/sqrt(4*zdepth*zdepth+(yheight-yheight2)*(yheight-yheight2));

this_box_storage.normal_vectors[4] = coords_set(0,y_component,z_component);
this_box_storage.normal_vectors[5] = coords_set(0,-y_component,z_component);

this_box_volume.geometry.visualization_on = visualize;

this_box_volume.geometry.geometry_parameters.p_box_storage = &this_box_storage;

// Assign pointers to functions for intersection with the shape, checking if a point is inside the shape
if (this_box_storage.is_rectangle == 1) {
this_box_volume.geometry.intersect_function = &sample_box_intersect_simple;
this_box_volume.geometry.within_function = &r_within_box_simple;
}
else {
this_box_volume.geometry.intersect_function = &sample_box_intersect_advanced;
this_box_volume.geometry.within_function = &r_within_box_advanced;
}

this_box_volume.geometry.shell_points = &box_shell_points;
this_box_volume.geometry.mcdisplay_function = &mcdisplay_box_function;
this_box_volume.geometry.initialize_from_main_function = &initialize_box_geometry_from_main_component;
this_box_volume.geometry.process_rot_allocated = 0;

this_box_volume.geometry.copy_geometry_parameters = &allocate_box_storage_copy;

rot_copy(this_box_volume.geometry.rotation_matrix,ROT_A_CURRENT_COMP); //check how ROT_R_CURRENT_COMP would work
rot_transpose(ROT_A_CURRENT_COMP,this_box_volume.geometry.transpose_rotation_matrix);

// Initialize loggers
this_box_volume.loggers.num_elements = 0;

// packing the information into the global_geometry_element, which is then included in the global_geometry_list.
sprintf(global_geometry_element.name,NAME_CURRENT_COMP);
global_geometry_element.activation_counter = number_of_activations;
global_geometry_element.component_index = INDEX_CURRENT_COMP;
global_geometry_element.Volume = &this_box_volume; // Would be nicer if this m was a pointer, now we have the (small) data two places
add_element_to_geometry_list(&global_geometry_list,global_geometry_element);
}
#line 250421 "MACS_sample_kidney_box.c"
#undef number_of_activations
#undef mask_setting
#undef mask_string
#undef p_interact
#undef focus_r
#undef focus_xh
#undef focus_xw
#undef focus_ah
#undef focus_aw
#undef target_z
#undef target_y
#undef target_x
#undef target_index
#undef visualize
#undef yheight2
#undef xwidth2
#undef zdepth
#undef yheight
#undef xwidth
#undef priority
#undef material_string
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

  /* Initializations for component channel_9_cave2_box3. */
  SIG_MESSAGE("channel_9_cave2_box3 (Init)");
#define mccompcurname  channel_9_cave2_box3
#define mccompcurtype  Union_box
#define mccompcurindex 495
#define loop_index mccchannel_9_cave2_box3_loop_index
#define this_box_volume mccchannel_9_cave2_box3_this_box_volume
#define global_geometry_element mccchannel_9_cave2_box3_global_geometry_element
#define this_box_storage mccchannel_9_cave2_box3_this_box_storage
#define material_string mccchannel_9_cave2_box3_material_string
#define priority mccchannel_9_cave2_box3_priority
#define xwidth mccchannel_9_cave2_box3_xwidth
#define yheight mccchannel_9_cave2_box3_yheight
#define zdepth mccchannel_9_cave2_box3_zdepth
#define xwidth2 mccchannel_9_cave2_box3_xwidth2
#define yheight2 mccchannel_9_cave2_box3_yheight2
#define visualize mccchannel_9_cave2_box3_visualize
#define target_index mccchannel_9_cave2_box3_target_index
#define target_x mccchannel_9_cave2_box3_target_x
#define target_y mccchannel_9_cave2_box3_target_y
#define target_z mccchannel_9_cave2_box3_target_z
#define focus_aw mccchannel_9_cave2_box3_focus_aw
#define focus_ah mccchannel_9_cave2_box3_focus_ah
#define focus_xw mccchannel_9_cave2_box3_focus_xw
#define focus_xh mccchannel_9_cave2_box3_focus_xh
#define focus_r mccchannel_9_cave2_box3_focus_r
#define p_interact mccchannel_9_cave2_box3_p_interact
#define mask_string mccchannel_9_cave2_box3_mask_string
#define mask_setting mccchannel_9_cave2_box3_mask_setting
#define number_of_activations mccchannel_9_cave2_box3_number_of_activations
#line 224 "Union_box.comp"
{
// Initializes the focusing system for this volume including input sanitation.
focus_initialize(&this_box_volume.geometry, POS_A_COMP_INDEX(INDEX_CURRENT_COMP+target_index), POS_A_CURRENT_COMP, ROT_A_CURRENT_COMP, target_index, target_x, target_y, target_z, focus_aw, focus_ah, focus_xw, focus_xh, focus_r, NAME_CURRENT_COMP);

// Input sanitation for this geometry
if (xwidth <= 0) {
  printf("\nERROR in Union_box named %s, the xwidth is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (yheight <= 0) {
  printf("\nERROR in Union_box named %s, yheight is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (zdepth <= 0) {
  printf("\nERROR in Union_box named %s, zdepth is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (xwidth2 <= 0 && xwidth2 != -1) {
  printf("\nERROR in Union_box named %s, the xwidth2 is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (yheight2 <= 0 && yheight2 != -1) {
  printf("\nERROR in Union_box named %s, yheight2 is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}

// Use sanitation
if (global_material_list.num_elements == 0) {
  printf("\nERROR: Need to define a material using Union_make_material before using a Union geometry component. \n");
  printf("       %s was defined before first use of Union_make_material.\n",NAME_CURRENT_COMP);
  exit(1);
}

this_box_volume.geometry.is_masked_volume = 0;
this_box_volume.geometry.is_exit_volume = 0;
this_box_volume.geometry.is_mask_volume = 0;
// check if the volume is a mask, if it is the material string is irelevant.
if (mask_string && strlen(mask_string) && strcmp(mask_string, "NULL") && strcmp(mask_string, "0")) {
    // A mask volume is used to limit the extend of other volumes, called the masked volumes. These are specified in the mask_string.
    // In order for a ray to enter a masked volume, it needs to be both in the region covered by that volume AND the mask volume.
    // When more than
    this_box_volume.geometry.mask_mode = 1; // Default is mask mode is ALL
    if (mask_setting && strlen(mask_setting) && strcmp(mask_setting, "NULL") && strcmp(mask_setting, "0")) {
        if (strcmp(mask_setting,"ALL") == 0 || strcmp(mask_setting,"All") == 0) this_box_volume.geometry.mask_mode = 1;
        else if (strcmp(mask_setting,"ANY") == 0 || strcmp(mask_setting,"Any") == 0) this_box_volume.geometry.mask_mode = 2;
        else {
            printf("The mask_mode of component %s is set to %s, but must be either ALL or ANY.\n",NAME_CURRENT_COMP,mask_setting);
            exit(1);
        }
    }
    
    for (loop_index=0;loop_index<global_geometry_list.num_elements;loop_index++) {
        // Add mask list
        if (1 == manual_linking_function(global_geometry_list.elements[loop_index].name,mask_string)) {
            add_element_to_int_list(&this_box_volume.geometry.mask_list,global_geometry_list.elements[loop_index].component_index);
            add_element_to_int_list(&global_geometry_list.elements[loop_index].Volume->geometry.masked_by_list,INDEX_CURRENT_COMP);
            global_geometry_list.elements[loop_index].Volume->geometry.is_masked_volume = 1;
            if (this_box_volume.geometry.mask_mode == 2)
                global_geometry_list.elements[loop_index].Volume->geometry.mask_mode = 2;
            if (this_box_volume.geometry.mask_mode == 1) {
                if (global_geometry_list.elements[loop_index].Volume->geometry.is_masked_volume == 1 && global_geometry_list.elements[loop_index].Volume->geometry.mask_mode != 2)
                    // If more than one mask is added to one volume, the ANY mode overwrites the (default) ALL mode.
                    global_geometry_list.elements[loop_index].Volume->geometry.mask_mode = 1;
            }
            
            found_geometries = 1;
        }
    }
    if (found_geometries == 0) {
        printf("The mask_string in geometry: %s did not find any of the specified volumes in the mask_string %s \n",NAME_CURRENT_COMP,mask_string);
        exit(1);
    }
    this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
    this_box_volume.p_physics->is_vacuum = 0; // Makes this volume a vacuum
    this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
    this_box_volume.p_physics->my_a = 0; // Should not be used.
    sprintf(this_box_volume.p_physics->name,"Mask");
    this_box_volume.geometry.is_mask_volume = 1;
    
    
// Read the material input, or if it lacks, use automatic linking.
} else if (material_string && strlen(material_string) && strcmp(material_string, "NULL") && strcmp(material_string, "0")) {
    // A geometry string was given, use it to determine which material
    if (0 == strcmp(material_string,"vacuum") || 0 == strcmp(material_string,"Vacuum")) {
        // One could have a global physics struct for vacuum instead of creating one for each
        this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
        this_box_volume.p_physics->is_vacuum = 1; // Makes this volume a vacuum
        this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
        this_box_volume.p_physics->my_a = 0; // Should not be used.
        sprintf(this_box_volume.p_physics->name,"Vacuum");
    } else if (0 == strcmp(material_string,"exit") || 0 == strcmp(material_string,"Exit")) {
        // One could have a global physics struct for vacuum instead of creating one for each
        this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
        this_box_volume.p_physics->is_vacuum = 1; // Makes this volume a vacuum
        this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
        this_box_volume.p_physics->my_a = 0; // Should not be used.
        this_box_volume.geometry.is_exit_volume = 1;
        sprintf(this_box_volume.p_physics->name,"Exit");
    } else {
        #ifndef MATERIAL_DETECTOR
            printf("Need to define a material before refering to it in a geometry %s.\n",NAME_CURRENT_COMP);
            exit(1);
        #endif
        for (loop_index=0;loop_index<global_material_list.num_elements;loop_index++) {
            if (0 == strcmp(material_string,global_material_list.elements[loop_index].name)) {
                this_box_volume.p_physics = global_material_list.elements[loop_index].physics;
                break;
            }
            if (loop_index == global_material_list.num_elements-1) {
            printf("\n");
            printf("ERROR: The material string \"%s\" in Union geometry \"%s\" did not match a specified material. \n",material_string,NAME_CURRENT_COMP);
            printf("       The materials available at this point (need to be defined before the geometry): \n");
            for (loop_index=0;loop_index<global_material_list.num_elements;loop_index++)
              printf("         %s\n",global_material_list.elements[loop_index].name);
            printf("\n");
            printf("       It is also possible to use one of the defualt materials avaiable: \n");
            printf("           Vacuum (for a Volume without scattering or absorption)\n");
            printf("           Exit (for a Volume where the ray exits the component if it enters)\n");
            printf("           Mask (for a Volume that masks existing volumes specified in the mask_string\n");
            exit(1);
          }
        }
    }
} else {
    // Automatic linking, simply using the last defined material.
    #ifndef MATERIAL_DETECTOR
        printf("Need to define a material before the geometry to use automatic linking %s.\n",NAME_CURRENT_COMP);
        exit(1);
    #endif
    this_box_volume.p_physics = global_material_list.elements[global_material_list.num_elements-1].physics;
}

sprintf(this_box_volume.name,NAME_CURRENT_COMP);
sprintf(this_box_volume.geometry.shape,"box");
this_box_volume.geometry.priority_value = priority;
this_box_volume.geometry.geometry_p_interact = p_interact;
// Currently the coordinates will be in absolute space.
this_box_volume.geometry.center = POS_A_CURRENT_COMP;

this_box_storage.z_depth = zdepth;
this_box_storage.x_width1 = xwidth;
this_box_storage.y_height1 = yheight;

this_box_storage.is_rectangle = 0;
if (xwidth2 < 0 && yheight2 < 0) this_box_storage.is_rectangle = 1;
if (xwidth == xwidth2 && yheight == yheight2) this_box_storage.is_rectangle = 1;

if (xwidth2 < 0) {
    this_box_storage.x_width2 = xwidth;
    xwidth2 = xwidth;
} else this_box_storage.x_width2 = xwidth2;

if (yheight2 < 0) {
    this_box_storage.y_height2 = yheight;
    yheight2 = yheight;
} else this_box_storage.y_height2 = yheight2;


this_box_storage.normal_vectors[0] = coords_set(0,0,1);
this_box_storage.normal_vectors[1] = coords_set(0,0,1);

// for sides with y component = 0
x_component = 2*zdepth/sqrt((xwidth-xwidth2)*(xwidth-xwidth2)+4*zdepth*zdepth);
z_component = (xwidth-xwidth2)/sqrt(4*zdepth*zdepth+(xwidth-xwidth2)*(xwidth-xwidth2));

this_box_storage.normal_vectors[2] = coords_set(x_component,0,z_component);
this_box_storage.normal_vectors[3] = coords_set(-x_component,0,z_component);

// for sides with x component = 0
y_component = 2*zdepth/sqrt((yheight-yheight2)*(yheight-yheight2)+4*zdepth*zdepth);
z_component = (yheight-yheight2)/sqrt(4*zdepth*zdepth+(yheight-yheight2)*(yheight-yheight2));

this_box_storage.normal_vectors[4] = coords_set(0,y_component,z_component);
this_box_storage.normal_vectors[5] = coords_set(0,-y_component,z_component);

this_box_volume.geometry.visualization_on = visualize;

this_box_volume.geometry.geometry_parameters.p_box_storage = &this_box_storage;

// Assign pointers to functions for intersection with the shape, checking if a point is inside the shape
if (this_box_storage.is_rectangle == 1) {
this_box_volume.geometry.intersect_function = &sample_box_intersect_simple;
this_box_volume.geometry.within_function = &r_within_box_simple;
}
else {
this_box_volume.geometry.intersect_function = &sample_box_intersect_advanced;
this_box_volume.geometry.within_function = &r_within_box_advanced;
}

this_box_volume.geometry.shell_points = &box_shell_points;
this_box_volume.geometry.mcdisplay_function = &mcdisplay_box_function;
this_box_volume.geometry.initialize_from_main_function = &initialize_box_geometry_from_main_component;
this_box_volume.geometry.process_rot_allocated = 0;

this_box_volume.geometry.copy_geometry_parameters = &allocate_box_storage_copy;

rot_copy(this_box_volume.geometry.rotation_matrix,ROT_A_CURRENT_COMP); //check how ROT_R_CURRENT_COMP would work
rot_transpose(ROT_A_CURRENT_COMP,this_box_volume.geometry.transpose_rotation_matrix);

// Initialize loggers
this_box_volume.loggers.num_elements = 0;

// packing the information into the global_geometry_element, which is then included in the global_geometry_list.
sprintf(global_geometry_element.name,NAME_CURRENT_COMP);
global_geometry_element.activation_counter = number_of_activations;
global_geometry_element.component_index = INDEX_CURRENT_COMP;
global_geometry_element.Volume = &this_box_volume; // Would be nicer if this m was a pointer, now we have the (small) data two places
add_element_to_geometry_list(&global_geometry_list,global_geometry_element);
}
#line 250691 "MACS_sample_kidney_box.c"
#undef number_of_activations
#undef mask_setting
#undef mask_string
#undef p_interact
#undef focus_r
#undef focus_xh
#undef focus_xw
#undef focus_ah
#undef focus_aw
#undef target_z
#undef target_y
#undef target_x
#undef target_index
#undef visualize
#undef yheight2
#undef xwidth2
#undef zdepth
#undef yheight
#undef xwidth
#undef priority
#undef material_string
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

  /* Initializations for component inter_analyzer_colimator_center_9. */
  SIG_MESSAGE("inter_analyzer_colimator_center_9 (Init)");

  /* Initializations for component inter_analyzer_colimator_9_blade_0. */
  SIG_MESSAGE("inter_analyzer_colimator_9_blade_0 (Init)");
#define mccompcurname  inter_analyzer_colimator_9_blade_0
#define mccompcurtype  Union_box
#define mccompcurindex 497
#define loop_index mccinter_analyzer_colimator_9_blade_0_loop_index
#define this_box_volume mccinter_analyzer_colimator_9_blade_0_this_box_volume
#define global_geometry_element mccinter_analyzer_colimator_9_blade_0_global_geometry_element
#define this_box_storage mccinter_analyzer_colimator_9_blade_0_this_box_storage
#define material_string mccinter_analyzer_colimator_9_blade_0_material_string
#define priority mccinter_analyzer_colimator_9_blade_0_priority
#define xwidth mccinter_analyzer_colimator_9_blade_0_xwidth
#define yheight mccinter_analyzer_colimator_9_blade_0_yheight
#define zdepth mccinter_analyzer_colimator_9_blade_0_zdepth
#define xwidth2 mccinter_analyzer_colimator_9_blade_0_xwidth2
#define yheight2 mccinter_analyzer_colimator_9_blade_0_yheight2
#define visualize mccinter_analyzer_colimator_9_blade_0_visualize
#define target_index mccinter_analyzer_colimator_9_blade_0_target_index
#define target_x mccinter_analyzer_colimator_9_blade_0_target_x
#define target_y mccinter_analyzer_colimator_9_blade_0_target_y
#define target_z mccinter_analyzer_colimator_9_blade_0_target_z
#define focus_aw mccinter_analyzer_colimator_9_blade_0_focus_aw
#define focus_ah mccinter_analyzer_colimator_9_blade_0_focus_ah
#define focus_xw mccinter_analyzer_colimator_9_blade_0_focus_xw
#define focus_xh mccinter_analyzer_colimator_9_blade_0_focus_xh
#define focus_r mccinter_analyzer_colimator_9_blade_0_focus_r
#define p_interact mccinter_analyzer_colimator_9_blade_0_p_interact
#define mask_string mccinter_analyzer_colimator_9_blade_0_mask_string
#define mask_setting mccinter_analyzer_colimator_9_blade_0_mask_setting
#define number_of_activations mccinter_analyzer_colimator_9_blade_0_number_of_activations
#line 224 "Union_box.comp"
{
// Initializes the focusing system for this volume including input sanitation.
focus_initialize(&this_box_volume.geometry, POS_A_COMP_INDEX(INDEX_CURRENT_COMP+target_index), POS_A_CURRENT_COMP, ROT_A_CURRENT_COMP, target_index, target_x, target_y, target_z, focus_aw, focus_ah, focus_xw, focus_xh, focus_r, NAME_CURRENT_COMP);

// Input sanitation for this geometry
if (xwidth <= 0) {
  printf("\nERROR in Union_box named %s, the xwidth is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (yheight <= 0) {
  printf("\nERROR in Union_box named %s, yheight is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (zdepth <= 0) {
  printf("\nERROR in Union_box named %s, zdepth is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (xwidth2 <= 0 && xwidth2 != -1) {
  printf("\nERROR in Union_box named %s, the xwidth2 is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (yheight2 <= 0 && yheight2 != -1) {
  printf("\nERROR in Union_box named %s, yheight2 is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}

// Use sanitation
if (global_material_list.num_elements == 0) {
  printf("\nERROR: Need to define a material using Union_make_material before using a Union geometry component. \n");
  printf("       %s was defined before first use of Union_make_material.\n",NAME_CURRENT_COMP);
  exit(1);
}

this_box_volume.geometry.is_masked_volume = 0;
this_box_volume.geometry.is_exit_volume = 0;
this_box_volume.geometry.is_mask_volume = 0;
// check if the volume is a mask, if it is the material string is irelevant.
if (mask_string && strlen(mask_string) && strcmp(mask_string, "NULL") && strcmp(mask_string, "0")) {
    // A mask volume is used to limit the extend of other volumes, called the masked volumes. These are specified in the mask_string.
    // In order for a ray to enter a masked volume, it needs to be both in the region covered by that volume AND the mask volume.
    // When more than
    this_box_volume.geometry.mask_mode = 1; // Default is mask mode is ALL
    if (mask_setting && strlen(mask_setting) && strcmp(mask_setting, "NULL") && strcmp(mask_setting, "0")) {
        if (strcmp(mask_setting,"ALL") == 0 || strcmp(mask_setting,"All") == 0) this_box_volume.geometry.mask_mode = 1;
        else if (strcmp(mask_setting,"ANY") == 0 || strcmp(mask_setting,"Any") == 0) this_box_volume.geometry.mask_mode = 2;
        else {
            printf("The mask_mode of component %s is set to %s, but must be either ALL or ANY.\n",NAME_CURRENT_COMP,mask_setting);
            exit(1);
        }
    }
    
    for (loop_index=0;loop_index<global_geometry_list.num_elements;loop_index++) {
        // Add mask list
        if (1 == manual_linking_function(global_geometry_list.elements[loop_index].name,mask_string)) {
            add_element_to_int_list(&this_box_volume.geometry.mask_list,global_geometry_list.elements[loop_index].component_index);
            add_element_to_int_list(&global_geometry_list.elements[loop_index].Volume->geometry.masked_by_list,INDEX_CURRENT_COMP);
            global_geometry_list.elements[loop_index].Volume->geometry.is_masked_volume = 1;
            if (this_box_volume.geometry.mask_mode == 2)
                global_geometry_list.elements[loop_index].Volume->geometry.mask_mode = 2;
            if (this_box_volume.geometry.mask_mode == 1) {
                if (global_geometry_list.elements[loop_index].Volume->geometry.is_masked_volume == 1 && global_geometry_list.elements[loop_index].Volume->geometry.mask_mode != 2)
                    // If more than one mask is added to one volume, the ANY mode overwrites the (default) ALL mode.
                    global_geometry_list.elements[loop_index].Volume->geometry.mask_mode = 1;
            }
            
            found_geometries = 1;
        }
    }
    if (found_geometries == 0) {
        printf("The mask_string in geometry: %s did not find any of the specified volumes in the mask_string %s \n",NAME_CURRENT_COMP,mask_string);
        exit(1);
    }
    this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
    this_box_volume.p_physics->is_vacuum = 0; // Makes this volume a vacuum
    this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
    this_box_volume.p_physics->my_a = 0; // Should not be used.
    sprintf(this_box_volume.p_physics->name,"Mask");
    this_box_volume.geometry.is_mask_volume = 1;
    
    
// Read the material input, or if it lacks, use automatic linking.
} else if (material_string && strlen(material_string) && strcmp(material_string, "NULL") && strcmp(material_string, "0")) {
    // A geometry string was given, use it to determine which material
    if (0 == strcmp(material_string,"vacuum") || 0 == strcmp(material_string,"Vacuum")) {
        // One could have a global physics struct for vacuum instead of creating one for each
        this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
        this_box_volume.p_physics->is_vacuum = 1; // Makes this volume a vacuum
        this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
        this_box_volume.p_physics->my_a = 0; // Should not be used.
        sprintf(this_box_volume.p_physics->name,"Vacuum");
    } else if (0 == strcmp(material_string,"exit") || 0 == strcmp(material_string,"Exit")) {
        // One could have a global physics struct for vacuum instead of creating one for each
        this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
        this_box_volume.p_physics->is_vacuum = 1; // Makes this volume a vacuum
        this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
        this_box_volume.p_physics->my_a = 0; // Should not be used.
        this_box_volume.geometry.is_exit_volume = 1;
        sprintf(this_box_volume.p_physics->name,"Exit");
    } else {
        #ifndef MATERIAL_DETECTOR
            printf("Need to define a material before refering to it in a geometry %s.\n",NAME_CURRENT_COMP);
            exit(1);
        #endif
        for (loop_index=0;loop_index<global_material_list.num_elements;loop_index++) {
            if (0 == strcmp(material_string,global_material_list.elements[loop_index].name)) {
                this_box_volume.p_physics = global_material_list.elements[loop_index].physics;
                break;
            }
            if (loop_index == global_material_list.num_elements-1) {
            printf("\n");
            printf("ERROR: The material string \"%s\" in Union geometry \"%s\" did not match a specified material. \n",material_string,NAME_CURRENT_COMP);
            printf("       The materials available at this point (need to be defined before the geometry): \n");
            for (loop_index=0;loop_index<global_material_list.num_elements;loop_index++)
              printf("         %s\n",global_material_list.elements[loop_index].name);
            printf("\n");
            printf("       It is also possible to use one of the defualt materials avaiable: \n");
            printf("           Vacuum (for a Volume without scattering or absorption)\n");
            printf("           Exit (for a Volume where the ray exits the component if it enters)\n");
            printf("           Mask (for a Volume that masks existing volumes specified in the mask_string\n");
            exit(1);
          }
        }
    }
} else {
    // Automatic linking, simply using the last defined material.
    #ifndef MATERIAL_DETECTOR
        printf("Need to define a material before the geometry to use automatic linking %s.\n",NAME_CURRENT_COMP);
        exit(1);
    #endif
    this_box_volume.p_physics = global_material_list.elements[global_material_list.num_elements-1].physics;
}

sprintf(this_box_volume.name,NAME_CURRENT_COMP);
sprintf(this_box_volume.geometry.shape,"box");
this_box_volume.geometry.priority_value = priority;
this_box_volume.geometry.geometry_p_interact = p_interact;
// Currently the coordinates will be in absolute space.
this_box_volume.geometry.center = POS_A_CURRENT_COMP;

this_box_storage.z_depth = zdepth;
this_box_storage.x_width1 = xwidth;
this_box_storage.y_height1 = yheight;

this_box_storage.is_rectangle = 0;
if (xwidth2 < 0 && yheight2 < 0) this_box_storage.is_rectangle = 1;
if (xwidth == xwidth2 && yheight == yheight2) this_box_storage.is_rectangle = 1;

if (xwidth2 < 0) {
    this_box_storage.x_width2 = xwidth;
    xwidth2 = xwidth;
} else this_box_storage.x_width2 = xwidth2;

if (yheight2 < 0) {
    this_box_storage.y_height2 = yheight;
    yheight2 = yheight;
} else this_box_storage.y_height2 = yheight2;


this_box_storage.normal_vectors[0] = coords_set(0,0,1);
this_box_storage.normal_vectors[1] = coords_set(0,0,1);

// for sides with y component = 0
x_component = 2*zdepth/sqrt((xwidth-xwidth2)*(xwidth-xwidth2)+4*zdepth*zdepth);
z_component = (xwidth-xwidth2)/sqrt(4*zdepth*zdepth+(xwidth-xwidth2)*(xwidth-xwidth2));

this_box_storage.normal_vectors[2] = coords_set(x_component,0,z_component);
this_box_storage.normal_vectors[3] = coords_set(-x_component,0,z_component);

// for sides with x component = 0
y_component = 2*zdepth/sqrt((yheight-yheight2)*(yheight-yheight2)+4*zdepth*zdepth);
z_component = (yheight-yheight2)/sqrt(4*zdepth*zdepth+(yheight-yheight2)*(yheight-yheight2));

this_box_storage.normal_vectors[4] = coords_set(0,y_component,z_component);
this_box_storage.normal_vectors[5] = coords_set(0,-y_component,z_component);

this_box_volume.geometry.visualization_on = visualize;

this_box_volume.geometry.geometry_parameters.p_box_storage = &this_box_storage;

// Assign pointers to functions for intersection with the shape, checking if a point is inside the shape
if (this_box_storage.is_rectangle == 1) {
this_box_volume.geometry.intersect_function = &sample_box_intersect_simple;
this_box_volume.geometry.within_function = &r_within_box_simple;
}
else {
this_box_volume.geometry.intersect_function = &sample_box_intersect_advanced;
this_box_volume.geometry.within_function = &r_within_box_advanced;
}

this_box_volume.geometry.shell_points = &box_shell_points;
this_box_volume.geometry.mcdisplay_function = &mcdisplay_box_function;
this_box_volume.geometry.initialize_from_main_function = &initialize_box_geometry_from_main_component;
this_box_volume.geometry.process_rot_allocated = 0;

this_box_volume.geometry.copy_geometry_parameters = &allocate_box_storage_copy;

rot_copy(this_box_volume.geometry.rotation_matrix,ROT_A_CURRENT_COMP); //check how ROT_R_CURRENT_COMP would work
rot_transpose(ROT_A_CURRENT_COMP,this_box_volume.geometry.transpose_rotation_matrix);

// Initialize loggers
this_box_volume.loggers.num_elements = 0;

// packing the information into the global_geometry_element, which is then included in the global_geometry_list.
sprintf(global_geometry_element.name,NAME_CURRENT_COMP);
global_geometry_element.activation_counter = number_of_activations;
global_geometry_element.component_index = INDEX_CURRENT_COMP;
global_geometry_element.Volume = &this_box_volume; // Would be nicer if this m was a pointer, now we have the (small) data two places
add_element_to_geometry_list(&global_geometry_list,global_geometry_element);
}
#line 250964 "MACS_sample_kidney_box.c"
#undef number_of_activations
#undef mask_setting
#undef mask_string
#undef p_interact
#undef focus_r
#undef focus_xh
#undef focus_xw
#undef focus_ah
#undef focus_aw
#undef target_z
#undef target_y
#undef target_x
#undef target_index
#undef visualize
#undef yheight2
#undef xwidth2
#undef zdepth
#undef yheight
#undef xwidth
#undef priority
#undef material_string
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

  /* Initializations for component inter_analyzer_colimator_9_blade_1. */
  SIG_MESSAGE("inter_analyzer_colimator_9_blade_1 (Init)");
#define mccompcurname  inter_analyzer_colimator_9_blade_1
#define mccompcurtype  Union_box
#define mccompcurindex 498
#define loop_index mccinter_analyzer_colimator_9_blade_1_loop_index
#define this_box_volume mccinter_analyzer_colimator_9_blade_1_this_box_volume
#define global_geometry_element mccinter_analyzer_colimator_9_blade_1_global_geometry_element
#define this_box_storage mccinter_analyzer_colimator_9_blade_1_this_box_storage
#define material_string mccinter_analyzer_colimator_9_blade_1_material_string
#define priority mccinter_analyzer_colimator_9_blade_1_priority
#define xwidth mccinter_analyzer_colimator_9_blade_1_xwidth
#define yheight mccinter_analyzer_colimator_9_blade_1_yheight
#define zdepth mccinter_analyzer_colimator_9_blade_1_zdepth
#define xwidth2 mccinter_analyzer_colimator_9_blade_1_xwidth2
#define yheight2 mccinter_analyzer_colimator_9_blade_1_yheight2
#define visualize mccinter_analyzer_colimator_9_blade_1_visualize
#define target_index mccinter_analyzer_colimator_9_blade_1_target_index
#define target_x mccinter_analyzer_colimator_9_blade_1_target_x
#define target_y mccinter_analyzer_colimator_9_blade_1_target_y
#define target_z mccinter_analyzer_colimator_9_blade_1_target_z
#define focus_aw mccinter_analyzer_colimator_9_blade_1_focus_aw
#define focus_ah mccinter_analyzer_colimator_9_blade_1_focus_ah
#define focus_xw mccinter_analyzer_colimator_9_blade_1_focus_xw
#define focus_xh mccinter_analyzer_colimator_9_blade_1_focus_xh
#define focus_r mccinter_analyzer_colimator_9_blade_1_focus_r
#define p_interact mccinter_analyzer_colimator_9_blade_1_p_interact
#define mask_string mccinter_analyzer_colimator_9_blade_1_mask_string
#define mask_setting mccinter_analyzer_colimator_9_blade_1_mask_setting
#define number_of_activations mccinter_analyzer_colimator_9_blade_1_number_of_activations
#line 224 "Union_box.comp"
{
// Initializes the focusing system for this volume including input sanitation.
focus_initialize(&this_box_volume.geometry, POS_A_COMP_INDEX(INDEX_CURRENT_COMP+target_index), POS_A_CURRENT_COMP, ROT_A_CURRENT_COMP, target_index, target_x, target_y, target_z, focus_aw, focus_ah, focus_xw, focus_xh, focus_r, NAME_CURRENT_COMP);

// Input sanitation for this geometry
if (xwidth <= 0) {
  printf("\nERROR in Union_box named %s, the xwidth is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (yheight <= 0) {
  printf("\nERROR in Union_box named %s, yheight is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (zdepth <= 0) {
  printf("\nERROR in Union_box named %s, zdepth is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (xwidth2 <= 0 && xwidth2 != -1) {
  printf("\nERROR in Union_box named %s, the xwidth2 is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (yheight2 <= 0 && yheight2 != -1) {
  printf("\nERROR in Union_box named %s, yheight2 is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}

// Use sanitation
if (global_material_list.num_elements == 0) {
  printf("\nERROR: Need to define a material using Union_make_material before using a Union geometry component. \n");
  printf("       %s was defined before first use of Union_make_material.\n",NAME_CURRENT_COMP);
  exit(1);
}

this_box_volume.geometry.is_masked_volume = 0;
this_box_volume.geometry.is_exit_volume = 0;
this_box_volume.geometry.is_mask_volume = 0;
// check if the volume is a mask, if it is the material string is irelevant.
if (mask_string && strlen(mask_string) && strcmp(mask_string, "NULL") && strcmp(mask_string, "0")) {
    // A mask volume is used to limit the extend of other volumes, called the masked volumes. These are specified in the mask_string.
    // In order for a ray to enter a masked volume, it needs to be both in the region covered by that volume AND the mask volume.
    // When more than
    this_box_volume.geometry.mask_mode = 1; // Default is mask mode is ALL
    if (mask_setting && strlen(mask_setting) && strcmp(mask_setting, "NULL") && strcmp(mask_setting, "0")) {
        if (strcmp(mask_setting,"ALL") == 0 || strcmp(mask_setting,"All") == 0) this_box_volume.geometry.mask_mode = 1;
        else if (strcmp(mask_setting,"ANY") == 0 || strcmp(mask_setting,"Any") == 0) this_box_volume.geometry.mask_mode = 2;
        else {
            printf("The mask_mode of component %s is set to %s, but must be either ALL or ANY.\n",NAME_CURRENT_COMP,mask_setting);
            exit(1);
        }
    }
    
    for (loop_index=0;loop_index<global_geometry_list.num_elements;loop_index++) {
        // Add mask list
        if (1 == manual_linking_function(global_geometry_list.elements[loop_index].name,mask_string)) {
            add_element_to_int_list(&this_box_volume.geometry.mask_list,global_geometry_list.elements[loop_index].component_index);
            add_element_to_int_list(&global_geometry_list.elements[loop_index].Volume->geometry.masked_by_list,INDEX_CURRENT_COMP);
            global_geometry_list.elements[loop_index].Volume->geometry.is_masked_volume = 1;
            if (this_box_volume.geometry.mask_mode == 2)
                global_geometry_list.elements[loop_index].Volume->geometry.mask_mode = 2;
            if (this_box_volume.geometry.mask_mode == 1) {
                if (global_geometry_list.elements[loop_index].Volume->geometry.is_masked_volume == 1 && global_geometry_list.elements[loop_index].Volume->geometry.mask_mode != 2)
                    // If more than one mask is added to one volume, the ANY mode overwrites the (default) ALL mode.
                    global_geometry_list.elements[loop_index].Volume->geometry.mask_mode = 1;
            }
            
            found_geometries = 1;
        }
    }
    if (found_geometries == 0) {
        printf("The mask_string in geometry: %s did not find any of the specified volumes in the mask_string %s \n",NAME_CURRENT_COMP,mask_string);
        exit(1);
    }
    this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
    this_box_volume.p_physics->is_vacuum = 0; // Makes this volume a vacuum
    this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
    this_box_volume.p_physics->my_a = 0; // Should not be used.
    sprintf(this_box_volume.p_physics->name,"Mask");
    this_box_volume.geometry.is_mask_volume = 1;
    
    
// Read the material input, or if it lacks, use automatic linking.
} else if (material_string && strlen(material_string) && strcmp(material_string, "NULL") && strcmp(material_string, "0")) {
    // A geometry string was given, use it to determine which material
    if (0 == strcmp(material_string,"vacuum") || 0 == strcmp(material_string,"Vacuum")) {
        // One could have a global physics struct for vacuum instead of creating one for each
        this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
        this_box_volume.p_physics->is_vacuum = 1; // Makes this volume a vacuum
        this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
        this_box_volume.p_physics->my_a = 0; // Should not be used.
        sprintf(this_box_volume.p_physics->name,"Vacuum");
    } else if (0 == strcmp(material_string,"exit") || 0 == strcmp(material_string,"Exit")) {
        // One could have a global physics struct for vacuum instead of creating one for each
        this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
        this_box_volume.p_physics->is_vacuum = 1; // Makes this volume a vacuum
        this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
        this_box_volume.p_physics->my_a = 0; // Should not be used.
        this_box_volume.geometry.is_exit_volume = 1;
        sprintf(this_box_volume.p_physics->name,"Exit");
    } else {
        #ifndef MATERIAL_DETECTOR
            printf("Need to define a material before refering to it in a geometry %s.\n",NAME_CURRENT_COMP);
            exit(1);
        #endif
        for (loop_index=0;loop_index<global_material_list.num_elements;loop_index++) {
            if (0 == strcmp(material_string,global_material_list.elements[loop_index].name)) {
                this_box_volume.p_physics = global_material_list.elements[loop_index].physics;
                break;
            }
            if (loop_index == global_material_list.num_elements-1) {
            printf("\n");
            printf("ERROR: The material string \"%s\" in Union geometry \"%s\" did not match a specified material. \n",material_string,NAME_CURRENT_COMP);
            printf("       The materials available at this point (need to be defined before the geometry): \n");
            for (loop_index=0;loop_index<global_material_list.num_elements;loop_index++)
              printf("         %s\n",global_material_list.elements[loop_index].name);
            printf("\n");
            printf("       It is also possible to use one of the defualt materials avaiable: \n");
            printf("           Vacuum (for a Volume without scattering or absorption)\n");
            printf("           Exit (for a Volume where the ray exits the component if it enters)\n");
            printf("           Mask (for a Volume that masks existing volumes specified in the mask_string\n");
            exit(1);
          }
        }
    }
} else {
    // Automatic linking, simply using the last defined material.
    #ifndef MATERIAL_DETECTOR
        printf("Need to define a material before the geometry to use automatic linking %s.\n",NAME_CURRENT_COMP);
        exit(1);
    #endif
    this_box_volume.p_physics = global_material_list.elements[global_material_list.num_elements-1].physics;
}

sprintf(this_box_volume.name,NAME_CURRENT_COMP);
sprintf(this_box_volume.geometry.shape,"box");
this_box_volume.geometry.priority_value = priority;
this_box_volume.geometry.geometry_p_interact = p_interact;
// Currently the coordinates will be in absolute space.
this_box_volume.geometry.center = POS_A_CURRENT_COMP;

this_box_storage.z_depth = zdepth;
this_box_storage.x_width1 = xwidth;
this_box_storage.y_height1 = yheight;

this_box_storage.is_rectangle = 0;
if (xwidth2 < 0 && yheight2 < 0) this_box_storage.is_rectangle = 1;
if (xwidth == xwidth2 && yheight == yheight2) this_box_storage.is_rectangle = 1;

if (xwidth2 < 0) {
    this_box_storage.x_width2 = xwidth;
    xwidth2 = xwidth;
} else this_box_storage.x_width2 = xwidth2;

if (yheight2 < 0) {
    this_box_storage.y_height2 = yheight;
    yheight2 = yheight;
} else this_box_storage.y_height2 = yheight2;


this_box_storage.normal_vectors[0] = coords_set(0,0,1);
this_box_storage.normal_vectors[1] = coords_set(0,0,1);

// for sides with y component = 0
x_component = 2*zdepth/sqrt((xwidth-xwidth2)*(xwidth-xwidth2)+4*zdepth*zdepth);
z_component = (xwidth-xwidth2)/sqrt(4*zdepth*zdepth+(xwidth-xwidth2)*(xwidth-xwidth2));

this_box_storage.normal_vectors[2] = coords_set(x_component,0,z_component);
this_box_storage.normal_vectors[3] = coords_set(-x_component,0,z_component);

// for sides with x component = 0
y_component = 2*zdepth/sqrt((yheight-yheight2)*(yheight-yheight2)+4*zdepth*zdepth);
z_component = (yheight-yheight2)/sqrt(4*zdepth*zdepth+(yheight-yheight2)*(yheight-yheight2));

this_box_storage.normal_vectors[4] = coords_set(0,y_component,z_component);
this_box_storage.normal_vectors[5] = coords_set(0,-y_component,z_component);

this_box_volume.geometry.visualization_on = visualize;

this_box_volume.geometry.geometry_parameters.p_box_storage = &this_box_storage;

// Assign pointers to functions for intersection with the shape, checking if a point is inside the shape
if (this_box_storage.is_rectangle == 1) {
this_box_volume.geometry.intersect_function = &sample_box_intersect_simple;
this_box_volume.geometry.within_function = &r_within_box_simple;
}
else {
this_box_volume.geometry.intersect_function = &sample_box_intersect_advanced;
this_box_volume.geometry.within_function = &r_within_box_advanced;
}

this_box_volume.geometry.shell_points = &box_shell_points;
this_box_volume.geometry.mcdisplay_function = &mcdisplay_box_function;
this_box_volume.geometry.initialize_from_main_function = &initialize_box_geometry_from_main_component;
this_box_volume.geometry.process_rot_allocated = 0;

this_box_volume.geometry.copy_geometry_parameters = &allocate_box_storage_copy;

rot_copy(this_box_volume.geometry.rotation_matrix,ROT_A_CURRENT_COMP); //check how ROT_R_CURRENT_COMP would work
rot_transpose(ROT_A_CURRENT_COMP,this_box_volume.geometry.transpose_rotation_matrix);

// Initialize loggers
this_box_volume.loggers.num_elements = 0;

// packing the information into the global_geometry_element, which is then included in the global_geometry_list.
sprintf(global_geometry_element.name,NAME_CURRENT_COMP);
global_geometry_element.activation_counter = number_of_activations;
global_geometry_element.component_index = INDEX_CURRENT_COMP;
global_geometry_element.Volume = &this_box_volume; // Would be nicer if this m was a pointer, now we have the (small) data two places
add_element_to_geometry_list(&global_geometry_list,global_geometry_element);
}
#line 251234 "MACS_sample_kidney_box.c"
#undef number_of_activations
#undef mask_setting
#undef mask_string
#undef p_interact
#undef focus_r
#undef focus_xh
#undef focus_xw
#undef focus_ah
#undef focus_aw
#undef target_z
#undef target_y
#undef target_x
#undef target_index
#undef visualize
#undef yheight2
#undef xwidth2
#undef zdepth
#undef yheight
#undef xwidth
#undef priority
#undef material_string
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

  /* Initializations for component inter_analyzer_colimator_9_blade_2. */
  SIG_MESSAGE("inter_analyzer_colimator_9_blade_2 (Init)");
#define mccompcurname  inter_analyzer_colimator_9_blade_2
#define mccompcurtype  Union_box
#define mccompcurindex 499
#define loop_index mccinter_analyzer_colimator_9_blade_2_loop_index
#define this_box_volume mccinter_analyzer_colimator_9_blade_2_this_box_volume
#define global_geometry_element mccinter_analyzer_colimator_9_blade_2_global_geometry_element
#define this_box_storage mccinter_analyzer_colimator_9_blade_2_this_box_storage
#define material_string mccinter_analyzer_colimator_9_blade_2_material_string
#define priority mccinter_analyzer_colimator_9_blade_2_priority
#define xwidth mccinter_analyzer_colimator_9_blade_2_xwidth
#define yheight mccinter_analyzer_colimator_9_blade_2_yheight
#define zdepth mccinter_analyzer_colimator_9_blade_2_zdepth
#define xwidth2 mccinter_analyzer_colimator_9_blade_2_xwidth2
#define yheight2 mccinter_analyzer_colimator_9_blade_2_yheight2
#define visualize mccinter_analyzer_colimator_9_blade_2_visualize
#define target_index mccinter_analyzer_colimator_9_blade_2_target_index
#define target_x mccinter_analyzer_colimator_9_blade_2_target_x
#define target_y mccinter_analyzer_colimator_9_blade_2_target_y
#define target_z mccinter_analyzer_colimator_9_blade_2_target_z
#define focus_aw mccinter_analyzer_colimator_9_blade_2_focus_aw
#define focus_ah mccinter_analyzer_colimator_9_blade_2_focus_ah
#define focus_xw mccinter_analyzer_colimator_9_blade_2_focus_xw
#define focus_xh mccinter_analyzer_colimator_9_blade_2_focus_xh
#define focus_r mccinter_analyzer_colimator_9_blade_2_focus_r
#define p_interact mccinter_analyzer_colimator_9_blade_2_p_interact
#define mask_string mccinter_analyzer_colimator_9_blade_2_mask_string
#define mask_setting mccinter_analyzer_colimator_9_blade_2_mask_setting
#define number_of_activations mccinter_analyzer_colimator_9_blade_2_number_of_activations
#line 224 "Union_box.comp"
{
// Initializes the focusing system for this volume including input sanitation.
focus_initialize(&this_box_volume.geometry, POS_A_COMP_INDEX(INDEX_CURRENT_COMP+target_index), POS_A_CURRENT_COMP, ROT_A_CURRENT_COMP, target_index, target_x, target_y, target_z, focus_aw, focus_ah, focus_xw, focus_xh, focus_r, NAME_CURRENT_COMP);

// Input sanitation for this geometry
if (xwidth <= 0) {
  printf("\nERROR in Union_box named %s, the xwidth is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (yheight <= 0) {
  printf("\nERROR in Union_box named %s, yheight is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (zdepth <= 0) {
  printf("\nERROR in Union_box named %s, zdepth is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (xwidth2 <= 0 && xwidth2 != -1) {
  printf("\nERROR in Union_box named %s, the xwidth2 is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (yheight2 <= 0 && yheight2 != -1) {
  printf("\nERROR in Union_box named %s, yheight2 is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}

// Use sanitation
if (global_material_list.num_elements == 0) {
  printf("\nERROR: Need to define a material using Union_make_material before using a Union geometry component. \n");
  printf("       %s was defined before first use of Union_make_material.\n",NAME_CURRENT_COMP);
  exit(1);
}

this_box_volume.geometry.is_masked_volume = 0;
this_box_volume.geometry.is_exit_volume = 0;
this_box_volume.geometry.is_mask_volume = 0;
// check if the volume is a mask, if it is the material string is irelevant.
if (mask_string && strlen(mask_string) && strcmp(mask_string, "NULL") && strcmp(mask_string, "0")) {
    // A mask volume is used to limit the extend of other volumes, called the masked volumes. These are specified in the mask_string.
    // In order for a ray to enter a masked volume, it needs to be both in the region covered by that volume AND the mask volume.
    // When more than
    this_box_volume.geometry.mask_mode = 1; // Default is mask mode is ALL
    if (mask_setting && strlen(mask_setting) && strcmp(mask_setting, "NULL") && strcmp(mask_setting, "0")) {
        if (strcmp(mask_setting,"ALL") == 0 || strcmp(mask_setting,"All") == 0) this_box_volume.geometry.mask_mode = 1;
        else if (strcmp(mask_setting,"ANY") == 0 || strcmp(mask_setting,"Any") == 0) this_box_volume.geometry.mask_mode = 2;
        else {
            printf("The mask_mode of component %s is set to %s, but must be either ALL or ANY.\n",NAME_CURRENT_COMP,mask_setting);
            exit(1);
        }
    }
    
    for (loop_index=0;loop_index<global_geometry_list.num_elements;loop_index++) {
        // Add mask list
        if (1 == manual_linking_function(global_geometry_list.elements[loop_index].name,mask_string)) {
            add_element_to_int_list(&this_box_volume.geometry.mask_list,global_geometry_list.elements[loop_index].component_index);
            add_element_to_int_list(&global_geometry_list.elements[loop_index].Volume->geometry.masked_by_list,INDEX_CURRENT_COMP);
            global_geometry_list.elements[loop_index].Volume->geometry.is_masked_volume = 1;
            if (this_box_volume.geometry.mask_mode == 2)
                global_geometry_list.elements[loop_index].Volume->geometry.mask_mode = 2;
            if (this_box_volume.geometry.mask_mode == 1) {
                if (global_geometry_list.elements[loop_index].Volume->geometry.is_masked_volume == 1 && global_geometry_list.elements[loop_index].Volume->geometry.mask_mode != 2)
                    // If more than one mask is added to one volume, the ANY mode overwrites the (default) ALL mode.
                    global_geometry_list.elements[loop_index].Volume->geometry.mask_mode = 1;
            }
            
            found_geometries = 1;
        }
    }
    if (found_geometries == 0) {
        printf("The mask_string in geometry: %s did not find any of the specified volumes in the mask_string %s \n",NAME_CURRENT_COMP,mask_string);
        exit(1);
    }
    this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
    this_box_volume.p_physics->is_vacuum = 0; // Makes this volume a vacuum
    this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
    this_box_volume.p_physics->my_a = 0; // Should not be used.
    sprintf(this_box_volume.p_physics->name,"Mask");
    this_box_volume.geometry.is_mask_volume = 1;
    
    
// Read the material input, or if it lacks, use automatic linking.
} else if (material_string && strlen(material_string) && strcmp(material_string, "NULL") && strcmp(material_string, "0")) {
    // A geometry string was given, use it to determine which material
    if (0 == strcmp(material_string,"vacuum") || 0 == strcmp(material_string,"Vacuum")) {
        // One could have a global physics struct for vacuum instead of creating one for each
        this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
        this_box_volume.p_physics->is_vacuum = 1; // Makes this volume a vacuum
        this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
        this_box_volume.p_physics->my_a = 0; // Should not be used.
        sprintf(this_box_volume.p_physics->name,"Vacuum");
    } else if (0 == strcmp(material_string,"exit") || 0 == strcmp(material_string,"Exit")) {
        // One could have a global physics struct for vacuum instead of creating one for each
        this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
        this_box_volume.p_physics->is_vacuum = 1; // Makes this volume a vacuum
        this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
        this_box_volume.p_physics->my_a = 0; // Should not be used.
        this_box_volume.geometry.is_exit_volume = 1;
        sprintf(this_box_volume.p_physics->name,"Exit");
    } else {
        #ifndef MATERIAL_DETECTOR
            printf("Need to define a material before refering to it in a geometry %s.\n",NAME_CURRENT_COMP);
            exit(1);
        #endif
        for (loop_index=0;loop_index<global_material_list.num_elements;loop_index++) {
            if (0 == strcmp(material_string,global_material_list.elements[loop_index].name)) {
                this_box_volume.p_physics = global_material_list.elements[loop_index].physics;
                break;
            }
            if (loop_index == global_material_list.num_elements-1) {
            printf("\n");
            printf("ERROR: The material string \"%s\" in Union geometry \"%s\" did not match a specified material. \n",material_string,NAME_CURRENT_COMP);
            printf("       The materials available at this point (need to be defined before the geometry): \n");
            for (loop_index=0;loop_index<global_material_list.num_elements;loop_index++)
              printf("         %s\n",global_material_list.elements[loop_index].name);
            printf("\n");
            printf("       It is also possible to use one of the defualt materials avaiable: \n");
            printf("           Vacuum (for a Volume without scattering or absorption)\n");
            printf("           Exit (for a Volume where the ray exits the component if it enters)\n");
            printf("           Mask (for a Volume that masks existing volumes specified in the mask_string\n");
            exit(1);
          }
        }
    }
} else {
    // Automatic linking, simply using the last defined material.
    #ifndef MATERIAL_DETECTOR
        printf("Need to define a material before the geometry to use automatic linking %s.\n",NAME_CURRENT_COMP);
        exit(1);
    #endif
    this_box_volume.p_physics = global_material_list.elements[global_material_list.num_elements-1].physics;
}

sprintf(this_box_volume.name,NAME_CURRENT_COMP);
sprintf(this_box_volume.geometry.shape,"box");
this_box_volume.geometry.priority_value = priority;
this_box_volume.geometry.geometry_p_interact = p_interact;
// Currently the coordinates will be in absolute space.
this_box_volume.geometry.center = POS_A_CURRENT_COMP;

this_box_storage.z_depth = zdepth;
this_box_storage.x_width1 = xwidth;
this_box_storage.y_height1 = yheight;

this_box_storage.is_rectangle = 0;
if (xwidth2 < 0 && yheight2 < 0) this_box_storage.is_rectangle = 1;
if (xwidth == xwidth2 && yheight == yheight2) this_box_storage.is_rectangle = 1;

if (xwidth2 < 0) {
    this_box_storage.x_width2 = xwidth;
    xwidth2 = xwidth;
} else this_box_storage.x_width2 = xwidth2;

if (yheight2 < 0) {
    this_box_storage.y_height2 = yheight;
    yheight2 = yheight;
} else this_box_storage.y_height2 = yheight2;


this_box_storage.normal_vectors[0] = coords_set(0,0,1);
this_box_storage.normal_vectors[1] = coords_set(0,0,1);

// for sides with y component = 0
x_component = 2*zdepth/sqrt((xwidth-xwidth2)*(xwidth-xwidth2)+4*zdepth*zdepth);
z_component = (xwidth-xwidth2)/sqrt(4*zdepth*zdepth+(xwidth-xwidth2)*(xwidth-xwidth2));

this_box_storage.normal_vectors[2] = coords_set(x_component,0,z_component);
this_box_storage.normal_vectors[3] = coords_set(-x_component,0,z_component);

// for sides with x component = 0
y_component = 2*zdepth/sqrt((yheight-yheight2)*(yheight-yheight2)+4*zdepth*zdepth);
z_component = (yheight-yheight2)/sqrt(4*zdepth*zdepth+(yheight-yheight2)*(yheight-yheight2));

this_box_storage.normal_vectors[4] = coords_set(0,y_component,z_component);
this_box_storage.normal_vectors[5] = coords_set(0,-y_component,z_component);

this_box_volume.geometry.visualization_on = visualize;

this_box_volume.geometry.geometry_parameters.p_box_storage = &this_box_storage;

// Assign pointers to functions for intersection with the shape, checking if a point is inside the shape
if (this_box_storage.is_rectangle == 1) {
this_box_volume.geometry.intersect_function = &sample_box_intersect_simple;
this_box_volume.geometry.within_function = &r_within_box_simple;
}
else {
this_box_volume.geometry.intersect_function = &sample_box_intersect_advanced;
this_box_volume.geometry.within_function = &r_within_box_advanced;
}

this_box_volume.geometry.shell_points = &box_shell_points;
this_box_volume.geometry.mcdisplay_function = &mcdisplay_box_function;
this_box_volume.geometry.initialize_from_main_function = &initialize_box_geometry_from_main_component;
this_box_volume.geometry.process_rot_allocated = 0;

this_box_volume.geometry.copy_geometry_parameters = &allocate_box_storage_copy;

rot_copy(this_box_volume.geometry.rotation_matrix,ROT_A_CURRENT_COMP); //check how ROT_R_CURRENT_COMP would work
rot_transpose(ROT_A_CURRENT_COMP,this_box_volume.geometry.transpose_rotation_matrix);

// Initialize loggers
this_box_volume.loggers.num_elements = 0;

// packing the information into the global_geometry_element, which is then included in the global_geometry_list.
sprintf(global_geometry_element.name,NAME_CURRENT_COMP);
global_geometry_element.activation_counter = number_of_activations;
global_geometry_element.component_index = INDEX_CURRENT_COMP;
global_geometry_element.Volume = &this_box_volume; // Would be nicer if this m was a pointer, now we have the (small) data two places
add_element_to_geometry_list(&global_geometry_list,global_geometry_element);
}
#line 251504 "MACS_sample_kidney_box.c"
#undef number_of_activations
#undef mask_setting
#undef mask_string
#undef p_interact
#undef focus_r
#undef focus_xh
#undef focus_xw
#undef focus_ah
#undef focus_aw
#undef target_z
#undef target_y
#undef target_x
#undef target_index
#undef visualize
#undef yheight2
#undef xwidth2
#undef zdepth
#undef yheight
#undef xwidth
#undef priority
#undef material_string
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

  /* Initializations for component inter_analyzer_colimator_9_blade_3. */
  SIG_MESSAGE("inter_analyzer_colimator_9_blade_3 (Init)");
#define mccompcurname  inter_analyzer_colimator_9_blade_3
#define mccompcurtype  Union_box
#define mccompcurindex 500
#define loop_index mccinter_analyzer_colimator_9_blade_3_loop_index
#define this_box_volume mccinter_analyzer_colimator_9_blade_3_this_box_volume
#define global_geometry_element mccinter_analyzer_colimator_9_blade_3_global_geometry_element
#define this_box_storage mccinter_analyzer_colimator_9_blade_3_this_box_storage
#define material_string mccinter_analyzer_colimator_9_blade_3_material_string
#define priority mccinter_analyzer_colimator_9_blade_3_priority
#define xwidth mccinter_analyzer_colimator_9_blade_3_xwidth
#define yheight mccinter_analyzer_colimator_9_blade_3_yheight
#define zdepth mccinter_analyzer_colimator_9_blade_3_zdepth
#define xwidth2 mccinter_analyzer_colimator_9_blade_3_xwidth2
#define yheight2 mccinter_analyzer_colimator_9_blade_3_yheight2
#define visualize mccinter_analyzer_colimator_9_blade_3_visualize
#define target_index mccinter_analyzer_colimator_9_blade_3_target_index
#define target_x mccinter_analyzer_colimator_9_blade_3_target_x
#define target_y mccinter_analyzer_colimator_9_blade_3_target_y
#define target_z mccinter_analyzer_colimator_9_blade_3_target_z
#define focus_aw mccinter_analyzer_colimator_9_blade_3_focus_aw
#define focus_ah mccinter_analyzer_colimator_9_blade_3_focus_ah
#define focus_xw mccinter_analyzer_colimator_9_blade_3_focus_xw
#define focus_xh mccinter_analyzer_colimator_9_blade_3_focus_xh
#define focus_r mccinter_analyzer_colimator_9_blade_3_focus_r
#define p_interact mccinter_analyzer_colimator_9_blade_3_p_interact
#define mask_string mccinter_analyzer_colimator_9_blade_3_mask_string
#define mask_setting mccinter_analyzer_colimator_9_blade_3_mask_setting
#define number_of_activations mccinter_analyzer_colimator_9_blade_3_number_of_activations
#line 224 "Union_box.comp"
{
// Initializes the focusing system for this volume including input sanitation.
focus_initialize(&this_box_volume.geometry, POS_A_COMP_INDEX(INDEX_CURRENT_COMP+target_index), POS_A_CURRENT_COMP, ROT_A_CURRENT_COMP, target_index, target_x, target_y, target_z, focus_aw, focus_ah, focus_xw, focus_xh, focus_r, NAME_CURRENT_COMP);

// Input sanitation for this geometry
if (xwidth <= 0) {
  printf("\nERROR in Union_box named %s, the xwidth is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (yheight <= 0) {
  printf("\nERROR in Union_box named %s, yheight is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (zdepth <= 0) {
  printf("\nERROR in Union_box named %s, zdepth is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (xwidth2 <= 0 && xwidth2 != -1) {
  printf("\nERROR in Union_box named %s, the xwidth2 is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (yheight2 <= 0 && yheight2 != -1) {
  printf("\nERROR in Union_box named %s, yheight2 is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}

// Use sanitation
if (global_material_list.num_elements == 0) {
  printf("\nERROR: Need to define a material using Union_make_material before using a Union geometry component. \n");
  printf("       %s was defined before first use of Union_make_material.\n",NAME_CURRENT_COMP);
  exit(1);
}

this_box_volume.geometry.is_masked_volume = 0;
this_box_volume.geometry.is_exit_volume = 0;
this_box_volume.geometry.is_mask_volume = 0;
// check if the volume is a mask, if it is the material string is irelevant.
if (mask_string && strlen(mask_string) && strcmp(mask_string, "NULL") && strcmp(mask_string, "0")) {
    // A mask volume is used to limit the extend of other volumes, called the masked volumes. These are specified in the mask_string.
    // In order for a ray to enter a masked volume, it needs to be both in the region covered by that volume AND the mask volume.
    // When more than
    this_box_volume.geometry.mask_mode = 1; // Default is mask mode is ALL
    if (mask_setting && strlen(mask_setting) && strcmp(mask_setting, "NULL") && strcmp(mask_setting, "0")) {
        if (strcmp(mask_setting,"ALL") == 0 || strcmp(mask_setting,"All") == 0) this_box_volume.geometry.mask_mode = 1;
        else if (strcmp(mask_setting,"ANY") == 0 || strcmp(mask_setting,"Any") == 0) this_box_volume.geometry.mask_mode = 2;
        else {
            printf("The mask_mode of component %s is set to %s, but must be either ALL or ANY.\n",NAME_CURRENT_COMP,mask_setting);
            exit(1);
        }
    }
    
    for (loop_index=0;loop_index<global_geometry_list.num_elements;loop_index++) {
        // Add mask list
        if (1 == manual_linking_function(global_geometry_list.elements[loop_index].name,mask_string)) {
            add_element_to_int_list(&this_box_volume.geometry.mask_list,global_geometry_list.elements[loop_index].component_index);
            add_element_to_int_list(&global_geometry_list.elements[loop_index].Volume->geometry.masked_by_list,INDEX_CURRENT_COMP);
            global_geometry_list.elements[loop_index].Volume->geometry.is_masked_volume = 1;
            if (this_box_volume.geometry.mask_mode == 2)
                global_geometry_list.elements[loop_index].Volume->geometry.mask_mode = 2;
            if (this_box_volume.geometry.mask_mode == 1) {
                if (global_geometry_list.elements[loop_index].Volume->geometry.is_masked_volume == 1 && global_geometry_list.elements[loop_index].Volume->geometry.mask_mode != 2)
                    // If more than one mask is added to one volume, the ANY mode overwrites the (default) ALL mode.
                    global_geometry_list.elements[loop_index].Volume->geometry.mask_mode = 1;
            }
            
            found_geometries = 1;
        }
    }
    if (found_geometries == 0) {
        printf("The mask_string in geometry: %s did not find any of the specified volumes in the mask_string %s \n",NAME_CURRENT_COMP,mask_string);
        exit(1);
    }
    this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
    this_box_volume.p_physics->is_vacuum = 0; // Makes this volume a vacuum
    this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
    this_box_volume.p_physics->my_a = 0; // Should not be used.
    sprintf(this_box_volume.p_physics->name,"Mask");
    this_box_volume.geometry.is_mask_volume = 1;
    
    
// Read the material input, or if it lacks, use automatic linking.
} else if (material_string && strlen(material_string) && strcmp(material_string, "NULL") && strcmp(material_string, "0")) {
    // A geometry string was given, use it to determine which material
    if (0 == strcmp(material_string,"vacuum") || 0 == strcmp(material_string,"Vacuum")) {
        // One could have a global physics struct for vacuum instead of creating one for each
        this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
        this_box_volume.p_physics->is_vacuum = 1; // Makes this volume a vacuum
        this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
        this_box_volume.p_physics->my_a = 0; // Should not be used.
        sprintf(this_box_volume.p_physics->name,"Vacuum");
    } else if (0 == strcmp(material_string,"exit") || 0 == strcmp(material_string,"Exit")) {
        // One could have a global physics struct for vacuum instead of creating one for each
        this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
        this_box_volume.p_physics->is_vacuum = 1; // Makes this volume a vacuum
        this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
        this_box_volume.p_physics->my_a = 0; // Should not be used.
        this_box_volume.geometry.is_exit_volume = 1;
        sprintf(this_box_volume.p_physics->name,"Exit");
    } else {
        #ifndef MATERIAL_DETECTOR
            printf("Need to define a material before refering to it in a geometry %s.\n",NAME_CURRENT_COMP);
            exit(1);
        #endif
        for (loop_index=0;loop_index<global_material_list.num_elements;loop_index++) {
            if (0 == strcmp(material_string,global_material_list.elements[loop_index].name)) {
                this_box_volume.p_physics = global_material_list.elements[loop_index].physics;
                break;
            }
            if (loop_index == global_material_list.num_elements-1) {
            printf("\n");
            printf("ERROR: The material string \"%s\" in Union geometry \"%s\" did not match a specified material. \n",material_string,NAME_CURRENT_COMP);
            printf("       The materials available at this point (need to be defined before the geometry): \n");
            for (loop_index=0;loop_index<global_material_list.num_elements;loop_index++)
              printf("         %s\n",global_material_list.elements[loop_index].name);
            printf("\n");
            printf("       It is also possible to use one of the defualt materials avaiable: \n");
            printf("           Vacuum (for a Volume without scattering or absorption)\n");
            printf("           Exit (for a Volume where the ray exits the component if it enters)\n");
            printf("           Mask (for a Volume that masks existing volumes specified in the mask_string\n");
            exit(1);
          }
        }
    }
} else {
    // Automatic linking, simply using the last defined material.
    #ifndef MATERIAL_DETECTOR
        printf("Need to define a material before the geometry to use automatic linking %s.\n",NAME_CURRENT_COMP);
        exit(1);
    #endif
    this_box_volume.p_physics = global_material_list.elements[global_material_list.num_elements-1].physics;
}

sprintf(this_box_volume.name,NAME_CURRENT_COMP);
sprintf(this_box_volume.geometry.shape,"box");
this_box_volume.geometry.priority_value = priority;
this_box_volume.geometry.geometry_p_interact = p_interact;
// Currently the coordinates will be in absolute space.
this_box_volume.geometry.center = POS_A_CURRENT_COMP;

this_box_storage.z_depth = zdepth;
this_box_storage.x_width1 = xwidth;
this_box_storage.y_height1 = yheight;

this_box_storage.is_rectangle = 0;
if (xwidth2 < 0 && yheight2 < 0) this_box_storage.is_rectangle = 1;
if (xwidth == xwidth2 && yheight == yheight2) this_box_storage.is_rectangle = 1;

if (xwidth2 < 0) {
    this_box_storage.x_width2 = xwidth;
    xwidth2 = xwidth;
} else this_box_storage.x_width2 = xwidth2;

if (yheight2 < 0) {
    this_box_storage.y_height2 = yheight;
    yheight2 = yheight;
} else this_box_storage.y_height2 = yheight2;


this_box_storage.normal_vectors[0] = coords_set(0,0,1);
this_box_storage.normal_vectors[1] = coords_set(0,0,1);

// for sides with y component = 0
x_component = 2*zdepth/sqrt((xwidth-xwidth2)*(xwidth-xwidth2)+4*zdepth*zdepth);
z_component = (xwidth-xwidth2)/sqrt(4*zdepth*zdepth+(xwidth-xwidth2)*(xwidth-xwidth2));

this_box_storage.normal_vectors[2] = coords_set(x_component,0,z_component);
this_box_storage.normal_vectors[3] = coords_set(-x_component,0,z_component);

// for sides with x component = 0
y_component = 2*zdepth/sqrt((yheight-yheight2)*(yheight-yheight2)+4*zdepth*zdepth);
z_component = (yheight-yheight2)/sqrt(4*zdepth*zdepth+(yheight-yheight2)*(yheight-yheight2));

this_box_storage.normal_vectors[4] = coords_set(0,y_component,z_component);
this_box_storage.normal_vectors[5] = coords_set(0,-y_component,z_component);

this_box_volume.geometry.visualization_on = visualize;

this_box_volume.geometry.geometry_parameters.p_box_storage = &this_box_storage;

// Assign pointers to functions for intersection with the shape, checking if a point is inside the shape
if (this_box_storage.is_rectangle == 1) {
this_box_volume.geometry.intersect_function = &sample_box_intersect_simple;
this_box_volume.geometry.within_function = &r_within_box_simple;
}
else {
this_box_volume.geometry.intersect_function = &sample_box_intersect_advanced;
this_box_volume.geometry.within_function = &r_within_box_advanced;
}

this_box_volume.geometry.shell_points = &box_shell_points;
this_box_volume.geometry.mcdisplay_function = &mcdisplay_box_function;
this_box_volume.geometry.initialize_from_main_function = &initialize_box_geometry_from_main_component;
this_box_volume.geometry.process_rot_allocated = 0;

this_box_volume.geometry.copy_geometry_parameters = &allocate_box_storage_copy;

rot_copy(this_box_volume.geometry.rotation_matrix,ROT_A_CURRENT_COMP); //check how ROT_R_CURRENT_COMP would work
rot_transpose(ROT_A_CURRENT_COMP,this_box_volume.geometry.transpose_rotation_matrix);

// Initialize loggers
this_box_volume.loggers.num_elements = 0;

// packing the information into the global_geometry_element, which is then included in the global_geometry_list.
sprintf(global_geometry_element.name,NAME_CURRENT_COMP);
global_geometry_element.activation_counter = number_of_activations;
global_geometry_element.component_index = INDEX_CURRENT_COMP;
global_geometry_element.Volume = &this_box_volume; // Would be nicer if this m was a pointer, now we have the (small) data two places
add_element_to_geometry_list(&global_geometry_list,global_geometry_element);
}
#line 251774 "MACS_sample_kidney_box.c"
#undef number_of_activations
#undef mask_setting
#undef mask_string
#undef p_interact
#undef focus_r
#undef focus_xh
#undef focus_xw
#undef focus_ah
#undef focus_aw
#undef target_z
#undef target_y
#undef target_x
#undef target_index
#undef visualize
#undef yheight2
#undef xwidth2
#undef zdepth
#undef yheight
#undef xwidth
#undef priority
#undef material_string
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

  /* Initializations for component inter_analyzer_colimator_9_blade_4. */
  SIG_MESSAGE("inter_analyzer_colimator_9_blade_4 (Init)");
#define mccompcurname  inter_analyzer_colimator_9_blade_4
#define mccompcurtype  Union_box
#define mccompcurindex 501
#define loop_index mccinter_analyzer_colimator_9_blade_4_loop_index
#define this_box_volume mccinter_analyzer_colimator_9_blade_4_this_box_volume
#define global_geometry_element mccinter_analyzer_colimator_9_blade_4_global_geometry_element
#define this_box_storage mccinter_analyzer_colimator_9_blade_4_this_box_storage
#define material_string mccinter_analyzer_colimator_9_blade_4_material_string
#define priority mccinter_analyzer_colimator_9_blade_4_priority
#define xwidth mccinter_analyzer_colimator_9_blade_4_xwidth
#define yheight mccinter_analyzer_colimator_9_blade_4_yheight
#define zdepth mccinter_analyzer_colimator_9_blade_4_zdepth
#define xwidth2 mccinter_analyzer_colimator_9_blade_4_xwidth2
#define yheight2 mccinter_analyzer_colimator_9_blade_4_yheight2
#define visualize mccinter_analyzer_colimator_9_blade_4_visualize
#define target_index mccinter_analyzer_colimator_9_blade_4_target_index
#define target_x mccinter_analyzer_colimator_9_blade_4_target_x
#define target_y mccinter_analyzer_colimator_9_blade_4_target_y
#define target_z mccinter_analyzer_colimator_9_blade_4_target_z
#define focus_aw mccinter_analyzer_colimator_9_blade_4_focus_aw
#define focus_ah mccinter_analyzer_colimator_9_blade_4_focus_ah
#define focus_xw mccinter_analyzer_colimator_9_blade_4_focus_xw
#define focus_xh mccinter_analyzer_colimator_9_blade_4_focus_xh
#define focus_r mccinter_analyzer_colimator_9_blade_4_focus_r
#define p_interact mccinter_analyzer_colimator_9_blade_4_p_interact
#define mask_string mccinter_analyzer_colimator_9_blade_4_mask_string
#define mask_setting mccinter_analyzer_colimator_9_blade_4_mask_setting
#define number_of_activations mccinter_analyzer_colimator_9_blade_4_number_of_activations
#line 224 "Union_box.comp"
{
// Initializes the focusing system for this volume including input sanitation.
focus_initialize(&this_box_volume.geometry, POS_A_COMP_INDEX(INDEX_CURRENT_COMP+target_index), POS_A_CURRENT_COMP, ROT_A_CURRENT_COMP, target_index, target_x, target_y, target_z, focus_aw, focus_ah, focus_xw, focus_xh, focus_r, NAME_CURRENT_COMP);

// Input sanitation for this geometry
if (xwidth <= 0) {
  printf("\nERROR in Union_box named %s, the xwidth is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (yheight <= 0) {
  printf("\nERROR in Union_box named %s, yheight is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (zdepth <= 0) {
  printf("\nERROR in Union_box named %s, zdepth is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (xwidth2 <= 0 && xwidth2 != -1) {
  printf("\nERROR in Union_box named %s, the xwidth2 is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (yheight2 <= 0 && yheight2 != -1) {
  printf("\nERROR in Union_box named %s, yheight2 is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}

// Use sanitation
if (global_material_list.num_elements == 0) {
  printf("\nERROR: Need to define a material using Union_make_material before using a Union geometry component. \n");
  printf("       %s was defined before first use of Union_make_material.\n",NAME_CURRENT_COMP);
  exit(1);
}

this_box_volume.geometry.is_masked_volume = 0;
this_box_volume.geometry.is_exit_volume = 0;
this_box_volume.geometry.is_mask_volume = 0;
// check if the volume is a mask, if it is the material string is irelevant.
if (mask_string && strlen(mask_string) && strcmp(mask_string, "NULL") && strcmp(mask_string, "0")) {
    // A mask volume is used to limit the extend of other volumes, called the masked volumes. These are specified in the mask_string.
    // In order for a ray to enter a masked volume, it needs to be both in the region covered by that volume AND the mask volume.
    // When more than
    this_box_volume.geometry.mask_mode = 1; // Default is mask mode is ALL
    if (mask_setting && strlen(mask_setting) && strcmp(mask_setting, "NULL") && strcmp(mask_setting, "0")) {
        if (strcmp(mask_setting,"ALL") == 0 || strcmp(mask_setting,"All") == 0) this_box_volume.geometry.mask_mode = 1;
        else if (strcmp(mask_setting,"ANY") == 0 || strcmp(mask_setting,"Any") == 0) this_box_volume.geometry.mask_mode = 2;
        else {
            printf("The mask_mode of component %s is set to %s, but must be either ALL or ANY.\n",NAME_CURRENT_COMP,mask_setting);
            exit(1);
        }
    }
    
    for (loop_index=0;loop_index<global_geometry_list.num_elements;loop_index++) {
        // Add mask list
        if (1 == manual_linking_function(global_geometry_list.elements[loop_index].name,mask_string)) {
            add_element_to_int_list(&this_box_volume.geometry.mask_list,global_geometry_list.elements[loop_index].component_index);
            add_element_to_int_list(&global_geometry_list.elements[loop_index].Volume->geometry.masked_by_list,INDEX_CURRENT_COMP);
            global_geometry_list.elements[loop_index].Volume->geometry.is_masked_volume = 1;
            if (this_box_volume.geometry.mask_mode == 2)
                global_geometry_list.elements[loop_index].Volume->geometry.mask_mode = 2;
            if (this_box_volume.geometry.mask_mode == 1) {
                if (global_geometry_list.elements[loop_index].Volume->geometry.is_masked_volume == 1 && global_geometry_list.elements[loop_index].Volume->geometry.mask_mode != 2)
                    // If more than one mask is added to one volume, the ANY mode overwrites the (default) ALL mode.
                    global_geometry_list.elements[loop_index].Volume->geometry.mask_mode = 1;
            }
            
            found_geometries = 1;
        }
    }
    if (found_geometries == 0) {
        printf("The mask_string in geometry: %s did not find any of the specified volumes in the mask_string %s \n",NAME_CURRENT_COMP,mask_string);
        exit(1);
    }
    this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
    this_box_volume.p_physics->is_vacuum = 0; // Makes this volume a vacuum
    this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
    this_box_volume.p_physics->my_a = 0; // Should not be used.
    sprintf(this_box_volume.p_physics->name,"Mask");
    this_box_volume.geometry.is_mask_volume = 1;
    
    
// Read the material input, or if it lacks, use automatic linking.
} else if (material_string && strlen(material_string) && strcmp(material_string, "NULL") && strcmp(material_string, "0")) {
    // A geometry string was given, use it to determine which material
    if (0 == strcmp(material_string,"vacuum") || 0 == strcmp(material_string,"Vacuum")) {
        // One could have a global physics struct for vacuum instead of creating one for each
        this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
        this_box_volume.p_physics->is_vacuum = 1; // Makes this volume a vacuum
        this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
        this_box_volume.p_physics->my_a = 0; // Should not be used.
        sprintf(this_box_volume.p_physics->name,"Vacuum");
    } else if (0 == strcmp(material_string,"exit") || 0 == strcmp(material_string,"Exit")) {
        // One could have a global physics struct for vacuum instead of creating one for each
        this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
        this_box_volume.p_physics->is_vacuum = 1; // Makes this volume a vacuum
        this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
        this_box_volume.p_physics->my_a = 0; // Should not be used.
        this_box_volume.geometry.is_exit_volume = 1;
        sprintf(this_box_volume.p_physics->name,"Exit");
    } else {
        #ifndef MATERIAL_DETECTOR
            printf("Need to define a material before refering to it in a geometry %s.\n",NAME_CURRENT_COMP);
            exit(1);
        #endif
        for (loop_index=0;loop_index<global_material_list.num_elements;loop_index++) {
            if (0 == strcmp(material_string,global_material_list.elements[loop_index].name)) {
                this_box_volume.p_physics = global_material_list.elements[loop_index].physics;
                break;
            }
            if (loop_index == global_material_list.num_elements-1) {
            printf("\n");
            printf("ERROR: The material string \"%s\" in Union geometry \"%s\" did not match a specified material. \n",material_string,NAME_CURRENT_COMP);
            printf("       The materials available at this point (need to be defined before the geometry): \n");
            for (loop_index=0;loop_index<global_material_list.num_elements;loop_index++)
              printf("         %s\n",global_material_list.elements[loop_index].name);
            printf("\n");
            printf("       It is also possible to use one of the defualt materials avaiable: \n");
            printf("           Vacuum (for a Volume without scattering or absorption)\n");
            printf("           Exit (for a Volume where the ray exits the component if it enters)\n");
            printf("           Mask (for a Volume that masks existing volumes specified in the mask_string\n");
            exit(1);
          }
        }
    }
} else {
    // Automatic linking, simply using the last defined material.
    #ifndef MATERIAL_DETECTOR
        printf("Need to define a material before the geometry to use automatic linking %s.\n",NAME_CURRENT_COMP);
        exit(1);
    #endif
    this_box_volume.p_physics = global_material_list.elements[global_material_list.num_elements-1].physics;
}

sprintf(this_box_volume.name,NAME_CURRENT_COMP);
sprintf(this_box_volume.geometry.shape,"box");
this_box_volume.geometry.priority_value = priority;
this_box_volume.geometry.geometry_p_interact = p_interact;
// Currently the coordinates will be in absolute space.
this_box_volume.geometry.center = POS_A_CURRENT_COMP;

this_box_storage.z_depth = zdepth;
this_box_storage.x_width1 = xwidth;
this_box_storage.y_height1 = yheight;

this_box_storage.is_rectangle = 0;
if (xwidth2 < 0 && yheight2 < 0) this_box_storage.is_rectangle = 1;
if (xwidth == xwidth2 && yheight == yheight2) this_box_storage.is_rectangle = 1;

if (xwidth2 < 0) {
    this_box_storage.x_width2 = xwidth;
    xwidth2 = xwidth;
} else this_box_storage.x_width2 = xwidth2;

if (yheight2 < 0) {
    this_box_storage.y_height2 = yheight;
    yheight2 = yheight;
} else this_box_storage.y_height2 = yheight2;


this_box_storage.normal_vectors[0] = coords_set(0,0,1);
this_box_storage.normal_vectors[1] = coords_set(0,0,1);

// for sides with y component = 0
x_component = 2*zdepth/sqrt((xwidth-xwidth2)*(xwidth-xwidth2)+4*zdepth*zdepth);
z_component = (xwidth-xwidth2)/sqrt(4*zdepth*zdepth+(xwidth-xwidth2)*(xwidth-xwidth2));

this_box_storage.normal_vectors[2] = coords_set(x_component,0,z_component);
this_box_storage.normal_vectors[3] = coords_set(-x_component,0,z_component);

// for sides with x component = 0
y_component = 2*zdepth/sqrt((yheight-yheight2)*(yheight-yheight2)+4*zdepth*zdepth);
z_component = (yheight-yheight2)/sqrt(4*zdepth*zdepth+(yheight-yheight2)*(yheight-yheight2));

this_box_storage.normal_vectors[4] = coords_set(0,y_component,z_component);
this_box_storage.normal_vectors[5] = coords_set(0,-y_component,z_component);

this_box_volume.geometry.visualization_on = visualize;

this_box_volume.geometry.geometry_parameters.p_box_storage = &this_box_storage;

// Assign pointers to functions for intersection with the shape, checking if a point is inside the shape
if (this_box_storage.is_rectangle == 1) {
this_box_volume.geometry.intersect_function = &sample_box_intersect_simple;
this_box_volume.geometry.within_function = &r_within_box_simple;
}
else {
this_box_volume.geometry.intersect_function = &sample_box_intersect_advanced;
this_box_volume.geometry.within_function = &r_within_box_advanced;
}

this_box_volume.geometry.shell_points = &box_shell_points;
this_box_volume.geometry.mcdisplay_function = &mcdisplay_box_function;
this_box_volume.geometry.initialize_from_main_function = &initialize_box_geometry_from_main_component;
this_box_volume.geometry.process_rot_allocated = 0;

this_box_volume.geometry.copy_geometry_parameters = &allocate_box_storage_copy;

rot_copy(this_box_volume.geometry.rotation_matrix,ROT_A_CURRENT_COMP); //check how ROT_R_CURRENT_COMP would work
rot_transpose(ROT_A_CURRENT_COMP,this_box_volume.geometry.transpose_rotation_matrix);

// Initialize loggers
this_box_volume.loggers.num_elements = 0;

// packing the information into the global_geometry_element, which is then included in the global_geometry_list.
sprintf(global_geometry_element.name,NAME_CURRENT_COMP);
global_geometry_element.activation_counter = number_of_activations;
global_geometry_element.component_index = INDEX_CURRENT_COMP;
global_geometry_element.Volume = &this_box_volume; // Would be nicer if this m was a pointer, now we have the (small) data two places
add_element_to_geometry_list(&global_geometry_list,global_geometry_element);
}
#line 252044 "MACS_sample_kidney_box.c"
#undef number_of_activations
#undef mask_setting
#undef mask_string
#undef p_interact
#undef focus_r
#undef focus_xh
#undef focus_xw
#undef focus_ah
#undef focus_aw
#undef target_z
#undef target_y
#undef target_x
#undef target_index
#undef visualize
#undef yheight2
#undef xwidth2
#undef zdepth
#undef yheight
#undef xwidth
#undef priority
#undef material_string
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

  /* Initializations for component diffraction_detector_9_exit_volume. */
  SIG_MESSAGE("diffraction_detector_9_exit_volume (Init)");
#define mccompcurname  diffraction_detector_9_exit_volume
#define mccompcurtype  Union_box
#define mccompcurindex 502
#define loop_index mccdiffraction_detector_9_exit_volume_loop_index
#define this_box_volume mccdiffraction_detector_9_exit_volume_this_box_volume
#define global_geometry_element mccdiffraction_detector_9_exit_volume_global_geometry_element
#define this_box_storage mccdiffraction_detector_9_exit_volume_this_box_storage
#define material_string mccdiffraction_detector_9_exit_volume_material_string
#define priority mccdiffraction_detector_9_exit_volume_priority
#define xwidth mccdiffraction_detector_9_exit_volume_xwidth
#define yheight mccdiffraction_detector_9_exit_volume_yheight
#define zdepth mccdiffraction_detector_9_exit_volume_zdepth
#define xwidth2 mccdiffraction_detector_9_exit_volume_xwidth2
#define yheight2 mccdiffraction_detector_9_exit_volume_yheight2
#define visualize mccdiffraction_detector_9_exit_volume_visualize
#define target_index mccdiffraction_detector_9_exit_volume_target_index
#define target_x mccdiffraction_detector_9_exit_volume_target_x
#define target_y mccdiffraction_detector_9_exit_volume_target_y
#define target_z mccdiffraction_detector_9_exit_volume_target_z
#define focus_aw mccdiffraction_detector_9_exit_volume_focus_aw
#define focus_ah mccdiffraction_detector_9_exit_volume_focus_ah
#define focus_xw mccdiffraction_detector_9_exit_volume_focus_xw
#define focus_xh mccdiffraction_detector_9_exit_volume_focus_xh
#define focus_r mccdiffraction_detector_9_exit_volume_focus_r
#define p_interact mccdiffraction_detector_9_exit_volume_p_interact
#define mask_string mccdiffraction_detector_9_exit_volume_mask_string
#define mask_setting mccdiffraction_detector_9_exit_volume_mask_setting
#define number_of_activations mccdiffraction_detector_9_exit_volume_number_of_activations
#line 224 "Union_box.comp"
{
// Initializes the focusing system for this volume including input sanitation.
focus_initialize(&this_box_volume.geometry, POS_A_COMP_INDEX(INDEX_CURRENT_COMP+target_index), POS_A_CURRENT_COMP, ROT_A_CURRENT_COMP, target_index, target_x, target_y, target_z, focus_aw, focus_ah, focus_xw, focus_xh, focus_r, NAME_CURRENT_COMP);

// Input sanitation for this geometry
if (xwidth <= 0) {
  printf("\nERROR in Union_box named %s, the xwidth is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (yheight <= 0) {
  printf("\nERROR in Union_box named %s, yheight is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (zdepth <= 0) {
  printf("\nERROR in Union_box named %s, zdepth is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (xwidth2 <= 0 && xwidth2 != -1) {
  printf("\nERROR in Union_box named %s, the xwidth2 is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (yheight2 <= 0 && yheight2 != -1) {
  printf("\nERROR in Union_box named %s, yheight2 is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}

// Use sanitation
if (global_material_list.num_elements == 0) {
  printf("\nERROR: Need to define a material using Union_make_material before using a Union geometry component. \n");
  printf("       %s was defined before first use of Union_make_material.\n",NAME_CURRENT_COMP);
  exit(1);
}

this_box_volume.geometry.is_masked_volume = 0;
this_box_volume.geometry.is_exit_volume = 0;
this_box_volume.geometry.is_mask_volume = 0;
// check if the volume is a mask, if it is the material string is irelevant.
if (mask_string && strlen(mask_string) && strcmp(mask_string, "NULL") && strcmp(mask_string, "0")) {
    // A mask volume is used to limit the extend of other volumes, called the masked volumes. These are specified in the mask_string.
    // In order for a ray to enter a masked volume, it needs to be both in the region covered by that volume AND the mask volume.
    // When more than
    this_box_volume.geometry.mask_mode = 1; // Default is mask mode is ALL
    if (mask_setting && strlen(mask_setting) && strcmp(mask_setting, "NULL") && strcmp(mask_setting, "0")) {
        if (strcmp(mask_setting,"ALL") == 0 || strcmp(mask_setting,"All") == 0) this_box_volume.geometry.mask_mode = 1;
        else if (strcmp(mask_setting,"ANY") == 0 || strcmp(mask_setting,"Any") == 0) this_box_volume.geometry.mask_mode = 2;
        else {
            printf("The mask_mode of component %s is set to %s, but must be either ALL or ANY.\n",NAME_CURRENT_COMP,mask_setting);
            exit(1);
        }
    }
    
    for (loop_index=0;loop_index<global_geometry_list.num_elements;loop_index++) {
        // Add mask list
        if (1 == manual_linking_function(global_geometry_list.elements[loop_index].name,mask_string)) {
            add_element_to_int_list(&this_box_volume.geometry.mask_list,global_geometry_list.elements[loop_index].component_index);
            add_element_to_int_list(&global_geometry_list.elements[loop_index].Volume->geometry.masked_by_list,INDEX_CURRENT_COMP);
            global_geometry_list.elements[loop_index].Volume->geometry.is_masked_volume = 1;
            if (this_box_volume.geometry.mask_mode == 2)
                global_geometry_list.elements[loop_index].Volume->geometry.mask_mode = 2;
            if (this_box_volume.geometry.mask_mode == 1) {
                if (global_geometry_list.elements[loop_index].Volume->geometry.is_masked_volume == 1 && global_geometry_list.elements[loop_index].Volume->geometry.mask_mode != 2)
                    // If more than one mask is added to one volume, the ANY mode overwrites the (default) ALL mode.
                    global_geometry_list.elements[loop_index].Volume->geometry.mask_mode = 1;
            }
            
            found_geometries = 1;
        }
    }
    if (found_geometries == 0) {
        printf("The mask_string in geometry: %s did not find any of the specified volumes in the mask_string %s \n",NAME_CURRENT_COMP,mask_string);
        exit(1);
    }
    this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
    this_box_volume.p_physics->is_vacuum = 0; // Makes this volume a vacuum
    this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
    this_box_volume.p_physics->my_a = 0; // Should not be used.
    sprintf(this_box_volume.p_physics->name,"Mask");
    this_box_volume.geometry.is_mask_volume = 1;
    
    
// Read the material input, or if it lacks, use automatic linking.
} else if (material_string && strlen(material_string) && strcmp(material_string, "NULL") && strcmp(material_string, "0")) {
    // A geometry string was given, use it to determine which material
    if (0 == strcmp(material_string,"vacuum") || 0 == strcmp(material_string,"Vacuum")) {
        // One could have a global physics struct for vacuum instead of creating one for each
        this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
        this_box_volume.p_physics->is_vacuum = 1; // Makes this volume a vacuum
        this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
        this_box_volume.p_physics->my_a = 0; // Should not be used.
        sprintf(this_box_volume.p_physics->name,"Vacuum");
    } else if (0 == strcmp(material_string,"exit") || 0 == strcmp(material_string,"Exit")) {
        // One could have a global physics struct for vacuum instead of creating one for each
        this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
        this_box_volume.p_physics->is_vacuum = 1; // Makes this volume a vacuum
        this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
        this_box_volume.p_physics->my_a = 0; // Should not be used.
        this_box_volume.geometry.is_exit_volume = 1;
        sprintf(this_box_volume.p_physics->name,"Exit");
    } else {
        #ifndef MATERIAL_DETECTOR
            printf("Need to define a material before refering to it in a geometry %s.\n",NAME_CURRENT_COMP);
            exit(1);
        #endif
        for (loop_index=0;loop_index<global_material_list.num_elements;loop_index++) {
            if (0 == strcmp(material_string,global_material_list.elements[loop_index].name)) {
                this_box_volume.p_physics = global_material_list.elements[loop_index].physics;
                break;
            }
            if (loop_index == global_material_list.num_elements-1) {
            printf("\n");
            printf("ERROR: The material string \"%s\" in Union geometry \"%s\" did not match a specified material. \n",material_string,NAME_CURRENT_COMP);
            printf("       The materials available at this point (need to be defined before the geometry): \n");
            for (loop_index=0;loop_index<global_material_list.num_elements;loop_index++)
              printf("         %s\n",global_material_list.elements[loop_index].name);
            printf("\n");
            printf("       It is also possible to use one of the defualt materials avaiable: \n");
            printf("           Vacuum (for a Volume without scattering or absorption)\n");
            printf("           Exit (for a Volume where the ray exits the component if it enters)\n");
            printf("           Mask (for a Volume that masks existing volumes specified in the mask_string\n");
            exit(1);
          }
        }
    }
} else {
    // Automatic linking, simply using the last defined material.
    #ifndef MATERIAL_DETECTOR
        printf("Need to define a material before the geometry to use automatic linking %s.\n",NAME_CURRENT_COMP);
        exit(1);
    #endif
    this_box_volume.p_physics = global_material_list.elements[global_material_list.num_elements-1].physics;
}

sprintf(this_box_volume.name,NAME_CURRENT_COMP);
sprintf(this_box_volume.geometry.shape,"box");
this_box_volume.geometry.priority_value = priority;
this_box_volume.geometry.geometry_p_interact = p_interact;
// Currently the coordinates will be in absolute space.
this_box_volume.geometry.center = POS_A_CURRENT_COMP;

this_box_storage.z_depth = zdepth;
this_box_storage.x_width1 = xwidth;
this_box_storage.y_height1 = yheight;

this_box_storage.is_rectangle = 0;
if (xwidth2 < 0 && yheight2 < 0) this_box_storage.is_rectangle = 1;
if (xwidth == xwidth2 && yheight == yheight2) this_box_storage.is_rectangle = 1;

if (xwidth2 < 0) {
    this_box_storage.x_width2 = xwidth;
    xwidth2 = xwidth;
} else this_box_storage.x_width2 = xwidth2;

if (yheight2 < 0) {
    this_box_storage.y_height2 = yheight;
    yheight2 = yheight;
} else this_box_storage.y_height2 = yheight2;


this_box_storage.normal_vectors[0] = coords_set(0,0,1);
this_box_storage.normal_vectors[1] = coords_set(0,0,1);

// for sides with y component = 0
x_component = 2*zdepth/sqrt((xwidth-xwidth2)*(xwidth-xwidth2)+4*zdepth*zdepth);
z_component = (xwidth-xwidth2)/sqrt(4*zdepth*zdepth+(xwidth-xwidth2)*(xwidth-xwidth2));

this_box_storage.normal_vectors[2] = coords_set(x_component,0,z_component);
this_box_storage.normal_vectors[3] = coords_set(-x_component,0,z_component);

// for sides with x component = 0
y_component = 2*zdepth/sqrt((yheight-yheight2)*(yheight-yheight2)+4*zdepth*zdepth);
z_component = (yheight-yheight2)/sqrt(4*zdepth*zdepth+(yheight-yheight2)*(yheight-yheight2));

this_box_storage.normal_vectors[4] = coords_set(0,y_component,z_component);
this_box_storage.normal_vectors[5] = coords_set(0,-y_component,z_component);

this_box_volume.geometry.visualization_on = visualize;

this_box_volume.geometry.geometry_parameters.p_box_storage = &this_box_storage;

// Assign pointers to functions for intersection with the shape, checking if a point is inside the shape
if (this_box_storage.is_rectangle == 1) {
this_box_volume.geometry.intersect_function = &sample_box_intersect_simple;
this_box_volume.geometry.within_function = &r_within_box_simple;
}
else {
this_box_volume.geometry.intersect_function = &sample_box_intersect_advanced;
this_box_volume.geometry.within_function = &r_within_box_advanced;
}

this_box_volume.geometry.shell_points = &box_shell_points;
this_box_volume.geometry.mcdisplay_function = &mcdisplay_box_function;
this_box_volume.geometry.initialize_from_main_function = &initialize_box_geometry_from_main_component;
this_box_volume.geometry.process_rot_allocated = 0;

this_box_volume.geometry.copy_geometry_parameters = &allocate_box_storage_copy;

rot_copy(this_box_volume.geometry.rotation_matrix,ROT_A_CURRENT_COMP); //check how ROT_R_CURRENT_COMP would work
rot_transpose(ROT_A_CURRENT_COMP,this_box_volume.geometry.transpose_rotation_matrix);

// Initialize loggers
this_box_volume.loggers.num_elements = 0;

// packing the information into the global_geometry_element, which is then included in the global_geometry_list.
sprintf(global_geometry_element.name,NAME_CURRENT_COMP);
global_geometry_element.activation_counter = number_of_activations;
global_geometry_element.component_index = INDEX_CURRENT_COMP;
global_geometry_element.Volume = &this_box_volume; // Would be nicer if this m was a pointer, now we have the (small) data two places
add_element_to_geometry_list(&global_geometry_list,global_geometry_element);
}
#line 252314 "MACS_sample_kidney_box.c"
#undef number_of_activations
#undef mask_setting
#undef mask_string
#undef p_interact
#undef focus_r
#undef focus_xh
#undef focus_xw
#undef focus_ah
#undef focus_aw
#undef target_z
#undef target_y
#undef target_x
#undef target_index
#undef visualize
#undef yheight2
#undef xwidth2
#undef zdepth
#undef yheight
#undef xwidth
#undef priority
#undef material_string
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

  /* Initializations for component spec_detector_9_exit_volume. */
  SIG_MESSAGE("spec_detector_9_exit_volume (Init)");
#define mccompcurname  spec_detector_9_exit_volume
#define mccompcurtype  Union_box
#define mccompcurindex 503
#define loop_index mccspec_detector_9_exit_volume_loop_index
#define this_box_volume mccspec_detector_9_exit_volume_this_box_volume
#define global_geometry_element mccspec_detector_9_exit_volume_global_geometry_element
#define this_box_storage mccspec_detector_9_exit_volume_this_box_storage
#define material_string mccspec_detector_9_exit_volume_material_string
#define priority mccspec_detector_9_exit_volume_priority
#define xwidth mccspec_detector_9_exit_volume_xwidth
#define yheight mccspec_detector_9_exit_volume_yheight
#define zdepth mccspec_detector_9_exit_volume_zdepth
#define xwidth2 mccspec_detector_9_exit_volume_xwidth2
#define yheight2 mccspec_detector_9_exit_volume_yheight2
#define visualize mccspec_detector_9_exit_volume_visualize
#define target_index mccspec_detector_9_exit_volume_target_index
#define target_x mccspec_detector_9_exit_volume_target_x
#define target_y mccspec_detector_9_exit_volume_target_y
#define target_z mccspec_detector_9_exit_volume_target_z
#define focus_aw mccspec_detector_9_exit_volume_focus_aw
#define focus_ah mccspec_detector_9_exit_volume_focus_ah
#define focus_xw mccspec_detector_9_exit_volume_focus_xw
#define focus_xh mccspec_detector_9_exit_volume_focus_xh
#define focus_r mccspec_detector_9_exit_volume_focus_r
#define p_interact mccspec_detector_9_exit_volume_p_interact
#define mask_string mccspec_detector_9_exit_volume_mask_string
#define mask_setting mccspec_detector_9_exit_volume_mask_setting
#define number_of_activations mccspec_detector_9_exit_volume_number_of_activations
#line 224 "Union_box.comp"
{
// Initializes the focusing system for this volume including input sanitation.
focus_initialize(&this_box_volume.geometry, POS_A_COMP_INDEX(INDEX_CURRENT_COMP+target_index), POS_A_CURRENT_COMP, ROT_A_CURRENT_COMP, target_index, target_x, target_y, target_z, focus_aw, focus_ah, focus_xw, focus_xh, focus_r, NAME_CURRENT_COMP);

// Input sanitation for this geometry
if (xwidth <= 0) {
  printf("\nERROR in Union_box named %s, the xwidth is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (yheight <= 0) {
  printf("\nERROR in Union_box named %s, yheight is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (zdepth <= 0) {
  printf("\nERROR in Union_box named %s, zdepth is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (xwidth2 <= 0 && xwidth2 != -1) {
  printf("\nERROR in Union_box named %s, the xwidth2 is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (yheight2 <= 0 && yheight2 != -1) {
  printf("\nERROR in Union_box named %s, yheight2 is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}

// Use sanitation
if (global_material_list.num_elements == 0) {
  printf("\nERROR: Need to define a material using Union_make_material before using a Union geometry component. \n");
  printf("       %s was defined before first use of Union_make_material.\n",NAME_CURRENT_COMP);
  exit(1);
}

this_box_volume.geometry.is_masked_volume = 0;
this_box_volume.geometry.is_exit_volume = 0;
this_box_volume.geometry.is_mask_volume = 0;
// check if the volume is a mask, if it is the material string is irelevant.
if (mask_string && strlen(mask_string) && strcmp(mask_string, "NULL") && strcmp(mask_string, "0")) {
    // A mask volume is used to limit the extend of other volumes, called the masked volumes. These are specified in the mask_string.
    // In order for a ray to enter a masked volume, it needs to be both in the region covered by that volume AND the mask volume.
    // When more than
    this_box_volume.geometry.mask_mode = 1; // Default is mask mode is ALL
    if (mask_setting && strlen(mask_setting) && strcmp(mask_setting, "NULL") && strcmp(mask_setting, "0")) {
        if (strcmp(mask_setting,"ALL") == 0 || strcmp(mask_setting,"All") == 0) this_box_volume.geometry.mask_mode = 1;
        else if (strcmp(mask_setting,"ANY") == 0 || strcmp(mask_setting,"Any") == 0) this_box_volume.geometry.mask_mode = 2;
        else {
            printf("The mask_mode of component %s is set to %s, but must be either ALL or ANY.\n",NAME_CURRENT_COMP,mask_setting);
            exit(1);
        }
    }
    
    for (loop_index=0;loop_index<global_geometry_list.num_elements;loop_index++) {
        // Add mask list
        if (1 == manual_linking_function(global_geometry_list.elements[loop_index].name,mask_string)) {
            add_element_to_int_list(&this_box_volume.geometry.mask_list,global_geometry_list.elements[loop_index].component_index);
            add_element_to_int_list(&global_geometry_list.elements[loop_index].Volume->geometry.masked_by_list,INDEX_CURRENT_COMP);
            global_geometry_list.elements[loop_index].Volume->geometry.is_masked_volume = 1;
            if (this_box_volume.geometry.mask_mode == 2)
                global_geometry_list.elements[loop_index].Volume->geometry.mask_mode = 2;
            if (this_box_volume.geometry.mask_mode == 1) {
                if (global_geometry_list.elements[loop_index].Volume->geometry.is_masked_volume == 1 && global_geometry_list.elements[loop_index].Volume->geometry.mask_mode != 2)
                    // If more than one mask is added to one volume, the ANY mode overwrites the (default) ALL mode.
                    global_geometry_list.elements[loop_index].Volume->geometry.mask_mode = 1;
            }
            
            found_geometries = 1;
        }
    }
    if (found_geometries == 0) {
        printf("The mask_string in geometry: %s did not find any of the specified volumes in the mask_string %s \n",NAME_CURRENT_COMP,mask_string);
        exit(1);
    }
    this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
    this_box_volume.p_physics->is_vacuum = 0; // Makes this volume a vacuum
    this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
    this_box_volume.p_physics->my_a = 0; // Should not be used.
    sprintf(this_box_volume.p_physics->name,"Mask");
    this_box_volume.geometry.is_mask_volume = 1;
    
    
// Read the material input, or if it lacks, use automatic linking.
} else if (material_string && strlen(material_string) && strcmp(material_string, "NULL") && strcmp(material_string, "0")) {
    // A geometry string was given, use it to determine which material
    if (0 == strcmp(material_string,"vacuum") || 0 == strcmp(material_string,"Vacuum")) {
        // One could have a global physics struct for vacuum instead of creating one for each
        this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
        this_box_volume.p_physics->is_vacuum = 1; // Makes this volume a vacuum
        this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
        this_box_volume.p_physics->my_a = 0; // Should not be used.
        sprintf(this_box_volume.p_physics->name,"Vacuum");
    } else if (0 == strcmp(material_string,"exit") || 0 == strcmp(material_string,"Exit")) {
        // One could have a global physics struct for vacuum instead of creating one for each
        this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
        this_box_volume.p_physics->is_vacuum = 1; // Makes this volume a vacuum
        this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
        this_box_volume.p_physics->my_a = 0; // Should not be used.
        this_box_volume.geometry.is_exit_volume = 1;
        sprintf(this_box_volume.p_physics->name,"Exit");
    } else {
        #ifndef MATERIAL_DETECTOR
            printf("Need to define a material before refering to it in a geometry %s.\n",NAME_CURRENT_COMP);
            exit(1);
        #endif
        for (loop_index=0;loop_index<global_material_list.num_elements;loop_index++) {
            if (0 == strcmp(material_string,global_material_list.elements[loop_index].name)) {
                this_box_volume.p_physics = global_material_list.elements[loop_index].physics;
                break;
            }
            if (loop_index == global_material_list.num_elements-1) {
            printf("\n");
            printf("ERROR: The material string \"%s\" in Union geometry \"%s\" did not match a specified material. \n",material_string,NAME_CURRENT_COMP);
            printf("       The materials available at this point (need to be defined before the geometry): \n");
            for (loop_index=0;loop_index<global_material_list.num_elements;loop_index++)
              printf("         %s\n",global_material_list.elements[loop_index].name);
            printf("\n");
            printf("       It is also possible to use one of the defualt materials avaiable: \n");
            printf("           Vacuum (for a Volume without scattering or absorption)\n");
            printf("           Exit (for a Volume where the ray exits the component if it enters)\n");
            printf("           Mask (for a Volume that masks existing volumes specified in the mask_string\n");
            exit(1);
          }
        }
    }
} else {
    // Automatic linking, simply using the last defined material.
    #ifndef MATERIAL_DETECTOR
        printf("Need to define a material before the geometry to use automatic linking %s.\n",NAME_CURRENT_COMP);
        exit(1);
    #endif
    this_box_volume.p_physics = global_material_list.elements[global_material_list.num_elements-1].physics;
}

sprintf(this_box_volume.name,NAME_CURRENT_COMP);
sprintf(this_box_volume.geometry.shape,"box");
this_box_volume.geometry.priority_value = priority;
this_box_volume.geometry.geometry_p_interact = p_interact;
// Currently the coordinates will be in absolute space.
this_box_volume.geometry.center = POS_A_CURRENT_COMP;

this_box_storage.z_depth = zdepth;
this_box_storage.x_width1 = xwidth;
this_box_storage.y_height1 = yheight;

this_box_storage.is_rectangle = 0;
if (xwidth2 < 0 && yheight2 < 0) this_box_storage.is_rectangle = 1;
if (xwidth == xwidth2 && yheight == yheight2) this_box_storage.is_rectangle = 1;

if (xwidth2 < 0) {
    this_box_storage.x_width2 = xwidth;
    xwidth2 = xwidth;
} else this_box_storage.x_width2 = xwidth2;

if (yheight2 < 0) {
    this_box_storage.y_height2 = yheight;
    yheight2 = yheight;
} else this_box_storage.y_height2 = yheight2;


this_box_storage.normal_vectors[0] = coords_set(0,0,1);
this_box_storage.normal_vectors[1] = coords_set(0,0,1);

// for sides with y component = 0
x_component = 2*zdepth/sqrt((xwidth-xwidth2)*(xwidth-xwidth2)+4*zdepth*zdepth);
z_component = (xwidth-xwidth2)/sqrt(4*zdepth*zdepth+(xwidth-xwidth2)*(xwidth-xwidth2));

this_box_storage.normal_vectors[2] = coords_set(x_component,0,z_component);
this_box_storage.normal_vectors[3] = coords_set(-x_component,0,z_component);

// for sides with x component = 0
y_component = 2*zdepth/sqrt((yheight-yheight2)*(yheight-yheight2)+4*zdepth*zdepth);
z_component = (yheight-yheight2)/sqrt(4*zdepth*zdepth+(yheight-yheight2)*(yheight-yheight2));

this_box_storage.normal_vectors[4] = coords_set(0,y_component,z_component);
this_box_storage.normal_vectors[5] = coords_set(0,-y_component,z_component);

this_box_volume.geometry.visualization_on = visualize;

this_box_volume.geometry.geometry_parameters.p_box_storage = &this_box_storage;

// Assign pointers to functions for intersection with the shape, checking if a point is inside the shape
if (this_box_storage.is_rectangle == 1) {
this_box_volume.geometry.intersect_function = &sample_box_intersect_simple;
this_box_volume.geometry.within_function = &r_within_box_simple;
}
else {
this_box_volume.geometry.intersect_function = &sample_box_intersect_advanced;
this_box_volume.geometry.within_function = &r_within_box_advanced;
}

this_box_volume.geometry.shell_points = &box_shell_points;
this_box_volume.geometry.mcdisplay_function = &mcdisplay_box_function;
this_box_volume.geometry.initialize_from_main_function = &initialize_box_geometry_from_main_component;
this_box_volume.geometry.process_rot_allocated = 0;

this_box_volume.geometry.copy_geometry_parameters = &allocate_box_storage_copy;

rot_copy(this_box_volume.geometry.rotation_matrix,ROT_A_CURRENT_COMP); //check how ROT_R_CURRENT_COMP would work
rot_transpose(ROT_A_CURRENT_COMP,this_box_volume.geometry.transpose_rotation_matrix);

// Initialize loggers
this_box_volume.loggers.num_elements = 0;

// packing the information into the global_geometry_element, which is then included in the global_geometry_list.
sprintf(global_geometry_element.name,NAME_CURRENT_COMP);
global_geometry_element.activation_counter = number_of_activations;
global_geometry_element.component_index = INDEX_CURRENT_COMP;
global_geometry_element.Volume = &this_box_volume; // Would be nicer if this m was a pointer, now we have the (small) data two places
add_element_to_geometry_list(&global_geometry_list,global_geometry_element);
}
#line 252584 "MACS_sample_kidney_box.c"
#undef number_of_activations
#undef mask_setting
#undef mask_string
#undef p_interact
#undef focus_r
#undef focus_xh
#undef focus_xw
#undef focus_ah
#undef focus_aw
#undef target_z
#undef target_y
#undef target_x
#undef target_index
#undef visualize
#undef yheight2
#undef xwidth2
#undef zdepth
#undef yheight
#undef xwidth
#undef priority
#undef material_string
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

  /* Initializations for component channel_10_cave1_box1. */
  SIG_MESSAGE("channel_10_cave1_box1 (Init)");
#define mccompcurname  channel_10_cave1_box1
#define mccompcurtype  Union_box
#define mccompcurindex 504
#define loop_index mccchannel_10_cave1_box1_loop_index
#define this_box_volume mccchannel_10_cave1_box1_this_box_volume
#define global_geometry_element mccchannel_10_cave1_box1_global_geometry_element
#define this_box_storage mccchannel_10_cave1_box1_this_box_storage
#define material_string mccchannel_10_cave1_box1_material_string
#define priority mccchannel_10_cave1_box1_priority
#define xwidth mccchannel_10_cave1_box1_xwidth
#define yheight mccchannel_10_cave1_box1_yheight
#define zdepth mccchannel_10_cave1_box1_zdepth
#define xwidth2 mccchannel_10_cave1_box1_xwidth2
#define yheight2 mccchannel_10_cave1_box1_yheight2
#define visualize mccchannel_10_cave1_box1_visualize
#define target_index mccchannel_10_cave1_box1_target_index
#define target_x mccchannel_10_cave1_box1_target_x
#define target_y mccchannel_10_cave1_box1_target_y
#define target_z mccchannel_10_cave1_box1_target_z
#define focus_aw mccchannel_10_cave1_box1_focus_aw
#define focus_ah mccchannel_10_cave1_box1_focus_ah
#define focus_xw mccchannel_10_cave1_box1_focus_xw
#define focus_xh mccchannel_10_cave1_box1_focus_xh
#define focus_r mccchannel_10_cave1_box1_focus_r
#define p_interact mccchannel_10_cave1_box1_p_interact
#define mask_string mccchannel_10_cave1_box1_mask_string
#define mask_setting mccchannel_10_cave1_box1_mask_setting
#define number_of_activations mccchannel_10_cave1_box1_number_of_activations
#line 224 "Union_box.comp"
{
// Initializes the focusing system for this volume including input sanitation.
focus_initialize(&this_box_volume.geometry, POS_A_COMP_INDEX(INDEX_CURRENT_COMP+target_index), POS_A_CURRENT_COMP, ROT_A_CURRENT_COMP, target_index, target_x, target_y, target_z, focus_aw, focus_ah, focus_xw, focus_xh, focus_r, NAME_CURRENT_COMP);

// Input sanitation for this geometry
if (xwidth <= 0) {
  printf("\nERROR in Union_box named %s, the xwidth is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (yheight <= 0) {
  printf("\nERROR in Union_box named %s, yheight is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (zdepth <= 0) {
  printf("\nERROR in Union_box named %s, zdepth is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (xwidth2 <= 0 && xwidth2 != -1) {
  printf("\nERROR in Union_box named %s, the xwidth2 is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (yheight2 <= 0 && yheight2 != -1) {
  printf("\nERROR in Union_box named %s, yheight2 is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}

// Use sanitation
if (global_material_list.num_elements == 0) {
  printf("\nERROR: Need to define a material using Union_make_material before using a Union geometry component. \n");
  printf("       %s was defined before first use of Union_make_material.\n",NAME_CURRENT_COMP);
  exit(1);
}

this_box_volume.geometry.is_masked_volume = 0;
this_box_volume.geometry.is_exit_volume = 0;
this_box_volume.geometry.is_mask_volume = 0;
// check if the volume is a mask, if it is the material string is irelevant.
if (mask_string && strlen(mask_string) && strcmp(mask_string, "NULL") && strcmp(mask_string, "0")) {
    // A mask volume is used to limit the extend of other volumes, called the masked volumes. These are specified in the mask_string.
    // In order for a ray to enter a masked volume, it needs to be both in the region covered by that volume AND the mask volume.
    // When more than
    this_box_volume.geometry.mask_mode = 1; // Default is mask mode is ALL
    if (mask_setting && strlen(mask_setting) && strcmp(mask_setting, "NULL") && strcmp(mask_setting, "0")) {
        if (strcmp(mask_setting,"ALL") == 0 || strcmp(mask_setting,"All") == 0) this_box_volume.geometry.mask_mode = 1;
        else if (strcmp(mask_setting,"ANY") == 0 || strcmp(mask_setting,"Any") == 0) this_box_volume.geometry.mask_mode = 2;
        else {
            printf("The mask_mode of component %s is set to %s, but must be either ALL or ANY.\n",NAME_CURRENT_COMP,mask_setting);
            exit(1);
        }
    }
    
    for (loop_index=0;loop_index<global_geometry_list.num_elements;loop_index++) {
        // Add mask list
        if (1 == manual_linking_function(global_geometry_list.elements[loop_index].name,mask_string)) {
            add_element_to_int_list(&this_box_volume.geometry.mask_list,global_geometry_list.elements[loop_index].component_index);
            add_element_to_int_list(&global_geometry_list.elements[loop_index].Volume->geometry.masked_by_list,INDEX_CURRENT_COMP);
            global_geometry_list.elements[loop_index].Volume->geometry.is_masked_volume = 1;
            if (this_box_volume.geometry.mask_mode == 2)
                global_geometry_list.elements[loop_index].Volume->geometry.mask_mode = 2;
            if (this_box_volume.geometry.mask_mode == 1) {
                if (global_geometry_list.elements[loop_index].Volume->geometry.is_masked_volume == 1 && global_geometry_list.elements[loop_index].Volume->geometry.mask_mode != 2)
                    // If more than one mask is added to one volume, the ANY mode overwrites the (default) ALL mode.
                    global_geometry_list.elements[loop_index].Volume->geometry.mask_mode = 1;
            }
            
            found_geometries = 1;
        }
    }
    if (found_geometries == 0) {
        printf("The mask_string in geometry: %s did not find any of the specified volumes in the mask_string %s \n",NAME_CURRENT_COMP,mask_string);
        exit(1);
    }
    this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
    this_box_volume.p_physics->is_vacuum = 0; // Makes this volume a vacuum
    this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
    this_box_volume.p_physics->my_a = 0; // Should not be used.
    sprintf(this_box_volume.p_physics->name,"Mask");
    this_box_volume.geometry.is_mask_volume = 1;
    
    
// Read the material input, or if it lacks, use automatic linking.
} else if (material_string && strlen(material_string) && strcmp(material_string, "NULL") && strcmp(material_string, "0")) {
    // A geometry string was given, use it to determine which material
    if (0 == strcmp(material_string,"vacuum") || 0 == strcmp(material_string,"Vacuum")) {
        // One could have a global physics struct for vacuum instead of creating one for each
        this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
        this_box_volume.p_physics->is_vacuum = 1; // Makes this volume a vacuum
        this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
        this_box_volume.p_physics->my_a = 0; // Should not be used.
        sprintf(this_box_volume.p_physics->name,"Vacuum");
    } else if (0 == strcmp(material_string,"exit") || 0 == strcmp(material_string,"Exit")) {
        // One could have a global physics struct for vacuum instead of creating one for each
        this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
        this_box_volume.p_physics->is_vacuum = 1; // Makes this volume a vacuum
        this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
        this_box_volume.p_physics->my_a = 0; // Should not be used.
        this_box_volume.geometry.is_exit_volume = 1;
        sprintf(this_box_volume.p_physics->name,"Exit");
    } else {
        #ifndef MATERIAL_DETECTOR
            printf("Need to define a material before refering to it in a geometry %s.\n",NAME_CURRENT_COMP);
            exit(1);
        #endif
        for (loop_index=0;loop_index<global_material_list.num_elements;loop_index++) {
            if (0 == strcmp(material_string,global_material_list.elements[loop_index].name)) {
                this_box_volume.p_physics = global_material_list.elements[loop_index].physics;
                break;
            }
            if (loop_index == global_material_list.num_elements-1) {
            printf("\n");
            printf("ERROR: The material string \"%s\" in Union geometry \"%s\" did not match a specified material. \n",material_string,NAME_CURRENT_COMP);
            printf("       The materials available at this point (need to be defined before the geometry): \n");
            for (loop_index=0;loop_index<global_material_list.num_elements;loop_index++)
              printf("         %s\n",global_material_list.elements[loop_index].name);
            printf("\n");
            printf("       It is also possible to use one of the defualt materials avaiable: \n");
            printf("           Vacuum (for a Volume without scattering or absorption)\n");
            printf("           Exit (for a Volume where the ray exits the component if it enters)\n");
            printf("           Mask (for a Volume that masks existing volumes specified in the mask_string\n");
            exit(1);
          }
        }
    }
} else {
    // Automatic linking, simply using the last defined material.
    #ifndef MATERIAL_DETECTOR
        printf("Need to define a material before the geometry to use automatic linking %s.\n",NAME_CURRENT_COMP);
        exit(1);
    #endif
    this_box_volume.p_physics = global_material_list.elements[global_material_list.num_elements-1].physics;
}

sprintf(this_box_volume.name,NAME_CURRENT_COMP);
sprintf(this_box_volume.geometry.shape,"box");
this_box_volume.geometry.priority_value = priority;
this_box_volume.geometry.geometry_p_interact = p_interact;
// Currently the coordinates will be in absolute space.
this_box_volume.geometry.center = POS_A_CURRENT_COMP;

this_box_storage.z_depth = zdepth;
this_box_storage.x_width1 = xwidth;
this_box_storage.y_height1 = yheight;

this_box_storage.is_rectangle = 0;
if (xwidth2 < 0 && yheight2 < 0) this_box_storage.is_rectangle = 1;
if (xwidth == xwidth2 && yheight == yheight2) this_box_storage.is_rectangle = 1;

if (xwidth2 < 0) {
    this_box_storage.x_width2 = xwidth;
    xwidth2 = xwidth;
} else this_box_storage.x_width2 = xwidth2;

if (yheight2 < 0) {
    this_box_storage.y_height2 = yheight;
    yheight2 = yheight;
} else this_box_storage.y_height2 = yheight2;


this_box_storage.normal_vectors[0] = coords_set(0,0,1);
this_box_storage.normal_vectors[1] = coords_set(0,0,1);

// for sides with y component = 0
x_component = 2*zdepth/sqrt((xwidth-xwidth2)*(xwidth-xwidth2)+4*zdepth*zdepth);
z_component = (xwidth-xwidth2)/sqrt(4*zdepth*zdepth+(xwidth-xwidth2)*(xwidth-xwidth2));

this_box_storage.normal_vectors[2] = coords_set(x_component,0,z_component);
this_box_storage.normal_vectors[3] = coords_set(-x_component,0,z_component);

// for sides with x component = 0
y_component = 2*zdepth/sqrt((yheight-yheight2)*(yheight-yheight2)+4*zdepth*zdepth);
z_component = (yheight-yheight2)/sqrt(4*zdepth*zdepth+(yheight-yheight2)*(yheight-yheight2));

this_box_storage.normal_vectors[4] = coords_set(0,y_component,z_component);
this_box_storage.normal_vectors[5] = coords_set(0,-y_component,z_component);

this_box_volume.geometry.visualization_on = visualize;

this_box_volume.geometry.geometry_parameters.p_box_storage = &this_box_storage;

// Assign pointers to functions for intersection with the shape, checking if a point is inside the shape
if (this_box_storage.is_rectangle == 1) {
this_box_volume.geometry.intersect_function = &sample_box_intersect_simple;
this_box_volume.geometry.within_function = &r_within_box_simple;
}
else {
this_box_volume.geometry.intersect_function = &sample_box_intersect_advanced;
this_box_volume.geometry.within_function = &r_within_box_advanced;
}

this_box_volume.geometry.shell_points = &box_shell_points;
this_box_volume.geometry.mcdisplay_function = &mcdisplay_box_function;
this_box_volume.geometry.initialize_from_main_function = &initialize_box_geometry_from_main_component;
this_box_volume.geometry.process_rot_allocated = 0;

this_box_volume.geometry.copy_geometry_parameters = &allocate_box_storage_copy;

rot_copy(this_box_volume.geometry.rotation_matrix,ROT_A_CURRENT_COMP); //check how ROT_R_CURRENT_COMP would work
rot_transpose(ROT_A_CURRENT_COMP,this_box_volume.geometry.transpose_rotation_matrix);

// Initialize loggers
this_box_volume.loggers.num_elements = 0;

// packing the information into the global_geometry_element, which is then included in the global_geometry_list.
sprintf(global_geometry_element.name,NAME_CURRENT_COMP);
global_geometry_element.activation_counter = number_of_activations;
global_geometry_element.component_index = INDEX_CURRENT_COMP;
global_geometry_element.Volume = &this_box_volume; // Would be nicer if this m was a pointer, now we have the (small) data two places
add_element_to_geometry_list(&global_geometry_list,global_geometry_element);
}
#line 252854 "MACS_sample_kidney_box.c"
#undef number_of_activations
#undef mask_setting
#undef mask_string
#undef p_interact
#undef focus_r
#undef focus_xh
#undef focus_xw
#undef focus_ah
#undef focus_aw
#undef target_z
#undef target_y
#undef target_x
#undef target_index
#undef visualize
#undef yheight2
#undef xwidth2
#undef zdepth
#undef yheight
#undef xwidth
#undef priority
#undef material_string
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

  /* Initializations for component channel_10_cave1_box2. */
  SIG_MESSAGE("channel_10_cave1_box2 (Init)");
#define mccompcurname  channel_10_cave1_box2
#define mccompcurtype  Union_box
#define mccompcurindex 505
#define loop_index mccchannel_10_cave1_box2_loop_index
#define this_box_volume mccchannel_10_cave1_box2_this_box_volume
#define global_geometry_element mccchannel_10_cave1_box2_global_geometry_element
#define this_box_storage mccchannel_10_cave1_box2_this_box_storage
#define material_string mccchannel_10_cave1_box2_material_string
#define priority mccchannel_10_cave1_box2_priority
#define xwidth mccchannel_10_cave1_box2_xwidth
#define yheight mccchannel_10_cave1_box2_yheight
#define zdepth mccchannel_10_cave1_box2_zdepth
#define xwidth2 mccchannel_10_cave1_box2_xwidth2
#define yheight2 mccchannel_10_cave1_box2_yheight2
#define visualize mccchannel_10_cave1_box2_visualize
#define target_index mccchannel_10_cave1_box2_target_index
#define target_x mccchannel_10_cave1_box2_target_x
#define target_y mccchannel_10_cave1_box2_target_y
#define target_z mccchannel_10_cave1_box2_target_z
#define focus_aw mccchannel_10_cave1_box2_focus_aw
#define focus_ah mccchannel_10_cave1_box2_focus_ah
#define focus_xw mccchannel_10_cave1_box2_focus_xw
#define focus_xh mccchannel_10_cave1_box2_focus_xh
#define focus_r mccchannel_10_cave1_box2_focus_r
#define p_interact mccchannel_10_cave1_box2_p_interact
#define mask_string mccchannel_10_cave1_box2_mask_string
#define mask_setting mccchannel_10_cave1_box2_mask_setting
#define number_of_activations mccchannel_10_cave1_box2_number_of_activations
#line 224 "Union_box.comp"
{
// Initializes the focusing system for this volume including input sanitation.
focus_initialize(&this_box_volume.geometry, POS_A_COMP_INDEX(INDEX_CURRENT_COMP+target_index), POS_A_CURRENT_COMP, ROT_A_CURRENT_COMP, target_index, target_x, target_y, target_z, focus_aw, focus_ah, focus_xw, focus_xh, focus_r, NAME_CURRENT_COMP);

// Input sanitation for this geometry
if (xwidth <= 0) {
  printf("\nERROR in Union_box named %s, the xwidth is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (yheight <= 0) {
  printf("\nERROR in Union_box named %s, yheight is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (zdepth <= 0) {
  printf("\nERROR in Union_box named %s, zdepth is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (xwidth2 <= 0 && xwidth2 != -1) {
  printf("\nERROR in Union_box named %s, the xwidth2 is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (yheight2 <= 0 && yheight2 != -1) {
  printf("\nERROR in Union_box named %s, yheight2 is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}

// Use sanitation
if (global_material_list.num_elements == 0) {
  printf("\nERROR: Need to define a material using Union_make_material before using a Union geometry component. \n");
  printf("       %s was defined before first use of Union_make_material.\n",NAME_CURRENT_COMP);
  exit(1);
}

this_box_volume.geometry.is_masked_volume = 0;
this_box_volume.geometry.is_exit_volume = 0;
this_box_volume.geometry.is_mask_volume = 0;
// check if the volume is a mask, if it is the material string is irelevant.
if (mask_string && strlen(mask_string) && strcmp(mask_string, "NULL") && strcmp(mask_string, "0")) {
    // A mask volume is used to limit the extend of other volumes, called the masked volumes. These are specified in the mask_string.
    // In order for a ray to enter a masked volume, it needs to be both in the region covered by that volume AND the mask volume.
    // When more than
    this_box_volume.geometry.mask_mode = 1; // Default is mask mode is ALL
    if (mask_setting && strlen(mask_setting) && strcmp(mask_setting, "NULL") && strcmp(mask_setting, "0")) {
        if (strcmp(mask_setting,"ALL") == 0 || strcmp(mask_setting,"All") == 0) this_box_volume.geometry.mask_mode = 1;
        else if (strcmp(mask_setting,"ANY") == 0 || strcmp(mask_setting,"Any") == 0) this_box_volume.geometry.mask_mode = 2;
        else {
            printf("The mask_mode of component %s is set to %s, but must be either ALL or ANY.\n",NAME_CURRENT_COMP,mask_setting);
            exit(1);
        }
    }
    
    for (loop_index=0;loop_index<global_geometry_list.num_elements;loop_index++) {
        // Add mask list
        if (1 == manual_linking_function(global_geometry_list.elements[loop_index].name,mask_string)) {
            add_element_to_int_list(&this_box_volume.geometry.mask_list,global_geometry_list.elements[loop_index].component_index);
            add_element_to_int_list(&global_geometry_list.elements[loop_index].Volume->geometry.masked_by_list,INDEX_CURRENT_COMP);
            global_geometry_list.elements[loop_index].Volume->geometry.is_masked_volume = 1;
            if (this_box_volume.geometry.mask_mode == 2)
                global_geometry_list.elements[loop_index].Volume->geometry.mask_mode = 2;
            if (this_box_volume.geometry.mask_mode == 1) {
                if (global_geometry_list.elements[loop_index].Volume->geometry.is_masked_volume == 1 && global_geometry_list.elements[loop_index].Volume->geometry.mask_mode != 2)
                    // If more than one mask is added to one volume, the ANY mode overwrites the (default) ALL mode.
                    global_geometry_list.elements[loop_index].Volume->geometry.mask_mode = 1;
            }
            
            found_geometries = 1;
        }
    }
    if (found_geometries == 0) {
        printf("The mask_string in geometry: %s did not find any of the specified volumes in the mask_string %s \n",NAME_CURRENT_COMP,mask_string);
        exit(1);
    }
    this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
    this_box_volume.p_physics->is_vacuum = 0; // Makes this volume a vacuum
    this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
    this_box_volume.p_physics->my_a = 0; // Should not be used.
    sprintf(this_box_volume.p_physics->name,"Mask");
    this_box_volume.geometry.is_mask_volume = 1;
    
    
// Read the material input, or if it lacks, use automatic linking.
} else if (material_string && strlen(material_string) && strcmp(material_string, "NULL") && strcmp(material_string, "0")) {
    // A geometry string was given, use it to determine which material
    if (0 == strcmp(material_string,"vacuum") || 0 == strcmp(material_string,"Vacuum")) {
        // One could have a global physics struct for vacuum instead of creating one for each
        this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
        this_box_volume.p_physics->is_vacuum = 1; // Makes this volume a vacuum
        this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
        this_box_volume.p_physics->my_a = 0; // Should not be used.
        sprintf(this_box_volume.p_physics->name,"Vacuum");
    } else if (0 == strcmp(material_string,"exit") || 0 == strcmp(material_string,"Exit")) {
        // One could have a global physics struct for vacuum instead of creating one for each
        this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
        this_box_volume.p_physics->is_vacuum = 1; // Makes this volume a vacuum
        this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
        this_box_volume.p_physics->my_a = 0; // Should not be used.
        this_box_volume.geometry.is_exit_volume = 1;
        sprintf(this_box_volume.p_physics->name,"Exit");
    } else {
        #ifndef MATERIAL_DETECTOR
            printf("Need to define a material before refering to it in a geometry %s.\n",NAME_CURRENT_COMP);
            exit(1);
        #endif
        for (loop_index=0;loop_index<global_material_list.num_elements;loop_index++) {
            if (0 == strcmp(material_string,global_material_list.elements[loop_index].name)) {
                this_box_volume.p_physics = global_material_list.elements[loop_index].physics;
                break;
            }
            if (loop_index == global_material_list.num_elements-1) {
            printf("\n");
            printf("ERROR: The material string \"%s\" in Union geometry \"%s\" did not match a specified material. \n",material_string,NAME_CURRENT_COMP);
            printf("       The materials available at this point (need to be defined before the geometry): \n");
            for (loop_index=0;loop_index<global_material_list.num_elements;loop_index++)
              printf("         %s\n",global_material_list.elements[loop_index].name);
            printf("\n");
            printf("       It is also possible to use one of the defualt materials avaiable: \n");
            printf("           Vacuum (for a Volume without scattering or absorption)\n");
            printf("           Exit (for a Volume where the ray exits the component if it enters)\n");
            printf("           Mask (for a Volume that masks existing volumes specified in the mask_string\n");
            exit(1);
          }
        }
    }
} else {
    // Automatic linking, simply using the last defined material.
    #ifndef MATERIAL_DETECTOR
        printf("Need to define a material before the geometry to use automatic linking %s.\n",NAME_CURRENT_COMP);
        exit(1);
    #endif
    this_box_volume.p_physics = global_material_list.elements[global_material_list.num_elements-1].physics;
}

sprintf(this_box_volume.name,NAME_CURRENT_COMP);
sprintf(this_box_volume.geometry.shape,"box");
this_box_volume.geometry.priority_value = priority;
this_box_volume.geometry.geometry_p_interact = p_interact;
// Currently the coordinates will be in absolute space.
this_box_volume.geometry.center = POS_A_CURRENT_COMP;

this_box_storage.z_depth = zdepth;
this_box_storage.x_width1 = xwidth;
this_box_storage.y_height1 = yheight;

this_box_storage.is_rectangle = 0;
if (xwidth2 < 0 && yheight2 < 0) this_box_storage.is_rectangle = 1;
if (xwidth == xwidth2 && yheight == yheight2) this_box_storage.is_rectangle = 1;

if (xwidth2 < 0) {
    this_box_storage.x_width2 = xwidth;
    xwidth2 = xwidth;
} else this_box_storage.x_width2 = xwidth2;

if (yheight2 < 0) {
    this_box_storage.y_height2 = yheight;
    yheight2 = yheight;
} else this_box_storage.y_height2 = yheight2;


this_box_storage.normal_vectors[0] = coords_set(0,0,1);
this_box_storage.normal_vectors[1] = coords_set(0,0,1);

// for sides with y component = 0
x_component = 2*zdepth/sqrt((xwidth-xwidth2)*(xwidth-xwidth2)+4*zdepth*zdepth);
z_component = (xwidth-xwidth2)/sqrt(4*zdepth*zdepth+(xwidth-xwidth2)*(xwidth-xwidth2));

this_box_storage.normal_vectors[2] = coords_set(x_component,0,z_component);
this_box_storage.normal_vectors[3] = coords_set(-x_component,0,z_component);

// for sides with x component = 0
y_component = 2*zdepth/sqrt((yheight-yheight2)*(yheight-yheight2)+4*zdepth*zdepth);
z_component = (yheight-yheight2)/sqrt(4*zdepth*zdepth+(yheight-yheight2)*(yheight-yheight2));

this_box_storage.normal_vectors[4] = coords_set(0,y_component,z_component);
this_box_storage.normal_vectors[5] = coords_set(0,-y_component,z_component);

this_box_volume.geometry.visualization_on = visualize;

this_box_volume.geometry.geometry_parameters.p_box_storage = &this_box_storage;

// Assign pointers to functions for intersection with the shape, checking if a point is inside the shape
if (this_box_storage.is_rectangle == 1) {
this_box_volume.geometry.intersect_function = &sample_box_intersect_simple;
this_box_volume.geometry.within_function = &r_within_box_simple;
}
else {
this_box_volume.geometry.intersect_function = &sample_box_intersect_advanced;
this_box_volume.geometry.within_function = &r_within_box_advanced;
}

this_box_volume.geometry.shell_points = &box_shell_points;
this_box_volume.geometry.mcdisplay_function = &mcdisplay_box_function;
this_box_volume.geometry.initialize_from_main_function = &initialize_box_geometry_from_main_component;
this_box_volume.geometry.process_rot_allocated = 0;

this_box_volume.geometry.copy_geometry_parameters = &allocate_box_storage_copy;

rot_copy(this_box_volume.geometry.rotation_matrix,ROT_A_CURRENT_COMP); //check how ROT_R_CURRENT_COMP would work
rot_transpose(ROT_A_CURRENT_COMP,this_box_volume.geometry.transpose_rotation_matrix);

// Initialize loggers
this_box_volume.loggers.num_elements = 0;

// packing the information into the global_geometry_element, which is then included in the global_geometry_list.
sprintf(global_geometry_element.name,NAME_CURRENT_COMP);
global_geometry_element.activation_counter = number_of_activations;
global_geometry_element.component_index = INDEX_CURRENT_COMP;
global_geometry_element.Volume = &this_box_volume; // Would be nicer if this m was a pointer, now we have the (small) data two places
add_element_to_geometry_list(&global_geometry_list,global_geometry_element);
}
#line 253124 "MACS_sample_kidney_box.c"
#undef number_of_activations
#undef mask_setting
#undef mask_string
#undef p_interact
#undef focus_r
#undef focus_xh
#undef focus_xw
#undef focus_ah
#undef focus_aw
#undef target_z
#undef target_y
#undef target_x
#undef target_index
#undef visualize
#undef yheight2
#undef xwidth2
#undef zdepth
#undef yheight
#undef xwidth
#undef priority
#undef material_string
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

  /* Initializations for component channel_10_cave1_box3. */
  SIG_MESSAGE("channel_10_cave1_box3 (Init)");
#define mccompcurname  channel_10_cave1_box3
#define mccompcurtype  Union_box
#define mccompcurindex 506
#define loop_index mccchannel_10_cave1_box3_loop_index
#define this_box_volume mccchannel_10_cave1_box3_this_box_volume
#define global_geometry_element mccchannel_10_cave1_box3_global_geometry_element
#define this_box_storage mccchannel_10_cave1_box3_this_box_storage
#define material_string mccchannel_10_cave1_box3_material_string
#define priority mccchannel_10_cave1_box3_priority
#define xwidth mccchannel_10_cave1_box3_xwidth
#define yheight mccchannel_10_cave1_box3_yheight
#define zdepth mccchannel_10_cave1_box3_zdepth
#define xwidth2 mccchannel_10_cave1_box3_xwidth2
#define yheight2 mccchannel_10_cave1_box3_yheight2
#define visualize mccchannel_10_cave1_box3_visualize
#define target_index mccchannel_10_cave1_box3_target_index
#define target_x mccchannel_10_cave1_box3_target_x
#define target_y mccchannel_10_cave1_box3_target_y
#define target_z mccchannel_10_cave1_box3_target_z
#define focus_aw mccchannel_10_cave1_box3_focus_aw
#define focus_ah mccchannel_10_cave1_box3_focus_ah
#define focus_xw mccchannel_10_cave1_box3_focus_xw
#define focus_xh mccchannel_10_cave1_box3_focus_xh
#define focus_r mccchannel_10_cave1_box3_focus_r
#define p_interact mccchannel_10_cave1_box3_p_interact
#define mask_string mccchannel_10_cave1_box3_mask_string
#define mask_setting mccchannel_10_cave1_box3_mask_setting
#define number_of_activations mccchannel_10_cave1_box3_number_of_activations
#line 224 "Union_box.comp"
{
// Initializes the focusing system for this volume including input sanitation.
focus_initialize(&this_box_volume.geometry, POS_A_COMP_INDEX(INDEX_CURRENT_COMP+target_index), POS_A_CURRENT_COMP, ROT_A_CURRENT_COMP, target_index, target_x, target_y, target_z, focus_aw, focus_ah, focus_xw, focus_xh, focus_r, NAME_CURRENT_COMP);

// Input sanitation for this geometry
if (xwidth <= 0) {
  printf("\nERROR in Union_box named %s, the xwidth is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (yheight <= 0) {
  printf("\nERROR in Union_box named %s, yheight is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (zdepth <= 0) {
  printf("\nERROR in Union_box named %s, zdepth is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (xwidth2 <= 0 && xwidth2 != -1) {
  printf("\nERROR in Union_box named %s, the xwidth2 is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (yheight2 <= 0 && yheight2 != -1) {
  printf("\nERROR in Union_box named %s, yheight2 is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}

// Use sanitation
if (global_material_list.num_elements == 0) {
  printf("\nERROR: Need to define a material using Union_make_material before using a Union geometry component. \n");
  printf("       %s was defined before first use of Union_make_material.\n",NAME_CURRENT_COMP);
  exit(1);
}

this_box_volume.geometry.is_masked_volume = 0;
this_box_volume.geometry.is_exit_volume = 0;
this_box_volume.geometry.is_mask_volume = 0;
// check if the volume is a mask, if it is the material string is irelevant.
if (mask_string && strlen(mask_string) && strcmp(mask_string, "NULL") && strcmp(mask_string, "0")) {
    // A mask volume is used to limit the extend of other volumes, called the masked volumes. These are specified in the mask_string.
    // In order for a ray to enter a masked volume, it needs to be both in the region covered by that volume AND the mask volume.
    // When more than
    this_box_volume.geometry.mask_mode = 1; // Default is mask mode is ALL
    if (mask_setting && strlen(mask_setting) && strcmp(mask_setting, "NULL") && strcmp(mask_setting, "0")) {
        if (strcmp(mask_setting,"ALL") == 0 || strcmp(mask_setting,"All") == 0) this_box_volume.geometry.mask_mode = 1;
        else if (strcmp(mask_setting,"ANY") == 0 || strcmp(mask_setting,"Any") == 0) this_box_volume.geometry.mask_mode = 2;
        else {
            printf("The mask_mode of component %s is set to %s, but must be either ALL or ANY.\n",NAME_CURRENT_COMP,mask_setting);
            exit(1);
        }
    }
    
    for (loop_index=0;loop_index<global_geometry_list.num_elements;loop_index++) {
        // Add mask list
        if (1 == manual_linking_function(global_geometry_list.elements[loop_index].name,mask_string)) {
            add_element_to_int_list(&this_box_volume.geometry.mask_list,global_geometry_list.elements[loop_index].component_index);
            add_element_to_int_list(&global_geometry_list.elements[loop_index].Volume->geometry.masked_by_list,INDEX_CURRENT_COMP);
            global_geometry_list.elements[loop_index].Volume->geometry.is_masked_volume = 1;
            if (this_box_volume.geometry.mask_mode == 2)
                global_geometry_list.elements[loop_index].Volume->geometry.mask_mode = 2;
            if (this_box_volume.geometry.mask_mode == 1) {
                if (global_geometry_list.elements[loop_index].Volume->geometry.is_masked_volume == 1 && global_geometry_list.elements[loop_index].Volume->geometry.mask_mode != 2)
                    // If more than one mask is added to one volume, the ANY mode overwrites the (default) ALL mode.
                    global_geometry_list.elements[loop_index].Volume->geometry.mask_mode = 1;
            }
            
            found_geometries = 1;
        }
    }
    if (found_geometries == 0) {
        printf("The mask_string in geometry: %s did not find any of the specified volumes in the mask_string %s \n",NAME_CURRENT_COMP,mask_string);
        exit(1);
    }
    this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
    this_box_volume.p_physics->is_vacuum = 0; // Makes this volume a vacuum
    this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
    this_box_volume.p_physics->my_a = 0; // Should not be used.
    sprintf(this_box_volume.p_physics->name,"Mask");
    this_box_volume.geometry.is_mask_volume = 1;
    
    
// Read the material input, or if it lacks, use automatic linking.
} else if (material_string && strlen(material_string) && strcmp(material_string, "NULL") && strcmp(material_string, "0")) {
    // A geometry string was given, use it to determine which material
    if (0 == strcmp(material_string,"vacuum") || 0 == strcmp(material_string,"Vacuum")) {
        // One could have a global physics struct for vacuum instead of creating one for each
        this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
        this_box_volume.p_physics->is_vacuum = 1; // Makes this volume a vacuum
        this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
        this_box_volume.p_physics->my_a = 0; // Should not be used.
        sprintf(this_box_volume.p_physics->name,"Vacuum");
    } else if (0 == strcmp(material_string,"exit") || 0 == strcmp(material_string,"Exit")) {
        // One could have a global physics struct for vacuum instead of creating one for each
        this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
        this_box_volume.p_physics->is_vacuum = 1; // Makes this volume a vacuum
        this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
        this_box_volume.p_physics->my_a = 0; // Should not be used.
        this_box_volume.geometry.is_exit_volume = 1;
        sprintf(this_box_volume.p_physics->name,"Exit");
    } else {
        #ifndef MATERIAL_DETECTOR
            printf("Need to define a material before refering to it in a geometry %s.\n",NAME_CURRENT_COMP);
            exit(1);
        #endif
        for (loop_index=0;loop_index<global_material_list.num_elements;loop_index++) {
            if (0 == strcmp(material_string,global_material_list.elements[loop_index].name)) {
                this_box_volume.p_physics = global_material_list.elements[loop_index].physics;
                break;
            }
            if (loop_index == global_material_list.num_elements-1) {
            printf("\n");
            printf("ERROR: The material string \"%s\" in Union geometry \"%s\" did not match a specified material. \n",material_string,NAME_CURRENT_COMP);
            printf("       The materials available at this point (need to be defined before the geometry): \n");
            for (loop_index=0;loop_index<global_material_list.num_elements;loop_index++)
              printf("         %s\n",global_material_list.elements[loop_index].name);
            printf("\n");
            printf("       It is also possible to use one of the defualt materials avaiable: \n");
            printf("           Vacuum (for a Volume without scattering or absorption)\n");
            printf("           Exit (for a Volume where the ray exits the component if it enters)\n");
            printf("           Mask (for a Volume that masks existing volumes specified in the mask_string\n");
            exit(1);
          }
        }
    }
} else {
    // Automatic linking, simply using the last defined material.
    #ifndef MATERIAL_DETECTOR
        printf("Need to define a material before the geometry to use automatic linking %s.\n",NAME_CURRENT_COMP);
        exit(1);
    #endif
    this_box_volume.p_physics = global_material_list.elements[global_material_list.num_elements-1].physics;
}

sprintf(this_box_volume.name,NAME_CURRENT_COMP);
sprintf(this_box_volume.geometry.shape,"box");
this_box_volume.geometry.priority_value = priority;
this_box_volume.geometry.geometry_p_interact = p_interact;
// Currently the coordinates will be in absolute space.
this_box_volume.geometry.center = POS_A_CURRENT_COMP;

this_box_storage.z_depth = zdepth;
this_box_storage.x_width1 = xwidth;
this_box_storage.y_height1 = yheight;

this_box_storage.is_rectangle = 0;
if (xwidth2 < 0 && yheight2 < 0) this_box_storage.is_rectangle = 1;
if (xwidth == xwidth2 && yheight == yheight2) this_box_storage.is_rectangle = 1;

if (xwidth2 < 0) {
    this_box_storage.x_width2 = xwidth;
    xwidth2 = xwidth;
} else this_box_storage.x_width2 = xwidth2;

if (yheight2 < 0) {
    this_box_storage.y_height2 = yheight;
    yheight2 = yheight;
} else this_box_storage.y_height2 = yheight2;


this_box_storage.normal_vectors[0] = coords_set(0,0,1);
this_box_storage.normal_vectors[1] = coords_set(0,0,1);

// for sides with y component = 0
x_component = 2*zdepth/sqrt((xwidth-xwidth2)*(xwidth-xwidth2)+4*zdepth*zdepth);
z_component = (xwidth-xwidth2)/sqrt(4*zdepth*zdepth+(xwidth-xwidth2)*(xwidth-xwidth2));

this_box_storage.normal_vectors[2] = coords_set(x_component,0,z_component);
this_box_storage.normal_vectors[3] = coords_set(-x_component,0,z_component);

// for sides with x component = 0
y_component = 2*zdepth/sqrt((yheight-yheight2)*(yheight-yheight2)+4*zdepth*zdepth);
z_component = (yheight-yheight2)/sqrt(4*zdepth*zdepth+(yheight-yheight2)*(yheight-yheight2));

this_box_storage.normal_vectors[4] = coords_set(0,y_component,z_component);
this_box_storage.normal_vectors[5] = coords_set(0,-y_component,z_component);

this_box_volume.geometry.visualization_on = visualize;

this_box_volume.geometry.geometry_parameters.p_box_storage = &this_box_storage;

// Assign pointers to functions for intersection with the shape, checking if a point is inside the shape
if (this_box_storage.is_rectangle == 1) {
this_box_volume.geometry.intersect_function = &sample_box_intersect_simple;
this_box_volume.geometry.within_function = &r_within_box_simple;
}
else {
this_box_volume.geometry.intersect_function = &sample_box_intersect_advanced;
this_box_volume.geometry.within_function = &r_within_box_advanced;
}

this_box_volume.geometry.shell_points = &box_shell_points;
this_box_volume.geometry.mcdisplay_function = &mcdisplay_box_function;
this_box_volume.geometry.initialize_from_main_function = &initialize_box_geometry_from_main_component;
this_box_volume.geometry.process_rot_allocated = 0;

this_box_volume.geometry.copy_geometry_parameters = &allocate_box_storage_copy;

rot_copy(this_box_volume.geometry.rotation_matrix,ROT_A_CURRENT_COMP); //check how ROT_R_CURRENT_COMP would work
rot_transpose(ROT_A_CURRENT_COMP,this_box_volume.geometry.transpose_rotation_matrix);

// Initialize loggers
this_box_volume.loggers.num_elements = 0;

// packing the information into the global_geometry_element, which is then included in the global_geometry_list.
sprintf(global_geometry_element.name,NAME_CURRENT_COMP);
global_geometry_element.activation_counter = number_of_activations;
global_geometry_element.component_index = INDEX_CURRENT_COMP;
global_geometry_element.Volume = &this_box_volume; // Would be nicer if this m was a pointer, now we have the (small) data two places
add_element_to_geometry_list(&global_geometry_list,global_geometry_element);
}
#line 253394 "MACS_sample_kidney_box.c"
#undef number_of_activations
#undef mask_setting
#undef mask_string
#undef p_interact
#undef focus_r
#undef focus_xh
#undef focus_xw
#undef focus_ah
#undef focus_aw
#undef target_z
#undef target_y
#undef target_x
#undef target_index
#undef visualize
#undef yheight2
#undef xwidth2
#undef zdepth
#undef yheight
#undef xwidth
#undef priority
#undef material_string
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

  /* Initializations for component channel_10_cave1_cyl1. */
  SIG_MESSAGE("channel_10_cave1_cyl1 (Init)");
#define mccompcurname  channel_10_cave1_cyl1
#define mccompcurtype  Union_cylinder
#define mccompcurindex 507
#define loop_index mccchannel_10_cave1_cyl1_loop_index
#define this_cylinder_volume mccchannel_10_cave1_cyl1_this_cylinder_volume
#define global_geometry_element mccchannel_10_cave1_cyl1_global_geometry_element
#define this_cylinder_storage mccchannel_10_cave1_cyl1_this_cylinder_storage
#define material_string mccchannel_10_cave1_cyl1_material_string
#define priority mccchannel_10_cave1_cyl1_priority
#define radius mccchannel_10_cave1_cyl1_radius
#define yheight mccchannel_10_cave1_cyl1_yheight
#define visualize mccchannel_10_cave1_cyl1_visualize
#define target_index mccchannel_10_cave1_cyl1_target_index
#define target_x mccchannel_10_cave1_cyl1_target_x
#define target_y mccchannel_10_cave1_cyl1_target_y
#define target_z mccchannel_10_cave1_cyl1_target_z
#define focus_aw mccchannel_10_cave1_cyl1_focus_aw
#define focus_ah mccchannel_10_cave1_cyl1_focus_ah
#define focus_xw mccchannel_10_cave1_cyl1_focus_xw
#define focus_xh mccchannel_10_cave1_cyl1_focus_xh
#define focus_r mccchannel_10_cave1_cyl1_focus_r
#define p_interact mccchannel_10_cave1_cyl1_p_interact
#define mask_string mccchannel_10_cave1_cyl1_mask_string
#define mask_setting mccchannel_10_cave1_cyl1_mask_setting
#define number_of_activations mccchannel_10_cave1_cyl1_number_of_activations
#line 185 "Union_cylinder.comp"
{
// Initializes the focusing system for this volume including input sanitation.
focus_initialize(&this_cylinder_volume.geometry, POS_A_COMP_INDEX(INDEX_CURRENT_COMP+target_index), POS_A_CURRENT_COMP, ROT_A_CURRENT_COMP, target_index, target_x, target_y, target_z, focus_aw, focus_ah, focus_xw, focus_xh, focus_r, NAME_CURRENT_COMP);

// Input sanitation for this geometry
if (radius <= 0) {
  printf("\nERROR in Union_cylinder named %s, the radius is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}

if (yheight <= 0) {
  printf("\nERROR in Union_cylinder named %s, yheight is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}

// Use sanitation
#ifdef MATERIAL_DETECTOR
if (global_material_list.num_elements == 0) {
  // Here if the user have defined a material, but only after this material
  printf("\nERROR: Need to define a material using Union_make_material before using a Union geometry component. \n");
  printf("       %s was defined before first use of Union_make_material.\n",NAME_CURRENT_COMP);
  exit(1);
}
#endif
#ifndef MATERIAL_DETECTOR
  printf("\nERROR: Need to define a material using Union_make_material before using a Union geometry component. \n");
  exit(1);
#endif


this_cylinder_volume.geometry.is_masked_volume = 0;
this_cylinder_volume.geometry.is_exit_volume = 0;
this_cylinder_volume.geometry.is_mask_volume = 0;

// Read the material input, or if it lacks, use automatic linking.
if (mask_string && strlen(mask_string) && strcmp(mask_string, "NULL") && strcmp(mask_string, "0")) {
    // A mask volume is used to limit the extend of other volumes, called the masked volumes. These are specified in the mask_string.
    // In order for a ray to enter a masked volume, it needs to be both in the region covered by that volume AND the mask volume.
    // When more than
    this_cylinder_volume.geometry.mask_mode = 1; // Default is mask mode is ALL
    if (mask_setting && strlen(mask_setting) && strcmp(mask_setting, "NULL") && strcmp(mask_setting, "0")) {
        if (strcmp(mask_setting,"ALL") == 0 || strcmp(mask_setting,"All") == 0) this_cylinder_volume.geometry.mask_mode = 1;
        else if (strcmp(mask_setting,"ANY") == 0 || strcmp(mask_setting,"Any") == 0) this_cylinder_volume.geometry.mask_mode = 2;
        else {
            printf("The mask_mode of component %s is set to %s, but must be either ALL or ANY.\n",NAME_CURRENT_COMP,mask_setting);
            exit(1);
        }
    }
    
    for (loop_index=0;loop_index<global_geometry_list.num_elements;loop_index++) {
        // Add mask list
        if (1 == manual_linking_function(global_geometry_list.elements[loop_index].name,mask_string)) {
            add_element_to_int_list(&this_cylinder_volume.geometry.mask_list,global_geometry_list.elements[loop_index].component_index);
            add_element_to_int_list(&global_geometry_list.elements[loop_index].Volume->geometry.masked_by_list,INDEX_CURRENT_COMP);
            global_geometry_list.elements[loop_index].Volume->geometry.is_masked_volume = 1;
            if (this_cylinder_volume.geometry.mask_mode == 2)
                global_geometry_list.elements[loop_index].Volume->geometry.mask_mode = 2;
            if (this_cylinder_volume.geometry.mask_mode == 1) {
                if (global_geometry_list.elements[loop_index].Volume->geometry.is_masked_volume == 1 && global_geometry_list.elements[loop_index].Volume->geometry.mask_mode != 2)
                    // If more than one mask is added to one volume, the ANY mode overwrites the (default) ALL mode.
                    global_geometry_list.elements[loop_index].Volume->geometry.mask_mode = 1;
            }
            
            found_geometries = 1;
        }
    }
    if (found_geometries == 0) {
        printf("The mask_string in geometry: %s did not find any of the specified volumes in the mask_string %s \n",NAME_CURRENT_COMP,mask_string);
        exit(1);
    }
    this_cylinder_volume.p_physics = malloc(sizeof(struct physics_struct));
    this_cylinder_volume.p_physics->is_vacuum = 0; // Makes this volume a vacuum
    this_cylinder_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
    this_cylinder_volume.p_physics->my_a = 0; // Should not be used.
    sprintf(this_cylinder_volume.p_physics->name,"Mask");
    this_cylinder_volume.geometry.is_mask_volume = 1;
    
    
// Read the material input, or if it lacks, use automatic linking.
} else if (material_string && strlen(material_string) && strcmp(material_string, "NULL") && strcmp(material_string, "0")) {
    // A geometry string was given, use it to determine which material
    if (0 == strcmp(material_string,"vacuum") || 0 == strcmp(material_string,"Vacuum")) {
        // One could have a global physics struct for vacuum instead of creating one for each
        this_cylinder_volume.p_physics = malloc(sizeof(struct physics_struct));
        this_cylinder_volume.p_physics->is_vacuum = 1; // Makes this volume a vacuum
        this_cylinder_volume.p_physics->number_of_processes = (int) 0;
        this_cylinder_volume.p_physics->my_a = 0; // Should not be used.
        sprintf(this_cylinder_volume.p_physics->name,"Vacuum");
    } else if (0 == strcmp(material_string,"exit") || 0 == strcmp(material_string,"Exit")) {
        // One could have a global physics struct for exit instead of creating one for each
        this_cylinder_volume.p_physics = malloc(sizeof(struct physics_struct));
        this_cylinder_volume.p_physics->is_vacuum = 1; // Makes this volume a vacuum
        this_cylinder_volume.p_physics->number_of_processes = (int) 0;
        this_cylinder_volume.p_physics->my_a = 0; // Should not be used.
        this_cylinder_volume.geometry.is_exit_volume = 1;
        sprintf(this_cylinder_volume.p_physics->name,"Exit");
    } else {
        for (loop_index=0;loop_index<global_material_list.num_elements;loop_index++) {
          if (0 == strcmp(material_string,global_material_list.elements[loop_index].name)) {
            this_cylinder_volume.p_physics = global_material_list.elements[loop_index].physics;
            break;
          }
          if (loop_index == global_material_list.num_elements-1) {
            printf("\n");
            printf("ERROR: The material string \"%s\" in Union geometry \"%s\" did not match a specified material. \n",material_string,NAME_CURRENT_COMP);
            printf("       The materials available at this point (need to be defined before the geometry): \n");
            for (loop_index=0;loop_index<global_material_list.num_elements;loop_index++)
              printf("         %s\n",global_material_list.elements[loop_index].name);
            printf("\n");
            printf("       It is also possible to use one of the defualt materials avaiable: \n");
            printf("           Vacuum (for a Volume without scattering or absorption)\n");
            printf("           Exit (for a Volume where the ray exits the component if it enters)\n");
            printf("           Mask (for a Volume that masks existing volumes specified in the mask_string\n");
            exit(1);
          }
        }
    }
} else {
    // Automatic linking, simply using the last defined material.
    #ifndef MATERIAL_DETECTOR
        printf("Need to define a material before the geometry to use automatic linking %s.\n",NAME_CURRENT_COMP);
        exit(1);
    #endif
    this_cylinder_volume.p_physics = global_material_list.elements[global_material_list.num_elements-1].physics;
}

sprintf(this_cylinder_volume.name,NAME_CURRENT_COMP);
sprintf(this_cylinder_volume.geometry.shape,"cylinder");
this_cylinder_volume.geometry.priority_value = priority;
// Currently the coordinates will be in absolute space.
this_cylinder_volume.geometry.center = POS_A_CURRENT_COMP;

this_cylinder_volume.geometry.geometry_p_interact = p_interact;
this_cylinder_storage.cyl_radius = radius;
this_cylinder_storage.height = yheight;
this_cylinder_volume.geometry.visualization_on = visualize;
this_cylinder_volume.geometry.geometry_parameters.p_cylinder_storage = &this_cylinder_storage;
this_cylinder_volume.geometry.within_function = &r_within_cylinder;
this_cylinder_volume.geometry.intersect_function = &sample_cylinder_intersect;
this_cylinder_volume.geometry.mcdisplay_function = &mcdisplay_cylinder_function;
this_cylinder_volume.geometry.shell_points = &cylinder_shell_points;
this_cylinder_volume.geometry.initialize_from_main_function = &initialize_cylinder_geometry_from_main_component;
this_cylinder_volume.geometry.process_rot_allocated = 0;
this_cylinder_volume.geometry.copy_geometry_parameters = &allocate_cylinder_storage_copy;

rot_copy(this_cylinder_volume.geometry.rotation_matrix,ROT_A_CURRENT_COMP);
rot_transpose(ROT_A_CURRENT_COMP,this_cylinder_volume.geometry.transpose_rotation_matrix);

// Initialize loggers
this_cylinder_volume.loggers.num_elements = 0;

// packing the information into the global_geometry_element, which is then included in the global_geometry_list.
sprintf(global_geometry_element.name,NAME_CURRENT_COMP);
global_geometry_element.activation_counter = number_of_activations;
global_geometry_element.component_index = INDEX_CURRENT_COMP;
global_geometry_element.Volume = &this_cylinder_volume; // Would be nicer if this m was a pointer, now we have the (small) data two places
add_element_to_geometry_list(&global_geometry_list,global_geometry_element);
}
#line 253610 "MACS_sample_kidney_box.c"
#undef number_of_activations
#undef mask_setting
#undef mask_string
#undef p_interact
#undef focus_r
#undef focus_xh
#undef focus_xw
#undef focus_ah
#undef focus_aw
#undef target_z
#undef target_y
#undef target_x
#undef target_index
#undef visualize
#undef yheight
#undef radius
#undef priority
#undef material_string
#undef this_cylinder_storage
#undef global_geometry_element
#undef this_cylinder_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

  /* Initializations for component channel_10_analyzer_1_center. */
  SIG_MESSAGE("channel_10_analyzer_1_center (Init)");

  /* Initializations for component channel_10_analyzer_1_rotated. */
  SIG_MESSAGE("channel_10_analyzer_1_rotated (Init)");

  /* Initializations for component channel_10_analyzer_1_array_crystal_array_0. */
  SIG_MESSAGE("channel_10_analyzer_1_array_crystal_array_0 (Init)");
#define mccompcurname  channel_10_analyzer_1_array_crystal_array_0
#define mccompcurtype  Union_box
#define mccompcurindex 510
#define loop_index mccchannel_10_analyzer_1_array_crystal_array_0_loop_index
#define this_box_volume mccchannel_10_analyzer_1_array_crystal_array_0_this_box_volume
#define global_geometry_element mccchannel_10_analyzer_1_array_crystal_array_0_global_geometry_element
#define this_box_storage mccchannel_10_analyzer_1_array_crystal_array_0_this_box_storage
#define material_string mccchannel_10_analyzer_1_array_crystal_array_0_material_string
#define priority mccchannel_10_analyzer_1_array_crystal_array_0_priority
#define xwidth mccchannel_10_analyzer_1_array_crystal_array_0_xwidth
#define yheight mccchannel_10_analyzer_1_array_crystal_array_0_yheight
#define zdepth mccchannel_10_analyzer_1_array_crystal_array_0_zdepth
#define xwidth2 mccchannel_10_analyzer_1_array_crystal_array_0_xwidth2
#define yheight2 mccchannel_10_analyzer_1_array_crystal_array_0_yheight2
#define visualize mccchannel_10_analyzer_1_array_crystal_array_0_visualize
#define target_index mccchannel_10_analyzer_1_array_crystal_array_0_target_index
#define target_x mccchannel_10_analyzer_1_array_crystal_array_0_target_x
#define target_y mccchannel_10_analyzer_1_array_crystal_array_0_target_y
#define target_z mccchannel_10_analyzer_1_array_crystal_array_0_target_z
#define focus_aw mccchannel_10_analyzer_1_array_crystal_array_0_focus_aw
#define focus_ah mccchannel_10_analyzer_1_array_crystal_array_0_focus_ah
#define focus_xw mccchannel_10_analyzer_1_array_crystal_array_0_focus_xw
#define focus_xh mccchannel_10_analyzer_1_array_crystal_array_0_focus_xh
#define focus_r mccchannel_10_analyzer_1_array_crystal_array_0_focus_r
#define p_interact mccchannel_10_analyzer_1_array_crystal_array_0_p_interact
#define mask_string mccchannel_10_analyzer_1_array_crystal_array_0_mask_string
#define mask_setting mccchannel_10_analyzer_1_array_crystal_array_0_mask_setting
#define number_of_activations mccchannel_10_analyzer_1_array_crystal_array_0_number_of_activations
#line 224 "Union_box.comp"
{
// Initializes the focusing system for this volume including input sanitation.
focus_initialize(&this_box_volume.geometry, POS_A_COMP_INDEX(INDEX_CURRENT_COMP+target_index), POS_A_CURRENT_COMP, ROT_A_CURRENT_COMP, target_index, target_x, target_y, target_z, focus_aw, focus_ah, focus_xw, focus_xh, focus_r, NAME_CURRENT_COMP);

// Input sanitation for this geometry
if (xwidth <= 0) {
  printf("\nERROR in Union_box named %s, the xwidth is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (yheight <= 0) {
  printf("\nERROR in Union_box named %s, yheight is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (zdepth <= 0) {
  printf("\nERROR in Union_box named %s, zdepth is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (xwidth2 <= 0 && xwidth2 != -1) {
  printf("\nERROR in Union_box named %s, the xwidth2 is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (yheight2 <= 0 && yheight2 != -1) {
  printf("\nERROR in Union_box named %s, yheight2 is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}

// Use sanitation
if (global_material_list.num_elements == 0) {
  printf("\nERROR: Need to define a material using Union_make_material before using a Union geometry component. \n");
  printf("       %s was defined before first use of Union_make_material.\n",NAME_CURRENT_COMP);
  exit(1);
}

this_box_volume.geometry.is_masked_volume = 0;
this_box_volume.geometry.is_exit_volume = 0;
this_box_volume.geometry.is_mask_volume = 0;
// check if the volume is a mask, if it is the material string is irelevant.
if (mask_string && strlen(mask_string) && strcmp(mask_string, "NULL") && strcmp(mask_string, "0")) {
    // A mask volume is used to limit the extend of other volumes, called the masked volumes. These are specified in the mask_string.
    // In order for a ray to enter a masked volume, it needs to be both in the region covered by that volume AND the mask volume.
    // When more than
    this_box_volume.geometry.mask_mode = 1; // Default is mask mode is ALL
    if (mask_setting && strlen(mask_setting) && strcmp(mask_setting, "NULL") && strcmp(mask_setting, "0")) {
        if (strcmp(mask_setting,"ALL") == 0 || strcmp(mask_setting,"All") == 0) this_box_volume.geometry.mask_mode = 1;
        else if (strcmp(mask_setting,"ANY") == 0 || strcmp(mask_setting,"Any") == 0) this_box_volume.geometry.mask_mode = 2;
        else {
            printf("The mask_mode of component %s is set to %s, but must be either ALL or ANY.\n",NAME_CURRENT_COMP,mask_setting);
            exit(1);
        }
    }
    
    for (loop_index=0;loop_index<global_geometry_list.num_elements;loop_index++) {
        // Add mask list
        if (1 == manual_linking_function(global_geometry_list.elements[loop_index].name,mask_string)) {
            add_element_to_int_list(&this_box_volume.geometry.mask_list,global_geometry_list.elements[loop_index].component_index);
            add_element_to_int_list(&global_geometry_list.elements[loop_index].Volume->geometry.masked_by_list,INDEX_CURRENT_COMP);
            global_geometry_list.elements[loop_index].Volume->geometry.is_masked_volume = 1;
            if (this_box_volume.geometry.mask_mode == 2)
                global_geometry_list.elements[loop_index].Volume->geometry.mask_mode = 2;
            if (this_box_volume.geometry.mask_mode == 1) {
                if (global_geometry_list.elements[loop_index].Volume->geometry.is_masked_volume == 1 && global_geometry_list.elements[loop_index].Volume->geometry.mask_mode != 2)
                    // If more than one mask is added to one volume, the ANY mode overwrites the (default) ALL mode.
                    global_geometry_list.elements[loop_index].Volume->geometry.mask_mode = 1;
            }
            
            found_geometries = 1;
        }
    }
    if (found_geometries == 0) {
        printf("The mask_string in geometry: %s did not find any of the specified volumes in the mask_string %s \n",NAME_CURRENT_COMP,mask_string);
        exit(1);
    }
    this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
    this_box_volume.p_physics->is_vacuum = 0; // Makes this volume a vacuum
    this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
    this_box_volume.p_physics->my_a = 0; // Should not be used.
    sprintf(this_box_volume.p_physics->name,"Mask");
    this_box_volume.geometry.is_mask_volume = 1;
    
    
// Read the material input, or if it lacks, use automatic linking.
} else if (material_string && strlen(material_string) && strcmp(material_string, "NULL") && strcmp(material_string, "0")) {
    // A geometry string was given, use it to determine which material
    if (0 == strcmp(material_string,"vacuum") || 0 == strcmp(material_string,"Vacuum")) {
        // One could have a global physics struct for vacuum instead of creating one for each
        this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
        this_box_volume.p_physics->is_vacuum = 1; // Makes this volume a vacuum
        this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
        this_box_volume.p_physics->my_a = 0; // Should not be used.
        sprintf(this_box_volume.p_physics->name,"Vacuum");
    } else if (0 == strcmp(material_string,"exit") || 0 == strcmp(material_string,"Exit")) {
        // One could have a global physics struct for vacuum instead of creating one for each
        this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
        this_box_volume.p_physics->is_vacuum = 1; // Makes this volume a vacuum
        this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
        this_box_volume.p_physics->my_a = 0; // Should not be used.
        this_box_volume.geometry.is_exit_volume = 1;
        sprintf(this_box_volume.p_physics->name,"Exit");
    } else {
        #ifndef MATERIAL_DETECTOR
            printf("Need to define a material before refering to it in a geometry %s.\n",NAME_CURRENT_COMP);
            exit(1);
        #endif
        for (loop_index=0;loop_index<global_material_list.num_elements;loop_index++) {
            if (0 == strcmp(material_string,global_material_list.elements[loop_index].name)) {
                this_box_volume.p_physics = global_material_list.elements[loop_index].physics;
                break;
            }
            if (loop_index == global_material_list.num_elements-1) {
            printf("\n");
            printf("ERROR: The material string \"%s\" in Union geometry \"%s\" did not match a specified material. \n",material_string,NAME_CURRENT_COMP);
            printf("       The materials available at this point (need to be defined before the geometry): \n");
            for (loop_index=0;loop_index<global_material_list.num_elements;loop_index++)
              printf("         %s\n",global_material_list.elements[loop_index].name);
            printf("\n");
            printf("       It is also possible to use one of the defualt materials avaiable: \n");
            printf("           Vacuum (for a Volume without scattering or absorption)\n");
            printf("           Exit (for a Volume where the ray exits the component if it enters)\n");
            printf("           Mask (for a Volume that masks existing volumes specified in the mask_string\n");
            exit(1);
          }
        }
    }
} else {
    // Automatic linking, simply using the last defined material.
    #ifndef MATERIAL_DETECTOR
        printf("Need to define a material before the geometry to use automatic linking %s.\n",NAME_CURRENT_COMP);
        exit(1);
    #endif
    this_box_volume.p_physics = global_material_list.elements[global_material_list.num_elements-1].physics;
}

sprintf(this_box_volume.name,NAME_CURRENT_COMP);
sprintf(this_box_volume.geometry.shape,"box");
this_box_volume.geometry.priority_value = priority;
this_box_volume.geometry.geometry_p_interact = p_interact;
// Currently the coordinates will be in absolute space.
this_box_volume.geometry.center = POS_A_CURRENT_COMP;

this_box_storage.z_depth = zdepth;
this_box_storage.x_width1 = xwidth;
this_box_storage.y_height1 = yheight;

this_box_storage.is_rectangle = 0;
if (xwidth2 < 0 && yheight2 < 0) this_box_storage.is_rectangle = 1;
if (xwidth == xwidth2 && yheight == yheight2) this_box_storage.is_rectangle = 1;

if (xwidth2 < 0) {
    this_box_storage.x_width2 = xwidth;
    xwidth2 = xwidth;
} else this_box_storage.x_width2 = xwidth2;

if (yheight2 < 0) {
    this_box_storage.y_height2 = yheight;
    yheight2 = yheight;
} else this_box_storage.y_height2 = yheight2;


this_box_storage.normal_vectors[0] = coords_set(0,0,1);
this_box_storage.normal_vectors[1] = coords_set(0,0,1);

// for sides with y component = 0
x_component = 2*zdepth/sqrt((xwidth-xwidth2)*(xwidth-xwidth2)+4*zdepth*zdepth);
z_component = (xwidth-xwidth2)/sqrt(4*zdepth*zdepth+(xwidth-xwidth2)*(xwidth-xwidth2));

this_box_storage.normal_vectors[2] = coords_set(x_component,0,z_component);
this_box_storage.normal_vectors[3] = coords_set(-x_component,0,z_component);

// for sides with x component = 0
y_component = 2*zdepth/sqrt((yheight-yheight2)*(yheight-yheight2)+4*zdepth*zdepth);
z_component = (yheight-yheight2)/sqrt(4*zdepth*zdepth+(yheight-yheight2)*(yheight-yheight2));

this_box_storage.normal_vectors[4] = coords_set(0,y_component,z_component);
this_box_storage.normal_vectors[5] = coords_set(0,-y_component,z_component);

this_box_volume.geometry.visualization_on = visualize;

this_box_volume.geometry.geometry_parameters.p_box_storage = &this_box_storage;

// Assign pointers to functions for intersection with the shape, checking if a point is inside the shape
if (this_box_storage.is_rectangle == 1) {
this_box_volume.geometry.intersect_function = &sample_box_intersect_simple;
this_box_volume.geometry.within_function = &r_within_box_simple;
}
else {
this_box_volume.geometry.intersect_function = &sample_box_intersect_advanced;
this_box_volume.geometry.within_function = &r_within_box_advanced;
}

this_box_volume.geometry.shell_points = &box_shell_points;
this_box_volume.geometry.mcdisplay_function = &mcdisplay_box_function;
this_box_volume.geometry.initialize_from_main_function = &initialize_box_geometry_from_main_component;
this_box_volume.geometry.process_rot_allocated = 0;

this_box_volume.geometry.copy_geometry_parameters = &allocate_box_storage_copy;

rot_copy(this_box_volume.geometry.rotation_matrix,ROT_A_CURRENT_COMP); //check how ROT_R_CURRENT_COMP would work
rot_transpose(ROT_A_CURRENT_COMP,this_box_volume.geometry.transpose_rotation_matrix);

// Initialize loggers
this_box_volume.loggers.num_elements = 0;

// packing the information into the global_geometry_element, which is then included in the global_geometry_list.
sprintf(global_geometry_element.name,NAME_CURRENT_COMP);
global_geometry_element.activation_counter = number_of_activations;
global_geometry_element.component_index = INDEX_CURRENT_COMP;
global_geometry_element.Volume = &this_box_volume; // Would be nicer if this m was a pointer, now we have the (small) data two places
add_element_to_geometry_list(&global_geometry_list,global_geometry_element);
}
#line 253883 "MACS_sample_kidney_box.c"
#undef number_of_activations
#undef mask_setting
#undef mask_string
#undef p_interact
#undef focus_r
#undef focus_xh
#undef focus_xw
#undef focus_ah
#undef focus_aw
#undef target_z
#undef target_y
#undef target_x
#undef target_index
#undef visualize
#undef yheight2
#undef xwidth2
#undef zdepth
#undef yheight
#undef xwidth
#undef priority
#undef material_string
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

  /* Initializations for component channel_10_analyzer_1_array_crystal_array_1. */
  SIG_MESSAGE("channel_10_analyzer_1_array_crystal_array_1 (Init)");
#define mccompcurname  channel_10_analyzer_1_array_crystal_array_1
#define mccompcurtype  Union_box
#define mccompcurindex 511
#define loop_index mccchannel_10_analyzer_1_array_crystal_array_1_loop_index
#define this_box_volume mccchannel_10_analyzer_1_array_crystal_array_1_this_box_volume
#define global_geometry_element mccchannel_10_analyzer_1_array_crystal_array_1_global_geometry_element
#define this_box_storage mccchannel_10_analyzer_1_array_crystal_array_1_this_box_storage
#define material_string mccchannel_10_analyzer_1_array_crystal_array_1_material_string
#define priority mccchannel_10_analyzer_1_array_crystal_array_1_priority
#define xwidth mccchannel_10_analyzer_1_array_crystal_array_1_xwidth
#define yheight mccchannel_10_analyzer_1_array_crystal_array_1_yheight
#define zdepth mccchannel_10_analyzer_1_array_crystal_array_1_zdepth
#define xwidth2 mccchannel_10_analyzer_1_array_crystal_array_1_xwidth2
#define yheight2 mccchannel_10_analyzer_1_array_crystal_array_1_yheight2
#define visualize mccchannel_10_analyzer_1_array_crystal_array_1_visualize
#define target_index mccchannel_10_analyzer_1_array_crystal_array_1_target_index
#define target_x mccchannel_10_analyzer_1_array_crystal_array_1_target_x
#define target_y mccchannel_10_analyzer_1_array_crystal_array_1_target_y
#define target_z mccchannel_10_analyzer_1_array_crystal_array_1_target_z
#define focus_aw mccchannel_10_analyzer_1_array_crystal_array_1_focus_aw
#define focus_ah mccchannel_10_analyzer_1_array_crystal_array_1_focus_ah
#define focus_xw mccchannel_10_analyzer_1_array_crystal_array_1_focus_xw
#define focus_xh mccchannel_10_analyzer_1_array_crystal_array_1_focus_xh
#define focus_r mccchannel_10_analyzer_1_array_crystal_array_1_focus_r
#define p_interact mccchannel_10_analyzer_1_array_crystal_array_1_p_interact
#define mask_string mccchannel_10_analyzer_1_array_crystal_array_1_mask_string
#define mask_setting mccchannel_10_analyzer_1_array_crystal_array_1_mask_setting
#define number_of_activations mccchannel_10_analyzer_1_array_crystal_array_1_number_of_activations
#line 224 "Union_box.comp"
{
// Initializes the focusing system for this volume including input sanitation.
focus_initialize(&this_box_volume.geometry, POS_A_COMP_INDEX(INDEX_CURRENT_COMP+target_index), POS_A_CURRENT_COMP, ROT_A_CURRENT_COMP, target_index, target_x, target_y, target_z, focus_aw, focus_ah, focus_xw, focus_xh, focus_r, NAME_CURRENT_COMP);

// Input sanitation for this geometry
if (xwidth <= 0) {
  printf("\nERROR in Union_box named %s, the xwidth is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (yheight <= 0) {
  printf("\nERROR in Union_box named %s, yheight is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (zdepth <= 0) {
  printf("\nERROR in Union_box named %s, zdepth is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (xwidth2 <= 0 && xwidth2 != -1) {
  printf("\nERROR in Union_box named %s, the xwidth2 is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (yheight2 <= 0 && yheight2 != -1) {
  printf("\nERROR in Union_box named %s, yheight2 is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}

// Use sanitation
if (global_material_list.num_elements == 0) {
  printf("\nERROR: Need to define a material using Union_make_material before using a Union geometry component. \n");
  printf("       %s was defined before first use of Union_make_material.\n",NAME_CURRENT_COMP);
  exit(1);
}

this_box_volume.geometry.is_masked_volume = 0;
this_box_volume.geometry.is_exit_volume = 0;
this_box_volume.geometry.is_mask_volume = 0;
// check if the volume is a mask, if it is the material string is irelevant.
if (mask_string && strlen(mask_string) && strcmp(mask_string, "NULL") && strcmp(mask_string, "0")) {
    // A mask volume is used to limit the extend of other volumes, called the masked volumes. These are specified in the mask_string.
    // In order for a ray to enter a masked volume, it needs to be both in the region covered by that volume AND the mask volume.
    // When more than
    this_box_volume.geometry.mask_mode = 1; // Default is mask mode is ALL
    if (mask_setting && strlen(mask_setting) && strcmp(mask_setting, "NULL") && strcmp(mask_setting, "0")) {
        if (strcmp(mask_setting,"ALL") == 0 || strcmp(mask_setting,"All") == 0) this_box_volume.geometry.mask_mode = 1;
        else if (strcmp(mask_setting,"ANY") == 0 || strcmp(mask_setting,"Any") == 0) this_box_volume.geometry.mask_mode = 2;
        else {
            printf("The mask_mode of component %s is set to %s, but must be either ALL or ANY.\n",NAME_CURRENT_COMP,mask_setting);
            exit(1);
        }
    }
    
    for (loop_index=0;loop_index<global_geometry_list.num_elements;loop_index++) {
        // Add mask list
        if (1 == manual_linking_function(global_geometry_list.elements[loop_index].name,mask_string)) {
            add_element_to_int_list(&this_box_volume.geometry.mask_list,global_geometry_list.elements[loop_index].component_index);
            add_element_to_int_list(&global_geometry_list.elements[loop_index].Volume->geometry.masked_by_list,INDEX_CURRENT_COMP);
            global_geometry_list.elements[loop_index].Volume->geometry.is_masked_volume = 1;
            if (this_box_volume.geometry.mask_mode == 2)
                global_geometry_list.elements[loop_index].Volume->geometry.mask_mode = 2;
            if (this_box_volume.geometry.mask_mode == 1) {
                if (global_geometry_list.elements[loop_index].Volume->geometry.is_masked_volume == 1 && global_geometry_list.elements[loop_index].Volume->geometry.mask_mode != 2)
                    // If more than one mask is added to one volume, the ANY mode overwrites the (default) ALL mode.
                    global_geometry_list.elements[loop_index].Volume->geometry.mask_mode = 1;
            }
            
            found_geometries = 1;
        }
    }
    if (found_geometries == 0) {
        printf("The mask_string in geometry: %s did not find any of the specified volumes in the mask_string %s \n",NAME_CURRENT_COMP,mask_string);
        exit(1);
    }
    this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
    this_box_volume.p_physics->is_vacuum = 0; // Makes this volume a vacuum
    this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
    this_box_volume.p_physics->my_a = 0; // Should not be used.
    sprintf(this_box_volume.p_physics->name,"Mask");
    this_box_volume.geometry.is_mask_volume = 1;
    
    
// Read the material input, or if it lacks, use automatic linking.
} else if (material_string && strlen(material_string) && strcmp(material_string, "NULL") && strcmp(material_string, "0")) {
    // A geometry string was given, use it to determine which material
    if (0 == strcmp(material_string,"vacuum") || 0 == strcmp(material_string,"Vacuum")) {
        // One could have a global physics struct for vacuum instead of creating one for each
        this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
        this_box_volume.p_physics->is_vacuum = 1; // Makes this volume a vacuum
        this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
        this_box_volume.p_physics->my_a = 0; // Should not be used.
        sprintf(this_box_volume.p_physics->name,"Vacuum");
    } else if (0 == strcmp(material_string,"exit") || 0 == strcmp(material_string,"Exit")) {
        // One could have a global physics struct for vacuum instead of creating one for each
        this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
        this_box_volume.p_physics->is_vacuum = 1; // Makes this volume a vacuum
        this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
        this_box_volume.p_physics->my_a = 0; // Should not be used.
        this_box_volume.geometry.is_exit_volume = 1;
        sprintf(this_box_volume.p_physics->name,"Exit");
    } else {
        #ifndef MATERIAL_DETECTOR
            printf("Need to define a material before refering to it in a geometry %s.\n",NAME_CURRENT_COMP);
            exit(1);
        #endif
        for (loop_index=0;loop_index<global_material_list.num_elements;loop_index++) {
            if (0 == strcmp(material_string,global_material_list.elements[loop_index].name)) {
                this_box_volume.p_physics = global_material_list.elements[loop_index].physics;
                break;
            }
            if (loop_index == global_material_list.num_elements-1) {
            printf("\n");
            printf("ERROR: The material string \"%s\" in Union geometry \"%s\" did not match a specified material. \n",material_string,NAME_CURRENT_COMP);
            printf("       The materials available at this point (need to be defined before the geometry): \n");
            for (loop_index=0;loop_index<global_material_list.num_elements;loop_index++)
              printf("         %s\n",global_material_list.elements[loop_index].name);
            printf("\n");
            printf("       It is also possible to use one of the defualt materials avaiable: \n");
            printf("           Vacuum (for a Volume without scattering or absorption)\n");
            printf("           Exit (for a Volume where the ray exits the component if it enters)\n");
            printf("           Mask (for a Volume that masks existing volumes specified in the mask_string\n");
            exit(1);
          }
        }
    }
} else {
    // Automatic linking, simply using the last defined material.
    #ifndef MATERIAL_DETECTOR
        printf("Need to define a material before the geometry to use automatic linking %s.\n",NAME_CURRENT_COMP);
        exit(1);
    #endif
    this_box_volume.p_physics = global_material_list.elements[global_material_list.num_elements-1].physics;
}

sprintf(this_box_volume.name,NAME_CURRENT_COMP);
sprintf(this_box_volume.geometry.shape,"box");
this_box_volume.geometry.priority_value = priority;
this_box_volume.geometry.geometry_p_interact = p_interact;
// Currently the coordinates will be in absolute space.
this_box_volume.geometry.center = POS_A_CURRENT_COMP;

this_box_storage.z_depth = zdepth;
this_box_storage.x_width1 = xwidth;
this_box_storage.y_height1 = yheight;

this_box_storage.is_rectangle = 0;
if (xwidth2 < 0 && yheight2 < 0) this_box_storage.is_rectangle = 1;
if (xwidth == xwidth2 && yheight == yheight2) this_box_storage.is_rectangle = 1;

if (xwidth2 < 0) {
    this_box_storage.x_width2 = xwidth;
    xwidth2 = xwidth;
} else this_box_storage.x_width2 = xwidth2;

if (yheight2 < 0) {
    this_box_storage.y_height2 = yheight;
    yheight2 = yheight;
} else this_box_storage.y_height2 = yheight2;


this_box_storage.normal_vectors[0] = coords_set(0,0,1);
this_box_storage.normal_vectors[1] = coords_set(0,0,1);

// for sides with y component = 0
x_component = 2*zdepth/sqrt((xwidth-xwidth2)*(xwidth-xwidth2)+4*zdepth*zdepth);
z_component = (xwidth-xwidth2)/sqrt(4*zdepth*zdepth+(xwidth-xwidth2)*(xwidth-xwidth2));

this_box_storage.normal_vectors[2] = coords_set(x_component,0,z_component);
this_box_storage.normal_vectors[3] = coords_set(-x_component,0,z_component);

// for sides with x component = 0
y_component = 2*zdepth/sqrt((yheight-yheight2)*(yheight-yheight2)+4*zdepth*zdepth);
z_component = (yheight-yheight2)/sqrt(4*zdepth*zdepth+(yheight-yheight2)*(yheight-yheight2));

this_box_storage.normal_vectors[4] = coords_set(0,y_component,z_component);
this_box_storage.normal_vectors[5] = coords_set(0,-y_component,z_component);

this_box_volume.geometry.visualization_on = visualize;

this_box_volume.geometry.geometry_parameters.p_box_storage = &this_box_storage;

// Assign pointers to functions for intersection with the shape, checking if a point is inside the shape
if (this_box_storage.is_rectangle == 1) {
this_box_volume.geometry.intersect_function = &sample_box_intersect_simple;
this_box_volume.geometry.within_function = &r_within_box_simple;
}
else {
this_box_volume.geometry.intersect_function = &sample_box_intersect_advanced;
this_box_volume.geometry.within_function = &r_within_box_advanced;
}

this_box_volume.geometry.shell_points = &box_shell_points;
this_box_volume.geometry.mcdisplay_function = &mcdisplay_box_function;
this_box_volume.geometry.initialize_from_main_function = &initialize_box_geometry_from_main_component;
this_box_volume.geometry.process_rot_allocated = 0;

this_box_volume.geometry.copy_geometry_parameters = &allocate_box_storage_copy;

rot_copy(this_box_volume.geometry.rotation_matrix,ROT_A_CURRENT_COMP); //check how ROT_R_CURRENT_COMP would work
rot_transpose(ROT_A_CURRENT_COMP,this_box_volume.geometry.transpose_rotation_matrix);

// Initialize loggers
this_box_volume.loggers.num_elements = 0;

// packing the information into the global_geometry_element, which is then included in the global_geometry_list.
sprintf(global_geometry_element.name,NAME_CURRENT_COMP);
global_geometry_element.activation_counter = number_of_activations;
global_geometry_element.component_index = INDEX_CURRENT_COMP;
global_geometry_element.Volume = &this_box_volume; // Would be nicer if this m was a pointer, now we have the (small) data two places
add_element_to_geometry_list(&global_geometry_list,global_geometry_element);
}
#line 254153 "MACS_sample_kidney_box.c"
#undef number_of_activations
#undef mask_setting
#undef mask_string
#undef p_interact
#undef focus_r
#undef focus_xh
#undef focus_xw
#undef focus_ah
#undef focus_aw
#undef target_z
#undef target_y
#undef target_x
#undef target_index
#undef visualize
#undef yheight2
#undef xwidth2
#undef zdepth
#undef yheight
#undef xwidth
#undef priority
#undef material_string
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

  /* Initializations for component channel_10_analyzer_1_array_crystal_array_2. */
  SIG_MESSAGE("channel_10_analyzer_1_array_crystal_array_2 (Init)");
#define mccompcurname  channel_10_analyzer_1_array_crystal_array_2
#define mccompcurtype  Union_box
#define mccompcurindex 512
#define loop_index mccchannel_10_analyzer_1_array_crystal_array_2_loop_index
#define this_box_volume mccchannel_10_analyzer_1_array_crystal_array_2_this_box_volume
#define global_geometry_element mccchannel_10_analyzer_1_array_crystal_array_2_global_geometry_element
#define this_box_storage mccchannel_10_analyzer_1_array_crystal_array_2_this_box_storage
#define material_string mccchannel_10_analyzer_1_array_crystal_array_2_material_string
#define priority mccchannel_10_analyzer_1_array_crystal_array_2_priority
#define xwidth mccchannel_10_analyzer_1_array_crystal_array_2_xwidth
#define yheight mccchannel_10_analyzer_1_array_crystal_array_2_yheight
#define zdepth mccchannel_10_analyzer_1_array_crystal_array_2_zdepth
#define xwidth2 mccchannel_10_analyzer_1_array_crystal_array_2_xwidth2
#define yheight2 mccchannel_10_analyzer_1_array_crystal_array_2_yheight2
#define visualize mccchannel_10_analyzer_1_array_crystal_array_2_visualize
#define target_index mccchannel_10_analyzer_1_array_crystal_array_2_target_index
#define target_x mccchannel_10_analyzer_1_array_crystal_array_2_target_x
#define target_y mccchannel_10_analyzer_1_array_crystal_array_2_target_y
#define target_z mccchannel_10_analyzer_1_array_crystal_array_2_target_z
#define focus_aw mccchannel_10_analyzer_1_array_crystal_array_2_focus_aw
#define focus_ah mccchannel_10_analyzer_1_array_crystal_array_2_focus_ah
#define focus_xw mccchannel_10_analyzer_1_array_crystal_array_2_focus_xw
#define focus_xh mccchannel_10_analyzer_1_array_crystal_array_2_focus_xh
#define focus_r mccchannel_10_analyzer_1_array_crystal_array_2_focus_r
#define p_interact mccchannel_10_analyzer_1_array_crystal_array_2_p_interact
#define mask_string mccchannel_10_analyzer_1_array_crystal_array_2_mask_string
#define mask_setting mccchannel_10_analyzer_1_array_crystal_array_2_mask_setting
#define number_of_activations mccchannel_10_analyzer_1_array_crystal_array_2_number_of_activations
#line 224 "Union_box.comp"
{
// Initializes the focusing system for this volume including input sanitation.
focus_initialize(&this_box_volume.geometry, POS_A_COMP_INDEX(INDEX_CURRENT_COMP+target_index), POS_A_CURRENT_COMP, ROT_A_CURRENT_COMP, target_index, target_x, target_y, target_z, focus_aw, focus_ah, focus_xw, focus_xh, focus_r, NAME_CURRENT_COMP);

// Input sanitation for this geometry
if (xwidth <= 0) {
  printf("\nERROR in Union_box named %s, the xwidth is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (yheight <= 0) {
  printf("\nERROR in Union_box named %s, yheight is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (zdepth <= 0) {
  printf("\nERROR in Union_box named %s, zdepth is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (xwidth2 <= 0 && xwidth2 != -1) {
  printf("\nERROR in Union_box named %s, the xwidth2 is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (yheight2 <= 0 && yheight2 != -1) {
  printf("\nERROR in Union_box named %s, yheight2 is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}

// Use sanitation
if (global_material_list.num_elements == 0) {
  printf("\nERROR: Need to define a material using Union_make_material before using a Union geometry component. \n");
  printf("       %s was defined before first use of Union_make_material.\n",NAME_CURRENT_COMP);
  exit(1);
}

this_box_volume.geometry.is_masked_volume = 0;
this_box_volume.geometry.is_exit_volume = 0;
this_box_volume.geometry.is_mask_volume = 0;
// check if the volume is a mask, if it is the material string is irelevant.
if (mask_string && strlen(mask_string) && strcmp(mask_string, "NULL") && strcmp(mask_string, "0")) {
    // A mask volume is used to limit the extend of other volumes, called the masked volumes. These are specified in the mask_string.
    // In order for a ray to enter a masked volume, it needs to be both in the region covered by that volume AND the mask volume.
    // When more than
    this_box_volume.geometry.mask_mode = 1; // Default is mask mode is ALL
    if (mask_setting && strlen(mask_setting) && strcmp(mask_setting, "NULL") && strcmp(mask_setting, "0")) {
        if (strcmp(mask_setting,"ALL") == 0 || strcmp(mask_setting,"All") == 0) this_box_volume.geometry.mask_mode = 1;
        else if (strcmp(mask_setting,"ANY") == 0 || strcmp(mask_setting,"Any") == 0) this_box_volume.geometry.mask_mode = 2;
        else {
            printf("The mask_mode of component %s is set to %s, but must be either ALL or ANY.\n",NAME_CURRENT_COMP,mask_setting);
            exit(1);
        }
    }
    
    for (loop_index=0;loop_index<global_geometry_list.num_elements;loop_index++) {
        // Add mask list
        if (1 == manual_linking_function(global_geometry_list.elements[loop_index].name,mask_string)) {
            add_element_to_int_list(&this_box_volume.geometry.mask_list,global_geometry_list.elements[loop_index].component_index);
            add_element_to_int_list(&global_geometry_list.elements[loop_index].Volume->geometry.masked_by_list,INDEX_CURRENT_COMP);
            global_geometry_list.elements[loop_index].Volume->geometry.is_masked_volume = 1;
            if (this_box_volume.geometry.mask_mode == 2)
                global_geometry_list.elements[loop_index].Volume->geometry.mask_mode = 2;
            if (this_box_volume.geometry.mask_mode == 1) {
                if (global_geometry_list.elements[loop_index].Volume->geometry.is_masked_volume == 1 && global_geometry_list.elements[loop_index].Volume->geometry.mask_mode != 2)
                    // If more than one mask is added to one volume, the ANY mode overwrites the (default) ALL mode.
                    global_geometry_list.elements[loop_index].Volume->geometry.mask_mode = 1;
            }
            
            found_geometries = 1;
        }
    }
    if (found_geometries == 0) {
        printf("The mask_string in geometry: %s did not find any of the specified volumes in the mask_string %s \n",NAME_CURRENT_COMP,mask_string);
        exit(1);
    }
    this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
    this_box_volume.p_physics->is_vacuum = 0; // Makes this volume a vacuum
    this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
    this_box_volume.p_physics->my_a = 0; // Should not be used.
    sprintf(this_box_volume.p_physics->name,"Mask");
    this_box_volume.geometry.is_mask_volume = 1;
    
    
// Read the material input, or if it lacks, use automatic linking.
} else if (material_string && strlen(material_string) && strcmp(material_string, "NULL") && strcmp(material_string, "0")) {
    // A geometry string was given, use it to determine which material
    if (0 == strcmp(material_string,"vacuum") || 0 == strcmp(material_string,"Vacuum")) {
        // One could have a global physics struct for vacuum instead of creating one for each
        this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
        this_box_volume.p_physics->is_vacuum = 1; // Makes this volume a vacuum
        this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
        this_box_volume.p_physics->my_a = 0; // Should not be used.
        sprintf(this_box_volume.p_physics->name,"Vacuum");
    } else if (0 == strcmp(material_string,"exit") || 0 == strcmp(material_string,"Exit")) {
        // One could have a global physics struct for vacuum instead of creating one for each
        this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
        this_box_volume.p_physics->is_vacuum = 1; // Makes this volume a vacuum
        this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
        this_box_volume.p_physics->my_a = 0; // Should not be used.
        this_box_volume.geometry.is_exit_volume = 1;
        sprintf(this_box_volume.p_physics->name,"Exit");
    } else {
        #ifndef MATERIAL_DETECTOR
            printf("Need to define a material before refering to it in a geometry %s.\n",NAME_CURRENT_COMP);
            exit(1);
        #endif
        for (loop_index=0;loop_index<global_material_list.num_elements;loop_index++) {
            if (0 == strcmp(material_string,global_material_list.elements[loop_index].name)) {
                this_box_volume.p_physics = global_material_list.elements[loop_index].physics;
                break;
            }
            if (loop_index == global_material_list.num_elements-1) {
            printf("\n");
            printf("ERROR: The material string \"%s\" in Union geometry \"%s\" did not match a specified material. \n",material_string,NAME_CURRENT_COMP);
            printf("       The materials available at this point (need to be defined before the geometry): \n");
            for (loop_index=0;loop_index<global_material_list.num_elements;loop_index++)
              printf("         %s\n",global_material_list.elements[loop_index].name);
            printf("\n");
            printf("       It is also possible to use one of the defualt materials avaiable: \n");
            printf("           Vacuum (for a Volume without scattering or absorption)\n");
            printf("           Exit (for a Volume where the ray exits the component if it enters)\n");
            printf("           Mask (for a Volume that masks existing volumes specified in the mask_string\n");
            exit(1);
          }
        }
    }
} else {
    // Automatic linking, simply using the last defined material.
    #ifndef MATERIAL_DETECTOR
        printf("Need to define a material before the geometry to use automatic linking %s.\n",NAME_CURRENT_COMP);
        exit(1);
    #endif
    this_box_volume.p_physics = global_material_list.elements[global_material_list.num_elements-1].physics;
}

sprintf(this_box_volume.name,NAME_CURRENT_COMP);
sprintf(this_box_volume.geometry.shape,"box");
this_box_volume.geometry.priority_value = priority;
this_box_volume.geometry.geometry_p_interact = p_interact;
// Currently the coordinates will be in absolute space.
this_box_volume.geometry.center = POS_A_CURRENT_COMP;

this_box_storage.z_depth = zdepth;
this_box_storage.x_width1 = xwidth;
this_box_storage.y_height1 = yheight;

this_box_storage.is_rectangle = 0;
if (xwidth2 < 0 && yheight2 < 0) this_box_storage.is_rectangle = 1;
if (xwidth == xwidth2 && yheight == yheight2) this_box_storage.is_rectangle = 1;

if (xwidth2 < 0) {
    this_box_storage.x_width2 = xwidth;
    xwidth2 = xwidth;
} else this_box_storage.x_width2 = xwidth2;

if (yheight2 < 0) {
    this_box_storage.y_height2 = yheight;
    yheight2 = yheight;
} else this_box_storage.y_height2 = yheight2;


this_box_storage.normal_vectors[0] = coords_set(0,0,1);
this_box_storage.normal_vectors[1] = coords_set(0,0,1);

// for sides with y component = 0
x_component = 2*zdepth/sqrt((xwidth-xwidth2)*(xwidth-xwidth2)+4*zdepth*zdepth);
z_component = (xwidth-xwidth2)/sqrt(4*zdepth*zdepth+(xwidth-xwidth2)*(xwidth-xwidth2));

this_box_storage.normal_vectors[2] = coords_set(x_component,0,z_component);
this_box_storage.normal_vectors[3] = coords_set(-x_component,0,z_component);

// for sides with x component = 0
y_component = 2*zdepth/sqrt((yheight-yheight2)*(yheight-yheight2)+4*zdepth*zdepth);
z_component = (yheight-yheight2)/sqrt(4*zdepth*zdepth+(yheight-yheight2)*(yheight-yheight2));

this_box_storage.normal_vectors[4] = coords_set(0,y_component,z_component);
this_box_storage.normal_vectors[5] = coords_set(0,-y_component,z_component);

this_box_volume.geometry.visualization_on = visualize;

this_box_volume.geometry.geometry_parameters.p_box_storage = &this_box_storage;

// Assign pointers to functions for intersection with the shape, checking if a point is inside the shape
if (this_box_storage.is_rectangle == 1) {
this_box_volume.geometry.intersect_function = &sample_box_intersect_simple;
this_box_volume.geometry.within_function = &r_within_box_simple;
}
else {
this_box_volume.geometry.intersect_function = &sample_box_intersect_advanced;
this_box_volume.geometry.within_function = &r_within_box_advanced;
}

this_box_volume.geometry.shell_points = &box_shell_points;
this_box_volume.geometry.mcdisplay_function = &mcdisplay_box_function;
this_box_volume.geometry.initialize_from_main_function = &initialize_box_geometry_from_main_component;
this_box_volume.geometry.process_rot_allocated = 0;

this_box_volume.geometry.copy_geometry_parameters = &allocate_box_storage_copy;

rot_copy(this_box_volume.geometry.rotation_matrix,ROT_A_CURRENT_COMP); //check how ROT_R_CURRENT_COMP would work
rot_transpose(ROT_A_CURRENT_COMP,this_box_volume.geometry.transpose_rotation_matrix);

// Initialize loggers
this_box_volume.loggers.num_elements = 0;

// packing the information into the global_geometry_element, which is then included in the global_geometry_list.
sprintf(global_geometry_element.name,NAME_CURRENT_COMP);
global_geometry_element.activation_counter = number_of_activations;
global_geometry_element.component_index = INDEX_CURRENT_COMP;
global_geometry_element.Volume = &this_box_volume; // Would be nicer if this m was a pointer, now we have the (small) data two places
add_element_to_geometry_list(&global_geometry_list,global_geometry_element);
}
#line 254423 "MACS_sample_kidney_box.c"
#undef number_of_activations
#undef mask_setting
#undef mask_string
#undef p_interact
#undef focus_r
#undef focus_xh
#undef focus_xw
#undef focus_ah
#undef focus_aw
#undef target_z
#undef target_y
#undef target_x
#undef target_index
#undef visualize
#undef yheight2
#undef xwidth2
#undef zdepth
#undef yheight
#undef xwidth
#undef priority
#undef material_string
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

  /* Initializations for component channel_10_analyzer_1_array_crystal_array_3. */
  SIG_MESSAGE("channel_10_analyzer_1_array_crystal_array_3 (Init)");
#define mccompcurname  channel_10_analyzer_1_array_crystal_array_3
#define mccompcurtype  Union_box
#define mccompcurindex 513
#define loop_index mccchannel_10_analyzer_1_array_crystal_array_3_loop_index
#define this_box_volume mccchannel_10_analyzer_1_array_crystal_array_3_this_box_volume
#define global_geometry_element mccchannel_10_analyzer_1_array_crystal_array_3_global_geometry_element
#define this_box_storage mccchannel_10_analyzer_1_array_crystal_array_3_this_box_storage
#define material_string mccchannel_10_analyzer_1_array_crystal_array_3_material_string
#define priority mccchannel_10_analyzer_1_array_crystal_array_3_priority
#define xwidth mccchannel_10_analyzer_1_array_crystal_array_3_xwidth
#define yheight mccchannel_10_analyzer_1_array_crystal_array_3_yheight
#define zdepth mccchannel_10_analyzer_1_array_crystal_array_3_zdepth
#define xwidth2 mccchannel_10_analyzer_1_array_crystal_array_3_xwidth2
#define yheight2 mccchannel_10_analyzer_1_array_crystal_array_3_yheight2
#define visualize mccchannel_10_analyzer_1_array_crystal_array_3_visualize
#define target_index mccchannel_10_analyzer_1_array_crystal_array_3_target_index
#define target_x mccchannel_10_analyzer_1_array_crystal_array_3_target_x
#define target_y mccchannel_10_analyzer_1_array_crystal_array_3_target_y
#define target_z mccchannel_10_analyzer_1_array_crystal_array_3_target_z
#define focus_aw mccchannel_10_analyzer_1_array_crystal_array_3_focus_aw
#define focus_ah mccchannel_10_analyzer_1_array_crystal_array_3_focus_ah
#define focus_xw mccchannel_10_analyzer_1_array_crystal_array_3_focus_xw
#define focus_xh mccchannel_10_analyzer_1_array_crystal_array_3_focus_xh
#define focus_r mccchannel_10_analyzer_1_array_crystal_array_3_focus_r
#define p_interact mccchannel_10_analyzer_1_array_crystal_array_3_p_interact
#define mask_string mccchannel_10_analyzer_1_array_crystal_array_3_mask_string
#define mask_setting mccchannel_10_analyzer_1_array_crystal_array_3_mask_setting
#define number_of_activations mccchannel_10_analyzer_1_array_crystal_array_3_number_of_activations
#line 224 "Union_box.comp"
{
// Initializes the focusing system for this volume including input sanitation.
focus_initialize(&this_box_volume.geometry, POS_A_COMP_INDEX(INDEX_CURRENT_COMP+target_index), POS_A_CURRENT_COMP, ROT_A_CURRENT_COMP, target_index, target_x, target_y, target_z, focus_aw, focus_ah, focus_xw, focus_xh, focus_r, NAME_CURRENT_COMP);

// Input sanitation for this geometry
if (xwidth <= 0) {
  printf("\nERROR in Union_box named %s, the xwidth is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (yheight <= 0) {
  printf("\nERROR in Union_box named %s, yheight is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (zdepth <= 0) {
  printf("\nERROR in Union_box named %s, zdepth is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (xwidth2 <= 0 && xwidth2 != -1) {
  printf("\nERROR in Union_box named %s, the xwidth2 is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (yheight2 <= 0 && yheight2 != -1) {
  printf("\nERROR in Union_box named %s, yheight2 is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}

// Use sanitation
if (global_material_list.num_elements == 0) {
  printf("\nERROR: Need to define a material using Union_make_material before using a Union geometry component. \n");
  printf("       %s was defined before first use of Union_make_material.\n",NAME_CURRENT_COMP);
  exit(1);
}

this_box_volume.geometry.is_masked_volume = 0;
this_box_volume.geometry.is_exit_volume = 0;
this_box_volume.geometry.is_mask_volume = 0;
// check if the volume is a mask, if it is the material string is irelevant.
if (mask_string && strlen(mask_string) && strcmp(mask_string, "NULL") && strcmp(mask_string, "0")) {
    // A mask volume is used to limit the extend of other volumes, called the masked volumes. These are specified in the mask_string.
    // In order for a ray to enter a masked volume, it needs to be both in the region covered by that volume AND the mask volume.
    // When more than
    this_box_volume.geometry.mask_mode = 1; // Default is mask mode is ALL
    if (mask_setting && strlen(mask_setting) && strcmp(mask_setting, "NULL") && strcmp(mask_setting, "0")) {
        if (strcmp(mask_setting,"ALL") == 0 || strcmp(mask_setting,"All") == 0) this_box_volume.geometry.mask_mode = 1;
        else if (strcmp(mask_setting,"ANY") == 0 || strcmp(mask_setting,"Any") == 0) this_box_volume.geometry.mask_mode = 2;
        else {
            printf("The mask_mode of component %s is set to %s, but must be either ALL or ANY.\n",NAME_CURRENT_COMP,mask_setting);
            exit(1);
        }
    }
    
    for (loop_index=0;loop_index<global_geometry_list.num_elements;loop_index++) {
        // Add mask list
        if (1 == manual_linking_function(global_geometry_list.elements[loop_index].name,mask_string)) {
            add_element_to_int_list(&this_box_volume.geometry.mask_list,global_geometry_list.elements[loop_index].component_index);
            add_element_to_int_list(&global_geometry_list.elements[loop_index].Volume->geometry.masked_by_list,INDEX_CURRENT_COMP);
            global_geometry_list.elements[loop_index].Volume->geometry.is_masked_volume = 1;
            if (this_box_volume.geometry.mask_mode == 2)
                global_geometry_list.elements[loop_index].Volume->geometry.mask_mode = 2;
            if (this_box_volume.geometry.mask_mode == 1) {
                if (global_geometry_list.elements[loop_index].Volume->geometry.is_masked_volume == 1 && global_geometry_list.elements[loop_index].Volume->geometry.mask_mode != 2)
                    // If more than one mask is added to one volume, the ANY mode overwrites the (default) ALL mode.
                    global_geometry_list.elements[loop_index].Volume->geometry.mask_mode = 1;
            }
            
            found_geometries = 1;
        }
    }
    if (found_geometries == 0) {
        printf("The mask_string in geometry: %s did not find any of the specified volumes in the mask_string %s \n",NAME_CURRENT_COMP,mask_string);
        exit(1);
    }
    this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
    this_box_volume.p_physics->is_vacuum = 0; // Makes this volume a vacuum
    this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
    this_box_volume.p_physics->my_a = 0; // Should not be used.
    sprintf(this_box_volume.p_physics->name,"Mask");
    this_box_volume.geometry.is_mask_volume = 1;
    
    
// Read the material input, or if it lacks, use automatic linking.
} else if (material_string && strlen(material_string) && strcmp(material_string, "NULL") && strcmp(material_string, "0")) {
    // A geometry string was given, use it to determine which material
    if (0 == strcmp(material_string,"vacuum") || 0 == strcmp(material_string,"Vacuum")) {
        // One could have a global physics struct for vacuum instead of creating one for each
        this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
        this_box_volume.p_physics->is_vacuum = 1; // Makes this volume a vacuum
        this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
        this_box_volume.p_physics->my_a = 0; // Should not be used.
        sprintf(this_box_volume.p_physics->name,"Vacuum");
    } else if (0 == strcmp(material_string,"exit") || 0 == strcmp(material_string,"Exit")) {
        // One could have a global physics struct for vacuum instead of creating one for each
        this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
        this_box_volume.p_physics->is_vacuum = 1; // Makes this volume a vacuum
        this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
        this_box_volume.p_physics->my_a = 0; // Should not be used.
        this_box_volume.geometry.is_exit_volume = 1;
        sprintf(this_box_volume.p_physics->name,"Exit");
    } else {
        #ifndef MATERIAL_DETECTOR
            printf("Need to define a material before refering to it in a geometry %s.\n",NAME_CURRENT_COMP);
            exit(1);
        #endif
        for (loop_index=0;loop_index<global_material_list.num_elements;loop_index++) {
            if (0 == strcmp(material_string,global_material_list.elements[loop_index].name)) {
                this_box_volume.p_physics = global_material_list.elements[loop_index].physics;
                break;
            }
            if (loop_index == global_material_list.num_elements-1) {
            printf("\n");
            printf("ERROR: The material string \"%s\" in Union geometry \"%s\" did not match a specified material. \n",material_string,NAME_CURRENT_COMP);
            printf("       The materials available at this point (need to be defined before the geometry): \n");
            for (loop_index=0;loop_index<global_material_list.num_elements;loop_index++)
              printf("         %s\n",global_material_list.elements[loop_index].name);
            printf("\n");
            printf("       It is also possible to use one of the defualt materials avaiable: \n");
            printf("           Vacuum (for a Volume without scattering or absorption)\n");
            printf("           Exit (for a Volume where the ray exits the component if it enters)\n");
            printf("           Mask (for a Volume that masks existing volumes specified in the mask_string\n");
            exit(1);
          }
        }
    }
} else {
    // Automatic linking, simply using the last defined material.
    #ifndef MATERIAL_DETECTOR
        printf("Need to define a material before the geometry to use automatic linking %s.\n",NAME_CURRENT_COMP);
        exit(1);
    #endif
    this_box_volume.p_physics = global_material_list.elements[global_material_list.num_elements-1].physics;
}

sprintf(this_box_volume.name,NAME_CURRENT_COMP);
sprintf(this_box_volume.geometry.shape,"box");
this_box_volume.geometry.priority_value = priority;
this_box_volume.geometry.geometry_p_interact = p_interact;
// Currently the coordinates will be in absolute space.
this_box_volume.geometry.center = POS_A_CURRENT_COMP;

this_box_storage.z_depth = zdepth;
this_box_storage.x_width1 = xwidth;
this_box_storage.y_height1 = yheight;

this_box_storage.is_rectangle = 0;
if (xwidth2 < 0 && yheight2 < 0) this_box_storage.is_rectangle = 1;
if (xwidth == xwidth2 && yheight == yheight2) this_box_storage.is_rectangle = 1;

if (xwidth2 < 0) {
    this_box_storage.x_width2 = xwidth;
    xwidth2 = xwidth;
} else this_box_storage.x_width2 = xwidth2;

if (yheight2 < 0) {
    this_box_storage.y_height2 = yheight;
    yheight2 = yheight;
} else this_box_storage.y_height2 = yheight2;


this_box_storage.normal_vectors[0] = coords_set(0,0,1);
this_box_storage.normal_vectors[1] = coords_set(0,0,1);

// for sides with y component = 0
x_component = 2*zdepth/sqrt((xwidth-xwidth2)*(xwidth-xwidth2)+4*zdepth*zdepth);
z_component = (xwidth-xwidth2)/sqrt(4*zdepth*zdepth+(xwidth-xwidth2)*(xwidth-xwidth2));

this_box_storage.normal_vectors[2] = coords_set(x_component,0,z_component);
this_box_storage.normal_vectors[3] = coords_set(-x_component,0,z_component);

// for sides with x component = 0
y_component = 2*zdepth/sqrt((yheight-yheight2)*(yheight-yheight2)+4*zdepth*zdepth);
z_component = (yheight-yheight2)/sqrt(4*zdepth*zdepth+(yheight-yheight2)*(yheight-yheight2));

this_box_storage.normal_vectors[4] = coords_set(0,y_component,z_component);
this_box_storage.normal_vectors[5] = coords_set(0,-y_component,z_component);

this_box_volume.geometry.visualization_on = visualize;

this_box_volume.geometry.geometry_parameters.p_box_storage = &this_box_storage;

// Assign pointers to functions for intersection with the shape, checking if a point is inside the shape
if (this_box_storage.is_rectangle == 1) {
this_box_volume.geometry.intersect_function = &sample_box_intersect_simple;
this_box_volume.geometry.within_function = &r_within_box_simple;
}
else {
this_box_volume.geometry.intersect_function = &sample_box_intersect_advanced;
this_box_volume.geometry.within_function = &r_within_box_advanced;
}

this_box_volume.geometry.shell_points = &box_shell_points;
this_box_volume.geometry.mcdisplay_function = &mcdisplay_box_function;
this_box_volume.geometry.initialize_from_main_function = &initialize_box_geometry_from_main_component;
this_box_volume.geometry.process_rot_allocated = 0;

this_box_volume.geometry.copy_geometry_parameters = &allocate_box_storage_copy;

rot_copy(this_box_volume.geometry.rotation_matrix,ROT_A_CURRENT_COMP); //check how ROT_R_CURRENT_COMP would work
rot_transpose(ROT_A_CURRENT_COMP,this_box_volume.geometry.transpose_rotation_matrix);

// Initialize loggers
this_box_volume.loggers.num_elements = 0;

// packing the information into the global_geometry_element, which is then included in the global_geometry_list.
sprintf(global_geometry_element.name,NAME_CURRENT_COMP);
global_geometry_element.activation_counter = number_of_activations;
global_geometry_element.component_index = INDEX_CURRENT_COMP;
global_geometry_element.Volume = &this_box_volume; // Would be nicer if this m was a pointer, now we have the (small) data two places
add_element_to_geometry_list(&global_geometry_list,global_geometry_element);
}
#line 254693 "MACS_sample_kidney_box.c"
#undef number_of_activations
#undef mask_setting
#undef mask_string
#undef p_interact
#undef focus_r
#undef focus_xh
#undef focus_xw
#undef focus_ah
#undef focus_aw
#undef target_z
#undef target_y
#undef target_x
#undef target_index
#undef visualize
#undef yheight2
#undef xwidth2
#undef zdepth
#undef yheight
#undef xwidth
#undef priority
#undef material_string
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

  /* Initializations for component channel_10_analyzer_1_array_crystal_array_4. */
  SIG_MESSAGE("channel_10_analyzer_1_array_crystal_array_4 (Init)");
#define mccompcurname  channel_10_analyzer_1_array_crystal_array_4
#define mccompcurtype  Union_box
#define mccompcurindex 514
#define loop_index mccchannel_10_analyzer_1_array_crystal_array_4_loop_index
#define this_box_volume mccchannel_10_analyzer_1_array_crystal_array_4_this_box_volume
#define global_geometry_element mccchannel_10_analyzer_1_array_crystal_array_4_global_geometry_element
#define this_box_storage mccchannel_10_analyzer_1_array_crystal_array_4_this_box_storage
#define material_string mccchannel_10_analyzer_1_array_crystal_array_4_material_string
#define priority mccchannel_10_analyzer_1_array_crystal_array_4_priority
#define xwidth mccchannel_10_analyzer_1_array_crystal_array_4_xwidth
#define yheight mccchannel_10_analyzer_1_array_crystal_array_4_yheight
#define zdepth mccchannel_10_analyzer_1_array_crystal_array_4_zdepth
#define xwidth2 mccchannel_10_analyzer_1_array_crystal_array_4_xwidth2
#define yheight2 mccchannel_10_analyzer_1_array_crystal_array_4_yheight2
#define visualize mccchannel_10_analyzer_1_array_crystal_array_4_visualize
#define target_index mccchannel_10_analyzer_1_array_crystal_array_4_target_index
#define target_x mccchannel_10_analyzer_1_array_crystal_array_4_target_x
#define target_y mccchannel_10_analyzer_1_array_crystal_array_4_target_y
#define target_z mccchannel_10_analyzer_1_array_crystal_array_4_target_z
#define focus_aw mccchannel_10_analyzer_1_array_crystal_array_4_focus_aw
#define focus_ah mccchannel_10_analyzer_1_array_crystal_array_4_focus_ah
#define focus_xw mccchannel_10_analyzer_1_array_crystal_array_4_focus_xw
#define focus_xh mccchannel_10_analyzer_1_array_crystal_array_4_focus_xh
#define focus_r mccchannel_10_analyzer_1_array_crystal_array_4_focus_r
#define p_interact mccchannel_10_analyzer_1_array_crystal_array_4_p_interact
#define mask_string mccchannel_10_analyzer_1_array_crystal_array_4_mask_string
#define mask_setting mccchannel_10_analyzer_1_array_crystal_array_4_mask_setting
#define number_of_activations mccchannel_10_analyzer_1_array_crystal_array_4_number_of_activations
#line 224 "Union_box.comp"
{
// Initializes the focusing system for this volume including input sanitation.
focus_initialize(&this_box_volume.geometry, POS_A_COMP_INDEX(INDEX_CURRENT_COMP+target_index), POS_A_CURRENT_COMP, ROT_A_CURRENT_COMP, target_index, target_x, target_y, target_z, focus_aw, focus_ah, focus_xw, focus_xh, focus_r, NAME_CURRENT_COMP);

// Input sanitation for this geometry
if (xwidth <= 0) {
  printf("\nERROR in Union_box named %s, the xwidth is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (yheight <= 0) {
  printf("\nERROR in Union_box named %s, yheight is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (zdepth <= 0) {
  printf("\nERROR in Union_box named %s, zdepth is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (xwidth2 <= 0 && xwidth2 != -1) {
  printf("\nERROR in Union_box named %s, the xwidth2 is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (yheight2 <= 0 && yheight2 != -1) {
  printf("\nERROR in Union_box named %s, yheight2 is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}

// Use sanitation
if (global_material_list.num_elements == 0) {
  printf("\nERROR: Need to define a material using Union_make_material before using a Union geometry component. \n");
  printf("       %s was defined before first use of Union_make_material.\n",NAME_CURRENT_COMP);
  exit(1);
}

this_box_volume.geometry.is_masked_volume = 0;
this_box_volume.geometry.is_exit_volume = 0;
this_box_volume.geometry.is_mask_volume = 0;
// check if the volume is a mask, if it is the material string is irelevant.
if (mask_string && strlen(mask_string) && strcmp(mask_string, "NULL") && strcmp(mask_string, "0")) {
    // A mask volume is used to limit the extend of other volumes, called the masked volumes. These are specified in the mask_string.
    // In order for a ray to enter a masked volume, it needs to be both in the region covered by that volume AND the mask volume.
    // When more than
    this_box_volume.geometry.mask_mode = 1; // Default is mask mode is ALL
    if (mask_setting && strlen(mask_setting) && strcmp(mask_setting, "NULL") && strcmp(mask_setting, "0")) {
        if (strcmp(mask_setting,"ALL") == 0 || strcmp(mask_setting,"All") == 0) this_box_volume.geometry.mask_mode = 1;
        else if (strcmp(mask_setting,"ANY") == 0 || strcmp(mask_setting,"Any") == 0) this_box_volume.geometry.mask_mode = 2;
        else {
            printf("The mask_mode of component %s is set to %s, but must be either ALL or ANY.\n",NAME_CURRENT_COMP,mask_setting);
            exit(1);
        }
    }
    
    for (loop_index=0;loop_index<global_geometry_list.num_elements;loop_index++) {
        // Add mask list
        if (1 == manual_linking_function(global_geometry_list.elements[loop_index].name,mask_string)) {
            add_element_to_int_list(&this_box_volume.geometry.mask_list,global_geometry_list.elements[loop_index].component_index);
            add_element_to_int_list(&global_geometry_list.elements[loop_index].Volume->geometry.masked_by_list,INDEX_CURRENT_COMP);
            global_geometry_list.elements[loop_index].Volume->geometry.is_masked_volume = 1;
            if (this_box_volume.geometry.mask_mode == 2)
                global_geometry_list.elements[loop_index].Volume->geometry.mask_mode = 2;
            if (this_box_volume.geometry.mask_mode == 1) {
                if (global_geometry_list.elements[loop_index].Volume->geometry.is_masked_volume == 1 && global_geometry_list.elements[loop_index].Volume->geometry.mask_mode != 2)
                    // If more than one mask is added to one volume, the ANY mode overwrites the (default) ALL mode.
                    global_geometry_list.elements[loop_index].Volume->geometry.mask_mode = 1;
            }
            
            found_geometries = 1;
        }
    }
    if (found_geometries == 0) {
        printf("The mask_string in geometry: %s did not find any of the specified volumes in the mask_string %s \n",NAME_CURRENT_COMP,mask_string);
        exit(1);
    }
    this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
    this_box_volume.p_physics->is_vacuum = 0; // Makes this volume a vacuum
    this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
    this_box_volume.p_physics->my_a = 0; // Should not be used.
    sprintf(this_box_volume.p_physics->name,"Mask");
    this_box_volume.geometry.is_mask_volume = 1;
    
    
// Read the material input, or if it lacks, use automatic linking.
} else if (material_string && strlen(material_string) && strcmp(material_string, "NULL") && strcmp(material_string, "0")) {
    // A geometry string was given, use it to determine which material
    if (0 == strcmp(material_string,"vacuum") || 0 == strcmp(material_string,"Vacuum")) {
        // One could have a global physics struct for vacuum instead of creating one for each
        this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
        this_box_volume.p_physics->is_vacuum = 1; // Makes this volume a vacuum
        this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
        this_box_volume.p_physics->my_a = 0; // Should not be used.
        sprintf(this_box_volume.p_physics->name,"Vacuum");
    } else if (0 == strcmp(material_string,"exit") || 0 == strcmp(material_string,"Exit")) {
        // One could have a global physics struct for vacuum instead of creating one for each
        this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
        this_box_volume.p_physics->is_vacuum = 1; // Makes this volume a vacuum
        this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
        this_box_volume.p_physics->my_a = 0; // Should not be used.
        this_box_volume.geometry.is_exit_volume = 1;
        sprintf(this_box_volume.p_physics->name,"Exit");
    } else {
        #ifndef MATERIAL_DETECTOR
            printf("Need to define a material before refering to it in a geometry %s.\n",NAME_CURRENT_COMP);
            exit(1);
        #endif
        for (loop_index=0;loop_index<global_material_list.num_elements;loop_index++) {
            if (0 == strcmp(material_string,global_material_list.elements[loop_index].name)) {
                this_box_volume.p_physics = global_material_list.elements[loop_index].physics;
                break;
            }
            if (loop_index == global_material_list.num_elements-1) {
            printf("\n");
            printf("ERROR: The material string \"%s\" in Union geometry \"%s\" did not match a specified material. \n",material_string,NAME_CURRENT_COMP);
            printf("       The materials available at this point (need to be defined before the geometry): \n");
            for (loop_index=0;loop_index<global_material_list.num_elements;loop_index++)
              printf("         %s\n",global_material_list.elements[loop_index].name);
            printf("\n");
            printf("       It is also possible to use one of the defualt materials avaiable: \n");
            printf("           Vacuum (for a Volume without scattering or absorption)\n");
            printf("           Exit (for a Volume where the ray exits the component if it enters)\n");
            printf("           Mask (for a Volume that masks existing volumes specified in the mask_string\n");
            exit(1);
          }
        }
    }
} else {
    // Automatic linking, simply using the last defined material.
    #ifndef MATERIAL_DETECTOR
        printf("Need to define a material before the geometry to use automatic linking %s.\n",NAME_CURRENT_COMP);
        exit(1);
    #endif
    this_box_volume.p_physics = global_material_list.elements[global_material_list.num_elements-1].physics;
}

sprintf(this_box_volume.name,NAME_CURRENT_COMP);
sprintf(this_box_volume.geometry.shape,"box");
this_box_volume.geometry.priority_value = priority;
this_box_volume.geometry.geometry_p_interact = p_interact;
// Currently the coordinates will be in absolute space.
this_box_volume.geometry.center = POS_A_CURRENT_COMP;

this_box_storage.z_depth = zdepth;
this_box_storage.x_width1 = xwidth;
this_box_storage.y_height1 = yheight;

this_box_storage.is_rectangle = 0;
if (xwidth2 < 0 && yheight2 < 0) this_box_storage.is_rectangle = 1;
if (xwidth == xwidth2 && yheight == yheight2) this_box_storage.is_rectangle = 1;

if (xwidth2 < 0) {
    this_box_storage.x_width2 = xwidth;
    xwidth2 = xwidth;
} else this_box_storage.x_width2 = xwidth2;

if (yheight2 < 0) {
    this_box_storage.y_height2 = yheight;
    yheight2 = yheight;
} else this_box_storage.y_height2 = yheight2;


this_box_storage.normal_vectors[0] = coords_set(0,0,1);
this_box_storage.normal_vectors[1] = coords_set(0,0,1);

// for sides with y component = 0
x_component = 2*zdepth/sqrt((xwidth-xwidth2)*(xwidth-xwidth2)+4*zdepth*zdepth);
z_component = (xwidth-xwidth2)/sqrt(4*zdepth*zdepth+(xwidth-xwidth2)*(xwidth-xwidth2));

this_box_storage.normal_vectors[2] = coords_set(x_component,0,z_component);
this_box_storage.normal_vectors[3] = coords_set(-x_component,0,z_component);

// for sides with x component = 0
y_component = 2*zdepth/sqrt((yheight-yheight2)*(yheight-yheight2)+4*zdepth*zdepth);
z_component = (yheight-yheight2)/sqrt(4*zdepth*zdepth+(yheight-yheight2)*(yheight-yheight2));

this_box_storage.normal_vectors[4] = coords_set(0,y_component,z_component);
this_box_storage.normal_vectors[5] = coords_set(0,-y_component,z_component);

this_box_volume.geometry.visualization_on = visualize;

this_box_volume.geometry.geometry_parameters.p_box_storage = &this_box_storage;

// Assign pointers to functions for intersection with the shape, checking if a point is inside the shape
if (this_box_storage.is_rectangle == 1) {
this_box_volume.geometry.intersect_function = &sample_box_intersect_simple;
this_box_volume.geometry.within_function = &r_within_box_simple;
}
else {
this_box_volume.geometry.intersect_function = &sample_box_intersect_advanced;
this_box_volume.geometry.within_function = &r_within_box_advanced;
}

this_box_volume.geometry.shell_points = &box_shell_points;
this_box_volume.geometry.mcdisplay_function = &mcdisplay_box_function;
this_box_volume.geometry.initialize_from_main_function = &initialize_box_geometry_from_main_component;
this_box_volume.geometry.process_rot_allocated = 0;

this_box_volume.geometry.copy_geometry_parameters = &allocate_box_storage_copy;

rot_copy(this_box_volume.geometry.rotation_matrix,ROT_A_CURRENT_COMP); //check how ROT_R_CURRENT_COMP would work
rot_transpose(ROT_A_CURRENT_COMP,this_box_volume.geometry.transpose_rotation_matrix);

// Initialize loggers
this_box_volume.loggers.num_elements = 0;

// packing the information into the global_geometry_element, which is then included in the global_geometry_list.
sprintf(global_geometry_element.name,NAME_CURRENT_COMP);
global_geometry_element.activation_counter = number_of_activations;
global_geometry_element.component_index = INDEX_CURRENT_COMP;
global_geometry_element.Volume = &this_box_volume; // Would be nicer if this m was a pointer, now we have the (small) data two places
add_element_to_geometry_list(&global_geometry_list,global_geometry_element);
}
#line 254963 "MACS_sample_kidney_box.c"
#undef number_of_activations
#undef mask_setting
#undef mask_string
#undef p_interact
#undef focus_r
#undef focus_xh
#undef focus_xw
#undef focus_ah
#undef focus_aw
#undef target_z
#undef target_y
#undef target_x
#undef target_index
#undef visualize
#undef yheight2
#undef xwidth2
#undef zdepth
#undef yheight
#undef xwidth
#undef priority
#undef material_string
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

  /* Initializations for component channel_10_analyzer_1_array_crystal_array_5. */
  SIG_MESSAGE("channel_10_analyzer_1_array_crystal_array_5 (Init)");
#define mccompcurname  channel_10_analyzer_1_array_crystal_array_5
#define mccompcurtype  Union_box
#define mccompcurindex 515
#define loop_index mccchannel_10_analyzer_1_array_crystal_array_5_loop_index
#define this_box_volume mccchannel_10_analyzer_1_array_crystal_array_5_this_box_volume
#define global_geometry_element mccchannel_10_analyzer_1_array_crystal_array_5_global_geometry_element
#define this_box_storage mccchannel_10_analyzer_1_array_crystal_array_5_this_box_storage
#define material_string mccchannel_10_analyzer_1_array_crystal_array_5_material_string
#define priority mccchannel_10_analyzer_1_array_crystal_array_5_priority
#define xwidth mccchannel_10_analyzer_1_array_crystal_array_5_xwidth
#define yheight mccchannel_10_analyzer_1_array_crystal_array_5_yheight
#define zdepth mccchannel_10_analyzer_1_array_crystal_array_5_zdepth
#define xwidth2 mccchannel_10_analyzer_1_array_crystal_array_5_xwidth2
#define yheight2 mccchannel_10_analyzer_1_array_crystal_array_5_yheight2
#define visualize mccchannel_10_analyzer_1_array_crystal_array_5_visualize
#define target_index mccchannel_10_analyzer_1_array_crystal_array_5_target_index
#define target_x mccchannel_10_analyzer_1_array_crystal_array_5_target_x
#define target_y mccchannel_10_analyzer_1_array_crystal_array_5_target_y
#define target_z mccchannel_10_analyzer_1_array_crystal_array_5_target_z
#define focus_aw mccchannel_10_analyzer_1_array_crystal_array_5_focus_aw
#define focus_ah mccchannel_10_analyzer_1_array_crystal_array_5_focus_ah
#define focus_xw mccchannel_10_analyzer_1_array_crystal_array_5_focus_xw
#define focus_xh mccchannel_10_analyzer_1_array_crystal_array_5_focus_xh
#define focus_r mccchannel_10_analyzer_1_array_crystal_array_5_focus_r
#define p_interact mccchannel_10_analyzer_1_array_crystal_array_5_p_interact
#define mask_string mccchannel_10_analyzer_1_array_crystal_array_5_mask_string
#define mask_setting mccchannel_10_analyzer_1_array_crystal_array_5_mask_setting
#define number_of_activations mccchannel_10_analyzer_1_array_crystal_array_5_number_of_activations
#line 224 "Union_box.comp"
{
// Initializes the focusing system for this volume including input sanitation.
focus_initialize(&this_box_volume.geometry, POS_A_COMP_INDEX(INDEX_CURRENT_COMP+target_index), POS_A_CURRENT_COMP, ROT_A_CURRENT_COMP, target_index, target_x, target_y, target_z, focus_aw, focus_ah, focus_xw, focus_xh, focus_r, NAME_CURRENT_COMP);

// Input sanitation for this geometry
if (xwidth <= 0) {
  printf("\nERROR in Union_box named %s, the xwidth is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (yheight <= 0) {
  printf("\nERROR in Union_box named %s, yheight is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (zdepth <= 0) {
  printf("\nERROR in Union_box named %s, zdepth is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (xwidth2 <= 0 && xwidth2 != -1) {
  printf("\nERROR in Union_box named %s, the xwidth2 is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (yheight2 <= 0 && yheight2 != -1) {
  printf("\nERROR in Union_box named %s, yheight2 is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}

// Use sanitation
if (global_material_list.num_elements == 0) {
  printf("\nERROR: Need to define a material using Union_make_material before using a Union geometry component. \n");
  printf("       %s was defined before first use of Union_make_material.\n",NAME_CURRENT_COMP);
  exit(1);
}

this_box_volume.geometry.is_masked_volume = 0;
this_box_volume.geometry.is_exit_volume = 0;
this_box_volume.geometry.is_mask_volume = 0;
// check if the volume is a mask, if it is the material string is irelevant.
if (mask_string && strlen(mask_string) && strcmp(mask_string, "NULL") && strcmp(mask_string, "0")) {
    // A mask volume is used to limit the extend of other volumes, called the masked volumes. These are specified in the mask_string.
    // In order for a ray to enter a masked volume, it needs to be both in the region covered by that volume AND the mask volume.
    // When more than
    this_box_volume.geometry.mask_mode = 1; // Default is mask mode is ALL
    if (mask_setting && strlen(mask_setting) && strcmp(mask_setting, "NULL") && strcmp(mask_setting, "0")) {
        if (strcmp(mask_setting,"ALL") == 0 || strcmp(mask_setting,"All") == 0) this_box_volume.geometry.mask_mode = 1;
        else if (strcmp(mask_setting,"ANY") == 0 || strcmp(mask_setting,"Any") == 0) this_box_volume.geometry.mask_mode = 2;
        else {
            printf("The mask_mode of component %s is set to %s, but must be either ALL or ANY.\n",NAME_CURRENT_COMP,mask_setting);
            exit(1);
        }
    }
    
    for (loop_index=0;loop_index<global_geometry_list.num_elements;loop_index++) {
        // Add mask list
        if (1 == manual_linking_function(global_geometry_list.elements[loop_index].name,mask_string)) {
            add_element_to_int_list(&this_box_volume.geometry.mask_list,global_geometry_list.elements[loop_index].component_index);
            add_element_to_int_list(&global_geometry_list.elements[loop_index].Volume->geometry.masked_by_list,INDEX_CURRENT_COMP);
            global_geometry_list.elements[loop_index].Volume->geometry.is_masked_volume = 1;
            if (this_box_volume.geometry.mask_mode == 2)
                global_geometry_list.elements[loop_index].Volume->geometry.mask_mode = 2;
            if (this_box_volume.geometry.mask_mode == 1) {
                if (global_geometry_list.elements[loop_index].Volume->geometry.is_masked_volume == 1 && global_geometry_list.elements[loop_index].Volume->geometry.mask_mode != 2)
                    // If more than one mask is added to one volume, the ANY mode overwrites the (default) ALL mode.
                    global_geometry_list.elements[loop_index].Volume->geometry.mask_mode = 1;
            }
            
            found_geometries = 1;
        }
    }
    if (found_geometries == 0) {
        printf("The mask_string in geometry: %s did not find any of the specified volumes in the mask_string %s \n",NAME_CURRENT_COMP,mask_string);
        exit(1);
    }
    this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
    this_box_volume.p_physics->is_vacuum = 0; // Makes this volume a vacuum
    this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
    this_box_volume.p_physics->my_a = 0; // Should not be used.
    sprintf(this_box_volume.p_physics->name,"Mask");
    this_box_volume.geometry.is_mask_volume = 1;
    
    
// Read the material input, or if it lacks, use automatic linking.
} else if (material_string && strlen(material_string) && strcmp(material_string, "NULL") && strcmp(material_string, "0")) {
    // A geometry string was given, use it to determine which material
    if (0 == strcmp(material_string,"vacuum") || 0 == strcmp(material_string,"Vacuum")) {
        // One could have a global physics struct for vacuum instead of creating one for each
        this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
        this_box_volume.p_physics->is_vacuum = 1; // Makes this volume a vacuum
        this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
        this_box_volume.p_physics->my_a = 0; // Should not be used.
        sprintf(this_box_volume.p_physics->name,"Vacuum");
    } else if (0 == strcmp(material_string,"exit") || 0 == strcmp(material_string,"Exit")) {
        // One could have a global physics struct for vacuum instead of creating one for each
        this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
        this_box_volume.p_physics->is_vacuum = 1; // Makes this volume a vacuum
        this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
        this_box_volume.p_physics->my_a = 0; // Should not be used.
        this_box_volume.geometry.is_exit_volume = 1;
        sprintf(this_box_volume.p_physics->name,"Exit");
    } else {
        #ifndef MATERIAL_DETECTOR
            printf("Need to define a material before refering to it in a geometry %s.\n",NAME_CURRENT_COMP);
            exit(1);
        #endif
        for (loop_index=0;loop_index<global_material_list.num_elements;loop_index++) {
            if (0 == strcmp(material_string,global_material_list.elements[loop_index].name)) {
                this_box_volume.p_physics = global_material_list.elements[loop_index].physics;
                break;
            }
            if (loop_index == global_material_list.num_elements-1) {
            printf("\n");
            printf("ERROR: The material string \"%s\" in Union geometry \"%s\" did not match a specified material. \n",material_string,NAME_CURRENT_COMP);
            printf("       The materials available at this point (need to be defined before the geometry): \n");
            for (loop_index=0;loop_index<global_material_list.num_elements;loop_index++)
              printf("         %s\n",global_material_list.elements[loop_index].name);
            printf("\n");
            printf("       It is also possible to use one of the defualt materials avaiable: \n");
            printf("           Vacuum (for a Volume without scattering or absorption)\n");
            printf("           Exit (for a Volume where the ray exits the component if it enters)\n");
            printf("           Mask (for a Volume that masks existing volumes specified in the mask_string\n");
            exit(1);
          }
        }
    }
} else {
    // Automatic linking, simply using the last defined material.
    #ifndef MATERIAL_DETECTOR
        printf("Need to define a material before the geometry to use automatic linking %s.\n",NAME_CURRENT_COMP);
        exit(1);
    #endif
    this_box_volume.p_physics = global_material_list.elements[global_material_list.num_elements-1].physics;
}

sprintf(this_box_volume.name,NAME_CURRENT_COMP);
sprintf(this_box_volume.geometry.shape,"box");
this_box_volume.geometry.priority_value = priority;
this_box_volume.geometry.geometry_p_interact = p_interact;
// Currently the coordinates will be in absolute space.
this_box_volume.geometry.center = POS_A_CURRENT_COMP;

this_box_storage.z_depth = zdepth;
this_box_storage.x_width1 = xwidth;
this_box_storage.y_height1 = yheight;

this_box_storage.is_rectangle = 0;
if (xwidth2 < 0 && yheight2 < 0) this_box_storage.is_rectangle = 1;
if (xwidth == xwidth2 && yheight == yheight2) this_box_storage.is_rectangle = 1;

if (xwidth2 < 0) {
    this_box_storage.x_width2 = xwidth;
    xwidth2 = xwidth;
} else this_box_storage.x_width2 = xwidth2;

if (yheight2 < 0) {
    this_box_storage.y_height2 = yheight;
    yheight2 = yheight;
} else this_box_storage.y_height2 = yheight2;


this_box_storage.normal_vectors[0] = coords_set(0,0,1);
this_box_storage.normal_vectors[1] = coords_set(0,0,1);

// for sides with y component = 0
x_component = 2*zdepth/sqrt((xwidth-xwidth2)*(xwidth-xwidth2)+4*zdepth*zdepth);
z_component = (xwidth-xwidth2)/sqrt(4*zdepth*zdepth+(xwidth-xwidth2)*(xwidth-xwidth2));

this_box_storage.normal_vectors[2] = coords_set(x_component,0,z_component);
this_box_storage.normal_vectors[3] = coords_set(-x_component,0,z_component);

// for sides with x component = 0
y_component = 2*zdepth/sqrt((yheight-yheight2)*(yheight-yheight2)+4*zdepth*zdepth);
z_component = (yheight-yheight2)/sqrt(4*zdepth*zdepth+(yheight-yheight2)*(yheight-yheight2));

this_box_storage.normal_vectors[4] = coords_set(0,y_component,z_component);
this_box_storage.normal_vectors[5] = coords_set(0,-y_component,z_component);

this_box_volume.geometry.visualization_on = visualize;

this_box_volume.geometry.geometry_parameters.p_box_storage = &this_box_storage;

// Assign pointers to functions for intersection with the shape, checking if a point is inside the shape
if (this_box_storage.is_rectangle == 1) {
this_box_volume.geometry.intersect_function = &sample_box_intersect_simple;
this_box_volume.geometry.within_function = &r_within_box_simple;
}
else {
this_box_volume.geometry.intersect_function = &sample_box_intersect_advanced;
this_box_volume.geometry.within_function = &r_within_box_advanced;
}

this_box_volume.geometry.shell_points = &box_shell_points;
this_box_volume.geometry.mcdisplay_function = &mcdisplay_box_function;
this_box_volume.geometry.initialize_from_main_function = &initialize_box_geometry_from_main_component;
this_box_volume.geometry.process_rot_allocated = 0;

this_box_volume.geometry.copy_geometry_parameters = &allocate_box_storage_copy;

rot_copy(this_box_volume.geometry.rotation_matrix,ROT_A_CURRENT_COMP); //check how ROT_R_CURRENT_COMP would work
rot_transpose(ROT_A_CURRENT_COMP,this_box_volume.geometry.transpose_rotation_matrix);

// Initialize loggers
this_box_volume.loggers.num_elements = 0;

// packing the information into the global_geometry_element, which is then included in the global_geometry_list.
sprintf(global_geometry_element.name,NAME_CURRENT_COMP);
global_geometry_element.activation_counter = number_of_activations;
global_geometry_element.component_index = INDEX_CURRENT_COMP;
global_geometry_element.Volume = &this_box_volume; // Would be nicer if this m was a pointer, now we have the (small) data two places
add_element_to_geometry_list(&global_geometry_list,global_geometry_element);
}
#line 255233 "MACS_sample_kidney_box.c"
#undef number_of_activations
#undef mask_setting
#undef mask_string
#undef p_interact
#undef focus_r
#undef focus_xh
#undef focus_xw
#undef focus_ah
#undef focus_aw
#undef target_z
#undef target_y
#undef target_x
#undef target_index
#undef visualize
#undef yheight2
#undef xwidth2
#undef zdepth
#undef yheight
#undef xwidth
#undef priority
#undef material_string
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

  /* Initializations for component channel_10_analyzer_1_array_crystal_array_6. */
  SIG_MESSAGE("channel_10_analyzer_1_array_crystal_array_6 (Init)");
#define mccompcurname  channel_10_analyzer_1_array_crystal_array_6
#define mccompcurtype  Union_box
#define mccompcurindex 516
#define loop_index mccchannel_10_analyzer_1_array_crystal_array_6_loop_index
#define this_box_volume mccchannel_10_analyzer_1_array_crystal_array_6_this_box_volume
#define global_geometry_element mccchannel_10_analyzer_1_array_crystal_array_6_global_geometry_element
#define this_box_storage mccchannel_10_analyzer_1_array_crystal_array_6_this_box_storage
#define material_string mccchannel_10_analyzer_1_array_crystal_array_6_material_string
#define priority mccchannel_10_analyzer_1_array_crystal_array_6_priority
#define xwidth mccchannel_10_analyzer_1_array_crystal_array_6_xwidth
#define yheight mccchannel_10_analyzer_1_array_crystal_array_6_yheight
#define zdepth mccchannel_10_analyzer_1_array_crystal_array_6_zdepth
#define xwidth2 mccchannel_10_analyzer_1_array_crystal_array_6_xwidth2
#define yheight2 mccchannel_10_analyzer_1_array_crystal_array_6_yheight2
#define visualize mccchannel_10_analyzer_1_array_crystal_array_6_visualize
#define target_index mccchannel_10_analyzer_1_array_crystal_array_6_target_index
#define target_x mccchannel_10_analyzer_1_array_crystal_array_6_target_x
#define target_y mccchannel_10_analyzer_1_array_crystal_array_6_target_y
#define target_z mccchannel_10_analyzer_1_array_crystal_array_6_target_z
#define focus_aw mccchannel_10_analyzer_1_array_crystal_array_6_focus_aw
#define focus_ah mccchannel_10_analyzer_1_array_crystal_array_6_focus_ah
#define focus_xw mccchannel_10_analyzer_1_array_crystal_array_6_focus_xw
#define focus_xh mccchannel_10_analyzer_1_array_crystal_array_6_focus_xh
#define focus_r mccchannel_10_analyzer_1_array_crystal_array_6_focus_r
#define p_interact mccchannel_10_analyzer_1_array_crystal_array_6_p_interact
#define mask_string mccchannel_10_analyzer_1_array_crystal_array_6_mask_string
#define mask_setting mccchannel_10_analyzer_1_array_crystal_array_6_mask_setting
#define number_of_activations mccchannel_10_analyzer_1_array_crystal_array_6_number_of_activations
#line 224 "Union_box.comp"
{
// Initializes the focusing system for this volume including input sanitation.
focus_initialize(&this_box_volume.geometry, POS_A_COMP_INDEX(INDEX_CURRENT_COMP+target_index), POS_A_CURRENT_COMP, ROT_A_CURRENT_COMP, target_index, target_x, target_y, target_z, focus_aw, focus_ah, focus_xw, focus_xh, focus_r, NAME_CURRENT_COMP);

// Input sanitation for this geometry
if (xwidth <= 0) {
  printf("\nERROR in Union_box named %s, the xwidth is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (yheight <= 0) {
  printf("\nERROR in Union_box named %s, yheight is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (zdepth <= 0) {
  printf("\nERROR in Union_box named %s, zdepth is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (xwidth2 <= 0 && xwidth2 != -1) {
  printf("\nERROR in Union_box named %s, the xwidth2 is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (yheight2 <= 0 && yheight2 != -1) {
  printf("\nERROR in Union_box named %s, yheight2 is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}

// Use sanitation
if (global_material_list.num_elements == 0) {
  printf("\nERROR: Need to define a material using Union_make_material before using a Union geometry component. \n");
  printf("       %s was defined before first use of Union_make_material.\n",NAME_CURRENT_COMP);
  exit(1);
}

this_box_volume.geometry.is_masked_volume = 0;
this_box_volume.geometry.is_exit_volume = 0;
this_box_volume.geometry.is_mask_volume = 0;
// check if the volume is a mask, if it is the material string is irelevant.
if (mask_string && strlen(mask_string) && strcmp(mask_string, "NULL") && strcmp(mask_string, "0")) {
    // A mask volume is used to limit the extend of other volumes, called the masked volumes. These are specified in the mask_string.
    // In order for a ray to enter a masked volume, it needs to be both in the region covered by that volume AND the mask volume.
    // When more than
    this_box_volume.geometry.mask_mode = 1; // Default is mask mode is ALL
    if (mask_setting && strlen(mask_setting) && strcmp(mask_setting, "NULL") && strcmp(mask_setting, "0")) {
        if (strcmp(mask_setting,"ALL") == 0 || strcmp(mask_setting,"All") == 0) this_box_volume.geometry.mask_mode = 1;
        else if (strcmp(mask_setting,"ANY") == 0 || strcmp(mask_setting,"Any") == 0) this_box_volume.geometry.mask_mode = 2;
        else {
            printf("The mask_mode of component %s is set to %s, but must be either ALL or ANY.\n",NAME_CURRENT_COMP,mask_setting);
            exit(1);
        }
    }
    
    for (loop_index=0;loop_index<global_geometry_list.num_elements;loop_index++) {
        // Add mask list
        if (1 == manual_linking_function(global_geometry_list.elements[loop_index].name,mask_string)) {
            add_element_to_int_list(&this_box_volume.geometry.mask_list,global_geometry_list.elements[loop_index].component_index);
            add_element_to_int_list(&global_geometry_list.elements[loop_index].Volume->geometry.masked_by_list,INDEX_CURRENT_COMP);
            global_geometry_list.elements[loop_index].Volume->geometry.is_masked_volume = 1;
            if (this_box_volume.geometry.mask_mode == 2)
                global_geometry_list.elements[loop_index].Volume->geometry.mask_mode = 2;
            if (this_box_volume.geometry.mask_mode == 1) {
                if (global_geometry_list.elements[loop_index].Volume->geometry.is_masked_volume == 1 && global_geometry_list.elements[loop_index].Volume->geometry.mask_mode != 2)
                    // If more than one mask is added to one volume, the ANY mode overwrites the (default) ALL mode.
                    global_geometry_list.elements[loop_index].Volume->geometry.mask_mode = 1;
            }
            
            found_geometries = 1;
        }
    }
    if (found_geometries == 0) {
        printf("The mask_string in geometry: %s did not find any of the specified volumes in the mask_string %s \n",NAME_CURRENT_COMP,mask_string);
        exit(1);
    }
    this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
    this_box_volume.p_physics->is_vacuum = 0; // Makes this volume a vacuum
    this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
    this_box_volume.p_physics->my_a = 0; // Should not be used.
    sprintf(this_box_volume.p_physics->name,"Mask");
    this_box_volume.geometry.is_mask_volume = 1;
    
    
// Read the material input, or if it lacks, use automatic linking.
} else if (material_string && strlen(material_string) && strcmp(material_string, "NULL") && strcmp(material_string, "0")) {
    // A geometry string was given, use it to determine which material
    if (0 == strcmp(material_string,"vacuum") || 0 == strcmp(material_string,"Vacuum")) {
        // One could have a global physics struct for vacuum instead of creating one for each
        this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
        this_box_volume.p_physics->is_vacuum = 1; // Makes this volume a vacuum
        this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
        this_box_volume.p_physics->my_a = 0; // Should not be used.
        sprintf(this_box_volume.p_physics->name,"Vacuum");
    } else if (0 == strcmp(material_string,"exit") || 0 == strcmp(material_string,"Exit")) {
        // One could have a global physics struct for vacuum instead of creating one for each
        this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
        this_box_volume.p_physics->is_vacuum = 1; // Makes this volume a vacuum
        this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
        this_box_volume.p_physics->my_a = 0; // Should not be used.
        this_box_volume.geometry.is_exit_volume = 1;
        sprintf(this_box_volume.p_physics->name,"Exit");
    } else {
        #ifndef MATERIAL_DETECTOR
            printf("Need to define a material before refering to it in a geometry %s.\n",NAME_CURRENT_COMP);
            exit(1);
        #endif
        for (loop_index=0;loop_index<global_material_list.num_elements;loop_index++) {
            if (0 == strcmp(material_string,global_material_list.elements[loop_index].name)) {
                this_box_volume.p_physics = global_material_list.elements[loop_index].physics;
                break;
            }
            if (loop_index == global_material_list.num_elements-1) {
            printf("\n");
            printf("ERROR: The material string \"%s\" in Union geometry \"%s\" did not match a specified material. \n",material_string,NAME_CURRENT_COMP);
            printf("       The materials available at this point (need to be defined before the geometry): \n");
            for (loop_index=0;loop_index<global_material_list.num_elements;loop_index++)
              printf("         %s\n",global_material_list.elements[loop_index].name);
            printf("\n");
            printf("       It is also possible to use one of the defualt materials avaiable: \n");
            printf("           Vacuum (for a Volume without scattering or absorption)\n");
            printf("           Exit (for a Volume where the ray exits the component if it enters)\n");
            printf("           Mask (for a Volume that masks existing volumes specified in the mask_string\n");
            exit(1);
          }
        }
    }
} else {
    // Automatic linking, simply using the last defined material.
    #ifndef MATERIAL_DETECTOR
        printf("Need to define a material before the geometry to use automatic linking %s.\n",NAME_CURRENT_COMP);
        exit(1);
    #endif
    this_box_volume.p_physics = global_material_list.elements[global_material_list.num_elements-1].physics;
}

sprintf(this_box_volume.name,NAME_CURRENT_COMP);
sprintf(this_box_volume.geometry.shape,"box");
this_box_volume.geometry.priority_value = priority;
this_box_volume.geometry.geometry_p_interact = p_interact;
// Currently the coordinates will be in absolute space.
this_box_volume.geometry.center = POS_A_CURRENT_COMP;

this_box_storage.z_depth = zdepth;
this_box_storage.x_width1 = xwidth;
this_box_storage.y_height1 = yheight;

this_box_storage.is_rectangle = 0;
if (xwidth2 < 0 && yheight2 < 0) this_box_storage.is_rectangle = 1;
if (xwidth == xwidth2 && yheight == yheight2) this_box_storage.is_rectangle = 1;

if (xwidth2 < 0) {
    this_box_storage.x_width2 = xwidth;
    xwidth2 = xwidth;
} else this_box_storage.x_width2 = xwidth2;

if (yheight2 < 0) {
    this_box_storage.y_height2 = yheight;
    yheight2 = yheight;
} else this_box_storage.y_height2 = yheight2;


this_box_storage.normal_vectors[0] = coords_set(0,0,1);
this_box_storage.normal_vectors[1] = coords_set(0,0,1);

// for sides with y component = 0
x_component = 2*zdepth/sqrt((xwidth-xwidth2)*(xwidth-xwidth2)+4*zdepth*zdepth);
z_component = (xwidth-xwidth2)/sqrt(4*zdepth*zdepth+(xwidth-xwidth2)*(xwidth-xwidth2));

this_box_storage.normal_vectors[2] = coords_set(x_component,0,z_component);
this_box_storage.normal_vectors[3] = coords_set(-x_component,0,z_component);

// for sides with x component = 0
y_component = 2*zdepth/sqrt((yheight-yheight2)*(yheight-yheight2)+4*zdepth*zdepth);
z_component = (yheight-yheight2)/sqrt(4*zdepth*zdepth+(yheight-yheight2)*(yheight-yheight2));

this_box_storage.normal_vectors[4] = coords_set(0,y_component,z_component);
this_box_storage.normal_vectors[5] = coords_set(0,-y_component,z_component);

this_box_volume.geometry.visualization_on = visualize;

this_box_volume.geometry.geometry_parameters.p_box_storage = &this_box_storage;

// Assign pointers to functions for intersection with the shape, checking if a point is inside the shape
if (this_box_storage.is_rectangle == 1) {
this_box_volume.geometry.intersect_function = &sample_box_intersect_simple;
this_box_volume.geometry.within_function = &r_within_box_simple;
}
else {
this_box_volume.geometry.intersect_function = &sample_box_intersect_advanced;
this_box_volume.geometry.within_function = &r_within_box_advanced;
}

this_box_volume.geometry.shell_points = &box_shell_points;
this_box_volume.geometry.mcdisplay_function = &mcdisplay_box_function;
this_box_volume.geometry.initialize_from_main_function = &initialize_box_geometry_from_main_component;
this_box_volume.geometry.process_rot_allocated = 0;

this_box_volume.geometry.copy_geometry_parameters = &allocate_box_storage_copy;

rot_copy(this_box_volume.geometry.rotation_matrix,ROT_A_CURRENT_COMP); //check how ROT_R_CURRENT_COMP would work
rot_transpose(ROT_A_CURRENT_COMP,this_box_volume.geometry.transpose_rotation_matrix);

// Initialize loggers
this_box_volume.loggers.num_elements = 0;

// packing the information into the global_geometry_element, which is then included in the global_geometry_list.
sprintf(global_geometry_element.name,NAME_CURRENT_COMP);
global_geometry_element.activation_counter = number_of_activations;
global_geometry_element.component_index = INDEX_CURRENT_COMP;
global_geometry_element.Volume = &this_box_volume; // Would be nicer if this m was a pointer, now we have the (small) data two places
add_element_to_geometry_list(&global_geometry_list,global_geometry_element);
}
#line 255503 "MACS_sample_kidney_box.c"
#undef number_of_activations
#undef mask_setting
#undef mask_string
#undef p_interact
#undef focus_r
#undef focus_xh
#undef focus_xw
#undef focus_ah
#undef focus_aw
#undef target_z
#undef target_y
#undef target_x
#undef target_index
#undef visualize
#undef yheight2
#undef xwidth2
#undef zdepth
#undef yheight
#undef xwidth
#undef priority
#undef material_string
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

  /* Initializations for component channel_10_analyzer_1_array_crystal_array_7. */
  SIG_MESSAGE("channel_10_analyzer_1_array_crystal_array_7 (Init)");
#define mccompcurname  channel_10_analyzer_1_array_crystal_array_7
#define mccompcurtype  Union_box
#define mccompcurindex 517
#define loop_index mccchannel_10_analyzer_1_array_crystal_array_7_loop_index
#define this_box_volume mccchannel_10_analyzer_1_array_crystal_array_7_this_box_volume
#define global_geometry_element mccchannel_10_analyzer_1_array_crystal_array_7_global_geometry_element
#define this_box_storage mccchannel_10_analyzer_1_array_crystal_array_7_this_box_storage
#define material_string mccchannel_10_analyzer_1_array_crystal_array_7_material_string
#define priority mccchannel_10_analyzer_1_array_crystal_array_7_priority
#define xwidth mccchannel_10_analyzer_1_array_crystal_array_7_xwidth
#define yheight mccchannel_10_analyzer_1_array_crystal_array_7_yheight
#define zdepth mccchannel_10_analyzer_1_array_crystal_array_7_zdepth
#define xwidth2 mccchannel_10_analyzer_1_array_crystal_array_7_xwidth2
#define yheight2 mccchannel_10_analyzer_1_array_crystal_array_7_yheight2
#define visualize mccchannel_10_analyzer_1_array_crystal_array_7_visualize
#define target_index mccchannel_10_analyzer_1_array_crystal_array_7_target_index
#define target_x mccchannel_10_analyzer_1_array_crystal_array_7_target_x
#define target_y mccchannel_10_analyzer_1_array_crystal_array_7_target_y
#define target_z mccchannel_10_analyzer_1_array_crystal_array_7_target_z
#define focus_aw mccchannel_10_analyzer_1_array_crystal_array_7_focus_aw
#define focus_ah mccchannel_10_analyzer_1_array_crystal_array_7_focus_ah
#define focus_xw mccchannel_10_analyzer_1_array_crystal_array_7_focus_xw
#define focus_xh mccchannel_10_analyzer_1_array_crystal_array_7_focus_xh
#define focus_r mccchannel_10_analyzer_1_array_crystal_array_7_focus_r
#define p_interact mccchannel_10_analyzer_1_array_crystal_array_7_p_interact
#define mask_string mccchannel_10_analyzer_1_array_crystal_array_7_mask_string
#define mask_setting mccchannel_10_analyzer_1_array_crystal_array_7_mask_setting
#define number_of_activations mccchannel_10_analyzer_1_array_crystal_array_7_number_of_activations
#line 224 "Union_box.comp"
{
// Initializes the focusing system for this volume including input sanitation.
focus_initialize(&this_box_volume.geometry, POS_A_COMP_INDEX(INDEX_CURRENT_COMP+target_index), POS_A_CURRENT_COMP, ROT_A_CURRENT_COMP, target_index, target_x, target_y, target_z, focus_aw, focus_ah, focus_xw, focus_xh, focus_r, NAME_CURRENT_COMP);

// Input sanitation for this geometry
if (xwidth <= 0) {
  printf("\nERROR in Union_box named %s, the xwidth is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (yheight <= 0) {
  printf("\nERROR in Union_box named %s, yheight is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (zdepth <= 0) {
  printf("\nERROR in Union_box named %s, zdepth is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (xwidth2 <= 0 && xwidth2 != -1) {
  printf("\nERROR in Union_box named %s, the xwidth2 is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (yheight2 <= 0 && yheight2 != -1) {
  printf("\nERROR in Union_box named %s, yheight2 is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}

// Use sanitation
if (global_material_list.num_elements == 0) {
  printf("\nERROR: Need to define a material using Union_make_material before using a Union geometry component. \n");
  printf("       %s was defined before first use of Union_make_material.\n",NAME_CURRENT_COMP);
  exit(1);
}

this_box_volume.geometry.is_masked_volume = 0;
this_box_volume.geometry.is_exit_volume = 0;
this_box_volume.geometry.is_mask_volume = 0;
// check if the volume is a mask, if it is the material string is irelevant.
if (mask_string && strlen(mask_string) && strcmp(mask_string, "NULL") && strcmp(mask_string, "0")) {
    // A mask volume is used to limit the extend of other volumes, called the masked volumes. These are specified in the mask_string.
    // In order for a ray to enter a masked volume, it needs to be both in the region covered by that volume AND the mask volume.
    // When more than
    this_box_volume.geometry.mask_mode = 1; // Default is mask mode is ALL
    if (mask_setting && strlen(mask_setting) && strcmp(mask_setting, "NULL") && strcmp(mask_setting, "0")) {
        if (strcmp(mask_setting,"ALL") == 0 || strcmp(mask_setting,"All") == 0) this_box_volume.geometry.mask_mode = 1;
        else if (strcmp(mask_setting,"ANY") == 0 || strcmp(mask_setting,"Any") == 0) this_box_volume.geometry.mask_mode = 2;
        else {
            printf("The mask_mode of component %s is set to %s, but must be either ALL or ANY.\n",NAME_CURRENT_COMP,mask_setting);
            exit(1);
        }
    }
    
    for (loop_index=0;loop_index<global_geometry_list.num_elements;loop_index++) {
        // Add mask list
        if (1 == manual_linking_function(global_geometry_list.elements[loop_index].name,mask_string)) {
            add_element_to_int_list(&this_box_volume.geometry.mask_list,global_geometry_list.elements[loop_index].component_index);
            add_element_to_int_list(&global_geometry_list.elements[loop_index].Volume->geometry.masked_by_list,INDEX_CURRENT_COMP);
            global_geometry_list.elements[loop_index].Volume->geometry.is_masked_volume = 1;
            if (this_box_volume.geometry.mask_mode == 2)
                global_geometry_list.elements[loop_index].Volume->geometry.mask_mode = 2;
            if (this_box_volume.geometry.mask_mode == 1) {
                if (global_geometry_list.elements[loop_index].Volume->geometry.is_masked_volume == 1 && global_geometry_list.elements[loop_index].Volume->geometry.mask_mode != 2)
                    // If more than one mask is added to one volume, the ANY mode overwrites the (default) ALL mode.
                    global_geometry_list.elements[loop_index].Volume->geometry.mask_mode = 1;
            }
            
            found_geometries = 1;
        }
    }
    if (found_geometries == 0) {
        printf("The mask_string in geometry: %s did not find any of the specified volumes in the mask_string %s \n",NAME_CURRENT_COMP,mask_string);
        exit(1);
    }
    this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
    this_box_volume.p_physics->is_vacuum = 0; // Makes this volume a vacuum
    this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
    this_box_volume.p_physics->my_a = 0; // Should not be used.
    sprintf(this_box_volume.p_physics->name,"Mask");
    this_box_volume.geometry.is_mask_volume = 1;
    
    
// Read the material input, or if it lacks, use automatic linking.
} else if (material_string && strlen(material_string) && strcmp(material_string, "NULL") && strcmp(material_string, "0")) {
    // A geometry string was given, use it to determine which material
    if (0 == strcmp(material_string,"vacuum") || 0 == strcmp(material_string,"Vacuum")) {
        // One could have a global physics struct for vacuum instead of creating one for each
        this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
        this_box_volume.p_physics->is_vacuum = 1; // Makes this volume a vacuum
        this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
        this_box_volume.p_physics->my_a = 0; // Should not be used.
        sprintf(this_box_volume.p_physics->name,"Vacuum");
    } else if (0 == strcmp(material_string,"exit") || 0 == strcmp(material_string,"Exit")) {
        // One could have a global physics struct for vacuum instead of creating one for each
        this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
        this_box_volume.p_physics->is_vacuum = 1; // Makes this volume a vacuum
        this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
        this_box_volume.p_physics->my_a = 0; // Should not be used.
        this_box_volume.geometry.is_exit_volume = 1;
        sprintf(this_box_volume.p_physics->name,"Exit");
    } else {
        #ifndef MATERIAL_DETECTOR
            printf("Need to define a material before refering to it in a geometry %s.\n",NAME_CURRENT_COMP);
            exit(1);
        #endif
        for (loop_index=0;loop_index<global_material_list.num_elements;loop_index++) {
            if (0 == strcmp(material_string,global_material_list.elements[loop_index].name)) {
                this_box_volume.p_physics = global_material_list.elements[loop_index].physics;
                break;
            }
            if (loop_index == global_material_list.num_elements-1) {
            printf("\n");
            printf("ERROR: The material string \"%s\" in Union geometry \"%s\" did not match a specified material. \n",material_string,NAME_CURRENT_COMP);
            printf("       The materials available at this point (need to be defined before the geometry): \n");
            for (loop_index=0;loop_index<global_material_list.num_elements;loop_index++)
              printf("         %s\n",global_material_list.elements[loop_index].name);
            printf("\n");
            printf("       It is also possible to use one of the defualt materials avaiable: \n");
            printf("           Vacuum (for a Volume without scattering or absorption)\n");
            printf("           Exit (for a Volume where the ray exits the component if it enters)\n");
            printf("           Mask (for a Volume that masks existing volumes specified in the mask_string\n");
            exit(1);
          }
        }
    }
} else {
    // Automatic linking, simply using the last defined material.
    #ifndef MATERIAL_DETECTOR
        printf("Need to define a material before the geometry to use automatic linking %s.\n",NAME_CURRENT_COMP);
        exit(1);
    #endif
    this_box_volume.p_physics = global_material_list.elements[global_material_list.num_elements-1].physics;
}

sprintf(this_box_volume.name,NAME_CURRENT_COMP);
sprintf(this_box_volume.geometry.shape,"box");
this_box_volume.geometry.priority_value = priority;
this_box_volume.geometry.geometry_p_interact = p_interact;
// Currently the coordinates will be in absolute space.
this_box_volume.geometry.center = POS_A_CURRENT_COMP;

this_box_storage.z_depth = zdepth;
this_box_storage.x_width1 = xwidth;
this_box_storage.y_height1 = yheight;

this_box_storage.is_rectangle = 0;
if (xwidth2 < 0 && yheight2 < 0) this_box_storage.is_rectangle = 1;
if (xwidth == xwidth2 && yheight == yheight2) this_box_storage.is_rectangle = 1;

if (xwidth2 < 0) {
    this_box_storage.x_width2 = xwidth;
    xwidth2 = xwidth;
} else this_box_storage.x_width2 = xwidth2;

if (yheight2 < 0) {
    this_box_storage.y_height2 = yheight;
    yheight2 = yheight;
} else this_box_storage.y_height2 = yheight2;


this_box_storage.normal_vectors[0] = coords_set(0,0,1);
this_box_storage.normal_vectors[1] = coords_set(0,0,1);

// for sides with y component = 0
x_component = 2*zdepth/sqrt((xwidth-xwidth2)*(xwidth-xwidth2)+4*zdepth*zdepth);
z_component = (xwidth-xwidth2)/sqrt(4*zdepth*zdepth+(xwidth-xwidth2)*(xwidth-xwidth2));

this_box_storage.normal_vectors[2] = coords_set(x_component,0,z_component);
this_box_storage.normal_vectors[3] = coords_set(-x_component,0,z_component);

// for sides with x component = 0
y_component = 2*zdepth/sqrt((yheight-yheight2)*(yheight-yheight2)+4*zdepth*zdepth);
z_component = (yheight-yheight2)/sqrt(4*zdepth*zdepth+(yheight-yheight2)*(yheight-yheight2));

this_box_storage.normal_vectors[4] = coords_set(0,y_component,z_component);
this_box_storage.normal_vectors[5] = coords_set(0,-y_component,z_component);

this_box_volume.geometry.visualization_on = visualize;

this_box_volume.geometry.geometry_parameters.p_box_storage = &this_box_storage;

// Assign pointers to functions for intersection with the shape, checking if a point is inside the shape
if (this_box_storage.is_rectangle == 1) {
this_box_volume.geometry.intersect_function = &sample_box_intersect_simple;
this_box_volume.geometry.within_function = &r_within_box_simple;
}
else {
this_box_volume.geometry.intersect_function = &sample_box_intersect_advanced;
this_box_volume.geometry.within_function = &r_within_box_advanced;
}

this_box_volume.geometry.shell_points = &box_shell_points;
this_box_volume.geometry.mcdisplay_function = &mcdisplay_box_function;
this_box_volume.geometry.initialize_from_main_function = &initialize_box_geometry_from_main_component;
this_box_volume.geometry.process_rot_allocated = 0;

this_box_volume.geometry.copy_geometry_parameters = &allocate_box_storage_copy;

rot_copy(this_box_volume.geometry.rotation_matrix,ROT_A_CURRENT_COMP); //check how ROT_R_CURRENT_COMP would work
rot_transpose(ROT_A_CURRENT_COMP,this_box_volume.geometry.transpose_rotation_matrix);

// Initialize loggers
this_box_volume.loggers.num_elements = 0;

// packing the information into the global_geometry_element, which is then included in the global_geometry_list.
sprintf(global_geometry_element.name,NAME_CURRENT_COMP);
global_geometry_element.activation_counter = number_of_activations;
global_geometry_element.component_index = INDEX_CURRENT_COMP;
global_geometry_element.Volume = &this_box_volume; // Would be nicer if this m was a pointer, now we have the (small) data two places
add_element_to_geometry_list(&global_geometry_list,global_geometry_element);
}
#line 255773 "MACS_sample_kidney_box.c"
#undef number_of_activations
#undef mask_setting
#undef mask_string
#undef p_interact
#undef focus_r
#undef focus_xh
#undef focus_xw
#undef focus_ah
#undef focus_aw
#undef target_z
#undef target_y
#undef target_x
#undef target_index
#undef visualize
#undef yheight2
#undef xwidth2
#undef zdepth
#undef yheight
#undef xwidth
#undef priority
#undef material_string
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

  /* Initializations for component channel_10_analyzer_1_array_crystal_array_8. */
  SIG_MESSAGE("channel_10_analyzer_1_array_crystal_array_8 (Init)");
#define mccompcurname  channel_10_analyzer_1_array_crystal_array_8
#define mccompcurtype  Union_box
#define mccompcurindex 518
#define loop_index mccchannel_10_analyzer_1_array_crystal_array_8_loop_index
#define this_box_volume mccchannel_10_analyzer_1_array_crystal_array_8_this_box_volume
#define global_geometry_element mccchannel_10_analyzer_1_array_crystal_array_8_global_geometry_element
#define this_box_storage mccchannel_10_analyzer_1_array_crystal_array_8_this_box_storage
#define material_string mccchannel_10_analyzer_1_array_crystal_array_8_material_string
#define priority mccchannel_10_analyzer_1_array_crystal_array_8_priority
#define xwidth mccchannel_10_analyzer_1_array_crystal_array_8_xwidth
#define yheight mccchannel_10_analyzer_1_array_crystal_array_8_yheight
#define zdepth mccchannel_10_analyzer_1_array_crystal_array_8_zdepth
#define xwidth2 mccchannel_10_analyzer_1_array_crystal_array_8_xwidth2
#define yheight2 mccchannel_10_analyzer_1_array_crystal_array_8_yheight2
#define visualize mccchannel_10_analyzer_1_array_crystal_array_8_visualize
#define target_index mccchannel_10_analyzer_1_array_crystal_array_8_target_index
#define target_x mccchannel_10_analyzer_1_array_crystal_array_8_target_x
#define target_y mccchannel_10_analyzer_1_array_crystal_array_8_target_y
#define target_z mccchannel_10_analyzer_1_array_crystal_array_8_target_z
#define focus_aw mccchannel_10_analyzer_1_array_crystal_array_8_focus_aw
#define focus_ah mccchannel_10_analyzer_1_array_crystal_array_8_focus_ah
#define focus_xw mccchannel_10_analyzer_1_array_crystal_array_8_focus_xw
#define focus_xh mccchannel_10_analyzer_1_array_crystal_array_8_focus_xh
#define focus_r mccchannel_10_analyzer_1_array_crystal_array_8_focus_r
#define p_interact mccchannel_10_analyzer_1_array_crystal_array_8_p_interact
#define mask_string mccchannel_10_analyzer_1_array_crystal_array_8_mask_string
#define mask_setting mccchannel_10_analyzer_1_array_crystal_array_8_mask_setting
#define number_of_activations mccchannel_10_analyzer_1_array_crystal_array_8_number_of_activations
#line 224 "Union_box.comp"
{
// Initializes the focusing system for this volume including input sanitation.
focus_initialize(&this_box_volume.geometry, POS_A_COMP_INDEX(INDEX_CURRENT_COMP+target_index), POS_A_CURRENT_COMP, ROT_A_CURRENT_COMP, target_index, target_x, target_y, target_z, focus_aw, focus_ah, focus_xw, focus_xh, focus_r, NAME_CURRENT_COMP);

// Input sanitation for this geometry
if (xwidth <= 0) {
  printf("\nERROR in Union_box named %s, the xwidth is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (yheight <= 0) {
  printf("\nERROR in Union_box named %s, yheight is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (zdepth <= 0) {
  printf("\nERROR in Union_box named %s, zdepth is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (xwidth2 <= 0 && xwidth2 != -1) {
  printf("\nERROR in Union_box named %s, the xwidth2 is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (yheight2 <= 0 && yheight2 != -1) {
  printf("\nERROR in Union_box named %s, yheight2 is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}

// Use sanitation
if (global_material_list.num_elements == 0) {
  printf("\nERROR: Need to define a material using Union_make_material before using a Union geometry component. \n");
  printf("       %s was defined before first use of Union_make_material.\n",NAME_CURRENT_COMP);
  exit(1);
}

this_box_volume.geometry.is_masked_volume = 0;
this_box_volume.geometry.is_exit_volume = 0;
this_box_volume.geometry.is_mask_volume = 0;
// check if the volume is a mask, if it is the material string is irelevant.
if (mask_string && strlen(mask_string) && strcmp(mask_string, "NULL") && strcmp(mask_string, "0")) {
    // A mask volume is used to limit the extend of other volumes, called the masked volumes. These are specified in the mask_string.
    // In order for a ray to enter a masked volume, it needs to be both in the region covered by that volume AND the mask volume.
    // When more than
    this_box_volume.geometry.mask_mode = 1; // Default is mask mode is ALL
    if (mask_setting && strlen(mask_setting) && strcmp(mask_setting, "NULL") && strcmp(mask_setting, "0")) {
        if (strcmp(mask_setting,"ALL") == 0 || strcmp(mask_setting,"All") == 0) this_box_volume.geometry.mask_mode = 1;
        else if (strcmp(mask_setting,"ANY") == 0 || strcmp(mask_setting,"Any") == 0) this_box_volume.geometry.mask_mode = 2;
        else {
            printf("The mask_mode of component %s is set to %s, but must be either ALL or ANY.\n",NAME_CURRENT_COMP,mask_setting);
            exit(1);
        }
    }
    
    for (loop_index=0;loop_index<global_geometry_list.num_elements;loop_index++) {
        // Add mask list
        if (1 == manual_linking_function(global_geometry_list.elements[loop_index].name,mask_string)) {
            add_element_to_int_list(&this_box_volume.geometry.mask_list,global_geometry_list.elements[loop_index].component_index);
            add_element_to_int_list(&global_geometry_list.elements[loop_index].Volume->geometry.masked_by_list,INDEX_CURRENT_COMP);
            global_geometry_list.elements[loop_index].Volume->geometry.is_masked_volume = 1;
            if (this_box_volume.geometry.mask_mode == 2)
                global_geometry_list.elements[loop_index].Volume->geometry.mask_mode = 2;
            if (this_box_volume.geometry.mask_mode == 1) {
                if (global_geometry_list.elements[loop_index].Volume->geometry.is_masked_volume == 1 && global_geometry_list.elements[loop_index].Volume->geometry.mask_mode != 2)
                    // If more than one mask is added to one volume, the ANY mode overwrites the (default) ALL mode.
                    global_geometry_list.elements[loop_index].Volume->geometry.mask_mode = 1;
            }
            
            found_geometries = 1;
        }
    }
    if (found_geometries == 0) {
        printf("The mask_string in geometry: %s did not find any of the specified volumes in the mask_string %s \n",NAME_CURRENT_COMP,mask_string);
        exit(1);
    }
    this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
    this_box_volume.p_physics->is_vacuum = 0; // Makes this volume a vacuum
    this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
    this_box_volume.p_physics->my_a = 0; // Should not be used.
    sprintf(this_box_volume.p_physics->name,"Mask");
    this_box_volume.geometry.is_mask_volume = 1;
    
    
// Read the material input, or if it lacks, use automatic linking.
} else if (material_string && strlen(material_string) && strcmp(material_string, "NULL") && strcmp(material_string, "0")) {
    // A geometry string was given, use it to determine which material
    if (0 == strcmp(material_string,"vacuum") || 0 == strcmp(material_string,"Vacuum")) {
        // One could have a global physics struct for vacuum instead of creating one for each
        this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
        this_box_volume.p_physics->is_vacuum = 1; // Makes this volume a vacuum
        this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
        this_box_volume.p_physics->my_a = 0; // Should not be used.
        sprintf(this_box_volume.p_physics->name,"Vacuum");
    } else if (0 == strcmp(material_string,"exit") || 0 == strcmp(material_string,"Exit")) {
        // One could have a global physics struct for vacuum instead of creating one for each
        this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
        this_box_volume.p_physics->is_vacuum = 1; // Makes this volume a vacuum
        this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
        this_box_volume.p_physics->my_a = 0; // Should not be used.
        this_box_volume.geometry.is_exit_volume = 1;
        sprintf(this_box_volume.p_physics->name,"Exit");
    } else {
        #ifndef MATERIAL_DETECTOR
            printf("Need to define a material before refering to it in a geometry %s.\n",NAME_CURRENT_COMP);
            exit(1);
        #endif
        for (loop_index=0;loop_index<global_material_list.num_elements;loop_index++) {
            if (0 == strcmp(material_string,global_material_list.elements[loop_index].name)) {
                this_box_volume.p_physics = global_material_list.elements[loop_index].physics;
                break;
            }
            if (loop_index == global_material_list.num_elements-1) {
            printf("\n");
            printf("ERROR: The material string \"%s\" in Union geometry \"%s\" did not match a specified material. \n",material_string,NAME_CURRENT_COMP);
            printf("       The materials available at this point (need to be defined before the geometry): \n");
            for (loop_index=0;loop_index<global_material_list.num_elements;loop_index++)
              printf("         %s\n",global_material_list.elements[loop_index].name);
            printf("\n");
            printf("       It is also possible to use one of the defualt materials avaiable: \n");
            printf("           Vacuum (for a Volume without scattering or absorption)\n");
            printf("           Exit (for a Volume where the ray exits the component if it enters)\n");
            printf("           Mask (for a Volume that masks existing volumes specified in the mask_string\n");
            exit(1);
          }
        }
    }
} else {
    // Automatic linking, simply using the last defined material.
    #ifndef MATERIAL_DETECTOR
        printf("Need to define a material before the geometry to use automatic linking %s.\n",NAME_CURRENT_COMP);
        exit(1);
    #endif
    this_box_volume.p_physics = global_material_list.elements[global_material_list.num_elements-1].physics;
}

sprintf(this_box_volume.name,NAME_CURRENT_COMP);
sprintf(this_box_volume.geometry.shape,"box");
this_box_volume.geometry.priority_value = priority;
this_box_volume.geometry.geometry_p_interact = p_interact;
// Currently the coordinates will be in absolute space.
this_box_volume.geometry.center = POS_A_CURRENT_COMP;

this_box_storage.z_depth = zdepth;
this_box_storage.x_width1 = xwidth;
this_box_storage.y_height1 = yheight;

this_box_storage.is_rectangle = 0;
if (xwidth2 < 0 && yheight2 < 0) this_box_storage.is_rectangle = 1;
if (xwidth == xwidth2 && yheight == yheight2) this_box_storage.is_rectangle = 1;

if (xwidth2 < 0) {
    this_box_storage.x_width2 = xwidth;
    xwidth2 = xwidth;
} else this_box_storage.x_width2 = xwidth2;

if (yheight2 < 0) {
    this_box_storage.y_height2 = yheight;
    yheight2 = yheight;
} else this_box_storage.y_height2 = yheight2;


this_box_storage.normal_vectors[0] = coords_set(0,0,1);
this_box_storage.normal_vectors[1] = coords_set(0,0,1);

// for sides with y component = 0
x_component = 2*zdepth/sqrt((xwidth-xwidth2)*(xwidth-xwidth2)+4*zdepth*zdepth);
z_component = (xwidth-xwidth2)/sqrt(4*zdepth*zdepth+(xwidth-xwidth2)*(xwidth-xwidth2));

this_box_storage.normal_vectors[2] = coords_set(x_component,0,z_component);
this_box_storage.normal_vectors[3] = coords_set(-x_component,0,z_component);

// for sides with x component = 0
y_component = 2*zdepth/sqrt((yheight-yheight2)*(yheight-yheight2)+4*zdepth*zdepth);
z_component = (yheight-yheight2)/sqrt(4*zdepth*zdepth+(yheight-yheight2)*(yheight-yheight2));

this_box_storage.normal_vectors[4] = coords_set(0,y_component,z_component);
this_box_storage.normal_vectors[5] = coords_set(0,-y_component,z_component);

this_box_volume.geometry.visualization_on = visualize;

this_box_volume.geometry.geometry_parameters.p_box_storage = &this_box_storage;

// Assign pointers to functions for intersection with the shape, checking if a point is inside the shape
if (this_box_storage.is_rectangle == 1) {
this_box_volume.geometry.intersect_function = &sample_box_intersect_simple;
this_box_volume.geometry.within_function = &r_within_box_simple;
}
else {
this_box_volume.geometry.intersect_function = &sample_box_intersect_advanced;
this_box_volume.geometry.within_function = &r_within_box_advanced;
}

this_box_volume.geometry.shell_points = &box_shell_points;
this_box_volume.geometry.mcdisplay_function = &mcdisplay_box_function;
this_box_volume.geometry.initialize_from_main_function = &initialize_box_geometry_from_main_component;
this_box_volume.geometry.process_rot_allocated = 0;

this_box_volume.geometry.copy_geometry_parameters = &allocate_box_storage_copy;

rot_copy(this_box_volume.geometry.rotation_matrix,ROT_A_CURRENT_COMP); //check how ROT_R_CURRENT_COMP would work
rot_transpose(ROT_A_CURRENT_COMP,this_box_volume.geometry.transpose_rotation_matrix);

// Initialize loggers
this_box_volume.loggers.num_elements = 0;

// packing the information into the global_geometry_element, which is then included in the global_geometry_list.
sprintf(global_geometry_element.name,NAME_CURRENT_COMP);
global_geometry_element.activation_counter = number_of_activations;
global_geometry_element.component_index = INDEX_CURRENT_COMP;
global_geometry_element.Volume = &this_box_volume; // Would be nicer if this m was a pointer, now we have the (small) data two places
add_element_to_geometry_list(&global_geometry_list,global_geometry_element);
}
#line 256043 "MACS_sample_kidney_box.c"
#undef number_of_activations
#undef mask_setting
#undef mask_string
#undef p_interact
#undef focus_r
#undef focus_xh
#undef focus_xw
#undef focus_ah
#undef focus_aw
#undef target_z
#undef target_y
#undef target_x
#undef target_index
#undef visualize
#undef yheight2
#undef xwidth2
#undef zdepth
#undef yheight
#undef xwidth
#undef priority
#undef material_string
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

  /* Initializations for component channel_10_analyzer_2_center. */
  SIG_MESSAGE("channel_10_analyzer_2_center (Init)");

  /* Initializations for component channel_10_analyzer_2_rotated. */
  SIG_MESSAGE("channel_10_analyzer_2_rotated (Init)");

  /* Initializations for component channel_10_analyzer_2_array_crystal_array_0. */
  SIG_MESSAGE("channel_10_analyzer_2_array_crystal_array_0 (Init)");
#define mccompcurname  channel_10_analyzer_2_array_crystal_array_0
#define mccompcurtype  Union_box
#define mccompcurindex 521
#define loop_index mccchannel_10_analyzer_2_array_crystal_array_0_loop_index
#define this_box_volume mccchannel_10_analyzer_2_array_crystal_array_0_this_box_volume
#define global_geometry_element mccchannel_10_analyzer_2_array_crystal_array_0_global_geometry_element
#define this_box_storage mccchannel_10_analyzer_2_array_crystal_array_0_this_box_storage
#define material_string mccchannel_10_analyzer_2_array_crystal_array_0_material_string
#define priority mccchannel_10_analyzer_2_array_crystal_array_0_priority
#define xwidth mccchannel_10_analyzer_2_array_crystal_array_0_xwidth
#define yheight mccchannel_10_analyzer_2_array_crystal_array_0_yheight
#define zdepth mccchannel_10_analyzer_2_array_crystal_array_0_zdepth
#define xwidth2 mccchannel_10_analyzer_2_array_crystal_array_0_xwidth2
#define yheight2 mccchannel_10_analyzer_2_array_crystal_array_0_yheight2
#define visualize mccchannel_10_analyzer_2_array_crystal_array_0_visualize
#define target_index mccchannel_10_analyzer_2_array_crystal_array_0_target_index
#define target_x mccchannel_10_analyzer_2_array_crystal_array_0_target_x
#define target_y mccchannel_10_analyzer_2_array_crystal_array_0_target_y
#define target_z mccchannel_10_analyzer_2_array_crystal_array_0_target_z
#define focus_aw mccchannel_10_analyzer_2_array_crystal_array_0_focus_aw
#define focus_ah mccchannel_10_analyzer_2_array_crystal_array_0_focus_ah
#define focus_xw mccchannel_10_analyzer_2_array_crystal_array_0_focus_xw
#define focus_xh mccchannel_10_analyzer_2_array_crystal_array_0_focus_xh
#define focus_r mccchannel_10_analyzer_2_array_crystal_array_0_focus_r
#define p_interact mccchannel_10_analyzer_2_array_crystal_array_0_p_interact
#define mask_string mccchannel_10_analyzer_2_array_crystal_array_0_mask_string
#define mask_setting mccchannel_10_analyzer_2_array_crystal_array_0_mask_setting
#define number_of_activations mccchannel_10_analyzer_2_array_crystal_array_0_number_of_activations
#line 224 "Union_box.comp"
{
// Initializes the focusing system for this volume including input sanitation.
focus_initialize(&this_box_volume.geometry, POS_A_COMP_INDEX(INDEX_CURRENT_COMP+target_index), POS_A_CURRENT_COMP, ROT_A_CURRENT_COMP, target_index, target_x, target_y, target_z, focus_aw, focus_ah, focus_xw, focus_xh, focus_r, NAME_CURRENT_COMP);

// Input sanitation for this geometry
if (xwidth <= 0) {
  printf("\nERROR in Union_box named %s, the xwidth is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (yheight <= 0) {
  printf("\nERROR in Union_box named %s, yheight is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (zdepth <= 0) {
  printf("\nERROR in Union_box named %s, zdepth is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (xwidth2 <= 0 && xwidth2 != -1) {
  printf("\nERROR in Union_box named %s, the xwidth2 is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (yheight2 <= 0 && yheight2 != -1) {
  printf("\nERROR in Union_box named %s, yheight2 is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}

// Use sanitation
if (global_material_list.num_elements == 0) {
  printf("\nERROR: Need to define a material using Union_make_material before using a Union geometry component. \n");
  printf("       %s was defined before first use of Union_make_material.\n",NAME_CURRENT_COMP);
  exit(1);
}

this_box_volume.geometry.is_masked_volume = 0;
this_box_volume.geometry.is_exit_volume = 0;
this_box_volume.geometry.is_mask_volume = 0;
// check if the volume is a mask, if it is the material string is irelevant.
if (mask_string && strlen(mask_string) && strcmp(mask_string, "NULL") && strcmp(mask_string, "0")) {
    // A mask volume is used to limit the extend of other volumes, called the masked volumes. These are specified in the mask_string.
    // In order for a ray to enter a masked volume, it needs to be both in the region covered by that volume AND the mask volume.
    // When more than
    this_box_volume.geometry.mask_mode = 1; // Default is mask mode is ALL
    if (mask_setting && strlen(mask_setting) && strcmp(mask_setting, "NULL") && strcmp(mask_setting, "0")) {
        if (strcmp(mask_setting,"ALL") == 0 || strcmp(mask_setting,"All") == 0) this_box_volume.geometry.mask_mode = 1;
        else if (strcmp(mask_setting,"ANY") == 0 || strcmp(mask_setting,"Any") == 0) this_box_volume.geometry.mask_mode = 2;
        else {
            printf("The mask_mode of component %s is set to %s, but must be either ALL or ANY.\n",NAME_CURRENT_COMP,mask_setting);
            exit(1);
        }
    }
    
    for (loop_index=0;loop_index<global_geometry_list.num_elements;loop_index++) {
        // Add mask list
        if (1 == manual_linking_function(global_geometry_list.elements[loop_index].name,mask_string)) {
            add_element_to_int_list(&this_box_volume.geometry.mask_list,global_geometry_list.elements[loop_index].component_index);
            add_element_to_int_list(&global_geometry_list.elements[loop_index].Volume->geometry.masked_by_list,INDEX_CURRENT_COMP);
            global_geometry_list.elements[loop_index].Volume->geometry.is_masked_volume = 1;
            if (this_box_volume.geometry.mask_mode == 2)
                global_geometry_list.elements[loop_index].Volume->geometry.mask_mode = 2;
            if (this_box_volume.geometry.mask_mode == 1) {
                if (global_geometry_list.elements[loop_index].Volume->geometry.is_masked_volume == 1 && global_geometry_list.elements[loop_index].Volume->geometry.mask_mode != 2)
                    // If more than one mask is added to one volume, the ANY mode overwrites the (default) ALL mode.
                    global_geometry_list.elements[loop_index].Volume->geometry.mask_mode = 1;
            }
            
            found_geometries = 1;
        }
    }
    if (found_geometries == 0) {
        printf("The mask_string in geometry: %s did not find any of the specified volumes in the mask_string %s \n",NAME_CURRENT_COMP,mask_string);
        exit(1);
    }
    this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
    this_box_volume.p_physics->is_vacuum = 0; // Makes this volume a vacuum
    this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
    this_box_volume.p_physics->my_a = 0; // Should not be used.
    sprintf(this_box_volume.p_physics->name,"Mask");
    this_box_volume.geometry.is_mask_volume = 1;
    
    
// Read the material input, or if it lacks, use automatic linking.
} else if (material_string && strlen(material_string) && strcmp(material_string, "NULL") && strcmp(material_string, "0")) {
    // A geometry string was given, use it to determine which material
    if (0 == strcmp(material_string,"vacuum") || 0 == strcmp(material_string,"Vacuum")) {
        // One could have a global physics struct for vacuum instead of creating one for each
        this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
        this_box_volume.p_physics->is_vacuum = 1; // Makes this volume a vacuum
        this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
        this_box_volume.p_physics->my_a = 0; // Should not be used.
        sprintf(this_box_volume.p_physics->name,"Vacuum");
    } else if (0 == strcmp(material_string,"exit") || 0 == strcmp(material_string,"Exit")) {
        // One could have a global physics struct for vacuum instead of creating one for each
        this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
        this_box_volume.p_physics->is_vacuum = 1; // Makes this volume a vacuum
        this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
        this_box_volume.p_physics->my_a = 0; // Should not be used.
        this_box_volume.geometry.is_exit_volume = 1;
        sprintf(this_box_volume.p_physics->name,"Exit");
    } else {
        #ifndef MATERIAL_DETECTOR
            printf("Need to define a material before refering to it in a geometry %s.\n",NAME_CURRENT_COMP);
            exit(1);
        #endif
        for (loop_index=0;loop_index<global_material_list.num_elements;loop_index++) {
            if (0 == strcmp(material_string,global_material_list.elements[loop_index].name)) {
                this_box_volume.p_physics = global_material_list.elements[loop_index].physics;
                break;
            }
            if (loop_index == global_material_list.num_elements-1) {
            printf("\n");
            printf("ERROR: The material string \"%s\" in Union geometry \"%s\" did not match a specified material. \n",material_string,NAME_CURRENT_COMP);
            printf("       The materials available at this point (need to be defined before the geometry): \n");
            for (loop_index=0;loop_index<global_material_list.num_elements;loop_index++)
              printf("         %s\n",global_material_list.elements[loop_index].name);
            printf("\n");
            printf("       It is also possible to use one of the defualt materials avaiable: \n");
            printf("           Vacuum (for a Volume without scattering or absorption)\n");
            printf("           Exit (for a Volume where the ray exits the component if it enters)\n");
            printf("           Mask (for a Volume that masks existing volumes specified in the mask_string\n");
            exit(1);
          }
        }
    }
} else {
    // Automatic linking, simply using the last defined material.
    #ifndef MATERIAL_DETECTOR
        printf("Need to define a material before the geometry to use automatic linking %s.\n",NAME_CURRENT_COMP);
        exit(1);
    #endif
    this_box_volume.p_physics = global_material_list.elements[global_material_list.num_elements-1].physics;
}

sprintf(this_box_volume.name,NAME_CURRENT_COMP);
sprintf(this_box_volume.geometry.shape,"box");
this_box_volume.geometry.priority_value = priority;
this_box_volume.geometry.geometry_p_interact = p_interact;
// Currently the coordinates will be in absolute space.
this_box_volume.geometry.center = POS_A_CURRENT_COMP;

this_box_storage.z_depth = zdepth;
this_box_storage.x_width1 = xwidth;
this_box_storage.y_height1 = yheight;

this_box_storage.is_rectangle = 0;
if (xwidth2 < 0 && yheight2 < 0) this_box_storage.is_rectangle = 1;
if (xwidth == xwidth2 && yheight == yheight2) this_box_storage.is_rectangle = 1;

if (xwidth2 < 0) {
    this_box_storage.x_width2 = xwidth;
    xwidth2 = xwidth;
} else this_box_storage.x_width2 = xwidth2;

if (yheight2 < 0) {
    this_box_storage.y_height2 = yheight;
    yheight2 = yheight;
} else this_box_storage.y_height2 = yheight2;


this_box_storage.normal_vectors[0] = coords_set(0,0,1);
this_box_storage.normal_vectors[1] = coords_set(0,0,1);

// for sides with y component = 0
x_component = 2*zdepth/sqrt((xwidth-xwidth2)*(xwidth-xwidth2)+4*zdepth*zdepth);
z_component = (xwidth-xwidth2)/sqrt(4*zdepth*zdepth+(xwidth-xwidth2)*(xwidth-xwidth2));

this_box_storage.normal_vectors[2] = coords_set(x_component,0,z_component);
this_box_storage.normal_vectors[3] = coords_set(-x_component,0,z_component);

// for sides with x component = 0
y_component = 2*zdepth/sqrt((yheight-yheight2)*(yheight-yheight2)+4*zdepth*zdepth);
z_component = (yheight-yheight2)/sqrt(4*zdepth*zdepth+(yheight-yheight2)*(yheight-yheight2));

this_box_storage.normal_vectors[4] = coords_set(0,y_component,z_component);
this_box_storage.normal_vectors[5] = coords_set(0,-y_component,z_component);

this_box_volume.geometry.visualization_on = visualize;

this_box_volume.geometry.geometry_parameters.p_box_storage = &this_box_storage;

// Assign pointers to functions for intersection with the shape, checking if a point is inside the shape
if (this_box_storage.is_rectangle == 1) {
this_box_volume.geometry.intersect_function = &sample_box_intersect_simple;
this_box_volume.geometry.within_function = &r_within_box_simple;
}
else {
this_box_volume.geometry.intersect_function = &sample_box_intersect_advanced;
this_box_volume.geometry.within_function = &r_within_box_advanced;
}

this_box_volume.geometry.shell_points = &box_shell_points;
this_box_volume.geometry.mcdisplay_function = &mcdisplay_box_function;
this_box_volume.geometry.initialize_from_main_function = &initialize_box_geometry_from_main_component;
this_box_volume.geometry.process_rot_allocated = 0;

this_box_volume.geometry.copy_geometry_parameters = &allocate_box_storage_copy;

rot_copy(this_box_volume.geometry.rotation_matrix,ROT_A_CURRENT_COMP); //check how ROT_R_CURRENT_COMP would work
rot_transpose(ROT_A_CURRENT_COMP,this_box_volume.geometry.transpose_rotation_matrix);

// Initialize loggers
this_box_volume.loggers.num_elements = 0;

// packing the information into the global_geometry_element, which is then included in the global_geometry_list.
sprintf(global_geometry_element.name,NAME_CURRENT_COMP);
global_geometry_element.activation_counter = number_of_activations;
global_geometry_element.component_index = INDEX_CURRENT_COMP;
global_geometry_element.Volume = &this_box_volume; // Would be nicer if this m was a pointer, now we have the (small) data two places
add_element_to_geometry_list(&global_geometry_list,global_geometry_element);
}
#line 256319 "MACS_sample_kidney_box.c"
#undef number_of_activations
#undef mask_setting
#undef mask_string
#undef p_interact
#undef focus_r
#undef focus_xh
#undef focus_xw
#undef focus_ah
#undef focus_aw
#undef target_z
#undef target_y
#undef target_x
#undef target_index
#undef visualize
#undef yheight2
#undef xwidth2
#undef zdepth
#undef yheight
#undef xwidth
#undef priority
#undef material_string
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

  /* Initializations for component channel_10_analyzer_2_array_crystal_array_1. */
  SIG_MESSAGE("channel_10_analyzer_2_array_crystal_array_1 (Init)");
#define mccompcurname  channel_10_analyzer_2_array_crystal_array_1
#define mccompcurtype  Union_box
#define mccompcurindex 522
#define loop_index mccchannel_10_analyzer_2_array_crystal_array_1_loop_index
#define this_box_volume mccchannel_10_analyzer_2_array_crystal_array_1_this_box_volume
#define global_geometry_element mccchannel_10_analyzer_2_array_crystal_array_1_global_geometry_element
#define this_box_storage mccchannel_10_analyzer_2_array_crystal_array_1_this_box_storage
#define material_string mccchannel_10_analyzer_2_array_crystal_array_1_material_string
#define priority mccchannel_10_analyzer_2_array_crystal_array_1_priority
#define xwidth mccchannel_10_analyzer_2_array_crystal_array_1_xwidth
#define yheight mccchannel_10_analyzer_2_array_crystal_array_1_yheight
#define zdepth mccchannel_10_analyzer_2_array_crystal_array_1_zdepth
#define xwidth2 mccchannel_10_analyzer_2_array_crystal_array_1_xwidth2
#define yheight2 mccchannel_10_analyzer_2_array_crystal_array_1_yheight2
#define visualize mccchannel_10_analyzer_2_array_crystal_array_1_visualize
#define target_index mccchannel_10_analyzer_2_array_crystal_array_1_target_index
#define target_x mccchannel_10_analyzer_2_array_crystal_array_1_target_x
#define target_y mccchannel_10_analyzer_2_array_crystal_array_1_target_y
#define target_z mccchannel_10_analyzer_2_array_crystal_array_1_target_z
#define focus_aw mccchannel_10_analyzer_2_array_crystal_array_1_focus_aw
#define focus_ah mccchannel_10_analyzer_2_array_crystal_array_1_focus_ah
#define focus_xw mccchannel_10_analyzer_2_array_crystal_array_1_focus_xw
#define focus_xh mccchannel_10_analyzer_2_array_crystal_array_1_focus_xh
#define focus_r mccchannel_10_analyzer_2_array_crystal_array_1_focus_r
#define p_interact mccchannel_10_analyzer_2_array_crystal_array_1_p_interact
#define mask_string mccchannel_10_analyzer_2_array_crystal_array_1_mask_string
#define mask_setting mccchannel_10_analyzer_2_array_crystal_array_1_mask_setting
#define number_of_activations mccchannel_10_analyzer_2_array_crystal_array_1_number_of_activations
#line 224 "Union_box.comp"
{
// Initializes the focusing system for this volume including input sanitation.
focus_initialize(&this_box_volume.geometry, POS_A_COMP_INDEX(INDEX_CURRENT_COMP+target_index), POS_A_CURRENT_COMP, ROT_A_CURRENT_COMP, target_index, target_x, target_y, target_z, focus_aw, focus_ah, focus_xw, focus_xh, focus_r, NAME_CURRENT_COMP);

// Input sanitation for this geometry
if (xwidth <= 0) {
  printf("\nERROR in Union_box named %s, the xwidth is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (yheight <= 0) {
  printf("\nERROR in Union_box named %s, yheight is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (zdepth <= 0) {
  printf("\nERROR in Union_box named %s, zdepth is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (xwidth2 <= 0 && xwidth2 != -1) {
  printf("\nERROR in Union_box named %s, the xwidth2 is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (yheight2 <= 0 && yheight2 != -1) {
  printf("\nERROR in Union_box named %s, yheight2 is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}

// Use sanitation
if (global_material_list.num_elements == 0) {
  printf("\nERROR: Need to define a material using Union_make_material before using a Union geometry component. \n");
  printf("       %s was defined before first use of Union_make_material.\n",NAME_CURRENT_COMP);
  exit(1);
}

this_box_volume.geometry.is_masked_volume = 0;
this_box_volume.geometry.is_exit_volume = 0;
this_box_volume.geometry.is_mask_volume = 0;
// check if the volume is a mask, if it is the material string is irelevant.
if (mask_string && strlen(mask_string) && strcmp(mask_string, "NULL") && strcmp(mask_string, "0")) {
    // A mask volume is used to limit the extend of other volumes, called the masked volumes. These are specified in the mask_string.
    // In order for a ray to enter a masked volume, it needs to be both in the region covered by that volume AND the mask volume.
    // When more than
    this_box_volume.geometry.mask_mode = 1; // Default is mask mode is ALL
    if (mask_setting && strlen(mask_setting) && strcmp(mask_setting, "NULL") && strcmp(mask_setting, "0")) {
        if (strcmp(mask_setting,"ALL") == 0 || strcmp(mask_setting,"All") == 0) this_box_volume.geometry.mask_mode = 1;
        else if (strcmp(mask_setting,"ANY") == 0 || strcmp(mask_setting,"Any") == 0) this_box_volume.geometry.mask_mode = 2;
        else {
            printf("The mask_mode of component %s is set to %s, but must be either ALL or ANY.\n",NAME_CURRENT_COMP,mask_setting);
            exit(1);
        }
    }
    
    for (loop_index=0;loop_index<global_geometry_list.num_elements;loop_index++) {
        // Add mask list
        if (1 == manual_linking_function(global_geometry_list.elements[loop_index].name,mask_string)) {
            add_element_to_int_list(&this_box_volume.geometry.mask_list,global_geometry_list.elements[loop_index].component_index);
            add_element_to_int_list(&global_geometry_list.elements[loop_index].Volume->geometry.masked_by_list,INDEX_CURRENT_COMP);
            global_geometry_list.elements[loop_index].Volume->geometry.is_masked_volume = 1;
            if (this_box_volume.geometry.mask_mode == 2)
                global_geometry_list.elements[loop_index].Volume->geometry.mask_mode = 2;
            if (this_box_volume.geometry.mask_mode == 1) {
                if (global_geometry_list.elements[loop_index].Volume->geometry.is_masked_volume == 1 && global_geometry_list.elements[loop_index].Volume->geometry.mask_mode != 2)
                    // If more than one mask is added to one volume, the ANY mode overwrites the (default) ALL mode.
                    global_geometry_list.elements[loop_index].Volume->geometry.mask_mode = 1;
            }
            
            found_geometries = 1;
        }
    }
    if (found_geometries == 0) {
        printf("The mask_string in geometry: %s did not find any of the specified volumes in the mask_string %s \n",NAME_CURRENT_COMP,mask_string);
        exit(1);
    }
    this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
    this_box_volume.p_physics->is_vacuum = 0; // Makes this volume a vacuum
    this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
    this_box_volume.p_physics->my_a = 0; // Should not be used.
    sprintf(this_box_volume.p_physics->name,"Mask");
    this_box_volume.geometry.is_mask_volume = 1;
    
    
// Read the material input, or if it lacks, use automatic linking.
} else if (material_string && strlen(material_string) && strcmp(material_string, "NULL") && strcmp(material_string, "0")) {
    // A geometry string was given, use it to determine which material
    if (0 == strcmp(material_string,"vacuum") || 0 == strcmp(material_string,"Vacuum")) {
        // One could have a global physics struct for vacuum instead of creating one for each
        this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
        this_box_volume.p_physics->is_vacuum = 1; // Makes this volume a vacuum
        this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
        this_box_volume.p_physics->my_a = 0; // Should not be used.
        sprintf(this_box_volume.p_physics->name,"Vacuum");
    } else if (0 == strcmp(material_string,"exit") || 0 == strcmp(material_string,"Exit")) {
        // One could have a global physics struct for vacuum instead of creating one for each
        this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
        this_box_volume.p_physics->is_vacuum = 1; // Makes this volume a vacuum
        this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
        this_box_volume.p_physics->my_a = 0; // Should not be used.
        this_box_volume.geometry.is_exit_volume = 1;
        sprintf(this_box_volume.p_physics->name,"Exit");
    } else {
        #ifndef MATERIAL_DETECTOR
            printf("Need to define a material before refering to it in a geometry %s.\n",NAME_CURRENT_COMP);
            exit(1);
        #endif
        for (loop_index=0;loop_index<global_material_list.num_elements;loop_index++) {
            if (0 == strcmp(material_string,global_material_list.elements[loop_index].name)) {
                this_box_volume.p_physics = global_material_list.elements[loop_index].physics;
                break;
            }
            if (loop_index == global_material_list.num_elements-1) {
            printf("\n");
            printf("ERROR: The material string \"%s\" in Union geometry \"%s\" did not match a specified material. \n",material_string,NAME_CURRENT_COMP);
            printf("       The materials available at this point (need to be defined before the geometry): \n");
            for (loop_index=0;loop_index<global_material_list.num_elements;loop_index++)
              printf("         %s\n",global_material_list.elements[loop_index].name);
            printf("\n");
            printf("       It is also possible to use one of the defualt materials avaiable: \n");
            printf("           Vacuum (for a Volume without scattering or absorption)\n");
            printf("           Exit (for a Volume where the ray exits the component if it enters)\n");
            printf("           Mask (for a Volume that masks existing volumes specified in the mask_string\n");
            exit(1);
          }
        }
    }
} else {
    // Automatic linking, simply using the last defined material.
    #ifndef MATERIAL_DETECTOR
        printf("Need to define a material before the geometry to use automatic linking %s.\n",NAME_CURRENT_COMP);
        exit(1);
    #endif
    this_box_volume.p_physics = global_material_list.elements[global_material_list.num_elements-1].physics;
}

sprintf(this_box_volume.name,NAME_CURRENT_COMP);
sprintf(this_box_volume.geometry.shape,"box");
this_box_volume.geometry.priority_value = priority;
this_box_volume.geometry.geometry_p_interact = p_interact;
// Currently the coordinates will be in absolute space.
this_box_volume.geometry.center = POS_A_CURRENT_COMP;

this_box_storage.z_depth = zdepth;
this_box_storage.x_width1 = xwidth;
this_box_storage.y_height1 = yheight;

this_box_storage.is_rectangle = 0;
if (xwidth2 < 0 && yheight2 < 0) this_box_storage.is_rectangle = 1;
if (xwidth == xwidth2 && yheight == yheight2) this_box_storage.is_rectangle = 1;

if (xwidth2 < 0) {
    this_box_storage.x_width2 = xwidth;
    xwidth2 = xwidth;
} else this_box_storage.x_width2 = xwidth2;

if (yheight2 < 0) {
    this_box_storage.y_height2 = yheight;
    yheight2 = yheight;
} else this_box_storage.y_height2 = yheight2;


this_box_storage.normal_vectors[0] = coords_set(0,0,1);
this_box_storage.normal_vectors[1] = coords_set(0,0,1);

// for sides with y component = 0
x_component = 2*zdepth/sqrt((xwidth-xwidth2)*(xwidth-xwidth2)+4*zdepth*zdepth);
z_component = (xwidth-xwidth2)/sqrt(4*zdepth*zdepth+(xwidth-xwidth2)*(xwidth-xwidth2));

this_box_storage.normal_vectors[2] = coords_set(x_component,0,z_component);
this_box_storage.normal_vectors[3] = coords_set(-x_component,0,z_component);

// for sides with x component = 0
y_component = 2*zdepth/sqrt((yheight-yheight2)*(yheight-yheight2)+4*zdepth*zdepth);
z_component = (yheight-yheight2)/sqrt(4*zdepth*zdepth+(yheight-yheight2)*(yheight-yheight2));

this_box_storage.normal_vectors[4] = coords_set(0,y_component,z_component);
this_box_storage.normal_vectors[5] = coords_set(0,-y_component,z_component);

this_box_volume.geometry.visualization_on = visualize;

this_box_volume.geometry.geometry_parameters.p_box_storage = &this_box_storage;

// Assign pointers to functions for intersection with the shape, checking if a point is inside the shape
if (this_box_storage.is_rectangle == 1) {
this_box_volume.geometry.intersect_function = &sample_box_intersect_simple;
this_box_volume.geometry.within_function = &r_within_box_simple;
}
else {
this_box_volume.geometry.intersect_function = &sample_box_intersect_advanced;
this_box_volume.geometry.within_function = &r_within_box_advanced;
}

this_box_volume.geometry.shell_points = &box_shell_points;
this_box_volume.geometry.mcdisplay_function = &mcdisplay_box_function;
this_box_volume.geometry.initialize_from_main_function = &initialize_box_geometry_from_main_component;
this_box_volume.geometry.process_rot_allocated = 0;

this_box_volume.geometry.copy_geometry_parameters = &allocate_box_storage_copy;

rot_copy(this_box_volume.geometry.rotation_matrix,ROT_A_CURRENT_COMP); //check how ROT_R_CURRENT_COMP would work
rot_transpose(ROT_A_CURRENT_COMP,this_box_volume.geometry.transpose_rotation_matrix);

// Initialize loggers
this_box_volume.loggers.num_elements = 0;

// packing the information into the global_geometry_element, which is then included in the global_geometry_list.
sprintf(global_geometry_element.name,NAME_CURRENT_COMP);
global_geometry_element.activation_counter = number_of_activations;
global_geometry_element.component_index = INDEX_CURRENT_COMP;
global_geometry_element.Volume = &this_box_volume; // Would be nicer if this m was a pointer, now we have the (small) data two places
add_element_to_geometry_list(&global_geometry_list,global_geometry_element);
}
#line 256589 "MACS_sample_kidney_box.c"
#undef number_of_activations
#undef mask_setting
#undef mask_string
#undef p_interact
#undef focus_r
#undef focus_xh
#undef focus_xw
#undef focus_ah
#undef focus_aw
#undef target_z
#undef target_y
#undef target_x
#undef target_index
#undef visualize
#undef yheight2
#undef xwidth2
#undef zdepth
#undef yheight
#undef xwidth
#undef priority
#undef material_string
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

  /* Initializations for component channel_10_analyzer_2_array_crystal_array_2. */
  SIG_MESSAGE("channel_10_analyzer_2_array_crystal_array_2 (Init)");
#define mccompcurname  channel_10_analyzer_2_array_crystal_array_2
#define mccompcurtype  Union_box
#define mccompcurindex 523
#define loop_index mccchannel_10_analyzer_2_array_crystal_array_2_loop_index
#define this_box_volume mccchannel_10_analyzer_2_array_crystal_array_2_this_box_volume
#define global_geometry_element mccchannel_10_analyzer_2_array_crystal_array_2_global_geometry_element
#define this_box_storage mccchannel_10_analyzer_2_array_crystal_array_2_this_box_storage
#define material_string mccchannel_10_analyzer_2_array_crystal_array_2_material_string
#define priority mccchannel_10_analyzer_2_array_crystal_array_2_priority
#define xwidth mccchannel_10_analyzer_2_array_crystal_array_2_xwidth
#define yheight mccchannel_10_analyzer_2_array_crystal_array_2_yheight
#define zdepth mccchannel_10_analyzer_2_array_crystal_array_2_zdepth
#define xwidth2 mccchannel_10_analyzer_2_array_crystal_array_2_xwidth2
#define yheight2 mccchannel_10_analyzer_2_array_crystal_array_2_yheight2
#define visualize mccchannel_10_analyzer_2_array_crystal_array_2_visualize
#define target_index mccchannel_10_analyzer_2_array_crystal_array_2_target_index
#define target_x mccchannel_10_analyzer_2_array_crystal_array_2_target_x
#define target_y mccchannel_10_analyzer_2_array_crystal_array_2_target_y
#define target_z mccchannel_10_analyzer_2_array_crystal_array_2_target_z
#define focus_aw mccchannel_10_analyzer_2_array_crystal_array_2_focus_aw
#define focus_ah mccchannel_10_analyzer_2_array_crystal_array_2_focus_ah
#define focus_xw mccchannel_10_analyzer_2_array_crystal_array_2_focus_xw
#define focus_xh mccchannel_10_analyzer_2_array_crystal_array_2_focus_xh
#define focus_r mccchannel_10_analyzer_2_array_crystal_array_2_focus_r
#define p_interact mccchannel_10_analyzer_2_array_crystal_array_2_p_interact
#define mask_string mccchannel_10_analyzer_2_array_crystal_array_2_mask_string
#define mask_setting mccchannel_10_analyzer_2_array_crystal_array_2_mask_setting
#define number_of_activations mccchannel_10_analyzer_2_array_crystal_array_2_number_of_activations
#line 224 "Union_box.comp"
{
// Initializes the focusing system for this volume including input sanitation.
focus_initialize(&this_box_volume.geometry, POS_A_COMP_INDEX(INDEX_CURRENT_COMP+target_index), POS_A_CURRENT_COMP, ROT_A_CURRENT_COMP, target_index, target_x, target_y, target_z, focus_aw, focus_ah, focus_xw, focus_xh, focus_r, NAME_CURRENT_COMP);

// Input sanitation for this geometry
if (xwidth <= 0) {
  printf("\nERROR in Union_box named %s, the xwidth is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (yheight <= 0) {
  printf("\nERROR in Union_box named %s, yheight is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (zdepth <= 0) {
  printf("\nERROR in Union_box named %s, zdepth is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (xwidth2 <= 0 && xwidth2 != -1) {
  printf("\nERROR in Union_box named %s, the xwidth2 is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (yheight2 <= 0 && yheight2 != -1) {
  printf("\nERROR in Union_box named %s, yheight2 is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}

// Use sanitation
if (global_material_list.num_elements == 0) {
  printf("\nERROR: Need to define a material using Union_make_material before using a Union geometry component. \n");
  printf("       %s was defined before first use of Union_make_material.\n",NAME_CURRENT_COMP);
  exit(1);
}

this_box_volume.geometry.is_masked_volume = 0;
this_box_volume.geometry.is_exit_volume = 0;
this_box_volume.geometry.is_mask_volume = 0;
// check if the volume is a mask, if it is the material string is irelevant.
if (mask_string && strlen(mask_string) && strcmp(mask_string, "NULL") && strcmp(mask_string, "0")) {
    // A mask volume is used to limit the extend of other volumes, called the masked volumes. These are specified in the mask_string.
    // In order for a ray to enter a masked volume, it needs to be both in the region covered by that volume AND the mask volume.
    // When more than
    this_box_volume.geometry.mask_mode = 1; // Default is mask mode is ALL
    if (mask_setting && strlen(mask_setting) && strcmp(mask_setting, "NULL") && strcmp(mask_setting, "0")) {
        if (strcmp(mask_setting,"ALL") == 0 || strcmp(mask_setting,"All") == 0) this_box_volume.geometry.mask_mode = 1;
        else if (strcmp(mask_setting,"ANY") == 0 || strcmp(mask_setting,"Any") == 0) this_box_volume.geometry.mask_mode = 2;
        else {
            printf("The mask_mode of component %s is set to %s, but must be either ALL or ANY.\n",NAME_CURRENT_COMP,mask_setting);
            exit(1);
        }
    }
    
    for (loop_index=0;loop_index<global_geometry_list.num_elements;loop_index++) {
        // Add mask list
        if (1 == manual_linking_function(global_geometry_list.elements[loop_index].name,mask_string)) {
            add_element_to_int_list(&this_box_volume.geometry.mask_list,global_geometry_list.elements[loop_index].component_index);
            add_element_to_int_list(&global_geometry_list.elements[loop_index].Volume->geometry.masked_by_list,INDEX_CURRENT_COMP);
            global_geometry_list.elements[loop_index].Volume->geometry.is_masked_volume = 1;
            if (this_box_volume.geometry.mask_mode == 2)
                global_geometry_list.elements[loop_index].Volume->geometry.mask_mode = 2;
            if (this_box_volume.geometry.mask_mode == 1) {
                if (global_geometry_list.elements[loop_index].Volume->geometry.is_masked_volume == 1 && global_geometry_list.elements[loop_index].Volume->geometry.mask_mode != 2)
                    // If more than one mask is added to one volume, the ANY mode overwrites the (default) ALL mode.
                    global_geometry_list.elements[loop_index].Volume->geometry.mask_mode = 1;
            }
            
            found_geometries = 1;
        }
    }
    if (found_geometries == 0) {
        printf("The mask_string in geometry: %s did not find any of the specified volumes in the mask_string %s \n",NAME_CURRENT_COMP,mask_string);
        exit(1);
    }
    this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
    this_box_volume.p_physics->is_vacuum = 0; // Makes this volume a vacuum
    this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
    this_box_volume.p_physics->my_a = 0; // Should not be used.
    sprintf(this_box_volume.p_physics->name,"Mask");
    this_box_volume.geometry.is_mask_volume = 1;
    
    
// Read the material input, or if it lacks, use automatic linking.
} else if (material_string && strlen(material_string) && strcmp(material_string, "NULL") && strcmp(material_string, "0")) {
    // A geometry string was given, use it to determine which material
    if (0 == strcmp(material_string,"vacuum") || 0 == strcmp(material_string,"Vacuum")) {
        // One could have a global physics struct for vacuum instead of creating one for each
        this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
        this_box_volume.p_physics->is_vacuum = 1; // Makes this volume a vacuum
        this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
        this_box_volume.p_physics->my_a = 0; // Should not be used.
        sprintf(this_box_volume.p_physics->name,"Vacuum");
    } else if (0 == strcmp(material_string,"exit") || 0 == strcmp(material_string,"Exit")) {
        // One could have a global physics struct for vacuum instead of creating one for each
        this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
        this_box_volume.p_physics->is_vacuum = 1; // Makes this volume a vacuum
        this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
        this_box_volume.p_physics->my_a = 0; // Should not be used.
        this_box_volume.geometry.is_exit_volume = 1;
        sprintf(this_box_volume.p_physics->name,"Exit");
    } else {
        #ifndef MATERIAL_DETECTOR
            printf("Need to define a material before refering to it in a geometry %s.\n",NAME_CURRENT_COMP);
            exit(1);
        #endif
        for (loop_index=0;loop_index<global_material_list.num_elements;loop_index++) {
            if (0 == strcmp(material_string,global_material_list.elements[loop_index].name)) {
                this_box_volume.p_physics = global_material_list.elements[loop_index].physics;
                break;
            }
            if (loop_index == global_material_list.num_elements-1) {
            printf("\n");
            printf("ERROR: The material string \"%s\" in Union geometry \"%s\" did not match a specified material. \n",material_string,NAME_CURRENT_COMP);
            printf("       The materials available at this point (need to be defined before the geometry): \n");
            for (loop_index=0;loop_index<global_material_list.num_elements;loop_index++)
              printf("         %s\n",global_material_list.elements[loop_index].name);
            printf("\n");
            printf("       It is also possible to use one of the defualt materials avaiable: \n");
            printf("           Vacuum (for a Volume without scattering or absorption)\n");
            printf("           Exit (for a Volume where the ray exits the component if it enters)\n");
            printf("           Mask (for a Volume that masks existing volumes specified in the mask_string\n");
            exit(1);
          }
        }
    }
} else {
    // Automatic linking, simply using the last defined material.
    #ifndef MATERIAL_DETECTOR
        printf("Need to define a material before the geometry to use automatic linking %s.\n",NAME_CURRENT_COMP);
        exit(1);
    #endif
    this_box_volume.p_physics = global_material_list.elements[global_material_list.num_elements-1].physics;
}

sprintf(this_box_volume.name,NAME_CURRENT_COMP);
sprintf(this_box_volume.geometry.shape,"box");
this_box_volume.geometry.priority_value = priority;
this_box_volume.geometry.geometry_p_interact = p_interact;
// Currently the coordinates will be in absolute space.
this_box_volume.geometry.center = POS_A_CURRENT_COMP;

this_box_storage.z_depth = zdepth;
this_box_storage.x_width1 = xwidth;
this_box_storage.y_height1 = yheight;

this_box_storage.is_rectangle = 0;
if (xwidth2 < 0 && yheight2 < 0) this_box_storage.is_rectangle = 1;
if (xwidth == xwidth2 && yheight == yheight2) this_box_storage.is_rectangle = 1;

if (xwidth2 < 0) {
    this_box_storage.x_width2 = xwidth;
    xwidth2 = xwidth;
} else this_box_storage.x_width2 = xwidth2;

if (yheight2 < 0) {
    this_box_storage.y_height2 = yheight;
    yheight2 = yheight;
} else this_box_storage.y_height2 = yheight2;


this_box_storage.normal_vectors[0] = coords_set(0,0,1);
this_box_storage.normal_vectors[1] = coords_set(0,0,1);

// for sides with y component = 0
x_component = 2*zdepth/sqrt((xwidth-xwidth2)*(xwidth-xwidth2)+4*zdepth*zdepth);
z_component = (xwidth-xwidth2)/sqrt(4*zdepth*zdepth+(xwidth-xwidth2)*(xwidth-xwidth2));

this_box_storage.normal_vectors[2] = coords_set(x_component,0,z_component);
this_box_storage.normal_vectors[3] = coords_set(-x_component,0,z_component);

// for sides with x component = 0
y_component = 2*zdepth/sqrt((yheight-yheight2)*(yheight-yheight2)+4*zdepth*zdepth);
z_component = (yheight-yheight2)/sqrt(4*zdepth*zdepth+(yheight-yheight2)*(yheight-yheight2));

this_box_storage.normal_vectors[4] = coords_set(0,y_component,z_component);
this_box_storage.normal_vectors[5] = coords_set(0,-y_component,z_component);

this_box_volume.geometry.visualization_on = visualize;

this_box_volume.geometry.geometry_parameters.p_box_storage = &this_box_storage;

// Assign pointers to functions for intersection with the shape, checking if a point is inside the shape
if (this_box_storage.is_rectangle == 1) {
this_box_volume.geometry.intersect_function = &sample_box_intersect_simple;
this_box_volume.geometry.within_function = &r_within_box_simple;
}
else {
this_box_volume.geometry.intersect_function = &sample_box_intersect_advanced;
this_box_volume.geometry.within_function = &r_within_box_advanced;
}

this_box_volume.geometry.shell_points = &box_shell_points;
this_box_volume.geometry.mcdisplay_function = &mcdisplay_box_function;
this_box_volume.geometry.initialize_from_main_function = &initialize_box_geometry_from_main_component;
this_box_volume.geometry.process_rot_allocated = 0;

this_box_volume.geometry.copy_geometry_parameters = &allocate_box_storage_copy;

rot_copy(this_box_volume.geometry.rotation_matrix,ROT_A_CURRENT_COMP); //check how ROT_R_CURRENT_COMP would work
rot_transpose(ROT_A_CURRENT_COMP,this_box_volume.geometry.transpose_rotation_matrix);

// Initialize loggers
this_box_volume.loggers.num_elements = 0;

// packing the information into the global_geometry_element, which is then included in the global_geometry_list.
sprintf(global_geometry_element.name,NAME_CURRENT_COMP);
global_geometry_element.activation_counter = number_of_activations;
global_geometry_element.component_index = INDEX_CURRENT_COMP;
global_geometry_element.Volume = &this_box_volume; // Would be nicer if this m was a pointer, now we have the (small) data two places
add_element_to_geometry_list(&global_geometry_list,global_geometry_element);
}
#line 256859 "MACS_sample_kidney_box.c"
#undef number_of_activations
#undef mask_setting
#undef mask_string
#undef p_interact
#undef focus_r
#undef focus_xh
#undef focus_xw
#undef focus_ah
#undef focus_aw
#undef target_z
#undef target_y
#undef target_x
#undef target_index
#undef visualize
#undef yheight2
#undef xwidth2
#undef zdepth
#undef yheight
#undef xwidth
#undef priority
#undef material_string
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

  /* Initializations for component channel_10_analyzer_2_array_crystal_array_3. */
  SIG_MESSAGE("channel_10_analyzer_2_array_crystal_array_3 (Init)");
#define mccompcurname  channel_10_analyzer_2_array_crystal_array_3
#define mccompcurtype  Union_box
#define mccompcurindex 524
#define loop_index mccchannel_10_analyzer_2_array_crystal_array_3_loop_index
#define this_box_volume mccchannel_10_analyzer_2_array_crystal_array_3_this_box_volume
#define global_geometry_element mccchannel_10_analyzer_2_array_crystal_array_3_global_geometry_element
#define this_box_storage mccchannel_10_analyzer_2_array_crystal_array_3_this_box_storage
#define material_string mccchannel_10_analyzer_2_array_crystal_array_3_material_string
#define priority mccchannel_10_analyzer_2_array_crystal_array_3_priority
#define xwidth mccchannel_10_analyzer_2_array_crystal_array_3_xwidth
#define yheight mccchannel_10_analyzer_2_array_crystal_array_3_yheight
#define zdepth mccchannel_10_analyzer_2_array_crystal_array_3_zdepth
#define xwidth2 mccchannel_10_analyzer_2_array_crystal_array_3_xwidth2
#define yheight2 mccchannel_10_analyzer_2_array_crystal_array_3_yheight2
#define visualize mccchannel_10_analyzer_2_array_crystal_array_3_visualize
#define target_index mccchannel_10_analyzer_2_array_crystal_array_3_target_index
#define target_x mccchannel_10_analyzer_2_array_crystal_array_3_target_x
#define target_y mccchannel_10_analyzer_2_array_crystal_array_3_target_y
#define target_z mccchannel_10_analyzer_2_array_crystal_array_3_target_z
#define focus_aw mccchannel_10_analyzer_2_array_crystal_array_3_focus_aw
#define focus_ah mccchannel_10_analyzer_2_array_crystal_array_3_focus_ah
#define focus_xw mccchannel_10_analyzer_2_array_crystal_array_3_focus_xw
#define focus_xh mccchannel_10_analyzer_2_array_crystal_array_3_focus_xh
#define focus_r mccchannel_10_analyzer_2_array_crystal_array_3_focus_r
#define p_interact mccchannel_10_analyzer_2_array_crystal_array_3_p_interact
#define mask_string mccchannel_10_analyzer_2_array_crystal_array_3_mask_string
#define mask_setting mccchannel_10_analyzer_2_array_crystal_array_3_mask_setting
#define number_of_activations mccchannel_10_analyzer_2_array_crystal_array_3_number_of_activations
#line 224 "Union_box.comp"
{
// Initializes the focusing system for this volume including input sanitation.
focus_initialize(&this_box_volume.geometry, POS_A_COMP_INDEX(INDEX_CURRENT_COMP+target_index), POS_A_CURRENT_COMP, ROT_A_CURRENT_COMP, target_index, target_x, target_y, target_z, focus_aw, focus_ah, focus_xw, focus_xh, focus_r, NAME_CURRENT_COMP);

// Input sanitation for this geometry
if (xwidth <= 0) {
  printf("\nERROR in Union_box named %s, the xwidth is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (yheight <= 0) {
  printf("\nERROR in Union_box named %s, yheight is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (zdepth <= 0) {
  printf("\nERROR in Union_box named %s, zdepth is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (xwidth2 <= 0 && xwidth2 != -1) {
  printf("\nERROR in Union_box named %s, the xwidth2 is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (yheight2 <= 0 && yheight2 != -1) {
  printf("\nERROR in Union_box named %s, yheight2 is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}

// Use sanitation
if (global_material_list.num_elements == 0) {
  printf("\nERROR: Need to define a material using Union_make_material before using a Union geometry component. \n");
  printf("       %s was defined before first use of Union_make_material.\n",NAME_CURRENT_COMP);
  exit(1);
}

this_box_volume.geometry.is_masked_volume = 0;
this_box_volume.geometry.is_exit_volume = 0;
this_box_volume.geometry.is_mask_volume = 0;
// check if the volume is a mask, if it is the material string is irelevant.
if (mask_string && strlen(mask_string) && strcmp(mask_string, "NULL") && strcmp(mask_string, "0")) {
    // A mask volume is used to limit the extend of other volumes, called the masked volumes. These are specified in the mask_string.
    // In order for a ray to enter a masked volume, it needs to be both in the region covered by that volume AND the mask volume.
    // When more than
    this_box_volume.geometry.mask_mode = 1; // Default is mask mode is ALL
    if (mask_setting && strlen(mask_setting) && strcmp(mask_setting, "NULL") && strcmp(mask_setting, "0")) {
        if (strcmp(mask_setting,"ALL") == 0 || strcmp(mask_setting,"All") == 0) this_box_volume.geometry.mask_mode = 1;
        else if (strcmp(mask_setting,"ANY") == 0 || strcmp(mask_setting,"Any") == 0) this_box_volume.geometry.mask_mode = 2;
        else {
            printf("The mask_mode of component %s is set to %s, but must be either ALL or ANY.\n",NAME_CURRENT_COMP,mask_setting);
            exit(1);
        }
    }
    
    for (loop_index=0;loop_index<global_geometry_list.num_elements;loop_index++) {
        // Add mask list
        if (1 == manual_linking_function(global_geometry_list.elements[loop_index].name,mask_string)) {
            add_element_to_int_list(&this_box_volume.geometry.mask_list,global_geometry_list.elements[loop_index].component_index);
            add_element_to_int_list(&global_geometry_list.elements[loop_index].Volume->geometry.masked_by_list,INDEX_CURRENT_COMP);
            global_geometry_list.elements[loop_index].Volume->geometry.is_masked_volume = 1;
            if (this_box_volume.geometry.mask_mode == 2)
                global_geometry_list.elements[loop_index].Volume->geometry.mask_mode = 2;
            if (this_box_volume.geometry.mask_mode == 1) {
                if (global_geometry_list.elements[loop_index].Volume->geometry.is_masked_volume == 1 && global_geometry_list.elements[loop_index].Volume->geometry.mask_mode != 2)
                    // If more than one mask is added to one volume, the ANY mode overwrites the (default) ALL mode.
                    global_geometry_list.elements[loop_index].Volume->geometry.mask_mode = 1;
            }
            
            found_geometries = 1;
        }
    }
    if (found_geometries == 0) {
        printf("The mask_string in geometry: %s did not find any of the specified volumes in the mask_string %s \n",NAME_CURRENT_COMP,mask_string);
        exit(1);
    }
    this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
    this_box_volume.p_physics->is_vacuum = 0; // Makes this volume a vacuum
    this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
    this_box_volume.p_physics->my_a = 0; // Should not be used.
    sprintf(this_box_volume.p_physics->name,"Mask");
    this_box_volume.geometry.is_mask_volume = 1;
    
    
// Read the material input, or if it lacks, use automatic linking.
} else if (material_string && strlen(material_string) && strcmp(material_string, "NULL") && strcmp(material_string, "0")) {
    // A geometry string was given, use it to determine which material
    if (0 == strcmp(material_string,"vacuum") || 0 == strcmp(material_string,"Vacuum")) {
        // One could have a global physics struct for vacuum instead of creating one for each
        this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
        this_box_volume.p_physics->is_vacuum = 1; // Makes this volume a vacuum
        this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
        this_box_volume.p_physics->my_a = 0; // Should not be used.
        sprintf(this_box_volume.p_physics->name,"Vacuum");
    } else if (0 == strcmp(material_string,"exit") || 0 == strcmp(material_string,"Exit")) {
        // One could have a global physics struct for vacuum instead of creating one for each
        this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
        this_box_volume.p_physics->is_vacuum = 1; // Makes this volume a vacuum
        this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
        this_box_volume.p_physics->my_a = 0; // Should not be used.
        this_box_volume.geometry.is_exit_volume = 1;
        sprintf(this_box_volume.p_physics->name,"Exit");
    } else {
        #ifndef MATERIAL_DETECTOR
            printf("Need to define a material before refering to it in a geometry %s.\n",NAME_CURRENT_COMP);
            exit(1);
        #endif
        for (loop_index=0;loop_index<global_material_list.num_elements;loop_index++) {
            if (0 == strcmp(material_string,global_material_list.elements[loop_index].name)) {
                this_box_volume.p_physics = global_material_list.elements[loop_index].physics;
                break;
            }
            if (loop_index == global_material_list.num_elements-1) {
            printf("\n");
            printf("ERROR: The material string \"%s\" in Union geometry \"%s\" did not match a specified material. \n",material_string,NAME_CURRENT_COMP);
            printf("       The materials available at this point (need to be defined before the geometry): \n");
            for (loop_index=0;loop_index<global_material_list.num_elements;loop_index++)
              printf("         %s\n",global_material_list.elements[loop_index].name);
            printf("\n");
            printf("       It is also possible to use one of the defualt materials avaiable: \n");
            printf("           Vacuum (for a Volume without scattering or absorption)\n");
            printf("           Exit (for a Volume where the ray exits the component if it enters)\n");
            printf("           Mask (for a Volume that masks existing volumes specified in the mask_string\n");
            exit(1);
          }
        }
    }
} else {
    // Automatic linking, simply using the last defined material.
    #ifndef MATERIAL_DETECTOR
        printf("Need to define a material before the geometry to use automatic linking %s.\n",NAME_CURRENT_COMP);
        exit(1);
    #endif
    this_box_volume.p_physics = global_material_list.elements[global_material_list.num_elements-1].physics;
}

sprintf(this_box_volume.name,NAME_CURRENT_COMP);
sprintf(this_box_volume.geometry.shape,"box");
this_box_volume.geometry.priority_value = priority;
this_box_volume.geometry.geometry_p_interact = p_interact;
// Currently the coordinates will be in absolute space.
this_box_volume.geometry.center = POS_A_CURRENT_COMP;

this_box_storage.z_depth = zdepth;
this_box_storage.x_width1 = xwidth;
this_box_storage.y_height1 = yheight;

this_box_storage.is_rectangle = 0;
if (xwidth2 < 0 && yheight2 < 0) this_box_storage.is_rectangle = 1;
if (xwidth == xwidth2 && yheight == yheight2) this_box_storage.is_rectangle = 1;

if (xwidth2 < 0) {
    this_box_storage.x_width2 = xwidth;
    xwidth2 = xwidth;
} else this_box_storage.x_width2 = xwidth2;

if (yheight2 < 0) {
    this_box_storage.y_height2 = yheight;
    yheight2 = yheight;
} else this_box_storage.y_height2 = yheight2;


this_box_storage.normal_vectors[0] = coords_set(0,0,1);
this_box_storage.normal_vectors[1] = coords_set(0,0,1);

// for sides with y component = 0
x_component = 2*zdepth/sqrt((xwidth-xwidth2)*(xwidth-xwidth2)+4*zdepth*zdepth);
z_component = (xwidth-xwidth2)/sqrt(4*zdepth*zdepth+(xwidth-xwidth2)*(xwidth-xwidth2));

this_box_storage.normal_vectors[2] = coords_set(x_component,0,z_component);
this_box_storage.normal_vectors[3] = coords_set(-x_component,0,z_component);

// for sides with x component = 0
y_component = 2*zdepth/sqrt((yheight-yheight2)*(yheight-yheight2)+4*zdepth*zdepth);
z_component = (yheight-yheight2)/sqrt(4*zdepth*zdepth+(yheight-yheight2)*(yheight-yheight2));

this_box_storage.normal_vectors[4] = coords_set(0,y_component,z_component);
this_box_storage.normal_vectors[5] = coords_set(0,-y_component,z_component);

this_box_volume.geometry.visualization_on = visualize;

this_box_volume.geometry.geometry_parameters.p_box_storage = &this_box_storage;

// Assign pointers to functions for intersection with the shape, checking if a point is inside the shape
if (this_box_storage.is_rectangle == 1) {
this_box_volume.geometry.intersect_function = &sample_box_intersect_simple;
this_box_volume.geometry.within_function = &r_within_box_simple;
}
else {
this_box_volume.geometry.intersect_function = &sample_box_intersect_advanced;
this_box_volume.geometry.within_function = &r_within_box_advanced;
}

this_box_volume.geometry.shell_points = &box_shell_points;
this_box_volume.geometry.mcdisplay_function = &mcdisplay_box_function;
this_box_volume.geometry.initialize_from_main_function = &initialize_box_geometry_from_main_component;
this_box_volume.geometry.process_rot_allocated = 0;

this_box_volume.geometry.copy_geometry_parameters = &allocate_box_storage_copy;

rot_copy(this_box_volume.geometry.rotation_matrix,ROT_A_CURRENT_COMP); //check how ROT_R_CURRENT_COMP would work
rot_transpose(ROT_A_CURRENT_COMP,this_box_volume.geometry.transpose_rotation_matrix);

// Initialize loggers
this_box_volume.loggers.num_elements = 0;

// packing the information into the global_geometry_element, which is then included in the global_geometry_list.
sprintf(global_geometry_element.name,NAME_CURRENT_COMP);
global_geometry_element.activation_counter = number_of_activations;
global_geometry_element.component_index = INDEX_CURRENT_COMP;
global_geometry_element.Volume = &this_box_volume; // Would be nicer if this m was a pointer, now we have the (small) data two places
add_element_to_geometry_list(&global_geometry_list,global_geometry_element);
}
#line 257129 "MACS_sample_kidney_box.c"
#undef number_of_activations
#undef mask_setting
#undef mask_string
#undef p_interact
#undef focus_r
#undef focus_xh
#undef focus_xw
#undef focus_ah
#undef focus_aw
#undef target_z
#undef target_y
#undef target_x
#undef target_index
#undef visualize
#undef yheight2
#undef xwidth2
#undef zdepth
#undef yheight
#undef xwidth
#undef priority
#undef material_string
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

  /* Initializations for component channel_10_analyzer_2_array_crystal_array_4. */
  SIG_MESSAGE("channel_10_analyzer_2_array_crystal_array_4 (Init)");
#define mccompcurname  channel_10_analyzer_2_array_crystal_array_4
#define mccompcurtype  Union_box
#define mccompcurindex 525
#define loop_index mccchannel_10_analyzer_2_array_crystal_array_4_loop_index
#define this_box_volume mccchannel_10_analyzer_2_array_crystal_array_4_this_box_volume
#define global_geometry_element mccchannel_10_analyzer_2_array_crystal_array_4_global_geometry_element
#define this_box_storage mccchannel_10_analyzer_2_array_crystal_array_4_this_box_storage
#define material_string mccchannel_10_analyzer_2_array_crystal_array_4_material_string
#define priority mccchannel_10_analyzer_2_array_crystal_array_4_priority
#define xwidth mccchannel_10_analyzer_2_array_crystal_array_4_xwidth
#define yheight mccchannel_10_analyzer_2_array_crystal_array_4_yheight
#define zdepth mccchannel_10_analyzer_2_array_crystal_array_4_zdepth
#define xwidth2 mccchannel_10_analyzer_2_array_crystal_array_4_xwidth2
#define yheight2 mccchannel_10_analyzer_2_array_crystal_array_4_yheight2
#define visualize mccchannel_10_analyzer_2_array_crystal_array_4_visualize
#define target_index mccchannel_10_analyzer_2_array_crystal_array_4_target_index
#define target_x mccchannel_10_analyzer_2_array_crystal_array_4_target_x
#define target_y mccchannel_10_analyzer_2_array_crystal_array_4_target_y
#define target_z mccchannel_10_analyzer_2_array_crystal_array_4_target_z
#define focus_aw mccchannel_10_analyzer_2_array_crystal_array_4_focus_aw
#define focus_ah mccchannel_10_analyzer_2_array_crystal_array_4_focus_ah
#define focus_xw mccchannel_10_analyzer_2_array_crystal_array_4_focus_xw
#define focus_xh mccchannel_10_analyzer_2_array_crystal_array_4_focus_xh
#define focus_r mccchannel_10_analyzer_2_array_crystal_array_4_focus_r
#define p_interact mccchannel_10_analyzer_2_array_crystal_array_4_p_interact
#define mask_string mccchannel_10_analyzer_2_array_crystal_array_4_mask_string
#define mask_setting mccchannel_10_analyzer_2_array_crystal_array_4_mask_setting
#define number_of_activations mccchannel_10_analyzer_2_array_crystal_array_4_number_of_activations
#line 224 "Union_box.comp"
{
// Initializes the focusing system for this volume including input sanitation.
focus_initialize(&this_box_volume.geometry, POS_A_COMP_INDEX(INDEX_CURRENT_COMP+target_index), POS_A_CURRENT_COMP, ROT_A_CURRENT_COMP, target_index, target_x, target_y, target_z, focus_aw, focus_ah, focus_xw, focus_xh, focus_r, NAME_CURRENT_COMP);

// Input sanitation for this geometry
if (xwidth <= 0) {
  printf("\nERROR in Union_box named %s, the xwidth is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (yheight <= 0) {
  printf("\nERROR in Union_box named %s, yheight is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (zdepth <= 0) {
  printf("\nERROR in Union_box named %s, zdepth is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (xwidth2 <= 0 && xwidth2 != -1) {
  printf("\nERROR in Union_box named %s, the xwidth2 is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (yheight2 <= 0 && yheight2 != -1) {
  printf("\nERROR in Union_box named %s, yheight2 is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}

// Use sanitation
if (global_material_list.num_elements == 0) {
  printf("\nERROR: Need to define a material using Union_make_material before using a Union geometry component. \n");
  printf("       %s was defined before first use of Union_make_material.\n",NAME_CURRENT_COMP);
  exit(1);
}

this_box_volume.geometry.is_masked_volume = 0;
this_box_volume.geometry.is_exit_volume = 0;
this_box_volume.geometry.is_mask_volume = 0;
// check if the volume is a mask, if it is the material string is irelevant.
if (mask_string && strlen(mask_string) && strcmp(mask_string, "NULL") && strcmp(mask_string, "0")) {
    // A mask volume is used to limit the extend of other volumes, called the masked volumes. These are specified in the mask_string.
    // In order for a ray to enter a masked volume, it needs to be both in the region covered by that volume AND the mask volume.
    // When more than
    this_box_volume.geometry.mask_mode = 1; // Default is mask mode is ALL
    if (mask_setting && strlen(mask_setting) && strcmp(mask_setting, "NULL") && strcmp(mask_setting, "0")) {
        if (strcmp(mask_setting,"ALL") == 0 || strcmp(mask_setting,"All") == 0) this_box_volume.geometry.mask_mode = 1;
        else if (strcmp(mask_setting,"ANY") == 0 || strcmp(mask_setting,"Any") == 0) this_box_volume.geometry.mask_mode = 2;
        else {
            printf("The mask_mode of component %s is set to %s, but must be either ALL or ANY.\n",NAME_CURRENT_COMP,mask_setting);
            exit(1);
        }
    }
    
    for (loop_index=0;loop_index<global_geometry_list.num_elements;loop_index++) {
        // Add mask list
        if (1 == manual_linking_function(global_geometry_list.elements[loop_index].name,mask_string)) {
            add_element_to_int_list(&this_box_volume.geometry.mask_list,global_geometry_list.elements[loop_index].component_index);
            add_element_to_int_list(&global_geometry_list.elements[loop_index].Volume->geometry.masked_by_list,INDEX_CURRENT_COMP);
            global_geometry_list.elements[loop_index].Volume->geometry.is_masked_volume = 1;
            if (this_box_volume.geometry.mask_mode == 2)
                global_geometry_list.elements[loop_index].Volume->geometry.mask_mode = 2;
            if (this_box_volume.geometry.mask_mode == 1) {
                if (global_geometry_list.elements[loop_index].Volume->geometry.is_masked_volume == 1 && global_geometry_list.elements[loop_index].Volume->geometry.mask_mode != 2)
                    // If more than one mask is added to one volume, the ANY mode overwrites the (default) ALL mode.
                    global_geometry_list.elements[loop_index].Volume->geometry.mask_mode = 1;
            }
            
            found_geometries = 1;
        }
    }
    if (found_geometries == 0) {
        printf("The mask_string in geometry: %s did not find any of the specified volumes in the mask_string %s \n",NAME_CURRENT_COMP,mask_string);
        exit(1);
    }
    this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
    this_box_volume.p_physics->is_vacuum = 0; // Makes this volume a vacuum
    this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
    this_box_volume.p_physics->my_a = 0; // Should not be used.
    sprintf(this_box_volume.p_physics->name,"Mask");
    this_box_volume.geometry.is_mask_volume = 1;
    
    
// Read the material input, or if it lacks, use automatic linking.
} else if (material_string && strlen(material_string) && strcmp(material_string, "NULL") && strcmp(material_string, "0")) {
    // A geometry string was given, use it to determine which material
    if (0 == strcmp(material_string,"vacuum") || 0 == strcmp(material_string,"Vacuum")) {
        // One could have a global physics struct for vacuum instead of creating one for each
        this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
        this_box_volume.p_physics->is_vacuum = 1; // Makes this volume a vacuum
        this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
        this_box_volume.p_physics->my_a = 0; // Should not be used.
        sprintf(this_box_volume.p_physics->name,"Vacuum");
    } else if (0 == strcmp(material_string,"exit") || 0 == strcmp(material_string,"Exit")) {
        // One could have a global physics struct for vacuum instead of creating one for each
        this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
        this_box_volume.p_physics->is_vacuum = 1; // Makes this volume a vacuum
        this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
        this_box_volume.p_physics->my_a = 0; // Should not be used.
        this_box_volume.geometry.is_exit_volume = 1;
        sprintf(this_box_volume.p_physics->name,"Exit");
    } else {
        #ifndef MATERIAL_DETECTOR
            printf("Need to define a material before refering to it in a geometry %s.\n",NAME_CURRENT_COMP);
            exit(1);
        #endif
        for (loop_index=0;loop_index<global_material_list.num_elements;loop_index++) {
            if (0 == strcmp(material_string,global_material_list.elements[loop_index].name)) {
                this_box_volume.p_physics = global_material_list.elements[loop_index].physics;
                break;
            }
            if (loop_index == global_material_list.num_elements-1) {
            printf("\n");
            printf("ERROR: The material string \"%s\" in Union geometry \"%s\" did not match a specified material. \n",material_string,NAME_CURRENT_COMP);
            printf("       The materials available at this point (need to be defined before the geometry): \n");
            for (loop_index=0;loop_index<global_material_list.num_elements;loop_index++)
              printf("         %s\n",global_material_list.elements[loop_index].name);
            printf("\n");
            printf("       It is also possible to use one of the defualt materials avaiable: \n");
            printf("           Vacuum (for a Volume without scattering or absorption)\n");
            printf("           Exit (for a Volume where the ray exits the component if it enters)\n");
            printf("           Mask (for a Volume that masks existing volumes specified in the mask_string\n");
            exit(1);
          }
        }
    }
} else {
    // Automatic linking, simply using the last defined material.
    #ifndef MATERIAL_DETECTOR
        printf("Need to define a material before the geometry to use automatic linking %s.\n",NAME_CURRENT_COMP);
        exit(1);
    #endif
    this_box_volume.p_physics = global_material_list.elements[global_material_list.num_elements-1].physics;
}

sprintf(this_box_volume.name,NAME_CURRENT_COMP);
sprintf(this_box_volume.geometry.shape,"box");
this_box_volume.geometry.priority_value = priority;
this_box_volume.geometry.geometry_p_interact = p_interact;
// Currently the coordinates will be in absolute space.
this_box_volume.geometry.center = POS_A_CURRENT_COMP;

this_box_storage.z_depth = zdepth;
this_box_storage.x_width1 = xwidth;
this_box_storage.y_height1 = yheight;

this_box_storage.is_rectangle = 0;
if (xwidth2 < 0 && yheight2 < 0) this_box_storage.is_rectangle = 1;
if (xwidth == xwidth2 && yheight == yheight2) this_box_storage.is_rectangle = 1;

if (xwidth2 < 0) {
    this_box_storage.x_width2 = xwidth;
    xwidth2 = xwidth;
} else this_box_storage.x_width2 = xwidth2;

if (yheight2 < 0) {
    this_box_storage.y_height2 = yheight;
    yheight2 = yheight;
} else this_box_storage.y_height2 = yheight2;


this_box_storage.normal_vectors[0] = coords_set(0,0,1);
this_box_storage.normal_vectors[1] = coords_set(0,0,1);

// for sides with y component = 0
x_component = 2*zdepth/sqrt((xwidth-xwidth2)*(xwidth-xwidth2)+4*zdepth*zdepth);
z_component = (xwidth-xwidth2)/sqrt(4*zdepth*zdepth+(xwidth-xwidth2)*(xwidth-xwidth2));

this_box_storage.normal_vectors[2] = coords_set(x_component,0,z_component);
this_box_storage.normal_vectors[3] = coords_set(-x_component,0,z_component);

// for sides with x component = 0
y_component = 2*zdepth/sqrt((yheight-yheight2)*(yheight-yheight2)+4*zdepth*zdepth);
z_component = (yheight-yheight2)/sqrt(4*zdepth*zdepth+(yheight-yheight2)*(yheight-yheight2));

this_box_storage.normal_vectors[4] = coords_set(0,y_component,z_component);
this_box_storage.normal_vectors[5] = coords_set(0,-y_component,z_component);

this_box_volume.geometry.visualization_on = visualize;

this_box_volume.geometry.geometry_parameters.p_box_storage = &this_box_storage;

// Assign pointers to functions for intersection with the shape, checking if a point is inside the shape
if (this_box_storage.is_rectangle == 1) {
this_box_volume.geometry.intersect_function = &sample_box_intersect_simple;
this_box_volume.geometry.within_function = &r_within_box_simple;
}
else {
this_box_volume.geometry.intersect_function = &sample_box_intersect_advanced;
this_box_volume.geometry.within_function = &r_within_box_advanced;
}

this_box_volume.geometry.shell_points = &box_shell_points;
this_box_volume.geometry.mcdisplay_function = &mcdisplay_box_function;
this_box_volume.geometry.initialize_from_main_function = &initialize_box_geometry_from_main_component;
this_box_volume.geometry.process_rot_allocated = 0;

this_box_volume.geometry.copy_geometry_parameters = &allocate_box_storage_copy;

rot_copy(this_box_volume.geometry.rotation_matrix,ROT_A_CURRENT_COMP); //check how ROT_R_CURRENT_COMP would work
rot_transpose(ROT_A_CURRENT_COMP,this_box_volume.geometry.transpose_rotation_matrix);

// Initialize loggers
this_box_volume.loggers.num_elements = 0;

// packing the information into the global_geometry_element, which is then included in the global_geometry_list.
sprintf(global_geometry_element.name,NAME_CURRENT_COMP);
global_geometry_element.activation_counter = number_of_activations;
global_geometry_element.component_index = INDEX_CURRENT_COMP;
global_geometry_element.Volume = &this_box_volume; // Would be nicer if this m was a pointer, now we have the (small) data two places
add_element_to_geometry_list(&global_geometry_list,global_geometry_element);
}
#line 257399 "MACS_sample_kidney_box.c"
#undef number_of_activations
#undef mask_setting
#undef mask_string
#undef p_interact
#undef focus_r
#undef focus_xh
#undef focus_xw
#undef focus_ah
#undef focus_aw
#undef target_z
#undef target_y
#undef target_x
#undef target_index
#undef visualize
#undef yheight2
#undef xwidth2
#undef zdepth
#undef yheight
#undef xwidth
#undef priority
#undef material_string
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

  /* Initializations for component channel_10_analyzer_2_array_crystal_array_5. */
  SIG_MESSAGE("channel_10_analyzer_2_array_crystal_array_5 (Init)");
#define mccompcurname  channel_10_analyzer_2_array_crystal_array_5
#define mccompcurtype  Union_box
#define mccompcurindex 526
#define loop_index mccchannel_10_analyzer_2_array_crystal_array_5_loop_index
#define this_box_volume mccchannel_10_analyzer_2_array_crystal_array_5_this_box_volume
#define global_geometry_element mccchannel_10_analyzer_2_array_crystal_array_5_global_geometry_element
#define this_box_storage mccchannel_10_analyzer_2_array_crystal_array_5_this_box_storage
#define material_string mccchannel_10_analyzer_2_array_crystal_array_5_material_string
#define priority mccchannel_10_analyzer_2_array_crystal_array_5_priority
#define xwidth mccchannel_10_analyzer_2_array_crystal_array_5_xwidth
#define yheight mccchannel_10_analyzer_2_array_crystal_array_5_yheight
#define zdepth mccchannel_10_analyzer_2_array_crystal_array_5_zdepth
#define xwidth2 mccchannel_10_analyzer_2_array_crystal_array_5_xwidth2
#define yheight2 mccchannel_10_analyzer_2_array_crystal_array_5_yheight2
#define visualize mccchannel_10_analyzer_2_array_crystal_array_5_visualize
#define target_index mccchannel_10_analyzer_2_array_crystal_array_5_target_index
#define target_x mccchannel_10_analyzer_2_array_crystal_array_5_target_x
#define target_y mccchannel_10_analyzer_2_array_crystal_array_5_target_y
#define target_z mccchannel_10_analyzer_2_array_crystal_array_5_target_z
#define focus_aw mccchannel_10_analyzer_2_array_crystal_array_5_focus_aw
#define focus_ah mccchannel_10_analyzer_2_array_crystal_array_5_focus_ah
#define focus_xw mccchannel_10_analyzer_2_array_crystal_array_5_focus_xw
#define focus_xh mccchannel_10_analyzer_2_array_crystal_array_5_focus_xh
#define focus_r mccchannel_10_analyzer_2_array_crystal_array_5_focus_r
#define p_interact mccchannel_10_analyzer_2_array_crystal_array_5_p_interact
#define mask_string mccchannel_10_analyzer_2_array_crystal_array_5_mask_string
#define mask_setting mccchannel_10_analyzer_2_array_crystal_array_5_mask_setting
#define number_of_activations mccchannel_10_analyzer_2_array_crystal_array_5_number_of_activations
#line 224 "Union_box.comp"
{
// Initializes the focusing system for this volume including input sanitation.
focus_initialize(&this_box_volume.geometry, POS_A_COMP_INDEX(INDEX_CURRENT_COMP+target_index), POS_A_CURRENT_COMP, ROT_A_CURRENT_COMP, target_index, target_x, target_y, target_z, focus_aw, focus_ah, focus_xw, focus_xh, focus_r, NAME_CURRENT_COMP);

// Input sanitation for this geometry
if (xwidth <= 0) {
  printf("\nERROR in Union_box named %s, the xwidth is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (yheight <= 0) {
  printf("\nERROR in Union_box named %s, yheight is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (zdepth <= 0) {
  printf("\nERROR in Union_box named %s, zdepth is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (xwidth2 <= 0 && xwidth2 != -1) {
  printf("\nERROR in Union_box named %s, the xwidth2 is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (yheight2 <= 0 && yheight2 != -1) {
  printf("\nERROR in Union_box named %s, yheight2 is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}

// Use sanitation
if (global_material_list.num_elements == 0) {
  printf("\nERROR: Need to define a material using Union_make_material before using a Union geometry component. \n");
  printf("       %s was defined before first use of Union_make_material.\n",NAME_CURRENT_COMP);
  exit(1);
}

this_box_volume.geometry.is_masked_volume = 0;
this_box_volume.geometry.is_exit_volume = 0;
this_box_volume.geometry.is_mask_volume = 0;
// check if the volume is a mask, if it is the material string is irelevant.
if (mask_string && strlen(mask_string) && strcmp(mask_string, "NULL") && strcmp(mask_string, "0")) {
    // A mask volume is used to limit the extend of other volumes, called the masked volumes. These are specified in the mask_string.
    // In order for a ray to enter a masked volume, it needs to be both in the region covered by that volume AND the mask volume.
    // When more than
    this_box_volume.geometry.mask_mode = 1; // Default is mask mode is ALL
    if (mask_setting && strlen(mask_setting) && strcmp(mask_setting, "NULL") && strcmp(mask_setting, "0")) {
        if (strcmp(mask_setting,"ALL") == 0 || strcmp(mask_setting,"All") == 0) this_box_volume.geometry.mask_mode = 1;
        else if (strcmp(mask_setting,"ANY") == 0 || strcmp(mask_setting,"Any") == 0) this_box_volume.geometry.mask_mode = 2;
        else {
            printf("The mask_mode of component %s is set to %s, but must be either ALL or ANY.\n",NAME_CURRENT_COMP,mask_setting);
            exit(1);
        }
    }
    
    for (loop_index=0;loop_index<global_geometry_list.num_elements;loop_index++) {
        // Add mask list
        if (1 == manual_linking_function(global_geometry_list.elements[loop_index].name,mask_string)) {
            add_element_to_int_list(&this_box_volume.geometry.mask_list,global_geometry_list.elements[loop_index].component_index);
            add_element_to_int_list(&global_geometry_list.elements[loop_index].Volume->geometry.masked_by_list,INDEX_CURRENT_COMP);
            global_geometry_list.elements[loop_index].Volume->geometry.is_masked_volume = 1;
            if (this_box_volume.geometry.mask_mode == 2)
                global_geometry_list.elements[loop_index].Volume->geometry.mask_mode = 2;
            if (this_box_volume.geometry.mask_mode == 1) {
                if (global_geometry_list.elements[loop_index].Volume->geometry.is_masked_volume == 1 && global_geometry_list.elements[loop_index].Volume->geometry.mask_mode != 2)
                    // If more than one mask is added to one volume, the ANY mode overwrites the (default) ALL mode.
                    global_geometry_list.elements[loop_index].Volume->geometry.mask_mode = 1;
            }
            
            found_geometries = 1;
        }
    }
    if (found_geometries == 0) {
        printf("The mask_string in geometry: %s did not find any of the specified volumes in the mask_string %s \n",NAME_CURRENT_COMP,mask_string);
        exit(1);
    }
    this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
    this_box_volume.p_physics->is_vacuum = 0; // Makes this volume a vacuum
    this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
    this_box_volume.p_physics->my_a = 0; // Should not be used.
    sprintf(this_box_volume.p_physics->name,"Mask");
    this_box_volume.geometry.is_mask_volume = 1;
    
    
// Read the material input, or if it lacks, use automatic linking.
} else if (material_string && strlen(material_string) && strcmp(material_string, "NULL") && strcmp(material_string, "0")) {
    // A geometry string was given, use it to determine which material
    if (0 == strcmp(material_string,"vacuum") || 0 == strcmp(material_string,"Vacuum")) {
        // One could have a global physics struct for vacuum instead of creating one for each
        this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
        this_box_volume.p_physics->is_vacuum = 1; // Makes this volume a vacuum
        this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
        this_box_volume.p_physics->my_a = 0; // Should not be used.
        sprintf(this_box_volume.p_physics->name,"Vacuum");
    } else if (0 == strcmp(material_string,"exit") || 0 == strcmp(material_string,"Exit")) {
        // One could have a global physics struct for vacuum instead of creating one for each
        this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
        this_box_volume.p_physics->is_vacuum = 1; // Makes this volume a vacuum
        this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
        this_box_volume.p_physics->my_a = 0; // Should not be used.
        this_box_volume.geometry.is_exit_volume = 1;
        sprintf(this_box_volume.p_physics->name,"Exit");
    } else {
        #ifndef MATERIAL_DETECTOR
            printf("Need to define a material before refering to it in a geometry %s.\n",NAME_CURRENT_COMP);
            exit(1);
        #endif
        for (loop_index=0;loop_index<global_material_list.num_elements;loop_index++) {
            if (0 == strcmp(material_string,global_material_list.elements[loop_index].name)) {
                this_box_volume.p_physics = global_material_list.elements[loop_index].physics;
                break;
            }
            if (loop_index == global_material_list.num_elements-1) {
            printf("\n");
            printf("ERROR: The material string \"%s\" in Union geometry \"%s\" did not match a specified material. \n",material_string,NAME_CURRENT_COMP);
            printf("       The materials available at this point (need to be defined before the geometry): \n");
            for (loop_index=0;loop_index<global_material_list.num_elements;loop_index++)
              printf("         %s\n",global_material_list.elements[loop_index].name);
            printf("\n");
            printf("       It is also possible to use one of the defualt materials avaiable: \n");
            printf("           Vacuum (for a Volume without scattering or absorption)\n");
            printf("           Exit (for a Volume where the ray exits the component if it enters)\n");
            printf("           Mask (for a Volume that masks existing volumes specified in the mask_string\n");
            exit(1);
          }
        }
    }
} else {
    // Automatic linking, simply using the last defined material.
    #ifndef MATERIAL_DETECTOR
        printf("Need to define a material before the geometry to use automatic linking %s.\n",NAME_CURRENT_COMP);
        exit(1);
    #endif
    this_box_volume.p_physics = global_material_list.elements[global_material_list.num_elements-1].physics;
}

sprintf(this_box_volume.name,NAME_CURRENT_COMP);
sprintf(this_box_volume.geometry.shape,"box");
this_box_volume.geometry.priority_value = priority;
this_box_volume.geometry.geometry_p_interact = p_interact;
// Currently the coordinates will be in absolute space.
this_box_volume.geometry.center = POS_A_CURRENT_COMP;

this_box_storage.z_depth = zdepth;
this_box_storage.x_width1 = xwidth;
this_box_storage.y_height1 = yheight;

this_box_storage.is_rectangle = 0;
if (xwidth2 < 0 && yheight2 < 0) this_box_storage.is_rectangle = 1;
if (xwidth == xwidth2 && yheight == yheight2) this_box_storage.is_rectangle = 1;

if (xwidth2 < 0) {
    this_box_storage.x_width2 = xwidth;
    xwidth2 = xwidth;
} else this_box_storage.x_width2 = xwidth2;

if (yheight2 < 0) {
    this_box_storage.y_height2 = yheight;
    yheight2 = yheight;
} else this_box_storage.y_height2 = yheight2;


this_box_storage.normal_vectors[0] = coords_set(0,0,1);
this_box_storage.normal_vectors[1] = coords_set(0,0,1);

// for sides with y component = 0
x_component = 2*zdepth/sqrt((xwidth-xwidth2)*(xwidth-xwidth2)+4*zdepth*zdepth);
z_component = (xwidth-xwidth2)/sqrt(4*zdepth*zdepth+(xwidth-xwidth2)*(xwidth-xwidth2));

this_box_storage.normal_vectors[2] = coords_set(x_component,0,z_component);
this_box_storage.normal_vectors[3] = coords_set(-x_component,0,z_component);

// for sides with x component = 0
y_component = 2*zdepth/sqrt((yheight-yheight2)*(yheight-yheight2)+4*zdepth*zdepth);
z_component = (yheight-yheight2)/sqrt(4*zdepth*zdepth+(yheight-yheight2)*(yheight-yheight2));

this_box_storage.normal_vectors[4] = coords_set(0,y_component,z_component);
this_box_storage.normal_vectors[5] = coords_set(0,-y_component,z_component);

this_box_volume.geometry.visualization_on = visualize;

this_box_volume.geometry.geometry_parameters.p_box_storage = &this_box_storage;

// Assign pointers to functions for intersection with the shape, checking if a point is inside the shape
if (this_box_storage.is_rectangle == 1) {
this_box_volume.geometry.intersect_function = &sample_box_intersect_simple;
this_box_volume.geometry.within_function = &r_within_box_simple;
}
else {
this_box_volume.geometry.intersect_function = &sample_box_intersect_advanced;
this_box_volume.geometry.within_function = &r_within_box_advanced;
}

this_box_volume.geometry.shell_points = &box_shell_points;
this_box_volume.geometry.mcdisplay_function = &mcdisplay_box_function;
this_box_volume.geometry.initialize_from_main_function = &initialize_box_geometry_from_main_component;
this_box_volume.geometry.process_rot_allocated = 0;

this_box_volume.geometry.copy_geometry_parameters = &allocate_box_storage_copy;

rot_copy(this_box_volume.geometry.rotation_matrix,ROT_A_CURRENT_COMP); //check how ROT_R_CURRENT_COMP would work
rot_transpose(ROT_A_CURRENT_COMP,this_box_volume.geometry.transpose_rotation_matrix);

// Initialize loggers
this_box_volume.loggers.num_elements = 0;

// packing the information into the global_geometry_element, which is then included in the global_geometry_list.
sprintf(global_geometry_element.name,NAME_CURRENT_COMP);
global_geometry_element.activation_counter = number_of_activations;
global_geometry_element.component_index = INDEX_CURRENT_COMP;
global_geometry_element.Volume = &this_box_volume; // Would be nicer if this m was a pointer, now we have the (small) data two places
add_element_to_geometry_list(&global_geometry_list,global_geometry_element);
}
#line 257669 "MACS_sample_kidney_box.c"
#undef number_of_activations
#undef mask_setting
#undef mask_string
#undef p_interact
#undef focus_r
#undef focus_xh
#undef focus_xw
#undef focus_ah
#undef focus_aw
#undef target_z
#undef target_y
#undef target_x
#undef target_index
#undef visualize
#undef yheight2
#undef xwidth2
#undef zdepth
#undef yheight
#undef xwidth
#undef priority
#undef material_string
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

  /* Initializations for component channel_10_analyzer_2_array_crystal_array_6. */
  SIG_MESSAGE("channel_10_analyzer_2_array_crystal_array_6 (Init)");
#define mccompcurname  channel_10_analyzer_2_array_crystal_array_6
#define mccompcurtype  Union_box
#define mccompcurindex 527
#define loop_index mccchannel_10_analyzer_2_array_crystal_array_6_loop_index
#define this_box_volume mccchannel_10_analyzer_2_array_crystal_array_6_this_box_volume
#define global_geometry_element mccchannel_10_analyzer_2_array_crystal_array_6_global_geometry_element
#define this_box_storage mccchannel_10_analyzer_2_array_crystal_array_6_this_box_storage
#define material_string mccchannel_10_analyzer_2_array_crystal_array_6_material_string
#define priority mccchannel_10_analyzer_2_array_crystal_array_6_priority
#define xwidth mccchannel_10_analyzer_2_array_crystal_array_6_xwidth
#define yheight mccchannel_10_analyzer_2_array_crystal_array_6_yheight
#define zdepth mccchannel_10_analyzer_2_array_crystal_array_6_zdepth
#define xwidth2 mccchannel_10_analyzer_2_array_crystal_array_6_xwidth2
#define yheight2 mccchannel_10_analyzer_2_array_crystal_array_6_yheight2
#define visualize mccchannel_10_analyzer_2_array_crystal_array_6_visualize
#define target_index mccchannel_10_analyzer_2_array_crystal_array_6_target_index
#define target_x mccchannel_10_analyzer_2_array_crystal_array_6_target_x
#define target_y mccchannel_10_analyzer_2_array_crystal_array_6_target_y
#define target_z mccchannel_10_analyzer_2_array_crystal_array_6_target_z
#define focus_aw mccchannel_10_analyzer_2_array_crystal_array_6_focus_aw
#define focus_ah mccchannel_10_analyzer_2_array_crystal_array_6_focus_ah
#define focus_xw mccchannel_10_analyzer_2_array_crystal_array_6_focus_xw
#define focus_xh mccchannel_10_analyzer_2_array_crystal_array_6_focus_xh
#define focus_r mccchannel_10_analyzer_2_array_crystal_array_6_focus_r
#define p_interact mccchannel_10_analyzer_2_array_crystal_array_6_p_interact
#define mask_string mccchannel_10_analyzer_2_array_crystal_array_6_mask_string
#define mask_setting mccchannel_10_analyzer_2_array_crystal_array_6_mask_setting
#define number_of_activations mccchannel_10_analyzer_2_array_crystal_array_6_number_of_activations
#line 224 "Union_box.comp"
{
// Initializes the focusing system for this volume including input sanitation.
focus_initialize(&this_box_volume.geometry, POS_A_COMP_INDEX(INDEX_CURRENT_COMP+target_index), POS_A_CURRENT_COMP, ROT_A_CURRENT_COMP, target_index, target_x, target_y, target_z, focus_aw, focus_ah, focus_xw, focus_xh, focus_r, NAME_CURRENT_COMP);

// Input sanitation for this geometry
if (xwidth <= 0) {
  printf("\nERROR in Union_box named %s, the xwidth is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (yheight <= 0) {
  printf("\nERROR in Union_box named %s, yheight is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (zdepth <= 0) {
  printf("\nERROR in Union_box named %s, zdepth is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (xwidth2 <= 0 && xwidth2 != -1) {
  printf("\nERROR in Union_box named %s, the xwidth2 is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (yheight2 <= 0 && yheight2 != -1) {
  printf("\nERROR in Union_box named %s, yheight2 is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}

// Use sanitation
if (global_material_list.num_elements == 0) {
  printf("\nERROR: Need to define a material using Union_make_material before using a Union geometry component. \n");
  printf("       %s was defined before first use of Union_make_material.\n",NAME_CURRENT_COMP);
  exit(1);
}

this_box_volume.geometry.is_masked_volume = 0;
this_box_volume.geometry.is_exit_volume = 0;
this_box_volume.geometry.is_mask_volume = 0;
// check if the volume is a mask, if it is the material string is irelevant.
if (mask_string && strlen(mask_string) && strcmp(mask_string, "NULL") && strcmp(mask_string, "0")) {
    // A mask volume is used to limit the extend of other volumes, called the masked volumes. These are specified in the mask_string.
    // In order for a ray to enter a masked volume, it needs to be both in the region covered by that volume AND the mask volume.
    // When more than
    this_box_volume.geometry.mask_mode = 1; // Default is mask mode is ALL
    if (mask_setting && strlen(mask_setting) && strcmp(mask_setting, "NULL") && strcmp(mask_setting, "0")) {
        if (strcmp(mask_setting,"ALL") == 0 || strcmp(mask_setting,"All") == 0) this_box_volume.geometry.mask_mode = 1;
        else if (strcmp(mask_setting,"ANY") == 0 || strcmp(mask_setting,"Any") == 0) this_box_volume.geometry.mask_mode = 2;
        else {
            printf("The mask_mode of component %s is set to %s, but must be either ALL or ANY.\n",NAME_CURRENT_COMP,mask_setting);
            exit(1);
        }
    }
    
    for (loop_index=0;loop_index<global_geometry_list.num_elements;loop_index++) {
        // Add mask list
        if (1 == manual_linking_function(global_geometry_list.elements[loop_index].name,mask_string)) {
            add_element_to_int_list(&this_box_volume.geometry.mask_list,global_geometry_list.elements[loop_index].component_index);
            add_element_to_int_list(&global_geometry_list.elements[loop_index].Volume->geometry.masked_by_list,INDEX_CURRENT_COMP);
            global_geometry_list.elements[loop_index].Volume->geometry.is_masked_volume = 1;
            if (this_box_volume.geometry.mask_mode == 2)
                global_geometry_list.elements[loop_index].Volume->geometry.mask_mode = 2;
            if (this_box_volume.geometry.mask_mode == 1) {
                if (global_geometry_list.elements[loop_index].Volume->geometry.is_masked_volume == 1 && global_geometry_list.elements[loop_index].Volume->geometry.mask_mode != 2)
                    // If more than one mask is added to one volume, the ANY mode overwrites the (default) ALL mode.
                    global_geometry_list.elements[loop_index].Volume->geometry.mask_mode = 1;
            }
            
            found_geometries = 1;
        }
    }
    if (found_geometries == 0) {
        printf("The mask_string in geometry: %s did not find any of the specified volumes in the mask_string %s \n",NAME_CURRENT_COMP,mask_string);
        exit(1);
    }
    this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
    this_box_volume.p_physics->is_vacuum = 0; // Makes this volume a vacuum
    this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
    this_box_volume.p_physics->my_a = 0; // Should not be used.
    sprintf(this_box_volume.p_physics->name,"Mask");
    this_box_volume.geometry.is_mask_volume = 1;
    
    
// Read the material input, or if it lacks, use automatic linking.
} else if (material_string && strlen(material_string) && strcmp(material_string, "NULL") && strcmp(material_string, "0")) {
    // A geometry string was given, use it to determine which material
    if (0 == strcmp(material_string,"vacuum") || 0 == strcmp(material_string,"Vacuum")) {
        // One could have a global physics struct for vacuum instead of creating one for each
        this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
        this_box_volume.p_physics->is_vacuum = 1; // Makes this volume a vacuum
        this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
        this_box_volume.p_physics->my_a = 0; // Should not be used.
        sprintf(this_box_volume.p_physics->name,"Vacuum");
    } else if (0 == strcmp(material_string,"exit") || 0 == strcmp(material_string,"Exit")) {
        // One could have a global physics struct for vacuum instead of creating one for each
        this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
        this_box_volume.p_physics->is_vacuum = 1; // Makes this volume a vacuum
        this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
        this_box_volume.p_physics->my_a = 0; // Should not be used.
        this_box_volume.geometry.is_exit_volume = 1;
        sprintf(this_box_volume.p_physics->name,"Exit");
    } else {
        #ifndef MATERIAL_DETECTOR
            printf("Need to define a material before refering to it in a geometry %s.\n",NAME_CURRENT_COMP);
            exit(1);
        #endif
        for (loop_index=0;loop_index<global_material_list.num_elements;loop_index++) {
            if (0 == strcmp(material_string,global_material_list.elements[loop_index].name)) {
                this_box_volume.p_physics = global_material_list.elements[loop_index].physics;
                break;
            }
            if (loop_index == global_material_list.num_elements-1) {
            printf("\n");
            printf("ERROR: The material string \"%s\" in Union geometry \"%s\" did not match a specified material. \n",material_string,NAME_CURRENT_COMP);
            printf("       The materials available at this point (need to be defined before the geometry): \n");
            for (loop_index=0;loop_index<global_material_list.num_elements;loop_index++)
              printf("         %s\n",global_material_list.elements[loop_index].name);
            printf("\n");
            printf("       It is also possible to use one of the defualt materials avaiable: \n");
            printf("           Vacuum (for a Volume without scattering or absorption)\n");
            printf("           Exit (for a Volume where the ray exits the component if it enters)\n");
            printf("           Mask (for a Volume that masks existing volumes specified in the mask_string\n");
            exit(1);
          }
        }
    }
} else {
    // Automatic linking, simply using the last defined material.
    #ifndef MATERIAL_DETECTOR
        printf("Need to define a material before the geometry to use automatic linking %s.\n",NAME_CURRENT_COMP);
        exit(1);
    #endif
    this_box_volume.p_physics = global_material_list.elements[global_material_list.num_elements-1].physics;
}

sprintf(this_box_volume.name,NAME_CURRENT_COMP);
sprintf(this_box_volume.geometry.shape,"box");
this_box_volume.geometry.priority_value = priority;
this_box_volume.geometry.geometry_p_interact = p_interact;
// Currently the coordinates will be in absolute space.
this_box_volume.geometry.center = POS_A_CURRENT_COMP;

this_box_storage.z_depth = zdepth;
this_box_storage.x_width1 = xwidth;
this_box_storage.y_height1 = yheight;

this_box_storage.is_rectangle = 0;
if (xwidth2 < 0 && yheight2 < 0) this_box_storage.is_rectangle = 1;
if (xwidth == xwidth2 && yheight == yheight2) this_box_storage.is_rectangle = 1;

if (xwidth2 < 0) {
    this_box_storage.x_width2 = xwidth;
    xwidth2 = xwidth;
} else this_box_storage.x_width2 = xwidth2;

if (yheight2 < 0) {
    this_box_storage.y_height2 = yheight;
    yheight2 = yheight;
} else this_box_storage.y_height2 = yheight2;


this_box_storage.normal_vectors[0] = coords_set(0,0,1);
this_box_storage.normal_vectors[1] = coords_set(0,0,1);

// for sides with y component = 0
x_component = 2*zdepth/sqrt((xwidth-xwidth2)*(xwidth-xwidth2)+4*zdepth*zdepth);
z_component = (xwidth-xwidth2)/sqrt(4*zdepth*zdepth+(xwidth-xwidth2)*(xwidth-xwidth2));

this_box_storage.normal_vectors[2] = coords_set(x_component,0,z_component);
this_box_storage.normal_vectors[3] = coords_set(-x_component,0,z_component);

// for sides with x component = 0
y_component = 2*zdepth/sqrt((yheight-yheight2)*(yheight-yheight2)+4*zdepth*zdepth);
z_component = (yheight-yheight2)/sqrt(4*zdepth*zdepth+(yheight-yheight2)*(yheight-yheight2));

this_box_storage.normal_vectors[4] = coords_set(0,y_component,z_component);
this_box_storage.normal_vectors[5] = coords_set(0,-y_component,z_component);

this_box_volume.geometry.visualization_on = visualize;

this_box_volume.geometry.geometry_parameters.p_box_storage = &this_box_storage;

// Assign pointers to functions for intersection with the shape, checking if a point is inside the shape
if (this_box_storage.is_rectangle == 1) {
this_box_volume.geometry.intersect_function = &sample_box_intersect_simple;
this_box_volume.geometry.within_function = &r_within_box_simple;
}
else {
this_box_volume.geometry.intersect_function = &sample_box_intersect_advanced;
this_box_volume.geometry.within_function = &r_within_box_advanced;
}

this_box_volume.geometry.shell_points = &box_shell_points;
this_box_volume.geometry.mcdisplay_function = &mcdisplay_box_function;
this_box_volume.geometry.initialize_from_main_function = &initialize_box_geometry_from_main_component;
this_box_volume.geometry.process_rot_allocated = 0;

this_box_volume.geometry.copy_geometry_parameters = &allocate_box_storage_copy;

rot_copy(this_box_volume.geometry.rotation_matrix,ROT_A_CURRENT_COMP); //check how ROT_R_CURRENT_COMP would work
rot_transpose(ROT_A_CURRENT_COMP,this_box_volume.geometry.transpose_rotation_matrix);

// Initialize loggers
this_box_volume.loggers.num_elements = 0;

// packing the information into the global_geometry_element, which is then included in the global_geometry_list.
sprintf(global_geometry_element.name,NAME_CURRENT_COMP);
global_geometry_element.activation_counter = number_of_activations;
global_geometry_element.component_index = INDEX_CURRENT_COMP;
global_geometry_element.Volume = &this_box_volume; // Would be nicer if this m was a pointer, now we have the (small) data two places
add_element_to_geometry_list(&global_geometry_list,global_geometry_element);
}
#line 257939 "MACS_sample_kidney_box.c"
#undef number_of_activations
#undef mask_setting
#undef mask_string
#undef p_interact
#undef focus_r
#undef focus_xh
#undef focus_xw
#undef focus_ah
#undef focus_aw
#undef target_z
#undef target_y
#undef target_x
#undef target_index
#undef visualize
#undef yheight2
#undef xwidth2
#undef zdepth
#undef yheight
#undef xwidth
#undef priority
#undef material_string
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

  /* Initializations for component channel_10_analyzer_2_array_crystal_array_7. */
  SIG_MESSAGE("channel_10_analyzer_2_array_crystal_array_7 (Init)");
#define mccompcurname  channel_10_analyzer_2_array_crystal_array_7
#define mccompcurtype  Union_box
#define mccompcurindex 528
#define loop_index mccchannel_10_analyzer_2_array_crystal_array_7_loop_index
#define this_box_volume mccchannel_10_analyzer_2_array_crystal_array_7_this_box_volume
#define global_geometry_element mccchannel_10_analyzer_2_array_crystal_array_7_global_geometry_element
#define this_box_storage mccchannel_10_analyzer_2_array_crystal_array_7_this_box_storage
#define material_string mccchannel_10_analyzer_2_array_crystal_array_7_material_string
#define priority mccchannel_10_analyzer_2_array_crystal_array_7_priority
#define xwidth mccchannel_10_analyzer_2_array_crystal_array_7_xwidth
#define yheight mccchannel_10_analyzer_2_array_crystal_array_7_yheight
#define zdepth mccchannel_10_analyzer_2_array_crystal_array_7_zdepth
#define xwidth2 mccchannel_10_analyzer_2_array_crystal_array_7_xwidth2
#define yheight2 mccchannel_10_analyzer_2_array_crystal_array_7_yheight2
#define visualize mccchannel_10_analyzer_2_array_crystal_array_7_visualize
#define target_index mccchannel_10_analyzer_2_array_crystal_array_7_target_index
#define target_x mccchannel_10_analyzer_2_array_crystal_array_7_target_x
#define target_y mccchannel_10_analyzer_2_array_crystal_array_7_target_y
#define target_z mccchannel_10_analyzer_2_array_crystal_array_7_target_z
#define focus_aw mccchannel_10_analyzer_2_array_crystal_array_7_focus_aw
#define focus_ah mccchannel_10_analyzer_2_array_crystal_array_7_focus_ah
#define focus_xw mccchannel_10_analyzer_2_array_crystal_array_7_focus_xw
#define focus_xh mccchannel_10_analyzer_2_array_crystal_array_7_focus_xh
#define focus_r mccchannel_10_analyzer_2_array_crystal_array_7_focus_r
#define p_interact mccchannel_10_analyzer_2_array_crystal_array_7_p_interact
#define mask_string mccchannel_10_analyzer_2_array_crystal_array_7_mask_string
#define mask_setting mccchannel_10_analyzer_2_array_crystal_array_7_mask_setting
#define number_of_activations mccchannel_10_analyzer_2_array_crystal_array_7_number_of_activations
#line 224 "Union_box.comp"
{
// Initializes the focusing system for this volume including input sanitation.
focus_initialize(&this_box_volume.geometry, POS_A_COMP_INDEX(INDEX_CURRENT_COMP+target_index), POS_A_CURRENT_COMP, ROT_A_CURRENT_COMP, target_index, target_x, target_y, target_z, focus_aw, focus_ah, focus_xw, focus_xh, focus_r, NAME_CURRENT_COMP);

// Input sanitation for this geometry
if (xwidth <= 0) {
  printf("\nERROR in Union_box named %s, the xwidth is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (yheight <= 0) {
  printf("\nERROR in Union_box named %s, yheight is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (zdepth <= 0) {
  printf("\nERROR in Union_box named %s, zdepth is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (xwidth2 <= 0 && xwidth2 != -1) {
  printf("\nERROR in Union_box named %s, the xwidth2 is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (yheight2 <= 0 && yheight2 != -1) {
  printf("\nERROR in Union_box named %s, yheight2 is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}

// Use sanitation
if (global_material_list.num_elements == 0) {
  printf("\nERROR: Need to define a material using Union_make_material before using a Union geometry component. \n");
  printf("       %s was defined before first use of Union_make_material.\n",NAME_CURRENT_COMP);
  exit(1);
}

this_box_volume.geometry.is_masked_volume = 0;
this_box_volume.geometry.is_exit_volume = 0;
this_box_volume.geometry.is_mask_volume = 0;
// check if the volume is a mask, if it is the material string is irelevant.
if (mask_string && strlen(mask_string) && strcmp(mask_string, "NULL") && strcmp(mask_string, "0")) {
    // A mask volume is used to limit the extend of other volumes, called the masked volumes. These are specified in the mask_string.
    // In order for a ray to enter a masked volume, it needs to be both in the region covered by that volume AND the mask volume.
    // When more than
    this_box_volume.geometry.mask_mode = 1; // Default is mask mode is ALL
    if (mask_setting && strlen(mask_setting) && strcmp(mask_setting, "NULL") && strcmp(mask_setting, "0")) {
        if (strcmp(mask_setting,"ALL") == 0 || strcmp(mask_setting,"All") == 0) this_box_volume.geometry.mask_mode = 1;
        else if (strcmp(mask_setting,"ANY") == 0 || strcmp(mask_setting,"Any") == 0) this_box_volume.geometry.mask_mode = 2;
        else {
            printf("The mask_mode of component %s is set to %s, but must be either ALL or ANY.\n",NAME_CURRENT_COMP,mask_setting);
            exit(1);
        }
    }
    
    for (loop_index=0;loop_index<global_geometry_list.num_elements;loop_index++) {
        // Add mask list
        if (1 == manual_linking_function(global_geometry_list.elements[loop_index].name,mask_string)) {
            add_element_to_int_list(&this_box_volume.geometry.mask_list,global_geometry_list.elements[loop_index].component_index);
            add_element_to_int_list(&global_geometry_list.elements[loop_index].Volume->geometry.masked_by_list,INDEX_CURRENT_COMP);
            global_geometry_list.elements[loop_index].Volume->geometry.is_masked_volume = 1;
            if (this_box_volume.geometry.mask_mode == 2)
                global_geometry_list.elements[loop_index].Volume->geometry.mask_mode = 2;
            if (this_box_volume.geometry.mask_mode == 1) {
                if (global_geometry_list.elements[loop_index].Volume->geometry.is_masked_volume == 1 && global_geometry_list.elements[loop_index].Volume->geometry.mask_mode != 2)
                    // If more than one mask is added to one volume, the ANY mode overwrites the (default) ALL mode.
                    global_geometry_list.elements[loop_index].Volume->geometry.mask_mode = 1;
            }
            
            found_geometries = 1;
        }
    }
    if (found_geometries == 0) {
        printf("The mask_string in geometry: %s did not find any of the specified volumes in the mask_string %s \n",NAME_CURRENT_COMP,mask_string);
        exit(1);
    }
    this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
    this_box_volume.p_physics->is_vacuum = 0; // Makes this volume a vacuum
    this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
    this_box_volume.p_physics->my_a = 0; // Should not be used.
    sprintf(this_box_volume.p_physics->name,"Mask");
    this_box_volume.geometry.is_mask_volume = 1;
    
    
// Read the material input, or if it lacks, use automatic linking.
} else if (material_string && strlen(material_string) && strcmp(material_string, "NULL") && strcmp(material_string, "0")) {
    // A geometry string was given, use it to determine which material
    if (0 == strcmp(material_string,"vacuum") || 0 == strcmp(material_string,"Vacuum")) {
        // One could have a global physics struct for vacuum instead of creating one for each
        this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
        this_box_volume.p_physics->is_vacuum = 1; // Makes this volume a vacuum
        this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
        this_box_volume.p_physics->my_a = 0; // Should not be used.
        sprintf(this_box_volume.p_physics->name,"Vacuum");
    } else if (0 == strcmp(material_string,"exit") || 0 == strcmp(material_string,"Exit")) {
        // One could have a global physics struct for vacuum instead of creating one for each
        this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
        this_box_volume.p_physics->is_vacuum = 1; // Makes this volume a vacuum
        this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
        this_box_volume.p_physics->my_a = 0; // Should not be used.
        this_box_volume.geometry.is_exit_volume = 1;
        sprintf(this_box_volume.p_physics->name,"Exit");
    } else {
        #ifndef MATERIAL_DETECTOR
            printf("Need to define a material before refering to it in a geometry %s.\n",NAME_CURRENT_COMP);
            exit(1);
        #endif
        for (loop_index=0;loop_index<global_material_list.num_elements;loop_index++) {
            if (0 == strcmp(material_string,global_material_list.elements[loop_index].name)) {
                this_box_volume.p_physics = global_material_list.elements[loop_index].physics;
                break;
            }
            if (loop_index == global_material_list.num_elements-1) {
            printf("\n");
            printf("ERROR: The material string \"%s\" in Union geometry \"%s\" did not match a specified material. \n",material_string,NAME_CURRENT_COMP);
            printf("       The materials available at this point (need to be defined before the geometry): \n");
            for (loop_index=0;loop_index<global_material_list.num_elements;loop_index++)
              printf("         %s\n",global_material_list.elements[loop_index].name);
            printf("\n");
            printf("       It is also possible to use one of the defualt materials avaiable: \n");
            printf("           Vacuum (for a Volume without scattering or absorption)\n");
            printf("           Exit (for a Volume where the ray exits the component if it enters)\n");
            printf("           Mask (for a Volume that masks existing volumes specified in the mask_string\n");
            exit(1);
          }
        }
    }
} else {
    // Automatic linking, simply using the last defined material.
    #ifndef MATERIAL_DETECTOR
        printf("Need to define a material before the geometry to use automatic linking %s.\n",NAME_CURRENT_COMP);
        exit(1);
    #endif
    this_box_volume.p_physics = global_material_list.elements[global_material_list.num_elements-1].physics;
}

sprintf(this_box_volume.name,NAME_CURRENT_COMP);
sprintf(this_box_volume.geometry.shape,"box");
this_box_volume.geometry.priority_value = priority;
this_box_volume.geometry.geometry_p_interact = p_interact;
// Currently the coordinates will be in absolute space.
this_box_volume.geometry.center = POS_A_CURRENT_COMP;

this_box_storage.z_depth = zdepth;
this_box_storage.x_width1 = xwidth;
this_box_storage.y_height1 = yheight;

this_box_storage.is_rectangle = 0;
if (xwidth2 < 0 && yheight2 < 0) this_box_storage.is_rectangle = 1;
if (xwidth == xwidth2 && yheight == yheight2) this_box_storage.is_rectangle = 1;

if (xwidth2 < 0) {
    this_box_storage.x_width2 = xwidth;
    xwidth2 = xwidth;
} else this_box_storage.x_width2 = xwidth2;

if (yheight2 < 0) {
    this_box_storage.y_height2 = yheight;
    yheight2 = yheight;
} else this_box_storage.y_height2 = yheight2;


this_box_storage.normal_vectors[0] = coords_set(0,0,1);
this_box_storage.normal_vectors[1] = coords_set(0,0,1);

// for sides with y component = 0
x_component = 2*zdepth/sqrt((xwidth-xwidth2)*(xwidth-xwidth2)+4*zdepth*zdepth);
z_component = (xwidth-xwidth2)/sqrt(4*zdepth*zdepth+(xwidth-xwidth2)*(xwidth-xwidth2));

this_box_storage.normal_vectors[2] = coords_set(x_component,0,z_component);
this_box_storage.normal_vectors[3] = coords_set(-x_component,0,z_component);

// for sides with x component = 0
y_component = 2*zdepth/sqrt((yheight-yheight2)*(yheight-yheight2)+4*zdepth*zdepth);
z_component = (yheight-yheight2)/sqrt(4*zdepth*zdepth+(yheight-yheight2)*(yheight-yheight2));

this_box_storage.normal_vectors[4] = coords_set(0,y_component,z_component);
this_box_storage.normal_vectors[5] = coords_set(0,-y_component,z_component);

this_box_volume.geometry.visualization_on = visualize;

this_box_volume.geometry.geometry_parameters.p_box_storage = &this_box_storage;

// Assign pointers to functions for intersection with the shape, checking if a point is inside the shape
if (this_box_storage.is_rectangle == 1) {
this_box_volume.geometry.intersect_function = &sample_box_intersect_simple;
this_box_volume.geometry.within_function = &r_within_box_simple;
}
else {
this_box_volume.geometry.intersect_function = &sample_box_intersect_advanced;
this_box_volume.geometry.within_function = &r_within_box_advanced;
}

this_box_volume.geometry.shell_points = &box_shell_points;
this_box_volume.geometry.mcdisplay_function = &mcdisplay_box_function;
this_box_volume.geometry.initialize_from_main_function = &initialize_box_geometry_from_main_component;
this_box_volume.geometry.process_rot_allocated = 0;

this_box_volume.geometry.copy_geometry_parameters = &allocate_box_storage_copy;

rot_copy(this_box_volume.geometry.rotation_matrix,ROT_A_CURRENT_COMP); //check how ROT_R_CURRENT_COMP would work
rot_transpose(ROT_A_CURRENT_COMP,this_box_volume.geometry.transpose_rotation_matrix);

// Initialize loggers
this_box_volume.loggers.num_elements = 0;

// packing the information into the global_geometry_element, which is then included in the global_geometry_list.
sprintf(global_geometry_element.name,NAME_CURRENT_COMP);
global_geometry_element.activation_counter = number_of_activations;
global_geometry_element.component_index = INDEX_CURRENT_COMP;
global_geometry_element.Volume = &this_box_volume; // Would be nicer if this m was a pointer, now we have the (small) data two places
add_element_to_geometry_list(&global_geometry_list,global_geometry_element);
}
#line 258209 "MACS_sample_kidney_box.c"
#undef number_of_activations
#undef mask_setting
#undef mask_string
#undef p_interact
#undef focus_r
#undef focus_xh
#undef focus_xw
#undef focus_ah
#undef focus_aw
#undef target_z
#undef target_y
#undef target_x
#undef target_index
#undef visualize
#undef yheight2
#undef xwidth2
#undef zdepth
#undef yheight
#undef xwidth
#undef priority
#undef material_string
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

  /* Initializations for component channel_10_analyzer_2_array_crystal_array_8. */
  SIG_MESSAGE("channel_10_analyzer_2_array_crystal_array_8 (Init)");
#define mccompcurname  channel_10_analyzer_2_array_crystal_array_8
#define mccompcurtype  Union_box
#define mccompcurindex 529
#define loop_index mccchannel_10_analyzer_2_array_crystal_array_8_loop_index
#define this_box_volume mccchannel_10_analyzer_2_array_crystal_array_8_this_box_volume
#define global_geometry_element mccchannel_10_analyzer_2_array_crystal_array_8_global_geometry_element
#define this_box_storage mccchannel_10_analyzer_2_array_crystal_array_8_this_box_storage
#define material_string mccchannel_10_analyzer_2_array_crystal_array_8_material_string
#define priority mccchannel_10_analyzer_2_array_crystal_array_8_priority
#define xwidth mccchannel_10_analyzer_2_array_crystal_array_8_xwidth
#define yheight mccchannel_10_analyzer_2_array_crystal_array_8_yheight
#define zdepth mccchannel_10_analyzer_2_array_crystal_array_8_zdepth
#define xwidth2 mccchannel_10_analyzer_2_array_crystal_array_8_xwidth2
#define yheight2 mccchannel_10_analyzer_2_array_crystal_array_8_yheight2
#define visualize mccchannel_10_analyzer_2_array_crystal_array_8_visualize
#define target_index mccchannel_10_analyzer_2_array_crystal_array_8_target_index
#define target_x mccchannel_10_analyzer_2_array_crystal_array_8_target_x
#define target_y mccchannel_10_analyzer_2_array_crystal_array_8_target_y
#define target_z mccchannel_10_analyzer_2_array_crystal_array_8_target_z
#define focus_aw mccchannel_10_analyzer_2_array_crystal_array_8_focus_aw
#define focus_ah mccchannel_10_analyzer_2_array_crystal_array_8_focus_ah
#define focus_xw mccchannel_10_analyzer_2_array_crystal_array_8_focus_xw
#define focus_xh mccchannel_10_analyzer_2_array_crystal_array_8_focus_xh
#define focus_r mccchannel_10_analyzer_2_array_crystal_array_8_focus_r
#define p_interact mccchannel_10_analyzer_2_array_crystal_array_8_p_interact
#define mask_string mccchannel_10_analyzer_2_array_crystal_array_8_mask_string
#define mask_setting mccchannel_10_analyzer_2_array_crystal_array_8_mask_setting
#define number_of_activations mccchannel_10_analyzer_2_array_crystal_array_8_number_of_activations
#line 224 "Union_box.comp"
{
// Initializes the focusing system for this volume including input sanitation.
focus_initialize(&this_box_volume.geometry, POS_A_COMP_INDEX(INDEX_CURRENT_COMP+target_index), POS_A_CURRENT_COMP, ROT_A_CURRENT_COMP, target_index, target_x, target_y, target_z, focus_aw, focus_ah, focus_xw, focus_xh, focus_r, NAME_CURRENT_COMP);

// Input sanitation for this geometry
if (xwidth <= 0) {
  printf("\nERROR in Union_box named %s, the xwidth is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (yheight <= 0) {
  printf("\nERROR in Union_box named %s, yheight is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (zdepth <= 0) {
  printf("\nERROR in Union_box named %s, zdepth is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (xwidth2 <= 0 && xwidth2 != -1) {
  printf("\nERROR in Union_box named %s, the xwidth2 is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (yheight2 <= 0 && yheight2 != -1) {
  printf("\nERROR in Union_box named %s, yheight2 is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}

// Use sanitation
if (global_material_list.num_elements == 0) {
  printf("\nERROR: Need to define a material using Union_make_material before using a Union geometry component. \n");
  printf("       %s was defined before first use of Union_make_material.\n",NAME_CURRENT_COMP);
  exit(1);
}

this_box_volume.geometry.is_masked_volume = 0;
this_box_volume.geometry.is_exit_volume = 0;
this_box_volume.geometry.is_mask_volume = 0;
// check if the volume is a mask, if it is the material string is irelevant.
if (mask_string && strlen(mask_string) && strcmp(mask_string, "NULL") && strcmp(mask_string, "0")) {
    // A mask volume is used to limit the extend of other volumes, called the masked volumes. These are specified in the mask_string.
    // In order for a ray to enter a masked volume, it needs to be both in the region covered by that volume AND the mask volume.
    // When more than
    this_box_volume.geometry.mask_mode = 1; // Default is mask mode is ALL
    if (mask_setting && strlen(mask_setting) && strcmp(mask_setting, "NULL") && strcmp(mask_setting, "0")) {
        if (strcmp(mask_setting,"ALL") == 0 || strcmp(mask_setting,"All") == 0) this_box_volume.geometry.mask_mode = 1;
        else if (strcmp(mask_setting,"ANY") == 0 || strcmp(mask_setting,"Any") == 0) this_box_volume.geometry.mask_mode = 2;
        else {
            printf("The mask_mode of component %s is set to %s, but must be either ALL or ANY.\n",NAME_CURRENT_COMP,mask_setting);
            exit(1);
        }
    }
    
    for (loop_index=0;loop_index<global_geometry_list.num_elements;loop_index++) {
        // Add mask list
        if (1 == manual_linking_function(global_geometry_list.elements[loop_index].name,mask_string)) {
            add_element_to_int_list(&this_box_volume.geometry.mask_list,global_geometry_list.elements[loop_index].component_index);
            add_element_to_int_list(&global_geometry_list.elements[loop_index].Volume->geometry.masked_by_list,INDEX_CURRENT_COMP);
            global_geometry_list.elements[loop_index].Volume->geometry.is_masked_volume = 1;
            if (this_box_volume.geometry.mask_mode == 2)
                global_geometry_list.elements[loop_index].Volume->geometry.mask_mode = 2;
            if (this_box_volume.geometry.mask_mode == 1) {
                if (global_geometry_list.elements[loop_index].Volume->geometry.is_masked_volume == 1 && global_geometry_list.elements[loop_index].Volume->geometry.mask_mode != 2)
                    // If more than one mask is added to one volume, the ANY mode overwrites the (default) ALL mode.
                    global_geometry_list.elements[loop_index].Volume->geometry.mask_mode = 1;
            }
            
            found_geometries = 1;
        }
    }
    if (found_geometries == 0) {
        printf("The mask_string in geometry: %s did not find any of the specified volumes in the mask_string %s \n",NAME_CURRENT_COMP,mask_string);
        exit(1);
    }
    this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
    this_box_volume.p_physics->is_vacuum = 0; // Makes this volume a vacuum
    this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
    this_box_volume.p_physics->my_a = 0; // Should not be used.
    sprintf(this_box_volume.p_physics->name,"Mask");
    this_box_volume.geometry.is_mask_volume = 1;
    
    
// Read the material input, or if it lacks, use automatic linking.
} else if (material_string && strlen(material_string) && strcmp(material_string, "NULL") && strcmp(material_string, "0")) {
    // A geometry string was given, use it to determine which material
    if (0 == strcmp(material_string,"vacuum") || 0 == strcmp(material_string,"Vacuum")) {
        // One could have a global physics struct for vacuum instead of creating one for each
        this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
        this_box_volume.p_physics->is_vacuum = 1; // Makes this volume a vacuum
        this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
        this_box_volume.p_physics->my_a = 0; // Should not be used.
        sprintf(this_box_volume.p_physics->name,"Vacuum");
    } else if (0 == strcmp(material_string,"exit") || 0 == strcmp(material_string,"Exit")) {
        // One could have a global physics struct for vacuum instead of creating one for each
        this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
        this_box_volume.p_physics->is_vacuum = 1; // Makes this volume a vacuum
        this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
        this_box_volume.p_physics->my_a = 0; // Should not be used.
        this_box_volume.geometry.is_exit_volume = 1;
        sprintf(this_box_volume.p_physics->name,"Exit");
    } else {
        #ifndef MATERIAL_DETECTOR
            printf("Need to define a material before refering to it in a geometry %s.\n",NAME_CURRENT_COMP);
            exit(1);
        #endif
        for (loop_index=0;loop_index<global_material_list.num_elements;loop_index++) {
            if (0 == strcmp(material_string,global_material_list.elements[loop_index].name)) {
                this_box_volume.p_physics = global_material_list.elements[loop_index].physics;
                break;
            }
            if (loop_index == global_material_list.num_elements-1) {
            printf("\n");
            printf("ERROR: The material string \"%s\" in Union geometry \"%s\" did not match a specified material. \n",material_string,NAME_CURRENT_COMP);
            printf("       The materials available at this point (need to be defined before the geometry): \n");
            for (loop_index=0;loop_index<global_material_list.num_elements;loop_index++)
              printf("         %s\n",global_material_list.elements[loop_index].name);
            printf("\n");
            printf("       It is also possible to use one of the defualt materials avaiable: \n");
            printf("           Vacuum (for a Volume without scattering or absorption)\n");
            printf("           Exit (for a Volume where the ray exits the component if it enters)\n");
            printf("           Mask (for a Volume that masks existing volumes specified in the mask_string\n");
            exit(1);
          }
        }
    }
} else {
    // Automatic linking, simply using the last defined material.
    #ifndef MATERIAL_DETECTOR
        printf("Need to define a material before the geometry to use automatic linking %s.\n",NAME_CURRENT_COMP);
        exit(1);
    #endif
    this_box_volume.p_physics = global_material_list.elements[global_material_list.num_elements-1].physics;
}

sprintf(this_box_volume.name,NAME_CURRENT_COMP);
sprintf(this_box_volume.geometry.shape,"box");
this_box_volume.geometry.priority_value = priority;
this_box_volume.geometry.geometry_p_interact = p_interact;
// Currently the coordinates will be in absolute space.
this_box_volume.geometry.center = POS_A_CURRENT_COMP;

this_box_storage.z_depth = zdepth;
this_box_storage.x_width1 = xwidth;
this_box_storage.y_height1 = yheight;

this_box_storage.is_rectangle = 0;
if (xwidth2 < 0 && yheight2 < 0) this_box_storage.is_rectangle = 1;
if (xwidth == xwidth2 && yheight == yheight2) this_box_storage.is_rectangle = 1;

if (xwidth2 < 0) {
    this_box_storage.x_width2 = xwidth;
    xwidth2 = xwidth;
} else this_box_storage.x_width2 = xwidth2;

if (yheight2 < 0) {
    this_box_storage.y_height2 = yheight;
    yheight2 = yheight;
} else this_box_storage.y_height2 = yheight2;


this_box_storage.normal_vectors[0] = coords_set(0,0,1);
this_box_storage.normal_vectors[1] = coords_set(0,0,1);

// for sides with y component = 0
x_component = 2*zdepth/sqrt((xwidth-xwidth2)*(xwidth-xwidth2)+4*zdepth*zdepth);
z_component = (xwidth-xwidth2)/sqrt(4*zdepth*zdepth+(xwidth-xwidth2)*(xwidth-xwidth2));

this_box_storage.normal_vectors[2] = coords_set(x_component,0,z_component);
this_box_storage.normal_vectors[3] = coords_set(-x_component,0,z_component);

// for sides with x component = 0
y_component = 2*zdepth/sqrt((yheight-yheight2)*(yheight-yheight2)+4*zdepth*zdepth);
z_component = (yheight-yheight2)/sqrt(4*zdepth*zdepth+(yheight-yheight2)*(yheight-yheight2));

this_box_storage.normal_vectors[4] = coords_set(0,y_component,z_component);
this_box_storage.normal_vectors[5] = coords_set(0,-y_component,z_component);

this_box_volume.geometry.visualization_on = visualize;

this_box_volume.geometry.geometry_parameters.p_box_storage = &this_box_storage;

// Assign pointers to functions for intersection with the shape, checking if a point is inside the shape
if (this_box_storage.is_rectangle == 1) {
this_box_volume.geometry.intersect_function = &sample_box_intersect_simple;
this_box_volume.geometry.within_function = &r_within_box_simple;
}
else {
this_box_volume.geometry.intersect_function = &sample_box_intersect_advanced;
this_box_volume.geometry.within_function = &r_within_box_advanced;
}

this_box_volume.geometry.shell_points = &box_shell_points;
this_box_volume.geometry.mcdisplay_function = &mcdisplay_box_function;
this_box_volume.geometry.initialize_from_main_function = &initialize_box_geometry_from_main_component;
this_box_volume.geometry.process_rot_allocated = 0;

this_box_volume.geometry.copy_geometry_parameters = &allocate_box_storage_copy;

rot_copy(this_box_volume.geometry.rotation_matrix,ROT_A_CURRENT_COMP); //check how ROT_R_CURRENT_COMP would work
rot_transpose(ROT_A_CURRENT_COMP,this_box_volume.geometry.transpose_rotation_matrix);

// Initialize loggers
this_box_volume.loggers.num_elements = 0;

// packing the information into the global_geometry_element, which is then included in the global_geometry_list.
sprintf(global_geometry_element.name,NAME_CURRENT_COMP);
global_geometry_element.activation_counter = number_of_activations;
global_geometry_element.component_index = INDEX_CURRENT_COMP;
global_geometry_element.Volume = &this_box_volume; // Would be nicer if this m was a pointer, now we have the (small) data two places
add_element_to_geometry_list(&global_geometry_list,global_geometry_element);
}
#line 258479 "MACS_sample_kidney_box.c"
#undef number_of_activations
#undef mask_setting
#undef mask_string
#undef p_interact
#undef focus_r
#undef focus_xh
#undef focus_xw
#undef focus_ah
#undef focus_aw
#undef target_z
#undef target_y
#undef target_x
#undef target_index
#undef visualize
#undef yheight2
#undef xwidth2
#undef zdepth
#undef yheight
#undef xwidth
#undef priority
#undef material_string
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

  /* Initializations for component channel_10_cave2_cyl1. */
  SIG_MESSAGE("channel_10_cave2_cyl1 (Init)");
#define mccompcurname  channel_10_cave2_cyl1
#define mccompcurtype  Union_cylinder
#define mccompcurindex 530
#define loop_index mccchannel_10_cave2_cyl1_loop_index
#define this_cylinder_volume mccchannel_10_cave2_cyl1_this_cylinder_volume
#define global_geometry_element mccchannel_10_cave2_cyl1_global_geometry_element
#define this_cylinder_storage mccchannel_10_cave2_cyl1_this_cylinder_storage
#define material_string mccchannel_10_cave2_cyl1_material_string
#define priority mccchannel_10_cave2_cyl1_priority
#define radius mccchannel_10_cave2_cyl1_radius
#define yheight mccchannel_10_cave2_cyl1_yheight
#define visualize mccchannel_10_cave2_cyl1_visualize
#define target_index mccchannel_10_cave2_cyl1_target_index
#define target_x mccchannel_10_cave2_cyl1_target_x
#define target_y mccchannel_10_cave2_cyl1_target_y
#define target_z mccchannel_10_cave2_cyl1_target_z
#define focus_aw mccchannel_10_cave2_cyl1_focus_aw
#define focus_ah mccchannel_10_cave2_cyl1_focus_ah
#define focus_xw mccchannel_10_cave2_cyl1_focus_xw
#define focus_xh mccchannel_10_cave2_cyl1_focus_xh
#define focus_r mccchannel_10_cave2_cyl1_focus_r
#define p_interact mccchannel_10_cave2_cyl1_p_interact
#define mask_string mccchannel_10_cave2_cyl1_mask_string
#define mask_setting mccchannel_10_cave2_cyl1_mask_setting
#define number_of_activations mccchannel_10_cave2_cyl1_number_of_activations
#line 185 "Union_cylinder.comp"
{
// Initializes the focusing system for this volume including input sanitation.
focus_initialize(&this_cylinder_volume.geometry, POS_A_COMP_INDEX(INDEX_CURRENT_COMP+target_index), POS_A_CURRENT_COMP, ROT_A_CURRENT_COMP, target_index, target_x, target_y, target_z, focus_aw, focus_ah, focus_xw, focus_xh, focus_r, NAME_CURRENT_COMP);

// Input sanitation for this geometry
if (radius <= 0) {
  printf("\nERROR in Union_cylinder named %s, the radius is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}

if (yheight <= 0) {
  printf("\nERROR in Union_cylinder named %s, yheight is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}

// Use sanitation
#ifdef MATERIAL_DETECTOR
if (global_material_list.num_elements == 0) {
  // Here if the user have defined a material, but only after this material
  printf("\nERROR: Need to define a material using Union_make_material before using a Union geometry component. \n");
  printf("       %s was defined before first use of Union_make_material.\n",NAME_CURRENT_COMP);
  exit(1);
}
#endif
#ifndef MATERIAL_DETECTOR
  printf("\nERROR: Need to define a material using Union_make_material before using a Union geometry component. \n");
  exit(1);
#endif


this_cylinder_volume.geometry.is_masked_volume = 0;
this_cylinder_volume.geometry.is_exit_volume = 0;
this_cylinder_volume.geometry.is_mask_volume = 0;

// Read the material input, or if it lacks, use automatic linking.
if (mask_string && strlen(mask_string) && strcmp(mask_string, "NULL") && strcmp(mask_string, "0")) {
    // A mask volume is used to limit the extend of other volumes, called the masked volumes. These are specified in the mask_string.
    // In order for a ray to enter a masked volume, it needs to be both in the region covered by that volume AND the mask volume.
    // When more than
    this_cylinder_volume.geometry.mask_mode = 1; // Default is mask mode is ALL
    if (mask_setting && strlen(mask_setting) && strcmp(mask_setting, "NULL") && strcmp(mask_setting, "0")) {
        if (strcmp(mask_setting,"ALL") == 0 || strcmp(mask_setting,"All") == 0) this_cylinder_volume.geometry.mask_mode = 1;
        else if (strcmp(mask_setting,"ANY") == 0 || strcmp(mask_setting,"Any") == 0) this_cylinder_volume.geometry.mask_mode = 2;
        else {
            printf("The mask_mode of component %s is set to %s, but must be either ALL or ANY.\n",NAME_CURRENT_COMP,mask_setting);
            exit(1);
        }
    }
    
    for (loop_index=0;loop_index<global_geometry_list.num_elements;loop_index++) {
        // Add mask list
        if (1 == manual_linking_function(global_geometry_list.elements[loop_index].name,mask_string)) {
            add_element_to_int_list(&this_cylinder_volume.geometry.mask_list,global_geometry_list.elements[loop_index].component_index);
            add_element_to_int_list(&global_geometry_list.elements[loop_index].Volume->geometry.masked_by_list,INDEX_CURRENT_COMP);
            global_geometry_list.elements[loop_index].Volume->geometry.is_masked_volume = 1;
            if (this_cylinder_volume.geometry.mask_mode == 2)
                global_geometry_list.elements[loop_index].Volume->geometry.mask_mode = 2;
            if (this_cylinder_volume.geometry.mask_mode == 1) {
                if (global_geometry_list.elements[loop_index].Volume->geometry.is_masked_volume == 1 && global_geometry_list.elements[loop_index].Volume->geometry.mask_mode != 2)
                    // If more than one mask is added to one volume, the ANY mode overwrites the (default) ALL mode.
                    global_geometry_list.elements[loop_index].Volume->geometry.mask_mode = 1;
            }
            
            found_geometries = 1;
        }
    }
    if (found_geometries == 0) {
        printf("The mask_string in geometry: %s did not find any of the specified volumes in the mask_string %s \n",NAME_CURRENT_COMP,mask_string);
        exit(1);
    }
    this_cylinder_volume.p_physics = malloc(sizeof(struct physics_struct));
    this_cylinder_volume.p_physics->is_vacuum = 0; // Makes this volume a vacuum
    this_cylinder_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
    this_cylinder_volume.p_physics->my_a = 0; // Should not be used.
    sprintf(this_cylinder_volume.p_physics->name,"Mask");
    this_cylinder_volume.geometry.is_mask_volume = 1;
    
    
// Read the material input, or if it lacks, use automatic linking.
} else if (material_string && strlen(material_string) && strcmp(material_string, "NULL") && strcmp(material_string, "0")) {
    // A geometry string was given, use it to determine which material
    if (0 == strcmp(material_string,"vacuum") || 0 == strcmp(material_string,"Vacuum")) {
        // One could have a global physics struct for vacuum instead of creating one for each
        this_cylinder_volume.p_physics = malloc(sizeof(struct physics_struct));
        this_cylinder_volume.p_physics->is_vacuum = 1; // Makes this volume a vacuum
        this_cylinder_volume.p_physics->number_of_processes = (int) 0;
        this_cylinder_volume.p_physics->my_a = 0; // Should not be used.
        sprintf(this_cylinder_volume.p_physics->name,"Vacuum");
    } else if (0 == strcmp(material_string,"exit") || 0 == strcmp(material_string,"Exit")) {
        // One could have a global physics struct for exit instead of creating one for each
        this_cylinder_volume.p_physics = malloc(sizeof(struct physics_struct));
        this_cylinder_volume.p_physics->is_vacuum = 1; // Makes this volume a vacuum
        this_cylinder_volume.p_physics->number_of_processes = (int) 0;
        this_cylinder_volume.p_physics->my_a = 0; // Should not be used.
        this_cylinder_volume.geometry.is_exit_volume = 1;
        sprintf(this_cylinder_volume.p_physics->name,"Exit");
    } else {
        for (loop_index=0;loop_index<global_material_list.num_elements;loop_index++) {
          if (0 == strcmp(material_string,global_material_list.elements[loop_index].name)) {
            this_cylinder_volume.p_physics = global_material_list.elements[loop_index].physics;
            break;
          }
          if (loop_index == global_material_list.num_elements-1) {
            printf("\n");
            printf("ERROR: The material string \"%s\" in Union geometry \"%s\" did not match a specified material. \n",material_string,NAME_CURRENT_COMP);
            printf("       The materials available at this point (need to be defined before the geometry): \n");
            for (loop_index=0;loop_index<global_material_list.num_elements;loop_index++)
              printf("         %s\n",global_material_list.elements[loop_index].name);
            printf("\n");
            printf("       It is also possible to use one of the defualt materials avaiable: \n");
            printf("           Vacuum (for a Volume without scattering or absorption)\n");
            printf("           Exit (for a Volume where the ray exits the component if it enters)\n");
            printf("           Mask (for a Volume that masks existing volumes specified in the mask_string\n");
            exit(1);
          }
        }
    }
} else {
    // Automatic linking, simply using the last defined material.
    #ifndef MATERIAL_DETECTOR
        printf("Need to define a material before the geometry to use automatic linking %s.\n",NAME_CURRENT_COMP);
        exit(1);
    #endif
    this_cylinder_volume.p_physics = global_material_list.elements[global_material_list.num_elements-1].physics;
}

sprintf(this_cylinder_volume.name,NAME_CURRENT_COMP);
sprintf(this_cylinder_volume.geometry.shape,"cylinder");
this_cylinder_volume.geometry.priority_value = priority;
// Currently the coordinates will be in absolute space.
this_cylinder_volume.geometry.center = POS_A_CURRENT_COMP;

this_cylinder_volume.geometry.geometry_p_interact = p_interact;
this_cylinder_storage.cyl_radius = radius;
this_cylinder_storage.height = yheight;
this_cylinder_volume.geometry.visualization_on = visualize;
this_cylinder_volume.geometry.geometry_parameters.p_cylinder_storage = &this_cylinder_storage;
this_cylinder_volume.geometry.within_function = &r_within_cylinder;
this_cylinder_volume.geometry.intersect_function = &sample_cylinder_intersect;
this_cylinder_volume.geometry.mcdisplay_function = &mcdisplay_cylinder_function;
this_cylinder_volume.geometry.shell_points = &cylinder_shell_points;
this_cylinder_volume.geometry.initialize_from_main_function = &initialize_cylinder_geometry_from_main_component;
this_cylinder_volume.geometry.process_rot_allocated = 0;
this_cylinder_volume.geometry.copy_geometry_parameters = &allocate_cylinder_storage_copy;

rot_copy(this_cylinder_volume.geometry.rotation_matrix,ROT_A_CURRENT_COMP);
rot_transpose(ROT_A_CURRENT_COMP,this_cylinder_volume.geometry.transpose_rotation_matrix);

// Initialize loggers
this_cylinder_volume.loggers.num_elements = 0;

// packing the information into the global_geometry_element, which is then included in the global_geometry_list.
sprintf(global_geometry_element.name,NAME_CURRENT_COMP);
global_geometry_element.activation_counter = number_of_activations;
global_geometry_element.component_index = INDEX_CURRENT_COMP;
global_geometry_element.Volume = &this_cylinder_volume; // Would be nicer if this m was a pointer, now we have the (small) data two places
add_element_to_geometry_list(&global_geometry_list,global_geometry_element);
}
#line 258695 "MACS_sample_kidney_box.c"
#undef number_of_activations
#undef mask_setting
#undef mask_string
#undef p_interact
#undef focus_r
#undef focus_xh
#undef focus_xw
#undef focus_ah
#undef focus_aw
#undef target_z
#undef target_y
#undef target_x
#undef target_index
#undef visualize
#undef yheight
#undef radius
#undef priority
#undef material_string
#undef this_cylinder_storage
#undef global_geometry_element
#undef this_cylinder_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

  /* Initializations for component channel_10_cave2_box1. */
  SIG_MESSAGE("channel_10_cave2_box1 (Init)");
#define mccompcurname  channel_10_cave2_box1
#define mccompcurtype  Union_box
#define mccompcurindex 531
#define loop_index mccchannel_10_cave2_box1_loop_index
#define this_box_volume mccchannel_10_cave2_box1_this_box_volume
#define global_geometry_element mccchannel_10_cave2_box1_global_geometry_element
#define this_box_storage mccchannel_10_cave2_box1_this_box_storage
#define material_string mccchannel_10_cave2_box1_material_string
#define priority mccchannel_10_cave2_box1_priority
#define xwidth mccchannel_10_cave2_box1_xwidth
#define yheight mccchannel_10_cave2_box1_yheight
#define zdepth mccchannel_10_cave2_box1_zdepth
#define xwidth2 mccchannel_10_cave2_box1_xwidth2
#define yheight2 mccchannel_10_cave2_box1_yheight2
#define visualize mccchannel_10_cave2_box1_visualize
#define target_index mccchannel_10_cave2_box1_target_index
#define target_x mccchannel_10_cave2_box1_target_x
#define target_y mccchannel_10_cave2_box1_target_y
#define target_z mccchannel_10_cave2_box1_target_z
#define focus_aw mccchannel_10_cave2_box1_focus_aw
#define focus_ah mccchannel_10_cave2_box1_focus_ah
#define focus_xw mccchannel_10_cave2_box1_focus_xw
#define focus_xh mccchannel_10_cave2_box1_focus_xh
#define focus_r mccchannel_10_cave2_box1_focus_r
#define p_interact mccchannel_10_cave2_box1_p_interact
#define mask_string mccchannel_10_cave2_box1_mask_string
#define mask_setting mccchannel_10_cave2_box1_mask_setting
#define number_of_activations mccchannel_10_cave2_box1_number_of_activations
#line 224 "Union_box.comp"
{
// Initializes the focusing system for this volume including input sanitation.
focus_initialize(&this_box_volume.geometry, POS_A_COMP_INDEX(INDEX_CURRENT_COMP+target_index), POS_A_CURRENT_COMP, ROT_A_CURRENT_COMP, target_index, target_x, target_y, target_z, focus_aw, focus_ah, focus_xw, focus_xh, focus_r, NAME_CURRENT_COMP);

// Input sanitation for this geometry
if (xwidth <= 0) {
  printf("\nERROR in Union_box named %s, the xwidth is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (yheight <= 0) {
  printf("\nERROR in Union_box named %s, yheight is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (zdepth <= 0) {
  printf("\nERROR in Union_box named %s, zdepth is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (xwidth2 <= 0 && xwidth2 != -1) {
  printf("\nERROR in Union_box named %s, the xwidth2 is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (yheight2 <= 0 && yheight2 != -1) {
  printf("\nERROR in Union_box named %s, yheight2 is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}

// Use sanitation
if (global_material_list.num_elements == 0) {
  printf("\nERROR: Need to define a material using Union_make_material before using a Union geometry component. \n");
  printf("       %s was defined before first use of Union_make_material.\n",NAME_CURRENT_COMP);
  exit(1);
}

this_box_volume.geometry.is_masked_volume = 0;
this_box_volume.geometry.is_exit_volume = 0;
this_box_volume.geometry.is_mask_volume = 0;
// check if the volume is a mask, if it is the material string is irelevant.
if (mask_string && strlen(mask_string) && strcmp(mask_string, "NULL") && strcmp(mask_string, "0")) {
    // A mask volume is used to limit the extend of other volumes, called the masked volumes. These are specified in the mask_string.
    // In order for a ray to enter a masked volume, it needs to be both in the region covered by that volume AND the mask volume.
    // When more than
    this_box_volume.geometry.mask_mode = 1; // Default is mask mode is ALL
    if (mask_setting && strlen(mask_setting) && strcmp(mask_setting, "NULL") && strcmp(mask_setting, "0")) {
        if (strcmp(mask_setting,"ALL") == 0 || strcmp(mask_setting,"All") == 0) this_box_volume.geometry.mask_mode = 1;
        else if (strcmp(mask_setting,"ANY") == 0 || strcmp(mask_setting,"Any") == 0) this_box_volume.geometry.mask_mode = 2;
        else {
            printf("The mask_mode of component %s is set to %s, but must be either ALL or ANY.\n",NAME_CURRENT_COMP,mask_setting);
            exit(1);
        }
    }
    
    for (loop_index=0;loop_index<global_geometry_list.num_elements;loop_index++) {
        // Add mask list
        if (1 == manual_linking_function(global_geometry_list.elements[loop_index].name,mask_string)) {
            add_element_to_int_list(&this_box_volume.geometry.mask_list,global_geometry_list.elements[loop_index].component_index);
            add_element_to_int_list(&global_geometry_list.elements[loop_index].Volume->geometry.masked_by_list,INDEX_CURRENT_COMP);
            global_geometry_list.elements[loop_index].Volume->geometry.is_masked_volume = 1;
            if (this_box_volume.geometry.mask_mode == 2)
                global_geometry_list.elements[loop_index].Volume->geometry.mask_mode = 2;
            if (this_box_volume.geometry.mask_mode == 1) {
                if (global_geometry_list.elements[loop_index].Volume->geometry.is_masked_volume == 1 && global_geometry_list.elements[loop_index].Volume->geometry.mask_mode != 2)
                    // If more than one mask is added to one volume, the ANY mode overwrites the (default) ALL mode.
                    global_geometry_list.elements[loop_index].Volume->geometry.mask_mode = 1;
            }
            
            found_geometries = 1;
        }
    }
    if (found_geometries == 0) {
        printf("The mask_string in geometry: %s did not find any of the specified volumes in the mask_string %s \n",NAME_CURRENT_COMP,mask_string);
        exit(1);
    }
    this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
    this_box_volume.p_physics->is_vacuum = 0; // Makes this volume a vacuum
    this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
    this_box_volume.p_physics->my_a = 0; // Should not be used.
    sprintf(this_box_volume.p_physics->name,"Mask");
    this_box_volume.geometry.is_mask_volume = 1;
    
    
// Read the material input, or if it lacks, use automatic linking.
} else if (material_string && strlen(material_string) && strcmp(material_string, "NULL") && strcmp(material_string, "0")) {
    // A geometry string was given, use it to determine which material
    if (0 == strcmp(material_string,"vacuum") || 0 == strcmp(material_string,"Vacuum")) {
        // One could have a global physics struct for vacuum instead of creating one for each
        this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
        this_box_volume.p_physics->is_vacuum = 1; // Makes this volume a vacuum
        this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
        this_box_volume.p_physics->my_a = 0; // Should not be used.
        sprintf(this_box_volume.p_physics->name,"Vacuum");
    } else if (0 == strcmp(material_string,"exit") || 0 == strcmp(material_string,"Exit")) {
        // One could have a global physics struct for vacuum instead of creating one for each
        this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
        this_box_volume.p_physics->is_vacuum = 1; // Makes this volume a vacuum
        this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
        this_box_volume.p_physics->my_a = 0; // Should not be used.
        this_box_volume.geometry.is_exit_volume = 1;
        sprintf(this_box_volume.p_physics->name,"Exit");
    } else {
        #ifndef MATERIAL_DETECTOR
            printf("Need to define a material before refering to it in a geometry %s.\n",NAME_CURRENT_COMP);
            exit(1);
        #endif
        for (loop_index=0;loop_index<global_material_list.num_elements;loop_index++) {
            if (0 == strcmp(material_string,global_material_list.elements[loop_index].name)) {
                this_box_volume.p_physics = global_material_list.elements[loop_index].physics;
                break;
            }
            if (loop_index == global_material_list.num_elements-1) {
            printf("\n");
            printf("ERROR: The material string \"%s\" in Union geometry \"%s\" did not match a specified material. \n",material_string,NAME_CURRENT_COMP);
            printf("       The materials available at this point (need to be defined before the geometry): \n");
            for (loop_index=0;loop_index<global_material_list.num_elements;loop_index++)
              printf("         %s\n",global_material_list.elements[loop_index].name);
            printf("\n");
            printf("       It is also possible to use one of the defualt materials avaiable: \n");
            printf("           Vacuum (for a Volume without scattering or absorption)\n");
            printf("           Exit (for a Volume where the ray exits the component if it enters)\n");
            printf("           Mask (for a Volume that masks existing volumes specified in the mask_string\n");
            exit(1);
          }
        }
    }
} else {
    // Automatic linking, simply using the last defined material.
    #ifndef MATERIAL_DETECTOR
        printf("Need to define a material before the geometry to use automatic linking %s.\n",NAME_CURRENT_COMP);
        exit(1);
    #endif
    this_box_volume.p_physics = global_material_list.elements[global_material_list.num_elements-1].physics;
}

sprintf(this_box_volume.name,NAME_CURRENT_COMP);
sprintf(this_box_volume.geometry.shape,"box");
this_box_volume.geometry.priority_value = priority;
this_box_volume.geometry.geometry_p_interact = p_interact;
// Currently the coordinates will be in absolute space.
this_box_volume.geometry.center = POS_A_CURRENT_COMP;

this_box_storage.z_depth = zdepth;
this_box_storage.x_width1 = xwidth;
this_box_storage.y_height1 = yheight;

this_box_storage.is_rectangle = 0;
if (xwidth2 < 0 && yheight2 < 0) this_box_storage.is_rectangle = 1;
if (xwidth == xwidth2 && yheight == yheight2) this_box_storage.is_rectangle = 1;

if (xwidth2 < 0) {
    this_box_storage.x_width2 = xwidth;
    xwidth2 = xwidth;
} else this_box_storage.x_width2 = xwidth2;

if (yheight2 < 0) {
    this_box_storage.y_height2 = yheight;
    yheight2 = yheight;
} else this_box_storage.y_height2 = yheight2;


this_box_storage.normal_vectors[0] = coords_set(0,0,1);
this_box_storage.normal_vectors[1] = coords_set(0,0,1);

// for sides with y component = 0
x_component = 2*zdepth/sqrt((xwidth-xwidth2)*(xwidth-xwidth2)+4*zdepth*zdepth);
z_component = (xwidth-xwidth2)/sqrt(4*zdepth*zdepth+(xwidth-xwidth2)*(xwidth-xwidth2));

this_box_storage.normal_vectors[2] = coords_set(x_component,0,z_component);
this_box_storage.normal_vectors[3] = coords_set(-x_component,0,z_component);

// for sides with x component = 0
y_component = 2*zdepth/sqrt((yheight-yheight2)*(yheight-yheight2)+4*zdepth*zdepth);
z_component = (yheight-yheight2)/sqrt(4*zdepth*zdepth+(yheight-yheight2)*(yheight-yheight2));

this_box_storage.normal_vectors[4] = coords_set(0,y_component,z_component);
this_box_storage.normal_vectors[5] = coords_set(0,-y_component,z_component);

this_box_volume.geometry.visualization_on = visualize;

this_box_volume.geometry.geometry_parameters.p_box_storage = &this_box_storage;

// Assign pointers to functions for intersection with the shape, checking if a point is inside the shape
if (this_box_storage.is_rectangle == 1) {
this_box_volume.geometry.intersect_function = &sample_box_intersect_simple;
this_box_volume.geometry.within_function = &r_within_box_simple;
}
else {
this_box_volume.geometry.intersect_function = &sample_box_intersect_advanced;
this_box_volume.geometry.within_function = &r_within_box_advanced;
}

this_box_volume.geometry.shell_points = &box_shell_points;
this_box_volume.geometry.mcdisplay_function = &mcdisplay_box_function;
this_box_volume.geometry.initialize_from_main_function = &initialize_box_geometry_from_main_component;
this_box_volume.geometry.process_rot_allocated = 0;

this_box_volume.geometry.copy_geometry_parameters = &allocate_box_storage_copy;

rot_copy(this_box_volume.geometry.rotation_matrix,ROT_A_CURRENT_COMP); //check how ROT_R_CURRENT_COMP would work
rot_transpose(ROT_A_CURRENT_COMP,this_box_volume.geometry.transpose_rotation_matrix);

// Initialize loggers
this_box_volume.loggers.num_elements = 0;

// packing the information into the global_geometry_element, which is then included in the global_geometry_list.
sprintf(global_geometry_element.name,NAME_CURRENT_COMP);
global_geometry_element.activation_counter = number_of_activations;
global_geometry_element.component_index = INDEX_CURRENT_COMP;
global_geometry_element.Volume = &this_box_volume; // Would be nicer if this m was a pointer, now we have the (small) data two places
add_element_to_geometry_list(&global_geometry_list,global_geometry_element);
}
#line 258962 "MACS_sample_kidney_box.c"
#undef number_of_activations
#undef mask_setting
#undef mask_string
#undef p_interact
#undef focus_r
#undef focus_xh
#undef focus_xw
#undef focus_ah
#undef focus_aw
#undef target_z
#undef target_y
#undef target_x
#undef target_index
#undef visualize
#undef yheight2
#undef xwidth2
#undef zdepth
#undef yheight
#undef xwidth
#undef priority
#undef material_string
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

  /* Initializations for component channel_10_cave2_box2. */
  SIG_MESSAGE("channel_10_cave2_box2 (Init)");
#define mccompcurname  channel_10_cave2_box2
#define mccompcurtype  Union_box
#define mccompcurindex 532
#define loop_index mccchannel_10_cave2_box2_loop_index
#define this_box_volume mccchannel_10_cave2_box2_this_box_volume
#define global_geometry_element mccchannel_10_cave2_box2_global_geometry_element
#define this_box_storage mccchannel_10_cave2_box2_this_box_storage
#define material_string mccchannel_10_cave2_box2_material_string
#define priority mccchannel_10_cave2_box2_priority
#define xwidth mccchannel_10_cave2_box2_xwidth
#define yheight mccchannel_10_cave2_box2_yheight
#define zdepth mccchannel_10_cave2_box2_zdepth
#define xwidth2 mccchannel_10_cave2_box2_xwidth2
#define yheight2 mccchannel_10_cave2_box2_yheight2
#define visualize mccchannel_10_cave2_box2_visualize
#define target_index mccchannel_10_cave2_box2_target_index
#define target_x mccchannel_10_cave2_box2_target_x
#define target_y mccchannel_10_cave2_box2_target_y
#define target_z mccchannel_10_cave2_box2_target_z
#define focus_aw mccchannel_10_cave2_box2_focus_aw
#define focus_ah mccchannel_10_cave2_box2_focus_ah
#define focus_xw mccchannel_10_cave2_box2_focus_xw
#define focus_xh mccchannel_10_cave2_box2_focus_xh
#define focus_r mccchannel_10_cave2_box2_focus_r
#define p_interact mccchannel_10_cave2_box2_p_interact
#define mask_string mccchannel_10_cave2_box2_mask_string
#define mask_setting mccchannel_10_cave2_box2_mask_setting
#define number_of_activations mccchannel_10_cave2_box2_number_of_activations
#line 224 "Union_box.comp"
{
// Initializes the focusing system for this volume including input sanitation.
focus_initialize(&this_box_volume.geometry, POS_A_COMP_INDEX(INDEX_CURRENT_COMP+target_index), POS_A_CURRENT_COMP, ROT_A_CURRENT_COMP, target_index, target_x, target_y, target_z, focus_aw, focus_ah, focus_xw, focus_xh, focus_r, NAME_CURRENT_COMP);

// Input sanitation for this geometry
if (xwidth <= 0) {
  printf("\nERROR in Union_box named %s, the xwidth is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (yheight <= 0) {
  printf("\nERROR in Union_box named %s, yheight is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (zdepth <= 0) {
  printf("\nERROR in Union_box named %s, zdepth is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (xwidth2 <= 0 && xwidth2 != -1) {
  printf("\nERROR in Union_box named %s, the xwidth2 is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (yheight2 <= 0 && yheight2 != -1) {
  printf("\nERROR in Union_box named %s, yheight2 is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}

// Use sanitation
if (global_material_list.num_elements == 0) {
  printf("\nERROR: Need to define a material using Union_make_material before using a Union geometry component. \n");
  printf("       %s was defined before first use of Union_make_material.\n",NAME_CURRENT_COMP);
  exit(1);
}

this_box_volume.geometry.is_masked_volume = 0;
this_box_volume.geometry.is_exit_volume = 0;
this_box_volume.geometry.is_mask_volume = 0;
// check if the volume is a mask, if it is the material string is irelevant.
if (mask_string && strlen(mask_string) && strcmp(mask_string, "NULL") && strcmp(mask_string, "0")) {
    // A mask volume is used to limit the extend of other volumes, called the masked volumes. These are specified in the mask_string.
    // In order for a ray to enter a masked volume, it needs to be both in the region covered by that volume AND the mask volume.
    // When more than
    this_box_volume.geometry.mask_mode = 1; // Default is mask mode is ALL
    if (mask_setting && strlen(mask_setting) && strcmp(mask_setting, "NULL") && strcmp(mask_setting, "0")) {
        if (strcmp(mask_setting,"ALL") == 0 || strcmp(mask_setting,"All") == 0) this_box_volume.geometry.mask_mode = 1;
        else if (strcmp(mask_setting,"ANY") == 0 || strcmp(mask_setting,"Any") == 0) this_box_volume.geometry.mask_mode = 2;
        else {
            printf("The mask_mode of component %s is set to %s, but must be either ALL or ANY.\n",NAME_CURRENT_COMP,mask_setting);
            exit(1);
        }
    }
    
    for (loop_index=0;loop_index<global_geometry_list.num_elements;loop_index++) {
        // Add mask list
        if (1 == manual_linking_function(global_geometry_list.elements[loop_index].name,mask_string)) {
            add_element_to_int_list(&this_box_volume.geometry.mask_list,global_geometry_list.elements[loop_index].component_index);
            add_element_to_int_list(&global_geometry_list.elements[loop_index].Volume->geometry.masked_by_list,INDEX_CURRENT_COMP);
            global_geometry_list.elements[loop_index].Volume->geometry.is_masked_volume = 1;
            if (this_box_volume.geometry.mask_mode == 2)
                global_geometry_list.elements[loop_index].Volume->geometry.mask_mode = 2;
            if (this_box_volume.geometry.mask_mode == 1) {
                if (global_geometry_list.elements[loop_index].Volume->geometry.is_masked_volume == 1 && global_geometry_list.elements[loop_index].Volume->geometry.mask_mode != 2)
                    // If more than one mask is added to one volume, the ANY mode overwrites the (default) ALL mode.
                    global_geometry_list.elements[loop_index].Volume->geometry.mask_mode = 1;
            }
            
            found_geometries = 1;
        }
    }
    if (found_geometries == 0) {
        printf("The mask_string in geometry: %s did not find any of the specified volumes in the mask_string %s \n",NAME_CURRENT_COMP,mask_string);
        exit(1);
    }
    this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
    this_box_volume.p_physics->is_vacuum = 0; // Makes this volume a vacuum
    this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
    this_box_volume.p_physics->my_a = 0; // Should not be used.
    sprintf(this_box_volume.p_physics->name,"Mask");
    this_box_volume.geometry.is_mask_volume = 1;
    
    
// Read the material input, or if it lacks, use automatic linking.
} else if (material_string && strlen(material_string) && strcmp(material_string, "NULL") && strcmp(material_string, "0")) {
    // A geometry string was given, use it to determine which material
    if (0 == strcmp(material_string,"vacuum") || 0 == strcmp(material_string,"Vacuum")) {
        // One could have a global physics struct for vacuum instead of creating one for each
        this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
        this_box_volume.p_physics->is_vacuum = 1; // Makes this volume a vacuum
        this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
        this_box_volume.p_physics->my_a = 0; // Should not be used.
        sprintf(this_box_volume.p_physics->name,"Vacuum");
    } else if (0 == strcmp(material_string,"exit") || 0 == strcmp(material_string,"Exit")) {
        // One could have a global physics struct for vacuum instead of creating one for each
        this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
        this_box_volume.p_physics->is_vacuum = 1; // Makes this volume a vacuum
        this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
        this_box_volume.p_physics->my_a = 0; // Should not be used.
        this_box_volume.geometry.is_exit_volume = 1;
        sprintf(this_box_volume.p_physics->name,"Exit");
    } else {
        #ifndef MATERIAL_DETECTOR
            printf("Need to define a material before refering to it in a geometry %s.\n",NAME_CURRENT_COMP);
            exit(1);
        #endif
        for (loop_index=0;loop_index<global_material_list.num_elements;loop_index++) {
            if (0 == strcmp(material_string,global_material_list.elements[loop_index].name)) {
                this_box_volume.p_physics = global_material_list.elements[loop_index].physics;
                break;
            }
            if (loop_index == global_material_list.num_elements-1) {
            printf("\n");
            printf("ERROR: The material string \"%s\" in Union geometry \"%s\" did not match a specified material. \n",material_string,NAME_CURRENT_COMP);
            printf("       The materials available at this point (need to be defined before the geometry): \n");
            for (loop_index=0;loop_index<global_material_list.num_elements;loop_index++)
              printf("         %s\n",global_material_list.elements[loop_index].name);
            printf("\n");
            printf("       It is also possible to use one of the defualt materials avaiable: \n");
            printf("           Vacuum (for a Volume without scattering or absorption)\n");
            printf("           Exit (for a Volume where the ray exits the component if it enters)\n");
            printf("           Mask (for a Volume that masks existing volumes specified in the mask_string\n");
            exit(1);
          }
        }
    }
} else {
    // Automatic linking, simply using the last defined material.
    #ifndef MATERIAL_DETECTOR
        printf("Need to define a material before the geometry to use automatic linking %s.\n",NAME_CURRENT_COMP);
        exit(1);
    #endif
    this_box_volume.p_physics = global_material_list.elements[global_material_list.num_elements-1].physics;
}

sprintf(this_box_volume.name,NAME_CURRENT_COMP);
sprintf(this_box_volume.geometry.shape,"box");
this_box_volume.geometry.priority_value = priority;
this_box_volume.geometry.geometry_p_interact = p_interact;
// Currently the coordinates will be in absolute space.
this_box_volume.geometry.center = POS_A_CURRENT_COMP;

this_box_storage.z_depth = zdepth;
this_box_storage.x_width1 = xwidth;
this_box_storage.y_height1 = yheight;

this_box_storage.is_rectangle = 0;
if (xwidth2 < 0 && yheight2 < 0) this_box_storage.is_rectangle = 1;
if (xwidth == xwidth2 && yheight == yheight2) this_box_storage.is_rectangle = 1;

if (xwidth2 < 0) {
    this_box_storage.x_width2 = xwidth;
    xwidth2 = xwidth;
} else this_box_storage.x_width2 = xwidth2;

if (yheight2 < 0) {
    this_box_storage.y_height2 = yheight;
    yheight2 = yheight;
} else this_box_storage.y_height2 = yheight2;


this_box_storage.normal_vectors[0] = coords_set(0,0,1);
this_box_storage.normal_vectors[1] = coords_set(0,0,1);

// for sides with y component = 0
x_component = 2*zdepth/sqrt((xwidth-xwidth2)*(xwidth-xwidth2)+4*zdepth*zdepth);
z_component = (xwidth-xwidth2)/sqrt(4*zdepth*zdepth+(xwidth-xwidth2)*(xwidth-xwidth2));

this_box_storage.normal_vectors[2] = coords_set(x_component,0,z_component);
this_box_storage.normal_vectors[3] = coords_set(-x_component,0,z_component);

// for sides with x component = 0
y_component = 2*zdepth/sqrt((yheight-yheight2)*(yheight-yheight2)+4*zdepth*zdepth);
z_component = (yheight-yheight2)/sqrt(4*zdepth*zdepth+(yheight-yheight2)*(yheight-yheight2));

this_box_storage.normal_vectors[4] = coords_set(0,y_component,z_component);
this_box_storage.normal_vectors[5] = coords_set(0,-y_component,z_component);

this_box_volume.geometry.visualization_on = visualize;

this_box_volume.geometry.geometry_parameters.p_box_storage = &this_box_storage;

// Assign pointers to functions for intersection with the shape, checking if a point is inside the shape
if (this_box_storage.is_rectangle == 1) {
this_box_volume.geometry.intersect_function = &sample_box_intersect_simple;
this_box_volume.geometry.within_function = &r_within_box_simple;
}
else {
this_box_volume.geometry.intersect_function = &sample_box_intersect_advanced;
this_box_volume.geometry.within_function = &r_within_box_advanced;
}

this_box_volume.geometry.shell_points = &box_shell_points;
this_box_volume.geometry.mcdisplay_function = &mcdisplay_box_function;
this_box_volume.geometry.initialize_from_main_function = &initialize_box_geometry_from_main_component;
this_box_volume.geometry.process_rot_allocated = 0;

this_box_volume.geometry.copy_geometry_parameters = &allocate_box_storage_copy;

rot_copy(this_box_volume.geometry.rotation_matrix,ROT_A_CURRENT_COMP); //check how ROT_R_CURRENT_COMP would work
rot_transpose(ROT_A_CURRENT_COMP,this_box_volume.geometry.transpose_rotation_matrix);

// Initialize loggers
this_box_volume.loggers.num_elements = 0;

// packing the information into the global_geometry_element, which is then included in the global_geometry_list.
sprintf(global_geometry_element.name,NAME_CURRENT_COMP);
global_geometry_element.activation_counter = number_of_activations;
global_geometry_element.component_index = INDEX_CURRENT_COMP;
global_geometry_element.Volume = &this_box_volume; // Would be nicer if this m was a pointer, now we have the (small) data two places
add_element_to_geometry_list(&global_geometry_list,global_geometry_element);
}
#line 259232 "MACS_sample_kidney_box.c"
#undef number_of_activations
#undef mask_setting
#undef mask_string
#undef p_interact
#undef focus_r
#undef focus_xh
#undef focus_xw
#undef focus_ah
#undef focus_aw
#undef target_z
#undef target_y
#undef target_x
#undef target_index
#undef visualize
#undef yheight2
#undef xwidth2
#undef zdepth
#undef yheight
#undef xwidth
#undef priority
#undef material_string
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

  /* Initializations for component channel_10_cave2_box3. */
  SIG_MESSAGE("channel_10_cave2_box3 (Init)");
#define mccompcurname  channel_10_cave2_box3
#define mccompcurtype  Union_box
#define mccompcurindex 533
#define loop_index mccchannel_10_cave2_box3_loop_index
#define this_box_volume mccchannel_10_cave2_box3_this_box_volume
#define global_geometry_element mccchannel_10_cave2_box3_global_geometry_element
#define this_box_storage mccchannel_10_cave2_box3_this_box_storage
#define material_string mccchannel_10_cave2_box3_material_string
#define priority mccchannel_10_cave2_box3_priority
#define xwidth mccchannel_10_cave2_box3_xwidth
#define yheight mccchannel_10_cave2_box3_yheight
#define zdepth mccchannel_10_cave2_box3_zdepth
#define xwidth2 mccchannel_10_cave2_box3_xwidth2
#define yheight2 mccchannel_10_cave2_box3_yheight2
#define visualize mccchannel_10_cave2_box3_visualize
#define target_index mccchannel_10_cave2_box3_target_index
#define target_x mccchannel_10_cave2_box3_target_x
#define target_y mccchannel_10_cave2_box3_target_y
#define target_z mccchannel_10_cave2_box3_target_z
#define focus_aw mccchannel_10_cave2_box3_focus_aw
#define focus_ah mccchannel_10_cave2_box3_focus_ah
#define focus_xw mccchannel_10_cave2_box3_focus_xw
#define focus_xh mccchannel_10_cave2_box3_focus_xh
#define focus_r mccchannel_10_cave2_box3_focus_r
#define p_interact mccchannel_10_cave2_box3_p_interact
#define mask_string mccchannel_10_cave2_box3_mask_string
#define mask_setting mccchannel_10_cave2_box3_mask_setting
#define number_of_activations mccchannel_10_cave2_box3_number_of_activations
#line 224 "Union_box.comp"
{
// Initializes the focusing system for this volume including input sanitation.
focus_initialize(&this_box_volume.geometry, POS_A_COMP_INDEX(INDEX_CURRENT_COMP+target_index), POS_A_CURRENT_COMP, ROT_A_CURRENT_COMP, target_index, target_x, target_y, target_z, focus_aw, focus_ah, focus_xw, focus_xh, focus_r, NAME_CURRENT_COMP);

// Input sanitation for this geometry
if (xwidth <= 0) {
  printf("\nERROR in Union_box named %s, the xwidth is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (yheight <= 0) {
  printf("\nERROR in Union_box named %s, yheight is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (zdepth <= 0) {
  printf("\nERROR in Union_box named %s, zdepth is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (xwidth2 <= 0 && xwidth2 != -1) {
  printf("\nERROR in Union_box named %s, the xwidth2 is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (yheight2 <= 0 && yheight2 != -1) {
  printf("\nERROR in Union_box named %s, yheight2 is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}

// Use sanitation
if (global_material_list.num_elements == 0) {
  printf("\nERROR: Need to define a material using Union_make_material before using a Union geometry component. \n");
  printf("       %s was defined before first use of Union_make_material.\n",NAME_CURRENT_COMP);
  exit(1);
}

this_box_volume.geometry.is_masked_volume = 0;
this_box_volume.geometry.is_exit_volume = 0;
this_box_volume.geometry.is_mask_volume = 0;
// check if the volume is a mask, if it is the material string is irelevant.
if (mask_string && strlen(mask_string) && strcmp(mask_string, "NULL") && strcmp(mask_string, "0")) {
    // A mask volume is used to limit the extend of other volumes, called the masked volumes. These are specified in the mask_string.
    // In order for a ray to enter a masked volume, it needs to be both in the region covered by that volume AND the mask volume.
    // When more than
    this_box_volume.geometry.mask_mode = 1; // Default is mask mode is ALL
    if (mask_setting && strlen(mask_setting) && strcmp(mask_setting, "NULL") && strcmp(mask_setting, "0")) {
        if (strcmp(mask_setting,"ALL") == 0 || strcmp(mask_setting,"All") == 0) this_box_volume.geometry.mask_mode = 1;
        else if (strcmp(mask_setting,"ANY") == 0 || strcmp(mask_setting,"Any") == 0) this_box_volume.geometry.mask_mode = 2;
        else {
            printf("The mask_mode of component %s is set to %s, but must be either ALL or ANY.\n",NAME_CURRENT_COMP,mask_setting);
            exit(1);
        }
    }
    
    for (loop_index=0;loop_index<global_geometry_list.num_elements;loop_index++) {
        // Add mask list
        if (1 == manual_linking_function(global_geometry_list.elements[loop_index].name,mask_string)) {
            add_element_to_int_list(&this_box_volume.geometry.mask_list,global_geometry_list.elements[loop_index].component_index);
            add_element_to_int_list(&global_geometry_list.elements[loop_index].Volume->geometry.masked_by_list,INDEX_CURRENT_COMP);
            global_geometry_list.elements[loop_index].Volume->geometry.is_masked_volume = 1;
            if (this_box_volume.geometry.mask_mode == 2)
                global_geometry_list.elements[loop_index].Volume->geometry.mask_mode = 2;
            if (this_box_volume.geometry.mask_mode == 1) {
                if (global_geometry_list.elements[loop_index].Volume->geometry.is_masked_volume == 1 && global_geometry_list.elements[loop_index].Volume->geometry.mask_mode != 2)
                    // If more than one mask is added to one volume, the ANY mode overwrites the (default) ALL mode.
                    global_geometry_list.elements[loop_index].Volume->geometry.mask_mode = 1;
            }
            
            found_geometries = 1;
        }
    }
    if (found_geometries == 0) {
        printf("The mask_string in geometry: %s did not find any of the specified volumes in the mask_string %s \n",NAME_CURRENT_COMP,mask_string);
        exit(1);
    }
    this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
    this_box_volume.p_physics->is_vacuum = 0; // Makes this volume a vacuum
    this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
    this_box_volume.p_physics->my_a = 0; // Should not be used.
    sprintf(this_box_volume.p_physics->name,"Mask");
    this_box_volume.geometry.is_mask_volume = 1;
    
    
// Read the material input, or if it lacks, use automatic linking.
} else if (material_string && strlen(material_string) && strcmp(material_string, "NULL") && strcmp(material_string, "0")) {
    // A geometry string was given, use it to determine which material
    if (0 == strcmp(material_string,"vacuum") || 0 == strcmp(material_string,"Vacuum")) {
        // One could have a global physics struct for vacuum instead of creating one for each
        this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
        this_box_volume.p_physics->is_vacuum = 1; // Makes this volume a vacuum
        this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
        this_box_volume.p_physics->my_a = 0; // Should not be used.
        sprintf(this_box_volume.p_physics->name,"Vacuum");
    } else if (0 == strcmp(material_string,"exit") || 0 == strcmp(material_string,"Exit")) {
        // One could have a global physics struct for vacuum instead of creating one for each
        this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
        this_box_volume.p_physics->is_vacuum = 1; // Makes this volume a vacuum
        this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
        this_box_volume.p_physics->my_a = 0; // Should not be used.
        this_box_volume.geometry.is_exit_volume = 1;
        sprintf(this_box_volume.p_physics->name,"Exit");
    } else {
        #ifndef MATERIAL_DETECTOR
            printf("Need to define a material before refering to it in a geometry %s.\n",NAME_CURRENT_COMP);
            exit(1);
        #endif
        for (loop_index=0;loop_index<global_material_list.num_elements;loop_index++) {
            if (0 == strcmp(material_string,global_material_list.elements[loop_index].name)) {
                this_box_volume.p_physics = global_material_list.elements[loop_index].physics;
                break;
            }
            if (loop_index == global_material_list.num_elements-1) {
            printf("\n");
            printf("ERROR: The material string \"%s\" in Union geometry \"%s\" did not match a specified material. \n",material_string,NAME_CURRENT_COMP);
            printf("       The materials available at this point (need to be defined before the geometry): \n");
            for (loop_index=0;loop_index<global_material_list.num_elements;loop_index++)
              printf("         %s\n",global_material_list.elements[loop_index].name);
            printf("\n");
            printf("       It is also possible to use one of the defualt materials avaiable: \n");
            printf("           Vacuum (for a Volume without scattering or absorption)\n");
            printf("           Exit (for a Volume where the ray exits the component if it enters)\n");
            printf("           Mask (for a Volume that masks existing volumes specified in the mask_string\n");
            exit(1);
          }
        }
    }
} else {
    // Automatic linking, simply using the last defined material.
    #ifndef MATERIAL_DETECTOR
        printf("Need to define a material before the geometry to use automatic linking %s.\n",NAME_CURRENT_COMP);
        exit(1);
    #endif
    this_box_volume.p_physics = global_material_list.elements[global_material_list.num_elements-1].physics;
}

sprintf(this_box_volume.name,NAME_CURRENT_COMP);
sprintf(this_box_volume.geometry.shape,"box");
this_box_volume.geometry.priority_value = priority;
this_box_volume.geometry.geometry_p_interact = p_interact;
// Currently the coordinates will be in absolute space.
this_box_volume.geometry.center = POS_A_CURRENT_COMP;

this_box_storage.z_depth = zdepth;
this_box_storage.x_width1 = xwidth;
this_box_storage.y_height1 = yheight;

this_box_storage.is_rectangle = 0;
if (xwidth2 < 0 && yheight2 < 0) this_box_storage.is_rectangle = 1;
if (xwidth == xwidth2 && yheight == yheight2) this_box_storage.is_rectangle = 1;

if (xwidth2 < 0) {
    this_box_storage.x_width2 = xwidth;
    xwidth2 = xwidth;
} else this_box_storage.x_width2 = xwidth2;

if (yheight2 < 0) {
    this_box_storage.y_height2 = yheight;
    yheight2 = yheight;
} else this_box_storage.y_height2 = yheight2;


this_box_storage.normal_vectors[0] = coords_set(0,0,1);
this_box_storage.normal_vectors[1] = coords_set(0,0,1);

// for sides with y component = 0
x_component = 2*zdepth/sqrt((xwidth-xwidth2)*(xwidth-xwidth2)+4*zdepth*zdepth);
z_component = (xwidth-xwidth2)/sqrt(4*zdepth*zdepth+(xwidth-xwidth2)*(xwidth-xwidth2));

this_box_storage.normal_vectors[2] = coords_set(x_component,0,z_component);
this_box_storage.normal_vectors[3] = coords_set(-x_component,0,z_component);

// for sides with x component = 0
y_component = 2*zdepth/sqrt((yheight-yheight2)*(yheight-yheight2)+4*zdepth*zdepth);
z_component = (yheight-yheight2)/sqrt(4*zdepth*zdepth+(yheight-yheight2)*(yheight-yheight2));

this_box_storage.normal_vectors[4] = coords_set(0,y_component,z_component);
this_box_storage.normal_vectors[5] = coords_set(0,-y_component,z_component);

this_box_volume.geometry.visualization_on = visualize;

this_box_volume.geometry.geometry_parameters.p_box_storage = &this_box_storage;

// Assign pointers to functions for intersection with the shape, checking if a point is inside the shape
if (this_box_storage.is_rectangle == 1) {
this_box_volume.geometry.intersect_function = &sample_box_intersect_simple;
this_box_volume.geometry.within_function = &r_within_box_simple;
}
else {
this_box_volume.geometry.intersect_function = &sample_box_intersect_advanced;
this_box_volume.geometry.within_function = &r_within_box_advanced;
}

this_box_volume.geometry.shell_points = &box_shell_points;
this_box_volume.geometry.mcdisplay_function = &mcdisplay_box_function;
this_box_volume.geometry.initialize_from_main_function = &initialize_box_geometry_from_main_component;
this_box_volume.geometry.process_rot_allocated = 0;

this_box_volume.geometry.copy_geometry_parameters = &allocate_box_storage_copy;

rot_copy(this_box_volume.geometry.rotation_matrix,ROT_A_CURRENT_COMP); //check how ROT_R_CURRENT_COMP would work
rot_transpose(ROT_A_CURRENT_COMP,this_box_volume.geometry.transpose_rotation_matrix);

// Initialize loggers
this_box_volume.loggers.num_elements = 0;

// packing the information into the global_geometry_element, which is then included in the global_geometry_list.
sprintf(global_geometry_element.name,NAME_CURRENT_COMP);
global_geometry_element.activation_counter = number_of_activations;
global_geometry_element.component_index = INDEX_CURRENT_COMP;
global_geometry_element.Volume = &this_box_volume; // Would be nicer if this m was a pointer, now we have the (small) data two places
add_element_to_geometry_list(&global_geometry_list,global_geometry_element);
}
#line 259502 "MACS_sample_kidney_box.c"
#undef number_of_activations
#undef mask_setting
#undef mask_string
#undef p_interact
#undef focus_r
#undef focus_xh
#undef focus_xw
#undef focus_ah
#undef focus_aw
#undef target_z
#undef target_y
#undef target_x
#undef target_index
#undef visualize
#undef yheight2
#undef xwidth2
#undef zdepth
#undef yheight
#undef xwidth
#undef priority
#undef material_string
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

  /* Initializations for component inter_analyzer_colimator_center_10. */
  SIG_MESSAGE("inter_analyzer_colimator_center_10 (Init)");

  /* Initializations for component inter_analyzer_colimator_10_blade_0. */
  SIG_MESSAGE("inter_analyzer_colimator_10_blade_0 (Init)");
#define mccompcurname  inter_analyzer_colimator_10_blade_0
#define mccompcurtype  Union_box
#define mccompcurindex 535
#define loop_index mccinter_analyzer_colimator_10_blade_0_loop_index
#define this_box_volume mccinter_analyzer_colimator_10_blade_0_this_box_volume
#define global_geometry_element mccinter_analyzer_colimator_10_blade_0_global_geometry_element
#define this_box_storage mccinter_analyzer_colimator_10_blade_0_this_box_storage
#define material_string mccinter_analyzer_colimator_10_blade_0_material_string
#define priority mccinter_analyzer_colimator_10_blade_0_priority
#define xwidth mccinter_analyzer_colimator_10_blade_0_xwidth
#define yheight mccinter_analyzer_colimator_10_blade_0_yheight
#define zdepth mccinter_analyzer_colimator_10_blade_0_zdepth
#define xwidth2 mccinter_analyzer_colimator_10_blade_0_xwidth2
#define yheight2 mccinter_analyzer_colimator_10_blade_0_yheight2
#define visualize mccinter_analyzer_colimator_10_blade_0_visualize
#define target_index mccinter_analyzer_colimator_10_blade_0_target_index
#define target_x mccinter_analyzer_colimator_10_blade_0_target_x
#define target_y mccinter_analyzer_colimator_10_blade_0_target_y
#define target_z mccinter_analyzer_colimator_10_blade_0_target_z
#define focus_aw mccinter_analyzer_colimator_10_blade_0_focus_aw
#define focus_ah mccinter_analyzer_colimator_10_blade_0_focus_ah
#define focus_xw mccinter_analyzer_colimator_10_blade_0_focus_xw
#define focus_xh mccinter_analyzer_colimator_10_blade_0_focus_xh
#define focus_r mccinter_analyzer_colimator_10_blade_0_focus_r
#define p_interact mccinter_analyzer_colimator_10_blade_0_p_interact
#define mask_string mccinter_analyzer_colimator_10_blade_0_mask_string
#define mask_setting mccinter_analyzer_colimator_10_blade_0_mask_setting
#define number_of_activations mccinter_analyzer_colimator_10_blade_0_number_of_activations
#line 224 "Union_box.comp"
{
// Initializes the focusing system for this volume including input sanitation.
focus_initialize(&this_box_volume.geometry, POS_A_COMP_INDEX(INDEX_CURRENT_COMP+target_index), POS_A_CURRENT_COMP, ROT_A_CURRENT_COMP, target_index, target_x, target_y, target_z, focus_aw, focus_ah, focus_xw, focus_xh, focus_r, NAME_CURRENT_COMP);

// Input sanitation for this geometry
if (xwidth <= 0) {
  printf("\nERROR in Union_box named %s, the xwidth is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (yheight <= 0) {
  printf("\nERROR in Union_box named %s, yheight is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (zdepth <= 0) {
  printf("\nERROR in Union_box named %s, zdepth is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (xwidth2 <= 0 && xwidth2 != -1) {
  printf("\nERROR in Union_box named %s, the xwidth2 is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (yheight2 <= 0 && yheight2 != -1) {
  printf("\nERROR in Union_box named %s, yheight2 is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}

// Use sanitation
if (global_material_list.num_elements == 0) {
  printf("\nERROR: Need to define a material using Union_make_material before using a Union geometry component. \n");
  printf("       %s was defined before first use of Union_make_material.\n",NAME_CURRENT_COMP);
  exit(1);
}

this_box_volume.geometry.is_masked_volume = 0;
this_box_volume.geometry.is_exit_volume = 0;
this_box_volume.geometry.is_mask_volume = 0;
// check if the volume is a mask, if it is the material string is irelevant.
if (mask_string && strlen(mask_string) && strcmp(mask_string, "NULL") && strcmp(mask_string, "0")) {
    // A mask volume is used to limit the extend of other volumes, called the masked volumes. These are specified in the mask_string.
    // In order for a ray to enter a masked volume, it needs to be both in the region covered by that volume AND the mask volume.
    // When more than
    this_box_volume.geometry.mask_mode = 1; // Default is mask mode is ALL
    if (mask_setting && strlen(mask_setting) && strcmp(mask_setting, "NULL") && strcmp(mask_setting, "0")) {
        if (strcmp(mask_setting,"ALL") == 0 || strcmp(mask_setting,"All") == 0) this_box_volume.geometry.mask_mode = 1;
        else if (strcmp(mask_setting,"ANY") == 0 || strcmp(mask_setting,"Any") == 0) this_box_volume.geometry.mask_mode = 2;
        else {
            printf("The mask_mode of component %s is set to %s, but must be either ALL or ANY.\n",NAME_CURRENT_COMP,mask_setting);
            exit(1);
        }
    }
    
    for (loop_index=0;loop_index<global_geometry_list.num_elements;loop_index++) {
        // Add mask list
        if (1 == manual_linking_function(global_geometry_list.elements[loop_index].name,mask_string)) {
            add_element_to_int_list(&this_box_volume.geometry.mask_list,global_geometry_list.elements[loop_index].component_index);
            add_element_to_int_list(&global_geometry_list.elements[loop_index].Volume->geometry.masked_by_list,INDEX_CURRENT_COMP);
            global_geometry_list.elements[loop_index].Volume->geometry.is_masked_volume = 1;
            if (this_box_volume.geometry.mask_mode == 2)
                global_geometry_list.elements[loop_index].Volume->geometry.mask_mode = 2;
            if (this_box_volume.geometry.mask_mode == 1) {
                if (global_geometry_list.elements[loop_index].Volume->geometry.is_masked_volume == 1 && global_geometry_list.elements[loop_index].Volume->geometry.mask_mode != 2)
                    // If more than one mask is added to one volume, the ANY mode overwrites the (default) ALL mode.
                    global_geometry_list.elements[loop_index].Volume->geometry.mask_mode = 1;
            }
            
            found_geometries = 1;
        }
    }
    if (found_geometries == 0) {
        printf("The mask_string in geometry: %s did not find any of the specified volumes in the mask_string %s \n",NAME_CURRENT_COMP,mask_string);
        exit(1);
    }
    this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
    this_box_volume.p_physics->is_vacuum = 0; // Makes this volume a vacuum
    this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
    this_box_volume.p_physics->my_a = 0; // Should not be used.
    sprintf(this_box_volume.p_physics->name,"Mask");
    this_box_volume.geometry.is_mask_volume = 1;
    
    
// Read the material input, or if it lacks, use automatic linking.
} else if (material_string && strlen(material_string) && strcmp(material_string, "NULL") && strcmp(material_string, "0")) {
    // A geometry string was given, use it to determine which material
    if (0 == strcmp(material_string,"vacuum") || 0 == strcmp(material_string,"Vacuum")) {
        // One could have a global physics struct for vacuum instead of creating one for each
        this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
        this_box_volume.p_physics->is_vacuum = 1; // Makes this volume a vacuum
        this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
        this_box_volume.p_physics->my_a = 0; // Should not be used.
        sprintf(this_box_volume.p_physics->name,"Vacuum");
    } else if (0 == strcmp(material_string,"exit") || 0 == strcmp(material_string,"Exit")) {
        // One could have a global physics struct for vacuum instead of creating one for each
        this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
        this_box_volume.p_physics->is_vacuum = 1; // Makes this volume a vacuum
        this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
        this_box_volume.p_physics->my_a = 0; // Should not be used.
        this_box_volume.geometry.is_exit_volume = 1;
        sprintf(this_box_volume.p_physics->name,"Exit");
    } else {
        #ifndef MATERIAL_DETECTOR
            printf("Need to define a material before refering to it in a geometry %s.\n",NAME_CURRENT_COMP);
            exit(1);
        #endif
        for (loop_index=0;loop_index<global_material_list.num_elements;loop_index++) {
            if (0 == strcmp(material_string,global_material_list.elements[loop_index].name)) {
                this_box_volume.p_physics = global_material_list.elements[loop_index].physics;
                break;
            }
            if (loop_index == global_material_list.num_elements-1) {
            printf("\n");
            printf("ERROR: The material string \"%s\" in Union geometry \"%s\" did not match a specified material. \n",material_string,NAME_CURRENT_COMP);
            printf("       The materials available at this point (need to be defined before the geometry): \n");
            for (loop_index=0;loop_index<global_material_list.num_elements;loop_index++)
              printf("         %s\n",global_material_list.elements[loop_index].name);
            printf("\n");
            printf("       It is also possible to use one of the defualt materials avaiable: \n");
            printf("           Vacuum (for a Volume without scattering or absorption)\n");
            printf("           Exit (for a Volume where the ray exits the component if it enters)\n");
            printf("           Mask (for a Volume that masks existing volumes specified in the mask_string\n");
            exit(1);
          }
        }
    }
} else {
    // Automatic linking, simply using the last defined material.
    #ifndef MATERIAL_DETECTOR
        printf("Need to define a material before the geometry to use automatic linking %s.\n",NAME_CURRENT_COMP);
        exit(1);
    #endif
    this_box_volume.p_physics = global_material_list.elements[global_material_list.num_elements-1].physics;
}

sprintf(this_box_volume.name,NAME_CURRENT_COMP);
sprintf(this_box_volume.geometry.shape,"box");
this_box_volume.geometry.priority_value = priority;
this_box_volume.geometry.geometry_p_interact = p_interact;
// Currently the coordinates will be in absolute space.
this_box_volume.geometry.center = POS_A_CURRENT_COMP;

this_box_storage.z_depth = zdepth;
this_box_storage.x_width1 = xwidth;
this_box_storage.y_height1 = yheight;

this_box_storage.is_rectangle = 0;
if (xwidth2 < 0 && yheight2 < 0) this_box_storage.is_rectangle = 1;
if (xwidth == xwidth2 && yheight == yheight2) this_box_storage.is_rectangle = 1;

if (xwidth2 < 0) {
    this_box_storage.x_width2 = xwidth;
    xwidth2 = xwidth;
} else this_box_storage.x_width2 = xwidth2;

if (yheight2 < 0) {
    this_box_storage.y_height2 = yheight;
    yheight2 = yheight;
} else this_box_storage.y_height2 = yheight2;


this_box_storage.normal_vectors[0] = coords_set(0,0,1);
this_box_storage.normal_vectors[1] = coords_set(0,0,1);

// for sides with y component = 0
x_component = 2*zdepth/sqrt((xwidth-xwidth2)*(xwidth-xwidth2)+4*zdepth*zdepth);
z_component = (xwidth-xwidth2)/sqrt(4*zdepth*zdepth+(xwidth-xwidth2)*(xwidth-xwidth2));

this_box_storage.normal_vectors[2] = coords_set(x_component,0,z_component);
this_box_storage.normal_vectors[3] = coords_set(-x_component,0,z_component);

// for sides with x component = 0
y_component = 2*zdepth/sqrt((yheight-yheight2)*(yheight-yheight2)+4*zdepth*zdepth);
z_component = (yheight-yheight2)/sqrt(4*zdepth*zdepth+(yheight-yheight2)*(yheight-yheight2));

this_box_storage.normal_vectors[4] = coords_set(0,y_component,z_component);
this_box_storage.normal_vectors[5] = coords_set(0,-y_component,z_component);

this_box_volume.geometry.visualization_on = visualize;

this_box_volume.geometry.geometry_parameters.p_box_storage = &this_box_storage;

// Assign pointers to functions for intersection with the shape, checking if a point is inside the shape
if (this_box_storage.is_rectangle == 1) {
this_box_volume.geometry.intersect_function = &sample_box_intersect_simple;
this_box_volume.geometry.within_function = &r_within_box_simple;
}
else {
this_box_volume.geometry.intersect_function = &sample_box_intersect_advanced;
this_box_volume.geometry.within_function = &r_within_box_advanced;
}

this_box_volume.geometry.shell_points = &box_shell_points;
this_box_volume.geometry.mcdisplay_function = &mcdisplay_box_function;
this_box_volume.geometry.initialize_from_main_function = &initialize_box_geometry_from_main_component;
this_box_volume.geometry.process_rot_allocated = 0;

this_box_volume.geometry.copy_geometry_parameters = &allocate_box_storage_copy;

rot_copy(this_box_volume.geometry.rotation_matrix,ROT_A_CURRENT_COMP); //check how ROT_R_CURRENT_COMP would work
rot_transpose(ROT_A_CURRENT_COMP,this_box_volume.geometry.transpose_rotation_matrix);

// Initialize loggers
this_box_volume.loggers.num_elements = 0;

// packing the information into the global_geometry_element, which is then included in the global_geometry_list.
sprintf(global_geometry_element.name,NAME_CURRENT_COMP);
global_geometry_element.activation_counter = number_of_activations;
global_geometry_element.component_index = INDEX_CURRENT_COMP;
global_geometry_element.Volume = &this_box_volume; // Would be nicer if this m was a pointer, now we have the (small) data two places
add_element_to_geometry_list(&global_geometry_list,global_geometry_element);
}
#line 259775 "MACS_sample_kidney_box.c"
#undef number_of_activations
#undef mask_setting
#undef mask_string
#undef p_interact
#undef focus_r
#undef focus_xh
#undef focus_xw
#undef focus_ah
#undef focus_aw
#undef target_z
#undef target_y
#undef target_x
#undef target_index
#undef visualize
#undef yheight2
#undef xwidth2
#undef zdepth
#undef yheight
#undef xwidth
#undef priority
#undef material_string
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

  /* Initializations for component inter_analyzer_colimator_10_blade_1. */
  SIG_MESSAGE("inter_analyzer_colimator_10_blade_1 (Init)");
#define mccompcurname  inter_analyzer_colimator_10_blade_1
#define mccompcurtype  Union_box
#define mccompcurindex 536
#define loop_index mccinter_analyzer_colimator_10_blade_1_loop_index
#define this_box_volume mccinter_analyzer_colimator_10_blade_1_this_box_volume
#define global_geometry_element mccinter_analyzer_colimator_10_blade_1_global_geometry_element
#define this_box_storage mccinter_analyzer_colimator_10_blade_1_this_box_storage
#define material_string mccinter_analyzer_colimator_10_blade_1_material_string
#define priority mccinter_analyzer_colimator_10_blade_1_priority
#define xwidth mccinter_analyzer_colimator_10_blade_1_xwidth
#define yheight mccinter_analyzer_colimator_10_blade_1_yheight
#define zdepth mccinter_analyzer_colimator_10_blade_1_zdepth
#define xwidth2 mccinter_analyzer_colimator_10_blade_1_xwidth2
#define yheight2 mccinter_analyzer_colimator_10_blade_1_yheight2
#define visualize mccinter_analyzer_colimator_10_blade_1_visualize
#define target_index mccinter_analyzer_colimator_10_blade_1_target_index
#define target_x mccinter_analyzer_colimator_10_blade_1_target_x
#define target_y mccinter_analyzer_colimator_10_blade_1_target_y
#define target_z mccinter_analyzer_colimator_10_blade_1_target_z
#define focus_aw mccinter_analyzer_colimator_10_blade_1_focus_aw
#define focus_ah mccinter_analyzer_colimator_10_blade_1_focus_ah
#define focus_xw mccinter_analyzer_colimator_10_blade_1_focus_xw
#define focus_xh mccinter_analyzer_colimator_10_blade_1_focus_xh
#define focus_r mccinter_analyzer_colimator_10_blade_1_focus_r
#define p_interact mccinter_analyzer_colimator_10_blade_1_p_interact
#define mask_string mccinter_analyzer_colimator_10_blade_1_mask_string
#define mask_setting mccinter_analyzer_colimator_10_blade_1_mask_setting
#define number_of_activations mccinter_analyzer_colimator_10_blade_1_number_of_activations
#line 224 "Union_box.comp"
{
// Initializes the focusing system for this volume including input sanitation.
focus_initialize(&this_box_volume.geometry, POS_A_COMP_INDEX(INDEX_CURRENT_COMP+target_index), POS_A_CURRENT_COMP, ROT_A_CURRENT_COMP, target_index, target_x, target_y, target_z, focus_aw, focus_ah, focus_xw, focus_xh, focus_r, NAME_CURRENT_COMP);

// Input sanitation for this geometry
if (xwidth <= 0) {
  printf("\nERROR in Union_box named %s, the xwidth is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (yheight <= 0) {
  printf("\nERROR in Union_box named %s, yheight is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (zdepth <= 0) {
  printf("\nERROR in Union_box named %s, zdepth is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (xwidth2 <= 0 && xwidth2 != -1) {
  printf("\nERROR in Union_box named %s, the xwidth2 is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (yheight2 <= 0 && yheight2 != -1) {
  printf("\nERROR in Union_box named %s, yheight2 is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}

// Use sanitation
if (global_material_list.num_elements == 0) {
  printf("\nERROR: Need to define a material using Union_make_material before using a Union geometry component. \n");
  printf("       %s was defined before first use of Union_make_material.\n",NAME_CURRENT_COMP);
  exit(1);
}

this_box_volume.geometry.is_masked_volume = 0;
this_box_volume.geometry.is_exit_volume = 0;
this_box_volume.geometry.is_mask_volume = 0;
// check if the volume is a mask, if it is the material string is irelevant.
if (mask_string && strlen(mask_string) && strcmp(mask_string, "NULL") && strcmp(mask_string, "0")) {
    // A mask volume is used to limit the extend of other volumes, called the masked volumes. These are specified in the mask_string.
    // In order for a ray to enter a masked volume, it needs to be both in the region covered by that volume AND the mask volume.
    // When more than
    this_box_volume.geometry.mask_mode = 1; // Default is mask mode is ALL
    if (mask_setting && strlen(mask_setting) && strcmp(mask_setting, "NULL") && strcmp(mask_setting, "0")) {
        if (strcmp(mask_setting,"ALL") == 0 || strcmp(mask_setting,"All") == 0) this_box_volume.geometry.mask_mode = 1;
        else if (strcmp(mask_setting,"ANY") == 0 || strcmp(mask_setting,"Any") == 0) this_box_volume.geometry.mask_mode = 2;
        else {
            printf("The mask_mode of component %s is set to %s, but must be either ALL or ANY.\n",NAME_CURRENT_COMP,mask_setting);
            exit(1);
        }
    }
    
    for (loop_index=0;loop_index<global_geometry_list.num_elements;loop_index++) {
        // Add mask list
        if (1 == manual_linking_function(global_geometry_list.elements[loop_index].name,mask_string)) {
            add_element_to_int_list(&this_box_volume.geometry.mask_list,global_geometry_list.elements[loop_index].component_index);
            add_element_to_int_list(&global_geometry_list.elements[loop_index].Volume->geometry.masked_by_list,INDEX_CURRENT_COMP);
            global_geometry_list.elements[loop_index].Volume->geometry.is_masked_volume = 1;
            if (this_box_volume.geometry.mask_mode == 2)
                global_geometry_list.elements[loop_index].Volume->geometry.mask_mode = 2;
            if (this_box_volume.geometry.mask_mode == 1) {
                if (global_geometry_list.elements[loop_index].Volume->geometry.is_masked_volume == 1 && global_geometry_list.elements[loop_index].Volume->geometry.mask_mode != 2)
                    // If more than one mask is added to one volume, the ANY mode overwrites the (default) ALL mode.
                    global_geometry_list.elements[loop_index].Volume->geometry.mask_mode = 1;
            }
            
            found_geometries = 1;
        }
    }
    if (found_geometries == 0) {
        printf("The mask_string in geometry: %s did not find any of the specified volumes in the mask_string %s \n",NAME_CURRENT_COMP,mask_string);
        exit(1);
    }
    this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
    this_box_volume.p_physics->is_vacuum = 0; // Makes this volume a vacuum
    this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
    this_box_volume.p_physics->my_a = 0; // Should not be used.
    sprintf(this_box_volume.p_physics->name,"Mask");
    this_box_volume.geometry.is_mask_volume = 1;
    
    
// Read the material input, or if it lacks, use automatic linking.
} else if (material_string && strlen(material_string) && strcmp(material_string, "NULL") && strcmp(material_string, "0")) {
    // A geometry string was given, use it to determine which material
    if (0 == strcmp(material_string,"vacuum") || 0 == strcmp(material_string,"Vacuum")) {
        // One could have a global physics struct for vacuum instead of creating one for each
        this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
        this_box_volume.p_physics->is_vacuum = 1; // Makes this volume a vacuum
        this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
        this_box_volume.p_physics->my_a = 0; // Should not be used.
        sprintf(this_box_volume.p_physics->name,"Vacuum");
    } else if (0 == strcmp(material_string,"exit") || 0 == strcmp(material_string,"Exit")) {
        // One could have a global physics struct for vacuum instead of creating one for each
        this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
        this_box_volume.p_physics->is_vacuum = 1; // Makes this volume a vacuum
        this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
        this_box_volume.p_physics->my_a = 0; // Should not be used.
        this_box_volume.geometry.is_exit_volume = 1;
        sprintf(this_box_volume.p_physics->name,"Exit");
    } else {
        #ifndef MATERIAL_DETECTOR
            printf("Need to define a material before refering to it in a geometry %s.\n",NAME_CURRENT_COMP);
            exit(1);
        #endif
        for (loop_index=0;loop_index<global_material_list.num_elements;loop_index++) {
            if (0 == strcmp(material_string,global_material_list.elements[loop_index].name)) {
                this_box_volume.p_physics = global_material_list.elements[loop_index].physics;
                break;
            }
            if (loop_index == global_material_list.num_elements-1) {
            printf("\n");
            printf("ERROR: The material string \"%s\" in Union geometry \"%s\" did not match a specified material. \n",material_string,NAME_CURRENT_COMP);
            printf("       The materials available at this point (need to be defined before the geometry): \n");
            for (loop_index=0;loop_index<global_material_list.num_elements;loop_index++)
              printf("         %s\n",global_material_list.elements[loop_index].name);
            printf("\n");
            printf("       It is also possible to use one of the defualt materials avaiable: \n");
            printf("           Vacuum (for a Volume without scattering or absorption)\n");
            printf("           Exit (for a Volume where the ray exits the component if it enters)\n");
            printf("           Mask (for a Volume that masks existing volumes specified in the mask_string\n");
            exit(1);
          }
        }
    }
} else {
    // Automatic linking, simply using the last defined material.
    #ifndef MATERIAL_DETECTOR
        printf("Need to define a material before the geometry to use automatic linking %s.\n",NAME_CURRENT_COMP);
        exit(1);
    #endif
    this_box_volume.p_physics = global_material_list.elements[global_material_list.num_elements-1].physics;
}

sprintf(this_box_volume.name,NAME_CURRENT_COMP);
sprintf(this_box_volume.geometry.shape,"box");
this_box_volume.geometry.priority_value = priority;
this_box_volume.geometry.geometry_p_interact = p_interact;
// Currently the coordinates will be in absolute space.
this_box_volume.geometry.center = POS_A_CURRENT_COMP;

this_box_storage.z_depth = zdepth;
this_box_storage.x_width1 = xwidth;
this_box_storage.y_height1 = yheight;

this_box_storage.is_rectangle = 0;
if (xwidth2 < 0 && yheight2 < 0) this_box_storage.is_rectangle = 1;
if (xwidth == xwidth2 && yheight == yheight2) this_box_storage.is_rectangle = 1;

if (xwidth2 < 0) {
    this_box_storage.x_width2 = xwidth;
    xwidth2 = xwidth;
} else this_box_storage.x_width2 = xwidth2;

if (yheight2 < 0) {
    this_box_storage.y_height2 = yheight;
    yheight2 = yheight;
} else this_box_storage.y_height2 = yheight2;


this_box_storage.normal_vectors[0] = coords_set(0,0,1);
this_box_storage.normal_vectors[1] = coords_set(0,0,1);

// for sides with y component = 0
x_component = 2*zdepth/sqrt((xwidth-xwidth2)*(xwidth-xwidth2)+4*zdepth*zdepth);
z_component = (xwidth-xwidth2)/sqrt(4*zdepth*zdepth+(xwidth-xwidth2)*(xwidth-xwidth2));

this_box_storage.normal_vectors[2] = coords_set(x_component,0,z_component);
this_box_storage.normal_vectors[3] = coords_set(-x_component,0,z_component);

// for sides with x component = 0
y_component = 2*zdepth/sqrt((yheight-yheight2)*(yheight-yheight2)+4*zdepth*zdepth);
z_component = (yheight-yheight2)/sqrt(4*zdepth*zdepth+(yheight-yheight2)*(yheight-yheight2));

this_box_storage.normal_vectors[4] = coords_set(0,y_component,z_component);
this_box_storage.normal_vectors[5] = coords_set(0,-y_component,z_component);

this_box_volume.geometry.visualization_on = visualize;

this_box_volume.geometry.geometry_parameters.p_box_storage = &this_box_storage;

// Assign pointers to functions for intersection with the shape, checking if a point is inside the shape
if (this_box_storage.is_rectangle == 1) {
this_box_volume.geometry.intersect_function = &sample_box_intersect_simple;
this_box_volume.geometry.within_function = &r_within_box_simple;
}
else {
this_box_volume.geometry.intersect_function = &sample_box_intersect_advanced;
this_box_volume.geometry.within_function = &r_within_box_advanced;
}

this_box_volume.geometry.shell_points = &box_shell_points;
this_box_volume.geometry.mcdisplay_function = &mcdisplay_box_function;
this_box_volume.geometry.initialize_from_main_function = &initialize_box_geometry_from_main_component;
this_box_volume.geometry.process_rot_allocated = 0;

this_box_volume.geometry.copy_geometry_parameters = &allocate_box_storage_copy;

rot_copy(this_box_volume.geometry.rotation_matrix,ROT_A_CURRENT_COMP); //check how ROT_R_CURRENT_COMP would work
rot_transpose(ROT_A_CURRENT_COMP,this_box_volume.geometry.transpose_rotation_matrix);

// Initialize loggers
this_box_volume.loggers.num_elements = 0;

// packing the information into the global_geometry_element, which is then included in the global_geometry_list.
sprintf(global_geometry_element.name,NAME_CURRENT_COMP);
global_geometry_element.activation_counter = number_of_activations;
global_geometry_element.component_index = INDEX_CURRENT_COMP;
global_geometry_element.Volume = &this_box_volume; // Would be nicer if this m was a pointer, now we have the (small) data two places
add_element_to_geometry_list(&global_geometry_list,global_geometry_element);
}
#line 260045 "MACS_sample_kidney_box.c"
#undef number_of_activations
#undef mask_setting
#undef mask_string
#undef p_interact
#undef focus_r
#undef focus_xh
#undef focus_xw
#undef focus_ah
#undef focus_aw
#undef target_z
#undef target_y
#undef target_x
#undef target_index
#undef visualize
#undef yheight2
#undef xwidth2
#undef zdepth
#undef yheight
#undef xwidth
#undef priority
#undef material_string
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

  /* Initializations for component inter_analyzer_colimator_10_blade_2. */
  SIG_MESSAGE("inter_analyzer_colimator_10_blade_2 (Init)");
#define mccompcurname  inter_analyzer_colimator_10_blade_2
#define mccompcurtype  Union_box
#define mccompcurindex 537
#define loop_index mccinter_analyzer_colimator_10_blade_2_loop_index
#define this_box_volume mccinter_analyzer_colimator_10_blade_2_this_box_volume
#define global_geometry_element mccinter_analyzer_colimator_10_blade_2_global_geometry_element
#define this_box_storage mccinter_analyzer_colimator_10_blade_2_this_box_storage
#define material_string mccinter_analyzer_colimator_10_blade_2_material_string
#define priority mccinter_analyzer_colimator_10_blade_2_priority
#define xwidth mccinter_analyzer_colimator_10_blade_2_xwidth
#define yheight mccinter_analyzer_colimator_10_blade_2_yheight
#define zdepth mccinter_analyzer_colimator_10_blade_2_zdepth
#define xwidth2 mccinter_analyzer_colimator_10_blade_2_xwidth2
#define yheight2 mccinter_analyzer_colimator_10_blade_2_yheight2
#define visualize mccinter_analyzer_colimator_10_blade_2_visualize
#define target_index mccinter_analyzer_colimator_10_blade_2_target_index
#define target_x mccinter_analyzer_colimator_10_blade_2_target_x
#define target_y mccinter_analyzer_colimator_10_blade_2_target_y
#define target_z mccinter_analyzer_colimator_10_blade_2_target_z
#define focus_aw mccinter_analyzer_colimator_10_blade_2_focus_aw
#define focus_ah mccinter_analyzer_colimator_10_blade_2_focus_ah
#define focus_xw mccinter_analyzer_colimator_10_blade_2_focus_xw
#define focus_xh mccinter_analyzer_colimator_10_blade_2_focus_xh
#define focus_r mccinter_analyzer_colimator_10_blade_2_focus_r
#define p_interact mccinter_analyzer_colimator_10_blade_2_p_interact
#define mask_string mccinter_analyzer_colimator_10_blade_2_mask_string
#define mask_setting mccinter_analyzer_colimator_10_blade_2_mask_setting
#define number_of_activations mccinter_analyzer_colimator_10_blade_2_number_of_activations
#line 224 "Union_box.comp"
{
// Initializes the focusing system for this volume including input sanitation.
focus_initialize(&this_box_volume.geometry, POS_A_COMP_INDEX(INDEX_CURRENT_COMP+target_index), POS_A_CURRENT_COMP, ROT_A_CURRENT_COMP, target_index, target_x, target_y, target_z, focus_aw, focus_ah, focus_xw, focus_xh, focus_r, NAME_CURRENT_COMP);

// Input sanitation for this geometry
if (xwidth <= 0) {
  printf("\nERROR in Union_box named %s, the xwidth is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (yheight <= 0) {
  printf("\nERROR in Union_box named %s, yheight is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (zdepth <= 0) {
  printf("\nERROR in Union_box named %s, zdepth is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (xwidth2 <= 0 && xwidth2 != -1) {
  printf("\nERROR in Union_box named %s, the xwidth2 is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (yheight2 <= 0 && yheight2 != -1) {
  printf("\nERROR in Union_box named %s, yheight2 is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}

// Use sanitation
if (global_material_list.num_elements == 0) {
  printf("\nERROR: Need to define a material using Union_make_material before using a Union geometry component. \n");
  printf("       %s was defined before first use of Union_make_material.\n",NAME_CURRENT_COMP);
  exit(1);
}

this_box_volume.geometry.is_masked_volume = 0;
this_box_volume.geometry.is_exit_volume = 0;
this_box_volume.geometry.is_mask_volume = 0;
// check if the volume is a mask, if it is the material string is irelevant.
if (mask_string && strlen(mask_string) && strcmp(mask_string, "NULL") && strcmp(mask_string, "0")) {
    // A mask volume is used to limit the extend of other volumes, called the masked volumes. These are specified in the mask_string.
    // In order for a ray to enter a masked volume, it needs to be both in the region covered by that volume AND the mask volume.
    // When more than
    this_box_volume.geometry.mask_mode = 1; // Default is mask mode is ALL
    if (mask_setting && strlen(mask_setting) && strcmp(mask_setting, "NULL") && strcmp(mask_setting, "0")) {
        if (strcmp(mask_setting,"ALL") == 0 || strcmp(mask_setting,"All") == 0) this_box_volume.geometry.mask_mode = 1;
        else if (strcmp(mask_setting,"ANY") == 0 || strcmp(mask_setting,"Any") == 0) this_box_volume.geometry.mask_mode = 2;
        else {
            printf("The mask_mode of component %s is set to %s, but must be either ALL or ANY.\n",NAME_CURRENT_COMP,mask_setting);
            exit(1);
        }
    }
    
    for (loop_index=0;loop_index<global_geometry_list.num_elements;loop_index++) {
        // Add mask list
        if (1 == manual_linking_function(global_geometry_list.elements[loop_index].name,mask_string)) {
            add_element_to_int_list(&this_box_volume.geometry.mask_list,global_geometry_list.elements[loop_index].component_index);
            add_element_to_int_list(&global_geometry_list.elements[loop_index].Volume->geometry.masked_by_list,INDEX_CURRENT_COMP);
            global_geometry_list.elements[loop_index].Volume->geometry.is_masked_volume = 1;
            if (this_box_volume.geometry.mask_mode == 2)
                global_geometry_list.elements[loop_index].Volume->geometry.mask_mode = 2;
            if (this_box_volume.geometry.mask_mode == 1) {
                if (global_geometry_list.elements[loop_index].Volume->geometry.is_masked_volume == 1 && global_geometry_list.elements[loop_index].Volume->geometry.mask_mode != 2)
                    // If more than one mask is added to one volume, the ANY mode overwrites the (default) ALL mode.
                    global_geometry_list.elements[loop_index].Volume->geometry.mask_mode = 1;
            }
            
            found_geometries = 1;
        }
    }
    if (found_geometries == 0) {
        printf("The mask_string in geometry: %s did not find any of the specified volumes in the mask_string %s \n",NAME_CURRENT_COMP,mask_string);
        exit(1);
    }
    this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
    this_box_volume.p_physics->is_vacuum = 0; // Makes this volume a vacuum
    this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
    this_box_volume.p_physics->my_a = 0; // Should not be used.
    sprintf(this_box_volume.p_physics->name,"Mask");
    this_box_volume.geometry.is_mask_volume = 1;
    
    
// Read the material input, or if it lacks, use automatic linking.
} else if (material_string && strlen(material_string) && strcmp(material_string, "NULL") && strcmp(material_string, "0")) {
    // A geometry string was given, use it to determine which material
    if (0 == strcmp(material_string,"vacuum") || 0 == strcmp(material_string,"Vacuum")) {
        // One could have a global physics struct for vacuum instead of creating one for each
        this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
        this_box_volume.p_physics->is_vacuum = 1; // Makes this volume a vacuum
        this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
        this_box_volume.p_physics->my_a = 0; // Should not be used.
        sprintf(this_box_volume.p_physics->name,"Vacuum");
    } else if (0 == strcmp(material_string,"exit") || 0 == strcmp(material_string,"Exit")) {
        // One could have a global physics struct for vacuum instead of creating one for each
        this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
        this_box_volume.p_physics->is_vacuum = 1; // Makes this volume a vacuum
        this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
        this_box_volume.p_physics->my_a = 0; // Should not be used.
        this_box_volume.geometry.is_exit_volume = 1;
        sprintf(this_box_volume.p_physics->name,"Exit");
    } else {
        #ifndef MATERIAL_DETECTOR
            printf("Need to define a material before refering to it in a geometry %s.\n",NAME_CURRENT_COMP);
            exit(1);
        #endif
        for (loop_index=0;loop_index<global_material_list.num_elements;loop_index++) {
            if (0 == strcmp(material_string,global_material_list.elements[loop_index].name)) {
                this_box_volume.p_physics = global_material_list.elements[loop_index].physics;
                break;
            }
            if (loop_index == global_material_list.num_elements-1) {
            printf("\n");
            printf("ERROR: The material string \"%s\" in Union geometry \"%s\" did not match a specified material. \n",material_string,NAME_CURRENT_COMP);
            printf("       The materials available at this point (need to be defined before the geometry): \n");
            for (loop_index=0;loop_index<global_material_list.num_elements;loop_index++)
              printf("         %s\n",global_material_list.elements[loop_index].name);
            printf("\n");
            printf("       It is also possible to use one of the defualt materials avaiable: \n");
            printf("           Vacuum (for a Volume without scattering or absorption)\n");
            printf("           Exit (for a Volume where the ray exits the component if it enters)\n");
            printf("           Mask (for a Volume that masks existing volumes specified in the mask_string\n");
            exit(1);
          }
        }
    }
} else {
    // Automatic linking, simply using the last defined material.
    #ifndef MATERIAL_DETECTOR
        printf("Need to define a material before the geometry to use automatic linking %s.\n",NAME_CURRENT_COMP);
        exit(1);
    #endif
    this_box_volume.p_physics = global_material_list.elements[global_material_list.num_elements-1].physics;
}

sprintf(this_box_volume.name,NAME_CURRENT_COMP);
sprintf(this_box_volume.geometry.shape,"box");
this_box_volume.geometry.priority_value = priority;
this_box_volume.geometry.geometry_p_interact = p_interact;
// Currently the coordinates will be in absolute space.
this_box_volume.geometry.center = POS_A_CURRENT_COMP;

this_box_storage.z_depth = zdepth;
this_box_storage.x_width1 = xwidth;
this_box_storage.y_height1 = yheight;

this_box_storage.is_rectangle = 0;
if (xwidth2 < 0 && yheight2 < 0) this_box_storage.is_rectangle = 1;
if (xwidth == xwidth2 && yheight == yheight2) this_box_storage.is_rectangle = 1;

if (xwidth2 < 0) {
    this_box_storage.x_width2 = xwidth;
    xwidth2 = xwidth;
} else this_box_storage.x_width2 = xwidth2;

if (yheight2 < 0) {
    this_box_storage.y_height2 = yheight;
    yheight2 = yheight;
} else this_box_storage.y_height2 = yheight2;


this_box_storage.normal_vectors[0] = coords_set(0,0,1);
this_box_storage.normal_vectors[1] = coords_set(0,0,1);

// for sides with y component = 0
x_component = 2*zdepth/sqrt((xwidth-xwidth2)*(xwidth-xwidth2)+4*zdepth*zdepth);
z_component = (xwidth-xwidth2)/sqrt(4*zdepth*zdepth+(xwidth-xwidth2)*(xwidth-xwidth2));

this_box_storage.normal_vectors[2] = coords_set(x_component,0,z_component);
this_box_storage.normal_vectors[3] = coords_set(-x_component,0,z_component);

// for sides with x component = 0
y_component = 2*zdepth/sqrt((yheight-yheight2)*(yheight-yheight2)+4*zdepth*zdepth);
z_component = (yheight-yheight2)/sqrt(4*zdepth*zdepth+(yheight-yheight2)*(yheight-yheight2));

this_box_storage.normal_vectors[4] = coords_set(0,y_component,z_component);
this_box_storage.normal_vectors[5] = coords_set(0,-y_component,z_component);

this_box_volume.geometry.visualization_on = visualize;

this_box_volume.geometry.geometry_parameters.p_box_storage = &this_box_storage;

// Assign pointers to functions for intersection with the shape, checking if a point is inside the shape
if (this_box_storage.is_rectangle == 1) {
this_box_volume.geometry.intersect_function = &sample_box_intersect_simple;
this_box_volume.geometry.within_function = &r_within_box_simple;
}
else {
this_box_volume.geometry.intersect_function = &sample_box_intersect_advanced;
this_box_volume.geometry.within_function = &r_within_box_advanced;
}

this_box_volume.geometry.shell_points = &box_shell_points;
this_box_volume.geometry.mcdisplay_function = &mcdisplay_box_function;
this_box_volume.geometry.initialize_from_main_function = &initialize_box_geometry_from_main_component;
this_box_volume.geometry.process_rot_allocated = 0;

this_box_volume.geometry.copy_geometry_parameters = &allocate_box_storage_copy;

rot_copy(this_box_volume.geometry.rotation_matrix,ROT_A_CURRENT_COMP); //check how ROT_R_CURRENT_COMP would work
rot_transpose(ROT_A_CURRENT_COMP,this_box_volume.geometry.transpose_rotation_matrix);

// Initialize loggers
this_box_volume.loggers.num_elements = 0;

// packing the information into the global_geometry_element, which is then included in the global_geometry_list.
sprintf(global_geometry_element.name,NAME_CURRENT_COMP);
global_geometry_element.activation_counter = number_of_activations;
global_geometry_element.component_index = INDEX_CURRENT_COMP;
global_geometry_element.Volume = &this_box_volume; // Would be nicer if this m was a pointer, now we have the (small) data two places
add_element_to_geometry_list(&global_geometry_list,global_geometry_element);
}
#line 260315 "MACS_sample_kidney_box.c"
#undef number_of_activations
#undef mask_setting
#undef mask_string
#undef p_interact
#undef focus_r
#undef focus_xh
#undef focus_xw
#undef focus_ah
#undef focus_aw
#undef target_z
#undef target_y
#undef target_x
#undef target_index
#undef visualize
#undef yheight2
#undef xwidth2
#undef zdepth
#undef yheight
#undef xwidth
#undef priority
#undef material_string
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

  /* Initializations for component inter_analyzer_colimator_10_blade_3. */
  SIG_MESSAGE("inter_analyzer_colimator_10_blade_3 (Init)");
#define mccompcurname  inter_analyzer_colimator_10_blade_3
#define mccompcurtype  Union_box
#define mccompcurindex 538
#define loop_index mccinter_analyzer_colimator_10_blade_3_loop_index
#define this_box_volume mccinter_analyzer_colimator_10_blade_3_this_box_volume
#define global_geometry_element mccinter_analyzer_colimator_10_blade_3_global_geometry_element
#define this_box_storage mccinter_analyzer_colimator_10_blade_3_this_box_storage
#define material_string mccinter_analyzer_colimator_10_blade_3_material_string
#define priority mccinter_analyzer_colimator_10_blade_3_priority
#define xwidth mccinter_analyzer_colimator_10_blade_3_xwidth
#define yheight mccinter_analyzer_colimator_10_blade_3_yheight
#define zdepth mccinter_analyzer_colimator_10_blade_3_zdepth
#define xwidth2 mccinter_analyzer_colimator_10_blade_3_xwidth2
#define yheight2 mccinter_analyzer_colimator_10_blade_3_yheight2
#define visualize mccinter_analyzer_colimator_10_blade_3_visualize
#define target_index mccinter_analyzer_colimator_10_blade_3_target_index
#define target_x mccinter_analyzer_colimator_10_blade_3_target_x
#define target_y mccinter_analyzer_colimator_10_blade_3_target_y
#define target_z mccinter_analyzer_colimator_10_blade_3_target_z
#define focus_aw mccinter_analyzer_colimator_10_blade_3_focus_aw
#define focus_ah mccinter_analyzer_colimator_10_blade_3_focus_ah
#define focus_xw mccinter_analyzer_colimator_10_blade_3_focus_xw
#define focus_xh mccinter_analyzer_colimator_10_blade_3_focus_xh
#define focus_r mccinter_analyzer_colimator_10_blade_3_focus_r
#define p_interact mccinter_analyzer_colimator_10_blade_3_p_interact
#define mask_string mccinter_analyzer_colimator_10_blade_3_mask_string
#define mask_setting mccinter_analyzer_colimator_10_blade_3_mask_setting
#define number_of_activations mccinter_analyzer_colimator_10_blade_3_number_of_activations
#line 224 "Union_box.comp"
{
// Initializes the focusing system for this volume including input sanitation.
focus_initialize(&this_box_volume.geometry, POS_A_COMP_INDEX(INDEX_CURRENT_COMP+target_index), POS_A_CURRENT_COMP, ROT_A_CURRENT_COMP, target_index, target_x, target_y, target_z, focus_aw, focus_ah, focus_xw, focus_xh, focus_r, NAME_CURRENT_COMP);

// Input sanitation for this geometry
if (xwidth <= 0) {
  printf("\nERROR in Union_box named %s, the xwidth is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (yheight <= 0) {
  printf("\nERROR in Union_box named %s, yheight is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (zdepth <= 0) {
  printf("\nERROR in Union_box named %s, zdepth is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (xwidth2 <= 0 && xwidth2 != -1) {
  printf("\nERROR in Union_box named %s, the xwidth2 is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (yheight2 <= 0 && yheight2 != -1) {
  printf("\nERROR in Union_box named %s, yheight2 is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}

// Use sanitation
if (global_material_list.num_elements == 0) {
  printf("\nERROR: Need to define a material using Union_make_material before using a Union geometry component. \n");
  printf("       %s was defined before first use of Union_make_material.\n",NAME_CURRENT_COMP);
  exit(1);
}

this_box_volume.geometry.is_masked_volume = 0;
this_box_volume.geometry.is_exit_volume = 0;
this_box_volume.geometry.is_mask_volume = 0;
// check if the volume is a mask, if it is the material string is irelevant.
if (mask_string && strlen(mask_string) && strcmp(mask_string, "NULL") && strcmp(mask_string, "0")) {
    // A mask volume is used to limit the extend of other volumes, called the masked volumes. These are specified in the mask_string.
    // In order for a ray to enter a masked volume, it needs to be both in the region covered by that volume AND the mask volume.
    // When more than
    this_box_volume.geometry.mask_mode = 1; // Default is mask mode is ALL
    if (mask_setting && strlen(mask_setting) && strcmp(mask_setting, "NULL") && strcmp(mask_setting, "0")) {
        if (strcmp(mask_setting,"ALL") == 0 || strcmp(mask_setting,"All") == 0) this_box_volume.geometry.mask_mode = 1;
        else if (strcmp(mask_setting,"ANY") == 0 || strcmp(mask_setting,"Any") == 0) this_box_volume.geometry.mask_mode = 2;
        else {
            printf("The mask_mode of component %s is set to %s, but must be either ALL or ANY.\n",NAME_CURRENT_COMP,mask_setting);
            exit(1);
        }
    }
    
    for (loop_index=0;loop_index<global_geometry_list.num_elements;loop_index++) {
        // Add mask list
        if (1 == manual_linking_function(global_geometry_list.elements[loop_index].name,mask_string)) {
            add_element_to_int_list(&this_box_volume.geometry.mask_list,global_geometry_list.elements[loop_index].component_index);
            add_element_to_int_list(&global_geometry_list.elements[loop_index].Volume->geometry.masked_by_list,INDEX_CURRENT_COMP);
            global_geometry_list.elements[loop_index].Volume->geometry.is_masked_volume = 1;
            if (this_box_volume.geometry.mask_mode == 2)
                global_geometry_list.elements[loop_index].Volume->geometry.mask_mode = 2;
            if (this_box_volume.geometry.mask_mode == 1) {
                if (global_geometry_list.elements[loop_index].Volume->geometry.is_masked_volume == 1 && global_geometry_list.elements[loop_index].Volume->geometry.mask_mode != 2)
                    // If more than one mask is added to one volume, the ANY mode overwrites the (default) ALL mode.
                    global_geometry_list.elements[loop_index].Volume->geometry.mask_mode = 1;
            }
            
            found_geometries = 1;
        }
    }
    if (found_geometries == 0) {
        printf("The mask_string in geometry: %s did not find any of the specified volumes in the mask_string %s \n",NAME_CURRENT_COMP,mask_string);
        exit(1);
    }
    this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
    this_box_volume.p_physics->is_vacuum = 0; // Makes this volume a vacuum
    this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
    this_box_volume.p_physics->my_a = 0; // Should not be used.
    sprintf(this_box_volume.p_physics->name,"Mask");
    this_box_volume.geometry.is_mask_volume = 1;
    
    
// Read the material input, or if it lacks, use automatic linking.
} else if (material_string && strlen(material_string) && strcmp(material_string, "NULL") && strcmp(material_string, "0")) {
    // A geometry string was given, use it to determine which material
    if (0 == strcmp(material_string,"vacuum") || 0 == strcmp(material_string,"Vacuum")) {
        // One could have a global physics struct for vacuum instead of creating one for each
        this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
        this_box_volume.p_physics->is_vacuum = 1; // Makes this volume a vacuum
        this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
        this_box_volume.p_physics->my_a = 0; // Should not be used.
        sprintf(this_box_volume.p_physics->name,"Vacuum");
    } else if (0 == strcmp(material_string,"exit") || 0 == strcmp(material_string,"Exit")) {
        // One could have a global physics struct for vacuum instead of creating one for each
        this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
        this_box_volume.p_physics->is_vacuum = 1; // Makes this volume a vacuum
        this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
        this_box_volume.p_physics->my_a = 0; // Should not be used.
        this_box_volume.geometry.is_exit_volume = 1;
        sprintf(this_box_volume.p_physics->name,"Exit");
    } else {
        #ifndef MATERIAL_DETECTOR
            printf("Need to define a material before refering to it in a geometry %s.\n",NAME_CURRENT_COMP);
            exit(1);
        #endif
        for (loop_index=0;loop_index<global_material_list.num_elements;loop_index++) {
            if (0 == strcmp(material_string,global_material_list.elements[loop_index].name)) {
                this_box_volume.p_physics = global_material_list.elements[loop_index].physics;
                break;
            }
            if (loop_index == global_material_list.num_elements-1) {
            printf("\n");
            printf("ERROR: The material string \"%s\" in Union geometry \"%s\" did not match a specified material. \n",material_string,NAME_CURRENT_COMP);
            printf("       The materials available at this point (need to be defined before the geometry): \n");
            for (loop_index=0;loop_index<global_material_list.num_elements;loop_index++)
              printf("         %s\n",global_material_list.elements[loop_index].name);
            printf("\n");
            printf("       It is also possible to use one of the defualt materials avaiable: \n");
            printf("           Vacuum (for a Volume without scattering or absorption)\n");
            printf("           Exit (for a Volume where the ray exits the component if it enters)\n");
            printf("           Mask (for a Volume that masks existing volumes specified in the mask_string\n");
            exit(1);
          }
        }
    }
} else {
    // Automatic linking, simply using the last defined material.
    #ifndef MATERIAL_DETECTOR
        printf("Need to define a material before the geometry to use automatic linking %s.\n",NAME_CURRENT_COMP);
        exit(1);
    #endif
    this_box_volume.p_physics = global_material_list.elements[global_material_list.num_elements-1].physics;
}

sprintf(this_box_volume.name,NAME_CURRENT_COMP);
sprintf(this_box_volume.geometry.shape,"box");
this_box_volume.geometry.priority_value = priority;
this_box_volume.geometry.geometry_p_interact = p_interact;
// Currently the coordinates will be in absolute space.
this_box_volume.geometry.center = POS_A_CURRENT_COMP;

this_box_storage.z_depth = zdepth;
this_box_storage.x_width1 = xwidth;
this_box_storage.y_height1 = yheight;

this_box_storage.is_rectangle = 0;
if (xwidth2 < 0 && yheight2 < 0) this_box_storage.is_rectangle = 1;
if (xwidth == xwidth2 && yheight == yheight2) this_box_storage.is_rectangle = 1;

if (xwidth2 < 0) {
    this_box_storage.x_width2 = xwidth;
    xwidth2 = xwidth;
} else this_box_storage.x_width2 = xwidth2;

if (yheight2 < 0) {
    this_box_storage.y_height2 = yheight;
    yheight2 = yheight;
} else this_box_storage.y_height2 = yheight2;


this_box_storage.normal_vectors[0] = coords_set(0,0,1);
this_box_storage.normal_vectors[1] = coords_set(0,0,1);

// for sides with y component = 0
x_component = 2*zdepth/sqrt((xwidth-xwidth2)*(xwidth-xwidth2)+4*zdepth*zdepth);
z_component = (xwidth-xwidth2)/sqrt(4*zdepth*zdepth+(xwidth-xwidth2)*(xwidth-xwidth2));

this_box_storage.normal_vectors[2] = coords_set(x_component,0,z_component);
this_box_storage.normal_vectors[3] = coords_set(-x_component,0,z_component);

// for sides with x component = 0
y_component = 2*zdepth/sqrt((yheight-yheight2)*(yheight-yheight2)+4*zdepth*zdepth);
z_component = (yheight-yheight2)/sqrt(4*zdepth*zdepth+(yheight-yheight2)*(yheight-yheight2));

this_box_storage.normal_vectors[4] = coords_set(0,y_component,z_component);
this_box_storage.normal_vectors[5] = coords_set(0,-y_component,z_component);

this_box_volume.geometry.visualization_on = visualize;

this_box_volume.geometry.geometry_parameters.p_box_storage = &this_box_storage;

// Assign pointers to functions for intersection with the shape, checking if a point is inside the shape
if (this_box_storage.is_rectangle == 1) {
this_box_volume.geometry.intersect_function = &sample_box_intersect_simple;
this_box_volume.geometry.within_function = &r_within_box_simple;
}
else {
this_box_volume.geometry.intersect_function = &sample_box_intersect_advanced;
this_box_volume.geometry.within_function = &r_within_box_advanced;
}

this_box_volume.geometry.shell_points = &box_shell_points;
this_box_volume.geometry.mcdisplay_function = &mcdisplay_box_function;
this_box_volume.geometry.initialize_from_main_function = &initialize_box_geometry_from_main_component;
this_box_volume.geometry.process_rot_allocated = 0;

this_box_volume.geometry.copy_geometry_parameters = &allocate_box_storage_copy;

rot_copy(this_box_volume.geometry.rotation_matrix,ROT_A_CURRENT_COMP); //check how ROT_R_CURRENT_COMP would work
rot_transpose(ROT_A_CURRENT_COMP,this_box_volume.geometry.transpose_rotation_matrix);

// Initialize loggers
this_box_volume.loggers.num_elements = 0;

// packing the information into the global_geometry_element, which is then included in the global_geometry_list.
sprintf(global_geometry_element.name,NAME_CURRENT_COMP);
global_geometry_element.activation_counter = number_of_activations;
global_geometry_element.component_index = INDEX_CURRENT_COMP;
global_geometry_element.Volume = &this_box_volume; // Would be nicer if this m was a pointer, now we have the (small) data two places
add_element_to_geometry_list(&global_geometry_list,global_geometry_element);
}
#line 260585 "MACS_sample_kidney_box.c"
#undef number_of_activations
#undef mask_setting
#undef mask_string
#undef p_interact
#undef focus_r
#undef focus_xh
#undef focus_xw
#undef focus_ah
#undef focus_aw
#undef target_z
#undef target_y
#undef target_x
#undef target_index
#undef visualize
#undef yheight2
#undef xwidth2
#undef zdepth
#undef yheight
#undef xwidth
#undef priority
#undef material_string
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

  /* Initializations for component inter_analyzer_colimator_10_blade_4. */
  SIG_MESSAGE("inter_analyzer_colimator_10_blade_4 (Init)");
#define mccompcurname  inter_analyzer_colimator_10_blade_4
#define mccompcurtype  Union_box
#define mccompcurindex 539
#define loop_index mccinter_analyzer_colimator_10_blade_4_loop_index
#define this_box_volume mccinter_analyzer_colimator_10_blade_4_this_box_volume
#define global_geometry_element mccinter_analyzer_colimator_10_blade_4_global_geometry_element
#define this_box_storage mccinter_analyzer_colimator_10_blade_4_this_box_storage
#define material_string mccinter_analyzer_colimator_10_blade_4_material_string
#define priority mccinter_analyzer_colimator_10_blade_4_priority
#define xwidth mccinter_analyzer_colimator_10_blade_4_xwidth
#define yheight mccinter_analyzer_colimator_10_blade_4_yheight
#define zdepth mccinter_analyzer_colimator_10_blade_4_zdepth
#define xwidth2 mccinter_analyzer_colimator_10_blade_4_xwidth2
#define yheight2 mccinter_analyzer_colimator_10_blade_4_yheight2
#define visualize mccinter_analyzer_colimator_10_blade_4_visualize
#define target_index mccinter_analyzer_colimator_10_blade_4_target_index
#define target_x mccinter_analyzer_colimator_10_blade_4_target_x
#define target_y mccinter_analyzer_colimator_10_blade_4_target_y
#define target_z mccinter_analyzer_colimator_10_blade_4_target_z
#define focus_aw mccinter_analyzer_colimator_10_blade_4_focus_aw
#define focus_ah mccinter_analyzer_colimator_10_blade_4_focus_ah
#define focus_xw mccinter_analyzer_colimator_10_blade_4_focus_xw
#define focus_xh mccinter_analyzer_colimator_10_blade_4_focus_xh
#define focus_r mccinter_analyzer_colimator_10_blade_4_focus_r
#define p_interact mccinter_analyzer_colimator_10_blade_4_p_interact
#define mask_string mccinter_analyzer_colimator_10_blade_4_mask_string
#define mask_setting mccinter_analyzer_colimator_10_blade_4_mask_setting
#define number_of_activations mccinter_analyzer_colimator_10_blade_4_number_of_activations
#line 224 "Union_box.comp"
{
// Initializes the focusing system for this volume including input sanitation.
focus_initialize(&this_box_volume.geometry, POS_A_COMP_INDEX(INDEX_CURRENT_COMP+target_index), POS_A_CURRENT_COMP, ROT_A_CURRENT_COMP, target_index, target_x, target_y, target_z, focus_aw, focus_ah, focus_xw, focus_xh, focus_r, NAME_CURRENT_COMP);

// Input sanitation for this geometry
if (xwidth <= 0) {
  printf("\nERROR in Union_box named %s, the xwidth is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (yheight <= 0) {
  printf("\nERROR in Union_box named %s, yheight is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (zdepth <= 0) {
  printf("\nERROR in Union_box named %s, zdepth is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (xwidth2 <= 0 && xwidth2 != -1) {
  printf("\nERROR in Union_box named %s, the xwidth2 is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (yheight2 <= 0 && yheight2 != -1) {
  printf("\nERROR in Union_box named %s, yheight2 is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}

// Use sanitation
if (global_material_list.num_elements == 0) {
  printf("\nERROR: Need to define a material using Union_make_material before using a Union geometry component. \n");
  printf("       %s was defined before first use of Union_make_material.\n",NAME_CURRENT_COMP);
  exit(1);
}

this_box_volume.geometry.is_masked_volume = 0;
this_box_volume.geometry.is_exit_volume = 0;
this_box_volume.geometry.is_mask_volume = 0;
// check if the volume is a mask, if it is the material string is irelevant.
if (mask_string && strlen(mask_string) && strcmp(mask_string, "NULL") && strcmp(mask_string, "0")) {
    // A mask volume is used to limit the extend of other volumes, called the masked volumes. These are specified in the mask_string.
    // In order for a ray to enter a masked volume, it needs to be both in the region covered by that volume AND the mask volume.
    // When more than
    this_box_volume.geometry.mask_mode = 1; // Default is mask mode is ALL
    if (mask_setting && strlen(mask_setting) && strcmp(mask_setting, "NULL") && strcmp(mask_setting, "0")) {
        if (strcmp(mask_setting,"ALL") == 0 || strcmp(mask_setting,"All") == 0) this_box_volume.geometry.mask_mode = 1;
        else if (strcmp(mask_setting,"ANY") == 0 || strcmp(mask_setting,"Any") == 0) this_box_volume.geometry.mask_mode = 2;
        else {
            printf("The mask_mode of component %s is set to %s, but must be either ALL or ANY.\n",NAME_CURRENT_COMP,mask_setting);
            exit(1);
        }
    }
    
    for (loop_index=0;loop_index<global_geometry_list.num_elements;loop_index++) {
        // Add mask list
        if (1 == manual_linking_function(global_geometry_list.elements[loop_index].name,mask_string)) {
            add_element_to_int_list(&this_box_volume.geometry.mask_list,global_geometry_list.elements[loop_index].component_index);
            add_element_to_int_list(&global_geometry_list.elements[loop_index].Volume->geometry.masked_by_list,INDEX_CURRENT_COMP);
            global_geometry_list.elements[loop_index].Volume->geometry.is_masked_volume = 1;
            if (this_box_volume.geometry.mask_mode == 2)
                global_geometry_list.elements[loop_index].Volume->geometry.mask_mode = 2;
            if (this_box_volume.geometry.mask_mode == 1) {
                if (global_geometry_list.elements[loop_index].Volume->geometry.is_masked_volume == 1 && global_geometry_list.elements[loop_index].Volume->geometry.mask_mode != 2)
                    // If more than one mask is added to one volume, the ANY mode overwrites the (default) ALL mode.
                    global_geometry_list.elements[loop_index].Volume->geometry.mask_mode = 1;
            }
            
            found_geometries = 1;
        }
    }
    if (found_geometries == 0) {
        printf("The mask_string in geometry: %s did not find any of the specified volumes in the mask_string %s \n",NAME_CURRENT_COMP,mask_string);
        exit(1);
    }
    this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
    this_box_volume.p_physics->is_vacuum = 0; // Makes this volume a vacuum
    this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
    this_box_volume.p_physics->my_a = 0; // Should not be used.
    sprintf(this_box_volume.p_physics->name,"Mask");
    this_box_volume.geometry.is_mask_volume = 1;
    
    
// Read the material input, or if it lacks, use automatic linking.
} else if (material_string && strlen(material_string) && strcmp(material_string, "NULL") && strcmp(material_string, "0")) {
    // A geometry string was given, use it to determine which material
    if (0 == strcmp(material_string,"vacuum") || 0 == strcmp(material_string,"Vacuum")) {
        // One could have a global physics struct for vacuum instead of creating one for each
        this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
        this_box_volume.p_physics->is_vacuum = 1; // Makes this volume a vacuum
        this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
        this_box_volume.p_physics->my_a = 0; // Should not be used.
        sprintf(this_box_volume.p_physics->name,"Vacuum");
    } else if (0 == strcmp(material_string,"exit") || 0 == strcmp(material_string,"Exit")) {
        // One could have a global physics struct for vacuum instead of creating one for each
        this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
        this_box_volume.p_physics->is_vacuum = 1; // Makes this volume a vacuum
        this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
        this_box_volume.p_physics->my_a = 0; // Should not be used.
        this_box_volume.geometry.is_exit_volume = 1;
        sprintf(this_box_volume.p_physics->name,"Exit");
    } else {
        #ifndef MATERIAL_DETECTOR
            printf("Need to define a material before refering to it in a geometry %s.\n",NAME_CURRENT_COMP);
            exit(1);
        #endif
        for (loop_index=0;loop_index<global_material_list.num_elements;loop_index++) {
            if (0 == strcmp(material_string,global_material_list.elements[loop_index].name)) {
                this_box_volume.p_physics = global_material_list.elements[loop_index].physics;
                break;
            }
            if (loop_index == global_material_list.num_elements-1) {
            printf("\n");
            printf("ERROR: The material string \"%s\" in Union geometry \"%s\" did not match a specified material. \n",material_string,NAME_CURRENT_COMP);
            printf("       The materials available at this point (need to be defined before the geometry): \n");
            for (loop_index=0;loop_index<global_material_list.num_elements;loop_index++)
              printf("         %s\n",global_material_list.elements[loop_index].name);
            printf("\n");
            printf("       It is also possible to use one of the defualt materials avaiable: \n");
            printf("           Vacuum (for a Volume without scattering or absorption)\n");
            printf("           Exit (for a Volume where the ray exits the component if it enters)\n");
            printf("           Mask (for a Volume that masks existing volumes specified in the mask_string\n");
            exit(1);
          }
        }
    }
} else {
    // Automatic linking, simply using the last defined material.
    #ifndef MATERIAL_DETECTOR
        printf("Need to define a material before the geometry to use automatic linking %s.\n",NAME_CURRENT_COMP);
        exit(1);
    #endif
    this_box_volume.p_physics = global_material_list.elements[global_material_list.num_elements-1].physics;
}

sprintf(this_box_volume.name,NAME_CURRENT_COMP);
sprintf(this_box_volume.geometry.shape,"box");
this_box_volume.geometry.priority_value = priority;
this_box_volume.geometry.geometry_p_interact = p_interact;
// Currently the coordinates will be in absolute space.
this_box_volume.geometry.center = POS_A_CURRENT_COMP;

this_box_storage.z_depth = zdepth;
this_box_storage.x_width1 = xwidth;
this_box_storage.y_height1 = yheight;

this_box_storage.is_rectangle = 0;
if (xwidth2 < 0 && yheight2 < 0) this_box_storage.is_rectangle = 1;
if (xwidth == xwidth2 && yheight == yheight2) this_box_storage.is_rectangle = 1;

if (xwidth2 < 0) {
    this_box_storage.x_width2 = xwidth;
    xwidth2 = xwidth;
} else this_box_storage.x_width2 = xwidth2;

if (yheight2 < 0) {
    this_box_storage.y_height2 = yheight;
    yheight2 = yheight;
} else this_box_storage.y_height2 = yheight2;


this_box_storage.normal_vectors[0] = coords_set(0,0,1);
this_box_storage.normal_vectors[1] = coords_set(0,0,1);

// for sides with y component = 0
x_component = 2*zdepth/sqrt((xwidth-xwidth2)*(xwidth-xwidth2)+4*zdepth*zdepth);
z_component = (xwidth-xwidth2)/sqrt(4*zdepth*zdepth+(xwidth-xwidth2)*(xwidth-xwidth2));

this_box_storage.normal_vectors[2] = coords_set(x_component,0,z_component);
this_box_storage.normal_vectors[3] = coords_set(-x_component,0,z_component);

// for sides with x component = 0
y_component = 2*zdepth/sqrt((yheight-yheight2)*(yheight-yheight2)+4*zdepth*zdepth);
z_component = (yheight-yheight2)/sqrt(4*zdepth*zdepth+(yheight-yheight2)*(yheight-yheight2));

this_box_storage.normal_vectors[4] = coords_set(0,y_component,z_component);
this_box_storage.normal_vectors[5] = coords_set(0,-y_component,z_component);

this_box_volume.geometry.visualization_on = visualize;

this_box_volume.geometry.geometry_parameters.p_box_storage = &this_box_storage;

// Assign pointers to functions for intersection with the shape, checking if a point is inside the shape
if (this_box_storage.is_rectangle == 1) {
this_box_volume.geometry.intersect_function = &sample_box_intersect_simple;
this_box_volume.geometry.within_function = &r_within_box_simple;
}
else {
this_box_volume.geometry.intersect_function = &sample_box_intersect_advanced;
this_box_volume.geometry.within_function = &r_within_box_advanced;
}

this_box_volume.geometry.shell_points = &box_shell_points;
this_box_volume.geometry.mcdisplay_function = &mcdisplay_box_function;
this_box_volume.geometry.initialize_from_main_function = &initialize_box_geometry_from_main_component;
this_box_volume.geometry.process_rot_allocated = 0;

this_box_volume.geometry.copy_geometry_parameters = &allocate_box_storage_copy;

rot_copy(this_box_volume.geometry.rotation_matrix,ROT_A_CURRENT_COMP); //check how ROT_R_CURRENT_COMP would work
rot_transpose(ROT_A_CURRENT_COMP,this_box_volume.geometry.transpose_rotation_matrix);

// Initialize loggers
this_box_volume.loggers.num_elements = 0;

// packing the information into the global_geometry_element, which is then included in the global_geometry_list.
sprintf(global_geometry_element.name,NAME_CURRENT_COMP);
global_geometry_element.activation_counter = number_of_activations;
global_geometry_element.component_index = INDEX_CURRENT_COMP;
global_geometry_element.Volume = &this_box_volume; // Would be nicer if this m was a pointer, now we have the (small) data two places
add_element_to_geometry_list(&global_geometry_list,global_geometry_element);
}
#line 260855 "MACS_sample_kidney_box.c"
#undef number_of_activations
#undef mask_setting
#undef mask_string
#undef p_interact
#undef focus_r
#undef focus_xh
#undef focus_xw
#undef focus_ah
#undef focus_aw
#undef target_z
#undef target_y
#undef target_x
#undef target_index
#undef visualize
#undef yheight2
#undef xwidth2
#undef zdepth
#undef yheight
#undef xwidth
#undef priority
#undef material_string
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

  /* Initializations for component diffraction_detector_10_exit_volume. */
  SIG_MESSAGE("diffraction_detector_10_exit_volume (Init)");
#define mccompcurname  diffraction_detector_10_exit_volume
#define mccompcurtype  Union_box
#define mccompcurindex 540
#define loop_index mccdiffraction_detector_10_exit_volume_loop_index
#define this_box_volume mccdiffraction_detector_10_exit_volume_this_box_volume
#define global_geometry_element mccdiffraction_detector_10_exit_volume_global_geometry_element
#define this_box_storage mccdiffraction_detector_10_exit_volume_this_box_storage
#define material_string mccdiffraction_detector_10_exit_volume_material_string
#define priority mccdiffraction_detector_10_exit_volume_priority
#define xwidth mccdiffraction_detector_10_exit_volume_xwidth
#define yheight mccdiffraction_detector_10_exit_volume_yheight
#define zdepth mccdiffraction_detector_10_exit_volume_zdepth
#define xwidth2 mccdiffraction_detector_10_exit_volume_xwidth2
#define yheight2 mccdiffraction_detector_10_exit_volume_yheight2
#define visualize mccdiffraction_detector_10_exit_volume_visualize
#define target_index mccdiffraction_detector_10_exit_volume_target_index
#define target_x mccdiffraction_detector_10_exit_volume_target_x
#define target_y mccdiffraction_detector_10_exit_volume_target_y
#define target_z mccdiffraction_detector_10_exit_volume_target_z
#define focus_aw mccdiffraction_detector_10_exit_volume_focus_aw
#define focus_ah mccdiffraction_detector_10_exit_volume_focus_ah
#define focus_xw mccdiffraction_detector_10_exit_volume_focus_xw
#define focus_xh mccdiffraction_detector_10_exit_volume_focus_xh
#define focus_r mccdiffraction_detector_10_exit_volume_focus_r
#define p_interact mccdiffraction_detector_10_exit_volume_p_interact
#define mask_string mccdiffraction_detector_10_exit_volume_mask_string
#define mask_setting mccdiffraction_detector_10_exit_volume_mask_setting
#define number_of_activations mccdiffraction_detector_10_exit_volume_number_of_activations
#line 224 "Union_box.comp"
{
// Initializes the focusing system for this volume including input sanitation.
focus_initialize(&this_box_volume.geometry, POS_A_COMP_INDEX(INDEX_CURRENT_COMP+target_index), POS_A_CURRENT_COMP, ROT_A_CURRENT_COMP, target_index, target_x, target_y, target_z, focus_aw, focus_ah, focus_xw, focus_xh, focus_r, NAME_CURRENT_COMP);

// Input sanitation for this geometry
if (xwidth <= 0) {
  printf("\nERROR in Union_box named %s, the xwidth is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (yheight <= 0) {
  printf("\nERROR in Union_box named %s, yheight is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (zdepth <= 0) {
  printf("\nERROR in Union_box named %s, zdepth is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (xwidth2 <= 0 && xwidth2 != -1) {
  printf("\nERROR in Union_box named %s, the xwidth2 is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (yheight2 <= 0 && yheight2 != -1) {
  printf("\nERROR in Union_box named %s, yheight2 is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}

// Use sanitation
if (global_material_list.num_elements == 0) {
  printf("\nERROR: Need to define a material using Union_make_material before using a Union geometry component. \n");
  printf("       %s was defined before first use of Union_make_material.\n",NAME_CURRENT_COMP);
  exit(1);
}

this_box_volume.geometry.is_masked_volume = 0;
this_box_volume.geometry.is_exit_volume = 0;
this_box_volume.geometry.is_mask_volume = 0;
// check if the volume is a mask, if it is the material string is irelevant.
if (mask_string && strlen(mask_string) && strcmp(mask_string, "NULL") && strcmp(mask_string, "0")) {
    // A mask volume is used to limit the extend of other volumes, called the masked volumes. These are specified in the mask_string.
    // In order for a ray to enter a masked volume, it needs to be both in the region covered by that volume AND the mask volume.
    // When more than
    this_box_volume.geometry.mask_mode = 1; // Default is mask mode is ALL
    if (mask_setting && strlen(mask_setting) && strcmp(mask_setting, "NULL") && strcmp(mask_setting, "0")) {
        if (strcmp(mask_setting,"ALL") == 0 || strcmp(mask_setting,"All") == 0) this_box_volume.geometry.mask_mode = 1;
        else if (strcmp(mask_setting,"ANY") == 0 || strcmp(mask_setting,"Any") == 0) this_box_volume.geometry.mask_mode = 2;
        else {
            printf("The mask_mode of component %s is set to %s, but must be either ALL or ANY.\n",NAME_CURRENT_COMP,mask_setting);
            exit(1);
        }
    }
    
    for (loop_index=0;loop_index<global_geometry_list.num_elements;loop_index++) {
        // Add mask list
        if (1 == manual_linking_function(global_geometry_list.elements[loop_index].name,mask_string)) {
            add_element_to_int_list(&this_box_volume.geometry.mask_list,global_geometry_list.elements[loop_index].component_index);
            add_element_to_int_list(&global_geometry_list.elements[loop_index].Volume->geometry.masked_by_list,INDEX_CURRENT_COMP);
            global_geometry_list.elements[loop_index].Volume->geometry.is_masked_volume = 1;
            if (this_box_volume.geometry.mask_mode == 2)
                global_geometry_list.elements[loop_index].Volume->geometry.mask_mode = 2;
            if (this_box_volume.geometry.mask_mode == 1) {
                if (global_geometry_list.elements[loop_index].Volume->geometry.is_masked_volume == 1 && global_geometry_list.elements[loop_index].Volume->geometry.mask_mode != 2)
                    // If more than one mask is added to one volume, the ANY mode overwrites the (default) ALL mode.
                    global_geometry_list.elements[loop_index].Volume->geometry.mask_mode = 1;
            }
            
            found_geometries = 1;
        }
    }
    if (found_geometries == 0) {
        printf("The mask_string in geometry: %s did not find any of the specified volumes in the mask_string %s \n",NAME_CURRENT_COMP,mask_string);
        exit(1);
    }
    this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
    this_box_volume.p_physics->is_vacuum = 0; // Makes this volume a vacuum
    this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
    this_box_volume.p_physics->my_a = 0; // Should not be used.
    sprintf(this_box_volume.p_physics->name,"Mask");
    this_box_volume.geometry.is_mask_volume = 1;
    
    
// Read the material input, or if it lacks, use automatic linking.
} else if (material_string && strlen(material_string) && strcmp(material_string, "NULL") && strcmp(material_string, "0")) {
    // A geometry string was given, use it to determine which material
    if (0 == strcmp(material_string,"vacuum") || 0 == strcmp(material_string,"Vacuum")) {
        // One could have a global physics struct for vacuum instead of creating one for each
        this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
        this_box_volume.p_physics->is_vacuum = 1; // Makes this volume a vacuum
        this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
        this_box_volume.p_physics->my_a = 0; // Should not be used.
        sprintf(this_box_volume.p_physics->name,"Vacuum");
    } else if (0 == strcmp(material_string,"exit") || 0 == strcmp(material_string,"Exit")) {
        // One could have a global physics struct for vacuum instead of creating one for each
        this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
        this_box_volume.p_physics->is_vacuum = 1; // Makes this volume a vacuum
        this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
        this_box_volume.p_physics->my_a = 0; // Should not be used.
        this_box_volume.geometry.is_exit_volume = 1;
        sprintf(this_box_volume.p_physics->name,"Exit");
    } else {
        #ifndef MATERIAL_DETECTOR
            printf("Need to define a material before refering to it in a geometry %s.\n",NAME_CURRENT_COMP);
            exit(1);
        #endif
        for (loop_index=0;loop_index<global_material_list.num_elements;loop_index++) {
            if (0 == strcmp(material_string,global_material_list.elements[loop_index].name)) {
                this_box_volume.p_physics = global_material_list.elements[loop_index].physics;
                break;
            }
            if (loop_index == global_material_list.num_elements-1) {
            printf("\n");
            printf("ERROR: The material string \"%s\" in Union geometry \"%s\" did not match a specified material. \n",material_string,NAME_CURRENT_COMP);
            printf("       The materials available at this point (need to be defined before the geometry): \n");
            for (loop_index=0;loop_index<global_material_list.num_elements;loop_index++)
              printf("         %s\n",global_material_list.elements[loop_index].name);
            printf("\n");
            printf("       It is also possible to use one of the defualt materials avaiable: \n");
            printf("           Vacuum (for a Volume without scattering or absorption)\n");
            printf("           Exit (for a Volume where the ray exits the component if it enters)\n");
            printf("           Mask (for a Volume that masks existing volumes specified in the mask_string\n");
            exit(1);
          }
        }
    }
} else {
    // Automatic linking, simply using the last defined material.
    #ifndef MATERIAL_DETECTOR
        printf("Need to define a material before the geometry to use automatic linking %s.\n",NAME_CURRENT_COMP);
        exit(1);
    #endif
    this_box_volume.p_physics = global_material_list.elements[global_material_list.num_elements-1].physics;
}

sprintf(this_box_volume.name,NAME_CURRENT_COMP);
sprintf(this_box_volume.geometry.shape,"box");
this_box_volume.geometry.priority_value = priority;
this_box_volume.geometry.geometry_p_interact = p_interact;
// Currently the coordinates will be in absolute space.
this_box_volume.geometry.center = POS_A_CURRENT_COMP;

this_box_storage.z_depth = zdepth;
this_box_storage.x_width1 = xwidth;
this_box_storage.y_height1 = yheight;

this_box_storage.is_rectangle = 0;
if (xwidth2 < 0 && yheight2 < 0) this_box_storage.is_rectangle = 1;
if (xwidth == xwidth2 && yheight == yheight2) this_box_storage.is_rectangle = 1;

if (xwidth2 < 0) {
    this_box_storage.x_width2 = xwidth;
    xwidth2 = xwidth;
} else this_box_storage.x_width2 = xwidth2;

if (yheight2 < 0) {
    this_box_storage.y_height2 = yheight;
    yheight2 = yheight;
} else this_box_storage.y_height2 = yheight2;


this_box_storage.normal_vectors[0] = coords_set(0,0,1);
this_box_storage.normal_vectors[1] = coords_set(0,0,1);

// for sides with y component = 0
x_component = 2*zdepth/sqrt((xwidth-xwidth2)*(xwidth-xwidth2)+4*zdepth*zdepth);
z_component = (xwidth-xwidth2)/sqrt(4*zdepth*zdepth+(xwidth-xwidth2)*(xwidth-xwidth2));

this_box_storage.normal_vectors[2] = coords_set(x_component,0,z_component);
this_box_storage.normal_vectors[3] = coords_set(-x_component,0,z_component);

// for sides with x component = 0
y_component = 2*zdepth/sqrt((yheight-yheight2)*(yheight-yheight2)+4*zdepth*zdepth);
z_component = (yheight-yheight2)/sqrt(4*zdepth*zdepth+(yheight-yheight2)*(yheight-yheight2));

this_box_storage.normal_vectors[4] = coords_set(0,y_component,z_component);
this_box_storage.normal_vectors[5] = coords_set(0,-y_component,z_component);

this_box_volume.geometry.visualization_on = visualize;

this_box_volume.geometry.geometry_parameters.p_box_storage = &this_box_storage;

// Assign pointers to functions for intersection with the shape, checking if a point is inside the shape
if (this_box_storage.is_rectangle == 1) {
this_box_volume.geometry.intersect_function = &sample_box_intersect_simple;
this_box_volume.geometry.within_function = &r_within_box_simple;
}
else {
this_box_volume.geometry.intersect_function = &sample_box_intersect_advanced;
this_box_volume.geometry.within_function = &r_within_box_advanced;
}

this_box_volume.geometry.shell_points = &box_shell_points;
this_box_volume.geometry.mcdisplay_function = &mcdisplay_box_function;
this_box_volume.geometry.initialize_from_main_function = &initialize_box_geometry_from_main_component;
this_box_volume.geometry.process_rot_allocated = 0;

this_box_volume.geometry.copy_geometry_parameters = &allocate_box_storage_copy;

rot_copy(this_box_volume.geometry.rotation_matrix,ROT_A_CURRENT_COMP); //check how ROT_R_CURRENT_COMP would work
rot_transpose(ROT_A_CURRENT_COMP,this_box_volume.geometry.transpose_rotation_matrix);

// Initialize loggers
this_box_volume.loggers.num_elements = 0;

// packing the information into the global_geometry_element, which is then included in the global_geometry_list.
sprintf(global_geometry_element.name,NAME_CURRENT_COMP);
global_geometry_element.activation_counter = number_of_activations;
global_geometry_element.component_index = INDEX_CURRENT_COMP;
global_geometry_element.Volume = &this_box_volume; // Would be nicer if this m was a pointer, now we have the (small) data two places
add_element_to_geometry_list(&global_geometry_list,global_geometry_element);
}
#line 261125 "MACS_sample_kidney_box.c"
#undef number_of_activations
#undef mask_setting
#undef mask_string
#undef p_interact
#undef focus_r
#undef focus_xh
#undef focus_xw
#undef focus_ah
#undef focus_aw
#undef target_z
#undef target_y
#undef target_x
#undef target_index
#undef visualize
#undef yheight2
#undef xwidth2
#undef zdepth
#undef yheight
#undef xwidth
#undef priority
#undef material_string
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

  /* Initializations for component spec_detector_10_exit_volume. */
  SIG_MESSAGE("spec_detector_10_exit_volume (Init)");
#define mccompcurname  spec_detector_10_exit_volume
#define mccompcurtype  Union_box
#define mccompcurindex 541
#define loop_index mccspec_detector_10_exit_volume_loop_index
#define this_box_volume mccspec_detector_10_exit_volume_this_box_volume
#define global_geometry_element mccspec_detector_10_exit_volume_global_geometry_element
#define this_box_storage mccspec_detector_10_exit_volume_this_box_storage
#define material_string mccspec_detector_10_exit_volume_material_string
#define priority mccspec_detector_10_exit_volume_priority
#define xwidth mccspec_detector_10_exit_volume_xwidth
#define yheight mccspec_detector_10_exit_volume_yheight
#define zdepth mccspec_detector_10_exit_volume_zdepth
#define xwidth2 mccspec_detector_10_exit_volume_xwidth2
#define yheight2 mccspec_detector_10_exit_volume_yheight2
#define visualize mccspec_detector_10_exit_volume_visualize
#define target_index mccspec_detector_10_exit_volume_target_index
#define target_x mccspec_detector_10_exit_volume_target_x
#define target_y mccspec_detector_10_exit_volume_target_y
#define target_z mccspec_detector_10_exit_volume_target_z
#define focus_aw mccspec_detector_10_exit_volume_focus_aw
#define focus_ah mccspec_detector_10_exit_volume_focus_ah
#define focus_xw mccspec_detector_10_exit_volume_focus_xw
#define focus_xh mccspec_detector_10_exit_volume_focus_xh
#define focus_r mccspec_detector_10_exit_volume_focus_r
#define p_interact mccspec_detector_10_exit_volume_p_interact
#define mask_string mccspec_detector_10_exit_volume_mask_string
#define mask_setting mccspec_detector_10_exit_volume_mask_setting
#define number_of_activations mccspec_detector_10_exit_volume_number_of_activations
#line 224 "Union_box.comp"
{
// Initializes the focusing system for this volume including input sanitation.
focus_initialize(&this_box_volume.geometry, POS_A_COMP_INDEX(INDEX_CURRENT_COMP+target_index), POS_A_CURRENT_COMP, ROT_A_CURRENT_COMP, target_index, target_x, target_y, target_z, focus_aw, focus_ah, focus_xw, focus_xh, focus_r, NAME_CURRENT_COMP);

// Input sanitation for this geometry
if (xwidth <= 0) {
  printf("\nERROR in Union_box named %s, the xwidth is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (yheight <= 0) {
  printf("\nERROR in Union_box named %s, yheight is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (zdepth <= 0) {
  printf("\nERROR in Union_box named %s, zdepth is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (xwidth2 <= 0 && xwidth2 != -1) {
  printf("\nERROR in Union_box named %s, the xwidth2 is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (yheight2 <= 0 && yheight2 != -1) {
  printf("\nERROR in Union_box named %s, yheight2 is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}

// Use sanitation
if (global_material_list.num_elements == 0) {
  printf("\nERROR: Need to define a material using Union_make_material before using a Union geometry component. \n");
  printf("       %s was defined before first use of Union_make_material.\n",NAME_CURRENT_COMP);
  exit(1);
}

this_box_volume.geometry.is_masked_volume = 0;
this_box_volume.geometry.is_exit_volume = 0;
this_box_volume.geometry.is_mask_volume = 0;
// check if the volume is a mask, if it is the material string is irelevant.
if (mask_string && strlen(mask_string) && strcmp(mask_string, "NULL") && strcmp(mask_string, "0")) {
    // A mask volume is used to limit the extend of other volumes, called the masked volumes. These are specified in the mask_string.
    // In order for a ray to enter a masked volume, it needs to be both in the region covered by that volume AND the mask volume.
    // When more than
    this_box_volume.geometry.mask_mode = 1; // Default is mask mode is ALL
    if (mask_setting && strlen(mask_setting) && strcmp(mask_setting, "NULL") && strcmp(mask_setting, "0")) {
        if (strcmp(mask_setting,"ALL") == 0 || strcmp(mask_setting,"All") == 0) this_box_volume.geometry.mask_mode = 1;
        else if (strcmp(mask_setting,"ANY") == 0 || strcmp(mask_setting,"Any") == 0) this_box_volume.geometry.mask_mode = 2;
        else {
            printf("The mask_mode of component %s is set to %s, but must be either ALL or ANY.\n",NAME_CURRENT_COMP,mask_setting);
            exit(1);
        }
    }
    
    for (loop_index=0;loop_index<global_geometry_list.num_elements;loop_index++) {
        // Add mask list
        if (1 == manual_linking_function(global_geometry_list.elements[loop_index].name,mask_string)) {
            add_element_to_int_list(&this_box_volume.geometry.mask_list,global_geometry_list.elements[loop_index].component_index);
            add_element_to_int_list(&global_geometry_list.elements[loop_index].Volume->geometry.masked_by_list,INDEX_CURRENT_COMP);
            global_geometry_list.elements[loop_index].Volume->geometry.is_masked_volume = 1;
            if (this_box_volume.geometry.mask_mode == 2)
                global_geometry_list.elements[loop_index].Volume->geometry.mask_mode = 2;
            if (this_box_volume.geometry.mask_mode == 1) {
                if (global_geometry_list.elements[loop_index].Volume->geometry.is_masked_volume == 1 && global_geometry_list.elements[loop_index].Volume->geometry.mask_mode != 2)
                    // If more than one mask is added to one volume, the ANY mode overwrites the (default) ALL mode.
                    global_geometry_list.elements[loop_index].Volume->geometry.mask_mode = 1;
            }
            
            found_geometries = 1;
        }
    }
    if (found_geometries == 0) {
        printf("The mask_string in geometry: %s did not find any of the specified volumes in the mask_string %s \n",NAME_CURRENT_COMP,mask_string);
        exit(1);
    }
    this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
    this_box_volume.p_physics->is_vacuum = 0; // Makes this volume a vacuum
    this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
    this_box_volume.p_physics->my_a = 0; // Should not be used.
    sprintf(this_box_volume.p_physics->name,"Mask");
    this_box_volume.geometry.is_mask_volume = 1;
    
    
// Read the material input, or if it lacks, use automatic linking.
} else if (material_string && strlen(material_string) && strcmp(material_string, "NULL") && strcmp(material_string, "0")) {
    // A geometry string was given, use it to determine which material
    if (0 == strcmp(material_string,"vacuum") || 0 == strcmp(material_string,"Vacuum")) {
        // One could have a global physics struct for vacuum instead of creating one for each
        this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
        this_box_volume.p_physics->is_vacuum = 1; // Makes this volume a vacuum
        this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
        this_box_volume.p_physics->my_a = 0; // Should not be used.
        sprintf(this_box_volume.p_physics->name,"Vacuum");
    } else if (0 == strcmp(material_string,"exit") || 0 == strcmp(material_string,"Exit")) {
        // One could have a global physics struct for vacuum instead of creating one for each
        this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
        this_box_volume.p_physics->is_vacuum = 1; // Makes this volume a vacuum
        this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
        this_box_volume.p_physics->my_a = 0; // Should not be used.
        this_box_volume.geometry.is_exit_volume = 1;
        sprintf(this_box_volume.p_physics->name,"Exit");
    } else {
        #ifndef MATERIAL_DETECTOR
            printf("Need to define a material before refering to it in a geometry %s.\n",NAME_CURRENT_COMP);
            exit(1);
        #endif
        for (loop_index=0;loop_index<global_material_list.num_elements;loop_index++) {
            if (0 == strcmp(material_string,global_material_list.elements[loop_index].name)) {
                this_box_volume.p_physics = global_material_list.elements[loop_index].physics;
                break;
            }
            if (loop_index == global_material_list.num_elements-1) {
            printf("\n");
            printf("ERROR: The material string \"%s\" in Union geometry \"%s\" did not match a specified material. \n",material_string,NAME_CURRENT_COMP);
            printf("       The materials available at this point (need to be defined before the geometry): \n");
            for (loop_index=0;loop_index<global_material_list.num_elements;loop_index++)
              printf("         %s\n",global_material_list.elements[loop_index].name);
            printf("\n");
            printf("       It is also possible to use one of the defualt materials avaiable: \n");
            printf("           Vacuum (for a Volume without scattering or absorption)\n");
            printf("           Exit (for a Volume where the ray exits the component if it enters)\n");
            printf("           Mask (for a Volume that masks existing volumes specified in the mask_string\n");
            exit(1);
          }
        }
    }
} else {
    // Automatic linking, simply using the last defined material.
    #ifndef MATERIAL_DETECTOR
        printf("Need to define a material before the geometry to use automatic linking %s.\n",NAME_CURRENT_COMP);
        exit(1);
    #endif
    this_box_volume.p_physics = global_material_list.elements[global_material_list.num_elements-1].physics;
}

sprintf(this_box_volume.name,NAME_CURRENT_COMP);
sprintf(this_box_volume.geometry.shape,"box");
this_box_volume.geometry.priority_value = priority;
this_box_volume.geometry.geometry_p_interact = p_interact;
// Currently the coordinates will be in absolute space.
this_box_volume.geometry.center = POS_A_CURRENT_COMP;

this_box_storage.z_depth = zdepth;
this_box_storage.x_width1 = xwidth;
this_box_storage.y_height1 = yheight;

this_box_storage.is_rectangle = 0;
if (xwidth2 < 0 && yheight2 < 0) this_box_storage.is_rectangle = 1;
if (xwidth == xwidth2 && yheight == yheight2) this_box_storage.is_rectangle = 1;

if (xwidth2 < 0) {
    this_box_storage.x_width2 = xwidth;
    xwidth2 = xwidth;
} else this_box_storage.x_width2 = xwidth2;

if (yheight2 < 0) {
    this_box_storage.y_height2 = yheight;
    yheight2 = yheight;
} else this_box_storage.y_height2 = yheight2;


this_box_storage.normal_vectors[0] = coords_set(0,0,1);
this_box_storage.normal_vectors[1] = coords_set(0,0,1);

// for sides with y component = 0
x_component = 2*zdepth/sqrt((xwidth-xwidth2)*(xwidth-xwidth2)+4*zdepth*zdepth);
z_component = (xwidth-xwidth2)/sqrt(4*zdepth*zdepth+(xwidth-xwidth2)*(xwidth-xwidth2));

this_box_storage.normal_vectors[2] = coords_set(x_component,0,z_component);
this_box_storage.normal_vectors[3] = coords_set(-x_component,0,z_component);

// for sides with x component = 0
y_component = 2*zdepth/sqrt((yheight-yheight2)*(yheight-yheight2)+4*zdepth*zdepth);
z_component = (yheight-yheight2)/sqrt(4*zdepth*zdepth+(yheight-yheight2)*(yheight-yheight2));

this_box_storage.normal_vectors[4] = coords_set(0,y_component,z_component);
this_box_storage.normal_vectors[5] = coords_set(0,-y_component,z_component);

this_box_volume.geometry.visualization_on = visualize;

this_box_volume.geometry.geometry_parameters.p_box_storage = &this_box_storage;

// Assign pointers to functions for intersection with the shape, checking if a point is inside the shape
if (this_box_storage.is_rectangle == 1) {
this_box_volume.geometry.intersect_function = &sample_box_intersect_simple;
this_box_volume.geometry.within_function = &r_within_box_simple;
}
else {
this_box_volume.geometry.intersect_function = &sample_box_intersect_advanced;
this_box_volume.geometry.within_function = &r_within_box_advanced;
}

this_box_volume.geometry.shell_points = &box_shell_points;
this_box_volume.geometry.mcdisplay_function = &mcdisplay_box_function;
this_box_volume.geometry.initialize_from_main_function = &initialize_box_geometry_from_main_component;
this_box_volume.geometry.process_rot_allocated = 0;

this_box_volume.geometry.copy_geometry_parameters = &allocate_box_storage_copy;

rot_copy(this_box_volume.geometry.rotation_matrix,ROT_A_CURRENT_COMP); //check how ROT_R_CURRENT_COMP would work
rot_transpose(ROT_A_CURRENT_COMP,this_box_volume.geometry.transpose_rotation_matrix);

// Initialize loggers
this_box_volume.loggers.num_elements = 0;

// packing the information into the global_geometry_element, which is then included in the global_geometry_list.
sprintf(global_geometry_element.name,NAME_CURRENT_COMP);
global_geometry_element.activation_counter = number_of_activations;
global_geometry_element.component_index = INDEX_CURRENT_COMP;
global_geometry_element.Volume = &this_box_volume; // Would be nicer if this m was a pointer, now we have the (small) data two places
add_element_to_geometry_list(&global_geometry_list,global_geometry_element);
}
#line 261395 "MACS_sample_kidney_box.c"
#undef number_of_activations
#undef mask_setting
#undef mask_string
#undef p_interact
#undef focus_r
#undef focus_xh
#undef focus_xw
#undef focus_ah
#undef focus_aw
#undef target_z
#undef target_y
#undef target_x
#undef target_index
#undef visualize
#undef yheight2
#undef xwidth2
#undef zdepth
#undef yheight
#undef xwidth
#undef priority
#undef material_string
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

  /* Initializations for component channel_11_cave1_box1. */
  SIG_MESSAGE("channel_11_cave1_box1 (Init)");
#define mccompcurname  channel_11_cave1_box1
#define mccompcurtype  Union_box
#define mccompcurindex 542
#define loop_index mccchannel_11_cave1_box1_loop_index
#define this_box_volume mccchannel_11_cave1_box1_this_box_volume
#define global_geometry_element mccchannel_11_cave1_box1_global_geometry_element
#define this_box_storage mccchannel_11_cave1_box1_this_box_storage
#define material_string mccchannel_11_cave1_box1_material_string
#define priority mccchannel_11_cave1_box1_priority
#define xwidth mccchannel_11_cave1_box1_xwidth
#define yheight mccchannel_11_cave1_box1_yheight
#define zdepth mccchannel_11_cave1_box1_zdepth
#define xwidth2 mccchannel_11_cave1_box1_xwidth2
#define yheight2 mccchannel_11_cave1_box1_yheight2
#define visualize mccchannel_11_cave1_box1_visualize
#define target_index mccchannel_11_cave1_box1_target_index
#define target_x mccchannel_11_cave1_box1_target_x
#define target_y mccchannel_11_cave1_box1_target_y
#define target_z mccchannel_11_cave1_box1_target_z
#define focus_aw mccchannel_11_cave1_box1_focus_aw
#define focus_ah mccchannel_11_cave1_box1_focus_ah
#define focus_xw mccchannel_11_cave1_box1_focus_xw
#define focus_xh mccchannel_11_cave1_box1_focus_xh
#define focus_r mccchannel_11_cave1_box1_focus_r
#define p_interact mccchannel_11_cave1_box1_p_interact
#define mask_string mccchannel_11_cave1_box1_mask_string
#define mask_setting mccchannel_11_cave1_box1_mask_setting
#define number_of_activations mccchannel_11_cave1_box1_number_of_activations
#line 224 "Union_box.comp"
{
// Initializes the focusing system for this volume including input sanitation.
focus_initialize(&this_box_volume.geometry, POS_A_COMP_INDEX(INDEX_CURRENT_COMP+target_index), POS_A_CURRENT_COMP, ROT_A_CURRENT_COMP, target_index, target_x, target_y, target_z, focus_aw, focus_ah, focus_xw, focus_xh, focus_r, NAME_CURRENT_COMP);

// Input sanitation for this geometry
if (xwidth <= 0) {
  printf("\nERROR in Union_box named %s, the xwidth is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (yheight <= 0) {
  printf("\nERROR in Union_box named %s, yheight is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (zdepth <= 0) {
  printf("\nERROR in Union_box named %s, zdepth is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (xwidth2 <= 0 && xwidth2 != -1) {
  printf("\nERROR in Union_box named %s, the xwidth2 is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (yheight2 <= 0 && yheight2 != -1) {
  printf("\nERROR in Union_box named %s, yheight2 is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}

// Use sanitation
if (global_material_list.num_elements == 0) {
  printf("\nERROR: Need to define a material using Union_make_material before using a Union geometry component. \n");
  printf("       %s was defined before first use of Union_make_material.\n",NAME_CURRENT_COMP);
  exit(1);
}

this_box_volume.geometry.is_masked_volume = 0;
this_box_volume.geometry.is_exit_volume = 0;
this_box_volume.geometry.is_mask_volume = 0;
// check if the volume is a mask, if it is the material string is irelevant.
if (mask_string && strlen(mask_string) && strcmp(mask_string, "NULL") && strcmp(mask_string, "0")) {
    // A mask volume is used to limit the extend of other volumes, called the masked volumes. These are specified in the mask_string.
    // In order for a ray to enter a masked volume, it needs to be both in the region covered by that volume AND the mask volume.
    // When more than
    this_box_volume.geometry.mask_mode = 1; // Default is mask mode is ALL
    if (mask_setting && strlen(mask_setting) && strcmp(mask_setting, "NULL") && strcmp(mask_setting, "0")) {
        if (strcmp(mask_setting,"ALL") == 0 || strcmp(mask_setting,"All") == 0) this_box_volume.geometry.mask_mode = 1;
        else if (strcmp(mask_setting,"ANY") == 0 || strcmp(mask_setting,"Any") == 0) this_box_volume.geometry.mask_mode = 2;
        else {
            printf("The mask_mode of component %s is set to %s, but must be either ALL or ANY.\n",NAME_CURRENT_COMP,mask_setting);
            exit(1);
        }
    }
    
    for (loop_index=0;loop_index<global_geometry_list.num_elements;loop_index++) {
        // Add mask list
        if (1 == manual_linking_function(global_geometry_list.elements[loop_index].name,mask_string)) {
            add_element_to_int_list(&this_box_volume.geometry.mask_list,global_geometry_list.elements[loop_index].component_index);
            add_element_to_int_list(&global_geometry_list.elements[loop_index].Volume->geometry.masked_by_list,INDEX_CURRENT_COMP);
            global_geometry_list.elements[loop_index].Volume->geometry.is_masked_volume = 1;
            if (this_box_volume.geometry.mask_mode == 2)
                global_geometry_list.elements[loop_index].Volume->geometry.mask_mode = 2;
            if (this_box_volume.geometry.mask_mode == 1) {
                if (global_geometry_list.elements[loop_index].Volume->geometry.is_masked_volume == 1 && global_geometry_list.elements[loop_index].Volume->geometry.mask_mode != 2)
                    // If more than one mask is added to one volume, the ANY mode overwrites the (default) ALL mode.
                    global_geometry_list.elements[loop_index].Volume->geometry.mask_mode = 1;
            }
            
            found_geometries = 1;
        }
    }
    if (found_geometries == 0) {
        printf("The mask_string in geometry: %s did not find any of the specified volumes in the mask_string %s \n",NAME_CURRENT_COMP,mask_string);
        exit(1);
    }
    this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
    this_box_volume.p_physics->is_vacuum = 0; // Makes this volume a vacuum
    this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
    this_box_volume.p_physics->my_a = 0; // Should not be used.
    sprintf(this_box_volume.p_physics->name,"Mask");
    this_box_volume.geometry.is_mask_volume = 1;
    
    
// Read the material input, or if it lacks, use automatic linking.
} else if (material_string && strlen(material_string) && strcmp(material_string, "NULL") && strcmp(material_string, "0")) {
    // A geometry string was given, use it to determine which material
    if (0 == strcmp(material_string,"vacuum") || 0 == strcmp(material_string,"Vacuum")) {
        // One could have a global physics struct for vacuum instead of creating one for each
        this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
        this_box_volume.p_physics->is_vacuum = 1; // Makes this volume a vacuum
        this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
        this_box_volume.p_physics->my_a = 0; // Should not be used.
        sprintf(this_box_volume.p_physics->name,"Vacuum");
    } else if (0 == strcmp(material_string,"exit") || 0 == strcmp(material_string,"Exit")) {
        // One could have a global physics struct for vacuum instead of creating one for each
        this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
        this_box_volume.p_physics->is_vacuum = 1; // Makes this volume a vacuum
        this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
        this_box_volume.p_physics->my_a = 0; // Should not be used.
        this_box_volume.geometry.is_exit_volume = 1;
        sprintf(this_box_volume.p_physics->name,"Exit");
    } else {
        #ifndef MATERIAL_DETECTOR
            printf("Need to define a material before refering to it in a geometry %s.\n",NAME_CURRENT_COMP);
            exit(1);
        #endif
        for (loop_index=0;loop_index<global_material_list.num_elements;loop_index++) {
            if (0 == strcmp(material_string,global_material_list.elements[loop_index].name)) {
                this_box_volume.p_physics = global_material_list.elements[loop_index].physics;
                break;
            }
            if (loop_index == global_material_list.num_elements-1) {
            printf("\n");
            printf("ERROR: The material string \"%s\" in Union geometry \"%s\" did not match a specified material. \n",material_string,NAME_CURRENT_COMP);
            printf("       The materials available at this point (need to be defined before the geometry): \n");
            for (loop_index=0;loop_index<global_material_list.num_elements;loop_index++)
              printf("         %s\n",global_material_list.elements[loop_index].name);
            printf("\n");
            printf("       It is also possible to use one of the defualt materials avaiable: \n");
            printf("           Vacuum (for a Volume without scattering or absorption)\n");
            printf("           Exit (for a Volume where the ray exits the component if it enters)\n");
            printf("           Mask (for a Volume that masks existing volumes specified in the mask_string\n");
            exit(1);
          }
        }
    }
} else {
    // Automatic linking, simply using the last defined material.
    #ifndef MATERIAL_DETECTOR
        printf("Need to define a material before the geometry to use automatic linking %s.\n",NAME_CURRENT_COMP);
        exit(1);
    #endif
    this_box_volume.p_physics = global_material_list.elements[global_material_list.num_elements-1].physics;
}

sprintf(this_box_volume.name,NAME_CURRENT_COMP);
sprintf(this_box_volume.geometry.shape,"box");
this_box_volume.geometry.priority_value = priority;
this_box_volume.geometry.geometry_p_interact = p_interact;
// Currently the coordinates will be in absolute space.
this_box_volume.geometry.center = POS_A_CURRENT_COMP;

this_box_storage.z_depth = zdepth;
this_box_storage.x_width1 = xwidth;
this_box_storage.y_height1 = yheight;

this_box_storage.is_rectangle = 0;
if (xwidth2 < 0 && yheight2 < 0) this_box_storage.is_rectangle = 1;
if (xwidth == xwidth2 && yheight == yheight2) this_box_storage.is_rectangle = 1;

if (xwidth2 < 0) {
    this_box_storage.x_width2 = xwidth;
    xwidth2 = xwidth;
} else this_box_storage.x_width2 = xwidth2;

if (yheight2 < 0) {
    this_box_storage.y_height2 = yheight;
    yheight2 = yheight;
} else this_box_storage.y_height2 = yheight2;


this_box_storage.normal_vectors[0] = coords_set(0,0,1);
this_box_storage.normal_vectors[1] = coords_set(0,0,1);

// for sides with y component = 0
x_component = 2*zdepth/sqrt((xwidth-xwidth2)*(xwidth-xwidth2)+4*zdepth*zdepth);
z_component = (xwidth-xwidth2)/sqrt(4*zdepth*zdepth+(xwidth-xwidth2)*(xwidth-xwidth2));

this_box_storage.normal_vectors[2] = coords_set(x_component,0,z_component);
this_box_storage.normal_vectors[3] = coords_set(-x_component,0,z_component);

// for sides with x component = 0
y_component = 2*zdepth/sqrt((yheight-yheight2)*(yheight-yheight2)+4*zdepth*zdepth);
z_component = (yheight-yheight2)/sqrt(4*zdepth*zdepth+(yheight-yheight2)*(yheight-yheight2));

this_box_storage.normal_vectors[4] = coords_set(0,y_component,z_component);
this_box_storage.normal_vectors[5] = coords_set(0,-y_component,z_component);

this_box_volume.geometry.visualization_on = visualize;

this_box_volume.geometry.geometry_parameters.p_box_storage = &this_box_storage;

// Assign pointers to functions for intersection with the shape, checking if a point is inside the shape
if (this_box_storage.is_rectangle == 1) {
this_box_volume.geometry.intersect_function = &sample_box_intersect_simple;
this_box_volume.geometry.within_function = &r_within_box_simple;
}
else {
this_box_volume.geometry.intersect_function = &sample_box_intersect_advanced;
this_box_volume.geometry.within_function = &r_within_box_advanced;
}

this_box_volume.geometry.shell_points = &box_shell_points;
this_box_volume.geometry.mcdisplay_function = &mcdisplay_box_function;
this_box_volume.geometry.initialize_from_main_function = &initialize_box_geometry_from_main_component;
this_box_volume.geometry.process_rot_allocated = 0;

this_box_volume.geometry.copy_geometry_parameters = &allocate_box_storage_copy;

rot_copy(this_box_volume.geometry.rotation_matrix,ROT_A_CURRENT_COMP); //check how ROT_R_CURRENT_COMP would work
rot_transpose(ROT_A_CURRENT_COMP,this_box_volume.geometry.transpose_rotation_matrix);

// Initialize loggers
this_box_volume.loggers.num_elements = 0;

// packing the information into the global_geometry_element, which is then included in the global_geometry_list.
sprintf(global_geometry_element.name,NAME_CURRENT_COMP);
global_geometry_element.activation_counter = number_of_activations;
global_geometry_element.component_index = INDEX_CURRENT_COMP;
global_geometry_element.Volume = &this_box_volume; // Would be nicer if this m was a pointer, now we have the (small) data two places
add_element_to_geometry_list(&global_geometry_list,global_geometry_element);
}
#line 261665 "MACS_sample_kidney_box.c"
#undef number_of_activations
#undef mask_setting
#undef mask_string
#undef p_interact
#undef focus_r
#undef focus_xh
#undef focus_xw
#undef focus_ah
#undef focus_aw
#undef target_z
#undef target_y
#undef target_x
#undef target_index
#undef visualize
#undef yheight2
#undef xwidth2
#undef zdepth
#undef yheight
#undef xwidth
#undef priority
#undef material_string
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

  /* Initializations for component channel_11_cave1_box2. */
  SIG_MESSAGE("channel_11_cave1_box2 (Init)");
#define mccompcurname  channel_11_cave1_box2
#define mccompcurtype  Union_box
#define mccompcurindex 543
#define loop_index mccchannel_11_cave1_box2_loop_index
#define this_box_volume mccchannel_11_cave1_box2_this_box_volume
#define global_geometry_element mccchannel_11_cave1_box2_global_geometry_element
#define this_box_storage mccchannel_11_cave1_box2_this_box_storage
#define material_string mccchannel_11_cave1_box2_material_string
#define priority mccchannel_11_cave1_box2_priority
#define xwidth mccchannel_11_cave1_box2_xwidth
#define yheight mccchannel_11_cave1_box2_yheight
#define zdepth mccchannel_11_cave1_box2_zdepth
#define xwidth2 mccchannel_11_cave1_box2_xwidth2
#define yheight2 mccchannel_11_cave1_box2_yheight2
#define visualize mccchannel_11_cave1_box2_visualize
#define target_index mccchannel_11_cave1_box2_target_index
#define target_x mccchannel_11_cave1_box2_target_x
#define target_y mccchannel_11_cave1_box2_target_y
#define target_z mccchannel_11_cave1_box2_target_z
#define focus_aw mccchannel_11_cave1_box2_focus_aw
#define focus_ah mccchannel_11_cave1_box2_focus_ah
#define focus_xw mccchannel_11_cave1_box2_focus_xw
#define focus_xh mccchannel_11_cave1_box2_focus_xh
#define focus_r mccchannel_11_cave1_box2_focus_r
#define p_interact mccchannel_11_cave1_box2_p_interact
#define mask_string mccchannel_11_cave1_box2_mask_string
#define mask_setting mccchannel_11_cave1_box2_mask_setting
#define number_of_activations mccchannel_11_cave1_box2_number_of_activations
#line 224 "Union_box.comp"
{
// Initializes the focusing system for this volume including input sanitation.
focus_initialize(&this_box_volume.geometry, POS_A_COMP_INDEX(INDEX_CURRENT_COMP+target_index), POS_A_CURRENT_COMP, ROT_A_CURRENT_COMP, target_index, target_x, target_y, target_z, focus_aw, focus_ah, focus_xw, focus_xh, focus_r, NAME_CURRENT_COMP);

// Input sanitation for this geometry
if (xwidth <= 0) {
  printf("\nERROR in Union_box named %s, the xwidth is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (yheight <= 0) {
  printf("\nERROR in Union_box named %s, yheight is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (zdepth <= 0) {
  printf("\nERROR in Union_box named %s, zdepth is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (xwidth2 <= 0 && xwidth2 != -1) {
  printf("\nERROR in Union_box named %s, the xwidth2 is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (yheight2 <= 0 && yheight2 != -1) {
  printf("\nERROR in Union_box named %s, yheight2 is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}

// Use sanitation
if (global_material_list.num_elements == 0) {
  printf("\nERROR: Need to define a material using Union_make_material before using a Union geometry component. \n");
  printf("       %s was defined before first use of Union_make_material.\n",NAME_CURRENT_COMP);
  exit(1);
}

this_box_volume.geometry.is_masked_volume = 0;
this_box_volume.geometry.is_exit_volume = 0;
this_box_volume.geometry.is_mask_volume = 0;
// check if the volume is a mask, if it is the material string is irelevant.
if (mask_string && strlen(mask_string) && strcmp(mask_string, "NULL") && strcmp(mask_string, "0")) {
    // A mask volume is used to limit the extend of other volumes, called the masked volumes. These are specified in the mask_string.
    // In order for a ray to enter a masked volume, it needs to be both in the region covered by that volume AND the mask volume.
    // When more than
    this_box_volume.geometry.mask_mode = 1; // Default is mask mode is ALL
    if (mask_setting && strlen(mask_setting) && strcmp(mask_setting, "NULL") && strcmp(mask_setting, "0")) {
        if (strcmp(mask_setting,"ALL") == 0 || strcmp(mask_setting,"All") == 0) this_box_volume.geometry.mask_mode = 1;
        else if (strcmp(mask_setting,"ANY") == 0 || strcmp(mask_setting,"Any") == 0) this_box_volume.geometry.mask_mode = 2;
        else {
            printf("The mask_mode of component %s is set to %s, but must be either ALL or ANY.\n",NAME_CURRENT_COMP,mask_setting);
            exit(1);
        }
    }
    
    for (loop_index=0;loop_index<global_geometry_list.num_elements;loop_index++) {
        // Add mask list
        if (1 == manual_linking_function(global_geometry_list.elements[loop_index].name,mask_string)) {
            add_element_to_int_list(&this_box_volume.geometry.mask_list,global_geometry_list.elements[loop_index].component_index);
            add_element_to_int_list(&global_geometry_list.elements[loop_index].Volume->geometry.masked_by_list,INDEX_CURRENT_COMP);
            global_geometry_list.elements[loop_index].Volume->geometry.is_masked_volume = 1;
            if (this_box_volume.geometry.mask_mode == 2)
                global_geometry_list.elements[loop_index].Volume->geometry.mask_mode = 2;
            if (this_box_volume.geometry.mask_mode == 1) {
                if (global_geometry_list.elements[loop_index].Volume->geometry.is_masked_volume == 1 && global_geometry_list.elements[loop_index].Volume->geometry.mask_mode != 2)
                    // If more than one mask is added to one volume, the ANY mode overwrites the (default) ALL mode.
                    global_geometry_list.elements[loop_index].Volume->geometry.mask_mode = 1;
            }
            
            found_geometries = 1;
        }
    }
    if (found_geometries == 0) {
        printf("The mask_string in geometry: %s did not find any of the specified volumes in the mask_string %s \n",NAME_CURRENT_COMP,mask_string);
        exit(1);
    }
    this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
    this_box_volume.p_physics->is_vacuum = 0; // Makes this volume a vacuum
    this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
    this_box_volume.p_physics->my_a = 0; // Should not be used.
    sprintf(this_box_volume.p_physics->name,"Mask");
    this_box_volume.geometry.is_mask_volume = 1;
    
    
// Read the material input, or if it lacks, use automatic linking.
} else if (material_string && strlen(material_string) && strcmp(material_string, "NULL") && strcmp(material_string, "0")) {
    // A geometry string was given, use it to determine which material
    if (0 == strcmp(material_string,"vacuum") || 0 == strcmp(material_string,"Vacuum")) {
        // One could have a global physics struct for vacuum instead of creating one for each
        this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
        this_box_volume.p_physics->is_vacuum = 1; // Makes this volume a vacuum
        this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
        this_box_volume.p_physics->my_a = 0; // Should not be used.
        sprintf(this_box_volume.p_physics->name,"Vacuum");
    } else if (0 == strcmp(material_string,"exit") || 0 == strcmp(material_string,"Exit")) {
        // One could have a global physics struct for vacuum instead of creating one for each
        this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
        this_box_volume.p_physics->is_vacuum = 1; // Makes this volume a vacuum
        this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
        this_box_volume.p_physics->my_a = 0; // Should not be used.
        this_box_volume.geometry.is_exit_volume = 1;
        sprintf(this_box_volume.p_physics->name,"Exit");
    } else {
        #ifndef MATERIAL_DETECTOR
            printf("Need to define a material before refering to it in a geometry %s.\n",NAME_CURRENT_COMP);
            exit(1);
        #endif
        for (loop_index=0;loop_index<global_material_list.num_elements;loop_index++) {
            if (0 == strcmp(material_string,global_material_list.elements[loop_index].name)) {
                this_box_volume.p_physics = global_material_list.elements[loop_index].physics;
                break;
            }
            if (loop_index == global_material_list.num_elements-1) {
            printf("\n");
            printf("ERROR: The material string \"%s\" in Union geometry \"%s\" did not match a specified material. \n",material_string,NAME_CURRENT_COMP);
            printf("       The materials available at this point (need to be defined before the geometry): \n");
            for (loop_index=0;loop_index<global_material_list.num_elements;loop_index++)
              printf("         %s\n",global_material_list.elements[loop_index].name);
            printf("\n");
            printf("       It is also possible to use one of the defualt materials avaiable: \n");
            printf("           Vacuum (for a Volume without scattering or absorption)\n");
            printf("           Exit (for a Volume where the ray exits the component if it enters)\n");
            printf("           Mask (for a Volume that masks existing volumes specified in the mask_string\n");
            exit(1);
          }
        }
    }
} else {
    // Automatic linking, simply using the last defined material.
    #ifndef MATERIAL_DETECTOR
        printf("Need to define a material before the geometry to use automatic linking %s.\n",NAME_CURRENT_COMP);
        exit(1);
    #endif
    this_box_volume.p_physics = global_material_list.elements[global_material_list.num_elements-1].physics;
}

sprintf(this_box_volume.name,NAME_CURRENT_COMP);
sprintf(this_box_volume.geometry.shape,"box");
this_box_volume.geometry.priority_value = priority;
this_box_volume.geometry.geometry_p_interact = p_interact;
// Currently the coordinates will be in absolute space.
this_box_volume.geometry.center = POS_A_CURRENT_COMP;

this_box_storage.z_depth = zdepth;
this_box_storage.x_width1 = xwidth;
this_box_storage.y_height1 = yheight;

this_box_storage.is_rectangle = 0;
if (xwidth2 < 0 && yheight2 < 0) this_box_storage.is_rectangle = 1;
if (xwidth == xwidth2 && yheight == yheight2) this_box_storage.is_rectangle = 1;

if (xwidth2 < 0) {
    this_box_storage.x_width2 = xwidth;
    xwidth2 = xwidth;
} else this_box_storage.x_width2 = xwidth2;

if (yheight2 < 0) {
    this_box_storage.y_height2 = yheight;
    yheight2 = yheight;
} else this_box_storage.y_height2 = yheight2;


this_box_storage.normal_vectors[0] = coords_set(0,0,1);
this_box_storage.normal_vectors[1] = coords_set(0,0,1);

// for sides with y component = 0
x_component = 2*zdepth/sqrt((xwidth-xwidth2)*(xwidth-xwidth2)+4*zdepth*zdepth);
z_component = (xwidth-xwidth2)/sqrt(4*zdepth*zdepth+(xwidth-xwidth2)*(xwidth-xwidth2));

this_box_storage.normal_vectors[2] = coords_set(x_component,0,z_component);
this_box_storage.normal_vectors[3] = coords_set(-x_component,0,z_component);

// for sides with x component = 0
y_component = 2*zdepth/sqrt((yheight-yheight2)*(yheight-yheight2)+4*zdepth*zdepth);
z_component = (yheight-yheight2)/sqrt(4*zdepth*zdepth+(yheight-yheight2)*(yheight-yheight2));

this_box_storage.normal_vectors[4] = coords_set(0,y_component,z_component);
this_box_storage.normal_vectors[5] = coords_set(0,-y_component,z_component);

this_box_volume.geometry.visualization_on = visualize;

this_box_volume.geometry.geometry_parameters.p_box_storage = &this_box_storage;

// Assign pointers to functions for intersection with the shape, checking if a point is inside the shape
if (this_box_storage.is_rectangle == 1) {
this_box_volume.geometry.intersect_function = &sample_box_intersect_simple;
this_box_volume.geometry.within_function = &r_within_box_simple;
}
else {
this_box_volume.geometry.intersect_function = &sample_box_intersect_advanced;
this_box_volume.geometry.within_function = &r_within_box_advanced;
}

this_box_volume.geometry.shell_points = &box_shell_points;
this_box_volume.geometry.mcdisplay_function = &mcdisplay_box_function;
this_box_volume.geometry.initialize_from_main_function = &initialize_box_geometry_from_main_component;
this_box_volume.geometry.process_rot_allocated = 0;

this_box_volume.geometry.copy_geometry_parameters = &allocate_box_storage_copy;

rot_copy(this_box_volume.geometry.rotation_matrix,ROT_A_CURRENT_COMP); //check how ROT_R_CURRENT_COMP would work
rot_transpose(ROT_A_CURRENT_COMP,this_box_volume.geometry.transpose_rotation_matrix);

// Initialize loggers
this_box_volume.loggers.num_elements = 0;

// packing the information into the global_geometry_element, which is then included in the global_geometry_list.
sprintf(global_geometry_element.name,NAME_CURRENT_COMP);
global_geometry_element.activation_counter = number_of_activations;
global_geometry_element.component_index = INDEX_CURRENT_COMP;
global_geometry_element.Volume = &this_box_volume; // Would be nicer if this m was a pointer, now we have the (small) data two places
add_element_to_geometry_list(&global_geometry_list,global_geometry_element);
}
#line 261935 "MACS_sample_kidney_box.c"
#undef number_of_activations
#undef mask_setting
#undef mask_string
#undef p_interact
#undef focus_r
#undef focus_xh
#undef focus_xw
#undef focus_ah
#undef focus_aw
#undef target_z
#undef target_y
#undef target_x
#undef target_index
#undef visualize
#undef yheight2
#undef xwidth2
#undef zdepth
#undef yheight
#undef xwidth
#undef priority
#undef material_string
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

  /* Initializations for component channel_11_cave1_box3. */
  SIG_MESSAGE("channel_11_cave1_box3 (Init)");
#define mccompcurname  channel_11_cave1_box3
#define mccompcurtype  Union_box
#define mccompcurindex 544
#define loop_index mccchannel_11_cave1_box3_loop_index
#define this_box_volume mccchannel_11_cave1_box3_this_box_volume
#define global_geometry_element mccchannel_11_cave1_box3_global_geometry_element
#define this_box_storage mccchannel_11_cave1_box3_this_box_storage
#define material_string mccchannel_11_cave1_box3_material_string
#define priority mccchannel_11_cave1_box3_priority
#define xwidth mccchannel_11_cave1_box3_xwidth
#define yheight mccchannel_11_cave1_box3_yheight
#define zdepth mccchannel_11_cave1_box3_zdepth
#define xwidth2 mccchannel_11_cave1_box3_xwidth2
#define yheight2 mccchannel_11_cave1_box3_yheight2
#define visualize mccchannel_11_cave1_box3_visualize
#define target_index mccchannel_11_cave1_box3_target_index
#define target_x mccchannel_11_cave1_box3_target_x
#define target_y mccchannel_11_cave1_box3_target_y
#define target_z mccchannel_11_cave1_box3_target_z
#define focus_aw mccchannel_11_cave1_box3_focus_aw
#define focus_ah mccchannel_11_cave1_box3_focus_ah
#define focus_xw mccchannel_11_cave1_box3_focus_xw
#define focus_xh mccchannel_11_cave1_box3_focus_xh
#define focus_r mccchannel_11_cave1_box3_focus_r
#define p_interact mccchannel_11_cave1_box3_p_interact
#define mask_string mccchannel_11_cave1_box3_mask_string
#define mask_setting mccchannel_11_cave1_box3_mask_setting
#define number_of_activations mccchannel_11_cave1_box3_number_of_activations
#line 224 "Union_box.comp"
{
// Initializes the focusing system for this volume including input sanitation.
focus_initialize(&this_box_volume.geometry, POS_A_COMP_INDEX(INDEX_CURRENT_COMP+target_index), POS_A_CURRENT_COMP, ROT_A_CURRENT_COMP, target_index, target_x, target_y, target_z, focus_aw, focus_ah, focus_xw, focus_xh, focus_r, NAME_CURRENT_COMP);

// Input sanitation for this geometry
if (xwidth <= 0) {
  printf("\nERROR in Union_box named %s, the xwidth is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (yheight <= 0) {
  printf("\nERROR in Union_box named %s, yheight is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (zdepth <= 0) {
  printf("\nERROR in Union_box named %s, zdepth is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (xwidth2 <= 0 && xwidth2 != -1) {
  printf("\nERROR in Union_box named %s, the xwidth2 is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (yheight2 <= 0 && yheight2 != -1) {
  printf("\nERROR in Union_box named %s, yheight2 is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}

// Use sanitation
if (global_material_list.num_elements == 0) {
  printf("\nERROR: Need to define a material using Union_make_material before using a Union geometry component. \n");
  printf("       %s was defined before first use of Union_make_material.\n",NAME_CURRENT_COMP);
  exit(1);
}

this_box_volume.geometry.is_masked_volume = 0;
this_box_volume.geometry.is_exit_volume = 0;
this_box_volume.geometry.is_mask_volume = 0;
// check if the volume is a mask, if it is the material string is irelevant.
if (mask_string && strlen(mask_string) && strcmp(mask_string, "NULL") && strcmp(mask_string, "0")) {
    // A mask volume is used to limit the extend of other volumes, called the masked volumes. These are specified in the mask_string.
    // In order for a ray to enter a masked volume, it needs to be both in the region covered by that volume AND the mask volume.
    // When more than
    this_box_volume.geometry.mask_mode = 1; // Default is mask mode is ALL
    if (mask_setting && strlen(mask_setting) && strcmp(mask_setting, "NULL") && strcmp(mask_setting, "0")) {
        if (strcmp(mask_setting,"ALL") == 0 || strcmp(mask_setting,"All") == 0) this_box_volume.geometry.mask_mode = 1;
        else if (strcmp(mask_setting,"ANY") == 0 || strcmp(mask_setting,"Any") == 0) this_box_volume.geometry.mask_mode = 2;
        else {
            printf("The mask_mode of component %s is set to %s, but must be either ALL or ANY.\n",NAME_CURRENT_COMP,mask_setting);
            exit(1);
        }
    }
    
    for (loop_index=0;loop_index<global_geometry_list.num_elements;loop_index++) {
        // Add mask list
        if (1 == manual_linking_function(global_geometry_list.elements[loop_index].name,mask_string)) {
            add_element_to_int_list(&this_box_volume.geometry.mask_list,global_geometry_list.elements[loop_index].component_index);
            add_element_to_int_list(&global_geometry_list.elements[loop_index].Volume->geometry.masked_by_list,INDEX_CURRENT_COMP);
            global_geometry_list.elements[loop_index].Volume->geometry.is_masked_volume = 1;
            if (this_box_volume.geometry.mask_mode == 2)
                global_geometry_list.elements[loop_index].Volume->geometry.mask_mode = 2;
            if (this_box_volume.geometry.mask_mode == 1) {
                if (global_geometry_list.elements[loop_index].Volume->geometry.is_masked_volume == 1 && global_geometry_list.elements[loop_index].Volume->geometry.mask_mode != 2)
                    // If more than one mask is added to one volume, the ANY mode overwrites the (default) ALL mode.
                    global_geometry_list.elements[loop_index].Volume->geometry.mask_mode = 1;
            }
            
            found_geometries = 1;
        }
    }
    if (found_geometries == 0) {
        printf("The mask_string in geometry: %s did not find any of the specified volumes in the mask_string %s \n",NAME_CURRENT_COMP,mask_string);
        exit(1);
    }
    this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
    this_box_volume.p_physics->is_vacuum = 0; // Makes this volume a vacuum
    this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
    this_box_volume.p_physics->my_a = 0; // Should not be used.
    sprintf(this_box_volume.p_physics->name,"Mask");
    this_box_volume.geometry.is_mask_volume = 1;
    
    
// Read the material input, or if it lacks, use automatic linking.
} else if (material_string && strlen(material_string) && strcmp(material_string, "NULL") && strcmp(material_string, "0")) {
    // A geometry string was given, use it to determine which material
    if (0 == strcmp(material_string,"vacuum") || 0 == strcmp(material_string,"Vacuum")) {
        // One could have a global physics struct for vacuum instead of creating one for each
        this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
        this_box_volume.p_physics->is_vacuum = 1; // Makes this volume a vacuum
        this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
        this_box_volume.p_physics->my_a = 0; // Should not be used.
        sprintf(this_box_volume.p_physics->name,"Vacuum");
    } else if (0 == strcmp(material_string,"exit") || 0 == strcmp(material_string,"Exit")) {
        // One could have a global physics struct for vacuum instead of creating one for each
        this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
        this_box_volume.p_physics->is_vacuum = 1; // Makes this volume a vacuum
        this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
        this_box_volume.p_physics->my_a = 0; // Should not be used.
        this_box_volume.geometry.is_exit_volume = 1;
        sprintf(this_box_volume.p_physics->name,"Exit");
    } else {
        #ifndef MATERIAL_DETECTOR
            printf("Need to define a material before refering to it in a geometry %s.\n",NAME_CURRENT_COMP);
            exit(1);
        #endif
        for (loop_index=0;loop_index<global_material_list.num_elements;loop_index++) {
            if (0 == strcmp(material_string,global_material_list.elements[loop_index].name)) {
                this_box_volume.p_physics = global_material_list.elements[loop_index].physics;
                break;
            }
            if (loop_index == global_material_list.num_elements-1) {
            printf("\n");
            printf("ERROR: The material string \"%s\" in Union geometry \"%s\" did not match a specified material. \n",material_string,NAME_CURRENT_COMP);
            printf("       The materials available at this point (need to be defined before the geometry): \n");
            for (loop_index=0;loop_index<global_material_list.num_elements;loop_index++)
              printf("         %s\n",global_material_list.elements[loop_index].name);
            printf("\n");
            printf("       It is also possible to use one of the defualt materials avaiable: \n");
            printf("           Vacuum (for a Volume without scattering or absorption)\n");
            printf("           Exit (for a Volume where the ray exits the component if it enters)\n");
            printf("           Mask (for a Volume that masks existing volumes specified in the mask_string\n");
            exit(1);
          }
        }
    }
} else {
    // Automatic linking, simply using the last defined material.
    #ifndef MATERIAL_DETECTOR
        printf("Need to define a material before the geometry to use automatic linking %s.\n",NAME_CURRENT_COMP);
        exit(1);
    #endif
    this_box_volume.p_physics = global_material_list.elements[global_material_list.num_elements-1].physics;
}

sprintf(this_box_volume.name,NAME_CURRENT_COMP);
sprintf(this_box_volume.geometry.shape,"box");
this_box_volume.geometry.priority_value = priority;
this_box_volume.geometry.geometry_p_interact = p_interact;
// Currently the coordinates will be in absolute space.
this_box_volume.geometry.center = POS_A_CURRENT_COMP;

this_box_storage.z_depth = zdepth;
this_box_storage.x_width1 = xwidth;
this_box_storage.y_height1 = yheight;

this_box_storage.is_rectangle = 0;
if (xwidth2 < 0 && yheight2 < 0) this_box_storage.is_rectangle = 1;
if (xwidth == xwidth2 && yheight == yheight2) this_box_storage.is_rectangle = 1;

if (xwidth2 < 0) {
    this_box_storage.x_width2 = xwidth;
    xwidth2 = xwidth;
} else this_box_storage.x_width2 = xwidth2;

if (yheight2 < 0) {
    this_box_storage.y_height2 = yheight;
    yheight2 = yheight;
} else this_box_storage.y_height2 = yheight2;


this_box_storage.normal_vectors[0] = coords_set(0,0,1);
this_box_storage.normal_vectors[1] = coords_set(0,0,1);

// for sides with y component = 0
x_component = 2*zdepth/sqrt((xwidth-xwidth2)*(xwidth-xwidth2)+4*zdepth*zdepth);
z_component = (xwidth-xwidth2)/sqrt(4*zdepth*zdepth+(xwidth-xwidth2)*(xwidth-xwidth2));

this_box_storage.normal_vectors[2] = coords_set(x_component,0,z_component);
this_box_storage.normal_vectors[3] = coords_set(-x_component,0,z_component);

// for sides with x component = 0
y_component = 2*zdepth/sqrt((yheight-yheight2)*(yheight-yheight2)+4*zdepth*zdepth);
z_component = (yheight-yheight2)/sqrt(4*zdepth*zdepth+(yheight-yheight2)*(yheight-yheight2));

this_box_storage.normal_vectors[4] = coords_set(0,y_component,z_component);
this_box_storage.normal_vectors[5] = coords_set(0,-y_component,z_component);

this_box_volume.geometry.visualization_on = visualize;

this_box_volume.geometry.geometry_parameters.p_box_storage = &this_box_storage;

// Assign pointers to functions for intersection with the shape, checking if a point is inside the shape
if (this_box_storage.is_rectangle == 1) {
this_box_volume.geometry.intersect_function = &sample_box_intersect_simple;
this_box_volume.geometry.within_function = &r_within_box_simple;
}
else {
this_box_volume.geometry.intersect_function = &sample_box_intersect_advanced;
this_box_volume.geometry.within_function = &r_within_box_advanced;
}

this_box_volume.geometry.shell_points = &box_shell_points;
this_box_volume.geometry.mcdisplay_function = &mcdisplay_box_function;
this_box_volume.geometry.initialize_from_main_function = &initialize_box_geometry_from_main_component;
this_box_volume.geometry.process_rot_allocated = 0;

this_box_volume.geometry.copy_geometry_parameters = &allocate_box_storage_copy;

rot_copy(this_box_volume.geometry.rotation_matrix,ROT_A_CURRENT_COMP); //check how ROT_R_CURRENT_COMP would work
rot_transpose(ROT_A_CURRENT_COMP,this_box_volume.geometry.transpose_rotation_matrix);

// Initialize loggers
this_box_volume.loggers.num_elements = 0;

// packing the information into the global_geometry_element, which is then included in the global_geometry_list.
sprintf(global_geometry_element.name,NAME_CURRENT_COMP);
global_geometry_element.activation_counter = number_of_activations;
global_geometry_element.component_index = INDEX_CURRENT_COMP;
global_geometry_element.Volume = &this_box_volume; // Would be nicer if this m was a pointer, now we have the (small) data two places
add_element_to_geometry_list(&global_geometry_list,global_geometry_element);
}
#line 262205 "MACS_sample_kidney_box.c"
#undef number_of_activations
#undef mask_setting
#undef mask_string
#undef p_interact
#undef focus_r
#undef focus_xh
#undef focus_xw
#undef focus_ah
#undef focus_aw
#undef target_z
#undef target_y
#undef target_x
#undef target_index
#undef visualize
#undef yheight2
#undef xwidth2
#undef zdepth
#undef yheight
#undef xwidth
#undef priority
#undef material_string
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

  /* Initializations for component channel_11_cave1_cyl1. */
  SIG_MESSAGE("channel_11_cave1_cyl1 (Init)");
#define mccompcurname  channel_11_cave1_cyl1
#define mccompcurtype  Union_cylinder
#define mccompcurindex 545
#define loop_index mccchannel_11_cave1_cyl1_loop_index
#define this_cylinder_volume mccchannel_11_cave1_cyl1_this_cylinder_volume
#define global_geometry_element mccchannel_11_cave1_cyl1_global_geometry_element
#define this_cylinder_storage mccchannel_11_cave1_cyl1_this_cylinder_storage
#define material_string mccchannel_11_cave1_cyl1_material_string
#define priority mccchannel_11_cave1_cyl1_priority
#define radius mccchannel_11_cave1_cyl1_radius
#define yheight mccchannel_11_cave1_cyl1_yheight
#define visualize mccchannel_11_cave1_cyl1_visualize
#define target_index mccchannel_11_cave1_cyl1_target_index
#define target_x mccchannel_11_cave1_cyl1_target_x
#define target_y mccchannel_11_cave1_cyl1_target_y
#define target_z mccchannel_11_cave1_cyl1_target_z
#define focus_aw mccchannel_11_cave1_cyl1_focus_aw
#define focus_ah mccchannel_11_cave1_cyl1_focus_ah
#define focus_xw mccchannel_11_cave1_cyl1_focus_xw
#define focus_xh mccchannel_11_cave1_cyl1_focus_xh
#define focus_r mccchannel_11_cave1_cyl1_focus_r
#define p_interact mccchannel_11_cave1_cyl1_p_interact
#define mask_string mccchannel_11_cave1_cyl1_mask_string
#define mask_setting mccchannel_11_cave1_cyl1_mask_setting
#define number_of_activations mccchannel_11_cave1_cyl1_number_of_activations
#line 185 "Union_cylinder.comp"
{
// Initializes the focusing system for this volume including input sanitation.
focus_initialize(&this_cylinder_volume.geometry, POS_A_COMP_INDEX(INDEX_CURRENT_COMP+target_index), POS_A_CURRENT_COMP, ROT_A_CURRENT_COMP, target_index, target_x, target_y, target_z, focus_aw, focus_ah, focus_xw, focus_xh, focus_r, NAME_CURRENT_COMP);

// Input sanitation for this geometry
if (radius <= 0) {
  printf("\nERROR in Union_cylinder named %s, the radius is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}

if (yheight <= 0) {
  printf("\nERROR in Union_cylinder named %s, yheight is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}

// Use sanitation
#ifdef MATERIAL_DETECTOR
if (global_material_list.num_elements == 0) {
  // Here if the user have defined a material, but only after this material
  printf("\nERROR: Need to define a material using Union_make_material before using a Union geometry component. \n");
  printf("       %s was defined before first use of Union_make_material.\n",NAME_CURRENT_COMP);
  exit(1);
}
#endif
#ifndef MATERIAL_DETECTOR
  printf("\nERROR: Need to define a material using Union_make_material before using a Union geometry component. \n");
  exit(1);
#endif


this_cylinder_volume.geometry.is_masked_volume = 0;
this_cylinder_volume.geometry.is_exit_volume = 0;
this_cylinder_volume.geometry.is_mask_volume = 0;

// Read the material input, or if it lacks, use automatic linking.
if (mask_string && strlen(mask_string) && strcmp(mask_string, "NULL") && strcmp(mask_string, "0")) {
    // A mask volume is used to limit the extend of other volumes, called the masked volumes. These are specified in the mask_string.
    // In order for a ray to enter a masked volume, it needs to be both in the region covered by that volume AND the mask volume.
    // When more than
    this_cylinder_volume.geometry.mask_mode = 1; // Default is mask mode is ALL
    if (mask_setting && strlen(mask_setting) && strcmp(mask_setting, "NULL") && strcmp(mask_setting, "0")) {
        if (strcmp(mask_setting,"ALL") == 0 || strcmp(mask_setting,"All") == 0) this_cylinder_volume.geometry.mask_mode = 1;
        else if (strcmp(mask_setting,"ANY") == 0 || strcmp(mask_setting,"Any") == 0) this_cylinder_volume.geometry.mask_mode = 2;
        else {
            printf("The mask_mode of component %s is set to %s, but must be either ALL or ANY.\n",NAME_CURRENT_COMP,mask_setting);
            exit(1);
        }
    }
    
    for (loop_index=0;loop_index<global_geometry_list.num_elements;loop_index++) {
        // Add mask list
        if (1 == manual_linking_function(global_geometry_list.elements[loop_index].name,mask_string)) {
            add_element_to_int_list(&this_cylinder_volume.geometry.mask_list,global_geometry_list.elements[loop_index].component_index);
            add_element_to_int_list(&global_geometry_list.elements[loop_index].Volume->geometry.masked_by_list,INDEX_CURRENT_COMP);
            global_geometry_list.elements[loop_index].Volume->geometry.is_masked_volume = 1;
            if (this_cylinder_volume.geometry.mask_mode == 2)
                global_geometry_list.elements[loop_index].Volume->geometry.mask_mode = 2;
            if (this_cylinder_volume.geometry.mask_mode == 1) {
                if (global_geometry_list.elements[loop_index].Volume->geometry.is_masked_volume == 1 && global_geometry_list.elements[loop_index].Volume->geometry.mask_mode != 2)
                    // If more than one mask is added to one volume, the ANY mode overwrites the (default) ALL mode.
                    global_geometry_list.elements[loop_index].Volume->geometry.mask_mode = 1;
            }
            
            found_geometries = 1;
        }
    }
    if (found_geometries == 0) {
        printf("The mask_string in geometry: %s did not find any of the specified volumes in the mask_string %s \n",NAME_CURRENT_COMP,mask_string);
        exit(1);
    }
    this_cylinder_volume.p_physics = malloc(sizeof(struct physics_struct));
    this_cylinder_volume.p_physics->is_vacuum = 0; // Makes this volume a vacuum
    this_cylinder_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
    this_cylinder_volume.p_physics->my_a = 0; // Should not be used.
    sprintf(this_cylinder_volume.p_physics->name,"Mask");
    this_cylinder_volume.geometry.is_mask_volume = 1;
    
    
// Read the material input, or if it lacks, use automatic linking.
} else if (material_string && strlen(material_string) && strcmp(material_string, "NULL") && strcmp(material_string, "0")) {
    // A geometry string was given, use it to determine which material
    if (0 == strcmp(material_string,"vacuum") || 0 == strcmp(material_string,"Vacuum")) {
        // One could have a global physics struct for vacuum instead of creating one for each
        this_cylinder_volume.p_physics = malloc(sizeof(struct physics_struct));
        this_cylinder_volume.p_physics->is_vacuum = 1; // Makes this volume a vacuum
        this_cylinder_volume.p_physics->number_of_processes = (int) 0;
        this_cylinder_volume.p_physics->my_a = 0; // Should not be used.
        sprintf(this_cylinder_volume.p_physics->name,"Vacuum");
    } else if (0 == strcmp(material_string,"exit") || 0 == strcmp(material_string,"Exit")) {
        // One could have a global physics struct for exit instead of creating one for each
        this_cylinder_volume.p_physics = malloc(sizeof(struct physics_struct));
        this_cylinder_volume.p_physics->is_vacuum = 1; // Makes this volume a vacuum
        this_cylinder_volume.p_physics->number_of_processes = (int) 0;
        this_cylinder_volume.p_physics->my_a = 0; // Should not be used.
        this_cylinder_volume.geometry.is_exit_volume = 1;
        sprintf(this_cylinder_volume.p_physics->name,"Exit");
    } else {
        for (loop_index=0;loop_index<global_material_list.num_elements;loop_index++) {
          if (0 == strcmp(material_string,global_material_list.elements[loop_index].name)) {
            this_cylinder_volume.p_physics = global_material_list.elements[loop_index].physics;
            break;
          }
          if (loop_index == global_material_list.num_elements-1) {
            printf("\n");
            printf("ERROR: The material string \"%s\" in Union geometry \"%s\" did not match a specified material. \n",material_string,NAME_CURRENT_COMP);
            printf("       The materials available at this point (need to be defined before the geometry): \n");
            for (loop_index=0;loop_index<global_material_list.num_elements;loop_index++)
              printf("         %s\n",global_material_list.elements[loop_index].name);
            printf("\n");
            printf("       It is also possible to use one of the defualt materials avaiable: \n");
            printf("           Vacuum (for a Volume without scattering or absorption)\n");
            printf("           Exit (for a Volume where the ray exits the component if it enters)\n");
            printf("           Mask (for a Volume that masks existing volumes specified in the mask_string\n");
            exit(1);
          }
        }
    }
} else {
    // Automatic linking, simply using the last defined material.
    #ifndef MATERIAL_DETECTOR
        printf("Need to define a material before the geometry to use automatic linking %s.\n",NAME_CURRENT_COMP);
        exit(1);
    #endif
    this_cylinder_volume.p_physics = global_material_list.elements[global_material_list.num_elements-1].physics;
}

sprintf(this_cylinder_volume.name,NAME_CURRENT_COMP);
sprintf(this_cylinder_volume.geometry.shape,"cylinder");
this_cylinder_volume.geometry.priority_value = priority;
// Currently the coordinates will be in absolute space.
this_cylinder_volume.geometry.center = POS_A_CURRENT_COMP;

this_cylinder_volume.geometry.geometry_p_interact = p_interact;
this_cylinder_storage.cyl_radius = radius;
this_cylinder_storage.height = yheight;
this_cylinder_volume.geometry.visualization_on = visualize;
this_cylinder_volume.geometry.geometry_parameters.p_cylinder_storage = &this_cylinder_storage;
this_cylinder_volume.geometry.within_function = &r_within_cylinder;
this_cylinder_volume.geometry.intersect_function = &sample_cylinder_intersect;
this_cylinder_volume.geometry.mcdisplay_function = &mcdisplay_cylinder_function;
this_cylinder_volume.geometry.shell_points = &cylinder_shell_points;
this_cylinder_volume.geometry.initialize_from_main_function = &initialize_cylinder_geometry_from_main_component;
this_cylinder_volume.geometry.process_rot_allocated = 0;
this_cylinder_volume.geometry.copy_geometry_parameters = &allocate_cylinder_storage_copy;

rot_copy(this_cylinder_volume.geometry.rotation_matrix,ROT_A_CURRENT_COMP);
rot_transpose(ROT_A_CURRENT_COMP,this_cylinder_volume.geometry.transpose_rotation_matrix);

// Initialize loggers
this_cylinder_volume.loggers.num_elements = 0;

// packing the information into the global_geometry_element, which is then included in the global_geometry_list.
sprintf(global_geometry_element.name,NAME_CURRENT_COMP);
global_geometry_element.activation_counter = number_of_activations;
global_geometry_element.component_index = INDEX_CURRENT_COMP;
global_geometry_element.Volume = &this_cylinder_volume; // Would be nicer if this m was a pointer, now we have the (small) data two places
add_element_to_geometry_list(&global_geometry_list,global_geometry_element);
}
#line 262421 "MACS_sample_kidney_box.c"
#undef number_of_activations
#undef mask_setting
#undef mask_string
#undef p_interact
#undef focus_r
#undef focus_xh
#undef focus_xw
#undef focus_ah
#undef focus_aw
#undef target_z
#undef target_y
#undef target_x
#undef target_index
#undef visualize
#undef yheight
#undef radius
#undef priority
#undef material_string
#undef this_cylinder_storage
#undef global_geometry_element
#undef this_cylinder_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

  /* Initializations for component channel_11_analyzer_1_center. */
  SIG_MESSAGE("channel_11_analyzer_1_center (Init)");

  /* Initializations for component channel_11_analyzer_1_rotated. */
  SIG_MESSAGE("channel_11_analyzer_1_rotated (Init)");

  /* Initializations for component channel_11_analyzer_1_array_crystal_array_0. */
  SIG_MESSAGE("channel_11_analyzer_1_array_crystal_array_0 (Init)");
#define mccompcurname  channel_11_analyzer_1_array_crystal_array_0
#define mccompcurtype  Union_box
#define mccompcurindex 548
#define loop_index mccchannel_11_analyzer_1_array_crystal_array_0_loop_index
#define this_box_volume mccchannel_11_analyzer_1_array_crystal_array_0_this_box_volume
#define global_geometry_element mccchannel_11_analyzer_1_array_crystal_array_0_global_geometry_element
#define this_box_storage mccchannel_11_analyzer_1_array_crystal_array_0_this_box_storage
#define material_string mccchannel_11_analyzer_1_array_crystal_array_0_material_string
#define priority mccchannel_11_analyzer_1_array_crystal_array_0_priority
#define xwidth mccchannel_11_analyzer_1_array_crystal_array_0_xwidth
#define yheight mccchannel_11_analyzer_1_array_crystal_array_0_yheight
#define zdepth mccchannel_11_analyzer_1_array_crystal_array_0_zdepth
#define xwidth2 mccchannel_11_analyzer_1_array_crystal_array_0_xwidth2
#define yheight2 mccchannel_11_analyzer_1_array_crystal_array_0_yheight2
#define visualize mccchannel_11_analyzer_1_array_crystal_array_0_visualize
#define target_index mccchannel_11_analyzer_1_array_crystal_array_0_target_index
#define target_x mccchannel_11_analyzer_1_array_crystal_array_0_target_x
#define target_y mccchannel_11_analyzer_1_array_crystal_array_0_target_y
#define target_z mccchannel_11_analyzer_1_array_crystal_array_0_target_z
#define focus_aw mccchannel_11_analyzer_1_array_crystal_array_0_focus_aw
#define focus_ah mccchannel_11_analyzer_1_array_crystal_array_0_focus_ah
#define focus_xw mccchannel_11_analyzer_1_array_crystal_array_0_focus_xw
#define focus_xh mccchannel_11_analyzer_1_array_crystal_array_0_focus_xh
#define focus_r mccchannel_11_analyzer_1_array_crystal_array_0_focus_r
#define p_interact mccchannel_11_analyzer_1_array_crystal_array_0_p_interact
#define mask_string mccchannel_11_analyzer_1_array_crystal_array_0_mask_string
#define mask_setting mccchannel_11_analyzer_1_array_crystal_array_0_mask_setting
#define number_of_activations mccchannel_11_analyzer_1_array_crystal_array_0_number_of_activations
#line 224 "Union_box.comp"
{
// Initializes the focusing system for this volume including input sanitation.
focus_initialize(&this_box_volume.geometry, POS_A_COMP_INDEX(INDEX_CURRENT_COMP+target_index), POS_A_CURRENT_COMP, ROT_A_CURRENT_COMP, target_index, target_x, target_y, target_z, focus_aw, focus_ah, focus_xw, focus_xh, focus_r, NAME_CURRENT_COMP);

// Input sanitation for this geometry
if (xwidth <= 0) {
  printf("\nERROR in Union_box named %s, the xwidth is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (yheight <= 0) {
  printf("\nERROR in Union_box named %s, yheight is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (zdepth <= 0) {
  printf("\nERROR in Union_box named %s, zdepth is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (xwidth2 <= 0 && xwidth2 != -1) {
  printf("\nERROR in Union_box named %s, the xwidth2 is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (yheight2 <= 0 && yheight2 != -1) {
  printf("\nERROR in Union_box named %s, yheight2 is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}

// Use sanitation
if (global_material_list.num_elements == 0) {
  printf("\nERROR: Need to define a material using Union_make_material before using a Union geometry component. \n");
  printf("       %s was defined before first use of Union_make_material.\n",NAME_CURRENT_COMP);
  exit(1);
}

this_box_volume.geometry.is_masked_volume = 0;
this_box_volume.geometry.is_exit_volume = 0;
this_box_volume.geometry.is_mask_volume = 0;
// check if the volume is a mask, if it is the material string is irelevant.
if (mask_string && strlen(mask_string) && strcmp(mask_string, "NULL") && strcmp(mask_string, "0")) {
    // A mask volume is used to limit the extend of other volumes, called the masked volumes. These are specified in the mask_string.
    // In order for a ray to enter a masked volume, it needs to be both in the region covered by that volume AND the mask volume.
    // When more than
    this_box_volume.geometry.mask_mode = 1; // Default is mask mode is ALL
    if (mask_setting && strlen(mask_setting) && strcmp(mask_setting, "NULL") && strcmp(mask_setting, "0")) {
        if (strcmp(mask_setting,"ALL") == 0 || strcmp(mask_setting,"All") == 0) this_box_volume.geometry.mask_mode = 1;
        else if (strcmp(mask_setting,"ANY") == 0 || strcmp(mask_setting,"Any") == 0) this_box_volume.geometry.mask_mode = 2;
        else {
            printf("The mask_mode of component %s is set to %s, but must be either ALL or ANY.\n",NAME_CURRENT_COMP,mask_setting);
            exit(1);
        }
    }
    
    for (loop_index=0;loop_index<global_geometry_list.num_elements;loop_index++) {
        // Add mask list
        if (1 == manual_linking_function(global_geometry_list.elements[loop_index].name,mask_string)) {
            add_element_to_int_list(&this_box_volume.geometry.mask_list,global_geometry_list.elements[loop_index].component_index);
            add_element_to_int_list(&global_geometry_list.elements[loop_index].Volume->geometry.masked_by_list,INDEX_CURRENT_COMP);
            global_geometry_list.elements[loop_index].Volume->geometry.is_masked_volume = 1;
            if (this_box_volume.geometry.mask_mode == 2)
                global_geometry_list.elements[loop_index].Volume->geometry.mask_mode = 2;
            if (this_box_volume.geometry.mask_mode == 1) {
                if (global_geometry_list.elements[loop_index].Volume->geometry.is_masked_volume == 1 && global_geometry_list.elements[loop_index].Volume->geometry.mask_mode != 2)
                    // If more than one mask is added to one volume, the ANY mode overwrites the (default) ALL mode.
                    global_geometry_list.elements[loop_index].Volume->geometry.mask_mode = 1;
            }
            
            found_geometries = 1;
        }
    }
    if (found_geometries == 0) {
        printf("The mask_string in geometry: %s did not find any of the specified volumes in the mask_string %s \n",NAME_CURRENT_COMP,mask_string);
        exit(1);
    }
    this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
    this_box_volume.p_physics->is_vacuum = 0; // Makes this volume a vacuum
    this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
    this_box_volume.p_physics->my_a = 0; // Should not be used.
    sprintf(this_box_volume.p_physics->name,"Mask");
    this_box_volume.geometry.is_mask_volume = 1;
    
    
// Read the material input, or if it lacks, use automatic linking.
} else if (material_string && strlen(material_string) && strcmp(material_string, "NULL") && strcmp(material_string, "0")) {
    // A geometry string was given, use it to determine which material
    if (0 == strcmp(material_string,"vacuum") || 0 == strcmp(material_string,"Vacuum")) {
        // One could have a global physics struct for vacuum instead of creating one for each
        this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
        this_box_volume.p_physics->is_vacuum = 1; // Makes this volume a vacuum
        this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
        this_box_volume.p_physics->my_a = 0; // Should not be used.
        sprintf(this_box_volume.p_physics->name,"Vacuum");
    } else if (0 == strcmp(material_string,"exit") || 0 == strcmp(material_string,"Exit")) {
        // One could have a global physics struct for vacuum instead of creating one for each
        this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
        this_box_volume.p_physics->is_vacuum = 1; // Makes this volume a vacuum
        this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
        this_box_volume.p_physics->my_a = 0; // Should not be used.
        this_box_volume.geometry.is_exit_volume = 1;
        sprintf(this_box_volume.p_physics->name,"Exit");
    } else {
        #ifndef MATERIAL_DETECTOR
            printf("Need to define a material before refering to it in a geometry %s.\n",NAME_CURRENT_COMP);
            exit(1);
        #endif
        for (loop_index=0;loop_index<global_material_list.num_elements;loop_index++) {
            if (0 == strcmp(material_string,global_material_list.elements[loop_index].name)) {
                this_box_volume.p_physics = global_material_list.elements[loop_index].physics;
                break;
            }
            if (loop_index == global_material_list.num_elements-1) {
            printf("\n");
            printf("ERROR: The material string \"%s\" in Union geometry \"%s\" did not match a specified material. \n",material_string,NAME_CURRENT_COMP);
            printf("       The materials available at this point (need to be defined before the geometry): \n");
            for (loop_index=0;loop_index<global_material_list.num_elements;loop_index++)
              printf("         %s\n",global_material_list.elements[loop_index].name);
            printf("\n");
            printf("       It is also possible to use one of the defualt materials avaiable: \n");
            printf("           Vacuum (for a Volume without scattering or absorption)\n");
            printf("           Exit (for a Volume where the ray exits the component if it enters)\n");
            printf("           Mask (for a Volume that masks existing volumes specified in the mask_string\n");
            exit(1);
          }
        }
    }
} else {
    // Automatic linking, simply using the last defined material.
    #ifndef MATERIAL_DETECTOR
        printf("Need to define a material before the geometry to use automatic linking %s.\n",NAME_CURRENT_COMP);
        exit(1);
    #endif
    this_box_volume.p_physics = global_material_list.elements[global_material_list.num_elements-1].physics;
}

sprintf(this_box_volume.name,NAME_CURRENT_COMP);
sprintf(this_box_volume.geometry.shape,"box");
this_box_volume.geometry.priority_value = priority;
this_box_volume.geometry.geometry_p_interact = p_interact;
// Currently the coordinates will be in absolute space.
this_box_volume.geometry.center = POS_A_CURRENT_COMP;

this_box_storage.z_depth = zdepth;
this_box_storage.x_width1 = xwidth;
this_box_storage.y_height1 = yheight;

this_box_storage.is_rectangle = 0;
if (xwidth2 < 0 && yheight2 < 0) this_box_storage.is_rectangle = 1;
if (xwidth == xwidth2 && yheight == yheight2) this_box_storage.is_rectangle = 1;

if (xwidth2 < 0) {
    this_box_storage.x_width2 = xwidth;
    xwidth2 = xwidth;
} else this_box_storage.x_width2 = xwidth2;

if (yheight2 < 0) {
    this_box_storage.y_height2 = yheight;
    yheight2 = yheight;
} else this_box_storage.y_height2 = yheight2;


this_box_storage.normal_vectors[0] = coords_set(0,0,1);
this_box_storage.normal_vectors[1] = coords_set(0,0,1);

// for sides with y component = 0
x_component = 2*zdepth/sqrt((xwidth-xwidth2)*(xwidth-xwidth2)+4*zdepth*zdepth);
z_component = (xwidth-xwidth2)/sqrt(4*zdepth*zdepth+(xwidth-xwidth2)*(xwidth-xwidth2));

this_box_storage.normal_vectors[2] = coords_set(x_component,0,z_component);
this_box_storage.normal_vectors[3] = coords_set(-x_component,0,z_component);

// for sides with x component = 0
y_component = 2*zdepth/sqrt((yheight-yheight2)*(yheight-yheight2)+4*zdepth*zdepth);
z_component = (yheight-yheight2)/sqrt(4*zdepth*zdepth+(yheight-yheight2)*(yheight-yheight2));

this_box_storage.normal_vectors[4] = coords_set(0,y_component,z_component);
this_box_storage.normal_vectors[5] = coords_set(0,-y_component,z_component);

this_box_volume.geometry.visualization_on = visualize;

this_box_volume.geometry.geometry_parameters.p_box_storage = &this_box_storage;

// Assign pointers to functions for intersection with the shape, checking if a point is inside the shape
if (this_box_storage.is_rectangle == 1) {
this_box_volume.geometry.intersect_function = &sample_box_intersect_simple;
this_box_volume.geometry.within_function = &r_within_box_simple;
}
else {
this_box_volume.geometry.intersect_function = &sample_box_intersect_advanced;
this_box_volume.geometry.within_function = &r_within_box_advanced;
}

this_box_volume.geometry.shell_points = &box_shell_points;
this_box_volume.geometry.mcdisplay_function = &mcdisplay_box_function;
this_box_volume.geometry.initialize_from_main_function = &initialize_box_geometry_from_main_component;
this_box_volume.geometry.process_rot_allocated = 0;

this_box_volume.geometry.copy_geometry_parameters = &allocate_box_storage_copy;

rot_copy(this_box_volume.geometry.rotation_matrix,ROT_A_CURRENT_COMP); //check how ROT_R_CURRENT_COMP would work
rot_transpose(ROT_A_CURRENT_COMP,this_box_volume.geometry.transpose_rotation_matrix);

// Initialize loggers
this_box_volume.loggers.num_elements = 0;

// packing the information into the global_geometry_element, which is then included in the global_geometry_list.
sprintf(global_geometry_element.name,NAME_CURRENT_COMP);
global_geometry_element.activation_counter = number_of_activations;
global_geometry_element.component_index = INDEX_CURRENT_COMP;
global_geometry_element.Volume = &this_box_volume; // Would be nicer if this m was a pointer, now we have the (small) data two places
add_element_to_geometry_list(&global_geometry_list,global_geometry_element);
}
#line 262694 "MACS_sample_kidney_box.c"
#undef number_of_activations
#undef mask_setting
#undef mask_string
#undef p_interact
#undef focus_r
#undef focus_xh
#undef focus_xw
#undef focus_ah
#undef focus_aw
#undef target_z
#undef target_y
#undef target_x
#undef target_index
#undef visualize
#undef yheight2
#undef xwidth2
#undef zdepth
#undef yheight
#undef xwidth
#undef priority
#undef material_string
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

  /* Initializations for component channel_11_analyzer_1_array_crystal_array_1. */
  SIG_MESSAGE("channel_11_analyzer_1_array_crystal_array_1 (Init)");
#define mccompcurname  channel_11_analyzer_1_array_crystal_array_1
#define mccompcurtype  Union_box
#define mccompcurindex 549
#define loop_index mccchannel_11_analyzer_1_array_crystal_array_1_loop_index
#define this_box_volume mccchannel_11_analyzer_1_array_crystal_array_1_this_box_volume
#define global_geometry_element mccchannel_11_analyzer_1_array_crystal_array_1_global_geometry_element
#define this_box_storage mccchannel_11_analyzer_1_array_crystal_array_1_this_box_storage
#define material_string mccchannel_11_analyzer_1_array_crystal_array_1_material_string
#define priority mccchannel_11_analyzer_1_array_crystal_array_1_priority
#define xwidth mccchannel_11_analyzer_1_array_crystal_array_1_xwidth
#define yheight mccchannel_11_analyzer_1_array_crystal_array_1_yheight
#define zdepth mccchannel_11_analyzer_1_array_crystal_array_1_zdepth
#define xwidth2 mccchannel_11_analyzer_1_array_crystal_array_1_xwidth2
#define yheight2 mccchannel_11_analyzer_1_array_crystal_array_1_yheight2
#define visualize mccchannel_11_analyzer_1_array_crystal_array_1_visualize
#define target_index mccchannel_11_analyzer_1_array_crystal_array_1_target_index
#define target_x mccchannel_11_analyzer_1_array_crystal_array_1_target_x
#define target_y mccchannel_11_analyzer_1_array_crystal_array_1_target_y
#define target_z mccchannel_11_analyzer_1_array_crystal_array_1_target_z
#define focus_aw mccchannel_11_analyzer_1_array_crystal_array_1_focus_aw
#define focus_ah mccchannel_11_analyzer_1_array_crystal_array_1_focus_ah
#define focus_xw mccchannel_11_analyzer_1_array_crystal_array_1_focus_xw
#define focus_xh mccchannel_11_analyzer_1_array_crystal_array_1_focus_xh
#define focus_r mccchannel_11_analyzer_1_array_crystal_array_1_focus_r
#define p_interact mccchannel_11_analyzer_1_array_crystal_array_1_p_interact
#define mask_string mccchannel_11_analyzer_1_array_crystal_array_1_mask_string
#define mask_setting mccchannel_11_analyzer_1_array_crystal_array_1_mask_setting
#define number_of_activations mccchannel_11_analyzer_1_array_crystal_array_1_number_of_activations
#line 224 "Union_box.comp"
{
// Initializes the focusing system for this volume including input sanitation.
focus_initialize(&this_box_volume.geometry, POS_A_COMP_INDEX(INDEX_CURRENT_COMP+target_index), POS_A_CURRENT_COMP, ROT_A_CURRENT_COMP, target_index, target_x, target_y, target_z, focus_aw, focus_ah, focus_xw, focus_xh, focus_r, NAME_CURRENT_COMP);

// Input sanitation for this geometry
if (xwidth <= 0) {
  printf("\nERROR in Union_box named %s, the xwidth is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (yheight <= 0) {
  printf("\nERROR in Union_box named %s, yheight is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (zdepth <= 0) {
  printf("\nERROR in Union_box named %s, zdepth is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (xwidth2 <= 0 && xwidth2 != -1) {
  printf("\nERROR in Union_box named %s, the xwidth2 is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (yheight2 <= 0 && yheight2 != -1) {
  printf("\nERROR in Union_box named %s, yheight2 is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}

// Use sanitation
if (global_material_list.num_elements == 0) {
  printf("\nERROR: Need to define a material using Union_make_material before using a Union geometry component. \n");
  printf("       %s was defined before first use of Union_make_material.\n",NAME_CURRENT_COMP);
  exit(1);
}

this_box_volume.geometry.is_masked_volume = 0;
this_box_volume.geometry.is_exit_volume = 0;
this_box_volume.geometry.is_mask_volume = 0;
// check if the volume is a mask, if it is the material string is irelevant.
if (mask_string && strlen(mask_string) && strcmp(mask_string, "NULL") && strcmp(mask_string, "0")) {
    // A mask volume is used to limit the extend of other volumes, called the masked volumes. These are specified in the mask_string.
    // In order for a ray to enter a masked volume, it needs to be both in the region covered by that volume AND the mask volume.
    // When more than
    this_box_volume.geometry.mask_mode = 1; // Default is mask mode is ALL
    if (mask_setting && strlen(mask_setting) && strcmp(mask_setting, "NULL") && strcmp(mask_setting, "0")) {
        if (strcmp(mask_setting,"ALL") == 0 || strcmp(mask_setting,"All") == 0) this_box_volume.geometry.mask_mode = 1;
        else if (strcmp(mask_setting,"ANY") == 0 || strcmp(mask_setting,"Any") == 0) this_box_volume.geometry.mask_mode = 2;
        else {
            printf("The mask_mode of component %s is set to %s, but must be either ALL or ANY.\n",NAME_CURRENT_COMP,mask_setting);
            exit(1);
        }
    }
    
    for (loop_index=0;loop_index<global_geometry_list.num_elements;loop_index++) {
        // Add mask list
        if (1 == manual_linking_function(global_geometry_list.elements[loop_index].name,mask_string)) {
            add_element_to_int_list(&this_box_volume.geometry.mask_list,global_geometry_list.elements[loop_index].component_index);
            add_element_to_int_list(&global_geometry_list.elements[loop_index].Volume->geometry.masked_by_list,INDEX_CURRENT_COMP);
            global_geometry_list.elements[loop_index].Volume->geometry.is_masked_volume = 1;
            if (this_box_volume.geometry.mask_mode == 2)
                global_geometry_list.elements[loop_index].Volume->geometry.mask_mode = 2;
            if (this_box_volume.geometry.mask_mode == 1) {
                if (global_geometry_list.elements[loop_index].Volume->geometry.is_masked_volume == 1 && global_geometry_list.elements[loop_index].Volume->geometry.mask_mode != 2)
                    // If more than one mask is added to one volume, the ANY mode overwrites the (default) ALL mode.
                    global_geometry_list.elements[loop_index].Volume->geometry.mask_mode = 1;
            }
            
            found_geometries = 1;
        }
    }
    if (found_geometries == 0) {
        printf("The mask_string in geometry: %s did not find any of the specified volumes in the mask_string %s \n",NAME_CURRENT_COMP,mask_string);
        exit(1);
    }
    this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
    this_box_volume.p_physics->is_vacuum = 0; // Makes this volume a vacuum
    this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
    this_box_volume.p_physics->my_a = 0; // Should not be used.
    sprintf(this_box_volume.p_physics->name,"Mask");
    this_box_volume.geometry.is_mask_volume = 1;
    
    
// Read the material input, or if it lacks, use automatic linking.
} else if (material_string && strlen(material_string) && strcmp(material_string, "NULL") && strcmp(material_string, "0")) {
    // A geometry string was given, use it to determine which material
    if (0 == strcmp(material_string,"vacuum") || 0 == strcmp(material_string,"Vacuum")) {
        // One could have a global physics struct for vacuum instead of creating one for each
        this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
        this_box_volume.p_physics->is_vacuum = 1; // Makes this volume a vacuum
        this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
        this_box_volume.p_physics->my_a = 0; // Should not be used.
        sprintf(this_box_volume.p_physics->name,"Vacuum");
    } else if (0 == strcmp(material_string,"exit") || 0 == strcmp(material_string,"Exit")) {
        // One could have a global physics struct for vacuum instead of creating one for each
        this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
        this_box_volume.p_physics->is_vacuum = 1; // Makes this volume a vacuum
        this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
        this_box_volume.p_physics->my_a = 0; // Should not be used.
        this_box_volume.geometry.is_exit_volume = 1;
        sprintf(this_box_volume.p_physics->name,"Exit");
    } else {
        #ifndef MATERIAL_DETECTOR
            printf("Need to define a material before refering to it in a geometry %s.\n",NAME_CURRENT_COMP);
            exit(1);
        #endif
        for (loop_index=0;loop_index<global_material_list.num_elements;loop_index++) {
            if (0 == strcmp(material_string,global_material_list.elements[loop_index].name)) {
                this_box_volume.p_physics = global_material_list.elements[loop_index].physics;
                break;
            }
            if (loop_index == global_material_list.num_elements-1) {
            printf("\n");
            printf("ERROR: The material string \"%s\" in Union geometry \"%s\" did not match a specified material. \n",material_string,NAME_CURRENT_COMP);
            printf("       The materials available at this point (need to be defined before the geometry): \n");
            for (loop_index=0;loop_index<global_material_list.num_elements;loop_index++)
              printf("         %s\n",global_material_list.elements[loop_index].name);
            printf("\n");
            printf("       It is also possible to use one of the defualt materials avaiable: \n");
            printf("           Vacuum (for a Volume without scattering or absorption)\n");
            printf("           Exit (for a Volume where the ray exits the component if it enters)\n");
            printf("           Mask (for a Volume that masks existing volumes specified in the mask_string\n");
            exit(1);
          }
        }
    }
} else {
    // Automatic linking, simply using the last defined material.
    #ifndef MATERIAL_DETECTOR
        printf("Need to define a material before the geometry to use automatic linking %s.\n",NAME_CURRENT_COMP);
        exit(1);
    #endif
    this_box_volume.p_physics = global_material_list.elements[global_material_list.num_elements-1].physics;
}

sprintf(this_box_volume.name,NAME_CURRENT_COMP);
sprintf(this_box_volume.geometry.shape,"box");
this_box_volume.geometry.priority_value = priority;
this_box_volume.geometry.geometry_p_interact = p_interact;
// Currently the coordinates will be in absolute space.
this_box_volume.geometry.center = POS_A_CURRENT_COMP;

this_box_storage.z_depth = zdepth;
this_box_storage.x_width1 = xwidth;
this_box_storage.y_height1 = yheight;

this_box_storage.is_rectangle = 0;
if (xwidth2 < 0 && yheight2 < 0) this_box_storage.is_rectangle = 1;
if (xwidth == xwidth2 && yheight == yheight2) this_box_storage.is_rectangle = 1;

if (xwidth2 < 0) {
    this_box_storage.x_width2 = xwidth;
    xwidth2 = xwidth;
} else this_box_storage.x_width2 = xwidth2;

if (yheight2 < 0) {
    this_box_storage.y_height2 = yheight;
    yheight2 = yheight;
} else this_box_storage.y_height2 = yheight2;


this_box_storage.normal_vectors[0] = coords_set(0,0,1);
this_box_storage.normal_vectors[1] = coords_set(0,0,1);

// for sides with y component = 0
x_component = 2*zdepth/sqrt((xwidth-xwidth2)*(xwidth-xwidth2)+4*zdepth*zdepth);
z_component = (xwidth-xwidth2)/sqrt(4*zdepth*zdepth+(xwidth-xwidth2)*(xwidth-xwidth2));

this_box_storage.normal_vectors[2] = coords_set(x_component,0,z_component);
this_box_storage.normal_vectors[3] = coords_set(-x_component,0,z_component);

// for sides with x component = 0
y_component = 2*zdepth/sqrt((yheight-yheight2)*(yheight-yheight2)+4*zdepth*zdepth);
z_component = (yheight-yheight2)/sqrt(4*zdepth*zdepth+(yheight-yheight2)*(yheight-yheight2));

this_box_storage.normal_vectors[4] = coords_set(0,y_component,z_component);
this_box_storage.normal_vectors[5] = coords_set(0,-y_component,z_component);

this_box_volume.geometry.visualization_on = visualize;

this_box_volume.geometry.geometry_parameters.p_box_storage = &this_box_storage;

// Assign pointers to functions for intersection with the shape, checking if a point is inside the shape
if (this_box_storage.is_rectangle == 1) {
this_box_volume.geometry.intersect_function = &sample_box_intersect_simple;
this_box_volume.geometry.within_function = &r_within_box_simple;
}
else {
this_box_volume.geometry.intersect_function = &sample_box_intersect_advanced;
this_box_volume.geometry.within_function = &r_within_box_advanced;
}

this_box_volume.geometry.shell_points = &box_shell_points;
this_box_volume.geometry.mcdisplay_function = &mcdisplay_box_function;
this_box_volume.geometry.initialize_from_main_function = &initialize_box_geometry_from_main_component;
this_box_volume.geometry.process_rot_allocated = 0;

this_box_volume.geometry.copy_geometry_parameters = &allocate_box_storage_copy;

rot_copy(this_box_volume.geometry.rotation_matrix,ROT_A_CURRENT_COMP); //check how ROT_R_CURRENT_COMP would work
rot_transpose(ROT_A_CURRENT_COMP,this_box_volume.geometry.transpose_rotation_matrix);

// Initialize loggers
this_box_volume.loggers.num_elements = 0;

// packing the information into the global_geometry_element, which is then included in the global_geometry_list.
sprintf(global_geometry_element.name,NAME_CURRENT_COMP);
global_geometry_element.activation_counter = number_of_activations;
global_geometry_element.component_index = INDEX_CURRENT_COMP;
global_geometry_element.Volume = &this_box_volume; // Would be nicer if this m was a pointer, now we have the (small) data two places
add_element_to_geometry_list(&global_geometry_list,global_geometry_element);
}
#line 262964 "MACS_sample_kidney_box.c"
#undef number_of_activations
#undef mask_setting
#undef mask_string
#undef p_interact
#undef focus_r
#undef focus_xh
#undef focus_xw
#undef focus_ah
#undef focus_aw
#undef target_z
#undef target_y
#undef target_x
#undef target_index
#undef visualize
#undef yheight2
#undef xwidth2
#undef zdepth
#undef yheight
#undef xwidth
#undef priority
#undef material_string
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

  /* Initializations for component channel_11_analyzer_1_array_crystal_array_2. */
  SIG_MESSAGE("channel_11_analyzer_1_array_crystal_array_2 (Init)");
#define mccompcurname  channel_11_analyzer_1_array_crystal_array_2
#define mccompcurtype  Union_box
#define mccompcurindex 550
#define loop_index mccchannel_11_analyzer_1_array_crystal_array_2_loop_index
#define this_box_volume mccchannel_11_analyzer_1_array_crystal_array_2_this_box_volume
#define global_geometry_element mccchannel_11_analyzer_1_array_crystal_array_2_global_geometry_element
#define this_box_storage mccchannel_11_analyzer_1_array_crystal_array_2_this_box_storage
#define material_string mccchannel_11_analyzer_1_array_crystal_array_2_material_string
#define priority mccchannel_11_analyzer_1_array_crystal_array_2_priority
#define xwidth mccchannel_11_analyzer_1_array_crystal_array_2_xwidth
#define yheight mccchannel_11_analyzer_1_array_crystal_array_2_yheight
#define zdepth mccchannel_11_analyzer_1_array_crystal_array_2_zdepth
#define xwidth2 mccchannel_11_analyzer_1_array_crystal_array_2_xwidth2
#define yheight2 mccchannel_11_analyzer_1_array_crystal_array_2_yheight2
#define visualize mccchannel_11_analyzer_1_array_crystal_array_2_visualize
#define target_index mccchannel_11_analyzer_1_array_crystal_array_2_target_index
#define target_x mccchannel_11_analyzer_1_array_crystal_array_2_target_x
#define target_y mccchannel_11_analyzer_1_array_crystal_array_2_target_y
#define target_z mccchannel_11_analyzer_1_array_crystal_array_2_target_z
#define focus_aw mccchannel_11_analyzer_1_array_crystal_array_2_focus_aw
#define focus_ah mccchannel_11_analyzer_1_array_crystal_array_2_focus_ah
#define focus_xw mccchannel_11_analyzer_1_array_crystal_array_2_focus_xw
#define focus_xh mccchannel_11_analyzer_1_array_crystal_array_2_focus_xh
#define focus_r mccchannel_11_analyzer_1_array_crystal_array_2_focus_r
#define p_interact mccchannel_11_analyzer_1_array_crystal_array_2_p_interact
#define mask_string mccchannel_11_analyzer_1_array_crystal_array_2_mask_string
#define mask_setting mccchannel_11_analyzer_1_array_crystal_array_2_mask_setting
#define number_of_activations mccchannel_11_analyzer_1_array_crystal_array_2_number_of_activations
#line 224 "Union_box.comp"
{
// Initializes the focusing system for this volume including input sanitation.
focus_initialize(&this_box_volume.geometry, POS_A_COMP_INDEX(INDEX_CURRENT_COMP+target_index), POS_A_CURRENT_COMP, ROT_A_CURRENT_COMP, target_index, target_x, target_y, target_z, focus_aw, focus_ah, focus_xw, focus_xh, focus_r, NAME_CURRENT_COMP);

// Input sanitation for this geometry
if (xwidth <= 0) {
  printf("\nERROR in Union_box named %s, the xwidth is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (yheight <= 0) {
  printf("\nERROR in Union_box named %s, yheight is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (zdepth <= 0) {
  printf("\nERROR in Union_box named %s, zdepth is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (xwidth2 <= 0 && xwidth2 != -1) {
  printf("\nERROR in Union_box named %s, the xwidth2 is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (yheight2 <= 0 && yheight2 != -1) {
  printf("\nERROR in Union_box named %s, yheight2 is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}

// Use sanitation
if (global_material_list.num_elements == 0) {
  printf("\nERROR: Need to define a material using Union_make_material before using a Union geometry component. \n");
  printf("       %s was defined before first use of Union_make_material.\n",NAME_CURRENT_COMP);
  exit(1);
}

this_box_volume.geometry.is_masked_volume = 0;
this_box_volume.geometry.is_exit_volume = 0;
this_box_volume.geometry.is_mask_volume = 0;
// check if the volume is a mask, if it is the material string is irelevant.
if (mask_string && strlen(mask_string) && strcmp(mask_string, "NULL") && strcmp(mask_string, "0")) {
    // A mask volume is used to limit the extend of other volumes, called the masked volumes. These are specified in the mask_string.
    // In order for a ray to enter a masked volume, it needs to be both in the region covered by that volume AND the mask volume.
    // When more than
    this_box_volume.geometry.mask_mode = 1; // Default is mask mode is ALL
    if (mask_setting && strlen(mask_setting) && strcmp(mask_setting, "NULL") && strcmp(mask_setting, "0")) {
        if (strcmp(mask_setting,"ALL") == 0 || strcmp(mask_setting,"All") == 0) this_box_volume.geometry.mask_mode = 1;
        else if (strcmp(mask_setting,"ANY") == 0 || strcmp(mask_setting,"Any") == 0) this_box_volume.geometry.mask_mode = 2;
        else {
            printf("The mask_mode of component %s is set to %s, but must be either ALL or ANY.\n",NAME_CURRENT_COMP,mask_setting);
            exit(1);
        }
    }
    
    for (loop_index=0;loop_index<global_geometry_list.num_elements;loop_index++) {
        // Add mask list
        if (1 == manual_linking_function(global_geometry_list.elements[loop_index].name,mask_string)) {
            add_element_to_int_list(&this_box_volume.geometry.mask_list,global_geometry_list.elements[loop_index].component_index);
            add_element_to_int_list(&global_geometry_list.elements[loop_index].Volume->geometry.masked_by_list,INDEX_CURRENT_COMP);
            global_geometry_list.elements[loop_index].Volume->geometry.is_masked_volume = 1;
            if (this_box_volume.geometry.mask_mode == 2)
                global_geometry_list.elements[loop_index].Volume->geometry.mask_mode = 2;
            if (this_box_volume.geometry.mask_mode == 1) {
                if (global_geometry_list.elements[loop_index].Volume->geometry.is_masked_volume == 1 && global_geometry_list.elements[loop_index].Volume->geometry.mask_mode != 2)
                    // If more than one mask is added to one volume, the ANY mode overwrites the (default) ALL mode.
                    global_geometry_list.elements[loop_index].Volume->geometry.mask_mode = 1;
            }
            
            found_geometries = 1;
        }
    }
    if (found_geometries == 0) {
        printf("The mask_string in geometry: %s did not find any of the specified volumes in the mask_string %s \n",NAME_CURRENT_COMP,mask_string);
        exit(1);
    }
    this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
    this_box_volume.p_physics->is_vacuum = 0; // Makes this volume a vacuum
    this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
    this_box_volume.p_physics->my_a = 0; // Should not be used.
    sprintf(this_box_volume.p_physics->name,"Mask");
    this_box_volume.geometry.is_mask_volume = 1;
    
    
// Read the material input, or if it lacks, use automatic linking.
} else if (material_string && strlen(material_string) && strcmp(material_string, "NULL") && strcmp(material_string, "0")) {
    // A geometry string was given, use it to determine which material
    if (0 == strcmp(material_string,"vacuum") || 0 == strcmp(material_string,"Vacuum")) {
        // One could have a global physics struct for vacuum instead of creating one for each
        this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
        this_box_volume.p_physics->is_vacuum = 1; // Makes this volume a vacuum
        this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
        this_box_volume.p_physics->my_a = 0; // Should not be used.
        sprintf(this_box_volume.p_physics->name,"Vacuum");
    } else if (0 == strcmp(material_string,"exit") || 0 == strcmp(material_string,"Exit")) {
        // One could have a global physics struct for vacuum instead of creating one for each
        this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
        this_box_volume.p_physics->is_vacuum = 1; // Makes this volume a vacuum
        this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
        this_box_volume.p_physics->my_a = 0; // Should not be used.
        this_box_volume.geometry.is_exit_volume = 1;
        sprintf(this_box_volume.p_physics->name,"Exit");
    } else {
        #ifndef MATERIAL_DETECTOR
            printf("Need to define a material before refering to it in a geometry %s.\n",NAME_CURRENT_COMP);
            exit(1);
        #endif
        for (loop_index=0;loop_index<global_material_list.num_elements;loop_index++) {
            if (0 == strcmp(material_string,global_material_list.elements[loop_index].name)) {
                this_box_volume.p_physics = global_material_list.elements[loop_index].physics;
                break;
            }
            if (loop_index == global_material_list.num_elements-1) {
            printf("\n");
            printf("ERROR: The material string \"%s\" in Union geometry \"%s\" did not match a specified material. \n",material_string,NAME_CURRENT_COMP);
            printf("       The materials available at this point (need to be defined before the geometry): \n");
            for (loop_index=0;loop_index<global_material_list.num_elements;loop_index++)
              printf("         %s\n",global_material_list.elements[loop_index].name);
            printf("\n");
            printf("       It is also possible to use one of the defualt materials avaiable: \n");
            printf("           Vacuum (for a Volume without scattering or absorption)\n");
            printf("           Exit (for a Volume where the ray exits the component if it enters)\n");
            printf("           Mask (for a Volume that masks existing volumes specified in the mask_string\n");
            exit(1);
          }
        }
    }
} else {
    // Automatic linking, simply using the last defined material.
    #ifndef MATERIAL_DETECTOR
        printf("Need to define a material before the geometry to use automatic linking %s.\n",NAME_CURRENT_COMP);
        exit(1);
    #endif
    this_box_volume.p_physics = global_material_list.elements[global_material_list.num_elements-1].physics;
}

sprintf(this_box_volume.name,NAME_CURRENT_COMP);
sprintf(this_box_volume.geometry.shape,"box");
this_box_volume.geometry.priority_value = priority;
this_box_volume.geometry.geometry_p_interact = p_interact;
// Currently the coordinates will be in absolute space.
this_box_volume.geometry.center = POS_A_CURRENT_COMP;

this_box_storage.z_depth = zdepth;
this_box_storage.x_width1 = xwidth;
this_box_storage.y_height1 = yheight;

this_box_storage.is_rectangle = 0;
if (xwidth2 < 0 && yheight2 < 0) this_box_storage.is_rectangle = 1;
if (xwidth == xwidth2 && yheight == yheight2) this_box_storage.is_rectangle = 1;

if (xwidth2 < 0) {
    this_box_storage.x_width2 = xwidth;
    xwidth2 = xwidth;
} else this_box_storage.x_width2 = xwidth2;

if (yheight2 < 0) {
    this_box_storage.y_height2 = yheight;
    yheight2 = yheight;
} else this_box_storage.y_height2 = yheight2;


this_box_storage.normal_vectors[0] = coords_set(0,0,1);
this_box_storage.normal_vectors[1] = coords_set(0,0,1);

// for sides with y component = 0
x_component = 2*zdepth/sqrt((xwidth-xwidth2)*(xwidth-xwidth2)+4*zdepth*zdepth);
z_component = (xwidth-xwidth2)/sqrt(4*zdepth*zdepth+(xwidth-xwidth2)*(xwidth-xwidth2));

this_box_storage.normal_vectors[2] = coords_set(x_component,0,z_component);
this_box_storage.normal_vectors[3] = coords_set(-x_component,0,z_component);

// for sides with x component = 0
y_component = 2*zdepth/sqrt((yheight-yheight2)*(yheight-yheight2)+4*zdepth*zdepth);
z_component = (yheight-yheight2)/sqrt(4*zdepth*zdepth+(yheight-yheight2)*(yheight-yheight2));

this_box_storage.normal_vectors[4] = coords_set(0,y_component,z_component);
this_box_storage.normal_vectors[5] = coords_set(0,-y_component,z_component);

this_box_volume.geometry.visualization_on = visualize;

this_box_volume.geometry.geometry_parameters.p_box_storage = &this_box_storage;

// Assign pointers to functions for intersection with the shape, checking if a point is inside the shape
if (this_box_storage.is_rectangle == 1) {
this_box_volume.geometry.intersect_function = &sample_box_intersect_simple;
this_box_volume.geometry.within_function = &r_within_box_simple;
}
else {
this_box_volume.geometry.intersect_function = &sample_box_intersect_advanced;
this_box_volume.geometry.within_function = &r_within_box_advanced;
}

this_box_volume.geometry.shell_points = &box_shell_points;
this_box_volume.geometry.mcdisplay_function = &mcdisplay_box_function;
this_box_volume.geometry.initialize_from_main_function = &initialize_box_geometry_from_main_component;
this_box_volume.geometry.process_rot_allocated = 0;

this_box_volume.geometry.copy_geometry_parameters = &allocate_box_storage_copy;

rot_copy(this_box_volume.geometry.rotation_matrix,ROT_A_CURRENT_COMP); //check how ROT_R_CURRENT_COMP would work
rot_transpose(ROT_A_CURRENT_COMP,this_box_volume.geometry.transpose_rotation_matrix);

// Initialize loggers
this_box_volume.loggers.num_elements = 0;

// packing the information into the global_geometry_element, which is then included in the global_geometry_list.
sprintf(global_geometry_element.name,NAME_CURRENT_COMP);
global_geometry_element.activation_counter = number_of_activations;
global_geometry_element.component_index = INDEX_CURRENT_COMP;
global_geometry_element.Volume = &this_box_volume; // Would be nicer if this m was a pointer, now we have the (small) data two places
add_element_to_geometry_list(&global_geometry_list,global_geometry_element);
}
#line 263234 "MACS_sample_kidney_box.c"
#undef number_of_activations
#undef mask_setting
#undef mask_string
#undef p_interact
#undef focus_r
#undef focus_xh
#undef focus_xw
#undef focus_ah
#undef focus_aw
#undef target_z
#undef target_y
#undef target_x
#undef target_index
#undef visualize
#undef yheight2
#undef xwidth2
#undef zdepth
#undef yheight
#undef xwidth
#undef priority
#undef material_string
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

  /* Initializations for component channel_11_analyzer_1_array_crystal_array_3. */
  SIG_MESSAGE("channel_11_analyzer_1_array_crystal_array_3 (Init)");
#define mccompcurname  channel_11_analyzer_1_array_crystal_array_3
#define mccompcurtype  Union_box
#define mccompcurindex 551
#define loop_index mccchannel_11_analyzer_1_array_crystal_array_3_loop_index
#define this_box_volume mccchannel_11_analyzer_1_array_crystal_array_3_this_box_volume
#define global_geometry_element mccchannel_11_analyzer_1_array_crystal_array_3_global_geometry_element
#define this_box_storage mccchannel_11_analyzer_1_array_crystal_array_3_this_box_storage
#define material_string mccchannel_11_analyzer_1_array_crystal_array_3_material_string
#define priority mccchannel_11_analyzer_1_array_crystal_array_3_priority
#define xwidth mccchannel_11_analyzer_1_array_crystal_array_3_xwidth
#define yheight mccchannel_11_analyzer_1_array_crystal_array_3_yheight
#define zdepth mccchannel_11_analyzer_1_array_crystal_array_3_zdepth
#define xwidth2 mccchannel_11_analyzer_1_array_crystal_array_3_xwidth2
#define yheight2 mccchannel_11_analyzer_1_array_crystal_array_3_yheight2
#define visualize mccchannel_11_analyzer_1_array_crystal_array_3_visualize
#define target_index mccchannel_11_analyzer_1_array_crystal_array_3_target_index
#define target_x mccchannel_11_analyzer_1_array_crystal_array_3_target_x
#define target_y mccchannel_11_analyzer_1_array_crystal_array_3_target_y
#define target_z mccchannel_11_analyzer_1_array_crystal_array_3_target_z
#define focus_aw mccchannel_11_analyzer_1_array_crystal_array_3_focus_aw
#define focus_ah mccchannel_11_analyzer_1_array_crystal_array_3_focus_ah
#define focus_xw mccchannel_11_analyzer_1_array_crystal_array_3_focus_xw
#define focus_xh mccchannel_11_analyzer_1_array_crystal_array_3_focus_xh
#define focus_r mccchannel_11_analyzer_1_array_crystal_array_3_focus_r
#define p_interact mccchannel_11_analyzer_1_array_crystal_array_3_p_interact
#define mask_string mccchannel_11_analyzer_1_array_crystal_array_3_mask_string
#define mask_setting mccchannel_11_analyzer_1_array_crystal_array_3_mask_setting
#define number_of_activations mccchannel_11_analyzer_1_array_crystal_array_3_number_of_activations
#line 224 "Union_box.comp"
{
// Initializes the focusing system for this volume including input sanitation.
focus_initialize(&this_box_volume.geometry, POS_A_COMP_INDEX(INDEX_CURRENT_COMP+target_index), POS_A_CURRENT_COMP, ROT_A_CURRENT_COMP, target_index, target_x, target_y, target_z, focus_aw, focus_ah, focus_xw, focus_xh, focus_r, NAME_CURRENT_COMP);

// Input sanitation for this geometry
if (xwidth <= 0) {
  printf("\nERROR in Union_box named %s, the xwidth is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (yheight <= 0) {
  printf("\nERROR in Union_box named %s, yheight is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (zdepth <= 0) {
  printf("\nERROR in Union_box named %s, zdepth is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (xwidth2 <= 0 && xwidth2 != -1) {
  printf("\nERROR in Union_box named %s, the xwidth2 is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (yheight2 <= 0 && yheight2 != -1) {
  printf("\nERROR in Union_box named %s, yheight2 is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}

// Use sanitation
if (global_material_list.num_elements == 0) {
  printf("\nERROR: Need to define a material using Union_make_material before using a Union geometry component. \n");
  printf("       %s was defined before first use of Union_make_material.\n",NAME_CURRENT_COMP);
  exit(1);
}

this_box_volume.geometry.is_masked_volume = 0;
this_box_volume.geometry.is_exit_volume = 0;
this_box_volume.geometry.is_mask_volume = 0;
// check if the volume is a mask, if it is the material string is irelevant.
if (mask_string && strlen(mask_string) && strcmp(mask_string, "NULL") && strcmp(mask_string, "0")) {
    // A mask volume is used to limit the extend of other volumes, called the masked volumes. These are specified in the mask_string.
    // In order for a ray to enter a masked volume, it needs to be both in the region covered by that volume AND the mask volume.
    // When more than
    this_box_volume.geometry.mask_mode = 1; // Default is mask mode is ALL
    if (mask_setting && strlen(mask_setting) && strcmp(mask_setting, "NULL") && strcmp(mask_setting, "0")) {
        if (strcmp(mask_setting,"ALL") == 0 || strcmp(mask_setting,"All") == 0) this_box_volume.geometry.mask_mode = 1;
        else if (strcmp(mask_setting,"ANY") == 0 || strcmp(mask_setting,"Any") == 0) this_box_volume.geometry.mask_mode = 2;
        else {
            printf("The mask_mode of component %s is set to %s, but must be either ALL or ANY.\n",NAME_CURRENT_COMP,mask_setting);
            exit(1);
        }
    }
    
    for (loop_index=0;loop_index<global_geometry_list.num_elements;loop_index++) {
        // Add mask list
        if (1 == manual_linking_function(global_geometry_list.elements[loop_index].name,mask_string)) {
            add_element_to_int_list(&this_box_volume.geometry.mask_list,global_geometry_list.elements[loop_index].component_index);
            add_element_to_int_list(&global_geometry_list.elements[loop_index].Volume->geometry.masked_by_list,INDEX_CURRENT_COMP);
            global_geometry_list.elements[loop_index].Volume->geometry.is_masked_volume = 1;
            if (this_box_volume.geometry.mask_mode == 2)
                global_geometry_list.elements[loop_index].Volume->geometry.mask_mode = 2;
            if (this_box_volume.geometry.mask_mode == 1) {
                if (global_geometry_list.elements[loop_index].Volume->geometry.is_masked_volume == 1 && global_geometry_list.elements[loop_index].Volume->geometry.mask_mode != 2)
                    // If more than one mask is added to one volume, the ANY mode overwrites the (default) ALL mode.
                    global_geometry_list.elements[loop_index].Volume->geometry.mask_mode = 1;
            }
            
            found_geometries = 1;
        }
    }
    if (found_geometries == 0) {
        printf("The mask_string in geometry: %s did not find any of the specified volumes in the mask_string %s \n",NAME_CURRENT_COMP,mask_string);
        exit(1);
    }
    this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
    this_box_volume.p_physics->is_vacuum = 0; // Makes this volume a vacuum
    this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
    this_box_volume.p_physics->my_a = 0; // Should not be used.
    sprintf(this_box_volume.p_physics->name,"Mask");
    this_box_volume.geometry.is_mask_volume = 1;
    
    
// Read the material input, or if it lacks, use automatic linking.
} else if (material_string && strlen(material_string) && strcmp(material_string, "NULL") && strcmp(material_string, "0")) {
    // A geometry string was given, use it to determine which material
    if (0 == strcmp(material_string,"vacuum") || 0 == strcmp(material_string,"Vacuum")) {
        // One could have a global physics struct for vacuum instead of creating one for each
        this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
        this_box_volume.p_physics->is_vacuum = 1; // Makes this volume a vacuum
        this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
        this_box_volume.p_physics->my_a = 0; // Should not be used.
        sprintf(this_box_volume.p_physics->name,"Vacuum");
    } else if (0 == strcmp(material_string,"exit") || 0 == strcmp(material_string,"Exit")) {
        // One could have a global physics struct for vacuum instead of creating one for each
        this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
        this_box_volume.p_physics->is_vacuum = 1; // Makes this volume a vacuum
        this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
        this_box_volume.p_physics->my_a = 0; // Should not be used.
        this_box_volume.geometry.is_exit_volume = 1;
        sprintf(this_box_volume.p_physics->name,"Exit");
    } else {
        #ifndef MATERIAL_DETECTOR
            printf("Need to define a material before refering to it in a geometry %s.\n",NAME_CURRENT_COMP);
            exit(1);
        #endif
        for (loop_index=0;loop_index<global_material_list.num_elements;loop_index++) {
            if (0 == strcmp(material_string,global_material_list.elements[loop_index].name)) {
                this_box_volume.p_physics = global_material_list.elements[loop_index].physics;
                break;
            }
            if (loop_index == global_material_list.num_elements-1) {
            printf("\n");
            printf("ERROR: The material string \"%s\" in Union geometry \"%s\" did not match a specified material. \n",material_string,NAME_CURRENT_COMP);
            printf("       The materials available at this point (need to be defined before the geometry): \n");
            for (loop_index=0;loop_index<global_material_list.num_elements;loop_index++)
              printf("         %s\n",global_material_list.elements[loop_index].name);
            printf("\n");
            printf("       It is also possible to use one of the defualt materials avaiable: \n");
            printf("           Vacuum (for a Volume without scattering or absorption)\n");
            printf("           Exit (for a Volume where the ray exits the component if it enters)\n");
            printf("           Mask (for a Volume that masks existing volumes specified in the mask_string\n");
            exit(1);
          }
        }
    }
} else {
    // Automatic linking, simply using the last defined material.
    #ifndef MATERIAL_DETECTOR
        printf("Need to define a material before the geometry to use automatic linking %s.\n",NAME_CURRENT_COMP);
        exit(1);
    #endif
    this_box_volume.p_physics = global_material_list.elements[global_material_list.num_elements-1].physics;
}

sprintf(this_box_volume.name,NAME_CURRENT_COMP);
sprintf(this_box_volume.geometry.shape,"box");
this_box_volume.geometry.priority_value = priority;
this_box_volume.geometry.geometry_p_interact = p_interact;
// Currently the coordinates will be in absolute space.
this_box_volume.geometry.center = POS_A_CURRENT_COMP;

this_box_storage.z_depth = zdepth;
this_box_storage.x_width1 = xwidth;
this_box_storage.y_height1 = yheight;

this_box_storage.is_rectangle = 0;
if (xwidth2 < 0 && yheight2 < 0) this_box_storage.is_rectangle = 1;
if (xwidth == xwidth2 && yheight == yheight2) this_box_storage.is_rectangle = 1;

if (xwidth2 < 0) {
    this_box_storage.x_width2 = xwidth;
    xwidth2 = xwidth;
} else this_box_storage.x_width2 = xwidth2;

if (yheight2 < 0) {
    this_box_storage.y_height2 = yheight;
    yheight2 = yheight;
} else this_box_storage.y_height2 = yheight2;


this_box_storage.normal_vectors[0] = coords_set(0,0,1);
this_box_storage.normal_vectors[1] = coords_set(0,0,1);

// for sides with y component = 0
x_component = 2*zdepth/sqrt((xwidth-xwidth2)*(xwidth-xwidth2)+4*zdepth*zdepth);
z_component = (xwidth-xwidth2)/sqrt(4*zdepth*zdepth+(xwidth-xwidth2)*(xwidth-xwidth2));

this_box_storage.normal_vectors[2] = coords_set(x_component,0,z_component);
this_box_storage.normal_vectors[3] = coords_set(-x_component,0,z_component);

// for sides with x component = 0
y_component = 2*zdepth/sqrt((yheight-yheight2)*(yheight-yheight2)+4*zdepth*zdepth);
z_component = (yheight-yheight2)/sqrt(4*zdepth*zdepth+(yheight-yheight2)*(yheight-yheight2));

this_box_storage.normal_vectors[4] = coords_set(0,y_component,z_component);
this_box_storage.normal_vectors[5] = coords_set(0,-y_component,z_component);

this_box_volume.geometry.visualization_on = visualize;

this_box_volume.geometry.geometry_parameters.p_box_storage = &this_box_storage;

// Assign pointers to functions for intersection with the shape, checking if a point is inside the shape
if (this_box_storage.is_rectangle == 1) {
this_box_volume.geometry.intersect_function = &sample_box_intersect_simple;
this_box_volume.geometry.within_function = &r_within_box_simple;
}
else {
this_box_volume.geometry.intersect_function = &sample_box_intersect_advanced;
this_box_volume.geometry.within_function = &r_within_box_advanced;
}

this_box_volume.geometry.shell_points = &box_shell_points;
this_box_volume.geometry.mcdisplay_function = &mcdisplay_box_function;
this_box_volume.geometry.initialize_from_main_function = &initialize_box_geometry_from_main_component;
this_box_volume.geometry.process_rot_allocated = 0;

this_box_volume.geometry.copy_geometry_parameters = &allocate_box_storage_copy;

rot_copy(this_box_volume.geometry.rotation_matrix,ROT_A_CURRENT_COMP); //check how ROT_R_CURRENT_COMP would work
rot_transpose(ROT_A_CURRENT_COMP,this_box_volume.geometry.transpose_rotation_matrix);

// Initialize loggers
this_box_volume.loggers.num_elements = 0;

// packing the information into the global_geometry_element, which is then included in the global_geometry_list.
sprintf(global_geometry_element.name,NAME_CURRENT_COMP);
global_geometry_element.activation_counter = number_of_activations;
global_geometry_element.component_index = INDEX_CURRENT_COMP;
global_geometry_element.Volume = &this_box_volume; // Would be nicer if this m was a pointer, now we have the (small) data two places
add_element_to_geometry_list(&global_geometry_list,global_geometry_element);
}
#line 263504 "MACS_sample_kidney_box.c"
#undef number_of_activations
#undef mask_setting
#undef mask_string
#undef p_interact
#undef focus_r
#undef focus_xh
#undef focus_xw
#undef focus_ah
#undef focus_aw
#undef target_z
#undef target_y
#undef target_x
#undef target_index
#undef visualize
#undef yheight2
#undef xwidth2
#undef zdepth
#undef yheight
#undef xwidth
#undef priority
#undef material_string
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

  /* Initializations for component channel_11_analyzer_1_array_crystal_array_4. */
  SIG_MESSAGE("channel_11_analyzer_1_array_crystal_array_4 (Init)");
#define mccompcurname  channel_11_analyzer_1_array_crystal_array_4
#define mccompcurtype  Union_box
#define mccompcurindex 552
#define loop_index mccchannel_11_analyzer_1_array_crystal_array_4_loop_index
#define this_box_volume mccchannel_11_analyzer_1_array_crystal_array_4_this_box_volume
#define global_geometry_element mccchannel_11_analyzer_1_array_crystal_array_4_global_geometry_element
#define this_box_storage mccchannel_11_analyzer_1_array_crystal_array_4_this_box_storage
#define material_string mccchannel_11_analyzer_1_array_crystal_array_4_material_string
#define priority mccchannel_11_analyzer_1_array_crystal_array_4_priority
#define xwidth mccchannel_11_analyzer_1_array_crystal_array_4_xwidth
#define yheight mccchannel_11_analyzer_1_array_crystal_array_4_yheight
#define zdepth mccchannel_11_analyzer_1_array_crystal_array_4_zdepth
#define xwidth2 mccchannel_11_analyzer_1_array_crystal_array_4_xwidth2
#define yheight2 mccchannel_11_analyzer_1_array_crystal_array_4_yheight2
#define visualize mccchannel_11_analyzer_1_array_crystal_array_4_visualize
#define target_index mccchannel_11_analyzer_1_array_crystal_array_4_target_index
#define target_x mccchannel_11_analyzer_1_array_crystal_array_4_target_x
#define target_y mccchannel_11_analyzer_1_array_crystal_array_4_target_y
#define target_z mccchannel_11_analyzer_1_array_crystal_array_4_target_z
#define focus_aw mccchannel_11_analyzer_1_array_crystal_array_4_focus_aw
#define focus_ah mccchannel_11_analyzer_1_array_crystal_array_4_focus_ah
#define focus_xw mccchannel_11_analyzer_1_array_crystal_array_4_focus_xw
#define focus_xh mccchannel_11_analyzer_1_array_crystal_array_4_focus_xh
#define focus_r mccchannel_11_analyzer_1_array_crystal_array_4_focus_r
#define p_interact mccchannel_11_analyzer_1_array_crystal_array_4_p_interact
#define mask_string mccchannel_11_analyzer_1_array_crystal_array_4_mask_string
#define mask_setting mccchannel_11_analyzer_1_array_crystal_array_4_mask_setting
#define number_of_activations mccchannel_11_analyzer_1_array_crystal_array_4_number_of_activations
#line 224 "Union_box.comp"
{
// Initializes the focusing system for this volume including input sanitation.
focus_initialize(&this_box_volume.geometry, POS_A_COMP_INDEX(INDEX_CURRENT_COMP+target_index), POS_A_CURRENT_COMP, ROT_A_CURRENT_COMP, target_index, target_x, target_y, target_z, focus_aw, focus_ah, focus_xw, focus_xh, focus_r, NAME_CURRENT_COMP);

// Input sanitation for this geometry
if (xwidth <= 0) {
  printf("\nERROR in Union_box named %s, the xwidth is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (yheight <= 0) {
  printf("\nERROR in Union_box named %s, yheight is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (zdepth <= 0) {
  printf("\nERROR in Union_box named %s, zdepth is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (xwidth2 <= 0 && xwidth2 != -1) {
  printf("\nERROR in Union_box named %s, the xwidth2 is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (yheight2 <= 0 && yheight2 != -1) {
  printf("\nERROR in Union_box named %s, yheight2 is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}

// Use sanitation
if (global_material_list.num_elements == 0) {
  printf("\nERROR: Need to define a material using Union_make_material before using a Union geometry component. \n");
  printf("       %s was defined before first use of Union_make_material.\n",NAME_CURRENT_COMP);
  exit(1);
}

this_box_volume.geometry.is_masked_volume = 0;
this_box_volume.geometry.is_exit_volume = 0;
this_box_volume.geometry.is_mask_volume = 0;
// check if the volume is a mask, if it is the material string is irelevant.
if (mask_string && strlen(mask_string) && strcmp(mask_string, "NULL") && strcmp(mask_string, "0")) {
    // A mask volume is used to limit the extend of other volumes, called the masked volumes. These are specified in the mask_string.
    // In order for a ray to enter a masked volume, it needs to be both in the region covered by that volume AND the mask volume.
    // When more than
    this_box_volume.geometry.mask_mode = 1; // Default is mask mode is ALL
    if (mask_setting && strlen(mask_setting) && strcmp(mask_setting, "NULL") && strcmp(mask_setting, "0")) {
        if (strcmp(mask_setting,"ALL") == 0 || strcmp(mask_setting,"All") == 0) this_box_volume.geometry.mask_mode = 1;
        else if (strcmp(mask_setting,"ANY") == 0 || strcmp(mask_setting,"Any") == 0) this_box_volume.geometry.mask_mode = 2;
        else {
            printf("The mask_mode of component %s is set to %s, but must be either ALL or ANY.\n",NAME_CURRENT_COMP,mask_setting);
            exit(1);
        }
    }
    
    for (loop_index=0;loop_index<global_geometry_list.num_elements;loop_index++) {
        // Add mask list
        if (1 == manual_linking_function(global_geometry_list.elements[loop_index].name,mask_string)) {
            add_element_to_int_list(&this_box_volume.geometry.mask_list,global_geometry_list.elements[loop_index].component_index);
            add_element_to_int_list(&global_geometry_list.elements[loop_index].Volume->geometry.masked_by_list,INDEX_CURRENT_COMP);
            global_geometry_list.elements[loop_index].Volume->geometry.is_masked_volume = 1;
            if (this_box_volume.geometry.mask_mode == 2)
                global_geometry_list.elements[loop_index].Volume->geometry.mask_mode = 2;
            if (this_box_volume.geometry.mask_mode == 1) {
                if (global_geometry_list.elements[loop_index].Volume->geometry.is_masked_volume == 1 && global_geometry_list.elements[loop_index].Volume->geometry.mask_mode != 2)
                    // If more than one mask is added to one volume, the ANY mode overwrites the (default) ALL mode.
                    global_geometry_list.elements[loop_index].Volume->geometry.mask_mode = 1;
            }
            
            found_geometries = 1;
        }
    }
    if (found_geometries == 0) {
        printf("The mask_string in geometry: %s did not find any of the specified volumes in the mask_string %s \n",NAME_CURRENT_COMP,mask_string);
        exit(1);
    }
    this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
    this_box_volume.p_physics->is_vacuum = 0; // Makes this volume a vacuum
    this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
    this_box_volume.p_physics->my_a = 0; // Should not be used.
    sprintf(this_box_volume.p_physics->name,"Mask");
    this_box_volume.geometry.is_mask_volume = 1;
    
    
// Read the material input, or if it lacks, use automatic linking.
} else if (material_string && strlen(material_string) && strcmp(material_string, "NULL") && strcmp(material_string, "0")) {
    // A geometry string was given, use it to determine which material
    if (0 == strcmp(material_string,"vacuum") || 0 == strcmp(material_string,"Vacuum")) {
        // One could have a global physics struct for vacuum instead of creating one for each
        this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
        this_box_volume.p_physics->is_vacuum = 1; // Makes this volume a vacuum
        this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
        this_box_volume.p_physics->my_a = 0; // Should not be used.
        sprintf(this_box_volume.p_physics->name,"Vacuum");
    } else if (0 == strcmp(material_string,"exit") || 0 == strcmp(material_string,"Exit")) {
        // One could have a global physics struct for vacuum instead of creating one for each
        this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
        this_box_volume.p_physics->is_vacuum = 1; // Makes this volume a vacuum
        this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
        this_box_volume.p_physics->my_a = 0; // Should not be used.
        this_box_volume.geometry.is_exit_volume = 1;
        sprintf(this_box_volume.p_physics->name,"Exit");
    } else {
        #ifndef MATERIAL_DETECTOR
            printf("Need to define a material before refering to it in a geometry %s.\n",NAME_CURRENT_COMP);
            exit(1);
        #endif
        for (loop_index=0;loop_index<global_material_list.num_elements;loop_index++) {
            if (0 == strcmp(material_string,global_material_list.elements[loop_index].name)) {
                this_box_volume.p_physics = global_material_list.elements[loop_index].physics;
                break;
            }
            if (loop_index == global_material_list.num_elements-1) {
            printf("\n");
            printf("ERROR: The material string \"%s\" in Union geometry \"%s\" did not match a specified material. \n",material_string,NAME_CURRENT_COMP);
            printf("       The materials available at this point (need to be defined before the geometry): \n");
            for (loop_index=0;loop_index<global_material_list.num_elements;loop_index++)
              printf("         %s\n",global_material_list.elements[loop_index].name);
            printf("\n");
            printf("       It is also possible to use one of the defualt materials avaiable: \n");
            printf("           Vacuum (for a Volume without scattering or absorption)\n");
            printf("           Exit (for a Volume where the ray exits the component if it enters)\n");
            printf("           Mask (for a Volume that masks existing volumes specified in the mask_string\n");
            exit(1);
          }
        }
    }
} else {
    // Automatic linking, simply using the last defined material.
    #ifndef MATERIAL_DETECTOR
        printf("Need to define a material before the geometry to use automatic linking %s.\n",NAME_CURRENT_COMP);
        exit(1);
    #endif
    this_box_volume.p_physics = global_material_list.elements[global_material_list.num_elements-1].physics;
}

sprintf(this_box_volume.name,NAME_CURRENT_COMP);
sprintf(this_box_volume.geometry.shape,"box");
this_box_volume.geometry.priority_value = priority;
this_box_volume.geometry.geometry_p_interact = p_interact;
// Currently the coordinates will be in absolute space.
this_box_volume.geometry.center = POS_A_CURRENT_COMP;

this_box_storage.z_depth = zdepth;
this_box_storage.x_width1 = xwidth;
this_box_storage.y_height1 = yheight;

this_box_storage.is_rectangle = 0;
if (xwidth2 < 0 && yheight2 < 0) this_box_storage.is_rectangle = 1;
if (xwidth == xwidth2 && yheight == yheight2) this_box_storage.is_rectangle = 1;

if (xwidth2 < 0) {
    this_box_storage.x_width2 = xwidth;
    xwidth2 = xwidth;
} else this_box_storage.x_width2 = xwidth2;

if (yheight2 < 0) {
    this_box_storage.y_height2 = yheight;
    yheight2 = yheight;
} else this_box_storage.y_height2 = yheight2;


this_box_storage.normal_vectors[0] = coords_set(0,0,1);
this_box_storage.normal_vectors[1] = coords_set(0,0,1);

// for sides with y component = 0
x_component = 2*zdepth/sqrt((xwidth-xwidth2)*(xwidth-xwidth2)+4*zdepth*zdepth);
z_component = (xwidth-xwidth2)/sqrt(4*zdepth*zdepth+(xwidth-xwidth2)*(xwidth-xwidth2));

this_box_storage.normal_vectors[2] = coords_set(x_component,0,z_component);
this_box_storage.normal_vectors[3] = coords_set(-x_component,0,z_component);

// for sides with x component = 0
y_component = 2*zdepth/sqrt((yheight-yheight2)*(yheight-yheight2)+4*zdepth*zdepth);
z_component = (yheight-yheight2)/sqrt(4*zdepth*zdepth+(yheight-yheight2)*(yheight-yheight2));

this_box_storage.normal_vectors[4] = coords_set(0,y_component,z_component);
this_box_storage.normal_vectors[5] = coords_set(0,-y_component,z_component);

this_box_volume.geometry.visualization_on = visualize;

this_box_volume.geometry.geometry_parameters.p_box_storage = &this_box_storage;

// Assign pointers to functions for intersection with the shape, checking if a point is inside the shape
if (this_box_storage.is_rectangle == 1) {
this_box_volume.geometry.intersect_function = &sample_box_intersect_simple;
this_box_volume.geometry.within_function = &r_within_box_simple;
}
else {
this_box_volume.geometry.intersect_function = &sample_box_intersect_advanced;
this_box_volume.geometry.within_function = &r_within_box_advanced;
}

this_box_volume.geometry.shell_points = &box_shell_points;
this_box_volume.geometry.mcdisplay_function = &mcdisplay_box_function;
this_box_volume.geometry.initialize_from_main_function = &initialize_box_geometry_from_main_component;
this_box_volume.geometry.process_rot_allocated = 0;

this_box_volume.geometry.copy_geometry_parameters = &allocate_box_storage_copy;

rot_copy(this_box_volume.geometry.rotation_matrix,ROT_A_CURRENT_COMP); //check how ROT_R_CURRENT_COMP would work
rot_transpose(ROT_A_CURRENT_COMP,this_box_volume.geometry.transpose_rotation_matrix);

// Initialize loggers
this_box_volume.loggers.num_elements = 0;

// packing the information into the global_geometry_element, which is then included in the global_geometry_list.
sprintf(global_geometry_element.name,NAME_CURRENT_COMP);
global_geometry_element.activation_counter = number_of_activations;
global_geometry_element.component_index = INDEX_CURRENT_COMP;
global_geometry_element.Volume = &this_box_volume; // Would be nicer if this m was a pointer, now we have the (small) data two places
add_element_to_geometry_list(&global_geometry_list,global_geometry_element);
}
#line 263774 "MACS_sample_kidney_box.c"
#undef number_of_activations
#undef mask_setting
#undef mask_string
#undef p_interact
#undef focus_r
#undef focus_xh
#undef focus_xw
#undef focus_ah
#undef focus_aw
#undef target_z
#undef target_y
#undef target_x
#undef target_index
#undef visualize
#undef yheight2
#undef xwidth2
#undef zdepth
#undef yheight
#undef xwidth
#undef priority
#undef material_string
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

  /* Initializations for component channel_11_analyzer_1_array_crystal_array_5. */
  SIG_MESSAGE("channel_11_analyzer_1_array_crystal_array_5 (Init)");
#define mccompcurname  channel_11_analyzer_1_array_crystal_array_5
#define mccompcurtype  Union_box
#define mccompcurindex 553
#define loop_index mccchannel_11_analyzer_1_array_crystal_array_5_loop_index
#define this_box_volume mccchannel_11_analyzer_1_array_crystal_array_5_this_box_volume
#define global_geometry_element mccchannel_11_analyzer_1_array_crystal_array_5_global_geometry_element
#define this_box_storage mccchannel_11_analyzer_1_array_crystal_array_5_this_box_storage
#define material_string mccchannel_11_analyzer_1_array_crystal_array_5_material_string
#define priority mccchannel_11_analyzer_1_array_crystal_array_5_priority
#define xwidth mccchannel_11_analyzer_1_array_crystal_array_5_xwidth
#define yheight mccchannel_11_analyzer_1_array_crystal_array_5_yheight
#define zdepth mccchannel_11_analyzer_1_array_crystal_array_5_zdepth
#define xwidth2 mccchannel_11_analyzer_1_array_crystal_array_5_xwidth2
#define yheight2 mccchannel_11_analyzer_1_array_crystal_array_5_yheight2
#define visualize mccchannel_11_analyzer_1_array_crystal_array_5_visualize
#define target_index mccchannel_11_analyzer_1_array_crystal_array_5_target_index
#define target_x mccchannel_11_analyzer_1_array_crystal_array_5_target_x
#define target_y mccchannel_11_analyzer_1_array_crystal_array_5_target_y
#define target_z mccchannel_11_analyzer_1_array_crystal_array_5_target_z
#define focus_aw mccchannel_11_analyzer_1_array_crystal_array_5_focus_aw
#define focus_ah mccchannel_11_analyzer_1_array_crystal_array_5_focus_ah
#define focus_xw mccchannel_11_analyzer_1_array_crystal_array_5_focus_xw
#define focus_xh mccchannel_11_analyzer_1_array_crystal_array_5_focus_xh
#define focus_r mccchannel_11_analyzer_1_array_crystal_array_5_focus_r
#define p_interact mccchannel_11_analyzer_1_array_crystal_array_5_p_interact
#define mask_string mccchannel_11_analyzer_1_array_crystal_array_5_mask_string
#define mask_setting mccchannel_11_analyzer_1_array_crystal_array_5_mask_setting
#define number_of_activations mccchannel_11_analyzer_1_array_crystal_array_5_number_of_activations
#line 224 "Union_box.comp"
{
// Initializes the focusing system for this volume including input sanitation.
focus_initialize(&this_box_volume.geometry, POS_A_COMP_INDEX(INDEX_CURRENT_COMP+target_index), POS_A_CURRENT_COMP, ROT_A_CURRENT_COMP, target_index, target_x, target_y, target_z, focus_aw, focus_ah, focus_xw, focus_xh, focus_r, NAME_CURRENT_COMP);

// Input sanitation for this geometry
if (xwidth <= 0) {
  printf("\nERROR in Union_box named %s, the xwidth is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (yheight <= 0) {
  printf("\nERROR in Union_box named %s, yheight is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (zdepth <= 0) {
  printf("\nERROR in Union_box named %s, zdepth is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (xwidth2 <= 0 && xwidth2 != -1) {
  printf("\nERROR in Union_box named %s, the xwidth2 is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (yheight2 <= 0 && yheight2 != -1) {
  printf("\nERROR in Union_box named %s, yheight2 is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}

// Use sanitation
if (global_material_list.num_elements == 0) {
  printf("\nERROR: Need to define a material using Union_make_material before using a Union geometry component. \n");
  printf("       %s was defined before first use of Union_make_material.\n",NAME_CURRENT_COMP);
  exit(1);
}

this_box_volume.geometry.is_masked_volume = 0;
this_box_volume.geometry.is_exit_volume = 0;
this_box_volume.geometry.is_mask_volume = 0;
// check if the volume is a mask, if it is the material string is irelevant.
if (mask_string && strlen(mask_string) && strcmp(mask_string, "NULL") && strcmp(mask_string, "0")) {
    // A mask volume is used to limit the extend of other volumes, called the masked volumes. These are specified in the mask_string.
    // In order for a ray to enter a masked volume, it needs to be both in the region covered by that volume AND the mask volume.
    // When more than
    this_box_volume.geometry.mask_mode = 1; // Default is mask mode is ALL
    if (mask_setting && strlen(mask_setting) && strcmp(mask_setting, "NULL") && strcmp(mask_setting, "0")) {
        if (strcmp(mask_setting,"ALL") == 0 || strcmp(mask_setting,"All") == 0) this_box_volume.geometry.mask_mode = 1;
        else if (strcmp(mask_setting,"ANY") == 0 || strcmp(mask_setting,"Any") == 0) this_box_volume.geometry.mask_mode = 2;
        else {
            printf("The mask_mode of component %s is set to %s, but must be either ALL or ANY.\n",NAME_CURRENT_COMP,mask_setting);
            exit(1);
        }
    }
    
    for (loop_index=0;loop_index<global_geometry_list.num_elements;loop_index++) {
        // Add mask list
        if (1 == manual_linking_function(global_geometry_list.elements[loop_index].name,mask_string)) {
            add_element_to_int_list(&this_box_volume.geometry.mask_list,global_geometry_list.elements[loop_index].component_index);
            add_element_to_int_list(&global_geometry_list.elements[loop_index].Volume->geometry.masked_by_list,INDEX_CURRENT_COMP);
            global_geometry_list.elements[loop_index].Volume->geometry.is_masked_volume = 1;
            if (this_box_volume.geometry.mask_mode == 2)
                global_geometry_list.elements[loop_index].Volume->geometry.mask_mode = 2;
            if (this_box_volume.geometry.mask_mode == 1) {
                if (global_geometry_list.elements[loop_index].Volume->geometry.is_masked_volume == 1 && global_geometry_list.elements[loop_index].Volume->geometry.mask_mode != 2)
                    // If more than one mask is added to one volume, the ANY mode overwrites the (default) ALL mode.
                    global_geometry_list.elements[loop_index].Volume->geometry.mask_mode = 1;
            }
            
            found_geometries = 1;
        }
    }
    if (found_geometries == 0) {
        printf("The mask_string in geometry: %s did not find any of the specified volumes in the mask_string %s \n",NAME_CURRENT_COMP,mask_string);
        exit(1);
    }
    this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
    this_box_volume.p_physics->is_vacuum = 0; // Makes this volume a vacuum
    this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
    this_box_volume.p_physics->my_a = 0; // Should not be used.
    sprintf(this_box_volume.p_physics->name,"Mask");
    this_box_volume.geometry.is_mask_volume = 1;
    
    
// Read the material input, or if it lacks, use automatic linking.
} else if (material_string && strlen(material_string) && strcmp(material_string, "NULL") && strcmp(material_string, "0")) {
    // A geometry string was given, use it to determine which material
    if (0 == strcmp(material_string,"vacuum") || 0 == strcmp(material_string,"Vacuum")) {
        // One could have a global physics struct for vacuum instead of creating one for each
        this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
        this_box_volume.p_physics->is_vacuum = 1; // Makes this volume a vacuum
        this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
        this_box_volume.p_physics->my_a = 0; // Should not be used.
        sprintf(this_box_volume.p_physics->name,"Vacuum");
    } else if (0 == strcmp(material_string,"exit") || 0 == strcmp(material_string,"Exit")) {
        // One could have a global physics struct for vacuum instead of creating one for each
        this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
        this_box_volume.p_physics->is_vacuum = 1; // Makes this volume a vacuum
        this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
        this_box_volume.p_physics->my_a = 0; // Should not be used.
        this_box_volume.geometry.is_exit_volume = 1;
        sprintf(this_box_volume.p_physics->name,"Exit");
    } else {
        #ifndef MATERIAL_DETECTOR
            printf("Need to define a material before refering to it in a geometry %s.\n",NAME_CURRENT_COMP);
            exit(1);
        #endif
        for (loop_index=0;loop_index<global_material_list.num_elements;loop_index++) {
            if (0 == strcmp(material_string,global_material_list.elements[loop_index].name)) {
                this_box_volume.p_physics = global_material_list.elements[loop_index].physics;
                break;
            }
            if (loop_index == global_material_list.num_elements-1) {
            printf("\n");
            printf("ERROR: The material string \"%s\" in Union geometry \"%s\" did not match a specified material. \n",material_string,NAME_CURRENT_COMP);
            printf("       The materials available at this point (need to be defined before the geometry): \n");
            for (loop_index=0;loop_index<global_material_list.num_elements;loop_index++)
              printf("         %s\n",global_material_list.elements[loop_index].name);
            printf("\n");
            printf("       It is also possible to use one of the defualt materials avaiable: \n");
            printf("           Vacuum (for a Volume without scattering or absorption)\n");
            printf("           Exit (for a Volume where the ray exits the component if it enters)\n");
            printf("           Mask (for a Volume that masks existing volumes specified in the mask_string\n");
            exit(1);
          }
        }
    }
} else {
    // Automatic linking, simply using the last defined material.
    #ifndef MATERIAL_DETECTOR
        printf("Need to define a material before the geometry to use automatic linking %s.\n",NAME_CURRENT_COMP);
        exit(1);
    #endif
    this_box_volume.p_physics = global_material_list.elements[global_material_list.num_elements-1].physics;
}

sprintf(this_box_volume.name,NAME_CURRENT_COMP);
sprintf(this_box_volume.geometry.shape,"box");
this_box_volume.geometry.priority_value = priority;
this_box_volume.geometry.geometry_p_interact = p_interact;
// Currently the coordinates will be in absolute space.
this_box_volume.geometry.center = POS_A_CURRENT_COMP;

this_box_storage.z_depth = zdepth;
this_box_storage.x_width1 = xwidth;
this_box_storage.y_height1 = yheight;

this_box_storage.is_rectangle = 0;
if (xwidth2 < 0 && yheight2 < 0) this_box_storage.is_rectangle = 1;
if (xwidth == xwidth2 && yheight == yheight2) this_box_storage.is_rectangle = 1;

if (xwidth2 < 0) {
    this_box_storage.x_width2 = xwidth;
    xwidth2 = xwidth;
} else this_box_storage.x_width2 = xwidth2;

if (yheight2 < 0) {
    this_box_storage.y_height2 = yheight;
    yheight2 = yheight;
} else this_box_storage.y_height2 = yheight2;


this_box_storage.normal_vectors[0] = coords_set(0,0,1);
this_box_storage.normal_vectors[1] = coords_set(0,0,1);

// for sides with y component = 0
x_component = 2*zdepth/sqrt((xwidth-xwidth2)*(xwidth-xwidth2)+4*zdepth*zdepth);
z_component = (xwidth-xwidth2)/sqrt(4*zdepth*zdepth+(xwidth-xwidth2)*(xwidth-xwidth2));

this_box_storage.normal_vectors[2] = coords_set(x_component,0,z_component);
this_box_storage.normal_vectors[3] = coords_set(-x_component,0,z_component);

// for sides with x component = 0
y_component = 2*zdepth/sqrt((yheight-yheight2)*(yheight-yheight2)+4*zdepth*zdepth);
z_component = (yheight-yheight2)/sqrt(4*zdepth*zdepth+(yheight-yheight2)*(yheight-yheight2));

this_box_storage.normal_vectors[4] = coords_set(0,y_component,z_component);
this_box_storage.normal_vectors[5] = coords_set(0,-y_component,z_component);

this_box_volume.geometry.visualization_on = visualize;

this_box_volume.geometry.geometry_parameters.p_box_storage = &this_box_storage;

// Assign pointers to functions for intersection with the shape, checking if a point is inside the shape
if (this_box_storage.is_rectangle == 1) {
this_box_volume.geometry.intersect_function = &sample_box_intersect_simple;
this_box_volume.geometry.within_function = &r_within_box_simple;
}
else {
this_box_volume.geometry.intersect_function = &sample_box_intersect_advanced;
this_box_volume.geometry.within_function = &r_within_box_advanced;
}

this_box_volume.geometry.shell_points = &box_shell_points;
this_box_volume.geometry.mcdisplay_function = &mcdisplay_box_function;
this_box_volume.geometry.initialize_from_main_function = &initialize_box_geometry_from_main_component;
this_box_volume.geometry.process_rot_allocated = 0;

this_box_volume.geometry.copy_geometry_parameters = &allocate_box_storage_copy;

rot_copy(this_box_volume.geometry.rotation_matrix,ROT_A_CURRENT_COMP); //check how ROT_R_CURRENT_COMP would work
rot_transpose(ROT_A_CURRENT_COMP,this_box_volume.geometry.transpose_rotation_matrix);

// Initialize loggers
this_box_volume.loggers.num_elements = 0;

// packing the information into the global_geometry_element, which is then included in the global_geometry_list.
sprintf(global_geometry_element.name,NAME_CURRENT_COMP);
global_geometry_element.activation_counter = number_of_activations;
global_geometry_element.component_index = INDEX_CURRENT_COMP;
global_geometry_element.Volume = &this_box_volume; // Would be nicer if this m was a pointer, now we have the (small) data two places
add_element_to_geometry_list(&global_geometry_list,global_geometry_element);
}
#line 264044 "MACS_sample_kidney_box.c"
#undef number_of_activations
#undef mask_setting
#undef mask_string
#undef p_interact
#undef focus_r
#undef focus_xh
#undef focus_xw
#undef focus_ah
#undef focus_aw
#undef target_z
#undef target_y
#undef target_x
#undef target_index
#undef visualize
#undef yheight2
#undef xwidth2
#undef zdepth
#undef yheight
#undef xwidth
#undef priority
#undef material_string
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

  /* Initializations for component channel_11_analyzer_1_array_crystal_array_6. */
  SIG_MESSAGE("channel_11_analyzer_1_array_crystal_array_6 (Init)");
#define mccompcurname  channel_11_analyzer_1_array_crystal_array_6
#define mccompcurtype  Union_box
#define mccompcurindex 554
#define loop_index mccchannel_11_analyzer_1_array_crystal_array_6_loop_index
#define this_box_volume mccchannel_11_analyzer_1_array_crystal_array_6_this_box_volume
#define global_geometry_element mccchannel_11_analyzer_1_array_crystal_array_6_global_geometry_element
#define this_box_storage mccchannel_11_analyzer_1_array_crystal_array_6_this_box_storage
#define material_string mccchannel_11_analyzer_1_array_crystal_array_6_material_string
#define priority mccchannel_11_analyzer_1_array_crystal_array_6_priority
#define xwidth mccchannel_11_analyzer_1_array_crystal_array_6_xwidth
#define yheight mccchannel_11_analyzer_1_array_crystal_array_6_yheight
#define zdepth mccchannel_11_analyzer_1_array_crystal_array_6_zdepth
#define xwidth2 mccchannel_11_analyzer_1_array_crystal_array_6_xwidth2
#define yheight2 mccchannel_11_analyzer_1_array_crystal_array_6_yheight2
#define visualize mccchannel_11_analyzer_1_array_crystal_array_6_visualize
#define target_index mccchannel_11_analyzer_1_array_crystal_array_6_target_index
#define target_x mccchannel_11_analyzer_1_array_crystal_array_6_target_x
#define target_y mccchannel_11_analyzer_1_array_crystal_array_6_target_y
#define target_z mccchannel_11_analyzer_1_array_crystal_array_6_target_z
#define focus_aw mccchannel_11_analyzer_1_array_crystal_array_6_focus_aw
#define focus_ah mccchannel_11_analyzer_1_array_crystal_array_6_focus_ah
#define focus_xw mccchannel_11_analyzer_1_array_crystal_array_6_focus_xw
#define focus_xh mccchannel_11_analyzer_1_array_crystal_array_6_focus_xh
#define focus_r mccchannel_11_analyzer_1_array_crystal_array_6_focus_r
#define p_interact mccchannel_11_analyzer_1_array_crystal_array_6_p_interact
#define mask_string mccchannel_11_analyzer_1_array_crystal_array_6_mask_string
#define mask_setting mccchannel_11_analyzer_1_array_crystal_array_6_mask_setting
#define number_of_activations mccchannel_11_analyzer_1_array_crystal_array_6_number_of_activations
#line 224 "Union_box.comp"
{
// Initializes the focusing system for this volume including input sanitation.
focus_initialize(&this_box_volume.geometry, POS_A_COMP_INDEX(INDEX_CURRENT_COMP+target_index), POS_A_CURRENT_COMP, ROT_A_CURRENT_COMP, target_index, target_x, target_y, target_z, focus_aw, focus_ah, focus_xw, focus_xh, focus_r, NAME_CURRENT_COMP);

// Input sanitation for this geometry
if (xwidth <= 0) {
  printf("\nERROR in Union_box named %s, the xwidth is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (yheight <= 0) {
  printf("\nERROR in Union_box named %s, yheight is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (zdepth <= 0) {
  printf("\nERROR in Union_box named %s, zdepth is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (xwidth2 <= 0 && xwidth2 != -1) {
  printf("\nERROR in Union_box named %s, the xwidth2 is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (yheight2 <= 0 && yheight2 != -1) {
  printf("\nERROR in Union_box named %s, yheight2 is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}

// Use sanitation
if (global_material_list.num_elements == 0) {
  printf("\nERROR: Need to define a material using Union_make_material before using a Union geometry component. \n");
  printf("       %s was defined before first use of Union_make_material.\n",NAME_CURRENT_COMP);
  exit(1);
}

this_box_volume.geometry.is_masked_volume = 0;
this_box_volume.geometry.is_exit_volume = 0;
this_box_volume.geometry.is_mask_volume = 0;
// check if the volume is a mask, if it is the material string is irelevant.
if (mask_string && strlen(mask_string) && strcmp(mask_string, "NULL") && strcmp(mask_string, "0")) {
    // A mask volume is used to limit the extend of other volumes, called the masked volumes. These are specified in the mask_string.
    // In order for a ray to enter a masked volume, it needs to be both in the region covered by that volume AND the mask volume.
    // When more than
    this_box_volume.geometry.mask_mode = 1; // Default is mask mode is ALL
    if (mask_setting && strlen(mask_setting) && strcmp(mask_setting, "NULL") && strcmp(mask_setting, "0")) {
        if (strcmp(mask_setting,"ALL") == 0 || strcmp(mask_setting,"All") == 0) this_box_volume.geometry.mask_mode = 1;
        else if (strcmp(mask_setting,"ANY") == 0 || strcmp(mask_setting,"Any") == 0) this_box_volume.geometry.mask_mode = 2;
        else {
            printf("The mask_mode of component %s is set to %s, but must be either ALL or ANY.\n",NAME_CURRENT_COMP,mask_setting);
            exit(1);
        }
    }
    
    for (loop_index=0;loop_index<global_geometry_list.num_elements;loop_index++) {
        // Add mask list
        if (1 == manual_linking_function(global_geometry_list.elements[loop_index].name,mask_string)) {
            add_element_to_int_list(&this_box_volume.geometry.mask_list,global_geometry_list.elements[loop_index].component_index);
            add_element_to_int_list(&global_geometry_list.elements[loop_index].Volume->geometry.masked_by_list,INDEX_CURRENT_COMP);
            global_geometry_list.elements[loop_index].Volume->geometry.is_masked_volume = 1;
            if (this_box_volume.geometry.mask_mode == 2)
                global_geometry_list.elements[loop_index].Volume->geometry.mask_mode = 2;
            if (this_box_volume.geometry.mask_mode == 1) {
                if (global_geometry_list.elements[loop_index].Volume->geometry.is_masked_volume == 1 && global_geometry_list.elements[loop_index].Volume->geometry.mask_mode != 2)
                    // If more than one mask is added to one volume, the ANY mode overwrites the (default) ALL mode.
                    global_geometry_list.elements[loop_index].Volume->geometry.mask_mode = 1;
            }
            
            found_geometries = 1;
        }
    }
    if (found_geometries == 0) {
        printf("The mask_string in geometry: %s did not find any of the specified volumes in the mask_string %s \n",NAME_CURRENT_COMP,mask_string);
        exit(1);
    }
    this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
    this_box_volume.p_physics->is_vacuum = 0; // Makes this volume a vacuum
    this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
    this_box_volume.p_physics->my_a = 0; // Should not be used.
    sprintf(this_box_volume.p_physics->name,"Mask");
    this_box_volume.geometry.is_mask_volume = 1;
    
    
// Read the material input, or if it lacks, use automatic linking.
} else if (material_string && strlen(material_string) && strcmp(material_string, "NULL") && strcmp(material_string, "0")) {
    // A geometry string was given, use it to determine which material
    if (0 == strcmp(material_string,"vacuum") || 0 == strcmp(material_string,"Vacuum")) {
        // One could have a global physics struct for vacuum instead of creating one for each
        this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
        this_box_volume.p_physics->is_vacuum = 1; // Makes this volume a vacuum
        this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
        this_box_volume.p_physics->my_a = 0; // Should not be used.
        sprintf(this_box_volume.p_physics->name,"Vacuum");
    } else if (0 == strcmp(material_string,"exit") || 0 == strcmp(material_string,"Exit")) {
        // One could have a global physics struct for vacuum instead of creating one for each
        this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
        this_box_volume.p_physics->is_vacuum = 1; // Makes this volume a vacuum
        this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
        this_box_volume.p_physics->my_a = 0; // Should not be used.
        this_box_volume.geometry.is_exit_volume = 1;
        sprintf(this_box_volume.p_physics->name,"Exit");
    } else {
        #ifndef MATERIAL_DETECTOR
            printf("Need to define a material before refering to it in a geometry %s.\n",NAME_CURRENT_COMP);
            exit(1);
        #endif
        for (loop_index=0;loop_index<global_material_list.num_elements;loop_index++) {
            if (0 == strcmp(material_string,global_material_list.elements[loop_index].name)) {
                this_box_volume.p_physics = global_material_list.elements[loop_index].physics;
                break;
            }
            if (loop_index == global_material_list.num_elements-1) {
            printf("\n");
            printf("ERROR: The material string \"%s\" in Union geometry \"%s\" did not match a specified material. \n",material_string,NAME_CURRENT_COMP);
            printf("       The materials available at this point (need to be defined before the geometry): \n");
            for (loop_index=0;loop_index<global_material_list.num_elements;loop_index++)
              printf("         %s\n",global_material_list.elements[loop_index].name);
            printf("\n");
            printf("       It is also possible to use one of the defualt materials avaiable: \n");
            printf("           Vacuum (for a Volume without scattering or absorption)\n");
            printf("           Exit (for a Volume where the ray exits the component if it enters)\n");
            printf("           Mask (for a Volume that masks existing volumes specified in the mask_string\n");
            exit(1);
          }
        }
    }
} else {
    // Automatic linking, simply using the last defined material.
    #ifndef MATERIAL_DETECTOR
        printf("Need to define a material before the geometry to use automatic linking %s.\n",NAME_CURRENT_COMP);
        exit(1);
    #endif
    this_box_volume.p_physics = global_material_list.elements[global_material_list.num_elements-1].physics;
}

sprintf(this_box_volume.name,NAME_CURRENT_COMP);
sprintf(this_box_volume.geometry.shape,"box");
this_box_volume.geometry.priority_value = priority;
this_box_volume.geometry.geometry_p_interact = p_interact;
// Currently the coordinates will be in absolute space.
this_box_volume.geometry.center = POS_A_CURRENT_COMP;

this_box_storage.z_depth = zdepth;
this_box_storage.x_width1 = xwidth;
this_box_storage.y_height1 = yheight;

this_box_storage.is_rectangle = 0;
if (xwidth2 < 0 && yheight2 < 0) this_box_storage.is_rectangle = 1;
if (xwidth == xwidth2 && yheight == yheight2) this_box_storage.is_rectangle = 1;

if (xwidth2 < 0) {
    this_box_storage.x_width2 = xwidth;
    xwidth2 = xwidth;
} else this_box_storage.x_width2 = xwidth2;

if (yheight2 < 0) {
    this_box_storage.y_height2 = yheight;
    yheight2 = yheight;
} else this_box_storage.y_height2 = yheight2;


this_box_storage.normal_vectors[0] = coords_set(0,0,1);
this_box_storage.normal_vectors[1] = coords_set(0,0,1);

// for sides with y component = 0
x_component = 2*zdepth/sqrt((xwidth-xwidth2)*(xwidth-xwidth2)+4*zdepth*zdepth);
z_component = (xwidth-xwidth2)/sqrt(4*zdepth*zdepth+(xwidth-xwidth2)*(xwidth-xwidth2));

this_box_storage.normal_vectors[2] = coords_set(x_component,0,z_component);
this_box_storage.normal_vectors[3] = coords_set(-x_component,0,z_component);

// for sides with x component = 0
y_component = 2*zdepth/sqrt((yheight-yheight2)*(yheight-yheight2)+4*zdepth*zdepth);
z_component = (yheight-yheight2)/sqrt(4*zdepth*zdepth+(yheight-yheight2)*(yheight-yheight2));

this_box_storage.normal_vectors[4] = coords_set(0,y_component,z_component);
this_box_storage.normal_vectors[5] = coords_set(0,-y_component,z_component);

this_box_volume.geometry.visualization_on = visualize;

this_box_volume.geometry.geometry_parameters.p_box_storage = &this_box_storage;

// Assign pointers to functions for intersection with the shape, checking if a point is inside the shape
if (this_box_storage.is_rectangle == 1) {
this_box_volume.geometry.intersect_function = &sample_box_intersect_simple;
this_box_volume.geometry.within_function = &r_within_box_simple;
}
else {
this_box_volume.geometry.intersect_function = &sample_box_intersect_advanced;
this_box_volume.geometry.within_function = &r_within_box_advanced;
}

this_box_volume.geometry.shell_points = &box_shell_points;
this_box_volume.geometry.mcdisplay_function = &mcdisplay_box_function;
this_box_volume.geometry.initialize_from_main_function = &initialize_box_geometry_from_main_component;
this_box_volume.geometry.process_rot_allocated = 0;

this_box_volume.geometry.copy_geometry_parameters = &allocate_box_storage_copy;

rot_copy(this_box_volume.geometry.rotation_matrix,ROT_A_CURRENT_COMP); //check how ROT_R_CURRENT_COMP would work
rot_transpose(ROT_A_CURRENT_COMP,this_box_volume.geometry.transpose_rotation_matrix);

// Initialize loggers
this_box_volume.loggers.num_elements = 0;

// packing the information into the global_geometry_element, which is then included in the global_geometry_list.
sprintf(global_geometry_element.name,NAME_CURRENT_COMP);
global_geometry_element.activation_counter = number_of_activations;
global_geometry_element.component_index = INDEX_CURRENT_COMP;
global_geometry_element.Volume = &this_box_volume; // Would be nicer if this m was a pointer, now we have the (small) data two places
add_element_to_geometry_list(&global_geometry_list,global_geometry_element);
}
#line 264314 "MACS_sample_kidney_box.c"
#undef number_of_activations
#undef mask_setting
#undef mask_string
#undef p_interact
#undef focus_r
#undef focus_xh
#undef focus_xw
#undef focus_ah
#undef focus_aw
#undef target_z
#undef target_y
#undef target_x
#undef target_index
#undef visualize
#undef yheight2
#undef xwidth2
#undef zdepth
#undef yheight
#undef xwidth
#undef priority
#undef material_string
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

  /* Initializations for component channel_11_analyzer_1_array_crystal_array_7. */
  SIG_MESSAGE("channel_11_analyzer_1_array_crystal_array_7 (Init)");
#define mccompcurname  channel_11_analyzer_1_array_crystal_array_7
#define mccompcurtype  Union_box
#define mccompcurindex 555
#define loop_index mccchannel_11_analyzer_1_array_crystal_array_7_loop_index
#define this_box_volume mccchannel_11_analyzer_1_array_crystal_array_7_this_box_volume
#define global_geometry_element mccchannel_11_analyzer_1_array_crystal_array_7_global_geometry_element
#define this_box_storage mccchannel_11_analyzer_1_array_crystal_array_7_this_box_storage
#define material_string mccchannel_11_analyzer_1_array_crystal_array_7_material_string
#define priority mccchannel_11_analyzer_1_array_crystal_array_7_priority
#define xwidth mccchannel_11_analyzer_1_array_crystal_array_7_xwidth
#define yheight mccchannel_11_analyzer_1_array_crystal_array_7_yheight
#define zdepth mccchannel_11_analyzer_1_array_crystal_array_7_zdepth
#define xwidth2 mccchannel_11_analyzer_1_array_crystal_array_7_xwidth2
#define yheight2 mccchannel_11_analyzer_1_array_crystal_array_7_yheight2
#define visualize mccchannel_11_analyzer_1_array_crystal_array_7_visualize
#define target_index mccchannel_11_analyzer_1_array_crystal_array_7_target_index
#define target_x mccchannel_11_analyzer_1_array_crystal_array_7_target_x
#define target_y mccchannel_11_analyzer_1_array_crystal_array_7_target_y
#define target_z mccchannel_11_analyzer_1_array_crystal_array_7_target_z
#define focus_aw mccchannel_11_analyzer_1_array_crystal_array_7_focus_aw
#define focus_ah mccchannel_11_analyzer_1_array_crystal_array_7_focus_ah
#define focus_xw mccchannel_11_analyzer_1_array_crystal_array_7_focus_xw
#define focus_xh mccchannel_11_analyzer_1_array_crystal_array_7_focus_xh
#define focus_r mccchannel_11_analyzer_1_array_crystal_array_7_focus_r
#define p_interact mccchannel_11_analyzer_1_array_crystal_array_7_p_interact
#define mask_string mccchannel_11_analyzer_1_array_crystal_array_7_mask_string
#define mask_setting mccchannel_11_analyzer_1_array_crystal_array_7_mask_setting
#define number_of_activations mccchannel_11_analyzer_1_array_crystal_array_7_number_of_activations
#line 224 "Union_box.comp"
{
// Initializes the focusing system for this volume including input sanitation.
focus_initialize(&this_box_volume.geometry, POS_A_COMP_INDEX(INDEX_CURRENT_COMP+target_index), POS_A_CURRENT_COMP, ROT_A_CURRENT_COMP, target_index, target_x, target_y, target_z, focus_aw, focus_ah, focus_xw, focus_xh, focus_r, NAME_CURRENT_COMP);

// Input sanitation for this geometry
if (xwidth <= 0) {
  printf("\nERROR in Union_box named %s, the xwidth is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (yheight <= 0) {
  printf("\nERROR in Union_box named %s, yheight is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (zdepth <= 0) {
  printf("\nERROR in Union_box named %s, zdepth is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (xwidth2 <= 0 && xwidth2 != -1) {
  printf("\nERROR in Union_box named %s, the xwidth2 is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (yheight2 <= 0 && yheight2 != -1) {
  printf("\nERROR in Union_box named %s, yheight2 is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}

// Use sanitation
if (global_material_list.num_elements == 0) {
  printf("\nERROR: Need to define a material using Union_make_material before using a Union geometry component. \n");
  printf("       %s was defined before first use of Union_make_material.\n",NAME_CURRENT_COMP);
  exit(1);
}

this_box_volume.geometry.is_masked_volume = 0;
this_box_volume.geometry.is_exit_volume = 0;
this_box_volume.geometry.is_mask_volume = 0;
// check if the volume is a mask, if it is the material string is irelevant.
if (mask_string && strlen(mask_string) && strcmp(mask_string, "NULL") && strcmp(mask_string, "0")) {
    // A mask volume is used to limit the extend of other volumes, called the masked volumes. These are specified in the mask_string.
    // In order for a ray to enter a masked volume, it needs to be both in the region covered by that volume AND the mask volume.
    // When more than
    this_box_volume.geometry.mask_mode = 1; // Default is mask mode is ALL
    if (mask_setting && strlen(mask_setting) && strcmp(mask_setting, "NULL") && strcmp(mask_setting, "0")) {
        if (strcmp(mask_setting,"ALL") == 0 || strcmp(mask_setting,"All") == 0) this_box_volume.geometry.mask_mode = 1;
        else if (strcmp(mask_setting,"ANY") == 0 || strcmp(mask_setting,"Any") == 0) this_box_volume.geometry.mask_mode = 2;
        else {
            printf("The mask_mode of component %s is set to %s, but must be either ALL or ANY.\n",NAME_CURRENT_COMP,mask_setting);
            exit(1);
        }
    }
    
    for (loop_index=0;loop_index<global_geometry_list.num_elements;loop_index++) {
        // Add mask list
        if (1 == manual_linking_function(global_geometry_list.elements[loop_index].name,mask_string)) {
            add_element_to_int_list(&this_box_volume.geometry.mask_list,global_geometry_list.elements[loop_index].component_index);
            add_element_to_int_list(&global_geometry_list.elements[loop_index].Volume->geometry.masked_by_list,INDEX_CURRENT_COMP);
            global_geometry_list.elements[loop_index].Volume->geometry.is_masked_volume = 1;
            if (this_box_volume.geometry.mask_mode == 2)
                global_geometry_list.elements[loop_index].Volume->geometry.mask_mode = 2;
            if (this_box_volume.geometry.mask_mode == 1) {
                if (global_geometry_list.elements[loop_index].Volume->geometry.is_masked_volume == 1 && global_geometry_list.elements[loop_index].Volume->geometry.mask_mode != 2)
                    // If more than one mask is added to one volume, the ANY mode overwrites the (default) ALL mode.
                    global_geometry_list.elements[loop_index].Volume->geometry.mask_mode = 1;
            }
            
            found_geometries = 1;
        }
    }
    if (found_geometries == 0) {
        printf("The mask_string in geometry: %s did not find any of the specified volumes in the mask_string %s \n",NAME_CURRENT_COMP,mask_string);
        exit(1);
    }
    this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
    this_box_volume.p_physics->is_vacuum = 0; // Makes this volume a vacuum
    this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
    this_box_volume.p_physics->my_a = 0; // Should not be used.
    sprintf(this_box_volume.p_physics->name,"Mask");
    this_box_volume.geometry.is_mask_volume = 1;
    
    
// Read the material input, or if it lacks, use automatic linking.
} else if (material_string && strlen(material_string) && strcmp(material_string, "NULL") && strcmp(material_string, "0")) {
    // A geometry string was given, use it to determine which material
    if (0 == strcmp(material_string,"vacuum") || 0 == strcmp(material_string,"Vacuum")) {
        // One could have a global physics struct for vacuum instead of creating one for each
        this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
        this_box_volume.p_physics->is_vacuum = 1; // Makes this volume a vacuum
        this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
        this_box_volume.p_physics->my_a = 0; // Should not be used.
        sprintf(this_box_volume.p_physics->name,"Vacuum");
    } else if (0 == strcmp(material_string,"exit") || 0 == strcmp(material_string,"Exit")) {
        // One could have a global physics struct for vacuum instead of creating one for each
        this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
        this_box_volume.p_physics->is_vacuum = 1; // Makes this volume a vacuum
        this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
        this_box_volume.p_physics->my_a = 0; // Should not be used.
        this_box_volume.geometry.is_exit_volume = 1;
        sprintf(this_box_volume.p_physics->name,"Exit");
    } else {
        #ifndef MATERIAL_DETECTOR
            printf("Need to define a material before refering to it in a geometry %s.\n",NAME_CURRENT_COMP);
            exit(1);
        #endif
        for (loop_index=0;loop_index<global_material_list.num_elements;loop_index++) {
            if (0 == strcmp(material_string,global_material_list.elements[loop_index].name)) {
                this_box_volume.p_physics = global_material_list.elements[loop_index].physics;
                break;
            }
            if (loop_index == global_material_list.num_elements-1) {
            printf("\n");
            printf("ERROR: The material string \"%s\" in Union geometry \"%s\" did not match a specified material. \n",material_string,NAME_CURRENT_COMP);
            printf("       The materials available at this point (need to be defined before the geometry): \n");
            for (loop_index=0;loop_index<global_material_list.num_elements;loop_index++)
              printf("         %s\n",global_material_list.elements[loop_index].name);
            printf("\n");
            printf("       It is also possible to use one of the defualt materials avaiable: \n");
            printf("           Vacuum (for a Volume without scattering or absorption)\n");
            printf("           Exit (for a Volume where the ray exits the component if it enters)\n");
            printf("           Mask (for a Volume that masks existing volumes specified in the mask_string\n");
            exit(1);
          }
        }
    }
} else {
    // Automatic linking, simply using the last defined material.
    #ifndef MATERIAL_DETECTOR
        printf("Need to define a material before the geometry to use automatic linking %s.\n",NAME_CURRENT_COMP);
        exit(1);
    #endif
    this_box_volume.p_physics = global_material_list.elements[global_material_list.num_elements-1].physics;
}

sprintf(this_box_volume.name,NAME_CURRENT_COMP);
sprintf(this_box_volume.geometry.shape,"box");
this_box_volume.geometry.priority_value = priority;
this_box_volume.geometry.geometry_p_interact = p_interact;
// Currently the coordinates will be in absolute space.
this_box_volume.geometry.center = POS_A_CURRENT_COMP;

this_box_storage.z_depth = zdepth;
this_box_storage.x_width1 = xwidth;
this_box_storage.y_height1 = yheight;

this_box_storage.is_rectangle = 0;
if (xwidth2 < 0 && yheight2 < 0) this_box_storage.is_rectangle = 1;
if (xwidth == xwidth2 && yheight == yheight2) this_box_storage.is_rectangle = 1;

if (xwidth2 < 0) {
    this_box_storage.x_width2 = xwidth;
    xwidth2 = xwidth;
} else this_box_storage.x_width2 = xwidth2;

if (yheight2 < 0) {
    this_box_storage.y_height2 = yheight;
    yheight2 = yheight;
} else this_box_storage.y_height2 = yheight2;


this_box_storage.normal_vectors[0] = coords_set(0,0,1);
this_box_storage.normal_vectors[1] = coords_set(0,0,1);

// for sides with y component = 0
x_component = 2*zdepth/sqrt((xwidth-xwidth2)*(xwidth-xwidth2)+4*zdepth*zdepth);
z_component = (xwidth-xwidth2)/sqrt(4*zdepth*zdepth+(xwidth-xwidth2)*(xwidth-xwidth2));

this_box_storage.normal_vectors[2] = coords_set(x_component,0,z_component);
this_box_storage.normal_vectors[3] = coords_set(-x_component,0,z_component);

// for sides with x component = 0
y_component = 2*zdepth/sqrt((yheight-yheight2)*(yheight-yheight2)+4*zdepth*zdepth);
z_component = (yheight-yheight2)/sqrt(4*zdepth*zdepth+(yheight-yheight2)*(yheight-yheight2));

this_box_storage.normal_vectors[4] = coords_set(0,y_component,z_component);
this_box_storage.normal_vectors[5] = coords_set(0,-y_component,z_component);

this_box_volume.geometry.visualization_on = visualize;

this_box_volume.geometry.geometry_parameters.p_box_storage = &this_box_storage;

// Assign pointers to functions for intersection with the shape, checking if a point is inside the shape
if (this_box_storage.is_rectangle == 1) {
this_box_volume.geometry.intersect_function = &sample_box_intersect_simple;
this_box_volume.geometry.within_function = &r_within_box_simple;
}
else {
this_box_volume.geometry.intersect_function = &sample_box_intersect_advanced;
this_box_volume.geometry.within_function = &r_within_box_advanced;
}

this_box_volume.geometry.shell_points = &box_shell_points;
this_box_volume.geometry.mcdisplay_function = &mcdisplay_box_function;
this_box_volume.geometry.initialize_from_main_function = &initialize_box_geometry_from_main_component;
this_box_volume.geometry.process_rot_allocated = 0;

this_box_volume.geometry.copy_geometry_parameters = &allocate_box_storage_copy;

rot_copy(this_box_volume.geometry.rotation_matrix,ROT_A_CURRENT_COMP); //check how ROT_R_CURRENT_COMP would work
rot_transpose(ROT_A_CURRENT_COMP,this_box_volume.geometry.transpose_rotation_matrix);

// Initialize loggers
this_box_volume.loggers.num_elements = 0;

// packing the information into the global_geometry_element, which is then included in the global_geometry_list.
sprintf(global_geometry_element.name,NAME_CURRENT_COMP);
global_geometry_element.activation_counter = number_of_activations;
global_geometry_element.component_index = INDEX_CURRENT_COMP;
global_geometry_element.Volume = &this_box_volume; // Would be nicer if this m was a pointer, now we have the (small) data two places
add_element_to_geometry_list(&global_geometry_list,global_geometry_element);
}
#line 264584 "MACS_sample_kidney_box.c"
#undef number_of_activations
#undef mask_setting
#undef mask_string
#undef p_interact
#undef focus_r
#undef focus_xh
#undef focus_xw
#undef focus_ah
#undef focus_aw
#undef target_z
#undef target_y
#undef target_x
#undef target_index
#undef visualize
#undef yheight2
#undef xwidth2
#undef zdepth
#undef yheight
#undef xwidth
#undef priority
#undef material_string
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

  /* Initializations for component channel_11_analyzer_1_array_crystal_array_8. */
  SIG_MESSAGE("channel_11_analyzer_1_array_crystal_array_8 (Init)");
#define mccompcurname  channel_11_analyzer_1_array_crystal_array_8
#define mccompcurtype  Union_box
#define mccompcurindex 556
#define loop_index mccchannel_11_analyzer_1_array_crystal_array_8_loop_index
#define this_box_volume mccchannel_11_analyzer_1_array_crystal_array_8_this_box_volume
#define global_geometry_element mccchannel_11_analyzer_1_array_crystal_array_8_global_geometry_element
#define this_box_storage mccchannel_11_analyzer_1_array_crystal_array_8_this_box_storage
#define material_string mccchannel_11_analyzer_1_array_crystal_array_8_material_string
#define priority mccchannel_11_analyzer_1_array_crystal_array_8_priority
#define xwidth mccchannel_11_analyzer_1_array_crystal_array_8_xwidth
#define yheight mccchannel_11_analyzer_1_array_crystal_array_8_yheight
#define zdepth mccchannel_11_analyzer_1_array_crystal_array_8_zdepth
#define xwidth2 mccchannel_11_analyzer_1_array_crystal_array_8_xwidth2
#define yheight2 mccchannel_11_analyzer_1_array_crystal_array_8_yheight2
#define visualize mccchannel_11_analyzer_1_array_crystal_array_8_visualize
#define target_index mccchannel_11_analyzer_1_array_crystal_array_8_target_index
#define target_x mccchannel_11_analyzer_1_array_crystal_array_8_target_x
#define target_y mccchannel_11_analyzer_1_array_crystal_array_8_target_y
#define target_z mccchannel_11_analyzer_1_array_crystal_array_8_target_z
#define focus_aw mccchannel_11_analyzer_1_array_crystal_array_8_focus_aw
#define focus_ah mccchannel_11_analyzer_1_array_crystal_array_8_focus_ah
#define focus_xw mccchannel_11_analyzer_1_array_crystal_array_8_focus_xw
#define focus_xh mccchannel_11_analyzer_1_array_crystal_array_8_focus_xh
#define focus_r mccchannel_11_analyzer_1_array_crystal_array_8_focus_r
#define p_interact mccchannel_11_analyzer_1_array_crystal_array_8_p_interact
#define mask_string mccchannel_11_analyzer_1_array_crystal_array_8_mask_string
#define mask_setting mccchannel_11_analyzer_1_array_crystal_array_8_mask_setting
#define number_of_activations mccchannel_11_analyzer_1_array_crystal_array_8_number_of_activations
#line 224 "Union_box.comp"
{
// Initializes the focusing system for this volume including input sanitation.
focus_initialize(&this_box_volume.geometry, POS_A_COMP_INDEX(INDEX_CURRENT_COMP+target_index), POS_A_CURRENT_COMP, ROT_A_CURRENT_COMP, target_index, target_x, target_y, target_z, focus_aw, focus_ah, focus_xw, focus_xh, focus_r, NAME_CURRENT_COMP);

// Input sanitation for this geometry
if (xwidth <= 0) {
  printf("\nERROR in Union_box named %s, the xwidth is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (yheight <= 0) {
  printf("\nERROR in Union_box named %s, yheight is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (zdepth <= 0) {
  printf("\nERROR in Union_box named %s, zdepth is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (xwidth2 <= 0 && xwidth2 != -1) {
  printf("\nERROR in Union_box named %s, the xwidth2 is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (yheight2 <= 0 && yheight2 != -1) {
  printf("\nERROR in Union_box named %s, yheight2 is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}

// Use sanitation
if (global_material_list.num_elements == 0) {
  printf("\nERROR: Need to define a material using Union_make_material before using a Union geometry component. \n");
  printf("       %s was defined before first use of Union_make_material.\n",NAME_CURRENT_COMP);
  exit(1);
}

this_box_volume.geometry.is_masked_volume = 0;
this_box_volume.geometry.is_exit_volume = 0;
this_box_volume.geometry.is_mask_volume = 0;
// check if the volume is a mask, if it is the material string is irelevant.
if (mask_string && strlen(mask_string) && strcmp(mask_string, "NULL") && strcmp(mask_string, "0")) {
    // A mask volume is used to limit the extend of other volumes, called the masked volumes. These are specified in the mask_string.
    // In order for a ray to enter a masked volume, it needs to be both in the region covered by that volume AND the mask volume.
    // When more than
    this_box_volume.geometry.mask_mode = 1; // Default is mask mode is ALL
    if (mask_setting && strlen(mask_setting) && strcmp(mask_setting, "NULL") && strcmp(mask_setting, "0")) {
        if (strcmp(mask_setting,"ALL") == 0 || strcmp(mask_setting,"All") == 0) this_box_volume.geometry.mask_mode = 1;
        else if (strcmp(mask_setting,"ANY") == 0 || strcmp(mask_setting,"Any") == 0) this_box_volume.geometry.mask_mode = 2;
        else {
            printf("The mask_mode of component %s is set to %s, but must be either ALL or ANY.\n",NAME_CURRENT_COMP,mask_setting);
            exit(1);
        }
    }
    
    for (loop_index=0;loop_index<global_geometry_list.num_elements;loop_index++) {
        // Add mask list
        if (1 == manual_linking_function(global_geometry_list.elements[loop_index].name,mask_string)) {
            add_element_to_int_list(&this_box_volume.geometry.mask_list,global_geometry_list.elements[loop_index].component_index);
            add_element_to_int_list(&global_geometry_list.elements[loop_index].Volume->geometry.masked_by_list,INDEX_CURRENT_COMP);
            global_geometry_list.elements[loop_index].Volume->geometry.is_masked_volume = 1;
            if (this_box_volume.geometry.mask_mode == 2)
                global_geometry_list.elements[loop_index].Volume->geometry.mask_mode = 2;
            if (this_box_volume.geometry.mask_mode == 1) {
                if (global_geometry_list.elements[loop_index].Volume->geometry.is_masked_volume == 1 && global_geometry_list.elements[loop_index].Volume->geometry.mask_mode != 2)
                    // If more than one mask is added to one volume, the ANY mode overwrites the (default) ALL mode.
                    global_geometry_list.elements[loop_index].Volume->geometry.mask_mode = 1;
            }
            
            found_geometries = 1;
        }
    }
    if (found_geometries == 0) {
        printf("The mask_string in geometry: %s did not find any of the specified volumes in the mask_string %s \n",NAME_CURRENT_COMP,mask_string);
        exit(1);
    }
    this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
    this_box_volume.p_physics->is_vacuum = 0; // Makes this volume a vacuum
    this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
    this_box_volume.p_physics->my_a = 0; // Should not be used.
    sprintf(this_box_volume.p_physics->name,"Mask");
    this_box_volume.geometry.is_mask_volume = 1;
    
    
// Read the material input, or if it lacks, use automatic linking.
} else if (material_string && strlen(material_string) && strcmp(material_string, "NULL") && strcmp(material_string, "0")) {
    // A geometry string was given, use it to determine which material
    if (0 == strcmp(material_string,"vacuum") || 0 == strcmp(material_string,"Vacuum")) {
        // One could have a global physics struct for vacuum instead of creating one for each
        this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
        this_box_volume.p_physics->is_vacuum = 1; // Makes this volume a vacuum
        this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
        this_box_volume.p_physics->my_a = 0; // Should not be used.
        sprintf(this_box_volume.p_physics->name,"Vacuum");
    } else if (0 == strcmp(material_string,"exit") || 0 == strcmp(material_string,"Exit")) {
        // One could have a global physics struct for vacuum instead of creating one for each
        this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
        this_box_volume.p_physics->is_vacuum = 1; // Makes this volume a vacuum
        this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
        this_box_volume.p_physics->my_a = 0; // Should not be used.
        this_box_volume.geometry.is_exit_volume = 1;
        sprintf(this_box_volume.p_physics->name,"Exit");
    } else {
        #ifndef MATERIAL_DETECTOR
            printf("Need to define a material before refering to it in a geometry %s.\n",NAME_CURRENT_COMP);
            exit(1);
        #endif
        for (loop_index=0;loop_index<global_material_list.num_elements;loop_index++) {
            if (0 == strcmp(material_string,global_material_list.elements[loop_index].name)) {
                this_box_volume.p_physics = global_material_list.elements[loop_index].physics;
                break;
            }
            if (loop_index == global_material_list.num_elements-1) {
            printf("\n");
            printf("ERROR: The material string \"%s\" in Union geometry \"%s\" did not match a specified material. \n",material_string,NAME_CURRENT_COMP);
            printf("       The materials available at this point (need to be defined before the geometry): \n");
            for (loop_index=0;loop_index<global_material_list.num_elements;loop_index++)
              printf("         %s\n",global_material_list.elements[loop_index].name);
            printf("\n");
            printf("       It is also possible to use one of the defualt materials avaiable: \n");
            printf("           Vacuum (for a Volume without scattering or absorption)\n");
            printf("           Exit (for a Volume where the ray exits the component if it enters)\n");
            printf("           Mask (for a Volume that masks existing volumes specified in the mask_string\n");
            exit(1);
          }
        }
    }
} else {
    // Automatic linking, simply using the last defined material.
    #ifndef MATERIAL_DETECTOR
        printf("Need to define a material before the geometry to use automatic linking %s.\n",NAME_CURRENT_COMP);
        exit(1);
    #endif
    this_box_volume.p_physics = global_material_list.elements[global_material_list.num_elements-1].physics;
}

sprintf(this_box_volume.name,NAME_CURRENT_COMP);
sprintf(this_box_volume.geometry.shape,"box");
this_box_volume.geometry.priority_value = priority;
this_box_volume.geometry.geometry_p_interact = p_interact;
// Currently the coordinates will be in absolute space.
this_box_volume.geometry.center = POS_A_CURRENT_COMP;

this_box_storage.z_depth = zdepth;
this_box_storage.x_width1 = xwidth;
this_box_storage.y_height1 = yheight;

this_box_storage.is_rectangle = 0;
if (xwidth2 < 0 && yheight2 < 0) this_box_storage.is_rectangle = 1;
if (xwidth == xwidth2 && yheight == yheight2) this_box_storage.is_rectangle = 1;

if (xwidth2 < 0) {
    this_box_storage.x_width2 = xwidth;
    xwidth2 = xwidth;
} else this_box_storage.x_width2 = xwidth2;

if (yheight2 < 0) {
    this_box_storage.y_height2 = yheight;
    yheight2 = yheight;
} else this_box_storage.y_height2 = yheight2;


this_box_storage.normal_vectors[0] = coords_set(0,0,1);
this_box_storage.normal_vectors[1] = coords_set(0,0,1);

// for sides with y component = 0
x_component = 2*zdepth/sqrt((xwidth-xwidth2)*(xwidth-xwidth2)+4*zdepth*zdepth);
z_component = (xwidth-xwidth2)/sqrt(4*zdepth*zdepth+(xwidth-xwidth2)*(xwidth-xwidth2));

this_box_storage.normal_vectors[2] = coords_set(x_component,0,z_component);
this_box_storage.normal_vectors[3] = coords_set(-x_component,0,z_component);

// for sides with x component = 0
y_component = 2*zdepth/sqrt((yheight-yheight2)*(yheight-yheight2)+4*zdepth*zdepth);
z_component = (yheight-yheight2)/sqrt(4*zdepth*zdepth+(yheight-yheight2)*(yheight-yheight2));

this_box_storage.normal_vectors[4] = coords_set(0,y_component,z_component);
this_box_storage.normal_vectors[5] = coords_set(0,-y_component,z_component);

this_box_volume.geometry.visualization_on = visualize;

this_box_volume.geometry.geometry_parameters.p_box_storage = &this_box_storage;

// Assign pointers to functions for intersection with the shape, checking if a point is inside the shape
if (this_box_storage.is_rectangle == 1) {
this_box_volume.geometry.intersect_function = &sample_box_intersect_simple;
this_box_volume.geometry.within_function = &r_within_box_simple;
}
else {
this_box_volume.geometry.intersect_function = &sample_box_intersect_advanced;
this_box_volume.geometry.within_function = &r_within_box_advanced;
}

this_box_volume.geometry.shell_points = &box_shell_points;
this_box_volume.geometry.mcdisplay_function = &mcdisplay_box_function;
this_box_volume.geometry.initialize_from_main_function = &initialize_box_geometry_from_main_component;
this_box_volume.geometry.process_rot_allocated = 0;

this_box_volume.geometry.copy_geometry_parameters = &allocate_box_storage_copy;

rot_copy(this_box_volume.geometry.rotation_matrix,ROT_A_CURRENT_COMP); //check how ROT_R_CURRENT_COMP would work
rot_transpose(ROT_A_CURRENT_COMP,this_box_volume.geometry.transpose_rotation_matrix);

// Initialize loggers
this_box_volume.loggers.num_elements = 0;

// packing the information into the global_geometry_element, which is then included in the global_geometry_list.
sprintf(global_geometry_element.name,NAME_CURRENT_COMP);
global_geometry_element.activation_counter = number_of_activations;
global_geometry_element.component_index = INDEX_CURRENT_COMP;
global_geometry_element.Volume = &this_box_volume; // Would be nicer if this m was a pointer, now we have the (small) data two places
add_element_to_geometry_list(&global_geometry_list,global_geometry_element);
}
#line 264854 "MACS_sample_kidney_box.c"
#undef number_of_activations
#undef mask_setting
#undef mask_string
#undef p_interact
#undef focus_r
#undef focus_xh
#undef focus_xw
#undef focus_ah
#undef focus_aw
#undef target_z
#undef target_y
#undef target_x
#undef target_index
#undef visualize
#undef yheight2
#undef xwidth2
#undef zdepth
#undef yheight
#undef xwidth
#undef priority
#undef material_string
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

  /* Initializations for component channel_11_analyzer_2_center. */
  SIG_MESSAGE("channel_11_analyzer_2_center (Init)");

  /* Initializations for component channel_11_analyzer_2_rotated. */
  SIG_MESSAGE("channel_11_analyzer_2_rotated (Init)");

  /* Initializations for component channel_11_analyzer_2_array_crystal_array_0. */
  SIG_MESSAGE("channel_11_analyzer_2_array_crystal_array_0 (Init)");
#define mccompcurname  channel_11_analyzer_2_array_crystal_array_0
#define mccompcurtype  Union_box
#define mccompcurindex 559
#define loop_index mccchannel_11_analyzer_2_array_crystal_array_0_loop_index
#define this_box_volume mccchannel_11_analyzer_2_array_crystal_array_0_this_box_volume
#define global_geometry_element mccchannel_11_analyzer_2_array_crystal_array_0_global_geometry_element
#define this_box_storage mccchannel_11_analyzer_2_array_crystal_array_0_this_box_storage
#define material_string mccchannel_11_analyzer_2_array_crystal_array_0_material_string
#define priority mccchannel_11_analyzer_2_array_crystal_array_0_priority
#define xwidth mccchannel_11_analyzer_2_array_crystal_array_0_xwidth
#define yheight mccchannel_11_analyzer_2_array_crystal_array_0_yheight
#define zdepth mccchannel_11_analyzer_2_array_crystal_array_0_zdepth
#define xwidth2 mccchannel_11_analyzer_2_array_crystal_array_0_xwidth2
#define yheight2 mccchannel_11_analyzer_2_array_crystal_array_0_yheight2
#define visualize mccchannel_11_analyzer_2_array_crystal_array_0_visualize
#define target_index mccchannel_11_analyzer_2_array_crystal_array_0_target_index
#define target_x mccchannel_11_analyzer_2_array_crystal_array_0_target_x
#define target_y mccchannel_11_analyzer_2_array_crystal_array_0_target_y
#define target_z mccchannel_11_analyzer_2_array_crystal_array_0_target_z
#define focus_aw mccchannel_11_analyzer_2_array_crystal_array_0_focus_aw
#define focus_ah mccchannel_11_analyzer_2_array_crystal_array_0_focus_ah
#define focus_xw mccchannel_11_analyzer_2_array_crystal_array_0_focus_xw
#define focus_xh mccchannel_11_analyzer_2_array_crystal_array_0_focus_xh
#define focus_r mccchannel_11_analyzer_2_array_crystal_array_0_focus_r
#define p_interact mccchannel_11_analyzer_2_array_crystal_array_0_p_interact
#define mask_string mccchannel_11_analyzer_2_array_crystal_array_0_mask_string
#define mask_setting mccchannel_11_analyzer_2_array_crystal_array_0_mask_setting
#define number_of_activations mccchannel_11_analyzer_2_array_crystal_array_0_number_of_activations
#line 224 "Union_box.comp"
{
// Initializes the focusing system for this volume including input sanitation.
focus_initialize(&this_box_volume.geometry, POS_A_COMP_INDEX(INDEX_CURRENT_COMP+target_index), POS_A_CURRENT_COMP, ROT_A_CURRENT_COMP, target_index, target_x, target_y, target_z, focus_aw, focus_ah, focus_xw, focus_xh, focus_r, NAME_CURRENT_COMP);

// Input sanitation for this geometry
if (xwidth <= 0) {
  printf("\nERROR in Union_box named %s, the xwidth is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (yheight <= 0) {
  printf("\nERROR in Union_box named %s, yheight is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (zdepth <= 0) {
  printf("\nERROR in Union_box named %s, zdepth is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (xwidth2 <= 0 && xwidth2 != -1) {
  printf("\nERROR in Union_box named %s, the xwidth2 is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (yheight2 <= 0 && yheight2 != -1) {
  printf("\nERROR in Union_box named %s, yheight2 is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}

// Use sanitation
if (global_material_list.num_elements == 0) {
  printf("\nERROR: Need to define a material using Union_make_material before using a Union geometry component. \n");
  printf("       %s was defined before first use of Union_make_material.\n",NAME_CURRENT_COMP);
  exit(1);
}

this_box_volume.geometry.is_masked_volume = 0;
this_box_volume.geometry.is_exit_volume = 0;
this_box_volume.geometry.is_mask_volume = 0;
// check if the volume is a mask, if it is the material string is irelevant.
if (mask_string && strlen(mask_string) && strcmp(mask_string, "NULL") && strcmp(mask_string, "0")) {
    // A mask volume is used to limit the extend of other volumes, called the masked volumes. These are specified in the mask_string.
    // In order for a ray to enter a masked volume, it needs to be both in the region covered by that volume AND the mask volume.
    // When more than
    this_box_volume.geometry.mask_mode = 1; // Default is mask mode is ALL
    if (mask_setting && strlen(mask_setting) && strcmp(mask_setting, "NULL") && strcmp(mask_setting, "0")) {
        if (strcmp(mask_setting,"ALL") == 0 || strcmp(mask_setting,"All") == 0) this_box_volume.geometry.mask_mode = 1;
        else if (strcmp(mask_setting,"ANY") == 0 || strcmp(mask_setting,"Any") == 0) this_box_volume.geometry.mask_mode = 2;
        else {
            printf("The mask_mode of component %s is set to %s, but must be either ALL or ANY.\n",NAME_CURRENT_COMP,mask_setting);
            exit(1);
        }
    }
    
    for (loop_index=0;loop_index<global_geometry_list.num_elements;loop_index++) {
        // Add mask list
        if (1 == manual_linking_function(global_geometry_list.elements[loop_index].name,mask_string)) {
            add_element_to_int_list(&this_box_volume.geometry.mask_list,global_geometry_list.elements[loop_index].component_index);
            add_element_to_int_list(&global_geometry_list.elements[loop_index].Volume->geometry.masked_by_list,INDEX_CURRENT_COMP);
            global_geometry_list.elements[loop_index].Volume->geometry.is_masked_volume = 1;
            if (this_box_volume.geometry.mask_mode == 2)
                global_geometry_list.elements[loop_index].Volume->geometry.mask_mode = 2;
            if (this_box_volume.geometry.mask_mode == 1) {
                if (global_geometry_list.elements[loop_index].Volume->geometry.is_masked_volume == 1 && global_geometry_list.elements[loop_index].Volume->geometry.mask_mode != 2)
                    // If more than one mask is added to one volume, the ANY mode overwrites the (default) ALL mode.
                    global_geometry_list.elements[loop_index].Volume->geometry.mask_mode = 1;
            }
            
            found_geometries = 1;
        }
    }
    if (found_geometries == 0) {
        printf("The mask_string in geometry: %s did not find any of the specified volumes in the mask_string %s \n",NAME_CURRENT_COMP,mask_string);
        exit(1);
    }
    this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
    this_box_volume.p_physics->is_vacuum = 0; // Makes this volume a vacuum
    this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
    this_box_volume.p_physics->my_a = 0; // Should not be used.
    sprintf(this_box_volume.p_physics->name,"Mask");
    this_box_volume.geometry.is_mask_volume = 1;
    
    
// Read the material input, or if it lacks, use automatic linking.
} else if (material_string && strlen(material_string) && strcmp(material_string, "NULL") && strcmp(material_string, "0")) {
    // A geometry string was given, use it to determine which material
    if (0 == strcmp(material_string,"vacuum") || 0 == strcmp(material_string,"Vacuum")) {
        // One could have a global physics struct for vacuum instead of creating one for each
        this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
        this_box_volume.p_physics->is_vacuum = 1; // Makes this volume a vacuum
        this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
        this_box_volume.p_physics->my_a = 0; // Should not be used.
        sprintf(this_box_volume.p_physics->name,"Vacuum");
    } else if (0 == strcmp(material_string,"exit") || 0 == strcmp(material_string,"Exit")) {
        // One could have a global physics struct for vacuum instead of creating one for each
        this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
        this_box_volume.p_physics->is_vacuum = 1; // Makes this volume a vacuum
        this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
        this_box_volume.p_physics->my_a = 0; // Should not be used.
        this_box_volume.geometry.is_exit_volume = 1;
        sprintf(this_box_volume.p_physics->name,"Exit");
    } else {
        #ifndef MATERIAL_DETECTOR
            printf("Need to define a material before refering to it in a geometry %s.\n",NAME_CURRENT_COMP);
            exit(1);
        #endif
        for (loop_index=0;loop_index<global_material_list.num_elements;loop_index++) {
            if (0 == strcmp(material_string,global_material_list.elements[loop_index].name)) {
                this_box_volume.p_physics = global_material_list.elements[loop_index].physics;
                break;
            }
            if (loop_index == global_material_list.num_elements-1) {
            printf("\n");
            printf("ERROR: The material string \"%s\" in Union geometry \"%s\" did not match a specified material. \n",material_string,NAME_CURRENT_COMP);
            printf("       The materials available at this point (need to be defined before the geometry): \n");
            for (loop_index=0;loop_index<global_material_list.num_elements;loop_index++)
              printf("         %s\n",global_material_list.elements[loop_index].name);
            printf("\n");
            printf("       It is also possible to use one of the defualt materials avaiable: \n");
            printf("           Vacuum (for a Volume without scattering or absorption)\n");
            printf("           Exit (for a Volume where the ray exits the component if it enters)\n");
            printf("           Mask (for a Volume that masks existing volumes specified in the mask_string\n");
            exit(1);
          }
        }
    }
} else {
    // Automatic linking, simply using the last defined material.
    #ifndef MATERIAL_DETECTOR
        printf("Need to define a material before the geometry to use automatic linking %s.\n",NAME_CURRENT_COMP);
        exit(1);
    #endif
    this_box_volume.p_physics = global_material_list.elements[global_material_list.num_elements-1].physics;
}

sprintf(this_box_volume.name,NAME_CURRENT_COMP);
sprintf(this_box_volume.geometry.shape,"box");
this_box_volume.geometry.priority_value = priority;
this_box_volume.geometry.geometry_p_interact = p_interact;
// Currently the coordinates will be in absolute space.
this_box_volume.geometry.center = POS_A_CURRENT_COMP;

this_box_storage.z_depth = zdepth;
this_box_storage.x_width1 = xwidth;
this_box_storage.y_height1 = yheight;

this_box_storage.is_rectangle = 0;
if (xwidth2 < 0 && yheight2 < 0) this_box_storage.is_rectangle = 1;
if (xwidth == xwidth2 && yheight == yheight2) this_box_storage.is_rectangle = 1;

if (xwidth2 < 0) {
    this_box_storage.x_width2 = xwidth;
    xwidth2 = xwidth;
} else this_box_storage.x_width2 = xwidth2;

if (yheight2 < 0) {
    this_box_storage.y_height2 = yheight;
    yheight2 = yheight;
} else this_box_storage.y_height2 = yheight2;


this_box_storage.normal_vectors[0] = coords_set(0,0,1);
this_box_storage.normal_vectors[1] = coords_set(0,0,1);

// for sides with y component = 0
x_component = 2*zdepth/sqrt((xwidth-xwidth2)*(xwidth-xwidth2)+4*zdepth*zdepth);
z_component = (xwidth-xwidth2)/sqrt(4*zdepth*zdepth+(xwidth-xwidth2)*(xwidth-xwidth2));

this_box_storage.normal_vectors[2] = coords_set(x_component,0,z_component);
this_box_storage.normal_vectors[3] = coords_set(-x_component,0,z_component);

// for sides with x component = 0
y_component = 2*zdepth/sqrt((yheight-yheight2)*(yheight-yheight2)+4*zdepth*zdepth);
z_component = (yheight-yheight2)/sqrt(4*zdepth*zdepth+(yheight-yheight2)*(yheight-yheight2));

this_box_storage.normal_vectors[4] = coords_set(0,y_component,z_component);
this_box_storage.normal_vectors[5] = coords_set(0,-y_component,z_component);

this_box_volume.geometry.visualization_on = visualize;

this_box_volume.geometry.geometry_parameters.p_box_storage = &this_box_storage;

// Assign pointers to functions for intersection with the shape, checking if a point is inside the shape
if (this_box_storage.is_rectangle == 1) {
this_box_volume.geometry.intersect_function = &sample_box_intersect_simple;
this_box_volume.geometry.within_function = &r_within_box_simple;
}
else {
this_box_volume.geometry.intersect_function = &sample_box_intersect_advanced;
this_box_volume.geometry.within_function = &r_within_box_advanced;
}

this_box_volume.geometry.shell_points = &box_shell_points;
this_box_volume.geometry.mcdisplay_function = &mcdisplay_box_function;
this_box_volume.geometry.initialize_from_main_function = &initialize_box_geometry_from_main_component;
this_box_volume.geometry.process_rot_allocated = 0;

this_box_volume.geometry.copy_geometry_parameters = &allocate_box_storage_copy;

rot_copy(this_box_volume.geometry.rotation_matrix,ROT_A_CURRENT_COMP); //check how ROT_R_CURRENT_COMP would work
rot_transpose(ROT_A_CURRENT_COMP,this_box_volume.geometry.transpose_rotation_matrix);

// Initialize loggers
this_box_volume.loggers.num_elements = 0;

// packing the information into the global_geometry_element, which is then included in the global_geometry_list.
sprintf(global_geometry_element.name,NAME_CURRENT_COMP);
global_geometry_element.activation_counter = number_of_activations;
global_geometry_element.component_index = INDEX_CURRENT_COMP;
global_geometry_element.Volume = &this_box_volume; // Would be nicer if this m was a pointer, now we have the (small) data two places
add_element_to_geometry_list(&global_geometry_list,global_geometry_element);
}
#line 265130 "MACS_sample_kidney_box.c"
#undef number_of_activations
#undef mask_setting
#undef mask_string
#undef p_interact
#undef focus_r
#undef focus_xh
#undef focus_xw
#undef focus_ah
#undef focus_aw
#undef target_z
#undef target_y
#undef target_x
#undef target_index
#undef visualize
#undef yheight2
#undef xwidth2
#undef zdepth
#undef yheight
#undef xwidth
#undef priority
#undef material_string
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

  /* Initializations for component channel_11_analyzer_2_array_crystal_array_1. */
  SIG_MESSAGE("channel_11_analyzer_2_array_crystal_array_1 (Init)");
#define mccompcurname  channel_11_analyzer_2_array_crystal_array_1
#define mccompcurtype  Union_box
#define mccompcurindex 560
#define loop_index mccchannel_11_analyzer_2_array_crystal_array_1_loop_index
#define this_box_volume mccchannel_11_analyzer_2_array_crystal_array_1_this_box_volume
#define global_geometry_element mccchannel_11_analyzer_2_array_crystal_array_1_global_geometry_element
#define this_box_storage mccchannel_11_analyzer_2_array_crystal_array_1_this_box_storage
#define material_string mccchannel_11_analyzer_2_array_crystal_array_1_material_string
#define priority mccchannel_11_analyzer_2_array_crystal_array_1_priority
#define xwidth mccchannel_11_analyzer_2_array_crystal_array_1_xwidth
#define yheight mccchannel_11_analyzer_2_array_crystal_array_1_yheight
#define zdepth mccchannel_11_analyzer_2_array_crystal_array_1_zdepth
#define xwidth2 mccchannel_11_analyzer_2_array_crystal_array_1_xwidth2
#define yheight2 mccchannel_11_analyzer_2_array_crystal_array_1_yheight2
#define visualize mccchannel_11_analyzer_2_array_crystal_array_1_visualize
#define target_index mccchannel_11_analyzer_2_array_crystal_array_1_target_index
#define target_x mccchannel_11_analyzer_2_array_crystal_array_1_target_x
#define target_y mccchannel_11_analyzer_2_array_crystal_array_1_target_y
#define target_z mccchannel_11_analyzer_2_array_crystal_array_1_target_z
#define focus_aw mccchannel_11_analyzer_2_array_crystal_array_1_focus_aw
#define focus_ah mccchannel_11_analyzer_2_array_crystal_array_1_focus_ah
#define focus_xw mccchannel_11_analyzer_2_array_crystal_array_1_focus_xw
#define focus_xh mccchannel_11_analyzer_2_array_crystal_array_1_focus_xh
#define focus_r mccchannel_11_analyzer_2_array_crystal_array_1_focus_r
#define p_interact mccchannel_11_analyzer_2_array_crystal_array_1_p_interact
#define mask_string mccchannel_11_analyzer_2_array_crystal_array_1_mask_string
#define mask_setting mccchannel_11_analyzer_2_array_crystal_array_1_mask_setting
#define number_of_activations mccchannel_11_analyzer_2_array_crystal_array_1_number_of_activations
#line 224 "Union_box.comp"
{
// Initializes the focusing system for this volume including input sanitation.
focus_initialize(&this_box_volume.geometry, POS_A_COMP_INDEX(INDEX_CURRENT_COMP+target_index), POS_A_CURRENT_COMP, ROT_A_CURRENT_COMP, target_index, target_x, target_y, target_z, focus_aw, focus_ah, focus_xw, focus_xh, focus_r, NAME_CURRENT_COMP);

// Input sanitation for this geometry
if (xwidth <= 0) {
  printf("\nERROR in Union_box named %s, the xwidth is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (yheight <= 0) {
  printf("\nERROR in Union_box named %s, yheight is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (zdepth <= 0) {
  printf("\nERROR in Union_box named %s, zdepth is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (xwidth2 <= 0 && xwidth2 != -1) {
  printf("\nERROR in Union_box named %s, the xwidth2 is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (yheight2 <= 0 && yheight2 != -1) {
  printf("\nERROR in Union_box named %s, yheight2 is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}

// Use sanitation
if (global_material_list.num_elements == 0) {
  printf("\nERROR: Need to define a material using Union_make_material before using a Union geometry component. \n");
  printf("       %s was defined before first use of Union_make_material.\n",NAME_CURRENT_COMP);
  exit(1);
}

this_box_volume.geometry.is_masked_volume = 0;
this_box_volume.geometry.is_exit_volume = 0;
this_box_volume.geometry.is_mask_volume = 0;
// check if the volume is a mask, if it is the material string is irelevant.
if (mask_string && strlen(mask_string) && strcmp(mask_string, "NULL") && strcmp(mask_string, "0")) {
    // A mask volume is used to limit the extend of other volumes, called the masked volumes. These are specified in the mask_string.
    // In order for a ray to enter a masked volume, it needs to be both in the region covered by that volume AND the mask volume.
    // When more than
    this_box_volume.geometry.mask_mode = 1; // Default is mask mode is ALL
    if (mask_setting && strlen(mask_setting) && strcmp(mask_setting, "NULL") && strcmp(mask_setting, "0")) {
        if (strcmp(mask_setting,"ALL") == 0 || strcmp(mask_setting,"All") == 0) this_box_volume.geometry.mask_mode = 1;
        else if (strcmp(mask_setting,"ANY") == 0 || strcmp(mask_setting,"Any") == 0) this_box_volume.geometry.mask_mode = 2;
        else {
            printf("The mask_mode of component %s is set to %s, but must be either ALL or ANY.\n",NAME_CURRENT_COMP,mask_setting);
            exit(1);
        }
    }
    
    for (loop_index=0;loop_index<global_geometry_list.num_elements;loop_index++) {
        // Add mask list
        if (1 == manual_linking_function(global_geometry_list.elements[loop_index].name,mask_string)) {
            add_element_to_int_list(&this_box_volume.geometry.mask_list,global_geometry_list.elements[loop_index].component_index);
            add_element_to_int_list(&global_geometry_list.elements[loop_index].Volume->geometry.masked_by_list,INDEX_CURRENT_COMP);
            global_geometry_list.elements[loop_index].Volume->geometry.is_masked_volume = 1;
            if (this_box_volume.geometry.mask_mode == 2)
                global_geometry_list.elements[loop_index].Volume->geometry.mask_mode = 2;
            if (this_box_volume.geometry.mask_mode == 1) {
                if (global_geometry_list.elements[loop_index].Volume->geometry.is_masked_volume == 1 && global_geometry_list.elements[loop_index].Volume->geometry.mask_mode != 2)
                    // If more than one mask is added to one volume, the ANY mode overwrites the (default) ALL mode.
                    global_geometry_list.elements[loop_index].Volume->geometry.mask_mode = 1;
            }
            
            found_geometries = 1;
        }
    }
    if (found_geometries == 0) {
        printf("The mask_string in geometry: %s did not find any of the specified volumes in the mask_string %s \n",NAME_CURRENT_COMP,mask_string);
        exit(1);
    }
    this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
    this_box_volume.p_physics->is_vacuum = 0; // Makes this volume a vacuum
    this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
    this_box_volume.p_physics->my_a = 0; // Should not be used.
    sprintf(this_box_volume.p_physics->name,"Mask");
    this_box_volume.geometry.is_mask_volume = 1;
    
    
// Read the material input, or if it lacks, use automatic linking.
} else if (material_string && strlen(material_string) && strcmp(material_string, "NULL") && strcmp(material_string, "0")) {
    // A geometry string was given, use it to determine which material
    if (0 == strcmp(material_string,"vacuum") || 0 == strcmp(material_string,"Vacuum")) {
        // One could have a global physics struct for vacuum instead of creating one for each
        this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
        this_box_volume.p_physics->is_vacuum = 1; // Makes this volume a vacuum
        this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
        this_box_volume.p_physics->my_a = 0; // Should not be used.
        sprintf(this_box_volume.p_physics->name,"Vacuum");
    } else if (0 == strcmp(material_string,"exit") || 0 == strcmp(material_string,"Exit")) {
        // One could have a global physics struct for vacuum instead of creating one for each
        this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
        this_box_volume.p_physics->is_vacuum = 1; // Makes this volume a vacuum
        this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
        this_box_volume.p_physics->my_a = 0; // Should not be used.
        this_box_volume.geometry.is_exit_volume = 1;
        sprintf(this_box_volume.p_physics->name,"Exit");
    } else {
        #ifndef MATERIAL_DETECTOR
            printf("Need to define a material before refering to it in a geometry %s.\n",NAME_CURRENT_COMP);
            exit(1);
        #endif
        for (loop_index=0;loop_index<global_material_list.num_elements;loop_index++) {
            if (0 == strcmp(material_string,global_material_list.elements[loop_index].name)) {
                this_box_volume.p_physics = global_material_list.elements[loop_index].physics;
                break;
            }
            if (loop_index == global_material_list.num_elements-1) {
            printf("\n");
            printf("ERROR: The material string \"%s\" in Union geometry \"%s\" did not match a specified material. \n",material_string,NAME_CURRENT_COMP);
            printf("       The materials available at this point (need to be defined before the geometry): \n");
            for (loop_index=0;loop_index<global_material_list.num_elements;loop_index++)
              printf("         %s\n",global_material_list.elements[loop_index].name);
            printf("\n");
            printf("       It is also possible to use one of the defualt materials avaiable: \n");
            printf("           Vacuum (for a Volume without scattering or absorption)\n");
            printf("           Exit (for a Volume where the ray exits the component if it enters)\n");
            printf("           Mask (for a Volume that masks existing volumes specified in the mask_string\n");
            exit(1);
          }
        }
    }
} else {
    // Automatic linking, simply using the last defined material.
    #ifndef MATERIAL_DETECTOR
        printf("Need to define a material before the geometry to use automatic linking %s.\n",NAME_CURRENT_COMP);
        exit(1);
    #endif
    this_box_volume.p_physics = global_material_list.elements[global_material_list.num_elements-1].physics;
}

sprintf(this_box_volume.name,NAME_CURRENT_COMP);
sprintf(this_box_volume.geometry.shape,"box");
this_box_volume.geometry.priority_value = priority;
this_box_volume.geometry.geometry_p_interact = p_interact;
// Currently the coordinates will be in absolute space.
this_box_volume.geometry.center = POS_A_CURRENT_COMP;

this_box_storage.z_depth = zdepth;
this_box_storage.x_width1 = xwidth;
this_box_storage.y_height1 = yheight;

this_box_storage.is_rectangle = 0;
if (xwidth2 < 0 && yheight2 < 0) this_box_storage.is_rectangle = 1;
if (xwidth == xwidth2 && yheight == yheight2) this_box_storage.is_rectangle = 1;

if (xwidth2 < 0) {
    this_box_storage.x_width2 = xwidth;
    xwidth2 = xwidth;
} else this_box_storage.x_width2 = xwidth2;

if (yheight2 < 0) {
    this_box_storage.y_height2 = yheight;
    yheight2 = yheight;
} else this_box_storage.y_height2 = yheight2;


this_box_storage.normal_vectors[0] = coords_set(0,0,1);
this_box_storage.normal_vectors[1] = coords_set(0,0,1);

// for sides with y component = 0
x_component = 2*zdepth/sqrt((xwidth-xwidth2)*(xwidth-xwidth2)+4*zdepth*zdepth);
z_component = (xwidth-xwidth2)/sqrt(4*zdepth*zdepth+(xwidth-xwidth2)*(xwidth-xwidth2));

this_box_storage.normal_vectors[2] = coords_set(x_component,0,z_component);
this_box_storage.normal_vectors[3] = coords_set(-x_component,0,z_component);

// for sides with x component = 0
y_component = 2*zdepth/sqrt((yheight-yheight2)*(yheight-yheight2)+4*zdepth*zdepth);
z_component = (yheight-yheight2)/sqrt(4*zdepth*zdepth+(yheight-yheight2)*(yheight-yheight2));

this_box_storage.normal_vectors[4] = coords_set(0,y_component,z_component);
this_box_storage.normal_vectors[5] = coords_set(0,-y_component,z_component);

this_box_volume.geometry.visualization_on = visualize;

this_box_volume.geometry.geometry_parameters.p_box_storage = &this_box_storage;

// Assign pointers to functions for intersection with the shape, checking if a point is inside the shape
if (this_box_storage.is_rectangle == 1) {
this_box_volume.geometry.intersect_function = &sample_box_intersect_simple;
this_box_volume.geometry.within_function = &r_within_box_simple;
}
else {
this_box_volume.geometry.intersect_function = &sample_box_intersect_advanced;
this_box_volume.geometry.within_function = &r_within_box_advanced;
}

this_box_volume.geometry.shell_points = &box_shell_points;
this_box_volume.geometry.mcdisplay_function = &mcdisplay_box_function;
this_box_volume.geometry.initialize_from_main_function = &initialize_box_geometry_from_main_component;
this_box_volume.geometry.process_rot_allocated = 0;

this_box_volume.geometry.copy_geometry_parameters = &allocate_box_storage_copy;

rot_copy(this_box_volume.geometry.rotation_matrix,ROT_A_CURRENT_COMP); //check how ROT_R_CURRENT_COMP would work
rot_transpose(ROT_A_CURRENT_COMP,this_box_volume.geometry.transpose_rotation_matrix);

// Initialize loggers
this_box_volume.loggers.num_elements = 0;

// packing the information into the global_geometry_element, which is then included in the global_geometry_list.
sprintf(global_geometry_element.name,NAME_CURRENT_COMP);
global_geometry_element.activation_counter = number_of_activations;
global_geometry_element.component_index = INDEX_CURRENT_COMP;
global_geometry_element.Volume = &this_box_volume; // Would be nicer if this m was a pointer, now we have the (small) data two places
add_element_to_geometry_list(&global_geometry_list,global_geometry_element);
}
#line 265400 "MACS_sample_kidney_box.c"
#undef number_of_activations
#undef mask_setting
#undef mask_string
#undef p_interact
#undef focus_r
#undef focus_xh
#undef focus_xw
#undef focus_ah
#undef focus_aw
#undef target_z
#undef target_y
#undef target_x
#undef target_index
#undef visualize
#undef yheight2
#undef xwidth2
#undef zdepth
#undef yheight
#undef xwidth
#undef priority
#undef material_string
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

  /* Initializations for component channel_11_analyzer_2_array_crystal_array_2. */
  SIG_MESSAGE("channel_11_analyzer_2_array_crystal_array_2 (Init)");
#define mccompcurname  channel_11_analyzer_2_array_crystal_array_2
#define mccompcurtype  Union_box
#define mccompcurindex 561
#define loop_index mccchannel_11_analyzer_2_array_crystal_array_2_loop_index
#define this_box_volume mccchannel_11_analyzer_2_array_crystal_array_2_this_box_volume
#define global_geometry_element mccchannel_11_analyzer_2_array_crystal_array_2_global_geometry_element
#define this_box_storage mccchannel_11_analyzer_2_array_crystal_array_2_this_box_storage
#define material_string mccchannel_11_analyzer_2_array_crystal_array_2_material_string
#define priority mccchannel_11_analyzer_2_array_crystal_array_2_priority
#define xwidth mccchannel_11_analyzer_2_array_crystal_array_2_xwidth
#define yheight mccchannel_11_analyzer_2_array_crystal_array_2_yheight
#define zdepth mccchannel_11_analyzer_2_array_crystal_array_2_zdepth
#define xwidth2 mccchannel_11_analyzer_2_array_crystal_array_2_xwidth2
#define yheight2 mccchannel_11_analyzer_2_array_crystal_array_2_yheight2
#define visualize mccchannel_11_analyzer_2_array_crystal_array_2_visualize
#define target_index mccchannel_11_analyzer_2_array_crystal_array_2_target_index
#define target_x mccchannel_11_analyzer_2_array_crystal_array_2_target_x
#define target_y mccchannel_11_analyzer_2_array_crystal_array_2_target_y
#define target_z mccchannel_11_analyzer_2_array_crystal_array_2_target_z
#define focus_aw mccchannel_11_analyzer_2_array_crystal_array_2_focus_aw
#define focus_ah mccchannel_11_analyzer_2_array_crystal_array_2_focus_ah
#define focus_xw mccchannel_11_analyzer_2_array_crystal_array_2_focus_xw
#define focus_xh mccchannel_11_analyzer_2_array_crystal_array_2_focus_xh
#define focus_r mccchannel_11_analyzer_2_array_crystal_array_2_focus_r
#define p_interact mccchannel_11_analyzer_2_array_crystal_array_2_p_interact
#define mask_string mccchannel_11_analyzer_2_array_crystal_array_2_mask_string
#define mask_setting mccchannel_11_analyzer_2_array_crystal_array_2_mask_setting
#define number_of_activations mccchannel_11_analyzer_2_array_crystal_array_2_number_of_activations
#line 224 "Union_box.comp"
{
// Initializes the focusing system for this volume including input sanitation.
focus_initialize(&this_box_volume.geometry, POS_A_COMP_INDEX(INDEX_CURRENT_COMP+target_index), POS_A_CURRENT_COMP, ROT_A_CURRENT_COMP, target_index, target_x, target_y, target_z, focus_aw, focus_ah, focus_xw, focus_xh, focus_r, NAME_CURRENT_COMP);

// Input sanitation for this geometry
if (xwidth <= 0) {
  printf("\nERROR in Union_box named %s, the xwidth is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (yheight <= 0) {
  printf("\nERROR in Union_box named %s, yheight is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (zdepth <= 0) {
  printf("\nERROR in Union_box named %s, zdepth is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (xwidth2 <= 0 && xwidth2 != -1) {
  printf("\nERROR in Union_box named %s, the xwidth2 is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (yheight2 <= 0 && yheight2 != -1) {
  printf("\nERROR in Union_box named %s, yheight2 is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}

// Use sanitation
if (global_material_list.num_elements == 0) {
  printf("\nERROR: Need to define a material using Union_make_material before using a Union geometry component. \n");
  printf("       %s was defined before first use of Union_make_material.\n",NAME_CURRENT_COMP);
  exit(1);
}

this_box_volume.geometry.is_masked_volume = 0;
this_box_volume.geometry.is_exit_volume = 0;
this_box_volume.geometry.is_mask_volume = 0;
// check if the volume is a mask, if it is the material string is irelevant.
if (mask_string && strlen(mask_string) && strcmp(mask_string, "NULL") && strcmp(mask_string, "0")) {
    // A mask volume is used to limit the extend of other volumes, called the masked volumes. These are specified in the mask_string.
    // In order for a ray to enter a masked volume, it needs to be both in the region covered by that volume AND the mask volume.
    // When more than
    this_box_volume.geometry.mask_mode = 1; // Default is mask mode is ALL
    if (mask_setting && strlen(mask_setting) && strcmp(mask_setting, "NULL") && strcmp(mask_setting, "0")) {
        if (strcmp(mask_setting,"ALL") == 0 || strcmp(mask_setting,"All") == 0) this_box_volume.geometry.mask_mode = 1;
        else if (strcmp(mask_setting,"ANY") == 0 || strcmp(mask_setting,"Any") == 0) this_box_volume.geometry.mask_mode = 2;
        else {
            printf("The mask_mode of component %s is set to %s, but must be either ALL or ANY.\n",NAME_CURRENT_COMP,mask_setting);
            exit(1);
        }
    }
    
    for (loop_index=0;loop_index<global_geometry_list.num_elements;loop_index++) {
        // Add mask list
        if (1 == manual_linking_function(global_geometry_list.elements[loop_index].name,mask_string)) {
            add_element_to_int_list(&this_box_volume.geometry.mask_list,global_geometry_list.elements[loop_index].component_index);
            add_element_to_int_list(&global_geometry_list.elements[loop_index].Volume->geometry.masked_by_list,INDEX_CURRENT_COMP);
            global_geometry_list.elements[loop_index].Volume->geometry.is_masked_volume = 1;
            if (this_box_volume.geometry.mask_mode == 2)
                global_geometry_list.elements[loop_index].Volume->geometry.mask_mode = 2;
            if (this_box_volume.geometry.mask_mode == 1) {
                if (global_geometry_list.elements[loop_index].Volume->geometry.is_masked_volume == 1 && global_geometry_list.elements[loop_index].Volume->geometry.mask_mode != 2)
                    // If more than one mask is added to one volume, the ANY mode overwrites the (default) ALL mode.
                    global_geometry_list.elements[loop_index].Volume->geometry.mask_mode = 1;
            }
            
            found_geometries = 1;
        }
    }
    if (found_geometries == 0) {
        printf("The mask_string in geometry: %s did not find any of the specified volumes in the mask_string %s \n",NAME_CURRENT_COMP,mask_string);
        exit(1);
    }
    this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
    this_box_volume.p_physics->is_vacuum = 0; // Makes this volume a vacuum
    this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
    this_box_volume.p_physics->my_a = 0; // Should not be used.
    sprintf(this_box_volume.p_physics->name,"Mask");
    this_box_volume.geometry.is_mask_volume = 1;
    
    
// Read the material input, or if it lacks, use automatic linking.
} else if (material_string && strlen(material_string) && strcmp(material_string, "NULL") && strcmp(material_string, "0")) {
    // A geometry string was given, use it to determine which material
    if (0 == strcmp(material_string,"vacuum") || 0 == strcmp(material_string,"Vacuum")) {
        // One could have a global physics struct for vacuum instead of creating one for each
        this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
        this_box_volume.p_physics->is_vacuum = 1; // Makes this volume a vacuum
        this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
        this_box_volume.p_physics->my_a = 0; // Should not be used.
        sprintf(this_box_volume.p_physics->name,"Vacuum");
    } else if (0 == strcmp(material_string,"exit") || 0 == strcmp(material_string,"Exit")) {
        // One could have a global physics struct for vacuum instead of creating one for each
        this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
        this_box_volume.p_physics->is_vacuum = 1; // Makes this volume a vacuum
        this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
        this_box_volume.p_physics->my_a = 0; // Should not be used.
        this_box_volume.geometry.is_exit_volume = 1;
        sprintf(this_box_volume.p_physics->name,"Exit");
    } else {
        #ifndef MATERIAL_DETECTOR
            printf("Need to define a material before refering to it in a geometry %s.\n",NAME_CURRENT_COMP);
            exit(1);
        #endif
        for (loop_index=0;loop_index<global_material_list.num_elements;loop_index++) {
            if (0 == strcmp(material_string,global_material_list.elements[loop_index].name)) {
                this_box_volume.p_physics = global_material_list.elements[loop_index].physics;
                break;
            }
            if (loop_index == global_material_list.num_elements-1) {
            printf("\n");
            printf("ERROR: The material string \"%s\" in Union geometry \"%s\" did not match a specified material. \n",material_string,NAME_CURRENT_COMP);
            printf("       The materials available at this point (need to be defined before the geometry): \n");
            for (loop_index=0;loop_index<global_material_list.num_elements;loop_index++)
              printf("         %s\n",global_material_list.elements[loop_index].name);
            printf("\n");
            printf("       It is also possible to use one of the defualt materials avaiable: \n");
            printf("           Vacuum (for a Volume without scattering or absorption)\n");
            printf("           Exit (for a Volume where the ray exits the component if it enters)\n");
            printf("           Mask (for a Volume that masks existing volumes specified in the mask_string\n");
            exit(1);
          }
        }
    }
} else {
    // Automatic linking, simply using the last defined material.
    #ifndef MATERIAL_DETECTOR
        printf("Need to define a material before the geometry to use automatic linking %s.\n",NAME_CURRENT_COMP);
        exit(1);
    #endif
    this_box_volume.p_physics = global_material_list.elements[global_material_list.num_elements-1].physics;
}

sprintf(this_box_volume.name,NAME_CURRENT_COMP);
sprintf(this_box_volume.geometry.shape,"box");
this_box_volume.geometry.priority_value = priority;
this_box_volume.geometry.geometry_p_interact = p_interact;
// Currently the coordinates will be in absolute space.
this_box_volume.geometry.center = POS_A_CURRENT_COMP;

this_box_storage.z_depth = zdepth;
this_box_storage.x_width1 = xwidth;
this_box_storage.y_height1 = yheight;

this_box_storage.is_rectangle = 0;
if (xwidth2 < 0 && yheight2 < 0) this_box_storage.is_rectangle = 1;
if (xwidth == xwidth2 && yheight == yheight2) this_box_storage.is_rectangle = 1;

if (xwidth2 < 0) {
    this_box_storage.x_width2 = xwidth;
    xwidth2 = xwidth;
} else this_box_storage.x_width2 = xwidth2;

if (yheight2 < 0) {
    this_box_storage.y_height2 = yheight;
    yheight2 = yheight;
} else this_box_storage.y_height2 = yheight2;


this_box_storage.normal_vectors[0] = coords_set(0,0,1);
this_box_storage.normal_vectors[1] = coords_set(0,0,1);

// for sides with y component = 0
x_component = 2*zdepth/sqrt((xwidth-xwidth2)*(xwidth-xwidth2)+4*zdepth*zdepth);
z_component = (xwidth-xwidth2)/sqrt(4*zdepth*zdepth+(xwidth-xwidth2)*(xwidth-xwidth2));

this_box_storage.normal_vectors[2] = coords_set(x_component,0,z_component);
this_box_storage.normal_vectors[3] = coords_set(-x_component,0,z_component);

// for sides with x component = 0
y_component = 2*zdepth/sqrt((yheight-yheight2)*(yheight-yheight2)+4*zdepth*zdepth);
z_component = (yheight-yheight2)/sqrt(4*zdepth*zdepth+(yheight-yheight2)*(yheight-yheight2));

this_box_storage.normal_vectors[4] = coords_set(0,y_component,z_component);
this_box_storage.normal_vectors[5] = coords_set(0,-y_component,z_component);

this_box_volume.geometry.visualization_on = visualize;

this_box_volume.geometry.geometry_parameters.p_box_storage = &this_box_storage;

// Assign pointers to functions for intersection with the shape, checking if a point is inside the shape
if (this_box_storage.is_rectangle == 1) {
this_box_volume.geometry.intersect_function = &sample_box_intersect_simple;
this_box_volume.geometry.within_function = &r_within_box_simple;
}
else {
this_box_volume.geometry.intersect_function = &sample_box_intersect_advanced;
this_box_volume.geometry.within_function = &r_within_box_advanced;
}

this_box_volume.geometry.shell_points = &box_shell_points;
this_box_volume.geometry.mcdisplay_function = &mcdisplay_box_function;
this_box_volume.geometry.initialize_from_main_function = &initialize_box_geometry_from_main_component;
this_box_volume.geometry.process_rot_allocated = 0;

this_box_volume.geometry.copy_geometry_parameters = &allocate_box_storage_copy;

rot_copy(this_box_volume.geometry.rotation_matrix,ROT_A_CURRENT_COMP); //check how ROT_R_CURRENT_COMP would work
rot_transpose(ROT_A_CURRENT_COMP,this_box_volume.geometry.transpose_rotation_matrix);

// Initialize loggers
this_box_volume.loggers.num_elements = 0;

// packing the information into the global_geometry_element, which is then included in the global_geometry_list.
sprintf(global_geometry_element.name,NAME_CURRENT_COMP);
global_geometry_element.activation_counter = number_of_activations;
global_geometry_element.component_index = INDEX_CURRENT_COMP;
global_geometry_element.Volume = &this_box_volume; // Would be nicer if this m was a pointer, now we have the (small) data two places
add_element_to_geometry_list(&global_geometry_list,global_geometry_element);
}
#line 265670 "MACS_sample_kidney_box.c"
#undef number_of_activations
#undef mask_setting
#undef mask_string
#undef p_interact
#undef focus_r
#undef focus_xh
#undef focus_xw
#undef focus_ah
#undef focus_aw
#undef target_z
#undef target_y
#undef target_x
#undef target_index
#undef visualize
#undef yheight2
#undef xwidth2
#undef zdepth
#undef yheight
#undef xwidth
#undef priority
#undef material_string
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

  /* Initializations for component channel_11_analyzer_2_array_crystal_array_3. */
  SIG_MESSAGE("channel_11_analyzer_2_array_crystal_array_3 (Init)");
#define mccompcurname  channel_11_analyzer_2_array_crystal_array_3
#define mccompcurtype  Union_box
#define mccompcurindex 562
#define loop_index mccchannel_11_analyzer_2_array_crystal_array_3_loop_index
#define this_box_volume mccchannel_11_analyzer_2_array_crystal_array_3_this_box_volume
#define global_geometry_element mccchannel_11_analyzer_2_array_crystal_array_3_global_geometry_element
#define this_box_storage mccchannel_11_analyzer_2_array_crystal_array_3_this_box_storage
#define material_string mccchannel_11_analyzer_2_array_crystal_array_3_material_string
#define priority mccchannel_11_analyzer_2_array_crystal_array_3_priority
#define xwidth mccchannel_11_analyzer_2_array_crystal_array_3_xwidth
#define yheight mccchannel_11_analyzer_2_array_crystal_array_3_yheight
#define zdepth mccchannel_11_analyzer_2_array_crystal_array_3_zdepth
#define xwidth2 mccchannel_11_analyzer_2_array_crystal_array_3_xwidth2
#define yheight2 mccchannel_11_analyzer_2_array_crystal_array_3_yheight2
#define visualize mccchannel_11_analyzer_2_array_crystal_array_3_visualize
#define target_index mccchannel_11_analyzer_2_array_crystal_array_3_target_index
#define target_x mccchannel_11_analyzer_2_array_crystal_array_3_target_x
#define target_y mccchannel_11_analyzer_2_array_crystal_array_3_target_y
#define target_z mccchannel_11_analyzer_2_array_crystal_array_3_target_z
#define focus_aw mccchannel_11_analyzer_2_array_crystal_array_3_focus_aw
#define focus_ah mccchannel_11_analyzer_2_array_crystal_array_3_focus_ah
#define focus_xw mccchannel_11_analyzer_2_array_crystal_array_3_focus_xw
#define focus_xh mccchannel_11_analyzer_2_array_crystal_array_3_focus_xh
#define focus_r mccchannel_11_analyzer_2_array_crystal_array_3_focus_r
#define p_interact mccchannel_11_analyzer_2_array_crystal_array_3_p_interact
#define mask_string mccchannel_11_analyzer_2_array_crystal_array_3_mask_string
#define mask_setting mccchannel_11_analyzer_2_array_crystal_array_3_mask_setting
#define number_of_activations mccchannel_11_analyzer_2_array_crystal_array_3_number_of_activations
#line 224 "Union_box.comp"
{
// Initializes the focusing system for this volume including input sanitation.
focus_initialize(&this_box_volume.geometry, POS_A_COMP_INDEX(INDEX_CURRENT_COMP+target_index), POS_A_CURRENT_COMP, ROT_A_CURRENT_COMP, target_index, target_x, target_y, target_z, focus_aw, focus_ah, focus_xw, focus_xh, focus_r, NAME_CURRENT_COMP);

// Input sanitation for this geometry
if (xwidth <= 0) {
  printf("\nERROR in Union_box named %s, the xwidth is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (yheight <= 0) {
  printf("\nERROR in Union_box named %s, yheight is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (zdepth <= 0) {
  printf("\nERROR in Union_box named %s, zdepth is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (xwidth2 <= 0 && xwidth2 != -1) {
  printf("\nERROR in Union_box named %s, the xwidth2 is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (yheight2 <= 0 && yheight2 != -1) {
  printf("\nERROR in Union_box named %s, yheight2 is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}

// Use sanitation
if (global_material_list.num_elements == 0) {
  printf("\nERROR: Need to define a material using Union_make_material before using a Union geometry component. \n");
  printf("       %s was defined before first use of Union_make_material.\n",NAME_CURRENT_COMP);
  exit(1);
}

this_box_volume.geometry.is_masked_volume = 0;
this_box_volume.geometry.is_exit_volume = 0;
this_box_volume.geometry.is_mask_volume = 0;
// check if the volume is a mask, if it is the material string is irelevant.
if (mask_string && strlen(mask_string) && strcmp(mask_string, "NULL") && strcmp(mask_string, "0")) {
    // A mask volume is used to limit the extend of other volumes, called the masked volumes. These are specified in the mask_string.
    // In order for a ray to enter a masked volume, it needs to be both in the region covered by that volume AND the mask volume.
    // When more than
    this_box_volume.geometry.mask_mode = 1; // Default is mask mode is ALL
    if (mask_setting && strlen(mask_setting) && strcmp(mask_setting, "NULL") && strcmp(mask_setting, "0")) {
        if (strcmp(mask_setting,"ALL") == 0 || strcmp(mask_setting,"All") == 0) this_box_volume.geometry.mask_mode = 1;
        else if (strcmp(mask_setting,"ANY") == 0 || strcmp(mask_setting,"Any") == 0) this_box_volume.geometry.mask_mode = 2;
        else {
            printf("The mask_mode of component %s is set to %s, but must be either ALL or ANY.\n",NAME_CURRENT_COMP,mask_setting);
            exit(1);
        }
    }
    
    for (loop_index=0;loop_index<global_geometry_list.num_elements;loop_index++) {
        // Add mask list
        if (1 == manual_linking_function(global_geometry_list.elements[loop_index].name,mask_string)) {
            add_element_to_int_list(&this_box_volume.geometry.mask_list,global_geometry_list.elements[loop_index].component_index);
            add_element_to_int_list(&global_geometry_list.elements[loop_index].Volume->geometry.masked_by_list,INDEX_CURRENT_COMP);
            global_geometry_list.elements[loop_index].Volume->geometry.is_masked_volume = 1;
            if (this_box_volume.geometry.mask_mode == 2)
                global_geometry_list.elements[loop_index].Volume->geometry.mask_mode = 2;
            if (this_box_volume.geometry.mask_mode == 1) {
                if (global_geometry_list.elements[loop_index].Volume->geometry.is_masked_volume == 1 && global_geometry_list.elements[loop_index].Volume->geometry.mask_mode != 2)
                    // If more than one mask is added to one volume, the ANY mode overwrites the (default) ALL mode.
                    global_geometry_list.elements[loop_index].Volume->geometry.mask_mode = 1;
            }
            
            found_geometries = 1;
        }
    }
    if (found_geometries == 0) {
        printf("The mask_string in geometry: %s did not find any of the specified volumes in the mask_string %s \n",NAME_CURRENT_COMP,mask_string);
        exit(1);
    }
    this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
    this_box_volume.p_physics->is_vacuum = 0; // Makes this volume a vacuum
    this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
    this_box_volume.p_physics->my_a = 0; // Should not be used.
    sprintf(this_box_volume.p_physics->name,"Mask");
    this_box_volume.geometry.is_mask_volume = 1;
    
    
// Read the material input, or if it lacks, use automatic linking.
} else if (material_string && strlen(material_string) && strcmp(material_string, "NULL") && strcmp(material_string, "0")) {
    // A geometry string was given, use it to determine which material
    if (0 == strcmp(material_string,"vacuum") || 0 == strcmp(material_string,"Vacuum")) {
        // One could have a global physics struct for vacuum instead of creating one for each
        this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
        this_box_volume.p_physics->is_vacuum = 1; // Makes this volume a vacuum
        this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
        this_box_volume.p_physics->my_a = 0; // Should not be used.
        sprintf(this_box_volume.p_physics->name,"Vacuum");
    } else if (0 == strcmp(material_string,"exit") || 0 == strcmp(material_string,"Exit")) {
        // One could have a global physics struct for vacuum instead of creating one for each
        this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
        this_box_volume.p_physics->is_vacuum = 1; // Makes this volume a vacuum
        this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
        this_box_volume.p_physics->my_a = 0; // Should not be used.
        this_box_volume.geometry.is_exit_volume = 1;
        sprintf(this_box_volume.p_physics->name,"Exit");
    } else {
        #ifndef MATERIAL_DETECTOR
            printf("Need to define a material before refering to it in a geometry %s.\n",NAME_CURRENT_COMP);
            exit(1);
        #endif
        for (loop_index=0;loop_index<global_material_list.num_elements;loop_index++) {
            if (0 == strcmp(material_string,global_material_list.elements[loop_index].name)) {
                this_box_volume.p_physics = global_material_list.elements[loop_index].physics;
                break;
            }
            if (loop_index == global_material_list.num_elements-1) {
            printf("\n");
            printf("ERROR: The material string \"%s\" in Union geometry \"%s\" did not match a specified material. \n",material_string,NAME_CURRENT_COMP);
            printf("       The materials available at this point (need to be defined before the geometry): \n");
            for (loop_index=0;loop_index<global_material_list.num_elements;loop_index++)
              printf("         %s\n",global_material_list.elements[loop_index].name);
            printf("\n");
            printf("       It is also possible to use one of the defualt materials avaiable: \n");
            printf("           Vacuum (for a Volume without scattering or absorption)\n");
            printf("           Exit (for a Volume where the ray exits the component if it enters)\n");
            printf("           Mask (for a Volume that masks existing volumes specified in the mask_string\n");
            exit(1);
          }
        }
    }
} else {
    // Automatic linking, simply using the last defined material.
    #ifndef MATERIAL_DETECTOR
        printf("Need to define a material before the geometry to use automatic linking %s.\n",NAME_CURRENT_COMP);
        exit(1);
    #endif
    this_box_volume.p_physics = global_material_list.elements[global_material_list.num_elements-1].physics;
}

sprintf(this_box_volume.name,NAME_CURRENT_COMP);
sprintf(this_box_volume.geometry.shape,"box");
this_box_volume.geometry.priority_value = priority;
this_box_volume.geometry.geometry_p_interact = p_interact;
// Currently the coordinates will be in absolute space.
this_box_volume.geometry.center = POS_A_CURRENT_COMP;

this_box_storage.z_depth = zdepth;
this_box_storage.x_width1 = xwidth;
this_box_storage.y_height1 = yheight;

this_box_storage.is_rectangle = 0;
if (xwidth2 < 0 && yheight2 < 0) this_box_storage.is_rectangle = 1;
if (xwidth == xwidth2 && yheight == yheight2) this_box_storage.is_rectangle = 1;

if (xwidth2 < 0) {
    this_box_storage.x_width2 = xwidth;
    xwidth2 = xwidth;
} else this_box_storage.x_width2 = xwidth2;

if (yheight2 < 0) {
    this_box_storage.y_height2 = yheight;
    yheight2 = yheight;
} else this_box_storage.y_height2 = yheight2;


this_box_storage.normal_vectors[0] = coords_set(0,0,1);
this_box_storage.normal_vectors[1] = coords_set(0,0,1);

// for sides with y component = 0
x_component = 2*zdepth/sqrt((xwidth-xwidth2)*(xwidth-xwidth2)+4*zdepth*zdepth);
z_component = (xwidth-xwidth2)/sqrt(4*zdepth*zdepth+(xwidth-xwidth2)*(xwidth-xwidth2));

this_box_storage.normal_vectors[2] = coords_set(x_component,0,z_component);
this_box_storage.normal_vectors[3] = coords_set(-x_component,0,z_component);

// for sides with x component = 0
y_component = 2*zdepth/sqrt((yheight-yheight2)*(yheight-yheight2)+4*zdepth*zdepth);
z_component = (yheight-yheight2)/sqrt(4*zdepth*zdepth+(yheight-yheight2)*(yheight-yheight2));

this_box_storage.normal_vectors[4] = coords_set(0,y_component,z_component);
this_box_storage.normal_vectors[5] = coords_set(0,-y_component,z_component);

this_box_volume.geometry.visualization_on = visualize;

this_box_volume.geometry.geometry_parameters.p_box_storage = &this_box_storage;

// Assign pointers to functions for intersection with the shape, checking if a point is inside the shape
if (this_box_storage.is_rectangle == 1) {
this_box_volume.geometry.intersect_function = &sample_box_intersect_simple;
this_box_volume.geometry.within_function = &r_within_box_simple;
}
else {
this_box_volume.geometry.intersect_function = &sample_box_intersect_advanced;
this_box_volume.geometry.within_function = &r_within_box_advanced;
}

this_box_volume.geometry.shell_points = &box_shell_points;
this_box_volume.geometry.mcdisplay_function = &mcdisplay_box_function;
this_box_volume.geometry.initialize_from_main_function = &initialize_box_geometry_from_main_component;
this_box_volume.geometry.process_rot_allocated = 0;

this_box_volume.geometry.copy_geometry_parameters = &allocate_box_storage_copy;

rot_copy(this_box_volume.geometry.rotation_matrix,ROT_A_CURRENT_COMP); //check how ROT_R_CURRENT_COMP would work
rot_transpose(ROT_A_CURRENT_COMP,this_box_volume.geometry.transpose_rotation_matrix);

// Initialize loggers
this_box_volume.loggers.num_elements = 0;

// packing the information into the global_geometry_element, which is then included in the global_geometry_list.
sprintf(global_geometry_element.name,NAME_CURRENT_COMP);
global_geometry_element.activation_counter = number_of_activations;
global_geometry_element.component_index = INDEX_CURRENT_COMP;
global_geometry_element.Volume = &this_box_volume; // Would be nicer if this m was a pointer, now we have the (small) data two places
add_element_to_geometry_list(&global_geometry_list,global_geometry_element);
}
#line 265940 "MACS_sample_kidney_box.c"
#undef number_of_activations
#undef mask_setting
#undef mask_string
#undef p_interact
#undef focus_r
#undef focus_xh
#undef focus_xw
#undef focus_ah
#undef focus_aw
#undef target_z
#undef target_y
#undef target_x
#undef target_index
#undef visualize
#undef yheight2
#undef xwidth2
#undef zdepth
#undef yheight
#undef xwidth
#undef priority
#undef material_string
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

  /* Initializations for component channel_11_analyzer_2_array_crystal_array_4. */
  SIG_MESSAGE("channel_11_analyzer_2_array_crystal_array_4 (Init)");
#define mccompcurname  channel_11_analyzer_2_array_crystal_array_4
#define mccompcurtype  Union_box
#define mccompcurindex 563
#define loop_index mccchannel_11_analyzer_2_array_crystal_array_4_loop_index
#define this_box_volume mccchannel_11_analyzer_2_array_crystal_array_4_this_box_volume
#define global_geometry_element mccchannel_11_analyzer_2_array_crystal_array_4_global_geometry_element
#define this_box_storage mccchannel_11_analyzer_2_array_crystal_array_4_this_box_storage
#define material_string mccchannel_11_analyzer_2_array_crystal_array_4_material_string
#define priority mccchannel_11_analyzer_2_array_crystal_array_4_priority
#define xwidth mccchannel_11_analyzer_2_array_crystal_array_4_xwidth
#define yheight mccchannel_11_analyzer_2_array_crystal_array_4_yheight
#define zdepth mccchannel_11_analyzer_2_array_crystal_array_4_zdepth
#define xwidth2 mccchannel_11_analyzer_2_array_crystal_array_4_xwidth2
#define yheight2 mccchannel_11_analyzer_2_array_crystal_array_4_yheight2
#define visualize mccchannel_11_analyzer_2_array_crystal_array_4_visualize
#define target_index mccchannel_11_analyzer_2_array_crystal_array_4_target_index
#define target_x mccchannel_11_analyzer_2_array_crystal_array_4_target_x
#define target_y mccchannel_11_analyzer_2_array_crystal_array_4_target_y
#define target_z mccchannel_11_analyzer_2_array_crystal_array_4_target_z
#define focus_aw mccchannel_11_analyzer_2_array_crystal_array_4_focus_aw
#define focus_ah mccchannel_11_analyzer_2_array_crystal_array_4_focus_ah
#define focus_xw mccchannel_11_analyzer_2_array_crystal_array_4_focus_xw
#define focus_xh mccchannel_11_analyzer_2_array_crystal_array_4_focus_xh
#define focus_r mccchannel_11_analyzer_2_array_crystal_array_4_focus_r
#define p_interact mccchannel_11_analyzer_2_array_crystal_array_4_p_interact
#define mask_string mccchannel_11_analyzer_2_array_crystal_array_4_mask_string
#define mask_setting mccchannel_11_analyzer_2_array_crystal_array_4_mask_setting
#define number_of_activations mccchannel_11_analyzer_2_array_crystal_array_4_number_of_activations
#line 224 "Union_box.comp"
{
// Initializes the focusing system for this volume including input sanitation.
focus_initialize(&this_box_volume.geometry, POS_A_COMP_INDEX(INDEX_CURRENT_COMP+target_index), POS_A_CURRENT_COMP, ROT_A_CURRENT_COMP, target_index, target_x, target_y, target_z, focus_aw, focus_ah, focus_xw, focus_xh, focus_r, NAME_CURRENT_COMP);

// Input sanitation for this geometry
if (xwidth <= 0) {
  printf("\nERROR in Union_box named %s, the xwidth is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (yheight <= 0) {
  printf("\nERROR in Union_box named %s, yheight is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (zdepth <= 0) {
  printf("\nERROR in Union_box named %s, zdepth is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (xwidth2 <= 0 && xwidth2 != -1) {
  printf("\nERROR in Union_box named %s, the xwidth2 is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (yheight2 <= 0 && yheight2 != -1) {
  printf("\nERROR in Union_box named %s, yheight2 is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}

// Use sanitation
if (global_material_list.num_elements == 0) {
  printf("\nERROR: Need to define a material using Union_make_material before using a Union geometry component. \n");
  printf("       %s was defined before first use of Union_make_material.\n",NAME_CURRENT_COMP);
  exit(1);
}

this_box_volume.geometry.is_masked_volume = 0;
this_box_volume.geometry.is_exit_volume = 0;
this_box_volume.geometry.is_mask_volume = 0;
// check if the volume is a mask, if it is the material string is irelevant.
if (mask_string && strlen(mask_string) && strcmp(mask_string, "NULL") && strcmp(mask_string, "0")) {
    // A mask volume is used to limit the extend of other volumes, called the masked volumes. These are specified in the mask_string.
    // In order for a ray to enter a masked volume, it needs to be both in the region covered by that volume AND the mask volume.
    // When more than
    this_box_volume.geometry.mask_mode = 1; // Default is mask mode is ALL
    if (mask_setting && strlen(mask_setting) && strcmp(mask_setting, "NULL") && strcmp(mask_setting, "0")) {
        if (strcmp(mask_setting,"ALL") == 0 || strcmp(mask_setting,"All") == 0) this_box_volume.geometry.mask_mode = 1;
        else if (strcmp(mask_setting,"ANY") == 0 || strcmp(mask_setting,"Any") == 0) this_box_volume.geometry.mask_mode = 2;
        else {
            printf("The mask_mode of component %s is set to %s, but must be either ALL or ANY.\n",NAME_CURRENT_COMP,mask_setting);
            exit(1);
        }
    }
    
    for (loop_index=0;loop_index<global_geometry_list.num_elements;loop_index++) {
        // Add mask list
        if (1 == manual_linking_function(global_geometry_list.elements[loop_index].name,mask_string)) {
            add_element_to_int_list(&this_box_volume.geometry.mask_list,global_geometry_list.elements[loop_index].component_index);
            add_element_to_int_list(&global_geometry_list.elements[loop_index].Volume->geometry.masked_by_list,INDEX_CURRENT_COMP);
            global_geometry_list.elements[loop_index].Volume->geometry.is_masked_volume = 1;
            if (this_box_volume.geometry.mask_mode == 2)
                global_geometry_list.elements[loop_index].Volume->geometry.mask_mode = 2;
            if (this_box_volume.geometry.mask_mode == 1) {
                if (global_geometry_list.elements[loop_index].Volume->geometry.is_masked_volume == 1 && global_geometry_list.elements[loop_index].Volume->geometry.mask_mode != 2)
                    // If more than one mask is added to one volume, the ANY mode overwrites the (default) ALL mode.
                    global_geometry_list.elements[loop_index].Volume->geometry.mask_mode = 1;
            }
            
            found_geometries = 1;
        }
    }
    if (found_geometries == 0) {
        printf("The mask_string in geometry: %s did not find any of the specified volumes in the mask_string %s \n",NAME_CURRENT_COMP,mask_string);
        exit(1);
    }
    this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
    this_box_volume.p_physics->is_vacuum = 0; // Makes this volume a vacuum
    this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
    this_box_volume.p_physics->my_a = 0; // Should not be used.
    sprintf(this_box_volume.p_physics->name,"Mask");
    this_box_volume.geometry.is_mask_volume = 1;
    
    
// Read the material input, or if it lacks, use automatic linking.
} else if (material_string && strlen(material_string) && strcmp(material_string, "NULL") && strcmp(material_string, "0")) {
    // A geometry string was given, use it to determine which material
    if (0 == strcmp(material_string,"vacuum") || 0 == strcmp(material_string,"Vacuum")) {
        // One could have a global physics struct for vacuum instead of creating one for each
        this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
        this_box_volume.p_physics->is_vacuum = 1; // Makes this volume a vacuum
        this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
        this_box_volume.p_physics->my_a = 0; // Should not be used.
        sprintf(this_box_volume.p_physics->name,"Vacuum");
    } else if (0 == strcmp(material_string,"exit") || 0 == strcmp(material_string,"Exit")) {
        // One could have a global physics struct for vacuum instead of creating one for each
        this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
        this_box_volume.p_physics->is_vacuum = 1; // Makes this volume a vacuum
        this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
        this_box_volume.p_physics->my_a = 0; // Should not be used.
        this_box_volume.geometry.is_exit_volume = 1;
        sprintf(this_box_volume.p_physics->name,"Exit");
    } else {
        #ifndef MATERIAL_DETECTOR
            printf("Need to define a material before refering to it in a geometry %s.\n",NAME_CURRENT_COMP);
            exit(1);
        #endif
        for (loop_index=0;loop_index<global_material_list.num_elements;loop_index++) {
            if (0 == strcmp(material_string,global_material_list.elements[loop_index].name)) {
                this_box_volume.p_physics = global_material_list.elements[loop_index].physics;
                break;
            }
            if (loop_index == global_material_list.num_elements-1) {
            printf("\n");
            printf("ERROR: The material string \"%s\" in Union geometry \"%s\" did not match a specified material. \n",material_string,NAME_CURRENT_COMP);
            printf("       The materials available at this point (need to be defined before the geometry): \n");
            for (loop_index=0;loop_index<global_material_list.num_elements;loop_index++)
              printf("         %s\n",global_material_list.elements[loop_index].name);
            printf("\n");
            printf("       It is also possible to use one of the defualt materials avaiable: \n");
            printf("           Vacuum (for a Volume without scattering or absorption)\n");
            printf("           Exit (for a Volume where the ray exits the component if it enters)\n");
            printf("           Mask (for a Volume that masks existing volumes specified in the mask_string\n");
            exit(1);
          }
        }
    }
} else {
    // Automatic linking, simply using the last defined material.
    #ifndef MATERIAL_DETECTOR
        printf("Need to define a material before the geometry to use automatic linking %s.\n",NAME_CURRENT_COMP);
        exit(1);
    #endif
    this_box_volume.p_physics = global_material_list.elements[global_material_list.num_elements-1].physics;
}

sprintf(this_box_volume.name,NAME_CURRENT_COMP);
sprintf(this_box_volume.geometry.shape,"box");
this_box_volume.geometry.priority_value = priority;
this_box_volume.geometry.geometry_p_interact = p_interact;
// Currently the coordinates will be in absolute space.
this_box_volume.geometry.center = POS_A_CURRENT_COMP;

this_box_storage.z_depth = zdepth;
this_box_storage.x_width1 = xwidth;
this_box_storage.y_height1 = yheight;

this_box_storage.is_rectangle = 0;
if (xwidth2 < 0 && yheight2 < 0) this_box_storage.is_rectangle = 1;
if (xwidth == xwidth2 && yheight == yheight2) this_box_storage.is_rectangle = 1;

if (xwidth2 < 0) {
    this_box_storage.x_width2 = xwidth;
    xwidth2 = xwidth;
} else this_box_storage.x_width2 = xwidth2;

if (yheight2 < 0) {
    this_box_storage.y_height2 = yheight;
    yheight2 = yheight;
} else this_box_storage.y_height2 = yheight2;


this_box_storage.normal_vectors[0] = coords_set(0,0,1);
this_box_storage.normal_vectors[1] = coords_set(0,0,1);

// for sides with y component = 0
x_component = 2*zdepth/sqrt((xwidth-xwidth2)*(xwidth-xwidth2)+4*zdepth*zdepth);
z_component = (xwidth-xwidth2)/sqrt(4*zdepth*zdepth+(xwidth-xwidth2)*(xwidth-xwidth2));

this_box_storage.normal_vectors[2] = coords_set(x_component,0,z_component);
this_box_storage.normal_vectors[3] = coords_set(-x_component,0,z_component);

// for sides with x component = 0
y_component = 2*zdepth/sqrt((yheight-yheight2)*(yheight-yheight2)+4*zdepth*zdepth);
z_component = (yheight-yheight2)/sqrt(4*zdepth*zdepth+(yheight-yheight2)*(yheight-yheight2));

this_box_storage.normal_vectors[4] = coords_set(0,y_component,z_component);
this_box_storage.normal_vectors[5] = coords_set(0,-y_component,z_component);

this_box_volume.geometry.visualization_on = visualize;

this_box_volume.geometry.geometry_parameters.p_box_storage = &this_box_storage;

// Assign pointers to functions for intersection with the shape, checking if a point is inside the shape
if (this_box_storage.is_rectangle == 1) {
this_box_volume.geometry.intersect_function = &sample_box_intersect_simple;
this_box_volume.geometry.within_function = &r_within_box_simple;
}
else {
this_box_volume.geometry.intersect_function = &sample_box_intersect_advanced;
this_box_volume.geometry.within_function = &r_within_box_advanced;
}

this_box_volume.geometry.shell_points = &box_shell_points;
this_box_volume.geometry.mcdisplay_function = &mcdisplay_box_function;
this_box_volume.geometry.initialize_from_main_function = &initialize_box_geometry_from_main_component;
this_box_volume.geometry.process_rot_allocated = 0;

this_box_volume.geometry.copy_geometry_parameters = &allocate_box_storage_copy;

rot_copy(this_box_volume.geometry.rotation_matrix,ROT_A_CURRENT_COMP); //check how ROT_R_CURRENT_COMP would work
rot_transpose(ROT_A_CURRENT_COMP,this_box_volume.geometry.transpose_rotation_matrix);

// Initialize loggers
this_box_volume.loggers.num_elements = 0;

// packing the information into the global_geometry_element, which is then included in the global_geometry_list.
sprintf(global_geometry_element.name,NAME_CURRENT_COMP);
global_geometry_element.activation_counter = number_of_activations;
global_geometry_element.component_index = INDEX_CURRENT_COMP;
global_geometry_element.Volume = &this_box_volume; // Would be nicer if this m was a pointer, now we have the (small) data two places
add_element_to_geometry_list(&global_geometry_list,global_geometry_element);
}
#line 266210 "MACS_sample_kidney_box.c"
#undef number_of_activations
#undef mask_setting
#undef mask_string
#undef p_interact
#undef focus_r
#undef focus_xh
#undef focus_xw
#undef focus_ah
#undef focus_aw
#undef target_z
#undef target_y
#undef target_x
#undef target_index
#undef visualize
#undef yheight2
#undef xwidth2
#undef zdepth
#undef yheight
#undef xwidth
#undef priority
#undef material_string
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

  /* Initializations for component channel_11_analyzer_2_array_crystal_array_5. */
  SIG_MESSAGE("channel_11_analyzer_2_array_crystal_array_5 (Init)");
#define mccompcurname  channel_11_analyzer_2_array_crystal_array_5
#define mccompcurtype  Union_box
#define mccompcurindex 564
#define loop_index mccchannel_11_analyzer_2_array_crystal_array_5_loop_index
#define this_box_volume mccchannel_11_analyzer_2_array_crystal_array_5_this_box_volume
#define global_geometry_element mccchannel_11_analyzer_2_array_crystal_array_5_global_geometry_element
#define this_box_storage mccchannel_11_analyzer_2_array_crystal_array_5_this_box_storage
#define material_string mccchannel_11_analyzer_2_array_crystal_array_5_material_string
#define priority mccchannel_11_analyzer_2_array_crystal_array_5_priority
#define xwidth mccchannel_11_analyzer_2_array_crystal_array_5_xwidth
#define yheight mccchannel_11_analyzer_2_array_crystal_array_5_yheight
#define zdepth mccchannel_11_analyzer_2_array_crystal_array_5_zdepth
#define xwidth2 mccchannel_11_analyzer_2_array_crystal_array_5_xwidth2
#define yheight2 mccchannel_11_analyzer_2_array_crystal_array_5_yheight2
#define visualize mccchannel_11_analyzer_2_array_crystal_array_5_visualize
#define target_index mccchannel_11_analyzer_2_array_crystal_array_5_target_index
#define target_x mccchannel_11_analyzer_2_array_crystal_array_5_target_x
#define target_y mccchannel_11_analyzer_2_array_crystal_array_5_target_y
#define target_z mccchannel_11_analyzer_2_array_crystal_array_5_target_z
#define focus_aw mccchannel_11_analyzer_2_array_crystal_array_5_focus_aw
#define focus_ah mccchannel_11_analyzer_2_array_crystal_array_5_focus_ah
#define focus_xw mccchannel_11_analyzer_2_array_crystal_array_5_focus_xw
#define focus_xh mccchannel_11_analyzer_2_array_crystal_array_5_focus_xh
#define focus_r mccchannel_11_analyzer_2_array_crystal_array_5_focus_r
#define p_interact mccchannel_11_analyzer_2_array_crystal_array_5_p_interact
#define mask_string mccchannel_11_analyzer_2_array_crystal_array_5_mask_string
#define mask_setting mccchannel_11_analyzer_2_array_crystal_array_5_mask_setting
#define number_of_activations mccchannel_11_analyzer_2_array_crystal_array_5_number_of_activations
#line 224 "Union_box.comp"
{
// Initializes the focusing system for this volume including input sanitation.
focus_initialize(&this_box_volume.geometry, POS_A_COMP_INDEX(INDEX_CURRENT_COMP+target_index), POS_A_CURRENT_COMP, ROT_A_CURRENT_COMP, target_index, target_x, target_y, target_z, focus_aw, focus_ah, focus_xw, focus_xh, focus_r, NAME_CURRENT_COMP);

// Input sanitation for this geometry
if (xwidth <= 0) {
  printf("\nERROR in Union_box named %s, the xwidth is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (yheight <= 0) {
  printf("\nERROR in Union_box named %s, yheight is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (zdepth <= 0) {
  printf("\nERROR in Union_box named %s, zdepth is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (xwidth2 <= 0 && xwidth2 != -1) {
  printf("\nERROR in Union_box named %s, the xwidth2 is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (yheight2 <= 0 && yheight2 != -1) {
  printf("\nERROR in Union_box named %s, yheight2 is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}

// Use sanitation
if (global_material_list.num_elements == 0) {
  printf("\nERROR: Need to define a material using Union_make_material before using a Union geometry component. \n");
  printf("       %s was defined before first use of Union_make_material.\n",NAME_CURRENT_COMP);
  exit(1);
}

this_box_volume.geometry.is_masked_volume = 0;
this_box_volume.geometry.is_exit_volume = 0;
this_box_volume.geometry.is_mask_volume = 0;
// check if the volume is a mask, if it is the material string is irelevant.
if (mask_string && strlen(mask_string) && strcmp(mask_string, "NULL") && strcmp(mask_string, "0")) {
    // A mask volume is used to limit the extend of other volumes, called the masked volumes. These are specified in the mask_string.
    // In order for a ray to enter a masked volume, it needs to be both in the region covered by that volume AND the mask volume.
    // When more than
    this_box_volume.geometry.mask_mode = 1; // Default is mask mode is ALL
    if (mask_setting && strlen(mask_setting) && strcmp(mask_setting, "NULL") && strcmp(mask_setting, "0")) {
        if (strcmp(mask_setting,"ALL") == 0 || strcmp(mask_setting,"All") == 0) this_box_volume.geometry.mask_mode = 1;
        else if (strcmp(mask_setting,"ANY") == 0 || strcmp(mask_setting,"Any") == 0) this_box_volume.geometry.mask_mode = 2;
        else {
            printf("The mask_mode of component %s is set to %s, but must be either ALL or ANY.\n",NAME_CURRENT_COMP,mask_setting);
            exit(1);
        }
    }
    
    for (loop_index=0;loop_index<global_geometry_list.num_elements;loop_index++) {
        // Add mask list
        if (1 == manual_linking_function(global_geometry_list.elements[loop_index].name,mask_string)) {
            add_element_to_int_list(&this_box_volume.geometry.mask_list,global_geometry_list.elements[loop_index].component_index);
            add_element_to_int_list(&global_geometry_list.elements[loop_index].Volume->geometry.masked_by_list,INDEX_CURRENT_COMP);
            global_geometry_list.elements[loop_index].Volume->geometry.is_masked_volume = 1;
            if (this_box_volume.geometry.mask_mode == 2)
                global_geometry_list.elements[loop_index].Volume->geometry.mask_mode = 2;
            if (this_box_volume.geometry.mask_mode == 1) {
                if (global_geometry_list.elements[loop_index].Volume->geometry.is_masked_volume == 1 && global_geometry_list.elements[loop_index].Volume->geometry.mask_mode != 2)
                    // If more than one mask is added to one volume, the ANY mode overwrites the (default) ALL mode.
                    global_geometry_list.elements[loop_index].Volume->geometry.mask_mode = 1;
            }
            
            found_geometries = 1;
        }
    }
    if (found_geometries == 0) {
        printf("The mask_string in geometry: %s did not find any of the specified volumes in the mask_string %s \n",NAME_CURRENT_COMP,mask_string);
        exit(1);
    }
    this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
    this_box_volume.p_physics->is_vacuum = 0; // Makes this volume a vacuum
    this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
    this_box_volume.p_physics->my_a = 0; // Should not be used.
    sprintf(this_box_volume.p_physics->name,"Mask");
    this_box_volume.geometry.is_mask_volume = 1;
    
    
// Read the material input, or if it lacks, use automatic linking.
} else if (material_string && strlen(material_string) && strcmp(material_string, "NULL") && strcmp(material_string, "0")) {
    // A geometry string was given, use it to determine which material
    if (0 == strcmp(material_string,"vacuum") || 0 == strcmp(material_string,"Vacuum")) {
        // One could have a global physics struct for vacuum instead of creating one for each
        this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
        this_box_volume.p_physics->is_vacuum = 1; // Makes this volume a vacuum
        this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
        this_box_volume.p_physics->my_a = 0; // Should not be used.
        sprintf(this_box_volume.p_physics->name,"Vacuum");
    } else if (0 == strcmp(material_string,"exit") || 0 == strcmp(material_string,"Exit")) {
        // One could have a global physics struct for vacuum instead of creating one for each
        this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
        this_box_volume.p_physics->is_vacuum = 1; // Makes this volume a vacuum
        this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
        this_box_volume.p_physics->my_a = 0; // Should not be used.
        this_box_volume.geometry.is_exit_volume = 1;
        sprintf(this_box_volume.p_physics->name,"Exit");
    } else {
        #ifndef MATERIAL_DETECTOR
            printf("Need to define a material before refering to it in a geometry %s.\n",NAME_CURRENT_COMP);
            exit(1);
        #endif
        for (loop_index=0;loop_index<global_material_list.num_elements;loop_index++) {
            if (0 == strcmp(material_string,global_material_list.elements[loop_index].name)) {
                this_box_volume.p_physics = global_material_list.elements[loop_index].physics;
                break;
            }
            if (loop_index == global_material_list.num_elements-1) {
            printf("\n");
            printf("ERROR: The material string \"%s\" in Union geometry \"%s\" did not match a specified material. \n",material_string,NAME_CURRENT_COMP);
            printf("       The materials available at this point (need to be defined before the geometry): \n");
            for (loop_index=0;loop_index<global_material_list.num_elements;loop_index++)
              printf("         %s\n",global_material_list.elements[loop_index].name);
            printf("\n");
            printf("       It is also possible to use one of the defualt materials avaiable: \n");
            printf("           Vacuum (for a Volume without scattering or absorption)\n");
            printf("           Exit (for a Volume where the ray exits the component if it enters)\n");
            printf("           Mask (for a Volume that masks existing volumes specified in the mask_string\n");
            exit(1);
          }
        }
    }
} else {
    // Automatic linking, simply using the last defined material.
    #ifndef MATERIAL_DETECTOR
        printf("Need to define a material before the geometry to use automatic linking %s.\n",NAME_CURRENT_COMP);
        exit(1);
    #endif
    this_box_volume.p_physics = global_material_list.elements[global_material_list.num_elements-1].physics;
}

sprintf(this_box_volume.name,NAME_CURRENT_COMP);
sprintf(this_box_volume.geometry.shape,"box");
this_box_volume.geometry.priority_value = priority;
this_box_volume.geometry.geometry_p_interact = p_interact;
// Currently the coordinates will be in absolute space.
this_box_volume.geometry.center = POS_A_CURRENT_COMP;

this_box_storage.z_depth = zdepth;
this_box_storage.x_width1 = xwidth;
this_box_storage.y_height1 = yheight;

this_box_storage.is_rectangle = 0;
if (xwidth2 < 0 && yheight2 < 0) this_box_storage.is_rectangle = 1;
if (xwidth == xwidth2 && yheight == yheight2) this_box_storage.is_rectangle = 1;

if (xwidth2 < 0) {
    this_box_storage.x_width2 = xwidth;
    xwidth2 = xwidth;
} else this_box_storage.x_width2 = xwidth2;

if (yheight2 < 0) {
    this_box_storage.y_height2 = yheight;
    yheight2 = yheight;
} else this_box_storage.y_height2 = yheight2;


this_box_storage.normal_vectors[0] = coords_set(0,0,1);
this_box_storage.normal_vectors[1] = coords_set(0,0,1);

// for sides with y component = 0
x_component = 2*zdepth/sqrt((xwidth-xwidth2)*(xwidth-xwidth2)+4*zdepth*zdepth);
z_component = (xwidth-xwidth2)/sqrt(4*zdepth*zdepth+(xwidth-xwidth2)*(xwidth-xwidth2));

this_box_storage.normal_vectors[2] = coords_set(x_component,0,z_component);
this_box_storage.normal_vectors[3] = coords_set(-x_component,0,z_component);

// for sides with x component = 0
y_component = 2*zdepth/sqrt((yheight-yheight2)*(yheight-yheight2)+4*zdepth*zdepth);
z_component = (yheight-yheight2)/sqrt(4*zdepth*zdepth+(yheight-yheight2)*(yheight-yheight2));

this_box_storage.normal_vectors[4] = coords_set(0,y_component,z_component);
this_box_storage.normal_vectors[5] = coords_set(0,-y_component,z_component);

this_box_volume.geometry.visualization_on = visualize;

this_box_volume.geometry.geometry_parameters.p_box_storage = &this_box_storage;

// Assign pointers to functions for intersection with the shape, checking if a point is inside the shape
if (this_box_storage.is_rectangle == 1) {
this_box_volume.geometry.intersect_function = &sample_box_intersect_simple;
this_box_volume.geometry.within_function = &r_within_box_simple;
}
else {
this_box_volume.geometry.intersect_function = &sample_box_intersect_advanced;
this_box_volume.geometry.within_function = &r_within_box_advanced;
}

this_box_volume.geometry.shell_points = &box_shell_points;
this_box_volume.geometry.mcdisplay_function = &mcdisplay_box_function;
this_box_volume.geometry.initialize_from_main_function = &initialize_box_geometry_from_main_component;
this_box_volume.geometry.process_rot_allocated = 0;

this_box_volume.geometry.copy_geometry_parameters = &allocate_box_storage_copy;

rot_copy(this_box_volume.geometry.rotation_matrix,ROT_A_CURRENT_COMP); //check how ROT_R_CURRENT_COMP would work
rot_transpose(ROT_A_CURRENT_COMP,this_box_volume.geometry.transpose_rotation_matrix);

// Initialize loggers
this_box_volume.loggers.num_elements = 0;

// packing the information into the global_geometry_element, which is then included in the global_geometry_list.
sprintf(global_geometry_element.name,NAME_CURRENT_COMP);
global_geometry_element.activation_counter = number_of_activations;
global_geometry_element.component_index = INDEX_CURRENT_COMP;
global_geometry_element.Volume = &this_box_volume; // Would be nicer if this m was a pointer, now we have the (small) data two places
add_element_to_geometry_list(&global_geometry_list,global_geometry_element);
}
#line 266480 "MACS_sample_kidney_box.c"
#undef number_of_activations
#undef mask_setting
#undef mask_string
#undef p_interact
#undef focus_r
#undef focus_xh
#undef focus_xw
#undef focus_ah
#undef focus_aw
#undef target_z
#undef target_y
#undef target_x
#undef target_index
#undef visualize
#undef yheight2
#undef xwidth2
#undef zdepth
#undef yheight
#undef xwidth
#undef priority
#undef material_string
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

  /* Initializations for component channel_11_analyzer_2_array_crystal_array_6. */
  SIG_MESSAGE("channel_11_analyzer_2_array_crystal_array_6 (Init)");
#define mccompcurname  channel_11_analyzer_2_array_crystal_array_6
#define mccompcurtype  Union_box
#define mccompcurindex 565
#define loop_index mccchannel_11_analyzer_2_array_crystal_array_6_loop_index
#define this_box_volume mccchannel_11_analyzer_2_array_crystal_array_6_this_box_volume
#define global_geometry_element mccchannel_11_analyzer_2_array_crystal_array_6_global_geometry_element
#define this_box_storage mccchannel_11_analyzer_2_array_crystal_array_6_this_box_storage
#define material_string mccchannel_11_analyzer_2_array_crystal_array_6_material_string
#define priority mccchannel_11_analyzer_2_array_crystal_array_6_priority
#define xwidth mccchannel_11_analyzer_2_array_crystal_array_6_xwidth
#define yheight mccchannel_11_analyzer_2_array_crystal_array_6_yheight
#define zdepth mccchannel_11_analyzer_2_array_crystal_array_6_zdepth
#define xwidth2 mccchannel_11_analyzer_2_array_crystal_array_6_xwidth2
#define yheight2 mccchannel_11_analyzer_2_array_crystal_array_6_yheight2
#define visualize mccchannel_11_analyzer_2_array_crystal_array_6_visualize
#define target_index mccchannel_11_analyzer_2_array_crystal_array_6_target_index
#define target_x mccchannel_11_analyzer_2_array_crystal_array_6_target_x
#define target_y mccchannel_11_analyzer_2_array_crystal_array_6_target_y
#define target_z mccchannel_11_analyzer_2_array_crystal_array_6_target_z
#define focus_aw mccchannel_11_analyzer_2_array_crystal_array_6_focus_aw
#define focus_ah mccchannel_11_analyzer_2_array_crystal_array_6_focus_ah
#define focus_xw mccchannel_11_analyzer_2_array_crystal_array_6_focus_xw
#define focus_xh mccchannel_11_analyzer_2_array_crystal_array_6_focus_xh
#define focus_r mccchannel_11_analyzer_2_array_crystal_array_6_focus_r
#define p_interact mccchannel_11_analyzer_2_array_crystal_array_6_p_interact
#define mask_string mccchannel_11_analyzer_2_array_crystal_array_6_mask_string
#define mask_setting mccchannel_11_analyzer_2_array_crystal_array_6_mask_setting
#define number_of_activations mccchannel_11_analyzer_2_array_crystal_array_6_number_of_activations
#line 224 "Union_box.comp"
{
// Initializes the focusing system for this volume including input sanitation.
focus_initialize(&this_box_volume.geometry, POS_A_COMP_INDEX(INDEX_CURRENT_COMP+target_index), POS_A_CURRENT_COMP, ROT_A_CURRENT_COMP, target_index, target_x, target_y, target_z, focus_aw, focus_ah, focus_xw, focus_xh, focus_r, NAME_CURRENT_COMP);

// Input sanitation for this geometry
if (xwidth <= 0) {
  printf("\nERROR in Union_box named %s, the xwidth is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (yheight <= 0) {
  printf("\nERROR in Union_box named %s, yheight is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (zdepth <= 0) {
  printf("\nERROR in Union_box named %s, zdepth is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (xwidth2 <= 0 && xwidth2 != -1) {
  printf("\nERROR in Union_box named %s, the xwidth2 is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (yheight2 <= 0 && yheight2 != -1) {
  printf("\nERROR in Union_box named %s, yheight2 is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}

// Use sanitation
if (global_material_list.num_elements == 0) {
  printf("\nERROR: Need to define a material using Union_make_material before using a Union geometry component. \n");
  printf("       %s was defined before first use of Union_make_material.\n",NAME_CURRENT_COMP);
  exit(1);
}

this_box_volume.geometry.is_masked_volume = 0;
this_box_volume.geometry.is_exit_volume = 0;
this_box_volume.geometry.is_mask_volume = 0;
// check if the volume is a mask, if it is the material string is irelevant.
if (mask_string && strlen(mask_string) && strcmp(mask_string, "NULL") && strcmp(mask_string, "0")) {
    // A mask volume is used to limit the extend of other volumes, called the masked volumes. These are specified in the mask_string.
    // In order for a ray to enter a masked volume, it needs to be both in the region covered by that volume AND the mask volume.
    // When more than
    this_box_volume.geometry.mask_mode = 1; // Default is mask mode is ALL
    if (mask_setting && strlen(mask_setting) && strcmp(mask_setting, "NULL") && strcmp(mask_setting, "0")) {
        if (strcmp(mask_setting,"ALL") == 0 || strcmp(mask_setting,"All") == 0) this_box_volume.geometry.mask_mode = 1;
        else if (strcmp(mask_setting,"ANY") == 0 || strcmp(mask_setting,"Any") == 0) this_box_volume.geometry.mask_mode = 2;
        else {
            printf("The mask_mode of component %s is set to %s, but must be either ALL or ANY.\n",NAME_CURRENT_COMP,mask_setting);
            exit(1);
        }
    }
    
    for (loop_index=0;loop_index<global_geometry_list.num_elements;loop_index++) {
        // Add mask list
        if (1 == manual_linking_function(global_geometry_list.elements[loop_index].name,mask_string)) {
            add_element_to_int_list(&this_box_volume.geometry.mask_list,global_geometry_list.elements[loop_index].component_index);
            add_element_to_int_list(&global_geometry_list.elements[loop_index].Volume->geometry.masked_by_list,INDEX_CURRENT_COMP);
            global_geometry_list.elements[loop_index].Volume->geometry.is_masked_volume = 1;
            if (this_box_volume.geometry.mask_mode == 2)
                global_geometry_list.elements[loop_index].Volume->geometry.mask_mode = 2;
            if (this_box_volume.geometry.mask_mode == 1) {
                if (global_geometry_list.elements[loop_index].Volume->geometry.is_masked_volume == 1 && global_geometry_list.elements[loop_index].Volume->geometry.mask_mode != 2)
                    // If more than one mask is added to one volume, the ANY mode overwrites the (default) ALL mode.
                    global_geometry_list.elements[loop_index].Volume->geometry.mask_mode = 1;
            }
            
            found_geometries = 1;
        }
    }
    if (found_geometries == 0) {
        printf("The mask_string in geometry: %s did not find any of the specified volumes in the mask_string %s \n",NAME_CURRENT_COMP,mask_string);
        exit(1);
    }
    this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
    this_box_volume.p_physics->is_vacuum = 0; // Makes this volume a vacuum
    this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
    this_box_volume.p_physics->my_a = 0; // Should not be used.
    sprintf(this_box_volume.p_physics->name,"Mask");
    this_box_volume.geometry.is_mask_volume = 1;
    
    
// Read the material input, or if it lacks, use automatic linking.
} else if (material_string && strlen(material_string) && strcmp(material_string, "NULL") && strcmp(material_string, "0")) {
    // A geometry string was given, use it to determine which material
    if (0 == strcmp(material_string,"vacuum") || 0 == strcmp(material_string,"Vacuum")) {
        // One could have a global physics struct for vacuum instead of creating one for each
        this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
        this_box_volume.p_physics->is_vacuum = 1; // Makes this volume a vacuum
        this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
        this_box_volume.p_physics->my_a = 0; // Should not be used.
        sprintf(this_box_volume.p_physics->name,"Vacuum");
    } else if (0 == strcmp(material_string,"exit") || 0 == strcmp(material_string,"Exit")) {
        // One could have a global physics struct for vacuum instead of creating one for each
        this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
        this_box_volume.p_physics->is_vacuum = 1; // Makes this volume a vacuum
        this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
        this_box_volume.p_physics->my_a = 0; // Should not be used.
        this_box_volume.geometry.is_exit_volume = 1;
        sprintf(this_box_volume.p_physics->name,"Exit");
    } else {
        #ifndef MATERIAL_DETECTOR
            printf("Need to define a material before refering to it in a geometry %s.\n",NAME_CURRENT_COMP);
            exit(1);
        #endif
        for (loop_index=0;loop_index<global_material_list.num_elements;loop_index++) {
            if (0 == strcmp(material_string,global_material_list.elements[loop_index].name)) {
                this_box_volume.p_physics = global_material_list.elements[loop_index].physics;
                break;
            }
            if (loop_index == global_material_list.num_elements-1) {
            printf("\n");
            printf("ERROR: The material string \"%s\" in Union geometry \"%s\" did not match a specified material. \n",material_string,NAME_CURRENT_COMP);
            printf("       The materials available at this point (need to be defined before the geometry): \n");
            for (loop_index=0;loop_index<global_material_list.num_elements;loop_index++)
              printf("         %s\n",global_material_list.elements[loop_index].name);
            printf("\n");
            printf("       It is also possible to use one of the defualt materials avaiable: \n");
            printf("           Vacuum (for a Volume without scattering or absorption)\n");
            printf("           Exit (for a Volume where the ray exits the component if it enters)\n");
            printf("           Mask (for a Volume that masks existing volumes specified in the mask_string\n");
            exit(1);
          }
        }
    }
} else {
    // Automatic linking, simply using the last defined material.
    #ifndef MATERIAL_DETECTOR
        printf("Need to define a material before the geometry to use automatic linking %s.\n",NAME_CURRENT_COMP);
        exit(1);
    #endif
    this_box_volume.p_physics = global_material_list.elements[global_material_list.num_elements-1].physics;
}

sprintf(this_box_volume.name,NAME_CURRENT_COMP);
sprintf(this_box_volume.geometry.shape,"box");
this_box_volume.geometry.priority_value = priority;
this_box_volume.geometry.geometry_p_interact = p_interact;
// Currently the coordinates will be in absolute space.
this_box_volume.geometry.center = POS_A_CURRENT_COMP;

this_box_storage.z_depth = zdepth;
this_box_storage.x_width1 = xwidth;
this_box_storage.y_height1 = yheight;

this_box_storage.is_rectangle = 0;
if (xwidth2 < 0 && yheight2 < 0) this_box_storage.is_rectangle = 1;
if (xwidth == xwidth2 && yheight == yheight2) this_box_storage.is_rectangle = 1;

if (xwidth2 < 0) {
    this_box_storage.x_width2 = xwidth;
    xwidth2 = xwidth;
} else this_box_storage.x_width2 = xwidth2;

if (yheight2 < 0) {
    this_box_storage.y_height2 = yheight;
    yheight2 = yheight;
} else this_box_storage.y_height2 = yheight2;


this_box_storage.normal_vectors[0] = coords_set(0,0,1);
this_box_storage.normal_vectors[1] = coords_set(0,0,1);

// for sides with y component = 0
x_component = 2*zdepth/sqrt((xwidth-xwidth2)*(xwidth-xwidth2)+4*zdepth*zdepth);
z_component = (xwidth-xwidth2)/sqrt(4*zdepth*zdepth+(xwidth-xwidth2)*(xwidth-xwidth2));

this_box_storage.normal_vectors[2] = coords_set(x_component,0,z_component);
this_box_storage.normal_vectors[3] = coords_set(-x_component,0,z_component);

// for sides with x component = 0
y_component = 2*zdepth/sqrt((yheight-yheight2)*(yheight-yheight2)+4*zdepth*zdepth);
z_component = (yheight-yheight2)/sqrt(4*zdepth*zdepth+(yheight-yheight2)*(yheight-yheight2));

this_box_storage.normal_vectors[4] = coords_set(0,y_component,z_component);
this_box_storage.normal_vectors[5] = coords_set(0,-y_component,z_component);

this_box_volume.geometry.visualization_on = visualize;

this_box_volume.geometry.geometry_parameters.p_box_storage = &this_box_storage;

// Assign pointers to functions for intersection with the shape, checking if a point is inside the shape
if (this_box_storage.is_rectangle == 1) {
this_box_volume.geometry.intersect_function = &sample_box_intersect_simple;
this_box_volume.geometry.within_function = &r_within_box_simple;
}
else {
this_box_volume.geometry.intersect_function = &sample_box_intersect_advanced;
this_box_volume.geometry.within_function = &r_within_box_advanced;
}

this_box_volume.geometry.shell_points = &box_shell_points;
this_box_volume.geometry.mcdisplay_function = &mcdisplay_box_function;
this_box_volume.geometry.initialize_from_main_function = &initialize_box_geometry_from_main_component;
this_box_volume.geometry.process_rot_allocated = 0;

this_box_volume.geometry.copy_geometry_parameters = &allocate_box_storage_copy;

rot_copy(this_box_volume.geometry.rotation_matrix,ROT_A_CURRENT_COMP); //check how ROT_R_CURRENT_COMP would work
rot_transpose(ROT_A_CURRENT_COMP,this_box_volume.geometry.transpose_rotation_matrix);

// Initialize loggers
this_box_volume.loggers.num_elements = 0;

// packing the information into the global_geometry_element, which is then included in the global_geometry_list.
sprintf(global_geometry_element.name,NAME_CURRENT_COMP);
global_geometry_element.activation_counter = number_of_activations;
global_geometry_element.component_index = INDEX_CURRENT_COMP;
global_geometry_element.Volume = &this_box_volume; // Would be nicer if this m was a pointer, now we have the (small) data two places
add_element_to_geometry_list(&global_geometry_list,global_geometry_element);
}
#line 266750 "MACS_sample_kidney_box.c"
#undef number_of_activations
#undef mask_setting
#undef mask_string
#undef p_interact
#undef focus_r
#undef focus_xh
#undef focus_xw
#undef focus_ah
#undef focus_aw
#undef target_z
#undef target_y
#undef target_x
#undef target_index
#undef visualize
#undef yheight2
#undef xwidth2
#undef zdepth
#undef yheight
#undef xwidth
#undef priority
#undef material_string
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

  /* Initializations for component channel_11_analyzer_2_array_crystal_array_7. */
  SIG_MESSAGE("channel_11_analyzer_2_array_crystal_array_7 (Init)");
#define mccompcurname  channel_11_analyzer_2_array_crystal_array_7
#define mccompcurtype  Union_box
#define mccompcurindex 566
#define loop_index mccchannel_11_analyzer_2_array_crystal_array_7_loop_index
#define this_box_volume mccchannel_11_analyzer_2_array_crystal_array_7_this_box_volume
#define global_geometry_element mccchannel_11_analyzer_2_array_crystal_array_7_global_geometry_element
#define this_box_storage mccchannel_11_analyzer_2_array_crystal_array_7_this_box_storage
#define material_string mccchannel_11_analyzer_2_array_crystal_array_7_material_string
#define priority mccchannel_11_analyzer_2_array_crystal_array_7_priority
#define xwidth mccchannel_11_analyzer_2_array_crystal_array_7_xwidth
#define yheight mccchannel_11_analyzer_2_array_crystal_array_7_yheight
#define zdepth mccchannel_11_analyzer_2_array_crystal_array_7_zdepth
#define xwidth2 mccchannel_11_analyzer_2_array_crystal_array_7_xwidth2
#define yheight2 mccchannel_11_analyzer_2_array_crystal_array_7_yheight2
#define visualize mccchannel_11_analyzer_2_array_crystal_array_7_visualize
#define target_index mccchannel_11_analyzer_2_array_crystal_array_7_target_index
#define target_x mccchannel_11_analyzer_2_array_crystal_array_7_target_x
#define target_y mccchannel_11_analyzer_2_array_crystal_array_7_target_y
#define target_z mccchannel_11_analyzer_2_array_crystal_array_7_target_z
#define focus_aw mccchannel_11_analyzer_2_array_crystal_array_7_focus_aw
#define focus_ah mccchannel_11_analyzer_2_array_crystal_array_7_focus_ah
#define focus_xw mccchannel_11_analyzer_2_array_crystal_array_7_focus_xw
#define focus_xh mccchannel_11_analyzer_2_array_crystal_array_7_focus_xh
#define focus_r mccchannel_11_analyzer_2_array_crystal_array_7_focus_r
#define p_interact mccchannel_11_analyzer_2_array_crystal_array_7_p_interact
#define mask_string mccchannel_11_analyzer_2_array_crystal_array_7_mask_string
#define mask_setting mccchannel_11_analyzer_2_array_crystal_array_7_mask_setting
#define number_of_activations mccchannel_11_analyzer_2_array_crystal_array_7_number_of_activations
#line 224 "Union_box.comp"
{
// Initializes the focusing system for this volume including input sanitation.
focus_initialize(&this_box_volume.geometry, POS_A_COMP_INDEX(INDEX_CURRENT_COMP+target_index), POS_A_CURRENT_COMP, ROT_A_CURRENT_COMP, target_index, target_x, target_y, target_z, focus_aw, focus_ah, focus_xw, focus_xh, focus_r, NAME_CURRENT_COMP);

// Input sanitation for this geometry
if (xwidth <= 0) {
  printf("\nERROR in Union_box named %s, the xwidth is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (yheight <= 0) {
  printf("\nERROR in Union_box named %s, yheight is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (zdepth <= 0) {
  printf("\nERROR in Union_box named %s, zdepth is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (xwidth2 <= 0 && xwidth2 != -1) {
  printf("\nERROR in Union_box named %s, the xwidth2 is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (yheight2 <= 0 && yheight2 != -1) {
  printf("\nERROR in Union_box named %s, yheight2 is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}

// Use sanitation
if (global_material_list.num_elements == 0) {
  printf("\nERROR: Need to define a material using Union_make_material before using a Union geometry component. \n");
  printf("       %s was defined before first use of Union_make_material.\n",NAME_CURRENT_COMP);
  exit(1);
}

this_box_volume.geometry.is_masked_volume = 0;
this_box_volume.geometry.is_exit_volume = 0;
this_box_volume.geometry.is_mask_volume = 0;
// check if the volume is a mask, if it is the material string is irelevant.
if (mask_string && strlen(mask_string) && strcmp(mask_string, "NULL") && strcmp(mask_string, "0")) {
    // A mask volume is used to limit the extend of other volumes, called the masked volumes. These are specified in the mask_string.
    // In order for a ray to enter a masked volume, it needs to be both in the region covered by that volume AND the mask volume.
    // When more than
    this_box_volume.geometry.mask_mode = 1; // Default is mask mode is ALL
    if (mask_setting && strlen(mask_setting) && strcmp(mask_setting, "NULL") && strcmp(mask_setting, "0")) {
        if (strcmp(mask_setting,"ALL") == 0 || strcmp(mask_setting,"All") == 0) this_box_volume.geometry.mask_mode = 1;
        else if (strcmp(mask_setting,"ANY") == 0 || strcmp(mask_setting,"Any") == 0) this_box_volume.geometry.mask_mode = 2;
        else {
            printf("The mask_mode of component %s is set to %s, but must be either ALL or ANY.\n",NAME_CURRENT_COMP,mask_setting);
            exit(1);
        }
    }
    
    for (loop_index=0;loop_index<global_geometry_list.num_elements;loop_index++) {
        // Add mask list
        if (1 == manual_linking_function(global_geometry_list.elements[loop_index].name,mask_string)) {
            add_element_to_int_list(&this_box_volume.geometry.mask_list,global_geometry_list.elements[loop_index].component_index);
            add_element_to_int_list(&global_geometry_list.elements[loop_index].Volume->geometry.masked_by_list,INDEX_CURRENT_COMP);
            global_geometry_list.elements[loop_index].Volume->geometry.is_masked_volume = 1;
            if (this_box_volume.geometry.mask_mode == 2)
                global_geometry_list.elements[loop_index].Volume->geometry.mask_mode = 2;
            if (this_box_volume.geometry.mask_mode == 1) {
                if (global_geometry_list.elements[loop_index].Volume->geometry.is_masked_volume == 1 && global_geometry_list.elements[loop_index].Volume->geometry.mask_mode != 2)
                    // If more than one mask is added to one volume, the ANY mode overwrites the (default) ALL mode.
                    global_geometry_list.elements[loop_index].Volume->geometry.mask_mode = 1;
            }
            
            found_geometries = 1;
        }
    }
    if (found_geometries == 0) {
        printf("The mask_string in geometry: %s did not find any of the specified volumes in the mask_string %s \n",NAME_CURRENT_COMP,mask_string);
        exit(1);
    }
    this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
    this_box_volume.p_physics->is_vacuum = 0; // Makes this volume a vacuum
    this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
    this_box_volume.p_physics->my_a = 0; // Should not be used.
    sprintf(this_box_volume.p_physics->name,"Mask");
    this_box_volume.geometry.is_mask_volume = 1;
    
    
// Read the material input, or if it lacks, use automatic linking.
} else if (material_string && strlen(material_string) && strcmp(material_string, "NULL") && strcmp(material_string, "0")) {
    // A geometry string was given, use it to determine which material
    if (0 == strcmp(material_string,"vacuum") || 0 == strcmp(material_string,"Vacuum")) {
        // One could have a global physics struct for vacuum instead of creating one for each
        this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
        this_box_volume.p_physics->is_vacuum = 1; // Makes this volume a vacuum
        this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
        this_box_volume.p_physics->my_a = 0; // Should not be used.
        sprintf(this_box_volume.p_physics->name,"Vacuum");
    } else if (0 == strcmp(material_string,"exit") || 0 == strcmp(material_string,"Exit")) {
        // One could have a global physics struct for vacuum instead of creating one for each
        this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
        this_box_volume.p_physics->is_vacuum = 1; // Makes this volume a vacuum
        this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
        this_box_volume.p_physics->my_a = 0; // Should not be used.
        this_box_volume.geometry.is_exit_volume = 1;
        sprintf(this_box_volume.p_physics->name,"Exit");
    } else {
        #ifndef MATERIAL_DETECTOR
            printf("Need to define a material before refering to it in a geometry %s.\n",NAME_CURRENT_COMP);
            exit(1);
        #endif
        for (loop_index=0;loop_index<global_material_list.num_elements;loop_index++) {
            if (0 == strcmp(material_string,global_material_list.elements[loop_index].name)) {
                this_box_volume.p_physics = global_material_list.elements[loop_index].physics;
                break;
            }
            if (loop_index == global_material_list.num_elements-1) {
            printf("\n");
            printf("ERROR: The material string \"%s\" in Union geometry \"%s\" did not match a specified material. \n",material_string,NAME_CURRENT_COMP);
            printf("       The materials available at this point (need to be defined before the geometry): \n");
            for (loop_index=0;loop_index<global_material_list.num_elements;loop_index++)
              printf("         %s\n",global_material_list.elements[loop_index].name);
            printf("\n");
            printf("       It is also possible to use one of the defualt materials avaiable: \n");
            printf("           Vacuum (for a Volume without scattering or absorption)\n");
            printf("           Exit (for a Volume where the ray exits the component if it enters)\n");
            printf("           Mask (for a Volume that masks existing volumes specified in the mask_string\n");
            exit(1);
          }
        }
    }
} else {
    // Automatic linking, simply using the last defined material.
    #ifndef MATERIAL_DETECTOR
        printf("Need to define a material before the geometry to use automatic linking %s.\n",NAME_CURRENT_COMP);
        exit(1);
    #endif
    this_box_volume.p_physics = global_material_list.elements[global_material_list.num_elements-1].physics;
}

sprintf(this_box_volume.name,NAME_CURRENT_COMP);
sprintf(this_box_volume.geometry.shape,"box");
this_box_volume.geometry.priority_value = priority;
this_box_volume.geometry.geometry_p_interact = p_interact;
// Currently the coordinates will be in absolute space.
this_box_volume.geometry.center = POS_A_CURRENT_COMP;

this_box_storage.z_depth = zdepth;
this_box_storage.x_width1 = xwidth;
this_box_storage.y_height1 = yheight;

this_box_storage.is_rectangle = 0;
if (xwidth2 < 0 && yheight2 < 0) this_box_storage.is_rectangle = 1;
if (xwidth == xwidth2 && yheight == yheight2) this_box_storage.is_rectangle = 1;

if (xwidth2 < 0) {
    this_box_storage.x_width2 = xwidth;
    xwidth2 = xwidth;
} else this_box_storage.x_width2 = xwidth2;

if (yheight2 < 0) {
    this_box_storage.y_height2 = yheight;
    yheight2 = yheight;
} else this_box_storage.y_height2 = yheight2;


this_box_storage.normal_vectors[0] = coords_set(0,0,1);
this_box_storage.normal_vectors[1] = coords_set(0,0,1);

// for sides with y component = 0
x_component = 2*zdepth/sqrt((xwidth-xwidth2)*(xwidth-xwidth2)+4*zdepth*zdepth);
z_component = (xwidth-xwidth2)/sqrt(4*zdepth*zdepth+(xwidth-xwidth2)*(xwidth-xwidth2));

this_box_storage.normal_vectors[2] = coords_set(x_component,0,z_component);
this_box_storage.normal_vectors[3] = coords_set(-x_component,0,z_component);

// for sides with x component = 0
y_component = 2*zdepth/sqrt((yheight-yheight2)*(yheight-yheight2)+4*zdepth*zdepth);
z_component = (yheight-yheight2)/sqrt(4*zdepth*zdepth+(yheight-yheight2)*(yheight-yheight2));

this_box_storage.normal_vectors[4] = coords_set(0,y_component,z_component);
this_box_storage.normal_vectors[5] = coords_set(0,-y_component,z_component);

this_box_volume.geometry.visualization_on = visualize;

this_box_volume.geometry.geometry_parameters.p_box_storage = &this_box_storage;

// Assign pointers to functions for intersection with the shape, checking if a point is inside the shape
if (this_box_storage.is_rectangle == 1) {
this_box_volume.geometry.intersect_function = &sample_box_intersect_simple;
this_box_volume.geometry.within_function = &r_within_box_simple;
}
else {
this_box_volume.geometry.intersect_function = &sample_box_intersect_advanced;
this_box_volume.geometry.within_function = &r_within_box_advanced;
}

this_box_volume.geometry.shell_points = &box_shell_points;
this_box_volume.geometry.mcdisplay_function = &mcdisplay_box_function;
this_box_volume.geometry.initialize_from_main_function = &initialize_box_geometry_from_main_component;
this_box_volume.geometry.process_rot_allocated = 0;

this_box_volume.geometry.copy_geometry_parameters = &allocate_box_storage_copy;

rot_copy(this_box_volume.geometry.rotation_matrix,ROT_A_CURRENT_COMP); //check how ROT_R_CURRENT_COMP would work
rot_transpose(ROT_A_CURRENT_COMP,this_box_volume.geometry.transpose_rotation_matrix);

// Initialize loggers
this_box_volume.loggers.num_elements = 0;

// packing the information into the global_geometry_element, which is then included in the global_geometry_list.
sprintf(global_geometry_element.name,NAME_CURRENT_COMP);
global_geometry_element.activation_counter = number_of_activations;
global_geometry_element.component_index = INDEX_CURRENT_COMP;
global_geometry_element.Volume = &this_box_volume; // Would be nicer if this m was a pointer, now we have the (small) data two places
add_element_to_geometry_list(&global_geometry_list,global_geometry_element);
}
#line 267020 "MACS_sample_kidney_box.c"
#undef number_of_activations
#undef mask_setting
#undef mask_string
#undef p_interact
#undef focus_r
#undef focus_xh
#undef focus_xw
#undef focus_ah
#undef focus_aw
#undef target_z
#undef target_y
#undef target_x
#undef target_index
#undef visualize
#undef yheight2
#undef xwidth2
#undef zdepth
#undef yheight
#undef xwidth
#undef priority
#undef material_string
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

  /* Initializations for component channel_11_analyzer_2_array_crystal_array_8. */
  SIG_MESSAGE("channel_11_analyzer_2_array_crystal_array_8 (Init)");
#define mccompcurname  channel_11_analyzer_2_array_crystal_array_8
#define mccompcurtype  Union_box
#define mccompcurindex 567
#define loop_index mccchannel_11_analyzer_2_array_crystal_array_8_loop_index
#define this_box_volume mccchannel_11_analyzer_2_array_crystal_array_8_this_box_volume
#define global_geometry_element mccchannel_11_analyzer_2_array_crystal_array_8_global_geometry_element
#define this_box_storage mccchannel_11_analyzer_2_array_crystal_array_8_this_box_storage
#define material_string mccchannel_11_analyzer_2_array_crystal_array_8_material_string
#define priority mccchannel_11_analyzer_2_array_crystal_array_8_priority
#define xwidth mccchannel_11_analyzer_2_array_crystal_array_8_xwidth
#define yheight mccchannel_11_analyzer_2_array_crystal_array_8_yheight
#define zdepth mccchannel_11_analyzer_2_array_crystal_array_8_zdepth
#define xwidth2 mccchannel_11_analyzer_2_array_crystal_array_8_xwidth2
#define yheight2 mccchannel_11_analyzer_2_array_crystal_array_8_yheight2
#define visualize mccchannel_11_analyzer_2_array_crystal_array_8_visualize
#define target_index mccchannel_11_analyzer_2_array_crystal_array_8_target_index
#define target_x mccchannel_11_analyzer_2_array_crystal_array_8_target_x
#define target_y mccchannel_11_analyzer_2_array_crystal_array_8_target_y
#define target_z mccchannel_11_analyzer_2_array_crystal_array_8_target_z
#define focus_aw mccchannel_11_analyzer_2_array_crystal_array_8_focus_aw
#define focus_ah mccchannel_11_analyzer_2_array_crystal_array_8_focus_ah
#define focus_xw mccchannel_11_analyzer_2_array_crystal_array_8_focus_xw
#define focus_xh mccchannel_11_analyzer_2_array_crystal_array_8_focus_xh
#define focus_r mccchannel_11_analyzer_2_array_crystal_array_8_focus_r
#define p_interact mccchannel_11_analyzer_2_array_crystal_array_8_p_interact
#define mask_string mccchannel_11_analyzer_2_array_crystal_array_8_mask_string
#define mask_setting mccchannel_11_analyzer_2_array_crystal_array_8_mask_setting
#define number_of_activations mccchannel_11_analyzer_2_array_crystal_array_8_number_of_activations
#line 224 "Union_box.comp"
{
// Initializes the focusing system for this volume including input sanitation.
focus_initialize(&this_box_volume.geometry, POS_A_COMP_INDEX(INDEX_CURRENT_COMP+target_index), POS_A_CURRENT_COMP, ROT_A_CURRENT_COMP, target_index, target_x, target_y, target_z, focus_aw, focus_ah, focus_xw, focus_xh, focus_r, NAME_CURRENT_COMP);

// Input sanitation for this geometry
if (xwidth <= 0) {
  printf("\nERROR in Union_box named %s, the xwidth is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (yheight <= 0) {
  printf("\nERROR in Union_box named %s, yheight is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (zdepth <= 0) {
  printf("\nERROR in Union_box named %s, zdepth is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (xwidth2 <= 0 && xwidth2 != -1) {
  printf("\nERROR in Union_box named %s, the xwidth2 is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (yheight2 <= 0 && yheight2 != -1) {
  printf("\nERROR in Union_box named %s, yheight2 is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}

// Use sanitation
if (global_material_list.num_elements == 0) {
  printf("\nERROR: Need to define a material using Union_make_material before using a Union geometry component. \n");
  printf("       %s was defined before first use of Union_make_material.\n",NAME_CURRENT_COMP);
  exit(1);
}

this_box_volume.geometry.is_masked_volume = 0;
this_box_volume.geometry.is_exit_volume = 0;
this_box_volume.geometry.is_mask_volume = 0;
// check if the volume is a mask, if it is the material string is irelevant.
if (mask_string && strlen(mask_string) && strcmp(mask_string, "NULL") && strcmp(mask_string, "0")) {
    // A mask volume is used to limit the extend of other volumes, called the masked volumes. These are specified in the mask_string.
    // In order for a ray to enter a masked volume, it needs to be both in the region covered by that volume AND the mask volume.
    // When more than
    this_box_volume.geometry.mask_mode = 1; // Default is mask mode is ALL
    if (mask_setting && strlen(mask_setting) && strcmp(mask_setting, "NULL") && strcmp(mask_setting, "0")) {
        if (strcmp(mask_setting,"ALL") == 0 || strcmp(mask_setting,"All") == 0) this_box_volume.geometry.mask_mode = 1;
        else if (strcmp(mask_setting,"ANY") == 0 || strcmp(mask_setting,"Any") == 0) this_box_volume.geometry.mask_mode = 2;
        else {
            printf("The mask_mode of component %s is set to %s, but must be either ALL or ANY.\n",NAME_CURRENT_COMP,mask_setting);
            exit(1);
        }
    }
    
    for (loop_index=0;loop_index<global_geometry_list.num_elements;loop_index++) {
        // Add mask list
        if (1 == manual_linking_function(global_geometry_list.elements[loop_index].name,mask_string)) {
            add_element_to_int_list(&this_box_volume.geometry.mask_list,global_geometry_list.elements[loop_index].component_index);
            add_element_to_int_list(&global_geometry_list.elements[loop_index].Volume->geometry.masked_by_list,INDEX_CURRENT_COMP);
            global_geometry_list.elements[loop_index].Volume->geometry.is_masked_volume = 1;
            if (this_box_volume.geometry.mask_mode == 2)
                global_geometry_list.elements[loop_index].Volume->geometry.mask_mode = 2;
            if (this_box_volume.geometry.mask_mode == 1) {
                if (global_geometry_list.elements[loop_index].Volume->geometry.is_masked_volume == 1 && global_geometry_list.elements[loop_index].Volume->geometry.mask_mode != 2)
                    // If more than one mask is added to one volume, the ANY mode overwrites the (default) ALL mode.
                    global_geometry_list.elements[loop_index].Volume->geometry.mask_mode = 1;
            }
            
            found_geometries = 1;
        }
    }
    if (found_geometries == 0) {
        printf("The mask_string in geometry: %s did not find any of the specified volumes in the mask_string %s \n",NAME_CURRENT_COMP,mask_string);
        exit(1);
    }
    this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
    this_box_volume.p_physics->is_vacuum = 0; // Makes this volume a vacuum
    this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
    this_box_volume.p_physics->my_a = 0; // Should not be used.
    sprintf(this_box_volume.p_physics->name,"Mask");
    this_box_volume.geometry.is_mask_volume = 1;
    
    
// Read the material input, or if it lacks, use automatic linking.
} else if (material_string && strlen(material_string) && strcmp(material_string, "NULL") && strcmp(material_string, "0")) {
    // A geometry string was given, use it to determine which material
    if (0 == strcmp(material_string,"vacuum") || 0 == strcmp(material_string,"Vacuum")) {
        // One could have a global physics struct for vacuum instead of creating one for each
        this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
        this_box_volume.p_physics->is_vacuum = 1; // Makes this volume a vacuum
        this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
        this_box_volume.p_physics->my_a = 0; // Should not be used.
        sprintf(this_box_volume.p_physics->name,"Vacuum");
    } else if (0 == strcmp(material_string,"exit") || 0 == strcmp(material_string,"Exit")) {
        // One could have a global physics struct for vacuum instead of creating one for each
        this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
        this_box_volume.p_physics->is_vacuum = 1; // Makes this volume a vacuum
        this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
        this_box_volume.p_physics->my_a = 0; // Should not be used.
        this_box_volume.geometry.is_exit_volume = 1;
        sprintf(this_box_volume.p_physics->name,"Exit");
    } else {
        #ifndef MATERIAL_DETECTOR
            printf("Need to define a material before refering to it in a geometry %s.\n",NAME_CURRENT_COMP);
            exit(1);
        #endif
        for (loop_index=0;loop_index<global_material_list.num_elements;loop_index++) {
            if (0 == strcmp(material_string,global_material_list.elements[loop_index].name)) {
                this_box_volume.p_physics = global_material_list.elements[loop_index].physics;
                break;
            }
            if (loop_index == global_material_list.num_elements-1) {
            printf("\n");
            printf("ERROR: The material string \"%s\" in Union geometry \"%s\" did not match a specified material. \n",material_string,NAME_CURRENT_COMP);
            printf("       The materials available at this point (need to be defined before the geometry): \n");
            for (loop_index=0;loop_index<global_material_list.num_elements;loop_index++)
              printf("         %s\n",global_material_list.elements[loop_index].name);
            printf("\n");
            printf("       It is also possible to use one of the defualt materials avaiable: \n");
            printf("           Vacuum (for a Volume without scattering or absorption)\n");
            printf("           Exit (for a Volume where the ray exits the component if it enters)\n");
            printf("           Mask (for a Volume that masks existing volumes specified in the mask_string\n");
            exit(1);
          }
        }
    }
} else {
    // Automatic linking, simply using the last defined material.
    #ifndef MATERIAL_DETECTOR
        printf("Need to define a material before the geometry to use automatic linking %s.\n",NAME_CURRENT_COMP);
        exit(1);
    #endif
    this_box_volume.p_physics = global_material_list.elements[global_material_list.num_elements-1].physics;
}

sprintf(this_box_volume.name,NAME_CURRENT_COMP);
sprintf(this_box_volume.geometry.shape,"box");
this_box_volume.geometry.priority_value = priority;
this_box_volume.geometry.geometry_p_interact = p_interact;
// Currently the coordinates will be in absolute space.
this_box_volume.geometry.center = POS_A_CURRENT_COMP;

this_box_storage.z_depth = zdepth;
this_box_storage.x_width1 = xwidth;
this_box_storage.y_height1 = yheight;

this_box_storage.is_rectangle = 0;
if (xwidth2 < 0 && yheight2 < 0) this_box_storage.is_rectangle = 1;
if (xwidth == xwidth2 && yheight == yheight2) this_box_storage.is_rectangle = 1;

if (xwidth2 < 0) {
    this_box_storage.x_width2 = xwidth;
    xwidth2 = xwidth;
} else this_box_storage.x_width2 = xwidth2;

if (yheight2 < 0) {
    this_box_storage.y_height2 = yheight;
    yheight2 = yheight;
} else this_box_storage.y_height2 = yheight2;


this_box_storage.normal_vectors[0] = coords_set(0,0,1);
this_box_storage.normal_vectors[1] = coords_set(0,0,1);

// for sides with y component = 0
x_component = 2*zdepth/sqrt((xwidth-xwidth2)*(xwidth-xwidth2)+4*zdepth*zdepth);
z_component = (xwidth-xwidth2)/sqrt(4*zdepth*zdepth+(xwidth-xwidth2)*(xwidth-xwidth2));

this_box_storage.normal_vectors[2] = coords_set(x_component,0,z_component);
this_box_storage.normal_vectors[3] = coords_set(-x_component,0,z_component);

// for sides with x component = 0
y_component = 2*zdepth/sqrt((yheight-yheight2)*(yheight-yheight2)+4*zdepth*zdepth);
z_component = (yheight-yheight2)/sqrt(4*zdepth*zdepth+(yheight-yheight2)*(yheight-yheight2));

this_box_storage.normal_vectors[4] = coords_set(0,y_component,z_component);
this_box_storage.normal_vectors[5] = coords_set(0,-y_component,z_component);

this_box_volume.geometry.visualization_on = visualize;

this_box_volume.geometry.geometry_parameters.p_box_storage = &this_box_storage;

// Assign pointers to functions for intersection with the shape, checking if a point is inside the shape
if (this_box_storage.is_rectangle == 1) {
this_box_volume.geometry.intersect_function = &sample_box_intersect_simple;
this_box_volume.geometry.within_function = &r_within_box_simple;
}
else {
this_box_volume.geometry.intersect_function = &sample_box_intersect_advanced;
this_box_volume.geometry.within_function = &r_within_box_advanced;
}

this_box_volume.geometry.shell_points = &box_shell_points;
this_box_volume.geometry.mcdisplay_function = &mcdisplay_box_function;
this_box_volume.geometry.initialize_from_main_function = &initialize_box_geometry_from_main_component;
this_box_volume.geometry.process_rot_allocated = 0;

this_box_volume.geometry.copy_geometry_parameters = &allocate_box_storage_copy;

rot_copy(this_box_volume.geometry.rotation_matrix,ROT_A_CURRENT_COMP); //check how ROT_R_CURRENT_COMP would work
rot_transpose(ROT_A_CURRENT_COMP,this_box_volume.geometry.transpose_rotation_matrix);

// Initialize loggers
this_box_volume.loggers.num_elements = 0;

// packing the information into the global_geometry_element, which is then included in the global_geometry_list.
sprintf(global_geometry_element.name,NAME_CURRENT_COMP);
global_geometry_element.activation_counter = number_of_activations;
global_geometry_element.component_index = INDEX_CURRENT_COMP;
global_geometry_element.Volume = &this_box_volume; // Would be nicer if this m was a pointer, now we have the (small) data two places
add_element_to_geometry_list(&global_geometry_list,global_geometry_element);
}
#line 267290 "MACS_sample_kidney_box.c"
#undef number_of_activations
#undef mask_setting
#undef mask_string
#undef p_interact
#undef focus_r
#undef focus_xh
#undef focus_xw
#undef focus_ah
#undef focus_aw
#undef target_z
#undef target_y
#undef target_x
#undef target_index
#undef visualize
#undef yheight2
#undef xwidth2
#undef zdepth
#undef yheight
#undef xwidth
#undef priority
#undef material_string
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

  /* Initializations for component channel_11_cave2_cyl1. */
  SIG_MESSAGE("channel_11_cave2_cyl1 (Init)");
#define mccompcurname  channel_11_cave2_cyl1
#define mccompcurtype  Union_cylinder
#define mccompcurindex 568
#define loop_index mccchannel_11_cave2_cyl1_loop_index
#define this_cylinder_volume mccchannel_11_cave2_cyl1_this_cylinder_volume
#define global_geometry_element mccchannel_11_cave2_cyl1_global_geometry_element
#define this_cylinder_storage mccchannel_11_cave2_cyl1_this_cylinder_storage
#define material_string mccchannel_11_cave2_cyl1_material_string
#define priority mccchannel_11_cave2_cyl1_priority
#define radius mccchannel_11_cave2_cyl1_radius
#define yheight mccchannel_11_cave2_cyl1_yheight
#define visualize mccchannel_11_cave2_cyl1_visualize
#define target_index mccchannel_11_cave2_cyl1_target_index
#define target_x mccchannel_11_cave2_cyl1_target_x
#define target_y mccchannel_11_cave2_cyl1_target_y
#define target_z mccchannel_11_cave2_cyl1_target_z
#define focus_aw mccchannel_11_cave2_cyl1_focus_aw
#define focus_ah mccchannel_11_cave2_cyl1_focus_ah
#define focus_xw mccchannel_11_cave2_cyl1_focus_xw
#define focus_xh mccchannel_11_cave2_cyl1_focus_xh
#define focus_r mccchannel_11_cave2_cyl1_focus_r
#define p_interact mccchannel_11_cave2_cyl1_p_interact
#define mask_string mccchannel_11_cave2_cyl1_mask_string
#define mask_setting mccchannel_11_cave2_cyl1_mask_setting
#define number_of_activations mccchannel_11_cave2_cyl1_number_of_activations
#line 185 "Union_cylinder.comp"
{
// Initializes the focusing system for this volume including input sanitation.
focus_initialize(&this_cylinder_volume.geometry, POS_A_COMP_INDEX(INDEX_CURRENT_COMP+target_index), POS_A_CURRENT_COMP, ROT_A_CURRENT_COMP, target_index, target_x, target_y, target_z, focus_aw, focus_ah, focus_xw, focus_xh, focus_r, NAME_CURRENT_COMP);

// Input sanitation for this geometry
if (radius <= 0) {
  printf("\nERROR in Union_cylinder named %s, the radius is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}

if (yheight <= 0) {
  printf("\nERROR in Union_cylinder named %s, yheight is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}

// Use sanitation
#ifdef MATERIAL_DETECTOR
if (global_material_list.num_elements == 0) {
  // Here if the user have defined a material, but only after this material
  printf("\nERROR: Need to define a material using Union_make_material before using a Union geometry component. \n");
  printf("       %s was defined before first use of Union_make_material.\n",NAME_CURRENT_COMP);
  exit(1);
}
#endif
#ifndef MATERIAL_DETECTOR
  printf("\nERROR: Need to define a material using Union_make_material before using a Union geometry component. \n");
  exit(1);
#endif


this_cylinder_volume.geometry.is_masked_volume = 0;
this_cylinder_volume.geometry.is_exit_volume = 0;
this_cylinder_volume.geometry.is_mask_volume = 0;

// Read the material input, or if it lacks, use automatic linking.
if (mask_string && strlen(mask_string) && strcmp(mask_string, "NULL") && strcmp(mask_string, "0")) {
    // A mask volume is used to limit the extend of other volumes, called the masked volumes. These are specified in the mask_string.
    // In order for a ray to enter a masked volume, it needs to be both in the region covered by that volume AND the mask volume.
    // When more than
    this_cylinder_volume.geometry.mask_mode = 1; // Default is mask mode is ALL
    if (mask_setting && strlen(mask_setting) && strcmp(mask_setting, "NULL") && strcmp(mask_setting, "0")) {
        if (strcmp(mask_setting,"ALL") == 0 || strcmp(mask_setting,"All") == 0) this_cylinder_volume.geometry.mask_mode = 1;
        else if (strcmp(mask_setting,"ANY") == 0 || strcmp(mask_setting,"Any") == 0) this_cylinder_volume.geometry.mask_mode = 2;
        else {
            printf("The mask_mode of component %s is set to %s, but must be either ALL or ANY.\n",NAME_CURRENT_COMP,mask_setting);
            exit(1);
        }
    }
    
    for (loop_index=0;loop_index<global_geometry_list.num_elements;loop_index++) {
        // Add mask list
        if (1 == manual_linking_function(global_geometry_list.elements[loop_index].name,mask_string)) {
            add_element_to_int_list(&this_cylinder_volume.geometry.mask_list,global_geometry_list.elements[loop_index].component_index);
            add_element_to_int_list(&global_geometry_list.elements[loop_index].Volume->geometry.masked_by_list,INDEX_CURRENT_COMP);
            global_geometry_list.elements[loop_index].Volume->geometry.is_masked_volume = 1;
            if (this_cylinder_volume.geometry.mask_mode == 2)
                global_geometry_list.elements[loop_index].Volume->geometry.mask_mode = 2;
            if (this_cylinder_volume.geometry.mask_mode == 1) {
                if (global_geometry_list.elements[loop_index].Volume->geometry.is_masked_volume == 1 && global_geometry_list.elements[loop_index].Volume->geometry.mask_mode != 2)
                    // If more than one mask is added to one volume, the ANY mode overwrites the (default) ALL mode.
                    global_geometry_list.elements[loop_index].Volume->geometry.mask_mode = 1;
            }
            
            found_geometries = 1;
        }
    }
    if (found_geometries == 0) {
        printf("The mask_string in geometry: %s did not find any of the specified volumes in the mask_string %s \n",NAME_CURRENT_COMP,mask_string);
        exit(1);
    }
    this_cylinder_volume.p_physics = malloc(sizeof(struct physics_struct));
    this_cylinder_volume.p_physics->is_vacuum = 0; // Makes this volume a vacuum
    this_cylinder_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
    this_cylinder_volume.p_physics->my_a = 0; // Should not be used.
    sprintf(this_cylinder_volume.p_physics->name,"Mask");
    this_cylinder_volume.geometry.is_mask_volume = 1;
    
    
// Read the material input, or if it lacks, use automatic linking.
} else if (material_string && strlen(material_string) && strcmp(material_string, "NULL") && strcmp(material_string, "0")) {
    // A geometry string was given, use it to determine which material
    if (0 == strcmp(material_string,"vacuum") || 0 == strcmp(material_string,"Vacuum")) {
        // One could have a global physics struct for vacuum instead of creating one for each
        this_cylinder_volume.p_physics = malloc(sizeof(struct physics_struct));
        this_cylinder_volume.p_physics->is_vacuum = 1; // Makes this volume a vacuum
        this_cylinder_volume.p_physics->number_of_processes = (int) 0;
        this_cylinder_volume.p_physics->my_a = 0; // Should not be used.
        sprintf(this_cylinder_volume.p_physics->name,"Vacuum");
    } else if (0 == strcmp(material_string,"exit") || 0 == strcmp(material_string,"Exit")) {
        // One could have a global physics struct for exit instead of creating one for each
        this_cylinder_volume.p_physics = malloc(sizeof(struct physics_struct));
        this_cylinder_volume.p_physics->is_vacuum = 1; // Makes this volume a vacuum
        this_cylinder_volume.p_physics->number_of_processes = (int) 0;
        this_cylinder_volume.p_physics->my_a = 0; // Should not be used.
        this_cylinder_volume.geometry.is_exit_volume = 1;
        sprintf(this_cylinder_volume.p_physics->name,"Exit");
    } else {
        for (loop_index=0;loop_index<global_material_list.num_elements;loop_index++) {
          if (0 == strcmp(material_string,global_material_list.elements[loop_index].name)) {
            this_cylinder_volume.p_physics = global_material_list.elements[loop_index].physics;
            break;
          }
          if (loop_index == global_material_list.num_elements-1) {
            printf("\n");
            printf("ERROR: The material string \"%s\" in Union geometry \"%s\" did not match a specified material. \n",material_string,NAME_CURRENT_COMP);
            printf("       The materials available at this point (need to be defined before the geometry): \n");
            for (loop_index=0;loop_index<global_material_list.num_elements;loop_index++)
              printf("         %s\n",global_material_list.elements[loop_index].name);
            printf("\n");
            printf("       It is also possible to use one of the defualt materials avaiable: \n");
            printf("           Vacuum (for a Volume without scattering or absorption)\n");
            printf("           Exit (for a Volume where the ray exits the component if it enters)\n");
            printf("           Mask (for a Volume that masks existing volumes specified in the mask_string\n");
            exit(1);
          }
        }
    }
} else {
    // Automatic linking, simply using the last defined material.
    #ifndef MATERIAL_DETECTOR
        printf("Need to define a material before the geometry to use automatic linking %s.\n",NAME_CURRENT_COMP);
        exit(1);
    #endif
    this_cylinder_volume.p_physics = global_material_list.elements[global_material_list.num_elements-1].physics;
}

sprintf(this_cylinder_volume.name,NAME_CURRENT_COMP);
sprintf(this_cylinder_volume.geometry.shape,"cylinder");
this_cylinder_volume.geometry.priority_value = priority;
// Currently the coordinates will be in absolute space.
this_cylinder_volume.geometry.center = POS_A_CURRENT_COMP;

this_cylinder_volume.geometry.geometry_p_interact = p_interact;
this_cylinder_storage.cyl_radius = radius;
this_cylinder_storage.height = yheight;
this_cylinder_volume.geometry.visualization_on = visualize;
this_cylinder_volume.geometry.geometry_parameters.p_cylinder_storage = &this_cylinder_storage;
this_cylinder_volume.geometry.within_function = &r_within_cylinder;
this_cylinder_volume.geometry.intersect_function = &sample_cylinder_intersect;
this_cylinder_volume.geometry.mcdisplay_function = &mcdisplay_cylinder_function;
this_cylinder_volume.geometry.shell_points = &cylinder_shell_points;
this_cylinder_volume.geometry.initialize_from_main_function = &initialize_cylinder_geometry_from_main_component;
this_cylinder_volume.geometry.process_rot_allocated = 0;
this_cylinder_volume.geometry.copy_geometry_parameters = &allocate_cylinder_storage_copy;

rot_copy(this_cylinder_volume.geometry.rotation_matrix,ROT_A_CURRENT_COMP);
rot_transpose(ROT_A_CURRENT_COMP,this_cylinder_volume.geometry.transpose_rotation_matrix);

// Initialize loggers
this_cylinder_volume.loggers.num_elements = 0;

// packing the information into the global_geometry_element, which is then included in the global_geometry_list.
sprintf(global_geometry_element.name,NAME_CURRENT_COMP);
global_geometry_element.activation_counter = number_of_activations;
global_geometry_element.component_index = INDEX_CURRENT_COMP;
global_geometry_element.Volume = &this_cylinder_volume; // Would be nicer if this m was a pointer, now we have the (small) data two places
add_element_to_geometry_list(&global_geometry_list,global_geometry_element);
}
#line 267506 "MACS_sample_kidney_box.c"
#undef number_of_activations
#undef mask_setting
#undef mask_string
#undef p_interact
#undef focus_r
#undef focus_xh
#undef focus_xw
#undef focus_ah
#undef focus_aw
#undef target_z
#undef target_y
#undef target_x
#undef target_index
#undef visualize
#undef yheight
#undef radius
#undef priority
#undef material_string
#undef this_cylinder_storage
#undef global_geometry_element
#undef this_cylinder_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

  /* Initializations for component channel_11_cave2_box1. */
  SIG_MESSAGE("channel_11_cave2_box1 (Init)");
#define mccompcurname  channel_11_cave2_box1
#define mccompcurtype  Union_box
#define mccompcurindex 569
#define loop_index mccchannel_11_cave2_box1_loop_index
#define this_box_volume mccchannel_11_cave2_box1_this_box_volume
#define global_geometry_element mccchannel_11_cave2_box1_global_geometry_element
#define this_box_storage mccchannel_11_cave2_box1_this_box_storage
#define material_string mccchannel_11_cave2_box1_material_string
#define priority mccchannel_11_cave2_box1_priority
#define xwidth mccchannel_11_cave2_box1_xwidth
#define yheight mccchannel_11_cave2_box1_yheight
#define zdepth mccchannel_11_cave2_box1_zdepth
#define xwidth2 mccchannel_11_cave2_box1_xwidth2
#define yheight2 mccchannel_11_cave2_box1_yheight2
#define visualize mccchannel_11_cave2_box1_visualize
#define target_index mccchannel_11_cave2_box1_target_index
#define target_x mccchannel_11_cave2_box1_target_x
#define target_y mccchannel_11_cave2_box1_target_y
#define target_z mccchannel_11_cave2_box1_target_z
#define focus_aw mccchannel_11_cave2_box1_focus_aw
#define focus_ah mccchannel_11_cave2_box1_focus_ah
#define focus_xw mccchannel_11_cave2_box1_focus_xw
#define focus_xh mccchannel_11_cave2_box1_focus_xh
#define focus_r mccchannel_11_cave2_box1_focus_r
#define p_interact mccchannel_11_cave2_box1_p_interact
#define mask_string mccchannel_11_cave2_box1_mask_string
#define mask_setting mccchannel_11_cave2_box1_mask_setting
#define number_of_activations mccchannel_11_cave2_box1_number_of_activations
#line 224 "Union_box.comp"
{
// Initializes the focusing system for this volume including input sanitation.
focus_initialize(&this_box_volume.geometry, POS_A_COMP_INDEX(INDEX_CURRENT_COMP+target_index), POS_A_CURRENT_COMP, ROT_A_CURRENT_COMP, target_index, target_x, target_y, target_z, focus_aw, focus_ah, focus_xw, focus_xh, focus_r, NAME_CURRENT_COMP);

// Input sanitation for this geometry
if (xwidth <= 0) {
  printf("\nERROR in Union_box named %s, the xwidth is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (yheight <= 0) {
  printf("\nERROR in Union_box named %s, yheight is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (zdepth <= 0) {
  printf("\nERROR in Union_box named %s, zdepth is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (xwidth2 <= 0 && xwidth2 != -1) {
  printf("\nERROR in Union_box named %s, the xwidth2 is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (yheight2 <= 0 && yheight2 != -1) {
  printf("\nERROR in Union_box named %s, yheight2 is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}

// Use sanitation
if (global_material_list.num_elements == 0) {
  printf("\nERROR: Need to define a material using Union_make_material before using a Union geometry component. \n");
  printf("       %s was defined before first use of Union_make_material.\n",NAME_CURRENT_COMP);
  exit(1);
}

this_box_volume.geometry.is_masked_volume = 0;
this_box_volume.geometry.is_exit_volume = 0;
this_box_volume.geometry.is_mask_volume = 0;
// check if the volume is a mask, if it is the material string is irelevant.
if (mask_string && strlen(mask_string) && strcmp(mask_string, "NULL") && strcmp(mask_string, "0")) {
    // A mask volume is used to limit the extend of other volumes, called the masked volumes. These are specified in the mask_string.
    // In order for a ray to enter a masked volume, it needs to be both in the region covered by that volume AND the mask volume.
    // When more than
    this_box_volume.geometry.mask_mode = 1; // Default is mask mode is ALL
    if (mask_setting && strlen(mask_setting) && strcmp(mask_setting, "NULL") && strcmp(mask_setting, "0")) {
        if (strcmp(mask_setting,"ALL") == 0 || strcmp(mask_setting,"All") == 0) this_box_volume.geometry.mask_mode = 1;
        else if (strcmp(mask_setting,"ANY") == 0 || strcmp(mask_setting,"Any") == 0) this_box_volume.geometry.mask_mode = 2;
        else {
            printf("The mask_mode of component %s is set to %s, but must be either ALL or ANY.\n",NAME_CURRENT_COMP,mask_setting);
            exit(1);
        }
    }
    
    for (loop_index=0;loop_index<global_geometry_list.num_elements;loop_index++) {
        // Add mask list
        if (1 == manual_linking_function(global_geometry_list.elements[loop_index].name,mask_string)) {
            add_element_to_int_list(&this_box_volume.geometry.mask_list,global_geometry_list.elements[loop_index].component_index);
            add_element_to_int_list(&global_geometry_list.elements[loop_index].Volume->geometry.masked_by_list,INDEX_CURRENT_COMP);
            global_geometry_list.elements[loop_index].Volume->geometry.is_masked_volume = 1;
            if (this_box_volume.geometry.mask_mode == 2)
                global_geometry_list.elements[loop_index].Volume->geometry.mask_mode = 2;
            if (this_box_volume.geometry.mask_mode == 1) {
                if (global_geometry_list.elements[loop_index].Volume->geometry.is_masked_volume == 1 && global_geometry_list.elements[loop_index].Volume->geometry.mask_mode != 2)
                    // If more than one mask is added to one volume, the ANY mode overwrites the (default) ALL mode.
                    global_geometry_list.elements[loop_index].Volume->geometry.mask_mode = 1;
            }
            
            found_geometries = 1;
        }
    }
    if (found_geometries == 0) {
        printf("The mask_string in geometry: %s did not find any of the specified volumes in the mask_string %s \n",NAME_CURRENT_COMP,mask_string);
        exit(1);
    }
    this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
    this_box_volume.p_physics->is_vacuum = 0; // Makes this volume a vacuum
    this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
    this_box_volume.p_physics->my_a = 0; // Should not be used.
    sprintf(this_box_volume.p_physics->name,"Mask");
    this_box_volume.geometry.is_mask_volume = 1;
    
    
// Read the material input, or if it lacks, use automatic linking.
} else if (material_string && strlen(material_string) && strcmp(material_string, "NULL") && strcmp(material_string, "0")) {
    // A geometry string was given, use it to determine which material
    if (0 == strcmp(material_string,"vacuum") || 0 == strcmp(material_string,"Vacuum")) {
        // One could have a global physics struct for vacuum instead of creating one for each
        this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
        this_box_volume.p_physics->is_vacuum = 1; // Makes this volume a vacuum
        this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
        this_box_volume.p_physics->my_a = 0; // Should not be used.
        sprintf(this_box_volume.p_physics->name,"Vacuum");
    } else if (0 == strcmp(material_string,"exit") || 0 == strcmp(material_string,"Exit")) {
        // One could have a global physics struct for vacuum instead of creating one for each
        this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
        this_box_volume.p_physics->is_vacuum = 1; // Makes this volume a vacuum
        this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
        this_box_volume.p_physics->my_a = 0; // Should not be used.
        this_box_volume.geometry.is_exit_volume = 1;
        sprintf(this_box_volume.p_physics->name,"Exit");
    } else {
        #ifndef MATERIAL_DETECTOR
            printf("Need to define a material before refering to it in a geometry %s.\n",NAME_CURRENT_COMP);
            exit(1);
        #endif
        for (loop_index=0;loop_index<global_material_list.num_elements;loop_index++) {
            if (0 == strcmp(material_string,global_material_list.elements[loop_index].name)) {
                this_box_volume.p_physics = global_material_list.elements[loop_index].physics;
                break;
            }
            if (loop_index == global_material_list.num_elements-1) {
            printf("\n");
            printf("ERROR: The material string \"%s\" in Union geometry \"%s\" did not match a specified material. \n",material_string,NAME_CURRENT_COMP);
            printf("       The materials available at this point (need to be defined before the geometry): \n");
            for (loop_index=0;loop_index<global_material_list.num_elements;loop_index++)
              printf("         %s\n",global_material_list.elements[loop_index].name);
            printf("\n");
            printf("       It is also possible to use one of the defualt materials avaiable: \n");
            printf("           Vacuum (for a Volume without scattering or absorption)\n");
            printf("           Exit (for a Volume where the ray exits the component if it enters)\n");
            printf("           Mask (for a Volume that masks existing volumes specified in the mask_string\n");
            exit(1);
          }
        }
    }
} else {
    // Automatic linking, simply using the last defined material.
    #ifndef MATERIAL_DETECTOR
        printf("Need to define a material before the geometry to use automatic linking %s.\n",NAME_CURRENT_COMP);
        exit(1);
    #endif
    this_box_volume.p_physics = global_material_list.elements[global_material_list.num_elements-1].physics;
}

sprintf(this_box_volume.name,NAME_CURRENT_COMP);
sprintf(this_box_volume.geometry.shape,"box");
this_box_volume.geometry.priority_value = priority;
this_box_volume.geometry.geometry_p_interact = p_interact;
// Currently the coordinates will be in absolute space.
this_box_volume.geometry.center = POS_A_CURRENT_COMP;

this_box_storage.z_depth = zdepth;
this_box_storage.x_width1 = xwidth;
this_box_storage.y_height1 = yheight;

this_box_storage.is_rectangle = 0;
if (xwidth2 < 0 && yheight2 < 0) this_box_storage.is_rectangle = 1;
if (xwidth == xwidth2 && yheight == yheight2) this_box_storage.is_rectangle = 1;

if (xwidth2 < 0) {
    this_box_storage.x_width2 = xwidth;
    xwidth2 = xwidth;
} else this_box_storage.x_width2 = xwidth2;

if (yheight2 < 0) {
    this_box_storage.y_height2 = yheight;
    yheight2 = yheight;
} else this_box_storage.y_height2 = yheight2;


this_box_storage.normal_vectors[0] = coords_set(0,0,1);
this_box_storage.normal_vectors[1] = coords_set(0,0,1);

// for sides with y component = 0
x_component = 2*zdepth/sqrt((xwidth-xwidth2)*(xwidth-xwidth2)+4*zdepth*zdepth);
z_component = (xwidth-xwidth2)/sqrt(4*zdepth*zdepth+(xwidth-xwidth2)*(xwidth-xwidth2));

this_box_storage.normal_vectors[2] = coords_set(x_component,0,z_component);
this_box_storage.normal_vectors[3] = coords_set(-x_component,0,z_component);

// for sides with x component = 0
y_component = 2*zdepth/sqrt((yheight-yheight2)*(yheight-yheight2)+4*zdepth*zdepth);
z_component = (yheight-yheight2)/sqrt(4*zdepth*zdepth+(yheight-yheight2)*(yheight-yheight2));

this_box_storage.normal_vectors[4] = coords_set(0,y_component,z_component);
this_box_storage.normal_vectors[5] = coords_set(0,-y_component,z_component);

this_box_volume.geometry.visualization_on = visualize;

this_box_volume.geometry.geometry_parameters.p_box_storage = &this_box_storage;

// Assign pointers to functions for intersection with the shape, checking if a point is inside the shape
if (this_box_storage.is_rectangle == 1) {
this_box_volume.geometry.intersect_function = &sample_box_intersect_simple;
this_box_volume.geometry.within_function = &r_within_box_simple;
}
else {
this_box_volume.geometry.intersect_function = &sample_box_intersect_advanced;
this_box_volume.geometry.within_function = &r_within_box_advanced;
}

this_box_volume.geometry.shell_points = &box_shell_points;
this_box_volume.geometry.mcdisplay_function = &mcdisplay_box_function;
this_box_volume.geometry.initialize_from_main_function = &initialize_box_geometry_from_main_component;
this_box_volume.geometry.process_rot_allocated = 0;

this_box_volume.geometry.copy_geometry_parameters = &allocate_box_storage_copy;

rot_copy(this_box_volume.geometry.rotation_matrix,ROT_A_CURRENT_COMP); //check how ROT_R_CURRENT_COMP would work
rot_transpose(ROT_A_CURRENT_COMP,this_box_volume.geometry.transpose_rotation_matrix);

// Initialize loggers
this_box_volume.loggers.num_elements = 0;

// packing the information into the global_geometry_element, which is then included in the global_geometry_list.
sprintf(global_geometry_element.name,NAME_CURRENT_COMP);
global_geometry_element.activation_counter = number_of_activations;
global_geometry_element.component_index = INDEX_CURRENT_COMP;
global_geometry_element.Volume = &this_box_volume; // Would be nicer if this m was a pointer, now we have the (small) data two places
add_element_to_geometry_list(&global_geometry_list,global_geometry_element);
}
#line 267773 "MACS_sample_kidney_box.c"
#undef number_of_activations
#undef mask_setting
#undef mask_string
#undef p_interact
#undef focus_r
#undef focus_xh
#undef focus_xw
#undef focus_ah
#undef focus_aw
#undef target_z
#undef target_y
#undef target_x
#undef target_index
#undef visualize
#undef yheight2
#undef xwidth2
#undef zdepth
#undef yheight
#undef xwidth
#undef priority
#undef material_string
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

  /* Initializations for component channel_11_cave2_box2. */
  SIG_MESSAGE("channel_11_cave2_box2 (Init)");
#define mccompcurname  channel_11_cave2_box2
#define mccompcurtype  Union_box
#define mccompcurindex 570
#define loop_index mccchannel_11_cave2_box2_loop_index
#define this_box_volume mccchannel_11_cave2_box2_this_box_volume
#define global_geometry_element mccchannel_11_cave2_box2_global_geometry_element
#define this_box_storage mccchannel_11_cave2_box2_this_box_storage
#define material_string mccchannel_11_cave2_box2_material_string
#define priority mccchannel_11_cave2_box2_priority
#define xwidth mccchannel_11_cave2_box2_xwidth
#define yheight mccchannel_11_cave2_box2_yheight
#define zdepth mccchannel_11_cave2_box2_zdepth
#define xwidth2 mccchannel_11_cave2_box2_xwidth2
#define yheight2 mccchannel_11_cave2_box2_yheight2
#define visualize mccchannel_11_cave2_box2_visualize
#define target_index mccchannel_11_cave2_box2_target_index
#define target_x mccchannel_11_cave2_box2_target_x
#define target_y mccchannel_11_cave2_box2_target_y
#define target_z mccchannel_11_cave2_box2_target_z
#define focus_aw mccchannel_11_cave2_box2_focus_aw
#define focus_ah mccchannel_11_cave2_box2_focus_ah
#define focus_xw mccchannel_11_cave2_box2_focus_xw
#define focus_xh mccchannel_11_cave2_box2_focus_xh
#define focus_r mccchannel_11_cave2_box2_focus_r
#define p_interact mccchannel_11_cave2_box2_p_interact
#define mask_string mccchannel_11_cave2_box2_mask_string
#define mask_setting mccchannel_11_cave2_box2_mask_setting
#define number_of_activations mccchannel_11_cave2_box2_number_of_activations
#line 224 "Union_box.comp"
{
// Initializes the focusing system for this volume including input sanitation.
focus_initialize(&this_box_volume.geometry, POS_A_COMP_INDEX(INDEX_CURRENT_COMP+target_index), POS_A_CURRENT_COMP, ROT_A_CURRENT_COMP, target_index, target_x, target_y, target_z, focus_aw, focus_ah, focus_xw, focus_xh, focus_r, NAME_CURRENT_COMP);

// Input sanitation for this geometry
if (xwidth <= 0) {
  printf("\nERROR in Union_box named %s, the xwidth is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (yheight <= 0) {
  printf("\nERROR in Union_box named %s, yheight is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (zdepth <= 0) {
  printf("\nERROR in Union_box named %s, zdepth is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (xwidth2 <= 0 && xwidth2 != -1) {
  printf("\nERROR in Union_box named %s, the xwidth2 is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (yheight2 <= 0 && yheight2 != -1) {
  printf("\nERROR in Union_box named %s, yheight2 is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}

// Use sanitation
if (global_material_list.num_elements == 0) {
  printf("\nERROR: Need to define a material using Union_make_material before using a Union geometry component. \n");
  printf("       %s was defined before first use of Union_make_material.\n",NAME_CURRENT_COMP);
  exit(1);
}

this_box_volume.geometry.is_masked_volume = 0;
this_box_volume.geometry.is_exit_volume = 0;
this_box_volume.geometry.is_mask_volume = 0;
// check if the volume is a mask, if it is the material string is irelevant.
if (mask_string && strlen(mask_string) && strcmp(mask_string, "NULL") && strcmp(mask_string, "0")) {
    // A mask volume is used to limit the extend of other volumes, called the masked volumes. These are specified in the mask_string.
    // In order for a ray to enter a masked volume, it needs to be both in the region covered by that volume AND the mask volume.
    // When more than
    this_box_volume.geometry.mask_mode = 1; // Default is mask mode is ALL
    if (mask_setting && strlen(mask_setting) && strcmp(mask_setting, "NULL") && strcmp(mask_setting, "0")) {
        if (strcmp(mask_setting,"ALL") == 0 || strcmp(mask_setting,"All") == 0) this_box_volume.geometry.mask_mode = 1;
        else if (strcmp(mask_setting,"ANY") == 0 || strcmp(mask_setting,"Any") == 0) this_box_volume.geometry.mask_mode = 2;
        else {
            printf("The mask_mode of component %s is set to %s, but must be either ALL or ANY.\n",NAME_CURRENT_COMP,mask_setting);
            exit(1);
        }
    }
    
    for (loop_index=0;loop_index<global_geometry_list.num_elements;loop_index++) {
        // Add mask list
        if (1 == manual_linking_function(global_geometry_list.elements[loop_index].name,mask_string)) {
            add_element_to_int_list(&this_box_volume.geometry.mask_list,global_geometry_list.elements[loop_index].component_index);
            add_element_to_int_list(&global_geometry_list.elements[loop_index].Volume->geometry.masked_by_list,INDEX_CURRENT_COMP);
            global_geometry_list.elements[loop_index].Volume->geometry.is_masked_volume = 1;
            if (this_box_volume.geometry.mask_mode == 2)
                global_geometry_list.elements[loop_index].Volume->geometry.mask_mode = 2;
            if (this_box_volume.geometry.mask_mode == 1) {
                if (global_geometry_list.elements[loop_index].Volume->geometry.is_masked_volume == 1 && global_geometry_list.elements[loop_index].Volume->geometry.mask_mode != 2)
                    // If more than one mask is added to one volume, the ANY mode overwrites the (default) ALL mode.
                    global_geometry_list.elements[loop_index].Volume->geometry.mask_mode = 1;
            }
            
            found_geometries = 1;
        }
    }
    if (found_geometries == 0) {
        printf("The mask_string in geometry: %s did not find any of the specified volumes in the mask_string %s \n",NAME_CURRENT_COMP,mask_string);
        exit(1);
    }
    this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
    this_box_volume.p_physics->is_vacuum = 0; // Makes this volume a vacuum
    this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
    this_box_volume.p_physics->my_a = 0; // Should not be used.
    sprintf(this_box_volume.p_physics->name,"Mask");
    this_box_volume.geometry.is_mask_volume = 1;
    
    
// Read the material input, or if it lacks, use automatic linking.
} else if (material_string && strlen(material_string) && strcmp(material_string, "NULL") && strcmp(material_string, "0")) {
    // A geometry string was given, use it to determine which material
    if (0 == strcmp(material_string,"vacuum") || 0 == strcmp(material_string,"Vacuum")) {
        // One could have a global physics struct for vacuum instead of creating one for each
        this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
        this_box_volume.p_physics->is_vacuum = 1; // Makes this volume a vacuum
        this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
        this_box_volume.p_physics->my_a = 0; // Should not be used.
        sprintf(this_box_volume.p_physics->name,"Vacuum");
    } else if (0 == strcmp(material_string,"exit") || 0 == strcmp(material_string,"Exit")) {
        // One could have a global physics struct for vacuum instead of creating one for each
        this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
        this_box_volume.p_physics->is_vacuum = 1; // Makes this volume a vacuum
        this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
        this_box_volume.p_physics->my_a = 0; // Should not be used.
        this_box_volume.geometry.is_exit_volume = 1;
        sprintf(this_box_volume.p_physics->name,"Exit");
    } else {
        #ifndef MATERIAL_DETECTOR
            printf("Need to define a material before refering to it in a geometry %s.\n",NAME_CURRENT_COMP);
            exit(1);
        #endif
        for (loop_index=0;loop_index<global_material_list.num_elements;loop_index++) {
            if (0 == strcmp(material_string,global_material_list.elements[loop_index].name)) {
                this_box_volume.p_physics = global_material_list.elements[loop_index].physics;
                break;
            }
            if (loop_index == global_material_list.num_elements-1) {
            printf("\n");
            printf("ERROR: The material string \"%s\" in Union geometry \"%s\" did not match a specified material. \n",material_string,NAME_CURRENT_COMP);
            printf("       The materials available at this point (need to be defined before the geometry): \n");
            for (loop_index=0;loop_index<global_material_list.num_elements;loop_index++)
              printf("         %s\n",global_material_list.elements[loop_index].name);
            printf("\n");
            printf("       It is also possible to use one of the defualt materials avaiable: \n");
            printf("           Vacuum (for a Volume without scattering or absorption)\n");
            printf("           Exit (for a Volume where the ray exits the component if it enters)\n");
            printf("           Mask (for a Volume that masks existing volumes specified in the mask_string\n");
            exit(1);
          }
        }
    }
} else {
    // Automatic linking, simply using the last defined material.
    #ifndef MATERIAL_DETECTOR
        printf("Need to define a material before the geometry to use automatic linking %s.\n",NAME_CURRENT_COMP);
        exit(1);
    #endif
    this_box_volume.p_physics = global_material_list.elements[global_material_list.num_elements-1].physics;
}

sprintf(this_box_volume.name,NAME_CURRENT_COMP);
sprintf(this_box_volume.geometry.shape,"box");
this_box_volume.geometry.priority_value = priority;
this_box_volume.geometry.geometry_p_interact = p_interact;
// Currently the coordinates will be in absolute space.
this_box_volume.geometry.center = POS_A_CURRENT_COMP;

this_box_storage.z_depth = zdepth;
this_box_storage.x_width1 = xwidth;
this_box_storage.y_height1 = yheight;

this_box_storage.is_rectangle = 0;
if (xwidth2 < 0 && yheight2 < 0) this_box_storage.is_rectangle = 1;
if (xwidth == xwidth2 && yheight == yheight2) this_box_storage.is_rectangle = 1;

if (xwidth2 < 0) {
    this_box_storage.x_width2 = xwidth;
    xwidth2 = xwidth;
} else this_box_storage.x_width2 = xwidth2;

if (yheight2 < 0) {
    this_box_storage.y_height2 = yheight;
    yheight2 = yheight;
} else this_box_storage.y_height2 = yheight2;


this_box_storage.normal_vectors[0] = coords_set(0,0,1);
this_box_storage.normal_vectors[1] = coords_set(0,0,1);

// for sides with y component = 0
x_component = 2*zdepth/sqrt((xwidth-xwidth2)*(xwidth-xwidth2)+4*zdepth*zdepth);
z_component = (xwidth-xwidth2)/sqrt(4*zdepth*zdepth+(xwidth-xwidth2)*(xwidth-xwidth2));

this_box_storage.normal_vectors[2] = coords_set(x_component,0,z_component);
this_box_storage.normal_vectors[3] = coords_set(-x_component,0,z_component);

// for sides with x component = 0
y_component = 2*zdepth/sqrt((yheight-yheight2)*(yheight-yheight2)+4*zdepth*zdepth);
z_component = (yheight-yheight2)/sqrt(4*zdepth*zdepth+(yheight-yheight2)*(yheight-yheight2));

this_box_storage.normal_vectors[4] = coords_set(0,y_component,z_component);
this_box_storage.normal_vectors[5] = coords_set(0,-y_component,z_component);

this_box_volume.geometry.visualization_on = visualize;

this_box_volume.geometry.geometry_parameters.p_box_storage = &this_box_storage;

// Assign pointers to functions for intersection with the shape, checking if a point is inside the shape
if (this_box_storage.is_rectangle == 1) {
this_box_volume.geometry.intersect_function = &sample_box_intersect_simple;
this_box_volume.geometry.within_function = &r_within_box_simple;
}
else {
this_box_volume.geometry.intersect_function = &sample_box_intersect_advanced;
this_box_volume.geometry.within_function = &r_within_box_advanced;
}

this_box_volume.geometry.shell_points = &box_shell_points;
this_box_volume.geometry.mcdisplay_function = &mcdisplay_box_function;
this_box_volume.geometry.initialize_from_main_function = &initialize_box_geometry_from_main_component;
this_box_volume.geometry.process_rot_allocated = 0;

this_box_volume.geometry.copy_geometry_parameters = &allocate_box_storage_copy;

rot_copy(this_box_volume.geometry.rotation_matrix,ROT_A_CURRENT_COMP); //check how ROT_R_CURRENT_COMP would work
rot_transpose(ROT_A_CURRENT_COMP,this_box_volume.geometry.transpose_rotation_matrix);

// Initialize loggers
this_box_volume.loggers.num_elements = 0;

// packing the information into the global_geometry_element, which is then included in the global_geometry_list.
sprintf(global_geometry_element.name,NAME_CURRENT_COMP);
global_geometry_element.activation_counter = number_of_activations;
global_geometry_element.component_index = INDEX_CURRENT_COMP;
global_geometry_element.Volume = &this_box_volume; // Would be nicer if this m was a pointer, now we have the (small) data two places
add_element_to_geometry_list(&global_geometry_list,global_geometry_element);
}
#line 268043 "MACS_sample_kidney_box.c"
#undef number_of_activations
#undef mask_setting
#undef mask_string
#undef p_interact
#undef focus_r
#undef focus_xh
#undef focus_xw
#undef focus_ah
#undef focus_aw
#undef target_z
#undef target_y
#undef target_x
#undef target_index
#undef visualize
#undef yheight2
#undef xwidth2
#undef zdepth
#undef yheight
#undef xwidth
#undef priority
#undef material_string
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

  /* Initializations for component channel_11_cave2_box3. */
  SIG_MESSAGE("channel_11_cave2_box3 (Init)");
#define mccompcurname  channel_11_cave2_box3
#define mccompcurtype  Union_box
#define mccompcurindex 571
#define loop_index mccchannel_11_cave2_box3_loop_index
#define this_box_volume mccchannel_11_cave2_box3_this_box_volume
#define global_geometry_element mccchannel_11_cave2_box3_global_geometry_element
#define this_box_storage mccchannel_11_cave2_box3_this_box_storage
#define material_string mccchannel_11_cave2_box3_material_string
#define priority mccchannel_11_cave2_box3_priority
#define xwidth mccchannel_11_cave2_box3_xwidth
#define yheight mccchannel_11_cave2_box3_yheight
#define zdepth mccchannel_11_cave2_box3_zdepth
#define xwidth2 mccchannel_11_cave2_box3_xwidth2
#define yheight2 mccchannel_11_cave2_box3_yheight2
#define visualize mccchannel_11_cave2_box3_visualize
#define target_index mccchannel_11_cave2_box3_target_index
#define target_x mccchannel_11_cave2_box3_target_x
#define target_y mccchannel_11_cave2_box3_target_y
#define target_z mccchannel_11_cave2_box3_target_z
#define focus_aw mccchannel_11_cave2_box3_focus_aw
#define focus_ah mccchannel_11_cave2_box3_focus_ah
#define focus_xw mccchannel_11_cave2_box3_focus_xw
#define focus_xh mccchannel_11_cave2_box3_focus_xh
#define focus_r mccchannel_11_cave2_box3_focus_r
#define p_interact mccchannel_11_cave2_box3_p_interact
#define mask_string mccchannel_11_cave2_box3_mask_string
#define mask_setting mccchannel_11_cave2_box3_mask_setting
#define number_of_activations mccchannel_11_cave2_box3_number_of_activations
#line 224 "Union_box.comp"
{
// Initializes the focusing system for this volume including input sanitation.
focus_initialize(&this_box_volume.geometry, POS_A_COMP_INDEX(INDEX_CURRENT_COMP+target_index), POS_A_CURRENT_COMP, ROT_A_CURRENT_COMP, target_index, target_x, target_y, target_z, focus_aw, focus_ah, focus_xw, focus_xh, focus_r, NAME_CURRENT_COMP);

// Input sanitation for this geometry
if (xwidth <= 0) {
  printf("\nERROR in Union_box named %s, the xwidth is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (yheight <= 0) {
  printf("\nERROR in Union_box named %s, yheight is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (zdepth <= 0) {
  printf("\nERROR in Union_box named %s, zdepth is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (xwidth2 <= 0 && xwidth2 != -1) {
  printf("\nERROR in Union_box named %s, the xwidth2 is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (yheight2 <= 0 && yheight2 != -1) {
  printf("\nERROR in Union_box named %s, yheight2 is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}

// Use sanitation
if (global_material_list.num_elements == 0) {
  printf("\nERROR: Need to define a material using Union_make_material before using a Union geometry component. \n");
  printf("       %s was defined before first use of Union_make_material.\n",NAME_CURRENT_COMP);
  exit(1);
}

this_box_volume.geometry.is_masked_volume = 0;
this_box_volume.geometry.is_exit_volume = 0;
this_box_volume.geometry.is_mask_volume = 0;
// check if the volume is a mask, if it is the material string is irelevant.
if (mask_string && strlen(mask_string) && strcmp(mask_string, "NULL") && strcmp(mask_string, "0")) {
    // A mask volume is used to limit the extend of other volumes, called the masked volumes. These are specified in the mask_string.
    // In order for a ray to enter a masked volume, it needs to be both in the region covered by that volume AND the mask volume.
    // When more than
    this_box_volume.geometry.mask_mode = 1; // Default is mask mode is ALL
    if (mask_setting && strlen(mask_setting) && strcmp(mask_setting, "NULL") && strcmp(mask_setting, "0")) {
        if (strcmp(mask_setting,"ALL") == 0 || strcmp(mask_setting,"All") == 0) this_box_volume.geometry.mask_mode = 1;
        else if (strcmp(mask_setting,"ANY") == 0 || strcmp(mask_setting,"Any") == 0) this_box_volume.geometry.mask_mode = 2;
        else {
            printf("The mask_mode of component %s is set to %s, but must be either ALL or ANY.\n",NAME_CURRENT_COMP,mask_setting);
            exit(1);
        }
    }
    
    for (loop_index=0;loop_index<global_geometry_list.num_elements;loop_index++) {
        // Add mask list
        if (1 == manual_linking_function(global_geometry_list.elements[loop_index].name,mask_string)) {
            add_element_to_int_list(&this_box_volume.geometry.mask_list,global_geometry_list.elements[loop_index].component_index);
            add_element_to_int_list(&global_geometry_list.elements[loop_index].Volume->geometry.masked_by_list,INDEX_CURRENT_COMP);
            global_geometry_list.elements[loop_index].Volume->geometry.is_masked_volume = 1;
            if (this_box_volume.geometry.mask_mode == 2)
                global_geometry_list.elements[loop_index].Volume->geometry.mask_mode = 2;
            if (this_box_volume.geometry.mask_mode == 1) {
                if (global_geometry_list.elements[loop_index].Volume->geometry.is_masked_volume == 1 && global_geometry_list.elements[loop_index].Volume->geometry.mask_mode != 2)
                    // If more than one mask is added to one volume, the ANY mode overwrites the (default) ALL mode.
                    global_geometry_list.elements[loop_index].Volume->geometry.mask_mode = 1;
            }
            
            found_geometries = 1;
        }
    }
    if (found_geometries == 0) {
        printf("The mask_string in geometry: %s did not find any of the specified volumes in the mask_string %s \n",NAME_CURRENT_COMP,mask_string);
        exit(1);
    }
    this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
    this_box_volume.p_physics->is_vacuum = 0; // Makes this volume a vacuum
    this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
    this_box_volume.p_physics->my_a = 0; // Should not be used.
    sprintf(this_box_volume.p_physics->name,"Mask");
    this_box_volume.geometry.is_mask_volume = 1;
    
    
// Read the material input, or if it lacks, use automatic linking.
} else if (material_string && strlen(material_string) && strcmp(material_string, "NULL") && strcmp(material_string, "0")) {
    // A geometry string was given, use it to determine which material
    if (0 == strcmp(material_string,"vacuum") || 0 == strcmp(material_string,"Vacuum")) {
        // One could have a global physics struct for vacuum instead of creating one for each
        this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
        this_box_volume.p_physics->is_vacuum = 1; // Makes this volume a vacuum
        this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
        this_box_volume.p_physics->my_a = 0; // Should not be used.
        sprintf(this_box_volume.p_physics->name,"Vacuum");
    } else if (0 == strcmp(material_string,"exit") || 0 == strcmp(material_string,"Exit")) {
        // One could have a global physics struct for vacuum instead of creating one for each
        this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
        this_box_volume.p_physics->is_vacuum = 1; // Makes this volume a vacuum
        this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
        this_box_volume.p_physics->my_a = 0; // Should not be used.
        this_box_volume.geometry.is_exit_volume = 1;
        sprintf(this_box_volume.p_physics->name,"Exit");
    } else {
        #ifndef MATERIAL_DETECTOR
            printf("Need to define a material before refering to it in a geometry %s.\n",NAME_CURRENT_COMP);
            exit(1);
        #endif
        for (loop_index=0;loop_index<global_material_list.num_elements;loop_index++) {
            if (0 == strcmp(material_string,global_material_list.elements[loop_index].name)) {
                this_box_volume.p_physics = global_material_list.elements[loop_index].physics;
                break;
            }
            if (loop_index == global_material_list.num_elements-1) {
            printf("\n");
            printf("ERROR: The material string \"%s\" in Union geometry \"%s\" did not match a specified material. \n",material_string,NAME_CURRENT_COMP);
            printf("       The materials available at this point (need to be defined before the geometry): \n");
            for (loop_index=0;loop_index<global_material_list.num_elements;loop_index++)
              printf("         %s\n",global_material_list.elements[loop_index].name);
            printf("\n");
            printf("       It is also possible to use one of the defualt materials avaiable: \n");
            printf("           Vacuum (for a Volume without scattering or absorption)\n");
            printf("           Exit (for a Volume where the ray exits the component if it enters)\n");
            printf("           Mask (for a Volume that masks existing volumes specified in the mask_string\n");
            exit(1);
          }
        }
    }
} else {
    // Automatic linking, simply using the last defined material.
    #ifndef MATERIAL_DETECTOR
        printf("Need to define a material before the geometry to use automatic linking %s.\n",NAME_CURRENT_COMP);
        exit(1);
    #endif
    this_box_volume.p_physics = global_material_list.elements[global_material_list.num_elements-1].physics;
}

sprintf(this_box_volume.name,NAME_CURRENT_COMP);
sprintf(this_box_volume.geometry.shape,"box");
this_box_volume.geometry.priority_value = priority;
this_box_volume.geometry.geometry_p_interact = p_interact;
// Currently the coordinates will be in absolute space.
this_box_volume.geometry.center = POS_A_CURRENT_COMP;

this_box_storage.z_depth = zdepth;
this_box_storage.x_width1 = xwidth;
this_box_storage.y_height1 = yheight;

this_box_storage.is_rectangle = 0;
if (xwidth2 < 0 && yheight2 < 0) this_box_storage.is_rectangle = 1;
if (xwidth == xwidth2 && yheight == yheight2) this_box_storage.is_rectangle = 1;

if (xwidth2 < 0) {
    this_box_storage.x_width2 = xwidth;
    xwidth2 = xwidth;
} else this_box_storage.x_width2 = xwidth2;

if (yheight2 < 0) {
    this_box_storage.y_height2 = yheight;
    yheight2 = yheight;
} else this_box_storage.y_height2 = yheight2;


this_box_storage.normal_vectors[0] = coords_set(0,0,1);
this_box_storage.normal_vectors[1] = coords_set(0,0,1);

// for sides with y component = 0
x_component = 2*zdepth/sqrt((xwidth-xwidth2)*(xwidth-xwidth2)+4*zdepth*zdepth);
z_component = (xwidth-xwidth2)/sqrt(4*zdepth*zdepth+(xwidth-xwidth2)*(xwidth-xwidth2));

this_box_storage.normal_vectors[2] = coords_set(x_component,0,z_component);
this_box_storage.normal_vectors[3] = coords_set(-x_component,0,z_component);

// for sides with x component = 0
y_component = 2*zdepth/sqrt((yheight-yheight2)*(yheight-yheight2)+4*zdepth*zdepth);
z_component = (yheight-yheight2)/sqrt(4*zdepth*zdepth+(yheight-yheight2)*(yheight-yheight2));

this_box_storage.normal_vectors[4] = coords_set(0,y_component,z_component);
this_box_storage.normal_vectors[5] = coords_set(0,-y_component,z_component);

this_box_volume.geometry.visualization_on = visualize;

this_box_volume.geometry.geometry_parameters.p_box_storage = &this_box_storage;

// Assign pointers to functions for intersection with the shape, checking if a point is inside the shape
if (this_box_storage.is_rectangle == 1) {
this_box_volume.geometry.intersect_function = &sample_box_intersect_simple;
this_box_volume.geometry.within_function = &r_within_box_simple;
}
else {
this_box_volume.geometry.intersect_function = &sample_box_intersect_advanced;
this_box_volume.geometry.within_function = &r_within_box_advanced;
}

this_box_volume.geometry.shell_points = &box_shell_points;
this_box_volume.geometry.mcdisplay_function = &mcdisplay_box_function;
this_box_volume.geometry.initialize_from_main_function = &initialize_box_geometry_from_main_component;
this_box_volume.geometry.process_rot_allocated = 0;

this_box_volume.geometry.copy_geometry_parameters = &allocate_box_storage_copy;

rot_copy(this_box_volume.geometry.rotation_matrix,ROT_A_CURRENT_COMP); //check how ROT_R_CURRENT_COMP would work
rot_transpose(ROT_A_CURRENT_COMP,this_box_volume.geometry.transpose_rotation_matrix);

// Initialize loggers
this_box_volume.loggers.num_elements = 0;

// packing the information into the global_geometry_element, which is then included in the global_geometry_list.
sprintf(global_geometry_element.name,NAME_CURRENT_COMP);
global_geometry_element.activation_counter = number_of_activations;
global_geometry_element.component_index = INDEX_CURRENT_COMP;
global_geometry_element.Volume = &this_box_volume; // Would be nicer if this m was a pointer, now we have the (small) data two places
add_element_to_geometry_list(&global_geometry_list,global_geometry_element);
}
#line 268313 "MACS_sample_kidney_box.c"
#undef number_of_activations
#undef mask_setting
#undef mask_string
#undef p_interact
#undef focus_r
#undef focus_xh
#undef focus_xw
#undef focus_ah
#undef focus_aw
#undef target_z
#undef target_y
#undef target_x
#undef target_index
#undef visualize
#undef yheight2
#undef xwidth2
#undef zdepth
#undef yheight
#undef xwidth
#undef priority
#undef material_string
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

  /* Initializations for component inter_analyzer_colimator_center_11. */
  SIG_MESSAGE("inter_analyzer_colimator_center_11 (Init)");

  /* Initializations for component inter_analyzer_colimator_11_blade_0. */
  SIG_MESSAGE("inter_analyzer_colimator_11_blade_0 (Init)");
#define mccompcurname  inter_analyzer_colimator_11_blade_0
#define mccompcurtype  Union_box
#define mccompcurindex 573
#define loop_index mccinter_analyzer_colimator_11_blade_0_loop_index
#define this_box_volume mccinter_analyzer_colimator_11_blade_0_this_box_volume
#define global_geometry_element mccinter_analyzer_colimator_11_blade_0_global_geometry_element
#define this_box_storage mccinter_analyzer_colimator_11_blade_0_this_box_storage
#define material_string mccinter_analyzer_colimator_11_blade_0_material_string
#define priority mccinter_analyzer_colimator_11_blade_0_priority
#define xwidth mccinter_analyzer_colimator_11_blade_0_xwidth
#define yheight mccinter_analyzer_colimator_11_blade_0_yheight
#define zdepth mccinter_analyzer_colimator_11_blade_0_zdepth
#define xwidth2 mccinter_analyzer_colimator_11_blade_0_xwidth2
#define yheight2 mccinter_analyzer_colimator_11_blade_0_yheight2
#define visualize mccinter_analyzer_colimator_11_blade_0_visualize
#define target_index mccinter_analyzer_colimator_11_blade_0_target_index
#define target_x mccinter_analyzer_colimator_11_blade_0_target_x
#define target_y mccinter_analyzer_colimator_11_blade_0_target_y
#define target_z mccinter_analyzer_colimator_11_blade_0_target_z
#define focus_aw mccinter_analyzer_colimator_11_blade_0_focus_aw
#define focus_ah mccinter_analyzer_colimator_11_blade_0_focus_ah
#define focus_xw mccinter_analyzer_colimator_11_blade_0_focus_xw
#define focus_xh mccinter_analyzer_colimator_11_blade_0_focus_xh
#define focus_r mccinter_analyzer_colimator_11_blade_0_focus_r
#define p_interact mccinter_analyzer_colimator_11_blade_0_p_interact
#define mask_string mccinter_analyzer_colimator_11_blade_0_mask_string
#define mask_setting mccinter_analyzer_colimator_11_blade_0_mask_setting
#define number_of_activations mccinter_analyzer_colimator_11_blade_0_number_of_activations
#line 224 "Union_box.comp"
{
// Initializes the focusing system for this volume including input sanitation.
focus_initialize(&this_box_volume.geometry, POS_A_COMP_INDEX(INDEX_CURRENT_COMP+target_index), POS_A_CURRENT_COMP, ROT_A_CURRENT_COMP, target_index, target_x, target_y, target_z, focus_aw, focus_ah, focus_xw, focus_xh, focus_r, NAME_CURRENT_COMP);

// Input sanitation for this geometry
if (xwidth <= 0) {
  printf("\nERROR in Union_box named %s, the xwidth is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (yheight <= 0) {
  printf("\nERROR in Union_box named %s, yheight is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (zdepth <= 0) {
  printf("\nERROR in Union_box named %s, zdepth is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (xwidth2 <= 0 && xwidth2 != -1) {
  printf("\nERROR in Union_box named %s, the xwidth2 is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (yheight2 <= 0 && yheight2 != -1) {
  printf("\nERROR in Union_box named %s, yheight2 is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}

// Use sanitation
if (global_material_list.num_elements == 0) {
  printf("\nERROR: Need to define a material using Union_make_material before using a Union geometry component. \n");
  printf("       %s was defined before first use of Union_make_material.\n",NAME_CURRENT_COMP);
  exit(1);
}

this_box_volume.geometry.is_masked_volume = 0;
this_box_volume.geometry.is_exit_volume = 0;
this_box_volume.geometry.is_mask_volume = 0;
// check if the volume is a mask, if it is the material string is irelevant.
if (mask_string && strlen(mask_string) && strcmp(mask_string, "NULL") && strcmp(mask_string, "0")) {
    // A mask volume is used to limit the extend of other volumes, called the masked volumes. These are specified in the mask_string.
    // In order for a ray to enter a masked volume, it needs to be both in the region covered by that volume AND the mask volume.
    // When more than
    this_box_volume.geometry.mask_mode = 1; // Default is mask mode is ALL
    if (mask_setting && strlen(mask_setting) && strcmp(mask_setting, "NULL") && strcmp(mask_setting, "0")) {
        if (strcmp(mask_setting,"ALL") == 0 || strcmp(mask_setting,"All") == 0) this_box_volume.geometry.mask_mode = 1;
        else if (strcmp(mask_setting,"ANY") == 0 || strcmp(mask_setting,"Any") == 0) this_box_volume.geometry.mask_mode = 2;
        else {
            printf("The mask_mode of component %s is set to %s, but must be either ALL or ANY.\n",NAME_CURRENT_COMP,mask_setting);
            exit(1);
        }
    }
    
    for (loop_index=0;loop_index<global_geometry_list.num_elements;loop_index++) {
        // Add mask list
        if (1 == manual_linking_function(global_geometry_list.elements[loop_index].name,mask_string)) {
            add_element_to_int_list(&this_box_volume.geometry.mask_list,global_geometry_list.elements[loop_index].component_index);
            add_element_to_int_list(&global_geometry_list.elements[loop_index].Volume->geometry.masked_by_list,INDEX_CURRENT_COMP);
            global_geometry_list.elements[loop_index].Volume->geometry.is_masked_volume = 1;
            if (this_box_volume.geometry.mask_mode == 2)
                global_geometry_list.elements[loop_index].Volume->geometry.mask_mode = 2;
            if (this_box_volume.geometry.mask_mode == 1) {
                if (global_geometry_list.elements[loop_index].Volume->geometry.is_masked_volume == 1 && global_geometry_list.elements[loop_index].Volume->geometry.mask_mode != 2)
                    // If more than one mask is added to one volume, the ANY mode overwrites the (default) ALL mode.
                    global_geometry_list.elements[loop_index].Volume->geometry.mask_mode = 1;
            }
            
            found_geometries = 1;
        }
    }
    if (found_geometries == 0) {
        printf("The mask_string in geometry: %s did not find any of the specified volumes in the mask_string %s \n",NAME_CURRENT_COMP,mask_string);
        exit(1);
    }
    this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
    this_box_volume.p_physics->is_vacuum = 0; // Makes this volume a vacuum
    this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
    this_box_volume.p_physics->my_a = 0; // Should not be used.
    sprintf(this_box_volume.p_physics->name,"Mask");
    this_box_volume.geometry.is_mask_volume = 1;
    
    
// Read the material input, or if it lacks, use automatic linking.
} else if (material_string && strlen(material_string) && strcmp(material_string, "NULL") && strcmp(material_string, "0")) {
    // A geometry string was given, use it to determine which material
    if (0 == strcmp(material_string,"vacuum") || 0 == strcmp(material_string,"Vacuum")) {
        // One could have a global physics struct for vacuum instead of creating one for each
        this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
        this_box_volume.p_physics->is_vacuum = 1; // Makes this volume a vacuum
        this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
        this_box_volume.p_physics->my_a = 0; // Should not be used.
        sprintf(this_box_volume.p_physics->name,"Vacuum");
    } else if (0 == strcmp(material_string,"exit") || 0 == strcmp(material_string,"Exit")) {
        // One could have a global physics struct for vacuum instead of creating one for each
        this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
        this_box_volume.p_physics->is_vacuum = 1; // Makes this volume a vacuum
        this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
        this_box_volume.p_physics->my_a = 0; // Should not be used.
        this_box_volume.geometry.is_exit_volume = 1;
        sprintf(this_box_volume.p_physics->name,"Exit");
    } else {
        #ifndef MATERIAL_DETECTOR
            printf("Need to define a material before refering to it in a geometry %s.\n",NAME_CURRENT_COMP);
            exit(1);
        #endif
        for (loop_index=0;loop_index<global_material_list.num_elements;loop_index++) {
            if (0 == strcmp(material_string,global_material_list.elements[loop_index].name)) {
                this_box_volume.p_physics = global_material_list.elements[loop_index].physics;
                break;
            }
            if (loop_index == global_material_list.num_elements-1) {
            printf("\n");
            printf("ERROR: The material string \"%s\" in Union geometry \"%s\" did not match a specified material. \n",material_string,NAME_CURRENT_COMP);
            printf("       The materials available at this point (need to be defined before the geometry): \n");
            for (loop_index=0;loop_index<global_material_list.num_elements;loop_index++)
              printf("         %s\n",global_material_list.elements[loop_index].name);
            printf("\n");
            printf("       It is also possible to use one of the defualt materials avaiable: \n");
            printf("           Vacuum (for a Volume without scattering or absorption)\n");
            printf("           Exit (for a Volume where the ray exits the component if it enters)\n");
            printf("           Mask (for a Volume that masks existing volumes specified in the mask_string\n");
            exit(1);
          }
        }
    }
} else {
    // Automatic linking, simply using the last defined material.
    #ifndef MATERIAL_DETECTOR
        printf("Need to define a material before the geometry to use automatic linking %s.\n",NAME_CURRENT_COMP);
        exit(1);
    #endif
    this_box_volume.p_physics = global_material_list.elements[global_material_list.num_elements-1].physics;
}

sprintf(this_box_volume.name,NAME_CURRENT_COMP);
sprintf(this_box_volume.geometry.shape,"box");
this_box_volume.geometry.priority_value = priority;
this_box_volume.geometry.geometry_p_interact = p_interact;
// Currently the coordinates will be in absolute space.
this_box_volume.geometry.center = POS_A_CURRENT_COMP;

this_box_storage.z_depth = zdepth;
this_box_storage.x_width1 = xwidth;
this_box_storage.y_height1 = yheight;

this_box_storage.is_rectangle = 0;
if (xwidth2 < 0 && yheight2 < 0) this_box_storage.is_rectangle = 1;
if (xwidth == xwidth2 && yheight == yheight2) this_box_storage.is_rectangle = 1;

if (xwidth2 < 0) {
    this_box_storage.x_width2 = xwidth;
    xwidth2 = xwidth;
} else this_box_storage.x_width2 = xwidth2;

if (yheight2 < 0) {
    this_box_storage.y_height2 = yheight;
    yheight2 = yheight;
} else this_box_storage.y_height2 = yheight2;


this_box_storage.normal_vectors[0] = coords_set(0,0,1);
this_box_storage.normal_vectors[1] = coords_set(0,0,1);

// for sides with y component = 0
x_component = 2*zdepth/sqrt((xwidth-xwidth2)*(xwidth-xwidth2)+4*zdepth*zdepth);
z_component = (xwidth-xwidth2)/sqrt(4*zdepth*zdepth+(xwidth-xwidth2)*(xwidth-xwidth2));

this_box_storage.normal_vectors[2] = coords_set(x_component,0,z_component);
this_box_storage.normal_vectors[3] = coords_set(-x_component,0,z_component);

// for sides with x component = 0
y_component = 2*zdepth/sqrt((yheight-yheight2)*(yheight-yheight2)+4*zdepth*zdepth);
z_component = (yheight-yheight2)/sqrt(4*zdepth*zdepth+(yheight-yheight2)*(yheight-yheight2));

this_box_storage.normal_vectors[4] = coords_set(0,y_component,z_component);
this_box_storage.normal_vectors[5] = coords_set(0,-y_component,z_component);

this_box_volume.geometry.visualization_on = visualize;

this_box_volume.geometry.geometry_parameters.p_box_storage = &this_box_storage;

// Assign pointers to functions for intersection with the shape, checking if a point is inside the shape
if (this_box_storage.is_rectangle == 1) {
this_box_volume.geometry.intersect_function = &sample_box_intersect_simple;
this_box_volume.geometry.within_function = &r_within_box_simple;
}
else {
this_box_volume.geometry.intersect_function = &sample_box_intersect_advanced;
this_box_volume.geometry.within_function = &r_within_box_advanced;
}

this_box_volume.geometry.shell_points = &box_shell_points;
this_box_volume.geometry.mcdisplay_function = &mcdisplay_box_function;
this_box_volume.geometry.initialize_from_main_function = &initialize_box_geometry_from_main_component;
this_box_volume.geometry.process_rot_allocated = 0;

this_box_volume.geometry.copy_geometry_parameters = &allocate_box_storage_copy;

rot_copy(this_box_volume.geometry.rotation_matrix,ROT_A_CURRENT_COMP); //check how ROT_R_CURRENT_COMP would work
rot_transpose(ROT_A_CURRENT_COMP,this_box_volume.geometry.transpose_rotation_matrix);

// Initialize loggers
this_box_volume.loggers.num_elements = 0;

// packing the information into the global_geometry_element, which is then included in the global_geometry_list.
sprintf(global_geometry_element.name,NAME_CURRENT_COMP);
global_geometry_element.activation_counter = number_of_activations;
global_geometry_element.component_index = INDEX_CURRENT_COMP;
global_geometry_element.Volume = &this_box_volume; // Would be nicer if this m was a pointer, now we have the (small) data two places
add_element_to_geometry_list(&global_geometry_list,global_geometry_element);
}
#line 268586 "MACS_sample_kidney_box.c"
#undef number_of_activations
#undef mask_setting
#undef mask_string
#undef p_interact
#undef focus_r
#undef focus_xh
#undef focus_xw
#undef focus_ah
#undef focus_aw
#undef target_z
#undef target_y
#undef target_x
#undef target_index
#undef visualize
#undef yheight2
#undef xwidth2
#undef zdepth
#undef yheight
#undef xwidth
#undef priority
#undef material_string
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

  /* Initializations for component inter_analyzer_colimator_11_blade_1. */
  SIG_MESSAGE("inter_analyzer_colimator_11_blade_1 (Init)");
#define mccompcurname  inter_analyzer_colimator_11_blade_1
#define mccompcurtype  Union_box
#define mccompcurindex 574
#define loop_index mccinter_analyzer_colimator_11_blade_1_loop_index
#define this_box_volume mccinter_analyzer_colimator_11_blade_1_this_box_volume
#define global_geometry_element mccinter_analyzer_colimator_11_blade_1_global_geometry_element
#define this_box_storage mccinter_analyzer_colimator_11_blade_1_this_box_storage
#define material_string mccinter_analyzer_colimator_11_blade_1_material_string
#define priority mccinter_analyzer_colimator_11_blade_1_priority
#define xwidth mccinter_analyzer_colimator_11_blade_1_xwidth
#define yheight mccinter_analyzer_colimator_11_blade_1_yheight
#define zdepth mccinter_analyzer_colimator_11_blade_1_zdepth
#define xwidth2 mccinter_analyzer_colimator_11_blade_1_xwidth2
#define yheight2 mccinter_analyzer_colimator_11_blade_1_yheight2
#define visualize mccinter_analyzer_colimator_11_blade_1_visualize
#define target_index mccinter_analyzer_colimator_11_blade_1_target_index
#define target_x mccinter_analyzer_colimator_11_blade_1_target_x
#define target_y mccinter_analyzer_colimator_11_blade_1_target_y
#define target_z mccinter_analyzer_colimator_11_blade_1_target_z
#define focus_aw mccinter_analyzer_colimator_11_blade_1_focus_aw
#define focus_ah mccinter_analyzer_colimator_11_blade_1_focus_ah
#define focus_xw mccinter_analyzer_colimator_11_blade_1_focus_xw
#define focus_xh mccinter_analyzer_colimator_11_blade_1_focus_xh
#define focus_r mccinter_analyzer_colimator_11_blade_1_focus_r
#define p_interact mccinter_analyzer_colimator_11_blade_1_p_interact
#define mask_string mccinter_analyzer_colimator_11_blade_1_mask_string
#define mask_setting mccinter_analyzer_colimator_11_blade_1_mask_setting
#define number_of_activations mccinter_analyzer_colimator_11_blade_1_number_of_activations
#line 224 "Union_box.comp"
{
// Initializes the focusing system for this volume including input sanitation.
focus_initialize(&this_box_volume.geometry, POS_A_COMP_INDEX(INDEX_CURRENT_COMP+target_index), POS_A_CURRENT_COMP, ROT_A_CURRENT_COMP, target_index, target_x, target_y, target_z, focus_aw, focus_ah, focus_xw, focus_xh, focus_r, NAME_CURRENT_COMP);

// Input sanitation for this geometry
if (xwidth <= 0) {
  printf("\nERROR in Union_box named %s, the xwidth is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (yheight <= 0) {
  printf("\nERROR in Union_box named %s, yheight is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (zdepth <= 0) {
  printf("\nERROR in Union_box named %s, zdepth is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (xwidth2 <= 0 && xwidth2 != -1) {
  printf("\nERROR in Union_box named %s, the xwidth2 is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (yheight2 <= 0 && yheight2 != -1) {
  printf("\nERROR in Union_box named %s, yheight2 is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}

// Use sanitation
if (global_material_list.num_elements == 0) {
  printf("\nERROR: Need to define a material using Union_make_material before using a Union geometry component. \n");
  printf("       %s was defined before first use of Union_make_material.\n",NAME_CURRENT_COMP);
  exit(1);
}

this_box_volume.geometry.is_masked_volume = 0;
this_box_volume.geometry.is_exit_volume = 0;
this_box_volume.geometry.is_mask_volume = 0;
// check if the volume is a mask, if it is the material string is irelevant.
if (mask_string && strlen(mask_string) && strcmp(mask_string, "NULL") && strcmp(mask_string, "0")) {
    // A mask volume is used to limit the extend of other volumes, called the masked volumes. These are specified in the mask_string.
    // In order for a ray to enter a masked volume, it needs to be both in the region covered by that volume AND the mask volume.
    // When more than
    this_box_volume.geometry.mask_mode = 1; // Default is mask mode is ALL
    if (mask_setting && strlen(mask_setting) && strcmp(mask_setting, "NULL") && strcmp(mask_setting, "0")) {
        if (strcmp(mask_setting,"ALL") == 0 || strcmp(mask_setting,"All") == 0) this_box_volume.geometry.mask_mode = 1;
        else if (strcmp(mask_setting,"ANY") == 0 || strcmp(mask_setting,"Any") == 0) this_box_volume.geometry.mask_mode = 2;
        else {
            printf("The mask_mode of component %s is set to %s, but must be either ALL or ANY.\n",NAME_CURRENT_COMP,mask_setting);
            exit(1);
        }
    }
    
    for (loop_index=0;loop_index<global_geometry_list.num_elements;loop_index++) {
        // Add mask list
        if (1 == manual_linking_function(global_geometry_list.elements[loop_index].name,mask_string)) {
            add_element_to_int_list(&this_box_volume.geometry.mask_list,global_geometry_list.elements[loop_index].component_index);
            add_element_to_int_list(&global_geometry_list.elements[loop_index].Volume->geometry.masked_by_list,INDEX_CURRENT_COMP);
            global_geometry_list.elements[loop_index].Volume->geometry.is_masked_volume = 1;
            if (this_box_volume.geometry.mask_mode == 2)
                global_geometry_list.elements[loop_index].Volume->geometry.mask_mode = 2;
            if (this_box_volume.geometry.mask_mode == 1) {
                if (global_geometry_list.elements[loop_index].Volume->geometry.is_masked_volume == 1 && global_geometry_list.elements[loop_index].Volume->geometry.mask_mode != 2)
                    // If more than one mask is added to one volume, the ANY mode overwrites the (default) ALL mode.
                    global_geometry_list.elements[loop_index].Volume->geometry.mask_mode = 1;
            }
            
            found_geometries = 1;
        }
    }
    if (found_geometries == 0) {
        printf("The mask_string in geometry: %s did not find any of the specified volumes in the mask_string %s \n",NAME_CURRENT_COMP,mask_string);
        exit(1);
    }
    this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
    this_box_volume.p_physics->is_vacuum = 0; // Makes this volume a vacuum
    this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
    this_box_volume.p_physics->my_a = 0; // Should not be used.
    sprintf(this_box_volume.p_physics->name,"Mask");
    this_box_volume.geometry.is_mask_volume = 1;
    
    
// Read the material input, or if it lacks, use automatic linking.
} else if (material_string && strlen(material_string) && strcmp(material_string, "NULL") && strcmp(material_string, "0")) {
    // A geometry string was given, use it to determine which material
    if (0 == strcmp(material_string,"vacuum") || 0 == strcmp(material_string,"Vacuum")) {
        // One could have a global physics struct for vacuum instead of creating one for each
        this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
        this_box_volume.p_physics->is_vacuum = 1; // Makes this volume a vacuum
        this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
        this_box_volume.p_physics->my_a = 0; // Should not be used.
        sprintf(this_box_volume.p_physics->name,"Vacuum");
    } else if (0 == strcmp(material_string,"exit") || 0 == strcmp(material_string,"Exit")) {
        // One could have a global physics struct for vacuum instead of creating one for each
        this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
        this_box_volume.p_physics->is_vacuum = 1; // Makes this volume a vacuum
        this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
        this_box_volume.p_physics->my_a = 0; // Should not be used.
        this_box_volume.geometry.is_exit_volume = 1;
        sprintf(this_box_volume.p_physics->name,"Exit");
    } else {
        #ifndef MATERIAL_DETECTOR
            printf("Need to define a material before refering to it in a geometry %s.\n",NAME_CURRENT_COMP);
            exit(1);
        #endif
        for (loop_index=0;loop_index<global_material_list.num_elements;loop_index++) {
            if (0 == strcmp(material_string,global_material_list.elements[loop_index].name)) {
                this_box_volume.p_physics = global_material_list.elements[loop_index].physics;
                break;
            }
            if (loop_index == global_material_list.num_elements-1) {
            printf("\n");
            printf("ERROR: The material string \"%s\" in Union geometry \"%s\" did not match a specified material. \n",material_string,NAME_CURRENT_COMP);
            printf("       The materials available at this point (need to be defined before the geometry): \n");
            for (loop_index=0;loop_index<global_material_list.num_elements;loop_index++)
              printf("         %s\n",global_material_list.elements[loop_index].name);
            printf("\n");
            printf("       It is also possible to use one of the defualt materials avaiable: \n");
            printf("           Vacuum (for a Volume without scattering or absorption)\n");
            printf("           Exit (for a Volume where the ray exits the component if it enters)\n");
            printf("           Mask (for a Volume that masks existing volumes specified in the mask_string\n");
            exit(1);
          }
        }
    }
} else {
    // Automatic linking, simply using the last defined material.
    #ifndef MATERIAL_DETECTOR
        printf("Need to define a material before the geometry to use automatic linking %s.\n",NAME_CURRENT_COMP);
        exit(1);
    #endif
    this_box_volume.p_physics = global_material_list.elements[global_material_list.num_elements-1].physics;
}

sprintf(this_box_volume.name,NAME_CURRENT_COMP);
sprintf(this_box_volume.geometry.shape,"box");
this_box_volume.geometry.priority_value = priority;
this_box_volume.geometry.geometry_p_interact = p_interact;
// Currently the coordinates will be in absolute space.
this_box_volume.geometry.center = POS_A_CURRENT_COMP;

this_box_storage.z_depth = zdepth;
this_box_storage.x_width1 = xwidth;
this_box_storage.y_height1 = yheight;

this_box_storage.is_rectangle = 0;
if (xwidth2 < 0 && yheight2 < 0) this_box_storage.is_rectangle = 1;
if (xwidth == xwidth2 && yheight == yheight2) this_box_storage.is_rectangle = 1;

if (xwidth2 < 0) {
    this_box_storage.x_width2 = xwidth;
    xwidth2 = xwidth;
} else this_box_storage.x_width2 = xwidth2;

if (yheight2 < 0) {
    this_box_storage.y_height2 = yheight;
    yheight2 = yheight;
} else this_box_storage.y_height2 = yheight2;


this_box_storage.normal_vectors[0] = coords_set(0,0,1);
this_box_storage.normal_vectors[1] = coords_set(0,0,1);

// for sides with y component = 0
x_component = 2*zdepth/sqrt((xwidth-xwidth2)*(xwidth-xwidth2)+4*zdepth*zdepth);
z_component = (xwidth-xwidth2)/sqrt(4*zdepth*zdepth+(xwidth-xwidth2)*(xwidth-xwidth2));

this_box_storage.normal_vectors[2] = coords_set(x_component,0,z_component);
this_box_storage.normal_vectors[3] = coords_set(-x_component,0,z_component);

// for sides with x component = 0
y_component = 2*zdepth/sqrt((yheight-yheight2)*(yheight-yheight2)+4*zdepth*zdepth);
z_component = (yheight-yheight2)/sqrt(4*zdepth*zdepth+(yheight-yheight2)*(yheight-yheight2));

this_box_storage.normal_vectors[4] = coords_set(0,y_component,z_component);
this_box_storage.normal_vectors[5] = coords_set(0,-y_component,z_component);

this_box_volume.geometry.visualization_on = visualize;

this_box_volume.geometry.geometry_parameters.p_box_storage = &this_box_storage;

// Assign pointers to functions for intersection with the shape, checking if a point is inside the shape
if (this_box_storage.is_rectangle == 1) {
this_box_volume.geometry.intersect_function = &sample_box_intersect_simple;
this_box_volume.geometry.within_function = &r_within_box_simple;
}
else {
this_box_volume.geometry.intersect_function = &sample_box_intersect_advanced;
this_box_volume.geometry.within_function = &r_within_box_advanced;
}

this_box_volume.geometry.shell_points = &box_shell_points;
this_box_volume.geometry.mcdisplay_function = &mcdisplay_box_function;
this_box_volume.geometry.initialize_from_main_function = &initialize_box_geometry_from_main_component;
this_box_volume.geometry.process_rot_allocated = 0;

this_box_volume.geometry.copy_geometry_parameters = &allocate_box_storage_copy;

rot_copy(this_box_volume.geometry.rotation_matrix,ROT_A_CURRENT_COMP); //check how ROT_R_CURRENT_COMP would work
rot_transpose(ROT_A_CURRENT_COMP,this_box_volume.geometry.transpose_rotation_matrix);

// Initialize loggers
this_box_volume.loggers.num_elements = 0;

// packing the information into the global_geometry_element, which is then included in the global_geometry_list.
sprintf(global_geometry_element.name,NAME_CURRENT_COMP);
global_geometry_element.activation_counter = number_of_activations;
global_geometry_element.component_index = INDEX_CURRENT_COMP;
global_geometry_element.Volume = &this_box_volume; // Would be nicer if this m was a pointer, now we have the (small) data two places
add_element_to_geometry_list(&global_geometry_list,global_geometry_element);
}
#line 268856 "MACS_sample_kidney_box.c"
#undef number_of_activations
#undef mask_setting
#undef mask_string
#undef p_interact
#undef focus_r
#undef focus_xh
#undef focus_xw
#undef focus_ah
#undef focus_aw
#undef target_z
#undef target_y
#undef target_x
#undef target_index
#undef visualize
#undef yheight2
#undef xwidth2
#undef zdepth
#undef yheight
#undef xwidth
#undef priority
#undef material_string
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

  /* Initializations for component inter_analyzer_colimator_11_blade_2. */
  SIG_MESSAGE("inter_analyzer_colimator_11_blade_2 (Init)");
#define mccompcurname  inter_analyzer_colimator_11_blade_2
#define mccompcurtype  Union_box
#define mccompcurindex 575
#define loop_index mccinter_analyzer_colimator_11_blade_2_loop_index
#define this_box_volume mccinter_analyzer_colimator_11_blade_2_this_box_volume
#define global_geometry_element mccinter_analyzer_colimator_11_blade_2_global_geometry_element
#define this_box_storage mccinter_analyzer_colimator_11_blade_2_this_box_storage
#define material_string mccinter_analyzer_colimator_11_blade_2_material_string
#define priority mccinter_analyzer_colimator_11_blade_2_priority
#define xwidth mccinter_analyzer_colimator_11_blade_2_xwidth
#define yheight mccinter_analyzer_colimator_11_blade_2_yheight
#define zdepth mccinter_analyzer_colimator_11_blade_2_zdepth
#define xwidth2 mccinter_analyzer_colimator_11_blade_2_xwidth2
#define yheight2 mccinter_analyzer_colimator_11_blade_2_yheight2
#define visualize mccinter_analyzer_colimator_11_blade_2_visualize
#define target_index mccinter_analyzer_colimator_11_blade_2_target_index
#define target_x mccinter_analyzer_colimator_11_blade_2_target_x
#define target_y mccinter_analyzer_colimator_11_blade_2_target_y
#define target_z mccinter_analyzer_colimator_11_blade_2_target_z
#define focus_aw mccinter_analyzer_colimator_11_blade_2_focus_aw
#define focus_ah mccinter_analyzer_colimator_11_blade_2_focus_ah
#define focus_xw mccinter_analyzer_colimator_11_blade_2_focus_xw
#define focus_xh mccinter_analyzer_colimator_11_blade_2_focus_xh
#define focus_r mccinter_analyzer_colimator_11_blade_2_focus_r
#define p_interact mccinter_analyzer_colimator_11_blade_2_p_interact
#define mask_string mccinter_analyzer_colimator_11_blade_2_mask_string
#define mask_setting mccinter_analyzer_colimator_11_blade_2_mask_setting
#define number_of_activations mccinter_analyzer_colimator_11_blade_2_number_of_activations
#line 224 "Union_box.comp"
{
// Initializes the focusing system for this volume including input sanitation.
focus_initialize(&this_box_volume.geometry, POS_A_COMP_INDEX(INDEX_CURRENT_COMP+target_index), POS_A_CURRENT_COMP, ROT_A_CURRENT_COMP, target_index, target_x, target_y, target_z, focus_aw, focus_ah, focus_xw, focus_xh, focus_r, NAME_CURRENT_COMP);

// Input sanitation for this geometry
if (xwidth <= 0) {
  printf("\nERROR in Union_box named %s, the xwidth is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (yheight <= 0) {
  printf("\nERROR in Union_box named %s, yheight is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (zdepth <= 0) {
  printf("\nERROR in Union_box named %s, zdepth is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (xwidth2 <= 0 && xwidth2 != -1) {
  printf("\nERROR in Union_box named %s, the xwidth2 is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (yheight2 <= 0 && yheight2 != -1) {
  printf("\nERROR in Union_box named %s, yheight2 is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}

// Use sanitation
if (global_material_list.num_elements == 0) {
  printf("\nERROR: Need to define a material using Union_make_material before using a Union geometry component. \n");
  printf("       %s was defined before first use of Union_make_material.\n",NAME_CURRENT_COMP);
  exit(1);
}

this_box_volume.geometry.is_masked_volume = 0;
this_box_volume.geometry.is_exit_volume = 0;
this_box_volume.geometry.is_mask_volume = 0;
// check if the volume is a mask, if it is the material string is irelevant.
if (mask_string && strlen(mask_string) && strcmp(mask_string, "NULL") && strcmp(mask_string, "0")) {
    // A mask volume is used to limit the extend of other volumes, called the masked volumes. These are specified in the mask_string.
    // In order for a ray to enter a masked volume, it needs to be both in the region covered by that volume AND the mask volume.
    // When more than
    this_box_volume.geometry.mask_mode = 1; // Default is mask mode is ALL
    if (mask_setting && strlen(mask_setting) && strcmp(mask_setting, "NULL") && strcmp(mask_setting, "0")) {
        if (strcmp(mask_setting,"ALL") == 0 || strcmp(mask_setting,"All") == 0) this_box_volume.geometry.mask_mode = 1;
        else if (strcmp(mask_setting,"ANY") == 0 || strcmp(mask_setting,"Any") == 0) this_box_volume.geometry.mask_mode = 2;
        else {
            printf("The mask_mode of component %s is set to %s, but must be either ALL or ANY.\n",NAME_CURRENT_COMP,mask_setting);
            exit(1);
        }
    }
    
    for (loop_index=0;loop_index<global_geometry_list.num_elements;loop_index++) {
        // Add mask list
        if (1 == manual_linking_function(global_geometry_list.elements[loop_index].name,mask_string)) {
            add_element_to_int_list(&this_box_volume.geometry.mask_list,global_geometry_list.elements[loop_index].component_index);
            add_element_to_int_list(&global_geometry_list.elements[loop_index].Volume->geometry.masked_by_list,INDEX_CURRENT_COMP);
            global_geometry_list.elements[loop_index].Volume->geometry.is_masked_volume = 1;
            if (this_box_volume.geometry.mask_mode == 2)
                global_geometry_list.elements[loop_index].Volume->geometry.mask_mode = 2;
            if (this_box_volume.geometry.mask_mode == 1) {
                if (global_geometry_list.elements[loop_index].Volume->geometry.is_masked_volume == 1 && global_geometry_list.elements[loop_index].Volume->geometry.mask_mode != 2)
                    // If more than one mask is added to one volume, the ANY mode overwrites the (default) ALL mode.
                    global_geometry_list.elements[loop_index].Volume->geometry.mask_mode = 1;
            }
            
            found_geometries = 1;
        }
    }
    if (found_geometries == 0) {
        printf("The mask_string in geometry: %s did not find any of the specified volumes in the mask_string %s \n",NAME_CURRENT_COMP,mask_string);
        exit(1);
    }
    this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
    this_box_volume.p_physics->is_vacuum = 0; // Makes this volume a vacuum
    this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
    this_box_volume.p_physics->my_a = 0; // Should not be used.
    sprintf(this_box_volume.p_physics->name,"Mask");
    this_box_volume.geometry.is_mask_volume = 1;
    
    
// Read the material input, or if it lacks, use automatic linking.
} else if (material_string && strlen(material_string) && strcmp(material_string, "NULL") && strcmp(material_string, "0")) {
    // A geometry string was given, use it to determine which material
    if (0 == strcmp(material_string,"vacuum") || 0 == strcmp(material_string,"Vacuum")) {
        // One could have a global physics struct for vacuum instead of creating one for each
        this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
        this_box_volume.p_physics->is_vacuum = 1; // Makes this volume a vacuum
        this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
        this_box_volume.p_physics->my_a = 0; // Should not be used.
        sprintf(this_box_volume.p_physics->name,"Vacuum");
    } else if (0 == strcmp(material_string,"exit") || 0 == strcmp(material_string,"Exit")) {
        // One could have a global physics struct for vacuum instead of creating one for each
        this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
        this_box_volume.p_physics->is_vacuum = 1; // Makes this volume a vacuum
        this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
        this_box_volume.p_physics->my_a = 0; // Should not be used.
        this_box_volume.geometry.is_exit_volume = 1;
        sprintf(this_box_volume.p_physics->name,"Exit");
    } else {
        #ifndef MATERIAL_DETECTOR
            printf("Need to define a material before refering to it in a geometry %s.\n",NAME_CURRENT_COMP);
            exit(1);
        #endif
        for (loop_index=0;loop_index<global_material_list.num_elements;loop_index++) {
            if (0 == strcmp(material_string,global_material_list.elements[loop_index].name)) {
                this_box_volume.p_physics = global_material_list.elements[loop_index].physics;
                break;
            }
            if (loop_index == global_material_list.num_elements-1) {
            printf("\n");
            printf("ERROR: The material string \"%s\" in Union geometry \"%s\" did not match a specified material. \n",material_string,NAME_CURRENT_COMP);
            printf("       The materials available at this point (need to be defined before the geometry): \n");
            for (loop_index=0;loop_index<global_material_list.num_elements;loop_index++)
              printf("         %s\n",global_material_list.elements[loop_index].name);
            printf("\n");
            printf("       It is also possible to use one of the defualt materials avaiable: \n");
            printf("           Vacuum (for a Volume without scattering or absorption)\n");
            printf("           Exit (for a Volume where the ray exits the component if it enters)\n");
            printf("           Mask (for a Volume that masks existing volumes specified in the mask_string\n");
            exit(1);
          }
        }
    }
} else {
    // Automatic linking, simply using the last defined material.
    #ifndef MATERIAL_DETECTOR
        printf("Need to define a material before the geometry to use automatic linking %s.\n",NAME_CURRENT_COMP);
        exit(1);
    #endif
    this_box_volume.p_physics = global_material_list.elements[global_material_list.num_elements-1].physics;
}

sprintf(this_box_volume.name,NAME_CURRENT_COMP);
sprintf(this_box_volume.geometry.shape,"box");
this_box_volume.geometry.priority_value = priority;
this_box_volume.geometry.geometry_p_interact = p_interact;
// Currently the coordinates will be in absolute space.
this_box_volume.geometry.center = POS_A_CURRENT_COMP;

this_box_storage.z_depth = zdepth;
this_box_storage.x_width1 = xwidth;
this_box_storage.y_height1 = yheight;

this_box_storage.is_rectangle = 0;
if (xwidth2 < 0 && yheight2 < 0) this_box_storage.is_rectangle = 1;
if (xwidth == xwidth2 && yheight == yheight2) this_box_storage.is_rectangle = 1;

if (xwidth2 < 0) {
    this_box_storage.x_width2 = xwidth;
    xwidth2 = xwidth;
} else this_box_storage.x_width2 = xwidth2;

if (yheight2 < 0) {
    this_box_storage.y_height2 = yheight;
    yheight2 = yheight;
} else this_box_storage.y_height2 = yheight2;


this_box_storage.normal_vectors[0] = coords_set(0,0,1);
this_box_storage.normal_vectors[1] = coords_set(0,0,1);

// for sides with y component = 0
x_component = 2*zdepth/sqrt((xwidth-xwidth2)*(xwidth-xwidth2)+4*zdepth*zdepth);
z_component = (xwidth-xwidth2)/sqrt(4*zdepth*zdepth+(xwidth-xwidth2)*(xwidth-xwidth2));

this_box_storage.normal_vectors[2] = coords_set(x_component,0,z_component);
this_box_storage.normal_vectors[3] = coords_set(-x_component,0,z_component);

// for sides with x component = 0
y_component = 2*zdepth/sqrt((yheight-yheight2)*(yheight-yheight2)+4*zdepth*zdepth);
z_component = (yheight-yheight2)/sqrt(4*zdepth*zdepth+(yheight-yheight2)*(yheight-yheight2));

this_box_storage.normal_vectors[4] = coords_set(0,y_component,z_component);
this_box_storage.normal_vectors[5] = coords_set(0,-y_component,z_component);

this_box_volume.geometry.visualization_on = visualize;

this_box_volume.geometry.geometry_parameters.p_box_storage = &this_box_storage;

// Assign pointers to functions for intersection with the shape, checking if a point is inside the shape
if (this_box_storage.is_rectangle == 1) {
this_box_volume.geometry.intersect_function = &sample_box_intersect_simple;
this_box_volume.geometry.within_function = &r_within_box_simple;
}
else {
this_box_volume.geometry.intersect_function = &sample_box_intersect_advanced;
this_box_volume.geometry.within_function = &r_within_box_advanced;
}

this_box_volume.geometry.shell_points = &box_shell_points;
this_box_volume.geometry.mcdisplay_function = &mcdisplay_box_function;
this_box_volume.geometry.initialize_from_main_function = &initialize_box_geometry_from_main_component;
this_box_volume.geometry.process_rot_allocated = 0;

this_box_volume.geometry.copy_geometry_parameters = &allocate_box_storage_copy;

rot_copy(this_box_volume.geometry.rotation_matrix,ROT_A_CURRENT_COMP); //check how ROT_R_CURRENT_COMP would work
rot_transpose(ROT_A_CURRENT_COMP,this_box_volume.geometry.transpose_rotation_matrix);

// Initialize loggers
this_box_volume.loggers.num_elements = 0;

// packing the information into the global_geometry_element, which is then included in the global_geometry_list.
sprintf(global_geometry_element.name,NAME_CURRENT_COMP);
global_geometry_element.activation_counter = number_of_activations;
global_geometry_element.component_index = INDEX_CURRENT_COMP;
global_geometry_element.Volume = &this_box_volume; // Would be nicer if this m was a pointer, now we have the (small) data two places
add_element_to_geometry_list(&global_geometry_list,global_geometry_element);
}
#line 269126 "MACS_sample_kidney_box.c"
#undef number_of_activations
#undef mask_setting
#undef mask_string
#undef p_interact
#undef focus_r
#undef focus_xh
#undef focus_xw
#undef focus_ah
#undef focus_aw
#undef target_z
#undef target_y
#undef target_x
#undef target_index
#undef visualize
#undef yheight2
#undef xwidth2
#undef zdepth
#undef yheight
#undef xwidth
#undef priority
#undef material_string
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

  /* Initializations for component inter_analyzer_colimator_11_blade_3. */
  SIG_MESSAGE("inter_analyzer_colimator_11_blade_3 (Init)");
#define mccompcurname  inter_analyzer_colimator_11_blade_3
#define mccompcurtype  Union_box
#define mccompcurindex 576
#define loop_index mccinter_analyzer_colimator_11_blade_3_loop_index
#define this_box_volume mccinter_analyzer_colimator_11_blade_3_this_box_volume
#define global_geometry_element mccinter_analyzer_colimator_11_blade_3_global_geometry_element
#define this_box_storage mccinter_analyzer_colimator_11_blade_3_this_box_storage
#define material_string mccinter_analyzer_colimator_11_blade_3_material_string
#define priority mccinter_analyzer_colimator_11_blade_3_priority
#define xwidth mccinter_analyzer_colimator_11_blade_3_xwidth
#define yheight mccinter_analyzer_colimator_11_blade_3_yheight
#define zdepth mccinter_analyzer_colimator_11_blade_3_zdepth
#define xwidth2 mccinter_analyzer_colimator_11_blade_3_xwidth2
#define yheight2 mccinter_analyzer_colimator_11_blade_3_yheight2
#define visualize mccinter_analyzer_colimator_11_blade_3_visualize
#define target_index mccinter_analyzer_colimator_11_blade_3_target_index
#define target_x mccinter_analyzer_colimator_11_blade_3_target_x
#define target_y mccinter_analyzer_colimator_11_blade_3_target_y
#define target_z mccinter_analyzer_colimator_11_blade_3_target_z
#define focus_aw mccinter_analyzer_colimator_11_blade_3_focus_aw
#define focus_ah mccinter_analyzer_colimator_11_blade_3_focus_ah
#define focus_xw mccinter_analyzer_colimator_11_blade_3_focus_xw
#define focus_xh mccinter_analyzer_colimator_11_blade_3_focus_xh
#define focus_r mccinter_analyzer_colimator_11_blade_3_focus_r
#define p_interact mccinter_analyzer_colimator_11_blade_3_p_interact
#define mask_string mccinter_analyzer_colimator_11_blade_3_mask_string
#define mask_setting mccinter_analyzer_colimator_11_blade_3_mask_setting
#define number_of_activations mccinter_analyzer_colimator_11_blade_3_number_of_activations
#line 224 "Union_box.comp"
{
// Initializes the focusing system for this volume including input sanitation.
focus_initialize(&this_box_volume.geometry, POS_A_COMP_INDEX(INDEX_CURRENT_COMP+target_index), POS_A_CURRENT_COMP, ROT_A_CURRENT_COMP, target_index, target_x, target_y, target_z, focus_aw, focus_ah, focus_xw, focus_xh, focus_r, NAME_CURRENT_COMP);

// Input sanitation for this geometry
if (xwidth <= 0) {
  printf("\nERROR in Union_box named %s, the xwidth is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (yheight <= 0) {
  printf("\nERROR in Union_box named %s, yheight is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (zdepth <= 0) {
  printf("\nERROR in Union_box named %s, zdepth is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (xwidth2 <= 0 && xwidth2 != -1) {
  printf("\nERROR in Union_box named %s, the xwidth2 is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (yheight2 <= 0 && yheight2 != -1) {
  printf("\nERROR in Union_box named %s, yheight2 is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}

// Use sanitation
if (global_material_list.num_elements == 0) {
  printf("\nERROR: Need to define a material using Union_make_material before using a Union geometry component. \n");
  printf("       %s was defined before first use of Union_make_material.\n",NAME_CURRENT_COMP);
  exit(1);
}

this_box_volume.geometry.is_masked_volume = 0;
this_box_volume.geometry.is_exit_volume = 0;
this_box_volume.geometry.is_mask_volume = 0;
// check if the volume is a mask, if it is the material string is irelevant.
if (mask_string && strlen(mask_string) && strcmp(mask_string, "NULL") && strcmp(mask_string, "0")) {
    // A mask volume is used to limit the extend of other volumes, called the masked volumes. These are specified in the mask_string.
    // In order for a ray to enter a masked volume, it needs to be both in the region covered by that volume AND the mask volume.
    // When more than
    this_box_volume.geometry.mask_mode = 1; // Default is mask mode is ALL
    if (mask_setting && strlen(mask_setting) && strcmp(mask_setting, "NULL") && strcmp(mask_setting, "0")) {
        if (strcmp(mask_setting,"ALL") == 0 || strcmp(mask_setting,"All") == 0) this_box_volume.geometry.mask_mode = 1;
        else if (strcmp(mask_setting,"ANY") == 0 || strcmp(mask_setting,"Any") == 0) this_box_volume.geometry.mask_mode = 2;
        else {
            printf("The mask_mode of component %s is set to %s, but must be either ALL or ANY.\n",NAME_CURRENT_COMP,mask_setting);
            exit(1);
        }
    }
    
    for (loop_index=0;loop_index<global_geometry_list.num_elements;loop_index++) {
        // Add mask list
        if (1 == manual_linking_function(global_geometry_list.elements[loop_index].name,mask_string)) {
            add_element_to_int_list(&this_box_volume.geometry.mask_list,global_geometry_list.elements[loop_index].component_index);
            add_element_to_int_list(&global_geometry_list.elements[loop_index].Volume->geometry.masked_by_list,INDEX_CURRENT_COMP);
            global_geometry_list.elements[loop_index].Volume->geometry.is_masked_volume = 1;
            if (this_box_volume.geometry.mask_mode == 2)
                global_geometry_list.elements[loop_index].Volume->geometry.mask_mode = 2;
            if (this_box_volume.geometry.mask_mode == 1) {
                if (global_geometry_list.elements[loop_index].Volume->geometry.is_masked_volume == 1 && global_geometry_list.elements[loop_index].Volume->geometry.mask_mode != 2)
                    // If more than one mask is added to one volume, the ANY mode overwrites the (default) ALL mode.
                    global_geometry_list.elements[loop_index].Volume->geometry.mask_mode = 1;
            }
            
            found_geometries = 1;
        }
    }
    if (found_geometries == 0) {
        printf("The mask_string in geometry: %s did not find any of the specified volumes in the mask_string %s \n",NAME_CURRENT_COMP,mask_string);
        exit(1);
    }
    this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
    this_box_volume.p_physics->is_vacuum = 0; // Makes this volume a vacuum
    this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
    this_box_volume.p_physics->my_a = 0; // Should not be used.
    sprintf(this_box_volume.p_physics->name,"Mask");
    this_box_volume.geometry.is_mask_volume = 1;
    
    
// Read the material input, or if it lacks, use automatic linking.
} else if (material_string && strlen(material_string) && strcmp(material_string, "NULL") && strcmp(material_string, "0")) {
    // A geometry string was given, use it to determine which material
    if (0 == strcmp(material_string,"vacuum") || 0 == strcmp(material_string,"Vacuum")) {
        // One could have a global physics struct for vacuum instead of creating one for each
        this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
        this_box_volume.p_physics->is_vacuum = 1; // Makes this volume a vacuum
        this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
        this_box_volume.p_physics->my_a = 0; // Should not be used.
        sprintf(this_box_volume.p_physics->name,"Vacuum");
    } else if (0 == strcmp(material_string,"exit") || 0 == strcmp(material_string,"Exit")) {
        // One could have a global physics struct for vacuum instead of creating one for each
        this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
        this_box_volume.p_physics->is_vacuum = 1; // Makes this volume a vacuum
        this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
        this_box_volume.p_physics->my_a = 0; // Should not be used.
        this_box_volume.geometry.is_exit_volume = 1;
        sprintf(this_box_volume.p_physics->name,"Exit");
    } else {
        #ifndef MATERIAL_DETECTOR
            printf("Need to define a material before refering to it in a geometry %s.\n",NAME_CURRENT_COMP);
            exit(1);
        #endif
        for (loop_index=0;loop_index<global_material_list.num_elements;loop_index++) {
            if (0 == strcmp(material_string,global_material_list.elements[loop_index].name)) {
                this_box_volume.p_physics = global_material_list.elements[loop_index].physics;
                break;
            }
            if (loop_index == global_material_list.num_elements-1) {
            printf("\n");
            printf("ERROR: The material string \"%s\" in Union geometry \"%s\" did not match a specified material. \n",material_string,NAME_CURRENT_COMP);
            printf("       The materials available at this point (need to be defined before the geometry): \n");
            for (loop_index=0;loop_index<global_material_list.num_elements;loop_index++)
              printf("         %s\n",global_material_list.elements[loop_index].name);
            printf("\n");
            printf("       It is also possible to use one of the defualt materials avaiable: \n");
            printf("           Vacuum (for a Volume without scattering or absorption)\n");
            printf("           Exit (for a Volume where the ray exits the component if it enters)\n");
            printf("           Mask (for a Volume that masks existing volumes specified in the mask_string\n");
            exit(1);
          }
        }
    }
} else {
    // Automatic linking, simply using the last defined material.
    #ifndef MATERIAL_DETECTOR
        printf("Need to define a material before the geometry to use automatic linking %s.\n",NAME_CURRENT_COMP);
        exit(1);
    #endif
    this_box_volume.p_physics = global_material_list.elements[global_material_list.num_elements-1].physics;
}

sprintf(this_box_volume.name,NAME_CURRENT_COMP);
sprintf(this_box_volume.geometry.shape,"box");
this_box_volume.geometry.priority_value = priority;
this_box_volume.geometry.geometry_p_interact = p_interact;
// Currently the coordinates will be in absolute space.
this_box_volume.geometry.center = POS_A_CURRENT_COMP;

this_box_storage.z_depth = zdepth;
this_box_storage.x_width1 = xwidth;
this_box_storage.y_height1 = yheight;

this_box_storage.is_rectangle = 0;
if (xwidth2 < 0 && yheight2 < 0) this_box_storage.is_rectangle = 1;
if (xwidth == xwidth2 && yheight == yheight2) this_box_storage.is_rectangle = 1;

if (xwidth2 < 0) {
    this_box_storage.x_width2 = xwidth;
    xwidth2 = xwidth;
} else this_box_storage.x_width2 = xwidth2;

if (yheight2 < 0) {
    this_box_storage.y_height2 = yheight;
    yheight2 = yheight;
} else this_box_storage.y_height2 = yheight2;


this_box_storage.normal_vectors[0] = coords_set(0,0,1);
this_box_storage.normal_vectors[1] = coords_set(0,0,1);

// for sides with y component = 0
x_component = 2*zdepth/sqrt((xwidth-xwidth2)*(xwidth-xwidth2)+4*zdepth*zdepth);
z_component = (xwidth-xwidth2)/sqrt(4*zdepth*zdepth+(xwidth-xwidth2)*(xwidth-xwidth2));

this_box_storage.normal_vectors[2] = coords_set(x_component,0,z_component);
this_box_storage.normal_vectors[3] = coords_set(-x_component,0,z_component);

// for sides with x component = 0
y_component = 2*zdepth/sqrt((yheight-yheight2)*(yheight-yheight2)+4*zdepth*zdepth);
z_component = (yheight-yheight2)/sqrt(4*zdepth*zdepth+(yheight-yheight2)*(yheight-yheight2));

this_box_storage.normal_vectors[4] = coords_set(0,y_component,z_component);
this_box_storage.normal_vectors[5] = coords_set(0,-y_component,z_component);

this_box_volume.geometry.visualization_on = visualize;

this_box_volume.geometry.geometry_parameters.p_box_storage = &this_box_storage;

// Assign pointers to functions for intersection with the shape, checking if a point is inside the shape
if (this_box_storage.is_rectangle == 1) {
this_box_volume.geometry.intersect_function = &sample_box_intersect_simple;
this_box_volume.geometry.within_function = &r_within_box_simple;
}
else {
this_box_volume.geometry.intersect_function = &sample_box_intersect_advanced;
this_box_volume.geometry.within_function = &r_within_box_advanced;
}

this_box_volume.geometry.shell_points = &box_shell_points;
this_box_volume.geometry.mcdisplay_function = &mcdisplay_box_function;
this_box_volume.geometry.initialize_from_main_function = &initialize_box_geometry_from_main_component;
this_box_volume.geometry.process_rot_allocated = 0;

this_box_volume.geometry.copy_geometry_parameters = &allocate_box_storage_copy;

rot_copy(this_box_volume.geometry.rotation_matrix,ROT_A_CURRENT_COMP); //check how ROT_R_CURRENT_COMP would work
rot_transpose(ROT_A_CURRENT_COMP,this_box_volume.geometry.transpose_rotation_matrix);

// Initialize loggers
this_box_volume.loggers.num_elements = 0;

// packing the information into the global_geometry_element, which is then included in the global_geometry_list.
sprintf(global_geometry_element.name,NAME_CURRENT_COMP);
global_geometry_element.activation_counter = number_of_activations;
global_geometry_element.component_index = INDEX_CURRENT_COMP;
global_geometry_element.Volume = &this_box_volume; // Would be nicer if this m was a pointer, now we have the (small) data two places
add_element_to_geometry_list(&global_geometry_list,global_geometry_element);
}
#line 269396 "MACS_sample_kidney_box.c"
#undef number_of_activations
#undef mask_setting
#undef mask_string
#undef p_interact
#undef focus_r
#undef focus_xh
#undef focus_xw
#undef focus_ah
#undef focus_aw
#undef target_z
#undef target_y
#undef target_x
#undef target_index
#undef visualize
#undef yheight2
#undef xwidth2
#undef zdepth
#undef yheight
#undef xwidth
#undef priority
#undef material_string
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

  /* Initializations for component inter_analyzer_colimator_11_blade_4. */
  SIG_MESSAGE("inter_analyzer_colimator_11_blade_4 (Init)");
#define mccompcurname  inter_analyzer_colimator_11_blade_4
#define mccompcurtype  Union_box
#define mccompcurindex 577
#define loop_index mccinter_analyzer_colimator_11_blade_4_loop_index
#define this_box_volume mccinter_analyzer_colimator_11_blade_4_this_box_volume
#define global_geometry_element mccinter_analyzer_colimator_11_blade_4_global_geometry_element
#define this_box_storage mccinter_analyzer_colimator_11_blade_4_this_box_storage
#define material_string mccinter_analyzer_colimator_11_blade_4_material_string
#define priority mccinter_analyzer_colimator_11_blade_4_priority
#define xwidth mccinter_analyzer_colimator_11_blade_4_xwidth
#define yheight mccinter_analyzer_colimator_11_blade_4_yheight
#define zdepth mccinter_analyzer_colimator_11_blade_4_zdepth
#define xwidth2 mccinter_analyzer_colimator_11_blade_4_xwidth2
#define yheight2 mccinter_analyzer_colimator_11_blade_4_yheight2
#define visualize mccinter_analyzer_colimator_11_blade_4_visualize
#define target_index mccinter_analyzer_colimator_11_blade_4_target_index
#define target_x mccinter_analyzer_colimator_11_blade_4_target_x
#define target_y mccinter_analyzer_colimator_11_blade_4_target_y
#define target_z mccinter_analyzer_colimator_11_blade_4_target_z
#define focus_aw mccinter_analyzer_colimator_11_blade_4_focus_aw
#define focus_ah mccinter_analyzer_colimator_11_blade_4_focus_ah
#define focus_xw mccinter_analyzer_colimator_11_blade_4_focus_xw
#define focus_xh mccinter_analyzer_colimator_11_blade_4_focus_xh
#define focus_r mccinter_analyzer_colimator_11_blade_4_focus_r
#define p_interact mccinter_analyzer_colimator_11_blade_4_p_interact
#define mask_string mccinter_analyzer_colimator_11_blade_4_mask_string
#define mask_setting mccinter_analyzer_colimator_11_blade_4_mask_setting
#define number_of_activations mccinter_analyzer_colimator_11_blade_4_number_of_activations
#line 224 "Union_box.comp"
{
// Initializes the focusing system for this volume including input sanitation.
focus_initialize(&this_box_volume.geometry, POS_A_COMP_INDEX(INDEX_CURRENT_COMP+target_index), POS_A_CURRENT_COMP, ROT_A_CURRENT_COMP, target_index, target_x, target_y, target_z, focus_aw, focus_ah, focus_xw, focus_xh, focus_r, NAME_CURRENT_COMP);

// Input sanitation for this geometry
if (xwidth <= 0) {
  printf("\nERROR in Union_box named %s, the xwidth is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (yheight <= 0) {
  printf("\nERROR in Union_box named %s, yheight is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (zdepth <= 0) {
  printf("\nERROR in Union_box named %s, zdepth is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (xwidth2 <= 0 && xwidth2 != -1) {
  printf("\nERROR in Union_box named %s, the xwidth2 is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (yheight2 <= 0 && yheight2 != -1) {
  printf("\nERROR in Union_box named %s, yheight2 is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}

// Use sanitation
if (global_material_list.num_elements == 0) {
  printf("\nERROR: Need to define a material using Union_make_material before using a Union geometry component. \n");
  printf("       %s was defined before first use of Union_make_material.\n",NAME_CURRENT_COMP);
  exit(1);
}

this_box_volume.geometry.is_masked_volume = 0;
this_box_volume.geometry.is_exit_volume = 0;
this_box_volume.geometry.is_mask_volume = 0;
// check if the volume is a mask, if it is the material string is irelevant.
if (mask_string && strlen(mask_string) && strcmp(mask_string, "NULL") && strcmp(mask_string, "0")) {
    // A mask volume is used to limit the extend of other volumes, called the masked volumes. These are specified in the mask_string.
    // In order for a ray to enter a masked volume, it needs to be both in the region covered by that volume AND the mask volume.
    // When more than
    this_box_volume.geometry.mask_mode = 1; // Default is mask mode is ALL
    if (mask_setting && strlen(mask_setting) && strcmp(mask_setting, "NULL") && strcmp(mask_setting, "0")) {
        if (strcmp(mask_setting,"ALL") == 0 || strcmp(mask_setting,"All") == 0) this_box_volume.geometry.mask_mode = 1;
        else if (strcmp(mask_setting,"ANY") == 0 || strcmp(mask_setting,"Any") == 0) this_box_volume.geometry.mask_mode = 2;
        else {
            printf("The mask_mode of component %s is set to %s, but must be either ALL or ANY.\n",NAME_CURRENT_COMP,mask_setting);
            exit(1);
        }
    }
    
    for (loop_index=0;loop_index<global_geometry_list.num_elements;loop_index++) {
        // Add mask list
        if (1 == manual_linking_function(global_geometry_list.elements[loop_index].name,mask_string)) {
            add_element_to_int_list(&this_box_volume.geometry.mask_list,global_geometry_list.elements[loop_index].component_index);
            add_element_to_int_list(&global_geometry_list.elements[loop_index].Volume->geometry.masked_by_list,INDEX_CURRENT_COMP);
            global_geometry_list.elements[loop_index].Volume->geometry.is_masked_volume = 1;
            if (this_box_volume.geometry.mask_mode == 2)
                global_geometry_list.elements[loop_index].Volume->geometry.mask_mode = 2;
            if (this_box_volume.geometry.mask_mode == 1) {
                if (global_geometry_list.elements[loop_index].Volume->geometry.is_masked_volume == 1 && global_geometry_list.elements[loop_index].Volume->geometry.mask_mode != 2)
                    // If more than one mask is added to one volume, the ANY mode overwrites the (default) ALL mode.
                    global_geometry_list.elements[loop_index].Volume->geometry.mask_mode = 1;
            }
            
            found_geometries = 1;
        }
    }
    if (found_geometries == 0) {
        printf("The mask_string in geometry: %s did not find any of the specified volumes in the mask_string %s \n",NAME_CURRENT_COMP,mask_string);
        exit(1);
    }
    this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
    this_box_volume.p_physics->is_vacuum = 0; // Makes this volume a vacuum
    this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
    this_box_volume.p_physics->my_a = 0; // Should not be used.
    sprintf(this_box_volume.p_physics->name,"Mask");
    this_box_volume.geometry.is_mask_volume = 1;
    
    
// Read the material input, or if it lacks, use automatic linking.
} else if (material_string && strlen(material_string) && strcmp(material_string, "NULL") && strcmp(material_string, "0")) {
    // A geometry string was given, use it to determine which material
    if (0 == strcmp(material_string,"vacuum") || 0 == strcmp(material_string,"Vacuum")) {
        // One could have a global physics struct for vacuum instead of creating one for each
        this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
        this_box_volume.p_physics->is_vacuum = 1; // Makes this volume a vacuum
        this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
        this_box_volume.p_physics->my_a = 0; // Should not be used.
        sprintf(this_box_volume.p_physics->name,"Vacuum");
    } else if (0 == strcmp(material_string,"exit") || 0 == strcmp(material_string,"Exit")) {
        // One could have a global physics struct for vacuum instead of creating one for each
        this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
        this_box_volume.p_physics->is_vacuum = 1; // Makes this volume a vacuum
        this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
        this_box_volume.p_physics->my_a = 0; // Should not be used.
        this_box_volume.geometry.is_exit_volume = 1;
        sprintf(this_box_volume.p_physics->name,"Exit");
    } else {
        #ifndef MATERIAL_DETECTOR
            printf("Need to define a material before refering to it in a geometry %s.\n",NAME_CURRENT_COMP);
            exit(1);
        #endif
        for (loop_index=0;loop_index<global_material_list.num_elements;loop_index++) {
            if (0 == strcmp(material_string,global_material_list.elements[loop_index].name)) {
                this_box_volume.p_physics = global_material_list.elements[loop_index].physics;
                break;
            }
            if (loop_index == global_material_list.num_elements-1) {
            printf("\n");
            printf("ERROR: The material string \"%s\" in Union geometry \"%s\" did not match a specified material. \n",material_string,NAME_CURRENT_COMP);
            printf("       The materials available at this point (need to be defined before the geometry): \n");
            for (loop_index=0;loop_index<global_material_list.num_elements;loop_index++)
              printf("         %s\n",global_material_list.elements[loop_index].name);
            printf("\n");
            printf("       It is also possible to use one of the defualt materials avaiable: \n");
            printf("           Vacuum (for a Volume without scattering or absorption)\n");
            printf("           Exit (for a Volume where the ray exits the component if it enters)\n");
            printf("           Mask (for a Volume that masks existing volumes specified in the mask_string\n");
            exit(1);
          }
        }
    }
} else {
    // Automatic linking, simply using the last defined material.
    #ifndef MATERIAL_DETECTOR
        printf("Need to define a material before the geometry to use automatic linking %s.\n",NAME_CURRENT_COMP);
        exit(1);
    #endif
    this_box_volume.p_physics = global_material_list.elements[global_material_list.num_elements-1].physics;
}

sprintf(this_box_volume.name,NAME_CURRENT_COMP);
sprintf(this_box_volume.geometry.shape,"box");
this_box_volume.geometry.priority_value = priority;
this_box_volume.geometry.geometry_p_interact = p_interact;
// Currently the coordinates will be in absolute space.
this_box_volume.geometry.center = POS_A_CURRENT_COMP;

this_box_storage.z_depth = zdepth;
this_box_storage.x_width1 = xwidth;
this_box_storage.y_height1 = yheight;

this_box_storage.is_rectangle = 0;
if (xwidth2 < 0 && yheight2 < 0) this_box_storage.is_rectangle = 1;
if (xwidth == xwidth2 && yheight == yheight2) this_box_storage.is_rectangle = 1;

if (xwidth2 < 0) {
    this_box_storage.x_width2 = xwidth;
    xwidth2 = xwidth;
} else this_box_storage.x_width2 = xwidth2;

if (yheight2 < 0) {
    this_box_storage.y_height2 = yheight;
    yheight2 = yheight;
} else this_box_storage.y_height2 = yheight2;


this_box_storage.normal_vectors[0] = coords_set(0,0,1);
this_box_storage.normal_vectors[1] = coords_set(0,0,1);

// for sides with y component = 0
x_component = 2*zdepth/sqrt((xwidth-xwidth2)*(xwidth-xwidth2)+4*zdepth*zdepth);
z_component = (xwidth-xwidth2)/sqrt(4*zdepth*zdepth+(xwidth-xwidth2)*(xwidth-xwidth2));

this_box_storage.normal_vectors[2] = coords_set(x_component,0,z_component);
this_box_storage.normal_vectors[3] = coords_set(-x_component,0,z_component);

// for sides with x component = 0
y_component = 2*zdepth/sqrt((yheight-yheight2)*(yheight-yheight2)+4*zdepth*zdepth);
z_component = (yheight-yheight2)/sqrt(4*zdepth*zdepth+(yheight-yheight2)*(yheight-yheight2));

this_box_storage.normal_vectors[4] = coords_set(0,y_component,z_component);
this_box_storage.normal_vectors[5] = coords_set(0,-y_component,z_component);

this_box_volume.geometry.visualization_on = visualize;

this_box_volume.geometry.geometry_parameters.p_box_storage = &this_box_storage;

// Assign pointers to functions for intersection with the shape, checking if a point is inside the shape
if (this_box_storage.is_rectangle == 1) {
this_box_volume.geometry.intersect_function = &sample_box_intersect_simple;
this_box_volume.geometry.within_function = &r_within_box_simple;
}
else {
this_box_volume.geometry.intersect_function = &sample_box_intersect_advanced;
this_box_volume.geometry.within_function = &r_within_box_advanced;
}

this_box_volume.geometry.shell_points = &box_shell_points;
this_box_volume.geometry.mcdisplay_function = &mcdisplay_box_function;
this_box_volume.geometry.initialize_from_main_function = &initialize_box_geometry_from_main_component;
this_box_volume.geometry.process_rot_allocated = 0;

this_box_volume.geometry.copy_geometry_parameters = &allocate_box_storage_copy;

rot_copy(this_box_volume.geometry.rotation_matrix,ROT_A_CURRENT_COMP); //check how ROT_R_CURRENT_COMP would work
rot_transpose(ROT_A_CURRENT_COMP,this_box_volume.geometry.transpose_rotation_matrix);

// Initialize loggers
this_box_volume.loggers.num_elements = 0;

// packing the information into the global_geometry_element, which is then included in the global_geometry_list.
sprintf(global_geometry_element.name,NAME_CURRENT_COMP);
global_geometry_element.activation_counter = number_of_activations;
global_geometry_element.component_index = INDEX_CURRENT_COMP;
global_geometry_element.Volume = &this_box_volume; // Would be nicer if this m was a pointer, now we have the (small) data two places
add_element_to_geometry_list(&global_geometry_list,global_geometry_element);
}
#line 269666 "MACS_sample_kidney_box.c"
#undef number_of_activations
#undef mask_setting
#undef mask_string
#undef p_interact
#undef focus_r
#undef focus_xh
#undef focus_xw
#undef focus_ah
#undef focus_aw
#undef target_z
#undef target_y
#undef target_x
#undef target_index
#undef visualize
#undef yheight2
#undef xwidth2
#undef zdepth
#undef yheight
#undef xwidth
#undef priority
#undef material_string
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

  /* Initializations for component diffraction_detector_11_exit_volume. */
  SIG_MESSAGE("diffraction_detector_11_exit_volume (Init)");
#define mccompcurname  diffraction_detector_11_exit_volume
#define mccompcurtype  Union_box
#define mccompcurindex 578
#define loop_index mccdiffraction_detector_11_exit_volume_loop_index
#define this_box_volume mccdiffraction_detector_11_exit_volume_this_box_volume
#define global_geometry_element mccdiffraction_detector_11_exit_volume_global_geometry_element
#define this_box_storage mccdiffraction_detector_11_exit_volume_this_box_storage
#define material_string mccdiffraction_detector_11_exit_volume_material_string
#define priority mccdiffraction_detector_11_exit_volume_priority
#define xwidth mccdiffraction_detector_11_exit_volume_xwidth
#define yheight mccdiffraction_detector_11_exit_volume_yheight
#define zdepth mccdiffraction_detector_11_exit_volume_zdepth
#define xwidth2 mccdiffraction_detector_11_exit_volume_xwidth2
#define yheight2 mccdiffraction_detector_11_exit_volume_yheight2
#define visualize mccdiffraction_detector_11_exit_volume_visualize
#define target_index mccdiffraction_detector_11_exit_volume_target_index
#define target_x mccdiffraction_detector_11_exit_volume_target_x
#define target_y mccdiffraction_detector_11_exit_volume_target_y
#define target_z mccdiffraction_detector_11_exit_volume_target_z
#define focus_aw mccdiffraction_detector_11_exit_volume_focus_aw
#define focus_ah mccdiffraction_detector_11_exit_volume_focus_ah
#define focus_xw mccdiffraction_detector_11_exit_volume_focus_xw
#define focus_xh mccdiffraction_detector_11_exit_volume_focus_xh
#define focus_r mccdiffraction_detector_11_exit_volume_focus_r
#define p_interact mccdiffraction_detector_11_exit_volume_p_interact
#define mask_string mccdiffraction_detector_11_exit_volume_mask_string
#define mask_setting mccdiffraction_detector_11_exit_volume_mask_setting
#define number_of_activations mccdiffraction_detector_11_exit_volume_number_of_activations
#line 224 "Union_box.comp"
{
// Initializes the focusing system for this volume including input sanitation.
focus_initialize(&this_box_volume.geometry, POS_A_COMP_INDEX(INDEX_CURRENT_COMP+target_index), POS_A_CURRENT_COMP, ROT_A_CURRENT_COMP, target_index, target_x, target_y, target_z, focus_aw, focus_ah, focus_xw, focus_xh, focus_r, NAME_CURRENT_COMP);

// Input sanitation for this geometry
if (xwidth <= 0) {
  printf("\nERROR in Union_box named %s, the xwidth is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (yheight <= 0) {
  printf("\nERROR in Union_box named %s, yheight is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (zdepth <= 0) {
  printf("\nERROR in Union_box named %s, zdepth is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (xwidth2 <= 0 && xwidth2 != -1) {
  printf("\nERROR in Union_box named %s, the xwidth2 is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (yheight2 <= 0 && yheight2 != -1) {
  printf("\nERROR in Union_box named %s, yheight2 is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}

// Use sanitation
if (global_material_list.num_elements == 0) {
  printf("\nERROR: Need to define a material using Union_make_material before using a Union geometry component. \n");
  printf("       %s was defined before first use of Union_make_material.\n",NAME_CURRENT_COMP);
  exit(1);
}

this_box_volume.geometry.is_masked_volume = 0;
this_box_volume.geometry.is_exit_volume = 0;
this_box_volume.geometry.is_mask_volume = 0;
// check if the volume is a mask, if it is the material string is irelevant.
if (mask_string && strlen(mask_string) && strcmp(mask_string, "NULL") && strcmp(mask_string, "0")) {
    // A mask volume is used to limit the extend of other volumes, called the masked volumes. These are specified in the mask_string.
    // In order for a ray to enter a masked volume, it needs to be both in the region covered by that volume AND the mask volume.
    // When more than
    this_box_volume.geometry.mask_mode = 1; // Default is mask mode is ALL
    if (mask_setting && strlen(mask_setting) && strcmp(mask_setting, "NULL") && strcmp(mask_setting, "0")) {
        if (strcmp(mask_setting,"ALL") == 0 || strcmp(mask_setting,"All") == 0) this_box_volume.geometry.mask_mode = 1;
        else if (strcmp(mask_setting,"ANY") == 0 || strcmp(mask_setting,"Any") == 0) this_box_volume.geometry.mask_mode = 2;
        else {
            printf("The mask_mode of component %s is set to %s, but must be either ALL or ANY.\n",NAME_CURRENT_COMP,mask_setting);
            exit(1);
        }
    }
    
    for (loop_index=0;loop_index<global_geometry_list.num_elements;loop_index++) {
        // Add mask list
        if (1 == manual_linking_function(global_geometry_list.elements[loop_index].name,mask_string)) {
            add_element_to_int_list(&this_box_volume.geometry.mask_list,global_geometry_list.elements[loop_index].component_index);
            add_element_to_int_list(&global_geometry_list.elements[loop_index].Volume->geometry.masked_by_list,INDEX_CURRENT_COMP);
            global_geometry_list.elements[loop_index].Volume->geometry.is_masked_volume = 1;
            if (this_box_volume.geometry.mask_mode == 2)
                global_geometry_list.elements[loop_index].Volume->geometry.mask_mode = 2;
            if (this_box_volume.geometry.mask_mode == 1) {
                if (global_geometry_list.elements[loop_index].Volume->geometry.is_masked_volume == 1 && global_geometry_list.elements[loop_index].Volume->geometry.mask_mode != 2)
                    // If more than one mask is added to one volume, the ANY mode overwrites the (default) ALL mode.
                    global_geometry_list.elements[loop_index].Volume->geometry.mask_mode = 1;
            }
            
            found_geometries = 1;
        }
    }
    if (found_geometries == 0) {
        printf("The mask_string in geometry: %s did not find any of the specified volumes in the mask_string %s \n",NAME_CURRENT_COMP,mask_string);
        exit(1);
    }
    this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
    this_box_volume.p_physics->is_vacuum = 0; // Makes this volume a vacuum
    this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
    this_box_volume.p_physics->my_a = 0; // Should not be used.
    sprintf(this_box_volume.p_physics->name,"Mask");
    this_box_volume.geometry.is_mask_volume = 1;
    
    
// Read the material input, or if it lacks, use automatic linking.
} else if (material_string && strlen(material_string) && strcmp(material_string, "NULL") && strcmp(material_string, "0")) {
    // A geometry string was given, use it to determine which material
    if (0 == strcmp(material_string,"vacuum") || 0 == strcmp(material_string,"Vacuum")) {
        // One could have a global physics struct for vacuum instead of creating one for each
        this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
        this_box_volume.p_physics->is_vacuum = 1; // Makes this volume a vacuum
        this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
        this_box_volume.p_physics->my_a = 0; // Should not be used.
        sprintf(this_box_volume.p_physics->name,"Vacuum");
    } else if (0 == strcmp(material_string,"exit") || 0 == strcmp(material_string,"Exit")) {
        // One could have a global physics struct for vacuum instead of creating one for each
        this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
        this_box_volume.p_physics->is_vacuum = 1; // Makes this volume a vacuum
        this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
        this_box_volume.p_physics->my_a = 0; // Should not be used.
        this_box_volume.geometry.is_exit_volume = 1;
        sprintf(this_box_volume.p_physics->name,"Exit");
    } else {
        #ifndef MATERIAL_DETECTOR
            printf("Need to define a material before refering to it in a geometry %s.\n",NAME_CURRENT_COMP);
            exit(1);
        #endif
        for (loop_index=0;loop_index<global_material_list.num_elements;loop_index++) {
            if (0 == strcmp(material_string,global_material_list.elements[loop_index].name)) {
                this_box_volume.p_physics = global_material_list.elements[loop_index].physics;
                break;
            }
            if (loop_index == global_material_list.num_elements-1) {
            printf("\n");
            printf("ERROR: The material string \"%s\" in Union geometry \"%s\" did not match a specified material. \n",material_string,NAME_CURRENT_COMP);
            printf("       The materials available at this point (need to be defined before the geometry): \n");
            for (loop_index=0;loop_index<global_material_list.num_elements;loop_index++)
              printf("         %s\n",global_material_list.elements[loop_index].name);
            printf("\n");
            printf("       It is also possible to use one of the defualt materials avaiable: \n");
            printf("           Vacuum (for a Volume without scattering or absorption)\n");
            printf("           Exit (for a Volume where the ray exits the component if it enters)\n");
            printf("           Mask (for a Volume that masks existing volumes specified in the mask_string\n");
            exit(1);
          }
        }
    }
} else {
    // Automatic linking, simply using the last defined material.
    #ifndef MATERIAL_DETECTOR
        printf("Need to define a material before the geometry to use automatic linking %s.\n",NAME_CURRENT_COMP);
        exit(1);
    #endif
    this_box_volume.p_physics = global_material_list.elements[global_material_list.num_elements-1].physics;
}

sprintf(this_box_volume.name,NAME_CURRENT_COMP);
sprintf(this_box_volume.geometry.shape,"box");
this_box_volume.geometry.priority_value = priority;
this_box_volume.geometry.geometry_p_interact = p_interact;
// Currently the coordinates will be in absolute space.
this_box_volume.geometry.center = POS_A_CURRENT_COMP;

this_box_storage.z_depth = zdepth;
this_box_storage.x_width1 = xwidth;
this_box_storage.y_height1 = yheight;

this_box_storage.is_rectangle = 0;
if (xwidth2 < 0 && yheight2 < 0) this_box_storage.is_rectangle = 1;
if (xwidth == xwidth2 && yheight == yheight2) this_box_storage.is_rectangle = 1;

if (xwidth2 < 0) {
    this_box_storage.x_width2 = xwidth;
    xwidth2 = xwidth;
} else this_box_storage.x_width2 = xwidth2;

if (yheight2 < 0) {
    this_box_storage.y_height2 = yheight;
    yheight2 = yheight;
} else this_box_storage.y_height2 = yheight2;


this_box_storage.normal_vectors[0] = coords_set(0,0,1);
this_box_storage.normal_vectors[1] = coords_set(0,0,1);

// for sides with y component = 0
x_component = 2*zdepth/sqrt((xwidth-xwidth2)*(xwidth-xwidth2)+4*zdepth*zdepth);
z_component = (xwidth-xwidth2)/sqrt(4*zdepth*zdepth+(xwidth-xwidth2)*(xwidth-xwidth2));

this_box_storage.normal_vectors[2] = coords_set(x_component,0,z_component);
this_box_storage.normal_vectors[3] = coords_set(-x_component,0,z_component);

// for sides with x component = 0
y_component = 2*zdepth/sqrt((yheight-yheight2)*(yheight-yheight2)+4*zdepth*zdepth);
z_component = (yheight-yheight2)/sqrt(4*zdepth*zdepth+(yheight-yheight2)*(yheight-yheight2));

this_box_storage.normal_vectors[4] = coords_set(0,y_component,z_component);
this_box_storage.normal_vectors[5] = coords_set(0,-y_component,z_component);

this_box_volume.geometry.visualization_on = visualize;

this_box_volume.geometry.geometry_parameters.p_box_storage = &this_box_storage;

// Assign pointers to functions for intersection with the shape, checking if a point is inside the shape
if (this_box_storage.is_rectangle == 1) {
this_box_volume.geometry.intersect_function = &sample_box_intersect_simple;
this_box_volume.geometry.within_function = &r_within_box_simple;
}
else {
this_box_volume.geometry.intersect_function = &sample_box_intersect_advanced;
this_box_volume.geometry.within_function = &r_within_box_advanced;
}

this_box_volume.geometry.shell_points = &box_shell_points;
this_box_volume.geometry.mcdisplay_function = &mcdisplay_box_function;
this_box_volume.geometry.initialize_from_main_function = &initialize_box_geometry_from_main_component;
this_box_volume.geometry.process_rot_allocated = 0;

this_box_volume.geometry.copy_geometry_parameters = &allocate_box_storage_copy;

rot_copy(this_box_volume.geometry.rotation_matrix,ROT_A_CURRENT_COMP); //check how ROT_R_CURRENT_COMP would work
rot_transpose(ROT_A_CURRENT_COMP,this_box_volume.geometry.transpose_rotation_matrix);

// Initialize loggers
this_box_volume.loggers.num_elements = 0;

// packing the information into the global_geometry_element, which is then included in the global_geometry_list.
sprintf(global_geometry_element.name,NAME_CURRENT_COMP);
global_geometry_element.activation_counter = number_of_activations;
global_geometry_element.component_index = INDEX_CURRENT_COMP;
global_geometry_element.Volume = &this_box_volume; // Would be nicer if this m was a pointer, now we have the (small) data two places
add_element_to_geometry_list(&global_geometry_list,global_geometry_element);
}
#line 269936 "MACS_sample_kidney_box.c"
#undef number_of_activations
#undef mask_setting
#undef mask_string
#undef p_interact
#undef focus_r
#undef focus_xh
#undef focus_xw
#undef focus_ah
#undef focus_aw
#undef target_z
#undef target_y
#undef target_x
#undef target_index
#undef visualize
#undef yheight2
#undef xwidth2
#undef zdepth
#undef yheight
#undef xwidth
#undef priority
#undef material_string
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

  /* Initializations for component spec_detector_11_exit_volume. */
  SIG_MESSAGE("spec_detector_11_exit_volume (Init)");
#define mccompcurname  spec_detector_11_exit_volume
#define mccompcurtype  Union_box
#define mccompcurindex 579
#define loop_index mccspec_detector_11_exit_volume_loop_index
#define this_box_volume mccspec_detector_11_exit_volume_this_box_volume
#define global_geometry_element mccspec_detector_11_exit_volume_global_geometry_element
#define this_box_storage mccspec_detector_11_exit_volume_this_box_storage
#define material_string mccspec_detector_11_exit_volume_material_string
#define priority mccspec_detector_11_exit_volume_priority
#define xwidth mccspec_detector_11_exit_volume_xwidth
#define yheight mccspec_detector_11_exit_volume_yheight
#define zdepth mccspec_detector_11_exit_volume_zdepth
#define xwidth2 mccspec_detector_11_exit_volume_xwidth2
#define yheight2 mccspec_detector_11_exit_volume_yheight2
#define visualize mccspec_detector_11_exit_volume_visualize
#define target_index mccspec_detector_11_exit_volume_target_index
#define target_x mccspec_detector_11_exit_volume_target_x
#define target_y mccspec_detector_11_exit_volume_target_y
#define target_z mccspec_detector_11_exit_volume_target_z
#define focus_aw mccspec_detector_11_exit_volume_focus_aw
#define focus_ah mccspec_detector_11_exit_volume_focus_ah
#define focus_xw mccspec_detector_11_exit_volume_focus_xw
#define focus_xh mccspec_detector_11_exit_volume_focus_xh
#define focus_r mccspec_detector_11_exit_volume_focus_r
#define p_interact mccspec_detector_11_exit_volume_p_interact
#define mask_string mccspec_detector_11_exit_volume_mask_string
#define mask_setting mccspec_detector_11_exit_volume_mask_setting
#define number_of_activations mccspec_detector_11_exit_volume_number_of_activations
#line 224 "Union_box.comp"
{
// Initializes the focusing system for this volume including input sanitation.
focus_initialize(&this_box_volume.geometry, POS_A_COMP_INDEX(INDEX_CURRENT_COMP+target_index), POS_A_CURRENT_COMP, ROT_A_CURRENT_COMP, target_index, target_x, target_y, target_z, focus_aw, focus_ah, focus_xw, focus_xh, focus_r, NAME_CURRENT_COMP);

// Input sanitation for this geometry
if (xwidth <= 0) {
  printf("\nERROR in Union_box named %s, the xwidth is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (yheight <= 0) {
  printf("\nERROR in Union_box named %s, yheight is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (zdepth <= 0) {
  printf("\nERROR in Union_box named %s, zdepth is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (xwidth2 <= 0 && xwidth2 != -1) {
  printf("\nERROR in Union_box named %s, the xwidth2 is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (yheight2 <= 0 && yheight2 != -1) {
  printf("\nERROR in Union_box named %s, yheight2 is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}

// Use sanitation
if (global_material_list.num_elements == 0) {
  printf("\nERROR: Need to define a material using Union_make_material before using a Union geometry component. \n");
  printf("       %s was defined before first use of Union_make_material.\n",NAME_CURRENT_COMP);
  exit(1);
}

this_box_volume.geometry.is_masked_volume = 0;
this_box_volume.geometry.is_exit_volume = 0;
this_box_volume.geometry.is_mask_volume = 0;
// check if the volume is a mask, if it is the material string is irelevant.
if (mask_string && strlen(mask_string) && strcmp(mask_string, "NULL") && strcmp(mask_string, "0")) {
    // A mask volume is used to limit the extend of other volumes, called the masked volumes. These are specified in the mask_string.
    // In order for a ray to enter a masked volume, it needs to be both in the region covered by that volume AND the mask volume.
    // When more than
    this_box_volume.geometry.mask_mode = 1; // Default is mask mode is ALL
    if (mask_setting && strlen(mask_setting) && strcmp(mask_setting, "NULL") && strcmp(mask_setting, "0")) {
        if (strcmp(mask_setting,"ALL") == 0 || strcmp(mask_setting,"All") == 0) this_box_volume.geometry.mask_mode = 1;
        else if (strcmp(mask_setting,"ANY") == 0 || strcmp(mask_setting,"Any") == 0) this_box_volume.geometry.mask_mode = 2;
        else {
            printf("The mask_mode of component %s is set to %s, but must be either ALL or ANY.\n",NAME_CURRENT_COMP,mask_setting);
            exit(1);
        }
    }
    
    for (loop_index=0;loop_index<global_geometry_list.num_elements;loop_index++) {
        // Add mask list
        if (1 == manual_linking_function(global_geometry_list.elements[loop_index].name,mask_string)) {
            add_element_to_int_list(&this_box_volume.geometry.mask_list,global_geometry_list.elements[loop_index].component_index);
            add_element_to_int_list(&global_geometry_list.elements[loop_index].Volume->geometry.masked_by_list,INDEX_CURRENT_COMP);
            global_geometry_list.elements[loop_index].Volume->geometry.is_masked_volume = 1;
            if (this_box_volume.geometry.mask_mode == 2)
                global_geometry_list.elements[loop_index].Volume->geometry.mask_mode = 2;
            if (this_box_volume.geometry.mask_mode == 1) {
                if (global_geometry_list.elements[loop_index].Volume->geometry.is_masked_volume == 1 && global_geometry_list.elements[loop_index].Volume->geometry.mask_mode != 2)
                    // If more than one mask is added to one volume, the ANY mode overwrites the (default) ALL mode.
                    global_geometry_list.elements[loop_index].Volume->geometry.mask_mode = 1;
            }
            
            found_geometries = 1;
        }
    }
    if (found_geometries == 0) {
        printf("The mask_string in geometry: %s did not find any of the specified volumes in the mask_string %s \n",NAME_CURRENT_COMP,mask_string);
        exit(1);
    }
    this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
    this_box_volume.p_physics->is_vacuum = 0; // Makes this volume a vacuum
    this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
    this_box_volume.p_physics->my_a = 0; // Should not be used.
    sprintf(this_box_volume.p_physics->name,"Mask");
    this_box_volume.geometry.is_mask_volume = 1;
    
    
// Read the material input, or if it lacks, use automatic linking.
} else if (material_string && strlen(material_string) && strcmp(material_string, "NULL") && strcmp(material_string, "0")) {
    // A geometry string was given, use it to determine which material
    if (0 == strcmp(material_string,"vacuum") || 0 == strcmp(material_string,"Vacuum")) {
        // One could have a global physics struct for vacuum instead of creating one for each
        this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
        this_box_volume.p_physics->is_vacuum = 1; // Makes this volume a vacuum
        this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
        this_box_volume.p_physics->my_a = 0; // Should not be used.
        sprintf(this_box_volume.p_physics->name,"Vacuum");
    } else if (0 == strcmp(material_string,"exit") || 0 == strcmp(material_string,"Exit")) {
        // One could have a global physics struct for vacuum instead of creating one for each
        this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
        this_box_volume.p_physics->is_vacuum = 1; // Makes this volume a vacuum
        this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
        this_box_volume.p_physics->my_a = 0; // Should not be used.
        this_box_volume.geometry.is_exit_volume = 1;
        sprintf(this_box_volume.p_physics->name,"Exit");
    } else {
        #ifndef MATERIAL_DETECTOR
            printf("Need to define a material before refering to it in a geometry %s.\n",NAME_CURRENT_COMP);
            exit(1);
        #endif
        for (loop_index=0;loop_index<global_material_list.num_elements;loop_index++) {
            if (0 == strcmp(material_string,global_material_list.elements[loop_index].name)) {
                this_box_volume.p_physics = global_material_list.elements[loop_index].physics;
                break;
            }
            if (loop_index == global_material_list.num_elements-1) {
            printf("\n");
            printf("ERROR: The material string \"%s\" in Union geometry \"%s\" did not match a specified material. \n",material_string,NAME_CURRENT_COMP);
            printf("       The materials available at this point (need to be defined before the geometry): \n");
            for (loop_index=0;loop_index<global_material_list.num_elements;loop_index++)
              printf("         %s\n",global_material_list.elements[loop_index].name);
            printf("\n");
            printf("       It is also possible to use one of the defualt materials avaiable: \n");
            printf("           Vacuum (for a Volume without scattering or absorption)\n");
            printf("           Exit (for a Volume where the ray exits the component if it enters)\n");
            printf("           Mask (for a Volume that masks existing volumes specified in the mask_string\n");
            exit(1);
          }
        }
    }
} else {
    // Automatic linking, simply using the last defined material.
    #ifndef MATERIAL_DETECTOR
        printf("Need to define a material before the geometry to use automatic linking %s.\n",NAME_CURRENT_COMP);
        exit(1);
    #endif
    this_box_volume.p_physics = global_material_list.elements[global_material_list.num_elements-1].physics;
}

sprintf(this_box_volume.name,NAME_CURRENT_COMP);
sprintf(this_box_volume.geometry.shape,"box");
this_box_volume.geometry.priority_value = priority;
this_box_volume.geometry.geometry_p_interact = p_interact;
// Currently the coordinates will be in absolute space.
this_box_volume.geometry.center = POS_A_CURRENT_COMP;

this_box_storage.z_depth = zdepth;
this_box_storage.x_width1 = xwidth;
this_box_storage.y_height1 = yheight;

this_box_storage.is_rectangle = 0;
if (xwidth2 < 0 && yheight2 < 0) this_box_storage.is_rectangle = 1;
if (xwidth == xwidth2 && yheight == yheight2) this_box_storage.is_rectangle = 1;

if (xwidth2 < 0) {
    this_box_storage.x_width2 = xwidth;
    xwidth2 = xwidth;
} else this_box_storage.x_width2 = xwidth2;

if (yheight2 < 0) {
    this_box_storage.y_height2 = yheight;
    yheight2 = yheight;
} else this_box_storage.y_height2 = yheight2;


this_box_storage.normal_vectors[0] = coords_set(0,0,1);
this_box_storage.normal_vectors[1] = coords_set(0,0,1);

// for sides with y component = 0
x_component = 2*zdepth/sqrt((xwidth-xwidth2)*(xwidth-xwidth2)+4*zdepth*zdepth);
z_component = (xwidth-xwidth2)/sqrt(4*zdepth*zdepth+(xwidth-xwidth2)*(xwidth-xwidth2));

this_box_storage.normal_vectors[2] = coords_set(x_component,0,z_component);
this_box_storage.normal_vectors[3] = coords_set(-x_component,0,z_component);

// for sides with x component = 0
y_component = 2*zdepth/sqrt((yheight-yheight2)*(yheight-yheight2)+4*zdepth*zdepth);
z_component = (yheight-yheight2)/sqrt(4*zdepth*zdepth+(yheight-yheight2)*(yheight-yheight2));

this_box_storage.normal_vectors[4] = coords_set(0,y_component,z_component);
this_box_storage.normal_vectors[5] = coords_set(0,-y_component,z_component);

this_box_volume.geometry.visualization_on = visualize;

this_box_volume.geometry.geometry_parameters.p_box_storage = &this_box_storage;

// Assign pointers to functions for intersection with the shape, checking if a point is inside the shape
if (this_box_storage.is_rectangle == 1) {
this_box_volume.geometry.intersect_function = &sample_box_intersect_simple;
this_box_volume.geometry.within_function = &r_within_box_simple;
}
else {
this_box_volume.geometry.intersect_function = &sample_box_intersect_advanced;
this_box_volume.geometry.within_function = &r_within_box_advanced;
}

this_box_volume.geometry.shell_points = &box_shell_points;
this_box_volume.geometry.mcdisplay_function = &mcdisplay_box_function;
this_box_volume.geometry.initialize_from_main_function = &initialize_box_geometry_from_main_component;
this_box_volume.geometry.process_rot_allocated = 0;

this_box_volume.geometry.copy_geometry_parameters = &allocate_box_storage_copy;

rot_copy(this_box_volume.geometry.rotation_matrix,ROT_A_CURRENT_COMP); //check how ROT_R_CURRENT_COMP would work
rot_transpose(ROT_A_CURRENT_COMP,this_box_volume.geometry.transpose_rotation_matrix);

// Initialize loggers
this_box_volume.loggers.num_elements = 0;

// packing the information into the global_geometry_element, which is then included in the global_geometry_list.
sprintf(global_geometry_element.name,NAME_CURRENT_COMP);
global_geometry_element.activation_counter = number_of_activations;
global_geometry_element.component_index = INDEX_CURRENT_COMP;
global_geometry_element.Volume = &this_box_volume; // Would be nicer if this m was a pointer, now we have the (small) data two places
add_element_to_geometry_list(&global_geometry_list,global_geometry_element);
}
#line 270206 "MACS_sample_kidney_box.c"
#undef number_of_activations
#undef mask_setting
#undef mask_string
#undef p_interact
#undef focus_r
#undef focus_xh
#undef focus_xw
#undef focus_ah
#undef focus_aw
#undef target_z
#undef target_y
#undef target_x
#undef target_index
#undef visualize
#undef yheight2
#undef xwidth2
#undef zdepth
#undef yheight
#undef xwidth
#undef priority
#undef material_string
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

  /* Initializations for component channel_12_cave1_box1. */
  SIG_MESSAGE("channel_12_cave1_box1 (Init)");
#define mccompcurname  channel_12_cave1_box1
#define mccompcurtype  Union_box
#define mccompcurindex 580
#define loop_index mccchannel_12_cave1_box1_loop_index
#define this_box_volume mccchannel_12_cave1_box1_this_box_volume
#define global_geometry_element mccchannel_12_cave1_box1_global_geometry_element
#define this_box_storage mccchannel_12_cave1_box1_this_box_storage
#define material_string mccchannel_12_cave1_box1_material_string
#define priority mccchannel_12_cave1_box1_priority
#define xwidth mccchannel_12_cave1_box1_xwidth
#define yheight mccchannel_12_cave1_box1_yheight
#define zdepth mccchannel_12_cave1_box1_zdepth
#define xwidth2 mccchannel_12_cave1_box1_xwidth2
#define yheight2 mccchannel_12_cave1_box1_yheight2
#define visualize mccchannel_12_cave1_box1_visualize
#define target_index mccchannel_12_cave1_box1_target_index
#define target_x mccchannel_12_cave1_box1_target_x
#define target_y mccchannel_12_cave1_box1_target_y
#define target_z mccchannel_12_cave1_box1_target_z
#define focus_aw mccchannel_12_cave1_box1_focus_aw
#define focus_ah mccchannel_12_cave1_box1_focus_ah
#define focus_xw mccchannel_12_cave1_box1_focus_xw
#define focus_xh mccchannel_12_cave1_box1_focus_xh
#define focus_r mccchannel_12_cave1_box1_focus_r
#define p_interact mccchannel_12_cave1_box1_p_interact
#define mask_string mccchannel_12_cave1_box1_mask_string
#define mask_setting mccchannel_12_cave1_box1_mask_setting
#define number_of_activations mccchannel_12_cave1_box1_number_of_activations
#line 224 "Union_box.comp"
{
// Initializes the focusing system for this volume including input sanitation.
focus_initialize(&this_box_volume.geometry, POS_A_COMP_INDEX(INDEX_CURRENT_COMP+target_index), POS_A_CURRENT_COMP, ROT_A_CURRENT_COMP, target_index, target_x, target_y, target_z, focus_aw, focus_ah, focus_xw, focus_xh, focus_r, NAME_CURRENT_COMP);

// Input sanitation for this geometry
if (xwidth <= 0) {
  printf("\nERROR in Union_box named %s, the xwidth is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (yheight <= 0) {
  printf("\nERROR in Union_box named %s, yheight is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (zdepth <= 0) {
  printf("\nERROR in Union_box named %s, zdepth is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (xwidth2 <= 0 && xwidth2 != -1) {
  printf("\nERROR in Union_box named %s, the xwidth2 is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (yheight2 <= 0 && yheight2 != -1) {
  printf("\nERROR in Union_box named %s, yheight2 is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}

// Use sanitation
if (global_material_list.num_elements == 0) {
  printf("\nERROR: Need to define a material using Union_make_material before using a Union geometry component. \n");
  printf("       %s was defined before first use of Union_make_material.\n",NAME_CURRENT_COMP);
  exit(1);
}

this_box_volume.geometry.is_masked_volume = 0;
this_box_volume.geometry.is_exit_volume = 0;
this_box_volume.geometry.is_mask_volume = 0;
// check if the volume is a mask, if it is the material string is irelevant.
if (mask_string && strlen(mask_string) && strcmp(mask_string, "NULL") && strcmp(mask_string, "0")) {
    // A mask volume is used to limit the extend of other volumes, called the masked volumes. These are specified in the mask_string.
    // In order for a ray to enter a masked volume, it needs to be both in the region covered by that volume AND the mask volume.
    // When more than
    this_box_volume.geometry.mask_mode = 1; // Default is mask mode is ALL
    if (mask_setting && strlen(mask_setting) && strcmp(mask_setting, "NULL") && strcmp(mask_setting, "0")) {
        if (strcmp(mask_setting,"ALL") == 0 || strcmp(mask_setting,"All") == 0) this_box_volume.geometry.mask_mode = 1;
        else if (strcmp(mask_setting,"ANY") == 0 || strcmp(mask_setting,"Any") == 0) this_box_volume.geometry.mask_mode = 2;
        else {
            printf("The mask_mode of component %s is set to %s, but must be either ALL or ANY.\n",NAME_CURRENT_COMP,mask_setting);
            exit(1);
        }
    }
    
    for (loop_index=0;loop_index<global_geometry_list.num_elements;loop_index++) {
        // Add mask list
        if (1 == manual_linking_function(global_geometry_list.elements[loop_index].name,mask_string)) {
            add_element_to_int_list(&this_box_volume.geometry.mask_list,global_geometry_list.elements[loop_index].component_index);
            add_element_to_int_list(&global_geometry_list.elements[loop_index].Volume->geometry.masked_by_list,INDEX_CURRENT_COMP);
            global_geometry_list.elements[loop_index].Volume->geometry.is_masked_volume = 1;
            if (this_box_volume.geometry.mask_mode == 2)
                global_geometry_list.elements[loop_index].Volume->geometry.mask_mode = 2;
            if (this_box_volume.geometry.mask_mode == 1) {
                if (global_geometry_list.elements[loop_index].Volume->geometry.is_masked_volume == 1 && global_geometry_list.elements[loop_index].Volume->geometry.mask_mode != 2)
                    // If more than one mask is added to one volume, the ANY mode overwrites the (default) ALL mode.
                    global_geometry_list.elements[loop_index].Volume->geometry.mask_mode = 1;
            }
            
            found_geometries = 1;
        }
    }
    if (found_geometries == 0) {
        printf("The mask_string in geometry: %s did not find any of the specified volumes in the mask_string %s \n",NAME_CURRENT_COMP,mask_string);
        exit(1);
    }
    this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
    this_box_volume.p_physics->is_vacuum = 0; // Makes this volume a vacuum
    this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
    this_box_volume.p_physics->my_a = 0; // Should not be used.
    sprintf(this_box_volume.p_physics->name,"Mask");
    this_box_volume.geometry.is_mask_volume = 1;
    
    
// Read the material input, or if it lacks, use automatic linking.
} else if (material_string && strlen(material_string) && strcmp(material_string, "NULL") && strcmp(material_string, "0")) {
    // A geometry string was given, use it to determine which material
    if (0 == strcmp(material_string,"vacuum") || 0 == strcmp(material_string,"Vacuum")) {
        // One could have a global physics struct for vacuum instead of creating one for each
        this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
        this_box_volume.p_physics->is_vacuum = 1; // Makes this volume a vacuum
        this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
        this_box_volume.p_physics->my_a = 0; // Should not be used.
        sprintf(this_box_volume.p_physics->name,"Vacuum");
    } else if (0 == strcmp(material_string,"exit") || 0 == strcmp(material_string,"Exit")) {
        // One could have a global physics struct for vacuum instead of creating one for each
        this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
        this_box_volume.p_physics->is_vacuum = 1; // Makes this volume a vacuum
        this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
        this_box_volume.p_physics->my_a = 0; // Should not be used.
        this_box_volume.geometry.is_exit_volume = 1;
        sprintf(this_box_volume.p_physics->name,"Exit");
    } else {
        #ifndef MATERIAL_DETECTOR
            printf("Need to define a material before refering to it in a geometry %s.\n",NAME_CURRENT_COMP);
            exit(1);
        #endif
        for (loop_index=0;loop_index<global_material_list.num_elements;loop_index++) {
            if (0 == strcmp(material_string,global_material_list.elements[loop_index].name)) {
                this_box_volume.p_physics = global_material_list.elements[loop_index].physics;
                break;
            }
            if (loop_index == global_material_list.num_elements-1) {
            printf("\n");
            printf("ERROR: The material string \"%s\" in Union geometry \"%s\" did not match a specified material. \n",material_string,NAME_CURRENT_COMP);
            printf("       The materials available at this point (need to be defined before the geometry): \n");
            for (loop_index=0;loop_index<global_material_list.num_elements;loop_index++)
              printf("         %s\n",global_material_list.elements[loop_index].name);
            printf("\n");
            printf("       It is also possible to use one of the defualt materials avaiable: \n");
            printf("           Vacuum (for a Volume without scattering or absorption)\n");
            printf("           Exit (for a Volume where the ray exits the component if it enters)\n");
            printf("           Mask (for a Volume that masks existing volumes specified in the mask_string\n");
            exit(1);
          }
        }
    }
} else {
    // Automatic linking, simply using the last defined material.
    #ifndef MATERIAL_DETECTOR
        printf("Need to define a material before the geometry to use automatic linking %s.\n",NAME_CURRENT_COMP);
        exit(1);
    #endif
    this_box_volume.p_physics = global_material_list.elements[global_material_list.num_elements-1].physics;
}

sprintf(this_box_volume.name,NAME_CURRENT_COMP);
sprintf(this_box_volume.geometry.shape,"box");
this_box_volume.geometry.priority_value = priority;
this_box_volume.geometry.geometry_p_interact = p_interact;
// Currently the coordinates will be in absolute space.
this_box_volume.geometry.center = POS_A_CURRENT_COMP;

this_box_storage.z_depth = zdepth;
this_box_storage.x_width1 = xwidth;
this_box_storage.y_height1 = yheight;

this_box_storage.is_rectangle = 0;
if (xwidth2 < 0 && yheight2 < 0) this_box_storage.is_rectangle = 1;
if (xwidth == xwidth2 && yheight == yheight2) this_box_storage.is_rectangle = 1;

if (xwidth2 < 0) {
    this_box_storage.x_width2 = xwidth;
    xwidth2 = xwidth;
} else this_box_storage.x_width2 = xwidth2;

if (yheight2 < 0) {
    this_box_storage.y_height2 = yheight;
    yheight2 = yheight;
} else this_box_storage.y_height2 = yheight2;


this_box_storage.normal_vectors[0] = coords_set(0,0,1);
this_box_storage.normal_vectors[1] = coords_set(0,0,1);

// for sides with y component = 0
x_component = 2*zdepth/sqrt((xwidth-xwidth2)*(xwidth-xwidth2)+4*zdepth*zdepth);
z_component = (xwidth-xwidth2)/sqrt(4*zdepth*zdepth+(xwidth-xwidth2)*(xwidth-xwidth2));

this_box_storage.normal_vectors[2] = coords_set(x_component,0,z_component);
this_box_storage.normal_vectors[3] = coords_set(-x_component,0,z_component);

// for sides with x component = 0
y_component = 2*zdepth/sqrt((yheight-yheight2)*(yheight-yheight2)+4*zdepth*zdepth);
z_component = (yheight-yheight2)/sqrt(4*zdepth*zdepth+(yheight-yheight2)*(yheight-yheight2));

this_box_storage.normal_vectors[4] = coords_set(0,y_component,z_component);
this_box_storage.normal_vectors[5] = coords_set(0,-y_component,z_component);

this_box_volume.geometry.visualization_on = visualize;

this_box_volume.geometry.geometry_parameters.p_box_storage = &this_box_storage;

// Assign pointers to functions for intersection with the shape, checking if a point is inside the shape
if (this_box_storage.is_rectangle == 1) {
this_box_volume.geometry.intersect_function = &sample_box_intersect_simple;
this_box_volume.geometry.within_function = &r_within_box_simple;
}
else {
this_box_volume.geometry.intersect_function = &sample_box_intersect_advanced;
this_box_volume.geometry.within_function = &r_within_box_advanced;
}

this_box_volume.geometry.shell_points = &box_shell_points;
this_box_volume.geometry.mcdisplay_function = &mcdisplay_box_function;
this_box_volume.geometry.initialize_from_main_function = &initialize_box_geometry_from_main_component;
this_box_volume.geometry.process_rot_allocated = 0;

this_box_volume.geometry.copy_geometry_parameters = &allocate_box_storage_copy;

rot_copy(this_box_volume.geometry.rotation_matrix,ROT_A_CURRENT_COMP); //check how ROT_R_CURRENT_COMP would work
rot_transpose(ROT_A_CURRENT_COMP,this_box_volume.geometry.transpose_rotation_matrix);

// Initialize loggers
this_box_volume.loggers.num_elements = 0;

// packing the information into the global_geometry_element, which is then included in the global_geometry_list.
sprintf(global_geometry_element.name,NAME_CURRENT_COMP);
global_geometry_element.activation_counter = number_of_activations;
global_geometry_element.component_index = INDEX_CURRENT_COMP;
global_geometry_element.Volume = &this_box_volume; // Would be nicer if this m was a pointer, now we have the (small) data two places
add_element_to_geometry_list(&global_geometry_list,global_geometry_element);
}
#line 270476 "MACS_sample_kidney_box.c"
#undef number_of_activations
#undef mask_setting
#undef mask_string
#undef p_interact
#undef focus_r
#undef focus_xh
#undef focus_xw
#undef focus_ah
#undef focus_aw
#undef target_z
#undef target_y
#undef target_x
#undef target_index
#undef visualize
#undef yheight2
#undef xwidth2
#undef zdepth
#undef yheight
#undef xwidth
#undef priority
#undef material_string
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

  /* Initializations for component channel_12_cave1_box2. */
  SIG_MESSAGE("channel_12_cave1_box2 (Init)");
#define mccompcurname  channel_12_cave1_box2
#define mccompcurtype  Union_box
#define mccompcurindex 581
#define loop_index mccchannel_12_cave1_box2_loop_index
#define this_box_volume mccchannel_12_cave1_box2_this_box_volume
#define global_geometry_element mccchannel_12_cave1_box2_global_geometry_element
#define this_box_storage mccchannel_12_cave1_box2_this_box_storage
#define material_string mccchannel_12_cave1_box2_material_string
#define priority mccchannel_12_cave1_box2_priority
#define xwidth mccchannel_12_cave1_box2_xwidth
#define yheight mccchannel_12_cave1_box2_yheight
#define zdepth mccchannel_12_cave1_box2_zdepth
#define xwidth2 mccchannel_12_cave1_box2_xwidth2
#define yheight2 mccchannel_12_cave1_box2_yheight2
#define visualize mccchannel_12_cave1_box2_visualize
#define target_index mccchannel_12_cave1_box2_target_index
#define target_x mccchannel_12_cave1_box2_target_x
#define target_y mccchannel_12_cave1_box2_target_y
#define target_z mccchannel_12_cave1_box2_target_z
#define focus_aw mccchannel_12_cave1_box2_focus_aw
#define focus_ah mccchannel_12_cave1_box2_focus_ah
#define focus_xw mccchannel_12_cave1_box2_focus_xw
#define focus_xh mccchannel_12_cave1_box2_focus_xh
#define focus_r mccchannel_12_cave1_box2_focus_r
#define p_interact mccchannel_12_cave1_box2_p_interact
#define mask_string mccchannel_12_cave1_box2_mask_string
#define mask_setting mccchannel_12_cave1_box2_mask_setting
#define number_of_activations mccchannel_12_cave1_box2_number_of_activations
#line 224 "Union_box.comp"
{
// Initializes the focusing system for this volume including input sanitation.
focus_initialize(&this_box_volume.geometry, POS_A_COMP_INDEX(INDEX_CURRENT_COMP+target_index), POS_A_CURRENT_COMP, ROT_A_CURRENT_COMP, target_index, target_x, target_y, target_z, focus_aw, focus_ah, focus_xw, focus_xh, focus_r, NAME_CURRENT_COMP);

// Input sanitation for this geometry
if (xwidth <= 0) {
  printf("\nERROR in Union_box named %s, the xwidth is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (yheight <= 0) {
  printf("\nERROR in Union_box named %s, yheight is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (zdepth <= 0) {
  printf("\nERROR in Union_box named %s, zdepth is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (xwidth2 <= 0 && xwidth2 != -1) {
  printf("\nERROR in Union_box named %s, the xwidth2 is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (yheight2 <= 0 && yheight2 != -1) {
  printf("\nERROR in Union_box named %s, yheight2 is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}

// Use sanitation
if (global_material_list.num_elements == 0) {
  printf("\nERROR: Need to define a material using Union_make_material before using a Union geometry component. \n");
  printf("       %s was defined before first use of Union_make_material.\n",NAME_CURRENT_COMP);
  exit(1);
}

this_box_volume.geometry.is_masked_volume = 0;
this_box_volume.geometry.is_exit_volume = 0;
this_box_volume.geometry.is_mask_volume = 0;
// check if the volume is a mask, if it is the material string is irelevant.
if (mask_string && strlen(mask_string) && strcmp(mask_string, "NULL") && strcmp(mask_string, "0")) {
    // A mask volume is used to limit the extend of other volumes, called the masked volumes. These are specified in the mask_string.
    // In order for a ray to enter a masked volume, it needs to be both in the region covered by that volume AND the mask volume.
    // When more than
    this_box_volume.geometry.mask_mode = 1; // Default is mask mode is ALL
    if (mask_setting && strlen(mask_setting) && strcmp(mask_setting, "NULL") && strcmp(mask_setting, "0")) {
        if (strcmp(mask_setting,"ALL") == 0 || strcmp(mask_setting,"All") == 0) this_box_volume.geometry.mask_mode = 1;
        else if (strcmp(mask_setting,"ANY") == 0 || strcmp(mask_setting,"Any") == 0) this_box_volume.geometry.mask_mode = 2;
        else {
            printf("The mask_mode of component %s is set to %s, but must be either ALL or ANY.\n",NAME_CURRENT_COMP,mask_setting);
            exit(1);
        }
    }
    
    for (loop_index=0;loop_index<global_geometry_list.num_elements;loop_index++) {
        // Add mask list
        if (1 == manual_linking_function(global_geometry_list.elements[loop_index].name,mask_string)) {
            add_element_to_int_list(&this_box_volume.geometry.mask_list,global_geometry_list.elements[loop_index].component_index);
            add_element_to_int_list(&global_geometry_list.elements[loop_index].Volume->geometry.masked_by_list,INDEX_CURRENT_COMP);
            global_geometry_list.elements[loop_index].Volume->geometry.is_masked_volume = 1;
            if (this_box_volume.geometry.mask_mode == 2)
                global_geometry_list.elements[loop_index].Volume->geometry.mask_mode = 2;
            if (this_box_volume.geometry.mask_mode == 1) {
                if (global_geometry_list.elements[loop_index].Volume->geometry.is_masked_volume == 1 && global_geometry_list.elements[loop_index].Volume->geometry.mask_mode != 2)
                    // If more than one mask is added to one volume, the ANY mode overwrites the (default) ALL mode.
                    global_geometry_list.elements[loop_index].Volume->geometry.mask_mode = 1;
            }
            
            found_geometries = 1;
        }
    }
    if (found_geometries == 0) {
        printf("The mask_string in geometry: %s did not find any of the specified volumes in the mask_string %s \n",NAME_CURRENT_COMP,mask_string);
        exit(1);
    }
    this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
    this_box_volume.p_physics->is_vacuum = 0; // Makes this volume a vacuum
    this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
    this_box_volume.p_physics->my_a = 0; // Should not be used.
    sprintf(this_box_volume.p_physics->name,"Mask");
    this_box_volume.geometry.is_mask_volume = 1;
    
    
// Read the material input, or if it lacks, use automatic linking.
} else if (material_string && strlen(material_string) && strcmp(material_string, "NULL") && strcmp(material_string, "0")) {
    // A geometry string was given, use it to determine which material
    if (0 == strcmp(material_string,"vacuum") || 0 == strcmp(material_string,"Vacuum")) {
        // One could have a global physics struct for vacuum instead of creating one for each
        this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
        this_box_volume.p_physics->is_vacuum = 1; // Makes this volume a vacuum
        this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
        this_box_volume.p_physics->my_a = 0; // Should not be used.
        sprintf(this_box_volume.p_physics->name,"Vacuum");
    } else if (0 == strcmp(material_string,"exit") || 0 == strcmp(material_string,"Exit")) {
        // One could have a global physics struct for vacuum instead of creating one for each
        this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
        this_box_volume.p_physics->is_vacuum = 1; // Makes this volume a vacuum
        this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
        this_box_volume.p_physics->my_a = 0; // Should not be used.
        this_box_volume.geometry.is_exit_volume = 1;
        sprintf(this_box_volume.p_physics->name,"Exit");
    } else {
        #ifndef MATERIAL_DETECTOR
            printf("Need to define a material before refering to it in a geometry %s.\n",NAME_CURRENT_COMP);
            exit(1);
        #endif
        for (loop_index=0;loop_index<global_material_list.num_elements;loop_index++) {
            if (0 == strcmp(material_string,global_material_list.elements[loop_index].name)) {
                this_box_volume.p_physics = global_material_list.elements[loop_index].physics;
                break;
            }
            if (loop_index == global_material_list.num_elements-1) {
            printf("\n");
            printf("ERROR: The material string \"%s\" in Union geometry \"%s\" did not match a specified material. \n",material_string,NAME_CURRENT_COMP);
            printf("       The materials available at this point (need to be defined before the geometry): \n");
            for (loop_index=0;loop_index<global_material_list.num_elements;loop_index++)
              printf("         %s\n",global_material_list.elements[loop_index].name);
            printf("\n");
            printf("       It is also possible to use one of the defualt materials avaiable: \n");
            printf("           Vacuum (for a Volume without scattering or absorption)\n");
            printf("           Exit (for a Volume where the ray exits the component if it enters)\n");
            printf("           Mask (for a Volume that masks existing volumes specified in the mask_string\n");
            exit(1);
          }
        }
    }
} else {
    // Automatic linking, simply using the last defined material.
    #ifndef MATERIAL_DETECTOR
        printf("Need to define a material before the geometry to use automatic linking %s.\n",NAME_CURRENT_COMP);
        exit(1);
    #endif
    this_box_volume.p_physics = global_material_list.elements[global_material_list.num_elements-1].physics;
}

sprintf(this_box_volume.name,NAME_CURRENT_COMP);
sprintf(this_box_volume.geometry.shape,"box");
this_box_volume.geometry.priority_value = priority;
this_box_volume.geometry.geometry_p_interact = p_interact;
// Currently the coordinates will be in absolute space.
this_box_volume.geometry.center = POS_A_CURRENT_COMP;

this_box_storage.z_depth = zdepth;
this_box_storage.x_width1 = xwidth;
this_box_storage.y_height1 = yheight;

this_box_storage.is_rectangle = 0;
if (xwidth2 < 0 && yheight2 < 0) this_box_storage.is_rectangle = 1;
if (xwidth == xwidth2 && yheight == yheight2) this_box_storage.is_rectangle = 1;

if (xwidth2 < 0) {
    this_box_storage.x_width2 = xwidth;
    xwidth2 = xwidth;
} else this_box_storage.x_width2 = xwidth2;

if (yheight2 < 0) {
    this_box_storage.y_height2 = yheight;
    yheight2 = yheight;
} else this_box_storage.y_height2 = yheight2;


this_box_storage.normal_vectors[0] = coords_set(0,0,1);
this_box_storage.normal_vectors[1] = coords_set(0,0,1);

// for sides with y component = 0
x_component = 2*zdepth/sqrt((xwidth-xwidth2)*(xwidth-xwidth2)+4*zdepth*zdepth);
z_component = (xwidth-xwidth2)/sqrt(4*zdepth*zdepth+(xwidth-xwidth2)*(xwidth-xwidth2));

this_box_storage.normal_vectors[2] = coords_set(x_component,0,z_component);
this_box_storage.normal_vectors[3] = coords_set(-x_component,0,z_component);

// for sides with x component = 0
y_component = 2*zdepth/sqrt((yheight-yheight2)*(yheight-yheight2)+4*zdepth*zdepth);
z_component = (yheight-yheight2)/sqrt(4*zdepth*zdepth+(yheight-yheight2)*(yheight-yheight2));

this_box_storage.normal_vectors[4] = coords_set(0,y_component,z_component);
this_box_storage.normal_vectors[5] = coords_set(0,-y_component,z_component);

this_box_volume.geometry.visualization_on = visualize;

this_box_volume.geometry.geometry_parameters.p_box_storage = &this_box_storage;

// Assign pointers to functions for intersection with the shape, checking if a point is inside the shape
if (this_box_storage.is_rectangle == 1) {
this_box_volume.geometry.intersect_function = &sample_box_intersect_simple;
this_box_volume.geometry.within_function = &r_within_box_simple;
}
else {
this_box_volume.geometry.intersect_function = &sample_box_intersect_advanced;
this_box_volume.geometry.within_function = &r_within_box_advanced;
}

this_box_volume.geometry.shell_points = &box_shell_points;
this_box_volume.geometry.mcdisplay_function = &mcdisplay_box_function;
this_box_volume.geometry.initialize_from_main_function = &initialize_box_geometry_from_main_component;
this_box_volume.geometry.process_rot_allocated = 0;

this_box_volume.geometry.copy_geometry_parameters = &allocate_box_storage_copy;

rot_copy(this_box_volume.geometry.rotation_matrix,ROT_A_CURRENT_COMP); //check how ROT_R_CURRENT_COMP would work
rot_transpose(ROT_A_CURRENT_COMP,this_box_volume.geometry.transpose_rotation_matrix);

// Initialize loggers
this_box_volume.loggers.num_elements = 0;

// packing the information into the global_geometry_element, which is then included in the global_geometry_list.
sprintf(global_geometry_element.name,NAME_CURRENT_COMP);
global_geometry_element.activation_counter = number_of_activations;
global_geometry_element.component_index = INDEX_CURRENT_COMP;
global_geometry_element.Volume = &this_box_volume; // Would be nicer if this m was a pointer, now we have the (small) data two places
add_element_to_geometry_list(&global_geometry_list,global_geometry_element);
}
#line 270746 "MACS_sample_kidney_box.c"
#undef number_of_activations
#undef mask_setting
#undef mask_string
#undef p_interact
#undef focus_r
#undef focus_xh
#undef focus_xw
#undef focus_ah
#undef focus_aw
#undef target_z
#undef target_y
#undef target_x
#undef target_index
#undef visualize
#undef yheight2
#undef xwidth2
#undef zdepth
#undef yheight
#undef xwidth
#undef priority
#undef material_string
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

  /* Initializations for component channel_12_cave1_box3. */
  SIG_MESSAGE("channel_12_cave1_box3 (Init)");
#define mccompcurname  channel_12_cave1_box3
#define mccompcurtype  Union_box
#define mccompcurindex 582
#define loop_index mccchannel_12_cave1_box3_loop_index
#define this_box_volume mccchannel_12_cave1_box3_this_box_volume
#define global_geometry_element mccchannel_12_cave1_box3_global_geometry_element
#define this_box_storage mccchannel_12_cave1_box3_this_box_storage
#define material_string mccchannel_12_cave1_box3_material_string
#define priority mccchannel_12_cave1_box3_priority
#define xwidth mccchannel_12_cave1_box3_xwidth
#define yheight mccchannel_12_cave1_box3_yheight
#define zdepth mccchannel_12_cave1_box3_zdepth
#define xwidth2 mccchannel_12_cave1_box3_xwidth2
#define yheight2 mccchannel_12_cave1_box3_yheight2
#define visualize mccchannel_12_cave1_box3_visualize
#define target_index mccchannel_12_cave1_box3_target_index
#define target_x mccchannel_12_cave1_box3_target_x
#define target_y mccchannel_12_cave1_box3_target_y
#define target_z mccchannel_12_cave1_box3_target_z
#define focus_aw mccchannel_12_cave1_box3_focus_aw
#define focus_ah mccchannel_12_cave1_box3_focus_ah
#define focus_xw mccchannel_12_cave1_box3_focus_xw
#define focus_xh mccchannel_12_cave1_box3_focus_xh
#define focus_r mccchannel_12_cave1_box3_focus_r
#define p_interact mccchannel_12_cave1_box3_p_interact
#define mask_string mccchannel_12_cave1_box3_mask_string
#define mask_setting mccchannel_12_cave1_box3_mask_setting
#define number_of_activations mccchannel_12_cave1_box3_number_of_activations
#line 224 "Union_box.comp"
{
// Initializes the focusing system for this volume including input sanitation.
focus_initialize(&this_box_volume.geometry, POS_A_COMP_INDEX(INDEX_CURRENT_COMP+target_index), POS_A_CURRENT_COMP, ROT_A_CURRENT_COMP, target_index, target_x, target_y, target_z, focus_aw, focus_ah, focus_xw, focus_xh, focus_r, NAME_CURRENT_COMP);

// Input sanitation for this geometry
if (xwidth <= 0) {
  printf("\nERROR in Union_box named %s, the xwidth is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (yheight <= 0) {
  printf("\nERROR in Union_box named %s, yheight is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (zdepth <= 0) {
  printf("\nERROR in Union_box named %s, zdepth is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (xwidth2 <= 0 && xwidth2 != -1) {
  printf("\nERROR in Union_box named %s, the xwidth2 is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (yheight2 <= 0 && yheight2 != -1) {
  printf("\nERROR in Union_box named %s, yheight2 is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}

// Use sanitation
if (global_material_list.num_elements == 0) {
  printf("\nERROR: Need to define a material using Union_make_material before using a Union geometry component. \n");
  printf("       %s was defined before first use of Union_make_material.\n",NAME_CURRENT_COMP);
  exit(1);
}

this_box_volume.geometry.is_masked_volume = 0;
this_box_volume.geometry.is_exit_volume = 0;
this_box_volume.geometry.is_mask_volume = 0;
// check if the volume is a mask, if it is the material string is irelevant.
if (mask_string && strlen(mask_string) && strcmp(mask_string, "NULL") && strcmp(mask_string, "0")) {
    // A mask volume is used to limit the extend of other volumes, called the masked volumes. These are specified in the mask_string.
    // In order for a ray to enter a masked volume, it needs to be both in the region covered by that volume AND the mask volume.
    // When more than
    this_box_volume.geometry.mask_mode = 1; // Default is mask mode is ALL
    if (mask_setting && strlen(mask_setting) && strcmp(mask_setting, "NULL") && strcmp(mask_setting, "0")) {
        if (strcmp(mask_setting,"ALL") == 0 || strcmp(mask_setting,"All") == 0) this_box_volume.geometry.mask_mode = 1;
        else if (strcmp(mask_setting,"ANY") == 0 || strcmp(mask_setting,"Any") == 0) this_box_volume.geometry.mask_mode = 2;
        else {
            printf("The mask_mode of component %s is set to %s, but must be either ALL or ANY.\n",NAME_CURRENT_COMP,mask_setting);
            exit(1);
        }
    }
    
    for (loop_index=0;loop_index<global_geometry_list.num_elements;loop_index++) {
        // Add mask list
        if (1 == manual_linking_function(global_geometry_list.elements[loop_index].name,mask_string)) {
            add_element_to_int_list(&this_box_volume.geometry.mask_list,global_geometry_list.elements[loop_index].component_index);
            add_element_to_int_list(&global_geometry_list.elements[loop_index].Volume->geometry.masked_by_list,INDEX_CURRENT_COMP);
            global_geometry_list.elements[loop_index].Volume->geometry.is_masked_volume = 1;
            if (this_box_volume.geometry.mask_mode == 2)
                global_geometry_list.elements[loop_index].Volume->geometry.mask_mode = 2;
            if (this_box_volume.geometry.mask_mode == 1) {
                if (global_geometry_list.elements[loop_index].Volume->geometry.is_masked_volume == 1 && global_geometry_list.elements[loop_index].Volume->geometry.mask_mode != 2)
                    // If more than one mask is added to one volume, the ANY mode overwrites the (default) ALL mode.
                    global_geometry_list.elements[loop_index].Volume->geometry.mask_mode = 1;
            }
            
            found_geometries = 1;
        }
    }
    if (found_geometries == 0) {
        printf("The mask_string in geometry: %s did not find any of the specified volumes in the mask_string %s \n",NAME_CURRENT_COMP,mask_string);
        exit(1);
    }
    this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
    this_box_volume.p_physics->is_vacuum = 0; // Makes this volume a vacuum
    this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
    this_box_volume.p_physics->my_a = 0; // Should not be used.
    sprintf(this_box_volume.p_physics->name,"Mask");
    this_box_volume.geometry.is_mask_volume = 1;
    
    
// Read the material input, or if it lacks, use automatic linking.
} else if (material_string && strlen(material_string) && strcmp(material_string, "NULL") && strcmp(material_string, "0")) {
    // A geometry string was given, use it to determine which material
    if (0 == strcmp(material_string,"vacuum") || 0 == strcmp(material_string,"Vacuum")) {
        // One could have a global physics struct for vacuum instead of creating one for each
        this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
        this_box_volume.p_physics->is_vacuum = 1; // Makes this volume a vacuum
        this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
        this_box_volume.p_physics->my_a = 0; // Should not be used.
        sprintf(this_box_volume.p_physics->name,"Vacuum");
    } else if (0 == strcmp(material_string,"exit") || 0 == strcmp(material_string,"Exit")) {
        // One could have a global physics struct for vacuum instead of creating one for each
        this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
        this_box_volume.p_physics->is_vacuum = 1; // Makes this volume a vacuum
        this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
        this_box_volume.p_physics->my_a = 0; // Should not be used.
        this_box_volume.geometry.is_exit_volume = 1;
        sprintf(this_box_volume.p_physics->name,"Exit");
    } else {
        #ifndef MATERIAL_DETECTOR
            printf("Need to define a material before refering to it in a geometry %s.\n",NAME_CURRENT_COMP);
            exit(1);
        #endif
        for (loop_index=0;loop_index<global_material_list.num_elements;loop_index++) {
            if (0 == strcmp(material_string,global_material_list.elements[loop_index].name)) {
                this_box_volume.p_physics = global_material_list.elements[loop_index].physics;
                break;
            }
            if (loop_index == global_material_list.num_elements-1) {
            printf("\n");
            printf("ERROR: The material string \"%s\" in Union geometry \"%s\" did not match a specified material. \n",material_string,NAME_CURRENT_COMP);
            printf("       The materials available at this point (need to be defined before the geometry): \n");
            for (loop_index=0;loop_index<global_material_list.num_elements;loop_index++)
              printf("         %s\n",global_material_list.elements[loop_index].name);
            printf("\n");
            printf("       It is also possible to use one of the defualt materials avaiable: \n");
            printf("           Vacuum (for a Volume without scattering or absorption)\n");
            printf("           Exit (for a Volume where the ray exits the component if it enters)\n");
            printf("           Mask (for a Volume that masks existing volumes specified in the mask_string\n");
            exit(1);
          }
        }
    }
} else {
    // Automatic linking, simply using the last defined material.
    #ifndef MATERIAL_DETECTOR
        printf("Need to define a material before the geometry to use automatic linking %s.\n",NAME_CURRENT_COMP);
        exit(1);
    #endif
    this_box_volume.p_physics = global_material_list.elements[global_material_list.num_elements-1].physics;
}

sprintf(this_box_volume.name,NAME_CURRENT_COMP);
sprintf(this_box_volume.geometry.shape,"box");
this_box_volume.geometry.priority_value = priority;
this_box_volume.geometry.geometry_p_interact = p_interact;
// Currently the coordinates will be in absolute space.
this_box_volume.geometry.center = POS_A_CURRENT_COMP;

this_box_storage.z_depth = zdepth;
this_box_storage.x_width1 = xwidth;
this_box_storage.y_height1 = yheight;

this_box_storage.is_rectangle = 0;
if (xwidth2 < 0 && yheight2 < 0) this_box_storage.is_rectangle = 1;
if (xwidth == xwidth2 && yheight == yheight2) this_box_storage.is_rectangle = 1;

if (xwidth2 < 0) {
    this_box_storage.x_width2 = xwidth;
    xwidth2 = xwidth;
} else this_box_storage.x_width2 = xwidth2;

if (yheight2 < 0) {
    this_box_storage.y_height2 = yheight;
    yheight2 = yheight;
} else this_box_storage.y_height2 = yheight2;


this_box_storage.normal_vectors[0] = coords_set(0,0,1);
this_box_storage.normal_vectors[1] = coords_set(0,0,1);

// for sides with y component = 0
x_component = 2*zdepth/sqrt((xwidth-xwidth2)*(xwidth-xwidth2)+4*zdepth*zdepth);
z_component = (xwidth-xwidth2)/sqrt(4*zdepth*zdepth+(xwidth-xwidth2)*(xwidth-xwidth2));

this_box_storage.normal_vectors[2] = coords_set(x_component,0,z_component);
this_box_storage.normal_vectors[3] = coords_set(-x_component,0,z_component);

// for sides with x component = 0
y_component = 2*zdepth/sqrt((yheight-yheight2)*(yheight-yheight2)+4*zdepth*zdepth);
z_component = (yheight-yheight2)/sqrt(4*zdepth*zdepth+(yheight-yheight2)*(yheight-yheight2));

this_box_storage.normal_vectors[4] = coords_set(0,y_component,z_component);
this_box_storage.normal_vectors[5] = coords_set(0,-y_component,z_component);

this_box_volume.geometry.visualization_on = visualize;

this_box_volume.geometry.geometry_parameters.p_box_storage = &this_box_storage;

// Assign pointers to functions for intersection with the shape, checking if a point is inside the shape
if (this_box_storage.is_rectangle == 1) {
this_box_volume.geometry.intersect_function = &sample_box_intersect_simple;
this_box_volume.geometry.within_function = &r_within_box_simple;
}
else {
this_box_volume.geometry.intersect_function = &sample_box_intersect_advanced;
this_box_volume.geometry.within_function = &r_within_box_advanced;
}

this_box_volume.geometry.shell_points = &box_shell_points;
this_box_volume.geometry.mcdisplay_function = &mcdisplay_box_function;
this_box_volume.geometry.initialize_from_main_function = &initialize_box_geometry_from_main_component;
this_box_volume.geometry.process_rot_allocated = 0;

this_box_volume.geometry.copy_geometry_parameters = &allocate_box_storage_copy;

rot_copy(this_box_volume.geometry.rotation_matrix,ROT_A_CURRENT_COMP); //check how ROT_R_CURRENT_COMP would work
rot_transpose(ROT_A_CURRENT_COMP,this_box_volume.geometry.transpose_rotation_matrix);

// Initialize loggers
this_box_volume.loggers.num_elements = 0;

// packing the information into the global_geometry_element, which is then included in the global_geometry_list.
sprintf(global_geometry_element.name,NAME_CURRENT_COMP);
global_geometry_element.activation_counter = number_of_activations;
global_geometry_element.component_index = INDEX_CURRENT_COMP;
global_geometry_element.Volume = &this_box_volume; // Would be nicer if this m was a pointer, now we have the (small) data two places
add_element_to_geometry_list(&global_geometry_list,global_geometry_element);
}
#line 271016 "MACS_sample_kidney_box.c"
#undef number_of_activations
#undef mask_setting
#undef mask_string
#undef p_interact
#undef focus_r
#undef focus_xh
#undef focus_xw
#undef focus_ah
#undef focus_aw
#undef target_z
#undef target_y
#undef target_x
#undef target_index
#undef visualize
#undef yheight2
#undef xwidth2
#undef zdepth
#undef yheight
#undef xwidth
#undef priority
#undef material_string
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

  /* Initializations for component channel_12_cave1_cyl1. */
  SIG_MESSAGE("channel_12_cave1_cyl1 (Init)");
#define mccompcurname  channel_12_cave1_cyl1
#define mccompcurtype  Union_cylinder
#define mccompcurindex 583
#define loop_index mccchannel_12_cave1_cyl1_loop_index
#define this_cylinder_volume mccchannel_12_cave1_cyl1_this_cylinder_volume
#define global_geometry_element mccchannel_12_cave1_cyl1_global_geometry_element
#define this_cylinder_storage mccchannel_12_cave1_cyl1_this_cylinder_storage
#define material_string mccchannel_12_cave1_cyl1_material_string
#define priority mccchannel_12_cave1_cyl1_priority
#define radius mccchannel_12_cave1_cyl1_radius
#define yheight mccchannel_12_cave1_cyl1_yheight
#define visualize mccchannel_12_cave1_cyl1_visualize
#define target_index mccchannel_12_cave1_cyl1_target_index
#define target_x mccchannel_12_cave1_cyl1_target_x
#define target_y mccchannel_12_cave1_cyl1_target_y
#define target_z mccchannel_12_cave1_cyl1_target_z
#define focus_aw mccchannel_12_cave1_cyl1_focus_aw
#define focus_ah mccchannel_12_cave1_cyl1_focus_ah
#define focus_xw mccchannel_12_cave1_cyl1_focus_xw
#define focus_xh mccchannel_12_cave1_cyl1_focus_xh
#define focus_r mccchannel_12_cave1_cyl1_focus_r
#define p_interact mccchannel_12_cave1_cyl1_p_interact
#define mask_string mccchannel_12_cave1_cyl1_mask_string
#define mask_setting mccchannel_12_cave1_cyl1_mask_setting
#define number_of_activations mccchannel_12_cave1_cyl1_number_of_activations
#line 185 "Union_cylinder.comp"
{
// Initializes the focusing system for this volume including input sanitation.
focus_initialize(&this_cylinder_volume.geometry, POS_A_COMP_INDEX(INDEX_CURRENT_COMP+target_index), POS_A_CURRENT_COMP, ROT_A_CURRENT_COMP, target_index, target_x, target_y, target_z, focus_aw, focus_ah, focus_xw, focus_xh, focus_r, NAME_CURRENT_COMP);

// Input sanitation for this geometry
if (radius <= 0) {
  printf("\nERROR in Union_cylinder named %s, the radius is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}

if (yheight <= 0) {
  printf("\nERROR in Union_cylinder named %s, yheight is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}

// Use sanitation
#ifdef MATERIAL_DETECTOR
if (global_material_list.num_elements == 0) {
  // Here if the user have defined a material, but only after this material
  printf("\nERROR: Need to define a material using Union_make_material before using a Union geometry component. \n");
  printf("       %s was defined before first use of Union_make_material.\n",NAME_CURRENT_COMP);
  exit(1);
}
#endif
#ifndef MATERIAL_DETECTOR
  printf("\nERROR: Need to define a material using Union_make_material before using a Union geometry component. \n");
  exit(1);
#endif


this_cylinder_volume.geometry.is_masked_volume = 0;
this_cylinder_volume.geometry.is_exit_volume = 0;
this_cylinder_volume.geometry.is_mask_volume = 0;

// Read the material input, or if it lacks, use automatic linking.
if (mask_string && strlen(mask_string) && strcmp(mask_string, "NULL") && strcmp(mask_string, "0")) {
    // A mask volume is used to limit the extend of other volumes, called the masked volumes. These are specified in the mask_string.
    // In order for a ray to enter a masked volume, it needs to be both in the region covered by that volume AND the mask volume.
    // When more than
    this_cylinder_volume.geometry.mask_mode = 1; // Default is mask mode is ALL
    if (mask_setting && strlen(mask_setting) && strcmp(mask_setting, "NULL") && strcmp(mask_setting, "0")) {
        if (strcmp(mask_setting,"ALL") == 0 || strcmp(mask_setting,"All") == 0) this_cylinder_volume.geometry.mask_mode = 1;
        else if (strcmp(mask_setting,"ANY") == 0 || strcmp(mask_setting,"Any") == 0) this_cylinder_volume.geometry.mask_mode = 2;
        else {
            printf("The mask_mode of component %s is set to %s, but must be either ALL or ANY.\n",NAME_CURRENT_COMP,mask_setting);
            exit(1);
        }
    }
    
    for (loop_index=0;loop_index<global_geometry_list.num_elements;loop_index++) {
        // Add mask list
        if (1 == manual_linking_function(global_geometry_list.elements[loop_index].name,mask_string)) {
            add_element_to_int_list(&this_cylinder_volume.geometry.mask_list,global_geometry_list.elements[loop_index].component_index);
            add_element_to_int_list(&global_geometry_list.elements[loop_index].Volume->geometry.masked_by_list,INDEX_CURRENT_COMP);
            global_geometry_list.elements[loop_index].Volume->geometry.is_masked_volume = 1;
            if (this_cylinder_volume.geometry.mask_mode == 2)
                global_geometry_list.elements[loop_index].Volume->geometry.mask_mode = 2;
            if (this_cylinder_volume.geometry.mask_mode == 1) {
                if (global_geometry_list.elements[loop_index].Volume->geometry.is_masked_volume == 1 && global_geometry_list.elements[loop_index].Volume->geometry.mask_mode != 2)
                    // If more than one mask is added to one volume, the ANY mode overwrites the (default) ALL mode.
                    global_geometry_list.elements[loop_index].Volume->geometry.mask_mode = 1;
            }
            
            found_geometries = 1;
        }
    }
    if (found_geometries == 0) {
        printf("The mask_string in geometry: %s did not find any of the specified volumes in the mask_string %s \n",NAME_CURRENT_COMP,mask_string);
        exit(1);
    }
    this_cylinder_volume.p_physics = malloc(sizeof(struct physics_struct));
    this_cylinder_volume.p_physics->is_vacuum = 0; // Makes this volume a vacuum
    this_cylinder_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
    this_cylinder_volume.p_physics->my_a = 0; // Should not be used.
    sprintf(this_cylinder_volume.p_physics->name,"Mask");
    this_cylinder_volume.geometry.is_mask_volume = 1;
    
    
// Read the material input, or if it lacks, use automatic linking.
} else if (material_string && strlen(material_string) && strcmp(material_string, "NULL") && strcmp(material_string, "0")) {
    // A geometry string was given, use it to determine which material
    if (0 == strcmp(material_string,"vacuum") || 0 == strcmp(material_string,"Vacuum")) {
        // One could have a global physics struct for vacuum instead of creating one for each
        this_cylinder_volume.p_physics = malloc(sizeof(struct physics_struct));
        this_cylinder_volume.p_physics->is_vacuum = 1; // Makes this volume a vacuum
        this_cylinder_volume.p_physics->number_of_processes = (int) 0;
        this_cylinder_volume.p_physics->my_a = 0; // Should not be used.
        sprintf(this_cylinder_volume.p_physics->name,"Vacuum");
    } else if (0 == strcmp(material_string,"exit") || 0 == strcmp(material_string,"Exit")) {
        // One could have a global physics struct for exit instead of creating one for each
        this_cylinder_volume.p_physics = malloc(sizeof(struct physics_struct));
        this_cylinder_volume.p_physics->is_vacuum = 1; // Makes this volume a vacuum
        this_cylinder_volume.p_physics->number_of_processes = (int) 0;
        this_cylinder_volume.p_physics->my_a = 0; // Should not be used.
        this_cylinder_volume.geometry.is_exit_volume = 1;
        sprintf(this_cylinder_volume.p_physics->name,"Exit");
    } else {
        for (loop_index=0;loop_index<global_material_list.num_elements;loop_index++) {
          if (0 == strcmp(material_string,global_material_list.elements[loop_index].name)) {
            this_cylinder_volume.p_physics = global_material_list.elements[loop_index].physics;
            break;
          }
          if (loop_index == global_material_list.num_elements-1) {
            printf("\n");
            printf("ERROR: The material string \"%s\" in Union geometry \"%s\" did not match a specified material. \n",material_string,NAME_CURRENT_COMP);
            printf("       The materials available at this point (need to be defined before the geometry): \n");
            for (loop_index=0;loop_index<global_material_list.num_elements;loop_index++)
              printf("         %s\n",global_material_list.elements[loop_index].name);
            printf("\n");
            printf("       It is also possible to use one of the defualt materials avaiable: \n");
            printf("           Vacuum (for a Volume without scattering or absorption)\n");
            printf("           Exit (for a Volume where the ray exits the component if it enters)\n");
            printf("           Mask (for a Volume that masks existing volumes specified in the mask_string\n");
            exit(1);
          }
        }
    }
} else {
    // Automatic linking, simply using the last defined material.
    #ifndef MATERIAL_DETECTOR
        printf("Need to define a material before the geometry to use automatic linking %s.\n",NAME_CURRENT_COMP);
        exit(1);
    #endif
    this_cylinder_volume.p_physics = global_material_list.elements[global_material_list.num_elements-1].physics;
}

sprintf(this_cylinder_volume.name,NAME_CURRENT_COMP);
sprintf(this_cylinder_volume.geometry.shape,"cylinder");
this_cylinder_volume.geometry.priority_value = priority;
// Currently the coordinates will be in absolute space.
this_cylinder_volume.geometry.center = POS_A_CURRENT_COMP;

this_cylinder_volume.geometry.geometry_p_interact = p_interact;
this_cylinder_storage.cyl_radius = radius;
this_cylinder_storage.height = yheight;
this_cylinder_volume.geometry.visualization_on = visualize;
this_cylinder_volume.geometry.geometry_parameters.p_cylinder_storage = &this_cylinder_storage;
this_cylinder_volume.geometry.within_function = &r_within_cylinder;
this_cylinder_volume.geometry.intersect_function = &sample_cylinder_intersect;
this_cylinder_volume.geometry.mcdisplay_function = &mcdisplay_cylinder_function;
this_cylinder_volume.geometry.shell_points = &cylinder_shell_points;
this_cylinder_volume.geometry.initialize_from_main_function = &initialize_cylinder_geometry_from_main_component;
this_cylinder_volume.geometry.process_rot_allocated = 0;
this_cylinder_volume.geometry.copy_geometry_parameters = &allocate_cylinder_storage_copy;

rot_copy(this_cylinder_volume.geometry.rotation_matrix,ROT_A_CURRENT_COMP);
rot_transpose(ROT_A_CURRENT_COMP,this_cylinder_volume.geometry.transpose_rotation_matrix);

// Initialize loggers
this_cylinder_volume.loggers.num_elements = 0;

// packing the information into the global_geometry_element, which is then included in the global_geometry_list.
sprintf(global_geometry_element.name,NAME_CURRENT_COMP);
global_geometry_element.activation_counter = number_of_activations;
global_geometry_element.component_index = INDEX_CURRENT_COMP;
global_geometry_element.Volume = &this_cylinder_volume; // Would be nicer if this m was a pointer, now we have the (small) data two places
add_element_to_geometry_list(&global_geometry_list,global_geometry_element);
}
#line 271232 "MACS_sample_kidney_box.c"
#undef number_of_activations
#undef mask_setting
#undef mask_string
#undef p_interact
#undef focus_r
#undef focus_xh
#undef focus_xw
#undef focus_ah
#undef focus_aw
#undef target_z
#undef target_y
#undef target_x
#undef target_index
#undef visualize
#undef yheight
#undef radius
#undef priority
#undef material_string
#undef this_cylinder_storage
#undef global_geometry_element
#undef this_cylinder_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

  /* Initializations for component channel_12_analyzer_1_center. */
  SIG_MESSAGE("channel_12_analyzer_1_center (Init)");

  /* Initializations for component channel_12_analyzer_1_rotated. */
  SIG_MESSAGE("channel_12_analyzer_1_rotated (Init)");

  /* Initializations for component channel_12_analyzer_1_array_crystal_array_0. */
  SIG_MESSAGE("channel_12_analyzer_1_array_crystal_array_0 (Init)");
#define mccompcurname  channel_12_analyzer_1_array_crystal_array_0
#define mccompcurtype  Union_box
#define mccompcurindex 586
#define loop_index mccchannel_12_analyzer_1_array_crystal_array_0_loop_index
#define this_box_volume mccchannel_12_analyzer_1_array_crystal_array_0_this_box_volume
#define global_geometry_element mccchannel_12_analyzer_1_array_crystal_array_0_global_geometry_element
#define this_box_storage mccchannel_12_analyzer_1_array_crystal_array_0_this_box_storage
#define material_string mccchannel_12_analyzer_1_array_crystal_array_0_material_string
#define priority mccchannel_12_analyzer_1_array_crystal_array_0_priority
#define xwidth mccchannel_12_analyzer_1_array_crystal_array_0_xwidth
#define yheight mccchannel_12_analyzer_1_array_crystal_array_0_yheight
#define zdepth mccchannel_12_analyzer_1_array_crystal_array_0_zdepth
#define xwidth2 mccchannel_12_analyzer_1_array_crystal_array_0_xwidth2
#define yheight2 mccchannel_12_analyzer_1_array_crystal_array_0_yheight2
#define visualize mccchannel_12_analyzer_1_array_crystal_array_0_visualize
#define target_index mccchannel_12_analyzer_1_array_crystal_array_0_target_index
#define target_x mccchannel_12_analyzer_1_array_crystal_array_0_target_x
#define target_y mccchannel_12_analyzer_1_array_crystal_array_0_target_y
#define target_z mccchannel_12_analyzer_1_array_crystal_array_0_target_z
#define focus_aw mccchannel_12_analyzer_1_array_crystal_array_0_focus_aw
#define focus_ah mccchannel_12_analyzer_1_array_crystal_array_0_focus_ah
#define focus_xw mccchannel_12_analyzer_1_array_crystal_array_0_focus_xw
#define focus_xh mccchannel_12_analyzer_1_array_crystal_array_0_focus_xh
#define focus_r mccchannel_12_analyzer_1_array_crystal_array_0_focus_r
#define p_interact mccchannel_12_analyzer_1_array_crystal_array_0_p_interact
#define mask_string mccchannel_12_analyzer_1_array_crystal_array_0_mask_string
#define mask_setting mccchannel_12_analyzer_1_array_crystal_array_0_mask_setting
#define number_of_activations mccchannel_12_analyzer_1_array_crystal_array_0_number_of_activations
#line 224 "Union_box.comp"
{
// Initializes the focusing system for this volume including input sanitation.
focus_initialize(&this_box_volume.geometry, POS_A_COMP_INDEX(INDEX_CURRENT_COMP+target_index), POS_A_CURRENT_COMP, ROT_A_CURRENT_COMP, target_index, target_x, target_y, target_z, focus_aw, focus_ah, focus_xw, focus_xh, focus_r, NAME_CURRENT_COMP);

// Input sanitation for this geometry
if (xwidth <= 0) {
  printf("\nERROR in Union_box named %s, the xwidth is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (yheight <= 0) {
  printf("\nERROR in Union_box named %s, yheight is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (zdepth <= 0) {
  printf("\nERROR in Union_box named %s, zdepth is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (xwidth2 <= 0 && xwidth2 != -1) {
  printf("\nERROR in Union_box named %s, the xwidth2 is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (yheight2 <= 0 && yheight2 != -1) {
  printf("\nERROR in Union_box named %s, yheight2 is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}

// Use sanitation
if (global_material_list.num_elements == 0) {
  printf("\nERROR: Need to define a material using Union_make_material before using a Union geometry component. \n");
  printf("       %s was defined before first use of Union_make_material.\n",NAME_CURRENT_COMP);
  exit(1);
}

this_box_volume.geometry.is_masked_volume = 0;
this_box_volume.geometry.is_exit_volume = 0;
this_box_volume.geometry.is_mask_volume = 0;
// check if the volume is a mask, if it is the material string is irelevant.
if (mask_string && strlen(mask_string) && strcmp(mask_string, "NULL") && strcmp(mask_string, "0")) {
    // A mask volume is used to limit the extend of other volumes, called the masked volumes. These are specified in the mask_string.
    // In order for a ray to enter a masked volume, it needs to be both in the region covered by that volume AND the mask volume.
    // When more than
    this_box_volume.geometry.mask_mode = 1; // Default is mask mode is ALL
    if (mask_setting && strlen(mask_setting) && strcmp(mask_setting, "NULL") && strcmp(mask_setting, "0")) {
        if (strcmp(mask_setting,"ALL") == 0 || strcmp(mask_setting,"All") == 0) this_box_volume.geometry.mask_mode = 1;
        else if (strcmp(mask_setting,"ANY") == 0 || strcmp(mask_setting,"Any") == 0) this_box_volume.geometry.mask_mode = 2;
        else {
            printf("The mask_mode of component %s is set to %s, but must be either ALL or ANY.\n",NAME_CURRENT_COMP,mask_setting);
            exit(1);
        }
    }
    
    for (loop_index=0;loop_index<global_geometry_list.num_elements;loop_index++) {
        // Add mask list
        if (1 == manual_linking_function(global_geometry_list.elements[loop_index].name,mask_string)) {
            add_element_to_int_list(&this_box_volume.geometry.mask_list,global_geometry_list.elements[loop_index].component_index);
            add_element_to_int_list(&global_geometry_list.elements[loop_index].Volume->geometry.masked_by_list,INDEX_CURRENT_COMP);
            global_geometry_list.elements[loop_index].Volume->geometry.is_masked_volume = 1;
            if (this_box_volume.geometry.mask_mode == 2)
                global_geometry_list.elements[loop_index].Volume->geometry.mask_mode = 2;
            if (this_box_volume.geometry.mask_mode == 1) {
                if (global_geometry_list.elements[loop_index].Volume->geometry.is_masked_volume == 1 && global_geometry_list.elements[loop_index].Volume->geometry.mask_mode != 2)
                    // If more than one mask is added to one volume, the ANY mode overwrites the (default) ALL mode.
                    global_geometry_list.elements[loop_index].Volume->geometry.mask_mode = 1;
            }
            
            found_geometries = 1;
        }
    }
    if (found_geometries == 0) {
        printf("The mask_string in geometry: %s did not find any of the specified volumes in the mask_string %s \n",NAME_CURRENT_COMP,mask_string);
        exit(1);
    }
    this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
    this_box_volume.p_physics->is_vacuum = 0; // Makes this volume a vacuum
    this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
    this_box_volume.p_physics->my_a = 0; // Should not be used.
    sprintf(this_box_volume.p_physics->name,"Mask");
    this_box_volume.geometry.is_mask_volume = 1;
    
    
// Read the material input, or if it lacks, use automatic linking.
} else if (material_string && strlen(material_string) && strcmp(material_string, "NULL") && strcmp(material_string, "0")) {
    // A geometry string was given, use it to determine which material
    if (0 == strcmp(material_string,"vacuum") || 0 == strcmp(material_string,"Vacuum")) {
        // One could have a global physics struct for vacuum instead of creating one for each
        this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
        this_box_volume.p_physics->is_vacuum = 1; // Makes this volume a vacuum
        this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
        this_box_volume.p_physics->my_a = 0; // Should not be used.
        sprintf(this_box_volume.p_physics->name,"Vacuum");
    } else if (0 == strcmp(material_string,"exit") || 0 == strcmp(material_string,"Exit")) {
        // One could have a global physics struct for vacuum instead of creating one for each
        this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
        this_box_volume.p_physics->is_vacuum = 1; // Makes this volume a vacuum
        this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
        this_box_volume.p_physics->my_a = 0; // Should not be used.
        this_box_volume.geometry.is_exit_volume = 1;
        sprintf(this_box_volume.p_physics->name,"Exit");
    } else {
        #ifndef MATERIAL_DETECTOR
            printf("Need to define a material before refering to it in a geometry %s.\n",NAME_CURRENT_COMP);
            exit(1);
        #endif
        for (loop_index=0;loop_index<global_material_list.num_elements;loop_index++) {
            if (0 == strcmp(material_string,global_material_list.elements[loop_index].name)) {
                this_box_volume.p_physics = global_material_list.elements[loop_index].physics;
                break;
            }
            if (loop_index == global_material_list.num_elements-1) {
            printf("\n");
            printf("ERROR: The material string \"%s\" in Union geometry \"%s\" did not match a specified material. \n",material_string,NAME_CURRENT_COMP);
            printf("       The materials available at this point (need to be defined before the geometry): \n");
            for (loop_index=0;loop_index<global_material_list.num_elements;loop_index++)
              printf("         %s\n",global_material_list.elements[loop_index].name);
            printf("\n");
            printf("       It is also possible to use one of the defualt materials avaiable: \n");
            printf("           Vacuum (for a Volume without scattering or absorption)\n");
            printf("           Exit (for a Volume where the ray exits the component if it enters)\n");
            printf("           Mask (for a Volume that masks existing volumes specified in the mask_string\n");
            exit(1);
          }
        }
    }
} else {
    // Automatic linking, simply using the last defined material.
    #ifndef MATERIAL_DETECTOR
        printf("Need to define a material before the geometry to use automatic linking %s.\n",NAME_CURRENT_COMP);
        exit(1);
    #endif
    this_box_volume.p_physics = global_material_list.elements[global_material_list.num_elements-1].physics;
}

sprintf(this_box_volume.name,NAME_CURRENT_COMP);
sprintf(this_box_volume.geometry.shape,"box");
this_box_volume.geometry.priority_value = priority;
this_box_volume.geometry.geometry_p_interact = p_interact;
// Currently the coordinates will be in absolute space.
this_box_volume.geometry.center = POS_A_CURRENT_COMP;

this_box_storage.z_depth = zdepth;
this_box_storage.x_width1 = xwidth;
this_box_storage.y_height1 = yheight;

this_box_storage.is_rectangle = 0;
if (xwidth2 < 0 && yheight2 < 0) this_box_storage.is_rectangle = 1;
if (xwidth == xwidth2 && yheight == yheight2) this_box_storage.is_rectangle = 1;

if (xwidth2 < 0) {
    this_box_storage.x_width2 = xwidth;
    xwidth2 = xwidth;
} else this_box_storage.x_width2 = xwidth2;

if (yheight2 < 0) {
    this_box_storage.y_height2 = yheight;
    yheight2 = yheight;
} else this_box_storage.y_height2 = yheight2;


this_box_storage.normal_vectors[0] = coords_set(0,0,1);
this_box_storage.normal_vectors[1] = coords_set(0,0,1);

// for sides with y component = 0
x_component = 2*zdepth/sqrt((xwidth-xwidth2)*(xwidth-xwidth2)+4*zdepth*zdepth);
z_component = (xwidth-xwidth2)/sqrt(4*zdepth*zdepth+(xwidth-xwidth2)*(xwidth-xwidth2));

this_box_storage.normal_vectors[2] = coords_set(x_component,0,z_component);
this_box_storage.normal_vectors[3] = coords_set(-x_component,0,z_component);

// for sides with x component = 0
y_component = 2*zdepth/sqrt((yheight-yheight2)*(yheight-yheight2)+4*zdepth*zdepth);
z_component = (yheight-yheight2)/sqrt(4*zdepth*zdepth+(yheight-yheight2)*(yheight-yheight2));

this_box_storage.normal_vectors[4] = coords_set(0,y_component,z_component);
this_box_storage.normal_vectors[5] = coords_set(0,-y_component,z_component);

this_box_volume.geometry.visualization_on = visualize;

this_box_volume.geometry.geometry_parameters.p_box_storage = &this_box_storage;

// Assign pointers to functions for intersection with the shape, checking if a point is inside the shape
if (this_box_storage.is_rectangle == 1) {
this_box_volume.geometry.intersect_function = &sample_box_intersect_simple;
this_box_volume.geometry.within_function = &r_within_box_simple;
}
else {
this_box_volume.geometry.intersect_function = &sample_box_intersect_advanced;
this_box_volume.geometry.within_function = &r_within_box_advanced;
}

this_box_volume.geometry.shell_points = &box_shell_points;
this_box_volume.geometry.mcdisplay_function = &mcdisplay_box_function;
this_box_volume.geometry.initialize_from_main_function = &initialize_box_geometry_from_main_component;
this_box_volume.geometry.process_rot_allocated = 0;

this_box_volume.geometry.copy_geometry_parameters = &allocate_box_storage_copy;

rot_copy(this_box_volume.geometry.rotation_matrix,ROT_A_CURRENT_COMP); //check how ROT_R_CURRENT_COMP would work
rot_transpose(ROT_A_CURRENT_COMP,this_box_volume.geometry.transpose_rotation_matrix);

// Initialize loggers
this_box_volume.loggers.num_elements = 0;

// packing the information into the global_geometry_element, which is then included in the global_geometry_list.
sprintf(global_geometry_element.name,NAME_CURRENT_COMP);
global_geometry_element.activation_counter = number_of_activations;
global_geometry_element.component_index = INDEX_CURRENT_COMP;
global_geometry_element.Volume = &this_box_volume; // Would be nicer if this m was a pointer, now we have the (small) data two places
add_element_to_geometry_list(&global_geometry_list,global_geometry_element);
}
#line 271505 "MACS_sample_kidney_box.c"
#undef number_of_activations
#undef mask_setting
#undef mask_string
#undef p_interact
#undef focus_r
#undef focus_xh
#undef focus_xw
#undef focus_ah
#undef focus_aw
#undef target_z
#undef target_y
#undef target_x
#undef target_index
#undef visualize
#undef yheight2
#undef xwidth2
#undef zdepth
#undef yheight
#undef xwidth
#undef priority
#undef material_string
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

  /* Initializations for component channel_12_analyzer_1_array_crystal_array_1. */
  SIG_MESSAGE("channel_12_analyzer_1_array_crystal_array_1 (Init)");
#define mccompcurname  channel_12_analyzer_1_array_crystal_array_1
#define mccompcurtype  Union_box
#define mccompcurindex 587
#define loop_index mccchannel_12_analyzer_1_array_crystal_array_1_loop_index
#define this_box_volume mccchannel_12_analyzer_1_array_crystal_array_1_this_box_volume
#define global_geometry_element mccchannel_12_analyzer_1_array_crystal_array_1_global_geometry_element
#define this_box_storage mccchannel_12_analyzer_1_array_crystal_array_1_this_box_storage
#define material_string mccchannel_12_analyzer_1_array_crystal_array_1_material_string
#define priority mccchannel_12_analyzer_1_array_crystal_array_1_priority
#define xwidth mccchannel_12_analyzer_1_array_crystal_array_1_xwidth
#define yheight mccchannel_12_analyzer_1_array_crystal_array_1_yheight
#define zdepth mccchannel_12_analyzer_1_array_crystal_array_1_zdepth
#define xwidth2 mccchannel_12_analyzer_1_array_crystal_array_1_xwidth2
#define yheight2 mccchannel_12_analyzer_1_array_crystal_array_1_yheight2
#define visualize mccchannel_12_analyzer_1_array_crystal_array_1_visualize
#define target_index mccchannel_12_analyzer_1_array_crystal_array_1_target_index
#define target_x mccchannel_12_analyzer_1_array_crystal_array_1_target_x
#define target_y mccchannel_12_analyzer_1_array_crystal_array_1_target_y
#define target_z mccchannel_12_analyzer_1_array_crystal_array_1_target_z
#define focus_aw mccchannel_12_analyzer_1_array_crystal_array_1_focus_aw
#define focus_ah mccchannel_12_analyzer_1_array_crystal_array_1_focus_ah
#define focus_xw mccchannel_12_analyzer_1_array_crystal_array_1_focus_xw
#define focus_xh mccchannel_12_analyzer_1_array_crystal_array_1_focus_xh
#define focus_r mccchannel_12_analyzer_1_array_crystal_array_1_focus_r
#define p_interact mccchannel_12_analyzer_1_array_crystal_array_1_p_interact
#define mask_string mccchannel_12_analyzer_1_array_crystal_array_1_mask_string
#define mask_setting mccchannel_12_analyzer_1_array_crystal_array_1_mask_setting
#define number_of_activations mccchannel_12_analyzer_1_array_crystal_array_1_number_of_activations
#line 224 "Union_box.comp"
{
// Initializes the focusing system for this volume including input sanitation.
focus_initialize(&this_box_volume.geometry, POS_A_COMP_INDEX(INDEX_CURRENT_COMP+target_index), POS_A_CURRENT_COMP, ROT_A_CURRENT_COMP, target_index, target_x, target_y, target_z, focus_aw, focus_ah, focus_xw, focus_xh, focus_r, NAME_CURRENT_COMP);

// Input sanitation for this geometry
if (xwidth <= 0) {
  printf("\nERROR in Union_box named %s, the xwidth is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (yheight <= 0) {
  printf("\nERROR in Union_box named %s, yheight is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (zdepth <= 0) {
  printf("\nERROR in Union_box named %s, zdepth is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (xwidth2 <= 0 && xwidth2 != -1) {
  printf("\nERROR in Union_box named %s, the xwidth2 is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (yheight2 <= 0 && yheight2 != -1) {
  printf("\nERROR in Union_box named %s, yheight2 is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}

// Use sanitation
if (global_material_list.num_elements == 0) {
  printf("\nERROR: Need to define a material using Union_make_material before using a Union geometry component. \n");
  printf("       %s was defined before first use of Union_make_material.\n",NAME_CURRENT_COMP);
  exit(1);
}

this_box_volume.geometry.is_masked_volume = 0;
this_box_volume.geometry.is_exit_volume = 0;
this_box_volume.geometry.is_mask_volume = 0;
// check if the volume is a mask, if it is the material string is irelevant.
if (mask_string && strlen(mask_string) && strcmp(mask_string, "NULL") && strcmp(mask_string, "0")) {
    // A mask volume is used to limit the extend of other volumes, called the masked volumes. These are specified in the mask_string.
    // In order for a ray to enter a masked volume, it needs to be both in the region covered by that volume AND the mask volume.
    // When more than
    this_box_volume.geometry.mask_mode = 1; // Default is mask mode is ALL
    if (mask_setting && strlen(mask_setting) && strcmp(mask_setting, "NULL") && strcmp(mask_setting, "0")) {
        if (strcmp(mask_setting,"ALL") == 0 || strcmp(mask_setting,"All") == 0) this_box_volume.geometry.mask_mode = 1;
        else if (strcmp(mask_setting,"ANY") == 0 || strcmp(mask_setting,"Any") == 0) this_box_volume.geometry.mask_mode = 2;
        else {
            printf("The mask_mode of component %s is set to %s, but must be either ALL or ANY.\n",NAME_CURRENT_COMP,mask_setting);
            exit(1);
        }
    }
    
    for (loop_index=0;loop_index<global_geometry_list.num_elements;loop_index++) {
        // Add mask list
        if (1 == manual_linking_function(global_geometry_list.elements[loop_index].name,mask_string)) {
            add_element_to_int_list(&this_box_volume.geometry.mask_list,global_geometry_list.elements[loop_index].component_index);
            add_element_to_int_list(&global_geometry_list.elements[loop_index].Volume->geometry.masked_by_list,INDEX_CURRENT_COMP);
            global_geometry_list.elements[loop_index].Volume->geometry.is_masked_volume = 1;
            if (this_box_volume.geometry.mask_mode == 2)
                global_geometry_list.elements[loop_index].Volume->geometry.mask_mode = 2;
            if (this_box_volume.geometry.mask_mode == 1) {
                if (global_geometry_list.elements[loop_index].Volume->geometry.is_masked_volume == 1 && global_geometry_list.elements[loop_index].Volume->geometry.mask_mode != 2)
                    // If more than one mask is added to one volume, the ANY mode overwrites the (default) ALL mode.
                    global_geometry_list.elements[loop_index].Volume->geometry.mask_mode = 1;
            }
            
            found_geometries = 1;
        }
    }
    if (found_geometries == 0) {
        printf("The mask_string in geometry: %s did not find any of the specified volumes in the mask_string %s \n",NAME_CURRENT_COMP,mask_string);
        exit(1);
    }
    this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
    this_box_volume.p_physics->is_vacuum = 0; // Makes this volume a vacuum
    this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
    this_box_volume.p_physics->my_a = 0; // Should not be used.
    sprintf(this_box_volume.p_physics->name,"Mask");
    this_box_volume.geometry.is_mask_volume = 1;
    
    
// Read the material input, or if it lacks, use automatic linking.
} else if (material_string && strlen(material_string) && strcmp(material_string, "NULL") && strcmp(material_string, "0")) {
    // A geometry string was given, use it to determine which material
    if (0 == strcmp(material_string,"vacuum") || 0 == strcmp(material_string,"Vacuum")) {
        // One could have a global physics struct for vacuum instead of creating one for each
        this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
        this_box_volume.p_physics->is_vacuum = 1; // Makes this volume a vacuum
        this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
        this_box_volume.p_physics->my_a = 0; // Should not be used.
        sprintf(this_box_volume.p_physics->name,"Vacuum");
    } else if (0 == strcmp(material_string,"exit") || 0 == strcmp(material_string,"Exit")) {
        // One could have a global physics struct for vacuum instead of creating one for each
        this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
        this_box_volume.p_physics->is_vacuum = 1; // Makes this volume a vacuum
        this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
        this_box_volume.p_physics->my_a = 0; // Should not be used.
        this_box_volume.geometry.is_exit_volume = 1;
        sprintf(this_box_volume.p_physics->name,"Exit");
    } else {
        #ifndef MATERIAL_DETECTOR
            printf("Need to define a material before refering to it in a geometry %s.\n",NAME_CURRENT_COMP);
            exit(1);
        #endif
        for (loop_index=0;loop_index<global_material_list.num_elements;loop_index++) {
            if (0 == strcmp(material_string,global_material_list.elements[loop_index].name)) {
                this_box_volume.p_physics = global_material_list.elements[loop_index].physics;
                break;
            }
            if (loop_index == global_material_list.num_elements-1) {
            printf("\n");
            printf("ERROR: The material string \"%s\" in Union geometry \"%s\" did not match a specified material. \n",material_string,NAME_CURRENT_COMP);
            printf("       The materials available at this point (need to be defined before the geometry): \n");
            for (loop_index=0;loop_index<global_material_list.num_elements;loop_index++)
              printf("         %s\n",global_material_list.elements[loop_index].name);
            printf("\n");
            printf("       It is also possible to use one of the defualt materials avaiable: \n");
            printf("           Vacuum (for a Volume without scattering or absorption)\n");
            printf("           Exit (for a Volume where the ray exits the component if it enters)\n");
            printf("           Mask (for a Volume that masks existing volumes specified in the mask_string\n");
            exit(1);
          }
        }
    }
} else {
    // Automatic linking, simply using the last defined material.
    #ifndef MATERIAL_DETECTOR
        printf("Need to define a material before the geometry to use automatic linking %s.\n",NAME_CURRENT_COMP);
        exit(1);
    #endif
    this_box_volume.p_physics = global_material_list.elements[global_material_list.num_elements-1].physics;
}

sprintf(this_box_volume.name,NAME_CURRENT_COMP);
sprintf(this_box_volume.geometry.shape,"box");
this_box_volume.geometry.priority_value = priority;
this_box_volume.geometry.geometry_p_interact = p_interact;
// Currently the coordinates will be in absolute space.
this_box_volume.geometry.center = POS_A_CURRENT_COMP;

this_box_storage.z_depth = zdepth;
this_box_storage.x_width1 = xwidth;
this_box_storage.y_height1 = yheight;

this_box_storage.is_rectangle = 0;
if (xwidth2 < 0 && yheight2 < 0) this_box_storage.is_rectangle = 1;
if (xwidth == xwidth2 && yheight == yheight2) this_box_storage.is_rectangle = 1;

if (xwidth2 < 0) {
    this_box_storage.x_width2 = xwidth;
    xwidth2 = xwidth;
} else this_box_storage.x_width2 = xwidth2;

if (yheight2 < 0) {
    this_box_storage.y_height2 = yheight;
    yheight2 = yheight;
} else this_box_storage.y_height2 = yheight2;


this_box_storage.normal_vectors[0] = coords_set(0,0,1);
this_box_storage.normal_vectors[1] = coords_set(0,0,1);

// for sides with y component = 0
x_component = 2*zdepth/sqrt((xwidth-xwidth2)*(xwidth-xwidth2)+4*zdepth*zdepth);
z_component = (xwidth-xwidth2)/sqrt(4*zdepth*zdepth+(xwidth-xwidth2)*(xwidth-xwidth2));

this_box_storage.normal_vectors[2] = coords_set(x_component,0,z_component);
this_box_storage.normal_vectors[3] = coords_set(-x_component,0,z_component);

// for sides with x component = 0
y_component = 2*zdepth/sqrt((yheight-yheight2)*(yheight-yheight2)+4*zdepth*zdepth);
z_component = (yheight-yheight2)/sqrt(4*zdepth*zdepth+(yheight-yheight2)*(yheight-yheight2));

this_box_storage.normal_vectors[4] = coords_set(0,y_component,z_component);
this_box_storage.normal_vectors[5] = coords_set(0,-y_component,z_component);

this_box_volume.geometry.visualization_on = visualize;

this_box_volume.geometry.geometry_parameters.p_box_storage = &this_box_storage;

// Assign pointers to functions for intersection with the shape, checking if a point is inside the shape
if (this_box_storage.is_rectangle == 1) {
this_box_volume.geometry.intersect_function = &sample_box_intersect_simple;
this_box_volume.geometry.within_function = &r_within_box_simple;
}
else {
this_box_volume.geometry.intersect_function = &sample_box_intersect_advanced;
this_box_volume.geometry.within_function = &r_within_box_advanced;
}

this_box_volume.geometry.shell_points = &box_shell_points;
this_box_volume.geometry.mcdisplay_function = &mcdisplay_box_function;
this_box_volume.geometry.initialize_from_main_function = &initialize_box_geometry_from_main_component;
this_box_volume.geometry.process_rot_allocated = 0;

this_box_volume.geometry.copy_geometry_parameters = &allocate_box_storage_copy;

rot_copy(this_box_volume.geometry.rotation_matrix,ROT_A_CURRENT_COMP); //check how ROT_R_CURRENT_COMP would work
rot_transpose(ROT_A_CURRENT_COMP,this_box_volume.geometry.transpose_rotation_matrix);

// Initialize loggers
this_box_volume.loggers.num_elements = 0;

// packing the information into the global_geometry_element, which is then included in the global_geometry_list.
sprintf(global_geometry_element.name,NAME_CURRENT_COMP);
global_geometry_element.activation_counter = number_of_activations;
global_geometry_element.component_index = INDEX_CURRENT_COMP;
global_geometry_element.Volume = &this_box_volume; // Would be nicer if this m was a pointer, now we have the (small) data two places
add_element_to_geometry_list(&global_geometry_list,global_geometry_element);
}
#line 271775 "MACS_sample_kidney_box.c"
#undef number_of_activations
#undef mask_setting
#undef mask_string
#undef p_interact
#undef focus_r
#undef focus_xh
#undef focus_xw
#undef focus_ah
#undef focus_aw
#undef target_z
#undef target_y
#undef target_x
#undef target_index
#undef visualize
#undef yheight2
#undef xwidth2
#undef zdepth
#undef yheight
#undef xwidth
#undef priority
#undef material_string
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

  /* Initializations for component channel_12_analyzer_1_array_crystal_array_2. */
  SIG_MESSAGE("channel_12_analyzer_1_array_crystal_array_2 (Init)");
#define mccompcurname  channel_12_analyzer_1_array_crystal_array_2
#define mccompcurtype  Union_box
#define mccompcurindex 588
#define loop_index mccchannel_12_analyzer_1_array_crystal_array_2_loop_index
#define this_box_volume mccchannel_12_analyzer_1_array_crystal_array_2_this_box_volume
#define global_geometry_element mccchannel_12_analyzer_1_array_crystal_array_2_global_geometry_element
#define this_box_storage mccchannel_12_analyzer_1_array_crystal_array_2_this_box_storage
#define material_string mccchannel_12_analyzer_1_array_crystal_array_2_material_string
#define priority mccchannel_12_analyzer_1_array_crystal_array_2_priority
#define xwidth mccchannel_12_analyzer_1_array_crystal_array_2_xwidth
#define yheight mccchannel_12_analyzer_1_array_crystal_array_2_yheight
#define zdepth mccchannel_12_analyzer_1_array_crystal_array_2_zdepth
#define xwidth2 mccchannel_12_analyzer_1_array_crystal_array_2_xwidth2
#define yheight2 mccchannel_12_analyzer_1_array_crystal_array_2_yheight2
#define visualize mccchannel_12_analyzer_1_array_crystal_array_2_visualize
#define target_index mccchannel_12_analyzer_1_array_crystal_array_2_target_index
#define target_x mccchannel_12_analyzer_1_array_crystal_array_2_target_x
#define target_y mccchannel_12_analyzer_1_array_crystal_array_2_target_y
#define target_z mccchannel_12_analyzer_1_array_crystal_array_2_target_z
#define focus_aw mccchannel_12_analyzer_1_array_crystal_array_2_focus_aw
#define focus_ah mccchannel_12_analyzer_1_array_crystal_array_2_focus_ah
#define focus_xw mccchannel_12_analyzer_1_array_crystal_array_2_focus_xw
#define focus_xh mccchannel_12_analyzer_1_array_crystal_array_2_focus_xh
#define focus_r mccchannel_12_analyzer_1_array_crystal_array_2_focus_r
#define p_interact mccchannel_12_analyzer_1_array_crystal_array_2_p_interact
#define mask_string mccchannel_12_analyzer_1_array_crystal_array_2_mask_string
#define mask_setting mccchannel_12_analyzer_1_array_crystal_array_2_mask_setting
#define number_of_activations mccchannel_12_analyzer_1_array_crystal_array_2_number_of_activations
#line 224 "Union_box.comp"
{
// Initializes the focusing system for this volume including input sanitation.
focus_initialize(&this_box_volume.geometry, POS_A_COMP_INDEX(INDEX_CURRENT_COMP+target_index), POS_A_CURRENT_COMP, ROT_A_CURRENT_COMP, target_index, target_x, target_y, target_z, focus_aw, focus_ah, focus_xw, focus_xh, focus_r, NAME_CURRENT_COMP);

// Input sanitation for this geometry
if (xwidth <= 0) {
  printf("\nERROR in Union_box named %s, the xwidth is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (yheight <= 0) {
  printf("\nERROR in Union_box named %s, yheight is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (zdepth <= 0) {
  printf("\nERROR in Union_box named %s, zdepth is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (xwidth2 <= 0 && xwidth2 != -1) {
  printf("\nERROR in Union_box named %s, the xwidth2 is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (yheight2 <= 0 && yheight2 != -1) {
  printf("\nERROR in Union_box named %s, yheight2 is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}

// Use sanitation
if (global_material_list.num_elements == 0) {
  printf("\nERROR: Need to define a material using Union_make_material before using a Union geometry component. \n");
  printf("       %s was defined before first use of Union_make_material.\n",NAME_CURRENT_COMP);
  exit(1);
}

this_box_volume.geometry.is_masked_volume = 0;
this_box_volume.geometry.is_exit_volume = 0;
this_box_volume.geometry.is_mask_volume = 0;
// check if the volume is a mask, if it is the material string is irelevant.
if (mask_string && strlen(mask_string) && strcmp(mask_string, "NULL") && strcmp(mask_string, "0")) {
    // A mask volume is used to limit the extend of other volumes, called the masked volumes. These are specified in the mask_string.
    // In order for a ray to enter a masked volume, it needs to be both in the region covered by that volume AND the mask volume.
    // When more than
    this_box_volume.geometry.mask_mode = 1; // Default is mask mode is ALL
    if (mask_setting && strlen(mask_setting) && strcmp(mask_setting, "NULL") && strcmp(mask_setting, "0")) {
        if (strcmp(mask_setting,"ALL") == 0 || strcmp(mask_setting,"All") == 0) this_box_volume.geometry.mask_mode = 1;
        else if (strcmp(mask_setting,"ANY") == 0 || strcmp(mask_setting,"Any") == 0) this_box_volume.geometry.mask_mode = 2;
        else {
            printf("The mask_mode of component %s is set to %s, but must be either ALL or ANY.\n",NAME_CURRENT_COMP,mask_setting);
            exit(1);
        }
    }
    
    for (loop_index=0;loop_index<global_geometry_list.num_elements;loop_index++) {
        // Add mask list
        if (1 == manual_linking_function(global_geometry_list.elements[loop_index].name,mask_string)) {
            add_element_to_int_list(&this_box_volume.geometry.mask_list,global_geometry_list.elements[loop_index].component_index);
            add_element_to_int_list(&global_geometry_list.elements[loop_index].Volume->geometry.masked_by_list,INDEX_CURRENT_COMP);
            global_geometry_list.elements[loop_index].Volume->geometry.is_masked_volume = 1;
            if (this_box_volume.geometry.mask_mode == 2)
                global_geometry_list.elements[loop_index].Volume->geometry.mask_mode = 2;
            if (this_box_volume.geometry.mask_mode == 1) {
                if (global_geometry_list.elements[loop_index].Volume->geometry.is_masked_volume == 1 && global_geometry_list.elements[loop_index].Volume->geometry.mask_mode != 2)
                    // If more than one mask is added to one volume, the ANY mode overwrites the (default) ALL mode.
                    global_geometry_list.elements[loop_index].Volume->geometry.mask_mode = 1;
            }
            
            found_geometries = 1;
        }
    }
    if (found_geometries == 0) {
        printf("The mask_string in geometry: %s did not find any of the specified volumes in the mask_string %s \n",NAME_CURRENT_COMP,mask_string);
        exit(1);
    }
    this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
    this_box_volume.p_physics->is_vacuum = 0; // Makes this volume a vacuum
    this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
    this_box_volume.p_physics->my_a = 0; // Should not be used.
    sprintf(this_box_volume.p_physics->name,"Mask");
    this_box_volume.geometry.is_mask_volume = 1;
    
    
// Read the material input, or if it lacks, use automatic linking.
} else if (material_string && strlen(material_string) && strcmp(material_string, "NULL") && strcmp(material_string, "0")) {
    // A geometry string was given, use it to determine which material
    if (0 == strcmp(material_string,"vacuum") || 0 == strcmp(material_string,"Vacuum")) {
        // One could have a global physics struct for vacuum instead of creating one for each
        this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
        this_box_volume.p_physics->is_vacuum = 1; // Makes this volume a vacuum
        this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
        this_box_volume.p_physics->my_a = 0; // Should not be used.
        sprintf(this_box_volume.p_physics->name,"Vacuum");
    } else if (0 == strcmp(material_string,"exit") || 0 == strcmp(material_string,"Exit")) {
        // One could have a global physics struct for vacuum instead of creating one for each
        this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
        this_box_volume.p_physics->is_vacuum = 1; // Makes this volume a vacuum
        this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
        this_box_volume.p_physics->my_a = 0; // Should not be used.
        this_box_volume.geometry.is_exit_volume = 1;
        sprintf(this_box_volume.p_physics->name,"Exit");
    } else {
        #ifndef MATERIAL_DETECTOR
            printf("Need to define a material before refering to it in a geometry %s.\n",NAME_CURRENT_COMP);
            exit(1);
        #endif
        for (loop_index=0;loop_index<global_material_list.num_elements;loop_index++) {
            if (0 == strcmp(material_string,global_material_list.elements[loop_index].name)) {
                this_box_volume.p_physics = global_material_list.elements[loop_index].physics;
                break;
            }
            if (loop_index == global_material_list.num_elements-1) {
            printf("\n");
            printf("ERROR: The material string \"%s\" in Union geometry \"%s\" did not match a specified material. \n",material_string,NAME_CURRENT_COMP);
            printf("       The materials available at this point (need to be defined before the geometry): \n");
            for (loop_index=0;loop_index<global_material_list.num_elements;loop_index++)
              printf("         %s\n",global_material_list.elements[loop_index].name);
            printf("\n");
            printf("       It is also possible to use one of the defualt materials avaiable: \n");
            printf("           Vacuum (for a Volume without scattering or absorption)\n");
            printf("           Exit (for a Volume where the ray exits the component if it enters)\n");
            printf("           Mask (for a Volume that masks existing volumes specified in the mask_string\n");
            exit(1);
          }
        }
    }
} else {
    // Automatic linking, simply using the last defined material.
    #ifndef MATERIAL_DETECTOR
        printf("Need to define a material before the geometry to use automatic linking %s.\n",NAME_CURRENT_COMP);
        exit(1);
    #endif
    this_box_volume.p_physics = global_material_list.elements[global_material_list.num_elements-1].physics;
}

sprintf(this_box_volume.name,NAME_CURRENT_COMP);
sprintf(this_box_volume.geometry.shape,"box");
this_box_volume.geometry.priority_value = priority;
this_box_volume.geometry.geometry_p_interact = p_interact;
// Currently the coordinates will be in absolute space.
this_box_volume.geometry.center = POS_A_CURRENT_COMP;

this_box_storage.z_depth = zdepth;
this_box_storage.x_width1 = xwidth;
this_box_storage.y_height1 = yheight;

this_box_storage.is_rectangle = 0;
if (xwidth2 < 0 && yheight2 < 0) this_box_storage.is_rectangle = 1;
if (xwidth == xwidth2 && yheight == yheight2) this_box_storage.is_rectangle = 1;

if (xwidth2 < 0) {
    this_box_storage.x_width2 = xwidth;
    xwidth2 = xwidth;
} else this_box_storage.x_width2 = xwidth2;

if (yheight2 < 0) {
    this_box_storage.y_height2 = yheight;
    yheight2 = yheight;
} else this_box_storage.y_height2 = yheight2;


this_box_storage.normal_vectors[0] = coords_set(0,0,1);
this_box_storage.normal_vectors[1] = coords_set(0,0,1);

// for sides with y component = 0
x_component = 2*zdepth/sqrt((xwidth-xwidth2)*(xwidth-xwidth2)+4*zdepth*zdepth);
z_component = (xwidth-xwidth2)/sqrt(4*zdepth*zdepth+(xwidth-xwidth2)*(xwidth-xwidth2));

this_box_storage.normal_vectors[2] = coords_set(x_component,0,z_component);
this_box_storage.normal_vectors[3] = coords_set(-x_component,0,z_component);

// for sides with x component = 0
y_component = 2*zdepth/sqrt((yheight-yheight2)*(yheight-yheight2)+4*zdepth*zdepth);
z_component = (yheight-yheight2)/sqrt(4*zdepth*zdepth+(yheight-yheight2)*(yheight-yheight2));

this_box_storage.normal_vectors[4] = coords_set(0,y_component,z_component);
this_box_storage.normal_vectors[5] = coords_set(0,-y_component,z_component);

this_box_volume.geometry.visualization_on = visualize;

this_box_volume.geometry.geometry_parameters.p_box_storage = &this_box_storage;

// Assign pointers to functions for intersection with the shape, checking if a point is inside the shape
if (this_box_storage.is_rectangle == 1) {
this_box_volume.geometry.intersect_function = &sample_box_intersect_simple;
this_box_volume.geometry.within_function = &r_within_box_simple;
}
else {
this_box_volume.geometry.intersect_function = &sample_box_intersect_advanced;
this_box_volume.geometry.within_function = &r_within_box_advanced;
}

this_box_volume.geometry.shell_points = &box_shell_points;
this_box_volume.geometry.mcdisplay_function = &mcdisplay_box_function;
this_box_volume.geometry.initialize_from_main_function = &initialize_box_geometry_from_main_component;
this_box_volume.geometry.process_rot_allocated = 0;

this_box_volume.geometry.copy_geometry_parameters = &allocate_box_storage_copy;

rot_copy(this_box_volume.geometry.rotation_matrix,ROT_A_CURRENT_COMP); //check how ROT_R_CURRENT_COMP would work
rot_transpose(ROT_A_CURRENT_COMP,this_box_volume.geometry.transpose_rotation_matrix);

// Initialize loggers
this_box_volume.loggers.num_elements = 0;

// packing the information into the global_geometry_element, which is then included in the global_geometry_list.
sprintf(global_geometry_element.name,NAME_CURRENT_COMP);
global_geometry_element.activation_counter = number_of_activations;
global_geometry_element.component_index = INDEX_CURRENT_COMP;
global_geometry_element.Volume = &this_box_volume; // Would be nicer if this m was a pointer, now we have the (small) data two places
add_element_to_geometry_list(&global_geometry_list,global_geometry_element);
}
#line 272045 "MACS_sample_kidney_box.c"
#undef number_of_activations
#undef mask_setting
#undef mask_string
#undef p_interact
#undef focus_r
#undef focus_xh
#undef focus_xw
#undef focus_ah
#undef focus_aw
#undef target_z
#undef target_y
#undef target_x
#undef target_index
#undef visualize
#undef yheight2
#undef xwidth2
#undef zdepth
#undef yheight
#undef xwidth
#undef priority
#undef material_string
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

  /* Initializations for component channel_12_analyzer_1_array_crystal_array_3. */
  SIG_MESSAGE("channel_12_analyzer_1_array_crystal_array_3 (Init)");
#define mccompcurname  channel_12_analyzer_1_array_crystal_array_3
#define mccompcurtype  Union_box
#define mccompcurindex 589
#define loop_index mccchannel_12_analyzer_1_array_crystal_array_3_loop_index
#define this_box_volume mccchannel_12_analyzer_1_array_crystal_array_3_this_box_volume
#define global_geometry_element mccchannel_12_analyzer_1_array_crystal_array_3_global_geometry_element
#define this_box_storage mccchannel_12_analyzer_1_array_crystal_array_3_this_box_storage
#define material_string mccchannel_12_analyzer_1_array_crystal_array_3_material_string
#define priority mccchannel_12_analyzer_1_array_crystal_array_3_priority
#define xwidth mccchannel_12_analyzer_1_array_crystal_array_3_xwidth
#define yheight mccchannel_12_analyzer_1_array_crystal_array_3_yheight
#define zdepth mccchannel_12_analyzer_1_array_crystal_array_3_zdepth
#define xwidth2 mccchannel_12_analyzer_1_array_crystal_array_3_xwidth2
#define yheight2 mccchannel_12_analyzer_1_array_crystal_array_3_yheight2
#define visualize mccchannel_12_analyzer_1_array_crystal_array_3_visualize
#define target_index mccchannel_12_analyzer_1_array_crystal_array_3_target_index
#define target_x mccchannel_12_analyzer_1_array_crystal_array_3_target_x
#define target_y mccchannel_12_analyzer_1_array_crystal_array_3_target_y
#define target_z mccchannel_12_analyzer_1_array_crystal_array_3_target_z
#define focus_aw mccchannel_12_analyzer_1_array_crystal_array_3_focus_aw
#define focus_ah mccchannel_12_analyzer_1_array_crystal_array_3_focus_ah
#define focus_xw mccchannel_12_analyzer_1_array_crystal_array_3_focus_xw
#define focus_xh mccchannel_12_analyzer_1_array_crystal_array_3_focus_xh
#define focus_r mccchannel_12_analyzer_1_array_crystal_array_3_focus_r
#define p_interact mccchannel_12_analyzer_1_array_crystal_array_3_p_interact
#define mask_string mccchannel_12_analyzer_1_array_crystal_array_3_mask_string
#define mask_setting mccchannel_12_analyzer_1_array_crystal_array_3_mask_setting
#define number_of_activations mccchannel_12_analyzer_1_array_crystal_array_3_number_of_activations
#line 224 "Union_box.comp"
{
// Initializes the focusing system for this volume including input sanitation.
focus_initialize(&this_box_volume.geometry, POS_A_COMP_INDEX(INDEX_CURRENT_COMP+target_index), POS_A_CURRENT_COMP, ROT_A_CURRENT_COMP, target_index, target_x, target_y, target_z, focus_aw, focus_ah, focus_xw, focus_xh, focus_r, NAME_CURRENT_COMP);

// Input sanitation for this geometry
if (xwidth <= 0) {
  printf("\nERROR in Union_box named %s, the xwidth is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (yheight <= 0) {
  printf("\nERROR in Union_box named %s, yheight is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (zdepth <= 0) {
  printf("\nERROR in Union_box named %s, zdepth is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (xwidth2 <= 0 && xwidth2 != -1) {
  printf("\nERROR in Union_box named %s, the xwidth2 is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (yheight2 <= 0 && yheight2 != -1) {
  printf("\nERROR in Union_box named %s, yheight2 is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}

// Use sanitation
if (global_material_list.num_elements == 0) {
  printf("\nERROR: Need to define a material using Union_make_material before using a Union geometry component. \n");
  printf("       %s was defined before first use of Union_make_material.\n",NAME_CURRENT_COMP);
  exit(1);
}

this_box_volume.geometry.is_masked_volume = 0;
this_box_volume.geometry.is_exit_volume = 0;
this_box_volume.geometry.is_mask_volume = 0;
// check if the volume is a mask, if it is the material string is irelevant.
if (mask_string && strlen(mask_string) && strcmp(mask_string, "NULL") && strcmp(mask_string, "0")) {
    // A mask volume is used to limit the extend of other volumes, called the masked volumes. These are specified in the mask_string.
    // In order for a ray to enter a masked volume, it needs to be both in the region covered by that volume AND the mask volume.
    // When more than
    this_box_volume.geometry.mask_mode = 1; // Default is mask mode is ALL
    if (mask_setting && strlen(mask_setting) && strcmp(mask_setting, "NULL") && strcmp(mask_setting, "0")) {
        if (strcmp(mask_setting,"ALL") == 0 || strcmp(mask_setting,"All") == 0) this_box_volume.geometry.mask_mode = 1;
        else if (strcmp(mask_setting,"ANY") == 0 || strcmp(mask_setting,"Any") == 0) this_box_volume.geometry.mask_mode = 2;
        else {
            printf("The mask_mode of component %s is set to %s, but must be either ALL or ANY.\n",NAME_CURRENT_COMP,mask_setting);
            exit(1);
        }
    }
    
    for (loop_index=0;loop_index<global_geometry_list.num_elements;loop_index++) {
        // Add mask list
        if (1 == manual_linking_function(global_geometry_list.elements[loop_index].name,mask_string)) {
            add_element_to_int_list(&this_box_volume.geometry.mask_list,global_geometry_list.elements[loop_index].component_index);
            add_element_to_int_list(&global_geometry_list.elements[loop_index].Volume->geometry.masked_by_list,INDEX_CURRENT_COMP);
            global_geometry_list.elements[loop_index].Volume->geometry.is_masked_volume = 1;
            if (this_box_volume.geometry.mask_mode == 2)
                global_geometry_list.elements[loop_index].Volume->geometry.mask_mode = 2;
            if (this_box_volume.geometry.mask_mode == 1) {
                if (global_geometry_list.elements[loop_index].Volume->geometry.is_masked_volume == 1 && global_geometry_list.elements[loop_index].Volume->geometry.mask_mode != 2)
                    // If more than one mask is added to one volume, the ANY mode overwrites the (default) ALL mode.
                    global_geometry_list.elements[loop_index].Volume->geometry.mask_mode = 1;
            }
            
            found_geometries = 1;
        }
    }
    if (found_geometries == 0) {
        printf("The mask_string in geometry: %s did not find any of the specified volumes in the mask_string %s \n",NAME_CURRENT_COMP,mask_string);
        exit(1);
    }
    this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
    this_box_volume.p_physics->is_vacuum = 0; // Makes this volume a vacuum
    this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
    this_box_volume.p_physics->my_a = 0; // Should not be used.
    sprintf(this_box_volume.p_physics->name,"Mask");
    this_box_volume.geometry.is_mask_volume = 1;
    
    
// Read the material input, or if it lacks, use automatic linking.
} else if (material_string && strlen(material_string) && strcmp(material_string, "NULL") && strcmp(material_string, "0")) {
    // A geometry string was given, use it to determine which material
    if (0 == strcmp(material_string,"vacuum") || 0 == strcmp(material_string,"Vacuum")) {
        // One could have a global physics struct for vacuum instead of creating one for each
        this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
        this_box_volume.p_physics->is_vacuum = 1; // Makes this volume a vacuum
        this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
        this_box_volume.p_physics->my_a = 0; // Should not be used.
        sprintf(this_box_volume.p_physics->name,"Vacuum");
    } else if (0 == strcmp(material_string,"exit") || 0 == strcmp(material_string,"Exit")) {
        // One could have a global physics struct for vacuum instead of creating one for each
        this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
        this_box_volume.p_physics->is_vacuum = 1; // Makes this volume a vacuum
        this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
        this_box_volume.p_physics->my_a = 0; // Should not be used.
        this_box_volume.geometry.is_exit_volume = 1;
        sprintf(this_box_volume.p_physics->name,"Exit");
    } else {
        #ifndef MATERIAL_DETECTOR
            printf("Need to define a material before refering to it in a geometry %s.\n",NAME_CURRENT_COMP);
            exit(1);
        #endif
        for (loop_index=0;loop_index<global_material_list.num_elements;loop_index++) {
            if (0 == strcmp(material_string,global_material_list.elements[loop_index].name)) {
                this_box_volume.p_physics = global_material_list.elements[loop_index].physics;
                break;
            }
            if (loop_index == global_material_list.num_elements-1) {
            printf("\n");
            printf("ERROR: The material string \"%s\" in Union geometry \"%s\" did not match a specified material. \n",material_string,NAME_CURRENT_COMP);
            printf("       The materials available at this point (need to be defined before the geometry): \n");
            for (loop_index=0;loop_index<global_material_list.num_elements;loop_index++)
              printf("         %s\n",global_material_list.elements[loop_index].name);
            printf("\n");
            printf("       It is also possible to use one of the defualt materials avaiable: \n");
            printf("           Vacuum (for a Volume without scattering or absorption)\n");
            printf("           Exit (for a Volume where the ray exits the component if it enters)\n");
            printf("           Mask (for a Volume that masks existing volumes specified in the mask_string\n");
            exit(1);
          }
        }
    }
} else {
    // Automatic linking, simply using the last defined material.
    #ifndef MATERIAL_DETECTOR
        printf("Need to define a material before the geometry to use automatic linking %s.\n",NAME_CURRENT_COMP);
        exit(1);
    #endif
    this_box_volume.p_physics = global_material_list.elements[global_material_list.num_elements-1].physics;
}

sprintf(this_box_volume.name,NAME_CURRENT_COMP);
sprintf(this_box_volume.geometry.shape,"box");
this_box_volume.geometry.priority_value = priority;
this_box_volume.geometry.geometry_p_interact = p_interact;
// Currently the coordinates will be in absolute space.
this_box_volume.geometry.center = POS_A_CURRENT_COMP;

this_box_storage.z_depth = zdepth;
this_box_storage.x_width1 = xwidth;
this_box_storage.y_height1 = yheight;

this_box_storage.is_rectangle = 0;
if (xwidth2 < 0 && yheight2 < 0) this_box_storage.is_rectangle = 1;
if (xwidth == xwidth2 && yheight == yheight2) this_box_storage.is_rectangle = 1;

if (xwidth2 < 0) {
    this_box_storage.x_width2 = xwidth;
    xwidth2 = xwidth;
} else this_box_storage.x_width2 = xwidth2;

if (yheight2 < 0) {
    this_box_storage.y_height2 = yheight;
    yheight2 = yheight;
} else this_box_storage.y_height2 = yheight2;


this_box_storage.normal_vectors[0] = coords_set(0,0,1);
this_box_storage.normal_vectors[1] = coords_set(0,0,1);

// for sides with y component = 0
x_component = 2*zdepth/sqrt((xwidth-xwidth2)*(xwidth-xwidth2)+4*zdepth*zdepth);
z_component = (xwidth-xwidth2)/sqrt(4*zdepth*zdepth+(xwidth-xwidth2)*(xwidth-xwidth2));

this_box_storage.normal_vectors[2] = coords_set(x_component,0,z_component);
this_box_storage.normal_vectors[3] = coords_set(-x_component,0,z_component);

// for sides with x component = 0
y_component = 2*zdepth/sqrt((yheight-yheight2)*(yheight-yheight2)+4*zdepth*zdepth);
z_component = (yheight-yheight2)/sqrt(4*zdepth*zdepth+(yheight-yheight2)*(yheight-yheight2));

this_box_storage.normal_vectors[4] = coords_set(0,y_component,z_component);
this_box_storage.normal_vectors[5] = coords_set(0,-y_component,z_component);

this_box_volume.geometry.visualization_on = visualize;

this_box_volume.geometry.geometry_parameters.p_box_storage = &this_box_storage;

// Assign pointers to functions for intersection with the shape, checking if a point is inside the shape
if (this_box_storage.is_rectangle == 1) {
this_box_volume.geometry.intersect_function = &sample_box_intersect_simple;
this_box_volume.geometry.within_function = &r_within_box_simple;
}
else {
this_box_volume.geometry.intersect_function = &sample_box_intersect_advanced;
this_box_volume.geometry.within_function = &r_within_box_advanced;
}

this_box_volume.geometry.shell_points = &box_shell_points;
this_box_volume.geometry.mcdisplay_function = &mcdisplay_box_function;
this_box_volume.geometry.initialize_from_main_function = &initialize_box_geometry_from_main_component;
this_box_volume.geometry.process_rot_allocated = 0;

this_box_volume.geometry.copy_geometry_parameters = &allocate_box_storage_copy;

rot_copy(this_box_volume.geometry.rotation_matrix,ROT_A_CURRENT_COMP); //check how ROT_R_CURRENT_COMP would work
rot_transpose(ROT_A_CURRENT_COMP,this_box_volume.geometry.transpose_rotation_matrix);

// Initialize loggers
this_box_volume.loggers.num_elements = 0;

// packing the information into the global_geometry_element, which is then included in the global_geometry_list.
sprintf(global_geometry_element.name,NAME_CURRENT_COMP);
global_geometry_element.activation_counter = number_of_activations;
global_geometry_element.component_index = INDEX_CURRENT_COMP;
global_geometry_element.Volume = &this_box_volume; // Would be nicer if this m was a pointer, now we have the (small) data two places
add_element_to_geometry_list(&global_geometry_list,global_geometry_element);
}
#line 272315 "MACS_sample_kidney_box.c"
#undef number_of_activations
#undef mask_setting
#undef mask_string
#undef p_interact
#undef focus_r
#undef focus_xh
#undef focus_xw
#undef focus_ah
#undef focus_aw
#undef target_z
#undef target_y
#undef target_x
#undef target_index
#undef visualize
#undef yheight2
#undef xwidth2
#undef zdepth
#undef yheight
#undef xwidth
#undef priority
#undef material_string
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

  /* Initializations for component channel_12_analyzer_1_array_crystal_array_4. */
  SIG_MESSAGE("channel_12_analyzer_1_array_crystal_array_4 (Init)");
#define mccompcurname  channel_12_analyzer_1_array_crystal_array_4
#define mccompcurtype  Union_box
#define mccompcurindex 590
#define loop_index mccchannel_12_analyzer_1_array_crystal_array_4_loop_index
#define this_box_volume mccchannel_12_analyzer_1_array_crystal_array_4_this_box_volume
#define global_geometry_element mccchannel_12_analyzer_1_array_crystal_array_4_global_geometry_element
#define this_box_storage mccchannel_12_analyzer_1_array_crystal_array_4_this_box_storage
#define material_string mccchannel_12_analyzer_1_array_crystal_array_4_material_string
#define priority mccchannel_12_analyzer_1_array_crystal_array_4_priority
#define xwidth mccchannel_12_analyzer_1_array_crystal_array_4_xwidth
#define yheight mccchannel_12_analyzer_1_array_crystal_array_4_yheight
#define zdepth mccchannel_12_analyzer_1_array_crystal_array_4_zdepth
#define xwidth2 mccchannel_12_analyzer_1_array_crystal_array_4_xwidth2
#define yheight2 mccchannel_12_analyzer_1_array_crystal_array_4_yheight2
#define visualize mccchannel_12_analyzer_1_array_crystal_array_4_visualize
#define target_index mccchannel_12_analyzer_1_array_crystal_array_4_target_index
#define target_x mccchannel_12_analyzer_1_array_crystal_array_4_target_x
#define target_y mccchannel_12_analyzer_1_array_crystal_array_4_target_y
#define target_z mccchannel_12_analyzer_1_array_crystal_array_4_target_z
#define focus_aw mccchannel_12_analyzer_1_array_crystal_array_4_focus_aw
#define focus_ah mccchannel_12_analyzer_1_array_crystal_array_4_focus_ah
#define focus_xw mccchannel_12_analyzer_1_array_crystal_array_4_focus_xw
#define focus_xh mccchannel_12_analyzer_1_array_crystal_array_4_focus_xh
#define focus_r mccchannel_12_analyzer_1_array_crystal_array_4_focus_r
#define p_interact mccchannel_12_analyzer_1_array_crystal_array_4_p_interact
#define mask_string mccchannel_12_analyzer_1_array_crystal_array_4_mask_string
#define mask_setting mccchannel_12_analyzer_1_array_crystal_array_4_mask_setting
#define number_of_activations mccchannel_12_analyzer_1_array_crystal_array_4_number_of_activations
#line 224 "Union_box.comp"
{
// Initializes the focusing system for this volume including input sanitation.
focus_initialize(&this_box_volume.geometry, POS_A_COMP_INDEX(INDEX_CURRENT_COMP+target_index), POS_A_CURRENT_COMP, ROT_A_CURRENT_COMP, target_index, target_x, target_y, target_z, focus_aw, focus_ah, focus_xw, focus_xh, focus_r, NAME_CURRENT_COMP);

// Input sanitation for this geometry
if (xwidth <= 0) {
  printf("\nERROR in Union_box named %s, the xwidth is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (yheight <= 0) {
  printf("\nERROR in Union_box named %s, yheight is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (zdepth <= 0) {
  printf("\nERROR in Union_box named %s, zdepth is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (xwidth2 <= 0 && xwidth2 != -1) {
  printf("\nERROR in Union_box named %s, the xwidth2 is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (yheight2 <= 0 && yheight2 != -1) {
  printf("\nERROR in Union_box named %s, yheight2 is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}

// Use sanitation
if (global_material_list.num_elements == 0) {
  printf("\nERROR: Need to define a material using Union_make_material before using a Union geometry component. \n");
  printf("       %s was defined before first use of Union_make_material.\n",NAME_CURRENT_COMP);
  exit(1);
}

this_box_volume.geometry.is_masked_volume = 0;
this_box_volume.geometry.is_exit_volume = 0;
this_box_volume.geometry.is_mask_volume = 0;
// check if the volume is a mask, if it is the material string is irelevant.
if (mask_string && strlen(mask_string) && strcmp(mask_string, "NULL") && strcmp(mask_string, "0")) {
    // A mask volume is used to limit the extend of other volumes, called the masked volumes. These are specified in the mask_string.
    // In order for a ray to enter a masked volume, it needs to be both in the region covered by that volume AND the mask volume.
    // When more than
    this_box_volume.geometry.mask_mode = 1; // Default is mask mode is ALL
    if (mask_setting && strlen(mask_setting) && strcmp(mask_setting, "NULL") && strcmp(mask_setting, "0")) {
        if (strcmp(mask_setting,"ALL") == 0 || strcmp(mask_setting,"All") == 0) this_box_volume.geometry.mask_mode = 1;
        else if (strcmp(mask_setting,"ANY") == 0 || strcmp(mask_setting,"Any") == 0) this_box_volume.geometry.mask_mode = 2;
        else {
            printf("The mask_mode of component %s is set to %s, but must be either ALL or ANY.\n",NAME_CURRENT_COMP,mask_setting);
            exit(1);
        }
    }
    
    for (loop_index=0;loop_index<global_geometry_list.num_elements;loop_index++) {
        // Add mask list
        if (1 == manual_linking_function(global_geometry_list.elements[loop_index].name,mask_string)) {
            add_element_to_int_list(&this_box_volume.geometry.mask_list,global_geometry_list.elements[loop_index].component_index);
            add_element_to_int_list(&global_geometry_list.elements[loop_index].Volume->geometry.masked_by_list,INDEX_CURRENT_COMP);
            global_geometry_list.elements[loop_index].Volume->geometry.is_masked_volume = 1;
            if (this_box_volume.geometry.mask_mode == 2)
                global_geometry_list.elements[loop_index].Volume->geometry.mask_mode = 2;
            if (this_box_volume.geometry.mask_mode == 1) {
                if (global_geometry_list.elements[loop_index].Volume->geometry.is_masked_volume == 1 && global_geometry_list.elements[loop_index].Volume->geometry.mask_mode != 2)
                    // If more than one mask is added to one volume, the ANY mode overwrites the (default) ALL mode.
                    global_geometry_list.elements[loop_index].Volume->geometry.mask_mode = 1;
            }
            
            found_geometries = 1;
        }
    }
    if (found_geometries == 0) {
        printf("The mask_string in geometry: %s did not find any of the specified volumes in the mask_string %s \n",NAME_CURRENT_COMP,mask_string);
        exit(1);
    }
    this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
    this_box_volume.p_physics->is_vacuum = 0; // Makes this volume a vacuum
    this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
    this_box_volume.p_physics->my_a = 0; // Should not be used.
    sprintf(this_box_volume.p_physics->name,"Mask");
    this_box_volume.geometry.is_mask_volume = 1;
    
    
// Read the material input, or if it lacks, use automatic linking.
} else if (material_string && strlen(material_string) && strcmp(material_string, "NULL") && strcmp(material_string, "0")) {
    // A geometry string was given, use it to determine which material
    if (0 == strcmp(material_string,"vacuum") || 0 == strcmp(material_string,"Vacuum")) {
        // One could have a global physics struct for vacuum instead of creating one for each
        this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
        this_box_volume.p_physics->is_vacuum = 1; // Makes this volume a vacuum
        this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
        this_box_volume.p_physics->my_a = 0; // Should not be used.
        sprintf(this_box_volume.p_physics->name,"Vacuum");
    } else if (0 == strcmp(material_string,"exit") || 0 == strcmp(material_string,"Exit")) {
        // One could have a global physics struct for vacuum instead of creating one for each
        this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
        this_box_volume.p_physics->is_vacuum = 1; // Makes this volume a vacuum
        this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
        this_box_volume.p_physics->my_a = 0; // Should not be used.
        this_box_volume.geometry.is_exit_volume = 1;
        sprintf(this_box_volume.p_physics->name,"Exit");
    } else {
        #ifndef MATERIAL_DETECTOR
            printf("Need to define a material before refering to it in a geometry %s.\n",NAME_CURRENT_COMP);
            exit(1);
        #endif
        for (loop_index=0;loop_index<global_material_list.num_elements;loop_index++) {
            if (0 == strcmp(material_string,global_material_list.elements[loop_index].name)) {
                this_box_volume.p_physics = global_material_list.elements[loop_index].physics;
                break;
            }
            if (loop_index == global_material_list.num_elements-1) {
            printf("\n");
            printf("ERROR: The material string \"%s\" in Union geometry \"%s\" did not match a specified material. \n",material_string,NAME_CURRENT_COMP);
            printf("       The materials available at this point (need to be defined before the geometry): \n");
            for (loop_index=0;loop_index<global_material_list.num_elements;loop_index++)
              printf("         %s\n",global_material_list.elements[loop_index].name);
            printf("\n");
            printf("       It is also possible to use one of the defualt materials avaiable: \n");
            printf("           Vacuum (for a Volume without scattering or absorption)\n");
            printf("           Exit (for a Volume where the ray exits the component if it enters)\n");
            printf("           Mask (for a Volume that masks existing volumes specified in the mask_string\n");
            exit(1);
          }
        }
    }
} else {
    // Automatic linking, simply using the last defined material.
    #ifndef MATERIAL_DETECTOR
        printf("Need to define a material before the geometry to use automatic linking %s.\n",NAME_CURRENT_COMP);
        exit(1);
    #endif
    this_box_volume.p_physics = global_material_list.elements[global_material_list.num_elements-1].physics;
}

sprintf(this_box_volume.name,NAME_CURRENT_COMP);
sprintf(this_box_volume.geometry.shape,"box");
this_box_volume.geometry.priority_value = priority;
this_box_volume.geometry.geometry_p_interact = p_interact;
// Currently the coordinates will be in absolute space.
this_box_volume.geometry.center = POS_A_CURRENT_COMP;

this_box_storage.z_depth = zdepth;
this_box_storage.x_width1 = xwidth;
this_box_storage.y_height1 = yheight;

this_box_storage.is_rectangle = 0;
if (xwidth2 < 0 && yheight2 < 0) this_box_storage.is_rectangle = 1;
if (xwidth == xwidth2 && yheight == yheight2) this_box_storage.is_rectangle = 1;

if (xwidth2 < 0) {
    this_box_storage.x_width2 = xwidth;
    xwidth2 = xwidth;
} else this_box_storage.x_width2 = xwidth2;

if (yheight2 < 0) {
    this_box_storage.y_height2 = yheight;
    yheight2 = yheight;
} else this_box_storage.y_height2 = yheight2;


this_box_storage.normal_vectors[0] = coords_set(0,0,1);
this_box_storage.normal_vectors[1] = coords_set(0,0,1);

// for sides with y component = 0
x_component = 2*zdepth/sqrt((xwidth-xwidth2)*(xwidth-xwidth2)+4*zdepth*zdepth);
z_component = (xwidth-xwidth2)/sqrt(4*zdepth*zdepth+(xwidth-xwidth2)*(xwidth-xwidth2));

this_box_storage.normal_vectors[2] = coords_set(x_component,0,z_component);
this_box_storage.normal_vectors[3] = coords_set(-x_component,0,z_component);

// for sides with x component = 0
y_component = 2*zdepth/sqrt((yheight-yheight2)*(yheight-yheight2)+4*zdepth*zdepth);
z_component = (yheight-yheight2)/sqrt(4*zdepth*zdepth+(yheight-yheight2)*(yheight-yheight2));

this_box_storage.normal_vectors[4] = coords_set(0,y_component,z_component);
this_box_storage.normal_vectors[5] = coords_set(0,-y_component,z_component);

this_box_volume.geometry.visualization_on = visualize;

this_box_volume.geometry.geometry_parameters.p_box_storage = &this_box_storage;

// Assign pointers to functions for intersection with the shape, checking if a point is inside the shape
if (this_box_storage.is_rectangle == 1) {
this_box_volume.geometry.intersect_function = &sample_box_intersect_simple;
this_box_volume.geometry.within_function = &r_within_box_simple;
}
else {
this_box_volume.geometry.intersect_function = &sample_box_intersect_advanced;
this_box_volume.geometry.within_function = &r_within_box_advanced;
}

this_box_volume.geometry.shell_points = &box_shell_points;
this_box_volume.geometry.mcdisplay_function = &mcdisplay_box_function;
this_box_volume.geometry.initialize_from_main_function = &initialize_box_geometry_from_main_component;
this_box_volume.geometry.process_rot_allocated = 0;

this_box_volume.geometry.copy_geometry_parameters = &allocate_box_storage_copy;

rot_copy(this_box_volume.geometry.rotation_matrix,ROT_A_CURRENT_COMP); //check how ROT_R_CURRENT_COMP would work
rot_transpose(ROT_A_CURRENT_COMP,this_box_volume.geometry.transpose_rotation_matrix);

// Initialize loggers
this_box_volume.loggers.num_elements = 0;

// packing the information into the global_geometry_element, which is then included in the global_geometry_list.
sprintf(global_geometry_element.name,NAME_CURRENT_COMP);
global_geometry_element.activation_counter = number_of_activations;
global_geometry_element.component_index = INDEX_CURRENT_COMP;
global_geometry_element.Volume = &this_box_volume; // Would be nicer if this m was a pointer, now we have the (small) data two places
add_element_to_geometry_list(&global_geometry_list,global_geometry_element);
}
#line 272585 "MACS_sample_kidney_box.c"
#undef number_of_activations
#undef mask_setting
#undef mask_string
#undef p_interact
#undef focus_r
#undef focus_xh
#undef focus_xw
#undef focus_ah
#undef focus_aw
#undef target_z
#undef target_y
#undef target_x
#undef target_index
#undef visualize
#undef yheight2
#undef xwidth2
#undef zdepth
#undef yheight
#undef xwidth
#undef priority
#undef material_string
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

  /* Initializations for component channel_12_analyzer_1_array_crystal_array_5. */
  SIG_MESSAGE("channel_12_analyzer_1_array_crystal_array_5 (Init)");
#define mccompcurname  channel_12_analyzer_1_array_crystal_array_5
#define mccompcurtype  Union_box
#define mccompcurindex 591
#define loop_index mccchannel_12_analyzer_1_array_crystal_array_5_loop_index
#define this_box_volume mccchannel_12_analyzer_1_array_crystal_array_5_this_box_volume
#define global_geometry_element mccchannel_12_analyzer_1_array_crystal_array_5_global_geometry_element
#define this_box_storage mccchannel_12_analyzer_1_array_crystal_array_5_this_box_storage
#define material_string mccchannel_12_analyzer_1_array_crystal_array_5_material_string
#define priority mccchannel_12_analyzer_1_array_crystal_array_5_priority
#define xwidth mccchannel_12_analyzer_1_array_crystal_array_5_xwidth
#define yheight mccchannel_12_analyzer_1_array_crystal_array_5_yheight
#define zdepth mccchannel_12_analyzer_1_array_crystal_array_5_zdepth
#define xwidth2 mccchannel_12_analyzer_1_array_crystal_array_5_xwidth2
#define yheight2 mccchannel_12_analyzer_1_array_crystal_array_5_yheight2
#define visualize mccchannel_12_analyzer_1_array_crystal_array_5_visualize
#define target_index mccchannel_12_analyzer_1_array_crystal_array_5_target_index
#define target_x mccchannel_12_analyzer_1_array_crystal_array_5_target_x
#define target_y mccchannel_12_analyzer_1_array_crystal_array_5_target_y
#define target_z mccchannel_12_analyzer_1_array_crystal_array_5_target_z
#define focus_aw mccchannel_12_analyzer_1_array_crystal_array_5_focus_aw
#define focus_ah mccchannel_12_analyzer_1_array_crystal_array_5_focus_ah
#define focus_xw mccchannel_12_analyzer_1_array_crystal_array_5_focus_xw
#define focus_xh mccchannel_12_analyzer_1_array_crystal_array_5_focus_xh
#define focus_r mccchannel_12_analyzer_1_array_crystal_array_5_focus_r
#define p_interact mccchannel_12_analyzer_1_array_crystal_array_5_p_interact
#define mask_string mccchannel_12_analyzer_1_array_crystal_array_5_mask_string
#define mask_setting mccchannel_12_analyzer_1_array_crystal_array_5_mask_setting
#define number_of_activations mccchannel_12_analyzer_1_array_crystal_array_5_number_of_activations
#line 224 "Union_box.comp"
{
// Initializes the focusing system for this volume including input sanitation.
focus_initialize(&this_box_volume.geometry, POS_A_COMP_INDEX(INDEX_CURRENT_COMP+target_index), POS_A_CURRENT_COMP, ROT_A_CURRENT_COMP, target_index, target_x, target_y, target_z, focus_aw, focus_ah, focus_xw, focus_xh, focus_r, NAME_CURRENT_COMP);

// Input sanitation for this geometry
if (xwidth <= 0) {
  printf("\nERROR in Union_box named %s, the xwidth is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (yheight <= 0) {
  printf("\nERROR in Union_box named %s, yheight is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (zdepth <= 0) {
  printf("\nERROR in Union_box named %s, zdepth is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (xwidth2 <= 0 && xwidth2 != -1) {
  printf("\nERROR in Union_box named %s, the xwidth2 is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (yheight2 <= 0 && yheight2 != -1) {
  printf("\nERROR in Union_box named %s, yheight2 is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}

// Use sanitation
if (global_material_list.num_elements == 0) {
  printf("\nERROR: Need to define a material using Union_make_material before using a Union geometry component. \n");
  printf("       %s was defined before first use of Union_make_material.\n",NAME_CURRENT_COMP);
  exit(1);
}

this_box_volume.geometry.is_masked_volume = 0;
this_box_volume.geometry.is_exit_volume = 0;
this_box_volume.geometry.is_mask_volume = 0;
// check if the volume is a mask, if it is the material string is irelevant.
if (mask_string && strlen(mask_string) && strcmp(mask_string, "NULL") && strcmp(mask_string, "0")) {
    // A mask volume is used to limit the extend of other volumes, called the masked volumes. These are specified in the mask_string.
    // In order for a ray to enter a masked volume, it needs to be both in the region covered by that volume AND the mask volume.
    // When more than
    this_box_volume.geometry.mask_mode = 1; // Default is mask mode is ALL
    if (mask_setting && strlen(mask_setting) && strcmp(mask_setting, "NULL") && strcmp(mask_setting, "0")) {
        if (strcmp(mask_setting,"ALL") == 0 || strcmp(mask_setting,"All") == 0) this_box_volume.geometry.mask_mode = 1;
        else if (strcmp(mask_setting,"ANY") == 0 || strcmp(mask_setting,"Any") == 0) this_box_volume.geometry.mask_mode = 2;
        else {
            printf("The mask_mode of component %s is set to %s, but must be either ALL or ANY.\n",NAME_CURRENT_COMP,mask_setting);
            exit(1);
        }
    }
    
    for (loop_index=0;loop_index<global_geometry_list.num_elements;loop_index++) {
        // Add mask list
        if (1 == manual_linking_function(global_geometry_list.elements[loop_index].name,mask_string)) {
            add_element_to_int_list(&this_box_volume.geometry.mask_list,global_geometry_list.elements[loop_index].component_index);
            add_element_to_int_list(&global_geometry_list.elements[loop_index].Volume->geometry.masked_by_list,INDEX_CURRENT_COMP);
            global_geometry_list.elements[loop_index].Volume->geometry.is_masked_volume = 1;
            if (this_box_volume.geometry.mask_mode == 2)
                global_geometry_list.elements[loop_index].Volume->geometry.mask_mode = 2;
            if (this_box_volume.geometry.mask_mode == 1) {
                if (global_geometry_list.elements[loop_index].Volume->geometry.is_masked_volume == 1 && global_geometry_list.elements[loop_index].Volume->geometry.mask_mode != 2)
                    // If more than one mask is added to one volume, the ANY mode overwrites the (default) ALL mode.
                    global_geometry_list.elements[loop_index].Volume->geometry.mask_mode = 1;
            }
            
            found_geometries = 1;
        }
    }
    if (found_geometries == 0) {
        printf("The mask_string in geometry: %s did not find any of the specified volumes in the mask_string %s \n",NAME_CURRENT_COMP,mask_string);
        exit(1);
    }
    this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
    this_box_volume.p_physics->is_vacuum = 0; // Makes this volume a vacuum
    this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
    this_box_volume.p_physics->my_a = 0; // Should not be used.
    sprintf(this_box_volume.p_physics->name,"Mask");
    this_box_volume.geometry.is_mask_volume = 1;
    
    
// Read the material input, or if it lacks, use automatic linking.
} else if (material_string && strlen(material_string) && strcmp(material_string, "NULL") && strcmp(material_string, "0")) {
    // A geometry string was given, use it to determine which material
    if (0 == strcmp(material_string,"vacuum") || 0 == strcmp(material_string,"Vacuum")) {
        // One could have a global physics struct for vacuum instead of creating one for each
        this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
        this_box_volume.p_physics->is_vacuum = 1; // Makes this volume a vacuum
        this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
        this_box_volume.p_physics->my_a = 0; // Should not be used.
        sprintf(this_box_volume.p_physics->name,"Vacuum");
    } else if (0 == strcmp(material_string,"exit") || 0 == strcmp(material_string,"Exit")) {
        // One could have a global physics struct for vacuum instead of creating one for each
        this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
        this_box_volume.p_physics->is_vacuum = 1; // Makes this volume a vacuum
        this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
        this_box_volume.p_physics->my_a = 0; // Should not be used.
        this_box_volume.geometry.is_exit_volume = 1;
        sprintf(this_box_volume.p_physics->name,"Exit");
    } else {
        #ifndef MATERIAL_DETECTOR
            printf("Need to define a material before refering to it in a geometry %s.\n",NAME_CURRENT_COMP);
            exit(1);
        #endif
        for (loop_index=0;loop_index<global_material_list.num_elements;loop_index++) {
            if (0 == strcmp(material_string,global_material_list.elements[loop_index].name)) {
                this_box_volume.p_physics = global_material_list.elements[loop_index].physics;
                break;
            }
            if (loop_index == global_material_list.num_elements-1) {
            printf("\n");
            printf("ERROR: The material string \"%s\" in Union geometry \"%s\" did not match a specified material. \n",material_string,NAME_CURRENT_COMP);
            printf("       The materials available at this point (need to be defined before the geometry): \n");
            for (loop_index=0;loop_index<global_material_list.num_elements;loop_index++)
              printf("         %s\n",global_material_list.elements[loop_index].name);
            printf("\n");
            printf("       It is also possible to use one of the defualt materials avaiable: \n");
            printf("           Vacuum (for a Volume without scattering or absorption)\n");
            printf("           Exit (for a Volume where the ray exits the component if it enters)\n");
            printf("           Mask (for a Volume that masks existing volumes specified in the mask_string\n");
            exit(1);
          }
        }
    }
} else {
    // Automatic linking, simply using the last defined material.
    #ifndef MATERIAL_DETECTOR
        printf("Need to define a material before the geometry to use automatic linking %s.\n",NAME_CURRENT_COMP);
        exit(1);
    #endif
    this_box_volume.p_physics = global_material_list.elements[global_material_list.num_elements-1].physics;
}

sprintf(this_box_volume.name,NAME_CURRENT_COMP);
sprintf(this_box_volume.geometry.shape,"box");
this_box_volume.geometry.priority_value = priority;
this_box_volume.geometry.geometry_p_interact = p_interact;
// Currently the coordinates will be in absolute space.
this_box_volume.geometry.center = POS_A_CURRENT_COMP;

this_box_storage.z_depth = zdepth;
this_box_storage.x_width1 = xwidth;
this_box_storage.y_height1 = yheight;

this_box_storage.is_rectangle = 0;
if (xwidth2 < 0 && yheight2 < 0) this_box_storage.is_rectangle = 1;
if (xwidth == xwidth2 && yheight == yheight2) this_box_storage.is_rectangle = 1;

if (xwidth2 < 0) {
    this_box_storage.x_width2 = xwidth;
    xwidth2 = xwidth;
} else this_box_storage.x_width2 = xwidth2;

if (yheight2 < 0) {
    this_box_storage.y_height2 = yheight;
    yheight2 = yheight;
} else this_box_storage.y_height2 = yheight2;


this_box_storage.normal_vectors[0] = coords_set(0,0,1);
this_box_storage.normal_vectors[1] = coords_set(0,0,1);

// for sides with y component = 0
x_component = 2*zdepth/sqrt((xwidth-xwidth2)*(xwidth-xwidth2)+4*zdepth*zdepth);
z_component = (xwidth-xwidth2)/sqrt(4*zdepth*zdepth+(xwidth-xwidth2)*(xwidth-xwidth2));

this_box_storage.normal_vectors[2] = coords_set(x_component,0,z_component);
this_box_storage.normal_vectors[3] = coords_set(-x_component,0,z_component);

// for sides with x component = 0
y_component = 2*zdepth/sqrt((yheight-yheight2)*(yheight-yheight2)+4*zdepth*zdepth);
z_component = (yheight-yheight2)/sqrt(4*zdepth*zdepth+(yheight-yheight2)*(yheight-yheight2));

this_box_storage.normal_vectors[4] = coords_set(0,y_component,z_component);
this_box_storage.normal_vectors[5] = coords_set(0,-y_component,z_component);

this_box_volume.geometry.visualization_on = visualize;

this_box_volume.geometry.geometry_parameters.p_box_storage = &this_box_storage;

// Assign pointers to functions for intersection with the shape, checking if a point is inside the shape
if (this_box_storage.is_rectangle == 1) {
this_box_volume.geometry.intersect_function = &sample_box_intersect_simple;
this_box_volume.geometry.within_function = &r_within_box_simple;
}
else {
this_box_volume.geometry.intersect_function = &sample_box_intersect_advanced;
this_box_volume.geometry.within_function = &r_within_box_advanced;
}

this_box_volume.geometry.shell_points = &box_shell_points;
this_box_volume.geometry.mcdisplay_function = &mcdisplay_box_function;
this_box_volume.geometry.initialize_from_main_function = &initialize_box_geometry_from_main_component;
this_box_volume.geometry.process_rot_allocated = 0;

this_box_volume.geometry.copy_geometry_parameters = &allocate_box_storage_copy;

rot_copy(this_box_volume.geometry.rotation_matrix,ROT_A_CURRENT_COMP); //check how ROT_R_CURRENT_COMP would work
rot_transpose(ROT_A_CURRENT_COMP,this_box_volume.geometry.transpose_rotation_matrix);

// Initialize loggers
this_box_volume.loggers.num_elements = 0;

// packing the information into the global_geometry_element, which is then included in the global_geometry_list.
sprintf(global_geometry_element.name,NAME_CURRENT_COMP);
global_geometry_element.activation_counter = number_of_activations;
global_geometry_element.component_index = INDEX_CURRENT_COMP;
global_geometry_element.Volume = &this_box_volume; // Would be nicer if this m was a pointer, now we have the (small) data two places
add_element_to_geometry_list(&global_geometry_list,global_geometry_element);
}
#line 272855 "MACS_sample_kidney_box.c"
#undef number_of_activations
#undef mask_setting
#undef mask_string
#undef p_interact
#undef focus_r
#undef focus_xh
#undef focus_xw
#undef focus_ah
#undef focus_aw
#undef target_z
#undef target_y
#undef target_x
#undef target_index
#undef visualize
#undef yheight2
#undef xwidth2
#undef zdepth
#undef yheight
#undef xwidth
#undef priority
#undef material_string
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

  /* Initializations for component channel_12_analyzer_1_array_crystal_array_6. */
  SIG_MESSAGE("channel_12_analyzer_1_array_crystal_array_6 (Init)");
#define mccompcurname  channel_12_analyzer_1_array_crystal_array_6
#define mccompcurtype  Union_box
#define mccompcurindex 592
#define loop_index mccchannel_12_analyzer_1_array_crystal_array_6_loop_index
#define this_box_volume mccchannel_12_analyzer_1_array_crystal_array_6_this_box_volume
#define global_geometry_element mccchannel_12_analyzer_1_array_crystal_array_6_global_geometry_element
#define this_box_storage mccchannel_12_analyzer_1_array_crystal_array_6_this_box_storage
#define material_string mccchannel_12_analyzer_1_array_crystal_array_6_material_string
#define priority mccchannel_12_analyzer_1_array_crystal_array_6_priority
#define xwidth mccchannel_12_analyzer_1_array_crystal_array_6_xwidth
#define yheight mccchannel_12_analyzer_1_array_crystal_array_6_yheight
#define zdepth mccchannel_12_analyzer_1_array_crystal_array_6_zdepth
#define xwidth2 mccchannel_12_analyzer_1_array_crystal_array_6_xwidth2
#define yheight2 mccchannel_12_analyzer_1_array_crystal_array_6_yheight2
#define visualize mccchannel_12_analyzer_1_array_crystal_array_6_visualize
#define target_index mccchannel_12_analyzer_1_array_crystal_array_6_target_index
#define target_x mccchannel_12_analyzer_1_array_crystal_array_6_target_x
#define target_y mccchannel_12_analyzer_1_array_crystal_array_6_target_y
#define target_z mccchannel_12_analyzer_1_array_crystal_array_6_target_z
#define focus_aw mccchannel_12_analyzer_1_array_crystal_array_6_focus_aw
#define focus_ah mccchannel_12_analyzer_1_array_crystal_array_6_focus_ah
#define focus_xw mccchannel_12_analyzer_1_array_crystal_array_6_focus_xw
#define focus_xh mccchannel_12_analyzer_1_array_crystal_array_6_focus_xh
#define focus_r mccchannel_12_analyzer_1_array_crystal_array_6_focus_r
#define p_interact mccchannel_12_analyzer_1_array_crystal_array_6_p_interact
#define mask_string mccchannel_12_analyzer_1_array_crystal_array_6_mask_string
#define mask_setting mccchannel_12_analyzer_1_array_crystal_array_6_mask_setting
#define number_of_activations mccchannel_12_analyzer_1_array_crystal_array_6_number_of_activations
#line 224 "Union_box.comp"
{
// Initializes the focusing system for this volume including input sanitation.
focus_initialize(&this_box_volume.geometry, POS_A_COMP_INDEX(INDEX_CURRENT_COMP+target_index), POS_A_CURRENT_COMP, ROT_A_CURRENT_COMP, target_index, target_x, target_y, target_z, focus_aw, focus_ah, focus_xw, focus_xh, focus_r, NAME_CURRENT_COMP);

// Input sanitation for this geometry
if (xwidth <= 0) {
  printf("\nERROR in Union_box named %s, the xwidth is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (yheight <= 0) {
  printf("\nERROR in Union_box named %s, yheight is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (zdepth <= 0) {
  printf("\nERROR in Union_box named %s, zdepth is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (xwidth2 <= 0 && xwidth2 != -1) {
  printf("\nERROR in Union_box named %s, the xwidth2 is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (yheight2 <= 0 && yheight2 != -1) {
  printf("\nERROR in Union_box named %s, yheight2 is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}

// Use sanitation
if (global_material_list.num_elements == 0) {
  printf("\nERROR: Need to define a material using Union_make_material before using a Union geometry component. \n");
  printf("       %s was defined before first use of Union_make_material.\n",NAME_CURRENT_COMP);
  exit(1);
}

this_box_volume.geometry.is_masked_volume = 0;
this_box_volume.geometry.is_exit_volume = 0;
this_box_volume.geometry.is_mask_volume = 0;
// check if the volume is a mask, if it is the material string is irelevant.
if (mask_string && strlen(mask_string) && strcmp(mask_string, "NULL") && strcmp(mask_string, "0")) {
    // A mask volume is used to limit the extend of other volumes, called the masked volumes. These are specified in the mask_string.
    // In order for a ray to enter a masked volume, it needs to be both in the region covered by that volume AND the mask volume.
    // When more than
    this_box_volume.geometry.mask_mode = 1; // Default is mask mode is ALL
    if (mask_setting && strlen(mask_setting) && strcmp(mask_setting, "NULL") && strcmp(mask_setting, "0")) {
        if (strcmp(mask_setting,"ALL") == 0 || strcmp(mask_setting,"All") == 0) this_box_volume.geometry.mask_mode = 1;
        else if (strcmp(mask_setting,"ANY") == 0 || strcmp(mask_setting,"Any") == 0) this_box_volume.geometry.mask_mode = 2;
        else {
            printf("The mask_mode of component %s is set to %s, but must be either ALL or ANY.\n",NAME_CURRENT_COMP,mask_setting);
            exit(1);
        }
    }
    
    for (loop_index=0;loop_index<global_geometry_list.num_elements;loop_index++) {
        // Add mask list
        if (1 == manual_linking_function(global_geometry_list.elements[loop_index].name,mask_string)) {
            add_element_to_int_list(&this_box_volume.geometry.mask_list,global_geometry_list.elements[loop_index].component_index);
            add_element_to_int_list(&global_geometry_list.elements[loop_index].Volume->geometry.masked_by_list,INDEX_CURRENT_COMP);
            global_geometry_list.elements[loop_index].Volume->geometry.is_masked_volume = 1;
            if (this_box_volume.geometry.mask_mode == 2)
                global_geometry_list.elements[loop_index].Volume->geometry.mask_mode = 2;
            if (this_box_volume.geometry.mask_mode == 1) {
                if (global_geometry_list.elements[loop_index].Volume->geometry.is_masked_volume == 1 && global_geometry_list.elements[loop_index].Volume->geometry.mask_mode != 2)
                    // If more than one mask is added to one volume, the ANY mode overwrites the (default) ALL mode.
                    global_geometry_list.elements[loop_index].Volume->geometry.mask_mode = 1;
            }
            
            found_geometries = 1;
        }
    }
    if (found_geometries == 0) {
        printf("The mask_string in geometry: %s did not find any of the specified volumes in the mask_string %s \n",NAME_CURRENT_COMP,mask_string);
        exit(1);
    }
    this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
    this_box_volume.p_physics->is_vacuum = 0; // Makes this volume a vacuum
    this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
    this_box_volume.p_physics->my_a = 0; // Should not be used.
    sprintf(this_box_volume.p_physics->name,"Mask");
    this_box_volume.geometry.is_mask_volume = 1;
    
    
// Read the material input, or if it lacks, use automatic linking.
} else if (material_string && strlen(material_string) && strcmp(material_string, "NULL") && strcmp(material_string, "0")) {
    // A geometry string was given, use it to determine which material
    if (0 == strcmp(material_string,"vacuum") || 0 == strcmp(material_string,"Vacuum")) {
        // One could have a global physics struct for vacuum instead of creating one for each
        this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
        this_box_volume.p_physics->is_vacuum = 1; // Makes this volume a vacuum
        this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
        this_box_volume.p_physics->my_a = 0; // Should not be used.
        sprintf(this_box_volume.p_physics->name,"Vacuum");
    } else if (0 == strcmp(material_string,"exit") || 0 == strcmp(material_string,"Exit")) {
        // One could have a global physics struct for vacuum instead of creating one for each
        this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
        this_box_volume.p_physics->is_vacuum = 1; // Makes this volume a vacuum
        this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
        this_box_volume.p_physics->my_a = 0; // Should not be used.
        this_box_volume.geometry.is_exit_volume = 1;
        sprintf(this_box_volume.p_physics->name,"Exit");
    } else {
        #ifndef MATERIAL_DETECTOR
            printf("Need to define a material before refering to it in a geometry %s.\n",NAME_CURRENT_COMP);
            exit(1);
        #endif
        for (loop_index=0;loop_index<global_material_list.num_elements;loop_index++) {
            if (0 == strcmp(material_string,global_material_list.elements[loop_index].name)) {
                this_box_volume.p_physics = global_material_list.elements[loop_index].physics;
                break;
            }
            if (loop_index == global_material_list.num_elements-1) {
            printf("\n");
            printf("ERROR: The material string \"%s\" in Union geometry \"%s\" did not match a specified material. \n",material_string,NAME_CURRENT_COMP);
            printf("       The materials available at this point (need to be defined before the geometry): \n");
            for (loop_index=0;loop_index<global_material_list.num_elements;loop_index++)
              printf("         %s\n",global_material_list.elements[loop_index].name);
            printf("\n");
            printf("       It is also possible to use one of the defualt materials avaiable: \n");
            printf("           Vacuum (for a Volume without scattering or absorption)\n");
            printf("           Exit (for a Volume where the ray exits the component if it enters)\n");
            printf("           Mask (for a Volume that masks existing volumes specified in the mask_string\n");
            exit(1);
          }
        }
    }
} else {
    // Automatic linking, simply using the last defined material.
    #ifndef MATERIAL_DETECTOR
        printf("Need to define a material before the geometry to use automatic linking %s.\n",NAME_CURRENT_COMP);
        exit(1);
    #endif
    this_box_volume.p_physics = global_material_list.elements[global_material_list.num_elements-1].physics;
}

sprintf(this_box_volume.name,NAME_CURRENT_COMP);
sprintf(this_box_volume.geometry.shape,"box");
this_box_volume.geometry.priority_value = priority;
this_box_volume.geometry.geometry_p_interact = p_interact;
// Currently the coordinates will be in absolute space.
this_box_volume.geometry.center = POS_A_CURRENT_COMP;

this_box_storage.z_depth = zdepth;
this_box_storage.x_width1 = xwidth;
this_box_storage.y_height1 = yheight;

this_box_storage.is_rectangle = 0;
if (xwidth2 < 0 && yheight2 < 0) this_box_storage.is_rectangle = 1;
if (xwidth == xwidth2 && yheight == yheight2) this_box_storage.is_rectangle = 1;

if (xwidth2 < 0) {
    this_box_storage.x_width2 = xwidth;
    xwidth2 = xwidth;
} else this_box_storage.x_width2 = xwidth2;

if (yheight2 < 0) {
    this_box_storage.y_height2 = yheight;
    yheight2 = yheight;
} else this_box_storage.y_height2 = yheight2;


this_box_storage.normal_vectors[0] = coords_set(0,0,1);
this_box_storage.normal_vectors[1] = coords_set(0,0,1);

// for sides with y component = 0
x_component = 2*zdepth/sqrt((xwidth-xwidth2)*(xwidth-xwidth2)+4*zdepth*zdepth);
z_component = (xwidth-xwidth2)/sqrt(4*zdepth*zdepth+(xwidth-xwidth2)*(xwidth-xwidth2));

this_box_storage.normal_vectors[2] = coords_set(x_component,0,z_component);
this_box_storage.normal_vectors[3] = coords_set(-x_component,0,z_component);

// for sides with x component = 0
y_component = 2*zdepth/sqrt((yheight-yheight2)*(yheight-yheight2)+4*zdepth*zdepth);
z_component = (yheight-yheight2)/sqrt(4*zdepth*zdepth+(yheight-yheight2)*(yheight-yheight2));

this_box_storage.normal_vectors[4] = coords_set(0,y_component,z_component);
this_box_storage.normal_vectors[5] = coords_set(0,-y_component,z_component);

this_box_volume.geometry.visualization_on = visualize;

this_box_volume.geometry.geometry_parameters.p_box_storage = &this_box_storage;

// Assign pointers to functions for intersection with the shape, checking if a point is inside the shape
if (this_box_storage.is_rectangle == 1) {
this_box_volume.geometry.intersect_function = &sample_box_intersect_simple;
this_box_volume.geometry.within_function = &r_within_box_simple;
}
else {
this_box_volume.geometry.intersect_function = &sample_box_intersect_advanced;
this_box_volume.geometry.within_function = &r_within_box_advanced;
}

this_box_volume.geometry.shell_points = &box_shell_points;
this_box_volume.geometry.mcdisplay_function = &mcdisplay_box_function;
this_box_volume.geometry.initialize_from_main_function = &initialize_box_geometry_from_main_component;
this_box_volume.geometry.process_rot_allocated = 0;

this_box_volume.geometry.copy_geometry_parameters = &allocate_box_storage_copy;

rot_copy(this_box_volume.geometry.rotation_matrix,ROT_A_CURRENT_COMP); //check how ROT_R_CURRENT_COMP would work
rot_transpose(ROT_A_CURRENT_COMP,this_box_volume.geometry.transpose_rotation_matrix);

// Initialize loggers
this_box_volume.loggers.num_elements = 0;

// packing the information into the global_geometry_element, which is then included in the global_geometry_list.
sprintf(global_geometry_element.name,NAME_CURRENT_COMP);
global_geometry_element.activation_counter = number_of_activations;
global_geometry_element.component_index = INDEX_CURRENT_COMP;
global_geometry_element.Volume = &this_box_volume; // Would be nicer if this m was a pointer, now we have the (small) data two places
add_element_to_geometry_list(&global_geometry_list,global_geometry_element);
}
#line 273125 "MACS_sample_kidney_box.c"
#undef number_of_activations
#undef mask_setting
#undef mask_string
#undef p_interact
#undef focus_r
#undef focus_xh
#undef focus_xw
#undef focus_ah
#undef focus_aw
#undef target_z
#undef target_y
#undef target_x
#undef target_index
#undef visualize
#undef yheight2
#undef xwidth2
#undef zdepth
#undef yheight
#undef xwidth
#undef priority
#undef material_string
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

  /* Initializations for component channel_12_analyzer_1_array_crystal_array_7. */
  SIG_MESSAGE("channel_12_analyzer_1_array_crystal_array_7 (Init)");
#define mccompcurname  channel_12_analyzer_1_array_crystal_array_7
#define mccompcurtype  Union_box
#define mccompcurindex 593
#define loop_index mccchannel_12_analyzer_1_array_crystal_array_7_loop_index
#define this_box_volume mccchannel_12_analyzer_1_array_crystal_array_7_this_box_volume
#define global_geometry_element mccchannel_12_analyzer_1_array_crystal_array_7_global_geometry_element
#define this_box_storage mccchannel_12_analyzer_1_array_crystal_array_7_this_box_storage
#define material_string mccchannel_12_analyzer_1_array_crystal_array_7_material_string
#define priority mccchannel_12_analyzer_1_array_crystal_array_7_priority
#define xwidth mccchannel_12_analyzer_1_array_crystal_array_7_xwidth
#define yheight mccchannel_12_analyzer_1_array_crystal_array_7_yheight
#define zdepth mccchannel_12_analyzer_1_array_crystal_array_7_zdepth
#define xwidth2 mccchannel_12_analyzer_1_array_crystal_array_7_xwidth2
#define yheight2 mccchannel_12_analyzer_1_array_crystal_array_7_yheight2
#define visualize mccchannel_12_analyzer_1_array_crystal_array_7_visualize
#define target_index mccchannel_12_analyzer_1_array_crystal_array_7_target_index
#define target_x mccchannel_12_analyzer_1_array_crystal_array_7_target_x
#define target_y mccchannel_12_analyzer_1_array_crystal_array_7_target_y
#define target_z mccchannel_12_analyzer_1_array_crystal_array_7_target_z
#define focus_aw mccchannel_12_analyzer_1_array_crystal_array_7_focus_aw
#define focus_ah mccchannel_12_analyzer_1_array_crystal_array_7_focus_ah
#define focus_xw mccchannel_12_analyzer_1_array_crystal_array_7_focus_xw
#define focus_xh mccchannel_12_analyzer_1_array_crystal_array_7_focus_xh
#define focus_r mccchannel_12_analyzer_1_array_crystal_array_7_focus_r
#define p_interact mccchannel_12_analyzer_1_array_crystal_array_7_p_interact
#define mask_string mccchannel_12_analyzer_1_array_crystal_array_7_mask_string
#define mask_setting mccchannel_12_analyzer_1_array_crystal_array_7_mask_setting
#define number_of_activations mccchannel_12_analyzer_1_array_crystal_array_7_number_of_activations
#line 224 "Union_box.comp"
{
// Initializes the focusing system for this volume including input sanitation.
focus_initialize(&this_box_volume.geometry, POS_A_COMP_INDEX(INDEX_CURRENT_COMP+target_index), POS_A_CURRENT_COMP, ROT_A_CURRENT_COMP, target_index, target_x, target_y, target_z, focus_aw, focus_ah, focus_xw, focus_xh, focus_r, NAME_CURRENT_COMP);

// Input sanitation for this geometry
if (xwidth <= 0) {
  printf("\nERROR in Union_box named %s, the xwidth is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (yheight <= 0) {
  printf("\nERROR in Union_box named %s, yheight is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (zdepth <= 0) {
  printf("\nERROR in Union_box named %s, zdepth is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (xwidth2 <= 0 && xwidth2 != -1) {
  printf("\nERROR in Union_box named %s, the xwidth2 is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (yheight2 <= 0 && yheight2 != -1) {
  printf("\nERROR in Union_box named %s, yheight2 is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}

// Use sanitation
if (global_material_list.num_elements == 0) {
  printf("\nERROR: Need to define a material using Union_make_material before using a Union geometry component. \n");
  printf("       %s was defined before first use of Union_make_material.\n",NAME_CURRENT_COMP);
  exit(1);
}

this_box_volume.geometry.is_masked_volume = 0;
this_box_volume.geometry.is_exit_volume = 0;
this_box_volume.geometry.is_mask_volume = 0;
// check if the volume is a mask, if it is the material string is irelevant.
if (mask_string && strlen(mask_string) && strcmp(mask_string, "NULL") && strcmp(mask_string, "0")) {
    // A mask volume is used to limit the extend of other volumes, called the masked volumes. These are specified in the mask_string.
    // In order for a ray to enter a masked volume, it needs to be both in the region covered by that volume AND the mask volume.
    // When more than
    this_box_volume.geometry.mask_mode = 1; // Default is mask mode is ALL
    if (mask_setting && strlen(mask_setting) && strcmp(mask_setting, "NULL") && strcmp(mask_setting, "0")) {
        if (strcmp(mask_setting,"ALL") == 0 || strcmp(mask_setting,"All") == 0) this_box_volume.geometry.mask_mode = 1;
        else if (strcmp(mask_setting,"ANY") == 0 || strcmp(mask_setting,"Any") == 0) this_box_volume.geometry.mask_mode = 2;
        else {
            printf("The mask_mode of component %s is set to %s, but must be either ALL or ANY.\n",NAME_CURRENT_COMP,mask_setting);
            exit(1);
        }
    }
    
    for (loop_index=0;loop_index<global_geometry_list.num_elements;loop_index++) {
        // Add mask list
        if (1 == manual_linking_function(global_geometry_list.elements[loop_index].name,mask_string)) {
            add_element_to_int_list(&this_box_volume.geometry.mask_list,global_geometry_list.elements[loop_index].component_index);
            add_element_to_int_list(&global_geometry_list.elements[loop_index].Volume->geometry.masked_by_list,INDEX_CURRENT_COMP);
            global_geometry_list.elements[loop_index].Volume->geometry.is_masked_volume = 1;
            if (this_box_volume.geometry.mask_mode == 2)
                global_geometry_list.elements[loop_index].Volume->geometry.mask_mode = 2;
            if (this_box_volume.geometry.mask_mode == 1) {
                if (global_geometry_list.elements[loop_index].Volume->geometry.is_masked_volume == 1 && global_geometry_list.elements[loop_index].Volume->geometry.mask_mode != 2)
                    // If more than one mask is added to one volume, the ANY mode overwrites the (default) ALL mode.
                    global_geometry_list.elements[loop_index].Volume->geometry.mask_mode = 1;
            }
            
            found_geometries = 1;
        }
    }
    if (found_geometries == 0) {
        printf("The mask_string in geometry: %s did not find any of the specified volumes in the mask_string %s \n",NAME_CURRENT_COMP,mask_string);
        exit(1);
    }
    this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
    this_box_volume.p_physics->is_vacuum = 0; // Makes this volume a vacuum
    this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
    this_box_volume.p_physics->my_a = 0; // Should not be used.
    sprintf(this_box_volume.p_physics->name,"Mask");
    this_box_volume.geometry.is_mask_volume = 1;
    
    
// Read the material input, or if it lacks, use automatic linking.
} else if (material_string && strlen(material_string) && strcmp(material_string, "NULL") && strcmp(material_string, "0")) {
    // A geometry string was given, use it to determine which material
    if (0 == strcmp(material_string,"vacuum") || 0 == strcmp(material_string,"Vacuum")) {
        // One could have a global physics struct for vacuum instead of creating one for each
        this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
        this_box_volume.p_physics->is_vacuum = 1; // Makes this volume a vacuum
        this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
        this_box_volume.p_physics->my_a = 0; // Should not be used.
        sprintf(this_box_volume.p_physics->name,"Vacuum");
    } else if (0 == strcmp(material_string,"exit") || 0 == strcmp(material_string,"Exit")) {
        // One could have a global physics struct for vacuum instead of creating one for each
        this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
        this_box_volume.p_physics->is_vacuum = 1; // Makes this volume a vacuum
        this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
        this_box_volume.p_physics->my_a = 0; // Should not be used.
        this_box_volume.geometry.is_exit_volume = 1;
        sprintf(this_box_volume.p_physics->name,"Exit");
    } else {
        #ifndef MATERIAL_DETECTOR
            printf("Need to define a material before refering to it in a geometry %s.\n",NAME_CURRENT_COMP);
            exit(1);
        #endif
        for (loop_index=0;loop_index<global_material_list.num_elements;loop_index++) {
            if (0 == strcmp(material_string,global_material_list.elements[loop_index].name)) {
                this_box_volume.p_physics = global_material_list.elements[loop_index].physics;
                break;
            }
            if (loop_index == global_material_list.num_elements-1) {
            printf("\n");
            printf("ERROR: The material string \"%s\" in Union geometry \"%s\" did not match a specified material. \n",material_string,NAME_CURRENT_COMP);
            printf("       The materials available at this point (need to be defined before the geometry): \n");
            for (loop_index=0;loop_index<global_material_list.num_elements;loop_index++)
              printf("         %s\n",global_material_list.elements[loop_index].name);
            printf("\n");
            printf("       It is also possible to use one of the defualt materials avaiable: \n");
            printf("           Vacuum (for a Volume without scattering or absorption)\n");
            printf("           Exit (for a Volume where the ray exits the component if it enters)\n");
            printf("           Mask (for a Volume that masks existing volumes specified in the mask_string\n");
            exit(1);
          }
        }
    }
} else {
    // Automatic linking, simply using the last defined material.
    #ifndef MATERIAL_DETECTOR
        printf("Need to define a material before the geometry to use automatic linking %s.\n",NAME_CURRENT_COMP);
        exit(1);
    #endif
    this_box_volume.p_physics = global_material_list.elements[global_material_list.num_elements-1].physics;
}

sprintf(this_box_volume.name,NAME_CURRENT_COMP);
sprintf(this_box_volume.geometry.shape,"box");
this_box_volume.geometry.priority_value = priority;
this_box_volume.geometry.geometry_p_interact = p_interact;
// Currently the coordinates will be in absolute space.
this_box_volume.geometry.center = POS_A_CURRENT_COMP;

this_box_storage.z_depth = zdepth;
this_box_storage.x_width1 = xwidth;
this_box_storage.y_height1 = yheight;

this_box_storage.is_rectangle = 0;
if (xwidth2 < 0 && yheight2 < 0) this_box_storage.is_rectangle = 1;
if (xwidth == xwidth2 && yheight == yheight2) this_box_storage.is_rectangle = 1;

if (xwidth2 < 0) {
    this_box_storage.x_width2 = xwidth;
    xwidth2 = xwidth;
} else this_box_storage.x_width2 = xwidth2;

if (yheight2 < 0) {
    this_box_storage.y_height2 = yheight;
    yheight2 = yheight;
} else this_box_storage.y_height2 = yheight2;


this_box_storage.normal_vectors[0] = coords_set(0,0,1);
this_box_storage.normal_vectors[1] = coords_set(0,0,1);

// for sides with y component = 0
x_component = 2*zdepth/sqrt((xwidth-xwidth2)*(xwidth-xwidth2)+4*zdepth*zdepth);
z_component = (xwidth-xwidth2)/sqrt(4*zdepth*zdepth+(xwidth-xwidth2)*(xwidth-xwidth2));

this_box_storage.normal_vectors[2] = coords_set(x_component,0,z_component);
this_box_storage.normal_vectors[3] = coords_set(-x_component,0,z_component);

// for sides with x component = 0
y_component = 2*zdepth/sqrt((yheight-yheight2)*(yheight-yheight2)+4*zdepth*zdepth);
z_component = (yheight-yheight2)/sqrt(4*zdepth*zdepth+(yheight-yheight2)*(yheight-yheight2));

this_box_storage.normal_vectors[4] = coords_set(0,y_component,z_component);
this_box_storage.normal_vectors[5] = coords_set(0,-y_component,z_component);

this_box_volume.geometry.visualization_on = visualize;

this_box_volume.geometry.geometry_parameters.p_box_storage = &this_box_storage;

// Assign pointers to functions for intersection with the shape, checking if a point is inside the shape
if (this_box_storage.is_rectangle == 1) {
this_box_volume.geometry.intersect_function = &sample_box_intersect_simple;
this_box_volume.geometry.within_function = &r_within_box_simple;
}
else {
this_box_volume.geometry.intersect_function = &sample_box_intersect_advanced;
this_box_volume.geometry.within_function = &r_within_box_advanced;
}

this_box_volume.geometry.shell_points = &box_shell_points;
this_box_volume.geometry.mcdisplay_function = &mcdisplay_box_function;
this_box_volume.geometry.initialize_from_main_function = &initialize_box_geometry_from_main_component;
this_box_volume.geometry.process_rot_allocated = 0;

this_box_volume.geometry.copy_geometry_parameters = &allocate_box_storage_copy;

rot_copy(this_box_volume.geometry.rotation_matrix,ROT_A_CURRENT_COMP); //check how ROT_R_CURRENT_COMP would work
rot_transpose(ROT_A_CURRENT_COMP,this_box_volume.geometry.transpose_rotation_matrix);

// Initialize loggers
this_box_volume.loggers.num_elements = 0;

// packing the information into the global_geometry_element, which is then included in the global_geometry_list.
sprintf(global_geometry_element.name,NAME_CURRENT_COMP);
global_geometry_element.activation_counter = number_of_activations;
global_geometry_element.component_index = INDEX_CURRENT_COMP;
global_geometry_element.Volume = &this_box_volume; // Would be nicer if this m was a pointer, now we have the (small) data two places
add_element_to_geometry_list(&global_geometry_list,global_geometry_element);
}
#line 273395 "MACS_sample_kidney_box.c"
#undef number_of_activations
#undef mask_setting
#undef mask_string
#undef p_interact
#undef focus_r
#undef focus_xh
#undef focus_xw
#undef focus_ah
#undef focus_aw
#undef target_z
#undef target_y
#undef target_x
#undef target_index
#undef visualize
#undef yheight2
#undef xwidth2
#undef zdepth
#undef yheight
#undef xwidth
#undef priority
#undef material_string
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

  /* Initializations for component channel_12_analyzer_1_array_crystal_array_8. */
  SIG_MESSAGE("channel_12_analyzer_1_array_crystal_array_8 (Init)");
#define mccompcurname  channel_12_analyzer_1_array_crystal_array_8
#define mccompcurtype  Union_box
#define mccompcurindex 594
#define loop_index mccchannel_12_analyzer_1_array_crystal_array_8_loop_index
#define this_box_volume mccchannel_12_analyzer_1_array_crystal_array_8_this_box_volume
#define global_geometry_element mccchannel_12_analyzer_1_array_crystal_array_8_global_geometry_element
#define this_box_storage mccchannel_12_analyzer_1_array_crystal_array_8_this_box_storage
#define material_string mccchannel_12_analyzer_1_array_crystal_array_8_material_string
#define priority mccchannel_12_analyzer_1_array_crystal_array_8_priority
#define xwidth mccchannel_12_analyzer_1_array_crystal_array_8_xwidth
#define yheight mccchannel_12_analyzer_1_array_crystal_array_8_yheight
#define zdepth mccchannel_12_analyzer_1_array_crystal_array_8_zdepth
#define xwidth2 mccchannel_12_analyzer_1_array_crystal_array_8_xwidth2
#define yheight2 mccchannel_12_analyzer_1_array_crystal_array_8_yheight2
#define visualize mccchannel_12_analyzer_1_array_crystal_array_8_visualize
#define target_index mccchannel_12_analyzer_1_array_crystal_array_8_target_index
#define target_x mccchannel_12_analyzer_1_array_crystal_array_8_target_x
#define target_y mccchannel_12_analyzer_1_array_crystal_array_8_target_y
#define target_z mccchannel_12_analyzer_1_array_crystal_array_8_target_z
#define focus_aw mccchannel_12_analyzer_1_array_crystal_array_8_focus_aw
#define focus_ah mccchannel_12_analyzer_1_array_crystal_array_8_focus_ah
#define focus_xw mccchannel_12_analyzer_1_array_crystal_array_8_focus_xw
#define focus_xh mccchannel_12_analyzer_1_array_crystal_array_8_focus_xh
#define focus_r mccchannel_12_analyzer_1_array_crystal_array_8_focus_r
#define p_interact mccchannel_12_analyzer_1_array_crystal_array_8_p_interact
#define mask_string mccchannel_12_analyzer_1_array_crystal_array_8_mask_string
#define mask_setting mccchannel_12_analyzer_1_array_crystal_array_8_mask_setting
#define number_of_activations mccchannel_12_analyzer_1_array_crystal_array_8_number_of_activations
#line 224 "Union_box.comp"
{
// Initializes the focusing system for this volume including input sanitation.
focus_initialize(&this_box_volume.geometry, POS_A_COMP_INDEX(INDEX_CURRENT_COMP+target_index), POS_A_CURRENT_COMP, ROT_A_CURRENT_COMP, target_index, target_x, target_y, target_z, focus_aw, focus_ah, focus_xw, focus_xh, focus_r, NAME_CURRENT_COMP);

// Input sanitation for this geometry
if (xwidth <= 0) {
  printf("\nERROR in Union_box named %s, the xwidth is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (yheight <= 0) {
  printf("\nERROR in Union_box named %s, yheight is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (zdepth <= 0) {
  printf("\nERROR in Union_box named %s, zdepth is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (xwidth2 <= 0 && xwidth2 != -1) {
  printf("\nERROR in Union_box named %s, the xwidth2 is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (yheight2 <= 0 && yheight2 != -1) {
  printf("\nERROR in Union_box named %s, yheight2 is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}

// Use sanitation
if (global_material_list.num_elements == 0) {
  printf("\nERROR: Need to define a material using Union_make_material before using a Union geometry component. \n");
  printf("       %s was defined before first use of Union_make_material.\n",NAME_CURRENT_COMP);
  exit(1);
}

this_box_volume.geometry.is_masked_volume = 0;
this_box_volume.geometry.is_exit_volume = 0;
this_box_volume.geometry.is_mask_volume = 0;
// check if the volume is a mask, if it is the material string is irelevant.
if (mask_string && strlen(mask_string) && strcmp(mask_string, "NULL") && strcmp(mask_string, "0")) {
    // A mask volume is used to limit the extend of other volumes, called the masked volumes. These are specified in the mask_string.
    // In order for a ray to enter a masked volume, it needs to be both in the region covered by that volume AND the mask volume.
    // When more than
    this_box_volume.geometry.mask_mode = 1; // Default is mask mode is ALL
    if (mask_setting && strlen(mask_setting) && strcmp(mask_setting, "NULL") && strcmp(mask_setting, "0")) {
        if (strcmp(mask_setting,"ALL") == 0 || strcmp(mask_setting,"All") == 0) this_box_volume.geometry.mask_mode = 1;
        else if (strcmp(mask_setting,"ANY") == 0 || strcmp(mask_setting,"Any") == 0) this_box_volume.geometry.mask_mode = 2;
        else {
            printf("The mask_mode of component %s is set to %s, but must be either ALL or ANY.\n",NAME_CURRENT_COMP,mask_setting);
            exit(1);
        }
    }
    
    for (loop_index=0;loop_index<global_geometry_list.num_elements;loop_index++) {
        // Add mask list
        if (1 == manual_linking_function(global_geometry_list.elements[loop_index].name,mask_string)) {
            add_element_to_int_list(&this_box_volume.geometry.mask_list,global_geometry_list.elements[loop_index].component_index);
            add_element_to_int_list(&global_geometry_list.elements[loop_index].Volume->geometry.masked_by_list,INDEX_CURRENT_COMP);
            global_geometry_list.elements[loop_index].Volume->geometry.is_masked_volume = 1;
            if (this_box_volume.geometry.mask_mode == 2)
                global_geometry_list.elements[loop_index].Volume->geometry.mask_mode = 2;
            if (this_box_volume.geometry.mask_mode == 1) {
                if (global_geometry_list.elements[loop_index].Volume->geometry.is_masked_volume == 1 && global_geometry_list.elements[loop_index].Volume->geometry.mask_mode != 2)
                    // If more than one mask is added to one volume, the ANY mode overwrites the (default) ALL mode.
                    global_geometry_list.elements[loop_index].Volume->geometry.mask_mode = 1;
            }
            
            found_geometries = 1;
        }
    }
    if (found_geometries == 0) {
        printf("The mask_string in geometry: %s did not find any of the specified volumes in the mask_string %s \n",NAME_CURRENT_COMP,mask_string);
        exit(1);
    }
    this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
    this_box_volume.p_physics->is_vacuum = 0; // Makes this volume a vacuum
    this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
    this_box_volume.p_physics->my_a = 0; // Should not be used.
    sprintf(this_box_volume.p_physics->name,"Mask");
    this_box_volume.geometry.is_mask_volume = 1;
    
    
// Read the material input, or if it lacks, use automatic linking.
} else if (material_string && strlen(material_string) && strcmp(material_string, "NULL") && strcmp(material_string, "0")) {
    // A geometry string was given, use it to determine which material
    if (0 == strcmp(material_string,"vacuum") || 0 == strcmp(material_string,"Vacuum")) {
        // One could have a global physics struct for vacuum instead of creating one for each
        this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
        this_box_volume.p_physics->is_vacuum = 1; // Makes this volume a vacuum
        this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
        this_box_volume.p_physics->my_a = 0; // Should not be used.
        sprintf(this_box_volume.p_physics->name,"Vacuum");
    } else if (0 == strcmp(material_string,"exit") || 0 == strcmp(material_string,"Exit")) {
        // One could have a global physics struct for vacuum instead of creating one for each
        this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
        this_box_volume.p_physics->is_vacuum = 1; // Makes this volume a vacuum
        this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
        this_box_volume.p_physics->my_a = 0; // Should not be used.
        this_box_volume.geometry.is_exit_volume = 1;
        sprintf(this_box_volume.p_physics->name,"Exit");
    } else {
        #ifndef MATERIAL_DETECTOR
            printf("Need to define a material before refering to it in a geometry %s.\n",NAME_CURRENT_COMP);
            exit(1);
        #endif
        for (loop_index=0;loop_index<global_material_list.num_elements;loop_index++) {
            if (0 == strcmp(material_string,global_material_list.elements[loop_index].name)) {
                this_box_volume.p_physics = global_material_list.elements[loop_index].physics;
                break;
            }
            if (loop_index == global_material_list.num_elements-1) {
            printf("\n");
            printf("ERROR: The material string \"%s\" in Union geometry \"%s\" did not match a specified material. \n",material_string,NAME_CURRENT_COMP);
            printf("       The materials available at this point (need to be defined before the geometry): \n");
            for (loop_index=0;loop_index<global_material_list.num_elements;loop_index++)
              printf("         %s\n",global_material_list.elements[loop_index].name);
            printf("\n");
            printf("       It is also possible to use one of the defualt materials avaiable: \n");
            printf("           Vacuum (for a Volume without scattering or absorption)\n");
            printf("           Exit (for a Volume where the ray exits the component if it enters)\n");
            printf("           Mask (for a Volume that masks existing volumes specified in the mask_string\n");
            exit(1);
          }
        }
    }
} else {
    // Automatic linking, simply using the last defined material.
    #ifndef MATERIAL_DETECTOR
        printf("Need to define a material before the geometry to use automatic linking %s.\n",NAME_CURRENT_COMP);
        exit(1);
    #endif
    this_box_volume.p_physics = global_material_list.elements[global_material_list.num_elements-1].physics;
}

sprintf(this_box_volume.name,NAME_CURRENT_COMP);
sprintf(this_box_volume.geometry.shape,"box");
this_box_volume.geometry.priority_value = priority;
this_box_volume.geometry.geometry_p_interact = p_interact;
// Currently the coordinates will be in absolute space.
this_box_volume.geometry.center = POS_A_CURRENT_COMP;

this_box_storage.z_depth = zdepth;
this_box_storage.x_width1 = xwidth;
this_box_storage.y_height1 = yheight;

this_box_storage.is_rectangle = 0;
if (xwidth2 < 0 && yheight2 < 0) this_box_storage.is_rectangle = 1;
if (xwidth == xwidth2 && yheight == yheight2) this_box_storage.is_rectangle = 1;

if (xwidth2 < 0) {
    this_box_storage.x_width2 = xwidth;
    xwidth2 = xwidth;
} else this_box_storage.x_width2 = xwidth2;

if (yheight2 < 0) {
    this_box_storage.y_height2 = yheight;
    yheight2 = yheight;
} else this_box_storage.y_height2 = yheight2;


this_box_storage.normal_vectors[0] = coords_set(0,0,1);
this_box_storage.normal_vectors[1] = coords_set(0,0,1);

// for sides with y component = 0
x_component = 2*zdepth/sqrt((xwidth-xwidth2)*(xwidth-xwidth2)+4*zdepth*zdepth);
z_component = (xwidth-xwidth2)/sqrt(4*zdepth*zdepth+(xwidth-xwidth2)*(xwidth-xwidth2));

this_box_storage.normal_vectors[2] = coords_set(x_component,0,z_component);
this_box_storage.normal_vectors[3] = coords_set(-x_component,0,z_component);

// for sides with x component = 0
y_component = 2*zdepth/sqrt((yheight-yheight2)*(yheight-yheight2)+4*zdepth*zdepth);
z_component = (yheight-yheight2)/sqrt(4*zdepth*zdepth+(yheight-yheight2)*(yheight-yheight2));

this_box_storage.normal_vectors[4] = coords_set(0,y_component,z_component);
this_box_storage.normal_vectors[5] = coords_set(0,-y_component,z_component);

this_box_volume.geometry.visualization_on = visualize;

this_box_volume.geometry.geometry_parameters.p_box_storage = &this_box_storage;

// Assign pointers to functions for intersection with the shape, checking if a point is inside the shape
if (this_box_storage.is_rectangle == 1) {
this_box_volume.geometry.intersect_function = &sample_box_intersect_simple;
this_box_volume.geometry.within_function = &r_within_box_simple;
}
else {
this_box_volume.geometry.intersect_function = &sample_box_intersect_advanced;
this_box_volume.geometry.within_function = &r_within_box_advanced;
}

this_box_volume.geometry.shell_points = &box_shell_points;
this_box_volume.geometry.mcdisplay_function = &mcdisplay_box_function;
this_box_volume.geometry.initialize_from_main_function = &initialize_box_geometry_from_main_component;
this_box_volume.geometry.process_rot_allocated = 0;

this_box_volume.geometry.copy_geometry_parameters = &allocate_box_storage_copy;

rot_copy(this_box_volume.geometry.rotation_matrix,ROT_A_CURRENT_COMP); //check how ROT_R_CURRENT_COMP would work
rot_transpose(ROT_A_CURRENT_COMP,this_box_volume.geometry.transpose_rotation_matrix);

// Initialize loggers
this_box_volume.loggers.num_elements = 0;

// packing the information into the global_geometry_element, which is then included in the global_geometry_list.
sprintf(global_geometry_element.name,NAME_CURRENT_COMP);
global_geometry_element.activation_counter = number_of_activations;
global_geometry_element.component_index = INDEX_CURRENT_COMP;
global_geometry_element.Volume = &this_box_volume; // Would be nicer if this m was a pointer, now we have the (small) data two places
add_element_to_geometry_list(&global_geometry_list,global_geometry_element);
}
#line 273665 "MACS_sample_kidney_box.c"
#undef number_of_activations
#undef mask_setting
#undef mask_string
#undef p_interact
#undef focus_r
#undef focus_xh
#undef focus_xw
#undef focus_ah
#undef focus_aw
#undef target_z
#undef target_y
#undef target_x
#undef target_index
#undef visualize
#undef yheight2
#undef xwidth2
#undef zdepth
#undef yheight
#undef xwidth
#undef priority
#undef material_string
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

  /* Initializations for component channel_12_analyzer_2_center. */
  SIG_MESSAGE("channel_12_analyzer_2_center (Init)");

  /* Initializations for component channel_12_analyzer_2_rotated. */
  SIG_MESSAGE("channel_12_analyzer_2_rotated (Init)");

  /* Initializations for component channel_12_analyzer_2_array_crystal_array_0. */
  SIG_MESSAGE("channel_12_analyzer_2_array_crystal_array_0 (Init)");
#define mccompcurname  channel_12_analyzer_2_array_crystal_array_0
#define mccompcurtype  Union_box
#define mccompcurindex 597
#define loop_index mccchannel_12_analyzer_2_array_crystal_array_0_loop_index
#define this_box_volume mccchannel_12_analyzer_2_array_crystal_array_0_this_box_volume
#define global_geometry_element mccchannel_12_analyzer_2_array_crystal_array_0_global_geometry_element
#define this_box_storage mccchannel_12_analyzer_2_array_crystal_array_0_this_box_storage
#define material_string mccchannel_12_analyzer_2_array_crystal_array_0_material_string
#define priority mccchannel_12_analyzer_2_array_crystal_array_0_priority
#define xwidth mccchannel_12_analyzer_2_array_crystal_array_0_xwidth
#define yheight mccchannel_12_analyzer_2_array_crystal_array_0_yheight
#define zdepth mccchannel_12_analyzer_2_array_crystal_array_0_zdepth
#define xwidth2 mccchannel_12_analyzer_2_array_crystal_array_0_xwidth2
#define yheight2 mccchannel_12_analyzer_2_array_crystal_array_0_yheight2
#define visualize mccchannel_12_analyzer_2_array_crystal_array_0_visualize
#define target_index mccchannel_12_analyzer_2_array_crystal_array_0_target_index
#define target_x mccchannel_12_analyzer_2_array_crystal_array_0_target_x
#define target_y mccchannel_12_analyzer_2_array_crystal_array_0_target_y
#define target_z mccchannel_12_analyzer_2_array_crystal_array_0_target_z
#define focus_aw mccchannel_12_analyzer_2_array_crystal_array_0_focus_aw
#define focus_ah mccchannel_12_analyzer_2_array_crystal_array_0_focus_ah
#define focus_xw mccchannel_12_analyzer_2_array_crystal_array_0_focus_xw
#define focus_xh mccchannel_12_analyzer_2_array_crystal_array_0_focus_xh
#define focus_r mccchannel_12_analyzer_2_array_crystal_array_0_focus_r
#define p_interact mccchannel_12_analyzer_2_array_crystal_array_0_p_interact
#define mask_string mccchannel_12_analyzer_2_array_crystal_array_0_mask_string
#define mask_setting mccchannel_12_analyzer_2_array_crystal_array_0_mask_setting
#define number_of_activations mccchannel_12_analyzer_2_array_crystal_array_0_number_of_activations
#line 224 "Union_box.comp"
{
// Initializes the focusing system for this volume including input sanitation.
focus_initialize(&this_box_volume.geometry, POS_A_COMP_INDEX(INDEX_CURRENT_COMP+target_index), POS_A_CURRENT_COMP, ROT_A_CURRENT_COMP, target_index, target_x, target_y, target_z, focus_aw, focus_ah, focus_xw, focus_xh, focus_r, NAME_CURRENT_COMP);

// Input sanitation for this geometry
if (xwidth <= 0) {
  printf("\nERROR in Union_box named %s, the xwidth is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (yheight <= 0) {
  printf("\nERROR in Union_box named %s, yheight is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (zdepth <= 0) {
  printf("\nERROR in Union_box named %s, zdepth is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (xwidth2 <= 0 && xwidth2 != -1) {
  printf("\nERROR in Union_box named %s, the xwidth2 is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (yheight2 <= 0 && yheight2 != -1) {
  printf("\nERROR in Union_box named %s, yheight2 is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}

// Use sanitation
if (global_material_list.num_elements == 0) {
  printf("\nERROR: Need to define a material using Union_make_material before using a Union geometry component. \n");
  printf("       %s was defined before first use of Union_make_material.\n",NAME_CURRENT_COMP);
  exit(1);
}

this_box_volume.geometry.is_masked_volume = 0;
this_box_volume.geometry.is_exit_volume = 0;
this_box_volume.geometry.is_mask_volume = 0;
// check if the volume is a mask, if it is the material string is irelevant.
if (mask_string && strlen(mask_string) && strcmp(mask_string, "NULL") && strcmp(mask_string, "0")) {
    // A mask volume is used to limit the extend of other volumes, called the masked volumes. These are specified in the mask_string.
    // In order for a ray to enter a masked volume, it needs to be both in the region covered by that volume AND the mask volume.
    // When more than
    this_box_volume.geometry.mask_mode = 1; // Default is mask mode is ALL
    if (mask_setting && strlen(mask_setting) && strcmp(mask_setting, "NULL") && strcmp(mask_setting, "0")) {
        if (strcmp(mask_setting,"ALL") == 0 || strcmp(mask_setting,"All") == 0) this_box_volume.geometry.mask_mode = 1;
        else if (strcmp(mask_setting,"ANY") == 0 || strcmp(mask_setting,"Any") == 0) this_box_volume.geometry.mask_mode = 2;
        else {
            printf("The mask_mode of component %s is set to %s, but must be either ALL or ANY.\n",NAME_CURRENT_COMP,mask_setting);
            exit(1);
        }
    }
    
    for (loop_index=0;loop_index<global_geometry_list.num_elements;loop_index++) {
        // Add mask list
        if (1 == manual_linking_function(global_geometry_list.elements[loop_index].name,mask_string)) {
            add_element_to_int_list(&this_box_volume.geometry.mask_list,global_geometry_list.elements[loop_index].component_index);
            add_element_to_int_list(&global_geometry_list.elements[loop_index].Volume->geometry.masked_by_list,INDEX_CURRENT_COMP);
            global_geometry_list.elements[loop_index].Volume->geometry.is_masked_volume = 1;
            if (this_box_volume.geometry.mask_mode == 2)
                global_geometry_list.elements[loop_index].Volume->geometry.mask_mode = 2;
            if (this_box_volume.geometry.mask_mode == 1) {
                if (global_geometry_list.elements[loop_index].Volume->geometry.is_masked_volume == 1 && global_geometry_list.elements[loop_index].Volume->geometry.mask_mode != 2)
                    // If more than one mask is added to one volume, the ANY mode overwrites the (default) ALL mode.
                    global_geometry_list.elements[loop_index].Volume->geometry.mask_mode = 1;
            }
            
            found_geometries = 1;
        }
    }
    if (found_geometries == 0) {
        printf("The mask_string in geometry: %s did not find any of the specified volumes in the mask_string %s \n",NAME_CURRENT_COMP,mask_string);
        exit(1);
    }
    this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
    this_box_volume.p_physics->is_vacuum = 0; // Makes this volume a vacuum
    this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
    this_box_volume.p_physics->my_a = 0; // Should not be used.
    sprintf(this_box_volume.p_physics->name,"Mask");
    this_box_volume.geometry.is_mask_volume = 1;
    
    
// Read the material input, or if it lacks, use automatic linking.
} else if (material_string && strlen(material_string) && strcmp(material_string, "NULL") && strcmp(material_string, "0")) {
    // A geometry string was given, use it to determine which material
    if (0 == strcmp(material_string,"vacuum") || 0 == strcmp(material_string,"Vacuum")) {
        // One could have a global physics struct for vacuum instead of creating one for each
        this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
        this_box_volume.p_physics->is_vacuum = 1; // Makes this volume a vacuum
        this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
        this_box_volume.p_physics->my_a = 0; // Should not be used.
        sprintf(this_box_volume.p_physics->name,"Vacuum");
    } else if (0 == strcmp(material_string,"exit") || 0 == strcmp(material_string,"Exit")) {
        // One could have a global physics struct for vacuum instead of creating one for each
        this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
        this_box_volume.p_physics->is_vacuum = 1; // Makes this volume a vacuum
        this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
        this_box_volume.p_physics->my_a = 0; // Should not be used.
        this_box_volume.geometry.is_exit_volume = 1;
        sprintf(this_box_volume.p_physics->name,"Exit");
    } else {
        #ifndef MATERIAL_DETECTOR
            printf("Need to define a material before refering to it in a geometry %s.\n",NAME_CURRENT_COMP);
            exit(1);
        #endif
        for (loop_index=0;loop_index<global_material_list.num_elements;loop_index++) {
            if (0 == strcmp(material_string,global_material_list.elements[loop_index].name)) {
                this_box_volume.p_physics = global_material_list.elements[loop_index].physics;
                break;
            }
            if (loop_index == global_material_list.num_elements-1) {
            printf("\n");
            printf("ERROR: The material string \"%s\" in Union geometry \"%s\" did not match a specified material. \n",material_string,NAME_CURRENT_COMP);
            printf("       The materials available at this point (need to be defined before the geometry): \n");
            for (loop_index=0;loop_index<global_material_list.num_elements;loop_index++)
              printf("         %s\n",global_material_list.elements[loop_index].name);
            printf("\n");
            printf("       It is also possible to use one of the defualt materials avaiable: \n");
            printf("           Vacuum (for a Volume without scattering or absorption)\n");
            printf("           Exit (for a Volume where the ray exits the component if it enters)\n");
            printf("           Mask (for a Volume that masks existing volumes specified in the mask_string\n");
            exit(1);
          }
        }
    }
} else {
    // Automatic linking, simply using the last defined material.
    #ifndef MATERIAL_DETECTOR
        printf("Need to define a material before the geometry to use automatic linking %s.\n",NAME_CURRENT_COMP);
        exit(1);
    #endif
    this_box_volume.p_physics = global_material_list.elements[global_material_list.num_elements-1].physics;
}

sprintf(this_box_volume.name,NAME_CURRENT_COMP);
sprintf(this_box_volume.geometry.shape,"box");
this_box_volume.geometry.priority_value = priority;
this_box_volume.geometry.geometry_p_interact = p_interact;
// Currently the coordinates will be in absolute space.
this_box_volume.geometry.center = POS_A_CURRENT_COMP;

this_box_storage.z_depth = zdepth;
this_box_storage.x_width1 = xwidth;
this_box_storage.y_height1 = yheight;

this_box_storage.is_rectangle = 0;
if (xwidth2 < 0 && yheight2 < 0) this_box_storage.is_rectangle = 1;
if (xwidth == xwidth2 && yheight == yheight2) this_box_storage.is_rectangle = 1;

if (xwidth2 < 0) {
    this_box_storage.x_width2 = xwidth;
    xwidth2 = xwidth;
} else this_box_storage.x_width2 = xwidth2;

if (yheight2 < 0) {
    this_box_storage.y_height2 = yheight;
    yheight2 = yheight;
} else this_box_storage.y_height2 = yheight2;


this_box_storage.normal_vectors[0] = coords_set(0,0,1);
this_box_storage.normal_vectors[1] = coords_set(0,0,1);

// for sides with y component = 0
x_component = 2*zdepth/sqrt((xwidth-xwidth2)*(xwidth-xwidth2)+4*zdepth*zdepth);
z_component = (xwidth-xwidth2)/sqrt(4*zdepth*zdepth+(xwidth-xwidth2)*(xwidth-xwidth2));

this_box_storage.normal_vectors[2] = coords_set(x_component,0,z_component);
this_box_storage.normal_vectors[3] = coords_set(-x_component,0,z_component);

// for sides with x component = 0
y_component = 2*zdepth/sqrt((yheight-yheight2)*(yheight-yheight2)+4*zdepth*zdepth);
z_component = (yheight-yheight2)/sqrt(4*zdepth*zdepth+(yheight-yheight2)*(yheight-yheight2));

this_box_storage.normal_vectors[4] = coords_set(0,y_component,z_component);
this_box_storage.normal_vectors[5] = coords_set(0,-y_component,z_component);

this_box_volume.geometry.visualization_on = visualize;

this_box_volume.geometry.geometry_parameters.p_box_storage = &this_box_storage;

// Assign pointers to functions for intersection with the shape, checking if a point is inside the shape
if (this_box_storage.is_rectangle == 1) {
this_box_volume.geometry.intersect_function = &sample_box_intersect_simple;
this_box_volume.geometry.within_function = &r_within_box_simple;
}
else {
this_box_volume.geometry.intersect_function = &sample_box_intersect_advanced;
this_box_volume.geometry.within_function = &r_within_box_advanced;
}

this_box_volume.geometry.shell_points = &box_shell_points;
this_box_volume.geometry.mcdisplay_function = &mcdisplay_box_function;
this_box_volume.geometry.initialize_from_main_function = &initialize_box_geometry_from_main_component;
this_box_volume.geometry.process_rot_allocated = 0;

this_box_volume.geometry.copy_geometry_parameters = &allocate_box_storage_copy;

rot_copy(this_box_volume.geometry.rotation_matrix,ROT_A_CURRENT_COMP); //check how ROT_R_CURRENT_COMP would work
rot_transpose(ROT_A_CURRENT_COMP,this_box_volume.geometry.transpose_rotation_matrix);

// Initialize loggers
this_box_volume.loggers.num_elements = 0;

// packing the information into the global_geometry_element, which is then included in the global_geometry_list.
sprintf(global_geometry_element.name,NAME_CURRENT_COMP);
global_geometry_element.activation_counter = number_of_activations;
global_geometry_element.component_index = INDEX_CURRENT_COMP;
global_geometry_element.Volume = &this_box_volume; // Would be nicer if this m was a pointer, now we have the (small) data two places
add_element_to_geometry_list(&global_geometry_list,global_geometry_element);
}
#line 273941 "MACS_sample_kidney_box.c"
#undef number_of_activations
#undef mask_setting
#undef mask_string
#undef p_interact
#undef focus_r
#undef focus_xh
#undef focus_xw
#undef focus_ah
#undef focus_aw
#undef target_z
#undef target_y
#undef target_x
#undef target_index
#undef visualize
#undef yheight2
#undef xwidth2
#undef zdepth
#undef yheight
#undef xwidth
#undef priority
#undef material_string
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

  /* Initializations for component channel_12_analyzer_2_array_crystal_array_1. */
  SIG_MESSAGE("channel_12_analyzer_2_array_crystal_array_1 (Init)");
#define mccompcurname  channel_12_analyzer_2_array_crystal_array_1
#define mccompcurtype  Union_box
#define mccompcurindex 598
#define loop_index mccchannel_12_analyzer_2_array_crystal_array_1_loop_index
#define this_box_volume mccchannel_12_analyzer_2_array_crystal_array_1_this_box_volume
#define global_geometry_element mccchannel_12_analyzer_2_array_crystal_array_1_global_geometry_element
#define this_box_storage mccchannel_12_analyzer_2_array_crystal_array_1_this_box_storage
#define material_string mccchannel_12_analyzer_2_array_crystal_array_1_material_string
#define priority mccchannel_12_analyzer_2_array_crystal_array_1_priority
#define xwidth mccchannel_12_analyzer_2_array_crystal_array_1_xwidth
#define yheight mccchannel_12_analyzer_2_array_crystal_array_1_yheight
#define zdepth mccchannel_12_analyzer_2_array_crystal_array_1_zdepth
#define xwidth2 mccchannel_12_analyzer_2_array_crystal_array_1_xwidth2
#define yheight2 mccchannel_12_analyzer_2_array_crystal_array_1_yheight2
#define visualize mccchannel_12_analyzer_2_array_crystal_array_1_visualize
#define target_index mccchannel_12_analyzer_2_array_crystal_array_1_target_index
#define target_x mccchannel_12_analyzer_2_array_crystal_array_1_target_x
#define target_y mccchannel_12_analyzer_2_array_crystal_array_1_target_y
#define target_z mccchannel_12_analyzer_2_array_crystal_array_1_target_z
#define focus_aw mccchannel_12_analyzer_2_array_crystal_array_1_focus_aw
#define focus_ah mccchannel_12_analyzer_2_array_crystal_array_1_focus_ah
#define focus_xw mccchannel_12_analyzer_2_array_crystal_array_1_focus_xw
#define focus_xh mccchannel_12_analyzer_2_array_crystal_array_1_focus_xh
#define focus_r mccchannel_12_analyzer_2_array_crystal_array_1_focus_r
#define p_interact mccchannel_12_analyzer_2_array_crystal_array_1_p_interact
#define mask_string mccchannel_12_analyzer_2_array_crystal_array_1_mask_string
#define mask_setting mccchannel_12_analyzer_2_array_crystal_array_1_mask_setting
#define number_of_activations mccchannel_12_analyzer_2_array_crystal_array_1_number_of_activations
#line 224 "Union_box.comp"
{
// Initializes the focusing system for this volume including input sanitation.
focus_initialize(&this_box_volume.geometry, POS_A_COMP_INDEX(INDEX_CURRENT_COMP+target_index), POS_A_CURRENT_COMP, ROT_A_CURRENT_COMP, target_index, target_x, target_y, target_z, focus_aw, focus_ah, focus_xw, focus_xh, focus_r, NAME_CURRENT_COMP);

// Input sanitation for this geometry
if (xwidth <= 0) {
  printf("\nERROR in Union_box named %s, the xwidth is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (yheight <= 0) {
  printf("\nERROR in Union_box named %s, yheight is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (zdepth <= 0) {
  printf("\nERROR in Union_box named %s, zdepth is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (xwidth2 <= 0 && xwidth2 != -1) {
  printf("\nERROR in Union_box named %s, the xwidth2 is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (yheight2 <= 0 && yheight2 != -1) {
  printf("\nERROR in Union_box named %s, yheight2 is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}

// Use sanitation
if (global_material_list.num_elements == 0) {
  printf("\nERROR: Need to define a material using Union_make_material before using a Union geometry component. \n");
  printf("       %s was defined before first use of Union_make_material.\n",NAME_CURRENT_COMP);
  exit(1);
}

this_box_volume.geometry.is_masked_volume = 0;
this_box_volume.geometry.is_exit_volume = 0;
this_box_volume.geometry.is_mask_volume = 0;
// check if the volume is a mask, if it is the material string is irelevant.
if (mask_string && strlen(mask_string) && strcmp(mask_string, "NULL") && strcmp(mask_string, "0")) {
    // A mask volume is used to limit the extend of other volumes, called the masked volumes. These are specified in the mask_string.
    // In order for a ray to enter a masked volume, it needs to be both in the region covered by that volume AND the mask volume.
    // When more than
    this_box_volume.geometry.mask_mode = 1; // Default is mask mode is ALL
    if (mask_setting && strlen(mask_setting) && strcmp(mask_setting, "NULL") && strcmp(mask_setting, "0")) {
        if (strcmp(mask_setting,"ALL") == 0 || strcmp(mask_setting,"All") == 0) this_box_volume.geometry.mask_mode = 1;
        else if (strcmp(mask_setting,"ANY") == 0 || strcmp(mask_setting,"Any") == 0) this_box_volume.geometry.mask_mode = 2;
        else {
            printf("The mask_mode of component %s is set to %s, but must be either ALL or ANY.\n",NAME_CURRENT_COMP,mask_setting);
            exit(1);
        }
    }
    
    for (loop_index=0;loop_index<global_geometry_list.num_elements;loop_index++) {
        // Add mask list
        if (1 == manual_linking_function(global_geometry_list.elements[loop_index].name,mask_string)) {
            add_element_to_int_list(&this_box_volume.geometry.mask_list,global_geometry_list.elements[loop_index].component_index);
            add_element_to_int_list(&global_geometry_list.elements[loop_index].Volume->geometry.masked_by_list,INDEX_CURRENT_COMP);
            global_geometry_list.elements[loop_index].Volume->geometry.is_masked_volume = 1;
            if (this_box_volume.geometry.mask_mode == 2)
                global_geometry_list.elements[loop_index].Volume->geometry.mask_mode = 2;
            if (this_box_volume.geometry.mask_mode == 1) {
                if (global_geometry_list.elements[loop_index].Volume->geometry.is_masked_volume == 1 && global_geometry_list.elements[loop_index].Volume->geometry.mask_mode != 2)
                    // If more than one mask is added to one volume, the ANY mode overwrites the (default) ALL mode.
                    global_geometry_list.elements[loop_index].Volume->geometry.mask_mode = 1;
            }
            
            found_geometries = 1;
        }
    }
    if (found_geometries == 0) {
        printf("The mask_string in geometry: %s did not find any of the specified volumes in the mask_string %s \n",NAME_CURRENT_COMP,mask_string);
        exit(1);
    }
    this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
    this_box_volume.p_physics->is_vacuum = 0; // Makes this volume a vacuum
    this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
    this_box_volume.p_physics->my_a = 0; // Should not be used.
    sprintf(this_box_volume.p_physics->name,"Mask");
    this_box_volume.geometry.is_mask_volume = 1;
    
    
// Read the material input, or if it lacks, use automatic linking.
} else if (material_string && strlen(material_string) && strcmp(material_string, "NULL") && strcmp(material_string, "0")) {
    // A geometry string was given, use it to determine which material
    if (0 == strcmp(material_string,"vacuum") || 0 == strcmp(material_string,"Vacuum")) {
        // One could have a global physics struct for vacuum instead of creating one for each
        this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
        this_box_volume.p_physics->is_vacuum = 1; // Makes this volume a vacuum
        this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
        this_box_volume.p_physics->my_a = 0; // Should not be used.
        sprintf(this_box_volume.p_physics->name,"Vacuum");
    } else if (0 == strcmp(material_string,"exit") || 0 == strcmp(material_string,"Exit")) {
        // One could have a global physics struct for vacuum instead of creating one for each
        this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
        this_box_volume.p_physics->is_vacuum = 1; // Makes this volume a vacuum
        this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
        this_box_volume.p_physics->my_a = 0; // Should not be used.
        this_box_volume.geometry.is_exit_volume = 1;
        sprintf(this_box_volume.p_physics->name,"Exit");
    } else {
        #ifndef MATERIAL_DETECTOR
            printf("Need to define a material before refering to it in a geometry %s.\n",NAME_CURRENT_COMP);
            exit(1);
        #endif
        for (loop_index=0;loop_index<global_material_list.num_elements;loop_index++) {
            if (0 == strcmp(material_string,global_material_list.elements[loop_index].name)) {
                this_box_volume.p_physics = global_material_list.elements[loop_index].physics;
                break;
            }
            if (loop_index == global_material_list.num_elements-1) {
            printf("\n");
            printf("ERROR: The material string \"%s\" in Union geometry \"%s\" did not match a specified material. \n",material_string,NAME_CURRENT_COMP);
            printf("       The materials available at this point (need to be defined before the geometry): \n");
            for (loop_index=0;loop_index<global_material_list.num_elements;loop_index++)
              printf("         %s\n",global_material_list.elements[loop_index].name);
            printf("\n");
            printf("       It is also possible to use one of the defualt materials avaiable: \n");
            printf("           Vacuum (for a Volume without scattering or absorption)\n");
            printf("           Exit (for a Volume where the ray exits the component if it enters)\n");
            printf("           Mask (for a Volume that masks existing volumes specified in the mask_string\n");
            exit(1);
          }
        }
    }
} else {
    // Automatic linking, simply using the last defined material.
    #ifndef MATERIAL_DETECTOR
        printf("Need to define a material before the geometry to use automatic linking %s.\n",NAME_CURRENT_COMP);
        exit(1);
    #endif
    this_box_volume.p_physics = global_material_list.elements[global_material_list.num_elements-1].physics;
}

sprintf(this_box_volume.name,NAME_CURRENT_COMP);
sprintf(this_box_volume.geometry.shape,"box");
this_box_volume.geometry.priority_value = priority;
this_box_volume.geometry.geometry_p_interact = p_interact;
// Currently the coordinates will be in absolute space.
this_box_volume.geometry.center = POS_A_CURRENT_COMP;

this_box_storage.z_depth = zdepth;
this_box_storage.x_width1 = xwidth;
this_box_storage.y_height1 = yheight;

this_box_storage.is_rectangle = 0;
if (xwidth2 < 0 && yheight2 < 0) this_box_storage.is_rectangle = 1;
if (xwidth == xwidth2 && yheight == yheight2) this_box_storage.is_rectangle = 1;

if (xwidth2 < 0) {
    this_box_storage.x_width2 = xwidth;
    xwidth2 = xwidth;
} else this_box_storage.x_width2 = xwidth2;

if (yheight2 < 0) {
    this_box_storage.y_height2 = yheight;
    yheight2 = yheight;
} else this_box_storage.y_height2 = yheight2;


this_box_storage.normal_vectors[0] = coords_set(0,0,1);
this_box_storage.normal_vectors[1] = coords_set(0,0,1);

// for sides with y component = 0
x_component = 2*zdepth/sqrt((xwidth-xwidth2)*(xwidth-xwidth2)+4*zdepth*zdepth);
z_component = (xwidth-xwidth2)/sqrt(4*zdepth*zdepth+(xwidth-xwidth2)*(xwidth-xwidth2));

this_box_storage.normal_vectors[2] = coords_set(x_component,0,z_component);
this_box_storage.normal_vectors[3] = coords_set(-x_component,0,z_component);

// for sides with x component = 0
y_component = 2*zdepth/sqrt((yheight-yheight2)*(yheight-yheight2)+4*zdepth*zdepth);
z_component = (yheight-yheight2)/sqrt(4*zdepth*zdepth+(yheight-yheight2)*(yheight-yheight2));

this_box_storage.normal_vectors[4] = coords_set(0,y_component,z_component);
this_box_storage.normal_vectors[5] = coords_set(0,-y_component,z_component);

this_box_volume.geometry.visualization_on = visualize;

this_box_volume.geometry.geometry_parameters.p_box_storage = &this_box_storage;

// Assign pointers to functions for intersection with the shape, checking if a point is inside the shape
if (this_box_storage.is_rectangle == 1) {
this_box_volume.geometry.intersect_function = &sample_box_intersect_simple;
this_box_volume.geometry.within_function = &r_within_box_simple;
}
else {
this_box_volume.geometry.intersect_function = &sample_box_intersect_advanced;
this_box_volume.geometry.within_function = &r_within_box_advanced;
}

this_box_volume.geometry.shell_points = &box_shell_points;
this_box_volume.geometry.mcdisplay_function = &mcdisplay_box_function;
this_box_volume.geometry.initialize_from_main_function = &initialize_box_geometry_from_main_component;
this_box_volume.geometry.process_rot_allocated = 0;

this_box_volume.geometry.copy_geometry_parameters = &allocate_box_storage_copy;

rot_copy(this_box_volume.geometry.rotation_matrix,ROT_A_CURRENT_COMP); //check how ROT_R_CURRENT_COMP would work
rot_transpose(ROT_A_CURRENT_COMP,this_box_volume.geometry.transpose_rotation_matrix);

// Initialize loggers
this_box_volume.loggers.num_elements = 0;

// packing the information into the global_geometry_element, which is then included in the global_geometry_list.
sprintf(global_geometry_element.name,NAME_CURRENT_COMP);
global_geometry_element.activation_counter = number_of_activations;
global_geometry_element.component_index = INDEX_CURRENT_COMP;
global_geometry_element.Volume = &this_box_volume; // Would be nicer if this m was a pointer, now we have the (small) data two places
add_element_to_geometry_list(&global_geometry_list,global_geometry_element);
}
#line 274211 "MACS_sample_kidney_box.c"
#undef number_of_activations
#undef mask_setting
#undef mask_string
#undef p_interact
#undef focus_r
#undef focus_xh
#undef focus_xw
#undef focus_ah
#undef focus_aw
#undef target_z
#undef target_y
#undef target_x
#undef target_index
#undef visualize
#undef yheight2
#undef xwidth2
#undef zdepth
#undef yheight
#undef xwidth
#undef priority
#undef material_string
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

  /* Initializations for component channel_12_analyzer_2_array_crystal_array_2. */
  SIG_MESSAGE("channel_12_analyzer_2_array_crystal_array_2 (Init)");
#define mccompcurname  channel_12_analyzer_2_array_crystal_array_2
#define mccompcurtype  Union_box
#define mccompcurindex 599
#define loop_index mccchannel_12_analyzer_2_array_crystal_array_2_loop_index
#define this_box_volume mccchannel_12_analyzer_2_array_crystal_array_2_this_box_volume
#define global_geometry_element mccchannel_12_analyzer_2_array_crystal_array_2_global_geometry_element
#define this_box_storage mccchannel_12_analyzer_2_array_crystal_array_2_this_box_storage
#define material_string mccchannel_12_analyzer_2_array_crystal_array_2_material_string
#define priority mccchannel_12_analyzer_2_array_crystal_array_2_priority
#define xwidth mccchannel_12_analyzer_2_array_crystal_array_2_xwidth
#define yheight mccchannel_12_analyzer_2_array_crystal_array_2_yheight
#define zdepth mccchannel_12_analyzer_2_array_crystal_array_2_zdepth
#define xwidth2 mccchannel_12_analyzer_2_array_crystal_array_2_xwidth2
#define yheight2 mccchannel_12_analyzer_2_array_crystal_array_2_yheight2
#define visualize mccchannel_12_analyzer_2_array_crystal_array_2_visualize
#define target_index mccchannel_12_analyzer_2_array_crystal_array_2_target_index
#define target_x mccchannel_12_analyzer_2_array_crystal_array_2_target_x
#define target_y mccchannel_12_analyzer_2_array_crystal_array_2_target_y
#define target_z mccchannel_12_analyzer_2_array_crystal_array_2_target_z
#define focus_aw mccchannel_12_analyzer_2_array_crystal_array_2_focus_aw
#define focus_ah mccchannel_12_analyzer_2_array_crystal_array_2_focus_ah
#define focus_xw mccchannel_12_analyzer_2_array_crystal_array_2_focus_xw
#define focus_xh mccchannel_12_analyzer_2_array_crystal_array_2_focus_xh
#define focus_r mccchannel_12_analyzer_2_array_crystal_array_2_focus_r
#define p_interact mccchannel_12_analyzer_2_array_crystal_array_2_p_interact
#define mask_string mccchannel_12_analyzer_2_array_crystal_array_2_mask_string
#define mask_setting mccchannel_12_analyzer_2_array_crystal_array_2_mask_setting
#define number_of_activations mccchannel_12_analyzer_2_array_crystal_array_2_number_of_activations
#line 224 "Union_box.comp"
{
// Initializes the focusing system for this volume including input sanitation.
focus_initialize(&this_box_volume.geometry, POS_A_COMP_INDEX(INDEX_CURRENT_COMP+target_index), POS_A_CURRENT_COMP, ROT_A_CURRENT_COMP, target_index, target_x, target_y, target_z, focus_aw, focus_ah, focus_xw, focus_xh, focus_r, NAME_CURRENT_COMP);

// Input sanitation for this geometry
if (xwidth <= 0) {
  printf("\nERROR in Union_box named %s, the xwidth is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (yheight <= 0) {
  printf("\nERROR in Union_box named %s, yheight is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (zdepth <= 0) {
  printf("\nERROR in Union_box named %s, zdepth is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (xwidth2 <= 0 && xwidth2 != -1) {
  printf("\nERROR in Union_box named %s, the xwidth2 is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (yheight2 <= 0 && yheight2 != -1) {
  printf("\nERROR in Union_box named %s, yheight2 is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}

// Use sanitation
if (global_material_list.num_elements == 0) {
  printf("\nERROR: Need to define a material using Union_make_material before using a Union geometry component. \n");
  printf("       %s was defined before first use of Union_make_material.\n",NAME_CURRENT_COMP);
  exit(1);
}

this_box_volume.geometry.is_masked_volume = 0;
this_box_volume.geometry.is_exit_volume = 0;
this_box_volume.geometry.is_mask_volume = 0;
// check if the volume is a mask, if it is the material string is irelevant.
if (mask_string && strlen(mask_string) && strcmp(mask_string, "NULL") && strcmp(mask_string, "0")) {
    // A mask volume is used to limit the extend of other volumes, called the masked volumes. These are specified in the mask_string.
    // In order for a ray to enter a masked volume, it needs to be both in the region covered by that volume AND the mask volume.
    // When more than
    this_box_volume.geometry.mask_mode = 1; // Default is mask mode is ALL
    if (mask_setting && strlen(mask_setting) && strcmp(mask_setting, "NULL") && strcmp(mask_setting, "0")) {
        if (strcmp(mask_setting,"ALL") == 0 || strcmp(mask_setting,"All") == 0) this_box_volume.geometry.mask_mode = 1;
        else if (strcmp(mask_setting,"ANY") == 0 || strcmp(mask_setting,"Any") == 0) this_box_volume.geometry.mask_mode = 2;
        else {
            printf("The mask_mode of component %s is set to %s, but must be either ALL or ANY.\n",NAME_CURRENT_COMP,mask_setting);
            exit(1);
        }
    }
    
    for (loop_index=0;loop_index<global_geometry_list.num_elements;loop_index++) {
        // Add mask list
        if (1 == manual_linking_function(global_geometry_list.elements[loop_index].name,mask_string)) {
            add_element_to_int_list(&this_box_volume.geometry.mask_list,global_geometry_list.elements[loop_index].component_index);
            add_element_to_int_list(&global_geometry_list.elements[loop_index].Volume->geometry.masked_by_list,INDEX_CURRENT_COMP);
            global_geometry_list.elements[loop_index].Volume->geometry.is_masked_volume = 1;
            if (this_box_volume.geometry.mask_mode == 2)
                global_geometry_list.elements[loop_index].Volume->geometry.mask_mode = 2;
            if (this_box_volume.geometry.mask_mode == 1) {
                if (global_geometry_list.elements[loop_index].Volume->geometry.is_masked_volume == 1 && global_geometry_list.elements[loop_index].Volume->geometry.mask_mode != 2)
                    // If more than one mask is added to one volume, the ANY mode overwrites the (default) ALL mode.
                    global_geometry_list.elements[loop_index].Volume->geometry.mask_mode = 1;
            }
            
            found_geometries = 1;
        }
    }
    if (found_geometries == 0) {
        printf("The mask_string in geometry: %s did not find any of the specified volumes in the mask_string %s \n",NAME_CURRENT_COMP,mask_string);
        exit(1);
    }
    this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
    this_box_volume.p_physics->is_vacuum = 0; // Makes this volume a vacuum
    this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
    this_box_volume.p_physics->my_a = 0; // Should not be used.
    sprintf(this_box_volume.p_physics->name,"Mask");
    this_box_volume.geometry.is_mask_volume = 1;
    
    
// Read the material input, or if it lacks, use automatic linking.
} else if (material_string && strlen(material_string) && strcmp(material_string, "NULL") && strcmp(material_string, "0")) {
    // A geometry string was given, use it to determine which material
    if (0 == strcmp(material_string,"vacuum") || 0 == strcmp(material_string,"Vacuum")) {
        // One could have a global physics struct for vacuum instead of creating one for each
        this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
        this_box_volume.p_physics->is_vacuum = 1; // Makes this volume a vacuum
        this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
        this_box_volume.p_physics->my_a = 0; // Should not be used.
        sprintf(this_box_volume.p_physics->name,"Vacuum");
    } else if (0 == strcmp(material_string,"exit") || 0 == strcmp(material_string,"Exit")) {
        // One could have a global physics struct for vacuum instead of creating one for each
        this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
        this_box_volume.p_physics->is_vacuum = 1; // Makes this volume a vacuum
        this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
        this_box_volume.p_physics->my_a = 0; // Should not be used.
        this_box_volume.geometry.is_exit_volume = 1;
        sprintf(this_box_volume.p_physics->name,"Exit");
    } else {
        #ifndef MATERIAL_DETECTOR
            printf("Need to define a material before refering to it in a geometry %s.\n",NAME_CURRENT_COMP);
            exit(1);
        #endif
        for (loop_index=0;loop_index<global_material_list.num_elements;loop_index++) {
            if (0 == strcmp(material_string,global_material_list.elements[loop_index].name)) {
                this_box_volume.p_physics = global_material_list.elements[loop_index].physics;
                break;
            }
            if (loop_index == global_material_list.num_elements-1) {
            printf("\n");
            printf("ERROR: The material string \"%s\" in Union geometry \"%s\" did not match a specified material. \n",material_string,NAME_CURRENT_COMP);
            printf("       The materials available at this point (need to be defined before the geometry): \n");
            for (loop_index=0;loop_index<global_material_list.num_elements;loop_index++)
              printf("         %s\n",global_material_list.elements[loop_index].name);
            printf("\n");
            printf("       It is also possible to use one of the defualt materials avaiable: \n");
            printf("           Vacuum (for a Volume without scattering or absorption)\n");
            printf("           Exit (for a Volume where the ray exits the component if it enters)\n");
            printf("           Mask (for a Volume that masks existing volumes specified in the mask_string\n");
            exit(1);
          }
        }
    }
} else {
    // Automatic linking, simply using the last defined material.
    #ifndef MATERIAL_DETECTOR
        printf("Need to define a material before the geometry to use automatic linking %s.\n",NAME_CURRENT_COMP);
        exit(1);
    #endif
    this_box_volume.p_physics = global_material_list.elements[global_material_list.num_elements-1].physics;
}

sprintf(this_box_volume.name,NAME_CURRENT_COMP);
sprintf(this_box_volume.geometry.shape,"box");
this_box_volume.geometry.priority_value = priority;
this_box_volume.geometry.geometry_p_interact = p_interact;
// Currently the coordinates will be in absolute space.
this_box_volume.geometry.center = POS_A_CURRENT_COMP;

this_box_storage.z_depth = zdepth;
this_box_storage.x_width1 = xwidth;
this_box_storage.y_height1 = yheight;

this_box_storage.is_rectangle = 0;
if (xwidth2 < 0 && yheight2 < 0) this_box_storage.is_rectangle = 1;
if (xwidth == xwidth2 && yheight == yheight2) this_box_storage.is_rectangle = 1;

if (xwidth2 < 0) {
    this_box_storage.x_width2 = xwidth;
    xwidth2 = xwidth;
} else this_box_storage.x_width2 = xwidth2;

if (yheight2 < 0) {
    this_box_storage.y_height2 = yheight;
    yheight2 = yheight;
} else this_box_storage.y_height2 = yheight2;


this_box_storage.normal_vectors[0] = coords_set(0,0,1);
this_box_storage.normal_vectors[1] = coords_set(0,0,1);

// for sides with y component = 0
x_component = 2*zdepth/sqrt((xwidth-xwidth2)*(xwidth-xwidth2)+4*zdepth*zdepth);
z_component = (xwidth-xwidth2)/sqrt(4*zdepth*zdepth+(xwidth-xwidth2)*(xwidth-xwidth2));

this_box_storage.normal_vectors[2] = coords_set(x_component,0,z_component);
this_box_storage.normal_vectors[3] = coords_set(-x_component,0,z_component);

// for sides with x component = 0
y_component = 2*zdepth/sqrt((yheight-yheight2)*(yheight-yheight2)+4*zdepth*zdepth);
z_component = (yheight-yheight2)/sqrt(4*zdepth*zdepth+(yheight-yheight2)*(yheight-yheight2));

this_box_storage.normal_vectors[4] = coords_set(0,y_component,z_component);
this_box_storage.normal_vectors[5] = coords_set(0,-y_component,z_component);

this_box_volume.geometry.visualization_on = visualize;

this_box_volume.geometry.geometry_parameters.p_box_storage = &this_box_storage;

// Assign pointers to functions for intersection with the shape, checking if a point is inside the shape
if (this_box_storage.is_rectangle == 1) {
this_box_volume.geometry.intersect_function = &sample_box_intersect_simple;
this_box_volume.geometry.within_function = &r_within_box_simple;
}
else {
this_box_volume.geometry.intersect_function = &sample_box_intersect_advanced;
this_box_volume.geometry.within_function = &r_within_box_advanced;
}

this_box_volume.geometry.shell_points = &box_shell_points;
this_box_volume.geometry.mcdisplay_function = &mcdisplay_box_function;
this_box_volume.geometry.initialize_from_main_function = &initialize_box_geometry_from_main_component;
this_box_volume.geometry.process_rot_allocated = 0;

this_box_volume.geometry.copy_geometry_parameters = &allocate_box_storage_copy;

rot_copy(this_box_volume.geometry.rotation_matrix,ROT_A_CURRENT_COMP); //check how ROT_R_CURRENT_COMP would work
rot_transpose(ROT_A_CURRENT_COMP,this_box_volume.geometry.transpose_rotation_matrix);

// Initialize loggers
this_box_volume.loggers.num_elements = 0;

// packing the information into the global_geometry_element, which is then included in the global_geometry_list.
sprintf(global_geometry_element.name,NAME_CURRENT_COMP);
global_geometry_element.activation_counter = number_of_activations;
global_geometry_element.component_index = INDEX_CURRENT_COMP;
global_geometry_element.Volume = &this_box_volume; // Would be nicer if this m was a pointer, now we have the (small) data two places
add_element_to_geometry_list(&global_geometry_list,global_geometry_element);
}
#line 274481 "MACS_sample_kidney_box.c"
#undef number_of_activations
#undef mask_setting
#undef mask_string
#undef p_interact
#undef focus_r
#undef focus_xh
#undef focus_xw
#undef focus_ah
#undef focus_aw
#undef target_z
#undef target_y
#undef target_x
#undef target_index
#undef visualize
#undef yheight2
#undef xwidth2
#undef zdepth
#undef yheight
#undef xwidth
#undef priority
#undef material_string
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

  /* Initializations for component channel_12_analyzer_2_array_crystal_array_3. */
  SIG_MESSAGE("channel_12_analyzer_2_array_crystal_array_3 (Init)");
#define mccompcurname  channel_12_analyzer_2_array_crystal_array_3
#define mccompcurtype  Union_box
#define mccompcurindex 600
#define loop_index mccchannel_12_analyzer_2_array_crystal_array_3_loop_index
#define this_box_volume mccchannel_12_analyzer_2_array_crystal_array_3_this_box_volume
#define global_geometry_element mccchannel_12_analyzer_2_array_crystal_array_3_global_geometry_element
#define this_box_storage mccchannel_12_analyzer_2_array_crystal_array_3_this_box_storage
#define material_string mccchannel_12_analyzer_2_array_crystal_array_3_material_string
#define priority mccchannel_12_analyzer_2_array_crystal_array_3_priority
#define xwidth mccchannel_12_analyzer_2_array_crystal_array_3_xwidth
#define yheight mccchannel_12_analyzer_2_array_crystal_array_3_yheight
#define zdepth mccchannel_12_analyzer_2_array_crystal_array_3_zdepth
#define xwidth2 mccchannel_12_analyzer_2_array_crystal_array_3_xwidth2
#define yheight2 mccchannel_12_analyzer_2_array_crystal_array_3_yheight2
#define visualize mccchannel_12_analyzer_2_array_crystal_array_3_visualize
#define target_index mccchannel_12_analyzer_2_array_crystal_array_3_target_index
#define target_x mccchannel_12_analyzer_2_array_crystal_array_3_target_x
#define target_y mccchannel_12_analyzer_2_array_crystal_array_3_target_y
#define target_z mccchannel_12_analyzer_2_array_crystal_array_3_target_z
#define focus_aw mccchannel_12_analyzer_2_array_crystal_array_3_focus_aw
#define focus_ah mccchannel_12_analyzer_2_array_crystal_array_3_focus_ah
#define focus_xw mccchannel_12_analyzer_2_array_crystal_array_3_focus_xw
#define focus_xh mccchannel_12_analyzer_2_array_crystal_array_3_focus_xh
#define focus_r mccchannel_12_analyzer_2_array_crystal_array_3_focus_r
#define p_interact mccchannel_12_analyzer_2_array_crystal_array_3_p_interact
#define mask_string mccchannel_12_analyzer_2_array_crystal_array_3_mask_string
#define mask_setting mccchannel_12_analyzer_2_array_crystal_array_3_mask_setting
#define number_of_activations mccchannel_12_analyzer_2_array_crystal_array_3_number_of_activations
#line 224 "Union_box.comp"
{
// Initializes the focusing system for this volume including input sanitation.
focus_initialize(&this_box_volume.geometry, POS_A_COMP_INDEX(INDEX_CURRENT_COMP+target_index), POS_A_CURRENT_COMP, ROT_A_CURRENT_COMP, target_index, target_x, target_y, target_z, focus_aw, focus_ah, focus_xw, focus_xh, focus_r, NAME_CURRENT_COMP);

// Input sanitation for this geometry
if (xwidth <= 0) {
  printf("\nERROR in Union_box named %s, the xwidth is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (yheight <= 0) {
  printf("\nERROR in Union_box named %s, yheight is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (zdepth <= 0) {
  printf("\nERROR in Union_box named %s, zdepth is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (xwidth2 <= 0 && xwidth2 != -1) {
  printf("\nERROR in Union_box named %s, the xwidth2 is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (yheight2 <= 0 && yheight2 != -1) {
  printf("\nERROR in Union_box named %s, yheight2 is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}

// Use sanitation
if (global_material_list.num_elements == 0) {
  printf("\nERROR: Need to define a material using Union_make_material before using a Union geometry component. \n");
  printf("       %s was defined before first use of Union_make_material.\n",NAME_CURRENT_COMP);
  exit(1);
}

this_box_volume.geometry.is_masked_volume = 0;
this_box_volume.geometry.is_exit_volume = 0;
this_box_volume.geometry.is_mask_volume = 0;
// check if the volume is a mask, if it is the material string is irelevant.
if (mask_string && strlen(mask_string) && strcmp(mask_string, "NULL") && strcmp(mask_string, "0")) {
    // A mask volume is used to limit the extend of other volumes, called the masked volumes. These are specified in the mask_string.
    // In order for a ray to enter a masked volume, it needs to be both in the region covered by that volume AND the mask volume.
    // When more than
    this_box_volume.geometry.mask_mode = 1; // Default is mask mode is ALL
    if (mask_setting && strlen(mask_setting) && strcmp(mask_setting, "NULL") && strcmp(mask_setting, "0")) {
        if (strcmp(mask_setting,"ALL") == 0 || strcmp(mask_setting,"All") == 0) this_box_volume.geometry.mask_mode = 1;
        else if (strcmp(mask_setting,"ANY") == 0 || strcmp(mask_setting,"Any") == 0) this_box_volume.geometry.mask_mode = 2;
        else {
            printf("The mask_mode of component %s is set to %s, but must be either ALL or ANY.\n",NAME_CURRENT_COMP,mask_setting);
            exit(1);
        }
    }
    
    for (loop_index=0;loop_index<global_geometry_list.num_elements;loop_index++) {
        // Add mask list
        if (1 == manual_linking_function(global_geometry_list.elements[loop_index].name,mask_string)) {
            add_element_to_int_list(&this_box_volume.geometry.mask_list,global_geometry_list.elements[loop_index].component_index);
            add_element_to_int_list(&global_geometry_list.elements[loop_index].Volume->geometry.masked_by_list,INDEX_CURRENT_COMP);
            global_geometry_list.elements[loop_index].Volume->geometry.is_masked_volume = 1;
            if (this_box_volume.geometry.mask_mode == 2)
                global_geometry_list.elements[loop_index].Volume->geometry.mask_mode = 2;
            if (this_box_volume.geometry.mask_mode == 1) {
                if (global_geometry_list.elements[loop_index].Volume->geometry.is_masked_volume == 1 && global_geometry_list.elements[loop_index].Volume->geometry.mask_mode != 2)
                    // If more than one mask is added to one volume, the ANY mode overwrites the (default) ALL mode.
                    global_geometry_list.elements[loop_index].Volume->geometry.mask_mode = 1;
            }
            
            found_geometries = 1;
        }
    }
    if (found_geometries == 0) {
        printf("The mask_string in geometry: %s did not find any of the specified volumes in the mask_string %s \n",NAME_CURRENT_COMP,mask_string);
        exit(1);
    }
    this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
    this_box_volume.p_physics->is_vacuum = 0; // Makes this volume a vacuum
    this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
    this_box_volume.p_physics->my_a = 0; // Should not be used.
    sprintf(this_box_volume.p_physics->name,"Mask");
    this_box_volume.geometry.is_mask_volume = 1;
    
    
// Read the material input, or if it lacks, use automatic linking.
} else if (material_string && strlen(material_string) && strcmp(material_string, "NULL") && strcmp(material_string, "0")) {
    // A geometry string was given, use it to determine which material
    if (0 == strcmp(material_string,"vacuum") || 0 == strcmp(material_string,"Vacuum")) {
        // One could have a global physics struct for vacuum instead of creating one for each
        this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
        this_box_volume.p_physics->is_vacuum = 1; // Makes this volume a vacuum
        this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
        this_box_volume.p_physics->my_a = 0; // Should not be used.
        sprintf(this_box_volume.p_physics->name,"Vacuum");
    } else if (0 == strcmp(material_string,"exit") || 0 == strcmp(material_string,"Exit")) {
        // One could have a global physics struct for vacuum instead of creating one for each
        this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
        this_box_volume.p_physics->is_vacuum = 1; // Makes this volume a vacuum
        this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
        this_box_volume.p_physics->my_a = 0; // Should not be used.
        this_box_volume.geometry.is_exit_volume = 1;
        sprintf(this_box_volume.p_physics->name,"Exit");
    } else {
        #ifndef MATERIAL_DETECTOR
            printf("Need to define a material before refering to it in a geometry %s.\n",NAME_CURRENT_COMP);
            exit(1);
        #endif
        for (loop_index=0;loop_index<global_material_list.num_elements;loop_index++) {
            if (0 == strcmp(material_string,global_material_list.elements[loop_index].name)) {
                this_box_volume.p_physics = global_material_list.elements[loop_index].physics;
                break;
            }
            if (loop_index == global_material_list.num_elements-1) {
            printf("\n");
            printf("ERROR: The material string \"%s\" in Union geometry \"%s\" did not match a specified material. \n",material_string,NAME_CURRENT_COMP);
            printf("       The materials available at this point (need to be defined before the geometry): \n");
            for (loop_index=0;loop_index<global_material_list.num_elements;loop_index++)
              printf("         %s\n",global_material_list.elements[loop_index].name);
            printf("\n");
            printf("       It is also possible to use one of the defualt materials avaiable: \n");
            printf("           Vacuum (for a Volume without scattering or absorption)\n");
            printf("           Exit (for a Volume where the ray exits the component if it enters)\n");
            printf("           Mask (for a Volume that masks existing volumes specified in the mask_string\n");
            exit(1);
          }
        }
    }
} else {
    // Automatic linking, simply using the last defined material.
    #ifndef MATERIAL_DETECTOR
        printf("Need to define a material before the geometry to use automatic linking %s.\n",NAME_CURRENT_COMP);
        exit(1);
    #endif
    this_box_volume.p_physics = global_material_list.elements[global_material_list.num_elements-1].physics;
}

sprintf(this_box_volume.name,NAME_CURRENT_COMP);
sprintf(this_box_volume.geometry.shape,"box");
this_box_volume.geometry.priority_value = priority;
this_box_volume.geometry.geometry_p_interact = p_interact;
// Currently the coordinates will be in absolute space.
this_box_volume.geometry.center = POS_A_CURRENT_COMP;

this_box_storage.z_depth = zdepth;
this_box_storage.x_width1 = xwidth;
this_box_storage.y_height1 = yheight;

this_box_storage.is_rectangle = 0;
if (xwidth2 < 0 && yheight2 < 0) this_box_storage.is_rectangle = 1;
if (xwidth == xwidth2 && yheight == yheight2) this_box_storage.is_rectangle = 1;

if (xwidth2 < 0) {
    this_box_storage.x_width2 = xwidth;
    xwidth2 = xwidth;
} else this_box_storage.x_width2 = xwidth2;

if (yheight2 < 0) {
    this_box_storage.y_height2 = yheight;
    yheight2 = yheight;
} else this_box_storage.y_height2 = yheight2;


this_box_storage.normal_vectors[0] = coords_set(0,0,1);
this_box_storage.normal_vectors[1] = coords_set(0,0,1);

// for sides with y component = 0
x_component = 2*zdepth/sqrt((xwidth-xwidth2)*(xwidth-xwidth2)+4*zdepth*zdepth);
z_component = (xwidth-xwidth2)/sqrt(4*zdepth*zdepth+(xwidth-xwidth2)*(xwidth-xwidth2));

this_box_storage.normal_vectors[2] = coords_set(x_component,0,z_component);
this_box_storage.normal_vectors[3] = coords_set(-x_component,0,z_component);

// for sides with x component = 0
y_component = 2*zdepth/sqrt((yheight-yheight2)*(yheight-yheight2)+4*zdepth*zdepth);
z_component = (yheight-yheight2)/sqrt(4*zdepth*zdepth+(yheight-yheight2)*(yheight-yheight2));

this_box_storage.normal_vectors[4] = coords_set(0,y_component,z_component);
this_box_storage.normal_vectors[5] = coords_set(0,-y_component,z_component);

this_box_volume.geometry.visualization_on = visualize;

this_box_volume.geometry.geometry_parameters.p_box_storage = &this_box_storage;

// Assign pointers to functions for intersection with the shape, checking if a point is inside the shape
if (this_box_storage.is_rectangle == 1) {
this_box_volume.geometry.intersect_function = &sample_box_intersect_simple;
this_box_volume.geometry.within_function = &r_within_box_simple;
}
else {
this_box_volume.geometry.intersect_function = &sample_box_intersect_advanced;
this_box_volume.geometry.within_function = &r_within_box_advanced;
}

this_box_volume.geometry.shell_points = &box_shell_points;
this_box_volume.geometry.mcdisplay_function = &mcdisplay_box_function;
this_box_volume.geometry.initialize_from_main_function = &initialize_box_geometry_from_main_component;
this_box_volume.geometry.process_rot_allocated = 0;

this_box_volume.geometry.copy_geometry_parameters = &allocate_box_storage_copy;

rot_copy(this_box_volume.geometry.rotation_matrix,ROT_A_CURRENT_COMP); //check how ROT_R_CURRENT_COMP would work
rot_transpose(ROT_A_CURRENT_COMP,this_box_volume.geometry.transpose_rotation_matrix);

// Initialize loggers
this_box_volume.loggers.num_elements = 0;

// packing the information into the global_geometry_element, which is then included in the global_geometry_list.
sprintf(global_geometry_element.name,NAME_CURRENT_COMP);
global_geometry_element.activation_counter = number_of_activations;
global_geometry_element.component_index = INDEX_CURRENT_COMP;
global_geometry_element.Volume = &this_box_volume; // Would be nicer if this m was a pointer, now we have the (small) data two places
add_element_to_geometry_list(&global_geometry_list,global_geometry_element);
}
#line 274751 "MACS_sample_kidney_box.c"
#undef number_of_activations
#undef mask_setting
#undef mask_string
#undef p_interact
#undef focus_r
#undef focus_xh
#undef focus_xw
#undef focus_ah
#undef focus_aw
#undef target_z
#undef target_y
#undef target_x
#undef target_index
#undef visualize
#undef yheight2
#undef xwidth2
#undef zdepth
#undef yheight
#undef xwidth
#undef priority
#undef material_string
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

  /* Initializations for component channel_12_analyzer_2_array_crystal_array_4. */
  SIG_MESSAGE("channel_12_analyzer_2_array_crystal_array_4 (Init)");
#define mccompcurname  channel_12_analyzer_2_array_crystal_array_4
#define mccompcurtype  Union_box
#define mccompcurindex 601
#define loop_index mccchannel_12_analyzer_2_array_crystal_array_4_loop_index
#define this_box_volume mccchannel_12_analyzer_2_array_crystal_array_4_this_box_volume
#define global_geometry_element mccchannel_12_analyzer_2_array_crystal_array_4_global_geometry_element
#define this_box_storage mccchannel_12_analyzer_2_array_crystal_array_4_this_box_storage
#define material_string mccchannel_12_analyzer_2_array_crystal_array_4_material_string
#define priority mccchannel_12_analyzer_2_array_crystal_array_4_priority
#define xwidth mccchannel_12_analyzer_2_array_crystal_array_4_xwidth
#define yheight mccchannel_12_analyzer_2_array_crystal_array_4_yheight
#define zdepth mccchannel_12_analyzer_2_array_crystal_array_4_zdepth
#define xwidth2 mccchannel_12_analyzer_2_array_crystal_array_4_xwidth2
#define yheight2 mccchannel_12_analyzer_2_array_crystal_array_4_yheight2
#define visualize mccchannel_12_analyzer_2_array_crystal_array_4_visualize
#define target_index mccchannel_12_analyzer_2_array_crystal_array_4_target_index
#define target_x mccchannel_12_analyzer_2_array_crystal_array_4_target_x
#define target_y mccchannel_12_analyzer_2_array_crystal_array_4_target_y
#define target_z mccchannel_12_analyzer_2_array_crystal_array_4_target_z
#define focus_aw mccchannel_12_analyzer_2_array_crystal_array_4_focus_aw
#define focus_ah mccchannel_12_analyzer_2_array_crystal_array_4_focus_ah
#define focus_xw mccchannel_12_analyzer_2_array_crystal_array_4_focus_xw
#define focus_xh mccchannel_12_analyzer_2_array_crystal_array_4_focus_xh
#define focus_r mccchannel_12_analyzer_2_array_crystal_array_4_focus_r
#define p_interact mccchannel_12_analyzer_2_array_crystal_array_4_p_interact
#define mask_string mccchannel_12_analyzer_2_array_crystal_array_4_mask_string
#define mask_setting mccchannel_12_analyzer_2_array_crystal_array_4_mask_setting
#define number_of_activations mccchannel_12_analyzer_2_array_crystal_array_4_number_of_activations
#line 224 "Union_box.comp"
{
// Initializes the focusing system for this volume including input sanitation.
focus_initialize(&this_box_volume.geometry, POS_A_COMP_INDEX(INDEX_CURRENT_COMP+target_index), POS_A_CURRENT_COMP, ROT_A_CURRENT_COMP, target_index, target_x, target_y, target_z, focus_aw, focus_ah, focus_xw, focus_xh, focus_r, NAME_CURRENT_COMP);

// Input sanitation for this geometry
if (xwidth <= 0) {
  printf("\nERROR in Union_box named %s, the xwidth is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (yheight <= 0) {
  printf("\nERROR in Union_box named %s, yheight is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (zdepth <= 0) {
  printf("\nERROR in Union_box named %s, zdepth is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (xwidth2 <= 0 && xwidth2 != -1) {
  printf("\nERROR in Union_box named %s, the xwidth2 is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (yheight2 <= 0 && yheight2 != -1) {
  printf("\nERROR in Union_box named %s, yheight2 is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}

// Use sanitation
if (global_material_list.num_elements == 0) {
  printf("\nERROR: Need to define a material using Union_make_material before using a Union geometry component. \n");
  printf("       %s was defined before first use of Union_make_material.\n",NAME_CURRENT_COMP);
  exit(1);
}

this_box_volume.geometry.is_masked_volume = 0;
this_box_volume.geometry.is_exit_volume = 0;
this_box_volume.geometry.is_mask_volume = 0;
// check if the volume is a mask, if it is the material string is irelevant.
if (mask_string && strlen(mask_string) && strcmp(mask_string, "NULL") && strcmp(mask_string, "0")) {
    // A mask volume is used to limit the extend of other volumes, called the masked volumes. These are specified in the mask_string.
    // In order for a ray to enter a masked volume, it needs to be both in the region covered by that volume AND the mask volume.
    // When more than
    this_box_volume.geometry.mask_mode = 1; // Default is mask mode is ALL
    if (mask_setting && strlen(mask_setting) && strcmp(mask_setting, "NULL") && strcmp(mask_setting, "0")) {
        if (strcmp(mask_setting,"ALL") == 0 || strcmp(mask_setting,"All") == 0) this_box_volume.geometry.mask_mode = 1;
        else if (strcmp(mask_setting,"ANY") == 0 || strcmp(mask_setting,"Any") == 0) this_box_volume.geometry.mask_mode = 2;
        else {
            printf("The mask_mode of component %s is set to %s, but must be either ALL or ANY.\n",NAME_CURRENT_COMP,mask_setting);
            exit(1);
        }
    }
    
    for (loop_index=0;loop_index<global_geometry_list.num_elements;loop_index++) {
        // Add mask list
        if (1 == manual_linking_function(global_geometry_list.elements[loop_index].name,mask_string)) {
            add_element_to_int_list(&this_box_volume.geometry.mask_list,global_geometry_list.elements[loop_index].component_index);
            add_element_to_int_list(&global_geometry_list.elements[loop_index].Volume->geometry.masked_by_list,INDEX_CURRENT_COMP);
            global_geometry_list.elements[loop_index].Volume->geometry.is_masked_volume = 1;
            if (this_box_volume.geometry.mask_mode == 2)
                global_geometry_list.elements[loop_index].Volume->geometry.mask_mode = 2;
            if (this_box_volume.geometry.mask_mode == 1) {
                if (global_geometry_list.elements[loop_index].Volume->geometry.is_masked_volume == 1 && global_geometry_list.elements[loop_index].Volume->geometry.mask_mode != 2)
                    // If more than one mask is added to one volume, the ANY mode overwrites the (default) ALL mode.
                    global_geometry_list.elements[loop_index].Volume->geometry.mask_mode = 1;
            }
            
            found_geometries = 1;
        }
    }
    if (found_geometries == 0) {
        printf("The mask_string in geometry: %s did not find any of the specified volumes in the mask_string %s \n",NAME_CURRENT_COMP,mask_string);
        exit(1);
    }
    this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
    this_box_volume.p_physics->is_vacuum = 0; // Makes this volume a vacuum
    this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
    this_box_volume.p_physics->my_a = 0; // Should not be used.
    sprintf(this_box_volume.p_physics->name,"Mask");
    this_box_volume.geometry.is_mask_volume = 1;
    
    
// Read the material input, or if it lacks, use automatic linking.
} else if (material_string && strlen(material_string) && strcmp(material_string, "NULL") && strcmp(material_string, "0")) {
    // A geometry string was given, use it to determine which material
    if (0 == strcmp(material_string,"vacuum") || 0 == strcmp(material_string,"Vacuum")) {
        // One could have a global physics struct for vacuum instead of creating one for each
        this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
        this_box_volume.p_physics->is_vacuum = 1; // Makes this volume a vacuum
        this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
        this_box_volume.p_physics->my_a = 0; // Should not be used.
        sprintf(this_box_volume.p_physics->name,"Vacuum");
    } else if (0 == strcmp(material_string,"exit") || 0 == strcmp(material_string,"Exit")) {
        // One could have a global physics struct for vacuum instead of creating one for each
        this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
        this_box_volume.p_physics->is_vacuum = 1; // Makes this volume a vacuum
        this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
        this_box_volume.p_physics->my_a = 0; // Should not be used.
        this_box_volume.geometry.is_exit_volume = 1;
        sprintf(this_box_volume.p_physics->name,"Exit");
    } else {
        #ifndef MATERIAL_DETECTOR
            printf("Need to define a material before refering to it in a geometry %s.\n",NAME_CURRENT_COMP);
            exit(1);
        #endif
        for (loop_index=0;loop_index<global_material_list.num_elements;loop_index++) {
            if (0 == strcmp(material_string,global_material_list.elements[loop_index].name)) {
                this_box_volume.p_physics = global_material_list.elements[loop_index].physics;
                break;
            }
            if (loop_index == global_material_list.num_elements-1) {
            printf("\n");
            printf("ERROR: The material string \"%s\" in Union geometry \"%s\" did not match a specified material. \n",material_string,NAME_CURRENT_COMP);
            printf("       The materials available at this point (need to be defined before the geometry): \n");
            for (loop_index=0;loop_index<global_material_list.num_elements;loop_index++)
              printf("         %s\n",global_material_list.elements[loop_index].name);
            printf("\n");
            printf("       It is also possible to use one of the defualt materials avaiable: \n");
            printf("           Vacuum (for a Volume without scattering or absorption)\n");
            printf("           Exit (for a Volume where the ray exits the component if it enters)\n");
            printf("           Mask (for a Volume that masks existing volumes specified in the mask_string\n");
            exit(1);
          }
        }
    }
} else {
    // Automatic linking, simply using the last defined material.
    #ifndef MATERIAL_DETECTOR
        printf("Need to define a material before the geometry to use automatic linking %s.\n",NAME_CURRENT_COMP);
        exit(1);
    #endif
    this_box_volume.p_physics = global_material_list.elements[global_material_list.num_elements-1].physics;
}

sprintf(this_box_volume.name,NAME_CURRENT_COMP);
sprintf(this_box_volume.geometry.shape,"box");
this_box_volume.geometry.priority_value = priority;
this_box_volume.geometry.geometry_p_interact = p_interact;
// Currently the coordinates will be in absolute space.
this_box_volume.geometry.center = POS_A_CURRENT_COMP;

this_box_storage.z_depth = zdepth;
this_box_storage.x_width1 = xwidth;
this_box_storage.y_height1 = yheight;

this_box_storage.is_rectangle = 0;
if (xwidth2 < 0 && yheight2 < 0) this_box_storage.is_rectangle = 1;
if (xwidth == xwidth2 && yheight == yheight2) this_box_storage.is_rectangle = 1;

if (xwidth2 < 0) {
    this_box_storage.x_width2 = xwidth;
    xwidth2 = xwidth;
} else this_box_storage.x_width2 = xwidth2;

if (yheight2 < 0) {
    this_box_storage.y_height2 = yheight;
    yheight2 = yheight;
} else this_box_storage.y_height2 = yheight2;


this_box_storage.normal_vectors[0] = coords_set(0,0,1);
this_box_storage.normal_vectors[1] = coords_set(0,0,1);

// for sides with y component = 0
x_component = 2*zdepth/sqrt((xwidth-xwidth2)*(xwidth-xwidth2)+4*zdepth*zdepth);
z_component = (xwidth-xwidth2)/sqrt(4*zdepth*zdepth+(xwidth-xwidth2)*(xwidth-xwidth2));

this_box_storage.normal_vectors[2] = coords_set(x_component,0,z_component);
this_box_storage.normal_vectors[3] = coords_set(-x_component,0,z_component);

// for sides with x component = 0
y_component = 2*zdepth/sqrt((yheight-yheight2)*(yheight-yheight2)+4*zdepth*zdepth);
z_component = (yheight-yheight2)/sqrt(4*zdepth*zdepth+(yheight-yheight2)*(yheight-yheight2));

this_box_storage.normal_vectors[4] = coords_set(0,y_component,z_component);
this_box_storage.normal_vectors[5] = coords_set(0,-y_component,z_component);

this_box_volume.geometry.visualization_on = visualize;

this_box_volume.geometry.geometry_parameters.p_box_storage = &this_box_storage;

// Assign pointers to functions for intersection with the shape, checking if a point is inside the shape
if (this_box_storage.is_rectangle == 1) {
this_box_volume.geometry.intersect_function = &sample_box_intersect_simple;
this_box_volume.geometry.within_function = &r_within_box_simple;
}
else {
this_box_volume.geometry.intersect_function = &sample_box_intersect_advanced;
this_box_volume.geometry.within_function = &r_within_box_advanced;
}

this_box_volume.geometry.shell_points = &box_shell_points;
this_box_volume.geometry.mcdisplay_function = &mcdisplay_box_function;
this_box_volume.geometry.initialize_from_main_function = &initialize_box_geometry_from_main_component;
this_box_volume.geometry.process_rot_allocated = 0;

this_box_volume.geometry.copy_geometry_parameters = &allocate_box_storage_copy;

rot_copy(this_box_volume.geometry.rotation_matrix,ROT_A_CURRENT_COMP); //check how ROT_R_CURRENT_COMP would work
rot_transpose(ROT_A_CURRENT_COMP,this_box_volume.geometry.transpose_rotation_matrix);

// Initialize loggers
this_box_volume.loggers.num_elements = 0;

// packing the information into the global_geometry_element, which is then included in the global_geometry_list.
sprintf(global_geometry_element.name,NAME_CURRENT_COMP);
global_geometry_element.activation_counter = number_of_activations;
global_geometry_element.component_index = INDEX_CURRENT_COMP;
global_geometry_element.Volume = &this_box_volume; // Would be nicer if this m was a pointer, now we have the (small) data two places
add_element_to_geometry_list(&global_geometry_list,global_geometry_element);
}
#line 275021 "MACS_sample_kidney_box.c"
#undef number_of_activations
#undef mask_setting
#undef mask_string
#undef p_interact
#undef focus_r
#undef focus_xh
#undef focus_xw
#undef focus_ah
#undef focus_aw
#undef target_z
#undef target_y
#undef target_x
#undef target_index
#undef visualize
#undef yheight2
#undef xwidth2
#undef zdepth
#undef yheight
#undef xwidth
#undef priority
#undef material_string
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

  /* Initializations for component channel_12_analyzer_2_array_crystal_array_5. */
  SIG_MESSAGE("channel_12_analyzer_2_array_crystal_array_5 (Init)");
#define mccompcurname  channel_12_analyzer_2_array_crystal_array_5
#define mccompcurtype  Union_box
#define mccompcurindex 602
#define loop_index mccchannel_12_analyzer_2_array_crystal_array_5_loop_index
#define this_box_volume mccchannel_12_analyzer_2_array_crystal_array_5_this_box_volume
#define global_geometry_element mccchannel_12_analyzer_2_array_crystal_array_5_global_geometry_element
#define this_box_storage mccchannel_12_analyzer_2_array_crystal_array_5_this_box_storage
#define material_string mccchannel_12_analyzer_2_array_crystal_array_5_material_string
#define priority mccchannel_12_analyzer_2_array_crystal_array_5_priority
#define xwidth mccchannel_12_analyzer_2_array_crystal_array_5_xwidth
#define yheight mccchannel_12_analyzer_2_array_crystal_array_5_yheight
#define zdepth mccchannel_12_analyzer_2_array_crystal_array_5_zdepth
#define xwidth2 mccchannel_12_analyzer_2_array_crystal_array_5_xwidth2
#define yheight2 mccchannel_12_analyzer_2_array_crystal_array_5_yheight2
#define visualize mccchannel_12_analyzer_2_array_crystal_array_5_visualize
#define target_index mccchannel_12_analyzer_2_array_crystal_array_5_target_index
#define target_x mccchannel_12_analyzer_2_array_crystal_array_5_target_x
#define target_y mccchannel_12_analyzer_2_array_crystal_array_5_target_y
#define target_z mccchannel_12_analyzer_2_array_crystal_array_5_target_z
#define focus_aw mccchannel_12_analyzer_2_array_crystal_array_5_focus_aw
#define focus_ah mccchannel_12_analyzer_2_array_crystal_array_5_focus_ah
#define focus_xw mccchannel_12_analyzer_2_array_crystal_array_5_focus_xw
#define focus_xh mccchannel_12_analyzer_2_array_crystal_array_5_focus_xh
#define focus_r mccchannel_12_analyzer_2_array_crystal_array_5_focus_r
#define p_interact mccchannel_12_analyzer_2_array_crystal_array_5_p_interact
#define mask_string mccchannel_12_analyzer_2_array_crystal_array_5_mask_string
#define mask_setting mccchannel_12_analyzer_2_array_crystal_array_5_mask_setting
#define number_of_activations mccchannel_12_analyzer_2_array_crystal_array_5_number_of_activations
#line 224 "Union_box.comp"
{
// Initializes the focusing system for this volume including input sanitation.
focus_initialize(&this_box_volume.geometry, POS_A_COMP_INDEX(INDEX_CURRENT_COMP+target_index), POS_A_CURRENT_COMP, ROT_A_CURRENT_COMP, target_index, target_x, target_y, target_z, focus_aw, focus_ah, focus_xw, focus_xh, focus_r, NAME_CURRENT_COMP);

// Input sanitation for this geometry
if (xwidth <= 0) {
  printf("\nERROR in Union_box named %s, the xwidth is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (yheight <= 0) {
  printf("\nERROR in Union_box named %s, yheight is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (zdepth <= 0) {
  printf("\nERROR in Union_box named %s, zdepth is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (xwidth2 <= 0 && xwidth2 != -1) {
  printf("\nERROR in Union_box named %s, the xwidth2 is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (yheight2 <= 0 && yheight2 != -1) {
  printf("\nERROR in Union_box named %s, yheight2 is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}

// Use sanitation
if (global_material_list.num_elements == 0) {
  printf("\nERROR: Need to define a material using Union_make_material before using a Union geometry component. \n");
  printf("       %s was defined before first use of Union_make_material.\n",NAME_CURRENT_COMP);
  exit(1);
}

this_box_volume.geometry.is_masked_volume = 0;
this_box_volume.geometry.is_exit_volume = 0;
this_box_volume.geometry.is_mask_volume = 0;
// check if the volume is a mask, if it is the material string is irelevant.
if (mask_string && strlen(mask_string) && strcmp(mask_string, "NULL") && strcmp(mask_string, "0")) {
    // A mask volume is used to limit the extend of other volumes, called the masked volumes. These are specified in the mask_string.
    // In order for a ray to enter a masked volume, it needs to be both in the region covered by that volume AND the mask volume.
    // When more than
    this_box_volume.geometry.mask_mode = 1; // Default is mask mode is ALL
    if (mask_setting && strlen(mask_setting) && strcmp(mask_setting, "NULL") && strcmp(mask_setting, "0")) {
        if (strcmp(mask_setting,"ALL") == 0 || strcmp(mask_setting,"All") == 0) this_box_volume.geometry.mask_mode = 1;
        else if (strcmp(mask_setting,"ANY") == 0 || strcmp(mask_setting,"Any") == 0) this_box_volume.geometry.mask_mode = 2;
        else {
            printf("The mask_mode of component %s is set to %s, but must be either ALL or ANY.\n",NAME_CURRENT_COMP,mask_setting);
            exit(1);
        }
    }
    
    for (loop_index=0;loop_index<global_geometry_list.num_elements;loop_index++) {
        // Add mask list
        if (1 == manual_linking_function(global_geometry_list.elements[loop_index].name,mask_string)) {
            add_element_to_int_list(&this_box_volume.geometry.mask_list,global_geometry_list.elements[loop_index].component_index);
            add_element_to_int_list(&global_geometry_list.elements[loop_index].Volume->geometry.masked_by_list,INDEX_CURRENT_COMP);
            global_geometry_list.elements[loop_index].Volume->geometry.is_masked_volume = 1;
            if (this_box_volume.geometry.mask_mode == 2)
                global_geometry_list.elements[loop_index].Volume->geometry.mask_mode = 2;
            if (this_box_volume.geometry.mask_mode == 1) {
                if (global_geometry_list.elements[loop_index].Volume->geometry.is_masked_volume == 1 && global_geometry_list.elements[loop_index].Volume->geometry.mask_mode != 2)
                    // If more than one mask is added to one volume, the ANY mode overwrites the (default) ALL mode.
                    global_geometry_list.elements[loop_index].Volume->geometry.mask_mode = 1;
            }
            
            found_geometries = 1;
        }
    }
    if (found_geometries == 0) {
        printf("The mask_string in geometry: %s did not find any of the specified volumes in the mask_string %s \n",NAME_CURRENT_COMP,mask_string);
        exit(1);
    }
    this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
    this_box_volume.p_physics->is_vacuum = 0; // Makes this volume a vacuum
    this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
    this_box_volume.p_physics->my_a = 0; // Should not be used.
    sprintf(this_box_volume.p_physics->name,"Mask");
    this_box_volume.geometry.is_mask_volume = 1;
    
    
// Read the material input, or if it lacks, use automatic linking.
} else if (material_string && strlen(material_string) && strcmp(material_string, "NULL") && strcmp(material_string, "0")) {
    // A geometry string was given, use it to determine which material
    if (0 == strcmp(material_string,"vacuum") || 0 == strcmp(material_string,"Vacuum")) {
        // One could have a global physics struct for vacuum instead of creating one for each
        this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
        this_box_volume.p_physics->is_vacuum = 1; // Makes this volume a vacuum
        this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
        this_box_volume.p_physics->my_a = 0; // Should not be used.
        sprintf(this_box_volume.p_physics->name,"Vacuum");
    } else if (0 == strcmp(material_string,"exit") || 0 == strcmp(material_string,"Exit")) {
        // One could have a global physics struct for vacuum instead of creating one for each
        this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
        this_box_volume.p_physics->is_vacuum = 1; // Makes this volume a vacuum
        this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
        this_box_volume.p_physics->my_a = 0; // Should not be used.
        this_box_volume.geometry.is_exit_volume = 1;
        sprintf(this_box_volume.p_physics->name,"Exit");
    } else {
        #ifndef MATERIAL_DETECTOR
            printf("Need to define a material before refering to it in a geometry %s.\n",NAME_CURRENT_COMP);
            exit(1);
        #endif
        for (loop_index=0;loop_index<global_material_list.num_elements;loop_index++) {
            if (0 == strcmp(material_string,global_material_list.elements[loop_index].name)) {
                this_box_volume.p_physics = global_material_list.elements[loop_index].physics;
                break;
            }
            if (loop_index == global_material_list.num_elements-1) {
            printf("\n");
            printf("ERROR: The material string \"%s\" in Union geometry \"%s\" did not match a specified material. \n",material_string,NAME_CURRENT_COMP);
            printf("       The materials available at this point (need to be defined before the geometry): \n");
            for (loop_index=0;loop_index<global_material_list.num_elements;loop_index++)
              printf("         %s\n",global_material_list.elements[loop_index].name);
            printf("\n");
            printf("       It is also possible to use one of the defualt materials avaiable: \n");
            printf("           Vacuum (for a Volume without scattering or absorption)\n");
            printf("           Exit (for a Volume where the ray exits the component if it enters)\n");
            printf("           Mask (for a Volume that masks existing volumes specified in the mask_string\n");
            exit(1);
          }
        }
    }
} else {
    // Automatic linking, simply using the last defined material.
    #ifndef MATERIAL_DETECTOR
        printf("Need to define a material before the geometry to use automatic linking %s.\n",NAME_CURRENT_COMP);
        exit(1);
    #endif
    this_box_volume.p_physics = global_material_list.elements[global_material_list.num_elements-1].physics;
}

sprintf(this_box_volume.name,NAME_CURRENT_COMP);
sprintf(this_box_volume.geometry.shape,"box");
this_box_volume.geometry.priority_value = priority;
this_box_volume.geometry.geometry_p_interact = p_interact;
// Currently the coordinates will be in absolute space.
this_box_volume.geometry.center = POS_A_CURRENT_COMP;

this_box_storage.z_depth = zdepth;
this_box_storage.x_width1 = xwidth;
this_box_storage.y_height1 = yheight;

this_box_storage.is_rectangle = 0;
if (xwidth2 < 0 && yheight2 < 0) this_box_storage.is_rectangle = 1;
if (xwidth == xwidth2 && yheight == yheight2) this_box_storage.is_rectangle = 1;

if (xwidth2 < 0) {
    this_box_storage.x_width2 = xwidth;
    xwidth2 = xwidth;
} else this_box_storage.x_width2 = xwidth2;

if (yheight2 < 0) {
    this_box_storage.y_height2 = yheight;
    yheight2 = yheight;
} else this_box_storage.y_height2 = yheight2;


this_box_storage.normal_vectors[0] = coords_set(0,0,1);
this_box_storage.normal_vectors[1] = coords_set(0,0,1);

// for sides with y component = 0
x_component = 2*zdepth/sqrt((xwidth-xwidth2)*(xwidth-xwidth2)+4*zdepth*zdepth);
z_component = (xwidth-xwidth2)/sqrt(4*zdepth*zdepth+(xwidth-xwidth2)*(xwidth-xwidth2));

this_box_storage.normal_vectors[2] = coords_set(x_component,0,z_component);
this_box_storage.normal_vectors[3] = coords_set(-x_component,0,z_component);

// for sides with x component = 0
y_component = 2*zdepth/sqrt((yheight-yheight2)*(yheight-yheight2)+4*zdepth*zdepth);
z_component = (yheight-yheight2)/sqrt(4*zdepth*zdepth+(yheight-yheight2)*(yheight-yheight2));

this_box_storage.normal_vectors[4] = coords_set(0,y_component,z_component);
this_box_storage.normal_vectors[5] = coords_set(0,-y_component,z_component);

this_box_volume.geometry.visualization_on = visualize;

this_box_volume.geometry.geometry_parameters.p_box_storage = &this_box_storage;

// Assign pointers to functions for intersection with the shape, checking if a point is inside the shape
if (this_box_storage.is_rectangle == 1) {
this_box_volume.geometry.intersect_function = &sample_box_intersect_simple;
this_box_volume.geometry.within_function = &r_within_box_simple;
}
else {
this_box_volume.geometry.intersect_function = &sample_box_intersect_advanced;
this_box_volume.geometry.within_function = &r_within_box_advanced;
}

this_box_volume.geometry.shell_points = &box_shell_points;
this_box_volume.geometry.mcdisplay_function = &mcdisplay_box_function;
this_box_volume.geometry.initialize_from_main_function = &initialize_box_geometry_from_main_component;
this_box_volume.geometry.process_rot_allocated = 0;

this_box_volume.geometry.copy_geometry_parameters = &allocate_box_storage_copy;

rot_copy(this_box_volume.geometry.rotation_matrix,ROT_A_CURRENT_COMP); //check how ROT_R_CURRENT_COMP would work
rot_transpose(ROT_A_CURRENT_COMP,this_box_volume.geometry.transpose_rotation_matrix);

// Initialize loggers
this_box_volume.loggers.num_elements = 0;

// packing the information into the global_geometry_element, which is then included in the global_geometry_list.
sprintf(global_geometry_element.name,NAME_CURRENT_COMP);
global_geometry_element.activation_counter = number_of_activations;
global_geometry_element.component_index = INDEX_CURRENT_COMP;
global_geometry_element.Volume = &this_box_volume; // Would be nicer if this m was a pointer, now we have the (small) data two places
add_element_to_geometry_list(&global_geometry_list,global_geometry_element);
}
#line 275291 "MACS_sample_kidney_box.c"
#undef number_of_activations
#undef mask_setting
#undef mask_string
#undef p_interact
#undef focus_r
#undef focus_xh
#undef focus_xw
#undef focus_ah
#undef focus_aw
#undef target_z
#undef target_y
#undef target_x
#undef target_index
#undef visualize
#undef yheight2
#undef xwidth2
#undef zdepth
#undef yheight
#undef xwidth
#undef priority
#undef material_string
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

  /* Initializations for component channel_12_analyzer_2_array_crystal_array_6. */
  SIG_MESSAGE("channel_12_analyzer_2_array_crystal_array_6 (Init)");
#define mccompcurname  channel_12_analyzer_2_array_crystal_array_6
#define mccompcurtype  Union_box
#define mccompcurindex 603
#define loop_index mccchannel_12_analyzer_2_array_crystal_array_6_loop_index
#define this_box_volume mccchannel_12_analyzer_2_array_crystal_array_6_this_box_volume
#define global_geometry_element mccchannel_12_analyzer_2_array_crystal_array_6_global_geometry_element
#define this_box_storage mccchannel_12_analyzer_2_array_crystal_array_6_this_box_storage
#define material_string mccchannel_12_analyzer_2_array_crystal_array_6_material_string
#define priority mccchannel_12_analyzer_2_array_crystal_array_6_priority
#define xwidth mccchannel_12_analyzer_2_array_crystal_array_6_xwidth
#define yheight mccchannel_12_analyzer_2_array_crystal_array_6_yheight
#define zdepth mccchannel_12_analyzer_2_array_crystal_array_6_zdepth
#define xwidth2 mccchannel_12_analyzer_2_array_crystal_array_6_xwidth2
#define yheight2 mccchannel_12_analyzer_2_array_crystal_array_6_yheight2
#define visualize mccchannel_12_analyzer_2_array_crystal_array_6_visualize
#define target_index mccchannel_12_analyzer_2_array_crystal_array_6_target_index
#define target_x mccchannel_12_analyzer_2_array_crystal_array_6_target_x
#define target_y mccchannel_12_analyzer_2_array_crystal_array_6_target_y
#define target_z mccchannel_12_analyzer_2_array_crystal_array_6_target_z
#define focus_aw mccchannel_12_analyzer_2_array_crystal_array_6_focus_aw
#define focus_ah mccchannel_12_analyzer_2_array_crystal_array_6_focus_ah
#define focus_xw mccchannel_12_analyzer_2_array_crystal_array_6_focus_xw
#define focus_xh mccchannel_12_analyzer_2_array_crystal_array_6_focus_xh
#define focus_r mccchannel_12_analyzer_2_array_crystal_array_6_focus_r
#define p_interact mccchannel_12_analyzer_2_array_crystal_array_6_p_interact
#define mask_string mccchannel_12_analyzer_2_array_crystal_array_6_mask_string
#define mask_setting mccchannel_12_analyzer_2_array_crystal_array_6_mask_setting
#define number_of_activations mccchannel_12_analyzer_2_array_crystal_array_6_number_of_activations
#line 224 "Union_box.comp"
{
// Initializes the focusing system for this volume including input sanitation.
focus_initialize(&this_box_volume.geometry, POS_A_COMP_INDEX(INDEX_CURRENT_COMP+target_index), POS_A_CURRENT_COMP, ROT_A_CURRENT_COMP, target_index, target_x, target_y, target_z, focus_aw, focus_ah, focus_xw, focus_xh, focus_r, NAME_CURRENT_COMP);

// Input sanitation for this geometry
if (xwidth <= 0) {
  printf("\nERROR in Union_box named %s, the xwidth is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (yheight <= 0) {
  printf("\nERROR in Union_box named %s, yheight is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (zdepth <= 0) {
  printf("\nERROR in Union_box named %s, zdepth is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (xwidth2 <= 0 && xwidth2 != -1) {
  printf("\nERROR in Union_box named %s, the xwidth2 is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (yheight2 <= 0 && yheight2 != -1) {
  printf("\nERROR in Union_box named %s, yheight2 is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}

// Use sanitation
if (global_material_list.num_elements == 0) {
  printf("\nERROR: Need to define a material using Union_make_material before using a Union geometry component. \n");
  printf("       %s was defined before first use of Union_make_material.\n",NAME_CURRENT_COMP);
  exit(1);
}

this_box_volume.geometry.is_masked_volume = 0;
this_box_volume.geometry.is_exit_volume = 0;
this_box_volume.geometry.is_mask_volume = 0;
// check if the volume is a mask, if it is the material string is irelevant.
if (mask_string && strlen(mask_string) && strcmp(mask_string, "NULL") && strcmp(mask_string, "0")) {
    // A mask volume is used to limit the extend of other volumes, called the masked volumes. These are specified in the mask_string.
    // In order for a ray to enter a masked volume, it needs to be both in the region covered by that volume AND the mask volume.
    // When more than
    this_box_volume.geometry.mask_mode = 1; // Default is mask mode is ALL
    if (mask_setting && strlen(mask_setting) && strcmp(mask_setting, "NULL") && strcmp(mask_setting, "0")) {
        if (strcmp(mask_setting,"ALL") == 0 || strcmp(mask_setting,"All") == 0) this_box_volume.geometry.mask_mode = 1;
        else if (strcmp(mask_setting,"ANY") == 0 || strcmp(mask_setting,"Any") == 0) this_box_volume.geometry.mask_mode = 2;
        else {
            printf("The mask_mode of component %s is set to %s, but must be either ALL or ANY.\n",NAME_CURRENT_COMP,mask_setting);
            exit(1);
        }
    }
    
    for (loop_index=0;loop_index<global_geometry_list.num_elements;loop_index++) {
        // Add mask list
        if (1 == manual_linking_function(global_geometry_list.elements[loop_index].name,mask_string)) {
            add_element_to_int_list(&this_box_volume.geometry.mask_list,global_geometry_list.elements[loop_index].component_index);
            add_element_to_int_list(&global_geometry_list.elements[loop_index].Volume->geometry.masked_by_list,INDEX_CURRENT_COMP);
            global_geometry_list.elements[loop_index].Volume->geometry.is_masked_volume = 1;
            if (this_box_volume.geometry.mask_mode == 2)
                global_geometry_list.elements[loop_index].Volume->geometry.mask_mode = 2;
            if (this_box_volume.geometry.mask_mode == 1) {
                if (global_geometry_list.elements[loop_index].Volume->geometry.is_masked_volume == 1 && global_geometry_list.elements[loop_index].Volume->geometry.mask_mode != 2)
                    // If more than one mask is added to one volume, the ANY mode overwrites the (default) ALL mode.
                    global_geometry_list.elements[loop_index].Volume->geometry.mask_mode = 1;
            }
            
            found_geometries = 1;
        }
    }
    if (found_geometries == 0) {
        printf("The mask_string in geometry: %s did not find any of the specified volumes in the mask_string %s \n",NAME_CURRENT_COMP,mask_string);
        exit(1);
    }
    this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
    this_box_volume.p_physics->is_vacuum = 0; // Makes this volume a vacuum
    this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
    this_box_volume.p_physics->my_a = 0; // Should not be used.
    sprintf(this_box_volume.p_physics->name,"Mask");
    this_box_volume.geometry.is_mask_volume = 1;
    
    
// Read the material input, or if it lacks, use automatic linking.
} else if (material_string && strlen(material_string) && strcmp(material_string, "NULL") && strcmp(material_string, "0")) {
    // A geometry string was given, use it to determine which material
    if (0 == strcmp(material_string,"vacuum") || 0 == strcmp(material_string,"Vacuum")) {
        // One could have a global physics struct for vacuum instead of creating one for each
        this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
        this_box_volume.p_physics->is_vacuum = 1; // Makes this volume a vacuum
        this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
        this_box_volume.p_physics->my_a = 0; // Should not be used.
        sprintf(this_box_volume.p_physics->name,"Vacuum");
    } else if (0 == strcmp(material_string,"exit") || 0 == strcmp(material_string,"Exit")) {
        // One could have a global physics struct for vacuum instead of creating one for each
        this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
        this_box_volume.p_physics->is_vacuum = 1; // Makes this volume a vacuum
        this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
        this_box_volume.p_physics->my_a = 0; // Should not be used.
        this_box_volume.geometry.is_exit_volume = 1;
        sprintf(this_box_volume.p_physics->name,"Exit");
    } else {
        #ifndef MATERIAL_DETECTOR
            printf("Need to define a material before refering to it in a geometry %s.\n",NAME_CURRENT_COMP);
            exit(1);
        #endif
        for (loop_index=0;loop_index<global_material_list.num_elements;loop_index++) {
            if (0 == strcmp(material_string,global_material_list.elements[loop_index].name)) {
                this_box_volume.p_physics = global_material_list.elements[loop_index].physics;
                break;
            }
            if (loop_index == global_material_list.num_elements-1) {
            printf("\n");
            printf("ERROR: The material string \"%s\" in Union geometry \"%s\" did not match a specified material. \n",material_string,NAME_CURRENT_COMP);
            printf("       The materials available at this point (need to be defined before the geometry): \n");
            for (loop_index=0;loop_index<global_material_list.num_elements;loop_index++)
              printf("         %s\n",global_material_list.elements[loop_index].name);
            printf("\n");
            printf("       It is also possible to use one of the defualt materials avaiable: \n");
            printf("           Vacuum (for a Volume without scattering or absorption)\n");
            printf("           Exit (for a Volume where the ray exits the component if it enters)\n");
            printf("           Mask (for a Volume that masks existing volumes specified in the mask_string\n");
            exit(1);
          }
        }
    }
} else {
    // Automatic linking, simply using the last defined material.
    #ifndef MATERIAL_DETECTOR
        printf("Need to define a material before the geometry to use automatic linking %s.\n",NAME_CURRENT_COMP);
        exit(1);
    #endif
    this_box_volume.p_physics = global_material_list.elements[global_material_list.num_elements-1].physics;
}

sprintf(this_box_volume.name,NAME_CURRENT_COMP);
sprintf(this_box_volume.geometry.shape,"box");
this_box_volume.geometry.priority_value = priority;
this_box_volume.geometry.geometry_p_interact = p_interact;
// Currently the coordinates will be in absolute space.
this_box_volume.geometry.center = POS_A_CURRENT_COMP;

this_box_storage.z_depth = zdepth;
this_box_storage.x_width1 = xwidth;
this_box_storage.y_height1 = yheight;

this_box_storage.is_rectangle = 0;
if (xwidth2 < 0 && yheight2 < 0) this_box_storage.is_rectangle = 1;
if (xwidth == xwidth2 && yheight == yheight2) this_box_storage.is_rectangle = 1;

if (xwidth2 < 0) {
    this_box_storage.x_width2 = xwidth;
    xwidth2 = xwidth;
} else this_box_storage.x_width2 = xwidth2;

if (yheight2 < 0) {
    this_box_storage.y_height2 = yheight;
    yheight2 = yheight;
} else this_box_storage.y_height2 = yheight2;


this_box_storage.normal_vectors[0] = coords_set(0,0,1);
this_box_storage.normal_vectors[1] = coords_set(0,0,1);

// for sides with y component = 0
x_component = 2*zdepth/sqrt((xwidth-xwidth2)*(xwidth-xwidth2)+4*zdepth*zdepth);
z_component = (xwidth-xwidth2)/sqrt(4*zdepth*zdepth+(xwidth-xwidth2)*(xwidth-xwidth2));

this_box_storage.normal_vectors[2] = coords_set(x_component,0,z_component);
this_box_storage.normal_vectors[3] = coords_set(-x_component,0,z_component);

// for sides with x component = 0
y_component = 2*zdepth/sqrt((yheight-yheight2)*(yheight-yheight2)+4*zdepth*zdepth);
z_component = (yheight-yheight2)/sqrt(4*zdepth*zdepth+(yheight-yheight2)*(yheight-yheight2));

this_box_storage.normal_vectors[4] = coords_set(0,y_component,z_component);
this_box_storage.normal_vectors[5] = coords_set(0,-y_component,z_component);

this_box_volume.geometry.visualization_on = visualize;

this_box_volume.geometry.geometry_parameters.p_box_storage = &this_box_storage;

// Assign pointers to functions for intersection with the shape, checking if a point is inside the shape
if (this_box_storage.is_rectangle == 1) {
this_box_volume.geometry.intersect_function = &sample_box_intersect_simple;
this_box_volume.geometry.within_function = &r_within_box_simple;
}
else {
this_box_volume.geometry.intersect_function = &sample_box_intersect_advanced;
this_box_volume.geometry.within_function = &r_within_box_advanced;
}

this_box_volume.geometry.shell_points = &box_shell_points;
this_box_volume.geometry.mcdisplay_function = &mcdisplay_box_function;
this_box_volume.geometry.initialize_from_main_function = &initialize_box_geometry_from_main_component;
this_box_volume.geometry.process_rot_allocated = 0;

this_box_volume.geometry.copy_geometry_parameters = &allocate_box_storage_copy;

rot_copy(this_box_volume.geometry.rotation_matrix,ROT_A_CURRENT_COMP); //check how ROT_R_CURRENT_COMP would work
rot_transpose(ROT_A_CURRENT_COMP,this_box_volume.geometry.transpose_rotation_matrix);

// Initialize loggers
this_box_volume.loggers.num_elements = 0;

// packing the information into the global_geometry_element, which is then included in the global_geometry_list.
sprintf(global_geometry_element.name,NAME_CURRENT_COMP);
global_geometry_element.activation_counter = number_of_activations;
global_geometry_element.component_index = INDEX_CURRENT_COMP;
global_geometry_element.Volume = &this_box_volume; // Would be nicer if this m was a pointer, now we have the (small) data two places
add_element_to_geometry_list(&global_geometry_list,global_geometry_element);
}
#line 275561 "MACS_sample_kidney_box.c"
#undef number_of_activations
#undef mask_setting
#undef mask_string
#undef p_interact
#undef focus_r
#undef focus_xh
#undef focus_xw
#undef focus_ah
#undef focus_aw
#undef target_z
#undef target_y
#undef target_x
#undef target_index
#undef visualize
#undef yheight2
#undef xwidth2
#undef zdepth
#undef yheight
#undef xwidth
#undef priority
#undef material_string
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

  /* Initializations for component channel_12_analyzer_2_array_crystal_array_7. */
  SIG_MESSAGE("channel_12_analyzer_2_array_crystal_array_7 (Init)");
#define mccompcurname  channel_12_analyzer_2_array_crystal_array_7
#define mccompcurtype  Union_box
#define mccompcurindex 604
#define loop_index mccchannel_12_analyzer_2_array_crystal_array_7_loop_index
#define this_box_volume mccchannel_12_analyzer_2_array_crystal_array_7_this_box_volume
#define global_geometry_element mccchannel_12_analyzer_2_array_crystal_array_7_global_geometry_element
#define this_box_storage mccchannel_12_analyzer_2_array_crystal_array_7_this_box_storage
#define material_string mccchannel_12_analyzer_2_array_crystal_array_7_material_string
#define priority mccchannel_12_analyzer_2_array_crystal_array_7_priority
#define xwidth mccchannel_12_analyzer_2_array_crystal_array_7_xwidth
#define yheight mccchannel_12_analyzer_2_array_crystal_array_7_yheight
#define zdepth mccchannel_12_analyzer_2_array_crystal_array_7_zdepth
#define xwidth2 mccchannel_12_analyzer_2_array_crystal_array_7_xwidth2
#define yheight2 mccchannel_12_analyzer_2_array_crystal_array_7_yheight2
#define visualize mccchannel_12_analyzer_2_array_crystal_array_7_visualize
#define target_index mccchannel_12_analyzer_2_array_crystal_array_7_target_index
#define target_x mccchannel_12_analyzer_2_array_crystal_array_7_target_x
#define target_y mccchannel_12_analyzer_2_array_crystal_array_7_target_y
#define target_z mccchannel_12_analyzer_2_array_crystal_array_7_target_z
#define focus_aw mccchannel_12_analyzer_2_array_crystal_array_7_focus_aw
#define focus_ah mccchannel_12_analyzer_2_array_crystal_array_7_focus_ah
#define focus_xw mccchannel_12_analyzer_2_array_crystal_array_7_focus_xw
#define focus_xh mccchannel_12_analyzer_2_array_crystal_array_7_focus_xh
#define focus_r mccchannel_12_analyzer_2_array_crystal_array_7_focus_r
#define p_interact mccchannel_12_analyzer_2_array_crystal_array_7_p_interact
#define mask_string mccchannel_12_analyzer_2_array_crystal_array_7_mask_string
#define mask_setting mccchannel_12_analyzer_2_array_crystal_array_7_mask_setting
#define number_of_activations mccchannel_12_analyzer_2_array_crystal_array_7_number_of_activations
#line 224 "Union_box.comp"
{
// Initializes the focusing system for this volume including input sanitation.
focus_initialize(&this_box_volume.geometry, POS_A_COMP_INDEX(INDEX_CURRENT_COMP+target_index), POS_A_CURRENT_COMP, ROT_A_CURRENT_COMP, target_index, target_x, target_y, target_z, focus_aw, focus_ah, focus_xw, focus_xh, focus_r, NAME_CURRENT_COMP);

// Input sanitation for this geometry
if (xwidth <= 0) {
  printf("\nERROR in Union_box named %s, the xwidth is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (yheight <= 0) {
  printf("\nERROR in Union_box named %s, yheight is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (zdepth <= 0) {
  printf("\nERROR in Union_box named %s, zdepth is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (xwidth2 <= 0 && xwidth2 != -1) {
  printf("\nERROR in Union_box named %s, the xwidth2 is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (yheight2 <= 0 && yheight2 != -1) {
  printf("\nERROR in Union_box named %s, yheight2 is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}

// Use sanitation
if (global_material_list.num_elements == 0) {
  printf("\nERROR: Need to define a material using Union_make_material before using a Union geometry component. \n");
  printf("       %s was defined before first use of Union_make_material.\n",NAME_CURRENT_COMP);
  exit(1);
}

this_box_volume.geometry.is_masked_volume = 0;
this_box_volume.geometry.is_exit_volume = 0;
this_box_volume.geometry.is_mask_volume = 0;
// check if the volume is a mask, if it is the material string is irelevant.
if (mask_string && strlen(mask_string) && strcmp(mask_string, "NULL") && strcmp(mask_string, "0")) {
    // A mask volume is used to limit the extend of other volumes, called the masked volumes. These are specified in the mask_string.
    // In order for a ray to enter a masked volume, it needs to be both in the region covered by that volume AND the mask volume.
    // When more than
    this_box_volume.geometry.mask_mode = 1; // Default is mask mode is ALL
    if (mask_setting && strlen(mask_setting) && strcmp(mask_setting, "NULL") && strcmp(mask_setting, "0")) {
        if (strcmp(mask_setting,"ALL") == 0 || strcmp(mask_setting,"All") == 0) this_box_volume.geometry.mask_mode = 1;
        else if (strcmp(mask_setting,"ANY") == 0 || strcmp(mask_setting,"Any") == 0) this_box_volume.geometry.mask_mode = 2;
        else {
            printf("The mask_mode of component %s is set to %s, but must be either ALL or ANY.\n",NAME_CURRENT_COMP,mask_setting);
            exit(1);
        }
    }
    
    for (loop_index=0;loop_index<global_geometry_list.num_elements;loop_index++) {
        // Add mask list
        if (1 == manual_linking_function(global_geometry_list.elements[loop_index].name,mask_string)) {
            add_element_to_int_list(&this_box_volume.geometry.mask_list,global_geometry_list.elements[loop_index].component_index);
            add_element_to_int_list(&global_geometry_list.elements[loop_index].Volume->geometry.masked_by_list,INDEX_CURRENT_COMP);
            global_geometry_list.elements[loop_index].Volume->geometry.is_masked_volume = 1;
            if (this_box_volume.geometry.mask_mode == 2)
                global_geometry_list.elements[loop_index].Volume->geometry.mask_mode = 2;
            if (this_box_volume.geometry.mask_mode == 1) {
                if (global_geometry_list.elements[loop_index].Volume->geometry.is_masked_volume == 1 && global_geometry_list.elements[loop_index].Volume->geometry.mask_mode != 2)
                    // If more than one mask is added to one volume, the ANY mode overwrites the (default) ALL mode.
                    global_geometry_list.elements[loop_index].Volume->geometry.mask_mode = 1;
            }
            
            found_geometries = 1;
        }
    }
    if (found_geometries == 0) {
        printf("The mask_string in geometry: %s did not find any of the specified volumes in the mask_string %s \n",NAME_CURRENT_COMP,mask_string);
        exit(1);
    }
    this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
    this_box_volume.p_physics->is_vacuum = 0; // Makes this volume a vacuum
    this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
    this_box_volume.p_physics->my_a = 0; // Should not be used.
    sprintf(this_box_volume.p_physics->name,"Mask");
    this_box_volume.geometry.is_mask_volume = 1;
    
    
// Read the material input, or if it lacks, use automatic linking.
} else if (material_string && strlen(material_string) && strcmp(material_string, "NULL") && strcmp(material_string, "0")) {
    // A geometry string was given, use it to determine which material
    if (0 == strcmp(material_string,"vacuum") || 0 == strcmp(material_string,"Vacuum")) {
        // One could have a global physics struct for vacuum instead of creating one for each
        this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
        this_box_volume.p_physics->is_vacuum = 1; // Makes this volume a vacuum
        this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
        this_box_volume.p_physics->my_a = 0; // Should not be used.
        sprintf(this_box_volume.p_physics->name,"Vacuum");
    } else if (0 == strcmp(material_string,"exit") || 0 == strcmp(material_string,"Exit")) {
        // One could have a global physics struct for vacuum instead of creating one for each
        this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
        this_box_volume.p_physics->is_vacuum = 1; // Makes this volume a vacuum
        this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
        this_box_volume.p_physics->my_a = 0; // Should not be used.
        this_box_volume.geometry.is_exit_volume = 1;
        sprintf(this_box_volume.p_physics->name,"Exit");
    } else {
        #ifndef MATERIAL_DETECTOR
            printf("Need to define a material before refering to it in a geometry %s.\n",NAME_CURRENT_COMP);
            exit(1);
        #endif
        for (loop_index=0;loop_index<global_material_list.num_elements;loop_index++) {
            if (0 == strcmp(material_string,global_material_list.elements[loop_index].name)) {
                this_box_volume.p_physics = global_material_list.elements[loop_index].physics;
                break;
            }
            if (loop_index == global_material_list.num_elements-1) {
            printf("\n");
            printf("ERROR: The material string \"%s\" in Union geometry \"%s\" did not match a specified material. \n",material_string,NAME_CURRENT_COMP);
            printf("       The materials available at this point (need to be defined before the geometry): \n");
            for (loop_index=0;loop_index<global_material_list.num_elements;loop_index++)
              printf("         %s\n",global_material_list.elements[loop_index].name);
            printf("\n");
            printf("       It is also possible to use one of the defualt materials avaiable: \n");
            printf("           Vacuum (for a Volume without scattering or absorption)\n");
            printf("           Exit (for a Volume where the ray exits the component if it enters)\n");
            printf("           Mask (for a Volume that masks existing volumes specified in the mask_string\n");
            exit(1);
          }
        }
    }
} else {
    // Automatic linking, simply using the last defined material.
    #ifndef MATERIAL_DETECTOR
        printf("Need to define a material before the geometry to use automatic linking %s.\n",NAME_CURRENT_COMP);
        exit(1);
    #endif
    this_box_volume.p_physics = global_material_list.elements[global_material_list.num_elements-1].physics;
}

sprintf(this_box_volume.name,NAME_CURRENT_COMP);
sprintf(this_box_volume.geometry.shape,"box");
this_box_volume.geometry.priority_value = priority;
this_box_volume.geometry.geometry_p_interact = p_interact;
// Currently the coordinates will be in absolute space.
this_box_volume.geometry.center = POS_A_CURRENT_COMP;

this_box_storage.z_depth = zdepth;
this_box_storage.x_width1 = xwidth;
this_box_storage.y_height1 = yheight;

this_box_storage.is_rectangle = 0;
if (xwidth2 < 0 && yheight2 < 0) this_box_storage.is_rectangle = 1;
if (xwidth == xwidth2 && yheight == yheight2) this_box_storage.is_rectangle = 1;

if (xwidth2 < 0) {
    this_box_storage.x_width2 = xwidth;
    xwidth2 = xwidth;
} else this_box_storage.x_width2 = xwidth2;

if (yheight2 < 0) {
    this_box_storage.y_height2 = yheight;
    yheight2 = yheight;
} else this_box_storage.y_height2 = yheight2;


this_box_storage.normal_vectors[0] = coords_set(0,0,1);
this_box_storage.normal_vectors[1] = coords_set(0,0,1);

// for sides with y component = 0
x_component = 2*zdepth/sqrt((xwidth-xwidth2)*(xwidth-xwidth2)+4*zdepth*zdepth);
z_component = (xwidth-xwidth2)/sqrt(4*zdepth*zdepth+(xwidth-xwidth2)*(xwidth-xwidth2));

this_box_storage.normal_vectors[2] = coords_set(x_component,0,z_component);
this_box_storage.normal_vectors[3] = coords_set(-x_component,0,z_component);

// for sides with x component = 0
y_component = 2*zdepth/sqrt((yheight-yheight2)*(yheight-yheight2)+4*zdepth*zdepth);
z_component = (yheight-yheight2)/sqrt(4*zdepth*zdepth+(yheight-yheight2)*(yheight-yheight2));

this_box_storage.normal_vectors[4] = coords_set(0,y_component,z_component);
this_box_storage.normal_vectors[5] = coords_set(0,-y_component,z_component);

this_box_volume.geometry.visualization_on = visualize;

this_box_volume.geometry.geometry_parameters.p_box_storage = &this_box_storage;

// Assign pointers to functions for intersection with the shape, checking if a point is inside the shape
if (this_box_storage.is_rectangle == 1) {
this_box_volume.geometry.intersect_function = &sample_box_intersect_simple;
this_box_volume.geometry.within_function = &r_within_box_simple;
}
else {
this_box_volume.geometry.intersect_function = &sample_box_intersect_advanced;
this_box_volume.geometry.within_function = &r_within_box_advanced;
}

this_box_volume.geometry.shell_points = &box_shell_points;
this_box_volume.geometry.mcdisplay_function = &mcdisplay_box_function;
this_box_volume.geometry.initialize_from_main_function = &initialize_box_geometry_from_main_component;
this_box_volume.geometry.process_rot_allocated = 0;

this_box_volume.geometry.copy_geometry_parameters = &allocate_box_storage_copy;

rot_copy(this_box_volume.geometry.rotation_matrix,ROT_A_CURRENT_COMP); //check how ROT_R_CURRENT_COMP would work
rot_transpose(ROT_A_CURRENT_COMP,this_box_volume.geometry.transpose_rotation_matrix);

// Initialize loggers
this_box_volume.loggers.num_elements = 0;

// packing the information into the global_geometry_element, which is then included in the global_geometry_list.
sprintf(global_geometry_element.name,NAME_CURRENT_COMP);
global_geometry_element.activation_counter = number_of_activations;
global_geometry_element.component_index = INDEX_CURRENT_COMP;
global_geometry_element.Volume = &this_box_volume; // Would be nicer if this m was a pointer, now we have the (small) data two places
add_element_to_geometry_list(&global_geometry_list,global_geometry_element);
}
#line 275831 "MACS_sample_kidney_box.c"
#undef number_of_activations
#undef mask_setting
#undef mask_string
#undef p_interact
#undef focus_r
#undef focus_xh
#undef focus_xw
#undef focus_ah
#undef focus_aw
#undef target_z
#undef target_y
#undef target_x
#undef target_index
#undef visualize
#undef yheight2
#undef xwidth2
#undef zdepth
#undef yheight
#undef xwidth
#undef priority
#undef material_string
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

  /* Initializations for component channel_12_analyzer_2_array_crystal_array_8. */
  SIG_MESSAGE("channel_12_analyzer_2_array_crystal_array_8 (Init)");
#define mccompcurname  channel_12_analyzer_2_array_crystal_array_8
#define mccompcurtype  Union_box
#define mccompcurindex 605
#define loop_index mccchannel_12_analyzer_2_array_crystal_array_8_loop_index
#define this_box_volume mccchannel_12_analyzer_2_array_crystal_array_8_this_box_volume
#define global_geometry_element mccchannel_12_analyzer_2_array_crystal_array_8_global_geometry_element
#define this_box_storage mccchannel_12_analyzer_2_array_crystal_array_8_this_box_storage
#define material_string mccchannel_12_analyzer_2_array_crystal_array_8_material_string
#define priority mccchannel_12_analyzer_2_array_crystal_array_8_priority
#define xwidth mccchannel_12_analyzer_2_array_crystal_array_8_xwidth
#define yheight mccchannel_12_analyzer_2_array_crystal_array_8_yheight
#define zdepth mccchannel_12_analyzer_2_array_crystal_array_8_zdepth
#define xwidth2 mccchannel_12_analyzer_2_array_crystal_array_8_xwidth2
#define yheight2 mccchannel_12_analyzer_2_array_crystal_array_8_yheight2
#define visualize mccchannel_12_analyzer_2_array_crystal_array_8_visualize
#define target_index mccchannel_12_analyzer_2_array_crystal_array_8_target_index
#define target_x mccchannel_12_analyzer_2_array_crystal_array_8_target_x
#define target_y mccchannel_12_analyzer_2_array_crystal_array_8_target_y
#define target_z mccchannel_12_analyzer_2_array_crystal_array_8_target_z
#define focus_aw mccchannel_12_analyzer_2_array_crystal_array_8_focus_aw
#define focus_ah mccchannel_12_analyzer_2_array_crystal_array_8_focus_ah
#define focus_xw mccchannel_12_analyzer_2_array_crystal_array_8_focus_xw
#define focus_xh mccchannel_12_analyzer_2_array_crystal_array_8_focus_xh
#define focus_r mccchannel_12_analyzer_2_array_crystal_array_8_focus_r
#define p_interact mccchannel_12_analyzer_2_array_crystal_array_8_p_interact
#define mask_string mccchannel_12_analyzer_2_array_crystal_array_8_mask_string
#define mask_setting mccchannel_12_analyzer_2_array_crystal_array_8_mask_setting
#define number_of_activations mccchannel_12_analyzer_2_array_crystal_array_8_number_of_activations
#line 224 "Union_box.comp"
{
// Initializes the focusing system for this volume including input sanitation.
focus_initialize(&this_box_volume.geometry, POS_A_COMP_INDEX(INDEX_CURRENT_COMP+target_index), POS_A_CURRENT_COMP, ROT_A_CURRENT_COMP, target_index, target_x, target_y, target_z, focus_aw, focus_ah, focus_xw, focus_xh, focus_r, NAME_CURRENT_COMP);

// Input sanitation for this geometry
if (xwidth <= 0) {
  printf("\nERROR in Union_box named %s, the xwidth is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (yheight <= 0) {
  printf("\nERROR in Union_box named %s, yheight is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (zdepth <= 0) {
  printf("\nERROR in Union_box named %s, zdepth is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (xwidth2 <= 0 && xwidth2 != -1) {
  printf("\nERROR in Union_box named %s, the xwidth2 is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (yheight2 <= 0 && yheight2 != -1) {
  printf("\nERROR in Union_box named %s, yheight2 is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}

// Use sanitation
if (global_material_list.num_elements == 0) {
  printf("\nERROR: Need to define a material using Union_make_material before using a Union geometry component. \n");
  printf("       %s was defined before first use of Union_make_material.\n",NAME_CURRENT_COMP);
  exit(1);
}

this_box_volume.geometry.is_masked_volume = 0;
this_box_volume.geometry.is_exit_volume = 0;
this_box_volume.geometry.is_mask_volume = 0;
// check if the volume is a mask, if it is the material string is irelevant.
if (mask_string && strlen(mask_string) && strcmp(mask_string, "NULL") && strcmp(mask_string, "0")) {
    // A mask volume is used to limit the extend of other volumes, called the masked volumes. These are specified in the mask_string.
    // In order for a ray to enter a masked volume, it needs to be both in the region covered by that volume AND the mask volume.
    // When more than
    this_box_volume.geometry.mask_mode = 1; // Default is mask mode is ALL
    if (mask_setting && strlen(mask_setting) && strcmp(mask_setting, "NULL") && strcmp(mask_setting, "0")) {
        if (strcmp(mask_setting,"ALL") == 0 || strcmp(mask_setting,"All") == 0) this_box_volume.geometry.mask_mode = 1;
        else if (strcmp(mask_setting,"ANY") == 0 || strcmp(mask_setting,"Any") == 0) this_box_volume.geometry.mask_mode = 2;
        else {
            printf("The mask_mode of component %s is set to %s, but must be either ALL or ANY.\n",NAME_CURRENT_COMP,mask_setting);
            exit(1);
        }
    }
    
    for (loop_index=0;loop_index<global_geometry_list.num_elements;loop_index++) {
        // Add mask list
        if (1 == manual_linking_function(global_geometry_list.elements[loop_index].name,mask_string)) {
            add_element_to_int_list(&this_box_volume.geometry.mask_list,global_geometry_list.elements[loop_index].component_index);
            add_element_to_int_list(&global_geometry_list.elements[loop_index].Volume->geometry.masked_by_list,INDEX_CURRENT_COMP);
            global_geometry_list.elements[loop_index].Volume->geometry.is_masked_volume = 1;
            if (this_box_volume.geometry.mask_mode == 2)
                global_geometry_list.elements[loop_index].Volume->geometry.mask_mode = 2;
            if (this_box_volume.geometry.mask_mode == 1) {
                if (global_geometry_list.elements[loop_index].Volume->geometry.is_masked_volume == 1 && global_geometry_list.elements[loop_index].Volume->geometry.mask_mode != 2)
                    // If more than one mask is added to one volume, the ANY mode overwrites the (default) ALL mode.
                    global_geometry_list.elements[loop_index].Volume->geometry.mask_mode = 1;
            }
            
            found_geometries = 1;
        }
    }
    if (found_geometries == 0) {
        printf("The mask_string in geometry: %s did not find any of the specified volumes in the mask_string %s \n",NAME_CURRENT_COMP,mask_string);
        exit(1);
    }
    this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
    this_box_volume.p_physics->is_vacuum = 0; // Makes this volume a vacuum
    this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
    this_box_volume.p_physics->my_a = 0; // Should not be used.
    sprintf(this_box_volume.p_physics->name,"Mask");
    this_box_volume.geometry.is_mask_volume = 1;
    
    
// Read the material input, or if it lacks, use automatic linking.
} else if (material_string && strlen(material_string) && strcmp(material_string, "NULL") && strcmp(material_string, "0")) {
    // A geometry string was given, use it to determine which material
    if (0 == strcmp(material_string,"vacuum") || 0 == strcmp(material_string,"Vacuum")) {
        // One could have a global physics struct for vacuum instead of creating one for each
        this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
        this_box_volume.p_physics->is_vacuum = 1; // Makes this volume a vacuum
        this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
        this_box_volume.p_physics->my_a = 0; // Should not be used.
        sprintf(this_box_volume.p_physics->name,"Vacuum");
    } else if (0 == strcmp(material_string,"exit") || 0 == strcmp(material_string,"Exit")) {
        // One could have a global physics struct for vacuum instead of creating one for each
        this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
        this_box_volume.p_physics->is_vacuum = 1; // Makes this volume a vacuum
        this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
        this_box_volume.p_physics->my_a = 0; // Should not be used.
        this_box_volume.geometry.is_exit_volume = 1;
        sprintf(this_box_volume.p_physics->name,"Exit");
    } else {
        #ifndef MATERIAL_DETECTOR
            printf("Need to define a material before refering to it in a geometry %s.\n",NAME_CURRENT_COMP);
            exit(1);
        #endif
        for (loop_index=0;loop_index<global_material_list.num_elements;loop_index++) {
            if (0 == strcmp(material_string,global_material_list.elements[loop_index].name)) {
                this_box_volume.p_physics = global_material_list.elements[loop_index].physics;
                break;
            }
            if (loop_index == global_material_list.num_elements-1) {
            printf("\n");
            printf("ERROR: The material string \"%s\" in Union geometry \"%s\" did not match a specified material. \n",material_string,NAME_CURRENT_COMP);
            printf("       The materials available at this point (need to be defined before the geometry): \n");
            for (loop_index=0;loop_index<global_material_list.num_elements;loop_index++)
              printf("         %s\n",global_material_list.elements[loop_index].name);
            printf("\n");
            printf("       It is also possible to use one of the defualt materials avaiable: \n");
            printf("           Vacuum (for a Volume without scattering or absorption)\n");
            printf("           Exit (for a Volume where the ray exits the component if it enters)\n");
            printf("           Mask (for a Volume that masks existing volumes specified in the mask_string\n");
            exit(1);
          }
        }
    }
} else {
    // Automatic linking, simply using the last defined material.
    #ifndef MATERIAL_DETECTOR
        printf("Need to define a material before the geometry to use automatic linking %s.\n",NAME_CURRENT_COMP);
        exit(1);
    #endif
    this_box_volume.p_physics = global_material_list.elements[global_material_list.num_elements-1].physics;
}

sprintf(this_box_volume.name,NAME_CURRENT_COMP);
sprintf(this_box_volume.geometry.shape,"box");
this_box_volume.geometry.priority_value = priority;
this_box_volume.geometry.geometry_p_interact = p_interact;
// Currently the coordinates will be in absolute space.
this_box_volume.geometry.center = POS_A_CURRENT_COMP;

this_box_storage.z_depth = zdepth;
this_box_storage.x_width1 = xwidth;
this_box_storage.y_height1 = yheight;

this_box_storage.is_rectangle = 0;
if (xwidth2 < 0 && yheight2 < 0) this_box_storage.is_rectangle = 1;
if (xwidth == xwidth2 && yheight == yheight2) this_box_storage.is_rectangle = 1;

if (xwidth2 < 0) {
    this_box_storage.x_width2 = xwidth;
    xwidth2 = xwidth;
} else this_box_storage.x_width2 = xwidth2;

if (yheight2 < 0) {
    this_box_storage.y_height2 = yheight;
    yheight2 = yheight;
} else this_box_storage.y_height2 = yheight2;


this_box_storage.normal_vectors[0] = coords_set(0,0,1);
this_box_storage.normal_vectors[1] = coords_set(0,0,1);

// for sides with y component = 0
x_component = 2*zdepth/sqrt((xwidth-xwidth2)*(xwidth-xwidth2)+4*zdepth*zdepth);
z_component = (xwidth-xwidth2)/sqrt(4*zdepth*zdepth+(xwidth-xwidth2)*(xwidth-xwidth2));

this_box_storage.normal_vectors[2] = coords_set(x_component,0,z_component);
this_box_storage.normal_vectors[3] = coords_set(-x_component,0,z_component);

// for sides with x component = 0
y_component = 2*zdepth/sqrt((yheight-yheight2)*(yheight-yheight2)+4*zdepth*zdepth);
z_component = (yheight-yheight2)/sqrt(4*zdepth*zdepth+(yheight-yheight2)*(yheight-yheight2));

this_box_storage.normal_vectors[4] = coords_set(0,y_component,z_component);
this_box_storage.normal_vectors[5] = coords_set(0,-y_component,z_component);

this_box_volume.geometry.visualization_on = visualize;

this_box_volume.geometry.geometry_parameters.p_box_storage = &this_box_storage;

// Assign pointers to functions for intersection with the shape, checking if a point is inside the shape
if (this_box_storage.is_rectangle == 1) {
this_box_volume.geometry.intersect_function = &sample_box_intersect_simple;
this_box_volume.geometry.within_function = &r_within_box_simple;
}
else {
this_box_volume.geometry.intersect_function = &sample_box_intersect_advanced;
this_box_volume.geometry.within_function = &r_within_box_advanced;
}

this_box_volume.geometry.shell_points = &box_shell_points;
this_box_volume.geometry.mcdisplay_function = &mcdisplay_box_function;
this_box_volume.geometry.initialize_from_main_function = &initialize_box_geometry_from_main_component;
this_box_volume.geometry.process_rot_allocated = 0;

this_box_volume.geometry.copy_geometry_parameters = &allocate_box_storage_copy;

rot_copy(this_box_volume.geometry.rotation_matrix,ROT_A_CURRENT_COMP); //check how ROT_R_CURRENT_COMP would work
rot_transpose(ROT_A_CURRENT_COMP,this_box_volume.geometry.transpose_rotation_matrix);

// Initialize loggers
this_box_volume.loggers.num_elements = 0;

// packing the information into the global_geometry_element, which is then included in the global_geometry_list.
sprintf(global_geometry_element.name,NAME_CURRENT_COMP);
global_geometry_element.activation_counter = number_of_activations;
global_geometry_element.component_index = INDEX_CURRENT_COMP;
global_geometry_element.Volume = &this_box_volume; // Would be nicer if this m was a pointer, now we have the (small) data two places
add_element_to_geometry_list(&global_geometry_list,global_geometry_element);
}
#line 276101 "MACS_sample_kidney_box.c"
#undef number_of_activations
#undef mask_setting
#undef mask_string
#undef p_interact
#undef focus_r
#undef focus_xh
#undef focus_xw
#undef focus_ah
#undef focus_aw
#undef target_z
#undef target_y
#undef target_x
#undef target_index
#undef visualize
#undef yheight2
#undef xwidth2
#undef zdepth
#undef yheight
#undef xwidth
#undef priority
#undef material_string
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

  /* Initializations for component channel_12_cave2_cyl1. */
  SIG_MESSAGE("channel_12_cave2_cyl1 (Init)");
#define mccompcurname  channel_12_cave2_cyl1
#define mccompcurtype  Union_cylinder
#define mccompcurindex 606
#define loop_index mccchannel_12_cave2_cyl1_loop_index
#define this_cylinder_volume mccchannel_12_cave2_cyl1_this_cylinder_volume
#define global_geometry_element mccchannel_12_cave2_cyl1_global_geometry_element
#define this_cylinder_storage mccchannel_12_cave2_cyl1_this_cylinder_storage
#define material_string mccchannel_12_cave2_cyl1_material_string
#define priority mccchannel_12_cave2_cyl1_priority
#define radius mccchannel_12_cave2_cyl1_radius
#define yheight mccchannel_12_cave2_cyl1_yheight
#define visualize mccchannel_12_cave2_cyl1_visualize
#define target_index mccchannel_12_cave2_cyl1_target_index
#define target_x mccchannel_12_cave2_cyl1_target_x
#define target_y mccchannel_12_cave2_cyl1_target_y
#define target_z mccchannel_12_cave2_cyl1_target_z
#define focus_aw mccchannel_12_cave2_cyl1_focus_aw
#define focus_ah mccchannel_12_cave2_cyl1_focus_ah
#define focus_xw mccchannel_12_cave2_cyl1_focus_xw
#define focus_xh mccchannel_12_cave2_cyl1_focus_xh
#define focus_r mccchannel_12_cave2_cyl1_focus_r
#define p_interact mccchannel_12_cave2_cyl1_p_interact
#define mask_string mccchannel_12_cave2_cyl1_mask_string
#define mask_setting mccchannel_12_cave2_cyl1_mask_setting
#define number_of_activations mccchannel_12_cave2_cyl1_number_of_activations
#line 185 "Union_cylinder.comp"
{
// Initializes the focusing system for this volume including input sanitation.
focus_initialize(&this_cylinder_volume.geometry, POS_A_COMP_INDEX(INDEX_CURRENT_COMP+target_index), POS_A_CURRENT_COMP, ROT_A_CURRENT_COMP, target_index, target_x, target_y, target_z, focus_aw, focus_ah, focus_xw, focus_xh, focus_r, NAME_CURRENT_COMP);

// Input sanitation for this geometry
if (radius <= 0) {
  printf("\nERROR in Union_cylinder named %s, the radius is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}

if (yheight <= 0) {
  printf("\nERROR in Union_cylinder named %s, yheight is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}

// Use sanitation
#ifdef MATERIAL_DETECTOR
if (global_material_list.num_elements == 0) {
  // Here if the user have defined a material, but only after this material
  printf("\nERROR: Need to define a material using Union_make_material before using a Union geometry component. \n");
  printf("       %s was defined before first use of Union_make_material.\n",NAME_CURRENT_COMP);
  exit(1);
}
#endif
#ifndef MATERIAL_DETECTOR
  printf("\nERROR: Need to define a material using Union_make_material before using a Union geometry component. \n");
  exit(1);
#endif


this_cylinder_volume.geometry.is_masked_volume = 0;
this_cylinder_volume.geometry.is_exit_volume = 0;
this_cylinder_volume.geometry.is_mask_volume = 0;

// Read the material input, or if it lacks, use automatic linking.
if (mask_string && strlen(mask_string) && strcmp(mask_string, "NULL") && strcmp(mask_string, "0")) {
    // A mask volume is used to limit the extend of other volumes, called the masked volumes. These are specified in the mask_string.
    // In order for a ray to enter a masked volume, it needs to be both in the region covered by that volume AND the mask volume.
    // When more than
    this_cylinder_volume.geometry.mask_mode = 1; // Default is mask mode is ALL
    if (mask_setting && strlen(mask_setting) && strcmp(mask_setting, "NULL") && strcmp(mask_setting, "0")) {
        if (strcmp(mask_setting,"ALL") == 0 || strcmp(mask_setting,"All") == 0) this_cylinder_volume.geometry.mask_mode = 1;
        else if (strcmp(mask_setting,"ANY") == 0 || strcmp(mask_setting,"Any") == 0) this_cylinder_volume.geometry.mask_mode = 2;
        else {
            printf("The mask_mode of component %s is set to %s, but must be either ALL or ANY.\n",NAME_CURRENT_COMP,mask_setting);
            exit(1);
        }
    }
    
    for (loop_index=0;loop_index<global_geometry_list.num_elements;loop_index++) {
        // Add mask list
        if (1 == manual_linking_function(global_geometry_list.elements[loop_index].name,mask_string)) {
            add_element_to_int_list(&this_cylinder_volume.geometry.mask_list,global_geometry_list.elements[loop_index].component_index);
            add_element_to_int_list(&global_geometry_list.elements[loop_index].Volume->geometry.masked_by_list,INDEX_CURRENT_COMP);
            global_geometry_list.elements[loop_index].Volume->geometry.is_masked_volume = 1;
            if (this_cylinder_volume.geometry.mask_mode == 2)
                global_geometry_list.elements[loop_index].Volume->geometry.mask_mode = 2;
            if (this_cylinder_volume.geometry.mask_mode == 1) {
                if (global_geometry_list.elements[loop_index].Volume->geometry.is_masked_volume == 1 && global_geometry_list.elements[loop_index].Volume->geometry.mask_mode != 2)
                    // If more than one mask is added to one volume, the ANY mode overwrites the (default) ALL mode.
                    global_geometry_list.elements[loop_index].Volume->geometry.mask_mode = 1;
            }
            
            found_geometries = 1;
        }
    }
    if (found_geometries == 0) {
        printf("The mask_string in geometry: %s did not find any of the specified volumes in the mask_string %s \n",NAME_CURRENT_COMP,mask_string);
        exit(1);
    }
    this_cylinder_volume.p_physics = malloc(sizeof(struct physics_struct));
    this_cylinder_volume.p_physics->is_vacuum = 0; // Makes this volume a vacuum
    this_cylinder_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
    this_cylinder_volume.p_physics->my_a = 0; // Should not be used.
    sprintf(this_cylinder_volume.p_physics->name,"Mask");
    this_cylinder_volume.geometry.is_mask_volume = 1;
    
    
// Read the material input, or if it lacks, use automatic linking.
} else if (material_string && strlen(material_string) && strcmp(material_string, "NULL") && strcmp(material_string, "0")) {
    // A geometry string was given, use it to determine which material
    if (0 == strcmp(material_string,"vacuum") || 0 == strcmp(material_string,"Vacuum")) {
        // One could have a global physics struct for vacuum instead of creating one for each
        this_cylinder_volume.p_physics = malloc(sizeof(struct physics_struct));
        this_cylinder_volume.p_physics->is_vacuum = 1; // Makes this volume a vacuum
        this_cylinder_volume.p_physics->number_of_processes = (int) 0;
        this_cylinder_volume.p_physics->my_a = 0; // Should not be used.
        sprintf(this_cylinder_volume.p_physics->name,"Vacuum");
    } else if (0 == strcmp(material_string,"exit") || 0 == strcmp(material_string,"Exit")) {
        // One could have a global physics struct for exit instead of creating one for each
        this_cylinder_volume.p_physics = malloc(sizeof(struct physics_struct));
        this_cylinder_volume.p_physics->is_vacuum = 1; // Makes this volume a vacuum
        this_cylinder_volume.p_physics->number_of_processes = (int) 0;
        this_cylinder_volume.p_physics->my_a = 0; // Should not be used.
        this_cylinder_volume.geometry.is_exit_volume = 1;
        sprintf(this_cylinder_volume.p_physics->name,"Exit");
    } else {
        for (loop_index=0;loop_index<global_material_list.num_elements;loop_index++) {
          if (0 == strcmp(material_string,global_material_list.elements[loop_index].name)) {
            this_cylinder_volume.p_physics = global_material_list.elements[loop_index].physics;
            break;
          }
          if (loop_index == global_material_list.num_elements-1) {
            printf("\n");
            printf("ERROR: The material string \"%s\" in Union geometry \"%s\" did not match a specified material. \n",material_string,NAME_CURRENT_COMP);
            printf("       The materials available at this point (need to be defined before the geometry): \n");
            for (loop_index=0;loop_index<global_material_list.num_elements;loop_index++)
              printf("         %s\n",global_material_list.elements[loop_index].name);
            printf("\n");
            printf("       It is also possible to use one of the defualt materials avaiable: \n");
            printf("           Vacuum (for a Volume without scattering or absorption)\n");
            printf("           Exit (for a Volume where the ray exits the component if it enters)\n");
            printf("           Mask (for a Volume that masks existing volumes specified in the mask_string\n");
            exit(1);
          }
        }
    }
} else {
    // Automatic linking, simply using the last defined material.
    #ifndef MATERIAL_DETECTOR
        printf("Need to define a material before the geometry to use automatic linking %s.\n",NAME_CURRENT_COMP);
        exit(1);
    #endif
    this_cylinder_volume.p_physics = global_material_list.elements[global_material_list.num_elements-1].physics;
}

sprintf(this_cylinder_volume.name,NAME_CURRENT_COMP);
sprintf(this_cylinder_volume.geometry.shape,"cylinder");
this_cylinder_volume.geometry.priority_value = priority;
// Currently the coordinates will be in absolute space.
this_cylinder_volume.geometry.center = POS_A_CURRENT_COMP;

this_cylinder_volume.geometry.geometry_p_interact = p_interact;
this_cylinder_storage.cyl_radius = radius;
this_cylinder_storage.height = yheight;
this_cylinder_volume.geometry.visualization_on = visualize;
this_cylinder_volume.geometry.geometry_parameters.p_cylinder_storage = &this_cylinder_storage;
this_cylinder_volume.geometry.within_function = &r_within_cylinder;
this_cylinder_volume.geometry.intersect_function = &sample_cylinder_intersect;
this_cylinder_volume.geometry.mcdisplay_function = &mcdisplay_cylinder_function;
this_cylinder_volume.geometry.shell_points = &cylinder_shell_points;
this_cylinder_volume.geometry.initialize_from_main_function = &initialize_cylinder_geometry_from_main_component;
this_cylinder_volume.geometry.process_rot_allocated = 0;
this_cylinder_volume.geometry.copy_geometry_parameters = &allocate_cylinder_storage_copy;

rot_copy(this_cylinder_volume.geometry.rotation_matrix,ROT_A_CURRENT_COMP);
rot_transpose(ROT_A_CURRENT_COMP,this_cylinder_volume.geometry.transpose_rotation_matrix);

// Initialize loggers
this_cylinder_volume.loggers.num_elements = 0;

// packing the information into the global_geometry_element, which is then included in the global_geometry_list.
sprintf(global_geometry_element.name,NAME_CURRENT_COMP);
global_geometry_element.activation_counter = number_of_activations;
global_geometry_element.component_index = INDEX_CURRENT_COMP;
global_geometry_element.Volume = &this_cylinder_volume; // Would be nicer if this m was a pointer, now we have the (small) data two places
add_element_to_geometry_list(&global_geometry_list,global_geometry_element);
}
#line 276317 "MACS_sample_kidney_box.c"
#undef number_of_activations
#undef mask_setting
#undef mask_string
#undef p_interact
#undef focus_r
#undef focus_xh
#undef focus_xw
#undef focus_ah
#undef focus_aw
#undef target_z
#undef target_y
#undef target_x
#undef target_index
#undef visualize
#undef yheight
#undef radius
#undef priority
#undef material_string
#undef this_cylinder_storage
#undef global_geometry_element
#undef this_cylinder_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

  /* Initializations for component channel_12_cave2_box1. */
  SIG_MESSAGE("channel_12_cave2_box1 (Init)");
#define mccompcurname  channel_12_cave2_box1
#define mccompcurtype  Union_box
#define mccompcurindex 607
#define loop_index mccchannel_12_cave2_box1_loop_index
#define this_box_volume mccchannel_12_cave2_box1_this_box_volume
#define global_geometry_element mccchannel_12_cave2_box1_global_geometry_element
#define this_box_storage mccchannel_12_cave2_box1_this_box_storage
#define material_string mccchannel_12_cave2_box1_material_string
#define priority mccchannel_12_cave2_box1_priority
#define xwidth mccchannel_12_cave2_box1_xwidth
#define yheight mccchannel_12_cave2_box1_yheight
#define zdepth mccchannel_12_cave2_box1_zdepth
#define xwidth2 mccchannel_12_cave2_box1_xwidth2
#define yheight2 mccchannel_12_cave2_box1_yheight2
#define visualize mccchannel_12_cave2_box1_visualize
#define target_index mccchannel_12_cave2_box1_target_index
#define target_x mccchannel_12_cave2_box1_target_x
#define target_y mccchannel_12_cave2_box1_target_y
#define target_z mccchannel_12_cave2_box1_target_z
#define focus_aw mccchannel_12_cave2_box1_focus_aw
#define focus_ah mccchannel_12_cave2_box1_focus_ah
#define focus_xw mccchannel_12_cave2_box1_focus_xw
#define focus_xh mccchannel_12_cave2_box1_focus_xh
#define focus_r mccchannel_12_cave2_box1_focus_r
#define p_interact mccchannel_12_cave2_box1_p_interact
#define mask_string mccchannel_12_cave2_box1_mask_string
#define mask_setting mccchannel_12_cave2_box1_mask_setting
#define number_of_activations mccchannel_12_cave2_box1_number_of_activations
#line 224 "Union_box.comp"
{
// Initializes the focusing system for this volume including input sanitation.
focus_initialize(&this_box_volume.geometry, POS_A_COMP_INDEX(INDEX_CURRENT_COMP+target_index), POS_A_CURRENT_COMP, ROT_A_CURRENT_COMP, target_index, target_x, target_y, target_z, focus_aw, focus_ah, focus_xw, focus_xh, focus_r, NAME_CURRENT_COMP);

// Input sanitation for this geometry
if (xwidth <= 0) {
  printf("\nERROR in Union_box named %s, the xwidth is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (yheight <= 0) {
  printf("\nERROR in Union_box named %s, yheight is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (zdepth <= 0) {
  printf("\nERROR in Union_box named %s, zdepth is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (xwidth2 <= 0 && xwidth2 != -1) {
  printf("\nERROR in Union_box named %s, the xwidth2 is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (yheight2 <= 0 && yheight2 != -1) {
  printf("\nERROR in Union_box named %s, yheight2 is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}

// Use sanitation
if (global_material_list.num_elements == 0) {
  printf("\nERROR: Need to define a material using Union_make_material before using a Union geometry component. \n");
  printf("       %s was defined before first use of Union_make_material.\n",NAME_CURRENT_COMP);
  exit(1);
}

this_box_volume.geometry.is_masked_volume = 0;
this_box_volume.geometry.is_exit_volume = 0;
this_box_volume.geometry.is_mask_volume = 0;
// check if the volume is a mask, if it is the material string is irelevant.
if (mask_string && strlen(mask_string) && strcmp(mask_string, "NULL") && strcmp(mask_string, "0")) {
    // A mask volume is used to limit the extend of other volumes, called the masked volumes. These are specified in the mask_string.
    // In order for a ray to enter a masked volume, it needs to be both in the region covered by that volume AND the mask volume.
    // When more than
    this_box_volume.geometry.mask_mode = 1; // Default is mask mode is ALL
    if (mask_setting && strlen(mask_setting) && strcmp(mask_setting, "NULL") && strcmp(mask_setting, "0")) {
        if (strcmp(mask_setting,"ALL") == 0 || strcmp(mask_setting,"All") == 0) this_box_volume.geometry.mask_mode = 1;
        else if (strcmp(mask_setting,"ANY") == 0 || strcmp(mask_setting,"Any") == 0) this_box_volume.geometry.mask_mode = 2;
        else {
            printf("The mask_mode of component %s is set to %s, but must be either ALL or ANY.\n",NAME_CURRENT_COMP,mask_setting);
            exit(1);
        }
    }
    
    for (loop_index=0;loop_index<global_geometry_list.num_elements;loop_index++) {
        // Add mask list
        if (1 == manual_linking_function(global_geometry_list.elements[loop_index].name,mask_string)) {
            add_element_to_int_list(&this_box_volume.geometry.mask_list,global_geometry_list.elements[loop_index].component_index);
            add_element_to_int_list(&global_geometry_list.elements[loop_index].Volume->geometry.masked_by_list,INDEX_CURRENT_COMP);
            global_geometry_list.elements[loop_index].Volume->geometry.is_masked_volume = 1;
            if (this_box_volume.geometry.mask_mode == 2)
                global_geometry_list.elements[loop_index].Volume->geometry.mask_mode = 2;
            if (this_box_volume.geometry.mask_mode == 1) {
                if (global_geometry_list.elements[loop_index].Volume->geometry.is_masked_volume == 1 && global_geometry_list.elements[loop_index].Volume->geometry.mask_mode != 2)
                    // If more than one mask is added to one volume, the ANY mode overwrites the (default) ALL mode.
                    global_geometry_list.elements[loop_index].Volume->geometry.mask_mode = 1;
            }
            
            found_geometries = 1;
        }
    }
    if (found_geometries == 0) {
        printf("The mask_string in geometry: %s did not find any of the specified volumes in the mask_string %s \n",NAME_CURRENT_COMP,mask_string);
        exit(1);
    }
    this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
    this_box_volume.p_physics->is_vacuum = 0; // Makes this volume a vacuum
    this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
    this_box_volume.p_physics->my_a = 0; // Should not be used.
    sprintf(this_box_volume.p_physics->name,"Mask");
    this_box_volume.geometry.is_mask_volume = 1;
    
    
// Read the material input, or if it lacks, use automatic linking.
} else if (material_string && strlen(material_string) && strcmp(material_string, "NULL") && strcmp(material_string, "0")) {
    // A geometry string was given, use it to determine which material
    if (0 == strcmp(material_string,"vacuum") || 0 == strcmp(material_string,"Vacuum")) {
        // One could have a global physics struct for vacuum instead of creating one for each
        this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
        this_box_volume.p_physics->is_vacuum = 1; // Makes this volume a vacuum
        this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
        this_box_volume.p_physics->my_a = 0; // Should not be used.
        sprintf(this_box_volume.p_physics->name,"Vacuum");
    } else if (0 == strcmp(material_string,"exit") || 0 == strcmp(material_string,"Exit")) {
        // One could have a global physics struct for vacuum instead of creating one for each
        this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
        this_box_volume.p_physics->is_vacuum = 1; // Makes this volume a vacuum
        this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
        this_box_volume.p_physics->my_a = 0; // Should not be used.
        this_box_volume.geometry.is_exit_volume = 1;
        sprintf(this_box_volume.p_physics->name,"Exit");
    } else {
        #ifndef MATERIAL_DETECTOR
            printf("Need to define a material before refering to it in a geometry %s.\n",NAME_CURRENT_COMP);
            exit(1);
        #endif
        for (loop_index=0;loop_index<global_material_list.num_elements;loop_index++) {
            if (0 == strcmp(material_string,global_material_list.elements[loop_index].name)) {
                this_box_volume.p_physics = global_material_list.elements[loop_index].physics;
                break;
            }
            if (loop_index == global_material_list.num_elements-1) {
            printf("\n");
            printf("ERROR: The material string \"%s\" in Union geometry \"%s\" did not match a specified material. \n",material_string,NAME_CURRENT_COMP);
            printf("       The materials available at this point (need to be defined before the geometry): \n");
            for (loop_index=0;loop_index<global_material_list.num_elements;loop_index++)
              printf("         %s\n",global_material_list.elements[loop_index].name);
            printf("\n");
            printf("       It is also possible to use one of the defualt materials avaiable: \n");
            printf("           Vacuum (for a Volume without scattering or absorption)\n");
            printf("           Exit (for a Volume where the ray exits the component if it enters)\n");
            printf("           Mask (for a Volume that masks existing volumes specified in the mask_string\n");
            exit(1);
          }
        }
    }
} else {
    // Automatic linking, simply using the last defined material.
    #ifndef MATERIAL_DETECTOR
        printf("Need to define a material before the geometry to use automatic linking %s.\n",NAME_CURRENT_COMP);
        exit(1);
    #endif
    this_box_volume.p_physics = global_material_list.elements[global_material_list.num_elements-1].physics;
}

sprintf(this_box_volume.name,NAME_CURRENT_COMP);
sprintf(this_box_volume.geometry.shape,"box");
this_box_volume.geometry.priority_value = priority;
this_box_volume.geometry.geometry_p_interact = p_interact;
// Currently the coordinates will be in absolute space.
this_box_volume.geometry.center = POS_A_CURRENT_COMP;

this_box_storage.z_depth = zdepth;
this_box_storage.x_width1 = xwidth;
this_box_storage.y_height1 = yheight;

this_box_storage.is_rectangle = 0;
if (xwidth2 < 0 && yheight2 < 0) this_box_storage.is_rectangle = 1;
if (xwidth == xwidth2 && yheight == yheight2) this_box_storage.is_rectangle = 1;

if (xwidth2 < 0) {
    this_box_storage.x_width2 = xwidth;
    xwidth2 = xwidth;
} else this_box_storage.x_width2 = xwidth2;

if (yheight2 < 0) {
    this_box_storage.y_height2 = yheight;
    yheight2 = yheight;
} else this_box_storage.y_height2 = yheight2;


this_box_storage.normal_vectors[0] = coords_set(0,0,1);
this_box_storage.normal_vectors[1] = coords_set(0,0,1);

// for sides with y component = 0
x_component = 2*zdepth/sqrt((xwidth-xwidth2)*(xwidth-xwidth2)+4*zdepth*zdepth);
z_component = (xwidth-xwidth2)/sqrt(4*zdepth*zdepth+(xwidth-xwidth2)*(xwidth-xwidth2));

this_box_storage.normal_vectors[2] = coords_set(x_component,0,z_component);
this_box_storage.normal_vectors[3] = coords_set(-x_component,0,z_component);

// for sides with x component = 0
y_component = 2*zdepth/sqrt((yheight-yheight2)*(yheight-yheight2)+4*zdepth*zdepth);
z_component = (yheight-yheight2)/sqrt(4*zdepth*zdepth+(yheight-yheight2)*(yheight-yheight2));

this_box_storage.normal_vectors[4] = coords_set(0,y_component,z_component);
this_box_storage.normal_vectors[5] = coords_set(0,-y_component,z_component);

this_box_volume.geometry.visualization_on = visualize;

this_box_volume.geometry.geometry_parameters.p_box_storage = &this_box_storage;

// Assign pointers to functions for intersection with the shape, checking if a point is inside the shape
if (this_box_storage.is_rectangle == 1) {
this_box_volume.geometry.intersect_function = &sample_box_intersect_simple;
this_box_volume.geometry.within_function = &r_within_box_simple;
}
else {
this_box_volume.geometry.intersect_function = &sample_box_intersect_advanced;
this_box_volume.geometry.within_function = &r_within_box_advanced;
}

this_box_volume.geometry.shell_points = &box_shell_points;
this_box_volume.geometry.mcdisplay_function = &mcdisplay_box_function;
this_box_volume.geometry.initialize_from_main_function = &initialize_box_geometry_from_main_component;
this_box_volume.geometry.process_rot_allocated = 0;

this_box_volume.geometry.copy_geometry_parameters = &allocate_box_storage_copy;

rot_copy(this_box_volume.geometry.rotation_matrix,ROT_A_CURRENT_COMP); //check how ROT_R_CURRENT_COMP would work
rot_transpose(ROT_A_CURRENT_COMP,this_box_volume.geometry.transpose_rotation_matrix);

// Initialize loggers
this_box_volume.loggers.num_elements = 0;

// packing the information into the global_geometry_element, which is then included in the global_geometry_list.
sprintf(global_geometry_element.name,NAME_CURRENT_COMP);
global_geometry_element.activation_counter = number_of_activations;
global_geometry_element.component_index = INDEX_CURRENT_COMP;
global_geometry_element.Volume = &this_box_volume; // Would be nicer if this m was a pointer, now we have the (small) data two places
add_element_to_geometry_list(&global_geometry_list,global_geometry_element);
}
#line 276584 "MACS_sample_kidney_box.c"
#undef number_of_activations
#undef mask_setting
#undef mask_string
#undef p_interact
#undef focus_r
#undef focus_xh
#undef focus_xw
#undef focus_ah
#undef focus_aw
#undef target_z
#undef target_y
#undef target_x
#undef target_index
#undef visualize
#undef yheight2
#undef xwidth2
#undef zdepth
#undef yheight
#undef xwidth
#undef priority
#undef material_string
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

  /* Initializations for component channel_12_cave2_box2. */
  SIG_MESSAGE("channel_12_cave2_box2 (Init)");
#define mccompcurname  channel_12_cave2_box2
#define mccompcurtype  Union_box
#define mccompcurindex 608
#define loop_index mccchannel_12_cave2_box2_loop_index
#define this_box_volume mccchannel_12_cave2_box2_this_box_volume
#define global_geometry_element mccchannel_12_cave2_box2_global_geometry_element
#define this_box_storage mccchannel_12_cave2_box2_this_box_storage
#define material_string mccchannel_12_cave2_box2_material_string
#define priority mccchannel_12_cave2_box2_priority
#define xwidth mccchannel_12_cave2_box2_xwidth
#define yheight mccchannel_12_cave2_box2_yheight
#define zdepth mccchannel_12_cave2_box2_zdepth
#define xwidth2 mccchannel_12_cave2_box2_xwidth2
#define yheight2 mccchannel_12_cave2_box2_yheight2
#define visualize mccchannel_12_cave2_box2_visualize
#define target_index mccchannel_12_cave2_box2_target_index
#define target_x mccchannel_12_cave2_box2_target_x
#define target_y mccchannel_12_cave2_box2_target_y
#define target_z mccchannel_12_cave2_box2_target_z
#define focus_aw mccchannel_12_cave2_box2_focus_aw
#define focus_ah mccchannel_12_cave2_box2_focus_ah
#define focus_xw mccchannel_12_cave2_box2_focus_xw
#define focus_xh mccchannel_12_cave2_box2_focus_xh
#define focus_r mccchannel_12_cave2_box2_focus_r
#define p_interact mccchannel_12_cave2_box2_p_interact
#define mask_string mccchannel_12_cave2_box2_mask_string
#define mask_setting mccchannel_12_cave2_box2_mask_setting
#define number_of_activations mccchannel_12_cave2_box2_number_of_activations
#line 224 "Union_box.comp"
{
// Initializes the focusing system for this volume including input sanitation.
focus_initialize(&this_box_volume.geometry, POS_A_COMP_INDEX(INDEX_CURRENT_COMP+target_index), POS_A_CURRENT_COMP, ROT_A_CURRENT_COMP, target_index, target_x, target_y, target_z, focus_aw, focus_ah, focus_xw, focus_xh, focus_r, NAME_CURRENT_COMP);

// Input sanitation for this geometry
if (xwidth <= 0) {
  printf("\nERROR in Union_box named %s, the xwidth is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (yheight <= 0) {
  printf("\nERROR in Union_box named %s, yheight is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (zdepth <= 0) {
  printf("\nERROR in Union_box named %s, zdepth is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (xwidth2 <= 0 && xwidth2 != -1) {
  printf("\nERROR in Union_box named %s, the xwidth2 is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (yheight2 <= 0 && yheight2 != -1) {
  printf("\nERROR in Union_box named %s, yheight2 is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}

// Use sanitation
if (global_material_list.num_elements == 0) {
  printf("\nERROR: Need to define a material using Union_make_material before using a Union geometry component. \n");
  printf("       %s was defined before first use of Union_make_material.\n",NAME_CURRENT_COMP);
  exit(1);
}

this_box_volume.geometry.is_masked_volume = 0;
this_box_volume.geometry.is_exit_volume = 0;
this_box_volume.geometry.is_mask_volume = 0;
// check if the volume is a mask, if it is the material string is irelevant.
if (mask_string && strlen(mask_string) && strcmp(mask_string, "NULL") && strcmp(mask_string, "0")) {
    // A mask volume is used to limit the extend of other volumes, called the masked volumes. These are specified in the mask_string.
    // In order for a ray to enter a masked volume, it needs to be both in the region covered by that volume AND the mask volume.
    // When more than
    this_box_volume.geometry.mask_mode = 1; // Default is mask mode is ALL
    if (mask_setting && strlen(mask_setting) && strcmp(mask_setting, "NULL") && strcmp(mask_setting, "0")) {
        if (strcmp(mask_setting,"ALL") == 0 || strcmp(mask_setting,"All") == 0) this_box_volume.geometry.mask_mode = 1;
        else if (strcmp(mask_setting,"ANY") == 0 || strcmp(mask_setting,"Any") == 0) this_box_volume.geometry.mask_mode = 2;
        else {
            printf("The mask_mode of component %s is set to %s, but must be either ALL or ANY.\n",NAME_CURRENT_COMP,mask_setting);
            exit(1);
        }
    }
    
    for (loop_index=0;loop_index<global_geometry_list.num_elements;loop_index++) {
        // Add mask list
        if (1 == manual_linking_function(global_geometry_list.elements[loop_index].name,mask_string)) {
            add_element_to_int_list(&this_box_volume.geometry.mask_list,global_geometry_list.elements[loop_index].component_index);
            add_element_to_int_list(&global_geometry_list.elements[loop_index].Volume->geometry.masked_by_list,INDEX_CURRENT_COMP);
            global_geometry_list.elements[loop_index].Volume->geometry.is_masked_volume = 1;
            if (this_box_volume.geometry.mask_mode == 2)
                global_geometry_list.elements[loop_index].Volume->geometry.mask_mode = 2;
            if (this_box_volume.geometry.mask_mode == 1) {
                if (global_geometry_list.elements[loop_index].Volume->geometry.is_masked_volume == 1 && global_geometry_list.elements[loop_index].Volume->geometry.mask_mode != 2)
                    // If more than one mask is added to one volume, the ANY mode overwrites the (default) ALL mode.
                    global_geometry_list.elements[loop_index].Volume->geometry.mask_mode = 1;
            }
            
            found_geometries = 1;
        }
    }
    if (found_geometries == 0) {
        printf("The mask_string in geometry: %s did not find any of the specified volumes in the mask_string %s \n",NAME_CURRENT_COMP,mask_string);
        exit(1);
    }
    this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
    this_box_volume.p_physics->is_vacuum = 0; // Makes this volume a vacuum
    this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
    this_box_volume.p_physics->my_a = 0; // Should not be used.
    sprintf(this_box_volume.p_physics->name,"Mask");
    this_box_volume.geometry.is_mask_volume = 1;
    
    
// Read the material input, or if it lacks, use automatic linking.
} else if (material_string && strlen(material_string) && strcmp(material_string, "NULL") && strcmp(material_string, "0")) {
    // A geometry string was given, use it to determine which material
    if (0 == strcmp(material_string,"vacuum") || 0 == strcmp(material_string,"Vacuum")) {
        // One could have a global physics struct for vacuum instead of creating one for each
        this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
        this_box_volume.p_physics->is_vacuum = 1; // Makes this volume a vacuum
        this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
        this_box_volume.p_physics->my_a = 0; // Should not be used.
        sprintf(this_box_volume.p_physics->name,"Vacuum");
    } else if (0 == strcmp(material_string,"exit") || 0 == strcmp(material_string,"Exit")) {
        // One could have a global physics struct for vacuum instead of creating one for each
        this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
        this_box_volume.p_physics->is_vacuum = 1; // Makes this volume a vacuum
        this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
        this_box_volume.p_physics->my_a = 0; // Should not be used.
        this_box_volume.geometry.is_exit_volume = 1;
        sprintf(this_box_volume.p_physics->name,"Exit");
    } else {
        #ifndef MATERIAL_DETECTOR
            printf("Need to define a material before refering to it in a geometry %s.\n",NAME_CURRENT_COMP);
            exit(1);
        #endif
        for (loop_index=0;loop_index<global_material_list.num_elements;loop_index++) {
            if (0 == strcmp(material_string,global_material_list.elements[loop_index].name)) {
                this_box_volume.p_physics = global_material_list.elements[loop_index].physics;
                break;
            }
            if (loop_index == global_material_list.num_elements-1) {
            printf("\n");
            printf("ERROR: The material string \"%s\" in Union geometry \"%s\" did not match a specified material. \n",material_string,NAME_CURRENT_COMP);
            printf("       The materials available at this point (need to be defined before the geometry): \n");
            for (loop_index=0;loop_index<global_material_list.num_elements;loop_index++)
              printf("         %s\n",global_material_list.elements[loop_index].name);
            printf("\n");
            printf("       It is also possible to use one of the defualt materials avaiable: \n");
            printf("           Vacuum (for a Volume without scattering or absorption)\n");
            printf("           Exit (for a Volume where the ray exits the component if it enters)\n");
            printf("           Mask (for a Volume that masks existing volumes specified in the mask_string\n");
            exit(1);
          }
        }
    }
} else {
    // Automatic linking, simply using the last defined material.
    #ifndef MATERIAL_DETECTOR
        printf("Need to define a material before the geometry to use automatic linking %s.\n",NAME_CURRENT_COMP);
        exit(1);
    #endif
    this_box_volume.p_physics = global_material_list.elements[global_material_list.num_elements-1].physics;
}

sprintf(this_box_volume.name,NAME_CURRENT_COMP);
sprintf(this_box_volume.geometry.shape,"box");
this_box_volume.geometry.priority_value = priority;
this_box_volume.geometry.geometry_p_interact = p_interact;
// Currently the coordinates will be in absolute space.
this_box_volume.geometry.center = POS_A_CURRENT_COMP;

this_box_storage.z_depth = zdepth;
this_box_storage.x_width1 = xwidth;
this_box_storage.y_height1 = yheight;

this_box_storage.is_rectangle = 0;
if (xwidth2 < 0 && yheight2 < 0) this_box_storage.is_rectangle = 1;
if (xwidth == xwidth2 && yheight == yheight2) this_box_storage.is_rectangle = 1;

if (xwidth2 < 0) {
    this_box_storage.x_width2 = xwidth;
    xwidth2 = xwidth;
} else this_box_storage.x_width2 = xwidth2;

if (yheight2 < 0) {
    this_box_storage.y_height2 = yheight;
    yheight2 = yheight;
} else this_box_storage.y_height2 = yheight2;


this_box_storage.normal_vectors[0] = coords_set(0,0,1);
this_box_storage.normal_vectors[1] = coords_set(0,0,1);

// for sides with y component = 0
x_component = 2*zdepth/sqrt((xwidth-xwidth2)*(xwidth-xwidth2)+4*zdepth*zdepth);
z_component = (xwidth-xwidth2)/sqrt(4*zdepth*zdepth+(xwidth-xwidth2)*(xwidth-xwidth2));

this_box_storage.normal_vectors[2] = coords_set(x_component,0,z_component);
this_box_storage.normal_vectors[3] = coords_set(-x_component,0,z_component);

// for sides with x component = 0
y_component = 2*zdepth/sqrt((yheight-yheight2)*(yheight-yheight2)+4*zdepth*zdepth);
z_component = (yheight-yheight2)/sqrt(4*zdepth*zdepth+(yheight-yheight2)*(yheight-yheight2));

this_box_storage.normal_vectors[4] = coords_set(0,y_component,z_component);
this_box_storage.normal_vectors[5] = coords_set(0,-y_component,z_component);

this_box_volume.geometry.visualization_on = visualize;

this_box_volume.geometry.geometry_parameters.p_box_storage = &this_box_storage;

// Assign pointers to functions for intersection with the shape, checking if a point is inside the shape
if (this_box_storage.is_rectangle == 1) {
this_box_volume.geometry.intersect_function = &sample_box_intersect_simple;
this_box_volume.geometry.within_function = &r_within_box_simple;
}
else {
this_box_volume.geometry.intersect_function = &sample_box_intersect_advanced;
this_box_volume.geometry.within_function = &r_within_box_advanced;
}

this_box_volume.geometry.shell_points = &box_shell_points;
this_box_volume.geometry.mcdisplay_function = &mcdisplay_box_function;
this_box_volume.geometry.initialize_from_main_function = &initialize_box_geometry_from_main_component;
this_box_volume.geometry.process_rot_allocated = 0;

this_box_volume.geometry.copy_geometry_parameters = &allocate_box_storage_copy;

rot_copy(this_box_volume.geometry.rotation_matrix,ROT_A_CURRENT_COMP); //check how ROT_R_CURRENT_COMP would work
rot_transpose(ROT_A_CURRENT_COMP,this_box_volume.geometry.transpose_rotation_matrix);

// Initialize loggers
this_box_volume.loggers.num_elements = 0;

// packing the information into the global_geometry_element, which is then included in the global_geometry_list.
sprintf(global_geometry_element.name,NAME_CURRENT_COMP);
global_geometry_element.activation_counter = number_of_activations;
global_geometry_element.component_index = INDEX_CURRENT_COMP;
global_geometry_element.Volume = &this_box_volume; // Would be nicer if this m was a pointer, now we have the (small) data two places
add_element_to_geometry_list(&global_geometry_list,global_geometry_element);
}
#line 276854 "MACS_sample_kidney_box.c"
#undef number_of_activations
#undef mask_setting
#undef mask_string
#undef p_interact
#undef focus_r
#undef focus_xh
#undef focus_xw
#undef focus_ah
#undef focus_aw
#undef target_z
#undef target_y
#undef target_x
#undef target_index
#undef visualize
#undef yheight2
#undef xwidth2
#undef zdepth
#undef yheight
#undef xwidth
#undef priority
#undef material_string
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

  /* Initializations for component channel_12_cave2_box3. */
  SIG_MESSAGE("channel_12_cave2_box3 (Init)");
#define mccompcurname  channel_12_cave2_box3
#define mccompcurtype  Union_box
#define mccompcurindex 609
#define loop_index mccchannel_12_cave2_box3_loop_index
#define this_box_volume mccchannel_12_cave2_box3_this_box_volume
#define global_geometry_element mccchannel_12_cave2_box3_global_geometry_element
#define this_box_storage mccchannel_12_cave2_box3_this_box_storage
#define material_string mccchannel_12_cave2_box3_material_string
#define priority mccchannel_12_cave2_box3_priority
#define xwidth mccchannel_12_cave2_box3_xwidth
#define yheight mccchannel_12_cave2_box3_yheight
#define zdepth mccchannel_12_cave2_box3_zdepth
#define xwidth2 mccchannel_12_cave2_box3_xwidth2
#define yheight2 mccchannel_12_cave2_box3_yheight2
#define visualize mccchannel_12_cave2_box3_visualize
#define target_index mccchannel_12_cave2_box3_target_index
#define target_x mccchannel_12_cave2_box3_target_x
#define target_y mccchannel_12_cave2_box3_target_y
#define target_z mccchannel_12_cave2_box3_target_z
#define focus_aw mccchannel_12_cave2_box3_focus_aw
#define focus_ah mccchannel_12_cave2_box3_focus_ah
#define focus_xw mccchannel_12_cave2_box3_focus_xw
#define focus_xh mccchannel_12_cave2_box3_focus_xh
#define focus_r mccchannel_12_cave2_box3_focus_r
#define p_interact mccchannel_12_cave2_box3_p_interact
#define mask_string mccchannel_12_cave2_box3_mask_string
#define mask_setting mccchannel_12_cave2_box3_mask_setting
#define number_of_activations mccchannel_12_cave2_box3_number_of_activations
#line 224 "Union_box.comp"
{
// Initializes the focusing system for this volume including input sanitation.
focus_initialize(&this_box_volume.geometry, POS_A_COMP_INDEX(INDEX_CURRENT_COMP+target_index), POS_A_CURRENT_COMP, ROT_A_CURRENT_COMP, target_index, target_x, target_y, target_z, focus_aw, focus_ah, focus_xw, focus_xh, focus_r, NAME_CURRENT_COMP);

// Input sanitation for this geometry
if (xwidth <= 0) {
  printf("\nERROR in Union_box named %s, the xwidth is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (yheight <= 0) {
  printf("\nERROR in Union_box named %s, yheight is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (zdepth <= 0) {
  printf("\nERROR in Union_box named %s, zdepth is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (xwidth2 <= 0 && xwidth2 != -1) {
  printf("\nERROR in Union_box named %s, the xwidth2 is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (yheight2 <= 0 && yheight2 != -1) {
  printf("\nERROR in Union_box named %s, yheight2 is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}

// Use sanitation
if (global_material_list.num_elements == 0) {
  printf("\nERROR: Need to define a material using Union_make_material before using a Union geometry component. \n");
  printf("       %s was defined before first use of Union_make_material.\n",NAME_CURRENT_COMP);
  exit(1);
}

this_box_volume.geometry.is_masked_volume = 0;
this_box_volume.geometry.is_exit_volume = 0;
this_box_volume.geometry.is_mask_volume = 0;
// check if the volume is a mask, if it is the material string is irelevant.
if (mask_string && strlen(mask_string) && strcmp(mask_string, "NULL") && strcmp(mask_string, "0")) {
    // A mask volume is used to limit the extend of other volumes, called the masked volumes. These are specified in the mask_string.
    // In order for a ray to enter a masked volume, it needs to be both in the region covered by that volume AND the mask volume.
    // When more than
    this_box_volume.geometry.mask_mode = 1; // Default is mask mode is ALL
    if (mask_setting && strlen(mask_setting) && strcmp(mask_setting, "NULL") && strcmp(mask_setting, "0")) {
        if (strcmp(mask_setting,"ALL") == 0 || strcmp(mask_setting,"All") == 0) this_box_volume.geometry.mask_mode = 1;
        else if (strcmp(mask_setting,"ANY") == 0 || strcmp(mask_setting,"Any") == 0) this_box_volume.geometry.mask_mode = 2;
        else {
            printf("The mask_mode of component %s is set to %s, but must be either ALL or ANY.\n",NAME_CURRENT_COMP,mask_setting);
            exit(1);
        }
    }
    
    for (loop_index=0;loop_index<global_geometry_list.num_elements;loop_index++) {
        // Add mask list
        if (1 == manual_linking_function(global_geometry_list.elements[loop_index].name,mask_string)) {
            add_element_to_int_list(&this_box_volume.geometry.mask_list,global_geometry_list.elements[loop_index].component_index);
            add_element_to_int_list(&global_geometry_list.elements[loop_index].Volume->geometry.masked_by_list,INDEX_CURRENT_COMP);
            global_geometry_list.elements[loop_index].Volume->geometry.is_masked_volume = 1;
            if (this_box_volume.geometry.mask_mode == 2)
                global_geometry_list.elements[loop_index].Volume->geometry.mask_mode = 2;
            if (this_box_volume.geometry.mask_mode == 1) {
                if (global_geometry_list.elements[loop_index].Volume->geometry.is_masked_volume == 1 && global_geometry_list.elements[loop_index].Volume->geometry.mask_mode != 2)
                    // If more than one mask is added to one volume, the ANY mode overwrites the (default) ALL mode.
                    global_geometry_list.elements[loop_index].Volume->geometry.mask_mode = 1;
            }
            
            found_geometries = 1;
        }
    }
    if (found_geometries == 0) {
        printf("The mask_string in geometry: %s did not find any of the specified volumes in the mask_string %s \n",NAME_CURRENT_COMP,mask_string);
        exit(1);
    }
    this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
    this_box_volume.p_physics->is_vacuum = 0; // Makes this volume a vacuum
    this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
    this_box_volume.p_physics->my_a = 0; // Should not be used.
    sprintf(this_box_volume.p_physics->name,"Mask");
    this_box_volume.geometry.is_mask_volume = 1;
    
    
// Read the material input, or if it lacks, use automatic linking.
} else if (material_string && strlen(material_string) && strcmp(material_string, "NULL") && strcmp(material_string, "0")) {
    // A geometry string was given, use it to determine which material
    if (0 == strcmp(material_string,"vacuum") || 0 == strcmp(material_string,"Vacuum")) {
        // One could have a global physics struct for vacuum instead of creating one for each
        this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
        this_box_volume.p_physics->is_vacuum = 1; // Makes this volume a vacuum
        this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
        this_box_volume.p_physics->my_a = 0; // Should not be used.
        sprintf(this_box_volume.p_physics->name,"Vacuum");
    } else if (0 == strcmp(material_string,"exit") || 0 == strcmp(material_string,"Exit")) {
        // One could have a global physics struct for vacuum instead of creating one for each
        this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
        this_box_volume.p_physics->is_vacuum = 1; // Makes this volume a vacuum
        this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
        this_box_volume.p_physics->my_a = 0; // Should not be used.
        this_box_volume.geometry.is_exit_volume = 1;
        sprintf(this_box_volume.p_physics->name,"Exit");
    } else {
        #ifndef MATERIAL_DETECTOR
            printf("Need to define a material before refering to it in a geometry %s.\n",NAME_CURRENT_COMP);
            exit(1);
        #endif
        for (loop_index=0;loop_index<global_material_list.num_elements;loop_index++) {
            if (0 == strcmp(material_string,global_material_list.elements[loop_index].name)) {
                this_box_volume.p_physics = global_material_list.elements[loop_index].physics;
                break;
            }
            if (loop_index == global_material_list.num_elements-1) {
            printf("\n");
            printf("ERROR: The material string \"%s\" in Union geometry \"%s\" did not match a specified material. \n",material_string,NAME_CURRENT_COMP);
            printf("       The materials available at this point (need to be defined before the geometry): \n");
            for (loop_index=0;loop_index<global_material_list.num_elements;loop_index++)
              printf("         %s\n",global_material_list.elements[loop_index].name);
            printf("\n");
            printf("       It is also possible to use one of the defualt materials avaiable: \n");
            printf("           Vacuum (for a Volume without scattering or absorption)\n");
            printf("           Exit (for a Volume where the ray exits the component if it enters)\n");
            printf("           Mask (for a Volume that masks existing volumes specified in the mask_string\n");
            exit(1);
          }
        }
    }
} else {
    // Automatic linking, simply using the last defined material.
    #ifndef MATERIAL_DETECTOR
        printf("Need to define a material before the geometry to use automatic linking %s.\n",NAME_CURRENT_COMP);
        exit(1);
    #endif
    this_box_volume.p_physics = global_material_list.elements[global_material_list.num_elements-1].physics;
}

sprintf(this_box_volume.name,NAME_CURRENT_COMP);
sprintf(this_box_volume.geometry.shape,"box");
this_box_volume.geometry.priority_value = priority;
this_box_volume.geometry.geometry_p_interact = p_interact;
// Currently the coordinates will be in absolute space.
this_box_volume.geometry.center = POS_A_CURRENT_COMP;

this_box_storage.z_depth = zdepth;
this_box_storage.x_width1 = xwidth;
this_box_storage.y_height1 = yheight;

this_box_storage.is_rectangle = 0;
if (xwidth2 < 0 && yheight2 < 0) this_box_storage.is_rectangle = 1;
if (xwidth == xwidth2 && yheight == yheight2) this_box_storage.is_rectangle = 1;

if (xwidth2 < 0) {
    this_box_storage.x_width2 = xwidth;
    xwidth2 = xwidth;
} else this_box_storage.x_width2 = xwidth2;

if (yheight2 < 0) {
    this_box_storage.y_height2 = yheight;
    yheight2 = yheight;
} else this_box_storage.y_height2 = yheight2;


this_box_storage.normal_vectors[0] = coords_set(0,0,1);
this_box_storage.normal_vectors[1] = coords_set(0,0,1);

// for sides with y component = 0
x_component = 2*zdepth/sqrt((xwidth-xwidth2)*(xwidth-xwidth2)+4*zdepth*zdepth);
z_component = (xwidth-xwidth2)/sqrt(4*zdepth*zdepth+(xwidth-xwidth2)*(xwidth-xwidth2));

this_box_storage.normal_vectors[2] = coords_set(x_component,0,z_component);
this_box_storage.normal_vectors[3] = coords_set(-x_component,0,z_component);

// for sides with x component = 0
y_component = 2*zdepth/sqrt((yheight-yheight2)*(yheight-yheight2)+4*zdepth*zdepth);
z_component = (yheight-yheight2)/sqrt(4*zdepth*zdepth+(yheight-yheight2)*(yheight-yheight2));

this_box_storage.normal_vectors[4] = coords_set(0,y_component,z_component);
this_box_storage.normal_vectors[5] = coords_set(0,-y_component,z_component);

this_box_volume.geometry.visualization_on = visualize;

this_box_volume.geometry.geometry_parameters.p_box_storage = &this_box_storage;

// Assign pointers to functions for intersection with the shape, checking if a point is inside the shape
if (this_box_storage.is_rectangle == 1) {
this_box_volume.geometry.intersect_function = &sample_box_intersect_simple;
this_box_volume.geometry.within_function = &r_within_box_simple;
}
else {
this_box_volume.geometry.intersect_function = &sample_box_intersect_advanced;
this_box_volume.geometry.within_function = &r_within_box_advanced;
}

this_box_volume.geometry.shell_points = &box_shell_points;
this_box_volume.geometry.mcdisplay_function = &mcdisplay_box_function;
this_box_volume.geometry.initialize_from_main_function = &initialize_box_geometry_from_main_component;
this_box_volume.geometry.process_rot_allocated = 0;

this_box_volume.geometry.copy_geometry_parameters = &allocate_box_storage_copy;

rot_copy(this_box_volume.geometry.rotation_matrix,ROT_A_CURRENT_COMP); //check how ROT_R_CURRENT_COMP would work
rot_transpose(ROT_A_CURRENT_COMP,this_box_volume.geometry.transpose_rotation_matrix);

// Initialize loggers
this_box_volume.loggers.num_elements = 0;

// packing the information into the global_geometry_element, which is then included in the global_geometry_list.
sprintf(global_geometry_element.name,NAME_CURRENT_COMP);
global_geometry_element.activation_counter = number_of_activations;
global_geometry_element.component_index = INDEX_CURRENT_COMP;
global_geometry_element.Volume = &this_box_volume; // Would be nicer if this m was a pointer, now we have the (small) data two places
add_element_to_geometry_list(&global_geometry_list,global_geometry_element);
}
#line 277124 "MACS_sample_kidney_box.c"
#undef number_of_activations
#undef mask_setting
#undef mask_string
#undef p_interact
#undef focus_r
#undef focus_xh
#undef focus_xw
#undef focus_ah
#undef focus_aw
#undef target_z
#undef target_y
#undef target_x
#undef target_index
#undef visualize
#undef yheight2
#undef xwidth2
#undef zdepth
#undef yheight
#undef xwidth
#undef priority
#undef material_string
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

  /* Initializations for component inter_analyzer_colimator_center_12. */
  SIG_MESSAGE("inter_analyzer_colimator_center_12 (Init)");

  /* Initializations for component inter_analyzer_colimator_12_blade_0. */
  SIG_MESSAGE("inter_analyzer_colimator_12_blade_0 (Init)");
#define mccompcurname  inter_analyzer_colimator_12_blade_0
#define mccompcurtype  Union_box
#define mccompcurindex 611
#define loop_index mccinter_analyzer_colimator_12_blade_0_loop_index
#define this_box_volume mccinter_analyzer_colimator_12_blade_0_this_box_volume
#define global_geometry_element mccinter_analyzer_colimator_12_blade_0_global_geometry_element
#define this_box_storage mccinter_analyzer_colimator_12_blade_0_this_box_storage
#define material_string mccinter_analyzer_colimator_12_blade_0_material_string
#define priority mccinter_analyzer_colimator_12_blade_0_priority
#define xwidth mccinter_analyzer_colimator_12_blade_0_xwidth
#define yheight mccinter_analyzer_colimator_12_blade_0_yheight
#define zdepth mccinter_analyzer_colimator_12_blade_0_zdepth
#define xwidth2 mccinter_analyzer_colimator_12_blade_0_xwidth2
#define yheight2 mccinter_analyzer_colimator_12_blade_0_yheight2
#define visualize mccinter_analyzer_colimator_12_blade_0_visualize
#define target_index mccinter_analyzer_colimator_12_blade_0_target_index
#define target_x mccinter_analyzer_colimator_12_blade_0_target_x
#define target_y mccinter_analyzer_colimator_12_blade_0_target_y
#define target_z mccinter_analyzer_colimator_12_blade_0_target_z
#define focus_aw mccinter_analyzer_colimator_12_blade_0_focus_aw
#define focus_ah mccinter_analyzer_colimator_12_blade_0_focus_ah
#define focus_xw mccinter_analyzer_colimator_12_blade_0_focus_xw
#define focus_xh mccinter_analyzer_colimator_12_blade_0_focus_xh
#define focus_r mccinter_analyzer_colimator_12_blade_0_focus_r
#define p_interact mccinter_analyzer_colimator_12_blade_0_p_interact
#define mask_string mccinter_analyzer_colimator_12_blade_0_mask_string
#define mask_setting mccinter_analyzer_colimator_12_blade_0_mask_setting
#define number_of_activations mccinter_analyzer_colimator_12_blade_0_number_of_activations
#line 224 "Union_box.comp"
{
// Initializes the focusing system for this volume including input sanitation.
focus_initialize(&this_box_volume.geometry, POS_A_COMP_INDEX(INDEX_CURRENT_COMP+target_index), POS_A_CURRENT_COMP, ROT_A_CURRENT_COMP, target_index, target_x, target_y, target_z, focus_aw, focus_ah, focus_xw, focus_xh, focus_r, NAME_CURRENT_COMP);

// Input sanitation for this geometry
if (xwidth <= 0) {
  printf("\nERROR in Union_box named %s, the xwidth is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (yheight <= 0) {
  printf("\nERROR in Union_box named %s, yheight is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (zdepth <= 0) {
  printf("\nERROR in Union_box named %s, zdepth is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (xwidth2 <= 0 && xwidth2 != -1) {
  printf("\nERROR in Union_box named %s, the xwidth2 is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (yheight2 <= 0 && yheight2 != -1) {
  printf("\nERROR in Union_box named %s, yheight2 is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}

// Use sanitation
if (global_material_list.num_elements == 0) {
  printf("\nERROR: Need to define a material using Union_make_material before using a Union geometry component. \n");
  printf("       %s was defined before first use of Union_make_material.\n",NAME_CURRENT_COMP);
  exit(1);
}

this_box_volume.geometry.is_masked_volume = 0;
this_box_volume.geometry.is_exit_volume = 0;
this_box_volume.geometry.is_mask_volume = 0;
// check if the volume is a mask, if it is the material string is irelevant.
if (mask_string && strlen(mask_string) && strcmp(mask_string, "NULL") && strcmp(mask_string, "0")) {
    // A mask volume is used to limit the extend of other volumes, called the masked volumes. These are specified in the mask_string.
    // In order for a ray to enter a masked volume, it needs to be both in the region covered by that volume AND the mask volume.
    // When more than
    this_box_volume.geometry.mask_mode = 1; // Default is mask mode is ALL
    if (mask_setting && strlen(mask_setting) && strcmp(mask_setting, "NULL") && strcmp(mask_setting, "0")) {
        if (strcmp(mask_setting,"ALL") == 0 || strcmp(mask_setting,"All") == 0) this_box_volume.geometry.mask_mode = 1;
        else if (strcmp(mask_setting,"ANY") == 0 || strcmp(mask_setting,"Any") == 0) this_box_volume.geometry.mask_mode = 2;
        else {
            printf("The mask_mode of component %s is set to %s, but must be either ALL or ANY.\n",NAME_CURRENT_COMP,mask_setting);
            exit(1);
        }
    }
    
    for (loop_index=0;loop_index<global_geometry_list.num_elements;loop_index++) {
        // Add mask list
        if (1 == manual_linking_function(global_geometry_list.elements[loop_index].name,mask_string)) {
            add_element_to_int_list(&this_box_volume.geometry.mask_list,global_geometry_list.elements[loop_index].component_index);
            add_element_to_int_list(&global_geometry_list.elements[loop_index].Volume->geometry.masked_by_list,INDEX_CURRENT_COMP);
            global_geometry_list.elements[loop_index].Volume->geometry.is_masked_volume = 1;
            if (this_box_volume.geometry.mask_mode == 2)
                global_geometry_list.elements[loop_index].Volume->geometry.mask_mode = 2;
            if (this_box_volume.geometry.mask_mode == 1) {
                if (global_geometry_list.elements[loop_index].Volume->geometry.is_masked_volume == 1 && global_geometry_list.elements[loop_index].Volume->geometry.mask_mode != 2)
                    // If more than one mask is added to one volume, the ANY mode overwrites the (default) ALL mode.
                    global_geometry_list.elements[loop_index].Volume->geometry.mask_mode = 1;
            }
            
            found_geometries = 1;
        }
    }
    if (found_geometries == 0) {
        printf("The mask_string in geometry: %s did not find any of the specified volumes in the mask_string %s \n",NAME_CURRENT_COMP,mask_string);
        exit(1);
    }
    this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
    this_box_volume.p_physics->is_vacuum = 0; // Makes this volume a vacuum
    this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
    this_box_volume.p_physics->my_a = 0; // Should not be used.
    sprintf(this_box_volume.p_physics->name,"Mask");
    this_box_volume.geometry.is_mask_volume = 1;
    
    
// Read the material input, or if it lacks, use automatic linking.
} else if (material_string && strlen(material_string) && strcmp(material_string, "NULL") && strcmp(material_string, "0")) {
    // A geometry string was given, use it to determine which material
    if (0 == strcmp(material_string,"vacuum") || 0 == strcmp(material_string,"Vacuum")) {
        // One could have a global physics struct for vacuum instead of creating one for each
        this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
        this_box_volume.p_physics->is_vacuum = 1; // Makes this volume a vacuum
        this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
        this_box_volume.p_physics->my_a = 0; // Should not be used.
        sprintf(this_box_volume.p_physics->name,"Vacuum");
    } else if (0 == strcmp(material_string,"exit") || 0 == strcmp(material_string,"Exit")) {
        // One could have a global physics struct for vacuum instead of creating one for each
        this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
        this_box_volume.p_physics->is_vacuum = 1; // Makes this volume a vacuum
        this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
        this_box_volume.p_physics->my_a = 0; // Should not be used.
        this_box_volume.geometry.is_exit_volume = 1;
        sprintf(this_box_volume.p_physics->name,"Exit");
    } else {
        #ifndef MATERIAL_DETECTOR
            printf("Need to define a material before refering to it in a geometry %s.\n",NAME_CURRENT_COMP);
            exit(1);
        #endif
        for (loop_index=0;loop_index<global_material_list.num_elements;loop_index++) {
            if (0 == strcmp(material_string,global_material_list.elements[loop_index].name)) {
                this_box_volume.p_physics = global_material_list.elements[loop_index].physics;
                break;
            }
            if (loop_index == global_material_list.num_elements-1) {
            printf("\n");
            printf("ERROR: The material string \"%s\" in Union geometry \"%s\" did not match a specified material. \n",material_string,NAME_CURRENT_COMP);
            printf("       The materials available at this point (need to be defined before the geometry): \n");
            for (loop_index=0;loop_index<global_material_list.num_elements;loop_index++)
              printf("         %s\n",global_material_list.elements[loop_index].name);
            printf("\n");
            printf("       It is also possible to use one of the defualt materials avaiable: \n");
            printf("           Vacuum (for a Volume without scattering or absorption)\n");
            printf("           Exit (for a Volume where the ray exits the component if it enters)\n");
            printf("           Mask (for a Volume that masks existing volumes specified in the mask_string\n");
            exit(1);
          }
        }
    }
} else {
    // Automatic linking, simply using the last defined material.
    #ifndef MATERIAL_DETECTOR
        printf("Need to define a material before the geometry to use automatic linking %s.\n",NAME_CURRENT_COMP);
        exit(1);
    #endif
    this_box_volume.p_physics = global_material_list.elements[global_material_list.num_elements-1].physics;
}

sprintf(this_box_volume.name,NAME_CURRENT_COMP);
sprintf(this_box_volume.geometry.shape,"box");
this_box_volume.geometry.priority_value = priority;
this_box_volume.geometry.geometry_p_interact = p_interact;
// Currently the coordinates will be in absolute space.
this_box_volume.geometry.center = POS_A_CURRENT_COMP;

this_box_storage.z_depth = zdepth;
this_box_storage.x_width1 = xwidth;
this_box_storage.y_height1 = yheight;

this_box_storage.is_rectangle = 0;
if (xwidth2 < 0 && yheight2 < 0) this_box_storage.is_rectangle = 1;
if (xwidth == xwidth2 && yheight == yheight2) this_box_storage.is_rectangle = 1;

if (xwidth2 < 0) {
    this_box_storage.x_width2 = xwidth;
    xwidth2 = xwidth;
} else this_box_storage.x_width2 = xwidth2;

if (yheight2 < 0) {
    this_box_storage.y_height2 = yheight;
    yheight2 = yheight;
} else this_box_storage.y_height2 = yheight2;


this_box_storage.normal_vectors[0] = coords_set(0,0,1);
this_box_storage.normal_vectors[1] = coords_set(0,0,1);

// for sides with y component = 0
x_component = 2*zdepth/sqrt((xwidth-xwidth2)*(xwidth-xwidth2)+4*zdepth*zdepth);
z_component = (xwidth-xwidth2)/sqrt(4*zdepth*zdepth+(xwidth-xwidth2)*(xwidth-xwidth2));

this_box_storage.normal_vectors[2] = coords_set(x_component,0,z_component);
this_box_storage.normal_vectors[3] = coords_set(-x_component,0,z_component);

// for sides with x component = 0
y_component = 2*zdepth/sqrt((yheight-yheight2)*(yheight-yheight2)+4*zdepth*zdepth);
z_component = (yheight-yheight2)/sqrt(4*zdepth*zdepth+(yheight-yheight2)*(yheight-yheight2));

this_box_storage.normal_vectors[4] = coords_set(0,y_component,z_component);
this_box_storage.normal_vectors[5] = coords_set(0,-y_component,z_component);

this_box_volume.geometry.visualization_on = visualize;

this_box_volume.geometry.geometry_parameters.p_box_storage = &this_box_storage;

// Assign pointers to functions for intersection with the shape, checking if a point is inside the shape
if (this_box_storage.is_rectangle == 1) {
this_box_volume.geometry.intersect_function = &sample_box_intersect_simple;
this_box_volume.geometry.within_function = &r_within_box_simple;
}
else {
this_box_volume.geometry.intersect_function = &sample_box_intersect_advanced;
this_box_volume.geometry.within_function = &r_within_box_advanced;
}

this_box_volume.geometry.shell_points = &box_shell_points;
this_box_volume.geometry.mcdisplay_function = &mcdisplay_box_function;
this_box_volume.geometry.initialize_from_main_function = &initialize_box_geometry_from_main_component;
this_box_volume.geometry.process_rot_allocated = 0;

this_box_volume.geometry.copy_geometry_parameters = &allocate_box_storage_copy;

rot_copy(this_box_volume.geometry.rotation_matrix,ROT_A_CURRENT_COMP); //check how ROT_R_CURRENT_COMP would work
rot_transpose(ROT_A_CURRENT_COMP,this_box_volume.geometry.transpose_rotation_matrix);

// Initialize loggers
this_box_volume.loggers.num_elements = 0;

// packing the information into the global_geometry_element, which is then included in the global_geometry_list.
sprintf(global_geometry_element.name,NAME_CURRENT_COMP);
global_geometry_element.activation_counter = number_of_activations;
global_geometry_element.component_index = INDEX_CURRENT_COMP;
global_geometry_element.Volume = &this_box_volume; // Would be nicer if this m was a pointer, now we have the (small) data two places
add_element_to_geometry_list(&global_geometry_list,global_geometry_element);
}
#line 277397 "MACS_sample_kidney_box.c"
#undef number_of_activations
#undef mask_setting
#undef mask_string
#undef p_interact
#undef focus_r
#undef focus_xh
#undef focus_xw
#undef focus_ah
#undef focus_aw
#undef target_z
#undef target_y
#undef target_x
#undef target_index
#undef visualize
#undef yheight2
#undef xwidth2
#undef zdepth
#undef yheight
#undef xwidth
#undef priority
#undef material_string
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

  /* Initializations for component inter_analyzer_colimator_12_blade_1. */
  SIG_MESSAGE("inter_analyzer_colimator_12_blade_1 (Init)");
#define mccompcurname  inter_analyzer_colimator_12_blade_1
#define mccompcurtype  Union_box
#define mccompcurindex 612
#define loop_index mccinter_analyzer_colimator_12_blade_1_loop_index
#define this_box_volume mccinter_analyzer_colimator_12_blade_1_this_box_volume
#define global_geometry_element mccinter_analyzer_colimator_12_blade_1_global_geometry_element
#define this_box_storage mccinter_analyzer_colimator_12_blade_1_this_box_storage
#define material_string mccinter_analyzer_colimator_12_blade_1_material_string
#define priority mccinter_analyzer_colimator_12_blade_1_priority
#define xwidth mccinter_analyzer_colimator_12_blade_1_xwidth
#define yheight mccinter_analyzer_colimator_12_blade_1_yheight
#define zdepth mccinter_analyzer_colimator_12_blade_1_zdepth
#define xwidth2 mccinter_analyzer_colimator_12_blade_1_xwidth2
#define yheight2 mccinter_analyzer_colimator_12_blade_1_yheight2
#define visualize mccinter_analyzer_colimator_12_blade_1_visualize
#define target_index mccinter_analyzer_colimator_12_blade_1_target_index
#define target_x mccinter_analyzer_colimator_12_blade_1_target_x
#define target_y mccinter_analyzer_colimator_12_blade_1_target_y
#define target_z mccinter_analyzer_colimator_12_blade_1_target_z
#define focus_aw mccinter_analyzer_colimator_12_blade_1_focus_aw
#define focus_ah mccinter_analyzer_colimator_12_blade_1_focus_ah
#define focus_xw mccinter_analyzer_colimator_12_blade_1_focus_xw
#define focus_xh mccinter_analyzer_colimator_12_blade_1_focus_xh
#define focus_r mccinter_analyzer_colimator_12_blade_1_focus_r
#define p_interact mccinter_analyzer_colimator_12_blade_1_p_interact
#define mask_string mccinter_analyzer_colimator_12_blade_1_mask_string
#define mask_setting mccinter_analyzer_colimator_12_blade_1_mask_setting
#define number_of_activations mccinter_analyzer_colimator_12_blade_1_number_of_activations
#line 224 "Union_box.comp"
{
// Initializes the focusing system for this volume including input sanitation.
focus_initialize(&this_box_volume.geometry, POS_A_COMP_INDEX(INDEX_CURRENT_COMP+target_index), POS_A_CURRENT_COMP, ROT_A_CURRENT_COMP, target_index, target_x, target_y, target_z, focus_aw, focus_ah, focus_xw, focus_xh, focus_r, NAME_CURRENT_COMP);

// Input sanitation for this geometry
if (xwidth <= 0) {
  printf("\nERROR in Union_box named %s, the xwidth is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (yheight <= 0) {
  printf("\nERROR in Union_box named %s, yheight is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (zdepth <= 0) {
  printf("\nERROR in Union_box named %s, zdepth is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (xwidth2 <= 0 && xwidth2 != -1) {
  printf("\nERROR in Union_box named %s, the xwidth2 is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (yheight2 <= 0 && yheight2 != -1) {
  printf("\nERROR in Union_box named %s, yheight2 is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}

// Use sanitation
if (global_material_list.num_elements == 0) {
  printf("\nERROR: Need to define a material using Union_make_material before using a Union geometry component. \n");
  printf("       %s was defined before first use of Union_make_material.\n",NAME_CURRENT_COMP);
  exit(1);
}

this_box_volume.geometry.is_masked_volume = 0;
this_box_volume.geometry.is_exit_volume = 0;
this_box_volume.geometry.is_mask_volume = 0;
// check if the volume is a mask, if it is the material string is irelevant.
if (mask_string && strlen(mask_string) && strcmp(mask_string, "NULL") && strcmp(mask_string, "0")) {
    // A mask volume is used to limit the extend of other volumes, called the masked volumes. These are specified in the mask_string.
    // In order for a ray to enter a masked volume, it needs to be both in the region covered by that volume AND the mask volume.
    // When more than
    this_box_volume.geometry.mask_mode = 1; // Default is mask mode is ALL
    if (mask_setting && strlen(mask_setting) && strcmp(mask_setting, "NULL") && strcmp(mask_setting, "0")) {
        if (strcmp(mask_setting,"ALL") == 0 || strcmp(mask_setting,"All") == 0) this_box_volume.geometry.mask_mode = 1;
        else if (strcmp(mask_setting,"ANY") == 0 || strcmp(mask_setting,"Any") == 0) this_box_volume.geometry.mask_mode = 2;
        else {
            printf("The mask_mode of component %s is set to %s, but must be either ALL or ANY.\n",NAME_CURRENT_COMP,mask_setting);
            exit(1);
        }
    }
    
    for (loop_index=0;loop_index<global_geometry_list.num_elements;loop_index++) {
        // Add mask list
        if (1 == manual_linking_function(global_geometry_list.elements[loop_index].name,mask_string)) {
            add_element_to_int_list(&this_box_volume.geometry.mask_list,global_geometry_list.elements[loop_index].component_index);
            add_element_to_int_list(&global_geometry_list.elements[loop_index].Volume->geometry.masked_by_list,INDEX_CURRENT_COMP);
            global_geometry_list.elements[loop_index].Volume->geometry.is_masked_volume = 1;
            if (this_box_volume.geometry.mask_mode == 2)
                global_geometry_list.elements[loop_index].Volume->geometry.mask_mode = 2;
            if (this_box_volume.geometry.mask_mode == 1) {
                if (global_geometry_list.elements[loop_index].Volume->geometry.is_masked_volume == 1 && global_geometry_list.elements[loop_index].Volume->geometry.mask_mode != 2)
                    // If more than one mask is added to one volume, the ANY mode overwrites the (default) ALL mode.
                    global_geometry_list.elements[loop_index].Volume->geometry.mask_mode = 1;
            }
            
            found_geometries = 1;
        }
    }
    if (found_geometries == 0) {
        printf("The mask_string in geometry: %s did not find any of the specified volumes in the mask_string %s \n",NAME_CURRENT_COMP,mask_string);
        exit(1);
    }
    this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
    this_box_volume.p_physics->is_vacuum = 0; // Makes this volume a vacuum
    this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
    this_box_volume.p_physics->my_a = 0; // Should not be used.
    sprintf(this_box_volume.p_physics->name,"Mask");
    this_box_volume.geometry.is_mask_volume = 1;
    
    
// Read the material input, or if it lacks, use automatic linking.
} else if (material_string && strlen(material_string) && strcmp(material_string, "NULL") && strcmp(material_string, "0")) {
    // A geometry string was given, use it to determine which material
    if (0 == strcmp(material_string,"vacuum") || 0 == strcmp(material_string,"Vacuum")) {
        // One could have a global physics struct for vacuum instead of creating one for each
        this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
        this_box_volume.p_physics->is_vacuum = 1; // Makes this volume a vacuum
        this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
        this_box_volume.p_physics->my_a = 0; // Should not be used.
        sprintf(this_box_volume.p_physics->name,"Vacuum");
    } else if (0 == strcmp(material_string,"exit") || 0 == strcmp(material_string,"Exit")) {
        // One could have a global physics struct for vacuum instead of creating one for each
        this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
        this_box_volume.p_physics->is_vacuum = 1; // Makes this volume a vacuum
        this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
        this_box_volume.p_physics->my_a = 0; // Should not be used.
        this_box_volume.geometry.is_exit_volume = 1;
        sprintf(this_box_volume.p_physics->name,"Exit");
    } else {
        #ifndef MATERIAL_DETECTOR
            printf("Need to define a material before refering to it in a geometry %s.\n",NAME_CURRENT_COMP);
            exit(1);
        #endif
        for (loop_index=0;loop_index<global_material_list.num_elements;loop_index++) {
            if (0 == strcmp(material_string,global_material_list.elements[loop_index].name)) {
                this_box_volume.p_physics = global_material_list.elements[loop_index].physics;
                break;
            }
            if (loop_index == global_material_list.num_elements-1) {
            printf("\n");
            printf("ERROR: The material string \"%s\" in Union geometry \"%s\" did not match a specified material. \n",material_string,NAME_CURRENT_COMP);
            printf("       The materials available at this point (need to be defined before the geometry): \n");
            for (loop_index=0;loop_index<global_material_list.num_elements;loop_index++)
              printf("         %s\n",global_material_list.elements[loop_index].name);
            printf("\n");
            printf("       It is also possible to use one of the defualt materials avaiable: \n");
            printf("           Vacuum (for a Volume without scattering or absorption)\n");
            printf("           Exit (for a Volume where the ray exits the component if it enters)\n");
            printf("           Mask (for a Volume that masks existing volumes specified in the mask_string\n");
            exit(1);
          }
        }
    }
} else {
    // Automatic linking, simply using the last defined material.
    #ifndef MATERIAL_DETECTOR
        printf("Need to define a material before the geometry to use automatic linking %s.\n",NAME_CURRENT_COMP);
        exit(1);
    #endif
    this_box_volume.p_physics = global_material_list.elements[global_material_list.num_elements-1].physics;
}

sprintf(this_box_volume.name,NAME_CURRENT_COMP);
sprintf(this_box_volume.geometry.shape,"box");
this_box_volume.geometry.priority_value = priority;
this_box_volume.geometry.geometry_p_interact = p_interact;
// Currently the coordinates will be in absolute space.
this_box_volume.geometry.center = POS_A_CURRENT_COMP;

this_box_storage.z_depth = zdepth;
this_box_storage.x_width1 = xwidth;
this_box_storage.y_height1 = yheight;

this_box_storage.is_rectangle = 0;
if (xwidth2 < 0 && yheight2 < 0) this_box_storage.is_rectangle = 1;
if (xwidth == xwidth2 && yheight == yheight2) this_box_storage.is_rectangle = 1;

if (xwidth2 < 0) {
    this_box_storage.x_width2 = xwidth;
    xwidth2 = xwidth;
} else this_box_storage.x_width2 = xwidth2;

if (yheight2 < 0) {
    this_box_storage.y_height2 = yheight;
    yheight2 = yheight;
} else this_box_storage.y_height2 = yheight2;


this_box_storage.normal_vectors[0] = coords_set(0,0,1);
this_box_storage.normal_vectors[1] = coords_set(0,0,1);

// for sides with y component = 0
x_component = 2*zdepth/sqrt((xwidth-xwidth2)*(xwidth-xwidth2)+4*zdepth*zdepth);
z_component = (xwidth-xwidth2)/sqrt(4*zdepth*zdepth+(xwidth-xwidth2)*(xwidth-xwidth2));

this_box_storage.normal_vectors[2] = coords_set(x_component,0,z_component);
this_box_storage.normal_vectors[3] = coords_set(-x_component,0,z_component);

// for sides with x component = 0
y_component = 2*zdepth/sqrt((yheight-yheight2)*(yheight-yheight2)+4*zdepth*zdepth);
z_component = (yheight-yheight2)/sqrt(4*zdepth*zdepth+(yheight-yheight2)*(yheight-yheight2));

this_box_storage.normal_vectors[4] = coords_set(0,y_component,z_component);
this_box_storage.normal_vectors[5] = coords_set(0,-y_component,z_component);

this_box_volume.geometry.visualization_on = visualize;

this_box_volume.geometry.geometry_parameters.p_box_storage = &this_box_storage;

// Assign pointers to functions for intersection with the shape, checking if a point is inside the shape
if (this_box_storage.is_rectangle == 1) {
this_box_volume.geometry.intersect_function = &sample_box_intersect_simple;
this_box_volume.geometry.within_function = &r_within_box_simple;
}
else {
this_box_volume.geometry.intersect_function = &sample_box_intersect_advanced;
this_box_volume.geometry.within_function = &r_within_box_advanced;
}

this_box_volume.geometry.shell_points = &box_shell_points;
this_box_volume.geometry.mcdisplay_function = &mcdisplay_box_function;
this_box_volume.geometry.initialize_from_main_function = &initialize_box_geometry_from_main_component;
this_box_volume.geometry.process_rot_allocated = 0;

this_box_volume.geometry.copy_geometry_parameters = &allocate_box_storage_copy;

rot_copy(this_box_volume.geometry.rotation_matrix,ROT_A_CURRENT_COMP); //check how ROT_R_CURRENT_COMP would work
rot_transpose(ROT_A_CURRENT_COMP,this_box_volume.geometry.transpose_rotation_matrix);

// Initialize loggers
this_box_volume.loggers.num_elements = 0;

// packing the information into the global_geometry_element, which is then included in the global_geometry_list.
sprintf(global_geometry_element.name,NAME_CURRENT_COMP);
global_geometry_element.activation_counter = number_of_activations;
global_geometry_element.component_index = INDEX_CURRENT_COMP;
global_geometry_element.Volume = &this_box_volume; // Would be nicer if this m was a pointer, now we have the (small) data two places
add_element_to_geometry_list(&global_geometry_list,global_geometry_element);
}
#line 277667 "MACS_sample_kidney_box.c"
#undef number_of_activations
#undef mask_setting
#undef mask_string
#undef p_interact
#undef focus_r
#undef focus_xh
#undef focus_xw
#undef focus_ah
#undef focus_aw
#undef target_z
#undef target_y
#undef target_x
#undef target_index
#undef visualize
#undef yheight2
#undef xwidth2
#undef zdepth
#undef yheight
#undef xwidth
#undef priority
#undef material_string
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

  /* Initializations for component inter_analyzer_colimator_12_blade_2. */
  SIG_MESSAGE("inter_analyzer_colimator_12_blade_2 (Init)");
#define mccompcurname  inter_analyzer_colimator_12_blade_2
#define mccompcurtype  Union_box
#define mccompcurindex 613
#define loop_index mccinter_analyzer_colimator_12_blade_2_loop_index
#define this_box_volume mccinter_analyzer_colimator_12_blade_2_this_box_volume
#define global_geometry_element mccinter_analyzer_colimator_12_blade_2_global_geometry_element
#define this_box_storage mccinter_analyzer_colimator_12_blade_2_this_box_storage
#define material_string mccinter_analyzer_colimator_12_blade_2_material_string
#define priority mccinter_analyzer_colimator_12_blade_2_priority
#define xwidth mccinter_analyzer_colimator_12_blade_2_xwidth
#define yheight mccinter_analyzer_colimator_12_blade_2_yheight
#define zdepth mccinter_analyzer_colimator_12_blade_2_zdepth
#define xwidth2 mccinter_analyzer_colimator_12_blade_2_xwidth2
#define yheight2 mccinter_analyzer_colimator_12_blade_2_yheight2
#define visualize mccinter_analyzer_colimator_12_blade_2_visualize
#define target_index mccinter_analyzer_colimator_12_blade_2_target_index
#define target_x mccinter_analyzer_colimator_12_blade_2_target_x
#define target_y mccinter_analyzer_colimator_12_blade_2_target_y
#define target_z mccinter_analyzer_colimator_12_blade_2_target_z
#define focus_aw mccinter_analyzer_colimator_12_blade_2_focus_aw
#define focus_ah mccinter_analyzer_colimator_12_blade_2_focus_ah
#define focus_xw mccinter_analyzer_colimator_12_blade_2_focus_xw
#define focus_xh mccinter_analyzer_colimator_12_blade_2_focus_xh
#define focus_r mccinter_analyzer_colimator_12_blade_2_focus_r
#define p_interact mccinter_analyzer_colimator_12_blade_2_p_interact
#define mask_string mccinter_analyzer_colimator_12_blade_2_mask_string
#define mask_setting mccinter_analyzer_colimator_12_blade_2_mask_setting
#define number_of_activations mccinter_analyzer_colimator_12_blade_2_number_of_activations
#line 224 "Union_box.comp"
{
// Initializes the focusing system for this volume including input sanitation.
focus_initialize(&this_box_volume.geometry, POS_A_COMP_INDEX(INDEX_CURRENT_COMP+target_index), POS_A_CURRENT_COMP, ROT_A_CURRENT_COMP, target_index, target_x, target_y, target_z, focus_aw, focus_ah, focus_xw, focus_xh, focus_r, NAME_CURRENT_COMP);

// Input sanitation for this geometry
if (xwidth <= 0) {
  printf("\nERROR in Union_box named %s, the xwidth is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (yheight <= 0) {
  printf("\nERROR in Union_box named %s, yheight is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (zdepth <= 0) {
  printf("\nERROR in Union_box named %s, zdepth is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (xwidth2 <= 0 && xwidth2 != -1) {
  printf("\nERROR in Union_box named %s, the xwidth2 is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (yheight2 <= 0 && yheight2 != -1) {
  printf("\nERROR in Union_box named %s, yheight2 is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}

// Use sanitation
if (global_material_list.num_elements == 0) {
  printf("\nERROR: Need to define a material using Union_make_material before using a Union geometry component. \n");
  printf("       %s was defined before first use of Union_make_material.\n",NAME_CURRENT_COMP);
  exit(1);
}

this_box_volume.geometry.is_masked_volume = 0;
this_box_volume.geometry.is_exit_volume = 0;
this_box_volume.geometry.is_mask_volume = 0;
// check if the volume is a mask, if it is the material string is irelevant.
if (mask_string && strlen(mask_string) && strcmp(mask_string, "NULL") && strcmp(mask_string, "0")) {
    // A mask volume is used to limit the extend of other volumes, called the masked volumes. These are specified in the mask_string.
    // In order for a ray to enter a masked volume, it needs to be both in the region covered by that volume AND the mask volume.
    // When more than
    this_box_volume.geometry.mask_mode = 1; // Default is mask mode is ALL
    if (mask_setting && strlen(mask_setting) && strcmp(mask_setting, "NULL") && strcmp(mask_setting, "0")) {
        if (strcmp(mask_setting,"ALL") == 0 || strcmp(mask_setting,"All") == 0) this_box_volume.geometry.mask_mode = 1;
        else if (strcmp(mask_setting,"ANY") == 0 || strcmp(mask_setting,"Any") == 0) this_box_volume.geometry.mask_mode = 2;
        else {
            printf("The mask_mode of component %s is set to %s, but must be either ALL or ANY.\n",NAME_CURRENT_COMP,mask_setting);
            exit(1);
        }
    }
    
    for (loop_index=0;loop_index<global_geometry_list.num_elements;loop_index++) {
        // Add mask list
        if (1 == manual_linking_function(global_geometry_list.elements[loop_index].name,mask_string)) {
            add_element_to_int_list(&this_box_volume.geometry.mask_list,global_geometry_list.elements[loop_index].component_index);
            add_element_to_int_list(&global_geometry_list.elements[loop_index].Volume->geometry.masked_by_list,INDEX_CURRENT_COMP);
            global_geometry_list.elements[loop_index].Volume->geometry.is_masked_volume = 1;
            if (this_box_volume.geometry.mask_mode == 2)
                global_geometry_list.elements[loop_index].Volume->geometry.mask_mode = 2;
            if (this_box_volume.geometry.mask_mode == 1) {
                if (global_geometry_list.elements[loop_index].Volume->geometry.is_masked_volume == 1 && global_geometry_list.elements[loop_index].Volume->geometry.mask_mode != 2)
                    // If more than one mask is added to one volume, the ANY mode overwrites the (default) ALL mode.
                    global_geometry_list.elements[loop_index].Volume->geometry.mask_mode = 1;
            }
            
            found_geometries = 1;
        }
    }
    if (found_geometries == 0) {
        printf("The mask_string in geometry: %s did not find any of the specified volumes in the mask_string %s \n",NAME_CURRENT_COMP,mask_string);
        exit(1);
    }
    this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
    this_box_volume.p_physics->is_vacuum = 0; // Makes this volume a vacuum
    this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
    this_box_volume.p_physics->my_a = 0; // Should not be used.
    sprintf(this_box_volume.p_physics->name,"Mask");
    this_box_volume.geometry.is_mask_volume = 1;
    
    
// Read the material input, or if it lacks, use automatic linking.
} else if (material_string && strlen(material_string) && strcmp(material_string, "NULL") && strcmp(material_string, "0")) {
    // A geometry string was given, use it to determine which material
    if (0 == strcmp(material_string,"vacuum") || 0 == strcmp(material_string,"Vacuum")) {
        // One could have a global physics struct for vacuum instead of creating one for each
        this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
        this_box_volume.p_physics->is_vacuum = 1; // Makes this volume a vacuum
        this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
        this_box_volume.p_physics->my_a = 0; // Should not be used.
        sprintf(this_box_volume.p_physics->name,"Vacuum");
    } else if (0 == strcmp(material_string,"exit") || 0 == strcmp(material_string,"Exit")) {
        // One could have a global physics struct for vacuum instead of creating one for each
        this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
        this_box_volume.p_physics->is_vacuum = 1; // Makes this volume a vacuum
        this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
        this_box_volume.p_physics->my_a = 0; // Should not be used.
        this_box_volume.geometry.is_exit_volume = 1;
        sprintf(this_box_volume.p_physics->name,"Exit");
    } else {
        #ifndef MATERIAL_DETECTOR
            printf("Need to define a material before refering to it in a geometry %s.\n",NAME_CURRENT_COMP);
            exit(1);
        #endif
        for (loop_index=0;loop_index<global_material_list.num_elements;loop_index++) {
            if (0 == strcmp(material_string,global_material_list.elements[loop_index].name)) {
                this_box_volume.p_physics = global_material_list.elements[loop_index].physics;
                break;
            }
            if (loop_index == global_material_list.num_elements-1) {
            printf("\n");
            printf("ERROR: The material string \"%s\" in Union geometry \"%s\" did not match a specified material. \n",material_string,NAME_CURRENT_COMP);
            printf("       The materials available at this point (need to be defined before the geometry): \n");
            for (loop_index=0;loop_index<global_material_list.num_elements;loop_index++)
              printf("         %s\n",global_material_list.elements[loop_index].name);
            printf("\n");
            printf("       It is also possible to use one of the defualt materials avaiable: \n");
            printf("           Vacuum (for a Volume without scattering or absorption)\n");
            printf("           Exit (for a Volume where the ray exits the component if it enters)\n");
            printf("           Mask (for a Volume that masks existing volumes specified in the mask_string\n");
            exit(1);
          }
        }
    }
} else {
    // Automatic linking, simply using the last defined material.
    #ifndef MATERIAL_DETECTOR
        printf("Need to define a material before the geometry to use automatic linking %s.\n",NAME_CURRENT_COMP);
        exit(1);
    #endif
    this_box_volume.p_physics = global_material_list.elements[global_material_list.num_elements-1].physics;
}

sprintf(this_box_volume.name,NAME_CURRENT_COMP);
sprintf(this_box_volume.geometry.shape,"box");
this_box_volume.geometry.priority_value = priority;
this_box_volume.geometry.geometry_p_interact = p_interact;
// Currently the coordinates will be in absolute space.
this_box_volume.geometry.center = POS_A_CURRENT_COMP;

this_box_storage.z_depth = zdepth;
this_box_storage.x_width1 = xwidth;
this_box_storage.y_height1 = yheight;

this_box_storage.is_rectangle = 0;
if (xwidth2 < 0 && yheight2 < 0) this_box_storage.is_rectangle = 1;
if (xwidth == xwidth2 && yheight == yheight2) this_box_storage.is_rectangle = 1;

if (xwidth2 < 0) {
    this_box_storage.x_width2 = xwidth;
    xwidth2 = xwidth;
} else this_box_storage.x_width2 = xwidth2;

if (yheight2 < 0) {
    this_box_storage.y_height2 = yheight;
    yheight2 = yheight;
} else this_box_storage.y_height2 = yheight2;


this_box_storage.normal_vectors[0] = coords_set(0,0,1);
this_box_storage.normal_vectors[1] = coords_set(0,0,1);

// for sides with y component = 0
x_component = 2*zdepth/sqrt((xwidth-xwidth2)*(xwidth-xwidth2)+4*zdepth*zdepth);
z_component = (xwidth-xwidth2)/sqrt(4*zdepth*zdepth+(xwidth-xwidth2)*(xwidth-xwidth2));

this_box_storage.normal_vectors[2] = coords_set(x_component,0,z_component);
this_box_storage.normal_vectors[3] = coords_set(-x_component,0,z_component);

// for sides with x component = 0
y_component = 2*zdepth/sqrt((yheight-yheight2)*(yheight-yheight2)+4*zdepth*zdepth);
z_component = (yheight-yheight2)/sqrt(4*zdepth*zdepth+(yheight-yheight2)*(yheight-yheight2));

this_box_storage.normal_vectors[4] = coords_set(0,y_component,z_component);
this_box_storage.normal_vectors[5] = coords_set(0,-y_component,z_component);

this_box_volume.geometry.visualization_on = visualize;

this_box_volume.geometry.geometry_parameters.p_box_storage = &this_box_storage;

// Assign pointers to functions for intersection with the shape, checking if a point is inside the shape
if (this_box_storage.is_rectangle == 1) {
this_box_volume.geometry.intersect_function = &sample_box_intersect_simple;
this_box_volume.geometry.within_function = &r_within_box_simple;
}
else {
this_box_volume.geometry.intersect_function = &sample_box_intersect_advanced;
this_box_volume.geometry.within_function = &r_within_box_advanced;
}

this_box_volume.geometry.shell_points = &box_shell_points;
this_box_volume.geometry.mcdisplay_function = &mcdisplay_box_function;
this_box_volume.geometry.initialize_from_main_function = &initialize_box_geometry_from_main_component;
this_box_volume.geometry.process_rot_allocated = 0;

this_box_volume.geometry.copy_geometry_parameters = &allocate_box_storage_copy;

rot_copy(this_box_volume.geometry.rotation_matrix,ROT_A_CURRENT_COMP); //check how ROT_R_CURRENT_COMP would work
rot_transpose(ROT_A_CURRENT_COMP,this_box_volume.geometry.transpose_rotation_matrix);

// Initialize loggers
this_box_volume.loggers.num_elements = 0;

// packing the information into the global_geometry_element, which is then included in the global_geometry_list.
sprintf(global_geometry_element.name,NAME_CURRENT_COMP);
global_geometry_element.activation_counter = number_of_activations;
global_geometry_element.component_index = INDEX_CURRENT_COMP;
global_geometry_element.Volume = &this_box_volume; // Would be nicer if this m was a pointer, now we have the (small) data two places
add_element_to_geometry_list(&global_geometry_list,global_geometry_element);
}
#line 277937 "MACS_sample_kidney_box.c"
#undef number_of_activations
#undef mask_setting
#undef mask_string
#undef p_interact
#undef focus_r
#undef focus_xh
#undef focus_xw
#undef focus_ah
#undef focus_aw
#undef target_z
#undef target_y
#undef target_x
#undef target_index
#undef visualize
#undef yheight2
#undef xwidth2
#undef zdepth
#undef yheight
#undef xwidth
#undef priority
#undef material_string
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

  /* Initializations for component inter_analyzer_colimator_12_blade_3. */
  SIG_MESSAGE("inter_analyzer_colimator_12_blade_3 (Init)");
#define mccompcurname  inter_analyzer_colimator_12_blade_3
#define mccompcurtype  Union_box
#define mccompcurindex 614
#define loop_index mccinter_analyzer_colimator_12_blade_3_loop_index
#define this_box_volume mccinter_analyzer_colimator_12_blade_3_this_box_volume
#define global_geometry_element mccinter_analyzer_colimator_12_blade_3_global_geometry_element
#define this_box_storage mccinter_analyzer_colimator_12_blade_3_this_box_storage
#define material_string mccinter_analyzer_colimator_12_blade_3_material_string
#define priority mccinter_analyzer_colimator_12_blade_3_priority
#define xwidth mccinter_analyzer_colimator_12_blade_3_xwidth
#define yheight mccinter_analyzer_colimator_12_blade_3_yheight
#define zdepth mccinter_analyzer_colimator_12_blade_3_zdepth
#define xwidth2 mccinter_analyzer_colimator_12_blade_3_xwidth2
#define yheight2 mccinter_analyzer_colimator_12_blade_3_yheight2
#define visualize mccinter_analyzer_colimator_12_blade_3_visualize
#define target_index mccinter_analyzer_colimator_12_blade_3_target_index
#define target_x mccinter_analyzer_colimator_12_blade_3_target_x
#define target_y mccinter_analyzer_colimator_12_blade_3_target_y
#define target_z mccinter_analyzer_colimator_12_blade_3_target_z
#define focus_aw mccinter_analyzer_colimator_12_blade_3_focus_aw
#define focus_ah mccinter_analyzer_colimator_12_blade_3_focus_ah
#define focus_xw mccinter_analyzer_colimator_12_blade_3_focus_xw
#define focus_xh mccinter_analyzer_colimator_12_blade_3_focus_xh
#define focus_r mccinter_analyzer_colimator_12_blade_3_focus_r
#define p_interact mccinter_analyzer_colimator_12_blade_3_p_interact
#define mask_string mccinter_analyzer_colimator_12_blade_3_mask_string
#define mask_setting mccinter_analyzer_colimator_12_blade_3_mask_setting
#define number_of_activations mccinter_analyzer_colimator_12_blade_3_number_of_activations
#line 224 "Union_box.comp"
{
// Initializes the focusing system for this volume including input sanitation.
focus_initialize(&this_box_volume.geometry, POS_A_COMP_INDEX(INDEX_CURRENT_COMP+target_index), POS_A_CURRENT_COMP, ROT_A_CURRENT_COMP, target_index, target_x, target_y, target_z, focus_aw, focus_ah, focus_xw, focus_xh, focus_r, NAME_CURRENT_COMP);

// Input sanitation for this geometry
if (xwidth <= 0) {
  printf("\nERROR in Union_box named %s, the xwidth is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (yheight <= 0) {
  printf("\nERROR in Union_box named %s, yheight is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (zdepth <= 0) {
  printf("\nERROR in Union_box named %s, zdepth is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (xwidth2 <= 0 && xwidth2 != -1) {
  printf("\nERROR in Union_box named %s, the xwidth2 is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (yheight2 <= 0 && yheight2 != -1) {
  printf("\nERROR in Union_box named %s, yheight2 is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}

// Use sanitation
if (global_material_list.num_elements == 0) {
  printf("\nERROR: Need to define a material using Union_make_material before using a Union geometry component. \n");
  printf("       %s was defined before first use of Union_make_material.\n",NAME_CURRENT_COMP);
  exit(1);
}

this_box_volume.geometry.is_masked_volume = 0;
this_box_volume.geometry.is_exit_volume = 0;
this_box_volume.geometry.is_mask_volume = 0;
// check if the volume is a mask, if it is the material string is irelevant.
if (mask_string && strlen(mask_string) && strcmp(mask_string, "NULL") && strcmp(mask_string, "0")) {
    // A mask volume is used to limit the extend of other volumes, called the masked volumes. These are specified in the mask_string.
    // In order for a ray to enter a masked volume, it needs to be both in the region covered by that volume AND the mask volume.
    // When more than
    this_box_volume.geometry.mask_mode = 1; // Default is mask mode is ALL
    if (mask_setting && strlen(mask_setting) && strcmp(mask_setting, "NULL") && strcmp(mask_setting, "0")) {
        if (strcmp(mask_setting,"ALL") == 0 || strcmp(mask_setting,"All") == 0) this_box_volume.geometry.mask_mode = 1;
        else if (strcmp(mask_setting,"ANY") == 0 || strcmp(mask_setting,"Any") == 0) this_box_volume.geometry.mask_mode = 2;
        else {
            printf("The mask_mode of component %s is set to %s, but must be either ALL or ANY.\n",NAME_CURRENT_COMP,mask_setting);
            exit(1);
        }
    }
    
    for (loop_index=0;loop_index<global_geometry_list.num_elements;loop_index++) {
        // Add mask list
        if (1 == manual_linking_function(global_geometry_list.elements[loop_index].name,mask_string)) {
            add_element_to_int_list(&this_box_volume.geometry.mask_list,global_geometry_list.elements[loop_index].component_index);
            add_element_to_int_list(&global_geometry_list.elements[loop_index].Volume->geometry.masked_by_list,INDEX_CURRENT_COMP);
            global_geometry_list.elements[loop_index].Volume->geometry.is_masked_volume = 1;
            if (this_box_volume.geometry.mask_mode == 2)
                global_geometry_list.elements[loop_index].Volume->geometry.mask_mode = 2;
            if (this_box_volume.geometry.mask_mode == 1) {
                if (global_geometry_list.elements[loop_index].Volume->geometry.is_masked_volume == 1 && global_geometry_list.elements[loop_index].Volume->geometry.mask_mode != 2)
                    // If more than one mask is added to one volume, the ANY mode overwrites the (default) ALL mode.
                    global_geometry_list.elements[loop_index].Volume->geometry.mask_mode = 1;
            }
            
            found_geometries = 1;
        }
    }
    if (found_geometries == 0) {
        printf("The mask_string in geometry: %s did not find any of the specified volumes in the mask_string %s \n",NAME_CURRENT_COMP,mask_string);
        exit(1);
    }
    this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
    this_box_volume.p_physics->is_vacuum = 0; // Makes this volume a vacuum
    this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
    this_box_volume.p_physics->my_a = 0; // Should not be used.
    sprintf(this_box_volume.p_physics->name,"Mask");
    this_box_volume.geometry.is_mask_volume = 1;
    
    
// Read the material input, or if it lacks, use automatic linking.
} else if (material_string && strlen(material_string) && strcmp(material_string, "NULL") && strcmp(material_string, "0")) {
    // A geometry string was given, use it to determine which material
    if (0 == strcmp(material_string,"vacuum") || 0 == strcmp(material_string,"Vacuum")) {
        // One could have a global physics struct for vacuum instead of creating one for each
        this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
        this_box_volume.p_physics->is_vacuum = 1; // Makes this volume a vacuum
        this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
        this_box_volume.p_physics->my_a = 0; // Should not be used.
        sprintf(this_box_volume.p_physics->name,"Vacuum");
    } else if (0 == strcmp(material_string,"exit") || 0 == strcmp(material_string,"Exit")) {
        // One could have a global physics struct for vacuum instead of creating one for each
        this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
        this_box_volume.p_physics->is_vacuum = 1; // Makes this volume a vacuum
        this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
        this_box_volume.p_physics->my_a = 0; // Should not be used.
        this_box_volume.geometry.is_exit_volume = 1;
        sprintf(this_box_volume.p_physics->name,"Exit");
    } else {
        #ifndef MATERIAL_DETECTOR
            printf("Need to define a material before refering to it in a geometry %s.\n",NAME_CURRENT_COMP);
            exit(1);
        #endif
        for (loop_index=0;loop_index<global_material_list.num_elements;loop_index++) {
            if (0 == strcmp(material_string,global_material_list.elements[loop_index].name)) {
                this_box_volume.p_physics = global_material_list.elements[loop_index].physics;
                break;
            }
            if (loop_index == global_material_list.num_elements-1) {
            printf("\n");
            printf("ERROR: The material string \"%s\" in Union geometry \"%s\" did not match a specified material. \n",material_string,NAME_CURRENT_COMP);
            printf("       The materials available at this point (need to be defined before the geometry): \n");
            for (loop_index=0;loop_index<global_material_list.num_elements;loop_index++)
              printf("         %s\n",global_material_list.elements[loop_index].name);
            printf("\n");
            printf("       It is also possible to use one of the defualt materials avaiable: \n");
            printf("           Vacuum (for a Volume without scattering or absorption)\n");
            printf("           Exit (for a Volume where the ray exits the component if it enters)\n");
            printf("           Mask (for a Volume that masks existing volumes specified in the mask_string\n");
            exit(1);
          }
        }
    }
} else {
    // Automatic linking, simply using the last defined material.
    #ifndef MATERIAL_DETECTOR
        printf("Need to define a material before the geometry to use automatic linking %s.\n",NAME_CURRENT_COMP);
        exit(1);
    #endif
    this_box_volume.p_physics = global_material_list.elements[global_material_list.num_elements-1].physics;
}

sprintf(this_box_volume.name,NAME_CURRENT_COMP);
sprintf(this_box_volume.geometry.shape,"box");
this_box_volume.geometry.priority_value = priority;
this_box_volume.geometry.geometry_p_interact = p_interact;
// Currently the coordinates will be in absolute space.
this_box_volume.geometry.center = POS_A_CURRENT_COMP;

this_box_storage.z_depth = zdepth;
this_box_storage.x_width1 = xwidth;
this_box_storage.y_height1 = yheight;

this_box_storage.is_rectangle = 0;
if (xwidth2 < 0 && yheight2 < 0) this_box_storage.is_rectangle = 1;
if (xwidth == xwidth2 && yheight == yheight2) this_box_storage.is_rectangle = 1;

if (xwidth2 < 0) {
    this_box_storage.x_width2 = xwidth;
    xwidth2 = xwidth;
} else this_box_storage.x_width2 = xwidth2;

if (yheight2 < 0) {
    this_box_storage.y_height2 = yheight;
    yheight2 = yheight;
} else this_box_storage.y_height2 = yheight2;


this_box_storage.normal_vectors[0] = coords_set(0,0,1);
this_box_storage.normal_vectors[1] = coords_set(0,0,1);

// for sides with y component = 0
x_component = 2*zdepth/sqrt((xwidth-xwidth2)*(xwidth-xwidth2)+4*zdepth*zdepth);
z_component = (xwidth-xwidth2)/sqrt(4*zdepth*zdepth+(xwidth-xwidth2)*(xwidth-xwidth2));

this_box_storage.normal_vectors[2] = coords_set(x_component,0,z_component);
this_box_storage.normal_vectors[3] = coords_set(-x_component,0,z_component);

// for sides with x component = 0
y_component = 2*zdepth/sqrt((yheight-yheight2)*(yheight-yheight2)+4*zdepth*zdepth);
z_component = (yheight-yheight2)/sqrt(4*zdepth*zdepth+(yheight-yheight2)*(yheight-yheight2));

this_box_storage.normal_vectors[4] = coords_set(0,y_component,z_component);
this_box_storage.normal_vectors[5] = coords_set(0,-y_component,z_component);

this_box_volume.geometry.visualization_on = visualize;

this_box_volume.geometry.geometry_parameters.p_box_storage = &this_box_storage;

// Assign pointers to functions for intersection with the shape, checking if a point is inside the shape
if (this_box_storage.is_rectangle == 1) {
this_box_volume.geometry.intersect_function = &sample_box_intersect_simple;
this_box_volume.geometry.within_function = &r_within_box_simple;
}
else {
this_box_volume.geometry.intersect_function = &sample_box_intersect_advanced;
this_box_volume.geometry.within_function = &r_within_box_advanced;
}

this_box_volume.geometry.shell_points = &box_shell_points;
this_box_volume.geometry.mcdisplay_function = &mcdisplay_box_function;
this_box_volume.geometry.initialize_from_main_function = &initialize_box_geometry_from_main_component;
this_box_volume.geometry.process_rot_allocated = 0;

this_box_volume.geometry.copy_geometry_parameters = &allocate_box_storage_copy;

rot_copy(this_box_volume.geometry.rotation_matrix,ROT_A_CURRENT_COMP); //check how ROT_R_CURRENT_COMP would work
rot_transpose(ROT_A_CURRENT_COMP,this_box_volume.geometry.transpose_rotation_matrix);

// Initialize loggers
this_box_volume.loggers.num_elements = 0;

// packing the information into the global_geometry_element, which is then included in the global_geometry_list.
sprintf(global_geometry_element.name,NAME_CURRENT_COMP);
global_geometry_element.activation_counter = number_of_activations;
global_geometry_element.component_index = INDEX_CURRENT_COMP;
global_geometry_element.Volume = &this_box_volume; // Would be nicer if this m was a pointer, now we have the (small) data two places
add_element_to_geometry_list(&global_geometry_list,global_geometry_element);
}
#line 278207 "MACS_sample_kidney_box.c"
#undef number_of_activations
#undef mask_setting
#undef mask_string
#undef p_interact
#undef focus_r
#undef focus_xh
#undef focus_xw
#undef focus_ah
#undef focus_aw
#undef target_z
#undef target_y
#undef target_x
#undef target_index
#undef visualize
#undef yheight2
#undef xwidth2
#undef zdepth
#undef yheight
#undef xwidth
#undef priority
#undef material_string
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

  /* Initializations for component inter_analyzer_colimator_12_blade_4. */
  SIG_MESSAGE("inter_analyzer_colimator_12_blade_4 (Init)");
#define mccompcurname  inter_analyzer_colimator_12_blade_4
#define mccompcurtype  Union_box
#define mccompcurindex 615
#define loop_index mccinter_analyzer_colimator_12_blade_4_loop_index
#define this_box_volume mccinter_analyzer_colimator_12_blade_4_this_box_volume
#define global_geometry_element mccinter_analyzer_colimator_12_blade_4_global_geometry_element
#define this_box_storage mccinter_analyzer_colimator_12_blade_4_this_box_storage
#define material_string mccinter_analyzer_colimator_12_blade_4_material_string
#define priority mccinter_analyzer_colimator_12_blade_4_priority
#define xwidth mccinter_analyzer_colimator_12_blade_4_xwidth
#define yheight mccinter_analyzer_colimator_12_blade_4_yheight
#define zdepth mccinter_analyzer_colimator_12_blade_4_zdepth
#define xwidth2 mccinter_analyzer_colimator_12_blade_4_xwidth2
#define yheight2 mccinter_analyzer_colimator_12_blade_4_yheight2
#define visualize mccinter_analyzer_colimator_12_blade_4_visualize
#define target_index mccinter_analyzer_colimator_12_blade_4_target_index
#define target_x mccinter_analyzer_colimator_12_blade_4_target_x
#define target_y mccinter_analyzer_colimator_12_blade_4_target_y
#define target_z mccinter_analyzer_colimator_12_blade_4_target_z
#define focus_aw mccinter_analyzer_colimator_12_blade_4_focus_aw
#define focus_ah mccinter_analyzer_colimator_12_blade_4_focus_ah
#define focus_xw mccinter_analyzer_colimator_12_blade_4_focus_xw
#define focus_xh mccinter_analyzer_colimator_12_blade_4_focus_xh
#define focus_r mccinter_analyzer_colimator_12_blade_4_focus_r
#define p_interact mccinter_analyzer_colimator_12_blade_4_p_interact
#define mask_string mccinter_analyzer_colimator_12_blade_4_mask_string
#define mask_setting mccinter_analyzer_colimator_12_blade_4_mask_setting
#define number_of_activations mccinter_analyzer_colimator_12_blade_4_number_of_activations
#line 224 "Union_box.comp"
{
// Initializes the focusing system for this volume including input sanitation.
focus_initialize(&this_box_volume.geometry, POS_A_COMP_INDEX(INDEX_CURRENT_COMP+target_index), POS_A_CURRENT_COMP, ROT_A_CURRENT_COMP, target_index, target_x, target_y, target_z, focus_aw, focus_ah, focus_xw, focus_xh, focus_r, NAME_CURRENT_COMP);

// Input sanitation for this geometry
if (xwidth <= 0) {
  printf("\nERROR in Union_box named %s, the xwidth is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (yheight <= 0) {
  printf("\nERROR in Union_box named %s, yheight is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (zdepth <= 0) {
  printf("\nERROR in Union_box named %s, zdepth is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (xwidth2 <= 0 && xwidth2 != -1) {
  printf("\nERROR in Union_box named %s, the xwidth2 is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (yheight2 <= 0 && yheight2 != -1) {
  printf("\nERROR in Union_box named %s, yheight2 is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}

// Use sanitation
if (global_material_list.num_elements == 0) {
  printf("\nERROR: Need to define a material using Union_make_material before using a Union geometry component. \n");
  printf("       %s was defined before first use of Union_make_material.\n",NAME_CURRENT_COMP);
  exit(1);
}

this_box_volume.geometry.is_masked_volume = 0;
this_box_volume.geometry.is_exit_volume = 0;
this_box_volume.geometry.is_mask_volume = 0;
// check if the volume is a mask, if it is the material string is irelevant.
if (mask_string && strlen(mask_string) && strcmp(mask_string, "NULL") && strcmp(mask_string, "0")) {
    // A mask volume is used to limit the extend of other volumes, called the masked volumes. These are specified in the mask_string.
    // In order for a ray to enter a masked volume, it needs to be both in the region covered by that volume AND the mask volume.
    // When more than
    this_box_volume.geometry.mask_mode = 1; // Default is mask mode is ALL
    if (mask_setting && strlen(mask_setting) && strcmp(mask_setting, "NULL") && strcmp(mask_setting, "0")) {
        if (strcmp(mask_setting,"ALL") == 0 || strcmp(mask_setting,"All") == 0) this_box_volume.geometry.mask_mode = 1;
        else if (strcmp(mask_setting,"ANY") == 0 || strcmp(mask_setting,"Any") == 0) this_box_volume.geometry.mask_mode = 2;
        else {
            printf("The mask_mode of component %s is set to %s, but must be either ALL or ANY.\n",NAME_CURRENT_COMP,mask_setting);
            exit(1);
        }
    }
    
    for (loop_index=0;loop_index<global_geometry_list.num_elements;loop_index++) {
        // Add mask list
        if (1 == manual_linking_function(global_geometry_list.elements[loop_index].name,mask_string)) {
            add_element_to_int_list(&this_box_volume.geometry.mask_list,global_geometry_list.elements[loop_index].component_index);
            add_element_to_int_list(&global_geometry_list.elements[loop_index].Volume->geometry.masked_by_list,INDEX_CURRENT_COMP);
            global_geometry_list.elements[loop_index].Volume->geometry.is_masked_volume = 1;
            if (this_box_volume.geometry.mask_mode == 2)
                global_geometry_list.elements[loop_index].Volume->geometry.mask_mode = 2;
            if (this_box_volume.geometry.mask_mode == 1) {
                if (global_geometry_list.elements[loop_index].Volume->geometry.is_masked_volume == 1 && global_geometry_list.elements[loop_index].Volume->geometry.mask_mode != 2)
                    // If more than one mask is added to one volume, the ANY mode overwrites the (default) ALL mode.
                    global_geometry_list.elements[loop_index].Volume->geometry.mask_mode = 1;
            }
            
            found_geometries = 1;
        }
    }
    if (found_geometries == 0) {
        printf("The mask_string in geometry: %s did not find any of the specified volumes in the mask_string %s \n",NAME_CURRENT_COMP,mask_string);
        exit(1);
    }
    this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
    this_box_volume.p_physics->is_vacuum = 0; // Makes this volume a vacuum
    this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
    this_box_volume.p_physics->my_a = 0; // Should not be used.
    sprintf(this_box_volume.p_physics->name,"Mask");
    this_box_volume.geometry.is_mask_volume = 1;
    
    
// Read the material input, or if it lacks, use automatic linking.
} else if (material_string && strlen(material_string) && strcmp(material_string, "NULL") && strcmp(material_string, "0")) {
    // A geometry string was given, use it to determine which material
    if (0 == strcmp(material_string,"vacuum") || 0 == strcmp(material_string,"Vacuum")) {
        // One could have a global physics struct for vacuum instead of creating one for each
        this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
        this_box_volume.p_physics->is_vacuum = 1; // Makes this volume a vacuum
        this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
        this_box_volume.p_physics->my_a = 0; // Should not be used.
        sprintf(this_box_volume.p_physics->name,"Vacuum");
    } else if (0 == strcmp(material_string,"exit") || 0 == strcmp(material_string,"Exit")) {
        // One could have a global physics struct for vacuum instead of creating one for each
        this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
        this_box_volume.p_physics->is_vacuum = 1; // Makes this volume a vacuum
        this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
        this_box_volume.p_physics->my_a = 0; // Should not be used.
        this_box_volume.geometry.is_exit_volume = 1;
        sprintf(this_box_volume.p_physics->name,"Exit");
    } else {
        #ifndef MATERIAL_DETECTOR
            printf("Need to define a material before refering to it in a geometry %s.\n",NAME_CURRENT_COMP);
            exit(1);
        #endif
        for (loop_index=0;loop_index<global_material_list.num_elements;loop_index++) {
            if (0 == strcmp(material_string,global_material_list.elements[loop_index].name)) {
                this_box_volume.p_physics = global_material_list.elements[loop_index].physics;
                break;
            }
            if (loop_index == global_material_list.num_elements-1) {
            printf("\n");
            printf("ERROR: The material string \"%s\" in Union geometry \"%s\" did not match a specified material. \n",material_string,NAME_CURRENT_COMP);
            printf("       The materials available at this point (need to be defined before the geometry): \n");
            for (loop_index=0;loop_index<global_material_list.num_elements;loop_index++)
              printf("         %s\n",global_material_list.elements[loop_index].name);
            printf("\n");
            printf("       It is also possible to use one of the defualt materials avaiable: \n");
            printf("           Vacuum (for a Volume without scattering or absorption)\n");
            printf("           Exit (for a Volume where the ray exits the component if it enters)\n");
            printf("           Mask (for a Volume that masks existing volumes specified in the mask_string\n");
            exit(1);
          }
        }
    }
} else {
    // Automatic linking, simply using the last defined material.
    #ifndef MATERIAL_DETECTOR
        printf("Need to define a material before the geometry to use automatic linking %s.\n",NAME_CURRENT_COMP);
        exit(1);
    #endif
    this_box_volume.p_physics = global_material_list.elements[global_material_list.num_elements-1].physics;
}

sprintf(this_box_volume.name,NAME_CURRENT_COMP);
sprintf(this_box_volume.geometry.shape,"box");
this_box_volume.geometry.priority_value = priority;
this_box_volume.geometry.geometry_p_interact = p_interact;
// Currently the coordinates will be in absolute space.
this_box_volume.geometry.center = POS_A_CURRENT_COMP;

this_box_storage.z_depth = zdepth;
this_box_storage.x_width1 = xwidth;
this_box_storage.y_height1 = yheight;

this_box_storage.is_rectangle = 0;
if (xwidth2 < 0 && yheight2 < 0) this_box_storage.is_rectangle = 1;
if (xwidth == xwidth2 && yheight == yheight2) this_box_storage.is_rectangle = 1;

if (xwidth2 < 0) {
    this_box_storage.x_width2 = xwidth;
    xwidth2 = xwidth;
} else this_box_storage.x_width2 = xwidth2;

if (yheight2 < 0) {
    this_box_storage.y_height2 = yheight;
    yheight2 = yheight;
} else this_box_storage.y_height2 = yheight2;


this_box_storage.normal_vectors[0] = coords_set(0,0,1);
this_box_storage.normal_vectors[1] = coords_set(0,0,1);

// for sides with y component = 0
x_component = 2*zdepth/sqrt((xwidth-xwidth2)*(xwidth-xwidth2)+4*zdepth*zdepth);
z_component = (xwidth-xwidth2)/sqrt(4*zdepth*zdepth+(xwidth-xwidth2)*(xwidth-xwidth2));

this_box_storage.normal_vectors[2] = coords_set(x_component,0,z_component);
this_box_storage.normal_vectors[3] = coords_set(-x_component,0,z_component);

// for sides with x component = 0
y_component = 2*zdepth/sqrt((yheight-yheight2)*(yheight-yheight2)+4*zdepth*zdepth);
z_component = (yheight-yheight2)/sqrt(4*zdepth*zdepth+(yheight-yheight2)*(yheight-yheight2));

this_box_storage.normal_vectors[4] = coords_set(0,y_component,z_component);
this_box_storage.normal_vectors[5] = coords_set(0,-y_component,z_component);

this_box_volume.geometry.visualization_on = visualize;

this_box_volume.geometry.geometry_parameters.p_box_storage = &this_box_storage;

// Assign pointers to functions for intersection with the shape, checking if a point is inside the shape
if (this_box_storage.is_rectangle == 1) {
this_box_volume.geometry.intersect_function = &sample_box_intersect_simple;
this_box_volume.geometry.within_function = &r_within_box_simple;
}
else {
this_box_volume.geometry.intersect_function = &sample_box_intersect_advanced;
this_box_volume.geometry.within_function = &r_within_box_advanced;
}

this_box_volume.geometry.shell_points = &box_shell_points;
this_box_volume.geometry.mcdisplay_function = &mcdisplay_box_function;
this_box_volume.geometry.initialize_from_main_function = &initialize_box_geometry_from_main_component;
this_box_volume.geometry.process_rot_allocated = 0;

this_box_volume.geometry.copy_geometry_parameters = &allocate_box_storage_copy;

rot_copy(this_box_volume.geometry.rotation_matrix,ROT_A_CURRENT_COMP); //check how ROT_R_CURRENT_COMP would work
rot_transpose(ROT_A_CURRENT_COMP,this_box_volume.geometry.transpose_rotation_matrix);

// Initialize loggers
this_box_volume.loggers.num_elements = 0;

// packing the information into the global_geometry_element, which is then included in the global_geometry_list.
sprintf(global_geometry_element.name,NAME_CURRENT_COMP);
global_geometry_element.activation_counter = number_of_activations;
global_geometry_element.component_index = INDEX_CURRENT_COMP;
global_geometry_element.Volume = &this_box_volume; // Would be nicer if this m was a pointer, now we have the (small) data two places
add_element_to_geometry_list(&global_geometry_list,global_geometry_element);
}
#line 278477 "MACS_sample_kidney_box.c"
#undef number_of_activations
#undef mask_setting
#undef mask_string
#undef p_interact
#undef focus_r
#undef focus_xh
#undef focus_xw
#undef focus_ah
#undef focus_aw
#undef target_z
#undef target_y
#undef target_x
#undef target_index
#undef visualize
#undef yheight2
#undef xwidth2
#undef zdepth
#undef yheight
#undef xwidth
#undef priority
#undef material_string
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

  /* Initializations for component diffraction_detector_12_exit_volume. */
  SIG_MESSAGE("diffraction_detector_12_exit_volume (Init)");
#define mccompcurname  diffraction_detector_12_exit_volume
#define mccompcurtype  Union_box
#define mccompcurindex 616
#define loop_index mccdiffraction_detector_12_exit_volume_loop_index
#define this_box_volume mccdiffraction_detector_12_exit_volume_this_box_volume
#define global_geometry_element mccdiffraction_detector_12_exit_volume_global_geometry_element
#define this_box_storage mccdiffraction_detector_12_exit_volume_this_box_storage
#define material_string mccdiffraction_detector_12_exit_volume_material_string
#define priority mccdiffraction_detector_12_exit_volume_priority
#define xwidth mccdiffraction_detector_12_exit_volume_xwidth
#define yheight mccdiffraction_detector_12_exit_volume_yheight
#define zdepth mccdiffraction_detector_12_exit_volume_zdepth
#define xwidth2 mccdiffraction_detector_12_exit_volume_xwidth2
#define yheight2 mccdiffraction_detector_12_exit_volume_yheight2
#define visualize mccdiffraction_detector_12_exit_volume_visualize
#define target_index mccdiffraction_detector_12_exit_volume_target_index
#define target_x mccdiffraction_detector_12_exit_volume_target_x
#define target_y mccdiffraction_detector_12_exit_volume_target_y
#define target_z mccdiffraction_detector_12_exit_volume_target_z
#define focus_aw mccdiffraction_detector_12_exit_volume_focus_aw
#define focus_ah mccdiffraction_detector_12_exit_volume_focus_ah
#define focus_xw mccdiffraction_detector_12_exit_volume_focus_xw
#define focus_xh mccdiffraction_detector_12_exit_volume_focus_xh
#define focus_r mccdiffraction_detector_12_exit_volume_focus_r
#define p_interact mccdiffraction_detector_12_exit_volume_p_interact
#define mask_string mccdiffraction_detector_12_exit_volume_mask_string
#define mask_setting mccdiffraction_detector_12_exit_volume_mask_setting
#define number_of_activations mccdiffraction_detector_12_exit_volume_number_of_activations
#line 224 "Union_box.comp"
{
// Initializes the focusing system for this volume including input sanitation.
focus_initialize(&this_box_volume.geometry, POS_A_COMP_INDEX(INDEX_CURRENT_COMP+target_index), POS_A_CURRENT_COMP, ROT_A_CURRENT_COMP, target_index, target_x, target_y, target_z, focus_aw, focus_ah, focus_xw, focus_xh, focus_r, NAME_CURRENT_COMP);

// Input sanitation for this geometry
if (xwidth <= 0) {
  printf("\nERROR in Union_box named %s, the xwidth is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (yheight <= 0) {
  printf("\nERROR in Union_box named %s, yheight is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (zdepth <= 0) {
  printf("\nERROR in Union_box named %s, zdepth is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (xwidth2 <= 0 && xwidth2 != -1) {
  printf("\nERROR in Union_box named %s, the xwidth2 is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (yheight2 <= 0 && yheight2 != -1) {
  printf("\nERROR in Union_box named %s, yheight2 is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}

// Use sanitation
if (global_material_list.num_elements == 0) {
  printf("\nERROR: Need to define a material using Union_make_material before using a Union geometry component. \n");
  printf("       %s was defined before first use of Union_make_material.\n",NAME_CURRENT_COMP);
  exit(1);
}

this_box_volume.geometry.is_masked_volume = 0;
this_box_volume.geometry.is_exit_volume = 0;
this_box_volume.geometry.is_mask_volume = 0;
// check if the volume is a mask, if it is the material string is irelevant.
if (mask_string && strlen(mask_string) && strcmp(mask_string, "NULL") && strcmp(mask_string, "0")) {
    // A mask volume is used to limit the extend of other volumes, called the masked volumes. These are specified in the mask_string.
    // In order for a ray to enter a masked volume, it needs to be both in the region covered by that volume AND the mask volume.
    // When more than
    this_box_volume.geometry.mask_mode = 1; // Default is mask mode is ALL
    if (mask_setting && strlen(mask_setting) && strcmp(mask_setting, "NULL") && strcmp(mask_setting, "0")) {
        if (strcmp(mask_setting,"ALL") == 0 || strcmp(mask_setting,"All") == 0) this_box_volume.geometry.mask_mode = 1;
        else if (strcmp(mask_setting,"ANY") == 0 || strcmp(mask_setting,"Any") == 0) this_box_volume.geometry.mask_mode = 2;
        else {
            printf("The mask_mode of component %s is set to %s, but must be either ALL or ANY.\n",NAME_CURRENT_COMP,mask_setting);
            exit(1);
        }
    }
    
    for (loop_index=0;loop_index<global_geometry_list.num_elements;loop_index++) {
        // Add mask list
        if (1 == manual_linking_function(global_geometry_list.elements[loop_index].name,mask_string)) {
            add_element_to_int_list(&this_box_volume.geometry.mask_list,global_geometry_list.elements[loop_index].component_index);
            add_element_to_int_list(&global_geometry_list.elements[loop_index].Volume->geometry.masked_by_list,INDEX_CURRENT_COMP);
            global_geometry_list.elements[loop_index].Volume->geometry.is_masked_volume = 1;
            if (this_box_volume.geometry.mask_mode == 2)
                global_geometry_list.elements[loop_index].Volume->geometry.mask_mode = 2;
            if (this_box_volume.geometry.mask_mode == 1) {
                if (global_geometry_list.elements[loop_index].Volume->geometry.is_masked_volume == 1 && global_geometry_list.elements[loop_index].Volume->geometry.mask_mode != 2)
                    // If more than one mask is added to one volume, the ANY mode overwrites the (default) ALL mode.
                    global_geometry_list.elements[loop_index].Volume->geometry.mask_mode = 1;
            }
            
            found_geometries = 1;
        }
    }
    if (found_geometries == 0) {
        printf("The mask_string in geometry: %s did not find any of the specified volumes in the mask_string %s \n",NAME_CURRENT_COMP,mask_string);
        exit(1);
    }
    this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
    this_box_volume.p_physics->is_vacuum = 0; // Makes this volume a vacuum
    this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
    this_box_volume.p_physics->my_a = 0; // Should not be used.
    sprintf(this_box_volume.p_physics->name,"Mask");
    this_box_volume.geometry.is_mask_volume = 1;
    
    
// Read the material input, or if it lacks, use automatic linking.
} else if (material_string && strlen(material_string) && strcmp(material_string, "NULL") && strcmp(material_string, "0")) {
    // A geometry string was given, use it to determine which material
    if (0 == strcmp(material_string,"vacuum") || 0 == strcmp(material_string,"Vacuum")) {
        // One could have a global physics struct for vacuum instead of creating one for each
        this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
        this_box_volume.p_physics->is_vacuum = 1; // Makes this volume a vacuum
        this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
        this_box_volume.p_physics->my_a = 0; // Should not be used.
        sprintf(this_box_volume.p_physics->name,"Vacuum");
    } else if (0 == strcmp(material_string,"exit") || 0 == strcmp(material_string,"Exit")) {
        // One could have a global physics struct for vacuum instead of creating one for each
        this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
        this_box_volume.p_physics->is_vacuum = 1; // Makes this volume a vacuum
        this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
        this_box_volume.p_physics->my_a = 0; // Should not be used.
        this_box_volume.geometry.is_exit_volume = 1;
        sprintf(this_box_volume.p_physics->name,"Exit");
    } else {
        #ifndef MATERIAL_DETECTOR
            printf("Need to define a material before refering to it in a geometry %s.\n",NAME_CURRENT_COMP);
            exit(1);
        #endif
        for (loop_index=0;loop_index<global_material_list.num_elements;loop_index++) {
            if (0 == strcmp(material_string,global_material_list.elements[loop_index].name)) {
                this_box_volume.p_physics = global_material_list.elements[loop_index].physics;
                break;
            }
            if (loop_index == global_material_list.num_elements-1) {
            printf("\n");
            printf("ERROR: The material string \"%s\" in Union geometry \"%s\" did not match a specified material. \n",material_string,NAME_CURRENT_COMP);
            printf("       The materials available at this point (need to be defined before the geometry): \n");
            for (loop_index=0;loop_index<global_material_list.num_elements;loop_index++)
              printf("         %s\n",global_material_list.elements[loop_index].name);
            printf("\n");
            printf("       It is also possible to use one of the defualt materials avaiable: \n");
            printf("           Vacuum (for a Volume without scattering or absorption)\n");
            printf("           Exit (for a Volume where the ray exits the component if it enters)\n");
            printf("           Mask (for a Volume that masks existing volumes specified in the mask_string\n");
            exit(1);
          }
        }
    }
} else {
    // Automatic linking, simply using the last defined material.
    #ifndef MATERIAL_DETECTOR
        printf("Need to define a material before the geometry to use automatic linking %s.\n",NAME_CURRENT_COMP);
        exit(1);
    #endif
    this_box_volume.p_physics = global_material_list.elements[global_material_list.num_elements-1].physics;
}

sprintf(this_box_volume.name,NAME_CURRENT_COMP);
sprintf(this_box_volume.geometry.shape,"box");
this_box_volume.geometry.priority_value = priority;
this_box_volume.geometry.geometry_p_interact = p_interact;
// Currently the coordinates will be in absolute space.
this_box_volume.geometry.center = POS_A_CURRENT_COMP;

this_box_storage.z_depth = zdepth;
this_box_storage.x_width1 = xwidth;
this_box_storage.y_height1 = yheight;

this_box_storage.is_rectangle = 0;
if (xwidth2 < 0 && yheight2 < 0) this_box_storage.is_rectangle = 1;
if (xwidth == xwidth2 && yheight == yheight2) this_box_storage.is_rectangle = 1;

if (xwidth2 < 0) {
    this_box_storage.x_width2 = xwidth;
    xwidth2 = xwidth;
} else this_box_storage.x_width2 = xwidth2;

if (yheight2 < 0) {
    this_box_storage.y_height2 = yheight;
    yheight2 = yheight;
} else this_box_storage.y_height2 = yheight2;


this_box_storage.normal_vectors[0] = coords_set(0,0,1);
this_box_storage.normal_vectors[1] = coords_set(0,0,1);

// for sides with y component = 0
x_component = 2*zdepth/sqrt((xwidth-xwidth2)*(xwidth-xwidth2)+4*zdepth*zdepth);
z_component = (xwidth-xwidth2)/sqrt(4*zdepth*zdepth+(xwidth-xwidth2)*(xwidth-xwidth2));

this_box_storage.normal_vectors[2] = coords_set(x_component,0,z_component);
this_box_storage.normal_vectors[3] = coords_set(-x_component,0,z_component);

// for sides with x component = 0
y_component = 2*zdepth/sqrt((yheight-yheight2)*(yheight-yheight2)+4*zdepth*zdepth);
z_component = (yheight-yheight2)/sqrt(4*zdepth*zdepth+(yheight-yheight2)*(yheight-yheight2));

this_box_storage.normal_vectors[4] = coords_set(0,y_component,z_component);
this_box_storage.normal_vectors[5] = coords_set(0,-y_component,z_component);

this_box_volume.geometry.visualization_on = visualize;

this_box_volume.geometry.geometry_parameters.p_box_storage = &this_box_storage;

// Assign pointers to functions for intersection with the shape, checking if a point is inside the shape
if (this_box_storage.is_rectangle == 1) {
this_box_volume.geometry.intersect_function = &sample_box_intersect_simple;
this_box_volume.geometry.within_function = &r_within_box_simple;
}
else {
this_box_volume.geometry.intersect_function = &sample_box_intersect_advanced;
this_box_volume.geometry.within_function = &r_within_box_advanced;
}

this_box_volume.geometry.shell_points = &box_shell_points;
this_box_volume.geometry.mcdisplay_function = &mcdisplay_box_function;
this_box_volume.geometry.initialize_from_main_function = &initialize_box_geometry_from_main_component;
this_box_volume.geometry.process_rot_allocated = 0;

this_box_volume.geometry.copy_geometry_parameters = &allocate_box_storage_copy;

rot_copy(this_box_volume.geometry.rotation_matrix,ROT_A_CURRENT_COMP); //check how ROT_R_CURRENT_COMP would work
rot_transpose(ROT_A_CURRENT_COMP,this_box_volume.geometry.transpose_rotation_matrix);

// Initialize loggers
this_box_volume.loggers.num_elements = 0;

// packing the information into the global_geometry_element, which is then included in the global_geometry_list.
sprintf(global_geometry_element.name,NAME_CURRENT_COMP);
global_geometry_element.activation_counter = number_of_activations;
global_geometry_element.component_index = INDEX_CURRENT_COMP;
global_geometry_element.Volume = &this_box_volume; // Would be nicer if this m was a pointer, now we have the (small) data two places
add_element_to_geometry_list(&global_geometry_list,global_geometry_element);
}
#line 278747 "MACS_sample_kidney_box.c"
#undef number_of_activations
#undef mask_setting
#undef mask_string
#undef p_interact
#undef focus_r
#undef focus_xh
#undef focus_xw
#undef focus_ah
#undef focus_aw
#undef target_z
#undef target_y
#undef target_x
#undef target_index
#undef visualize
#undef yheight2
#undef xwidth2
#undef zdepth
#undef yheight
#undef xwidth
#undef priority
#undef material_string
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

  /* Initializations for component spec_detector_12_exit_volume. */
  SIG_MESSAGE("spec_detector_12_exit_volume (Init)");
#define mccompcurname  spec_detector_12_exit_volume
#define mccompcurtype  Union_box
#define mccompcurindex 617
#define loop_index mccspec_detector_12_exit_volume_loop_index
#define this_box_volume mccspec_detector_12_exit_volume_this_box_volume
#define global_geometry_element mccspec_detector_12_exit_volume_global_geometry_element
#define this_box_storage mccspec_detector_12_exit_volume_this_box_storage
#define material_string mccspec_detector_12_exit_volume_material_string
#define priority mccspec_detector_12_exit_volume_priority
#define xwidth mccspec_detector_12_exit_volume_xwidth
#define yheight mccspec_detector_12_exit_volume_yheight
#define zdepth mccspec_detector_12_exit_volume_zdepth
#define xwidth2 mccspec_detector_12_exit_volume_xwidth2
#define yheight2 mccspec_detector_12_exit_volume_yheight2
#define visualize mccspec_detector_12_exit_volume_visualize
#define target_index mccspec_detector_12_exit_volume_target_index
#define target_x mccspec_detector_12_exit_volume_target_x
#define target_y mccspec_detector_12_exit_volume_target_y
#define target_z mccspec_detector_12_exit_volume_target_z
#define focus_aw mccspec_detector_12_exit_volume_focus_aw
#define focus_ah mccspec_detector_12_exit_volume_focus_ah
#define focus_xw mccspec_detector_12_exit_volume_focus_xw
#define focus_xh mccspec_detector_12_exit_volume_focus_xh
#define focus_r mccspec_detector_12_exit_volume_focus_r
#define p_interact mccspec_detector_12_exit_volume_p_interact
#define mask_string mccspec_detector_12_exit_volume_mask_string
#define mask_setting mccspec_detector_12_exit_volume_mask_setting
#define number_of_activations mccspec_detector_12_exit_volume_number_of_activations
#line 224 "Union_box.comp"
{
// Initializes the focusing system for this volume including input sanitation.
focus_initialize(&this_box_volume.geometry, POS_A_COMP_INDEX(INDEX_CURRENT_COMP+target_index), POS_A_CURRENT_COMP, ROT_A_CURRENT_COMP, target_index, target_x, target_y, target_z, focus_aw, focus_ah, focus_xw, focus_xh, focus_r, NAME_CURRENT_COMP);

// Input sanitation for this geometry
if (xwidth <= 0) {
  printf("\nERROR in Union_box named %s, the xwidth is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (yheight <= 0) {
  printf("\nERROR in Union_box named %s, yheight is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (zdepth <= 0) {
  printf("\nERROR in Union_box named %s, zdepth is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (xwidth2 <= 0 && xwidth2 != -1) {
  printf("\nERROR in Union_box named %s, the xwidth2 is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (yheight2 <= 0 && yheight2 != -1) {
  printf("\nERROR in Union_box named %s, yheight2 is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}

// Use sanitation
if (global_material_list.num_elements == 0) {
  printf("\nERROR: Need to define a material using Union_make_material before using a Union geometry component. \n");
  printf("       %s was defined before first use of Union_make_material.\n",NAME_CURRENT_COMP);
  exit(1);
}

this_box_volume.geometry.is_masked_volume = 0;
this_box_volume.geometry.is_exit_volume = 0;
this_box_volume.geometry.is_mask_volume = 0;
// check if the volume is a mask, if it is the material string is irelevant.
if (mask_string && strlen(mask_string) && strcmp(mask_string, "NULL") && strcmp(mask_string, "0")) {
    // A mask volume is used to limit the extend of other volumes, called the masked volumes. These are specified in the mask_string.
    // In order for a ray to enter a masked volume, it needs to be both in the region covered by that volume AND the mask volume.
    // When more than
    this_box_volume.geometry.mask_mode = 1; // Default is mask mode is ALL
    if (mask_setting && strlen(mask_setting) && strcmp(mask_setting, "NULL") && strcmp(mask_setting, "0")) {
        if (strcmp(mask_setting,"ALL") == 0 || strcmp(mask_setting,"All") == 0) this_box_volume.geometry.mask_mode = 1;
        else if (strcmp(mask_setting,"ANY") == 0 || strcmp(mask_setting,"Any") == 0) this_box_volume.geometry.mask_mode = 2;
        else {
            printf("The mask_mode of component %s is set to %s, but must be either ALL or ANY.\n",NAME_CURRENT_COMP,mask_setting);
            exit(1);
        }
    }
    
    for (loop_index=0;loop_index<global_geometry_list.num_elements;loop_index++) {
        // Add mask list
        if (1 == manual_linking_function(global_geometry_list.elements[loop_index].name,mask_string)) {
            add_element_to_int_list(&this_box_volume.geometry.mask_list,global_geometry_list.elements[loop_index].component_index);
            add_element_to_int_list(&global_geometry_list.elements[loop_index].Volume->geometry.masked_by_list,INDEX_CURRENT_COMP);
            global_geometry_list.elements[loop_index].Volume->geometry.is_masked_volume = 1;
            if (this_box_volume.geometry.mask_mode == 2)
                global_geometry_list.elements[loop_index].Volume->geometry.mask_mode = 2;
            if (this_box_volume.geometry.mask_mode == 1) {
                if (global_geometry_list.elements[loop_index].Volume->geometry.is_masked_volume == 1 && global_geometry_list.elements[loop_index].Volume->geometry.mask_mode != 2)
                    // If more than one mask is added to one volume, the ANY mode overwrites the (default) ALL mode.
                    global_geometry_list.elements[loop_index].Volume->geometry.mask_mode = 1;
            }
            
            found_geometries = 1;
        }
    }
    if (found_geometries == 0) {
        printf("The mask_string in geometry: %s did not find any of the specified volumes in the mask_string %s \n",NAME_CURRENT_COMP,mask_string);
        exit(1);
    }
    this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
    this_box_volume.p_physics->is_vacuum = 0; // Makes this volume a vacuum
    this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
    this_box_volume.p_physics->my_a = 0; // Should not be used.
    sprintf(this_box_volume.p_physics->name,"Mask");
    this_box_volume.geometry.is_mask_volume = 1;
    
    
// Read the material input, or if it lacks, use automatic linking.
} else if (material_string && strlen(material_string) && strcmp(material_string, "NULL") && strcmp(material_string, "0")) {
    // A geometry string was given, use it to determine which material
    if (0 == strcmp(material_string,"vacuum") || 0 == strcmp(material_string,"Vacuum")) {
        // One could have a global physics struct for vacuum instead of creating one for each
        this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
        this_box_volume.p_physics->is_vacuum = 1; // Makes this volume a vacuum
        this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
        this_box_volume.p_physics->my_a = 0; // Should not be used.
        sprintf(this_box_volume.p_physics->name,"Vacuum");
    } else if (0 == strcmp(material_string,"exit") || 0 == strcmp(material_string,"Exit")) {
        // One could have a global physics struct for vacuum instead of creating one for each
        this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
        this_box_volume.p_physics->is_vacuum = 1; // Makes this volume a vacuum
        this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
        this_box_volume.p_physics->my_a = 0; // Should not be used.
        this_box_volume.geometry.is_exit_volume = 1;
        sprintf(this_box_volume.p_physics->name,"Exit");
    } else {
        #ifndef MATERIAL_DETECTOR
            printf("Need to define a material before refering to it in a geometry %s.\n",NAME_CURRENT_COMP);
            exit(1);
        #endif
        for (loop_index=0;loop_index<global_material_list.num_elements;loop_index++) {
            if (0 == strcmp(material_string,global_material_list.elements[loop_index].name)) {
                this_box_volume.p_physics = global_material_list.elements[loop_index].physics;
                break;
            }
            if (loop_index == global_material_list.num_elements-1) {
            printf("\n");
            printf("ERROR: The material string \"%s\" in Union geometry \"%s\" did not match a specified material. \n",material_string,NAME_CURRENT_COMP);
            printf("       The materials available at this point (need to be defined before the geometry): \n");
            for (loop_index=0;loop_index<global_material_list.num_elements;loop_index++)
              printf("         %s\n",global_material_list.elements[loop_index].name);
            printf("\n");
            printf("       It is also possible to use one of the defualt materials avaiable: \n");
            printf("           Vacuum (for a Volume without scattering or absorption)\n");
            printf("           Exit (for a Volume where the ray exits the component if it enters)\n");
            printf("           Mask (for a Volume that masks existing volumes specified in the mask_string\n");
            exit(1);
          }
        }
    }
} else {
    // Automatic linking, simply using the last defined material.
    #ifndef MATERIAL_DETECTOR
        printf("Need to define a material before the geometry to use automatic linking %s.\n",NAME_CURRENT_COMP);
        exit(1);
    #endif
    this_box_volume.p_physics = global_material_list.elements[global_material_list.num_elements-1].physics;
}

sprintf(this_box_volume.name,NAME_CURRENT_COMP);
sprintf(this_box_volume.geometry.shape,"box");
this_box_volume.geometry.priority_value = priority;
this_box_volume.geometry.geometry_p_interact = p_interact;
// Currently the coordinates will be in absolute space.
this_box_volume.geometry.center = POS_A_CURRENT_COMP;

this_box_storage.z_depth = zdepth;
this_box_storage.x_width1 = xwidth;
this_box_storage.y_height1 = yheight;

this_box_storage.is_rectangle = 0;
if (xwidth2 < 0 && yheight2 < 0) this_box_storage.is_rectangle = 1;
if (xwidth == xwidth2 && yheight == yheight2) this_box_storage.is_rectangle = 1;

if (xwidth2 < 0) {
    this_box_storage.x_width2 = xwidth;
    xwidth2 = xwidth;
} else this_box_storage.x_width2 = xwidth2;

if (yheight2 < 0) {
    this_box_storage.y_height2 = yheight;
    yheight2 = yheight;
} else this_box_storage.y_height2 = yheight2;


this_box_storage.normal_vectors[0] = coords_set(0,0,1);
this_box_storage.normal_vectors[1] = coords_set(0,0,1);

// for sides with y component = 0
x_component = 2*zdepth/sqrt((xwidth-xwidth2)*(xwidth-xwidth2)+4*zdepth*zdepth);
z_component = (xwidth-xwidth2)/sqrt(4*zdepth*zdepth+(xwidth-xwidth2)*(xwidth-xwidth2));

this_box_storage.normal_vectors[2] = coords_set(x_component,0,z_component);
this_box_storage.normal_vectors[3] = coords_set(-x_component,0,z_component);

// for sides with x component = 0
y_component = 2*zdepth/sqrt((yheight-yheight2)*(yheight-yheight2)+4*zdepth*zdepth);
z_component = (yheight-yheight2)/sqrt(4*zdepth*zdepth+(yheight-yheight2)*(yheight-yheight2));

this_box_storage.normal_vectors[4] = coords_set(0,y_component,z_component);
this_box_storage.normal_vectors[5] = coords_set(0,-y_component,z_component);

this_box_volume.geometry.visualization_on = visualize;

this_box_volume.geometry.geometry_parameters.p_box_storage = &this_box_storage;

// Assign pointers to functions for intersection with the shape, checking if a point is inside the shape
if (this_box_storage.is_rectangle == 1) {
this_box_volume.geometry.intersect_function = &sample_box_intersect_simple;
this_box_volume.geometry.within_function = &r_within_box_simple;
}
else {
this_box_volume.geometry.intersect_function = &sample_box_intersect_advanced;
this_box_volume.geometry.within_function = &r_within_box_advanced;
}

this_box_volume.geometry.shell_points = &box_shell_points;
this_box_volume.geometry.mcdisplay_function = &mcdisplay_box_function;
this_box_volume.geometry.initialize_from_main_function = &initialize_box_geometry_from_main_component;
this_box_volume.geometry.process_rot_allocated = 0;

this_box_volume.geometry.copy_geometry_parameters = &allocate_box_storage_copy;

rot_copy(this_box_volume.geometry.rotation_matrix,ROT_A_CURRENT_COMP); //check how ROT_R_CURRENT_COMP would work
rot_transpose(ROT_A_CURRENT_COMP,this_box_volume.geometry.transpose_rotation_matrix);

// Initialize loggers
this_box_volume.loggers.num_elements = 0;

// packing the information into the global_geometry_element, which is then included in the global_geometry_list.
sprintf(global_geometry_element.name,NAME_CURRENT_COMP);
global_geometry_element.activation_counter = number_of_activations;
global_geometry_element.component_index = INDEX_CURRENT_COMP;
global_geometry_element.Volume = &this_box_volume; // Would be nicer if this m was a pointer, now we have the (small) data two places
add_element_to_geometry_list(&global_geometry_list,global_geometry_element);
}
#line 279017 "MACS_sample_kidney_box.c"
#undef number_of_activations
#undef mask_setting
#undef mask_string
#undef p_interact
#undef focus_r
#undef focus_xh
#undef focus_xw
#undef focus_ah
#undef focus_aw
#undef target_z
#undef target_y
#undef target_x
#undef target_index
#undef visualize
#undef yheight2
#undef xwidth2
#undef zdepth
#undef yheight
#undef xwidth
#undef priority
#undef material_string
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

  /* Initializations for component channel_13_cave1_box1. */
  SIG_MESSAGE("channel_13_cave1_box1 (Init)");
#define mccompcurname  channel_13_cave1_box1
#define mccompcurtype  Union_box
#define mccompcurindex 618
#define loop_index mccchannel_13_cave1_box1_loop_index
#define this_box_volume mccchannel_13_cave1_box1_this_box_volume
#define global_geometry_element mccchannel_13_cave1_box1_global_geometry_element
#define this_box_storage mccchannel_13_cave1_box1_this_box_storage
#define material_string mccchannel_13_cave1_box1_material_string
#define priority mccchannel_13_cave1_box1_priority
#define xwidth mccchannel_13_cave1_box1_xwidth
#define yheight mccchannel_13_cave1_box1_yheight
#define zdepth mccchannel_13_cave1_box1_zdepth
#define xwidth2 mccchannel_13_cave1_box1_xwidth2
#define yheight2 mccchannel_13_cave1_box1_yheight2
#define visualize mccchannel_13_cave1_box1_visualize
#define target_index mccchannel_13_cave1_box1_target_index
#define target_x mccchannel_13_cave1_box1_target_x
#define target_y mccchannel_13_cave1_box1_target_y
#define target_z mccchannel_13_cave1_box1_target_z
#define focus_aw mccchannel_13_cave1_box1_focus_aw
#define focus_ah mccchannel_13_cave1_box1_focus_ah
#define focus_xw mccchannel_13_cave1_box1_focus_xw
#define focus_xh mccchannel_13_cave1_box1_focus_xh
#define focus_r mccchannel_13_cave1_box1_focus_r
#define p_interact mccchannel_13_cave1_box1_p_interact
#define mask_string mccchannel_13_cave1_box1_mask_string
#define mask_setting mccchannel_13_cave1_box1_mask_setting
#define number_of_activations mccchannel_13_cave1_box1_number_of_activations
#line 224 "Union_box.comp"
{
// Initializes the focusing system for this volume including input sanitation.
focus_initialize(&this_box_volume.geometry, POS_A_COMP_INDEX(INDEX_CURRENT_COMP+target_index), POS_A_CURRENT_COMP, ROT_A_CURRENT_COMP, target_index, target_x, target_y, target_z, focus_aw, focus_ah, focus_xw, focus_xh, focus_r, NAME_CURRENT_COMP);

// Input sanitation for this geometry
if (xwidth <= 0) {
  printf("\nERROR in Union_box named %s, the xwidth is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (yheight <= 0) {
  printf("\nERROR in Union_box named %s, yheight is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (zdepth <= 0) {
  printf("\nERROR in Union_box named %s, zdepth is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (xwidth2 <= 0 && xwidth2 != -1) {
  printf("\nERROR in Union_box named %s, the xwidth2 is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (yheight2 <= 0 && yheight2 != -1) {
  printf("\nERROR in Union_box named %s, yheight2 is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}

// Use sanitation
if (global_material_list.num_elements == 0) {
  printf("\nERROR: Need to define a material using Union_make_material before using a Union geometry component. \n");
  printf("       %s was defined before first use of Union_make_material.\n",NAME_CURRENT_COMP);
  exit(1);
}

this_box_volume.geometry.is_masked_volume = 0;
this_box_volume.geometry.is_exit_volume = 0;
this_box_volume.geometry.is_mask_volume = 0;
// check if the volume is a mask, if it is the material string is irelevant.
if (mask_string && strlen(mask_string) && strcmp(mask_string, "NULL") && strcmp(mask_string, "0")) {
    // A mask volume is used to limit the extend of other volumes, called the masked volumes. These are specified in the mask_string.
    // In order for a ray to enter a masked volume, it needs to be both in the region covered by that volume AND the mask volume.
    // When more than
    this_box_volume.geometry.mask_mode = 1; // Default is mask mode is ALL
    if (mask_setting && strlen(mask_setting) && strcmp(mask_setting, "NULL") && strcmp(mask_setting, "0")) {
        if (strcmp(mask_setting,"ALL") == 0 || strcmp(mask_setting,"All") == 0) this_box_volume.geometry.mask_mode = 1;
        else if (strcmp(mask_setting,"ANY") == 0 || strcmp(mask_setting,"Any") == 0) this_box_volume.geometry.mask_mode = 2;
        else {
            printf("The mask_mode of component %s is set to %s, but must be either ALL or ANY.\n",NAME_CURRENT_COMP,mask_setting);
            exit(1);
        }
    }
    
    for (loop_index=0;loop_index<global_geometry_list.num_elements;loop_index++) {
        // Add mask list
        if (1 == manual_linking_function(global_geometry_list.elements[loop_index].name,mask_string)) {
            add_element_to_int_list(&this_box_volume.geometry.mask_list,global_geometry_list.elements[loop_index].component_index);
            add_element_to_int_list(&global_geometry_list.elements[loop_index].Volume->geometry.masked_by_list,INDEX_CURRENT_COMP);
            global_geometry_list.elements[loop_index].Volume->geometry.is_masked_volume = 1;
            if (this_box_volume.geometry.mask_mode == 2)
                global_geometry_list.elements[loop_index].Volume->geometry.mask_mode = 2;
            if (this_box_volume.geometry.mask_mode == 1) {
                if (global_geometry_list.elements[loop_index].Volume->geometry.is_masked_volume == 1 && global_geometry_list.elements[loop_index].Volume->geometry.mask_mode != 2)
                    // If more than one mask is added to one volume, the ANY mode overwrites the (default) ALL mode.
                    global_geometry_list.elements[loop_index].Volume->geometry.mask_mode = 1;
            }
            
            found_geometries = 1;
        }
    }
    if (found_geometries == 0) {
        printf("The mask_string in geometry: %s did not find any of the specified volumes in the mask_string %s \n",NAME_CURRENT_COMP,mask_string);
        exit(1);
    }
    this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
    this_box_volume.p_physics->is_vacuum = 0; // Makes this volume a vacuum
    this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
    this_box_volume.p_physics->my_a = 0; // Should not be used.
    sprintf(this_box_volume.p_physics->name,"Mask");
    this_box_volume.geometry.is_mask_volume = 1;
    
    
// Read the material input, or if it lacks, use automatic linking.
} else if (material_string && strlen(material_string) && strcmp(material_string, "NULL") && strcmp(material_string, "0")) {
    // A geometry string was given, use it to determine which material
    if (0 == strcmp(material_string,"vacuum") || 0 == strcmp(material_string,"Vacuum")) {
        // One could have a global physics struct for vacuum instead of creating one for each
        this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
        this_box_volume.p_physics->is_vacuum = 1; // Makes this volume a vacuum
        this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
        this_box_volume.p_physics->my_a = 0; // Should not be used.
        sprintf(this_box_volume.p_physics->name,"Vacuum");
    } else if (0 == strcmp(material_string,"exit") || 0 == strcmp(material_string,"Exit")) {
        // One could have a global physics struct for vacuum instead of creating one for each
        this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
        this_box_volume.p_physics->is_vacuum = 1; // Makes this volume a vacuum
        this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
        this_box_volume.p_physics->my_a = 0; // Should not be used.
        this_box_volume.geometry.is_exit_volume = 1;
        sprintf(this_box_volume.p_physics->name,"Exit");
    } else {
        #ifndef MATERIAL_DETECTOR
            printf("Need to define a material before refering to it in a geometry %s.\n",NAME_CURRENT_COMP);
            exit(1);
        #endif
        for (loop_index=0;loop_index<global_material_list.num_elements;loop_index++) {
            if (0 == strcmp(material_string,global_material_list.elements[loop_index].name)) {
                this_box_volume.p_physics = global_material_list.elements[loop_index].physics;
                break;
            }
            if (loop_index == global_material_list.num_elements-1) {
            printf("\n");
            printf("ERROR: The material string \"%s\" in Union geometry \"%s\" did not match a specified material. \n",material_string,NAME_CURRENT_COMP);
            printf("       The materials available at this point (need to be defined before the geometry): \n");
            for (loop_index=0;loop_index<global_material_list.num_elements;loop_index++)
              printf("         %s\n",global_material_list.elements[loop_index].name);
            printf("\n");
            printf("       It is also possible to use one of the defualt materials avaiable: \n");
            printf("           Vacuum (for a Volume without scattering or absorption)\n");
            printf("           Exit (for a Volume where the ray exits the component if it enters)\n");
            printf("           Mask (for a Volume that masks existing volumes specified in the mask_string\n");
            exit(1);
          }
        }
    }
} else {
    // Automatic linking, simply using the last defined material.
    #ifndef MATERIAL_DETECTOR
        printf("Need to define a material before the geometry to use automatic linking %s.\n",NAME_CURRENT_COMP);
        exit(1);
    #endif
    this_box_volume.p_physics = global_material_list.elements[global_material_list.num_elements-1].physics;
}

sprintf(this_box_volume.name,NAME_CURRENT_COMP);
sprintf(this_box_volume.geometry.shape,"box");
this_box_volume.geometry.priority_value = priority;
this_box_volume.geometry.geometry_p_interact = p_interact;
// Currently the coordinates will be in absolute space.
this_box_volume.geometry.center = POS_A_CURRENT_COMP;

this_box_storage.z_depth = zdepth;
this_box_storage.x_width1 = xwidth;
this_box_storage.y_height1 = yheight;

this_box_storage.is_rectangle = 0;
if (xwidth2 < 0 && yheight2 < 0) this_box_storage.is_rectangle = 1;
if (xwidth == xwidth2 && yheight == yheight2) this_box_storage.is_rectangle = 1;

if (xwidth2 < 0) {
    this_box_storage.x_width2 = xwidth;
    xwidth2 = xwidth;
} else this_box_storage.x_width2 = xwidth2;

if (yheight2 < 0) {
    this_box_storage.y_height2 = yheight;
    yheight2 = yheight;
} else this_box_storage.y_height2 = yheight2;


this_box_storage.normal_vectors[0] = coords_set(0,0,1);
this_box_storage.normal_vectors[1] = coords_set(0,0,1);

// for sides with y component = 0
x_component = 2*zdepth/sqrt((xwidth-xwidth2)*(xwidth-xwidth2)+4*zdepth*zdepth);
z_component = (xwidth-xwidth2)/sqrt(4*zdepth*zdepth+(xwidth-xwidth2)*(xwidth-xwidth2));

this_box_storage.normal_vectors[2] = coords_set(x_component,0,z_component);
this_box_storage.normal_vectors[3] = coords_set(-x_component,0,z_component);

// for sides with x component = 0
y_component = 2*zdepth/sqrt((yheight-yheight2)*(yheight-yheight2)+4*zdepth*zdepth);
z_component = (yheight-yheight2)/sqrt(4*zdepth*zdepth+(yheight-yheight2)*(yheight-yheight2));

this_box_storage.normal_vectors[4] = coords_set(0,y_component,z_component);
this_box_storage.normal_vectors[5] = coords_set(0,-y_component,z_component);

this_box_volume.geometry.visualization_on = visualize;

this_box_volume.geometry.geometry_parameters.p_box_storage = &this_box_storage;

// Assign pointers to functions for intersection with the shape, checking if a point is inside the shape
if (this_box_storage.is_rectangle == 1) {
this_box_volume.geometry.intersect_function = &sample_box_intersect_simple;
this_box_volume.geometry.within_function = &r_within_box_simple;
}
else {
this_box_volume.geometry.intersect_function = &sample_box_intersect_advanced;
this_box_volume.geometry.within_function = &r_within_box_advanced;
}

this_box_volume.geometry.shell_points = &box_shell_points;
this_box_volume.geometry.mcdisplay_function = &mcdisplay_box_function;
this_box_volume.geometry.initialize_from_main_function = &initialize_box_geometry_from_main_component;
this_box_volume.geometry.process_rot_allocated = 0;

this_box_volume.geometry.copy_geometry_parameters = &allocate_box_storage_copy;

rot_copy(this_box_volume.geometry.rotation_matrix,ROT_A_CURRENT_COMP); //check how ROT_R_CURRENT_COMP would work
rot_transpose(ROT_A_CURRENT_COMP,this_box_volume.geometry.transpose_rotation_matrix);

// Initialize loggers
this_box_volume.loggers.num_elements = 0;

// packing the information into the global_geometry_element, which is then included in the global_geometry_list.
sprintf(global_geometry_element.name,NAME_CURRENT_COMP);
global_geometry_element.activation_counter = number_of_activations;
global_geometry_element.component_index = INDEX_CURRENT_COMP;
global_geometry_element.Volume = &this_box_volume; // Would be nicer if this m was a pointer, now we have the (small) data two places
add_element_to_geometry_list(&global_geometry_list,global_geometry_element);
}
#line 279287 "MACS_sample_kidney_box.c"
#undef number_of_activations
#undef mask_setting
#undef mask_string
#undef p_interact
#undef focus_r
#undef focus_xh
#undef focus_xw
#undef focus_ah
#undef focus_aw
#undef target_z
#undef target_y
#undef target_x
#undef target_index
#undef visualize
#undef yheight2
#undef xwidth2
#undef zdepth
#undef yheight
#undef xwidth
#undef priority
#undef material_string
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

  /* Initializations for component channel_13_cave1_box2. */
  SIG_MESSAGE("channel_13_cave1_box2 (Init)");
#define mccompcurname  channel_13_cave1_box2
#define mccompcurtype  Union_box
#define mccompcurindex 619
#define loop_index mccchannel_13_cave1_box2_loop_index
#define this_box_volume mccchannel_13_cave1_box2_this_box_volume
#define global_geometry_element mccchannel_13_cave1_box2_global_geometry_element
#define this_box_storage mccchannel_13_cave1_box2_this_box_storage
#define material_string mccchannel_13_cave1_box2_material_string
#define priority mccchannel_13_cave1_box2_priority
#define xwidth mccchannel_13_cave1_box2_xwidth
#define yheight mccchannel_13_cave1_box2_yheight
#define zdepth mccchannel_13_cave1_box2_zdepth
#define xwidth2 mccchannel_13_cave1_box2_xwidth2
#define yheight2 mccchannel_13_cave1_box2_yheight2
#define visualize mccchannel_13_cave1_box2_visualize
#define target_index mccchannel_13_cave1_box2_target_index
#define target_x mccchannel_13_cave1_box2_target_x
#define target_y mccchannel_13_cave1_box2_target_y
#define target_z mccchannel_13_cave1_box2_target_z
#define focus_aw mccchannel_13_cave1_box2_focus_aw
#define focus_ah mccchannel_13_cave1_box2_focus_ah
#define focus_xw mccchannel_13_cave1_box2_focus_xw
#define focus_xh mccchannel_13_cave1_box2_focus_xh
#define focus_r mccchannel_13_cave1_box2_focus_r
#define p_interact mccchannel_13_cave1_box2_p_interact
#define mask_string mccchannel_13_cave1_box2_mask_string
#define mask_setting mccchannel_13_cave1_box2_mask_setting
#define number_of_activations mccchannel_13_cave1_box2_number_of_activations
#line 224 "Union_box.comp"
{
// Initializes the focusing system for this volume including input sanitation.
focus_initialize(&this_box_volume.geometry, POS_A_COMP_INDEX(INDEX_CURRENT_COMP+target_index), POS_A_CURRENT_COMP, ROT_A_CURRENT_COMP, target_index, target_x, target_y, target_z, focus_aw, focus_ah, focus_xw, focus_xh, focus_r, NAME_CURRENT_COMP);

// Input sanitation for this geometry
if (xwidth <= 0) {
  printf("\nERROR in Union_box named %s, the xwidth is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (yheight <= 0) {
  printf("\nERROR in Union_box named %s, yheight is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (zdepth <= 0) {
  printf("\nERROR in Union_box named %s, zdepth is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (xwidth2 <= 0 && xwidth2 != -1) {
  printf("\nERROR in Union_box named %s, the xwidth2 is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (yheight2 <= 0 && yheight2 != -1) {
  printf("\nERROR in Union_box named %s, yheight2 is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}

// Use sanitation
if (global_material_list.num_elements == 0) {
  printf("\nERROR: Need to define a material using Union_make_material before using a Union geometry component. \n");
  printf("       %s was defined before first use of Union_make_material.\n",NAME_CURRENT_COMP);
  exit(1);
}

this_box_volume.geometry.is_masked_volume = 0;
this_box_volume.geometry.is_exit_volume = 0;
this_box_volume.geometry.is_mask_volume = 0;
// check if the volume is a mask, if it is the material string is irelevant.
if (mask_string && strlen(mask_string) && strcmp(mask_string, "NULL") && strcmp(mask_string, "0")) {
    // A mask volume is used to limit the extend of other volumes, called the masked volumes. These are specified in the mask_string.
    // In order for a ray to enter a masked volume, it needs to be both in the region covered by that volume AND the mask volume.
    // When more than
    this_box_volume.geometry.mask_mode = 1; // Default is mask mode is ALL
    if (mask_setting && strlen(mask_setting) && strcmp(mask_setting, "NULL") && strcmp(mask_setting, "0")) {
        if (strcmp(mask_setting,"ALL") == 0 || strcmp(mask_setting,"All") == 0) this_box_volume.geometry.mask_mode = 1;
        else if (strcmp(mask_setting,"ANY") == 0 || strcmp(mask_setting,"Any") == 0) this_box_volume.geometry.mask_mode = 2;
        else {
            printf("The mask_mode of component %s is set to %s, but must be either ALL or ANY.\n",NAME_CURRENT_COMP,mask_setting);
            exit(1);
        }
    }
    
    for (loop_index=0;loop_index<global_geometry_list.num_elements;loop_index++) {
        // Add mask list
        if (1 == manual_linking_function(global_geometry_list.elements[loop_index].name,mask_string)) {
            add_element_to_int_list(&this_box_volume.geometry.mask_list,global_geometry_list.elements[loop_index].component_index);
            add_element_to_int_list(&global_geometry_list.elements[loop_index].Volume->geometry.masked_by_list,INDEX_CURRENT_COMP);
            global_geometry_list.elements[loop_index].Volume->geometry.is_masked_volume = 1;
            if (this_box_volume.geometry.mask_mode == 2)
                global_geometry_list.elements[loop_index].Volume->geometry.mask_mode = 2;
            if (this_box_volume.geometry.mask_mode == 1) {
                if (global_geometry_list.elements[loop_index].Volume->geometry.is_masked_volume == 1 && global_geometry_list.elements[loop_index].Volume->geometry.mask_mode != 2)
                    // If more than one mask is added to one volume, the ANY mode overwrites the (default) ALL mode.
                    global_geometry_list.elements[loop_index].Volume->geometry.mask_mode = 1;
            }
            
            found_geometries = 1;
        }
    }
    if (found_geometries == 0) {
        printf("The mask_string in geometry: %s did not find any of the specified volumes in the mask_string %s \n",NAME_CURRENT_COMP,mask_string);
        exit(1);
    }
    this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
    this_box_volume.p_physics->is_vacuum = 0; // Makes this volume a vacuum
    this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
    this_box_volume.p_physics->my_a = 0; // Should not be used.
    sprintf(this_box_volume.p_physics->name,"Mask");
    this_box_volume.geometry.is_mask_volume = 1;
    
    
// Read the material input, or if it lacks, use automatic linking.
} else if (material_string && strlen(material_string) && strcmp(material_string, "NULL") && strcmp(material_string, "0")) {
    // A geometry string was given, use it to determine which material
    if (0 == strcmp(material_string,"vacuum") || 0 == strcmp(material_string,"Vacuum")) {
        // One could have a global physics struct for vacuum instead of creating one for each
        this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
        this_box_volume.p_physics->is_vacuum = 1; // Makes this volume a vacuum
        this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
        this_box_volume.p_physics->my_a = 0; // Should not be used.
        sprintf(this_box_volume.p_physics->name,"Vacuum");
    } else if (0 == strcmp(material_string,"exit") || 0 == strcmp(material_string,"Exit")) {
        // One could have a global physics struct for vacuum instead of creating one for each
        this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
        this_box_volume.p_physics->is_vacuum = 1; // Makes this volume a vacuum
        this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
        this_box_volume.p_physics->my_a = 0; // Should not be used.
        this_box_volume.geometry.is_exit_volume = 1;
        sprintf(this_box_volume.p_physics->name,"Exit");
    } else {
        #ifndef MATERIAL_DETECTOR
            printf("Need to define a material before refering to it in a geometry %s.\n",NAME_CURRENT_COMP);
            exit(1);
        #endif
        for (loop_index=0;loop_index<global_material_list.num_elements;loop_index++) {
            if (0 == strcmp(material_string,global_material_list.elements[loop_index].name)) {
                this_box_volume.p_physics = global_material_list.elements[loop_index].physics;
                break;
            }
            if (loop_index == global_material_list.num_elements-1) {
            printf("\n");
            printf("ERROR: The material string \"%s\" in Union geometry \"%s\" did not match a specified material. \n",material_string,NAME_CURRENT_COMP);
            printf("       The materials available at this point (need to be defined before the geometry): \n");
            for (loop_index=0;loop_index<global_material_list.num_elements;loop_index++)
              printf("         %s\n",global_material_list.elements[loop_index].name);
            printf("\n");
            printf("       It is also possible to use one of the defualt materials avaiable: \n");
            printf("           Vacuum (for a Volume without scattering or absorption)\n");
            printf("           Exit (for a Volume where the ray exits the component if it enters)\n");
            printf("           Mask (for a Volume that masks existing volumes specified in the mask_string\n");
            exit(1);
          }
        }
    }
} else {
    // Automatic linking, simply using the last defined material.
    #ifndef MATERIAL_DETECTOR
        printf("Need to define a material before the geometry to use automatic linking %s.\n",NAME_CURRENT_COMP);
        exit(1);
    #endif
    this_box_volume.p_physics = global_material_list.elements[global_material_list.num_elements-1].physics;
}

sprintf(this_box_volume.name,NAME_CURRENT_COMP);
sprintf(this_box_volume.geometry.shape,"box");
this_box_volume.geometry.priority_value = priority;
this_box_volume.geometry.geometry_p_interact = p_interact;
// Currently the coordinates will be in absolute space.
this_box_volume.geometry.center = POS_A_CURRENT_COMP;

this_box_storage.z_depth = zdepth;
this_box_storage.x_width1 = xwidth;
this_box_storage.y_height1 = yheight;

this_box_storage.is_rectangle = 0;
if (xwidth2 < 0 && yheight2 < 0) this_box_storage.is_rectangle = 1;
if (xwidth == xwidth2 && yheight == yheight2) this_box_storage.is_rectangle = 1;

if (xwidth2 < 0) {
    this_box_storage.x_width2 = xwidth;
    xwidth2 = xwidth;
} else this_box_storage.x_width2 = xwidth2;

if (yheight2 < 0) {
    this_box_storage.y_height2 = yheight;
    yheight2 = yheight;
} else this_box_storage.y_height2 = yheight2;


this_box_storage.normal_vectors[0] = coords_set(0,0,1);
this_box_storage.normal_vectors[1] = coords_set(0,0,1);

// for sides with y component = 0
x_component = 2*zdepth/sqrt((xwidth-xwidth2)*(xwidth-xwidth2)+4*zdepth*zdepth);
z_component = (xwidth-xwidth2)/sqrt(4*zdepth*zdepth+(xwidth-xwidth2)*(xwidth-xwidth2));

this_box_storage.normal_vectors[2] = coords_set(x_component,0,z_component);
this_box_storage.normal_vectors[3] = coords_set(-x_component,0,z_component);

// for sides with x component = 0
y_component = 2*zdepth/sqrt((yheight-yheight2)*(yheight-yheight2)+4*zdepth*zdepth);
z_component = (yheight-yheight2)/sqrt(4*zdepth*zdepth+(yheight-yheight2)*(yheight-yheight2));

this_box_storage.normal_vectors[4] = coords_set(0,y_component,z_component);
this_box_storage.normal_vectors[5] = coords_set(0,-y_component,z_component);

this_box_volume.geometry.visualization_on = visualize;

this_box_volume.geometry.geometry_parameters.p_box_storage = &this_box_storage;

// Assign pointers to functions for intersection with the shape, checking if a point is inside the shape
if (this_box_storage.is_rectangle == 1) {
this_box_volume.geometry.intersect_function = &sample_box_intersect_simple;
this_box_volume.geometry.within_function = &r_within_box_simple;
}
else {
this_box_volume.geometry.intersect_function = &sample_box_intersect_advanced;
this_box_volume.geometry.within_function = &r_within_box_advanced;
}

this_box_volume.geometry.shell_points = &box_shell_points;
this_box_volume.geometry.mcdisplay_function = &mcdisplay_box_function;
this_box_volume.geometry.initialize_from_main_function = &initialize_box_geometry_from_main_component;
this_box_volume.geometry.process_rot_allocated = 0;

this_box_volume.geometry.copy_geometry_parameters = &allocate_box_storage_copy;

rot_copy(this_box_volume.geometry.rotation_matrix,ROT_A_CURRENT_COMP); //check how ROT_R_CURRENT_COMP would work
rot_transpose(ROT_A_CURRENT_COMP,this_box_volume.geometry.transpose_rotation_matrix);

// Initialize loggers
this_box_volume.loggers.num_elements = 0;

// packing the information into the global_geometry_element, which is then included in the global_geometry_list.
sprintf(global_geometry_element.name,NAME_CURRENT_COMP);
global_geometry_element.activation_counter = number_of_activations;
global_geometry_element.component_index = INDEX_CURRENT_COMP;
global_geometry_element.Volume = &this_box_volume; // Would be nicer if this m was a pointer, now we have the (small) data two places
add_element_to_geometry_list(&global_geometry_list,global_geometry_element);
}
#line 279557 "MACS_sample_kidney_box.c"
#undef number_of_activations
#undef mask_setting
#undef mask_string
#undef p_interact
#undef focus_r
#undef focus_xh
#undef focus_xw
#undef focus_ah
#undef focus_aw
#undef target_z
#undef target_y
#undef target_x
#undef target_index
#undef visualize
#undef yheight2
#undef xwidth2
#undef zdepth
#undef yheight
#undef xwidth
#undef priority
#undef material_string
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

  /* Initializations for component channel_13_cave1_box3. */
  SIG_MESSAGE("channel_13_cave1_box3 (Init)");
#define mccompcurname  channel_13_cave1_box3
#define mccompcurtype  Union_box
#define mccompcurindex 620
#define loop_index mccchannel_13_cave1_box3_loop_index
#define this_box_volume mccchannel_13_cave1_box3_this_box_volume
#define global_geometry_element mccchannel_13_cave1_box3_global_geometry_element
#define this_box_storage mccchannel_13_cave1_box3_this_box_storage
#define material_string mccchannel_13_cave1_box3_material_string
#define priority mccchannel_13_cave1_box3_priority
#define xwidth mccchannel_13_cave1_box3_xwidth
#define yheight mccchannel_13_cave1_box3_yheight
#define zdepth mccchannel_13_cave1_box3_zdepth
#define xwidth2 mccchannel_13_cave1_box3_xwidth2
#define yheight2 mccchannel_13_cave1_box3_yheight2
#define visualize mccchannel_13_cave1_box3_visualize
#define target_index mccchannel_13_cave1_box3_target_index
#define target_x mccchannel_13_cave1_box3_target_x
#define target_y mccchannel_13_cave1_box3_target_y
#define target_z mccchannel_13_cave1_box3_target_z
#define focus_aw mccchannel_13_cave1_box3_focus_aw
#define focus_ah mccchannel_13_cave1_box3_focus_ah
#define focus_xw mccchannel_13_cave1_box3_focus_xw
#define focus_xh mccchannel_13_cave1_box3_focus_xh
#define focus_r mccchannel_13_cave1_box3_focus_r
#define p_interact mccchannel_13_cave1_box3_p_interact
#define mask_string mccchannel_13_cave1_box3_mask_string
#define mask_setting mccchannel_13_cave1_box3_mask_setting
#define number_of_activations mccchannel_13_cave1_box3_number_of_activations
#line 224 "Union_box.comp"
{
// Initializes the focusing system for this volume including input sanitation.
focus_initialize(&this_box_volume.geometry, POS_A_COMP_INDEX(INDEX_CURRENT_COMP+target_index), POS_A_CURRENT_COMP, ROT_A_CURRENT_COMP, target_index, target_x, target_y, target_z, focus_aw, focus_ah, focus_xw, focus_xh, focus_r, NAME_CURRENT_COMP);

// Input sanitation for this geometry
if (xwidth <= 0) {
  printf("\nERROR in Union_box named %s, the xwidth is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (yheight <= 0) {
  printf("\nERROR in Union_box named %s, yheight is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (zdepth <= 0) {
  printf("\nERROR in Union_box named %s, zdepth is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (xwidth2 <= 0 && xwidth2 != -1) {
  printf("\nERROR in Union_box named %s, the xwidth2 is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (yheight2 <= 0 && yheight2 != -1) {
  printf("\nERROR in Union_box named %s, yheight2 is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}

// Use sanitation
if (global_material_list.num_elements == 0) {
  printf("\nERROR: Need to define a material using Union_make_material before using a Union geometry component. \n");
  printf("       %s was defined before first use of Union_make_material.\n",NAME_CURRENT_COMP);
  exit(1);
}

this_box_volume.geometry.is_masked_volume = 0;
this_box_volume.geometry.is_exit_volume = 0;
this_box_volume.geometry.is_mask_volume = 0;
// check if the volume is a mask, if it is the material string is irelevant.
if (mask_string && strlen(mask_string) && strcmp(mask_string, "NULL") && strcmp(mask_string, "0")) {
    // A mask volume is used to limit the extend of other volumes, called the masked volumes. These are specified in the mask_string.
    // In order for a ray to enter a masked volume, it needs to be both in the region covered by that volume AND the mask volume.
    // When more than
    this_box_volume.geometry.mask_mode = 1; // Default is mask mode is ALL
    if (mask_setting && strlen(mask_setting) && strcmp(mask_setting, "NULL") && strcmp(mask_setting, "0")) {
        if (strcmp(mask_setting,"ALL") == 0 || strcmp(mask_setting,"All") == 0) this_box_volume.geometry.mask_mode = 1;
        else if (strcmp(mask_setting,"ANY") == 0 || strcmp(mask_setting,"Any") == 0) this_box_volume.geometry.mask_mode = 2;
        else {
            printf("The mask_mode of component %s is set to %s, but must be either ALL or ANY.\n",NAME_CURRENT_COMP,mask_setting);
            exit(1);
        }
    }
    
    for (loop_index=0;loop_index<global_geometry_list.num_elements;loop_index++) {
        // Add mask list
        if (1 == manual_linking_function(global_geometry_list.elements[loop_index].name,mask_string)) {
            add_element_to_int_list(&this_box_volume.geometry.mask_list,global_geometry_list.elements[loop_index].component_index);
            add_element_to_int_list(&global_geometry_list.elements[loop_index].Volume->geometry.masked_by_list,INDEX_CURRENT_COMP);
            global_geometry_list.elements[loop_index].Volume->geometry.is_masked_volume = 1;
            if (this_box_volume.geometry.mask_mode == 2)
                global_geometry_list.elements[loop_index].Volume->geometry.mask_mode = 2;
            if (this_box_volume.geometry.mask_mode == 1) {
                if (global_geometry_list.elements[loop_index].Volume->geometry.is_masked_volume == 1 && global_geometry_list.elements[loop_index].Volume->geometry.mask_mode != 2)
                    // If more than one mask is added to one volume, the ANY mode overwrites the (default) ALL mode.
                    global_geometry_list.elements[loop_index].Volume->geometry.mask_mode = 1;
            }
            
            found_geometries = 1;
        }
    }
    if (found_geometries == 0) {
        printf("The mask_string in geometry: %s did not find any of the specified volumes in the mask_string %s \n",NAME_CURRENT_COMP,mask_string);
        exit(1);
    }
    this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
    this_box_volume.p_physics->is_vacuum = 0; // Makes this volume a vacuum
    this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
    this_box_volume.p_physics->my_a = 0; // Should not be used.
    sprintf(this_box_volume.p_physics->name,"Mask");
    this_box_volume.geometry.is_mask_volume = 1;
    
    
// Read the material input, or if it lacks, use automatic linking.
} else if (material_string && strlen(material_string) && strcmp(material_string, "NULL") && strcmp(material_string, "0")) {
    // A geometry string was given, use it to determine which material
    if (0 == strcmp(material_string,"vacuum") || 0 == strcmp(material_string,"Vacuum")) {
        // One could have a global physics struct for vacuum instead of creating one for each
        this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
        this_box_volume.p_physics->is_vacuum = 1; // Makes this volume a vacuum
        this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
        this_box_volume.p_physics->my_a = 0; // Should not be used.
        sprintf(this_box_volume.p_physics->name,"Vacuum");
    } else if (0 == strcmp(material_string,"exit") || 0 == strcmp(material_string,"Exit")) {
        // One could have a global physics struct for vacuum instead of creating one for each
        this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
        this_box_volume.p_physics->is_vacuum = 1; // Makes this volume a vacuum
        this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
        this_box_volume.p_physics->my_a = 0; // Should not be used.
        this_box_volume.geometry.is_exit_volume = 1;
        sprintf(this_box_volume.p_physics->name,"Exit");
    } else {
        #ifndef MATERIAL_DETECTOR
            printf("Need to define a material before refering to it in a geometry %s.\n",NAME_CURRENT_COMP);
            exit(1);
        #endif
        for (loop_index=0;loop_index<global_material_list.num_elements;loop_index++) {
            if (0 == strcmp(material_string,global_material_list.elements[loop_index].name)) {
                this_box_volume.p_physics = global_material_list.elements[loop_index].physics;
                break;
            }
            if (loop_index == global_material_list.num_elements-1) {
            printf("\n");
            printf("ERROR: The material string \"%s\" in Union geometry \"%s\" did not match a specified material. \n",material_string,NAME_CURRENT_COMP);
            printf("       The materials available at this point (need to be defined before the geometry): \n");
            for (loop_index=0;loop_index<global_material_list.num_elements;loop_index++)
              printf("         %s\n",global_material_list.elements[loop_index].name);
            printf("\n");
            printf("       It is also possible to use one of the defualt materials avaiable: \n");
            printf("           Vacuum (for a Volume without scattering or absorption)\n");
            printf("           Exit (for a Volume where the ray exits the component if it enters)\n");
            printf("           Mask (for a Volume that masks existing volumes specified in the mask_string\n");
            exit(1);
          }
        }
    }
} else {
    // Automatic linking, simply using the last defined material.
    #ifndef MATERIAL_DETECTOR
        printf("Need to define a material before the geometry to use automatic linking %s.\n",NAME_CURRENT_COMP);
        exit(1);
    #endif
    this_box_volume.p_physics = global_material_list.elements[global_material_list.num_elements-1].physics;
}

sprintf(this_box_volume.name,NAME_CURRENT_COMP);
sprintf(this_box_volume.geometry.shape,"box");
this_box_volume.geometry.priority_value = priority;
this_box_volume.geometry.geometry_p_interact = p_interact;
// Currently the coordinates will be in absolute space.
this_box_volume.geometry.center = POS_A_CURRENT_COMP;

this_box_storage.z_depth = zdepth;
this_box_storage.x_width1 = xwidth;
this_box_storage.y_height1 = yheight;

this_box_storage.is_rectangle = 0;
if (xwidth2 < 0 && yheight2 < 0) this_box_storage.is_rectangle = 1;
if (xwidth == xwidth2 && yheight == yheight2) this_box_storage.is_rectangle = 1;

if (xwidth2 < 0) {
    this_box_storage.x_width2 = xwidth;
    xwidth2 = xwidth;
} else this_box_storage.x_width2 = xwidth2;

if (yheight2 < 0) {
    this_box_storage.y_height2 = yheight;
    yheight2 = yheight;
} else this_box_storage.y_height2 = yheight2;


this_box_storage.normal_vectors[0] = coords_set(0,0,1);
this_box_storage.normal_vectors[1] = coords_set(0,0,1);

// for sides with y component = 0
x_component = 2*zdepth/sqrt((xwidth-xwidth2)*(xwidth-xwidth2)+4*zdepth*zdepth);
z_component = (xwidth-xwidth2)/sqrt(4*zdepth*zdepth+(xwidth-xwidth2)*(xwidth-xwidth2));

this_box_storage.normal_vectors[2] = coords_set(x_component,0,z_component);
this_box_storage.normal_vectors[3] = coords_set(-x_component,0,z_component);

// for sides with x component = 0
y_component = 2*zdepth/sqrt((yheight-yheight2)*(yheight-yheight2)+4*zdepth*zdepth);
z_component = (yheight-yheight2)/sqrt(4*zdepth*zdepth+(yheight-yheight2)*(yheight-yheight2));

this_box_storage.normal_vectors[4] = coords_set(0,y_component,z_component);
this_box_storage.normal_vectors[5] = coords_set(0,-y_component,z_component);

this_box_volume.geometry.visualization_on = visualize;

this_box_volume.geometry.geometry_parameters.p_box_storage = &this_box_storage;

// Assign pointers to functions for intersection with the shape, checking if a point is inside the shape
if (this_box_storage.is_rectangle == 1) {
this_box_volume.geometry.intersect_function = &sample_box_intersect_simple;
this_box_volume.geometry.within_function = &r_within_box_simple;
}
else {
this_box_volume.geometry.intersect_function = &sample_box_intersect_advanced;
this_box_volume.geometry.within_function = &r_within_box_advanced;
}

this_box_volume.geometry.shell_points = &box_shell_points;
this_box_volume.geometry.mcdisplay_function = &mcdisplay_box_function;
this_box_volume.geometry.initialize_from_main_function = &initialize_box_geometry_from_main_component;
this_box_volume.geometry.process_rot_allocated = 0;

this_box_volume.geometry.copy_geometry_parameters = &allocate_box_storage_copy;

rot_copy(this_box_volume.geometry.rotation_matrix,ROT_A_CURRENT_COMP); //check how ROT_R_CURRENT_COMP would work
rot_transpose(ROT_A_CURRENT_COMP,this_box_volume.geometry.transpose_rotation_matrix);

// Initialize loggers
this_box_volume.loggers.num_elements = 0;

// packing the information into the global_geometry_element, which is then included in the global_geometry_list.
sprintf(global_geometry_element.name,NAME_CURRENT_COMP);
global_geometry_element.activation_counter = number_of_activations;
global_geometry_element.component_index = INDEX_CURRENT_COMP;
global_geometry_element.Volume = &this_box_volume; // Would be nicer if this m was a pointer, now we have the (small) data two places
add_element_to_geometry_list(&global_geometry_list,global_geometry_element);
}
#line 279827 "MACS_sample_kidney_box.c"
#undef number_of_activations
#undef mask_setting
#undef mask_string
#undef p_interact
#undef focus_r
#undef focus_xh
#undef focus_xw
#undef focus_ah
#undef focus_aw
#undef target_z
#undef target_y
#undef target_x
#undef target_index
#undef visualize
#undef yheight2
#undef xwidth2
#undef zdepth
#undef yheight
#undef xwidth
#undef priority
#undef material_string
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

  /* Initializations for component channel_13_cave1_cyl1. */
  SIG_MESSAGE("channel_13_cave1_cyl1 (Init)");
#define mccompcurname  channel_13_cave1_cyl1
#define mccompcurtype  Union_cylinder
#define mccompcurindex 621
#define loop_index mccchannel_13_cave1_cyl1_loop_index
#define this_cylinder_volume mccchannel_13_cave1_cyl1_this_cylinder_volume
#define global_geometry_element mccchannel_13_cave1_cyl1_global_geometry_element
#define this_cylinder_storage mccchannel_13_cave1_cyl1_this_cylinder_storage
#define material_string mccchannel_13_cave1_cyl1_material_string
#define priority mccchannel_13_cave1_cyl1_priority
#define radius mccchannel_13_cave1_cyl1_radius
#define yheight mccchannel_13_cave1_cyl1_yheight
#define visualize mccchannel_13_cave1_cyl1_visualize
#define target_index mccchannel_13_cave1_cyl1_target_index
#define target_x mccchannel_13_cave1_cyl1_target_x
#define target_y mccchannel_13_cave1_cyl1_target_y
#define target_z mccchannel_13_cave1_cyl1_target_z
#define focus_aw mccchannel_13_cave1_cyl1_focus_aw
#define focus_ah mccchannel_13_cave1_cyl1_focus_ah
#define focus_xw mccchannel_13_cave1_cyl1_focus_xw
#define focus_xh mccchannel_13_cave1_cyl1_focus_xh
#define focus_r mccchannel_13_cave1_cyl1_focus_r
#define p_interact mccchannel_13_cave1_cyl1_p_interact
#define mask_string mccchannel_13_cave1_cyl1_mask_string
#define mask_setting mccchannel_13_cave1_cyl1_mask_setting
#define number_of_activations mccchannel_13_cave1_cyl1_number_of_activations
#line 185 "Union_cylinder.comp"
{
// Initializes the focusing system for this volume including input sanitation.
focus_initialize(&this_cylinder_volume.geometry, POS_A_COMP_INDEX(INDEX_CURRENT_COMP+target_index), POS_A_CURRENT_COMP, ROT_A_CURRENT_COMP, target_index, target_x, target_y, target_z, focus_aw, focus_ah, focus_xw, focus_xh, focus_r, NAME_CURRENT_COMP);

// Input sanitation for this geometry
if (radius <= 0) {
  printf("\nERROR in Union_cylinder named %s, the radius is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}

if (yheight <= 0) {
  printf("\nERROR in Union_cylinder named %s, yheight is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}

// Use sanitation
#ifdef MATERIAL_DETECTOR
if (global_material_list.num_elements == 0) {
  // Here if the user have defined a material, but only after this material
  printf("\nERROR: Need to define a material using Union_make_material before using a Union geometry component. \n");
  printf("       %s was defined before first use of Union_make_material.\n",NAME_CURRENT_COMP);
  exit(1);
}
#endif
#ifndef MATERIAL_DETECTOR
  printf("\nERROR: Need to define a material using Union_make_material before using a Union geometry component. \n");
  exit(1);
#endif


this_cylinder_volume.geometry.is_masked_volume = 0;
this_cylinder_volume.geometry.is_exit_volume = 0;
this_cylinder_volume.geometry.is_mask_volume = 0;

// Read the material input, or if it lacks, use automatic linking.
if (mask_string && strlen(mask_string) && strcmp(mask_string, "NULL") && strcmp(mask_string, "0")) {
    // A mask volume is used to limit the extend of other volumes, called the masked volumes. These are specified in the mask_string.
    // In order for a ray to enter a masked volume, it needs to be both in the region covered by that volume AND the mask volume.
    // When more than
    this_cylinder_volume.geometry.mask_mode = 1; // Default is mask mode is ALL
    if (mask_setting && strlen(mask_setting) && strcmp(mask_setting, "NULL") && strcmp(mask_setting, "0")) {
        if (strcmp(mask_setting,"ALL") == 0 || strcmp(mask_setting,"All") == 0) this_cylinder_volume.geometry.mask_mode = 1;
        else if (strcmp(mask_setting,"ANY") == 0 || strcmp(mask_setting,"Any") == 0) this_cylinder_volume.geometry.mask_mode = 2;
        else {
            printf("The mask_mode of component %s is set to %s, but must be either ALL or ANY.\n",NAME_CURRENT_COMP,mask_setting);
            exit(1);
        }
    }
    
    for (loop_index=0;loop_index<global_geometry_list.num_elements;loop_index++) {
        // Add mask list
        if (1 == manual_linking_function(global_geometry_list.elements[loop_index].name,mask_string)) {
            add_element_to_int_list(&this_cylinder_volume.geometry.mask_list,global_geometry_list.elements[loop_index].component_index);
            add_element_to_int_list(&global_geometry_list.elements[loop_index].Volume->geometry.masked_by_list,INDEX_CURRENT_COMP);
            global_geometry_list.elements[loop_index].Volume->geometry.is_masked_volume = 1;
            if (this_cylinder_volume.geometry.mask_mode == 2)
                global_geometry_list.elements[loop_index].Volume->geometry.mask_mode = 2;
            if (this_cylinder_volume.geometry.mask_mode == 1) {
                if (global_geometry_list.elements[loop_index].Volume->geometry.is_masked_volume == 1 && global_geometry_list.elements[loop_index].Volume->geometry.mask_mode != 2)
                    // If more than one mask is added to one volume, the ANY mode overwrites the (default) ALL mode.
                    global_geometry_list.elements[loop_index].Volume->geometry.mask_mode = 1;
            }
            
            found_geometries = 1;
        }
    }
    if (found_geometries == 0) {
        printf("The mask_string in geometry: %s did not find any of the specified volumes in the mask_string %s \n",NAME_CURRENT_COMP,mask_string);
        exit(1);
    }
    this_cylinder_volume.p_physics = malloc(sizeof(struct physics_struct));
    this_cylinder_volume.p_physics->is_vacuum = 0; // Makes this volume a vacuum
    this_cylinder_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
    this_cylinder_volume.p_physics->my_a = 0; // Should not be used.
    sprintf(this_cylinder_volume.p_physics->name,"Mask");
    this_cylinder_volume.geometry.is_mask_volume = 1;
    
    
// Read the material input, or if it lacks, use automatic linking.
} else if (material_string && strlen(material_string) && strcmp(material_string, "NULL") && strcmp(material_string, "0")) {
    // A geometry string was given, use it to determine which material
    if (0 == strcmp(material_string,"vacuum") || 0 == strcmp(material_string,"Vacuum")) {
        // One could have a global physics struct for vacuum instead of creating one for each
        this_cylinder_volume.p_physics = malloc(sizeof(struct physics_struct));
        this_cylinder_volume.p_physics->is_vacuum = 1; // Makes this volume a vacuum
        this_cylinder_volume.p_physics->number_of_processes = (int) 0;
        this_cylinder_volume.p_physics->my_a = 0; // Should not be used.
        sprintf(this_cylinder_volume.p_physics->name,"Vacuum");
    } else if (0 == strcmp(material_string,"exit") || 0 == strcmp(material_string,"Exit")) {
        // One could have a global physics struct for exit instead of creating one for each
        this_cylinder_volume.p_physics = malloc(sizeof(struct physics_struct));
        this_cylinder_volume.p_physics->is_vacuum = 1; // Makes this volume a vacuum
        this_cylinder_volume.p_physics->number_of_processes = (int) 0;
        this_cylinder_volume.p_physics->my_a = 0; // Should not be used.
        this_cylinder_volume.geometry.is_exit_volume = 1;
        sprintf(this_cylinder_volume.p_physics->name,"Exit");
    } else {
        for (loop_index=0;loop_index<global_material_list.num_elements;loop_index++) {
          if (0 == strcmp(material_string,global_material_list.elements[loop_index].name)) {
            this_cylinder_volume.p_physics = global_material_list.elements[loop_index].physics;
            break;
          }
          if (loop_index == global_material_list.num_elements-1) {
            printf("\n");
            printf("ERROR: The material string \"%s\" in Union geometry \"%s\" did not match a specified material. \n",material_string,NAME_CURRENT_COMP);
            printf("       The materials available at this point (need to be defined before the geometry): \n");
            for (loop_index=0;loop_index<global_material_list.num_elements;loop_index++)
              printf("         %s\n",global_material_list.elements[loop_index].name);
            printf("\n");
            printf("       It is also possible to use one of the defualt materials avaiable: \n");
            printf("           Vacuum (for a Volume without scattering or absorption)\n");
            printf("           Exit (for a Volume where the ray exits the component if it enters)\n");
            printf("           Mask (for a Volume that masks existing volumes specified in the mask_string\n");
            exit(1);
          }
        }
    }
} else {
    // Automatic linking, simply using the last defined material.
    #ifndef MATERIAL_DETECTOR
        printf("Need to define a material before the geometry to use automatic linking %s.\n",NAME_CURRENT_COMP);
        exit(1);
    #endif
    this_cylinder_volume.p_physics = global_material_list.elements[global_material_list.num_elements-1].physics;
}

sprintf(this_cylinder_volume.name,NAME_CURRENT_COMP);
sprintf(this_cylinder_volume.geometry.shape,"cylinder");
this_cylinder_volume.geometry.priority_value = priority;
// Currently the coordinates will be in absolute space.
this_cylinder_volume.geometry.center = POS_A_CURRENT_COMP;

this_cylinder_volume.geometry.geometry_p_interact = p_interact;
this_cylinder_storage.cyl_radius = radius;
this_cylinder_storage.height = yheight;
this_cylinder_volume.geometry.visualization_on = visualize;
this_cylinder_volume.geometry.geometry_parameters.p_cylinder_storage = &this_cylinder_storage;
this_cylinder_volume.geometry.within_function = &r_within_cylinder;
this_cylinder_volume.geometry.intersect_function = &sample_cylinder_intersect;
this_cylinder_volume.geometry.mcdisplay_function = &mcdisplay_cylinder_function;
this_cylinder_volume.geometry.shell_points = &cylinder_shell_points;
this_cylinder_volume.geometry.initialize_from_main_function = &initialize_cylinder_geometry_from_main_component;
this_cylinder_volume.geometry.process_rot_allocated = 0;
this_cylinder_volume.geometry.copy_geometry_parameters = &allocate_cylinder_storage_copy;

rot_copy(this_cylinder_volume.geometry.rotation_matrix,ROT_A_CURRENT_COMP);
rot_transpose(ROT_A_CURRENT_COMP,this_cylinder_volume.geometry.transpose_rotation_matrix);

// Initialize loggers
this_cylinder_volume.loggers.num_elements = 0;

// packing the information into the global_geometry_element, which is then included in the global_geometry_list.
sprintf(global_geometry_element.name,NAME_CURRENT_COMP);
global_geometry_element.activation_counter = number_of_activations;
global_geometry_element.component_index = INDEX_CURRENT_COMP;
global_geometry_element.Volume = &this_cylinder_volume; // Would be nicer if this m was a pointer, now we have the (small) data two places
add_element_to_geometry_list(&global_geometry_list,global_geometry_element);
}
#line 280043 "MACS_sample_kidney_box.c"
#undef number_of_activations
#undef mask_setting
#undef mask_string
#undef p_interact
#undef focus_r
#undef focus_xh
#undef focus_xw
#undef focus_ah
#undef focus_aw
#undef target_z
#undef target_y
#undef target_x
#undef target_index
#undef visualize
#undef yheight
#undef radius
#undef priority
#undef material_string
#undef this_cylinder_storage
#undef global_geometry_element
#undef this_cylinder_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

  /* Initializations for component channel_13_analyzer_1_center. */
  SIG_MESSAGE("channel_13_analyzer_1_center (Init)");

  /* Initializations for component channel_13_analyzer_1_rotated. */
  SIG_MESSAGE("channel_13_analyzer_1_rotated (Init)");

  /* Initializations for component channel_13_analyzer_1_array_crystal_array_0. */
  SIG_MESSAGE("channel_13_analyzer_1_array_crystal_array_0 (Init)");
#define mccompcurname  channel_13_analyzer_1_array_crystal_array_0
#define mccompcurtype  Union_box
#define mccompcurindex 624
#define loop_index mccchannel_13_analyzer_1_array_crystal_array_0_loop_index
#define this_box_volume mccchannel_13_analyzer_1_array_crystal_array_0_this_box_volume
#define global_geometry_element mccchannel_13_analyzer_1_array_crystal_array_0_global_geometry_element
#define this_box_storage mccchannel_13_analyzer_1_array_crystal_array_0_this_box_storage
#define material_string mccchannel_13_analyzer_1_array_crystal_array_0_material_string
#define priority mccchannel_13_analyzer_1_array_crystal_array_0_priority
#define xwidth mccchannel_13_analyzer_1_array_crystal_array_0_xwidth
#define yheight mccchannel_13_analyzer_1_array_crystal_array_0_yheight
#define zdepth mccchannel_13_analyzer_1_array_crystal_array_0_zdepth
#define xwidth2 mccchannel_13_analyzer_1_array_crystal_array_0_xwidth2
#define yheight2 mccchannel_13_analyzer_1_array_crystal_array_0_yheight2
#define visualize mccchannel_13_analyzer_1_array_crystal_array_0_visualize
#define target_index mccchannel_13_analyzer_1_array_crystal_array_0_target_index
#define target_x mccchannel_13_analyzer_1_array_crystal_array_0_target_x
#define target_y mccchannel_13_analyzer_1_array_crystal_array_0_target_y
#define target_z mccchannel_13_analyzer_1_array_crystal_array_0_target_z
#define focus_aw mccchannel_13_analyzer_1_array_crystal_array_0_focus_aw
#define focus_ah mccchannel_13_analyzer_1_array_crystal_array_0_focus_ah
#define focus_xw mccchannel_13_analyzer_1_array_crystal_array_0_focus_xw
#define focus_xh mccchannel_13_analyzer_1_array_crystal_array_0_focus_xh
#define focus_r mccchannel_13_analyzer_1_array_crystal_array_0_focus_r
#define p_interact mccchannel_13_analyzer_1_array_crystal_array_0_p_interact
#define mask_string mccchannel_13_analyzer_1_array_crystal_array_0_mask_string
#define mask_setting mccchannel_13_analyzer_1_array_crystal_array_0_mask_setting
#define number_of_activations mccchannel_13_analyzer_1_array_crystal_array_0_number_of_activations
#line 224 "Union_box.comp"
{
// Initializes the focusing system for this volume including input sanitation.
focus_initialize(&this_box_volume.geometry, POS_A_COMP_INDEX(INDEX_CURRENT_COMP+target_index), POS_A_CURRENT_COMP, ROT_A_CURRENT_COMP, target_index, target_x, target_y, target_z, focus_aw, focus_ah, focus_xw, focus_xh, focus_r, NAME_CURRENT_COMP);

// Input sanitation for this geometry
if (xwidth <= 0) {
  printf("\nERROR in Union_box named %s, the xwidth is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (yheight <= 0) {
  printf("\nERROR in Union_box named %s, yheight is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (zdepth <= 0) {
  printf("\nERROR in Union_box named %s, zdepth is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (xwidth2 <= 0 && xwidth2 != -1) {
  printf("\nERROR in Union_box named %s, the xwidth2 is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (yheight2 <= 0 && yheight2 != -1) {
  printf("\nERROR in Union_box named %s, yheight2 is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}

// Use sanitation
if (global_material_list.num_elements == 0) {
  printf("\nERROR: Need to define a material using Union_make_material before using a Union geometry component. \n");
  printf("       %s was defined before first use of Union_make_material.\n",NAME_CURRENT_COMP);
  exit(1);
}

this_box_volume.geometry.is_masked_volume = 0;
this_box_volume.geometry.is_exit_volume = 0;
this_box_volume.geometry.is_mask_volume = 0;
// check if the volume is a mask, if it is the material string is irelevant.
if (mask_string && strlen(mask_string) && strcmp(mask_string, "NULL") && strcmp(mask_string, "0")) {
    // A mask volume is used to limit the extend of other volumes, called the masked volumes. These are specified in the mask_string.
    // In order for a ray to enter a masked volume, it needs to be both in the region covered by that volume AND the mask volume.
    // When more than
    this_box_volume.geometry.mask_mode = 1; // Default is mask mode is ALL
    if (mask_setting && strlen(mask_setting) && strcmp(mask_setting, "NULL") && strcmp(mask_setting, "0")) {
        if (strcmp(mask_setting,"ALL") == 0 || strcmp(mask_setting,"All") == 0) this_box_volume.geometry.mask_mode = 1;
        else if (strcmp(mask_setting,"ANY") == 0 || strcmp(mask_setting,"Any") == 0) this_box_volume.geometry.mask_mode = 2;
        else {
            printf("The mask_mode of component %s is set to %s, but must be either ALL or ANY.\n",NAME_CURRENT_COMP,mask_setting);
            exit(1);
        }
    }
    
    for (loop_index=0;loop_index<global_geometry_list.num_elements;loop_index++) {
        // Add mask list
        if (1 == manual_linking_function(global_geometry_list.elements[loop_index].name,mask_string)) {
            add_element_to_int_list(&this_box_volume.geometry.mask_list,global_geometry_list.elements[loop_index].component_index);
            add_element_to_int_list(&global_geometry_list.elements[loop_index].Volume->geometry.masked_by_list,INDEX_CURRENT_COMP);
            global_geometry_list.elements[loop_index].Volume->geometry.is_masked_volume = 1;
            if (this_box_volume.geometry.mask_mode == 2)
                global_geometry_list.elements[loop_index].Volume->geometry.mask_mode = 2;
            if (this_box_volume.geometry.mask_mode == 1) {
                if (global_geometry_list.elements[loop_index].Volume->geometry.is_masked_volume == 1 && global_geometry_list.elements[loop_index].Volume->geometry.mask_mode != 2)
                    // If more than one mask is added to one volume, the ANY mode overwrites the (default) ALL mode.
                    global_geometry_list.elements[loop_index].Volume->geometry.mask_mode = 1;
            }
            
            found_geometries = 1;
        }
    }
    if (found_geometries == 0) {
        printf("The mask_string in geometry: %s did not find any of the specified volumes in the mask_string %s \n",NAME_CURRENT_COMP,mask_string);
        exit(1);
    }
    this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
    this_box_volume.p_physics->is_vacuum = 0; // Makes this volume a vacuum
    this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
    this_box_volume.p_physics->my_a = 0; // Should not be used.
    sprintf(this_box_volume.p_physics->name,"Mask");
    this_box_volume.geometry.is_mask_volume = 1;
    
    
// Read the material input, or if it lacks, use automatic linking.
} else if (material_string && strlen(material_string) && strcmp(material_string, "NULL") && strcmp(material_string, "0")) {
    // A geometry string was given, use it to determine which material
    if (0 == strcmp(material_string,"vacuum") || 0 == strcmp(material_string,"Vacuum")) {
        // One could have a global physics struct for vacuum instead of creating one for each
        this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
        this_box_volume.p_physics->is_vacuum = 1; // Makes this volume a vacuum
        this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
        this_box_volume.p_physics->my_a = 0; // Should not be used.
        sprintf(this_box_volume.p_physics->name,"Vacuum");
    } else if (0 == strcmp(material_string,"exit") || 0 == strcmp(material_string,"Exit")) {
        // One could have a global physics struct for vacuum instead of creating one for each
        this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
        this_box_volume.p_physics->is_vacuum = 1; // Makes this volume a vacuum
        this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
        this_box_volume.p_physics->my_a = 0; // Should not be used.
        this_box_volume.geometry.is_exit_volume = 1;
        sprintf(this_box_volume.p_physics->name,"Exit");
    } else {
        #ifndef MATERIAL_DETECTOR
            printf("Need to define a material before refering to it in a geometry %s.\n",NAME_CURRENT_COMP);
            exit(1);
        #endif
        for (loop_index=0;loop_index<global_material_list.num_elements;loop_index++) {
            if (0 == strcmp(material_string,global_material_list.elements[loop_index].name)) {
                this_box_volume.p_physics = global_material_list.elements[loop_index].physics;
                break;
            }
            if (loop_index == global_material_list.num_elements-1) {
            printf("\n");
            printf("ERROR: The material string \"%s\" in Union geometry \"%s\" did not match a specified material. \n",material_string,NAME_CURRENT_COMP);
            printf("       The materials available at this point (need to be defined before the geometry): \n");
            for (loop_index=0;loop_index<global_material_list.num_elements;loop_index++)
              printf("         %s\n",global_material_list.elements[loop_index].name);
            printf("\n");
            printf("       It is also possible to use one of the defualt materials avaiable: \n");
            printf("           Vacuum (for a Volume without scattering or absorption)\n");
            printf("           Exit (for a Volume where the ray exits the component if it enters)\n");
            printf("           Mask (for a Volume that masks existing volumes specified in the mask_string\n");
            exit(1);
          }
        }
    }
} else {
    // Automatic linking, simply using the last defined material.
    #ifndef MATERIAL_DETECTOR
        printf("Need to define a material before the geometry to use automatic linking %s.\n",NAME_CURRENT_COMP);
        exit(1);
    #endif
    this_box_volume.p_physics = global_material_list.elements[global_material_list.num_elements-1].physics;
}

sprintf(this_box_volume.name,NAME_CURRENT_COMP);
sprintf(this_box_volume.geometry.shape,"box");
this_box_volume.geometry.priority_value = priority;
this_box_volume.geometry.geometry_p_interact = p_interact;
// Currently the coordinates will be in absolute space.
this_box_volume.geometry.center = POS_A_CURRENT_COMP;

this_box_storage.z_depth = zdepth;
this_box_storage.x_width1 = xwidth;
this_box_storage.y_height1 = yheight;

this_box_storage.is_rectangle = 0;
if (xwidth2 < 0 && yheight2 < 0) this_box_storage.is_rectangle = 1;
if (xwidth == xwidth2 && yheight == yheight2) this_box_storage.is_rectangle = 1;

if (xwidth2 < 0) {
    this_box_storage.x_width2 = xwidth;
    xwidth2 = xwidth;
} else this_box_storage.x_width2 = xwidth2;

if (yheight2 < 0) {
    this_box_storage.y_height2 = yheight;
    yheight2 = yheight;
} else this_box_storage.y_height2 = yheight2;


this_box_storage.normal_vectors[0] = coords_set(0,0,1);
this_box_storage.normal_vectors[1] = coords_set(0,0,1);

// for sides with y component = 0
x_component = 2*zdepth/sqrt((xwidth-xwidth2)*(xwidth-xwidth2)+4*zdepth*zdepth);
z_component = (xwidth-xwidth2)/sqrt(4*zdepth*zdepth+(xwidth-xwidth2)*(xwidth-xwidth2));

this_box_storage.normal_vectors[2] = coords_set(x_component,0,z_component);
this_box_storage.normal_vectors[3] = coords_set(-x_component,0,z_component);

// for sides with x component = 0
y_component = 2*zdepth/sqrt((yheight-yheight2)*(yheight-yheight2)+4*zdepth*zdepth);
z_component = (yheight-yheight2)/sqrt(4*zdepth*zdepth+(yheight-yheight2)*(yheight-yheight2));

this_box_storage.normal_vectors[4] = coords_set(0,y_component,z_component);
this_box_storage.normal_vectors[5] = coords_set(0,-y_component,z_component);

this_box_volume.geometry.visualization_on = visualize;

this_box_volume.geometry.geometry_parameters.p_box_storage = &this_box_storage;

// Assign pointers to functions for intersection with the shape, checking if a point is inside the shape
if (this_box_storage.is_rectangle == 1) {
this_box_volume.geometry.intersect_function = &sample_box_intersect_simple;
this_box_volume.geometry.within_function = &r_within_box_simple;
}
else {
this_box_volume.geometry.intersect_function = &sample_box_intersect_advanced;
this_box_volume.geometry.within_function = &r_within_box_advanced;
}

this_box_volume.geometry.shell_points = &box_shell_points;
this_box_volume.geometry.mcdisplay_function = &mcdisplay_box_function;
this_box_volume.geometry.initialize_from_main_function = &initialize_box_geometry_from_main_component;
this_box_volume.geometry.process_rot_allocated = 0;

this_box_volume.geometry.copy_geometry_parameters = &allocate_box_storage_copy;

rot_copy(this_box_volume.geometry.rotation_matrix,ROT_A_CURRENT_COMP); //check how ROT_R_CURRENT_COMP would work
rot_transpose(ROT_A_CURRENT_COMP,this_box_volume.geometry.transpose_rotation_matrix);

// Initialize loggers
this_box_volume.loggers.num_elements = 0;

// packing the information into the global_geometry_element, which is then included in the global_geometry_list.
sprintf(global_geometry_element.name,NAME_CURRENT_COMP);
global_geometry_element.activation_counter = number_of_activations;
global_geometry_element.component_index = INDEX_CURRENT_COMP;
global_geometry_element.Volume = &this_box_volume; // Would be nicer if this m was a pointer, now we have the (small) data two places
add_element_to_geometry_list(&global_geometry_list,global_geometry_element);
}
#line 280316 "MACS_sample_kidney_box.c"
#undef number_of_activations
#undef mask_setting
#undef mask_string
#undef p_interact
#undef focus_r
#undef focus_xh
#undef focus_xw
#undef focus_ah
#undef focus_aw
#undef target_z
#undef target_y
#undef target_x
#undef target_index
#undef visualize
#undef yheight2
#undef xwidth2
#undef zdepth
#undef yheight
#undef xwidth
#undef priority
#undef material_string
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

  /* Initializations for component channel_13_analyzer_1_array_crystal_array_1. */
  SIG_MESSAGE("channel_13_analyzer_1_array_crystal_array_1 (Init)");
#define mccompcurname  channel_13_analyzer_1_array_crystal_array_1
#define mccompcurtype  Union_box
#define mccompcurindex 625
#define loop_index mccchannel_13_analyzer_1_array_crystal_array_1_loop_index
#define this_box_volume mccchannel_13_analyzer_1_array_crystal_array_1_this_box_volume
#define global_geometry_element mccchannel_13_analyzer_1_array_crystal_array_1_global_geometry_element
#define this_box_storage mccchannel_13_analyzer_1_array_crystal_array_1_this_box_storage
#define material_string mccchannel_13_analyzer_1_array_crystal_array_1_material_string
#define priority mccchannel_13_analyzer_1_array_crystal_array_1_priority
#define xwidth mccchannel_13_analyzer_1_array_crystal_array_1_xwidth
#define yheight mccchannel_13_analyzer_1_array_crystal_array_1_yheight
#define zdepth mccchannel_13_analyzer_1_array_crystal_array_1_zdepth
#define xwidth2 mccchannel_13_analyzer_1_array_crystal_array_1_xwidth2
#define yheight2 mccchannel_13_analyzer_1_array_crystal_array_1_yheight2
#define visualize mccchannel_13_analyzer_1_array_crystal_array_1_visualize
#define target_index mccchannel_13_analyzer_1_array_crystal_array_1_target_index
#define target_x mccchannel_13_analyzer_1_array_crystal_array_1_target_x
#define target_y mccchannel_13_analyzer_1_array_crystal_array_1_target_y
#define target_z mccchannel_13_analyzer_1_array_crystal_array_1_target_z
#define focus_aw mccchannel_13_analyzer_1_array_crystal_array_1_focus_aw
#define focus_ah mccchannel_13_analyzer_1_array_crystal_array_1_focus_ah
#define focus_xw mccchannel_13_analyzer_1_array_crystal_array_1_focus_xw
#define focus_xh mccchannel_13_analyzer_1_array_crystal_array_1_focus_xh
#define focus_r mccchannel_13_analyzer_1_array_crystal_array_1_focus_r
#define p_interact mccchannel_13_analyzer_1_array_crystal_array_1_p_interact
#define mask_string mccchannel_13_analyzer_1_array_crystal_array_1_mask_string
#define mask_setting mccchannel_13_analyzer_1_array_crystal_array_1_mask_setting
#define number_of_activations mccchannel_13_analyzer_1_array_crystal_array_1_number_of_activations
#line 224 "Union_box.comp"
{
// Initializes the focusing system for this volume including input sanitation.
focus_initialize(&this_box_volume.geometry, POS_A_COMP_INDEX(INDEX_CURRENT_COMP+target_index), POS_A_CURRENT_COMP, ROT_A_CURRENT_COMP, target_index, target_x, target_y, target_z, focus_aw, focus_ah, focus_xw, focus_xh, focus_r, NAME_CURRENT_COMP);

// Input sanitation for this geometry
if (xwidth <= 0) {
  printf("\nERROR in Union_box named %s, the xwidth is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (yheight <= 0) {
  printf("\nERROR in Union_box named %s, yheight is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (zdepth <= 0) {
  printf("\nERROR in Union_box named %s, zdepth is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (xwidth2 <= 0 && xwidth2 != -1) {
  printf("\nERROR in Union_box named %s, the xwidth2 is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (yheight2 <= 0 && yheight2 != -1) {
  printf("\nERROR in Union_box named %s, yheight2 is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}

// Use sanitation
if (global_material_list.num_elements == 0) {
  printf("\nERROR: Need to define a material using Union_make_material before using a Union geometry component. \n");
  printf("       %s was defined before first use of Union_make_material.\n",NAME_CURRENT_COMP);
  exit(1);
}

this_box_volume.geometry.is_masked_volume = 0;
this_box_volume.geometry.is_exit_volume = 0;
this_box_volume.geometry.is_mask_volume = 0;
// check if the volume is a mask, if it is the material string is irelevant.
if (mask_string && strlen(mask_string) && strcmp(mask_string, "NULL") && strcmp(mask_string, "0")) {
    // A mask volume is used to limit the extend of other volumes, called the masked volumes. These are specified in the mask_string.
    // In order for a ray to enter a masked volume, it needs to be both in the region covered by that volume AND the mask volume.
    // When more than
    this_box_volume.geometry.mask_mode = 1; // Default is mask mode is ALL
    if (mask_setting && strlen(mask_setting) && strcmp(mask_setting, "NULL") && strcmp(mask_setting, "0")) {
        if (strcmp(mask_setting,"ALL") == 0 || strcmp(mask_setting,"All") == 0) this_box_volume.geometry.mask_mode = 1;
        else if (strcmp(mask_setting,"ANY") == 0 || strcmp(mask_setting,"Any") == 0) this_box_volume.geometry.mask_mode = 2;
        else {
            printf("The mask_mode of component %s is set to %s, but must be either ALL or ANY.\n",NAME_CURRENT_COMP,mask_setting);
            exit(1);
        }
    }
    
    for (loop_index=0;loop_index<global_geometry_list.num_elements;loop_index++) {
        // Add mask list
        if (1 == manual_linking_function(global_geometry_list.elements[loop_index].name,mask_string)) {
            add_element_to_int_list(&this_box_volume.geometry.mask_list,global_geometry_list.elements[loop_index].component_index);
            add_element_to_int_list(&global_geometry_list.elements[loop_index].Volume->geometry.masked_by_list,INDEX_CURRENT_COMP);
            global_geometry_list.elements[loop_index].Volume->geometry.is_masked_volume = 1;
            if (this_box_volume.geometry.mask_mode == 2)
                global_geometry_list.elements[loop_index].Volume->geometry.mask_mode = 2;
            if (this_box_volume.geometry.mask_mode == 1) {
                if (global_geometry_list.elements[loop_index].Volume->geometry.is_masked_volume == 1 && global_geometry_list.elements[loop_index].Volume->geometry.mask_mode != 2)
                    // If more than one mask is added to one volume, the ANY mode overwrites the (default) ALL mode.
                    global_geometry_list.elements[loop_index].Volume->geometry.mask_mode = 1;
            }
            
            found_geometries = 1;
        }
    }
    if (found_geometries == 0) {
        printf("The mask_string in geometry: %s did not find any of the specified volumes in the mask_string %s \n",NAME_CURRENT_COMP,mask_string);
        exit(1);
    }
    this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
    this_box_volume.p_physics->is_vacuum = 0; // Makes this volume a vacuum
    this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
    this_box_volume.p_physics->my_a = 0; // Should not be used.
    sprintf(this_box_volume.p_physics->name,"Mask");
    this_box_volume.geometry.is_mask_volume = 1;
    
    
// Read the material input, or if it lacks, use automatic linking.
} else if (material_string && strlen(material_string) && strcmp(material_string, "NULL") && strcmp(material_string, "0")) {
    // A geometry string was given, use it to determine which material
    if (0 == strcmp(material_string,"vacuum") || 0 == strcmp(material_string,"Vacuum")) {
        // One could have a global physics struct for vacuum instead of creating one for each
        this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
        this_box_volume.p_physics->is_vacuum = 1; // Makes this volume a vacuum
        this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
        this_box_volume.p_physics->my_a = 0; // Should not be used.
        sprintf(this_box_volume.p_physics->name,"Vacuum");
    } else if (0 == strcmp(material_string,"exit") || 0 == strcmp(material_string,"Exit")) {
        // One could have a global physics struct for vacuum instead of creating one for each
        this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
        this_box_volume.p_physics->is_vacuum = 1; // Makes this volume a vacuum
        this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
        this_box_volume.p_physics->my_a = 0; // Should not be used.
        this_box_volume.geometry.is_exit_volume = 1;
        sprintf(this_box_volume.p_physics->name,"Exit");
    } else {
        #ifndef MATERIAL_DETECTOR
            printf("Need to define a material before refering to it in a geometry %s.\n",NAME_CURRENT_COMP);
            exit(1);
        #endif
        for (loop_index=0;loop_index<global_material_list.num_elements;loop_index++) {
            if (0 == strcmp(material_string,global_material_list.elements[loop_index].name)) {
                this_box_volume.p_physics = global_material_list.elements[loop_index].physics;
                break;
            }
            if (loop_index == global_material_list.num_elements-1) {
            printf("\n");
            printf("ERROR: The material string \"%s\" in Union geometry \"%s\" did not match a specified material. \n",material_string,NAME_CURRENT_COMP);
            printf("       The materials available at this point (need to be defined before the geometry): \n");
            for (loop_index=0;loop_index<global_material_list.num_elements;loop_index++)
              printf("         %s\n",global_material_list.elements[loop_index].name);
            printf("\n");
            printf("       It is also possible to use one of the defualt materials avaiable: \n");
            printf("           Vacuum (for a Volume without scattering or absorption)\n");
            printf("           Exit (for a Volume where the ray exits the component if it enters)\n");
            printf("           Mask (for a Volume that masks existing volumes specified in the mask_string\n");
            exit(1);
          }
        }
    }
} else {
    // Automatic linking, simply using the last defined material.
    #ifndef MATERIAL_DETECTOR
        printf("Need to define a material before the geometry to use automatic linking %s.\n",NAME_CURRENT_COMP);
        exit(1);
    #endif
    this_box_volume.p_physics = global_material_list.elements[global_material_list.num_elements-1].physics;
}

sprintf(this_box_volume.name,NAME_CURRENT_COMP);
sprintf(this_box_volume.geometry.shape,"box");
this_box_volume.geometry.priority_value = priority;
this_box_volume.geometry.geometry_p_interact = p_interact;
// Currently the coordinates will be in absolute space.
this_box_volume.geometry.center = POS_A_CURRENT_COMP;

this_box_storage.z_depth = zdepth;
this_box_storage.x_width1 = xwidth;
this_box_storage.y_height1 = yheight;

this_box_storage.is_rectangle = 0;
if (xwidth2 < 0 && yheight2 < 0) this_box_storage.is_rectangle = 1;
if (xwidth == xwidth2 && yheight == yheight2) this_box_storage.is_rectangle = 1;

if (xwidth2 < 0) {
    this_box_storage.x_width2 = xwidth;
    xwidth2 = xwidth;
} else this_box_storage.x_width2 = xwidth2;

if (yheight2 < 0) {
    this_box_storage.y_height2 = yheight;
    yheight2 = yheight;
} else this_box_storage.y_height2 = yheight2;


this_box_storage.normal_vectors[0] = coords_set(0,0,1);
this_box_storage.normal_vectors[1] = coords_set(0,0,1);

// for sides with y component = 0
x_component = 2*zdepth/sqrt((xwidth-xwidth2)*(xwidth-xwidth2)+4*zdepth*zdepth);
z_component = (xwidth-xwidth2)/sqrt(4*zdepth*zdepth+(xwidth-xwidth2)*(xwidth-xwidth2));

this_box_storage.normal_vectors[2] = coords_set(x_component,0,z_component);
this_box_storage.normal_vectors[3] = coords_set(-x_component,0,z_component);

// for sides with x component = 0
y_component = 2*zdepth/sqrt((yheight-yheight2)*(yheight-yheight2)+4*zdepth*zdepth);
z_component = (yheight-yheight2)/sqrt(4*zdepth*zdepth+(yheight-yheight2)*(yheight-yheight2));

this_box_storage.normal_vectors[4] = coords_set(0,y_component,z_component);
this_box_storage.normal_vectors[5] = coords_set(0,-y_component,z_component);

this_box_volume.geometry.visualization_on = visualize;

this_box_volume.geometry.geometry_parameters.p_box_storage = &this_box_storage;

// Assign pointers to functions for intersection with the shape, checking if a point is inside the shape
if (this_box_storage.is_rectangle == 1) {
this_box_volume.geometry.intersect_function = &sample_box_intersect_simple;
this_box_volume.geometry.within_function = &r_within_box_simple;
}
else {
this_box_volume.geometry.intersect_function = &sample_box_intersect_advanced;
this_box_volume.geometry.within_function = &r_within_box_advanced;
}

this_box_volume.geometry.shell_points = &box_shell_points;
this_box_volume.geometry.mcdisplay_function = &mcdisplay_box_function;
this_box_volume.geometry.initialize_from_main_function = &initialize_box_geometry_from_main_component;
this_box_volume.geometry.process_rot_allocated = 0;

this_box_volume.geometry.copy_geometry_parameters = &allocate_box_storage_copy;

rot_copy(this_box_volume.geometry.rotation_matrix,ROT_A_CURRENT_COMP); //check how ROT_R_CURRENT_COMP would work
rot_transpose(ROT_A_CURRENT_COMP,this_box_volume.geometry.transpose_rotation_matrix);

// Initialize loggers
this_box_volume.loggers.num_elements = 0;

// packing the information into the global_geometry_element, which is then included in the global_geometry_list.
sprintf(global_geometry_element.name,NAME_CURRENT_COMP);
global_geometry_element.activation_counter = number_of_activations;
global_geometry_element.component_index = INDEX_CURRENT_COMP;
global_geometry_element.Volume = &this_box_volume; // Would be nicer if this m was a pointer, now we have the (small) data two places
add_element_to_geometry_list(&global_geometry_list,global_geometry_element);
}
#line 280586 "MACS_sample_kidney_box.c"
#undef number_of_activations
#undef mask_setting
#undef mask_string
#undef p_interact
#undef focus_r
#undef focus_xh
#undef focus_xw
#undef focus_ah
#undef focus_aw
#undef target_z
#undef target_y
#undef target_x
#undef target_index
#undef visualize
#undef yheight2
#undef xwidth2
#undef zdepth
#undef yheight
#undef xwidth
#undef priority
#undef material_string
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

  /* Initializations for component channel_13_analyzer_1_array_crystal_array_2. */
  SIG_MESSAGE("channel_13_analyzer_1_array_crystal_array_2 (Init)");
#define mccompcurname  channel_13_analyzer_1_array_crystal_array_2
#define mccompcurtype  Union_box
#define mccompcurindex 626
#define loop_index mccchannel_13_analyzer_1_array_crystal_array_2_loop_index
#define this_box_volume mccchannel_13_analyzer_1_array_crystal_array_2_this_box_volume
#define global_geometry_element mccchannel_13_analyzer_1_array_crystal_array_2_global_geometry_element
#define this_box_storage mccchannel_13_analyzer_1_array_crystal_array_2_this_box_storage
#define material_string mccchannel_13_analyzer_1_array_crystal_array_2_material_string
#define priority mccchannel_13_analyzer_1_array_crystal_array_2_priority
#define xwidth mccchannel_13_analyzer_1_array_crystal_array_2_xwidth
#define yheight mccchannel_13_analyzer_1_array_crystal_array_2_yheight
#define zdepth mccchannel_13_analyzer_1_array_crystal_array_2_zdepth
#define xwidth2 mccchannel_13_analyzer_1_array_crystal_array_2_xwidth2
#define yheight2 mccchannel_13_analyzer_1_array_crystal_array_2_yheight2
#define visualize mccchannel_13_analyzer_1_array_crystal_array_2_visualize
#define target_index mccchannel_13_analyzer_1_array_crystal_array_2_target_index
#define target_x mccchannel_13_analyzer_1_array_crystal_array_2_target_x
#define target_y mccchannel_13_analyzer_1_array_crystal_array_2_target_y
#define target_z mccchannel_13_analyzer_1_array_crystal_array_2_target_z
#define focus_aw mccchannel_13_analyzer_1_array_crystal_array_2_focus_aw
#define focus_ah mccchannel_13_analyzer_1_array_crystal_array_2_focus_ah
#define focus_xw mccchannel_13_analyzer_1_array_crystal_array_2_focus_xw
#define focus_xh mccchannel_13_analyzer_1_array_crystal_array_2_focus_xh
#define focus_r mccchannel_13_analyzer_1_array_crystal_array_2_focus_r
#define p_interact mccchannel_13_analyzer_1_array_crystal_array_2_p_interact
#define mask_string mccchannel_13_analyzer_1_array_crystal_array_2_mask_string
#define mask_setting mccchannel_13_analyzer_1_array_crystal_array_2_mask_setting
#define number_of_activations mccchannel_13_analyzer_1_array_crystal_array_2_number_of_activations
#line 224 "Union_box.comp"
{
// Initializes the focusing system for this volume including input sanitation.
focus_initialize(&this_box_volume.geometry, POS_A_COMP_INDEX(INDEX_CURRENT_COMP+target_index), POS_A_CURRENT_COMP, ROT_A_CURRENT_COMP, target_index, target_x, target_y, target_z, focus_aw, focus_ah, focus_xw, focus_xh, focus_r, NAME_CURRENT_COMP);

// Input sanitation for this geometry
if (xwidth <= 0) {
  printf("\nERROR in Union_box named %s, the xwidth is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (yheight <= 0) {
  printf("\nERROR in Union_box named %s, yheight is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (zdepth <= 0) {
  printf("\nERROR in Union_box named %s, zdepth is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (xwidth2 <= 0 && xwidth2 != -1) {
  printf("\nERROR in Union_box named %s, the xwidth2 is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (yheight2 <= 0 && yheight2 != -1) {
  printf("\nERROR in Union_box named %s, yheight2 is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}

// Use sanitation
if (global_material_list.num_elements == 0) {
  printf("\nERROR: Need to define a material using Union_make_material before using a Union geometry component. \n");
  printf("       %s was defined before first use of Union_make_material.\n",NAME_CURRENT_COMP);
  exit(1);
}

this_box_volume.geometry.is_masked_volume = 0;
this_box_volume.geometry.is_exit_volume = 0;
this_box_volume.geometry.is_mask_volume = 0;
// check if the volume is a mask, if it is the material string is irelevant.
if (mask_string && strlen(mask_string) && strcmp(mask_string, "NULL") && strcmp(mask_string, "0")) {
    // A mask volume is used to limit the extend of other volumes, called the masked volumes. These are specified in the mask_string.
    // In order for a ray to enter a masked volume, it needs to be both in the region covered by that volume AND the mask volume.
    // When more than
    this_box_volume.geometry.mask_mode = 1; // Default is mask mode is ALL
    if (mask_setting && strlen(mask_setting) && strcmp(mask_setting, "NULL") && strcmp(mask_setting, "0")) {
        if (strcmp(mask_setting,"ALL") == 0 || strcmp(mask_setting,"All") == 0) this_box_volume.geometry.mask_mode = 1;
        else if (strcmp(mask_setting,"ANY") == 0 || strcmp(mask_setting,"Any") == 0) this_box_volume.geometry.mask_mode = 2;
        else {
            printf("The mask_mode of component %s is set to %s, but must be either ALL or ANY.\n",NAME_CURRENT_COMP,mask_setting);
            exit(1);
        }
    }
    
    for (loop_index=0;loop_index<global_geometry_list.num_elements;loop_index++) {
        // Add mask list
        if (1 == manual_linking_function(global_geometry_list.elements[loop_index].name,mask_string)) {
            add_element_to_int_list(&this_box_volume.geometry.mask_list,global_geometry_list.elements[loop_index].component_index);
            add_element_to_int_list(&global_geometry_list.elements[loop_index].Volume->geometry.masked_by_list,INDEX_CURRENT_COMP);
            global_geometry_list.elements[loop_index].Volume->geometry.is_masked_volume = 1;
            if (this_box_volume.geometry.mask_mode == 2)
                global_geometry_list.elements[loop_index].Volume->geometry.mask_mode = 2;
            if (this_box_volume.geometry.mask_mode == 1) {
                if (global_geometry_list.elements[loop_index].Volume->geometry.is_masked_volume == 1 && global_geometry_list.elements[loop_index].Volume->geometry.mask_mode != 2)
                    // If more than one mask is added to one volume, the ANY mode overwrites the (default) ALL mode.
                    global_geometry_list.elements[loop_index].Volume->geometry.mask_mode = 1;
            }
            
            found_geometries = 1;
        }
    }
    if (found_geometries == 0) {
        printf("The mask_string in geometry: %s did not find any of the specified volumes in the mask_string %s \n",NAME_CURRENT_COMP,mask_string);
        exit(1);
    }
    this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
    this_box_volume.p_physics->is_vacuum = 0; // Makes this volume a vacuum
    this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
    this_box_volume.p_physics->my_a = 0; // Should not be used.
    sprintf(this_box_volume.p_physics->name,"Mask");
    this_box_volume.geometry.is_mask_volume = 1;
    
    
// Read the material input, or if it lacks, use automatic linking.
} else if (material_string && strlen(material_string) && strcmp(material_string, "NULL") && strcmp(material_string, "0")) {
    // A geometry string was given, use it to determine which material
    if (0 == strcmp(material_string,"vacuum") || 0 == strcmp(material_string,"Vacuum")) {
        // One could have a global physics struct for vacuum instead of creating one for each
        this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
        this_box_volume.p_physics->is_vacuum = 1; // Makes this volume a vacuum
        this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
        this_box_volume.p_physics->my_a = 0; // Should not be used.
        sprintf(this_box_volume.p_physics->name,"Vacuum");
    } else if (0 == strcmp(material_string,"exit") || 0 == strcmp(material_string,"Exit")) {
        // One could have a global physics struct for vacuum instead of creating one for each
        this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
        this_box_volume.p_physics->is_vacuum = 1; // Makes this volume a vacuum
        this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
        this_box_volume.p_physics->my_a = 0; // Should not be used.
        this_box_volume.geometry.is_exit_volume = 1;
        sprintf(this_box_volume.p_physics->name,"Exit");
    } else {
        #ifndef MATERIAL_DETECTOR
            printf("Need to define a material before refering to it in a geometry %s.\n",NAME_CURRENT_COMP);
            exit(1);
        #endif
        for (loop_index=0;loop_index<global_material_list.num_elements;loop_index++) {
            if (0 == strcmp(material_string,global_material_list.elements[loop_index].name)) {
                this_box_volume.p_physics = global_material_list.elements[loop_index].physics;
                break;
            }
            if (loop_index == global_material_list.num_elements-1) {
            printf("\n");
            printf("ERROR: The material string \"%s\" in Union geometry \"%s\" did not match a specified material. \n",material_string,NAME_CURRENT_COMP);
            printf("       The materials available at this point (need to be defined before the geometry): \n");
            for (loop_index=0;loop_index<global_material_list.num_elements;loop_index++)
              printf("         %s\n",global_material_list.elements[loop_index].name);
            printf("\n");
            printf("       It is also possible to use one of the defualt materials avaiable: \n");
            printf("           Vacuum (for a Volume without scattering or absorption)\n");
            printf("           Exit (for a Volume where the ray exits the component if it enters)\n");
            printf("           Mask (for a Volume that masks existing volumes specified in the mask_string\n");
            exit(1);
          }
        }
    }
} else {
    // Automatic linking, simply using the last defined material.
    #ifndef MATERIAL_DETECTOR
        printf("Need to define a material before the geometry to use automatic linking %s.\n",NAME_CURRENT_COMP);
        exit(1);
    #endif
    this_box_volume.p_physics = global_material_list.elements[global_material_list.num_elements-1].physics;
}

sprintf(this_box_volume.name,NAME_CURRENT_COMP);
sprintf(this_box_volume.geometry.shape,"box");
this_box_volume.geometry.priority_value = priority;
this_box_volume.geometry.geometry_p_interact = p_interact;
// Currently the coordinates will be in absolute space.
this_box_volume.geometry.center = POS_A_CURRENT_COMP;

this_box_storage.z_depth = zdepth;
this_box_storage.x_width1 = xwidth;
this_box_storage.y_height1 = yheight;

this_box_storage.is_rectangle = 0;
if (xwidth2 < 0 && yheight2 < 0) this_box_storage.is_rectangle = 1;
if (xwidth == xwidth2 && yheight == yheight2) this_box_storage.is_rectangle = 1;

if (xwidth2 < 0) {
    this_box_storage.x_width2 = xwidth;
    xwidth2 = xwidth;
} else this_box_storage.x_width2 = xwidth2;

if (yheight2 < 0) {
    this_box_storage.y_height2 = yheight;
    yheight2 = yheight;
} else this_box_storage.y_height2 = yheight2;


this_box_storage.normal_vectors[0] = coords_set(0,0,1);
this_box_storage.normal_vectors[1] = coords_set(0,0,1);

// for sides with y component = 0
x_component = 2*zdepth/sqrt((xwidth-xwidth2)*(xwidth-xwidth2)+4*zdepth*zdepth);
z_component = (xwidth-xwidth2)/sqrt(4*zdepth*zdepth+(xwidth-xwidth2)*(xwidth-xwidth2));

this_box_storage.normal_vectors[2] = coords_set(x_component,0,z_component);
this_box_storage.normal_vectors[3] = coords_set(-x_component,0,z_component);

// for sides with x component = 0
y_component = 2*zdepth/sqrt((yheight-yheight2)*(yheight-yheight2)+4*zdepth*zdepth);
z_component = (yheight-yheight2)/sqrt(4*zdepth*zdepth+(yheight-yheight2)*(yheight-yheight2));

this_box_storage.normal_vectors[4] = coords_set(0,y_component,z_component);
this_box_storage.normal_vectors[5] = coords_set(0,-y_component,z_component);

this_box_volume.geometry.visualization_on = visualize;

this_box_volume.geometry.geometry_parameters.p_box_storage = &this_box_storage;

// Assign pointers to functions for intersection with the shape, checking if a point is inside the shape
if (this_box_storage.is_rectangle == 1) {
this_box_volume.geometry.intersect_function = &sample_box_intersect_simple;
this_box_volume.geometry.within_function = &r_within_box_simple;
}
else {
this_box_volume.geometry.intersect_function = &sample_box_intersect_advanced;
this_box_volume.geometry.within_function = &r_within_box_advanced;
}

this_box_volume.geometry.shell_points = &box_shell_points;
this_box_volume.geometry.mcdisplay_function = &mcdisplay_box_function;
this_box_volume.geometry.initialize_from_main_function = &initialize_box_geometry_from_main_component;
this_box_volume.geometry.process_rot_allocated = 0;

this_box_volume.geometry.copy_geometry_parameters = &allocate_box_storage_copy;

rot_copy(this_box_volume.geometry.rotation_matrix,ROT_A_CURRENT_COMP); //check how ROT_R_CURRENT_COMP would work
rot_transpose(ROT_A_CURRENT_COMP,this_box_volume.geometry.transpose_rotation_matrix);

// Initialize loggers
this_box_volume.loggers.num_elements = 0;

// packing the information into the global_geometry_element, which is then included in the global_geometry_list.
sprintf(global_geometry_element.name,NAME_CURRENT_COMP);
global_geometry_element.activation_counter = number_of_activations;
global_geometry_element.component_index = INDEX_CURRENT_COMP;
global_geometry_element.Volume = &this_box_volume; // Would be nicer if this m was a pointer, now we have the (small) data two places
add_element_to_geometry_list(&global_geometry_list,global_geometry_element);
}
#line 280856 "MACS_sample_kidney_box.c"
#undef number_of_activations
#undef mask_setting
#undef mask_string
#undef p_interact
#undef focus_r
#undef focus_xh
#undef focus_xw
#undef focus_ah
#undef focus_aw
#undef target_z
#undef target_y
#undef target_x
#undef target_index
#undef visualize
#undef yheight2
#undef xwidth2
#undef zdepth
#undef yheight
#undef xwidth
#undef priority
#undef material_string
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

  /* Initializations for component channel_13_analyzer_1_array_crystal_array_3. */
  SIG_MESSAGE("channel_13_analyzer_1_array_crystal_array_3 (Init)");
#define mccompcurname  channel_13_analyzer_1_array_crystal_array_3
#define mccompcurtype  Union_box
#define mccompcurindex 627
#define loop_index mccchannel_13_analyzer_1_array_crystal_array_3_loop_index
#define this_box_volume mccchannel_13_analyzer_1_array_crystal_array_3_this_box_volume
#define global_geometry_element mccchannel_13_analyzer_1_array_crystal_array_3_global_geometry_element
#define this_box_storage mccchannel_13_analyzer_1_array_crystal_array_3_this_box_storage
#define material_string mccchannel_13_analyzer_1_array_crystal_array_3_material_string
#define priority mccchannel_13_analyzer_1_array_crystal_array_3_priority
#define xwidth mccchannel_13_analyzer_1_array_crystal_array_3_xwidth
#define yheight mccchannel_13_analyzer_1_array_crystal_array_3_yheight
#define zdepth mccchannel_13_analyzer_1_array_crystal_array_3_zdepth
#define xwidth2 mccchannel_13_analyzer_1_array_crystal_array_3_xwidth2
#define yheight2 mccchannel_13_analyzer_1_array_crystal_array_3_yheight2
#define visualize mccchannel_13_analyzer_1_array_crystal_array_3_visualize
#define target_index mccchannel_13_analyzer_1_array_crystal_array_3_target_index
#define target_x mccchannel_13_analyzer_1_array_crystal_array_3_target_x
#define target_y mccchannel_13_analyzer_1_array_crystal_array_3_target_y
#define target_z mccchannel_13_analyzer_1_array_crystal_array_3_target_z
#define focus_aw mccchannel_13_analyzer_1_array_crystal_array_3_focus_aw
#define focus_ah mccchannel_13_analyzer_1_array_crystal_array_3_focus_ah
#define focus_xw mccchannel_13_analyzer_1_array_crystal_array_3_focus_xw
#define focus_xh mccchannel_13_analyzer_1_array_crystal_array_3_focus_xh
#define focus_r mccchannel_13_analyzer_1_array_crystal_array_3_focus_r
#define p_interact mccchannel_13_analyzer_1_array_crystal_array_3_p_interact
#define mask_string mccchannel_13_analyzer_1_array_crystal_array_3_mask_string
#define mask_setting mccchannel_13_analyzer_1_array_crystal_array_3_mask_setting
#define number_of_activations mccchannel_13_analyzer_1_array_crystal_array_3_number_of_activations
#line 224 "Union_box.comp"
{
// Initializes the focusing system for this volume including input sanitation.
focus_initialize(&this_box_volume.geometry, POS_A_COMP_INDEX(INDEX_CURRENT_COMP+target_index), POS_A_CURRENT_COMP, ROT_A_CURRENT_COMP, target_index, target_x, target_y, target_z, focus_aw, focus_ah, focus_xw, focus_xh, focus_r, NAME_CURRENT_COMP);

// Input sanitation for this geometry
if (xwidth <= 0) {
  printf("\nERROR in Union_box named %s, the xwidth is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (yheight <= 0) {
  printf("\nERROR in Union_box named %s, yheight is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (zdepth <= 0) {
  printf("\nERROR in Union_box named %s, zdepth is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (xwidth2 <= 0 && xwidth2 != -1) {
  printf("\nERROR in Union_box named %s, the xwidth2 is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (yheight2 <= 0 && yheight2 != -1) {
  printf("\nERROR in Union_box named %s, yheight2 is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}

// Use sanitation
if (global_material_list.num_elements == 0) {
  printf("\nERROR: Need to define a material using Union_make_material before using a Union geometry component. \n");
  printf("       %s was defined before first use of Union_make_material.\n",NAME_CURRENT_COMP);
  exit(1);
}

this_box_volume.geometry.is_masked_volume = 0;
this_box_volume.geometry.is_exit_volume = 0;
this_box_volume.geometry.is_mask_volume = 0;
// check if the volume is a mask, if it is the material string is irelevant.
if (mask_string && strlen(mask_string) && strcmp(mask_string, "NULL") && strcmp(mask_string, "0")) {
    // A mask volume is used to limit the extend of other volumes, called the masked volumes. These are specified in the mask_string.
    // In order for a ray to enter a masked volume, it needs to be both in the region covered by that volume AND the mask volume.
    // When more than
    this_box_volume.geometry.mask_mode = 1; // Default is mask mode is ALL
    if (mask_setting && strlen(mask_setting) && strcmp(mask_setting, "NULL") && strcmp(mask_setting, "0")) {
        if (strcmp(mask_setting,"ALL") == 0 || strcmp(mask_setting,"All") == 0) this_box_volume.geometry.mask_mode = 1;
        else if (strcmp(mask_setting,"ANY") == 0 || strcmp(mask_setting,"Any") == 0) this_box_volume.geometry.mask_mode = 2;
        else {
            printf("The mask_mode of component %s is set to %s, but must be either ALL or ANY.\n",NAME_CURRENT_COMP,mask_setting);
            exit(1);
        }
    }
    
    for (loop_index=0;loop_index<global_geometry_list.num_elements;loop_index++) {
        // Add mask list
        if (1 == manual_linking_function(global_geometry_list.elements[loop_index].name,mask_string)) {
            add_element_to_int_list(&this_box_volume.geometry.mask_list,global_geometry_list.elements[loop_index].component_index);
            add_element_to_int_list(&global_geometry_list.elements[loop_index].Volume->geometry.masked_by_list,INDEX_CURRENT_COMP);
            global_geometry_list.elements[loop_index].Volume->geometry.is_masked_volume = 1;
            if (this_box_volume.geometry.mask_mode == 2)
                global_geometry_list.elements[loop_index].Volume->geometry.mask_mode = 2;
            if (this_box_volume.geometry.mask_mode == 1) {
                if (global_geometry_list.elements[loop_index].Volume->geometry.is_masked_volume == 1 && global_geometry_list.elements[loop_index].Volume->geometry.mask_mode != 2)
                    // If more than one mask is added to one volume, the ANY mode overwrites the (default) ALL mode.
                    global_geometry_list.elements[loop_index].Volume->geometry.mask_mode = 1;
            }
            
            found_geometries = 1;
        }
    }
    if (found_geometries == 0) {
        printf("The mask_string in geometry: %s did not find any of the specified volumes in the mask_string %s \n",NAME_CURRENT_COMP,mask_string);
        exit(1);
    }
    this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
    this_box_volume.p_physics->is_vacuum = 0; // Makes this volume a vacuum
    this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
    this_box_volume.p_physics->my_a = 0; // Should not be used.
    sprintf(this_box_volume.p_physics->name,"Mask");
    this_box_volume.geometry.is_mask_volume = 1;
    
    
// Read the material input, or if it lacks, use automatic linking.
} else if (material_string && strlen(material_string) && strcmp(material_string, "NULL") && strcmp(material_string, "0")) {
    // A geometry string was given, use it to determine which material
    if (0 == strcmp(material_string,"vacuum") || 0 == strcmp(material_string,"Vacuum")) {
        // One could have a global physics struct for vacuum instead of creating one for each
        this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
        this_box_volume.p_physics->is_vacuum = 1; // Makes this volume a vacuum
        this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
        this_box_volume.p_physics->my_a = 0; // Should not be used.
        sprintf(this_box_volume.p_physics->name,"Vacuum");
    } else if (0 == strcmp(material_string,"exit") || 0 == strcmp(material_string,"Exit")) {
        // One could have a global physics struct for vacuum instead of creating one for each
        this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
        this_box_volume.p_physics->is_vacuum = 1; // Makes this volume a vacuum
        this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
        this_box_volume.p_physics->my_a = 0; // Should not be used.
        this_box_volume.geometry.is_exit_volume = 1;
        sprintf(this_box_volume.p_physics->name,"Exit");
    } else {
        #ifndef MATERIAL_DETECTOR
            printf("Need to define a material before refering to it in a geometry %s.\n",NAME_CURRENT_COMP);
            exit(1);
        #endif
        for (loop_index=0;loop_index<global_material_list.num_elements;loop_index++) {
            if (0 == strcmp(material_string,global_material_list.elements[loop_index].name)) {
                this_box_volume.p_physics = global_material_list.elements[loop_index].physics;
                break;
            }
            if (loop_index == global_material_list.num_elements-1) {
            printf("\n");
            printf("ERROR: The material string \"%s\" in Union geometry \"%s\" did not match a specified material. \n",material_string,NAME_CURRENT_COMP);
            printf("       The materials available at this point (need to be defined before the geometry): \n");
            for (loop_index=0;loop_index<global_material_list.num_elements;loop_index++)
              printf("         %s\n",global_material_list.elements[loop_index].name);
            printf("\n");
            printf("       It is also possible to use one of the defualt materials avaiable: \n");
            printf("           Vacuum (for a Volume without scattering or absorption)\n");
            printf("           Exit (for a Volume where the ray exits the component if it enters)\n");
            printf("           Mask (for a Volume that masks existing volumes specified in the mask_string\n");
            exit(1);
          }
        }
    }
} else {
    // Automatic linking, simply using the last defined material.
    #ifndef MATERIAL_DETECTOR
        printf("Need to define a material before the geometry to use automatic linking %s.\n",NAME_CURRENT_COMP);
        exit(1);
    #endif
    this_box_volume.p_physics = global_material_list.elements[global_material_list.num_elements-1].physics;
}

sprintf(this_box_volume.name,NAME_CURRENT_COMP);
sprintf(this_box_volume.geometry.shape,"box");
this_box_volume.geometry.priority_value = priority;
this_box_volume.geometry.geometry_p_interact = p_interact;
// Currently the coordinates will be in absolute space.
this_box_volume.geometry.center = POS_A_CURRENT_COMP;

this_box_storage.z_depth = zdepth;
this_box_storage.x_width1 = xwidth;
this_box_storage.y_height1 = yheight;

this_box_storage.is_rectangle = 0;
if (xwidth2 < 0 && yheight2 < 0) this_box_storage.is_rectangle = 1;
if (xwidth == xwidth2 && yheight == yheight2) this_box_storage.is_rectangle = 1;

if (xwidth2 < 0) {
    this_box_storage.x_width2 = xwidth;
    xwidth2 = xwidth;
} else this_box_storage.x_width2 = xwidth2;

if (yheight2 < 0) {
    this_box_storage.y_height2 = yheight;
    yheight2 = yheight;
} else this_box_storage.y_height2 = yheight2;


this_box_storage.normal_vectors[0] = coords_set(0,0,1);
this_box_storage.normal_vectors[1] = coords_set(0,0,1);

// for sides with y component = 0
x_component = 2*zdepth/sqrt((xwidth-xwidth2)*(xwidth-xwidth2)+4*zdepth*zdepth);
z_component = (xwidth-xwidth2)/sqrt(4*zdepth*zdepth+(xwidth-xwidth2)*(xwidth-xwidth2));

this_box_storage.normal_vectors[2] = coords_set(x_component,0,z_component);
this_box_storage.normal_vectors[3] = coords_set(-x_component,0,z_component);

// for sides with x component = 0
y_component = 2*zdepth/sqrt((yheight-yheight2)*(yheight-yheight2)+4*zdepth*zdepth);
z_component = (yheight-yheight2)/sqrt(4*zdepth*zdepth+(yheight-yheight2)*(yheight-yheight2));

this_box_storage.normal_vectors[4] = coords_set(0,y_component,z_component);
this_box_storage.normal_vectors[5] = coords_set(0,-y_component,z_component);

this_box_volume.geometry.visualization_on = visualize;

this_box_volume.geometry.geometry_parameters.p_box_storage = &this_box_storage;

// Assign pointers to functions for intersection with the shape, checking if a point is inside the shape
if (this_box_storage.is_rectangle == 1) {
this_box_volume.geometry.intersect_function = &sample_box_intersect_simple;
this_box_volume.geometry.within_function = &r_within_box_simple;
}
else {
this_box_volume.geometry.intersect_function = &sample_box_intersect_advanced;
this_box_volume.geometry.within_function = &r_within_box_advanced;
}

this_box_volume.geometry.shell_points = &box_shell_points;
this_box_volume.geometry.mcdisplay_function = &mcdisplay_box_function;
this_box_volume.geometry.initialize_from_main_function = &initialize_box_geometry_from_main_component;
this_box_volume.geometry.process_rot_allocated = 0;

this_box_volume.geometry.copy_geometry_parameters = &allocate_box_storage_copy;

rot_copy(this_box_volume.geometry.rotation_matrix,ROT_A_CURRENT_COMP); //check how ROT_R_CURRENT_COMP would work
rot_transpose(ROT_A_CURRENT_COMP,this_box_volume.geometry.transpose_rotation_matrix);

// Initialize loggers
this_box_volume.loggers.num_elements = 0;

// packing the information into the global_geometry_element, which is then included in the global_geometry_list.
sprintf(global_geometry_element.name,NAME_CURRENT_COMP);
global_geometry_element.activation_counter = number_of_activations;
global_geometry_element.component_index = INDEX_CURRENT_COMP;
global_geometry_element.Volume = &this_box_volume; // Would be nicer if this m was a pointer, now we have the (small) data two places
add_element_to_geometry_list(&global_geometry_list,global_geometry_element);
}
#line 281126 "MACS_sample_kidney_box.c"
#undef number_of_activations
#undef mask_setting
#undef mask_string
#undef p_interact
#undef focus_r
#undef focus_xh
#undef focus_xw
#undef focus_ah
#undef focus_aw
#undef target_z
#undef target_y
#undef target_x
#undef target_index
#undef visualize
#undef yheight2
#undef xwidth2
#undef zdepth
#undef yheight
#undef xwidth
#undef priority
#undef material_string
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

  /* Initializations for component channel_13_analyzer_1_array_crystal_array_4. */
  SIG_MESSAGE("channel_13_analyzer_1_array_crystal_array_4 (Init)");
#define mccompcurname  channel_13_analyzer_1_array_crystal_array_4
#define mccompcurtype  Union_box
#define mccompcurindex 628
#define loop_index mccchannel_13_analyzer_1_array_crystal_array_4_loop_index
#define this_box_volume mccchannel_13_analyzer_1_array_crystal_array_4_this_box_volume
#define global_geometry_element mccchannel_13_analyzer_1_array_crystal_array_4_global_geometry_element
#define this_box_storage mccchannel_13_analyzer_1_array_crystal_array_4_this_box_storage
#define material_string mccchannel_13_analyzer_1_array_crystal_array_4_material_string
#define priority mccchannel_13_analyzer_1_array_crystal_array_4_priority
#define xwidth mccchannel_13_analyzer_1_array_crystal_array_4_xwidth
#define yheight mccchannel_13_analyzer_1_array_crystal_array_4_yheight
#define zdepth mccchannel_13_analyzer_1_array_crystal_array_4_zdepth
#define xwidth2 mccchannel_13_analyzer_1_array_crystal_array_4_xwidth2
#define yheight2 mccchannel_13_analyzer_1_array_crystal_array_4_yheight2
#define visualize mccchannel_13_analyzer_1_array_crystal_array_4_visualize
#define target_index mccchannel_13_analyzer_1_array_crystal_array_4_target_index
#define target_x mccchannel_13_analyzer_1_array_crystal_array_4_target_x
#define target_y mccchannel_13_analyzer_1_array_crystal_array_4_target_y
#define target_z mccchannel_13_analyzer_1_array_crystal_array_4_target_z
#define focus_aw mccchannel_13_analyzer_1_array_crystal_array_4_focus_aw
#define focus_ah mccchannel_13_analyzer_1_array_crystal_array_4_focus_ah
#define focus_xw mccchannel_13_analyzer_1_array_crystal_array_4_focus_xw
#define focus_xh mccchannel_13_analyzer_1_array_crystal_array_4_focus_xh
#define focus_r mccchannel_13_analyzer_1_array_crystal_array_4_focus_r
#define p_interact mccchannel_13_analyzer_1_array_crystal_array_4_p_interact
#define mask_string mccchannel_13_analyzer_1_array_crystal_array_4_mask_string
#define mask_setting mccchannel_13_analyzer_1_array_crystal_array_4_mask_setting
#define number_of_activations mccchannel_13_analyzer_1_array_crystal_array_4_number_of_activations
#line 224 "Union_box.comp"
{
// Initializes the focusing system for this volume including input sanitation.
focus_initialize(&this_box_volume.geometry, POS_A_COMP_INDEX(INDEX_CURRENT_COMP+target_index), POS_A_CURRENT_COMP, ROT_A_CURRENT_COMP, target_index, target_x, target_y, target_z, focus_aw, focus_ah, focus_xw, focus_xh, focus_r, NAME_CURRENT_COMP);

// Input sanitation for this geometry
if (xwidth <= 0) {
  printf("\nERROR in Union_box named %s, the xwidth is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (yheight <= 0) {
  printf("\nERROR in Union_box named %s, yheight is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (zdepth <= 0) {
  printf("\nERROR in Union_box named %s, zdepth is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (xwidth2 <= 0 && xwidth2 != -1) {
  printf("\nERROR in Union_box named %s, the xwidth2 is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (yheight2 <= 0 && yheight2 != -1) {
  printf("\nERROR in Union_box named %s, yheight2 is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}

// Use sanitation
if (global_material_list.num_elements == 0) {
  printf("\nERROR: Need to define a material using Union_make_material before using a Union geometry component. \n");
  printf("       %s was defined before first use of Union_make_material.\n",NAME_CURRENT_COMP);
  exit(1);
}

this_box_volume.geometry.is_masked_volume = 0;
this_box_volume.geometry.is_exit_volume = 0;
this_box_volume.geometry.is_mask_volume = 0;
// check if the volume is a mask, if it is the material string is irelevant.
if (mask_string && strlen(mask_string) && strcmp(mask_string, "NULL") && strcmp(mask_string, "0")) {
    // A mask volume is used to limit the extend of other volumes, called the masked volumes. These are specified in the mask_string.
    // In order for a ray to enter a masked volume, it needs to be both in the region covered by that volume AND the mask volume.
    // When more than
    this_box_volume.geometry.mask_mode = 1; // Default is mask mode is ALL
    if (mask_setting && strlen(mask_setting) && strcmp(mask_setting, "NULL") && strcmp(mask_setting, "0")) {
        if (strcmp(mask_setting,"ALL") == 0 || strcmp(mask_setting,"All") == 0) this_box_volume.geometry.mask_mode = 1;
        else if (strcmp(mask_setting,"ANY") == 0 || strcmp(mask_setting,"Any") == 0) this_box_volume.geometry.mask_mode = 2;
        else {
            printf("The mask_mode of component %s is set to %s, but must be either ALL or ANY.\n",NAME_CURRENT_COMP,mask_setting);
            exit(1);
        }
    }
    
    for (loop_index=0;loop_index<global_geometry_list.num_elements;loop_index++) {
        // Add mask list
        if (1 == manual_linking_function(global_geometry_list.elements[loop_index].name,mask_string)) {
            add_element_to_int_list(&this_box_volume.geometry.mask_list,global_geometry_list.elements[loop_index].component_index);
            add_element_to_int_list(&global_geometry_list.elements[loop_index].Volume->geometry.masked_by_list,INDEX_CURRENT_COMP);
            global_geometry_list.elements[loop_index].Volume->geometry.is_masked_volume = 1;
            if (this_box_volume.geometry.mask_mode == 2)
                global_geometry_list.elements[loop_index].Volume->geometry.mask_mode = 2;
            if (this_box_volume.geometry.mask_mode == 1) {
                if (global_geometry_list.elements[loop_index].Volume->geometry.is_masked_volume == 1 && global_geometry_list.elements[loop_index].Volume->geometry.mask_mode != 2)
                    // If more than one mask is added to one volume, the ANY mode overwrites the (default) ALL mode.
                    global_geometry_list.elements[loop_index].Volume->geometry.mask_mode = 1;
            }
            
            found_geometries = 1;
        }
    }
    if (found_geometries == 0) {
        printf("The mask_string in geometry: %s did not find any of the specified volumes in the mask_string %s \n",NAME_CURRENT_COMP,mask_string);
        exit(1);
    }
    this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
    this_box_volume.p_physics->is_vacuum = 0; // Makes this volume a vacuum
    this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
    this_box_volume.p_physics->my_a = 0; // Should not be used.
    sprintf(this_box_volume.p_physics->name,"Mask");
    this_box_volume.geometry.is_mask_volume = 1;
    
    
// Read the material input, or if it lacks, use automatic linking.
} else if (material_string && strlen(material_string) && strcmp(material_string, "NULL") && strcmp(material_string, "0")) {
    // A geometry string was given, use it to determine which material
    if (0 == strcmp(material_string,"vacuum") || 0 == strcmp(material_string,"Vacuum")) {
        // One could have a global physics struct for vacuum instead of creating one for each
        this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
        this_box_volume.p_physics->is_vacuum = 1; // Makes this volume a vacuum
        this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
        this_box_volume.p_physics->my_a = 0; // Should not be used.
        sprintf(this_box_volume.p_physics->name,"Vacuum");
    } else if (0 == strcmp(material_string,"exit") || 0 == strcmp(material_string,"Exit")) {
        // One could have a global physics struct for vacuum instead of creating one for each
        this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
        this_box_volume.p_physics->is_vacuum = 1; // Makes this volume a vacuum
        this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
        this_box_volume.p_physics->my_a = 0; // Should not be used.
        this_box_volume.geometry.is_exit_volume = 1;
        sprintf(this_box_volume.p_physics->name,"Exit");
    } else {
        #ifndef MATERIAL_DETECTOR
            printf("Need to define a material before refering to it in a geometry %s.\n",NAME_CURRENT_COMP);
            exit(1);
        #endif
        for (loop_index=0;loop_index<global_material_list.num_elements;loop_index++) {
            if (0 == strcmp(material_string,global_material_list.elements[loop_index].name)) {
                this_box_volume.p_physics = global_material_list.elements[loop_index].physics;
                break;
            }
            if (loop_index == global_material_list.num_elements-1) {
            printf("\n");
            printf("ERROR: The material string \"%s\" in Union geometry \"%s\" did not match a specified material. \n",material_string,NAME_CURRENT_COMP);
            printf("       The materials available at this point (need to be defined before the geometry): \n");
            for (loop_index=0;loop_index<global_material_list.num_elements;loop_index++)
              printf("         %s\n",global_material_list.elements[loop_index].name);
            printf("\n");
            printf("       It is also possible to use one of the defualt materials avaiable: \n");
            printf("           Vacuum (for a Volume without scattering or absorption)\n");
            printf("           Exit (for a Volume where the ray exits the component if it enters)\n");
            printf("           Mask (for a Volume that masks existing volumes specified in the mask_string\n");
            exit(1);
          }
        }
    }
} else {
    // Automatic linking, simply using the last defined material.
    #ifndef MATERIAL_DETECTOR
        printf("Need to define a material before the geometry to use automatic linking %s.\n",NAME_CURRENT_COMP);
        exit(1);
    #endif
    this_box_volume.p_physics = global_material_list.elements[global_material_list.num_elements-1].physics;
}

sprintf(this_box_volume.name,NAME_CURRENT_COMP);
sprintf(this_box_volume.geometry.shape,"box");
this_box_volume.geometry.priority_value = priority;
this_box_volume.geometry.geometry_p_interact = p_interact;
// Currently the coordinates will be in absolute space.
this_box_volume.geometry.center = POS_A_CURRENT_COMP;

this_box_storage.z_depth = zdepth;
this_box_storage.x_width1 = xwidth;
this_box_storage.y_height1 = yheight;

this_box_storage.is_rectangle = 0;
if (xwidth2 < 0 && yheight2 < 0) this_box_storage.is_rectangle = 1;
if (xwidth == xwidth2 && yheight == yheight2) this_box_storage.is_rectangle = 1;

if (xwidth2 < 0) {
    this_box_storage.x_width2 = xwidth;
    xwidth2 = xwidth;
} else this_box_storage.x_width2 = xwidth2;

if (yheight2 < 0) {
    this_box_storage.y_height2 = yheight;
    yheight2 = yheight;
} else this_box_storage.y_height2 = yheight2;


this_box_storage.normal_vectors[0] = coords_set(0,0,1);
this_box_storage.normal_vectors[1] = coords_set(0,0,1);

// for sides with y component = 0
x_component = 2*zdepth/sqrt((xwidth-xwidth2)*(xwidth-xwidth2)+4*zdepth*zdepth);
z_component = (xwidth-xwidth2)/sqrt(4*zdepth*zdepth+(xwidth-xwidth2)*(xwidth-xwidth2));

this_box_storage.normal_vectors[2] = coords_set(x_component,0,z_component);
this_box_storage.normal_vectors[3] = coords_set(-x_component,0,z_component);

// for sides with x component = 0
y_component = 2*zdepth/sqrt((yheight-yheight2)*(yheight-yheight2)+4*zdepth*zdepth);
z_component = (yheight-yheight2)/sqrt(4*zdepth*zdepth+(yheight-yheight2)*(yheight-yheight2));

this_box_storage.normal_vectors[4] = coords_set(0,y_component,z_component);
this_box_storage.normal_vectors[5] = coords_set(0,-y_component,z_component);

this_box_volume.geometry.visualization_on = visualize;

this_box_volume.geometry.geometry_parameters.p_box_storage = &this_box_storage;

// Assign pointers to functions for intersection with the shape, checking if a point is inside the shape
if (this_box_storage.is_rectangle == 1) {
this_box_volume.geometry.intersect_function = &sample_box_intersect_simple;
this_box_volume.geometry.within_function = &r_within_box_simple;
}
else {
this_box_volume.geometry.intersect_function = &sample_box_intersect_advanced;
this_box_volume.geometry.within_function = &r_within_box_advanced;
}

this_box_volume.geometry.shell_points = &box_shell_points;
this_box_volume.geometry.mcdisplay_function = &mcdisplay_box_function;
this_box_volume.geometry.initialize_from_main_function = &initialize_box_geometry_from_main_component;
this_box_volume.geometry.process_rot_allocated = 0;

this_box_volume.geometry.copy_geometry_parameters = &allocate_box_storage_copy;

rot_copy(this_box_volume.geometry.rotation_matrix,ROT_A_CURRENT_COMP); //check how ROT_R_CURRENT_COMP would work
rot_transpose(ROT_A_CURRENT_COMP,this_box_volume.geometry.transpose_rotation_matrix);

// Initialize loggers
this_box_volume.loggers.num_elements = 0;

// packing the information into the global_geometry_element, which is then included in the global_geometry_list.
sprintf(global_geometry_element.name,NAME_CURRENT_COMP);
global_geometry_element.activation_counter = number_of_activations;
global_geometry_element.component_index = INDEX_CURRENT_COMP;
global_geometry_element.Volume = &this_box_volume; // Would be nicer if this m was a pointer, now we have the (small) data two places
add_element_to_geometry_list(&global_geometry_list,global_geometry_element);
}
#line 281396 "MACS_sample_kidney_box.c"
#undef number_of_activations
#undef mask_setting
#undef mask_string
#undef p_interact
#undef focus_r
#undef focus_xh
#undef focus_xw
#undef focus_ah
#undef focus_aw
#undef target_z
#undef target_y
#undef target_x
#undef target_index
#undef visualize
#undef yheight2
#undef xwidth2
#undef zdepth
#undef yheight
#undef xwidth
#undef priority
#undef material_string
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

  /* Initializations for component channel_13_analyzer_1_array_crystal_array_5. */
  SIG_MESSAGE("channel_13_analyzer_1_array_crystal_array_5 (Init)");
#define mccompcurname  channel_13_analyzer_1_array_crystal_array_5
#define mccompcurtype  Union_box
#define mccompcurindex 629
#define loop_index mccchannel_13_analyzer_1_array_crystal_array_5_loop_index
#define this_box_volume mccchannel_13_analyzer_1_array_crystal_array_5_this_box_volume
#define global_geometry_element mccchannel_13_analyzer_1_array_crystal_array_5_global_geometry_element
#define this_box_storage mccchannel_13_analyzer_1_array_crystal_array_5_this_box_storage
#define material_string mccchannel_13_analyzer_1_array_crystal_array_5_material_string
#define priority mccchannel_13_analyzer_1_array_crystal_array_5_priority
#define xwidth mccchannel_13_analyzer_1_array_crystal_array_5_xwidth
#define yheight mccchannel_13_analyzer_1_array_crystal_array_5_yheight
#define zdepth mccchannel_13_analyzer_1_array_crystal_array_5_zdepth
#define xwidth2 mccchannel_13_analyzer_1_array_crystal_array_5_xwidth2
#define yheight2 mccchannel_13_analyzer_1_array_crystal_array_5_yheight2
#define visualize mccchannel_13_analyzer_1_array_crystal_array_5_visualize
#define target_index mccchannel_13_analyzer_1_array_crystal_array_5_target_index
#define target_x mccchannel_13_analyzer_1_array_crystal_array_5_target_x
#define target_y mccchannel_13_analyzer_1_array_crystal_array_5_target_y
#define target_z mccchannel_13_analyzer_1_array_crystal_array_5_target_z
#define focus_aw mccchannel_13_analyzer_1_array_crystal_array_5_focus_aw
#define focus_ah mccchannel_13_analyzer_1_array_crystal_array_5_focus_ah
#define focus_xw mccchannel_13_analyzer_1_array_crystal_array_5_focus_xw
#define focus_xh mccchannel_13_analyzer_1_array_crystal_array_5_focus_xh
#define focus_r mccchannel_13_analyzer_1_array_crystal_array_5_focus_r
#define p_interact mccchannel_13_analyzer_1_array_crystal_array_5_p_interact
#define mask_string mccchannel_13_analyzer_1_array_crystal_array_5_mask_string
#define mask_setting mccchannel_13_analyzer_1_array_crystal_array_5_mask_setting
#define number_of_activations mccchannel_13_analyzer_1_array_crystal_array_5_number_of_activations
#line 224 "Union_box.comp"
{
// Initializes the focusing system for this volume including input sanitation.
focus_initialize(&this_box_volume.geometry, POS_A_COMP_INDEX(INDEX_CURRENT_COMP+target_index), POS_A_CURRENT_COMP, ROT_A_CURRENT_COMP, target_index, target_x, target_y, target_z, focus_aw, focus_ah, focus_xw, focus_xh, focus_r, NAME_CURRENT_COMP);

// Input sanitation for this geometry
if (xwidth <= 0) {
  printf("\nERROR in Union_box named %s, the xwidth is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (yheight <= 0) {
  printf("\nERROR in Union_box named %s, yheight is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (zdepth <= 0) {
  printf("\nERROR in Union_box named %s, zdepth is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (xwidth2 <= 0 && xwidth2 != -1) {
  printf("\nERROR in Union_box named %s, the xwidth2 is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (yheight2 <= 0 && yheight2 != -1) {
  printf("\nERROR in Union_box named %s, yheight2 is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}

// Use sanitation
if (global_material_list.num_elements == 0) {
  printf("\nERROR: Need to define a material using Union_make_material before using a Union geometry component. \n");
  printf("       %s was defined before first use of Union_make_material.\n",NAME_CURRENT_COMP);
  exit(1);
}

this_box_volume.geometry.is_masked_volume = 0;
this_box_volume.geometry.is_exit_volume = 0;
this_box_volume.geometry.is_mask_volume = 0;
// check if the volume is a mask, if it is the material string is irelevant.
if (mask_string && strlen(mask_string) && strcmp(mask_string, "NULL") && strcmp(mask_string, "0")) {
    // A mask volume is used to limit the extend of other volumes, called the masked volumes. These are specified in the mask_string.
    // In order for a ray to enter a masked volume, it needs to be both in the region covered by that volume AND the mask volume.
    // When more than
    this_box_volume.geometry.mask_mode = 1; // Default is mask mode is ALL
    if (mask_setting && strlen(mask_setting) && strcmp(mask_setting, "NULL") && strcmp(mask_setting, "0")) {
        if (strcmp(mask_setting,"ALL") == 0 || strcmp(mask_setting,"All") == 0) this_box_volume.geometry.mask_mode = 1;
        else if (strcmp(mask_setting,"ANY") == 0 || strcmp(mask_setting,"Any") == 0) this_box_volume.geometry.mask_mode = 2;
        else {
            printf("The mask_mode of component %s is set to %s, but must be either ALL or ANY.\n",NAME_CURRENT_COMP,mask_setting);
            exit(1);
        }
    }
    
    for (loop_index=0;loop_index<global_geometry_list.num_elements;loop_index++) {
        // Add mask list
        if (1 == manual_linking_function(global_geometry_list.elements[loop_index].name,mask_string)) {
            add_element_to_int_list(&this_box_volume.geometry.mask_list,global_geometry_list.elements[loop_index].component_index);
            add_element_to_int_list(&global_geometry_list.elements[loop_index].Volume->geometry.masked_by_list,INDEX_CURRENT_COMP);
            global_geometry_list.elements[loop_index].Volume->geometry.is_masked_volume = 1;
            if (this_box_volume.geometry.mask_mode == 2)
                global_geometry_list.elements[loop_index].Volume->geometry.mask_mode = 2;
            if (this_box_volume.geometry.mask_mode == 1) {
                if (global_geometry_list.elements[loop_index].Volume->geometry.is_masked_volume == 1 && global_geometry_list.elements[loop_index].Volume->geometry.mask_mode != 2)
                    // If more than one mask is added to one volume, the ANY mode overwrites the (default) ALL mode.
                    global_geometry_list.elements[loop_index].Volume->geometry.mask_mode = 1;
            }
            
            found_geometries = 1;
        }
    }
    if (found_geometries == 0) {
        printf("The mask_string in geometry: %s did not find any of the specified volumes in the mask_string %s \n",NAME_CURRENT_COMP,mask_string);
        exit(1);
    }
    this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
    this_box_volume.p_physics->is_vacuum = 0; // Makes this volume a vacuum
    this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
    this_box_volume.p_physics->my_a = 0; // Should not be used.
    sprintf(this_box_volume.p_physics->name,"Mask");
    this_box_volume.geometry.is_mask_volume = 1;
    
    
// Read the material input, or if it lacks, use automatic linking.
} else if (material_string && strlen(material_string) && strcmp(material_string, "NULL") && strcmp(material_string, "0")) {
    // A geometry string was given, use it to determine which material
    if (0 == strcmp(material_string,"vacuum") || 0 == strcmp(material_string,"Vacuum")) {
        // One could have a global physics struct for vacuum instead of creating one for each
        this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
        this_box_volume.p_physics->is_vacuum = 1; // Makes this volume a vacuum
        this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
        this_box_volume.p_physics->my_a = 0; // Should not be used.
        sprintf(this_box_volume.p_physics->name,"Vacuum");
    } else if (0 == strcmp(material_string,"exit") || 0 == strcmp(material_string,"Exit")) {
        // One could have a global physics struct for vacuum instead of creating one for each
        this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
        this_box_volume.p_physics->is_vacuum = 1; // Makes this volume a vacuum
        this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
        this_box_volume.p_physics->my_a = 0; // Should not be used.
        this_box_volume.geometry.is_exit_volume = 1;
        sprintf(this_box_volume.p_physics->name,"Exit");
    } else {
        #ifndef MATERIAL_DETECTOR
            printf("Need to define a material before refering to it in a geometry %s.\n",NAME_CURRENT_COMP);
            exit(1);
        #endif
        for (loop_index=0;loop_index<global_material_list.num_elements;loop_index++) {
            if (0 == strcmp(material_string,global_material_list.elements[loop_index].name)) {
                this_box_volume.p_physics = global_material_list.elements[loop_index].physics;
                break;
            }
            if (loop_index == global_material_list.num_elements-1) {
            printf("\n");
            printf("ERROR: The material string \"%s\" in Union geometry \"%s\" did not match a specified material. \n",material_string,NAME_CURRENT_COMP);
            printf("       The materials available at this point (need to be defined before the geometry): \n");
            for (loop_index=0;loop_index<global_material_list.num_elements;loop_index++)
              printf("         %s\n",global_material_list.elements[loop_index].name);
            printf("\n");
            printf("       It is also possible to use one of the defualt materials avaiable: \n");
            printf("           Vacuum (for a Volume without scattering or absorption)\n");
            printf("           Exit (for a Volume where the ray exits the component if it enters)\n");
            printf("           Mask (for a Volume that masks existing volumes specified in the mask_string\n");
            exit(1);
          }
        }
    }
} else {
    // Automatic linking, simply using the last defined material.
    #ifndef MATERIAL_DETECTOR
        printf("Need to define a material before the geometry to use automatic linking %s.\n",NAME_CURRENT_COMP);
        exit(1);
    #endif
    this_box_volume.p_physics = global_material_list.elements[global_material_list.num_elements-1].physics;
}

sprintf(this_box_volume.name,NAME_CURRENT_COMP);
sprintf(this_box_volume.geometry.shape,"box");
this_box_volume.geometry.priority_value = priority;
this_box_volume.geometry.geometry_p_interact = p_interact;
// Currently the coordinates will be in absolute space.
this_box_volume.geometry.center = POS_A_CURRENT_COMP;

this_box_storage.z_depth = zdepth;
this_box_storage.x_width1 = xwidth;
this_box_storage.y_height1 = yheight;

this_box_storage.is_rectangle = 0;
if (xwidth2 < 0 && yheight2 < 0) this_box_storage.is_rectangle = 1;
if (xwidth == xwidth2 && yheight == yheight2) this_box_storage.is_rectangle = 1;

if (xwidth2 < 0) {
    this_box_storage.x_width2 = xwidth;
    xwidth2 = xwidth;
} else this_box_storage.x_width2 = xwidth2;

if (yheight2 < 0) {
    this_box_storage.y_height2 = yheight;
    yheight2 = yheight;
} else this_box_storage.y_height2 = yheight2;


this_box_storage.normal_vectors[0] = coords_set(0,0,1);
this_box_storage.normal_vectors[1] = coords_set(0,0,1);

// for sides with y component = 0
x_component = 2*zdepth/sqrt((xwidth-xwidth2)*(xwidth-xwidth2)+4*zdepth*zdepth);
z_component = (xwidth-xwidth2)/sqrt(4*zdepth*zdepth+(xwidth-xwidth2)*(xwidth-xwidth2));

this_box_storage.normal_vectors[2] = coords_set(x_component,0,z_component);
this_box_storage.normal_vectors[3] = coords_set(-x_component,0,z_component);

// for sides with x component = 0
y_component = 2*zdepth/sqrt((yheight-yheight2)*(yheight-yheight2)+4*zdepth*zdepth);
z_component = (yheight-yheight2)/sqrt(4*zdepth*zdepth+(yheight-yheight2)*(yheight-yheight2));

this_box_storage.normal_vectors[4] = coords_set(0,y_component,z_component);
this_box_storage.normal_vectors[5] = coords_set(0,-y_component,z_component);

this_box_volume.geometry.visualization_on = visualize;

this_box_volume.geometry.geometry_parameters.p_box_storage = &this_box_storage;

// Assign pointers to functions for intersection with the shape, checking if a point is inside the shape
if (this_box_storage.is_rectangle == 1) {
this_box_volume.geometry.intersect_function = &sample_box_intersect_simple;
this_box_volume.geometry.within_function = &r_within_box_simple;
}
else {
this_box_volume.geometry.intersect_function = &sample_box_intersect_advanced;
this_box_volume.geometry.within_function = &r_within_box_advanced;
}

this_box_volume.geometry.shell_points = &box_shell_points;
this_box_volume.geometry.mcdisplay_function = &mcdisplay_box_function;
this_box_volume.geometry.initialize_from_main_function = &initialize_box_geometry_from_main_component;
this_box_volume.geometry.process_rot_allocated = 0;

this_box_volume.geometry.copy_geometry_parameters = &allocate_box_storage_copy;

rot_copy(this_box_volume.geometry.rotation_matrix,ROT_A_CURRENT_COMP); //check how ROT_R_CURRENT_COMP would work
rot_transpose(ROT_A_CURRENT_COMP,this_box_volume.geometry.transpose_rotation_matrix);

// Initialize loggers
this_box_volume.loggers.num_elements = 0;

// packing the information into the global_geometry_element, which is then included in the global_geometry_list.
sprintf(global_geometry_element.name,NAME_CURRENT_COMP);
global_geometry_element.activation_counter = number_of_activations;
global_geometry_element.component_index = INDEX_CURRENT_COMP;
global_geometry_element.Volume = &this_box_volume; // Would be nicer if this m was a pointer, now we have the (small) data two places
add_element_to_geometry_list(&global_geometry_list,global_geometry_element);
}
#line 281666 "MACS_sample_kidney_box.c"
#undef number_of_activations
#undef mask_setting
#undef mask_string
#undef p_interact
#undef focus_r
#undef focus_xh
#undef focus_xw
#undef focus_ah
#undef focus_aw
#undef target_z
#undef target_y
#undef target_x
#undef target_index
#undef visualize
#undef yheight2
#undef xwidth2
#undef zdepth
#undef yheight
#undef xwidth
#undef priority
#undef material_string
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

  /* Initializations for component channel_13_analyzer_1_array_crystal_array_6. */
  SIG_MESSAGE("channel_13_analyzer_1_array_crystal_array_6 (Init)");
#define mccompcurname  channel_13_analyzer_1_array_crystal_array_6
#define mccompcurtype  Union_box
#define mccompcurindex 630
#define loop_index mccchannel_13_analyzer_1_array_crystal_array_6_loop_index
#define this_box_volume mccchannel_13_analyzer_1_array_crystal_array_6_this_box_volume
#define global_geometry_element mccchannel_13_analyzer_1_array_crystal_array_6_global_geometry_element
#define this_box_storage mccchannel_13_analyzer_1_array_crystal_array_6_this_box_storage
#define material_string mccchannel_13_analyzer_1_array_crystal_array_6_material_string
#define priority mccchannel_13_analyzer_1_array_crystal_array_6_priority
#define xwidth mccchannel_13_analyzer_1_array_crystal_array_6_xwidth
#define yheight mccchannel_13_analyzer_1_array_crystal_array_6_yheight
#define zdepth mccchannel_13_analyzer_1_array_crystal_array_6_zdepth
#define xwidth2 mccchannel_13_analyzer_1_array_crystal_array_6_xwidth2
#define yheight2 mccchannel_13_analyzer_1_array_crystal_array_6_yheight2
#define visualize mccchannel_13_analyzer_1_array_crystal_array_6_visualize
#define target_index mccchannel_13_analyzer_1_array_crystal_array_6_target_index
#define target_x mccchannel_13_analyzer_1_array_crystal_array_6_target_x
#define target_y mccchannel_13_analyzer_1_array_crystal_array_6_target_y
#define target_z mccchannel_13_analyzer_1_array_crystal_array_6_target_z
#define focus_aw mccchannel_13_analyzer_1_array_crystal_array_6_focus_aw
#define focus_ah mccchannel_13_analyzer_1_array_crystal_array_6_focus_ah
#define focus_xw mccchannel_13_analyzer_1_array_crystal_array_6_focus_xw
#define focus_xh mccchannel_13_analyzer_1_array_crystal_array_6_focus_xh
#define focus_r mccchannel_13_analyzer_1_array_crystal_array_6_focus_r
#define p_interact mccchannel_13_analyzer_1_array_crystal_array_6_p_interact
#define mask_string mccchannel_13_analyzer_1_array_crystal_array_6_mask_string
#define mask_setting mccchannel_13_analyzer_1_array_crystal_array_6_mask_setting
#define number_of_activations mccchannel_13_analyzer_1_array_crystal_array_6_number_of_activations
#line 224 "Union_box.comp"
{
// Initializes the focusing system for this volume including input sanitation.
focus_initialize(&this_box_volume.geometry, POS_A_COMP_INDEX(INDEX_CURRENT_COMP+target_index), POS_A_CURRENT_COMP, ROT_A_CURRENT_COMP, target_index, target_x, target_y, target_z, focus_aw, focus_ah, focus_xw, focus_xh, focus_r, NAME_CURRENT_COMP);

// Input sanitation for this geometry
if (xwidth <= 0) {
  printf("\nERROR in Union_box named %s, the xwidth is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (yheight <= 0) {
  printf("\nERROR in Union_box named %s, yheight is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (zdepth <= 0) {
  printf("\nERROR in Union_box named %s, zdepth is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (xwidth2 <= 0 && xwidth2 != -1) {
  printf("\nERROR in Union_box named %s, the xwidth2 is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (yheight2 <= 0 && yheight2 != -1) {
  printf("\nERROR in Union_box named %s, yheight2 is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}

// Use sanitation
if (global_material_list.num_elements == 0) {
  printf("\nERROR: Need to define a material using Union_make_material before using a Union geometry component. \n");
  printf("       %s was defined before first use of Union_make_material.\n",NAME_CURRENT_COMP);
  exit(1);
}

this_box_volume.geometry.is_masked_volume = 0;
this_box_volume.geometry.is_exit_volume = 0;
this_box_volume.geometry.is_mask_volume = 0;
// check if the volume is a mask, if it is the material string is irelevant.
if (mask_string && strlen(mask_string) && strcmp(mask_string, "NULL") && strcmp(mask_string, "0")) {
    // A mask volume is used to limit the extend of other volumes, called the masked volumes. These are specified in the mask_string.
    // In order for a ray to enter a masked volume, it needs to be both in the region covered by that volume AND the mask volume.
    // When more than
    this_box_volume.geometry.mask_mode = 1; // Default is mask mode is ALL
    if (mask_setting && strlen(mask_setting) && strcmp(mask_setting, "NULL") && strcmp(mask_setting, "0")) {
        if (strcmp(mask_setting,"ALL") == 0 || strcmp(mask_setting,"All") == 0) this_box_volume.geometry.mask_mode = 1;
        else if (strcmp(mask_setting,"ANY") == 0 || strcmp(mask_setting,"Any") == 0) this_box_volume.geometry.mask_mode = 2;
        else {
            printf("The mask_mode of component %s is set to %s, but must be either ALL or ANY.\n",NAME_CURRENT_COMP,mask_setting);
            exit(1);
        }
    }
    
    for (loop_index=0;loop_index<global_geometry_list.num_elements;loop_index++) {
        // Add mask list
        if (1 == manual_linking_function(global_geometry_list.elements[loop_index].name,mask_string)) {
            add_element_to_int_list(&this_box_volume.geometry.mask_list,global_geometry_list.elements[loop_index].component_index);
            add_element_to_int_list(&global_geometry_list.elements[loop_index].Volume->geometry.masked_by_list,INDEX_CURRENT_COMP);
            global_geometry_list.elements[loop_index].Volume->geometry.is_masked_volume = 1;
            if (this_box_volume.geometry.mask_mode == 2)
                global_geometry_list.elements[loop_index].Volume->geometry.mask_mode = 2;
            if (this_box_volume.geometry.mask_mode == 1) {
                if (global_geometry_list.elements[loop_index].Volume->geometry.is_masked_volume == 1 && global_geometry_list.elements[loop_index].Volume->geometry.mask_mode != 2)
                    // If more than one mask is added to one volume, the ANY mode overwrites the (default) ALL mode.
                    global_geometry_list.elements[loop_index].Volume->geometry.mask_mode = 1;
            }
            
            found_geometries = 1;
        }
    }
    if (found_geometries == 0) {
        printf("The mask_string in geometry: %s did not find any of the specified volumes in the mask_string %s \n",NAME_CURRENT_COMP,mask_string);
        exit(1);
    }
    this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
    this_box_volume.p_physics->is_vacuum = 0; // Makes this volume a vacuum
    this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
    this_box_volume.p_physics->my_a = 0; // Should not be used.
    sprintf(this_box_volume.p_physics->name,"Mask");
    this_box_volume.geometry.is_mask_volume = 1;
    
    
// Read the material input, or if it lacks, use automatic linking.
} else if (material_string && strlen(material_string) && strcmp(material_string, "NULL") && strcmp(material_string, "0")) {
    // A geometry string was given, use it to determine which material
    if (0 == strcmp(material_string,"vacuum") || 0 == strcmp(material_string,"Vacuum")) {
        // One could have a global physics struct for vacuum instead of creating one for each
        this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
        this_box_volume.p_physics->is_vacuum = 1; // Makes this volume a vacuum
        this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
        this_box_volume.p_physics->my_a = 0; // Should not be used.
        sprintf(this_box_volume.p_physics->name,"Vacuum");
    } else if (0 == strcmp(material_string,"exit") || 0 == strcmp(material_string,"Exit")) {
        // One could have a global physics struct for vacuum instead of creating one for each
        this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
        this_box_volume.p_physics->is_vacuum = 1; // Makes this volume a vacuum
        this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
        this_box_volume.p_physics->my_a = 0; // Should not be used.
        this_box_volume.geometry.is_exit_volume = 1;
        sprintf(this_box_volume.p_physics->name,"Exit");
    } else {
        #ifndef MATERIAL_DETECTOR
            printf("Need to define a material before refering to it in a geometry %s.\n",NAME_CURRENT_COMP);
            exit(1);
        #endif
        for (loop_index=0;loop_index<global_material_list.num_elements;loop_index++) {
            if (0 == strcmp(material_string,global_material_list.elements[loop_index].name)) {
                this_box_volume.p_physics = global_material_list.elements[loop_index].physics;
                break;
            }
            if (loop_index == global_material_list.num_elements-1) {
            printf("\n");
            printf("ERROR: The material string \"%s\" in Union geometry \"%s\" did not match a specified material. \n",material_string,NAME_CURRENT_COMP);
            printf("       The materials available at this point (need to be defined before the geometry): \n");
            for (loop_index=0;loop_index<global_material_list.num_elements;loop_index++)
              printf("         %s\n",global_material_list.elements[loop_index].name);
            printf("\n");
            printf("       It is also possible to use one of the defualt materials avaiable: \n");
            printf("           Vacuum (for a Volume without scattering or absorption)\n");
            printf("           Exit (for a Volume where the ray exits the component if it enters)\n");
            printf("           Mask (for a Volume that masks existing volumes specified in the mask_string\n");
            exit(1);
          }
        }
    }
} else {
    // Automatic linking, simply using the last defined material.
    #ifndef MATERIAL_DETECTOR
        printf("Need to define a material before the geometry to use automatic linking %s.\n",NAME_CURRENT_COMP);
        exit(1);
    #endif
    this_box_volume.p_physics = global_material_list.elements[global_material_list.num_elements-1].physics;
}

sprintf(this_box_volume.name,NAME_CURRENT_COMP);
sprintf(this_box_volume.geometry.shape,"box");
this_box_volume.geometry.priority_value = priority;
this_box_volume.geometry.geometry_p_interact = p_interact;
// Currently the coordinates will be in absolute space.
this_box_volume.geometry.center = POS_A_CURRENT_COMP;

this_box_storage.z_depth = zdepth;
this_box_storage.x_width1 = xwidth;
this_box_storage.y_height1 = yheight;

this_box_storage.is_rectangle = 0;
if (xwidth2 < 0 && yheight2 < 0) this_box_storage.is_rectangle = 1;
if (xwidth == xwidth2 && yheight == yheight2) this_box_storage.is_rectangle = 1;

if (xwidth2 < 0) {
    this_box_storage.x_width2 = xwidth;
    xwidth2 = xwidth;
} else this_box_storage.x_width2 = xwidth2;

if (yheight2 < 0) {
    this_box_storage.y_height2 = yheight;
    yheight2 = yheight;
} else this_box_storage.y_height2 = yheight2;


this_box_storage.normal_vectors[0] = coords_set(0,0,1);
this_box_storage.normal_vectors[1] = coords_set(0,0,1);

// for sides with y component = 0
x_component = 2*zdepth/sqrt((xwidth-xwidth2)*(xwidth-xwidth2)+4*zdepth*zdepth);
z_component = (xwidth-xwidth2)/sqrt(4*zdepth*zdepth+(xwidth-xwidth2)*(xwidth-xwidth2));

this_box_storage.normal_vectors[2] = coords_set(x_component,0,z_component);
this_box_storage.normal_vectors[3] = coords_set(-x_component,0,z_component);

// for sides with x component = 0
y_component = 2*zdepth/sqrt((yheight-yheight2)*(yheight-yheight2)+4*zdepth*zdepth);
z_component = (yheight-yheight2)/sqrt(4*zdepth*zdepth+(yheight-yheight2)*(yheight-yheight2));

this_box_storage.normal_vectors[4] = coords_set(0,y_component,z_component);
this_box_storage.normal_vectors[5] = coords_set(0,-y_component,z_component);

this_box_volume.geometry.visualization_on = visualize;

this_box_volume.geometry.geometry_parameters.p_box_storage = &this_box_storage;

// Assign pointers to functions for intersection with the shape, checking if a point is inside the shape
if (this_box_storage.is_rectangle == 1) {
this_box_volume.geometry.intersect_function = &sample_box_intersect_simple;
this_box_volume.geometry.within_function = &r_within_box_simple;
}
else {
this_box_volume.geometry.intersect_function = &sample_box_intersect_advanced;
this_box_volume.geometry.within_function = &r_within_box_advanced;
}

this_box_volume.geometry.shell_points = &box_shell_points;
this_box_volume.geometry.mcdisplay_function = &mcdisplay_box_function;
this_box_volume.geometry.initialize_from_main_function = &initialize_box_geometry_from_main_component;
this_box_volume.geometry.process_rot_allocated = 0;

this_box_volume.geometry.copy_geometry_parameters = &allocate_box_storage_copy;

rot_copy(this_box_volume.geometry.rotation_matrix,ROT_A_CURRENT_COMP); //check how ROT_R_CURRENT_COMP would work
rot_transpose(ROT_A_CURRENT_COMP,this_box_volume.geometry.transpose_rotation_matrix);

// Initialize loggers
this_box_volume.loggers.num_elements = 0;

// packing the information into the global_geometry_element, which is then included in the global_geometry_list.
sprintf(global_geometry_element.name,NAME_CURRENT_COMP);
global_geometry_element.activation_counter = number_of_activations;
global_geometry_element.component_index = INDEX_CURRENT_COMP;
global_geometry_element.Volume = &this_box_volume; // Would be nicer if this m was a pointer, now we have the (small) data two places
add_element_to_geometry_list(&global_geometry_list,global_geometry_element);
}
#line 281936 "MACS_sample_kidney_box.c"
#undef number_of_activations
#undef mask_setting
#undef mask_string
#undef p_interact
#undef focus_r
#undef focus_xh
#undef focus_xw
#undef focus_ah
#undef focus_aw
#undef target_z
#undef target_y
#undef target_x
#undef target_index
#undef visualize
#undef yheight2
#undef xwidth2
#undef zdepth
#undef yheight
#undef xwidth
#undef priority
#undef material_string
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

  /* Initializations for component channel_13_analyzer_1_array_crystal_array_7. */
  SIG_MESSAGE("channel_13_analyzer_1_array_crystal_array_7 (Init)");
#define mccompcurname  channel_13_analyzer_1_array_crystal_array_7
#define mccompcurtype  Union_box
#define mccompcurindex 631
#define loop_index mccchannel_13_analyzer_1_array_crystal_array_7_loop_index
#define this_box_volume mccchannel_13_analyzer_1_array_crystal_array_7_this_box_volume
#define global_geometry_element mccchannel_13_analyzer_1_array_crystal_array_7_global_geometry_element
#define this_box_storage mccchannel_13_analyzer_1_array_crystal_array_7_this_box_storage
#define material_string mccchannel_13_analyzer_1_array_crystal_array_7_material_string
#define priority mccchannel_13_analyzer_1_array_crystal_array_7_priority
#define xwidth mccchannel_13_analyzer_1_array_crystal_array_7_xwidth
#define yheight mccchannel_13_analyzer_1_array_crystal_array_7_yheight
#define zdepth mccchannel_13_analyzer_1_array_crystal_array_7_zdepth
#define xwidth2 mccchannel_13_analyzer_1_array_crystal_array_7_xwidth2
#define yheight2 mccchannel_13_analyzer_1_array_crystal_array_7_yheight2
#define visualize mccchannel_13_analyzer_1_array_crystal_array_7_visualize
#define target_index mccchannel_13_analyzer_1_array_crystal_array_7_target_index
#define target_x mccchannel_13_analyzer_1_array_crystal_array_7_target_x
#define target_y mccchannel_13_analyzer_1_array_crystal_array_7_target_y
#define target_z mccchannel_13_analyzer_1_array_crystal_array_7_target_z
#define focus_aw mccchannel_13_analyzer_1_array_crystal_array_7_focus_aw
#define focus_ah mccchannel_13_analyzer_1_array_crystal_array_7_focus_ah
#define focus_xw mccchannel_13_analyzer_1_array_crystal_array_7_focus_xw
#define focus_xh mccchannel_13_analyzer_1_array_crystal_array_7_focus_xh
#define focus_r mccchannel_13_analyzer_1_array_crystal_array_7_focus_r
#define p_interact mccchannel_13_analyzer_1_array_crystal_array_7_p_interact
#define mask_string mccchannel_13_analyzer_1_array_crystal_array_7_mask_string
#define mask_setting mccchannel_13_analyzer_1_array_crystal_array_7_mask_setting
#define number_of_activations mccchannel_13_analyzer_1_array_crystal_array_7_number_of_activations
#line 224 "Union_box.comp"
{
// Initializes the focusing system for this volume including input sanitation.
focus_initialize(&this_box_volume.geometry, POS_A_COMP_INDEX(INDEX_CURRENT_COMP+target_index), POS_A_CURRENT_COMP, ROT_A_CURRENT_COMP, target_index, target_x, target_y, target_z, focus_aw, focus_ah, focus_xw, focus_xh, focus_r, NAME_CURRENT_COMP);

// Input sanitation for this geometry
if (xwidth <= 0) {
  printf("\nERROR in Union_box named %s, the xwidth is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (yheight <= 0) {
  printf("\nERROR in Union_box named %s, yheight is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (zdepth <= 0) {
  printf("\nERROR in Union_box named %s, zdepth is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (xwidth2 <= 0 && xwidth2 != -1) {
  printf("\nERROR in Union_box named %s, the xwidth2 is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (yheight2 <= 0 && yheight2 != -1) {
  printf("\nERROR in Union_box named %s, yheight2 is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}

// Use sanitation
if (global_material_list.num_elements == 0) {
  printf("\nERROR: Need to define a material using Union_make_material before using a Union geometry component. \n");
  printf("       %s was defined before first use of Union_make_material.\n",NAME_CURRENT_COMP);
  exit(1);
}

this_box_volume.geometry.is_masked_volume = 0;
this_box_volume.geometry.is_exit_volume = 0;
this_box_volume.geometry.is_mask_volume = 0;
// check if the volume is a mask, if it is the material string is irelevant.
if (mask_string && strlen(mask_string) && strcmp(mask_string, "NULL") && strcmp(mask_string, "0")) {
    // A mask volume is used to limit the extend of other volumes, called the masked volumes. These are specified in the mask_string.
    // In order for a ray to enter a masked volume, it needs to be both in the region covered by that volume AND the mask volume.
    // When more than
    this_box_volume.geometry.mask_mode = 1; // Default is mask mode is ALL
    if (mask_setting && strlen(mask_setting) && strcmp(mask_setting, "NULL") && strcmp(mask_setting, "0")) {
        if (strcmp(mask_setting,"ALL") == 0 || strcmp(mask_setting,"All") == 0) this_box_volume.geometry.mask_mode = 1;
        else if (strcmp(mask_setting,"ANY") == 0 || strcmp(mask_setting,"Any") == 0) this_box_volume.geometry.mask_mode = 2;
        else {
            printf("The mask_mode of component %s is set to %s, but must be either ALL or ANY.\n",NAME_CURRENT_COMP,mask_setting);
            exit(1);
        }
    }
    
    for (loop_index=0;loop_index<global_geometry_list.num_elements;loop_index++) {
        // Add mask list
        if (1 == manual_linking_function(global_geometry_list.elements[loop_index].name,mask_string)) {
            add_element_to_int_list(&this_box_volume.geometry.mask_list,global_geometry_list.elements[loop_index].component_index);
            add_element_to_int_list(&global_geometry_list.elements[loop_index].Volume->geometry.masked_by_list,INDEX_CURRENT_COMP);
            global_geometry_list.elements[loop_index].Volume->geometry.is_masked_volume = 1;
            if (this_box_volume.geometry.mask_mode == 2)
                global_geometry_list.elements[loop_index].Volume->geometry.mask_mode = 2;
            if (this_box_volume.geometry.mask_mode == 1) {
                if (global_geometry_list.elements[loop_index].Volume->geometry.is_masked_volume == 1 && global_geometry_list.elements[loop_index].Volume->geometry.mask_mode != 2)
                    // If more than one mask is added to one volume, the ANY mode overwrites the (default) ALL mode.
                    global_geometry_list.elements[loop_index].Volume->geometry.mask_mode = 1;
            }
            
            found_geometries = 1;
        }
    }
    if (found_geometries == 0) {
        printf("The mask_string in geometry: %s did not find any of the specified volumes in the mask_string %s \n",NAME_CURRENT_COMP,mask_string);
        exit(1);
    }
    this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
    this_box_volume.p_physics->is_vacuum = 0; // Makes this volume a vacuum
    this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
    this_box_volume.p_physics->my_a = 0; // Should not be used.
    sprintf(this_box_volume.p_physics->name,"Mask");
    this_box_volume.geometry.is_mask_volume = 1;
    
    
// Read the material input, or if it lacks, use automatic linking.
} else if (material_string && strlen(material_string) && strcmp(material_string, "NULL") && strcmp(material_string, "0")) {
    // A geometry string was given, use it to determine which material
    if (0 == strcmp(material_string,"vacuum") || 0 == strcmp(material_string,"Vacuum")) {
        // One could have a global physics struct for vacuum instead of creating one for each
        this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
        this_box_volume.p_physics->is_vacuum = 1; // Makes this volume a vacuum
        this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
        this_box_volume.p_physics->my_a = 0; // Should not be used.
        sprintf(this_box_volume.p_physics->name,"Vacuum");
    } else if (0 == strcmp(material_string,"exit") || 0 == strcmp(material_string,"Exit")) {
        // One could have a global physics struct for vacuum instead of creating one for each
        this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
        this_box_volume.p_physics->is_vacuum = 1; // Makes this volume a vacuum
        this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
        this_box_volume.p_physics->my_a = 0; // Should not be used.
        this_box_volume.geometry.is_exit_volume = 1;
        sprintf(this_box_volume.p_physics->name,"Exit");
    } else {
        #ifndef MATERIAL_DETECTOR
            printf("Need to define a material before refering to it in a geometry %s.\n",NAME_CURRENT_COMP);
            exit(1);
        #endif
        for (loop_index=0;loop_index<global_material_list.num_elements;loop_index++) {
            if (0 == strcmp(material_string,global_material_list.elements[loop_index].name)) {
                this_box_volume.p_physics = global_material_list.elements[loop_index].physics;
                break;
            }
            if (loop_index == global_material_list.num_elements-1) {
            printf("\n");
            printf("ERROR: The material string \"%s\" in Union geometry \"%s\" did not match a specified material. \n",material_string,NAME_CURRENT_COMP);
            printf("       The materials available at this point (need to be defined before the geometry): \n");
            for (loop_index=0;loop_index<global_material_list.num_elements;loop_index++)
              printf("         %s\n",global_material_list.elements[loop_index].name);
            printf("\n");
            printf("       It is also possible to use one of the defualt materials avaiable: \n");
            printf("           Vacuum (for a Volume without scattering or absorption)\n");
            printf("           Exit (for a Volume where the ray exits the component if it enters)\n");
            printf("           Mask (for a Volume that masks existing volumes specified in the mask_string\n");
            exit(1);
          }
        }
    }
} else {
    // Automatic linking, simply using the last defined material.
    #ifndef MATERIAL_DETECTOR
        printf("Need to define a material before the geometry to use automatic linking %s.\n",NAME_CURRENT_COMP);
        exit(1);
    #endif
    this_box_volume.p_physics = global_material_list.elements[global_material_list.num_elements-1].physics;
}

sprintf(this_box_volume.name,NAME_CURRENT_COMP);
sprintf(this_box_volume.geometry.shape,"box");
this_box_volume.geometry.priority_value = priority;
this_box_volume.geometry.geometry_p_interact = p_interact;
// Currently the coordinates will be in absolute space.
this_box_volume.geometry.center = POS_A_CURRENT_COMP;

this_box_storage.z_depth = zdepth;
this_box_storage.x_width1 = xwidth;
this_box_storage.y_height1 = yheight;

this_box_storage.is_rectangle = 0;
if (xwidth2 < 0 && yheight2 < 0) this_box_storage.is_rectangle = 1;
if (xwidth == xwidth2 && yheight == yheight2) this_box_storage.is_rectangle = 1;

if (xwidth2 < 0) {
    this_box_storage.x_width2 = xwidth;
    xwidth2 = xwidth;
} else this_box_storage.x_width2 = xwidth2;

if (yheight2 < 0) {
    this_box_storage.y_height2 = yheight;
    yheight2 = yheight;
} else this_box_storage.y_height2 = yheight2;


this_box_storage.normal_vectors[0] = coords_set(0,0,1);
this_box_storage.normal_vectors[1] = coords_set(0,0,1);

// for sides with y component = 0
x_component = 2*zdepth/sqrt((xwidth-xwidth2)*(xwidth-xwidth2)+4*zdepth*zdepth);
z_component = (xwidth-xwidth2)/sqrt(4*zdepth*zdepth+(xwidth-xwidth2)*(xwidth-xwidth2));

this_box_storage.normal_vectors[2] = coords_set(x_component,0,z_component);
this_box_storage.normal_vectors[3] = coords_set(-x_component,0,z_component);

// for sides with x component = 0
y_component = 2*zdepth/sqrt((yheight-yheight2)*(yheight-yheight2)+4*zdepth*zdepth);
z_component = (yheight-yheight2)/sqrt(4*zdepth*zdepth+(yheight-yheight2)*(yheight-yheight2));

this_box_storage.normal_vectors[4] = coords_set(0,y_component,z_component);
this_box_storage.normal_vectors[5] = coords_set(0,-y_component,z_component);

this_box_volume.geometry.visualization_on = visualize;

this_box_volume.geometry.geometry_parameters.p_box_storage = &this_box_storage;

// Assign pointers to functions for intersection with the shape, checking if a point is inside the shape
if (this_box_storage.is_rectangle == 1) {
this_box_volume.geometry.intersect_function = &sample_box_intersect_simple;
this_box_volume.geometry.within_function = &r_within_box_simple;
}
else {
this_box_volume.geometry.intersect_function = &sample_box_intersect_advanced;
this_box_volume.geometry.within_function = &r_within_box_advanced;
}

this_box_volume.geometry.shell_points = &box_shell_points;
this_box_volume.geometry.mcdisplay_function = &mcdisplay_box_function;
this_box_volume.geometry.initialize_from_main_function = &initialize_box_geometry_from_main_component;
this_box_volume.geometry.process_rot_allocated = 0;

this_box_volume.geometry.copy_geometry_parameters = &allocate_box_storage_copy;

rot_copy(this_box_volume.geometry.rotation_matrix,ROT_A_CURRENT_COMP); //check how ROT_R_CURRENT_COMP would work
rot_transpose(ROT_A_CURRENT_COMP,this_box_volume.geometry.transpose_rotation_matrix);

// Initialize loggers
this_box_volume.loggers.num_elements = 0;

// packing the information into the global_geometry_element, which is then included in the global_geometry_list.
sprintf(global_geometry_element.name,NAME_CURRENT_COMP);
global_geometry_element.activation_counter = number_of_activations;
global_geometry_element.component_index = INDEX_CURRENT_COMP;
global_geometry_element.Volume = &this_box_volume; // Would be nicer if this m was a pointer, now we have the (small) data two places
add_element_to_geometry_list(&global_geometry_list,global_geometry_element);
}
#line 282206 "MACS_sample_kidney_box.c"
#undef number_of_activations
#undef mask_setting
#undef mask_string
#undef p_interact
#undef focus_r
#undef focus_xh
#undef focus_xw
#undef focus_ah
#undef focus_aw
#undef target_z
#undef target_y
#undef target_x
#undef target_index
#undef visualize
#undef yheight2
#undef xwidth2
#undef zdepth
#undef yheight
#undef xwidth
#undef priority
#undef material_string
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

  /* Initializations for component channel_13_analyzer_1_array_crystal_array_8. */
  SIG_MESSAGE("channel_13_analyzer_1_array_crystal_array_8 (Init)");
#define mccompcurname  channel_13_analyzer_1_array_crystal_array_8
#define mccompcurtype  Union_box
#define mccompcurindex 632
#define loop_index mccchannel_13_analyzer_1_array_crystal_array_8_loop_index
#define this_box_volume mccchannel_13_analyzer_1_array_crystal_array_8_this_box_volume
#define global_geometry_element mccchannel_13_analyzer_1_array_crystal_array_8_global_geometry_element
#define this_box_storage mccchannel_13_analyzer_1_array_crystal_array_8_this_box_storage
#define material_string mccchannel_13_analyzer_1_array_crystal_array_8_material_string
#define priority mccchannel_13_analyzer_1_array_crystal_array_8_priority
#define xwidth mccchannel_13_analyzer_1_array_crystal_array_8_xwidth
#define yheight mccchannel_13_analyzer_1_array_crystal_array_8_yheight
#define zdepth mccchannel_13_analyzer_1_array_crystal_array_8_zdepth
#define xwidth2 mccchannel_13_analyzer_1_array_crystal_array_8_xwidth2
#define yheight2 mccchannel_13_analyzer_1_array_crystal_array_8_yheight2
#define visualize mccchannel_13_analyzer_1_array_crystal_array_8_visualize
#define target_index mccchannel_13_analyzer_1_array_crystal_array_8_target_index
#define target_x mccchannel_13_analyzer_1_array_crystal_array_8_target_x
#define target_y mccchannel_13_analyzer_1_array_crystal_array_8_target_y
#define target_z mccchannel_13_analyzer_1_array_crystal_array_8_target_z
#define focus_aw mccchannel_13_analyzer_1_array_crystal_array_8_focus_aw
#define focus_ah mccchannel_13_analyzer_1_array_crystal_array_8_focus_ah
#define focus_xw mccchannel_13_analyzer_1_array_crystal_array_8_focus_xw
#define focus_xh mccchannel_13_analyzer_1_array_crystal_array_8_focus_xh
#define focus_r mccchannel_13_analyzer_1_array_crystal_array_8_focus_r
#define p_interact mccchannel_13_analyzer_1_array_crystal_array_8_p_interact
#define mask_string mccchannel_13_analyzer_1_array_crystal_array_8_mask_string
#define mask_setting mccchannel_13_analyzer_1_array_crystal_array_8_mask_setting
#define number_of_activations mccchannel_13_analyzer_1_array_crystal_array_8_number_of_activations
#line 224 "Union_box.comp"
{
// Initializes the focusing system for this volume including input sanitation.
focus_initialize(&this_box_volume.geometry, POS_A_COMP_INDEX(INDEX_CURRENT_COMP+target_index), POS_A_CURRENT_COMP, ROT_A_CURRENT_COMP, target_index, target_x, target_y, target_z, focus_aw, focus_ah, focus_xw, focus_xh, focus_r, NAME_CURRENT_COMP);

// Input sanitation for this geometry
if (xwidth <= 0) {
  printf("\nERROR in Union_box named %s, the xwidth is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (yheight <= 0) {
  printf("\nERROR in Union_box named %s, yheight is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (zdepth <= 0) {
  printf("\nERROR in Union_box named %s, zdepth is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (xwidth2 <= 0 && xwidth2 != -1) {
  printf("\nERROR in Union_box named %s, the xwidth2 is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (yheight2 <= 0 && yheight2 != -1) {
  printf("\nERROR in Union_box named %s, yheight2 is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}

// Use sanitation
if (global_material_list.num_elements == 0) {
  printf("\nERROR: Need to define a material using Union_make_material before using a Union geometry component. \n");
  printf("       %s was defined before first use of Union_make_material.\n",NAME_CURRENT_COMP);
  exit(1);
}

this_box_volume.geometry.is_masked_volume = 0;
this_box_volume.geometry.is_exit_volume = 0;
this_box_volume.geometry.is_mask_volume = 0;
// check if the volume is a mask, if it is the material string is irelevant.
if (mask_string && strlen(mask_string) && strcmp(mask_string, "NULL") && strcmp(mask_string, "0")) {
    // A mask volume is used to limit the extend of other volumes, called the masked volumes. These are specified in the mask_string.
    // In order for a ray to enter a masked volume, it needs to be both in the region covered by that volume AND the mask volume.
    // When more than
    this_box_volume.geometry.mask_mode = 1; // Default is mask mode is ALL
    if (mask_setting && strlen(mask_setting) && strcmp(mask_setting, "NULL") && strcmp(mask_setting, "0")) {
        if (strcmp(mask_setting,"ALL") == 0 || strcmp(mask_setting,"All") == 0) this_box_volume.geometry.mask_mode = 1;
        else if (strcmp(mask_setting,"ANY") == 0 || strcmp(mask_setting,"Any") == 0) this_box_volume.geometry.mask_mode = 2;
        else {
            printf("The mask_mode of component %s is set to %s, but must be either ALL or ANY.\n",NAME_CURRENT_COMP,mask_setting);
            exit(1);
        }
    }
    
    for (loop_index=0;loop_index<global_geometry_list.num_elements;loop_index++) {
        // Add mask list
        if (1 == manual_linking_function(global_geometry_list.elements[loop_index].name,mask_string)) {
            add_element_to_int_list(&this_box_volume.geometry.mask_list,global_geometry_list.elements[loop_index].component_index);
            add_element_to_int_list(&global_geometry_list.elements[loop_index].Volume->geometry.masked_by_list,INDEX_CURRENT_COMP);
            global_geometry_list.elements[loop_index].Volume->geometry.is_masked_volume = 1;
            if (this_box_volume.geometry.mask_mode == 2)
                global_geometry_list.elements[loop_index].Volume->geometry.mask_mode = 2;
            if (this_box_volume.geometry.mask_mode == 1) {
                if (global_geometry_list.elements[loop_index].Volume->geometry.is_masked_volume == 1 && global_geometry_list.elements[loop_index].Volume->geometry.mask_mode != 2)
                    // If more than one mask is added to one volume, the ANY mode overwrites the (default) ALL mode.
                    global_geometry_list.elements[loop_index].Volume->geometry.mask_mode = 1;
            }
            
            found_geometries = 1;
        }
    }
    if (found_geometries == 0) {
        printf("The mask_string in geometry: %s did not find any of the specified volumes in the mask_string %s \n",NAME_CURRENT_COMP,mask_string);
        exit(1);
    }
    this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
    this_box_volume.p_physics->is_vacuum = 0; // Makes this volume a vacuum
    this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
    this_box_volume.p_physics->my_a = 0; // Should not be used.
    sprintf(this_box_volume.p_physics->name,"Mask");
    this_box_volume.geometry.is_mask_volume = 1;
    
    
// Read the material input, or if it lacks, use automatic linking.
} else if (material_string && strlen(material_string) && strcmp(material_string, "NULL") && strcmp(material_string, "0")) {
    // A geometry string was given, use it to determine which material
    if (0 == strcmp(material_string,"vacuum") || 0 == strcmp(material_string,"Vacuum")) {
        // One could have a global physics struct for vacuum instead of creating one for each
        this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
        this_box_volume.p_physics->is_vacuum = 1; // Makes this volume a vacuum
        this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
        this_box_volume.p_physics->my_a = 0; // Should not be used.
        sprintf(this_box_volume.p_physics->name,"Vacuum");
    } else if (0 == strcmp(material_string,"exit") || 0 == strcmp(material_string,"Exit")) {
        // One could have a global physics struct for vacuum instead of creating one for each
        this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
        this_box_volume.p_physics->is_vacuum = 1; // Makes this volume a vacuum
        this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
        this_box_volume.p_physics->my_a = 0; // Should not be used.
        this_box_volume.geometry.is_exit_volume = 1;
        sprintf(this_box_volume.p_physics->name,"Exit");
    } else {
        #ifndef MATERIAL_DETECTOR
            printf("Need to define a material before refering to it in a geometry %s.\n",NAME_CURRENT_COMP);
            exit(1);
        #endif
        for (loop_index=0;loop_index<global_material_list.num_elements;loop_index++) {
            if (0 == strcmp(material_string,global_material_list.elements[loop_index].name)) {
                this_box_volume.p_physics = global_material_list.elements[loop_index].physics;
                break;
            }
            if (loop_index == global_material_list.num_elements-1) {
            printf("\n");
            printf("ERROR: The material string \"%s\" in Union geometry \"%s\" did not match a specified material. \n",material_string,NAME_CURRENT_COMP);
            printf("       The materials available at this point (need to be defined before the geometry): \n");
            for (loop_index=0;loop_index<global_material_list.num_elements;loop_index++)
              printf("         %s\n",global_material_list.elements[loop_index].name);
            printf("\n");
            printf("       It is also possible to use one of the defualt materials avaiable: \n");
            printf("           Vacuum (for a Volume without scattering or absorption)\n");
            printf("           Exit (for a Volume where the ray exits the component if it enters)\n");
            printf("           Mask (for a Volume that masks existing volumes specified in the mask_string\n");
            exit(1);
          }
        }
    }
} else {
    // Automatic linking, simply using the last defined material.
    #ifndef MATERIAL_DETECTOR
        printf("Need to define a material before the geometry to use automatic linking %s.\n",NAME_CURRENT_COMP);
        exit(1);
    #endif
    this_box_volume.p_physics = global_material_list.elements[global_material_list.num_elements-1].physics;
}

sprintf(this_box_volume.name,NAME_CURRENT_COMP);
sprintf(this_box_volume.geometry.shape,"box");
this_box_volume.geometry.priority_value = priority;
this_box_volume.geometry.geometry_p_interact = p_interact;
// Currently the coordinates will be in absolute space.
this_box_volume.geometry.center = POS_A_CURRENT_COMP;

this_box_storage.z_depth = zdepth;
this_box_storage.x_width1 = xwidth;
this_box_storage.y_height1 = yheight;

this_box_storage.is_rectangle = 0;
if (xwidth2 < 0 && yheight2 < 0) this_box_storage.is_rectangle = 1;
if (xwidth == xwidth2 && yheight == yheight2) this_box_storage.is_rectangle = 1;

if (xwidth2 < 0) {
    this_box_storage.x_width2 = xwidth;
    xwidth2 = xwidth;
} else this_box_storage.x_width2 = xwidth2;

if (yheight2 < 0) {
    this_box_storage.y_height2 = yheight;
    yheight2 = yheight;
} else this_box_storage.y_height2 = yheight2;


this_box_storage.normal_vectors[0] = coords_set(0,0,1);
this_box_storage.normal_vectors[1] = coords_set(0,0,1);

// for sides with y component = 0
x_component = 2*zdepth/sqrt((xwidth-xwidth2)*(xwidth-xwidth2)+4*zdepth*zdepth);
z_component = (xwidth-xwidth2)/sqrt(4*zdepth*zdepth+(xwidth-xwidth2)*(xwidth-xwidth2));

this_box_storage.normal_vectors[2] = coords_set(x_component,0,z_component);
this_box_storage.normal_vectors[3] = coords_set(-x_component,0,z_component);

// for sides with x component = 0
y_component = 2*zdepth/sqrt((yheight-yheight2)*(yheight-yheight2)+4*zdepth*zdepth);
z_component = (yheight-yheight2)/sqrt(4*zdepth*zdepth+(yheight-yheight2)*(yheight-yheight2));

this_box_storage.normal_vectors[4] = coords_set(0,y_component,z_component);
this_box_storage.normal_vectors[5] = coords_set(0,-y_component,z_component);

this_box_volume.geometry.visualization_on = visualize;

this_box_volume.geometry.geometry_parameters.p_box_storage = &this_box_storage;

// Assign pointers to functions for intersection with the shape, checking if a point is inside the shape
if (this_box_storage.is_rectangle == 1) {
this_box_volume.geometry.intersect_function = &sample_box_intersect_simple;
this_box_volume.geometry.within_function = &r_within_box_simple;
}
else {
this_box_volume.geometry.intersect_function = &sample_box_intersect_advanced;
this_box_volume.geometry.within_function = &r_within_box_advanced;
}

this_box_volume.geometry.shell_points = &box_shell_points;
this_box_volume.geometry.mcdisplay_function = &mcdisplay_box_function;
this_box_volume.geometry.initialize_from_main_function = &initialize_box_geometry_from_main_component;
this_box_volume.geometry.process_rot_allocated = 0;

this_box_volume.geometry.copy_geometry_parameters = &allocate_box_storage_copy;

rot_copy(this_box_volume.geometry.rotation_matrix,ROT_A_CURRENT_COMP); //check how ROT_R_CURRENT_COMP would work
rot_transpose(ROT_A_CURRENT_COMP,this_box_volume.geometry.transpose_rotation_matrix);

// Initialize loggers
this_box_volume.loggers.num_elements = 0;

// packing the information into the global_geometry_element, which is then included in the global_geometry_list.
sprintf(global_geometry_element.name,NAME_CURRENT_COMP);
global_geometry_element.activation_counter = number_of_activations;
global_geometry_element.component_index = INDEX_CURRENT_COMP;
global_geometry_element.Volume = &this_box_volume; // Would be nicer if this m was a pointer, now we have the (small) data two places
add_element_to_geometry_list(&global_geometry_list,global_geometry_element);
}
#line 282476 "MACS_sample_kidney_box.c"
#undef number_of_activations
#undef mask_setting
#undef mask_string
#undef p_interact
#undef focus_r
#undef focus_xh
#undef focus_xw
#undef focus_ah
#undef focus_aw
#undef target_z
#undef target_y
#undef target_x
#undef target_index
#undef visualize
#undef yheight2
#undef xwidth2
#undef zdepth
#undef yheight
#undef xwidth
#undef priority
#undef material_string
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

  /* Initializations for component channel_13_analyzer_2_center. */
  SIG_MESSAGE("channel_13_analyzer_2_center (Init)");

  /* Initializations for component channel_13_analyzer_2_rotated. */
  SIG_MESSAGE("channel_13_analyzer_2_rotated (Init)");

  /* Initializations for component channel_13_analyzer_2_array_crystal_array_0. */
  SIG_MESSAGE("channel_13_analyzer_2_array_crystal_array_0 (Init)");
#define mccompcurname  channel_13_analyzer_2_array_crystal_array_0
#define mccompcurtype  Union_box
#define mccompcurindex 635
#define loop_index mccchannel_13_analyzer_2_array_crystal_array_0_loop_index
#define this_box_volume mccchannel_13_analyzer_2_array_crystal_array_0_this_box_volume
#define global_geometry_element mccchannel_13_analyzer_2_array_crystal_array_0_global_geometry_element
#define this_box_storage mccchannel_13_analyzer_2_array_crystal_array_0_this_box_storage
#define material_string mccchannel_13_analyzer_2_array_crystal_array_0_material_string
#define priority mccchannel_13_analyzer_2_array_crystal_array_0_priority
#define xwidth mccchannel_13_analyzer_2_array_crystal_array_0_xwidth
#define yheight mccchannel_13_analyzer_2_array_crystal_array_0_yheight
#define zdepth mccchannel_13_analyzer_2_array_crystal_array_0_zdepth
#define xwidth2 mccchannel_13_analyzer_2_array_crystal_array_0_xwidth2
#define yheight2 mccchannel_13_analyzer_2_array_crystal_array_0_yheight2
#define visualize mccchannel_13_analyzer_2_array_crystal_array_0_visualize
#define target_index mccchannel_13_analyzer_2_array_crystal_array_0_target_index
#define target_x mccchannel_13_analyzer_2_array_crystal_array_0_target_x
#define target_y mccchannel_13_analyzer_2_array_crystal_array_0_target_y
#define target_z mccchannel_13_analyzer_2_array_crystal_array_0_target_z
#define focus_aw mccchannel_13_analyzer_2_array_crystal_array_0_focus_aw
#define focus_ah mccchannel_13_analyzer_2_array_crystal_array_0_focus_ah
#define focus_xw mccchannel_13_analyzer_2_array_crystal_array_0_focus_xw
#define focus_xh mccchannel_13_analyzer_2_array_crystal_array_0_focus_xh
#define focus_r mccchannel_13_analyzer_2_array_crystal_array_0_focus_r
#define p_interact mccchannel_13_analyzer_2_array_crystal_array_0_p_interact
#define mask_string mccchannel_13_analyzer_2_array_crystal_array_0_mask_string
#define mask_setting mccchannel_13_analyzer_2_array_crystal_array_0_mask_setting
#define number_of_activations mccchannel_13_analyzer_2_array_crystal_array_0_number_of_activations
#line 224 "Union_box.comp"
{
// Initializes the focusing system for this volume including input sanitation.
focus_initialize(&this_box_volume.geometry, POS_A_COMP_INDEX(INDEX_CURRENT_COMP+target_index), POS_A_CURRENT_COMP, ROT_A_CURRENT_COMP, target_index, target_x, target_y, target_z, focus_aw, focus_ah, focus_xw, focus_xh, focus_r, NAME_CURRENT_COMP);

// Input sanitation for this geometry
if (xwidth <= 0) {
  printf("\nERROR in Union_box named %s, the xwidth is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (yheight <= 0) {
  printf("\nERROR in Union_box named %s, yheight is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (zdepth <= 0) {
  printf("\nERROR in Union_box named %s, zdepth is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (xwidth2 <= 0 && xwidth2 != -1) {
  printf("\nERROR in Union_box named %s, the xwidth2 is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (yheight2 <= 0 && yheight2 != -1) {
  printf("\nERROR in Union_box named %s, yheight2 is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}

// Use sanitation
if (global_material_list.num_elements == 0) {
  printf("\nERROR: Need to define a material using Union_make_material before using a Union geometry component. \n");
  printf("       %s was defined before first use of Union_make_material.\n",NAME_CURRENT_COMP);
  exit(1);
}

this_box_volume.geometry.is_masked_volume = 0;
this_box_volume.geometry.is_exit_volume = 0;
this_box_volume.geometry.is_mask_volume = 0;
// check if the volume is a mask, if it is the material string is irelevant.
if (mask_string && strlen(mask_string) && strcmp(mask_string, "NULL") && strcmp(mask_string, "0")) {
    // A mask volume is used to limit the extend of other volumes, called the masked volumes. These are specified in the mask_string.
    // In order for a ray to enter a masked volume, it needs to be both in the region covered by that volume AND the mask volume.
    // When more than
    this_box_volume.geometry.mask_mode = 1; // Default is mask mode is ALL
    if (mask_setting && strlen(mask_setting) && strcmp(mask_setting, "NULL") && strcmp(mask_setting, "0")) {
        if (strcmp(mask_setting,"ALL") == 0 || strcmp(mask_setting,"All") == 0) this_box_volume.geometry.mask_mode = 1;
        else if (strcmp(mask_setting,"ANY") == 0 || strcmp(mask_setting,"Any") == 0) this_box_volume.geometry.mask_mode = 2;
        else {
            printf("The mask_mode of component %s is set to %s, but must be either ALL or ANY.\n",NAME_CURRENT_COMP,mask_setting);
            exit(1);
        }
    }
    
    for (loop_index=0;loop_index<global_geometry_list.num_elements;loop_index++) {
        // Add mask list
        if (1 == manual_linking_function(global_geometry_list.elements[loop_index].name,mask_string)) {
            add_element_to_int_list(&this_box_volume.geometry.mask_list,global_geometry_list.elements[loop_index].component_index);
            add_element_to_int_list(&global_geometry_list.elements[loop_index].Volume->geometry.masked_by_list,INDEX_CURRENT_COMP);
            global_geometry_list.elements[loop_index].Volume->geometry.is_masked_volume = 1;
            if (this_box_volume.geometry.mask_mode == 2)
                global_geometry_list.elements[loop_index].Volume->geometry.mask_mode = 2;
            if (this_box_volume.geometry.mask_mode == 1) {
                if (global_geometry_list.elements[loop_index].Volume->geometry.is_masked_volume == 1 && global_geometry_list.elements[loop_index].Volume->geometry.mask_mode != 2)
                    // If more than one mask is added to one volume, the ANY mode overwrites the (default) ALL mode.
                    global_geometry_list.elements[loop_index].Volume->geometry.mask_mode = 1;
            }
            
            found_geometries = 1;
        }
    }
    if (found_geometries == 0) {
        printf("The mask_string in geometry: %s did not find any of the specified volumes in the mask_string %s \n",NAME_CURRENT_COMP,mask_string);
        exit(1);
    }
    this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
    this_box_volume.p_physics->is_vacuum = 0; // Makes this volume a vacuum
    this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
    this_box_volume.p_physics->my_a = 0; // Should not be used.
    sprintf(this_box_volume.p_physics->name,"Mask");
    this_box_volume.geometry.is_mask_volume = 1;
    
    
// Read the material input, or if it lacks, use automatic linking.
} else if (material_string && strlen(material_string) && strcmp(material_string, "NULL") && strcmp(material_string, "0")) {
    // A geometry string was given, use it to determine which material
    if (0 == strcmp(material_string,"vacuum") || 0 == strcmp(material_string,"Vacuum")) {
        // One could have a global physics struct for vacuum instead of creating one for each
        this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
        this_box_volume.p_physics->is_vacuum = 1; // Makes this volume a vacuum
        this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
        this_box_volume.p_physics->my_a = 0; // Should not be used.
        sprintf(this_box_volume.p_physics->name,"Vacuum");
    } else if (0 == strcmp(material_string,"exit") || 0 == strcmp(material_string,"Exit")) {
        // One could have a global physics struct for vacuum instead of creating one for each
        this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
        this_box_volume.p_physics->is_vacuum = 1; // Makes this volume a vacuum
        this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
        this_box_volume.p_physics->my_a = 0; // Should not be used.
        this_box_volume.geometry.is_exit_volume = 1;
        sprintf(this_box_volume.p_physics->name,"Exit");
    } else {
        #ifndef MATERIAL_DETECTOR
            printf("Need to define a material before refering to it in a geometry %s.\n",NAME_CURRENT_COMP);
            exit(1);
        #endif
        for (loop_index=0;loop_index<global_material_list.num_elements;loop_index++) {
            if (0 == strcmp(material_string,global_material_list.elements[loop_index].name)) {
                this_box_volume.p_physics = global_material_list.elements[loop_index].physics;
                break;
            }
            if (loop_index == global_material_list.num_elements-1) {
            printf("\n");
            printf("ERROR: The material string \"%s\" in Union geometry \"%s\" did not match a specified material. \n",material_string,NAME_CURRENT_COMP);
            printf("       The materials available at this point (need to be defined before the geometry): \n");
            for (loop_index=0;loop_index<global_material_list.num_elements;loop_index++)
              printf("         %s\n",global_material_list.elements[loop_index].name);
            printf("\n");
            printf("       It is also possible to use one of the defualt materials avaiable: \n");
            printf("           Vacuum (for a Volume without scattering or absorption)\n");
            printf("           Exit (for a Volume where the ray exits the component if it enters)\n");
            printf("           Mask (for a Volume that masks existing volumes specified in the mask_string\n");
            exit(1);
          }
        }
    }
} else {
    // Automatic linking, simply using the last defined material.
    #ifndef MATERIAL_DETECTOR
        printf("Need to define a material before the geometry to use automatic linking %s.\n",NAME_CURRENT_COMP);
        exit(1);
    #endif
    this_box_volume.p_physics = global_material_list.elements[global_material_list.num_elements-1].physics;
}

sprintf(this_box_volume.name,NAME_CURRENT_COMP);
sprintf(this_box_volume.geometry.shape,"box");
this_box_volume.geometry.priority_value = priority;
this_box_volume.geometry.geometry_p_interact = p_interact;
// Currently the coordinates will be in absolute space.
this_box_volume.geometry.center = POS_A_CURRENT_COMP;

this_box_storage.z_depth = zdepth;
this_box_storage.x_width1 = xwidth;
this_box_storage.y_height1 = yheight;

this_box_storage.is_rectangle = 0;
if (xwidth2 < 0 && yheight2 < 0) this_box_storage.is_rectangle = 1;
if (xwidth == xwidth2 && yheight == yheight2) this_box_storage.is_rectangle = 1;

if (xwidth2 < 0) {
    this_box_storage.x_width2 = xwidth;
    xwidth2 = xwidth;
} else this_box_storage.x_width2 = xwidth2;

if (yheight2 < 0) {
    this_box_storage.y_height2 = yheight;
    yheight2 = yheight;
} else this_box_storage.y_height2 = yheight2;


this_box_storage.normal_vectors[0] = coords_set(0,0,1);
this_box_storage.normal_vectors[1] = coords_set(0,0,1);

// for sides with y component = 0
x_component = 2*zdepth/sqrt((xwidth-xwidth2)*(xwidth-xwidth2)+4*zdepth*zdepth);
z_component = (xwidth-xwidth2)/sqrt(4*zdepth*zdepth+(xwidth-xwidth2)*(xwidth-xwidth2));

this_box_storage.normal_vectors[2] = coords_set(x_component,0,z_component);
this_box_storage.normal_vectors[3] = coords_set(-x_component,0,z_component);

// for sides with x component = 0
y_component = 2*zdepth/sqrt((yheight-yheight2)*(yheight-yheight2)+4*zdepth*zdepth);
z_component = (yheight-yheight2)/sqrt(4*zdepth*zdepth+(yheight-yheight2)*(yheight-yheight2));

this_box_storage.normal_vectors[4] = coords_set(0,y_component,z_component);
this_box_storage.normal_vectors[5] = coords_set(0,-y_component,z_component);

this_box_volume.geometry.visualization_on = visualize;

this_box_volume.geometry.geometry_parameters.p_box_storage = &this_box_storage;

// Assign pointers to functions for intersection with the shape, checking if a point is inside the shape
if (this_box_storage.is_rectangle == 1) {
this_box_volume.geometry.intersect_function = &sample_box_intersect_simple;
this_box_volume.geometry.within_function = &r_within_box_simple;
}
else {
this_box_volume.geometry.intersect_function = &sample_box_intersect_advanced;
this_box_volume.geometry.within_function = &r_within_box_advanced;
}

this_box_volume.geometry.shell_points = &box_shell_points;
this_box_volume.geometry.mcdisplay_function = &mcdisplay_box_function;
this_box_volume.geometry.initialize_from_main_function = &initialize_box_geometry_from_main_component;
this_box_volume.geometry.process_rot_allocated = 0;

this_box_volume.geometry.copy_geometry_parameters = &allocate_box_storage_copy;

rot_copy(this_box_volume.geometry.rotation_matrix,ROT_A_CURRENT_COMP); //check how ROT_R_CURRENT_COMP would work
rot_transpose(ROT_A_CURRENT_COMP,this_box_volume.geometry.transpose_rotation_matrix);

// Initialize loggers
this_box_volume.loggers.num_elements = 0;

// packing the information into the global_geometry_element, which is then included in the global_geometry_list.
sprintf(global_geometry_element.name,NAME_CURRENT_COMP);
global_geometry_element.activation_counter = number_of_activations;
global_geometry_element.component_index = INDEX_CURRENT_COMP;
global_geometry_element.Volume = &this_box_volume; // Would be nicer if this m was a pointer, now we have the (small) data two places
add_element_to_geometry_list(&global_geometry_list,global_geometry_element);
}
#line 282752 "MACS_sample_kidney_box.c"
#undef number_of_activations
#undef mask_setting
#undef mask_string
#undef p_interact
#undef focus_r
#undef focus_xh
#undef focus_xw
#undef focus_ah
#undef focus_aw
#undef target_z
#undef target_y
#undef target_x
#undef target_index
#undef visualize
#undef yheight2
#undef xwidth2
#undef zdepth
#undef yheight
#undef xwidth
#undef priority
#undef material_string
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

  /* Initializations for component channel_13_analyzer_2_array_crystal_array_1. */
  SIG_MESSAGE("channel_13_analyzer_2_array_crystal_array_1 (Init)");
#define mccompcurname  channel_13_analyzer_2_array_crystal_array_1
#define mccompcurtype  Union_box
#define mccompcurindex 636
#define loop_index mccchannel_13_analyzer_2_array_crystal_array_1_loop_index
#define this_box_volume mccchannel_13_analyzer_2_array_crystal_array_1_this_box_volume
#define global_geometry_element mccchannel_13_analyzer_2_array_crystal_array_1_global_geometry_element
#define this_box_storage mccchannel_13_analyzer_2_array_crystal_array_1_this_box_storage
#define material_string mccchannel_13_analyzer_2_array_crystal_array_1_material_string
#define priority mccchannel_13_analyzer_2_array_crystal_array_1_priority
#define xwidth mccchannel_13_analyzer_2_array_crystal_array_1_xwidth
#define yheight mccchannel_13_analyzer_2_array_crystal_array_1_yheight
#define zdepth mccchannel_13_analyzer_2_array_crystal_array_1_zdepth
#define xwidth2 mccchannel_13_analyzer_2_array_crystal_array_1_xwidth2
#define yheight2 mccchannel_13_analyzer_2_array_crystal_array_1_yheight2
#define visualize mccchannel_13_analyzer_2_array_crystal_array_1_visualize
#define target_index mccchannel_13_analyzer_2_array_crystal_array_1_target_index
#define target_x mccchannel_13_analyzer_2_array_crystal_array_1_target_x
#define target_y mccchannel_13_analyzer_2_array_crystal_array_1_target_y
#define target_z mccchannel_13_analyzer_2_array_crystal_array_1_target_z
#define focus_aw mccchannel_13_analyzer_2_array_crystal_array_1_focus_aw
#define focus_ah mccchannel_13_analyzer_2_array_crystal_array_1_focus_ah
#define focus_xw mccchannel_13_analyzer_2_array_crystal_array_1_focus_xw
#define focus_xh mccchannel_13_analyzer_2_array_crystal_array_1_focus_xh
#define focus_r mccchannel_13_analyzer_2_array_crystal_array_1_focus_r
#define p_interact mccchannel_13_analyzer_2_array_crystal_array_1_p_interact
#define mask_string mccchannel_13_analyzer_2_array_crystal_array_1_mask_string
#define mask_setting mccchannel_13_analyzer_2_array_crystal_array_1_mask_setting
#define number_of_activations mccchannel_13_analyzer_2_array_crystal_array_1_number_of_activations
#line 224 "Union_box.comp"
{
// Initializes the focusing system for this volume including input sanitation.
focus_initialize(&this_box_volume.geometry, POS_A_COMP_INDEX(INDEX_CURRENT_COMP+target_index), POS_A_CURRENT_COMP, ROT_A_CURRENT_COMP, target_index, target_x, target_y, target_z, focus_aw, focus_ah, focus_xw, focus_xh, focus_r, NAME_CURRENT_COMP);

// Input sanitation for this geometry
if (xwidth <= 0) {
  printf("\nERROR in Union_box named %s, the xwidth is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (yheight <= 0) {
  printf("\nERROR in Union_box named %s, yheight is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (zdepth <= 0) {
  printf("\nERROR in Union_box named %s, zdepth is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (xwidth2 <= 0 && xwidth2 != -1) {
  printf("\nERROR in Union_box named %s, the xwidth2 is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (yheight2 <= 0 && yheight2 != -1) {
  printf("\nERROR in Union_box named %s, yheight2 is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}

// Use sanitation
if (global_material_list.num_elements == 0) {
  printf("\nERROR: Need to define a material using Union_make_material before using a Union geometry component. \n");
  printf("       %s was defined before first use of Union_make_material.\n",NAME_CURRENT_COMP);
  exit(1);
}

this_box_volume.geometry.is_masked_volume = 0;
this_box_volume.geometry.is_exit_volume = 0;
this_box_volume.geometry.is_mask_volume = 0;
// check if the volume is a mask, if it is the material string is irelevant.
if (mask_string && strlen(mask_string) && strcmp(mask_string, "NULL") && strcmp(mask_string, "0")) {
    // A mask volume is used to limit the extend of other volumes, called the masked volumes. These are specified in the mask_string.
    // In order for a ray to enter a masked volume, it needs to be both in the region covered by that volume AND the mask volume.
    // When more than
    this_box_volume.geometry.mask_mode = 1; // Default is mask mode is ALL
    if (mask_setting && strlen(mask_setting) && strcmp(mask_setting, "NULL") && strcmp(mask_setting, "0")) {
        if (strcmp(mask_setting,"ALL") == 0 || strcmp(mask_setting,"All") == 0) this_box_volume.geometry.mask_mode = 1;
        else if (strcmp(mask_setting,"ANY") == 0 || strcmp(mask_setting,"Any") == 0) this_box_volume.geometry.mask_mode = 2;
        else {
            printf("The mask_mode of component %s is set to %s, but must be either ALL or ANY.\n",NAME_CURRENT_COMP,mask_setting);
            exit(1);
        }
    }
    
    for (loop_index=0;loop_index<global_geometry_list.num_elements;loop_index++) {
        // Add mask list
        if (1 == manual_linking_function(global_geometry_list.elements[loop_index].name,mask_string)) {
            add_element_to_int_list(&this_box_volume.geometry.mask_list,global_geometry_list.elements[loop_index].component_index);
            add_element_to_int_list(&global_geometry_list.elements[loop_index].Volume->geometry.masked_by_list,INDEX_CURRENT_COMP);
            global_geometry_list.elements[loop_index].Volume->geometry.is_masked_volume = 1;
            if (this_box_volume.geometry.mask_mode == 2)
                global_geometry_list.elements[loop_index].Volume->geometry.mask_mode = 2;
            if (this_box_volume.geometry.mask_mode == 1) {
                if (global_geometry_list.elements[loop_index].Volume->geometry.is_masked_volume == 1 && global_geometry_list.elements[loop_index].Volume->geometry.mask_mode != 2)
                    // If more than one mask is added to one volume, the ANY mode overwrites the (default) ALL mode.
                    global_geometry_list.elements[loop_index].Volume->geometry.mask_mode = 1;
            }
            
            found_geometries = 1;
        }
    }
    if (found_geometries == 0) {
        printf("The mask_string in geometry: %s did not find any of the specified volumes in the mask_string %s \n",NAME_CURRENT_COMP,mask_string);
        exit(1);
    }
    this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
    this_box_volume.p_physics->is_vacuum = 0; // Makes this volume a vacuum
    this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
    this_box_volume.p_physics->my_a = 0; // Should not be used.
    sprintf(this_box_volume.p_physics->name,"Mask");
    this_box_volume.geometry.is_mask_volume = 1;
    
    
// Read the material input, or if it lacks, use automatic linking.
} else if (material_string && strlen(material_string) && strcmp(material_string, "NULL") && strcmp(material_string, "0")) {
    // A geometry string was given, use it to determine which material
    if (0 == strcmp(material_string,"vacuum") || 0 == strcmp(material_string,"Vacuum")) {
        // One could have a global physics struct for vacuum instead of creating one for each
        this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
        this_box_volume.p_physics->is_vacuum = 1; // Makes this volume a vacuum
        this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
        this_box_volume.p_physics->my_a = 0; // Should not be used.
        sprintf(this_box_volume.p_physics->name,"Vacuum");
    } else if (0 == strcmp(material_string,"exit") || 0 == strcmp(material_string,"Exit")) {
        // One could have a global physics struct for vacuum instead of creating one for each
        this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
        this_box_volume.p_physics->is_vacuum = 1; // Makes this volume a vacuum
        this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
        this_box_volume.p_physics->my_a = 0; // Should not be used.
        this_box_volume.geometry.is_exit_volume = 1;
        sprintf(this_box_volume.p_physics->name,"Exit");
    } else {
        #ifndef MATERIAL_DETECTOR
            printf("Need to define a material before refering to it in a geometry %s.\n",NAME_CURRENT_COMP);
            exit(1);
        #endif
        for (loop_index=0;loop_index<global_material_list.num_elements;loop_index++) {
            if (0 == strcmp(material_string,global_material_list.elements[loop_index].name)) {
                this_box_volume.p_physics = global_material_list.elements[loop_index].physics;
                break;
            }
            if (loop_index == global_material_list.num_elements-1) {
            printf("\n");
            printf("ERROR: The material string \"%s\" in Union geometry \"%s\" did not match a specified material. \n",material_string,NAME_CURRENT_COMP);
            printf("       The materials available at this point (need to be defined before the geometry): \n");
            for (loop_index=0;loop_index<global_material_list.num_elements;loop_index++)
              printf("         %s\n",global_material_list.elements[loop_index].name);
            printf("\n");
            printf("       It is also possible to use one of the defualt materials avaiable: \n");
            printf("           Vacuum (for a Volume without scattering or absorption)\n");
            printf("           Exit (for a Volume where the ray exits the component if it enters)\n");
            printf("           Mask (for a Volume that masks existing volumes specified in the mask_string\n");
            exit(1);
          }
        }
    }
} else {
    // Automatic linking, simply using the last defined material.
    #ifndef MATERIAL_DETECTOR
        printf("Need to define a material before the geometry to use automatic linking %s.\n",NAME_CURRENT_COMP);
        exit(1);
    #endif
    this_box_volume.p_physics = global_material_list.elements[global_material_list.num_elements-1].physics;
}

sprintf(this_box_volume.name,NAME_CURRENT_COMP);
sprintf(this_box_volume.geometry.shape,"box");
this_box_volume.geometry.priority_value = priority;
this_box_volume.geometry.geometry_p_interact = p_interact;
// Currently the coordinates will be in absolute space.
this_box_volume.geometry.center = POS_A_CURRENT_COMP;

this_box_storage.z_depth = zdepth;
this_box_storage.x_width1 = xwidth;
this_box_storage.y_height1 = yheight;

this_box_storage.is_rectangle = 0;
if (xwidth2 < 0 && yheight2 < 0) this_box_storage.is_rectangle = 1;
if (xwidth == xwidth2 && yheight == yheight2) this_box_storage.is_rectangle = 1;

if (xwidth2 < 0) {
    this_box_storage.x_width2 = xwidth;
    xwidth2 = xwidth;
} else this_box_storage.x_width2 = xwidth2;

if (yheight2 < 0) {
    this_box_storage.y_height2 = yheight;
    yheight2 = yheight;
} else this_box_storage.y_height2 = yheight2;


this_box_storage.normal_vectors[0] = coords_set(0,0,1);
this_box_storage.normal_vectors[1] = coords_set(0,0,1);

// for sides with y component = 0
x_component = 2*zdepth/sqrt((xwidth-xwidth2)*(xwidth-xwidth2)+4*zdepth*zdepth);
z_component = (xwidth-xwidth2)/sqrt(4*zdepth*zdepth+(xwidth-xwidth2)*(xwidth-xwidth2));

this_box_storage.normal_vectors[2] = coords_set(x_component,0,z_component);
this_box_storage.normal_vectors[3] = coords_set(-x_component,0,z_component);

// for sides with x component = 0
y_component = 2*zdepth/sqrt((yheight-yheight2)*(yheight-yheight2)+4*zdepth*zdepth);
z_component = (yheight-yheight2)/sqrt(4*zdepth*zdepth+(yheight-yheight2)*(yheight-yheight2));

this_box_storage.normal_vectors[4] = coords_set(0,y_component,z_component);
this_box_storage.normal_vectors[5] = coords_set(0,-y_component,z_component);

this_box_volume.geometry.visualization_on = visualize;

this_box_volume.geometry.geometry_parameters.p_box_storage = &this_box_storage;

// Assign pointers to functions for intersection with the shape, checking if a point is inside the shape
if (this_box_storage.is_rectangle == 1) {
this_box_volume.geometry.intersect_function = &sample_box_intersect_simple;
this_box_volume.geometry.within_function = &r_within_box_simple;
}
else {
this_box_volume.geometry.intersect_function = &sample_box_intersect_advanced;
this_box_volume.geometry.within_function = &r_within_box_advanced;
}

this_box_volume.geometry.shell_points = &box_shell_points;
this_box_volume.geometry.mcdisplay_function = &mcdisplay_box_function;
this_box_volume.geometry.initialize_from_main_function = &initialize_box_geometry_from_main_component;
this_box_volume.geometry.process_rot_allocated = 0;

this_box_volume.geometry.copy_geometry_parameters = &allocate_box_storage_copy;

rot_copy(this_box_volume.geometry.rotation_matrix,ROT_A_CURRENT_COMP); //check how ROT_R_CURRENT_COMP would work
rot_transpose(ROT_A_CURRENT_COMP,this_box_volume.geometry.transpose_rotation_matrix);

// Initialize loggers
this_box_volume.loggers.num_elements = 0;

// packing the information into the global_geometry_element, which is then included in the global_geometry_list.
sprintf(global_geometry_element.name,NAME_CURRENT_COMP);
global_geometry_element.activation_counter = number_of_activations;
global_geometry_element.component_index = INDEX_CURRENT_COMP;
global_geometry_element.Volume = &this_box_volume; // Would be nicer if this m was a pointer, now we have the (small) data two places
add_element_to_geometry_list(&global_geometry_list,global_geometry_element);
}
#line 283022 "MACS_sample_kidney_box.c"
#undef number_of_activations
#undef mask_setting
#undef mask_string
#undef p_interact
#undef focus_r
#undef focus_xh
#undef focus_xw
#undef focus_ah
#undef focus_aw
#undef target_z
#undef target_y
#undef target_x
#undef target_index
#undef visualize
#undef yheight2
#undef xwidth2
#undef zdepth
#undef yheight
#undef xwidth
#undef priority
#undef material_string
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

  /* Initializations for component channel_13_analyzer_2_array_crystal_array_2. */
  SIG_MESSAGE("channel_13_analyzer_2_array_crystal_array_2 (Init)");
#define mccompcurname  channel_13_analyzer_2_array_crystal_array_2
#define mccompcurtype  Union_box
#define mccompcurindex 637
#define loop_index mccchannel_13_analyzer_2_array_crystal_array_2_loop_index
#define this_box_volume mccchannel_13_analyzer_2_array_crystal_array_2_this_box_volume
#define global_geometry_element mccchannel_13_analyzer_2_array_crystal_array_2_global_geometry_element
#define this_box_storage mccchannel_13_analyzer_2_array_crystal_array_2_this_box_storage
#define material_string mccchannel_13_analyzer_2_array_crystal_array_2_material_string
#define priority mccchannel_13_analyzer_2_array_crystal_array_2_priority
#define xwidth mccchannel_13_analyzer_2_array_crystal_array_2_xwidth
#define yheight mccchannel_13_analyzer_2_array_crystal_array_2_yheight
#define zdepth mccchannel_13_analyzer_2_array_crystal_array_2_zdepth
#define xwidth2 mccchannel_13_analyzer_2_array_crystal_array_2_xwidth2
#define yheight2 mccchannel_13_analyzer_2_array_crystal_array_2_yheight2
#define visualize mccchannel_13_analyzer_2_array_crystal_array_2_visualize
#define target_index mccchannel_13_analyzer_2_array_crystal_array_2_target_index
#define target_x mccchannel_13_analyzer_2_array_crystal_array_2_target_x
#define target_y mccchannel_13_analyzer_2_array_crystal_array_2_target_y
#define target_z mccchannel_13_analyzer_2_array_crystal_array_2_target_z
#define focus_aw mccchannel_13_analyzer_2_array_crystal_array_2_focus_aw
#define focus_ah mccchannel_13_analyzer_2_array_crystal_array_2_focus_ah
#define focus_xw mccchannel_13_analyzer_2_array_crystal_array_2_focus_xw
#define focus_xh mccchannel_13_analyzer_2_array_crystal_array_2_focus_xh
#define focus_r mccchannel_13_analyzer_2_array_crystal_array_2_focus_r
#define p_interact mccchannel_13_analyzer_2_array_crystal_array_2_p_interact
#define mask_string mccchannel_13_analyzer_2_array_crystal_array_2_mask_string
#define mask_setting mccchannel_13_analyzer_2_array_crystal_array_2_mask_setting
#define number_of_activations mccchannel_13_analyzer_2_array_crystal_array_2_number_of_activations
#line 224 "Union_box.comp"
{
// Initializes the focusing system for this volume including input sanitation.
focus_initialize(&this_box_volume.geometry, POS_A_COMP_INDEX(INDEX_CURRENT_COMP+target_index), POS_A_CURRENT_COMP, ROT_A_CURRENT_COMP, target_index, target_x, target_y, target_z, focus_aw, focus_ah, focus_xw, focus_xh, focus_r, NAME_CURRENT_COMP);

// Input sanitation for this geometry
if (xwidth <= 0) {
  printf("\nERROR in Union_box named %s, the xwidth is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (yheight <= 0) {
  printf("\nERROR in Union_box named %s, yheight is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (zdepth <= 0) {
  printf("\nERROR in Union_box named %s, zdepth is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (xwidth2 <= 0 && xwidth2 != -1) {
  printf("\nERROR in Union_box named %s, the xwidth2 is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (yheight2 <= 0 && yheight2 != -1) {
  printf("\nERROR in Union_box named %s, yheight2 is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}

// Use sanitation
if (global_material_list.num_elements == 0) {
  printf("\nERROR: Need to define a material using Union_make_material before using a Union geometry component. \n");
  printf("       %s was defined before first use of Union_make_material.\n",NAME_CURRENT_COMP);
  exit(1);
}

this_box_volume.geometry.is_masked_volume = 0;
this_box_volume.geometry.is_exit_volume = 0;
this_box_volume.geometry.is_mask_volume = 0;
// check if the volume is a mask, if it is the material string is irelevant.
if (mask_string && strlen(mask_string) && strcmp(mask_string, "NULL") && strcmp(mask_string, "0")) {
    // A mask volume is used to limit the extend of other volumes, called the masked volumes. These are specified in the mask_string.
    // In order for a ray to enter a masked volume, it needs to be both in the region covered by that volume AND the mask volume.
    // When more than
    this_box_volume.geometry.mask_mode = 1; // Default is mask mode is ALL
    if (mask_setting && strlen(mask_setting) && strcmp(mask_setting, "NULL") && strcmp(mask_setting, "0")) {
        if (strcmp(mask_setting,"ALL") == 0 || strcmp(mask_setting,"All") == 0) this_box_volume.geometry.mask_mode = 1;
        else if (strcmp(mask_setting,"ANY") == 0 || strcmp(mask_setting,"Any") == 0) this_box_volume.geometry.mask_mode = 2;
        else {
            printf("The mask_mode of component %s is set to %s, but must be either ALL or ANY.\n",NAME_CURRENT_COMP,mask_setting);
            exit(1);
        }
    }
    
    for (loop_index=0;loop_index<global_geometry_list.num_elements;loop_index++) {
        // Add mask list
        if (1 == manual_linking_function(global_geometry_list.elements[loop_index].name,mask_string)) {
            add_element_to_int_list(&this_box_volume.geometry.mask_list,global_geometry_list.elements[loop_index].component_index);
            add_element_to_int_list(&global_geometry_list.elements[loop_index].Volume->geometry.masked_by_list,INDEX_CURRENT_COMP);
            global_geometry_list.elements[loop_index].Volume->geometry.is_masked_volume = 1;
            if (this_box_volume.geometry.mask_mode == 2)
                global_geometry_list.elements[loop_index].Volume->geometry.mask_mode = 2;
            if (this_box_volume.geometry.mask_mode == 1) {
                if (global_geometry_list.elements[loop_index].Volume->geometry.is_masked_volume == 1 && global_geometry_list.elements[loop_index].Volume->geometry.mask_mode != 2)
                    // If more than one mask is added to one volume, the ANY mode overwrites the (default) ALL mode.
                    global_geometry_list.elements[loop_index].Volume->geometry.mask_mode = 1;
            }
            
            found_geometries = 1;
        }
    }
    if (found_geometries == 0) {
        printf("The mask_string in geometry: %s did not find any of the specified volumes in the mask_string %s \n",NAME_CURRENT_COMP,mask_string);
        exit(1);
    }
    this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
    this_box_volume.p_physics->is_vacuum = 0; // Makes this volume a vacuum
    this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
    this_box_volume.p_physics->my_a = 0; // Should not be used.
    sprintf(this_box_volume.p_physics->name,"Mask");
    this_box_volume.geometry.is_mask_volume = 1;
    
    
// Read the material input, or if it lacks, use automatic linking.
} else if (material_string && strlen(material_string) && strcmp(material_string, "NULL") && strcmp(material_string, "0")) {
    // A geometry string was given, use it to determine which material
    if (0 == strcmp(material_string,"vacuum") || 0 == strcmp(material_string,"Vacuum")) {
        // One could have a global physics struct for vacuum instead of creating one for each
        this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
        this_box_volume.p_physics->is_vacuum = 1; // Makes this volume a vacuum
        this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
        this_box_volume.p_physics->my_a = 0; // Should not be used.
        sprintf(this_box_volume.p_physics->name,"Vacuum");
    } else if (0 == strcmp(material_string,"exit") || 0 == strcmp(material_string,"Exit")) {
        // One could have a global physics struct for vacuum instead of creating one for each
        this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
        this_box_volume.p_physics->is_vacuum = 1; // Makes this volume a vacuum
        this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
        this_box_volume.p_physics->my_a = 0; // Should not be used.
        this_box_volume.geometry.is_exit_volume = 1;
        sprintf(this_box_volume.p_physics->name,"Exit");
    } else {
        #ifndef MATERIAL_DETECTOR
            printf("Need to define a material before refering to it in a geometry %s.\n",NAME_CURRENT_COMP);
            exit(1);
        #endif
        for (loop_index=0;loop_index<global_material_list.num_elements;loop_index++) {
            if (0 == strcmp(material_string,global_material_list.elements[loop_index].name)) {
                this_box_volume.p_physics = global_material_list.elements[loop_index].physics;
                break;
            }
            if (loop_index == global_material_list.num_elements-1) {
            printf("\n");
            printf("ERROR: The material string \"%s\" in Union geometry \"%s\" did not match a specified material. \n",material_string,NAME_CURRENT_COMP);
            printf("       The materials available at this point (need to be defined before the geometry): \n");
            for (loop_index=0;loop_index<global_material_list.num_elements;loop_index++)
              printf("         %s\n",global_material_list.elements[loop_index].name);
            printf("\n");
            printf("       It is also possible to use one of the defualt materials avaiable: \n");
            printf("           Vacuum (for a Volume without scattering or absorption)\n");
            printf("           Exit (for a Volume where the ray exits the component if it enters)\n");
            printf("           Mask (for a Volume that masks existing volumes specified in the mask_string\n");
            exit(1);
          }
        }
    }
} else {
    // Automatic linking, simply using the last defined material.
    #ifndef MATERIAL_DETECTOR
        printf("Need to define a material before the geometry to use automatic linking %s.\n",NAME_CURRENT_COMP);
        exit(1);
    #endif
    this_box_volume.p_physics = global_material_list.elements[global_material_list.num_elements-1].physics;
}

sprintf(this_box_volume.name,NAME_CURRENT_COMP);
sprintf(this_box_volume.geometry.shape,"box");
this_box_volume.geometry.priority_value = priority;
this_box_volume.geometry.geometry_p_interact = p_interact;
// Currently the coordinates will be in absolute space.
this_box_volume.geometry.center = POS_A_CURRENT_COMP;

this_box_storage.z_depth = zdepth;
this_box_storage.x_width1 = xwidth;
this_box_storage.y_height1 = yheight;

this_box_storage.is_rectangle = 0;
if (xwidth2 < 0 && yheight2 < 0) this_box_storage.is_rectangle = 1;
if (xwidth == xwidth2 && yheight == yheight2) this_box_storage.is_rectangle = 1;

if (xwidth2 < 0) {
    this_box_storage.x_width2 = xwidth;
    xwidth2 = xwidth;
} else this_box_storage.x_width2 = xwidth2;

if (yheight2 < 0) {
    this_box_storage.y_height2 = yheight;
    yheight2 = yheight;
} else this_box_storage.y_height2 = yheight2;


this_box_storage.normal_vectors[0] = coords_set(0,0,1);
this_box_storage.normal_vectors[1] = coords_set(0,0,1);

// for sides with y component = 0
x_component = 2*zdepth/sqrt((xwidth-xwidth2)*(xwidth-xwidth2)+4*zdepth*zdepth);
z_component = (xwidth-xwidth2)/sqrt(4*zdepth*zdepth+(xwidth-xwidth2)*(xwidth-xwidth2));

this_box_storage.normal_vectors[2] = coords_set(x_component,0,z_component);
this_box_storage.normal_vectors[3] = coords_set(-x_component,0,z_component);

// for sides with x component = 0
y_component = 2*zdepth/sqrt((yheight-yheight2)*(yheight-yheight2)+4*zdepth*zdepth);
z_component = (yheight-yheight2)/sqrt(4*zdepth*zdepth+(yheight-yheight2)*(yheight-yheight2));

this_box_storage.normal_vectors[4] = coords_set(0,y_component,z_component);
this_box_storage.normal_vectors[5] = coords_set(0,-y_component,z_component);

this_box_volume.geometry.visualization_on = visualize;

this_box_volume.geometry.geometry_parameters.p_box_storage = &this_box_storage;

// Assign pointers to functions for intersection with the shape, checking if a point is inside the shape
if (this_box_storage.is_rectangle == 1) {
this_box_volume.geometry.intersect_function = &sample_box_intersect_simple;
this_box_volume.geometry.within_function = &r_within_box_simple;
}
else {
this_box_volume.geometry.intersect_function = &sample_box_intersect_advanced;
this_box_volume.geometry.within_function = &r_within_box_advanced;
}

this_box_volume.geometry.shell_points = &box_shell_points;
this_box_volume.geometry.mcdisplay_function = &mcdisplay_box_function;
this_box_volume.geometry.initialize_from_main_function = &initialize_box_geometry_from_main_component;
this_box_volume.geometry.process_rot_allocated = 0;

this_box_volume.geometry.copy_geometry_parameters = &allocate_box_storage_copy;

rot_copy(this_box_volume.geometry.rotation_matrix,ROT_A_CURRENT_COMP); //check how ROT_R_CURRENT_COMP would work
rot_transpose(ROT_A_CURRENT_COMP,this_box_volume.geometry.transpose_rotation_matrix);

// Initialize loggers
this_box_volume.loggers.num_elements = 0;

// packing the information into the global_geometry_element, which is then included in the global_geometry_list.
sprintf(global_geometry_element.name,NAME_CURRENT_COMP);
global_geometry_element.activation_counter = number_of_activations;
global_geometry_element.component_index = INDEX_CURRENT_COMP;
global_geometry_element.Volume = &this_box_volume; // Would be nicer if this m was a pointer, now we have the (small) data two places
add_element_to_geometry_list(&global_geometry_list,global_geometry_element);
}
#line 283292 "MACS_sample_kidney_box.c"
#undef number_of_activations
#undef mask_setting
#undef mask_string
#undef p_interact
#undef focus_r
#undef focus_xh
#undef focus_xw
#undef focus_ah
#undef focus_aw
#undef target_z
#undef target_y
#undef target_x
#undef target_index
#undef visualize
#undef yheight2
#undef xwidth2
#undef zdepth
#undef yheight
#undef xwidth
#undef priority
#undef material_string
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

  /* Initializations for component channel_13_analyzer_2_array_crystal_array_3. */
  SIG_MESSAGE("channel_13_analyzer_2_array_crystal_array_3 (Init)");
#define mccompcurname  channel_13_analyzer_2_array_crystal_array_3
#define mccompcurtype  Union_box
#define mccompcurindex 638
#define loop_index mccchannel_13_analyzer_2_array_crystal_array_3_loop_index
#define this_box_volume mccchannel_13_analyzer_2_array_crystal_array_3_this_box_volume
#define global_geometry_element mccchannel_13_analyzer_2_array_crystal_array_3_global_geometry_element
#define this_box_storage mccchannel_13_analyzer_2_array_crystal_array_3_this_box_storage
#define material_string mccchannel_13_analyzer_2_array_crystal_array_3_material_string
#define priority mccchannel_13_analyzer_2_array_crystal_array_3_priority
#define xwidth mccchannel_13_analyzer_2_array_crystal_array_3_xwidth
#define yheight mccchannel_13_analyzer_2_array_crystal_array_3_yheight
#define zdepth mccchannel_13_analyzer_2_array_crystal_array_3_zdepth
#define xwidth2 mccchannel_13_analyzer_2_array_crystal_array_3_xwidth2
#define yheight2 mccchannel_13_analyzer_2_array_crystal_array_3_yheight2
#define visualize mccchannel_13_analyzer_2_array_crystal_array_3_visualize
#define target_index mccchannel_13_analyzer_2_array_crystal_array_3_target_index
#define target_x mccchannel_13_analyzer_2_array_crystal_array_3_target_x
#define target_y mccchannel_13_analyzer_2_array_crystal_array_3_target_y
#define target_z mccchannel_13_analyzer_2_array_crystal_array_3_target_z
#define focus_aw mccchannel_13_analyzer_2_array_crystal_array_3_focus_aw
#define focus_ah mccchannel_13_analyzer_2_array_crystal_array_3_focus_ah
#define focus_xw mccchannel_13_analyzer_2_array_crystal_array_3_focus_xw
#define focus_xh mccchannel_13_analyzer_2_array_crystal_array_3_focus_xh
#define focus_r mccchannel_13_analyzer_2_array_crystal_array_3_focus_r
#define p_interact mccchannel_13_analyzer_2_array_crystal_array_3_p_interact
#define mask_string mccchannel_13_analyzer_2_array_crystal_array_3_mask_string
#define mask_setting mccchannel_13_analyzer_2_array_crystal_array_3_mask_setting
#define number_of_activations mccchannel_13_analyzer_2_array_crystal_array_3_number_of_activations
#line 224 "Union_box.comp"
{
// Initializes the focusing system for this volume including input sanitation.
focus_initialize(&this_box_volume.geometry, POS_A_COMP_INDEX(INDEX_CURRENT_COMP+target_index), POS_A_CURRENT_COMP, ROT_A_CURRENT_COMP, target_index, target_x, target_y, target_z, focus_aw, focus_ah, focus_xw, focus_xh, focus_r, NAME_CURRENT_COMP);

// Input sanitation for this geometry
if (xwidth <= 0) {
  printf("\nERROR in Union_box named %s, the xwidth is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (yheight <= 0) {
  printf("\nERROR in Union_box named %s, yheight is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (zdepth <= 0) {
  printf("\nERROR in Union_box named %s, zdepth is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (xwidth2 <= 0 && xwidth2 != -1) {
  printf("\nERROR in Union_box named %s, the xwidth2 is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (yheight2 <= 0 && yheight2 != -1) {
  printf("\nERROR in Union_box named %s, yheight2 is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}

// Use sanitation
if (global_material_list.num_elements == 0) {
  printf("\nERROR: Need to define a material using Union_make_material before using a Union geometry component. \n");
  printf("       %s was defined before first use of Union_make_material.\n",NAME_CURRENT_COMP);
  exit(1);
}

this_box_volume.geometry.is_masked_volume = 0;
this_box_volume.geometry.is_exit_volume = 0;
this_box_volume.geometry.is_mask_volume = 0;
// check if the volume is a mask, if it is the material string is irelevant.
if (mask_string && strlen(mask_string) && strcmp(mask_string, "NULL") && strcmp(mask_string, "0")) {
    // A mask volume is used to limit the extend of other volumes, called the masked volumes. These are specified in the mask_string.
    // In order for a ray to enter a masked volume, it needs to be both in the region covered by that volume AND the mask volume.
    // When more than
    this_box_volume.geometry.mask_mode = 1; // Default is mask mode is ALL
    if (mask_setting && strlen(mask_setting) && strcmp(mask_setting, "NULL") && strcmp(mask_setting, "0")) {
        if (strcmp(mask_setting,"ALL") == 0 || strcmp(mask_setting,"All") == 0) this_box_volume.geometry.mask_mode = 1;
        else if (strcmp(mask_setting,"ANY") == 0 || strcmp(mask_setting,"Any") == 0) this_box_volume.geometry.mask_mode = 2;
        else {
            printf("The mask_mode of component %s is set to %s, but must be either ALL or ANY.\n",NAME_CURRENT_COMP,mask_setting);
            exit(1);
        }
    }
    
    for (loop_index=0;loop_index<global_geometry_list.num_elements;loop_index++) {
        // Add mask list
        if (1 == manual_linking_function(global_geometry_list.elements[loop_index].name,mask_string)) {
            add_element_to_int_list(&this_box_volume.geometry.mask_list,global_geometry_list.elements[loop_index].component_index);
            add_element_to_int_list(&global_geometry_list.elements[loop_index].Volume->geometry.masked_by_list,INDEX_CURRENT_COMP);
            global_geometry_list.elements[loop_index].Volume->geometry.is_masked_volume = 1;
            if (this_box_volume.geometry.mask_mode == 2)
                global_geometry_list.elements[loop_index].Volume->geometry.mask_mode = 2;
            if (this_box_volume.geometry.mask_mode == 1) {
                if (global_geometry_list.elements[loop_index].Volume->geometry.is_masked_volume == 1 && global_geometry_list.elements[loop_index].Volume->geometry.mask_mode != 2)
                    // If more than one mask is added to one volume, the ANY mode overwrites the (default) ALL mode.
                    global_geometry_list.elements[loop_index].Volume->geometry.mask_mode = 1;
            }
            
            found_geometries = 1;
        }
    }
    if (found_geometries == 0) {
        printf("The mask_string in geometry: %s did not find any of the specified volumes in the mask_string %s \n",NAME_CURRENT_COMP,mask_string);
        exit(1);
    }
    this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
    this_box_volume.p_physics->is_vacuum = 0; // Makes this volume a vacuum
    this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
    this_box_volume.p_physics->my_a = 0; // Should not be used.
    sprintf(this_box_volume.p_physics->name,"Mask");
    this_box_volume.geometry.is_mask_volume = 1;
    
    
// Read the material input, or if it lacks, use automatic linking.
} else if (material_string && strlen(material_string) && strcmp(material_string, "NULL") && strcmp(material_string, "0")) {
    // A geometry string was given, use it to determine which material
    if (0 == strcmp(material_string,"vacuum") || 0 == strcmp(material_string,"Vacuum")) {
        // One could have a global physics struct for vacuum instead of creating one for each
        this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
        this_box_volume.p_physics->is_vacuum = 1; // Makes this volume a vacuum
        this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
        this_box_volume.p_physics->my_a = 0; // Should not be used.
        sprintf(this_box_volume.p_physics->name,"Vacuum");
    } else if (0 == strcmp(material_string,"exit") || 0 == strcmp(material_string,"Exit")) {
        // One could have a global physics struct for vacuum instead of creating one for each
        this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
        this_box_volume.p_physics->is_vacuum = 1; // Makes this volume a vacuum
        this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
        this_box_volume.p_physics->my_a = 0; // Should not be used.
        this_box_volume.geometry.is_exit_volume = 1;
        sprintf(this_box_volume.p_physics->name,"Exit");
    } else {
        #ifndef MATERIAL_DETECTOR
            printf("Need to define a material before refering to it in a geometry %s.\n",NAME_CURRENT_COMP);
            exit(1);
        #endif
        for (loop_index=0;loop_index<global_material_list.num_elements;loop_index++) {
            if (0 == strcmp(material_string,global_material_list.elements[loop_index].name)) {
                this_box_volume.p_physics = global_material_list.elements[loop_index].physics;
                break;
            }
            if (loop_index == global_material_list.num_elements-1) {
            printf("\n");
            printf("ERROR: The material string \"%s\" in Union geometry \"%s\" did not match a specified material. \n",material_string,NAME_CURRENT_COMP);
            printf("       The materials available at this point (need to be defined before the geometry): \n");
            for (loop_index=0;loop_index<global_material_list.num_elements;loop_index++)
              printf("         %s\n",global_material_list.elements[loop_index].name);
            printf("\n");
            printf("       It is also possible to use one of the defualt materials avaiable: \n");
            printf("           Vacuum (for a Volume without scattering or absorption)\n");
            printf("           Exit (for a Volume where the ray exits the component if it enters)\n");
            printf("           Mask (for a Volume that masks existing volumes specified in the mask_string\n");
            exit(1);
          }
        }
    }
} else {
    // Automatic linking, simply using the last defined material.
    #ifndef MATERIAL_DETECTOR
        printf("Need to define a material before the geometry to use automatic linking %s.\n",NAME_CURRENT_COMP);
        exit(1);
    #endif
    this_box_volume.p_physics = global_material_list.elements[global_material_list.num_elements-1].physics;
}

sprintf(this_box_volume.name,NAME_CURRENT_COMP);
sprintf(this_box_volume.geometry.shape,"box");
this_box_volume.geometry.priority_value = priority;
this_box_volume.geometry.geometry_p_interact = p_interact;
// Currently the coordinates will be in absolute space.
this_box_volume.geometry.center = POS_A_CURRENT_COMP;

this_box_storage.z_depth = zdepth;
this_box_storage.x_width1 = xwidth;
this_box_storage.y_height1 = yheight;

this_box_storage.is_rectangle = 0;
if (xwidth2 < 0 && yheight2 < 0) this_box_storage.is_rectangle = 1;
if (xwidth == xwidth2 && yheight == yheight2) this_box_storage.is_rectangle = 1;

if (xwidth2 < 0) {
    this_box_storage.x_width2 = xwidth;
    xwidth2 = xwidth;
} else this_box_storage.x_width2 = xwidth2;

if (yheight2 < 0) {
    this_box_storage.y_height2 = yheight;
    yheight2 = yheight;
} else this_box_storage.y_height2 = yheight2;


this_box_storage.normal_vectors[0] = coords_set(0,0,1);
this_box_storage.normal_vectors[1] = coords_set(0,0,1);

// for sides with y component = 0
x_component = 2*zdepth/sqrt((xwidth-xwidth2)*(xwidth-xwidth2)+4*zdepth*zdepth);
z_component = (xwidth-xwidth2)/sqrt(4*zdepth*zdepth+(xwidth-xwidth2)*(xwidth-xwidth2));

this_box_storage.normal_vectors[2] = coords_set(x_component,0,z_component);
this_box_storage.normal_vectors[3] = coords_set(-x_component,0,z_component);

// for sides with x component = 0
y_component = 2*zdepth/sqrt((yheight-yheight2)*(yheight-yheight2)+4*zdepth*zdepth);
z_component = (yheight-yheight2)/sqrt(4*zdepth*zdepth+(yheight-yheight2)*(yheight-yheight2));

this_box_storage.normal_vectors[4] = coords_set(0,y_component,z_component);
this_box_storage.normal_vectors[5] = coords_set(0,-y_component,z_component);

this_box_volume.geometry.visualization_on = visualize;

this_box_volume.geometry.geometry_parameters.p_box_storage = &this_box_storage;

// Assign pointers to functions for intersection with the shape, checking if a point is inside the shape
if (this_box_storage.is_rectangle == 1) {
this_box_volume.geometry.intersect_function = &sample_box_intersect_simple;
this_box_volume.geometry.within_function = &r_within_box_simple;
}
else {
this_box_volume.geometry.intersect_function = &sample_box_intersect_advanced;
this_box_volume.geometry.within_function = &r_within_box_advanced;
}

this_box_volume.geometry.shell_points = &box_shell_points;
this_box_volume.geometry.mcdisplay_function = &mcdisplay_box_function;
this_box_volume.geometry.initialize_from_main_function = &initialize_box_geometry_from_main_component;
this_box_volume.geometry.process_rot_allocated = 0;

this_box_volume.geometry.copy_geometry_parameters = &allocate_box_storage_copy;

rot_copy(this_box_volume.geometry.rotation_matrix,ROT_A_CURRENT_COMP); //check how ROT_R_CURRENT_COMP would work
rot_transpose(ROT_A_CURRENT_COMP,this_box_volume.geometry.transpose_rotation_matrix);

// Initialize loggers
this_box_volume.loggers.num_elements = 0;

// packing the information into the global_geometry_element, which is then included in the global_geometry_list.
sprintf(global_geometry_element.name,NAME_CURRENT_COMP);
global_geometry_element.activation_counter = number_of_activations;
global_geometry_element.component_index = INDEX_CURRENT_COMP;
global_geometry_element.Volume = &this_box_volume; // Would be nicer if this m was a pointer, now we have the (small) data two places
add_element_to_geometry_list(&global_geometry_list,global_geometry_element);
}
#line 283562 "MACS_sample_kidney_box.c"
#undef number_of_activations
#undef mask_setting
#undef mask_string
#undef p_interact
#undef focus_r
#undef focus_xh
#undef focus_xw
#undef focus_ah
#undef focus_aw
#undef target_z
#undef target_y
#undef target_x
#undef target_index
#undef visualize
#undef yheight2
#undef xwidth2
#undef zdepth
#undef yheight
#undef xwidth
#undef priority
#undef material_string
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

  /* Initializations for component channel_13_analyzer_2_array_crystal_array_4. */
  SIG_MESSAGE("channel_13_analyzer_2_array_crystal_array_4 (Init)");
#define mccompcurname  channel_13_analyzer_2_array_crystal_array_4
#define mccompcurtype  Union_box
#define mccompcurindex 639
#define loop_index mccchannel_13_analyzer_2_array_crystal_array_4_loop_index
#define this_box_volume mccchannel_13_analyzer_2_array_crystal_array_4_this_box_volume
#define global_geometry_element mccchannel_13_analyzer_2_array_crystal_array_4_global_geometry_element
#define this_box_storage mccchannel_13_analyzer_2_array_crystal_array_4_this_box_storage
#define material_string mccchannel_13_analyzer_2_array_crystal_array_4_material_string
#define priority mccchannel_13_analyzer_2_array_crystal_array_4_priority
#define xwidth mccchannel_13_analyzer_2_array_crystal_array_4_xwidth
#define yheight mccchannel_13_analyzer_2_array_crystal_array_4_yheight
#define zdepth mccchannel_13_analyzer_2_array_crystal_array_4_zdepth
#define xwidth2 mccchannel_13_analyzer_2_array_crystal_array_4_xwidth2
#define yheight2 mccchannel_13_analyzer_2_array_crystal_array_4_yheight2
#define visualize mccchannel_13_analyzer_2_array_crystal_array_4_visualize
#define target_index mccchannel_13_analyzer_2_array_crystal_array_4_target_index
#define target_x mccchannel_13_analyzer_2_array_crystal_array_4_target_x
#define target_y mccchannel_13_analyzer_2_array_crystal_array_4_target_y
#define target_z mccchannel_13_analyzer_2_array_crystal_array_4_target_z
#define focus_aw mccchannel_13_analyzer_2_array_crystal_array_4_focus_aw
#define focus_ah mccchannel_13_analyzer_2_array_crystal_array_4_focus_ah
#define focus_xw mccchannel_13_analyzer_2_array_crystal_array_4_focus_xw
#define focus_xh mccchannel_13_analyzer_2_array_crystal_array_4_focus_xh
#define focus_r mccchannel_13_analyzer_2_array_crystal_array_4_focus_r
#define p_interact mccchannel_13_analyzer_2_array_crystal_array_4_p_interact
#define mask_string mccchannel_13_analyzer_2_array_crystal_array_4_mask_string
#define mask_setting mccchannel_13_analyzer_2_array_crystal_array_4_mask_setting
#define number_of_activations mccchannel_13_analyzer_2_array_crystal_array_4_number_of_activations
#line 224 "Union_box.comp"
{
// Initializes the focusing system for this volume including input sanitation.
focus_initialize(&this_box_volume.geometry, POS_A_COMP_INDEX(INDEX_CURRENT_COMP+target_index), POS_A_CURRENT_COMP, ROT_A_CURRENT_COMP, target_index, target_x, target_y, target_z, focus_aw, focus_ah, focus_xw, focus_xh, focus_r, NAME_CURRENT_COMP);

// Input sanitation for this geometry
if (xwidth <= 0) {
  printf("\nERROR in Union_box named %s, the xwidth is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (yheight <= 0) {
  printf("\nERROR in Union_box named %s, yheight is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (zdepth <= 0) {
  printf("\nERROR in Union_box named %s, zdepth is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (xwidth2 <= 0 && xwidth2 != -1) {
  printf("\nERROR in Union_box named %s, the xwidth2 is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (yheight2 <= 0 && yheight2 != -1) {
  printf("\nERROR in Union_box named %s, yheight2 is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}

// Use sanitation
if (global_material_list.num_elements == 0) {
  printf("\nERROR: Need to define a material using Union_make_material before using a Union geometry component. \n");
  printf("       %s was defined before first use of Union_make_material.\n",NAME_CURRENT_COMP);
  exit(1);
}

this_box_volume.geometry.is_masked_volume = 0;
this_box_volume.geometry.is_exit_volume = 0;
this_box_volume.geometry.is_mask_volume = 0;
// check if the volume is a mask, if it is the material string is irelevant.
if (mask_string && strlen(mask_string) && strcmp(mask_string, "NULL") && strcmp(mask_string, "0")) {
    // A mask volume is used to limit the extend of other volumes, called the masked volumes. These are specified in the mask_string.
    // In order for a ray to enter a masked volume, it needs to be both in the region covered by that volume AND the mask volume.
    // When more than
    this_box_volume.geometry.mask_mode = 1; // Default is mask mode is ALL
    if (mask_setting && strlen(mask_setting) && strcmp(mask_setting, "NULL") && strcmp(mask_setting, "0")) {
        if (strcmp(mask_setting,"ALL") == 0 || strcmp(mask_setting,"All") == 0) this_box_volume.geometry.mask_mode = 1;
        else if (strcmp(mask_setting,"ANY") == 0 || strcmp(mask_setting,"Any") == 0) this_box_volume.geometry.mask_mode = 2;
        else {
            printf("The mask_mode of component %s is set to %s, but must be either ALL or ANY.\n",NAME_CURRENT_COMP,mask_setting);
            exit(1);
        }
    }
    
    for (loop_index=0;loop_index<global_geometry_list.num_elements;loop_index++) {
        // Add mask list
        if (1 == manual_linking_function(global_geometry_list.elements[loop_index].name,mask_string)) {
            add_element_to_int_list(&this_box_volume.geometry.mask_list,global_geometry_list.elements[loop_index].component_index);
            add_element_to_int_list(&global_geometry_list.elements[loop_index].Volume->geometry.masked_by_list,INDEX_CURRENT_COMP);
            global_geometry_list.elements[loop_index].Volume->geometry.is_masked_volume = 1;
            if (this_box_volume.geometry.mask_mode == 2)
                global_geometry_list.elements[loop_index].Volume->geometry.mask_mode = 2;
            if (this_box_volume.geometry.mask_mode == 1) {
                if (global_geometry_list.elements[loop_index].Volume->geometry.is_masked_volume == 1 && global_geometry_list.elements[loop_index].Volume->geometry.mask_mode != 2)
                    // If more than one mask is added to one volume, the ANY mode overwrites the (default) ALL mode.
                    global_geometry_list.elements[loop_index].Volume->geometry.mask_mode = 1;
            }
            
            found_geometries = 1;
        }
    }
    if (found_geometries == 0) {
        printf("The mask_string in geometry: %s did not find any of the specified volumes in the mask_string %s \n",NAME_CURRENT_COMP,mask_string);
        exit(1);
    }
    this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
    this_box_volume.p_physics->is_vacuum = 0; // Makes this volume a vacuum
    this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
    this_box_volume.p_physics->my_a = 0; // Should not be used.
    sprintf(this_box_volume.p_physics->name,"Mask");
    this_box_volume.geometry.is_mask_volume = 1;
    
    
// Read the material input, or if it lacks, use automatic linking.
} else if (material_string && strlen(material_string) && strcmp(material_string, "NULL") && strcmp(material_string, "0")) {
    // A geometry string was given, use it to determine which material
    if (0 == strcmp(material_string,"vacuum") || 0 == strcmp(material_string,"Vacuum")) {
        // One could have a global physics struct for vacuum instead of creating one for each
        this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
        this_box_volume.p_physics->is_vacuum = 1; // Makes this volume a vacuum
        this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
        this_box_volume.p_physics->my_a = 0; // Should not be used.
        sprintf(this_box_volume.p_physics->name,"Vacuum");
    } else if (0 == strcmp(material_string,"exit") || 0 == strcmp(material_string,"Exit")) {
        // One could have a global physics struct for vacuum instead of creating one for each
        this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
        this_box_volume.p_physics->is_vacuum = 1; // Makes this volume a vacuum
        this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
        this_box_volume.p_physics->my_a = 0; // Should not be used.
        this_box_volume.geometry.is_exit_volume = 1;
        sprintf(this_box_volume.p_physics->name,"Exit");
    } else {
        #ifndef MATERIAL_DETECTOR
            printf("Need to define a material before refering to it in a geometry %s.\n",NAME_CURRENT_COMP);
            exit(1);
        #endif
        for (loop_index=0;loop_index<global_material_list.num_elements;loop_index++) {
            if (0 == strcmp(material_string,global_material_list.elements[loop_index].name)) {
                this_box_volume.p_physics = global_material_list.elements[loop_index].physics;
                break;
            }
            if (loop_index == global_material_list.num_elements-1) {
            printf("\n");
            printf("ERROR: The material string \"%s\" in Union geometry \"%s\" did not match a specified material. \n",material_string,NAME_CURRENT_COMP);
            printf("       The materials available at this point (need to be defined before the geometry): \n");
            for (loop_index=0;loop_index<global_material_list.num_elements;loop_index++)
              printf("         %s\n",global_material_list.elements[loop_index].name);
            printf("\n");
            printf("       It is also possible to use one of the defualt materials avaiable: \n");
            printf("           Vacuum (for a Volume without scattering or absorption)\n");
            printf("           Exit (for a Volume where the ray exits the component if it enters)\n");
            printf("           Mask (for a Volume that masks existing volumes specified in the mask_string\n");
            exit(1);
          }
        }
    }
} else {
    // Automatic linking, simply using the last defined material.
    #ifndef MATERIAL_DETECTOR
        printf("Need to define a material before the geometry to use automatic linking %s.\n",NAME_CURRENT_COMP);
        exit(1);
    #endif
    this_box_volume.p_physics = global_material_list.elements[global_material_list.num_elements-1].physics;
}

sprintf(this_box_volume.name,NAME_CURRENT_COMP);
sprintf(this_box_volume.geometry.shape,"box");
this_box_volume.geometry.priority_value = priority;
this_box_volume.geometry.geometry_p_interact = p_interact;
// Currently the coordinates will be in absolute space.
this_box_volume.geometry.center = POS_A_CURRENT_COMP;

this_box_storage.z_depth = zdepth;
this_box_storage.x_width1 = xwidth;
this_box_storage.y_height1 = yheight;

this_box_storage.is_rectangle = 0;
if (xwidth2 < 0 && yheight2 < 0) this_box_storage.is_rectangle = 1;
if (xwidth == xwidth2 && yheight == yheight2) this_box_storage.is_rectangle = 1;

if (xwidth2 < 0) {
    this_box_storage.x_width2 = xwidth;
    xwidth2 = xwidth;
} else this_box_storage.x_width2 = xwidth2;

if (yheight2 < 0) {
    this_box_storage.y_height2 = yheight;
    yheight2 = yheight;
} else this_box_storage.y_height2 = yheight2;


this_box_storage.normal_vectors[0] = coords_set(0,0,1);
this_box_storage.normal_vectors[1] = coords_set(0,0,1);

// for sides with y component = 0
x_component = 2*zdepth/sqrt((xwidth-xwidth2)*(xwidth-xwidth2)+4*zdepth*zdepth);
z_component = (xwidth-xwidth2)/sqrt(4*zdepth*zdepth+(xwidth-xwidth2)*(xwidth-xwidth2));

this_box_storage.normal_vectors[2] = coords_set(x_component,0,z_component);
this_box_storage.normal_vectors[3] = coords_set(-x_component,0,z_component);

// for sides with x component = 0
y_component = 2*zdepth/sqrt((yheight-yheight2)*(yheight-yheight2)+4*zdepth*zdepth);
z_component = (yheight-yheight2)/sqrt(4*zdepth*zdepth+(yheight-yheight2)*(yheight-yheight2));

this_box_storage.normal_vectors[4] = coords_set(0,y_component,z_component);
this_box_storage.normal_vectors[5] = coords_set(0,-y_component,z_component);

this_box_volume.geometry.visualization_on = visualize;

this_box_volume.geometry.geometry_parameters.p_box_storage = &this_box_storage;

// Assign pointers to functions for intersection with the shape, checking if a point is inside the shape
if (this_box_storage.is_rectangle == 1) {
this_box_volume.geometry.intersect_function = &sample_box_intersect_simple;
this_box_volume.geometry.within_function = &r_within_box_simple;
}
else {
this_box_volume.geometry.intersect_function = &sample_box_intersect_advanced;
this_box_volume.geometry.within_function = &r_within_box_advanced;
}

this_box_volume.geometry.shell_points = &box_shell_points;
this_box_volume.geometry.mcdisplay_function = &mcdisplay_box_function;
this_box_volume.geometry.initialize_from_main_function = &initialize_box_geometry_from_main_component;
this_box_volume.geometry.process_rot_allocated = 0;

this_box_volume.geometry.copy_geometry_parameters = &allocate_box_storage_copy;

rot_copy(this_box_volume.geometry.rotation_matrix,ROT_A_CURRENT_COMP); //check how ROT_R_CURRENT_COMP would work
rot_transpose(ROT_A_CURRENT_COMP,this_box_volume.geometry.transpose_rotation_matrix);

// Initialize loggers
this_box_volume.loggers.num_elements = 0;

// packing the information into the global_geometry_element, which is then included in the global_geometry_list.
sprintf(global_geometry_element.name,NAME_CURRENT_COMP);
global_geometry_element.activation_counter = number_of_activations;
global_geometry_element.component_index = INDEX_CURRENT_COMP;
global_geometry_element.Volume = &this_box_volume; // Would be nicer if this m was a pointer, now we have the (small) data two places
add_element_to_geometry_list(&global_geometry_list,global_geometry_element);
}
#line 283832 "MACS_sample_kidney_box.c"
#undef number_of_activations
#undef mask_setting
#undef mask_string
#undef p_interact
#undef focus_r
#undef focus_xh
#undef focus_xw
#undef focus_ah
#undef focus_aw
#undef target_z
#undef target_y
#undef target_x
#undef target_index
#undef visualize
#undef yheight2
#undef xwidth2
#undef zdepth
#undef yheight
#undef xwidth
#undef priority
#undef material_string
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

  /* Initializations for component channel_13_analyzer_2_array_crystal_array_5. */
  SIG_MESSAGE("channel_13_analyzer_2_array_crystal_array_5 (Init)");
#define mccompcurname  channel_13_analyzer_2_array_crystal_array_5
#define mccompcurtype  Union_box
#define mccompcurindex 640
#define loop_index mccchannel_13_analyzer_2_array_crystal_array_5_loop_index
#define this_box_volume mccchannel_13_analyzer_2_array_crystal_array_5_this_box_volume
#define global_geometry_element mccchannel_13_analyzer_2_array_crystal_array_5_global_geometry_element
#define this_box_storage mccchannel_13_analyzer_2_array_crystal_array_5_this_box_storage
#define material_string mccchannel_13_analyzer_2_array_crystal_array_5_material_string
#define priority mccchannel_13_analyzer_2_array_crystal_array_5_priority
#define xwidth mccchannel_13_analyzer_2_array_crystal_array_5_xwidth
#define yheight mccchannel_13_analyzer_2_array_crystal_array_5_yheight
#define zdepth mccchannel_13_analyzer_2_array_crystal_array_5_zdepth
#define xwidth2 mccchannel_13_analyzer_2_array_crystal_array_5_xwidth2
#define yheight2 mccchannel_13_analyzer_2_array_crystal_array_5_yheight2
#define visualize mccchannel_13_analyzer_2_array_crystal_array_5_visualize
#define target_index mccchannel_13_analyzer_2_array_crystal_array_5_target_index
#define target_x mccchannel_13_analyzer_2_array_crystal_array_5_target_x
#define target_y mccchannel_13_analyzer_2_array_crystal_array_5_target_y
#define target_z mccchannel_13_analyzer_2_array_crystal_array_5_target_z
#define focus_aw mccchannel_13_analyzer_2_array_crystal_array_5_focus_aw
#define focus_ah mccchannel_13_analyzer_2_array_crystal_array_5_focus_ah
#define focus_xw mccchannel_13_analyzer_2_array_crystal_array_5_focus_xw
#define focus_xh mccchannel_13_analyzer_2_array_crystal_array_5_focus_xh
#define focus_r mccchannel_13_analyzer_2_array_crystal_array_5_focus_r
#define p_interact mccchannel_13_analyzer_2_array_crystal_array_5_p_interact
#define mask_string mccchannel_13_analyzer_2_array_crystal_array_5_mask_string
#define mask_setting mccchannel_13_analyzer_2_array_crystal_array_5_mask_setting
#define number_of_activations mccchannel_13_analyzer_2_array_crystal_array_5_number_of_activations
#line 224 "Union_box.comp"
{
// Initializes the focusing system for this volume including input sanitation.
focus_initialize(&this_box_volume.geometry, POS_A_COMP_INDEX(INDEX_CURRENT_COMP+target_index), POS_A_CURRENT_COMP, ROT_A_CURRENT_COMP, target_index, target_x, target_y, target_z, focus_aw, focus_ah, focus_xw, focus_xh, focus_r, NAME_CURRENT_COMP);

// Input sanitation for this geometry
if (xwidth <= 0) {
  printf("\nERROR in Union_box named %s, the xwidth is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (yheight <= 0) {
  printf("\nERROR in Union_box named %s, yheight is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (zdepth <= 0) {
  printf("\nERROR in Union_box named %s, zdepth is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (xwidth2 <= 0 && xwidth2 != -1) {
  printf("\nERROR in Union_box named %s, the xwidth2 is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (yheight2 <= 0 && yheight2 != -1) {
  printf("\nERROR in Union_box named %s, yheight2 is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}

// Use sanitation
if (global_material_list.num_elements == 0) {
  printf("\nERROR: Need to define a material using Union_make_material before using a Union geometry component. \n");
  printf("       %s was defined before first use of Union_make_material.\n",NAME_CURRENT_COMP);
  exit(1);
}

this_box_volume.geometry.is_masked_volume = 0;
this_box_volume.geometry.is_exit_volume = 0;
this_box_volume.geometry.is_mask_volume = 0;
// check if the volume is a mask, if it is the material string is irelevant.
if (mask_string && strlen(mask_string) && strcmp(mask_string, "NULL") && strcmp(mask_string, "0")) {
    // A mask volume is used to limit the extend of other volumes, called the masked volumes. These are specified in the mask_string.
    // In order for a ray to enter a masked volume, it needs to be both in the region covered by that volume AND the mask volume.
    // When more than
    this_box_volume.geometry.mask_mode = 1; // Default is mask mode is ALL
    if (mask_setting && strlen(mask_setting) && strcmp(mask_setting, "NULL") && strcmp(mask_setting, "0")) {
        if (strcmp(mask_setting,"ALL") == 0 || strcmp(mask_setting,"All") == 0) this_box_volume.geometry.mask_mode = 1;
        else if (strcmp(mask_setting,"ANY") == 0 || strcmp(mask_setting,"Any") == 0) this_box_volume.geometry.mask_mode = 2;
        else {
            printf("The mask_mode of component %s is set to %s, but must be either ALL or ANY.\n",NAME_CURRENT_COMP,mask_setting);
            exit(1);
        }
    }
    
    for (loop_index=0;loop_index<global_geometry_list.num_elements;loop_index++) {
        // Add mask list
        if (1 == manual_linking_function(global_geometry_list.elements[loop_index].name,mask_string)) {
            add_element_to_int_list(&this_box_volume.geometry.mask_list,global_geometry_list.elements[loop_index].component_index);
            add_element_to_int_list(&global_geometry_list.elements[loop_index].Volume->geometry.masked_by_list,INDEX_CURRENT_COMP);
            global_geometry_list.elements[loop_index].Volume->geometry.is_masked_volume = 1;
            if (this_box_volume.geometry.mask_mode == 2)
                global_geometry_list.elements[loop_index].Volume->geometry.mask_mode = 2;
            if (this_box_volume.geometry.mask_mode == 1) {
                if (global_geometry_list.elements[loop_index].Volume->geometry.is_masked_volume == 1 && global_geometry_list.elements[loop_index].Volume->geometry.mask_mode != 2)
                    // If more than one mask is added to one volume, the ANY mode overwrites the (default) ALL mode.
                    global_geometry_list.elements[loop_index].Volume->geometry.mask_mode = 1;
            }
            
            found_geometries = 1;
        }
    }
    if (found_geometries == 0) {
        printf("The mask_string in geometry: %s did not find any of the specified volumes in the mask_string %s \n",NAME_CURRENT_COMP,mask_string);
        exit(1);
    }
    this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
    this_box_volume.p_physics->is_vacuum = 0; // Makes this volume a vacuum
    this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
    this_box_volume.p_physics->my_a = 0; // Should not be used.
    sprintf(this_box_volume.p_physics->name,"Mask");
    this_box_volume.geometry.is_mask_volume = 1;
    
    
// Read the material input, or if it lacks, use automatic linking.
} else if (material_string && strlen(material_string) && strcmp(material_string, "NULL") && strcmp(material_string, "0")) {
    // A geometry string was given, use it to determine which material
    if (0 == strcmp(material_string,"vacuum") || 0 == strcmp(material_string,"Vacuum")) {
        // One could have a global physics struct for vacuum instead of creating one for each
        this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
        this_box_volume.p_physics->is_vacuum = 1; // Makes this volume a vacuum
        this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
        this_box_volume.p_physics->my_a = 0; // Should not be used.
        sprintf(this_box_volume.p_physics->name,"Vacuum");
    } else if (0 == strcmp(material_string,"exit") || 0 == strcmp(material_string,"Exit")) {
        // One could have a global physics struct for vacuum instead of creating one for each
        this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
        this_box_volume.p_physics->is_vacuum = 1; // Makes this volume a vacuum
        this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
        this_box_volume.p_physics->my_a = 0; // Should not be used.
        this_box_volume.geometry.is_exit_volume = 1;
        sprintf(this_box_volume.p_physics->name,"Exit");
    } else {
        #ifndef MATERIAL_DETECTOR
            printf("Need to define a material before refering to it in a geometry %s.\n",NAME_CURRENT_COMP);
            exit(1);
        #endif
        for (loop_index=0;loop_index<global_material_list.num_elements;loop_index++) {
            if (0 == strcmp(material_string,global_material_list.elements[loop_index].name)) {
                this_box_volume.p_physics = global_material_list.elements[loop_index].physics;
                break;
            }
            if (loop_index == global_material_list.num_elements-1) {
            printf("\n");
            printf("ERROR: The material string \"%s\" in Union geometry \"%s\" did not match a specified material. \n",material_string,NAME_CURRENT_COMP);
            printf("       The materials available at this point (need to be defined before the geometry): \n");
            for (loop_index=0;loop_index<global_material_list.num_elements;loop_index++)
              printf("         %s\n",global_material_list.elements[loop_index].name);
            printf("\n");
            printf("       It is also possible to use one of the defualt materials avaiable: \n");
            printf("           Vacuum (for a Volume without scattering or absorption)\n");
            printf("           Exit (for a Volume where the ray exits the component if it enters)\n");
            printf("           Mask (for a Volume that masks existing volumes specified in the mask_string\n");
            exit(1);
          }
        }
    }
} else {
    // Automatic linking, simply using the last defined material.
    #ifndef MATERIAL_DETECTOR
        printf("Need to define a material before the geometry to use automatic linking %s.\n",NAME_CURRENT_COMP);
        exit(1);
    #endif
    this_box_volume.p_physics = global_material_list.elements[global_material_list.num_elements-1].physics;
}

sprintf(this_box_volume.name,NAME_CURRENT_COMP);
sprintf(this_box_volume.geometry.shape,"box");
this_box_volume.geometry.priority_value = priority;
this_box_volume.geometry.geometry_p_interact = p_interact;
// Currently the coordinates will be in absolute space.
this_box_volume.geometry.center = POS_A_CURRENT_COMP;

this_box_storage.z_depth = zdepth;
this_box_storage.x_width1 = xwidth;
this_box_storage.y_height1 = yheight;

this_box_storage.is_rectangle = 0;
if (xwidth2 < 0 && yheight2 < 0) this_box_storage.is_rectangle = 1;
if (xwidth == xwidth2 && yheight == yheight2) this_box_storage.is_rectangle = 1;

if (xwidth2 < 0) {
    this_box_storage.x_width2 = xwidth;
    xwidth2 = xwidth;
} else this_box_storage.x_width2 = xwidth2;

if (yheight2 < 0) {
    this_box_storage.y_height2 = yheight;
    yheight2 = yheight;
} else this_box_storage.y_height2 = yheight2;


this_box_storage.normal_vectors[0] = coords_set(0,0,1);
this_box_storage.normal_vectors[1] = coords_set(0,0,1);

// for sides with y component = 0
x_component = 2*zdepth/sqrt((xwidth-xwidth2)*(xwidth-xwidth2)+4*zdepth*zdepth);
z_component = (xwidth-xwidth2)/sqrt(4*zdepth*zdepth+(xwidth-xwidth2)*(xwidth-xwidth2));

this_box_storage.normal_vectors[2] = coords_set(x_component,0,z_component);
this_box_storage.normal_vectors[3] = coords_set(-x_component,0,z_component);

// for sides with x component = 0
y_component = 2*zdepth/sqrt((yheight-yheight2)*(yheight-yheight2)+4*zdepth*zdepth);
z_component = (yheight-yheight2)/sqrt(4*zdepth*zdepth+(yheight-yheight2)*(yheight-yheight2));

this_box_storage.normal_vectors[4] = coords_set(0,y_component,z_component);
this_box_storage.normal_vectors[5] = coords_set(0,-y_component,z_component);

this_box_volume.geometry.visualization_on = visualize;

this_box_volume.geometry.geometry_parameters.p_box_storage = &this_box_storage;

// Assign pointers to functions for intersection with the shape, checking if a point is inside the shape
if (this_box_storage.is_rectangle == 1) {
this_box_volume.geometry.intersect_function = &sample_box_intersect_simple;
this_box_volume.geometry.within_function = &r_within_box_simple;
}
else {
this_box_volume.geometry.intersect_function = &sample_box_intersect_advanced;
this_box_volume.geometry.within_function = &r_within_box_advanced;
}

this_box_volume.geometry.shell_points = &box_shell_points;
this_box_volume.geometry.mcdisplay_function = &mcdisplay_box_function;
this_box_volume.geometry.initialize_from_main_function = &initialize_box_geometry_from_main_component;
this_box_volume.geometry.process_rot_allocated = 0;

this_box_volume.geometry.copy_geometry_parameters = &allocate_box_storage_copy;

rot_copy(this_box_volume.geometry.rotation_matrix,ROT_A_CURRENT_COMP); //check how ROT_R_CURRENT_COMP would work
rot_transpose(ROT_A_CURRENT_COMP,this_box_volume.geometry.transpose_rotation_matrix);

// Initialize loggers
this_box_volume.loggers.num_elements = 0;

// packing the information into the global_geometry_element, which is then included in the global_geometry_list.
sprintf(global_geometry_element.name,NAME_CURRENT_COMP);
global_geometry_element.activation_counter = number_of_activations;
global_geometry_element.component_index = INDEX_CURRENT_COMP;
global_geometry_element.Volume = &this_box_volume; // Would be nicer if this m was a pointer, now we have the (small) data two places
add_element_to_geometry_list(&global_geometry_list,global_geometry_element);
}
#line 284102 "MACS_sample_kidney_box.c"
#undef number_of_activations
#undef mask_setting
#undef mask_string
#undef p_interact
#undef focus_r
#undef focus_xh
#undef focus_xw
#undef focus_ah
#undef focus_aw
#undef target_z
#undef target_y
#undef target_x
#undef target_index
#undef visualize
#undef yheight2
#undef xwidth2
#undef zdepth
#undef yheight
#undef xwidth
#undef priority
#undef material_string
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

  /* Initializations for component channel_13_analyzer_2_array_crystal_array_6. */
  SIG_MESSAGE("channel_13_analyzer_2_array_crystal_array_6 (Init)");
#define mccompcurname  channel_13_analyzer_2_array_crystal_array_6
#define mccompcurtype  Union_box
#define mccompcurindex 641
#define loop_index mccchannel_13_analyzer_2_array_crystal_array_6_loop_index
#define this_box_volume mccchannel_13_analyzer_2_array_crystal_array_6_this_box_volume
#define global_geometry_element mccchannel_13_analyzer_2_array_crystal_array_6_global_geometry_element
#define this_box_storage mccchannel_13_analyzer_2_array_crystal_array_6_this_box_storage
#define material_string mccchannel_13_analyzer_2_array_crystal_array_6_material_string
#define priority mccchannel_13_analyzer_2_array_crystal_array_6_priority
#define xwidth mccchannel_13_analyzer_2_array_crystal_array_6_xwidth
#define yheight mccchannel_13_analyzer_2_array_crystal_array_6_yheight
#define zdepth mccchannel_13_analyzer_2_array_crystal_array_6_zdepth
#define xwidth2 mccchannel_13_analyzer_2_array_crystal_array_6_xwidth2
#define yheight2 mccchannel_13_analyzer_2_array_crystal_array_6_yheight2
#define visualize mccchannel_13_analyzer_2_array_crystal_array_6_visualize
#define target_index mccchannel_13_analyzer_2_array_crystal_array_6_target_index
#define target_x mccchannel_13_analyzer_2_array_crystal_array_6_target_x
#define target_y mccchannel_13_analyzer_2_array_crystal_array_6_target_y
#define target_z mccchannel_13_analyzer_2_array_crystal_array_6_target_z
#define focus_aw mccchannel_13_analyzer_2_array_crystal_array_6_focus_aw
#define focus_ah mccchannel_13_analyzer_2_array_crystal_array_6_focus_ah
#define focus_xw mccchannel_13_analyzer_2_array_crystal_array_6_focus_xw
#define focus_xh mccchannel_13_analyzer_2_array_crystal_array_6_focus_xh
#define focus_r mccchannel_13_analyzer_2_array_crystal_array_6_focus_r
#define p_interact mccchannel_13_analyzer_2_array_crystal_array_6_p_interact
#define mask_string mccchannel_13_analyzer_2_array_crystal_array_6_mask_string
#define mask_setting mccchannel_13_analyzer_2_array_crystal_array_6_mask_setting
#define number_of_activations mccchannel_13_analyzer_2_array_crystal_array_6_number_of_activations
#line 224 "Union_box.comp"
{
// Initializes the focusing system for this volume including input sanitation.
focus_initialize(&this_box_volume.geometry, POS_A_COMP_INDEX(INDEX_CURRENT_COMP+target_index), POS_A_CURRENT_COMP, ROT_A_CURRENT_COMP, target_index, target_x, target_y, target_z, focus_aw, focus_ah, focus_xw, focus_xh, focus_r, NAME_CURRENT_COMP);

// Input sanitation for this geometry
if (xwidth <= 0) {
  printf("\nERROR in Union_box named %s, the xwidth is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (yheight <= 0) {
  printf("\nERROR in Union_box named %s, yheight is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (zdepth <= 0) {
  printf("\nERROR in Union_box named %s, zdepth is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (xwidth2 <= 0 && xwidth2 != -1) {
  printf("\nERROR in Union_box named %s, the xwidth2 is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (yheight2 <= 0 && yheight2 != -1) {
  printf("\nERROR in Union_box named %s, yheight2 is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}

// Use sanitation
if (global_material_list.num_elements == 0) {
  printf("\nERROR: Need to define a material using Union_make_material before using a Union geometry component. \n");
  printf("       %s was defined before first use of Union_make_material.\n",NAME_CURRENT_COMP);
  exit(1);
}

this_box_volume.geometry.is_masked_volume = 0;
this_box_volume.geometry.is_exit_volume = 0;
this_box_volume.geometry.is_mask_volume = 0;
// check if the volume is a mask, if it is the material string is irelevant.
if (mask_string && strlen(mask_string) && strcmp(mask_string, "NULL") && strcmp(mask_string, "0")) {
    // A mask volume is used to limit the extend of other volumes, called the masked volumes. These are specified in the mask_string.
    // In order for a ray to enter a masked volume, it needs to be both in the region covered by that volume AND the mask volume.
    // When more than
    this_box_volume.geometry.mask_mode = 1; // Default is mask mode is ALL
    if (mask_setting && strlen(mask_setting) && strcmp(mask_setting, "NULL") && strcmp(mask_setting, "0")) {
        if (strcmp(mask_setting,"ALL") == 0 || strcmp(mask_setting,"All") == 0) this_box_volume.geometry.mask_mode = 1;
        else if (strcmp(mask_setting,"ANY") == 0 || strcmp(mask_setting,"Any") == 0) this_box_volume.geometry.mask_mode = 2;
        else {
            printf("The mask_mode of component %s is set to %s, but must be either ALL or ANY.\n",NAME_CURRENT_COMP,mask_setting);
            exit(1);
        }
    }
    
    for (loop_index=0;loop_index<global_geometry_list.num_elements;loop_index++) {
        // Add mask list
        if (1 == manual_linking_function(global_geometry_list.elements[loop_index].name,mask_string)) {
            add_element_to_int_list(&this_box_volume.geometry.mask_list,global_geometry_list.elements[loop_index].component_index);
            add_element_to_int_list(&global_geometry_list.elements[loop_index].Volume->geometry.masked_by_list,INDEX_CURRENT_COMP);
            global_geometry_list.elements[loop_index].Volume->geometry.is_masked_volume = 1;
            if (this_box_volume.geometry.mask_mode == 2)
                global_geometry_list.elements[loop_index].Volume->geometry.mask_mode = 2;
            if (this_box_volume.geometry.mask_mode == 1) {
                if (global_geometry_list.elements[loop_index].Volume->geometry.is_masked_volume == 1 && global_geometry_list.elements[loop_index].Volume->geometry.mask_mode != 2)
                    // If more than one mask is added to one volume, the ANY mode overwrites the (default) ALL mode.
                    global_geometry_list.elements[loop_index].Volume->geometry.mask_mode = 1;
            }
            
            found_geometries = 1;
        }
    }
    if (found_geometries == 0) {
        printf("The mask_string in geometry: %s did not find any of the specified volumes in the mask_string %s \n",NAME_CURRENT_COMP,mask_string);
        exit(1);
    }
    this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
    this_box_volume.p_physics->is_vacuum = 0; // Makes this volume a vacuum
    this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
    this_box_volume.p_physics->my_a = 0; // Should not be used.
    sprintf(this_box_volume.p_physics->name,"Mask");
    this_box_volume.geometry.is_mask_volume = 1;
    
    
// Read the material input, or if it lacks, use automatic linking.
} else if (material_string && strlen(material_string) && strcmp(material_string, "NULL") && strcmp(material_string, "0")) {
    // A geometry string was given, use it to determine which material
    if (0 == strcmp(material_string,"vacuum") || 0 == strcmp(material_string,"Vacuum")) {
        // One could have a global physics struct for vacuum instead of creating one for each
        this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
        this_box_volume.p_physics->is_vacuum = 1; // Makes this volume a vacuum
        this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
        this_box_volume.p_physics->my_a = 0; // Should not be used.
        sprintf(this_box_volume.p_physics->name,"Vacuum");
    } else if (0 == strcmp(material_string,"exit") || 0 == strcmp(material_string,"Exit")) {
        // One could have a global physics struct for vacuum instead of creating one for each
        this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
        this_box_volume.p_physics->is_vacuum = 1; // Makes this volume a vacuum
        this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
        this_box_volume.p_physics->my_a = 0; // Should not be used.
        this_box_volume.geometry.is_exit_volume = 1;
        sprintf(this_box_volume.p_physics->name,"Exit");
    } else {
        #ifndef MATERIAL_DETECTOR
            printf("Need to define a material before refering to it in a geometry %s.\n",NAME_CURRENT_COMP);
            exit(1);
        #endif
        for (loop_index=0;loop_index<global_material_list.num_elements;loop_index++) {
            if (0 == strcmp(material_string,global_material_list.elements[loop_index].name)) {
                this_box_volume.p_physics = global_material_list.elements[loop_index].physics;
                break;
            }
            if (loop_index == global_material_list.num_elements-1) {
            printf("\n");
            printf("ERROR: The material string \"%s\" in Union geometry \"%s\" did not match a specified material. \n",material_string,NAME_CURRENT_COMP);
            printf("       The materials available at this point (need to be defined before the geometry): \n");
            for (loop_index=0;loop_index<global_material_list.num_elements;loop_index++)
              printf("         %s\n",global_material_list.elements[loop_index].name);
            printf("\n");
            printf("       It is also possible to use one of the defualt materials avaiable: \n");
            printf("           Vacuum (for a Volume without scattering or absorption)\n");
            printf("           Exit (for a Volume where the ray exits the component if it enters)\n");
            printf("           Mask (for a Volume that masks existing volumes specified in the mask_string\n");
            exit(1);
          }
        }
    }
} else {
    // Automatic linking, simply using the last defined material.
    #ifndef MATERIAL_DETECTOR
        printf("Need to define a material before the geometry to use automatic linking %s.\n",NAME_CURRENT_COMP);
        exit(1);
    #endif
    this_box_volume.p_physics = global_material_list.elements[global_material_list.num_elements-1].physics;
}

sprintf(this_box_volume.name,NAME_CURRENT_COMP);
sprintf(this_box_volume.geometry.shape,"box");
this_box_volume.geometry.priority_value = priority;
this_box_volume.geometry.geometry_p_interact = p_interact;
// Currently the coordinates will be in absolute space.
this_box_volume.geometry.center = POS_A_CURRENT_COMP;

this_box_storage.z_depth = zdepth;
this_box_storage.x_width1 = xwidth;
this_box_storage.y_height1 = yheight;

this_box_storage.is_rectangle = 0;
if (xwidth2 < 0 && yheight2 < 0) this_box_storage.is_rectangle = 1;
if (xwidth == xwidth2 && yheight == yheight2) this_box_storage.is_rectangle = 1;

if (xwidth2 < 0) {
    this_box_storage.x_width2 = xwidth;
    xwidth2 = xwidth;
} else this_box_storage.x_width2 = xwidth2;

if (yheight2 < 0) {
    this_box_storage.y_height2 = yheight;
    yheight2 = yheight;
} else this_box_storage.y_height2 = yheight2;


this_box_storage.normal_vectors[0] = coords_set(0,0,1);
this_box_storage.normal_vectors[1] = coords_set(0,0,1);

// for sides with y component = 0
x_component = 2*zdepth/sqrt((xwidth-xwidth2)*(xwidth-xwidth2)+4*zdepth*zdepth);
z_component = (xwidth-xwidth2)/sqrt(4*zdepth*zdepth+(xwidth-xwidth2)*(xwidth-xwidth2));

this_box_storage.normal_vectors[2] = coords_set(x_component,0,z_component);
this_box_storage.normal_vectors[3] = coords_set(-x_component,0,z_component);

// for sides with x component = 0
y_component = 2*zdepth/sqrt((yheight-yheight2)*(yheight-yheight2)+4*zdepth*zdepth);
z_component = (yheight-yheight2)/sqrt(4*zdepth*zdepth+(yheight-yheight2)*(yheight-yheight2));

this_box_storage.normal_vectors[4] = coords_set(0,y_component,z_component);
this_box_storage.normal_vectors[5] = coords_set(0,-y_component,z_component);

this_box_volume.geometry.visualization_on = visualize;

this_box_volume.geometry.geometry_parameters.p_box_storage = &this_box_storage;

// Assign pointers to functions for intersection with the shape, checking if a point is inside the shape
if (this_box_storage.is_rectangle == 1) {
this_box_volume.geometry.intersect_function = &sample_box_intersect_simple;
this_box_volume.geometry.within_function = &r_within_box_simple;
}
else {
this_box_volume.geometry.intersect_function = &sample_box_intersect_advanced;
this_box_volume.geometry.within_function = &r_within_box_advanced;
}

this_box_volume.geometry.shell_points = &box_shell_points;
this_box_volume.geometry.mcdisplay_function = &mcdisplay_box_function;
this_box_volume.geometry.initialize_from_main_function = &initialize_box_geometry_from_main_component;
this_box_volume.geometry.process_rot_allocated = 0;

this_box_volume.geometry.copy_geometry_parameters = &allocate_box_storage_copy;

rot_copy(this_box_volume.geometry.rotation_matrix,ROT_A_CURRENT_COMP); //check how ROT_R_CURRENT_COMP would work
rot_transpose(ROT_A_CURRENT_COMP,this_box_volume.geometry.transpose_rotation_matrix);

// Initialize loggers
this_box_volume.loggers.num_elements = 0;

// packing the information into the global_geometry_element, which is then included in the global_geometry_list.
sprintf(global_geometry_element.name,NAME_CURRENT_COMP);
global_geometry_element.activation_counter = number_of_activations;
global_geometry_element.component_index = INDEX_CURRENT_COMP;
global_geometry_element.Volume = &this_box_volume; // Would be nicer if this m was a pointer, now we have the (small) data two places
add_element_to_geometry_list(&global_geometry_list,global_geometry_element);
}
#line 284372 "MACS_sample_kidney_box.c"
#undef number_of_activations
#undef mask_setting
#undef mask_string
#undef p_interact
#undef focus_r
#undef focus_xh
#undef focus_xw
#undef focus_ah
#undef focus_aw
#undef target_z
#undef target_y
#undef target_x
#undef target_index
#undef visualize
#undef yheight2
#undef xwidth2
#undef zdepth
#undef yheight
#undef xwidth
#undef priority
#undef material_string
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

  /* Initializations for component channel_13_analyzer_2_array_crystal_array_7. */
  SIG_MESSAGE("channel_13_analyzer_2_array_crystal_array_7 (Init)");
#define mccompcurname  channel_13_analyzer_2_array_crystal_array_7
#define mccompcurtype  Union_box
#define mccompcurindex 642
#define loop_index mccchannel_13_analyzer_2_array_crystal_array_7_loop_index
#define this_box_volume mccchannel_13_analyzer_2_array_crystal_array_7_this_box_volume
#define global_geometry_element mccchannel_13_analyzer_2_array_crystal_array_7_global_geometry_element
#define this_box_storage mccchannel_13_analyzer_2_array_crystal_array_7_this_box_storage
#define material_string mccchannel_13_analyzer_2_array_crystal_array_7_material_string
#define priority mccchannel_13_analyzer_2_array_crystal_array_7_priority
#define xwidth mccchannel_13_analyzer_2_array_crystal_array_7_xwidth
#define yheight mccchannel_13_analyzer_2_array_crystal_array_7_yheight
#define zdepth mccchannel_13_analyzer_2_array_crystal_array_7_zdepth
#define xwidth2 mccchannel_13_analyzer_2_array_crystal_array_7_xwidth2
#define yheight2 mccchannel_13_analyzer_2_array_crystal_array_7_yheight2
#define visualize mccchannel_13_analyzer_2_array_crystal_array_7_visualize
#define target_index mccchannel_13_analyzer_2_array_crystal_array_7_target_index
#define target_x mccchannel_13_analyzer_2_array_crystal_array_7_target_x
#define target_y mccchannel_13_analyzer_2_array_crystal_array_7_target_y
#define target_z mccchannel_13_analyzer_2_array_crystal_array_7_target_z
#define focus_aw mccchannel_13_analyzer_2_array_crystal_array_7_focus_aw
#define focus_ah mccchannel_13_analyzer_2_array_crystal_array_7_focus_ah
#define focus_xw mccchannel_13_analyzer_2_array_crystal_array_7_focus_xw
#define focus_xh mccchannel_13_analyzer_2_array_crystal_array_7_focus_xh
#define focus_r mccchannel_13_analyzer_2_array_crystal_array_7_focus_r
#define p_interact mccchannel_13_analyzer_2_array_crystal_array_7_p_interact
#define mask_string mccchannel_13_analyzer_2_array_crystal_array_7_mask_string
#define mask_setting mccchannel_13_analyzer_2_array_crystal_array_7_mask_setting
#define number_of_activations mccchannel_13_analyzer_2_array_crystal_array_7_number_of_activations
#line 224 "Union_box.comp"
{
// Initializes the focusing system for this volume including input sanitation.
focus_initialize(&this_box_volume.geometry, POS_A_COMP_INDEX(INDEX_CURRENT_COMP+target_index), POS_A_CURRENT_COMP, ROT_A_CURRENT_COMP, target_index, target_x, target_y, target_z, focus_aw, focus_ah, focus_xw, focus_xh, focus_r, NAME_CURRENT_COMP);

// Input sanitation for this geometry
if (xwidth <= 0) {
  printf("\nERROR in Union_box named %s, the xwidth is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (yheight <= 0) {
  printf("\nERROR in Union_box named %s, yheight is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (zdepth <= 0) {
  printf("\nERROR in Union_box named %s, zdepth is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (xwidth2 <= 0 && xwidth2 != -1) {
  printf("\nERROR in Union_box named %s, the xwidth2 is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (yheight2 <= 0 && yheight2 != -1) {
  printf("\nERROR in Union_box named %s, yheight2 is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}

// Use sanitation
if (global_material_list.num_elements == 0) {
  printf("\nERROR: Need to define a material using Union_make_material before using a Union geometry component. \n");
  printf("       %s was defined before first use of Union_make_material.\n",NAME_CURRENT_COMP);
  exit(1);
}

this_box_volume.geometry.is_masked_volume = 0;
this_box_volume.geometry.is_exit_volume = 0;
this_box_volume.geometry.is_mask_volume = 0;
// check if the volume is a mask, if it is the material string is irelevant.
if (mask_string && strlen(mask_string) && strcmp(mask_string, "NULL") && strcmp(mask_string, "0")) {
    // A mask volume is used to limit the extend of other volumes, called the masked volumes. These are specified in the mask_string.
    // In order for a ray to enter a masked volume, it needs to be both in the region covered by that volume AND the mask volume.
    // When more than
    this_box_volume.geometry.mask_mode = 1; // Default is mask mode is ALL
    if (mask_setting && strlen(mask_setting) && strcmp(mask_setting, "NULL") && strcmp(mask_setting, "0")) {
        if (strcmp(mask_setting,"ALL") == 0 || strcmp(mask_setting,"All") == 0) this_box_volume.geometry.mask_mode = 1;
        else if (strcmp(mask_setting,"ANY") == 0 || strcmp(mask_setting,"Any") == 0) this_box_volume.geometry.mask_mode = 2;
        else {
            printf("The mask_mode of component %s is set to %s, but must be either ALL or ANY.\n",NAME_CURRENT_COMP,mask_setting);
            exit(1);
        }
    }
    
    for (loop_index=0;loop_index<global_geometry_list.num_elements;loop_index++) {
        // Add mask list
        if (1 == manual_linking_function(global_geometry_list.elements[loop_index].name,mask_string)) {
            add_element_to_int_list(&this_box_volume.geometry.mask_list,global_geometry_list.elements[loop_index].component_index);
            add_element_to_int_list(&global_geometry_list.elements[loop_index].Volume->geometry.masked_by_list,INDEX_CURRENT_COMP);
            global_geometry_list.elements[loop_index].Volume->geometry.is_masked_volume = 1;
            if (this_box_volume.geometry.mask_mode == 2)
                global_geometry_list.elements[loop_index].Volume->geometry.mask_mode = 2;
            if (this_box_volume.geometry.mask_mode == 1) {
                if (global_geometry_list.elements[loop_index].Volume->geometry.is_masked_volume == 1 && global_geometry_list.elements[loop_index].Volume->geometry.mask_mode != 2)
                    // If more than one mask is added to one volume, the ANY mode overwrites the (default) ALL mode.
                    global_geometry_list.elements[loop_index].Volume->geometry.mask_mode = 1;
            }
            
            found_geometries = 1;
        }
    }
    if (found_geometries == 0) {
        printf("The mask_string in geometry: %s did not find any of the specified volumes in the mask_string %s \n",NAME_CURRENT_COMP,mask_string);
        exit(1);
    }
    this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
    this_box_volume.p_physics->is_vacuum = 0; // Makes this volume a vacuum
    this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
    this_box_volume.p_physics->my_a = 0; // Should not be used.
    sprintf(this_box_volume.p_physics->name,"Mask");
    this_box_volume.geometry.is_mask_volume = 1;
    
    
// Read the material input, or if it lacks, use automatic linking.
} else if (material_string && strlen(material_string) && strcmp(material_string, "NULL") && strcmp(material_string, "0")) {
    // A geometry string was given, use it to determine which material
    if (0 == strcmp(material_string,"vacuum") || 0 == strcmp(material_string,"Vacuum")) {
        // One could have a global physics struct for vacuum instead of creating one for each
        this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
        this_box_volume.p_physics->is_vacuum = 1; // Makes this volume a vacuum
        this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
        this_box_volume.p_physics->my_a = 0; // Should not be used.
        sprintf(this_box_volume.p_physics->name,"Vacuum");
    } else if (0 == strcmp(material_string,"exit") || 0 == strcmp(material_string,"Exit")) {
        // One could have a global physics struct for vacuum instead of creating one for each
        this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
        this_box_volume.p_physics->is_vacuum = 1; // Makes this volume a vacuum
        this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
        this_box_volume.p_physics->my_a = 0; // Should not be used.
        this_box_volume.geometry.is_exit_volume = 1;
        sprintf(this_box_volume.p_physics->name,"Exit");
    } else {
        #ifndef MATERIAL_DETECTOR
            printf("Need to define a material before refering to it in a geometry %s.\n",NAME_CURRENT_COMP);
            exit(1);
        #endif
        for (loop_index=0;loop_index<global_material_list.num_elements;loop_index++) {
            if (0 == strcmp(material_string,global_material_list.elements[loop_index].name)) {
                this_box_volume.p_physics = global_material_list.elements[loop_index].physics;
                break;
            }
            if (loop_index == global_material_list.num_elements-1) {
            printf("\n");
            printf("ERROR: The material string \"%s\" in Union geometry \"%s\" did not match a specified material. \n",material_string,NAME_CURRENT_COMP);
            printf("       The materials available at this point (need to be defined before the geometry): \n");
            for (loop_index=0;loop_index<global_material_list.num_elements;loop_index++)
              printf("         %s\n",global_material_list.elements[loop_index].name);
            printf("\n");
            printf("       It is also possible to use one of the defualt materials avaiable: \n");
            printf("           Vacuum (for a Volume without scattering or absorption)\n");
            printf("           Exit (for a Volume where the ray exits the component if it enters)\n");
            printf("           Mask (for a Volume that masks existing volumes specified in the mask_string\n");
            exit(1);
          }
        }
    }
} else {
    // Automatic linking, simply using the last defined material.
    #ifndef MATERIAL_DETECTOR
        printf("Need to define a material before the geometry to use automatic linking %s.\n",NAME_CURRENT_COMP);
        exit(1);
    #endif
    this_box_volume.p_physics = global_material_list.elements[global_material_list.num_elements-1].physics;
}

sprintf(this_box_volume.name,NAME_CURRENT_COMP);
sprintf(this_box_volume.geometry.shape,"box");
this_box_volume.geometry.priority_value = priority;
this_box_volume.geometry.geometry_p_interact = p_interact;
// Currently the coordinates will be in absolute space.
this_box_volume.geometry.center = POS_A_CURRENT_COMP;

this_box_storage.z_depth = zdepth;
this_box_storage.x_width1 = xwidth;
this_box_storage.y_height1 = yheight;

this_box_storage.is_rectangle = 0;
if (xwidth2 < 0 && yheight2 < 0) this_box_storage.is_rectangle = 1;
if (xwidth == xwidth2 && yheight == yheight2) this_box_storage.is_rectangle = 1;

if (xwidth2 < 0) {
    this_box_storage.x_width2 = xwidth;
    xwidth2 = xwidth;
} else this_box_storage.x_width2 = xwidth2;

if (yheight2 < 0) {
    this_box_storage.y_height2 = yheight;
    yheight2 = yheight;
} else this_box_storage.y_height2 = yheight2;


this_box_storage.normal_vectors[0] = coords_set(0,0,1);
this_box_storage.normal_vectors[1] = coords_set(0,0,1);

// for sides with y component = 0
x_component = 2*zdepth/sqrt((xwidth-xwidth2)*(xwidth-xwidth2)+4*zdepth*zdepth);
z_component = (xwidth-xwidth2)/sqrt(4*zdepth*zdepth+(xwidth-xwidth2)*(xwidth-xwidth2));

this_box_storage.normal_vectors[2] = coords_set(x_component,0,z_component);
this_box_storage.normal_vectors[3] = coords_set(-x_component,0,z_component);

// for sides with x component = 0
y_component = 2*zdepth/sqrt((yheight-yheight2)*(yheight-yheight2)+4*zdepth*zdepth);
z_component = (yheight-yheight2)/sqrt(4*zdepth*zdepth+(yheight-yheight2)*(yheight-yheight2));

this_box_storage.normal_vectors[4] = coords_set(0,y_component,z_component);
this_box_storage.normal_vectors[5] = coords_set(0,-y_component,z_component);

this_box_volume.geometry.visualization_on = visualize;

this_box_volume.geometry.geometry_parameters.p_box_storage = &this_box_storage;

// Assign pointers to functions for intersection with the shape, checking if a point is inside the shape
if (this_box_storage.is_rectangle == 1) {
this_box_volume.geometry.intersect_function = &sample_box_intersect_simple;
this_box_volume.geometry.within_function = &r_within_box_simple;
}
else {
this_box_volume.geometry.intersect_function = &sample_box_intersect_advanced;
this_box_volume.geometry.within_function = &r_within_box_advanced;
}

this_box_volume.geometry.shell_points = &box_shell_points;
this_box_volume.geometry.mcdisplay_function = &mcdisplay_box_function;
this_box_volume.geometry.initialize_from_main_function = &initialize_box_geometry_from_main_component;
this_box_volume.geometry.process_rot_allocated = 0;

this_box_volume.geometry.copy_geometry_parameters = &allocate_box_storage_copy;

rot_copy(this_box_volume.geometry.rotation_matrix,ROT_A_CURRENT_COMP); //check how ROT_R_CURRENT_COMP would work
rot_transpose(ROT_A_CURRENT_COMP,this_box_volume.geometry.transpose_rotation_matrix);

// Initialize loggers
this_box_volume.loggers.num_elements = 0;

// packing the information into the global_geometry_element, which is then included in the global_geometry_list.
sprintf(global_geometry_element.name,NAME_CURRENT_COMP);
global_geometry_element.activation_counter = number_of_activations;
global_geometry_element.component_index = INDEX_CURRENT_COMP;
global_geometry_element.Volume = &this_box_volume; // Would be nicer if this m was a pointer, now we have the (small) data two places
add_element_to_geometry_list(&global_geometry_list,global_geometry_element);
}
#line 284642 "MACS_sample_kidney_box.c"
#undef number_of_activations
#undef mask_setting
#undef mask_string
#undef p_interact
#undef focus_r
#undef focus_xh
#undef focus_xw
#undef focus_ah
#undef focus_aw
#undef target_z
#undef target_y
#undef target_x
#undef target_index
#undef visualize
#undef yheight2
#undef xwidth2
#undef zdepth
#undef yheight
#undef xwidth
#undef priority
#undef material_string
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

  /* Initializations for component channel_13_analyzer_2_array_crystal_array_8. */
  SIG_MESSAGE("channel_13_analyzer_2_array_crystal_array_8 (Init)");
#define mccompcurname  channel_13_analyzer_2_array_crystal_array_8
#define mccompcurtype  Union_box
#define mccompcurindex 643
#define loop_index mccchannel_13_analyzer_2_array_crystal_array_8_loop_index
#define this_box_volume mccchannel_13_analyzer_2_array_crystal_array_8_this_box_volume
#define global_geometry_element mccchannel_13_analyzer_2_array_crystal_array_8_global_geometry_element
#define this_box_storage mccchannel_13_analyzer_2_array_crystal_array_8_this_box_storage
#define material_string mccchannel_13_analyzer_2_array_crystal_array_8_material_string
#define priority mccchannel_13_analyzer_2_array_crystal_array_8_priority
#define xwidth mccchannel_13_analyzer_2_array_crystal_array_8_xwidth
#define yheight mccchannel_13_analyzer_2_array_crystal_array_8_yheight
#define zdepth mccchannel_13_analyzer_2_array_crystal_array_8_zdepth
#define xwidth2 mccchannel_13_analyzer_2_array_crystal_array_8_xwidth2
#define yheight2 mccchannel_13_analyzer_2_array_crystal_array_8_yheight2
#define visualize mccchannel_13_analyzer_2_array_crystal_array_8_visualize
#define target_index mccchannel_13_analyzer_2_array_crystal_array_8_target_index
#define target_x mccchannel_13_analyzer_2_array_crystal_array_8_target_x
#define target_y mccchannel_13_analyzer_2_array_crystal_array_8_target_y
#define target_z mccchannel_13_analyzer_2_array_crystal_array_8_target_z
#define focus_aw mccchannel_13_analyzer_2_array_crystal_array_8_focus_aw
#define focus_ah mccchannel_13_analyzer_2_array_crystal_array_8_focus_ah
#define focus_xw mccchannel_13_analyzer_2_array_crystal_array_8_focus_xw
#define focus_xh mccchannel_13_analyzer_2_array_crystal_array_8_focus_xh
#define focus_r mccchannel_13_analyzer_2_array_crystal_array_8_focus_r
#define p_interact mccchannel_13_analyzer_2_array_crystal_array_8_p_interact
#define mask_string mccchannel_13_analyzer_2_array_crystal_array_8_mask_string
#define mask_setting mccchannel_13_analyzer_2_array_crystal_array_8_mask_setting
#define number_of_activations mccchannel_13_analyzer_2_array_crystal_array_8_number_of_activations
#line 224 "Union_box.comp"
{
// Initializes the focusing system for this volume including input sanitation.
focus_initialize(&this_box_volume.geometry, POS_A_COMP_INDEX(INDEX_CURRENT_COMP+target_index), POS_A_CURRENT_COMP, ROT_A_CURRENT_COMP, target_index, target_x, target_y, target_z, focus_aw, focus_ah, focus_xw, focus_xh, focus_r, NAME_CURRENT_COMP);

// Input sanitation for this geometry
if (xwidth <= 0) {
  printf("\nERROR in Union_box named %s, the xwidth is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (yheight <= 0) {
  printf("\nERROR in Union_box named %s, yheight is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (zdepth <= 0) {
  printf("\nERROR in Union_box named %s, zdepth is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (xwidth2 <= 0 && xwidth2 != -1) {
  printf("\nERROR in Union_box named %s, the xwidth2 is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (yheight2 <= 0 && yheight2 != -1) {
  printf("\nERROR in Union_box named %s, yheight2 is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}

// Use sanitation
if (global_material_list.num_elements == 0) {
  printf("\nERROR: Need to define a material using Union_make_material before using a Union geometry component. \n");
  printf("       %s was defined before first use of Union_make_material.\n",NAME_CURRENT_COMP);
  exit(1);
}

this_box_volume.geometry.is_masked_volume = 0;
this_box_volume.geometry.is_exit_volume = 0;
this_box_volume.geometry.is_mask_volume = 0;
// check if the volume is a mask, if it is the material string is irelevant.
if (mask_string && strlen(mask_string) && strcmp(mask_string, "NULL") && strcmp(mask_string, "0")) {
    // A mask volume is used to limit the extend of other volumes, called the masked volumes. These are specified in the mask_string.
    // In order for a ray to enter a masked volume, it needs to be both in the region covered by that volume AND the mask volume.
    // When more than
    this_box_volume.geometry.mask_mode = 1; // Default is mask mode is ALL
    if (mask_setting && strlen(mask_setting) && strcmp(mask_setting, "NULL") && strcmp(mask_setting, "0")) {
        if (strcmp(mask_setting,"ALL") == 0 || strcmp(mask_setting,"All") == 0) this_box_volume.geometry.mask_mode = 1;
        else if (strcmp(mask_setting,"ANY") == 0 || strcmp(mask_setting,"Any") == 0) this_box_volume.geometry.mask_mode = 2;
        else {
            printf("The mask_mode of component %s is set to %s, but must be either ALL or ANY.\n",NAME_CURRENT_COMP,mask_setting);
            exit(1);
        }
    }
    
    for (loop_index=0;loop_index<global_geometry_list.num_elements;loop_index++) {
        // Add mask list
        if (1 == manual_linking_function(global_geometry_list.elements[loop_index].name,mask_string)) {
            add_element_to_int_list(&this_box_volume.geometry.mask_list,global_geometry_list.elements[loop_index].component_index);
            add_element_to_int_list(&global_geometry_list.elements[loop_index].Volume->geometry.masked_by_list,INDEX_CURRENT_COMP);
            global_geometry_list.elements[loop_index].Volume->geometry.is_masked_volume = 1;
            if (this_box_volume.geometry.mask_mode == 2)
                global_geometry_list.elements[loop_index].Volume->geometry.mask_mode = 2;
            if (this_box_volume.geometry.mask_mode == 1) {
                if (global_geometry_list.elements[loop_index].Volume->geometry.is_masked_volume == 1 && global_geometry_list.elements[loop_index].Volume->geometry.mask_mode != 2)
                    // If more than one mask is added to one volume, the ANY mode overwrites the (default) ALL mode.
                    global_geometry_list.elements[loop_index].Volume->geometry.mask_mode = 1;
            }
            
            found_geometries = 1;
        }
    }
    if (found_geometries == 0) {
        printf("The mask_string in geometry: %s did not find any of the specified volumes in the mask_string %s \n",NAME_CURRENT_COMP,mask_string);
        exit(1);
    }
    this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
    this_box_volume.p_physics->is_vacuum = 0; // Makes this volume a vacuum
    this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
    this_box_volume.p_physics->my_a = 0; // Should not be used.
    sprintf(this_box_volume.p_physics->name,"Mask");
    this_box_volume.geometry.is_mask_volume = 1;
    
    
// Read the material input, or if it lacks, use automatic linking.
} else if (material_string && strlen(material_string) && strcmp(material_string, "NULL") && strcmp(material_string, "0")) {
    // A geometry string was given, use it to determine which material
    if (0 == strcmp(material_string,"vacuum") || 0 == strcmp(material_string,"Vacuum")) {
        // One could have a global physics struct for vacuum instead of creating one for each
        this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
        this_box_volume.p_physics->is_vacuum = 1; // Makes this volume a vacuum
        this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
        this_box_volume.p_physics->my_a = 0; // Should not be used.
        sprintf(this_box_volume.p_physics->name,"Vacuum");
    } else if (0 == strcmp(material_string,"exit") || 0 == strcmp(material_string,"Exit")) {
        // One could have a global physics struct for vacuum instead of creating one for each
        this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
        this_box_volume.p_physics->is_vacuum = 1; // Makes this volume a vacuum
        this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
        this_box_volume.p_physics->my_a = 0; // Should not be used.
        this_box_volume.geometry.is_exit_volume = 1;
        sprintf(this_box_volume.p_physics->name,"Exit");
    } else {
        #ifndef MATERIAL_DETECTOR
            printf("Need to define a material before refering to it in a geometry %s.\n",NAME_CURRENT_COMP);
            exit(1);
        #endif
        for (loop_index=0;loop_index<global_material_list.num_elements;loop_index++) {
            if (0 == strcmp(material_string,global_material_list.elements[loop_index].name)) {
                this_box_volume.p_physics = global_material_list.elements[loop_index].physics;
                break;
            }
            if (loop_index == global_material_list.num_elements-1) {
            printf("\n");
            printf("ERROR: The material string \"%s\" in Union geometry \"%s\" did not match a specified material. \n",material_string,NAME_CURRENT_COMP);
            printf("       The materials available at this point (need to be defined before the geometry): \n");
            for (loop_index=0;loop_index<global_material_list.num_elements;loop_index++)
              printf("         %s\n",global_material_list.elements[loop_index].name);
            printf("\n");
            printf("       It is also possible to use one of the defualt materials avaiable: \n");
            printf("           Vacuum (for a Volume without scattering or absorption)\n");
            printf("           Exit (for a Volume where the ray exits the component if it enters)\n");
            printf("           Mask (for a Volume that masks existing volumes specified in the mask_string\n");
            exit(1);
          }
        }
    }
} else {
    // Automatic linking, simply using the last defined material.
    #ifndef MATERIAL_DETECTOR
        printf("Need to define a material before the geometry to use automatic linking %s.\n",NAME_CURRENT_COMP);
        exit(1);
    #endif
    this_box_volume.p_physics = global_material_list.elements[global_material_list.num_elements-1].physics;
}

sprintf(this_box_volume.name,NAME_CURRENT_COMP);
sprintf(this_box_volume.geometry.shape,"box");
this_box_volume.geometry.priority_value = priority;
this_box_volume.geometry.geometry_p_interact = p_interact;
// Currently the coordinates will be in absolute space.
this_box_volume.geometry.center = POS_A_CURRENT_COMP;

this_box_storage.z_depth = zdepth;
this_box_storage.x_width1 = xwidth;
this_box_storage.y_height1 = yheight;

this_box_storage.is_rectangle = 0;
if (xwidth2 < 0 && yheight2 < 0) this_box_storage.is_rectangle = 1;
if (xwidth == xwidth2 && yheight == yheight2) this_box_storage.is_rectangle = 1;

if (xwidth2 < 0) {
    this_box_storage.x_width2 = xwidth;
    xwidth2 = xwidth;
} else this_box_storage.x_width2 = xwidth2;

if (yheight2 < 0) {
    this_box_storage.y_height2 = yheight;
    yheight2 = yheight;
} else this_box_storage.y_height2 = yheight2;


this_box_storage.normal_vectors[0] = coords_set(0,0,1);
this_box_storage.normal_vectors[1] = coords_set(0,0,1);

// for sides with y component = 0
x_component = 2*zdepth/sqrt((xwidth-xwidth2)*(xwidth-xwidth2)+4*zdepth*zdepth);
z_component = (xwidth-xwidth2)/sqrt(4*zdepth*zdepth+(xwidth-xwidth2)*(xwidth-xwidth2));

this_box_storage.normal_vectors[2] = coords_set(x_component,0,z_component);
this_box_storage.normal_vectors[3] = coords_set(-x_component,0,z_component);

// for sides with x component = 0
y_component = 2*zdepth/sqrt((yheight-yheight2)*(yheight-yheight2)+4*zdepth*zdepth);
z_component = (yheight-yheight2)/sqrt(4*zdepth*zdepth+(yheight-yheight2)*(yheight-yheight2));

this_box_storage.normal_vectors[4] = coords_set(0,y_component,z_component);
this_box_storage.normal_vectors[5] = coords_set(0,-y_component,z_component);

this_box_volume.geometry.visualization_on = visualize;

this_box_volume.geometry.geometry_parameters.p_box_storage = &this_box_storage;

// Assign pointers to functions for intersection with the shape, checking if a point is inside the shape
if (this_box_storage.is_rectangle == 1) {
this_box_volume.geometry.intersect_function = &sample_box_intersect_simple;
this_box_volume.geometry.within_function = &r_within_box_simple;
}
else {
this_box_volume.geometry.intersect_function = &sample_box_intersect_advanced;
this_box_volume.geometry.within_function = &r_within_box_advanced;
}

this_box_volume.geometry.shell_points = &box_shell_points;
this_box_volume.geometry.mcdisplay_function = &mcdisplay_box_function;
this_box_volume.geometry.initialize_from_main_function = &initialize_box_geometry_from_main_component;
this_box_volume.geometry.process_rot_allocated = 0;

this_box_volume.geometry.copy_geometry_parameters = &allocate_box_storage_copy;

rot_copy(this_box_volume.geometry.rotation_matrix,ROT_A_CURRENT_COMP); //check how ROT_R_CURRENT_COMP would work
rot_transpose(ROT_A_CURRENT_COMP,this_box_volume.geometry.transpose_rotation_matrix);

// Initialize loggers
this_box_volume.loggers.num_elements = 0;

// packing the information into the global_geometry_element, which is then included in the global_geometry_list.
sprintf(global_geometry_element.name,NAME_CURRENT_COMP);
global_geometry_element.activation_counter = number_of_activations;
global_geometry_element.component_index = INDEX_CURRENT_COMP;
global_geometry_element.Volume = &this_box_volume; // Would be nicer if this m was a pointer, now we have the (small) data two places
add_element_to_geometry_list(&global_geometry_list,global_geometry_element);
}
#line 284912 "MACS_sample_kidney_box.c"
#undef number_of_activations
#undef mask_setting
#undef mask_string
#undef p_interact
#undef focus_r
#undef focus_xh
#undef focus_xw
#undef focus_ah
#undef focus_aw
#undef target_z
#undef target_y
#undef target_x
#undef target_index
#undef visualize
#undef yheight2
#undef xwidth2
#undef zdepth
#undef yheight
#undef xwidth
#undef priority
#undef material_string
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

  /* Initializations for component channel_13_cave2_cyl1. */
  SIG_MESSAGE("channel_13_cave2_cyl1 (Init)");
#define mccompcurname  channel_13_cave2_cyl1
#define mccompcurtype  Union_cylinder
#define mccompcurindex 644
#define loop_index mccchannel_13_cave2_cyl1_loop_index
#define this_cylinder_volume mccchannel_13_cave2_cyl1_this_cylinder_volume
#define global_geometry_element mccchannel_13_cave2_cyl1_global_geometry_element
#define this_cylinder_storage mccchannel_13_cave2_cyl1_this_cylinder_storage
#define material_string mccchannel_13_cave2_cyl1_material_string
#define priority mccchannel_13_cave2_cyl1_priority
#define radius mccchannel_13_cave2_cyl1_radius
#define yheight mccchannel_13_cave2_cyl1_yheight
#define visualize mccchannel_13_cave2_cyl1_visualize
#define target_index mccchannel_13_cave2_cyl1_target_index
#define target_x mccchannel_13_cave2_cyl1_target_x
#define target_y mccchannel_13_cave2_cyl1_target_y
#define target_z mccchannel_13_cave2_cyl1_target_z
#define focus_aw mccchannel_13_cave2_cyl1_focus_aw
#define focus_ah mccchannel_13_cave2_cyl1_focus_ah
#define focus_xw mccchannel_13_cave2_cyl1_focus_xw
#define focus_xh mccchannel_13_cave2_cyl1_focus_xh
#define focus_r mccchannel_13_cave2_cyl1_focus_r
#define p_interact mccchannel_13_cave2_cyl1_p_interact
#define mask_string mccchannel_13_cave2_cyl1_mask_string
#define mask_setting mccchannel_13_cave2_cyl1_mask_setting
#define number_of_activations mccchannel_13_cave2_cyl1_number_of_activations
#line 185 "Union_cylinder.comp"
{
// Initializes the focusing system for this volume including input sanitation.
focus_initialize(&this_cylinder_volume.geometry, POS_A_COMP_INDEX(INDEX_CURRENT_COMP+target_index), POS_A_CURRENT_COMP, ROT_A_CURRENT_COMP, target_index, target_x, target_y, target_z, focus_aw, focus_ah, focus_xw, focus_xh, focus_r, NAME_CURRENT_COMP);

// Input sanitation for this geometry
if (radius <= 0) {
  printf("\nERROR in Union_cylinder named %s, the radius is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}

if (yheight <= 0) {
  printf("\nERROR in Union_cylinder named %s, yheight is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}

// Use sanitation
#ifdef MATERIAL_DETECTOR
if (global_material_list.num_elements == 0) {
  // Here if the user have defined a material, but only after this material
  printf("\nERROR: Need to define a material using Union_make_material before using a Union geometry component. \n");
  printf("       %s was defined before first use of Union_make_material.\n",NAME_CURRENT_COMP);
  exit(1);
}
#endif
#ifndef MATERIAL_DETECTOR
  printf("\nERROR: Need to define a material using Union_make_material before using a Union geometry component. \n");
  exit(1);
#endif


this_cylinder_volume.geometry.is_masked_volume = 0;
this_cylinder_volume.geometry.is_exit_volume = 0;
this_cylinder_volume.geometry.is_mask_volume = 0;

// Read the material input, or if it lacks, use automatic linking.
if (mask_string && strlen(mask_string) && strcmp(mask_string, "NULL") && strcmp(mask_string, "0")) {
    // A mask volume is used to limit the extend of other volumes, called the masked volumes. These are specified in the mask_string.
    // In order for a ray to enter a masked volume, it needs to be both in the region covered by that volume AND the mask volume.
    // When more than
    this_cylinder_volume.geometry.mask_mode = 1; // Default is mask mode is ALL
    if (mask_setting && strlen(mask_setting) && strcmp(mask_setting, "NULL") && strcmp(mask_setting, "0")) {
        if (strcmp(mask_setting,"ALL") == 0 || strcmp(mask_setting,"All") == 0) this_cylinder_volume.geometry.mask_mode = 1;
        else if (strcmp(mask_setting,"ANY") == 0 || strcmp(mask_setting,"Any") == 0) this_cylinder_volume.geometry.mask_mode = 2;
        else {
            printf("The mask_mode of component %s is set to %s, but must be either ALL or ANY.\n",NAME_CURRENT_COMP,mask_setting);
            exit(1);
        }
    }
    
    for (loop_index=0;loop_index<global_geometry_list.num_elements;loop_index++) {
        // Add mask list
        if (1 == manual_linking_function(global_geometry_list.elements[loop_index].name,mask_string)) {
            add_element_to_int_list(&this_cylinder_volume.geometry.mask_list,global_geometry_list.elements[loop_index].component_index);
            add_element_to_int_list(&global_geometry_list.elements[loop_index].Volume->geometry.masked_by_list,INDEX_CURRENT_COMP);
            global_geometry_list.elements[loop_index].Volume->geometry.is_masked_volume = 1;
            if (this_cylinder_volume.geometry.mask_mode == 2)
                global_geometry_list.elements[loop_index].Volume->geometry.mask_mode = 2;
            if (this_cylinder_volume.geometry.mask_mode == 1) {
                if (global_geometry_list.elements[loop_index].Volume->geometry.is_masked_volume == 1 && global_geometry_list.elements[loop_index].Volume->geometry.mask_mode != 2)
                    // If more than one mask is added to one volume, the ANY mode overwrites the (default) ALL mode.
                    global_geometry_list.elements[loop_index].Volume->geometry.mask_mode = 1;
            }
            
            found_geometries = 1;
        }
    }
    if (found_geometries == 0) {
        printf("The mask_string in geometry: %s did not find any of the specified volumes in the mask_string %s \n",NAME_CURRENT_COMP,mask_string);
        exit(1);
    }
    this_cylinder_volume.p_physics = malloc(sizeof(struct physics_struct));
    this_cylinder_volume.p_physics->is_vacuum = 0; // Makes this volume a vacuum
    this_cylinder_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
    this_cylinder_volume.p_physics->my_a = 0; // Should not be used.
    sprintf(this_cylinder_volume.p_physics->name,"Mask");
    this_cylinder_volume.geometry.is_mask_volume = 1;
    
    
// Read the material input, or if it lacks, use automatic linking.
} else if (material_string && strlen(material_string) && strcmp(material_string, "NULL") && strcmp(material_string, "0")) {
    // A geometry string was given, use it to determine which material
    if (0 == strcmp(material_string,"vacuum") || 0 == strcmp(material_string,"Vacuum")) {
        // One could have a global physics struct for vacuum instead of creating one for each
        this_cylinder_volume.p_physics = malloc(sizeof(struct physics_struct));
        this_cylinder_volume.p_physics->is_vacuum = 1; // Makes this volume a vacuum
        this_cylinder_volume.p_physics->number_of_processes = (int) 0;
        this_cylinder_volume.p_physics->my_a = 0; // Should not be used.
        sprintf(this_cylinder_volume.p_physics->name,"Vacuum");
    } else if (0 == strcmp(material_string,"exit") || 0 == strcmp(material_string,"Exit")) {
        // One could have a global physics struct for exit instead of creating one for each
        this_cylinder_volume.p_physics = malloc(sizeof(struct physics_struct));
        this_cylinder_volume.p_physics->is_vacuum = 1; // Makes this volume a vacuum
        this_cylinder_volume.p_physics->number_of_processes = (int) 0;
        this_cylinder_volume.p_physics->my_a = 0; // Should not be used.
        this_cylinder_volume.geometry.is_exit_volume = 1;
        sprintf(this_cylinder_volume.p_physics->name,"Exit");
    } else {
        for (loop_index=0;loop_index<global_material_list.num_elements;loop_index++) {
          if (0 == strcmp(material_string,global_material_list.elements[loop_index].name)) {
            this_cylinder_volume.p_physics = global_material_list.elements[loop_index].physics;
            break;
          }
          if (loop_index == global_material_list.num_elements-1) {
            printf("\n");
            printf("ERROR: The material string \"%s\" in Union geometry \"%s\" did not match a specified material. \n",material_string,NAME_CURRENT_COMP);
            printf("       The materials available at this point (need to be defined before the geometry): \n");
            for (loop_index=0;loop_index<global_material_list.num_elements;loop_index++)
              printf("         %s\n",global_material_list.elements[loop_index].name);
            printf("\n");
            printf("       It is also possible to use one of the defualt materials avaiable: \n");
            printf("           Vacuum (for a Volume without scattering or absorption)\n");
            printf("           Exit (for a Volume where the ray exits the component if it enters)\n");
            printf("           Mask (for a Volume that masks existing volumes specified in the mask_string\n");
            exit(1);
          }
        }
    }
} else {
    // Automatic linking, simply using the last defined material.
    #ifndef MATERIAL_DETECTOR
        printf("Need to define a material before the geometry to use automatic linking %s.\n",NAME_CURRENT_COMP);
        exit(1);
    #endif
    this_cylinder_volume.p_physics = global_material_list.elements[global_material_list.num_elements-1].physics;
}

sprintf(this_cylinder_volume.name,NAME_CURRENT_COMP);
sprintf(this_cylinder_volume.geometry.shape,"cylinder");
this_cylinder_volume.geometry.priority_value = priority;
// Currently the coordinates will be in absolute space.
this_cylinder_volume.geometry.center = POS_A_CURRENT_COMP;

this_cylinder_volume.geometry.geometry_p_interact = p_interact;
this_cylinder_storage.cyl_radius = radius;
this_cylinder_storage.height = yheight;
this_cylinder_volume.geometry.visualization_on = visualize;
this_cylinder_volume.geometry.geometry_parameters.p_cylinder_storage = &this_cylinder_storage;
this_cylinder_volume.geometry.within_function = &r_within_cylinder;
this_cylinder_volume.geometry.intersect_function = &sample_cylinder_intersect;
this_cylinder_volume.geometry.mcdisplay_function = &mcdisplay_cylinder_function;
this_cylinder_volume.geometry.shell_points = &cylinder_shell_points;
this_cylinder_volume.geometry.initialize_from_main_function = &initialize_cylinder_geometry_from_main_component;
this_cylinder_volume.geometry.process_rot_allocated = 0;
this_cylinder_volume.geometry.copy_geometry_parameters = &allocate_cylinder_storage_copy;

rot_copy(this_cylinder_volume.geometry.rotation_matrix,ROT_A_CURRENT_COMP);
rot_transpose(ROT_A_CURRENT_COMP,this_cylinder_volume.geometry.transpose_rotation_matrix);

// Initialize loggers
this_cylinder_volume.loggers.num_elements = 0;

// packing the information into the global_geometry_element, which is then included in the global_geometry_list.
sprintf(global_geometry_element.name,NAME_CURRENT_COMP);
global_geometry_element.activation_counter = number_of_activations;
global_geometry_element.component_index = INDEX_CURRENT_COMP;
global_geometry_element.Volume = &this_cylinder_volume; // Would be nicer if this m was a pointer, now we have the (small) data two places
add_element_to_geometry_list(&global_geometry_list,global_geometry_element);
}
#line 285128 "MACS_sample_kidney_box.c"
#undef number_of_activations
#undef mask_setting
#undef mask_string
#undef p_interact
#undef focus_r
#undef focus_xh
#undef focus_xw
#undef focus_ah
#undef focus_aw
#undef target_z
#undef target_y
#undef target_x
#undef target_index
#undef visualize
#undef yheight
#undef radius
#undef priority
#undef material_string
#undef this_cylinder_storage
#undef global_geometry_element
#undef this_cylinder_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

  /* Initializations for component channel_13_cave2_box1. */
  SIG_MESSAGE("channel_13_cave2_box1 (Init)");
#define mccompcurname  channel_13_cave2_box1
#define mccompcurtype  Union_box
#define mccompcurindex 645
#define loop_index mccchannel_13_cave2_box1_loop_index
#define this_box_volume mccchannel_13_cave2_box1_this_box_volume
#define global_geometry_element mccchannel_13_cave2_box1_global_geometry_element
#define this_box_storage mccchannel_13_cave2_box1_this_box_storage
#define material_string mccchannel_13_cave2_box1_material_string
#define priority mccchannel_13_cave2_box1_priority
#define xwidth mccchannel_13_cave2_box1_xwidth
#define yheight mccchannel_13_cave2_box1_yheight
#define zdepth mccchannel_13_cave2_box1_zdepth
#define xwidth2 mccchannel_13_cave2_box1_xwidth2
#define yheight2 mccchannel_13_cave2_box1_yheight2
#define visualize mccchannel_13_cave2_box1_visualize
#define target_index mccchannel_13_cave2_box1_target_index
#define target_x mccchannel_13_cave2_box1_target_x
#define target_y mccchannel_13_cave2_box1_target_y
#define target_z mccchannel_13_cave2_box1_target_z
#define focus_aw mccchannel_13_cave2_box1_focus_aw
#define focus_ah mccchannel_13_cave2_box1_focus_ah
#define focus_xw mccchannel_13_cave2_box1_focus_xw
#define focus_xh mccchannel_13_cave2_box1_focus_xh
#define focus_r mccchannel_13_cave2_box1_focus_r
#define p_interact mccchannel_13_cave2_box1_p_interact
#define mask_string mccchannel_13_cave2_box1_mask_string
#define mask_setting mccchannel_13_cave2_box1_mask_setting
#define number_of_activations mccchannel_13_cave2_box1_number_of_activations
#line 224 "Union_box.comp"
{
// Initializes the focusing system for this volume including input sanitation.
focus_initialize(&this_box_volume.geometry, POS_A_COMP_INDEX(INDEX_CURRENT_COMP+target_index), POS_A_CURRENT_COMP, ROT_A_CURRENT_COMP, target_index, target_x, target_y, target_z, focus_aw, focus_ah, focus_xw, focus_xh, focus_r, NAME_CURRENT_COMP);

// Input sanitation for this geometry
if (xwidth <= 0) {
  printf("\nERROR in Union_box named %s, the xwidth is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (yheight <= 0) {
  printf("\nERROR in Union_box named %s, yheight is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (zdepth <= 0) {
  printf("\nERROR in Union_box named %s, zdepth is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (xwidth2 <= 0 && xwidth2 != -1) {
  printf("\nERROR in Union_box named %s, the xwidth2 is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (yheight2 <= 0 && yheight2 != -1) {
  printf("\nERROR in Union_box named %s, yheight2 is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}

// Use sanitation
if (global_material_list.num_elements == 0) {
  printf("\nERROR: Need to define a material using Union_make_material before using a Union geometry component. \n");
  printf("       %s was defined before first use of Union_make_material.\n",NAME_CURRENT_COMP);
  exit(1);
}

this_box_volume.geometry.is_masked_volume = 0;
this_box_volume.geometry.is_exit_volume = 0;
this_box_volume.geometry.is_mask_volume = 0;
// check if the volume is a mask, if it is the material string is irelevant.
if (mask_string && strlen(mask_string) && strcmp(mask_string, "NULL") && strcmp(mask_string, "0")) {
    // A mask volume is used to limit the extend of other volumes, called the masked volumes. These are specified in the mask_string.
    // In order for a ray to enter a masked volume, it needs to be both in the region covered by that volume AND the mask volume.
    // When more than
    this_box_volume.geometry.mask_mode = 1; // Default is mask mode is ALL
    if (mask_setting && strlen(mask_setting) && strcmp(mask_setting, "NULL") && strcmp(mask_setting, "0")) {
        if (strcmp(mask_setting,"ALL") == 0 || strcmp(mask_setting,"All") == 0) this_box_volume.geometry.mask_mode = 1;
        else if (strcmp(mask_setting,"ANY") == 0 || strcmp(mask_setting,"Any") == 0) this_box_volume.geometry.mask_mode = 2;
        else {
            printf("The mask_mode of component %s is set to %s, but must be either ALL or ANY.\n",NAME_CURRENT_COMP,mask_setting);
            exit(1);
        }
    }
    
    for (loop_index=0;loop_index<global_geometry_list.num_elements;loop_index++) {
        // Add mask list
        if (1 == manual_linking_function(global_geometry_list.elements[loop_index].name,mask_string)) {
            add_element_to_int_list(&this_box_volume.geometry.mask_list,global_geometry_list.elements[loop_index].component_index);
            add_element_to_int_list(&global_geometry_list.elements[loop_index].Volume->geometry.masked_by_list,INDEX_CURRENT_COMP);
            global_geometry_list.elements[loop_index].Volume->geometry.is_masked_volume = 1;
            if (this_box_volume.geometry.mask_mode == 2)
                global_geometry_list.elements[loop_index].Volume->geometry.mask_mode = 2;
            if (this_box_volume.geometry.mask_mode == 1) {
                if (global_geometry_list.elements[loop_index].Volume->geometry.is_masked_volume == 1 && global_geometry_list.elements[loop_index].Volume->geometry.mask_mode != 2)
                    // If more than one mask is added to one volume, the ANY mode overwrites the (default) ALL mode.
                    global_geometry_list.elements[loop_index].Volume->geometry.mask_mode = 1;
            }
            
            found_geometries = 1;
        }
    }
    if (found_geometries == 0) {
        printf("The mask_string in geometry: %s did not find any of the specified volumes in the mask_string %s \n",NAME_CURRENT_COMP,mask_string);
        exit(1);
    }
    this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
    this_box_volume.p_physics->is_vacuum = 0; // Makes this volume a vacuum
    this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
    this_box_volume.p_physics->my_a = 0; // Should not be used.
    sprintf(this_box_volume.p_physics->name,"Mask");
    this_box_volume.geometry.is_mask_volume = 1;
    
    
// Read the material input, or if it lacks, use automatic linking.
} else if (material_string && strlen(material_string) && strcmp(material_string, "NULL") && strcmp(material_string, "0")) {
    // A geometry string was given, use it to determine which material
    if (0 == strcmp(material_string,"vacuum") || 0 == strcmp(material_string,"Vacuum")) {
        // One could have a global physics struct for vacuum instead of creating one for each
        this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
        this_box_volume.p_physics->is_vacuum = 1; // Makes this volume a vacuum
        this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
        this_box_volume.p_physics->my_a = 0; // Should not be used.
        sprintf(this_box_volume.p_physics->name,"Vacuum");
    } else if (0 == strcmp(material_string,"exit") || 0 == strcmp(material_string,"Exit")) {
        // One could have a global physics struct for vacuum instead of creating one for each
        this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
        this_box_volume.p_physics->is_vacuum = 1; // Makes this volume a vacuum
        this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
        this_box_volume.p_physics->my_a = 0; // Should not be used.
        this_box_volume.geometry.is_exit_volume = 1;
        sprintf(this_box_volume.p_physics->name,"Exit");
    } else {
        #ifndef MATERIAL_DETECTOR
            printf("Need to define a material before refering to it in a geometry %s.\n",NAME_CURRENT_COMP);
            exit(1);
        #endif
        for (loop_index=0;loop_index<global_material_list.num_elements;loop_index++) {
            if (0 == strcmp(material_string,global_material_list.elements[loop_index].name)) {
                this_box_volume.p_physics = global_material_list.elements[loop_index].physics;
                break;
            }
            if (loop_index == global_material_list.num_elements-1) {
            printf("\n");
            printf("ERROR: The material string \"%s\" in Union geometry \"%s\" did not match a specified material. \n",material_string,NAME_CURRENT_COMP);
            printf("       The materials available at this point (need to be defined before the geometry): \n");
            for (loop_index=0;loop_index<global_material_list.num_elements;loop_index++)
              printf("         %s\n",global_material_list.elements[loop_index].name);
            printf("\n");
            printf("       It is also possible to use one of the defualt materials avaiable: \n");
            printf("           Vacuum (for a Volume without scattering or absorption)\n");
            printf("           Exit (for a Volume where the ray exits the component if it enters)\n");
            printf("           Mask (for a Volume that masks existing volumes specified in the mask_string\n");
            exit(1);
          }
        }
    }
} else {
    // Automatic linking, simply using the last defined material.
    #ifndef MATERIAL_DETECTOR
        printf("Need to define a material before the geometry to use automatic linking %s.\n",NAME_CURRENT_COMP);
        exit(1);
    #endif
    this_box_volume.p_physics = global_material_list.elements[global_material_list.num_elements-1].physics;
}

sprintf(this_box_volume.name,NAME_CURRENT_COMP);
sprintf(this_box_volume.geometry.shape,"box");
this_box_volume.geometry.priority_value = priority;
this_box_volume.geometry.geometry_p_interact = p_interact;
// Currently the coordinates will be in absolute space.
this_box_volume.geometry.center = POS_A_CURRENT_COMP;

this_box_storage.z_depth = zdepth;
this_box_storage.x_width1 = xwidth;
this_box_storage.y_height1 = yheight;

this_box_storage.is_rectangle = 0;
if (xwidth2 < 0 && yheight2 < 0) this_box_storage.is_rectangle = 1;
if (xwidth == xwidth2 && yheight == yheight2) this_box_storage.is_rectangle = 1;

if (xwidth2 < 0) {
    this_box_storage.x_width2 = xwidth;
    xwidth2 = xwidth;
} else this_box_storage.x_width2 = xwidth2;

if (yheight2 < 0) {
    this_box_storage.y_height2 = yheight;
    yheight2 = yheight;
} else this_box_storage.y_height2 = yheight2;


this_box_storage.normal_vectors[0] = coords_set(0,0,1);
this_box_storage.normal_vectors[1] = coords_set(0,0,1);

// for sides with y component = 0
x_component = 2*zdepth/sqrt((xwidth-xwidth2)*(xwidth-xwidth2)+4*zdepth*zdepth);
z_component = (xwidth-xwidth2)/sqrt(4*zdepth*zdepth+(xwidth-xwidth2)*(xwidth-xwidth2));

this_box_storage.normal_vectors[2] = coords_set(x_component,0,z_component);
this_box_storage.normal_vectors[3] = coords_set(-x_component,0,z_component);

// for sides with x component = 0
y_component = 2*zdepth/sqrt((yheight-yheight2)*(yheight-yheight2)+4*zdepth*zdepth);
z_component = (yheight-yheight2)/sqrt(4*zdepth*zdepth+(yheight-yheight2)*(yheight-yheight2));

this_box_storage.normal_vectors[4] = coords_set(0,y_component,z_component);
this_box_storage.normal_vectors[5] = coords_set(0,-y_component,z_component);

this_box_volume.geometry.visualization_on = visualize;

this_box_volume.geometry.geometry_parameters.p_box_storage = &this_box_storage;

// Assign pointers to functions for intersection with the shape, checking if a point is inside the shape
if (this_box_storage.is_rectangle == 1) {
this_box_volume.geometry.intersect_function = &sample_box_intersect_simple;
this_box_volume.geometry.within_function = &r_within_box_simple;
}
else {
this_box_volume.geometry.intersect_function = &sample_box_intersect_advanced;
this_box_volume.geometry.within_function = &r_within_box_advanced;
}

this_box_volume.geometry.shell_points = &box_shell_points;
this_box_volume.geometry.mcdisplay_function = &mcdisplay_box_function;
this_box_volume.geometry.initialize_from_main_function = &initialize_box_geometry_from_main_component;
this_box_volume.geometry.process_rot_allocated = 0;

this_box_volume.geometry.copy_geometry_parameters = &allocate_box_storage_copy;

rot_copy(this_box_volume.geometry.rotation_matrix,ROT_A_CURRENT_COMP); //check how ROT_R_CURRENT_COMP would work
rot_transpose(ROT_A_CURRENT_COMP,this_box_volume.geometry.transpose_rotation_matrix);

// Initialize loggers
this_box_volume.loggers.num_elements = 0;

// packing the information into the global_geometry_element, which is then included in the global_geometry_list.
sprintf(global_geometry_element.name,NAME_CURRENT_COMP);
global_geometry_element.activation_counter = number_of_activations;
global_geometry_element.component_index = INDEX_CURRENT_COMP;
global_geometry_element.Volume = &this_box_volume; // Would be nicer if this m was a pointer, now we have the (small) data two places
add_element_to_geometry_list(&global_geometry_list,global_geometry_element);
}
#line 285395 "MACS_sample_kidney_box.c"
#undef number_of_activations
#undef mask_setting
#undef mask_string
#undef p_interact
#undef focus_r
#undef focus_xh
#undef focus_xw
#undef focus_ah
#undef focus_aw
#undef target_z
#undef target_y
#undef target_x
#undef target_index
#undef visualize
#undef yheight2
#undef xwidth2
#undef zdepth
#undef yheight
#undef xwidth
#undef priority
#undef material_string
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

  /* Initializations for component channel_13_cave2_box2. */
  SIG_MESSAGE("channel_13_cave2_box2 (Init)");
#define mccompcurname  channel_13_cave2_box2
#define mccompcurtype  Union_box
#define mccompcurindex 646
#define loop_index mccchannel_13_cave2_box2_loop_index
#define this_box_volume mccchannel_13_cave2_box2_this_box_volume
#define global_geometry_element mccchannel_13_cave2_box2_global_geometry_element
#define this_box_storage mccchannel_13_cave2_box2_this_box_storage
#define material_string mccchannel_13_cave2_box2_material_string
#define priority mccchannel_13_cave2_box2_priority
#define xwidth mccchannel_13_cave2_box2_xwidth
#define yheight mccchannel_13_cave2_box2_yheight
#define zdepth mccchannel_13_cave2_box2_zdepth
#define xwidth2 mccchannel_13_cave2_box2_xwidth2
#define yheight2 mccchannel_13_cave2_box2_yheight2
#define visualize mccchannel_13_cave2_box2_visualize
#define target_index mccchannel_13_cave2_box2_target_index
#define target_x mccchannel_13_cave2_box2_target_x
#define target_y mccchannel_13_cave2_box2_target_y
#define target_z mccchannel_13_cave2_box2_target_z
#define focus_aw mccchannel_13_cave2_box2_focus_aw
#define focus_ah mccchannel_13_cave2_box2_focus_ah
#define focus_xw mccchannel_13_cave2_box2_focus_xw
#define focus_xh mccchannel_13_cave2_box2_focus_xh
#define focus_r mccchannel_13_cave2_box2_focus_r
#define p_interact mccchannel_13_cave2_box2_p_interact
#define mask_string mccchannel_13_cave2_box2_mask_string
#define mask_setting mccchannel_13_cave2_box2_mask_setting
#define number_of_activations mccchannel_13_cave2_box2_number_of_activations
#line 224 "Union_box.comp"
{
// Initializes the focusing system for this volume including input sanitation.
focus_initialize(&this_box_volume.geometry, POS_A_COMP_INDEX(INDEX_CURRENT_COMP+target_index), POS_A_CURRENT_COMP, ROT_A_CURRENT_COMP, target_index, target_x, target_y, target_z, focus_aw, focus_ah, focus_xw, focus_xh, focus_r, NAME_CURRENT_COMP);

// Input sanitation for this geometry
if (xwidth <= 0) {
  printf("\nERROR in Union_box named %s, the xwidth is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (yheight <= 0) {
  printf("\nERROR in Union_box named %s, yheight is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (zdepth <= 0) {
  printf("\nERROR in Union_box named %s, zdepth is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (xwidth2 <= 0 && xwidth2 != -1) {
  printf("\nERROR in Union_box named %s, the xwidth2 is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (yheight2 <= 0 && yheight2 != -1) {
  printf("\nERROR in Union_box named %s, yheight2 is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}

// Use sanitation
if (global_material_list.num_elements == 0) {
  printf("\nERROR: Need to define a material using Union_make_material before using a Union geometry component. \n");
  printf("       %s was defined before first use of Union_make_material.\n",NAME_CURRENT_COMP);
  exit(1);
}

this_box_volume.geometry.is_masked_volume = 0;
this_box_volume.geometry.is_exit_volume = 0;
this_box_volume.geometry.is_mask_volume = 0;
// check if the volume is a mask, if it is the material string is irelevant.
if (mask_string && strlen(mask_string) && strcmp(mask_string, "NULL") && strcmp(mask_string, "0")) {
    // A mask volume is used to limit the extend of other volumes, called the masked volumes. These are specified in the mask_string.
    // In order for a ray to enter a masked volume, it needs to be both in the region covered by that volume AND the mask volume.
    // When more than
    this_box_volume.geometry.mask_mode = 1; // Default is mask mode is ALL
    if (mask_setting && strlen(mask_setting) && strcmp(mask_setting, "NULL") && strcmp(mask_setting, "0")) {
        if (strcmp(mask_setting,"ALL") == 0 || strcmp(mask_setting,"All") == 0) this_box_volume.geometry.mask_mode = 1;
        else if (strcmp(mask_setting,"ANY") == 0 || strcmp(mask_setting,"Any") == 0) this_box_volume.geometry.mask_mode = 2;
        else {
            printf("The mask_mode of component %s is set to %s, but must be either ALL or ANY.\n",NAME_CURRENT_COMP,mask_setting);
            exit(1);
        }
    }
    
    for (loop_index=0;loop_index<global_geometry_list.num_elements;loop_index++) {
        // Add mask list
        if (1 == manual_linking_function(global_geometry_list.elements[loop_index].name,mask_string)) {
            add_element_to_int_list(&this_box_volume.geometry.mask_list,global_geometry_list.elements[loop_index].component_index);
            add_element_to_int_list(&global_geometry_list.elements[loop_index].Volume->geometry.masked_by_list,INDEX_CURRENT_COMP);
            global_geometry_list.elements[loop_index].Volume->geometry.is_masked_volume = 1;
            if (this_box_volume.geometry.mask_mode == 2)
                global_geometry_list.elements[loop_index].Volume->geometry.mask_mode = 2;
            if (this_box_volume.geometry.mask_mode == 1) {
                if (global_geometry_list.elements[loop_index].Volume->geometry.is_masked_volume == 1 && global_geometry_list.elements[loop_index].Volume->geometry.mask_mode != 2)
                    // If more than one mask is added to one volume, the ANY mode overwrites the (default) ALL mode.
                    global_geometry_list.elements[loop_index].Volume->geometry.mask_mode = 1;
            }
            
            found_geometries = 1;
        }
    }
    if (found_geometries == 0) {
        printf("The mask_string in geometry: %s did not find any of the specified volumes in the mask_string %s \n",NAME_CURRENT_COMP,mask_string);
        exit(1);
    }
    this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
    this_box_volume.p_physics->is_vacuum = 0; // Makes this volume a vacuum
    this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
    this_box_volume.p_physics->my_a = 0; // Should not be used.
    sprintf(this_box_volume.p_physics->name,"Mask");
    this_box_volume.geometry.is_mask_volume = 1;
    
    
// Read the material input, or if it lacks, use automatic linking.
} else if (material_string && strlen(material_string) && strcmp(material_string, "NULL") && strcmp(material_string, "0")) {
    // A geometry string was given, use it to determine which material
    if (0 == strcmp(material_string,"vacuum") || 0 == strcmp(material_string,"Vacuum")) {
        // One could have a global physics struct for vacuum instead of creating one for each
        this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
        this_box_volume.p_physics->is_vacuum = 1; // Makes this volume a vacuum
        this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
        this_box_volume.p_physics->my_a = 0; // Should not be used.
        sprintf(this_box_volume.p_physics->name,"Vacuum");
    } else if (0 == strcmp(material_string,"exit") || 0 == strcmp(material_string,"Exit")) {
        // One could have a global physics struct for vacuum instead of creating one for each
        this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
        this_box_volume.p_physics->is_vacuum = 1; // Makes this volume a vacuum
        this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
        this_box_volume.p_physics->my_a = 0; // Should not be used.
        this_box_volume.geometry.is_exit_volume = 1;
        sprintf(this_box_volume.p_physics->name,"Exit");
    } else {
        #ifndef MATERIAL_DETECTOR
            printf("Need to define a material before refering to it in a geometry %s.\n",NAME_CURRENT_COMP);
            exit(1);
        #endif
        for (loop_index=0;loop_index<global_material_list.num_elements;loop_index++) {
            if (0 == strcmp(material_string,global_material_list.elements[loop_index].name)) {
                this_box_volume.p_physics = global_material_list.elements[loop_index].physics;
                break;
            }
            if (loop_index == global_material_list.num_elements-1) {
            printf("\n");
            printf("ERROR: The material string \"%s\" in Union geometry \"%s\" did not match a specified material. \n",material_string,NAME_CURRENT_COMP);
            printf("       The materials available at this point (need to be defined before the geometry): \n");
            for (loop_index=0;loop_index<global_material_list.num_elements;loop_index++)
              printf("         %s\n",global_material_list.elements[loop_index].name);
            printf("\n");
            printf("       It is also possible to use one of the defualt materials avaiable: \n");
            printf("           Vacuum (for a Volume without scattering or absorption)\n");
            printf("           Exit (for a Volume where the ray exits the component if it enters)\n");
            printf("           Mask (for a Volume that masks existing volumes specified in the mask_string\n");
            exit(1);
          }
        }
    }
} else {
    // Automatic linking, simply using the last defined material.
    #ifndef MATERIAL_DETECTOR
        printf("Need to define a material before the geometry to use automatic linking %s.\n",NAME_CURRENT_COMP);
        exit(1);
    #endif
    this_box_volume.p_physics = global_material_list.elements[global_material_list.num_elements-1].physics;
}

sprintf(this_box_volume.name,NAME_CURRENT_COMP);
sprintf(this_box_volume.geometry.shape,"box");
this_box_volume.geometry.priority_value = priority;
this_box_volume.geometry.geometry_p_interact = p_interact;
// Currently the coordinates will be in absolute space.
this_box_volume.geometry.center = POS_A_CURRENT_COMP;

this_box_storage.z_depth = zdepth;
this_box_storage.x_width1 = xwidth;
this_box_storage.y_height1 = yheight;

this_box_storage.is_rectangle = 0;
if (xwidth2 < 0 && yheight2 < 0) this_box_storage.is_rectangle = 1;
if (xwidth == xwidth2 && yheight == yheight2) this_box_storage.is_rectangle = 1;

if (xwidth2 < 0) {
    this_box_storage.x_width2 = xwidth;
    xwidth2 = xwidth;
} else this_box_storage.x_width2 = xwidth2;

if (yheight2 < 0) {
    this_box_storage.y_height2 = yheight;
    yheight2 = yheight;
} else this_box_storage.y_height2 = yheight2;


this_box_storage.normal_vectors[0] = coords_set(0,0,1);
this_box_storage.normal_vectors[1] = coords_set(0,0,1);

// for sides with y component = 0
x_component = 2*zdepth/sqrt((xwidth-xwidth2)*(xwidth-xwidth2)+4*zdepth*zdepth);
z_component = (xwidth-xwidth2)/sqrt(4*zdepth*zdepth+(xwidth-xwidth2)*(xwidth-xwidth2));

this_box_storage.normal_vectors[2] = coords_set(x_component,0,z_component);
this_box_storage.normal_vectors[3] = coords_set(-x_component,0,z_component);

// for sides with x component = 0
y_component = 2*zdepth/sqrt((yheight-yheight2)*(yheight-yheight2)+4*zdepth*zdepth);
z_component = (yheight-yheight2)/sqrt(4*zdepth*zdepth+(yheight-yheight2)*(yheight-yheight2));

this_box_storage.normal_vectors[4] = coords_set(0,y_component,z_component);
this_box_storage.normal_vectors[5] = coords_set(0,-y_component,z_component);

this_box_volume.geometry.visualization_on = visualize;

this_box_volume.geometry.geometry_parameters.p_box_storage = &this_box_storage;

// Assign pointers to functions for intersection with the shape, checking if a point is inside the shape
if (this_box_storage.is_rectangle == 1) {
this_box_volume.geometry.intersect_function = &sample_box_intersect_simple;
this_box_volume.geometry.within_function = &r_within_box_simple;
}
else {
this_box_volume.geometry.intersect_function = &sample_box_intersect_advanced;
this_box_volume.geometry.within_function = &r_within_box_advanced;
}

this_box_volume.geometry.shell_points = &box_shell_points;
this_box_volume.geometry.mcdisplay_function = &mcdisplay_box_function;
this_box_volume.geometry.initialize_from_main_function = &initialize_box_geometry_from_main_component;
this_box_volume.geometry.process_rot_allocated = 0;

this_box_volume.geometry.copy_geometry_parameters = &allocate_box_storage_copy;

rot_copy(this_box_volume.geometry.rotation_matrix,ROT_A_CURRENT_COMP); //check how ROT_R_CURRENT_COMP would work
rot_transpose(ROT_A_CURRENT_COMP,this_box_volume.geometry.transpose_rotation_matrix);

// Initialize loggers
this_box_volume.loggers.num_elements = 0;

// packing the information into the global_geometry_element, which is then included in the global_geometry_list.
sprintf(global_geometry_element.name,NAME_CURRENT_COMP);
global_geometry_element.activation_counter = number_of_activations;
global_geometry_element.component_index = INDEX_CURRENT_COMP;
global_geometry_element.Volume = &this_box_volume; // Would be nicer if this m was a pointer, now we have the (small) data two places
add_element_to_geometry_list(&global_geometry_list,global_geometry_element);
}
#line 285665 "MACS_sample_kidney_box.c"
#undef number_of_activations
#undef mask_setting
#undef mask_string
#undef p_interact
#undef focus_r
#undef focus_xh
#undef focus_xw
#undef focus_ah
#undef focus_aw
#undef target_z
#undef target_y
#undef target_x
#undef target_index
#undef visualize
#undef yheight2
#undef xwidth2
#undef zdepth
#undef yheight
#undef xwidth
#undef priority
#undef material_string
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

  /* Initializations for component channel_13_cave2_box3. */
  SIG_MESSAGE("channel_13_cave2_box3 (Init)");
#define mccompcurname  channel_13_cave2_box3
#define mccompcurtype  Union_box
#define mccompcurindex 647
#define loop_index mccchannel_13_cave2_box3_loop_index
#define this_box_volume mccchannel_13_cave2_box3_this_box_volume
#define global_geometry_element mccchannel_13_cave2_box3_global_geometry_element
#define this_box_storage mccchannel_13_cave2_box3_this_box_storage
#define material_string mccchannel_13_cave2_box3_material_string
#define priority mccchannel_13_cave2_box3_priority
#define xwidth mccchannel_13_cave2_box3_xwidth
#define yheight mccchannel_13_cave2_box3_yheight
#define zdepth mccchannel_13_cave2_box3_zdepth
#define xwidth2 mccchannel_13_cave2_box3_xwidth2
#define yheight2 mccchannel_13_cave2_box3_yheight2
#define visualize mccchannel_13_cave2_box3_visualize
#define target_index mccchannel_13_cave2_box3_target_index
#define target_x mccchannel_13_cave2_box3_target_x
#define target_y mccchannel_13_cave2_box3_target_y
#define target_z mccchannel_13_cave2_box3_target_z
#define focus_aw mccchannel_13_cave2_box3_focus_aw
#define focus_ah mccchannel_13_cave2_box3_focus_ah
#define focus_xw mccchannel_13_cave2_box3_focus_xw
#define focus_xh mccchannel_13_cave2_box3_focus_xh
#define focus_r mccchannel_13_cave2_box3_focus_r
#define p_interact mccchannel_13_cave2_box3_p_interact
#define mask_string mccchannel_13_cave2_box3_mask_string
#define mask_setting mccchannel_13_cave2_box3_mask_setting
#define number_of_activations mccchannel_13_cave2_box3_number_of_activations
#line 224 "Union_box.comp"
{
// Initializes the focusing system for this volume including input sanitation.
focus_initialize(&this_box_volume.geometry, POS_A_COMP_INDEX(INDEX_CURRENT_COMP+target_index), POS_A_CURRENT_COMP, ROT_A_CURRENT_COMP, target_index, target_x, target_y, target_z, focus_aw, focus_ah, focus_xw, focus_xh, focus_r, NAME_CURRENT_COMP);

// Input sanitation for this geometry
if (xwidth <= 0) {
  printf("\nERROR in Union_box named %s, the xwidth is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (yheight <= 0) {
  printf("\nERROR in Union_box named %s, yheight is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (zdepth <= 0) {
  printf("\nERROR in Union_box named %s, zdepth is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (xwidth2 <= 0 && xwidth2 != -1) {
  printf("\nERROR in Union_box named %s, the xwidth2 is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (yheight2 <= 0 && yheight2 != -1) {
  printf("\nERROR in Union_box named %s, yheight2 is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}

// Use sanitation
if (global_material_list.num_elements == 0) {
  printf("\nERROR: Need to define a material using Union_make_material before using a Union geometry component. \n");
  printf("       %s was defined before first use of Union_make_material.\n",NAME_CURRENT_COMP);
  exit(1);
}

this_box_volume.geometry.is_masked_volume = 0;
this_box_volume.geometry.is_exit_volume = 0;
this_box_volume.geometry.is_mask_volume = 0;
// check if the volume is a mask, if it is the material string is irelevant.
if (mask_string && strlen(mask_string) && strcmp(mask_string, "NULL") && strcmp(mask_string, "0")) {
    // A mask volume is used to limit the extend of other volumes, called the masked volumes. These are specified in the mask_string.
    // In order for a ray to enter a masked volume, it needs to be both in the region covered by that volume AND the mask volume.
    // When more than
    this_box_volume.geometry.mask_mode = 1; // Default is mask mode is ALL
    if (mask_setting && strlen(mask_setting) && strcmp(mask_setting, "NULL") && strcmp(mask_setting, "0")) {
        if (strcmp(mask_setting,"ALL") == 0 || strcmp(mask_setting,"All") == 0) this_box_volume.geometry.mask_mode = 1;
        else if (strcmp(mask_setting,"ANY") == 0 || strcmp(mask_setting,"Any") == 0) this_box_volume.geometry.mask_mode = 2;
        else {
            printf("The mask_mode of component %s is set to %s, but must be either ALL or ANY.\n",NAME_CURRENT_COMP,mask_setting);
            exit(1);
        }
    }
    
    for (loop_index=0;loop_index<global_geometry_list.num_elements;loop_index++) {
        // Add mask list
        if (1 == manual_linking_function(global_geometry_list.elements[loop_index].name,mask_string)) {
            add_element_to_int_list(&this_box_volume.geometry.mask_list,global_geometry_list.elements[loop_index].component_index);
            add_element_to_int_list(&global_geometry_list.elements[loop_index].Volume->geometry.masked_by_list,INDEX_CURRENT_COMP);
            global_geometry_list.elements[loop_index].Volume->geometry.is_masked_volume = 1;
            if (this_box_volume.geometry.mask_mode == 2)
                global_geometry_list.elements[loop_index].Volume->geometry.mask_mode = 2;
            if (this_box_volume.geometry.mask_mode == 1) {
                if (global_geometry_list.elements[loop_index].Volume->geometry.is_masked_volume == 1 && global_geometry_list.elements[loop_index].Volume->geometry.mask_mode != 2)
                    // If more than one mask is added to one volume, the ANY mode overwrites the (default) ALL mode.
                    global_geometry_list.elements[loop_index].Volume->geometry.mask_mode = 1;
            }
            
            found_geometries = 1;
        }
    }
    if (found_geometries == 0) {
        printf("The mask_string in geometry: %s did not find any of the specified volumes in the mask_string %s \n",NAME_CURRENT_COMP,mask_string);
        exit(1);
    }
    this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
    this_box_volume.p_physics->is_vacuum = 0; // Makes this volume a vacuum
    this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
    this_box_volume.p_physics->my_a = 0; // Should not be used.
    sprintf(this_box_volume.p_physics->name,"Mask");
    this_box_volume.geometry.is_mask_volume = 1;
    
    
// Read the material input, or if it lacks, use automatic linking.
} else if (material_string && strlen(material_string) && strcmp(material_string, "NULL") && strcmp(material_string, "0")) {
    // A geometry string was given, use it to determine which material
    if (0 == strcmp(material_string,"vacuum") || 0 == strcmp(material_string,"Vacuum")) {
        // One could have a global physics struct for vacuum instead of creating one for each
        this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
        this_box_volume.p_physics->is_vacuum = 1; // Makes this volume a vacuum
        this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
        this_box_volume.p_physics->my_a = 0; // Should not be used.
        sprintf(this_box_volume.p_physics->name,"Vacuum");
    } else if (0 == strcmp(material_string,"exit") || 0 == strcmp(material_string,"Exit")) {
        // One could have a global physics struct for vacuum instead of creating one for each
        this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
        this_box_volume.p_physics->is_vacuum = 1; // Makes this volume a vacuum
        this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
        this_box_volume.p_physics->my_a = 0; // Should not be used.
        this_box_volume.geometry.is_exit_volume = 1;
        sprintf(this_box_volume.p_physics->name,"Exit");
    } else {
        #ifndef MATERIAL_DETECTOR
            printf("Need to define a material before refering to it in a geometry %s.\n",NAME_CURRENT_COMP);
            exit(1);
        #endif
        for (loop_index=0;loop_index<global_material_list.num_elements;loop_index++) {
            if (0 == strcmp(material_string,global_material_list.elements[loop_index].name)) {
                this_box_volume.p_physics = global_material_list.elements[loop_index].physics;
                break;
            }
            if (loop_index == global_material_list.num_elements-1) {
            printf("\n");
            printf("ERROR: The material string \"%s\" in Union geometry \"%s\" did not match a specified material. \n",material_string,NAME_CURRENT_COMP);
            printf("       The materials available at this point (need to be defined before the geometry): \n");
            for (loop_index=0;loop_index<global_material_list.num_elements;loop_index++)
              printf("         %s\n",global_material_list.elements[loop_index].name);
            printf("\n");
            printf("       It is also possible to use one of the defualt materials avaiable: \n");
            printf("           Vacuum (for a Volume without scattering or absorption)\n");
            printf("           Exit (for a Volume where the ray exits the component if it enters)\n");
            printf("           Mask (for a Volume that masks existing volumes specified in the mask_string\n");
            exit(1);
          }
        }
    }
} else {
    // Automatic linking, simply using the last defined material.
    #ifndef MATERIAL_DETECTOR
        printf("Need to define a material before the geometry to use automatic linking %s.\n",NAME_CURRENT_COMP);
        exit(1);
    #endif
    this_box_volume.p_physics = global_material_list.elements[global_material_list.num_elements-1].physics;
}

sprintf(this_box_volume.name,NAME_CURRENT_COMP);
sprintf(this_box_volume.geometry.shape,"box");
this_box_volume.geometry.priority_value = priority;
this_box_volume.geometry.geometry_p_interact = p_interact;
// Currently the coordinates will be in absolute space.
this_box_volume.geometry.center = POS_A_CURRENT_COMP;

this_box_storage.z_depth = zdepth;
this_box_storage.x_width1 = xwidth;
this_box_storage.y_height1 = yheight;

this_box_storage.is_rectangle = 0;
if (xwidth2 < 0 && yheight2 < 0) this_box_storage.is_rectangle = 1;
if (xwidth == xwidth2 && yheight == yheight2) this_box_storage.is_rectangle = 1;

if (xwidth2 < 0) {
    this_box_storage.x_width2 = xwidth;
    xwidth2 = xwidth;
} else this_box_storage.x_width2 = xwidth2;

if (yheight2 < 0) {
    this_box_storage.y_height2 = yheight;
    yheight2 = yheight;
} else this_box_storage.y_height2 = yheight2;


this_box_storage.normal_vectors[0] = coords_set(0,0,1);
this_box_storage.normal_vectors[1] = coords_set(0,0,1);

// for sides with y component = 0
x_component = 2*zdepth/sqrt((xwidth-xwidth2)*(xwidth-xwidth2)+4*zdepth*zdepth);
z_component = (xwidth-xwidth2)/sqrt(4*zdepth*zdepth+(xwidth-xwidth2)*(xwidth-xwidth2));

this_box_storage.normal_vectors[2] = coords_set(x_component,0,z_component);
this_box_storage.normal_vectors[3] = coords_set(-x_component,0,z_component);

// for sides with x component = 0
y_component = 2*zdepth/sqrt((yheight-yheight2)*(yheight-yheight2)+4*zdepth*zdepth);
z_component = (yheight-yheight2)/sqrt(4*zdepth*zdepth+(yheight-yheight2)*(yheight-yheight2));

this_box_storage.normal_vectors[4] = coords_set(0,y_component,z_component);
this_box_storage.normal_vectors[5] = coords_set(0,-y_component,z_component);

this_box_volume.geometry.visualization_on = visualize;

this_box_volume.geometry.geometry_parameters.p_box_storage = &this_box_storage;

// Assign pointers to functions for intersection with the shape, checking if a point is inside the shape
if (this_box_storage.is_rectangle == 1) {
this_box_volume.geometry.intersect_function = &sample_box_intersect_simple;
this_box_volume.geometry.within_function = &r_within_box_simple;
}
else {
this_box_volume.geometry.intersect_function = &sample_box_intersect_advanced;
this_box_volume.geometry.within_function = &r_within_box_advanced;
}

this_box_volume.geometry.shell_points = &box_shell_points;
this_box_volume.geometry.mcdisplay_function = &mcdisplay_box_function;
this_box_volume.geometry.initialize_from_main_function = &initialize_box_geometry_from_main_component;
this_box_volume.geometry.process_rot_allocated = 0;

this_box_volume.geometry.copy_geometry_parameters = &allocate_box_storage_copy;

rot_copy(this_box_volume.geometry.rotation_matrix,ROT_A_CURRENT_COMP); //check how ROT_R_CURRENT_COMP would work
rot_transpose(ROT_A_CURRENT_COMP,this_box_volume.geometry.transpose_rotation_matrix);

// Initialize loggers
this_box_volume.loggers.num_elements = 0;

// packing the information into the global_geometry_element, which is then included in the global_geometry_list.
sprintf(global_geometry_element.name,NAME_CURRENT_COMP);
global_geometry_element.activation_counter = number_of_activations;
global_geometry_element.component_index = INDEX_CURRENT_COMP;
global_geometry_element.Volume = &this_box_volume; // Would be nicer if this m was a pointer, now we have the (small) data two places
add_element_to_geometry_list(&global_geometry_list,global_geometry_element);
}
#line 285935 "MACS_sample_kidney_box.c"
#undef number_of_activations
#undef mask_setting
#undef mask_string
#undef p_interact
#undef focus_r
#undef focus_xh
#undef focus_xw
#undef focus_ah
#undef focus_aw
#undef target_z
#undef target_y
#undef target_x
#undef target_index
#undef visualize
#undef yheight2
#undef xwidth2
#undef zdepth
#undef yheight
#undef xwidth
#undef priority
#undef material_string
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

  /* Initializations for component inter_analyzer_colimator_center_13. */
  SIG_MESSAGE("inter_analyzer_colimator_center_13 (Init)");

  /* Initializations for component inter_analyzer_colimator_13_blade_0. */
  SIG_MESSAGE("inter_analyzer_colimator_13_blade_0 (Init)");
#define mccompcurname  inter_analyzer_colimator_13_blade_0
#define mccompcurtype  Union_box
#define mccompcurindex 649
#define loop_index mccinter_analyzer_colimator_13_blade_0_loop_index
#define this_box_volume mccinter_analyzer_colimator_13_blade_0_this_box_volume
#define global_geometry_element mccinter_analyzer_colimator_13_blade_0_global_geometry_element
#define this_box_storage mccinter_analyzer_colimator_13_blade_0_this_box_storage
#define material_string mccinter_analyzer_colimator_13_blade_0_material_string
#define priority mccinter_analyzer_colimator_13_blade_0_priority
#define xwidth mccinter_analyzer_colimator_13_blade_0_xwidth
#define yheight mccinter_analyzer_colimator_13_blade_0_yheight
#define zdepth mccinter_analyzer_colimator_13_blade_0_zdepth
#define xwidth2 mccinter_analyzer_colimator_13_blade_0_xwidth2
#define yheight2 mccinter_analyzer_colimator_13_blade_0_yheight2
#define visualize mccinter_analyzer_colimator_13_blade_0_visualize
#define target_index mccinter_analyzer_colimator_13_blade_0_target_index
#define target_x mccinter_analyzer_colimator_13_blade_0_target_x
#define target_y mccinter_analyzer_colimator_13_blade_0_target_y
#define target_z mccinter_analyzer_colimator_13_blade_0_target_z
#define focus_aw mccinter_analyzer_colimator_13_blade_0_focus_aw
#define focus_ah mccinter_analyzer_colimator_13_blade_0_focus_ah
#define focus_xw mccinter_analyzer_colimator_13_blade_0_focus_xw
#define focus_xh mccinter_analyzer_colimator_13_blade_0_focus_xh
#define focus_r mccinter_analyzer_colimator_13_blade_0_focus_r
#define p_interact mccinter_analyzer_colimator_13_blade_0_p_interact
#define mask_string mccinter_analyzer_colimator_13_blade_0_mask_string
#define mask_setting mccinter_analyzer_colimator_13_blade_0_mask_setting
#define number_of_activations mccinter_analyzer_colimator_13_blade_0_number_of_activations
#line 224 "Union_box.comp"
{
// Initializes the focusing system for this volume including input sanitation.
focus_initialize(&this_box_volume.geometry, POS_A_COMP_INDEX(INDEX_CURRENT_COMP+target_index), POS_A_CURRENT_COMP, ROT_A_CURRENT_COMP, target_index, target_x, target_y, target_z, focus_aw, focus_ah, focus_xw, focus_xh, focus_r, NAME_CURRENT_COMP);

// Input sanitation for this geometry
if (xwidth <= 0) {
  printf("\nERROR in Union_box named %s, the xwidth is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (yheight <= 0) {
  printf("\nERROR in Union_box named %s, yheight is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (zdepth <= 0) {
  printf("\nERROR in Union_box named %s, zdepth is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (xwidth2 <= 0 && xwidth2 != -1) {
  printf("\nERROR in Union_box named %s, the xwidth2 is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (yheight2 <= 0 && yheight2 != -1) {
  printf("\nERROR in Union_box named %s, yheight2 is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}

// Use sanitation
if (global_material_list.num_elements == 0) {
  printf("\nERROR: Need to define a material using Union_make_material before using a Union geometry component. \n");
  printf("       %s was defined before first use of Union_make_material.\n",NAME_CURRENT_COMP);
  exit(1);
}

this_box_volume.geometry.is_masked_volume = 0;
this_box_volume.geometry.is_exit_volume = 0;
this_box_volume.geometry.is_mask_volume = 0;
// check if the volume is a mask, if it is the material string is irelevant.
if (mask_string && strlen(mask_string) && strcmp(mask_string, "NULL") && strcmp(mask_string, "0")) {
    // A mask volume is used to limit the extend of other volumes, called the masked volumes. These are specified in the mask_string.
    // In order for a ray to enter a masked volume, it needs to be both in the region covered by that volume AND the mask volume.
    // When more than
    this_box_volume.geometry.mask_mode = 1; // Default is mask mode is ALL
    if (mask_setting && strlen(mask_setting) && strcmp(mask_setting, "NULL") && strcmp(mask_setting, "0")) {
        if (strcmp(mask_setting,"ALL") == 0 || strcmp(mask_setting,"All") == 0) this_box_volume.geometry.mask_mode = 1;
        else if (strcmp(mask_setting,"ANY") == 0 || strcmp(mask_setting,"Any") == 0) this_box_volume.geometry.mask_mode = 2;
        else {
            printf("The mask_mode of component %s is set to %s, but must be either ALL or ANY.\n",NAME_CURRENT_COMP,mask_setting);
            exit(1);
        }
    }
    
    for (loop_index=0;loop_index<global_geometry_list.num_elements;loop_index++) {
        // Add mask list
        if (1 == manual_linking_function(global_geometry_list.elements[loop_index].name,mask_string)) {
            add_element_to_int_list(&this_box_volume.geometry.mask_list,global_geometry_list.elements[loop_index].component_index);
            add_element_to_int_list(&global_geometry_list.elements[loop_index].Volume->geometry.masked_by_list,INDEX_CURRENT_COMP);
            global_geometry_list.elements[loop_index].Volume->geometry.is_masked_volume = 1;
            if (this_box_volume.geometry.mask_mode == 2)
                global_geometry_list.elements[loop_index].Volume->geometry.mask_mode = 2;
            if (this_box_volume.geometry.mask_mode == 1) {
                if (global_geometry_list.elements[loop_index].Volume->geometry.is_masked_volume == 1 && global_geometry_list.elements[loop_index].Volume->geometry.mask_mode != 2)
                    // If more than one mask is added to one volume, the ANY mode overwrites the (default) ALL mode.
                    global_geometry_list.elements[loop_index].Volume->geometry.mask_mode = 1;
            }
            
            found_geometries = 1;
        }
    }
    if (found_geometries == 0) {
        printf("The mask_string in geometry: %s did not find any of the specified volumes in the mask_string %s \n",NAME_CURRENT_COMP,mask_string);
        exit(1);
    }
    this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
    this_box_volume.p_physics->is_vacuum = 0; // Makes this volume a vacuum
    this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
    this_box_volume.p_physics->my_a = 0; // Should not be used.
    sprintf(this_box_volume.p_physics->name,"Mask");
    this_box_volume.geometry.is_mask_volume = 1;
    
    
// Read the material input, or if it lacks, use automatic linking.
} else if (material_string && strlen(material_string) && strcmp(material_string, "NULL") && strcmp(material_string, "0")) {
    // A geometry string was given, use it to determine which material
    if (0 == strcmp(material_string,"vacuum") || 0 == strcmp(material_string,"Vacuum")) {
        // One could have a global physics struct for vacuum instead of creating one for each
        this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
        this_box_volume.p_physics->is_vacuum = 1; // Makes this volume a vacuum
        this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
        this_box_volume.p_physics->my_a = 0; // Should not be used.
        sprintf(this_box_volume.p_physics->name,"Vacuum");
    } else if (0 == strcmp(material_string,"exit") || 0 == strcmp(material_string,"Exit")) {
        // One could have a global physics struct for vacuum instead of creating one for each
        this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
        this_box_volume.p_physics->is_vacuum = 1; // Makes this volume a vacuum
        this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
        this_box_volume.p_physics->my_a = 0; // Should not be used.
        this_box_volume.geometry.is_exit_volume = 1;
        sprintf(this_box_volume.p_physics->name,"Exit");
    } else {
        #ifndef MATERIAL_DETECTOR
            printf("Need to define a material before refering to it in a geometry %s.\n",NAME_CURRENT_COMP);
            exit(1);
        #endif
        for (loop_index=0;loop_index<global_material_list.num_elements;loop_index++) {
            if (0 == strcmp(material_string,global_material_list.elements[loop_index].name)) {
                this_box_volume.p_physics = global_material_list.elements[loop_index].physics;
                break;
            }
            if (loop_index == global_material_list.num_elements-1) {
            printf("\n");
            printf("ERROR: The material string \"%s\" in Union geometry \"%s\" did not match a specified material. \n",material_string,NAME_CURRENT_COMP);
            printf("       The materials available at this point (need to be defined before the geometry): \n");
            for (loop_index=0;loop_index<global_material_list.num_elements;loop_index++)
              printf("         %s\n",global_material_list.elements[loop_index].name);
            printf("\n");
            printf("       It is also possible to use one of the defualt materials avaiable: \n");
            printf("           Vacuum (for a Volume without scattering or absorption)\n");
            printf("           Exit (for a Volume where the ray exits the component if it enters)\n");
            printf("           Mask (for a Volume that masks existing volumes specified in the mask_string\n");
            exit(1);
          }
        }
    }
} else {
    // Automatic linking, simply using the last defined material.
    #ifndef MATERIAL_DETECTOR
        printf("Need to define a material before the geometry to use automatic linking %s.\n",NAME_CURRENT_COMP);
        exit(1);
    #endif
    this_box_volume.p_physics = global_material_list.elements[global_material_list.num_elements-1].physics;
}

sprintf(this_box_volume.name,NAME_CURRENT_COMP);
sprintf(this_box_volume.geometry.shape,"box");
this_box_volume.geometry.priority_value = priority;
this_box_volume.geometry.geometry_p_interact = p_interact;
// Currently the coordinates will be in absolute space.
this_box_volume.geometry.center = POS_A_CURRENT_COMP;

this_box_storage.z_depth = zdepth;
this_box_storage.x_width1 = xwidth;
this_box_storage.y_height1 = yheight;

this_box_storage.is_rectangle = 0;
if (xwidth2 < 0 && yheight2 < 0) this_box_storage.is_rectangle = 1;
if (xwidth == xwidth2 && yheight == yheight2) this_box_storage.is_rectangle = 1;

if (xwidth2 < 0) {
    this_box_storage.x_width2 = xwidth;
    xwidth2 = xwidth;
} else this_box_storage.x_width2 = xwidth2;

if (yheight2 < 0) {
    this_box_storage.y_height2 = yheight;
    yheight2 = yheight;
} else this_box_storage.y_height2 = yheight2;


this_box_storage.normal_vectors[0] = coords_set(0,0,1);
this_box_storage.normal_vectors[1] = coords_set(0,0,1);

// for sides with y component = 0
x_component = 2*zdepth/sqrt((xwidth-xwidth2)*(xwidth-xwidth2)+4*zdepth*zdepth);
z_component = (xwidth-xwidth2)/sqrt(4*zdepth*zdepth+(xwidth-xwidth2)*(xwidth-xwidth2));

this_box_storage.normal_vectors[2] = coords_set(x_component,0,z_component);
this_box_storage.normal_vectors[3] = coords_set(-x_component,0,z_component);

// for sides with x component = 0
y_component = 2*zdepth/sqrt((yheight-yheight2)*(yheight-yheight2)+4*zdepth*zdepth);
z_component = (yheight-yheight2)/sqrt(4*zdepth*zdepth+(yheight-yheight2)*(yheight-yheight2));

this_box_storage.normal_vectors[4] = coords_set(0,y_component,z_component);
this_box_storage.normal_vectors[5] = coords_set(0,-y_component,z_component);

this_box_volume.geometry.visualization_on = visualize;

this_box_volume.geometry.geometry_parameters.p_box_storage = &this_box_storage;

// Assign pointers to functions for intersection with the shape, checking if a point is inside the shape
if (this_box_storage.is_rectangle == 1) {
this_box_volume.geometry.intersect_function = &sample_box_intersect_simple;
this_box_volume.geometry.within_function = &r_within_box_simple;
}
else {
this_box_volume.geometry.intersect_function = &sample_box_intersect_advanced;
this_box_volume.geometry.within_function = &r_within_box_advanced;
}

this_box_volume.geometry.shell_points = &box_shell_points;
this_box_volume.geometry.mcdisplay_function = &mcdisplay_box_function;
this_box_volume.geometry.initialize_from_main_function = &initialize_box_geometry_from_main_component;
this_box_volume.geometry.process_rot_allocated = 0;

this_box_volume.geometry.copy_geometry_parameters = &allocate_box_storage_copy;

rot_copy(this_box_volume.geometry.rotation_matrix,ROT_A_CURRENT_COMP); //check how ROT_R_CURRENT_COMP would work
rot_transpose(ROT_A_CURRENT_COMP,this_box_volume.geometry.transpose_rotation_matrix);

// Initialize loggers
this_box_volume.loggers.num_elements = 0;

// packing the information into the global_geometry_element, which is then included in the global_geometry_list.
sprintf(global_geometry_element.name,NAME_CURRENT_COMP);
global_geometry_element.activation_counter = number_of_activations;
global_geometry_element.component_index = INDEX_CURRENT_COMP;
global_geometry_element.Volume = &this_box_volume; // Would be nicer if this m was a pointer, now we have the (small) data two places
add_element_to_geometry_list(&global_geometry_list,global_geometry_element);
}
#line 286208 "MACS_sample_kidney_box.c"
#undef number_of_activations
#undef mask_setting
#undef mask_string
#undef p_interact
#undef focus_r
#undef focus_xh
#undef focus_xw
#undef focus_ah
#undef focus_aw
#undef target_z
#undef target_y
#undef target_x
#undef target_index
#undef visualize
#undef yheight2
#undef xwidth2
#undef zdepth
#undef yheight
#undef xwidth
#undef priority
#undef material_string
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

  /* Initializations for component inter_analyzer_colimator_13_blade_1. */
  SIG_MESSAGE("inter_analyzer_colimator_13_blade_1 (Init)");
#define mccompcurname  inter_analyzer_colimator_13_blade_1
#define mccompcurtype  Union_box
#define mccompcurindex 650
#define loop_index mccinter_analyzer_colimator_13_blade_1_loop_index
#define this_box_volume mccinter_analyzer_colimator_13_blade_1_this_box_volume
#define global_geometry_element mccinter_analyzer_colimator_13_blade_1_global_geometry_element
#define this_box_storage mccinter_analyzer_colimator_13_blade_1_this_box_storage
#define material_string mccinter_analyzer_colimator_13_blade_1_material_string
#define priority mccinter_analyzer_colimator_13_blade_1_priority
#define xwidth mccinter_analyzer_colimator_13_blade_1_xwidth
#define yheight mccinter_analyzer_colimator_13_blade_1_yheight
#define zdepth mccinter_analyzer_colimator_13_blade_1_zdepth
#define xwidth2 mccinter_analyzer_colimator_13_blade_1_xwidth2
#define yheight2 mccinter_analyzer_colimator_13_blade_1_yheight2
#define visualize mccinter_analyzer_colimator_13_blade_1_visualize
#define target_index mccinter_analyzer_colimator_13_blade_1_target_index
#define target_x mccinter_analyzer_colimator_13_blade_1_target_x
#define target_y mccinter_analyzer_colimator_13_blade_1_target_y
#define target_z mccinter_analyzer_colimator_13_blade_1_target_z
#define focus_aw mccinter_analyzer_colimator_13_blade_1_focus_aw
#define focus_ah mccinter_analyzer_colimator_13_blade_1_focus_ah
#define focus_xw mccinter_analyzer_colimator_13_blade_1_focus_xw
#define focus_xh mccinter_analyzer_colimator_13_blade_1_focus_xh
#define focus_r mccinter_analyzer_colimator_13_blade_1_focus_r
#define p_interact mccinter_analyzer_colimator_13_blade_1_p_interact
#define mask_string mccinter_analyzer_colimator_13_blade_1_mask_string
#define mask_setting mccinter_analyzer_colimator_13_blade_1_mask_setting
#define number_of_activations mccinter_analyzer_colimator_13_blade_1_number_of_activations
#line 224 "Union_box.comp"
{
// Initializes the focusing system for this volume including input sanitation.
focus_initialize(&this_box_volume.geometry, POS_A_COMP_INDEX(INDEX_CURRENT_COMP+target_index), POS_A_CURRENT_COMP, ROT_A_CURRENT_COMP, target_index, target_x, target_y, target_z, focus_aw, focus_ah, focus_xw, focus_xh, focus_r, NAME_CURRENT_COMP);

// Input sanitation for this geometry
if (xwidth <= 0) {
  printf("\nERROR in Union_box named %s, the xwidth is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (yheight <= 0) {
  printf("\nERROR in Union_box named %s, yheight is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (zdepth <= 0) {
  printf("\nERROR in Union_box named %s, zdepth is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (xwidth2 <= 0 && xwidth2 != -1) {
  printf("\nERROR in Union_box named %s, the xwidth2 is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (yheight2 <= 0 && yheight2 != -1) {
  printf("\nERROR in Union_box named %s, yheight2 is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}

// Use sanitation
if (global_material_list.num_elements == 0) {
  printf("\nERROR: Need to define a material using Union_make_material before using a Union geometry component. \n");
  printf("       %s was defined before first use of Union_make_material.\n",NAME_CURRENT_COMP);
  exit(1);
}

this_box_volume.geometry.is_masked_volume = 0;
this_box_volume.geometry.is_exit_volume = 0;
this_box_volume.geometry.is_mask_volume = 0;
// check if the volume is a mask, if it is the material string is irelevant.
if (mask_string && strlen(mask_string) && strcmp(mask_string, "NULL") && strcmp(mask_string, "0")) {
    // A mask volume is used to limit the extend of other volumes, called the masked volumes. These are specified in the mask_string.
    // In order for a ray to enter a masked volume, it needs to be both in the region covered by that volume AND the mask volume.
    // When more than
    this_box_volume.geometry.mask_mode = 1; // Default is mask mode is ALL
    if (mask_setting && strlen(mask_setting) && strcmp(mask_setting, "NULL") && strcmp(mask_setting, "0")) {
        if (strcmp(mask_setting,"ALL") == 0 || strcmp(mask_setting,"All") == 0) this_box_volume.geometry.mask_mode = 1;
        else if (strcmp(mask_setting,"ANY") == 0 || strcmp(mask_setting,"Any") == 0) this_box_volume.geometry.mask_mode = 2;
        else {
            printf("The mask_mode of component %s is set to %s, but must be either ALL or ANY.\n",NAME_CURRENT_COMP,mask_setting);
            exit(1);
        }
    }
    
    for (loop_index=0;loop_index<global_geometry_list.num_elements;loop_index++) {
        // Add mask list
        if (1 == manual_linking_function(global_geometry_list.elements[loop_index].name,mask_string)) {
            add_element_to_int_list(&this_box_volume.geometry.mask_list,global_geometry_list.elements[loop_index].component_index);
            add_element_to_int_list(&global_geometry_list.elements[loop_index].Volume->geometry.masked_by_list,INDEX_CURRENT_COMP);
            global_geometry_list.elements[loop_index].Volume->geometry.is_masked_volume = 1;
            if (this_box_volume.geometry.mask_mode == 2)
                global_geometry_list.elements[loop_index].Volume->geometry.mask_mode = 2;
            if (this_box_volume.geometry.mask_mode == 1) {
                if (global_geometry_list.elements[loop_index].Volume->geometry.is_masked_volume == 1 && global_geometry_list.elements[loop_index].Volume->geometry.mask_mode != 2)
                    // If more than one mask is added to one volume, the ANY mode overwrites the (default) ALL mode.
                    global_geometry_list.elements[loop_index].Volume->geometry.mask_mode = 1;
            }
            
            found_geometries = 1;
        }
    }
    if (found_geometries == 0) {
        printf("The mask_string in geometry: %s did not find any of the specified volumes in the mask_string %s \n",NAME_CURRENT_COMP,mask_string);
        exit(1);
    }
    this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
    this_box_volume.p_physics->is_vacuum = 0; // Makes this volume a vacuum
    this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
    this_box_volume.p_physics->my_a = 0; // Should not be used.
    sprintf(this_box_volume.p_physics->name,"Mask");
    this_box_volume.geometry.is_mask_volume = 1;
    
    
// Read the material input, or if it lacks, use automatic linking.
} else if (material_string && strlen(material_string) && strcmp(material_string, "NULL") && strcmp(material_string, "0")) {
    // A geometry string was given, use it to determine which material
    if (0 == strcmp(material_string,"vacuum") || 0 == strcmp(material_string,"Vacuum")) {
        // One could have a global physics struct for vacuum instead of creating one for each
        this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
        this_box_volume.p_physics->is_vacuum = 1; // Makes this volume a vacuum
        this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
        this_box_volume.p_physics->my_a = 0; // Should not be used.
        sprintf(this_box_volume.p_physics->name,"Vacuum");
    } else if (0 == strcmp(material_string,"exit") || 0 == strcmp(material_string,"Exit")) {
        // One could have a global physics struct for vacuum instead of creating one for each
        this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
        this_box_volume.p_physics->is_vacuum = 1; // Makes this volume a vacuum
        this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
        this_box_volume.p_physics->my_a = 0; // Should not be used.
        this_box_volume.geometry.is_exit_volume = 1;
        sprintf(this_box_volume.p_physics->name,"Exit");
    } else {
        #ifndef MATERIAL_DETECTOR
            printf("Need to define a material before refering to it in a geometry %s.\n",NAME_CURRENT_COMP);
            exit(1);
        #endif
        for (loop_index=0;loop_index<global_material_list.num_elements;loop_index++) {
            if (0 == strcmp(material_string,global_material_list.elements[loop_index].name)) {
                this_box_volume.p_physics = global_material_list.elements[loop_index].physics;
                break;
            }
            if (loop_index == global_material_list.num_elements-1) {
            printf("\n");
            printf("ERROR: The material string \"%s\" in Union geometry \"%s\" did not match a specified material. \n",material_string,NAME_CURRENT_COMP);
            printf("       The materials available at this point (need to be defined before the geometry): \n");
            for (loop_index=0;loop_index<global_material_list.num_elements;loop_index++)
              printf("         %s\n",global_material_list.elements[loop_index].name);
            printf("\n");
            printf("       It is also possible to use one of the defualt materials avaiable: \n");
            printf("           Vacuum (for a Volume without scattering or absorption)\n");
            printf("           Exit (for a Volume where the ray exits the component if it enters)\n");
            printf("           Mask (for a Volume that masks existing volumes specified in the mask_string\n");
            exit(1);
          }
        }
    }
} else {
    // Automatic linking, simply using the last defined material.
    #ifndef MATERIAL_DETECTOR
        printf("Need to define a material before the geometry to use automatic linking %s.\n",NAME_CURRENT_COMP);
        exit(1);
    #endif
    this_box_volume.p_physics = global_material_list.elements[global_material_list.num_elements-1].physics;
}

sprintf(this_box_volume.name,NAME_CURRENT_COMP);
sprintf(this_box_volume.geometry.shape,"box");
this_box_volume.geometry.priority_value = priority;
this_box_volume.geometry.geometry_p_interact = p_interact;
// Currently the coordinates will be in absolute space.
this_box_volume.geometry.center = POS_A_CURRENT_COMP;

this_box_storage.z_depth = zdepth;
this_box_storage.x_width1 = xwidth;
this_box_storage.y_height1 = yheight;

this_box_storage.is_rectangle = 0;
if (xwidth2 < 0 && yheight2 < 0) this_box_storage.is_rectangle = 1;
if (xwidth == xwidth2 && yheight == yheight2) this_box_storage.is_rectangle = 1;

if (xwidth2 < 0) {
    this_box_storage.x_width2 = xwidth;
    xwidth2 = xwidth;
} else this_box_storage.x_width2 = xwidth2;

if (yheight2 < 0) {
    this_box_storage.y_height2 = yheight;
    yheight2 = yheight;
} else this_box_storage.y_height2 = yheight2;


this_box_storage.normal_vectors[0] = coords_set(0,0,1);
this_box_storage.normal_vectors[1] = coords_set(0,0,1);

// for sides with y component = 0
x_component = 2*zdepth/sqrt((xwidth-xwidth2)*(xwidth-xwidth2)+4*zdepth*zdepth);
z_component = (xwidth-xwidth2)/sqrt(4*zdepth*zdepth+(xwidth-xwidth2)*(xwidth-xwidth2));

this_box_storage.normal_vectors[2] = coords_set(x_component,0,z_component);
this_box_storage.normal_vectors[3] = coords_set(-x_component,0,z_component);

// for sides with x component = 0
y_component = 2*zdepth/sqrt((yheight-yheight2)*(yheight-yheight2)+4*zdepth*zdepth);
z_component = (yheight-yheight2)/sqrt(4*zdepth*zdepth+(yheight-yheight2)*(yheight-yheight2));

this_box_storage.normal_vectors[4] = coords_set(0,y_component,z_component);
this_box_storage.normal_vectors[5] = coords_set(0,-y_component,z_component);

this_box_volume.geometry.visualization_on = visualize;

this_box_volume.geometry.geometry_parameters.p_box_storage = &this_box_storage;

// Assign pointers to functions for intersection with the shape, checking if a point is inside the shape
if (this_box_storage.is_rectangle == 1) {
this_box_volume.geometry.intersect_function = &sample_box_intersect_simple;
this_box_volume.geometry.within_function = &r_within_box_simple;
}
else {
this_box_volume.geometry.intersect_function = &sample_box_intersect_advanced;
this_box_volume.geometry.within_function = &r_within_box_advanced;
}

this_box_volume.geometry.shell_points = &box_shell_points;
this_box_volume.geometry.mcdisplay_function = &mcdisplay_box_function;
this_box_volume.geometry.initialize_from_main_function = &initialize_box_geometry_from_main_component;
this_box_volume.geometry.process_rot_allocated = 0;

this_box_volume.geometry.copy_geometry_parameters = &allocate_box_storage_copy;

rot_copy(this_box_volume.geometry.rotation_matrix,ROT_A_CURRENT_COMP); //check how ROT_R_CURRENT_COMP would work
rot_transpose(ROT_A_CURRENT_COMP,this_box_volume.geometry.transpose_rotation_matrix);

// Initialize loggers
this_box_volume.loggers.num_elements = 0;

// packing the information into the global_geometry_element, which is then included in the global_geometry_list.
sprintf(global_geometry_element.name,NAME_CURRENT_COMP);
global_geometry_element.activation_counter = number_of_activations;
global_geometry_element.component_index = INDEX_CURRENT_COMP;
global_geometry_element.Volume = &this_box_volume; // Would be nicer if this m was a pointer, now we have the (small) data two places
add_element_to_geometry_list(&global_geometry_list,global_geometry_element);
}
#line 286478 "MACS_sample_kidney_box.c"
#undef number_of_activations
#undef mask_setting
#undef mask_string
#undef p_interact
#undef focus_r
#undef focus_xh
#undef focus_xw
#undef focus_ah
#undef focus_aw
#undef target_z
#undef target_y
#undef target_x
#undef target_index
#undef visualize
#undef yheight2
#undef xwidth2
#undef zdepth
#undef yheight
#undef xwidth
#undef priority
#undef material_string
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

  /* Initializations for component inter_analyzer_colimator_13_blade_2. */
  SIG_MESSAGE("inter_analyzer_colimator_13_blade_2 (Init)");
#define mccompcurname  inter_analyzer_colimator_13_blade_2
#define mccompcurtype  Union_box
#define mccompcurindex 651
#define loop_index mccinter_analyzer_colimator_13_blade_2_loop_index
#define this_box_volume mccinter_analyzer_colimator_13_blade_2_this_box_volume
#define global_geometry_element mccinter_analyzer_colimator_13_blade_2_global_geometry_element
#define this_box_storage mccinter_analyzer_colimator_13_blade_2_this_box_storage
#define material_string mccinter_analyzer_colimator_13_blade_2_material_string
#define priority mccinter_analyzer_colimator_13_blade_2_priority
#define xwidth mccinter_analyzer_colimator_13_blade_2_xwidth
#define yheight mccinter_analyzer_colimator_13_blade_2_yheight
#define zdepth mccinter_analyzer_colimator_13_blade_2_zdepth
#define xwidth2 mccinter_analyzer_colimator_13_blade_2_xwidth2
#define yheight2 mccinter_analyzer_colimator_13_blade_2_yheight2
#define visualize mccinter_analyzer_colimator_13_blade_2_visualize
#define target_index mccinter_analyzer_colimator_13_blade_2_target_index
#define target_x mccinter_analyzer_colimator_13_blade_2_target_x
#define target_y mccinter_analyzer_colimator_13_blade_2_target_y
#define target_z mccinter_analyzer_colimator_13_blade_2_target_z
#define focus_aw mccinter_analyzer_colimator_13_blade_2_focus_aw
#define focus_ah mccinter_analyzer_colimator_13_blade_2_focus_ah
#define focus_xw mccinter_analyzer_colimator_13_blade_2_focus_xw
#define focus_xh mccinter_analyzer_colimator_13_blade_2_focus_xh
#define focus_r mccinter_analyzer_colimator_13_blade_2_focus_r
#define p_interact mccinter_analyzer_colimator_13_blade_2_p_interact
#define mask_string mccinter_analyzer_colimator_13_blade_2_mask_string
#define mask_setting mccinter_analyzer_colimator_13_blade_2_mask_setting
#define number_of_activations mccinter_analyzer_colimator_13_blade_2_number_of_activations
#line 224 "Union_box.comp"
{
// Initializes the focusing system for this volume including input sanitation.
focus_initialize(&this_box_volume.geometry, POS_A_COMP_INDEX(INDEX_CURRENT_COMP+target_index), POS_A_CURRENT_COMP, ROT_A_CURRENT_COMP, target_index, target_x, target_y, target_z, focus_aw, focus_ah, focus_xw, focus_xh, focus_r, NAME_CURRENT_COMP);

// Input sanitation for this geometry
if (xwidth <= 0) {
  printf("\nERROR in Union_box named %s, the xwidth is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (yheight <= 0) {
  printf("\nERROR in Union_box named %s, yheight is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (zdepth <= 0) {
  printf("\nERROR in Union_box named %s, zdepth is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (xwidth2 <= 0 && xwidth2 != -1) {
  printf("\nERROR in Union_box named %s, the xwidth2 is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (yheight2 <= 0 && yheight2 != -1) {
  printf("\nERROR in Union_box named %s, yheight2 is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}

// Use sanitation
if (global_material_list.num_elements == 0) {
  printf("\nERROR: Need to define a material using Union_make_material before using a Union geometry component. \n");
  printf("       %s was defined before first use of Union_make_material.\n",NAME_CURRENT_COMP);
  exit(1);
}

this_box_volume.geometry.is_masked_volume = 0;
this_box_volume.geometry.is_exit_volume = 0;
this_box_volume.geometry.is_mask_volume = 0;
// check if the volume is a mask, if it is the material string is irelevant.
if (mask_string && strlen(mask_string) && strcmp(mask_string, "NULL") && strcmp(mask_string, "0")) {
    // A mask volume is used to limit the extend of other volumes, called the masked volumes. These are specified in the mask_string.
    // In order for a ray to enter a masked volume, it needs to be both in the region covered by that volume AND the mask volume.
    // When more than
    this_box_volume.geometry.mask_mode = 1; // Default is mask mode is ALL
    if (mask_setting && strlen(mask_setting) && strcmp(mask_setting, "NULL") && strcmp(mask_setting, "0")) {
        if (strcmp(mask_setting,"ALL") == 0 || strcmp(mask_setting,"All") == 0) this_box_volume.geometry.mask_mode = 1;
        else if (strcmp(mask_setting,"ANY") == 0 || strcmp(mask_setting,"Any") == 0) this_box_volume.geometry.mask_mode = 2;
        else {
            printf("The mask_mode of component %s is set to %s, but must be either ALL or ANY.\n",NAME_CURRENT_COMP,mask_setting);
            exit(1);
        }
    }
    
    for (loop_index=0;loop_index<global_geometry_list.num_elements;loop_index++) {
        // Add mask list
        if (1 == manual_linking_function(global_geometry_list.elements[loop_index].name,mask_string)) {
            add_element_to_int_list(&this_box_volume.geometry.mask_list,global_geometry_list.elements[loop_index].component_index);
            add_element_to_int_list(&global_geometry_list.elements[loop_index].Volume->geometry.masked_by_list,INDEX_CURRENT_COMP);
            global_geometry_list.elements[loop_index].Volume->geometry.is_masked_volume = 1;
            if (this_box_volume.geometry.mask_mode == 2)
                global_geometry_list.elements[loop_index].Volume->geometry.mask_mode = 2;
            if (this_box_volume.geometry.mask_mode == 1) {
                if (global_geometry_list.elements[loop_index].Volume->geometry.is_masked_volume == 1 && global_geometry_list.elements[loop_index].Volume->geometry.mask_mode != 2)
                    // If more than one mask is added to one volume, the ANY mode overwrites the (default) ALL mode.
                    global_geometry_list.elements[loop_index].Volume->geometry.mask_mode = 1;
            }
            
            found_geometries = 1;
        }
    }
    if (found_geometries == 0) {
        printf("The mask_string in geometry: %s did not find any of the specified volumes in the mask_string %s \n",NAME_CURRENT_COMP,mask_string);
        exit(1);
    }
    this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
    this_box_volume.p_physics->is_vacuum = 0; // Makes this volume a vacuum
    this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
    this_box_volume.p_physics->my_a = 0; // Should not be used.
    sprintf(this_box_volume.p_physics->name,"Mask");
    this_box_volume.geometry.is_mask_volume = 1;
    
    
// Read the material input, or if it lacks, use automatic linking.
} else if (material_string && strlen(material_string) && strcmp(material_string, "NULL") && strcmp(material_string, "0")) {
    // A geometry string was given, use it to determine which material
    if (0 == strcmp(material_string,"vacuum") || 0 == strcmp(material_string,"Vacuum")) {
        // One could have a global physics struct for vacuum instead of creating one for each
        this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
        this_box_volume.p_physics->is_vacuum = 1; // Makes this volume a vacuum
        this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
        this_box_volume.p_physics->my_a = 0; // Should not be used.
        sprintf(this_box_volume.p_physics->name,"Vacuum");
    } else if (0 == strcmp(material_string,"exit") || 0 == strcmp(material_string,"Exit")) {
        // One could have a global physics struct for vacuum instead of creating one for each
        this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
        this_box_volume.p_physics->is_vacuum = 1; // Makes this volume a vacuum
        this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
        this_box_volume.p_physics->my_a = 0; // Should not be used.
        this_box_volume.geometry.is_exit_volume = 1;
        sprintf(this_box_volume.p_physics->name,"Exit");
    } else {
        #ifndef MATERIAL_DETECTOR
            printf("Need to define a material before refering to it in a geometry %s.\n",NAME_CURRENT_COMP);
            exit(1);
        #endif
        for (loop_index=0;loop_index<global_material_list.num_elements;loop_index++) {
            if (0 == strcmp(material_string,global_material_list.elements[loop_index].name)) {
                this_box_volume.p_physics = global_material_list.elements[loop_index].physics;
                break;
            }
            if (loop_index == global_material_list.num_elements-1) {
            printf("\n");
            printf("ERROR: The material string \"%s\" in Union geometry \"%s\" did not match a specified material. \n",material_string,NAME_CURRENT_COMP);
            printf("       The materials available at this point (need to be defined before the geometry): \n");
            for (loop_index=0;loop_index<global_material_list.num_elements;loop_index++)
              printf("         %s\n",global_material_list.elements[loop_index].name);
            printf("\n");
            printf("       It is also possible to use one of the defualt materials avaiable: \n");
            printf("           Vacuum (for a Volume without scattering or absorption)\n");
            printf("           Exit (for a Volume where the ray exits the component if it enters)\n");
            printf("           Mask (for a Volume that masks existing volumes specified in the mask_string\n");
            exit(1);
          }
        }
    }
} else {
    // Automatic linking, simply using the last defined material.
    #ifndef MATERIAL_DETECTOR
        printf("Need to define a material before the geometry to use automatic linking %s.\n",NAME_CURRENT_COMP);
        exit(1);
    #endif
    this_box_volume.p_physics = global_material_list.elements[global_material_list.num_elements-1].physics;
}

sprintf(this_box_volume.name,NAME_CURRENT_COMP);
sprintf(this_box_volume.geometry.shape,"box");
this_box_volume.geometry.priority_value = priority;
this_box_volume.geometry.geometry_p_interact = p_interact;
// Currently the coordinates will be in absolute space.
this_box_volume.geometry.center = POS_A_CURRENT_COMP;

this_box_storage.z_depth = zdepth;
this_box_storage.x_width1 = xwidth;
this_box_storage.y_height1 = yheight;

this_box_storage.is_rectangle = 0;
if (xwidth2 < 0 && yheight2 < 0) this_box_storage.is_rectangle = 1;
if (xwidth == xwidth2 && yheight == yheight2) this_box_storage.is_rectangle = 1;

if (xwidth2 < 0) {
    this_box_storage.x_width2 = xwidth;
    xwidth2 = xwidth;
} else this_box_storage.x_width2 = xwidth2;

if (yheight2 < 0) {
    this_box_storage.y_height2 = yheight;
    yheight2 = yheight;
} else this_box_storage.y_height2 = yheight2;


this_box_storage.normal_vectors[0] = coords_set(0,0,1);
this_box_storage.normal_vectors[1] = coords_set(0,0,1);

// for sides with y component = 0
x_component = 2*zdepth/sqrt((xwidth-xwidth2)*(xwidth-xwidth2)+4*zdepth*zdepth);
z_component = (xwidth-xwidth2)/sqrt(4*zdepth*zdepth+(xwidth-xwidth2)*(xwidth-xwidth2));

this_box_storage.normal_vectors[2] = coords_set(x_component,0,z_component);
this_box_storage.normal_vectors[3] = coords_set(-x_component,0,z_component);

// for sides with x component = 0
y_component = 2*zdepth/sqrt((yheight-yheight2)*(yheight-yheight2)+4*zdepth*zdepth);
z_component = (yheight-yheight2)/sqrt(4*zdepth*zdepth+(yheight-yheight2)*(yheight-yheight2));

this_box_storage.normal_vectors[4] = coords_set(0,y_component,z_component);
this_box_storage.normal_vectors[5] = coords_set(0,-y_component,z_component);

this_box_volume.geometry.visualization_on = visualize;

this_box_volume.geometry.geometry_parameters.p_box_storage = &this_box_storage;

// Assign pointers to functions for intersection with the shape, checking if a point is inside the shape
if (this_box_storage.is_rectangle == 1) {
this_box_volume.geometry.intersect_function = &sample_box_intersect_simple;
this_box_volume.geometry.within_function = &r_within_box_simple;
}
else {
this_box_volume.geometry.intersect_function = &sample_box_intersect_advanced;
this_box_volume.geometry.within_function = &r_within_box_advanced;
}

this_box_volume.geometry.shell_points = &box_shell_points;
this_box_volume.geometry.mcdisplay_function = &mcdisplay_box_function;
this_box_volume.geometry.initialize_from_main_function = &initialize_box_geometry_from_main_component;
this_box_volume.geometry.process_rot_allocated = 0;

this_box_volume.geometry.copy_geometry_parameters = &allocate_box_storage_copy;

rot_copy(this_box_volume.geometry.rotation_matrix,ROT_A_CURRENT_COMP); //check how ROT_R_CURRENT_COMP would work
rot_transpose(ROT_A_CURRENT_COMP,this_box_volume.geometry.transpose_rotation_matrix);

// Initialize loggers
this_box_volume.loggers.num_elements = 0;

// packing the information into the global_geometry_element, which is then included in the global_geometry_list.
sprintf(global_geometry_element.name,NAME_CURRENT_COMP);
global_geometry_element.activation_counter = number_of_activations;
global_geometry_element.component_index = INDEX_CURRENT_COMP;
global_geometry_element.Volume = &this_box_volume; // Would be nicer if this m was a pointer, now we have the (small) data two places
add_element_to_geometry_list(&global_geometry_list,global_geometry_element);
}
#line 286748 "MACS_sample_kidney_box.c"
#undef number_of_activations
#undef mask_setting
#undef mask_string
#undef p_interact
#undef focus_r
#undef focus_xh
#undef focus_xw
#undef focus_ah
#undef focus_aw
#undef target_z
#undef target_y
#undef target_x
#undef target_index
#undef visualize
#undef yheight2
#undef xwidth2
#undef zdepth
#undef yheight
#undef xwidth
#undef priority
#undef material_string
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

  /* Initializations for component inter_analyzer_colimator_13_blade_3. */
  SIG_MESSAGE("inter_analyzer_colimator_13_blade_3 (Init)");
#define mccompcurname  inter_analyzer_colimator_13_blade_3
#define mccompcurtype  Union_box
#define mccompcurindex 652
#define loop_index mccinter_analyzer_colimator_13_blade_3_loop_index
#define this_box_volume mccinter_analyzer_colimator_13_blade_3_this_box_volume
#define global_geometry_element mccinter_analyzer_colimator_13_blade_3_global_geometry_element
#define this_box_storage mccinter_analyzer_colimator_13_blade_3_this_box_storage
#define material_string mccinter_analyzer_colimator_13_blade_3_material_string
#define priority mccinter_analyzer_colimator_13_blade_3_priority
#define xwidth mccinter_analyzer_colimator_13_blade_3_xwidth
#define yheight mccinter_analyzer_colimator_13_blade_3_yheight
#define zdepth mccinter_analyzer_colimator_13_blade_3_zdepth
#define xwidth2 mccinter_analyzer_colimator_13_blade_3_xwidth2
#define yheight2 mccinter_analyzer_colimator_13_blade_3_yheight2
#define visualize mccinter_analyzer_colimator_13_blade_3_visualize
#define target_index mccinter_analyzer_colimator_13_blade_3_target_index
#define target_x mccinter_analyzer_colimator_13_blade_3_target_x
#define target_y mccinter_analyzer_colimator_13_blade_3_target_y
#define target_z mccinter_analyzer_colimator_13_blade_3_target_z
#define focus_aw mccinter_analyzer_colimator_13_blade_3_focus_aw
#define focus_ah mccinter_analyzer_colimator_13_blade_3_focus_ah
#define focus_xw mccinter_analyzer_colimator_13_blade_3_focus_xw
#define focus_xh mccinter_analyzer_colimator_13_blade_3_focus_xh
#define focus_r mccinter_analyzer_colimator_13_blade_3_focus_r
#define p_interact mccinter_analyzer_colimator_13_blade_3_p_interact
#define mask_string mccinter_analyzer_colimator_13_blade_3_mask_string
#define mask_setting mccinter_analyzer_colimator_13_blade_3_mask_setting
#define number_of_activations mccinter_analyzer_colimator_13_blade_3_number_of_activations
#line 224 "Union_box.comp"
{
// Initializes the focusing system for this volume including input sanitation.
focus_initialize(&this_box_volume.geometry, POS_A_COMP_INDEX(INDEX_CURRENT_COMP+target_index), POS_A_CURRENT_COMP, ROT_A_CURRENT_COMP, target_index, target_x, target_y, target_z, focus_aw, focus_ah, focus_xw, focus_xh, focus_r, NAME_CURRENT_COMP);

// Input sanitation for this geometry
if (xwidth <= 0) {
  printf("\nERROR in Union_box named %s, the xwidth is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (yheight <= 0) {
  printf("\nERROR in Union_box named %s, yheight is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (zdepth <= 0) {
  printf("\nERROR in Union_box named %s, zdepth is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (xwidth2 <= 0 && xwidth2 != -1) {
  printf("\nERROR in Union_box named %s, the xwidth2 is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (yheight2 <= 0 && yheight2 != -1) {
  printf("\nERROR in Union_box named %s, yheight2 is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}

// Use sanitation
if (global_material_list.num_elements == 0) {
  printf("\nERROR: Need to define a material using Union_make_material before using a Union geometry component. \n");
  printf("       %s was defined before first use of Union_make_material.\n",NAME_CURRENT_COMP);
  exit(1);
}

this_box_volume.geometry.is_masked_volume = 0;
this_box_volume.geometry.is_exit_volume = 0;
this_box_volume.geometry.is_mask_volume = 0;
// check if the volume is a mask, if it is the material string is irelevant.
if (mask_string && strlen(mask_string) && strcmp(mask_string, "NULL") && strcmp(mask_string, "0")) {
    // A mask volume is used to limit the extend of other volumes, called the masked volumes. These are specified in the mask_string.
    // In order for a ray to enter a masked volume, it needs to be both in the region covered by that volume AND the mask volume.
    // When more than
    this_box_volume.geometry.mask_mode = 1; // Default is mask mode is ALL
    if (mask_setting && strlen(mask_setting) && strcmp(mask_setting, "NULL") && strcmp(mask_setting, "0")) {
        if (strcmp(mask_setting,"ALL") == 0 || strcmp(mask_setting,"All") == 0) this_box_volume.geometry.mask_mode = 1;
        else if (strcmp(mask_setting,"ANY") == 0 || strcmp(mask_setting,"Any") == 0) this_box_volume.geometry.mask_mode = 2;
        else {
            printf("The mask_mode of component %s is set to %s, but must be either ALL or ANY.\n",NAME_CURRENT_COMP,mask_setting);
            exit(1);
        }
    }
    
    for (loop_index=0;loop_index<global_geometry_list.num_elements;loop_index++) {
        // Add mask list
        if (1 == manual_linking_function(global_geometry_list.elements[loop_index].name,mask_string)) {
            add_element_to_int_list(&this_box_volume.geometry.mask_list,global_geometry_list.elements[loop_index].component_index);
            add_element_to_int_list(&global_geometry_list.elements[loop_index].Volume->geometry.masked_by_list,INDEX_CURRENT_COMP);
            global_geometry_list.elements[loop_index].Volume->geometry.is_masked_volume = 1;
            if (this_box_volume.geometry.mask_mode == 2)
                global_geometry_list.elements[loop_index].Volume->geometry.mask_mode = 2;
            if (this_box_volume.geometry.mask_mode == 1) {
                if (global_geometry_list.elements[loop_index].Volume->geometry.is_masked_volume == 1 && global_geometry_list.elements[loop_index].Volume->geometry.mask_mode != 2)
                    // If more than one mask is added to one volume, the ANY mode overwrites the (default) ALL mode.
                    global_geometry_list.elements[loop_index].Volume->geometry.mask_mode = 1;
            }
            
            found_geometries = 1;
        }
    }
    if (found_geometries == 0) {
        printf("The mask_string in geometry: %s did not find any of the specified volumes in the mask_string %s \n",NAME_CURRENT_COMP,mask_string);
        exit(1);
    }
    this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
    this_box_volume.p_physics->is_vacuum = 0; // Makes this volume a vacuum
    this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
    this_box_volume.p_physics->my_a = 0; // Should not be used.
    sprintf(this_box_volume.p_physics->name,"Mask");
    this_box_volume.geometry.is_mask_volume = 1;
    
    
// Read the material input, or if it lacks, use automatic linking.
} else if (material_string && strlen(material_string) && strcmp(material_string, "NULL") && strcmp(material_string, "0")) {
    // A geometry string was given, use it to determine which material
    if (0 == strcmp(material_string,"vacuum") || 0 == strcmp(material_string,"Vacuum")) {
        // One could have a global physics struct for vacuum instead of creating one for each
        this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
        this_box_volume.p_physics->is_vacuum = 1; // Makes this volume a vacuum
        this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
        this_box_volume.p_physics->my_a = 0; // Should not be used.
        sprintf(this_box_volume.p_physics->name,"Vacuum");
    } else if (0 == strcmp(material_string,"exit") || 0 == strcmp(material_string,"Exit")) {
        // One could have a global physics struct for vacuum instead of creating one for each
        this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
        this_box_volume.p_physics->is_vacuum = 1; // Makes this volume a vacuum
        this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
        this_box_volume.p_physics->my_a = 0; // Should not be used.
        this_box_volume.geometry.is_exit_volume = 1;
        sprintf(this_box_volume.p_physics->name,"Exit");
    } else {
        #ifndef MATERIAL_DETECTOR
            printf("Need to define a material before refering to it in a geometry %s.\n",NAME_CURRENT_COMP);
            exit(1);
        #endif
        for (loop_index=0;loop_index<global_material_list.num_elements;loop_index++) {
            if (0 == strcmp(material_string,global_material_list.elements[loop_index].name)) {
                this_box_volume.p_physics = global_material_list.elements[loop_index].physics;
                break;
            }
            if (loop_index == global_material_list.num_elements-1) {
            printf("\n");
            printf("ERROR: The material string \"%s\" in Union geometry \"%s\" did not match a specified material. \n",material_string,NAME_CURRENT_COMP);
            printf("       The materials available at this point (need to be defined before the geometry): \n");
            for (loop_index=0;loop_index<global_material_list.num_elements;loop_index++)
              printf("         %s\n",global_material_list.elements[loop_index].name);
            printf("\n");
            printf("       It is also possible to use one of the defualt materials avaiable: \n");
            printf("           Vacuum (for a Volume without scattering or absorption)\n");
            printf("           Exit (for a Volume where the ray exits the component if it enters)\n");
            printf("           Mask (for a Volume that masks existing volumes specified in the mask_string\n");
            exit(1);
          }
        }
    }
} else {
    // Automatic linking, simply using the last defined material.
    #ifndef MATERIAL_DETECTOR
        printf("Need to define a material before the geometry to use automatic linking %s.\n",NAME_CURRENT_COMP);
        exit(1);
    #endif
    this_box_volume.p_physics = global_material_list.elements[global_material_list.num_elements-1].physics;
}

sprintf(this_box_volume.name,NAME_CURRENT_COMP);
sprintf(this_box_volume.geometry.shape,"box");
this_box_volume.geometry.priority_value = priority;
this_box_volume.geometry.geometry_p_interact = p_interact;
// Currently the coordinates will be in absolute space.
this_box_volume.geometry.center = POS_A_CURRENT_COMP;

this_box_storage.z_depth = zdepth;
this_box_storage.x_width1 = xwidth;
this_box_storage.y_height1 = yheight;

this_box_storage.is_rectangle = 0;
if (xwidth2 < 0 && yheight2 < 0) this_box_storage.is_rectangle = 1;
if (xwidth == xwidth2 && yheight == yheight2) this_box_storage.is_rectangle = 1;

if (xwidth2 < 0) {
    this_box_storage.x_width2 = xwidth;
    xwidth2 = xwidth;
} else this_box_storage.x_width2 = xwidth2;

if (yheight2 < 0) {
    this_box_storage.y_height2 = yheight;
    yheight2 = yheight;
} else this_box_storage.y_height2 = yheight2;


this_box_storage.normal_vectors[0] = coords_set(0,0,1);
this_box_storage.normal_vectors[1] = coords_set(0,0,1);

// for sides with y component = 0
x_component = 2*zdepth/sqrt((xwidth-xwidth2)*(xwidth-xwidth2)+4*zdepth*zdepth);
z_component = (xwidth-xwidth2)/sqrt(4*zdepth*zdepth+(xwidth-xwidth2)*(xwidth-xwidth2));

this_box_storage.normal_vectors[2] = coords_set(x_component,0,z_component);
this_box_storage.normal_vectors[3] = coords_set(-x_component,0,z_component);

// for sides with x component = 0
y_component = 2*zdepth/sqrt((yheight-yheight2)*(yheight-yheight2)+4*zdepth*zdepth);
z_component = (yheight-yheight2)/sqrt(4*zdepth*zdepth+(yheight-yheight2)*(yheight-yheight2));

this_box_storage.normal_vectors[4] = coords_set(0,y_component,z_component);
this_box_storage.normal_vectors[5] = coords_set(0,-y_component,z_component);

this_box_volume.geometry.visualization_on = visualize;

this_box_volume.geometry.geometry_parameters.p_box_storage = &this_box_storage;

// Assign pointers to functions for intersection with the shape, checking if a point is inside the shape
if (this_box_storage.is_rectangle == 1) {
this_box_volume.geometry.intersect_function = &sample_box_intersect_simple;
this_box_volume.geometry.within_function = &r_within_box_simple;
}
else {
this_box_volume.geometry.intersect_function = &sample_box_intersect_advanced;
this_box_volume.geometry.within_function = &r_within_box_advanced;
}

this_box_volume.geometry.shell_points = &box_shell_points;
this_box_volume.geometry.mcdisplay_function = &mcdisplay_box_function;
this_box_volume.geometry.initialize_from_main_function = &initialize_box_geometry_from_main_component;
this_box_volume.geometry.process_rot_allocated = 0;

this_box_volume.geometry.copy_geometry_parameters = &allocate_box_storage_copy;

rot_copy(this_box_volume.geometry.rotation_matrix,ROT_A_CURRENT_COMP); //check how ROT_R_CURRENT_COMP would work
rot_transpose(ROT_A_CURRENT_COMP,this_box_volume.geometry.transpose_rotation_matrix);

// Initialize loggers
this_box_volume.loggers.num_elements = 0;

// packing the information into the global_geometry_element, which is then included in the global_geometry_list.
sprintf(global_geometry_element.name,NAME_CURRENT_COMP);
global_geometry_element.activation_counter = number_of_activations;
global_geometry_element.component_index = INDEX_CURRENT_COMP;
global_geometry_element.Volume = &this_box_volume; // Would be nicer if this m was a pointer, now we have the (small) data two places
add_element_to_geometry_list(&global_geometry_list,global_geometry_element);
}
#line 287018 "MACS_sample_kidney_box.c"
#undef number_of_activations
#undef mask_setting
#undef mask_string
#undef p_interact
#undef focus_r
#undef focus_xh
#undef focus_xw
#undef focus_ah
#undef focus_aw
#undef target_z
#undef target_y
#undef target_x
#undef target_index
#undef visualize
#undef yheight2
#undef xwidth2
#undef zdepth
#undef yheight
#undef xwidth
#undef priority
#undef material_string
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

  /* Initializations for component inter_analyzer_colimator_13_blade_4. */
  SIG_MESSAGE("inter_analyzer_colimator_13_blade_4 (Init)");
#define mccompcurname  inter_analyzer_colimator_13_blade_4
#define mccompcurtype  Union_box
#define mccompcurindex 653
#define loop_index mccinter_analyzer_colimator_13_blade_4_loop_index
#define this_box_volume mccinter_analyzer_colimator_13_blade_4_this_box_volume
#define global_geometry_element mccinter_analyzer_colimator_13_blade_4_global_geometry_element
#define this_box_storage mccinter_analyzer_colimator_13_blade_4_this_box_storage
#define material_string mccinter_analyzer_colimator_13_blade_4_material_string
#define priority mccinter_analyzer_colimator_13_blade_4_priority
#define xwidth mccinter_analyzer_colimator_13_blade_4_xwidth
#define yheight mccinter_analyzer_colimator_13_blade_4_yheight
#define zdepth mccinter_analyzer_colimator_13_blade_4_zdepth
#define xwidth2 mccinter_analyzer_colimator_13_blade_4_xwidth2
#define yheight2 mccinter_analyzer_colimator_13_blade_4_yheight2
#define visualize mccinter_analyzer_colimator_13_blade_4_visualize
#define target_index mccinter_analyzer_colimator_13_blade_4_target_index
#define target_x mccinter_analyzer_colimator_13_blade_4_target_x
#define target_y mccinter_analyzer_colimator_13_blade_4_target_y
#define target_z mccinter_analyzer_colimator_13_blade_4_target_z
#define focus_aw mccinter_analyzer_colimator_13_blade_4_focus_aw
#define focus_ah mccinter_analyzer_colimator_13_blade_4_focus_ah
#define focus_xw mccinter_analyzer_colimator_13_blade_4_focus_xw
#define focus_xh mccinter_analyzer_colimator_13_blade_4_focus_xh
#define focus_r mccinter_analyzer_colimator_13_blade_4_focus_r
#define p_interact mccinter_analyzer_colimator_13_blade_4_p_interact
#define mask_string mccinter_analyzer_colimator_13_blade_4_mask_string
#define mask_setting mccinter_analyzer_colimator_13_blade_4_mask_setting
#define number_of_activations mccinter_analyzer_colimator_13_blade_4_number_of_activations
#line 224 "Union_box.comp"
{
// Initializes the focusing system for this volume including input sanitation.
focus_initialize(&this_box_volume.geometry, POS_A_COMP_INDEX(INDEX_CURRENT_COMP+target_index), POS_A_CURRENT_COMP, ROT_A_CURRENT_COMP, target_index, target_x, target_y, target_z, focus_aw, focus_ah, focus_xw, focus_xh, focus_r, NAME_CURRENT_COMP);

// Input sanitation for this geometry
if (xwidth <= 0) {
  printf("\nERROR in Union_box named %s, the xwidth is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (yheight <= 0) {
  printf("\nERROR in Union_box named %s, yheight is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (zdepth <= 0) {
  printf("\nERROR in Union_box named %s, zdepth is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (xwidth2 <= 0 && xwidth2 != -1) {
  printf("\nERROR in Union_box named %s, the xwidth2 is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (yheight2 <= 0 && yheight2 != -1) {
  printf("\nERROR in Union_box named %s, yheight2 is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}

// Use sanitation
if (global_material_list.num_elements == 0) {
  printf("\nERROR: Need to define a material using Union_make_material before using a Union geometry component. \n");
  printf("       %s was defined before first use of Union_make_material.\n",NAME_CURRENT_COMP);
  exit(1);
}

this_box_volume.geometry.is_masked_volume = 0;
this_box_volume.geometry.is_exit_volume = 0;
this_box_volume.geometry.is_mask_volume = 0;
// check if the volume is a mask, if it is the material string is irelevant.
if (mask_string && strlen(mask_string) && strcmp(mask_string, "NULL") && strcmp(mask_string, "0")) {
    // A mask volume is used to limit the extend of other volumes, called the masked volumes. These are specified in the mask_string.
    // In order for a ray to enter a masked volume, it needs to be both in the region covered by that volume AND the mask volume.
    // When more than
    this_box_volume.geometry.mask_mode = 1; // Default is mask mode is ALL
    if (mask_setting && strlen(mask_setting) && strcmp(mask_setting, "NULL") && strcmp(mask_setting, "0")) {
        if (strcmp(mask_setting,"ALL") == 0 || strcmp(mask_setting,"All") == 0) this_box_volume.geometry.mask_mode = 1;
        else if (strcmp(mask_setting,"ANY") == 0 || strcmp(mask_setting,"Any") == 0) this_box_volume.geometry.mask_mode = 2;
        else {
            printf("The mask_mode of component %s is set to %s, but must be either ALL or ANY.\n",NAME_CURRENT_COMP,mask_setting);
            exit(1);
        }
    }
    
    for (loop_index=0;loop_index<global_geometry_list.num_elements;loop_index++) {
        // Add mask list
        if (1 == manual_linking_function(global_geometry_list.elements[loop_index].name,mask_string)) {
            add_element_to_int_list(&this_box_volume.geometry.mask_list,global_geometry_list.elements[loop_index].component_index);
            add_element_to_int_list(&global_geometry_list.elements[loop_index].Volume->geometry.masked_by_list,INDEX_CURRENT_COMP);
            global_geometry_list.elements[loop_index].Volume->geometry.is_masked_volume = 1;
            if (this_box_volume.geometry.mask_mode == 2)
                global_geometry_list.elements[loop_index].Volume->geometry.mask_mode = 2;
            if (this_box_volume.geometry.mask_mode == 1) {
                if (global_geometry_list.elements[loop_index].Volume->geometry.is_masked_volume == 1 && global_geometry_list.elements[loop_index].Volume->geometry.mask_mode != 2)
                    // If more than one mask is added to one volume, the ANY mode overwrites the (default) ALL mode.
                    global_geometry_list.elements[loop_index].Volume->geometry.mask_mode = 1;
            }
            
            found_geometries = 1;
        }
    }
    if (found_geometries == 0) {
        printf("The mask_string in geometry: %s did not find any of the specified volumes in the mask_string %s \n",NAME_CURRENT_COMP,mask_string);
        exit(1);
    }
    this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
    this_box_volume.p_physics->is_vacuum = 0; // Makes this volume a vacuum
    this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
    this_box_volume.p_physics->my_a = 0; // Should not be used.
    sprintf(this_box_volume.p_physics->name,"Mask");
    this_box_volume.geometry.is_mask_volume = 1;
    
    
// Read the material input, or if it lacks, use automatic linking.
} else if (material_string && strlen(material_string) && strcmp(material_string, "NULL") && strcmp(material_string, "0")) {
    // A geometry string was given, use it to determine which material
    if (0 == strcmp(material_string,"vacuum") || 0 == strcmp(material_string,"Vacuum")) {
        // One could have a global physics struct for vacuum instead of creating one for each
        this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
        this_box_volume.p_physics->is_vacuum = 1; // Makes this volume a vacuum
        this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
        this_box_volume.p_physics->my_a = 0; // Should not be used.
        sprintf(this_box_volume.p_physics->name,"Vacuum");
    } else if (0 == strcmp(material_string,"exit") || 0 == strcmp(material_string,"Exit")) {
        // One could have a global physics struct for vacuum instead of creating one for each
        this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
        this_box_volume.p_physics->is_vacuum = 1; // Makes this volume a vacuum
        this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
        this_box_volume.p_physics->my_a = 0; // Should not be used.
        this_box_volume.geometry.is_exit_volume = 1;
        sprintf(this_box_volume.p_physics->name,"Exit");
    } else {
        #ifndef MATERIAL_DETECTOR
            printf("Need to define a material before refering to it in a geometry %s.\n",NAME_CURRENT_COMP);
            exit(1);
        #endif
        for (loop_index=0;loop_index<global_material_list.num_elements;loop_index++) {
            if (0 == strcmp(material_string,global_material_list.elements[loop_index].name)) {
                this_box_volume.p_physics = global_material_list.elements[loop_index].physics;
                break;
            }
            if (loop_index == global_material_list.num_elements-1) {
            printf("\n");
            printf("ERROR: The material string \"%s\" in Union geometry \"%s\" did not match a specified material. \n",material_string,NAME_CURRENT_COMP);
            printf("       The materials available at this point (need to be defined before the geometry): \n");
            for (loop_index=0;loop_index<global_material_list.num_elements;loop_index++)
              printf("         %s\n",global_material_list.elements[loop_index].name);
            printf("\n");
            printf("       It is also possible to use one of the defualt materials avaiable: \n");
            printf("           Vacuum (for a Volume without scattering or absorption)\n");
            printf("           Exit (for a Volume where the ray exits the component if it enters)\n");
            printf("           Mask (for a Volume that masks existing volumes specified in the mask_string\n");
            exit(1);
          }
        }
    }
} else {
    // Automatic linking, simply using the last defined material.
    #ifndef MATERIAL_DETECTOR
        printf("Need to define a material before the geometry to use automatic linking %s.\n",NAME_CURRENT_COMP);
        exit(1);
    #endif
    this_box_volume.p_physics = global_material_list.elements[global_material_list.num_elements-1].physics;
}

sprintf(this_box_volume.name,NAME_CURRENT_COMP);
sprintf(this_box_volume.geometry.shape,"box");
this_box_volume.geometry.priority_value = priority;
this_box_volume.geometry.geometry_p_interact = p_interact;
// Currently the coordinates will be in absolute space.
this_box_volume.geometry.center = POS_A_CURRENT_COMP;

this_box_storage.z_depth = zdepth;
this_box_storage.x_width1 = xwidth;
this_box_storage.y_height1 = yheight;

this_box_storage.is_rectangle = 0;
if (xwidth2 < 0 && yheight2 < 0) this_box_storage.is_rectangle = 1;
if (xwidth == xwidth2 && yheight == yheight2) this_box_storage.is_rectangle = 1;

if (xwidth2 < 0) {
    this_box_storage.x_width2 = xwidth;
    xwidth2 = xwidth;
} else this_box_storage.x_width2 = xwidth2;

if (yheight2 < 0) {
    this_box_storage.y_height2 = yheight;
    yheight2 = yheight;
} else this_box_storage.y_height2 = yheight2;


this_box_storage.normal_vectors[0] = coords_set(0,0,1);
this_box_storage.normal_vectors[1] = coords_set(0,0,1);

// for sides with y component = 0
x_component = 2*zdepth/sqrt((xwidth-xwidth2)*(xwidth-xwidth2)+4*zdepth*zdepth);
z_component = (xwidth-xwidth2)/sqrt(4*zdepth*zdepth+(xwidth-xwidth2)*(xwidth-xwidth2));

this_box_storage.normal_vectors[2] = coords_set(x_component,0,z_component);
this_box_storage.normal_vectors[3] = coords_set(-x_component,0,z_component);

// for sides with x component = 0
y_component = 2*zdepth/sqrt((yheight-yheight2)*(yheight-yheight2)+4*zdepth*zdepth);
z_component = (yheight-yheight2)/sqrt(4*zdepth*zdepth+(yheight-yheight2)*(yheight-yheight2));

this_box_storage.normal_vectors[4] = coords_set(0,y_component,z_component);
this_box_storage.normal_vectors[5] = coords_set(0,-y_component,z_component);

this_box_volume.geometry.visualization_on = visualize;

this_box_volume.geometry.geometry_parameters.p_box_storage = &this_box_storage;

// Assign pointers to functions for intersection with the shape, checking if a point is inside the shape
if (this_box_storage.is_rectangle == 1) {
this_box_volume.geometry.intersect_function = &sample_box_intersect_simple;
this_box_volume.geometry.within_function = &r_within_box_simple;
}
else {
this_box_volume.geometry.intersect_function = &sample_box_intersect_advanced;
this_box_volume.geometry.within_function = &r_within_box_advanced;
}

this_box_volume.geometry.shell_points = &box_shell_points;
this_box_volume.geometry.mcdisplay_function = &mcdisplay_box_function;
this_box_volume.geometry.initialize_from_main_function = &initialize_box_geometry_from_main_component;
this_box_volume.geometry.process_rot_allocated = 0;

this_box_volume.geometry.copy_geometry_parameters = &allocate_box_storage_copy;

rot_copy(this_box_volume.geometry.rotation_matrix,ROT_A_CURRENT_COMP); //check how ROT_R_CURRENT_COMP would work
rot_transpose(ROT_A_CURRENT_COMP,this_box_volume.geometry.transpose_rotation_matrix);

// Initialize loggers
this_box_volume.loggers.num_elements = 0;

// packing the information into the global_geometry_element, which is then included in the global_geometry_list.
sprintf(global_geometry_element.name,NAME_CURRENT_COMP);
global_geometry_element.activation_counter = number_of_activations;
global_geometry_element.component_index = INDEX_CURRENT_COMP;
global_geometry_element.Volume = &this_box_volume; // Would be nicer if this m was a pointer, now we have the (small) data two places
add_element_to_geometry_list(&global_geometry_list,global_geometry_element);
}
#line 287288 "MACS_sample_kidney_box.c"
#undef number_of_activations
#undef mask_setting
#undef mask_string
#undef p_interact
#undef focus_r
#undef focus_xh
#undef focus_xw
#undef focus_ah
#undef focus_aw
#undef target_z
#undef target_y
#undef target_x
#undef target_index
#undef visualize
#undef yheight2
#undef xwidth2
#undef zdepth
#undef yheight
#undef xwidth
#undef priority
#undef material_string
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

  /* Initializations for component diffraction_detector_13_exit_volume. */
  SIG_MESSAGE("diffraction_detector_13_exit_volume (Init)");
#define mccompcurname  diffraction_detector_13_exit_volume
#define mccompcurtype  Union_box
#define mccompcurindex 654
#define loop_index mccdiffraction_detector_13_exit_volume_loop_index
#define this_box_volume mccdiffraction_detector_13_exit_volume_this_box_volume
#define global_geometry_element mccdiffraction_detector_13_exit_volume_global_geometry_element
#define this_box_storage mccdiffraction_detector_13_exit_volume_this_box_storage
#define material_string mccdiffraction_detector_13_exit_volume_material_string
#define priority mccdiffraction_detector_13_exit_volume_priority
#define xwidth mccdiffraction_detector_13_exit_volume_xwidth
#define yheight mccdiffraction_detector_13_exit_volume_yheight
#define zdepth mccdiffraction_detector_13_exit_volume_zdepth
#define xwidth2 mccdiffraction_detector_13_exit_volume_xwidth2
#define yheight2 mccdiffraction_detector_13_exit_volume_yheight2
#define visualize mccdiffraction_detector_13_exit_volume_visualize
#define target_index mccdiffraction_detector_13_exit_volume_target_index
#define target_x mccdiffraction_detector_13_exit_volume_target_x
#define target_y mccdiffraction_detector_13_exit_volume_target_y
#define target_z mccdiffraction_detector_13_exit_volume_target_z
#define focus_aw mccdiffraction_detector_13_exit_volume_focus_aw
#define focus_ah mccdiffraction_detector_13_exit_volume_focus_ah
#define focus_xw mccdiffraction_detector_13_exit_volume_focus_xw
#define focus_xh mccdiffraction_detector_13_exit_volume_focus_xh
#define focus_r mccdiffraction_detector_13_exit_volume_focus_r
#define p_interact mccdiffraction_detector_13_exit_volume_p_interact
#define mask_string mccdiffraction_detector_13_exit_volume_mask_string
#define mask_setting mccdiffraction_detector_13_exit_volume_mask_setting
#define number_of_activations mccdiffraction_detector_13_exit_volume_number_of_activations
#line 224 "Union_box.comp"
{
// Initializes the focusing system for this volume including input sanitation.
focus_initialize(&this_box_volume.geometry, POS_A_COMP_INDEX(INDEX_CURRENT_COMP+target_index), POS_A_CURRENT_COMP, ROT_A_CURRENT_COMP, target_index, target_x, target_y, target_z, focus_aw, focus_ah, focus_xw, focus_xh, focus_r, NAME_CURRENT_COMP);

// Input sanitation for this geometry
if (xwidth <= 0) {
  printf("\nERROR in Union_box named %s, the xwidth is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (yheight <= 0) {
  printf("\nERROR in Union_box named %s, yheight is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (zdepth <= 0) {
  printf("\nERROR in Union_box named %s, zdepth is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (xwidth2 <= 0 && xwidth2 != -1) {
  printf("\nERROR in Union_box named %s, the xwidth2 is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (yheight2 <= 0 && yheight2 != -1) {
  printf("\nERROR in Union_box named %s, yheight2 is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}

// Use sanitation
if (global_material_list.num_elements == 0) {
  printf("\nERROR: Need to define a material using Union_make_material before using a Union geometry component. \n");
  printf("       %s was defined before first use of Union_make_material.\n",NAME_CURRENT_COMP);
  exit(1);
}

this_box_volume.geometry.is_masked_volume = 0;
this_box_volume.geometry.is_exit_volume = 0;
this_box_volume.geometry.is_mask_volume = 0;
// check if the volume is a mask, if it is the material string is irelevant.
if (mask_string && strlen(mask_string) && strcmp(mask_string, "NULL") && strcmp(mask_string, "0")) {
    // A mask volume is used to limit the extend of other volumes, called the masked volumes. These are specified in the mask_string.
    // In order for a ray to enter a masked volume, it needs to be both in the region covered by that volume AND the mask volume.
    // When more than
    this_box_volume.geometry.mask_mode = 1; // Default is mask mode is ALL
    if (mask_setting && strlen(mask_setting) && strcmp(mask_setting, "NULL") && strcmp(mask_setting, "0")) {
        if (strcmp(mask_setting,"ALL") == 0 || strcmp(mask_setting,"All") == 0) this_box_volume.geometry.mask_mode = 1;
        else if (strcmp(mask_setting,"ANY") == 0 || strcmp(mask_setting,"Any") == 0) this_box_volume.geometry.mask_mode = 2;
        else {
            printf("The mask_mode of component %s is set to %s, but must be either ALL or ANY.\n",NAME_CURRENT_COMP,mask_setting);
            exit(1);
        }
    }
    
    for (loop_index=0;loop_index<global_geometry_list.num_elements;loop_index++) {
        // Add mask list
        if (1 == manual_linking_function(global_geometry_list.elements[loop_index].name,mask_string)) {
            add_element_to_int_list(&this_box_volume.geometry.mask_list,global_geometry_list.elements[loop_index].component_index);
            add_element_to_int_list(&global_geometry_list.elements[loop_index].Volume->geometry.masked_by_list,INDEX_CURRENT_COMP);
            global_geometry_list.elements[loop_index].Volume->geometry.is_masked_volume = 1;
            if (this_box_volume.geometry.mask_mode == 2)
                global_geometry_list.elements[loop_index].Volume->geometry.mask_mode = 2;
            if (this_box_volume.geometry.mask_mode == 1) {
                if (global_geometry_list.elements[loop_index].Volume->geometry.is_masked_volume == 1 && global_geometry_list.elements[loop_index].Volume->geometry.mask_mode != 2)
                    // If more than one mask is added to one volume, the ANY mode overwrites the (default) ALL mode.
                    global_geometry_list.elements[loop_index].Volume->geometry.mask_mode = 1;
            }
            
            found_geometries = 1;
        }
    }
    if (found_geometries == 0) {
        printf("The mask_string in geometry: %s did not find any of the specified volumes in the mask_string %s \n",NAME_CURRENT_COMP,mask_string);
        exit(1);
    }
    this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
    this_box_volume.p_physics->is_vacuum = 0; // Makes this volume a vacuum
    this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
    this_box_volume.p_physics->my_a = 0; // Should not be used.
    sprintf(this_box_volume.p_physics->name,"Mask");
    this_box_volume.geometry.is_mask_volume = 1;
    
    
// Read the material input, or if it lacks, use automatic linking.
} else if (material_string && strlen(material_string) && strcmp(material_string, "NULL") && strcmp(material_string, "0")) {
    // A geometry string was given, use it to determine which material
    if (0 == strcmp(material_string,"vacuum") || 0 == strcmp(material_string,"Vacuum")) {
        // One could have a global physics struct for vacuum instead of creating one for each
        this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
        this_box_volume.p_physics->is_vacuum = 1; // Makes this volume a vacuum
        this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
        this_box_volume.p_physics->my_a = 0; // Should not be used.
        sprintf(this_box_volume.p_physics->name,"Vacuum");
    } else if (0 == strcmp(material_string,"exit") || 0 == strcmp(material_string,"Exit")) {
        // One could have a global physics struct for vacuum instead of creating one for each
        this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
        this_box_volume.p_physics->is_vacuum = 1; // Makes this volume a vacuum
        this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
        this_box_volume.p_physics->my_a = 0; // Should not be used.
        this_box_volume.geometry.is_exit_volume = 1;
        sprintf(this_box_volume.p_physics->name,"Exit");
    } else {
        #ifndef MATERIAL_DETECTOR
            printf("Need to define a material before refering to it in a geometry %s.\n",NAME_CURRENT_COMP);
            exit(1);
        #endif
        for (loop_index=0;loop_index<global_material_list.num_elements;loop_index++) {
            if (0 == strcmp(material_string,global_material_list.elements[loop_index].name)) {
                this_box_volume.p_physics = global_material_list.elements[loop_index].physics;
                break;
            }
            if (loop_index == global_material_list.num_elements-1) {
            printf("\n");
            printf("ERROR: The material string \"%s\" in Union geometry \"%s\" did not match a specified material. \n",material_string,NAME_CURRENT_COMP);
            printf("       The materials available at this point (need to be defined before the geometry): \n");
            for (loop_index=0;loop_index<global_material_list.num_elements;loop_index++)
              printf("         %s\n",global_material_list.elements[loop_index].name);
            printf("\n");
            printf("       It is also possible to use one of the defualt materials avaiable: \n");
            printf("           Vacuum (for a Volume without scattering or absorption)\n");
            printf("           Exit (for a Volume where the ray exits the component if it enters)\n");
            printf("           Mask (for a Volume that masks existing volumes specified in the mask_string\n");
            exit(1);
          }
        }
    }
} else {
    // Automatic linking, simply using the last defined material.
    #ifndef MATERIAL_DETECTOR
        printf("Need to define a material before the geometry to use automatic linking %s.\n",NAME_CURRENT_COMP);
        exit(1);
    #endif
    this_box_volume.p_physics = global_material_list.elements[global_material_list.num_elements-1].physics;
}

sprintf(this_box_volume.name,NAME_CURRENT_COMP);
sprintf(this_box_volume.geometry.shape,"box");
this_box_volume.geometry.priority_value = priority;
this_box_volume.geometry.geometry_p_interact = p_interact;
// Currently the coordinates will be in absolute space.
this_box_volume.geometry.center = POS_A_CURRENT_COMP;

this_box_storage.z_depth = zdepth;
this_box_storage.x_width1 = xwidth;
this_box_storage.y_height1 = yheight;

this_box_storage.is_rectangle = 0;
if (xwidth2 < 0 && yheight2 < 0) this_box_storage.is_rectangle = 1;
if (xwidth == xwidth2 && yheight == yheight2) this_box_storage.is_rectangle = 1;

if (xwidth2 < 0) {
    this_box_storage.x_width2 = xwidth;
    xwidth2 = xwidth;
} else this_box_storage.x_width2 = xwidth2;

if (yheight2 < 0) {
    this_box_storage.y_height2 = yheight;
    yheight2 = yheight;
} else this_box_storage.y_height2 = yheight2;


this_box_storage.normal_vectors[0] = coords_set(0,0,1);
this_box_storage.normal_vectors[1] = coords_set(0,0,1);

// for sides with y component = 0
x_component = 2*zdepth/sqrt((xwidth-xwidth2)*(xwidth-xwidth2)+4*zdepth*zdepth);
z_component = (xwidth-xwidth2)/sqrt(4*zdepth*zdepth+(xwidth-xwidth2)*(xwidth-xwidth2));

this_box_storage.normal_vectors[2] = coords_set(x_component,0,z_component);
this_box_storage.normal_vectors[3] = coords_set(-x_component,0,z_component);

// for sides with x component = 0
y_component = 2*zdepth/sqrt((yheight-yheight2)*(yheight-yheight2)+4*zdepth*zdepth);
z_component = (yheight-yheight2)/sqrt(4*zdepth*zdepth+(yheight-yheight2)*(yheight-yheight2));

this_box_storage.normal_vectors[4] = coords_set(0,y_component,z_component);
this_box_storage.normal_vectors[5] = coords_set(0,-y_component,z_component);

this_box_volume.geometry.visualization_on = visualize;

this_box_volume.geometry.geometry_parameters.p_box_storage = &this_box_storage;

// Assign pointers to functions for intersection with the shape, checking if a point is inside the shape
if (this_box_storage.is_rectangle == 1) {
this_box_volume.geometry.intersect_function = &sample_box_intersect_simple;
this_box_volume.geometry.within_function = &r_within_box_simple;
}
else {
this_box_volume.geometry.intersect_function = &sample_box_intersect_advanced;
this_box_volume.geometry.within_function = &r_within_box_advanced;
}

this_box_volume.geometry.shell_points = &box_shell_points;
this_box_volume.geometry.mcdisplay_function = &mcdisplay_box_function;
this_box_volume.geometry.initialize_from_main_function = &initialize_box_geometry_from_main_component;
this_box_volume.geometry.process_rot_allocated = 0;

this_box_volume.geometry.copy_geometry_parameters = &allocate_box_storage_copy;

rot_copy(this_box_volume.geometry.rotation_matrix,ROT_A_CURRENT_COMP); //check how ROT_R_CURRENT_COMP would work
rot_transpose(ROT_A_CURRENT_COMP,this_box_volume.geometry.transpose_rotation_matrix);

// Initialize loggers
this_box_volume.loggers.num_elements = 0;

// packing the information into the global_geometry_element, which is then included in the global_geometry_list.
sprintf(global_geometry_element.name,NAME_CURRENT_COMP);
global_geometry_element.activation_counter = number_of_activations;
global_geometry_element.component_index = INDEX_CURRENT_COMP;
global_geometry_element.Volume = &this_box_volume; // Would be nicer if this m was a pointer, now we have the (small) data two places
add_element_to_geometry_list(&global_geometry_list,global_geometry_element);
}
#line 287558 "MACS_sample_kidney_box.c"
#undef number_of_activations
#undef mask_setting
#undef mask_string
#undef p_interact
#undef focus_r
#undef focus_xh
#undef focus_xw
#undef focus_ah
#undef focus_aw
#undef target_z
#undef target_y
#undef target_x
#undef target_index
#undef visualize
#undef yheight2
#undef xwidth2
#undef zdepth
#undef yheight
#undef xwidth
#undef priority
#undef material_string
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

  /* Initializations for component spec_detector_13_exit_volume. */
  SIG_MESSAGE("spec_detector_13_exit_volume (Init)");
#define mccompcurname  spec_detector_13_exit_volume
#define mccompcurtype  Union_box
#define mccompcurindex 655
#define loop_index mccspec_detector_13_exit_volume_loop_index
#define this_box_volume mccspec_detector_13_exit_volume_this_box_volume
#define global_geometry_element mccspec_detector_13_exit_volume_global_geometry_element
#define this_box_storage mccspec_detector_13_exit_volume_this_box_storage
#define material_string mccspec_detector_13_exit_volume_material_string
#define priority mccspec_detector_13_exit_volume_priority
#define xwidth mccspec_detector_13_exit_volume_xwidth
#define yheight mccspec_detector_13_exit_volume_yheight
#define zdepth mccspec_detector_13_exit_volume_zdepth
#define xwidth2 mccspec_detector_13_exit_volume_xwidth2
#define yheight2 mccspec_detector_13_exit_volume_yheight2
#define visualize mccspec_detector_13_exit_volume_visualize
#define target_index mccspec_detector_13_exit_volume_target_index
#define target_x mccspec_detector_13_exit_volume_target_x
#define target_y mccspec_detector_13_exit_volume_target_y
#define target_z mccspec_detector_13_exit_volume_target_z
#define focus_aw mccspec_detector_13_exit_volume_focus_aw
#define focus_ah mccspec_detector_13_exit_volume_focus_ah
#define focus_xw mccspec_detector_13_exit_volume_focus_xw
#define focus_xh mccspec_detector_13_exit_volume_focus_xh
#define focus_r mccspec_detector_13_exit_volume_focus_r
#define p_interact mccspec_detector_13_exit_volume_p_interact
#define mask_string mccspec_detector_13_exit_volume_mask_string
#define mask_setting mccspec_detector_13_exit_volume_mask_setting
#define number_of_activations mccspec_detector_13_exit_volume_number_of_activations
#line 224 "Union_box.comp"
{
// Initializes the focusing system for this volume including input sanitation.
focus_initialize(&this_box_volume.geometry, POS_A_COMP_INDEX(INDEX_CURRENT_COMP+target_index), POS_A_CURRENT_COMP, ROT_A_CURRENT_COMP, target_index, target_x, target_y, target_z, focus_aw, focus_ah, focus_xw, focus_xh, focus_r, NAME_CURRENT_COMP);

// Input sanitation for this geometry
if (xwidth <= 0) {
  printf("\nERROR in Union_box named %s, the xwidth is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (yheight <= 0) {
  printf("\nERROR in Union_box named %s, yheight is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (zdepth <= 0) {
  printf("\nERROR in Union_box named %s, zdepth is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (xwidth2 <= 0 && xwidth2 != -1) {
  printf("\nERROR in Union_box named %s, the xwidth2 is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (yheight2 <= 0 && yheight2 != -1) {
  printf("\nERROR in Union_box named %s, yheight2 is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}

// Use sanitation
if (global_material_list.num_elements == 0) {
  printf("\nERROR: Need to define a material using Union_make_material before using a Union geometry component. \n");
  printf("       %s was defined before first use of Union_make_material.\n",NAME_CURRENT_COMP);
  exit(1);
}

this_box_volume.geometry.is_masked_volume = 0;
this_box_volume.geometry.is_exit_volume = 0;
this_box_volume.geometry.is_mask_volume = 0;
// check if the volume is a mask, if it is the material string is irelevant.
if (mask_string && strlen(mask_string) && strcmp(mask_string, "NULL") && strcmp(mask_string, "0")) {
    // A mask volume is used to limit the extend of other volumes, called the masked volumes. These are specified in the mask_string.
    // In order for a ray to enter a masked volume, it needs to be both in the region covered by that volume AND the mask volume.
    // When more than
    this_box_volume.geometry.mask_mode = 1; // Default is mask mode is ALL
    if (mask_setting && strlen(mask_setting) && strcmp(mask_setting, "NULL") && strcmp(mask_setting, "0")) {
        if (strcmp(mask_setting,"ALL") == 0 || strcmp(mask_setting,"All") == 0) this_box_volume.geometry.mask_mode = 1;
        else if (strcmp(mask_setting,"ANY") == 0 || strcmp(mask_setting,"Any") == 0) this_box_volume.geometry.mask_mode = 2;
        else {
            printf("The mask_mode of component %s is set to %s, but must be either ALL or ANY.\n",NAME_CURRENT_COMP,mask_setting);
            exit(1);
        }
    }
    
    for (loop_index=0;loop_index<global_geometry_list.num_elements;loop_index++) {
        // Add mask list
        if (1 == manual_linking_function(global_geometry_list.elements[loop_index].name,mask_string)) {
            add_element_to_int_list(&this_box_volume.geometry.mask_list,global_geometry_list.elements[loop_index].component_index);
            add_element_to_int_list(&global_geometry_list.elements[loop_index].Volume->geometry.masked_by_list,INDEX_CURRENT_COMP);
            global_geometry_list.elements[loop_index].Volume->geometry.is_masked_volume = 1;
            if (this_box_volume.geometry.mask_mode == 2)
                global_geometry_list.elements[loop_index].Volume->geometry.mask_mode = 2;
            if (this_box_volume.geometry.mask_mode == 1) {
                if (global_geometry_list.elements[loop_index].Volume->geometry.is_masked_volume == 1 && global_geometry_list.elements[loop_index].Volume->geometry.mask_mode != 2)
                    // If more than one mask is added to one volume, the ANY mode overwrites the (default) ALL mode.
                    global_geometry_list.elements[loop_index].Volume->geometry.mask_mode = 1;
            }
            
            found_geometries = 1;
        }
    }
    if (found_geometries == 0) {
        printf("The mask_string in geometry: %s did not find any of the specified volumes in the mask_string %s \n",NAME_CURRENT_COMP,mask_string);
        exit(1);
    }
    this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
    this_box_volume.p_physics->is_vacuum = 0; // Makes this volume a vacuum
    this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
    this_box_volume.p_physics->my_a = 0; // Should not be used.
    sprintf(this_box_volume.p_physics->name,"Mask");
    this_box_volume.geometry.is_mask_volume = 1;
    
    
// Read the material input, or if it lacks, use automatic linking.
} else if (material_string && strlen(material_string) && strcmp(material_string, "NULL") && strcmp(material_string, "0")) {
    // A geometry string was given, use it to determine which material
    if (0 == strcmp(material_string,"vacuum") || 0 == strcmp(material_string,"Vacuum")) {
        // One could have a global physics struct for vacuum instead of creating one for each
        this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
        this_box_volume.p_physics->is_vacuum = 1; // Makes this volume a vacuum
        this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
        this_box_volume.p_physics->my_a = 0; // Should not be used.
        sprintf(this_box_volume.p_physics->name,"Vacuum");
    } else if (0 == strcmp(material_string,"exit") || 0 == strcmp(material_string,"Exit")) {
        // One could have a global physics struct for vacuum instead of creating one for each
        this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
        this_box_volume.p_physics->is_vacuum = 1; // Makes this volume a vacuum
        this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
        this_box_volume.p_physics->my_a = 0; // Should not be used.
        this_box_volume.geometry.is_exit_volume = 1;
        sprintf(this_box_volume.p_physics->name,"Exit");
    } else {
        #ifndef MATERIAL_DETECTOR
            printf("Need to define a material before refering to it in a geometry %s.\n",NAME_CURRENT_COMP);
            exit(1);
        #endif
        for (loop_index=0;loop_index<global_material_list.num_elements;loop_index++) {
            if (0 == strcmp(material_string,global_material_list.elements[loop_index].name)) {
                this_box_volume.p_physics = global_material_list.elements[loop_index].physics;
                break;
            }
            if (loop_index == global_material_list.num_elements-1) {
            printf("\n");
            printf("ERROR: The material string \"%s\" in Union geometry \"%s\" did not match a specified material. \n",material_string,NAME_CURRENT_COMP);
            printf("       The materials available at this point (need to be defined before the geometry): \n");
            for (loop_index=0;loop_index<global_material_list.num_elements;loop_index++)
              printf("         %s\n",global_material_list.elements[loop_index].name);
            printf("\n");
            printf("       It is also possible to use one of the defualt materials avaiable: \n");
            printf("           Vacuum (for a Volume without scattering or absorption)\n");
            printf("           Exit (for a Volume where the ray exits the component if it enters)\n");
            printf("           Mask (for a Volume that masks existing volumes specified in the mask_string\n");
            exit(1);
          }
        }
    }
} else {
    // Automatic linking, simply using the last defined material.
    #ifndef MATERIAL_DETECTOR
        printf("Need to define a material before the geometry to use automatic linking %s.\n",NAME_CURRENT_COMP);
        exit(1);
    #endif
    this_box_volume.p_physics = global_material_list.elements[global_material_list.num_elements-1].physics;
}

sprintf(this_box_volume.name,NAME_CURRENT_COMP);
sprintf(this_box_volume.geometry.shape,"box");
this_box_volume.geometry.priority_value = priority;
this_box_volume.geometry.geometry_p_interact = p_interact;
// Currently the coordinates will be in absolute space.
this_box_volume.geometry.center = POS_A_CURRENT_COMP;

this_box_storage.z_depth = zdepth;
this_box_storage.x_width1 = xwidth;
this_box_storage.y_height1 = yheight;

this_box_storage.is_rectangle = 0;
if (xwidth2 < 0 && yheight2 < 0) this_box_storage.is_rectangle = 1;
if (xwidth == xwidth2 && yheight == yheight2) this_box_storage.is_rectangle = 1;

if (xwidth2 < 0) {
    this_box_storage.x_width2 = xwidth;
    xwidth2 = xwidth;
} else this_box_storage.x_width2 = xwidth2;

if (yheight2 < 0) {
    this_box_storage.y_height2 = yheight;
    yheight2 = yheight;
} else this_box_storage.y_height2 = yheight2;


this_box_storage.normal_vectors[0] = coords_set(0,0,1);
this_box_storage.normal_vectors[1] = coords_set(0,0,1);

// for sides with y component = 0
x_component = 2*zdepth/sqrt((xwidth-xwidth2)*(xwidth-xwidth2)+4*zdepth*zdepth);
z_component = (xwidth-xwidth2)/sqrt(4*zdepth*zdepth+(xwidth-xwidth2)*(xwidth-xwidth2));

this_box_storage.normal_vectors[2] = coords_set(x_component,0,z_component);
this_box_storage.normal_vectors[3] = coords_set(-x_component,0,z_component);

// for sides with x component = 0
y_component = 2*zdepth/sqrt((yheight-yheight2)*(yheight-yheight2)+4*zdepth*zdepth);
z_component = (yheight-yheight2)/sqrt(4*zdepth*zdepth+(yheight-yheight2)*(yheight-yheight2));

this_box_storage.normal_vectors[4] = coords_set(0,y_component,z_component);
this_box_storage.normal_vectors[5] = coords_set(0,-y_component,z_component);

this_box_volume.geometry.visualization_on = visualize;

this_box_volume.geometry.geometry_parameters.p_box_storage = &this_box_storage;

// Assign pointers to functions for intersection with the shape, checking if a point is inside the shape
if (this_box_storage.is_rectangle == 1) {
this_box_volume.geometry.intersect_function = &sample_box_intersect_simple;
this_box_volume.geometry.within_function = &r_within_box_simple;
}
else {
this_box_volume.geometry.intersect_function = &sample_box_intersect_advanced;
this_box_volume.geometry.within_function = &r_within_box_advanced;
}

this_box_volume.geometry.shell_points = &box_shell_points;
this_box_volume.geometry.mcdisplay_function = &mcdisplay_box_function;
this_box_volume.geometry.initialize_from_main_function = &initialize_box_geometry_from_main_component;
this_box_volume.geometry.process_rot_allocated = 0;

this_box_volume.geometry.copy_geometry_parameters = &allocate_box_storage_copy;

rot_copy(this_box_volume.geometry.rotation_matrix,ROT_A_CURRENT_COMP); //check how ROT_R_CURRENT_COMP would work
rot_transpose(ROT_A_CURRENT_COMP,this_box_volume.geometry.transpose_rotation_matrix);

// Initialize loggers
this_box_volume.loggers.num_elements = 0;

// packing the information into the global_geometry_element, which is then included in the global_geometry_list.
sprintf(global_geometry_element.name,NAME_CURRENT_COMP);
global_geometry_element.activation_counter = number_of_activations;
global_geometry_element.component_index = INDEX_CURRENT_COMP;
global_geometry_element.Volume = &this_box_volume; // Would be nicer if this m was a pointer, now we have the (small) data two places
add_element_to_geometry_list(&global_geometry_list,global_geometry_element);
}
#line 287828 "MACS_sample_kidney_box.c"
#undef number_of_activations
#undef mask_setting
#undef mask_string
#undef p_interact
#undef focus_r
#undef focus_xh
#undef focus_xw
#undef focus_ah
#undef focus_aw
#undef target_z
#undef target_y
#undef target_x
#undef target_index
#undef visualize
#undef yheight2
#undef xwidth2
#undef zdepth
#undef yheight
#undef xwidth
#undef priority
#undef material_string
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

  /* Initializations for component channel_14_cave1_box1. */
  SIG_MESSAGE("channel_14_cave1_box1 (Init)");
#define mccompcurname  channel_14_cave1_box1
#define mccompcurtype  Union_box
#define mccompcurindex 656
#define loop_index mccchannel_14_cave1_box1_loop_index
#define this_box_volume mccchannel_14_cave1_box1_this_box_volume
#define global_geometry_element mccchannel_14_cave1_box1_global_geometry_element
#define this_box_storage mccchannel_14_cave1_box1_this_box_storage
#define material_string mccchannel_14_cave1_box1_material_string
#define priority mccchannel_14_cave1_box1_priority
#define xwidth mccchannel_14_cave1_box1_xwidth
#define yheight mccchannel_14_cave1_box1_yheight
#define zdepth mccchannel_14_cave1_box1_zdepth
#define xwidth2 mccchannel_14_cave1_box1_xwidth2
#define yheight2 mccchannel_14_cave1_box1_yheight2
#define visualize mccchannel_14_cave1_box1_visualize
#define target_index mccchannel_14_cave1_box1_target_index
#define target_x mccchannel_14_cave1_box1_target_x
#define target_y mccchannel_14_cave1_box1_target_y
#define target_z mccchannel_14_cave1_box1_target_z
#define focus_aw mccchannel_14_cave1_box1_focus_aw
#define focus_ah mccchannel_14_cave1_box1_focus_ah
#define focus_xw mccchannel_14_cave1_box1_focus_xw
#define focus_xh mccchannel_14_cave1_box1_focus_xh
#define focus_r mccchannel_14_cave1_box1_focus_r
#define p_interact mccchannel_14_cave1_box1_p_interact
#define mask_string mccchannel_14_cave1_box1_mask_string
#define mask_setting mccchannel_14_cave1_box1_mask_setting
#define number_of_activations mccchannel_14_cave1_box1_number_of_activations
#line 224 "Union_box.comp"
{
// Initializes the focusing system for this volume including input sanitation.
focus_initialize(&this_box_volume.geometry, POS_A_COMP_INDEX(INDEX_CURRENT_COMP+target_index), POS_A_CURRENT_COMP, ROT_A_CURRENT_COMP, target_index, target_x, target_y, target_z, focus_aw, focus_ah, focus_xw, focus_xh, focus_r, NAME_CURRENT_COMP);

// Input sanitation for this geometry
if (xwidth <= 0) {
  printf("\nERROR in Union_box named %s, the xwidth is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (yheight <= 0) {
  printf("\nERROR in Union_box named %s, yheight is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (zdepth <= 0) {
  printf("\nERROR in Union_box named %s, zdepth is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (xwidth2 <= 0 && xwidth2 != -1) {
  printf("\nERROR in Union_box named %s, the xwidth2 is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (yheight2 <= 0 && yheight2 != -1) {
  printf("\nERROR in Union_box named %s, yheight2 is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}

// Use sanitation
if (global_material_list.num_elements == 0) {
  printf("\nERROR: Need to define a material using Union_make_material before using a Union geometry component. \n");
  printf("       %s was defined before first use of Union_make_material.\n",NAME_CURRENT_COMP);
  exit(1);
}

this_box_volume.geometry.is_masked_volume = 0;
this_box_volume.geometry.is_exit_volume = 0;
this_box_volume.geometry.is_mask_volume = 0;
// check if the volume is a mask, if it is the material string is irelevant.
if (mask_string && strlen(mask_string) && strcmp(mask_string, "NULL") && strcmp(mask_string, "0")) {
    // A mask volume is used to limit the extend of other volumes, called the masked volumes. These are specified in the mask_string.
    // In order for a ray to enter a masked volume, it needs to be both in the region covered by that volume AND the mask volume.
    // When more than
    this_box_volume.geometry.mask_mode = 1; // Default is mask mode is ALL
    if (mask_setting && strlen(mask_setting) && strcmp(mask_setting, "NULL") && strcmp(mask_setting, "0")) {
        if (strcmp(mask_setting,"ALL") == 0 || strcmp(mask_setting,"All") == 0) this_box_volume.geometry.mask_mode = 1;
        else if (strcmp(mask_setting,"ANY") == 0 || strcmp(mask_setting,"Any") == 0) this_box_volume.geometry.mask_mode = 2;
        else {
            printf("The mask_mode of component %s is set to %s, but must be either ALL or ANY.\n",NAME_CURRENT_COMP,mask_setting);
            exit(1);
        }
    }
    
    for (loop_index=0;loop_index<global_geometry_list.num_elements;loop_index++) {
        // Add mask list
        if (1 == manual_linking_function(global_geometry_list.elements[loop_index].name,mask_string)) {
            add_element_to_int_list(&this_box_volume.geometry.mask_list,global_geometry_list.elements[loop_index].component_index);
            add_element_to_int_list(&global_geometry_list.elements[loop_index].Volume->geometry.masked_by_list,INDEX_CURRENT_COMP);
            global_geometry_list.elements[loop_index].Volume->geometry.is_masked_volume = 1;
            if (this_box_volume.geometry.mask_mode == 2)
                global_geometry_list.elements[loop_index].Volume->geometry.mask_mode = 2;
            if (this_box_volume.geometry.mask_mode == 1) {
                if (global_geometry_list.elements[loop_index].Volume->geometry.is_masked_volume == 1 && global_geometry_list.elements[loop_index].Volume->geometry.mask_mode != 2)
                    // If more than one mask is added to one volume, the ANY mode overwrites the (default) ALL mode.
                    global_geometry_list.elements[loop_index].Volume->geometry.mask_mode = 1;
            }
            
            found_geometries = 1;
        }
    }
    if (found_geometries == 0) {
        printf("The mask_string in geometry: %s did not find any of the specified volumes in the mask_string %s \n",NAME_CURRENT_COMP,mask_string);
        exit(1);
    }
    this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
    this_box_volume.p_physics->is_vacuum = 0; // Makes this volume a vacuum
    this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
    this_box_volume.p_physics->my_a = 0; // Should not be used.
    sprintf(this_box_volume.p_physics->name,"Mask");
    this_box_volume.geometry.is_mask_volume = 1;
    
    
// Read the material input, or if it lacks, use automatic linking.
} else if (material_string && strlen(material_string) && strcmp(material_string, "NULL") && strcmp(material_string, "0")) {
    // A geometry string was given, use it to determine which material
    if (0 == strcmp(material_string,"vacuum") || 0 == strcmp(material_string,"Vacuum")) {
        // One could have a global physics struct for vacuum instead of creating one for each
        this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
        this_box_volume.p_physics->is_vacuum = 1; // Makes this volume a vacuum
        this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
        this_box_volume.p_physics->my_a = 0; // Should not be used.
        sprintf(this_box_volume.p_physics->name,"Vacuum");
    } else if (0 == strcmp(material_string,"exit") || 0 == strcmp(material_string,"Exit")) {
        // One could have a global physics struct for vacuum instead of creating one for each
        this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
        this_box_volume.p_physics->is_vacuum = 1; // Makes this volume a vacuum
        this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
        this_box_volume.p_physics->my_a = 0; // Should not be used.
        this_box_volume.geometry.is_exit_volume = 1;
        sprintf(this_box_volume.p_physics->name,"Exit");
    } else {
        #ifndef MATERIAL_DETECTOR
            printf("Need to define a material before refering to it in a geometry %s.\n",NAME_CURRENT_COMP);
            exit(1);
        #endif
        for (loop_index=0;loop_index<global_material_list.num_elements;loop_index++) {
            if (0 == strcmp(material_string,global_material_list.elements[loop_index].name)) {
                this_box_volume.p_physics = global_material_list.elements[loop_index].physics;
                break;
            }
            if (loop_index == global_material_list.num_elements-1) {
            printf("\n");
            printf("ERROR: The material string \"%s\" in Union geometry \"%s\" did not match a specified material. \n",material_string,NAME_CURRENT_COMP);
            printf("       The materials available at this point (need to be defined before the geometry): \n");
            for (loop_index=0;loop_index<global_material_list.num_elements;loop_index++)
              printf("         %s\n",global_material_list.elements[loop_index].name);
            printf("\n");
            printf("       It is also possible to use one of the defualt materials avaiable: \n");
            printf("           Vacuum (for a Volume without scattering or absorption)\n");
            printf("           Exit (for a Volume where the ray exits the component if it enters)\n");
            printf("           Mask (for a Volume that masks existing volumes specified in the mask_string\n");
            exit(1);
          }
        }
    }
} else {
    // Automatic linking, simply using the last defined material.
    #ifndef MATERIAL_DETECTOR
        printf("Need to define a material before the geometry to use automatic linking %s.\n",NAME_CURRENT_COMP);
        exit(1);
    #endif
    this_box_volume.p_physics = global_material_list.elements[global_material_list.num_elements-1].physics;
}

sprintf(this_box_volume.name,NAME_CURRENT_COMP);
sprintf(this_box_volume.geometry.shape,"box");
this_box_volume.geometry.priority_value = priority;
this_box_volume.geometry.geometry_p_interact = p_interact;
// Currently the coordinates will be in absolute space.
this_box_volume.geometry.center = POS_A_CURRENT_COMP;

this_box_storage.z_depth = zdepth;
this_box_storage.x_width1 = xwidth;
this_box_storage.y_height1 = yheight;

this_box_storage.is_rectangle = 0;
if (xwidth2 < 0 && yheight2 < 0) this_box_storage.is_rectangle = 1;
if (xwidth == xwidth2 && yheight == yheight2) this_box_storage.is_rectangle = 1;

if (xwidth2 < 0) {
    this_box_storage.x_width2 = xwidth;
    xwidth2 = xwidth;
} else this_box_storage.x_width2 = xwidth2;

if (yheight2 < 0) {
    this_box_storage.y_height2 = yheight;
    yheight2 = yheight;
} else this_box_storage.y_height2 = yheight2;


this_box_storage.normal_vectors[0] = coords_set(0,0,1);
this_box_storage.normal_vectors[1] = coords_set(0,0,1);

// for sides with y component = 0
x_component = 2*zdepth/sqrt((xwidth-xwidth2)*(xwidth-xwidth2)+4*zdepth*zdepth);
z_component = (xwidth-xwidth2)/sqrt(4*zdepth*zdepth+(xwidth-xwidth2)*(xwidth-xwidth2));

this_box_storage.normal_vectors[2] = coords_set(x_component,0,z_component);
this_box_storage.normal_vectors[3] = coords_set(-x_component,0,z_component);

// for sides with x component = 0
y_component = 2*zdepth/sqrt((yheight-yheight2)*(yheight-yheight2)+4*zdepth*zdepth);
z_component = (yheight-yheight2)/sqrt(4*zdepth*zdepth+(yheight-yheight2)*(yheight-yheight2));

this_box_storage.normal_vectors[4] = coords_set(0,y_component,z_component);
this_box_storage.normal_vectors[5] = coords_set(0,-y_component,z_component);

this_box_volume.geometry.visualization_on = visualize;

this_box_volume.geometry.geometry_parameters.p_box_storage = &this_box_storage;

// Assign pointers to functions for intersection with the shape, checking if a point is inside the shape
if (this_box_storage.is_rectangle == 1) {
this_box_volume.geometry.intersect_function = &sample_box_intersect_simple;
this_box_volume.geometry.within_function = &r_within_box_simple;
}
else {
this_box_volume.geometry.intersect_function = &sample_box_intersect_advanced;
this_box_volume.geometry.within_function = &r_within_box_advanced;
}

this_box_volume.geometry.shell_points = &box_shell_points;
this_box_volume.geometry.mcdisplay_function = &mcdisplay_box_function;
this_box_volume.geometry.initialize_from_main_function = &initialize_box_geometry_from_main_component;
this_box_volume.geometry.process_rot_allocated = 0;

this_box_volume.geometry.copy_geometry_parameters = &allocate_box_storage_copy;

rot_copy(this_box_volume.geometry.rotation_matrix,ROT_A_CURRENT_COMP); //check how ROT_R_CURRENT_COMP would work
rot_transpose(ROT_A_CURRENT_COMP,this_box_volume.geometry.transpose_rotation_matrix);

// Initialize loggers
this_box_volume.loggers.num_elements = 0;

// packing the information into the global_geometry_element, which is then included in the global_geometry_list.
sprintf(global_geometry_element.name,NAME_CURRENT_COMP);
global_geometry_element.activation_counter = number_of_activations;
global_geometry_element.component_index = INDEX_CURRENT_COMP;
global_geometry_element.Volume = &this_box_volume; // Would be nicer if this m was a pointer, now we have the (small) data two places
add_element_to_geometry_list(&global_geometry_list,global_geometry_element);
}
#line 288098 "MACS_sample_kidney_box.c"
#undef number_of_activations
#undef mask_setting
#undef mask_string
#undef p_interact
#undef focus_r
#undef focus_xh
#undef focus_xw
#undef focus_ah
#undef focus_aw
#undef target_z
#undef target_y
#undef target_x
#undef target_index
#undef visualize
#undef yheight2
#undef xwidth2
#undef zdepth
#undef yheight
#undef xwidth
#undef priority
#undef material_string
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

  /* Initializations for component channel_14_cave1_box2. */
  SIG_MESSAGE("channel_14_cave1_box2 (Init)");
#define mccompcurname  channel_14_cave1_box2
#define mccompcurtype  Union_box
#define mccompcurindex 657
#define loop_index mccchannel_14_cave1_box2_loop_index
#define this_box_volume mccchannel_14_cave1_box2_this_box_volume
#define global_geometry_element mccchannel_14_cave1_box2_global_geometry_element
#define this_box_storage mccchannel_14_cave1_box2_this_box_storage
#define material_string mccchannel_14_cave1_box2_material_string
#define priority mccchannel_14_cave1_box2_priority
#define xwidth mccchannel_14_cave1_box2_xwidth
#define yheight mccchannel_14_cave1_box2_yheight
#define zdepth mccchannel_14_cave1_box2_zdepth
#define xwidth2 mccchannel_14_cave1_box2_xwidth2
#define yheight2 mccchannel_14_cave1_box2_yheight2
#define visualize mccchannel_14_cave1_box2_visualize
#define target_index mccchannel_14_cave1_box2_target_index
#define target_x mccchannel_14_cave1_box2_target_x
#define target_y mccchannel_14_cave1_box2_target_y
#define target_z mccchannel_14_cave1_box2_target_z
#define focus_aw mccchannel_14_cave1_box2_focus_aw
#define focus_ah mccchannel_14_cave1_box2_focus_ah
#define focus_xw mccchannel_14_cave1_box2_focus_xw
#define focus_xh mccchannel_14_cave1_box2_focus_xh
#define focus_r mccchannel_14_cave1_box2_focus_r
#define p_interact mccchannel_14_cave1_box2_p_interact
#define mask_string mccchannel_14_cave1_box2_mask_string
#define mask_setting mccchannel_14_cave1_box2_mask_setting
#define number_of_activations mccchannel_14_cave1_box2_number_of_activations
#line 224 "Union_box.comp"
{
// Initializes the focusing system for this volume including input sanitation.
focus_initialize(&this_box_volume.geometry, POS_A_COMP_INDEX(INDEX_CURRENT_COMP+target_index), POS_A_CURRENT_COMP, ROT_A_CURRENT_COMP, target_index, target_x, target_y, target_z, focus_aw, focus_ah, focus_xw, focus_xh, focus_r, NAME_CURRENT_COMP);

// Input sanitation for this geometry
if (xwidth <= 0) {
  printf("\nERROR in Union_box named %s, the xwidth is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (yheight <= 0) {
  printf("\nERROR in Union_box named %s, yheight is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (zdepth <= 0) {
  printf("\nERROR in Union_box named %s, zdepth is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (xwidth2 <= 0 && xwidth2 != -1) {
  printf("\nERROR in Union_box named %s, the xwidth2 is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (yheight2 <= 0 && yheight2 != -1) {
  printf("\nERROR in Union_box named %s, yheight2 is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}

// Use sanitation
if (global_material_list.num_elements == 0) {
  printf("\nERROR: Need to define a material using Union_make_material before using a Union geometry component. \n");
  printf("       %s was defined before first use of Union_make_material.\n",NAME_CURRENT_COMP);
  exit(1);
}

this_box_volume.geometry.is_masked_volume = 0;
this_box_volume.geometry.is_exit_volume = 0;
this_box_volume.geometry.is_mask_volume = 0;
// check if the volume is a mask, if it is the material string is irelevant.
if (mask_string && strlen(mask_string) && strcmp(mask_string, "NULL") && strcmp(mask_string, "0")) {
    // A mask volume is used to limit the extend of other volumes, called the masked volumes. These are specified in the mask_string.
    // In order for a ray to enter a masked volume, it needs to be both in the region covered by that volume AND the mask volume.
    // When more than
    this_box_volume.geometry.mask_mode = 1; // Default is mask mode is ALL
    if (mask_setting && strlen(mask_setting) && strcmp(mask_setting, "NULL") && strcmp(mask_setting, "0")) {
        if (strcmp(mask_setting,"ALL") == 0 || strcmp(mask_setting,"All") == 0) this_box_volume.geometry.mask_mode = 1;
        else if (strcmp(mask_setting,"ANY") == 0 || strcmp(mask_setting,"Any") == 0) this_box_volume.geometry.mask_mode = 2;
        else {
            printf("The mask_mode of component %s is set to %s, but must be either ALL or ANY.\n",NAME_CURRENT_COMP,mask_setting);
            exit(1);
        }
    }
    
    for (loop_index=0;loop_index<global_geometry_list.num_elements;loop_index++) {
        // Add mask list
        if (1 == manual_linking_function(global_geometry_list.elements[loop_index].name,mask_string)) {
            add_element_to_int_list(&this_box_volume.geometry.mask_list,global_geometry_list.elements[loop_index].component_index);
            add_element_to_int_list(&global_geometry_list.elements[loop_index].Volume->geometry.masked_by_list,INDEX_CURRENT_COMP);
            global_geometry_list.elements[loop_index].Volume->geometry.is_masked_volume = 1;
            if (this_box_volume.geometry.mask_mode == 2)
                global_geometry_list.elements[loop_index].Volume->geometry.mask_mode = 2;
            if (this_box_volume.geometry.mask_mode == 1) {
                if (global_geometry_list.elements[loop_index].Volume->geometry.is_masked_volume == 1 && global_geometry_list.elements[loop_index].Volume->geometry.mask_mode != 2)
                    // If more than one mask is added to one volume, the ANY mode overwrites the (default) ALL mode.
                    global_geometry_list.elements[loop_index].Volume->geometry.mask_mode = 1;
            }
            
            found_geometries = 1;
        }
    }
    if (found_geometries == 0) {
        printf("The mask_string in geometry: %s did not find any of the specified volumes in the mask_string %s \n",NAME_CURRENT_COMP,mask_string);
        exit(1);
    }
    this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
    this_box_volume.p_physics->is_vacuum = 0; // Makes this volume a vacuum
    this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
    this_box_volume.p_physics->my_a = 0; // Should not be used.
    sprintf(this_box_volume.p_physics->name,"Mask");
    this_box_volume.geometry.is_mask_volume = 1;
    
    
// Read the material input, or if it lacks, use automatic linking.
} else if (material_string && strlen(material_string) && strcmp(material_string, "NULL") && strcmp(material_string, "0")) {
    // A geometry string was given, use it to determine which material
    if (0 == strcmp(material_string,"vacuum") || 0 == strcmp(material_string,"Vacuum")) {
        // One could have a global physics struct for vacuum instead of creating one for each
        this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
        this_box_volume.p_physics->is_vacuum = 1; // Makes this volume a vacuum
        this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
        this_box_volume.p_physics->my_a = 0; // Should not be used.
        sprintf(this_box_volume.p_physics->name,"Vacuum");
    } else if (0 == strcmp(material_string,"exit") || 0 == strcmp(material_string,"Exit")) {
        // One could have a global physics struct for vacuum instead of creating one for each
        this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
        this_box_volume.p_physics->is_vacuum = 1; // Makes this volume a vacuum
        this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
        this_box_volume.p_physics->my_a = 0; // Should not be used.
        this_box_volume.geometry.is_exit_volume = 1;
        sprintf(this_box_volume.p_physics->name,"Exit");
    } else {
        #ifndef MATERIAL_DETECTOR
            printf("Need to define a material before refering to it in a geometry %s.\n",NAME_CURRENT_COMP);
            exit(1);
        #endif
        for (loop_index=0;loop_index<global_material_list.num_elements;loop_index++) {
            if (0 == strcmp(material_string,global_material_list.elements[loop_index].name)) {
                this_box_volume.p_physics = global_material_list.elements[loop_index].physics;
                break;
            }
            if (loop_index == global_material_list.num_elements-1) {
            printf("\n");
            printf("ERROR: The material string \"%s\" in Union geometry \"%s\" did not match a specified material. \n",material_string,NAME_CURRENT_COMP);
            printf("       The materials available at this point (need to be defined before the geometry): \n");
            for (loop_index=0;loop_index<global_material_list.num_elements;loop_index++)
              printf("         %s\n",global_material_list.elements[loop_index].name);
            printf("\n");
            printf("       It is also possible to use one of the defualt materials avaiable: \n");
            printf("           Vacuum (for a Volume without scattering or absorption)\n");
            printf("           Exit (for a Volume where the ray exits the component if it enters)\n");
            printf("           Mask (for a Volume that masks existing volumes specified in the mask_string\n");
            exit(1);
          }
        }
    }
} else {
    // Automatic linking, simply using the last defined material.
    #ifndef MATERIAL_DETECTOR
        printf("Need to define a material before the geometry to use automatic linking %s.\n",NAME_CURRENT_COMP);
        exit(1);
    #endif
    this_box_volume.p_physics = global_material_list.elements[global_material_list.num_elements-1].physics;
}

sprintf(this_box_volume.name,NAME_CURRENT_COMP);
sprintf(this_box_volume.geometry.shape,"box");
this_box_volume.geometry.priority_value = priority;
this_box_volume.geometry.geometry_p_interact = p_interact;
// Currently the coordinates will be in absolute space.
this_box_volume.geometry.center = POS_A_CURRENT_COMP;

this_box_storage.z_depth = zdepth;
this_box_storage.x_width1 = xwidth;
this_box_storage.y_height1 = yheight;

this_box_storage.is_rectangle = 0;
if (xwidth2 < 0 && yheight2 < 0) this_box_storage.is_rectangle = 1;
if (xwidth == xwidth2 && yheight == yheight2) this_box_storage.is_rectangle = 1;

if (xwidth2 < 0) {
    this_box_storage.x_width2 = xwidth;
    xwidth2 = xwidth;
} else this_box_storage.x_width2 = xwidth2;

if (yheight2 < 0) {
    this_box_storage.y_height2 = yheight;
    yheight2 = yheight;
} else this_box_storage.y_height2 = yheight2;


this_box_storage.normal_vectors[0] = coords_set(0,0,1);
this_box_storage.normal_vectors[1] = coords_set(0,0,1);

// for sides with y component = 0
x_component = 2*zdepth/sqrt((xwidth-xwidth2)*(xwidth-xwidth2)+4*zdepth*zdepth);
z_component = (xwidth-xwidth2)/sqrt(4*zdepth*zdepth+(xwidth-xwidth2)*(xwidth-xwidth2));

this_box_storage.normal_vectors[2] = coords_set(x_component,0,z_component);
this_box_storage.normal_vectors[3] = coords_set(-x_component,0,z_component);

// for sides with x component = 0
y_component = 2*zdepth/sqrt((yheight-yheight2)*(yheight-yheight2)+4*zdepth*zdepth);
z_component = (yheight-yheight2)/sqrt(4*zdepth*zdepth+(yheight-yheight2)*(yheight-yheight2));

this_box_storage.normal_vectors[4] = coords_set(0,y_component,z_component);
this_box_storage.normal_vectors[5] = coords_set(0,-y_component,z_component);

this_box_volume.geometry.visualization_on = visualize;

this_box_volume.geometry.geometry_parameters.p_box_storage = &this_box_storage;

// Assign pointers to functions for intersection with the shape, checking if a point is inside the shape
if (this_box_storage.is_rectangle == 1) {
this_box_volume.geometry.intersect_function = &sample_box_intersect_simple;
this_box_volume.geometry.within_function = &r_within_box_simple;
}
else {
this_box_volume.geometry.intersect_function = &sample_box_intersect_advanced;
this_box_volume.geometry.within_function = &r_within_box_advanced;
}

this_box_volume.geometry.shell_points = &box_shell_points;
this_box_volume.geometry.mcdisplay_function = &mcdisplay_box_function;
this_box_volume.geometry.initialize_from_main_function = &initialize_box_geometry_from_main_component;
this_box_volume.geometry.process_rot_allocated = 0;

this_box_volume.geometry.copy_geometry_parameters = &allocate_box_storage_copy;

rot_copy(this_box_volume.geometry.rotation_matrix,ROT_A_CURRENT_COMP); //check how ROT_R_CURRENT_COMP would work
rot_transpose(ROT_A_CURRENT_COMP,this_box_volume.geometry.transpose_rotation_matrix);

// Initialize loggers
this_box_volume.loggers.num_elements = 0;

// packing the information into the global_geometry_element, which is then included in the global_geometry_list.
sprintf(global_geometry_element.name,NAME_CURRENT_COMP);
global_geometry_element.activation_counter = number_of_activations;
global_geometry_element.component_index = INDEX_CURRENT_COMP;
global_geometry_element.Volume = &this_box_volume; // Would be nicer if this m was a pointer, now we have the (small) data two places
add_element_to_geometry_list(&global_geometry_list,global_geometry_element);
}
#line 288368 "MACS_sample_kidney_box.c"
#undef number_of_activations
#undef mask_setting
#undef mask_string
#undef p_interact
#undef focus_r
#undef focus_xh
#undef focus_xw
#undef focus_ah
#undef focus_aw
#undef target_z
#undef target_y
#undef target_x
#undef target_index
#undef visualize
#undef yheight2
#undef xwidth2
#undef zdepth
#undef yheight
#undef xwidth
#undef priority
#undef material_string
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

  /* Initializations for component channel_14_cave1_box3. */
  SIG_MESSAGE("channel_14_cave1_box3 (Init)");
#define mccompcurname  channel_14_cave1_box3
#define mccompcurtype  Union_box
#define mccompcurindex 658
#define loop_index mccchannel_14_cave1_box3_loop_index
#define this_box_volume mccchannel_14_cave1_box3_this_box_volume
#define global_geometry_element mccchannel_14_cave1_box3_global_geometry_element
#define this_box_storage mccchannel_14_cave1_box3_this_box_storage
#define material_string mccchannel_14_cave1_box3_material_string
#define priority mccchannel_14_cave1_box3_priority
#define xwidth mccchannel_14_cave1_box3_xwidth
#define yheight mccchannel_14_cave1_box3_yheight
#define zdepth mccchannel_14_cave1_box3_zdepth
#define xwidth2 mccchannel_14_cave1_box3_xwidth2
#define yheight2 mccchannel_14_cave1_box3_yheight2
#define visualize mccchannel_14_cave1_box3_visualize
#define target_index mccchannel_14_cave1_box3_target_index
#define target_x mccchannel_14_cave1_box3_target_x
#define target_y mccchannel_14_cave1_box3_target_y
#define target_z mccchannel_14_cave1_box3_target_z
#define focus_aw mccchannel_14_cave1_box3_focus_aw
#define focus_ah mccchannel_14_cave1_box3_focus_ah
#define focus_xw mccchannel_14_cave1_box3_focus_xw
#define focus_xh mccchannel_14_cave1_box3_focus_xh
#define focus_r mccchannel_14_cave1_box3_focus_r
#define p_interact mccchannel_14_cave1_box3_p_interact
#define mask_string mccchannel_14_cave1_box3_mask_string
#define mask_setting mccchannel_14_cave1_box3_mask_setting
#define number_of_activations mccchannel_14_cave1_box3_number_of_activations
#line 224 "Union_box.comp"
{
// Initializes the focusing system for this volume including input sanitation.
focus_initialize(&this_box_volume.geometry, POS_A_COMP_INDEX(INDEX_CURRENT_COMP+target_index), POS_A_CURRENT_COMP, ROT_A_CURRENT_COMP, target_index, target_x, target_y, target_z, focus_aw, focus_ah, focus_xw, focus_xh, focus_r, NAME_CURRENT_COMP);

// Input sanitation for this geometry
if (xwidth <= 0) {
  printf("\nERROR in Union_box named %s, the xwidth is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (yheight <= 0) {
  printf("\nERROR in Union_box named %s, yheight is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (zdepth <= 0) {
  printf("\nERROR in Union_box named %s, zdepth is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (xwidth2 <= 0 && xwidth2 != -1) {
  printf("\nERROR in Union_box named %s, the xwidth2 is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (yheight2 <= 0 && yheight2 != -1) {
  printf("\nERROR in Union_box named %s, yheight2 is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}

// Use sanitation
if (global_material_list.num_elements == 0) {
  printf("\nERROR: Need to define a material using Union_make_material before using a Union geometry component. \n");
  printf("       %s was defined before first use of Union_make_material.\n",NAME_CURRENT_COMP);
  exit(1);
}

this_box_volume.geometry.is_masked_volume = 0;
this_box_volume.geometry.is_exit_volume = 0;
this_box_volume.geometry.is_mask_volume = 0;
// check if the volume is a mask, if it is the material string is irelevant.
if (mask_string && strlen(mask_string) && strcmp(mask_string, "NULL") && strcmp(mask_string, "0")) {
    // A mask volume is used to limit the extend of other volumes, called the masked volumes. These are specified in the mask_string.
    // In order for a ray to enter a masked volume, it needs to be both in the region covered by that volume AND the mask volume.
    // When more than
    this_box_volume.geometry.mask_mode = 1; // Default is mask mode is ALL
    if (mask_setting && strlen(mask_setting) && strcmp(mask_setting, "NULL") && strcmp(mask_setting, "0")) {
        if (strcmp(mask_setting,"ALL") == 0 || strcmp(mask_setting,"All") == 0) this_box_volume.geometry.mask_mode = 1;
        else if (strcmp(mask_setting,"ANY") == 0 || strcmp(mask_setting,"Any") == 0) this_box_volume.geometry.mask_mode = 2;
        else {
            printf("The mask_mode of component %s is set to %s, but must be either ALL or ANY.\n",NAME_CURRENT_COMP,mask_setting);
            exit(1);
        }
    }
    
    for (loop_index=0;loop_index<global_geometry_list.num_elements;loop_index++) {
        // Add mask list
        if (1 == manual_linking_function(global_geometry_list.elements[loop_index].name,mask_string)) {
            add_element_to_int_list(&this_box_volume.geometry.mask_list,global_geometry_list.elements[loop_index].component_index);
            add_element_to_int_list(&global_geometry_list.elements[loop_index].Volume->geometry.masked_by_list,INDEX_CURRENT_COMP);
            global_geometry_list.elements[loop_index].Volume->geometry.is_masked_volume = 1;
            if (this_box_volume.geometry.mask_mode == 2)
                global_geometry_list.elements[loop_index].Volume->geometry.mask_mode = 2;
            if (this_box_volume.geometry.mask_mode == 1) {
                if (global_geometry_list.elements[loop_index].Volume->geometry.is_masked_volume == 1 && global_geometry_list.elements[loop_index].Volume->geometry.mask_mode != 2)
                    // If more than one mask is added to one volume, the ANY mode overwrites the (default) ALL mode.
                    global_geometry_list.elements[loop_index].Volume->geometry.mask_mode = 1;
            }
            
            found_geometries = 1;
        }
    }
    if (found_geometries == 0) {
        printf("The mask_string in geometry: %s did not find any of the specified volumes in the mask_string %s \n",NAME_CURRENT_COMP,mask_string);
        exit(1);
    }
    this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
    this_box_volume.p_physics->is_vacuum = 0; // Makes this volume a vacuum
    this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
    this_box_volume.p_physics->my_a = 0; // Should not be used.
    sprintf(this_box_volume.p_physics->name,"Mask");
    this_box_volume.geometry.is_mask_volume = 1;
    
    
// Read the material input, or if it lacks, use automatic linking.
} else if (material_string && strlen(material_string) && strcmp(material_string, "NULL") && strcmp(material_string, "0")) {
    // A geometry string was given, use it to determine which material
    if (0 == strcmp(material_string,"vacuum") || 0 == strcmp(material_string,"Vacuum")) {
        // One could have a global physics struct for vacuum instead of creating one for each
        this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
        this_box_volume.p_physics->is_vacuum = 1; // Makes this volume a vacuum
        this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
        this_box_volume.p_physics->my_a = 0; // Should not be used.
        sprintf(this_box_volume.p_physics->name,"Vacuum");
    } else if (0 == strcmp(material_string,"exit") || 0 == strcmp(material_string,"Exit")) {
        // One could have a global physics struct for vacuum instead of creating one for each
        this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
        this_box_volume.p_physics->is_vacuum = 1; // Makes this volume a vacuum
        this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
        this_box_volume.p_physics->my_a = 0; // Should not be used.
        this_box_volume.geometry.is_exit_volume = 1;
        sprintf(this_box_volume.p_physics->name,"Exit");
    } else {
        #ifndef MATERIAL_DETECTOR
            printf("Need to define a material before refering to it in a geometry %s.\n",NAME_CURRENT_COMP);
            exit(1);
        #endif
        for (loop_index=0;loop_index<global_material_list.num_elements;loop_index++) {
            if (0 == strcmp(material_string,global_material_list.elements[loop_index].name)) {
                this_box_volume.p_physics = global_material_list.elements[loop_index].physics;
                break;
            }
            if (loop_index == global_material_list.num_elements-1) {
            printf("\n");
            printf("ERROR: The material string \"%s\" in Union geometry \"%s\" did not match a specified material. \n",material_string,NAME_CURRENT_COMP);
            printf("       The materials available at this point (need to be defined before the geometry): \n");
            for (loop_index=0;loop_index<global_material_list.num_elements;loop_index++)
              printf("         %s\n",global_material_list.elements[loop_index].name);
            printf("\n");
            printf("       It is also possible to use one of the defualt materials avaiable: \n");
            printf("           Vacuum (for a Volume without scattering or absorption)\n");
            printf("           Exit (for a Volume where the ray exits the component if it enters)\n");
            printf("           Mask (for a Volume that masks existing volumes specified in the mask_string\n");
            exit(1);
          }
        }
    }
} else {
    // Automatic linking, simply using the last defined material.
    #ifndef MATERIAL_DETECTOR
        printf("Need to define a material before the geometry to use automatic linking %s.\n",NAME_CURRENT_COMP);
        exit(1);
    #endif
    this_box_volume.p_physics = global_material_list.elements[global_material_list.num_elements-1].physics;
}

sprintf(this_box_volume.name,NAME_CURRENT_COMP);
sprintf(this_box_volume.geometry.shape,"box");
this_box_volume.geometry.priority_value = priority;
this_box_volume.geometry.geometry_p_interact = p_interact;
// Currently the coordinates will be in absolute space.
this_box_volume.geometry.center = POS_A_CURRENT_COMP;

this_box_storage.z_depth = zdepth;
this_box_storage.x_width1 = xwidth;
this_box_storage.y_height1 = yheight;

this_box_storage.is_rectangle = 0;
if (xwidth2 < 0 && yheight2 < 0) this_box_storage.is_rectangle = 1;
if (xwidth == xwidth2 && yheight == yheight2) this_box_storage.is_rectangle = 1;

if (xwidth2 < 0) {
    this_box_storage.x_width2 = xwidth;
    xwidth2 = xwidth;
} else this_box_storage.x_width2 = xwidth2;

if (yheight2 < 0) {
    this_box_storage.y_height2 = yheight;
    yheight2 = yheight;
} else this_box_storage.y_height2 = yheight2;


this_box_storage.normal_vectors[0] = coords_set(0,0,1);
this_box_storage.normal_vectors[1] = coords_set(0,0,1);

// for sides with y component = 0
x_component = 2*zdepth/sqrt((xwidth-xwidth2)*(xwidth-xwidth2)+4*zdepth*zdepth);
z_component = (xwidth-xwidth2)/sqrt(4*zdepth*zdepth+(xwidth-xwidth2)*(xwidth-xwidth2));

this_box_storage.normal_vectors[2] = coords_set(x_component,0,z_component);
this_box_storage.normal_vectors[3] = coords_set(-x_component,0,z_component);

// for sides with x component = 0
y_component = 2*zdepth/sqrt((yheight-yheight2)*(yheight-yheight2)+4*zdepth*zdepth);
z_component = (yheight-yheight2)/sqrt(4*zdepth*zdepth+(yheight-yheight2)*(yheight-yheight2));

this_box_storage.normal_vectors[4] = coords_set(0,y_component,z_component);
this_box_storage.normal_vectors[5] = coords_set(0,-y_component,z_component);

this_box_volume.geometry.visualization_on = visualize;

this_box_volume.geometry.geometry_parameters.p_box_storage = &this_box_storage;

// Assign pointers to functions for intersection with the shape, checking if a point is inside the shape
if (this_box_storage.is_rectangle == 1) {
this_box_volume.geometry.intersect_function = &sample_box_intersect_simple;
this_box_volume.geometry.within_function = &r_within_box_simple;
}
else {
this_box_volume.geometry.intersect_function = &sample_box_intersect_advanced;
this_box_volume.geometry.within_function = &r_within_box_advanced;
}

this_box_volume.geometry.shell_points = &box_shell_points;
this_box_volume.geometry.mcdisplay_function = &mcdisplay_box_function;
this_box_volume.geometry.initialize_from_main_function = &initialize_box_geometry_from_main_component;
this_box_volume.geometry.process_rot_allocated = 0;

this_box_volume.geometry.copy_geometry_parameters = &allocate_box_storage_copy;

rot_copy(this_box_volume.geometry.rotation_matrix,ROT_A_CURRENT_COMP); //check how ROT_R_CURRENT_COMP would work
rot_transpose(ROT_A_CURRENT_COMP,this_box_volume.geometry.transpose_rotation_matrix);

// Initialize loggers
this_box_volume.loggers.num_elements = 0;

// packing the information into the global_geometry_element, which is then included in the global_geometry_list.
sprintf(global_geometry_element.name,NAME_CURRENT_COMP);
global_geometry_element.activation_counter = number_of_activations;
global_geometry_element.component_index = INDEX_CURRENT_COMP;
global_geometry_element.Volume = &this_box_volume; // Would be nicer if this m was a pointer, now we have the (small) data two places
add_element_to_geometry_list(&global_geometry_list,global_geometry_element);
}
#line 288638 "MACS_sample_kidney_box.c"
#undef number_of_activations
#undef mask_setting
#undef mask_string
#undef p_interact
#undef focus_r
#undef focus_xh
#undef focus_xw
#undef focus_ah
#undef focus_aw
#undef target_z
#undef target_y
#undef target_x
#undef target_index
#undef visualize
#undef yheight2
#undef xwidth2
#undef zdepth
#undef yheight
#undef xwidth
#undef priority
#undef material_string
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

  /* Initializations for component channel_14_cave1_cyl1. */
  SIG_MESSAGE("channel_14_cave1_cyl1 (Init)");
#define mccompcurname  channel_14_cave1_cyl1
#define mccompcurtype  Union_cylinder
#define mccompcurindex 659
#define loop_index mccchannel_14_cave1_cyl1_loop_index
#define this_cylinder_volume mccchannel_14_cave1_cyl1_this_cylinder_volume
#define global_geometry_element mccchannel_14_cave1_cyl1_global_geometry_element
#define this_cylinder_storage mccchannel_14_cave1_cyl1_this_cylinder_storage
#define material_string mccchannel_14_cave1_cyl1_material_string
#define priority mccchannel_14_cave1_cyl1_priority
#define radius mccchannel_14_cave1_cyl1_radius
#define yheight mccchannel_14_cave1_cyl1_yheight
#define visualize mccchannel_14_cave1_cyl1_visualize
#define target_index mccchannel_14_cave1_cyl1_target_index
#define target_x mccchannel_14_cave1_cyl1_target_x
#define target_y mccchannel_14_cave1_cyl1_target_y
#define target_z mccchannel_14_cave1_cyl1_target_z
#define focus_aw mccchannel_14_cave1_cyl1_focus_aw
#define focus_ah mccchannel_14_cave1_cyl1_focus_ah
#define focus_xw mccchannel_14_cave1_cyl1_focus_xw
#define focus_xh mccchannel_14_cave1_cyl1_focus_xh
#define focus_r mccchannel_14_cave1_cyl1_focus_r
#define p_interact mccchannel_14_cave1_cyl1_p_interact
#define mask_string mccchannel_14_cave1_cyl1_mask_string
#define mask_setting mccchannel_14_cave1_cyl1_mask_setting
#define number_of_activations mccchannel_14_cave1_cyl1_number_of_activations
#line 185 "Union_cylinder.comp"
{
// Initializes the focusing system for this volume including input sanitation.
focus_initialize(&this_cylinder_volume.geometry, POS_A_COMP_INDEX(INDEX_CURRENT_COMP+target_index), POS_A_CURRENT_COMP, ROT_A_CURRENT_COMP, target_index, target_x, target_y, target_z, focus_aw, focus_ah, focus_xw, focus_xh, focus_r, NAME_CURRENT_COMP);

// Input sanitation for this geometry
if (radius <= 0) {
  printf("\nERROR in Union_cylinder named %s, the radius is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}

if (yheight <= 0) {
  printf("\nERROR in Union_cylinder named %s, yheight is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}

// Use sanitation
#ifdef MATERIAL_DETECTOR
if (global_material_list.num_elements == 0) {
  // Here if the user have defined a material, but only after this material
  printf("\nERROR: Need to define a material using Union_make_material before using a Union geometry component. \n");
  printf("       %s was defined before first use of Union_make_material.\n",NAME_CURRENT_COMP);
  exit(1);
}
#endif
#ifndef MATERIAL_DETECTOR
  printf("\nERROR: Need to define a material using Union_make_material before using a Union geometry component. \n");
  exit(1);
#endif


this_cylinder_volume.geometry.is_masked_volume = 0;
this_cylinder_volume.geometry.is_exit_volume = 0;
this_cylinder_volume.geometry.is_mask_volume = 0;

// Read the material input, or if it lacks, use automatic linking.
if (mask_string && strlen(mask_string) && strcmp(mask_string, "NULL") && strcmp(mask_string, "0")) {
    // A mask volume is used to limit the extend of other volumes, called the masked volumes. These are specified in the mask_string.
    // In order for a ray to enter a masked volume, it needs to be both in the region covered by that volume AND the mask volume.
    // When more than
    this_cylinder_volume.geometry.mask_mode = 1; // Default is mask mode is ALL
    if (mask_setting && strlen(mask_setting) && strcmp(mask_setting, "NULL") && strcmp(mask_setting, "0")) {
        if (strcmp(mask_setting,"ALL") == 0 || strcmp(mask_setting,"All") == 0) this_cylinder_volume.geometry.mask_mode = 1;
        else if (strcmp(mask_setting,"ANY") == 0 || strcmp(mask_setting,"Any") == 0) this_cylinder_volume.geometry.mask_mode = 2;
        else {
            printf("The mask_mode of component %s is set to %s, but must be either ALL or ANY.\n",NAME_CURRENT_COMP,mask_setting);
            exit(1);
        }
    }
    
    for (loop_index=0;loop_index<global_geometry_list.num_elements;loop_index++) {
        // Add mask list
        if (1 == manual_linking_function(global_geometry_list.elements[loop_index].name,mask_string)) {
            add_element_to_int_list(&this_cylinder_volume.geometry.mask_list,global_geometry_list.elements[loop_index].component_index);
            add_element_to_int_list(&global_geometry_list.elements[loop_index].Volume->geometry.masked_by_list,INDEX_CURRENT_COMP);
            global_geometry_list.elements[loop_index].Volume->geometry.is_masked_volume = 1;
            if (this_cylinder_volume.geometry.mask_mode == 2)
                global_geometry_list.elements[loop_index].Volume->geometry.mask_mode = 2;
            if (this_cylinder_volume.geometry.mask_mode == 1) {
                if (global_geometry_list.elements[loop_index].Volume->geometry.is_masked_volume == 1 && global_geometry_list.elements[loop_index].Volume->geometry.mask_mode != 2)
                    // If more than one mask is added to one volume, the ANY mode overwrites the (default) ALL mode.
                    global_geometry_list.elements[loop_index].Volume->geometry.mask_mode = 1;
            }
            
            found_geometries = 1;
        }
    }
    if (found_geometries == 0) {
        printf("The mask_string in geometry: %s did not find any of the specified volumes in the mask_string %s \n",NAME_CURRENT_COMP,mask_string);
        exit(1);
    }
    this_cylinder_volume.p_physics = malloc(sizeof(struct physics_struct));
    this_cylinder_volume.p_physics->is_vacuum = 0; // Makes this volume a vacuum
    this_cylinder_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
    this_cylinder_volume.p_physics->my_a = 0; // Should not be used.
    sprintf(this_cylinder_volume.p_physics->name,"Mask");
    this_cylinder_volume.geometry.is_mask_volume = 1;
    
    
// Read the material input, or if it lacks, use automatic linking.
} else if (material_string && strlen(material_string) && strcmp(material_string, "NULL") && strcmp(material_string, "0")) {
    // A geometry string was given, use it to determine which material
    if (0 == strcmp(material_string,"vacuum") || 0 == strcmp(material_string,"Vacuum")) {
        // One could have a global physics struct for vacuum instead of creating one for each
        this_cylinder_volume.p_physics = malloc(sizeof(struct physics_struct));
        this_cylinder_volume.p_physics->is_vacuum = 1; // Makes this volume a vacuum
        this_cylinder_volume.p_physics->number_of_processes = (int) 0;
        this_cylinder_volume.p_physics->my_a = 0; // Should not be used.
        sprintf(this_cylinder_volume.p_physics->name,"Vacuum");
    } else if (0 == strcmp(material_string,"exit") || 0 == strcmp(material_string,"Exit")) {
        // One could have a global physics struct for exit instead of creating one for each
        this_cylinder_volume.p_physics = malloc(sizeof(struct physics_struct));
        this_cylinder_volume.p_physics->is_vacuum = 1; // Makes this volume a vacuum
        this_cylinder_volume.p_physics->number_of_processes = (int) 0;
        this_cylinder_volume.p_physics->my_a = 0; // Should not be used.
        this_cylinder_volume.geometry.is_exit_volume = 1;
        sprintf(this_cylinder_volume.p_physics->name,"Exit");
    } else {
        for (loop_index=0;loop_index<global_material_list.num_elements;loop_index++) {
          if (0 == strcmp(material_string,global_material_list.elements[loop_index].name)) {
            this_cylinder_volume.p_physics = global_material_list.elements[loop_index].physics;
            break;
          }
          if (loop_index == global_material_list.num_elements-1) {
            printf("\n");
            printf("ERROR: The material string \"%s\" in Union geometry \"%s\" did not match a specified material. \n",material_string,NAME_CURRENT_COMP);
            printf("       The materials available at this point (need to be defined before the geometry): \n");
            for (loop_index=0;loop_index<global_material_list.num_elements;loop_index++)
              printf("         %s\n",global_material_list.elements[loop_index].name);
            printf("\n");
            printf("       It is also possible to use one of the defualt materials avaiable: \n");
            printf("           Vacuum (for a Volume without scattering or absorption)\n");
            printf("           Exit (for a Volume where the ray exits the component if it enters)\n");
            printf("           Mask (for a Volume that masks existing volumes specified in the mask_string\n");
            exit(1);
          }
        }
    }
} else {
    // Automatic linking, simply using the last defined material.
    #ifndef MATERIAL_DETECTOR
        printf("Need to define a material before the geometry to use automatic linking %s.\n",NAME_CURRENT_COMP);
        exit(1);
    #endif
    this_cylinder_volume.p_physics = global_material_list.elements[global_material_list.num_elements-1].physics;
}

sprintf(this_cylinder_volume.name,NAME_CURRENT_COMP);
sprintf(this_cylinder_volume.geometry.shape,"cylinder");
this_cylinder_volume.geometry.priority_value = priority;
// Currently the coordinates will be in absolute space.
this_cylinder_volume.geometry.center = POS_A_CURRENT_COMP;

this_cylinder_volume.geometry.geometry_p_interact = p_interact;
this_cylinder_storage.cyl_radius = radius;
this_cylinder_storage.height = yheight;
this_cylinder_volume.geometry.visualization_on = visualize;
this_cylinder_volume.geometry.geometry_parameters.p_cylinder_storage = &this_cylinder_storage;
this_cylinder_volume.geometry.within_function = &r_within_cylinder;
this_cylinder_volume.geometry.intersect_function = &sample_cylinder_intersect;
this_cylinder_volume.geometry.mcdisplay_function = &mcdisplay_cylinder_function;
this_cylinder_volume.geometry.shell_points = &cylinder_shell_points;
this_cylinder_volume.geometry.initialize_from_main_function = &initialize_cylinder_geometry_from_main_component;
this_cylinder_volume.geometry.process_rot_allocated = 0;
this_cylinder_volume.geometry.copy_geometry_parameters = &allocate_cylinder_storage_copy;

rot_copy(this_cylinder_volume.geometry.rotation_matrix,ROT_A_CURRENT_COMP);
rot_transpose(ROT_A_CURRENT_COMP,this_cylinder_volume.geometry.transpose_rotation_matrix);

// Initialize loggers
this_cylinder_volume.loggers.num_elements = 0;

// packing the information into the global_geometry_element, which is then included in the global_geometry_list.
sprintf(global_geometry_element.name,NAME_CURRENT_COMP);
global_geometry_element.activation_counter = number_of_activations;
global_geometry_element.component_index = INDEX_CURRENT_COMP;
global_geometry_element.Volume = &this_cylinder_volume; // Would be nicer if this m was a pointer, now we have the (small) data two places
add_element_to_geometry_list(&global_geometry_list,global_geometry_element);
}
#line 288854 "MACS_sample_kidney_box.c"
#undef number_of_activations
#undef mask_setting
#undef mask_string
#undef p_interact
#undef focus_r
#undef focus_xh
#undef focus_xw
#undef focus_ah
#undef focus_aw
#undef target_z
#undef target_y
#undef target_x
#undef target_index
#undef visualize
#undef yheight
#undef radius
#undef priority
#undef material_string
#undef this_cylinder_storage
#undef global_geometry_element
#undef this_cylinder_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

  /* Initializations for component channel_14_analyzer_1_center. */
  SIG_MESSAGE("channel_14_analyzer_1_center (Init)");

  /* Initializations for component channel_14_analyzer_1_rotated. */
  SIG_MESSAGE("channel_14_analyzer_1_rotated (Init)");

  /* Initializations for component channel_14_analyzer_1_array_crystal_array_0. */
  SIG_MESSAGE("channel_14_analyzer_1_array_crystal_array_0 (Init)");
#define mccompcurname  channel_14_analyzer_1_array_crystal_array_0
#define mccompcurtype  Union_box
#define mccompcurindex 662
#define loop_index mccchannel_14_analyzer_1_array_crystal_array_0_loop_index
#define this_box_volume mccchannel_14_analyzer_1_array_crystal_array_0_this_box_volume
#define global_geometry_element mccchannel_14_analyzer_1_array_crystal_array_0_global_geometry_element
#define this_box_storage mccchannel_14_analyzer_1_array_crystal_array_0_this_box_storage
#define material_string mccchannel_14_analyzer_1_array_crystal_array_0_material_string
#define priority mccchannel_14_analyzer_1_array_crystal_array_0_priority
#define xwidth mccchannel_14_analyzer_1_array_crystal_array_0_xwidth
#define yheight mccchannel_14_analyzer_1_array_crystal_array_0_yheight
#define zdepth mccchannel_14_analyzer_1_array_crystal_array_0_zdepth
#define xwidth2 mccchannel_14_analyzer_1_array_crystal_array_0_xwidth2
#define yheight2 mccchannel_14_analyzer_1_array_crystal_array_0_yheight2
#define visualize mccchannel_14_analyzer_1_array_crystal_array_0_visualize
#define target_index mccchannel_14_analyzer_1_array_crystal_array_0_target_index
#define target_x mccchannel_14_analyzer_1_array_crystal_array_0_target_x
#define target_y mccchannel_14_analyzer_1_array_crystal_array_0_target_y
#define target_z mccchannel_14_analyzer_1_array_crystal_array_0_target_z
#define focus_aw mccchannel_14_analyzer_1_array_crystal_array_0_focus_aw
#define focus_ah mccchannel_14_analyzer_1_array_crystal_array_0_focus_ah
#define focus_xw mccchannel_14_analyzer_1_array_crystal_array_0_focus_xw
#define focus_xh mccchannel_14_analyzer_1_array_crystal_array_0_focus_xh
#define focus_r mccchannel_14_analyzer_1_array_crystal_array_0_focus_r
#define p_interact mccchannel_14_analyzer_1_array_crystal_array_0_p_interact
#define mask_string mccchannel_14_analyzer_1_array_crystal_array_0_mask_string
#define mask_setting mccchannel_14_analyzer_1_array_crystal_array_0_mask_setting
#define number_of_activations mccchannel_14_analyzer_1_array_crystal_array_0_number_of_activations
#line 224 "Union_box.comp"
{
// Initializes the focusing system for this volume including input sanitation.
focus_initialize(&this_box_volume.geometry, POS_A_COMP_INDEX(INDEX_CURRENT_COMP+target_index), POS_A_CURRENT_COMP, ROT_A_CURRENT_COMP, target_index, target_x, target_y, target_z, focus_aw, focus_ah, focus_xw, focus_xh, focus_r, NAME_CURRENT_COMP);

// Input sanitation for this geometry
if (xwidth <= 0) {
  printf("\nERROR in Union_box named %s, the xwidth is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (yheight <= 0) {
  printf("\nERROR in Union_box named %s, yheight is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (zdepth <= 0) {
  printf("\nERROR in Union_box named %s, zdepth is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (xwidth2 <= 0 && xwidth2 != -1) {
  printf("\nERROR in Union_box named %s, the xwidth2 is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (yheight2 <= 0 && yheight2 != -1) {
  printf("\nERROR in Union_box named %s, yheight2 is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}

// Use sanitation
if (global_material_list.num_elements == 0) {
  printf("\nERROR: Need to define a material using Union_make_material before using a Union geometry component. \n");
  printf("       %s was defined before first use of Union_make_material.\n",NAME_CURRENT_COMP);
  exit(1);
}

this_box_volume.geometry.is_masked_volume = 0;
this_box_volume.geometry.is_exit_volume = 0;
this_box_volume.geometry.is_mask_volume = 0;
// check if the volume is a mask, if it is the material string is irelevant.
if (mask_string && strlen(mask_string) && strcmp(mask_string, "NULL") && strcmp(mask_string, "0")) {
    // A mask volume is used to limit the extend of other volumes, called the masked volumes. These are specified in the mask_string.
    // In order for a ray to enter a masked volume, it needs to be both in the region covered by that volume AND the mask volume.
    // When more than
    this_box_volume.geometry.mask_mode = 1; // Default is mask mode is ALL
    if (mask_setting && strlen(mask_setting) && strcmp(mask_setting, "NULL") && strcmp(mask_setting, "0")) {
        if (strcmp(mask_setting,"ALL") == 0 || strcmp(mask_setting,"All") == 0) this_box_volume.geometry.mask_mode = 1;
        else if (strcmp(mask_setting,"ANY") == 0 || strcmp(mask_setting,"Any") == 0) this_box_volume.geometry.mask_mode = 2;
        else {
            printf("The mask_mode of component %s is set to %s, but must be either ALL or ANY.\n",NAME_CURRENT_COMP,mask_setting);
            exit(1);
        }
    }
    
    for (loop_index=0;loop_index<global_geometry_list.num_elements;loop_index++) {
        // Add mask list
        if (1 == manual_linking_function(global_geometry_list.elements[loop_index].name,mask_string)) {
            add_element_to_int_list(&this_box_volume.geometry.mask_list,global_geometry_list.elements[loop_index].component_index);
            add_element_to_int_list(&global_geometry_list.elements[loop_index].Volume->geometry.masked_by_list,INDEX_CURRENT_COMP);
            global_geometry_list.elements[loop_index].Volume->geometry.is_masked_volume = 1;
            if (this_box_volume.geometry.mask_mode == 2)
                global_geometry_list.elements[loop_index].Volume->geometry.mask_mode = 2;
            if (this_box_volume.geometry.mask_mode == 1) {
                if (global_geometry_list.elements[loop_index].Volume->geometry.is_masked_volume == 1 && global_geometry_list.elements[loop_index].Volume->geometry.mask_mode != 2)
                    // If more than one mask is added to one volume, the ANY mode overwrites the (default) ALL mode.
                    global_geometry_list.elements[loop_index].Volume->geometry.mask_mode = 1;
            }
            
            found_geometries = 1;
        }
    }
    if (found_geometries == 0) {
        printf("The mask_string in geometry: %s did not find any of the specified volumes in the mask_string %s \n",NAME_CURRENT_COMP,mask_string);
        exit(1);
    }
    this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
    this_box_volume.p_physics->is_vacuum = 0; // Makes this volume a vacuum
    this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
    this_box_volume.p_physics->my_a = 0; // Should not be used.
    sprintf(this_box_volume.p_physics->name,"Mask");
    this_box_volume.geometry.is_mask_volume = 1;
    
    
// Read the material input, or if it lacks, use automatic linking.
} else if (material_string && strlen(material_string) && strcmp(material_string, "NULL") && strcmp(material_string, "0")) {
    // A geometry string was given, use it to determine which material
    if (0 == strcmp(material_string,"vacuum") || 0 == strcmp(material_string,"Vacuum")) {
        // One could have a global physics struct for vacuum instead of creating one for each
        this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
        this_box_volume.p_physics->is_vacuum = 1; // Makes this volume a vacuum
        this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
        this_box_volume.p_physics->my_a = 0; // Should not be used.
        sprintf(this_box_volume.p_physics->name,"Vacuum");
    } else if (0 == strcmp(material_string,"exit") || 0 == strcmp(material_string,"Exit")) {
        // One could have a global physics struct for vacuum instead of creating one for each
        this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
        this_box_volume.p_physics->is_vacuum = 1; // Makes this volume a vacuum
        this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
        this_box_volume.p_physics->my_a = 0; // Should not be used.
        this_box_volume.geometry.is_exit_volume = 1;
        sprintf(this_box_volume.p_physics->name,"Exit");
    } else {
        #ifndef MATERIAL_DETECTOR
            printf("Need to define a material before refering to it in a geometry %s.\n",NAME_CURRENT_COMP);
            exit(1);
        #endif
        for (loop_index=0;loop_index<global_material_list.num_elements;loop_index++) {
            if (0 == strcmp(material_string,global_material_list.elements[loop_index].name)) {
                this_box_volume.p_physics = global_material_list.elements[loop_index].physics;
                break;
            }
            if (loop_index == global_material_list.num_elements-1) {
            printf("\n");
            printf("ERROR: The material string \"%s\" in Union geometry \"%s\" did not match a specified material. \n",material_string,NAME_CURRENT_COMP);
            printf("       The materials available at this point (need to be defined before the geometry): \n");
            for (loop_index=0;loop_index<global_material_list.num_elements;loop_index++)
              printf("         %s\n",global_material_list.elements[loop_index].name);
            printf("\n");
            printf("       It is also possible to use one of the defualt materials avaiable: \n");
            printf("           Vacuum (for a Volume without scattering or absorption)\n");
            printf("           Exit (for a Volume where the ray exits the component if it enters)\n");
            printf("           Mask (for a Volume that masks existing volumes specified in the mask_string\n");
            exit(1);
          }
        }
    }
} else {
    // Automatic linking, simply using the last defined material.
    #ifndef MATERIAL_DETECTOR
        printf("Need to define a material before the geometry to use automatic linking %s.\n",NAME_CURRENT_COMP);
        exit(1);
    #endif
    this_box_volume.p_physics = global_material_list.elements[global_material_list.num_elements-1].physics;
}

sprintf(this_box_volume.name,NAME_CURRENT_COMP);
sprintf(this_box_volume.geometry.shape,"box");
this_box_volume.geometry.priority_value = priority;
this_box_volume.geometry.geometry_p_interact = p_interact;
// Currently the coordinates will be in absolute space.
this_box_volume.geometry.center = POS_A_CURRENT_COMP;

this_box_storage.z_depth = zdepth;
this_box_storage.x_width1 = xwidth;
this_box_storage.y_height1 = yheight;

this_box_storage.is_rectangle = 0;
if (xwidth2 < 0 && yheight2 < 0) this_box_storage.is_rectangle = 1;
if (xwidth == xwidth2 && yheight == yheight2) this_box_storage.is_rectangle = 1;

if (xwidth2 < 0) {
    this_box_storage.x_width2 = xwidth;
    xwidth2 = xwidth;
} else this_box_storage.x_width2 = xwidth2;

if (yheight2 < 0) {
    this_box_storage.y_height2 = yheight;
    yheight2 = yheight;
} else this_box_storage.y_height2 = yheight2;


this_box_storage.normal_vectors[0] = coords_set(0,0,1);
this_box_storage.normal_vectors[1] = coords_set(0,0,1);

// for sides with y component = 0
x_component = 2*zdepth/sqrt((xwidth-xwidth2)*(xwidth-xwidth2)+4*zdepth*zdepth);
z_component = (xwidth-xwidth2)/sqrt(4*zdepth*zdepth+(xwidth-xwidth2)*(xwidth-xwidth2));

this_box_storage.normal_vectors[2] = coords_set(x_component,0,z_component);
this_box_storage.normal_vectors[3] = coords_set(-x_component,0,z_component);

// for sides with x component = 0
y_component = 2*zdepth/sqrt((yheight-yheight2)*(yheight-yheight2)+4*zdepth*zdepth);
z_component = (yheight-yheight2)/sqrt(4*zdepth*zdepth+(yheight-yheight2)*(yheight-yheight2));

this_box_storage.normal_vectors[4] = coords_set(0,y_component,z_component);
this_box_storage.normal_vectors[5] = coords_set(0,-y_component,z_component);

this_box_volume.geometry.visualization_on = visualize;

this_box_volume.geometry.geometry_parameters.p_box_storage = &this_box_storage;

// Assign pointers to functions for intersection with the shape, checking if a point is inside the shape
if (this_box_storage.is_rectangle == 1) {
this_box_volume.geometry.intersect_function = &sample_box_intersect_simple;
this_box_volume.geometry.within_function = &r_within_box_simple;
}
else {
this_box_volume.geometry.intersect_function = &sample_box_intersect_advanced;
this_box_volume.geometry.within_function = &r_within_box_advanced;
}

this_box_volume.geometry.shell_points = &box_shell_points;
this_box_volume.geometry.mcdisplay_function = &mcdisplay_box_function;
this_box_volume.geometry.initialize_from_main_function = &initialize_box_geometry_from_main_component;
this_box_volume.geometry.process_rot_allocated = 0;

this_box_volume.geometry.copy_geometry_parameters = &allocate_box_storage_copy;

rot_copy(this_box_volume.geometry.rotation_matrix,ROT_A_CURRENT_COMP); //check how ROT_R_CURRENT_COMP would work
rot_transpose(ROT_A_CURRENT_COMP,this_box_volume.geometry.transpose_rotation_matrix);

// Initialize loggers
this_box_volume.loggers.num_elements = 0;

// packing the information into the global_geometry_element, which is then included in the global_geometry_list.
sprintf(global_geometry_element.name,NAME_CURRENT_COMP);
global_geometry_element.activation_counter = number_of_activations;
global_geometry_element.component_index = INDEX_CURRENT_COMP;
global_geometry_element.Volume = &this_box_volume; // Would be nicer if this m was a pointer, now we have the (small) data two places
add_element_to_geometry_list(&global_geometry_list,global_geometry_element);
}
#line 289127 "MACS_sample_kidney_box.c"
#undef number_of_activations
#undef mask_setting
#undef mask_string
#undef p_interact
#undef focus_r
#undef focus_xh
#undef focus_xw
#undef focus_ah
#undef focus_aw
#undef target_z
#undef target_y
#undef target_x
#undef target_index
#undef visualize
#undef yheight2
#undef xwidth2
#undef zdepth
#undef yheight
#undef xwidth
#undef priority
#undef material_string
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

  /* Initializations for component channel_14_analyzer_1_array_crystal_array_1. */
  SIG_MESSAGE("channel_14_analyzer_1_array_crystal_array_1 (Init)");
#define mccompcurname  channel_14_analyzer_1_array_crystal_array_1
#define mccompcurtype  Union_box
#define mccompcurindex 663
#define loop_index mccchannel_14_analyzer_1_array_crystal_array_1_loop_index
#define this_box_volume mccchannel_14_analyzer_1_array_crystal_array_1_this_box_volume
#define global_geometry_element mccchannel_14_analyzer_1_array_crystal_array_1_global_geometry_element
#define this_box_storage mccchannel_14_analyzer_1_array_crystal_array_1_this_box_storage
#define material_string mccchannel_14_analyzer_1_array_crystal_array_1_material_string
#define priority mccchannel_14_analyzer_1_array_crystal_array_1_priority
#define xwidth mccchannel_14_analyzer_1_array_crystal_array_1_xwidth
#define yheight mccchannel_14_analyzer_1_array_crystal_array_1_yheight
#define zdepth mccchannel_14_analyzer_1_array_crystal_array_1_zdepth
#define xwidth2 mccchannel_14_analyzer_1_array_crystal_array_1_xwidth2
#define yheight2 mccchannel_14_analyzer_1_array_crystal_array_1_yheight2
#define visualize mccchannel_14_analyzer_1_array_crystal_array_1_visualize
#define target_index mccchannel_14_analyzer_1_array_crystal_array_1_target_index
#define target_x mccchannel_14_analyzer_1_array_crystal_array_1_target_x
#define target_y mccchannel_14_analyzer_1_array_crystal_array_1_target_y
#define target_z mccchannel_14_analyzer_1_array_crystal_array_1_target_z
#define focus_aw mccchannel_14_analyzer_1_array_crystal_array_1_focus_aw
#define focus_ah mccchannel_14_analyzer_1_array_crystal_array_1_focus_ah
#define focus_xw mccchannel_14_analyzer_1_array_crystal_array_1_focus_xw
#define focus_xh mccchannel_14_analyzer_1_array_crystal_array_1_focus_xh
#define focus_r mccchannel_14_analyzer_1_array_crystal_array_1_focus_r
#define p_interact mccchannel_14_analyzer_1_array_crystal_array_1_p_interact
#define mask_string mccchannel_14_analyzer_1_array_crystal_array_1_mask_string
#define mask_setting mccchannel_14_analyzer_1_array_crystal_array_1_mask_setting
#define number_of_activations mccchannel_14_analyzer_1_array_crystal_array_1_number_of_activations
#line 224 "Union_box.comp"
{
// Initializes the focusing system for this volume including input sanitation.
focus_initialize(&this_box_volume.geometry, POS_A_COMP_INDEX(INDEX_CURRENT_COMP+target_index), POS_A_CURRENT_COMP, ROT_A_CURRENT_COMP, target_index, target_x, target_y, target_z, focus_aw, focus_ah, focus_xw, focus_xh, focus_r, NAME_CURRENT_COMP);

// Input sanitation for this geometry
if (xwidth <= 0) {
  printf("\nERROR in Union_box named %s, the xwidth is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (yheight <= 0) {
  printf("\nERROR in Union_box named %s, yheight is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (zdepth <= 0) {
  printf("\nERROR in Union_box named %s, zdepth is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (xwidth2 <= 0 && xwidth2 != -1) {
  printf("\nERROR in Union_box named %s, the xwidth2 is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (yheight2 <= 0 && yheight2 != -1) {
  printf("\nERROR in Union_box named %s, yheight2 is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}

// Use sanitation
if (global_material_list.num_elements == 0) {
  printf("\nERROR: Need to define a material using Union_make_material before using a Union geometry component. \n");
  printf("       %s was defined before first use of Union_make_material.\n",NAME_CURRENT_COMP);
  exit(1);
}

this_box_volume.geometry.is_masked_volume = 0;
this_box_volume.geometry.is_exit_volume = 0;
this_box_volume.geometry.is_mask_volume = 0;
// check if the volume is a mask, if it is the material string is irelevant.
if (mask_string && strlen(mask_string) && strcmp(mask_string, "NULL") && strcmp(mask_string, "0")) {
    // A mask volume is used to limit the extend of other volumes, called the masked volumes. These are specified in the mask_string.
    // In order for a ray to enter a masked volume, it needs to be both in the region covered by that volume AND the mask volume.
    // When more than
    this_box_volume.geometry.mask_mode = 1; // Default is mask mode is ALL
    if (mask_setting && strlen(mask_setting) && strcmp(mask_setting, "NULL") && strcmp(mask_setting, "0")) {
        if (strcmp(mask_setting,"ALL") == 0 || strcmp(mask_setting,"All") == 0) this_box_volume.geometry.mask_mode = 1;
        else if (strcmp(mask_setting,"ANY") == 0 || strcmp(mask_setting,"Any") == 0) this_box_volume.geometry.mask_mode = 2;
        else {
            printf("The mask_mode of component %s is set to %s, but must be either ALL or ANY.\n",NAME_CURRENT_COMP,mask_setting);
            exit(1);
        }
    }
    
    for (loop_index=0;loop_index<global_geometry_list.num_elements;loop_index++) {
        // Add mask list
        if (1 == manual_linking_function(global_geometry_list.elements[loop_index].name,mask_string)) {
            add_element_to_int_list(&this_box_volume.geometry.mask_list,global_geometry_list.elements[loop_index].component_index);
            add_element_to_int_list(&global_geometry_list.elements[loop_index].Volume->geometry.masked_by_list,INDEX_CURRENT_COMP);
            global_geometry_list.elements[loop_index].Volume->geometry.is_masked_volume = 1;
            if (this_box_volume.geometry.mask_mode == 2)
                global_geometry_list.elements[loop_index].Volume->geometry.mask_mode = 2;
            if (this_box_volume.geometry.mask_mode == 1) {
                if (global_geometry_list.elements[loop_index].Volume->geometry.is_masked_volume == 1 && global_geometry_list.elements[loop_index].Volume->geometry.mask_mode != 2)
                    // If more than one mask is added to one volume, the ANY mode overwrites the (default) ALL mode.
                    global_geometry_list.elements[loop_index].Volume->geometry.mask_mode = 1;
            }
            
            found_geometries = 1;
        }
    }
    if (found_geometries == 0) {
        printf("The mask_string in geometry: %s did not find any of the specified volumes in the mask_string %s \n",NAME_CURRENT_COMP,mask_string);
        exit(1);
    }
    this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
    this_box_volume.p_physics->is_vacuum = 0; // Makes this volume a vacuum
    this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
    this_box_volume.p_physics->my_a = 0; // Should not be used.
    sprintf(this_box_volume.p_physics->name,"Mask");
    this_box_volume.geometry.is_mask_volume = 1;
    
    
// Read the material input, or if it lacks, use automatic linking.
} else if (material_string && strlen(material_string) && strcmp(material_string, "NULL") && strcmp(material_string, "0")) {
    // A geometry string was given, use it to determine which material
    if (0 == strcmp(material_string,"vacuum") || 0 == strcmp(material_string,"Vacuum")) {
        // One could have a global physics struct for vacuum instead of creating one for each
        this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
        this_box_volume.p_physics->is_vacuum = 1; // Makes this volume a vacuum
        this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
        this_box_volume.p_physics->my_a = 0; // Should not be used.
        sprintf(this_box_volume.p_physics->name,"Vacuum");
    } else if (0 == strcmp(material_string,"exit") || 0 == strcmp(material_string,"Exit")) {
        // One could have a global physics struct for vacuum instead of creating one for each
        this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
        this_box_volume.p_physics->is_vacuum = 1; // Makes this volume a vacuum
        this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
        this_box_volume.p_physics->my_a = 0; // Should not be used.
        this_box_volume.geometry.is_exit_volume = 1;
        sprintf(this_box_volume.p_physics->name,"Exit");
    } else {
        #ifndef MATERIAL_DETECTOR
            printf("Need to define a material before refering to it in a geometry %s.\n",NAME_CURRENT_COMP);
            exit(1);
        #endif
        for (loop_index=0;loop_index<global_material_list.num_elements;loop_index++) {
            if (0 == strcmp(material_string,global_material_list.elements[loop_index].name)) {
                this_box_volume.p_physics = global_material_list.elements[loop_index].physics;
                break;
            }
            if (loop_index == global_material_list.num_elements-1) {
            printf("\n");
            printf("ERROR: The material string \"%s\" in Union geometry \"%s\" did not match a specified material. \n",material_string,NAME_CURRENT_COMP);
            printf("       The materials available at this point (need to be defined before the geometry): \n");
            for (loop_index=0;loop_index<global_material_list.num_elements;loop_index++)
              printf("         %s\n",global_material_list.elements[loop_index].name);
            printf("\n");
            printf("       It is also possible to use one of the defualt materials avaiable: \n");
            printf("           Vacuum (for a Volume without scattering or absorption)\n");
            printf("           Exit (for a Volume where the ray exits the component if it enters)\n");
            printf("           Mask (for a Volume that masks existing volumes specified in the mask_string\n");
            exit(1);
          }
        }
    }
} else {
    // Automatic linking, simply using the last defined material.
    #ifndef MATERIAL_DETECTOR
        printf("Need to define a material before the geometry to use automatic linking %s.\n",NAME_CURRENT_COMP);
        exit(1);
    #endif
    this_box_volume.p_physics = global_material_list.elements[global_material_list.num_elements-1].physics;
}

sprintf(this_box_volume.name,NAME_CURRENT_COMP);
sprintf(this_box_volume.geometry.shape,"box");
this_box_volume.geometry.priority_value = priority;
this_box_volume.geometry.geometry_p_interact = p_interact;
// Currently the coordinates will be in absolute space.
this_box_volume.geometry.center = POS_A_CURRENT_COMP;

this_box_storage.z_depth = zdepth;
this_box_storage.x_width1 = xwidth;
this_box_storage.y_height1 = yheight;

this_box_storage.is_rectangle = 0;
if (xwidth2 < 0 && yheight2 < 0) this_box_storage.is_rectangle = 1;
if (xwidth == xwidth2 && yheight == yheight2) this_box_storage.is_rectangle = 1;

if (xwidth2 < 0) {
    this_box_storage.x_width2 = xwidth;
    xwidth2 = xwidth;
} else this_box_storage.x_width2 = xwidth2;

if (yheight2 < 0) {
    this_box_storage.y_height2 = yheight;
    yheight2 = yheight;
} else this_box_storage.y_height2 = yheight2;


this_box_storage.normal_vectors[0] = coords_set(0,0,1);
this_box_storage.normal_vectors[1] = coords_set(0,0,1);

// for sides with y component = 0
x_component = 2*zdepth/sqrt((xwidth-xwidth2)*(xwidth-xwidth2)+4*zdepth*zdepth);
z_component = (xwidth-xwidth2)/sqrt(4*zdepth*zdepth+(xwidth-xwidth2)*(xwidth-xwidth2));

this_box_storage.normal_vectors[2] = coords_set(x_component,0,z_component);
this_box_storage.normal_vectors[3] = coords_set(-x_component,0,z_component);

// for sides with x component = 0
y_component = 2*zdepth/sqrt((yheight-yheight2)*(yheight-yheight2)+4*zdepth*zdepth);
z_component = (yheight-yheight2)/sqrt(4*zdepth*zdepth+(yheight-yheight2)*(yheight-yheight2));

this_box_storage.normal_vectors[4] = coords_set(0,y_component,z_component);
this_box_storage.normal_vectors[5] = coords_set(0,-y_component,z_component);

this_box_volume.geometry.visualization_on = visualize;

this_box_volume.geometry.geometry_parameters.p_box_storage = &this_box_storage;

// Assign pointers to functions for intersection with the shape, checking if a point is inside the shape
if (this_box_storage.is_rectangle == 1) {
this_box_volume.geometry.intersect_function = &sample_box_intersect_simple;
this_box_volume.geometry.within_function = &r_within_box_simple;
}
else {
this_box_volume.geometry.intersect_function = &sample_box_intersect_advanced;
this_box_volume.geometry.within_function = &r_within_box_advanced;
}

this_box_volume.geometry.shell_points = &box_shell_points;
this_box_volume.geometry.mcdisplay_function = &mcdisplay_box_function;
this_box_volume.geometry.initialize_from_main_function = &initialize_box_geometry_from_main_component;
this_box_volume.geometry.process_rot_allocated = 0;

this_box_volume.geometry.copy_geometry_parameters = &allocate_box_storage_copy;

rot_copy(this_box_volume.geometry.rotation_matrix,ROT_A_CURRENT_COMP); //check how ROT_R_CURRENT_COMP would work
rot_transpose(ROT_A_CURRENT_COMP,this_box_volume.geometry.transpose_rotation_matrix);

// Initialize loggers
this_box_volume.loggers.num_elements = 0;

// packing the information into the global_geometry_element, which is then included in the global_geometry_list.
sprintf(global_geometry_element.name,NAME_CURRENT_COMP);
global_geometry_element.activation_counter = number_of_activations;
global_geometry_element.component_index = INDEX_CURRENT_COMP;
global_geometry_element.Volume = &this_box_volume; // Would be nicer if this m was a pointer, now we have the (small) data two places
add_element_to_geometry_list(&global_geometry_list,global_geometry_element);
}
#line 289397 "MACS_sample_kidney_box.c"
#undef number_of_activations
#undef mask_setting
#undef mask_string
#undef p_interact
#undef focus_r
#undef focus_xh
#undef focus_xw
#undef focus_ah
#undef focus_aw
#undef target_z
#undef target_y
#undef target_x
#undef target_index
#undef visualize
#undef yheight2
#undef xwidth2
#undef zdepth
#undef yheight
#undef xwidth
#undef priority
#undef material_string
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

  /* Initializations for component channel_14_analyzer_1_array_crystal_array_2. */
  SIG_MESSAGE("channel_14_analyzer_1_array_crystal_array_2 (Init)");
#define mccompcurname  channel_14_analyzer_1_array_crystal_array_2
#define mccompcurtype  Union_box
#define mccompcurindex 664
#define loop_index mccchannel_14_analyzer_1_array_crystal_array_2_loop_index
#define this_box_volume mccchannel_14_analyzer_1_array_crystal_array_2_this_box_volume
#define global_geometry_element mccchannel_14_analyzer_1_array_crystal_array_2_global_geometry_element
#define this_box_storage mccchannel_14_analyzer_1_array_crystal_array_2_this_box_storage
#define material_string mccchannel_14_analyzer_1_array_crystal_array_2_material_string
#define priority mccchannel_14_analyzer_1_array_crystal_array_2_priority
#define xwidth mccchannel_14_analyzer_1_array_crystal_array_2_xwidth
#define yheight mccchannel_14_analyzer_1_array_crystal_array_2_yheight
#define zdepth mccchannel_14_analyzer_1_array_crystal_array_2_zdepth
#define xwidth2 mccchannel_14_analyzer_1_array_crystal_array_2_xwidth2
#define yheight2 mccchannel_14_analyzer_1_array_crystal_array_2_yheight2
#define visualize mccchannel_14_analyzer_1_array_crystal_array_2_visualize
#define target_index mccchannel_14_analyzer_1_array_crystal_array_2_target_index
#define target_x mccchannel_14_analyzer_1_array_crystal_array_2_target_x
#define target_y mccchannel_14_analyzer_1_array_crystal_array_2_target_y
#define target_z mccchannel_14_analyzer_1_array_crystal_array_2_target_z
#define focus_aw mccchannel_14_analyzer_1_array_crystal_array_2_focus_aw
#define focus_ah mccchannel_14_analyzer_1_array_crystal_array_2_focus_ah
#define focus_xw mccchannel_14_analyzer_1_array_crystal_array_2_focus_xw
#define focus_xh mccchannel_14_analyzer_1_array_crystal_array_2_focus_xh
#define focus_r mccchannel_14_analyzer_1_array_crystal_array_2_focus_r
#define p_interact mccchannel_14_analyzer_1_array_crystal_array_2_p_interact
#define mask_string mccchannel_14_analyzer_1_array_crystal_array_2_mask_string
#define mask_setting mccchannel_14_analyzer_1_array_crystal_array_2_mask_setting
#define number_of_activations mccchannel_14_analyzer_1_array_crystal_array_2_number_of_activations
#line 224 "Union_box.comp"
{
// Initializes the focusing system for this volume including input sanitation.
focus_initialize(&this_box_volume.geometry, POS_A_COMP_INDEX(INDEX_CURRENT_COMP+target_index), POS_A_CURRENT_COMP, ROT_A_CURRENT_COMP, target_index, target_x, target_y, target_z, focus_aw, focus_ah, focus_xw, focus_xh, focus_r, NAME_CURRENT_COMP);

// Input sanitation for this geometry
if (xwidth <= 0) {
  printf("\nERROR in Union_box named %s, the xwidth is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (yheight <= 0) {
  printf("\nERROR in Union_box named %s, yheight is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (zdepth <= 0) {
  printf("\nERROR in Union_box named %s, zdepth is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (xwidth2 <= 0 && xwidth2 != -1) {
  printf("\nERROR in Union_box named %s, the xwidth2 is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (yheight2 <= 0 && yheight2 != -1) {
  printf("\nERROR in Union_box named %s, yheight2 is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}

// Use sanitation
if (global_material_list.num_elements == 0) {
  printf("\nERROR: Need to define a material using Union_make_material before using a Union geometry component. \n");
  printf("       %s was defined before first use of Union_make_material.\n",NAME_CURRENT_COMP);
  exit(1);
}

this_box_volume.geometry.is_masked_volume = 0;
this_box_volume.geometry.is_exit_volume = 0;
this_box_volume.geometry.is_mask_volume = 0;
// check if the volume is a mask, if it is the material string is irelevant.
if (mask_string && strlen(mask_string) && strcmp(mask_string, "NULL") && strcmp(mask_string, "0")) {
    // A mask volume is used to limit the extend of other volumes, called the masked volumes. These are specified in the mask_string.
    // In order for a ray to enter a masked volume, it needs to be both in the region covered by that volume AND the mask volume.
    // When more than
    this_box_volume.geometry.mask_mode = 1; // Default is mask mode is ALL
    if (mask_setting && strlen(mask_setting) && strcmp(mask_setting, "NULL") && strcmp(mask_setting, "0")) {
        if (strcmp(mask_setting,"ALL") == 0 || strcmp(mask_setting,"All") == 0) this_box_volume.geometry.mask_mode = 1;
        else if (strcmp(mask_setting,"ANY") == 0 || strcmp(mask_setting,"Any") == 0) this_box_volume.geometry.mask_mode = 2;
        else {
            printf("The mask_mode of component %s is set to %s, but must be either ALL or ANY.\n",NAME_CURRENT_COMP,mask_setting);
            exit(1);
        }
    }
    
    for (loop_index=0;loop_index<global_geometry_list.num_elements;loop_index++) {
        // Add mask list
        if (1 == manual_linking_function(global_geometry_list.elements[loop_index].name,mask_string)) {
            add_element_to_int_list(&this_box_volume.geometry.mask_list,global_geometry_list.elements[loop_index].component_index);
            add_element_to_int_list(&global_geometry_list.elements[loop_index].Volume->geometry.masked_by_list,INDEX_CURRENT_COMP);
            global_geometry_list.elements[loop_index].Volume->geometry.is_masked_volume = 1;
            if (this_box_volume.geometry.mask_mode == 2)
                global_geometry_list.elements[loop_index].Volume->geometry.mask_mode = 2;
            if (this_box_volume.geometry.mask_mode == 1) {
                if (global_geometry_list.elements[loop_index].Volume->geometry.is_masked_volume == 1 && global_geometry_list.elements[loop_index].Volume->geometry.mask_mode != 2)
                    // If more than one mask is added to one volume, the ANY mode overwrites the (default) ALL mode.
                    global_geometry_list.elements[loop_index].Volume->geometry.mask_mode = 1;
            }
            
            found_geometries = 1;
        }
    }
    if (found_geometries == 0) {
        printf("The mask_string in geometry: %s did not find any of the specified volumes in the mask_string %s \n",NAME_CURRENT_COMP,mask_string);
        exit(1);
    }
    this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
    this_box_volume.p_physics->is_vacuum = 0; // Makes this volume a vacuum
    this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
    this_box_volume.p_physics->my_a = 0; // Should not be used.
    sprintf(this_box_volume.p_physics->name,"Mask");
    this_box_volume.geometry.is_mask_volume = 1;
    
    
// Read the material input, or if it lacks, use automatic linking.
} else if (material_string && strlen(material_string) && strcmp(material_string, "NULL") && strcmp(material_string, "0")) {
    // A geometry string was given, use it to determine which material
    if (0 == strcmp(material_string,"vacuum") || 0 == strcmp(material_string,"Vacuum")) {
        // One could have a global physics struct for vacuum instead of creating one for each
        this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
        this_box_volume.p_physics->is_vacuum = 1; // Makes this volume a vacuum
        this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
        this_box_volume.p_physics->my_a = 0; // Should not be used.
        sprintf(this_box_volume.p_physics->name,"Vacuum");
    } else if (0 == strcmp(material_string,"exit") || 0 == strcmp(material_string,"Exit")) {
        // One could have a global physics struct for vacuum instead of creating one for each
        this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
        this_box_volume.p_physics->is_vacuum = 1; // Makes this volume a vacuum
        this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
        this_box_volume.p_physics->my_a = 0; // Should not be used.
        this_box_volume.geometry.is_exit_volume = 1;
        sprintf(this_box_volume.p_physics->name,"Exit");
    } else {
        #ifndef MATERIAL_DETECTOR
            printf("Need to define a material before refering to it in a geometry %s.\n",NAME_CURRENT_COMP);
            exit(1);
        #endif
        for (loop_index=0;loop_index<global_material_list.num_elements;loop_index++) {
            if (0 == strcmp(material_string,global_material_list.elements[loop_index].name)) {
                this_box_volume.p_physics = global_material_list.elements[loop_index].physics;
                break;
            }
            if (loop_index == global_material_list.num_elements-1) {
            printf("\n");
            printf("ERROR: The material string \"%s\" in Union geometry \"%s\" did not match a specified material. \n",material_string,NAME_CURRENT_COMP);
            printf("       The materials available at this point (need to be defined before the geometry): \n");
            for (loop_index=0;loop_index<global_material_list.num_elements;loop_index++)
              printf("         %s\n",global_material_list.elements[loop_index].name);
            printf("\n");
            printf("       It is also possible to use one of the defualt materials avaiable: \n");
            printf("           Vacuum (for a Volume without scattering or absorption)\n");
            printf("           Exit (for a Volume where the ray exits the component if it enters)\n");
            printf("           Mask (for a Volume that masks existing volumes specified in the mask_string\n");
            exit(1);
          }
        }
    }
} else {
    // Automatic linking, simply using the last defined material.
    #ifndef MATERIAL_DETECTOR
        printf("Need to define a material before the geometry to use automatic linking %s.\n",NAME_CURRENT_COMP);
        exit(1);
    #endif
    this_box_volume.p_physics = global_material_list.elements[global_material_list.num_elements-1].physics;
}

sprintf(this_box_volume.name,NAME_CURRENT_COMP);
sprintf(this_box_volume.geometry.shape,"box");
this_box_volume.geometry.priority_value = priority;
this_box_volume.geometry.geometry_p_interact = p_interact;
// Currently the coordinates will be in absolute space.
this_box_volume.geometry.center = POS_A_CURRENT_COMP;

this_box_storage.z_depth = zdepth;
this_box_storage.x_width1 = xwidth;
this_box_storage.y_height1 = yheight;

this_box_storage.is_rectangle = 0;
if (xwidth2 < 0 && yheight2 < 0) this_box_storage.is_rectangle = 1;
if (xwidth == xwidth2 && yheight == yheight2) this_box_storage.is_rectangle = 1;

if (xwidth2 < 0) {
    this_box_storage.x_width2 = xwidth;
    xwidth2 = xwidth;
} else this_box_storage.x_width2 = xwidth2;

if (yheight2 < 0) {
    this_box_storage.y_height2 = yheight;
    yheight2 = yheight;
} else this_box_storage.y_height2 = yheight2;


this_box_storage.normal_vectors[0] = coords_set(0,0,1);
this_box_storage.normal_vectors[1] = coords_set(0,0,1);

// for sides with y component = 0
x_component = 2*zdepth/sqrt((xwidth-xwidth2)*(xwidth-xwidth2)+4*zdepth*zdepth);
z_component = (xwidth-xwidth2)/sqrt(4*zdepth*zdepth+(xwidth-xwidth2)*(xwidth-xwidth2));

this_box_storage.normal_vectors[2] = coords_set(x_component,0,z_component);
this_box_storage.normal_vectors[3] = coords_set(-x_component,0,z_component);

// for sides with x component = 0
y_component = 2*zdepth/sqrt((yheight-yheight2)*(yheight-yheight2)+4*zdepth*zdepth);
z_component = (yheight-yheight2)/sqrt(4*zdepth*zdepth+(yheight-yheight2)*(yheight-yheight2));

this_box_storage.normal_vectors[4] = coords_set(0,y_component,z_component);
this_box_storage.normal_vectors[5] = coords_set(0,-y_component,z_component);

this_box_volume.geometry.visualization_on = visualize;

this_box_volume.geometry.geometry_parameters.p_box_storage = &this_box_storage;

// Assign pointers to functions for intersection with the shape, checking if a point is inside the shape
if (this_box_storage.is_rectangle == 1) {
this_box_volume.geometry.intersect_function = &sample_box_intersect_simple;
this_box_volume.geometry.within_function = &r_within_box_simple;
}
else {
this_box_volume.geometry.intersect_function = &sample_box_intersect_advanced;
this_box_volume.geometry.within_function = &r_within_box_advanced;
}

this_box_volume.geometry.shell_points = &box_shell_points;
this_box_volume.geometry.mcdisplay_function = &mcdisplay_box_function;
this_box_volume.geometry.initialize_from_main_function = &initialize_box_geometry_from_main_component;
this_box_volume.geometry.process_rot_allocated = 0;

this_box_volume.geometry.copy_geometry_parameters = &allocate_box_storage_copy;

rot_copy(this_box_volume.geometry.rotation_matrix,ROT_A_CURRENT_COMP); //check how ROT_R_CURRENT_COMP would work
rot_transpose(ROT_A_CURRENT_COMP,this_box_volume.geometry.transpose_rotation_matrix);

// Initialize loggers
this_box_volume.loggers.num_elements = 0;

// packing the information into the global_geometry_element, which is then included in the global_geometry_list.
sprintf(global_geometry_element.name,NAME_CURRENT_COMP);
global_geometry_element.activation_counter = number_of_activations;
global_geometry_element.component_index = INDEX_CURRENT_COMP;
global_geometry_element.Volume = &this_box_volume; // Would be nicer if this m was a pointer, now we have the (small) data two places
add_element_to_geometry_list(&global_geometry_list,global_geometry_element);
}
#line 289667 "MACS_sample_kidney_box.c"
#undef number_of_activations
#undef mask_setting
#undef mask_string
#undef p_interact
#undef focus_r
#undef focus_xh
#undef focus_xw
#undef focus_ah
#undef focus_aw
#undef target_z
#undef target_y
#undef target_x
#undef target_index
#undef visualize
#undef yheight2
#undef xwidth2
#undef zdepth
#undef yheight
#undef xwidth
#undef priority
#undef material_string
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

  /* Initializations for component channel_14_analyzer_1_array_crystal_array_3. */
  SIG_MESSAGE("channel_14_analyzer_1_array_crystal_array_3 (Init)");
#define mccompcurname  channel_14_analyzer_1_array_crystal_array_3
#define mccompcurtype  Union_box
#define mccompcurindex 665
#define loop_index mccchannel_14_analyzer_1_array_crystal_array_3_loop_index
#define this_box_volume mccchannel_14_analyzer_1_array_crystal_array_3_this_box_volume
#define global_geometry_element mccchannel_14_analyzer_1_array_crystal_array_3_global_geometry_element
#define this_box_storage mccchannel_14_analyzer_1_array_crystal_array_3_this_box_storage
#define material_string mccchannel_14_analyzer_1_array_crystal_array_3_material_string
#define priority mccchannel_14_analyzer_1_array_crystal_array_3_priority
#define xwidth mccchannel_14_analyzer_1_array_crystal_array_3_xwidth
#define yheight mccchannel_14_analyzer_1_array_crystal_array_3_yheight
#define zdepth mccchannel_14_analyzer_1_array_crystal_array_3_zdepth
#define xwidth2 mccchannel_14_analyzer_1_array_crystal_array_3_xwidth2
#define yheight2 mccchannel_14_analyzer_1_array_crystal_array_3_yheight2
#define visualize mccchannel_14_analyzer_1_array_crystal_array_3_visualize
#define target_index mccchannel_14_analyzer_1_array_crystal_array_3_target_index
#define target_x mccchannel_14_analyzer_1_array_crystal_array_3_target_x
#define target_y mccchannel_14_analyzer_1_array_crystal_array_3_target_y
#define target_z mccchannel_14_analyzer_1_array_crystal_array_3_target_z
#define focus_aw mccchannel_14_analyzer_1_array_crystal_array_3_focus_aw
#define focus_ah mccchannel_14_analyzer_1_array_crystal_array_3_focus_ah
#define focus_xw mccchannel_14_analyzer_1_array_crystal_array_3_focus_xw
#define focus_xh mccchannel_14_analyzer_1_array_crystal_array_3_focus_xh
#define focus_r mccchannel_14_analyzer_1_array_crystal_array_3_focus_r
#define p_interact mccchannel_14_analyzer_1_array_crystal_array_3_p_interact
#define mask_string mccchannel_14_analyzer_1_array_crystal_array_3_mask_string
#define mask_setting mccchannel_14_analyzer_1_array_crystal_array_3_mask_setting
#define number_of_activations mccchannel_14_analyzer_1_array_crystal_array_3_number_of_activations
#line 224 "Union_box.comp"
{
// Initializes the focusing system for this volume including input sanitation.
focus_initialize(&this_box_volume.geometry, POS_A_COMP_INDEX(INDEX_CURRENT_COMP+target_index), POS_A_CURRENT_COMP, ROT_A_CURRENT_COMP, target_index, target_x, target_y, target_z, focus_aw, focus_ah, focus_xw, focus_xh, focus_r, NAME_CURRENT_COMP);

// Input sanitation for this geometry
if (xwidth <= 0) {
  printf("\nERROR in Union_box named %s, the xwidth is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (yheight <= 0) {
  printf("\nERROR in Union_box named %s, yheight is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (zdepth <= 0) {
  printf("\nERROR in Union_box named %s, zdepth is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (xwidth2 <= 0 && xwidth2 != -1) {
  printf("\nERROR in Union_box named %s, the xwidth2 is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (yheight2 <= 0 && yheight2 != -1) {
  printf("\nERROR in Union_box named %s, yheight2 is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}

// Use sanitation
if (global_material_list.num_elements == 0) {
  printf("\nERROR: Need to define a material using Union_make_material before using a Union geometry component. \n");
  printf("       %s was defined before first use of Union_make_material.\n",NAME_CURRENT_COMP);
  exit(1);
}

this_box_volume.geometry.is_masked_volume = 0;
this_box_volume.geometry.is_exit_volume = 0;
this_box_volume.geometry.is_mask_volume = 0;
// check if the volume is a mask, if it is the material string is irelevant.
if (mask_string && strlen(mask_string) && strcmp(mask_string, "NULL") && strcmp(mask_string, "0")) {
    // A mask volume is used to limit the extend of other volumes, called the masked volumes. These are specified in the mask_string.
    // In order for a ray to enter a masked volume, it needs to be both in the region covered by that volume AND the mask volume.
    // When more than
    this_box_volume.geometry.mask_mode = 1; // Default is mask mode is ALL
    if (mask_setting && strlen(mask_setting) && strcmp(mask_setting, "NULL") && strcmp(mask_setting, "0")) {
        if (strcmp(mask_setting,"ALL") == 0 || strcmp(mask_setting,"All") == 0) this_box_volume.geometry.mask_mode = 1;
        else if (strcmp(mask_setting,"ANY") == 0 || strcmp(mask_setting,"Any") == 0) this_box_volume.geometry.mask_mode = 2;
        else {
            printf("The mask_mode of component %s is set to %s, but must be either ALL or ANY.\n",NAME_CURRENT_COMP,mask_setting);
            exit(1);
        }
    }
    
    for (loop_index=0;loop_index<global_geometry_list.num_elements;loop_index++) {
        // Add mask list
        if (1 == manual_linking_function(global_geometry_list.elements[loop_index].name,mask_string)) {
            add_element_to_int_list(&this_box_volume.geometry.mask_list,global_geometry_list.elements[loop_index].component_index);
            add_element_to_int_list(&global_geometry_list.elements[loop_index].Volume->geometry.masked_by_list,INDEX_CURRENT_COMP);
            global_geometry_list.elements[loop_index].Volume->geometry.is_masked_volume = 1;
            if (this_box_volume.geometry.mask_mode == 2)
                global_geometry_list.elements[loop_index].Volume->geometry.mask_mode = 2;
            if (this_box_volume.geometry.mask_mode == 1) {
                if (global_geometry_list.elements[loop_index].Volume->geometry.is_masked_volume == 1 && global_geometry_list.elements[loop_index].Volume->geometry.mask_mode != 2)
                    // If more than one mask is added to one volume, the ANY mode overwrites the (default) ALL mode.
                    global_geometry_list.elements[loop_index].Volume->geometry.mask_mode = 1;
            }
            
            found_geometries = 1;
        }
    }
    if (found_geometries == 0) {
        printf("The mask_string in geometry: %s did not find any of the specified volumes in the mask_string %s \n",NAME_CURRENT_COMP,mask_string);
        exit(1);
    }
    this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
    this_box_volume.p_physics->is_vacuum = 0; // Makes this volume a vacuum
    this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
    this_box_volume.p_physics->my_a = 0; // Should not be used.
    sprintf(this_box_volume.p_physics->name,"Mask");
    this_box_volume.geometry.is_mask_volume = 1;
    
    
// Read the material input, or if it lacks, use automatic linking.
} else if (material_string && strlen(material_string) && strcmp(material_string, "NULL") && strcmp(material_string, "0")) {
    // A geometry string was given, use it to determine which material
    if (0 == strcmp(material_string,"vacuum") || 0 == strcmp(material_string,"Vacuum")) {
        // One could have a global physics struct for vacuum instead of creating one for each
        this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
        this_box_volume.p_physics->is_vacuum = 1; // Makes this volume a vacuum
        this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
        this_box_volume.p_physics->my_a = 0; // Should not be used.
        sprintf(this_box_volume.p_physics->name,"Vacuum");
    } else if (0 == strcmp(material_string,"exit") || 0 == strcmp(material_string,"Exit")) {
        // One could have a global physics struct for vacuum instead of creating one for each
        this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
        this_box_volume.p_physics->is_vacuum = 1; // Makes this volume a vacuum
        this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
        this_box_volume.p_physics->my_a = 0; // Should not be used.
        this_box_volume.geometry.is_exit_volume = 1;
        sprintf(this_box_volume.p_physics->name,"Exit");
    } else {
        #ifndef MATERIAL_DETECTOR
            printf("Need to define a material before refering to it in a geometry %s.\n",NAME_CURRENT_COMP);
            exit(1);
        #endif
        for (loop_index=0;loop_index<global_material_list.num_elements;loop_index++) {
            if (0 == strcmp(material_string,global_material_list.elements[loop_index].name)) {
                this_box_volume.p_physics = global_material_list.elements[loop_index].physics;
                break;
            }
            if (loop_index == global_material_list.num_elements-1) {
            printf("\n");
            printf("ERROR: The material string \"%s\" in Union geometry \"%s\" did not match a specified material. \n",material_string,NAME_CURRENT_COMP);
            printf("       The materials available at this point (need to be defined before the geometry): \n");
            for (loop_index=0;loop_index<global_material_list.num_elements;loop_index++)
              printf("         %s\n",global_material_list.elements[loop_index].name);
            printf("\n");
            printf("       It is also possible to use one of the defualt materials avaiable: \n");
            printf("           Vacuum (for a Volume without scattering or absorption)\n");
            printf("           Exit (for a Volume where the ray exits the component if it enters)\n");
            printf("           Mask (for a Volume that masks existing volumes specified in the mask_string\n");
            exit(1);
          }
        }
    }
} else {
    // Automatic linking, simply using the last defined material.
    #ifndef MATERIAL_DETECTOR
        printf("Need to define a material before the geometry to use automatic linking %s.\n",NAME_CURRENT_COMP);
        exit(1);
    #endif
    this_box_volume.p_physics = global_material_list.elements[global_material_list.num_elements-1].physics;
}

sprintf(this_box_volume.name,NAME_CURRENT_COMP);
sprintf(this_box_volume.geometry.shape,"box");
this_box_volume.geometry.priority_value = priority;
this_box_volume.geometry.geometry_p_interact = p_interact;
// Currently the coordinates will be in absolute space.
this_box_volume.geometry.center = POS_A_CURRENT_COMP;

this_box_storage.z_depth = zdepth;
this_box_storage.x_width1 = xwidth;
this_box_storage.y_height1 = yheight;

this_box_storage.is_rectangle = 0;
if (xwidth2 < 0 && yheight2 < 0) this_box_storage.is_rectangle = 1;
if (xwidth == xwidth2 && yheight == yheight2) this_box_storage.is_rectangle = 1;

if (xwidth2 < 0) {
    this_box_storage.x_width2 = xwidth;
    xwidth2 = xwidth;
} else this_box_storage.x_width2 = xwidth2;

if (yheight2 < 0) {
    this_box_storage.y_height2 = yheight;
    yheight2 = yheight;
} else this_box_storage.y_height2 = yheight2;


this_box_storage.normal_vectors[0] = coords_set(0,0,1);
this_box_storage.normal_vectors[1] = coords_set(0,0,1);

// for sides with y component = 0
x_component = 2*zdepth/sqrt((xwidth-xwidth2)*(xwidth-xwidth2)+4*zdepth*zdepth);
z_component = (xwidth-xwidth2)/sqrt(4*zdepth*zdepth+(xwidth-xwidth2)*(xwidth-xwidth2));

this_box_storage.normal_vectors[2] = coords_set(x_component,0,z_component);
this_box_storage.normal_vectors[3] = coords_set(-x_component,0,z_component);

// for sides with x component = 0
y_component = 2*zdepth/sqrt((yheight-yheight2)*(yheight-yheight2)+4*zdepth*zdepth);
z_component = (yheight-yheight2)/sqrt(4*zdepth*zdepth+(yheight-yheight2)*(yheight-yheight2));

this_box_storage.normal_vectors[4] = coords_set(0,y_component,z_component);
this_box_storage.normal_vectors[5] = coords_set(0,-y_component,z_component);

this_box_volume.geometry.visualization_on = visualize;

this_box_volume.geometry.geometry_parameters.p_box_storage = &this_box_storage;

// Assign pointers to functions for intersection with the shape, checking if a point is inside the shape
if (this_box_storage.is_rectangle == 1) {
this_box_volume.geometry.intersect_function = &sample_box_intersect_simple;
this_box_volume.geometry.within_function = &r_within_box_simple;
}
else {
this_box_volume.geometry.intersect_function = &sample_box_intersect_advanced;
this_box_volume.geometry.within_function = &r_within_box_advanced;
}

this_box_volume.geometry.shell_points = &box_shell_points;
this_box_volume.geometry.mcdisplay_function = &mcdisplay_box_function;
this_box_volume.geometry.initialize_from_main_function = &initialize_box_geometry_from_main_component;
this_box_volume.geometry.process_rot_allocated = 0;

this_box_volume.geometry.copy_geometry_parameters = &allocate_box_storage_copy;

rot_copy(this_box_volume.geometry.rotation_matrix,ROT_A_CURRENT_COMP); //check how ROT_R_CURRENT_COMP would work
rot_transpose(ROT_A_CURRENT_COMP,this_box_volume.geometry.transpose_rotation_matrix);

// Initialize loggers
this_box_volume.loggers.num_elements = 0;

// packing the information into the global_geometry_element, which is then included in the global_geometry_list.
sprintf(global_geometry_element.name,NAME_CURRENT_COMP);
global_geometry_element.activation_counter = number_of_activations;
global_geometry_element.component_index = INDEX_CURRENT_COMP;
global_geometry_element.Volume = &this_box_volume; // Would be nicer if this m was a pointer, now we have the (small) data two places
add_element_to_geometry_list(&global_geometry_list,global_geometry_element);
}
#line 289937 "MACS_sample_kidney_box.c"
#undef number_of_activations
#undef mask_setting
#undef mask_string
#undef p_interact
#undef focus_r
#undef focus_xh
#undef focus_xw
#undef focus_ah
#undef focus_aw
#undef target_z
#undef target_y
#undef target_x
#undef target_index
#undef visualize
#undef yheight2
#undef xwidth2
#undef zdepth
#undef yheight
#undef xwidth
#undef priority
#undef material_string
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

  /* Initializations for component channel_14_analyzer_1_array_crystal_array_4. */
  SIG_MESSAGE("channel_14_analyzer_1_array_crystal_array_4 (Init)");
#define mccompcurname  channel_14_analyzer_1_array_crystal_array_4
#define mccompcurtype  Union_box
#define mccompcurindex 666
#define loop_index mccchannel_14_analyzer_1_array_crystal_array_4_loop_index
#define this_box_volume mccchannel_14_analyzer_1_array_crystal_array_4_this_box_volume
#define global_geometry_element mccchannel_14_analyzer_1_array_crystal_array_4_global_geometry_element
#define this_box_storage mccchannel_14_analyzer_1_array_crystal_array_4_this_box_storage
#define material_string mccchannel_14_analyzer_1_array_crystal_array_4_material_string
#define priority mccchannel_14_analyzer_1_array_crystal_array_4_priority
#define xwidth mccchannel_14_analyzer_1_array_crystal_array_4_xwidth
#define yheight mccchannel_14_analyzer_1_array_crystal_array_4_yheight
#define zdepth mccchannel_14_analyzer_1_array_crystal_array_4_zdepth
#define xwidth2 mccchannel_14_analyzer_1_array_crystal_array_4_xwidth2
#define yheight2 mccchannel_14_analyzer_1_array_crystal_array_4_yheight2
#define visualize mccchannel_14_analyzer_1_array_crystal_array_4_visualize
#define target_index mccchannel_14_analyzer_1_array_crystal_array_4_target_index
#define target_x mccchannel_14_analyzer_1_array_crystal_array_4_target_x
#define target_y mccchannel_14_analyzer_1_array_crystal_array_4_target_y
#define target_z mccchannel_14_analyzer_1_array_crystal_array_4_target_z
#define focus_aw mccchannel_14_analyzer_1_array_crystal_array_4_focus_aw
#define focus_ah mccchannel_14_analyzer_1_array_crystal_array_4_focus_ah
#define focus_xw mccchannel_14_analyzer_1_array_crystal_array_4_focus_xw
#define focus_xh mccchannel_14_analyzer_1_array_crystal_array_4_focus_xh
#define focus_r mccchannel_14_analyzer_1_array_crystal_array_4_focus_r
#define p_interact mccchannel_14_analyzer_1_array_crystal_array_4_p_interact
#define mask_string mccchannel_14_analyzer_1_array_crystal_array_4_mask_string
#define mask_setting mccchannel_14_analyzer_1_array_crystal_array_4_mask_setting
#define number_of_activations mccchannel_14_analyzer_1_array_crystal_array_4_number_of_activations
#line 224 "Union_box.comp"
{
// Initializes the focusing system for this volume including input sanitation.
focus_initialize(&this_box_volume.geometry, POS_A_COMP_INDEX(INDEX_CURRENT_COMP+target_index), POS_A_CURRENT_COMP, ROT_A_CURRENT_COMP, target_index, target_x, target_y, target_z, focus_aw, focus_ah, focus_xw, focus_xh, focus_r, NAME_CURRENT_COMP);

// Input sanitation for this geometry
if (xwidth <= 0) {
  printf("\nERROR in Union_box named %s, the xwidth is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (yheight <= 0) {
  printf("\nERROR in Union_box named %s, yheight is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (zdepth <= 0) {
  printf("\nERROR in Union_box named %s, zdepth is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (xwidth2 <= 0 && xwidth2 != -1) {
  printf("\nERROR in Union_box named %s, the xwidth2 is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (yheight2 <= 0 && yheight2 != -1) {
  printf("\nERROR in Union_box named %s, yheight2 is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}

// Use sanitation
if (global_material_list.num_elements == 0) {
  printf("\nERROR: Need to define a material using Union_make_material before using a Union geometry component. \n");
  printf("       %s was defined before first use of Union_make_material.\n",NAME_CURRENT_COMP);
  exit(1);
}

this_box_volume.geometry.is_masked_volume = 0;
this_box_volume.geometry.is_exit_volume = 0;
this_box_volume.geometry.is_mask_volume = 0;
// check if the volume is a mask, if it is the material string is irelevant.
if (mask_string && strlen(mask_string) && strcmp(mask_string, "NULL") && strcmp(mask_string, "0")) {
    // A mask volume is used to limit the extend of other volumes, called the masked volumes. These are specified in the mask_string.
    // In order for a ray to enter a masked volume, it needs to be both in the region covered by that volume AND the mask volume.
    // When more than
    this_box_volume.geometry.mask_mode = 1; // Default is mask mode is ALL
    if (mask_setting && strlen(mask_setting) && strcmp(mask_setting, "NULL") && strcmp(mask_setting, "0")) {
        if (strcmp(mask_setting,"ALL") == 0 || strcmp(mask_setting,"All") == 0) this_box_volume.geometry.mask_mode = 1;
        else if (strcmp(mask_setting,"ANY") == 0 || strcmp(mask_setting,"Any") == 0) this_box_volume.geometry.mask_mode = 2;
        else {
            printf("The mask_mode of component %s is set to %s, but must be either ALL or ANY.\n",NAME_CURRENT_COMP,mask_setting);
            exit(1);
        }
    }
    
    for (loop_index=0;loop_index<global_geometry_list.num_elements;loop_index++) {
        // Add mask list
        if (1 == manual_linking_function(global_geometry_list.elements[loop_index].name,mask_string)) {
            add_element_to_int_list(&this_box_volume.geometry.mask_list,global_geometry_list.elements[loop_index].component_index);
            add_element_to_int_list(&global_geometry_list.elements[loop_index].Volume->geometry.masked_by_list,INDEX_CURRENT_COMP);
            global_geometry_list.elements[loop_index].Volume->geometry.is_masked_volume = 1;
            if (this_box_volume.geometry.mask_mode == 2)
                global_geometry_list.elements[loop_index].Volume->geometry.mask_mode = 2;
            if (this_box_volume.geometry.mask_mode == 1) {
                if (global_geometry_list.elements[loop_index].Volume->geometry.is_masked_volume == 1 && global_geometry_list.elements[loop_index].Volume->geometry.mask_mode != 2)
                    // If more than one mask is added to one volume, the ANY mode overwrites the (default) ALL mode.
                    global_geometry_list.elements[loop_index].Volume->geometry.mask_mode = 1;
            }
            
            found_geometries = 1;
        }
    }
    if (found_geometries == 0) {
        printf("The mask_string in geometry: %s did not find any of the specified volumes in the mask_string %s \n",NAME_CURRENT_COMP,mask_string);
        exit(1);
    }
    this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
    this_box_volume.p_physics->is_vacuum = 0; // Makes this volume a vacuum
    this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
    this_box_volume.p_physics->my_a = 0; // Should not be used.
    sprintf(this_box_volume.p_physics->name,"Mask");
    this_box_volume.geometry.is_mask_volume = 1;
    
    
// Read the material input, or if it lacks, use automatic linking.
} else if (material_string && strlen(material_string) && strcmp(material_string, "NULL") && strcmp(material_string, "0")) {
    // A geometry string was given, use it to determine which material
    if (0 == strcmp(material_string,"vacuum") || 0 == strcmp(material_string,"Vacuum")) {
        // One could have a global physics struct for vacuum instead of creating one for each
        this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
        this_box_volume.p_physics->is_vacuum = 1; // Makes this volume a vacuum
        this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
        this_box_volume.p_physics->my_a = 0; // Should not be used.
        sprintf(this_box_volume.p_physics->name,"Vacuum");
    } else if (0 == strcmp(material_string,"exit") || 0 == strcmp(material_string,"Exit")) {
        // One could have a global physics struct for vacuum instead of creating one for each
        this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
        this_box_volume.p_physics->is_vacuum = 1; // Makes this volume a vacuum
        this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
        this_box_volume.p_physics->my_a = 0; // Should not be used.
        this_box_volume.geometry.is_exit_volume = 1;
        sprintf(this_box_volume.p_physics->name,"Exit");
    } else {
        #ifndef MATERIAL_DETECTOR
            printf("Need to define a material before refering to it in a geometry %s.\n",NAME_CURRENT_COMP);
            exit(1);
        #endif
        for (loop_index=0;loop_index<global_material_list.num_elements;loop_index++) {
            if (0 == strcmp(material_string,global_material_list.elements[loop_index].name)) {
                this_box_volume.p_physics = global_material_list.elements[loop_index].physics;
                break;
            }
            if (loop_index == global_material_list.num_elements-1) {
            printf("\n");
            printf("ERROR: The material string \"%s\" in Union geometry \"%s\" did not match a specified material. \n",material_string,NAME_CURRENT_COMP);
            printf("       The materials available at this point (need to be defined before the geometry): \n");
            for (loop_index=0;loop_index<global_material_list.num_elements;loop_index++)
              printf("         %s\n",global_material_list.elements[loop_index].name);
            printf("\n");
            printf("       It is also possible to use one of the defualt materials avaiable: \n");
            printf("           Vacuum (for a Volume without scattering or absorption)\n");
            printf("           Exit (for a Volume where the ray exits the component if it enters)\n");
            printf("           Mask (for a Volume that masks existing volumes specified in the mask_string\n");
            exit(1);
          }
        }
    }
} else {
    // Automatic linking, simply using the last defined material.
    #ifndef MATERIAL_DETECTOR
        printf("Need to define a material before the geometry to use automatic linking %s.\n",NAME_CURRENT_COMP);
        exit(1);
    #endif
    this_box_volume.p_physics = global_material_list.elements[global_material_list.num_elements-1].physics;
}

sprintf(this_box_volume.name,NAME_CURRENT_COMP);
sprintf(this_box_volume.geometry.shape,"box");
this_box_volume.geometry.priority_value = priority;
this_box_volume.geometry.geometry_p_interact = p_interact;
// Currently the coordinates will be in absolute space.
this_box_volume.geometry.center = POS_A_CURRENT_COMP;

this_box_storage.z_depth = zdepth;
this_box_storage.x_width1 = xwidth;
this_box_storage.y_height1 = yheight;

this_box_storage.is_rectangle = 0;
if (xwidth2 < 0 && yheight2 < 0) this_box_storage.is_rectangle = 1;
if (xwidth == xwidth2 && yheight == yheight2) this_box_storage.is_rectangle = 1;

if (xwidth2 < 0) {
    this_box_storage.x_width2 = xwidth;
    xwidth2 = xwidth;
} else this_box_storage.x_width2 = xwidth2;

if (yheight2 < 0) {
    this_box_storage.y_height2 = yheight;
    yheight2 = yheight;
} else this_box_storage.y_height2 = yheight2;


this_box_storage.normal_vectors[0] = coords_set(0,0,1);
this_box_storage.normal_vectors[1] = coords_set(0,0,1);

// for sides with y component = 0
x_component = 2*zdepth/sqrt((xwidth-xwidth2)*(xwidth-xwidth2)+4*zdepth*zdepth);
z_component = (xwidth-xwidth2)/sqrt(4*zdepth*zdepth+(xwidth-xwidth2)*(xwidth-xwidth2));

this_box_storage.normal_vectors[2] = coords_set(x_component,0,z_component);
this_box_storage.normal_vectors[3] = coords_set(-x_component,0,z_component);

// for sides with x component = 0
y_component = 2*zdepth/sqrt((yheight-yheight2)*(yheight-yheight2)+4*zdepth*zdepth);
z_component = (yheight-yheight2)/sqrt(4*zdepth*zdepth+(yheight-yheight2)*(yheight-yheight2));

this_box_storage.normal_vectors[4] = coords_set(0,y_component,z_component);
this_box_storage.normal_vectors[5] = coords_set(0,-y_component,z_component);

this_box_volume.geometry.visualization_on = visualize;

this_box_volume.geometry.geometry_parameters.p_box_storage = &this_box_storage;

// Assign pointers to functions for intersection with the shape, checking if a point is inside the shape
if (this_box_storage.is_rectangle == 1) {
this_box_volume.geometry.intersect_function = &sample_box_intersect_simple;
this_box_volume.geometry.within_function = &r_within_box_simple;
}
else {
this_box_volume.geometry.intersect_function = &sample_box_intersect_advanced;
this_box_volume.geometry.within_function = &r_within_box_advanced;
}

this_box_volume.geometry.shell_points = &box_shell_points;
this_box_volume.geometry.mcdisplay_function = &mcdisplay_box_function;
this_box_volume.geometry.initialize_from_main_function = &initialize_box_geometry_from_main_component;
this_box_volume.geometry.process_rot_allocated = 0;

this_box_volume.geometry.copy_geometry_parameters = &allocate_box_storage_copy;

rot_copy(this_box_volume.geometry.rotation_matrix,ROT_A_CURRENT_COMP); //check how ROT_R_CURRENT_COMP would work
rot_transpose(ROT_A_CURRENT_COMP,this_box_volume.geometry.transpose_rotation_matrix);

// Initialize loggers
this_box_volume.loggers.num_elements = 0;

// packing the information into the global_geometry_element, which is then included in the global_geometry_list.
sprintf(global_geometry_element.name,NAME_CURRENT_COMP);
global_geometry_element.activation_counter = number_of_activations;
global_geometry_element.component_index = INDEX_CURRENT_COMP;
global_geometry_element.Volume = &this_box_volume; // Would be nicer if this m was a pointer, now we have the (small) data two places
add_element_to_geometry_list(&global_geometry_list,global_geometry_element);
}
#line 290207 "MACS_sample_kidney_box.c"
#undef number_of_activations
#undef mask_setting
#undef mask_string
#undef p_interact
#undef focus_r
#undef focus_xh
#undef focus_xw
#undef focus_ah
#undef focus_aw
#undef target_z
#undef target_y
#undef target_x
#undef target_index
#undef visualize
#undef yheight2
#undef xwidth2
#undef zdepth
#undef yheight
#undef xwidth
#undef priority
#undef material_string
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

  /* Initializations for component channel_14_analyzer_1_array_crystal_array_5. */
  SIG_MESSAGE("channel_14_analyzer_1_array_crystal_array_5 (Init)");
#define mccompcurname  channel_14_analyzer_1_array_crystal_array_5
#define mccompcurtype  Union_box
#define mccompcurindex 667
#define loop_index mccchannel_14_analyzer_1_array_crystal_array_5_loop_index
#define this_box_volume mccchannel_14_analyzer_1_array_crystal_array_5_this_box_volume
#define global_geometry_element mccchannel_14_analyzer_1_array_crystal_array_5_global_geometry_element
#define this_box_storage mccchannel_14_analyzer_1_array_crystal_array_5_this_box_storage
#define material_string mccchannel_14_analyzer_1_array_crystal_array_5_material_string
#define priority mccchannel_14_analyzer_1_array_crystal_array_5_priority
#define xwidth mccchannel_14_analyzer_1_array_crystal_array_5_xwidth
#define yheight mccchannel_14_analyzer_1_array_crystal_array_5_yheight
#define zdepth mccchannel_14_analyzer_1_array_crystal_array_5_zdepth
#define xwidth2 mccchannel_14_analyzer_1_array_crystal_array_5_xwidth2
#define yheight2 mccchannel_14_analyzer_1_array_crystal_array_5_yheight2
#define visualize mccchannel_14_analyzer_1_array_crystal_array_5_visualize
#define target_index mccchannel_14_analyzer_1_array_crystal_array_5_target_index
#define target_x mccchannel_14_analyzer_1_array_crystal_array_5_target_x
#define target_y mccchannel_14_analyzer_1_array_crystal_array_5_target_y
#define target_z mccchannel_14_analyzer_1_array_crystal_array_5_target_z
#define focus_aw mccchannel_14_analyzer_1_array_crystal_array_5_focus_aw
#define focus_ah mccchannel_14_analyzer_1_array_crystal_array_5_focus_ah
#define focus_xw mccchannel_14_analyzer_1_array_crystal_array_5_focus_xw
#define focus_xh mccchannel_14_analyzer_1_array_crystal_array_5_focus_xh
#define focus_r mccchannel_14_analyzer_1_array_crystal_array_5_focus_r
#define p_interact mccchannel_14_analyzer_1_array_crystal_array_5_p_interact
#define mask_string mccchannel_14_analyzer_1_array_crystal_array_5_mask_string
#define mask_setting mccchannel_14_analyzer_1_array_crystal_array_5_mask_setting
#define number_of_activations mccchannel_14_analyzer_1_array_crystal_array_5_number_of_activations
#line 224 "Union_box.comp"
{
// Initializes the focusing system for this volume including input sanitation.
focus_initialize(&this_box_volume.geometry, POS_A_COMP_INDEX(INDEX_CURRENT_COMP+target_index), POS_A_CURRENT_COMP, ROT_A_CURRENT_COMP, target_index, target_x, target_y, target_z, focus_aw, focus_ah, focus_xw, focus_xh, focus_r, NAME_CURRENT_COMP);

// Input sanitation for this geometry
if (xwidth <= 0) {
  printf("\nERROR in Union_box named %s, the xwidth is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (yheight <= 0) {
  printf("\nERROR in Union_box named %s, yheight is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (zdepth <= 0) {
  printf("\nERROR in Union_box named %s, zdepth is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (xwidth2 <= 0 && xwidth2 != -1) {
  printf("\nERROR in Union_box named %s, the xwidth2 is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (yheight2 <= 0 && yheight2 != -1) {
  printf("\nERROR in Union_box named %s, yheight2 is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}

// Use sanitation
if (global_material_list.num_elements == 0) {
  printf("\nERROR: Need to define a material using Union_make_material before using a Union geometry component. \n");
  printf("       %s was defined before first use of Union_make_material.\n",NAME_CURRENT_COMP);
  exit(1);
}

this_box_volume.geometry.is_masked_volume = 0;
this_box_volume.geometry.is_exit_volume = 0;
this_box_volume.geometry.is_mask_volume = 0;
// check if the volume is a mask, if it is the material string is irelevant.
if (mask_string && strlen(mask_string) && strcmp(mask_string, "NULL") && strcmp(mask_string, "0")) {
    // A mask volume is used to limit the extend of other volumes, called the masked volumes. These are specified in the mask_string.
    // In order for a ray to enter a masked volume, it needs to be both in the region covered by that volume AND the mask volume.
    // When more than
    this_box_volume.geometry.mask_mode = 1; // Default is mask mode is ALL
    if (mask_setting && strlen(mask_setting) && strcmp(mask_setting, "NULL") && strcmp(mask_setting, "0")) {
        if (strcmp(mask_setting,"ALL") == 0 || strcmp(mask_setting,"All") == 0) this_box_volume.geometry.mask_mode = 1;
        else if (strcmp(mask_setting,"ANY") == 0 || strcmp(mask_setting,"Any") == 0) this_box_volume.geometry.mask_mode = 2;
        else {
            printf("The mask_mode of component %s is set to %s, but must be either ALL or ANY.\n",NAME_CURRENT_COMP,mask_setting);
            exit(1);
        }
    }
    
    for (loop_index=0;loop_index<global_geometry_list.num_elements;loop_index++) {
        // Add mask list
        if (1 == manual_linking_function(global_geometry_list.elements[loop_index].name,mask_string)) {
            add_element_to_int_list(&this_box_volume.geometry.mask_list,global_geometry_list.elements[loop_index].component_index);
            add_element_to_int_list(&global_geometry_list.elements[loop_index].Volume->geometry.masked_by_list,INDEX_CURRENT_COMP);
            global_geometry_list.elements[loop_index].Volume->geometry.is_masked_volume = 1;
            if (this_box_volume.geometry.mask_mode == 2)
                global_geometry_list.elements[loop_index].Volume->geometry.mask_mode = 2;
            if (this_box_volume.geometry.mask_mode == 1) {
                if (global_geometry_list.elements[loop_index].Volume->geometry.is_masked_volume == 1 && global_geometry_list.elements[loop_index].Volume->geometry.mask_mode != 2)
                    // If more than one mask is added to one volume, the ANY mode overwrites the (default) ALL mode.
                    global_geometry_list.elements[loop_index].Volume->geometry.mask_mode = 1;
            }
            
            found_geometries = 1;
        }
    }
    if (found_geometries == 0) {
        printf("The mask_string in geometry: %s did not find any of the specified volumes in the mask_string %s \n",NAME_CURRENT_COMP,mask_string);
        exit(1);
    }
    this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
    this_box_volume.p_physics->is_vacuum = 0; // Makes this volume a vacuum
    this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
    this_box_volume.p_physics->my_a = 0; // Should not be used.
    sprintf(this_box_volume.p_physics->name,"Mask");
    this_box_volume.geometry.is_mask_volume = 1;
    
    
// Read the material input, or if it lacks, use automatic linking.
} else if (material_string && strlen(material_string) && strcmp(material_string, "NULL") && strcmp(material_string, "0")) {
    // A geometry string was given, use it to determine which material
    if (0 == strcmp(material_string,"vacuum") || 0 == strcmp(material_string,"Vacuum")) {
        // One could have a global physics struct for vacuum instead of creating one for each
        this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
        this_box_volume.p_physics->is_vacuum = 1; // Makes this volume a vacuum
        this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
        this_box_volume.p_physics->my_a = 0; // Should not be used.
        sprintf(this_box_volume.p_physics->name,"Vacuum");
    } else if (0 == strcmp(material_string,"exit") || 0 == strcmp(material_string,"Exit")) {
        // One could have a global physics struct for vacuum instead of creating one for each
        this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
        this_box_volume.p_physics->is_vacuum = 1; // Makes this volume a vacuum
        this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
        this_box_volume.p_physics->my_a = 0; // Should not be used.
        this_box_volume.geometry.is_exit_volume = 1;
        sprintf(this_box_volume.p_physics->name,"Exit");
    } else {
        #ifndef MATERIAL_DETECTOR
            printf("Need to define a material before refering to it in a geometry %s.\n",NAME_CURRENT_COMP);
            exit(1);
        #endif
        for (loop_index=0;loop_index<global_material_list.num_elements;loop_index++) {
            if (0 == strcmp(material_string,global_material_list.elements[loop_index].name)) {
                this_box_volume.p_physics = global_material_list.elements[loop_index].physics;
                break;
            }
            if (loop_index == global_material_list.num_elements-1) {
            printf("\n");
            printf("ERROR: The material string \"%s\" in Union geometry \"%s\" did not match a specified material. \n",material_string,NAME_CURRENT_COMP);
            printf("       The materials available at this point (need to be defined before the geometry): \n");
            for (loop_index=0;loop_index<global_material_list.num_elements;loop_index++)
              printf("         %s\n",global_material_list.elements[loop_index].name);
            printf("\n");
            printf("       It is also possible to use one of the defualt materials avaiable: \n");
            printf("           Vacuum (for a Volume without scattering or absorption)\n");
            printf("           Exit (for a Volume where the ray exits the component if it enters)\n");
            printf("           Mask (for a Volume that masks existing volumes specified in the mask_string\n");
            exit(1);
          }
        }
    }
} else {
    // Automatic linking, simply using the last defined material.
    #ifndef MATERIAL_DETECTOR
        printf("Need to define a material before the geometry to use automatic linking %s.\n",NAME_CURRENT_COMP);
        exit(1);
    #endif
    this_box_volume.p_physics = global_material_list.elements[global_material_list.num_elements-1].physics;
}

sprintf(this_box_volume.name,NAME_CURRENT_COMP);
sprintf(this_box_volume.geometry.shape,"box");
this_box_volume.geometry.priority_value = priority;
this_box_volume.geometry.geometry_p_interact = p_interact;
// Currently the coordinates will be in absolute space.
this_box_volume.geometry.center = POS_A_CURRENT_COMP;

this_box_storage.z_depth = zdepth;
this_box_storage.x_width1 = xwidth;
this_box_storage.y_height1 = yheight;

this_box_storage.is_rectangle = 0;
if (xwidth2 < 0 && yheight2 < 0) this_box_storage.is_rectangle = 1;
if (xwidth == xwidth2 && yheight == yheight2) this_box_storage.is_rectangle = 1;

if (xwidth2 < 0) {
    this_box_storage.x_width2 = xwidth;
    xwidth2 = xwidth;
} else this_box_storage.x_width2 = xwidth2;

if (yheight2 < 0) {
    this_box_storage.y_height2 = yheight;
    yheight2 = yheight;
} else this_box_storage.y_height2 = yheight2;


this_box_storage.normal_vectors[0] = coords_set(0,0,1);
this_box_storage.normal_vectors[1] = coords_set(0,0,1);

// for sides with y component = 0
x_component = 2*zdepth/sqrt((xwidth-xwidth2)*(xwidth-xwidth2)+4*zdepth*zdepth);
z_component = (xwidth-xwidth2)/sqrt(4*zdepth*zdepth+(xwidth-xwidth2)*(xwidth-xwidth2));

this_box_storage.normal_vectors[2] = coords_set(x_component,0,z_component);
this_box_storage.normal_vectors[3] = coords_set(-x_component,0,z_component);

// for sides with x component = 0
y_component = 2*zdepth/sqrt((yheight-yheight2)*(yheight-yheight2)+4*zdepth*zdepth);
z_component = (yheight-yheight2)/sqrt(4*zdepth*zdepth+(yheight-yheight2)*(yheight-yheight2));

this_box_storage.normal_vectors[4] = coords_set(0,y_component,z_component);
this_box_storage.normal_vectors[5] = coords_set(0,-y_component,z_component);

this_box_volume.geometry.visualization_on = visualize;

this_box_volume.geometry.geometry_parameters.p_box_storage = &this_box_storage;

// Assign pointers to functions for intersection with the shape, checking if a point is inside the shape
if (this_box_storage.is_rectangle == 1) {
this_box_volume.geometry.intersect_function = &sample_box_intersect_simple;
this_box_volume.geometry.within_function = &r_within_box_simple;
}
else {
this_box_volume.geometry.intersect_function = &sample_box_intersect_advanced;
this_box_volume.geometry.within_function = &r_within_box_advanced;
}

this_box_volume.geometry.shell_points = &box_shell_points;
this_box_volume.geometry.mcdisplay_function = &mcdisplay_box_function;
this_box_volume.geometry.initialize_from_main_function = &initialize_box_geometry_from_main_component;
this_box_volume.geometry.process_rot_allocated = 0;

this_box_volume.geometry.copy_geometry_parameters = &allocate_box_storage_copy;

rot_copy(this_box_volume.geometry.rotation_matrix,ROT_A_CURRENT_COMP); //check how ROT_R_CURRENT_COMP would work
rot_transpose(ROT_A_CURRENT_COMP,this_box_volume.geometry.transpose_rotation_matrix);

// Initialize loggers
this_box_volume.loggers.num_elements = 0;

// packing the information into the global_geometry_element, which is then included in the global_geometry_list.
sprintf(global_geometry_element.name,NAME_CURRENT_COMP);
global_geometry_element.activation_counter = number_of_activations;
global_geometry_element.component_index = INDEX_CURRENT_COMP;
global_geometry_element.Volume = &this_box_volume; // Would be nicer if this m was a pointer, now we have the (small) data two places
add_element_to_geometry_list(&global_geometry_list,global_geometry_element);
}
#line 290477 "MACS_sample_kidney_box.c"
#undef number_of_activations
#undef mask_setting
#undef mask_string
#undef p_interact
#undef focus_r
#undef focus_xh
#undef focus_xw
#undef focus_ah
#undef focus_aw
#undef target_z
#undef target_y
#undef target_x
#undef target_index
#undef visualize
#undef yheight2
#undef xwidth2
#undef zdepth
#undef yheight
#undef xwidth
#undef priority
#undef material_string
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

  /* Initializations for component channel_14_analyzer_1_array_crystal_array_6. */
  SIG_MESSAGE("channel_14_analyzer_1_array_crystal_array_6 (Init)");
#define mccompcurname  channel_14_analyzer_1_array_crystal_array_6
#define mccompcurtype  Union_box
#define mccompcurindex 668
#define loop_index mccchannel_14_analyzer_1_array_crystal_array_6_loop_index
#define this_box_volume mccchannel_14_analyzer_1_array_crystal_array_6_this_box_volume
#define global_geometry_element mccchannel_14_analyzer_1_array_crystal_array_6_global_geometry_element
#define this_box_storage mccchannel_14_analyzer_1_array_crystal_array_6_this_box_storage
#define material_string mccchannel_14_analyzer_1_array_crystal_array_6_material_string
#define priority mccchannel_14_analyzer_1_array_crystal_array_6_priority
#define xwidth mccchannel_14_analyzer_1_array_crystal_array_6_xwidth
#define yheight mccchannel_14_analyzer_1_array_crystal_array_6_yheight
#define zdepth mccchannel_14_analyzer_1_array_crystal_array_6_zdepth
#define xwidth2 mccchannel_14_analyzer_1_array_crystal_array_6_xwidth2
#define yheight2 mccchannel_14_analyzer_1_array_crystal_array_6_yheight2
#define visualize mccchannel_14_analyzer_1_array_crystal_array_6_visualize
#define target_index mccchannel_14_analyzer_1_array_crystal_array_6_target_index
#define target_x mccchannel_14_analyzer_1_array_crystal_array_6_target_x
#define target_y mccchannel_14_analyzer_1_array_crystal_array_6_target_y
#define target_z mccchannel_14_analyzer_1_array_crystal_array_6_target_z
#define focus_aw mccchannel_14_analyzer_1_array_crystal_array_6_focus_aw
#define focus_ah mccchannel_14_analyzer_1_array_crystal_array_6_focus_ah
#define focus_xw mccchannel_14_analyzer_1_array_crystal_array_6_focus_xw
#define focus_xh mccchannel_14_analyzer_1_array_crystal_array_6_focus_xh
#define focus_r mccchannel_14_analyzer_1_array_crystal_array_6_focus_r
#define p_interact mccchannel_14_analyzer_1_array_crystal_array_6_p_interact
#define mask_string mccchannel_14_analyzer_1_array_crystal_array_6_mask_string
#define mask_setting mccchannel_14_analyzer_1_array_crystal_array_6_mask_setting
#define number_of_activations mccchannel_14_analyzer_1_array_crystal_array_6_number_of_activations
#line 224 "Union_box.comp"
{
// Initializes the focusing system for this volume including input sanitation.
focus_initialize(&this_box_volume.geometry, POS_A_COMP_INDEX(INDEX_CURRENT_COMP+target_index), POS_A_CURRENT_COMP, ROT_A_CURRENT_COMP, target_index, target_x, target_y, target_z, focus_aw, focus_ah, focus_xw, focus_xh, focus_r, NAME_CURRENT_COMP);

// Input sanitation for this geometry
if (xwidth <= 0) {
  printf("\nERROR in Union_box named %s, the xwidth is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (yheight <= 0) {
  printf("\nERROR in Union_box named %s, yheight is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (zdepth <= 0) {
  printf("\nERROR in Union_box named %s, zdepth is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (xwidth2 <= 0 && xwidth2 != -1) {
  printf("\nERROR in Union_box named %s, the xwidth2 is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (yheight2 <= 0 && yheight2 != -1) {
  printf("\nERROR in Union_box named %s, yheight2 is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}

// Use sanitation
if (global_material_list.num_elements == 0) {
  printf("\nERROR: Need to define a material using Union_make_material before using a Union geometry component. \n");
  printf("       %s was defined before first use of Union_make_material.\n",NAME_CURRENT_COMP);
  exit(1);
}

this_box_volume.geometry.is_masked_volume = 0;
this_box_volume.geometry.is_exit_volume = 0;
this_box_volume.geometry.is_mask_volume = 0;
// check if the volume is a mask, if it is the material string is irelevant.
if (mask_string && strlen(mask_string) && strcmp(mask_string, "NULL") && strcmp(mask_string, "0")) {
    // A mask volume is used to limit the extend of other volumes, called the masked volumes. These are specified in the mask_string.
    // In order for a ray to enter a masked volume, it needs to be both in the region covered by that volume AND the mask volume.
    // When more than
    this_box_volume.geometry.mask_mode = 1; // Default is mask mode is ALL
    if (mask_setting && strlen(mask_setting) && strcmp(mask_setting, "NULL") && strcmp(mask_setting, "0")) {
        if (strcmp(mask_setting,"ALL") == 0 || strcmp(mask_setting,"All") == 0) this_box_volume.geometry.mask_mode = 1;
        else if (strcmp(mask_setting,"ANY") == 0 || strcmp(mask_setting,"Any") == 0) this_box_volume.geometry.mask_mode = 2;
        else {
            printf("The mask_mode of component %s is set to %s, but must be either ALL or ANY.\n",NAME_CURRENT_COMP,mask_setting);
            exit(1);
        }
    }
    
    for (loop_index=0;loop_index<global_geometry_list.num_elements;loop_index++) {
        // Add mask list
        if (1 == manual_linking_function(global_geometry_list.elements[loop_index].name,mask_string)) {
            add_element_to_int_list(&this_box_volume.geometry.mask_list,global_geometry_list.elements[loop_index].component_index);
            add_element_to_int_list(&global_geometry_list.elements[loop_index].Volume->geometry.masked_by_list,INDEX_CURRENT_COMP);
            global_geometry_list.elements[loop_index].Volume->geometry.is_masked_volume = 1;
            if (this_box_volume.geometry.mask_mode == 2)
                global_geometry_list.elements[loop_index].Volume->geometry.mask_mode = 2;
            if (this_box_volume.geometry.mask_mode == 1) {
                if (global_geometry_list.elements[loop_index].Volume->geometry.is_masked_volume == 1 && global_geometry_list.elements[loop_index].Volume->geometry.mask_mode != 2)
                    // If more than one mask is added to one volume, the ANY mode overwrites the (default) ALL mode.
                    global_geometry_list.elements[loop_index].Volume->geometry.mask_mode = 1;
            }
            
            found_geometries = 1;
        }
    }
    if (found_geometries == 0) {
        printf("The mask_string in geometry: %s did not find any of the specified volumes in the mask_string %s \n",NAME_CURRENT_COMP,mask_string);
        exit(1);
    }
    this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
    this_box_volume.p_physics->is_vacuum = 0; // Makes this volume a vacuum
    this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
    this_box_volume.p_physics->my_a = 0; // Should not be used.
    sprintf(this_box_volume.p_physics->name,"Mask");
    this_box_volume.geometry.is_mask_volume = 1;
    
    
// Read the material input, or if it lacks, use automatic linking.
} else if (material_string && strlen(material_string) && strcmp(material_string, "NULL") && strcmp(material_string, "0")) {
    // A geometry string was given, use it to determine which material
    if (0 == strcmp(material_string,"vacuum") || 0 == strcmp(material_string,"Vacuum")) {
        // One could have a global physics struct for vacuum instead of creating one for each
        this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
        this_box_volume.p_physics->is_vacuum = 1; // Makes this volume a vacuum
        this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
        this_box_volume.p_physics->my_a = 0; // Should not be used.
        sprintf(this_box_volume.p_physics->name,"Vacuum");
    } else if (0 == strcmp(material_string,"exit") || 0 == strcmp(material_string,"Exit")) {
        // One could have a global physics struct for vacuum instead of creating one for each
        this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
        this_box_volume.p_physics->is_vacuum = 1; // Makes this volume a vacuum
        this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
        this_box_volume.p_physics->my_a = 0; // Should not be used.
        this_box_volume.geometry.is_exit_volume = 1;
        sprintf(this_box_volume.p_physics->name,"Exit");
    } else {
        #ifndef MATERIAL_DETECTOR
            printf("Need to define a material before refering to it in a geometry %s.\n",NAME_CURRENT_COMP);
            exit(1);
        #endif
        for (loop_index=0;loop_index<global_material_list.num_elements;loop_index++) {
            if (0 == strcmp(material_string,global_material_list.elements[loop_index].name)) {
                this_box_volume.p_physics = global_material_list.elements[loop_index].physics;
                break;
            }
            if (loop_index == global_material_list.num_elements-1) {
            printf("\n");
            printf("ERROR: The material string \"%s\" in Union geometry \"%s\" did not match a specified material. \n",material_string,NAME_CURRENT_COMP);
            printf("       The materials available at this point (need to be defined before the geometry): \n");
            for (loop_index=0;loop_index<global_material_list.num_elements;loop_index++)
              printf("         %s\n",global_material_list.elements[loop_index].name);
            printf("\n");
            printf("       It is also possible to use one of the defualt materials avaiable: \n");
            printf("           Vacuum (for a Volume without scattering or absorption)\n");
            printf("           Exit (for a Volume where the ray exits the component if it enters)\n");
            printf("           Mask (for a Volume that masks existing volumes specified in the mask_string\n");
            exit(1);
          }
        }
    }
} else {
    // Automatic linking, simply using the last defined material.
    #ifndef MATERIAL_DETECTOR
        printf("Need to define a material before the geometry to use automatic linking %s.\n",NAME_CURRENT_COMP);
        exit(1);
    #endif
    this_box_volume.p_physics = global_material_list.elements[global_material_list.num_elements-1].physics;
}

sprintf(this_box_volume.name,NAME_CURRENT_COMP);
sprintf(this_box_volume.geometry.shape,"box");
this_box_volume.geometry.priority_value = priority;
this_box_volume.geometry.geometry_p_interact = p_interact;
// Currently the coordinates will be in absolute space.
this_box_volume.geometry.center = POS_A_CURRENT_COMP;

this_box_storage.z_depth = zdepth;
this_box_storage.x_width1 = xwidth;
this_box_storage.y_height1 = yheight;

this_box_storage.is_rectangle = 0;
if (xwidth2 < 0 && yheight2 < 0) this_box_storage.is_rectangle = 1;
if (xwidth == xwidth2 && yheight == yheight2) this_box_storage.is_rectangle = 1;

if (xwidth2 < 0) {
    this_box_storage.x_width2 = xwidth;
    xwidth2 = xwidth;
} else this_box_storage.x_width2 = xwidth2;

if (yheight2 < 0) {
    this_box_storage.y_height2 = yheight;
    yheight2 = yheight;
} else this_box_storage.y_height2 = yheight2;


this_box_storage.normal_vectors[0] = coords_set(0,0,1);
this_box_storage.normal_vectors[1] = coords_set(0,0,1);

// for sides with y component = 0
x_component = 2*zdepth/sqrt((xwidth-xwidth2)*(xwidth-xwidth2)+4*zdepth*zdepth);
z_component = (xwidth-xwidth2)/sqrt(4*zdepth*zdepth+(xwidth-xwidth2)*(xwidth-xwidth2));

this_box_storage.normal_vectors[2] = coords_set(x_component,0,z_component);
this_box_storage.normal_vectors[3] = coords_set(-x_component,0,z_component);

// for sides with x component = 0
y_component = 2*zdepth/sqrt((yheight-yheight2)*(yheight-yheight2)+4*zdepth*zdepth);
z_component = (yheight-yheight2)/sqrt(4*zdepth*zdepth+(yheight-yheight2)*(yheight-yheight2));

this_box_storage.normal_vectors[4] = coords_set(0,y_component,z_component);
this_box_storage.normal_vectors[5] = coords_set(0,-y_component,z_component);

this_box_volume.geometry.visualization_on = visualize;

this_box_volume.geometry.geometry_parameters.p_box_storage = &this_box_storage;

// Assign pointers to functions for intersection with the shape, checking if a point is inside the shape
if (this_box_storage.is_rectangle == 1) {
this_box_volume.geometry.intersect_function = &sample_box_intersect_simple;
this_box_volume.geometry.within_function = &r_within_box_simple;
}
else {
this_box_volume.geometry.intersect_function = &sample_box_intersect_advanced;
this_box_volume.geometry.within_function = &r_within_box_advanced;
}

this_box_volume.geometry.shell_points = &box_shell_points;
this_box_volume.geometry.mcdisplay_function = &mcdisplay_box_function;
this_box_volume.geometry.initialize_from_main_function = &initialize_box_geometry_from_main_component;
this_box_volume.geometry.process_rot_allocated = 0;

this_box_volume.geometry.copy_geometry_parameters = &allocate_box_storage_copy;

rot_copy(this_box_volume.geometry.rotation_matrix,ROT_A_CURRENT_COMP); //check how ROT_R_CURRENT_COMP would work
rot_transpose(ROT_A_CURRENT_COMP,this_box_volume.geometry.transpose_rotation_matrix);

// Initialize loggers
this_box_volume.loggers.num_elements = 0;

// packing the information into the global_geometry_element, which is then included in the global_geometry_list.
sprintf(global_geometry_element.name,NAME_CURRENT_COMP);
global_geometry_element.activation_counter = number_of_activations;
global_geometry_element.component_index = INDEX_CURRENT_COMP;
global_geometry_element.Volume = &this_box_volume; // Would be nicer if this m was a pointer, now we have the (small) data two places
add_element_to_geometry_list(&global_geometry_list,global_geometry_element);
}
#line 290747 "MACS_sample_kidney_box.c"
#undef number_of_activations
#undef mask_setting
#undef mask_string
#undef p_interact
#undef focus_r
#undef focus_xh
#undef focus_xw
#undef focus_ah
#undef focus_aw
#undef target_z
#undef target_y
#undef target_x
#undef target_index
#undef visualize
#undef yheight2
#undef xwidth2
#undef zdepth
#undef yheight
#undef xwidth
#undef priority
#undef material_string
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

  /* Initializations for component channel_14_analyzer_1_array_crystal_array_7. */
  SIG_MESSAGE("channel_14_analyzer_1_array_crystal_array_7 (Init)");
#define mccompcurname  channel_14_analyzer_1_array_crystal_array_7
#define mccompcurtype  Union_box
#define mccompcurindex 669
#define loop_index mccchannel_14_analyzer_1_array_crystal_array_7_loop_index
#define this_box_volume mccchannel_14_analyzer_1_array_crystal_array_7_this_box_volume
#define global_geometry_element mccchannel_14_analyzer_1_array_crystal_array_7_global_geometry_element
#define this_box_storage mccchannel_14_analyzer_1_array_crystal_array_7_this_box_storage
#define material_string mccchannel_14_analyzer_1_array_crystal_array_7_material_string
#define priority mccchannel_14_analyzer_1_array_crystal_array_7_priority
#define xwidth mccchannel_14_analyzer_1_array_crystal_array_7_xwidth
#define yheight mccchannel_14_analyzer_1_array_crystal_array_7_yheight
#define zdepth mccchannel_14_analyzer_1_array_crystal_array_7_zdepth
#define xwidth2 mccchannel_14_analyzer_1_array_crystal_array_7_xwidth2
#define yheight2 mccchannel_14_analyzer_1_array_crystal_array_7_yheight2
#define visualize mccchannel_14_analyzer_1_array_crystal_array_7_visualize
#define target_index mccchannel_14_analyzer_1_array_crystal_array_7_target_index
#define target_x mccchannel_14_analyzer_1_array_crystal_array_7_target_x
#define target_y mccchannel_14_analyzer_1_array_crystal_array_7_target_y
#define target_z mccchannel_14_analyzer_1_array_crystal_array_7_target_z
#define focus_aw mccchannel_14_analyzer_1_array_crystal_array_7_focus_aw
#define focus_ah mccchannel_14_analyzer_1_array_crystal_array_7_focus_ah
#define focus_xw mccchannel_14_analyzer_1_array_crystal_array_7_focus_xw
#define focus_xh mccchannel_14_analyzer_1_array_crystal_array_7_focus_xh
#define focus_r mccchannel_14_analyzer_1_array_crystal_array_7_focus_r
#define p_interact mccchannel_14_analyzer_1_array_crystal_array_7_p_interact
#define mask_string mccchannel_14_analyzer_1_array_crystal_array_7_mask_string
#define mask_setting mccchannel_14_analyzer_1_array_crystal_array_7_mask_setting
#define number_of_activations mccchannel_14_analyzer_1_array_crystal_array_7_number_of_activations
#line 224 "Union_box.comp"
{
// Initializes the focusing system for this volume including input sanitation.
focus_initialize(&this_box_volume.geometry, POS_A_COMP_INDEX(INDEX_CURRENT_COMP+target_index), POS_A_CURRENT_COMP, ROT_A_CURRENT_COMP, target_index, target_x, target_y, target_z, focus_aw, focus_ah, focus_xw, focus_xh, focus_r, NAME_CURRENT_COMP);

// Input sanitation for this geometry
if (xwidth <= 0) {
  printf("\nERROR in Union_box named %s, the xwidth is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (yheight <= 0) {
  printf("\nERROR in Union_box named %s, yheight is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (zdepth <= 0) {
  printf("\nERROR in Union_box named %s, zdepth is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (xwidth2 <= 0 && xwidth2 != -1) {
  printf("\nERROR in Union_box named %s, the xwidth2 is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (yheight2 <= 0 && yheight2 != -1) {
  printf("\nERROR in Union_box named %s, yheight2 is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}

// Use sanitation
if (global_material_list.num_elements == 0) {
  printf("\nERROR: Need to define a material using Union_make_material before using a Union geometry component. \n");
  printf("       %s was defined before first use of Union_make_material.\n",NAME_CURRENT_COMP);
  exit(1);
}

this_box_volume.geometry.is_masked_volume = 0;
this_box_volume.geometry.is_exit_volume = 0;
this_box_volume.geometry.is_mask_volume = 0;
// check if the volume is a mask, if it is the material string is irelevant.
if (mask_string && strlen(mask_string) && strcmp(mask_string, "NULL") && strcmp(mask_string, "0")) {
    // A mask volume is used to limit the extend of other volumes, called the masked volumes. These are specified in the mask_string.
    // In order for a ray to enter a masked volume, it needs to be both in the region covered by that volume AND the mask volume.
    // When more than
    this_box_volume.geometry.mask_mode = 1; // Default is mask mode is ALL
    if (mask_setting && strlen(mask_setting) && strcmp(mask_setting, "NULL") && strcmp(mask_setting, "0")) {
        if (strcmp(mask_setting,"ALL") == 0 || strcmp(mask_setting,"All") == 0) this_box_volume.geometry.mask_mode = 1;
        else if (strcmp(mask_setting,"ANY") == 0 || strcmp(mask_setting,"Any") == 0) this_box_volume.geometry.mask_mode = 2;
        else {
            printf("The mask_mode of component %s is set to %s, but must be either ALL or ANY.\n",NAME_CURRENT_COMP,mask_setting);
            exit(1);
        }
    }
    
    for (loop_index=0;loop_index<global_geometry_list.num_elements;loop_index++) {
        // Add mask list
        if (1 == manual_linking_function(global_geometry_list.elements[loop_index].name,mask_string)) {
            add_element_to_int_list(&this_box_volume.geometry.mask_list,global_geometry_list.elements[loop_index].component_index);
            add_element_to_int_list(&global_geometry_list.elements[loop_index].Volume->geometry.masked_by_list,INDEX_CURRENT_COMP);
            global_geometry_list.elements[loop_index].Volume->geometry.is_masked_volume = 1;
            if (this_box_volume.geometry.mask_mode == 2)
                global_geometry_list.elements[loop_index].Volume->geometry.mask_mode = 2;
            if (this_box_volume.geometry.mask_mode == 1) {
                if (global_geometry_list.elements[loop_index].Volume->geometry.is_masked_volume == 1 && global_geometry_list.elements[loop_index].Volume->geometry.mask_mode != 2)
                    // If more than one mask is added to one volume, the ANY mode overwrites the (default) ALL mode.
                    global_geometry_list.elements[loop_index].Volume->geometry.mask_mode = 1;
            }
            
            found_geometries = 1;
        }
    }
    if (found_geometries == 0) {
        printf("The mask_string in geometry: %s did not find any of the specified volumes in the mask_string %s \n",NAME_CURRENT_COMP,mask_string);
        exit(1);
    }
    this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
    this_box_volume.p_physics->is_vacuum = 0; // Makes this volume a vacuum
    this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
    this_box_volume.p_physics->my_a = 0; // Should not be used.
    sprintf(this_box_volume.p_physics->name,"Mask");
    this_box_volume.geometry.is_mask_volume = 1;
    
    
// Read the material input, or if it lacks, use automatic linking.
} else if (material_string && strlen(material_string) && strcmp(material_string, "NULL") && strcmp(material_string, "0")) {
    // A geometry string was given, use it to determine which material
    if (0 == strcmp(material_string,"vacuum") || 0 == strcmp(material_string,"Vacuum")) {
        // One could have a global physics struct for vacuum instead of creating one for each
        this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
        this_box_volume.p_physics->is_vacuum = 1; // Makes this volume a vacuum
        this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
        this_box_volume.p_physics->my_a = 0; // Should not be used.
        sprintf(this_box_volume.p_physics->name,"Vacuum");
    } else if (0 == strcmp(material_string,"exit") || 0 == strcmp(material_string,"Exit")) {
        // One could have a global physics struct for vacuum instead of creating one for each
        this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
        this_box_volume.p_physics->is_vacuum = 1; // Makes this volume a vacuum
        this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
        this_box_volume.p_physics->my_a = 0; // Should not be used.
        this_box_volume.geometry.is_exit_volume = 1;
        sprintf(this_box_volume.p_physics->name,"Exit");
    } else {
        #ifndef MATERIAL_DETECTOR
            printf("Need to define a material before refering to it in a geometry %s.\n",NAME_CURRENT_COMP);
            exit(1);
        #endif
        for (loop_index=0;loop_index<global_material_list.num_elements;loop_index++) {
            if (0 == strcmp(material_string,global_material_list.elements[loop_index].name)) {
                this_box_volume.p_physics = global_material_list.elements[loop_index].physics;
                break;
            }
            if (loop_index == global_material_list.num_elements-1) {
            printf("\n");
            printf("ERROR: The material string \"%s\" in Union geometry \"%s\" did not match a specified material. \n",material_string,NAME_CURRENT_COMP);
            printf("       The materials available at this point (need to be defined before the geometry): \n");
            for (loop_index=0;loop_index<global_material_list.num_elements;loop_index++)
              printf("         %s\n",global_material_list.elements[loop_index].name);
            printf("\n");
            printf("       It is also possible to use one of the defualt materials avaiable: \n");
            printf("           Vacuum (for a Volume without scattering or absorption)\n");
            printf("           Exit (for a Volume where the ray exits the component if it enters)\n");
            printf("           Mask (for a Volume that masks existing volumes specified in the mask_string\n");
            exit(1);
          }
        }
    }
} else {
    // Automatic linking, simply using the last defined material.
    #ifndef MATERIAL_DETECTOR
        printf("Need to define a material before the geometry to use automatic linking %s.\n",NAME_CURRENT_COMP);
        exit(1);
    #endif
    this_box_volume.p_physics = global_material_list.elements[global_material_list.num_elements-1].physics;
}

sprintf(this_box_volume.name,NAME_CURRENT_COMP);
sprintf(this_box_volume.geometry.shape,"box");
this_box_volume.geometry.priority_value = priority;
this_box_volume.geometry.geometry_p_interact = p_interact;
// Currently the coordinates will be in absolute space.
this_box_volume.geometry.center = POS_A_CURRENT_COMP;

this_box_storage.z_depth = zdepth;
this_box_storage.x_width1 = xwidth;
this_box_storage.y_height1 = yheight;

this_box_storage.is_rectangle = 0;
if (xwidth2 < 0 && yheight2 < 0) this_box_storage.is_rectangle = 1;
if (xwidth == xwidth2 && yheight == yheight2) this_box_storage.is_rectangle = 1;

if (xwidth2 < 0) {
    this_box_storage.x_width2 = xwidth;
    xwidth2 = xwidth;
} else this_box_storage.x_width2 = xwidth2;

if (yheight2 < 0) {
    this_box_storage.y_height2 = yheight;
    yheight2 = yheight;
} else this_box_storage.y_height2 = yheight2;


this_box_storage.normal_vectors[0] = coords_set(0,0,1);
this_box_storage.normal_vectors[1] = coords_set(0,0,1);

// for sides with y component = 0
x_component = 2*zdepth/sqrt((xwidth-xwidth2)*(xwidth-xwidth2)+4*zdepth*zdepth);
z_component = (xwidth-xwidth2)/sqrt(4*zdepth*zdepth+(xwidth-xwidth2)*(xwidth-xwidth2));

this_box_storage.normal_vectors[2] = coords_set(x_component,0,z_component);
this_box_storage.normal_vectors[3] = coords_set(-x_component,0,z_component);

// for sides with x component = 0
y_component = 2*zdepth/sqrt((yheight-yheight2)*(yheight-yheight2)+4*zdepth*zdepth);
z_component = (yheight-yheight2)/sqrt(4*zdepth*zdepth+(yheight-yheight2)*(yheight-yheight2));

this_box_storage.normal_vectors[4] = coords_set(0,y_component,z_component);
this_box_storage.normal_vectors[5] = coords_set(0,-y_component,z_component);

this_box_volume.geometry.visualization_on = visualize;

this_box_volume.geometry.geometry_parameters.p_box_storage = &this_box_storage;

// Assign pointers to functions for intersection with the shape, checking if a point is inside the shape
if (this_box_storage.is_rectangle == 1) {
this_box_volume.geometry.intersect_function = &sample_box_intersect_simple;
this_box_volume.geometry.within_function = &r_within_box_simple;
}
else {
this_box_volume.geometry.intersect_function = &sample_box_intersect_advanced;
this_box_volume.geometry.within_function = &r_within_box_advanced;
}

this_box_volume.geometry.shell_points = &box_shell_points;
this_box_volume.geometry.mcdisplay_function = &mcdisplay_box_function;
this_box_volume.geometry.initialize_from_main_function = &initialize_box_geometry_from_main_component;
this_box_volume.geometry.process_rot_allocated = 0;

this_box_volume.geometry.copy_geometry_parameters = &allocate_box_storage_copy;

rot_copy(this_box_volume.geometry.rotation_matrix,ROT_A_CURRENT_COMP); //check how ROT_R_CURRENT_COMP would work
rot_transpose(ROT_A_CURRENT_COMP,this_box_volume.geometry.transpose_rotation_matrix);

// Initialize loggers
this_box_volume.loggers.num_elements = 0;

// packing the information into the global_geometry_element, which is then included in the global_geometry_list.
sprintf(global_geometry_element.name,NAME_CURRENT_COMP);
global_geometry_element.activation_counter = number_of_activations;
global_geometry_element.component_index = INDEX_CURRENT_COMP;
global_geometry_element.Volume = &this_box_volume; // Would be nicer if this m was a pointer, now we have the (small) data two places
add_element_to_geometry_list(&global_geometry_list,global_geometry_element);
}
#line 291017 "MACS_sample_kidney_box.c"
#undef number_of_activations
#undef mask_setting
#undef mask_string
#undef p_interact
#undef focus_r
#undef focus_xh
#undef focus_xw
#undef focus_ah
#undef focus_aw
#undef target_z
#undef target_y
#undef target_x
#undef target_index
#undef visualize
#undef yheight2
#undef xwidth2
#undef zdepth
#undef yheight
#undef xwidth
#undef priority
#undef material_string
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

  /* Initializations for component channel_14_analyzer_1_array_crystal_array_8. */
  SIG_MESSAGE("channel_14_analyzer_1_array_crystal_array_8 (Init)");
#define mccompcurname  channel_14_analyzer_1_array_crystal_array_8
#define mccompcurtype  Union_box
#define mccompcurindex 670
#define loop_index mccchannel_14_analyzer_1_array_crystal_array_8_loop_index
#define this_box_volume mccchannel_14_analyzer_1_array_crystal_array_8_this_box_volume
#define global_geometry_element mccchannel_14_analyzer_1_array_crystal_array_8_global_geometry_element
#define this_box_storage mccchannel_14_analyzer_1_array_crystal_array_8_this_box_storage
#define material_string mccchannel_14_analyzer_1_array_crystal_array_8_material_string
#define priority mccchannel_14_analyzer_1_array_crystal_array_8_priority
#define xwidth mccchannel_14_analyzer_1_array_crystal_array_8_xwidth
#define yheight mccchannel_14_analyzer_1_array_crystal_array_8_yheight
#define zdepth mccchannel_14_analyzer_1_array_crystal_array_8_zdepth
#define xwidth2 mccchannel_14_analyzer_1_array_crystal_array_8_xwidth2
#define yheight2 mccchannel_14_analyzer_1_array_crystal_array_8_yheight2
#define visualize mccchannel_14_analyzer_1_array_crystal_array_8_visualize
#define target_index mccchannel_14_analyzer_1_array_crystal_array_8_target_index
#define target_x mccchannel_14_analyzer_1_array_crystal_array_8_target_x
#define target_y mccchannel_14_analyzer_1_array_crystal_array_8_target_y
#define target_z mccchannel_14_analyzer_1_array_crystal_array_8_target_z
#define focus_aw mccchannel_14_analyzer_1_array_crystal_array_8_focus_aw
#define focus_ah mccchannel_14_analyzer_1_array_crystal_array_8_focus_ah
#define focus_xw mccchannel_14_analyzer_1_array_crystal_array_8_focus_xw
#define focus_xh mccchannel_14_analyzer_1_array_crystal_array_8_focus_xh
#define focus_r mccchannel_14_analyzer_1_array_crystal_array_8_focus_r
#define p_interact mccchannel_14_analyzer_1_array_crystal_array_8_p_interact
#define mask_string mccchannel_14_analyzer_1_array_crystal_array_8_mask_string
#define mask_setting mccchannel_14_analyzer_1_array_crystal_array_8_mask_setting
#define number_of_activations mccchannel_14_analyzer_1_array_crystal_array_8_number_of_activations
#line 224 "Union_box.comp"
{
// Initializes the focusing system for this volume including input sanitation.
focus_initialize(&this_box_volume.geometry, POS_A_COMP_INDEX(INDEX_CURRENT_COMP+target_index), POS_A_CURRENT_COMP, ROT_A_CURRENT_COMP, target_index, target_x, target_y, target_z, focus_aw, focus_ah, focus_xw, focus_xh, focus_r, NAME_CURRENT_COMP);

// Input sanitation for this geometry
if (xwidth <= 0) {
  printf("\nERROR in Union_box named %s, the xwidth is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (yheight <= 0) {
  printf("\nERROR in Union_box named %s, yheight is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (zdepth <= 0) {
  printf("\nERROR in Union_box named %s, zdepth is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (xwidth2 <= 0 && xwidth2 != -1) {
  printf("\nERROR in Union_box named %s, the xwidth2 is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (yheight2 <= 0 && yheight2 != -1) {
  printf("\nERROR in Union_box named %s, yheight2 is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}

// Use sanitation
if (global_material_list.num_elements == 0) {
  printf("\nERROR: Need to define a material using Union_make_material before using a Union geometry component. \n");
  printf("       %s was defined before first use of Union_make_material.\n",NAME_CURRENT_COMP);
  exit(1);
}

this_box_volume.geometry.is_masked_volume = 0;
this_box_volume.geometry.is_exit_volume = 0;
this_box_volume.geometry.is_mask_volume = 0;
// check if the volume is a mask, if it is the material string is irelevant.
if (mask_string && strlen(mask_string) && strcmp(mask_string, "NULL") && strcmp(mask_string, "0")) {
    // A mask volume is used to limit the extend of other volumes, called the masked volumes. These are specified in the mask_string.
    // In order for a ray to enter a masked volume, it needs to be both in the region covered by that volume AND the mask volume.
    // When more than
    this_box_volume.geometry.mask_mode = 1; // Default is mask mode is ALL
    if (mask_setting && strlen(mask_setting) && strcmp(mask_setting, "NULL") && strcmp(mask_setting, "0")) {
        if (strcmp(mask_setting,"ALL") == 0 || strcmp(mask_setting,"All") == 0) this_box_volume.geometry.mask_mode = 1;
        else if (strcmp(mask_setting,"ANY") == 0 || strcmp(mask_setting,"Any") == 0) this_box_volume.geometry.mask_mode = 2;
        else {
            printf("The mask_mode of component %s is set to %s, but must be either ALL or ANY.\n",NAME_CURRENT_COMP,mask_setting);
            exit(1);
        }
    }
    
    for (loop_index=0;loop_index<global_geometry_list.num_elements;loop_index++) {
        // Add mask list
        if (1 == manual_linking_function(global_geometry_list.elements[loop_index].name,mask_string)) {
            add_element_to_int_list(&this_box_volume.geometry.mask_list,global_geometry_list.elements[loop_index].component_index);
            add_element_to_int_list(&global_geometry_list.elements[loop_index].Volume->geometry.masked_by_list,INDEX_CURRENT_COMP);
            global_geometry_list.elements[loop_index].Volume->geometry.is_masked_volume = 1;
            if (this_box_volume.geometry.mask_mode == 2)
                global_geometry_list.elements[loop_index].Volume->geometry.mask_mode = 2;
            if (this_box_volume.geometry.mask_mode == 1) {
                if (global_geometry_list.elements[loop_index].Volume->geometry.is_masked_volume == 1 && global_geometry_list.elements[loop_index].Volume->geometry.mask_mode != 2)
                    // If more than one mask is added to one volume, the ANY mode overwrites the (default) ALL mode.
                    global_geometry_list.elements[loop_index].Volume->geometry.mask_mode = 1;
            }
            
            found_geometries = 1;
        }
    }
    if (found_geometries == 0) {
        printf("The mask_string in geometry: %s did not find any of the specified volumes in the mask_string %s \n",NAME_CURRENT_COMP,mask_string);
        exit(1);
    }
    this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
    this_box_volume.p_physics->is_vacuum = 0; // Makes this volume a vacuum
    this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
    this_box_volume.p_physics->my_a = 0; // Should not be used.
    sprintf(this_box_volume.p_physics->name,"Mask");
    this_box_volume.geometry.is_mask_volume = 1;
    
    
// Read the material input, or if it lacks, use automatic linking.
} else if (material_string && strlen(material_string) && strcmp(material_string, "NULL") && strcmp(material_string, "0")) {
    // A geometry string was given, use it to determine which material
    if (0 == strcmp(material_string,"vacuum") || 0 == strcmp(material_string,"Vacuum")) {
        // One could have a global physics struct for vacuum instead of creating one for each
        this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
        this_box_volume.p_physics->is_vacuum = 1; // Makes this volume a vacuum
        this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
        this_box_volume.p_physics->my_a = 0; // Should not be used.
        sprintf(this_box_volume.p_physics->name,"Vacuum");
    } else if (0 == strcmp(material_string,"exit") || 0 == strcmp(material_string,"Exit")) {
        // One could have a global physics struct for vacuum instead of creating one for each
        this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
        this_box_volume.p_physics->is_vacuum = 1; // Makes this volume a vacuum
        this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
        this_box_volume.p_physics->my_a = 0; // Should not be used.
        this_box_volume.geometry.is_exit_volume = 1;
        sprintf(this_box_volume.p_physics->name,"Exit");
    } else {
        #ifndef MATERIAL_DETECTOR
            printf("Need to define a material before refering to it in a geometry %s.\n",NAME_CURRENT_COMP);
            exit(1);
        #endif
        for (loop_index=0;loop_index<global_material_list.num_elements;loop_index++) {
            if (0 == strcmp(material_string,global_material_list.elements[loop_index].name)) {
                this_box_volume.p_physics = global_material_list.elements[loop_index].physics;
                break;
            }
            if (loop_index == global_material_list.num_elements-1) {
            printf("\n");
            printf("ERROR: The material string \"%s\" in Union geometry \"%s\" did not match a specified material. \n",material_string,NAME_CURRENT_COMP);
            printf("       The materials available at this point (need to be defined before the geometry): \n");
            for (loop_index=0;loop_index<global_material_list.num_elements;loop_index++)
              printf("         %s\n",global_material_list.elements[loop_index].name);
            printf("\n");
            printf("       It is also possible to use one of the defualt materials avaiable: \n");
            printf("           Vacuum (for a Volume without scattering or absorption)\n");
            printf("           Exit (for a Volume where the ray exits the component if it enters)\n");
            printf("           Mask (for a Volume that masks existing volumes specified in the mask_string\n");
            exit(1);
          }
        }
    }
} else {
    // Automatic linking, simply using the last defined material.
    #ifndef MATERIAL_DETECTOR
        printf("Need to define a material before the geometry to use automatic linking %s.\n",NAME_CURRENT_COMP);
        exit(1);
    #endif
    this_box_volume.p_physics = global_material_list.elements[global_material_list.num_elements-1].physics;
}

sprintf(this_box_volume.name,NAME_CURRENT_COMP);
sprintf(this_box_volume.geometry.shape,"box");
this_box_volume.geometry.priority_value = priority;
this_box_volume.geometry.geometry_p_interact = p_interact;
// Currently the coordinates will be in absolute space.
this_box_volume.geometry.center = POS_A_CURRENT_COMP;

this_box_storage.z_depth = zdepth;
this_box_storage.x_width1 = xwidth;
this_box_storage.y_height1 = yheight;

this_box_storage.is_rectangle = 0;
if (xwidth2 < 0 && yheight2 < 0) this_box_storage.is_rectangle = 1;
if (xwidth == xwidth2 && yheight == yheight2) this_box_storage.is_rectangle = 1;

if (xwidth2 < 0) {
    this_box_storage.x_width2 = xwidth;
    xwidth2 = xwidth;
} else this_box_storage.x_width2 = xwidth2;

if (yheight2 < 0) {
    this_box_storage.y_height2 = yheight;
    yheight2 = yheight;
} else this_box_storage.y_height2 = yheight2;


this_box_storage.normal_vectors[0] = coords_set(0,0,1);
this_box_storage.normal_vectors[1] = coords_set(0,0,1);

// for sides with y component = 0
x_component = 2*zdepth/sqrt((xwidth-xwidth2)*(xwidth-xwidth2)+4*zdepth*zdepth);
z_component = (xwidth-xwidth2)/sqrt(4*zdepth*zdepth+(xwidth-xwidth2)*(xwidth-xwidth2));

this_box_storage.normal_vectors[2] = coords_set(x_component,0,z_component);
this_box_storage.normal_vectors[3] = coords_set(-x_component,0,z_component);

// for sides with x component = 0
y_component = 2*zdepth/sqrt((yheight-yheight2)*(yheight-yheight2)+4*zdepth*zdepth);
z_component = (yheight-yheight2)/sqrt(4*zdepth*zdepth+(yheight-yheight2)*(yheight-yheight2));

this_box_storage.normal_vectors[4] = coords_set(0,y_component,z_component);
this_box_storage.normal_vectors[5] = coords_set(0,-y_component,z_component);

this_box_volume.geometry.visualization_on = visualize;

this_box_volume.geometry.geometry_parameters.p_box_storage = &this_box_storage;

// Assign pointers to functions for intersection with the shape, checking if a point is inside the shape
if (this_box_storage.is_rectangle == 1) {
this_box_volume.geometry.intersect_function = &sample_box_intersect_simple;
this_box_volume.geometry.within_function = &r_within_box_simple;
}
else {
this_box_volume.geometry.intersect_function = &sample_box_intersect_advanced;
this_box_volume.geometry.within_function = &r_within_box_advanced;
}

this_box_volume.geometry.shell_points = &box_shell_points;
this_box_volume.geometry.mcdisplay_function = &mcdisplay_box_function;
this_box_volume.geometry.initialize_from_main_function = &initialize_box_geometry_from_main_component;
this_box_volume.geometry.process_rot_allocated = 0;

this_box_volume.geometry.copy_geometry_parameters = &allocate_box_storage_copy;

rot_copy(this_box_volume.geometry.rotation_matrix,ROT_A_CURRENT_COMP); //check how ROT_R_CURRENT_COMP would work
rot_transpose(ROT_A_CURRENT_COMP,this_box_volume.geometry.transpose_rotation_matrix);

// Initialize loggers
this_box_volume.loggers.num_elements = 0;

// packing the information into the global_geometry_element, which is then included in the global_geometry_list.
sprintf(global_geometry_element.name,NAME_CURRENT_COMP);
global_geometry_element.activation_counter = number_of_activations;
global_geometry_element.component_index = INDEX_CURRENT_COMP;
global_geometry_element.Volume = &this_box_volume; // Would be nicer if this m was a pointer, now we have the (small) data two places
add_element_to_geometry_list(&global_geometry_list,global_geometry_element);
}
#line 291287 "MACS_sample_kidney_box.c"
#undef number_of_activations
#undef mask_setting
#undef mask_string
#undef p_interact
#undef focus_r
#undef focus_xh
#undef focus_xw
#undef focus_ah
#undef focus_aw
#undef target_z
#undef target_y
#undef target_x
#undef target_index
#undef visualize
#undef yheight2
#undef xwidth2
#undef zdepth
#undef yheight
#undef xwidth
#undef priority
#undef material_string
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

  /* Initializations for component channel_14_analyzer_2_center. */
  SIG_MESSAGE("channel_14_analyzer_2_center (Init)");

  /* Initializations for component channel_14_analyzer_2_rotated. */
  SIG_MESSAGE("channel_14_analyzer_2_rotated (Init)");

  /* Initializations for component channel_14_analyzer_2_array_crystal_array_0. */
  SIG_MESSAGE("channel_14_analyzer_2_array_crystal_array_0 (Init)");
#define mccompcurname  channel_14_analyzer_2_array_crystal_array_0
#define mccompcurtype  Union_box
#define mccompcurindex 673
#define loop_index mccchannel_14_analyzer_2_array_crystal_array_0_loop_index
#define this_box_volume mccchannel_14_analyzer_2_array_crystal_array_0_this_box_volume
#define global_geometry_element mccchannel_14_analyzer_2_array_crystal_array_0_global_geometry_element
#define this_box_storage mccchannel_14_analyzer_2_array_crystal_array_0_this_box_storage
#define material_string mccchannel_14_analyzer_2_array_crystal_array_0_material_string
#define priority mccchannel_14_analyzer_2_array_crystal_array_0_priority
#define xwidth mccchannel_14_analyzer_2_array_crystal_array_0_xwidth
#define yheight mccchannel_14_analyzer_2_array_crystal_array_0_yheight
#define zdepth mccchannel_14_analyzer_2_array_crystal_array_0_zdepth
#define xwidth2 mccchannel_14_analyzer_2_array_crystal_array_0_xwidth2
#define yheight2 mccchannel_14_analyzer_2_array_crystal_array_0_yheight2
#define visualize mccchannel_14_analyzer_2_array_crystal_array_0_visualize
#define target_index mccchannel_14_analyzer_2_array_crystal_array_0_target_index
#define target_x mccchannel_14_analyzer_2_array_crystal_array_0_target_x
#define target_y mccchannel_14_analyzer_2_array_crystal_array_0_target_y
#define target_z mccchannel_14_analyzer_2_array_crystal_array_0_target_z
#define focus_aw mccchannel_14_analyzer_2_array_crystal_array_0_focus_aw
#define focus_ah mccchannel_14_analyzer_2_array_crystal_array_0_focus_ah
#define focus_xw mccchannel_14_analyzer_2_array_crystal_array_0_focus_xw
#define focus_xh mccchannel_14_analyzer_2_array_crystal_array_0_focus_xh
#define focus_r mccchannel_14_analyzer_2_array_crystal_array_0_focus_r
#define p_interact mccchannel_14_analyzer_2_array_crystal_array_0_p_interact
#define mask_string mccchannel_14_analyzer_2_array_crystal_array_0_mask_string
#define mask_setting mccchannel_14_analyzer_2_array_crystal_array_0_mask_setting
#define number_of_activations mccchannel_14_analyzer_2_array_crystal_array_0_number_of_activations
#line 224 "Union_box.comp"
{
// Initializes the focusing system for this volume including input sanitation.
focus_initialize(&this_box_volume.geometry, POS_A_COMP_INDEX(INDEX_CURRENT_COMP+target_index), POS_A_CURRENT_COMP, ROT_A_CURRENT_COMP, target_index, target_x, target_y, target_z, focus_aw, focus_ah, focus_xw, focus_xh, focus_r, NAME_CURRENT_COMP);

// Input sanitation for this geometry
if (xwidth <= 0) {
  printf("\nERROR in Union_box named %s, the xwidth is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (yheight <= 0) {
  printf("\nERROR in Union_box named %s, yheight is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (zdepth <= 0) {
  printf("\nERROR in Union_box named %s, zdepth is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (xwidth2 <= 0 && xwidth2 != -1) {
  printf("\nERROR in Union_box named %s, the xwidth2 is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (yheight2 <= 0 && yheight2 != -1) {
  printf("\nERROR in Union_box named %s, yheight2 is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}

// Use sanitation
if (global_material_list.num_elements == 0) {
  printf("\nERROR: Need to define a material using Union_make_material before using a Union geometry component. \n");
  printf("       %s was defined before first use of Union_make_material.\n",NAME_CURRENT_COMP);
  exit(1);
}

this_box_volume.geometry.is_masked_volume = 0;
this_box_volume.geometry.is_exit_volume = 0;
this_box_volume.geometry.is_mask_volume = 0;
// check if the volume is a mask, if it is the material string is irelevant.
if (mask_string && strlen(mask_string) && strcmp(mask_string, "NULL") && strcmp(mask_string, "0")) {
    // A mask volume is used to limit the extend of other volumes, called the masked volumes. These are specified in the mask_string.
    // In order for a ray to enter a masked volume, it needs to be both in the region covered by that volume AND the mask volume.
    // When more than
    this_box_volume.geometry.mask_mode = 1; // Default is mask mode is ALL
    if (mask_setting && strlen(mask_setting) && strcmp(mask_setting, "NULL") && strcmp(mask_setting, "0")) {
        if (strcmp(mask_setting,"ALL") == 0 || strcmp(mask_setting,"All") == 0) this_box_volume.geometry.mask_mode = 1;
        else if (strcmp(mask_setting,"ANY") == 0 || strcmp(mask_setting,"Any") == 0) this_box_volume.geometry.mask_mode = 2;
        else {
            printf("The mask_mode of component %s is set to %s, but must be either ALL or ANY.\n",NAME_CURRENT_COMP,mask_setting);
            exit(1);
        }
    }
    
    for (loop_index=0;loop_index<global_geometry_list.num_elements;loop_index++) {
        // Add mask list
        if (1 == manual_linking_function(global_geometry_list.elements[loop_index].name,mask_string)) {
            add_element_to_int_list(&this_box_volume.geometry.mask_list,global_geometry_list.elements[loop_index].component_index);
            add_element_to_int_list(&global_geometry_list.elements[loop_index].Volume->geometry.masked_by_list,INDEX_CURRENT_COMP);
            global_geometry_list.elements[loop_index].Volume->geometry.is_masked_volume = 1;
            if (this_box_volume.geometry.mask_mode == 2)
                global_geometry_list.elements[loop_index].Volume->geometry.mask_mode = 2;
            if (this_box_volume.geometry.mask_mode == 1) {
                if (global_geometry_list.elements[loop_index].Volume->geometry.is_masked_volume == 1 && global_geometry_list.elements[loop_index].Volume->geometry.mask_mode != 2)
                    // If more than one mask is added to one volume, the ANY mode overwrites the (default) ALL mode.
                    global_geometry_list.elements[loop_index].Volume->geometry.mask_mode = 1;
            }
            
            found_geometries = 1;
        }
    }
    if (found_geometries == 0) {
        printf("The mask_string in geometry: %s did not find any of the specified volumes in the mask_string %s \n",NAME_CURRENT_COMP,mask_string);
        exit(1);
    }
    this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
    this_box_volume.p_physics->is_vacuum = 0; // Makes this volume a vacuum
    this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
    this_box_volume.p_physics->my_a = 0; // Should not be used.
    sprintf(this_box_volume.p_physics->name,"Mask");
    this_box_volume.geometry.is_mask_volume = 1;
    
    
// Read the material input, or if it lacks, use automatic linking.
} else if (material_string && strlen(material_string) && strcmp(material_string, "NULL") && strcmp(material_string, "0")) {
    // A geometry string was given, use it to determine which material
    if (0 == strcmp(material_string,"vacuum") || 0 == strcmp(material_string,"Vacuum")) {
        // One could have a global physics struct for vacuum instead of creating one for each
        this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
        this_box_volume.p_physics->is_vacuum = 1; // Makes this volume a vacuum
        this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
        this_box_volume.p_physics->my_a = 0; // Should not be used.
        sprintf(this_box_volume.p_physics->name,"Vacuum");
    } else if (0 == strcmp(material_string,"exit") || 0 == strcmp(material_string,"Exit")) {
        // One could have a global physics struct for vacuum instead of creating one for each
        this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
        this_box_volume.p_physics->is_vacuum = 1; // Makes this volume a vacuum
        this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
        this_box_volume.p_physics->my_a = 0; // Should not be used.
        this_box_volume.geometry.is_exit_volume = 1;
        sprintf(this_box_volume.p_physics->name,"Exit");
    } else {
        #ifndef MATERIAL_DETECTOR
            printf("Need to define a material before refering to it in a geometry %s.\n",NAME_CURRENT_COMP);
            exit(1);
        #endif
        for (loop_index=0;loop_index<global_material_list.num_elements;loop_index++) {
            if (0 == strcmp(material_string,global_material_list.elements[loop_index].name)) {
                this_box_volume.p_physics = global_material_list.elements[loop_index].physics;
                break;
            }
            if (loop_index == global_material_list.num_elements-1) {
            printf("\n");
            printf("ERROR: The material string \"%s\" in Union geometry \"%s\" did not match a specified material. \n",material_string,NAME_CURRENT_COMP);
            printf("       The materials available at this point (need to be defined before the geometry): \n");
            for (loop_index=0;loop_index<global_material_list.num_elements;loop_index++)
              printf("         %s\n",global_material_list.elements[loop_index].name);
            printf("\n");
            printf("       It is also possible to use one of the defualt materials avaiable: \n");
            printf("           Vacuum (for a Volume without scattering or absorption)\n");
            printf("           Exit (for a Volume where the ray exits the component if it enters)\n");
            printf("           Mask (for a Volume that masks existing volumes specified in the mask_string\n");
            exit(1);
          }
        }
    }
} else {
    // Automatic linking, simply using the last defined material.
    #ifndef MATERIAL_DETECTOR
        printf("Need to define a material before the geometry to use automatic linking %s.\n",NAME_CURRENT_COMP);
        exit(1);
    #endif
    this_box_volume.p_physics = global_material_list.elements[global_material_list.num_elements-1].physics;
}

sprintf(this_box_volume.name,NAME_CURRENT_COMP);
sprintf(this_box_volume.geometry.shape,"box");
this_box_volume.geometry.priority_value = priority;
this_box_volume.geometry.geometry_p_interact = p_interact;
// Currently the coordinates will be in absolute space.
this_box_volume.geometry.center = POS_A_CURRENT_COMP;

this_box_storage.z_depth = zdepth;
this_box_storage.x_width1 = xwidth;
this_box_storage.y_height1 = yheight;

this_box_storage.is_rectangle = 0;
if (xwidth2 < 0 && yheight2 < 0) this_box_storage.is_rectangle = 1;
if (xwidth == xwidth2 && yheight == yheight2) this_box_storage.is_rectangle = 1;

if (xwidth2 < 0) {
    this_box_storage.x_width2 = xwidth;
    xwidth2 = xwidth;
} else this_box_storage.x_width2 = xwidth2;

if (yheight2 < 0) {
    this_box_storage.y_height2 = yheight;
    yheight2 = yheight;
} else this_box_storage.y_height2 = yheight2;


this_box_storage.normal_vectors[0] = coords_set(0,0,1);
this_box_storage.normal_vectors[1] = coords_set(0,0,1);

// for sides with y component = 0
x_component = 2*zdepth/sqrt((xwidth-xwidth2)*(xwidth-xwidth2)+4*zdepth*zdepth);
z_component = (xwidth-xwidth2)/sqrt(4*zdepth*zdepth+(xwidth-xwidth2)*(xwidth-xwidth2));

this_box_storage.normal_vectors[2] = coords_set(x_component,0,z_component);
this_box_storage.normal_vectors[3] = coords_set(-x_component,0,z_component);

// for sides with x component = 0
y_component = 2*zdepth/sqrt((yheight-yheight2)*(yheight-yheight2)+4*zdepth*zdepth);
z_component = (yheight-yheight2)/sqrt(4*zdepth*zdepth+(yheight-yheight2)*(yheight-yheight2));

this_box_storage.normal_vectors[4] = coords_set(0,y_component,z_component);
this_box_storage.normal_vectors[5] = coords_set(0,-y_component,z_component);

this_box_volume.geometry.visualization_on = visualize;

this_box_volume.geometry.geometry_parameters.p_box_storage = &this_box_storage;

// Assign pointers to functions for intersection with the shape, checking if a point is inside the shape
if (this_box_storage.is_rectangle == 1) {
this_box_volume.geometry.intersect_function = &sample_box_intersect_simple;
this_box_volume.geometry.within_function = &r_within_box_simple;
}
else {
this_box_volume.geometry.intersect_function = &sample_box_intersect_advanced;
this_box_volume.geometry.within_function = &r_within_box_advanced;
}

this_box_volume.geometry.shell_points = &box_shell_points;
this_box_volume.geometry.mcdisplay_function = &mcdisplay_box_function;
this_box_volume.geometry.initialize_from_main_function = &initialize_box_geometry_from_main_component;
this_box_volume.geometry.process_rot_allocated = 0;

this_box_volume.geometry.copy_geometry_parameters = &allocate_box_storage_copy;

rot_copy(this_box_volume.geometry.rotation_matrix,ROT_A_CURRENT_COMP); //check how ROT_R_CURRENT_COMP would work
rot_transpose(ROT_A_CURRENT_COMP,this_box_volume.geometry.transpose_rotation_matrix);

// Initialize loggers
this_box_volume.loggers.num_elements = 0;

// packing the information into the global_geometry_element, which is then included in the global_geometry_list.
sprintf(global_geometry_element.name,NAME_CURRENT_COMP);
global_geometry_element.activation_counter = number_of_activations;
global_geometry_element.component_index = INDEX_CURRENT_COMP;
global_geometry_element.Volume = &this_box_volume; // Would be nicer if this m was a pointer, now we have the (small) data two places
add_element_to_geometry_list(&global_geometry_list,global_geometry_element);
}
#line 291563 "MACS_sample_kidney_box.c"
#undef number_of_activations
#undef mask_setting
#undef mask_string
#undef p_interact
#undef focus_r
#undef focus_xh
#undef focus_xw
#undef focus_ah
#undef focus_aw
#undef target_z
#undef target_y
#undef target_x
#undef target_index
#undef visualize
#undef yheight2
#undef xwidth2
#undef zdepth
#undef yheight
#undef xwidth
#undef priority
#undef material_string
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

  /* Initializations for component channel_14_analyzer_2_array_crystal_array_1. */
  SIG_MESSAGE("channel_14_analyzer_2_array_crystal_array_1 (Init)");
#define mccompcurname  channel_14_analyzer_2_array_crystal_array_1
#define mccompcurtype  Union_box
#define mccompcurindex 674
#define loop_index mccchannel_14_analyzer_2_array_crystal_array_1_loop_index
#define this_box_volume mccchannel_14_analyzer_2_array_crystal_array_1_this_box_volume
#define global_geometry_element mccchannel_14_analyzer_2_array_crystal_array_1_global_geometry_element
#define this_box_storage mccchannel_14_analyzer_2_array_crystal_array_1_this_box_storage
#define material_string mccchannel_14_analyzer_2_array_crystal_array_1_material_string
#define priority mccchannel_14_analyzer_2_array_crystal_array_1_priority
#define xwidth mccchannel_14_analyzer_2_array_crystal_array_1_xwidth
#define yheight mccchannel_14_analyzer_2_array_crystal_array_1_yheight
#define zdepth mccchannel_14_analyzer_2_array_crystal_array_1_zdepth
#define xwidth2 mccchannel_14_analyzer_2_array_crystal_array_1_xwidth2
#define yheight2 mccchannel_14_analyzer_2_array_crystal_array_1_yheight2
#define visualize mccchannel_14_analyzer_2_array_crystal_array_1_visualize
#define target_index mccchannel_14_analyzer_2_array_crystal_array_1_target_index
#define target_x mccchannel_14_analyzer_2_array_crystal_array_1_target_x
#define target_y mccchannel_14_analyzer_2_array_crystal_array_1_target_y
#define target_z mccchannel_14_analyzer_2_array_crystal_array_1_target_z
#define focus_aw mccchannel_14_analyzer_2_array_crystal_array_1_focus_aw
#define focus_ah mccchannel_14_analyzer_2_array_crystal_array_1_focus_ah
#define focus_xw mccchannel_14_analyzer_2_array_crystal_array_1_focus_xw
#define focus_xh mccchannel_14_analyzer_2_array_crystal_array_1_focus_xh
#define focus_r mccchannel_14_analyzer_2_array_crystal_array_1_focus_r
#define p_interact mccchannel_14_analyzer_2_array_crystal_array_1_p_interact
#define mask_string mccchannel_14_analyzer_2_array_crystal_array_1_mask_string
#define mask_setting mccchannel_14_analyzer_2_array_crystal_array_1_mask_setting
#define number_of_activations mccchannel_14_analyzer_2_array_crystal_array_1_number_of_activations
#line 224 "Union_box.comp"
{
// Initializes the focusing system for this volume including input sanitation.
focus_initialize(&this_box_volume.geometry, POS_A_COMP_INDEX(INDEX_CURRENT_COMP+target_index), POS_A_CURRENT_COMP, ROT_A_CURRENT_COMP, target_index, target_x, target_y, target_z, focus_aw, focus_ah, focus_xw, focus_xh, focus_r, NAME_CURRENT_COMP);

// Input sanitation for this geometry
if (xwidth <= 0) {
  printf("\nERROR in Union_box named %s, the xwidth is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (yheight <= 0) {
  printf("\nERROR in Union_box named %s, yheight is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (zdepth <= 0) {
  printf("\nERROR in Union_box named %s, zdepth is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (xwidth2 <= 0 && xwidth2 != -1) {
  printf("\nERROR in Union_box named %s, the xwidth2 is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (yheight2 <= 0 && yheight2 != -1) {
  printf("\nERROR in Union_box named %s, yheight2 is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}

// Use sanitation
if (global_material_list.num_elements == 0) {
  printf("\nERROR: Need to define a material using Union_make_material before using a Union geometry component. \n");
  printf("       %s was defined before first use of Union_make_material.\n",NAME_CURRENT_COMP);
  exit(1);
}

this_box_volume.geometry.is_masked_volume = 0;
this_box_volume.geometry.is_exit_volume = 0;
this_box_volume.geometry.is_mask_volume = 0;
// check if the volume is a mask, if it is the material string is irelevant.
if (mask_string && strlen(mask_string) && strcmp(mask_string, "NULL") && strcmp(mask_string, "0")) {
    // A mask volume is used to limit the extend of other volumes, called the masked volumes. These are specified in the mask_string.
    // In order for a ray to enter a masked volume, it needs to be both in the region covered by that volume AND the mask volume.
    // When more than
    this_box_volume.geometry.mask_mode = 1; // Default is mask mode is ALL
    if (mask_setting && strlen(mask_setting) && strcmp(mask_setting, "NULL") && strcmp(mask_setting, "0")) {
        if (strcmp(mask_setting,"ALL") == 0 || strcmp(mask_setting,"All") == 0) this_box_volume.geometry.mask_mode = 1;
        else if (strcmp(mask_setting,"ANY") == 0 || strcmp(mask_setting,"Any") == 0) this_box_volume.geometry.mask_mode = 2;
        else {
            printf("The mask_mode of component %s is set to %s, but must be either ALL or ANY.\n",NAME_CURRENT_COMP,mask_setting);
            exit(1);
        }
    }
    
    for (loop_index=0;loop_index<global_geometry_list.num_elements;loop_index++) {
        // Add mask list
        if (1 == manual_linking_function(global_geometry_list.elements[loop_index].name,mask_string)) {
            add_element_to_int_list(&this_box_volume.geometry.mask_list,global_geometry_list.elements[loop_index].component_index);
            add_element_to_int_list(&global_geometry_list.elements[loop_index].Volume->geometry.masked_by_list,INDEX_CURRENT_COMP);
            global_geometry_list.elements[loop_index].Volume->geometry.is_masked_volume = 1;
            if (this_box_volume.geometry.mask_mode == 2)
                global_geometry_list.elements[loop_index].Volume->geometry.mask_mode = 2;
            if (this_box_volume.geometry.mask_mode == 1) {
                if (global_geometry_list.elements[loop_index].Volume->geometry.is_masked_volume == 1 && global_geometry_list.elements[loop_index].Volume->geometry.mask_mode != 2)
                    // If more than one mask is added to one volume, the ANY mode overwrites the (default) ALL mode.
                    global_geometry_list.elements[loop_index].Volume->geometry.mask_mode = 1;
            }
            
            found_geometries = 1;
        }
    }
    if (found_geometries == 0) {
        printf("The mask_string in geometry: %s did not find any of the specified volumes in the mask_string %s \n",NAME_CURRENT_COMP,mask_string);
        exit(1);
    }
    this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
    this_box_volume.p_physics->is_vacuum = 0; // Makes this volume a vacuum
    this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
    this_box_volume.p_physics->my_a = 0; // Should not be used.
    sprintf(this_box_volume.p_physics->name,"Mask");
    this_box_volume.geometry.is_mask_volume = 1;
    
    
// Read the material input, or if it lacks, use automatic linking.
} else if (material_string && strlen(material_string) && strcmp(material_string, "NULL") && strcmp(material_string, "0")) {
    // A geometry string was given, use it to determine which material
    if (0 == strcmp(material_string,"vacuum") || 0 == strcmp(material_string,"Vacuum")) {
        // One could have a global physics struct for vacuum instead of creating one for each
        this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
        this_box_volume.p_physics->is_vacuum = 1; // Makes this volume a vacuum
        this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
        this_box_volume.p_physics->my_a = 0; // Should not be used.
        sprintf(this_box_volume.p_physics->name,"Vacuum");
    } else if (0 == strcmp(material_string,"exit") || 0 == strcmp(material_string,"Exit")) {
        // One could have a global physics struct for vacuum instead of creating one for each
        this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
        this_box_volume.p_physics->is_vacuum = 1; // Makes this volume a vacuum
        this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
        this_box_volume.p_physics->my_a = 0; // Should not be used.
        this_box_volume.geometry.is_exit_volume = 1;
        sprintf(this_box_volume.p_physics->name,"Exit");
    } else {
        #ifndef MATERIAL_DETECTOR
            printf("Need to define a material before refering to it in a geometry %s.\n",NAME_CURRENT_COMP);
            exit(1);
        #endif
        for (loop_index=0;loop_index<global_material_list.num_elements;loop_index++) {
            if (0 == strcmp(material_string,global_material_list.elements[loop_index].name)) {
                this_box_volume.p_physics = global_material_list.elements[loop_index].physics;
                break;
            }
            if (loop_index == global_material_list.num_elements-1) {
            printf("\n");
            printf("ERROR: The material string \"%s\" in Union geometry \"%s\" did not match a specified material. \n",material_string,NAME_CURRENT_COMP);
            printf("       The materials available at this point (need to be defined before the geometry): \n");
            for (loop_index=0;loop_index<global_material_list.num_elements;loop_index++)
              printf("         %s\n",global_material_list.elements[loop_index].name);
            printf("\n");
            printf("       It is also possible to use one of the defualt materials avaiable: \n");
            printf("           Vacuum (for a Volume without scattering or absorption)\n");
            printf("           Exit (for a Volume where the ray exits the component if it enters)\n");
            printf("           Mask (for a Volume that masks existing volumes specified in the mask_string\n");
            exit(1);
          }
        }
    }
} else {
    // Automatic linking, simply using the last defined material.
    #ifndef MATERIAL_DETECTOR
        printf("Need to define a material before the geometry to use automatic linking %s.\n",NAME_CURRENT_COMP);
        exit(1);
    #endif
    this_box_volume.p_physics = global_material_list.elements[global_material_list.num_elements-1].physics;
}

sprintf(this_box_volume.name,NAME_CURRENT_COMP);
sprintf(this_box_volume.geometry.shape,"box");
this_box_volume.geometry.priority_value = priority;
this_box_volume.geometry.geometry_p_interact = p_interact;
// Currently the coordinates will be in absolute space.
this_box_volume.geometry.center = POS_A_CURRENT_COMP;

this_box_storage.z_depth = zdepth;
this_box_storage.x_width1 = xwidth;
this_box_storage.y_height1 = yheight;

this_box_storage.is_rectangle = 0;
if (xwidth2 < 0 && yheight2 < 0) this_box_storage.is_rectangle = 1;
if (xwidth == xwidth2 && yheight == yheight2) this_box_storage.is_rectangle = 1;

if (xwidth2 < 0) {
    this_box_storage.x_width2 = xwidth;
    xwidth2 = xwidth;
} else this_box_storage.x_width2 = xwidth2;

if (yheight2 < 0) {
    this_box_storage.y_height2 = yheight;
    yheight2 = yheight;
} else this_box_storage.y_height2 = yheight2;


this_box_storage.normal_vectors[0] = coords_set(0,0,1);
this_box_storage.normal_vectors[1] = coords_set(0,0,1);

// for sides with y component = 0
x_component = 2*zdepth/sqrt((xwidth-xwidth2)*(xwidth-xwidth2)+4*zdepth*zdepth);
z_component = (xwidth-xwidth2)/sqrt(4*zdepth*zdepth+(xwidth-xwidth2)*(xwidth-xwidth2));

this_box_storage.normal_vectors[2] = coords_set(x_component,0,z_component);
this_box_storage.normal_vectors[3] = coords_set(-x_component,0,z_component);

// for sides with x component = 0
y_component = 2*zdepth/sqrt((yheight-yheight2)*(yheight-yheight2)+4*zdepth*zdepth);
z_component = (yheight-yheight2)/sqrt(4*zdepth*zdepth+(yheight-yheight2)*(yheight-yheight2));

this_box_storage.normal_vectors[4] = coords_set(0,y_component,z_component);
this_box_storage.normal_vectors[5] = coords_set(0,-y_component,z_component);

this_box_volume.geometry.visualization_on = visualize;

this_box_volume.geometry.geometry_parameters.p_box_storage = &this_box_storage;

// Assign pointers to functions for intersection with the shape, checking if a point is inside the shape
if (this_box_storage.is_rectangle == 1) {
this_box_volume.geometry.intersect_function = &sample_box_intersect_simple;
this_box_volume.geometry.within_function = &r_within_box_simple;
}
else {
this_box_volume.geometry.intersect_function = &sample_box_intersect_advanced;
this_box_volume.geometry.within_function = &r_within_box_advanced;
}

this_box_volume.geometry.shell_points = &box_shell_points;
this_box_volume.geometry.mcdisplay_function = &mcdisplay_box_function;
this_box_volume.geometry.initialize_from_main_function = &initialize_box_geometry_from_main_component;
this_box_volume.geometry.process_rot_allocated = 0;

this_box_volume.geometry.copy_geometry_parameters = &allocate_box_storage_copy;

rot_copy(this_box_volume.geometry.rotation_matrix,ROT_A_CURRENT_COMP); //check how ROT_R_CURRENT_COMP would work
rot_transpose(ROT_A_CURRENT_COMP,this_box_volume.geometry.transpose_rotation_matrix);

// Initialize loggers
this_box_volume.loggers.num_elements = 0;

// packing the information into the global_geometry_element, which is then included in the global_geometry_list.
sprintf(global_geometry_element.name,NAME_CURRENT_COMP);
global_geometry_element.activation_counter = number_of_activations;
global_geometry_element.component_index = INDEX_CURRENT_COMP;
global_geometry_element.Volume = &this_box_volume; // Would be nicer if this m was a pointer, now we have the (small) data two places
add_element_to_geometry_list(&global_geometry_list,global_geometry_element);
}
#line 291833 "MACS_sample_kidney_box.c"
#undef number_of_activations
#undef mask_setting
#undef mask_string
#undef p_interact
#undef focus_r
#undef focus_xh
#undef focus_xw
#undef focus_ah
#undef focus_aw
#undef target_z
#undef target_y
#undef target_x
#undef target_index
#undef visualize
#undef yheight2
#undef xwidth2
#undef zdepth
#undef yheight
#undef xwidth
#undef priority
#undef material_string
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

  /* Initializations for component channel_14_analyzer_2_array_crystal_array_2. */
  SIG_MESSAGE("channel_14_analyzer_2_array_crystal_array_2 (Init)");
#define mccompcurname  channel_14_analyzer_2_array_crystal_array_2
#define mccompcurtype  Union_box
#define mccompcurindex 675
#define loop_index mccchannel_14_analyzer_2_array_crystal_array_2_loop_index
#define this_box_volume mccchannel_14_analyzer_2_array_crystal_array_2_this_box_volume
#define global_geometry_element mccchannel_14_analyzer_2_array_crystal_array_2_global_geometry_element
#define this_box_storage mccchannel_14_analyzer_2_array_crystal_array_2_this_box_storage
#define material_string mccchannel_14_analyzer_2_array_crystal_array_2_material_string
#define priority mccchannel_14_analyzer_2_array_crystal_array_2_priority
#define xwidth mccchannel_14_analyzer_2_array_crystal_array_2_xwidth
#define yheight mccchannel_14_analyzer_2_array_crystal_array_2_yheight
#define zdepth mccchannel_14_analyzer_2_array_crystal_array_2_zdepth
#define xwidth2 mccchannel_14_analyzer_2_array_crystal_array_2_xwidth2
#define yheight2 mccchannel_14_analyzer_2_array_crystal_array_2_yheight2
#define visualize mccchannel_14_analyzer_2_array_crystal_array_2_visualize
#define target_index mccchannel_14_analyzer_2_array_crystal_array_2_target_index
#define target_x mccchannel_14_analyzer_2_array_crystal_array_2_target_x
#define target_y mccchannel_14_analyzer_2_array_crystal_array_2_target_y
#define target_z mccchannel_14_analyzer_2_array_crystal_array_2_target_z
#define focus_aw mccchannel_14_analyzer_2_array_crystal_array_2_focus_aw
#define focus_ah mccchannel_14_analyzer_2_array_crystal_array_2_focus_ah
#define focus_xw mccchannel_14_analyzer_2_array_crystal_array_2_focus_xw
#define focus_xh mccchannel_14_analyzer_2_array_crystal_array_2_focus_xh
#define focus_r mccchannel_14_analyzer_2_array_crystal_array_2_focus_r
#define p_interact mccchannel_14_analyzer_2_array_crystal_array_2_p_interact
#define mask_string mccchannel_14_analyzer_2_array_crystal_array_2_mask_string
#define mask_setting mccchannel_14_analyzer_2_array_crystal_array_2_mask_setting
#define number_of_activations mccchannel_14_analyzer_2_array_crystal_array_2_number_of_activations
#line 224 "Union_box.comp"
{
// Initializes the focusing system for this volume including input sanitation.
focus_initialize(&this_box_volume.geometry, POS_A_COMP_INDEX(INDEX_CURRENT_COMP+target_index), POS_A_CURRENT_COMP, ROT_A_CURRENT_COMP, target_index, target_x, target_y, target_z, focus_aw, focus_ah, focus_xw, focus_xh, focus_r, NAME_CURRENT_COMP);

// Input sanitation for this geometry
if (xwidth <= 0) {
  printf("\nERROR in Union_box named %s, the xwidth is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (yheight <= 0) {
  printf("\nERROR in Union_box named %s, yheight is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (zdepth <= 0) {
  printf("\nERROR in Union_box named %s, zdepth is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (xwidth2 <= 0 && xwidth2 != -1) {
  printf("\nERROR in Union_box named %s, the xwidth2 is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (yheight2 <= 0 && yheight2 != -1) {
  printf("\nERROR in Union_box named %s, yheight2 is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}

// Use sanitation
if (global_material_list.num_elements == 0) {
  printf("\nERROR: Need to define a material using Union_make_material before using a Union geometry component. \n");
  printf("       %s was defined before first use of Union_make_material.\n",NAME_CURRENT_COMP);
  exit(1);
}

this_box_volume.geometry.is_masked_volume = 0;
this_box_volume.geometry.is_exit_volume = 0;
this_box_volume.geometry.is_mask_volume = 0;
// check if the volume is a mask, if it is the material string is irelevant.
if (mask_string && strlen(mask_string) && strcmp(mask_string, "NULL") && strcmp(mask_string, "0")) {
    // A mask volume is used to limit the extend of other volumes, called the masked volumes. These are specified in the mask_string.
    // In order for a ray to enter a masked volume, it needs to be both in the region covered by that volume AND the mask volume.
    // When more than
    this_box_volume.geometry.mask_mode = 1; // Default is mask mode is ALL
    if (mask_setting && strlen(mask_setting) && strcmp(mask_setting, "NULL") && strcmp(mask_setting, "0")) {
        if (strcmp(mask_setting,"ALL") == 0 || strcmp(mask_setting,"All") == 0) this_box_volume.geometry.mask_mode = 1;
        else if (strcmp(mask_setting,"ANY") == 0 || strcmp(mask_setting,"Any") == 0) this_box_volume.geometry.mask_mode = 2;
        else {
            printf("The mask_mode of component %s is set to %s, but must be either ALL or ANY.\n",NAME_CURRENT_COMP,mask_setting);
            exit(1);
        }
    }
    
    for (loop_index=0;loop_index<global_geometry_list.num_elements;loop_index++) {
        // Add mask list
        if (1 == manual_linking_function(global_geometry_list.elements[loop_index].name,mask_string)) {
            add_element_to_int_list(&this_box_volume.geometry.mask_list,global_geometry_list.elements[loop_index].component_index);
            add_element_to_int_list(&global_geometry_list.elements[loop_index].Volume->geometry.masked_by_list,INDEX_CURRENT_COMP);
            global_geometry_list.elements[loop_index].Volume->geometry.is_masked_volume = 1;
            if (this_box_volume.geometry.mask_mode == 2)
                global_geometry_list.elements[loop_index].Volume->geometry.mask_mode = 2;
            if (this_box_volume.geometry.mask_mode == 1) {
                if (global_geometry_list.elements[loop_index].Volume->geometry.is_masked_volume == 1 && global_geometry_list.elements[loop_index].Volume->geometry.mask_mode != 2)
                    // If more than one mask is added to one volume, the ANY mode overwrites the (default) ALL mode.
                    global_geometry_list.elements[loop_index].Volume->geometry.mask_mode = 1;
            }
            
            found_geometries = 1;
        }
    }
    if (found_geometries == 0) {
        printf("The mask_string in geometry: %s did not find any of the specified volumes in the mask_string %s \n",NAME_CURRENT_COMP,mask_string);
        exit(1);
    }
    this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
    this_box_volume.p_physics->is_vacuum = 0; // Makes this volume a vacuum
    this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
    this_box_volume.p_physics->my_a = 0; // Should not be used.
    sprintf(this_box_volume.p_physics->name,"Mask");
    this_box_volume.geometry.is_mask_volume = 1;
    
    
// Read the material input, or if it lacks, use automatic linking.
} else if (material_string && strlen(material_string) && strcmp(material_string, "NULL") && strcmp(material_string, "0")) {
    // A geometry string was given, use it to determine which material
    if (0 == strcmp(material_string,"vacuum") || 0 == strcmp(material_string,"Vacuum")) {
        // One could have a global physics struct for vacuum instead of creating one for each
        this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
        this_box_volume.p_physics->is_vacuum = 1; // Makes this volume a vacuum
        this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
        this_box_volume.p_physics->my_a = 0; // Should not be used.
        sprintf(this_box_volume.p_physics->name,"Vacuum");
    } else if (0 == strcmp(material_string,"exit") || 0 == strcmp(material_string,"Exit")) {
        // One could have a global physics struct for vacuum instead of creating one for each
        this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
        this_box_volume.p_physics->is_vacuum = 1; // Makes this volume a vacuum
        this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
        this_box_volume.p_physics->my_a = 0; // Should not be used.
        this_box_volume.geometry.is_exit_volume = 1;
        sprintf(this_box_volume.p_physics->name,"Exit");
    } else {
        #ifndef MATERIAL_DETECTOR
            printf("Need to define a material before refering to it in a geometry %s.\n",NAME_CURRENT_COMP);
            exit(1);
        #endif
        for (loop_index=0;loop_index<global_material_list.num_elements;loop_index++) {
            if (0 == strcmp(material_string,global_material_list.elements[loop_index].name)) {
                this_box_volume.p_physics = global_material_list.elements[loop_index].physics;
                break;
            }
            if (loop_index == global_material_list.num_elements-1) {
            printf("\n");
            printf("ERROR: The material string \"%s\" in Union geometry \"%s\" did not match a specified material. \n",material_string,NAME_CURRENT_COMP);
            printf("       The materials available at this point (need to be defined before the geometry): \n");
            for (loop_index=0;loop_index<global_material_list.num_elements;loop_index++)
              printf("         %s\n",global_material_list.elements[loop_index].name);
            printf("\n");
            printf("       It is also possible to use one of the defualt materials avaiable: \n");
            printf("           Vacuum (for a Volume without scattering or absorption)\n");
            printf("           Exit (for a Volume where the ray exits the component if it enters)\n");
            printf("           Mask (for a Volume that masks existing volumes specified in the mask_string\n");
            exit(1);
          }
        }
    }
} else {
    // Automatic linking, simply using the last defined material.
    #ifndef MATERIAL_DETECTOR
        printf("Need to define a material before the geometry to use automatic linking %s.\n",NAME_CURRENT_COMP);
        exit(1);
    #endif
    this_box_volume.p_physics = global_material_list.elements[global_material_list.num_elements-1].physics;
}

sprintf(this_box_volume.name,NAME_CURRENT_COMP);
sprintf(this_box_volume.geometry.shape,"box");
this_box_volume.geometry.priority_value = priority;
this_box_volume.geometry.geometry_p_interact = p_interact;
// Currently the coordinates will be in absolute space.
this_box_volume.geometry.center = POS_A_CURRENT_COMP;

this_box_storage.z_depth = zdepth;
this_box_storage.x_width1 = xwidth;
this_box_storage.y_height1 = yheight;

this_box_storage.is_rectangle = 0;
if (xwidth2 < 0 && yheight2 < 0) this_box_storage.is_rectangle = 1;
if (xwidth == xwidth2 && yheight == yheight2) this_box_storage.is_rectangle = 1;

if (xwidth2 < 0) {
    this_box_storage.x_width2 = xwidth;
    xwidth2 = xwidth;
} else this_box_storage.x_width2 = xwidth2;

if (yheight2 < 0) {
    this_box_storage.y_height2 = yheight;
    yheight2 = yheight;
} else this_box_storage.y_height2 = yheight2;


this_box_storage.normal_vectors[0] = coords_set(0,0,1);
this_box_storage.normal_vectors[1] = coords_set(0,0,1);

// for sides with y component = 0
x_component = 2*zdepth/sqrt((xwidth-xwidth2)*(xwidth-xwidth2)+4*zdepth*zdepth);
z_component = (xwidth-xwidth2)/sqrt(4*zdepth*zdepth+(xwidth-xwidth2)*(xwidth-xwidth2));

this_box_storage.normal_vectors[2] = coords_set(x_component,0,z_component);
this_box_storage.normal_vectors[3] = coords_set(-x_component,0,z_component);

// for sides with x component = 0
y_component = 2*zdepth/sqrt((yheight-yheight2)*(yheight-yheight2)+4*zdepth*zdepth);
z_component = (yheight-yheight2)/sqrt(4*zdepth*zdepth+(yheight-yheight2)*(yheight-yheight2));

this_box_storage.normal_vectors[4] = coords_set(0,y_component,z_component);
this_box_storage.normal_vectors[5] = coords_set(0,-y_component,z_component);

this_box_volume.geometry.visualization_on = visualize;

this_box_volume.geometry.geometry_parameters.p_box_storage = &this_box_storage;

// Assign pointers to functions for intersection with the shape, checking if a point is inside the shape
if (this_box_storage.is_rectangle == 1) {
this_box_volume.geometry.intersect_function = &sample_box_intersect_simple;
this_box_volume.geometry.within_function = &r_within_box_simple;
}
else {
this_box_volume.geometry.intersect_function = &sample_box_intersect_advanced;
this_box_volume.geometry.within_function = &r_within_box_advanced;
}

this_box_volume.geometry.shell_points = &box_shell_points;
this_box_volume.geometry.mcdisplay_function = &mcdisplay_box_function;
this_box_volume.geometry.initialize_from_main_function = &initialize_box_geometry_from_main_component;
this_box_volume.geometry.process_rot_allocated = 0;

this_box_volume.geometry.copy_geometry_parameters = &allocate_box_storage_copy;

rot_copy(this_box_volume.geometry.rotation_matrix,ROT_A_CURRENT_COMP); //check how ROT_R_CURRENT_COMP would work
rot_transpose(ROT_A_CURRENT_COMP,this_box_volume.geometry.transpose_rotation_matrix);

// Initialize loggers
this_box_volume.loggers.num_elements = 0;

// packing the information into the global_geometry_element, which is then included in the global_geometry_list.
sprintf(global_geometry_element.name,NAME_CURRENT_COMP);
global_geometry_element.activation_counter = number_of_activations;
global_geometry_element.component_index = INDEX_CURRENT_COMP;
global_geometry_element.Volume = &this_box_volume; // Would be nicer if this m was a pointer, now we have the (small) data two places
add_element_to_geometry_list(&global_geometry_list,global_geometry_element);
}
#line 292103 "MACS_sample_kidney_box.c"
#undef number_of_activations
#undef mask_setting
#undef mask_string
#undef p_interact
#undef focus_r
#undef focus_xh
#undef focus_xw
#undef focus_ah
#undef focus_aw
#undef target_z
#undef target_y
#undef target_x
#undef target_index
#undef visualize
#undef yheight2
#undef xwidth2
#undef zdepth
#undef yheight
#undef xwidth
#undef priority
#undef material_string
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

  /* Initializations for component channel_14_analyzer_2_array_crystal_array_3. */
  SIG_MESSAGE("channel_14_analyzer_2_array_crystal_array_3 (Init)");
#define mccompcurname  channel_14_analyzer_2_array_crystal_array_3
#define mccompcurtype  Union_box
#define mccompcurindex 676
#define loop_index mccchannel_14_analyzer_2_array_crystal_array_3_loop_index
#define this_box_volume mccchannel_14_analyzer_2_array_crystal_array_3_this_box_volume
#define global_geometry_element mccchannel_14_analyzer_2_array_crystal_array_3_global_geometry_element
#define this_box_storage mccchannel_14_analyzer_2_array_crystal_array_3_this_box_storage
#define material_string mccchannel_14_analyzer_2_array_crystal_array_3_material_string
#define priority mccchannel_14_analyzer_2_array_crystal_array_3_priority
#define xwidth mccchannel_14_analyzer_2_array_crystal_array_3_xwidth
#define yheight mccchannel_14_analyzer_2_array_crystal_array_3_yheight
#define zdepth mccchannel_14_analyzer_2_array_crystal_array_3_zdepth
#define xwidth2 mccchannel_14_analyzer_2_array_crystal_array_3_xwidth2
#define yheight2 mccchannel_14_analyzer_2_array_crystal_array_3_yheight2
#define visualize mccchannel_14_analyzer_2_array_crystal_array_3_visualize
#define target_index mccchannel_14_analyzer_2_array_crystal_array_3_target_index
#define target_x mccchannel_14_analyzer_2_array_crystal_array_3_target_x
#define target_y mccchannel_14_analyzer_2_array_crystal_array_3_target_y
#define target_z mccchannel_14_analyzer_2_array_crystal_array_3_target_z
#define focus_aw mccchannel_14_analyzer_2_array_crystal_array_3_focus_aw
#define focus_ah mccchannel_14_analyzer_2_array_crystal_array_3_focus_ah
#define focus_xw mccchannel_14_analyzer_2_array_crystal_array_3_focus_xw
#define focus_xh mccchannel_14_analyzer_2_array_crystal_array_3_focus_xh
#define focus_r mccchannel_14_analyzer_2_array_crystal_array_3_focus_r
#define p_interact mccchannel_14_analyzer_2_array_crystal_array_3_p_interact
#define mask_string mccchannel_14_analyzer_2_array_crystal_array_3_mask_string
#define mask_setting mccchannel_14_analyzer_2_array_crystal_array_3_mask_setting
#define number_of_activations mccchannel_14_analyzer_2_array_crystal_array_3_number_of_activations
#line 224 "Union_box.comp"
{
// Initializes the focusing system for this volume including input sanitation.
focus_initialize(&this_box_volume.geometry, POS_A_COMP_INDEX(INDEX_CURRENT_COMP+target_index), POS_A_CURRENT_COMP, ROT_A_CURRENT_COMP, target_index, target_x, target_y, target_z, focus_aw, focus_ah, focus_xw, focus_xh, focus_r, NAME_CURRENT_COMP);

// Input sanitation for this geometry
if (xwidth <= 0) {
  printf("\nERROR in Union_box named %s, the xwidth is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (yheight <= 0) {
  printf("\nERROR in Union_box named %s, yheight is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (zdepth <= 0) {
  printf("\nERROR in Union_box named %s, zdepth is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (xwidth2 <= 0 && xwidth2 != -1) {
  printf("\nERROR in Union_box named %s, the xwidth2 is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (yheight2 <= 0 && yheight2 != -1) {
  printf("\nERROR in Union_box named %s, yheight2 is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}

// Use sanitation
if (global_material_list.num_elements == 0) {
  printf("\nERROR: Need to define a material using Union_make_material before using a Union geometry component. \n");
  printf("       %s was defined before first use of Union_make_material.\n",NAME_CURRENT_COMP);
  exit(1);
}

this_box_volume.geometry.is_masked_volume = 0;
this_box_volume.geometry.is_exit_volume = 0;
this_box_volume.geometry.is_mask_volume = 0;
// check if the volume is a mask, if it is the material string is irelevant.
if (mask_string && strlen(mask_string) && strcmp(mask_string, "NULL") && strcmp(mask_string, "0")) {
    // A mask volume is used to limit the extend of other volumes, called the masked volumes. These are specified in the mask_string.
    // In order for a ray to enter a masked volume, it needs to be both in the region covered by that volume AND the mask volume.
    // When more than
    this_box_volume.geometry.mask_mode = 1; // Default is mask mode is ALL
    if (mask_setting && strlen(mask_setting) && strcmp(mask_setting, "NULL") && strcmp(mask_setting, "0")) {
        if (strcmp(mask_setting,"ALL") == 0 || strcmp(mask_setting,"All") == 0) this_box_volume.geometry.mask_mode = 1;
        else if (strcmp(mask_setting,"ANY") == 0 || strcmp(mask_setting,"Any") == 0) this_box_volume.geometry.mask_mode = 2;
        else {
            printf("The mask_mode of component %s is set to %s, but must be either ALL or ANY.\n",NAME_CURRENT_COMP,mask_setting);
            exit(1);
        }
    }
    
    for (loop_index=0;loop_index<global_geometry_list.num_elements;loop_index++) {
        // Add mask list
        if (1 == manual_linking_function(global_geometry_list.elements[loop_index].name,mask_string)) {
            add_element_to_int_list(&this_box_volume.geometry.mask_list,global_geometry_list.elements[loop_index].component_index);
            add_element_to_int_list(&global_geometry_list.elements[loop_index].Volume->geometry.masked_by_list,INDEX_CURRENT_COMP);
            global_geometry_list.elements[loop_index].Volume->geometry.is_masked_volume = 1;
            if (this_box_volume.geometry.mask_mode == 2)
                global_geometry_list.elements[loop_index].Volume->geometry.mask_mode = 2;
            if (this_box_volume.geometry.mask_mode == 1) {
                if (global_geometry_list.elements[loop_index].Volume->geometry.is_masked_volume == 1 && global_geometry_list.elements[loop_index].Volume->geometry.mask_mode != 2)
                    // If more than one mask is added to one volume, the ANY mode overwrites the (default) ALL mode.
                    global_geometry_list.elements[loop_index].Volume->geometry.mask_mode = 1;
            }
            
            found_geometries = 1;
        }
    }
    if (found_geometries == 0) {
        printf("The mask_string in geometry: %s did not find any of the specified volumes in the mask_string %s \n",NAME_CURRENT_COMP,mask_string);
        exit(1);
    }
    this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
    this_box_volume.p_physics->is_vacuum = 0; // Makes this volume a vacuum
    this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
    this_box_volume.p_physics->my_a = 0; // Should not be used.
    sprintf(this_box_volume.p_physics->name,"Mask");
    this_box_volume.geometry.is_mask_volume = 1;
    
    
// Read the material input, or if it lacks, use automatic linking.
} else if (material_string && strlen(material_string) && strcmp(material_string, "NULL") && strcmp(material_string, "0")) {
    // A geometry string was given, use it to determine which material
    if (0 == strcmp(material_string,"vacuum") || 0 == strcmp(material_string,"Vacuum")) {
        // One could have a global physics struct for vacuum instead of creating one for each
        this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
        this_box_volume.p_physics->is_vacuum = 1; // Makes this volume a vacuum
        this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
        this_box_volume.p_physics->my_a = 0; // Should not be used.
        sprintf(this_box_volume.p_physics->name,"Vacuum");
    } else if (0 == strcmp(material_string,"exit") || 0 == strcmp(material_string,"Exit")) {
        // One could have a global physics struct for vacuum instead of creating one for each
        this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
        this_box_volume.p_physics->is_vacuum = 1; // Makes this volume a vacuum
        this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
        this_box_volume.p_physics->my_a = 0; // Should not be used.
        this_box_volume.geometry.is_exit_volume = 1;
        sprintf(this_box_volume.p_physics->name,"Exit");
    } else {
        #ifndef MATERIAL_DETECTOR
            printf("Need to define a material before refering to it in a geometry %s.\n",NAME_CURRENT_COMP);
            exit(1);
        #endif
        for (loop_index=0;loop_index<global_material_list.num_elements;loop_index++) {
            if (0 == strcmp(material_string,global_material_list.elements[loop_index].name)) {
                this_box_volume.p_physics = global_material_list.elements[loop_index].physics;
                break;
            }
            if (loop_index == global_material_list.num_elements-1) {
            printf("\n");
            printf("ERROR: The material string \"%s\" in Union geometry \"%s\" did not match a specified material. \n",material_string,NAME_CURRENT_COMP);
            printf("       The materials available at this point (need to be defined before the geometry): \n");
            for (loop_index=0;loop_index<global_material_list.num_elements;loop_index++)
              printf("         %s\n",global_material_list.elements[loop_index].name);
            printf("\n");
            printf("       It is also possible to use one of the defualt materials avaiable: \n");
            printf("           Vacuum (for a Volume without scattering or absorption)\n");
            printf("           Exit (for a Volume where the ray exits the component if it enters)\n");
            printf("           Mask (for a Volume that masks existing volumes specified in the mask_string\n");
            exit(1);
          }
        }
    }
} else {
    // Automatic linking, simply using the last defined material.
    #ifndef MATERIAL_DETECTOR
        printf("Need to define a material before the geometry to use automatic linking %s.\n",NAME_CURRENT_COMP);
        exit(1);
    #endif
    this_box_volume.p_physics = global_material_list.elements[global_material_list.num_elements-1].physics;
}

sprintf(this_box_volume.name,NAME_CURRENT_COMP);
sprintf(this_box_volume.geometry.shape,"box");
this_box_volume.geometry.priority_value = priority;
this_box_volume.geometry.geometry_p_interact = p_interact;
// Currently the coordinates will be in absolute space.
this_box_volume.geometry.center = POS_A_CURRENT_COMP;

this_box_storage.z_depth = zdepth;
this_box_storage.x_width1 = xwidth;
this_box_storage.y_height1 = yheight;

this_box_storage.is_rectangle = 0;
if (xwidth2 < 0 && yheight2 < 0) this_box_storage.is_rectangle = 1;
if (xwidth == xwidth2 && yheight == yheight2) this_box_storage.is_rectangle = 1;

if (xwidth2 < 0) {
    this_box_storage.x_width2 = xwidth;
    xwidth2 = xwidth;
} else this_box_storage.x_width2 = xwidth2;

if (yheight2 < 0) {
    this_box_storage.y_height2 = yheight;
    yheight2 = yheight;
} else this_box_storage.y_height2 = yheight2;


this_box_storage.normal_vectors[0] = coords_set(0,0,1);
this_box_storage.normal_vectors[1] = coords_set(0,0,1);

// for sides with y component = 0
x_component = 2*zdepth/sqrt((xwidth-xwidth2)*(xwidth-xwidth2)+4*zdepth*zdepth);
z_component = (xwidth-xwidth2)/sqrt(4*zdepth*zdepth+(xwidth-xwidth2)*(xwidth-xwidth2));

this_box_storage.normal_vectors[2] = coords_set(x_component,0,z_component);
this_box_storage.normal_vectors[3] = coords_set(-x_component,0,z_component);

// for sides with x component = 0
y_component = 2*zdepth/sqrt((yheight-yheight2)*(yheight-yheight2)+4*zdepth*zdepth);
z_component = (yheight-yheight2)/sqrt(4*zdepth*zdepth+(yheight-yheight2)*(yheight-yheight2));

this_box_storage.normal_vectors[4] = coords_set(0,y_component,z_component);
this_box_storage.normal_vectors[5] = coords_set(0,-y_component,z_component);

this_box_volume.geometry.visualization_on = visualize;

this_box_volume.geometry.geometry_parameters.p_box_storage = &this_box_storage;

// Assign pointers to functions for intersection with the shape, checking if a point is inside the shape
if (this_box_storage.is_rectangle == 1) {
this_box_volume.geometry.intersect_function = &sample_box_intersect_simple;
this_box_volume.geometry.within_function = &r_within_box_simple;
}
else {
this_box_volume.geometry.intersect_function = &sample_box_intersect_advanced;
this_box_volume.geometry.within_function = &r_within_box_advanced;
}

this_box_volume.geometry.shell_points = &box_shell_points;
this_box_volume.geometry.mcdisplay_function = &mcdisplay_box_function;
this_box_volume.geometry.initialize_from_main_function = &initialize_box_geometry_from_main_component;
this_box_volume.geometry.process_rot_allocated = 0;

this_box_volume.geometry.copy_geometry_parameters = &allocate_box_storage_copy;

rot_copy(this_box_volume.geometry.rotation_matrix,ROT_A_CURRENT_COMP); //check how ROT_R_CURRENT_COMP would work
rot_transpose(ROT_A_CURRENT_COMP,this_box_volume.geometry.transpose_rotation_matrix);

// Initialize loggers
this_box_volume.loggers.num_elements = 0;

// packing the information into the global_geometry_element, which is then included in the global_geometry_list.
sprintf(global_geometry_element.name,NAME_CURRENT_COMP);
global_geometry_element.activation_counter = number_of_activations;
global_geometry_element.component_index = INDEX_CURRENT_COMP;
global_geometry_element.Volume = &this_box_volume; // Would be nicer if this m was a pointer, now we have the (small) data two places
add_element_to_geometry_list(&global_geometry_list,global_geometry_element);
}
#line 292373 "MACS_sample_kidney_box.c"
#undef number_of_activations
#undef mask_setting
#undef mask_string
#undef p_interact
#undef focus_r
#undef focus_xh
#undef focus_xw
#undef focus_ah
#undef focus_aw
#undef target_z
#undef target_y
#undef target_x
#undef target_index
#undef visualize
#undef yheight2
#undef xwidth2
#undef zdepth
#undef yheight
#undef xwidth
#undef priority
#undef material_string
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

  /* Initializations for component channel_14_analyzer_2_array_crystal_array_4. */
  SIG_MESSAGE("channel_14_analyzer_2_array_crystal_array_4 (Init)");
#define mccompcurname  channel_14_analyzer_2_array_crystal_array_4
#define mccompcurtype  Union_box
#define mccompcurindex 677
#define loop_index mccchannel_14_analyzer_2_array_crystal_array_4_loop_index
#define this_box_volume mccchannel_14_analyzer_2_array_crystal_array_4_this_box_volume
#define global_geometry_element mccchannel_14_analyzer_2_array_crystal_array_4_global_geometry_element
#define this_box_storage mccchannel_14_analyzer_2_array_crystal_array_4_this_box_storage
#define material_string mccchannel_14_analyzer_2_array_crystal_array_4_material_string
#define priority mccchannel_14_analyzer_2_array_crystal_array_4_priority
#define xwidth mccchannel_14_analyzer_2_array_crystal_array_4_xwidth
#define yheight mccchannel_14_analyzer_2_array_crystal_array_4_yheight
#define zdepth mccchannel_14_analyzer_2_array_crystal_array_4_zdepth
#define xwidth2 mccchannel_14_analyzer_2_array_crystal_array_4_xwidth2
#define yheight2 mccchannel_14_analyzer_2_array_crystal_array_4_yheight2
#define visualize mccchannel_14_analyzer_2_array_crystal_array_4_visualize
#define target_index mccchannel_14_analyzer_2_array_crystal_array_4_target_index
#define target_x mccchannel_14_analyzer_2_array_crystal_array_4_target_x
#define target_y mccchannel_14_analyzer_2_array_crystal_array_4_target_y
#define target_z mccchannel_14_analyzer_2_array_crystal_array_4_target_z
#define focus_aw mccchannel_14_analyzer_2_array_crystal_array_4_focus_aw
#define focus_ah mccchannel_14_analyzer_2_array_crystal_array_4_focus_ah
#define focus_xw mccchannel_14_analyzer_2_array_crystal_array_4_focus_xw
#define focus_xh mccchannel_14_analyzer_2_array_crystal_array_4_focus_xh
#define focus_r mccchannel_14_analyzer_2_array_crystal_array_4_focus_r
#define p_interact mccchannel_14_analyzer_2_array_crystal_array_4_p_interact
#define mask_string mccchannel_14_analyzer_2_array_crystal_array_4_mask_string
#define mask_setting mccchannel_14_analyzer_2_array_crystal_array_4_mask_setting
#define number_of_activations mccchannel_14_analyzer_2_array_crystal_array_4_number_of_activations
#line 224 "Union_box.comp"
{
// Initializes the focusing system for this volume including input sanitation.
focus_initialize(&this_box_volume.geometry, POS_A_COMP_INDEX(INDEX_CURRENT_COMP+target_index), POS_A_CURRENT_COMP, ROT_A_CURRENT_COMP, target_index, target_x, target_y, target_z, focus_aw, focus_ah, focus_xw, focus_xh, focus_r, NAME_CURRENT_COMP);

// Input sanitation for this geometry
if (xwidth <= 0) {
  printf("\nERROR in Union_box named %s, the xwidth is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (yheight <= 0) {
  printf("\nERROR in Union_box named %s, yheight is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (zdepth <= 0) {
  printf("\nERROR in Union_box named %s, zdepth is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (xwidth2 <= 0 && xwidth2 != -1) {
  printf("\nERROR in Union_box named %s, the xwidth2 is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (yheight2 <= 0 && yheight2 != -1) {
  printf("\nERROR in Union_box named %s, yheight2 is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}

// Use sanitation
if (global_material_list.num_elements == 0) {
  printf("\nERROR: Need to define a material using Union_make_material before using a Union geometry component. \n");
  printf("       %s was defined before first use of Union_make_material.\n",NAME_CURRENT_COMP);
  exit(1);
}

this_box_volume.geometry.is_masked_volume = 0;
this_box_volume.geometry.is_exit_volume = 0;
this_box_volume.geometry.is_mask_volume = 0;
// check if the volume is a mask, if it is the material string is irelevant.
if (mask_string && strlen(mask_string) && strcmp(mask_string, "NULL") && strcmp(mask_string, "0")) {
    // A mask volume is used to limit the extend of other volumes, called the masked volumes. These are specified in the mask_string.
    // In order for a ray to enter a masked volume, it needs to be both in the region covered by that volume AND the mask volume.
    // When more than
    this_box_volume.geometry.mask_mode = 1; // Default is mask mode is ALL
    if (mask_setting && strlen(mask_setting) && strcmp(mask_setting, "NULL") && strcmp(mask_setting, "0")) {
        if (strcmp(mask_setting,"ALL") == 0 || strcmp(mask_setting,"All") == 0) this_box_volume.geometry.mask_mode = 1;
        else if (strcmp(mask_setting,"ANY") == 0 || strcmp(mask_setting,"Any") == 0) this_box_volume.geometry.mask_mode = 2;
        else {
            printf("The mask_mode of component %s is set to %s, but must be either ALL or ANY.\n",NAME_CURRENT_COMP,mask_setting);
            exit(1);
        }
    }
    
    for (loop_index=0;loop_index<global_geometry_list.num_elements;loop_index++) {
        // Add mask list
        if (1 == manual_linking_function(global_geometry_list.elements[loop_index].name,mask_string)) {
            add_element_to_int_list(&this_box_volume.geometry.mask_list,global_geometry_list.elements[loop_index].component_index);
            add_element_to_int_list(&global_geometry_list.elements[loop_index].Volume->geometry.masked_by_list,INDEX_CURRENT_COMP);
            global_geometry_list.elements[loop_index].Volume->geometry.is_masked_volume = 1;
            if (this_box_volume.geometry.mask_mode == 2)
                global_geometry_list.elements[loop_index].Volume->geometry.mask_mode = 2;
            if (this_box_volume.geometry.mask_mode == 1) {
                if (global_geometry_list.elements[loop_index].Volume->geometry.is_masked_volume == 1 && global_geometry_list.elements[loop_index].Volume->geometry.mask_mode != 2)
                    // If more than one mask is added to one volume, the ANY mode overwrites the (default) ALL mode.
                    global_geometry_list.elements[loop_index].Volume->geometry.mask_mode = 1;
            }
            
            found_geometries = 1;
        }
    }
    if (found_geometries == 0) {
        printf("The mask_string in geometry: %s did not find any of the specified volumes in the mask_string %s \n",NAME_CURRENT_COMP,mask_string);
        exit(1);
    }
    this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
    this_box_volume.p_physics->is_vacuum = 0; // Makes this volume a vacuum
    this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
    this_box_volume.p_physics->my_a = 0; // Should not be used.
    sprintf(this_box_volume.p_physics->name,"Mask");
    this_box_volume.geometry.is_mask_volume = 1;
    
    
// Read the material input, or if it lacks, use automatic linking.
} else if (material_string && strlen(material_string) && strcmp(material_string, "NULL") && strcmp(material_string, "0")) {
    // A geometry string was given, use it to determine which material
    if (0 == strcmp(material_string,"vacuum") || 0 == strcmp(material_string,"Vacuum")) {
        // One could have a global physics struct for vacuum instead of creating one for each
        this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
        this_box_volume.p_physics->is_vacuum = 1; // Makes this volume a vacuum
        this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
        this_box_volume.p_physics->my_a = 0; // Should not be used.
        sprintf(this_box_volume.p_physics->name,"Vacuum");
    } else if (0 == strcmp(material_string,"exit") || 0 == strcmp(material_string,"Exit")) {
        // One could have a global physics struct for vacuum instead of creating one for each
        this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
        this_box_volume.p_physics->is_vacuum = 1; // Makes this volume a vacuum
        this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
        this_box_volume.p_physics->my_a = 0; // Should not be used.
        this_box_volume.geometry.is_exit_volume = 1;
        sprintf(this_box_volume.p_physics->name,"Exit");
    } else {
        #ifndef MATERIAL_DETECTOR
            printf("Need to define a material before refering to it in a geometry %s.\n",NAME_CURRENT_COMP);
            exit(1);
        #endif
        for (loop_index=0;loop_index<global_material_list.num_elements;loop_index++) {
            if (0 == strcmp(material_string,global_material_list.elements[loop_index].name)) {
                this_box_volume.p_physics = global_material_list.elements[loop_index].physics;
                break;
            }
            if (loop_index == global_material_list.num_elements-1) {
            printf("\n");
            printf("ERROR: The material string \"%s\" in Union geometry \"%s\" did not match a specified material. \n",material_string,NAME_CURRENT_COMP);
            printf("       The materials available at this point (need to be defined before the geometry): \n");
            for (loop_index=0;loop_index<global_material_list.num_elements;loop_index++)
              printf("         %s\n",global_material_list.elements[loop_index].name);
            printf("\n");
            printf("       It is also possible to use one of the defualt materials avaiable: \n");
            printf("           Vacuum (for a Volume without scattering or absorption)\n");
            printf("           Exit (for a Volume where the ray exits the component if it enters)\n");
            printf("           Mask (for a Volume that masks existing volumes specified in the mask_string\n");
            exit(1);
          }
        }
    }
} else {
    // Automatic linking, simply using the last defined material.
    #ifndef MATERIAL_DETECTOR
        printf("Need to define a material before the geometry to use automatic linking %s.\n",NAME_CURRENT_COMP);
        exit(1);
    #endif
    this_box_volume.p_physics = global_material_list.elements[global_material_list.num_elements-1].physics;
}

sprintf(this_box_volume.name,NAME_CURRENT_COMP);
sprintf(this_box_volume.geometry.shape,"box");
this_box_volume.geometry.priority_value = priority;
this_box_volume.geometry.geometry_p_interact = p_interact;
// Currently the coordinates will be in absolute space.
this_box_volume.geometry.center = POS_A_CURRENT_COMP;

this_box_storage.z_depth = zdepth;
this_box_storage.x_width1 = xwidth;
this_box_storage.y_height1 = yheight;

this_box_storage.is_rectangle = 0;
if (xwidth2 < 0 && yheight2 < 0) this_box_storage.is_rectangle = 1;
if (xwidth == xwidth2 && yheight == yheight2) this_box_storage.is_rectangle = 1;

if (xwidth2 < 0) {
    this_box_storage.x_width2 = xwidth;
    xwidth2 = xwidth;
} else this_box_storage.x_width2 = xwidth2;

if (yheight2 < 0) {
    this_box_storage.y_height2 = yheight;
    yheight2 = yheight;
} else this_box_storage.y_height2 = yheight2;


this_box_storage.normal_vectors[0] = coords_set(0,0,1);
this_box_storage.normal_vectors[1] = coords_set(0,0,1);

// for sides with y component = 0
x_component = 2*zdepth/sqrt((xwidth-xwidth2)*(xwidth-xwidth2)+4*zdepth*zdepth);
z_component = (xwidth-xwidth2)/sqrt(4*zdepth*zdepth+(xwidth-xwidth2)*(xwidth-xwidth2));

this_box_storage.normal_vectors[2] = coords_set(x_component,0,z_component);
this_box_storage.normal_vectors[3] = coords_set(-x_component,0,z_component);

// for sides with x component = 0
y_component = 2*zdepth/sqrt((yheight-yheight2)*(yheight-yheight2)+4*zdepth*zdepth);
z_component = (yheight-yheight2)/sqrt(4*zdepth*zdepth+(yheight-yheight2)*(yheight-yheight2));

this_box_storage.normal_vectors[4] = coords_set(0,y_component,z_component);
this_box_storage.normal_vectors[5] = coords_set(0,-y_component,z_component);

this_box_volume.geometry.visualization_on = visualize;

this_box_volume.geometry.geometry_parameters.p_box_storage = &this_box_storage;

// Assign pointers to functions for intersection with the shape, checking if a point is inside the shape
if (this_box_storage.is_rectangle == 1) {
this_box_volume.geometry.intersect_function = &sample_box_intersect_simple;
this_box_volume.geometry.within_function = &r_within_box_simple;
}
else {
this_box_volume.geometry.intersect_function = &sample_box_intersect_advanced;
this_box_volume.geometry.within_function = &r_within_box_advanced;
}

this_box_volume.geometry.shell_points = &box_shell_points;
this_box_volume.geometry.mcdisplay_function = &mcdisplay_box_function;
this_box_volume.geometry.initialize_from_main_function = &initialize_box_geometry_from_main_component;
this_box_volume.geometry.process_rot_allocated = 0;

this_box_volume.geometry.copy_geometry_parameters = &allocate_box_storage_copy;

rot_copy(this_box_volume.geometry.rotation_matrix,ROT_A_CURRENT_COMP); //check how ROT_R_CURRENT_COMP would work
rot_transpose(ROT_A_CURRENT_COMP,this_box_volume.geometry.transpose_rotation_matrix);

// Initialize loggers
this_box_volume.loggers.num_elements = 0;

// packing the information into the global_geometry_element, which is then included in the global_geometry_list.
sprintf(global_geometry_element.name,NAME_CURRENT_COMP);
global_geometry_element.activation_counter = number_of_activations;
global_geometry_element.component_index = INDEX_CURRENT_COMP;
global_geometry_element.Volume = &this_box_volume; // Would be nicer if this m was a pointer, now we have the (small) data two places
add_element_to_geometry_list(&global_geometry_list,global_geometry_element);
}
#line 292643 "MACS_sample_kidney_box.c"
#undef number_of_activations
#undef mask_setting
#undef mask_string
#undef p_interact
#undef focus_r
#undef focus_xh
#undef focus_xw
#undef focus_ah
#undef focus_aw
#undef target_z
#undef target_y
#undef target_x
#undef target_index
#undef visualize
#undef yheight2
#undef xwidth2
#undef zdepth
#undef yheight
#undef xwidth
#undef priority
#undef material_string
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

  /* Initializations for component channel_14_analyzer_2_array_crystal_array_5. */
  SIG_MESSAGE("channel_14_analyzer_2_array_crystal_array_5 (Init)");
#define mccompcurname  channel_14_analyzer_2_array_crystal_array_5
#define mccompcurtype  Union_box
#define mccompcurindex 678
#define loop_index mccchannel_14_analyzer_2_array_crystal_array_5_loop_index
#define this_box_volume mccchannel_14_analyzer_2_array_crystal_array_5_this_box_volume
#define global_geometry_element mccchannel_14_analyzer_2_array_crystal_array_5_global_geometry_element
#define this_box_storage mccchannel_14_analyzer_2_array_crystal_array_5_this_box_storage
#define material_string mccchannel_14_analyzer_2_array_crystal_array_5_material_string
#define priority mccchannel_14_analyzer_2_array_crystal_array_5_priority
#define xwidth mccchannel_14_analyzer_2_array_crystal_array_5_xwidth
#define yheight mccchannel_14_analyzer_2_array_crystal_array_5_yheight
#define zdepth mccchannel_14_analyzer_2_array_crystal_array_5_zdepth
#define xwidth2 mccchannel_14_analyzer_2_array_crystal_array_5_xwidth2
#define yheight2 mccchannel_14_analyzer_2_array_crystal_array_5_yheight2
#define visualize mccchannel_14_analyzer_2_array_crystal_array_5_visualize
#define target_index mccchannel_14_analyzer_2_array_crystal_array_5_target_index
#define target_x mccchannel_14_analyzer_2_array_crystal_array_5_target_x
#define target_y mccchannel_14_analyzer_2_array_crystal_array_5_target_y
#define target_z mccchannel_14_analyzer_2_array_crystal_array_5_target_z
#define focus_aw mccchannel_14_analyzer_2_array_crystal_array_5_focus_aw
#define focus_ah mccchannel_14_analyzer_2_array_crystal_array_5_focus_ah
#define focus_xw mccchannel_14_analyzer_2_array_crystal_array_5_focus_xw
#define focus_xh mccchannel_14_analyzer_2_array_crystal_array_5_focus_xh
#define focus_r mccchannel_14_analyzer_2_array_crystal_array_5_focus_r
#define p_interact mccchannel_14_analyzer_2_array_crystal_array_5_p_interact
#define mask_string mccchannel_14_analyzer_2_array_crystal_array_5_mask_string
#define mask_setting mccchannel_14_analyzer_2_array_crystal_array_5_mask_setting
#define number_of_activations mccchannel_14_analyzer_2_array_crystal_array_5_number_of_activations
#line 224 "Union_box.comp"
{
// Initializes the focusing system for this volume including input sanitation.
focus_initialize(&this_box_volume.geometry, POS_A_COMP_INDEX(INDEX_CURRENT_COMP+target_index), POS_A_CURRENT_COMP, ROT_A_CURRENT_COMP, target_index, target_x, target_y, target_z, focus_aw, focus_ah, focus_xw, focus_xh, focus_r, NAME_CURRENT_COMP);

// Input sanitation for this geometry
if (xwidth <= 0) {
  printf("\nERROR in Union_box named %s, the xwidth is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (yheight <= 0) {
  printf("\nERROR in Union_box named %s, yheight is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (zdepth <= 0) {
  printf("\nERROR in Union_box named %s, zdepth is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (xwidth2 <= 0 && xwidth2 != -1) {
  printf("\nERROR in Union_box named %s, the xwidth2 is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (yheight2 <= 0 && yheight2 != -1) {
  printf("\nERROR in Union_box named %s, yheight2 is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}

// Use sanitation
if (global_material_list.num_elements == 0) {
  printf("\nERROR: Need to define a material using Union_make_material before using a Union geometry component. \n");
  printf("       %s was defined before first use of Union_make_material.\n",NAME_CURRENT_COMP);
  exit(1);
}

this_box_volume.geometry.is_masked_volume = 0;
this_box_volume.geometry.is_exit_volume = 0;
this_box_volume.geometry.is_mask_volume = 0;
// check if the volume is a mask, if it is the material string is irelevant.
if (mask_string && strlen(mask_string) && strcmp(mask_string, "NULL") && strcmp(mask_string, "0")) {
    // A mask volume is used to limit the extend of other volumes, called the masked volumes. These are specified in the mask_string.
    // In order for a ray to enter a masked volume, it needs to be both in the region covered by that volume AND the mask volume.
    // When more than
    this_box_volume.geometry.mask_mode = 1; // Default is mask mode is ALL
    if (mask_setting && strlen(mask_setting) && strcmp(mask_setting, "NULL") && strcmp(mask_setting, "0")) {
        if (strcmp(mask_setting,"ALL") == 0 || strcmp(mask_setting,"All") == 0) this_box_volume.geometry.mask_mode = 1;
        else if (strcmp(mask_setting,"ANY") == 0 || strcmp(mask_setting,"Any") == 0) this_box_volume.geometry.mask_mode = 2;
        else {
            printf("The mask_mode of component %s is set to %s, but must be either ALL or ANY.\n",NAME_CURRENT_COMP,mask_setting);
            exit(1);
        }
    }
    
    for (loop_index=0;loop_index<global_geometry_list.num_elements;loop_index++) {
        // Add mask list
        if (1 == manual_linking_function(global_geometry_list.elements[loop_index].name,mask_string)) {
            add_element_to_int_list(&this_box_volume.geometry.mask_list,global_geometry_list.elements[loop_index].component_index);
            add_element_to_int_list(&global_geometry_list.elements[loop_index].Volume->geometry.masked_by_list,INDEX_CURRENT_COMP);
            global_geometry_list.elements[loop_index].Volume->geometry.is_masked_volume = 1;
            if (this_box_volume.geometry.mask_mode == 2)
                global_geometry_list.elements[loop_index].Volume->geometry.mask_mode = 2;
            if (this_box_volume.geometry.mask_mode == 1) {
                if (global_geometry_list.elements[loop_index].Volume->geometry.is_masked_volume == 1 && global_geometry_list.elements[loop_index].Volume->geometry.mask_mode != 2)
                    // If more than one mask is added to one volume, the ANY mode overwrites the (default) ALL mode.
                    global_geometry_list.elements[loop_index].Volume->geometry.mask_mode = 1;
            }
            
            found_geometries = 1;
        }
    }
    if (found_geometries == 0) {
        printf("The mask_string in geometry: %s did not find any of the specified volumes in the mask_string %s \n",NAME_CURRENT_COMP,mask_string);
        exit(1);
    }
    this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
    this_box_volume.p_physics->is_vacuum = 0; // Makes this volume a vacuum
    this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
    this_box_volume.p_physics->my_a = 0; // Should not be used.
    sprintf(this_box_volume.p_physics->name,"Mask");
    this_box_volume.geometry.is_mask_volume = 1;
    
    
// Read the material input, or if it lacks, use automatic linking.
} else if (material_string && strlen(material_string) && strcmp(material_string, "NULL") && strcmp(material_string, "0")) {
    // A geometry string was given, use it to determine which material
    if (0 == strcmp(material_string,"vacuum") || 0 == strcmp(material_string,"Vacuum")) {
        // One could have a global physics struct for vacuum instead of creating one for each
        this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
        this_box_volume.p_physics->is_vacuum = 1; // Makes this volume a vacuum
        this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
        this_box_volume.p_physics->my_a = 0; // Should not be used.
        sprintf(this_box_volume.p_physics->name,"Vacuum");
    } else if (0 == strcmp(material_string,"exit") || 0 == strcmp(material_string,"Exit")) {
        // One could have a global physics struct for vacuum instead of creating one for each
        this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
        this_box_volume.p_physics->is_vacuum = 1; // Makes this volume a vacuum
        this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
        this_box_volume.p_physics->my_a = 0; // Should not be used.
        this_box_volume.geometry.is_exit_volume = 1;
        sprintf(this_box_volume.p_physics->name,"Exit");
    } else {
        #ifndef MATERIAL_DETECTOR
            printf("Need to define a material before refering to it in a geometry %s.\n",NAME_CURRENT_COMP);
            exit(1);
        #endif
        for (loop_index=0;loop_index<global_material_list.num_elements;loop_index++) {
            if (0 == strcmp(material_string,global_material_list.elements[loop_index].name)) {
                this_box_volume.p_physics = global_material_list.elements[loop_index].physics;
                break;
            }
            if (loop_index == global_material_list.num_elements-1) {
            printf("\n");
            printf("ERROR: The material string \"%s\" in Union geometry \"%s\" did not match a specified material. \n",material_string,NAME_CURRENT_COMP);
            printf("       The materials available at this point (need to be defined before the geometry): \n");
            for (loop_index=0;loop_index<global_material_list.num_elements;loop_index++)
              printf("         %s\n",global_material_list.elements[loop_index].name);
            printf("\n");
            printf("       It is also possible to use one of the defualt materials avaiable: \n");
            printf("           Vacuum (for a Volume without scattering or absorption)\n");
            printf("           Exit (for a Volume where the ray exits the component if it enters)\n");
            printf("           Mask (for a Volume that masks existing volumes specified in the mask_string\n");
            exit(1);
          }
        }
    }
} else {
    // Automatic linking, simply using the last defined material.
    #ifndef MATERIAL_DETECTOR
        printf("Need to define a material before the geometry to use automatic linking %s.\n",NAME_CURRENT_COMP);
        exit(1);
    #endif
    this_box_volume.p_physics = global_material_list.elements[global_material_list.num_elements-1].physics;
}

sprintf(this_box_volume.name,NAME_CURRENT_COMP);
sprintf(this_box_volume.geometry.shape,"box");
this_box_volume.geometry.priority_value = priority;
this_box_volume.geometry.geometry_p_interact = p_interact;
// Currently the coordinates will be in absolute space.
this_box_volume.geometry.center = POS_A_CURRENT_COMP;

this_box_storage.z_depth = zdepth;
this_box_storage.x_width1 = xwidth;
this_box_storage.y_height1 = yheight;

this_box_storage.is_rectangle = 0;
if (xwidth2 < 0 && yheight2 < 0) this_box_storage.is_rectangle = 1;
if (xwidth == xwidth2 && yheight == yheight2) this_box_storage.is_rectangle = 1;

if (xwidth2 < 0) {
    this_box_storage.x_width2 = xwidth;
    xwidth2 = xwidth;
} else this_box_storage.x_width2 = xwidth2;

if (yheight2 < 0) {
    this_box_storage.y_height2 = yheight;
    yheight2 = yheight;
} else this_box_storage.y_height2 = yheight2;


this_box_storage.normal_vectors[0] = coords_set(0,0,1);
this_box_storage.normal_vectors[1] = coords_set(0,0,1);

// for sides with y component = 0
x_component = 2*zdepth/sqrt((xwidth-xwidth2)*(xwidth-xwidth2)+4*zdepth*zdepth);
z_component = (xwidth-xwidth2)/sqrt(4*zdepth*zdepth+(xwidth-xwidth2)*(xwidth-xwidth2));

this_box_storage.normal_vectors[2] = coords_set(x_component,0,z_component);
this_box_storage.normal_vectors[3] = coords_set(-x_component,0,z_component);

// for sides with x component = 0
y_component = 2*zdepth/sqrt((yheight-yheight2)*(yheight-yheight2)+4*zdepth*zdepth);
z_component = (yheight-yheight2)/sqrt(4*zdepth*zdepth+(yheight-yheight2)*(yheight-yheight2));

this_box_storage.normal_vectors[4] = coords_set(0,y_component,z_component);
this_box_storage.normal_vectors[5] = coords_set(0,-y_component,z_component);

this_box_volume.geometry.visualization_on = visualize;

this_box_volume.geometry.geometry_parameters.p_box_storage = &this_box_storage;

// Assign pointers to functions for intersection with the shape, checking if a point is inside the shape
if (this_box_storage.is_rectangle == 1) {
this_box_volume.geometry.intersect_function = &sample_box_intersect_simple;
this_box_volume.geometry.within_function = &r_within_box_simple;
}
else {
this_box_volume.geometry.intersect_function = &sample_box_intersect_advanced;
this_box_volume.geometry.within_function = &r_within_box_advanced;
}

this_box_volume.geometry.shell_points = &box_shell_points;
this_box_volume.geometry.mcdisplay_function = &mcdisplay_box_function;
this_box_volume.geometry.initialize_from_main_function = &initialize_box_geometry_from_main_component;
this_box_volume.geometry.process_rot_allocated = 0;

this_box_volume.geometry.copy_geometry_parameters = &allocate_box_storage_copy;

rot_copy(this_box_volume.geometry.rotation_matrix,ROT_A_CURRENT_COMP); //check how ROT_R_CURRENT_COMP would work
rot_transpose(ROT_A_CURRENT_COMP,this_box_volume.geometry.transpose_rotation_matrix);

// Initialize loggers
this_box_volume.loggers.num_elements = 0;

// packing the information into the global_geometry_element, which is then included in the global_geometry_list.
sprintf(global_geometry_element.name,NAME_CURRENT_COMP);
global_geometry_element.activation_counter = number_of_activations;
global_geometry_element.component_index = INDEX_CURRENT_COMP;
global_geometry_element.Volume = &this_box_volume; // Would be nicer if this m was a pointer, now we have the (small) data two places
add_element_to_geometry_list(&global_geometry_list,global_geometry_element);
}
#line 292913 "MACS_sample_kidney_box.c"
#undef number_of_activations
#undef mask_setting
#undef mask_string
#undef p_interact
#undef focus_r
#undef focus_xh
#undef focus_xw
#undef focus_ah
#undef focus_aw
#undef target_z
#undef target_y
#undef target_x
#undef target_index
#undef visualize
#undef yheight2
#undef xwidth2
#undef zdepth
#undef yheight
#undef xwidth
#undef priority
#undef material_string
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

  /* Initializations for component channel_14_analyzer_2_array_crystal_array_6. */
  SIG_MESSAGE("channel_14_analyzer_2_array_crystal_array_6 (Init)");
#define mccompcurname  channel_14_analyzer_2_array_crystal_array_6
#define mccompcurtype  Union_box
#define mccompcurindex 679
#define loop_index mccchannel_14_analyzer_2_array_crystal_array_6_loop_index
#define this_box_volume mccchannel_14_analyzer_2_array_crystal_array_6_this_box_volume
#define global_geometry_element mccchannel_14_analyzer_2_array_crystal_array_6_global_geometry_element
#define this_box_storage mccchannel_14_analyzer_2_array_crystal_array_6_this_box_storage
#define material_string mccchannel_14_analyzer_2_array_crystal_array_6_material_string
#define priority mccchannel_14_analyzer_2_array_crystal_array_6_priority
#define xwidth mccchannel_14_analyzer_2_array_crystal_array_6_xwidth
#define yheight mccchannel_14_analyzer_2_array_crystal_array_6_yheight
#define zdepth mccchannel_14_analyzer_2_array_crystal_array_6_zdepth
#define xwidth2 mccchannel_14_analyzer_2_array_crystal_array_6_xwidth2
#define yheight2 mccchannel_14_analyzer_2_array_crystal_array_6_yheight2
#define visualize mccchannel_14_analyzer_2_array_crystal_array_6_visualize
#define target_index mccchannel_14_analyzer_2_array_crystal_array_6_target_index
#define target_x mccchannel_14_analyzer_2_array_crystal_array_6_target_x
#define target_y mccchannel_14_analyzer_2_array_crystal_array_6_target_y
#define target_z mccchannel_14_analyzer_2_array_crystal_array_6_target_z
#define focus_aw mccchannel_14_analyzer_2_array_crystal_array_6_focus_aw
#define focus_ah mccchannel_14_analyzer_2_array_crystal_array_6_focus_ah
#define focus_xw mccchannel_14_analyzer_2_array_crystal_array_6_focus_xw
#define focus_xh mccchannel_14_analyzer_2_array_crystal_array_6_focus_xh
#define focus_r mccchannel_14_analyzer_2_array_crystal_array_6_focus_r
#define p_interact mccchannel_14_analyzer_2_array_crystal_array_6_p_interact
#define mask_string mccchannel_14_analyzer_2_array_crystal_array_6_mask_string
#define mask_setting mccchannel_14_analyzer_2_array_crystal_array_6_mask_setting
#define number_of_activations mccchannel_14_analyzer_2_array_crystal_array_6_number_of_activations
#line 224 "Union_box.comp"
{
// Initializes the focusing system for this volume including input sanitation.
focus_initialize(&this_box_volume.geometry, POS_A_COMP_INDEX(INDEX_CURRENT_COMP+target_index), POS_A_CURRENT_COMP, ROT_A_CURRENT_COMP, target_index, target_x, target_y, target_z, focus_aw, focus_ah, focus_xw, focus_xh, focus_r, NAME_CURRENT_COMP);

// Input sanitation for this geometry
if (xwidth <= 0) {
  printf("\nERROR in Union_box named %s, the xwidth is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (yheight <= 0) {
  printf("\nERROR in Union_box named %s, yheight is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (zdepth <= 0) {
  printf("\nERROR in Union_box named %s, zdepth is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (xwidth2 <= 0 && xwidth2 != -1) {
  printf("\nERROR in Union_box named %s, the xwidth2 is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (yheight2 <= 0 && yheight2 != -1) {
  printf("\nERROR in Union_box named %s, yheight2 is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}

// Use sanitation
if (global_material_list.num_elements == 0) {
  printf("\nERROR: Need to define a material using Union_make_material before using a Union geometry component. \n");
  printf("       %s was defined before first use of Union_make_material.\n",NAME_CURRENT_COMP);
  exit(1);
}

this_box_volume.geometry.is_masked_volume = 0;
this_box_volume.geometry.is_exit_volume = 0;
this_box_volume.geometry.is_mask_volume = 0;
// check if the volume is a mask, if it is the material string is irelevant.
if (mask_string && strlen(mask_string) && strcmp(mask_string, "NULL") && strcmp(mask_string, "0")) {
    // A mask volume is used to limit the extend of other volumes, called the masked volumes. These are specified in the mask_string.
    // In order for a ray to enter a masked volume, it needs to be both in the region covered by that volume AND the mask volume.
    // When more than
    this_box_volume.geometry.mask_mode = 1; // Default is mask mode is ALL
    if (mask_setting && strlen(mask_setting) && strcmp(mask_setting, "NULL") && strcmp(mask_setting, "0")) {
        if (strcmp(mask_setting,"ALL") == 0 || strcmp(mask_setting,"All") == 0) this_box_volume.geometry.mask_mode = 1;
        else if (strcmp(mask_setting,"ANY") == 0 || strcmp(mask_setting,"Any") == 0) this_box_volume.geometry.mask_mode = 2;
        else {
            printf("The mask_mode of component %s is set to %s, but must be either ALL or ANY.\n",NAME_CURRENT_COMP,mask_setting);
            exit(1);
        }
    }
    
    for (loop_index=0;loop_index<global_geometry_list.num_elements;loop_index++) {
        // Add mask list
        if (1 == manual_linking_function(global_geometry_list.elements[loop_index].name,mask_string)) {
            add_element_to_int_list(&this_box_volume.geometry.mask_list,global_geometry_list.elements[loop_index].component_index);
            add_element_to_int_list(&global_geometry_list.elements[loop_index].Volume->geometry.masked_by_list,INDEX_CURRENT_COMP);
            global_geometry_list.elements[loop_index].Volume->geometry.is_masked_volume = 1;
            if (this_box_volume.geometry.mask_mode == 2)
                global_geometry_list.elements[loop_index].Volume->geometry.mask_mode = 2;
            if (this_box_volume.geometry.mask_mode == 1) {
                if (global_geometry_list.elements[loop_index].Volume->geometry.is_masked_volume == 1 && global_geometry_list.elements[loop_index].Volume->geometry.mask_mode != 2)
                    // If more than one mask is added to one volume, the ANY mode overwrites the (default) ALL mode.
                    global_geometry_list.elements[loop_index].Volume->geometry.mask_mode = 1;
            }
            
            found_geometries = 1;
        }
    }
    if (found_geometries == 0) {
        printf("The mask_string in geometry: %s did not find any of the specified volumes in the mask_string %s \n",NAME_CURRENT_COMP,mask_string);
        exit(1);
    }
    this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
    this_box_volume.p_physics->is_vacuum = 0; // Makes this volume a vacuum
    this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
    this_box_volume.p_physics->my_a = 0; // Should not be used.
    sprintf(this_box_volume.p_physics->name,"Mask");
    this_box_volume.geometry.is_mask_volume = 1;
    
    
// Read the material input, or if it lacks, use automatic linking.
} else if (material_string && strlen(material_string) && strcmp(material_string, "NULL") && strcmp(material_string, "0")) {
    // A geometry string was given, use it to determine which material
    if (0 == strcmp(material_string,"vacuum") || 0 == strcmp(material_string,"Vacuum")) {
        // One could have a global physics struct for vacuum instead of creating one for each
        this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
        this_box_volume.p_physics->is_vacuum = 1; // Makes this volume a vacuum
        this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
        this_box_volume.p_physics->my_a = 0; // Should not be used.
        sprintf(this_box_volume.p_physics->name,"Vacuum");
    } else if (0 == strcmp(material_string,"exit") || 0 == strcmp(material_string,"Exit")) {
        // One could have a global physics struct for vacuum instead of creating one for each
        this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
        this_box_volume.p_physics->is_vacuum = 1; // Makes this volume a vacuum
        this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
        this_box_volume.p_physics->my_a = 0; // Should not be used.
        this_box_volume.geometry.is_exit_volume = 1;
        sprintf(this_box_volume.p_physics->name,"Exit");
    } else {
        #ifndef MATERIAL_DETECTOR
            printf("Need to define a material before refering to it in a geometry %s.\n",NAME_CURRENT_COMP);
            exit(1);
        #endif
        for (loop_index=0;loop_index<global_material_list.num_elements;loop_index++) {
            if (0 == strcmp(material_string,global_material_list.elements[loop_index].name)) {
                this_box_volume.p_physics = global_material_list.elements[loop_index].physics;
                break;
            }
            if (loop_index == global_material_list.num_elements-1) {
            printf("\n");
            printf("ERROR: The material string \"%s\" in Union geometry \"%s\" did not match a specified material. \n",material_string,NAME_CURRENT_COMP);
            printf("       The materials available at this point (need to be defined before the geometry): \n");
            for (loop_index=0;loop_index<global_material_list.num_elements;loop_index++)
              printf("         %s\n",global_material_list.elements[loop_index].name);
            printf("\n");
            printf("       It is also possible to use one of the defualt materials avaiable: \n");
            printf("           Vacuum (for a Volume without scattering or absorption)\n");
            printf("           Exit (for a Volume where the ray exits the component if it enters)\n");
            printf("           Mask (for a Volume that masks existing volumes specified in the mask_string\n");
            exit(1);
          }
        }
    }
} else {
    // Automatic linking, simply using the last defined material.
    #ifndef MATERIAL_DETECTOR
        printf("Need to define a material before the geometry to use automatic linking %s.\n",NAME_CURRENT_COMP);
        exit(1);
    #endif
    this_box_volume.p_physics = global_material_list.elements[global_material_list.num_elements-1].physics;
}

sprintf(this_box_volume.name,NAME_CURRENT_COMP);
sprintf(this_box_volume.geometry.shape,"box");
this_box_volume.geometry.priority_value = priority;
this_box_volume.geometry.geometry_p_interact = p_interact;
// Currently the coordinates will be in absolute space.
this_box_volume.geometry.center = POS_A_CURRENT_COMP;

this_box_storage.z_depth = zdepth;
this_box_storage.x_width1 = xwidth;
this_box_storage.y_height1 = yheight;

this_box_storage.is_rectangle = 0;
if (xwidth2 < 0 && yheight2 < 0) this_box_storage.is_rectangle = 1;
if (xwidth == xwidth2 && yheight == yheight2) this_box_storage.is_rectangle = 1;

if (xwidth2 < 0) {
    this_box_storage.x_width2 = xwidth;
    xwidth2 = xwidth;
} else this_box_storage.x_width2 = xwidth2;

if (yheight2 < 0) {
    this_box_storage.y_height2 = yheight;
    yheight2 = yheight;
} else this_box_storage.y_height2 = yheight2;


this_box_storage.normal_vectors[0] = coords_set(0,0,1);
this_box_storage.normal_vectors[1] = coords_set(0,0,1);

// for sides with y component = 0
x_component = 2*zdepth/sqrt((xwidth-xwidth2)*(xwidth-xwidth2)+4*zdepth*zdepth);
z_component = (xwidth-xwidth2)/sqrt(4*zdepth*zdepth+(xwidth-xwidth2)*(xwidth-xwidth2));

this_box_storage.normal_vectors[2] = coords_set(x_component,0,z_component);
this_box_storage.normal_vectors[3] = coords_set(-x_component,0,z_component);

// for sides with x component = 0
y_component = 2*zdepth/sqrt((yheight-yheight2)*(yheight-yheight2)+4*zdepth*zdepth);
z_component = (yheight-yheight2)/sqrt(4*zdepth*zdepth+(yheight-yheight2)*(yheight-yheight2));

this_box_storage.normal_vectors[4] = coords_set(0,y_component,z_component);
this_box_storage.normal_vectors[5] = coords_set(0,-y_component,z_component);

this_box_volume.geometry.visualization_on = visualize;

this_box_volume.geometry.geometry_parameters.p_box_storage = &this_box_storage;

// Assign pointers to functions for intersection with the shape, checking if a point is inside the shape
if (this_box_storage.is_rectangle == 1) {
this_box_volume.geometry.intersect_function = &sample_box_intersect_simple;
this_box_volume.geometry.within_function = &r_within_box_simple;
}
else {
this_box_volume.geometry.intersect_function = &sample_box_intersect_advanced;
this_box_volume.geometry.within_function = &r_within_box_advanced;
}

this_box_volume.geometry.shell_points = &box_shell_points;
this_box_volume.geometry.mcdisplay_function = &mcdisplay_box_function;
this_box_volume.geometry.initialize_from_main_function = &initialize_box_geometry_from_main_component;
this_box_volume.geometry.process_rot_allocated = 0;

this_box_volume.geometry.copy_geometry_parameters = &allocate_box_storage_copy;

rot_copy(this_box_volume.geometry.rotation_matrix,ROT_A_CURRENT_COMP); //check how ROT_R_CURRENT_COMP would work
rot_transpose(ROT_A_CURRENT_COMP,this_box_volume.geometry.transpose_rotation_matrix);

// Initialize loggers
this_box_volume.loggers.num_elements = 0;

// packing the information into the global_geometry_element, which is then included in the global_geometry_list.
sprintf(global_geometry_element.name,NAME_CURRENT_COMP);
global_geometry_element.activation_counter = number_of_activations;
global_geometry_element.component_index = INDEX_CURRENT_COMP;
global_geometry_element.Volume = &this_box_volume; // Would be nicer if this m was a pointer, now we have the (small) data two places
add_element_to_geometry_list(&global_geometry_list,global_geometry_element);
}
#line 293183 "MACS_sample_kidney_box.c"
#undef number_of_activations
#undef mask_setting
#undef mask_string
#undef p_interact
#undef focus_r
#undef focus_xh
#undef focus_xw
#undef focus_ah
#undef focus_aw
#undef target_z
#undef target_y
#undef target_x
#undef target_index
#undef visualize
#undef yheight2
#undef xwidth2
#undef zdepth
#undef yheight
#undef xwidth
#undef priority
#undef material_string
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

  /* Initializations for component channel_14_analyzer_2_array_crystal_array_7. */
  SIG_MESSAGE("channel_14_analyzer_2_array_crystal_array_7 (Init)");
#define mccompcurname  channel_14_analyzer_2_array_crystal_array_7
#define mccompcurtype  Union_box
#define mccompcurindex 680
#define loop_index mccchannel_14_analyzer_2_array_crystal_array_7_loop_index
#define this_box_volume mccchannel_14_analyzer_2_array_crystal_array_7_this_box_volume
#define global_geometry_element mccchannel_14_analyzer_2_array_crystal_array_7_global_geometry_element
#define this_box_storage mccchannel_14_analyzer_2_array_crystal_array_7_this_box_storage
#define material_string mccchannel_14_analyzer_2_array_crystal_array_7_material_string
#define priority mccchannel_14_analyzer_2_array_crystal_array_7_priority
#define xwidth mccchannel_14_analyzer_2_array_crystal_array_7_xwidth
#define yheight mccchannel_14_analyzer_2_array_crystal_array_7_yheight
#define zdepth mccchannel_14_analyzer_2_array_crystal_array_7_zdepth
#define xwidth2 mccchannel_14_analyzer_2_array_crystal_array_7_xwidth2
#define yheight2 mccchannel_14_analyzer_2_array_crystal_array_7_yheight2
#define visualize mccchannel_14_analyzer_2_array_crystal_array_7_visualize
#define target_index mccchannel_14_analyzer_2_array_crystal_array_7_target_index
#define target_x mccchannel_14_analyzer_2_array_crystal_array_7_target_x
#define target_y mccchannel_14_analyzer_2_array_crystal_array_7_target_y
#define target_z mccchannel_14_analyzer_2_array_crystal_array_7_target_z
#define focus_aw mccchannel_14_analyzer_2_array_crystal_array_7_focus_aw
#define focus_ah mccchannel_14_analyzer_2_array_crystal_array_7_focus_ah
#define focus_xw mccchannel_14_analyzer_2_array_crystal_array_7_focus_xw
#define focus_xh mccchannel_14_analyzer_2_array_crystal_array_7_focus_xh
#define focus_r mccchannel_14_analyzer_2_array_crystal_array_7_focus_r
#define p_interact mccchannel_14_analyzer_2_array_crystal_array_7_p_interact
#define mask_string mccchannel_14_analyzer_2_array_crystal_array_7_mask_string
#define mask_setting mccchannel_14_analyzer_2_array_crystal_array_7_mask_setting
#define number_of_activations mccchannel_14_analyzer_2_array_crystal_array_7_number_of_activations
#line 224 "Union_box.comp"
{
// Initializes the focusing system for this volume including input sanitation.
focus_initialize(&this_box_volume.geometry, POS_A_COMP_INDEX(INDEX_CURRENT_COMP+target_index), POS_A_CURRENT_COMP, ROT_A_CURRENT_COMP, target_index, target_x, target_y, target_z, focus_aw, focus_ah, focus_xw, focus_xh, focus_r, NAME_CURRENT_COMP);

// Input sanitation for this geometry
if (xwidth <= 0) {
  printf("\nERROR in Union_box named %s, the xwidth is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (yheight <= 0) {
  printf("\nERROR in Union_box named %s, yheight is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (zdepth <= 0) {
  printf("\nERROR in Union_box named %s, zdepth is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (xwidth2 <= 0 && xwidth2 != -1) {
  printf("\nERROR in Union_box named %s, the xwidth2 is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (yheight2 <= 0 && yheight2 != -1) {
  printf("\nERROR in Union_box named %s, yheight2 is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}

// Use sanitation
if (global_material_list.num_elements == 0) {
  printf("\nERROR: Need to define a material using Union_make_material before using a Union geometry component. \n");
  printf("       %s was defined before first use of Union_make_material.\n",NAME_CURRENT_COMP);
  exit(1);
}

this_box_volume.geometry.is_masked_volume = 0;
this_box_volume.geometry.is_exit_volume = 0;
this_box_volume.geometry.is_mask_volume = 0;
// check if the volume is a mask, if it is the material string is irelevant.
if (mask_string && strlen(mask_string) && strcmp(mask_string, "NULL") && strcmp(mask_string, "0")) {
    // A mask volume is used to limit the extend of other volumes, called the masked volumes. These are specified in the mask_string.
    // In order for a ray to enter a masked volume, it needs to be both in the region covered by that volume AND the mask volume.
    // When more than
    this_box_volume.geometry.mask_mode = 1; // Default is mask mode is ALL
    if (mask_setting && strlen(mask_setting) && strcmp(mask_setting, "NULL") && strcmp(mask_setting, "0")) {
        if (strcmp(mask_setting,"ALL") == 0 || strcmp(mask_setting,"All") == 0) this_box_volume.geometry.mask_mode = 1;
        else if (strcmp(mask_setting,"ANY") == 0 || strcmp(mask_setting,"Any") == 0) this_box_volume.geometry.mask_mode = 2;
        else {
            printf("The mask_mode of component %s is set to %s, but must be either ALL or ANY.\n",NAME_CURRENT_COMP,mask_setting);
            exit(1);
        }
    }
    
    for (loop_index=0;loop_index<global_geometry_list.num_elements;loop_index++) {
        // Add mask list
        if (1 == manual_linking_function(global_geometry_list.elements[loop_index].name,mask_string)) {
            add_element_to_int_list(&this_box_volume.geometry.mask_list,global_geometry_list.elements[loop_index].component_index);
            add_element_to_int_list(&global_geometry_list.elements[loop_index].Volume->geometry.masked_by_list,INDEX_CURRENT_COMP);
            global_geometry_list.elements[loop_index].Volume->geometry.is_masked_volume = 1;
            if (this_box_volume.geometry.mask_mode == 2)
                global_geometry_list.elements[loop_index].Volume->geometry.mask_mode = 2;
            if (this_box_volume.geometry.mask_mode == 1) {
                if (global_geometry_list.elements[loop_index].Volume->geometry.is_masked_volume == 1 && global_geometry_list.elements[loop_index].Volume->geometry.mask_mode != 2)
                    // If more than one mask is added to one volume, the ANY mode overwrites the (default) ALL mode.
                    global_geometry_list.elements[loop_index].Volume->geometry.mask_mode = 1;
            }
            
            found_geometries = 1;
        }
    }
    if (found_geometries == 0) {
        printf("The mask_string in geometry: %s did not find any of the specified volumes in the mask_string %s \n",NAME_CURRENT_COMP,mask_string);
        exit(1);
    }
    this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
    this_box_volume.p_physics->is_vacuum = 0; // Makes this volume a vacuum
    this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
    this_box_volume.p_physics->my_a = 0; // Should not be used.
    sprintf(this_box_volume.p_physics->name,"Mask");
    this_box_volume.geometry.is_mask_volume = 1;
    
    
// Read the material input, or if it lacks, use automatic linking.
} else if (material_string && strlen(material_string) && strcmp(material_string, "NULL") && strcmp(material_string, "0")) {
    // A geometry string was given, use it to determine which material
    if (0 == strcmp(material_string,"vacuum") || 0 == strcmp(material_string,"Vacuum")) {
        // One could have a global physics struct for vacuum instead of creating one for each
        this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
        this_box_volume.p_physics->is_vacuum = 1; // Makes this volume a vacuum
        this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
        this_box_volume.p_physics->my_a = 0; // Should not be used.
        sprintf(this_box_volume.p_physics->name,"Vacuum");
    } else if (0 == strcmp(material_string,"exit") || 0 == strcmp(material_string,"Exit")) {
        // One could have a global physics struct for vacuum instead of creating one for each
        this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
        this_box_volume.p_physics->is_vacuum = 1; // Makes this volume a vacuum
        this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
        this_box_volume.p_physics->my_a = 0; // Should not be used.
        this_box_volume.geometry.is_exit_volume = 1;
        sprintf(this_box_volume.p_physics->name,"Exit");
    } else {
        #ifndef MATERIAL_DETECTOR
            printf("Need to define a material before refering to it in a geometry %s.\n",NAME_CURRENT_COMP);
            exit(1);
        #endif
        for (loop_index=0;loop_index<global_material_list.num_elements;loop_index++) {
            if (0 == strcmp(material_string,global_material_list.elements[loop_index].name)) {
                this_box_volume.p_physics = global_material_list.elements[loop_index].physics;
                break;
            }
            if (loop_index == global_material_list.num_elements-1) {
            printf("\n");
            printf("ERROR: The material string \"%s\" in Union geometry \"%s\" did not match a specified material. \n",material_string,NAME_CURRENT_COMP);
            printf("       The materials available at this point (need to be defined before the geometry): \n");
            for (loop_index=0;loop_index<global_material_list.num_elements;loop_index++)
              printf("         %s\n",global_material_list.elements[loop_index].name);
            printf("\n");
            printf("       It is also possible to use one of the defualt materials avaiable: \n");
            printf("           Vacuum (for a Volume without scattering or absorption)\n");
            printf("           Exit (for a Volume where the ray exits the component if it enters)\n");
            printf("           Mask (for a Volume that masks existing volumes specified in the mask_string\n");
            exit(1);
          }
        }
    }
} else {
    // Automatic linking, simply using the last defined material.
    #ifndef MATERIAL_DETECTOR
        printf("Need to define a material before the geometry to use automatic linking %s.\n",NAME_CURRENT_COMP);
        exit(1);
    #endif
    this_box_volume.p_physics = global_material_list.elements[global_material_list.num_elements-1].physics;
}

sprintf(this_box_volume.name,NAME_CURRENT_COMP);
sprintf(this_box_volume.geometry.shape,"box");
this_box_volume.geometry.priority_value = priority;
this_box_volume.geometry.geometry_p_interact = p_interact;
// Currently the coordinates will be in absolute space.
this_box_volume.geometry.center = POS_A_CURRENT_COMP;

this_box_storage.z_depth = zdepth;
this_box_storage.x_width1 = xwidth;
this_box_storage.y_height1 = yheight;

this_box_storage.is_rectangle = 0;
if (xwidth2 < 0 && yheight2 < 0) this_box_storage.is_rectangle = 1;
if (xwidth == xwidth2 && yheight == yheight2) this_box_storage.is_rectangle = 1;

if (xwidth2 < 0) {
    this_box_storage.x_width2 = xwidth;
    xwidth2 = xwidth;
} else this_box_storage.x_width2 = xwidth2;

if (yheight2 < 0) {
    this_box_storage.y_height2 = yheight;
    yheight2 = yheight;
} else this_box_storage.y_height2 = yheight2;


this_box_storage.normal_vectors[0] = coords_set(0,0,1);
this_box_storage.normal_vectors[1] = coords_set(0,0,1);

// for sides with y component = 0
x_component = 2*zdepth/sqrt((xwidth-xwidth2)*(xwidth-xwidth2)+4*zdepth*zdepth);
z_component = (xwidth-xwidth2)/sqrt(4*zdepth*zdepth+(xwidth-xwidth2)*(xwidth-xwidth2));

this_box_storage.normal_vectors[2] = coords_set(x_component,0,z_component);
this_box_storage.normal_vectors[3] = coords_set(-x_component,0,z_component);

// for sides with x component = 0
y_component = 2*zdepth/sqrt((yheight-yheight2)*(yheight-yheight2)+4*zdepth*zdepth);
z_component = (yheight-yheight2)/sqrt(4*zdepth*zdepth+(yheight-yheight2)*(yheight-yheight2));

this_box_storage.normal_vectors[4] = coords_set(0,y_component,z_component);
this_box_storage.normal_vectors[5] = coords_set(0,-y_component,z_component);

this_box_volume.geometry.visualization_on = visualize;

this_box_volume.geometry.geometry_parameters.p_box_storage = &this_box_storage;

// Assign pointers to functions for intersection with the shape, checking if a point is inside the shape
if (this_box_storage.is_rectangle == 1) {
this_box_volume.geometry.intersect_function = &sample_box_intersect_simple;
this_box_volume.geometry.within_function = &r_within_box_simple;
}
else {
this_box_volume.geometry.intersect_function = &sample_box_intersect_advanced;
this_box_volume.geometry.within_function = &r_within_box_advanced;
}

this_box_volume.geometry.shell_points = &box_shell_points;
this_box_volume.geometry.mcdisplay_function = &mcdisplay_box_function;
this_box_volume.geometry.initialize_from_main_function = &initialize_box_geometry_from_main_component;
this_box_volume.geometry.process_rot_allocated = 0;

this_box_volume.geometry.copy_geometry_parameters = &allocate_box_storage_copy;

rot_copy(this_box_volume.geometry.rotation_matrix,ROT_A_CURRENT_COMP); //check how ROT_R_CURRENT_COMP would work
rot_transpose(ROT_A_CURRENT_COMP,this_box_volume.geometry.transpose_rotation_matrix);

// Initialize loggers
this_box_volume.loggers.num_elements = 0;

// packing the information into the global_geometry_element, which is then included in the global_geometry_list.
sprintf(global_geometry_element.name,NAME_CURRENT_COMP);
global_geometry_element.activation_counter = number_of_activations;
global_geometry_element.component_index = INDEX_CURRENT_COMP;
global_geometry_element.Volume = &this_box_volume; // Would be nicer if this m was a pointer, now we have the (small) data two places
add_element_to_geometry_list(&global_geometry_list,global_geometry_element);
}
#line 293453 "MACS_sample_kidney_box.c"
#undef number_of_activations
#undef mask_setting
#undef mask_string
#undef p_interact
#undef focus_r
#undef focus_xh
#undef focus_xw
#undef focus_ah
#undef focus_aw
#undef target_z
#undef target_y
#undef target_x
#undef target_index
#undef visualize
#undef yheight2
#undef xwidth2
#undef zdepth
#undef yheight
#undef xwidth
#undef priority
#undef material_string
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

  /* Initializations for component channel_14_analyzer_2_array_crystal_array_8. */
  SIG_MESSAGE("channel_14_analyzer_2_array_crystal_array_8 (Init)");
#define mccompcurname  channel_14_analyzer_2_array_crystal_array_8
#define mccompcurtype  Union_box
#define mccompcurindex 681
#define loop_index mccchannel_14_analyzer_2_array_crystal_array_8_loop_index
#define this_box_volume mccchannel_14_analyzer_2_array_crystal_array_8_this_box_volume
#define global_geometry_element mccchannel_14_analyzer_2_array_crystal_array_8_global_geometry_element
#define this_box_storage mccchannel_14_analyzer_2_array_crystal_array_8_this_box_storage
#define material_string mccchannel_14_analyzer_2_array_crystal_array_8_material_string
#define priority mccchannel_14_analyzer_2_array_crystal_array_8_priority
#define xwidth mccchannel_14_analyzer_2_array_crystal_array_8_xwidth
#define yheight mccchannel_14_analyzer_2_array_crystal_array_8_yheight
#define zdepth mccchannel_14_analyzer_2_array_crystal_array_8_zdepth
#define xwidth2 mccchannel_14_analyzer_2_array_crystal_array_8_xwidth2
#define yheight2 mccchannel_14_analyzer_2_array_crystal_array_8_yheight2
#define visualize mccchannel_14_analyzer_2_array_crystal_array_8_visualize
#define target_index mccchannel_14_analyzer_2_array_crystal_array_8_target_index
#define target_x mccchannel_14_analyzer_2_array_crystal_array_8_target_x
#define target_y mccchannel_14_analyzer_2_array_crystal_array_8_target_y
#define target_z mccchannel_14_analyzer_2_array_crystal_array_8_target_z
#define focus_aw mccchannel_14_analyzer_2_array_crystal_array_8_focus_aw
#define focus_ah mccchannel_14_analyzer_2_array_crystal_array_8_focus_ah
#define focus_xw mccchannel_14_analyzer_2_array_crystal_array_8_focus_xw
#define focus_xh mccchannel_14_analyzer_2_array_crystal_array_8_focus_xh
#define focus_r mccchannel_14_analyzer_2_array_crystal_array_8_focus_r
#define p_interact mccchannel_14_analyzer_2_array_crystal_array_8_p_interact
#define mask_string mccchannel_14_analyzer_2_array_crystal_array_8_mask_string
#define mask_setting mccchannel_14_analyzer_2_array_crystal_array_8_mask_setting
#define number_of_activations mccchannel_14_analyzer_2_array_crystal_array_8_number_of_activations
#line 224 "Union_box.comp"
{
// Initializes the focusing system for this volume including input sanitation.
focus_initialize(&this_box_volume.geometry, POS_A_COMP_INDEX(INDEX_CURRENT_COMP+target_index), POS_A_CURRENT_COMP, ROT_A_CURRENT_COMP, target_index, target_x, target_y, target_z, focus_aw, focus_ah, focus_xw, focus_xh, focus_r, NAME_CURRENT_COMP);

// Input sanitation for this geometry
if (xwidth <= 0) {
  printf("\nERROR in Union_box named %s, the xwidth is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (yheight <= 0) {
  printf("\nERROR in Union_box named %s, yheight is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (zdepth <= 0) {
  printf("\nERROR in Union_box named %s, zdepth is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (xwidth2 <= 0 && xwidth2 != -1) {
  printf("\nERROR in Union_box named %s, the xwidth2 is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (yheight2 <= 0 && yheight2 != -1) {
  printf("\nERROR in Union_box named %s, yheight2 is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}

// Use sanitation
if (global_material_list.num_elements == 0) {
  printf("\nERROR: Need to define a material using Union_make_material before using a Union geometry component. \n");
  printf("       %s was defined before first use of Union_make_material.\n",NAME_CURRENT_COMP);
  exit(1);
}

this_box_volume.geometry.is_masked_volume = 0;
this_box_volume.geometry.is_exit_volume = 0;
this_box_volume.geometry.is_mask_volume = 0;
// check if the volume is a mask, if it is the material string is irelevant.
if (mask_string && strlen(mask_string) && strcmp(mask_string, "NULL") && strcmp(mask_string, "0")) {
    // A mask volume is used to limit the extend of other volumes, called the masked volumes. These are specified in the mask_string.
    // In order for a ray to enter a masked volume, it needs to be both in the region covered by that volume AND the mask volume.
    // When more than
    this_box_volume.geometry.mask_mode = 1; // Default is mask mode is ALL
    if (mask_setting && strlen(mask_setting) && strcmp(mask_setting, "NULL") && strcmp(mask_setting, "0")) {
        if (strcmp(mask_setting,"ALL") == 0 || strcmp(mask_setting,"All") == 0) this_box_volume.geometry.mask_mode = 1;
        else if (strcmp(mask_setting,"ANY") == 0 || strcmp(mask_setting,"Any") == 0) this_box_volume.geometry.mask_mode = 2;
        else {
            printf("The mask_mode of component %s is set to %s, but must be either ALL or ANY.\n",NAME_CURRENT_COMP,mask_setting);
            exit(1);
        }
    }
    
    for (loop_index=0;loop_index<global_geometry_list.num_elements;loop_index++) {
        // Add mask list
        if (1 == manual_linking_function(global_geometry_list.elements[loop_index].name,mask_string)) {
            add_element_to_int_list(&this_box_volume.geometry.mask_list,global_geometry_list.elements[loop_index].component_index);
            add_element_to_int_list(&global_geometry_list.elements[loop_index].Volume->geometry.masked_by_list,INDEX_CURRENT_COMP);
            global_geometry_list.elements[loop_index].Volume->geometry.is_masked_volume = 1;
            if (this_box_volume.geometry.mask_mode == 2)
                global_geometry_list.elements[loop_index].Volume->geometry.mask_mode = 2;
            if (this_box_volume.geometry.mask_mode == 1) {
                if (global_geometry_list.elements[loop_index].Volume->geometry.is_masked_volume == 1 && global_geometry_list.elements[loop_index].Volume->geometry.mask_mode != 2)
                    // If more than one mask is added to one volume, the ANY mode overwrites the (default) ALL mode.
                    global_geometry_list.elements[loop_index].Volume->geometry.mask_mode = 1;
            }
            
            found_geometries = 1;
        }
    }
    if (found_geometries == 0) {
        printf("The mask_string in geometry: %s did not find any of the specified volumes in the mask_string %s \n",NAME_CURRENT_COMP,mask_string);
        exit(1);
    }
    this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
    this_box_volume.p_physics->is_vacuum = 0; // Makes this volume a vacuum
    this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
    this_box_volume.p_physics->my_a = 0; // Should not be used.
    sprintf(this_box_volume.p_physics->name,"Mask");
    this_box_volume.geometry.is_mask_volume = 1;
    
    
// Read the material input, or if it lacks, use automatic linking.
} else if (material_string && strlen(material_string) && strcmp(material_string, "NULL") && strcmp(material_string, "0")) {
    // A geometry string was given, use it to determine which material
    if (0 == strcmp(material_string,"vacuum") || 0 == strcmp(material_string,"Vacuum")) {
        // One could have a global physics struct for vacuum instead of creating one for each
        this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
        this_box_volume.p_physics->is_vacuum = 1; // Makes this volume a vacuum
        this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
        this_box_volume.p_physics->my_a = 0; // Should not be used.
        sprintf(this_box_volume.p_physics->name,"Vacuum");
    } else if (0 == strcmp(material_string,"exit") || 0 == strcmp(material_string,"Exit")) {
        // One could have a global physics struct for vacuum instead of creating one for each
        this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
        this_box_volume.p_physics->is_vacuum = 1; // Makes this volume a vacuum
        this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
        this_box_volume.p_physics->my_a = 0; // Should not be used.
        this_box_volume.geometry.is_exit_volume = 1;
        sprintf(this_box_volume.p_physics->name,"Exit");
    } else {
        #ifndef MATERIAL_DETECTOR
            printf("Need to define a material before refering to it in a geometry %s.\n",NAME_CURRENT_COMP);
            exit(1);
        #endif
        for (loop_index=0;loop_index<global_material_list.num_elements;loop_index++) {
            if (0 == strcmp(material_string,global_material_list.elements[loop_index].name)) {
                this_box_volume.p_physics = global_material_list.elements[loop_index].physics;
                break;
            }
            if (loop_index == global_material_list.num_elements-1) {
            printf("\n");
            printf("ERROR: The material string \"%s\" in Union geometry \"%s\" did not match a specified material. \n",material_string,NAME_CURRENT_COMP);
            printf("       The materials available at this point (need to be defined before the geometry): \n");
            for (loop_index=0;loop_index<global_material_list.num_elements;loop_index++)
              printf("         %s\n",global_material_list.elements[loop_index].name);
            printf("\n");
            printf("       It is also possible to use one of the defualt materials avaiable: \n");
            printf("           Vacuum (for a Volume without scattering or absorption)\n");
            printf("           Exit (for a Volume where the ray exits the component if it enters)\n");
            printf("           Mask (for a Volume that masks existing volumes specified in the mask_string\n");
            exit(1);
          }
        }
    }
} else {
    // Automatic linking, simply using the last defined material.
    #ifndef MATERIAL_DETECTOR
        printf("Need to define a material before the geometry to use automatic linking %s.\n",NAME_CURRENT_COMP);
        exit(1);
    #endif
    this_box_volume.p_physics = global_material_list.elements[global_material_list.num_elements-1].physics;
}

sprintf(this_box_volume.name,NAME_CURRENT_COMP);
sprintf(this_box_volume.geometry.shape,"box");
this_box_volume.geometry.priority_value = priority;
this_box_volume.geometry.geometry_p_interact = p_interact;
// Currently the coordinates will be in absolute space.
this_box_volume.geometry.center = POS_A_CURRENT_COMP;

this_box_storage.z_depth = zdepth;
this_box_storage.x_width1 = xwidth;
this_box_storage.y_height1 = yheight;

this_box_storage.is_rectangle = 0;
if (xwidth2 < 0 && yheight2 < 0) this_box_storage.is_rectangle = 1;
if (xwidth == xwidth2 && yheight == yheight2) this_box_storage.is_rectangle = 1;

if (xwidth2 < 0) {
    this_box_storage.x_width2 = xwidth;
    xwidth2 = xwidth;
} else this_box_storage.x_width2 = xwidth2;

if (yheight2 < 0) {
    this_box_storage.y_height2 = yheight;
    yheight2 = yheight;
} else this_box_storage.y_height2 = yheight2;


this_box_storage.normal_vectors[0] = coords_set(0,0,1);
this_box_storage.normal_vectors[1] = coords_set(0,0,1);

// for sides with y component = 0
x_component = 2*zdepth/sqrt((xwidth-xwidth2)*(xwidth-xwidth2)+4*zdepth*zdepth);
z_component = (xwidth-xwidth2)/sqrt(4*zdepth*zdepth+(xwidth-xwidth2)*(xwidth-xwidth2));

this_box_storage.normal_vectors[2] = coords_set(x_component,0,z_component);
this_box_storage.normal_vectors[3] = coords_set(-x_component,0,z_component);

// for sides with x component = 0
y_component = 2*zdepth/sqrt((yheight-yheight2)*(yheight-yheight2)+4*zdepth*zdepth);
z_component = (yheight-yheight2)/sqrt(4*zdepth*zdepth+(yheight-yheight2)*(yheight-yheight2));

this_box_storage.normal_vectors[4] = coords_set(0,y_component,z_component);
this_box_storage.normal_vectors[5] = coords_set(0,-y_component,z_component);

this_box_volume.geometry.visualization_on = visualize;

this_box_volume.geometry.geometry_parameters.p_box_storage = &this_box_storage;

// Assign pointers to functions for intersection with the shape, checking if a point is inside the shape
if (this_box_storage.is_rectangle == 1) {
this_box_volume.geometry.intersect_function = &sample_box_intersect_simple;
this_box_volume.geometry.within_function = &r_within_box_simple;
}
else {
this_box_volume.geometry.intersect_function = &sample_box_intersect_advanced;
this_box_volume.geometry.within_function = &r_within_box_advanced;
}

this_box_volume.geometry.shell_points = &box_shell_points;
this_box_volume.geometry.mcdisplay_function = &mcdisplay_box_function;
this_box_volume.geometry.initialize_from_main_function = &initialize_box_geometry_from_main_component;
this_box_volume.geometry.process_rot_allocated = 0;

this_box_volume.geometry.copy_geometry_parameters = &allocate_box_storage_copy;

rot_copy(this_box_volume.geometry.rotation_matrix,ROT_A_CURRENT_COMP); //check how ROT_R_CURRENT_COMP would work
rot_transpose(ROT_A_CURRENT_COMP,this_box_volume.geometry.transpose_rotation_matrix);

// Initialize loggers
this_box_volume.loggers.num_elements = 0;

// packing the information into the global_geometry_element, which is then included in the global_geometry_list.
sprintf(global_geometry_element.name,NAME_CURRENT_COMP);
global_geometry_element.activation_counter = number_of_activations;
global_geometry_element.component_index = INDEX_CURRENT_COMP;
global_geometry_element.Volume = &this_box_volume; // Would be nicer if this m was a pointer, now we have the (small) data two places
add_element_to_geometry_list(&global_geometry_list,global_geometry_element);
}
#line 293723 "MACS_sample_kidney_box.c"
#undef number_of_activations
#undef mask_setting
#undef mask_string
#undef p_interact
#undef focus_r
#undef focus_xh
#undef focus_xw
#undef focus_ah
#undef focus_aw
#undef target_z
#undef target_y
#undef target_x
#undef target_index
#undef visualize
#undef yheight2
#undef xwidth2
#undef zdepth
#undef yheight
#undef xwidth
#undef priority
#undef material_string
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

  /* Initializations for component channel_14_cave2_cyl1. */
  SIG_MESSAGE("channel_14_cave2_cyl1 (Init)");
#define mccompcurname  channel_14_cave2_cyl1
#define mccompcurtype  Union_cylinder
#define mccompcurindex 682
#define loop_index mccchannel_14_cave2_cyl1_loop_index
#define this_cylinder_volume mccchannel_14_cave2_cyl1_this_cylinder_volume
#define global_geometry_element mccchannel_14_cave2_cyl1_global_geometry_element
#define this_cylinder_storage mccchannel_14_cave2_cyl1_this_cylinder_storage
#define material_string mccchannel_14_cave2_cyl1_material_string
#define priority mccchannel_14_cave2_cyl1_priority
#define radius mccchannel_14_cave2_cyl1_radius
#define yheight mccchannel_14_cave2_cyl1_yheight
#define visualize mccchannel_14_cave2_cyl1_visualize
#define target_index mccchannel_14_cave2_cyl1_target_index
#define target_x mccchannel_14_cave2_cyl1_target_x
#define target_y mccchannel_14_cave2_cyl1_target_y
#define target_z mccchannel_14_cave2_cyl1_target_z
#define focus_aw mccchannel_14_cave2_cyl1_focus_aw
#define focus_ah mccchannel_14_cave2_cyl1_focus_ah
#define focus_xw mccchannel_14_cave2_cyl1_focus_xw
#define focus_xh mccchannel_14_cave2_cyl1_focus_xh
#define focus_r mccchannel_14_cave2_cyl1_focus_r
#define p_interact mccchannel_14_cave2_cyl1_p_interact
#define mask_string mccchannel_14_cave2_cyl1_mask_string
#define mask_setting mccchannel_14_cave2_cyl1_mask_setting
#define number_of_activations mccchannel_14_cave2_cyl1_number_of_activations
#line 185 "Union_cylinder.comp"
{
// Initializes the focusing system for this volume including input sanitation.
focus_initialize(&this_cylinder_volume.geometry, POS_A_COMP_INDEX(INDEX_CURRENT_COMP+target_index), POS_A_CURRENT_COMP, ROT_A_CURRENT_COMP, target_index, target_x, target_y, target_z, focus_aw, focus_ah, focus_xw, focus_xh, focus_r, NAME_CURRENT_COMP);

// Input sanitation for this geometry
if (radius <= 0) {
  printf("\nERROR in Union_cylinder named %s, the radius is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}

if (yheight <= 0) {
  printf("\nERROR in Union_cylinder named %s, yheight is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}

// Use sanitation
#ifdef MATERIAL_DETECTOR
if (global_material_list.num_elements == 0) {
  // Here if the user have defined a material, but only after this material
  printf("\nERROR: Need to define a material using Union_make_material before using a Union geometry component. \n");
  printf("       %s was defined before first use of Union_make_material.\n",NAME_CURRENT_COMP);
  exit(1);
}
#endif
#ifndef MATERIAL_DETECTOR
  printf("\nERROR: Need to define a material using Union_make_material before using a Union geometry component. \n");
  exit(1);
#endif


this_cylinder_volume.geometry.is_masked_volume = 0;
this_cylinder_volume.geometry.is_exit_volume = 0;
this_cylinder_volume.geometry.is_mask_volume = 0;

// Read the material input, or if it lacks, use automatic linking.
if (mask_string && strlen(mask_string) && strcmp(mask_string, "NULL") && strcmp(mask_string, "0")) {
    // A mask volume is used to limit the extend of other volumes, called the masked volumes. These are specified in the mask_string.
    // In order for a ray to enter a masked volume, it needs to be both in the region covered by that volume AND the mask volume.
    // When more than
    this_cylinder_volume.geometry.mask_mode = 1; // Default is mask mode is ALL
    if (mask_setting && strlen(mask_setting) && strcmp(mask_setting, "NULL") && strcmp(mask_setting, "0")) {
        if (strcmp(mask_setting,"ALL") == 0 || strcmp(mask_setting,"All") == 0) this_cylinder_volume.geometry.mask_mode = 1;
        else if (strcmp(mask_setting,"ANY") == 0 || strcmp(mask_setting,"Any") == 0) this_cylinder_volume.geometry.mask_mode = 2;
        else {
            printf("The mask_mode of component %s is set to %s, but must be either ALL or ANY.\n",NAME_CURRENT_COMP,mask_setting);
            exit(1);
        }
    }
    
    for (loop_index=0;loop_index<global_geometry_list.num_elements;loop_index++) {
        // Add mask list
        if (1 == manual_linking_function(global_geometry_list.elements[loop_index].name,mask_string)) {
            add_element_to_int_list(&this_cylinder_volume.geometry.mask_list,global_geometry_list.elements[loop_index].component_index);
            add_element_to_int_list(&global_geometry_list.elements[loop_index].Volume->geometry.masked_by_list,INDEX_CURRENT_COMP);
            global_geometry_list.elements[loop_index].Volume->geometry.is_masked_volume = 1;
            if (this_cylinder_volume.geometry.mask_mode == 2)
                global_geometry_list.elements[loop_index].Volume->geometry.mask_mode = 2;
            if (this_cylinder_volume.geometry.mask_mode == 1) {
                if (global_geometry_list.elements[loop_index].Volume->geometry.is_masked_volume == 1 && global_geometry_list.elements[loop_index].Volume->geometry.mask_mode != 2)
                    // If more than one mask is added to one volume, the ANY mode overwrites the (default) ALL mode.
                    global_geometry_list.elements[loop_index].Volume->geometry.mask_mode = 1;
            }
            
            found_geometries = 1;
        }
    }
    if (found_geometries == 0) {
        printf("The mask_string in geometry: %s did not find any of the specified volumes in the mask_string %s \n",NAME_CURRENT_COMP,mask_string);
        exit(1);
    }
    this_cylinder_volume.p_physics = malloc(sizeof(struct physics_struct));
    this_cylinder_volume.p_physics->is_vacuum = 0; // Makes this volume a vacuum
    this_cylinder_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
    this_cylinder_volume.p_physics->my_a = 0; // Should not be used.
    sprintf(this_cylinder_volume.p_physics->name,"Mask");
    this_cylinder_volume.geometry.is_mask_volume = 1;
    
    
// Read the material input, or if it lacks, use automatic linking.
} else if (material_string && strlen(material_string) && strcmp(material_string, "NULL") && strcmp(material_string, "0")) {
    // A geometry string was given, use it to determine which material
    if (0 == strcmp(material_string,"vacuum") || 0 == strcmp(material_string,"Vacuum")) {
        // One could have a global physics struct for vacuum instead of creating one for each
        this_cylinder_volume.p_physics = malloc(sizeof(struct physics_struct));
        this_cylinder_volume.p_physics->is_vacuum = 1; // Makes this volume a vacuum
        this_cylinder_volume.p_physics->number_of_processes = (int) 0;
        this_cylinder_volume.p_physics->my_a = 0; // Should not be used.
        sprintf(this_cylinder_volume.p_physics->name,"Vacuum");
    } else if (0 == strcmp(material_string,"exit") || 0 == strcmp(material_string,"Exit")) {
        // One could have a global physics struct for exit instead of creating one for each
        this_cylinder_volume.p_physics = malloc(sizeof(struct physics_struct));
        this_cylinder_volume.p_physics->is_vacuum = 1; // Makes this volume a vacuum
        this_cylinder_volume.p_physics->number_of_processes = (int) 0;
        this_cylinder_volume.p_physics->my_a = 0; // Should not be used.
        this_cylinder_volume.geometry.is_exit_volume = 1;
        sprintf(this_cylinder_volume.p_physics->name,"Exit");
    } else {
        for (loop_index=0;loop_index<global_material_list.num_elements;loop_index++) {
          if (0 == strcmp(material_string,global_material_list.elements[loop_index].name)) {
            this_cylinder_volume.p_physics = global_material_list.elements[loop_index].physics;
            break;
          }
          if (loop_index == global_material_list.num_elements-1) {
            printf("\n");
            printf("ERROR: The material string \"%s\" in Union geometry \"%s\" did not match a specified material. \n",material_string,NAME_CURRENT_COMP);
            printf("       The materials available at this point (need to be defined before the geometry): \n");
            for (loop_index=0;loop_index<global_material_list.num_elements;loop_index++)
              printf("         %s\n",global_material_list.elements[loop_index].name);
            printf("\n");
            printf("       It is also possible to use one of the defualt materials avaiable: \n");
            printf("           Vacuum (for a Volume without scattering or absorption)\n");
            printf("           Exit (for a Volume where the ray exits the component if it enters)\n");
            printf("           Mask (for a Volume that masks existing volumes specified in the mask_string\n");
            exit(1);
          }
        }
    }
} else {
    // Automatic linking, simply using the last defined material.
    #ifndef MATERIAL_DETECTOR
        printf("Need to define a material before the geometry to use automatic linking %s.\n",NAME_CURRENT_COMP);
        exit(1);
    #endif
    this_cylinder_volume.p_physics = global_material_list.elements[global_material_list.num_elements-1].physics;
}

sprintf(this_cylinder_volume.name,NAME_CURRENT_COMP);
sprintf(this_cylinder_volume.geometry.shape,"cylinder");
this_cylinder_volume.geometry.priority_value = priority;
// Currently the coordinates will be in absolute space.
this_cylinder_volume.geometry.center = POS_A_CURRENT_COMP;

this_cylinder_volume.geometry.geometry_p_interact = p_interact;
this_cylinder_storage.cyl_radius = radius;
this_cylinder_storage.height = yheight;
this_cylinder_volume.geometry.visualization_on = visualize;
this_cylinder_volume.geometry.geometry_parameters.p_cylinder_storage = &this_cylinder_storage;
this_cylinder_volume.geometry.within_function = &r_within_cylinder;
this_cylinder_volume.geometry.intersect_function = &sample_cylinder_intersect;
this_cylinder_volume.geometry.mcdisplay_function = &mcdisplay_cylinder_function;
this_cylinder_volume.geometry.shell_points = &cylinder_shell_points;
this_cylinder_volume.geometry.initialize_from_main_function = &initialize_cylinder_geometry_from_main_component;
this_cylinder_volume.geometry.process_rot_allocated = 0;
this_cylinder_volume.geometry.copy_geometry_parameters = &allocate_cylinder_storage_copy;

rot_copy(this_cylinder_volume.geometry.rotation_matrix,ROT_A_CURRENT_COMP);
rot_transpose(ROT_A_CURRENT_COMP,this_cylinder_volume.geometry.transpose_rotation_matrix);

// Initialize loggers
this_cylinder_volume.loggers.num_elements = 0;

// packing the information into the global_geometry_element, which is then included in the global_geometry_list.
sprintf(global_geometry_element.name,NAME_CURRENT_COMP);
global_geometry_element.activation_counter = number_of_activations;
global_geometry_element.component_index = INDEX_CURRENT_COMP;
global_geometry_element.Volume = &this_cylinder_volume; // Would be nicer if this m was a pointer, now we have the (small) data two places
add_element_to_geometry_list(&global_geometry_list,global_geometry_element);
}
#line 293939 "MACS_sample_kidney_box.c"
#undef number_of_activations
#undef mask_setting
#undef mask_string
#undef p_interact
#undef focus_r
#undef focus_xh
#undef focus_xw
#undef focus_ah
#undef focus_aw
#undef target_z
#undef target_y
#undef target_x
#undef target_index
#undef visualize
#undef yheight
#undef radius
#undef priority
#undef material_string
#undef this_cylinder_storage
#undef global_geometry_element
#undef this_cylinder_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

  /* Initializations for component channel_14_cave2_box1. */
  SIG_MESSAGE("channel_14_cave2_box1 (Init)");
#define mccompcurname  channel_14_cave2_box1
#define mccompcurtype  Union_box
#define mccompcurindex 683
#define loop_index mccchannel_14_cave2_box1_loop_index
#define this_box_volume mccchannel_14_cave2_box1_this_box_volume
#define global_geometry_element mccchannel_14_cave2_box1_global_geometry_element
#define this_box_storage mccchannel_14_cave2_box1_this_box_storage
#define material_string mccchannel_14_cave2_box1_material_string
#define priority mccchannel_14_cave2_box1_priority
#define xwidth mccchannel_14_cave2_box1_xwidth
#define yheight mccchannel_14_cave2_box1_yheight
#define zdepth mccchannel_14_cave2_box1_zdepth
#define xwidth2 mccchannel_14_cave2_box1_xwidth2
#define yheight2 mccchannel_14_cave2_box1_yheight2
#define visualize mccchannel_14_cave2_box1_visualize
#define target_index mccchannel_14_cave2_box1_target_index
#define target_x mccchannel_14_cave2_box1_target_x
#define target_y mccchannel_14_cave2_box1_target_y
#define target_z mccchannel_14_cave2_box1_target_z
#define focus_aw mccchannel_14_cave2_box1_focus_aw
#define focus_ah mccchannel_14_cave2_box1_focus_ah
#define focus_xw mccchannel_14_cave2_box1_focus_xw
#define focus_xh mccchannel_14_cave2_box1_focus_xh
#define focus_r mccchannel_14_cave2_box1_focus_r
#define p_interact mccchannel_14_cave2_box1_p_interact
#define mask_string mccchannel_14_cave2_box1_mask_string
#define mask_setting mccchannel_14_cave2_box1_mask_setting
#define number_of_activations mccchannel_14_cave2_box1_number_of_activations
#line 224 "Union_box.comp"
{
// Initializes the focusing system for this volume including input sanitation.
focus_initialize(&this_box_volume.geometry, POS_A_COMP_INDEX(INDEX_CURRENT_COMP+target_index), POS_A_CURRENT_COMP, ROT_A_CURRENT_COMP, target_index, target_x, target_y, target_z, focus_aw, focus_ah, focus_xw, focus_xh, focus_r, NAME_CURRENT_COMP);

// Input sanitation for this geometry
if (xwidth <= 0) {
  printf("\nERROR in Union_box named %s, the xwidth is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (yheight <= 0) {
  printf("\nERROR in Union_box named %s, yheight is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (zdepth <= 0) {
  printf("\nERROR in Union_box named %s, zdepth is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (xwidth2 <= 0 && xwidth2 != -1) {
  printf("\nERROR in Union_box named %s, the xwidth2 is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (yheight2 <= 0 && yheight2 != -1) {
  printf("\nERROR in Union_box named %s, yheight2 is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}

// Use sanitation
if (global_material_list.num_elements == 0) {
  printf("\nERROR: Need to define a material using Union_make_material before using a Union geometry component. \n");
  printf("       %s was defined before first use of Union_make_material.\n",NAME_CURRENT_COMP);
  exit(1);
}

this_box_volume.geometry.is_masked_volume = 0;
this_box_volume.geometry.is_exit_volume = 0;
this_box_volume.geometry.is_mask_volume = 0;
// check if the volume is a mask, if it is the material string is irelevant.
if (mask_string && strlen(mask_string) && strcmp(mask_string, "NULL") && strcmp(mask_string, "0")) {
    // A mask volume is used to limit the extend of other volumes, called the masked volumes. These are specified in the mask_string.
    // In order for a ray to enter a masked volume, it needs to be both in the region covered by that volume AND the mask volume.
    // When more than
    this_box_volume.geometry.mask_mode = 1; // Default is mask mode is ALL
    if (mask_setting && strlen(mask_setting) && strcmp(mask_setting, "NULL") && strcmp(mask_setting, "0")) {
        if (strcmp(mask_setting,"ALL") == 0 || strcmp(mask_setting,"All") == 0) this_box_volume.geometry.mask_mode = 1;
        else if (strcmp(mask_setting,"ANY") == 0 || strcmp(mask_setting,"Any") == 0) this_box_volume.geometry.mask_mode = 2;
        else {
            printf("The mask_mode of component %s is set to %s, but must be either ALL or ANY.\n",NAME_CURRENT_COMP,mask_setting);
            exit(1);
        }
    }
    
    for (loop_index=0;loop_index<global_geometry_list.num_elements;loop_index++) {
        // Add mask list
        if (1 == manual_linking_function(global_geometry_list.elements[loop_index].name,mask_string)) {
            add_element_to_int_list(&this_box_volume.geometry.mask_list,global_geometry_list.elements[loop_index].component_index);
            add_element_to_int_list(&global_geometry_list.elements[loop_index].Volume->geometry.masked_by_list,INDEX_CURRENT_COMP);
            global_geometry_list.elements[loop_index].Volume->geometry.is_masked_volume = 1;
            if (this_box_volume.geometry.mask_mode == 2)
                global_geometry_list.elements[loop_index].Volume->geometry.mask_mode = 2;
            if (this_box_volume.geometry.mask_mode == 1) {
                if (global_geometry_list.elements[loop_index].Volume->geometry.is_masked_volume == 1 && global_geometry_list.elements[loop_index].Volume->geometry.mask_mode != 2)
                    // If more than one mask is added to one volume, the ANY mode overwrites the (default) ALL mode.
                    global_geometry_list.elements[loop_index].Volume->geometry.mask_mode = 1;
            }
            
            found_geometries = 1;
        }
    }
    if (found_geometries == 0) {
        printf("The mask_string in geometry: %s did not find any of the specified volumes in the mask_string %s \n",NAME_CURRENT_COMP,mask_string);
        exit(1);
    }
    this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
    this_box_volume.p_physics->is_vacuum = 0; // Makes this volume a vacuum
    this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
    this_box_volume.p_physics->my_a = 0; // Should not be used.
    sprintf(this_box_volume.p_physics->name,"Mask");
    this_box_volume.geometry.is_mask_volume = 1;
    
    
// Read the material input, or if it lacks, use automatic linking.
} else if (material_string && strlen(material_string) && strcmp(material_string, "NULL") && strcmp(material_string, "0")) {
    // A geometry string was given, use it to determine which material
    if (0 == strcmp(material_string,"vacuum") || 0 == strcmp(material_string,"Vacuum")) {
        // One could have a global physics struct for vacuum instead of creating one for each
        this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
        this_box_volume.p_physics->is_vacuum = 1; // Makes this volume a vacuum
        this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
        this_box_volume.p_physics->my_a = 0; // Should not be used.
        sprintf(this_box_volume.p_physics->name,"Vacuum");
    } else if (0 == strcmp(material_string,"exit") || 0 == strcmp(material_string,"Exit")) {
        // One could have a global physics struct for vacuum instead of creating one for each
        this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
        this_box_volume.p_physics->is_vacuum = 1; // Makes this volume a vacuum
        this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
        this_box_volume.p_physics->my_a = 0; // Should not be used.
        this_box_volume.geometry.is_exit_volume = 1;
        sprintf(this_box_volume.p_physics->name,"Exit");
    } else {
        #ifndef MATERIAL_DETECTOR
            printf("Need to define a material before refering to it in a geometry %s.\n",NAME_CURRENT_COMP);
            exit(1);
        #endif
        for (loop_index=0;loop_index<global_material_list.num_elements;loop_index++) {
            if (0 == strcmp(material_string,global_material_list.elements[loop_index].name)) {
                this_box_volume.p_physics = global_material_list.elements[loop_index].physics;
                break;
            }
            if (loop_index == global_material_list.num_elements-1) {
            printf("\n");
            printf("ERROR: The material string \"%s\" in Union geometry \"%s\" did not match a specified material. \n",material_string,NAME_CURRENT_COMP);
            printf("       The materials available at this point (need to be defined before the geometry): \n");
            for (loop_index=0;loop_index<global_material_list.num_elements;loop_index++)
              printf("         %s\n",global_material_list.elements[loop_index].name);
            printf("\n");
            printf("       It is also possible to use one of the defualt materials avaiable: \n");
            printf("           Vacuum (for a Volume without scattering or absorption)\n");
            printf("           Exit (for a Volume where the ray exits the component if it enters)\n");
            printf("           Mask (for a Volume that masks existing volumes specified in the mask_string\n");
            exit(1);
          }
        }
    }
} else {
    // Automatic linking, simply using the last defined material.
    #ifndef MATERIAL_DETECTOR
        printf("Need to define a material before the geometry to use automatic linking %s.\n",NAME_CURRENT_COMP);
        exit(1);
    #endif
    this_box_volume.p_physics = global_material_list.elements[global_material_list.num_elements-1].physics;
}

sprintf(this_box_volume.name,NAME_CURRENT_COMP);
sprintf(this_box_volume.geometry.shape,"box");
this_box_volume.geometry.priority_value = priority;
this_box_volume.geometry.geometry_p_interact = p_interact;
// Currently the coordinates will be in absolute space.
this_box_volume.geometry.center = POS_A_CURRENT_COMP;

this_box_storage.z_depth = zdepth;
this_box_storage.x_width1 = xwidth;
this_box_storage.y_height1 = yheight;

this_box_storage.is_rectangle = 0;
if (xwidth2 < 0 && yheight2 < 0) this_box_storage.is_rectangle = 1;
if (xwidth == xwidth2 && yheight == yheight2) this_box_storage.is_rectangle = 1;

if (xwidth2 < 0) {
    this_box_storage.x_width2 = xwidth;
    xwidth2 = xwidth;
} else this_box_storage.x_width2 = xwidth2;

if (yheight2 < 0) {
    this_box_storage.y_height2 = yheight;
    yheight2 = yheight;
} else this_box_storage.y_height2 = yheight2;


this_box_storage.normal_vectors[0] = coords_set(0,0,1);
this_box_storage.normal_vectors[1] = coords_set(0,0,1);

// for sides with y component = 0
x_component = 2*zdepth/sqrt((xwidth-xwidth2)*(xwidth-xwidth2)+4*zdepth*zdepth);
z_component = (xwidth-xwidth2)/sqrt(4*zdepth*zdepth+(xwidth-xwidth2)*(xwidth-xwidth2));

this_box_storage.normal_vectors[2] = coords_set(x_component,0,z_component);
this_box_storage.normal_vectors[3] = coords_set(-x_component,0,z_component);

// for sides with x component = 0
y_component = 2*zdepth/sqrt((yheight-yheight2)*(yheight-yheight2)+4*zdepth*zdepth);
z_component = (yheight-yheight2)/sqrt(4*zdepth*zdepth+(yheight-yheight2)*(yheight-yheight2));

this_box_storage.normal_vectors[4] = coords_set(0,y_component,z_component);
this_box_storage.normal_vectors[5] = coords_set(0,-y_component,z_component);

this_box_volume.geometry.visualization_on = visualize;

this_box_volume.geometry.geometry_parameters.p_box_storage = &this_box_storage;

// Assign pointers to functions for intersection with the shape, checking if a point is inside the shape
if (this_box_storage.is_rectangle == 1) {
this_box_volume.geometry.intersect_function = &sample_box_intersect_simple;
this_box_volume.geometry.within_function = &r_within_box_simple;
}
else {
this_box_volume.geometry.intersect_function = &sample_box_intersect_advanced;
this_box_volume.geometry.within_function = &r_within_box_advanced;
}

this_box_volume.geometry.shell_points = &box_shell_points;
this_box_volume.geometry.mcdisplay_function = &mcdisplay_box_function;
this_box_volume.geometry.initialize_from_main_function = &initialize_box_geometry_from_main_component;
this_box_volume.geometry.process_rot_allocated = 0;

this_box_volume.geometry.copy_geometry_parameters = &allocate_box_storage_copy;

rot_copy(this_box_volume.geometry.rotation_matrix,ROT_A_CURRENT_COMP); //check how ROT_R_CURRENT_COMP would work
rot_transpose(ROT_A_CURRENT_COMP,this_box_volume.geometry.transpose_rotation_matrix);

// Initialize loggers
this_box_volume.loggers.num_elements = 0;

// packing the information into the global_geometry_element, which is then included in the global_geometry_list.
sprintf(global_geometry_element.name,NAME_CURRENT_COMP);
global_geometry_element.activation_counter = number_of_activations;
global_geometry_element.component_index = INDEX_CURRENT_COMP;
global_geometry_element.Volume = &this_box_volume; // Would be nicer if this m was a pointer, now we have the (small) data two places
add_element_to_geometry_list(&global_geometry_list,global_geometry_element);
}
#line 294206 "MACS_sample_kidney_box.c"
#undef number_of_activations
#undef mask_setting
#undef mask_string
#undef p_interact
#undef focus_r
#undef focus_xh
#undef focus_xw
#undef focus_ah
#undef focus_aw
#undef target_z
#undef target_y
#undef target_x
#undef target_index
#undef visualize
#undef yheight2
#undef xwidth2
#undef zdepth
#undef yheight
#undef xwidth
#undef priority
#undef material_string
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

  /* Initializations for component channel_14_cave2_box2. */
  SIG_MESSAGE("channel_14_cave2_box2 (Init)");
#define mccompcurname  channel_14_cave2_box2
#define mccompcurtype  Union_box
#define mccompcurindex 684
#define loop_index mccchannel_14_cave2_box2_loop_index
#define this_box_volume mccchannel_14_cave2_box2_this_box_volume
#define global_geometry_element mccchannel_14_cave2_box2_global_geometry_element
#define this_box_storage mccchannel_14_cave2_box2_this_box_storage
#define material_string mccchannel_14_cave2_box2_material_string
#define priority mccchannel_14_cave2_box2_priority
#define xwidth mccchannel_14_cave2_box2_xwidth
#define yheight mccchannel_14_cave2_box2_yheight
#define zdepth mccchannel_14_cave2_box2_zdepth
#define xwidth2 mccchannel_14_cave2_box2_xwidth2
#define yheight2 mccchannel_14_cave2_box2_yheight2
#define visualize mccchannel_14_cave2_box2_visualize
#define target_index mccchannel_14_cave2_box2_target_index
#define target_x mccchannel_14_cave2_box2_target_x
#define target_y mccchannel_14_cave2_box2_target_y
#define target_z mccchannel_14_cave2_box2_target_z
#define focus_aw mccchannel_14_cave2_box2_focus_aw
#define focus_ah mccchannel_14_cave2_box2_focus_ah
#define focus_xw mccchannel_14_cave2_box2_focus_xw
#define focus_xh mccchannel_14_cave2_box2_focus_xh
#define focus_r mccchannel_14_cave2_box2_focus_r
#define p_interact mccchannel_14_cave2_box2_p_interact
#define mask_string mccchannel_14_cave2_box2_mask_string
#define mask_setting mccchannel_14_cave2_box2_mask_setting
#define number_of_activations mccchannel_14_cave2_box2_number_of_activations
#line 224 "Union_box.comp"
{
// Initializes the focusing system for this volume including input sanitation.
focus_initialize(&this_box_volume.geometry, POS_A_COMP_INDEX(INDEX_CURRENT_COMP+target_index), POS_A_CURRENT_COMP, ROT_A_CURRENT_COMP, target_index, target_x, target_y, target_z, focus_aw, focus_ah, focus_xw, focus_xh, focus_r, NAME_CURRENT_COMP);

// Input sanitation for this geometry
if (xwidth <= 0) {
  printf("\nERROR in Union_box named %s, the xwidth is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (yheight <= 0) {
  printf("\nERROR in Union_box named %s, yheight is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (zdepth <= 0) {
  printf("\nERROR in Union_box named %s, zdepth is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (xwidth2 <= 0 && xwidth2 != -1) {
  printf("\nERROR in Union_box named %s, the xwidth2 is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (yheight2 <= 0 && yheight2 != -1) {
  printf("\nERROR in Union_box named %s, yheight2 is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}

// Use sanitation
if (global_material_list.num_elements == 0) {
  printf("\nERROR: Need to define a material using Union_make_material before using a Union geometry component. \n");
  printf("       %s was defined before first use of Union_make_material.\n",NAME_CURRENT_COMP);
  exit(1);
}

this_box_volume.geometry.is_masked_volume = 0;
this_box_volume.geometry.is_exit_volume = 0;
this_box_volume.geometry.is_mask_volume = 0;
// check if the volume is a mask, if it is the material string is irelevant.
if (mask_string && strlen(mask_string) && strcmp(mask_string, "NULL") && strcmp(mask_string, "0")) {
    // A mask volume is used to limit the extend of other volumes, called the masked volumes. These are specified in the mask_string.
    // In order for a ray to enter a masked volume, it needs to be both in the region covered by that volume AND the mask volume.
    // When more than
    this_box_volume.geometry.mask_mode = 1; // Default is mask mode is ALL
    if (mask_setting && strlen(mask_setting) && strcmp(mask_setting, "NULL") && strcmp(mask_setting, "0")) {
        if (strcmp(mask_setting,"ALL") == 0 || strcmp(mask_setting,"All") == 0) this_box_volume.geometry.mask_mode = 1;
        else if (strcmp(mask_setting,"ANY") == 0 || strcmp(mask_setting,"Any") == 0) this_box_volume.geometry.mask_mode = 2;
        else {
            printf("The mask_mode of component %s is set to %s, but must be either ALL or ANY.\n",NAME_CURRENT_COMP,mask_setting);
            exit(1);
        }
    }
    
    for (loop_index=0;loop_index<global_geometry_list.num_elements;loop_index++) {
        // Add mask list
        if (1 == manual_linking_function(global_geometry_list.elements[loop_index].name,mask_string)) {
            add_element_to_int_list(&this_box_volume.geometry.mask_list,global_geometry_list.elements[loop_index].component_index);
            add_element_to_int_list(&global_geometry_list.elements[loop_index].Volume->geometry.masked_by_list,INDEX_CURRENT_COMP);
            global_geometry_list.elements[loop_index].Volume->geometry.is_masked_volume = 1;
            if (this_box_volume.geometry.mask_mode == 2)
                global_geometry_list.elements[loop_index].Volume->geometry.mask_mode = 2;
            if (this_box_volume.geometry.mask_mode == 1) {
                if (global_geometry_list.elements[loop_index].Volume->geometry.is_masked_volume == 1 && global_geometry_list.elements[loop_index].Volume->geometry.mask_mode != 2)
                    // If more than one mask is added to one volume, the ANY mode overwrites the (default) ALL mode.
                    global_geometry_list.elements[loop_index].Volume->geometry.mask_mode = 1;
            }
            
            found_geometries = 1;
        }
    }
    if (found_geometries == 0) {
        printf("The mask_string in geometry: %s did not find any of the specified volumes in the mask_string %s \n",NAME_CURRENT_COMP,mask_string);
        exit(1);
    }
    this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
    this_box_volume.p_physics->is_vacuum = 0; // Makes this volume a vacuum
    this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
    this_box_volume.p_physics->my_a = 0; // Should not be used.
    sprintf(this_box_volume.p_physics->name,"Mask");
    this_box_volume.geometry.is_mask_volume = 1;
    
    
// Read the material input, or if it lacks, use automatic linking.
} else if (material_string && strlen(material_string) && strcmp(material_string, "NULL") && strcmp(material_string, "0")) {
    // A geometry string was given, use it to determine which material
    if (0 == strcmp(material_string,"vacuum") || 0 == strcmp(material_string,"Vacuum")) {
        // One could have a global physics struct for vacuum instead of creating one for each
        this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
        this_box_volume.p_physics->is_vacuum = 1; // Makes this volume a vacuum
        this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
        this_box_volume.p_physics->my_a = 0; // Should not be used.
        sprintf(this_box_volume.p_physics->name,"Vacuum");
    } else if (0 == strcmp(material_string,"exit") || 0 == strcmp(material_string,"Exit")) {
        // One could have a global physics struct for vacuum instead of creating one for each
        this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
        this_box_volume.p_physics->is_vacuum = 1; // Makes this volume a vacuum
        this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
        this_box_volume.p_physics->my_a = 0; // Should not be used.
        this_box_volume.geometry.is_exit_volume = 1;
        sprintf(this_box_volume.p_physics->name,"Exit");
    } else {
        #ifndef MATERIAL_DETECTOR
            printf("Need to define a material before refering to it in a geometry %s.\n",NAME_CURRENT_COMP);
            exit(1);
        #endif
        for (loop_index=0;loop_index<global_material_list.num_elements;loop_index++) {
            if (0 == strcmp(material_string,global_material_list.elements[loop_index].name)) {
                this_box_volume.p_physics = global_material_list.elements[loop_index].physics;
                break;
            }
            if (loop_index == global_material_list.num_elements-1) {
            printf("\n");
            printf("ERROR: The material string \"%s\" in Union geometry \"%s\" did not match a specified material. \n",material_string,NAME_CURRENT_COMP);
            printf("       The materials available at this point (need to be defined before the geometry): \n");
            for (loop_index=0;loop_index<global_material_list.num_elements;loop_index++)
              printf("         %s\n",global_material_list.elements[loop_index].name);
            printf("\n");
            printf("       It is also possible to use one of the defualt materials avaiable: \n");
            printf("           Vacuum (for a Volume without scattering or absorption)\n");
            printf("           Exit (for a Volume where the ray exits the component if it enters)\n");
            printf("           Mask (for a Volume that masks existing volumes specified in the mask_string\n");
            exit(1);
          }
        }
    }
} else {
    // Automatic linking, simply using the last defined material.
    #ifndef MATERIAL_DETECTOR
        printf("Need to define a material before the geometry to use automatic linking %s.\n",NAME_CURRENT_COMP);
        exit(1);
    #endif
    this_box_volume.p_physics = global_material_list.elements[global_material_list.num_elements-1].physics;
}

sprintf(this_box_volume.name,NAME_CURRENT_COMP);
sprintf(this_box_volume.geometry.shape,"box");
this_box_volume.geometry.priority_value = priority;
this_box_volume.geometry.geometry_p_interact = p_interact;
// Currently the coordinates will be in absolute space.
this_box_volume.geometry.center = POS_A_CURRENT_COMP;

this_box_storage.z_depth = zdepth;
this_box_storage.x_width1 = xwidth;
this_box_storage.y_height1 = yheight;

this_box_storage.is_rectangle = 0;
if (xwidth2 < 0 && yheight2 < 0) this_box_storage.is_rectangle = 1;
if (xwidth == xwidth2 && yheight == yheight2) this_box_storage.is_rectangle = 1;

if (xwidth2 < 0) {
    this_box_storage.x_width2 = xwidth;
    xwidth2 = xwidth;
} else this_box_storage.x_width2 = xwidth2;

if (yheight2 < 0) {
    this_box_storage.y_height2 = yheight;
    yheight2 = yheight;
} else this_box_storage.y_height2 = yheight2;


this_box_storage.normal_vectors[0] = coords_set(0,0,1);
this_box_storage.normal_vectors[1] = coords_set(0,0,1);

// for sides with y component = 0
x_component = 2*zdepth/sqrt((xwidth-xwidth2)*(xwidth-xwidth2)+4*zdepth*zdepth);
z_component = (xwidth-xwidth2)/sqrt(4*zdepth*zdepth+(xwidth-xwidth2)*(xwidth-xwidth2));

this_box_storage.normal_vectors[2] = coords_set(x_component,0,z_component);
this_box_storage.normal_vectors[3] = coords_set(-x_component,0,z_component);

// for sides with x component = 0
y_component = 2*zdepth/sqrt((yheight-yheight2)*(yheight-yheight2)+4*zdepth*zdepth);
z_component = (yheight-yheight2)/sqrt(4*zdepth*zdepth+(yheight-yheight2)*(yheight-yheight2));

this_box_storage.normal_vectors[4] = coords_set(0,y_component,z_component);
this_box_storage.normal_vectors[5] = coords_set(0,-y_component,z_component);

this_box_volume.geometry.visualization_on = visualize;

this_box_volume.geometry.geometry_parameters.p_box_storage = &this_box_storage;

// Assign pointers to functions for intersection with the shape, checking if a point is inside the shape
if (this_box_storage.is_rectangle == 1) {
this_box_volume.geometry.intersect_function = &sample_box_intersect_simple;
this_box_volume.geometry.within_function = &r_within_box_simple;
}
else {
this_box_volume.geometry.intersect_function = &sample_box_intersect_advanced;
this_box_volume.geometry.within_function = &r_within_box_advanced;
}

this_box_volume.geometry.shell_points = &box_shell_points;
this_box_volume.geometry.mcdisplay_function = &mcdisplay_box_function;
this_box_volume.geometry.initialize_from_main_function = &initialize_box_geometry_from_main_component;
this_box_volume.geometry.process_rot_allocated = 0;

this_box_volume.geometry.copy_geometry_parameters = &allocate_box_storage_copy;

rot_copy(this_box_volume.geometry.rotation_matrix,ROT_A_CURRENT_COMP); //check how ROT_R_CURRENT_COMP would work
rot_transpose(ROT_A_CURRENT_COMP,this_box_volume.geometry.transpose_rotation_matrix);

// Initialize loggers
this_box_volume.loggers.num_elements = 0;

// packing the information into the global_geometry_element, which is then included in the global_geometry_list.
sprintf(global_geometry_element.name,NAME_CURRENT_COMP);
global_geometry_element.activation_counter = number_of_activations;
global_geometry_element.component_index = INDEX_CURRENT_COMP;
global_geometry_element.Volume = &this_box_volume; // Would be nicer if this m was a pointer, now we have the (small) data two places
add_element_to_geometry_list(&global_geometry_list,global_geometry_element);
}
#line 294476 "MACS_sample_kidney_box.c"
#undef number_of_activations
#undef mask_setting
#undef mask_string
#undef p_interact
#undef focus_r
#undef focus_xh
#undef focus_xw
#undef focus_ah
#undef focus_aw
#undef target_z
#undef target_y
#undef target_x
#undef target_index
#undef visualize
#undef yheight2
#undef xwidth2
#undef zdepth
#undef yheight
#undef xwidth
#undef priority
#undef material_string
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

  /* Initializations for component channel_14_cave2_box3. */
  SIG_MESSAGE("channel_14_cave2_box3 (Init)");
#define mccompcurname  channel_14_cave2_box3
#define mccompcurtype  Union_box
#define mccompcurindex 685
#define loop_index mccchannel_14_cave2_box3_loop_index
#define this_box_volume mccchannel_14_cave2_box3_this_box_volume
#define global_geometry_element mccchannel_14_cave2_box3_global_geometry_element
#define this_box_storage mccchannel_14_cave2_box3_this_box_storage
#define material_string mccchannel_14_cave2_box3_material_string
#define priority mccchannel_14_cave2_box3_priority
#define xwidth mccchannel_14_cave2_box3_xwidth
#define yheight mccchannel_14_cave2_box3_yheight
#define zdepth mccchannel_14_cave2_box3_zdepth
#define xwidth2 mccchannel_14_cave2_box3_xwidth2
#define yheight2 mccchannel_14_cave2_box3_yheight2
#define visualize mccchannel_14_cave2_box3_visualize
#define target_index mccchannel_14_cave2_box3_target_index
#define target_x mccchannel_14_cave2_box3_target_x
#define target_y mccchannel_14_cave2_box3_target_y
#define target_z mccchannel_14_cave2_box3_target_z
#define focus_aw mccchannel_14_cave2_box3_focus_aw
#define focus_ah mccchannel_14_cave2_box3_focus_ah
#define focus_xw mccchannel_14_cave2_box3_focus_xw
#define focus_xh mccchannel_14_cave2_box3_focus_xh
#define focus_r mccchannel_14_cave2_box3_focus_r
#define p_interact mccchannel_14_cave2_box3_p_interact
#define mask_string mccchannel_14_cave2_box3_mask_string
#define mask_setting mccchannel_14_cave2_box3_mask_setting
#define number_of_activations mccchannel_14_cave2_box3_number_of_activations
#line 224 "Union_box.comp"
{
// Initializes the focusing system for this volume including input sanitation.
focus_initialize(&this_box_volume.geometry, POS_A_COMP_INDEX(INDEX_CURRENT_COMP+target_index), POS_A_CURRENT_COMP, ROT_A_CURRENT_COMP, target_index, target_x, target_y, target_z, focus_aw, focus_ah, focus_xw, focus_xh, focus_r, NAME_CURRENT_COMP);

// Input sanitation for this geometry
if (xwidth <= 0) {
  printf("\nERROR in Union_box named %s, the xwidth is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (yheight <= 0) {
  printf("\nERROR in Union_box named %s, yheight is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (zdepth <= 0) {
  printf("\nERROR in Union_box named %s, zdepth is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (xwidth2 <= 0 && xwidth2 != -1) {
  printf("\nERROR in Union_box named %s, the xwidth2 is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (yheight2 <= 0 && yheight2 != -1) {
  printf("\nERROR in Union_box named %s, yheight2 is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}

// Use sanitation
if (global_material_list.num_elements == 0) {
  printf("\nERROR: Need to define a material using Union_make_material before using a Union geometry component. \n");
  printf("       %s was defined before first use of Union_make_material.\n",NAME_CURRENT_COMP);
  exit(1);
}

this_box_volume.geometry.is_masked_volume = 0;
this_box_volume.geometry.is_exit_volume = 0;
this_box_volume.geometry.is_mask_volume = 0;
// check if the volume is a mask, if it is the material string is irelevant.
if (mask_string && strlen(mask_string) && strcmp(mask_string, "NULL") && strcmp(mask_string, "0")) {
    // A mask volume is used to limit the extend of other volumes, called the masked volumes. These are specified in the mask_string.
    // In order for a ray to enter a masked volume, it needs to be both in the region covered by that volume AND the mask volume.
    // When more than
    this_box_volume.geometry.mask_mode = 1; // Default is mask mode is ALL
    if (mask_setting && strlen(mask_setting) && strcmp(mask_setting, "NULL") && strcmp(mask_setting, "0")) {
        if (strcmp(mask_setting,"ALL") == 0 || strcmp(mask_setting,"All") == 0) this_box_volume.geometry.mask_mode = 1;
        else if (strcmp(mask_setting,"ANY") == 0 || strcmp(mask_setting,"Any") == 0) this_box_volume.geometry.mask_mode = 2;
        else {
            printf("The mask_mode of component %s is set to %s, but must be either ALL or ANY.\n",NAME_CURRENT_COMP,mask_setting);
            exit(1);
        }
    }
    
    for (loop_index=0;loop_index<global_geometry_list.num_elements;loop_index++) {
        // Add mask list
        if (1 == manual_linking_function(global_geometry_list.elements[loop_index].name,mask_string)) {
            add_element_to_int_list(&this_box_volume.geometry.mask_list,global_geometry_list.elements[loop_index].component_index);
            add_element_to_int_list(&global_geometry_list.elements[loop_index].Volume->geometry.masked_by_list,INDEX_CURRENT_COMP);
            global_geometry_list.elements[loop_index].Volume->geometry.is_masked_volume = 1;
            if (this_box_volume.geometry.mask_mode == 2)
                global_geometry_list.elements[loop_index].Volume->geometry.mask_mode = 2;
            if (this_box_volume.geometry.mask_mode == 1) {
                if (global_geometry_list.elements[loop_index].Volume->geometry.is_masked_volume == 1 && global_geometry_list.elements[loop_index].Volume->geometry.mask_mode != 2)
                    // If more than one mask is added to one volume, the ANY mode overwrites the (default) ALL mode.
                    global_geometry_list.elements[loop_index].Volume->geometry.mask_mode = 1;
            }
            
            found_geometries = 1;
        }
    }
    if (found_geometries == 0) {
        printf("The mask_string in geometry: %s did not find any of the specified volumes in the mask_string %s \n",NAME_CURRENT_COMP,mask_string);
        exit(1);
    }
    this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
    this_box_volume.p_physics->is_vacuum = 0; // Makes this volume a vacuum
    this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
    this_box_volume.p_physics->my_a = 0; // Should not be used.
    sprintf(this_box_volume.p_physics->name,"Mask");
    this_box_volume.geometry.is_mask_volume = 1;
    
    
// Read the material input, or if it lacks, use automatic linking.
} else if (material_string && strlen(material_string) && strcmp(material_string, "NULL") && strcmp(material_string, "0")) {
    // A geometry string was given, use it to determine which material
    if (0 == strcmp(material_string,"vacuum") || 0 == strcmp(material_string,"Vacuum")) {
        // One could have a global physics struct for vacuum instead of creating one for each
        this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
        this_box_volume.p_physics->is_vacuum = 1; // Makes this volume a vacuum
        this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
        this_box_volume.p_physics->my_a = 0; // Should not be used.
        sprintf(this_box_volume.p_physics->name,"Vacuum");
    } else if (0 == strcmp(material_string,"exit") || 0 == strcmp(material_string,"Exit")) {
        // One could have a global physics struct for vacuum instead of creating one for each
        this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
        this_box_volume.p_physics->is_vacuum = 1; // Makes this volume a vacuum
        this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
        this_box_volume.p_physics->my_a = 0; // Should not be used.
        this_box_volume.geometry.is_exit_volume = 1;
        sprintf(this_box_volume.p_physics->name,"Exit");
    } else {
        #ifndef MATERIAL_DETECTOR
            printf("Need to define a material before refering to it in a geometry %s.\n",NAME_CURRENT_COMP);
            exit(1);
        #endif
        for (loop_index=0;loop_index<global_material_list.num_elements;loop_index++) {
            if (0 == strcmp(material_string,global_material_list.elements[loop_index].name)) {
                this_box_volume.p_physics = global_material_list.elements[loop_index].physics;
                break;
            }
            if (loop_index == global_material_list.num_elements-1) {
            printf("\n");
            printf("ERROR: The material string \"%s\" in Union geometry \"%s\" did not match a specified material. \n",material_string,NAME_CURRENT_COMP);
            printf("       The materials available at this point (need to be defined before the geometry): \n");
            for (loop_index=0;loop_index<global_material_list.num_elements;loop_index++)
              printf("         %s\n",global_material_list.elements[loop_index].name);
            printf("\n");
            printf("       It is also possible to use one of the defualt materials avaiable: \n");
            printf("           Vacuum (for a Volume without scattering or absorption)\n");
            printf("           Exit (for a Volume where the ray exits the component if it enters)\n");
            printf("           Mask (for a Volume that masks existing volumes specified in the mask_string\n");
            exit(1);
          }
        }
    }
} else {
    // Automatic linking, simply using the last defined material.
    #ifndef MATERIAL_DETECTOR
        printf("Need to define a material before the geometry to use automatic linking %s.\n",NAME_CURRENT_COMP);
        exit(1);
    #endif
    this_box_volume.p_physics = global_material_list.elements[global_material_list.num_elements-1].physics;
}

sprintf(this_box_volume.name,NAME_CURRENT_COMP);
sprintf(this_box_volume.geometry.shape,"box");
this_box_volume.geometry.priority_value = priority;
this_box_volume.geometry.geometry_p_interact = p_interact;
// Currently the coordinates will be in absolute space.
this_box_volume.geometry.center = POS_A_CURRENT_COMP;

this_box_storage.z_depth = zdepth;
this_box_storage.x_width1 = xwidth;
this_box_storage.y_height1 = yheight;

this_box_storage.is_rectangle = 0;
if (xwidth2 < 0 && yheight2 < 0) this_box_storage.is_rectangle = 1;
if (xwidth == xwidth2 && yheight == yheight2) this_box_storage.is_rectangle = 1;

if (xwidth2 < 0) {
    this_box_storage.x_width2 = xwidth;
    xwidth2 = xwidth;
} else this_box_storage.x_width2 = xwidth2;

if (yheight2 < 0) {
    this_box_storage.y_height2 = yheight;
    yheight2 = yheight;
} else this_box_storage.y_height2 = yheight2;


this_box_storage.normal_vectors[0] = coords_set(0,0,1);
this_box_storage.normal_vectors[1] = coords_set(0,0,1);

// for sides with y component = 0
x_component = 2*zdepth/sqrt((xwidth-xwidth2)*(xwidth-xwidth2)+4*zdepth*zdepth);
z_component = (xwidth-xwidth2)/sqrt(4*zdepth*zdepth+(xwidth-xwidth2)*(xwidth-xwidth2));

this_box_storage.normal_vectors[2] = coords_set(x_component,0,z_component);
this_box_storage.normal_vectors[3] = coords_set(-x_component,0,z_component);

// for sides with x component = 0
y_component = 2*zdepth/sqrt((yheight-yheight2)*(yheight-yheight2)+4*zdepth*zdepth);
z_component = (yheight-yheight2)/sqrt(4*zdepth*zdepth+(yheight-yheight2)*(yheight-yheight2));

this_box_storage.normal_vectors[4] = coords_set(0,y_component,z_component);
this_box_storage.normal_vectors[5] = coords_set(0,-y_component,z_component);

this_box_volume.geometry.visualization_on = visualize;

this_box_volume.geometry.geometry_parameters.p_box_storage = &this_box_storage;

// Assign pointers to functions for intersection with the shape, checking if a point is inside the shape
if (this_box_storage.is_rectangle == 1) {
this_box_volume.geometry.intersect_function = &sample_box_intersect_simple;
this_box_volume.geometry.within_function = &r_within_box_simple;
}
else {
this_box_volume.geometry.intersect_function = &sample_box_intersect_advanced;
this_box_volume.geometry.within_function = &r_within_box_advanced;
}

this_box_volume.geometry.shell_points = &box_shell_points;
this_box_volume.geometry.mcdisplay_function = &mcdisplay_box_function;
this_box_volume.geometry.initialize_from_main_function = &initialize_box_geometry_from_main_component;
this_box_volume.geometry.process_rot_allocated = 0;

this_box_volume.geometry.copy_geometry_parameters = &allocate_box_storage_copy;

rot_copy(this_box_volume.geometry.rotation_matrix,ROT_A_CURRENT_COMP); //check how ROT_R_CURRENT_COMP would work
rot_transpose(ROT_A_CURRENT_COMP,this_box_volume.geometry.transpose_rotation_matrix);

// Initialize loggers
this_box_volume.loggers.num_elements = 0;

// packing the information into the global_geometry_element, which is then included in the global_geometry_list.
sprintf(global_geometry_element.name,NAME_CURRENT_COMP);
global_geometry_element.activation_counter = number_of_activations;
global_geometry_element.component_index = INDEX_CURRENT_COMP;
global_geometry_element.Volume = &this_box_volume; // Would be nicer if this m was a pointer, now we have the (small) data two places
add_element_to_geometry_list(&global_geometry_list,global_geometry_element);
}
#line 294746 "MACS_sample_kidney_box.c"
#undef number_of_activations
#undef mask_setting
#undef mask_string
#undef p_interact
#undef focus_r
#undef focus_xh
#undef focus_xw
#undef focus_ah
#undef focus_aw
#undef target_z
#undef target_y
#undef target_x
#undef target_index
#undef visualize
#undef yheight2
#undef xwidth2
#undef zdepth
#undef yheight
#undef xwidth
#undef priority
#undef material_string
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

  /* Initializations for component inter_analyzer_colimator_center_14. */
  SIG_MESSAGE("inter_analyzer_colimator_center_14 (Init)");

  /* Initializations for component inter_analyzer_colimator_14_blade_0. */
  SIG_MESSAGE("inter_analyzer_colimator_14_blade_0 (Init)");
#define mccompcurname  inter_analyzer_colimator_14_blade_0
#define mccompcurtype  Union_box
#define mccompcurindex 687
#define loop_index mccinter_analyzer_colimator_14_blade_0_loop_index
#define this_box_volume mccinter_analyzer_colimator_14_blade_0_this_box_volume
#define global_geometry_element mccinter_analyzer_colimator_14_blade_0_global_geometry_element
#define this_box_storage mccinter_analyzer_colimator_14_blade_0_this_box_storage
#define material_string mccinter_analyzer_colimator_14_blade_0_material_string
#define priority mccinter_analyzer_colimator_14_blade_0_priority
#define xwidth mccinter_analyzer_colimator_14_blade_0_xwidth
#define yheight mccinter_analyzer_colimator_14_blade_0_yheight
#define zdepth mccinter_analyzer_colimator_14_blade_0_zdepth
#define xwidth2 mccinter_analyzer_colimator_14_blade_0_xwidth2
#define yheight2 mccinter_analyzer_colimator_14_blade_0_yheight2
#define visualize mccinter_analyzer_colimator_14_blade_0_visualize
#define target_index mccinter_analyzer_colimator_14_blade_0_target_index
#define target_x mccinter_analyzer_colimator_14_blade_0_target_x
#define target_y mccinter_analyzer_colimator_14_blade_0_target_y
#define target_z mccinter_analyzer_colimator_14_blade_0_target_z
#define focus_aw mccinter_analyzer_colimator_14_blade_0_focus_aw
#define focus_ah mccinter_analyzer_colimator_14_blade_0_focus_ah
#define focus_xw mccinter_analyzer_colimator_14_blade_0_focus_xw
#define focus_xh mccinter_analyzer_colimator_14_blade_0_focus_xh
#define focus_r mccinter_analyzer_colimator_14_blade_0_focus_r
#define p_interact mccinter_analyzer_colimator_14_blade_0_p_interact
#define mask_string mccinter_analyzer_colimator_14_blade_0_mask_string
#define mask_setting mccinter_analyzer_colimator_14_blade_0_mask_setting
#define number_of_activations mccinter_analyzer_colimator_14_blade_0_number_of_activations
#line 224 "Union_box.comp"
{
// Initializes the focusing system for this volume including input sanitation.
focus_initialize(&this_box_volume.geometry, POS_A_COMP_INDEX(INDEX_CURRENT_COMP+target_index), POS_A_CURRENT_COMP, ROT_A_CURRENT_COMP, target_index, target_x, target_y, target_z, focus_aw, focus_ah, focus_xw, focus_xh, focus_r, NAME_CURRENT_COMP);

// Input sanitation for this geometry
if (xwidth <= 0) {
  printf("\nERROR in Union_box named %s, the xwidth is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (yheight <= 0) {
  printf("\nERROR in Union_box named %s, yheight is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (zdepth <= 0) {
  printf("\nERROR in Union_box named %s, zdepth is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (xwidth2 <= 0 && xwidth2 != -1) {
  printf("\nERROR in Union_box named %s, the xwidth2 is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (yheight2 <= 0 && yheight2 != -1) {
  printf("\nERROR in Union_box named %s, yheight2 is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}

// Use sanitation
if (global_material_list.num_elements == 0) {
  printf("\nERROR: Need to define a material using Union_make_material before using a Union geometry component. \n");
  printf("       %s was defined before first use of Union_make_material.\n",NAME_CURRENT_COMP);
  exit(1);
}

this_box_volume.geometry.is_masked_volume = 0;
this_box_volume.geometry.is_exit_volume = 0;
this_box_volume.geometry.is_mask_volume = 0;
// check if the volume is a mask, if it is the material string is irelevant.
if (mask_string && strlen(mask_string) && strcmp(mask_string, "NULL") && strcmp(mask_string, "0")) {
    // A mask volume is used to limit the extend of other volumes, called the masked volumes. These are specified in the mask_string.
    // In order for a ray to enter a masked volume, it needs to be both in the region covered by that volume AND the mask volume.
    // When more than
    this_box_volume.geometry.mask_mode = 1; // Default is mask mode is ALL
    if (mask_setting && strlen(mask_setting) && strcmp(mask_setting, "NULL") && strcmp(mask_setting, "0")) {
        if (strcmp(mask_setting,"ALL") == 0 || strcmp(mask_setting,"All") == 0) this_box_volume.geometry.mask_mode = 1;
        else if (strcmp(mask_setting,"ANY") == 0 || strcmp(mask_setting,"Any") == 0) this_box_volume.geometry.mask_mode = 2;
        else {
            printf("The mask_mode of component %s is set to %s, but must be either ALL or ANY.\n",NAME_CURRENT_COMP,mask_setting);
            exit(1);
        }
    }
    
    for (loop_index=0;loop_index<global_geometry_list.num_elements;loop_index++) {
        // Add mask list
        if (1 == manual_linking_function(global_geometry_list.elements[loop_index].name,mask_string)) {
            add_element_to_int_list(&this_box_volume.geometry.mask_list,global_geometry_list.elements[loop_index].component_index);
            add_element_to_int_list(&global_geometry_list.elements[loop_index].Volume->geometry.masked_by_list,INDEX_CURRENT_COMP);
            global_geometry_list.elements[loop_index].Volume->geometry.is_masked_volume = 1;
            if (this_box_volume.geometry.mask_mode == 2)
                global_geometry_list.elements[loop_index].Volume->geometry.mask_mode = 2;
            if (this_box_volume.geometry.mask_mode == 1) {
                if (global_geometry_list.elements[loop_index].Volume->geometry.is_masked_volume == 1 && global_geometry_list.elements[loop_index].Volume->geometry.mask_mode != 2)
                    // If more than one mask is added to one volume, the ANY mode overwrites the (default) ALL mode.
                    global_geometry_list.elements[loop_index].Volume->geometry.mask_mode = 1;
            }
            
            found_geometries = 1;
        }
    }
    if (found_geometries == 0) {
        printf("The mask_string in geometry: %s did not find any of the specified volumes in the mask_string %s \n",NAME_CURRENT_COMP,mask_string);
        exit(1);
    }
    this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
    this_box_volume.p_physics->is_vacuum = 0; // Makes this volume a vacuum
    this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
    this_box_volume.p_physics->my_a = 0; // Should not be used.
    sprintf(this_box_volume.p_physics->name,"Mask");
    this_box_volume.geometry.is_mask_volume = 1;
    
    
// Read the material input, or if it lacks, use automatic linking.
} else if (material_string && strlen(material_string) && strcmp(material_string, "NULL") && strcmp(material_string, "0")) {
    // A geometry string was given, use it to determine which material
    if (0 == strcmp(material_string,"vacuum") || 0 == strcmp(material_string,"Vacuum")) {
        // One could have a global physics struct for vacuum instead of creating one for each
        this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
        this_box_volume.p_physics->is_vacuum = 1; // Makes this volume a vacuum
        this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
        this_box_volume.p_physics->my_a = 0; // Should not be used.
        sprintf(this_box_volume.p_physics->name,"Vacuum");
    } else if (0 == strcmp(material_string,"exit") || 0 == strcmp(material_string,"Exit")) {
        // One could have a global physics struct for vacuum instead of creating one for each
        this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
        this_box_volume.p_physics->is_vacuum = 1; // Makes this volume a vacuum
        this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
        this_box_volume.p_physics->my_a = 0; // Should not be used.
        this_box_volume.geometry.is_exit_volume = 1;
        sprintf(this_box_volume.p_physics->name,"Exit");
    } else {
        #ifndef MATERIAL_DETECTOR
            printf("Need to define a material before refering to it in a geometry %s.\n",NAME_CURRENT_COMP);
            exit(1);
        #endif
        for (loop_index=0;loop_index<global_material_list.num_elements;loop_index++) {
            if (0 == strcmp(material_string,global_material_list.elements[loop_index].name)) {
                this_box_volume.p_physics = global_material_list.elements[loop_index].physics;
                break;
            }
            if (loop_index == global_material_list.num_elements-1) {
            printf("\n");
            printf("ERROR: The material string \"%s\" in Union geometry \"%s\" did not match a specified material. \n",material_string,NAME_CURRENT_COMP);
            printf("       The materials available at this point (need to be defined before the geometry): \n");
            for (loop_index=0;loop_index<global_material_list.num_elements;loop_index++)
              printf("         %s\n",global_material_list.elements[loop_index].name);
            printf("\n");
            printf("       It is also possible to use one of the defualt materials avaiable: \n");
            printf("           Vacuum (for a Volume without scattering or absorption)\n");
            printf("           Exit (for a Volume where the ray exits the component if it enters)\n");
            printf("           Mask (for a Volume that masks existing volumes specified in the mask_string\n");
            exit(1);
          }
        }
    }
} else {
    // Automatic linking, simply using the last defined material.
    #ifndef MATERIAL_DETECTOR
        printf("Need to define a material before the geometry to use automatic linking %s.\n",NAME_CURRENT_COMP);
        exit(1);
    #endif
    this_box_volume.p_physics = global_material_list.elements[global_material_list.num_elements-1].physics;
}

sprintf(this_box_volume.name,NAME_CURRENT_COMP);
sprintf(this_box_volume.geometry.shape,"box");
this_box_volume.geometry.priority_value = priority;
this_box_volume.geometry.geometry_p_interact = p_interact;
// Currently the coordinates will be in absolute space.
this_box_volume.geometry.center = POS_A_CURRENT_COMP;

this_box_storage.z_depth = zdepth;
this_box_storage.x_width1 = xwidth;
this_box_storage.y_height1 = yheight;

this_box_storage.is_rectangle = 0;
if (xwidth2 < 0 && yheight2 < 0) this_box_storage.is_rectangle = 1;
if (xwidth == xwidth2 && yheight == yheight2) this_box_storage.is_rectangle = 1;

if (xwidth2 < 0) {
    this_box_storage.x_width2 = xwidth;
    xwidth2 = xwidth;
} else this_box_storage.x_width2 = xwidth2;

if (yheight2 < 0) {
    this_box_storage.y_height2 = yheight;
    yheight2 = yheight;
} else this_box_storage.y_height2 = yheight2;


this_box_storage.normal_vectors[0] = coords_set(0,0,1);
this_box_storage.normal_vectors[1] = coords_set(0,0,1);

// for sides with y component = 0
x_component = 2*zdepth/sqrt((xwidth-xwidth2)*(xwidth-xwidth2)+4*zdepth*zdepth);
z_component = (xwidth-xwidth2)/sqrt(4*zdepth*zdepth+(xwidth-xwidth2)*(xwidth-xwidth2));

this_box_storage.normal_vectors[2] = coords_set(x_component,0,z_component);
this_box_storage.normal_vectors[3] = coords_set(-x_component,0,z_component);

// for sides with x component = 0
y_component = 2*zdepth/sqrt((yheight-yheight2)*(yheight-yheight2)+4*zdepth*zdepth);
z_component = (yheight-yheight2)/sqrt(4*zdepth*zdepth+(yheight-yheight2)*(yheight-yheight2));

this_box_storage.normal_vectors[4] = coords_set(0,y_component,z_component);
this_box_storage.normal_vectors[5] = coords_set(0,-y_component,z_component);

this_box_volume.geometry.visualization_on = visualize;

this_box_volume.geometry.geometry_parameters.p_box_storage = &this_box_storage;

// Assign pointers to functions for intersection with the shape, checking if a point is inside the shape
if (this_box_storage.is_rectangle == 1) {
this_box_volume.geometry.intersect_function = &sample_box_intersect_simple;
this_box_volume.geometry.within_function = &r_within_box_simple;
}
else {
this_box_volume.geometry.intersect_function = &sample_box_intersect_advanced;
this_box_volume.geometry.within_function = &r_within_box_advanced;
}

this_box_volume.geometry.shell_points = &box_shell_points;
this_box_volume.geometry.mcdisplay_function = &mcdisplay_box_function;
this_box_volume.geometry.initialize_from_main_function = &initialize_box_geometry_from_main_component;
this_box_volume.geometry.process_rot_allocated = 0;

this_box_volume.geometry.copy_geometry_parameters = &allocate_box_storage_copy;

rot_copy(this_box_volume.geometry.rotation_matrix,ROT_A_CURRENT_COMP); //check how ROT_R_CURRENT_COMP would work
rot_transpose(ROT_A_CURRENT_COMP,this_box_volume.geometry.transpose_rotation_matrix);

// Initialize loggers
this_box_volume.loggers.num_elements = 0;

// packing the information into the global_geometry_element, which is then included in the global_geometry_list.
sprintf(global_geometry_element.name,NAME_CURRENT_COMP);
global_geometry_element.activation_counter = number_of_activations;
global_geometry_element.component_index = INDEX_CURRENT_COMP;
global_geometry_element.Volume = &this_box_volume; // Would be nicer if this m was a pointer, now we have the (small) data two places
add_element_to_geometry_list(&global_geometry_list,global_geometry_element);
}
#line 295019 "MACS_sample_kidney_box.c"
#undef number_of_activations
#undef mask_setting
#undef mask_string
#undef p_interact
#undef focus_r
#undef focus_xh
#undef focus_xw
#undef focus_ah
#undef focus_aw
#undef target_z
#undef target_y
#undef target_x
#undef target_index
#undef visualize
#undef yheight2
#undef xwidth2
#undef zdepth
#undef yheight
#undef xwidth
#undef priority
#undef material_string
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

  /* Initializations for component inter_analyzer_colimator_14_blade_1. */
  SIG_MESSAGE("inter_analyzer_colimator_14_blade_1 (Init)");
#define mccompcurname  inter_analyzer_colimator_14_blade_1
#define mccompcurtype  Union_box
#define mccompcurindex 688
#define loop_index mccinter_analyzer_colimator_14_blade_1_loop_index
#define this_box_volume mccinter_analyzer_colimator_14_blade_1_this_box_volume
#define global_geometry_element mccinter_analyzer_colimator_14_blade_1_global_geometry_element
#define this_box_storage mccinter_analyzer_colimator_14_blade_1_this_box_storage
#define material_string mccinter_analyzer_colimator_14_blade_1_material_string
#define priority mccinter_analyzer_colimator_14_blade_1_priority
#define xwidth mccinter_analyzer_colimator_14_blade_1_xwidth
#define yheight mccinter_analyzer_colimator_14_blade_1_yheight
#define zdepth mccinter_analyzer_colimator_14_blade_1_zdepth
#define xwidth2 mccinter_analyzer_colimator_14_blade_1_xwidth2
#define yheight2 mccinter_analyzer_colimator_14_blade_1_yheight2
#define visualize mccinter_analyzer_colimator_14_blade_1_visualize
#define target_index mccinter_analyzer_colimator_14_blade_1_target_index
#define target_x mccinter_analyzer_colimator_14_blade_1_target_x
#define target_y mccinter_analyzer_colimator_14_blade_1_target_y
#define target_z mccinter_analyzer_colimator_14_blade_1_target_z
#define focus_aw mccinter_analyzer_colimator_14_blade_1_focus_aw
#define focus_ah mccinter_analyzer_colimator_14_blade_1_focus_ah
#define focus_xw mccinter_analyzer_colimator_14_blade_1_focus_xw
#define focus_xh mccinter_analyzer_colimator_14_blade_1_focus_xh
#define focus_r mccinter_analyzer_colimator_14_blade_1_focus_r
#define p_interact mccinter_analyzer_colimator_14_blade_1_p_interact
#define mask_string mccinter_analyzer_colimator_14_blade_1_mask_string
#define mask_setting mccinter_analyzer_colimator_14_blade_1_mask_setting
#define number_of_activations mccinter_analyzer_colimator_14_blade_1_number_of_activations
#line 224 "Union_box.comp"
{
// Initializes the focusing system for this volume including input sanitation.
focus_initialize(&this_box_volume.geometry, POS_A_COMP_INDEX(INDEX_CURRENT_COMP+target_index), POS_A_CURRENT_COMP, ROT_A_CURRENT_COMP, target_index, target_x, target_y, target_z, focus_aw, focus_ah, focus_xw, focus_xh, focus_r, NAME_CURRENT_COMP);

// Input sanitation for this geometry
if (xwidth <= 0) {
  printf("\nERROR in Union_box named %s, the xwidth is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (yheight <= 0) {
  printf("\nERROR in Union_box named %s, yheight is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (zdepth <= 0) {
  printf("\nERROR in Union_box named %s, zdepth is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (xwidth2 <= 0 && xwidth2 != -1) {
  printf("\nERROR in Union_box named %s, the xwidth2 is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (yheight2 <= 0 && yheight2 != -1) {
  printf("\nERROR in Union_box named %s, yheight2 is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}

// Use sanitation
if (global_material_list.num_elements == 0) {
  printf("\nERROR: Need to define a material using Union_make_material before using a Union geometry component. \n");
  printf("       %s was defined before first use of Union_make_material.\n",NAME_CURRENT_COMP);
  exit(1);
}

this_box_volume.geometry.is_masked_volume = 0;
this_box_volume.geometry.is_exit_volume = 0;
this_box_volume.geometry.is_mask_volume = 0;
// check if the volume is a mask, if it is the material string is irelevant.
if (mask_string && strlen(mask_string) && strcmp(mask_string, "NULL") && strcmp(mask_string, "0")) {
    // A mask volume is used to limit the extend of other volumes, called the masked volumes. These are specified in the mask_string.
    // In order for a ray to enter a masked volume, it needs to be both in the region covered by that volume AND the mask volume.
    // When more than
    this_box_volume.geometry.mask_mode = 1; // Default is mask mode is ALL
    if (mask_setting && strlen(mask_setting) && strcmp(mask_setting, "NULL") && strcmp(mask_setting, "0")) {
        if (strcmp(mask_setting,"ALL") == 0 || strcmp(mask_setting,"All") == 0) this_box_volume.geometry.mask_mode = 1;
        else if (strcmp(mask_setting,"ANY") == 0 || strcmp(mask_setting,"Any") == 0) this_box_volume.geometry.mask_mode = 2;
        else {
            printf("The mask_mode of component %s is set to %s, but must be either ALL or ANY.\n",NAME_CURRENT_COMP,mask_setting);
            exit(1);
        }
    }
    
    for (loop_index=0;loop_index<global_geometry_list.num_elements;loop_index++) {
        // Add mask list
        if (1 == manual_linking_function(global_geometry_list.elements[loop_index].name,mask_string)) {
            add_element_to_int_list(&this_box_volume.geometry.mask_list,global_geometry_list.elements[loop_index].component_index);
            add_element_to_int_list(&global_geometry_list.elements[loop_index].Volume->geometry.masked_by_list,INDEX_CURRENT_COMP);
            global_geometry_list.elements[loop_index].Volume->geometry.is_masked_volume = 1;
            if (this_box_volume.geometry.mask_mode == 2)
                global_geometry_list.elements[loop_index].Volume->geometry.mask_mode = 2;
            if (this_box_volume.geometry.mask_mode == 1) {
                if (global_geometry_list.elements[loop_index].Volume->geometry.is_masked_volume == 1 && global_geometry_list.elements[loop_index].Volume->geometry.mask_mode != 2)
                    // If more than one mask is added to one volume, the ANY mode overwrites the (default) ALL mode.
                    global_geometry_list.elements[loop_index].Volume->geometry.mask_mode = 1;
            }
            
            found_geometries = 1;
        }
    }
    if (found_geometries == 0) {
        printf("The mask_string in geometry: %s did not find any of the specified volumes in the mask_string %s \n",NAME_CURRENT_COMP,mask_string);
        exit(1);
    }
    this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
    this_box_volume.p_physics->is_vacuum = 0; // Makes this volume a vacuum
    this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
    this_box_volume.p_physics->my_a = 0; // Should not be used.
    sprintf(this_box_volume.p_physics->name,"Mask");
    this_box_volume.geometry.is_mask_volume = 1;
    
    
// Read the material input, or if it lacks, use automatic linking.
} else if (material_string && strlen(material_string) && strcmp(material_string, "NULL") && strcmp(material_string, "0")) {
    // A geometry string was given, use it to determine which material
    if (0 == strcmp(material_string,"vacuum") || 0 == strcmp(material_string,"Vacuum")) {
        // One could have a global physics struct for vacuum instead of creating one for each
        this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
        this_box_volume.p_physics->is_vacuum = 1; // Makes this volume a vacuum
        this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
        this_box_volume.p_physics->my_a = 0; // Should not be used.
        sprintf(this_box_volume.p_physics->name,"Vacuum");
    } else if (0 == strcmp(material_string,"exit") || 0 == strcmp(material_string,"Exit")) {
        // One could have a global physics struct for vacuum instead of creating one for each
        this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
        this_box_volume.p_physics->is_vacuum = 1; // Makes this volume a vacuum
        this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
        this_box_volume.p_physics->my_a = 0; // Should not be used.
        this_box_volume.geometry.is_exit_volume = 1;
        sprintf(this_box_volume.p_physics->name,"Exit");
    } else {
        #ifndef MATERIAL_DETECTOR
            printf("Need to define a material before refering to it in a geometry %s.\n",NAME_CURRENT_COMP);
            exit(1);
        #endif
        for (loop_index=0;loop_index<global_material_list.num_elements;loop_index++) {
            if (0 == strcmp(material_string,global_material_list.elements[loop_index].name)) {
                this_box_volume.p_physics = global_material_list.elements[loop_index].physics;
                break;
            }
            if (loop_index == global_material_list.num_elements-1) {
            printf("\n");
            printf("ERROR: The material string \"%s\" in Union geometry \"%s\" did not match a specified material. \n",material_string,NAME_CURRENT_COMP);
            printf("       The materials available at this point (need to be defined before the geometry): \n");
            for (loop_index=0;loop_index<global_material_list.num_elements;loop_index++)
              printf("         %s\n",global_material_list.elements[loop_index].name);
            printf("\n");
            printf("       It is also possible to use one of the defualt materials avaiable: \n");
            printf("           Vacuum (for a Volume without scattering or absorption)\n");
            printf("           Exit (for a Volume where the ray exits the component if it enters)\n");
            printf("           Mask (for a Volume that masks existing volumes specified in the mask_string\n");
            exit(1);
          }
        }
    }
} else {
    // Automatic linking, simply using the last defined material.
    #ifndef MATERIAL_DETECTOR
        printf("Need to define a material before the geometry to use automatic linking %s.\n",NAME_CURRENT_COMP);
        exit(1);
    #endif
    this_box_volume.p_physics = global_material_list.elements[global_material_list.num_elements-1].physics;
}

sprintf(this_box_volume.name,NAME_CURRENT_COMP);
sprintf(this_box_volume.geometry.shape,"box");
this_box_volume.geometry.priority_value = priority;
this_box_volume.geometry.geometry_p_interact = p_interact;
// Currently the coordinates will be in absolute space.
this_box_volume.geometry.center = POS_A_CURRENT_COMP;

this_box_storage.z_depth = zdepth;
this_box_storage.x_width1 = xwidth;
this_box_storage.y_height1 = yheight;

this_box_storage.is_rectangle = 0;
if (xwidth2 < 0 && yheight2 < 0) this_box_storage.is_rectangle = 1;
if (xwidth == xwidth2 && yheight == yheight2) this_box_storage.is_rectangle = 1;

if (xwidth2 < 0) {
    this_box_storage.x_width2 = xwidth;
    xwidth2 = xwidth;
} else this_box_storage.x_width2 = xwidth2;

if (yheight2 < 0) {
    this_box_storage.y_height2 = yheight;
    yheight2 = yheight;
} else this_box_storage.y_height2 = yheight2;


this_box_storage.normal_vectors[0] = coords_set(0,0,1);
this_box_storage.normal_vectors[1] = coords_set(0,0,1);

// for sides with y component = 0
x_component = 2*zdepth/sqrt((xwidth-xwidth2)*(xwidth-xwidth2)+4*zdepth*zdepth);
z_component = (xwidth-xwidth2)/sqrt(4*zdepth*zdepth+(xwidth-xwidth2)*(xwidth-xwidth2));

this_box_storage.normal_vectors[2] = coords_set(x_component,0,z_component);
this_box_storage.normal_vectors[3] = coords_set(-x_component,0,z_component);

// for sides with x component = 0
y_component = 2*zdepth/sqrt((yheight-yheight2)*(yheight-yheight2)+4*zdepth*zdepth);
z_component = (yheight-yheight2)/sqrt(4*zdepth*zdepth+(yheight-yheight2)*(yheight-yheight2));

this_box_storage.normal_vectors[4] = coords_set(0,y_component,z_component);
this_box_storage.normal_vectors[5] = coords_set(0,-y_component,z_component);

this_box_volume.geometry.visualization_on = visualize;

this_box_volume.geometry.geometry_parameters.p_box_storage = &this_box_storage;

// Assign pointers to functions for intersection with the shape, checking if a point is inside the shape
if (this_box_storage.is_rectangle == 1) {
this_box_volume.geometry.intersect_function = &sample_box_intersect_simple;
this_box_volume.geometry.within_function = &r_within_box_simple;
}
else {
this_box_volume.geometry.intersect_function = &sample_box_intersect_advanced;
this_box_volume.geometry.within_function = &r_within_box_advanced;
}

this_box_volume.geometry.shell_points = &box_shell_points;
this_box_volume.geometry.mcdisplay_function = &mcdisplay_box_function;
this_box_volume.geometry.initialize_from_main_function = &initialize_box_geometry_from_main_component;
this_box_volume.geometry.process_rot_allocated = 0;

this_box_volume.geometry.copy_geometry_parameters = &allocate_box_storage_copy;

rot_copy(this_box_volume.geometry.rotation_matrix,ROT_A_CURRENT_COMP); //check how ROT_R_CURRENT_COMP would work
rot_transpose(ROT_A_CURRENT_COMP,this_box_volume.geometry.transpose_rotation_matrix);

// Initialize loggers
this_box_volume.loggers.num_elements = 0;

// packing the information into the global_geometry_element, which is then included in the global_geometry_list.
sprintf(global_geometry_element.name,NAME_CURRENT_COMP);
global_geometry_element.activation_counter = number_of_activations;
global_geometry_element.component_index = INDEX_CURRENT_COMP;
global_geometry_element.Volume = &this_box_volume; // Would be nicer if this m was a pointer, now we have the (small) data two places
add_element_to_geometry_list(&global_geometry_list,global_geometry_element);
}
#line 295289 "MACS_sample_kidney_box.c"
#undef number_of_activations
#undef mask_setting
#undef mask_string
#undef p_interact
#undef focus_r
#undef focus_xh
#undef focus_xw
#undef focus_ah
#undef focus_aw
#undef target_z
#undef target_y
#undef target_x
#undef target_index
#undef visualize
#undef yheight2
#undef xwidth2
#undef zdepth
#undef yheight
#undef xwidth
#undef priority
#undef material_string
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

  /* Initializations for component inter_analyzer_colimator_14_blade_2. */
  SIG_MESSAGE("inter_analyzer_colimator_14_blade_2 (Init)");
#define mccompcurname  inter_analyzer_colimator_14_blade_2
#define mccompcurtype  Union_box
#define mccompcurindex 689
#define loop_index mccinter_analyzer_colimator_14_blade_2_loop_index
#define this_box_volume mccinter_analyzer_colimator_14_blade_2_this_box_volume
#define global_geometry_element mccinter_analyzer_colimator_14_blade_2_global_geometry_element
#define this_box_storage mccinter_analyzer_colimator_14_blade_2_this_box_storage
#define material_string mccinter_analyzer_colimator_14_blade_2_material_string
#define priority mccinter_analyzer_colimator_14_blade_2_priority
#define xwidth mccinter_analyzer_colimator_14_blade_2_xwidth
#define yheight mccinter_analyzer_colimator_14_blade_2_yheight
#define zdepth mccinter_analyzer_colimator_14_blade_2_zdepth
#define xwidth2 mccinter_analyzer_colimator_14_blade_2_xwidth2
#define yheight2 mccinter_analyzer_colimator_14_blade_2_yheight2
#define visualize mccinter_analyzer_colimator_14_blade_2_visualize
#define target_index mccinter_analyzer_colimator_14_blade_2_target_index
#define target_x mccinter_analyzer_colimator_14_blade_2_target_x
#define target_y mccinter_analyzer_colimator_14_blade_2_target_y
#define target_z mccinter_analyzer_colimator_14_blade_2_target_z
#define focus_aw mccinter_analyzer_colimator_14_blade_2_focus_aw
#define focus_ah mccinter_analyzer_colimator_14_blade_2_focus_ah
#define focus_xw mccinter_analyzer_colimator_14_blade_2_focus_xw
#define focus_xh mccinter_analyzer_colimator_14_blade_2_focus_xh
#define focus_r mccinter_analyzer_colimator_14_blade_2_focus_r
#define p_interact mccinter_analyzer_colimator_14_blade_2_p_interact
#define mask_string mccinter_analyzer_colimator_14_blade_2_mask_string
#define mask_setting mccinter_analyzer_colimator_14_blade_2_mask_setting
#define number_of_activations mccinter_analyzer_colimator_14_blade_2_number_of_activations
#line 224 "Union_box.comp"
{
// Initializes the focusing system for this volume including input sanitation.
focus_initialize(&this_box_volume.geometry, POS_A_COMP_INDEX(INDEX_CURRENT_COMP+target_index), POS_A_CURRENT_COMP, ROT_A_CURRENT_COMP, target_index, target_x, target_y, target_z, focus_aw, focus_ah, focus_xw, focus_xh, focus_r, NAME_CURRENT_COMP);

// Input sanitation for this geometry
if (xwidth <= 0) {
  printf("\nERROR in Union_box named %s, the xwidth is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (yheight <= 0) {
  printf("\nERROR in Union_box named %s, yheight is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (zdepth <= 0) {
  printf("\nERROR in Union_box named %s, zdepth is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (xwidth2 <= 0 && xwidth2 != -1) {
  printf("\nERROR in Union_box named %s, the xwidth2 is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (yheight2 <= 0 && yheight2 != -1) {
  printf("\nERROR in Union_box named %s, yheight2 is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}

// Use sanitation
if (global_material_list.num_elements == 0) {
  printf("\nERROR: Need to define a material using Union_make_material before using a Union geometry component. \n");
  printf("       %s was defined before first use of Union_make_material.\n",NAME_CURRENT_COMP);
  exit(1);
}

this_box_volume.geometry.is_masked_volume = 0;
this_box_volume.geometry.is_exit_volume = 0;
this_box_volume.geometry.is_mask_volume = 0;
// check if the volume is a mask, if it is the material string is irelevant.
if (mask_string && strlen(mask_string) && strcmp(mask_string, "NULL") && strcmp(mask_string, "0")) {
    // A mask volume is used to limit the extend of other volumes, called the masked volumes. These are specified in the mask_string.
    // In order for a ray to enter a masked volume, it needs to be both in the region covered by that volume AND the mask volume.
    // When more than
    this_box_volume.geometry.mask_mode = 1; // Default is mask mode is ALL
    if (mask_setting && strlen(mask_setting) && strcmp(mask_setting, "NULL") && strcmp(mask_setting, "0")) {
        if (strcmp(mask_setting,"ALL") == 0 || strcmp(mask_setting,"All") == 0) this_box_volume.geometry.mask_mode = 1;
        else if (strcmp(mask_setting,"ANY") == 0 || strcmp(mask_setting,"Any") == 0) this_box_volume.geometry.mask_mode = 2;
        else {
            printf("The mask_mode of component %s is set to %s, but must be either ALL or ANY.\n",NAME_CURRENT_COMP,mask_setting);
            exit(1);
        }
    }
    
    for (loop_index=0;loop_index<global_geometry_list.num_elements;loop_index++) {
        // Add mask list
        if (1 == manual_linking_function(global_geometry_list.elements[loop_index].name,mask_string)) {
            add_element_to_int_list(&this_box_volume.geometry.mask_list,global_geometry_list.elements[loop_index].component_index);
            add_element_to_int_list(&global_geometry_list.elements[loop_index].Volume->geometry.masked_by_list,INDEX_CURRENT_COMP);
            global_geometry_list.elements[loop_index].Volume->geometry.is_masked_volume = 1;
            if (this_box_volume.geometry.mask_mode == 2)
                global_geometry_list.elements[loop_index].Volume->geometry.mask_mode = 2;
            if (this_box_volume.geometry.mask_mode == 1) {
                if (global_geometry_list.elements[loop_index].Volume->geometry.is_masked_volume == 1 && global_geometry_list.elements[loop_index].Volume->geometry.mask_mode != 2)
                    // If more than one mask is added to one volume, the ANY mode overwrites the (default) ALL mode.
                    global_geometry_list.elements[loop_index].Volume->geometry.mask_mode = 1;
            }
            
            found_geometries = 1;
        }
    }
    if (found_geometries == 0) {
        printf("The mask_string in geometry: %s did not find any of the specified volumes in the mask_string %s \n",NAME_CURRENT_COMP,mask_string);
        exit(1);
    }
    this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
    this_box_volume.p_physics->is_vacuum = 0; // Makes this volume a vacuum
    this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
    this_box_volume.p_physics->my_a = 0; // Should not be used.
    sprintf(this_box_volume.p_physics->name,"Mask");
    this_box_volume.geometry.is_mask_volume = 1;
    
    
// Read the material input, or if it lacks, use automatic linking.
} else if (material_string && strlen(material_string) && strcmp(material_string, "NULL") && strcmp(material_string, "0")) {
    // A geometry string was given, use it to determine which material
    if (0 == strcmp(material_string,"vacuum") || 0 == strcmp(material_string,"Vacuum")) {
        // One could have a global physics struct for vacuum instead of creating one for each
        this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
        this_box_volume.p_physics->is_vacuum = 1; // Makes this volume a vacuum
        this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
        this_box_volume.p_physics->my_a = 0; // Should not be used.
        sprintf(this_box_volume.p_physics->name,"Vacuum");
    } else if (0 == strcmp(material_string,"exit") || 0 == strcmp(material_string,"Exit")) {
        // One could have a global physics struct for vacuum instead of creating one for each
        this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
        this_box_volume.p_physics->is_vacuum = 1; // Makes this volume a vacuum
        this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
        this_box_volume.p_physics->my_a = 0; // Should not be used.
        this_box_volume.geometry.is_exit_volume = 1;
        sprintf(this_box_volume.p_physics->name,"Exit");
    } else {
        #ifndef MATERIAL_DETECTOR
            printf("Need to define a material before refering to it in a geometry %s.\n",NAME_CURRENT_COMP);
            exit(1);
        #endif
        for (loop_index=0;loop_index<global_material_list.num_elements;loop_index++) {
            if (0 == strcmp(material_string,global_material_list.elements[loop_index].name)) {
                this_box_volume.p_physics = global_material_list.elements[loop_index].physics;
                break;
            }
            if (loop_index == global_material_list.num_elements-1) {
            printf("\n");
            printf("ERROR: The material string \"%s\" in Union geometry \"%s\" did not match a specified material. \n",material_string,NAME_CURRENT_COMP);
            printf("       The materials available at this point (need to be defined before the geometry): \n");
            for (loop_index=0;loop_index<global_material_list.num_elements;loop_index++)
              printf("         %s\n",global_material_list.elements[loop_index].name);
            printf("\n");
            printf("       It is also possible to use one of the defualt materials avaiable: \n");
            printf("           Vacuum (for a Volume without scattering or absorption)\n");
            printf("           Exit (for a Volume where the ray exits the component if it enters)\n");
            printf("           Mask (for a Volume that masks existing volumes specified in the mask_string\n");
            exit(1);
          }
        }
    }
} else {
    // Automatic linking, simply using the last defined material.
    #ifndef MATERIAL_DETECTOR
        printf("Need to define a material before the geometry to use automatic linking %s.\n",NAME_CURRENT_COMP);
        exit(1);
    #endif
    this_box_volume.p_physics = global_material_list.elements[global_material_list.num_elements-1].physics;
}

sprintf(this_box_volume.name,NAME_CURRENT_COMP);
sprintf(this_box_volume.geometry.shape,"box");
this_box_volume.geometry.priority_value = priority;
this_box_volume.geometry.geometry_p_interact = p_interact;
// Currently the coordinates will be in absolute space.
this_box_volume.geometry.center = POS_A_CURRENT_COMP;

this_box_storage.z_depth = zdepth;
this_box_storage.x_width1 = xwidth;
this_box_storage.y_height1 = yheight;

this_box_storage.is_rectangle = 0;
if (xwidth2 < 0 && yheight2 < 0) this_box_storage.is_rectangle = 1;
if (xwidth == xwidth2 && yheight == yheight2) this_box_storage.is_rectangle = 1;

if (xwidth2 < 0) {
    this_box_storage.x_width2 = xwidth;
    xwidth2 = xwidth;
} else this_box_storage.x_width2 = xwidth2;

if (yheight2 < 0) {
    this_box_storage.y_height2 = yheight;
    yheight2 = yheight;
} else this_box_storage.y_height2 = yheight2;


this_box_storage.normal_vectors[0] = coords_set(0,0,1);
this_box_storage.normal_vectors[1] = coords_set(0,0,1);

// for sides with y component = 0
x_component = 2*zdepth/sqrt((xwidth-xwidth2)*(xwidth-xwidth2)+4*zdepth*zdepth);
z_component = (xwidth-xwidth2)/sqrt(4*zdepth*zdepth+(xwidth-xwidth2)*(xwidth-xwidth2));

this_box_storage.normal_vectors[2] = coords_set(x_component,0,z_component);
this_box_storage.normal_vectors[3] = coords_set(-x_component,0,z_component);

// for sides with x component = 0
y_component = 2*zdepth/sqrt((yheight-yheight2)*(yheight-yheight2)+4*zdepth*zdepth);
z_component = (yheight-yheight2)/sqrt(4*zdepth*zdepth+(yheight-yheight2)*(yheight-yheight2));

this_box_storage.normal_vectors[4] = coords_set(0,y_component,z_component);
this_box_storage.normal_vectors[5] = coords_set(0,-y_component,z_component);

this_box_volume.geometry.visualization_on = visualize;

this_box_volume.geometry.geometry_parameters.p_box_storage = &this_box_storage;

// Assign pointers to functions for intersection with the shape, checking if a point is inside the shape
if (this_box_storage.is_rectangle == 1) {
this_box_volume.geometry.intersect_function = &sample_box_intersect_simple;
this_box_volume.geometry.within_function = &r_within_box_simple;
}
else {
this_box_volume.geometry.intersect_function = &sample_box_intersect_advanced;
this_box_volume.geometry.within_function = &r_within_box_advanced;
}

this_box_volume.geometry.shell_points = &box_shell_points;
this_box_volume.geometry.mcdisplay_function = &mcdisplay_box_function;
this_box_volume.geometry.initialize_from_main_function = &initialize_box_geometry_from_main_component;
this_box_volume.geometry.process_rot_allocated = 0;

this_box_volume.geometry.copy_geometry_parameters = &allocate_box_storage_copy;

rot_copy(this_box_volume.geometry.rotation_matrix,ROT_A_CURRENT_COMP); //check how ROT_R_CURRENT_COMP would work
rot_transpose(ROT_A_CURRENT_COMP,this_box_volume.geometry.transpose_rotation_matrix);

// Initialize loggers
this_box_volume.loggers.num_elements = 0;

// packing the information into the global_geometry_element, which is then included in the global_geometry_list.
sprintf(global_geometry_element.name,NAME_CURRENT_COMP);
global_geometry_element.activation_counter = number_of_activations;
global_geometry_element.component_index = INDEX_CURRENT_COMP;
global_geometry_element.Volume = &this_box_volume; // Would be nicer if this m was a pointer, now we have the (small) data two places
add_element_to_geometry_list(&global_geometry_list,global_geometry_element);
}
#line 295559 "MACS_sample_kidney_box.c"
#undef number_of_activations
#undef mask_setting
#undef mask_string
#undef p_interact
#undef focus_r
#undef focus_xh
#undef focus_xw
#undef focus_ah
#undef focus_aw
#undef target_z
#undef target_y
#undef target_x
#undef target_index
#undef visualize
#undef yheight2
#undef xwidth2
#undef zdepth
#undef yheight
#undef xwidth
#undef priority
#undef material_string
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

  /* Initializations for component inter_analyzer_colimator_14_blade_3. */
  SIG_MESSAGE("inter_analyzer_colimator_14_blade_3 (Init)");
#define mccompcurname  inter_analyzer_colimator_14_blade_3
#define mccompcurtype  Union_box
#define mccompcurindex 690
#define loop_index mccinter_analyzer_colimator_14_blade_3_loop_index
#define this_box_volume mccinter_analyzer_colimator_14_blade_3_this_box_volume
#define global_geometry_element mccinter_analyzer_colimator_14_blade_3_global_geometry_element
#define this_box_storage mccinter_analyzer_colimator_14_blade_3_this_box_storage
#define material_string mccinter_analyzer_colimator_14_blade_3_material_string
#define priority mccinter_analyzer_colimator_14_blade_3_priority
#define xwidth mccinter_analyzer_colimator_14_blade_3_xwidth
#define yheight mccinter_analyzer_colimator_14_blade_3_yheight
#define zdepth mccinter_analyzer_colimator_14_blade_3_zdepth
#define xwidth2 mccinter_analyzer_colimator_14_blade_3_xwidth2
#define yheight2 mccinter_analyzer_colimator_14_blade_3_yheight2
#define visualize mccinter_analyzer_colimator_14_blade_3_visualize
#define target_index mccinter_analyzer_colimator_14_blade_3_target_index
#define target_x mccinter_analyzer_colimator_14_blade_3_target_x
#define target_y mccinter_analyzer_colimator_14_blade_3_target_y
#define target_z mccinter_analyzer_colimator_14_blade_3_target_z
#define focus_aw mccinter_analyzer_colimator_14_blade_3_focus_aw
#define focus_ah mccinter_analyzer_colimator_14_blade_3_focus_ah
#define focus_xw mccinter_analyzer_colimator_14_blade_3_focus_xw
#define focus_xh mccinter_analyzer_colimator_14_blade_3_focus_xh
#define focus_r mccinter_analyzer_colimator_14_blade_3_focus_r
#define p_interact mccinter_analyzer_colimator_14_blade_3_p_interact
#define mask_string mccinter_analyzer_colimator_14_blade_3_mask_string
#define mask_setting mccinter_analyzer_colimator_14_blade_3_mask_setting
#define number_of_activations mccinter_analyzer_colimator_14_blade_3_number_of_activations
#line 224 "Union_box.comp"
{
// Initializes the focusing system for this volume including input sanitation.
focus_initialize(&this_box_volume.geometry, POS_A_COMP_INDEX(INDEX_CURRENT_COMP+target_index), POS_A_CURRENT_COMP, ROT_A_CURRENT_COMP, target_index, target_x, target_y, target_z, focus_aw, focus_ah, focus_xw, focus_xh, focus_r, NAME_CURRENT_COMP);

// Input sanitation for this geometry
if (xwidth <= 0) {
  printf("\nERROR in Union_box named %s, the xwidth is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (yheight <= 0) {
  printf("\nERROR in Union_box named %s, yheight is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (zdepth <= 0) {
  printf("\nERROR in Union_box named %s, zdepth is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (xwidth2 <= 0 && xwidth2 != -1) {
  printf("\nERROR in Union_box named %s, the xwidth2 is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (yheight2 <= 0 && yheight2 != -1) {
  printf("\nERROR in Union_box named %s, yheight2 is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}

// Use sanitation
if (global_material_list.num_elements == 0) {
  printf("\nERROR: Need to define a material using Union_make_material before using a Union geometry component. \n");
  printf("       %s was defined before first use of Union_make_material.\n",NAME_CURRENT_COMP);
  exit(1);
}

this_box_volume.geometry.is_masked_volume = 0;
this_box_volume.geometry.is_exit_volume = 0;
this_box_volume.geometry.is_mask_volume = 0;
// check if the volume is a mask, if it is the material string is irelevant.
if (mask_string && strlen(mask_string) && strcmp(mask_string, "NULL") && strcmp(mask_string, "0")) {
    // A mask volume is used to limit the extend of other volumes, called the masked volumes. These are specified in the mask_string.
    // In order for a ray to enter a masked volume, it needs to be both in the region covered by that volume AND the mask volume.
    // When more than
    this_box_volume.geometry.mask_mode = 1; // Default is mask mode is ALL
    if (mask_setting && strlen(mask_setting) && strcmp(mask_setting, "NULL") && strcmp(mask_setting, "0")) {
        if (strcmp(mask_setting,"ALL") == 0 || strcmp(mask_setting,"All") == 0) this_box_volume.geometry.mask_mode = 1;
        else if (strcmp(mask_setting,"ANY") == 0 || strcmp(mask_setting,"Any") == 0) this_box_volume.geometry.mask_mode = 2;
        else {
            printf("The mask_mode of component %s is set to %s, but must be either ALL or ANY.\n",NAME_CURRENT_COMP,mask_setting);
            exit(1);
        }
    }
    
    for (loop_index=0;loop_index<global_geometry_list.num_elements;loop_index++) {
        // Add mask list
        if (1 == manual_linking_function(global_geometry_list.elements[loop_index].name,mask_string)) {
            add_element_to_int_list(&this_box_volume.geometry.mask_list,global_geometry_list.elements[loop_index].component_index);
            add_element_to_int_list(&global_geometry_list.elements[loop_index].Volume->geometry.masked_by_list,INDEX_CURRENT_COMP);
            global_geometry_list.elements[loop_index].Volume->geometry.is_masked_volume = 1;
            if (this_box_volume.geometry.mask_mode == 2)
                global_geometry_list.elements[loop_index].Volume->geometry.mask_mode = 2;
            if (this_box_volume.geometry.mask_mode == 1) {
                if (global_geometry_list.elements[loop_index].Volume->geometry.is_masked_volume == 1 && global_geometry_list.elements[loop_index].Volume->geometry.mask_mode != 2)
                    // If more than one mask is added to one volume, the ANY mode overwrites the (default) ALL mode.
                    global_geometry_list.elements[loop_index].Volume->geometry.mask_mode = 1;
            }
            
            found_geometries = 1;
        }
    }
    if (found_geometries == 0) {
        printf("The mask_string in geometry: %s did not find any of the specified volumes in the mask_string %s \n",NAME_CURRENT_COMP,mask_string);
        exit(1);
    }
    this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
    this_box_volume.p_physics->is_vacuum = 0; // Makes this volume a vacuum
    this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
    this_box_volume.p_physics->my_a = 0; // Should not be used.
    sprintf(this_box_volume.p_physics->name,"Mask");
    this_box_volume.geometry.is_mask_volume = 1;
    
    
// Read the material input, or if it lacks, use automatic linking.
} else if (material_string && strlen(material_string) && strcmp(material_string, "NULL") && strcmp(material_string, "0")) {
    // A geometry string was given, use it to determine which material
    if (0 == strcmp(material_string,"vacuum") || 0 == strcmp(material_string,"Vacuum")) {
        // One could have a global physics struct for vacuum instead of creating one for each
        this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
        this_box_volume.p_physics->is_vacuum = 1; // Makes this volume a vacuum
        this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
        this_box_volume.p_physics->my_a = 0; // Should not be used.
        sprintf(this_box_volume.p_physics->name,"Vacuum");
    } else if (0 == strcmp(material_string,"exit") || 0 == strcmp(material_string,"Exit")) {
        // One could have a global physics struct for vacuum instead of creating one for each
        this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
        this_box_volume.p_physics->is_vacuum = 1; // Makes this volume a vacuum
        this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
        this_box_volume.p_physics->my_a = 0; // Should not be used.
        this_box_volume.geometry.is_exit_volume = 1;
        sprintf(this_box_volume.p_physics->name,"Exit");
    } else {
        #ifndef MATERIAL_DETECTOR
            printf("Need to define a material before refering to it in a geometry %s.\n",NAME_CURRENT_COMP);
            exit(1);
        #endif
        for (loop_index=0;loop_index<global_material_list.num_elements;loop_index++) {
            if (0 == strcmp(material_string,global_material_list.elements[loop_index].name)) {
                this_box_volume.p_physics = global_material_list.elements[loop_index].physics;
                break;
            }
            if (loop_index == global_material_list.num_elements-1) {
            printf("\n");
            printf("ERROR: The material string \"%s\" in Union geometry \"%s\" did not match a specified material. \n",material_string,NAME_CURRENT_COMP);
            printf("       The materials available at this point (need to be defined before the geometry): \n");
            for (loop_index=0;loop_index<global_material_list.num_elements;loop_index++)
              printf("         %s\n",global_material_list.elements[loop_index].name);
            printf("\n");
            printf("       It is also possible to use one of the defualt materials avaiable: \n");
            printf("           Vacuum (for a Volume without scattering or absorption)\n");
            printf("           Exit (for a Volume where the ray exits the component if it enters)\n");
            printf("           Mask (for a Volume that masks existing volumes specified in the mask_string\n");
            exit(1);
          }
        }
    }
} else {
    // Automatic linking, simply using the last defined material.
    #ifndef MATERIAL_DETECTOR
        printf("Need to define a material before the geometry to use automatic linking %s.\n",NAME_CURRENT_COMP);
        exit(1);
    #endif
    this_box_volume.p_physics = global_material_list.elements[global_material_list.num_elements-1].physics;
}

sprintf(this_box_volume.name,NAME_CURRENT_COMP);
sprintf(this_box_volume.geometry.shape,"box");
this_box_volume.geometry.priority_value = priority;
this_box_volume.geometry.geometry_p_interact = p_interact;
// Currently the coordinates will be in absolute space.
this_box_volume.geometry.center = POS_A_CURRENT_COMP;

this_box_storage.z_depth = zdepth;
this_box_storage.x_width1 = xwidth;
this_box_storage.y_height1 = yheight;

this_box_storage.is_rectangle = 0;
if (xwidth2 < 0 && yheight2 < 0) this_box_storage.is_rectangle = 1;
if (xwidth == xwidth2 && yheight == yheight2) this_box_storage.is_rectangle = 1;

if (xwidth2 < 0) {
    this_box_storage.x_width2 = xwidth;
    xwidth2 = xwidth;
} else this_box_storage.x_width2 = xwidth2;

if (yheight2 < 0) {
    this_box_storage.y_height2 = yheight;
    yheight2 = yheight;
} else this_box_storage.y_height2 = yheight2;


this_box_storage.normal_vectors[0] = coords_set(0,0,1);
this_box_storage.normal_vectors[1] = coords_set(0,0,1);

// for sides with y component = 0
x_component = 2*zdepth/sqrt((xwidth-xwidth2)*(xwidth-xwidth2)+4*zdepth*zdepth);
z_component = (xwidth-xwidth2)/sqrt(4*zdepth*zdepth+(xwidth-xwidth2)*(xwidth-xwidth2));

this_box_storage.normal_vectors[2] = coords_set(x_component,0,z_component);
this_box_storage.normal_vectors[3] = coords_set(-x_component,0,z_component);

// for sides with x component = 0
y_component = 2*zdepth/sqrt((yheight-yheight2)*(yheight-yheight2)+4*zdepth*zdepth);
z_component = (yheight-yheight2)/sqrt(4*zdepth*zdepth+(yheight-yheight2)*(yheight-yheight2));

this_box_storage.normal_vectors[4] = coords_set(0,y_component,z_component);
this_box_storage.normal_vectors[5] = coords_set(0,-y_component,z_component);

this_box_volume.geometry.visualization_on = visualize;

this_box_volume.geometry.geometry_parameters.p_box_storage = &this_box_storage;

// Assign pointers to functions for intersection with the shape, checking if a point is inside the shape
if (this_box_storage.is_rectangle == 1) {
this_box_volume.geometry.intersect_function = &sample_box_intersect_simple;
this_box_volume.geometry.within_function = &r_within_box_simple;
}
else {
this_box_volume.geometry.intersect_function = &sample_box_intersect_advanced;
this_box_volume.geometry.within_function = &r_within_box_advanced;
}

this_box_volume.geometry.shell_points = &box_shell_points;
this_box_volume.geometry.mcdisplay_function = &mcdisplay_box_function;
this_box_volume.geometry.initialize_from_main_function = &initialize_box_geometry_from_main_component;
this_box_volume.geometry.process_rot_allocated = 0;

this_box_volume.geometry.copy_geometry_parameters = &allocate_box_storage_copy;

rot_copy(this_box_volume.geometry.rotation_matrix,ROT_A_CURRENT_COMP); //check how ROT_R_CURRENT_COMP would work
rot_transpose(ROT_A_CURRENT_COMP,this_box_volume.geometry.transpose_rotation_matrix);

// Initialize loggers
this_box_volume.loggers.num_elements = 0;

// packing the information into the global_geometry_element, which is then included in the global_geometry_list.
sprintf(global_geometry_element.name,NAME_CURRENT_COMP);
global_geometry_element.activation_counter = number_of_activations;
global_geometry_element.component_index = INDEX_CURRENT_COMP;
global_geometry_element.Volume = &this_box_volume; // Would be nicer if this m was a pointer, now we have the (small) data two places
add_element_to_geometry_list(&global_geometry_list,global_geometry_element);
}
#line 295829 "MACS_sample_kidney_box.c"
#undef number_of_activations
#undef mask_setting
#undef mask_string
#undef p_interact
#undef focus_r
#undef focus_xh
#undef focus_xw
#undef focus_ah
#undef focus_aw
#undef target_z
#undef target_y
#undef target_x
#undef target_index
#undef visualize
#undef yheight2
#undef xwidth2
#undef zdepth
#undef yheight
#undef xwidth
#undef priority
#undef material_string
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

  /* Initializations for component inter_analyzer_colimator_14_blade_4. */
  SIG_MESSAGE("inter_analyzer_colimator_14_blade_4 (Init)");
#define mccompcurname  inter_analyzer_colimator_14_blade_4
#define mccompcurtype  Union_box
#define mccompcurindex 691
#define loop_index mccinter_analyzer_colimator_14_blade_4_loop_index
#define this_box_volume mccinter_analyzer_colimator_14_blade_4_this_box_volume
#define global_geometry_element mccinter_analyzer_colimator_14_blade_4_global_geometry_element
#define this_box_storage mccinter_analyzer_colimator_14_blade_4_this_box_storage
#define material_string mccinter_analyzer_colimator_14_blade_4_material_string
#define priority mccinter_analyzer_colimator_14_blade_4_priority
#define xwidth mccinter_analyzer_colimator_14_blade_4_xwidth
#define yheight mccinter_analyzer_colimator_14_blade_4_yheight
#define zdepth mccinter_analyzer_colimator_14_blade_4_zdepth
#define xwidth2 mccinter_analyzer_colimator_14_blade_4_xwidth2
#define yheight2 mccinter_analyzer_colimator_14_blade_4_yheight2
#define visualize mccinter_analyzer_colimator_14_blade_4_visualize
#define target_index mccinter_analyzer_colimator_14_blade_4_target_index
#define target_x mccinter_analyzer_colimator_14_blade_4_target_x
#define target_y mccinter_analyzer_colimator_14_blade_4_target_y
#define target_z mccinter_analyzer_colimator_14_blade_4_target_z
#define focus_aw mccinter_analyzer_colimator_14_blade_4_focus_aw
#define focus_ah mccinter_analyzer_colimator_14_blade_4_focus_ah
#define focus_xw mccinter_analyzer_colimator_14_blade_4_focus_xw
#define focus_xh mccinter_analyzer_colimator_14_blade_4_focus_xh
#define focus_r mccinter_analyzer_colimator_14_blade_4_focus_r
#define p_interact mccinter_analyzer_colimator_14_blade_4_p_interact
#define mask_string mccinter_analyzer_colimator_14_blade_4_mask_string
#define mask_setting mccinter_analyzer_colimator_14_blade_4_mask_setting
#define number_of_activations mccinter_analyzer_colimator_14_blade_4_number_of_activations
#line 224 "Union_box.comp"
{
// Initializes the focusing system for this volume including input sanitation.
focus_initialize(&this_box_volume.geometry, POS_A_COMP_INDEX(INDEX_CURRENT_COMP+target_index), POS_A_CURRENT_COMP, ROT_A_CURRENT_COMP, target_index, target_x, target_y, target_z, focus_aw, focus_ah, focus_xw, focus_xh, focus_r, NAME_CURRENT_COMP);

// Input sanitation for this geometry
if (xwidth <= 0) {
  printf("\nERROR in Union_box named %s, the xwidth is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (yheight <= 0) {
  printf("\nERROR in Union_box named %s, yheight is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (zdepth <= 0) {
  printf("\nERROR in Union_box named %s, zdepth is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (xwidth2 <= 0 && xwidth2 != -1) {
  printf("\nERROR in Union_box named %s, the xwidth2 is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (yheight2 <= 0 && yheight2 != -1) {
  printf("\nERROR in Union_box named %s, yheight2 is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}

// Use sanitation
if (global_material_list.num_elements == 0) {
  printf("\nERROR: Need to define a material using Union_make_material before using a Union geometry component. \n");
  printf("       %s was defined before first use of Union_make_material.\n",NAME_CURRENT_COMP);
  exit(1);
}

this_box_volume.geometry.is_masked_volume = 0;
this_box_volume.geometry.is_exit_volume = 0;
this_box_volume.geometry.is_mask_volume = 0;
// check if the volume is a mask, if it is the material string is irelevant.
if (mask_string && strlen(mask_string) && strcmp(mask_string, "NULL") && strcmp(mask_string, "0")) {
    // A mask volume is used to limit the extend of other volumes, called the masked volumes. These are specified in the mask_string.
    // In order for a ray to enter a masked volume, it needs to be both in the region covered by that volume AND the mask volume.
    // When more than
    this_box_volume.geometry.mask_mode = 1; // Default is mask mode is ALL
    if (mask_setting && strlen(mask_setting) && strcmp(mask_setting, "NULL") && strcmp(mask_setting, "0")) {
        if (strcmp(mask_setting,"ALL") == 0 || strcmp(mask_setting,"All") == 0) this_box_volume.geometry.mask_mode = 1;
        else if (strcmp(mask_setting,"ANY") == 0 || strcmp(mask_setting,"Any") == 0) this_box_volume.geometry.mask_mode = 2;
        else {
            printf("The mask_mode of component %s is set to %s, but must be either ALL or ANY.\n",NAME_CURRENT_COMP,mask_setting);
            exit(1);
        }
    }
    
    for (loop_index=0;loop_index<global_geometry_list.num_elements;loop_index++) {
        // Add mask list
        if (1 == manual_linking_function(global_geometry_list.elements[loop_index].name,mask_string)) {
            add_element_to_int_list(&this_box_volume.geometry.mask_list,global_geometry_list.elements[loop_index].component_index);
            add_element_to_int_list(&global_geometry_list.elements[loop_index].Volume->geometry.masked_by_list,INDEX_CURRENT_COMP);
            global_geometry_list.elements[loop_index].Volume->geometry.is_masked_volume = 1;
            if (this_box_volume.geometry.mask_mode == 2)
                global_geometry_list.elements[loop_index].Volume->geometry.mask_mode = 2;
            if (this_box_volume.geometry.mask_mode == 1) {
                if (global_geometry_list.elements[loop_index].Volume->geometry.is_masked_volume == 1 && global_geometry_list.elements[loop_index].Volume->geometry.mask_mode != 2)
                    // If more than one mask is added to one volume, the ANY mode overwrites the (default) ALL mode.
                    global_geometry_list.elements[loop_index].Volume->geometry.mask_mode = 1;
            }
            
            found_geometries = 1;
        }
    }
    if (found_geometries == 0) {
        printf("The mask_string in geometry: %s did not find any of the specified volumes in the mask_string %s \n",NAME_CURRENT_COMP,mask_string);
        exit(1);
    }
    this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
    this_box_volume.p_physics->is_vacuum = 0; // Makes this volume a vacuum
    this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
    this_box_volume.p_physics->my_a = 0; // Should not be used.
    sprintf(this_box_volume.p_physics->name,"Mask");
    this_box_volume.geometry.is_mask_volume = 1;
    
    
// Read the material input, or if it lacks, use automatic linking.
} else if (material_string && strlen(material_string) && strcmp(material_string, "NULL") && strcmp(material_string, "0")) {
    // A geometry string was given, use it to determine which material
    if (0 == strcmp(material_string,"vacuum") || 0 == strcmp(material_string,"Vacuum")) {
        // One could have a global physics struct for vacuum instead of creating one for each
        this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
        this_box_volume.p_physics->is_vacuum = 1; // Makes this volume a vacuum
        this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
        this_box_volume.p_physics->my_a = 0; // Should not be used.
        sprintf(this_box_volume.p_physics->name,"Vacuum");
    } else if (0 == strcmp(material_string,"exit") || 0 == strcmp(material_string,"Exit")) {
        // One could have a global physics struct for vacuum instead of creating one for each
        this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
        this_box_volume.p_physics->is_vacuum = 1; // Makes this volume a vacuum
        this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
        this_box_volume.p_physics->my_a = 0; // Should not be used.
        this_box_volume.geometry.is_exit_volume = 1;
        sprintf(this_box_volume.p_physics->name,"Exit");
    } else {
        #ifndef MATERIAL_DETECTOR
            printf("Need to define a material before refering to it in a geometry %s.\n",NAME_CURRENT_COMP);
            exit(1);
        #endif
        for (loop_index=0;loop_index<global_material_list.num_elements;loop_index++) {
            if (0 == strcmp(material_string,global_material_list.elements[loop_index].name)) {
                this_box_volume.p_physics = global_material_list.elements[loop_index].physics;
                break;
            }
            if (loop_index == global_material_list.num_elements-1) {
            printf("\n");
            printf("ERROR: The material string \"%s\" in Union geometry \"%s\" did not match a specified material. \n",material_string,NAME_CURRENT_COMP);
            printf("       The materials available at this point (need to be defined before the geometry): \n");
            for (loop_index=0;loop_index<global_material_list.num_elements;loop_index++)
              printf("         %s\n",global_material_list.elements[loop_index].name);
            printf("\n");
            printf("       It is also possible to use one of the defualt materials avaiable: \n");
            printf("           Vacuum (for a Volume without scattering or absorption)\n");
            printf("           Exit (for a Volume where the ray exits the component if it enters)\n");
            printf("           Mask (for a Volume that masks existing volumes specified in the mask_string\n");
            exit(1);
          }
        }
    }
} else {
    // Automatic linking, simply using the last defined material.
    #ifndef MATERIAL_DETECTOR
        printf("Need to define a material before the geometry to use automatic linking %s.\n",NAME_CURRENT_COMP);
        exit(1);
    #endif
    this_box_volume.p_physics = global_material_list.elements[global_material_list.num_elements-1].physics;
}

sprintf(this_box_volume.name,NAME_CURRENT_COMP);
sprintf(this_box_volume.geometry.shape,"box");
this_box_volume.geometry.priority_value = priority;
this_box_volume.geometry.geometry_p_interact = p_interact;
// Currently the coordinates will be in absolute space.
this_box_volume.geometry.center = POS_A_CURRENT_COMP;

this_box_storage.z_depth = zdepth;
this_box_storage.x_width1 = xwidth;
this_box_storage.y_height1 = yheight;

this_box_storage.is_rectangle = 0;
if (xwidth2 < 0 && yheight2 < 0) this_box_storage.is_rectangle = 1;
if (xwidth == xwidth2 && yheight == yheight2) this_box_storage.is_rectangle = 1;

if (xwidth2 < 0) {
    this_box_storage.x_width2 = xwidth;
    xwidth2 = xwidth;
} else this_box_storage.x_width2 = xwidth2;

if (yheight2 < 0) {
    this_box_storage.y_height2 = yheight;
    yheight2 = yheight;
} else this_box_storage.y_height2 = yheight2;


this_box_storage.normal_vectors[0] = coords_set(0,0,1);
this_box_storage.normal_vectors[1] = coords_set(0,0,1);

// for sides with y component = 0
x_component = 2*zdepth/sqrt((xwidth-xwidth2)*(xwidth-xwidth2)+4*zdepth*zdepth);
z_component = (xwidth-xwidth2)/sqrt(4*zdepth*zdepth+(xwidth-xwidth2)*(xwidth-xwidth2));

this_box_storage.normal_vectors[2] = coords_set(x_component,0,z_component);
this_box_storage.normal_vectors[3] = coords_set(-x_component,0,z_component);

// for sides with x component = 0
y_component = 2*zdepth/sqrt((yheight-yheight2)*(yheight-yheight2)+4*zdepth*zdepth);
z_component = (yheight-yheight2)/sqrt(4*zdepth*zdepth+(yheight-yheight2)*(yheight-yheight2));

this_box_storage.normal_vectors[4] = coords_set(0,y_component,z_component);
this_box_storage.normal_vectors[5] = coords_set(0,-y_component,z_component);

this_box_volume.geometry.visualization_on = visualize;

this_box_volume.geometry.geometry_parameters.p_box_storage = &this_box_storage;

// Assign pointers to functions for intersection with the shape, checking if a point is inside the shape
if (this_box_storage.is_rectangle == 1) {
this_box_volume.geometry.intersect_function = &sample_box_intersect_simple;
this_box_volume.geometry.within_function = &r_within_box_simple;
}
else {
this_box_volume.geometry.intersect_function = &sample_box_intersect_advanced;
this_box_volume.geometry.within_function = &r_within_box_advanced;
}

this_box_volume.geometry.shell_points = &box_shell_points;
this_box_volume.geometry.mcdisplay_function = &mcdisplay_box_function;
this_box_volume.geometry.initialize_from_main_function = &initialize_box_geometry_from_main_component;
this_box_volume.geometry.process_rot_allocated = 0;

this_box_volume.geometry.copy_geometry_parameters = &allocate_box_storage_copy;

rot_copy(this_box_volume.geometry.rotation_matrix,ROT_A_CURRENT_COMP); //check how ROT_R_CURRENT_COMP would work
rot_transpose(ROT_A_CURRENT_COMP,this_box_volume.geometry.transpose_rotation_matrix);

// Initialize loggers
this_box_volume.loggers.num_elements = 0;

// packing the information into the global_geometry_element, which is then included in the global_geometry_list.
sprintf(global_geometry_element.name,NAME_CURRENT_COMP);
global_geometry_element.activation_counter = number_of_activations;
global_geometry_element.component_index = INDEX_CURRENT_COMP;
global_geometry_element.Volume = &this_box_volume; // Would be nicer if this m was a pointer, now we have the (small) data two places
add_element_to_geometry_list(&global_geometry_list,global_geometry_element);
}
#line 296099 "MACS_sample_kidney_box.c"
#undef number_of_activations
#undef mask_setting
#undef mask_string
#undef p_interact
#undef focus_r
#undef focus_xh
#undef focus_xw
#undef focus_ah
#undef focus_aw
#undef target_z
#undef target_y
#undef target_x
#undef target_index
#undef visualize
#undef yheight2
#undef xwidth2
#undef zdepth
#undef yheight
#undef xwidth
#undef priority
#undef material_string
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

  /* Initializations for component diffraction_detector_14_exit_volume. */
  SIG_MESSAGE("diffraction_detector_14_exit_volume (Init)");
#define mccompcurname  diffraction_detector_14_exit_volume
#define mccompcurtype  Union_box
#define mccompcurindex 692
#define loop_index mccdiffraction_detector_14_exit_volume_loop_index
#define this_box_volume mccdiffraction_detector_14_exit_volume_this_box_volume
#define global_geometry_element mccdiffraction_detector_14_exit_volume_global_geometry_element
#define this_box_storage mccdiffraction_detector_14_exit_volume_this_box_storage
#define material_string mccdiffraction_detector_14_exit_volume_material_string
#define priority mccdiffraction_detector_14_exit_volume_priority
#define xwidth mccdiffraction_detector_14_exit_volume_xwidth
#define yheight mccdiffraction_detector_14_exit_volume_yheight
#define zdepth mccdiffraction_detector_14_exit_volume_zdepth
#define xwidth2 mccdiffraction_detector_14_exit_volume_xwidth2
#define yheight2 mccdiffraction_detector_14_exit_volume_yheight2
#define visualize mccdiffraction_detector_14_exit_volume_visualize
#define target_index mccdiffraction_detector_14_exit_volume_target_index
#define target_x mccdiffraction_detector_14_exit_volume_target_x
#define target_y mccdiffraction_detector_14_exit_volume_target_y
#define target_z mccdiffraction_detector_14_exit_volume_target_z
#define focus_aw mccdiffraction_detector_14_exit_volume_focus_aw
#define focus_ah mccdiffraction_detector_14_exit_volume_focus_ah
#define focus_xw mccdiffraction_detector_14_exit_volume_focus_xw
#define focus_xh mccdiffraction_detector_14_exit_volume_focus_xh
#define focus_r mccdiffraction_detector_14_exit_volume_focus_r
#define p_interact mccdiffraction_detector_14_exit_volume_p_interact
#define mask_string mccdiffraction_detector_14_exit_volume_mask_string
#define mask_setting mccdiffraction_detector_14_exit_volume_mask_setting
#define number_of_activations mccdiffraction_detector_14_exit_volume_number_of_activations
#line 224 "Union_box.comp"
{
// Initializes the focusing system for this volume including input sanitation.
focus_initialize(&this_box_volume.geometry, POS_A_COMP_INDEX(INDEX_CURRENT_COMP+target_index), POS_A_CURRENT_COMP, ROT_A_CURRENT_COMP, target_index, target_x, target_y, target_z, focus_aw, focus_ah, focus_xw, focus_xh, focus_r, NAME_CURRENT_COMP);

// Input sanitation for this geometry
if (xwidth <= 0) {
  printf("\nERROR in Union_box named %s, the xwidth is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (yheight <= 0) {
  printf("\nERROR in Union_box named %s, yheight is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (zdepth <= 0) {
  printf("\nERROR in Union_box named %s, zdepth is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (xwidth2 <= 0 && xwidth2 != -1) {
  printf("\nERROR in Union_box named %s, the xwidth2 is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (yheight2 <= 0 && yheight2 != -1) {
  printf("\nERROR in Union_box named %s, yheight2 is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}

// Use sanitation
if (global_material_list.num_elements == 0) {
  printf("\nERROR: Need to define a material using Union_make_material before using a Union geometry component. \n");
  printf("       %s was defined before first use of Union_make_material.\n",NAME_CURRENT_COMP);
  exit(1);
}

this_box_volume.geometry.is_masked_volume = 0;
this_box_volume.geometry.is_exit_volume = 0;
this_box_volume.geometry.is_mask_volume = 0;
// check if the volume is a mask, if it is the material string is irelevant.
if (mask_string && strlen(mask_string) && strcmp(mask_string, "NULL") && strcmp(mask_string, "0")) {
    // A mask volume is used to limit the extend of other volumes, called the masked volumes. These are specified in the mask_string.
    // In order for a ray to enter a masked volume, it needs to be both in the region covered by that volume AND the mask volume.
    // When more than
    this_box_volume.geometry.mask_mode = 1; // Default is mask mode is ALL
    if (mask_setting && strlen(mask_setting) && strcmp(mask_setting, "NULL") && strcmp(mask_setting, "0")) {
        if (strcmp(mask_setting,"ALL") == 0 || strcmp(mask_setting,"All") == 0) this_box_volume.geometry.mask_mode = 1;
        else if (strcmp(mask_setting,"ANY") == 0 || strcmp(mask_setting,"Any") == 0) this_box_volume.geometry.mask_mode = 2;
        else {
            printf("The mask_mode of component %s is set to %s, but must be either ALL or ANY.\n",NAME_CURRENT_COMP,mask_setting);
            exit(1);
        }
    }
    
    for (loop_index=0;loop_index<global_geometry_list.num_elements;loop_index++) {
        // Add mask list
        if (1 == manual_linking_function(global_geometry_list.elements[loop_index].name,mask_string)) {
            add_element_to_int_list(&this_box_volume.geometry.mask_list,global_geometry_list.elements[loop_index].component_index);
            add_element_to_int_list(&global_geometry_list.elements[loop_index].Volume->geometry.masked_by_list,INDEX_CURRENT_COMP);
            global_geometry_list.elements[loop_index].Volume->geometry.is_masked_volume = 1;
            if (this_box_volume.geometry.mask_mode == 2)
                global_geometry_list.elements[loop_index].Volume->geometry.mask_mode = 2;
            if (this_box_volume.geometry.mask_mode == 1) {
                if (global_geometry_list.elements[loop_index].Volume->geometry.is_masked_volume == 1 && global_geometry_list.elements[loop_index].Volume->geometry.mask_mode != 2)
                    // If more than one mask is added to one volume, the ANY mode overwrites the (default) ALL mode.
                    global_geometry_list.elements[loop_index].Volume->geometry.mask_mode = 1;
            }
            
            found_geometries = 1;
        }
    }
    if (found_geometries == 0) {
        printf("The mask_string in geometry: %s did not find any of the specified volumes in the mask_string %s \n",NAME_CURRENT_COMP,mask_string);
        exit(1);
    }
    this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
    this_box_volume.p_physics->is_vacuum = 0; // Makes this volume a vacuum
    this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
    this_box_volume.p_physics->my_a = 0; // Should not be used.
    sprintf(this_box_volume.p_physics->name,"Mask");
    this_box_volume.geometry.is_mask_volume = 1;
    
    
// Read the material input, or if it lacks, use automatic linking.
} else if (material_string && strlen(material_string) && strcmp(material_string, "NULL") && strcmp(material_string, "0")) {
    // A geometry string was given, use it to determine which material
    if (0 == strcmp(material_string,"vacuum") || 0 == strcmp(material_string,"Vacuum")) {
        // One could have a global physics struct for vacuum instead of creating one for each
        this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
        this_box_volume.p_physics->is_vacuum = 1; // Makes this volume a vacuum
        this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
        this_box_volume.p_physics->my_a = 0; // Should not be used.
        sprintf(this_box_volume.p_physics->name,"Vacuum");
    } else if (0 == strcmp(material_string,"exit") || 0 == strcmp(material_string,"Exit")) {
        // One could have a global physics struct for vacuum instead of creating one for each
        this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
        this_box_volume.p_physics->is_vacuum = 1; // Makes this volume a vacuum
        this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
        this_box_volume.p_physics->my_a = 0; // Should not be used.
        this_box_volume.geometry.is_exit_volume = 1;
        sprintf(this_box_volume.p_physics->name,"Exit");
    } else {
        #ifndef MATERIAL_DETECTOR
            printf("Need to define a material before refering to it in a geometry %s.\n",NAME_CURRENT_COMP);
            exit(1);
        #endif
        for (loop_index=0;loop_index<global_material_list.num_elements;loop_index++) {
            if (0 == strcmp(material_string,global_material_list.elements[loop_index].name)) {
                this_box_volume.p_physics = global_material_list.elements[loop_index].physics;
                break;
            }
            if (loop_index == global_material_list.num_elements-1) {
            printf("\n");
            printf("ERROR: The material string \"%s\" in Union geometry \"%s\" did not match a specified material. \n",material_string,NAME_CURRENT_COMP);
            printf("       The materials available at this point (need to be defined before the geometry): \n");
            for (loop_index=0;loop_index<global_material_list.num_elements;loop_index++)
              printf("         %s\n",global_material_list.elements[loop_index].name);
            printf("\n");
            printf("       It is also possible to use one of the defualt materials avaiable: \n");
            printf("           Vacuum (for a Volume without scattering or absorption)\n");
            printf("           Exit (for a Volume where the ray exits the component if it enters)\n");
            printf("           Mask (for a Volume that masks existing volumes specified in the mask_string\n");
            exit(1);
          }
        }
    }
} else {
    // Automatic linking, simply using the last defined material.
    #ifndef MATERIAL_DETECTOR
        printf("Need to define a material before the geometry to use automatic linking %s.\n",NAME_CURRENT_COMP);
        exit(1);
    #endif
    this_box_volume.p_physics = global_material_list.elements[global_material_list.num_elements-1].physics;
}

sprintf(this_box_volume.name,NAME_CURRENT_COMP);
sprintf(this_box_volume.geometry.shape,"box");
this_box_volume.geometry.priority_value = priority;
this_box_volume.geometry.geometry_p_interact = p_interact;
// Currently the coordinates will be in absolute space.
this_box_volume.geometry.center = POS_A_CURRENT_COMP;

this_box_storage.z_depth = zdepth;
this_box_storage.x_width1 = xwidth;
this_box_storage.y_height1 = yheight;

this_box_storage.is_rectangle = 0;
if (xwidth2 < 0 && yheight2 < 0) this_box_storage.is_rectangle = 1;
if (xwidth == xwidth2 && yheight == yheight2) this_box_storage.is_rectangle = 1;

if (xwidth2 < 0) {
    this_box_storage.x_width2 = xwidth;
    xwidth2 = xwidth;
} else this_box_storage.x_width2 = xwidth2;

if (yheight2 < 0) {
    this_box_storage.y_height2 = yheight;
    yheight2 = yheight;
} else this_box_storage.y_height2 = yheight2;


this_box_storage.normal_vectors[0] = coords_set(0,0,1);
this_box_storage.normal_vectors[1] = coords_set(0,0,1);

// for sides with y component = 0
x_component = 2*zdepth/sqrt((xwidth-xwidth2)*(xwidth-xwidth2)+4*zdepth*zdepth);
z_component = (xwidth-xwidth2)/sqrt(4*zdepth*zdepth+(xwidth-xwidth2)*(xwidth-xwidth2));

this_box_storage.normal_vectors[2] = coords_set(x_component,0,z_component);
this_box_storage.normal_vectors[3] = coords_set(-x_component,0,z_component);

// for sides with x component = 0
y_component = 2*zdepth/sqrt((yheight-yheight2)*(yheight-yheight2)+4*zdepth*zdepth);
z_component = (yheight-yheight2)/sqrt(4*zdepth*zdepth+(yheight-yheight2)*(yheight-yheight2));

this_box_storage.normal_vectors[4] = coords_set(0,y_component,z_component);
this_box_storage.normal_vectors[5] = coords_set(0,-y_component,z_component);

this_box_volume.geometry.visualization_on = visualize;

this_box_volume.geometry.geometry_parameters.p_box_storage = &this_box_storage;

// Assign pointers to functions for intersection with the shape, checking if a point is inside the shape
if (this_box_storage.is_rectangle == 1) {
this_box_volume.geometry.intersect_function = &sample_box_intersect_simple;
this_box_volume.geometry.within_function = &r_within_box_simple;
}
else {
this_box_volume.geometry.intersect_function = &sample_box_intersect_advanced;
this_box_volume.geometry.within_function = &r_within_box_advanced;
}

this_box_volume.geometry.shell_points = &box_shell_points;
this_box_volume.geometry.mcdisplay_function = &mcdisplay_box_function;
this_box_volume.geometry.initialize_from_main_function = &initialize_box_geometry_from_main_component;
this_box_volume.geometry.process_rot_allocated = 0;

this_box_volume.geometry.copy_geometry_parameters = &allocate_box_storage_copy;

rot_copy(this_box_volume.geometry.rotation_matrix,ROT_A_CURRENT_COMP); //check how ROT_R_CURRENT_COMP would work
rot_transpose(ROT_A_CURRENT_COMP,this_box_volume.geometry.transpose_rotation_matrix);

// Initialize loggers
this_box_volume.loggers.num_elements = 0;

// packing the information into the global_geometry_element, which is then included in the global_geometry_list.
sprintf(global_geometry_element.name,NAME_CURRENT_COMP);
global_geometry_element.activation_counter = number_of_activations;
global_geometry_element.component_index = INDEX_CURRENT_COMP;
global_geometry_element.Volume = &this_box_volume; // Would be nicer if this m was a pointer, now we have the (small) data two places
add_element_to_geometry_list(&global_geometry_list,global_geometry_element);
}
#line 296369 "MACS_sample_kidney_box.c"
#undef number_of_activations
#undef mask_setting
#undef mask_string
#undef p_interact
#undef focus_r
#undef focus_xh
#undef focus_xw
#undef focus_ah
#undef focus_aw
#undef target_z
#undef target_y
#undef target_x
#undef target_index
#undef visualize
#undef yheight2
#undef xwidth2
#undef zdepth
#undef yheight
#undef xwidth
#undef priority
#undef material_string
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

  /* Initializations for component spec_detector_14_exit_volume. */
  SIG_MESSAGE("spec_detector_14_exit_volume (Init)");
#define mccompcurname  spec_detector_14_exit_volume
#define mccompcurtype  Union_box
#define mccompcurindex 693
#define loop_index mccspec_detector_14_exit_volume_loop_index
#define this_box_volume mccspec_detector_14_exit_volume_this_box_volume
#define global_geometry_element mccspec_detector_14_exit_volume_global_geometry_element
#define this_box_storage mccspec_detector_14_exit_volume_this_box_storage
#define material_string mccspec_detector_14_exit_volume_material_string
#define priority mccspec_detector_14_exit_volume_priority
#define xwidth mccspec_detector_14_exit_volume_xwidth
#define yheight mccspec_detector_14_exit_volume_yheight
#define zdepth mccspec_detector_14_exit_volume_zdepth
#define xwidth2 mccspec_detector_14_exit_volume_xwidth2
#define yheight2 mccspec_detector_14_exit_volume_yheight2
#define visualize mccspec_detector_14_exit_volume_visualize
#define target_index mccspec_detector_14_exit_volume_target_index
#define target_x mccspec_detector_14_exit_volume_target_x
#define target_y mccspec_detector_14_exit_volume_target_y
#define target_z mccspec_detector_14_exit_volume_target_z
#define focus_aw mccspec_detector_14_exit_volume_focus_aw
#define focus_ah mccspec_detector_14_exit_volume_focus_ah
#define focus_xw mccspec_detector_14_exit_volume_focus_xw
#define focus_xh mccspec_detector_14_exit_volume_focus_xh
#define focus_r mccspec_detector_14_exit_volume_focus_r
#define p_interact mccspec_detector_14_exit_volume_p_interact
#define mask_string mccspec_detector_14_exit_volume_mask_string
#define mask_setting mccspec_detector_14_exit_volume_mask_setting
#define number_of_activations mccspec_detector_14_exit_volume_number_of_activations
#line 224 "Union_box.comp"
{
// Initializes the focusing system for this volume including input sanitation.
focus_initialize(&this_box_volume.geometry, POS_A_COMP_INDEX(INDEX_CURRENT_COMP+target_index), POS_A_CURRENT_COMP, ROT_A_CURRENT_COMP, target_index, target_x, target_y, target_z, focus_aw, focus_ah, focus_xw, focus_xh, focus_r, NAME_CURRENT_COMP);

// Input sanitation for this geometry
if (xwidth <= 0) {
  printf("\nERROR in Union_box named %s, the xwidth is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (yheight <= 0) {
  printf("\nERROR in Union_box named %s, yheight is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (zdepth <= 0) {
  printf("\nERROR in Union_box named %s, zdepth is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (xwidth2 <= 0 && xwidth2 != -1) {
  printf("\nERROR in Union_box named %s, the xwidth2 is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (yheight2 <= 0 && yheight2 != -1) {
  printf("\nERROR in Union_box named %s, yheight2 is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}

// Use sanitation
if (global_material_list.num_elements == 0) {
  printf("\nERROR: Need to define a material using Union_make_material before using a Union geometry component. \n");
  printf("       %s was defined before first use of Union_make_material.\n",NAME_CURRENT_COMP);
  exit(1);
}

this_box_volume.geometry.is_masked_volume = 0;
this_box_volume.geometry.is_exit_volume = 0;
this_box_volume.geometry.is_mask_volume = 0;
// check if the volume is a mask, if it is the material string is irelevant.
if (mask_string && strlen(mask_string) && strcmp(mask_string, "NULL") && strcmp(mask_string, "0")) {
    // A mask volume is used to limit the extend of other volumes, called the masked volumes. These are specified in the mask_string.
    // In order for a ray to enter a masked volume, it needs to be both in the region covered by that volume AND the mask volume.
    // When more than
    this_box_volume.geometry.mask_mode = 1; // Default is mask mode is ALL
    if (mask_setting && strlen(mask_setting) && strcmp(mask_setting, "NULL") && strcmp(mask_setting, "0")) {
        if (strcmp(mask_setting,"ALL") == 0 || strcmp(mask_setting,"All") == 0) this_box_volume.geometry.mask_mode = 1;
        else if (strcmp(mask_setting,"ANY") == 0 || strcmp(mask_setting,"Any") == 0) this_box_volume.geometry.mask_mode = 2;
        else {
            printf("The mask_mode of component %s is set to %s, but must be either ALL or ANY.\n",NAME_CURRENT_COMP,mask_setting);
            exit(1);
        }
    }
    
    for (loop_index=0;loop_index<global_geometry_list.num_elements;loop_index++) {
        // Add mask list
        if (1 == manual_linking_function(global_geometry_list.elements[loop_index].name,mask_string)) {
            add_element_to_int_list(&this_box_volume.geometry.mask_list,global_geometry_list.elements[loop_index].component_index);
            add_element_to_int_list(&global_geometry_list.elements[loop_index].Volume->geometry.masked_by_list,INDEX_CURRENT_COMP);
            global_geometry_list.elements[loop_index].Volume->geometry.is_masked_volume = 1;
            if (this_box_volume.geometry.mask_mode == 2)
                global_geometry_list.elements[loop_index].Volume->geometry.mask_mode = 2;
            if (this_box_volume.geometry.mask_mode == 1) {
                if (global_geometry_list.elements[loop_index].Volume->geometry.is_masked_volume == 1 && global_geometry_list.elements[loop_index].Volume->geometry.mask_mode != 2)
                    // If more than one mask is added to one volume, the ANY mode overwrites the (default) ALL mode.
                    global_geometry_list.elements[loop_index].Volume->geometry.mask_mode = 1;
            }
            
            found_geometries = 1;
        }
    }
    if (found_geometries == 0) {
        printf("The mask_string in geometry: %s did not find any of the specified volumes in the mask_string %s \n",NAME_CURRENT_COMP,mask_string);
        exit(1);
    }
    this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
    this_box_volume.p_physics->is_vacuum = 0; // Makes this volume a vacuum
    this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
    this_box_volume.p_physics->my_a = 0; // Should not be used.
    sprintf(this_box_volume.p_physics->name,"Mask");
    this_box_volume.geometry.is_mask_volume = 1;
    
    
// Read the material input, or if it lacks, use automatic linking.
} else if (material_string && strlen(material_string) && strcmp(material_string, "NULL") && strcmp(material_string, "0")) {
    // A geometry string was given, use it to determine which material
    if (0 == strcmp(material_string,"vacuum") || 0 == strcmp(material_string,"Vacuum")) {
        // One could have a global physics struct for vacuum instead of creating one for each
        this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
        this_box_volume.p_physics->is_vacuum = 1; // Makes this volume a vacuum
        this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
        this_box_volume.p_physics->my_a = 0; // Should not be used.
        sprintf(this_box_volume.p_physics->name,"Vacuum");
    } else if (0 == strcmp(material_string,"exit") || 0 == strcmp(material_string,"Exit")) {
        // One could have a global physics struct for vacuum instead of creating one for each
        this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
        this_box_volume.p_physics->is_vacuum = 1; // Makes this volume a vacuum
        this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
        this_box_volume.p_physics->my_a = 0; // Should not be used.
        this_box_volume.geometry.is_exit_volume = 1;
        sprintf(this_box_volume.p_physics->name,"Exit");
    } else {
        #ifndef MATERIAL_DETECTOR
            printf("Need to define a material before refering to it in a geometry %s.\n",NAME_CURRENT_COMP);
            exit(1);
        #endif
        for (loop_index=0;loop_index<global_material_list.num_elements;loop_index++) {
            if (0 == strcmp(material_string,global_material_list.elements[loop_index].name)) {
                this_box_volume.p_physics = global_material_list.elements[loop_index].physics;
                break;
            }
            if (loop_index == global_material_list.num_elements-1) {
            printf("\n");
            printf("ERROR: The material string \"%s\" in Union geometry \"%s\" did not match a specified material. \n",material_string,NAME_CURRENT_COMP);
            printf("       The materials available at this point (need to be defined before the geometry): \n");
            for (loop_index=0;loop_index<global_material_list.num_elements;loop_index++)
              printf("         %s\n",global_material_list.elements[loop_index].name);
            printf("\n");
            printf("       It is also possible to use one of the defualt materials avaiable: \n");
            printf("           Vacuum (for a Volume without scattering or absorption)\n");
            printf("           Exit (for a Volume where the ray exits the component if it enters)\n");
            printf("           Mask (for a Volume that masks existing volumes specified in the mask_string\n");
            exit(1);
          }
        }
    }
} else {
    // Automatic linking, simply using the last defined material.
    #ifndef MATERIAL_DETECTOR
        printf("Need to define a material before the geometry to use automatic linking %s.\n",NAME_CURRENT_COMP);
        exit(1);
    #endif
    this_box_volume.p_physics = global_material_list.elements[global_material_list.num_elements-1].physics;
}

sprintf(this_box_volume.name,NAME_CURRENT_COMP);
sprintf(this_box_volume.geometry.shape,"box");
this_box_volume.geometry.priority_value = priority;
this_box_volume.geometry.geometry_p_interact = p_interact;
// Currently the coordinates will be in absolute space.
this_box_volume.geometry.center = POS_A_CURRENT_COMP;

this_box_storage.z_depth = zdepth;
this_box_storage.x_width1 = xwidth;
this_box_storage.y_height1 = yheight;

this_box_storage.is_rectangle = 0;
if (xwidth2 < 0 && yheight2 < 0) this_box_storage.is_rectangle = 1;
if (xwidth == xwidth2 && yheight == yheight2) this_box_storage.is_rectangle = 1;

if (xwidth2 < 0) {
    this_box_storage.x_width2 = xwidth;
    xwidth2 = xwidth;
} else this_box_storage.x_width2 = xwidth2;

if (yheight2 < 0) {
    this_box_storage.y_height2 = yheight;
    yheight2 = yheight;
} else this_box_storage.y_height2 = yheight2;


this_box_storage.normal_vectors[0] = coords_set(0,0,1);
this_box_storage.normal_vectors[1] = coords_set(0,0,1);

// for sides with y component = 0
x_component = 2*zdepth/sqrt((xwidth-xwidth2)*(xwidth-xwidth2)+4*zdepth*zdepth);
z_component = (xwidth-xwidth2)/sqrt(4*zdepth*zdepth+(xwidth-xwidth2)*(xwidth-xwidth2));

this_box_storage.normal_vectors[2] = coords_set(x_component,0,z_component);
this_box_storage.normal_vectors[3] = coords_set(-x_component,0,z_component);

// for sides with x component = 0
y_component = 2*zdepth/sqrt((yheight-yheight2)*(yheight-yheight2)+4*zdepth*zdepth);
z_component = (yheight-yheight2)/sqrt(4*zdepth*zdepth+(yheight-yheight2)*(yheight-yheight2));

this_box_storage.normal_vectors[4] = coords_set(0,y_component,z_component);
this_box_storage.normal_vectors[5] = coords_set(0,-y_component,z_component);

this_box_volume.geometry.visualization_on = visualize;

this_box_volume.geometry.geometry_parameters.p_box_storage = &this_box_storage;

// Assign pointers to functions for intersection with the shape, checking if a point is inside the shape
if (this_box_storage.is_rectangle == 1) {
this_box_volume.geometry.intersect_function = &sample_box_intersect_simple;
this_box_volume.geometry.within_function = &r_within_box_simple;
}
else {
this_box_volume.geometry.intersect_function = &sample_box_intersect_advanced;
this_box_volume.geometry.within_function = &r_within_box_advanced;
}

this_box_volume.geometry.shell_points = &box_shell_points;
this_box_volume.geometry.mcdisplay_function = &mcdisplay_box_function;
this_box_volume.geometry.initialize_from_main_function = &initialize_box_geometry_from_main_component;
this_box_volume.geometry.process_rot_allocated = 0;

this_box_volume.geometry.copy_geometry_parameters = &allocate_box_storage_copy;

rot_copy(this_box_volume.geometry.rotation_matrix,ROT_A_CURRENT_COMP); //check how ROT_R_CURRENT_COMP would work
rot_transpose(ROT_A_CURRENT_COMP,this_box_volume.geometry.transpose_rotation_matrix);

// Initialize loggers
this_box_volume.loggers.num_elements = 0;

// packing the information into the global_geometry_element, which is then included in the global_geometry_list.
sprintf(global_geometry_element.name,NAME_CURRENT_COMP);
global_geometry_element.activation_counter = number_of_activations;
global_geometry_element.component_index = INDEX_CURRENT_COMP;
global_geometry_element.Volume = &this_box_volume; // Would be nicer if this m was a pointer, now we have the (small) data two places
add_element_to_geometry_list(&global_geometry_list,global_geometry_element);
}
#line 296639 "MACS_sample_kidney_box.c"
#undef number_of_activations
#undef mask_setting
#undef mask_string
#undef p_interact
#undef focus_r
#undef focus_xh
#undef focus_xw
#undef focus_ah
#undef focus_aw
#undef target_z
#undef target_y
#undef target_x
#undef target_index
#undef visualize
#undef yheight2
#undef xwidth2
#undef zdepth
#undef yheight
#undef xwidth
#undef priority
#undef material_string
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

  /* Initializations for component channel_15_cave1_box1. */
  SIG_MESSAGE("channel_15_cave1_box1 (Init)");
#define mccompcurname  channel_15_cave1_box1
#define mccompcurtype  Union_box
#define mccompcurindex 694
#define loop_index mccchannel_15_cave1_box1_loop_index
#define this_box_volume mccchannel_15_cave1_box1_this_box_volume
#define global_geometry_element mccchannel_15_cave1_box1_global_geometry_element
#define this_box_storage mccchannel_15_cave1_box1_this_box_storage
#define material_string mccchannel_15_cave1_box1_material_string
#define priority mccchannel_15_cave1_box1_priority
#define xwidth mccchannel_15_cave1_box1_xwidth
#define yheight mccchannel_15_cave1_box1_yheight
#define zdepth mccchannel_15_cave1_box1_zdepth
#define xwidth2 mccchannel_15_cave1_box1_xwidth2
#define yheight2 mccchannel_15_cave1_box1_yheight2
#define visualize mccchannel_15_cave1_box1_visualize
#define target_index mccchannel_15_cave1_box1_target_index
#define target_x mccchannel_15_cave1_box1_target_x
#define target_y mccchannel_15_cave1_box1_target_y
#define target_z mccchannel_15_cave1_box1_target_z
#define focus_aw mccchannel_15_cave1_box1_focus_aw
#define focus_ah mccchannel_15_cave1_box1_focus_ah
#define focus_xw mccchannel_15_cave1_box1_focus_xw
#define focus_xh mccchannel_15_cave1_box1_focus_xh
#define focus_r mccchannel_15_cave1_box1_focus_r
#define p_interact mccchannel_15_cave1_box1_p_interact
#define mask_string mccchannel_15_cave1_box1_mask_string
#define mask_setting mccchannel_15_cave1_box1_mask_setting
#define number_of_activations mccchannel_15_cave1_box1_number_of_activations
#line 224 "Union_box.comp"
{
// Initializes the focusing system for this volume including input sanitation.
focus_initialize(&this_box_volume.geometry, POS_A_COMP_INDEX(INDEX_CURRENT_COMP+target_index), POS_A_CURRENT_COMP, ROT_A_CURRENT_COMP, target_index, target_x, target_y, target_z, focus_aw, focus_ah, focus_xw, focus_xh, focus_r, NAME_CURRENT_COMP);

// Input sanitation for this geometry
if (xwidth <= 0) {
  printf("\nERROR in Union_box named %s, the xwidth is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (yheight <= 0) {
  printf("\nERROR in Union_box named %s, yheight is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (zdepth <= 0) {
  printf("\nERROR in Union_box named %s, zdepth is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (xwidth2 <= 0 && xwidth2 != -1) {
  printf("\nERROR in Union_box named %s, the xwidth2 is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (yheight2 <= 0 && yheight2 != -1) {
  printf("\nERROR in Union_box named %s, yheight2 is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}

// Use sanitation
if (global_material_list.num_elements == 0) {
  printf("\nERROR: Need to define a material using Union_make_material before using a Union geometry component. \n");
  printf("       %s was defined before first use of Union_make_material.\n",NAME_CURRENT_COMP);
  exit(1);
}

this_box_volume.geometry.is_masked_volume = 0;
this_box_volume.geometry.is_exit_volume = 0;
this_box_volume.geometry.is_mask_volume = 0;
// check if the volume is a mask, if it is the material string is irelevant.
if (mask_string && strlen(mask_string) && strcmp(mask_string, "NULL") && strcmp(mask_string, "0")) {
    // A mask volume is used to limit the extend of other volumes, called the masked volumes. These are specified in the mask_string.
    // In order for a ray to enter a masked volume, it needs to be both in the region covered by that volume AND the mask volume.
    // When more than
    this_box_volume.geometry.mask_mode = 1; // Default is mask mode is ALL
    if (mask_setting && strlen(mask_setting) && strcmp(mask_setting, "NULL") && strcmp(mask_setting, "0")) {
        if (strcmp(mask_setting,"ALL") == 0 || strcmp(mask_setting,"All") == 0) this_box_volume.geometry.mask_mode = 1;
        else if (strcmp(mask_setting,"ANY") == 0 || strcmp(mask_setting,"Any") == 0) this_box_volume.geometry.mask_mode = 2;
        else {
            printf("The mask_mode of component %s is set to %s, but must be either ALL or ANY.\n",NAME_CURRENT_COMP,mask_setting);
            exit(1);
        }
    }
    
    for (loop_index=0;loop_index<global_geometry_list.num_elements;loop_index++) {
        // Add mask list
        if (1 == manual_linking_function(global_geometry_list.elements[loop_index].name,mask_string)) {
            add_element_to_int_list(&this_box_volume.geometry.mask_list,global_geometry_list.elements[loop_index].component_index);
            add_element_to_int_list(&global_geometry_list.elements[loop_index].Volume->geometry.masked_by_list,INDEX_CURRENT_COMP);
            global_geometry_list.elements[loop_index].Volume->geometry.is_masked_volume = 1;
            if (this_box_volume.geometry.mask_mode == 2)
                global_geometry_list.elements[loop_index].Volume->geometry.mask_mode = 2;
            if (this_box_volume.geometry.mask_mode == 1) {
                if (global_geometry_list.elements[loop_index].Volume->geometry.is_masked_volume == 1 && global_geometry_list.elements[loop_index].Volume->geometry.mask_mode != 2)
                    // If more than one mask is added to one volume, the ANY mode overwrites the (default) ALL mode.
                    global_geometry_list.elements[loop_index].Volume->geometry.mask_mode = 1;
            }
            
            found_geometries = 1;
        }
    }
    if (found_geometries == 0) {
        printf("The mask_string in geometry: %s did not find any of the specified volumes in the mask_string %s \n",NAME_CURRENT_COMP,mask_string);
        exit(1);
    }
    this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
    this_box_volume.p_physics->is_vacuum = 0; // Makes this volume a vacuum
    this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
    this_box_volume.p_physics->my_a = 0; // Should not be used.
    sprintf(this_box_volume.p_physics->name,"Mask");
    this_box_volume.geometry.is_mask_volume = 1;
    
    
// Read the material input, or if it lacks, use automatic linking.
} else if (material_string && strlen(material_string) && strcmp(material_string, "NULL") && strcmp(material_string, "0")) {
    // A geometry string was given, use it to determine which material
    if (0 == strcmp(material_string,"vacuum") || 0 == strcmp(material_string,"Vacuum")) {
        // One could have a global physics struct for vacuum instead of creating one for each
        this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
        this_box_volume.p_physics->is_vacuum = 1; // Makes this volume a vacuum
        this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
        this_box_volume.p_physics->my_a = 0; // Should not be used.
        sprintf(this_box_volume.p_physics->name,"Vacuum");
    } else if (0 == strcmp(material_string,"exit") || 0 == strcmp(material_string,"Exit")) {
        // One could have a global physics struct for vacuum instead of creating one for each
        this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
        this_box_volume.p_physics->is_vacuum = 1; // Makes this volume a vacuum
        this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
        this_box_volume.p_physics->my_a = 0; // Should not be used.
        this_box_volume.geometry.is_exit_volume = 1;
        sprintf(this_box_volume.p_physics->name,"Exit");
    } else {
        #ifndef MATERIAL_DETECTOR
            printf("Need to define a material before refering to it in a geometry %s.\n",NAME_CURRENT_COMP);
            exit(1);
        #endif
        for (loop_index=0;loop_index<global_material_list.num_elements;loop_index++) {
            if (0 == strcmp(material_string,global_material_list.elements[loop_index].name)) {
                this_box_volume.p_physics = global_material_list.elements[loop_index].physics;
                break;
            }
            if (loop_index == global_material_list.num_elements-1) {
            printf("\n");
            printf("ERROR: The material string \"%s\" in Union geometry \"%s\" did not match a specified material. \n",material_string,NAME_CURRENT_COMP);
            printf("       The materials available at this point (need to be defined before the geometry): \n");
            for (loop_index=0;loop_index<global_material_list.num_elements;loop_index++)
              printf("         %s\n",global_material_list.elements[loop_index].name);
            printf("\n");
            printf("       It is also possible to use one of the defualt materials avaiable: \n");
            printf("           Vacuum (for a Volume without scattering or absorption)\n");
            printf("           Exit (for a Volume where the ray exits the component if it enters)\n");
            printf("           Mask (for a Volume that masks existing volumes specified in the mask_string\n");
            exit(1);
          }
        }
    }
} else {
    // Automatic linking, simply using the last defined material.
    #ifndef MATERIAL_DETECTOR
        printf("Need to define a material before the geometry to use automatic linking %s.\n",NAME_CURRENT_COMP);
        exit(1);
    #endif
    this_box_volume.p_physics = global_material_list.elements[global_material_list.num_elements-1].physics;
}

sprintf(this_box_volume.name,NAME_CURRENT_COMP);
sprintf(this_box_volume.geometry.shape,"box");
this_box_volume.geometry.priority_value = priority;
this_box_volume.geometry.geometry_p_interact = p_interact;
// Currently the coordinates will be in absolute space.
this_box_volume.geometry.center = POS_A_CURRENT_COMP;

this_box_storage.z_depth = zdepth;
this_box_storage.x_width1 = xwidth;
this_box_storage.y_height1 = yheight;

this_box_storage.is_rectangle = 0;
if (xwidth2 < 0 && yheight2 < 0) this_box_storage.is_rectangle = 1;
if (xwidth == xwidth2 && yheight == yheight2) this_box_storage.is_rectangle = 1;

if (xwidth2 < 0) {
    this_box_storage.x_width2 = xwidth;
    xwidth2 = xwidth;
} else this_box_storage.x_width2 = xwidth2;

if (yheight2 < 0) {
    this_box_storage.y_height2 = yheight;
    yheight2 = yheight;
} else this_box_storage.y_height2 = yheight2;


this_box_storage.normal_vectors[0] = coords_set(0,0,1);
this_box_storage.normal_vectors[1] = coords_set(0,0,1);

// for sides with y component = 0
x_component = 2*zdepth/sqrt((xwidth-xwidth2)*(xwidth-xwidth2)+4*zdepth*zdepth);
z_component = (xwidth-xwidth2)/sqrt(4*zdepth*zdepth+(xwidth-xwidth2)*(xwidth-xwidth2));

this_box_storage.normal_vectors[2] = coords_set(x_component,0,z_component);
this_box_storage.normal_vectors[3] = coords_set(-x_component,0,z_component);

// for sides with x component = 0
y_component = 2*zdepth/sqrt((yheight-yheight2)*(yheight-yheight2)+4*zdepth*zdepth);
z_component = (yheight-yheight2)/sqrt(4*zdepth*zdepth+(yheight-yheight2)*(yheight-yheight2));

this_box_storage.normal_vectors[4] = coords_set(0,y_component,z_component);
this_box_storage.normal_vectors[5] = coords_set(0,-y_component,z_component);

this_box_volume.geometry.visualization_on = visualize;

this_box_volume.geometry.geometry_parameters.p_box_storage = &this_box_storage;

// Assign pointers to functions for intersection with the shape, checking if a point is inside the shape
if (this_box_storage.is_rectangle == 1) {
this_box_volume.geometry.intersect_function = &sample_box_intersect_simple;
this_box_volume.geometry.within_function = &r_within_box_simple;
}
else {
this_box_volume.geometry.intersect_function = &sample_box_intersect_advanced;
this_box_volume.geometry.within_function = &r_within_box_advanced;
}

this_box_volume.geometry.shell_points = &box_shell_points;
this_box_volume.geometry.mcdisplay_function = &mcdisplay_box_function;
this_box_volume.geometry.initialize_from_main_function = &initialize_box_geometry_from_main_component;
this_box_volume.geometry.process_rot_allocated = 0;

this_box_volume.geometry.copy_geometry_parameters = &allocate_box_storage_copy;

rot_copy(this_box_volume.geometry.rotation_matrix,ROT_A_CURRENT_COMP); //check how ROT_R_CURRENT_COMP would work
rot_transpose(ROT_A_CURRENT_COMP,this_box_volume.geometry.transpose_rotation_matrix);

// Initialize loggers
this_box_volume.loggers.num_elements = 0;

// packing the information into the global_geometry_element, which is then included in the global_geometry_list.
sprintf(global_geometry_element.name,NAME_CURRENT_COMP);
global_geometry_element.activation_counter = number_of_activations;
global_geometry_element.component_index = INDEX_CURRENT_COMP;
global_geometry_element.Volume = &this_box_volume; // Would be nicer if this m was a pointer, now we have the (small) data two places
add_element_to_geometry_list(&global_geometry_list,global_geometry_element);
}
#line 296909 "MACS_sample_kidney_box.c"
#undef number_of_activations
#undef mask_setting
#undef mask_string
#undef p_interact
#undef focus_r
#undef focus_xh
#undef focus_xw
#undef focus_ah
#undef focus_aw
#undef target_z
#undef target_y
#undef target_x
#undef target_index
#undef visualize
#undef yheight2
#undef xwidth2
#undef zdepth
#undef yheight
#undef xwidth
#undef priority
#undef material_string
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

  /* Initializations for component channel_15_cave1_box2. */
  SIG_MESSAGE("channel_15_cave1_box2 (Init)");
#define mccompcurname  channel_15_cave1_box2
#define mccompcurtype  Union_box
#define mccompcurindex 695
#define loop_index mccchannel_15_cave1_box2_loop_index
#define this_box_volume mccchannel_15_cave1_box2_this_box_volume
#define global_geometry_element mccchannel_15_cave1_box2_global_geometry_element
#define this_box_storage mccchannel_15_cave1_box2_this_box_storage
#define material_string mccchannel_15_cave1_box2_material_string
#define priority mccchannel_15_cave1_box2_priority
#define xwidth mccchannel_15_cave1_box2_xwidth
#define yheight mccchannel_15_cave1_box2_yheight
#define zdepth mccchannel_15_cave1_box2_zdepth
#define xwidth2 mccchannel_15_cave1_box2_xwidth2
#define yheight2 mccchannel_15_cave1_box2_yheight2
#define visualize mccchannel_15_cave1_box2_visualize
#define target_index mccchannel_15_cave1_box2_target_index
#define target_x mccchannel_15_cave1_box2_target_x
#define target_y mccchannel_15_cave1_box2_target_y
#define target_z mccchannel_15_cave1_box2_target_z
#define focus_aw mccchannel_15_cave1_box2_focus_aw
#define focus_ah mccchannel_15_cave1_box2_focus_ah
#define focus_xw mccchannel_15_cave1_box2_focus_xw
#define focus_xh mccchannel_15_cave1_box2_focus_xh
#define focus_r mccchannel_15_cave1_box2_focus_r
#define p_interact mccchannel_15_cave1_box2_p_interact
#define mask_string mccchannel_15_cave1_box2_mask_string
#define mask_setting mccchannel_15_cave1_box2_mask_setting
#define number_of_activations mccchannel_15_cave1_box2_number_of_activations
#line 224 "Union_box.comp"
{
// Initializes the focusing system for this volume including input sanitation.
focus_initialize(&this_box_volume.geometry, POS_A_COMP_INDEX(INDEX_CURRENT_COMP+target_index), POS_A_CURRENT_COMP, ROT_A_CURRENT_COMP, target_index, target_x, target_y, target_z, focus_aw, focus_ah, focus_xw, focus_xh, focus_r, NAME_CURRENT_COMP);

// Input sanitation for this geometry
if (xwidth <= 0) {
  printf("\nERROR in Union_box named %s, the xwidth is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (yheight <= 0) {
  printf("\nERROR in Union_box named %s, yheight is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (zdepth <= 0) {
  printf("\nERROR in Union_box named %s, zdepth is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (xwidth2 <= 0 && xwidth2 != -1) {
  printf("\nERROR in Union_box named %s, the xwidth2 is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (yheight2 <= 0 && yheight2 != -1) {
  printf("\nERROR in Union_box named %s, yheight2 is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}

// Use sanitation
if (global_material_list.num_elements == 0) {
  printf("\nERROR: Need to define a material using Union_make_material before using a Union geometry component. \n");
  printf("       %s was defined before first use of Union_make_material.\n",NAME_CURRENT_COMP);
  exit(1);
}

this_box_volume.geometry.is_masked_volume = 0;
this_box_volume.geometry.is_exit_volume = 0;
this_box_volume.geometry.is_mask_volume = 0;
// check if the volume is a mask, if it is the material string is irelevant.
if (mask_string && strlen(mask_string) && strcmp(mask_string, "NULL") && strcmp(mask_string, "0")) {
    // A mask volume is used to limit the extend of other volumes, called the masked volumes. These are specified in the mask_string.
    // In order for a ray to enter a masked volume, it needs to be both in the region covered by that volume AND the mask volume.
    // When more than
    this_box_volume.geometry.mask_mode = 1; // Default is mask mode is ALL
    if (mask_setting && strlen(mask_setting) && strcmp(mask_setting, "NULL") && strcmp(mask_setting, "0")) {
        if (strcmp(mask_setting,"ALL") == 0 || strcmp(mask_setting,"All") == 0) this_box_volume.geometry.mask_mode = 1;
        else if (strcmp(mask_setting,"ANY") == 0 || strcmp(mask_setting,"Any") == 0) this_box_volume.geometry.mask_mode = 2;
        else {
            printf("The mask_mode of component %s is set to %s, but must be either ALL or ANY.\n",NAME_CURRENT_COMP,mask_setting);
            exit(1);
        }
    }
    
    for (loop_index=0;loop_index<global_geometry_list.num_elements;loop_index++) {
        // Add mask list
        if (1 == manual_linking_function(global_geometry_list.elements[loop_index].name,mask_string)) {
            add_element_to_int_list(&this_box_volume.geometry.mask_list,global_geometry_list.elements[loop_index].component_index);
            add_element_to_int_list(&global_geometry_list.elements[loop_index].Volume->geometry.masked_by_list,INDEX_CURRENT_COMP);
            global_geometry_list.elements[loop_index].Volume->geometry.is_masked_volume = 1;
            if (this_box_volume.geometry.mask_mode == 2)
                global_geometry_list.elements[loop_index].Volume->geometry.mask_mode = 2;
            if (this_box_volume.geometry.mask_mode == 1) {
                if (global_geometry_list.elements[loop_index].Volume->geometry.is_masked_volume == 1 && global_geometry_list.elements[loop_index].Volume->geometry.mask_mode != 2)
                    // If more than one mask is added to one volume, the ANY mode overwrites the (default) ALL mode.
                    global_geometry_list.elements[loop_index].Volume->geometry.mask_mode = 1;
            }
            
            found_geometries = 1;
        }
    }
    if (found_geometries == 0) {
        printf("The mask_string in geometry: %s did not find any of the specified volumes in the mask_string %s \n",NAME_CURRENT_COMP,mask_string);
        exit(1);
    }
    this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
    this_box_volume.p_physics->is_vacuum = 0; // Makes this volume a vacuum
    this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
    this_box_volume.p_physics->my_a = 0; // Should not be used.
    sprintf(this_box_volume.p_physics->name,"Mask");
    this_box_volume.geometry.is_mask_volume = 1;
    
    
// Read the material input, or if it lacks, use automatic linking.
} else if (material_string && strlen(material_string) && strcmp(material_string, "NULL") && strcmp(material_string, "0")) {
    // A geometry string was given, use it to determine which material
    if (0 == strcmp(material_string,"vacuum") || 0 == strcmp(material_string,"Vacuum")) {
        // One could have a global physics struct for vacuum instead of creating one for each
        this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
        this_box_volume.p_physics->is_vacuum = 1; // Makes this volume a vacuum
        this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
        this_box_volume.p_physics->my_a = 0; // Should not be used.
        sprintf(this_box_volume.p_physics->name,"Vacuum");
    } else if (0 == strcmp(material_string,"exit") || 0 == strcmp(material_string,"Exit")) {
        // One could have a global physics struct for vacuum instead of creating one for each
        this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
        this_box_volume.p_physics->is_vacuum = 1; // Makes this volume a vacuum
        this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
        this_box_volume.p_physics->my_a = 0; // Should not be used.
        this_box_volume.geometry.is_exit_volume = 1;
        sprintf(this_box_volume.p_physics->name,"Exit");
    } else {
        #ifndef MATERIAL_DETECTOR
            printf("Need to define a material before refering to it in a geometry %s.\n",NAME_CURRENT_COMP);
            exit(1);
        #endif
        for (loop_index=0;loop_index<global_material_list.num_elements;loop_index++) {
            if (0 == strcmp(material_string,global_material_list.elements[loop_index].name)) {
                this_box_volume.p_physics = global_material_list.elements[loop_index].physics;
                break;
            }
            if (loop_index == global_material_list.num_elements-1) {
            printf("\n");
            printf("ERROR: The material string \"%s\" in Union geometry \"%s\" did not match a specified material. \n",material_string,NAME_CURRENT_COMP);
            printf("       The materials available at this point (need to be defined before the geometry): \n");
            for (loop_index=0;loop_index<global_material_list.num_elements;loop_index++)
              printf("         %s\n",global_material_list.elements[loop_index].name);
            printf("\n");
            printf("       It is also possible to use one of the defualt materials avaiable: \n");
            printf("           Vacuum (for a Volume without scattering or absorption)\n");
            printf("           Exit (for a Volume where the ray exits the component if it enters)\n");
            printf("           Mask (for a Volume that masks existing volumes specified in the mask_string\n");
            exit(1);
          }
        }
    }
} else {
    // Automatic linking, simply using the last defined material.
    #ifndef MATERIAL_DETECTOR
        printf("Need to define a material before the geometry to use automatic linking %s.\n",NAME_CURRENT_COMP);
        exit(1);
    #endif
    this_box_volume.p_physics = global_material_list.elements[global_material_list.num_elements-1].physics;
}

sprintf(this_box_volume.name,NAME_CURRENT_COMP);
sprintf(this_box_volume.geometry.shape,"box");
this_box_volume.geometry.priority_value = priority;
this_box_volume.geometry.geometry_p_interact = p_interact;
// Currently the coordinates will be in absolute space.
this_box_volume.geometry.center = POS_A_CURRENT_COMP;

this_box_storage.z_depth = zdepth;
this_box_storage.x_width1 = xwidth;
this_box_storage.y_height1 = yheight;

this_box_storage.is_rectangle = 0;
if (xwidth2 < 0 && yheight2 < 0) this_box_storage.is_rectangle = 1;
if (xwidth == xwidth2 && yheight == yheight2) this_box_storage.is_rectangle = 1;

if (xwidth2 < 0) {
    this_box_storage.x_width2 = xwidth;
    xwidth2 = xwidth;
} else this_box_storage.x_width2 = xwidth2;

if (yheight2 < 0) {
    this_box_storage.y_height2 = yheight;
    yheight2 = yheight;
} else this_box_storage.y_height2 = yheight2;


this_box_storage.normal_vectors[0] = coords_set(0,0,1);
this_box_storage.normal_vectors[1] = coords_set(0,0,1);

// for sides with y component = 0
x_component = 2*zdepth/sqrt((xwidth-xwidth2)*(xwidth-xwidth2)+4*zdepth*zdepth);
z_component = (xwidth-xwidth2)/sqrt(4*zdepth*zdepth+(xwidth-xwidth2)*(xwidth-xwidth2));

this_box_storage.normal_vectors[2] = coords_set(x_component,0,z_component);
this_box_storage.normal_vectors[3] = coords_set(-x_component,0,z_component);

// for sides with x component = 0
y_component = 2*zdepth/sqrt((yheight-yheight2)*(yheight-yheight2)+4*zdepth*zdepth);
z_component = (yheight-yheight2)/sqrt(4*zdepth*zdepth+(yheight-yheight2)*(yheight-yheight2));

this_box_storage.normal_vectors[4] = coords_set(0,y_component,z_component);
this_box_storage.normal_vectors[5] = coords_set(0,-y_component,z_component);

this_box_volume.geometry.visualization_on = visualize;

this_box_volume.geometry.geometry_parameters.p_box_storage = &this_box_storage;

// Assign pointers to functions for intersection with the shape, checking if a point is inside the shape
if (this_box_storage.is_rectangle == 1) {
this_box_volume.geometry.intersect_function = &sample_box_intersect_simple;
this_box_volume.geometry.within_function = &r_within_box_simple;
}
else {
this_box_volume.geometry.intersect_function = &sample_box_intersect_advanced;
this_box_volume.geometry.within_function = &r_within_box_advanced;
}

this_box_volume.geometry.shell_points = &box_shell_points;
this_box_volume.geometry.mcdisplay_function = &mcdisplay_box_function;
this_box_volume.geometry.initialize_from_main_function = &initialize_box_geometry_from_main_component;
this_box_volume.geometry.process_rot_allocated = 0;

this_box_volume.geometry.copy_geometry_parameters = &allocate_box_storage_copy;

rot_copy(this_box_volume.geometry.rotation_matrix,ROT_A_CURRENT_COMP); //check how ROT_R_CURRENT_COMP would work
rot_transpose(ROT_A_CURRENT_COMP,this_box_volume.geometry.transpose_rotation_matrix);

// Initialize loggers
this_box_volume.loggers.num_elements = 0;

// packing the information into the global_geometry_element, which is then included in the global_geometry_list.
sprintf(global_geometry_element.name,NAME_CURRENT_COMP);
global_geometry_element.activation_counter = number_of_activations;
global_geometry_element.component_index = INDEX_CURRENT_COMP;
global_geometry_element.Volume = &this_box_volume; // Would be nicer if this m was a pointer, now we have the (small) data two places
add_element_to_geometry_list(&global_geometry_list,global_geometry_element);
}
#line 297179 "MACS_sample_kidney_box.c"
#undef number_of_activations
#undef mask_setting
#undef mask_string
#undef p_interact
#undef focus_r
#undef focus_xh
#undef focus_xw
#undef focus_ah
#undef focus_aw
#undef target_z
#undef target_y
#undef target_x
#undef target_index
#undef visualize
#undef yheight2
#undef xwidth2
#undef zdepth
#undef yheight
#undef xwidth
#undef priority
#undef material_string
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

  /* Initializations for component channel_15_cave1_box3. */
  SIG_MESSAGE("channel_15_cave1_box3 (Init)");
#define mccompcurname  channel_15_cave1_box3
#define mccompcurtype  Union_box
#define mccompcurindex 696
#define loop_index mccchannel_15_cave1_box3_loop_index
#define this_box_volume mccchannel_15_cave1_box3_this_box_volume
#define global_geometry_element mccchannel_15_cave1_box3_global_geometry_element
#define this_box_storage mccchannel_15_cave1_box3_this_box_storage
#define material_string mccchannel_15_cave1_box3_material_string
#define priority mccchannel_15_cave1_box3_priority
#define xwidth mccchannel_15_cave1_box3_xwidth
#define yheight mccchannel_15_cave1_box3_yheight
#define zdepth mccchannel_15_cave1_box3_zdepth
#define xwidth2 mccchannel_15_cave1_box3_xwidth2
#define yheight2 mccchannel_15_cave1_box3_yheight2
#define visualize mccchannel_15_cave1_box3_visualize
#define target_index mccchannel_15_cave1_box3_target_index
#define target_x mccchannel_15_cave1_box3_target_x
#define target_y mccchannel_15_cave1_box3_target_y
#define target_z mccchannel_15_cave1_box3_target_z
#define focus_aw mccchannel_15_cave1_box3_focus_aw
#define focus_ah mccchannel_15_cave1_box3_focus_ah
#define focus_xw mccchannel_15_cave1_box3_focus_xw
#define focus_xh mccchannel_15_cave1_box3_focus_xh
#define focus_r mccchannel_15_cave1_box3_focus_r
#define p_interact mccchannel_15_cave1_box3_p_interact
#define mask_string mccchannel_15_cave1_box3_mask_string
#define mask_setting mccchannel_15_cave1_box3_mask_setting
#define number_of_activations mccchannel_15_cave1_box3_number_of_activations
#line 224 "Union_box.comp"
{
// Initializes the focusing system for this volume including input sanitation.
focus_initialize(&this_box_volume.geometry, POS_A_COMP_INDEX(INDEX_CURRENT_COMP+target_index), POS_A_CURRENT_COMP, ROT_A_CURRENT_COMP, target_index, target_x, target_y, target_z, focus_aw, focus_ah, focus_xw, focus_xh, focus_r, NAME_CURRENT_COMP);

// Input sanitation for this geometry
if (xwidth <= 0) {
  printf("\nERROR in Union_box named %s, the xwidth is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (yheight <= 0) {
  printf("\nERROR in Union_box named %s, yheight is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (zdepth <= 0) {
  printf("\nERROR in Union_box named %s, zdepth is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (xwidth2 <= 0 && xwidth2 != -1) {
  printf("\nERROR in Union_box named %s, the xwidth2 is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (yheight2 <= 0 && yheight2 != -1) {
  printf("\nERROR in Union_box named %s, yheight2 is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}

// Use sanitation
if (global_material_list.num_elements == 0) {
  printf("\nERROR: Need to define a material using Union_make_material before using a Union geometry component. \n");
  printf("       %s was defined before first use of Union_make_material.\n",NAME_CURRENT_COMP);
  exit(1);
}

this_box_volume.geometry.is_masked_volume = 0;
this_box_volume.geometry.is_exit_volume = 0;
this_box_volume.geometry.is_mask_volume = 0;
// check if the volume is a mask, if it is the material string is irelevant.
if (mask_string && strlen(mask_string) && strcmp(mask_string, "NULL") && strcmp(mask_string, "0")) {
    // A mask volume is used to limit the extend of other volumes, called the masked volumes. These are specified in the mask_string.
    // In order for a ray to enter a masked volume, it needs to be both in the region covered by that volume AND the mask volume.
    // When more than
    this_box_volume.geometry.mask_mode = 1; // Default is mask mode is ALL
    if (mask_setting && strlen(mask_setting) && strcmp(mask_setting, "NULL") && strcmp(mask_setting, "0")) {
        if (strcmp(mask_setting,"ALL") == 0 || strcmp(mask_setting,"All") == 0) this_box_volume.geometry.mask_mode = 1;
        else if (strcmp(mask_setting,"ANY") == 0 || strcmp(mask_setting,"Any") == 0) this_box_volume.geometry.mask_mode = 2;
        else {
            printf("The mask_mode of component %s is set to %s, but must be either ALL or ANY.\n",NAME_CURRENT_COMP,mask_setting);
            exit(1);
        }
    }
    
    for (loop_index=0;loop_index<global_geometry_list.num_elements;loop_index++) {
        // Add mask list
        if (1 == manual_linking_function(global_geometry_list.elements[loop_index].name,mask_string)) {
            add_element_to_int_list(&this_box_volume.geometry.mask_list,global_geometry_list.elements[loop_index].component_index);
            add_element_to_int_list(&global_geometry_list.elements[loop_index].Volume->geometry.masked_by_list,INDEX_CURRENT_COMP);
            global_geometry_list.elements[loop_index].Volume->geometry.is_masked_volume = 1;
            if (this_box_volume.geometry.mask_mode == 2)
                global_geometry_list.elements[loop_index].Volume->geometry.mask_mode = 2;
            if (this_box_volume.geometry.mask_mode == 1) {
                if (global_geometry_list.elements[loop_index].Volume->geometry.is_masked_volume == 1 && global_geometry_list.elements[loop_index].Volume->geometry.mask_mode != 2)
                    // If more than one mask is added to one volume, the ANY mode overwrites the (default) ALL mode.
                    global_geometry_list.elements[loop_index].Volume->geometry.mask_mode = 1;
            }
            
            found_geometries = 1;
        }
    }
    if (found_geometries == 0) {
        printf("The mask_string in geometry: %s did not find any of the specified volumes in the mask_string %s \n",NAME_CURRENT_COMP,mask_string);
        exit(1);
    }
    this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
    this_box_volume.p_physics->is_vacuum = 0; // Makes this volume a vacuum
    this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
    this_box_volume.p_physics->my_a = 0; // Should not be used.
    sprintf(this_box_volume.p_physics->name,"Mask");
    this_box_volume.geometry.is_mask_volume = 1;
    
    
// Read the material input, or if it lacks, use automatic linking.
} else if (material_string && strlen(material_string) && strcmp(material_string, "NULL") && strcmp(material_string, "0")) {
    // A geometry string was given, use it to determine which material
    if (0 == strcmp(material_string,"vacuum") || 0 == strcmp(material_string,"Vacuum")) {
        // One could have a global physics struct for vacuum instead of creating one for each
        this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
        this_box_volume.p_physics->is_vacuum = 1; // Makes this volume a vacuum
        this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
        this_box_volume.p_physics->my_a = 0; // Should not be used.
        sprintf(this_box_volume.p_physics->name,"Vacuum");
    } else if (0 == strcmp(material_string,"exit") || 0 == strcmp(material_string,"Exit")) {
        // One could have a global physics struct for vacuum instead of creating one for each
        this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
        this_box_volume.p_physics->is_vacuum = 1; // Makes this volume a vacuum
        this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
        this_box_volume.p_physics->my_a = 0; // Should not be used.
        this_box_volume.geometry.is_exit_volume = 1;
        sprintf(this_box_volume.p_physics->name,"Exit");
    } else {
        #ifndef MATERIAL_DETECTOR
            printf("Need to define a material before refering to it in a geometry %s.\n",NAME_CURRENT_COMP);
            exit(1);
        #endif
        for (loop_index=0;loop_index<global_material_list.num_elements;loop_index++) {
            if (0 == strcmp(material_string,global_material_list.elements[loop_index].name)) {
                this_box_volume.p_physics = global_material_list.elements[loop_index].physics;
                break;
            }
            if (loop_index == global_material_list.num_elements-1) {
            printf("\n");
            printf("ERROR: The material string \"%s\" in Union geometry \"%s\" did not match a specified material. \n",material_string,NAME_CURRENT_COMP);
            printf("       The materials available at this point (need to be defined before the geometry): \n");
            for (loop_index=0;loop_index<global_material_list.num_elements;loop_index++)
              printf("         %s\n",global_material_list.elements[loop_index].name);
            printf("\n");
            printf("       It is also possible to use one of the defualt materials avaiable: \n");
            printf("           Vacuum (for a Volume without scattering or absorption)\n");
            printf("           Exit (for a Volume where the ray exits the component if it enters)\n");
            printf("           Mask (for a Volume that masks existing volumes specified in the mask_string\n");
            exit(1);
          }
        }
    }
} else {
    // Automatic linking, simply using the last defined material.
    #ifndef MATERIAL_DETECTOR
        printf("Need to define a material before the geometry to use automatic linking %s.\n",NAME_CURRENT_COMP);
        exit(1);
    #endif
    this_box_volume.p_physics = global_material_list.elements[global_material_list.num_elements-1].physics;
}

sprintf(this_box_volume.name,NAME_CURRENT_COMP);
sprintf(this_box_volume.geometry.shape,"box");
this_box_volume.geometry.priority_value = priority;
this_box_volume.geometry.geometry_p_interact = p_interact;
// Currently the coordinates will be in absolute space.
this_box_volume.geometry.center = POS_A_CURRENT_COMP;

this_box_storage.z_depth = zdepth;
this_box_storage.x_width1 = xwidth;
this_box_storage.y_height1 = yheight;

this_box_storage.is_rectangle = 0;
if (xwidth2 < 0 && yheight2 < 0) this_box_storage.is_rectangle = 1;
if (xwidth == xwidth2 && yheight == yheight2) this_box_storage.is_rectangle = 1;

if (xwidth2 < 0) {
    this_box_storage.x_width2 = xwidth;
    xwidth2 = xwidth;
} else this_box_storage.x_width2 = xwidth2;

if (yheight2 < 0) {
    this_box_storage.y_height2 = yheight;
    yheight2 = yheight;
} else this_box_storage.y_height2 = yheight2;


this_box_storage.normal_vectors[0] = coords_set(0,0,1);
this_box_storage.normal_vectors[1] = coords_set(0,0,1);

// for sides with y component = 0
x_component = 2*zdepth/sqrt((xwidth-xwidth2)*(xwidth-xwidth2)+4*zdepth*zdepth);
z_component = (xwidth-xwidth2)/sqrt(4*zdepth*zdepth+(xwidth-xwidth2)*(xwidth-xwidth2));

this_box_storage.normal_vectors[2] = coords_set(x_component,0,z_component);
this_box_storage.normal_vectors[3] = coords_set(-x_component,0,z_component);

// for sides with x component = 0
y_component = 2*zdepth/sqrt((yheight-yheight2)*(yheight-yheight2)+4*zdepth*zdepth);
z_component = (yheight-yheight2)/sqrt(4*zdepth*zdepth+(yheight-yheight2)*(yheight-yheight2));

this_box_storage.normal_vectors[4] = coords_set(0,y_component,z_component);
this_box_storage.normal_vectors[5] = coords_set(0,-y_component,z_component);

this_box_volume.geometry.visualization_on = visualize;

this_box_volume.geometry.geometry_parameters.p_box_storage = &this_box_storage;

// Assign pointers to functions for intersection with the shape, checking if a point is inside the shape
if (this_box_storage.is_rectangle == 1) {
this_box_volume.geometry.intersect_function = &sample_box_intersect_simple;
this_box_volume.geometry.within_function = &r_within_box_simple;
}
else {
this_box_volume.geometry.intersect_function = &sample_box_intersect_advanced;
this_box_volume.geometry.within_function = &r_within_box_advanced;
}

this_box_volume.geometry.shell_points = &box_shell_points;
this_box_volume.geometry.mcdisplay_function = &mcdisplay_box_function;
this_box_volume.geometry.initialize_from_main_function = &initialize_box_geometry_from_main_component;
this_box_volume.geometry.process_rot_allocated = 0;

this_box_volume.geometry.copy_geometry_parameters = &allocate_box_storage_copy;

rot_copy(this_box_volume.geometry.rotation_matrix,ROT_A_CURRENT_COMP); //check how ROT_R_CURRENT_COMP would work
rot_transpose(ROT_A_CURRENT_COMP,this_box_volume.geometry.transpose_rotation_matrix);

// Initialize loggers
this_box_volume.loggers.num_elements = 0;

// packing the information into the global_geometry_element, which is then included in the global_geometry_list.
sprintf(global_geometry_element.name,NAME_CURRENT_COMP);
global_geometry_element.activation_counter = number_of_activations;
global_geometry_element.component_index = INDEX_CURRENT_COMP;
global_geometry_element.Volume = &this_box_volume; // Would be nicer if this m was a pointer, now we have the (small) data two places
add_element_to_geometry_list(&global_geometry_list,global_geometry_element);
}
#line 297449 "MACS_sample_kidney_box.c"
#undef number_of_activations
#undef mask_setting
#undef mask_string
#undef p_interact
#undef focus_r
#undef focus_xh
#undef focus_xw
#undef focus_ah
#undef focus_aw
#undef target_z
#undef target_y
#undef target_x
#undef target_index
#undef visualize
#undef yheight2
#undef xwidth2
#undef zdepth
#undef yheight
#undef xwidth
#undef priority
#undef material_string
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

  /* Initializations for component channel_15_cave1_cyl1. */
  SIG_MESSAGE("channel_15_cave1_cyl1 (Init)");
#define mccompcurname  channel_15_cave1_cyl1
#define mccompcurtype  Union_cylinder
#define mccompcurindex 697
#define loop_index mccchannel_15_cave1_cyl1_loop_index
#define this_cylinder_volume mccchannel_15_cave1_cyl1_this_cylinder_volume
#define global_geometry_element mccchannel_15_cave1_cyl1_global_geometry_element
#define this_cylinder_storage mccchannel_15_cave1_cyl1_this_cylinder_storage
#define material_string mccchannel_15_cave1_cyl1_material_string
#define priority mccchannel_15_cave1_cyl1_priority
#define radius mccchannel_15_cave1_cyl1_radius
#define yheight mccchannel_15_cave1_cyl1_yheight
#define visualize mccchannel_15_cave1_cyl1_visualize
#define target_index mccchannel_15_cave1_cyl1_target_index
#define target_x mccchannel_15_cave1_cyl1_target_x
#define target_y mccchannel_15_cave1_cyl1_target_y
#define target_z mccchannel_15_cave1_cyl1_target_z
#define focus_aw mccchannel_15_cave1_cyl1_focus_aw
#define focus_ah mccchannel_15_cave1_cyl1_focus_ah
#define focus_xw mccchannel_15_cave1_cyl1_focus_xw
#define focus_xh mccchannel_15_cave1_cyl1_focus_xh
#define focus_r mccchannel_15_cave1_cyl1_focus_r
#define p_interact mccchannel_15_cave1_cyl1_p_interact
#define mask_string mccchannel_15_cave1_cyl1_mask_string
#define mask_setting mccchannel_15_cave1_cyl1_mask_setting
#define number_of_activations mccchannel_15_cave1_cyl1_number_of_activations
#line 185 "Union_cylinder.comp"
{
// Initializes the focusing system for this volume including input sanitation.
focus_initialize(&this_cylinder_volume.geometry, POS_A_COMP_INDEX(INDEX_CURRENT_COMP+target_index), POS_A_CURRENT_COMP, ROT_A_CURRENT_COMP, target_index, target_x, target_y, target_z, focus_aw, focus_ah, focus_xw, focus_xh, focus_r, NAME_CURRENT_COMP);

// Input sanitation for this geometry
if (radius <= 0) {
  printf("\nERROR in Union_cylinder named %s, the radius is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}

if (yheight <= 0) {
  printf("\nERROR in Union_cylinder named %s, yheight is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}

// Use sanitation
#ifdef MATERIAL_DETECTOR
if (global_material_list.num_elements == 0) {
  // Here if the user have defined a material, but only after this material
  printf("\nERROR: Need to define a material using Union_make_material before using a Union geometry component. \n");
  printf("       %s was defined before first use of Union_make_material.\n",NAME_CURRENT_COMP);
  exit(1);
}
#endif
#ifndef MATERIAL_DETECTOR
  printf("\nERROR: Need to define a material using Union_make_material before using a Union geometry component. \n");
  exit(1);
#endif


this_cylinder_volume.geometry.is_masked_volume = 0;
this_cylinder_volume.geometry.is_exit_volume = 0;
this_cylinder_volume.geometry.is_mask_volume = 0;

// Read the material input, or if it lacks, use automatic linking.
if (mask_string && strlen(mask_string) && strcmp(mask_string, "NULL") && strcmp(mask_string, "0")) {
    // A mask volume is used to limit the extend of other volumes, called the masked volumes. These are specified in the mask_string.
    // In order for a ray to enter a masked volume, it needs to be both in the region covered by that volume AND the mask volume.
    // When more than
    this_cylinder_volume.geometry.mask_mode = 1; // Default is mask mode is ALL
    if (mask_setting && strlen(mask_setting) && strcmp(mask_setting, "NULL") && strcmp(mask_setting, "0")) {
        if (strcmp(mask_setting,"ALL") == 0 || strcmp(mask_setting,"All") == 0) this_cylinder_volume.geometry.mask_mode = 1;
        else if (strcmp(mask_setting,"ANY") == 0 || strcmp(mask_setting,"Any") == 0) this_cylinder_volume.geometry.mask_mode = 2;
        else {
            printf("The mask_mode of component %s is set to %s, but must be either ALL or ANY.\n",NAME_CURRENT_COMP,mask_setting);
            exit(1);
        }
    }
    
    for (loop_index=0;loop_index<global_geometry_list.num_elements;loop_index++) {
        // Add mask list
        if (1 == manual_linking_function(global_geometry_list.elements[loop_index].name,mask_string)) {
            add_element_to_int_list(&this_cylinder_volume.geometry.mask_list,global_geometry_list.elements[loop_index].component_index);
            add_element_to_int_list(&global_geometry_list.elements[loop_index].Volume->geometry.masked_by_list,INDEX_CURRENT_COMP);
            global_geometry_list.elements[loop_index].Volume->geometry.is_masked_volume = 1;
            if (this_cylinder_volume.geometry.mask_mode == 2)
                global_geometry_list.elements[loop_index].Volume->geometry.mask_mode = 2;
            if (this_cylinder_volume.geometry.mask_mode == 1) {
                if (global_geometry_list.elements[loop_index].Volume->geometry.is_masked_volume == 1 && global_geometry_list.elements[loop_index].Volume->geometry.mask_mode != 2)
                    // If more than one mask is added to one volume, the ANY mode overwrites the (default) ALL mode.
                    global_geometry_list.elements[loop_index].Volume->geometry.mask_mode = 1;
            }
            
            found_geometries = 1;
        }
    }
    if (found_geometries == 0) {
        printf("The mask_string in geometry: %s did not find any of the specified volumes in the mask_string %s \n",NAME_CURRENT_COMP,mask_string);
        exit(1);
    }
    this_cylinder_volume.p_physics = malloc(sizeof(struct physics_struct));
    this_cylinder_volume.p_physics->is_vacuum = 0; // Makes this volume a vacuum
    this_cylinder_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
    this_cylinder_volume.p_physics->my_a = 0; // Should not be used.
    sprintf(this_cylinder_volume.p_physics->name,"Mask");
    this_cylinder_volume.geometry.is_mask_volume = 1;
    
    
// Read the material input, or if it lacks, use automatic linking.
} else if (material_string && strlen(material_string) && strcmp(material_string, "NULL") && strcmp(material_string, "0")) {
    // A geometry string was given, use it to determine which material
    if (0 == strcmp(material_string,"vacuum") || 0 == strcmp(material_string,"Vacuum")) {
        // One could have a global physics struct for vacuum instead of creating one for each
        this_cylinder_volume.p_physics = malloc(sizeof(struct physics_struct));
        this_cylinder_volume.p_physics->is_vacuum = 1; // Makes this volume a vacuum
        this_cylinder_volume.p_physics->number_of_processes = (int) 0;
        this_cylinder_volume.p_physics->my_a = 0; // Should not be used.
        sprintf(this_cylinder_volume.p_physics->name,"Vacuum");
    } else if (0 == strcmp(material_string,"exit") || 0 == strcmp(material_string,"Exit")) {
        // One could have a global physics struct for exit instead of creating one for each
        this_cylinder_volume.p_physics = malloc(sizeof(struct physics_struct));
        this_cylinder_volume.p_physics->is_vacuum = 1; // Makes this volume a vacuum
        this_cylinder_volume.p_physics->number_of_processes = (int) 0;
        this_cylinder_volume.p_physics->my_a = 0; // Should not be used.
        this_cylinder_volume.geometry.is_exit_volume = 1;
        sprintf(this_cylinder_volume.p_physics->name,"Exit");
    } else {
        for (loop_index=0;loop_index<global_material_list.num_elements;loop_index++) {
          if (0 == strcmp(material_string,global_material_list.elements[loop_index].name)) {
            this_cylinder_volume.p_physics = global_material_list.elements[loop_index].physics;
            break;
          }
          if (loop_index == global_material_list.num_elements-1) {
            printf("\n");
            printf("ERROR: The material string \"%s\" in Union geometry \"%s\" did not match a specified material. \n",material_string,NAME_CURRENT_COMP);
            printf("       The materials available at this point (need to be defined before the geometry): \n");
            for (loop_index=0;loop_index<global_material_list.num_elements;loop_index++)
              printf("         %s\n",global_material_list.elements[loop_index].name);
            printf("\n");
            printf("       It is also possible to use one of the defualt materials avaiable: \n");
            printf("           Vacuum (for a Volume without scattering or absorption)\n");
            printf("           Exit (for a Volume where the ray exits the component if it enters)\n");
            printf("           Mask (for a Volume that masks existing volumes specified in the mask_string\n");
            exit(1);
          }
        }
    }
} else {
    // Automatic linking, simply using the last defined material.
    #ifndef MATERIAL_DETECTOR
        printf("Need to define a material before the geometry to use automatic linking %s.\n",NAME_CURRENT_COMP);
        exit(1);
    #endif
    this_cylinder_volume.p_physics = global_material_list.elements[global_material_list.num_elements-1].physics;
}

sprintf(this_cylinder_volume.name,NAME_CURRENT_COMP);
sprintf(this_cylinder_volume.geometry.shape,"cylinder");
this_cylinder_volume.geometry.priority_value = priority;
// Currently the coordinates will be in absolute space.
this_cylinder_volume.geometry.center = POS_A_CURRENT_COMP;

this_cylinder_volume.geometry.geometry_p_interact = p_interact;
this_cylinder_storage.cyl_radius = radius;
this_cylinder_storage.height = yheight;
this_cylinder_volume.geometry.visualization_on = visualize;
this_cylinder_volume.geometry.geometry_parameters.p_cylinder_storage = &this_cylinder_storage;
this_cylinder_volume.geometry.within_function = &r_within_cylinder;
this_cylinder_volume.geometry.intersect_function = &sample_cylinder_intersect;
this_cylinder_volume.geometry.mcdisplay_function = &mcdisplay_cylinder_function;
this_cylinder_volume.geometry.shell_points = &cylinder_shell_points;
this_cylinder_volume.geometry.initialize_from_main_function = &initialize_cylinder_geometry_from_main_component;
this_cylinder_volume.geometry.process_rot_allocated = 0;
this_cylinder_volume.geometry.copy_geometry_parameters = &allocate_cylinder_storage_copy;

rot_copy(this_cylinder_volume.geometry.rotation_matrix,ROT_A_CURRENT_COMP);
rot_transpose(ROT_A_CURRENT_COMP,this_cylinder_volume.geometry.transpose_rotation_matrix);

// Initialize loggers
this_cylinder_volume.loggers.num_elements = 0;

// packing the information into the global_geometry_element, which is then included in the global_geometry_list.
sprintf(global_geometry_element.name,NAME_CURRENT_COMP);
global_geometry_element.activation_counter = number_of_activations;
global_geometry_element.component_index = INDEX_CURRENT_COMP;
global_geometry_element.Volume = &this_cylinder_volume; // Would be nicer if this m was a pointer, now we have the (small) data two places
add_element_to_geometry_list(&global_geometry_list,global_geometry_element);
}
#line 297665 "MACS_sample_kidney_box.c"
#undef number_of_activations
#undef mask_setting
#undef mask_string
#undef p_interact
#undef focus_r
#undef focus_xh
#undef focus_xw
#undef focus_ah
#undef focus_aw
#undef target_z
#undef target_y
#undef target_x
#undef target_index
#undef visualize
#undef yheight
#undef radius
#undef priority
#undef material_string
#undef this_cylinder_storage
#undef global_geometry_element
#undef this_cylinder_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

  /* Initializations for component channel_15_analyzer_1_center. */
  SIG_MESSAGE("channel_15_analyzer_1_center (Init)");

  /* Initializations for component channel_15_analyzer_1_rotated. */
  SIG_MESSAGE("channel_15_analyzer_1_rotated (Init)");

  /* Initializations for component channel_15_analyzer_1_array_crystal_array_0. */
  SIG_MESSAGE("channel_15_analyzer_1_array_crystal_array_0 (Init)");
#define mccompcurname  channel_15_analyzer_1_array_crystal_array_0
#define mccompcurtype  Union_box
#define mccompcurindex 700
#define loop_index mccchannel_15_analyzer_1_array_crystal_array_0_loop_index
#define this_box_volume mccchannel_15_analyzer_1_array_crystal_array_0_this_box_volume
#define global_geometry_element mccchannel_15_analyzer_1_array_crystal_array_0_global_geometry_element
#define this_box_storage mccchannel_15_analyzer_1_array_crystal_array_0_this_box_storage
#define material_string mccchannel_15_analyzer_1_array_crystal_array_0_material_string
#define priority mccchannel_15_analyzer_1_array_crystal_array_0_priority
#define xwidth mccchannel_15_analyzer_1_array_crystal_array_0_xwidth
#define yheight mccchannel_15_analyzer_1_array_crystal_array_0_yheight
#define zdepth mccchannel_15_analyzer_1_array_crystal_array_0_zdepth
#define xwidth2 mccchannel_15_analyzer_1_array_crystal_array_0_xwidth2
#define yheight2 mccchannel_15_analyzer_1_array_crystal_array_0_yheight2
#define visualize mccchannel_15_analyzer_1_array_crystal_array_0_visualize
#define target_index mccchannel_15_analyzer_1_array_crystal_array_0_target_index
#define target_x mccchannel_15_analyzer_1_array_crystal_array_0_target_x
#define target_y mccchannel_15_analyzer_1_array_crystal_array_0_target_y
#define target_z mccchannel_15_analyzer_1_array_crystal_array_0_target_z
#define focus_aw mccchannel_15_analyzer_1_array_crystal_array_0_focus_aw
#define focus_ah mccchannel_15_analyzer_1_array_crystal_array_0_focus_ah
#define focus_xw mccchannel_15_analyzer_1_array_crystal_array_0_focus_xw
#define focus_xh mccchannel_15_analyzer_1_array_crystal_array_0_focus_xh
#define focus_r mccchannel_15_analyzer_1_array_crystal_array_0_focus_r
#define p_interact mccchannel_15_analyzer_1_array_crystal_array_0_p_interact
#define mask_string mccchannel_15_analyzer_1_array_crystal_array_0_mask_string
#define mask_setting mccchannel_15_analyzer_1_array_crystal_array_0_mask_setting
#define number_of_activations mccchannel_15_analyzer_1_array_crystal_array_0_number_of_activations
#line 224 "Union_box.comp"
{
// Initializes the focusing system for this volume including input sanitation.
focus_initialize(&this_box_volume.geometry, POS_A_COMP_INDEX(INDEX_CURRENT_COMP+target_index), POS_A_CURRENT_COMP, ROT_A_CURRENT_COMP, target_index, target_x, target_y, target_z, focus_aw, focus_ah, focus_xw, focus_xh, focus_r, NAME_CURRENT_COMP);

// Input sanitation for this geometry
if (xwidth <= 0) {
  printf("\nERROR in Union_box named %s, the xwidth is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (yheight <= 0) {
  printf("\nERROR in Union_box named %s, yheight is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (zdepth <= 0) {
  printf("\nERROR in Union_box named %s, zdepth is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (xwidth2 <= 0 && xwidth2 != -1) {
  printf("\nERROR in Union_box named %s, the xwidth2 is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (yheight2 <= 0 && yheight2 != -1) {
  printf("\nERROR in Union_box named %s, yheight2 is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}

// Use sanitation
if (global_material_list.num_elements == 0) {
  printf("\nERROR: Need to define a material using Union_make_material before using a Union geometry component. \n");
  printf("       %s was defined before first use of Union_make_material.\n",NAME_CURRENT_COMP);
  exit(1);
}

this_box_volume.geometry.is_masked_volume = 0;
this_box_volume.geometry.is_exit_volume = 0;
this_box_volume.geometry.is_mask_volume = 0;
// check if the volume is a mask, if it is the material string is irelevant.
if (mask_string && strlen(mask_string) && strcmp(mask_string, "NULL") && strcmp(mask_string, "0")) {
    // A mask volume is used to limit the extend of other volumes, called the masked volumes. These are specified in the mask_string.
    // In order for a ray to enter a masked volume, it needs to be both in the region covered by that volume AND the mask volume.
    // When more than
    this_box_volume.geometry.mask_mode = 1; // Default is mask mode is ALL
    if (mask_setting && strlen(mask_setting) && strcmp(mask_setting, "NULL") && strcmp(mask_setting, "0")) {
        if (strcmp(mask_setting,"ALL") == 0 || strcmp(mask_setting,"All") == 0) this_box_volume.geometry.mask_mode = 1;
        else if (strcmp(mask_setting,"ANY") == 0 || strcmp(mask_setting,"Any") == 0) this_box_volume.geometry.mask_mode = 2;
        else {
            printf("The mask_mode of component %s is set to %s, but must be either ALL or ANY.\n",NAME_CURRENT_COMP,mask_setting);
            exit(1);
        }
    }
    
    for (loop_index=0;loop_index<global_geometry_list.num_elements;loop_index++) {
        // Add mask list
        if (1 == manual_linking_function(global_geometry_list.elements[loop_index].name,mask_string)) {
            add_element_to_int_list(&this_box_volume.geometry.mask_list,global_geometry_list.elements[loop_index].component_index);
            add_element_to_int_list(&global_geometry_list.elements[loop_index].Volume->geometry.masked_by_list,INDEX_CURRENT_COMP);
            global_geometry_list.elements[loop_index].Volume->geometry.is_masked_volume = 1;
            if (this_box_volume.geometry.mask_mode == 2)
                global_geometry_list.elements[loop_index].Volume->geometry.mask_mode = 2;
            if (this_box_volume.geometry.mask_mode == 1) {
                if (global_geometry_list.elements[loop_index].Volume->geometry.is_masked_volume == 1 && global_geometry_list.elements[loop_index].Volume->geometry.mask_mode != 2)
                    // If more than one mask is added to one volume, the ANY mode overwrites the (default) ALL mode.
                    global_geometry_list.elements[loop_index].Volume->geometry.mask_mode = 1;
            }
            
            found_geometries = 1;
        }
    }
    if (found_geometries == 0) {
        printf("The mask_string in geometry: %s did not find any of the specified volumes in the mask_string %s \n",NAME_CURRENT_COMP,mask_string);
        exit(1);
    }
    this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
    this_box_volume.p_physics->is_vacuum = 0; // Makes this volume a vacuum
    this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
    this_box_volume.p_physics->my_a = 0; // Should not be used.
    sprintf(this_box_volume.p_physics->name,"Mask");
    this_box_volume.geometry.is_mask_volume = 1;
    
    
// Read the material input, or if it lacks, use automatic linking.
} else if (material_string && strlen(material_string) && strcmp(material_string, "NULL") && strcmp(material_string, "0")) {
    // A geometry string was given, use it to determine which material
    if (0 == strcmp(material_string,"vacuum") || 0 == strcmp(material_string,"Vacuum")) {
        // One could have a global physics struct for vacuum instead of creating one for each
        this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
        this_box_volume.p_physics->is_vacuum = 1; // Makes this volume a vacuum
        this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
        this_box_volume.p_physics->my_a = 0; // Should not be used.
        sprintf(this_box_volume.p_physics->name,"Vacuum");
    } else if (0 == strcmp(material_string,"exit") || 0 == strcmp(material_string,"Exit")) {
        // One could have a global physics struct for vacuum instead of creating one for each
        this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
        this_box_volume.p_physics->is_vacuum = 1; // Makes this volume a vacuum
        this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
        this_box_volume.p_physics->my_a = 0; // Should not be used.
        this_box_volume.geometry.is_exit_volume = 1;
        sprintf(this_box_volume.p_physics->name,"Exit");
    } else {
        #ifndef MATERIAL_DETECTOR
            printf("Need to define a material before refering to it in a geometry %s.\n",NAME_CURRENT_COMP);
            exit(1);
        #endif
        for (loop_index=0;loop_index<global_material_list.num_elements;loop_index++) {
            if (0 == strcmp(material_string,global_material_list.elements[loop_index].name)) {
                this_box_volume.p_physics = global_material_list.elements[loop_index].physics;
                break;
            }
            if (loop_index == global_material_list.num_elements-1) {
            printf("\n");
            printf("ERROR: The material string \"%s\" in Union geometry \"%s\" did not match a specified material. \n",material_string,NAME_CURRENT_COMP);
            printf("       The materials available at this point (need to be defined before the geometry): \n");
            for (loop_index=0;loop_index<global_material_list.num_elements;loop_index++)
              printf("         %s\n",global_material_list.elements[loop_index].name);
            printf("\n");
            printf("       It is also possible to use one of the defualt materials avaiable: \n");
            printf("           Vacuum (for a Volume without scattering or absorption)\n");
            printf("           Exit (for a Volume where the ray exits the component if it enters)\n");
            printf("           Mask (for a Volume that masks existing volumes specified in the mask_string\n");
            exit(1);
          }
        }
    }
} else {
    // Automatic linking, simply using the last defined material.
    #ifndef MATERIAL_DETECTOR
        printf("Need to define a material before the geometry to use automatic linking %s.\n",NAME_CURRENT_COMP);
        exit(1);
    #endif
    this_box_volume.p_physics = global_material_list.elements[global_material_list.num_elements-1].physics;
}

sprintf(this_box_volume.name,NAME_CURRENT_COMP);
sprintf(this_box_volume.geometry.shape,"box");
this_box_volume.geometry.priority_value = priority;
this_box_volume.geometry.geometry_p_interact = p_interact;
// Currently the coordinates will be in absolute space.
this_box_volume.geometry.center = POS_A_CURRENT_COMP;

this_box_storage.z_depth = zdepth;
this_box_storage.x_width1 = xwidth;
this_box_storage.y_height1 = yheight;

this_box_storage.is_rectangle = 0;
if (xwidth2 < 0 && yheight2 < 0) this_box_storage.is_rectangle = 1;
if (xwidth == xwidth2 && yheight == yheight2) this_box_storage.is_rectangle = 1;

if (xwidth2 < 0) {
    this_box_storage.x_width2 = xwidth;
    xwidth2 = xwidth;
} else this_box_storage.x_width2 = xwidth2;

if (yheight2 < 0) {
    this_box_storage.y_height2 = yheight;
    yheight2 = yheight;
} else this_box_storage.y_height2 = yheight2;


this_box_storage.normal_vectors[0] = coords_set(0,0,1);
this_box_storage.normal_vectors[1] = coords_set(0,0,1);

// for sides with y component = 0
x_component = 2*zdepth/sqrt((xwidth-xwidth2)*(xwidth-xwidth2)+4*zdepth*zdepth);
z_component = (xwidth-xwidth2)/sqrt(4*zdepth*zdepth+(xwidth-xwidth2)*(xwidth-xwidth2));

this_box_storage.normal_vectors[2] = coords_set(x_component,0,z_component);
this_box_storage.normal_vectors[3] = coords_set(-x_component,0,z_component);

// for sides with x component = 0
y_component = 2*zdepth/sqrt((yheight-yheight2)*(yheight-yheight2)+4*zdepth*zdepth);
z_component = (yheight-yheight2)/sqrt(4*zdepth*zdepth+(yheight-yheight2)*(yheight-yheight2));

this_box_storage.normal_vectors[4] = coords_set(0,y_component,z_component);
this_box_storage.normal_vectors[5] = coords_set(0,-y_component,z_component);

this_box_volume.geometry.visualization_on = visualize;

this_box_volume.geometry.geometry_parameters.p_box_storage = &this_box_storage;

// Assign pointers to functions for intersection with the shape, checking if a point is inside the shape
if (this_box_storage.is_rectangle == 1) {
this_box_volume.geometry.intersect_function = &sample_box_intersect_simple;
this_box_volume.geometry.within_function = &r_within_box_simple;
}
else {
this_box_volume.geometry.intersect_function = &sample_box_intersect_advanced;
this_box_volume.geometry.within_function = &r_within_box_advanced;
}

this_box_volume.geometry.shell_points = &box_shell_points;
this_box_volume.geometry.mcdisplay_function = &mcdisplay_box_function;
this_box_volume.geometry.initialize_from_main_function = &initialize_box_geometry_from_main_component;
this_box_volume.geometry.process_rot_allocated = 0;

this_box_volume.geometry.copy_geometry_parameters = &allocate_box_storage_copy;

rot_copy(this_box_volume.geometry.rotation_matrix,ROT_A_CURRENT_COMP); //check how ROT_R_CURRENT_COMP would work
rot_transpose(ROT_A_CURRENT_COMP,this_box_volume.geometry.transpose_rotation_matrix);

// Initialize loggers
this_box_volume.loggers.num_elements = 0;

// packing the information into the global_geometry_element, which is then included in the global_geometry_list.
sprintf(global_geometry_element.name,NAME_CURRENT_COMP);
global_geometry_element.activation_counter = number_of_activations;
global_geometry_element.component_index = INDEX_CURRENT_COMP;
global_geometry_element.Volume = &this_box_volume; // Would be nicer if this m was a pointer, now we have the (small) data two places
add_element_to_geometry_list(&global_geometry_list,global_geometry_element);
}
#line 297938 "MACS_sample_kidney_box.c"
#undef number_of_activations
#undef mask_setting
#undef mask_string
#undef p_interact
#undef focus_r
#undef focus_xh
#undef focus_xw
#undef focus_ah
#undef focus_aw
#undef target_z
#undef target_y
#undef target_x
#undef target_index
#undef visualize
#undef yheight2
#undef xwidth2
#undef zdepth
#undef yheight
#undef xwidth
#undef priority
#undef material_string
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

  /* Initializations for component channel_15_analyzer_1_array_crystal_array_1. */
  SIG_MESSAGE("channel_15_analyzer_1_array_crystal_array_1 (Init)");
#define mccompcurname  channel_15_analyzer_1_array_crystal_array_1
#define mccompcurtype  Union_box
#define mccompcurindex 701
#define loop_index mccchannel_15_analyzer_1_array_crystal_array_1_loop_index
#define this_box_volume mccchannel_15_analyzer_1_array_crystal_array_1_this_box_volume
#define global_geometry_element mccchannel_15_analyzer_1_array_crystal_array_1_global_geometry_element
#define this_box_storage mccchannel_15_analyzer_1_array_crystal_array_1_this_box_storage
#define material_string mccchannel_15_analyzer_1_array_crystal_array_1_material_string
#define priority mccchannel_15_analyzer_1_array_crystal_array_1_priority
#define xwidth mccchannel_15_analyzer_1_array_crystal_array_1_xwidth
#define yheight mccchannel_15_analyzer_1_array_crystal_array_1_yheight
#define zdepth mccchannel_15_analyzer_1_array_crystal_array_1_zdepth
#define xwidth2 mccchannel_15_analyzer_1_array_crystal_array_1_xwidth2
#define yheight2 mccchannel_15_analyzer_1_array_crystal_array_1_yheight2
#define visualize mccchannel_15_analyzer_1_array_crystal_array_1_visualize
#define target_index mccchannel_15_analyzer_1_array_crystal_array_1_target_index
#define target_x mccchannel_15_analyzer_1_array_crystal_array_1_target_x
#define target_y mccchannel_15_analyzer_1_array_crystal_array_1_target_y
#define target_z mccchannel_15_analyzer_1_array_crystal_array_1_target_z
#define focus_aw mccchannel_15_analyzer_1_array_crystal_array_1_focus_aw
#define focus_ah mccchannel_15_analyzer_1_array_crystal_array_1_focus_ah
#define focus_xw mccchannel_15_analyzer_1_array_crystal_array_1_focus_xw
#define focus_xh mccchannel_15_analyzer_1_array_crystal_array_1_focus_xh
#define focus_r mccchannel_15_analyzer_1_array_crystal_array_1_focus_r
#define p_interact mccchannel_15_analyzer_1_array_crystal_array_1_p_interact
#define mask_string mccchannel_15_analyzer_1_array_crystal_array_1_mask_string
#define mask_setting mccchannel_15_analyzer_1_array_crystal_array_1_mask_setting
#define number_of_activations mccchannel_15_analyzer_1_array_crystal_array_1_number_of_activations
#line 224 "Union_box.comp"
{
// Initializes the focusing system for this volume including input sanitation.
focus_initialize(&this_box_volume.geometry, POS_A_COMP_INDEX(INDEX_CURRENT_COMP+target_index), POS_A_CURRENT_COMP, ROT_A_CURRENT_COMP, target_index, target_x, target_y, target_z, focus_aw, focus_ah, focus_xw, focus_xh, focus_r, NAME_CURRENT_COMP);

// Input sanitation for this geometry
if (xwidth <= 0) {
  printf("\nERROR in Union_box named %s, the xwidth is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (yheight <= 0) {
  printf("\nERROR in Union_box named %s, yheight is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (zdepth <= 0) {
  printf("\nERROR in Union_box named %s, zdepth is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (xwidth2 <= 0 && xwidth2 != -1) {
  printf("\nERROR in Union_box named %s, the xwidth2 is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (yheight2 <= 0 && yheight2 != -1) {
  printf("\nERROR in Union_box named %s, yheight2 is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}

// Use sanitation
if (global_material_list.num_elements == 0) {
  printf("\nERROR: Need to define a material using Union_make_material before using a Union geometry component. \n");
  printf("       %s was defined before first use of Union_make_material.\n",NAME_CURRENT_COMP);
  exit(1);
}

this_box_volume.geometry.is_masked_volume = 0;
this_box_volume.geometry.is_exit_volume = 0;
this_box_volume.geometry.is_mask_volume = 0;
// check if the volume is a mask, if it is the material string is irelevant.
if (mask_string && strlen(mask_string) && strcmp(mask_string, "NULL") && strcmp(mask_string, "0")) {
    // A mask volume is used to limit the extend of other volumes, called the masked volumes. These are specified in the mask_string.
    // In order for a ray to enter a masked volume, it needs to be both in the region covered by that volume AND the mask volume.
    // When more than
    this_box_volume.geometry.mask_mode = 1; // Default is mask mode is ALL
    if (mask_setting && strlen(mask_setting) && strcmp(mask_setting, "NULL") && strcmp(mask_setting, "0")) {
        if (strcmp(mask_setting,"ALL") == 0 || strcmp(mask_setting,"All") == 0) this_box_volume.geometry.mask_mode = 1;
        else if (strcmp(mask_setting,"ANY") == 0 || strcmp(mask_setting,"Any") == 0) this_box_volume.geometry.mask_mode = 2;
        else {
            printf("The mask_mode of component %s is set to %s, but must be either ALL or ANY.\n",NAME_CURRENT_COMP,mask_setting);
            exit(1);
        }
    }
    
    for (loop_index=0;loop_index<global_geometry_list.num_elements;loop_index++) {
        // Add mask list
        if (1 == manual_linking_function(global_geometry_list.elements[loop_index].name,mask_string)) {
            add_element_to_int_list(&this_box_volume.geometry.mask_list,global_geometry_list.elements[loop_index].component_index);
            add_element_to_int_list(&global_geometry_list.elements[loop_index].Volume->geometry.masked_by_list,INDEX_CURRENT_COMP);
            global_geometry_list.elements[loop_index].Volume->geometry.is_masked_volume = 1;
            if (this_box_volume.geometry.mask_mode == 2)
                global_geometry_list.elements[loop_index].Volume->geometry.mask_mode = 2;
            if (this_box_volume.geometry.mask_mode == 1) {
                if (global_geometry_list.elements[loop_index].Volume->geometry.is_masked_volume == 1 && global_geometry_list.elements[loop_index].Volume->geometry.mask_mode != 2)
                    // If more than one mask is added to one volume, the ANY mode overwrites the (default) ALL mode.
                    global_geometry_list.elements[loop_index].Volume->geometry.mask_mode = 1;
            }
            
            found_geometries = 1;
        }
    }
    if (found_geometries == 0) {
        printf("The mask_string in geometry: %s did not find any of the specified volumes in the mask_string %s \n",NAME_CURRENT_COMP,mask_string);
        exit(1);
    }
    this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
    this_box_volume.p_physics->is_vacuum = 0; // Makes this volume a vacuum
    this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
    this_box_volume.p_physics->my_a = 0; // Should not be used.
    sprintf(this_box_volume.p_physics->name,"Mask");
    this_box_volume.geometry.is_mask_volume = 1;
    
    
// Read the material input, or if it lacks, use automatic linking.
} else if (material_string && strlen(material_string) && strcmp(material_string, "NULL") && strcmp(material_string, "0")) {
    // A geometry string was given, use it to determine which material
    if (0 == strcmp(material_string,"vacuum") || 0 == strcmp(material_string,"Vacuum")) {
        // One could have a global physics struct for vacuum instead of creating one for each
        this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
        this_box_volume.p_physics->is_vacuum = 1; // Makes this volume a vacuum
        this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
        this_box_volume.p_physics->my_a = 0; // Should not be used.
        sprintf(this_box_volume.p_physics->name,"Vacuum");
    } else if (0 == strcmp(material_string,"exit") || 0 == strcmp(material_string,"Exit")) {
        // One could have a global physics struct for vacuum instead of creating one for each
        this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
        this_box_volume.p_physics->is_vacuum = 1; // Makes this volume a vacuum
        this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
        this_box_volume.p_physics->my_a = 0; // Should not be used.
        this_box_volume.geometry.is_exit_volume = 1;
        sprintf(this_box_volume.p_physics->name,"Exit");
    } else {
        #ifndef MATERIAL_DETECTOR
            printf("Need to define a material before refering to it in a geometry %s.\n",NAME_CURRENT_COMP);
            exit(1);
        #endif
        for (loop_index=0;loop_index<global_material_list.num_elements;loop_index++) {
            if (0 == strcmp(material_string,global_material_list.elements[loop_index].name)) {
                this_box_volume.p_physics = global_material_list.elements[loop_index].physics;
                break;
            }
            if (loop_index == global_material_list.num_elements-1) {
            printf("\n");
            printf("ERROR: The material string \"%s\" in Union geometry \"%s\" did not match a specified material. \n",material_string,NAME_CURRENT_COMP);
            printf("       The materials available at this point (need to be defined before the geometry): \n");
            for (loop_index=0;loop_index<global_material_list.num_elements;loop_index++)
              printf("         %s\n",global_material_list.elements[loop_index].name);
            printf("\n");
            printf("       It is also possible to use one of the defualt materials avaiable: \n");
            printf("           Vacuum (for a Volume without scattering or absorption)\n");
            printf("           Exit (for a Volume where the ray exits the component if it enters)\n");
            printf("           Mask (for a Volume that masks existing volumes specified in the mask_string\n");
            exit(1);
          }
        }
    }
} else {
    // Automatic linking, simply using the last defined material.
    #ifndef MATERIAL_DETECTOR
        printf("Need to define a material before the geometry to use automatic linking %s.\n",NAME_CURRENT_COMP);
        exit(1);
    #endif
    this_box_volume.p_physics = global_material_list.elements[global_material_list.num_elements-1].physics;
}

sprintf(this_box_volume.name,NAME_CURRENT_COMP);
sprintf(this_box_volume.geometry.shape,"box");
this_box_volume.geometry.priority_value = priority;
this_box_volume.geometry.geometry_p_interact = p_interact;
// Currently the coordinates will be in absolute space.
this_box_volume.geometry.center = POS_A_CURRENT_COMP;

this_box_storage.z_depth = zdepth;
this_box_storage.x_width1 = xwidth;
this_box_storage.y_height1 = yheight;

this_box_storage.is_rectangle = 0;
if (xwidth2 < 0 && yheight2 < 0) this_box_storage.is_rectangle = 1;
if (xwidth == xwidth2 && yheight == yheight2) this_box_storage.is_rectangle = 1;

if (xwidth2 < 0) {
    this_box_storage.x_width2 = xwidth;
    xwidth2 = xwidth;
} else this_box_storage.x_width2 = xwidth2;

if (yheight2 < 0) {
    this_box_storage.y_height2 = yheight;
    yheight2 = yheight;
} else this_box_storage.y_height2 = yheight2;


this_box_storage.normal_vectors[0] = coords_set(0,0,1);
this_box_storage.normal_vectors[1] = coords_set(0,0,1);

// for sides with y component = 0
x_component = 2*zdepth/sqrt((xwidth-xwidth2)*(xwidth-xwidth2)+4*zdepth*zdepth);
z_component = (xwidth-xwidth2)/sqrt(4*zdepth*zdepth+(xwidth-xwidth2)*(xwidth-xwidth2));

this_box_storage.normal_vectors[2] = coords_set(x_component,0,z_component);
this_box_storage.normal_vectors[3] = coords_set(-x_component,0,z_component);

// for sides with x component = 0
y_component = 2*zdepth/sqrt((yheight-yheight2)*(yheight-yheight2)+4*zdepth*zdepth);
z_component = (yheight-yheight2)/sqrt(4*zdepth*zdepth+(yheight-yheight2)*(yheight-yheight2));

this_box_storage.normal_vectors[4] = coords_set(0,y_component,z_component);
this_box_storage.normal_vectors[5] = coords_set(0,-y_component,z_component);

this_box_volume.geometry.visualization_on = visualize;

this_box_volume.geometry.geometry_parameters.p_box_storage = &this_box_storage;

// Assign pointers to functions for intersection with the shape, checking if a point is inside the shape
if (this_box_storage.is_rectangle == 1) {
this_box_volume.geometry.intersect_function = &sample_box_intersect_simple;
this_box_volume.geometry.within_function = &r_within_box_simple;
}
else {
this_box_volume.geometry.intersect_function = &sample_box_intersect_advanced;
this_box_volume.geometry.within_function = &r_within_box_advanced;
}

this_box_volume.geometry.shell_points = &box_shell_points;
this_box_volume.geometry.mcdisplay_function = &mcdisplay_box_function;
this_box_volume.geometry.initialize_from_main_function = &initialize_box_geometry_from_main_component;
this_box_volume.geometry.process_rot_allocated = 0;

this_box_volume.geometry.copy_geometry_parameters = &allocate_box_storage_copy;

rot_copy(this_box_volume.geometry.rotation_matrix,ROT_A_CURRENT_COMP); //check how ROT_R_CURRENT_COMP would work
rot_transpose(ROT_A_CURRENT_COMP,this_box_volume.geometry.transpose_rotation_matrix);

// Initialize loggers
this_box_volume.loggers.num_elements = 0;

// packing the information into the global_geometry_element, which is then included in the global_geometry_list.
sprintf(global_geometry_element.name,NAME_CURRENT_COMP);
global_geometry_element.activation_counter = number_of_activations;
global_geometry_element.component_index = INDEX_CURRENT_COMP;
global_geometry_element.Volume = &this_box_volume; // Would be nicer if this m was a pointer, now we have the (small) data two places
add_element_to_geometry_list(&global_geometry_list,global_geometry_element);
}
#line 298208 "MACS_sample_kidney_box.c"
#undef number_of_activations
#undef mask_setting
#undef mask_string
#undef p_interact
#undef focus_r
#undef focus_xh
#undef focus_xw
#undef focus_ah
#undef focus_aw
#undef target_z
#undef target_y
#undef target_x
#undef target_index
#undef visualize
#undef yheight2
#undef xwidth2
#undef zdepth
#undef yheight
#undef xwidth
#undef priority
#undef material_string
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

  /* Initializations for component channel_15_analyzer_1_array_crystal_array_2. */
  SIG_MESSAGE("channel_15_analyzer_1_array_crystal_array_2 (Init)");
#define mccompcurname  channel_15_analyzer_1_array_crystal_array_2
#define mccompcurtype  Union_box
#define mccompcurindex 702
#define loop_index mccchannel_15_analyzer_1_array_crystal_array_2_loop_index
#define this_box_volume mccchannel_15_analyzer_1_array_crystal_array_2_this_box_volume
#define global_geometry_element mccchannel_15_analyzer_1_array_crystal_array_2_global_geometry_element
#define this_box_storage mccchannel_15_analyzer_1_array_crystal_array_2_this_box_storage
#define material_string mccchannel_15_analyzer_1_array_crystal_array_2_material_string
#define priority mccchannel_15_analyzer_1_array_crystal_array_2_priority
#define xwidth mccchannel_15_analyzer_1_array_crystal_array_2_xwidth
#define yheight mccchannel_15_analyzer_1_array_crystal_array_2_yheight
#define zdepth mccchannel_15_analyzer_1_array_crystal_array_2_zdepth
#define xwidth2 mccchannel_15_analyzer_1_array_crystal_array_2_xwidth2
#define yheight2 mccchannel_15_analyzer_1_array_crystal_array_2_yheight2
#define visualize mccchannel_15_analyzer_1_array_crystal_array_2_visualize
#define target_index mccchannel_15_analyzer_1_array_crystal_array_2_target_index
#define target_x mccchannel_15_analyzer_1_array_crystal_array_2_target_x
#define target_y mccchannel_15_analyzer_1_array_crystal_array_2_target_y
#define target_z mccchannel_15_analyzer_1_array_crystal_array_2_target_z
#define focus_aw mccchannel_15_analyzer_1_array_crystal_array_2_focus_aw
#define focus_ah mccchannel_15_analyzer_1_array_crystal_array_2_focus_ah
#define focus_xw mccchannel_15_analyzer_1_array_crystal_array_2_focus_xw
#define focus_xh mccchannel_15_analyzer_1_array_crystal_array_2_focus_xh
#define focus_r mccchannel_15_analyzer_1_array_crystal_array_2_focus_r
#define p_interact mccchannel_15_analyzer_1_array_crystal_array_2_p_interact
#define mask_string mccchannel_15_analyzer_1_array_crystal_array_2_mask_string
#define mask_setting mccchannel_15_analyzer_1_array_crystal_array_2_mask_setting
#define number_of_activations mccchannel_15_analyzer_1_array_crystal_array_2_number_of_activations
#line 224 "Union_box.comp"
{
// Initializes the focusing system for this volume including input sanitation.
focus_initialize(&this_box_volume.geometry, POS_A_COMP_INDEX(INDEX_CURRENT_COMP+target_index), POS_A_CURRENT_COMP, ROT_A_CURRENT_COMP, target_index, target_x, target_y, target_z, focus_aw, focus_ah, focus_xw, focus_xh, focus_r, NAME_CURRENT_COMP);

// Input sanitation for this geometry
if (xwidth <= 0) {
  printf("\nERROR in Union_box named %s, the xwidth is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (yheight <= 0) {
  printf("\nERROR in Union_box named %s, yheight is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (zdepth <= 0) {
  printf("\nERROR in Union_box named %s, zdepth is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (xwidth2 <= 0 && xwidth2 != -1) {
  printf("\nERROR in Union_box named %s, the xwidth2 is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (yheight2 <= 0 && yheight2 != -1) {
  printf("\nERROR in Union_box named %s, yheight2 is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}

// Use sanitation
if (global_material_list.num_elements == 0) {
  printf("\nERROR: Need to define a material using Union_make_material before using a Union geometry component. \n");
  printf("       %s was defined before first use of Union_make_material.\n",NAME_CURRENT_COMP);
  exit(1);
}

this_box_volume.geometry.is_masked_volume = 0;
this_box_volume.geometry.is_exit_volume = 0;
this_box_volume.geometry.is_mask_volume = 0;
// check if the volume is a mask, if it is the material string is irelevant.
if (mask_string && strlen(mask_string) && strcmp(mask_string, "NULL") && strcmp(mask_string, "0")) {
    // A mask volume is used to limit the extend of other volumes, called the masked volumes. These are specified in the mask_string.
    // In order for a ray to enter a masked volume, it needs to be both in the region covered by that volume AND the mask volume.
    // When more than
    this_box_volume.geometry.mask_mode = 1; // Default is mask mode is ALL
    if (mask_setting && strlen(mask_setting) && strcmp(mask_setting, "NULL") && strcmp(mask_setting, "0")) {
        if (strcmp(mask_setting,"ALL") == 0 || strcmp(mask_setting,"All") == 0) this_box_volume.geometry.mask_mode = 1;
        else if (strcmp(mask_setting,"ANY") == 0 || strcmp(mask_setting,"Any") == 0) this_box_volume.geometry.mask_mode = 2;
        else {
            printf("The mask_mode of component %s is set to %s, but must be either ALL or ANY.\n",NAME_CURRENT_COMP,mask_setting);
            exit(1);
        }
    }
    
    for (loop_index=0;loop_index<global_geometry_list.num_elements;loop_index++) {
        // Add mask list
        if (1 == manual_linking_function(global_geometry_list.elements[loop_index].name,mask_string)) {
            add_element_to_int_list(&this_box_volume.geometry.mask_list,global_geometry_list.elements[loop_index].component_index);
            add_element_to_int_list(&global_geometry_list.elements[loop_index].Volume->geometry.masked_by_list,INDEX_CURRENT_COMP);
            global_geometry_list.elements[loop_index].Volume->geometry.is_masked_volume = 1;
            if (this_box_volume.geometry.mask_mode == 2)
                global_geometry_list.elements[loop_index].Volume->geometry.mask_mode = 2;
            if (this_box_volume.geometry.mask_mode == 1) {
                if (global_geometry_list.elements[loop_index].Volume->geometry.is_masked_volume == 1 && global_geometry_list.elements[loop_index].Volume->geometry.mask_mode != 2)
                    // If more than one mask is added to one volume, the ANY mode overwrites the (default) ALL mode.
                    global_geometry_list.elements[loop_index].Volume->geometry.mask_mode = 1;
            }
            
            found_geometries = 1;
        }
    }
    if (found_geometries == 0) {
        printf("The mask_string in geometry: %s did not find any of the specified volumes in the mask_string %s \n",NAME_CURRENT_COMP,mask_string);
        exit(1);
    }
    this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
    this_box_volume.p_physics->is_vacuum = 0; // Makes this volume a vacuum
    this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
    this_box_volume.p_physics->my_a = 0; // Should not be used.
    sprintf(this_box_volume.p_physics->name,"Mask");
    this_box_volume.geometry.is_mask_volume = 1;
    
    
// Read the material input, or if it lacks, use automatic linking.
} else if (material_string && strlen(material_string) && strcmp(material_string, "NULL") && strcmp(material_string, "0")) {
    // A geometry string was given, use it to determine which material
    if (0 == strcmp(material_string,"vacuum") || 0 == strcmp(material_string,"Vacuum")) {
        // One could have a global physics struct for vacuum instead of creating one for each
        this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
        this_box_volume.p_physics->is_vacuum = 1; // Makes this volume a vacuum
        this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
        this_box_volume.p_physics->my_a = 0; // Should not be used.
        sprintf(this_box_volume.p_physics->name,"Vacuum");
    } else if (0 == strcmp(material_string,"exit") || 0 == strcmp(material_string,"Exit")) {
        // One could have a global physics struct for vacuum instead of creating one for each
        this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
        this_box_volume.p_physics->is_vacuum = 1; // Makes this volume a vacuum
        this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
        this_box_volume.p_physics->my_a = 0; // Should not be used.
        this_box_volume.geometry.is_exit_volume = 1;
        sprintf(this_box_volume.p_physics->name,"Exit");
    } else {
        #ifndef MATERIAL_DETECTOR
            printf("Need to define a material before refering to it in a geometry %s.\n",NAME_CURRENT_COMP);
            exit(1);
        #endif
        for (loop_index=0;loop_index<global_material_list.num_elements;loop_index++) {
            if (0 == strcmp(material_string,global_material_list.elements[loop_index].name)) {
                this_box_volume.p_physics = global_material_list.elements[loop_index].physics;
                break;
            }
            if (loop_index == global_material_list.num_elements-1) {
            printf("\n");
            printf("ERROR: The material string \"%s\" in Union geometry \"%s\" did not match a specified material. \n",material_string,NAME_CURRENT_COMP);
            printf("       The materials available at this point (need to be defined before the geometry): \n");
            for (loop_index=0;loop_index<global_material_list.num_elements;loop_index++)
              printf("         %s\n",global_material_list.elements[loop_index].name);
            printf("\n");
            printf("       It is also possible to use one of the defualt materials avaiable: \n");
            printf("           Vacuum (for a Volume without scattering or absorption)\n");
            printf("           Exit (for a Volume where the ray exits the component if it enters)\n");
            printf("           Mask (for a Volume that masks existing volumes specified in the mask_string\n");
            exit(1);
          }
        }
    }
} else {
    // Automatic linking, simply using the last defined material.
    #ifndef MATERIAL_DETECTOR
        printf("Need to define a material before the geometry to use automatic linking %s.\n",NAME_CURRENT_COMP);
        exit(1);
    #endif
    this_box_volume.p_physics = global_material_list.elements[global_material_list.num_elements-1].physics;
}

sprintf(this_box_volume.name,NAME_CURRENT_COMP);
sprintf(this_box_volume.geometry.shape,"box");
this_box_volume.geometry.priority_value = priority;
this_box_volume.geometry.geometry_p_interact = p_interact;
// Currently the coordinates will be in absolute space.
this_box_volume.geometry.center = POS_A_CURRENT_COMP;

this_box_storage.z_depth = zdepth;
this_box_storage.x_width1 = xwidth;
this_box_storage.y_height1 = yheight;

this_box_storage.is_rectangle = 0;
if (xwidth2 < 0 && yheight2 < 0) this_box_storage.is_rectangle = 1;
if (xwidth == xwidth2 && yheight == yheight2) this_box_storage.is_rectangle = 1;

if (xwidth2 < 0) {
    this_box_storage.x_width2 = xwidth;
    xwidth2 = xwidth;
} else this_box_storage.x_width2 = xwidth2;

if (yheight2 < 0) {
    this_box_storage.y_height2 = yheight;
    yheight2 = yheight;
} else this_box_storage.y_height2 = yheight2;


this_box_storage.normal_vectors[0] = coords_set(0,0,1);
this_box_storage.normal_vectors[1] = coords_set(0,0,1);

// for sides with y component = 0
x_component = 2*zdepth/sqrt((xwidth-xwidth2)*(xwidth-xwidth2)+4*zdepth*zdepth);
z_component = (xwidth-xwidth2)/sqrt(4*zdepth*zdepth+(xwidth-xwidth2)*(xwidth-xwidth2));

this_box_storage.normal_vectors[2] = coords_set(x_component,0,z_component);
this_box_storage.normal_vectors[3] = coords_set(-x_component,0,z_component);

// for sides with x component = 0
y_component = 2*zdepth/sqrt((yheight-yheight2)*(yheight-yheight2)+4*zdepth*zdepth);
z_component = (yheight-yheight2)/sqrt(4*zdepth*zdepth+(yheight-yheight2)*(yheight-yheight2));

this_box_storage.normal_vectors[4] = coords_set(0,y_component,z_component);
this_box_storage.normal_vectors[5] = coords_set(0,-y_component,z_component);

this_box_volume.geometry.visualization_on = visualize;

this_box_volume.geometry.geometry_parameters.p_box_storage = &this_box_storage;

// Assign pointers to functions for intersection with the shape, checking if a point is inside the shape
if (this_box_storage.is_rectangle == 1) {
this_box_volume.geometry.intersect_function = &sample_box_intersect_simple;
this_box_volume.geometry.within_function = &r_within_box_simple;
}
else {
this_box_volume.geometry.intersect_function = &sample_box_intersect_advanced;
this_box_volume.geometry.within_function = &r_within_box_advanced;
}

this_box_volume.geometry.shell_points = &box_shell_points;
this_box_volume.geometry.mcdisplay_function = &mcdisplay_box_function;
this_box_volume.geometry.initialize_from_main_function = &initialize_box_geometry_from_main_component;
this_box_volume.geometry.process_rot_allocated = 0;

this_box_volume.geometry.copy_geometry_parameters = &allocate_box_storage_copy;

rot_copy(this_box_volume.geometry.rotation_matrix,ROT_A_CURRENT_COMP); //check how ROT_R_CURRENT_COMP would work
rot_transpose(ROT_A_CURRENT_COMP,this_box_volume.geometry.transpose_rotation_matrix);

// Initialize loggers
this_box_volume.loggers.num_elements = 0;

// packing the information into the global_geometry_element, which is then included in the global_geometry_list.
sprintf(global_geometry_element.name,NAME_CURRENT_COMP);
global_geometry_element.activation_counter = number_of_activations;
global_geometry_element.component_index = INDEX_CURRENT_COMP;
global_geometry_element.Volume = &this_box_volume; // Would be nicer if this m was a pointer, now we have the (small) data two places
add_element_to_geometry_list(&global_geometry_list,global_geometry_element);
}
#line 298478 "MACS_sample_kidney_box.c"
#undef number_of_activations
#undef mask_setting
#undef mask_string
#undef p_interact
#undef focus_r
#undef focus_xh
#undef focus_xw
#undef focus_ah
#undef focus_aw
#undef target_z
#undef target_y
#undef target_x
#undef target_index
#undef visualize
#undef yheight2
#undef xwidth2
#undef zdepth
#undef yheight
#undef xwidth
#undef priority
#undef material_string
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

  /* Initializations for component channel_15_analyzer_1_array_crystal_array_3. */
  SIG_MESSAGE("channel_15_analyzer_1_array_crystal_array_3 (Init)");
#define mccompcurname  channel_15_analyzer_1_array_crystal_array_3
#define mccompcurtype  Union_box
#define mccompcurindex 703
#define loop_index mccchannel_15_analyzer_1_array_crystal_array_3_loop_index
#define this_box_volume mccchannel_15_analyzer_1_array_crystal_array_3_this_box_volume
#define global_geometry_element mccchannel_15_analyzer_1_array_crystal_array_3_global_geometry_element
#define this_box_storage mccchannel_15_analyzer_1_array_crystal_array_3_this_box_storage
#define material_string mccchannel_15_analyzer_1_array_crystal_array_3_material_string
#define priority mccchannel_15_analyzer_1_array_crystal_array_3_priority
#define xwidth mccchannel_15_analyzer_1_array_crystal_array_3_xwidth
#define yheight mccchannel_15_analyzer_1_array_crystal_array_3_yheight
#define zdepth mccchannel_15_analyzer_1_array_crystal_array_3_zdepth
#define xwidth2 mccchannel_15_analyzer_1_array_crystal_array_3_xwidth2
#define yheight2 mccchannel_15_analyzer_1_array_crystal_array_3_yheight2
#define visualize mccchannel_15_analyzer_1_array_crystal_array_3_visualize
#define target_index mccchannel_15_analyzer_1_array_crystal_array_3_target_index
#define target_x mccchannel_15_analyzer_1_array_crystal_array_3_target_x
#define target_y mccchannel_15_analyzer_1_array_crystal_array_3_target_y
#define target_z mccchannel_15_analyzer_1_array_crystal_array_3_target_z
#define focus_aw mccchannel_15_analyzer_1_array_crystal_array_3_focus_aw
#define focus_ah mccchannel_15_analyzer_1_array_crystal_array_3_focus_ah
#define focus_xw mccchannel_15_analyzer_1_array_crystal_array_3_focus_xw
#define focus_xh mccchannel_15_analyzer_1_array_crystal_array_3_focus_xh
#define focus_r mccchannel_15_analyzer_1_array_crystal_array_3_focus_r
#define p_interact mccchannel_15_analyzer_1_array_crystal_array_3_p_interact
#define mask_string mccchannel_15_analyzer_1_array_crystal_array_3_mask_string
#define mask_setting mccchannel_15_analyzer_1_array_crystal_array_3_mask_setting
#define number_of_activations mccchannel_15_analyzer_1_array_crystal_array_3_number_of_activations
#line 224 "Union_box.comp"
{
// Initializes the focusing system for this volume including input sanitation.
focus_initialize(&this_box_volume.geometry, POS_A_COMP_INDEX(INDEX_CURRENT_COMP+target_index), POS_A_CURRENT_COMP, ROT_A_CURRENT_COMP, target_index, target_x, target_y, target_z, focus_aw, focus_ah, focus_xw, focus_xh, focus_r, NAME_CURRENT_COMP);

// Input sanitation for this geometry
if (xwidth <= 0) {
  printf("\nERROR in Union_box named %s, the xwidth is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (yheight <= 0) {
  printf("\nERROR in Union_box named %s, yheight is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (zdepth <= 0) {
  printf("\nERROR in Union_box named %s, zdepth is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (xwidth2 <= 0 && xwidth2 != -1) {
  printf("\nERROR in Union_box named %s, the xwidth2 is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (yheight2 <= 0 && yheight2 != -1) {
  printf("\nERROR in Union_box named %s, yheight2 is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}

// Use sanitation
if (global_material_list.num_elements == 0) {
  printf("\nERROR: Need to define a material using Union_make_material before using a Union geometry component. \n");
  printf("       %s was defined before first use of Union_make_material.\n",NAME_CURRENT_COMP);
  exit(1);
}

this_box_volume.geometry.is_masked_volume = 0;
this_box_volume.geometry.is_exit_volume = 0;
this_box_volume.geometry.is_mask_volume = 0;
// check if the volume is a mask, if it is the material string is irelevant.
if (mask_string && strlen(mask_string) && strcmp(mask_string, "NULL") && strcmp(mask_string, "0")) {
    // A mask volume is used to limit the extend of other volumes, called the masked volumes. These are specified in the mask_string.
    // In order for a ray to enter a masked volume, it needs to be both in the region covered by that volume AND the mask volume.
    // When more than
    this_box_volume.geometry.mask_mode = 1; // Default is mask mode is ALL
    if (mask_setting && strlen(mask_setting) && strcmp(mask_setting, "NULL") && strcmp(mask_setting, "0")) {
        if (strcmp(mask_setting,"ALL") == 0 || strcmp(mask_setting,"All") == 0) this_box_volume.geometry.mask_mode = 1;
        else if (strcmp(mask_setting,"ANY") == 0 || strcmp(mask_setting,"Any") == 0) this_box_volume.geometry.mask_mode = 2;
        else {
            printf("The mask_mode of component %s is set to %s, but must be either ALL or ANY.\n",NAME_CURRENT_COMP,mask_setting);
            exit(1);
        }
    }
    
    for (loop_index=0;loop_index<global_geometry_list.num_elements;loop_index++) {
        // Add mask list
        if (1 == manual_linking_function(global_geometry_list.elements[loop_index].name,mask_string)) {
            add_element_to_int_list(&this_box_volume.geometry.mask_list,global_geometry_list.elements[loop_index].component_index);
            add_element_to_int_list(&global_geometry_list.elements[loop_index].Volume->geometry.masked_by_list,INDEX_CURRENT_COMP);
            global_geometry_list.elements[loop_index].Volume->geometry.is_masked_volume = 1;
            if (this_box_volume.geometry.mask_mode == 2)
                global_geometry_list.elements[loop_index].Volume->geometry.mask_mode = 2;
            if (this_box_volume.geometry.mask_mode == 1) {
                if (global_geometry_list.elements[loop_index].Volume->geometry.is_masked_volume == 1 && global_geometry_list.elements[loop_index].Volume->geometry.mask_mode != 2)
                    // If more than one mask is added to one volume, the ANY mode overwrites the (default) ALL mode.
                    global_geometry_list.elements[loop_index].Volume->geometry.mask_mode = 1;
            }
            
            found_geometries = 1;
        }
    }
    if (found_geometries == 0) {
        printf("The mask_string in geometry: %s did not find any of the specified volumes in the mask_string %s \n",NAME_CURRENT_COMP,mask_string);
        exit(1);
    }
    this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
    this_box_volume.p_physics->is_vacuum = 0; // Makes this volume a vacuum
    this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
    this_box_volume.p_physics->my_a = 0; // Should not be used.
    sprintf(this_box_volume.p_physics->name,"Mask");
    this_box_volume.geometry.is_mask_volume = 1;
    
    
// Read the material input, or if it lacks, use automatic linking.
} else if (material_string && strlen(material_string) && strcmp(material_string, "NULL") && strcmp(material_string, "0")) {
    // A geometry string was given, use it to determine which material
    if (0 == strcmp(material_string,"vacuum") || 0 == strcmp(material_string,"Vacuum")) {
        // One could have a global physics struct for vacuum instead of creating one for each
        this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
        this_box_volume.p_physics->is_vacuum = 1; // Makes this volume a vacuum
        this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
        this_box_volume.p_physics->my_a = 0; // Should not be used.
        sprintf(this_box_volume.p_physics->name,"Vacuum");
    } else if (0 == strcmp(material_string,"exit") || 0 == strcmp(material_string,"Exit")) {
        // One could have a global physics struct for vacuum instead of creating one for each
        this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
        this_box_volume.p_physics->is_vacuum = 1; // Makes this volume a vacuum
        this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
        this_box_volume.p_physics->my_a = 0; // Should not be used.
        this_box_volume.geometry.is_exit_volume = 1;
        sprintf(this_box_volume.p_physics->name,"Exit");
    } else {
        #ifndef MATERIAL_DETECTOR
            printf("Need to define a material before refering to it in a geometry %s.\n",NAME_CURRENT_COMP);
            exit(1);
        #endif
        for (loop_index=0;loop_index<global_material_list.num_elements;loop_index++) {
            if (0 == strcmp(material_string,global_material_list.elements[loop_index].name)) {
                this_box_volume.p_physics = global_material_list.elements[loop_index].physics;
                break;
            }
            if (loop_index == global_material_list.num_elements-1) {
            printf("\n");
            printf("ERROR: The material string \"%s\" in Union geometry \"%s\" did not match a specified material. \n",material_string,NAME_CURRENT_COMP);
            printf("       The materials available at this point (need to be defined before the geometry): \n");
            for (loop_index=0;loop_index<global_material_list.num_elements;loop_index++)
              printf("         %s\n",global_material_list.elements[loop_index].name);
            printf("\n");
            printf("       It is also possible to use one of the defualt materials avaiable: \n");
            printf("           Vacuum (for a Volume without scattering or absorption)\n");
            printf("           Exit (for a Volume where the ray exits the component if it enters)\n");
            printf("           Mask (for a Volume that masks existing volumes specified in the mask_string\n");
            exit(1);
          }
        }
    }
} else {
    // Automatic linking, simply using the last defined material.
    #ifndef MATERIAL_DETECTOR
        printf("Need to define a material before the geometry to use automatic linking %s.\n",NAME_CURRENT_COMP);
        exit(1);
    #endif
    this_box_volume.p_physics = global_material_list.elements[global_material_list.num_elements-1].physics;
}

sprintf(this_box_volume.name,NAME_CURRENT_COMP);
sprintf(this_box_volume.geometry.shape,"box");
this_box_volume.geometry.priority_value = priority;
this_box_volume.geometry.geometry_p_interact = p_interact;
// Currently the coordinates will be in absolute space.
this_box_volume.geometry.center = POS_A_CURRENT_COMP;

this_box_storage.z_depth = zdepth;
this_box_storage.x_width1 = xwidth;
this_box_storage.y_height1 = yheight;

this_box_storage.is_rectangle = 0;
if (xwidth2 < 0 && yheight2 < 0) this_box_storage.is_rectangle = 1;
if (xwidth == xwidth2 && yheight == yheight2) this_box_storage.is_rectangle = 1;

if (xwidth2 < 0) {
    this_box_storage.x_width2 = xwidth;
    xwidth2 = xwidth;
} else this_box_storage.x_width2 = xwidth2;

if (yheight2 < 0) {
    this_box_storage.y_height2 = yheight;
    yheight2 = yheight;
} else this_box_storage.y_height2 = yheight2;


this_box_storage.normal_vectors[0] = coords_set(0,0,1);
this_box_storage.normal_vectors[1] = coords_set(0,0,1);

// for sides with y component = 0
x_component = 2*zdepth/sqrt((xwidth-xwidth2)*(xwidth-xwidth2)+4*zdepth*zdepth);
z_component = (xwidth-xwidth2)/sqrt(4*zdepth*zdepth+(xwidth-xwidth2)*(xwidth-xwidth2));

this_box_storage.normal_vectors[2] = coords_set(x_component,0,z_component);
this_box_storage.normal_vectors[3] = coords_set(-x_component,0,z_component);

// for sides with x component = 0
y_component = 2*zdepth/sqrt((yheight-yheight2)*(yheight-yheight2)+4*zdepth*zdepth);
z_component = (yheight-yheight2)/sqrt(4*zdepth*zdepth+(yheight-yheight2)*(yheight-yheight2));

this_box_storage.normal_vectors[4] = coords_set(0,y_component,z_component);
this_box_storage.normal_vectors[5] = coords_set(0,-y_component,z_component);

this_box_volume.geometry.visualization_on = visualize;

this_box_volume.geometry.geometry_parameters.p_box_storage = &this_box_storage;

// Assign pointers to functions for intersection with the shape, checking if a point is inside the shape
if (this_box_storage.is_rectangle == 1) {
this_box_volume.geometry.intersect_function = &sample_box_intersect_simple;
this_box_volume.geometry.within_function = &r_within_box_simple;
}
else {
this_box_volume.geometry.intersect_function = &sample_box_intersect_advanced;
this_box_volume.geometry.within_function = &r_within_box_advanced;
}

this_box_volume.geometry.shell_points = &box_shell_points;
this_box_volume.geometry.mcdisplay_function = &mcdisplay_box_function;
this_box_volume.geometry.initialize_from_main_function = &initialize_box_geometry_from_main_component;
this_box_volume.geometry.process_rot_allocated = 0;

this_box_volume.geometry.copy_geometry_parameters = &allocate_box_storage_copy;

rot_copy(this_box_volume.geometry.rotation_matrix,ROT_A_CURRENT_COMP); //check how ROT_R_CURRENT_COMP would work
rot_transpose(ROT_A_CURRENT_COMP,this_box_volume.geometry.transpose_rotation_matrix);

// Initialize loggers
this_box_volume.loggers.num_elements = 0;

// packing the information into the global_geometry_element, which is then included in the global_geometry_list.
sprintf(global_geometry_element.name,NAME_CURRENT_COMP);
global_geometry_element.activation_counter = number_of_activations;
global_geometry_element.component_index = INDEX_CURRENT_COMP;
global_geometry_element.Volume = &this_box_volume; // Would be nicer if this m was a pointer, now we have the (small) data two places
add_element_to_geometry_list(&global_geometry_list,global_geometry_element);
}
#line 298748 "MACS_sample_kidney_box.c"
#undef number_of_activations
#undef mask_setting
#undef mask_string
#undef p_interact
#undef focus_r
#undef focus_xh
#undef focus_xw
#undef focus_ah
#undef focus_aw
#undef target_z
#undef target_y
#undef target_x
#undef target_index
#undef visualize
#undef yheight2
#undef xwidth2
#undef zdepth
#undef yheight
#undef xwidth
#undef priority
#undef material_string
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

  /* Initializations for component channel_15_analyzer_1_array_crystal_array_4. */
  SIG_MESSAGE("channel_15_analyzer_1_array_crystal_array_4 (Init)");
#define mccompcurname  channel_15_analyzer_1_array_crystal_array_4
#define mccompcurtype  Union_box
#define mccompcurindex 704
#define loop_index mccchannel_15_analyzer_1_array_crystal_array_4_loop_index
#define this_box_volume mccchannel_15_analyzer_1_array_crystal_array_4_this_box_volume
#define global_geometry_element mccchannel_15_analyzer_1_array_crystal_array_4_global_geometry_element
#define this_box_storage mccchannel_15_analyzer_1_array_crystal_array_4_this_box_storage
#define material_string mccchannel_15_analyzer_1_array_crystal_array_4_material_string
#define priority mccchannel_15_analyzer_1_array_crystal_array_4_priority
#define xwidth mccchannel_15_analyzer_1_array_crystal_array_4_xwidth
#define yheight mccchannel_15_analyzer_1_array_crystal_array_4_yheight
#define zdepth mccchannel_15_analyzer_1_array_crystal_array_4_zdepth
#define xwidth2 mccchannel_15_analyzer_1_array_crystal_array_4_xwidth2
#define yheight2 mccchannel_15_analyzer_1_array_crystal_array_4_yheight2
#define visualize mccchannel_15_analyzer_1_array_crystal_array_4_visualize
#define target_index mccchannel_15_analyzer_1_array_crystal_array_4_target_index
#define target_x mccchannel_15_analyzer_1_array_crystal_array_4_target_x
#define target_y mccchannel_15_analyzer_1_array_crystal_array_4_target_y
#define target_z mccchannel_15_analyzer_1_array_crystal_array_4_target_z
#define focus_aw mccchannel_15_analyzer_1_array_crystal_array_4_focus_aw
#define focus_ah mccchannel_15_analyzer_1_array_crystal_array_4_focus_ah
#define focus_xw mccchannel_15_analyzer_1_array_crystal_array_4_focus_xw
#define focus_xh mccchannel_15_analyzer_1_array_crystal_array_4_focus_xh
#define focus_r mccchannel_15_analyzer_1_array_crystal_array_4_focus_r
#define p_interact mccchannel_15_analyzer_1_array_crystal_array_4_p_interact
#define mask_string mccchannel_15_analyzer_1_array_crystal_array_4_mask_string
#define mask_setting mccchannel_15_analyzer_1_array_crystal_array_4_mask_setting
#define number_of_activations mccchannel_15_analyzer_1_array_crystal_array_4_number_of_activations
#line 224 "Union_box.comp"
{
// Initializes the focusing system for this volume including input sanitation.
focus_initialize(&this_box_volume.geometry, POS_A_COMP_INDEX(INDEX_CURRENT_COMP+target_index), POS_A_CURRENT_COMP, ROT_A_CURRENT_COMP, target_index, target_x, target_y, target_z, focus_aw, focus_ah, focus_xw, focus_xh, focus_r, NAME_CURRENT_COMP);

// Input sanitation for this geometry
if (xwidth <= 0) {
  printf("\nERROR in Union_box named %s, the xwidth is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (yheight <= 0) {
  printf("\nERROR in Union_box named %s, yheight is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (zdepth <= 0) {
  printf("\nERROR in Union_box named %s, zdepth is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (xwidth2 <= 0 && xwidth2 != -1) {
  printf("\nERROR in Union_box named %s, the xwidth2 is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (yheight2 <= 0 && yheight2 != -1) {
  printf("\nERROR in Union_box named %s, yheight2 is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}

// Use sanitation
if (global_material_list.num_elements == 0) {
  printf("\nERROR: Need to define a material using Union_make_material before using a Union geometry component. \n");
  printf("       %s was defined before first use of Union_make_material.\n",NAME_CURRENT_COMP);
  exit(1);
}

this_box_volume.geometry.is_masked_volume = 0;
this_box_volume.geometry.is_exit_volume = 0;
this_box_volume.geometry.is_mask_volume = 0;
// check if the volume is a mask, if it is the material string is irelevant.
if (mask_string && strlen(mask_string) && strcmp(mask_string, "NULL") && strcmp(mask_string, "0")) {
    // A mask volume is used to limit the extend of other volumes, called the masked volumes. These are specified in the mask_string.
    // In order for a ray to enter a masked volume, it needs to be both in the region covered by that volume AND the mask volume.
    // When more than
    this_box_volume.geometry.mask_mode = 1; // Default is mask mode is ALL
    if (mask_setting && strlen(mask_setting) && strcmp(mask_setting, "NULL") && strcmp(mask_setting, "0")) {
        if (strcmp(mask_setting,"ALL") == 0 || strcmp(mask_setting,"All") == 0) this_box_volume.geometry.mask_mode = 1;
        else if (strcmp(mask_setting,"ANY") == 0 || strcmp(mask_setting,"Any") == 0) this_box_volume.geometry.mask_mode = 2;
        else {
            printf("The mask_mode of component %s is set to %s, but must be either ALL or ANY.\n",NAME_CURRENT_COMP,mask_setting);
            exit(1);
        }
    }
    
    for (loop_index=0;loop_index<global_geometry_list.num_elements;loop_index++) {
        // Add mask list
        if (1 == manual_linking_function(global_geometry_list.elements[loop_index].name,mask_string)) {
            add_element_to_int_list(&this_box_volume.geometry.mask_list,global_geometry_list.elements[loop_index].component_index);
            add_element_to_int_list(&global_geometry_list.elements[loop_index].Volume->geometry.masked_by_list,INDEX_CURRENT_COMP);
            global_geometry_list.elements[loop_index].Volume->geometry.is_masked_volume = 1;
            if (this_box_volume.geometry.mask_mode == 2)
                global_geometry_list.elements[loop_index].Volume->geometry.mask_mode = 2;
            if (this_box_volume.geometry.mask_mode == 1) {
                if (global_geometry_list.elements[loop_index].Volume->geometry.is_masked_volume == 1 && global_geometry_list.elements[loop_index].Volume->geometry.mask_mode != 2)
                    // If more than one mask is added to one volume, the ANY mode overwrites the (default) ALL mode.
                    global_geometry_list.elements[loop_index].Volume->geometry.mask_mode = 1;
            }
            
            found_geometries = 1;
        }
    }
    if (found_geometries == 0) {
        printf("The mask_string in geometry: %s did not find any of the specified volumes in the mask_string %s \n",NAME_CURRENT_COMP,mask_string);
        exit(1);
    }
    this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
    this_box_volume.p_physics->is_vacuum = 0; // Makes this volume a vacuum
    this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
    this_box_volume.p_physics->my_a = 0; // Should not be used.
    sprintf(this_box_volume.p_physics->name,"Mask");
    this_box_volume.geometry.is_mask_volume = 1;
    
    
// Read the material input, or if it lacks, use automatic linking.
} else if (material_string && strlen(material_string) && strcmp(material_string, "NULL") && strcmp(material_string, "0")) {
    // A geometry string was given, use it to determine which material
    if (0 == strcmp(material_string,"vacuum") || 0 == strcmp(material_string,"Vacuum")) {
        // One could have a global physics struct for vacuum instead of creating one for each
        this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
        this_box_volume.p_physics->is_vacuum = 1; // Makes this volume a vacuum
        this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
        this_box_volume.p_physics->my_a = 0; // Should not be used.
        sprintf(this_box_volume.p_physics->name,"Vacuum");
    } else if (0 == strcmp(material_string,"exit") || 0 == strcmp(material_string,"Exit")) {
        // One could have a global physics struct for vacuum instead of creating one for each
        this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
        this_box_volume.p_physics->is_vacuum = 1; // Makes this volume a vacuum
        this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
        this_box_volume.p_physics->my_a = 0; // Should not be used.
        this_box_volume.geometry.is_exit_volume = 1;
        sprintf(this_box_volume.p_physics->name,"Exit");
    } else {
        #ifndef MATERIAL_DETECTOR
            printf("Need to define a material before refering to it in a geometry %s.\n",NAME_CURRENT_COMP);
            exit(1);
        #endif
        for (loop_index=0;loop_index<global_material_list.num_elements;loop_index++) {
            if (0 == strcmp(material_string,global_material_list.elements[loop_index].name)) {
                this_box_volume.p_physics = global_material_list.elements[loop_index].physics;
                break;
            }
            if (loop_index == global_material_list.num_elements-1) {
            printf("\n");
            printf("ERROR: The material string \"%s\" in Union geometry \"%s\" did not match a specified material. \n",material_string,NAME_CURRENT_COMP);
            printf("       The materials available at this point (need to be defined before the geometry): \n");
            for (loop_index=0;loop_index<global_material_list.num_elements;loop_index++)
              printf("         %s\n",global_material_list.elements[loop_index].name);
            printf("\n");
            printf("       It is also possible to use one of the defualt materials avaiable: \n");
            printf("           Vacuum (for a Volume without scattering or absorption)\n");
            printf("           Exit (for a Volume where the ray exits the component if it enters)\n");
            printf("           Mask (for a Volume that masks existing volumes specified in the mask_string\n");
            exit(1);
          }
        }
    }
} else {
    // Automatic linking, simply using the last defined material.
    #ifndef MATERIAL_DETECTOR
        printf("Need to define a material before the geometry to use automatic linking %s.\n",NAME_CURRENT_COMP);
        exit(1);
    #endif
    this_box_volume.p_physics = global_material_list.elements[global_material_list.num_elements-1].physics;
}

sprintf(this_box_volume.name,NAME_CURRENT_COMP);
sprintf(this_box_volume.geometry.shape,"box");
this_box_volume.geometry.priority_value = priority;
this_box_volume.geometry.geometry_p_interact = p_interact;
// Currently the coordinates will be in absolute space.
this_box_volume.geometry.center = POS_A_CURRENT_COMP;

this_box_storage.z_depth = zdepth;
this_box_storage.x_width1 = xwidth;
this_box_storage.y_height1 = yheight;

this_box_storage.is_rectangle = 0;
if (xwidth2 < 0 && yheight2 < 0) this_box_storage.is_rectangle = 1;
if (xwidth == xwidth2 && yheight == yheight2) this_box_storage.is_rectangle = 1;

if (xwidth2 < 0) {
    this_box_storage.x_width2 = xwidth;
    xwidth2 = xwidth;
} else this_box_storage.x_width2 = xwidth2;

if (yheight2 < 0) {
    this_box_storage.y_height2 = yheight;
    yheight2 = yheight;
} else this_box_storage.y_height2 = yheight2;


this_box_storage.normal_vectors[0] = coords_set(0,0,1);
this_box_storage.normal_vectors[1] = coords_set(0,0,1);

// for sides with y component = 0
x_component = 2*zdepth/sqrt((xwidth-xwidth2)*(xwidth-xwidth2)+4*zdepth*zdepth);
z_component = (xwidth-xwidth2)/sqrt(4*zdepth*zdepth+(xwidth-xwidth2)*(xwidth-xwidth2));

this_box_storage.normal_vectors[2] = coords_set(x_component,0,z_component);
this_box_storage.normal_vectors[3] = coords_set(-x_component,0,z_component);

// for sides with x component = 0
y_component = 2*zdepth/sqrt((yheight-yheight2)*(yheight-yheight2)+4*zdepth*zdepth);
z_component = (yheight-yheight2)/sqrt(4*zdepth*zdepth+(yheight-yheight2)*(yheight-yheight2));

this_box_storage.normal_vectors[4] = coords_set(0,y_component,z_component);
this_box_storage.normal_vectors[5] = coords_set(0,-y_component,z_component);

this_box_volume.geometry.visualization_on = visualize;

this_box_volume.geometry.geometry_parameters.p_box_storage = &this_box_storage;

// Assign pointers to functions for intersection with the shape, checking if a point is inside the shape
if (this_box_storage.is_rectangle == 1) {
this_box_volume.geometry.intersect_function = &sample_box_intersect_simple;
this_box_volume.geometry.within_function = &r_within_box_simple;
}
else {
this_box_volume.geometry.intersect_function = &sample_box_intersect_advanced;
this_box_volume.geometry.within_function = &r_within_box_advanced;
}

this_box_volume.geometry.shell_points = &box_shell_points;
this_box_volume.geometry.mcdisplay_function = &mcdisplay_box_function;
this_box_volume.geometry.initialize_from_main_function = &initialize_box_geometry_from_main_component;
this_box_volume.geometry.process_rot_allocated = 0;

this_box_volume.geometry.copy_geometry_parameters = &allocate_box_storage_copy;

rot_copy(this_box_volume.geometry.rotation_matrix,ROT_A_CURRENT_COMP); //check how ROT_R_CURRENT_COMP would work
rot_transpose(ROT_A_CURRENT_COMP,this_box_volume.geometry.transpose_rotation_matrix);

// Initialize loggers
this_box_volume.loggers.num_elements = 0;

// packing the information into the global_geometry_element, which is then included in the global_geometry_list.
sprintf(global_geometry_element.name,NAME_CURRENT_COMP);
global_geometry_element.activation_counter = number_of_activations;
global_geometry_element.component_index = INDEX_CURRENT_COMP;
global_geometry_element.Volume = &this_box_volume; // Would be nicer if this m was a pointer, now we have the (small) data two places
add_element_to_geometry_list(&global_geometry_list,global_geometry_element);
}
#line 299018 "MACS_sample_kidney_box.c"
#undef number_of_activations
#undef mask_setting
#undef mask_string
#undef p_interact
#undef focus_r
#undef focus_xh
#undef focus_xw
#undef focus_ah
#undef focus_aw
#undef target_z
#undef target_y
#undef target_x
#undef target_index
#undef visualize
#undef yheight2
#undef xwidth2
#undef zdepth
#undef yheight
#undef xwidth
#undef priority
#undef material_string
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

  /* Initializations for component channel_15_analyzer_1_array_crystal_array_5. */
  SIG_MESSAGE("channel_15_analyzer_1_array_crystal_array_5 (Init)");
#define mccompcurname  channel_15_analyzer_1_array_crystal_array_5
#define mccompcurtype  Union_box
#define mccompcurindex 705
#define loop_index mccchannel_15_analyzer_1_array_crystal_array_5_loop_index
#define this_box_volume mccchannel_15_analyzer_1_array_crystal_array_5_this_box_volume
#define global_geometry_element mccchannel_15_analyzer_1_array_crystal_array_5_global_geometry_element
#define this_box_storage mccchannel_15_analyzer_1_array_crystal_array_5_this_box_storage
#define material_string mccchannel_15_analyzer_1_array_crystal_array_5_material_string
#define priority mccchannel_15_analyzer_1_array_crystal_array_5_priority
#define xwidth mccchannel_15_analyzer_1_array_crystal_array_5_xwidth
#define yheight mccchannel_15_analyzer_1_array_crystal_array_5_yheight
#define zdepth mccchannel_15_analyzer_1_array_crystal_array_5_zdepth
#define xwidth2 mccchannel_15_analyzer_1_array_crystal_array_5_xwidth2
#define yheight2 mccchannel_15_analyzer_1_array_crystal_array_5_yheight2
#define visualize mccchannel_15_analyzer_1_array_crystal_array_5_visualize
#define target_index mccchannel_15_analyzer_1_array_crystal_array_5_target_index
#define target_x mccchannel_15_analyzer_1_array_crystal_array_5_target_x
#define target_y mccchannel_15_analyzer_1_array_crystal_array_5_target_y
#define target_z mccchannel_15_analyzer_1_array_crystal_array_5_target_z
#define focus_aw mccchannel_15_analyzer_1_array_crystal_array_5_focus_aw
#define focus_ah mccchannel_15_analyzer_1_array_crystal_array_5_focus_ah
#define focus_xw mccchannel_15_analyzer_1_array_crystal_array_5_focus_xw
#define focus_xh mccchannel_15_analyzer_1_array_crystal_array_5_focus_xh
#define focus_r mccchannel_15_analyzer_1_array_crystal_array_5_focus_r
#define p_interact mccchannel_15_analyzer_1_array_crystal_array_5_p_interact
#define mask_string mccchannel_15_analyzer_1_array_crystal_array_5_mask_string
#define mask_setting mccchannel_15_analyzer_1_array_crystal_array_5_mask_setting
#define number_of_activations mccchannel_15_analyzer_1_array_crystal_array_5_number_of_activations
#line 224 "Union_box.comp"
{
// Initializes the focusing system for this volume including input sanitation.
focus_initialize(&this_box_volume.geometry, POS_A_COMP_INDEX(INDEX_CURRENT_COMP+target_index), POS_A_CURRENT_COMP, ROT_A_CURRENT_COMP, target_index, target_x, target_y, target_z, focus_aw, focus_ah, focus_xw, focus_xh, focus_r, NAME_CURRENT_COMP);

// Input sanitation for this geometry
if (xwidth <= 0) {
  printf("\nERROR in Union_box named %s, the xwidth is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (yheight <= 0) {
  printf("\nERROR in Union_box named %s, yheight is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (zdepth <= 0) {
  printf("\nERROR in Union_box named %s, zdepth is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (xwidth2 <= 0 && xwidth2 != -1) {
  printf("\nERROR in Union_box named %s, the xwidth2 is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (yheight2 <= 0 && yheight2 != -1) {
  printf("\nERROR in Union_box named %s, yheight2 is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}

// Use sanitation
if (global_material_list.num_elements == 0) {
  printf("\nERROR: Need to define a material using Union_make_material before using a Union geometry component. \n");
  printf("       %s was defined before first use of Union_make_material.\n",NAME_CURRENT_COMP);
  exit(1);
}

this_box_volume.geometry.is_masked_volume = 0;
this_box_volume.geometry.is_exit_volume = 0;
this_box_volume.geometry.is_mask_volume = 0;
// check if the volume is a mask, if it is the material string is irelevant.
if (mask_string && strlen(mask_string) && strcmp(mask_string, "NULL") && strcmp(mask_string, "0")) {
    // A mask volume is used to limit the extend of other volumes, called the masked volumes. These are specified in the mask_string.
    // In order for a ray to enter a masked volume, it needs to be both in the region covered by that volume AND the mask volume.
    // When more than
    this_box_volume.geometry.mask_mode = 1; // Default is mask mode is ALL
    if (mask_setting && strlen(mask_setting) && strcmp(mask_setting, "NULL") && strcmp(mask_setting, "0")) {
        if (strcmp(mask_setting,"ALL") == 0 || strcmp(mask_setting,"All") == 0) this_box_volume.geometry.mask_mode = 1;
        else if (strcmp(mask_setting,"ANY") == 0 || strcmp(mask_setting,"Any") == 0) this_box_volume.geometry.mask_mode = 2;
        else {
            printf("The mask_mode of component %s is set to %s, but must be either ALL or ANY.\n",NAME_CURRENT_COMP,mask_setting);
            exit(1);
        }
    }
    
    for (loop_index=0;loop_index<global_geometry_list.num_elements;loop_index++) {
        // Add mask list
        if (1 == manual_linking_function(global_geometry_list.elements[loop_index].name,mask_string)) {
            add_element_to_int_list(&this_box_volume.geometry.mask_list,global_geometry_list.elements[loop_index].component_index);
            add_element_to_int_list(&global_geometry_list.elements[loop_index].Volume->geometry.masked_by_list,INDEX_CURRENT_COMP);
            global_geometry_list.elements[loop_index].Volume->geometry.is_masked_volume = 1;
            if (this_box_volume.geometry.mask_mode == 2)
                global_geometry_list.elements[loop_index].Volume->geometry.mask_mode = 2;
            if (this_box_volume.geometry.mask_mode == 1) {
                if (global_geometry_list.elements[loop_index].Volume->geometry.is_masked_volume == 1 && global_geometry_list.elements[loop_index].Volume->geometry.mask_mode != 2)
                    // If more than one mask is added to one volume, the ANY mode overwrites the (default) ALL mode.
                    global_geometry_list.elements[loop_index].Volume->geometry.mask_mode = 1;
            }
            
            found_geometries = 1;
        }
    }
    if (found_geometries == 0) {
        printf("The mask_string in geometry: %s did not find any of the specified volumes in the mask_string %s \n",NAME_CURRENT_COMP,mask_string);
        exit(1);
    }
    this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
    this_box_volume.p_physics->is_vacuum = 0; // Makes this volume a vacuum
    this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
    this_box_volume.p_physics->my_a = 0; // Should not be used.
    sprintf(this_box_volume.p_physics->name,"Mask");
    this_box_volume.geometry.is_mask_volume = 1;
    
    
// Read the material input, or if it lacks, use automatic linking.
} else if (material_string && strlen(material_string) && strcmp(material_string, "NULL") && strcmp(material_string, "0")) {
    // A geometry string was given, use it to determine which material
    if (0 == strcmp(material_string,"vacuum") || 0 == strcmp(material_string,"Vacuum")) {
        // One could have a global physics struct for vacuum instead of creating one for each
        this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
        this_box_volume.p_physics->is_vacuum = 1; // Makes this volume a vacuum
        this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
        this_box_volume.p_physics->my_a = 0; // Should not be used.
        sprintf(this_box_volume.p_physics->name,"Vacuum");
    } else if (0 == strcmp(material_string,"exit") || 0 == strcmp(material_string,"Exit")) {
        // One could have a global physics struct for vacuum instead of creating one for each
        this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
        this_box_volume.p_physics->is_vacuum = 1; // Makes this volume a vacuum
        this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
        this_box_volume.p_physics->my_a = 0; // Should not be used.
        this_box_volume.geometry.is_exit_volume = 1;
        sprintf(this_box_volume.p_physics->name,"Exit");
    } else {
        #ifndef MATERIAL_DETECTOR
            printf("Need to define a material before refering to it in a geometry %s.\n",NAME_CURRENT_COMP);
            exit(1);
        #endif
        for (loop_index=0;loop_index<global_material_list.num_elements;loop_index++) {
            if (0 == strcmp(material_string,global_material_list.elements[loop_index].name)) {
                this_box_volume.p_physics = global_material_list.elements[loop_index].physics;
                break;
            }
            if (loop_index == global_material_list.num_elements-1) {
            printf("\n");
            printf("ERROR: The material string \"%s\" in Union geometry \"%s\" did not match a specified material. \n",material_string,NAME_CURRENT_COMP);
            printf("       The materials available at this point (need to be defined before the geometry): \n");
            for (loop_index=0;loop_index<global_material_list.num_elements;loop_index++)
              printf("         %s\n",global_material_list.elements[loop_index].name);
            printf("\n");
            printf("       It is also possible to use one of the defualt materials avaiable: \n");
            printf("           Vacuum (for a Volume without scattering or absorption)\n");
            printf("           Exit (for a Volume where the ray exits the component if it enters)\n");
            printf("           Mask (for a Volume that masks existing volumes specified in the mask_string\n");
            exit(1);
          }
        }
    }
} else {
    // Automatic linking, simply using the last defined material.
    #ifndef MATERIAL_DETECTOR
        printf("Need to define a material before the geometry to use automatic linking %s.\n",NAME_CURRENT_COMP);
        exit(1);
    #endif
    this_box_volume.p_physics = global_material_list.elements[global_material_list.num_elements-1].physics;
}

sprintf(this_box_volume.name,NAME_CURRENT_COMP);
sprintf(this_box_volume.geometry.shape,"box");
this_box_volume.geometry.priority_value = priority;
this_box_volume.geometry.geometry_p_interact = p_interact;
// Currently the coordinates will be in absolute space.
this_box_volume.geometry.center = POS_A_CURRENT_COMP;

this_box_storage.z_depth = zdepth;
this_box_storage.x_width1 = xwidth;
this_box_storage.y_height1 = yheight;

this_box_storage.is_rectangle = 0;
if (xwidth2 < 0 && yheight2 < 0) this_box_storage.is_rectangle = 1;
if (xwidth == xwidth2 && yheight == yheight2) this_box_storage.is_rectangle = 1;

if (xwidth2 < 0) {
    this_box_storage.x_width2 = xwidth;
    xwidth2 = xwidth;
} else this_box_storage.x_width2 = xwidth2;

if (yheight2 < 0) {
    this_box_storage.y_height2 = yheight;
    yheight2 = yheight;
} else this_box_storage.y_height2 = yheight2;


this_box_storage.normal_vectors[0] = coords_set(0,0,1);
this_box_storage.normal_vectors[1] = coords_set(0,0,1);

// for sides with y component = 0
x_component = 2*zdepth/sqrt((xwidth-xwidth2)*(xwidth-xwidth2)+4*zdepth*zdepth);
z_component = (xwidth-xwidth2)/sqrt(4*zdepth*zdepth+(xwidth-xwidth2)*(xwidth-xwidth2));

this_box_storage.normal_vectors[2] = coords_set(x_component,0,z_component);
this_box_storage.normal_vectors[3] = coords_set(-x_component,0,z_component);

// for sides with x component = 0
y_component = 2*zdepth/sqrt((yheight-yheight2)*(yheight-yheight2)+4*zdepth*zdepth);
z_component = (yheight-yheight2)/sqrt(4*zdepth*zdepth+(yheight-yheight2)*(yheight-yheight2));

this_box_storage.normal_vectors[4] = coords_set(0,y_component,z_component);
this_box_storage.normal_vectors[5] = coords_set(0,-y_component,z_component);

this_box_volume.geometry.visualization_on = visualize;

this_box_volume.geometry.geometry_parameters.p_box_storage = &this_box_storage;

// Assign pointers to functions for intersection with the shape, checking if a point is inside the shape
if (this_box_storage.is_rectangle == 1) {
this_box_volume.geometry.intersect_function = &sample_box_intersect_simple;
this_box_volume.geometry.within_function = &r_within_box_simple;
}
else {
this_box_volume.geometry.intersect_function = &sample_box_intersect_advanced;
this_box_volume.geometry.within_function = &r_within_box_advanced;
}

this_box_volume.geometry.shell_points = &box_shell_points;
this_box_volume.geometry.mcdisplay_function = &mcdisplay_box_function;
this_box_volume.geometry.initialize_from_main_function = &initialize_box_geometry_from_main_component;
this_box_volume.geometry.process_rot_allocated = 0;

this_box_volume.geometry.copy_geometry_parameters = &allocate_box_storage_copy;

rot_copy(this_box_volume.geometry.rotation_matrix,ROT_A_CURRENT_COMP); //check how ROT_R_CURRENT_COMP would work
rot_transpose(ROT_A_CURRENT_COMP,this_box_volume.geometry.transpose_rotation_matrix);

// Initialize loggers
this_box_volume.loggers.num_elements = 0;

// packing the information into the global_geometry_element, which is then included in the global_geometry_list.
sprintf(global_geometry_element.name,NAME_CURRENT_COMP);
global_geometry_element.activation_counter = number_of_activations;
global_geometry_element.component_index = INDEX_CURRENT_COMP;
global_geometry_element.Volume = &this_box_volume; // Would be nicer if this m was a pointer, now we have the (small) data two places
add_element_to_geometry_list(&global_geometry_list,global_geometry_element);
}
#line 299288 "MACS_sample_kidney_box.c"
#undef number_of_activations
#undef mask_setting
#undef mask_string
#undef p_interact
#undef focus_r
#undef focus_xh
#undef focus_xw
#undef focus_ah
#undef focus_aw
#undef target_z
#undef target_y
#undef target_x
#undef target_index
#undef visualize
#undef yheight2
#undef xwidth2
#undef zdepth
#undef yheight
#undef xwidth
#undef priority
#undef material_string
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

  /* Initializations for component channel_15_analyzer_1_array_crystal_array_6. */
  SIG_MESSAGE("channel_15_analyzer_1_array_crystal_array_6 (Init)");
#define mccompcurname  channel_15_analyzer_1_array_crystal_array_6
#define mccompcurtype  Union_box
#define mccompcurindex 706
#define loop_index mccchannel_15_analyzer_1_array_crystal_array_6_loop_index
#define this_box_volume mccchannel_15_analyzer_1_array_crystal_array_6_this_box_volume
#define global_geometry_element mccchannel_15_analyzer_1_array_crystal_array_6_global_geometry_element
#define this_box_storage mccchannel_15_analyzer_1_array_crystal_array_6_this_box_storage
#define material_string mccchannel_15_analyzer_1_array_crystal_array_6_material_string
#define priority mccchannel_15_analyzer_1_array_crystal_array_6_priority
#define xwidth mccchannel_15_analyzer_1_array_crystal_array_6_xwidth
#define yheight mccchannel_15_analyzer_1_array_crystal_array_6_yheight
#define zdepth mccchannel_15_analyzer_1_array_crystal_array_6_zdepth
#define xwidth2 mccchannel_15_analyzer_1_array_crystal_array_6_xwidth2
#define yheight2 mccchannel_15_analyzer_1_array_crystal_array_6_yheight2
#define visualize mccchannel_15_analyzer_1_array_crystal_array_6_visualize
#define target_index mccchannel_15_analyzer_1_array_crystal_array_6_target_index
#define target_x mccchannel_15_analyzer_1_array_crystal_array_6_target_x
#define target_y mccchannel_15_analyzer_1_array_crystal_array_6_target_y
#define target_z mccchannel_15_analyzer_1_array_crystal_array_6_target_z
#define focus_aw mccchannel_15_analyzer_1_array_crystal_array_6_focus_aw
#define focus_ah mccchannel_15_analyzer_1_array_crystal_array_6_focus_ah
#define focus_xw mccchannel_15_analyzer_1_array_crystal_array_6_focus_xw
#define focus_xh mccchannel_15_analyzer_1_array_crystal_array_6_focus_xh
#define focus_r mccchannel_15_analyzer_1_array_crystal_array_6_focus_r
#define p_interact mccchannel_15_analyzer_1_array_crystal_array_6_p_interact
#define mask_string mccchannel_15_analyzer_1_array_crystal_array_6_mask_string
#define mask_setting mccchannel_15_analyzer_1_array_crystal_array_6_mask_setting
#define number_of_activations mccchannel_15_analyzer_1_array_crystal_array_6_number_of_activations
#line 224 "Union_box.comp"
{
// Initializes the focusing system for this volume including input sanitation.
focus_initialize(&this_box_volume.geometry, POS_A_COMP_INDEX(INDEX_CURRENT_COMP+target_index), POS_A_CURRENT_COMP, ROT_A_CURRENT_COMP, target_index, target_x, target_y, target_z, focus_aw, focus_ah, focus_xw, focus_xh, focus_r, NAME_CURRENT_COMP);

// Input sanitation for this geometry
if (xwidth <= 0) {
  printf("\nERROR in Union_box named %s, the xwidth is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (yheight <= 0) {
  printf("\nERROR in Union_box named %s, yheight is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (zdepth <= 0) {
  printf("\nERROR in Union_box named %s, zdepth is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (xwidth2 <= 0 && xwidth2 != -1) {
  printf("\nERROR in Union_box named %s, the xwidth2 is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (yheight2 <= 0 && yheight2 != -1) {
  printf("\nERROR in Union_box named %s, yheight2 is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}

// Use sanitation
if (global_material_list.num_elements == 0) {
  printf("\nERROR: Need to define a material using Union_make_material before using a Union geometry component. \n");
  printf("       %s was defined before first use of Union_make_material.\n",NAME_CURRENT_COMP);
  exit(1);
}

this_box_volume.geometry.is_masked_volume = 0;
this_box_volume.geometry.is_exit_volume = 0;
this_box_volume.geometry.is_mask_volume = 0;
// check if the volume is a mask, if it is the material string is irelevant.
if (mask_string && strlen(mask_string) && strcmp(mask_string, "NULL") && strcmp(mask_string, "0")) {
    // A mask volume is used to limit the extend of other volumes, called the masked volumes. These are specified in the mask_string.
    // In order for a ray to enter a masked volume, it needs to be both in the region covered by that volume AND the mask volume.
    // When more than
    this_box_volume.geometry.mask_mode = 1; // Default is mask mode is ALL
    if (mask_setting && strlen(mask_setting) && strcmp(mask_setting, "NULL") && strcmp(mask_setting, "0")) {
        if (strcmp(mask_setting,"ALL") == 0 || strcmp(mask_setting,"All") == 0) this_box_volume.geometry.mask_mode = 1;
        else if (strcmp(mask_setting,"ANY") == 0 || strcmp(mask_setting,"Any") == 0) this_box_volume.geometry.mask_mode = 2;
        else {
            printf("The mask_mode of component %s is set to %s, but must be either ALL or ANY.\n",NAME_CURRENT_COMP,mask_setting);
            exit(1);
        }
    }
    
    for (loop_index=0;loop_index<global_geometry_list.num_elements;loop_index++) {
        // Add mask list
        if (1 == manual_linking_function(global_geometry_list.elements[loop_index].name,mask_string)) {
            add_element_to_int_list(&this_box_volume.geometry.mask_list,global_geometry_list.elements[loop_index].component_index);
            add_element_to_int_list(&global_geometry_list.elements[loop_index].Volume->geometry.masked_by_list,INDEX_CURRENT_COMP);
            global_geometry_list.elements[loop_index].Volume->geometry.is_masked_volume = 1;
            if (this_box_volume.geometry.mask_mode == 2)
                global_geometry_list.elements[loop_index].Volume->geometry.mask_mode = 2;
            if (this_box_volume.geometry.mask_mode == 1) {
                if (global_geometry_list.elements[loop_index].Volume->geometry.is_masked_volume == 1 && global_geometry_list.elements[loop_index].Volume->geometry.mask_mode != 2)
                    // If more than one mask is added to one volume, the ANY mode overwrites the (default) ALL mode.
                    global_geometry_list.elements[loop_index].Volume->geometry.mask_mode = 1;
            }
            
            found_geometries = 1;
        }
    }
    if (found_geometries == 0) {
        printf("The mask_string in geometry: %s did not find any of the specified volumes in the mask_string %s \n",NAME_CURRENT_COMP,mask_string);
        exit(1);
    }
    this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
    this_box_volume.p_physics->is_vacuum = 0; // Makes this volume a vacuum
    this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
    this_box_volume.p_physics->my_a = 0; // Should not be used.
    sprintf(this_box_volume.p_physics->name,"Mask");
    this_box_volume.geometry.is_mask_volume = 1;
    
    
// Read the material input, or if it lacks, use automatic linking.
} else if (material_string && strlen(material_string) && strcmp(material_string, "NULL") && strcmp(material_string, "0")) {
    // A geometry string was given, use it to determine which material
    if (0 == strcmp(material_string,"vacuum") || 0 == strcmp(material_string,"Vacuum")) {
        // One could have a global physics struct for vacuum instead of creating one for each
        this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
        this_box_volume.p_physics->is_vacuum = 1; // Makes this volume a vacuum
        this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
        this_box_volume.p_physics->my_a = 0; // Should not be used.
        sprintf(this_box_volume.p_physics->name,"Vacuum");
    } else if (0 == strcmp(material_string,"exit") || 0 == strcmp(material_string,"Exit")) {
        // One could have a global physics struct for vacuum instead of creating one for each
        this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
        this_box_volume.p_physics->is_vacuum = 1; // Makes this volume a vacuum
        this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
        this_box_volume.p_physics->my_a = 0; // Should not be used.
        this_box_volume.geometry.is_exit_volume = 1;
        sprintf(this_box_volume.p_physics->name,"Exit");
    } else {
        #ifndef MATERIAL_DETECTOR
            printf("Need to define a material before refering to it in a geometry %s.\n",NAME_CURRENT_COMP);
            exit(1);
        #endif
        for (loop_index=0;loop_index<global_material_list.num_elements;loop_index++) {
            if (0 == strcmp(material_string,global_material_list.elements[loop_index].name)) {
                this_box_volume.p_physics = global_material_list.elements[loop_index].physics;
                break;
            }
            if (loop_index == global_material_list.num_elements-1) {
            printf("\n");
            printf("ERROR: The material string \"%s\" in Union geometry \"%s\" did not match a specified material. \n",material_string,NAME_CURRENT_COMP);
            printf("       The materials available at this point (need to be defined before the geometry): \n");
            for (loop_index=0;loop_index<global_material_list.num_elements;loop_index++)
              printf("         %s\n",global_material_list.elements[loop_index].name);
            printf("\n");
            printf("       It is also possible to use one of the defualt materials avaiable: \n");
            printf("           Vacuum (for a Volume without scattering or absorption)\n");
            printf("           Exit (for a Volume where the ray exits the component if it enters)\n");
            printf("           Mask (for a Volume that masks existing volumes specified in the mask_string\n");
            exit(1);
          }
        }
    }
} else {
    // Automatic linking, simply using the last defined material.
    #ifndef MATERIAL_DETECTOR
        printf("Need to define a material before the geometry to use automatic linking %s.\n",NAME_CURRENT_COMP);
        exit(1);
    #endif
    this_box_volume.p_physics = global_material_list.elements[global_material_list.num_elements-1].physics;
}

sprintf(this_box_volume.name,NAME_CURRENT_COMP);
sprintf(this_box_volume.geometry.shape,"box");
this_box_volume.geometry.priority_value = priority;
this_box_volume.geometry.geometry_p_interact = p_interact;
// Currently the coordinates will be in absolute space.
this_box_volume.geometry.center = POS_A_CURRENT_COMP;

this_box_storage.z_depth = zdepth;
this_box_storage.x_width1 = xwidth;
this_box_storage.y_height1 = yheight;

this_box_storage.is_rectangle = 0;
if (xwidth2 < 0 && yheight2 < 0) this_box_storage.is_rectangle = 1;
if (xwidth == xwidth2 && yheight == yheight2) this_box_storage.is_rectangle = 1;

if (xwidth2 < 0) {
    this_box_storage.x_width2 = xwidth;
    xwidth2 = xwidth;
} else this_box_storage.x_width2 = xwidth2;

if (yheight2 < 0) {
    this_box_storage.y_height2 = yheight;
    yheight2 = yheight;
} else this_box_storage.y_height2 = yheight2;


this_box_storage.normal_vectors[0] = coords_set(0,0,1);
this_box_storage.normal_vectors[1] = coords_set(0,0,1);

// for sides with y component = 0
x_component = 2*zdepth/sqrt((xwidth-xwidth2)*(xwidth-xwidth2)+4*zdepth*zdepth);
z_component = (xwidth-xwidth2)/sqrt(4*zdepth*zdepth+(xwidth-xwidth2)*(xwidth-xwidth2));

this_box_storage.normal_vectors[2] = coords_set(x_component,0,z_component);
this_box_storage.normal_vectors[3] = coords_set(-x_component,0,z_component);

// for sides with x component = 0
y_component = 2*zdepth/sqrt((yheight-yheight2)*(yheight-yheight2)+4*zdepth*zdepth);
z_component = (yheight-yheight2)/sqrt(4*zdepth*zdepth+(yheight-yheight2)*(yheight-yheight2));

this_box_storage.normal_vectors[4] = coords_set(0,y_component,z_component);
this_box_storage.normal_vectors[5] = coords_set(0,-y_component,z_component);

this_box_volume.geometry.visualization_on = visualize;

this_box_volume.geometry.geometry_parameters.p_box_storage = &this_box_storage;

// Assign pointers to functions for intersection with the shape, checking if a point is inside the shape
if (this_box_storage.is_rectangle == 1) {
this_box_volume.geometry.intersect_function = &sample_box_intersect_simple;
this_box_volume.geometry.within_function = &r_within_box_simple;
}
else {
this_box_volume.geometry.intersect_function = &sample_box_intersect_advanced;
this_box_volume.geometry.within_function = &r_within_box_advanced;
}

this_box_volume.geometry.shell_points = &box_shell_points;
this_box_volume.geometry.mcdisplay_function = &mcdisplay_box_function;
this_box_volume.geometry.initialize_from_main_function = &initialize_box_geometry_from_main_component;
this_box_volume.geometry.process_rot_allocated = 0;

this_box_volume.geometry.copy_geometry_parameters = &allocate_box_storage_copy;

rot_copy(this_box_volume.geometry.rotation_matrix,ROT_A_CURRENT_COMP); //check how ROT_R_CURRENT_COMP would work
rot_transpose(ROT_A_CURRENT_COMP,this_box_volume.geometry.transpose_rotation_matrix);

// Initialize loggers
this_box_volume.loggers.num_elements = 0;

// packing the information into the global_geometry_element, which is then included in the global_geometry_list.
sprintf(global_geometry_element.name,NAME_CURRENT_COMP);
global_geometry_element.activation_counter = number_of_activations;
global_geometry_element.component_index = INDEX_CURRENT_COMP;
global_geometry_element.Volume = &this_box_volume; // Would be nicer if this m was a pointer, now we have the (small) data two places
add_element_to_geometry_list(&global_geometry_list,global_geometry_element);
}
#line 299558 "MACS_sample_kidney_box.c"
#undef number_of_activations
#undef mask_setting
#undef mask_string
#undef p_interact
#undef focus_r
#undef focus_xh
#undef focus_xw
#undef focus_ah
#undef focus_aw
#undef target_z
#undef target_y
#undef target_x
#undef target_index
#undef visualize
#undef yheight2
#undef xwidth2
#undef zdepth
#undef yheight
#undef xwidth
#undef priority
#undef material_string
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

  /* Initializations for component channel_15_analyzer_1_array_crystal_array_7. */
  SIG_MESSAGE("channel_15_analyzer_1_array_crystal_array_7 (Init)");
#define mccompcurname  channel_15_analyzer_1_array_crystal_array_7
#define mccompcurtype  Union_box
#define mccompcurindex 707
#define loop_index mccchannel_15_analyzer_1_array_crystal_array_7_loop_index
#define this_box_volume mccchannel_15_analyzer_1_array_crystal_array_7_this_box_volume
#define global_geometry_element mccchannel_15_analyzer_1_array_crystal_array_7_global_geometry_element
#define this_box_storage mccchannel_15_analyzer_1_array_crystal_array_7_this_box_storage
#define material_string mccchannel_15_analyzer_1_array_crystal_array_7_material_string
#define priority mccchannel_15_analyzer_1_array_crystal_array_7_priority
#define xwidth mccchannel_15_analyzer_1_array_crystal_array_7_xwidth
#define yheight mccchannel_15_analyzer_1_array_crystal_array_7_yheight
#define zdepth mccchannel_15_analyzer_1_array_crystal_array_7_zdepth
#define xwidth2 mccchannel_15_analyzer_1_array_crystal_array_7_xwidth2
#define yheight2 mccchannel_15_analyzer_1_array_crystal_array_7_yheight2
#define visualize mccchannel_15_analyzer_1_array_crystal_array_7_visualize
#define target_index mccchannel_15_analyzer_1_array_crystal_array_7_target_index
#define target_x mccchannel_15_analyzer_1_array_crystal_array_7_target_x
#define target_y mccchannel_15_analyzer_1_array_crystal_array_7_target_y
#define target_z mccchannel_15_analyzer_1_array_crystal_array_7_target_z
#define focus_aw mccchannel_15_analyzer_1_array_crystal_array_7_focus_aw
#define focus_ah mccchannel_15_analyzer_1_array_crystal_array_7_focus_ah
#define focus_xw mccchannel_15_analyzer_1_array_crystal_array_7_focus_xw
#define focus_xh mccchannel_15_analyzer_1_array_crystal_array_7_focus_xh
#define focus_r mccchannel_15_analyzer_1_array_crystal_array_7_focus_r
#define p_interact mccchannel_15_analyzer_1_array_crystal_array_7_p_interact
#define mask_string mccchannel_15_analyzer_1_array_crystal_array_7_mask_string
#define mask_setting mccchannel_15_analyzer_1_array_crystal_array_7_mask_setting
#define number_of_activations mccchannel_15_analyzer_1_array_crystal_array_7_number_of_activations
#line 224 "Union_box.comp"
{
// Initializes the focusing system for this volume including input sanitation.
focus_initialize(&this_box_volume.geometry, POS_A_COMP_INDEX(INDEX_CURRENT_COMP+target_index), POS_A_CURRENT_COMP, ROT_A_CURRENT_COMP, target_index, target_x, target_y, target_z, focus_aw, focus_ah, focus_xw, focus_xh, focus_r, NAME_CURRENT_COMP);

// Input sanitation for this geometry
if (xwidth <= 0) {
  printf("\nERROR in Union_box named %s, the xwidth is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (yheight <= 0) {
  printf("\nERROR in Union_box named %s, yheight is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (zdepth <= 0) {
  printf("\nERROR in Union_box named %s, zdepth is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (xwidth2 <= 0 && xwidth2 != -1) {
  printf("\nERROR in Union_box named %s, the xwidth2 is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (yheight2 <= 0 && yheight2 != -1) {
  printf("\nERROR in Union_box named %s, yheight2 is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}

// Use sanitation
if (global_material_list.num_elements == 0) {
  printf("\nERROR: Need to define a material using Union_make_material before using a Union geometry component. \n");
  printf("       %s was defined before first use of Union_make_material.\n",NAME_CURRENT_COMP);
  exit(1);
}

this_box_volume.geometry.is_masked_volume = 0;
this_box_volume.geometry.is_exit_volume = 0;
this_box_volume.geometry.is_mask_volume = 0;
// check if the volume is a mask, if it is the material string is irelevant.
if (mask_string && strlen(mask_string) && strcmp(mask_string, "NULL") && strcmp(mask_string, "0")) {
    // A mask volume is used to limit the extend of other volumes, called the masked volumes. These are specified in the mask_string.
    // In order for a ray to enter a masked volume, it needs to be both in the region covered by that volume AND the mask volume.
    // When more than
    this_box_volume.geometry.mask_mode = 1; // Default is mask mode is ALL
    if (mask_setting && strlen(mask_setting) && strcmp(mask_setting, "NULL") && strcmp(mask_setting, "0")) {
        if (strcmp(mask_setting,"ALL") == 0 || strcmp(mask_setting,"All") == 0) this_box_volume.geometry.mask_mode = 1;
        else if (strcmp(mask_setting,"ANY") == 0 || strcmp(mask_setting,"Any") == 0) this_box_volume.geometry.mask_mode = 2;
        else {
            printf("The mask_mode of component %s is set to %s, but must be either ALL or ANY.\n",NAME_CURRENT_COMP,mask_setting);
            exit(1);
        }
    }
    
    for (loop_index=0;loop_index<global_geometry_list.num_elements;loop_index++) {
        // Add mask list
        if (1 == manual_linking_function(global_geometry_list.elements[loop_index].name,mask_string)) {
            add_element_to_int_list(&this_box_volume.geometry.mask_list,global_geometry_list.elements[loop_index].component_index);
            add_element_to_int_list(&global_geometry_list.elements[loop_index].Volume->geometry.masked_by_list,INDEX_CURRENT_COMP);
            global_geometry_list.elements[loop_index].Volume->geometry.is_masked_volume = 1;
            if (this_box_volume.geometry.mask_mode == 2)
                global_geometry_list.elements[loop_index].Volume->geometry.mask_mode = 2;
            if (this_box_volume.geometry.mask_mode == 1) {
                if (global_geometry_list.elements[loop_index].Volume->geometry.is_masked_volume == 1 && global_geometry_list.elements[loop_index].Volume->geometry.mask_mode != 2)
                    // If more than one mask is added to one volume, the ANY mode overwrites the (default) ALL mode.
                    global_geometry_list.elements[loop_index].Volume->geometry.mask_mode = 1;
            }
            
            found_geometries = 1;
        }
    }
    if (found_geometries == 0) {
        printf("The mask_string in geometry: %s did not find any of the specified volumes in the mask_string %s \n",NAME_CURRENT_COMP,mask_string);
        exit(1);
    }
    this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
    this_box_volume.p_physics->is_vacuum = 0; // Makes this volume a vacuum
    this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
    this_box_volume.p_physics->my_a = 0; // Should not be used.
    sprintf(this_box_volume.p_physics->name,"Mask");
    this_box_volume.geometry.is_mask_volume = 1;
    
    
// Read the material input, or if it lacks, use automatic linking.
} else if (material_string && strlen(material_string) && strcmp(material_string, "NULL") && strcmp(material_string, "0")) {
    // A geometry string was given, use it to determine which material
    if (0 == strcmp(material_string,"vacuum") || 0 == strcmp(material_string,"Vacuum")) {
        // One could have a global physics struct for vacuum instead of creating one for each
        this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
        this_box_volume.p_physics->is_vacuum = 1; // Makes this volume a vacuum
        this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
        this_box_volume.p_physics->my_a = 0; // Should not be used.
        sprintf(this_box_volume.p_physics->name,"Vacuum");
    } else if (0 == strcmp(material_string,"exit") || 0 == strcmp(material_string,"Exit")) {
        // One could have a global physics struct for vacuum instead of creating one for each
        this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
        this_box_volume.p_physics->is_vacuum = 1; // Makes this volume a vacuum
        this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
        this_box_volume.p_physics->my_a = 0; // Should not be used.
        this_box_volume.geometry.is_exit_volume = 1;
        sprintf(this_box_volume.p_physics->name,"Exit");
    } else {
        #ifndef MATERIAL_DETECTOR
            printf("Need to define a material before refering to it in a geometry %s.\n",NAME_CURRENT_COMP);
            exit(1);
        #endif
        for (loop_index=0;loop_index<global_material_list.num_elements;loop_index++) {
            if (0 == strcmp(material_string,global_material_list.elements[loop_index].name)) {
                this_box_volume.p_physics = global_material_list.elements[loop_index].physics;
                break;
            }
            if (loop_index == global_material_list.num_elements-1) {
            printf("\n");
            printf("ERROR: The material string \"%s\" in Union geometry \"%s\" did not match a specified material. \n",material_string,NAME_CURRENT_COMP);
            printf("       The materials available at this point (need to be defined before the geometry): \n");
            for (loop_index=0;loop_index<global_material_list.num_elements;loop_index++)
              printf("         %s\n",global_material_list.elements[loop_index].name);
            printf("\n");
            printf("       It is also possible to use one of the defualt materials avaiable: \n");
            printf("           Vacuum (for a Volume without scattering or absorption)\n");
            printf("           Exit (for a Volume where the ray exits the component if it enters)\n");
            printf("           Mask (for a Volume that masks existing volumes specified in the mask_string\n");
            exit(1);
          }
        }
    }
} else {
    // Automatic linking, simply using the last defined material.
    #ifndef MATERIAL_DETECTOR
        printf("Need to define a material before the geometry to use automatic linking %s.\n",NAME_CURRENT_COMP);
        exit(1);
    #endif
    this_box_volume.p_physics = global_material_list.elements[global_material_list.num_elements-1].physics;
}

sprintf(this_box_volume.name,NAME_CURRENT_COMP);
sprintf(this_box_volume.geometry.shape,"box");
this_box_volume.geometry.priority_value = priority;
this_box_volume.geometry.geometry_p_interact = p_interact;
// Currently the coordinates will be in absolute space.
this_box_volume.geometry.center = POS_A_CURRENT_COMP;

this_box_storage.z_depth = zdepth;
this_box_storage.x_width1 = xwidth;
this_box_storage.y_height1 = yheight;

this_box_storage.is_rectangle = 0;
if (xwidth2 < 0 && yheight2 < 0) this_box_storage.is_rectangle = 1;
if (xwidth == xwidth2 && yheight == yheight2) this_box_storage.is_rectangle = 1;

if (xwidth2 < 0) {
    this_box_storage.x_width2 = xwidth;
    xwidth2 = xwidth;
} else this_box_storage.x_width2 = xwidth2;

if (yheight2 < 0) {
    this_box_storage.y_height2 = yheight;
    yheight2 = yheight;
} else this_box_storage.y_height2 = yheight2;


this_box_storage.normal_vectors[0] = coords_set(0,0,1);
this_box_storage.normal_vectors[1] = coords_set(0,0,1);

// for sides with y component = 0
x_component = 2*zdepth/sqrt((xwidth-xwidth2)*(xwidth-xwidth2)+4*zdepth*zdepth);
z_component = (xwidth-xwidth2)/sqrt(4*zdepth*zdepth+(xwidth-xwidth2)*(xwidth-xwidth2));

this_box_storage.normal_vectors[2] = coords_set(x_component,0,z_component);
this_box_storage.normal_vectors[3] = coords_set(-x_component,0,z_component);

// for sides with x component = 0
y_component = 2*zdepth/sqrt((yheight-yheight2)*(yheight-yheight2)+4*zdepth*zdepth);
z_component = (yheight-yheight2)/sqrt(4*zdepth*zdepth+(yheight-yheight2)*(yheight-yheight2));

this_box_storage.normal_vectors[4] = coords_set(0,y_component,z_component);
this_box_storage.normal_vectors[5] = coords_set(0,-y_component,z_component);

this_box_volume.geometry.visualization_on = visualize;

this_box_volume.geometry.geometry_parameters.p_box_storage = &this_box_storage;

// Assign pointers to functions for intersection with the shape, checking if a point is inside the shape
if (this_box_storage.is_rectangle == 1) {
this_box_volume.geometry.intersect_function = &sample_box_intersect_simple;
this_box_volume.geometry.within_function = &r_within_box_simple;
}
else {
this_box_volume.geometry.intersect_function = &sample_box_intersect_advanced;
this_box_volume.geometry.within_function = &r_within_box_advanced;
}

this_box_volume.geometry.shell_points = &box_shell_points;
this_box_volume.geometry.mcdisplay_function = &mcdisplay_box_function;
this_box_volume.geometry.initialize_from_main_function = &initialize_box_geometry_from_main_component;
this_box_volume.geometry.process_rot_allocated = 0;

this_box_volume.geometry.copy_geometry_parameters = &allocate_box_storage_copy;

rot_copy(this_box_volume.geometry.rotation_matrix,ROT_A_CURRENT_COMP); //check how ROT_R_CURRENT_COMP would work
rot_transpose(ROT_A_CURRENT_COMP,this_box_volume.geometry.transpose_rotation_matrix);

// Initialize loggers
this_box_volume.loggers.num_elements = 0;

// packing the information into the global_geometry_element, which is then included in the global_geometry_list.
sprintf(global_geometry_element.name,NAME_CURRENT_COMP);
global_geometry_element.activation_counter = number_of_activations;
global_geometry_element.component_index = INDEX_CURRENT_COMP;
global_geometry_element.Volume = &this_box_volume; // Would be nicer if this m was a pointer, now we have the (small) data two places
add_element_to_geometry_list(&global_geometry_list,global_geometry_element);
}
#line 299828 "MACS_sample_kidney_box.c"
#undef number_of_activations
#undef mask_setting
#undef mask_string
#undef p_interact
#undef focus_r
#undef focus_xh
#undef focus_xw
#undef focus_ah
#undef focus_aw
#undef target_z
#undef target_y
#undef target_x
#undef target_index
#undef visualize
#undef yheight2
#undef xwidth2
#undef zdepth
#undef yheight
#undef xwidth
#undef priority
#undef material_string
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

  /* Initializations for component channel_15_analyzer_1_array_crystal_array_8. */
  SIG_MESSAGE("channel_15_analyzer_1_array_crystal_array_8 (Init)");
#define mccompcurname  channel_15_analyzer_1_array_crystal_array_8
#define mccompcurtype  Union_box
#define mccompcurindex 708
#define loop_index mccchannel_15_analyzer_1_array_crystal_array_8_loop_index
#define this_box_volume mccchannel_15_analyzer_1_array_crystal_array_8_this_box_volume
#define global_geometry_element mccchannel_15_analyzer_1_array_crystal_array_8_global_geometry_element
#define this_box_storage mccchannel_15_analyzer_1_array_crystal_array_8_this_box_storage
#define material_string mccchannel_15_analyzer_1_array_crystal_array_8_material_string
#define priority mccchannel_15_analyzer_1_array_crystal_array_8_priority
#define xwidth mccchannel_15_analyzer_1_array_crystal_array_8_xwidth
#define yheight mccchannel_15_analyzer_1_array_crystal_array_8_yheight
#define zdepth mccchannel_15_analyzer_1_array_crystal_array_8_zdepth
#define xwidth2 mccchannel_15_analyzer_1_array_crystal_array_8_xwidth2
#define yheight2 mccchannel_15_analyzer_1_array_crystal_array_8_yheight2
#define visualize mccchannel_15_analyzer_1_array_crystal_array_8_visualize
#define target_index mccchannel_15_analyzer_1_array_crystal_array_8_target_index
#define target_x mccchannel_15_analyzer_1_array_crystal_array_8_target_x
#define target_y mccchannel_15_analyzer_1_array_crystal_array_8_target_y
#define target_z mccchannel_15_analyzer_1_array_crystal_array_8_target_z
#define focus_aw mccchannel_15_analyzer_1_array_crystal_array_8_focus_aw
#define focus_ah mccchannel_15_analyzer_1_array_crystal_array_8_focus_ah
#define focus_xw mccchannel_15_analyzer_1_array_crystal_array_8_focus_xw
#define focus_xh mccchannel_15_analyzer_1_array_crystal_array_8_focus_xh
#define focus_r mccchannel_15_analyzer_1_array_crystal_array_8_focus_r
#define p_interact mccchannel_15_analyzer_1_array_crystal_array_8_p_interact
#define mask_string mccchannel_15_analyzer_1_array_crystal_array_8_mask_string
#define mask_setting mccchannel_15_analyzer_1_array_crystal_array_8_mask_setting
#define number_of_activations mccchannel_15_analyzer_1_array_crystal_array_8_number_of_activations
#line 224 "Union_box.comp"
{
// Initializes the focusing system for this volume including input sanitation.
focus_initialize(&this_box_volume.geometry, POS_A_COMP_INDEX(INDEX_CURRENT_COMP+target_index), POS_A_CURRENT_COMP, ROT_A_CURRENT_COMP, target_index, target_x, target_y, target_z, focus_aw, focus_ah, focus_xw, focus_xh, focus_r, NAME_CURRENT_COMP);

// Input sanitation for this geometry
if (xwidth <= 0) {
  printf("\nERROR in Union_box named %s, the xwidth is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (yheight <= 0) {
  printf("\nERROR in Union_box named %s, yheight is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (zdepth <= 0) {
  printf("\nERROR in Union_box named %s, zdepth is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (xwidth2 <= 0 && xwidth2 != -1) {
  printf("\nERROR in Union_box named %s, the xwidth2 is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (yheight2 <= 0 && yheight2 != -1) {
  printf("\nERROR in Union_box named %s, yheight2 is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}

// Use sanitation
if (global_material_list.num_elements == 0) {
  printf("\nERROR: Need to define a material using Union_make_material before using a Union geometry component. \n");
  printf("       %s was defined before first use of Union_make_material.\n",NAME_CURRENT_COMP);
  exit(1);
}

this_box_volume.geometry.is_masked_volume = 0;
this_box_volume.geometry.is_exit_volume = 0;
this_box_volume.geometry.is_mask_volume = 0;
// check if the volume is a mask, if it is the material string is irelevant.
if (mask_string && strlen(mask_string) && strcmp(mask_string, "NULL") && strcmp(mask_string, "0")) {
    // A mask volume is used to limit the extend of other volumes, called the masked volumes. These are specified in the mask_string.
    // In order for a ray to enter a masked volume, it needs to be both in the region covered by that volume AND the mask volume.
    // When more than
    this_box_volume.geometry.mask_mode = 1; // Default is mask mode is ALL
    if (mask_setting && strlen(mask_setting) && strcmp(mask_setting, "NULL") && strcmp(mask_setting, "0")) {
        if (strcmp(mask_setting,"ALL") == 0 || strcmp(mask_setting,"All") == 0) this_box_volume.geometry.mask_mode = 1;
        else if (strcmp(mask_setting,"ANY") == 0 || strcmp(mask_setting,"Any") == 0) this_box_volume.geometry.mask_mode = 2;
        else {
            printf("The mask_mode of component %s is set to %s, but must be either ALL or ANY.\n",NAME_CURRENT_COMP,mask_setting);
            exit(1);
        }
    }
    
    for (loop_index=0;loop_index<global_geometry_list.num_elements;loop_index++) {
        // Add mask list
        if (1 == manual_linking_function(global_geometry_list.elements[loop_index].name,mask_string)) {
            add_element_to_int_list(&this_box_volume.geometry.mask_list,global_geometry_list.elements[loop_index].component_index);
            add_element_to_int_list(&global_geometry_list.elements[loop_index].Volume->geometry.masked_by_list,INDEX_CURRENT_COMP);
            global_geometry_list.elements[loop_index].Volume->geometry.is_masked_volume = 1;
            if (this_box_volume.geometry.mask_mode == 2)
                global_geometry_list.elements[loop_index].Volume->geometry.mask_mode = 2;
            if (this_box_volume.geometry.mask_mode == 1) {
                if (global_geometry_list.elements[loop_index].Volume->geometry.is_masked_volume == 1 && global_geometry_list.elements[loop_index].Volume->geometry.mask_mode != 2)
                    // If more than one mask is added to one volume, the ANY mode overwrites the (default) ALL mode.
                    global_geometry_list.elements[loop_index].Volume->geometry.mask_mode = 1;
            }
            
            found_geometries = 1;
        }
    }
    if (found_geometries == 0) {
        printf("The mask_string in geometry: %s did not find any of the specified volumes in the mask_string %s \n",NAME_CURRENT_COMP,mask_string);
        exit(1);
    }
    this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
    this_box_volume.p_physics->is_vacuum = 0; // Makes this volume a vacuum
    this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
    this_box_volume.p_physics->my_a = 0; // Should not be used.
    sprintf(this_box_volume.p_physics->name,"Mask");
    this_box_volume.geometry.is_mask_volume = 1;
    
    
// Read the material input, or if it lacks, use automatic linking.
} else if (material_string && strlen(material_string) && strcmp(material_string, "NULL") && strcmp(material_string, "0")) {
    // A geometry string was given, use it to determine which material
    if (0 == strcmp(material_string,"vacuum") || 0 == strcmp(material_string,"Vacuum")) {
        // One could have a global physics struct for vacuum instead of creating one for each
        this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
        this_box_volume.p_physics->is_vacuum = 1; // Makes this volume a vacuum
        this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
        this_box_volume.p_physics->my_a = 0; // Should not be used.
        sprintf(this_box_volume.p_physics->name,"Vacuum");
    } else if (0 == strcmp(material_string,"exit") || 0 == strcmp(material_string,"Exit")) {
        // One could have a global physics struct for vacuum instead of creating one for each
        this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
        this_box_volume.p_physics->is_vacuum = 1; // Makes this volume a vacuum
        this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
        this_box_volume.p_physics->my_a = 0; // Should not be used.
        this_box_volume.geometry.is_exit_volume = 1;
        sprintf(this_box_volume.p_physics->name,"Exit");
    } else {
        #ifndef MATERIAL_DETECTOR
            printf("Need to define a material before refering to it in a geometry %s.\n",NAME_CURRENT_COMP);
            exit(1);
        #endif
        for (loop_index=0;loop_index<global_material_list.num_elements;loop_index++) {
            if (0 == strcmp(material_string,global_material_list.elements[loop_index].name)) {
                this_box_volume.p_physics = global_material_list.elements[loop_index].physics;
                break;
            }
            if (loop_index == global_material_list.num_elements-1) {
            printf("\n");
            printf("ERROR: The material string \"%s\" in Union geometry \"%s\" did not match a specified material. \n",material_string,NAME_CURRENT_COMP);
            printf("       The materials available at this point (need to be defined before the geometry): \n");
            for (loop_index=0;loop_index<global_material_list.num_elements;loop_index++)
              printf("         %s\n",global_material_list.elements[loop_index].name);
            printf("\n");
            printf("       It is also possible to use one of the defualt materials avaiable: \n");
            printf("           Vacuum (for a Volume without scattering or absorption)\n");
            printf("           Exit (for a Volume where the ray exits the component if it enters)\n");
            printf("           Mask (for a Volume that masks existing volumes specified in the mask_string\n");
            exit(1);
          }
        }
    }
} else {
    // Automatic linking, simply using the last defined material.
    #ifndef MATERIAL_DETECTOR
        printf("Need to define a material before the geometry to use automatic linking %s.\n",NAME_CURRENT_COMP);
        exit(1);
    #endif
    this_box_volume.p_physics = global_material_list.elements[global_material_list.num_elements-1].physics;
}

sprintf(this_box_volume.name,NAME_CURRENT_COMP);
sprintf(this_box_volume.geometry.shape,"box");
this_box_volume.geometry.priority_value = priority;
this_box_volume.geometry.geometry_p_interact = p_interact;
// Currently the coordinates will be in absolute space.
this_box_volume.geometry.center = POS_A_CURRENT_COMP;

this_box_storage.z_depth = zdepth;
this_box_storage.x_width1 = xwidth;
this_box_storage.y_height1 = yheight;

this_box_storage.is_rectangle = 0;
if (xwidth2 < 0 && yheight2 < 0) this_box_storage.is_rectangle = 1;
if (xwidth == xwidth2 && yheight == yheight2) this_box_storage.is_rectangle = 1;

if (xwidth2 < 0) {
    this_box_storage.x_width2 = xwidth;
    xwidth2 = xwidth;
} else this_box_storage.x_width2 = xwidth2;

if (yheight2 < 0) {
    this_box_storage.y_height2 = yheight;
    yheight2 = yheight;
} else this_box_storage.y_height2 = yheight2;


this_box_storage.normal_vectors[0] = coords_set(0,0,1);
this_box_storage.normal_vectors[1] = coords_set(0,0,1);

// for sides with y component = 0
x_component = 2*zdepth/sqrt((xwidth-xwidth2)*(xwidth-xwidth2)+4*zdepth*zdepth);
z_component = (xwidth-xwidth2)/sqrt(4*zdepth*zdepth+(xwidth-xwidth2)*(xwidth-xwidth2));

this_box_storage.normal_vectors[2] = coords_set(x_component,0,z_component);
this_box_storage.normal_vectors[3] = coords_set(-x_component,0,z_component);

// for sides with x component = 0
y_component = 2*zdepth/sqrt((yheight-yheight2)*(yheight-yheight2)+4*zdepth*zdepth);
z_component = (yheight-yheight2)/sqrt(4*zdepth*zdepth+(yheight-yheight2)*(yheight-yheight2));

this_box_storage.normal_vectors[4] = coords_set(0,y_component,z_component);
this_box_storage.normal_vectors[5] = coords_set(0,-y_component,z_component);

this_box_volume.geometry.visualization_on = visualize;

this_box_volume.geometry.geometry_parameters.p_box_storage = &this_box_storage;

// Assign pointers to functions for intersection with the shape, checking if a point is inside the shape
if (this_box_storage.is_rectangle == 1) {
this_box_volume.geometry.intersect_function = &sample_box_intersect_simple;
this_box_volume.geometry.within_function = &r_within_box_simple;
}
else {
this_box_volume.geometry.intersect_function = &sample_box_intersect_advanced;
this_box_volume.geometry.within_function = &r_within_box_advanced;
}

this_box_volume.geometry.shell_points = &box_shell_points;
this_box_volume.geometry.mcdisplay_function = &mcdisplay_box_function;
this_box_volume.geometry.initialize_from_main_function = &initialize_box_geometry_from_main_component;
this_box_volume.geometry.process_rot_allocated = 0;

this_box_volume.geometry.copy_geometry_parameters = &allocate_box_storage_copy;

rot_copy(this_box_volume.geometry.rotation_matrix,ROT_A_CURRENT_COMP); //check how ROT_R_CURRENT_COMP would work
rot_transpose(ROT_A_CURRENT_COMP,this_box_volume.geometry.transpose_rotation_matrix);

// Initialize loggers
this_box_volume.loggers.num_elements = 0;

// packing the information into the global_geometry_element, which is then included in the global_geometry_list.
sprintf(global_geometry_element.name,NAME_CURRENT_COMP);
global_geometry_element.activation_counter = number_of_activations;
global_geometry_element.component_index = INDEX_CURRENT_COMP;
global_geometry_element.Volume = &this_box_volume; // Would be nicer if this m was a pointer, now we have the (small) data two places
add_element_to_geometry_list(&global_geometry_list,global_geometry_element);
}
#line 300098 "MACS_sample_kidney_box.c"
#undef number_of_activations
#undef mask_setting
#undef mask_string
#undef p_interact
#undef focus_r
#undef focus_xh
#undef focus_xw
#undef focus_ah
#undef focus_aw
#undef target_z
#undef target_y
#undef target_x
#undef target_index
#undef visualize
#undef yheight2
#undef xwidth2
#undef zdepth
#undef yheight
#undef xwidth
#undef priority
#undef material_string
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

  /* Initializations for component channel_15_analyzer_2_center. */
  SIG_MESSAGE("channel_15_analyzer_2_center (Init)");

  /* Initializations for component channel_15_analyzer_2_rotated. */
  SIG_MESSAGE("channel_15_analyzer_2_rotated (Init)");

  /* Initializations for component channel_15_analyzer_2_array_crystal_array_0. */
  SIG_MESSAGE("channel_15_analyzer_2_array_crystal_array_0 (Init)");
#define mccompcurname  channel_15_analyzer_2_array_crystal_array_0
#define mccompcurtype  Union_box
#define mccompcurindex 711
#define loop_index mccchannel_15_analyzer_2_array_crystal_array_0_loop_index
#define this_box_volume mccchannel_15_analyzer_2_array_crystal_array_0_this_box_volume
#define global_geometry_element mccchannel_15_analyzer_2_array_crystal_array_0_global_geometry_element
#define this_box_storage mccchannel_15_analyzer_2_array_crystal_array_0_this_box_storage
#define material_string mccchannel_15_analyzer_2_array_crystal_array_0_material_string
#define priority mccchannel_15_analyzer_2_array_crystal_array_0_priority
#define xwidth mccchannel_15_analyzer_2_array_crystal_array_0_xwidth
#define yheight mccchannel_15_analyzer_2_array_crystal_array_0_yheight
#define zdepth mccchannel_15_analyzer_2_array_crystal_array_0_zdepth
#define xwidth2 mccchannel_15_analyzer_2_array_crystal_array_0_xwidth2
#define yheight2 mccchannel_15_analyzer_2_array_crystal_array_0_yheight2
#define visualize mccchannel_15_analyzer_2_array_crystal_array_0_visualize
#define target_index mccchannel_15_analyzer_2_array_crystal_array_0_target_index
#define target_x mccchannel_15_analyzer_2_array_crystal_array_0_target_x
#define target_y mccchannel_15_analyzer_2_array_crystal_array_0_target_y
#define target_z mccchannel_15_analyzer_2_array_crystal_array_0_target_z
#define focus_aw mccchannel_15_analyzer_2_array_crystal_array_0_focus_aw
#define focus_ah mccchannel_15_analyzer_2_array_crystal_array_0_focus_ah
#define focus_xw mccchannel_15_analyzer_2_array_crystal_array_0_focus_xw
#define focus_xh mccchannel_15_analyzer_2_array_crystal_array_0_focus_xh
#define focus_r mccchannel_15_analyzer_2_array_crystal_array_0_focus_r
#define p_interact mccchannel_15_analyzer_2_array_crystal_array_0_p_interact
#define mask_string mccchannel_15_analyzer_2_array_crystal_array_0_mask_string
#define mask_setting mccchannel_15_analyzer_2_array_crystal_array_0_mask_setting
#define number_of_activations mccchannel_15_analyzer_2_array_crystal_array_0_number_of_activations
#line 224 "Union_box.comp"
{
// Initializes the focusing system for this volume including input sanitation.
focus_initialize(&this_box_volume.geometry, POS_A_COMP_INDEX(INDEX_CURRENT_COMP+target_index), POS_A_CURRENT_COMP, ROT_A_CURRENT_COMP, target_index, target_x, target_y, target_z, focus_aw, focus_ah, focus_xw, focus_xh, focus_r, NAME_CURRENT_COMP);

// Input sanitation for this geometry
if (xwidth <= 0) {
  printf("\nERROR in Union_box named %s, the xwidth is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (yheight <= 0) {
  printf("\nERROR in Union_box named %s, yheight is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (zdepth <= 0) {
  printf("\nERROR in Union_box named %s, zdepth is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (xwidth2 <= 0 && xwidth2 != -1) {
  printf("\nERROR in Union_box named %s, the xwidth2 is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (yheight2 <= 0 && yheight2 != -1) {
  printf("\nERROR in Union_box named %s, yheight2 is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}

// Use sanitation
if (global_material_list.num_elements == 0) {
  printf("\nERROR: Need to define a material using Union_make_material before using a Union geometry component. \n");
  printf("       %s was defined before first use of Union_make_material.\n",NAME_CURRENT_COMP);
  exit(1);
}

this_box_volume.geometry.is_masked_volume = 0;
this_box_volume.geometry.is_exit_volume = 0;
this_box_volume.geometry.is_mask_volume = 0;
// check if the volume is a mask, if it is the material string is irelevant.
if (mask_string && strlen(mask_string) && strcmp(mask_string, "NULL") && strcmp(mask_string, "0")) {
    // A mask volume is used to limit the extend of other volumes, called the masked volumes. These are specified in the mask_string.
    // In order for a ray to enter a masked volume, it needs to be both in the region covered by that volume AND the mask volume.
    // When more than
    this_box_volume.geometry.mask_mode = 1; // Default is mask mode is ALL
    if (mask_setting && strlen(mask_setting) && strcmp(mask_setting, "NULL") && strcmp(mask_setting, "0")) {
        if (strcmp(mask_setting,"ALL") == 0 || strcmp(mask_setting,"All") == 0) this_box_volume.geometry.mask_mode = 1;
        else if (strcmp(mask_setting,"ANY") == 0 || strcmp(mask_setting,"Any") == 0) this_box_volume.geometry.mask_mode = 2;
        else {
            printf("The mask_mode of component %s is set to %s, but must be either ALL or ANY.\n",NAME_CURRENT_COMP,mask_setting);
            exit(1);
        }
    }
    
    for (loop_index=0;loop_index<global_geometry_list.num_elements;loop_index++) {
        // Add mask list
        if (1 == manual_linking_function(global_geometry_list.elements[loop_index].name,mask_string)) {
            add_element_to_int_list(&this_box_volume.geometry.mask_list,global_geometry_list.elements[loop_index].component_index);
            add_element_to_int_list(&global_geometry_list.elements[loop_index].Volume->geometry.masked_by_list,INDEX_CURRENT_COMP);
            global_geometry_list.elements[loop_index].Volume->geometry.is_masked_volume = 1;
            if (this_box_volume.geometry.mask_mode == 2)
                global_geometry_list.elements[loop_index].Volume->geometry.mask_mode = 2;
            if (this_box_volume.geometry.mask_mode == 1) {
                if (global_geometry_list.elements[loop_index].Volume->geometry.is_masked_volume == 1 && global_geometry_list.elements[loop_index].Volume->geometry.mask_mode != 2)
                    // If more than one mask is added to one volume, the ANY mode overwrites the (default) ALL mode.
                    global_geometry_list.elements[loop_index].Volume->geometry.mask_mode = 1;
            }
            
            found_geometries = 1;
        }
    }
    if (found_geometries == 0) {
        printf("The mask_string in geometry: %s did not find any of the specified volumes in the mask_string %s \n",NAME_CURRENT_COMP,mask_string);
        exit(1);
    }
    this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
    this_box_volume.p_physics->is_vacuum = 0; // Makes this volume a vacuum
    this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
    this_box_volume.p_physics->my_a = 0; // Should not be used.
    sprintf(this_box_volume.p_physics->name,"Mask");
    this_box_volume.geometry.is_mask_volume = 1;
    
    
// Read the material input, or if it lacks, use automatic linking.
} else if (material_string && strlen(material_string) && strcmp(material_string, "NULL") && strcmp(material_string, "0")) {
    // A geometry string was given, use it to determine which material
    if (0 == strcmp(material_string,"vacuum") || 0 == strcmp(material_string,"Vacuum")) {
        // One could have a global physics struct for vacuum instead of creating one for each
        this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
        this_box_volume.p_physics->is_vacuum = 1; // Makes this volume a vacuum
        this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
        this_box_volume.p_physics->my_a = 0; // Should not be used.
        sprintf(this_box_volume.p_physics->name,"Vacuum");
    } else if (0 == strcmp(material_string,"exit") || 0 == strcmp(material_string,"Exit")) {
        // One could have a global physics struct for vacuum instead of creating one for each
        this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
        this_box_volume.p_physics->is_vacuum = 1; // Makes this volume a vacuum
        this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
        this_box_volume.p_physics->my_a = 0; // Should not be used.
        this_box_volume.geometry.is_exit_volume = 1;
        sprintf(this_box_volume.p_physics->name,"Exit");
    } else {
        #ifndef MATERIAL_DETECTOR
            printf("Need to define a material before refering to it in a geometry %s.\n",NAME_CURRENT_COMP);
            exit(1);
        #endif
        for (loop_index=0;loop_index<global_material_list.num_elements;loop_index++) {
            if (0 == strcmp(material_string,global_material_list.elements[loop_index].name)) {
                this_box_volume.p_physics = global_material_list.elements[loop_index].physics;
                break;
            }
            if (loop_index == global_material_list.num_elements-1) {
            printf("\n");
            printf("ERROR: The material string \"%s\" in Union geometry \"%s\" did not match a specified material. \n",material_string,NAME_CURRENT_COMP);
            printf("       The materials available at this point (need to be defined before the geometry): \n");
            for (loop_index=0;loop_index<global_material_list.num_elements;loop_index++)
              printf("         %s\n",global_material_list.elements[loop_index].name);
            printf("\n");
            printf("       It is also possible to use one of the defualt materials avaiable: \n");
            printf("           Vacuum (for a Volume without scattering or absorption)\n");
            printf("           Exit (for a Volume where the ray exits the component if it enters)\n");
            printf("           Mask (for a Volume that masks existing volumes specified in the mask_string\n");
            exit(1);
          }
        }
    }
} else {
    // Automatic linking, simply using the last defined material.
    #ifndef MATERIAL_DETECTOR
        printf("Need to define a material before the geometry to use automatic linking %s.\n",NAME_CURRENT_COMP);
        exit(1);
    #endif
    this_box_volume.p_physics = global_material_list.elements[global_material_list.num_elements-1].physics;
}

sprintf(this_box_volume.name,NAME_CURRENT_COMP);
sprintf(this_box_volume.geometry.shape,"box");
this_box_volume.geometry.priority_value = priority;
this_box_volume.geometry.geometry_p_interact = p_interact;
// Currently the coordinates will be in absolute space.
this_box_volume.geometry.center = POS_A_CURRENT_COMP;

this_box_storage.z_depth = zdepth;
this_box_storage.x_width1 = xwidth;
this_box_storage.y_height1 = yheight;

this_box_storage.is_rectangle = 0;
if (xwidth2 < 0 && yheight2 < 0) this_box_storage.is_rectangle = 1;
if (xwidth == xwidth2 && yheight == yheight2) this_box_storage.is_rectangle = 1;

if (xwidth2 < 0) {
    this_box_storage.x_width2 = xwidth;
    xwidth2 = xwidth;
} else this_box_storage.x_width2 = xwidth2;

if (yheight2 < 0) {
    this_box_storage.y_height2 = yheight;
    yheight2 = yheight;
} else this_box_storage.y_height2 = yheight2;


this_box_storage.normal_vectors[0] = coords_set(0,0,1);
this_box_storage.normal_vectors[1] = coords_set(0,0,1);

// for sides with y component = 0
x_component = 2*zdepth/sqrt((xwidth-xwidth2)*(xwidth-xwidth2)+4*zdepth*zdepth);
z_component = (xwidth-xwidth2)/sqrt(4*zdepth*zdepth+(xwidth-xwidth2)*(xwidth-xwidth2));

this_box_storage.normal_vectors[2] = coords_set(x_component,0,z_component);
this_box_storage.normal_vectors[3] = coords_set(-x_component,0,z_component);

// for sides with x component = 0
y_component = 2*zdepth/sqrt((yheight-yheight2)*(yheight-yheight2)+4*zdepth*zdepth);
z_component = (yheight-yheight2)/sqrt(4*zdepth*zdepth+(yheight-yheight2)*(yheight-yheight2));

this_box_storage.normal_vectors[4] = coords_set(0,y_component,z_component);
this_box_storage.normal_vectors[5] = coords_set(0,-y_component,z_component);

this_box_volume.geometry.visualization_on = visualize;

this_box_volume.geometry.geometry_parameters.p_box_storage = &this_box_storage;

// Assign pointers to functions for intersection with the shape, checking if a point is inside the shape
if (this_box_storage.is_rectangle == 1) {
this_box_volume.geometry.intersect_function = &sample_box_intersect_simple;
this_box_volume.geometry.within_function = &r_within_box_simple;
}
else {
this_box_volume.geometry.intersect_function = &sample_box_intersect_advanced;
this_box_volume.geometry.within_function = &r_within_box_advanced;
}

this_box_volume.geometry.shell_points = &box_shell_points;
this_box_volume.geometry.mcdisplay_function = &mcdisplay_box_function;
this_box_volume.geometry.initialize_from_main_function = &initialize_box_geometry_from_main_component;
this_box_volume.geometry.process_rot_allocated = 0;

this_box_volume.geometry.copy_geometry_parameters = &allocate_box_storage_copy;

rot_copy(this_box_volume.geometry.rotation_matrix,ROT_A_CURRENT_COMP); //check how ROT_R_CURRENT_COMP would work
rot_transpose(ROT_A_CURRENT_COMP,this_box_volume.geometry.transpose_rotation_matrix);

// Initialize loggers
this_box_volume.loggers.num_elements = 0;

// packing the information into the global_geometry_element, which is then included in the global_geometry_list.
sprintf(global_geometry_element.name,NAME_CURRENT_COMP);
global_geometry_element.activation_counter = number_of_activations;
global_geometry_element.component_index = INDEX_CURRENT_COMP;
global_geometry_element.Volume = &this_box_volume; // Would be nicer if this m was a pointer, now we have the (small) data two places
add_element_to_geometry_list(&global_geometry_list,global_geometry_element);
}
#line 300374 "MACS_sample_kidney_box.c"
#undef number_of_activations
#undef mask_setting
#undef mask_string
#undef p_interact
#undef focus_r
#undef focus_xh
#undef focus_xw
#undef focus_ah
#undef focus_aw
#undef target_z
#undef target_y
#undef target_x
#undef target_index
#undef visualize
#undef yheight2
#undef xwidth2
#undef zdepth
#undef yheight
#undef xwidth
#undef priority
#undef material_string
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

  /* Initializations for component channel_15_analyzer_2_array_crystal_array_1. */
  SIG_MESSAGE("channel_15_analyzer_2_array_crystal_array_1 (Init)");
#define mccompcurname  channel_15_analyzer_2_array_crystal_array_1
#define mccompcurtype  Union_box
#define mccompcurindex 712
#define loop_index mccchannel_15_analyzer_2_array_crystal_array_1_loop_index
#define this_box_volume mccchannel_15_analyzer_2_array_crystal_array_1_this_box_volume
#define global_geometry_element mccchannel_15_analyzer_2_array_crystal_array_1_global_geometry_element
#define this_box_storage mccchannel_15_analyzer_2_array_crystal_array_1_this_box_storage
#define material_string mccchannel_15_analyzer_2_array_crystal_array_1_material_string
#define priority mccchannel_15_analyzer_2_array_crystal_array_1_priority
#define xwidth mccchannel_15_analyzer_2_array_crystal_array_1_xwidth
#define yheight mccchannel_15_analyzer_2_array_crystal_array_1_yheight
#define zdepth mccchannel_15_analyzer_2_array_crystal_array_1_zdepth
#define xwidth2 mccchannel_15_analyzer_2_array_crystal_array_1_xwidth2
#define yheight2 mccchannel_15_analyzer_2_array_crystal_array_1_yheight2
#define visualize mccchannel_15_analyzer_2_array_crystal_array_1_visualize
#define target_index mccchannel_15_analyzer_2_array_crystal_array_1_target_index
#define target_x mccchannel_15_analyzer_2_array_crystal_array_1_target_x
#define target_y mccchannel_15_analyzer_2_array_crystal_array_1_target_y
#define target_z mccchannel_15_analyzer_2_array_crystal_array_1_target_z
#define focus_aw mccchannel_15_analyzer_2_array_crystal_array_1_focus_aw
#define focus_ah mccchannel_15_analyzer_2_array_crystal_array_1_focus_ah
#define focus_xw mccchannel_15_analyzer_2_array_crystal_array_1_focus_xw
#define focus_xh mccchannel_15_analyzer_2_array_crystal_array_1_focus_xh
#define focus_r mccchannel_15_analyzer_2_array_crystal_array_1_focus_r
#define p_interact mccchannel_15_analyzer_2_array_crystal_array_1_p_interact
#define mask_string mccchannel_15_analyzer_2_array_crystal_array_1_mask_string
#define mask_setting mccchannel_15_analyzer_2_array_crystal_array_1_mask_setting
#define number_of_activations mccchannel_15_analyzer_2_array_crystal_array_1_number_of_activations
#line 224 "Union_box.comp"
{
// Initializes the focusing system for this volume including input sanitation.
focus_initialize(&this_box_volume.geometry, POS_A_COMP_INDEX(INDEX_CURRENT_COMP+target_index), POS_A_CURRENT_COMP, ROT_A_CURRENT_COMP, target_index, target_x, target_y, target_z, focus_aw, focus_ah, focus_xw, focus_xh, focus_r, NAME_CURRENT_COMP);

// Input sanitation for this geometry
if (xwidth <= 0) {
  printf("\nERROR in Union_box named %s, the xwidth is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (yheight <= 0) {
  printf("\nERROR in Union_box named %s, yheight is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (zdepth <= 0) {
  printf("\nERROR in Union_box named %s, zdepth is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (xwidth2 <= 0 && xwidth2 != -1) {
  printf("\nERROR in Union_box named %s, the xwidth2 is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (yheight2 <= 0 && yheight2 != -1) {
  printf("\nERROR in Union_box named %s, yheight2 is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}

// Use sanitation
if (global_material_list.num_elements == 0) {
  printf("\nERROR: Need to define a material using Union_make_material before using a Union geometry component. \n");
  printf("       %s was defined before first use of Union_make_material.\n",NAME_CURRENT_COMP);
  exit(1);
}

this_box_volume.geometry.is_masked_volume = 0;
this_box_volume.geometry.is_exit_volume = 0;
this_box_volume.geometry.is_mask_volume = 0;
// check if the volume is a mask, if it is the material string is irelevant.
if (mask_string && strlen(mask_string) && strcmp(mask_string, "NULL") && strcmp(mask_string, "0")) {
    // A mask volume is used to limit the extend of other volumes, called the masked volumes. These are specified in the mask_string.
    // In order for a ray to enter a masked volume, it needs to be both in the region covered by that volume AND the mask volume.
    // When more than
    this_box_volume.geometry.mask_mode = 1; // Default is mask mode is ALL
    if (mask_setting && strlen(mask_setting) && strcmp(mask_setting, "NULL") && strcmp(mask_setting, "0")) {
        if (strcmp(mask_setting,"ALL") == 0 || strcmp(mask_setting,"All") == 0) this_box_volume.geometry.mask_mode = 1;
        else if (strcmp(mask_setting,"ANY") == 0 || strcmp(mask_setting,"Any") == 0) this_box_volume.geometry.mask_mode = 2;
        else {
            printf("The mask_mode of component %s is set to %s, but must be either ALL or ANY.\n",NAME_CURRENT_COMP,mask_setting);
            exit(1);
        }
    }
    
    for (loop_index=0;loop_index<global_geometry_list.num_elements;loop_index++) {
        // Add mask list
        if (1 == manual_linking_function(global_geometry_list.elements[loop_index].name,mask_string)) {
            add_element_to_int_list(&this_box_volume.geometry.mask_list,global_geometry_list.elements[loop_index].component_index);
            add_element_to_int_list(&global_geometry_list.elements[loop_index].Volume->geometry.masked_by_list,INDEX_CURRENT_COMP);
            global_geometry_list.elements[loop_index].Volume->geometry.is_masked_volume = 1;
            if (this_box_volume.geometry.mask_mode == 2)
                global_geometry_list.elements[loop_index].Volume->geometry.mask_mode = 2;
            if (this_box_volume.geometry.mask_mode == 1) {
                if (global_geometry_list.elements[loop_index].Volume->geometry.is_masked_volume == 1 && global_geometry_list.elements[loop_index].Volume->geometry.mask_mode != 2)
                    // If more than one mask is added to one volume, the ANY mode overwrites the (default) ALL mode.
                    global_geometry_list.elements[loop_index].Volume->geometry.mask_mode = 1;
            }
            
            found_geometries = 1;
        }
    }
    if (found_geometries == 0) {
        printf("The mask_string in geometry: %s did not find any of the specified volumes in the mask_string %s \n",NAME_CURRENT_COMP,mask_string);
        exit(1);
    }
    this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
    this_box_volume.p_physics->is_vacuum = 0; // Makes this volume a vacuum
    this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
    this_box_volume.p_physics->my_a = 0; // Should not be used.
    sprintf(this_box_volume.p_physics->name,"Mask");
    this_box_volume.geometry.is_mask_volume = 1;
    
    
// Read the material input, or if it lacks, use automatic linking.
} else if (material_string && strlen(material_string) && strcmp(material_string, "NULL") && strcmp(material_string, "0")) {
    // A geometry string was given, use it to determine which material
    if (0 == strcmp(material_string,"vacuum") || 0 == strcmp(material_string,"Vacuum")) {
        // One could have a global physics struct for vacuum instead of creating one for each
        this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
        this_box_volume.p_physics->is_vacuum = 1; // Makes this volume a vacuum
        this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
        this_box_volume.p_physics->my_a = 0; // Should not be used.
        sprintf(this_box_volume.p_physics->name,"Vacuum");
    } else if (0 == strcmp(material_string,"exit") || 0 == strcmp(material_string,"Exit")) {
        // One could have a global physics struct for vacuum instead of creating one for each
        this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
        this_box_volume.p_physics->is_vacuum = 1; // Makes this volume a vacuum
        this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
        this_box_volume.p_physics->my_a = 0; // Should not be used.
        this_box_volume.geometry.is_exit_volume = 1;
        sprintf(this_box_volume.p_physics->name,"Exit");
    } else {
        #ifndef MATERIAL_DETECTOR
            printf("Need to define a material before refering to it in a geometry %s.\n",NAME_CURRENT_COMP);
            exit(1);
        #endif
        for (loop_index=0;loop_index<global_material_list.num_elements;loop_index++) {
            if (0 == strcmp(material_string,global_material_list.elements[loop_index].name)) {
                this_box_volume.p_physics = global_material_list.elements[loop_index].physics;
                break;
            }
            if (loop_index == global_material_list.num_elements-1) {
            printf("\n");
            printf("ERROR: The material string \"%s\" in Union geometry \"%s\" did not match a specified material. \n",material_string,NAME_CURRENT_COMP);
            printf("       The materials available at this point (need to be defined before the geometry): \n");
            for (loop_index=0;loop_index<global_material_list.num_elements;loop_index++)
              printf("         %s\n",global_material_list.elements[loop_index].name);
            printf("\n");
            printf("       It is also possible to use one of the defualt materials avaiable: \n");
            printf("           Vacuum (for a Volume without scattering or absorption)\n");
            printf("           Exit (for a Volume where the ray exits the component if it enters)\n");
            printf("           Mask (for a Volume that masks existing volumes specified in the mask_string\n");
            exit(1);
          }
        }
    }
} else {
    // Automatic linking, simply using the last defined material.
    #ifndef MATERIAL_DETECTOR
        printf("Need to define a material before the geometry to use automatic linking %s.\n",NAME_CURRENT_COMP);
        exit(1);
    #endif
    this_box_volume.p_physics = global_material_list.elements[global_material_list.num_elements-1].physics;
}

sprintf(this_box_volume.name,NAME_CURRENT_COMP);
sprintf(this_box_volume.geometry.shape,"box");
this_box_volume.geometry.priority_value = priority;
this_box_volume.geometry.geometry_p_interact = p_interact;
// Currently the coordinates will be in absolute space.
this_box_volume.geometry.center = POS_A_CURRENT_COMP;

this_box_storage.z_depth = zdepth;
this_box_storage.x_width1 = xwidth;
this_box_storage.y_height1 = yheight;

this_box_storage.is_rectangle = 0;
if (xwidth2 < 0 && yheight2 < 0) this_box_storage.is_rectangle = 1;
if (xwidth == xwidth2 && yheight == yheight2) this_box_storage.is_rectangle = 1;

if (xwidth2 < 0) {
    this_box_storage.x_width2 = xwidth;
    xwidth2 = xwidth;
} else this_box_storage.x_width2 = xwidth2;

if (yheight2 < 0) {
    this_box_storage.y_height2 = yheight;
    yheight2 = yheight;
} else this_box_storage.y_height2 = yheight2;


this_box_storage.normal_vectors[0] = coords_set(0,0,1);
this_box_storage.normal_vectors[1] = coords_set(0,0,1);

// for sides with y component = 0
x_component = 2*zdepth/sqrt((xwidth-xwidth2)*(xwidth-xwidth2)+4*zdepth*zdepth);
z_component = (xwidth-xwidth2)/sqrt(4*zdepth*zdepth+(xwidth-xwidth2)*(xwidth-xwidth2));

this_box_storage.normal_vectors[2] = coords_set(x_component,0,z_component);
this_box_storage.normal_vectors[3] = coords_set(-x_component,0,z_component);

// for sides with x component = 0
y_component = 2*zdepth/sqrt((yheight-yheight2)*(yheight-yheight2)+4*zdepth*zdepth);
z_component = (yheight-yheight2)/sqrt(4*zdepth*zdepth+(yheight-yheight2)*(yheight-yheight2));

this_box_storage.normal_vectors[4] = coords_set(0,y_component,z_component);
this_box_storage.normal_vectors[5] = coords_set(0,-y_component,z_component);

this_box_volume.geometry.visualization_on = visualize;

this_box_volume.geometry.geometry_parameters.p_box_storage = &this_box_storage;

// Assign pointers to functions for intersection with the shape, checking if a point is inside the shape
if (this_box_storage.is_rectangle == 1) {
this_box_volume.geometry.intersect_function = &sample_box_intersect_simple;
this_box_volume.geometry.within_function = &r_within_box_simple;
}
else {
this_box_volume.geometry.intersect_function = &sample_box_intersect_advanced;
this_box_volume.geometry.within_function = &r_within_box_advanced;
}

this_box_volume.geometry.shell_points = &box_shell_points;
this_box_volume.geometry.mcdisplay_function = &mcdisplay_box_function;
this_box_volume.geometry.initialize_from_main_function = &initialize_box_geometry_from_main_component;
this_box_volume.geometry.process_rot_allocated = 0;

this_box_volume.geometry.copy_geometry_parameters = &allocate_box_storage_copy;

rot_copy(this_box_volume.geometry.rotation_matrix,ROT_A_CURRENT_COMP); //check how ROT_R_CURRENT_COMP would work
rot_transpose(ROT_A_CURRENT_COMP,this_box_volume.geometry.transpose_rotation_matrix);

// Initialize loggers
this_box_volume.loggers.num_elements = 0;

// packing the information into the global_geometry_element, which is then included in the global_geometry_list.
sprintf(global_geometry_element.name,NAME_CURRENT_COMP);
global_geometry_element.activation_counter = number_of_activations;
global_geometry_element.component_index = INDEX_CURRENT_COMP;
global_geometry_element.Volume = &this_box_volume; // Would be nicer if this m was a pointer, now we have the (small) data two places
add_element_to_geometry_list(&global_geometry_list,global_geometry_element);
}
#line 300644 "MACS_sample_kidney_box.c"
#undef number_of_activations
#undef mask_setting
#undef mask_string
#undef p_interact
#undef focus_r
#undef focus_xh
#undef focus_xw
#undef focus_ah
#undef focus_aw
#undef target_z
#undef target_y
#undef target_x
#undef target_index
#undef visualize
#undef yheight2
#undef xwidth2
#undef zdepth
#undef yheight
#undef xwidth
#undef priority
#undef material_string
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

  /* Initializations for component channel_15_analyzer_2_array_crystal_array_2. */
  SIG_MESSAGE("channel_15_analyzer_2_array_crystal_array_2 (Init)");
#define mccompcurname  channel_15_analyzer_2_array_crystal_array_2
#define mccompcurtype  Union_box
#define mccompcurindex 713
#define loop_index mccchannel_15_analyzer_2_array_crystal_array_2_loop_index
#define this_box_volume mccchannel_15_analyzer_2_array_crystal_array_2_this_box_volume
#define global_geometry_element mccchannel_15_analyzer_2_array_crystal_array_2_global_geometry_element
#define this_box_storage mccchannel_15_analyzer_2_array_crystal_array_2_this_box_storage
#define material_string mccchannel_15_analyzer_2_array_crystal_array_2_material_string
#define priority mccchannel_15_analyzer_2_array_crystal_array_2_priority
#define xwidth mccchannel_15_analyzer_2_array_crystal_array_2_xwidth
#define yheight mccchannel_15_analyzer_2_array_crystal_array_2_yheight
#define zdepth mccchannel_15_analyzer_2_array_crystal_array_2_zdepth
#define xwidth2 mccchannel_15_analyzer_2_array_crystal_array_2_xwidth2
#define yheight2 mccchannel_15_analyzer_2_array_crystal_array_2_yheight2
#define visualize mccchannel_15_analyzer_2_array_crystal_array_2_visualize
#define target_index mccchannel_15_analyzer_2_array_crystal_array_2_target_index
#define target_x mccchannel_15_analyzer_2_array_crystal_array_2_target_x
#define target_y mccchannel_15_analyzer_2_array_crystal_array_2_target_y
#define target_z mccchannel_15_analyzer_2_array_crystal_array_2_target_z
#define focus_aw mccchannel_15_analyzer_2_array_crystal_array_2_focus_aw
#define focus_ah mccchannel_15_analyzer_2_array_crystal_array_2_focus_ah
#define focus_xw mccchannel_15_analyzer_2_array_crystal_array_2_focus_xw
#define focus_xh mccchannel_15_analyzer_2_array_crystal_array_2_focus_xh
#define focus_r mccchannel_15_analyzer_2_array_crystal_array_2_focus_r
#define p_interact mccchannel_15_analyzer_2_array_crystal_array_2_p_interact
#define mask_string mccchannel_15_analyzer_2_array_crystal_array_2_mask_string
#define mask_setting mccchannel_15_analyzer_2_array_crystal_array_2_mask_setting
#define number_of_activations mccchannel_15_analyzer_2_array_crystal_array_2_number_of_activations
#line 224 "Union_box.comp"
{
// Initializes the focusing system for this volume including input sanitation.
focus_initialize(&this_box_volume.geometry, POS_A_COMP_INDEX(INDEX_CURRENT_COMP+target_index), POS_A_CURRENT_COMP, ROT_A_CURRENT_COMP, target_index, target_x, target_y, target_z, focus_aw, focus_ah, focus_xw, focus_xh, focus_r, NAME_CURRENT_COMP);

// Input sanitation for this geometry
if (xwidth <= 0) {
  printf("\nERROR in Union_box named %s, the xwidth is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (yheight <= 0) {
  printf("\nERROR in Union_box named %s, yheight is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (zdepth <= 0) {
  printf("\nERROR in Union_box named %s, zdepth is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (xwidth2 <= 0 && xwidth2 != -1) {
  printf("\nERROR in Union_box named %s, the xwidth2 is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (yheight2 <= 0 && yheight2 != -1) {
  printf("\nERROR in Union_box named %s, yheight2 is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}

// Use sanitation
if (global_material_list.num_elements == 0) {
  printf("\nERROR: Need to define a material using Union_make_material before using a Union geometry component. \n");
  printf("       %s was defined before first use of Union_make_material.\n",NAME_CURRENT_COMP);
  exit(1);
}

this_box_volume.geometry.is_masked_volume = 0;
this_box_volume.geometry.is_exit_volume = 0;
this_box_volume.geometry.is_mask_volume = 0;
// check if the volume is a mask, if it is the material string is irelevant.
if (mask_string && strlen(mask_string) && strcmp(mask_string, "NULL") && strcmp(mask_string, "0")) {
    // A mask volume is used to limit the extend of other volumes, called the masked volumes. These are specified in the mask_string.
    // In order for a ray to enter a masked volume, it needs to be both in the region covered by that volume AND the mask volume.
    // When more than
    this_box_volume.geometry.mask_mode = 1; // Default is mask mode is ALL
    if (mask_setting && strlen(mask_setting) && strcmp(mask_setting, "NULL") && strcmp(mask_setting, "0")) {
        if (strcmp(mask_setting,"ALL") == 0 || strcmp(mask_setting,"All") == 0) this_box_volume.geometry.mask_mode = 1;
        else if (strcmp(mask_setting,"ANY") == 0 || strcmp(mask_setting,"Any") == 0) this_box_volume.geometry.mask_mode = 2;
        else {
            printf("The mask_mode of component %s is set to %s, but must be either ALL or ANY.\n",NAME_CURRENT_COMP,mask_setting);
            exit(1);
        }
    }
    
    for (loop_index=0;loop_index<global_geometry_list.num_elements;loop_index++) {
        // Add mask list
        if (1 == manual_linking_function(global_geometry_list.elements[loop_index].name,mask_string)) {
            add_element_to_int_list(&this_box_volume.geometry.mask_list,global_geometry_list.elements[loop_index].component_index);
            add_element_to_int_list(&global_geometry_list.elements[loop_index].Volume->geometry.masked_by_list,INDEX_CURRENT_COMP);
            global_geometry_list.elements[loop_index].Volume->geometry.is_masked_volume = 1;
            if (this_box_volume.geometry.mask_mode == 2)
                global_geometry_list.elements[loop_index].Volume->geometry.mask_mode = 2;
            if (this_box_volume.geometry.mask_mode == 1) {
                if (global_geometry_list.elements[loop_index].Volume->geometry.is_masked_volume == 1 && global_geometry_list.elements[loop_index].Volume->geometry.mask_mode != 2)
                    // If more than one mask is added to one volume, the ANY mode overwrites the (default) ALL mode.
                    global_geometry_list.elements[loop_index].Volume->geometry.mask_mode = 1;
            }
            
            found_geometries = 1;
        }
    }
    if (found_geometries == 0) {
        printf("The mask_string in geometry: %s did not find any of the specified volumes in the mask_string %s \n",NAME_CURRENT_COMP,mask_string);
        exit(1);
    }
    this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
    this_box_volume.p_physics->is_vacuum = 0; // Makes this volume a vacuum
    this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
    this_box_volume.p_physics->my_a = 0; // Should not be used.
    sprintf(this_box_volume.p_physics->name,"Mask");
    this_box_volume.geometry.is_mask_volume = 1;
    
    
// Read the material input, or if it lacks, use automatic linking.
} else if (material_string && strlen(material_string) && strcmp(material_string, "NULL") && strcmp(material_string, "0")) {
    // A geometry string was given, use it to determine which material
    if (0 == strcmp(material_string,"vacuum") || 0 == strcmp(material_string,"Vacuum")) {
        // One could have a global physics struct for vacuum instead of creating one for each
        this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
        this_box_volume.p_physics->is_vacuum = 1; // Makes this volume a vacuum
        this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
        this_box_volume.p_physics->my_a = 0; // Should not be used.
        sprintf(this_box_volume.p_physics->name,"Vacuum");
    } else if (0 == strcmp(material_string,"exit") || 0 == strcmp(material_string,"Exit")) {
        // One could have a global physics struct for vacuum instead of creating one for each
        this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
        this_box_volume.p_physics->is_vacuum = 1; // Makes this volume a vacuum
        this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
        this_box_volume.p_physics->my_a = 0; // Should not be used.
        this_box_volume.geometry.is_exit_volume = 1;
        sprintf(this_box_volume.p_physics->name,"Exit");
    } else {
        #ifndef MATERIAL_DETECTOR
            printf("Need to define a material before refering to it in a geometry %s.\n",NAME_CURRENT_COMP);
            exit(1);
        #endif
        for (loop_index=0;loop_index<global_material_list.num_elements;loop_index++) {
            if (0 == strcmp(material_string,global_material_list.elements[loop_index].name)) {
                this_box_volume.p_physics = global_material_list.elements[loop_index].physics;
                break;
            }
            if (loop_index == global_material_list.num_elements-1) {
            printf("\n");
            printf("ERROR: The material string \"%s\" in Union geometry \"%s\" did not match a specified material. \n",material_string,NAME_CURRENT_COMP);
            printf("       The materials available at this point (need to be defined before the geometry): \n");
            for (loop_index=0;loop_index<global_material_list.num_elements;loop_index++)
              printf("         %s\n",global_material_list.elements[loop_index].name);
            printf("\n");
            printf("       It is also possible to use one of the defualt materials avaiable: \n");
            printf("           Vacuum (for a Volume without scattering or absorption)\n");
            printf("           Exit (for a Volume where the ray exits the component if it enters)\n");
            printf("           Mask (for a Volume that masks existing volumes specified in the mask_string\n");
            exit(1);
          }
        }
    }
} else {
    // Automatic linking, simply using the last defined material.
    #ifndef MATERIAL_DETECTOR
        printf("Need to define a material before the geometry to use automatic linking %s.\n",NAME_CURRENT_COMP);
        exit(1);
    #endif
    this_box_volume.p_physics = global_material_list.elements[global_material_list.num_elements-1].physics;
}

sprintf(this_box_volume.name,NAME_CURRENT_COMP);
sprintf(this_box_volume.geometry.shape,"box");
this_box_volume.geometry.priority_value = priority;
this_box_volume.geometry.geometry_p_interact = p_interact;
// Currently the coordinates will be in absolute space.
this_box_volume.geometry.center = POS_A_CURRENT_COMP;

this_box_storage.z_depth = zdepth;
this_box_storage.x_width1 = xwidth;
this_box_storage.y_height1 = yheight;

this_box_storage.is_rectangle = 0;
if (xwidth2 < 0 && yheight2 < 0) this_box_storage.is_rectangle = 1;
if (xwidth == xwidth2 && yheight == yheight2) this_box_storage.is_rectangle = 1;

if (xwidth2 < 0) {
    this_box_storage.x_width2 = xwidth;
    xwidth2 = xwidth;
} else this_box_storage.x_width2 = xwidth2;

if (yheight2 < 0) {
    this_box_storage.y_height2 = yheight;
    yheight2 = yheight;
} else this_box_storage.y_height2 = yheight2;


this_box_storage.normal_vectors[0] = coords_set(0,0,1);
this_box_storage.normal_vectors[1] = coords_set(0,0,1);

// for sides with y component = 0
x_component = 2*zdepth/sqrt((xwidth-xwidth2)*(xwidth-xwidth2)+4*zdepth*zdepth);
z_component = (xwidth-xwidth2)/sqrt(4*zdepth*zdepth+(xwidth-xwidth2)*(xwidth-xwidth2));

this_box_storage.normal_vectors[2] = coords_set(x_component,0,z_component);
this_box_storage.normal_vectors[3] = coords_set(-x_component,0,z_component);

// for sides with x component = 0
y_component = 2*zdepth/sqrt((yheight-yheight2)*(yheight-yheight2)+4*zdepth*zdepth);
z_component = (yheight-yheight2)/sqrt(4*zdepth*zdepth+(yheight-yheight2)*(yheight-yheight2));

this_box_storage.normal_vectors[4] = coords_set(0,y_component,z_component);
this_box_storage.normal_vectors[5] = coords_set(0,-y_component,z_component);

this_box_volume.geometry.visualization_on = visualize;

this_box_volume.geometry.geometry_parameters.p_box_storage = &this_box_storage;

// Assign pointers to functions for intersection with the shape, checking if a point is inside the shape
if (this_box_storage.is_rectangle == 1) {
this_box_volume.geometry.intersect_function = &sample_box_intersect_simple;
this_box_volume.geometry.within_function = &r_within_box_simple;
}
else {
this_box_volume.geometry.intersect_function = &sample_box_intersect_advanced;
this_box_volume.geometry.within_function = &r_within_box_advanced;
}

this_box_volume.geometry.shell_points = &box_shell_points;
this_box_volume.geometry.mcdisplay_function = &mcdisplay_box_function;
this_box_volume.geometry.initialize_from_main_function = &initialize_box_geometry_from_main_component;
this_box_volume.geometry.process_rot_allocated = 0;

this_box_volume.geometry.copy_geometry_parameters = &allocate_box_storage_copy;

rot_copy(this_box_volume.geometry.rotation_matrix,ROT_A_CURRENT_COMP); //check how ROT_R_CURRENT_COMP would work
rot_transpose(ROT_A_CURRENT_COMP,this_box_volume.geometry.transpose_rotation_matrix);

// Initialize loggers
this_box_volume.loggers.num_elements = 0;

// packing the information into the global_geometry_element, which is then included in the global_geometry_list.
sprintf(global_geometry_element.name,NAME_CURRENT_COMP);
global_geometry_element.activation_counter = number_of_activations;
global_geometry_element.component_index = INDEX_CURRENT_COMP;
global_geometry_element.Volume = &this_box_volume; // Would be nicer if this m was a pointer, now we have the (small) data two places
add_element_to_geometry_list(&global_geometry_list,global_geometry_element);
}
#line 300914 "MACS_sample_kidney_box.c"
#undef number_of_activations
#undef mask_setting
#undef mask_string
#undef p_interact
#undef focus_r
#undef focus_xh
#undef focus_xw
#undef focus_ah
#undef focus_aw
#undef target_z
#undef target_y
#undef target_x
#undef target_index
#undef visualize
#undef yheight2
#undef xwidth2
#undef zdepth
#undef yheight
#undef xwidth
#undef priority
#undef material_string
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

  /* Initializations for component channel_15_analyzer_2_array_crystal_array_3. */
  SIG_MESSAGE("channel_15_analyzer_2_array_crystal_array_3 (Init)");
#define mccompcurname  channel_15_analyzer_2_array_crystal_array_3
#define mccompcurtype  Union_box
#define mccompcurindex 714
#define loop_index mccchannel_15_analyzer_2_array_crystal_array_3_loop_index
#define this_box_volume mccchannel_15_analyzer_2_array_crystal_array_3_this_box_volume
#define global_geometry_element mccchannel_15_analyzer_2_array_crystal_array_3_global_geometry_element
#define this_box_storage mccchannel_15_analyzer_2_array_crystal_array_3_this_box_storage
#define material_string mccchannel_15_analyzer_2_array_crystal_array_3_material_string
#define priority mccchannel_15_analyzer_2_array_crystal_array_3_priority
#define xwidth mccchannel_15_analyzer_2_array_crystal_array_3_xwidth
#define yheight mccchannel_15_analyzer_2_array_crystal_array_3_yheight
#define zdepth mccchannel_15_analyzer_2_array_crystal_array_3_zdepth
#define xwidth2 mccchannel_15_analyzer_2_array_crystal_array_3_xwidth2
#define yheight2 mccchannel_15_analyzer_2_array_crystal_array_3_yheight2
#define visualize mccchannel_15_analyzer_2_array_crystal_array_3_visualize
#define target_index mccchannel_15_analyzer_2_array_crystal_array_3_target_index
#define target_x mccchannel_15_analyzer_2_array_crystal_array_3_target_x
#define target_y mccchannel_15_analyzer_2_array_crystal_array_3_target_y
#define target_z mccchannel_15_analyzer_2_array_crystal_array_3_target_z
#define focus_aw mccchannel_15_analyzer_2_array_crystal_array_3_focus_aw
#define focus_ah mccchannel_15_analyzer_2_array_crystal_array_3_focus_ah
#define focus_xw mccchannel_15_analyzer_2_array_crystal_array_3_focus_xw
#define focus_xh mccchannel_15_analyzer_2_array_crystal_array_3_focus_xh
#define focus_r mccchannel_15_analyzer_2_array_crystal_array_3_focus_r
#define p_interact mccchannel_15_analyzer_2_array_crystal_array_3_p_interact
#define mask_string mccchannel_15_analyzer_2_array_crystal_array_3_mask_string
#define mask_setting mccchannel_15_analyzer_2_array_crystal_array_3_mask_setting
#define number_of_activations mccchannel_15_analyzer_2_array_crystal_array_3_number_of_activations
#line 224 "Union_box.comp"
{
// Initializes the focusing system for this volume including input sanitation.
focus_initialize(&this_box_volume.geometry, POS_A_COMP_INDEX(INDEX_CURRENT_COMP+target_index), POS_A_CURRENT_COMP, ROT_A_CURRENT_COMP, target_index, target_x, target_y, target_z, focus_aw, focus_ah, focus_xw, focus_xh, focus_r, NAME_CURRENT_COMP);

// Input sanitation for this geometry
if (xwidth <= 0) {
  printf("\nERROR in Union_box named %s, the xwidth is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (yheight <= 0) {
  printf("\nERROR in Union_box named %s, yheight is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (zdepth <= 0) {
  printf("\nERROR in Union_box named %s, zdepth is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (xwidth2 <= 0 && xwidth2 != -1) {
  printf("\nERROR in Union_box named %s, the xwidth2 is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (yheight2 <= 0 && yheight2 != -1) {
  printf("\nERROR in Union_box named %s, yheight2 is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}

// Use sanitation
if (global_material_list.num_elements == 0) {
  printf("\nERROR: Need to define a material using Union_make_material before using a Union geometry component. \n");
  printf("       %s was defined before first use of Union_make_material.\n",NAME_CURRENT_COMP);
  exit(1);
}

this_box_volume.geometry.is_masked_volume = 0;
this_box_volume.geometry.is_exit_volume = 0;
this_box_volume.geometry.is_mask_volume = 0;
// check if the volume is a mask, if it is the material string is irelevant.
if (mask_string && strlen(mask_string) && strcmp(mask_string, "NULL") && strcmp(mask_string, "0")) {
    // A mask volume is used to limit the extend of other volumes, called the masked volumes. These are specified in the mask_string.
    // In order for a ray to enter a masked volume, it needs to be both in the region covered by that volume AND the mask volume.
    // When more than
    this_box_volume.geometry.mask_mode = 1; // Default is mask mode is ALL
    if (mask_setting && strlen(mask_setting) && strcmp(mask_setting, "NULL") && strcmp(mask_setting, "0")) {
        if (strcmp(mask_setting,"ALL") == 0 || strcmp(mask_setting,"All") == 0) this_box_volume.geometry.mask_mode = 1;
        else if (strcmp(mask_setting,"ANY") == 0 || strcmp(mask_setting,"Any") == 0) this_box_volume.geometry.mask_mode = 2;
        else {
            printf("The mask_mode of component %s is set to %s, but must be either ALL or ANY.\n",NAME_CURRENT_COMP,mask_setting);
            exit(1);
        }
    }
    
    for (loop_index=0;loop_index<global_geometry_list.num_elements;loop_index++) {
        // Add mask list
        if (1 == manual_linking_function(global_geometry_list.elements[loop_index].name,mask_string)) {
            add_element_to_int_list(&this_box_volume.geometry.mask_list,global_geometry_list.elements[loop_index].component_index);
            add_element_to_int_list(&global_geometry_list.elements[loop_index].Volume->geometry.masked_by_list,INDEX_CURRENT_COMP);
            global_geometry_list.elements[loop_index].Volume->geometry.is_masked_volume = 1;
            if (this_box_volume.geometry.mask_mode == 2)
                global_geometry_list.elements[loop_index].Volume->geometry.mask_mode = 2;
            if (this_box_volume.geometry.mask_mode == 1) {
                if (global_geometry_list.elements[loop_index].Volume->geometry.is_masked_volume == 1 && global_geometry_list.elements[loop_index].Volume->geometry.mask_mode != 2)
                    // If more than one mask is added to one volume, the ANY mode overwrites the (default) ALL mode.
                    global_geometry_list.elements[loop_index].Volume->geometry.mask_mode = 1;
            }
            
            found_geometries = 1;
        }
    }
    if (found_geometries == 0) {
        printf("The mask_string in geometry: %s did not find any of the specified volumes in the mask_string %s \n",NAME_CURRENT_COMP,mask_string);
        exit(1);
    }
    this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
    this_box_volume.p_physics->is_vacuum = 0; // Makes this volume a vacuum
    this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
    this_box_volume.p_physics->my_a = 0; // Should not be used.
    sprintf(this_box_volume.p_physics->name,"Mask");
    this_box_volume.geometry.is_mask_volume = 1;
    
    
// Read the material input, or if it lacks, use automatic linking.
} else if (material_string && strlen(material_string) && strcmp(material_string, "NULL") && strcmp(material_string, "0")) {
    // A geometry string was given, use it to determine which material
    if (0 == strcmp(material_string,"vacuum") || 0 == strcmp(material_string,"Vacuum")) {
        // One could have a global physics struct for vacuum instead of creating one for each
        this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
        this_box_volume.p_physics->is_vacuum = 1; // Makes this volume a vacuum
        this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
        this_box_volume.p_physics->my_a = 0; // Should not be used.
        sprintf(this_box_volume.p_physics->name,"Vacuum");
    } else if (0 == strcmp(material_string,"exit") || 0 == strcmp(material_string,"Exit")) {
        // One could have a global physics struct for vacuum instead of creating one for each
        this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
        this_box_volume.p_physics->is_vacuum = 1; // Makes this volume a vacuum
        this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
        this_box_volume.p_physics->my_a = 0; // Should not be used.
        this_box_volume.geometry.is_exit_volume = 1;
        sprintf(this_box_volume.p_physics->name,"Exit");
    } else {
        #ifndef MATERIAL_DETECTOR
            printf("Need to define a material before refering to it in a geometry %s.\n",NAME_CURRENT_COMP);
            exit(1);
        #endif
        for (loop_index=0;loop_index<global_material_list.num_elements;loop_index++) {
            if (0 == strcmp(material_string,global_material_list.elements[loop_index].name)) {
                this_box_volume.p_physics = global_material_list.elements[loop_index].physics;
                break;
            }
            if (loop_index == global_material_list.num_elements-1) {
            printf("\n");
            printf("ERROR: The material string \"%s\" in Union geometry \"%s\" did not match a specified material. \n",material_string,NAME_CURRENT_COMP);
            printf("       The materials available at this point (need to be defined before the geometry): \n");
            for (loop_index=0;loop_index<global_material_list.num_elements;loop_index++)
              printf("         %s\n",global_material_list.elements[loop_index].name);
            printf("\n");
            printf("       It is also possible to use one of the defualt materials avaiable: \n");
            printf("           Vacuum (for a Volume without scattering or absorption)\n");
            printf("           Exit (for a Volume where the ray exits the component if it enters)\n");
            printf("           Mask (for a Volume that masks existing volumes specified in the mask_string\n");
            exit(1);
          }
        }
    }
} else {
    // Automatic linking, simply using the last defined material.
    #ifndef MATERIAL_DETECTOR
        printf("Need to define a material before the geometry to use automatic linking %s.\n",NAME_CURRENT_COMP);
        exit(1);
    #endif
    this_box_volume.p_physics = global_material_list.elements[global_material_list.num_elements-1].physics;
}

sprintf(this_box_volume.name,NAME_CURRENT_COMP);
sprintf(this_box_volume.geometry.shape,"box");
this_box_volume.geometry.priority_value = priority;
this_box_volume.geometry.geometry_p_interact = p_interact;
// Currently the coordinates will be in absolute space.
this_box_volume.geometry.center = POS_A_CURRENT_COMP;

this_box_storage.z_depth = zdepth;
this_box_storage.x_width1 = xwidth;
this_box_storage.y_height1 = yheight;

this_box_storage.is_rectangle = 0;
if (xwidth2 < 0 && yheight2 < 0) this_box_storage.is_rectangle = 1;
if (xwidth == xwidth2 && yheight == yheight2) this_box_storage.is_rectangle = 1;

if (xwidth2 < 0) {
    this_box_storage.x_width2 = xwidth;
    xwidth2 = xwidth;
} else this_box_storage.x_width2 = xwidth2;

if (yheight2 < 0) {
    this_box_storage.y_height2 = yheight;
    yheight2 = yheight;
} else this_box_storage.y_height2 = yheight2;


this_box_storage.normal_vectors[0] = coords_set(0,0,1);
this_box_storage.normal_vectors[1] = coords_set(0,0,1);

// for sides with y component = 0
x_component = 2*zdepth/sqrt((xwidth-xwidth2)*(xwidth-xwidth2)+4*zdepth*zdepth);
z_component = (xwidth-xwidth2)/sqrt(4*zdepth*zdepth+(xwidth-xwidth2)*(xwidth-xwidth2));

this_box_storage.normal_vectors[2] = coords_set(x_component,0,z_component);
this_box_storage.normal_vectors[3] = coords_set(-x_component,0,z_component);

// for sides with x component = 0
y_component = 2*zdepth/sqrt((yheight-yheight2)*(yheight-yheight2)+4*zdepth*zdepth);
z_component = (yheight-yheight2)/sqrt(4*zdepth*zdepth+(yheight-yheight2)*(yheight-yheight2));

this_box_storage.normal_vectors[4] = coords_set(0,y_component,z_component);
this_box_storage.normal_vectors[5] = coords_set(0,-y_component,z_component);

this_box_volume.geometry.visualization_on = visualize;

this_box_volume.geometry.geometry_parameters.p_box_storage = &this_box_storage;

// Assign pointers to functions for intersection with the shape, checking if a point is inside the shape
if (this_box_storage.is_rectangle == 1) {
this_box_volume.geometry.intersect_function = &sample_box_intersect_simple;
this_box_volume.geometry.within_function = &r_within_box_simple;
}
else {
this_box_volume.geometry.intersect_function = &sample_box_intersect_advanced;
this_box_volume.geometry.within_function = &r_within_box_advanced;
}

this_box_volume.geometry.shell_points = &box_shell_points;
this_box_volume.geometry.mcdisplay_function = &mcdisplay_box_function;
this_box_volume.geometry.initialize_from_main_function = &initialize_box_geometry_from_main_component;
this_box_volume.geometry.process_rot_allocated = 0;

this_box_volume.geometry.copy_geometry_parameters = &allocate_box_storage_copy;

rot_copy(this_box_volume.geometry.rotation_matrix,ROT_A_CURRENT_COMP); //check how ROT_R_CURRENT_COMP would work
rot_transpose(ROT_A_CURRENT_COMP,this_box_volume.geometry.transpose_rotation_matrix);

// Initialize loggers
this_box_volume.loggers.num_elements = 0;

// packing the information into the global_geometry_element, which is then included in the global_geometry_list.
sprintf(global_geometry_element.name,NAME_CURRENT_COMP);
global_geometry_element.activation_counter = number_of_activations;
global_geometry_element.component_index = INDEX_CURRENT_COMP;
global_geometry_element.Volume = &this_box_volume; // Would be nicer if this m was a pointer, now we have the (small) data two places
add_element_to_geometry_list(&global_geometry_list,global_geometry_element);
}
#line 301184 "MACS_sample_kidney_box.c"
#undef number_of_activations
#undef mask_setting
#undef mask_string
#undef p_interact
#undef focus_r
#undef focus_xh
#undef focus_xw
#undef focus_ah
#undef focus_aw
#undef target_z
#undef target_y
#undef target_x
#undef target_index
#undef visualize
#undef yheight2
#undef xwidth2
#undef zdepth
#undef yheight
#undef xwidth
#undef priority
#undef material_string
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

  /* Initializations for component channel_15_analyzer_2_array_crystal_array_4. */
  SIG_MESSAGE("channel_15_analyzer_2_array_crystal_array_4 (Init)");
#define mccompcurname  channel_15_analyzer_2_array_crystal_array_4
#define mccompcurtype  Union_box
#define mccompcurindex 715
#define loop_index mccchannel_15_analyzer_2_array_crystal_array_4_loop_index
#define this_box_volume mccchannel_15_analyzer_2_array_crystal_array_4_this_box_volume
#define global_geometry_element mccchannel_15_analyzer_2_array_crystal_array_4_global_geometry_element
#define this_box_storage mccchannel_15_analyzer_2_array_crystal_array_4_this_box_storage
#define material_string mccchannel_15_analyzer_2_array_crystal_array_4_material_string
#define priority mccchannel_15_analyzer_2_array_crystal_array_4_priority
#define xwidth mccchannel_15_analyzer_2_array_crystal_array_4_xwidth
#define yheight mccchannel_15_analyzer_2_array_crystal_array_4_yheight
#define zdepth mccchannel_15_analyzer_2_array_crystal_array_4_zdepth
#define xwidth2 mccchannel_15_analyzer_2_array_crystal_array_4_xwidth2
#define yheight2 mccchannel_15_analyzer_2_array_crystal_array_4_yheight2
#define visualize mccchannel_15_analyzer_2_array_crystal_array_4_visualize
#define target_index mccchannel_15_analyzer_2_array_crystal_array_4_target_index
#define target_x mccchannel_15_analyzer_2_array_crystal_array_4_target_x
#define target_y mccchannel_15_analyzer_2_array_crystal_array_4_target_y
#define target_z mccchannel_15_analyzer_2_array_crystal_array_4_target_z
#define focus_aw mccchannel_15_analyzer_2_array_crystal_array_4_focus_aw
#define focus_ah mccchannel_15_analyzer_2_array_crystal_array_4_focus_ah
#define focus_xw mccchannel_15_analyzer_2_array_crystal_array_4_focus_xw
#define focus_xh mccchannel_15_analyzer_2_array_crystal_array_4_focus_xh
#define focus_r mccchannel_15_analyzer_2_array_crystal_array_4_focus_r
#define p_interact mccchannel_15_analyzer_2_array_crystal_array_4_p_interact
#define mask_string mccchannel_15_analyzer_2_array_crystal_array_4_mask_string
#define mask_setting mccchannel_15_analyzer_2_array_crystal_array_4_mask_setting
#define number_of_activations mccchannel_15_analyzer_2_array_crystal_array_4_number_of_activations
#line 224 "Union_box.comp"
{
// Initializes the focusing system for this volume including input sanitation.
focus_initialize(&this_box_volume.geometry, POS_A_COMP_INDEX(INDEX_CURRENT_COMP+target_index), POS_A_CURRENT_COMP, ROT_A_CURRENT_COMP, target_index, target_x, target_y, target_z, focus_aw, focus_ah, focus_xw, focus_xh, focus_r, NAME_CURRENT_COMP);

// Input sanitation for this geometry
if (xwidth <= 0) {
  printf("\nERROR in Union_box named %s, the xwidth is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (yheight <= 0) {
  printf("\nERROR in Union_box named %s, yheight is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (zdepth <= 0) {
  printf("\nERROR in Union_box named %s, zdepth is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (xwidth2 <= 0 && xwidth2 != -1) {
  printf("\nERROR in Union_box named %s, the xwidth2 is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (yheight2 <= 0 && yheight2 != -1) {
  printf("\nERROR in Union_box named %s, yheight2 is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}

// Use sanitation
if (global_material_list.num_elements == 0) {
  printf("\nERROR: Need to define a material using Union_make_material before using a Union geometry component. \n");
  printf("       %s was defined before first use of Union_make_material.\n",NAME_CURRENT_COMP);
  exit(1);
}

this_box_volume.geometry.is_masked_volume = 0;
this_box_volume.geometry.is_exit_volume = 0;
this_box_volume.geometry.is_mask_volume = 0;
// check if the volume is a mask, if it is the material string is irelevant.
if (mask_string && strlen(mask_string) && strcmp(mask_string, "NULL") && strcmp(mask_string, "0")) {
    // A mask volume is used to limit the extend of other volumes, called the masked volumes. These are specified in the mask_string.
    // In order for a ray to enter a masked volume, it needs to be both in the region covered by that volume AND the mask volume.
    // When more than
    this_box_volume.geometry.mask_mode = 1; // Default is mask mode is ALL
    if (mask_setting && strlen(mask_setting) && strcmp(mask_setting, "NULL") && strcmp(mask_setting, "0")) {
        if (strcmp(mask_setting,"ALL") == 0 || strcmp(mask_setting,"All") == 0) this_box_volume.geometry.mask_mode = 1;
        else if (strcmp(mask_setting,"ANY") == 0 || strcmp(mask_setting,"Any") == 0) this_box_volume.geometry.mask_mode = 2;
        else {
            printf("The mask_mode of component %s is set to %s, but must be either ALL or ANY.\n",NAME_CURRENT_COMP,mask_setting);
            exit(1);
        }
    }
    
    for (loop_index=0;loop_index<global_geometry_list.num_elements;loop_index++) {
        // Add mask list
        if (1 == manual_linking_function(global_geometry_list.elements[loop_index].name,mask_string)) {
            add_element_to_int_list(&this_box_volume.geometry.mask_list,global_geometry_list.elements[loop_index].component_index);
            add_element_to_int_list(&global_geometry_list.elements[loop_index].Volume->geometry.masked_by_list,INDEX_CURRENT_COMP);
            global_geometry_list.elements[loop_index].Volume->geometry.is_masked_volume = 1;
            if (this_box_volume.geometry.mask_mode == 2)
                global_geometry_list.elements[loop_index].Volume->geometry.mask_mode = 2;
            if (this_box_volume.geometry.mask_mode == 1) {
                if (global_geometry_list.elements[loop_index].Volume->geometry.is_masked_volume == 1 && global_geometry_list.elements[loop_index].Volume->geometry.mask_mode != 2)
                    // If more than one mask is added to one volume, the ANY mode overwrites the (default) ALL mode.
                    global_geometry_list.elements[loop_index].Volume->geometry.mask_mode = 1;
            }
            
            found_geometries = 1;
        }
    }
    if (found_geometries == 0) {
        printf("The mask_string in geometry: %s did not find any of the specified volumes in the mask_string %s \n",NAME_CURRENT_COMP,mask_string);
        exit(1);
    }
    this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
    this_box_volume.p_physics->is_vacuum = 0; // Makes this volume a vacuum
    this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
    this_box_volume.p_physics->my_a = 0; // Should not be used.
    sprintf(this_box_volume.p_physics->name,"Mask");
    this_box_volume.geometry.is_mask_volume = 1;
    
    
// Read the material input, or if it lacks, use automatic linking.
} else if (material_string && strlen(material_string) && strcmp(material_string, "NULL") && strcmp(material_string, "0")) {
    // A geometry string was given, use it to determine which material
    if (0 == strcmp(material_string,"vacuum") || 0 == strcmp(material_string,"Vacuum")) {
        // One could have a global physics struct for vacuum instead of creating one for each
        this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
        this_box_volume.p_physics->is_vacuum = 1; // Makes this volume a vacuum
        this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
        this_box_volume.p_physics->my_a = 0; // Should not be used.
        sprintf(this_box_volume.p_physics->name,"Vacuum");
    } else if (0 == strcmp(material_string,"exit") || 0 == strcmp(material_string,"Exit")) {
        // One could have a global physics struct for vacuum instead of creating one for each
        this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
        this_box_volume.p_physics->is_vacuum = 1; // Makes this volume a vacuum
        this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
        this_box_volume.p_physics->my_a = 0; // Should not be used.
        this_box_volume.geometry.is_exit_volume = 1;
        sprintf(this_box_volume.p_physics->name,"Exit");
    } else {
        #ifndef MATERIAL_DETECTOR
            printf("Need to define a material before refering to it in a geometry %s.\n",NAME_CURRENT_COMP);
            exit(1);
        #endif
        for (loop_index=0;loop_index<global_material_list.num_elements;loop_index++) {
            if (0 == strcmp(material_string,global_material_list.elements[loop_index].name)) {
                this_box_volume.p_physics = global_material_list.elements[loop_index].physics;
                break;
            }
            if (loop_index == global_material_list.num_elements-1) {
            printf("\n");
            printf("ERROR: The material string \"%s\" in Union geometry \"%s\" did not match a specified material. \n",material_string,NAME_CURRENT_COMP);
            printf("       The materials available at this point (need to be defined before the geometry): \n");
            for (loop_index=0;loop_index<global_material_list.num_elements;loop_index++)
              printf("         %s\n",global_material_list.elements[loop_index].name);
            printf("\n");
            printf("       It is also possible to use one of the defualt materials avaiable: \n");
            printf("           Vacuum (for a Volume without scattering or absorption)\n");
            printf("           Exit (for a Volume where the ray exits the component if it enters)\n");
            printf("           Mask (for a Volume that masks existing volumes specified in the mask_string\n");
            exit(1);
          }
        }
    }
} else {
    // Automatic linking, simply using the last defined material.
    #ifndef MATERIAL_DETECTOR
        printf("Need to define a material before the geometry to use automatic linking %s.\n",NAME_CURRENT_COMP);
        exit(1);
    #endif
    this_box_volume.p_physics = global_material_list.elements[global_material_list.num_elements-1].physics;
}

sprintf(this_box_volume.name,NAME_CURRENT_COMP);
sprintf(this_box_volume.geometry.shape,"box");
this_box_volume.geometry.priority_value = priority;
this_box_volume.geometry.geometry_p_interact = p_interact;
// Currently the coordinates will be in absolute space.
this_box_volume.geometry.center = POS_A_CURRENT_COMP;

this_box_storage.z_depth = zdepth;
this_box_storage.x_width1 = xwidth;
this_box_storage.y_height1 = yheight;

this_box_storage.is_rectangle = 0;
if (xwidth2 < 0 && yheight2 < 0) this_box_storage.is_rectangle = 1;
if (xwidth == xwidth2 && yheight == yheight2) this_box_storage.is_rectangle = 1;

if (xwidth2 < 0) {
    this_box_storage.x_width2 = xwidth;
    xwidth2 = xwidth;
} else this_box_storage.x_width2 = xwidth2;

if (yheight2 < 0) {
    this_box_storage.y_height2 = yheight;
    yheight2 = yheight;
} else this_box_storage.y_height2 = yheight2;


this_box_storage.normal_vectors[0] = coords_set(0,0,1);
this_box_storage.normal_vectors[1] = coords_set(0,0,1);

// for sides with y component = 0
x_component = 2*zdepth/sqrt((xwidth-xwidth2)*(xwidth-xwidth2)+4*zdepth*zdepth);
z_component = (xwidth-xwidth2)/sqrt(4*zdepth*zdepth+(xwidth-xwidth2)*(xwidth-xwidth2));

this_box_storage.normal_vectors[2] = coords_set(x_component,0,z_component);
this_box_storage.normal_vectors[3] = coords_set(-x_component,0,z_component);

// for sides with x component = 0
y_component = 2*zdepth/sqrt((yheight-yheight2)*(yheight-yheight2)+4*zdepth*zdepth);
z_component = (yheight-yheight2)/sqrt(4*zdepth*zdepth+(yheight-yheight2)*(yheight-yheight2));

this_box_storage.normal_vectors[4] = coords_set(0,y_component,z_component);
this_box_storage.normal_vectors[5] = coords_set(0,-y_component,z_component);

this_box_volume.geometry.visualization_on = visualize;

this_box_volume.geometry.geometry_parameters.p_box_storage = &this_box_storage;

// Assign pointers to functions for intersection with the shape, checking if a point is inside the shape
if (this_box_storage.is_rectangle == 1) {
this_box_volume.geometry.intersect_function = &sample_box_intersect_simple;
this_box_volume.geometry.within_function = &r_within_box_simple;
}
else {
this_box_volume.geometry.intersect_function = &sample_box_intersect_advanced;
this_box_volume.geometry.within_function = &r_within_box_advanced;
}

this_box_volume.geometry.shell_points = &box_shell_points;
this_box_volume.geometry.mcdisplay_function = &mcdisplay_box_function;
this_box_volume.geometry.initialize_from_main_function = &initialize_box_geometry_from_main_component;
this_box_volume.geometry.process_rot_allocated = 0;

this_box_volume.geometry.copy_geometry_parameters = &allocate_box_storage_copy;

rot_copy(this_box_volume.geometry.rotation_matrix,ROT_A_CURRENT_COMP); //check how ROT_R_CURRENT_COMP would work
rot_transpose(ROT_A_CURRENT_COMP,this_box_volume.geometry.transpose_rotation_matrix);

// Initialize loggers
this_box_volume.loggers.num_elements = 0;

// packing the information into the global_geometry_element, which is then included in the global_geometry_list.
sprintf(global_geometry_element.name,NAME_CURRENT_COMP);
global_geometry_element.activation_counter = number_of_activations;
global_geometry_element.component_index = INDEX_CURRENT_COMP;
global_geometry_element.Volume = &this_box_volume; // Would be nicer if this m was a pointer, now we have the (small) data two places
add_element_to_geometry_list(&global_geometry_list,global_geometry_element);
}
#line 301454 "MACS_sample_kidney_box.c"
#undef number_of_activations
#undef mask_setting
#undef mask_string
#undef p_interact
#undef focus_r
#undef focus_xh
#undef focus_xw
#undef focus_ah
#undef focus_aw
#undef target_z
#undef target_y
#undef target_x
#undef target_index
#undef visualize
#undef yheight2
#undef xwidth2
#undef zdepth
#undef yheight
#undef xwidth
#undef priority
#undef material_string
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

  /* Initializations for component channel_15_analyzer_2_array_crystal_array_5. */
  SIG_MESSAGE("channel_15_analyzer_2_array_crystal_array_5 (Init)");
#define mccompcurname  channel_15_analyzer_2_array_crystal_array_5
#define mccompcurtype  Union_box
#define mccompcurindex 716
#define loop_index mccchannel_15_analyzer_2_array_crystal_array_5_loop_index
#define this_box_volume mccchannel_15_analyzer_2_array_crystal_array_5_this_box_volume
#define global_geometry_element mccchannel_15_analyzer_2_array_crystal_array_5_global_geometry_element
#define this_box_storage mccchannel_15_analyzer_2_array_crystal_array_5_this_box_storage
#define material_string mccchannel_15_analyzer_2_array_crystal_array_5_material_string
#define priority mccchannel_15_analyzer_2_array_crystal_array_5_priority
#define xwidth mccchannel_15_analyzer_2_array_crystal_array_5_xwidth
#define yheight mccchannel_15_analyzer_2_array_crystal_array_5_yheight
#define zdepth mccchannel_15_analyzer_2_array_crystal_array_5_zdepth
#define xwidth2 mccchannel_15_analyzer_2_array_crystal_array_5_xwidth2
#define yheight2 mccchannel_15_analyzer_2_array_crystal_array_5_yheight2
#define visualize mccchannel_15_analyzer_2_array_crystal_array_5_visualize
#define target_index mccchannel_15_analyzer_2_array_crystal_array_5_target_index
#define target_x mccchannel_15_analyzer_2_array_crystal_array_5_target_x
#define target_y mccchannel_15_analyzer_2_array_crystal_array_5_target_y
#define target_z mccchannel_15_analyzer_2_array_crystal_array_5_target_z
#define focus_aw mccchannel_15_analyzer_2_array_crystal_array_5_focus_aw
#define focus_ah mccchannel_15_analyzer_2_array_crystal_array_5_focus_ah
#define focus_xw mccchannel_15_analyzer_2_array_crystal_array_5_focus_xw
#define focus_xh mccchannel_15_analyzer_2_array_crystal_array_5_focus_xh
#define focus_r mccchannel_15_analyzer_2_array_crystal_array_5_focus_r
#define p_interact mccchannel_15_analyzer_2_array_crystal_array_5_p_interact
#define mask_string mccchannel_15_analyzer_2_array_crystal_array_5_mask_string
#define mask_setting mccchannel_15_analyzer_2_array_crystal_array_5_mask_setting
#define number_of_activations mccchannel_15_analyzer_2_array_crystal_array_5_number_of_activations
#line 224 "Union_box.comp"
{
// Initializes the focusing system for this volume including input sanitation.
focus_initialize(&this_box_volume.geometry, POS_A_COMP_INDEX(INDEX_CURRENT_COMP+target_index), POS_A_CURRENT_COMP, ROT_A_CURRENT_COMP, target_index, target_x, target_y, target_z, focus_aw, focus_ah, focus_xw, focus_xh, focus_r, NAME_CURRENT_COMP);

// Input sanitation for this geometry
if (xwidth <= 0) {
  printf("\nERROR in Union_box named %s, the xwidth is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (yheight <= 0) {
  printf("\nERROR in Union_box named %s, yheight is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (zdepth <= 0) {
  printf("\nERROR in Union_box named %s, zdepth is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (xwidth2 <= 0 && xwidth2 != -1) {
  printf("\nERROR in Union_box named %s, the xwidth2 is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (yheight2 <= 0 && yheight2 != -1) {
  printf("\nERROR in Union_box named %s, yheight2 is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}

// Use sanitation
if (global_material_list.num_elements == 0) {
  printf("\nERROR: Need to define a material using Union_make_material before using a Union geometry component. \n");
  printf("       %s was defined before first use of Union_make_material.\n",NAME_CURRENT_COMP);
  exit(1);
}

this_box_volume.geometry.is_masked_volume = 0;
this_box_volume.geometry.is_exit_volume = 0;
this_box_volume.geometry.is_mask_volume = 0;
// check if the volume is a mask, if it is the material string is irelevant.
if (mask_string && strlen(mask_string) && strcmp(mask_string, "NULL") && strcmp(mask_string, "0")) {
    // A mask volume is used to limit the extend of other volumes, called the masked volumes. These are specified in the mask_string.
    // In order for a ray to enter a masked volume, it needs to be both in the region covered by that volume AND the mask volume.
    // When more than
    this_box_volume.geometry.mask_mode = 1; // Default is mask mode is ALL
    if (mask_setting && strlen(mask_setting) && strcmp(mask_setting, "NULL") && strcmp(mask_setting, "0")) {
        if (strcmp(mask_setting,"ALL") == 0 || strcmp(mask_setting,"All") == 0) this_box_volume.geometry.mask_mode = 1;
        else if (strcmp(mask_setting,"ANY") == 0 || strcmp(mask_setting,"Any") == 0) this_box_volume.geometry.mask_mode = 2;
        else {
            printf("The mask_mode of component %s is set to %s, but must be either ALL or ANY.\n",NAME_CURRENT_COMP,mask_setting);
            exit(1);
        }
    }
    
    for (loop_index=0;loop_index<global_geometry_list.num_elements;loop_index++) {
        // Add mask list
        if (1 == manual_linking_function(global_geometry_list.elements[loop_index].name,mask_string)) {
            add_element_to_int_list(&this_box_volume.geometry.mask_list,global_geometry_list.elements[loop_index].component_index);
            add_element_to_int_list(&global_geometry_list.elements[loop_index].Volume->geometry.masked_by_list,INDEX_CURRENT_COMP);
            global_geometry_list.elements[loop_index].Volume->geometry.is_masked_volume = 1;
            if (this_box_volume.geometry.mask_mode == 2)
                global_geometry_list.elements[loop_index].Volume->geometry.mask_mode = 2;
            if (this_box_volume.geometry.mask_mode == 1) {
                if (global_geometry_list.elements[loop_index].Volume->geometry.is_masked_volume == 1 && global_geometry_list.elements[loop_index].Volume->geometry.mask_mode != 2)
                    // If more than one mask is added to one volume, the ANY mode overwrites the (default) ALL mode.
                    global_geometry_list.elements[loop_index].Volume->geometry.mask_mode = 1;
            }
            
            found_geometries = 1;
        }
    }
    if (found_geometries == 0) {
        printf("The mask_string in geometry: %s did not find any of the specified volumes in the mask_string %s \n",NAME_CURRENT_COMP,mask_string);
        exit(1);
    }
    this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
    this_box_volume.p_physics->is_vacuum = 0; // Makes this volume a vacuum
    this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
    this_box_volume.p_physics->my_a = 0; // Should not be used.
    sprintf(this_box_volume.p_physics->name,"Mask");
    this_box_volume.geometry.is_mask_volume = 1;
    
    
// Read the material input, or if it lacks, use automatic linking.
} else if (material_string && strlen(material_string) && strcmp(material_string, "NULL") && strcmp(material_string, "0")) {
    // A geometry string was given, use it to determine which material
    if (0 == strcmp(material_string,"vacuum") || 0 == strcmp(material_string,"Vacuum")) {
        // One could have a global physics struct for vacuum instead of creating one for each
        this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
        this_box_volume.p_physics->is_vacuum = 1; // Makes this volume a vacuum
        this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
        this_box_volume.p_physics->my_a = 0; // Should not be used.
        sprintf(this_box_volume.p_physics->name,"Vacuum");
    } else if (0 == strcmp(material_string,"exit") || 0 == strcmp(material_string,"Exit")) {
        // One could have a global physics struct for vacuum instead of creating one for each
        this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
        this_box_volume.p_physics->is_vacuum = 1; // Makes this volume a vacuum
        this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
        this_box_volume.p_physics->my_a = 0; // Should not be used.
        this_box_volume.geometry.is_exit_volume = 1;
        sprintf(this_box_volume.p_physics->name,"Exit");
    } else {
        #ifndef MATERIAL_DETECTOR
            printf("Need to define a material before refering to it in a geometry %s.\n",NAME_CURRENT_COMP);
            exit(1);
        #endif
        for (loop_index=0;loop_index<global_material_list.num_elements;loop_index++) {
            if (0 == strcmp(material_string,global_material_list.elements[loop_index].name)) {
                this_box_volume.p_physics = global_material_list.elements[loop_index].physics;
                break;
            }
            if (loop_index == global_material_list.num_elements-1) {
            printf("\n");
            printf("ERROR: The material string \"%s\" in Union geometry \"%s\" did not match a specified material. \n",material_string,NAME_CURRENT_COMP);
            printf("       The materials available at this point (need to be defined before the geometry): \n");
            for (loop_index=0;loop_index<global_material_list.num_elements;loop_index++)
              printf("         %s\n",global_material_list.elements[loop_index].name);
            printf("\n");
            printf("       It is also possible to use one of the defualt materials avaiable: \n");
            printf("           Vacuum (for a Volume without scattering or absorption)\n");
            printf("           Exit (for a Volume where the ray exits the component if it enters)\n");
            printf("           Mask (for a Volume that masks existing volumes specified in the mask_string\n");
            exit(1);
          }
        }
    }
} else {
    // Automatic linking, simply using the last defined material.
    #ifndef MATERIAL_DETECTOR
        printf("Need to define a material before the geometry to use automatic linking %s.\n",NAME_CURRENT_COMP);
        exit(1);
    #endif
    this_box_volume.p_physics = global_material_list.elements[global_material_list.num_elements-1].physics;
}

sprintf(this_box_volume.name,NAME_CURRENT_COMP);
sprintf(this_box_volume.geometry.shape,"box");
this_box_volume.geometry.priority_value = priority;
this_box_volume.geometry.geometry_p_interact = p_interact;
// Currently the coordinates will be in absolute space.
this_box_volume.geometry.center = POS_A_CURRENT_COMP;

this_box_storage.z_depth = zdepth;
this_box_storage.x_width1 = xwidth;
this_box_storage.y_height1 = yheight;

this_box_storage.is_rectangle = 0;
if (xwidth2 < 0 && yheight2 < 0) this_box_storage.is_rectangle = 1;
if (xwidth == xwidth2 && yheight == yheight2) this_box_storage.is_rectangle = 1;

if (xwidth2 < 0) {
    this_box_storage.x_width2 = xwidth;
    xwidth2 = xwidth;
} else this_box_storage.x_width2 = xwidth2;

if (yheight2 < 0) {
    this_box_storage.y_height2 = yheight;
    yheight2 = yheight;
} else this_box_storage.y_height2 = yheight2;


this_box_storage.normal_vectors[0] = coords_set(0,0,1);
this_box_storage.normal_vectors[1] = coords_set(0,0,1);

// for sides with y component = 0
x_component = 2*zdepth/sqrt((xwidth-xwidth2)*(xwidth-xwidth2)+4*zdepth*zdepth);
z_component = (xwidth-xwidth2)/sqrt(4*zdepth*zdepth+(xwidth-xwidth2)*(xwidth-xwidth2));

this_box_storage.normal_vectors[2] = coords_set(x_component,0,z_component);
this_box_storage.normal_vectors[3] = coords_set(-x_component,0,z_component);

// for sides with x component = 0
y_component = 2*zdepth/sqrt((yheight-yheight2)*(yheight-yheight2)+4*zdepth*zdepth);
z_component = (yheight-yheight2)/sqrt(4*zdepth*zdepth+(yheight-yheight2)*(yheight-yheight2));

this_box_storage.normal_vectors[4] = coords_set(0,y_component,z_component);
this_box_storage.normal_vectors[5] = coords_set(0,-y_component,z_component);

this_box_volume.geometry.visualization_on = visualize;

this_box_volume.geometry.geometry_parameters.p_box_storage = &this_box_storage;

// Assign pointers to functions for intersection with the shape, checking if a point is inside the shape
if (this_box_storage.is_rectangle == 1) {
this_box_volume.geometry.intersect_function = &sample_box_intersect_simple;
this_box_volume.geometry.within_function = &r_within_box_simple;
}
else {
this_box_volume.geometry.intersect_function = &sample_box_intersect_advanced;
this_box_volume.geometry.within_function = &r_within_box_advanced;
}

this_box_volume.geometry.shell_points = &box_shell_points;
this_box_volume.geometry.mcdisplay_function = &mcdisplay_box_function;
this_box_volume.geometry.initialize_from_main_function = &initialize_box_geometry_from_main_component;
this_box_volume.geometry.process_rot_allocated = 0;

this_box_volume.geometry.copy_geometry_parameters = &allocate_box_storage_copy;

rot_copy(this_box_volume.geometry.rotation_matrix,ROT_A_CURRENT_COMP); //check how ROT_R_CURRENT_COMP would work
rot_transpose(ROT_A_CURRENT_COMP,this_box_volume.geometry.transpose_rotation_matrix);

// Initialize loggers
this_box_volume.loggers.num_elements = 0;

// packing the information into the global_geometry_element, which is then included in the global_geometry_list.
sprintf(global_geometry_element.name,NAME_CURRENT_COMP);
global_geometry_element.activation_counter = number_of_activations;
global_geometry_element.component_index = INDEX_CURRENT_COMP;
global_geometry_element.Volume = &this_box_volume; // Would be nicer if this m was a pointer, now we have the (small) data two places
add_element_to_geometry_list(&global_geometry_list,global_geometry_element);
}
#line 301724 "MACS_sample_kidney_box.c"
#undef number_of_activations
#undef mask_setting
#undef mask_string
#undef p_interact
#undef focus_r
#undef focus_xh
#undef focus_xw
#undef focus_ah
#undef focus_aw
#undef target_z
#undef target_y
#undef target_x
#undef target_index
#undef visualize
#undef yheight2
#undef xwidth2
#undef zdepth
#undef yheight
#undef xwidth
#undef priority
#undef material_string
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

  /* Initializations for component channel_15_analyzer_2_array_crystal_array_6. */
  SIG_MESSAGE("channel_15_analyzer_2_array_crystal_array_6 (Init)");
#define mccompcurname  channel_15_analyzer_2_array_crystal_array_6
#define mccompcurtype  Union_box
#define mccompcurindex 717
#define loop_index mccchannel_15_analyzer_2_array_crystal_array_6_loop_index
#define this_box_volume mccchannel_15_analyzer_2_array_crystal_array_6_this_box_volume
#define global_geometry_element mccchannel_15_analyzer_2_array_crystal_array_6_global_geometry_element
#define this_box_storage mccchannel_15_analyzer_2_array_crystal_array_6_this_box_storage
#define material_string mccchannel_15_analyzer_2_array_crystal_array_6_material_string
#define priority mccchannel_15_analyzer_2_array_crystal_array_6_priority
#define xwidth mccchannel_15_analyzer_2_array_crystal_array_6_xwidth
#define yheight mccchannel_15_analyzer_2_array_crystal_array_6_yheight
#define zdepth mccchannel_15_analyzer_2_array_crystal_array_6_zdepth
#define xwidth2 mccchannel_15_analyzer_2_array_crystal_array_6_xwidth2
#define yheight2 mccchannel_15_analyzer_2_array_crystal_array_6_yheight2
#define visualize mccchannel_15_analyzer_2_array_crystal_array_6_visualize
#define target_index mccchannel_15_analyzer_2_array_crystal_array_6_target_index
#define target_x mccchannel_15_analyzer_2_array_crystal_array_6_target_x
#define target_y mccchannel_15_analyzer_2_array_crystal_array_6_target_y
#define target_z mccchannel_15_analyzer_2_array_crystal_array_6_target_z
#define focus_aw mccchannel_15_analyzer_2_array_crystal_array_6_focus_aw
#define focus_ah mccchannel_15_analyzer_2_array_crystal_array_6_focus_ah
#define focus_xw mccchannel_15_analyzer_2_array_crystal_array_6_focus_xw
#define focus_xh mccchannel_15_analyzer_2_array_crystal_array_6_focus_xh
#define focus_r mccchannel_15_analyzer_2_array_crystal_array_6_focus_r
#define p_interact mccchannel_15_analyzer_2_array_crystal_array_6_p_interact
#define mask_string mccchannel_15_analyzer_2_array_crystal_array_6_mask_string
#define mask_setting mccchannel_15_analyzer_2_array_crystal_array_6_mask_setting
#define number_of_activations mccchannel_15_analyzer_2_array_crystal_array_6_number_of_activations
#line 224 "Union_box.comp"
{
// Initializes the focusing system for this volume including input sanitation.
focus_initialize(&this_box_volume.geometry, POS_A_COMP_INDEX(INDEX_CURRENT_COMP+target_index), POS_A_CURRENT_COMP, ROT_A_CURRENT_COMP, target_index, target_x, target_y, target_z, focus_aw, focus_ah, focus_xw, focus_xh, focus_r, NAME_CURRENT_COMP);

// Input sanitation for this geometry
if (xwidth <= 0) {
  printf("\nERROR in Union_box named %s, the xwidth is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (yheight <= 0) {
  printf("\nERROR in Union_box named %s, yheight is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (zdepth <= 0) {
  printf("\nERROR in Union_box named %s, zdepth is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (xwidth2 <= 0 && xwidth2 != -1) {
  printf("\nERROR in Union_box named %s, the xwidth2 is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (yheight2 <= 0 && yheight2 != -1) {
  printf("\nERROR in Union_box named %s, yheight2 is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}

// Use sanitation
if (global_material_list.num_elements == 0) {
  printf("\nERROR: Need to define a material using Union_make_material before using a Union geometry component. \n");
  printf("       %s was defined before first use of Union_make_material.\n",NAME_CURRENT_COMP);
  exit(1);
}

this_box_volume.geometry.is_masked_volume = 0;
this_box_volume.geometry.is_exit_volume = 0;
this_box_volume.geometry.is_mask_volume = 0;
// check if the volume is a mask, if it is the material string is irelevant.
if (mask_string && strlen(mask_string) && strcmp(mask_string, "NULL") && strcmp(mask_string, "0")) {
    // A mask volume is used to limit the extend of other volumes, called the masked volumes. These are specified in the mask_string.
    // In order for a ray to enter a masked volume, it needs to be both in the region covered by that volume AND the mask volume.
    // When more than
    this_box_volume.geometry.mask_mode = 1; // Default is mask mode is ALL
    if (mask_setting && strlen(mask_setting) && strcmp(mask_setting, "NULL") && strcmp(mask_setting, "0")) {
        if (strcmp(mask_setting,"ALL") == 0 || strcmp(mask_setting,"All") == 0) this_box_volume.geometry.mask_mode = 1;
        else if (strcmp(mask_setting,"ANY") == 0 || strcmp(mask_setting,"Any") == 0) this_box_volume.geometry.mask_mode = 2;
        else {
            printf("The mask_mode of component %s is set to %s, but must be either ALL or ANY.\n",NAME_CURRENT_COMP,mask_setting);
            exit(1);
        }
    }
    
    for (loop_index=0;loop_index<global_geometry_list.num_elements;loop_index++) {
        // Add mask list
        if (1 == manual_linking_function(global_geometry_list.elements[loop_index].name,mask_string)) {
            add_element_to_int_list(&this_box_volume.geometry.mask_list,global_geometry_list.elements[loop_index].component_index);
            add_element_to_int_list(&global_geometry_list.elements[loop_index].Volume->geometry.masked_by_list,INDEX_CURRENT_COMP);
            global_geometry_list.elements[loop_index].Volume->geometry.is_masked_volume = 1;
            if (this_box_volume.geometry.mask_mode == 2)
                global_geometry_list.elements[loop_index].Volume->geometry.mask_mode = 2;
            if (this_box_volume.geometry.mask_mode == 1) {
                if (global_geometry_list.elements[loop_index].Volume->geometry.is_masked_volume == 1 && global_geometry_list.elements[loop_index].Volume->geometry.mask_mode != 2)
                    // If more than one mask is added to one volume, the ANY mode overwrites the (default) ALL mode.
                    global_geometry_list.elements[loop_index].Volume->geometry.mask_mode = 1;
            }
            
            found_geometries = 1;
        }
    }
    if (found_geometries == 0) {
        printf("The mask_string in geometry: %s did not find any of the specified volumes in the mask_string %s \n",NAME_CURRENT_COMP,mask_string);
        exit(1);
    }
    this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
    this_box_volume.p_physics->is_vacuum = 0; // Makes this volume a vacuum
    this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
    this_box_volume.p_physics->my_a = 0; // Should not be used.
    sprintf(this_box_volume.p_physics->name,"Mask");
    this_box_volume.geometry.is_mask_volume = 1;
    
    
// Read the material input, or if it lacks, use automatic linking.
} else if (material_string && strlen(material_string) && strcmp(material_string, "NULL") && strcmp(material_string, "0")) {
    // A geometry string was given, use it to determine which material
    if (0 == strcmp(material_string,"vacuum") || 0 == strcmp(material_string,"Vacuum")) {
        // One could have a global physics struct for vacuum instead of creating one for each
        this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
        this_box_volume.p_physics->is_vacuum = 1; // Makes this volume a vacuum
        this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
        this_box_volume.p_physics->my_a = 0; // Should not be used.
        sprintf(this_box_volume.p_physics->name,"Vacuum");
    } else if (0 == strcmp(material_string,"exit") || 0 == strcmp(material_string,"Exit")) {
        // One could have a global physics struct for vacuum instead of creating one for each
        this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
        this_box_volume.p_physics->is_vacuum = 1; // Makes this volume a vacuum
        this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
        this_box_volume.p_physics->my_a = 0; // Should not be used.
        this_box_volume.geometry.is_exit_volume = 1;
        sprintf(this_box_volume.p_physics->name,"Exit");
    } else {
        #ifndef MATERIAL_DETECTOR
            printf("Need to define a material before refering to it in a geometry %s.\n",NAME_CURRENT_COMP);
            exit(1);
        #endif
        for (loop_index=0;loop_index<global_material_list.num_elements;loop_index++) {
            if (0 == strcmp(material_string,global_material_list.elements[loop_index].name)) {
                this_box_volume.p_physics = global_material_list.elements[loop_index].physics;
                break;
            }
            if (loop_index == global_material_list.num_elements-1) {
            printf("\n");
            printf("ERROR: The material string \"%s\" in Union geometry \"%s\" did not match a specified material. \n",material_string,NAME_CURRENT_COMP);
            printf("       The materials available at this point (need to be defined before the geometry): \n");
            for (loop_index=0;loop_index<global_material_list.num_elements;loop_index++)
              printf("         %s\n",global_material_list.elements[loop_index].name);
            printf("\n");
            printf("       It is also possible to use one of the defualt materials avaiable: \n");
            printf("           Vacuum (for a Volume without scattering or absorption)\n");
            printf("           Exit (for a Volume where the ray exits the component if it enters)\n");
            printf("           Mask (for a Volume that masks existing volumes specified in the mask_string\n");
            exit(1);
          }
        }
    }
} else {
    // Automatic linking, simply using the last defined material.
    #ifndef MATERIAL_DETECTOR
        printf("Need to define a material before the geometry to use automatic linking %s.\n",NAME_CURRENT_COMP);
        exit(1);
    #endif
    this_box_volume.p_physics = global_material_list.elements[global_material_list.num_elements-1].physics;
}

sprintf(this_box_volume.name,NAME_CURRENT_COMP);
sprintf(this_box_volume.geometry.shape,"box");
this_box_volume.geometry.priority_value = priority;
this_box_volume.geometry.geometry_p_interact = p_interact;
// Currently the coordinates will be in absolute space.
this_box_volume.geometry.center = POS_A_CURRENT_COMP;

this_box_storage.z_depth = zdepth;
this_box_storage.x_width1 = xwidth;
this_box_storage.y_height1 = yheight;

this_box_storage.is_rectangle = 0;
if (xwidth2 < 0 && yheight2 < 0) this_box_storage.is_rectangle = 1;
if (xwidth == xwidth2 && yheight == yheight2) this_box_storage.is_rectangle = 1;

if (xwidth2 < 0) {
    this_box_storage.x_width2 = xwidth;
    xwidth2 = xwidth;
} else this_box_storage.x_width2 = xwidth2;

if (yheight2 < 0) {
    this_box_storage.y_height2 = yheight;
    yheight2 = yheight;
} else this_box_storage.y_height2 = yheight2;


this_box_storage.normal_vectors[0] = coords_set(0,0,1);
this_box_storage.normal_vectors[1] = coords_set(0,0,1);

// for sides with y component = 0
x_component = 2*zdepth/sqrt((xwidth-xwidth2)*(xwidth-xwidth2)+4*zdepth*zdepth);
z_component = (xwidth-xwidth2)/sqrt(4*zdepth*zdepth+(xwidth-xwidth2)*(xwidth-xwidth2));

this_box_storage.normal_vectors[2] = coords_set(x_component,0,z_component);
this_box_storage.normal_vectors[3] = coords_set(-x_component,0,z_component);

// for sides with x component = 0
y_component = 2*zdepth/sqrt((yheight-yheight2)*(yheight-yheight2)+4*zdepth*zdepth);
z_component = (yheight-yheight2)/sqrt(4*zdepth*zdepth+(yheight-yheight2)*(yheight-yheight2));

this_box_storage.normal_vectors[4] = coords_set(0,y_component,z_component);
this_box_storage.normal_vectors[5] = coords_set(0,-y_component,z_component);

this_box_volume.geometry.visualization_on = visualize;

this_box_volume.geometry.geometry_parameters.p_box_storage = &this_box_storage;

// Assign pointers to functions for intersection with the shape, checking if a point is inside the shape
if (this_box_storage.is_rectangle == 1) {
this_box_volume.geometry.intersect_function = &sample_box_intersect_simple;
this_box_volume.geometry.within_function = &r_within_box_simple;
}
else {
this_box_volume.geometry.intersect_function = &sample_box_intersect_advanced;
this_box_volume.geometry.within_function = &r_within_box_advanced;
}

this_box_volume.geometry.shell_points = &box_shell_points;
this_box_volume.geometry.mcdisplay_function = &mcdisplay_box_function;
this_box_volume.geometry.initialize_from_main_function = &initialize_box_geometry_from_main_component;
this_box_volume.geometry.process_rot_allocated = 0;

this_box_volume.geometry.copy_geometry_parameters = &allocate_box_storage_copy;

rot_copy(this_box_volume.geometry.rotation_matrix,ROT_A_CURRENT_COMP); //check how ROT_R_CURRENT_COMP would work
rot_transpose(ROT_A_CURRENT_COMP,this_box_volume.geometry.transpose_rotation_matrix);

// Initialize loggers
this_box_volume.loggers.num_elements = 0;

// packing the information into the global_geometry_element, which is then included in the global_geometry_list.
sprintf(global_geometry_element.name,NAME_CURRENT_COMP);
global_geometry_element.activation_counter = number_of_activations;
global_geometry_element.component_index = INDEX_CURRENT_COMP;
global_geometry_element.Volume = &this_box_volume; // Would be nicer if this m was a pointer, now we have the (small) data two places
add_element_to_geometry_list(&global_geometry_list,global_geometry_element);
}
#line 301994 "MACS_sample_kidney_box.c"
#undef number_of_activations
#undef mask_setting
#undef mask_string
#undef p_interact
#undef focus_r
#undef focus_xh
#undef focus_xw
#undef focus_ah
#undef focus_aw
#undef target_z
#undef target_y
#undef target_x
#undef target_index
#undef visualize
#undef yheight2
#undef xwidth2
#undef zdepth
#undef yheight
#undef xwidth
#undef priority
#undef material_string
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

  /* Initializations for component channel_15_analyzer_2_array_crystal_array_7. */
  SIG_MESSAGE("channel_15_analyzer_2_array_crystal_array_7 (Init)");
#define mccompcurname  channel_15_analyzer_2_array_crystal_array_7
#define mccompcurtype  Union_box
#define mccompcurindex 718
#define loop_index mccchannel_15_analyzer_2_array_crystal_array_7_loop_index
#define this_box_volume mccchannel_15_analyzer_2_array_crystal_array_7_this_box_volume
#define global_geometry_element mccchannel_15_analyzer_2_array_crystal_array_7_global_geometry_element
#define this_box_storage mccchannel_15_analyzer_2_array_crystal_array_7_this_box_storage
#define material_string mccchannel_15_analyzer_2_array_crystal_array_7_material_string
#define priority mccchannel_15_analyzer_2_array_crystal_array_7_priority
#define xwidth mccchannel_15_analyzer_2_array_crystal_array_7_xwidth
#define yheight mccchannel_15_analyzer_2_array_crystal_array_7_yheight
#define zdepth mccchannel_15_analyzer_2_array_crystal_array_7_zdepth
#define xwidth2 mccchannel_15_analyzer_2_array_crystal_array_7_xwidth2
#define yheight2 mccchannel_15_analyzer_2_array_crystal_array_7_yheight2
#define visualize mccchannel_15_analyzer_2_array_crystal_array_7_visualize
#define target_index mccchannel_15_analyzer_2_array_crystal_array_7_target_index
#define target_x mccchannel_15_analyzer_2_array_crystal_array_7_target_x
#define target_y mccchannel_15_analyzer_2_array_crystal_array_7_target_y
#define target_z mccchannel_15_analyzer_2_array_crystal_array_7_target_z
#define focus_aw mccchannel_15_analyzer_2_array_crystal_array_7_focus_aw
#define focus_ah mccchannel_15_analyzer_2_array_crystal_array_7_focus_ah
#define focus_xw mccchannel_15_analyzer_2_array_crystal_array_7_focus_xw
#define focus_xh mccchannel_15_analyzer_2_array_crystal_array_7_focus_xh
#define focus_r mccchannel_15_analyzer_2_array_crystal_array_7_focus_r
#define p_interact mccchannel_15_analyzer_2_array_crystal_array_7_p_interact
#define mask_string mccchannel_15_analyzer_2_array_crystal_array_7_mask_string
#define mask_setting mccchannel_15_analyzer_2_array_crystal_array_7_mask_setting
#define number_of_activations mccchannel_15_analyzer_2_array_crystal_array_7_number_of_activations
#line 224 "Union_box.comp"
{
// Initializes the focusing system for this volume including input sanitation.
focus_initialize(&this_box_volume.geometry, POS_A_COMP_INDEX(INDEX_CURRENT_COMP+target_index), POS_A_CURRENT_COMP, ROT_A_CURRENT_COMP, target_index, target_x, target_y, target_z, focus_aw, focus_ah, focus_xw, focus_xh, focus_r, NAME_CURRENT_COMP);

// Input sanitation for this geometry
if (xwidth <= 0) {
  printf("\nERROR in Union_box named %s, the xwidth is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (yheight <= 0) {
  printf("\nERROR in Union_box named %s, yheight is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (zdepth <= 0) {
  printf("\nERROR in Union_box named %s, zdepth is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (xwidth2 <= 0 && xwidth2 != -1) {
  printf("\nERROR in Union_box named %s, the xwidth2 is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (yheight2 <= 0 && yheight2 != -1) {
  printf("\nERROR in Union_box named %s, yheight2 is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}

// Use sanitation
if (global_material_list.num_elements == 0) {
  printf("\nERROR: Need to define a material using Union_make_material before using a Union geometry component. \n");
  printf("       %s was defined before first use of Union_make_material.\n",NAME_CURRENT_COMP);
  exit(1);
}

this_box_volume.geometry.is_masked_volume = 0;
this_box_volume.geometry.is_exit_volume = 0;
this_box_volume.geometry.is_mask_volume = 0;
// check if the volume is a mask, if it is the material string is irelevant.
if (mask_string && strlen(mask_string) && strcmp(mask_string, "NULL") && strcmp(mask_string, "0")) {
    // A mask volume is used to limit the extend of other volumes, called the masked volumes. These are specified in the mask_string.
    // In order for a ray to enter a masked volume, it needs to be both in the region covered by that volume AND the mask volume.
    // When more than
    this_box_volume.geometry.mask_mode = 1; // Default is mask mode is ALL
    if (mask_setting && strlen(mask_setting) && strcmp(mask_setting, "NULL") && strcmp(mask_setting, "0")) {
        if (strcmp(mask_setting,"ALL") == 0 || strcmp(mask_setting,"All") == 0) this_box_volume.geometry.mask_mode = 1;
        else if (strcmp(mask_setting,"ANY") == 0 || strcmp(mask_setting,"Any") == 0) this_box_volume.geometry.mask_mode = 2;
        else {
            printf("The mask_mode of component %s is set to %s, but must be either ALL or ANY.\n",NAME_CURRENT_COMP,mask_setting);
            exit(1);
        }
    }
    
    for (loop_index=0;loop_index<global_geometry_list.num_elements;loop_index++) {
        // Add mask list
        if (1 == manual_linking_function(global_geometry_list.elements[loop_index].name,mask_string)) {
            add_element_to_int_list(&this_box_volume.geometry.mask_list,global_geometry_list.elements[loop_index].component_index);
            add_element_to_int_list(&global_geometry_list.elements[loop_index].Volume->geometry.masked_by_list,INDEX_CURRENT_COMP);
            global_geometry_list.elements[loop_index].Volume->geometry.is_masked_volume = 1;
            if (this_box_volume.geometry.mask_mode == 2)
                global_geometry_list.elements[loop_index].Volume->geometry.mask_mode = 2;
            if (this_box_volume.geometry.mask_mode == 1) {
                if (global_geometry_list.elements[loop_index].Volume->geometry.is_masked_volume == 1 && global_geometry_list.elements[loop_index].Volume->geometry.mask_mode != 2)
                    // If more than one mask is added to one volume, the ANY mode overwrites the (default) ALL mode.
                    global_geometry_list.elements[loop_index].Volume->geometry.mask_mode = 1;
            }
            
            found_geometries = 1;
        }
    }
    if (found_geometries == 0) {
        printf("The mask_string in geometry: %s did not find any of the specified volumes in the mask_string %s \n",NAME_CURRENT_COMP,mask_string);
        exit(1);
    }
    this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
    this_box_volume.p_physics->is_vacuum = 0; // Makes this volume a vacuum
    this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
    this_box_volume.p_physics->my_a = 0; // Should not be used.
    sprintf(this_box_volume.p_physics->name,"Mask");
    this_box_volume.geometry.is_mask_volume = 1;
    
    
// Read the material input, or if it lacks, use automatic linking.
} else if (material_string && strlen(material_string) && strcmp(material_string, "NULL") && strcmp(material_string, "0")) {
    // A geometry string was given, use it to determine which material
    if (0 == strcmp(material_string,"vacuum") || 0 == strcmp(material_string,"Vacuum")) {
        // One could have a global physics struct for vacuum instead of creating one for each
        this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
        this_box_volume.p_physics->is_vacuum = 1; // Makes this volume a vacuum
        this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
        this_box_volume.p_physics->my_a = 0; // Should not be used.
        sprintf(this_box_volume.p_physics->name,"Vacuum");
    } else if (0 == strcmp(material_string,"exit") || 0 == strcmp(material_string,"Exit")) {
        // One could have a global physics struct for vacuum instead of creating one for each
        this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
        this_box_volume.p_physics->is_vacuum = 1; // Makes this volume a vacuum
        this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
        this_box_volume.p_physics->my_a = 0; // Should not be used.
        this_box_volume.geometry.is_exit_volume = 1;
        sprintf(this_box_volume.p_physics->name,"Exit");
    } else {
        #ifndef MATERIAL_DETECTOR
            printf("Need to define a material before refering to it in a geometry %s.\n",NAME_CURRENT_COMP);
            exit(1);
        #endif
        for (loop_index=0;loop_index<global_material_list.num_elements;loop_index++) {
            if (0 == strcmp(material_string,global_material_list.elements[loop_index].name)) {
                this_box_volume.p_physics = global_material_list.elements[loop_index].physics;
                break;
            }
            if (loop_index == global_material_list.num_elements-1) {
            printf("\n");
            printf("ERROR: The material string \"%s\" in Union geometry \"%s\" did not match a specified material. \n",material_string,NAME_CURRENT_COMP);
            printf("       The materials available at this point (need to be defined before the geometry): \n");
            for (loop_index=0;loop_index<global_material_list.num_elements;loop_index++)
              printf("         %s\n",global_material_list.elements[loop_index].name);
            printf("\n");
            printf("       It is also possible to use one of the defualt materials avaiable: \n");
            printf("           Vacuum (for a Volume without scattering or absorption)\n");
            printf("           Exit (for a Volume where the ray exits the component if it enters)\n");
            printf("           Mask (for a Volume that masks existing volumes specified in the mask_string\n");
            exit(1);
          }
        }
    }
} else {
    // Automatic linking, simply using the last defined material.
    #ifndef MATERIAL_DETECTOR
        printf("Need to define a material before the geometry to use automatic linking %s.\n",NAME_CURRENT_COMP);
        exit(1);
    #endif
    this_box_volume.p_physics = global_material_list.elements[global_material_list.num_elements-1].physics;
}

sprintf(this_box_volume.name,NAME_CURRENT_COMP);
sprintf(this_box_volume.geometry.shape,"box");
this_box_volume.geometry.priority_value = priority;
this_box_volume.geometry.geometry_p_interact = p_interact;
// Currently the coordinates will be in absolute space.
this_box_volume.geometry.center = POS_A_CURRENT_COMP;

this_box_storage.z_depth = zdepth;
this_box_storage.x_width1 = xwidth;
this_box_storage.y_height1 = yheight;

this_box_storage.is_rectangle = 0;
if (xwidth2 < 0 && yheight2 < 0) this_box_storage.is_rectangle = 1;
if (xwidth == xwidth2 && yheight == yheight2) this_box_storage.is_rectangle = 1;

if (xwidth2 < 0) {
    this_box_storage.x_width2 = xwidth;
    xwidth2 = xwidth;
} else this_box_storage.x_width2 = xwidth2;

if (yheight2 < 0) {
    this_box_storage.y_height2 = yheight;
    yheight2 = yheight;
} else this_box_storage.y_height2 = yheight2;


this_box_storage.normal_vectors[0] = coords_set(0,0,1);
this_box_storage.normal_vectors[1] = coords_set(0,0,1);

// for sides with y component = 0
x_component = 2*zdepth/sqrt((xwidth-xwidth2)*(xwidth-xwidth2)+4*zdepth*zdepth);
z_component = (xwidth-xwidth2)/sqrt(4*zdepth*zdepth+(xwidth-xwidth2)*(xwidth-xwidth2));

this_box_storage.normal_vectors[2] = coords_set(x_component,0,z_component);
this_box_storage.normal_vectors[3] = coords_set(-x_component,0,z_component);

// for sides with x component = 0
y_component = 2*zdepth/sqrt((yheight-yheight2)*(yheight-yheight2)+4*zdepth*zdepth);
z_component = (yheight-yheight2)/sqrt(4*zdepth*zdepth+(yheight-yheight2)*(yheight-yheight2));

this_box_storage.normal_vectors[4] = coords_set(0,y_component,z_component);
this_box_storage.normal_vectors[5] = coords_set(0,-y_component,z_component);

this_box_volume.geometry.visualization_on = visualize;

this_box_volume.geometry.geometry_parameters.p_box_storage = &this_box_storage;

// Assign pointers to functions for intersection with the shape, checking if a point is inside the shape
if (this_box_storage.is_rectangle == 1) {
this_box_volume.geometry.intersect_function = &sample_box_intersect_simple;
this_box_volume.geometry.within_function = &r_within_box_simple;
}
else {
this_box_volume.geometry.intersect_function = &sample_box_intersect_advanced;
this_box_volume.geometry.within_function = &r_within_box_advanced;
}

this_box_volume.geometry.shell_points = &box_shell_points;
this_box_volume.geometry.mcdisplay_function = &mcdisplay_box_function;
this_box_volume.geometry.initialize_from_main_function = &initialize_box_geometry_from_main_component;
this_box_volume.geometry.process_rot_allocated = 0;

this_box_volume.geometry.copy_geometry_parameters = &allocate_box_storage_copy;

rot_copy(this_box_volume.geometry.rotation_matrix,ROT_A_CURRENT_COMP); //check how ROT_R_CURRENT_COMP would work
rot_transpose(ROT_A_CURRENT_COMP,this_box_volume.geometry.transpose_rotation_matrix);

// Initialize loggers
this_box_volume.loggers.num_elements = 0;

// packing the information into the global_geometry_element, which is then included in the global_geometry_list.
sprintf(global_geometry_element.name,NAME_CURRENT_COMP);
global_geometry_element.activation_counter = number_of_activations;
global_geometry_element.component_index = INDEX_CURRENT_COMP;
global_geometry_element.Volume = &this_box_volume; // Would be nicer if this m was a pointer, now we have the (small) data two places
add_element_to_geometry_list(&global_geometry_list,global_geometry_element);
}
#line 302264 "MACS_sample_kidney_box.c"
#undef number_of_activations
#undef mask_setting
#undef mask_string
#undef p_interact
#undef focus_r
#undef focus_xh
#undef focus_xw
#undef focus_ah
#undef focus_aw
#undef target_z
#undef target_y
#undef target_x
#undef target_index
#undef visualize
#undef yheight2
#undef xwidth2
#undef zdepth
#undef yheight
#undef xwidth
#undef priority
#undef material_string
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

  /* Initializations for component channel_15_analyzer_2_array_crystal_array_8. */
  SIG_MESSAGE("channel_15_analyzer_2_array_crystal_array_8 (Init)");
#define mccompcurname  channel_15_analyzer_2_array_crystal_array_8
#define mccompcurtype  Union_box
#define mccompcurindex 719
#define loop_index mccchannel_15_analyzer_2_array_crystal_array_8_loop_index
#define this_box_volume mccchannel_15_analyzer_2_array_crystal_array_8_this_box_volume
#define global_geometry_element mccchannel_15_analyzer_2_array_crystal_array_8_global_geometry_element
#define this_box_storage mccchannel_15_analyzer_2_array_crystal_array_8_this_box_storage
#define material_string mccchannel_15_analyzer_2_array_crystal_array_8_material_string
#define priority mccchannel_15_analyzer_2_array_crystal_array_8_priority
#define xwidth mccchannel_15_analyzer_2_array_crystal_array_8_xwidth
#define yheight mccchannel_15_analyzer_2_array_crystal_array_8_yheight
#define zdepth mccchannel_15_analyzer_2_array_crystal_array_8_zdepth
#define xwidth2 mccchannel_15_analyzer_2_array_crystal_array_8_xwidth2
#define yheight2 mccchannel_15_analyzer_2_array_crystal_array_8_yheight2
#define visualize mccchannel_15_analyzer_2_array_crystal_array_8_visualize
#define target_index mccchannel_15_analyzer_2_array_crystal_array_8_target_index
#define target_x mccchannel_15_analyzer_2_array_crystal_array_8_target_x
#define target_y mccchannel_15_analyzer_2_array_crystal_array_8_target_y
#define target_z mccchannel_15_analyzer_2_array_crystal_array_8_target_z
#define focus_aw mccchannel_15_analyzer_2_array_crystal_array_8_focus_aw
#define focus_ah mccchannel_15_analyzer_2_array_crystal_array_8_focus_ah
#define focus_xw mccchannel_15_analyzer_2_array_crystal_array_8_focus_xw
#define focus_xh mccchannel_15_analyzer_2_array_crystal_array_8_focus_xh
#define focus_r mccchannel_15_analyzer_2_array_crystal_array_8_focus_r
#define p_interact mccchannel_15_analyzer_2_array_crystal_array_8_p_interact
#define mask_string mccchannel_15_analyzer_2_array_crystal_array_8_mask_string
#define mask_setting mccchannel_15_analyzer_2_array_crystal_array_8_mask_setting
#define number_of_activations mccchannel_15_analyzer_2_array_crystal_array_8_number_of_activations
#line 224 "Union_box.comp"
{
// Initializes the focusing system for this volume including input sanitation.
focus_initialize(&this_box_volume.geometry, POS_A_COMP_INDEX(INDEX_CURRENT_COMP+target_index), POS_A_CURRENT_COMP, ROT_A_CURRENT_COMP, target_index, target_x, target_y, target_z, focus_aw, focus_ah, focus_xw, focus_xh, focus_r, NAME_CURRENT_COMP);

// Input sanitation for this geometry
if (xwidth <= 0) {
  printf("\nERROR in Union_box named %s, the xwidth is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (yheight <= 0) {
  printf("\nERROR in Union_box named %s, yheight is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (zdepth <= 0) {
  printf("\nERROR in Union_box named %s, zdepth is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (xwidth2 <= 0 && xwidth2 != -1) {
  printf("\nERROR in Union_box named %s, the xwidth2 is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (yheight2 <= 0 && yheight2 != -1) {
  printf("\nERROR in Union_box named %s, yheight2 is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}

// Use sanitation
if (global_material_list.num_elements == 0) {
  printf("\nERROR: Need to define a material using Union_make_material before using a Union geometry component. \n");
  printf("       %s was defined before first use of Union_make_material.\n",NAME_CURRENT_COMP);
  exit(1);
}

this_box_volume.geometry.is_masked_volume = 0;
this_box_volume.geometry.is_exit_volume = 0;
this_box_volume.geometry.is_mask_volume = 0;
// check if the volume is a mask, if it is the material string is irelevant.
if (mask_string && strlen(mask_string) && strcmp(mask_string, "NULL") && strcmp(mask_string, "0")) {
    // A mask volume is used to limit the extend of other volumes, called the masked volumes. These are specified in the mask_string.
    // In order for a ray to enter a masked volume, it needs to be both in the region covered by that volume AND the mask volume.
    // When more than
    this_box_volume.geometry.mask_mode = 1; // Default is mask mode is ALL
    if (mask_setting && strlen(mask_setting) && strcmp(mask_setting, "NULL") && strcmp(mask_setting, "0")) {
        if (strcmp(mask_setting,"ALL") == 0 || strcmp(mask_setting,"All") == 0) this_box_volume.geometry.mask_mode = 1;
        else if (strcmp(mask_setting,"ANY") == 0 || strcmp(mask_setting,"Any") == 0) this_box_volume.geometry.mask_mode = 2;
        else {
            printf("The mask_mode of component %s is set to %s, but must be either ALL or ANY.\n",NAME_CURRENT_COMP,mask_setting);
            exit(1);
        }
    }
    
    for (loop_index=0;loop_index<global_geometry_list.num_elements;loop_index++) {
        // Add mask list
        if (1 == manual_linking_function(global_geometry_list.elements[loop_index].name,mask_string)) {
            add_element_to_int_list(&this_box_volume.geometry.mask_list,global_geometry_list.elements[loop_index].component_index);
            add_element_to_int_list(&global_geometry_list.elements[loop_index].Volume->geometry.masked_by_list,INDEX_CURRENT_COMP);
            global_geometry_list.elements[loop_index].Volume->geometry.is_masked_volume = 1;
            if (this_box_volume.geometry.mask_mode == 2)
                global_geometry_list.elements[loop_index].Volume->geometry.mask_mode = 2;
            if (this_box_volume.geometry.mask_mode == 1) {
                if (global_geometry_list.elements[loop_index].Volume->geometry.is_masked_volume == 1 && global_geometry_list.elements[loop_index].Volume->geometry.mask_mode != 2)
                    // If more than one mask is added to one volume, the ANY mode overwrites the (default) ALL mode.
                    global_geometry_list.elements[loop_index].Volume->geometry.mask_mode = 1;
            }
            
            found_geometries = 1;
        }
    }
    if (found_geometries == 0) {
        printf("The mask_string in geometry: %s did not find any of the specified volumes in the mask_string %s \n",NAME_CURRENT_COMP,mask_string);
        exit(1);
    }
    this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
    this_box_volume.p_physics->is_vacuum = 0; // Makes this volume a vacuum
    this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
    this_box_volume.p_physics->my_a = 0; // Should not be used.
    sprintf(this_box_volume.p_physics->name,"Mask");
    this_box_volume.geometry.is_mask_volume = 1;
    
    
// Read the material input, or if it lacks, use automatic linking.
} else if (material_string && strlen(material_string) && strcmp(material_string, "NULL") && strcmp(material_string, "0")) {
    // A geometry string was given, use it to determine which material
    if (0 == strcmp(material_string,"vacuum") || 0 == strcmp(material_string,"Vacuum")) {
        // One could have a global physics struct for vacuum instead of creating one for each
        this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
        this_box_volume.p_physics->is_vacuum = 1; // Makes this volume a vacuum
        this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
        this_box_volume.p_physics->my_a = 0; // Should not be used.
        sprintf(this_box_volume.p_physics->name,"Vacuum");
    } else if (0 == strcmp(material_string,"exit") || 0 == strcmp(material_string,"Exit")) {
        // One could have a global physics struct for vacuum instead of creating one for each
        this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
        this_box_volume.p_physics->is_vacuum = 1; // Makes this volume a vacuum
        this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
        this_box_volume.p_physics->my_a = 0; // Should not be used.
        this_box_volume.geometry.is_exit_volume = 1;
        sprintf(this_box_volume.p_physics->name,"Exit");
    } else {
        #ifndef MATERIAL_DETECTOR
            printf("Need to define a material before refering to it in a geometry %s.\n",NAME_CURRENT_COMP);
            exit(1);
        #endif
        for (loop_index=0;loop_index<global_material_list.num_elements;loop_index++) {
            if (0 == strcmp(material_string,global_material_list.elements[loop_index].name)) {
                this_box_volume.p_physics = global_material_list.elements[loop_index].physics;
                break;
            }
            if (loop_index == global_material_list.num_elements-1) {
            printf("\n");
            printf("ERROR: The material string \"%s\" in Union geometry \"%s\" did not match a specified material. \n",material_string,NAME_CURRENT_COMP);
            printf("       The materials available at this point (need to be defined before the geometry): \n");
            for (loop_index=0;loop_index<global_material_list.num_elements;loop_index++)
              printf("         %s\n",global_material_list.elements[loop_index].name);
            printf("\n");
            printf("       It is also possible to use one of the defualt materials avaiable: \n");
            printf("           Vacuum (for a Volume without scattering or absorption)\n");
            printf("           Exit (for a Volume where the ray exits the component if it enters)\n");
            printf("           Mask (for a Volume that masks existing volumes specified in the mask_string\n");
            exit(1);
          }
        }
    }
} else {
    // Automatic linking, simply using the last defined material.
    #ifndef MATERIAL_DETECTOR
        printf("Need to define a material before the geometry to use automatic linking %s.\n",NAME_CURRENT_COMP);
        exit(1);
    #endif
    this_box_volume.p_physics = global_material_list.elements[global_material_list.num_elements-1].physics;
}

sprintf(this_box_volume.name,NAME_CURRENT_COMP);
sprintf(this_box_volume.geometry.shape,"box");
this_box_volume.geometry.priority_value = priority;
this_box_volume.geometry.geometry_p_interact = p_interact;
// Currently the coordinates will be in absolute space.
this_box_volume.geometry.center = POS_A_CURRENT_COMP;

this_box_storage.z_depth = zdepth;
this_box_storage.x_width1 = xwidth;
this_box_storage.y_height1 = yheight;

this_box_storage.is_rectangle = 0;
if (xwidth2 < 0 && yheight2 < 0) this_box_storage.is_rectangle = 1;
if (xwidth == xwidth2 && yheight == yheight2) this_box_storage.is_rectangle = 1;

if (xwidth2 < 0) {
    this_box_storage.x_width2 = xwidth;
    xwidth2 = xwidth;
} else this_box_storage.x_width2 = xwidth2;

if (yheight2 < 0) {
    this_box_storage.y_height2 = yheight;
    yheight2 = yheight;
} else this_box_storage.y_height2 = yheight2;


this_box_storage.normal_vectors[0] = coords_set(0,0,1);
this_box_storage.normal_vectors[1] = coords_set(0,0,1);

// for sides with y component = 0
x_component = 2*zdepth/sqrt((xwidth-xwidth2)*(xwidth-xwidth2)+4*zdepth*zdepth);
z_component = (xwidth-xwidth2)/sqrt(4*zdepth*zdepth+(xwidth-xwidth2)*(xwidth-xwidth2));

this_box_storage.normal_vectors[2] = coords_set(x_component,0,z_component);
this_box_storage.normal_vectors[3] = coords_set(-x_component,0,z_component);

// for sides with x component = 0
y_component = 2*zdepth/sqrt((yheight-yheight2)*(yheight-yheight2)+4*zdepth*zdepth);
z_component = (yheight-yheight2)/sqrt(4*zdepth*zdepth+(yheight-yheight2)*(yheight-yheight2));

this_box_storage.normal_vectors[4] = coords_set(0,y_component,z_component);
this_box_storage.normal_vectors[5] = coords_set(0,-y_component,z_component);

this_box_volume.geometry.visualization_on = visualize;

this_box_volume.geometry.geometry_parameters.p_box_storage = &this_box_storage;

// Assign pointers to functions for intersection with the shape, checking if a point is inside the shape
if (this_box_storage.is_rectangle == 1) {
this_box_volume.geometry.intersect_function = &sample_box_intersect_simple;
this_box_volume.geometry.within_function = &r_within_box_simple;
}
else {
this_box_volume.geometry.intersect_function = &sample_box_intersect_advanced;
this_box_volume.geometry.within_function = &r_within_box_advanced;
}

this_box_volume.geometry.shell_points = &box_shell_points;
this_box_volume.geometry.mcdisplay_function = &mcdisplay_box_function;
this_box_volume.geometry.initialize_from_main_function = &initialize_box_geometry_from_main_component;
this_box_volume.geometry.process_rot_allocated = 0;

this_box_volume.geometry.copy_geometry_parameters = &allocate_box_storage_copy;

rot_copy(this_box_volume.geometry.rotation_matrix,ROT_A_CURRENT_COMP); //check how ROT_R_CURRENT_COMP would work
rot_transpose(ROT_A_CURRENT_COMP,this_box_volume.geometry.transpose_rotation_matrix);

// Initialize loggers
this_box_volume.loggers.num_elements = 0;

// packing the information into the global_geometry_element, which is then included in the global_geometry_list.
sprintf(global_geometry_element.name,NAME_CURRENT_COMP);
global_geometry_element.activation_counter = number_of_activations;
global_geometry_element.component_index = INDEX_CURRENT_COMP;
global_geometry_element.Volume = &this_box_volume; // Would be nicer if this m was a pointer, now we have the (small) data two places
add_element_to_geometry_list(&global_geometry_list,global_geometry_element);
}
#line 302534 "MACS_sample_kidney_box.c"
#undef number_of_activations
#undef mask_setting
#undef mask_string
#undef p_interact
#undef focus_r
#undef focus_xh
#undef focus_xw
#undef focus_ah
#undef focus_aw
#undef target_z
#undef target_y
#undef target_x
#undef target_index
#undef visualize
#undef yheight2
#undef xwidth2
#undef zdepth
#undef yheight
#undef xwidth
#undef priority
#undef material_string
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

  /* Initializations for component channel_15_cave2_cyl1. */
  SIG_MESSAGE("channel_15_cave2_cyl1 (Init)");
#define mccompcurname  channel_15_cave2_cyl1
#define mccompcurtype  Union_cylinder
#define mccompcurindex 720
#define loop_index mccchannel_15_cave2_cyl1_loop_index
#define this_cylinder_volume mccchannel_15_cave2_cyl1_this_cylinder_volume
#define global_geometry_element mccchannel_15_cave2_cyl1_global_geometry_element
#define this_cylinder_storage mccchannel_15_cave2_cyl1_this_cylinder_storage
#define material_string mccchannel_15_cave2_cyl1_material_string
#define priority mccchannel_15_cave2_cyl1_priority
#define radius mccchannel_15_cave2_cyl1_radius
#define yheight mccchannel_15_cave2_cyl1_yheight
#define visualize mccchannel_15_cave2_cyl1_visualize
#define target_index mccchannel_15_cave2_cyl1_target_index
#define target_x mccchannel_15_cave2_cyl1_target_x
#define target_y mccchannel_15_cave2_cyl1_target_y
#define target_z mccchannel_15_cave2_cyl1_target_z
#define focus_aw mccchannel_15_cave2_cyl1_focus_aw
#define focus_ah mccchannel_15_cave2_cyl1_focus_ah
#define focus_xw mccchannel_15_cave2_cyl1_focus_xw
#define focus_xh mccchannel_15_cave2_cyl1_focus_xh
#define focus_r mccchannel_15_cave2_cyl1_focus_r
#define p_interact mccchannel_15_cave2_cyl1_p_interact
#define mask_string mccchannel_15_cave2_cyl1_mask_string
#define mask_setting mccchannel_15_cave2_cyl1_mask_setting
#define number_of_activations mccchannel_15_cave2_cyl1_number_of_activations
#line 185 "Union_cylinder.comp"
{
// Initializes the focusing system for this volume including input sanitation.
focus_initialize(&this_cylinder_volume.geometry, POS_A_COMP_INDEX(INDEX_CURRENT_COMP+target_index), POS_A_CURRENT_COMP, ROT_A_CURRENT_COMP, target_index, target_x, target_y, target_z, focus_aw, focus_ah, focus_xw, focus_xh, focus_r, NAME_CURRENT_COMP);

// Input sanitation for this geometry
if (radius <= 0) {
  printf("\nERROR in Union_cylinder named %s, the radius is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}

if (yheight <= 0) {
  printf("\nERROR in Union_cylinder named %s, yheight is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}

// Use sanitation
#ifdef MATERIAL_DETECTOR
if (global_material_list.num_elements == 0) {
  // Here if the user have defined a material, but only after this material
  printf("\nERROR: Need to define a material using Union_make_material before using a Union geometry component. \n");
  printf("       %s was defined before first use of Union_make_material.\n",NAME_CURRENT_COMP);
  exit(1);
}
#endif
#ifndef MATERIAL_DETECTOR
  printf("\nERROR: Need to define a material using Union_make_material before using a Union geometry component. \n");
  exit(1);
#endif


this_cylinder_volume.geometry.is_masked_volume = 0;
this_cylinder_volume.geometry.is_exit_volume = 0;
this_cylinder_volume.geometry.is_mask_volume = 0;

// Read the material input, or if it lacks, use automatic linking.
if (mask_string && strlen(mask_string) && strcmp(mask_string, "NULL") && strcmp(mask_string, "0")) {
    // A mask volume is used to limit the extend of other volumes, called the masked volumes. These are specified in the mask_string.
    // In order for a ray to enter a masked volume, it needs to be both in the region covered by that volume AND the mask volume.
    // When more than
    this_cylinder_volume.geometry.mask_mode = 1; // Default is mask mode is ALL
    if (mask_setting && strlen(mask_setting) && strcmp(mask_setting, "NULL") && strcmp(mask_setting, "0")) {
        if (strcmp(mask_setting,"ALL") == 0 || strcmp(mask_setting,"All") == 0) this_cylinder_volume.geometry.mask_mode = 1;
        else if (strcmp(mask_setting,"ANY") == 0 || strcmp(mask_setting,"Any") == 0) this_cylinder_volume.geometry.mask_mode = 2;
        else {
            printf("The mask_mode of component %s is set to %s, but must be either ALL or ANY.\n",NAME_CURRENT_COMP,mask_setting);
            exit(1);
        }
    }
    
    for (loop_index=0;loop_index<global_geometry_list.num_elements;loop_index++) {
        // Add mask list
        if (1 == manual_linking_function(global_geometry_list.elements[loop_index].name,mask_string)) {
            add_element_to_int_list(&this_cylinder_volume.geometry.mask_list,global_geometry_list.elements[loop_index].component_index);
            add_element_to_int_list(&global_geometry_list.elements[loop_index].Volume->geometry.masked_by_list,INDEX_CURRENT_COMP);
            global_geometry_list.elements[loop_index].Volume->geometry.is_masked_volume = 1;
            if (this_cylinder_volume.geometry.mask_mode == 2)
                global_geometry_list.elements[loop_index].Volume->geometry.mask_mode = 2;
            if (this_cylinder_volume.geometry.mask_mode == 1) {
                if (global_geometry_list.elements[loop_index].Volume->geometry.is_masked_volume == 1 && global_geometry_list.elements[loop_index].Volume->geometry.mask_mode != 2)
                    // If more than one mask is added to one volume, the ANY mode overwrites the (default) ALL mode.
                    global_geometry_list.elements[loop_index].Volume->geometry.mask_mode = 1;
            }
            
            found_geometries = 1;
        }
    }
    if (found_geometries == 0) {
        printf("The mask_string in geometry: %s did not find any of the specified volumes in the mask_string %s \n",NAME_CURRENT_COMP,mask_string);
        exit(1);
    }
    this_cylinder_volume.p_physics = malloc(sizeof(struct physics_struct));
    this_cylinder_volume.p_physics->is_vacuum = 0; // Makes this volume a vacuum
    this_cylinder_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
    this_cylinder_volume.p_physics->my_a = 0; // Should not be used.
    sprintf(this_cylinder_volume.p_physics->name,"Mask");
    this_cylinder_volume.geometry.is_mask_volume = 1;
    
    
// Read the material input, or if it lacks, use automatic linking.
} else if (material_string && strlen(material_string) && strcmp(material_string, "NULL") && strcmp(material_string, "0")) {
    // A geometry string was given, use it to determine which material
    if (0 == strcmp(material_string,"vacuum") || 0 == strcmp(material_string,"Vacuum")) {
        // One could have a global physics struct for vacuum instead of creating one for each
        this_cylinder_volume.p_physics = malloc(sizeof(struct physics_struct));
        this_cylinder_volume.p_physics->is_vacuum = 1; // Makes this volume a vacuum
        this_cylinder_volume.p_physics->number_of_processes = (int) 0;
        this_cylinder_volume.p_physics->my_a = 0; // Should not be used.
        sprintf(this_cylinder_volume.p_physics->name,"Vacuum");
    } else if (0 == strcmp(material_string,"exit") || 0 == strcmp(material_string,"Exit")) {
        // One could have a global physics struct for exit instead of creating one for each
        this_cylinder_volume.p_physics = malloc(sizeof(struct physics_struct));
        this_cylinder_volume.p_physics->is_vacuum = 1; // Makes this volume a vacuum
        this_cylinder_volume.p_physics->number_of_processes = (int) 0;
        this_cylinder_volume.p_physics->my_a = 0; // Should not be used.
        this_cylinder_volume.geometry.is_exit_volume = 1;
        sprintf(this_cylinder_volume.p_physics->name,"Exit");
    } else {
        for (loop_index=0;loop_index<global_material_list.num_elements;loop_index++) {
          if (0 == strcmp(material_string,global_material_list.elements[loop_index].name)) {
            this_cylinder_volume.p_physics = global_material_list.elements[loop_index].physics;
            break;
          }
          if (loop_index == global_material_list.num_elements-1) {
            printf("\n");
            printf("ERROR: The material string \"%s\" in Union geometry \"%s\" did not match a specified material. \n",material_string,NAME_CURRENT_COMP);
            printf("       The materials available at this point (need to be defined before the geometry): \n");
            for (loop_index=0;loop_index<global_material_list.num_elements;loop_index++)
              printf("         %s\n",global_material_list.elements[loop_index].name);
            printf("\n");
            printf("       It is also possible to use one of the defualt materials avaiable: \n");
            printf("           Vacuum (for a Volume without scattering or absorption)\n");
            printf("           Exit (for a Volume where the ray exits the component if it enters)\n");
            printf("           Mask (for a Volume that masks existing volumes specified in the mask_string\n");
            exit(1);
          }
        }
    }
} else {
    // Automatic linking, simply using the last defined material.
    #ifndef MATERIAL_DETECTOR
        printf("Need to define a material before the geometry to use automatic linking %s.\n",NAME_CURRENT_COMP);
        exit(1);
    #endif
    this_cylinder_volume.p_physics = global_material_list.elements[global_material_list.num_elements-1].physics;
}

sprintf(this_cylinder_volume.name,NAME_CURRENT_COMP);
sprintf(this_cylinder_volume.geometry.shape,"cylinder");
this_cylinder_volume.geometry.priority_value = priority;
// Currently the coordinates will be in absolute space.
this_cylinder_volume.geometry.center = POS_A_CURRENT_COMP;

this_cylinder_volume.geometry.geometry_p_interact = p_interact;
this_cylinder_storage.cyl_radius = radius;
this_cylinder_storage.height = yheight;
this_cylinder_volume.geometry.visualization_on = visualize;
this_cylinder_volume.geometry.geometry_parameters.p_cylinder_storage = &this_cylinder_storage;
this_cylinder_volume.geometry.within_function = &r_within_cylinder;
this_cylinder_volume.geometry.intersect_function = &sample_cylinder_intersect;
this_cylinder_volume.geometry.mcdisplay_function = &mcdisplay_cylinder_function;
this_cylinder_volume.geometry.shell_points = &cylinder_shell_points;
this_cylinder_volume.geometry.initialize_from_main_function = &initialize_cylinder_geometry_from_main_component;
this_cylinder_volume.geometry.process_rot_allocated = 0;
this_cylinder_volume.geometry.copy_geometry_parameters = &allocate_cylinder_storage_copy;

rot_copy(this_cylinder_volume.geometry.rotation_matrix,ROT_A_CURRENT_COMP);
rot_transpose(ROT_A_CURRENT_COMP,this_cylinder_volume.geometry.transpose_rotation_matrix);

// Initialize loggers
this_cylinder_volume.loggers.num_elements = 0;

// packing the information into the global_geometry_element, which is then included in the global_geometry_list.
sprintf(global_geometry_element.name,NAME_CURRENT_COMP);
global_geometry_element.activation_counter = number_of_activations;
global_geometry_element.component_index = INDEX_CURRENT_COMP;
global_geometry_element.Volume = &this_cylinder_volume; // Would be nicer if this m was a pointer, now we have the (small) data two places
add_element_to_geometry_list(&global_geometry_list,global_geometry_element);
}
#line 302750 "MACS_sample_kidney_box.c"
#undef number_of_activations
#undef mask_setting
#undef mask_string
#undef p_interact
#undef focus_r
#undef focus_xh
#undef focus_xw
#undef focus_ah
#undef focus_aw
#undef target_z
#undef target_y
#undef target_x
#undef target_index
#undef visualize
#undef yheight
#undef radius
#undef priority
#undef material_string
#undef this_cylinder_storage
#undef global_geometry_element
#undef this_cylinder_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

  /* Initializations for component channel_15_cave2_box1. */
  SIG_MESSAGE("channel_15_cave2_box1 (Init)");
#define mccompcurname  channel_15_cave2_box1
#define mccompcurtype  Union_box
#define mccompcurindex 721
#define loop_index mccchannel_15_cave2_box1_loop_index
#define this_box_volume mccchannel_15_cave2_box1_this_box_volume
#define global_geometry_element mccchannel_15_cave2_box1_global_geometry_element
#define this_box_storage mccchannel_15_cave2_box1_this_box_storage
#define material_string mccchannel_15_cave2_box1_material_string
#define priority mccchannel_15_cave2_box1_priority
#define xwidth mccchannel_15_cave2_box1_xwidth
#define yheight mccchannel_15_cave2_box1_yheight
#define zdepth mccchannel_15_cave2_box1_zdepth
#define xwidth2 mccchannel_15_cave2_box1_xwidth2
#define yheight2 mccchannel_15_cave2_box1_yheight2
#define visualize mccchannel_15_cave2_box1_visualize
#define target_index mccchannel_15_cave2_box1_target_index
#define target_x mccchannel_15_cave2_box1_target_x
#define target_y mccchannel_15_cave2_box1_target_y
#define target_z mccchannel_15_cave2_box1_target_z
#define focus_aw mccchannel_15_cave2_box1_focus_aw
#define focus_ah mccchannel_15_cave2_box1_focus_ah
#define focus_xw mccchannel_15_cave2_box1_focus_xw
#define focus_xh mccchannel_15_cave2_box1_focus_xh
#define focus_r mccchannel_15_cave2_box1_focus_r
#define p_interact mccchannel_15_cave2_box1_p_interact
#define mask_string mccchannel_15_cave2_box1_mask_string
#define mask_setting mccchannel_15_cave2_box1_mask_setting
#define number_of_activations mccchannel_15_cave2_box1_number_of_activations
#line 224 "Union_box.comp"
{
// Initializes the focusing system for this volume including input sanitation.
focus_initialize(&this_box_volume.geometry, POS_A_COMP_INDEX(INDEX_CURRENT_COMP+target_index), POS_A_CURRENT_COMP, ROT_A_CURRENT_COMP, target_index, target_x, target_y, target_z, focus_aw, focus_ah, focus_xw, focus_xh, focus_r, NAME_CURRENT_COMP);

// Input sanitation for this geometry
if (xwidth <= 0) {
  printf("\nERROR in Union_box named %s, the xwidth is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (yheight <= 0) {
  printf("\nERROR in Union_box named %s, yheight is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (zdepth <= 0) {
  printf("\nERROR in Union_box named %s, zdepth is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (xwidth2 <= 0 && xwidth2 != -1) {
  printf("\nERROR in Union_box named %s, the xwidth2 is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (yheight2 <= 0 && yheight2 != -1) {
  printf("\nERROR in Union_box named %s, yheight2 is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}

// Use sanitation
if (global_material_list.num_elements == 0) {
  printf("\nERROR: Need to define a material using Union_make_material before using a Union geometry component. \n");
  printf("       %s was defined before first use of Union_make_material.\n",NAME_CURRENT_COMP);
  exit(1);
}

this_box_volume.geometry.is_masked_volume = 0;
this_box_volume.geometry.is_exit_volume = 0;
this_box_volume.geometry.is_mask_volume = 0;
// check if the volume is a mask, if it is the material string is irelevant.
if (mask_string && strlen(mask_string) && strcmp(mask_string, "NULL") && strcmp(mask_string, "0")) {
    // A mask volume is used to limit the extend of other volumes, called the masked volumes. These are specified in the mask_string.
    // In order for a ray to enter a masked volume, it needs to be both in the region covered by that volume AND the mask volume.
    // When more than
    this_box_volume.geometry.mask_mode = 1; // Default is mask mode is ALL
    if (mask_setting && strlen(mask_setting) && strcmp(mask_setting, "NULL") && strcmp(mask_setting, "0")) {
        if (strcmp(mask_setting,"ALL") == 0 || strcmp(mask_setting,"All") == 0) this_box_volume.geometry.mask_mode = 1;
        else if (strcmp(mask_setting,"ANY") == 0 || strcmp(mask_setting,"Any") == 0) this_box_volume.geometry.mask_mode = 2;
        else {
            printf("The mask_mode of component %s is set to %s, but must be either ALL or ANY.\n",NAME_CURRENT_COMP,mask_setting);
            exit(1);
        }
    }
    
    for (loop_index=0;loop_index<global_geometry_list.num_elements;loop_index++) {
        // Add mask list
        if (1 == manual_linking_function(global_geometry_list.elements[loop_index].name,mask_string)) {
            add_element_to_int_list(&this_box_volume.geometry.mask_list,global_geometry_list.elements[loop_index].component_index);
            add_element_to_int_list(&global_geometry_list.elements[loop_index].Volume->geometry.masked_by_list,INDEX_CURRENT_COMP);
            global_geometry_list.elements[loop_index].Volume->geometry.is_masked_volume = 1;
            if (this_box_volume.geometry.mask_mode == 2)
                global_geometry_list.elements[loop_index].Volume->geometry.mask_mode = 2;
            if (this_box_volume.geometry.mask_mode == 1) {
                if (global_geometry_list.elements[loop_index].Volume->geometry.is_masked_volume == 1 && global_geometry_list.elements[loop_index].Volume->geometry.mask_mode != 2)
                    // If more than one mask is added to one volume, the ANY mode overwrites the (default) ALL mode.
                    global_geometry_list.elements[loop_index].Volume->geometry.mask_mode = 1;
            }
            
            found_geometries = 1;
        }
    }
    if (found_geometries == 0) {
        printf("The mask_string in geometry: %s did not find any of the specified volumes in the mask_string %s \n",NAME_CURRENT_COMP,mask_string);
        exit(1);
    }
    this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
    this_box_volume.p_physics->is_vacuum = 0; // Makes this volume a vacuum
    this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
    this_box_volume.p_physics->my_a = 0; // Should not be used.
    sprintf(this_box_volume.p_physics->name,"Mask");
    this_box_volume.geometry.is_mask_volume = 1;
    
    
// Read the material input, or if it lacks, use automatic linking.
} else if (material_string && strlen(material_string) && strcmp(material_string, "NULL") && strcmp(material_string, "0")) {
    // A geometry string was given, use it to determine which material
    if (0 == strcmp(material_string,"vacuum") || 0 == strcmp(material_string,"Vacuum")) {
        // One could have a global physics struct for vacuum instead of creating one for each
        this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
        this_box_volume.p_physics->is_vacuum = 1; // Makes this volume a vacuum
        this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
        this_box_volume.p_physics->my_a = 0; // Should not be used.
        sprintf(this_box_volume.p_physics->name,"Vacuum");
    } else if (0 == strcmp(material_string,"exit") || 0 == strcmp(material_string,"Exit")) {
        // One could have a global physics struct for vacuum instead of creating one for each
        this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
        this_box_volume.p_physics->is_vacuum = 1; // Makes this volume a vacuum
        this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
        this_box_volume.p_physics->my_a = 0; // Should not be used.
        this_box_volume.geometry.is_exit_volume = 1;
        sprintf(this_box_volume.p_physics->name,"Exit");
    } else {
        #ifndef MATERIAL_DETECTOR
            printf("Need to define a material before refering to it in a geometry %s.\n",NAME_CURRENT_COMP);
            exit(1);
        #endif
        for (loop_index=0;loop_index<global_material_list.num_elements;loop_index++) {
            if (0 == strcmp(material_string,global_material_list.elements[loop_index].name)) {
                this_box_volume.p_physics = global_material_list.elements[loop_index].physics;
                break;
            }
            if (loop_index == global_material_list.num_elements-1) {
            printf("\n");
            printf("ERROR: The material string \"%s\" in Union geometry \"%s\" did not match a specified material. \n",material_string,NAME_CURRENT_COMP);
            printf("       The materials available at this point (need to be defined before the geometry): \n");
            for (loop_index=0;loop_index<global_material_list.num_elements;loop_index++)
              printf("         %s\n",global_material_list.elements[loop_index].name);
            printf("\n");
            printf("       It is also possible to use one of the defualt materials avaiable: \n");
            printf("           Vacuum (for a Volume without scattering or absorption)\n");
            printf("           Exit (for a Volume where the ray exits the component if it enters)\n");
            printf("           Mask (for a Volume that masks existing volumes specified in the mask_string\n");
            exit(1);
          }
        }
    }
} else {
    // Automatic linking, simply using the last defined material.
    #ifndef MATERIAL_DETECTOR
        printf("Need to define a material before the geometry to use automatic linking %s.\n",NAME_CURRENT_COMP);
        exit(1);
    #endif
    this_box_volume.p_physics = global_material_list.elements[global_material_list.num_elements-1].physics;
}

sprintf(this_box_volume.name,NAME_CURRENT_COMP);
sprintf(this_box_volume.geometry.shape,"box");
this_box_volume.geometry.priority_value = priority;
this_box_volume.geometry.geometry_p_interact = p_interact;
// Currently the coordinates will be in absolute space.
this_box_volume.geometry.center = POS_A_CURRENT_COMP;

this_box_storage.z_depth = zdepth;
this_box_storage.x_width1 = xwidth;
this_box_storage.y_height1 = yheight;

this_box_storage.is_rectangle = 0;
if (xwidth2 < 0 && yheight2 < 0) this_box_storage.is_rectangle = 1;
if (xwidth == xwidth2 && yheight == yheight2) this_box_storage.is_rectangle = 1;

if (xwidth2 < 0) {
    this_box_storage.x_width2 = xwidth;
    xwidth2 = xwidth;
} else this_box_storage.x_width2 = xwidth2;

if (yheight2 < 0) {
    this_box_storage.y_height2 = yheight;
    yheight2 = yheight;
} else this_box_storage.y_height2 = yheight2;


this_box_storage.normal_vectors[0] = coords_set(0,0,1);
this_box_storage.normal_vectors[1] = coords_set(0,0,1);

// for sides with y component = 0
x_component = 2*zdepth/sqrt((xwidth-xwidth2)*(xwidth-xwidth2)+4*zdepth*zdepth);
z_component = (xwidth-xwidth2)/sqrt(4*zdepth*zdepth+(xwidth-xwidth2)*(xwidth-xwidth2));

this_box_storage.normal_vectors[2] = coords_set(x_component,0,z_component);
this_box_storage.normal_vectors[3] = coords_set(-x_component,0,z_component);

// for sides with x component = 0
y_component = 2*zdepth/sqrt((yheight-yheight2)*(yheight-yheight2)+4*zdepth*zdepth);
z_component = (yheight-yheight2)/sqrt(4*zdepth*zdepth+(yheight-yheight2)*(yheight-yheight2));

this_box_storage.normal_vectors[4] = coords_set(0,y_component,z_component);
this_box_storage.normal_vectors[5] = coords_set(0,-y_component,z_component);

this_box_volume.geometry.visualization_on = visualize;

this_box_volume.geometry.geometry_parameters.p_box_storage = &this_box_storage;

// Assign pointers to functions for intersection with the shape, checking if a point is inside the shape
if (this_box_storage.is_rectangle == 1) {
this_box_volume.geometry.intersect_function = &sample_box_intersect_simple;
this_box_volume.geometry.within_function = &r_within_box_simple;
}
else {
this_box_volume.geometry.intersect_function = &sample_box_intersect_advanced;
this_box_volume.geometry.within_function = &r_within_box_advanced;
}

this_box_volume.geometry.shell_points = &box_shell_points;
this_box_volume.geometry.mcdisplay_function = &mcdisplay_box_function;
this_box_volume.geometry.initialize_from_main_function = &initialize_box_geometry_from_main_component;
this_box_volume.geometry.process_rot_allocated = 0;

this_box_volume.geometry.copy_geometry_parameters = &allocate_box_storage_copy;

rot_copy(this_box_volume.geometry.rotation_matrix,ROT_A_CURRENT_COMP); //check how ROT_R_CURRENT_COMP would work
rot_transpose(ROT_A_CURRENT_COMP,this_box_volume.geometry.transpose_rotation_matrix);

// Initialize loggers
this_box_volume.loggers.num_elements = 0;

// packing the information into the global_geometry_element, which is then included in the global_geometry_list.
sprintf(global_geometry_element.name,NAME_CURRENT_COMP);
global_geometry_element.activation_counter = number_of_activations;
global_geometry_element.component_index = INDEX_CURRENT_COMP;
global_geometry_element.Volume = &this_box_volume; // Would be nicer if this m was a pointer, now we have the (small) data two places
add_element_to_geometry_list(&global_geometry_list,global_geometry_element);
}
#line 303017 "MACS_sample_kidney_box.c"
#undef number_of_activations
#undef mask_setting
#undef mask_string
#undef p_interact
#undef focus_r
#undef focus_xh
#undef focus_xw
#undef focus_ah
#undef focus_aw
#undef target_z
#undef target_y
#undef target_x
#undef target_index
#undef visualize
#undef yheight2
#undef xwidth2
#undef zdepth
#undef yheight
#undef xwidth
#undef priority
#undef material_string
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

  /* Initializations for component channel_15_cave2_box2. */
  SIG_MESSAGE("channel_15_cave2_box2 (Init)");
#define mccompcurname  channel_15_cave2_box2
#define mccompcurtype  Union_box
#define mccompcurindex 722
#define loop_index mccchannel_15_cave2_box2_loop_index
#define this_box_volume mccchannel_15_cave2_box2_this_box_volume
#define global_geometry_element mccchannel_15_cave2_box2_global_geometry_element
#define this_box_storage mccchannel_15_cave2_box2_this_box_storage
#define material_string mccchannel_15_cave2_box2_material_string
#define priority mccchannel_15_cave2_box2_priority
#define xwidth mccchannel_15_cave2_box2_xwidth
#define yheight mccchannel_15_cave2_box2_yheight
#define zdepth mccchannel_15_cave2_box2_zdepth
#define xwidth2 mccchannel_15_cave2_box2_xwidth2
#define yheight2 mccchannel_15_cave2_box2_yheight2
#define visualize mccchannel_15_cave2_box2_visualize
#define target_index mccchannel_15_cave2_box2_target_index
#define target_x mccchannel_15_cave2_box2_target_x
#define target_y mccchannel_15_cave2_box2_target_y
#define target_z mccchannel_15_cave2_box2_target_z
#define focus_aw mccchannel_15_cave2_box2_focus_aw
#define focus_ah mccchannel_15_cave2_box2_focus_ah
#define focus_xw mccchannel_15_cave2_box2_focus_xw
#define focus_xh mccchannel_15_cave2_box2_focus_xh
#define focus_r mccchannel_15_cave2_box2_focus_r
#define p_interact mccchannel_15_cave2_box2_p_interact
#define mask_string mccchannel_15_cave2_box2_mask_string
#define mask_setting mccchannel_15_cave2_box2_mask_setting
#define number_of_activations mccchannel_15_cave2_box2_number_of_activations
#line 224 "Union_box.comp"
{
// Initializes the focusing system for this volume including input sanitation.
focus_initialize(&this_box_volume.geometry, POS_A_COMP_INDEX(INDEX_CURRENT_COMP+target_index), POS_A_CURRENT_COMP, ROT_A_CURRENT_COMP, target_index, target_x, target_y, target_z, focus_aw, focus_ah, focus_xw, focus_xh, focus_r, NAME_CURRENT_COMP);

// Input sanitation for this geometry
if (xwidth <= 0) {
  printf("\nERROR in Union_box named %s, the xwidth is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (yheight <= 0) {
  printf("\nERROR in Union_box named %s, yheight is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (zdepth <= 0) {
  printf("\nERROR in Union_box named %s, zdepth is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (xwidth2 <= 0 && xwidth2 != -1) {
  printf("\nERROR in Union_box named %s, the xwidth2 is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (yheight2 <= 0 && yheight2 != -1) {
  printf("\nERROR in Union_box named %s, yheight2 is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}

// Use sanitation
if (global_material_list.num_elements == 0) {
  printf("\nERROR: Need to define a material using Union_make_material before using a Union geometry component. \n");
  printf("       %s was defined before first use of Union_make_material.\n",NAME_CURRENT_COMP);
  exit(1);
}

this_box_volume.geometry.is_masked_volume = 0;
this_box_volume.geometry.is_exit_volume = 0;
this_box_volume.geometry.is_mask_volume = 0;
// check if the volume is a mask, if it is the material string is irelevant.
if (mask_string && strlen(mask_string) && strcmp(mask_string, "NULL") && strcmp(mask_string, "0")) {
    // A mask volume is used to limit the extend of other volumes, called the masked volumes. These are specified in the mask_string.
    // In order for a ray to enter a masked volume, it needs to be both in the region covered by that volume AND the mask volume.
    // When more than
    this_box_volume.geometry.mask_mode = 1; // Default is mask mode is ALL
    if (mask_setting && strlen(mask_setting) && strcmp(mask_setting, "NULL") && strcmp(mask_setting, "0")) {
        if (strcmp(mask_setting,"ALL") == 0 || strcmp(mask_setting,"All") == 0) this_box_volume.geometry.mask_mode = 1;
        else if (strcmp(mask_setting,"ANY") == 0 || strcmp(mask_setting,"Any") == 0) this_box_volume.geometry.mask_mode = 2;
        else {
            printf("The mask_mode of component %s is set to %s, but must be either ALL or ANY.\n",NAME_CURRENT_COMP,mask_setting);
            exit(1);
        }
    }
    
    for (loop_index=0;loop_index<global_geometry_list.num_elements;loop_index++) {
        // Add mask list
        if (1 == manual_linking_function(global_geometry_list.elements[loop_index].name,mask_string)) {
            add_element_to_int_list(&this_box_volume.geometry.mask_list,global_geometry_list.elements[loop_index].component_index);
            add_element_to_int_list(&global_geometry_list.elements[loop_index].Volume->geometry.masked_by_list,INDEX_CURRENT_COMP);
            global_geometry_list.elements[loop_index].Volume->geometry.is_masked_volume = 1;
            if (this_box_volume.geometry.mask_mode == 2)
                global_geometry_list.elements[loop_index].Volume->geometry.mask_mode = 2;
            if (this_box_volume.geometry.mask_mode == 1) {
                if (global_geometry_list.elements[loop_index].Volume->geometry.is_masked_volume == 1 && global_geometry_list.elements[loop_index].Volume->geometry.mask_mode != 2)
                    // If more than one mask is added to one volume, the ANY mode overwrites the (default) ALL mode.
                    global_geometry_list.elements[loop_index].Volume->geometry.mask_mode = 1;
            }
            
            found_geometries = 1;
        }
    }
    if (found_geometries == 0) {
        printf("The mask_string in geometry: %s did not find any of the specified volumes in the mask_string %s \n",NAME_CURRENT_COMP,mask_string);
        exit(1);
    }
    this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
    this_box_volume.p_physics->is_vacuum = 0; // Makes this volume a vacuum
    this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
    this_box_volume.p_physics->my_a = 0; // Should not be used.
    sprintf(this_box_volume.p_physics->name,"Mask");
    this_box_volume.geometry.is_mask_volume = 1;
    
    
// Read the material input, or if it lacks, use automatic linking.
} else if (material_string && strlen(material_string) && strcmp(material_string, "NULL") && strcmp(material_string, "0")) {
    // A geometry string was given, use it to determine which material
    if (0 == strcmp(material_string,"vacuum") || 0 == strcmp(material_string,"Vacuum")) {
        // One could have a global physics struct for vacuum instead of creating one for each
        this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
        this_box_volume.p_physics->is_vacuum = 1; // Makes this volume a vacuum
        this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
        this_box_volume.p_physics->my_a = 0; // Should not be used.
        sprintf(this_box_volume.p_physics->name,"Vacuum");
    } else if (0 == strcmp(material_string,"exit") || 0 == strcmp(material_string,"Exit")) {
        // One could have a global physics struct for vacuum instead of creating one for each
        this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
        this_box_volume.p_physics->is_vacuum = 1; // Makes this volume a vacuum
        this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
        this_box_volume.p_physics->my_a = 0; // Should not be used.
        this_box_volume.geometry.is_exit_volume = 1;
        sprintf(this_box_volume.p_physics->name,"Exit");
    } else {
        #ifndef MATERIAL_DETECTOR
            printf("Need to define a material before refering to it in a geometry %s.\n",NAME_CURRENT_COMP);
            exit(1);
        #endif
        for (loop_index=0;loop_index<global_material_list.num_elements;loop_index++) {
            if (0 == strcmp(material_string,global_material_list.elements[loop_index].name)) {
                this_box_volume.p_physics = global_material_list.elements[loop_index].physics;
                break;
            }
            if (loop_index == global_material_list.num_elements-1) {
            printf("\n");
            printf("ERROR: The material string \"%s\" in Union geometry \"%s\" did not match a specified material. \n",material_string,NAME_CURRENT_COMP);
            printf("       The materials available at this point (need to be defined before the geometry): \n");
            for (loop_index=0;loop_index<global_material_list.num_elements;loop_index++)
              printf("         %s\n",global_material_list.elements[loop_index].name);
            printf("\n");
            printf("       It is also possible to use one of the defualt materials avaiable: \n");
            printf("           Vacuum (for a Volume without scattering or absorption)\n");
            printf("           Exit (for a Volume where the ray exits the component if it enters)\n");
            printf("           Mask (for a Volume that masks existing volumes specified in the mask_string\n");
            exit(1);
          }
        }
    }
} else {
    // Automatic linking, simply using the last defined material.
    #ifndef MATERIAL_DETECTOR
        printf("Need to define a material before the geometry to use automatic linking %s.\n",NAME_CURRENT_COMP);
        exit(1);
    #endif
    this_box_volume.p_physics = global_material_list.elements[global_material_list.num_elements-1].physics;
}

sprintf(this_box_volume.name,NAME_CURRENT_COMP);
sprintf(this_box_volume.geometry.shape,"box");
this_box_volume.geometry.priority_value = priority;
this_box_volume.geometry.geometry_p_interact = p_interact;
// Currently the coordinates will be in absolute space.
this_box_volume.geometry.center = POS_A_CURRENT_COMP;

this_box_storage.z_depth = zdepth;
this_box_storage.x_width1 = xwidth;
this_box_storage.y_height1 = yheight;

this_box_storage.is_rectangle = 0;
if (xwidth2 < 0 && yheight2 < 0) this_box_storage.is_rectangle = 1;
if (xwidth == xwidth2 && yheight == yheight2) this_box_storage.is_rectangle = 1;

if (xwidth2 < 0) {
    this_box_storage.x_width2 = xwidth;
    xwidth2 = xwidth;
} else this_box_storage.x_width2 = xwidth2;

if (yheight2 < 0) {
    this_box_storage.y_height2 = yheight;
    yheight2 = yheight;
} else this_box_storage.y_height2 = yheight2;


this_box_storage.normal_vectors[0] = coords_set(0,0,1);
this_box_storage.normal_vectors[1] = coords_set(0,0,1);

// for sides with y component = 0
x_component = 2*zdepth/sqrt((xwidth-xwidth2)*(xwidth-xwidth2)+4*zdepth*zdepth);
z_component = (xwidth-xwidth2)/sqrt(4*zdepth*zdepth+(xwidth-xwidth2)*(xwidth-xwidth2));

this_box_storage.normal_vectors[2] = coords_set(x_component,0,z_component);
this_box_storage.normal_vectors[3] = coords_set(-x_component,0,z_component);

// for sides with x component = 0
y_component = 2*zdepth/sqrt((yheight-yheight2)*(yheight-yheight2)+4*zdepth*zdepth);
z_component = (yheight-yheight2)/sqrt(4*zdepth*zdepth+(yheight-yheight2)*(yheight-yheight2));

this_box_storage.normal_vectors[4] = coords_set(0,y_component,z_component);
this_box_storage.normal_vectors[5] = coords_set(0,-y_component,z_component);

this_box_volume.geometry.visualization_on = visualize;

this_box_volume.geometry.geometry_parameters.p_box_storage = &this_box_storage;

// Assign pointers to functions for intersection with the shape, checking if a point is inside the shape
if (this_box_storage.is_rectangle == 1) {
this_box_volume.geometry.intersect_function = &sample_box_intersect_simple;
this_box_volume.geometry.within_function = &r_within_box_simple;
}
else {
this_box_volume.geometry.intersect_function = &sample_box_intersect_advanced;
this_box_volume.geometry.within_function = &r_within_box_advanced;
}

this_box_volume.geometry.shell_points = &box_shell_points;
this_box_volume.geometry.mcdisplay_function = &mcdisplay_box_function;
this_box_volume.geometry.initialize_from_main_function = &initialize_box_geometry_from_main_component;
this_box_volume.geometry.process_rot_allocated = 0;

this_box_volume.geometry.copy_geometry_parameters = &allocate_box_storage_copy;

rot_copy(this_box_volume.geometry.rotation_matrix,ROT_A_CURRENT_COMP); //check how ROT_R_CURRENT_COMP would work
rot_transpose(ROT_A_CURRENT_COMP,this_box_volume.geometry.transpose_rotation_matrix);

// Initialize loggers
this_box_volume.loggers.num_elements = 0;

// packing the information into the global_geometry_element, which is then included in the global_geometry_list.
sprintf(global_geometry_element.name,NAME_CURRENT_COMP);
global_geometry_element.activation_counter = number_of_activations;
global_geometry_element.component_index = INDEX_CURRENT_COMP;
global_geometry_element.Volume = &this_box_volume; // Would be nicer if this m was a pointer, now we have the (small) data two places
add_element_to_geometry_list(&global_geometry_list,global_geometry_element);
}
#line 303287 "MACS_sample_kidney_box.c"
#undef number_of_activations
#undef mask_setting
#undef mask_string
#undef p_interact
#undef focus_r
#undef focus_xh
#undef focus_xw
#undef focus_ah
#undef focus_aw
#undef target_z
#undef target_y
#undef target_x
#undef target_index
#undef visualize
#undef yheight2
#undef xwidth2
#undef zdepth
#undef yheight
#undef xwidth
#undef priority
#undef material_string
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

  /* Initializations for component channel_15_cave2_box3. */
  SIG_MESSAGE("channel_15_cave2_box3 (Init)");
#define mccompcurname  channel_15_cave2_box3
#define mccompcurtype  Union_box
#define mccompcurindex 723
#define loop_index mccchannel_15_cave2_box3_loop_index
#define this_box_volume mccchannel_15_cave2_box3_this_box_volume
#define global_geometry_element mccchannel_15_cave2_box3_global_geometry_element
#define this_box_storage mccchannel_15_cave2_box3_this_box_storage
#define material_string mccchannel_15_cave2_box3_material_string
#define priority mccchannel_15_cave2_box3_priority
#define xwidth mccchannel_15_cave2_box3_xwidth
#define yheight mccchannel_15_cave2_box3_yheight
#define zdepth mccchannel_15_cave2_box3_zdepth
#define xwidth2 mccchannel_15_cave2_box3_xwidth2
#define yheight2 mccchannel_15_cave2_box3_yheight2
#define visualize mccchannel_15_cave2_box3_visualize
#define target_index mccchannel_15_cave2_box3_target_index
#define target_x mccchannel_15_cave2_box3_target_x
#define target_y mccchannel_15_cave2_box3_target_y
#define target_z mccchannel_15_cave2_box3_target_z
#define focus_aw mccchannel_15_cave2_box3_focus_aw
#define focus_ah mccchannel_15_cave2_box3_focus_ah
#define focus_xw mccchannel_15_cave2_box3_focus_xw
#define focus_xh mccchannel_15_cave2_box3_focus_xh
#define focus_r mccchannel_15_cave2_box3_focus_r
#define p_interact mccchannel_15_cave2_box3_p_interact
#define mask_string mccchannel_15_cave2_box3_mask_string
#define mask_setting mccchannel_15_cave2_box3_mask_setting
#define number_of_activations mccchannel_15_cave2_box3_number_of_activations
#line 224 "Union_box.comp"
{
// Initializes the focusing system for this volume including input sanitation.
focus_initialize(&this_box_volume.geometry, POS_A_COMP_INDEX(INDEX_CURRENT_COMP+target_index), POS_A_CURRENT_COMP, ROT_A_CURRENT_COMP, target_index, target_x, target_y, target_z, focus_aw, focus_ah, focus_xw, focus_xh, focus_r, NAME_CURRENT_COMP);

// Input sanitation for this geometry
if (xwidth <= 0) {
  printf("\nERROR in Union_box named %s, the xwidth is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (yheight <= 0) {
  printf("\nERROR in Union_box named %s, yheight is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (zdepth <= 0) {
  printf("\nERROR in Union_box named %s, zdepth is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (xwidth2 <= 0 && xwidth2 != -1) {
  printf("\nERROR in Union_box named %s, the xwidth2 is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (yheight2 <= 0 && yheight2 != -1) {
  printf("\nERROR in Union_box named %s, yheight2 is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}

// Use sanitation
if (global_material_list.num_elements == 0) {
  printf("\nERROR: Need to define a material using Union_make_material before using a Union geometry component. \n");
  printf("       %s was defined before first use of Union_make_material.\n",NAME_CURRENT_COMP);
  exit(1);
}

this_box_volume.geometry.is_masked_volume = 0;
this_box_volume.geometry.is_exit_volume = 0;
this_box_volume.geometry.is_mask_volume = 0;
// check if the volume is a mask, if it is the material string is irelevant.
if (mask_string && strlen(mask_string) && strcmp(mask_string, "NULL") && strcmp(mask_string, "0")) {
    // A mask volume is used to limit the extend of other volumes, called the masked volumes. These are specified in the mask_string.
    // In order for a ray to enter a masked volume, it needs to be both in the region covered by that volume AND the mask volume.
    // When more than
    this_box_volume.geometry.mask_mode = 1; // Default is mask mode is ALL
    if (mask_setting && strlen(mask_setting) && strcmp(mask_setting, "NULL") && strcmp(mask_setting, "0")) {
        if (strcmp(mask_setting,"ALL") == 0 || strcmp(mask_setting,"All") == 0) this_box_volume.geometry.mask_mode = 1;
        else if (strcmp(mask_setting,"ANY") == 0 || strcmp(mask_setting,"Any") == 0) this_box_volume.geometry.mask_mode = 2;
        else {
            printf("The mask_mode of component %s is set to %s, but must be either ALL or ANY.\n",NAME_CURRENT_COMP,mask_setting);
            exit(1);
        }
    }
    
    for (loop_index=0;loop_index<global_geometry_list.num_elements;loop_index++) {
        // Add mask list
        if (1 == manual_linking_function(global_geometry_list.elements[loop_index].name,mask_string)) {
            add_element_to_int_list(&this_box_volume.geometry.mask_list,global_geometry_list.elements[loop_index].component_index);
            add_element_to_int_list(&global_geometry_list.elements[loop_index].Volume->geometry.masked_by_list,INDEX_CURRENT_COMP);
            global_geometry_list.elements[loop_index].Volume->geometry.is_masked_volume = 1;
            if (this_box_volume.geometry.mask_mode == 2)
                global_geometry_list.elements[loop_index].Volume->geometry.mask_mode = 2;
            if (this_box_volume.geometry.mask_mode == 1) {
                if (global_geometry_list.elements[loop_index].Volume->geometry.is_masked_volume == 1 && global_geometry_list.elements[loop_index].Volume->geometry.mask_mode != 2)
                    // If more than one mask is added to one volume, the ANY mode overwrites the (default) ALL mode.
                    global_geometry_list.elements[loop_index].Volume->geometry.mask_mode = 1;
            }
            
            found_geometries = 1;
        }
    }
    if (found_geometries == 0) {
        printf("The mask_string in geometry: %s did not find any of the specified volumes in the mask_string %s \n",NAME_CURRENT_COMP,mask_string);
        exit(1);
    }
    this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
    this_box_volume.p_physics->is_vacuum = 0; // Makes this volume a vacuum
    this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
    this_box_volume.p_physics->my_a = 0; // Should not be used.
    sprintf(this_box_volume.p_physics->name,"Mask");
    this_box_volume.geometry.is_mask_volume = 1;
    
    
// Read the material input, or if it lacks, use automatic linking.
} else if (material_string && strlen(material_string) && strcmp(material_string, "NULL") && strcmp(material_string, "0")) {
    // A geometry string was given, use it to determine which material
    if (0 == strcmp(material_string,"vacuum") || 0 == strcmp(material_string,"Vacuum")) {
        // One could have a global physics struct for vacuum instead of creating one for each
        this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
        this_box_volume.p_physics->is_vacuum = 1; // Makes this volume a vacuum
        this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
        this_box_volume.p_physics->my_a = 0; // Should not be used.
        sprintf(this_box_volume.p_physics->name,"Vacuum");
    } else if (0 == strcmp(material_string,"exit") || 0 == strcmp(material_string,"Exit")) {
        // One could have a global physics struct for vacuum instead of creating one for each
        this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
        this_box_volume.p_physics->is_vacuum = 1; // Makes this volume a vacuum
        this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
        this_box_volume.p_physics->my_a = 0; // Should not be used.
        this_box_volume.geometry.is_exit_volume = 1;
        sprintf(this_box_volume.p_physics->name,"Exit");
    } else {
        #ifndef MATERIAL_DETECTOR
            printf("Need to define a material before refering to it in a geometry %s.\n",NAME_CURRENT_COMP);
            exit(1);
        #endif
        for (loop_index=0;loop_index<global_material_list.num_elements;loop_index++) {
            if (0 == strcmp(material_string,global_material_list.elements[loop_index].name)) {
                this_box_volume.p_physics = global_material_list.elements[loop_index].physics;
                break;
            }
            if (loop_index == global_material_list.num_elements-1) {
            printf("\n");
            printf("ERROR: The material string \"%s\" in Union geometry \"%s\" did not match a specified material. \n",material_string,NAME_CURRENT_COMP);
            printf("       The materials available at this point (need to be defined before the geometry): \n");
            for (loop_index=0;loop_index<global_material_list.num_elements;loop_index++)
              printf("         %s\n",global_material_list.elements[loop_index].name);
            printf("\n");
            printf("       It is also possible to use one of the defualt materials avaiable: \n");
            printf("           Vacuum (for a Volume without scattering or absorption)\n");
            printf("           Exit (for a Volume where the ray exits the component if it enters)\n");
            printf("           Mask (for a Volume that masks existing volumes specified in the mask_string\n");
            exit(1);
          }
        }
    }
} else {
    // Automatic linking, simply using the last defined material.
    #ifndef MATERIAL_DETECTOR
        printf("Need to define a material before the geometry to use automatic linking %s.\n",NAME_CURRENT_COMP);
        exit(1);
    #endif
    this_box_volume.p_physics = global_material_list.elements[global_material_list.num_elements-1].physics;
}

sprintf(this_box_volume.name,NAME_CURRENT_COMP);
sprintf(this_box_volume.geometry.shape,"box");
this_box_volume.geometry.priority_value = priority;
this_box_volume.geometry.geometry_p_interact = p_interact;
// Currently the coordinates will be in absolute space.
this_box_volume.geometry.center = POS_A_CURRENT_COMP;

this_box_storage.z_depth = zdepth;
this_box_storage.x_width1 = xwidth;
this_box_storage.y_height1 = yheight;

this_box_storage.is_rectangle = 0;
if (xwidth2 < 0 && yheight2 < 0) this_box_storage.is_rectangle = 1;
if (xwidth == xwidth2 && yheight == yheight2) this_box_storage.is_rectangle = 1;

if (xwidth2 < 0) {
    this_box_storage.x_width2 = xwidth;
    xwidth2 = xwidth;
} else this_box_storage.x_width2 = xwidth2;

if (yheight2 < 0) {
    this_box_storage.y_height2 = yheight;
    yheight2 = yheight;
} else this_box_storage.y_height2 = yheight2;


this_box_storage.normal_vectors[0] = coords_set(0,0,1);
this_box_storage.normal_vectors[1] = coords_set(0,0,1);

// for sides with y component = 0
x_component = 2*zdepth/sqrt((xwidth-xwidth2)*(xwidth-xwidth2)+4*zdepth*zdepth);
z_component = (xwidth-xwidth2)/sqrt(4*zdepth*zdepth+(xwidth-xwidth2)*(xwidth-xwidth2));

this_box_storage.normal_vectors[2] = coords_set(x_component,0,z_component);
this_box_storage.normal_vectors[3] = coords_set(-x_component,0,z_component);

// for sides with x component = 0
y_component = 2*zdepth/sqrt((yheight-yheight2)*(yheight-yheight2)+4*zdepth*zdepth);
z_component = (yheight-yheight2)/sqrt(4*zdepth*zdepth+(yheight-yheight2)*(yheight-yheight2));

this_box_storage.normal_vectors[4] = coords_set(0,y_component,z_component);
this_box_storage.normal_vectors[5] = coords_set(0,-y_component,z_component);

this_box_volume.geometry.visualization_on = visualize;

this_box_volume.geometry.geometry_parameters.p_box_storage = &this_box_storage;

// Assign pointers to functions for intersection with the shape, checking if a point is inside the shape
if (this_box_storage.is_rectangle == 1) {
this_box_volume.geometry.intersect_function = &sample_box_intersect_simple;
this_box_volume.geometry.within_function = &r_within_box_simple;
}
else {
this_box_volume.geometry.intersect_function = &sample_box_intersect_advanced;
this_box_volume.geometry.within_function = &r_within_box_advanced;
}

this_box_volume.geometry.shell_points = &box_shell_points;
this_box_volume.geometry.mcdisplay_function = &mcdisplay_box_function;
this_box_volume.geometry.initialize_from_main_function = &initialize_box_geometry_from_main_component;
this_box_volume.geometry.process_rot_allocated = 0;

this_box_volume.geometry.copy_geometry_parameters = &allocate_box_storage_copy;

rot_copy(this_box_volume.geometry.rotation_matrix,ROT_A_CURRENT_COMP); //check how ROT_R_CURRENT_COMP would work
rot_transpose(ROT_A_CURRENT_COMP,this_box_volume.geometry.transpose_rotation_matrix);

// Initialize loggers
this_box_volume.loggers.num_elements = 0;

// packing the information into the global_geometry_element, which is then included in the global_geometry_list.
sprintf(global_geometry_element.name,NAME_CURRENT_COMP);
global_geometry_element.activation_counter = number_of_activations;
global_geometry_element.component_index = INDEX_CURRENT_COMP;
global_geometry_element.Volume = &this_box_volume; // Would be nicer if this m was a pointer, now we have the (small) data two places
add_element_to_geometry_list(&global_geometry_list,global_geometry_element);
}
#line 303557 "MACS_sample_kidney_box.c"
#undef number_of_activations
#undef mask_setting
#undef mask_string
#undef p_interact
#undef focus_r
#undef focus_xh
#undef focus_xw
#undef focus_ah
#undef focus_aw
#undef target_z
#undef target_y
#undef target_x
#undef target_index
#undef visualize
#undef yheight2
#undef xwidth2
#undef zdepth
#undef yheight
#undef xwidth
#undef priority
#undef material_string
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

  /* Initializations for component inter_analyzer_colimator_center_15. */
  SIG_MESSAGE("inter_analyzer_colimator_center_15 (Init)");

  /* Initializations for component inter_analyzer_colimator_15_blade_0. */
  SIG_MESSAGE("inter_analyzer_colimator_15_blade_0 (Init)");
#define mccompcurname  inter_analyzer_colimator_15_blade_0
#define mccompcurtype  Union_box
#define mccompcurindex 725
#define loop_index mccinter_analyzer_colimator_15_blade_0_loop_index
#define this_box_volume mccinter_analyzer_colimator_15_blade_0_this_box_volume
#define global_geometry_element mccinter_analyzer_colimator_15_blade_0_global_geometry_element
#define this_box_storage mccinter_analyzer_colimator_15_blade_0_this_box_storage
#define material_string mccinter_analyzer_colimator_15_blade_0_material_string
#define priority mccinter_analyzer_colimator_15_blade_0_priority
#define xwidth mccinter_analyzer_colimator_15_blade_0_xwidth
#define yheight mccinter_analyzer_colimator_15_blade_0_yheight
#define zdepth mccinter_analyzer_colimator_15_blade_0_zdepth
#define xwidth2 mccinter_analyzer_colimator_15_blade_0_xwidth2
#define yheight2 mccinter_analyzer_colimator_15_blade_0_yheight2
#define visualize mccinter_analyzer_colimator_15_blade_0_visualize
#define target_index mccinter_analyzer_colimator_15_blade_0_target_index
#define target_x mccinter_analyzer_colimator_15_blade_0_target_x
#define target_y mccinter_analyzer_colimator_15_blade_0_target_y
#define target_z mccinter_analyzer_colimator_15_blade_0_target_z
#define focus_aw mccinter_analyzer_colimator_15_blade_0_focus_aw
#define focus_ah mccinter_analyzer_colimator_15_blade_0_focus_ah
#define focus_xw mccinter_analyzer_colimator_15_blade_0_focus_xw
#define focus_xh mccinter_analyzer_colimator_15_blade_0_focus_xh
#define focus_r mccinter_analyzer_colimator_15_blade_0_focus_r
#define p_interact mccinter_analyzer_colimator_15_blade_0_p_interact
#define mask_string mccinter_analyzer_colimator_15_blade_0_mask_string
#define mask_setting mccinter_analyzer_colimator_15_blade_0_mask_setting
#define number_of_activations mccinter_analyzer_colimator_15_blade_0_number_of_activations
#line 224 "Union_box.comp"
{
// Initializes the focusing system for this volume including input sanitation.
focus_initialize(&this_box_volume.geometry, POS_A_COMP_INDEX(INDEX_CURRENT_COMP+target_index), POS_A_CURRENT_COMP, ROT_A_CURRENT_COMP, target_index, target_x, target_y, target_z, focus_aw, focus_ah, focus_xw, focus_xh, focus_r, NAME_CURRENT_COMP);

// Input sanitation for this geometry
if (xwidth <= 0) {
  printf("\nERROR in Union_box named %s, the xwidth is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (yheight <= 0) {
  printf("\nERROR in Union_box named %s, yheight is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (zdepth <= 0) {
  printf("\nERROR in Union_box named %s, zdepth is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (xwidth2 <= 0 && xwidth2 != -1) {
  printf("\nERROR in Union_box named %s, the xwidth2 is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (yheight2 <= 0 && yheight2 != -1) {
  printf("\nERROR in Union_box named %s, yheight2 is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}

// Use sanitation
if (global_material_list.num_elements == 0) {
  printf("\nERROR: Need to define a material using Union_make_material before using a Union geometry component. \n");
  printf("       %s was defined before first use of Union_make_material.\n",NAME_CURRENT_COMP);
  exit(1);
}

this_box_volume.geometry.is_masked_volume = 0;
this_box_volume.geometry.is_exit_volume = 0;
this_box_volume.geometry.is_mask_volume = 0;
// check if the volume is a mask, if it is the material string is irelevant.
if (mask_string && strlen(mask_string) && strcmp(mask_string, "NULL") && strcmp(mask_string, "0")) {
    // A mask volume is used to limit the extend of other volumes, called the masked volumes. These are specified in the mask_string.
    // In order for a ray to enter a masked volume, it needs to be both in the region covered by that volume AND the mask volume.
    // When more than
    this_box_volume.geometry.mask_mode = 1; // Default is mask mode is ALL
    if (mask_setting && strlen(mask_setting) && strcmp(mask_setting, "NULL") && strcmp(mask_setting, "0")) {
        if (strcmp(mask_setting,"ALL") == 0 || strcmp(mask_setting,"All") == 0) this_box_volume.geometry.mask_mode = 1;
        else if (strcmp(mask_setting,"ANY") == 0 || strcmp(mask_setting,"Any") == 0) this_box_volume.geometry.mask_mode = 2;
        else {
            printf("The mask_mode of component %s is set to %s, but must be either ALL or ANY.\n",NAME_CURRENT_COMP,mask_setting);
            exit(1);
        }
    }
    
    for (loop_index=0;loop_index<global_geometry_list.num_elements;loop_index++) {
        // Add mask list
        if (1 == manual_linking_function(global_geometry_list.elements[loop_index].name,mask_string)) {
            add_element_to_int_list(&this_box_volume.geometry.mask_list,global_geometry_list.elements[loop_index].component_index);
            add_element_to_int_list(&global_geometry_list.elements[loop_index].Volume->geometry.masked_by_list,INDEX_CURRENT_COMP);
            global_geometry_list.elements[loop_index].Volume->geometry.is_masked_volume = 1;
            if (this_box_volume.geometry.mask_mode == 2)
                global_geometry_list.elements[loop_index].Volume->geometry.mask_mode = 2;
            if (this_box_volume.geometry.mask_mode == 1) {
                if (global_geometry_list.elements[loop_index].Volume->geometry.is_masked_volume == 1 && global_geometry_list.elements[loop_index].Volume->geometry.mask_mode != 2)
                    // If more than one mask is added to one volume, the ANY mode overwrites the (default) ALL mode.
                    global_geometry_list.elements[loop_index].Volume->geometry.mask_mode = 1;
            }
            
            found_geometries = 1;
        }
    }
    if (found_geometries == 0) {
        printf("The mask_string in geometry: %s did not find any of the specified volumes in the mask_string %s \n",NAME_CURRENT_COMP,mask_string);
        exit(1);
    }
    this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
    this_box_volume.p_physics->is_vacuum = 0; // Makes this volume a vacuum
    this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
    this_box_volume.p_physics->my_a = 0; // Should not be used.
    sprintf(this_box_volume.p_physics->name,"Mask");
    this_box_volume.geometry.is_mask_volume = 1;
    
    
// Read the material input, or if it lacks, use automatic linking.
} else if (material_string && strlen(material_string) && strcmp(material_string, "NULL") && strcmp(material_string, "0")) {
    // A geometry string was given, use it to determine which material
    if (0 == strcmp(material_string,"vacuum") || 0 == strcmp(material_string,"Vacuum")) {
        // One could have a global physics struct for vacuum instead of creating one for each
        this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
        this_box_volume.p_physics->is_vacuum = 1; // Makes this volume a vacuum
        this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
        this_box_volume.p_physics->my_a = 0; // Should not be used.
        sprintf(this_box_volume.p_physics->name,"Vacuum");
    } else if (0 == strcmp(material_string,"exit") || 0 == strcmp(material_string,"Exit")) {
        // One could have a global physics struct for vacuum instead of creating one for each
        this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
        this_box_volume.p_physics->is_vacuum = 1; // Makes this volume a vacuum
        this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
        this_box_volume.p_physics->my_a = 0; // Should not be used.
        this_box_volume.geometry.is_exit_volume = 1;
        sprintf(this_box_volume.p_physics->name,"Exit");
    } else {
        #ifndef MATERIAL_DETECTOR
            printf("Need to define a material before refering to it in a geometry %s.\n",NAME_CURRENT_COMP);
            exit(1);
        #endif
        for (loop_index=0;loop_index<global_material_list.num_elements;loop_index++) {
            if (0 == strcmp(material_string,global_material_list.elements[loop_index].name)) {
                this_box_volume.p_physics = global_material_list.elements[loop_index].physics;
                break;
            }
            if (loop_index == global_material_list.num_elements-1) {
            printf("\n");
            printf("ERROR: The material string \"%s\" in Union geometry \"%s\" did not match a specified material. \n",material_string,NAME_CURRENT_COMP);
            printf("       The materials available at this point (need to be defined before the geometry): \n");
            for (loop_index=0;loop_index<global_material_list.num_elements;loop_index++)
              printf("         %s\n",global_material_list.elements[loop_index].name);
            printf("\n");
            printf("       It is also possible to use one of the defualt materials avaiable: \n");
            printf("           Vacuum (for a Volume without scattering or absorption)\n");
            printf("           Exit (for a Volume where the ray exits the component if it enters)\n");
            printf("           Mask (for a Volume that masks existing volumes specified in the mask_string\n");
            exit(1);
          }
        }
    }
} else {
    // Automatic linking, simply using the last defined material.
    #ifndef MATERIAL_DETECTOR
        printf("Need to define a material before the geometry to use automatic linking %s.\n",NAME_CURRENT_COMP);
        exit(1);
    #endif
    this_box_volume.p_physics = global_material_list.elements[global_material_list.num_elements-1].physics;
}

sprintf(this_box_volume.name,NAME_CURRENT_COMP);
sprintf(this_box_volume.geometry.shape,"box");
this_box_volume.geometry.priority_value = priority;
this_box_volume.geometry.geometry_p_interact = p_interact;
// Currently the coordinates will be in absolute space.
this_box_volume.geometry.center = POS_A_CURRENT_COMP;

this_box_storage.z_depth = zdepth;
this_box_storage.x_width1 = xwidth;
this_box_storage.y_height1 = yheight;

this_box_storage.is_rectangle = 0;
if (xwidth2 < 0 && yheight2 < 0) this_box_storage.is_rectangle = 1;
if (xwidth == xwidth2 && yheight == yheight2) this_box_storage.is_rectangle = 1;

if (xwidth2 < 0) {
    this_box_storage.x_width2 = xwidth;
    xwidth2 = xwidth;
} else this_box_storage.x_width2 = xwidth2;

if (yheight2 < 0) {
    this_box_storage.y_height2 = yheight;
    yheight2 = yheight;
} else this_box_storage.y_height2 = yheight2;


this_box_storage.normal_vectors[0] = coords_set(0,0,1);
this_box_storage.normal_vectors[1] = coords_set(0,0,1);

// for sides with y component = 0
x_component = 2*zdepth/sqrt((xwidth-xwidth2)*(xwidth-xwidth2)+4*zdepth*zdepth);
z_component = (xwidth-xwidth2)/sqrt(4*zdepth*zdepth+(xwidth-xwidth2)*(xwidth-xwidth2));

this_box_storage.normal_vectors[2] = coords_set(x_component,0,z_component);
this_box_storage.normal_vectors[3] = coords_set(-x_component,0,z_component);

// for sides with x component = 0
y_component = 2*zdepth/sqrt((yheight-yheight2)*(yheight-yheight2)+4*zdepth*zdepth);
z_component = (yheight-yheight2)/sqrt(4*zdepth*zdepth+(yheight-yheight2)*(yheight-yheight2));

this_box_storage.normal_vectors[4] = coords_set(0,y_component,z_component);
this_box_storage.normal_vectors[5] = coords_set(0,-y_component,z_component);

this_box_volume.geometry.visualization_on = visualize;

this_box_volume.geometry.geometry_parameters.p_box_storage = &this_box_storage;

// Assign pointers to functions for intersection with the shape, checking if a point is inside the shape
if (this_box_storage.is_rectangle == 1) {
this_box_volume.geometry.intersect_function = &sample_box_intersect_simple;
this_box_volume.geometry.within_function = &r_within_box_simple;
}
else {
this_box_volume.geometry.intersect_function = &sample_box_intersect_advanced;
this_box_volume.geometry.within_function = &r_within_box_advanced;
}

this_box_volume.geometry.shell_points = &box_shell_points;
this_box_volume.geometry.mcdisplay_function = &mcdisplay_box_function;
this_box_volume.geometry.initialize_from_main_function = &initialize_box_geometry_from_main_component;
this_box_volume.geometry.process_rot_allocated = 0;

this_box_volume.geometry.copy_geometry_parameters = &allocate_box_storage_copy;

rot_copy(this_box_volume.geometry.rotation_matrix,ROT_A_CURRENT_COMP); //check how ROT_R_CURRENT_COMP would work
rot_transpose(ROT_A_CURRENT_COMP,this_box_volume.geometry.transpose_rotation_matrix);

// Initialize loggers
this_box_volume.loggers.num_elements = 0;

// packing the information into the global_geometry_element, which is then included in the global_geometry_list.
sprintf(global_geometry_element.name,NAME_CURRENT_COMP);
global_geometry_element.activation_counter = number_of_activations;
global_geometry_element.component_index = INDEX_CURRENT_COMP;
global_geometry_element.Volume = &this_box_volume; // Would be nicer if this m was a pointer, now we have the (small) data two places
add_element_to_geometry_list(&global_geometry_list,global_geometry_element);
}
#line 303830 "MACS_sample_kidney_box.c"
#undef number_of_activations
#undef mask_setting
#undef mask_string
#undef p_interact
#undef focus_r
#undef focus_xh
#undef focus_xw
#undef focus_ah
#undef focus_aw
#undef target_z
#undef target_y
#undef target_x
#undef target_index
#undef visualize
#undef yheight2
#undef xwidth2
#undef zdepth
#undef yheight
#undef xwidth
#undef priority
#undef material_string
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

  /* Initializations for component inter_analyzer_colimator_15_blade_1. */
  SIG_MESSAGE("inter_analyzer_colimator_15_blade_1 (Init)");
#define mccompcurname  inter_analyzer_colimator_15_blade_1
#define mccompcurtype  Union_box
#define mccompcurindex 726
#define loop_index mccinter_analyzer_colimator_15_blade_1_loop_index
#define this_box_volume mccinter_analyzer_colimator_15_blade_1_this_box_volume
#define global_geometry_element mccinter_analyzer_colimator_15_blade_1_global_geometry_element
#define this_box_storage mccinter_analyzer_colimator_15_blade_1_this_box_storage
#define material_string mccinter_analyzer_colimator_15_blade_1_material_string
#define priority mccinter_analyzer_colimator_15_blade_1_priority
#define xwidth mccinter_analyzer_colimator_15_blade_1_xwidth
#define yheight mccinter_analyzer_colimator_15_blade_1_yheight
#define zdepth mccinter_analyzer_colimator_15_blade_1_zdepth
#define xwidth2 mccinter_analyzer_colimator_15_blade_1_xwidth2
#define yheight2 mccinter_analyzer_colimator_15_blade_1_yheight2
#define visualize mccinter_analyzer_colimator_15_blade_1_visualize
#define target_index mccinter_analyzer_colimator_15_blade_1_target_index
#define target_x mccinter_analyzer_colimator_15_blade_1_target_x
#define target_y mccinter_analyzer_colimator_15_blade_1_target_y
#define target_z mccinter_analyzer_colimator_15_blade_1_target_z
#define focus_aw mccinter_analyzer_colimator_15_blade_1_focus_aw
#define focus_ah mccinter_analyzer_colimator_15_blade_1_focus_ah
#define focus_xw mccinter_analyzer_colimator_15_blade_1_focus_xw
#define focus_xh mccinter_analyzer_colimator_15_blade_1_focus_xh
#define focus_r mccinter_analyzer_colimator_15_blade_1_focus_r
#define p_interact mccinter_analyzer_colimator_15_blade_1_p_interact
#define mask_string mccinter_analyzer_colimator_15_blade_1_mask_string
#define mask_setting mccinter_analyzer_colimator_15_blade_1_mask_setting
#define number_of_activations mccinter_analyzer_colimator_15_blade_1_number_of_activations
#line 224 "Union_box.comp"
{
// Initializes the focusing system for this volume including input sanitation.
focus_initialize(&this_box_volume.geometry, POS_A_COMP_INDEX(INDEX_CURRENT_COMP+target_index), POS_A_CURRENT_COMP, ROT_A_CURRENT_COMP, target_index, target_x, target_y, target_z, focus_aw, focus_ah, focus_xw, focus_xh, focus_r, NAME_CURRENT_COMP);

// Input sanitation for this geometry
if (xwidth <= 0) {
  printf("\nERROR in Union_box named %s, the xwidth is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (yheight <= 0) {
  printf("\nERROR in Union_box named %s, yheight is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (zdepth <= 0) {
  printf("\nERROR in Union_box named %s, zdepth is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (xwidth2 <= 0 && xwidth2 != -1) {
  printf("\nERROR in Union_box named %s, the xwidth2 is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (yheight2 <= 0 && yheight2 != -1) {
  printf("\nERROR in Union_box named %s, yheight2 is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}

// Use sanitation
if (global_material_list.num_elements == 0) {
  printf("\nERROR: Need to define a material using Union_make_material before using a Union geometry component. \n");
  printf("       %s was defined before first use of Union_make_material.\n",NAME_CURRENT_COMP);
  exit(1);
}

this_box_volume.geometry.is_masked_volume = 0;
this_box_volume.geometry.is_exit_volume = 0;
this_box_volume.geometry.is_mask_volume = 0;
// check if the volume is a mask, if it is the material string is irelevant.
if (mask_string && strlen(mask_string) && strcmp(mask_string, "NULL") && strcmp(mask_string, "0")) {
    // A mask volume is used to limit the extend of other volumes, called the masked volumes. These are specified in the mask_string.
    // In order for a ray to enter a masked volume, it needs to be both in the region covered by that volume AND the mask volume.
    // When more than
    this_box_volume.geometry.mask_mode = 1; // Default is mask mode is ALL
    if (mask_setting && strlen(mask_setting) && strcmp(mask_setting, "NULL") && strcmp(mask_setting, "0")) {
        if (strcmp(mask_setting,"ALL") == 0 || strcmp(mask_setting,"All") == 0) this_box_volume.geometry.mask_mode = 1;
        else if (strcmp(mask_setting,"ANY") == 0 || strcmp(mask_setting,"Any") == 0) this_box_volume.geometry.mask_mode = 2;
        else {
            printf("The mask_mode of component %s is set to %s, but must be either ALL or ANY.\n",NAME_CURRENT_COMP,mask_setting);
            exit(1);
        }
    }
    
    for (loop_index=0;loop_index<global_geometry_list.num_elements;loop_index++) {
        // Add mask list
        if (1 == manual_linking_function(global_geometry_list.elements[loop_index].name,mask_string)) {
            add_element_to_int_list(&this_box_volume.geometry.mask_list,global_geometry_list.elements[loop_index].component_index);
            add_element_to_int_list(&global_geometry_list.elements[loop_index].Volume->geometry.masked_by_list,INDEX_CURRENT_COMP);
            global_geometry_list.elements[loop_index].Volume->geometry.is_masked_volume = 1;
            if (this_box_volume.geometry.mask_mode == 2)
                global_geometry_list.elements[loop_index].Volume->geometry.mask_mode = 2;
            if (this_box_volume.geometry.mask_mode == 1) {
                if (global_geometry_list.elements[loop_index].Volume->geometry.is_masked_volume == 1 && global_geometry_list.elements[loop_index].Volume->geometry.mask_mode != 2)
                    // If more than one mask is added to one volume, the ANY mode overwrites the (default) ALL mode.
                    global_geometry_list.elements[loop_index].Volume->geometry.mask_mode = 1;
            }
            
            found_geometries = 1;
        }
    }
    if (found_geometries == 0) {
        printf("The mask_string in geometry: %s did not find any of the specified volumes in the mask_string %s \n",NAME_CURRENT_COMP,mask_string);
        exit(1);
    }
    this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
    this_box_volume.p_physics->is_vacuum = 0; // Makes this volume a vacuum
    this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
    this_box_volume.p_physics->my_a = 0; // Should not be used.
    sprintf(this_box_volume.p_physics->name,"Mask");
    this_box_volume.geometry.is_mask_volume = 1;
    
    
// Read the material input, or if it lacks, use automatic linking.
} else if (material_string && strlen(material_string) && strcmp(material_string, "NULL") && strcmp(material_string, "0")) {
    // A geometry string was given, use it to determine which material
    if (0 == strcmp(material_string,"vacuum") || 0 == strcmp(material_string,"Vacuum")) {
        // One could have a global physics struct for vacuum instead of creating one for each
        this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
        this_box_volume.p_physics->is_vacuum = 1; // Makes this volume a vacuum
        this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
        this_box_volume.p_physics->my_a = 0; // Should not be used.
        sprintf(this_box_volume.p_physics->name,"Vacuum");
    } else if (0 == strcmp(material_string,"exit") || 0 == strcmp(material_string,"Exit")) {
        // One could have a global physics struct for vacuum instead of creating one for each
        this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
        this_box_volume.p_physics->is_vacuum = 1; // Makes this volume a vacuum
        this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
        this_box_volume.p_physics->my_a = 0; // Should not be used.
        this_box_volume.geometry.is_exit_volume = 1;
        sprintf(this_box_volume.p_physics->name,"Exit");
    } else {
        #ifndef MATERIAL_DETECTOR
            printf("Need to define a material before refering to it in a geometry %s.\n",NAME_CURRENT_COMP);
            exit(1);
        #endif
        for (loop_index=0;loop_index<global_material_list.num_elements;loop_index++) {
            if (0 == strcmp(material_string,global_material_list.elements[loop_index].name)) {
                this_box_volume.p_physics = global_material_list.elements[loop_index].physics;
                break;
            }
            if (loop_index == global_material_list.num_elements-1) {
            printf("\n");
            printf("ERROR: The material string \"%s\" in Union geometry \"%s\" did not match a specified material. \n",material_string,NAME_CURRENT_COMP);
            printf("       The materials available at this point (need to be defined before the geometry): \n");
            for (loop_index=0;loop_index<global_material_list.num_elements;loop_index++)
              printf("         %s\n",global_material_list.elements[loop_index].name);
            printf("\n");
            printf("       It is also possible to use one of the defualt materials avaiable: \n");
            printf("           Vacuum (for a Volume without scattering or absorption)\n");
            printf("           Exit (for a Volume where the ray exits the component if it enters)\n");
            printf("           Mask (for a Volume that masks existing volumes specified in the mask_string\n");
            exit(1);
          }
        }
    }
} else {
    // Automatic linking, simply using the last defined material.
    #ifndef MATERIAL_DETECTOR
        printf("Need to define a material before the geometry to use automatic linking %s.\n",NAME_CURRENT_COMP);
        exit(1);
    #endif
    this_box_volume.p_physics = global_material_list.elements[global_material_list.num_elements-1].physics;
}

sprintf(this_box_volume.name,NAME_CURRENT_COMP);
sprintf(this_box_volume.geometry.shape,"box");
this_box_volume.geometry.priority_value = priority;
this_box_volume.geometry.geometry_p_interact = p_interact;
// Currently the coordinates will be in absolute space.
this_box_volume.geometry.center = POS_A_CURRENT_COMP;

this_box_storage.z_depth = zdepth;
this_box_storage.x_width1 = xwidth;
this_box_storage.y_height1 = yheight;

this_box_storage.is_rectangle = 0;
if (xwidth2 < 0 && yheight2 < 0) this_box_storage.is_rectangle = 1;
if (xwidth == xwidth2 && yheight == yheight2) this_box_storage.is_rectangle = 1;

if (xwidth2 < 0) {
    this_box_storage.x_width2 = xwidth;
    xwidth2 = xwidth;
} else this_box_storage.x_width2 = xwidth2;

if (yheight2 < 0) {
    this_box_storage.y_height2 = yheight;
    yheight2 = yheight;
} else this_box_storage.y_height2 = yheight2;


this_box_storage.normal_vectors[0] = coords_set(0,0,1);
this_box_storage.normal_vectors[1] = coords_set(0,0,1);

// for sides with y component = 0
x_component = 2*zdepth/sqrt((xwidth-xwidth2)*(xwidth-xwidth2)+4*zdepth*zdepth);
z_component = (xwidth-xwidth2)/sqrt(4*zdepth*zdepth+(xwidth-xwidth2)*(xwidth-xwidth2));

this_box_storage.normal_vectors[2] = coords_set(x_component,0,z_component);
this_box_storage.normal_vectors[3] = coords_set(-x_component,0,z_component);

// for sides with x component = 0
y_component = 2*zdepth/sqrt((yheight-yheight2)*(yheight-yheight2)+4*zdepth*zdepth);
z_component = (yheight-yheight2)/sqrt(4*zdepth*zdepth+(yheight-yheight2)*(yheight-yheight2));

this_box_storage.normal_vectors[4] = coords_set(0,y_component,z_component);
this_box_storage.normal_vectors[5] = coords_set(0,-y_component,z_component);

this_box_volume.geometry.visualization_on = visualize;

this_box_volume.geometry.geometry_parameters.p_box_storage = &this_box_storage;

// Assign pointers to functions for intersection with the shape, checking if a point is inside the shape
if (this_box_storage.is_rectangle == 1) {
this_box_volume.geometry.intersect_function = &sample_box_intersect_simple;
this_box_volume.geometry.within_function = &r_within_box_simple;
}
else {
this_box_volume.geometry.intersect_function = &sample_box_intersect_advanced;
this_box_volume.geometry.within_function = &r_within_box_advanced;
}

this_box_volume.geometry.shell_points = &box_shell_points;
this_box_volume.geometry.mcdisplay_function = &mcdisplay_box_function;
this_box_volume.geometry.initialize_from_main_function = &initialize_box_geometry_from_main_component;
this_box_volume.geometry.process_rot_allocated = 0;

this_box_volume.geometry.copy_geometry_parameters = &allocate_box_storage_copy;

rot_copy(this_box_volume.geometry.rotation_matrix,ROT_A_CURRENT_COMP); //check how ROT_R_CURRENT_COMP would work
rot_transpose(ROT_A_CURRENT_COMP,this_box_volume.geometry.transpose_rotation_matrix);

// Initialize loggers
this_box_volume.loggers.num_elements = 0;

// packing the information into the global_geometry_element, which is then included in the global_geometry_list.
sprintf(global_geometry_element.name,NAME_CURRENT_COMP);
global_geometry_element.activation_counter = number_of_activations;
global_geometry_element.component_index = INDEX_CURRENT_COMP;
global_geometry_element.Volume = &this_box_volume; // Would be nicer if this m was a pointer, now we have the (small) data two places
add_element_to_geometry_list(&global_geometry_list,global_geometry_element);
}
#line 304100 "MACS_sample_kidney_box.c"
#undef number_of_activations
#undef mask_setting
#undef mask_string
#undef p_interact
#undef focus_r
#undef focus_xh
#undef focus_xw
#undef focus_ah
#undef focus_aw
#undef target_z
#undef target_y
#undef target_x
#undef target_index
#undef visualize
#undef yheight2
#undef xwidth2
#undef zdepth
#undef yheight
#undef xwidth
#undef priority
#undef material_string
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

  /* Initializations for component inter_analyzer_colimator_15_blade_2. */
  SIG_MESSAGE("inter_analyzer_colimator_15_blade_2 (Init)");
#define mccompcurname  inter_analyzer_colimator_15_blade_2
#define mccompcurtype  Union_box
#define mccompcurindex 727
#define loop_index mccinter_analyzer_colimator_15_blade_2_loop_index
#define this_box_volume mccinter_analyzer_colimator_15_blade_2_this_box_volume
#define global_geometry_element mccinter_analyzer_colimator_15_blade_2_global_geometry_element
#define this_box_storage mccinter_analyzer_colimator_15_blade_2_this_box_storage
#define material_string mccinter_analyzer_colimator_15_blade_2_material_string
#define priority mccinter_analyzer_colimator_15_blade_2_priority
#define xwidth mccinter_analyzer_colimator_15_blade_2_xwidth
#define yheight mccinter_analyzer_colimator_15_blade_2_yheight
#define zdepth mccinter_analyzer_colimator_15_blade_2_zdepth
#define xwidth2 mccinter_analyzer_colimator_15_blade_2_xwidth2
#define yheight2 mccinter_analyzer_colimator_15_blade_2_yheight2
#define visualize mccinter_analyzer_colimator_15_blade_2_visualize
#define target_index mccinter_analyzer_colimator_15_blade_2_target_index
#define target_x mccinter_analyzer_colimator_15_blade_2_target_x
#define target_y mccinter_analyzer_colimator_15_blade_2_target_y
#define target_z mccinter_analyzer_colimator_15_blade_2_target_z
#define focus_aw mccinter_analyzer_colimator_15_blade_2_focus_aw
#define focus_ah mccinter_analyzer_colimator_15_blade_2_focus_ah
#define focus_xw mccinter_analyzer_colimator_15_blade_2_focus_xw
#define focus_xh mccinter_analyzer_colimator_15_blade_2_focus_xh
#define focus_r mccinter_analyzer_colimator_15_blade_2_focus_r
#define p_interact mccinter_analyzer_colimator_15_blade_2_p_interact
#define mask_string mccinter_analyzer_colimator_15_blade_2_mask_string
#define mask_setting mccinter_analyzer_colimator_15_blade_2_mask_setting
#define number_of_activations mccinter_analyzer_colimator_15_blade_2_number_of_activations
#line 224 "Union_box.comp"
{
// Initializes the focusing system for this volume including input sanitation.
focus_initialize(&this_box_volume.geometry, POS_A_COMP_INDEX(INDEX_CURRENT_COMP+target_index), POS_A_CURRENT_COMP, ROT_A_CURRENT_COMP, target_index, target_x, target_y, target_z, focus_aw, focus_ah, focus_xw, focus_xh, focus_r, NAME_CURRENT_COMP);

// Input sanitation for this geometry
if (xwidth <= 0) {
  printf("\nERROR in Union_box named %s, the xwidth is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (yheight <= 0) {
  printf("\nERROR in Union_box named %s, yheight is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (zdepth <= 0) {
  printf("\nERROR in Union_box named %s, zdepth is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (xwidth2 <= 0 && xwidth2 != -1) {
  printf("\nERROR in Union_box named %s, the xwidth2 is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (yheight2 <= 0 && yheight2 != -1) {
  printf("\nERROR in Union_box named %s, yheight2 is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}

// Use sanitation
if (global_material_list.num_elements == 0) {
  printf("\nERROR: Need to define a material using Union_make_material before using a Union geometry component. \n");
  printf("       %s was defined before first use of Union_make_material.\n",NAME_CURRENT_COMP);
  exit(1);
}

this_box_volume.geometry.is_masked_volume = 0;
this_box_volume.geometry.is_exit_volume = 0;
this_box_volume.geometry.is_mask_volume = 0;
// check if the volume is a mask, if it is the material string is irelevant.
if (mask_string && strlen(mask_string) && strcmp(mask_string, "NULL") && strcmp(mask_string, "0")) {
    // A mask volume is used to limit the extend of other volumes, called the masked volumes. These are specified in the mask_string.
    // In order for a ray to enter a masked volume, it needs to be both in the region covered by that volume AND the mask volume.
    // When more than
    this_box_volume.geometry.mask_mode = 1; // Default is mask mode is ALL
    if (mask_setting && strlen(mask_setting) && strcmp(mask_setting, "NULL") && strcmp(mask_setting, "0")) {
        if (strcmp(mask_setting,"ALL") == 0 || strcmp(mask_setting,"All") == 0) this_box_volume.geometry.mask_mode = 1;
        else if (strcmp(mask_setting,"ANY") == 0 || strcmp(mask_setting,"Any") == 0) this_box_volume.geometry.mask_mode = 2;
        else {
            printf("The mask_mode of component %s is set to %s, but must be either ALL or ANY.\n",NAME_CURRENT_COMP,mask_setting);
            exit(1);
        }
    }
    
    for (loop_index=0;loop_index<global_geometry_list.num_elements;loop_index++) {
        // Add mask list
        if (1 == manual_linking_function(global_geometry_list.elements[loop_index].name,mask_string)) {
            add_element_to_int_list(&this_box_volume.geometry.mask_list,global_geometry_list.elements[loop_index].component_index);
            add_element_to_int_list(&global_geometry_list.elements[loop_index].Volume->geometry.masked_by_list,INDEX_CURRENT_COMP);
            global_geometry_list.elements[loop_index].Volume->geometry.is_masked_volume = 1;
            if (this_box_volume.geometry.mask_mode == 2)
                global_geometry_list.elements[loop_index].Volume->geometry.mask_mode = 2;
            if (this_box_volume.geometry.mask_mode == 1) {
                if (global_geometry_list.elements[loop_index].Volume->geometry.is_masked_volume == 1 && global_geometry_list.elements[loop_index].Volume->geometry.mask_mode != 2)
                    // If more than one mask is added to one volume, the ANY mode overwrites the (default) ALL mode.
                    global_geometry_list.elements[loop_index].Volume->geometry.mask_mode = 1;
            }
            
            found_geometries = 1;
        }
    }
    if (found_geometries == 0) {
        printf("The mask_string in geometry: %s did not find any of the specified volumes in the mask_string %s \n",NAME_CURRENT_COMP,mask_string);
        exit(1);
    }
    this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
    this_box_volume.p_physics->is_vacuum = 0; // Makes this volume a vacuum
    this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
    this_box_volume.p_physics->my_a = 0; // Should not be used.
    sprintf(this_box_volume.p_physics->name,"Mask");
    this_box_volume.geometry.is_mask_volume = 1;
    
    
// Read the material input, or if it lacks, use automatic linking.
} else if (material_string && strlen(material_string) && strcmp(material_string, "NULL") && strcmp(material_string, "0")) {
    // A geometry string was given, use it to determine which material
    if (0 == strcmp(material_string,"vacuum") || 0 == strcmp(material_string,"Vacuum")) {
        // One could have a global physics struct for vacuum instead of creating one for each
        this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
        this_box_volume.p_physics->is_vacuum = 1; // Makes this volume a vacuum
        this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
        this_box_volume.p_physics->my_a = 0; // Should not be used.
        sprintf(this_box_volume.p_physics->name,"Vacuum");
    } else if (0 == strcmp(material_string,"exit") || 0 == strcmp(material_string,"Exit")) {
        // One could have a global physics struct for vacuum instead of creating one for each
        this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
        this_box_volume.p_physics->is_vacuum = 1; // Makes this volume a vacuum
        this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
        this_box_volume.p_physics->my_a = 0; // Should not be used.
        this_box_volume.geometry.is_exit_volume = 1;
        sprintf(this_box_volume.p_physics->name,"Exit");
    } else {
        #ifndef MATERIAL_DETECTOR
            printf("Need to define a material before refering to it in a geometry %s.\n",NAME_CURRENT_COMP);
            exit(1);
        #endif
        for (loop_index=0;loop_index<global_material_list.num_elements;loop_index++) {
            if (0 == strcmp(material_string,global_material_list.elements[loop_index].name)) {
                this_box_volume.p_physics = global_material_list.elements[loop_index].physics;
                break;
            }
            if (loop_index == global_material_list.num_elements-1) {
            printf("\n");
            printf("ERROR: The material string \"%s\" in Union geometry \"%s\" did not match a specified material. \n",material_string,NAME_CURRENT_COMP);
            printf("       The materials available at this point (need to be defined before the geometry): \n");
            for (loop_index=0;loop_index<global_material_list.num_elements;loop_index++)
              printf("         %s\n",global_material_list.elements[loop_index].name);
            printf("\n");
            printf("       It is also possible to use one of the defualt materials avaiable: \n");
            printf("           Vacuum (for a Volume without scattering or absorption)\n");
            printf("           Exit (for a Volume where the ray exits the component if it enters)\n");
            printf("           Mask (for a Volume that masks existing volumes specified in the mask_string\n");
            exit(1);
          }
        }
    }
} else {
    // Automatic linking, simply using the last defined material.
    #ifndef MATERIAL_DETECTOR
        printf("Need to define a material before the geometry to use automatic linking %s.\n",NAME_CURRENT_COMP);
        exit(1);
    #endif
    this_box_volume.p_physics = global_material_list.elements[global_material_list.num_elements-1].physics;
}

sprintf(this_box_volume.name,NAME_CURRENT_COMP);
sprintf(this_box_volume.geometry.shape,"box");
this_box_volume.geometry.priority_value = priority;
this_box_volume.geometry.geometry_p_interact = p_interact;
// Currently the coordinates will be in absolute space.
this_box_volume.geometry.center = POS_A_CURRENT_COMP;

this_box_storage.z_depth = zdepth;
this_box_storage.x_width1 = xwidth;
this_box_storage.y_height1 = yheight;

this_box_storage.is_rectangle = 0;
if (xwidth2 < 0 && yheight2 < 0) this_box_storage.is_rectangle = 1;
if (xwidth == xwidth2 && yheight == yheight2) this_box_storage.is_rectangle = 1;

if (xwidth2 < 0) {
    this_box_storage.x_width2 = xwidth;
    xwidth2 = xwidth;
} else this_box_storage.x_width2 = xwidth2;

if (yheight2 < 0) {
    this_box_storage.y_height2 = yheight;
    yheight2 = yheight;
} else this_box_storage.y_height2 = yheight2;


this_box_storage.normal_vectors[0] = coords_set(0,0,1);
this_box_storage.normal_vectors[1] = coords_set(0,0,1);

// for sides with y component = 0
x_component = 2*zdepth/sqrt((xwidth-xwidth2)*(xwidth-xwidth2)+4*zdepth*zdepth);
z_component = (xwidth-xwidth2)/sqrt(4*zdepth*zdepth+(xwidth-xwidth2)*(xwidth-xwidth2));

this_box_storage.normal_vectors[2] = coords_set(x_component,0,z_component);
this_box_storage.normal_vectors[3] = coords_set(-x_component,0,z_component);

// for sides with x component = 0
y_component = 2*zdepth/sqrt((yheight-yheight2)*(yheight-yheight2)+4*zdepth*zdepth);
z_component = (yheight-yheight2)/sqrt(4*zdepth*zdepth+(yheight-yheight2)*(yheight-yheight2));

this_box_storage.normal_vectors[4] = coords_set(0,y_component,z_component);
this_box_storage.normal_vectors[5] = coords_set(0,-y_component,z_component);

this_box_volume.geometry.visualization_on = visualize;

this_box_volume.geometry.geometry_parameters.p_box_storage = &this_box_storage;

// Assign pointers to functions for intersection with the shape, checking if a point is inside the shape
if (this_box_storage.is_rectangle == 1) {
this_box_volume.geometry.intersect_function = &sample_box_intersect_simple;
this_box_volume.geometry.within_function = &r_within_box_simple;
}
else {
this_box_volume.geometry.intersect_function = &sample_box_intersect_advanced;
this_box_volume.geometry.within_function = &r_within_box_advanced;
}

this_box_volume.geometry.shell_points = &box_shell_points;
this_box_volume.geometry.mcdisplay_function = &mcdisplay_box_function;
this_box_volume.geometry.initialize_from_main_function = &initialize_box_geometry_from_main_component;
this_box_volume.geometry.process_rot_allocated = 0;

this_box_volume.geometry.copy_geometry_parameters = &allocate_box_storage_copy;

rot_copy(this_box_volume.geometry.rotation_matrix,ROT_A_CURRENT_COMP); //check how ROT_R_CURRENT_COMP would work
rot_transpose(ROT_A_CURRENT_COMP,this_box_volume.geometry.transpose_rotation_matrix);

// Initialize loggers
this_box_volume.loggers.num_elements = 0;

// packing the information into the global_geometry_element, which is then included in the global_geometry_list.
sprintf(global_geometry_element.name,NAME_CURRENT_COMP);
global_geometry_element.activation_counter = number_of_activations;
global_geometry_element.component_index = INDEX_CURRENT_COMP;
global_geometry_element.Volume = &this_box_volume; // Would be nicer if this m was a pointer, now we have the (small) data two places
add_element_to_geometry_list(&global_geometry_list,global_geometry_element);
}
#line 304370 "MACS_sample_kidney_box.c"
#undef number_of_activations
#undef mask_setting
#undef mask_string
#undef p_interact
#undef focus_r
#undef focus_xh
#undef focus_xw
#undef focus_ah
#undef focus_aw
#undef target_z
#undef target_y
#undef target_x
#undef target_index
#undef visualize
#undef yheight2
#undef xwidth2
#undef zdepth
#undef yheight
#undef xwidth
#undef priority
#undef material_string
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

  /* Initializations for component inter_analyzer_colimator_15_blade_3. */
  SIG_MESSAGE("inter_analyzer_colimator_15_blade_3 (Init)");
#define mccompcurname  inter_analyzer_colimator_15_blade_3
#define mccompcurtype  Union_box
#define mccompcurindex 728
#define loop_index mccinter_analyzer_colimator_15_blade_3_loop_index
#define this_box_volume mccinter_analyzer_colimator_15_blade_3_this_box_volume
#define global_geometry_element mccinter_analyzer_colimator_15_blade_3_global_geometry_element
#define this_box_storage mccinter_analyzer_colimator_15_blade_3_this_box_storage
#define material_string mccinter_analyzer_colimator_15_blade_3_material_string
#define priority mccinter_analyzer_colimator_15_blade_3_priority
#define xwidth mccinter_analyzer_colimator_15_blade_3_xwidth
#define yheight mccinter_analyzer_colimator_15_blade_3_yheight
#define zdepth mccinter_analyzer_colimator_15_blade_3_zdepth
#define xwidth2 mccinter_analyzer_colimator_15_blade_3_xwidth2
#define yheight2 mccinter_analyzer_colimator_15_blade_3_yheight2
#define visualize mccinter_analyzer_colimator_15_blade_3_visualize
#define target_index mccinter_analyzer_colimator_15_blade_3_target_index
#define target_x mccinter_analyzer_colimator_15_blade_3_target_x
#define target_y mccinter_analyzer_colimator_15_blade_3_target_y
#define target_z mccinter_analyzer_colimator_15_blade_3_target_z
#define focus_aw mccinter_analyzer_colimator_15_blade_3_focus_aw
#define focus_ah mccinter_analyzer_colimator_15_blade_3_focus_ah
#define focus_xw mccinter_analyzer_colimator_15_blade_3_focus_xw
#define focus_xh mccinter_analyzer_colimator_15_blade_3_focus_xh
#define focus_r mccinter_analyzer_colimator_15_blade_3_focus_r
#define p_interact mccinter_analyzer_colimator_15_blade_3_p_interact
#define mask_string mccinter_analyzer_colimator_15_blade_3_mask_string
#define mask_setting mccinter_analyzer_colimator_15_blade_3_mask_setting
#define number_of_activations mccinter_analyzer_colimator_15_blade_3_number_of_activations
#line 224 "Union_box.comp"
{
// Initializes the focusing system for this volume including input sanitation.
focus_initialize(&this_box_volume.geometry, POS_A_COMP_INDEX(INDEX_CURRENT_COMP+target_index), POS_A_CURRENT_COMP, ROT_A_CURRENT_COMP, target_index, target_x, target_y, target_z, focus_aw, focus_ah, focus_xw, focus_xh, focus_r, NAME_CURRENT_COMP);

// Input sanitation for this geometry
if (xwidth <= 0) {
  printf("\nERROR in Union_box named %s, the xwidth is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (yheight <= 0) {
  printf("\nERROR in Union_box named %s, yheight is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (zdepth <= 0) {
  printf("\nERROR in Union_box named %s, zdepth is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (xwidth2 <= 0 && xwidth2 != -1) {
  printf("\nERROR in Union_box named %s, the xwidth2 is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (yheight2 <= 0 && yheight2 != -1) {
  printf("\nERROR in Union_box named %s, yheight2 is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}

// Use sanitation
if (global_material_list.num_elements == 0) {
  printf("\nERROR: Need to define a material using Union_make_material before using a Union geometry component. \n");
  printf("       %s was defined before first use of Union_make_material.\n",NAME_CURRENT_COMP);
  exit(1);
}

this_box_volume.geometry.is_masked_volume = 0;
this_box_volume.geometry.is_exit_volume = 0;
this_box_volume.geometry.is_mask_volume = 0;
// check if the volume is a mask, if it is the material string is irelevant.
if (mask_string && strlen(mask_string) && strcmp(mask_string, "NULL") && strcmp(mask_string, "0")) {
    // A mask volume is used to limit the extend of other volumes, called the masked volumes. These are specified in the mask_string.
    // In order for a ray to enter a masked volume, it needs to be both in the region covered by that volume AND the mask volume.
    // When more than
    this_box_volume.geometry.mask_mode = 1; // Default is mask mode is ALL
    if (mask_setting && strlen(mask_setting) && strcmp(mask_setting, "NULL") && strcmp(mask_setting, "0")) {
        if (strcmp(mask_setting,"ALL") == 0 || strcmp(mask_setting,"All") == 0) this_box_volume.geometry.mask_mode = 1;
        else if (strcmp(mask_setting,"ANY") == 0 || strcmp(mask_setting,"Any") == 0) this_box_volume.geometry.mask_mode = 2;
        else {
            printf("The mask_mode of component %s is set to %s, but must be either ALL or ANY.\n",NAME_CURRENT_COMP,mask_setting);
            exit(1);
        }
    }
    
    for (loop_index=0;loop_index<global_geometry_list.num_elements;loop_index++) {
        // Add mask list
        if (1 == manual_linking_function(global_geometry_list.elements[loop_index].name,mask_string)) {
            add_element_to_int_list(&this_box_volume.geometry.mask_list,global_geometry_list.elements[loop_index].component_index);
            add_element_to_int_list(&global_geometry_list.elements[loop_index].Volume->geometry.masked_by_list,INDEX_CURRENT_COMP);
            global_geometry_list.elements[loop_index].Volume->geometry.is_masked_volume = 1;
            if (this_box_volume.geometry.mask_mode == 2)
                global_geometry_list.elements[loop_index].Volume->geometry.mask_mode = 2;
            if (this_box_volume.geometry.mask_mode == 1) {
                if (global_geometry_list.elements[loop_index].Volume->geometry.is_masked_volume == 1 && global_geometry_list.elements[loop_index].Volume->geometry.mask_mode != 2)
                    // If more than one mask is added to one volume, the ANY mode overwrites the (default) ALL mode.
                    global_geometry_list.elements[loop_index].Volume->geometry.mask_mode = 1;
            }
            
            found_geometries = 1;
        }
    }
    if (found_geometries == 0) {
        printf("The mask_string in geometry: %s did not find any of the specified volumes in the mask_string %s \n",NAME_CURRENT_COMP,mask_string);
        exit(1);
    }
    this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
    this_box_volume.p_physics->is_vacuum = 0; // Makes this volume a vacuum
    this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
    this_box_volume.p_physics->my_a = 0; // Should not be used.
    sprintf(this_box_volume.p_physics->name,"Mask");
    this_box_volume.geometry.is_mask_volume = 1;
    
    
// Read the material input, or if it lacks, use automatic linking.
} else if (material_string && strlen(material_string) && strcmp(material_string, "NULL") && strcmp(material_string, "0")) {
    // A geometry string was given, use it to determine which material
    if (0 == strcmp(material_string,"vacuum") || 0 == strcmp(material_string,"Vacuum")) {
        // One could have a global physics struct for vacuum instead of creating one for each
        this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
        this_box_volume.p_physics->is_vacuum = 1; // Makes this volume a vacuum
        this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
        this_box_volume.p_physics->my_a = 0; // Should not be used.
        sprintf(this_box_volume.p_physics->name,"Vacuum");
    } else if (0 == strcmp(material_string,"exit") || 0 == strcmp(material_string,"Exit")) {
        // One could have a global physics struct for vacuum instead of creating one for each
        this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
        this_box_volume.p_physics->is_vacuum = 1; // Makes this volume a vacuum
        this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
        this_box_volume.p_physics->my_a = 0; // Should not be used.
        this_box_volume.geometry.is_exit_volume = 1;
        sprintf(this_box_volume.p_physics->name,"Exit");
    } else {
        #ifndef MATERIAL_DETECTOR
            printf("Need to define a material before refering to it in a geometry %s.\n",NAME_CURRENT_COMP);
            exit(1);
        #endif
        for (loop_index=0;loop_index<global_material_list.num_elements;loop_index++) {
            if (0 == strcmp(material_string,global_material_list.elements[loop_index].name)) {
                this_box_volume.p_physics = global_material_list.elements[loop_index].physics;
                break;
            }
            if (loop_index == global_material_list.num_elements-1) {
            printf("\n");
            printf("ERROR: The material string \"%s\" in Union geometry \"%s\" did not match a specified material. \n",material_string,NAME_CURRENT_COMP);
            printf("       The materials available at this point (need to be defined before the geometry): \n");
            for (loop_index=0;loop_index<global_material_list.num_elements;loop_index++)
              printf("         %s\n",global_material_list.elements[loop_index].name);
            printf("\n");
            printf("       It is also possible to use one of the defualt materials avaiable: \n");
            printf("           Vacuum (for a Volume without scattering or absorption)\n");
            printf("           Exit (for a Volume where the ray exits the component if it enters)\n");
            printf("           Mask (for a Volume that masks existing volumes specified in the mask_string\n");
            exit(1);
          }
        }
    }
} else {
    // Automatic linking, simply using the last defined material.
    #ifndef MATERIAL_DETECTOR
        printf("Need to define a material before the geometry to use automatic linking %s.\n",NAME_CURRENT_COMP);
        exit(1);
    #endif
    this_box_volume.p_physics = global_material_list.elements[global_material_list.num_elements-1].physics;
}

sprintf(this_box_volume.name,NAME_CURRENT_COMP);
sprintf(this_box_volume.geometry.shape,"box");
this_box_volume.geometry.priority_value = priority;
this_box_volume.geometry.geometry_p_interact = p_interact;
// Currently the coordinates will be in absolute space.
this_box_volume.geometry.center = POS_A_CURRENT_COMP;

this_box_storage.z_depth = zdepth;
this_box_storage.x_width1 = xwidth;
this_box_storage.y_height1 = yheight;

this_box_storage.is_rectangle = 0;
if (xwidth2 < 0 && yheight2 < 0) this_box_storage.is_rectangle = 1;
if (xwidth == xwidth2 && yheight == yheight2) this_box_storage.is_rectangle = 1;

if (xwidth2 < 0) {
    this_box_storage.x_width2 = xwidth;
    xwidth2 = xwidth;
} else this_box_storage.x_width2 = xwidth2;

if (yheight2 < 0) {
    this_box_storage.y_height2 = yheight;
    yheight2 = yheight;
} else this_box_storage.y_height2 = yheight2;


this_box_storage.normal_vectors[0] = coords_set(0,0,1);
this_box_storage.normal_vectors[1] = coords_set(0,0,1);

// for sides with y component = 0
x_component = 2*zdepth/sqrt((xwidth-xwidth2)*(xwidth-xwidth2)+4*zdepth*zdepth);
z_component = (xwidth-xwidth2)/sqrt(4*zdepth*zdepth+(xwidth-xwidth2)*(xwidth-xwidth2));

this_box_storage.normal_vectors[2] = coords_set(x_component,0,z_component);
this_box_storage.normal_vectors[3] = coords_set(-x_component,0,z_component);

// for sides with x component = 0
y_component = 2*zdepth/sqrt((yheight-yheight2)*(yheight-yheight2)+4*zdepth*zdepth);
z_component = (yheight-yheight2)/sqrt(4*zdepth*zdepth+(yheight-yheight2)*(yheight-yheight2));

this_box_storage.normal_vectors[4] = coords_set(0,y_component,z_component);
this_box_storage.normal_vectors[5] = coords_set(0,-y_component,z_component);

this_box_volume.geometry.visualization_on = visualize;

this_box_volume.geometry.geometry_parameters.p_box_storage = &this_box_storage;

// Assign pointers to functions for intersection with the shape, checking if a point is inside the shape
if (this_box_storage.is_rectangle == 1) {
this_box_volume.geometry.intersect_function = &sample_box_intersect_simple;
this_box_volume.geometry.within_function = &r_within_box_simple;
}
else {
this_box_volume.geometry.intersect_function = &sample_box_intersect_advanced;
this_box_volume.geometry.within_function = &r_within_box_advanced;
}

this_box_volume.geometry.shell_points = &box_shell_points;
this_box_volume.geometry.mcdisplay_function = &mcdisplay_box_function;
this_box_volume.geometry.initialize_from_main_function = &initialize_box_geometry_from_main_component;
this_box_volume.geometry.process_rot_allocated = 0;

this_box_volume.geometry.copy_geometry_parameters = &allocate_box_storage_copy;

rot_copy(this_box_volume.geometry.rotation_matrix,ROT_A_CURRENT_COMP); //check how ROT_R_CURRENT_COMP would work
rot_transpose(ROT_A_CURRENT_COMP,this_box_volume.geometry.transpose_rotation_matrix);

// Initialize loggers
this_box_volume.loggers.num_elements = 0;

// packing the information into the global_geometry_element, which is then included in the global_geometry_list.
sprintf(global_geometry_element.name,NAME_CURRENT_COMP);
global_geometry_element.activation_counter = number_of_activations;
global_geometry_element.component_index = INDEX_CURRENT_COMP;
global_geometry_element.Volume = &this_box_volume; // Would be nicer if this m was a pointer, now we have the (small) data two places
add_element_to_geometry_list(&global_geometry_list,global_geometry_element);
}
#line 304640 "MACS_sample_kidney_box.c"
#undef number_of_activations
#undef mask_setting
#undef mask_string
#undef p_interact
#undef focus_r
#undef focus_xh
#undef focus_xw
#undef focus_ah
#undef focus_aw
#undef target_z
#undef target_y
#undef target_x
#undef target_index
#undef visualize
#undef yheight2
#undef xwidth2
#undef zdepth
#undef yheight
#undef xwidth
#undef priority
#undef material_string
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

  /* Initializations for component inter_analyzer_colimator_15_blade_4. */
  SIG_MESSAGE("inter_analyzer_colimator_15_blade_4 (Init)");
#define mccompcurname  inter_analyzer_colimator_15_blade_4
#define mccompcurtype  Union_box
#define mccompcurindex 729
#define loop_index mccinter_analyzer_colimator_15_blade_4_loop_index
#define this_box_volume mccinter_analyzer_colimator_15_blade_4_this_box_volume
#define global_geometry_element mccinter_analyzer_colimator_15_blade_4_global_geometry_element
#define this_box_storage mccinter_analyzer_colimator_15_blade_4_this_box_storage
#define material_string mccinter_analyzer_colimator_15_blade_4_material_string
#define priority mccinter_analyzer_colimator_15_blade_4_priority
#define xwidth mccinter_analyzer_colimator_15_blade_4_xwidth
#define yheight mccinter_analyzer_colimator_15_blade_4_yheight
#define zdepth mccinter_analyzer_colimator_15_blade_4_zdepth
#define xwidth2 mccinter_analyzer_colimator_15_blade_4_xwidth2
#define yheight2 mccinter_analyzer_colimator_15_blade_4_yheight2
#define visualize mccinter_analyzer_colimator_15_blade_4_visualize
#define target_index mccinter_analyzer_colimator_15_blade_4_target_index
#define target_x mccinter_analyzer_colimator_15_blade_4_target_x
#define target_y mccinter_analyzer_colimator_15_blade_4_target_y
#define target_z mccinter_analyzer_colimator_15_blade_4_target_z
#define focus_aw mccinter_analyzer_colimator_15_blade_4_focus_aw
#define focus_ah mccinter_analyzer_colimator_15_blade_4_focus_ah
#define focus_xw mccinter_analyzer_colimator_15_blade_4_focus_xw
#define focus_xh mccinter_analyzer_colimator_15_blade_4_focus_xh
#define focus_r mccinter_analyzer_colimator_15_blade_4_focus_r
#define p_interact mccinter_analyzer_colimator_15_blade_4_p_interact
#define mask_string mccinter_analyzer_colimator_15_blade_4_mask_string
#define mask_setting mccinter_analyzer_colimator_15_blade_4_mask_setting
#define number_of_activations mccinter_analyzer_colimator_15_blade_4_number_of_activations
#line 224 "Union_box.comp"
{
// Initializes the focusing system for this volume including input sanitation.
focus_initialize(&this_box_volume.geometry, POS_A_COMP_INDEX(INDEX_CURRENT_COMP+target_index), POS_A_CURRENT_COMP, ROT_A_CURRENT_COMP, target_index, target_x, target_y, target_z, focus_aw, focus_ah, focus_xw, focus_xh, focus_r, NAME_CURRENT_COMP);

// Input sanitation for this geometry
if (xwidth <= 0) {
  printf("\nERROR in Union_box named %s, the xwidth is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (yheight <= 0) {
  printf("\nERROR in Union_box named %s, yheight is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (zdepth <= 0) {
  printf("\nERROR in Union_box named %s, zdepth is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (xwidth2 <= 0 && xwidth2 != -1) {
  printf("\nERROR in Union_box named %s, the xwidth2 is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (yheight2 <= 0 && yheight2 != -1) {
  printf("\nERROR in Union_box named %s, yheight2 is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}

// Use sanitation
if (global_material_list.num_elements == 0) {
  printf("\nERROR: Need to define a material using Union_make_material before using a Union geometry component. \n");
  printf("       %s was defined before first use of Union_make_material.\n",NAME_CURRENT_COMP);
  exit(1);
}

this_box_volume.geometry.is_masked_volume = 0;
this_box_volume.geometry.is_exit_volume = 0;
this_box_volume.geometry.is_mask_volume = 0;
// check if the volume is a mask, if it is the material string is irelevant.
if (mask_string && strlen(mask_string) && strcmp(mask_string, "NULL") && strcmp(mask_string, "0")) {
    // A mask volume is used to limit the extend of other volumes, called the masked volumes. These are specified in the mask_string.
    // In order for a ray to enter a masked volume, it needs to be both in the region covered by that volume AND the mask volume.
    // When more than
    this_box_volume.geometry.mask_mode = 1; // Default is mask mode is ALL
    if (mask_setting && strlen(mask_setting) && strcmp(mask_setting, "NULL") && strcmp(mask_setting, "0")) {
        if (strcmp(mask_setting,"ALL") == 0 || strcmp(mask_setting,"All") == 0) this_box_volume.geometry.mask_mode = 1;
        else if (strcmp(mask_setting,"ANY") == 0 || strcmp(mask_setting,"Any") == 0) this_box_volume.geometry.mask_mode = 2;
        else {
            printf("The mask_mode of component %s is set to %s, but must be either ALL or ANY.\n",NAME_CURRENT_COMP,mask_setting);
            exit(1);
        }
    }
    
    for (loop_index=0;loop_index<global_geometry_list.num_elements;loop_index++) {
        // Add mask list
        if (1 == manual_linking_function(global_geometry_list.elements[loop_index].name,mask_string)) {
            add_element_to_int_list(&this_box_volume.geometry.mask_list,global_geometry_list.elements[loop_index].component_index);
            add_element_to_int_list(&global_geometry_list.elements[loop_index].Volume->geometry.masked_by_list,INDEX_CURRENT_COMP);
            global_geometry_list.elements[loop_index].Volume->geometry.is_masked_volume = 1;
            if (this_box_volume.geometry.mask_mode == 2)
                global_geometry_list.elements[loop_index].Volume->geometry.mask_mode = 2;
            if (this_box_volume.geometry.mask_mode == 1) {
                if (global_geometry_list.elements[loop_index].Volume->geometry.is_masked_volume == 1 && global_geometry_list.elements[loop_index].Volume->geometry.mask_mode != 2)
                    // If more than one mask is added to one volume, the ANY mode overwrites the (default) ALL mode.
                    global_geometry_list.elements[loop_index].Volume->geometry.mask_mode = 1;
            }
            
            found_geometries = 1;
        }
    }
    if (found_geometries == 0) {
        printf("The mask_string in geometry: %s did not find any of the specified volumes in the mask_string %s \n",NAME_CURRENT_COMP,mask_string);
        exit(1);
    }
    this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
    this_box_volume.p_physics->is_vacuum = 0; // Makes this volume a vacuum
    this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
    this_box_volume.p_physics->my_a = 0; // Should not be used.
    sprintf(this_box_volume.p_physics->name,"Mask");
    this_box_volume.geometry.is_mask_volume = 1;
    
    
// Read the material input, or if it lacks, use automatic linking.
} else if (material_string && strlen(material_string) && strcmp(material_string, "NULL") && strcmp(material_string, "0")) {
    // A geometry string was given, use it to determine which material
    if (0 == strcmp(material_string,"vacuum") || 0 == strcmp(material_string,"Vacuum")) {
        // One could have a global physics struct for vacuum instead of creating one for each
        this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
        this_box_volume.p_physics->is_vacuum = 1; // Makes this volume a vacuum
        this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
        this_box_volume.p_physics->my_a = 0; // Should not be used.
        sprintf(this_box_volume.p_physics->name,"Vacuum");
    } else if (0 == strcmp(material_string,"exit") || 0 == strcmp(material_string,"Exit")) {
        // One could have a global physics struct for vacuum instead of creating one for each
        this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
        this_box_volume.p_physics->is_vacuum = 1; // Makes this volume a vacuum
        this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
        this_box_volume.p_physics->my_a = 0; // Should not be used.
        this_box_volume.geometry.is_exit_volume = 1;
        sprintf(this_box_volume.p_physics->name,"Exit");
    } else {
        #ifndef MATERIAL_DETECTOR
            printf("Need to define a material before refering to it in a geometry %s.\n",NAME_CURRENT_COMP);
            exit(1);
        #endif
        for (loop_index=0;loop_index<global_material_list.num_elements;loop_index++) {
            if (0 == strcmp(material_string,global_material_list.elements[loop_index].name)) {
                this_box_volume.p_physics = global_material_list.elements[loop_index].physics;
                break;
            }
            if (loop_index == global_material_list.num_elements-1) {
            printf("\n");
            printf("ERROR: The material string \"%s\" in Union geometry \"%s\" did not match a specified material. \n",material_string,NAME_CURRENT_COMP);
            printf("       The materials available at this point (need to be defined before the geometry): \n");
            for (loop_index=0;loop_index<global_material_list.num_elements;loop_index++)
              printf("         %s\n",global_material_list.elements[loop_index].name);
            printf("\n");
            printf("       It is also possible to use one of the defualt materials avaiable: \n");
            printf("           Vacuum (for a Volume without scattering or absorption)\n");
            printf("           Exit (for a Volume where the ray exits the component if it enters)\n");
            printf("           Mask (for a Volume that masks existing volumes specified in the mask_string\n");
            exit(1);
          }
        }
    }
} else {
    // Automatic linking, simply using the last defined material.
    #ifndef MATERIAL_DETECTOR
        printf("Need to define a material before the geometry to use automatic linking %s.\n",NAME_CURRENT_COMP);
        exit(1);
    #endif
    this_box_volume.p_physics = global_material_list.elements[global_material_list.num_elements-1].physics;
}

sprintf(this_box_volume.name,NAME_CURRENT_COMP);
sprintf(this_box_volume.geometry.shape,"box");
this_box_volume.geometry.priority_value = priority;
this_box_volume.geometry.geometry_p_interact = p_interact;
// Currently the coordinates will be in absolute space.
this_box_volume.geometry.center = POS_A_CURRENT_COMP;

this_box_storage.z_depth = zdepth;
this_box_storage.x_width1 = xwidth;
this_box_storage.y_height1 = yheight;

this_box_storage.is_rectangle = 0;
if (xwidth2 < 0 && yheight2 < 0) this_box_storage.is_rectangle = 1;
if (xwidth == xwidth2 && yheight == yheight2) this_box_storage.is_rectangle = 1;

if (xwidth2 < 0) {
    this_box_storage.x_width2 = xwidth;
    xwidth2 = xwidth;
} else this_box_storage.x_width2 = xwidth2;

if (yheight2 < 0) {
    this_box_storage.y_height2 = yheight;
    yheight2 = yheight;
} else this_box_storage.y_height2 = yheight2;


this_box_storage.normal_vectors[0] = coords_set(0,0,1);
this_box_storage.normal_vectors[1] = coords_set(0,0,1);

// for sides with y component = 0
x_component = 2*zdepth/sqrt((xwidth-xwidth2)*(xwidth-xwidth2)+4*zdepth*zdepth);
z_component = (xwidth-xwidth2)/sqrt(4*zdepth*zdepth+(xwidth-xwidth2)*(xwidth-xwidth2));

this_box_storage.normal_vectors[2] = coords_set(x_component,0,z_component);
this_box_storage.normal_vectors[3] = coords_set(-x_component,0,z_component);

// for sides with x component = 0
y_component = 2*zdepth/sqrt((yheight-yheight2)*(yheight-yheight2)+4*zdepth*zdepth);
z_component = (yheight-yheight2)/sqrt(4*zdepth*zdepth+(yheight-yheight2)*(yheight-yheight2));

this_box_storage.normal_vectors[4] = coords_set(0,y_component,z_component);
this_box_storage.normal_vectors[5] = coords_set(0,-y_component,z_component);

this_box_volume.geometry.visualization_on = visualize;

this_box_volume.geometry.geometry_parameters.p_box_storage = &this_box_storage;

// Assign pointers to functions for intersection with the shape, checking if a point is inside the shape
if (this_box_storage.is_rectangle == 1) {
this_box_volume.geometry.intersect_function = &sample_box_intersect_simple;
this_box_volume.geometry.within_function = &r_within_box_simple;
}
else {
this_box_volume.geometry.intersect_function = &sample_box_intersect_advanced;
this_box_volume.geometry.within_function = &r_within_box_advanced;
}

this_box_volume.geometry.shell_points = &box_shell_points;
this_box_volume.geometry.mcdisplay_function = &mcdisplay_box_function;
this_box_volume.geometry.initialize_from_main_function = &initialize_box_geometry_from_main_component;
this_box_volume.geometry.process_rot_allocated = 0;

this_box_volume.geometry.copy_geometry_parameters = &allocate_box_storage_copy;

rot_copy(this_box_volume.geometry.rotation_matrix,ROT_A_CURRENT_COMP); //check how ROT_R_CURRENT_COMP would work
rot_transpose(ROT_A_CURRENT_COMP,this_box_volume.geometry.transpose_rotation_matrix);

// Initialize loggers
this_box_volume.loggers.num_elements = 0;

// packing the information into the global_geometry_element, which is then included in the global_geometry_list.
sprintf(global_geometry_element.name,NAME_CURRENT_COMP);
global_geometry_element.activation_counter = number_of_activations;
global_geometry_element.component_index = INDEX_CURRENT_COMP;
global_geometry_element.Volume = &this_box_volume; // Would be nicer if this m was a pointer, now we have the (small) data two places
add_element_to_geometry_list(&global_geometry_list,global_geometry_element);
}
#line 304910 "MACS_sample_kidney_box.c"
#undef number_of_activations
#undef mask_setting
#undef mask_string
#undef p_interact
#undef focus_r
#undef focus_xh
#undef focus_xw
#undef focus_ah
#undef focus_aw
#undef target_z
#undef target_y
#undef target_x
#undef target_index
#undef visualize
#undef yheight2
#undef xwidth2
#undef zdepth
#undef yheight
#undef xwidth
#undef priority
#undef material_string
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

  /* Initializations for component diffraction_detector_15_exit_volume. */
  SIG_MESSAGE("diffraction_detector_15_exit_volume (Init)");
#define mccompcurname  diffraction_detector_15_exit_volume
#define mccompcurtype  Union_box
#define mccompcurindex 730
#define loop_index mccdiffraction_detector_15_exit_volume_loop_index
#define this_box_volume mccdiffraction_detector_15_exit_volume_this_box_volume
#define global_geometry_element mccdiffraction_detector_15_exit_volume_global_geometry_element
#define this_box_storage mccdiffraction_detector_15_exit_volume_this_box_storage
#define material_string mccdiffraction_detector_15_exit_volume_material_string
#define priority mccdiffraction_detector_15_exit_volume_priority
#define xwidth mccdiffraction_detector_15_exit_volume_xwidth
#define yheight mccdiffraction_detector_15_exit_volume_yheight
#define zdepth mccdiffraction_detector_15_exit_volume_zdepth
#define xwidth2 mccdiffraction_detector_15_exit_volume_xwidth2
#define yheight2 mccdiffraction_detector_15_exit_volume_yheight2
#define visualize mccdiffraction_detector_15_exit_volume_visualize
#define target_index mccdiffraction_detector_15_exit_volume_target_index
#define target_x mccdiffraction_detector_15_exit_volume_target_x
#define target_y mccdiffraction_detector_15_exit_volume_target_y
#define target_z mccdiffraction_detector_15_exit_volume_target_z
#define focus_aw mccdiffraction_detector_15_exit_volume_focus_aw
#define focus_ah mccdiffraction_detector_15_exit_volume_focus_ah
#define focus_xw mccdiffraction_detector_15_exit_volume_focus_xw
#define focus_xh mccdiffraction_detector_15_exit_volume_focus_xh
#define focus_r mccdiffraction_detector_15_exit_volume_focus_r
#define p_interact mccdiffraction_detector_15_exit_volume_p_interact
#define mask_string mccdiffraction_detector_15_exit_volume_mask_string
#define mask_setting mccdiffraction_detector_15_exit_volume_mask_setting
#define number_of_activations mccdiffraction_detector_15_exit_volume_number_of_activations
#line 224 "Union_box.comp"
{
// Initializes the focusing system for this volume including input sanitation.
focus_initialize(&this_box_volume.geometry, POS_A_COMP_INDEX(INDEX_CURRENT_COMP+target_index), POS_A_CURRENT_COMP, ROT_A_CURRENT_COMP, target_index, target_x, target_y, target_z, focus_aw, focus_ah, focus_xw, focus_xh, focus_r, NAME_CURRENT_COMP);

// Input sanitation for this geometry
if (xwidth <= 0) {
  printf("\nERROR in Union_box named %s, the xwidth is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (yheight <= 0) {
  printf("\nERROR in Union_box named %s, yheight is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (zdepth <= 0) {
  printf("\nERROR in Union_box named %s, zdepth is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (xwidth2 <= 0 && xwidth2 != -1) {
  printf("\nERROR in Union_box named %s, the xwidth2 is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (yheight2 <= 0 && yheight2 != -1) {
  printf("\nERROR in Union_box named %s, yheight2 is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}

// Use sanitation
if (global_material_list.num_elements == 0) {
  printf("\nERROR: Need to define a material using Union_make_material before using a Union geometry component. \n");
  printf("       %s was defined before first use of Union_make_material.\n",NAME_CURRENT_COMP);
  exit(1);
}

this_box_volume.geometry.is_masked_volume = 0;
this_box_volume.geometry.is_exit_volume = 0;
this_box_volume.geometry.is_mask_volume = 0;
// check if the volume is a mask, if it is the material string is irelevant.
if (mask_string && strlen(mask_string) && strcmp(mask_string, "NULL") && strcmp(mask_string, "0")) {
    // A mask volume is used to limit the extend of other volumes, called the masked volumes. These are specified in the mask_string.
    // In order for a ray to enter a masked volume, it needs to be both in the region covered by that volume AND the mask volume.
    // When more than
    this_box_volume.geometry.mask_mode = 1; // Default is mask mode is ALL
    if (mask_setting && strlen(mask_setting) && strcmp(mask_setting, "NULL") && strcmp(mask_setting, "0")) {
        if (strcmp(mask_setting,"ALL") == 0 || strcmp(mask_setting,"All") == 0) this_box_volume.geometry.mask_mode = 1;
        else if (strcmp(mask_setting,"ANY") == 0 || strcmp(mask_setting,"Any") == 0) this_box_volume.geometry.mask_mode = 2;
        else {
            printf("The mask_mode of component %s is set to %s, but must be either ALL or ANY.\n",NAME_CURRENT_COMP,mask_setting);
            exit(1);
        }
    }
    
    for (loop_index=0;loop_index<global_geometry_list.num_elements;loop_index++) {
        // Add mask list
        if (1 == manual_linking_function(global_geometry_list.elements[loop_index].name,mask_string)) {
            add_element_to_int_list(&this_box_volume.geometry.mask_list,global_geometry_list.elements[loop_index].component_index);
            add_element_to_int_list(&global_geometry_list.elements[loop_index].Volume->geometry.masked_by_list,INDEX_CURRENT_COMP);
            global_geometry_list.elements[loop_index].Volume->geometry.is_masked_volume = 1;
            if (this_box_volume.geometry.mask_mode == 2)
                global_geometry_list.elements[loop_index].Volume->geometry.mask_mode = 2;
            if (this_box_volume.geometry.mask_mode == 1) {
                if (global_geometry_list.elements[loop_index].Volume->geometry.is_masked_volume == 1 && global_geometry_list.elements[loop_index].Volume->geometry.mask_mode != 2)
                    // If more than one mask is added to one volume, the ANY mode overwrites the (default) ALL mode.
                    global_geometry_list.elements[loop_index].Volume->geometry.mask_mode = 1;
            }
            
            found_geometries = 1;
        }
    }
    if (found_geometries == 0) {
        printf("The mask_string in geometry: %s did not find any of the specified volumes in the mask_string %s \n",NAME_CURRENT_COMP,mask_string);
        exit(1);
    }
    this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
    this_box_volume.p_physics->is_vacuum = 0; // Makes this volume a vacuum
    this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
    this_box_volume.p_physics->my_a = 0; // Should not be used.
    sprintf(this_box_volume.p_physics->name,"Mask");
    this_box_volume.geometry.is_mask_volume = 1;
    
    
// Read the material input, or if it lacks, use automatic linking.
} else if (material_string && strlen(material_string) && strcmp(material_string, "NULL") && strcmp(material_string, "0")) {
    // A geometry string was given, use it to determine which material
    if (0 == strcmp(material_string,"vacuum") || 0 == strcmp(material_string,"Vacuum")) {
        // One could have a global physics struct for vacuum instead of creating one for each
        this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
        this_box_volume.p_physics->is_vacuum = 1; // Makes this volume a vacuum
        this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
        this_box_volume.p_physics->my_a = 0; // Should not be used.
        sprintf(this_box_volume.p_physics->name,"Vacuum");
    } else if (0 == strcmp(material_string,"exit") || 0 == strcmp(material_string,"Exit")) {
        // One could have a global physics struct for vacuum instead of creating one for each
        this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
        this_box_volume.p_physics->is_vacuum = 1; // Makes this volume a vacuum
        this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
        this_box_volume.p_physics->my_a = 0; // Should not be used.
        this_box_volume.geometry.is_exit_volume = 1;
        sprintf(this_box_volume.p_physics->name,"Exit");
    } else {
        #ifndef MATERIAL_DETECTOR
            printf("Need to define a material before refering to it in a geometry %s.\n",NAME_CURRENT_COMP);
            exit(1);
        #endif
        for (loop_index=0;loop_index<global_material_list.num_elements;loop_index++) {
            if (0 == strcmp(material_string,global_material_list.elements[loop_index].name)) {
                this_box_volume.p_physics = global_material_list.elements[loop_index].physics;
                break;
            }
            if (loop_index == global_material_list.num_elements-1) {
            printf("\n");
            printf("ERROR: The material string \"%s\" in Union geometry \"%s\" did not match a specified material. \n",material_string,NAME_CURRENT_COMP);
            printf("       The materials available at this point (need to be defined before the geometry): \n");
            for (loop_index=0;loop_index<global_material_list.num_elements;loop_index++)
              printf("         %s\n",global_material_list.elements[loop_index].name);
            printf("\n");
            printf("       It is also possible to use one of the defualt materials avaiable: \n");
            printf("           Vacuum (for a Volume without scattering or absorption)\n");
            printf("           Exit (for a Volume where the ray exits the component if it enters)\n");
            printf("           Mask (for a Volume that masks existing volumes specified in the mask_string\n");
            exit(1);
          }
        }
    }
} else {
    // Automatic linking, simply using the last defined material.
    #ifndef MATERIAL_DETECTOR
        printf("Need to define a material before the geometry to use automatic linking %s.\n",NAME_CURRENT_COMP);
        exit(1);
    #endif
    this_box_volume.p_physics = global_material_list.elements[global_material_list.num_elements-1].physics;
}

sprintf(this_box_volume.name,NAME_CURRENT_COMP);
sprintf(this_box_volume.geometry.shape,"box");
this_box_volume.geometry.priority_value = priority;
this_box_volume.geometry.geometry_p_interact = p_interact;
// Currently the coordinates will be in absolute space.
this_box_volume.geometry.center = POS_A_CURRENT_COMP;

this_box_storage.z_depth = zdepth;
this_box_storage.x_width1 = xwidth;
this_box_storage.y_height1 = yheight;

this_box_storage.is_rectangle = 0;
if (xwidth2 < 0 && yheight2 < 0) this_box_storage.is_rectangle = 1;
if (xwidth == xwidth2 && yheight == yheight2) this_box_storage.is_rectangle = 1;

if (xwidth2 < 0) {
    this_box_storage.x_width2 = xwidth;
    xwidth2 = xwidth;
} else this_box_storage.x_width2 = xwidth2;

if (yheight2 < 0) {
    this_box_storage.y_height2 = yheight;
    yheight2 = yheight;
} else this_box_storage.y_height2 = yheight2;


this_box_storage.normal_vectors[0] = coords_set(0,0,1);
this_box_storage.normal_vectors[1] = coords_set(0,0,1);

// for sides with y component = 0
x_component = 2*zdepth/sqrt((xwidth-xwidth2)*(xwidth-xwidth2)+4*zdepth*zdepth);
z_component = (xwidth-xwidth2)/sqrt(4*zdepth*zdepth+(xwidth-xwidth2)*(xwidth-xwidth2));

this_box_storage.normal_vectors[2] = coords_set(x_component,0,z_component);
this_box_storage.normal_vectors[3] = coords_set(-x_component,0,z_component);

// for sides with x component = 0
y_component = 2*zdepth/sqrt((yheight-yheight2)*(yheight-yheight2)+4*zdepth*zdepth);
z_component = (yheight-yheight2)/sqrt(4*zdepth*zdepth+(yheight-yheight2)*(yheight-yheight2));

this_box_storage.normal_vectors[4] = coords_set(0,y_component,z_component);
this_box_storage.normal_vectors[5] = coords_set(0,-y_component,z_component);

this_box_volume.geometry.visualization_on = visualize;

this_box_volume.geometry.geometry_parameters.p_box_storage = &this_box_storage;

// Assign pointers to functions for intersection with the shape, checking if a point is inside the shape
if (this_box_storage.is_rectangle == 1) {
this_box_volume.geometry.intersect_function = &sample_box_intersect_simple;
this_box_volume.geometry.within_function = &r_within_box_simple;
}
else {
this_box_volume.geometry.intersect_function = &sample_box_intersect_advanced;
this_box_volume.geometry.within_function = &r_within_box_advanced;
}

this_box_volume.geometry.shell_points = &box_shell_points;
this_box_volume.geometry.mcdisplay_function = &mcdisplay_box_function;
this_box_volume.geometry.initialize_from_main_function = &initialize_box_geometry_from_main_component;
this_box_volume.geometry.process_rot_allocated = 0;

this_box_volume.geometry.copy_geometry_parameters = &allocate_box_storage_copy;

rot_copy(this_box_volume.geometry.rotation_matrix,ROT_A_CURRENT_COMP); //check how ROT_R_CURRENT_COMP would work
rot_transpose(ROT_A_CURRENT_COMP,this_box_volume.geometry.transpose_rotation_matrix);

// Initialize loggers
this_box_volume.loggers.num_elements = 0;

// packing the information into the global_geometry_element, which is then included in the global_geometry_list.
sprintf(global_geometry_element.name,NAME_CURRENT_COMP);
global_geometry_element.activation_counter = number_of_activations;
global_geometry_element.component_index = INDEX_CURRENT_COMP;
global_geometry_element.Volume = &this_box_volume; // Would be nicer if this m was a pointer, now we have the (small) data two places
add_element_to_geometry_list(&global_geometry_list,global_geometry_element);
}
#line 305180 "MACS_sample_kidney_box.c"
#undef number_of_activations
#undef mask_setting
#undef mask_string
#undef p_interact
#undef focus_r
#undef focus_xh
#undef focus_xw
#undef focus_ah
#undef focus_aw
#undef target_z
#undef target_y
#undef target_x
#undef target_index
#undef visualize
#undef yheight2
#undef xwidth2
#undef zdepth
#undef yheight
#undef xwidth
#undef priority
#undef material_string
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

  /* Initializations for component spec_detector_15_exit_volume. */
  SIG_MESSAGE("spec_detector_15_exit_volume (Init)");
#define mccompcurname  spec_detector_15_exit_volume
#define mccompcurtype  Union_box
#define mccompcurindex 731
#define loop_index mccspec_detector_15_exit_volume_loop_index
#define this_box_volume mccspec_detector_15_exit_volume_this_box_volume
#define global_geometry_element mccspec_detector_15_exit_volume_global_geometry_element
#define this_box_storage mccspec_detector_15_exit_volume_this_box_storage
#define material_string mccspec_detector_15_exit_volume_material_string
#define priority mccspec_detector_15_exit_volume_priority
#define xwidth mccspec_detector_15_exit_volume_xwidth
#define yheight mccspec_detector_15_exit_volume_yheight
#define zdepth mccspec_detector_15_exit_volume_zdepth
#define xwidth2 mccspec_detector_15_exit_volume_xwidth2
#define yheight2 mccspec_detector_15_exit_volume_yheight2
#define visualize mccspec_detector_15_exit_volume_visualize
#define target_index mccspec_detector_15_exit_volume_target_index
#define target_x mccspec_detector_15_exit_volume_target_x
#define target_y mccspec_detector_15_exit_volume_target_y
#define target_z mccspec_detector_15_exit_volume_target_z
#define focus_aw mccspec_detector_15_exit_volume_focus_aw
#define focus_ah mccspec_detector_15_exit_volume_focus_ah
#define focus_xw mccspec_detector_15_exit_volume_focus_xw
#define focus_xh mccspec_detector_15_exit_volume_focus_xh
#define focus_r mccspec_detector_15_exit_volume_focus_r
#define p_interact mccspec_detector_15_exit_volume_p_interact
#define mask_string mccspec_detector_15_exit_volume_mask_string
#define mask_setting mccspec_detector_15_exit_volume_mask_setting
#define number_of_activations mccspec_detector_15_exit_volume_number_of_activations
#line 224 "Union_box.comp"
{
// Initializes the focusing system for this volume including input sanitation.
focus_initialize(&this_box_volume.geometry, POS_A_COMP_INDEX(INDEX_CURRENT_COMP+target_index), POS_A_CURRENT_COMP, ROT_A_CURRENT_COMP, target_index, target_x, target_y, target_z, focus_aw, focus_ah, focus_xw, focus_xh, focus_r, NAME_CURRENT_COMP);

// Input sanitation for this geometry
if (xwidth <= 0) {
  printf("\nERROR in Union_box named %s, the xwidth is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (yheight <= 0) {
  printf("\nERROR in Union_box named %s, yheight is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (zdepth <= 0) {
  printf("\nERROR in Union_box named %s, zdepth is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (xwidth2 <= 0 && xwidth2 != -1) {
  printf("\nERROR in Union_box named %s, the xwidth2 is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (yheight2 <= 0 && yheight2 != -1) {
  printf("\nERROR in Union_box named %s, yheight2 is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}

// Use sanitation
if (global_material_list.num_elements == 0) {
  printf("\nERROR: Need to define a material using Union_make_material before using a Union geometry component. \n");
  printf("       %s was defined before first use of Union_make_material.\n",NAME_CURRENT_COMP);
  exit(1);
}

this_box_volume.geometry.is_masked_volume = 0;
this_box_volume.geometry.is_exit_volume = 0;
this_box_volume.geometry.is_mask_volume = 0;
// check if the volume is a mask, if it is the material string is irelevant.
if (mask_string && strlen(mask_string) && strcmp(mask_string, "NULL") && strcmp(mask_string, "0")) {
    // A mask volume is used to limit the extend of other volumes, called the masked volumes. These are specified in the mask_string.
    // In order for a ray to enter a masked volume, it needs to be both in the region covered by that volume AND the mask volume.
    // When more than
    this_box_volume.geometry.mask_mode = 1; // Default is mask mode is ALL
    if (mask_setting && strlen(mask_setting) && strcmp(mask_setting, "NULL") && strcmp(mask_setting, "0")) {
        if (strcmp(mask_setting,"ALL") == 0 || strcmp(mask_setting,"All") == 0) this_box_volume.geometry.mask_mode = 1;
        else if (strcmp(mask_setting,"ANY") == 0 || strcmp(mask_setting,"Any") == 0) this_box_volume.geometry.mask_mode = 2;
        else {
            printf("The mask_mode of component %s is set to %s, but must be either ALL or ANY.\n",NAME_CURRENT_COMP,mask_setting);
            exit(1);
        }
    }
    
    for (loop_index=0;loop_index<global_geometry_list.num_elements;loop_index++) {
        // Add mask list
        if (1 == manual_linking_function(global_geometry_list.elements[loop_index].name,mask_string)) {
            add_element_to_int_list(&this_box_volume.geometry.mask_list,global_geometry_list.elements[loop_index].component_index);
            add_element_to_int_list(&global_geometry_list.elements[loop_index].Volume->geometry.masked_by_list,INDEX_CURRENT_COMP);
            global_geometry_list.elements[loop_index].Volume->geometry.is_masked_volume = 1;
            if (this_box_volume.geometry.mask_mode == 2)
                global_geometry_list.elements[loop_index].Volume->geometry.mask_mode = 2;
            if (this_box_volume.geometry.mask_mode == 1) {
                if (global_geometry_list.elements[loop_index].Volume->geometry.is_masked_volume == 1 && global_geometry_list.elements[loop_index].Volume->geometry.mask_mode != 2)
                    // If more than one mask is added to one volume, the ANY mode overwrites the (default) ALL mode.
                    global_geometry_list.elements[loop_index].Volume->geometry.mask_mode = 1;
            }
            
            found_geometries = 1;
        }
    }
    if (found_geometries == 0) {
        printf("The mask_string in geometry: %s did not find any of the specified volumes in the mask_string %s \n",NAME_CURRENT_COMP,mask_string);
        exit(1);
    }
    this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
    this_box_volume.p_physics->is_vacuum = 0; // Makes this volume a vacuum
    this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
    this_box_volume.p_physics->my_a = 0; // Should not be used.
    sprintf(this_box_volume.p_physics->name,"Mask");
    this_box_volume.geometry.is_mask_volume = 1;
    
    
// Read the material input, or if it lacks, use automatic linking.
} else if (material_string && strlen(material_string) && strcmp(material_string, "NULL") && strcmp(material_string, "0")) {
    // A geometry string was given, use it to determine which material
    if (0 == strcmp(material_string,"vacuum") || 0 == strcmp(material_string,"Vacuum")) {
        // One could have a global physics struct for vacuum instead of creating one for each
        this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
        this_box_volume.p_physics->is_vacuum = 1; // Makes this volume a vacuum
        this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
        this_box_volume.p_physics->my_a = 0; // Should not be used.
        sprintf(this_box_volume.p_physics->name,"Vacuum");
    } else if (0 == strcmp(material_string,"exit") || 0 == strcmp(material_string,"Exit")) {
        // One could have a global physics struct for vacuum instead of creating one for each
        this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
        this_box_volume.p_physics->is_vacuum = 1; // Makes this volume a vacuum
        this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
        this_box_volume.p_physics->my_a = 0; // Should not be used.
        this_box_volume.geometry.is_exit_volume = 1;
        sprintf(this_box_volume.p_physics->name,"Exit");
    } else {
        #ifndef MATERIAL_DETECTOR
            printf("Need to define a material before refering to it in a geometry %s.\n",NAME_CURRENT_COMP);
            exit(1);
        #endif
        for (loop_index=0;loop_index<global_material_list.num_elements;loop_index++) {
            if (0 == strcmp(material_string,global_material_list.elements[loop_index].name)) {
                this_box_volume.p_physics = global_material_list.elements[loop_index].physics;
                break;
            }
            if (loop_index == global_material_list.num_elements-1) {
            printf("\n");
            printf("ERROR: The material string \"%s\" in Union geometry \"%s\" did not match a specified material. \n",material_string,NAME_CURRENT_COMP);
            printf("       The materials available at this point (need to be defined before the geometry): \n");
            for (loop_index=0;loop_index<global_material_list.num_elements;loop_index++)
              printf("         %s\n",global_material_list.elements[loop_index].name);
            printf("\n");
            printf("       It is also possible to use one of the defualt materials avaiable: \n");
            printf("           Vacuum (for a Volume without scattering or absorption)\n");
            printf("           Exit (for a Volume where the ray exits the component if it enters)\n");
            printf("           Mask (for a Volume that masks existing volumes specified in the mask_string\n");
            exit(1);
          }
        }
    }
} else {
    // Automatic linking, simply using the last defined material.
    #ifndef MATERIAL_DETECTOR
        printf("Need to define a material before the geometry to use automatic linking %s.\n",NAME_CURRENT_COMP);
        exit(1);
    #endif
    this_box_volume.p_physics = global_material_list.elements[global_material_list.num_elements-1].physics;
}

sprintf(this_box_volume.name,NAME_CURRENT_COMP);
sprintf(this_box_volume.geometry.shape,"box");
this_box_volume.geometry.priority_value = priority;
this_box_volume.geometry.geometry_p_interact = p_interact;
// Currently the coordinates will be in absolute space.
this_box_volume.geometry.center = POS_A_CURRENT_COMP;

this_box_storage.z_depth = zdepth;
this_box_storage.x_width1 = xwidth;
this_box_storage.y_height1 = yheight;

this_box_storage.is_rectangle = 0;
if (xwidth2 < 0 && yheight2 < 0) this_box_storage.is_rectangle = 1;
if (xwidth == xwidth2 && yheight == yheight2) this_box_storage.is_rectangle = 1;

if (xwidth2 < 0) {
    this_box_storage.x_width2 = xwidth;
    xwidth2 = xwidth;
} else this_box_storage.x_width2 = xwidth2;

if (yheight2 < 0) {
    this_box_storage.y_height2 = yheight;
    yheight2 = yheight;
} else this_box_storage.y_height2 = yheight2;


this_box_storage.normal_vectors[0] = coords_set(0,0,1);
this_box_storage.normal_vectors[1] = coords_set(0,0,1);

// for sides with y component = 0
x_component = 2*zdepth/sqrt((xwidth-xwidth2)*(xwidth-xwidth2)+4*zdepth*zdepth);
z_component = (xwidth-xwidth2)/sqrt(4*zdepth*zdepth+(xwidth-xwidth2)*(xwidth-xwidth2));

this_box_storage.normal_vectors[2] = coords_set(x_component,0,z_component);
this_box_storage.normal_vectors[3] = coords_set(-x_component,0,z_component);

// for sides with x component = 0
y_component = 2*zdepth/sqrt((yheight-yheight2)*(yheight-yheight2)+4*zdepth*zdepth);
z_component = (yheight-yheight2)/sqrt(4*zdepth*zdepth+(yheight-yheight2)*(yheight-yheight2));

this_box_storage.normal_vectors[4] = coords_set(0,y_component,z_component);
this_box_storage.normal_vectors[5] = coords_set(0,-y_component,z_component);

this_box_volume.geometry.visualization_on = visualize;

this_box_volume.geometry.geometry_parameters.p_box_storage = &this_box_storage;

// Assign pointers to functions for intersection with the shape, checking if a point is inside the shape
if (this_box_storage.is_rectangle == 1) {
this_box_volume.geometry.intersect_function = &sample_box_intersect_simple;
this_box_volume.geometry.within_function = &r_within_box_simple;
}
else {
this_box_volume.geometry.intersect_function = &sample_box_intersect_advanced;
this_box_volume.geometry.within_function = &r_within_box_advanced;
}

this_box_volume.geometry.shell_points = &box_shell_points;
this_box_volume.geometry.mcdisplay_function = &mcdisplay_box_function;
this_box_volume.geometry.initialize_from_main_function = &initialize_box_geometry_from_main_component;
this_box_volume.geometry.process_rot_allocated = 0;

this_box_volume.geometry.copy_geometry_parameters = &allocate_box_storage_copy;

rot_copy(this_box_volume.geometry.rotation_matrix,ROT_A_CURRENT_COMP); //check how ROT_R_CURRENT_COMP would work
rot_transpose(ROT_A_CURRENT_COMP,this_box_volume.geometry.transpose_rotation_matrix);

// Initialize loggers
this_box_volume.loggers.num_elements = 0;

// packing the information into the global_geometry_element, which is then included in the global_geometry_list.
sprintf(global_geometry_element.name,NAME_CURRENT_COMP);
global_geometry_element.activation_counter = number_of_activations;
global_geometry_element.component_index = INDEX_CURRENT_COMP;
global_geometry_element.Volume = &this_box_volume; // Would be nicer if this m was a pointer, now we have the (small) data two places
add_element_to_geometry_list(&global_geometry_list,global_geometry_element);
}
#line 305450 "MACS_sample_kidney_box.c"
#undef number_of_activations
#undef mask_setting
#undef mask_string
#undef p_interact
#undef focus_r
#undef focus_xh
#undef focus_xw
#undef focus_ah
#undef focus_aw
#undef target_z
#undef target_y
#undef target_x
#undef target_index
#undef visualize
#undef yheight2
#undef xwidth2
#undef zdepth
#undef yheight
#undef xwidth
#undef priority
#undef material_string
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

  /* Initializations for component channel_16_cave1_box1. */
  SIG_MESSAGE("channel_16_cave1_box1 (Init)");
#define mccompcurname  channel_16_cave1_box1
#define mccompcurtype  Union_box
#define mccompcurindex 732
#define loop_index mccchannel_16_cave1_box1_loop_index
#define this_box_volume mccchannel_16_cave1_box1_this_box_volume
#define global_geometry_element mccchannel_16_cave1_box1_global_geometry_element
#define this_box_storage mccchannel_16_cave1_box1_this_box_storage
#define material_string mccchannel_16_cave1_box1_material_string
#define priority mccchannel_16_cave1_box1_priority
#define xwidth mccchannel_16_cave1_box1_xwidth
#define yheight mccchannel_16_cave1_box1_yheight
#define zdepth mccchannel_16_cave1_box1_zdepth
#define xwidth2 mccchannel_16_cave1_box1_xwidth2
#define yheight2 mccchannel_16_cave1_box1_yheight2
#define visualize mccchannel_16_cave1_box1_visualize
#define target_index mccchannel_16_cave1_box1_target_index
#define target_x mccchannel_16_cave1_box1_target_x
#define target_y mccchannel_16_cave1_box1_target_y
#define target_z mccchannel_16_cave1_box1_target_z
#define focus_aw mccchannel_16_cave1_box1_focus_aw
#define focus_ah mccchannel_16_cave1_box1_focus_ah
#define focus_xw mccchannel_16_cave1_box1_focus_xw
#define focus_xh mccchannel_16_cave1_box1_focus_xh
#define focus_r mccchannel_16_cave1_box1_focus_r
#define p_interact mccchannel_16_cave1_box1_p_interact
#define mask_string mccchannel_16_cave1_box1_mask_string
#define mask_setting mccchannel_16_cave1_box1_mask_setting
#define number_of_activations mccchannel_16_cave1_box1_number_of_activations
#line 224 "Union_box.comp"
{
// Initializes the focusing system for this volume including input sanitation.
focus_initialize(&this_box_volume.geometry, POS_A_COMP_INDEX(INDEX_CURRENT_COMP+target_index), POS_A_CURRENT_COMP, ROT_A_CURRENT_COMP, target_index, target_x, target_y, target_z, focus_aw, focus_ah, focus_xw, focus_xh, focus_r, NAME_CURRENT_COMP);

// Input sanitation for this geometry
if (xwidth <= 0) {
  printf("\nERROR in Union_box named %s, the xwidth is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (yheight <= 0) {
  printf("\nERROR in Union_box named %s, yheight is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (zdepth <= 0) {
  printf("\nERROR in Union_box named %s, zdepth is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (xwidth2 <= 0 && xwidth2 != -1) {
  printf("\nERROR in Union_box named %s, the xwidth2 is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (yheight2 <= 0 && yheight2 != -1) {
  printf("\nERROR in Union_box named %s, yheight2 is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}

// Use sanitation
if (global_material_list.num_elements == 0) {
  printf("\nERROR: Need to define a material using Union_make_material before using a Union geometry component. \n");
  printf("       %s was defined before first use of Union_make_material.\n",NAME_CURRENT_COMP);
  exit(1);
}

this_box_volume.geometry.is_masked_volume = 0;
this_box_volume.geometry.is_exit_volume = 0;
this_box_volume.geometry.is_mask_volume = 0;
// check if the volume is a mask, if it is the material string is irelevant.
if (mask_string && strlen(mask_string) && strcmp(mask_string, "NULL") && strcmp(mask_string, "0")) {
    // A mask volume is used to limit the extend of other volumes, called the masked volumes. These are specified in the mask_string.
    // In order for a ray to enter a masked volume, it needs to be both in the region covered by that volume AND the mask volume.
    // When more than
    this_box_volume.geometry.mask_mode = 1; // Default is mask mode is ALL
    if (mask_setting && strlen(mask_setting) && strcmp(mask_setting, "NULL") && strcmp(mask_setting, "0")) {
        if (strcmp(mask_setting,"ALL") == 0 || strcmp(mask_setting,"All") == 0) this_box_volume.geometry.mask_mode = 1;
        else if (strcmp(mask_setting,"ANY") == 0 || strcmp(mask_setting,"Any") == 0) this_box_volume.geometry.mask_mode = 2;
        else {
            printf("The mask_mode of component %s is set to %s, but must be either ALL or ANY.\n",NAME_CURRENT_COMP,mask_setting);
            exit(1);
        }
    }
    
    for (loop_index=0;loop_index<global_geometry_list.num_elements;loop_index++) {
        // Add mask list
        if (1 == manual_linking_function(global_geometry_list.elements[loop_index].name,mask_string)) {
            add_element_to_int_list(&this_box_volume.geometry.mask_list,global_geometry_list.elements[loop_index].component_index);
            add_element_to_int_list(&global_geometry_list.elements[loop_index].Volume->geometry.masked_by_list,INDEX_CURRENT_COMP);
            global_geometry_list.elements[loop_index].Volume->geometry.is_masked_volume = 1;
            if (this_box_volume.geometry.mask_mode == 2)
                global_geometry_list.elements[loop_index].Volume->geometry.mask_mode = 2;
            if (this_box_volume.geometry.mask_mode == 1) {
                if (global_geometry_list.elements[loop_index].Volume->geometry.is_masked_volume == 1 && global_geometry_list.elements[loop_index].Volume->geometry.mask_mode != 2)
                    // If more than one mask is added to one volume, the ANY mode overwrites the (default) ALL mode.
                    global_geometry_list.elements[loop_index].Volume->geometry.mask_mode = 1;
            }
            
            found_geometries = 1;
        }
    }
    if (found_geometries == 0) {
        printf("The mask_string in geometry: %s did not find any of the specified volumes in the mask_string %s \n",NAME_CURRENT_COMP,mask_string);
        exit(1);
    }
    this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
    this_box_volume.p_physics->is_vacuum = 0; // Makes this volume a vacuum
    this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
    this_box_volume.p_physics->my_a = 0; // Should not be used.
    sprintf(this_box_volume.p_physics->name,"Mask");
    this_box_volume.geometry.is_mask_volume = 1;
    
    
// Read the material input, or if it lacks, use automatic linking.
} else if (material_string && strlen(material_string) && strcmp(material_string, "NULL") && strcmp(material_string, "0")) {
    // A geometry string was given, use it to determine which material
    if (0 == strcmp(material_string,"vacuum") || 0 == strcmp(material_string,"Vacuum")) {
        // One could have a global physics struct for vacuum instead of creating one for each
        this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
        this_box_volume.p_physics->is_vacuum = 1; // Makes this volume a vacuum
        this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
        this_box_volume.p_physics->my_a = 0; // Should not be used.
        sprintf(this_box_volume.p_physics->name,"Vacuum");
    } else if (0 == strcmp(material_string,"exit") || 0 == strcmp(material_string,"Exit")) {
        // One could have a global physics struct for vacuum instead of creating one for each
        this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
        this_box_volume.p_physics->is_vacuum = 1; // Makes this volume a vacuum
        this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
        this_box_volume.p_physics->my_a = 0; // Should not be used.
        this_box_volume.geometry.is_exit_volume = 1;
        sprintf(this_box_volume.p_physics->name,"Exit");
    } else {
        #ifndef MATERIAL_DETECTOR
            printf("Need to define a material before refering to it in a geometry %s.\n",NAME_CURRENT_COMP);
            exit(1);
        #endif
        for (loop_index=0;loop_index<global_material_list.num_elements;loop_index++) {
            if (0 == strcmp(material_string,global_material_list.elements[loop_index].name)) {
                this_box_volume.p_physics = global_material_list.elements[loop_index].physics;
                break;
            }
            if (loop_index == global_material_list.num_elements-1) {
            printf("\n");
            printf("ERROR: The material string \"%s\" in Union geometry \"%s\" did not match a specified material. \n",material_string,NAME_CURRENT_COMP);
            printf("       The materials available at this point (need to be defined before the geometry): \n");
            for (loop_index=0;loop_index<global_material_list.num_elements;loop_index++)
              printf("         %s\n",global_material_list.elements[loop_index].name);
            printf("\n");
            printf("       It is also possible to use one of the defualt materials avaiable: \n");
            printf("           Vacuum (for a Volume without scattering or absorption)\n");
            printf("           Exit (for a Volume where the ray exits the component if it enters)\n");
            printf("           Mask (for a Volume that masks existing volumes specified in the mask_string\n");
            exit(1);
          }
        }
    }
} else {
    // Automatic linking, simply using the last defined material.
    #ifndef MATERIAL_DETECTOR
        printf("Need to define a material before the geometry to use automatic linking %s.\n",NAME_CURRENT_COMP);
        exit(1);
    #endif
    this_box_volume.p_physics = global_material_list.elements[global_material_list.num_elements-1].physics;
}

sprintf(this_box_volume.name,NAME_CURRENT_COMP);
sprintf(this_box_volume.geometry.shape,"box");
this_box_volume.geometry.priority_value = priority;
this_box_volume.geometry.geometry_p_interact = p_interact;
// Currently the coordinates will be in absolute space.
this_box_volume.geometry.center = POS_A_CURRENT_COMP;

this_box_storage.z_depth = zdepth;
this_box_storage.x_width1 = xwidth;
this_box_storage.y_height1 = yheight;

this_box_storage.is_rectangle = 0;
if (xwidth2 < 0 && yheight2 < 0) this_box_storage.is_rectangle = 1;
if (xwidth == xwidth2 && yheight == yheight2) this_box_storage.is_rectangle = 1;

if (xwidth2 < 0) {
    this_box_storage.x_width2 = xwidth;
    xwidth2 = xwidth;
} else this_box_storage.x_width2 = xwidth2;

if (yheight2 < 0) {
    this_box_storage.y_height2 = yheight;
    yheight2 = yheight;
} else this_box_storage.y_height2 = yheight2;


this_box_storage.normal_vectors[0] = coords_set(0,0,1);
this_box_storage.normal_vectors[1] = coords_set(0,0,1);

// for sides with y component = 0
x_component = 2*zdepth/sqrt((xwidth-xwidth2)*(xwidth-xwidth2)+4*zdepth*zdepth);
z_component = (xwidth-xwidth2)/sqrt(4*zdepth*zdepth+(xwidth-xwidth2)*(xwidth-xwidth2));

this_box_storage.normal_vectors[2] = coords_set(x_component,0,z_component);
this_box_storage.normal_vectors[3] = coords_set(-x_component,0,z_component);

// for sides with x component = 0
y_component = 2*zdepth/sqrt((yheight-yheight2)*(yheight-yheight2)+4*zdepth*zdepth);
z_component = (yheight-yheight2)/sqrt(4*zdepth*zdepth+(yheight-yheight2)*(yheight-yheight2));

this_box_storage.normal_vectors[4] = coords_set(0,y_component,z_component);
this_box_storage.normal_vectors[5] = coords_set(0,-y_component,z_component);

this_box_volume.geometry.visualization_on = visualize;

this_box_volume.geometry.geometry_parameters.p_box_storage = &this_box_storage;

// Assign pointers to functions for intersection with the shape, checking if a point is inside the shape
if (this_box_storage.is_rectangle == 1) {
this_box_volume.geometry.intersect_function = &sample_box_intersect_simple;
this_box_volume.geometry.within_function = &r_within_box_simple;
}
else {
this_box_volume.geometry.intersect_function = &sample_box_intersect_advanced;
this_box_volume.geometry.within_function = &r_within_box_advanced;
}

this_box_volume.geometry.shell_points = &box_shell_points;
this_box_volume.geometry.mcdisplay_function = &mcdisplay_box_function;
this_box_volume.geometry.initialize_from_main_function = &initialize_box_geometry_from_main_component;
this_box_volume.geometry.process_rot_allocated = 0;

this_box_volume.geometry.copy_geometry_parameters = &allocate_box_storage_copy;

rot_copy(this_box_volume.geometry.rotation_matrix,ROT_A_CURRENT_COMP); //check how ROT_R_CURRENT_COMP would work
rot_transpose(ROT_A_CURRENT_COMP,this_box_volume.geometry.transpose_rotation_matrix);

// Initialize loggers
this_box_volume.loggers.num_elements = 0;

// packing the information into the global_geometry_element, which is then included in the global_geometry_list.
sprintf(global_geometry_element.name,NAME_CURRENT_COMP);
global_geometry_element.activation_counter = number_of_activations;
global_geometry_element.component_index = INDEX_CURRENT_COMP;
global_geometry_element.Volume = &this_box_volume; // Would be nicer if this m was a pointer, now we have the (small) data two places
add_element_to_geometry_list(&global_geometry_list,global_geometry_element);
}
#line 305720 "MACS_sample_kidney_box.c"
#undef number_of_activations
#undef mask_setting
#undef mask_string
#undef p_interact
#undef focus_r
#undef focus_xh
#undef focus_xw
#undef focus_ah
#undef focus_aw
#undef target_z
#undef target_y
#undef target_x
#undef target_index
#undef visualize
#undef yheight2
#undef xwidth2
#undef zdepth
#undef yheight
#undef xwidth
#undef priority
#undef material_string
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

  /* Initializations for component channel_16_cave1_box2. */
  SIG_MESSAGE("channel_16_cave1_box2 (Init)");
#define mccompcurname  channel_16_cave1_box2
#define mccompcurtype  Union_box
#define mccompcurindex 733
#define loop_index mccchannel_16_cave1_box2_loop_index
#define this_box_volume mccchannel_16_cave1_box2_this_box_volume
#define global_geometry_element mccchannel_16_cave1_box2_global_geometry_element
#define this_box_storage mccchannel_16_cave1_box2_this_box_storage
#define material_string mccchannel_16_cave1_box2_material_string
#define priority mccchannel_16_cave1_box2_priority
#define xwidth mccchannel_16_cave1_box2_xwidth
#define yheight mccchannel_16_cave1_box2_yheight
#define zdepth mccchannel_16_cave1_box2_zdepth
#define xwidth2 mccchannel_16_cave1_box2_xwidth2
#define yheight2 mccchannel_16_cave1_box2_yheight2
#define visualize mccchannel_16_cave1_box2_visualize
#define target_index mccchannel_16_cave1_box2_target_index
#define target_x mccchannel_16_cave1_box2_target_x
#define target_y mccchannel_16_cave1_box2_target_y
#define target_z mccchannel_16_cave1_box2_target_z
#define focus_aw mccchannel_16_cave1_box2_focus_aw
#define focus_ah mccchannel_16_cave1_box2_focus_ah
#define focus_xw mccchannel_16_cave1_box2_focus_xw
#define focus_xh mccchannel_16_cave1_box2_focus_xh
#define focus_r mccchannel_16_cave1_box2_focus_r
#define p_interact mccchannel_16_cave1_box2_p_interact
#define mask_string mccchannel_16_cave1_box2_mask_string
#define mask_setting mccchannel_16_cave1_box2_mask_setting
#define number_of_activations mccchannel_16_cave1_box2_number_of_activations
#line 224 "Union_box.comp"
{
// Initializes the focusing system for this volume including input sanitation.
focus_initialize(&this_box_volume.geometry, POS_A_COMP_INDEX(INDEX_CURRENT_COMP+target_index), POS_A_CURRENT_COMP, ROT_A_CURRENT_COMP, target_index, target_x, target_y, target_z, focus_aw, focus_ah, focus_xw, focus_xh, focus_r, NAME_CURRENT_COMP);

// Input sanitation for this geometry
if (xwidth <= 0) {
  printf("\nERROR in Union_box named %s, the xwidth is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (yheight <= 0) {
  printf("\nERROR in Union_box named %s, yheight is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (zdepth <= 0) {
  printf("\nERROR in Union_box named %s, zdepth is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (xwidth2 <= 0 && xwidth2 != -1) {
  printf("\nERROR in Union_box named %s, the xwidth2 is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (yheight2 <= 0 && yheight2 != -1) {
  printf("\nERROR in Union_box named %s, yheight2 is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}

// Use sanitation
if (global_material_list.num_elements == 0) {
  printf("\nERROR: Need to define a material using Union_make_material before using a Union geometry component. \n");
  printf("       %s was defined before first use of Union_make_material.\n",NAME_CURRENT_COMP);
  exit(1);
}

this_box_volume.geometry.is_masked_volume = 0;
this_box_volume.geometry.is_exit_volume = 0;
this_box_volume.geometry.is_mask_volume = 0;
// check if the volume is a mask, if it is the material string is irelevant.
if (mask_string && strlen(mask_string) && strcmp(mask_string, "NULL") && strcmp(mask_string, "0")) {
    // A mask volume is used to limit the extend of other volumes, called the masked volumes. These are specified in the mask_string.
    // In order for a ray to enter a masked volume, it needs to be both in the region covered by that volume AND the mask volume.
    // When more than
    this_box_volume.geometry.mask_mode = 1; // Default is mask mode is ALL
    if (mask_setting && strlen(mask_setting) && strcmp(mask_setting, "NULL") && strcmp(mask_setting, "0")) {
        if (strcmp(mask_setting,"ALL") == 0 || strcmp(mask_setting,"All") == 0) this_box_volume.geometry.mask_mode = 1;
        else if (strcmp(mask_setting,"ANY") == 0 || strcmp(mask_setting,"Any") == 0) this_box_volume.geometry.mask_mode = 2;
        else {
            printf("The mask_mode of component %s is set to %s, but must be either ALL or ANY.\n",NAME_CURRENT_COMP,mask_setting);
            exit(1);
        }
    }
    
    for (loop_index=0;loop_index<global_geometry_list.num_elements;loop_index++) {
        // Add mask list
        if (1 == manual_linking_function(global_geometry_list.elements[loop_index].name,mask_string)) {
            add_element_to_int_list(&this_box_volume.geometry.mask_list,global_geometry_list.elements[loop_index].component_index);
            add_element_to_int_list(&global_geometry_list.elements[loop_index].Volume->geometry.masked_by_list,INDEX_CURRENT_COMP);
            global_geometry_list.elements[loop_index].Volume->geometry.is_masked_volume = 1;
            if (this_box_volume.geometry.mask_mode == 2)
                global_geometry_list.elements[loop_index].Volume->geometry.mask_mode = 2;
            if (this_box_volume.geometry.mask_mode == 1) {
                if (global_geometry_list.elements[loop_index].Volume->geometry.is_masked_volume == 1 && global_geometry_list.elements[loop_index].Volume->geometry.mask_mode != 2)
                    // If more than one mask is added to one volume, the ANY mode overwrites the (default) ALL mode.
                    global_geometry_list.elements[loop_index].Volume->geometry.mask_mode = 1;
            }
            
            found_geometries = 1;
        }
    }
    if (found_geometries == 0) {
        printf("The mask_string in geometry: %s did not find any of the specified volumes in the mask_string %s \n",NAME_CURRENT_COMP,mask_string);
        exit(1);
    }
    this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
    this_box_volume.p_physics->is_vacuum = 0; // Makes this volume a vacuum
    this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
    this_box_volume.p_physics->my_a = 0; // Should not be used.
    sprintf(this_box_volume.p_physics->name,"Mask");
    this_box_volume.geometry.is_mask_volume = 1;
    
    
// Read the material input, or if it lacks, use automatic linking.
} else if (material_string && strlen(material_string) && strcmp(material_string, "NULL") && strcmp(material_string, "0")) {
    // A geometry string was given, use it to determine which material
    if (0 == strcmp(material_string,"vacuum") || 0 == strcmp(material_string,"Vacuum")) {
        // One could have a global physics struct for vacuum instead of creating one for each
        this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
        this_box_volume.p_physics->is_vacuum = 1; // Makes this volume a vacuum
        this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
        this_box_volume.p_physics->my_a = 0; // Should not be used.
        sprintf(this_box_volume.p_physics->name,"Vacuum");
    } else if (0 == strcmp(material_string,"exit") || 0 == strcmp(material_string,"Exit")) {
        // One could have a global physics struct for vacuum instead of creating one for each
        this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
        this_box_volume.p_physics->is_vacuum = 1; // Makes this volume a vacuum
        this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
        this_box_volume.p_physics->my_a = 0; // Should not be used.
        this_box_volume.geometry.is_exit_volume = 1;
        sprintf(this_box_volume.p_physics->name,"Exit");
    } else {
        #ifndef MATERIAL_DETECTOR
            printf("Need to define a material before refering to it in a geometry %s.\n",NAME_CURRENT_COMP);
            exit(1);
        #endif
        for (loop_index=0;loop_index<global_material_list.num_elements;loop_index++) {
            if (0 == strcmp(material_string,global_material_list.elements[loop_index].name)) {
                this_box_volume.p_physics = global_material_list.elements[loop_index].physics;
                break;
            }
            if (loop_index == global_material_list.num_elements-1) {
            printf("\n");
            printf("ERROR: The material string \"%s\" in Union geometry \"%s\" did not match a specified material. \n",material_string,NAME_CURRENT_COMP);
            printf("       The materials available at this point (need to be defined before the geometry): \n");
            for (loop_index=0;loop_index<global_material_list.num_elements;loop_index++)
              printf("         %s\n",global_material_list.elements[loop_index].name);
            printf("\n");
            printf("       It is also possible to use one of the defualt materials avaiable: \n");
            printf("           Vacuum (for a Volume without scattering or absorption)\n");
            printf("           Exit (for a Volume where the ray exits the component if it enters)\n");
            printf("           Mask (for a Volume that masks existing volumes specified in the mask_string\n");
            exit(1);
          }
        }
    }
} else {
    // Automatic linking, simply using the last defined material.
    #ifndef MATERIAL_DETECTOR
        printf("Need to define a material before the geometry to use automatic linking %s.\n",NAME_CURRENT_COMP);
        exit(1);
    #endif
    this_box_volume.p_physics = global_material_list.elements[global_material_list.num_elements-1].physics;
}

sprintf(this_box_volume.name,NAME_CURRENT_COMP);
sprintf(this_box_volume.geometry.shape,"box");
this_box_volume.geometry.priority_value = priority;
this_box_volume.geometry.geometry_p_interact = p_interact;
// Currently the coordinates will be in absolute space.
this_box_volume.geometry.center = POS_A_CURRENT_COMP;

this_box_storage.z_depth = zdepth;
this_box_storage.x_width1 = xwidth;
this_box_storage.y_height1 = yheight;

this_box_storage.is_rectangle = 0;
if (xwidth2 < 0 && yheight2 < 0) this_box_storage.is_rectangle = 1;
if (xwidth == xwidth2 && yheight == yheight2) this_box_storage.is_rectangle = 1;

if (xwidth2 < 0) {
    this_box_storage.x_width2 = xwidth;
    xwidth2 = xwidth;
} else this_box_storage.x_width2 = xwidth2;

if (yheight2 < 0) {
    this_box_storage.y_height2 = yheight;
    yheight2 = yheight;
} else this_box_storage.y_height2 = yheight2;


this_box_storage.normal_vectors[0] = coords_set(0,0,1);
this_box_storage.normal_vectors[1] = coords_set(0,0,1);

// for sides with y component = 0
x_component = 2*zdepth/sqrt((xwidth-xwidth2)*(xwidth-xwidth2)+4*zdepth*zdepth);
z_component = (xwidth-xwidth2)/sqrt(4*zdepth*zdepth+(xwidth-xwidth2)*(xwidth-xwidth2));

this_box_storage.normal_vectors[2] = coords_set(x_component,0,z_component);
this_box_storage.normal_vectors[3] = coords_set(-x_component,0,z_component);

// for sides with x component = 0
y_component = 2*zdepth/sqrt((yheight-yheight2)*(yheight-yheight2)+4*zdepth*zdepth);
z_component = (yheight-yheight2)/sqrt(4*zdepth*zdepth+(yheight-yheight2)*(yheight-yheight2));

this_box_storage.normal_vectors[4] = coords_set(0,y_component,z_component);
this_box_storage.normal_vectors[5] = coords_set(0,-y_component,z_component);

this_box_volume.geometry.visualization_on = visualize;

this_box_volume.geometry.geometry_parameters.p_box_storage = &this_box_storage;

// Assign pointers to functions for intersection with the shape, checking if a point is inside the shape
if (this_box_storage.is_rectangle == 1) {
this_box_volume.geometry.intersect_function = &sample_box_intersect_simple;
this_box_volume.geometry.within_function = &r_within_box_simple;
}
else {
this_box_volume.geometry.intersect_function = &sample_box_intersect_advanced;
this_box_volume.geometry.within_function = &r_within_box_advanced;
}

this_box_volume.geometry.shell_points = &box_shell_points;
this_box_volume.geometry.mcdisplay_function = &mcdisplay_box_function;
this_box_volume.geometry.initialize_from_main_function = &initialize_box_geometry_from_main_component;
this_box_volume.geometry.process_rot_allocated = 0;

this_box_volume.geometry.copy_geometry_parameters = &allocate_box_storage_copy;

rot_copy(this_box_volume.geometry.rotation_matrix,ROT_A_CURRENT_COMP); //check how ROT_R_CURRENT_COMP would work
rot_transpose(ROT_A_CURRENT_COMP,this_box_volume.geometry.transpose_rotation_matrix);

// Initialize loggers
this_box_volume.loggers.num_elements = 0;

// packing the information into the global_geometry_element, which is then included in the global_geometry_list.
sprintf(global_geometry_element.name,NAME_CURRENT_COMP);
global_geometry_element.activation_counter = number_of_activations;
global_geometry_element.component_index = INDEX_CURRENT_COMP;
global_geometry_element.Volume = &this_box_volume; // Would be nicer if this m was a pointer, now we have the (small) data two places
add_element_to_geometry_list(&global_geometry_list,global_geometry_element);
}
#line 305990 "MACS_sample_kidney_box.c"
#undef number_of_activations
#undef mask_setting
#undef mask_string
#undef p_interact
#undef focus_r
#undef focus_xh
#undef focus_xw
#undef focus_ah
#undef focus_aw
#undef target_z
#undef target_y
#undef target_x
#undef target_index
#undef visualize
#undef yheight2
#undef xwidth2
#undef zdepth
#undef yheight
#undef xwidth
#undef priority
#undef material_string
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

  /* Initializations for component channel_16_cave1_box3. */
  SIG_MESSAGE("channel_16_cave1_box3 (Init)");
#define mccompcurname  channel_16_cave1_box3
#define mccompcurtype  Union_box
#define mccompcurindex 734
#define loop_index mccchannel_16_cave1_box3_loop_index
#define this_box_volume mccchannel_16_cave1_box3_this_box_volume
#define global_geometry_element mccchannel_16_cave1_box3_global_geometry_element
#define this_box_storage mccchannel_16_cave1_box3_this_box_storage
#define material_string mccchannel_16_cave1_box3_material_string
#define priority mccchannel_16_cave1_box3_priority
#define xwidth mccchannel_16_cave1_box3_xwidth
#define yheight mccchannel_16_cave1_box3_yheight
#define zdepth mccchannel_16_cave1_box3_zdepth
#define xwidth2 mccchannel_16_cave1_box3_xwidth2
#define yheight2 mccchannel_16_cave1_box3_yheight2
#define visualize mccchannel_16_cave1_box3_visualize
#define target_index mccchannel_16_cave1_box3_target_index
#define target_x mccchannel_16_cave1_box3_target_x
#define target_y mccchannel_16_cave1_box3_target_y
#define target_z mccchannel_16_cave1_box3_target_z
#define focus_aw mccchannel_16_cave1_box3_focus_aw
#define focus_ah mccchannel_16_cave1_box3_focus_ah
#define focus_xw mccchannel_16_cave1_box3_focus_xw
#define focus_xh mccchannel_16_cave1_box3_focus_xh
#define focus_r mccchannel_16_cave1_box3_focus_r
#define p_interact mccchannel_16_cave1_box3_p_interact
#define mask_string mccchannel_16_cave1_box3_mask_string
#define mask_setting mccchannel_16_cave1_box3_mask_setting
#define number_of_activations mccchannel_16_cave1_box3_number_of_activations
#line 224 "Union_box.comp"
{
// Initializes the focusing system for this volume including input sanitation.
focus_initialize(&this_box_volume.geometry, POS_A_COMP_INDEX(INDEX_CURRENT_COMP+target_index), POS_A_CURRENT_COMP, ROT_A_CURRENT_COMP, target_index, target_x, target_y, target_z, focus_aw, focus_ah, focus_xw, focus_xh, focus_r, NAME_CURRENT_COMP);

// Input sanitation for this geometry
if (xwidth <= 0) {
  printf("\nERROR in Union_box named %s, the xwidth is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (yheight <= 0) {
  printf("\nERROR in Union_box named %s, yheight is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (zdepth <= 0) {
  printf("\nERROR in Union_box named %s, zdepth is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (xwidth2 <= 0 && xwidth2 != -1) {
  printf("\nERROR in Union_box named %s, the xwidth2 is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (yheight2 <= 0 && yheight2 != -1) {
  printf("\nERROR in Union_box named %s, yheight2 is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}

// Use sanitation
if (global_material_list.num_elements == 0) {
  printf("\nERROR: Need to define a material using Union_make_material before using a Union geometry component. \n");
  printf("       %s was defined before first use of Union_make_material.\n",NAME_CURRENT_COMP);
  exit(1);
}

this_box_volume.geometry.is_masked_volume = 0;
this_box_volume.geometry.is_exit_volume = 0;
this_box_volume.geometry.is_mask_volume = 0;
// check if the volume is a mask, if it is the material string is irelevant.
if (mask_string && strlen(mask_string) && strcmp(mask_string, "NULL") && strcmp(mask_string, "0")) {
    // A mask volume is used to limit the extend of other volumes, called the masked volumes. These are specified in the mask_string.
    // In order for a ray to enter a masked volume, it needs to be both in the region covered by that volume AND the mask volume.
    // When more than
    this_box_volume.geometry.mask_mode = 1; // Default is mask mode is ALL
    if (mask_setting && strlen(mask_setting) && strcmp(mask_setting, "NULL") && strcmp(mask_setting, "0")) {
        if (strcmp(mask_setting,"ALL") == 0 || strcmp(mask_setting,"All") == 0) this_box_volume.geometry.mask_mode = 1;
        else if (strcmp(mask_setting,"ANY") == 0 || strcmp(mask_setting,"Any") == 0) this_box_volume.geometry.mask_mode = 2;
        else {
            printf("The mask_mode of component %s is set to %s, but must be either ALL or ANY.\n",NAME_CURRENT_COMP,mask_setting);
            exit(1);
        }
    }
    
    for (loop_index=0;loop_index<global_geometry_list.num_elements;loop_index++) {
        // Add mask list
        if (1 == manual_linking_function(global_geometry_list.elements[loop_index].name,mask_string)) {
            add_element_to_int_list(&this_box_volume.geometry.mask_list,global_geometry_list.elements[loop_index].component_index);
            add_element_to_int_list(&global_geometry_list.elements[loop_index].Volume->geometry.masked_by_list,INDEX_CURRENT_COMP);
            global_geometry_list.elements[loop_index].Volume->geometry.is_masked_volume = 1;
            if (this_box_volume.geometry.mask_mode == 2)
                global_geometry_list.elements[loop_index].Volume->geometry.mask_mode = 2;
            if (this_box_volume.geometry.mask_mode == 1) {
                if (global_geometry_list.elements[loop_index].Volume->geometry.is_masked_volume == 1 && global_geometry_list.elements[loop_index].Volume->geometry.mask_mode != 2)
                    // If more than one mask is added to one volume, the ANY mode overwrites the (default) ALL mode.
                    global_geometry_list.elements[loop_index].Volume->geometry.mask_mode = 1;
            }
            
            found_geometries = 1;
        }
    }
    if (found_geometries == 0) {
        printf("The mask_string in geometry: %s did not find any of the specified volumes in the mask_string %s \n",NAME_CURRENT_COMP,mask_string);
        exit(1);
    }
    this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
    this_box_volume.p_physics->is_vacuum = 0; // Makes this volume a vacuum
    this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
    this_box_volume.p_physics->my_a = 0; // Should not be used.
    sprintf(this_box_volume.p_physics->name,"Mask");
    this_box_volume.geometry.is_mask_volume = 1;
    
    
// Read the material input, or if it lacks, use automatic linking.
} else if (material_string && strlen(material_string) && strcmp(material_string, "NULL") && strcmp(material_string, "0")) {
    // A geometry string was given, use it to determine which material
    if (0 == strcmp(material_string,"vacuum") || 0 == strcmp(material_string,"Vacuum")) {
        // One could have a global physics struct for vacuum instead of creating one for each
        this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
        this_box_volume.p_physics->is_vacuum = 1; // Makes this volume a vacuum
        this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
        this_box_volume.p_physics->my_a = 0; // Should not be used.
        sprintf(this_box_volume.p_physics->name,"Vacuum");
    } else if (0 == strcmp(material_string,"exit") || 0 == strcmp(material_string,"Exit")) {
        // One could have a global physics struct for vacuum instead of creating one for each
        this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
        this_box_volume.p_physics->is_vacuum = 1; // Makes this volume a vacuum
        this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
        this_box_volume.p_physics->my_a = 0; // Should not be used.
        this_box_volume.geometry.is_exit_volume = 1;
        sprintf(this_box_volume.p_physics->name,"Exit");
    } else {
        #ifndef MATERIAL_DETECTOR
            printf("Need to define a material before refering to it in a geometry %s.\n",NAME_CURRENT_COMP);
            exit(1);
        #endif
        for (loop_index=0;loop_index<global_material_list.num_elements;loop_index++) {
            if (0 == strcmp(material_string,global_material_list.elements[loop_index].name)) {
                this_box_volume.p_physics = global_material_list.elements[loop_index].physics;
                break;
            }
            if (loop_index == global_material_list.num_elements-1) {
            printf("\n");
            printf("ERROR: The material string \"%s\" in Union geometry \"%s\" did not match a specified material. \n",material_string,NAME_CURRENT_COMP);
            printf("       The materials available at this point (need to be defined before the geometry): \n");
            for (loop_index=0;loop_index<global_material_list.num_elements;loop_index++)
              printf("         %s\n",global_material_list.elements[loop_index].name);
            printf("\n");
            printf("       It is also possible to use one of the defualt materials avaiable: \n");
            printf("           Vacuum (for a Volume without scattering or absorption)\n");
            printf("           Exit (for a Volume where the ray exits the component if it enters)\n");
            printf("           Mask (for a Volume that masks existing volumes specified in the mask_string\n");
            exit(1);
          }
        }
    }
} else {
    // Automatic linking, simply using the last defined material.
    #ifndef MATERIAL_DETECTOR
        printf("Need to define a material before the geometry to use automatic linking %s.\n",NAME_CURRENT_COMP);
        exit(1);
    #endif
    this_box_volume.p_physics = global_material_list.elements[global_material_list.num_elements-1].physics;
}

sprintf(this_box_volume.name,NAME_CURRENT_COMP);
sprintf(this_box_volume.geometry.shape,"box");
this_box_volume.geometry.priority_value = priority;
this_box_volume.geometry.geometry_p_interact = p_interact;
// Currently the coordinates will be in absolute space.
this_box_volume.geometry.center = POS_A_CURRENT_COMP;

this_box_storage.z_depth = zdepth;
this_box_storage.x_width1 = xwidth;
this_box_storage.y_height1 = yheight;

this_box_storage.is_rectangle = 0;
if (xwidth2 < 0 && yheight2 < 0) this_box_storage.is_rectangle = 1;
if (xwidth == xwidth2 && yheight == yheight2) this_box_storage.is_rectangle = 1;

if (xwidth2 < 0) {
    this_box_storage.x_width2 = xwidth;
    xwidth2 = xwidth;
} else this_box_storage.x_width2 = xwidth2;

if (yheight2 < 0) {
    this_box_storage.y_height2 = yheight;
    yheight2 = yheight;
} else this_box_storage.y_height2 = yheight2;


this_box_storage.normal_vectors[0] = coords_set(0,0,1);
this_box_storage.normal_vectors[1] = coords_set(0,0,1);

// for sides with y component = 0
x_component = 2*zdepth/sqrt((xwidth-xwidth2)*(xwidth-xwidth2)+4*zdepth*zdepth);
z_component = (xwidth-xwidth2)/sqrt(4*zdepth*zdepth+(xwidth-xwidth2)*(xwidth-xwidth2));

this_box_storage.normal_vectors[2] = coords_set(x_component,0,z_component);
this_box_storage.normal_vectors[3] = coords_set(-x_component,0,z_component);

// for sides with x component = 0
y_component = 2*zdepth/sqrt((yheight-yheight2)*(yheight-yheight2)+4*zdepth*zdepth);
z_component = (yheight-yheight2)/sqrt(4*zdepth*zdepth+(yheight-yheight2)*(yheight-yheight2));

this_box_storage.normal_vectors[4] = coords_set(0,y_component,z_component);
this_box_storage.normal_vectors[5] = coords_set(0,-y_component,z_component);

this_box_volume.geometry.visualization_on = visualize;

this_box_volume.geometry.geometry_parameters.p_box_storage = &this_box_storage;

// Assign pointers to functions for intersection with the shape, checking if a point is inside the shape
if (this_box_storage.is_rectangle == 1) {
this_box_volume.geometry.intersect_function = &sample_box_intersect_simple;
this_box_volume.geometry.within_function = &r_within_box_simple;
}
else {
this_box_volume.geometry.intersect_function = &sample_box_intersect_advanced;
this_box_volume.geometry.within_function = &r_within_box_advanced;
}

this_box_volume.geometry.shell_points = &box_shell_points;
this_box_volume.geometry.mcdisplay_function = &mcdisplay_box_function;
this_box_volume.geometry.initialize_from_main_function = &initialize_box_geometry_from_main_component;
this_box_volume.geometry.process_rot_allocated = 0;

this_box_volume.geometry.copy_geometry_parameters = &allocate_box_storage_copy;

rot_copy(this_box_volume.geometry.rotation_matrix,ROT_A_CURRENT_COMP); //check how ROT_R_CURRENT_COMP would work
rot_transpose(ROT_A_CURRENT_COMP,this_box_volume.geometry.transpose_rotation_matrix);

// Initialize loggers
this_box_volume.loggers.num_elements = 0;

// packing the information into the global_geometry_element, which is then included in the global_geometry_list.
sprintf(global_geometry_element.name,NAME_CURRENT_COMP);
global_geometry_element.activation_counter = number_of_activations;
global_geometry_element.component_index = INDEX_CURRENT_COMP;
global_geometry_element.Volume = &this_box_volume; // Would be nicer if this m was a pointer, now we have the (small) data two places
add_element_to_geometry_list(&global_geometry_list,global_geometry_element);
}
#line 306260 "MACS_sample_kidney_box.c"
#undef number_of_activations
#undef mask_setting
#undef mask_string
#undef p_interact
#undef focus_r
#undef focus_xh
#undef focus_xw
#undef focus_ah
#undef focus_aw
#undef target_z
#undef target_y
#undef target_x
#undef target_index
#undef visualize
#undef yheight2
#undef xwidth2
#undef zdepth
#undef yheight
#undef xwidth
#undef priority
#undef material_string
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

  /* Initializations for component channel_16_cave1_cyl1. */
  SIG_MESSAGE("channel_16_cave1_cyl1 (Init)");
#define mccompcurname  channel_16_cave1_cyl1
#define mccompcurtype  Union_cylinder
#define mccompcurindex 735
#define loop_index mccchannel_16_cave1_cyl1_loop_index
#define this_cylinder_volume mccchannel_16_cave1_cyl1_this_cylinder_volume
#define global_geometry_element mccchannel_16_cave1_cyl1_global_geometry_element
#define this_cylinder_storage mccchannel_16_cave1_cyl1_this_cylinder_storage
#define material_string mccchannel_16_cave1_cyl1_material_string
#define priority mccchannel_16_cave1_cyl1_priority
#define radius mccchannel_16_cave1_cyl1_radius
#define yheight mccchannel_16_cave1_cyl1_yheight
#define visualize mccchannel_16_cave1_cyl1_visualize
#define target_index mccchannel_16_cave1_cyl1_target_index
#define target_x mccchannel_16_cave1_cyl1_target_x
#define target_y mccchannel_16_cave1_cyl1_target_y
#define target_z mccchannel_16_cave1_cyl1_target_z
#define focus_aw mccchannel_16_cave1_cyl1_focus_aw
#define focus_ah mccchannel_16_cave1_cyl1_focus_ah
#define focus_xw mccchannel_16_cave1_cyl1_focus_xw
#define focus_xh mccchannel_16_cave1_cyl1_focus_xh
#define focus_r mccchannel_16_cave1_cyl1_focus_r
#define p_interact mccchannel_16_cave1_cyl1_p_interact
#define mask_string mccchannel_16_cave1_cyl1_mask_string
#define mask_setting mccchannel_16_cave1_cyl1_mask_setting
#define number_of_activations mccchannel_16_cave1_cyl1_number_of_activations
#line 185 "Union_cylinder.comp"
{
// Initializes the focusing system for this volume including input sanitation.
focus_initialize(&this_cylinder_volume.geometry, POS_A_COMP_INDEX(INDEX_CURRENT_COMP+target_index), POS_A_CURRENT_COMP, ROT_A_CURRENT_COMP, target_index, target_x, target_y, target_z, focus_aw, focus_ah, focus_xw, focus_xh, focus_r, NAME_CURRENT_COMP);

// Input sanitation for this geometry
if (radius <= 0) {
  printf("\nERROR in Union_cylinder named %s, the radius is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}

if (yheight <= 0) {
  printf("\nERROR in Union_cylinder named %s, yheight is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}

// Use sanitation
#ifdef MATERIAL_DETECTOR
if (global_material_list.num_elements == 0) {
  // Here if the user have defined a material, but only after this material
  printf("\nERROR: Need to define a material using Union_make_material before using a Union geometry component. \n");
  printf("       %s was defined before first use of Union_make_material.\n",NAME_CURRENT_COMP);
  exit(1);
}
#endif
#ifndef MATERIAL_DETECTOR
  printf("\nERROR: Need to define a material using Union_make_material before using a Union geometry component. \n");
  exit(1);
#endif


this_cylinder_volume.geometry.is_masked_volume = 0;
this_cylinder_volume.geometry.is_exit_volume = 0;
this_cylinder_volume.geometry.is_mask_volume = 0;

// Read the material input, or if it lacks, use automatic linking.
if (mask_string && strlen(mask_string) && strcmp(mask_string, "NULL") && strcmp(mask_string, "0")) {
    // A mask volume is used to limit the extend of other volumes, called the masked volumes. These are specified in the mask_string.
    // In order for a ray to enter a masked volume, it needs to be both in the region covered by that volume AND the mask volume.
    // When more than
    this_cylinder_volume.geometry.mask_mode = 1; // Default is mask mode is ALL
    if (mask_setting && strlen(mask_setting) && strcmp(mask_setting, "NULL") && strcmp(mask_setting, "0")) {
        if (strcmp(mask_setting,"ALL") == 0 || strcmp(mask_setting,"All") == 0) this_cylinder_volume.geometry.mask_mode = 1;
        else if (strcmp(mask_setting,"ANY") == 0 || strcmp(mask_setting,"Any") == 0) this_cylinder_volume.geometry.mask_mode = 2;
        else {
            printf("The mask_mode of component %s is set to %s, but must be either ALL or ANY.\n",NAME_CURRENT_COMP,mask_setting);
            exit(1);
        }
    }
    
    for (loop_index=0;loop_index<global_geometry_list.num_elements;loop_index++) {
        // Add mask list
        if (1 == manual_linking_function(global_geometry_list.elements[loop_index].name,mask_string)) {
            add_element_to_int_list(&this_cylinder_volume.geometry.mask_list,global_geometry_list.elements[loop_index].component_index);
            add_element_to_int_list(&global_geometry_list.elements[loop_index].Volume->geometry.masked_by_list,INDEX_CURRENT_COMP);
            global_geometry_list.elements[loop_index].Volume->geometry.is_masked_volume = 1;
            if (this_cylinder_volume.geometry.mask_mode == 2)
                global_geometry_list.elements[loop_index].Volume->geometry.mask_mode = 2;
            if (this_cylinder_volume.geometry.mask_mode == 1) {
                if (global_geometry_list.elements[loop_index].Volume->geometry.is_masked_volume == 1 && global_geometry_list.elements[loop_index].Volume->geometry.mask_mode != 2)
                    // If more than one mask is added to one volume, the ANY mode overwrites the (default) ALL mode.
                    global_geometry_list.elements[loop_index].Volume->geometry.mask_mode = 1;
            }
            
            found_geometries = 1;
        }
    }
    if (found_geometries == 0) {
        printf("The mask_string in geometry: %s did not find any of the specified volumes in the mask_string %s \n",NAME_CURRENT_COMP,mask_string);
        exit(1);
    }
    this_cylinder_volume.p_physics = malloc(sizeof(struct physics_struct));
    this_cylinder_volume.p_physics->is_vacuum = 0; // Makes this volume a vacuum
    this_cylinder_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
    this_cylinder_volume.p_physics->my_a = 0; // Should not be used.
    sprintf(this_cylinder_volume.p_physics->name,"Mask");
    this_cylinder_volume.geometry.is_mask_volume = 1;
    
    
// Read the material input, or if it lacks, use automatic linking.
} else if (material_string && strlen(material_string) && strcmp(material_string, "NULL") && strcmp(material_string, "0")) {
    // A geometry string was given, use it to determine which material
    if (0 == strcmp(material_string,"vacuum") || 0 == strcmp(material_string,"Vacuum")) {
        // One could have a global physics struct for vacuum instead of creating one for each
        this_cylinder_volume.p_physics = malloc(sizeof(struct physics_struct));
        this_cylinder_volume.p_physics->is_vacuum = 1; // Makes this volume a vacuum
        this_cylinder_volume.p_physics->number_of_processes = (int) 0;
        this_cylinder_volume.p_physics->my_a = 0; // Should not be used.
        sprintf(this_cylinder_volume.p_physics->name,"Vacuum");
    } else if (0 == strcmp(material_string,"exit") || 0 == strcmp(material_string,"Exit")) {
        // One could have a global physics struct for exit instead of creating one for each
        this_cylinder_volume.p_physics = malloc(sizeof(struct physics_struct));
        this_cylinder_volume.p_physics->is_vacuum = 1; // Makes this volume a vacuum
        this_cylinder_volume.p_physics->number_of_processes = (int) 0;
        this_cylinder_volume.p_physics->my_a = 0; // Should not be used.
        this_cylinder_volume.geometry.is_exit_volume = 1;
        sprintf(this_cylinder_volume.p_physics->name,"Exit");
    } else {
        for (loop_index=0;loop_index<global_material_list.num_elements;loop_index++) {
          if (0 == strcmp(material_string,global_material_list.elements[loop_index].name)) {
            this_cylinder_volume.p_physics = global_material_list.elements[loop_index].physics;
            break;
          }
          if (loop_index == global_material_list.num_elements-1) {
            printf("\n");
            printf("ERROR: The material string \"%s\" in Union geometry \"%s\" did not match a specified material. \n",material_string,NAME_CURRENT_COMP);
            printf("       The materials available at this point (need to be defined before the geometry): \n");
            for (loop_index=0;loop_index<global_material_list.num_elements;loop_index++)
              printf("         %s\n",global_material_list.elements[loop_index].name);
            printf("\n");
            printf("       It is also possible to use one of the defualt materials avaiable: \n");
            printf("           Vacuum (for a Volume without scattering or absorption)\n");
            printf("           Exit (for a Volume where the ray exits the component if it enters)\n");
            printf("           Mask (for a Volume that masks existing volumes specified in the mask_string\n");
            exit(1);
          }
        }
    }
} else {
    // Automatic linking, simply using the last defined material.
    #ifndef MATERIAL_DETECTOR
        printf("Need to define a material before the geometry to use automatic linking %s.\n",NAME_CURRENT_COMP);
        exit(1);
    #endif
    this_cylinder_volume.p_physics = global_material_list.elements[global_material_list.num_elements-1].physics;
}

sprintf(this_cylinder_volume.name,NAME_CURRENT_COMP);
sprintf(this_cylinder_volume.geometry.shape,"cylinder");
this_cylinder_volume.geometry.priority_value = priority;
// Currently the coordinates will be in absolute space.
this_cylinder_volume.geometry.center = POS_A_CURRENT_COMP;

this_cylinder_volume.geometry.geometry_p_interact = p_interact;
this_cylinder_storage.cyl_radius = radius;
this_cylinder_storage.height = yheight;
this_cylinder_volume.geometry.visualization_on = visualize;
this_cylinder_volume.geometry.geometry_parameters.p_cylinder_storage = &this_cylinder_storage;
this_cylinder_volume.geometry.within_function = &r_within_cylinder;
this_cylinder_volume.geometry.intersect_function = &sample_cylinder_intersect;
this_cylinder_volume.geometry.mcdisplay_function = &mcdisplay_cylinder_function;
this_cylinder_volume.geometry.shell_points = &cylinder_shell_points;
this_cylinder_volume.geometry.initialize_from_main_function = &initialize_cylinder_geometry_from_main_component;
this_cylinder_volume.geometry.process_rot_allocated = 0;
this_cylinder_volume.geometry.copy_geometry_parameters = &allocate_cylinder_storage_copy;

rot_copy(this_cylinder_volume.geometry.rotation_matrix,ROT_A_CURRENT_COMP);
rot_transpose(ROT_A_CURRENT_COMP,this_cylinder_volume.geometry.transpose_rotation_matrix);

// Initialize loggers
this_cylinder_volume.loggers.num_elements = 0;

// packing the information into the global_geometry_element, which is then included in the global_geometry_list.
sprintf(global_geometry_element.name,NAME_CURRENT_COMP);
global_geometry_element.activation_counter = number_of_activations;
global_geometry_element.component_index = INDEX_CURRENT_COMP;
global_geometry_element.Volume = &this_cylinder_volume; // Would be nicer if this m was a pointer, now we have the (small) data two places
add_element_to_geometry_list(&global_geometry_list,global_geometry_element);
}
#line 306476 "MACS_sample_kidney_box.c"
#undef number_of_activations
#undef mask_setting
#undef mask_string
#undef p_interact
#undef focus_r
#undef focus_xh
#undef focus_xw
#undef focus_ah
#undef focus_aw
#undef target_z
#undef target_y
#undef target_x
#undef target_index
#undef visualize
#undef yheight
#undef radius
#undef priority
#undef material_string
#undef this_cylinder_storage
#undef global_geometry_element
#undef this_cylinder_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

  /* Initializations for component channel_16_analyzer_1_center. */
  SIG_MESSAGE("channel_16_analyzer_1_center (Init)");

  /* Initializations for component channel_16_analyzer_1_rotated. */
  SIG_MESSAGE("channel_16_analyzer_1_rotated (Init)");

  /* Initializations for component channel_16_analyzer_1_array_crystal_array_0. */
  SIG_MESSAGE("channel_16_analyzer_1_array_crystal_array_0 (Init)");
#define mccompcurname  channel_16_analyzer_1_array_crystal_array_0
#define mccompcurtype  Union_box
#define mccompcurindex 738
#define loop_index mccchannel_16_analyzer_1_array_crystal_array_0_loop_index
#define this_box_volume mccchannel_16_analyzer_1_array_crystal_array_0_this_box_volume
#define global_geometry_element mccchannel_16_analyzer_1_array_crystal_array_0_global_geometry_element
#define this_box_storage mccchannel_16_analyzer_1_array_crystal_array_0_this_box_storage
#define material_string mccchannel_16_analyzer_1_array_crystal_array_0_material_string
#define priority mccchannel_16_analyzer_1_array_crystal_array_0_priority
#define xwidth mccchannel_16_analyzer_1_array_crystal_array_0_xwidth
#define yheight mccchannel_16_analyzer_1_array_crystal_array_0_yheight
#define zdepth mccchannel_16_analyzer_1_array_crystal_array_0_zdepth
#define xwidth2 mccchannel_16_analyzer_1_array_crystal_array_0_xwidth2
#define yheight2 mccchannel_16_analyzer_1_array_crystal_array_0_yheight2
#define visualize mccchannel_16_analyzer_1_array_crystal_array_0_visualize
#define target_index mccchannel_16_analyzer_1_array_crystal_array_0_target_index
#define target_x mccchannel_16_analyzer_1_array_crystal_array_0_target_x
#define target_y mccchannel_16_analyzer_1_array_crystal_array_0_target_y
#define target_z mccchannel_16_analyzer_1_array_crystal_array_0_target_z
#define focus_aw mccchannel_16_analyzer_1_array_crystal_array_0_focus_aw
#define focus_ah mccchannel_16_analyzer_1_array_crystal_array_0_focus_ah
#define focus_xw mccchannel_16_analyzer_1_array_crystal_array_0_focus_xw
#define focus_xh mccchannel_16_analyzer_1_array_crystal_array_0_focus_xh
#define focus_r mccchannel_16_analyzer_1_array_crystal_array_0_focus_r
#define p_interact mccchannel_16_analyzer_1_array_crystal_array_0_p_interact
#define mask_string mccchannel_16_analyzer_1_array_crystal_array_0_mask_string
#define mask_setting mccchannel_16_analyzer_1_array_crystal_array_0_mask_setting
#define number_of_activations mccchannel_16_analyzer_1_array_crystal_array_0_number_of_activations
#line 224 "Union_box.comp"
{
// Initializes the focusing system for this volume including input sanitation.
focus_initialize(&this_box_volume.geometry, POS_A_COMP_INDEX(INDEX_CURRENT_COMP+target_index), POS_A_CURRENT_COMP, ROT_A_CURRENT_COMP, target_index, target_x, target_y, target_z, focus_aw, focus_ah, focus_xw, focus_xh, focus_r, NAME_CURRENT_COMP);

// Input sanitation for this geometry
if (xwidth <= 0) {
  printf("\nERROR in Union_box named %s, the xwidth is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (yheight <= 0) {
  printf("\nERROR in Union_box named %s, yheight is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (zdepth <= 0) {
  printf("\nERROR in Union_box named %s, zdepth is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (xwidth2 <= 0 && xwidth2 != -1) {
  printf("\nERROR in Union_box named %s, the xwidth2 is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (yheight2 <= 0 && yheight2 != -1) {
  printf("\nERROR in Union_box named %s, yheight2 is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}

// Use sanitation
if (global_material_list.num_elements == 0) {
  printf("\nERROR: Need to define a material using Union_make_material before using a Union geometry component. \n");
  printf("       %s was defined before first use of Union_make_material.\n",NAME_CURRENT_COMP);
  exit(1);
}

this_box_volume.geometry.is_masked_volume = 0;
this_box_volume.geometry.is_exit_volume = 0;
this_box_volume.geometry.is_mask_volume = 0;
// check if the volume is a mask, if it is the material string is irelevant.
if (mask_string && strlen(mask_string) && strcmp(mask_string, "NULL") && strcmp(mask_string, "0")) {
    // A mask volume is used to limit the extend of other volumes, called the masked volumes. These are specified in the mask_string.
    // In order for a ray to enter a masked volume, it needs to be both in the region covered by that volume AND the mask volume.
    // When more than
    this_box_volume.geometry.mask_mode = 1; // Default is mask mode is ALL
    if (mask_setting && strlen(mask_setting) && strcmp(mask_setting, "NULL") && strcmp(mask_setting, "0")) {
        if (strcmp(mask_setting,"ALL") == 0 || strcmp(mask_setting,"All") == 0) this_box_volume.geometry.mask_mode = 1;
        else if (strcmp(mask_setting,"ANY") == 0 || strcmp(mask_setting,"Any") == 0) this_box_volume.geometry.mask_mode = 2;
        else {
            printf("The mask_mode of component %s is set to %s, but must be either ALL or ANY.\n",NAME_CURRENT_COMP,mask_setting);
            exit(1);
        }
    }
    
    for (loop_index=0;loop_index<global_geometry_list.num_elements;loop_index++) {
        // Add mask list
        if (1 == manual_linking_function(global_geometry_list.elements[loop_index].name,mask_string)) {
            add_element_to_int_list(&this_box_volume.geometry.mask_list,global_geometry_list.elements[loop_index].component_index);
            add_element_to_int_list(&global_geometry_list.elements[loop_index].Volume->geometry.masked_by_list,INDEX_CURRENT_COMP);
            global_geometry_list.elements[loop_index].Volume->geometry.is_masked_volume = 1;
            if (this_box_volume.geometry.mask_mode == 2)
                global_geometry_list.elements[loop_index].Volume->geometry.mask_mode = 2;
            if (this_box_volume.geometry.mask_mode == 1) {
                if (global_geometry_list.elements[loop_index].Volume->geometry.is_masked_volume == 1 && global_geometry_list.elements[loop_index].Volume->geometry.mask_mode != 2)
                    // If more than one mask is added to one volume, the ANY mode overwrites the (default) ALL mode.
                    global_geometry_list.elements[loop_index].Volume->geometry.mask_mode = 1;
            }
            
            found_geometries = 1;
        }
    }
    if (found_geometries == 0) {
        printf("The mask_string in geometry: %s did not find any of the specified volumes in the mask_string %s \n",NAME_CURRENT_COMP,mask_string);
        exit(1);
    }
    this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
    this_box_volume.p_physics->is_vacuum = 0; // Makes this volume a vacuum
    this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
    this_box_volume.p_physics->my_a = 0; // Should not be used.
    sprintf(this_box_volume.p_physics->name,"Mask");
    this_box_volume.geometry.is_mask_volume = 1;
    
    
// Read the material input, or if it lacks, use automatic linking.
} else if (material_string && strlen(material_string) && strcmp(material_string, "NULL") && strcmp(material_string, "0")) {
    // A geometry string was given, use it to determine which material
    if (0 == strcmp(material_string,"vacuum") || 0 == strcmp(material_string,"Vacuum")) {
        // One could have a global physics struct for vacuum instead of creating one for each
        this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
        this_box_volume.p_physics->is_vacuum = 1; // Makes this volume a vacuum
        this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
        this_box_volume.p_physics->my_a = 0; // Should not be used.
        sprintf(this_box_volume.p_physics->name,"Vacuum");
    } else if (0 == strcmp(material_string,"exit") || 0 == strcmp(material_string,"Exit")) {
        // One could have a global physics struct for vacuum instead of creating one for each
        this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
        this_box_volume.p_physics->is_vacuum = 1; // Makes this volume a vacuum
        this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
        this_box_volume.p_physics->my_a = 0; // Should not be used.
        this_box_volume.geometry.is_exit_volume = 1;
        sprintf(this_box_volume.p_physics->name,"Exit");
    } else {
        #ifndef MATERIAL_DETECTOR
            printf("Need to define a material before refering to it in a geometry %s.\n",NAME_CURRENT_COMP);
            exit(1);
        #endif
        for (loop_index=0;loop_index<global_material_list.num_elements;loop_index++) {
            if (0 == strcmp(material_string,global_material_list.elements[loop_index].name)) {
                this_box_volume.p_physics = global_material_list.elements[loop_index].physics;
                break;
            }
            if (loop_index == global_material_list.num_elements-1) {
            printf("\n");
            printf("ERROR: The material string \"%s\" in Union geometry \"%s\" did not match a specified material. \n",material_string,NAME_CURRENT_COMP);
            printf("       The materials available at this point (need to be defined before the geometry): \n");
            for (loop_index=0;loop_index<global_material_list.num_elements;loop_index++)
              printf("         %s\n",global_material_list.elements[loop_index].name);
            printf("\n");
            printf("       It is also possible to use one of the defualt materials avaiable: \n");
            printf("           Vacuum (for a Volume without scattering or absorption)\n");
            printf("           Exit (for a Volume where the ray exits the component if it enters)\n");
            printf("           Mask (for a Volume that masks existing volumes specified in the mask_string\n");
            exit(1);
          }
        }
    }
} else {
    // Automatic linking, simply using the last defined material.
    #ifndef MATERIAL_DETECTOR
        printf("Need to define a material before the geometry to use automatic linking %s.\n",NAME_CURRENT_COMP);
        exit(1);
    #endif
    this_box_volume.p_physics = global_material_list.elements[global_material_list.num_elements-1].physics;
}

sprintf(this_box_volume.name,NAME_CURRENT_COMP);
sprintf(this_box_volume.geometry.shape,"box");
this_box_volume.geometry.priority_value = priority;
this_box_volume.geometry.geometry_p_interact = p_interact;
// Currently the coordinates will be in absolute space.
this_box_volume.geometry.center = POS_A_CURRENT_COMP;

this_box_storage.z_depth = zdepth;
this_box_storage.x_width1 = xwidth;
this_box_storage.y_height1 = yheight;

this_box_storage.is_rectangle = 0;
if (xwidth2 < 0 && yheight2 < 0) this_box_storage.is_rectangle = 1;
if (xwidth == xwidth2 && yheight == yheight2) this_box_storage.is_rectangle = 1;

if (xwidth2 < 0) {
    this_box_storage.x_width2 = xwidth;
    xwidth2 = xwidth;
} else this_box_storage.x_width2 = xwidth2;

if (yheight2 < 0) {
    this_box_storage.y_height2 = yheight;
    yheight2 = yheight;
} else this_box_storage.y_height2 = yheight2;


this_box_storage.normal_vectors[0] = coords_set(0,0,1);
this_box_storage.normal_vectors[1] = coords_set(0,0,1);

// for sides with y component = 0
x_component = 2*zdepth/sqrt((xwidth-xwidth2)*(xwidth-xwidth2)+4*zdepth*zdepth);
z_component = (xwidth-xwidth2)/sqrt(4*zdepth*zdepth+(xwidth-xwidth2)*(xwidth-xwidth2));

this_box_storage.normal_vectors[2] = coords_set(x_component,0,z_component);
this_box_storage.normal_vectors[3] = coords_set(-x_component,0,z_component);

// for sides with x component = 0
y_component = 2*zdepth/sqrt((yheight-yheight2)*(yheight-yheight2)+4*zdepth*zdepth);
z_component = (yheight-yheight2)/sqrt(4*zdepth*zdepth+(yheight-yheight2)*(yheight-yheight2));

this_box_storage.normal_vectors[4] = coords_set(0,y_component,z_component);
this_box_storage.normal_vectors[5] = coords_set(0,-y_component,z_component);

this_box_volume.geometry.visualization_on = visualize;

this_box_volume.geometry.geometry_parameters.p_box_storage = &this_box_storage;

// Assign pointers to functions for intersection with the shape, checking if a point is inside the shape
if (this_box_storage.is_rectangle == 1) {
this_box_volume.geometry.intersect_function = &sample_box_intersect_simple;
this_box_volume.geometry.within_function = &r_within_box_simple;
}
else {
this_box_volume.geometry.intersect_function = &sample_box_intersect_advanced;
this_box_volume.geometry.within_function = &r_within_box_advanced;
}

this_box_volume.geometry.shell_points = &box_shell_points;
this_box_volume.geometry.mcdisplay_function = &mcdisplay_box_function;
this_box_volume.geometry.initialize_from_main_function = &initialize_box_geometry_from_main_component;
this_box_volume.geometry.process_rot_allocated = 0;

this_box_volume.geometry.copy_geometry_parameters = &allocate_box_storage_copy;

rot_copy(this_box_volume.geometry.rotation_matrix,ROT_A_CURRENT_COMP); //check how ROT_R_CURRENT_COMP would work
rot_transpose(ROT_A_CURRENT_COMP,this_box_volume.geometry.transpose_rotation_matrix);

// Initialize loggers
this_box_volume.loggers.num_elements = 0;

// packing the information into the global_geometry_element, which is then included in the global_geometry_list.
sprintf(global_geometry_element.name,NAME_CURRENT_COMP);
global_geometry_element.activation_counter = number_of_activations;
global_geometry_element.component_index = INDEX_CURRENT_COMP;
global_geometry_element.Volume = &this_box_volume; // Would be nicer if this m was a pointer, now we have the (small) data two places
add_element_to_geometry_list(&global_geometry_list,global_geometry_element);
}
#line 306749 "MACS_sample_kidney_box.c"
#undef number_of_activations
#undef mask_setting
#undef mask_string
#undef p_interact
#undef focus_r
#undef focus_xh
#undef focus_xw
#undef focus_ah
#undef focus_aw
#undef target_z
#undef target_y
#undef target_x
#undef target_index
#undef visualize
#undef yheight2
#undef xwidth2
#undef zdepth
#undef yheight
#undef xwidth
#undef priority
#undef material_string
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

  /* Initializations for component channel_16_analyzer_1_array_crystal_array_1. */
  SIG_MESSAGE("channel_16_analyzer_1_array_crystal_array_1 (Init)");
#define mccompcurname  channel_16_analyzer_1_array_crystal_array_1
#define mccompcurtype  Union_box
#define mccompcurindex 739
#define loop_index mccchannel_16_analyzer_1_array_crystal_array_1_loop_index
#define this_box_volume mccchannel_16_analyzer_1_array_crystal_array_1_this_box_volume
#define global_geometry_element mccchannel_16_analyzer_1_array_crystal_array_1_global_geometry_element
#define this_box_storage mccchannel_16_analyzer_1_array_crystal_array_1_this_box_storage
#define material_string mccchannel_16_analyzer_1_array_crystal_array_1_material_string
#define priority mccchannel_16_analyzer_1_array_crystal_array_1_priority
#define xwidth mccchannel_16_analyzer_1_array_crystal_array_1_xwidth
#define yheight mccchannel_16_analyzer_1_array_crystal_array_1_yheight
#define zdepth mccchannel_16_analyzer_1_array_crystal_array_1_zdepth
#define xwidth2 mccchannel_16_analyzer_1_array_crystal_array_1_xwidth2
#define yheight2 mccchannel_16_analyzer_1_array_crystal_array_1_yheight2
#define visualize mccchannel_16_analyzer_1_array_crystal_array_1_visualize
#define target_index mccchannel_16_analyzer_1_array_crystal_array_1_target_index
#define target_x mccchannel_16_analyzer_1_array_crystal_array_1_target_x
#define target_y mccchannel_16_analyzer_1_array_crystal_array_1_target_y
#define target_z mccchannel_16_analyzer_1_array_crystal_array_1_target_z
#define focus_aw mccchannel_16_analyzer_1_array_crystal_array_1_focus_aw
#define focus_ah mccchannel_16_analyzer_1_array_crystal_array_1_focus_ah
#define focus_xw mccchannel_16_analyzer_1_array_crystal_array_1_focus_xw
#define focus_xh mccchannel_16_analyzer_1_array_crystal_array_1_focus_xh
#define focus_r mccchannel_16_analyzer_1_array_crystal_array_1_focus_r
#define p_interact mccchannel_16_analyzer_1_array_crystal_array_1_p_interact
#define mask_string mccchannel_16_analyzer_1_array_crystal_array_1_mask_string
#define mask_setting mccchannel_16_analyzer_1_array_crystal_array_1_mask_setting
#define number_of_activations mccchannel_16_analyzer_1_array_crystal_array_1_number_of_activations
#line 224 "Union_box.comp"
{
// Initializes the focusing system for this volume including input sanitation.
focus_initialize(&this_box_volume.geometry, POS_A_COMP_INDEX(INDEX_CURRENT_COMP+target_index), POS_A_CURRENT_COMP, ROT_A_CURRENT_COMP, target_index, target_x, target_y, target_z, focus_aw, focus_ah, focus_xw, focus_xh, focus_r, NAME_CURRENT_COMP);

// Input sanitation for this geometry
if (xwidth <= 0) {
  printf("\nERROR in Union_box named %s, the xwidth is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (yheight <= 0) {
  printf("\nERROR in Union_box named %s, yheight is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (zdepth <= 0) {
  printf("\nERROR in Union_box named %s, zdepth is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (xwidth2 <= 0 && xwidth2 != -1) {
  printf("\nERROR in Union_box named %s, the xwidth2 is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (yheight2 <= 0 && yheight2 != -1) {
  printf("\nERROR in Union_box named %s, yheight2 is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}

// Use sanitation
if (global_material_list.num_elements == 0) {
  printf("\nERROR: Need to define a material using Union_make_material before using a Union geometry component. \n");
  printf("       %s was defined before first use of Union_make_material.\n",NAME_CURRENT_COMP);
  exit(1);
}

this_box_volume.geometry.is_masked_volume = 0;
this_box_volume.geometry.is_exit_volume = 0;
this_box_volume.geometry.is_mask_volume = 0;
// check if the volume is a mask, if it is the material string is irelevant.
if (mask_string && strlen(mask_string) && strcmp(mask_string, "NULL") && strcmp(mask_string, "0")) {
    // A mask volume is used to limit the extend of other volumes, called the masked volumes. These are specified in the mask_string.
    // In order for a ray to enter a masked volume, it needs to be both in the region covered by that volume AND the mask volume.
    // When more than
    this_box_volume.geometry.mask_mode = 1; // Default is mask mode is ALL
    if (mask_setting && strlen(mask_setting) && strcmp(mask_setting, "NULL") && strcmp(mask_setting, "0")) {
        if (strcmp(mask_setting,"ALL") == 0 || strcmp(mask_setting,"All") == 0) this_box_volume.geometry.mask_mode = 1;
        else if (strcmp(mask_setting,"ANY") == 0 || strcmp(mask_setting,"Any") == 0) this_box_volume.geometry.mask_mode = 2;
        else {
            printf("The mask_mode of component %s is set to %s, but must be either ALL or ANY.\n",NAME_CURRENT_COMP,mask_setting);
            exit(1);
        }
    }
    
    for (loop_index=0;loop_index<global_geometry_list.num_elements;loop_index++) {
        // Add mask list
        if (1 == manual_linking_function(global_geometry_list.elements[loop_index].name,mask_string)) {
            add_element_to_int_list(&this_box_volume.geometry.mask_list,global_geometry_list.elements[loop_index].component_index);
            add_element_to_int_list(&global_geometry_list.elements[loop_index].Volume->geometry.masked_by_list,INDEX_CURRENT_COMP);
            global_geometry_list.elements[loop_index].Volume->geometry.is_masked_volume = 1;
            if (this_box_volume.geometry.mask_mode == 2)
                global_geometry_list.elements[loop_index].Volume->geometry.mask_mode = 2;
            if (this_box_volume.geometry.mask_mode == 1) {
                if (global_geometry_list.elements[loop_index].Volume->geometry.is_masked_volume == 1 && global_geometry_list.elements[loop_index].Volume->geometry.mask_mode != 2)
                    // If more than one mask is added to one volume, the ANY mode overwrites the (default) ALL mode.
                    global_geometry_list.elements[loop_index].Volume->geometry.mask_mode = 1;
            }
            
            found_geometries = 1;
        }
    }
    if (found_geometries == 0) {
        printf("The mask_string in geometry: %s did not find any of the specified volumes in the mask_string %s \n",NAME_CURRENT_COMP,mask_string);
        exit(1);
    }
    this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
    this_box_volume.p_physics->is_vacuum = 0; // Makes this volume a vacuum
    this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
    this_box_volume.p_physics->my_a = 0; // Should not be used.
    sprintf(this_box_volume.p_physics->name,"Mask");
    this_box_volume.geometry.is_mask_volume = 1;
    
    
// Read the material input, or if it lacks, use automatic linking.
} else if (material_string && strlen(material_string) && strcmp(material_string, "NULL") && strcmp(material_string, "0")) {
    // A geometry string was given, use it to determine which material
    if (0 == strcmp(material_string,"vacuum") || 0 == strcmp(material_string,"Vacuum")) {
        // One could have a global physics struct for vacuum instead of creating one for each
        this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
        this_box_volume.p_physics->is_vacuum = 1; // Makes this volume a vacuum
        this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
        this_box_volume.p_physics->my_a = 0; // Should not be used.
        sprintf(this_box_volume.p_physics->name,"Vacuum");
    } else if (0 == strcmp(material_string,"exit") || 0 == strcmp(material_string,"Exit")) {
        // One could have a global physics struct for vacuum instead of creating one for each
        this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
        this_box_volume.p_physics->is_vacuum = 1; // Makes this volume a vacuum
        this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
        this_box_volume.p_physics->my_a = 0; // Should not be used.
        this_box_volume.geometry.is_exit_volume = 1;
        sprintf(this_box_volume.p_physics->name,"Exit");
    } else {
        #ifndef MATERIAL_DETECTOR
            printf("Need to define a material before refering to it in a geometry %s.\n",NAME_CURRENT_COMP);
            exit(1);
        #endif
        for (loop_index=0;loop_index<global_material_list.num_elements;loop_index++) {
            if (0 == strcmp(material_string,global_material_list.elements[loop_index].name)) {
                this_box_volume.p_physics = global_material_list.elements[loop_index].physics;
                break;
            }
            if (loop_index == global_material_list.num_elements-1) {
            printf("\n");
            printf("ERROR: The material string \"%s\" in Union geometry \"%s\" did not match a specified material. \n",material_string,NAME_CURRENT_COMP);
            printf("       The materials available at this point (need to be defined before the geometry): \n");
            for (loop_index=0;loop_index<global_material_list.num_elements;loop_index++)
              printf("         %s\n",global_material_list.elements[loop_index].name);
            printf("\n");
            printf("       It is also possible to use one of the defualt materials avaiable: \n");
            printf("           Vacuum (for a Volume without scattering or absorption)\n");
            printf("           Exit (for a Volume where the ray exits the component if it enters)\n");
            printf("           Mask (for a Volume that masks existing volumes specified in the mask_string\n");
            exit(1);
          }
        }
    }
} else {
    // Automatic linking, simply using the last defined material.
    #ifndef MATERIAL_DETECTOR
        printf("Need to define a material before the geometry to use automatic linking %s.\n",NAME_CURRENT_COMP);
        exit(1);
    #endif
    this_box_volume.p_physics = global_material_list.elements[global_material_list.num_elements-1].physics;
}

sprintf(this_box_volume.name,NAME_CURRENT_COMP);
sprintf(this_box_volume.geometry.shape,"box");
this_box_volume.geometry.priority_value = priority;
this_box_volume.geometry.geometry_p_interact = p_interact;
// Currently the coordinates will be in absolute space.
this_box_volume.geometry.center = POS_A_CURRENT_COMP;

this_box_storage.z_depth = zdepth;
this_box_storage.x_width1 = xwidth;
this_box_storage.y_height1 = yheight;

this_box_storage.is_rectangle = 0;
if (xwidth2 < 0 && yheight2 < 0) this_box_storage.is_rectangle = 1;
if (xwidth == xwidth2 && yheight == yheight2) this_box_storage.is_rectangle = 1;

if (xwidth2 < 0) {
    this_box_storage.x_width2 = xwidth;
    xwidth2 = xwidth;
} else this_box_storage.x_width2 = xwidth2;

if (yheight2 < 0) {
    this_box_storage.y_height2 = yheight;
    yheight2 = yheight;
} else this_box_storage.y_height2 = yheight2;


this_box_storage.normal_vectors[0] = coords_set(0,0,1);
this_box_storage.normal_vectors[1] = coords_set(0,0,1);

// for sides with y component = 0
x_component = 2*zdepth/sqrt((xwidth-xwidth2)*(xwidth-xwidth2)+4*zdepth*zdepth);
z_component = (xwidth-xwidth2)/sqrt(4*zdepth*zdepth+(xwidth-xwidth2)*(xwidth-xwidth2));

this_box_storage.normal_vectors[2] = coords_set(x_component,0,z_component);
this_box_storage.normal_vectors[3] = coords_set(-x_component,0,z_component);

// for sides with x component = 0
y_component = 2*zdepth/sqrt((yheight-yheight2)*(yheight-yheight2)+4*zdepth*zdepth);
z_component = (yheight-yheight2)/sqrt(4*zdepth*zdepth+(yheight-yheight2)*(yheight-yheight2));

this_box_storage.normal_vectors[4] = coords_set(0,y_component,z_component);
this_box_storage.normal_vectors[5] = coords_set(0,-y_component,z_component);

this_box_volume.geometry.visualization_on = visualize;

this_box_volume.geometry.geometry_parameters.p_box_storage = &this_box_storage;

// Assign pointers to functions for intersection with the shape, checking if a point is inside the shape
if (this_box_storage.is_rectangle == 1) {
this_box_volume.geometry.intersect_function = &sample_box_intersect_simple;
this_box_volume.geometry.within_function = &r_within_box_simple;
}
else {
this_box_volume.geometry.intersect_function = &sample_box_intersect_advanced;
this_box_volume.geometry.within_function = &r_within_box_advanced;
}

this_box_volume.geometry.shell_points = &box_shell_points;
this_box_volume.geometry.mcdisplay_function = &mcdisplay_box_function;
this_box_volume.geometry.initialize_from_main_function = &initialize_box_geometry_from_main_component;
this_box_volume.geometry.process_rot_allocated = 0;

this_box_volume.geometry.copy_geometry_parameters = &allocate_box_storage_copy;

rot_copy(this_box_volume.geometry.rotation_matrix,ROT_A_CURRENT_COMP); //check how ROT_R_CURRENT_COMP would work
rot_transpose(ROT_A_CURRENT_COMP,this_box_volume.geometry.transpose_rotation_matrix);

// Initialize loggers
this_box_volume.loggers.num_elements = 0;

// packing the information into the global_geometry_element, which is then included in the global_geometry_list.
sprintf(global_geometry_element.name,NAME_CURRENT_COMP);
global_geometry_element.activation_counter = number_of_activations;
global_geometry_element.component_index = INDEX_CURRENT_COMP;
global_geometry_element.Volume = &this_box_volume; // Would be nicer if this m was a pointer, now we have the (small) data two places
add_element_to_geometry_list(&global_geometry_list,global_geometry_element);
}
#line 307019 "MACS_sample_kidney_box.c"
#undef number_of_activations
#undef mask_setting
#undef mask_string
#undef p_interact
#undef focus_r
#undef focus_xh
#undef focus_xw
#undef focus_ah
#undef focus_aw
#undef target_z
#undef target_y
#undef target_x
#undef target_index
#undef visualize
#undef yheight2
#undef xwidth2
#undef zdepth
#undef yheight
#undef xwidth
#undef priority
#undef material_string
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

  /* Initializations for component channel_16_analyzer_1_array_crystal_array_2. */
  SIG_MESSAGE("channel_16_analyzer_1_array_crystal_array_2 (Init)");
#define mccompcurname  channel_16_analyzer_1_array_crystal_array_2
#define mccompcurtype  Union_box
#define mccompcurindex 740
#define loop_index mccchannel_16_analyzer_1_array_crystal_array_2_loop_index
#define this_box_volume mccchannel_16_analyzer_1_array_crystal_array_2_this_box_volume
#define global_geometry_element mccchannel_16_analyzer_1_array_crystal_array_2_global_geometry_element
#define this_box_storage mccchannel_16_analyzer_1_array_crystal_array_2_this_box_storage
#define material_string mccchannel_16_analyzer_1_array_crystal_array_2_material_string
#define priority mccchannel_16_analyzer_1_array_crystal_array_2_priority
#define xwidth mccchannel_16_analyzer_1_array_crystal_array_2_xwidth
#define yheight mccchannel_16_analyzer_1_array_crystal_array_2_yheight
#define zdepth mccchannel_16_analyzer_1_array_crystal_array_2_zdepth
#define xwidth2 mccchannel_16_analyzer_1_array_crystal_array_2_xwidth2
#define yheight2 mccchannel_16_analyzer_1_array_crystal_array_2_yheight2
#define visualize mccchannel_16_analyzer_1_array_crystal_array_2_visualize
#define target_index mccchannel_16_analyzer_1_array_crystal_array_2_target_index
#define target_x mccchannel_16_analyzer_1_array_crystal_array_2_target_x
#define target_y mccchannel_16_analyzer_1_array_crystal_array_2_target_y
#define target_z mccchannel_16_analyzer_1_array_crystal_array_2_target_z
#define focus_aw mccchannel_16_analyzer_1_array_crystal_array_2_focus_aw
#define focus_ah mccchannel_16_analyzer_1_array_crystal_array_2_focus_ah
#define focus_xw mccchannel_16_analyzer_1_array_crystal_array_2_focus_xw
#define focus_xh mccchannel_16_analyzer_1_array_crystal_array_2_focus_xh
#define focus_r mccchannel_16_analyzer_1_array_crystal_array_2_focus_r
#define p_interact mccchannel_16_analyzer_1_array_crystal_array_2_p_interact
#define mask_string mccchannel_16_analyzer_1_array_crystal_array_2_mask_string
#define mask_setting mccchannel_16_analyzer_1_array_crystal_array_2_mask_setting
#define number_of_activations mccchannel_16_analyzer_1_array_crystal_array_2_number_of_activations
#line 224 "Union_box.comp"
{
// Initializes the focusing system for this volume including input sanitation.
focus_initialize(&this_box_volume.geometry, POS_A_COMP_INDEX(INDEX_CURRENT_COMP+target_index), POS_A_CURRENT_COMP, ROT_A_CURRENT_COMP, target_index, target_x, target_y, target_z, focus_aw, focus_ah, focus_xw, focus_xh, focus_r, NAME_CURRENT_COMP);

// Input sanitation for this geometry
if (xwidth <= 0) {
  printf("\nERROR in Union_box named %s, the xwidth is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (yheight <= 0) {
  printf("\nERROR in Union_box named %s, yheight is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (zdepth <= 0) {
  printf("\nERROR in Union_box named %s, zdepth is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (xwidth2 <= 0 && xwidth2 != -1) {
  printf("\nERROR in Union_box named %s, the xwidth2 is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (yheight2 <= 0 && yheight2 != -1) {
  printf("\nERROR in Union_box named %s, yheight2 is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}

// Use sanitation
if (global_material_list.num_elements == 0) {
  printf("\nERROR: Need to define a material using Union_make_material before using a Union geometry component. \n");
  printf("       %s was defined before first use of Union_make_material.\n",NAME_CURRENT_COMP);
  exit(1);
}

this_box_volume.geometry.is_masked_volume = 0;
this_box_volume.geometry.is_exit_volume = 0;
this_box_volume.geometry.is_mask_volume = 0;
// check if the volume is a mask, if it is the material string is irelevant.
if (mask_string && strlen(mask_string) && strcmp(mask_string, "NULL") && strcmp(mask_string, "0")) {
    // A mask volume is used to limit the extend of other volumes, called the masked volumes. These are specified in the mask_string.
    // In order for a ray to enter a masked volume, it needs to be both in the region covered by that volume AND the mask volume.
    // When more than
    this_box_volume.geometry.mask_mode = 1; // Default is mask mode is ALL
    if (mask_setting && strlen(mask_setting) && strcmp(mask_setting, "NULL") && strcmp(mask_setting, "0")) {
        if (strcmp(mask_setting,"ALL") == 0 || strcmp(mask_setting,"All") == 0) this_box_volume.geometry.mask_mode = 1;
        else if (strcmp(mask_setting,"ANY") == 0 || strcmp(mask_setting,"Any") == 0) this_box_volume.geometry.mask_mode = 2;
        else {
            printf("The mask_mode of component %s is set to %s, but must be either ALL or ANY.\n",NAME_CURRENT_COMP,mask_setting);
            exit(1);
        }
    }
    
    for (loop_index=0;loop_index<global_geometry_list.num_elements;loop_index++) {
        // Add mask list
        if (1 == manual_linking_function(global_geometry_list.elements[loop_index].name,mask_string)) {
            add_element_to_int_list(&this_box_volume.geometry.mask_list,global_geometry_list.elements[loop_index].component_index);
            add_element_to_int_list(&global_geometry_list.elements[loop_index].Volume->geometry.masked_by_list,INDEX_CURRENT_COMP);
            global_geometry_list.elements[loop_index].Volume->geometry.is_masked_volume = 1;
            if (this_box_volume.geometry.mask_mode == 2)
                global_geometry_list.elements[loop_index].Volume->geometry.mask_mode = 2;
            if (this_box_volume.geometry.mask_mode == 1) {
                if (global_geometry_list.elements[loop_index].Volume->geometry.is_masked_volume == 1 && global_geometry_list.elements[loop_index].Volume->geometry.mask_mode != 2)
                    // If more than one mask is added to one volume, the ANY mode overwrites the (default) ALL mode.
                    global_geometry_list.elements[loop_index].Volume->geometry.mask_mode = 1;
            }
            
            found_geometries = 1;
        }
    }
    if (found_geometries == 0) {
        printf("The mask_string in geometry: %s did not find any of the specified volumes in the mask_string %s \n",NAME_CURRENT_COMP,mask_string);
        exit(1);
    }
    this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
    this_box_volume.p_physics->is_vacuum = 0; // Makes this volume a vacuum
    this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
    this_box_volume.p_physics->my_a = 0; // Should not be used.
    sprintf(this_box_volume.p_physics->name,"Mask");
    this_box_volume.geometry.is_mask_volume = 1;
    
    
// Read the material input, or if it lacks, use automatic linking.
} else if (material_string && strlen(material_string) && strcmp(material_string, "NULL") && strcmp(material_string, "0")) {
    // A geometry string was given, use it to determine which material
    if (0 == strcmp(material_string,"vacuum") || 0 == strcmp(material_string,"Vacuum")) {
        // One could have a global physics struct for vacuum instead of creating one for each
        this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
        this_box_volume.p_physics->is_vacuum = 1; // Makes this volume a vacuum
        this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
        this_box_volume.p_physics->my_a = 0; // Should not be used.
        sprintf(this_box_volume.p_physics->name,"Vacuum");
    } else if (0 == strcmp(material_string,"exit") || 0 == strcmp(material_string,"Exit")) {
        // One could have a global physics struct for vacuum instead of creating one for each
        this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
        this_box_volume.p_physics->is_vacuum = 1; // Makes this volume a vacuum
        this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
        this_box_volume.p_physics->my_a = 0; // Should not be used.
        this_box_volume.geometry.is_exit_volume = 1;
        sprintf(this_box_volume.p_physics->name,"Exit");
    } else {
        #ifndef MATERIAL_DETECTOR
            printf("Need to define a material before refering to it in a geometry %s.\n",NAME_CURRENT_COMP);
            exit(1);
        #endif
        for (loop_index=0;loop_index<global_material_list.num_elements;loop_index++) {
            if (0 == strcmp(material_string,global_material_list.elements[loop_index].name)) {
                this_box_volume.p_physics = global_material_list.elements[loop_index].physics;
                break;
            }
            if (loop_index == global_material_list.num_elements-1) {
            printf("\n");
            printf("ERROR: The material string \"%s\" in Union geometry \"%s\" did not match a specified material. \n",material_string,NAME_CURRENT_COMP);
            printf("       The materials available at this point (need to be defined before the geometry): \n");
            for (loop_index=0;loop_index<global_material_list.num_elements;loop_index++)
              printf("         %s\n",global_material_list.elements[loop_index].name);
            printf("\n");
            printf("       It is also possible to use one of the defualt materials avaiable: \n");
            printf("           Vacuum (for a Volume without scattering or absorption)\n");
            printf("           Exit (for a Volume where the ray exits the component if it enters)\n");
            printf("           Mask (for a Volume that masks existing volumes specified in the mask_string\n");
            exit(1);
          }
        }
    }
} else {
    // Automatic linking, simply using the last defined material.
    #ifndef MATERIAL_DETECTOR
        printf("Need to define a material before the geometry to use automatic linking %s.\n",NAME_CURRENT_COMP);
        exit(1);
    #endif
    this_box_volume.p_physics = global_material_list.elements[global_material_list.num_elements-1].physics;
}

sprintf(this_box_volume.name,NAME_CURRENT_COMP);
sprintf(this_box_volume.geometry.shape,"box");
this_box_volume.geometry.priority_value = priority;
this_box_volume.geometry.geometry_p_interact = p_interact;
// Currently the coordinates will be in absolute space.
this_box_volume.geometry.center = POS_A_CURRENT_COMP;

this_box_storage.z_depth = zdepth;
this_box_storage.x_width1 = xwidth;
this_box_storage.y_height1 = yheight;

this_box_storage.is_rectangle = 0;
if (xwidth2 < 0 && yheight2 < 0) this_box_storage.is_rectangle = 1;
if (xwidth == xwidth2 && yheight == yheight2) this_box_storage.is_rectangle = 1;

if (xwidth2 < 0) {
    this_box_storage.x_width2 = xwidth;
    xwidth2 = xwidth;
} else this_box_storage.x_width2 = xwidth2;

if (yheight2 < 0) {
    this_box_storage.y_height2 = yheight;
    yheight2 = yheight;
} else this_box_storage.y_height2 = yheight2;


this_box_storage.normal_vectors[0] = coords_set(0,0,1);
this_box_storage.normal_vectors[1] = coords_set(0,0,1);

// for sides with y component = 0
x_component = 2*zdepth/sqrt((xwidth-xwidth2)*(xwidth-xwidth2)+4*zdepth*zdepth);
z_component = (xwidth-xwidth2)/sqrt(4*zdepth*zdepth+(xwidth-xwidth2)*(xwidth-xwidth2));

this_box_storage.normal_vectors[2] = coords_set(x_component,0,z_component);
this_box_storage.normal_vectors[3] = coords_set(-x_component,0,z_component);

// for sides with x component = 0
y_component = 2*zdepth/sqrt((yheight-yheight2)*(yheight-yheight2)+4*zdepth*zdepth);
z_component = (yheight-yheight2)/sqrt(4*zdepth*zdepth+(yheight-yheight2)*(yheight-yheight2));

this_box_storage.normal_vectors[4] = coords_set(0,y_component,z_component);
this_box_storage.normal_vectors[5] = coords_set(0,-y_component,z_component);

this_box_volume.geometry.visualization_on = visualize;

this_box_volume.geometry.geometry_parameters.p_box_storage = &this_box_storage;

// Assign pointers to functions for intersection with the shape, checking if a point is inside the shape
if (this_box_storage.is_rectangle == 1) {
this_box_volume.geometry.intersect_function = &sample_box_intersect_simple;
this_box_volume.geometry.within_function = &r_within_box_simple;
}
else {
this_box_volume.geometry.intersect_function = &sample_box_intersect_advanced;
this_box_volume.geometry.within_function = &r_within_box_advanced;
}

this_box_volume.geometry.shell_points = &box_shell_points;
this_box_volume.geometry.mcdisplay_function = &mcdisplay_box_function;
this_box_volume.geometry.initialize_from_main_function = &initialize_box_geometry_from_main_component;
this_box_volume.geometry.process_rot_allocated = 0;

this_box_volume.geometry.copy_geometry_parameters = &allocate_box_storage_copy;

rot_copy(this_box_volume.geometry.rotation_matrix,ROT_A_CURRENT_COMP); //check how ROT_R_CURRENT_COMP would work
rot_transpose(ROT_A_CURRENT_COMP,this_box_volume.geometry.transpose_rotation_matrix);

// Initialize loggers
this_box_volume.loggers.num_elements = 0;

// packing the information into the global_geometry_element, which is then included in the global_geometry_list.
sprintf(global_geometry_element.name,NAME_CURRENT_COMP);
global_geometry_element.activation_counter = number_of_activations;
global_geometry_element.component_index = INDEX_CURRENT_COMP;
global_geometry_element.Volume = &this_box_volume; // Would be nicer if this m was a pointer, now we have the (small) data two places
add_element_to_geometry_list(&global_geometry_list,global_geometry_element);
}
#line 307289 "MACS_sample_kidney_box.c"
#undef number_of_activations
#undef mask_setting
#undef mask_string
#undef p_interact
#undef focus_r
#undef focus_xh
#undef focus_xw
#undef focus_ah
#undef focus_aw
#undef target_z
#undef target_y
#undef target_x
#undef target_index
#undef visualize
#undef yheight2
#undef xwidth2
#undef zdepth
#undef yheight
#undef xwidth
#undef priority
#undef material_string
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

  /* Initializations for component channel_16_analyzer_1_array_crystal_array_3. */
  SIG_MESSAGE("channel_16_analyzer_1_array_crystal_array_3 (Init)");
#define mccompcurname  channel_16_analyzer_1_array_crystal_array_3
#define mccompcurtype  Union_box
#define mccompcurindex 741
#define loop_index mccchannel_16_analyzer_1_array_crystal_array_3_loop_index
#define this_box_volume mccchannel_16_analyzer_1_array_crystal_array_3_this_box_volume
#define global_geometry_element mccchannel_16_analyzer_1_array_crystal_array_3_global_geometry_element
#define this_box_storage mccchannel_16_analyzer_1_array_crystal_array_3_this_box_storage
#define material_string mccchannel_16_analyzer_1_array_crystal_array_3_material_string
#define priority mccchannel_16_analyzer_1_array_crystal_array_3_priority
#define xwidth mccchannel_16_analyzer_1_array_crystal_array_3_xwidth
#define yheight mccchannel_16_analyzer_1_array_crystal_array_3_yheight
#define zdepth mccchannel_16_analyzer_1_array_crystal_array_3_zdepth
#define xwidth2 mccchannel_16_analyzer_1_array_crystal_array_3_xwidth2
#define yheight2 mccchannel_16_analyzer_1_array_crystal_array_3_yheight2
#define visualize mccchannel_16_analyzer_1_array_crystal_array_3_visualize
#define target_index mccchannel_16_analyzer_1_array_crystal_array_3_target_index
#define target_x mccchannel_16_analyzer_1_array_crystal_array_3_target_x
#define target_y mccchannel_16_analyzer_1_array_crystal_array_3_target_y
#define target_z mccchannel_16_analyzer_1_array_crystal_array_3_target_z
#define focus_aw mccchannel_16_analyzer_1_array_crystal_array_3_focus_aw
#define focus_ah mccchannel_16_analyzer_1_array_crystal_array_3_focus_ah
#define focus_xw mccchannel_16_analyzer_1_array_crystal_array_3_focus_xw
#define focus_xh mccchannel_16_analyzer_1_array_crystal_array_3_focus_xh
#define focus_r mccchannel_16_analyzer_1_array_crystal_array_3_focus_r
#define p_interact mccchannel_16_analyzer_1_array_crystal_array_3_p_interact
#define mask_string mccchannel_16_analyzer_1_array_crystal_array_3_mask_string
#define mask_setting mccchannel_16_analyzer_1_array_crystal_array_3_mask_setting
#define number_of_activations mccchannel_16_analyzer_1_array_crystal_array_3_number_of_activations
#line 224 "Union_box.comp"
{
// Initializes the focusing system for this volume including input sanitation.
focus_initialize(&this_box_volume.geometry, POS_A_COMP_INDEX(INDEX_CURRENT_COMP+target_index), POS_A_CURRENT_COMP, ROT_A_CURRENT_COMP, target_index, target_x, target_y, target_z, focus_aw, focus_ah, focus_xw, focus_xh, focus_r, NAME_CURRENT_COMP);

// Input sanitation for this geometry
if (xwidth <= 0) {
  printf("\nERROR in Union_box named %s, the xwidth is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (yheight <= 0) {
  printf("\nERROR in Union_box named %s, yheight is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (zdepth <= 0) {
  printf("\nERROR in Union_box named %s, zdepth is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (xwidth2 <= 0 && xwidth2 != -1) {
  printf("\nERROR in Union_box named %s, the xwidth2 is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (yheight2 <= 0 && yheight2 != -1) {
  printf("\nERROR in Union_box named %s, yheight2 is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}

// Use sanitation
if (global_material_list.num_elements == 0) {
  printf("\nERROR: Need to define a material using Union_make_material before using a Union geometry component. \n");
  printf("       %s was defined before first use of Union_make_material.\n",NAME_CURRENT_COMP);
  exit(1);
}

this_box_volume.geometry.is_masked_volume = 0;
this_box_volume.geometry.is_exit_volume = 0;
this_box_volume.geometry.is_mask_volume = 0;
// check if the volume is a mask, if it is the material string is irelevant.
if (mask_string && strlen(mask_string) && strcmp(mask_string, "NULL") && strcmp(mask_string, "0")) {
    // A mask volume is used to limit the extend of other volumes, called the masked volumes. These are specified in the mask_string.
    // In order for a ray to enter a masked volume, it needs to be both in the region covered by that volume AND the mask volume.
    // When more than
    this_box_volume.geometry.mask_mode = 1; // Default is mask mode is ALL
    if (mask_setting && strlen(mask_setting) && strcmp(mask_setting, "NULL") && strcmp(mask_setting, "0")) {
        if (strcmp(mask_setting,"ALL") == 0 || strcmp(mask_setting,"All") == 0) this_box_volume.geometry.mask_mode = 1;
        else if (strcmp(mask_setting,"ANY") == 0 || strcmp(mask_setting,"Any") == 0) this_box_volume.geometry.mask_mode = 2;
        else {
            printf("The mask_mode of component %s is set to %s, but must be either ALL or ANY.\n",NAME_CURRENT_COMP,mask_setting);
            exit(1);
        }
    }
    
    for (loop_index=0;loop_index<global_geometry_list.num_elements;loop_index++) {
        // Add mask list
        if (1 == manual_linking_function(global_geometry_list.elements[loop_index].name,mask_string)) {
            add_element_to_int_list(&this_box_volume.geometry.mask_list,global_geometry_list.elements[loop_index].component_index);
            add_element_to_int_list(&global_geometry_list.elements[loop_index].Volume->geometry.masked_by_list,INDEX_CURRENT_COMP);
            global_geometry_list.elements[loop_index].Volume->geometry.is_masked_volume = 1;
            if (this_box_volume.geometry.mask_mode == 2)
                global_geometry_list.elements[loop_index].Volume->geometry.mask_mode = 2;
            if (this_box_volume.geometry.mask_mode == 1) {
                if (global_geometry_list.elements[loop_index].Volume->geometry.is_masked_volume == 1 && global_geometry_list.elements[loop_index].Volume->geometry.mask_mode != 2)
                    // If more than one mask is added to one volume, the ANY mode overwrites the (default) ALL mode.
                    global_geometry_list.elements[loop_index].Volume->geometry.mask_mode = 1;
            }
            
            found_geometries = 1;
        }
    }
    if (found_geometries == 0) {
        printf("The mask_string in geometry: %s did not find any of the specified volumes in the mask_string %s \n",NAME_CURRENT_COMP,mask_string);
        exit(1);
    }
    this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
    this_box_volume.p_physics->is_vacuum = 0; // Makes this volume a vacuum
    this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
    this_box_volume.p_physics->my_a = 0; // Should not be used.
    sprintf(this_box_volume.p_physics->name,"Mask");
    this_box_volume.geometry.is_mask_volume = 1;
    
    
// Read the material input, or if it lacks, use automatic linking.
} else if (material_string && strlen(material_string) && strcmp(material_string, "NULL") && strcmp(material_string, "0")) {
    // A geometry string was given, use it to determine which material
    if (0 == strcmp(material_string,"vacuum") || 0 == strcmp(material_string,"Vacuum")) {
        // One could have a global physics struct for vacuum instead of creating one for each
        this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
        this_box_volume.p_physics->is_vacuum = 1; // Makes this volume a vacuum
        this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
        this_box_volume.p_physics->my_a = 0; // Should not be used.
        sprintf(this_box_volume.p_physics->name,"Vacuum");
    } else if (0 == strcmp(material_string,"exit") || 0 == strcmp(material_string,"Exit")) {
        // One could have a global physics struct for vacuum instead of creating one for each
        this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
        this_box_volume.p_physics->is_vacuum = 1; // Makes this volume a vacuum
        this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
        this_box_volume.p_physics->my_a = 0; // Should not be used.
        this_box_volume.geometry.is_exit_volume = 1;
        sprintf(this_box_volume.p_physics->name,"Exit");
    } else {
        #ifndef MATERIAL_DETECTOR
            printf("Need to define a material before refering to it in a geometry %s.\n",NAME_CURRENT_COMP);
            exit(1);
        #endif
        for (loop_index=0;loop_index<global_material_list.num_elements;loop_index++) {
            if (0 == strcmp(material_string,global_material_list.elements[loop_index].name)) {
                this_box_volume.p_physics = global_material_list.elements[loop_index].physics;
                break;
            }
            if (loop_index == global_material_list.num_elements-1) {
            printf("\n");
            printf("ERROR: The material string \"%s\" in Union geometry \"%s\" did not match a specified material. \n",material_string,NAME_CURRENT_COMP);
            printf("       The materials available at this point (need to be defined before the geometry): \n");
            for (loop_index=0;loop_index<global_material_list.num_elements;loop_index++)
              printf("         %s\n",global_material_list.elements[loop_index].name);
            printf("\n");
            printf("       It is also possible to use one of the defualt materials avaiable: \n");
            printf("           Vacuum (for a Volume without scattering or absorption)\n");
            printf("           Exit (for a Volume where the ray exits the component if it enters)\n");
            printf("           Mask (for a Volume that masks existing volumes specified in the mask_string\n");
            exit(1);
          }
        }
    }
} else {
    // Automatic linking, simply using the last defined material.
    #ifndef MATERIAL_DETECTOR
        printf("Need to define a material before the geometry to use automatic linking %s.\n",NAME_CURRENT_COMP);
        exit(1);
    #endif
    this_box_volume.p_physics = global_material_list.elements[global_material_list.num_elements-1].physics;
}

sprintf(this_box_volume.name,NAME_CURRENT_COMP);
sprintf(this_box_volume.geometry.shape,"box");
this_box_volume.geometry.priority_value = priority;
this_box_volume.geometry.geometry_p_interact = p_interact;
// Currently the coordinates will be in absolute space.
this_box_volume.geometry.center = POS_A_CURRENT_COMP;

this_box_storage.z_depth = zdepth;
this_box_storage.x_width1 = xwidth;
this_box_storage.y_height1 = yheight;

this_box_storage.is_rectangle = 0;
if (xwidth2 < 0 && yheight2 < 0) this_box_storage.is_rectangle = 1;
if (xwidth == xwidth2 && yheight == yheight2) this_box_storage.is_rectangle = 1;

if (xwidth2 < 0) {
    this_box_storage.x_width2 = xwidth;
    xwidth2 = xwidth;
} else this_box_storage.x_width2 = xwidth2;

if (yheight2 < 0) {
    this_box_storage.y_height2 = yheight;
    yheight2 = yheight;
} else this_box_storage.y_height2 = yheight2;


this_box_storage.normal_vectors[0] = coords_set(0,0,1);
this_box_storage.normal_vectors[1] = coords_set(0,0,1);

// for sides with y component = 0
x_component = 2*zdepth/sqrt((xwidth-xwidth2)*(xwidth-xwidth2)+4*zdepth*zdepth);
z_component = (xwidth-xwidth2)/sqrt(4*zdepth*zdepth+(xwidth-xwidth2)*(xwidth-xwidth2));

this_box_storage.normal_vectors[2] = coords_set(x_component,0,z_component);
this_box_storage.normal_vectors[3] = coords_set(-x_component,0,z_component);

// for sides with x component = 0
y_component = 2*zdepth/sqrt((yheight-yheight2)*(yheight-yheight2)+4*zdepth*zdepth);
z_component = (yheight-yheight2)/sqrt(4*zdepth*zdepth+(yheight-yheight2)*(yheight-yheight2));

this_box_storage.normal_vectors[4] = coords_set(0,y_component,z_component);
this_box_storage.normal_vectors[5] = coords_set(0,-y_component,z_component);

this_box_volume.geometry.visualization_on = visualize;

this_box_volume.geometry.geometry_parameters.p_box_storage = &this_box_storage;

// Assign pointers to functions for intersection with the shape, checking if a point is inside the shape
if (this_box_storage.is_rectangle == 1) {
this_box_volume.geometry.intersect_function = &sample_box_intersect_simple;
this_box_volume.geometry.within_function = &r_within_box_simple;
}
else {
this_box_volume.geometry.intersect_function = &sample_box_intersect_advanced;
this_box_volume.geometry.within_function = &r_within_box_advanced;
}

this_box_volume.geometry.shell_points = &box_shell_points;
this_box_volume.geometry.mcdisplay_function = &mcdisplay_box_function;
this_box_volume.geometry.initialize_from_main_function = &initialize_box_geometry_from_main_component;
this_box_volume.geometry.process_rot_allocated = 0;

this_box_volume.geometry.copy_geometry_parameters = &allocate_box_storage_copy;

rot_copy(this_box_volume.geometry.rotation_matrix,ROT_A_CURRENT_COMP); //check how ROT_R_CURRENT_COMP would work
rot_transpose(ROT_A_CURRENT_COMP,this_box_volume.geometry.transpose_rotation_matrix);

// Initialize loggers
this_box_volume.loggers.num_elements = 0;

// packing the information into the global_geometry_element, which is then included in the global_geometry_list.
sprintf(global_geometry_element.name,NAME_CURRENT_COMP);
global_geometry_element.activation_counter = number_of_activations;
global_geometry_element.component_index = INDEX_CURRENT_COMP;
global_geometry_element.Volume = &this_box_volume; // Would be nicer if this m was a pointer, now we have the (small) data two places
add_element_to_geometry_list(&global_geometry_list,global_geometry_element);
}
#line 307559 "MACS_sample_kidney_box.c"
#undef number_of_activations
#undef mask_setting
#undef mask_string
#undef p_interact
#undef focus_r
#undef focus_xh
#undef focus_xw
#undef focus_ah
#undef focus_aw
#undef target_z
#undef target_y
#undef target_x
#undef target_index
#undef visualize
#undef yheight2
#undef xwidth2
#undef zdepth
#undef yheight
#undef xwidth
#undef priority
#undef material_string
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

  /* Initializations for component channel_16_analyzer_1_array_crystal_array_4. */
  SIG_MESSAGE("channel_16_analyzer_1_array_crystal_array_4 (Init)");
#define mccompcurname  channel_16_analyzer_1_array_crystal_array_4
#define mccompcurtype  Union_box
#define mccompcurindex 742
#define loop_index mccchannel_16_analyzer_1_array_crystal_array_4_loop_index
#define this_box_volume mccchannel_16_analyzer_1_array_crystal_array_4_this_box_volume
#define global_geometry_element mccchannel_16_analyzer_1_array_crystal_array_4_global_geometry_element
#define this_box_storage mccchannel_16_analyzer_1_array_crystal_array_4_this_box_storage
#define material_string mccchannel_16_analyzer_1_array_crystal_array_4_material_string
#define priority mccchannel_16_analyzer_1_array_crystal_array_4_priority
#define xwidth mccchannel_16_analyzer_1_array_crystal_array_4_xwidth
#define yheight mccchannel_16_analyzer_1_array_crystal_array_4_yheight
#define zdepth mccchannel_16_analyzer_1_array_crystal_array_4_zdepth
#define xwidth2 mccchannel_16_analyzer_1_array_crystal_array_4_xwidth2
#define yheight2 mccchannel_16_analyzer_1_array_crystal_array_4_yheight2
#define visualize mccchannel_16_analyzer_1_array_crystal_array_4_visualize
#define target_index mccchannel_16_analyzer_1_array_crystal_array_4_target_index
#define target_x mccchannel_16_analyzer_1_array_crystal_array_4_target_x
#define target_y mccchannel_16_analyzer_1_array_crystal_array_4_target_y
#define target_z mccchannel_16_analyzer_1_array_crystal_array_4_target_z
#define focus_aw mccchannel_16_analyzer_1_array_crystal_array_4_focus_aw
#define focus_ah mccchannel_16_analyzer_1_array_crystal_array_4_focus_ah
#define focus_xw mccchannel_16_analyzer_1_array_crystal_array_4_focus_xw
#define focus_xh mccchannel_16_analyzer_1_array_crystal_array_4_focus_xh
#define focus_r mccchannel_16_analyzer_1_array_crystal_array_4_focus_r
#define p_interact mccchannel_16_analyzer_1_array_crystal_array_4_p_interact
#define mask_string mccchannel_16_analyzer_1_array_crystal_array_4_mask_string
#define mask_setting mccchannel_16_analyzer_1_array_crystal_array_4_mask_setting
#define number_of_activations mccchannel_16_analyzer_1_array_crystal_array_4_number_of_activations
#line 224 "Union_box.comp"
{
// Initializes the focusing system for this volume including input sanitation.
focus_initialize(&this_box_volume.geometry, POS_A_COMP_INDEX(INDEX_CURRENT_COMP+target_index), POS_A_CURRENT_COMP, ROT_A_CURRENT_COMP, target_index, target_x, target_y, target_z, focus_aw, focus_ah, focus_xw, focus_xh, focus_r, NAME_CURRENT_COMP);

// Input sanitation for this geometry
if (xwidth <= 0) {
  printf("\nERROR in Union_box named %s, the xwidth is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (yheight <= 0) {
  printf("\nERROR in Union_box named %s, yheight is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (zdepth <= 0) {
  printf("\nERROR in Union_box named %s, zdepth is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (xwidth2 <= 0 && xwidth2 != -1) {
  printf("\nERROR in Union_box named %s, the xwidth2 is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (yheight2 <= 0 && yheight2 != -1) {
  printf("\nERROR in Union_box named %s, yheight2 is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}

// Use sanitation
if (global_material_list.num_elements == 0) {
  printf("\nERROR: Need to define a material using Union_make_material before using a Union geometry component. \n");
  printf("       %s was defined before first use of Union_make_material.\n",NAME_CURRENT_COMP);
  exit(1);
}

this_box_volume.geometry.is_masked_volume = 0;
this_box_volume.geometry.is_exit_volume = 0;
this_box_volume.geometry.is_mask_volume = 0;
// check if the volume is a mask, if it is the material string is irelevant.
if (mask_string && strlen(mask_string) && strcmp(mask_string, "NULL") && strcmp(mask_string, "0")) {
    // A mask volume is used to limit the extend of other volumes, called the masked volumes. These are specified in the mask_string.
    // In order for a ray to enter a masked volume, it needs to be both in the region covered by that volume AND the mask volume.
    // When more than
    this_box_volume.geometry.mask_mode = 1; // Default is mask mode is ALL
    if (mask_setting && strlen(mask_setting) && strcmp(mask_setting, "NULL") && strcmp(mask_setting, "0")) {
        if (strcmp(mask_setting,"ALL") == 0 || strcmp(mask_setting,"All") == 0) this_box_volume.geometry.mask_mode = 1;
        else if (strcmp(mask_setting,"ANY") == 0 || strcmp(mask_setting,"Any") == 0) this_box_volume.geometry.mask_mode = 2;
        else {
            printf("The mask_mode of component %s is set to %s, but must be either ALL or ANY.\n",NAME_CURRENT_COMP,mask_setting);
            exit(1);
        }
    }
    
    for (loop_index=0;loop_index<global_geometry_list.num_elements;loop_index++) {
        // Add mask list
        if (1 == manual_linking_function(global_geometry_list.elements[loop_index].name,mask_string)) {
            add_element_to_int_list(&this_box_volume.geometry.mask_list,global_geometry_list.elements[loop_index].component_index);
            add_element_to_int_list(&global_geometry_list.elements[loop_index].Volume->geometry.masked_by_list,INDEX_CURRENT_COMP);
            global_geometry_list.elements[loop_index].Volume->geometry.is_masked_volume = 1;
            if (this_box_volume.geometry.mask_mode == 2)
                global_geometry_list.elements[loop_index].Volume->geometry.mask_mode = 2;
            if (this_box_volume.geometry.mask_mode == 1) {
                if (global_geometry_list.elements[loop_index].Volume->geometry.is_masked_volume == 1 && global_geometry_list.elements[loop_index].Volume->geometry.mask_mode != 2)
                    // If more than one mask is added to one volume, the ANY mode overwrites the (default) ALL mode.
                    global_geometry_list.elements[loop_index].Volume->geometry.mask_mode = 1;
            }
            
            found_geometries = 1;
        }
    }
    if (found_geometries == 0) {
        printf("The mask_string in geometry: %s did not find any of the specified volumes in the mask_string %s \n",NAME_CURRENT_COMP,mask_string);
        exit(1);
    }
    this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
    this_box_volume.p_physics->is_vacuum = 0; // Makes this volume a vacuum
    this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
    this_box_volume.p_physics->my_a = 0; // Should not be used.
    sprintf(this_box_volume.p_physics->name,"Mask");
    this_box_volume.geometry.is_mask_volume = 1;
    
    
// Read the material input, or if it lacks, use automatic linking.
} else if (material_string && strlen(material_string) && strcmp(material_string, "NULL") && strcmp(material_string, "0")) {
    // A geometry string was given, use it to determine which material
    if (0 == strcmp(material_string,"vacuum") || 0 == strcmp(material_string,"Vacuum")) {
        // One could have a global physics struct for vacuum instead of creating one for each
        this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
        this_box_volume.p_physics->is_vacuum = 1; // Makes this volume a vacuum
        this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
        this_box_volume.p_physics->my_a = 0; // Should not be used.
        sprintf(this_box_volume.p_physics->name,"Vacuum");
    } else if (0 == strcmp(material_string,"exit") || 0 == strcmp(material_string,"Exit")) {
        // One could have a global physics struct for vacuum instead of creating one for each
        this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
        this_box_volume.p_physics->is_vacuum = 1; // Makes this volume a vacuum
        this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
        this_box_volume.p_physics->my_a = 0; // Should not be used.
        this_box_volume.geometry.is_exit_volume = 1;
        sprintf(this_box_volume.p_physics->name,"Exit");
    } else {
        #ifndef MATERIAL_DETECTOR
            printf("Need to define a material before refering to it in a geometry %s.\n",NAME_CURRENT_COMP);
            exit(1);
        #endif
        for (loop_index=0;loop_index<global_material_list.num_elements;loop_index++) {
            if (0 == strcmp(material_string,global_material_list.elements[loop_index].name)) {
                this_box_volume.p_physics = global_material_list.elements[loop_index].physics;
                break;
            }
            if (loop_index == global_material_list.num_elements-1) {
            printf("\n");
            printf("ERROR: The material string \"%s\" in Union geometry \"%s\" did not match a specified material. \n",material_string,NAME_CURRENT_COMP);
            printf("       The materials available at this point (need to be defined before the geometry): \n");
            for (loop_index=0;loop_index<global_material_list.num_elements;loop_index++)
              printf("         %s\n",global_material_list.elements[loop_index].name);
            printf("\n");
            printf("       It is also possible to use one of the defualt materials avaiable: \n");
            printf("           Vacuum (for a Volume without scattering or absorption)\n");
            printf("           Exit (for a Volume where the ray exits the component if it enters)\n");
            printf("           Mask (for a Volume that masks existing volumes specified in the mask_string\n");
            exit(1);
          }
        }
    }
} else {
    // Automatic linking, simply using the last defined material.
    #ifndef MATERIAL_DETECTOR
        printf("Need to define a material before the geometry to use automatic linking %s.\n",NAME_CURRENT_COMP);
        exit(1);
    #endif
    this_box_volume.p_physics = global_material_list.elements[global_material_list.num_elements-1].physics;
}

sprintf(this_box_volume.name,NAME_CURRENT_COMP);
sprintf(this_box_volume.geometry.shape,"box");
this_box_volume.geometry.priority_value = priority;
this_box_volume.geometry.geometry_p_interact = p_interact;
// Currently the coordinates will be in absolute space.
this_box_volume.geometry.center = POS_A_CURRENT_COMP;

this_box_storage.z_depth = zdepth;
this_box_storage.x_width1 = xwidth;
this_box_storage.y_height1 = yheight;

this_box_storage.is_rectangle = 0;
if (xwidth2 < 0 && yheight2 < 0) this_box_storage.is_rectangle = 1;
if (xwidth == xwidth2 && yheight == yheight2) this_box_storage.is_rectangle = 1;

if (xwidth2 < 0) {
    this_box_storage.x_width2 = xwidth;
    xwidth2 = xwidth;
} else this_box_storage.x_width2 = xwidth2;

if (yheight2 < 0) {
    this_box_storage.y_height2 = yheight;
    yheight2 = yheight;
} else this_box_storage.y_height2 = yheight2;


this_box_storage.normal_vectors[0] = coords_set(0,0,1);
this_box_storage.normal_vectors[1] = coords_set(0,0,1);

// for sides with y component = 0
x_component = 2*zdepth/sqrt((xwidth-xwidth2)*(xwidth-xwidth2)+4*zdepth*zdepth);
z_component = (xwidth-xwidth2)/sqrt(4*zdepth*zdepth+(xwidth-xwidth2)*(xwidth-xwidth2));

this_box_storage.normal_vectors[2] = coords_set(x_component,0,z_component);
this_box_storage.normal_vectors[3] = coords_set(-x_component,0,z_component);

// for sides with x component = 0
y_component = 2*zdepth/sqrt((yheight-yheight2)*(yheight-yheight2)+4*zdepth*zdepth);
z_component = (yheight-yheight2)/sqrt(4*zdepth*zdepth+(yheight-yheight2)*(yheight-yheight2));

this_box_storage.normal_vectors[4] = coords_set(0,y_component,z_component);
this_box_storage.normal_vectors[5] = coords_set(0,-y_component,z_component);

this_box_volume.geometry.visualization_on = visualize;

this_box_volume.geometry.geometry_parameters.p_box_storage = &this_box_storage;

// Assign pointers to functions for intersection with the shape, checking if a point is inside the shape
if (this_box_storage.is_rectangle == 1) {
this_box_volume.geometry.intersect_function = &sample_box_intersect_simple;
this_box_volume.geometry.within_function = &r_within_box_simple;
}
else {
this_box_volume.geometry.intersect_function = &sample_box_intersect_advanced;
this_box_volume.geometry.within_function = &r_within_box_advanced;
}

this_box_volume.geometry.shell_points = &box_shell_points;
this_box_volume.geometry.mcdisplay_function = &mcdisplay_box_function;
this_box_volume.geometry.initialize_from_main_function = &initialize_box_geometry_from_main_component;
this_box_volume.geometry.process_rot_allocated = 0;

this_box_volume.geometry.copy_geometry_parameters = &allocate_box_storage_copy;

rot_copy(this_box_volume.geometry.rotation_matrix,ROT_A_CURRENT_COMP); //check how ROT_R_CURRENT_COMP would work
rot_transpose(ROT_A_CURRENT_COMP,this_box_volume.geometry.transpose_rotation_matrix);

// Initialize loggers
this_box_volume.loggers.num_elements = 0;

// packing the information into the global_geometry_element, which is then included in the global_geometry_list.
sprintf(global_geometry_element.name,NAME_CURRENT_COMP);
global_geometry_element.activation_counter = number_of_activations;
global_geometry_element.component_index = INDEX_CURRENT_COMP;
global_geometry_element.Volume = &this_box_volume; // Would be nicer if this m was a pointer, now we have the (small) data two places
add_element_to_geometry_list(&global_geometry_list,global_geometry_element);
}
#line 307829 "MACS_sample_kidney_box.c"
#undef number_of_activations
#undef mask_setting
#undef mask_string
#undef p_interact
#undef focus_r
#undef focus_xh
#undef focus_xw
#undef focus_ah
#undef focus_aw
#undef target_z
#undef target_y
#undef target_x
#undef target_index
#undef visualize
#undef yheight2
#undef xwidth2
#undef zdepth
#undef yheight
#undef xwidth
#undef priority
#undef material_string
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

  /* Initializations for component channel_16_analyzer_1_array_crystal_array_5. */
  SIG_MESSAGE("channel_16_analyzer_1_array_crystal_array_5 (Init)");
#define mccompcurname  channel_16_analyzer_1_array_crystal_array_5
#define mccompcurtype  Union_box
#define mccompcurindex 743
#define loop_index mccchannel_16_analyzer_1_array_crystal_array_5_loop_index
#define this_box_volume mccchannel_16_analyzer_1_array_crystal_array_5_this_box_volume
#define global_geometry_element mccchannel_16_analyzer_1_array_crystal_array_5_global_geometry_element
#define this_box_storage mccchannel_16_analyzer_1_array_crystal_array_5_this_box_storage
#define material_string mccchannel_16_analyzer_1_array_crystal_array_5_material_string
#define priority mccchannel_16_analyzer_1_array_crystal_array_5_priority
#define xwidth mccchannel_16_analyzer_1_array_crystal_array_5_xwidth
#define yheight mccchannel_16_analyzer_1_array_crystal_array_5_yheight
#define zdepth mccchannel_16_analyzer_1_array_crystal_array_5_zdepth
#define xwidth2 mccchannel_16_analyzer_1_array_crystal_array_5_xwidth2
#define yheight2 mccchannel_16_analyzer_1_array_crystal_array_5_yheight2
#define visualize mccchannel_16_analyzer_1_array_crystal_array_5_visualize
#define target_index mccchannel_16_analyzer_1_array_crystal_array_5_target_index
#define target_x mccchannel_16_analyzer_1_array_crystal_array_5_target_x
#define target_y mccchannel_16_analyzer_1_array_crystal_array_5_target_y
#define target_z mccchannel_16_analyzer_1_array_crystal_array_5_target_z
#define focus_aw mccchannel_16_analyzer_1_array_crystal_array_5_focus_aw
#define focus_ah mccchannel_16_analyzer_1_array_crystal_array_5_focus_ah
#define focus_xw mccchannel_16_analyzer_1_array_crystal_array_5_focus_xw
#define focus_xh mccchannel_16_analyzer_1_array_crystal_array_5_focus_xh
#define focus_r mccchannel_16_analyzer_1_array_crystal_array_5_focus_r
#define p_interact mccchannel_16_analyzer_1_array_crystal_array_5_p_interact
#define mask_string mccchannel_16_analyzer_1_array_crystal_array_5_mask_string
#define mask_setting mccchannel_16_analyzer_1_array_crystal_array_5_mask_setting
#define number_of_activations mccchannel_16_analyzer_1_array_crystal_array_5_number_of_activations
#line 224 "Union_box.comp"
{
// Initializes the focusing system for this volume including input sanitation.
focus_initialize(&this_box_volume.geometry, POS_A_COMP_INDEX(INDEX_CURRENT_COMP+target_index), POS_A_CURRENT_COMP, ROT_A_CURRENT_COMP, target_index, target_x, target_y, target_z, focus_aw, focus_ah, focus_xw, focus_xh, focus_r, NAME_CURRENT_COMP);

// Input sanitation for this geometry
if (xwidth <= 0) {
  printf("\nERROR in Union_box named %s, the xwidth is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (yheight <= 0) {
  printf("\nERROR in Union_box named %s, yheight is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (zdepth <= 0) {
  printf("\nERROR in Union_box named %s, zdepth is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (xwidth2 <= 0 && xwidth2 != -1) {
  printf("\nERROR in Union_box named %s, the xwidth2 is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (yheight2 <= 0 && yheight2 != -1) {
  printf("\nERROR in Union_box named %s, yheight2 is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}

// Use sanitation
if (global_material_list.num_elements == 0) {
  printf("\nERROR: Need to define a material using Union_make_material before using a Union geometry component. \n");
  printf("       %s was defined before first use of Union_make_material.\n",NAME_CURRENT_COMP);
  exit(1);
}

this_box_volume.geometry.is_masked_volume = 0;
this_box_volume.geometry.is_exit_volume = 0;
this_box_volume.geometry.is_mask_volume = 0;
// check if the volume is a mask, if it is the material string is irelevant.
if (mask_string && strlen(mask_string) && strcmp(mask_string, "NULL") && strcmp(mask_string, "0")) {
    // A mask volume is used to limit the extend of other volumes, called the masked volumes. These are specified in the mask_string.
    // In order for a ray to enter a masked volume, it needs to be both in the region covered by that volume AND the mask volume.
    // When more than
    this_box_volume.geometry.mask_mode = 1; // Default is mask mode is ALL
    if (mask_setting && strlen(mask_setting) && strcmp(mask_setting, "NULL") && strcmp(mask_setting, "0")) {
        if (strcmp(mask_setting,"ALL") == 0 || strcmp(mask_setting,"All") == 0) this_box_volume.geometry.mask_mode = 1;
        else if (strcmp(mask_setting,"ANY") == 0 || strcmp(mask_setting,"Any") == 0) this_box_volume.geometry.mask_mode = 2;
        else {
            printf("The mask_mode of component %s is set to %s, but must be either ALL or ANY.\n",NAME_CURRENT_COMP,mask_setting);
            exit(1);
        }
    }
    
    for (loop_index=0;loop_index<global_geometry_list.num_elements;loop_index++) {
        // Add mask list
        if (1 == manual_linking_function(global_geometry_list.elements[loop_index].name,mask_string)) {
            add_element_to_int_list(&this_box_volume.geometry.mask_list,global_geometry_list.elements[loop_index].component_index);
            add_element_to_int_list(&global_geometry_list.elements[loop_index].Volume->geometry.masked_by_list,INDEX_CURRENT_COMP);
            global_geometry_list.elements[loop_index].Volume->geometry.is_masked_volume = 1;
            if (this_box_volume.geometry.mask_mode == 2)
                global_geometry_list.elements[loop_index].Volume->geometry.mask_mode = 2;
            if (this_box_volume.geometry.mask_mode == 1) {
                if (global_geometry_list.elements[loop_index].Volume->geometry.is_masked_volume == 1 && global_geometry_list.elements[loop_index].Volume->geometry.mask_mode != 2)
                    // If more than one mask is added to one volume, the ANY mode overwrites the (default) ALL mode.
                    global_geometry_list.elements[loop_index].Volume->geometry.mask_mode = 1;
            }
            
            found_geometries = 1;
        }
    }
    if (found_geometries == 0) {
        printf("The mask_string in geometry: %s did not find any of the specified volumes in the mask_string %s \n",NAME_CURRENT_COMP,mask_string);
        exit(1);
    }
    this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
    this_box_volume.p_physics->is_vacuum = 0; // Makes this volume a vacuum
    this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
    this_box_volume.p_physics->my_a = 0; // Should not be used.
    sprintf(this_box_volume.p_physics->name,"Mask");
    this_box_volume.geometry.is_mask_volume = 1;
    
    
// Read the material input, or if it lacks, use automatic linking.
} else if (material_string && strlen(material_string) && strcmp(material_string, "NULL") && strcmp(material_string, "0")) {
    // A geometry string was given, use it to determine which material
    if (0 == strcmp(material_string,"vacuum") || 0 == strcmp(material_string,"Vacuum")) {
        // One could have a global physics struct for vacuum instead of creating one for each
        this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
        this_box_volume.p_physics->is_vacuum = 1; // Makes this volume a vacuum
        this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
        this_box_volume.p_physics->my_a = 0; // Should not be used.
        sprintf(this_box_volume.p_physics->name,"Vacuum");
    } else if (0 == strcmp(material_string,"exit") || 0 == strcmp(material_string,"Exit")) {
        // One could have a global physics struct for vacuum instead of creating one for each
        this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
        this_box_volume.p_physics->is_vacuum = 1; // Makes this volume a vacuum
        this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
        this_box_volume.p_physics->my_a = 0; // Should not be used.
        this_box_volume.geometry.is_exit_volume = 1;
        sprintf(this_box_volume.p_physics->name,"Exit");
    } else {
        #ifndef MATERIAL_DETECTOR
            printf("Need to define a material before refering to it in a geometry %s.\n",NAME_CURRENT_COMP);
            exit(1);
        #endif
        for (loop_index=0;loop_index<global_material_list.num_elements;loop_index++) {
            if (0 == strcmp(material_string,global_material_list.elements[loop_index].name)) {
                this_box_volume.p_physics = global_material_list.elements[loop_index].physics;
                break;
            }
            if (loop_index == global_material_list.num_elements-1) {
            printf("\n");
            printf("ERROR: The material string \"%s\" in Union geometry \"%s\" did not match a specified material. \n",material_string,NAME_CURRENT_COMP);
            printf("       The materials available at this point (need to be defined before the geometry): \n");
            for (loop_index=0;loop_index<global_material_list.num_elements;loop_index++)
              printf("         %s\n",global_material_list.elements[loop_index].name);
            printf("\n");
            printf("       It is also possible to use one of the defualt materials avaiable: \n");
            printf("           Vacuum (for a Volume without scattering or absorption)\n");
            printf("           Exit (for a Volume where the ray exits the component if it enters)\n");
            printf("           Mask (for a Volume that masks existing volumes specified in the mask_string\n");
            exit(1);
          }
        }
    }
} else {
    // Automatic linking, simply using the last defined material.
    #ifndef MATERIAL_DETECTOR
        printf("Need to define a material before the geometry to use automatic linking %s.\n",NAME_CURRENT_COMP);
        exit(1);
    #endif
    this_box_volume.p_physics = global_material_list.elements[global_material_list.num_elements-1].physics;
}

sprintf(this_box_volume.name,NAME_CURRENT_COMP);
sprintf(this_box_volume.geometry.shape,"box");
this_box_volume.geometry.priority_value = priority;
this_box_volume.geometry.geometry_p_interact = p_interact;
// Currently the coordinates will be in absolute space.
this_box_volume.geometry.center = POS_A_CURRENT_COMP;

this_box_storage.z_depth = zdepth;
this_box_storage.x_width1 = xwidth;
this_box_storage.y_height1 = yheight;

this_box_storage.is_rectangle = 0;
if (xwidth2 < 0 && yheight2 < 0) this_box_storage.is_rectangle = 1;
if (xwidth == xwidth2 && yheight == yheight2) this_box_storage.is_rectangle = 1;

if (xwidth2 < 0) {
    this_box_storage.x_width2 = xwidth;
    xwidth2 = xwidth;
} else this_box_storage.x_width2 = xwidth2;

if (yheight2 < 0) {
    this_box_storage.y_height2 = yheight;
    yheight2 = yheight;
} else this_box_storage.y_height2 = yheight2;


this_box_storage.normal_vectors[0] = coords_set(0,0,1);
this_box_storage.normal_vectors[1] = coords_set(0,0,1);

// for sides with y component = 0
x_component = 2*zdepth/sqrt((xwidth-xwidth2)*(xwidth-xwidth2)+4*zdepth*zdepth);
z_component = (xwidth-xwidth2)/sqrt(4*zdepth*zdepth+(xwidth-xwidth2)*(xwidth-xwidth2));

this_box_storage.normal_vectors[2] = coords_set(x_component,0,z_component);
this_box_storage.normal_vectors[3] = coords_set(-x_component,0,z_component);

// for sides with x component = 0
y_component = 2*zdepth/sqrt((yheight-yheight2)*(yheight-yheight2)+4*zdepth*zdepth);
z_component = (yheight-yheight2)/sqrt(4*zdepth*zdepth+(yheight-yheight2)*(yheight-yheight2));

this_box_storage.normal_vectors[4] = coords_set(0,y_component,z_component);
this_box_storage.normal_vectors[5] = coords_set(0,-y_component,z_component);

this_box_volume.geometry.visualization_on = visualize;

this_box_volume.geometry.geometry_parameters.p_box_storage = &this_box_storage;

// Assign pointers to functions for intersection with the shape, checking if a point is inside the shape
if (this_box_storage.is_rectangle == 1) {
this_box_volume.geometry.intersect_function = &sample_box_intersect_simple;
this_box_volume.geometry.within_function = &r_within_box_simple;
}
else {
this_box_volume.geometry.intersect_function = &sample_box_intersect_advanced;
this_box_volume.geometry.within_function = &r_within_box_advanced;
}

this_box_volume.geometry.shell_points = &box_shell_points;
this_box_volume.geometry.mcdisplay_function = &mcdisplay_box_function;
this_box_volume.geometry.initialize_from_main_function = &initialize_box_geometry_from_main_component;
this_box_volume.geometry.process_rot_allocated = 0;

this_box_volume.geometry.copy_geometry_parameters = &allocate_box_storage_copy;

rot_copy(this_box_volume.geometry.rotation_matrix,ROT_A_CURRENT_COMP); //check how ROT_R_CURRENT_COMP would work
rot_transpose(ROT_A_CURRENT_COMP,this_box_volume.geometry.transpose_rotation_matrix);

// Initialize loggers
this_box_volume.loggers.num_elements = 0;

// packing the information into the global_geometry_element, which is then included in the global_geometry_list.
sprintf(global_geometry_element.name,NAME_CURRENT_COMP);
global_geometry_element.activation_counter = number_of_activations;
global_geometry_element.component_index = INDEX_CURRENT_COMP;
global_geometry_element.Volume = &this_box_volume; // Would be nicer if this m was a pointer, now we have the (small) data two places
add_element_to_geometry_list(&global_geometry_list,global_geometry_element);
}
#line 308099 "MACS_sample_kidney_box.c"
#undef number_of_activations
#undef mask_setting
#undef mask_string
#undef p_interact
#undef focus_r
#undef focus_xh
#undef focus_xw
#undef focus_ah
#undef focus_aw
#undef target_z
#undef target_y
#undef target_x
#undef target_index
#undef visualize
#undef yheight2
#undef xwidth2
#undef zdepth
#undef yheight
#undef xwidth
#undef priority
#undef material_string
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

  /* Initializations for component channel_16_analyzer_1_array_crystal_array_6. */
  SIG_MESSAGE("channel_16_analyzer_1_array_crystal_array_6 (Init)");
#define mccompcurname  channel_16_analyzer_1_array_crystal_array_6
#define mccompcurtype  Union_box
#define mccompcurindex 744
#define loop_index mccchannel_16_analyzer_1_array_crystal_array_6_loop_index
#define this_box_volume mccchannel_16_analyzer_1_array_crystal_array_6_this_box_volume
#define global_geometry_element mccchannel_16_analyzer_1_array_crystal_array_6_global_geometry_element
#define this_box_storage mccchannel_16_analyzer_1_array_crystal_array_6_this_box_storage
#define material_string mccchannel_16_analyzer_1_array_crystal_array_6_material_string
#define priority mccchannel_16_analyzer_1_array_crystal_array_6_priority
#define xwidth mccchannel_16_analyzer_1_array_crystal_array_6_xwidth
#define yheight mccchannel_16_analyzer_1_array_crystal_array_6_yheight
#define zdepth mccchannel_16_analyzer_1_array_crystal_array_6_zdepth
#define xwidth2 mccchannel_16_analyzer_1_array_crystal_array_6_xwidth2
#define yheight2 mccchannel_16_analyzer_1_array_crystal_array_6_yheight2
#define visualize mccchannel_16_analyzer_1_array_crystal_array_6_visualize
#define target_index mccchannel_16_analyzer_1_array_crystal_array_6_target_index
#define target_x mccchannel_16_analyzer_1_array_crystal_array_6_target_x
#define target_y mccchannel_16_analyzer_1_array_crystal_array_6_target_y
#define target_z mccchannel_16_analyzer_1_array_crystal_array_6_target_z
#define focus_aw mccchannel_16_analyzer_1_array_crystal_array_6_focus_aw
#define focus_ah mccchannel_16_analyzer_1_array_crystal_array_6_focus_ah
#define focus_xw mccchannel_16_analyzer_1_array_crystal_array_6_focus_xw
#define focus_xh mccchannel_16_analyzer_1_array_crystal_array_6_focus_xh
#define focus_r mccchannel_16_analyzer_1_array_crystal_array_6_focus_r
#define p_interact mccchannel_16_analyzer_1_array_crystal_array_6_p_interact
#define mask_string mccchannel_16_analyzer_1_array_crystal_array_6_mask_string
#define mask_setting mccchannel_16_analyzer_1_array_crystal_array_6_mask_setting
#define number_of_activations mccchannel_16_analyzer_1_array_crystal_array_6_number_of_activations
#line 224 "Union_box.comp"
{
// Initializes the focusing system for this volume including input sanitation.
focus_initialize(&this_box_volume.geometry, POS_A_COMP_INDEX(INDEX_CURRENT_COMP+target_index), POS_A_CURRENT_COMP, ROT_A_CURRENT_COMP, target_index, target_x, target_y, target_z, focus_aw, focus_ah, focus_xw, focus_xh, focus_r, NAME_CURRENT_COMP);

// Input sanitation for this geometry
if (xwidth <= 0) {
  printf("\nERROR in Union_box named %s, the xwidth is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (yheight <= 0) {
  printf("\nERROR in Union_box named %s, yheight is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (zdepth <= 0) {
  printf("\nERROR in Union_box named %s, zdepth is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (xwidth2 <= 0 && xwidth2 != -1) {
  printf("\nERROR in Union_box named %s, the xwidth2 is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (yheight2 <= 0 && yheight2 != -1) {
  printf("\nERROR in Union_box named %s, yheight2 is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}

// Use sanitation
if (global_material_list.num_elements == 0) {
  printf("\nERROR: Need to define a material using Union_make_material before using a Union geometry component. \n");
  printf("       %s was defined before first use of Union_make_material.\n",NAME_CURRENT_COMP);
  exit(1);
}

this_box_volume.geometry.is_masked_volume = 0;
this_box_volume.geometry.is_exit_volume = 0;
this_box_volume.geometry.is_mask_volume = 0;
// check if the volume is a mask, if it is the material string is irelevant.
if (mask_string && strlen(mask_string) && strcmp(mask_string, "NULL") && strcmp(mask_string, "0")) {
    // A mask volume is used to limit the extend of other volumes, called the masked volumes. These are specified in the mask_string.
    // In order for a ray to enter a masked volume, it needs to be both in the region covered by that volume AND the mask volume.
    // When more than
    this_box_volume.geometry.mask_mode = 1; // Default is mask mode is ALL
    if (mask_setting && strlen(mask_setting) && strcmp(mask_setting, "NULL") && strcmp(mask_setting, "0")) {
        if (strcmp(mask_setting,"ALL") == 0 || strcmp(mask_setting,"All") == 0) this_box_volume.geometry.mask_mode = 1;
        else if (strcmp(mask_setting,"ANY") == 0 || strcmp(mask_setting,"Any") == 0) this_box_volume.geometry.mask_mode = 2;
        else {
            printf("The mask_mode of component %s is set to %s, but must be either ALL or ANY.\n",NAME_CURRENT_COMP,mask_setting);
            exit(1);
        }
    }
    
    for (loop_index=0;loop_index<global_geometry_list.num_elements;loop_index++) {
        // Add mask list
        if (1 == manual_linking_function(global_geometry_list.elements[loop_index].name,mask_string)) {
            add_element_to_int_list(&this_box_volume.geometry.mask_list,global_geometry_list.elements[loop_index].component_index);
            add_element_to_int_list(&global_geometry_list.elements[loop_index].Volume->geometry.masked_by_list,INDEX_CURRENT_COMP);
            global_geometry_list.elements[loop_index].Volume->geometry.is_masked_volume = 1;
            if (this_box_volume.geometry.mask_mode == 2)
                global_geometry_list.elements[loop_index].Volume->geometry.mask_mode = 2;
            if (this_box_volume.geometry.mask_mode == 1) {
                if (global_geometry_list.elements[loop_index].Volume->geometry.is_masked_volume == 1 && global_geometry_list.elements[loop_index].Volume->geometry.mask_mode != 2)
                    // If more than one mask is added to one volume, the ANY mode overwrites the (default) ALL mode.
                    global_geometry_list.elements[loop_index].Volume->geometry.mask_mode = 1;
            }
            
            found_geometries = 1;
        }
    }
    if (found_geometries == 0) {
        printf("The mask_string in geometry: %s did not find any of the specified volumes in the mask_string %s \n",NAME_CURRENT_COMP,mask_string);
        exit(1);
    }
    this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
    this_box_volume.p_physics->is_vacuum = 0; // Makes this volume a vacuum
    this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
    this_box_volume.p_physics->my_a = 0; // Should not be used.
    sprintf(this_box_volume.p_physics->name,"Mask");
    this_box_volume.geometry.is_mask_volume = 1;
    
    
// Read the material input, or if it lacks, use automatic linking.
} else if (material_string && strlen(material_string) && strcmp(material_string, "NULL") && strcmp(material_string, "0")) {
    // A geometry string was given, use it to determine which material
    if (0 == strcmp(material_string,"vacuum") || 0 == strcmp(material_string,"Vacuum")) {
        // One could have a global physics struct for vacuum instead of creating one for each
        this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
        this_box_volume.p_physics->is_vacuum = 1; // Makes this volume a vacuum
        this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
        this_box_volume.p_physics->my_a = 0; // Should not be used.
        sprintf(this_box_volume.p_physics->name,"Vacuum");
    } else if (0 == strcmp(material_string,"exit") || 0 == strcmp(material_string,"Exit")) {
        // One could have a global physics struct for vacuum instead of creating one for each
        this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
        this_box_volume.p_physics->is_vacuum = 1; // Makes this volume a vacuum
        this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
        this_box_volume.p_physics->my_a = 0; // Should not be used.
        this_box_volume.geometry.is_exit_volume = 1;
        sprintf(this_box_volume.p_physics->name,"Exit");
    } else {
        #ifndef MATERIAL_DETECTOR
            printf("Need to define a material before refering to it in a geometry %s.\n",NAME_CURRENT_COMP);
            exit(1);
        #endif
        for (loop_index=0;loop_index<global_material_list.num_elements;loop_index++) {
            if (0 == strcmp(material_string,global_material_list.elements[loop_index].name)) {
                this_box_volume.p_physics = global_material_list.elements[loop_index].physics;
                break;
            }
            if (loop_index == global_material_list.num_elements-1) {
            printf("\n");
            printf("ERROR: The material string \"%s\" in Union geometry \"%s\" did not match a specified material. \n",material_string,NAME_CURRENT_COMP);
            printf("       The materials available at this point (need to be defined before the geometry): \n");
            for (loop_index=0;loop_index<global_material_list.num_elements;loop_index++)
              printf("         %s\n",global_material_list.elements[loop_index].name);
            printf("\n");
            printf("       It is also possible to use one of the defualt materials avaiable: \n");
            printf("           Vacuum (for a Volume without scattering or absorption)\n");
            printf("           Exit (for a Volume where the ray exits the component if it enters)\n");
            printf("           Mask (for a Volume that masks existing volumes specified in the mask_string\n");
            exit(1);
          }
        }
    }
} else {
    // Automatic linking, simply using the last defined material.
    #ifndef MATERIAL_DETECTOR
        printf("Need to define a material before the geometry to use automatic linking %s.\n",NAME_CURRENT_COMP);
        exit(1);
    #endif
    this_box_volume.p_physics = global_material_list.elements[global_material_list.num_elements-1].physics;
}

sprintf(this_box_volume.name,NAME_CURRENT_COMP);
sprintf(this_box_volume.geometry.shape,"box");
this_box_volume.geometry.priority_value = priority;
this_box_volume.geometry.geometry_p_interact = p_interact;
// Currently the coordinates will be in absolute space.
this_box_volume.geometry.center = POS_A_CURRENT_COMP;

this_box_storage.z_depth = zdepth;
this_box_storage.x_width1 = xwidth;
this_box_storage.y_height1 = yheight;

this_box_storage.is_rectangle = 0;
if (xwidth2 < 0 && yheight2 < 0) this_box_storage.is_rectangle = 1;
if (xwidth == xwidth2 && yheight == yheight2) this_box_storage.is_rectangle = 1;

if (xwidth2 < 0) {
    this_box_storage.x_width2 = xwidth;
    xwidth2 = xwidth;
} else this_box_storage.x_width2 = xwidth2;

if (yheight2 < 0) {
    this_box_storage.y_height2 = yheight;
    yheight2 = yheight;
} else this_box_storage.y_height2 = yheight2;


this_box_storage.normal_vectors[0] = coords_set(0,0,1);
this_box_storage.normal_vectors[1] = coords_set(0,0,1);

// for sides with y component = 0
x_component = 2*zdepth/sqrt((xwidth-xwidth2)*(xwidth-xwidth2)+4*zdepth*zdepth);
z_component = (xwidth-xwidth2)/sqrt(4*zdepth*zdepth+(xwidth-xwidth2)*(xwidth-xwidth2));

this_box_storage.normal_vectors[2] = coords_set(x_component,0,z_component);
this_box_storage.normal_vectors[3] = coords_set(-x_component,0,z_component);

// for sides with x component = 0
y_component = 2*zdepth/sqrt((yheight-yheight2)*(yheight-yheight2)+4*zdepth*zdepth);
z_component = (yheight-yheight2)/sqrt(4*zdepth*zdepth+(yheight-yheight2)*(yheight-yheight2));

this_box_storage.normal_vectors[4] = coords_set(0,y_component,z_component);
this_box_storage.normal_vectors[5] = coords_set(0,-y_component,z_component);

this_box_volume.geometry.visualization_on = visualize;

this_box_volume.geometry.geometry_parameters.p_box_storage = &this_box_storage;

// Assign pointers to functions for intersection with the shape, checking if a point is inside the shape
if (this_box_storage.is_rectangle == 1) {
this_box_volume.geometry.intersect_function = &sample_box_intersect_simple;
this_box_volume.geometry.within_function = &r_within_box_simple;
}
else {
this_box_volume.geometry.intersect_function = &sample_box_intersect_advanced;
this_box_volume.geometry.within_function = &r_within_box_advanced;
}

this_box_volume.geometry.shell_points = &box_shell_points;
this_box_volume.geometry.mcdisplay_function = &mcdisplay_box_function;
this_box_volume.geometry.initialize_from_main_function = &initialize_box_geometry_from_main_component;
this_box_volume.geometry.process_rot_allocated = 0;

this_box_volume.geometry.copy_geometry_parameters = &allocate_box_storage_copy;

rot_copy(this_box_volume.geometry.rotation_matrix,ROT_A_CURRENT_COMP); //check how ROT_R_CURRENT_COMP would work
rot_transpose(ROT_A_CURRENT_COMP,this_box_volume.geometry.transpose_rotation_matrix);

// Initialize loggers
this_box_volume.loggers.num_elements = 0;

// packing the information into the global_geometry_element, which is then included in the global_geometry_list.
sprintf(global_geometry_element.name,NAME_CURRENT_COMP);
global_geometry_element.activation_counter = number_of_activations;
global_geometry_element.component_index = INDEX_CURRENT_COMP;
global_geometry_element.Volume = &this_box_volume; // Would be nicer if this m was a pointer, now we have the (small) data two places
add_element_to_geometry_list(&global_geometry_list,global_geometry_element);
}
#line 308369 "MACS_sample_kidney_box.c"
#undef number_of_activations
#undef mask_setting
#undef mask_string
#undef p_interact
#undef focus_r
#undef focus_xh
#undef focus_xw
#undef focus_ah
#undef focus_aw
#undef target_z
#undef target_y
#undef target_x
#undef target_index
#undef visualize
#undef yheight2
#undef xwidth2
#undef zdepth
#undef yheight
#undef xwidth
#undef priority
#undef material_string
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

  /* Initializations for component channel_16_analyzer_1_array_crystal_array_7. */
  SIG_MESSAGE("channel_16_analyzer_1_array_crystal_array_7 (Init)");
#define mccompcurname  channel_16_analyzer_1_array_crystal_array_7
#define mccompcurtype  Union_box
#define mccompcurindex 745
#define loop_index mccchannel_16_analyzer_1_array_crystal_array_7_loop_index
#define this_box_volume mccchannel_16_analyzer_1_array_crystal_array_7_this_box_volume
#define global_geometry_element mccchannel_16_analyzer_1_array_crystal_array_7_global_geometry_element
#define this_box_storage mccchannel_16_analyzer_1_array_crystal_array_7_this_box_storage
#define material_string mccchannel_16_analyzer_1_array_crystal_array_7_material_string
#define priority mccchannel_16_analyzer_1_array_crystal_array_7_priority
#define xwidth mccchannel_16_analyzer_1_array_crystal_array_7_xwidth
#define yheight mccchannel_16_analyzer_1_array_crystal_array_7_yheight
#define zdepth mccchannel_16_analyzer_1_array_crystal_array_7_zdepth
#define xwidth2 mccchannel_16_analyzer_1_array_crystal_array_7_xwidth2
#define yheight2 mccchannel_16_analyzer_1_array_crystal_array_7_yheight2
#define visualize mccchannel_16_analyzer_1_array_crystal_array_7_visualize
#define target_index mccchannel_16_analyzer_1_array_crystal_array_7_target_index
#define target_x mccchannel_16_analyzer_1_array_crystal_array_7_target_x
#define target_y mccchannel_16_analyzer_1_array_crystal_array_7_target_y
#define target_z mccchannel_16_analyzer_1_array_crystal_array_7_target_z
#define focus_aw mccchannel_16_analyzer_1_array_crystal_array_7_focus_aw
#define focus_ah mccchannel_16_analyzer_1_array_crystal_array_7_focus_ah
#define focus_xw mccchannel_16_analyzer_1_array_crystal_array_7_focus_xw
#define focus_xh mccchannel_16_analyzer_1_array_crystal_array_7_focus_xh
#define focus_r mccchannel_16_analyzer_1_array_crystal_array_7_focus_r
#define p_interact mccchannel_16_analyzer_1_array_crystal_array_7_p_interact
#define mask_string mccchannel_16_analyzer_1_array_crystal_array_7_mask_string
#define mask_setting mccchannel_16_analyzer_1_array_crystal_array_7_mask_setting
#define number_of_activations mccchannel_16_analyzer_1_array_crystal_array_7_number_of_activations
#line 224 "Union_box.comp"
{
// Initializes the focusing system for this volume including input sanitation.
focus_initialize(&this_box_volume.geometry, POS_A_COMP_INDEX(INDEX_CURRENT_COMP+target_index), POS_A_CURRENT_COMP, ROT_A_CURRENT_COMP, target_index, target_x, target_y, target_z, focus_aw, focus_ah, focus_xw, focus_xh, focus_r, NAME_CURRENT_COMP);

// Input sanitation for this geometry
if (xwidth <= 0) {
  printf("\nERROR in Union_box named %s, the xwidth is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (yheight <= 0) {
  printf("\nERROR in Union_box named %s, yheight is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (zdepth <= 0) {
  printf("\nERROR in Union_box named %s, zdepth is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (xwidth2 <= 0 && xwidth2 != -1) {
  printf("\nERROR in Union_box named %s, the xwidth2 is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (yheight2 <= 0 && yheight2 != -1) {
  printf("\nERROR in Union_box named %s, yheight2 is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}

// Use sanitation
if (global_material_list.num_elements == 0) {
  printf("\nERROR: Need to define a material using Union_make_material before using a Union geometry component. \n");
  printf("       %s was defined before first use of Union_make_material.\n",NAME_CURRENT_COMP);
  exit(1);
}

this_box_volume.geometry.is_masked_volume = 0;
this_box_volume.geometry.is_exit_volume = 0;
this_box_volume.geometry.is_mask_volume = 0;
// check if the volume is a mask, if it is the material string is irelevant.
if (mask_string && strlen(mask_string) && strcmp(mask_string, "NULL") && strcmp(mask_string, "0")) {
    // A mask volume is used to limit the extend of other volumes, called the masked volumes. These are specified in the mask_string.
    // In order for a ray to enter a masked volume, it needs to be both in the region covered by that volume AND the mask volume.
    // When more than
    this_box_volume.geometry.mask_mode = 1; // Default is mask mode is ALL
    if (mask_setting && strlen(mask_setting) && strcmp(mask_setting, "NULL") && strcmp(mask_setting, "0")) {
        if (strcmp(mask_setting,"ALL") == 0 || strcmp(mask_setting,"All") == 0) this_box_volume.geometry.mask_mode = 1;
        else if (strcmp(mask_setting,"ANY") == 0 || strcmp(mask_setting,"Any") == 0) this_box_volume.geometry.mask_mode = 2;
        else {
            printf("The mask_mode of component %s is set to %s, but must be either ALL or ANY.\n",NAME_CURRENT_COMP,mask_setting);
            exit(1);
        }
    }
    
    for (loop_index=0;loop_index<global_geometry_list.num_elements;loop_index++) {
        // Add mask list
        if (1 == manual_linking_function(global_geometry_list.elements[loop_index].name,mask_string)) {
            add_element_to_int_list(&this_box_volume.geometry.mask_list,global_geometry_list.elements[loop_index].component_index);
            add_element_to_int_list(&global_geometry_list.elements[loop_index].Volume->geometry.masked_by_list,INDEX_CURRENT_COMP);
            global_geometry_list.elements[loop_index].Volume->geometry.is_masked_volume = 1;
            if (this_box_volume.geometry.mask_mode == 2)
                global_geometry_list.elements[loop_index].Volume->geometry.mask_mode = 2;
            if (this_box_volume.geometry.mask_mode == 1) {
                if (global_geometry_list.elements[loop_index].Volume->geometry.is_masked_volume == 1 && global_geometry_list.elements[loop_index].Volume->geometry.mask_mode != 2)
                    // If more than one mask is added to one volume, the ANY mode overwrites the (default) ALL mode.
                    global_geometry_list.elements[loop_index].Volume->geometry.mask_mode = 1;
            }
            
            found_geometries = 1;
        }
    }
    if (found_geometries == 0) {
        printf("The mask_string in geometry: %s did not find any of the specified volumes in the mask_string %s \n",NAME_CURRENT_COMP,mask_string);
        exit(1);
    }
    this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
    this_box_volume.p_physics->is_vacuum = 0; // Makes this volume a vacuum
    this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
    this_box_volume.p_physics->my_a = 0; // Should not be used.
    sprintf(this_box_volume.p_physics->name,"Mask");
    this_box_volume.geometry.is_mask_volume = 1;
    
    
// Read the material input, or if it lacks, use automatic linking.
} else if (material_string && strlen(material_string) && strcmp(material_string, "NULL") && strcmp(material_string, "0")) {
    // A geometry string was given, use it to determine which material
    if (0 == strcmp(material_string,"vacuum") || 0 == strcmp(material_string,"Vacuum")) {
        // One could have a global physics struct for vacuum instead of creating one for each
        this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
        this_box_volume.p_physics->is_vacuum = 1; // Makes this volume a vacuum
        this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
        this_box_volume.p_physics->my_a = 0; // Should not be used.
        sprintf(this_box_volume.p_physics->name,"Vacuum");
    } else if (0 == strcmp(material_string,"exit") || 0 == strcmp(material_string,"Exit")) {
        // One could have a global physics struct for vacuum instead of creating one for each
        this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
        this_box_volume.p_physics->is_vacuum = 1; // Makes this volume a vacuum
        this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
        this_box_volume.p_physics->my_a = 0; // Should not be used.
        this_box_volume.geometry.is_exit_volume = 1;
        sprintf(this_box_volume.p_physics->name,"Exit");
    } else {
        #ifndef MATERIAL_DETECTOR
            printf("Need to define a material before refering to it in a geometry %s.\n",NAME_CURRENT_COMP);
            exit(1);
        #endif
        for (loop_index=0;loop_index<global_material_list.num_elements;loop_index++) {
            if (0 == strcmp(material_string,global_material_list.elements[loop_index].name)) {
                this_box_volume.p_physics = global_material_list.elements[loop_index].physics;
                break;
            }
            if (loop_index == global_material_list.num_elements-1) {
            printf("\n");
            printf("ERROR: The material string \"%s\" in Union geometry \"%s\" did not match a specified material. \n",material_string,NAME_CURRENT_COMP);
            printf("       The materials available at this point (need to be defined before the geometry): \n");
            for (loop_index=0;loop_index<global_material_list.num_elements;loop_index++)
              printf("         %s\n",global_material_list.elements[loop_index].name);
            printf("\n");
            printf("       It is also possible to use one of the defualt materials avaiable: \n");
            printf("           Vacuum (for a Volume without scattering or absorption)\n");
            printf("           Exit (for a Volume where the ray exits the component if it enters)\n");
            printf("           Mask (for a Volume that masks existing volumes specified in the mask_string\n");
            exit(1);
          }
        }
    }
} else {
    // Automatic linking, simply using the last defined material.
    #ifndef MATERIAL_DETECTOR
        printf("Need to define a material before the geometry to use automatic linking %s.\n",NAME_CURRENT_COMP);
        exit(1);
    #endif
    this_box_volume.p_physics = global_material_list.elements[global_material_list.num_elements-1].physics;
}

sprintf(this_box_volume.name,NAME_CURRENT_COMP);
sprintf(this_box_volume.geometry.shape,"box");
this_box_volume.geometry.priority_value = priority;
this_box_volume.geometry.geometry_p_interact = p_interact;
// Currently the coordinates will be in absolute space.
this_box_volume.geometry.center = POS_A_CURRENT_COMP;

this_box_storage.z_depth = zdepth;
this_box_storage.x_width1 = xwidth;
this_box_storage.y_height1 = yheight;

this_box_storage.is_rectangle = 0;
if (xwidth2 < 0 && yheight2 < 0) this_box_storage.is_rectangle = 1;
if (xwidth == xwidth2 && yheight == yheight2) this_box_storage.is_rectangle = 1;

if (xwidth2 < 0) {
    this_box_storage.x_width2 = xwidth;
    xwidth2 = xwidth;
} else this_box_storage.x_width2 = xwidth2;

if (yheight2 < 0) {
    this_box_storage.y_height2 = yheight;
    yheight2 = yheight;
} else this_box_storage.y_height2 = yheight2;


this_box_storage.normal_vectors[0] = coords_set(0,0,1);
this_box_storage.normal_vectors[1] = coords_set(0,0,1);

// for sides with y component = 0
x_component = 2*zdepth/sqrt((xwidth-xwidth2)*(xwidth-xwidth2)+4*zdepth*zdepth);
z_component = (xwidth-xwidth2)/sqrt(4*zdepth*zdepth+(xwidth-xwidth2)*(xwidth-xwidth2));

this_box_storage.normal_vectors[2] = coords_set(x_component,0,z_component);
this_box_storage.normal_vectors[3] = coords_set(-x_component,0,z_component);

// for sides with x component = 0
y_component = 2*zdepth/sqrt((yheight-yheight2)*(yheight-yheight2)+4*zdepth*zdepth);
z_component = (yheight-yheight2)/sqrt(4*zdepth*zdepth+(yheight-yheight2)*(yheight-yheight2));

this_box_storage.normal_vectors[4] = coords_set(0,y_component,z_component);
this_box_storage.normal_vectors[5] = coords_set(0,-y_component,z_component);

this_box_volume.geometry.visualization_on = visualize;

this_box_volume.geometry.geometry_parameters.p_box_storage = &this_box_storage;

// Assign pointers to functions for intersection with the shape, checking if a point is inside the shape
if (this_box_storage.is_rectangle == 1) {
this_box_volume.geometry.intersect_function = &sample_box_intersect_simple;
this_box_volume.geometry.within_function = &r_within_box_simple;
}
else {
this_box_volume.geometry.intersect_function = &sample_box_intersect_advanced;
this_box_volume.geometry.within_function = &r_within_box_advanced;
}

this_box_volume.geometry.shell_points = &box_shell_points;
this_box_volume.geometry.mcdisplay_function = &mcdisplay_box_function;
this_box_volume.geometry.initialize_from_main_function = &initialize_box_geometry_from_main_component;
this_box_volume.geometry.process_rot_allocated = 0;

this_box_volume.geometry.copy_geometry_parameters = &allocate_box_storage_copy;

rot_copy(this_box_volume.geometry.rotation_matrix,ROT_A_CURRENT_COMP); //check how ROT_R_CURRENT_COMP would work
rot_transpose(ROT_A_CURRENT_COMP,this_box_volume.geometry.transpose_rotation_matrix);

// Initialize loggers
this_box_volume.loggers.num_elements = 0;

// packing the information into the global_geometry_element, which is then included in the global_geometry_list.
sprintf(global_geometry_element.name,NAME_CURRENT_COMP);
global_geometry_element.activation_counter = number_of_activations;
global_geometry_element.component_index = INDEX_CURRENT_COMP;
global_geometry_element.Volume = &this_box_volume; // Would be nicer if this m was a pointer, now we have the (small) data two places
add_element_to_geometry_list(&global_geometry_list,global_geometry_element);
}
#line 308639 "MACS_sample_kidney_box.c"
#undef number_of_activations
#undef mask_setting
#undef mask_string
#undef p_interact
#undef focus_r
#undef focus_xh
#undef focus_xw
#undef focus_ah
#undef focus_aw
#undef target_z
#undef target_y
#undef target_x
#undef target_index
#undef visualize
#undef yheight2
#undef xwidth2
#undef zdepth
#undef yheight
#undef xwidth
#undef priority
#undef material_string
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

  /* Initializations for component channel_16_analyzer_1_array_crystal_array_8. */
  SIG_MESSAGE("channel_16_analyzer_1_array_crystal_array_8 (Init)");
#define mccompcurname  channel_16_analyzer_1_array_crystal_array_8
#define mccompcurtype  Union_box
#define mccompcurindex 746
#define loop_index mccchannel_16_analyzer_1_array_crystal_array_8_loop_index
#define this_box_volume mccchannel_16_analyzer_1_array_crystal_array_8_this_box_volume
#define global_geometry_element mccchannel_16_analyzer_1_array_crystal_array_8_global_geometry_element
#define this_box_storage mccchannel_16_analyzer_1_array_crystal_array_8_this_box_storage
#define material_string mccchannel_16_analyzer_1_array_crystal_array_8_material_string
#define priority mccchannel_16_analyzer_1_array_crystal_array_8_priority
#define xwidth mccchannel_16_analyzer_1_array_crystal_array_8_xwidth
#define yheight mccchannel_16_analyzer_1_array_crystal_array_8_yheight
#define zdepth mccchannel_16_analyzer_1_array_crystal_array_8_zdepth
#define xwidth2 mccchannel_16_analyzer_1_array_crystal_array_8_xwidth2
#define yheight2 mccchannel_16_analyzer_1_array_crystal_array_8_yheight2
#define visualize mccchannel_16_analyzer_1_array_crystal_array_8_visualize
#define target_index mccchannel_16_analyzer_1_array_crystal_array_8_target_index
#define target_x mccchannel_16_analyzer_1_array_crystal_array_8_target_x
#define target_y mccchannel_16_analyzer_1_array_crystal_array_8_target_y
#define target_z mccchannel_16_analyzer_1_array_crystal_array_8_target_z
#define focus_aw mccchannel_16_analyzer_1_array_crystal_array_8_focus_aw
#define focus_ah mccchannel_16_analyzer_1_array_crystal_array_8_focus_ah
#define focus_xw mccchannel_16_analyzer_1_array_crystal_array_8_focus_xw
#define focus_xh mccchannel_16_analyzer_1_array_crystal_array_8_focus_xh
#define focus_r mccchannel_16_analyzer_1_array_crystal_array_8_focus_r
#define p_interact mccchannel_16_analyzer_1_array_crystal_array_8_p_interact
#define mask_string mccchannel_16_analyzer_1_array_crystal_array_8_mask_string
#define mask_setting mccchannel_16_analyzer_1_array_crystal_array_8_mask_setting
#define number_of_activations mccchannel_16_analyzer_1_array_crystal_array_8_number_of_activations
#line 224 "Union_box.comp"
{
// Initializes the focusing system for this volume including input sanitation.
focus_initialize(&this_box_volume.geometry, POS_A_COMP_INDEX(INDEX_CURRENT_COMP+target_index), POS_A_CURRENT_COMP, ROT_A_CURRENT_COMP, target_index, target_x, target_y, target_z, focus_aw, focus_ah, focus_xw, focus_xh, focus_r, NAME_CURRENT_COMP);

// Input sanitation for this geometry
if (xwidth <= 0) {
  printf("\nERROR in Union_box named %s, the xwidth is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (yheight <= 0) {
  printf("\nERROR in Union_box named %s, yheight is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (zdepth <= 0) {
  printf("\nERROR in Union_box named %s, zdepth is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (xwidth2 <= 0 && xwidth2 != -1) {
  printf("\nERROR in Union_box named %s, the xwidth2 is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (yheight2 <= 0 && yheight2 != -1) {
  printf("\nERROR in Union_box named %s, yheight2 is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}

// Use sanitation
if (global_material_list.num_elements == 0) {
  printf("\nERROR: Need to define a material using Union_make_material before using a Union geometry component. \n");
  printf("       %s was defined before first use of Union_make_material.\n",NAME_CURRENT_COMP);
  exit(1);
}

this_box_volume.geometry.is_masked_volume = 0;
this_box_volume.geometry.is_exit_volume = 0;
this_box_volume.geometry.is_mask_volume = 0;
// check if the volume is a mask, if it is the material string is irelevant.
if (mask_string && strlen(mask_string) && strcmp(mask_string, "NULL") && strcmp(mask_string, "0")) {
    // A mask volume is used to limit the extend of other volumes, called the masked volumes. These are specified in the mask_string.
    // In order for a ray to enter a masked volume, it needs to be both in the region covered by that volume AND the mask volume.
    // When more than
    this_box_volume.geometry.mask_mode = 1; // Default is mask mode is ALL
    if (mask_setting && strlen(mask_setting) && strcmp(mask_setting, "NULL") && strcmp(mask_setting, "0")) {
        if (strcmp(mask_setting,"ALL") == 0 || strcmp(mask_setting,"All") == 0) this_box_volume.geometry.mask_mode = 1;
        else if (strcmp(mask_setting,"ANY") == 0 || strcmp(mask_setting,"Any") == 0) this_box_volume.geometry.mask_mode = 2;
        else {
            printf("The mask_mode of component %s is set to %s, but must be either ALL or ANY.\n",NAME_CURRENT_COMP,mask_setting);
            exit(1);
        }
    }
    
    for (loop_index=0;loop_index<global_geometry_list.num_elements;loop_index++) {
        // Add mask list
        if (1 == manual_linking_function(global_geometry_list.elements[loop_index].name,mask_string)) {
            add_element_to_int_list(&this_box_volume.geometry.mask_list,global_geometry_list.elements[loop_index].component_index);
            add_element_to_int_list(&global_geometry_list.elements[loop_index].Volume->geometry.masked_by_list,INDEX_CURRENT_COMP);
            global_geometry_list.elements[loop_index].Volume->geometry.is_masked_volume = 1;
            if (this_box_volume.geometry.mask_mode == 2)
                global_geometry_list.elements[loop_index].Volume->geometry.mask_mode = 2;
            if (this_box_volume.geometry.mask_mode == 1) {
                if (global_geometry_list.elements[loop_index].Volume->geometry.is_masked_volume == 1 && global_geometry_list.elements[loop_index].Volume->geometry.mask_mode != 2)
                    // If more than one mask is added to one volume, the ANY mode overwrites the (default) ALL mode.
                    global_geometry_list.elements[loop_index].Volume->geometry.mask_mode = 1;
            }
            
            found_geometries = 1;
        }
    }
    if (found_geometries == 0) {
        printf("The mask_string in geometry: %s did not find any of the specified volumes in the mask_string %s \n",NAME_CURRENT_COMP,mask_string);
        exit(1);
    }
    this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
    this_box_volume.p_physics->is_vacuum = 0; // Makes this volume a vacuum
    this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
    this_box_volume.p_physics->my_a = 0; // Should not be used.
    sprintf(this_box_volume.p_physics->name,"Mask");
    this_box_volume.geometry.is_mask_volume = 1;
    
    
// Read the material input, or if it lacks, use automatic linking.
} else if (material_string && strlen(material_string) && strcmp(material_string, "NULL") && strcmp(material_string, "0")) {
    // A geometry string was given, use it to determine which material
    if (0 == strcmp(material_string,"vacuum") || 0 == strcmp(material_string,"Vacuum")) {
        // One could have a global physics struct for vacuum instead of creating one for each
        this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
        this_box_volume.p_physics->is_vacuum = 1; // Makes this volume a vacuum
        this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
        this_box_volume.p_physics->my_a = 0; // Should not be used.
        sprintf(this_box_volume.p_physics->name,"Vacuum");
    } else if (0 == strcmp(material_string,"exit") || 0 == strcmp(material_string,"Exit")) {
        // One could have a global physics struct for vacuum instead of creating one for each
        this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
        this_box_volume.p_physics->is_vacuum = 1; // Makes this volume a vacuum
        this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
        this_box_volume.p_physics->my_a = 0; // Should not be used.
        this_box_volume.geometry.is_exit_volume = 1;
        sprintf(this_box_volume.p_physics->name,"Exit");
    } else {
        #ifndef MATERIAL_DETECTOR
            printf("Need to define a material before refering to it in a geometry %s.\n",NAME_CURRENT_COMP);
            exit(1);
        #endif
        for (loop_index=0;loop_index<global_material_list.num_elements;loop_index++) {
            if (0 == strcmp(material_string,global_material_list.elements[loop_index].name)) {
                this_box_volume.p_physics = global_material_list.elements[loop_index].physics;
                break;
            }
            if (loop_index == global_material_list.num_elements-1) {
            printf("\n");
            printf("ERROR: The material string \"%s\" in Union geometry \"%s\" did not match a specified material. \n",material_string,NAME_CURRENT_COMP);
            printf("       The materials available at this point (need to be defined before the geometry): \n");
            for (loop_index=0;loop_index<global_material_list.num_elements;loop_index++)
              printf("         %s\n",global_material_list.elements[loop_index].name);
            printf("\n");
            printf("       It is also possible to use one of the defualt materials avaiable: \n");
            printf("           Vacuum (for a Volume without scattering or absorption)\n");
            printf("           Exit (for a Volume where the ray exits the component if it enters)\n");
            printf("           Mask (for a Volume that masks existing volumes specified in the mask_string\n");
            exit(1);
          }
        }
    }
} else {
    // Automatic linking, simply using the last defined material.
    #ifndef MATERIAL_DETECTOR
        printf("Need to define a material before the geometry to use automatic linking %s.\n",NAME_CURRENT_COMP);
        exit(1);
    #endif
    this_box_volume.p_physics = global_material_list.elements[global_material_list.num_elements-1].physics;
}

sprintf(this_box_volume.name,NAME_CURRENT_COMP);
sprintf(this_box_volume.geometry.shape,"box");
this_box_volume.geometry.priority_value = priority;
this_box_volume.geometry.geometry_p_interact = p_interact;
// Currently the coordinates will be in absolute space.
this_box_volume.geometry.center = POS_A_CURRENT_COMP;

this_box_storage.z_depth = zdepth;
this_box_storage.x_width1 = xwidth;
this_box_storage.y_height1 = yheight;

this_box_storage.is_rectangle = 0;
if (xwidth2 < 0 && yheight2 < 0) this_box_storage.is_rectangle = 1;
if (xwidth == xwidth2 && yheight == yheight2) this_box_storage.is_rectangle = 1;

if (xwidth2 < 0) {
    this_box_storage.x_width2 = xwidth;
    xwidth2 = xwidth;
} else this_box_storage.x_width2 = xwidth2;

if (yheight2 < 0) {
    this_box_storage.y_height2 = yheight;
    yheight2 = yheight;
} else this_box_storage.y_height2 = yheight2;


this_box_storage.normal_vectors[0] = coords_set(0,0,1);
this_box_storage.normal_vectors[1] = coords_set(0,0,1);

// for sides with y component = 0
x_component = 2*zdepth/sqrt((xwidth-xwidth2)*(xwidth-xwidth2)+4*zdepth*zdepth);
z_component = (xwidth-xwidth2)/sqrt(4*zdepth*zdepth+(xwidth-xwidth2)*(xwidth-xwidth2));

this_box_storage.normal_vectors[2] = coords_set(x_component,0,z_component);
this_box_storage.normal_vectors[3] = coords_set(-x_component,0,z_component);

// for sides with x component = 0
y_component = 2*zdepth/sqrt((yheight-yheight2)*(yheight-yheight2)+4*zdepth*zdepth);
z_component = (yheight-yheight2)/sqrt(4*zdepth*zdepth+(yheight-yheight2)*(yheight-yheight2));

this_box_storage.normal_vectors[4] = coords_set(0,y_component,z_component);
this_box_storage.normal_vectors[5] = coords_set(0,-y_component,z_component);

this_box_volume.geometry.visualization_on = visualize;

this_box_volume.geometry.geometry_parameters.p_box_storage = &this_box_storage;

// Assign pointers to functions for intersection with the shape, checking if a point is inside the shape
if (this_box_storage.is_rectangle == 1) {
this_box_volume.geometry.intersect_function = &sample_box_intersect_simple;
this_box_volume.geometry.within_function = &r_within_box_simple;
}
else {
this_box_volume.geometry.intersect_function = &sample_box_intersect_advanced;
this_box_volume.geometry.within_function = &r_within_box_advanced;
}

this_box_volume.geometry.shell_points = &box_shell_points;
this_box_volume.geometry.mcdisplay_function = &mcdisplay_box_function;
this_box_volume.geometry.initialize_from_main_function = &initialize_box_geometry_from_main_component;
this_box_volume.geometry.process_rot_allocated = 0;

this_box_volume.geometry.copy_geometry_parameters = &allocate_box_storage_copy;

rot_copy(this_box_volume.geometry.rotation_matrix,ROT_A_CURRENT_COMP); //check how ROT_R_CURRENT_COMP would work
rot_transpose(ROT_A_CURRENT_COMP,this_box_volume.geometry.transpose_rotation_matrix);

// Initialize loggers
this_box_volume.loggers.num_elements = 0;

// packing the information into the global_geometry_element, which is then included in the global_geometry_list.
sprintf(global_geometry_element.name,NAME_CURRENT_COMP);
global_geometry_element.activation_counter = number_of_activations;
global_geometry_element.component_index = INDEX_CURRENT_COMP;
global_geometry_element.Volume = &this_box_volume; // Would be nicer if this m was a pointer, now we have the (small) data two places
add_element_to_geometry_list(&global_geometry_list,global_geometry_element);
}
#line 308909 "MACS_sample_kidney_box.c"
#undef number_of_activations
#undef mask_setting
#undef mask_string
#undef p_interact
#undef focus_r
#undef focus_xh
#undef focus_xw
#undef focus_ah
#undef focus_aw
#undef target_z
#undef target_y
#undef target_x
#undef target_index
#undef visualize
#undef yheight2
#undef xwidth2
#undef zdepth
#undef yheight
#undef xwidth
#undef priority
#undef material_string
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

  /* Initializations for component channel_16_analyzer_2_center. */
  SIG_MESSAGE("channel_16_analyzer_2_center (Init)");

  /* Initializations for component channel_16_analyzer_2_rotated. */
  SIG_MESSAGE("channel_16_analyzer_2_rotated (Init)");

  /* Initializations for component channel_16_analyzer_2_array_crystal_array_0. */
  SIG_MESSAGE("channel_16_analyzer_2_array_crystal_array_0 (Init)");
#define mccompcurname  channel_16_analyzer_2_array_crystal_array_0
#define mccompcurtype  Union_box
#define mccompcurindex 749
#define loop_index mccchannel_16_analyzer_2_array_crystal_array_0_loop_index
#define this_box_volume mccchannel_16_analyzer_2_array_crystal_array_0_this_box_volume
#define global_geometry_element mccchannel_16_analyzer_2_array_crystal_array_0_global_geometry_element
#define this_box_storage mccchannel_16_analyzer_2_array_crystal_array_0_this_box_storage
#define material_string mccchannel_16_analyzer_2_array_crystal_array_0_material_string
#define priority mccchannel_16_analyzer_2_array_crystal_array_0_priority
#define xwidth mccchannel_16_analyzer_2_array_crystal_array_0_xwidth
#define yheight mccchannel_16_analyzer_2_array_crystal_array_0_yheight
#define zdepth mccchannel_16_analyzer_2_array_crystal_array_0_zdepth
#define xwidth2 mccchannel_16_analyzer_2_array_crystal_array_0_xwidth2
#define yheight2 mccchannel_16_analyzer_2_array_crystal_array_0_yheight2
#define visualize mccchannel_16_analyzer_2_array_crystal_array_0_visualize
#define target_index mccchannel_16_analyzer_2_array_crystal_array_0_target_index
#define target_x mccchannel_16_analyzer_2_array_crystal_array_0_target_x
#define target_y mccchannel_16_analyzer_2_array_crystal_array_0_target_y
#define target_z mccchannel_16_analyzer_2_array_crystal_array_0_target_z
#define focus_aw mccchannel_16_analyzer_2_array_crystal_array_0_focus_aw
#define focus_ah mccchannel_16_analyzer_2_array_crystal_array_0_focus_ah
#define focus_xw mccchannel_16_analyzer_2_array_crystal_array_0_focus_xw
#define focus_xh mccchannel_16_analyzer_2_array_crystal_array_0_focus_xh
#define focus_r mccchannel_16_analyzer_2_array_crystal_array_0_focus_r
#define p_interact mccchannel_16_analyzer_2_array_crystal_array_0_p_interact
#define mask_string mccchannel_16_analyzer_2_array_crystal_array_0_mask_string
#define mask_setting mccchannel_16_analyzer_2_array_crystal_array_0_mask_setting
#define number_of_activations mccchannel_16_analyzer_2_array_crystal_array_0_number_of_activations
#line 224 "Union_box.comp"
{
// Initializes the focusing system for this volume including input sanitation.
focus_initialize(&this_box_volume.geometry, POS_A_COMP_INDEX(INDEX_CURRENT_COMP+target_index), POS_A_CURRENT_COMP, ROT_A_CURRENT_COMP, target_index, target_x, target_y, target_z, focus_aw, focus_ah, focus_xw, focus_xh, focus_r, NAME_CURRENT_COMP);

// Input sanitation for this geometry
if (xwidth <= 0) {
  printf("\nERROR in Union_box named %s, the xwidth is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (yheight <= 0) {
  printf("\nERROR in Union_box named %s, yheight is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (zdepth <= 0) {
  printf("\nERROR in Union_box named %s, zdepth is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (xwidth2 <= 0 && xwidth2 != -1) {
  printf("\nERROR in Union_box named %s, the xwidth2 is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (yheight2 <= 0 && yheight2 != -1) {
  printf("\nERROR in Union_box named %s, yheight2 is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}

// Use sanitation
if (global_material_list.num_elements == 0) {
  printf("\nERROR: Need to define a material using Union_make_material before using a Union geometry component. \n");
  printf("       %s was defined before first use of Union_make_material.\n",NAME_CURRENT_COMP);
  exit(1);
}

this_box_volume.geometry.is_masked_volume = 0;
this_box_volume.geometry.is_exit_volume = 0;
this_box_volume.geometry.is_mask_volume = 0;
// check if the volume is a mask, if it is the material string is irelevant.
if (mask_string && strlen(mask_string) && strcmp(mask_string, "NULL") && strcmp(mask_string, "0")) {
    // A mask volume is used to limit the extend of other volumes, called the masked volumes. These are specified in the mask_string.
    // In order for a ray to enter a masked volume, it needs to be both in the region covered by that volume AND the mask volume.
    // When more than
    this_box_volume.geometry.mask_mode = 1; // Default is mask mode is ALL
    if (mask_setting && strlen(mask_setting) && strcmp(mask_setting, "NULL") && strcmp(mask_setting, "0")) {
        if (strcmp(mask_setting,"ALL") == 0 || strcmp(mask_setting,"All") == 0) this_box_volume.geometry.mask_mode = 1;
        else if (strcmp(mask_setting,"ANY") == 0 || strcmp(mask_setting,"Any") == 0) this_box_volume.geometry.mask_mode = 2;
        else {
            printf("The mask_mode of component %s is set to %s, but must be either ALL or ANY.\n",NAME_CURRENT_COMP,mask_setting);
            exit(1);
        }
    }
    
    for (loop_index=0;loop_index<global_geometry_list.num_elements;loop_index++) {
        // Add mask list
        if (1 == manual_linking_function(global_geometry_list.elements[loop_index].name,mask_string)) {
            add_element_to_int_list(&this_box_volume.geometry.mask_list,global_geometry_list.elements[loop_index].component_index);
            add_element_to_int_list(&global_geometry_list.elements[loop_index].Volume->geometry.masked_by_list,INDEX_CURRENT_COMP);
            global_geometry_list.elements[loop_index].Volume->geometry.is_masked_volume = 1;
            if (this_box_volume.geometry.mask_mode == 2)
                global_geometry_list.elements[loop_index].Volume->geometry.mask_mode = 2;
            if (this_box_volume.geometry.mask_mode == 1) {
                if (global_geometry_list.elements[loop_index].Volume->geometry.is_masked_volume == 1 && global_geometry_list.elements[loop_index].Volume->geometry.mask_mode != 2)
                    // If more than one mask is added to one volume, the ANY mode overwrites the (default) ALL mode.
                    global_geometry_list.elements[loop_index].Volume->geometry.mask_mode = 1;
            }
            
            found_geometries = 1;
        }
    }
    if (found_geometries == 0) {
        printf("The mask_string in geometry: %s did not find any of the specified volumes in the mask_string %s \n",NAME_CURRENT_COMP,mask_string);
        exit(1);
    }
    this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
    this_box_volume.p_physics->is_vacuum = 0; // Makes this volume a vacuum
    this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
    this_box_volume.p_physics->my_a = 0; // Should not be used.
    sprintf(this_box_volume.p_physics->name,"Mask");
    this_box_volume.geometry.is_mask_volume = 1;
    
    
// Read the material input, or if it lacks, use automatic linking.
} else if (material_string && strlen(material_string) && strcmp(material_string, "NULL") && strcmp(material_string, "0")) {
    // A geometry string was given, use it to determine which material
    if (0 == strcmp(material_string,"vacuum") || 0 == strcmp(material_string,"Vacuum")) {
        // One could have a global physics struct for vacuum instead of creating one for each
        this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
        this_box_volume.p_physics->is_vacuum = 1; // Makes this volume a vacuum
        this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
        this_box_volume.p_physics->my_a = 0; // Should not be used.
        sprintf(this_box_volume.p_physics->name,"Vacuum");
    } else if (0 == strcmp(material_string,"exit") || 0 == strcmp(material_string,"Exit")) {
        // One could have a global physics struct for vacuum instead of creating one for each
        this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
        this_box_volume.p_physics->is_vacuum = 1; // Makes this volume a vacuum
        this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
        this_box_volume.p_physics->my_a = 0; // Should not be used.
        this_box_volume.geometry.is_exit_volume = 1;
        sprintf(this_box_volume.p_physics->name,"Exit");
    } else {
        #ifndef MATERIAL_DETECTOR
            printf("Need to define a material before refering to it in a geometry %s.\n",NAME_CURRENT_COMP);
            exit(1);
        #endif
        for (loop_index=0;loop_index<global_material_list.num_elements;loop_index++) {
            if (0 == strcmp(material_string,global_material_list.elements[loop_index].name)) {
                this_box_volume.p_physics = global_material_list.elements[loop_index].physics;
                break;
            }
            if (loop_index == global_material_list.num_elements-1) {
            printf("\n");
            printf("ERROR: The material string \"%s\" in Union geometry \"%s\" did not match a specified material. \n",material_string,NAME_CURRENT_COMP);
            printf("       The materials available at this point (need to be defined before the geometry): \n");
            for (loop_index=0;loop_index<global_material_list.num_elements;loop_index++)
              printf("         %s\n",global_material_list.elements[loop_index].name);
            printf("\n");
            printf("       It is also possible to use one of the defualt materials avaiable: \n");
            printf("           Vacuum (for a Volume without scattering or absorption)\n");
            printf("           Exit (for a Volume where the ray exits the component if it enters)\n");
            printf("           Mask (for a Volume that masks existing volumes specified in the mask_string\n");
            exit(1);
          }
        }
    }
} else {
    // Automatic linking, simply using the last defined material.
    #ifndef MATERIAL_DETECTOR
        printf("Need to define a material before the geometry to use automatic linking %s.\n",NAME_CURRENT_COMP);
        exit(1);
    #endif
    this_box_volume.p_physics = global_material_list.elements[global_material_list.num_elements-1].physics;
}

sprintf(this_box_volume.name,NAME_CURRENT_COMP);
sprintf(this_box_volume.geometry.shape,"box");
this_box_volume.geometry.priority_value = priority;
this_box_volume.geometry.geometry_p_interact = p_interact;
// Currently the coordinates will be in absolute space.
this_box_volume.geometry.center = POS_A_CURRENT_COMP;

this_box_storage.z_depth = zdepth;
this_box_storage.x_width1 = xwidth;
this_box_storage.y_height1 = yheight;

this_box_storage.is_rectangle = 0;
if (xwidth2 < 0 && yheight2 < 0) this_box_storage.is_rectangle = 1;
if (xwidth == xwidth2 && yheight == yheight2) this_box_storage.is_rectangle = 1;

if (xwidth2 < 0) {
    this_box_storage.x_width2 = xwidth;
    xwidth2 = xwidth;
} else this_box_storage.x_width2 = xwidth2;

if (yheight2 < 0) {
    this_box_storage.y_height2 = yheight;
    yheight2 = yheight;
} else this_box_storage.y_height2 = yheight2;


this_box_storage.normal_vectors[0] = coords_set(0,0,1);
this_box_storage.normal_vectors[1] = coords_set(0,0,1);

// for sides with y component = 0
x_component = 2*zdepth/sqrt((xwidth-xwidth2)*(xwidth-xwidth2)+4*zdepth*zdepth);
z_component = (xwidth-xwidth2)/sqrt(4*zdepth*zdepth+(xwidth-xwidth2)*(xwidth-xwidth2));

this_box_storage.normal_vectors[2] = coords_set(x_component,0,z_component);
this_box_storage.normal_vectors[3] = coords_set(-x_component,0,z_component);

// for sides with x component = 0
y_component = 2*zdepth/sqrt((yheight-yheight2)*(yheight-yheight2)+4*zdepth*zdepth);
z_component = (yheight-yheight2)/sqrt(4*zdepth*zdepth+(yheight-yheight2)*(yheight-yheight2));

this_box_storage.normal_vectors[4] = coords_set(0,y_component,z_component);
this_box_storage.normal_vectors[5] = coords_set(0,-y_component,z_component);

this_box_volume.geometry.visualization_on = visualize;

this_box_volume.geometry.geometry_parameters.p_box_storage = &this_box_storage;

// Assign pointers to functions for intersection with the shape, checking if a point is inside the shape
if (this_box_storage.is_rectangle == 1) {
this_box_volume.geometry.intersect_function = &sample_box_intersect_simple;
this_box_volume.geometry.within_function = &r_within_box_simple;
}
else {
this_box_volume.geometry.intersect_function = &sample_box_intersect_advanced;
this_box_volume.geometry.within_function = &r_within_box_advanced;
}

this_box_volume.geometry.shell_points = &box_shell_points;
this_box_volume.geometry.mcdisplay_function = &mcdisplay_box_function;
this_box_volume.geometry.initialize_from_main_function = &initialize_box_geometry_from_main_component;
this_box_volume.geometry.process_rot_allocated = 0;

this_box_volume.geometry.copy_geometry_parameters = &allocate_box_storage_copy;

rot_copy(this_box_volume.geometry.rotation_matrix,ROT_A_CURRENT_COMP); //check how ROT_R_CURRENT_COMP would work
rot_transpose(ROT_A_CURRENT_COMP,this_box_volume.geometry.transpose_rotation_matrix);

// Initialize loggers
this_box_volume.loggers.num_elements = 0;

// packing the information into the global_geometry_element, which is then included in the global_geometry_list.
sprintf(global_geometry_element.name,NAME_CURRENT_COMP);
global_geometry_element.activation_counter = number_of_activations;
global_geometry_element.component_index = INDEX_CURRENT_COMP;
global_geometry_element.Volume = &this_box_volume; // Would be nicer if this m was a pointer, now we have the (small) data two places
add_element_to_geometry_list(&global_geometry_list,global_geometry_element);
}
#line 309185 "MACS_sample_kidney_box.c"
#undef number_of_activations
#undef mask_setting
#undef mask_string
#undef p_interact
#undef focus_r
#undef focus_xh
#undef focus_xw
#undef focus_ah
#undef focus_aw
#undef target_z
#undef target_y
#undef target_x
#undef target_index
#undef visualize
#undef yheight2
#undef xwidth2
#undef zdepth
#undef yheight
#undef xwidth
#undef priority
#undef material_string
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

  /* Initializations for component channel_16_analyzer_2_array_crystal_array_1. */
  SIG_MESSAGE("channel_16_analyzer_2_array_crystal_array_1 (Init)");
#define mccompcurname  channel_16_analyzer_2_array_crystal_array_1
#define mccompcurtype  Union_box
#define mccompcurindex 750
#define loop_index mccchannel_16_analyzer_2_array_crystal_array_1_loop_index
#define this_box_volume mccchannel_16_analyzer_2_array_crystal_array_1_this_box_volume
#define global_geometry_element mccchannel_16_analyzer_2_array_crystal_array_1_global_geometry_element
#define this_box_storage mccchannel_16_analyzer_2_array_crystal_array_1_this_box_storage
#define material_string mccchannel_16_analyzer_2_array_crystal_array_1_material_string
#define priority mccchannel_16_analyzer_2_array_crystal_array_1_priority
#define xwidth mccchannel_16_analyzer_2_array_crystal_array_1_xwidth
#define yheight mccchannel_16_analyzer_2_array_crystal_array_1_yheight
#define zdepth mccchannel_16_analyzer_2_array_crystal_array_1_zdepth
#define xwidth2 mccchannel_16_analyzer_2_array_crystal_array_1_xwidth2
#define yheight2 mccchannel_16_analyzer_2_array_crystal_array_1_yheight2
#define visualize mccchannel_16_analyzer_2_array_crystal_array_1_visualize
#define target_index mccchannel_16_analyzer_2_array_crystal_array_1_target_index
#define target_x mccchannel_16_analyzer_2_array_crystal_array_1_target_x
#define target_y mccchannel_16_analyzer_2_array_crystal_array_1_target_y
#define target_z mccchannel_16_analyzer_2_array_crystal_array_1_target_z
#define focus_aw mccchannel_16_analyzer_2_array_crystal_array_1_focus_aw
#define focus_ah mccchannel_16_analyzer_2_array_crystal_array_1_focus_ah
#define focus_xw mccchannel_16_analyzer_2_array_crystal_array_1_focus_xw
#define focus_xh mccchannel_16_analyzer_2_array_crystal_array_1_focus_xh
#define focus_r mccchannel_16_analyzer_2_array_crystal_array_1_focus_r
#define p_interact mccchannel_16_analyzer_2_array_crystal_array_1_p_interact
#define mask_string mccchannel_16_analyzer_2_array_crystal_array_1_mask_string
#define mask_setting mccchannel_16_analyzer_2_array_crystal_array_1_mask_setting
#define number_of_activations mccchannel_16_analyzer_2_array_crystal_array_1_number_of_activations
#line 224 "Union_box.comp"
{
// Initializes the focusing system for this volume including input sanitation.
focus_initialize(&this_box_volume.geometry, POS_A_COMP_INDEX(INDEX_CURRENT_COMP+target_index), POS_A_CURRENT_COMP, ROT_A_CURRENT_COMP, target_index, target_x, target_y, target_z, focus_aw, focus_ah, focus_xw, focus_xh, focus_r, NAME_CURRENT_COMP);

// Input sanitation for this geometry
if (xwidth <= 0) {
  printf("\nERROR in Union_box named %s, the xwidth is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (yheight <= 0) {
  printf("\nERROR in Union_box named %s, yheight is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (zdepth <= 0) {
  printf("\nERROR in Union_box named %s, zdepth is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (xwidth2 <= 0 && xwidth2 != -1) {
  printf("\nERROR in Union_box named %s, the xwidth2 is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (yheight2 <= 0 && yheight2 != -1) {
  printf("\nERROR in Union_box named %s, yheight2 is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}

// Use sanitation
if (global_material_list.num_elements == 0) {
  printf("\nERROR: Need to define a material using Union_make_material before using a Union geometry component. \n");
  printf("       %s was defined before first use of Union_make_material.\n",NAME_CURRENT_COMP);
  exit(1);
}

this_box_volume.geometry.is_masked_volume = 0;
this_box_volume.geometry.is_exit_volume = 0;
this_box_volume.geometry.is_mask_volume = 0;
// check if the volume is a mask, if it is the material string is irelevant.
if (mask_string && strlen(mask_string) && strcmp(mask_string, "NULL") && strcmp(mask_string, "0")) {
    // A mask volume is used to limit the extend of other volumes, called the masked volumes. These are specified in the mask_string.
    // In order for a ray to enter a masked volume, it needs to be both in the region covered by that volume AND the mask volume.
    // When more than
    this_box_volume.geometry.mask_mode = 1; // Default is mask mode is ALL
    if (mask_setting && strlen(mask_setting) && strcmp(mask_setting, "NULL") && strcmp(mask_setting, "0")) {
        if (strcmp(mask_setting,"ALL") == 0 || strcmp(mask_setting,"All") == 0) this_box_volume.geometry.mask_mode = 1;
        else if (strcmp(mask_setting,"ANY") == 0 || strcmp(mask_setting,"Any") == 0) this_box_volume.geometry.mask_mode = 2;
        else {
            printf("The mask_mode of component %s is set to %s, but must be either ALL or ANY.\n",NAME_CURRENT_COMP,mask_setting);
            exit(1);
        }
    }
    
    for (loop_index=0;loop_index<global_geometry_list.num_elements;loop_index++) {
        // Add mask list
        if (1 == manual_linking_function(global_geometry_list.elements[loop_index].name,mask_string)) {
            add_element_to_int_list(&this_box_volume.geometry.mask_list,global_geometry_list.elements[loop_index].component_index);
            add_element_to_int_list(&global_geometry_list.elements[loop_index].Volume->geometry.masked_by_list,INDEX_CURRENT_COMP);
            global_geometry_list.elements[loop_index].Volume->geometry.is_masked_volume = 1;
            if (this_box_volume.geometry.mask_mode == 2)
                global_geometry_list.elements[loop_index].Volume->geometry.mask_mode = 2;
            if (this_box_volume.geometry.mask_mode == 1) {
                if (global_geometry_list.elements[loop_index].Volume->geometry.is_masked_volume == 1 && global_geometry_list.elements[loop_index].Volume->geometry.mask_mode != 2)
                    // If more than one mask is added to one volume, the ANY mode overwrites the (default) ALL mode.
                    global_geometry_list.elements[loop_index].Volume->geometry.mask_mode = 1;
            }
            
            found_geometries = 1;
        }
    }
    if (found_geometries == 0) {
        printf("The mask_string in geometry: %s did not find any of the specified volumes in the mask_string %s \n",NAME_CURRENT_COMP,mask_string);
        exit(1);
    }
    this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
    this_box_volume.p_physics->is_vacuum = 0; // Makes this volume a vacuum
    this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
    this_box_volume.p_physics->my_a = 0; // Should not be used.
    sprintf(this_box_volume.p_physics->name,"Mask");
    this_box_volume.geometry.is_mask_volume = 1;
    
    
// Read the material input, or if it lacks, use automatic linking.
} else if (material_string && strlen(material_string) && strcmp(material_string, "NULL") && strcmp(material_string, "0")) {
    // A geometry string was given, use it to determine which material
    if (0 == strcmp(material_string,"vacuum") || 0 == strcmp(material_string,"Vacuum")) {
        // One could have a global physics struct for vacuum instead of creating one for each
        this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
        this_box_volume.p_physics->is_vacuum = 1; // Makes this volume a vacuum
        this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
        this_box_volume.p_physics->my_a = 0; // Should not be used.
        sprintf(this_box_volume.p_physics->name,"Vacuum");
    } else if (0 == strcmp(material_string,"exit") || 0 == strcmp(material_string,"Exit")) {
        // One could have a global physics struct for vacuum instead of creating one for each
        this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
        this_box_volume.p_physics->is_vacuum = 1; // Makes this volume a vacuum
        this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
        this_box_volume.p_physics->my_a = 0; // Should not be used.
        this_box_volume.geometry.is_exit_volume = 1;
        sprintf(this_box_volume.p_physics->name,"Exit");
    } else {
        #ifndef MATERIAL_DETECTOR
            printf("Need to define a material before refering to it in a geometry %s.\n",NAME_CURRENT_COMP);
            exit(1);
        #endif
        for (loop_index=0;loop_index<global_material_list.num_elements;loop_index++) {
            if (0 == strcmp(material_string,global_material_list.elements[loop_index].name)) {
                this_box_volume.p_physics = global_material_list.elements[loop_index].physics;
                break;
            }
            if (loop_index == global_material_list.num_elements-1) {
            printf("\n");
            printf("ERROR: The material string \"%s\" in Union geometry \"%s\" did not match a specified material. \n",material_string,NAME_CURRENT_COMP);
            printf("       The materials available at this point (need to be defined before the geometry): \n");
            for (loop_index=0;loop_index<global_material_list.num_elements;loop_index++)
              printf("         %s\n",global_material_list.elements[loop_index].name);
            printf("\n");
            printf("       It is also possible to use one of the defualt materials avaiable: \n");
            printf("           Vacuum (for a Volume without scattering or absorption)\n");
            printf("           Exit (for a Volume where the ray exits the component if it enters)\n");
            printf("           Mask (for a Volume that masks existing volumes specified in the mask_string\n");
            exit(1);
          }
        }
    }
} else {
    // Automatic linking, simply using the last defined material.
    #ifndef MATERIAL_DETECTOR
        printf("Need to define a material before the geometry to use automatic linking %s.\n",NAME_CURRENT_COMP);
        exit(1);
    #endif
    this_box_volume.p_physics = global_material_list.elements[global_material_list.num_elements-1].physics;
}

sprintf(this_box_volume.name,NAME_CURRENT_COMP);
sprintf(this_box_volume.geometry.shape,"box");
this_box_volume.geometry.priority_value = priority;
this_box_volume.geometry.geometry_p_interact = p_interact;
// Currently the coordinates will be in absolute space.
this_box_volume.geometry.center = POS_A_CURRENT_COMP;

this_box_storage.z_depth = zdepth;
this_box_storage.x_width1 = xwidth;
this_box_storage.y_height1 = yheight;

this_box_storage.is_rectangle = 0;
if (xwidth2 < 0 && yheight2 < 0) this_box_storage.is_rectangle = 1;
if (xwidth == xwidth2 && yheight == yheight2) this_box_storage.is_rectangle = 1;

if (xwidth2 < 0) {
    this_box_storage.x_width2 = xwidth;
    xwidth2 = xwidth;
} else this_box_storage.x_width2 = xwidth2;

if (yheight2 < 0) {
    this_box_storage.y_height2 = yheight;
    yheight2 = yheight;
} else this_box_storage.y_height2 = yheight2;


this_box_storage.normal_vectors[0] = coords_set(0,0,1);
this_box_storage.normal_vectors[1] = coords_set(0,0,1);

// for sides with y component = 0
x_component = 2*zdepth/sqrt((xwidth-xwidth2)*(xwidth-xwidth2)+4*zdepth*zdepth);
z_component = (xwidth-xwidth2)/sqrt(4*zdepth*zdepth+(xwidth-xwidth2)*(xwidth-xwidth2));

this_box_storage.normal_vectors[2] = coords_set(x_component,0,z_component);
this_box_storage.normal_vectors[3] = coords_set(-x_component,0,z_component);

// for sides with x component = 0
y_component = 2*zdepth/sqrt((yheight-yheight2)*(yheight-yheight2)+4*zdepth*zdepth);
z_component = (yheight-yheight2)/sqrt(4*zdepth*zdepth+(yheight-yheight2)*(yheight-yheight2));

this_box_storage.normal_vectors[4] = coords_set(0,y_component,z_component);
this_box_storage.normal_vectors[5] = coords_set(0,-y_component,z_component);

this_box_volume.geometry.visualization_on = visualize;

this_box_volume.geometry.geometry_parameters.p_box_storage = &this_box_storage;

// Assign pointers to functions for intersection with the shape, checking if a point is inside the shape
if (this_box_storage.is_rectangle == 1) {
this_box_volume.geometry.intersect_function = &sample_box_intersect_simple;
this_box_volume.geometry.within_function = &r_within_box_simple;
}
else {
this_box_volume.geometry.intersect_function = &sample_box_intersect_advanced;
this_box_volume.geometry.within_function = &r_within_box_advanced;
}

this_box_volume.geometry.shell_points = &box_shell_points;
this_box_volume.geometry.mcdisplay_function = &mcdisplay_box_function;
this_box_volume.geometry.initialize_from_main_function = &initialize_box_geometry_from_main_component;
this_box_volume.geometry.process_rot_allocated = 0;

this_box_volume.geometry.copy_geometry_parameters = &allocate_box_storage_copy;

rot_copy(this_box_volume.geometry.rotation_matrix,ROT_A_CURRENT_COMP); //check how ROT_R_CURRENT_COMP would work
rot_transpose(ROT_A_CURRENT_COMP,this_box_volume.geometry.transpose_rotation_matrix);

// Initialize loggers
this_box_volume.loggers.num_elements = 0;

// packing the information into the global_geometry_element, which is then included in the global_geometry_list.
sprintf(global_geometry_element.name,NAME_CURRENT_COMP);
global_geometry_element.activation_counter = number_of_activations;
global_geometry_element.component_index = INDEX_CURRENT_COMP;
global_geometry_element.Volume = &this_box_volume; // Would be nicer if this m was a pointer, now we have the (small) data two places
add_element_to_geometry_list(&global_geometry_list,global_geometry_element);
}
#line 309455 "MACS_sample_kidney_box.c"
#undef number_of_activations
#undef mask_setting
#undef mask_string
#undef p_interact
#undef focus_r
#undef focus_xh
#undef focus_xw
#undef focus_ah
#undef focus_aw
#undef target_z
#undef target_y
#undef target_x
#undef target_index
#undef visualize
#undef yheight2
#undef xwidth2
#undef zdepth
#undef yheight
#undef xwidth
#undef priority
#undef material_string
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

  /* Initializations for component channel_16_analyzer_2_array_crystal_array_2. */
  SIG_MESSAGE("channel_16_analyzer_2_array_crystal_array_2 (Init)");
#define mccompcurname  channel_16_analyzer_2_array_crystal_array_2
#define mccompcurtype  Union_box
#define mccompcurindex 751
#define loop_index mccchannel_16_analyzer_2_array_crystal_array_2_loop_index
#define this_box_volume mccchannel_16_analyzer_2_array_crystal_array_2_this_box_volume
#define global_geometry_element mccchannel_16_analyzer_2_array_crystal_array_2_global_geometry_element
#define this_box_storage mccchannel_16_analyzer_2_array_crystal_array_2_this_box_storage
#define material_string mccchannel_16_analyzer_2_array_crystal_array_2_material_string
#define priority mccchannel_16_analyzer_2_array_crystal_array_2_priority
#define xwidth mccchannel_16_analyzer_2_array_crystal_array_2_xwidth
#define yheight mccchannel_16_analyzer_2_array_crystal_array_2_yheight
#define zdepth mccchannel_16_analyzer_2_array_crystal_array_2_zdepth
#define xwidth2 mccchannel_16_analyzer_2_array_crystal_array_2_xwidth2
#define yheight2 mccchannel_16_analyzer_2_array_crystal_array_2_yheight2
#define visualize mccchannel_16_analyzer_2_array_crystal_array_2_visualize
#define target_index mccchannel_16_analyzer_2_array_crystal_array_2_target_index
#define target_x mccchannel_16_analyzer_2_array_crystal_array_2_target_x
#define target_y mccchannel_16_analyzer_2_array_crystal_array_2_target_y
#define target_z mccchannel_16_analyzer_2_array_crystal_array_2_target_z
#define focus_aw mccchannel_16_analyzer_2_array_crystal_array_2_focus_aw
#define focus_ah mccchannel_16_analyzer_2_array_crystal_array_2_focus_ah
#define focus_xw mccchannel_16_analyzer_2_array_crystal_array_2_focus_xw
#define focus_xh mccchannel_16_analyzer_2_array_crystal_array_2_focus_xh
#define focus_r mccchannel_16_analyzer_2_array_crystal_array_2_focus_r
#define p_interact mccchannel_16_analyzer_2_array_crystal_array_2_p_interact
#define mask_string mccchannel_16_analyzer_2_array_crystal_array_2_mask_string
#define mask_setting mccchannel_16_analyzer_2_array_crystal_array_2_mask_setting
#define number_of_activations mccchannel_16_analyzer_2_array_crystal_array_2_number_of_activations
#line 224 "Union_box.comp"
{
// Initializes the focusing system for this volume including input sanitation.
focus_initialize(&this_box_volume.geometry, POS_A_COMP_INDEX(INDEX_CURRENT_COMP+target_index), POS_A_CURRENT_COMP, ROT_A_CURRENT_COMP, target_index, target_x, target_y, target_z, focus_aw, focus_ah, focus_xw, focus_xh, focus_r, NAME_CURRENT_COMP);

// Input sanitation for this geometry
if (xwidth <= 0) {
  printf("\nERROR in Union_box named %s, the xwidth is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (yheight <= 0) {
  printf("\nERROR in Union_box named %s, yheight is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (zdepth <= 0) {
  printf("\nERROR in Union_box named %s, zdepth is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (xwidth2 <= 0 && xwidth2 != -1) {
  printf("\nERROR in Union_box named %s, the xwidth2 is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (yheight2 <= 0 && yheight2 != -1) {
  printf("\nERROR in Union_box named %s, yheight2 is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}

// Use sanitation
if (global_material_list.num_elements == 0) {
  printf("\nERROR: Need to define a material using Union_make_material before using a Union geometry component. \n");
  printf("       %s was defined before first use of Union_make_material.\n",NAME_CURRENT_COMP);
  exit(1);
}

this_box_volume.geometry.is_masked_volume = 0;
this_box_volume.geometry.is_exit_volume = 0;
this_box_volume.geometry.is_mask_volume = 0;
// check if the volume is a mask, if it is the material string is irelevant.
if (mask_string && strlen(mask_string) && strcmp(mask_string, "NULL") && strcmp(mask_string, "0")) {
    // A mask volume is used to limit the extend of other volumes, called the masked volumes. These are specified in the mask_string.
    // In order for a ray to enter a masked volume, it needs to be both in the region covered by that volume AND the mask volume.
    // When more than
    this_box_volume.geometry.mask_mode = 1; // Default is mask mode is ALL
    if (mask_setting && strlen(mask_setting) && strcmp(mask_setting, "NULL") && strcmp(mask_setting, "0")) {
        if (strcmp(mask_setting,"ALL") == 0 || strcmp(mask_setting,"All") == 0) this_box_volume.geometry.mask_mode = 1;
        else if (strcmp(mask_setting,"ANY") == 0 || strcmp(mask_setting,"Any") == 0) this_box_volume.geometry.mask_mode = 2;
        else {
            printf("The mask_mode of component %s is set to %s, but must be either ALL or ANY.\n",NAME_CURRENT_COMP,mask_setting);
            exit(1);
        }
    }
    
    for (loop_index=0;loop_index<global_geometry_list.num_elements;loop_index++) {
        // Add mask list
        if (1 == manual_linking_function(global_geometry_list.elements[loop_index].name,mask_string)) {
            add_element_to_int_list(&this_box_volume.geometry.mask_list,global_geometry_list.elements[loop_index].component_index);
            add_element_to_int_list(&global_geometry_list.elements[loop_index].Volume->geometry.masked_by_list,INDEX_CURRENT_COMP);
            global_geometry_list.elements[loop_index].Volume->geometry.is_masked_volume = 1;
            if (this_box_volume.geometry.mask_mode == 2)
                global_geometry_list.elements[loop_index].Volume->geometry.mask_mode = 2;
            if (this_box_volume.geometry.mask_mode == 1) {
                if (global_geometry_list.elements[loop_index].Volume->geometry.is_masked_volume == 1 && global_geometry_list.elements[loop_index].Volume->geometry.mask_mode != 2)
                    // If more than one mask is added to one volume, the ANY mode overwrites the (default) ALL mode.
                    global_geometry_list.elements[loop_index].Volume->geometry.mask_mode = 1;
            }
            
            found_geometries = 1;
        }
    }
    if (found_geometries == 0) {
        printf("The mask_string in geometry: %s did not find any of the specified volumes in the mask_string %s \n",NAME_CURRENT_COMP,mask_string);
        exit(1);
    }
    this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
    this_box_volume.p_physics->is_vacuum = 0; // Makes this volume a vacuum
    this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
    this_box_volume.p_physics->my_a = 0; // Should not be used.
    sprintf(this_box_volume.p_physics->name,"Mask");
    this_box_volume.geometry.is_mask_volume = 1;
    
    
// Read the material input, or if it lacks, use automatic linking.
} else if (material_string && strlen(material_string) && strcmp(material_string, "NULL") && strcmp(material_string, "0")) {
    // A geometry string was given, use it to determine which material
    if (0 == strcmp(material_string,"vacuum") || 0 == strcmp(material_string,"Vacuum")) {
        // One could have a global physics struct for vacuum instead of creating one for each
        this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
        this_box_volume.p_physics->is_vacuum = 1; // Makes this volume a vacuum
        this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
        this_box_volume.p_physics->my_a = 0; // Should not be used.
        sprintf(this_box_volume.p_physics->name,"Vacuum");
    } else if (0 == strcmp(material_string,"exit") || 0 == strcmp(material_string,"Exit")) {
        // One could have a global physics struct for vacuum instead of creating one for each
        this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
        this_box_volume.p_physics->is_vacuum = 1; // Makes this volume a vacuum
        this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
        this_box_volume.p_physics->my_a = 0; // Should not be used.
        this_box_volume.geometry.is_exit_volume = 1;
        sprintf(this_box_volume.p_physics->name,"Exit");
    } else {
        #ifndef MATERIAL_DETECTOR
            printf("Need to define a material before refering to it in a geometry %s.\n",NAME_CURRENT_COMP);
            exit(1);
        #endif
        for (loop_index=0;loop_index<global_material_list.num_elements;loop_index++) {
            if (0 == strcmp(material_string,global_material_list.elements[loop_index].name)) {
                this_box_volume.p_physics = global_material_list.elements[loop_index].physics;
                break;
            }
            if (loop_index == global_material_list.num_elements-1) {
            printf("\n");
            printf("ERROR: The material string \"%s\" in Union geometry \"%s\" did not match a specified material. \n",material_string,NAME_CURRENT_COMP);
            printf("       The materials available at this point (need to be defined before the geometry): \n");
            for (loop_index=0;loop_index<global_material_list.num_elements;loop_index++)
              printf("         %s\n",global_material_list.elements[loop_index].name);
            printf("\n");
            printf("       It is also possible to use one of the defualt materials avaiable: \n");
            printf("           Vacuum (for a Volume without scattering or absorption)\n");
            printf("           Exit (for a Volume where the ray exits the component if it enters)\n");
            printf("           Mask (for a Volume that masks existing volumes specified in the mask_string\n");
            exit(1);
          }
        }
    }
} else {
    // Automatic linking, simply using the last defined material.
    #ifndef MATERIAL_DETECTOR
        printf("Need to define a material before the geometry to use automatic linking %s.\n",NAME_CURRENT_COMP);
        exit(1);
    #endif
    this_box_volume.p_physics = global_material_list.elements[global_material_list.num_elements-1].physics;
}

sprintf(this_box_volume.name,NAME_CURRENT_COMP);
sprintf(this_box_volume.geometry.shape,"box");
this_box_volume.geometry.priority_value = priority;
this_box_volume.geometry.geometry_p_interact = p_interact;
// Currently the coordinates will be in absolute space.
this_box_volume.geometry.center = POS_A_CURRENT_COMP;

this_box_storage.z_depth = zdepth;
this_box_storage.x_width1 = xwidth;
this_box_storage.y_height1 = yheight;

this_box_storage.is_rectangle = 0;
if (xwidth2 < 0 && yheight2 < 0) this_box_storage.is_rectangle = 1;
if (xwidth == xwidth2 && yheight == yheight2) this_box_storage.is_rectangle = 1;

if (xwidth2 < 0) {
    this_box_storage.x_width2 = xwidth;
    xwidth2 = xwidth;
} else this_box_storage.x_width2 = xwidth2;

if (yheight2 < 0) {
    this_box_storage.y_height2 = yheight;
    yheight2 = yheight;
} else this_box_storage.y_height2 = yheight2;


this_box_storage.normal_vectors[0] = coords_set(0,0,1);
this_box_storage.normal_vectors[1] = coords_set(0,0,1);

// for sides with y component = 0
x_component = 2*zdepth/sqrt((xwidth-xwidth2)*(xwidth-xwidth2)+4*zdepth*zdepth);
z_component = (xwidth-xwidth2)/sqrt(4*zdepth*zdepth+(xwidth-xwidth2)*(xwidth-xwidth2));

this_box_storage.normal_vectors[2] = coords_set(x_component,0,z_component);
this_box_storage.normal_vectors[3] = coords_set(-x_component,0,z_component);

// for sides with x component = 0
y_component = 2*zdepth/sqrt((yheight-yheight2)*(yheight-yheight2)+4*zdepth*zdepth);
z_component = (yheight-yheight2)/sqrt(4*zdepth*zdepth+(yheight-yheight2)*(yheight-yheight2));

this_box_storage.normal_vectors[4] = coords_set(0,y_component,z_component);
this_box_storage.normal_vectors[5] = coords_set(0,-y_component,z_component);

this_box_volume.geometry.visualization_on = visualize;

this_box_volume.geometry.geometry_parameters.p_box_storage = &this_box_storage;

// Assign pointers to functions for intersection with the shape, checking if a point is inside the shape
if (this_box_storage.is_rectangle == 1) {
this_box_volume.geometry.intersect_function = &sample_box_intersect_simple;
this_box_volume.geometry.within_function = &r_within_box_simple;
}
else {
this_box_volume.geometry.intersect_function = &sample_box_intersect_advanced;
this_box_volume.geometry.within_function = &r_within_box_advanced;
}

this_box_volume.geometry.shell_points = &box_shell_points;
this_box_volume.geometry.mcdisplay_function = &mcdisplay_box_function;
this_box_volume.geometry.initialize_from_main_function = &initialize_box_geometry_from_main_component;
this_box_volume.geometry.process_rot_allocated = 0;

this_box_volume.geometry.copy_geometry_parameters = &allocate_box_storage_copy;

rot_copy(this_box_volume.geometry.rotation_matrix,ROT_A_CURRENT_COMP); //check how ROT_R_CURRENT_COMP would work
rot_transpose(ROT_A_CURRENT_COMP,this_box_volume.geometry.transpose_rotation_matrix);

// Initialize loggers
this_box_volume.loggers.num_elements = 0;

// packing the information into the global_geometry_element, which is then included in the global_geometry_list.
sprintf(global_geometry_element.name,NAME_CURRENT_COMP);
global_geometry_element.activation_counter = number_of_activations;
global_geometry_element.component_index = INDEX_CURRENT_COMP;
global_geometry_element.Volume = &this_box_volume; // Would be nicer if this m was a pointer, now we have the (small) data two places
add_element_to_geometry_list(&global_geometry_list,global_geometry_element);
}
#line 309725 "MACS_sample_kidney_box.c"
#undef number_of_activations
#undef mask_setting
#undef mask_string
#undef p_interact
#undef focus_r
#undef focus_xh
#undef focus_xw
#undef focus_ah
#undef focus_aw
#undef target_z
#undef target_y
#undef target_x
#undef target_index
#undef visualize
#undef yheight2
#undef xwidth2
#undef zdepth
#undef yheight
#undef xwidth
#undef priority
#undef material_string
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

  /* Initializations for component channel_16_analyzer_2_array_crystal_array_3. */
  SIG_MESSAGE("channel_16_analyzer_2_array_crystal_array_3 (Init)");
#define mccompcurname  channel_16_analyzer_2_array_crystal_array_3
#define mccompcurtype  Union_box
#define mccompcurindex 752
#define loop_index mccchannel_16_analyzer_2_array_crystal_array_3_loop_index
#define this_box_volume mccchannel_16_analyzer_2_array_crystal_array_3_this_box_volume
#define global_geometry_element mccchannel_16_analyzer_2_array_crystal_array_3_global_geometry_element
#define this_box_storage mccchannel_16_analyzer_2_array_crystal_array_3_this_box_storage
#define material_string mccchannel_16_analyzer_2_array_crystal_array_3_material_string
#define priority mccchannel_16_analyzer_2_array_crystal_array_3_priority
#define xwidth mccchannel_16_analyzer_2_array_crystal_array_3_xwidth
#define yheight mccchannel_16_analyzer_2_array_crystal_array_3_yheight
#define zdepth mccchannel_16_analyzer_2_array_crystal_array_3_zdepth
#define xwidth2 mccchannel_16_analyzer_2_array_crystal_array_3_xwidth2
#define yheight2 mccchannel_16_analyzer_2_array_crystal_array_3_yheight2
#define visualize mccchannel_16_analyzer_2_array_crystal_array_3_visualize
#define target_index mccchannel_16_analyzer_2_array_crystal_array_3_target_index
#define target_x mccchannel_16_analyzer_2_array_crystal_array_3_target_x
#define target_y mccchannel_16_analyzer_2_array_crystal_array_3_target_y
#define target_z mccchannel_16_analyzer_2_array_crystal_array_3_target_z
#define focus_aw mccchannel_16_analyzer_2_array_crystal_array_3_focus_aw
#define focus_ah mccchannel_16_analyzer_2_array_crystal_array_3_focus_ah
#define focus_xw mccchannel_16_analyzer_2_array_crystal_array_3_focus_xw
#define focus_xh mccchannel_16_analyzer_2_array_crystal_array_3_focus_xh
#define focus_r mccchannel_16_analyzer_2_array_crystal_array_3_focus_r
#define p_interact mccchannel_16_analyzer_2_array_crystal_array_3_p_interact
#define mask_string mccchannel_16_analyzer_2_array_crystal_array_3_mask_string
#define mask_setting mccchannel_16_analyzer_2_array_crystal_array_3_mask_setting
#define number_of_activations mccchannel_16_analyzer_2_array_crystal_array_3_number_of_activations
#line 224 "Union_box.comp"
{
// Initializes the focusing system for this volume including input sanitation.
focus_initialize(&this_box_volume.geometry, POS_A_COMP_INDEX(INDEX_CURRENT_COMP+target_index), POS_A_CURRENT_COMP, ROT_A_CURRENT_COMP, target_index, target_x, target_y, target_z, focus_aw, focus_ah, focus_xw, focus_xh, focus_r, NAME_CURRENT_COMP);

// Input sanitation for this geometry
if (xwidth <= 0) {
  printf("\nERROR in Union_box named %s, the xwidth is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (yheight <= 0) {
  printf("\nERROR in Union_box named %s, yheight is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (zdepth <= 0) {
  printf("\nERROR in Union_box named %s, zdepth is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (xwidth2 <= 0 && xwidth2 != -1) {
  printf("\nERROR in Union_box named %s, the xwidth2 is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (yheight2 <= 0 && yheight2 != -1) {
  printf("\nERROR in Union_box named %s, yheight2 is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}

// Use sanitation
if (global_material_list.num_elements == 0) {
  printf("\nERROR: Need to define a material using Union_make_material before using a Union geometry component. \n");
  printf("       %s was defined before first use of Union_make_material.\n",NAME_CURRENT_COMP);
  exit(1);
}

this_box_volume.geometry.is_masked_volume = 0;
this_box_volume.geometry.is_exit_volume = 0;
this_box_volume.geometry.is_mask_volume = 0;
// check if the volume is a mask, if it is the material string is irelevant.
if (mask_string && strlen(mask_string) && strcmp(mask_string, "NULL") && strcmp(mask_string, "0")) {
    // A mask volume is used to limit the extend of other volumes, called the masked volumes. These are specified in the mask_string.
    // In order for a ray to enter a masked volume, it needs to be both in the region covered by that volume AND the mask volume.
    // When more than
    this_box_volume.geometry.mask_mode = 1; // Default is mask mode is ALL
    if (mask_setting && strlen(mask_setting) && strcmp(mask_setting, "NULL") && strcmp(mask_setting, "0")) {
        if (strcmp(mask_setting,"ALL") == 0 || strcmp(mask_setting,"All") == 0) this_box_volume.geometry.mask_mode = 1;
        else if (strcmp(mask_setting,"ANY") == 0 || strcmp(mask_setting,"Any") == 0) this_box_volume.geometry.mask_mode = 2;
        else {
            printf("The mask_mode of component %s is set to %s, but must be either ALL or ANY.\n",NAME_CURRENT_COMP,mask_setting);
            exit(1);
        }
    }
    
    for (loop_index=0;loop_index<global_geometry_list.num_elements;loop_index++) {
        // Add mask list
        if (1 == manual_linking_function(global_geometry_list.elements[loop_index].name,mask_string)) {
            add_element_to_int_list(&this_box_volume.geometry.mask_list,global_geometry_list.elements[loop_index].component_index);
            add_element_to_int_list(&global_geometry_list.elements[loop_index].Volume->geometry.masked_by_list,INDEX_CURRENT_COMP);
            global_geometry_list.elements[loop_index].Volume->geometry.is_masked_volume = 1;
            if (this_box_volume.geometry.mask_mode == 2)
                global_geometry_list.elements[loop_index].Volume->geometry.mask_mode = 2;
            if (this_box_volume.geometry.mask_mode == 1) {
                if (global_geometry_list.elements[loop_index].Volume->geometry.is_masked_volume == 1 && global_geometry_list.elements[loop_index].Volume->geometry.mask_mode != 2)
                    // If more than one mask is added to one volume, the ANY mode overwrites the (default) ALL mode.
                    global_geometry_list.elements[loop_index].Volume->geometry.mask_mode = 1;
            }
            
            found_geometries = 1;
        }
    }
    if (found_geometries == 0) {
        printf("The mask_string in geometry: %s did not find any of the specified volumes in the mask_string %s \n",NAME_CURRENT_COMP,mask_string);
        exit(1);
    }
    this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
    this_box_volume.p_physics->is_vacuum = 0; // Makes this volume a vacuum
    this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
    this_box_volume.p_physics->my_a = 0; // Should not be used.
    sprintf(this_box_volume.p_physics->name,"Mask");
    this_box_volume.geometry.is_mask_volume = 1;
    
    
// Read the material input, or if it lacks, use automatic linking.
} else if (material_string && strlen(material_string) && strcmp(material_string, "NULL") && strcmp(material_string, "0")) {
    // A geometry string was given, use it to determine which material
    if (0 == strcmp(material_string,"vacuum") || 0 == strcmp(material_string,"Vacuum")) {
        // One could have a global physics struct for vacuum instead of creating one for each
        this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
        this_box_volume.p_physics->is_vacuum = 1; // Makes this volume a vacuum
        this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
        this_box_volume.p_physics->my_a = 0; // Should not be used.
        sprintf(this_box_volume.p_physics->name,"Vacuum");
    } else if (0 == strcmp(material_string,"exit") || 0 == strcmp(material_string,"Exit")) {
        // One could have a global physics struct for vacuum instead of creating one for each
        this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
        this_box_volume.p_physics->is_vacuum = 1; // Makes this volume a vacuum
        this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
        this_box_volume.p_physics->my_a = 0; // Should not be used.
        this_box_volume.geometry.is_exit_volume = 1;
        sprintf(this_box_volume.p_physics->name,"Exit");
    } else {
        #ifndef MATERIAL_DETECTOR
            printf("Need to define a material before refering to it in a geometry %s.\n",NAME_CURRENT_COMP);
            exit(1);
        #endif
        for (loop_index=0;loop_index<global_material_list.num_elements;loop_index++) {
            if (0 == strcmp(material_string,global_material_list.elements[loop_index].name)) {
                this_box_volume.p_physics = global_material_list.elements[loop_index].physics;
                break;
            }
            if (loop_index == global_material_list.num_elements-1) {
            printf("\n");
            printf("ERROR: The material string \"%s\" in Union geometry \"%s\" did not match a specified material. \n",material_string,NAME_CURRENT_COMP);
            printf("       The materials available at this point (need to be defined before the geometry): \n");
            for (loop_index=0;loop_index<global_material_list.num_elements;loop_index++)
              printf("         %s\n",global_material_list.elements[loop_index].name);
            printf("\n");
            printf("       It is also possible to use one of the defualt materials avaiable: \n");
            printf("           Vacuum (for a Volume without scattering or absorption)\n");
            printf("           Exit (for a Volume where the ray exits the component if it enters)\n");
            printf("           Mask (for a Volume that masks existing volumes specified in the mask_string\n");
            exit(1);
          }
        }
    }
} else {
    // Automatic linking, simply using the last defined material.
    #ifndef MATERIAL_DETECTOR
        printf("Need to define a material before the geometry to use automatic linking %s.\n",NAME_CURRENT_COMP);
        exit(1);
    #endif
    this_box_volume.p_physics = global_material_list.elements[global_material_list.num_elements-1].physics;
}

sprintf(this_box_volume.name,NAME_CURRENT_COMP);
sprintf(this_box_volume.geometry.shape,"box");
this_box_volume.geometry.priority_value = priority;
this_box_volume.geometry.geometry_p_interact = p_interact;
// Currently the coordinates will be in absolute space.
this_box_volume.geometry.center = POS_A_CURRENT_COMP;

this_box_storage.z_depth = zdepth;
this_box_storage.x_width1 = xwidth;
this_box_storage.y_height1 = yheight;

this_box_storage.is_rectangle = 0;
if (xwidth2 < 0 && yheight2 < 0) this_box_storage.is_rectangle = 1;
if (xwidth == xwidth2 && yheight == yheight2) this_box_storage.is_rectangle = 1;

if (xwidth2 < 0) {
    this_box_storage.x_width2 = xwidth;
    xwidth2 = xwidth;
} else this_box_storage.x_width2 = xwidth2;

if (yheight2 < 0) {
    this_box_storage.y_height2 = yheight;
    yheight2 = yheight;
} else this_box_storage.y_height2 = yheight2;


this_box_storage.normal_vectors[0] = coords_set(0,0,1);
this_box_storage.normal_vectors[1] = coords_set(0,0,1);

// for sides with y component = 0
x_component = 2*zdepth/sqrt((xwidth-xwidth2)*(xwidth-xwidth2)+4*zdepth*zdepth);
z_component = (xwidth-xwidth2)/sqrt(4*zdepth*zdepth+(xwidth-xwidth2)*(xwidth-xwidth2));

this_box_storage.normal_vectors[2] = coords_set(x_component,0,z_component);
this_box_storage.normal_vectors[3] = coords_set(-x_component,0,z_component);

// for sides with x component = 0
y_component = 2*zdepth/sqrt((yheight-yheight2)*(yheight-yheight2)+4*zdepth*zdepth);
z_component = (yheight-yheight2)/sqrt(4*zdepth*zdepth+(yheight-yheight2)*(yheight-yheight2));

this_box_storage.normal_vectors[4] = coords_set(0,y_component,z_component);
this_box_storage.normal_vectors[5] = coords_set(0,-y_component,z_component);

this_box_volume.geometry.visualization_on = visualize;

this_box_volume.geometry.geometry_parameters.p_box_storage = &this_box_storage;

// Assign pointers to functions for intersection with the shape, checking if a point is inside the shape
if (this_box_storage.is_rectangle == 1) {
this_box_volume.geometry.intersect_function = &sample_box_intersect_simple;
this_box_volume.geometry.within_function = &r_within_box_simple;
}
else {
this_box_volume.geometry.intersect_function = &sample_box_intersect_advanced;
this_box_volume.geometry.within_function = &r_within_box_advanced;
}

this_box_volume.geometry.shell_points = &box_shell_points;
this_box_volume.geometry.mcdisplay_function = &mcdisplay_box_function;
this_box_volume.geometry.initialize_from_main_function = &initialize_box_geometry_from_main_component;
this_box_volume.geometry.process_rot_allocated = 0;

this_box_volume.geometry.copy_geometry_parameters = &allocate_box_storage_copy;

rot_copy(this_box_volume.geometry.rotation_matrix,ROT_A_CURRENT_COMP); //check how ROT_R_CURRENT_COMP would work
rot_transpose(ROT_A_CURRENT_COMP,this_box_volume.geometry.transpose_rotation_matrix);

// Initialize loggers
this_box_volume.loggers.num_elements = 0;

// packing the information into the global_geometry_element, which is then included in the global_geometry_list.
sprintf(global_geometry_element.name,NAME_CURRENT_COMP);
global_geometry_element.activation_counter = number_of_activations;
global_geometry_element.component_index = INDEX_CURRENT_COMP;
global_geometry_element.Volume = &this_box_volume; // Would be nicer if this m was a pointer, now we have the (small) data two places
add_element_to_geometry_list(&global_geometry_list,global_geometry_element);
}
#line 309995 "MACS_sample_kidney_box.c"
#undef number_of_activations
#undef mask_setting
#undef mask_string
#undef p_interact
#undef focus_r
#undef focus_xh
#undef focus_xw
#undef focus_ah
#undef focus_aw
#undef target_z
#undef target_y
#undef target_x
#undef target_index
#undef visualize
#undef yheight2
#undef xwidth2
#undef zdepth
#undef yheight
#undef xwidth
#undef priority
#undef material_string
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

  /* Initializations for component channel_16_analyzer_2_array_crystal_array_4. */
  SIG_MESSAGE("channel_16_analyzer_2_array_crystal_array_4 (Init)");
#define mccompcurname  channel_16_analyzer_2_array_crystal_array_4
#define mccompcurtype  Union_box
#define mccompcurindex 753
#define loop_index mccchannel_16_analyzer_2_array_crystal_array_4_loop_index
#define this_box_volume mccchannel_16_analyzer_2_array_crystal_array_4_this_box_volume
#define global_geometry_element mccchannel_16_analyzer_2_array_crystal_array_4_global_geometry_element
#define this_box_storage mccchannel_16_analyzer_2_array_crystal_array_4_this_box_storage
#define material_string mccchannel_16_analyzer_2_array_crystal_array_4_material_string
#define priority mccchannel_16_analyzer_2_array_crystal_array_4_priority
#define xwidth mccchannel_16_analyzer_2_array_crystal_array_4_xwidth
#define yheight mccchannel_16_analyzer_2_array_crystal_array_4_yheight
#define zdepth mccchannel_16_analyzer_2_array_crystal_array_4_zdepth
#define xwidth2 mccchannel_16_analyzer_2_array_crystal_array_4_xwidth2
#define yheight2 mccchannel_16_analyzer_2_array_crystal_array_4_yheight2
#define visualize mccchannel_16_analyzer_2_array_crystal_array_4_visualize
#define target_index mccchannel_16_analyzer_2_array_crystal_array_4_target_index
#define target_x mccchannel_16_analyzer_2_array_crystal_array_4_target_x
#define target_y mccchannel_16_analyzer_2_array_crystal_array_4_target_y
#define target_z mccchannel_16_analyzer_2_array_crystal_array_4_target_z
#define focus_aw mccchannel_16_analyzer_2_array_crystal_array_4_focus_aw
#define focus_ah mccchannel_16_analyzer_2_array_crystal_array_4_focus_ah
#define focus_xw mccchannel_16_analyzer_2_array_crystal_array_4_focus_xw
#define focus_xh mccchannel_16_analyzer_2_array_crystal_array_4_focus_xh
#define focus_r mccchannel_16_analyzer_2_array_crystal_array_4_focus_r
#define p_interact mccchannel_16_analyzer_2_array_crystal_array_4_p_interact
#define mask_string mccchannel_16_analyzer_2_array_crystal_array_4_mask_string
#define mask_setting mccchannel_16_analyzer_2_array_crystal_array_4_mask_setting
#define number_of_activations mccchannel_16_analyzer_2_array_crystal_array_4_number_of_activations
#line 224 "Union_box.comp"
{
// Initializes the focusing system for this volume including input sanitation.
focus_initialize(&this_box_volume.geometry, POS_A_COMP_INDEX(INDEX_CURRENT_COMP+target_index), POS_A_CURRENT_COMP, ROT_A_CURRENT_COMP, target_index, target_x, target_y, target_z, focus_aw, focus_ah, focus_xw, focus_xh, focus_r, NAME_CURRENT_COMP);

// Input sanitation for this geometry
if (xwidth <= 0) {
  printf("\nERROR in Union_box named %s, the xwidth is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (yheight <= 0) {
  printf("\nERROR in Union_box named %s, yheight is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (zdepth <= 0) {
  printf("\nERROR in Union_box named %s, zdepth is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (xwidth2 <= 0 && xwidth2 != -1) {
  printf("\nERROR in Union_box named %s, the xwidth2 is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (yheight2 <= 0 && yheight2 != -1) {
  printf("\nERROR in Union_box named %s, yheight2 is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}

// Use sanitation
if (global_material_list.num_elements == 0) {
  printf("\nERROR: Need to define a material using Union_make_material before using a Union geometry component. \n");
  printf("       %s was defined before first use of Union_make_material.\n",NAME_CURRENT_COMP);
  exit(1);
}

this_box_volume.geometry.is_masked_volume = 0;
this_box_volume.geometry.is_exit_volume = 0;
this_box_volume.geometry.is_mask_volume = 0;
// check if the volume is a mask, if it is the material string is irelevant.
if (mask_string && strlen(mask_string) && strcmp(mask_string, "NULL") && strcmp(mask_string, "0")) {
    // A mask volume is used to limit the extend of other volumes, called the masked volumes. These are specified in the mask_string.
    // In order for a ray to enter a masked volume, it needs to be both in the region covered by that volume AND the mask volume.
    // When more than
    this_box_volume.geometry.mask_mode = 1; // Default is mask mode is ALL
    if (mask_setting && strlen(mask_setting) && strcmp(mask_setting, "NULL") && strcmp(mask_setting, "0")) {
        if (strcmp(mask_setting,"ALL") == 0 || strcmp(mask_setting,"All") == 0) this_box_volume.geometry.mask_mode = 1;
        else if (strcmp(mask_setting,"ANY") == 0 || strcmp(mask_setting,"Any") == 0) this_box_volume.geometry.mask_mode = 2;
        else {
            printf("The mask_mode of component %s is set to %s, but must be either ALL or ANY.\n",NAME_CURRENT_COMP,mask_setting);
            exit(1);
        }
    }
    
    for (loop_index=0;loop_index<global_geometry_list.num_elements;loop_index++) {
        // Add mask list
        if (1 == manual_linking_function(global_geometry_list.elements[loop_index].name,mask_string)) {
            add_element_to_int_list(&this_box_volume.geometry.mask_list,global_geometry_list.elements[loop_index].component_index);
            add_element_to_int_list(&global_geometry_list.elements[loop_index].Volume->geometry.masked_by_list,INDEX_CURRENT_COMP);
            global_geometry_list.elements[loop_index].Volume->geometry.is_masked_volume = 1;
            if (this_box_volume.geometry.mask_mode == 2)
                global_geometry_list.elements[loop_index].Volume->geometry.mask_mode = 2;
            if (this_box_volume.geometry.mask_mode == 1) {
                if (global_geometry_list.elements[loop_index].Volume->geometry.is_masked_volume == 1 && global_geometry_list.elements[loop_index].Volume->geometry.mask_mode != 2)
                    // If more than one mask is added to one volume, the ANY mode overwrites the (default) ALL mode.
                    global_geometry_list.elements[loop_index].Volume->geometry.mask_mode = 1;
            }
            
            found_geometries = 1;
        }
    }
    if (found_geometries == 0) {
        printf("The mask_string in geometry: %s did not find any of the specified volumes in the mask_string %s \n",NAME_CURRENT_COMP,mask_string);
        exit(1);
    }
    this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
    this_box_volume.p_physics->is_vacuum = 0; // Makes this volume a vacuum
    this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
    this_box_volume.p_physics->my_a = 0; // Should not be used.
    sprintf(this_box_volume.p_physics->name,"Mask");
    this_box_volume.geometry.is_mask_volume = 1;
    
    
// Read the material input, or if it lacks, use automatic linking.
} else if (material_string && strlen(material_string) && strcmp(material_string, "NULL") && strcmp(material_string, "0")) {
    // A geometry string was given, use it to determine which material
    if (0 == strcmp(material_string,"vacuum") || 0 == strcmp(material_string,"Vacuum")) {
        // One could have a global physics struct for vacuum instead of creating one for each
        this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
        this_box_volume.p_physics->is_vacuum = 1; // Makes this volume a vacuum
        this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
        this_box_volume.p_physics->my_a = 0; // Should not be used.
        sprintf(this_box_volume.p_physics->name,"Vacuum");
    } else if (0 == strcmp(material_string,"exit") || 0 == strcmp(material_string,"Exit")) {
        // One could have a global physics struct for vacuum instead of creating one for each
        this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
        this_box_volume.p_physics->is_vacuum = 1; // Makes this volume a vacuum
        this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
        this_box_volume.p_physics->my_a = 0; // Should not be used.
        this_box_volume.geometry.is_exit_volume = 1;
        sprintf(this_box_volume.p_physics->name,"Exit");
    } else {
        #ifndef MATERIAL_DETECTOR
            printf("Need to define a material before refering to it in a geometry %s.\n",NAME_CURRENT_COMP);
            exit(1);
        #endif
        for (loop_index=0;loop_index<global_material_list.num_elements;loop_index++) {
            if (0 == strcmp(material_string,global_material_list.elements[loop_index].name)) {
                this_box_volume.p_physics = global_material_list.elements[loop_index].physics;
                break;
            }
            if (loop_index == global_material_list.num_elements-1) {
            printf("\n");
            printf("ERROR: The material string \"%s\" in Union geometry \"%s\" did not match a specified material. \n",material_string,NAME_CURRENT_COMP);
            printf("       The materials available at this point (need to be defined before the geometry): \n");
            for (loop_index=0;loop_index<global_material_list.num_elements;loop_index++)
              printf("         %s\n",global_material_list.elements[loop_index].name);
            printf("\n");
            printf("       It is also possible to use one of the defualt materials avaiable: \n");
            printf("           Vacuum (for a Volume without scattering or absorption)\n");
            printf("           Exit (for a Volume where the ray exits the component if it enters)\n");
            printf("           Mask (for a Volume that masks existing volumes specified in the mask_string\n");
            exit(1);
          }
        }
    }
} else {
    // Automatic linking, simply using the last defined material.
    #ifndef MATERIAL_DETECTOR
        printf("Need to define a material before the geometry to use automatic linking %s.\n",NAME_CURRENT_COMP);
        exit(1);
    #endif
    this_box_volume.p_physics = global_material_list.elements[global_material_list.num_elements-1].physics;
}

sprintf(this_box_volume.name,NAME_CURRENT_COMP);
sprintf(this_box_volume.geometry.shape,"box");
this_box_volume.geometry.priority_value = priority;
this_box_volume.geometry.geometry_p_interact = p_interact;
// Currently the coordinates will be in absolute space.
this_box_volume.geometry.center = POS_A_CURRENT_COMP;

this_box_storage.z_depth = zdepth;
this_box_storage.x_width1 = xwidth;
this_box_storage.y_height1 = yheight;

this_box_storage.is_rectangle = 0;
if (xwidth2 < 0 && yheight2 < 0) this_box_storage.is_rectangle = 1;
if (xwidth == xwidth2 && yheight == yheight2) this_box_storage.is_rectangle = 1;

if (xwidth2 < 0) {
    this_box_storage.x_width2 = xwidth;
    xwidth2 = xwidth;
} else this_box_storage.x_width2 = xwidth2;

if (yheight2 < 0) {
    this_box_storage.y_height2 = yheight;
    yheight2 = yheight;
} else this_box_storage.y_height2 = yheight2;


this_box_storage.normal_vectors[0] = coords_set(0,0,1);
this_box_storage.normal_vectors[1] = coords_set(0,0,1);

// for sides with y component = 0
x_component = 2*zdepth/sqrt((xwidth-xwidth2)*(xwidth-xwidth2)+4*zdepth*zdepth);
z_component = (xwidth-xwidth2)/sqrt(4*zdepth*zdepth+(xwidth-xwidth2)*(xwidth-xwidth2));

this_box_storage.normal_vectors[2] = coords_set(x_component,0,z_component);
this_box_storage.normal_vectors[3] = coords_set(-x_component,0,z_component);

// for sides with x component = 0
y_component = 2*zdepth/sqrt((yheight-yheight2)*(yheight-yheight2)+4*zdepth*zdepth);
z_component = (yheight-yheight2)/sqrt(4*zdepth*zdepth+(yheight-yheight2)*(yheight-yheight2));

this_box_storage.normal_vectors[4] = coords_set(0,y_component,z_component);
this_box_storage.normal_vectors[5] = coords_set(0,-y_component,z_component);

this_box_volume.geometry.visualization_on = visualize;

this_box_volume.geometry.geometry_parameters.p_box_storage = &this_box_storage;

// Assign pointers to functions for intersection with the shape, checking if a point is inside the shape
if (this_box_storage.is_rectangle == 1) {
this_box_volume.geometry.intersect_function = &sample_box_intersect_simple;
this_box_volume.geometry.within_function = &r_within_box_simple;
}
else {
this_box_volume.geometry.intersect_function = &sample_box_intersect_advanced;
this_box_volume.geometry.within_function = &r_within_box_advanced;
}

this_box_volume.geometry.shell_points = &box_shell_points;
this_box_volume.geometry.mcdisplay_function = &mcdisplay_box_function;
this_box_volume.geometry.initialize_from_main_function = &initialize_box_geometry_from_main_component;
this_box_volume.geometry.process_rot_allocated = 0;

this_box_volume.geometry.copy_geometry_parameters = &allocate_box_storage_copy;

rot_copy(this_box_volume.geometry.rotation_matrix,ROT_A_CURRENT_COMP); //check how ROT_R_CURRENT_COMP would work
rot_transpose(ROT_A_CURRENT_COMP,this_box_volume.geometry.transpose_rotation_matrix);

// Initialize loggers
this_box_volume.loggers.num_elements = 0;

// packing the information into the global_geometry_element, which is then included in the global_geometry_list.
sprintf(global_geometry_element.name,NAME_CURRENT_COMP);
global_geometry_element.activation_counter = number_of_activations;
global_geometry_element.component_index = INDEX_CURRENT_COMP;
global_geometry_element.Volume = &this_box_volume; // Would be nicer if this m was a pointer, now we have the (small) data two places
add_element_to_geometry_list(&global_geometry_list,global_geometry_element);
}
#line 310265 "MACS_sample_kidney_box.c"
#undef number_of_activations
#undef mask_setting
#undef mask_string
#undef p_interact
#undef focus_r
#undef focus_xh
#undef focus_xw
#undef focus_ah
#undef focus_aw
#undef target_z
#undef target_y
#undef target_x
#undef target_index
#undef visualize
#undef yheight2
#undef xwidth2
#undef zdepth
#undef yheight
#undef xwidth
#undef priority
#undef material_string
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

  /* Initializations for component channel_16_analyzer_2_array_crystal_array_5. */
  SIG_MESSAGE("channel_16_analyzer_2_array_crystal_array_5 (Init)");
#define mccompcurname  channel_16_analyzer_2_array_crystal_array_5
#define mccompcurtype  Union_box
#define mccompcurindex 754
#define loop_index mccchannel_16_analyzer_2_array_crystal_array_5_loop_index
#define this_box_volume mccchannel_16_analyzer_2_array_crystal_array_5_this_box_volume
#define global_geometry_element mccchannel_16_analyzer_2_array_crystal_array_5_global_geometry_element
#define this_box_storage mccchannel_16_analyzer_2_array_crystal_array_5_this_box_storage
#define material_string mccchannel_16_analyzer_2_array_crystal_array_5_material_string
#define priority mccchannel_16_analyzer_2_array_crystal_array_5_priority
#define xwidth mccchannel_16_analyzer_2_array_crystal_array_5_xwidth
#define yheight mccchannel_16_analyzer_2_array_crystal_array_5_yheight
#define zdepth mccchannel_16_analyzer_2_array_crystal_array_5_zdepth
#define xwidth2 mccchannel_16_analyzer_2_array_crystal_array_5_xwidth2
#define yheight2 mccchannel_16_analyzer_2_array_crystal_array_5_yheight2
#define visualize mccchannel_16_analyzer_2_array_crystal_array_5_visualize
#define target_index mccchannel_16_analyzer_2_array_crystal_array_5_target_index
#define target_x mccchannel_16_analyzer_2_array_crystal_array_5_target_x
#define target_y mccchannel_16_analyzer_2_array_crystal_array_5_target_y
#define target_z mccchannel_16_analyzer_2_array_crystal_array_5_target_z
#define focus_aw mccchannel_16_analyzer_2_array_crystal_array_5_focus_aw
#define focus_ah mccchannel_16_analyzer_2_array_crystal_array_5_focus_ah
#define focus_xw mccchannel_16_analyzer_2_array_crystal_array_5_focus_xw
#define focus_xh mccchannel_16_analyzer_2_array_crystal_array_5_focus_xh
#define focus_r mccchannel_16_analyzer_2_array_crystal_array_5_focus_r
#define p_interact mccchannel_16_analyzer_2_array_crystal_array_5_p_interact
#define mask_string mccchannel_16_analyzer_2_array_crystal_array_5_mask_string
#define mask_setting mccchannel_16_analyzer_2_array_crystal_array_5_mask_setting
#define number_of_activations mccchannel_16_analyzer_2_array_crystal_array_5_number_of_activations
#line 224 "Union_box.comp"
{
// Initializes the focusing system for this volume including input sanitation.
focus_initialize(&this_box_volume.geometry, POS_A_COMP_INDEX(INDEX_CURRENT_COMP+target_index), POS_A_CURRENT_COMP, ROT_A_CURRENT_COMP, target_index, target_x, target_y, target_z, focus_aw, focus_ah, focus_xw, focus_xh, focus_r, NAME_CURRENT_COMP);

// Input sanitation for this geometry
if (xwidth <= 0) {
  printf("\nERROR in Union_box named %s, the xwidth is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (yheight <= 0) {
  printf("\nERROR in Union_box named %s, yheight is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (zdepth <= 0) {
  printf("\nERROR in Union_box named %s, zdepth is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (xwidth2 <= 0 && xwidth2 != -1) {
  printf("\nERROR in Union_box named %s, the xwidth2 is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (yheight2 <= 0 && yheight2 != -1) {
  printf("\nERROR in Union_box named %s, yheight2 is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}

// Use sanitation
if (global_material_list.num_elements == 0) {
  printf("\nERROR: Need to define a material using Union_make_material before using a Union geometry component. \n");
  printf("       %s was defined before first use of Union_make_material.\n",NAME_CURRENT_COMP);
  exit(1);
}

this_box_volume.geometry.is_masked_volume = 0;
this_box_volume.geometry.is_exit_volume = 0;
this_box_volume.geometry.is_mask_volume = 0;
// check if the volume is a mask, if it is the material string is irelevant.
if (mask_string && strlen(mask_string) && strcmp(mask_string, "NULL") && strcmp(mask_string, "0")) {
    // A mask volume is used to limit the extend of other volumes, called the masked volumes. These are specified in the mask_string.
    // In order for a ray to enter a masked volume, it needs to be both in the region covered by that volume AND the mask volume.
    // When more than
    this_box_volume.geometry.mask_mode = 1; // Default is mask mode is ALL
    if (mask_setting && strlen(mask_setting) && strcmp(mask_setting, "NULL") && strcmp(mask_setting, "0")) {
        if (strcmp(mask_setting,"ALL") == 0 || strcmp(mask_setting,"All") == 0) this_box_volume.geometry.mask_mode = 1;
        else if (strcmp(mask_setting,"ANY") == 0 || strcmp(mask_setting,"Any") == 0) this_box_volume.geometry.mask_mode = 2;
        else {
            printf("The mask_mode of component %s is set to %s, but must be either ALL or ANY.\n",NAME_CURRENT_COMP,mask_setting);
            exit(1);
        }
    }
    
    for (loop_index=0;loop_index<global_geometry_list.num_elements;loop_index++) {
        // Add mask list
        if (1 == manual_linking_function(global_geometry_list.elements[loop_index].name,mask_string)) {
            add_element_to_int_list(&this_box_volume.geometry.mask_list,global_geometry_list.elements[loop_index].component_index);
            add_element_to_int_list(&global_geometry_list.elements[loop_index].Volume->geometry.masked_by_list,INDEX_CURRENT_COMP);
            global_geometry_list.elements[loop_index].Volume->geometry.is_masked_volume = 1;
            if (this_box_volume.geometry.mask_mode == 2)
                global_geometry_list.elements[loop_index].Volume->geometry.mask_mode = 2;
            if (this_box_volume.geometry.mask_mode == 1) {
                if (global_geometry_list.elements[loop_index].Volume->geometry.is_masked_volume == 1 && global_geometry_list.elements[loop_index].Volume->geometry.mask_mode != 2)
                    // If more than one mask is added to one volume, the ANY mode overwrites the (default) ALL mode.
                    global_geometry_list.elements[loop_index].Volume->geometry.mask_mode = 1;
            }
            
            found_geometries = 1;
        }
    }
    if (found_geometries == 0) {
        printf("The mask_string in geometry: %s did not find any of the specified volumes in the mask_string %s \n",NAME_CURRENT_COMP,mask_string);
        exit(1);
    }
    this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
    this_box_volume.p_physics->is_vacuum = 0; // Makes this volume a vacuum
    this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
    this_box_volume.p_physics->my_a = 0; // Should not be used.
    sprintf(this_box_volume.p_physics->name,"Mask");
    this_box_volume.geometry.is_mask_volume = 1;
    
    
// Read the material input, or if it lacks, use automatic linking.
} else if (material_string && strlen(material_string) && strcmp(material_string, "NULL") && strcmp(material_string, "0")) {
    // A geometry string was given, use it to determine which material
    if (0 == strcmp(material_string,"vacuum") || 0 == strcmp(material_string,"Vacuum")) {
        // One could have a global physics struct for vacuum instead of creating one for each
        this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
        this_box_volume.p_physics->is_vacuum = 1; // Makes this volume a vacuum
        this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
        this_box_volume.p_physics->my_a = 0; // Should not be used.
        sprintf(this_box_volume.p_physics->name,"Vacuum");
    } else if (0 == strcmp(material_string,"exit") || 0 == strcmp(material_string,"Exit")) {
        // One could have a global physics struct for vacuum instead of creating one for each
        this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
        this_box_volume.p_physics->is_vacuum = 1; // Makes this volume a vacuum
        this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
        this_box_volume.p_physics->my_a = 0; // Should not be used.
        this_box_volume.geometry.is_exit_volume = 1;
        sprintf(this_box_volume.p_physics->name,"Exit");
    } else {
        #ifndef MATERIAL_DETECTOR
            printf("Need to define a material before refering to it in a geometry %s.\n",NAME_CURRENT_COMP);
            exit(1);
        #endif
        for (loop_index=0;loop_index<global_material_list.num_elements;loop_index++) {
            if (0 == strcmp(material_string,global_material_list.elements[loop_index].name)) {
                this_box_volume.p_physics = global_material_list.elements[loop_index].physics;
                break;
            }
            if (loop_index == global_material_list.num_elements-1) {
            printf("\n");
            printf("ERROR: The material string \"%s\" in Union geometry \"%s\" did not match a specified material. \n",material_string,NAME_CURRENT_COMP);
            printf("       The materials available at this point (need to be defined before the geometry): \n");
            for (loop_index=0;loop_index<global_material_list.num_elements;loop_index++)
              printf("         %s\n",global_material_list.elements[loop_index].name);
            printf("\n");
            printf("       It is also possible to use one of the defualt materials avaiable: \n");
            printf("           Vacuum (for a Volume without scattering or absorption)\n");
            printf("           Exit (for a Volume where the ray exits the component if it enters)\n");
            printf("           Mask (for a Volume that masks existing volumes specified in the mask_string\n");
            exit(1);
          }
        }
    }
} else {
    // Automatic linking, simply using the last defined material.
    #ifndef MATERIAL_DETECTOR
        printf("Need to define a material before the geometry to use automatic linking %s.\n",NAME_CURRENT_COMP);
        exit(1);
    #endif
    this_box_volume.p_physics = global_material_list.elements[global_material_list.num_elements-1].physics;
}

sprintf(this_box_volume.name,NAME_CURRENT_COMP);
sprintf(this_box_volume.geometry.shape,"box");
this_box_volume.geometry.priority_value = priority;
this_box_volume.geometry.geometry_p_interact = p_interact;
// Currently the coordinates will be in absolute space.
this_box_volume.geometry.center = POS_A_CURRENT_COMP;

this_box_storage.z_depth = zdepth;
this_box_storage.x_width1 = xwidth;
this_box_storage.y_height1 = yheight;

this_box_storage.is_rectangle = 0;
if (xwidth2 < 0 && yheight2 < 0) this_box_storage.is_rectangle = 1;
if (xwidth == xwidth2 && yheight == yheight2) this_box_storage.is_rectangle = 1;

if (xwidth2 < 0) {
    this_box_storage.x_width2 = xwidth;
    xwidth2 = xwidth;
} else this_box_storage.x_width2 = xwidth2;

if (yheight2 < 0) {
    this_box_storage.y_height2 = yheight;
    yheight2 = yheight;
} else this_box_storage.y_height2 = yheight2;


this_box_storage.normal_vectors[0] = coords_set(0,0,1);
this_box_storage.normal_vectors[1] = coords_set(0,0,1);

// for sides with y component = 0
x_component = 2*zdepth/sqrt((xwidth-xwidth2)*(xwidth-xwidth2)+4*zdepth*zdepth);
z_component = (xwidth-xwidth2)/sqrt(4*zdepth*zdepth+(xwidth-xwidth2)*(xwidth-xwidth2));

this_box_storage.normal_vectors[2] = coords_set(x_component,0,z_component);
this_box_storage.normal_vectors[3] = coords_set(-x_component,0,z_component);

// for sides with x component = 0
y_component = 2*zdepth/sqrt((yheight-yheight2)*(yheight-yheight2)+4*zdepth*zdepth);
z_component = (yheight-yheight2)/sqrt(4*zdepth*zdepth+(yheight-yheight2)*(yheight-yheight2));

this_box_storage.normal_vectors[4] = coords_set(0,y_component,z_component);
this_box_storage.normal_vectors[5] = coords_set(0,-y_component,z_component);

this_box_volume.geometry.visualization_on = visualize;

this_box_volume.geometry.geometry_parameters.p_box_storage = &this_box_storage;

// Assign pointers to functions for intersection with the shape, checking if a point is inside the shape
if (this_box_storage.is_rectangle == 1) {
this_box_volume.geometry.intersect_function = &sample_box_intersect_simple;
this_box_volume.geometry.within_function = &r_within_box_simple;
}
else {
this_box_volume.geometry.intersect_function = &sample_box_intersect_advanced;
this_box_volume.geometry.within_function = &r_within_box_advanced;
}

this_box_volume.geometry.shell_points = &box_shell_points;
this_box_volume.geometry.mcdisplay_function = &mcdisplay_box_function;
this_box_volume.geometry.initialize_from_main_function = &initialize_box_geometry_from_main_component;
this_box_volume.geometry.process_rot_allocated = 0;

this_box_volume.geometry.copy_geometry_parameters = &allocate_box_storage_copy;

rot_copy(this_box_volume.geometry.rotation_matrix,ROT_A_CURRENT_COMP); //check how ROT_R_CURRENT_COMP would work
rot_transpose(ROT_A_CURRENT_COMP,this_box_volume.geometry.transpose_rotation_matrix);

// Initialize loggers
this_box_volume.loggers.num_elements = 0;

// packing the information into the global_geometry_element, which is then included in the global_geometry_list.
sprintf(global_geometry_element.name,NAME_CURRENT_COMP);
global_geometry_element.activation_counter = number_of_activations;
global_geometry_element.component_index = INDEX_CURRENT_COMP;
global_geometry_element.Volume = &this_box_volume; // Would be nicer if this m was a pointer, now we have the (small) data two places
add_element_to_geometry_list(&global_geometry_list,global_geometry_element);
}
#line 310535 "MACS_sample_kidney_box.c"
#undef number_of_activations
#undef mask_setting
#undef mask_string
#undef p_interact
#undef focus_r
#undef focus_xh
#undef focus_xw
#undef focus_ah
#undef focus_aw
#undef target_z
#undef target_y
#undef target_x
#undef target_index
#undef visualize
#undef yheight2
#undef xwidth2
#undef zdepth
#undef yheight
#undef xwidth
#undef priority
#undef material_string
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

  /* Initializations for component channel_16_analyzer_2_array_crystal_array_6. */
  SIG_MESSAGE("channel_16_analyzer_2_array_crystal_array_6 (Init)");
#define mccompcurname  channel_16_analyzer_2_array_crystal_array_6
#define mccompcurtype  Union_box
#define mccompcurindex 755
#define loop_index mccchannel_16_analyzer_2_array_crystal_array_6_loop_index
#define this_box_volume mccchannel_16_analyzer_2_array_crystal_array_6_this_box_volume
#define global_geometry_element mccchannel_16_analyzer_2_array_crystal_array_6_global_geometry_element
#define this_box_storage mccchannel_16_analyzer_2_array_crystal_array_6_this_box_storage
#define material_string mccchannel_16_analyzer_2_array_crystal_array_6_material_string
#define priority mccchannel_16_analyzer_2_array_crystal_array_6_priority
#define xwidth mccchannel_16_analyzer_2_array_crystal_array_6_xwidth
#define yheight mccchannel_16_analyzer_2_array_crystal_array_6_yheight
#define zdepth mccchannel_16_analyzer_2_array_crystal_array_6_zdepth
#define xwidth2 mccchannel_16_analyzer_2_array_crystal_array_6_xwidth2
#define yheight2 mccchannel_16_analyzer_2_array_crystal_array_6_yheight2
#define visualize mccchannel_16_analyzer_2_array_crystal_array_6_visualize
#define target_index mccchannel_16_analyzer_2_array_crystal_array_6_target_index
#define target_x mccchannel_16_analyzer_2_array_crystal_array_6_target_x
#define target_y mccchannel_16_analyzer_2_array_crystal_array_6_target_y
#define target_z mccchannel_16_analyzer_2_array_crystal_array_6_target_z
#define focus_aw mccchannel_16_analyzer_2_array_crystal_array_6_focus_aw
#define focus_ah mccchannel_16_analyzer_2_array_crystal_array_6_focus_ah
#define focus_xw mccchannel_16_analyzer_2_array_crystal_array_6_focus_xw
#define focus_xh mccchannel_16_analyzer_2_array_crystal_array_6_focus_xh
#define focus_r mccchannel_16_analyzer_2_array_crystal_array_6_focus_r
#define p_interact mccchannel_16_analyzer_2_array_crystal_array_6_p_interact
#define mask_string mccchannel_16_analyzer_2_array_crystal_array_6_mask_string
#define mask_setting mccchannel_16_analyzer_2_array_crystal_array_6_mask_setting
#define number_of_activations mccchannel_16_analyzer_2_array_crystal_array_6_number_of_activations
#line 224 "Union_box.comp"
{
// Initializes the focusing system for this volume including input sanitation.
focus_initialize(&this_box_volume.geometry, POS_A_COMP_INDEX(INDEX_CURRENT_COMP+target_index), POS_A_CURRENT_COMP, ROT_A_CURRENT_COMP, target_index, target_x, target_y, target_z, focus_aw, focus_ah, focus_xw, focus_xh, focus_r, NAME_CURRENT_COMP);

// Input sanitation for this geometry
if (xwidth <= 0) {
  printf("\nERROR in Union_box named %s, the xwidth is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (yheight <= 0) {
  printf("\nERROR in Union_box named %s, yheight is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (zdepth <= 0) {
  printf("\nERROR in Union_box named %s, zdepth is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (xwidth2 <= 0 && xwidth2 != -1) {
  printf("\nERROR in Union_box named %s, the xwidth2 is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (yheight2 <= 0 && yheight2 != -1) {
  printf("\nERROR in Union_box named %s, yheight2 is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}

// Use sanitation
if (global_material_list.num_elements == 0) {
  printf("\nERROR: Need to define a material using Union_make_material before using a Union geometry component. \n");
  printf("       %s was defined before first use of Union_make_material.\n",NAME_CURRENT_COMP);
  exit(1);
}

this_box_volume.geometry.is_masked_volume = 0;
this_box_volume.geometry.is_exit_volume = 0;
this_box_volume.geometry.is_mask_volume = 0;
// check if the volume is a mask, if it is the material string is irelevant.
if (mask_string && strlen(mask_string) && strcmp(mask_string, "NULL") && strcmp(mask_string, "0")) {
    // A mask volume is used to limit the extend of other volumes, called the masked volumes. These are specified in the mask_string.
    // In order for a ray to enter a masked volume, it needs to be both in the region covered by that volume AND the mask volume.
    // When more than
    this_box_volume.geometry.mask_mode = 1; // Default is mask mode is ALL
    if (mask_setting && strlen(mask_setting) && strcmp(mask_setting, "NULL") && strcmp(mask_setting, "0")) {
        if (strcmp(mask_setting,"ALL") == 0 || strcmp(mask_setting,"All") == 0) this_box_volume.geometry.mask_mode = 1;
        else if (strcmp(mask_setting,"ANY") == 0 || strcmp(mask_setting,"Any") == 0) this_box_volume.geometry.mask_mode = 2;
        else {
            printf("The mask_mode of component %s is set to %s, but must be either ALL or ANY.\n",NAME_CURRENT_COMP,mask_setting);
            exit(1);
        }
    }
    
    for (loop_index=0;loop_index<global_geometry_list.num_elements;loop_index++) {
        // Add mask list
        if (1 == manual_linking_function(global_geometry_list.elements[loop_index].name,mask_string)) {
            add_element_to_int_list(&this_box_volume.geometry.mask_list,global_geometry_list.elements[loop_index].component_index);
            add_element_to_int_list(&global_geometry_list.elements[loop_index].Volume->geometry.masked_by_list,INDEX_CURRENT_COMP);
            global_geometry_list.elements[loop_index].Volume->geometry.is_masked_volume = 1;
            if (this_box_volume.geometry.mask_mode == 2)
                global_geometry_list.elements[loop_index].Volume->geometry.mask_mode = 2;
            if (this_box_volume.geometry.mask_mode == 1) {
                if (global_geometry_list.elements[loop_index].Volume->geometry.is_masked_volume == 1 && global_geometry_list.elements[loop_index].Volume->geometry.mask_mode != 2)
                    // If more than one mask is added to one volume, the ANY mode overwrites the (default) ALL mode.
                    global_geometry_list.elements[loop_index].Volume->geometry.mask_mode = 1;
            }
            
            found_geometries = 1;
        }
    }
    if (found_geometries == 0) {
        printf("The mask_string in geometry: %s did not find any of the specified volumes in the mask_string %s \n",NAME_CURRENT_COMP,mask_string);
        exit(1);
    }
    this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
    this_box_volume.p_physics->is_vacuum = 0; // Makes this volume a vacuum
    this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
    this_box_volume.p_physics->my_a = 0; // Should not be used.
    sprintf(this_box_volume.p_physics->name,"Mask");
    this_box_volume.geometry.is_mask_volume = 1;
    
    
// Read the material input, or if it lacks, use automatic linking.
} else if (material_string && strlen(material_string) && strcmp(material_string, "NULL") && strcmp(material_string, "0")) {
    // A geometry string was given, use it to determine which material
    if (0 == strcmp(material_string,"vacuum") || 0 == strcmp(material_string,"Vacuum")) {
        // One could have a global physics struct for vacuum instead of creating one for each
        this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
        this_box_volume.p_physics->is_vacuum = 1; // Makes this volume a vacuum
        this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
        this_box_volume.p_physics->my_a = 0; // Should not be used.
        sprintf(this_box_volume.p_physics->name,"Vacuum");
    } else if (0 == strcmp(material_string,"exit") || 0 == strcmp(material_string,"Exit")) {
        // One could have a global physics struct for vacuum instead of creating one for each
        this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
        this_box_volume.p_physics->is_vacuum = 1; // Makes this volume a vacuum
        this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
        this_box_volume.p_physics->my_a = 0; // Should not be used.
        this_box_volume.geometry.is_exit_volume = 1;
        sprintf(this_box_volume.p_physics->name,"Exit");
    } else {
        #ifndef MATERIAL_DETECTOR
            printf("Need to define a material before refering to it in a geometry %s.\n",NAME_CURRENT_COMP);
            exit(1);
        #endif
        for (loop_index=0;loop_index<global_material_list.num_elements;loop_index++) {
            if (0 == strcmp(material_string,global_material_list.elements[loop_index].name)) {
                this_box_volume.p_physics = global_material_list.elements[loop_index].physics;
                break;
            }
            if (loop_index == global_material_list.num_elements-1) {
            printf("\n");
            printf("ERROR: The material string \"%s\" in Union geometry \"%s\" did not match a specified material. \n",material_string,NAME_CURRENT_COMP);
            printf("       The materials available at this point (need to be defined before the geometry): \n");
            for (loop_index=0;loop_index<global_material_list.num_elements;loop_index++)
              printf("         %s\n",global_material_list.elements[loop_index].name);
            printf("\n");
            printf("       It is also possible to use one of the defualt materials avaiable: \n");
            printf("           Vacuum (for a Volume without scattering or absorption)\n");
            printf("           Exit (for a Volume where the ray exits the component if it enters)\n");
            printf("           Mask (for a Volume that masks existing volumes specified in the mask_string\n");
            exit(1);
          }
        }
    }
} else {
    // Automatic linking, simply using the last defined material.
    #ifndef MATERIAL_DETECTOR
        printf("Need to define a material before the geometry to use automatic linking %s.\n",NAME_CURRENT_COMP);
        exit(1);
    #endif
    this_box_volume.p_physics = global_material_list.elements[global_material_list.num_elements-1].physics;
}

sprintf(this_box_volume.name,NAME_CURRENT_COMP);
sprintf(this_box_volume.geometry.shape,"box");
this_box_volume.geometry.priority_value = priority;
this_box_volume.geometry.geometry_p_interact = p_interact;
// Currently the coordinates will be in absolute space.
this_box_volume.geometry.center = POS_A_CURRENT_COMP;

this_box_storage.z_depth = zdepth;
this_box_storage.x_width1 = xwidth;
this_box_storage.y_height1 = yheight;

this_box_storage.is_rectangle = 0;
if (xwidth2 < 0 && yheight2 < 0) this_box_storage.is_rectangle = 1;
if (xwidth == xwidth2 && yheight == yheight2) this_box_storage.is_rectangle = 1;

if (xwidth2 < 0) {
    this_box_storage.x_width2 = xwidth;
    xwidth2 = xwidth;
} else this_box_storage.x_width2 = xwidth2;

if (yheight2 < 0) {
    this_box_storage.y_height2 = yheight;
    yheight2 = yheight;
} else this_box_storage.y_height2 = yheight2;


this_box_storage.normal_vectors[0] = coords_set(0,0,1);
this_box_storage.normal_vectors[1] = coords_set(0,0,1);

// for sides with y component = 0
x_component = 2*zdepth/sqrt((xwidth-xwidth2)*(xwidth-xwidth2)+4*zdepth*zdepth);
z_component = (xwidth-xwidth2)/sqrt(4*zdepth*zdepth+(xwidth-xwidth2)*(xwidth-xwidth2));

this_box_storage.normal_vectors[2] = coords_set(x_component,0,z_component);
this_box_storage.normal_vectors[3] = coords_set(-x_component,0,z_component);

// for sides with x component = 0
y_component = 2*zdepth/sqrt((yheight-yheight2)*(yheight-yheight2)+4*zdepth*zdepth);
z_component = (yheight-yheight2)/sqrt(4*zdepth*zdepth+(yheight-yheight2)*(yheight-yheight2));

this_box_storage.normal_vectors[4] = coords_set(0,y_component,z_component);
this_box_storage.normal_vectors[5] = coords_set(0,-y_component,z_component);

this_box_volume.geometry.visualization_on = visualize;

this_box_volume.geometry.geometry_parameters.p_box_storage = &this_box_storage;

// Assign pointers to functions for intersection with the shape, checking if a point is inside the shape
if (this_box_storage.is_rectangle == 1) {
this_box_volume.geometry.intersect_function = &sample_box_intersect_simple;
this_box_volume.geometry.within_function = &r_within_box_simple;
}
else {
this_box_volume.geometry.intersect_function = &sample_box_intersect_advanced;
this_box_volume.geometry.within_function = &r_within_box_advanced;
}

this_box_volume.geometry.shell_points = &box_shell_points;
this_box_volume.geometry.mcdisplay_function = &mcdisplay_box_function;
this_box_volume.geometry.initialize_from_main_function = &initialize_box_geometry_from_main_component;
this_box_volume.geometry.process_rot_allocated = 0;

this_box_volume.geometry.copy_geometry_parameters = &allocate_box_storage_copy;

rot_copy(this_box_volume.geometry.rotation_matrix,ROT_A_CURRENT_COMP); //check how ROT_R_CURRENT_COMP would work
rot_transpose(ROT_A_CURRENT_COMP,this_box_volume.geometry.transpose_rotation_matrix);

// Initialize loggers
this_box_volume.loggers.num_elements = 0;

// packing the information into the global_geometry_element, which is then included in the global_geometry_list.
sprintf(global_geometry_element.name,NAME_CURRENT_COMP);
global_geometry_element.activation_counter = number_of_activations;
global_geometry_element.component_index = INDEX_CURRENT_COMP;
global_geometry_element.Volume = &this_box_volume; // Would be nicer if this m was a pointer, now we have the (small) data two places
add_element_to_geometry_list(&global_geometry_list,global_geometry_element);
}
#line 310805 "MACS_sample_kidney_box.c"
#undef number_of_activations
#undef mask_setting
#undef mask_string
#undef p_interact
#undef focus_r
#undef focus_xh
#undef focus_xw
#undef focus_ah
#undef focus_aw
#undef target_z
#undef target_y
#undef target_x
#undef target_index
#undef visualize
#undef yheight2
#undef xwidth2
#undef zdepth
#undef yheight
#undef xwidth
#undef priority
#undef material_string
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

  /* Initializations for component channel_16_analyzer_2_array_crystal_array_7. */
  SIG_MESSAGE("channel_16_analyzer_2_array_crystal_array_7 (Init)");
#define mccompcurname  channel_16_analyzer_2_array_crystal_array_7
#define mccompcurtype  Union_box
#define mccompcurindex 756
#define loop_index mccchannel_16_analyzer_2_array_crystal_array_7_loop_index
#define this_box_volume mccchannel_16_analyzer_2_array_crystal_array_7_this_box_volume
#define global_geometry_element mccchannel_16_analyzer_2_array_crystal_array_7_global_geometry_element
#define this_box_storage mccchannel_16_analyzer_2_array_crystal_array_7_this_box_storage
#define material_string mccchannel_16_analyzer_2_array_crystal_array_7_material_string
#define priority mccchannel_16_analyzer_2_array_crystal_array_7_priority
#define xwidth mccchannel_16_analyzer_2_array_crystal_array_7_xwidth
#define yheight mccchannel_16_analyzer_2_array_crystal_array_7_yheight
#define zdepth mccchannel_16_analyzer_2_array_crystal_array_7_zdepth
#define xwidth2 mccchannel_16_analyzer_2_array_crystal_array_7_xwidth2
#define yheight2 mccchannel_16_analyzer_2_array_crystal_array_7_yheight2
#define visualize mccchannel_16_analyzer_2_array_crystal_array_7_visualize
#define target_index mccchannel_16_analyzer_2_array_crystal_array_7_target_index
#define target_x mccchannel_16_analyzer_2_array_crystal_array_7_target_x
#define target_y mccchannel_16_analyzer_2_array_crystal_array_7_target_y
#define target_z mccchannel_16_analyzer_2_array_crystal_array_7_target_z
#define focus_aw mccchannel_16_analyzer_2_array_crystal_array_7_focus_aw
#define focus_ah mccchannel_16_analyzer_2_array_crystal_array_7_focus_ah
#define focus_xw mccchannel_16_analyzer_2_array_crystal_array_7_focus_xw
#define focus_xh mccchannel_16_analyzer_2_array_crystal_array_7_focus_xh
#define focus_r mccchannel_16_analyzer_2_array_crystal_array_7_focus_r
#define p_interact mccchannel_16_analyzer_2_array_crystal_array_7_p_interact
#define mask_string mccchannel_16_analyzer_2_array_crystal_array_7_mask_string
#define mask_setting mccchannel_16_analyzer_2_array_crystal_array_7_mask_setting
#define number_of_activations mccchannel_16_analyzer_2_array_crystal_array_7_number_of_activations
#line 224 "Union_box.comp"
{
// Initializes the focusing system for this volume including input sanitation.
focus_initialize(&this_box_volume.geometry, POS_A_COMP_INDEX(INDEX_CURRENT_COMP+target_index), POS_A_CURRENT_COMP, ROT_A_CURRENT_COMP, target_index, target_x, target_y, target_z, focus_aw, focus_ah, focus_xw, focus_xh, focus_r, NAME_CURRENT_COMP);

// Input sanitation for this geometry
if (xwidth <= 0) {
  printf("\nERROR in Union_box named %s, the xwidth is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (yheight <= 0) {
  printf("\nERROR in Union_box named %s, yheight is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (zdepth <= 0) {
  printf("\nERROR in Union_box named %s, zdepth is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (xwidth2 <= 0 && xwidth2 != -1) {
  printf("\nERROR in Union_box named %s, the xwidth2 is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (yheight2 <= 0 && yheight2 != -1) {
  printf("\nERROR in Union_box named %s, yheight2 is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}

// Use sanitation
if (global_material_list.num_elements == 0) {
  printf("\nERROR: Need to define a material using Union_make_material before using a Union geometry component. \n");
  printf("       %s was defined before first use of Union_make_material.\n",NAME_CURRENT_COMP);
  exit(1);
}

this_box_volume.geometry.is_masked_volume = 0;
this_box_volume.geometry.is_exit_volume = 0;
this_box_volume.geometry.is_mask_volume = 0;
// check if the volume is a mask, if it is the material string is irelevant.
if (mask_string && strlen(mask_string) && strcmp(mask_string, "NULL") && strcmp(mask_string, "0")) {
    // A mask volume is used to limit the extend of other volumes, called the masked volumes. These are specified in the mask_string.
    // In order for a ray to enter a masked volume, it needs to be both in the region covered by that volume AND the mask volume.
    // When more than
    this_box_volume.geometry.mask_mode = 1; // Default is mask mode is ALL
    if (mask_setting && strlen(mask_setting) && strcmp(mask_setting, "NULL") && strcmp(mask_setting, "0")) {
        if (strcmp(mask_setting,"ALL") == 0 || strcmp(mask_setting,"All") == 0) this_box_volume.geometry.mask_mode = 1;
        else if (strcmp(mask_setting,"ANY") == 0 || strcmp(mask_setting,"Any") == 0) this_box_volume.geometry.mask_mode = 2;
        else {
            printf("The mask_mode of component %s is set to %s, but must be either ALL or ANY.\n",NAME_CURRENT_COMP,mask_setting);
            exit(1);
        }
    }
    
    for (loop_index=0;loop_index<global_geometry_list.num_elements;loop_index++) {
        // Add mask list
        if (1 == manual_linking_function(global_geometry_list.elements[loop_index].name,mask_string)) {
            add_element_to_int_list(&this_box_volume.geometry.mask_list,global_geometry_list.elements[loop_index].component_index);
            add_element_to_int_list(&global_geometry_list.elements[loop_index].Volume->geometry.masked_by_list,INDEX_CURRENT_COMP);
            global_geometry_list.elements[loop_index].Volume->geometry.is_masked_volume = 1;
            if (this_box_volume.geometry.mask_mode == 2)
                global_geometry_list.elements[loop_index].Volume->geometry.mask_mode = 2;
            if (this_box_volume.geometry.mask_mode == 1) {
                if (global_geometry_list.elements[loop_index].Volume->geometry.is_masked_volume == 1 && global_geometry_list.elements[loop_index].Volume->geometry.mask_mode != 2)
                    // If more than one mask is added to one volume, the ANY mode overwrites the (default) ALL mode.
                    global_geometry_list.elements[loop_index].Volume->geometry.mask_mode = 1;
            }
            
            found_geometries = 1;
        }
    }
    if (found_geometries == 0) {
        printf("The mask_string in geometry: %s did not find any of the specified volumes in the mask_string %s \n",NAME_CURRENT_COMP,mask_string);
        exit(1);
    }
    this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
    this_box_volume.p_physics->is_vacuum = 0; // Makes this volume a vacuum
    this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
    this_box_volume.p_physics->my_a = 0; // Should not be used.
    sprintf(this_box_volume.p_physics->name,"Mask");
    this_box_volume.geometry.is_mask_volume = 1;
    
    
// Read the material input, or if it lacks, use automatic linking.
} else if (material_string && strlen(material_string) && strcmp(material_string, "NULL") && strcmp(material_string, "0")) {
    // A geometry string was given, use it to determine which material
    if (0 == strcmp(material_string,"vacuum") || 0 == strcmp(material_string,"Vacuum")) {
        // One could have a global physics struct for vacuum instead of creating one for each
        this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
        this_box_volume.p_physics->is_vacuum = 1; // Makes this volume a vacuum
        this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
        this_box_volume.p_physics->my_a = 0; // Should not be used.
        sprintf(this_box_volume.p_physics->name,"Vacuum");
    } else if (0 == strcmp(material_string,"exit") || 0 == strcmp(material_string,"Exit")) {
        // One could have a global physics struct for vacuum instead of creating one for each
        this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
        this_box_volume.p_physics->is_vacuum = 1; // Makes this volume a vacuum
        this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
        this_box_volume.p_physics->my_a = 0; // Should not be used.
        this_box_volume.geometry.is_exit_volume = 1;
        sprintf(this_box_volume.p_physics->name,"Exit");
    } else {
        #ifndef MATERIAL_DETECTOR
            printf("Need to define a material before refering to it in a geometry %s.\n",NAME_CURRENT_COMP);
            exit(1);
        #endif
        for (loop_index=0;loop_index<global_material_list.num_elements;loop_index++) {
            if (0 == strcmp(material_string,global_material_list.elements[loop_index].name)) {
                this_box_volume.p_physics = global_material_list.elements[loop_index].physics;
                break;
            }
            if (loop_index == global_material_list.num_elements-1) {
            printf("\n");
            printf("ERROR: The material string \"%s\" in Union geometry \"%s\" did not match a specified material. \n",material_string,NAME_CURRENT_COMP);
            printf("       The materials available at this point (need to be defined before the geometry): \n");
            for (loop_index=0;loop_index<global_material_list.num_elements;loop_index++)
              printf("         %s\n",global_material_list.elements[loop_index].name);
            printf("\n");
            printf("       It is also possible to use one of the defualt materials avaiable: \n");
            printf("           Vacuum (for a Volume without scattering or absorption)\n");
            printf("           Exit (for a Volume where the ray exits the component if it enters)\n");
            printf("           Mask (for a Volume that masks existing volumes specified in the mask_string\n");
            exit(1);
          }
        }
    }
} else {
    // Automatic linking, simply using the last defined material.
    #ifndef MATERIAL_DETECTOR
        printf("Need to define a material before the geometry to use automatic linking %s.\n",NAME_CURRENT_COMP);
        exit(1);
    #endif
    this_box_volume.p_physics = global_material_list.elements[global_material_list.num_elements-1].physics;
}

sprintf(this_box_volume.name,NAME_CURRENT_COMP);
sprintf(this_box_volume.geometry.shape,"box");
this_box_volume.geometry.priority_value = priority;
this_box_volume.geometry.geometry_p_interact = p_interact;
// Currently the coordinates will be in absolute space.
this_box_volume.geometry.center = POS_A_CURRENT_COMP;

this_box_storage.z_depth = zdepth;
this_box_storage.x_width1 = xwidth;
this_box_storage.y_height1 = yheight;

this_box_storage.is_rectangle = 0;
if (xwidth2 < 0 && yheight2 < 0) this_box_storage.is_rectangle = 1;
if (xwidth == xwidth2 && yheight == yheight2) this_box_storage.is_rectangle = 1;

if (xwidth2 < 0) {
    this_box_storage.x_width2 = xwidth;
    xwidth2 = xwidth;
} else this_box_storage.x_width2 = xwidth2;

if (yheight2 < 0) {
    this_box_storage.y_height2 = yheight;
    yheight2 = yheight;
} else this_box_storage.y_height2 = yheight2;


this_box_storage.normal_vectors[0] = coords_set(0,0,1);
this_box_storage.normal_vectors[1] = coords_set(0,0,1);

// for sides with y component = 0
x_component = 2*zdepth/sqrt((xwidth-xwidth2)*(xwidth-xwidth2)+4*zdepth*zdepth);
z_component = (xwidth-xwidth2)/sqrt(4*zdepth*zdepth+(xwidth-xwidth2)*(xwidth-xwidth2));

this_box_storage.normal_vectors[2] = coords_set(x_component,0,z_component);
this_box_storage.normal_vectors[3] = coords_set(-x_component,0,z_component);

// for sides with x component = 0
y_component = 2*zdepth/sqrt((yheight-yheight2)*(yheight-yheight2)+4*zdepth*zdepth);
z_component = (yheight-yheight2)/sqrt(4*zdepth*zdepth+(yheight-yheight2)*(yheight-yheight2));

this_box_storage.normal_vectors[4] = coords_set(0,y_component,z_component);
this_box_storage.normal_vectors[5] = coords_set(0,-y_component,z_component);

this_box_volume.geometry.visualization_on = visualize;

this_box_volume.geometry.geometry_parameters.p_box_storage = &this_box_storage;

// Assign pointers to functions for intersection with the shape, checking if a point is inside the shape
if (this_box_storage.is_rectangle == 1) {
this_box_volume.geometry.intersect_function = &sample_box_intersect_simple;
this_box_volume.geometry.within_function = &r_within_box_simple;
}
else {
this_box_volume.geometry.intersect_function = &sample_box_intersect_advanced;
this_box_volume.geometry.within_function = &r_within_box_advanced;
}

this_box_volume.geometry.shell_points = &box_shell_points;
this_box_volume.geometry.mcdisplay_function = &mcdisplay_box_function;
this_box_volume.geometry.initialize_from_main_function = &initialize_box_geometry_from_main_component;
this_box_volume.geometry.process_rot_allocated = 0;

this_box_volume.geometry.copy_geometry_parameters = &allocate_box_storage_copy;

rot_copy(this_box_volume.geometry.rotation_matrix,ROT_A_CURRENT_COMP); //check how ROT_R_CURRENT_COMP would work
rot_transpose(ROT_A_CURRENT_COMP,this_box_volume.geometry.transpose_rotation_matrix);

// Initialize loggers
this_box_volume.loggers.num_elements = 0;

// packing the information into the global_geometry_element, which is then included in the global_geometry_list.
sprintf(global_geometry_element.name,NAME_CURRENT_COMP);
global_geometry_element.activation_counter = number_of_activations;
global_geometry_element.component_index = INDEX_CURRENT_COMP;
global_geometry_element.Volume = &this_box_volume; // Would be nicer if this m was a pointer, now we have the (small) data two places
add_element_to_geometry_list(&global_geometry_list,global_geometry_element);
}
#line 311075 "MACS_sample_kidney_box.c"
#undef number_of_activations
#undef mask_setting
#undef mask_string
#undef p_interact
#undef focus_r
#undef focus_xh
#undef focus_xw
#undef focus_ah
#undef focus_aw
#undef target_z
#undef target_y
#undef target_x
#undef target_index
#undef visualize
#undef yheight2
#undef xwidth2
#undef zdepth
#undef yheight
#undef xwidth
#undef priority
#undef material_string
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

  /* Initializations for component channel_16_analyzer_2_array_crystal_array_8. */
  SIG_MESSAGE("channel_16_analyzer_2_array_crystal_array_8 (Init)");
#define mccompcurname  channel_16_analyzer_2_array_crystal_array_8
#define mccompcurtype  Union_box
#define mccompcurindex 757
#define loop_index mccchannel_16_analyzer_2_array_crystal_array_8_loop_index
#define this_box_volume mccchannel_16_analyzer_2_array_crystal_array_8_this_box_volume
#define global_geometry_element mccchannel_16_analyzer_2_array_crystal_array_8_global_geometry_element
#define this_box_storage mccchannel_16_analyzer_2_array_crystal_array_8_this_box_storage
#define material_string mccchannel_16_analyzer_2_array_crystal_array_8_material_string
#define priority mccchannel_16_analyzer_2_array_crystal_array_8_priority
#define xwidth mccchannel_16_analyzer_2_array_crystal_array_8_xwidth
#define yheight mccchannel_16_analyzer_2_array_crystal_array_8_yheight
#define zdepth mccchannel_16_analyzer_2_array_crystal_array_8_zdepth
#define xwidth2 mccchannel_16_analyzer_2_array_crystal_array_8_xwidth2
#define yheight2 mccchannel_16_analyzer_2_array_crystal_array_8_yheight2
#define visualize mccchannel_16_analyzer_2_array_crystal_array_8_visualize
#define target_index mccchannel_16_analyzer_2_array_crystal_array_8_target_index
#define target_x mccchannel_16_analyzer_2_array_crystal_array_8_target_x
#define target_y mccchannel_16_analyzer_2_array_crystal_array_8_target_y
#define target_z mccchannel_16_analyzer_2_array_crystal_array_8_target_z
#define focus_aw mccchannel_16_analyzer_2_array_crystal_array_8_focus_aw
#define focus_ah mccchannel_16_analyzer_2_array_crystal_array_8_focus_ah
#define focus_xw mccchannel_16_analyzer_2_array_crystal_array_8_focus_xw
#define focus_xh mccchannel_16_analyzer_2_array_crystal_array_8_focus_xh
#define focus_r mccchannel_16_analyzer_2_array_crystal_array_8_focus_r
#define p_interact mccchannel_16_analyzer_2_array_crystal_array_8_p_interact
#define mask_string mccchannel_16_analyzer_2_array_crystal_array_8_mask_string
#define mask_setting mccchannel_16_analyzer_2_array_crystal_array_8_mask_setting
#define number_of_activations mccchannel_16_analyzer_2_array_crystal_array_8_number_of_activations
#line 224 "Union_box.comp"
{
// Initializes the focusing system for this volume including input sanitation.
focus_initialize(&this_box_volume.geometry, POS_A_COMP_INDEX(INDEX_CURRENT_COMP+target_index), POS_A_CURRENT_COMP, ROT_A_CURRENT_COMP, target_index, target_x, target_y, target_z, focus_aw, focus_ah, focus_xw, focus_xh, focus_r, NAME_CURRENT_COMP);

// Input sanitation for this geometry
if (xwidth <= 0) {
  printf("\nERROR in Union_box named %s, the xwidth is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (yheight <= 0) {
  printf("\nERROR in Union_box named %s, yheight is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (zdepth <= 0) {
  printf("\nERROR in Union_box named %s, zdepth is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (xwidth2 <= 0 && xwidth2 != -1) {
  printf("\nERROR in Union_box named %s, the xwidth2 is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (yheight2 <= 0 && yheight2 != -1) {
  printf("\nERROR in Union_box named %s, yheight2 is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}

// Use sanitation
if (global_material_list.num_elements == 0) {
  printf("\nERROR: Need to define a material using Union_make_material before using a Union geometry component. \n");
  printf("       %s was defined before first use of Union_make_material.\n",NAME_CURRENT_COMP);
  exit(1);
}

this_box_volume.geometry.is_masked_volume = 0;
this_box_volume.geometry.is_exit_volume = 0;
this_box_volume.geometry.is_mask_volume = 0;
// check if the volume is a mask, if it is the material string is irelevant.
if (mask_string && strlen(mask_string) && strcmp(mask_string, "NULL") && strcmp(mask_string, "0")) {
    // A mask volume is used to limit the extend of other volumes, called the masked volumes. These are specified in the mask_string.
    // In order for a ray to enter a masked volume, it needs to be both in the region covered by that volume AND the mask volume.
    // When more than
    this_box_volume.geometry.mask_mode = 1; // Default is mask mode is ALL
    if (mask_setting && strlen(mask_setting) && strcmp(mask_setting, "NULL") && strcmp(mask_setting, "0")) {
        if (strcmp(mask_setting,"ALL") == 0 || strcmp(mask_setting,"All") == 0) this_box_volume.geometry.mask_mode = 1;
        else if (strcmp(mask_setting,"ANY") == 0 || strcmp(mask_setting,"Any") == 0) this_box_volume.geometry.mask_mode = 2;
        else {
            printf("The mask_mode of component %s is set to %s, but must be either ALL or ANY.\n",NAME_CURRENT_COMP,mask_setting);
            exit(1);
        }
    }
    
    for (loop_index=0;loop_index<global_geometry_list.num_elements;loop_index++) {
        // Add mask list
        if (1 == manual_linking_function(global_geometry_list.elements[loop_index].name,mask_string)) {
            add_element_to_int_list(&this_box_volume.geometry.mask_list,global_geometry_list.elements[loop_index].component_index);
            add_element_to_int_list(&global_geometry_list.elements[loop_index].Volume->geometry.masked_by_list,INDEX_CURRENT_COMP);
            global_geometry_list.elements[loop_index].Volume->geometry.is_masked_volume = 1;
            if (this_box_volume.geometry.mask_mode == 2)
                global_geometry_list.elements[loop_index].Volume->geometry.mask_mode = 2;
            if (this_box_volume.geometry.mask_mode == 1) {
                if (global_geometry_list.elements[loop_index].Volume->geometry.is_masked_volume == 1 && global_geometry_list.elements[loop_index].Volume->geometry.mask_mode != 2)
                    // If more than one mask is added to one volume, the ANY mode overwrites the (default) ALL mode.
                    global_geometry_list.elements[loop_index].Volume->geometry.mask_mode = 1;
            }
            
            found_geometries = 1;
        }
    }
    if (found_geometries == 0) {
        printf("The mask_string in geometry: %s did not find any of the specified volumes in the mask_string %s \n",NAME_CURRENT_COMP,mask_string);
        exit(1);
    }
    this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
    this_box_volume.p_physics->is_vacuum = 0; // Makes this volume a vacuum
    this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
    this_box_volume.p_physics->my_a = 0; // Should not be used.
    sprintf(this_box_volume.p_physics->name,"Mask");
    this_box_volume.geometry.is_mask_volume = 1;
    
    
// Read the material input, or if it lacks, use automatic linking.
} else if (material_string && strlen(material_string) && strcmp(material_string, "NULL") && strcmp(material_string, "0")) {
    // A geometry string was given, use it to determine which material
    if (0 == strcmp(material_string,"vacuum") || 0 == strcmp(material_string,"Vacuum")) {
        // One could have a global physics struct for vacuum instead of creating one for each
        this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
        this_box_volume.p_physics->is_vacuum = 1; // Makes this volume a vacuum
        this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
        this_box_volume.p_physics->my_a = 0; // Should not be used.
        sprintf(this_box_volume.p_physics->name,"Vacuum");
    } else if (0 == strcmp(material_string,"exit") || 0 == strcmp(material_string,"Exit")) {
        // One could have a global physics struct for vacuum instead of creating one for each
        this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
        this_box_volume.p_physics->is_vacuum = 1; // Makes this volume a vacuum
        this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
        this_box_volume.p_physics->my_a = 0; // Should not be used.
        this_box_volume.geometry.is_exit_volume = 1;
        sprintf(this_box_volume.p_physics->name,"Exit");
    } else {
        #ifndef MATERIAL_DETECTOR
            printf("Need to define a material before refering to it in a geometry %s.\n",NAME_CURRENT_COMP);
            exit(1);
        #endif
        for (loop_index=0;loop_index<global_material_list.num_elements;loop_index++) {
            if (0 == strcmp(material_string,global_material_list.elements[loop_index].name)) {
                this_box_volume.p_physics = global_material_list.elements[loop_index].physics;
                break;
            }
            if (loop_index == global_material_list.num_elements-1) {
            printf("\n");
            printf("ERROR: The material string \"%s\" in Union geometry \"%s\" did not match a specified material. \n",material_string,NAME_CURRENT_COMP);
            printf("       The materials available at this point (need to be defined before the geometry): \n");
            for (loop_index=0;loop_index<global_material_list.num_elements;loop_index++)
              printf("         %s\n",global_material_list.elements[loop_index].name);
            printf("\n");
            printf("       It is also possible to use one of the defualt materials avaiable: \n");
            printf("           Vacuum (for a Volume without scattering or absorption)\n");
            printf("           Exit (for a Volume where the ray exits the component if it enters)\n");
            printf("           Mask (for a Volume that masks existing volumes specified in the mask_string\n");
            exit(1);
          }
        }
    }
} else {
    // Automatic linking, simply using the last defined material.
    #ifndef MATERIAL_DETECTOR
        printf("Need to define a material before the geometry to use automatic linking %s.\n",NAME_CURRENT_COMP);
        exit(1);
    #endif
    this_box_volume.p_physics = global_material_list.elements[global_material_list.num_elements-1].physics;
}

sprintf(this_box_volume.name,NAME_CURRENT_COMP);
sprintf(this_box_volume.geometry.shape,"box");
this_box_volume.geometry.priority_value = priority;
this_box_volume.geometry.geometry_p_interact = p_interact;
// Currently the coordinates will be in absolute space.
this_box_volume.geometry.center = POS_A_CURRENT_COMP;

this_box_storage.z_depth = zdepth;
this_box_storage.x_width1 = xwidth;
this_box_storage.y_height1 = yheight;

this_box_storage.is_rectangle = 0;
if (xwidth2 < 0 && yheight2 < 0) this_box_storage.is_rectangle = 1;
if (xwidth == xwidth2 && yheight == yheight2) this_box_storage.is_rectangle = 1;

if (xwidth2 < 0) {
    this_box_storage.x_width2 = xwidth;
    xwidth2 = xwidth;
} else this_box_storage.x_width2 = xwidth2;

if (yheight2 < 0) {
    this_box_storage.y_height2 = yheight;
    yheight2 = yheight;
} else this_box_storage.y_height2 = yheight2;


this_box_storage.normal_vectors[0] = coords_set(0,0,1);
this_box_storage.normal_vectors[1] = coords_set(0,0,1);

// for sides with y component = 0
x_component = 2*zdepth/sqrt((xwidth-xwidth2)*(xwidth-xwidth2)+4*zdepth*zdepth);
z_component = (xwidth-xwidth2)/sqrt(4*zdepth*zdepth+(xwidth-xwidth2)*(xwidth-xwidth2));

this_box_storage.normal_vectors[2] = coords_set(x_component,0,z_component);
this_box_storage.normal_vectors[3] = coords_set(-x_component,0,z_component);

// for sides with x component = 0
y_component = 2*zdepth/sqrt((yheight-yheight2)*(yheight-yheight2)+4*zdepth*zdepth);
z_component = (yheight-yheight2)/sqrt(4*zdepth*zdepth+(yheight-yheight2)*(yheight-yheight2));

this_box_storage.normal_vectors[4] = coords_set(0,y_component,z_component);
this_box_storage.normal_vectors[5] = coords_set(0,-y_component,z_component);

this_box_volume.geometry.visualization_on = visualize;

this_box_volume.geometry.geometry_parameters.p_box_storage = &this_box_storage;

// Assign pointers to functions for intersection with the shape, checking if a point is inside the shape
if (this_box_storage.is_rectangle == 1) {
this_box_volume.geometry.intersect_function = &sample_box_intersect_simple;
this_box_volume.geometry.within_function = &r_within_box_simple;
}
else {
this_box_volume.geometry.intersect_function = &sample_box_intersect_advanced;
this_box_volume.geometry.within_function = &r_within_box_advanced;
}

this_box_volume.geometry.shell_points = &box_shell_points;
this_box_volume.geometry.mcdisplay_function = &mcdisplay_box_function;
this_box_volume.geometry.initialize_from_main_function = &initialize_box_geometry_from_main_component;
this_box_volume.geometry.process_rot_allocated = 0;

this_box_volume.geometry.copy_geometry_parameters = &allocate_box_storage_copy;

rot_copy(this_box_volume.geometry.rotation_matrix,ROT_A_CURRENT_COMP); //check how ROT_R_CURRENT_COMP would work
rot_transpose(ROT_A_CURRENT_COMP,this_box_volume.geometry.transpose_rotation_matrix);

// Initialize loggers
this_box_volume.loggers.num_elements = 0;

// packing the information into the global_geometry_element, which is then included in the global_geometry_list.
sprintf(global_geometry_element.name,NAME_CURRENT_COMP);
global_geometry_element.activation_counter = number_of_activations;
global_geometry_element.component_index = INDEX_CURRENT_COMP;
global_geometry_element.Volume = &this_box_volume; // Would be nicer if this m was a pointer, now we have the (small) data two places
add_element_to_geometry_list(&global_geometry_list,global_geometry_element);
}
#line 311345 "MACS_sample_kidney_box.c"
#undef number_of_activations
#undef mask_setting
#undef mask_string
#undef p_interact
#undef focus_r
#undef focus_xh
#undef focus_xw
#undef focus_ah
#undef focus_aw
#undef target_z
#undef target_y
#undef target_x
#undef target_index
#undef visualize
#undef yheight2
#undef xwidth2
#undef zdepth
#undef yheight
#undef xwidth
#undef priority
#undef material_string
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

  /* Initializations for component channel_16_cave2_cyl1. */
  SIG_MESSAGE("channel_16_cave2_cyl1 (Init)");
#define mccompcurname  channel_16_cave2_cyl1
#define mccompcurtype  Union_cylinder
#define mccompcurindex 758
#define loop_index mccchannel_16_cave2_cyl1_loop_index
#define this_cylinder_volume mccchannel_16_cave2_cyl1_this_cylinder_volume
#define global_geometry_element mccchannel_16_cave2_cyl1_global_geometry_element
#define this_cylinder_storage mccchannel_16_cave2_cyl1_this_cylinder_storage
#define material_string mccchannel_16_cave2_cyl1_material_string
#define priority mccchannel_16_cave2_cyl1_priority
#define radius mccchannel_16_cave2_cyl1_radius
#define yheight mccchannel_16_cave2_cyl1_yheight
#define visualize mccchannel_16_cave2_cyl1_visualize
#define target_index mccchannel_16_cave2_cyl1_target_index
#define target_x mccchannel_16_cave2_cyl1_target_x
#define target_y mccchannel_16_cave2_cyl1_target_y
#define target_z mccchannel_16_cave2_cyl1_target_z
#define focus_aw mccchannel_16_cave2_cyl1_focus_aw
#define focus_ah mccchannel_16_cave2_cyl1_focus_ah
#define focus_xw mccchannel_16_cave2_cyl1_focus_xw
#define focus_xh mccchannel_16_cave2_cyl1_focus_xh
#define focus_r mccchannel_16_cave2_cyl1_focus_r
#define p_interact mccchannel_16_cave2_cyl1_p_interact
#define mask_string mccchannel_16_cave2_cyl1_mask_string
#define mask_setting mccchannel_16_cave2_cyl1_mask_setting
#define number_of_activations mccchannel_16_cave2_cyl1_number_of_activations
#line 185 "Union_cylinder.comp"
{
// Initializes the focusing system for this volume including input sanitation.
focus_initialize(&this_cylinder_volume.geometry, POS_A_COMP_INDEX(INDEX_CURRENT_COMP+target_index), POS_A_CURRENT_COMP, ROT_A_CURRENT_COMP, target_index, target_x, target_y, target_z, focus_aw, focus_ah, focus_xw, focus_xh, focus_r, NAME_CURRENT_COMP);

// Input sanitation for this geometry
if (radius <= 0) {
  printf("\nERROR in Union_cylinder named %s, the radius is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}

if (yheight <= 0) {
  printf("\nERROR in Union_cylinder named %s, yheight is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}

// Use sanitation
#ifdef MATERIAL_DETECTOR
if (global_material_list.num_elements == 0) {
  // Here if the user have defined a material, but only after this material
  printf("\nERROR: Need to define a material using Union_make_material before using a Union geometry component. \n");
  printf("       %s was defined before first use of Union_make_material.\n",NAME_CURRENT_COMP);
  exit(1);
}
#endif
#ifndef MATERIAL_DETECTOR
  printf("\nERROR: Need to define a material using Union_make_material before using a Union geometry component. \n");
  exit(1);
#endif


this_cylinder_volume.geometry.is_masked_volume = 0;
this_cylinder_volume.geometry.is_exit_volume = 0;
this_cylinder_volume.geometry.is_mask_volume = 0;

// Read the material input, or if it lacks, use automatic linking.
if (mask_string && strlen(mask_string) && strcmp(mask_string, "NULL") && strcmp(mask_string, "0")) {
    // A mask volume is used to limit the extend of other volumes, called the masked volumes. These are specified in the mask_string.
    // In order for a ray to enter a masked volume, it needs to be both in the region covered by that volume AND the mask volume.
    // When more than
    this_cylinder_volume.geometry.mask_mode = 1; // Default is mask mode is ALL
    if (mask_setting && strlen(mask_setting) && strcmp(mask_setting, "NULL") && strcmp(mask_setting, "0")) {
        if (strcmp(mask_setting,"ALL") == 0 || strcmp(mask_setting,"All") == 0) this_cylinder_volume.geometry.mask_mode = 1;
        else if (strcmp(mask_setting,"ANY") == 0 || strcmp(mask_setting,"Any") == 0) this_cylinder_volume.geometry.mask_mode = 2;
        else {
            printf("The mask_mode of component %s is set to %s, but must be either ALL or ANY.\n",NAME_CURRENT_COMP,mask_setting);
            exit(1);
        }
    }
    
    for (loop_index=0;loop_index<global_geometry_list.num_elements;loop_index++) {
        // Add mask list
        if (1 == manual_linking_function(global_geometry_list.elements[loop_index].name,mask_string)) {
            add_element_to_int_list(&this_cylinder_volume.geometry.mask_list,global_geometry_list.elements[loop_index].component_index);
            add_element_to_int_list(&global_geometry_list.elements[loop_index].Volume->geometry.masked_by_list,INDEX_CURRENT_COMP);
            global_geometry_list.elements[loop_index].Volume->geometry.is_masked_volume = 1;
            if (this_cylinder_volume.geometry.mask_mode == 2)
                global_geometry_list.elements[loop_index].Volume->geometry.mask_mode = 2;
            if (this_cylinder_volume.geometry.mask_mode == 1) {
                if (global_geometry_list.elements[loop_index].Volume->geometry.is_masked_volume == 1 && global_geometry_list.elements[loop_index].Volume->geometry.mask_mode != 2)
                    // If more than one mask is added to one volume, the ANY mode overwrites the (default) ALL mode.
                    global_geometry_list.elements[loop_index].Volume->geometry.mask_mode = 1;
            }
            
            found_geometries = 1;
        }
    }
    if (found_geometries == 0) {
        printf("The mask_string in geometry: %s did not find any of the specified volumes in the mask_string %s \n",NAME_CURRENT_COMP,mask_string);
        exit(1);
    }
    this_cylinder_volume.p_physics = malloc(sizeof(struct physics_struct));
    this_cylinder_volume.p_physics->is_vacuum = 0; // Makes this volume a vacuum
    this_cylinder_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
    this_cylinder_volume.p_physics->my_a = 0; // Should not be used.
    sprintf(this_cylinder_volume.p_physics->name,"Mask");
    this_cylinder_volume.geometry.is_mask_volume = 1;
    
    
// Read the material input, or if it lacks, use automatic linking.
} else if (material_string && strlen(material_string) && strcmp(material_string, "NULL") && strcmp(material_string, "0")) {
    // A geometry string was given, use it to determine which material
    if (0 == strcmp(material_string,"vacuum") || 0 == strcmp(material_string,"Vacuum")) {
        // One could have a global physics struct for vacuum instead of creating one for each
        this_cylinder_volume.p_physics = malloc(sizeof(struct physics_struct));
        this_cylinder_volume.p_physics->is_vacuum = 1; // Makes this volume a vacuum
        this_cylinder_volume.p_physics->number_of_processes = (int) 0;
        this_cylinder_volume.p_physics->my_a = 0; // Should not be used.
        sprintf(this_cylinder_volume.p_physics->name,"Vacuum");
    } else if (0 == strcmp(material_string,"exit") || 0 == strcmp(material_string,"Exit")) {
        // One could have a global physics struct for exit instead of creating one for each
        this_cylinder_volume.p_physics = malloc(sizeof(struct physics_struct));
        this_cylinder_volume.p_physics->is_vacuum = 1; // Makes this volume a vacuum
        this_cylinder_volume.p_physics->number_of_processes = (int) 0;
        this_cylinder_volume.p_physics->my_a = 0; // Should not be used.
        this_cylinder_volume.geometry.is_exit_volume = 1;
        sprintf(this_cylinder_volume.p_physics->name,"Exit");
    } else {
        for (loop_index=0;loop_index<global_material_list.num_elements;loop_index++) {
          if (0 == strcmp(material_string,global_material_list.elements[loop_index].name)) {
            this_cylinder_volume.p_physics = global_material_list.elements[loop_index].physics;
            break;
          }
          if (loop_index == global_material_list.num_elements-1) {
            printf("\n");
            printf("ERROR: The material string \"%s\" in Union geometry \"%s\" did not match a specified material. \n",material_string,NAME_CURRENT_COMP);
            printf("       The materials available at this point (need to be defined before the geometry): \n");
            for (loop_index=0;loop_index<global_material_list.num_elements;loop_index++)
              printf("         %s\n",global_material_list.elements[loop_index].name);
            printf("\n");
            printf("       It is also possible to use one of the defualt materials avaiable: \n");
            printf("           Vacuum (for a Volume without scattering or absorption)\n");
            printf("           Exit (for a Volume where the ray exits the component if it enters)\n");
            printf("           Mask (for a Volume that masks existing volumes specified in the mask_string\n");
            exit(1);
          }
        }
    }
} else {
    // Automatic linking, simply using the last defined material.
    #ifndef MATERIAL_DETECTOR
        printf("Need to define a material before the geometry to use automatic linking %s.\n",NAME_CURRENT_COMP);
        exit(1);
    #endif
    this_cylinder_volume.p_physics = global_material_list.elements[global_material_list.num_elements-1].physics;
}

sprintf(this_cylinder_volume.name,NAME_CURRENT_COMP);
sprintf(this_cylinder_volume.geometry.shape,"cylinder");
this_cylinder_volume.geometry.priority_value = priority;
// Currently the coordinates will be in absolute space.
this_cylinder_volume.geometry.center = POS_A_CURRENT_COMP;

this_cylinder_volume.geometry.geometry_p_interact = p_interact;
this_cylinder_storage.cyl_radius = radius;
this_cylinder_storage.height = yheight;
this_cylinder_volume.geometry.visualization_on = visualize;
this_cylinder_volume.geometry.geometry_parameters.p_cylinder_storage = &this_cylinder_storage;
this_cylinder_volume.geometry.within_function = &r_within_cylinder;
this_cylinder_volume.geometry.intersect_function = &sample_cylinder_intersect;
this_cylinder_volume.geometry.mcdisplay_function = &mcdisplay_cylinder_function;
this_cylinder_volume.geometry.shell_points = &cylinder_shell_points;
this_cylinder_volume.geometry.initialize_from_main_function = &initialize_cylinder_geometry_from_main_component;
this_cylinder_volume.geometry.process_rot_allocated = 0;
this_cylinder_volume.geometry.copy_geometry_parameters = &allocate_cylinder_storage_copy;

rot_copy(this_cylinder_volume.geometry.rotation_matrix,ROT_A_CURRENT_COMP);
rot_transpose(ROT_A_CURRENT_COMP,this_cylinder_volume.geometry.transpose_rotation_matrix);

// Initialize loggers
this_cylinder_volume.loggers.num_elements = 0;

// packing the information into the global_geometry_element, which is then included in the global_geometry_list.
sprintf(global_geometry_element.name,NAME_CURRENT_COMP);
global_geometry_element.activation_counter = number_of_activations;
global_geometry_element.component_index = INDEX_CURRENT_COMP;
global_geometry_element.Volume = &this_cylinder_volume; // Would be nicer if this m was a pointer, now we have the (small) data two places
add_element_to_geometry_list(&global_geometry_list,global_geometry_element);
}
#line 311561 "MACS_sample_kidney_box.c"
#undef number_of_activations
#undef mask_setting
#undef mask_string
#undef p_interact
#undef focus_r
#undef focus_xh
#undef focus_xw
#undef focus_ah
#undef focus_aw
#undef target_z
#undef target_y
#undef target_x
#undef target_index
#undef visualize
#undef yheight
#undef radius
#undef priority
#undef material_string
#undef this_cylinder_storage
#undef global_geometry_element
#undef this_cylinder_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

  /* Initializations for component channel_16_cave2_box1. */
  SIG_MESSAGE("channel_16_cave2_box1 (Init)");
#define mccompcurname  channel_16_cave2_box1
#define mccompcurtype  Union_box
#define mccompcurindex 759
#define loop_index mccchannel_16_cave2_box1_loop_index
#define this_box_volume mccchannel_16_cave2_box1_this_box_volume
#define global_geometry_element mccchannel_16_cave2_box1_global_geometry_element
#define this_box_storage mccchannel_16_cave2_box1_this_box_storage
#define material_string mccchannel_16_cave2_box1_material_string
#define priority mccchannel_16_cave2_box1_priority
#define xwidth mccchannel_16_cave2_box1_xwidth
#define yheight mccchannel_16_cave2_box1_yheight
#define zdepth mccchannel_16_cave2_box1_zdepth
#define xwidth2 mccchannel_16_cave2_box1_xwidth2
#define yheight2 mccchannel_16_cave2_box1_yheight2
#define visualize mccchannel_16_cave2_box1_visualize
#define target_index mccchannel_16_cave2_box1_target_index
#define target_x mccchannel_16_cave2_box1_target_x
#define target_y mccchannel_16_cave2_box1_target_y
#define target_z mccchannel_16_cave2_box1_target_z
#define focus_aw mccchannel_16_cave2_box1_focus_aw
#define focus_ah mccchannel_16_cave2_box1_focus_ah
#define focus_xw mccchannel_16_cave2_box1_focus_xw
#define focus_xh mccchannel_16_cave2_box1_focus_xh
#define focus_r mccchannel_16_cave2_box1_focus_r
#define p_interact mccchannel_16_cave2_box1_p_interact
#define mask_string mccchannel_16_cave2_box1_mask_string
#define mask_setting mccchannel_16_cave2_box1_mask_setting
#define number_of_activations mccchannel_16_cave2_box1_number_of_activations
#line 224 "Union_box.comp"
{
// Initializes the focusing system for this volume including input sanitation.
focus_initialize(&this_box_volume.geometry, POS_A_COMP_INDEX(INDEX_CURRENT_COMP+target_index), POS_A_CURRENT_COMP, ROT_A_CURRENT_COMP, target_index, target_x, target_y, target_z, focus_aw, focus_ah, focus_xw, focus_xh, focus_r, NAME_CURRENT_COMP);

// Input sanitation for this geometry
if (xwidth <= 0) {
  printf("\nERROR in Union_box named %s, the xwidth is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (yheight <= 0) {
  printf("\nERROR in Union_box named %s, yheight is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (zdepth <= 0) {
  printf("\nERROR in Union_box named %s, zdepth is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (xwidth2 <= 0 && xwidth2 != -1) {
  printf("\nERROR in Union_box named %s, the xwidth2 is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (yheight2 <= 0 && yheight2 != -1) {
  printf("\nERROR in Union_box named %s, yheight2 is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}

// Use sanitation
if (global_material_list.num_elements == 0) {
  printf("\nERROR: Need to define a material using Union_make_material before using a Union geometry component. \n");
  printf("       %s was defined before first use of Union_make_material.\n",NAME_CURRENT_COMP);
  exit(1);
}

this_box_volume.geometry.is_masked_volume = 0;
this_box_volume.geometry.is_exit_volume = 0;
this_box_volume.geometry.is_mask_volume = 0;
// check if the volume is a mask, if it is the material string is irelevant.
if (mask_string && strlen(mask_string) && strcmp(mask_string, "NULL") && strcmp(mask_string, "0")) {
    // A mask volume is used to limit the extend of other volumes, called the masked volumes. These are specified in the mask_string.
    // In order for a ray to enter a masked volume, it needs to be both in the region covered by that volume AND the mask volume.
    // When more than
    this_box_volume.geometry.mask_mode = 1; // Default is mask mode is ALL
    if (mask_setting && strlen(mask_setting) && strcmp(mask_setting, "NULL") && strcmp(mask_setting, "0")) {
        if (strcmp(mask_setting,"ALL") == 0 || strcmp(mask_setting,"All") == 0) this_box_volume.geometry.mask_mode = 1;
        else if (strcmp(mask_setting,"ANY") == 0 || strcmp(mask_setting,"Any") == 0) this_box_volume.geometry.mask_mode = 2;
        else {
            printf("The mask_mode of component %s is set to %s, but must be either ALL or ANY.\n",NAME_CURRENT_COMP,mask_setting);
            exit(1);
        }
    }
    
    for (loop_index=0;loop_index<global_geometry_list.num_elements;loop_index++) {
        // Add mask list
        if (1 == manual_linking_function(global_geometry_list.elements[loop_index].name,mask_string)) {
            add_element_to_int_list(&this_box_volume.geometry.mask_list,global_geometry_list.elements[loop_index].component_index);
            add_element_to_int_list(&global_geometry_list.elements[loop_index].Volume->geometry.masked_by_list,INDEX_CURRENT_COMP);
            global_geometry_list.elements[loop_index].Volume->geometry.is_masked_volume = 1;
            if (this_box_volume.geometry.mask_mode == 2)
                global_geometry_list.elements[loop_index].Volume->geometry.mask_mode = 2;
            if (this_box_volume.geometry.mask_mode == 1) {
                if (global_geometry_list.elements[loop_index].Volume->geometry.is_masked_volume == 1 && global_geometry_list.elements[loop_index].Volume->geometry.mask_mode != 2)
                    // If more than one mask is added to one volume, the ANY mode overwrites the (default) ALL mode.
                    global_geometry_list.elements[loop_index].Volume->geometry.mask_mode = 1;
            }
            
            found_geometries = 1;
        }
    }
    if (found_geometries == 0) {
        printf("The mask_string in geometry: %s did not find any of the specified volumes in the mask_string %s \n",NAME_CURRENT_COMP,mask_string);
        exit(1);
    }
    this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
    this_box_volume.p_physics->is_vacuum = 0; // Makes this volume a vacuum
    this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
    this_box_volume.p_physics->my_a = 0; // Should not be used.
    sprintf(this_box_volume.p_physics->name,"Mask");
    this_box_volume.geometry.is_mask_volume = 1;
    
    
// Read the material input, or if it lacks, use automatic linking.
} else if (material_string && strlen(material_string) && strcmp(material_string, "NULL") && strcmp(material_string, "0")) {
    // A geometry string was given, use it to determine which material
    if (0 == strcmp(material_string,"vacuum") || 0 == strcmp(material_string,"Vacuum")) {
        // One could have a global physics struct for vacuum instead of creating one for each
        this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
        this_box_volume.p_physics->is_vacuum = 1; // Makes this volume a vacuum
        this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
        this_box_volume.p_physics->my_a = 0; // Should not be used.
        sprintf(this_box_volume.p_physics->name,"Vacuum");
    } else if (0 == strcmp(material_string,"exit") || 0 == strcmp(material_string,"Exit")) {
        // One could have a global physics struct for vacuum instead of creating one for each
        this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
        this_box_volume.p_physics->is_vacuum = 1; // Makes this volume a vacuum
        this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
        this_box_volume.p_physics->my_a = 0; // Should not be used.
        this_box_volume.geometry.is_exit_volume = 1;
        sprintf(this_box_volume.p_physics->name,"Exit");
    } else {
        #ifndef MATERIAL_DETECTOR
            printf("Need to define a material before refering to it in a geometry %s.\n",NAME_CURRENT_COMP);
            exit(1);
        #endif
        for (loop_index=0;loop_index<global_material_list.num_elements;loop_index++) {
            if (0 == strcmp(material_string,global_material_list.elements[loop_index].name)) {
                this_box_volume.p_physics = global_material_list.elements[loop_index].physics;
                break;
            }
            if (loop_index == global_material_list.num_elements-1) {
            printf("\n");
            printf("ERROR: The material string \"%s\" in Union geometry \"%s\" did not match a specified material. \n",material_string,NAME_CURRENT_COMP);
            printf("       The materials available at this point (need to be defined before the geometry): \n");
            for (loop_index=0;loop_index<global_material_list.num_elements;loop_index++)
              printf("         %s\n",global_material_list.elements[loop_index].name);
            printf("\n");
            printf("       It is also possible to use one of the defualt materials avaiable: \n");
            printf("           Vacuum (for a Volume without scattering or absorption)\n");
            printf("           Exit (for a Volume where the ray exits the component if it enters)\n");
            printf("           Mask (for a Volume that masks existing volumes specified in the mask_string\n");
            exit(1);
          }
        }
    }
} else {
    // Automatic linking, simply using the last defined material.
    #ifndef MATERIAL_DETECTOR
        printf("Need to define a material before the geometry to use automatic linking %s.\n",NAME_CURRENT_COMP);
        exit(1);
    #endif
    this_box_volume.p_physics = global_material_list.elements[global_material_list.num_elements-1].physics;
}

sprintf(this_box_volume.name,NAME_CURRENT_COMP);
sprintf(this_box_volume.geometry.shape,"box");
this_box_volume.geometry.priority_value = priority;
this_box_volume.geometry.geometry_p_interact = p_interact;
// Currently the coordinates will be in absolute space.
this_box_volume.geometry.center = POS_A_CURRENT_COMP;

this_box_storage.z_depth = zdepth;
this_box_storage.x_width1 = xwidth;
this_box_storage.y_height1 = yheight;

this_box_storage.is_rectangle = 0;
if (xwidth2 < 0 && yheight2 < 0) this_box_storage.is_rectangle = 1;
if (xwidth == xwidth2 && yheight == yheight2) this_box_storage.is_rectangle = 1;

if (xwidth2 < 0) {
    this_box_storage.x_width2 = xwidth;
    xwidth2 = xwidth;
} else this_box_storage.x_width2 = xwidth2;

if (yheight2 < 0) {
    this_box_storage.y_height2 = yheight;
    yheight2 = yheight;
} else this_box_storage.y_height2 = yheight2;


this_box_storage.normal_vectors[0] = coords_set(0,0,1);
this_box_storage.normal_vectors[1] = coords_set(0,0,1);

// for sides with y component = 0
x_component = 2*zdepth/sqrt((xwidth-xwidth2)*(xwidth-xwidth2)+4*zdepth*zdepth);
z_component = (xwidth-xwidth2)/sqrt(4*zdepth*zdepth+(xwidth-xwidth2)*(xwidth-xwidth2));

this_box_storage.normal_vectors[2] = coords_set(x_component,0,z_component);
this_box_storage.normal_vectors[3] = coords_set(-x_component,0,z_component);

// for sides with x component = 0
y_component = 2*zdepth/sqrt((yheight-yheight2)*(yheight-yheight2)+4*zdepth*zdepth);
z_component = (yheight-yheight2)/sqrt(4*zdepth*zdepth+(yheight-yheight2)*(yheight-yheight2));

this_box_storage.normal_vectors[4] = coords_set(0,y_component,z_component);
this_box_storage.normal_vectors[5] = coords_set(0,-y_component,z_component);

this_box_volume.geometry.visualization_on = visualize;

this_box_volume.geometry.geometry_parameters.p_box_storage = &this_box_storage;

// Assign pointers to functions for intersection with the shape, checking if a point is inside the shape
if (this_box_storage.is_rectangle == 1) {
this_box_volume.geometry.intersect_function = &sample_box_intersect_simple;
this_box_volume.geometry.within_function = &r_within_box_simple;
}
else {
this_box_volume.geometry.intersect_function = &sample_box_intersect_advanced;
this_box_volume.geometry.within_function = &r_within_box_advanced;
}

this_box_volume.geometry.shell_points = &box_shell_points;
this_box_volume.geometry.mcdisplay_function = &mcdisplay_box_function;
this_box_volume.geometry.initialize_from_main_function = &initialize_box_geometry_from_main_component;
this_box_volume.geometry.process_rot_allocated = 0;

this_box_volume.geometry.copy_geometry_parameters = &allocate_box_storage_copy;

rot_copy(this_box_volume.geometry.rotation_matrix,ROT_A_CURRENT_COMP); //check how ROT_R_CURRENT_COMP would work
rot_transpose(ROT_A_CURRENT_COMP,this_box_volume.geometry.transpose_rotation_matrix);

// Initialize loggers
this_box_volume.loggers.num_elements = 0;

// packing the information into the global_geometry_element, which is then included in the global_geometry_list.
sprintf(global_geometry_element.name,NAME_CURRENT_COMP);
global_geometry_element.activation_counter = number_of_activations;
global_geometry_element.component_index = INDEX_CURRENT_COMP;
global_geometry_element.Volume = &this_box_volume; // Would be nicer if this m was a pointer, now we have the (small) data two places
add_element_to_geometry_list(&global_geometry_list,global_geometry_element);
}
#line 311828 "MACS_sample_kidney_box.c"
#undef number_of_activations
#undef mask_setting
#undef mask_string
#undef p_interact
#undef focus_r
#undef focus_xh
#undef focus_xw
#undef focus_ah
#undef focus_aw
#undef target_z
#undef target_y
#undef target_x
#undef target_index
#undef visualize
#undef yheight2
#undef xwidth2
#undef zdepth
#undef yheight
#undef xwidth
#undef priority
#undef material_string
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

  /* Initializations for component channel_16_cave2_box2. */
  SIG_MESSAGE("channel_16_cave2_box2 (Init)");
#define mccompcurname  channel_16_cave2_box2
#define mccompcurtype  Union_box
#define mccompcurindex 760
#define loop_index mccchannel_16_cave2_box2_loop_index
#define this_box_volume mccchannel_16_cave2_box2_this_box_volume
#define global_geometry_element mccchannel_16_cave2_box2_global_geometry_element
#define this_box_storage mccchannel_16_cave2_box2_this_box_storage
#define material_string mccchannel_16_cave2_box2_material_string
#define priority mccchannel_16_cave2_box2_priority
#define xwidth mccchannel_16_cave2_box2_xwidth
#define yheight mccchannel_16_cave2_box2_yheight
#define zdepth mccchannel_16_cave2_box2_zdepth
#define xwidth2 mccchannel_16_cave2_box2_xwidth2
#define yheight2 mccchannel_16_cave2_box2_yheight2
#define visualize mccchannel_16_cave2_box2_visualize
#define target_index mccchannel_16_cave2_box2_target_index
#define target_x mccchannel_16_cave2_box2_target_x
#define target_y mccchannel_16_cave2_box2_target_y
#define target_z mccchannel_16_cave2_box2_target_z
#define focus_aw mccchannel_16_cave2_box2_focus_aw
#define focus_ah mccchannel_16_cave2_box2_focus_ah
#define focus_xw mccchannel_16_cave2_box2_focus_xw
#define focus_xh mccchannel_16_cave2_box2_focus_xh
#define focus_r mccchannel_16_cave2_box2_focus_r
#define p_interact mccchannel_16_cave2_box2_p_interact
#define mask_string mccchannel_16_cave2_box2_mask_string
#define mask_setting mccchannel_16_cave2_box2_mask_setting
#define number_of_activations mccchannel_16_cave2_box2_number_of_activations
#line 224 "Union_box.comp"
{
// Initializes the focusing system for this volume including input sanitation.
focus_initialize(&this_box_volume.geometry, POS_A_COMP_INDEX(INDEX_CURRENT_COMP+target_index), POS_A_CURRENT_COMP, ROT_A_CURRENT_COMP, target_index, target_x, target_y, target_z, focus_aw, focus_ah, focus_xw, focus_xh, focus_r, NAME_CURRENT_COMP);

// Input sanitation for this geometry
if (xwidth <= 0) {
  printf("\nERROR in Union_box named %s, the xwidth is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (yheight <= 0) {
  printf("\nERROR in Union_box named %s, yheight is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (zdepth <= 0) {
  printf("\nERROR in Union_box named %s, zdepth is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (xwidth2 <= 0 && xwidth2 != -1) {
  printf("\nERROR in Union_box named %s, the xwidth2 is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (yheight2 <= 0 && yheight2 != -1) {
  printf("\nERROR in Union_box named %s, yheight2 is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}

// Use sanitation
if (global_material_list.num_elements == 0) {
  printf("\nERROR: Need to define a material using Union_make_material before using a Union geometry component. \n");
  printf("       %s was defined before first use of Union_make_material.\n",NAME_CURRENT_COMP);
  exit(1);
}

this_box_volume.geometry.is_masked_volume = 0;
this_box_volume.geometry.is_exit_volume = 0;
this_box_volume.geometry.is_mask_volume = 0;
// check if the volume is a mask, if it is the material string is irelevant.
if (mask_string && strlen(mask_string) && strcmp(mask_string, "NULL") && strcmp(mask_string, "0")) {
    // A mask volume is used to limit the extend of other volumes, called the masked volumes. These are specified in the mask_string.
    // In order for a ray to enter a masked volume, it needs to be both in the region covered by that volume AND the mask volume.
    // When more than
    this_box_volume.geometry.mask_mode = 1; // Default is mask mode is ALL
    if (mask_setting && strlen(mask_setting) && strcmp(mask_setting, "NULL") && strcmp(mask_setting, "0")) {
        if (strcmp(mask_setting,"ALL") == 0 || strcmp(mask_setting,"All") == 0) this_box_volume.geometry.mask_mode = 1;
        else if (strcmp(mask_setting,"ANY") == 0 || strcmp(mask_setting,"Any") == 0) this_box_volume.geometry.mask_mode = 2;
        else {
            printf("The mask_mode of component %s is set to %s, but must be either ALL or ANY.\n",NAME_CURRENT_COMP,mask_setting);
            exit(1);
        }
    }
    
    for (loop_index=0;loop_index<global_geometry_list.num_elements;loop_index++) {
        // Add mask list
        if (1 == manual_linking_function(global_geometry_list.elements[loop_index].name,mask_string)) {
            add_element_to_int_list(&this_box_volume.geometry.mask_list,global_geometry_list.elements[loop_index].component_index);
            add_element_to_int_list(&global_geometry_list.elements[loop_index].Volume->geometry.masked_by_list,INDEX_CURRENT_COMP);
            global_geometry_list.elements[loop_index].Volume->geometry.is_masked_volume = 1;
            if (this_box_volume.geometry.mask_mode == 2)
                global_geometry_list.elements[loop_index].Volume->geometry.mask_mode = 2;
            if (this_box_volume.geometry.mask_mode == 1) {
                if (global_geometry_list.elements[loop_index].Volume->geometry.is_masked_volume == 1 && global_geometry_list.elements[loop_index].Volume->geometry.mask_mode != 2)
                    // If more than one mask is added to one volume, the ANY mode overwrites the (default) ALL mode.
                    global_geometry_list.elements[loop_index].Volume->geometry.mask_mode = 1;
            }
            
            found_geometries = 1;
        }
    }
    if (found_geometries == 0) {
        printf("The mask_string in geometry: %s did not find any of the specified volumes in the mask_string %s \n",NAME_CURRENT_COMP,mask_string);
        exit(1);
    }
    this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
    this_box_volume.p_physics->is_vacuum = 0; // Makes this volume a vacuum
    this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
    this_box_volume.p_physics->my_a = 0; // Should not be used.
    sprintf(this_box_volume.p_physics->name,"Mask");
    this_box_volume.geometry.is_mask_volume = 1;
    
    
// Read the material input, or if it lacks, use automatic linking.
} else if (material_string && strlen(material_string) && strcmp(material_string, "NULL") && strcmp(material_string, "0")) {
    // A geometry string was given, use it to determine which material
    if (0 == strcmp(material_string,"vacuum") || 0 == strcmp(material_string,"Vacuum")) {
        // One could have a global physics struct for vacuum instead of creating one for each
        this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
        this_box_volume.p_physics->is_vacuum = 1; // Makes this volume a vacuum
        this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
        this_box_volume.p_physics->my_a = 0; // Should not be used.
        sprintf(this_box_volume.p_physics->name,"Vacuum");
    } else if (0 == strcmp(material_string,"exit") || 0 == strcmp(material_string,"Exit")) {
        // One could have a global physics struct for vacuum instead of creating one for each
        this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
        this_box_volume.p_physics->is_vacuum = 1; // Makes this volume a vacuum
        this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
        this_box_volume.p_physics->my_a = 0; // Should not be used.
        this_box_volume.geometry.is_exit_volume = 1;
        sprintf(this_box_volume.p_physics->name,"Exit");
    } else {
        #ifndef MATERIAL_DETECTOR
            printf("Need to define a material before refering to it in a geometry %s.\n",NAME_CURRENT_COMP);
            exit(1);
        #endif
        for (loop_index=0;loop_index<global_material_list.num_elements;loop_index++) {
            if (0 == strcmp(material_string,global_material_list.elements[loop_index].name)) {
                this_box_volume.p_physics = global_material_list.elements[loop_index].physics;
                break;
            }
            if (loop_index == global_material_list.num_elements-1) {
            printf("\n");
            printf("ERROR: The material string \"%s\" in Union geometry \"%s\" did not match a specified material. \n",material_string,NAME_CURRENT_COMP);
            printf("       The materials available at this point (need to be defined before the geometry): \n");
            for (loop_index=0;loop_index<global_material_list.num_elements;loop_index++)
              printf("         %s\n",global_material_list.elements[loop_index].name);
            printf("\n");
            printf("       It is also possible to use one of the defualt materials avaiable: \n");
            printf("           Vacuum (for a Volume without scattering or absorption)\n");
            printf("           Exit (for a Volume where the ray exits the component if it enters)\n");
            printf("           Mask (for a Volume that masks existing volumes specified in the mask_string\n");
            exit(1);
          }
        }
    }
} else {
    // Automatic linking, simply using the last defined material.
    #ifndef MATERIAL_DETECTOR
        printf("Need to define a material before the geometry to use automatic linking %s.\n",NAME_CURRENT_COMP);
        exit(1);
    #endif
    this_box_volume.p_physics = global_material_list.elements[global_material_list.num_elements-1].physics;
}

sprintf(this_box_volume.name,NAME_CURRENT_COMP);
sprintf(this_box_volume.geometry.shape,"box");
this_box_volume.geometry.priority_value = priority;
this_box_volume.geometry.geometry_p_interact = p_interact;
// Currently the coordinates will be in absolute space.
this_box_volume.geometry.center = POS_A_CURRENT_COMP;

this_box_storage.z_depth = zdepth;
this_box_storage.x_width1 = xwidth;
this_box_storage.y_height1 = yheight;

this_box_storage.is_rectangle = 0;
if (xwidth2 < 0 && yheight2 < 0) this_box_storage.is_rectangle = 1;
if (xwidth == xwidth2 && yheight == yheight2) this_box_storage.is_rectangle = 1;

if (xwidth2 < 0) {
    this_box_storage.x_width2 = xwidth;
    xwidth2 = xwidth;
} else this_box_storage.x_width2 = xwidth2;

if (yheight2 < 0) {
    this_box_storage.y_height2 = yheight;
    yheight2 = yheight;
} else this_box_storage.y_height2 = yheight2;


this_box_storage.normal_vectors[0] = coords_set(0,0,1);
this_box_storage.normal_vectors[1] = coords_set(0,0,1);

// for sides with y component = 0
x_component = 2*zdepth/sqrt((xwidth-xwidth2)*(xwidth-xwidth2)+4*zdepth*zdepth);
z_component = (xwidth-xwidth2)/sqrt(4*zdepth*zdepth+(xwidth-xwidth2)*(xwidth-xwidth2));

this_box_storage.normal_vectors[2] = coords_set(x_component,0,z_component);
this_box_storage.normal_vectors[3] = coords_set(-x_component,0,z_component);

// for sides with x component = 0
y_component = 2*zdepth/sqrt((yheight-yheight2)*(yheight-yheight2)+4*zdepth*zdepth);
z_component = (yheight-yheight2)/sqrt(4*zdepth*zdepth+(yheight-yheight2)*(yheight-yheight2));

this_box_storage.normal_vectors[4] = coords_set(0,y_component,z_component);
this_box_storage.normal_vectors[5] = coords_set(0,-y_component,z_component);

this_box_volume.geometry.visualization_on = visualize;

this_box_volume.geometry.geometry_parameters.p_box_storage = &this_box_storage;

// Assign pointers to functions for intersection with the shape, checking if a point is inside the shape
if (this_box_storage.is_rectangle == 1) {
this_box_volume.geometry.intersect_function = &sample_box_intersect_simple;
this_box_volume.geometry.within_function = &r_within_box_simple;
}
else {
this_box_volume.geometry.intersect_function = &sample_box_intersect_advanced;
this_box_volume.geometry.within_function = &r_within_box_advanced;
}

this_box_volume.geometry.shell_points = &box_shell_points;
this_box_volume.geometry.mcdisplay_function = &mcdisplay_box_function;
this_box_volume.geometry.initialize_from_main_function = &initialize_box_geometry_from_main_component;
this_box_volume.geometry.process_rot_allocated = 0;

this_box_volume.geometry.copy_geometry_parameters = &allocate_box_storage_copy;

rot_copy(this_box_volume.geometry.rotation_matrix,ROT_A_CURRENT_COMP); //check how ROT_R_CURRENT_COMP would work
rot_transpose(ROT_A_CURRENT_COMP,this_box_volume.geometry.transpose_rotation_matrix);

// Initialize loggers
this_box_volume.loggers.num_elements = 0;

// packing the information into the global_geometry_element, which is then included in the global_geometry_list.
sprintf(global_geometry_element.name,NAME_CURRENT_COMP);
global_geometry_element.activation_counter = number_of_activations;
global_geometry_element.component_index = INDEX_CURRENT_COMP;
global_geometry_element.Volume = &this_box_volume; // Would be nicer if this m was a pointer, now we have the (small) data two places
add_element_to_geometry_list(&global_geometry_list,global_geometry_element);
}
#line 312098 "MACS_sample_kidney_box.c"
#undef number_of_activations
#undef mask_setting
#undef mask_string
#undef p_interact
#undef focus_r
#undef focus_xh
#undef focus_xw
#undef focus_ah
#undef focus_aw
#undef target_z
#undef target_y
#undef target_x
#undef target_index
#undef visualize
#undef yheight2
#undef xwidth2
#undef zdepth
#undef yheight
#undef xwidth
#undef priority
#undef material_string
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

  /* Initializations for component channel_16_cave2_box3. */
  SIG_MESSAGE("channel_16_cave2_box3 (Init)");
#define mccompcurname  channel_16_cave2_box3
#define mccompcurtype  Union_box
#define mccompcurindex 761
#define loop_index mccchannel_16_cave2_box3_loop_index
#define this_box_volume mccchannel_16_cave2_box3_this_box_volume
#define global_geometry_element mccchannel_16_cave2_box3_global_geometry_element
#define this_box_storage mccchannel_16_cave2_box3_this_box_storage
#define material_string mccchannel_16_cave2_box3_material_string
#define priority mccchannel_16_cave2_box3_priority
#define xwidth mccchannel_16_cave2_box3_xwidth
#define yheight mccchannel_16_cave2_box3_yheight
#define zdepth mccchannel_16_cave2_box3_zdepth
#define xwidth2 mccchannel_16_cave2_box3_xwidth2
#define yheight2 mccchannel_16_cave2_box3_yheight2
#define visualize mccchannel_16_cave2_box3_visualize
#define target_index mccchannel_16_cave2_box3_target_index
#define target_x mccchannel_16_cave2_box3_target_x
#define target_y mccchannel_16_cave2_box3_target_y
#define target_z mccchannel_16_cave2_box3_target_z
#define focus_aw mccchannel_16_cave2_box3_focus_aw
#define focus_ah mccchannel_16_cave2_box3_focus_ah
#define focus_xw mccchannel_16_cave2_box3_focus_xw
#define focus_xh mccchannel_16_cave2_box3_focus_xh
#define focus_r mccchannel_16_cave2_box3_focus_r
#define p_interact mccchannel_16_cave2_box3_p_interact
#define mask_string mccchannel_16_cave2_box3_mask_string
#define mask_setting mccchannel_16_cave2_box3_mask_setting
#define number_of_activations mccchannel_16_cave2_box3_number_of_activations
#line 224 "Union_box.comp"
{
// Initializes the focusing system for this volume including input sanitation.
focus_initialize(&this_box_volume.geometry, POS_A_COMP_INDEX(INDEX_CURRENT_COMP+target_index), POS_A_CURRENT_COMP, ROT_A_CURRENT_COMP, target_index, target_x, target_y, target_z, focus_aw, focus_ah, focus_xw, focus_xh, focus_r, NAME_CURRENT_COMP);

// Input sanitation for this geometry
if (xwidth <= 0) {
  printf("\nERROR in Union_box named %s, the xwidth is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (yheight <= 0) {
  printf("\nERROR in Union_box named %s, yheight is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (zdepth <= 0) {
  printf("\nERROR in Union_box named %s, zdepth is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (xwidth2 <= 0 && xwidth2 != -1) {
  printf("\nERROR in Union_box named %s, the xwidth2 is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (yheight2 <= 0 && yheight2 != -1) {
  printf("\nERROR in Union_box named %s, yheight2 is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}

// Use sanitation
if (global_material_list.num_elements == 0) {
  printf("\nERROR: Need to define a material using Union_make_material before using a Union geometry component. \n");
  printf("       %s was defined before first use of Union_make_material.\n",NAME_CURRENT_COMP);
  exit(1);
}

this_box_volume.geometry.is_masked_volume = 0;
this_box_volume.geometry.is_exit_volume = 0;
this_box_volume.geometry.is_mask_volume = 0;
// check if the volume is a mask, if it is the material string is irelevant.
if (mask_string && strlen(mask_string) && strcmp(mask_string, "NULL") && strcmp(mask_string, "0")) {
    // A mask volume is used to limit the extend of other volumes, called the masked volumes. These are specified in the mask_string.
    // In order for a ray to enter a masked volume, it needs to be both in the region covered by that volume AND the mask volume.
    // When more than
    this_box_volume.geometry.mask_mode = 1; // Default is mask mode is ALL
    if (mask_setting && strlen(mask_setting) && strcmp(mask_setting, "NULL") && strcmp(mask_setting, "0")) {
        if (strcmp(mask_setting,"ALL") == 0 || strcmp(mask_setting,"All") == 0) this_box_volume.geometry.mask_mode = 1;
        else if (strcmp(mask_setting,"ANY") == 0 || strcmp(mask_setting,"Any") == 0) this_box_volume.geometry.mask_mode = 2;
        else {
            printf("The mask_mode of component %s is set to %s, but must be either ALL or ANY.\n",NAME_CURRENT_COMP,mask_setting);
            exit(1);
        }
    }
    
    for (loop_index=0;loop_index<global_geometry_list.num_elements;loop_index++) {
        // Add mask list
        if (1 == manual_linking_function(global_geometry_list.elements[loop_index].name,mask_string)) {
            add_element_to_int_list(&this_box_volume.geometry.mask_list,global_geometry_list.elements[loop_index].component_index);
            add_element_to_int_list(&global_geometry_list.elements[loop_index].Volume->geometry.masked_by_list,INDEX_CURRENT_COMP);
            global_geometry_list.elements[loop_index].Volume->geometry.is_masked_volume = 1;
            if (this_box_volume.geometry.mask_mode == 2)
                global_geometry_list.elements[loop_index].Volume->geometry.mask_mode = 2;
            if (this_box_volume.geometry.mask_mode == 1) {
                if (global_geometry_list.elements[loop_index].Volume->geometry.is_masked_volume == 1 && global_geometry_list.elements[loop_index].Volume->geometry.mask_mode != 2)
                    // If more than one mask is added to one volume, the ANY mode overwrites the (default) ALL mode.
                    global_geometry_list.elements[loop_index].Volume->geometry.mask_mode = 1;
            }
            
            found_geometries = 1;
        }
    }
    if (found_geometries == 0) {
        printf("The mask_string in geometry: %s did not find any of the specified volumes in the mask_string %s \n",NAME_CURRENT_COMP,mask_string);
        exit(1);
    }
    this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
    this_box_volume.p_physics->is_vacuum = 0; // Makes this volume a vacuum
    this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
    this_box_volume.p_physics->my_a = 0; // Should not be used.
    sprintf(this_box_volume.p_physics->name,"Mask");
    this_box_volume.geometry.is_mask_volume = 1;
    
    
// Read the material input, or if it lacks, use automatic linking.
} else if (material_string && strlen(material_string) && strcmp(material_string, "NULL") && strcmp(material_string, "0")) {
    // A geometry string was given, use it to determine which material
    if (0 == strcmp(material_string,"vacuum") || 0 == strcmp(material_string,"Vacuum")) {
        // One could have a global physics struct for vacuum instead of creating one for each
        this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
        this_box_volume.p_physics->is_vacuum = 1; // Makes this volume a vacuum
        this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
        this_box_volume.p_physics->my_a = 0; // Should not be used.
        sprintf(this_box_volume.p_physics->name,"Vacuum");
    } else if (0 == strcmp(material_string,"exit") || 0 == strcmp(material_string,"Exit")) {
        // One could have a global physics struct for vacuum instead of creating one for each
        this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
        this_box_volume.p_physics->is_vacuum = 1; // Makes this volume a vacuum
        this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
        this_box_volume.p_physics->my_a = 0; // Should not be used.
        this_box_volume.geometry.is_exit_volume = 1;
        sprintf(this_box_volume.p_physics->name,"Exit");
    } else {
        #ifndef MATERIAL_DETECTOR
            printf("Need to define a material before refering to it in a geometry %s.\n",NAME_CURRENT_COMP);
            exit(1);
        #endif
        for (loop_index=0;loop_index<global_material_list.num_elements;loop_index++) {
            if (0 == strcmp(material_string,global_material_list.elements[loop_index].name)) {
                this_box_volume.p_physics = global_material_list.elements[loop_index].physics;
                break;
            }
            if (loop_index == global_material_list.num_elements-1) {
            printf("\n");
            printf("ERROR: The material string \"%s\" in Union geometry \"%s\" did not match a specified material. \n",material_string,NAME_CURRENT_COMP);
            printf("       The materials available at this point (need to be defined before the geometry): \n");
            for (loop_index=0;loop_index<global_material_list.num_elements;loop_index++)
              printf("         %s\n",global_material_list.elements[loop_index].name);
            printf("\n");
            printf("       It is also possible to use one of the defualt materials avaiable: \n");
            printf("           Vacuum (for a Volume without scattering or absorption)\n");
            printf("           Exit (for a Volume where the ray exits the component if it enters)\n");
            printf("           Mask (for a Volume that masks existing volumes specified in the mask_string\n");
            exit(1);
          }
        }
    }
} else {
    // Automatic linking, simply using the last defined material.
    #ifndef MATERIAL_DETECTOR
        printf("Need to define a material before the geometry to use automatic linking %s.\n",NAME_CURRENT_COMP);
        exit(1);
    #endif
    this_box_volume.p_physics = global_material_list.elements[global_material_list.num_elements-1].physics;
}

sprintf(this_box_volume.name,NAME_CURRENT_COMP);
sprintf(this_box_volume.geometry.shape,"box");
this_box_volume.geometry.priority_value = priority;
this_box_volume.geometry.geometry_p_interact = p_interact;
// Currently the coordinates will be in absolute space.
this_box_volume.geometry.center = POS_A_CURRENT_COMP;

this_box_storage.z_depth = zdepth;
this_box_storage.x_width1 = xwidth;
this_box_storage.y_height1 = yheight;

this_box_storage.is_rectangle = 0;
if (xwidth2 < 0 && yheight2 < 0) this_box_storage.is_rectangle = 1;
if (xwidth == xwidth2 && yheight == yheight2) this_box_storage.is_rectangle = 1;

if (xwidth2 < 0) {
    this_box_storage.x_width2 = xwidth;
    xwidth2 = xwidth;
} else this_box_storage.x_width2 = xwidth2;

if (yheight2 < 0) {
    this_box_storage.y_height2 = yheight;
    yheight2 = yheight;
} else this_box_storage.y_height2 = yheight2;


this_box_storage.normal_vectors[0] = coords_set(0,0,1);
this_box_storage.normal_vectors[1] = coords_set(0,0,1);

// for sides with y component = 0
x_component = 2*zdepth/sqrt((xwidth-xwidth2)*(xwidth-xwidth2)+4*zdepth*zdepth);
z_component = (xwidth-xwidth2)/sqrt(4*zdepth*zdepth+(xwidth-xwidth2)*(xwidth-xwidth2));

this_box_storage.normal_vectors[2] = coords_set(x_component,0,z_component);
this_box_storage.normal_vectors[3] = coords_set(-x_component,0,z_component);

// for sides with x component = 0
y_component = 2*zdepth/sqrt((yheight-yheight2)*(yheight-yheight2)+4*zdepth*zdepth);
z_component = (yheight-yheight2)/sqrt(4*zdepth*zdepth+(yheight-yheight2)*(yheight-yheight2));

this_box_storage.normal_vectors[4] = coords_set(0,y_component,z_component);
this_box_storage.normal_vectors[5] = coords_set(0,-y_component,z_component);

this_box_volume.geometry.visualization_on = visualize;

this_box_volume.geometry.geometry_parameters.p_box_storage = &this_box_storage;

// Assign pointers to functions for intersection with the shape, checking if a point is inside the shape
if (this_box_storage.is_rectangle == 1) {
this_box_volume.geometry.intersect_function = &sample_box_intersect_simple;
this_box_volume.geometry.within_function = &r_within_box_simple;
}
else {
this_box_volume.geometry.intersect_function = &sample_box_intersect_advanced;
this_box_volume.geometry.within_function = &r_within_box_advanced;
}

this_box_volume.geometry.shell_points = &box_shell_points;
this_box_volume.geometry.mcdisplay_function = &mcdisplay_box_function;
this_box_volume.geometry.initialize_from_main_function = &initialize_box_geometry_from_main_component;
this_box_volume.geometry.process_rot_allocated = 0;

this_box_volume.geometry.copy_geometry_parameters = &allocate_box_storage_copy;

rot_copy(this_box_volume.geometry.rotation_matrix,ROT_A_CURRENT_COMP); //check how ROT_R_CURRENT_COMP would work
rot_transpose(ROT_A_CURRENT_COMP,this_box_volume.geometry.transpose_rotation_matrix);

// Initialize loggers
this_box_volume.loggers.num_elements = 0;

// packing the information into the global_geometry_element, which is then included in the global_geometry_list.
sprintf(global_geometry_element.name,NAME_CURRENT_COMP);
global_geometry_element.activation_counter = number_of_activations;
global_geometry_element.component_index = INDEX_CURRENT_COMP;
global_geometry_element.Volume = &this_box_volume; // Would be nicer if this m was a pointer, now we have the (small) data two places
add_element_to_geometry_list(&global_geometry_list,global_geometry_element);
}
#line 312368 "MACS_sample_kidney_box.c"
#undef number_of_activations
#undef mask_setting
#undef mask_string
#undef p_interact
#undef focus_r
#undef focus_xh
#undef focus_xw
#undef focus_ah
#undef focus_aw
#undef target_z
#undef target_y
#undef target_x
#undef target_index
#undef visualize
#undef yheight2
#undef xwidth2
#undef zdepth
#undef yheight
#undef xwidth
#undef priority
#undef material_string
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

  /* Initializations for component inter_analyzer_colimator_center_16. */
  SIG_MESSAGE("inter_analyzer_colimator_center_16 (Init)");

  /* Initializations for component inter_analyzer_colimator_16_blade_0. */
  SIG_MESSAGE("inter_analyzer_colimator_16_blade_0 (Init)");
#define mccompcurname  inter_analyzer_colimator_16_blade_0
#define mccompcurtype  Union_box
#define mccompcurindex 763
#define loop_index mccinter_analyzer_colimator_16_blade_0_loop_index
#define this_box_volume mccinter_analyzer_colimator_16_blade_0_this_box_volume
#define global_geometry_element mccinter_analyzer_colimator_16_blade_0_global_geometry_element
#define this_box_storage mccinter_analyzer_colimator_16_blade_0_this_box_storage
#define material_string mccinter_analyzer_colimator_16_blade_0_material_string
#define priority mccinter_analyzer_colimator_16_blade_0_priority
#define xwidth mccinter_analyzer_colimator_16_blade_0_xwidth
#define yheight mccinter_analyzer_colimator_16_blade_0_yheight
#define zdepth mccinter_analyzer_colimator_16_blade_0_zdepth
#define xwidth2 mccinter_analyzer_colimator_16_blade_0_xwidth2
#define yheight2 mccinter_analyzer_colimator_16_blade_0_yheight2
#define visualize mccinter_analyzer_colimator_16_blade_0_visualize
#define target_index mccinter_analyzer_colimator_16_blade_0_target_index
#define target_x mccinter_analyzer_colimator_16_blade_0_target_x
#define target_y mccinter_analyzer_colimator_16_blade_0_target_y
#define target_z mccinter_analyzer_colimator_16_blade_0_target_z
#define focus_aw mccinter_analyzer_colimator_16_blade_0_focus_aw
#define focus_ah mccinter_analyzer_colimator_16_blade_0_focus_ah
#define focus_xw mccinter_analyzer_colimator_16_blade_0_focus_xw
#define focus_xh mccinter_analyzer_colimator_16_blade_0_focus_xh
#define focus_r mccinter_analyzer_colimator_16_blade_0_focus_r
#define p_interact mccinter_analyzer_colimator_16_blade_0_p_interact
#define mask_string mccinter_analyzer_colimator_16_blade_0_mask_string
#define mask_setting mccinter_analyzer_colimator_16_blade_0_mask_setting
#define number_of_activations mccinter_analyzer_colimator_16_blade_0_number_of_activations
#line 224 "Union_box.comp"
{
// Initializes the focusing system for this volume including input sanitation.
focus_initialize(&this_box_volume.geometry, POS_A_COMP_INDEX(INDEX_CURRENT_COMP+target_index), POS_A_CURRENT_COMP, ROT_A_CURRENT_COMP, target_index, target_x, target_y, target_z, focus_aw, focus_ah, focus_xw, focus_xh, focus_r, NAME_CURRENT_COMP);

// Input sanitation for this geometry
if (xwidth <= 0) {
  printf("\nERROR in Union_box named %s, the xwidth is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (yheight <= 0) {
  printf("\nERROR in Union_box named %s, yheight is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (zdepth <= 0) {
  printf("\nERROR in Union_box named %s, zdepth is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (xwidth2 <= 0 && xwidth2 != -1) {
  printf("\nERROR in Union_box named %s, the xwidth2 is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (yheight2 <= 0 && yheight2 != -1) {
  printf("\nERROR in Union_box named %s, yheight2 is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}

// Use sanitation
if (global_material_list.num_elements == 0) {
  printf("\nERROR: Need to define a material using Union_make_material before using a Union geometry component. \n");
  printf("       %s was defined before first use of Union_make_material.\n",NAME_CURRENT_COMP);
  exit(1);
}

this_box_volume.geometry.is_masked_volume = 0;
this_box_volume.geometry.is_exit_volume = 0;
this_box_volume.geometry.is_mask_volume = 0;
// check if the volume is a mask, if it is the material string is irelevant.
if (mask_string && strlen(mask_string) && strcmp(mask_string, "NULL") && strcmp(mask_string, "0")) {
    // A mask volume is used to limit the extend of other volumes, called the masked volumes. These are specified in the mask_string.
    // In order for a ray to enter a masked volume, it needs to be both in the region covered by that volume AND the mask volume.
    // When more than
    this_box_volume.geometry.mask_mode = 1; // Default is mask mode is ALL
    if (mask_setting && strlen(mask_setting) && strcmp(mask_setting, "NULL") && strcmp(mask_setting, "0")) {
        if (strcmp(mask_setting,"ALL") == 0 || strcmp(mask_setting,"All") == 0) this_box_volume.geometry.mask_mode = 1;
        else if (strcmp(mask_setting,"ANY") == 0 || strcmp(mask_setting,"Any") == 0) this_box_volume.geometry.mask_mode = 2;
        else {
            printf("The mask_mode of component %s is set to %s, but must be either ALL or ANY.\n",NAME_CURRENT_COMP,mask_setting);
            exit(1);
        }
    }
    
    for (loop_index=0;loop_index<global_geometry_list.num_elements;loop_index++) {
        // Add mask list
        if (1 == manual_linking_function(global_geometry_list.elements[loop_index].name,mask_string)) {
            add_element_to_int_list(&this_box_volume.geometry.mask_list,global_geometry_list.elements[loop_index].component_index);
            add_element_to_int_list(&global_geometry_list.elements[loop_index].Volume->geometry.masked_by_list,INDEX_CURRENT_COMP);
            global_geometry_list.elements[loop_index].Volume->geometry.is_masked_volume = 1;
            if (this_box_volume.geometry.mask_mode == 2)
                global_geometry_list.elements[loop_index].Volume->geometry.mask_mode = 2;
            if (this_box_volume.geometry.mask_mode == 1) {
                if (global_geometry_list.elements[loop_index].Volume->geometry.is_masked_volume == 1 && global_geometry_list.elements[loop_index].Volume->geometry.mask_mode != 2)
                    // If more than one mask is added to one volume, the ANY mode overwrites the (default) ALL mode.
                    global_geometry_list.elements[loop_index].Volume->geometry.mask_mode = 1;
            }
            
            found_geometries = 1;
        }
    }
    if (found_geometries == 0) {
        printf("The mask_string in geometry: %s did not find any of the specified volumes in the mask_string %s \n",NAME_CURRENT_COMP,mask_string);
        exit(1);
    }
    this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
    this_box_volume.p_physics->is_vacuum = 0; // Makes this volume a vacuum
    this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
    this_box_volume.p_physics->my_a = 0; // Should not be used.
    sprintf(this_box_volume.p_physics->name,"Mask");
    this_box_volume.geometry.is_mask_volume = 1;
    
    
// Read the material input, or if it lacks, use automatic linking.
} else if (material_string && strlen(material_string) && strcmp(material_string, "NULL") && strcmp(material_string, "0")) {
    // A geometry string was given, use it to determine which material
    if (0 == strcmp(material_string,"vacuum") || 0 == strcmp(material_string,"Vacuum")) {
        // One could have a global physics struct for vacuum instead of creating one for each
        this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
        this_box_volume.p_physics->is_vacuum = 1; // Makes this volume a vacuum
        this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
        this_box_volume.p_physics->my_a = 0; // Should not be used.
        sprintf(this_box_volume.p_physics->name,"Vacuum");
    } else if (0 == strcmp(material_string,"exit") || 0 == strcmp(material_string,"Exit")) {
        // One could have a global physics struct for vacuum instead of creating one for each
        this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
        this_box_volume.p_physics->is_vacuum = 1; // Makes this volume a vacuum
        this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
        this_box_volume.p_physics->my_a = 0; // Should not be used.
        this_box_volume.geometry.is_exit_volume = 1;
        sprintf(this_box_volume.p_physics->name,"Exit");
    } else {
        #ifndef MATERIAL_DETECTOR
            printf("Need to define a material before refering to it in a geometry %s.\n",NAME_CURRENT_COMP);
            exit(1);
        #endif
        for (loop_index=0;loop_index<global_material_list.num_elements;loop_index++) {
            if (0 == strcmp(material_string,global_material_list.elements[loop_index].name)) {
                this_box_volume.p_physics = global_material_list.elements[loop_index].physics;
                break;
            }
            if (loop_index == global_material_list.num_elements-1) {
            printf("\n");
            printf("ERROR: The material string \"%s\" in Union geometry \"%s\" did not match a specified material. \n",material_string,NAME_CURRENT_COMP);
            printf("       The materials available at this point (need to be defined before the geometry): \n");
            for (loop_index=0;loop_index<global_material_list.num_elements;loop_index++)
              printf("         %s\n",global_material_list.elements[loop_index].name);
            printf("\n");
            printf("       It is also possible to use one of the defualt materials avaiable: \n");
            printf("           Vacuum (for a Volume without scattering or absorption)\n");
            printf("           Exit (for a Volume where the ray exits the component if it enters)\n");
            printf("           Mask (for a Volume that masks existing volumes specified in the mask_string\n");
            exit(1);
          }
        }
    }
} else {
    // Automatic linking, simply using the last defined material.
    #ifndef MATERIAL_DETECTOR
        printf("Need to define a material before the geometry to use automatic linking %s.\n",NAME_CURRENT_COMP);
        exit(1);
    #endif
    this_box_volume.p_physics = global_material_list.elements[global_material_list.num_elements-1].physics;
}

sprintf(this_box_volume.name,NAME_CURRENT_COMP);
sprintf(this_box_volume.geometry.shape,"box");
this_box_volume.geometry.priority_value = priority;
this_box_volume.geometry.geometry_p_interact = p_interact;
// Currently the coordinates will be in absolute space.
this_box_volume.geometry.center = POS_A_CURRENT_COMP;

this_box_storage.z_depth = zdepth;
this_box_storage.x_width1 = xwidth;
this_box_storage.y_height1 = yheight;

this_box_storage.is_rectangle = 0;
if (xwidth2 < 0 && yheight2 < 0) this_box_storage.is_rectangle = 1;
if (xwidth == xwidth2 && yheight == yheight2) this_box_storage.is_rectangle = 1;

if (xwidth2 < 0) {
    this_box_storage.x_width2 = xwidth;
    xwidth2 = xwidth;
} else this_box_storage.x_width2 = xwidth2;

if (yheight2 < 0) {
    this_box_storage.y_height2 = yheight;
    yheight2 = yheight;
} else this_box_storage.y_height2 = yheight2;


this_box_storage.normal_vectors[0] = coords_set(0,0,1);
this_box_storage.normal_vectors[1] = coords_set(0,0,1);

// for sides with y component = 0
x_component = 2*zdepth/sqrt((xwidth-xwidth2)*(xwidth-xwidth2)+4*zdepth*zdepth);
z_component = (xwidth-xwidth2)/sqrt(4*zdepth*zdepth+(xwidth-xwidth2)*(xwidth-xwidth2));

this_box_storage.normal_vectors[2] = coords_set(x_component,0,z_component);
this_box_storage.normal_vectors[3] = coords_set(-x_component,0,z_component);

// for sides with x component = 0
y_component = 2*zdepth/sqrt((yheight-yheight2)*(yheight-yheight2)+4*zdepth*zdepth);
z_component = (yheight-yheight2)/sqrt(4*zdepth*zdepth+(yheight-yheight2)*(yheight-yheight2));

this_box_storage.normal_vectors[4] = coords_set(0,y_component,z_component);
this_box_storage.normal_vectors[5] = coords_set(0,-y_component,z_component);

this_box_volume.geometry.visualization_on = visualize;

this_box_volume.geometry.geometry_parameters.p_box_storage = &this_box_storage;

// Assign pointers to functions for intersection with the shape, checking if a point is inside the shape
if (this_box_storage.is_rectangle == 1) {
this_box_volume.geometry.intersect_function = &sample_box_intersect_simple;
this_box_volume.geometry.within_function = &r_within_box_simple;
}
else {
this_box_volume.geometry.intersect_function = &sample_box_intersect_advanced;
this_box_volume.geometry.within_function = &r_within_box_advanced;
}

this_box_volume.geometry.shell_points = &box_shell_points;
this_box_volume.geometry.mcdisplay_function = &mcdisplay_box_function;
this_box_volume.geometry.initialize_from_main_function = &initialize_box_geometry_from_main_component;
this_box_volume.geometry.process_rot_allocated = 0;

this_box_volume.geometry.copy_geometry_parameters = &allocate_box_storage_copy;

rot_copy(this_box_volume.geometry.rotation_matrix,ROT_A_CURRENT_COMP); //check how ROT_R_CURRENT_COMP would work
rot_transpose(ROT_A_CURRENT_COMP,this_box_volume.geometry.transpose_rotation_matrix);

// Initialize loggers
this_box_volume.loggers.num_elements = 0;

// packing the information into the global_geometry_element, which is then included in the global_geometry_list.
sprintf(global_geometry_element.name,NAME_CURRENT_COMP);
global_geometry_element.activation_counter = number_of_activations;
global_geometry_element.component_index = INDEX_CURRENT_COMP;
global_geometry_element.Volume = &this_box_volume; // Would be nicer if this m was a pointer, now we have the (small) data two places
add_element_to_geometry_list(&global_geometry_list,global_geometry_element);
}
#line 312641 "MACS_sample_kidney_box.c"
#undef number_of_activations
#undef mask_setting
#undef mask_string
#undef p_interact
#undef focus_r
#undef focus_xh
#undef focus_xw
#undef focus_ah
#undef focus_aw
#undef target_z
#undef target_y
#undef target_x
#undef target_index
#undef visualize
#undef yheight2
#undef xwidth2
#undef zdepth
#undef yheight
#undef xwidth
#undef priority
#undef material_string
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

  /* Initializations for component inter_analyzer_colimator_16_blade_1. */
  SIG_MESSAGE("inter_analyzer_colimator_16_blade_1 (Init)");
#define mccompcurname  inter_analyzer_colimator_16_blade_1
#define mccompcurtype  Union_box
#define mccompcurindex 764
#define loop_index mccinter_analyzer_colimator_16_blade_1_loop_index
#define this_box_volume mccinter_analyzer_colimator_16_blade_1_this_box_volume
#define global_geometry_element mccinter_analyzer_colimator_16_blade_1_global_geometry_element
#define this_box_storage mccinter_analyzer_colimator_16_blade_1_this_box_storage
#define material_string mccinter_analyzer_colimator_16_blade_1_material_string
#define priority mccinter_analyzer_colimator_16_blade_1_priority
#define xwidth mccinter_analyzer_colimator_16_blade_1_xwidth
#define yheight mccinter_analyzer_colimator_16_blade_1_yheight
#define zdepth mccinter_analyzer_colimator_16_blade_1_zdepth
#define xwidth2 mccinter_analyzer_colimator_16_blade_1_xwidth2
#define yheight2 mccinter_analyzer_colimator_16_blade_1_yheight2
#define visualize mccinter_analyzer_colimator_16_blade_1_visualize
#define target_index mccinter_analyzer_colimator_16_blade_1_target_index
#define target_x mccinter_analyzer_colimator_16_blade_1_target_x
#define target_y mccinter_analyzer_colimator_16_blade_1_target_y
#define target_z mccinter_analyzer_colimator_16_blade_1_target_z
#define focus_aw mccinter_analyzer_colimator_16_blade_1_focus_aw
#define focus_ah mccinter_analyzer_colimator_16_blade_1_focus_ah
#define focus_xw mccinter_analyzer_colimator_16_blade_1_focus_xw
#define focus_xh mccinter_analyzer_colimator_16_blade_1_focus_xh
#define focus_r mccinter_analyzer_colimator_16_blade_1_focus_r
#define p_interact mccinter_analyzer_colimator_16_blade_1_p_interact
#define mask_string mccinter_analyzer_colimator_16_blade_1_mask_string
#define mask_setting mccinter_analyzer_colimator_16_blade_1_mask_setting
#define number_of_activations mccinter_analyzer_colimator_16_blade_1_number_of_activations
#line 224 "Union_box.comp"
{
// Initializes the focusing system for this volume including input sanitation.
focus_initialize(&this_box_volume.geometry, POS_A_COMP_INDEX(INDEX_CURRENT_COMP+target_index), POS_A_CURRENT_COMP, ROT_A_CURRENT_COMP, target_index, target_x, target_y, target_z, focus_aw, focus_ah, focus_xw, focus_xh, focus_r, NAME_CURRENT_COMP);

// Input sanitation for this geometry
if (xwidth <= 0) {
  printf("\nERROR in Union_box named %s, the xwidth is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (yheight <= 0) {
  printf("\nERROR in Union_box named %s, yheight is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (zdepth <= 0) {
  printf("\nERROR in Union_box named %s, zdepth is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (xwidth2 <= 0 && xwidth2 != -1) {
  printf("\nERROR in Union_box named %s, the xwidth2 is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (yheight2 <= 0 && yheight2 != -1) {
  printf("\nERROR in Union_box named %s, yheight2 is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}

// Use sanitation
if (global_material_list.num_elements == 0) {
  printf("\nERROR: Need to define a material using Union_make_material before using a Union geometry component. \n");
  printf("       %s was defined before first use of Union_make_material.\n",NAME_CURRENT_COMP);
  exit(1);
}

this_box_volume.geometry.is_masked_volume = 0;
this_box_volume.geometry.is_exit_volume = 0;
this_box_volume.geometry.is_mask_volume = 0;
// check if the volume is a mask, if it is the material string is irelevant.
if (mask_string && strlen(mask_string) && strcmp(mask_string, "NULL") && strcmp(mask_string, "0")) {
    // A mask volume is used to limit the extend of other volumes, called the masked volumes. These are specified in the mask_string.
    // In order for a ray to enter a masked volume, it needs to be both in the region covered by that volume AND the mask volume.
    // When more than
    this_box_volume.geometry.mask_mode = 1; // Default is mask mode is ALL
    if (mask_setting && strlen(mask_setting) && strcmp(mask_setting, "NULL") && strcmp(mask_setting, "0")) {
        if (strcmp(mask_setting,"ALL") == 0 || strcmp(mask_setting,"All") == 0) this_box_volume.geometry.mask_mode = 1;
        else if (strcmp(mask_setting,"ANY") == 0 || strcmp(mask_setting,"Any") == 0) this_box_volume.geometry.mask_mode = 2;
        else {
            printf("The mask_mode of component %s is set to %s, but must be either ALL or ANY.\n",NAME_CURRENT_COMP,mask_setting);
            exit(1);
        }
    }
    
    for (loop_index=0;loop_index<global_geometry_list.num_elements;loop_index++) {
        // Add mask list
        if (1 == manual_linking_function(global_geometry_list.elements[loop_index].name,mask_string)) {
            add_element_to_int_list(&this_box_volume.geometry.mask_list,global_geometry_list.elements[loop_index].component_index);
            add_element_to_int_list(&global_geometry_list.elements[loop_index].Volume->geometry.masked_by_list,INDEX_CURRENT_COMP);
            global_geometry_list.elements[loop_index].Volume->geometry.is_masked_volume = 1;
            if (this_box_volume.geometry.mask_mode == 2)
                global_geometry_list.elements[loop_index].Volume->geometry.mask_mode = 2;
            if (this_box_volume.geometry.mask_mode == 1) {
                if (global_geometry_list.elements[loop_index].Volume->geometry.is_masked_volume == 1 && global_geometry_list.elements[loop_index].Volume->geometry.mask_mode != 2)
                    // If more than one mask is added to one volume, the ANY mode overwrites the (default) ALL mode.
                    global_geometry_list.elements[loop_index].Volume->geometry.mask_mode = 1;
            }
            
            found_geometries = 1;
        }
    }
    if (found_geometries == 0) {
        printf("The mask_string in geometry: %s did not find any of the specified volumes in the mask_string %s \n",NAME_CURRENT_COMP,mask_string);
        exit(1);
    }
    this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
    this_box_volume.p_physics->is_vacuum = 0; // Makes this volume a vacuum
    this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
    this_box_volume.p_physics->my_a = 0; // Should not be used.
    sprintf(this_box_volume.p_physics->name,"Mask");
    this_box_volume.geometry.is_mask_volume = 1;
    
    
// Read the material input, or if it lacks, use automatic linking.
} else if (material_string && strlen(material_string) && strcmp(material_string, "NULL") && strcmp(material_string, "0")) {
    // A geometry string was given, use it to determine which material
    if (0 == strcmp(material_string,"vacuum") || 0 == strcmp(material_string,"Vacuum")) {
        // One could have a global physics struct for vacuum instead of creating one for each
        this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
        this_box_volume.p_physics->is_vacuum = 1; // Makes this volume a vacuum
        this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
        this_box_volume.p_physics->my_a = 0; // Should not be used.
        sprintf(this_box_volume.p_physics->name,"Vacuum");
    } else if (0 == strcmp(material_string,"exit") || 0 == strcmp(material_string,"Exit")) {
        // One could have a global physics struct for vacuum instead of creating one for each
        this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
        this_box_volume.p_physics->is_vacuum = 1; // Makes this volume a vacuum
        this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
        this_box_volume.p_physics->my_a = 0; // Should not be used.
        this_box_volume.geometry.is_exit_volume = 1;
        sprintf(this_box_volume.p_physics->name,"Exit");
    } else {
        #ifndef MATERIAL_DETECTOR
            printf("Need to define a material before refering to it in a geometry %s.\n",NAME_CURRENT_COMP);
            exit(1);
        #endif
        for (loop_index=0;loop_index<global_material_list.num_elements;loop_index++) {
            if (0 == strcmp(material_string,global_material_list.elements[loop_index].name)) {
                this_box_volume.p_physics = global_material_list.elements[loop_index].physics;
                break;
            }
            if (loop_index == global_material_list.num_elements-1) {
            printf("\n");
            printf("ERROR: The material string \"%s\" in Union geometry \"%s\" did not match a specified material. \n",material_string,NAME_CURRENT_COMP);
            printf("       The materials available at this point (need to be defined before the geometry): \n");
            for (loop_index=0;loop_index<global_material_list.num_elements;loop_index++)
              printf("         %s\n",global_material_list.elements[loop_index].name);
            printf("\n");
            printf("       It is also possible to use one of the defualt materials avaiable: \n");
            printf("           Vacuum (for a Volume without scattering or absorption)\n");
            printf("           Exit (for a Volume where the ray exits the component if it enters)\n");
            printf("           Mask (for a Volume that masks existing volumes specified in the mask_string\n");
            exit(1);
          }
        }
    }
} else {
    // Automatic linking, simply using the last defined material.
    #ifndef MATERIAL_DETECTOR
        printf("Need to define a material before the geometry to use automatic linking %s.\n",NAME_CURRENT_COMP);
        exit(1);
    #endif
    this_box_volume.p_physics = global_material_list.elements[global_material_list.num_elements-1].physics;
}

sprintf(this_box_volume.name,NAME_CURRENT_COMP);
sprintf(this_box_volume.geometry.shape,"box");
this_box_volume.geometry.priority_value = priority;
this_box_volume.geometry.geometry_p_interact = p_interact;
// Currently the coordinates will be in absolute space.
this_box_volume.geometry.center = POS_A_CURRENT_COMP;

this_box_storage.z_depth = zdepth;
this_box_storage.x_width1 = xwidth;
this_box_storage.y_height1 = yheight;

this_box_storage.is_rectangle = 0;
if (xwidth2 < 0 && yheight2 < 0) this_box_storage.is_rectangle = 1;
if (xwidth == xwidth2 && yheight == yheight2) this_box_storage.is_rectangle = 1;

if (xwidth2 < 0) {
    this_box_storage.x_width2 = xwidth;
    xwidth2 = xwidth;
} else this_box_storage.x_width2 = xwidth2;

if (yheight2 < 0) {
    this_box_storage.y_height2 = yheight;
    yheight2 = yheight;
} else this_box_storage.y_height2 = yheight2;


this_box_storage.normal_vectors[0] = coords_set(0,0,1);
this_box_storage.normal_vectors[1] = coords_set(0,0,1);

// for sides with y component = 0
x_component = 2*zdepth/sqrt((xwidth-xwidth2)*(xwidth-xwidth2)+4*zdepth*zdepth);
z_component = (xwidth-xwidth2)/sqrt(4*zdepth*zdepth+(xwidth-xwidth2)*(xwidth-xwidth2));

this_box_storage.normal_vectors[2] = coords_set(x_component,0,z_component);
this_box_storage.normal_vectors[3] = coords_set(-x_component,0,z_component);

// for sides with x component = 0
y_component = 2*zdepth/sqrt((yheight-yheight2)*(yheight-yheight2)+4*zdepth*zdepth);
z_component = (yheight-yheight2)/sqrt(4*zdepth*zdepth+(yheight-yheight2)*(yheight-yheight2));

this_box_storage.normal_vectors[4] = coords_set(0,y_component,z_component);
this_box_storage.normal_vectors[5] = coords_set(0,-y_component,z_component);

this_box_volume.geometry.visualization_on = visualize;

this_box_volume.geometry.geometry_parameters.p_box_storage = &this_box_storage;

// Assign pointers to functions for intersection with the shape, checking if a point is inside the shape
if (this_box_storage.is_rectangle == 1) {
this_box_volume.geometry.intersect_function = &sample_box_intersect_simple;
this_box_volume.geometry.within_function = &r_within_box_simple;
}
else {
this_box_volume.geometry.intersect_function = &sample_box_intersect_advanced;
this_box_volume.geometry.within_function = &r_within_box_advanced;
}

this_box_volume.geometry.shell_points = &box_shell_points;
this_box_volume.geometry.mcdisplay_function = &mcdisplay_box_function;
this_box_volume.geometry.initialize_from_main_function = &initialize_box_geometry_from_main_component;
this_box_volume.geometry.process_rot_allocated = 0;

this_box_volume.geometry.copy_geometry_parameters = &allocate_box_storage_copy;

rot_copy(this_box_volume.geometry.rotation_matrix,ROT_A_CURRENT_COMP); //check how ROT_R_CURRENT_COMP would work
rot_transpose(ROT_A_CURRENT_COMP,this_box_volume.geometry.transpose_rotation_matrix);

// Initialize loggers
this_box_volume.loggers.num_elements = 0;

// packing the information into the global_geometry_element, which is then included in the global_geometry_list.
sprintf(global_geometry_element.name,NAME_CURRENT_COMP);
global_geometry_element.activation_counter = number_of_activations;
global_geometry_element.component_index = INDEX_CURRENT_COMP;
global_geometry_element.Volume = &this_box_volume; // Would be nicer if this m was a pointer, now we have the (small) data two places
add_element_to_geometry_list(&global_geometry_list,global_geometry_element);
}
#line 312911 "MACS_sample_kidney_box.c"
#undef number_of_activations
#undef mask_setting
#undef mask_string
#undef p_interact
#undef focus_r
#undef focus_xh
#undef focus_xw
#undef focus_ah
#undef focus_aw
#undef target_z
#undef target_y
#undef target_x
#undef target_index
#undef visualize
#undef yheight2
#undef xwidth2
#undef zdepth
#undef yheight
#undef xwidth
#undef priority
#undef material_string
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

  /* Initializations for component inter_analyzer_colimator_16_blade_2. */
  SIG_MESSAGE("inter_analyzer_colimator_16_blade_2 (Init)");
#define mccompcurname  inter_analyzer_colimator_16_blade_2
#define mccompcurtype  Union_box
#define mccompcurindex 765
#define loop_index mccinter_analyzer_colimator_16_blade_2_loop_index
#define this_box_volume mccinter_analyzer_colimator_16_blade_2_this_box_volume
#define global_geometry_element mccinter_analyzer_colimator_16_blade_2_global_geometry_element
#define this_box_storage mccinter_analyzer_colimator_16_blade_2_this_box_storage
#define material_string mccinter_analyzer_colimator_16_blade_2_material_string
#define priority mccinter_analyzer_colimator_16_blade_2_priority
#define xwidth mccinter_analyzer_colimator_16_blade_2_xwidth
#define yheight mccinter_analyzer_colimator_16_blade_2_yheight
#define zdepth mccinter_analyzer_colimator_16_blade_2_zdepth
#define xwidth2 mccinter_analyzer_colimator_16_blade_2_xwidth2
#define yheight2 mccinter_analyzer_colimator_16_blade_2_yheight2
#define visualize mccinter_analyzer_colimator_16_blade_2_visualize
#define target_index mccinter_analyzer_colimator_16_blade_2_target_index
#define target_x mccinter_analyzer_colimator_16_blade_2_target_x
#define target_y mccinter_analyzer_colimator_16_blade_2_target_y
#define target_z mccinter_analyzer_colimator_16_blade_2_target_z
#define focus_aw mccinter_analyzer_colimator_16_blade_2_focus_aw
#define focus_ah mccinter_analyzer_colimator_16_blade_2_focus_ah
#define focus_xw mccinter_analyzer_colimator_16_blade_2_focus_xw
#define focus_xh mccinter_analyzer_colimator_16_blade_2_focus_xh
#define focus_r mccinter_analyzer_colimator_16_blade_2_focus_r
#define p_interact mccinter_analyzer_colimator_16_blade_2_p_interact
#define mask_string mccinter_analyzer_colimator_16_blade_2_mask_string
#define mask_setting mccinter_analyzer_colimator_16_blade_2_mask_setting
#define number_of_activations mccinter_analyzer_colimator_16_blade_2_number_of_activations
#line 224 "Union_box.comp"
{
// Initializes the focusing system for this volume including input sanitation.
focus_initialize(&this_box_volume.geometry, POS_A_COMP_INDEX(INDEX_CURRENT_COMP+target_index), POS_A_CURRENT_COMP, ROT_A_CURRENT_COMP, target_index, target_x, target_y, target_z, focus_aw, focus_ah, focus_xw, focus_xh, focus_r, NAME_CURRENT_COMP);

// Input sanitation for this geometry
if (xwidth <= 0) {
  printf("\nERROR in Union_box named %s, the xwidth is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (yheight <= 0) {
  printf("\nERROR in Union_box named %s, yheight is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (zdepth <= 0) {
  printf("\nERROR in Union_box named %s, zdepth is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (xwidth2 <= 0 && xwidth2 != -1) {
  printf("\nERROR in Union_box named %s, the xwidth2 is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (yheight2 <= 0 && yheight2 != -1) {
  printf("\nERROR in Union_box named %s, yheight2 is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}

// Use sanitation
if (global_material_list.num_elements == 0) {
  printf("\nERROR: Need to define a material using Union_make_material before using a Union geometry component. \n");
  printf("       %s was defined before first use of Union_make_material.\n",NAME_CURRENT_COMP);
  exit(1);
}

this_box_volume.geometry.is_masked_volume = 0;
this_box_volume.geometry.is_exit_volume = 0;
this_box_volume.geometry.is_mask_volume = 0;
// check if the volume is a mask, if it is the material string is irelevant.
if (mask_string && strlen(mask_string) && strcmp(mask_string, "NULL") && strcmp(mask_string, "0")) {
    // A mask volume is used to limit the extend of other volumes, called the masked volumes. These are specified in the mask_string.
    // In order for a ray to enter a masked volume, it needs to be both in the region covered by that volume AND the mask volume.
    // When more than
    this_box_volume.geometry.mask_mode = 1; // Default is mask mode is ALL
    if (mask_setting && strlen(mask_setting) && strcmp(mask_setting, "NULL") && strcmp(mask_setting, "0")) {
        if (strcmp(mask_setting,"ALL") == 0 || strcmp(mask_setting,"All") == 0) this_box_volume.geometry.mask_mode = 1;
        else if (strcmp(mask_setting,"ANY") == 0 || strcmp(mask_setting,"Any") == 0) this_box_volume.geometry.mask_mode = 2;
        else {
            printf("The mask_mode of component %s is set to %s, but must be either ALL or ANY.\n",NAME_CURRENT_COMP,mask_setting);
            exit(1);
        }
    }
    
    for (loop_index=0;loop_index<global_geometry_list.num_elements;loop_index++) {
        // Add mask list
        if (1 == manual_linking_function(global_geometry_list.elements[loop_index].name,mask_string)) {
            add_element_to_int_list(&this_box_volume.geometry.mask_list,global_geometry_list.elements[loop_index].component_index);
            add_element_to_int_list(&global_geometry_list.elements[loop_index].Volume->geometry.masked_by_list,INDEX_CURRENT_COMP);
            global_geometry_list.elements[loop_index].Volume->geometry.is_masked_volume = 1;
            if (this_box_volume.geometry.mask_mode == 2)
                global_geometry_list.elements[loop_index].Volume->geometry.mask_mode = 2;
            if (this_box_volume.geometry.mask_mode == 1) {
                if (global_geometry_list.elements[loop_index].Volume->geometry.is_masked_volume == 1 && global_geometry_list.elements[loop_index].Volume->geometry.mask_mode != 2)
                    // If more than one mask is added to one volume, the ANY mode overwrites the (default) ALL mode.
                    global_geometry_list.elements[loop_index].Volume->geometry.mask_mode = 1;
            }
            
            found_geometries = 1;
        }
    }
    if (found_geometries == 0) {
        printf("The mask_string in geometry: %s did not find any of the specified volumes in the mask_string %s \n",NAME_CURRENT_COMP,mask_string);
        exit(1);
    }
    this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
    this_box_volume.p_physics->is_vacuum = 0; // Makes this volume a vacuum
    this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
    this_box_volume.p_physics->my_a = 0; // Should not be used.
    sprintf(this_box_volume.p_physics->name,"Mask");
    this_box_volume.geometry.is_mask_volume = 1;
    
    
// Read the material input, or if it lacks, use automatic linking.
} else if (material_string && strlen(material_string) && strcmp(material_string, "NULL") && strcmp(material_string, "0")) {
    // A geometry string was given, use it to determine which material
    if (0 == strcmp(material_string,"vacuum") || 0 == strcmp(material_string,"Vacuum")) {
        // One could have a global physics struct for vacuum instead of creating one for each
        this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
        this_box_volume.p_physics->is_vacuum = 1; // Makes this volume a vacuum
        this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
        this_box_volume.p_physics->my_a = 0; // Should not be used.
        sprintf(this_box_volume.p_physics->name,"Vacuum");
    } else if (0 == strcmp(material_string,"exit") || 0 == strcmp(material_string,"Exit")) {
        // One could have a global physics struct for vacuum instead of creating one for each
        this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
        this_box_volume.p_physics->is_vacuum = 1; // Makes this volume a vacuum
        this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
        this_box_volume.p_physics->my_a = 0; // Should not be used.
        this_box_volume.geometry.is_exit_volume = 1;
        sprintf(this_box_volume.p_physics->name,"Exit");
    } else {
        #ifndef MATERIAL_DETECTOR
            printf("Need to define a material before refering to it in a geometry %s.\n",NAME_CURRENT_COMP);
            exit(1);
        #endif
        for (loop_index=0;loop_index<global_material_list.num_elements;loop_index++) {
            if (0 == strcmp(material_string,global_material_list.elements[loop_index].name)) {
                this_box_volume.p_physics = global_material_list.elements[loop_index].physics;
                break;
            }
            if (loop_index == global_material_list.num_elements-1) {
            printf("\n");
            printf("ERROR: The material string \"%s\" in Union geometry \"%s\" did not match a specified material. \n",material_string,NAME_CURRENT_COMP);
            printf("       The materials available at this point (need to be defined before the geometry): \n");
            for (loop_index=0;loop_index<global_material_list.num_elements;loop_index++)
              printf("         %s\n",global_material_list.elements[loop_index].name);
            printf("\n");
            printf("       It is also possible to use one of the defualt materials avaiable: \n");
            printf("           Vacuum (for a Volume without scattering or absorption)\n");
            printf("           Exit (for a Volume where the ray exits the component if it enters)\n");
            printf("           Mask (for a Volume that masks existing volumes specified in the mask_string\n");
            exit(1);
          }
        }
    }
} else {
    // Automatic linking, simply using the last defined material.
    #ifndef MATERIAL_DETECTOR
        printf("Need to define a material before the geometry to use automatic linking %s.\n",NAME_CURRENT_COMP);
        exit(1);
    #endif
    this_box_volume.p_physics = global_material_list.elements[global_material_list.num_elements-1].physics;
}

sprintf(this_box_volume.name,NAME_CURRENT_COMP);
sprintf(this_box_volume.geometry.shape,"box");
this_box_volume.geometry.priority_value = priority;
this_box_volume.geometry.geometry_p_interact = p_interact;
// Currently the coordinates will be in absolute space.
this_box_volume.geometry.center = POS_A_CURRENT_COMP;

this_box_storage.z_depth = zdepth;
this_box_storage.x_width1 = xwidth;
this_box_storage.y_height1 = yheight;

this_box_storage.is_rectangle = 0;
if (xwidth2 < 0 && yheight2 < 0) this_box_storage.is_rectangle = 1;
if (xwidth == xwidth2 && yheight == yheight2) this_box_storage.is_rectangle = 1;

if (xwidth2 < 0) {
    this_box_storage.x_width2 = xwidth;
    xwidth2 = xwidth;
} else this_box_storage.x_width2 = xwidth2;

if (yheight2 < 0) {
    this_box_storage.y_height2 = yheight;
    yheight2 = yheight;
} else this_box_storage.y_height2 = yheight2;


this_box_storage.normal_vectors[0] = coords_set(0,0,1);
this_box_storage.normal_vectors[1] = coords_set(0,0,1);

// for sides with y component = 0
x_component = 2*zdepth/sqrt((xwidth-xwidth2)*(xwidth-xwidth2)+4*zdepth*zdepth);
z_component = (xwidth-xwidth2)/sqrt(4*zdepth*zdepth+(xwidth-xwidth2)*(xwidth-xwidth2));

this_box_storage.normal_vectors[2] = coords_set(x_component,0,z_component);
this_box_storage.normal_vectors[3] = coords_set(-x_component,0,z_component);

// for sides with x component = 0
y_component = 2*zdepth/sqrt((yheight-yheight2)*(yheight-yheight2)+4*zdepth*zdepth);
z_component = (yheight-yheight2)/sqrt(4*zdepth*zdepth+(yheight-yheight2)*(yheight-yheight2));

this_box_storage.normal_vectors[4] = coords_set(0,y_component,z_component);
this_box_storage.normal_vectors[5] = coords_set(0,-y_component,z_component);

this_box_volume.geometry.visualization_on = visualize;

this_box_volume.geometry.geometry_parameters.p_box_storage = &this_box_storage;

// Assign pointers to functions for intersection with the shape, checking if a point is inside the shape
if (this_box_storage.is_rectangle == 1) {
this_box_volume.geometry.intersect_function = &sample_box_intersect_simple;
this_box_volume.geometry.within_function = &r_within_box_simple;
}
else {
this_box_volume.geometry.intersect_function = &sample_box_intersect_advanced;
this_box_volume.geometry.within_function = &r_within_box_advanced;
}

this_box_volume.geometry.shell_points = &box_shell_points;
this_box_volume.geometry.mcdisplay_function = &mcdisplay_box_function;
this_box_volume.geometry.initialize_from_main_function = &initialize_box_geometry_from_main_component;
this_box_volume.geometry.process_rot_allocated = 0;

this_box_volume.geometry.copy_geometry_parameters = &allocate_box_storage_copy;

rot_copy(this_box_volume.geometry.rotation_matrix,ROT_A_CURRENT_COMP); //check how ROT_R_CURRENT_COMP would work
rot_transpose(ROT_A_CURRENT_COMP,this_box_volume.geometry.transpose_rotation_matrix);

// Initialize loggers
this_box_volume.loggers.num_elements = 0;

// packing the information into the global_geometry_element, which is then included in the global_geometry_list.
sprintf(global_geometry_element.name,NAME_CURRENT_COMP);
global_geometry_element.activation_counter = number_of_activations;
global_geometry_element.component_index = INDEX_CURRENT_COMP;
global_geometry_element.Volume = &this_box_volume; // Would be nicer if this m was a pointer, now we have the (small) data two places
add_element_to_geometry_list(&global_geometry_list,global_geometry_element);
}
#line 313181 "MACS_sample_kidney_box.c"
#undef number_of_activations
#undef mask_setting
#undef mask_string
#undef p_interact
#undef focus_r
#undef focus_xh
#undef focus_xw
#undef focus_ah
#undef focus_aw
#undef target_z
#undef target_y
#undef target_x
#undef target_index
#undef visualize
#undef yheight2
#undef xwidth2
#undef zdepth
#undef yheight
#undef xwidth
#undef priority
#undef material_string
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

  /* Initializations for component inter_analyzer_colimator_16_blade_3. */
  SIG_MESSAGE("inter_analyzer_colimator_16_blade_3 (Init)");
#define mccompcurname  inter_analyzer_colimator_16_blade_3
#define mccompcurtype  Union_box
#define mccompcurindex 766
#define loop_index mccinter_analyzer_colimator_16_blade_3_loop_index
#define this_box_volume mccinter_analyzer_colimator_16_blade_3_this_box_volume
#define global_geometry_element mccinter_analyzer_colimator_16_blade_3_global_geometry_element
#define this_box_storage mccinter_analyzer_colimator_16_blade_3_this_box_storage
#define material_string mccinter_analyzer_colimator_16_blade_3_material_string
#define priority mccinter_analyzer_colimator_16_blade_3_priority
#define xwidth mccinter_analyzer_colimator_16_blade_3_xwidth
#define yheight mccinter_analyzer_colimator_16_blade_3_yheight
#define zdepth mccinter_analyzer_colimator_16_blade_3_zdepth
#define xwidth2 mccinter_analyzer_colimator_16_blade_3_xwidth2
#define yheight2 mccinter_analyzer_colimator_16_blade_3_yheight2
#define visualize mccinter_analyzer_colimator_16_blade_3_visualize
#define target_index mccinter_analyzer_colimator_16_blade_3_target_index
#define target_x mccinter_analyzer_colimator_16_blade_3_target_x
#define target_y mccinter_analyzer_colimator_16_blade_3_target_y
#define target_z mccinter_analyzer_colimator_16_blade_3_target_z
#define focus_aw mccinter_analyzer_colimator_16_blade_3_focus_aw
#define focus_ah mccinter_analyzer_colimator_16_blade_3_focus_ah
#define focus_xw mccinter_analyzer_colimator_16_blade_3_focus_xw
#define focus_xh mccinter_analyzer_colimator_16_blade_3_focus_xh
#define focus_r mccinter_analyzer_colimator_16_blade_3_focus_r
#define p_interact mccinter_analyzer_colimator_16_blade_3_p_interact
#define mask_string mccinter_analyzer_colimator_16_blade_3_mask_string
#define mask_setting mccinter_analyzer_colimator_16_blade_3_mask_setting
#define number_of_activations mccinter_analyzer_colimator_16_blade_3_number_of_activations
#line 224 "Union_box.comp"
{
// Initializes the focusing system for this volume including input sanitation.
focus_initialize(&this_box_volume.geometry, POS_A_COMP_INDEX(INDEX_CURRENT_COMP+target_index), POS_A_CURRENT_COMP, ROT_A_CURRENT_COMP, target_index, target_x, target_y, target_z, focus_aw, focus_ah, focus_xw, focus_xh, focus_r, NAME_CURRENT_COMP);

// Input sanitation for this geometry
if (xwidth <= 0) {
  printf("\nERROR in Union_box named %s, the xwidth is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (yheight <= 0) {
  printf("\nERROR in Union_box named %s, yheight is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (zdepth <= 0) {
  printf("\nERROR in Union_box named %s, zdepth is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (xwidth2 <= 0 && xwidth2 != -1) {
  printf("\nERROR in Union_box named %s, the xwidth2 is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (yheight2 <= 0 && yheight2 != -1) {
  printf("\nERROR in Union_box named %s, yheight2 is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}

// Use sanitation
if (global_material_list.num_elements == 0) {
  printf("\nERROR: Need to define a material using Union_make_material before using a Union geometry component. \n");
  printf("       %s was defined before first use of Union_make_material.\n",NAME_CURRENT_COMP);
  exit(1);
}

this_box_volume.geometry.is_masked_volume = 0;
this_box_volume.geometry.is_exit_volume = 0;
this_box_volume.geometry.is_mask_volume = 0;
// check if the volume is a mask, if it is the material string is irelevant.
if (mask_string && strlen(mask_string) && strcmp(mask_string, "NULL") && strcmp(mask_string, "0")) {
    // A mask volume is used to limit the extend of other volumes, called the masked volumes. These are specified in the mask_string.
    // In order for a ray to enter a masked volume, it needs to be both in the region covered by that volume AND the mask volume.
    // When more than
    this_box_volume.geometry.mask_mode = 1; // Default is mask mode is ALL
    if (mask_setting && strlen(mask_setting) && strcmp(mask_setting, "NULL") && strcmp(mask_setting, "0")) {
        if (strcmp(mask_setting,"ALL") == 0 || strcmp(mask_setting,"All") == 0) this_box_volume.geometry.mask_mode = 1;
        else if (strcmp(mask_setting,"ANY") == 0 || strcmp(mask_setting,"Any") == 0) this_box_volume.geometry.mask_mode = 2;
        else {
            printf("The mask_mode of component %s is set to %s, but must be either ALL or ANY.\n",NAME_CURRENT_COMP,mask_setting);
            exit(1);
        }
    }
    
    for (loop_index=0;loop_index<global_geometry_list.num_elements;loop_index++) {
        // Add mask list
        if (1 == manual_linking_function(global_geometry_list.elements[loop_index].name,mask_string)) {
            add_element_to_int_list(&this_box_volume.geometry.mask_list,global_geometry_list.elements[loop_index].component_index);
            add_element_to_int_list(&global_geometry_list.elements[loop_index].Volume->geometry.masked_by_list,INDEX_CURRENT_COMP);
            global_geometry_list.elements[loop_index].Volume->geometry.is_masked_volume = 1;
            if (this_box_volume.geometry.mask_mode == 2)
                global_geometry_list.elements[loop_index].Volume->geometry.mask_mode = 2;
            if (this_box_volume.geometry.mask_mode == 1) {
                if (global_geometry_list.elements[loop_index].Volume->geometry.is_masked_volume == 1 && global_geometry_list.elements[loop_index].Volume->geometry.mask_mode != 2)
                    // If more than one mask is added to one volume, the ANY mode overwrites the (default) ALL mode.
                    global_geometry_list.elements[loop_index].Volume->geometry.mask_mode = 1;
            }
            
            found_geometries = 1;
        }
    }
    if (found_geometries == 0) {
        printf("The mask_string in geometry: %s did not find any of the specified volumes in the mask_string %s \n",NAME_CURRENT_COMP,mask_string);
        exit(1);
    }
    this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
    this_box_volume.p_physics->is_vacuum = 0; // Makes this volume a vacuum
    this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
    this_box_volume.p_physics->my_a = 0; // Should not be used.
    sprintf(this_box_volume.p_physics->name,"Mask");
    this_box_volume.geometry.is_mask_volume = 1;
    
    
// Read the material input, or if it lacks, use automatic linking.
} else if (material_string && strlen(material_string) && strcmp(material_string, "NULL") && strcmp(material_string, "0")) {
    // A geometry string was given, use it to determine which material
    if (0 == strcmp(material_string,"vacuum") || 0 == strcmp(material_string,"Vacuum")) {
        // One could have a global physics struct for vacuum instead of creating one for each
        this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
        this_box_volume.p_physics->is_vacuum = 1; // Makes this volume a vacuum
        this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
        this_box_volume.p_physics->my_a = 0; // Should not be used.
        sprintf(this_box_volume.p_physics->name,"Vacuum");
    } else if (0 == strcmp(material_string,"exit") || 0 == strcmp(material_string,"Exit")) {
        // One could have a global physics struct for vacuum instead of creating one for each
        this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
        this_box_volume.p_physics->is_vacuum = 1; // Makes this volume a vacuum
        this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
        this_box_volume.p_physics->my_a = 0; // Should not be used.
        this_box_volume.geometry.is_exit_volume = 1;
        sprintf(this_box_volume.p_physics->name,"Exit");
    } else {
        #ifndef MATERIAL_DETECTOR
            printf("Need to define a material before refering to it in a geometry %s.\n",NAME_CURRENT_COMP);
            exit(1);
        #endif
        for (loop_index=0;loop_index<global_material_list.num_elements;loop_index++) {
            if (0 == strcmp(material_string,global_material_list.elements[loop_index].name)) {
                this_box_volume.p_physics = global_material_list.elements[loop_index].physics;
                break;
            }
            if (loop_index == global_material_list.num_elements-1) {
            printf("\n");
            printf("ERROR: The material string \"%s\" in Union geometry \"%s\" did not match a specified material. \n",material_string,NAME_CURRENT_COMP);
            printf("       The materials available at this point (need to be defined before the geometry): \n");
            for (loop_index=0;loop_index<global_material_list.num_elements;loop_index++)
              printf("         %s\n",global_material_list.elements[loop_index].name);
            printf("\n");
            printf("       It is also possible to use one of the defualt materials avaiable: \n");
            printf("           Vacuum (for a Volume without scattering or absorption)\n");
            printf("           Exit (for a Volume where the ray exits the component if it enters)\n");
            printf("           Mask (for a Volume that masks existing volumes specified in the mask_string\n");
            exit(1);
          }
        }
    }
} else {
    // Automatic linking, simply using the last defined material.
    #ifndef MATERIAL_DETECTOR
        printf("Need to define a material before the geometry to use automatic linking %s.\n",NAME_CURRENT_COMP);
        exit(1);
    #endif
    this_box_volume.p_physics = global_material_list.elements[global_material_list.num_elements-1].physics;
}

sprintf(this_box_volume.name,NAME_CURRENT_COMP);
sprintf(this_box_volume.geometry.shape,"box");
this_box_volume.geometry.priority_value = priority;
this_box_volume.geometry.geometry_p_interact = p_interact;
// Currently the coordinates will be in absolute space.
this_box_volume.geometry.center = POS_A_CURRENT_COMP;

this_box_storage.z_depth = zdepth;
this_box_storage.x_width1 = xwidth;
this_box_storage.y_height1 = yheight;

this_box_storage.is_rectangle = 0;
if (xwidth2 < 0 && yheight2 < 0) this_box_storage.is_rectangle = 1;
if (xwidth == xwidth2 && yheight == yheight2) this_box_storage.is_rectangle = 1;

if (xwidth2 < 0) {
    this_box_storage.x_width2 = xwidth;
    xwidth2 = xwidth;
} else this_box_storage.x_width2 = xwidth2;

if (yheight2 < 0) {
    this_box_storage.y_height2 = yheight;
    yheight2 = yheight;
} else this_box_storage.y_height2 = yheight2;


this_box_storage.normal_vectors[0] = coords_set(0,0,1);
this_box_storage.normal_vectors[1] = coords_set(0,0,1);

// for sides with y component = 0
x_component = 2*zdepth/sqrt((xwidth-xwidth2)*(xwidth-xwidth2)+4*zdepth*zdepth);
z_component = (xwidth-xwidth2)/sqrt(4*zdepth*zdepth+(xwidth-xwidth2)*(xwidth-xwidth2));

this_box_storage.normal_vectors[2] = coords_set(x_component,0,z_component);
this_box_storage.normal_vectors[3] = coords_set(-x_component,0,z_component);

// for sides with x component = 0
y_component = 2*zdepth/sqrt((yheight-yheight2)*(yheight-yheight2)+4*zdepth*zdepth);
z_component = (yheight-yheight2)/sqrt(4*zdepth*zdepth+(yheight-yheight2)*(yheight-yheight2));

this_box_storage.normal_vectors[4] = coords_set(0,y_component,z_component);
this_box_storage.normal_vectors[5] = coords_set(0,-y_component,z_component);

this_box_volume.geometry.visualization_on = visualize;

this_box_volume.geometry.geometry_parameters.p_box_storage = &this_box_storage;

// Assign pointers to functions for intersection with the shape, checking if a point is inside the shape
if (this_box_storage.is_rectangle == 1) {
this_box_volume.geometry.intersect_function = &sample_box_intersect_simple;
this_box_volume.geometry.within_function = &r_within_box_simple;
}
else {
this_box_volume.geometry.intersect_function = &sample_box_intersect_advanced;
this_box_volume.geometry.within_function = &r_within_box_advanced;
}

this_box_volume.geometry.shell_points = &box_shell_points;
this_box_volume.geometry.mcdisplay_function = &mcdisplay_box_function;
this_box_volume.geometry.initialize_from_main_function = &initialize_box_geometry_from_main_component;
this_box_volume.geometry.process_rot_allocated = 0;

this_box_volume.geometry.copy_geometry_parameters = &allocate_box_storage_copy;

rot_copy(this_box_volume.geometry.rotation_matrix,ROT_A_CURRENT_COMP); //check how ROT_R_CURRENT_COMP would work
rot_transpose(ROT_A_CURRENT_COMP,this_box_volume.geometry.transpose_rotation_matrix);

// Initialize loggers
this_box_volume.loggers.num_elements = 0;

// packing the information into the global_geometry_element, which is then included in the global_geometry_list.
sprintf(global_geometry_element.name,NAME_CURRENT_COMP);
global_geometry_element.activation_counter = number_of_activations;
global_geometry_element.component_index = INDEX_CURRENT_COMP;
global_geometry_element.Volume = &this_box_volume; // Would be nicer if this m was a pointer, now we have the (small) data two places
add_element_to_geometry_list(&global_geometry_list,global_geometry_element);
}
#line 313451 "MACS_sample_kidney_box.c"
#undef number_of_activations
#undef mask_setting
#undef mask_string
#undef p_interact
#undef focus_r
#undef focus_xh
#undef focus_xw
#undef focus_ah
#undef focus_aw
#undef target_z
#undef target_y
#undef target_x
#undef target_index
#undef visualize
#undef yheight2
#undef xwidth2
#undef zdepth
#undef yheight
#undef xwidth
#undef priority
#undef material_string
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

  /* Initializations for component inter_analyzer_colimator_16_blade_4. */
  SIG_MESSAGE("inter_analyzer_colimator_16_blade_4 (Init)");
#define mccompcurname  inter_analyzer_colimator_16_blade_4
#define mccompcurtype  Union_box
#define mccompcurindex 767
#define loop_index mccinter_analyzer_colimator_16_blade_4_loop_index
#define this_box_volume mccinter_analyzer_colimator_16_blade_4_this_box_volume
#define global_geometry_element mccinter_analyzer_colimator_16_blade_4_global_geometry_element
#define this_box_storage mccinter_analyzer_colimator_16_blade_4_this_box_storage
#define material_string mccinter_analyzer_colimator_16_blade_4_material_string
#define priority mccinter_analyzer_colimator_16_blade_4_priority
#define xwidth mccinter_analyzer_colimator_16_blade_4_xwidth
#define yheight mccinter_analyzer_colimator_16_blade_4_yheight
#define zdepth mccinter_analyzer_colimator_16_blade_4_zdepth
#define xwidth2 mccinter_analyzer_colimator_16_blade_4_xwidth2
#define yheight2 mccinter_analyzer_colimator_16_blade_4_yheight2
#define visualize mccinter_analyzer_colimator_16_blade_4_visualize
#define target_index mccinter_analyzer_colimator_16_blade_4_target_index
#define target_x mccinter_analyzer_colimator_16_blade_4_target_x
#define target_y mccinter_analyzer_colimator_16_blade_4_target_y
#define target_z mccinter_analyzer_colimator_16_blade_4_target_z
#define focus_aw mccinter_analyzer_colimator_16_blade_4_focus_aw
#define focus_ah mccinter_analyzer_colimator_16_blade_4_focus_ah
#define focus_xw mccinter_analyzer_colimator_16_blade_4_focus_xw
#define focus_xh mccinter_analyzer_colimator_16_blade_4_focus_xh
#define focus_r mccinter_analyzer_colimator_16_blade_4_focus_r
#define p_interact mccinter_analyzer_colimator_16_blade_4_p_interact
#define mask_string mccinter_analyzer_colimator_16_blade_4_mask_string
#define mask_setting mccinter_analyzer_colimator_16_blade_4_mask_setting
#define number_of_activations mccinter_analyzer_colimator_16_blade_4_number_of_activations
#line 224 "Union_box.comp"
{
// Initializes the focusing system for this volume including input sanitation.
focus_initialize(&this_box_volume.geometry, POS_A_COMP_INDEX(INDEX_CURRENT_COMP+target_index), POS_A_CURRENT_COMP, ROT_A_CURRENT_COMP, target_index, target_x, target_y, target_z, focus_aw, focus_ah, focus_xw, focus_xh, focus_r, NAME_CURRENT_COMP);

// Input sanitation for this geometry
if (xwidth <= 0) {
  printf("\nERROR in Union_box named %s, the xwidth is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (yheight <= 0) {
  printf("\nERROR in Union_box named %s, yheight is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (zdepth <= 0) {
  printf("\nERROR in Union_box named %s, zdepth is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (xwidth2 <= 0 && xwidth2 != -1) {
  printf("\nERROR in Union_box named %s, the xwidth2 is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (yheight2 <= 0 && yheight2 != -1) {
  printf("\nERROR in Union_box named %s, yheight2 is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}

// Use sanitation
if (global_material_list.num_elements == 0) {
  printf("\nERROR: Need to define a material using Union_make_material before using a Union geometry component. \n");
  printf("       %s was defined before first use of Union_make_material.\n",NAME_CURRENT_COMP);
  exit(1);
}

this_box_volume.geometry.is_masked_volume = 0;
this_box_volume.geometry.is_exit_volume = 0;
this_box_volume.geometry.is_mask_volume = 0;
// check if the volume is a mask, if it is the material string is irelevant.
if (mask_string && strlen(mask_string) && strcmp(mask_string, "NULL") && strcmp(mask_string, "0")) {
    // A mask volume is used to limit the extend of other volumes, called the masked volumes. These are specified in the mask_string.
    // In order for a ray to enter a masked volume, it needs to be both in the region covered by that volume AND the mask volume.
    // When more than
    this_box_volume.geometry.mask_mode = 1; // Default is mask mode is ALL
    if (mask_setting && strlen(mask_setting) && strcmp(mask_setting, "NULL") && strcmp(mask_setting, "0")) {
        if (strcmp(mask_setting,"ALL") == 0 || strcmp(mask_setting,"All") == 0) this_box_volume.geometry.mask_mode = 1;
        else if (strcmp(mask_setting,"ANY") == 0 || strcmp(mask_setting,"Any") == 0) this_box_volume.geometry.mask_mode = 2;
        else {
            printf("The mask_mode of component %s is set to %s, but must be either ALL or ANY.\n",NAME_CURRENT_COMP,mask_setting);
            exit(1);
        }
    }
    
    for (loop_index=0;loop_index<global_geometry_list.num_elements;loop_index++) {
        // Add mask list
        if (1 == manual_linking_function(global_geometry_list.elements[loop_index].name,mask_string)) {
            add_element_to_int_list(&this_box_volume.geometry.mask_list,global_geometry_list.elements[loop_index].component_index);
            add_element_to_int_list(&global_geometry_list.elements[loop_index].Volume->geometry.masked_by_list,INDEX_CURRENT_COMP);
            global_geometry_list.elements[loop_index].Volume->geometry.is_masked_volume = 1;
            if (this_box_volume.geometry.mask_mode == 2)
                global_geometry_list.elements[loop_index].Volume->geometry.mask_mode = 2;
            if (this_box_volume.geometry.mask_mode == 1) {
                if (global_geometry_list.elements[loop_index].Volume->geometry.is_masked_volume == 1 && global_geometry_list.elements[loop_index].Volume->geometry.mask_mode != 2)
                    // If more than one mask is added to one volume, the ANY mode overwrites the (default) ALL mode.
                    global_geometry_list.elements[loop_index].Volume->geometry.mask_mode = 1;
            }
            
            found_geometries = 1;
        }
    }
    if (found_geometries == 0) {
        printf("The mask_string in geometry: %s did not find any of the specified volumes in the mask_string %s \n",NAME_CURRENT_COMP,mask_string);
        exit(1);
    }
    this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
    this_box_volume.p_physics->is_vacuum = 0; // Makes this volume a vacuum
    this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
    this_box_volume.p_physics->my_a = 0; // Should not be used.
    sprintf(this_box_volume.p_physics->name,"Mask");
    this_box_volume.geometry.is_mask_volume = 1;
    
    
// Read the material input, or if it lacks, use automatic linking.
} else if (material_string && strlen(material_string) && strcmp(material_string, "NULL") && strcmp(material_string, "0")) {
    // A geometry string was given, use it to determine which material
    if (0 == strcmp(material_string,"vacuum") || 0 == strcmp(material_string,"Vacuum")) {
        // One could have a global physics struct for vacuum instead of creating one for each
        this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
        this_box_volume.p_physics->is_vacuum = 1; // Makes this volume a vacuum
        this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
        this_box_volume.p_physics->my_a = 0; // Should not be used.
        sprintf(this_box_volume.p_physics->name,"Vacuum");
    } else if (0 == strcmp(material_string,"exit") || 0 == strcmp(material_string,"Exit")) {
        // One could have a global physics struct for vacuum instead of creating one for each
        this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
        this_box_volume.p_physics->is_vacuum = 1; // Makes this volume a vacuum
        this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
        this_box_volume.p_physics->my_a = 0; // Should not be used.
        this_box_volume.geometry.is_exit_volume = 1;
        sprintf(this_box_volume.p_physics->name,"Exit");
    } else {
        #ifndef MATERIAL_DETECTOR
            printf("Need to define a material before refering to it in a geometry %s.\n",NAME_CURRENT_COMP);
            exit(1);
        #endif
        for (loop_index=0;loop_index<global_material_list.num_elements;loop_index++) {
            if (0 == strcmp(material_string,global_material_list.elements[loop_index].name)) {
                this_box_volume.p_physics = global_material_list.elements[loop_index].physics;
                break;
            }
            if (loop_index == global_material_list.num_elements-1) {
            printf("\n");
            printf("ERROR: The material string \"%s\" in Union geometry \"%s\" did not match a specified material. \n",material_string,NAME_CURRENT_COMP);
            printf("       The materials available at this point (need to be defined before the geometry): \n");
            for (loop_index=0;loop_index<global_material_list.num_elements;loop_index++)
              printf("         %s\n",global_material_list.elements[loop_index].name);
            printf("\n");
            printf("       It is also possible to use one of the defualt materials avaiable: \n");
            printf("           Vacuum (for a Volume without scattering or absorption)\n");
            printf("           Exit (for a Volume where the ray exits the component if it enters)\n");
            printf("           Mask (for a Volume that masks existing volumes specified in the mask_string\n");
            exit(1);
          }
        }
    }
} else {
    // Automatic linking, simply using the last defined material.
    #ifndef MATERIAL_DETECTOR
        printf("Need to define a material before the geometry to use automatic linking %s.\n",NAME_CURRENT_COMP);
        exit(1);
    #endif
    this_box_volume.p_physics = global_material_list.elements[global_material_list.num_elements-1].physics;
}

sprintf(this_box_volume.name,NAME_CURRENT_COMP);
sprintf(this_box_volume.geometry.shape,"box");
this_box_volume.geometry.priority_value = priority;
this_box_volume.geometry.geometry_p_interact = p_interact;
// Currently the coordinates will be in absolute space.
this_box_volume.geometry.center = POS_A_CURRENT_COMP;

this_box_storage.z_depth = zdepth;
this_box_storage.x_width1 = xwidth;
this_box_storage.y_height1 = yheight;

this_box_storage.is_rectangle = 0;
if (xwidth2 < 0 && yheight2 < 0) this_box_storage.is_rectangle = 1;
if (xwidth == xwidth2 && yheight == yheight2) this_box_storage.is_rectangle = 1;

if (xwidth2 < 0) {
    this_box_storage.x_width2 = xwidth;
    xwidth2 = xwidth;
} else this_box_storage.x_width2 = xwidth2;

if (yheight2 < 0) {
    this_box_storage.y_height2 = yheight;
    yheight2 = yheight;
} else this_box_storage.y_height2 = yheight2;


this_box_storage.normal_vectors[0] = coords_set(0,0,1);
this_box_storage.normal_vectors[1] = coords_set(0,0,1);

// for sides with y component = 0
x_component = 2*zdepth/sqrt((xwidth-xwidth2)*(xwidth-xwidth2)+4*zdepth*zdepth);
z_component = (xwidth-xwidth2)/sqrt(4*zdepth*zdepth+(xwidth-xwidth2)*(xwidth-xwidth2));

this_box_storage.normal_vectors[2] = coords_set(x_component,0,z_component);
this_box_storage.normal_vectors[3] = coords_set(-x_component,0,z_component);

// for sides with x component = 0
y_component = 2*zdepth/sqrt((yheight-yheight2)*(yheight-yheight2)+4*zdepth*zdepth);
z_component = (yheight-yheight2)/sqrt(4*zdepth*zdepth+(yheight-yheight2)*(yheight-yheight2));

this_box_storage.normal_vectors[4] = coords_set(0,y_component,z_component);
this_box_storage.normal_vectors[5] = coords_set(0,-y_component,z_component);

this_box_volume.geometry.visualization_on = visualize;

this_box_volume.geometry.geometry_parameters.p_box_storage = &this_box_storage;

// Assign pointers to functions for intersection with the shape, checking if a point is inside the shape
if (this_box_storage.is_rectangle == 1) {
this_box_volume.geometry.intersect_function = &sample_box_intersect_simple;
this_box_volume.geometry.within_function = &r_within_box_simple;
}
else {
this_box_volume.geometry.intersect_function = &sample_box_intersect_advanced;
this_box_volume.geometry.within_function = &r_within_box_advanced;
}

this_box_volume.geometry.shell_points = &box_shell_points;
this_box_volume.geometry.mcdisplay_function = &mcdisplay_box_function;
this_box_volume.geometry.initialize_from_main_function = &initialize_box_geometry_from_main_component;
this_box_volume.geometry.process_rot_allocated = 0;

this_box_volume.geometry.copy_geometry_parameters = &allocate_box_storage_copy;

rot_copy(this_box_volume.geometry.rotation_matrix,ROT_A_CURRENT_COMP); //check how ROT_R_CURRENT_COMP would work
rot_transpose(ROT_A_CURRENT_COMP,this_box_volume.geometry.transpose_rotation_matrix);

// Initialize loggers
this_box_volume.loggers.num_elements = 0;

// packing the information into the global_geometry_element, which is then included in the global_geometry_list.
sprintf(global_geometry_element.name,NAME_CURRENT_COMP);
global_geometry_element.activation_counter = number_of_activations;
global_geometry_element.component_index = INDEX_CURRENT_COMP;
global_geometry_element.Volume = &this_box_volume; // Would be nicer if this m was a pointer, now we have the (small) data two places
add_element_to_geometry_list(&global_geometry_list,global_geometry_element);
}
#line 313721 "MACS_sample_kidney_box.c"
#undef number_of_activations
#undef mask_setting
#undef mask_string
#undef p_interact
#undef focus_r
#undef focus_xh
#undef focus_xw
#undef focus_ah
#undef focus_aw
#undef target_z
#undef target_y
#undef target_x
#undef target_index
#undef visualize
#undef yheight2
#undef xwidth2
#undef zdepth
#undef yheight
#undef xwidth
#undef priority
#undef material_string
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

  /* Initializations for component diffraction_detector_16_exit_volume. */
  SIG_MESSAGE("diffraction_detector_16_exit_volume (Init)");
#define mccompcurname  diffraction_detector_16_exit_volume
#define mccompcurtype  Union_box
#define mccompcurindex 768
#define loop_index mccdiffraction_detector_16_exit_volume_loop_index
#define this_box_volume mccdiffraction_detector_16_exit_volume_this_box_volume
#define global_geometry_element mccdiffraction_detector_16_exit_volume_global_geometry_element
#define this_box_storage mccdiffraction_detector_16_exit_volume_this_box_storage
#define material_string mccdiffraction_detector_16_exit_volume_material_string
#define priority mccdiffraction_detector_16_exit_volume_priority
#define xwidth mccdiffraction_detector_16_exit_volume_xwidth
#define yheight mccdiffraction_detector_16_exit_volume_yheight
#define zdepth mccdiffraction_detector_16_exit_volume_zdepth
#define xwidth2 mccdiffraction_detector_16_exit_volume_xwidth2
#define yheight2 mccdiffraction_detector_16_exit_volume_yheight2
#define visualize mccdiffraction_detector_16_exit_volume_visualize
#define target_index mccdiffraction_detector_16_exit_volume_target_index
#define target_x mccdiffraction_detector_16_exit_volume_target_x
#define target_y mccdiffraction_detector_16_exit_volume_target_y
#define target_z mccdiffraction_detector_16_exit_volume_target_z
#define focus_aw mccdiffraction_detector_16_exit_volume_focus_aw
#define focus_ah mccdiffraction_detector_16_exit_volume_focus_ah
#define focus_xw mccdiffraction_detector_16_exit_volume_focus_xw
#define focus_xh mccdiffraction_detector_16_exit_volume_focus_xh
#define focus_r mccdiffraction_detector_16_exit_volume_focus_r
#define p_interact mccdiffraction_detector_16_exit_volume_p_interact
#define mask_string mccdiffraction_detector_16_exit_volume_mask_string
#define mask_setting mccdiffraction_detector_16_exit_volume_mask_setting
#define number_of_activations mccdiffraction_detector_16_exit_volume_number_of_activations
#line 224 "Union_box.comp"
{
// Initializes the focusing system for this volume including input sanitation.
focus_initialize(&this_box_volume.geometry, POS_A_COMP_INDEX(INDEX_CURRENT_COMP+target_index), POS_A_CURRENT_COMP, ROT_A_CURRENT_COMP, target_index, target_x, target_y, target_z, focus_aw, focus_ah, focus_xw, focus_xh, focus_r, NAME_CURRENT_COMP);

// Input sanitation for this geometry
if (xwidth <= 0) {
  printf("\nERROR in Union_box named %s, the xwidth is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (yheight <= 0) {
  printf("\nERROR in Union_box named %s, yheight is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (zdepth <= 0) {
  printf("\nERROR in Union_box named %s, zdepth is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (xwidth2 <= 0 && xwidth2 != -1) {
  printf("\nERROR in Union_box named %s, the xwidth2 is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (yheight2 <= 0 && yheight2 != -1) {
  printf("\nERROR in Union_box named %s, yheight2 is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}

// Use sanitation
if (global_material_list.num_elements == 0) {
  printf("\nERROR: Need to define a material using Union_make_material before using a Union geometry component. \n");
  printf("       %s was defined before first use of Union_make_material.\n",NAME_CURRENT_COMP);
  exit(1);
}

this_box_volume.geometry.is_masked_volume = 0;
this_box_volume.geometry.is_exit_volume = 0;
this_box_volume.geometry.is_mask_volume = 0;
// check if the volume is a mask, if it is the material string is irelevant.
if (mask_string && strlen(mask_string) && strcmp(mask_string, "NULL") && strcmp(mask_string, "0")) {
    // A mask volume is used to limit the extend of other volumes, called the masked volumes. These are specified in the mask_string.
    // In order for a ray to enter a masked volume, it needs to be both in the region covered by that volume AND the mask volume.
    // When more than
    this_box_volume.geometry.mask_mode = 1; // Default is mask mode is ALL
    if (mask_setting && strlen(mask_setting) && strcmp(mask_setting, "NULL") && strcmp(mask_setting, "0")) {
        if (strcmp(mask_setting,"ALL") == 0 || strcmp(mask_setting,"All") == 0) this_box_volume.geometry.mask_mode = 1;
        else if (strcmp(mask_setting,"ANY") == 0 || strcmp(mask_setting,"Any") == 0) this_box_volume.geometry.mask_mode = 2;
        else {
            printf("The mask_mode of component %s is set to %s, but must be either ALL or ANY.\n",NAME_CURRENT_COMP,mask_setting);
            exit(1);
        }
    }
    
    for (loop_index=0;loop_index<global_geometry_list.num_elements;loop_index++) {
        // Add mask list
        if (1 == manual_linking_function(global_geometry_list.elements[loop_index].name,mask_string)) {
            add_element_to_int_list(&this_box_volume.geometry.mask_list,global_geometry_list.elements[loop_index].component_index);
            add_element_to_int_list(&global_geometry_list.elements[loop_index].Volume->geometry.masked_by_list,INDEX_CURRENT_COMP);
            global_geometry_list.elements[loop_index].Volume->geometry.is_masked_volume = 1;
            if (this_box_volume.geometry.mask_mode == 2)
                global_geometry_list.elements[loop_index].Volume->geometry.mask_mode = 2;
            if (this_box_volume.geometry.mask_mode == 1) {
                if (global_geometry_list.elements[loop_index].Volume->geometry.is_masked_volume == 1 && global_geometry_list.elements[loop_index].Volume->geometry.mask_mode != 2)
                    // If more than one mask is added to one volume, the ANY mode overwrites the (default) ALL mode.
                    global_geometry_list.elements[loop_index].Volume->geometry.mask_mode = 1;
            }
            
            found_geometries = 1;
        }
    }
    if (found_geometries == 0) {
        printf("The mask_string in geometry: %s did not find any of the specified volumes in the mask_string %s \n",NAME_CURRENT_COMP,mask_string);
        exit(1);
    }
    this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
    this_box_volume.p_physics->is_vacuum = 0; // Makes this volume a vacuum
    this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
    this_box_volume.p_physics->my_a = 0; // Should not be used.
    sprintf(this_box_volume.p_physics->name,"Mask");
    this_box_volume.geometry.is_mask_volume = 1;
    
    
// Read the material input, or if it lacks, use automatic linking.
} else if (material_string && strlen(material_string) && strcmp(material_string, "NULL") && strcmp(material_string, "0")) {
    // A geometry string was given, use it to determine which material
    if (0 == strcmp(material_string,"vacuum") || 0 == strcmp(material_string,"Vacuum")) {
        // One could have a global physics struct for vacuum instead of creating one for each
        this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
        this_box_volume.p_physics->is_vacuum = 1; // Makes this volume a vacuum
        this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
        this_box_volume.p_physics->my_a = 0; // Should not be used.
        sprintf(this_box_volume.p_physics->name,"Vacuum");
    } else if (0 == strcmp(material_string,"exit") || 0 == strcmp(material_string,"Exit")) {
        // One could have a global physics struct for vacuum instead of creating one for each
        this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
        this_box_volume.p_physics->is_vacuum = 1; // Makes this volume a vacuum
        this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
        this_box_volume.p_physics->my_a = 0; // Should not be used.
        this_box_volume.geometry.is_exit_volume = 1;
        sprintf(this_box_volume.p_physics->name,"Exit");
    } else {
        #ifndef MATERIAL_DETECTOR
            printf("Need to define a material before refering to it in a geometry %s.\n",NAME_CURRENT_COMP);
            exit(1);
        #endif
        for (loop_index=0;loop_index<global_material_list.num_elements;loop_index++) {
            if (0 == strcmp(material_string,global_material_list.elements[loop_index].name)) {
                this_box_volume.p_physics = global_material_list.elements[loop_index].physics;
                break;
            }
            if (loop_index == global_material_list.num_elements-1) {
            printf("\n");
            printf("ERROR: The material string \"%s\" in Union geometry \"%s\" did not match a specified material. \n",material_string,NAME_CURRENT_COMP);
            printf("       The materials available at this point (need to be defined before the geometry): \n");
            for (loop_index=0;loop_index<global_material_list.num_elements;loop_index++)
              printf("         %s\n",global_material_list.elements[loop_index].name);
            printf("\n");
            printf("       It is also possible to use one of the defualt materials avaiable: \n");
            printf("           Vacuum (for a Volume without scattering or absorption)\n");
            printf("           Exit (for a Volume where the ray exits the component if it enters)\n");
            printf("           Mask (for a Volume that masks existing volumes specified in the mask_string\n");
            exit(1);
          }
        }
    }
} else {
    // Automatic linking, simply using the last defined material.
    #ifndef MATERIAL_DETECTOR
        printf("Need to define a material before the geometry to use automatic linking %s.\n",NAME_CURRENT_COMP);
        exit(1);
    #endif
    this_box_volume.p_physics = global_material_list.elements[global_material_list.num_elements-1].physics;
}

sprintf(this_box_volume.name,NAME_CURRENT_COMP);
sprintf(this_box_volume.geometry.shape,"box");
this_box_volume.geometry.priority_value = priority;
this_box_volume.geometry.geometry_p_interact = p_interact;
// Currently the coordinates will be in absolute space.
this_box_volume.geometry.center = POS_A_CURRENT_COMP;

this_box_storage.z_depth = zdepth;
this_box_storage.x_width1 = xwidth;
this_box_storage.y_height1 = yheight;

this_box_storage.is_rectangle = 0;
if (xwidth2 < 0 && yheight2 < 0) this_box_storage.is_rectangle = 1;
if (xwidth == xwidth2 && yheight == yheight2) this_box_storage.is_rectangle = 1;

if (xwidth2 < 0) {
    this_box_storage.x_width2 = xwidth;
    xwidth2 = xwidth;
} else this_box_storage.x_width2 = xwidth2;

if (yheight2 < 0) {
    this_box_storage.y_height2 = yheight;
    yheight2 = yheight;
} else this_box_storage.y_height2 = yheight2;


this_box_storage.normal_vectors[0] = coords_set(0,0,1);
this_box_storage.normal_vectors[1] = coords_set(0,0,1);

// for sides with y component = 0
x_component = 2*zdepth/sqrt((xwidth-xwidth2)*(xwidth-xwidth2)+4*zdepth*zdepth);
z_component = (xwidth-xwidth2)/sqrt(4*zdepth*zdepth+(xwidth-xwidth2)*(xwidth-xwidth2));

this_box_storage.normal_vectors[2] = coords_set(x_component,0,z_component);
this_box_storage.normal_vectors[3] = coords_set(-x_component,0,z_component);

// for sides with x component = 0
y_component = 2*zdepth/sqrt((yheight-yheight2)*(yheight-yheight2)+4*zdepth*zdepth);
z_component = (yheight-yheight2)/sqrt(4*zdepth*zdepth+(yheight-yheight2)*(yheight-yheight2));

this_box_storage.normal_vectors[4] = coords_set(0,y_component,z_component);
this_box_storage.normal_vectors[5] = coords_set(0,-y_component,z_component);

this_box_volume.geometry.visualization_on = visualize;

this_box_volume.geometry.geometry_parameters.p_box_storage = &this_box_storage;

// Assign pointers to functions for intersection with the shape, checking if a point is inside the shape
if (this_box_storage.is_rectangle == 1) {
this_box_volume.geometry.intersect_function = &sample_box_intersect_simple;
this_box_volume.geometry.within_function = &r_within_box_simple;
}
else {
this_box_volume.geometry.intersect_function = &sample_box_intersect_advanced;
this_box_volume.geometry.within_function = &r_within_box_advanced;
}

this_box_volume.geometry.shell_points = &box_shell_points;
this_box_volume.geometry.mcdisplay_function = &mcdisplay_box_function;
this_box_volume.geometry.initialize_from_main_function = &initialize_box_geometry_from_main_component;
this_box_volume.geometry.process_rot_allocated = 0;

this_box_volume.geometry.copy_geometry_parameters = &allocate_box_storage_copy;

rot_copy(this_box_volume.geometry.rotation_matrix,ROT_A_CURRENT_COMP); //check how ROT_R_CURRENT_COMP would work
rot_transpose(ROT_A_CURRENT_COMP,this_box_volume.geometry.transpose_rotation_matrix);

// Initialize loggers
this_box_volume.loggers.num_elements = 0;

// packing the information into the global_geometry_element, which is then included in the global_geometry_list.
sprintf(global_geometry_element.name,NAME_CURRENT_COMP);
global_geometry_element.activation_counter = number_of_activations;
global_geometry_element.component_index = INDEX_CURRENT_COMP;
global_geometry_element.Volume = &this_box_volume; // Would be nicer if this m was a pointer, now we have the (small) data two places
add_element_to_geometry_list(&global_geometry_list,global_geometry_element);
}
#line 313991 "MACS_sample_kidney_box.c"
#undef number_of_activations
#undef mask_setting
#undef mask_string
#undef p_interact
#undef focus_r
#undef focus_xh
#undef focus_xw
#undef focus_ah
#undef focus_aw
#undef target_z
#undef target_y
#undef target_x
#undef target_index
#undef visualize
#undef yheight2
#undef xwidth2
#undef zdepth
#undef yheight
#undef xwidth
#undef priority
#undef material_string
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

  /* Initializations for component spec_detector_16_exit_volume. */
  SIG_MESSAGE("spec_detector_16_exit_volume (Init)");
#define mccompcurname  spec_detector_16_exit_volume
#define mccompcurtype  Union_box
#define mccompcurindex 769
#define loop_index mccspec_detector_16_exit_volume_loop_index
#define this_box_volume mccspec_detector_16_exit_volume_this_box_volume
#define global_geometry_element mccspec_detector_16_exit_volume_global_geometry_element
#define this_box_storage mccspec_detector_16_exit_volume_this_box_storage
#define material_string mccspec_detector_16_exit_volume_material_string
#define priority mccspec_detector_16_exit_volume_priority
#define xwidth mccspec_detector_16_exit_volume_xwidth
#define yheight mccspec_detector_16_exit_volume_yheight
#define zdepth mccspec_detector_16_exit_volume_zdepth
#define xwidth2 mccspec_detector_16_exit_volume_xwidth2
#define yheight2 mccspec_detector_16_exit_volume_yheight2
#define visualize mccspec_detector_16_exit_volume_visualize
#define target_index mccspec_detector_16_exit_volume_target_index
#define target_x mccspec_detector_16_exit_volume_target_x
#define target_y mccspec_detector_16_exit_volume_target_y
#define target_z mccspec_detector_16_exit_volume_target_z
#define focus_aw mccspec_detector_16_exit_volume_focus_aw
#define focus_ah mccspec_detector_16_exit_volume_focus_ah
#define focus_xw mccspec_detector_16_exit_volume_focus_xw
#define focus_xh mccspec_detector_16_exit_volume_focus_xh
#define focus_r mccspec_detector_16_exit_volume_focus_r
#define p_interact mccspec_detector_16_exit_volume_p_interact
#define mask_string mccspec_detector_16_exit_volume_mask_string
#define mask_setting mccspec_detector_16_exit_volume_mask_setting
#define number_of_activations mccspec_detector_16_exit_volume_number_of_activations
#line 224 "Union_box.comp"
{
// Initializes the focusing system for this volume including input sanitation.
focus_initialize(&this_box_volume.geometry, POS_A_COMP_INDEX(INDEX_CURRENT_COMP+target_index), POS_A_CURRENT_COMP, ROT_A_CURRENT_COMP, target_index, target_x, target_y, target_z, focus_aw, focus_ah, focus_xw, focus_xh, focus_r, NAME_CURRENT_COMP);

// Input sanitation for this geometry
if (xwidth <= 0) {
  printf("\nERROR in Union_box named %s, the xwidth is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (yheight <= 0) {
  printf("\nERROR in Union_box named %s, yheight is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (zdepth <= 0) {
  printf("\nERROR in Union_box named %s, zdepth is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (xwidth2 <= 0 && xwidth2 != -1) {
  printf("\nERROR in Union_box named %s, the xwidth2 is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (yheight2 <= 0 && yheight2 != -1) {
  printf("\nERROR in Union_box named %s, yheight2 is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}

// Use sanitation
if (global_material_list.num_elements == 0) {
  printf("\nERROR: Need to define a material using Union_make_material before using a Union geometry component. \n");
  printf("       %s was defined before first use of Union_make_material.\n",NAME_CURRENT_COMP);
  exit(1);
}

this_box_volume.geometry.is_masked_volume = 0;
this_box_volume.geometry.is_exit_volume = 0;
this_box_volume.geometry.is_mask_volume = 0;
// check if the volume is a mask, if it is the material string is irelevant.
if (mask_string && strlen(mask_string) && strcmp(mask_string, "NULL") && strcmp(mask_string, "0")) {
    // A mask volume is used to limit the extend of other volumes, called the masked volumes. These are specified in the mask_string.
    // In order for a ray to enter a masked volume, it needs to be both in the region covered by that volume AND the mask volume.
    // When more than
    this_box_volume.geometry.mask_mode = 1; // Default is mask mode is ALL
    if (mask_setting && strlen(mask_setting) && strcmp(mask_setting, "NULL") && strcmp(mask_setting, "0")) {
        if (strcmp(mask_setting,"ALL") == 0 || strcmp(mask_setting,"All") == 0) this_box_volume.geometry.mask_mode = 1;
        else if (strcmp(mask_setting,"ANY") == 0 || strcmp(mask_setting,"Any") == 0) this_box_volume.geometry.mask_mode = 2;
        else {
            printf("The mask_mode of component %s is set to %s, but must be either ALL or ANY.\n",NAME_CURRENT_COMP,mask_setting);
            exit(1);
        }
    }
    
    for (loop_index=0;loop_index<global_geometry_list.num_elements;loop_index++) {
        // Add mask list
        if (1 == manual_linking_function(global_geometry_list.elements[loop_index].name,mask_string)) {
            add_element_to_int_list(&this_box_volume.geometry.mask_list,global_geometry_list.elements[loop_index].component_index);
            add_element_to_int_list(&global_geometry_list.elements[loop_index].Volume->geometry.masked_by_list,INDEX_CURRENT_COMP);
            global_geometry_list.elements[loop_index].Volume->geometry.is_masked_volume = 1;
            if (this_box_volume.geometry.mask_mode == 2)
                global_geometry_list.elements[loop_index].Volume->geometry.mask_mode = 2;
            if (this_box_volume.geometry.mask_mode == 1) {
                if (global_geometry_list.elements[loop_index].Volume->geometry.is_masked_volume == 1 && global_geometry_list.elements[loop_index].Volume->geometry.mask_mode != 2)
                    // If more than one mask is added to one volume, the ANY mode overwrites the (default) ALL mode.
                    global_geometry_list.elements[loop_index].Volume->geometry.mask_mode = 1;
            }
            
            found_geometries = 1;
        }
    }
    if (found_geometries == 0) {
        printf("The mask_string in geometry: %s did not find any of the specified volumes in the mask_string %s \n",NAME_CURRENT_COMP,mask_string);
        exit(1);
    }
    this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
    this_box_volume.p_physics->is_vacuum = 0; // Makes this volume a vacuum
    this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
    this_box_volume.p_physics->my_a = 0; // Should not be used.
    sprintf(this_box_volume.p_physics->name,"Mask");
    this_box_volume.geometry.is_mask_volume = 1;
    
    
// Read the material input, or if it lacks, use automatic linking.
} else if (material_string && strlen(material_string) && strcmp(material_string, "NULL") && strcmp(material_string, "0")) {
    // A geometry string was given, use it to determine which material
    if (0 == strcmp(material_string,"vacuum") || 0 == strcmp(material_string,"Vacuum")) {
        // One could have a global physics struct for vacuum instead of creating one for each
        this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
        this_box_volume.p_physics->is_vacuum = 1; // Makes this volume a vacuum
        this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
        this_box_volume.p_physics->my_a = 0; // Should not be used.
        sprintf(this_box_volume.p_physics->name,"Vacuum");
    } else if (0 == strcmp(material_string,"exit") || 0 == strcmp(material_string,"Exit")) {
        // One could have a global physics struct for vacuum instead of creating one for each
        this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
        this_box_volume.p_physics->is_vacuum = 1; // Makes this volume a vacuum
        this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
        this_box_volume.p_physics->my_a = 0; // Should not be used.
        this_box_volume.geometry.is_exit_volume = 1;
        sprintf(this_box_volume.p_physics->name,"Exit");
    } else {
        #ifndef MATERIAL_DETECTOR
            printf("Need to define a material before refering to it in a geometry %s.\n",NAME_CURRENT_COMP);
            exit(1);
        #endif
        for (loop_index=0;loop_index<global_material_list.num_elements;loop_index++) {
            if (0 == strcmp(material_string,global_material_list.elements[loop_index].name)) {
                this_box_volume.p_physics = global_material_list.elements[loop_index].physics;
                break;
            }
            if (loop_index == global_material_list.num_elements-1) {
            printf("\n");
            printf("ERROR: The material string \"%s\" in Union geometry \"%s\" did not match a specified material. \n",material_string,NAME_CURRENT_COMP);
            printf("       The materials available at this point (need to be defined before the geometry): \n");
            for (loop_index=0;loop_index<global_material_list.num_elements;loop_index++)
              printf("         %s\n",global_material_list.elements[loop_index].name);
            printf("\n");
            printf("       It is also possible to use one of the defualt materials avaiable: \n");
            printf("           Vacuum (for a Volume without scattering or absorption)\n");
            printf("           Exit (for a Volume where the ray exits the component if it enters)\n");
            printf("           Mask (for a Volume that masks existing volumes specified in the mask_string\n");
            exit(1);
          }
        }
    }
} else {
    // Automatic linking, simply using the last defined material.
    #ifndef MATERIAL_DETECTOR
        printf("Need to define a material before the geometry to use automatic linking %s.\n",NAME_CURRENT_COMP);
        exit(1);
    #endif
    this_box_volume.p_physics = global_material_list.elements[global_material_list.num_elements-1].physics;
}

sprintf(this_box_volume.name,NAME_CURRENT_COMP);
sprintf(this_box_volume.geometry.shape,"box");
this_box_volume.geometry.priority_value = priority;
this_box_volume.geometry.geometry_p_interact = p_interact;
// Currently the coordinates will be in absolute space.
this_box_volume.geometry.center = POS_A_CURRENT_COMP;

this_box_storage.z_depth = zdepth;
this_box_storage.x_width1 = xwidth;
this_box_storage.y_height1 = yheight;

this_box_storage.is_rectangle = 0;
if (xwidth2 < 0 && yheight2 < 0) this_box_storage.is_rectangle = 1;
if (xwidth == xwidth2 && yheight == yheight2) this_box_storage.is_rectangle = 1;

if (xwidth2 < 0) {
    this_box_storage.x_width2 = xwidth;
    xwidth2 = xwidth;
} else this_box_storage.x_width2 = xwidth2;

if (yheight2 < 0) {
    this_box_storage.y_height2 = yheight;
    yheight2 = yheight;
} else this_box_storage.y_height2 = yheight2;


this_box_storage.normal_vectors[0] = coords_set(0,0,1);
this_box_storage.normal_vectors[1] = coords_set(0,0,1);

// for sides with y component = 0
x_component = 2*zdepth/sqrt((xwidth-xwidth2)*(xwidth-xwidth2)+4*zdepth*zdepth);
z_component = (xwidth-xwidth2)/sqrt(4*zdepth*zdepth+(xwidth-xwidth2)*(xwidth-xwidth2));

this_box_storage.normal_vectors[2] = coords_set(x_component,0,z_component);
this_box_storage.normal_vectors[3] = coords_set(-x_component,0,z_component);

// for sides with x component = 0
y_component = 2*zdepth/sqrt((yheight-yheight2)*(yheight-yheight2)+4*zdepth*zdepth);
z_component = (yheight-yheight2)/sqrt(4*zdepth*zdepth+(yheight-yheight2)*(yheight-yheight2));

this_box_storage.normal_vectors[4] = coords_set(0,y_component,z_component);
this_box_storage.normal_vectors[5] = coords_set(0,-y_component,z_component);

this_box_volume.geometry.visualization_on = visualize;

this_box_volume.geometry.geometry_parameters.p_box_storage = &this_box_storage;

// Assign pointers to functions for intersection with the shape, checking if a point is inside the shape
if (this_box_storage.is_rectangle == 1) {
this_box_volume.geometry.intersect_function = &sample_box_intersect_simple;
this_box_volume.geometry.within_function = &r_within_box_simple;
}
else {
this_box_volume.geometry.intersect_function = &sample_box_intersect_advanced;
this_box_volume.geometry.within_function = &r_within_box_advanced;
}

this_box_volume.geometry.shell_points = &box_shell_points;
this_box_volume.geometry.mcdisplay_function = &mcdisplay_box_function;
this_box_volume.geometry.initialize_from_main_function = &initialize_box_geometry_from_main_component;
this_box_volume.geometry.process_rot_allocated = 0;

this_box_volume.geometry.copy_geometry_parameters = &allocate_box_storage_copy;

rot_copy(this_box_volume.geometry.rotation_matrix,ROT_A_CURRENT_COMP); //check how ROT_R_CURRENT_COMP would work
rot_transpose(ROT_A_CURRENT_COMP,this_box_volume.geometry.transpose_rotation_matrix);

// Initialize loggers
this_box_volume.loggers.num_elements = 0;

// packing the information into the global_geometry_element, which is then included in the global_geometry_list.
sprintf(global_geometry_element.name,NAME_CURRENT_COMP);
global_geometry_element.activation_counter = number_of_activations;
global_geometry_element.component_index = INDEX_CURRENT_COMP;
global_geometry_element.Volume = &this_box_volume; // Would be nicer if this m was a pointer, now we have the (small) data two places
add_element_to_geometry_list(&global_geometry_list,global_geometry_element);
}
#line 314261 "MACS_sample_kidney_box.c"
#undef number_of_activations
#undef mask_setting
#undef mask_string
#undef p_interact
#undef focus_r
#undef focus_xh
#undef focus_xw
#undef focus_ah
#undef focus_aw
#undef target_z
#undef target_y
#undef target_x
#undef target_index
#undef visualize
#undef yheight2
#undef xwidth2
#undef zdepth
#undef yheight
#undef xwidth
#undef priority
#undef material_string
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

  /* Initializations for component channel_17_cave1_box1. */
  SIG_MESSAGE("channel_17_cave1_box1 (Init)");
#define mccompcurname  channel_17_cave1_box1
#define mccompcurtype  Union_box
#define mccompcurindex 770
#define loop_index mccchannel_17_cave1_box1_loop_index
#define this_box_volume mccchannel_17_cave1_box1_this_box_volume
#define global_geometry_element mccchannel_17_cave1_box1_global_geometry_element
#define this_box_storage mccchannel_17_cave1_box1_this_box_storage
#define material_string mccchannel_17_cave1_box1_material_string
#define priority mccchannel_17_cave1_box1_priority
#define xwidth mccchannel_17_cave1_box1_xwidth
#define yheight mccchannel_17_cave1_box1_yheight
#define zdepth mccchannel_17_cave1_box1_zdepth
#define xwidth2 mccchannel_17_cave1_box1_xwidth2
#define yheight2 mccchannel_17_cave1_box1_yheight2
#define visualize mccchannel_17_cave1_box1_visualize
#define target_index mccchannel_17_cave1_box1_target_index
#define target_x mccchannel_17_cave1_box1_target_x
#define target_y mccchannel_17_cave1_box1_target_y
#define target_z mccchannel_17_cave1_box1_target_z
#define focus_aw mccchannel_17_cave1_box1_focus_aw
#define focus_ah mccchannel_17_cave1_box1_focus_ah
#define focus_xw mccchannel_17_cave1_box1_focus_xw
#define focus_xh mccchannel_17_cave1_box1_focus_xh
#define focus_r mccchannel_17_cave1_box1_focus_r
#define p_interact mccchannel_17_cave1_box1_p_interact
#define mask_string mccchannel_17_cave1_box1_mask_string
#define mask_setting mccchannel_17_cave1_box1_mask_setting
#define number_of_activations mccchannel_17_cave1_box1_number_of_activations
#line 224 "Union_box.comp"
{
// Initializes the focusing system for this volume including input sanitation.
focus_initialize(&this_box_volume.geometry, POS_A_COMP_INDEX(INDEX_CURRENT_COMP+target_index), POS_A_CURRENT_COMP, ROT_A_CURRENT_COMP, target_index, target_x, target_y, target_z, focus_aw, focus_ah, focus_xw, focus_xh, focus_r, NAME_CURRENT_COMP);

// Input sanitation for this geometry
if (xwidth <= 0) {
  printf("\nERROR in Union_box named %s, the xwidth is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (yheight <= 0) {
  printf("\nERROR in Union_box named %s, yheight is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (zdepth <= 0) {
  printf("\nERROR in Union_box named %s, zdepth is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (xwidth2 <= 0 && xwidth2 != -1) {
  printf("\nERROR in Union_box named %s, the xwidth2 is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (yheight2 <= 0 && yheight2 != -1) {
  printf("\nERROR in Union_box named %s, yheight2 is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}

// Use sanitation
if (global_material_list.num_elements == 0) {
  printf("\nERROR: Need to define a material using Union_make_material before using a Union geometry component. \n");
  printf("       %s was defined before first use of Union_make_material.\n",NAME_CURRENT_COMP);
  exit(1);
}

this_box_volume.geometry.is_masked_volume = 0;
this_box_volume.geometry.is_exit_volume = 0;
this_box_volume.geometry.is_mask_volume = 0;
// check if the volume is a mask, if it is the material string is irelevant.
if (mask_string && strlen(mask_string) && strcmp(mask_string, "NULL") && strcmp(mask_string, "0")) {
    // A mask volume is used to limit the extend of other volumes, called the masked volumes. These are specified in the mask_string.
    // In order for a ray to enter a masked volume, it needs to be both in the region covered by that volume AND the mask volume.
    // When more than
    this_box_volume.geometry.mask_mode = 1; // Default is mask mode is ALL
    if (mask_setting && strlen(mask_setting) && strcmp(mask_setting, "NULL") && strcmp(mask_setting, "0")) {
        if (strcmp(mask_setting,"ALL") == 0 || strcmp(mask_setting,"All") == 0) this_box_volume.geometry.mask_mode = 1;
        else if (strcmp(mask_setting,"ANY") == 0 || strcmp(mask_setting,"Any") == 0) this_box_volume.geometry.mask_mode = 2;
        else {
            printf("The mask_mode of component %s is set to %s, but must be either ALL or ANY.\n",NAME_CURRENT_COMP,mask_setting);
            exit(1);
        }
    }
    
    for (loop_index=0;loop_index<global_geometry_list.num_elements;loop_index++) {
        // Add mask list
        if (1 == manual_linking_function(global_geometry_list.elements[loop_index].name,mask_string)) {
            add_element_to_int_list(&this_box_volume.geometry.mask_list,global_geometry_list.elements[loop_index].component_index);
            add_element_to_int_list(&global_geometry_list.elements[loop_index].Volume->geometry.masked_by_list,INDEX_CURRENT_COMP);
            global_geometry_list.elements[loop_index].Volume->geometry.is_masked_volume = 1;
            if (this_box_volume.geometry.mask_mode == 2)
                global_geometry_list.elements[loop_index].Volume->geometry.mask_mode = 2;
            if (this_box_volume.geometry.mask_mode == 1) {
                if (global_geometry_list.elements[loop_index].Volume->geometry.is_masked_volume == 1 && global_geometry_list.elements[loop_index].Volume->geometry.mask_mode != 2)
                    // If more than one mask is added to one volume, the ANY mode overwrites the (default) ALL mode.
                    global_geometry_list.elements[loop_index].Volume->geometry.mask_mode = 1;
            }
            
            found_geometries = 1;
        }
    }
    if (found_geometries == 0) {
        printf("The mask_string in geometry: %s did not find any of the specified volumes in the mask_string %s \n",NAME_CURRENT_COMP,mask_string);
        exit(1);
    }
    this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
    this_box_volume.p_physics->is_vacuum = 0; // Makes this volume a vacuum
    this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
    this_box_volume.p_physics->my_a = 0; // Should not be used.
    sprintf(this_box_volume.p_physics->name,"Mask");
    this_box_volume.geometry.is_mask_volume = 1;
    
    
// Read the material input, or if it lacks, use automatic linking.
} else if (material_string && strlen(material_string) && strcmp(material_string, "NULL") && strcmp(material_string, "0")) {
    // A geometry string was given, use it to determine which material
    if (0 == strcmp(material_string,"vacuum") || 0 == strcmp(material_string,"Vacuum")) {
        // One could have a global physics struct for vacuum instead of creating one for each
        this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
        this_box_volume.p_physics->is_vacuum = 1; // Makes this volume a vacuum
        this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
        this_box_volume.p_physics->my_a = 0; // Should not be used.
        sprintf(this_box_volume.p_physics->name,"Vacuum");
    } else if (0 == strcmp(material_string,"exit") || 0 == strcmp(material_string,"Exit")) {
        // One could have a global physics struct for vacuum instead of creating one for each
        this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
        this_box_volume.p_physics->is_vacuum = 1; // Makes this volume a vacuum
        this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
        this_box_volume.p_physics->my_a = 0; // Should not be used.
        this_box_volume.geometry.is_exit_volume = 1;
        sprintf(this_box_volume.p_physics->name,"Exit");
    } else {
        #ifndef MATERIAL_DETECTOR
            printf("Need to define a material before refering to it in a geometry %s.\n",NAME_CURRENT_COMP);
            exit(1);
        #endif
        for (loop_index=0;loop_index<global_material_list.num_elements;loop_index++) {
            if (0 == strcmp(material_string,global_material_list.elements[loop_index].name)) {
                this_box_volume.p_physics = global_material_list.elements[loop_index].physics;
                break;
            }
            if (loop_index == global_material_list.num_elements-1) {
            printf("\n");
            printf("ERROR: The material string \"%s\" in Union geometry \"%s\" did not match a specified material. \n",material_string,NAME_CURRENT_COMP);
            printf("       The materials available at this point (need to be defined before the geometry): \n");
            for (loop_index=0;loop_index<global_material_list.num_elements;loop_index++)
              printf("         %s\n",global_material_list.elements[loop_index].name);
            printf("\n");
            printf("       It is also possible to use one of the defualt materials avaiable: \n");
            printf("           Vacuum (for a Volume without scattering or absorption)\n");
            printf("           Exit (for a Volume where the ray exits the component if it enters)\n");
            printf("           Mask (for a Volume that masks existing volumes specified in the mask_string\n");
            exit(1);
          }
        }
    }
} else {
    // Automatic linking, simply using the last defined material.
    #ifndef MATERIAL_DETECTOR
        printf("Need to define a material before the geometry to use automatic linking %s.\n",NAME_CURRENT_COMP);
        exit(1);
    #endif
    this_box_volume.p_physics = global_material_list.elements[global_material_list.num_elements-1].physics;
}

sprintf(this_box_volume.name,NAME_CURRENT_COMP);
sprintf(this_box_volume.geometry.shape,"box");
this_box_volume.geometry.priority_value = priority;
this_box_volume.geometry.geometry_p_interact = p_interact;
// Currently the coordinates will be in absolute space.
this_box_volume.geometry.center = POS_A_CURRENT_COMP;

this_box_storage.z_depth = zdepth;
this_box_storage.x_width1 = xwidth;
this_box_storage.y_height1 = yheight;

this_box_storage.is_rectangle = 0;
if (xwidth2 < 0 && yheight2 < 0) this_box_storage.is_rectangle = 1;
if (xwidth == xwidth2 && yheight == yheight2) this_box_storage.is_rectangle = 1;

if (xwidth2 < 0) {
    this_box_storage.x_width2 = xwidth;
    xwidth2 = xwidth;
} else this_box_storage.x_width2 = xwidth2;

if (yheight2 < 0) {
    this_box_storage.y_height2 = yheight;
    yheight2 = yheight;
} else this_box_storage.y_height2 = yheight2;


this_box_storage.normal_vectors[0] = coords_set(0,0,1);
this_box_storage.normal_vectors[1] = coords_set(0,0,1);

// for sides with y component = 0
x_component = 2*zdepth/sqrt((xwidth-xwidth2)*(xwidth-xwidth2)+4*zdepth*zdepth);
z_component = (xwidth-xwidth2)/sqrt(4*zdepth*zdepth+(xwidth-xwidth2)*(xwidth-xwidth2));

this_box_storage.normal_vectors[2] = coords_set(x_component,0,z_component);
this_box_storage.normal_vectors[3] = coords_set(-x_component,0,z_component);

// for sides with x component = 0
y_component = 2*zdepth/sqrt((yheight-yheight2)*(yheight-yheight2)+4*zdepth*zdepth);
z_component = (yheight-yheight2)/sqrt(4*zdepth*zdepth+(yheight-yheight2)*(yheight-yheight2));

this_box_storage.normal_vectors[4] = coords_set(0,y_component,z_component);
this_box_storage.normal_vectors[5] = coords_set(0,-y_component,z_component);

this_box_volume.geometry.visualization_on = visualize;

this_box_volume.geometry.geometry_parameters.p_box_storage = &this_box_storage;

// Assign pointers to functions for intersection with the shape, checking if a point is inside the shape
if (this_box_storage.is_rectangle == 1) {
this_box_volume.geometry.intersect_function = &sample_box_intersect_simple;
this_box_volume.geometry.within_function = &r_within_box_simple;
}
else {
this_box_volume.geometry.intersect_function = &sample_box_intersect_advanced;
this_box_volume.geometry.within_function = &r_within_box_advanced;
}

this_box_volume.geometry.shell_points = &box_shell_points;
this_box_volume.geometry.mcdisplay_function = &mcdisplay_box_function;
this_box_volume.geometry.initialize_from_main_function = &initialize_box_geometry_from_main_component;
this_box_volume.geometry.process_rot_allocated = 0;

this_box_volume.geometry.copy_geometry_parameters = &allocate_box_storage_copy;

rot_copy(this_box_volume.geometry.rotation_matrix,ROT_A_CURRENT_COMP); //check how ROT_R_CURRENT_COMP would work
rot_transpose(ROT_A_CURRENT_COMP,this_box_volume.geometry.transpose_rotation_matrix);

// Initialize loggers
this_box_volume.loggers.num_elements = 0;

// packing the information into the global_geometry_element, which is then included in the global_geometry_list.
sprintf(global_geometry_element.name,NAME_CURRENT_COMP);
global_geometry_element.activation_counter = number_of_activations;
global_geometry_element.component_index = INDEX_CURRENT_COMP;
global_geometry_element.Volume = &this_box_volume; // Would be nicer if this m was a pointer, now we have the (small) data two places
add_element_to_geometry_list(&global_geometry_list,global_geometry_element);
}
#line 314531 "MACS_sample_kidney_box.c"
#undef number_of_activations
#undef mask_setting
#undef mask_string
#undef p_interact
#undef focus_r
#undef focus_xh
#undef focus_xw
#undef focus_ah
#undef focus_aw
#undef target_z
#undef target_y
#undef target_x
#undef target_index
#undef visualize
#undef yheight2
#undef xwidth2
#undef zdepth
#undef yheight
#undef xwidth
#undef priority
#undef material_string
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

  /* Initializations for component channel_17_cave1_box2. */
  SIG_MESSAGE("channel_17_cave1_box2 (Init)");
#define mccompcurname  channel_17_cave1_box2
#define mccompcurtype  Union_box
#define mccompcurindex 771
#define loop_index mccchannel_17_cave1_box2_loop_index
#define this_box_volume mccchannel_17_cave1_box2_this_box_volume
#define global_geometry_element mccchannel_17_cave1_box2_global_geometry_element
#define this_box_storage mccchannel_17_cave1_box2_this_box_storage
#define material_string mccchannel_17_cave1_box2_material_string
#define priority mccchannel_17_cave1_box2_priority
#define xwidth mccchannel_17_cave1_box2_xwidth
#define yheight mccchannel_17_cave1_box2_yheight
#define zdepth mccchannel_17_cave1_box2_zdepth
#define xwidth2 mccchannel_17_cave1_box2_xwidth2
#define yheight2 mccchannel_17_cave1_box2_yheight2
#define visualize mccchannel_17_cave1_box2_visualize
#define target_index mccchannel_17_cave1_box2_target_index
#define target_x mccchannel_17_cave1_box2_target_x
#define target_y mccchannel_17_cave1_box2_target_y
#define target_z mccchannel_17_cave1_box2_target_z
#define focus_aw mccchannel_17_cave1_box2_focus_aw
#define focus_ah mccchannel_17_cave1_box2_focus_ah
#define focus_xw mccchannel_17_cave1_box2_focus_xw
#define focus_xh mccchannel_17_cave1_box2_focus_xh
#define focus_r mccchannel_17_cave1_box2_focus_r
#define p_interact mccchannel_17_cave1_box2_p_interact
#define mask_string mccchannel_17_cave1_box2_mask_string
#define mask_setting mccchannel_17_cave1_box2_mask_setting
#define number_of_activations mccchannel_17_cave1_box2_number_of_activations
#line 224 "Union_box.comp"
{
// Initializes the focusing system for this volume including input sanitation.
focus_initialize(&this_box_volume.geometry, POS_A_COMP_INDEX(INDEX_CURRENT_COMP+target_index), POS_A_CURRENT_COMP, ROT_A_CURRENT_COMP, target_index, target_x, target_y, target_z, focus_aw, focus_ah, focus_xw, focus_xh, focus_r, NAME_CURRENT_COMP);

// Input sanitation for this geometry
if (xwidth <= 0) {
  printf("\nERROR in Union_box named %s, the xwidth is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (yheight <= 0) {
  printf("\nERROR in Union_box named %s, yheight is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (zdepth <= 0) {
  printf("\nERROR in Union_box named %s, zdepth is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (xwidth2 <= 0 && xwidth2 != -1) {
  printf("\nERROR in Union_box named %s, the xwidth2 is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (yheight2 <= 0 && yheight2 != -1) {
  printf("\nERROR in Union_box named %s, yheight2 is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}

// Use sanitation
if (global_material_list.num_elements == 0) {
  printf("\nERROR: Need to define a material using Union_make_material before using a Union geometry component. \n");
  printf("       %s was defined before first use of Union_make_material.\n",NAME_CURRENT_COMP);
  exit(1);
}

this_box_volume.geometry.is_masked_volume = 0;
this_box_volume.geometry.is_exit_volume = 0;
this_box_volume.geometry.is_mask_volume = 0;
// check if the volume is a mask, if it is the material string is irelevant.
if (mask_string && strlen(mask_string) && strcmp(mask_string, "NULL") && strcmp(mask_string, "0")) {
    // A mask volume is used to limit the extend of other volumes, called the masked volumes. These are specified in the mask_string.
    // In order for a ray to enter a masked volume, it needs to be both in the region covered by that volume AND the mask volume.
    // When more than
    this_box_volume.geometry.mask_mode = 1; // Default is mask mode is ALL
    if (mask_setting && strlen(mask_setting) && strcmp(mask_setting, "NULL") && strcmp(mask_setting, "0")) {
        if (strcmp(mask_setting,"ALL") == 0 || strcmp(mask_setting,"All") == 0) this_box_volume.geometry.mask_mode = 1;
        else if (strcmp(mask_setting,"ANY") == 0 || strcmp(mask_setting,"Any") == 0) this_box_volume.geometry.mask_mode = 2;
        else {
            printf("The mask_mode of component %s is set to %s, but must be either ALL or ANY.\n",NAME_CURRENT_COMP,mask_setting);
            exit(1);
        }
    }
    
    for (loop_index=0;loop_index<global_geometry_list.num_elements;loop_index++) {
        // Add mask list
        if (1 == manual_linking_function(global_geometry_list.elements[loop_index].name,mask_string)) {
            add_element_to_int_list(&this_box_volume.geometry.mask_list,global_geometry_list.elements[loop_index].component_index);
            add_element_to_int_list(&global_geometry_list.elements[loop_index].Volume->geometry.masked_by_list,INDEX_CURRENT_COMP);
            global_geometry_list.elements[loop_index].Volume->geometry.is_masked_volume = 1;
            if (this_box_volume.geometry.mask_mode == 2)
                global_geometry_list.elements[loop_index].Volume->geometry.mask_mode = 2;
            if (this_box_volume.geometry.mask_mode == 1) {
                if (global_geometry_list.elements[loop_index].Volume->geometry.is_masked_volume == 1 && global_geometry_list.elements[loop_index].Volume->geometry.mask_mode != 2)
                    // If more than one mask is added to one volume, the ANY mode overwrites the (default) ALL mode.
                    global_geometry_list.elements[loop_index].Volume->geometry.mask_mode = 1;
            }
            
            found_geometries = 1;
        }
    }
    if (found_geometries == 0) {
        printf("The mask_string in geometry: %s did not find any of the specified volumes in the mask_string %s \n",NAME_CURRENT_COMP,mask_string);
        exit(1);
    }
    this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
    this_box_volume.p_physics->is_vacuum = 0; // Makes this volume a vacuum
    this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
    this_box_volume.p_physics->my_a = 0; // Should not be used.
    sprintf(this_box_volume.p_physics->name,"Mask");
    this_box_volume.geometry.is_mask_volume = 1;
    
    
// Read the material input, or if it lacks, use automatic linking.
} else if (material_string && strlen(material_string) && strcmp(material_string, "NULL") && strcmp(material_string, "0")) {
    // A geometry string was given, use it to determine which material
    if (0 == strcmp(material_string,"vacuum") || 0 == strcmp(material_string,"Vacuum")) {
        // One could have a global physics struct for vacuum instead of creating one for each
        this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
        this_box_volume.p_physics->is_vacuum = 1; // Makes this volume a vacuum
        this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
        this_box_volume.p_physics->my_a = 0; // Should not be used.
        sprintf(this_box_volume.p_physics->name,"Vacuum");
    } else if (0 == strcmp(material_string,"exit") || 0 == strcmp(material_string,"Exit")) {
        // One could have a global physics struct for vacuum instead of creating one for each
        this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
        this_box_volume.p_physics->is_vacuum = 1; // Makes this volume a vacuum
        this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
        this_box_volume.p_physics->my_a = 0; // Should not be used.
        this_box_volume.geometry.is_exit_volume = 1;
        sprintf(this_box_volume.p_physics->name,"Exit");
    } else {
        #ifndef MATERIAL_DETECTOR
            printf("Need to define a material before refering to it in a geometry %s.\n",NAME_CURRENT_COMP);
            exit(1);
        #endif
        for (loop_index=0;loop_index<global_material_list.num_elements;loop_index++) {
            if (0 == strcmp(material_string,global_material_list.elements[loop_index].name)) {
                this_box_volume.p_physics = global_material_list.elements[loop_index].physics;
                break;
            }
            if (loop_index == global_material_list.num_elements-1) {
            printf("\n");
            printf("ERROR: The material string \"%s\" in Union geometry \"%s\" did not match a specified material. \n",material_string,NAME_CURRENT_COMP);
            printf("       The materials available at this point (need to be defined before the geometry): \n");
            for (loop_index=0;loop_index<global_material_list.num_elements;loop_index++)
              printf("         %s\n",global_material_list.elements[loop_index].name);
            printf("\n");
            printf("       It is also possible to use one of the defualt materials avaiable: \n");
            printf("           Vacuum (for a Volume without scattering or absorption)\n");
            printf("           Exit (for a Volume where the ray exits the component if it enters)\n");
            printf("           Mask (for a Volume that masks existing volumes specified in the mask_string\n");
            exit(1);
          }
        }
    }
} else {
    // Automatic linking, simply using the last defined material.
    #ifndef MATERIAL_DETECTOR
        printf("Need to define a material before the geometry to use automatic linking %s.\n",NAME_CURRENT_COMP);
        exit(1);
    #endif
    this_box_volume.p_physics = global_material_list.elements[global_material_list.num_elements-1].physics;
}

sprintf(this_box_volume.name,NAME_CURRENT_COMP);
sprintf(this_box_volume.geometry.shape,"box");
this_box_volume.geometry.priority_value = priority;
this_box_volume.geometry.geometry_p_interact = p_interact;
// Currently the coordinates will be in absolute space.
this_box_volume.geometry.center = POS_A_CURRENT_COMP;

this_box_storage.z_depth = zdepth;
this_box_storage.x_width1 = xwidth;
this_box_storage.y_height1 = yheight;

this_box_storage.is_rectangle = 0;
if (xwidth2 < 0 && yheight2 < 0) this_box_storage.is_rectangle = 1;
if (xwidth == xwidth2 && yheight == yheight2) this_box_storage.is_rectangle = 1;

if (xwidth2 < 0) {
    this_box_storage.x_width2 = xwidth;
    xwidth2 = xwidth;
} else this_box_storage.x_width2 = xwidth2;

if (yheight2 < 0) {
    this_box_storage.y_height2 = yheight;
    yheight2 = yheight;
} else this_box_storage.y_height2 = yheight2;


this_box_storage.normal_vectors[0] = coords_set(0,0,1);
this_box_storage.normal_vectors[1] = coords_set(0,0,1);

// for sides with y component = 0
x_component = 2*zdepth/sqrt((xwidth-xwidth2)*(xwidth-xwidth2)+4*zdepth*zdepth);
z_component = (xwidth-xwidth2)/sqrt(4*zdepth*zdepth+(xwidth-xwidth2)*(xwidth-xwidth2));

this_box_storage.normal_vectors[2] = coords_set(x_component,0,z_component);
this_box_storage.normal_vectors[3] = coords_set(-x_component,0,z_component);

// for sides with x component = 0
y_component = 2*zdepth/sqrt((yheight-yheight2)*(yheight-yheight2)+4*zdepth*zdepth);
z_component = (yheight-yheight2)/sqrt(4*zdepth*zdepth+(yheight-yheight2)*(yheight-yheight2));

this_box_storage.normal_vectors[4] = coords_set(0,y_component,z_component);
this_box_storage.normal_vectors[5] = coords_set(0,-y_component,z_component);

this_box_volume.geometry.visualization_on = visualize;

this_box_volume.geometry.geometry_parameters.p_box_storage = &this_box_storage;

// Assign pointers to functions for intersection with the shape, checking if a point is inside the shape
if (this_box_storage.is_rectangle == 1) {
this_box_volume.geometry.intersect_function = &sample_box_intersect_simple;
this_box_volume.geometry.within_function = &r_within_box_simple;
}
else {
this_box_volume.geometry.intersect_function = &sample_box_intersect_advanced;
this_box_volume.geometry.within_function = &r_within_box_advanced;
}

this_box_volume.geometry.shell_points = &box_shell_points;
this_box_volume.geometry.mcdisplay_function = &mcdisplay_box_function;
this_box_volume.geometry.initialize_from_main_function = &initialize_box_geometry_from_main_component;
this_box_volume.geometry.process_rot_allocated = 0;

this_box_volume.geometry.copy_geometry_parameters = &allocate_box_storage_copy;

rot_copy(this_box_volume.geometry.rotation_matrix,ROT_A_CURRENT_COMP); //check how ROT_R_CURRENT_COMP would work
rot_transpose(ROT_A_CURRENT_COMP,this_box_volume.geometry.transpose_rotation_matrix);

// Initialize loggers
this_box_volume.loggers.num_elements = 0;

// packing the information into the global_geometry_element, which is then included in the global_geometry_list.
sprintf(global_geometry_element.name,NAME_CURRENT_COMP);
global_geometry_element.activation_counter = number_of_activations;
global_geometry_element.component_index = INDEX_CURRENT_COMP;
global_geometry_element.Volume = &this_box_volume; // Would be nicer if this m was a pointer, now we have the (small) data two places
add_element_to_geometry_list(&global_geometry_list,global_geometry_element);
}
#line 314801 "MACS_sample_kidney_box.c"
#undef number_of_activations
#undef mask_setting
#undef mask_string
#undef p_interact
#undef focus_r
#undef focus_xh
#undef focus_xw
#undef focus_ah
#undef focus_aw
#undef target_z
#undef target_y
#undef target_x
#undef target_index
#undef visualize
#undef yheight2
#undef xwidth2
#undef zdepth
#undef yheight
#undef xwidth
#undef priority
#undef material_string
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

  /* Initializations for component channel_17_cave1_box3. */
  SIG_MESSAGE("channel_17_cave1_box3 (Init)");
#define mccompcurname  channel_17_cave1_box3
#define mccompcurtype  Union_box
#define mccompcurindex 772
#define loop_index mccchannel_17_cave1_box3_loop_index
#define this_box_volume mccchannel_17_cave1_box3_this_box_volume
#define global_geometry_element mccchannel_17_cave1_box3_global_geometry_element
#define this_box_storage mccchannel_17_cave1_box3_this_box_storage
#define material_string mccchannel_17_cave1_box3_material_string
#define priority mccchannel_17_cave1_box3_priority
#define xwidth mccchannel_17_cave1_box3_xwidth
#define yheight mccchannel_17_cave1_box3_yheight
#define zdepth mccchannel_17_cave1_box3_zdepth
#define xwidth2 mccchannel_17_cave1_box3_xwidth2
#define yheight2 mccchannel_17_cave1_box3_yheight2
#define visualize mccchannel_17_cave1_box3_visualize
#define target_index mccchannel_17_cave1_box3_target_index
#define target_x mccchannel_17_cave1_box3_target_x
#define target_y mccchannel_17_cave1_box3_target_y
#define target_z mccchannel_17_cave1_box3_target_z
#define focus_aw mccchannel_17_cave1_box3_focus_aw
#define focus_ah mccchannel_17_cave1_box3_focus_ah
#define focus_xw mccchannel_17_cave1_box3_focus_xw
#define focus_xh mccchannel_17_cave1_box3_focus_xh
#define focus_r mccchannel_17_cave1_box3_focus_r
#define p_interact mccchannel_17_cave1_box3_p_interact
#define mask_string mccchannel_17_cave1_box3_mask_string
#define mask_setting mccchannel_17_cave1_box3_mask_setting
#define number_of_activations mccchannel_17_cave1_box3_number_of_activations
#line 224 "Union_box.comp"
{
// Initializes the focusing system for this volume including input sanitation.
focus_initialize(&this_box_volume.geometry, POS_A_COMP_INDEX(INDEX_CURRENT_COMP+target_index), POS_A_CURRENT_COMP, ROT_A_CURRENT_COMP, target_index, target_x, target_y, target_z, focus_aw, focus_ah, focus_xw, focus_xh, focus_r, NAME_CURRENT_COMP);

// Input sanitation for this geometry
if (xwidth <= 0) {
  printf("\nERROR in Union_box named %s, the xwidth is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (yheight <= 0) {
  printf("\nERROR in Union_box named %s, yheight is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (zdepth <= 0) {
  printf("\nERROR in Union_box named %s, zdepth is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (xwidth2 <= 0 && xwidth2 != -1) {
  printf("\nERROR in Union_box named %s, the xwidth2 is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (yheight2 <= 0 && yheight2 != -1) {
  printf("\nERROR in Union_box named %s, yheight2 is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}

// Use sanitation
if (global_material_list.num_elements == 0) {
  printf("\nERROR: Need to define a material using Union_make_material before using a Union geometry component. \n");
  printf("       %s was defined before first use of Union_make_material.\n",NAME_CURRENT_COMP);
  exit(1);
}

this_box_volume.geometry.is_masked_volume = 0;
this_box_volume.geometry.is_exit_volume = 0;
this_box_volume.geometry.is_mask_volume = 0;
// check if the volume is a mask, if it is the material string is irelevant.
if (mask_string && strlen(mask_string) && strcmp(mask_string, "NULL") && strcmp(mask_string, "0")) {
    // A mask volume is used to limit the extend of other volumes, called the masked volumes. These are specified in the mask_string.
    // In order for a ray to enter a masked volume, it needs to be both in the region covered by that volume AND the mask volume.
    // When more than
    this_box_volume.geometry.mask_mode = 1; // Default is mask mode is ALL
    if (mask_setting && strlen(mask_setting) && strcmp(mask_setting, "NULL") && strcmp(mask_setting, "0")) {
        if (strcmp(mask_setting,"ALL") == 0 || strcmp(mask_setting,"All") == 0) this_box_volume.geometry.mask_mode = 1;
        else if (strcmp(mask_setting,"ANY") == 0 || strcmp(mask_setting,"Any") == 0) this_box_volume.geometry.mask_mode = 2;
        else {
            printf("The mask_mode of component %s is set to %s, but must be either ALL or ANY.\n",NAME_CURRENT_COMP,mask_setting);
            exit(1);
        }
    }
    
    for (loop_index=0;loop_index<global_geometry_list.num_elements;loop_index++) {
        // Add mask list
        if (1 == manual_linking_function(global_geometry_list.elements[loop_index].name,mask_string)) {
            add_element_to_int_list(&this_box_volume.geometry.mask_list,global_geometry_list.elements[loop_index].component_index);
            add_element_to_int_list(&global_geometry_list.elements[loop_index].Volume->geometry.masked_by_list,INDEX_CURRENT_COMP);
            global_geometry_list.elements[loop_index].Volume->geometry.is_masked_volume = 1;
            if (this_box_volume.geometry.mask_mode == 2)
                global_geometry_list.elements[loop_index].Volume->geometry.mask_mode = 2;
            if (this_box_volume.geometry.mask_mode == 1) {
                if (global_geometry_list.elements[loop_index].Volume->geometry.is_masked_volume == 1 && global_geometry_list.elements[loop_index].Volume->geometry.mask_mode != 2)
                    // If more than one mask is added to one volume, the ANY mode overwrites the (default) ALL mode.
                    global_geometry_list.elements[loop_index].Volume->geometry.mask_mode = 1;
            }
            
            found_geometries = 1;
        }
    }
    if (found_geometries == 0) {
        printf("The mask_string in geometry: %s did not find any of the specified volumes in the mask_string %s \n",NAME_CURRENT_COMP,mask_string);
        exit(1);
    }
    this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
    this_box_volume.p_physics->is_vacuum = 0; // Makes this volume a vacuum
    this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
    this_box_volume.p_physics->my_a = 0; // Should not be used.
    sprintf(this_box_volume.p_physics->name,"Mask");
    this_box_volume.geometry.is_mask_volume = 1;
    
    
// Read the material input, or if it lacks, use automatic linking.
} else if (material_string && strlen(material_string) && strcmp(material_string, "NULL") && strcmp(material_string, "0")) {
    // A geometry string was given, use it to determine which material
    if (0 == strcmp(material_string,"vacuum") || 0 == strcmp(material_string,"Vacuum")) {
        // One could have a global physics struct for vacuum instead of creating one for each
        this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
        this_box_volume.p_physics->is_vacuum = 1; // Makes this volume a vacuum
        this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
        this_box_volume.p_physics->my_a = 0; // Should not be used.
        sprintf(this_box_volume.p_physics->name,"Vacuum");
    } else if (0 == strcmp(material_string,"exit") || 0 == strcmp(material_string,"Exit")) {
        // One could have a global physics struct for vacuum instead of creating one for each
        this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
        this_box_volume.p_physics->is_vacuum = 1; // Makes this volume a vacuum
        this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
        this_box_volume.p_physics->my_a = 0; // Should not be used.
        this_box_volume.geometry.is_exit_volume = 1;
        sprintf(this_box_volume.p_physics->name,"Exit");
    } else {
        #ifndef MATERIAL_DETECTOR
            printf("Need to define a material before refering to it in a geometry %s.\n",NAME_CURRENT_COMP);
            exit(1);
        #endif
        for (loop_index=0;loop_index<global_material_list.num_elements;loop_index++) {
            if (0 == strcmp(material_string,global_material_list.elements[loop_index].name)) {
                this_box_volume.p_physics = global_material_list.elements[loop_index].physics;
                break;
            }
            if (loop_index == global_material_list.num_elements-1) {
            printf("\n");
            printf("ERROR: The material string \"%s\" in Union geometry \"%s\" did not match a specified material. \n",material_string,NAME_CURRENT_COMP);
            printf("       The materials available at this point (need to be defined before the geometry): \n");
            for (loop_index=0;loop_index<global_material_list.num_elements;loop_index++)
              printf("         %s\n",global_material_list.elements[loop_index].name);
            printf("\n");
            printf("       It is also possible to use one of the defualt materials avaiable: \n");
            printf("           Vacuum (for a Volume without scattering or absorption)\n");
            printf("           Exit (for a Volume where the ray exits the component if it enters)\n");
            printf("           Mask (for a Volume that masks existing volumes specified in the mask_string\n");
            exit(1);
          }
        }
    }
} else {
    // Automatic linking, simply using the last defined material.
    #ifndef MATERIAL_DETECTOR
        printf("Need to define a material before the geometry to use automatic linking %s.\n",NAME_CURRENT_COMP);
        exit(1);
    #endif
    this_box_volume.p_physics = global_material_list.elements[global_material_list.num_elements-1].physics;
}

sprintf(this_box_volume.name,NAME_CURRENT_COMP);
sprintf(this_box_volume.geometry.shape,"box");
this_box_volume.geometry.priority_value = priority;
this_box_volume.geometry.geometry_p_interact = p_interact;
// Currently the coordinates will be in absolute space.
this_box_volume.geometry.center = POS_A_CURRENT_COMP;

this_box_storage.z_depth = zdepth;
this_box_storage.x_width1 = xwidth;
this_box_storage.y_height1 = yheight;

this_box_storage.is_rectangle = 0;
if (xwidth2 < 0 && yheight2 < 0) this_box_storage.is_rectangle = 1;
if (xwidth == xwidth2 && yheight == yheight2) this_box_storage.is_rectangle = 1;

if (xwidth2 < 0) {
    this_box_storage.x_width2 = xwidth;
    xwidth2 = xwidth;
} else this_box_storage.x_width2 = xwidth2;

if (yheight2 < 0) {
    this_box_storage.y_height2 = yheight;
    yheight2 = yheight;
} else this_box_storage.y_height2 = yheight2;


this_box_storage.normal_vectors[0] = coords_set(0,0,1);
this_box_storage.normal_vectors[1] = coords_set(0,0,1);

// for sides with y component = 0
x_component = 2*zdepth/sqrt((xwidth-xwidth2)*(xwidth-xwidth2)+4*zdepth*zdepth);
z_component = (xwidth-xwidth2)/sqrt(4*zdepth*zdepth+(xwidth-xwidth2)*(xwidth-xwidth2));

this_box_storage.normal_vectors[2] = coords_set(x_component,0,z_component);
this_box_storage.normal_vectors[3] = coords_set(-x_component,0,z_component);

// for sides with x component = 0
y_component = 2*zdepth/sqrt((yheight-yheight2)*(yheight-yheight2)+4*zdepth*zdepth);
z_component = (yheight-yheight2)/sqrt(4*zdepth*zdepth+(yheight-yheight2)*(yheight-yheight2));

this_box_storage.normal_vectors[4] = coords_set(0,y_component,z_component);
this_box_storage.normal_vectors[5] = coords_set(0,-y_component,z_component);

this_box_volume.geometry.visualization_on = visualize;

this_box_volume.geometry.geometry_parameters.p_box_storage = &this_box_storage;

// Assign pointers to functions for intersection with the shape, checking if a point is inside the shape
if (this_box_storage.is_rectangle == 1) {
this_box_volume.geometry.intersect_function = &sample_box_intersect_simple;
this_box_volume.geometry.within_function = &r_within_box_simple;
}
else {
this_box_volume.geometry.intersect_function = &sample_box_intersect_advanced;
this_box_volume.geometry.within_function = &r_within_box_advanced;
}

this_box_volume.geometry.shell_points = &box_shell_points;
this_box_volume.geometry.mcdisplay_function = &mcdisplay_box_function;
this_box_volume.geometry.initialize_from_main_function = &initialize_box_geometry_from_main_component;
this_box_volume.geometry.process_rot_allocated = 0;

this_box_volume.geometry.copy_geometry_parameters = &allocate_box_storage_copy;

rot_copy(this_box_volume.geometry.rotation_matrix,ROT_A_CURRENT_COMP); //check how ROT_R_CURRENT_COMP would work
rot_transpose(ROT_A_CURRENT_COMP,this_box_volume.geometry.transpose_rotation_matrix);

// Initialize loggers
this_box_volume.loggers.num_elements = 0;

// packing the information into the global_geometry_element, which is then included in the global_geometry_list.
sprintf(global_geometry_element.name,NAME_CURRENT_COMP);
global_geometry_element.activation_counter = number_of_activations;
global_geometry_element.component_index = INDEX_CURRENT_COMP;
global_geometry_element.Volume = &this_box_volume; // Would be nicer if this m was a pointer, now we have the (small) data two places
add_element_to_geometry_list(&global_geometry_list,global_geometry_element);
}
#line 315071 "MACS_sample_kidney_box.c"
#undef number_of_activations
#undef mask_setting
#undef mask_string
#undef p_interact
#undef focus_r
#undef focus_xh
#undef focus_xw
#undef focus_ah
#undef focus_aw
#undef target_z
#undef target_y
#undef target_x
#undef target_index
#undef visualize
#undef yheight2
#undef xwidth2
#undef zdepth
#undef yheight
#undef xwidth
#undef priority
#undef material_string
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

  /* Initializations for component channel_17_cave1_cyl1. */
  SIG_MESSAGE("channel_17_cave1_cyl1 (Init)");
#define mccompcurname  channel_17_cave1_cyl1
#define mccompcurtype  Union_cylinder
#define mccompcurindex 773
#define loop_index mccchannel_17_cave1_cyl1_loop_index
#define this_cylinder_volume mccchannel_17_cave1_cyl1_this_cylinder_volume
#define global_geometry_element mccchannel_17_cave1_cyl1_global_geometry_element
#define this_cylinder_storage mccchannel_17_cave1_cyl1_this_cylinder_storage
#define material_string mccchannel_17_cave1_cyl1_material_string
#define priority mccchannel_17_cave1_cyl1_priority
#define radius mccchannel_17_cave1_cyl1_radius
#define yheight mccchannel_17_cave1_cyl1_yheight
#define visualize mccchannel_17_cave1_cyl1_visualize
#define target_index mccchannel_17_cave1_cyl1_target_index
#define target_x mccchannel_17_cave1_cyl1_target_x
#define target_y mccchannel_17_cave1_cyl1_target_y
#define target_z mccchannel_17_cave1_cyl1_target_z
#define focus_aw mccchannel_17_cave1_cyl1_focus_aw
#define focus_ah mccchannel_17_cave1_cyl1_focus_ah
#define focus_xw mccchannel_17_cave1_cyl1_focus_xw
#define focus_xh mccchannel_17_cave1_cyl1_focus_xh
#define focus_r mccchannel_17_cave1_cyl1_focus_r
#define p_interact mccchannel_17_cave1_cyl1_p_interact
#define mask_string mccchannel_17_cave1_cyl1_mask_string
#define mask_setting mccchannel_17_cave1_cyl1_mask_setting
#define number_of_activations mccchannel_17_cave1_cyl1_number_of_activations
#line 185 "Union_cylinder.comp"
{
// Initializes the focusing system for this volume including input sanitation.
focus_initialize(&this_cylinder_volume.geometry, POS_A_COMP_INDEX(INDEX_CURRENT_COMP+target_index), POS_A_CURRENT_COMP, ROT_A_CURRENT_COMP, target_index, target_x, target_y, target_z, focus_aw, focus_ah, focus_xw, focus_xh, focus_r, NAME_CURRENT_COMP);

// Input sanitation for this geometry
if (radius <= 0) {
  printf("\nERROR in Union_cylinder named %s, the radius is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}

if (yheight <= 0) {
  printf("\nERROR in Union_cylinder named %s, yheight is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}

// Use sanitation
#ifdef MATERIAL_DETECTOR
if (global_material_list.num_elements == 0) {
  // Here if the user have defined a material, but only after this material
  printf("\nERROR: Need to define a material using Union_make_material before using a Union geometry component. \n");
  printf("       %s was defined before first use of Union_make_material.\n",NAME_CURRENT_COMP);
  exit(1);
}
#endif
#ifndef MATERIAL_DETECTOR
  printf("\nERROR: Need to define a material using Union_make_material before using a Union geometry component. \n");
  exit(1);
#endif


this_cylinder_volume.geometry.is_masked_volume = 0;
this_cylinder_volume.geometry.is_exit_volume = 0;
this_cylinder_volume.geometry.is_mask_volume = 0;

// Read the material input, or if it lacks, use automatic linking.
if (mask_string && strlen(mask_string) && strcmp(mask_string, "NULL") && strcmp(mask_string, "0")) {
    // A mask volume is used to limit the extend of other volumes, called the masked volumes. These are specified in the mask_string.
    // In order for a ray to enter a masked volume, it needs to be both in the region covered by that volume AND the mask volume.
    // When more than
    this_cylinder_volume.geometry.mask_mode = 1; // Default is mask mode is ALL
    if (mask_setting && strlen(mask_setting) && strcmp(mask_setting, "NULL") && strcmp(mask_setting, "0")) {
        if (strcmp(mask_setting,"ALL") == 0 || strcmp(mask_setting,"All") == 0) this_cylinder_volume.geometry.mask_mode = 1;
        else if (strcmp(mask_setting,"ANY") == 0 || strcmp(mask_setting,"Any") == 0) this_cylinder_volume.geometry.mask_mode = 2;
        else {
            printf("The mask_mode of component %s is set to %s, but must be either ALL or ANY.\n",NAME_CURRENT_COMP,mask_setting);
            exit(1);
        }
    }
    
    for (loop_index=0;loop_index<global_geometry_list.num_elements;loop_index++) {
        // Add mask list
        if (1 == manual_linking_function(global_geometry_list.elements[loop_index].name,mask_string)) {
            add_element_to_int_list(&this_cylinder_volume.geometry.mask_list,global_geometry_list.elements[loop_index].component_index);
            add_element_to_int_list(&global_geometry_list.elements[loop_index].Volume->geometry.masked_by_list,INDEX_CURRENT_COMP);
            global_geometry_list.elements[loop_index].Volume->geometry.is_masked_volume = 1;
            if (this_cylinder_volume.geometry.mask_mode == 2)
                global_geometry_list.elements[loop_index].Volume->geometry.mask_mode = 2;
            if (this_cylinder_volume.geometry.mask_mode == 1) {
                if (global_geometry_list.elements[loop_index].Volume->geometry.is_masked_volume == 1 && global_geometry_list.elements[loop_index].Volume->geometry.mask_mode != 2)
                    // If more than one mask is added to one volume, the ANY mode overwrites the (default) ALL mode.
                    global_geometry_list.elements[loop_index].Volume->geometry.mask_mode = 1;
            }
            
            found_geometries = 1;
        }
    }
    if (found_geometries == 0) {
        printf("The mask_string in geometry: %s did not find any of the specified volumes in the mask_string %s \n",NAME_CURRENT_COMP,mask_string);
        exit(1);
    }
    this_cylinder_volume.p_physics = malloc(sizeof(struct physics_struct));
    this_cylinder_volume.p_physics->is_vacuum = 0; // Makes this volume a vacuum
    this_cylinder_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
    this_cylinder_volume.p_physics->my_a = 0; // Should not be used.
    sprintf(this_cylinder_volume.p_physics->name,"Mask");
    this_cylinder_volume.geometry.is_mask_volume = 1;
    
    
// Read the material input, or if it lacks, use automatic linking.
} else if (material_string && strlen(material_string) && strcmp(material_string, "NULL") && strcmp(material_string, "0")) {
    // A geometry string was given, use it to determine which material
    if (0 == strcmp(material_string,"vacuum") || 0 == strcmp(material_string,"Vacuum")) {
        // One could have a global physics struct for vacuum instead of creating one for each
        this_cylinder_volume.p_physics = malloc(sizeof(struct physics_struct));
        this_cylinder_volume.p_physics->is_vacuum = 1; // Makes this volume a vacuum
        this_cylinder_volume.p_physics->number_of_processes = (int) 0;
        this_cylinder_volume.p_physics->my_a = 0; // Should not be used.
        sprintf(this_cylinder_volume.p_physics->name,"Vacuum");
    } else if (0 == strcmp(material_string,"exit") || 0 == strcmp(material_string,"Exit")) {
        // One could have a global physics struct for exit instead of creating one for each
        this_cylinder_volume.p_physics = malloc(sizeof(struct physics_struct));
        this_cylinder_volume.p_physics->is_vacuum = 1; // Makes this volume a vacuum
        this_cylinder_volume.p_physics->number_of_processes = (int) 0;
        this_cylinder_volume.p_physics->my_a = 0; // Should not be used.
        this_cylinder_volume.geometry.is_exit_volume = 1;
        sprintf(this_cylinder_volume.p_physics->name,"Exit");
    } else {
        for (loop_index=0;loop_index<global_material_list.num_elements;loop_index++) {
          if (0 == strcmp(material_string,global_material_list.elements[loop_index].name)) {
            this_cylinder_volume.p_physics = global_material_list.elements[loop_index].physics;
            break;
          }
          if (loop_index == global_material_list.num_elements-1) {
            printf("\n");
            printf("ERROR: The material string \"%s\" in Union geometry \"%s\" did not match a specified material. \n",material_string,NAME_CURRENT_COMP);
            printf("       The materials available at this point (need to be defined before the geometry): \n");
            for (loop_index=0;loop_index<global_material_list.num_elements;loop_index++)
              printf("         %s\n",global_material_list.elements[loop_index].name);
            printf("\n");
            printf("       It is also possible to use one of the defualt materials avaiable: \n");
            printf("           Vacuum (for a Volume without scattering or absorption)\n");
            printf("           Exit (for a Volume where the ray exits the component if it enters)\n");
            printf("           Mask (for a Volume that masks existing volumes specified in the mask_string\n");
            exit(1);
          }
        }
    }
} else {
    // Automatic linking, simply using the last defined material.
    #ifndef MATERIAL_DETECTOR
        printf("Need to define a material before the geometry to use automatic linking %s.\n",NAME_CURRENT_COMP);
        exit(1);
    #endif
    this_cylinder_volume.p_physics = global_material_list.elements[global_material_list.num_elements-1].physics;
}

sprintf(this_cylinder_volume.name,NAME_CURRENT_COMP);
sprintf(this_cylinder_volume.geometry.shape,"cylinder");
this_cylinder_volume.geometry.priority_value = priority;
// Currently the coordinates will be in absolute space.
this_cylinder_volume.geometry.center = POS_A_CURRENT_COMP;

this_cylinder_volume.geometry.geometry_p_interact = p_interact;
this_cylinder_storage.cyl_radius = radius;
this_cylinder_storage.height = yheight;
this_cylinder_volume.geometry.visualization_on = visualize;
this_cylinder_volume.geometry.geometry_parameters.p_cylinder_storage = &this_cylinder_storage;
this_cylinder_volume.geometry.within_function = &r_within_cylinder;
this_cylinder_volume.geometry.intersect_function = &sample_cylinder_intersect;
this_cylinder_volume.geometry.mcdisplay_function = &mcdisplay_cylinder_function;
this_cylinder_volume.geometry.shell_points = &cylinder_shell_points;
this_cylinder_volume.geometry.initialize_from_main_function = &initialize_cylinder_geometry_from_main_component;
this_cylinder_volume.geometry.process_rot_allocated = 0;
this_cylinder_volume.geometry.copy_geometry_parameters = &allocate_cylinder_storage_copy;

rot_copy(this_cylinder_volume.geometry.rotation_matrix,ROT_A_CURRENT_COMP);
rot_transpose(ROT_A_CURRENT_COMP,this_cylinder_volume.geometry.transpose_rotation_matrix);

// Initialize loggers
this_cylinder_volume.loggers.num_elements = 0;

// packing the information into the global_geometry_element, which is then included in the global_geometry_list.
sprintf(global_geometry_element.name,NAME_CURRENT_COMP);
global_geometry_element.activation_counter = number_of_activations;
global_geometry_element.component_index = INDEX_CURRENT_COMP;
global_geometry_element.Volume = &this_cylinder_volume; // Would be nicer if this m was a pointer, now we have the (small) data two places
add_element_to_geometry_list(&global_geometry_list,global_geometry_element);
}
#line 315287 "MACS_sample_kidney_box.c"
#undef number_of_activations
#undef mask_setting
#undef mask_string
#undef p_interact
#undef focus_r
#undef focus_xh
#undef focus_xw
#undef focus_ah
#undef focus_aw
#undef target_z
#undef target_y
#undef target_x
#undef target_index
#undef visualize
#undef yheight
#undef radius
#undef priority
#undef material_string
#undef this_cylinder_storage
#undef global_geometry_element
#undef this_cylinder_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

  /* Initializations for component channel_17_analyzer_1_center. */
  SIG_MESSAGE("channel_17_analyzer_1_center (Init)");

  /* Initializations for component channel_17_analyzer_1_rotated. */
  SIG_MESSAGE("channel_17_analyzer_1_rotated (Init)");

  /* Initializations for component channel_17_analyzer_1_array_crystal_array_0. */
  SIG_MESSAGE("channel_17_analyzer_1_array_crystal_array_0 (Init)");
#define mccompcurname  channel_17_analyzer_1_array_crystal_array_0
#define mccompcurtype  Union_box
#define mccompcurindex 776
#define loop_index mccchannel_17_analyzer_1_array_crystal_array_0_loop_index
#define this_box_volume mccchannel_17_analyzer_1_array_crystal_array_0_this_box_volume
#define global_geometry_element mccchannel_17_analyzer_1_array_crystal_array_0_global_geometry_element
#define this_box_storage mccchannel_17_analyzer_1_array_crystal_array_0_this_box_storage
#define material_string mccchannel_17_analyzer_1_array_crystal_array_0_material_string
#define priority mccchannel_17_analyzer_1_array_crystal_array_0_priority
#define xwidth mccchannel_17_analyzer_1_array_crystal_array_0_xwidth
#define yheight mccchannel_17_analyzer_1_array_crystal_array_0_yheight
#define zdepth mccchannel_17_analyzer_1_array_crystal_array_0_zdepth
#define xwidth2 mccchannel_17_analyzer_1_array_crystal_array_0_xwidth2
#define yheight2 mccchannel_17_analyzer_1_array_crystal_array_0_yheight2
#define visualize mccchannel_17_analyzer_1_array_crystal_array_0_visualize
#define target_index mccchannel_17_analyzer_1_array_crystal_array_0_target_index
#define target_x mccchannel_17_analyzer_1_array_crystal_array_0_target_x
#define target_y mccchannel_17_analyzer_1_array_crystal_array_0_target_y
#define target_z mccchannel_17_analyzer_1_array_crystal_array_0_target_z
#define focus_aw mccchannel_17_analyzer_1_array_crystal_array_0_focus_aw
#define focus_ah mccchannel_17_analyzer_1_array_crystal_array_0_focus_ah
#define focus_xw mccchannel_17_analyzer_1_array_crystal_array_0_focus_xw
#define focus_xh mccchannel_17_analyzer_1_array_crystal_array_0_focus_xh
#define focus_r mccchannel_17_analyzer_1_array_crystal_array_0_focus_r
#define p_interact mccchannel_17_analyzer_1_array_crystal_array_0_p_interact
#define mask_string mccchannel_17_analyzer_1_array_crystal_array_0_mask_string
#define mask_setting mccchannel_17_analyzer_1_array_crystal_array_0_mask_setting
#define number_of_activations mccchannel_17_analyzer_1_array_crystal_array_0_number_of_activations
#line 224 "Union_box.comp"
{
// Initializes the focusing system for this volume including input sanitation.
focus_initialize(&this_box_volume.geometry, POS_A_COMP_INDEX(INDEX_CURRENT_COMP+target_index), POS_A_CURRENT_COMP, ROT_A_CURRENT_COMP, target_index, target_x, target_y, target_z, focus_aw, focus_ah, focus_xw, focus_xh, focus_r, NAME_CURRENT_COMP);

// Input sanitation for this geometry
if (xwidth <= 0) {
  printf("\nERROR in Union_box named %s, the xwidth is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (yheight <= 0) {
  printf("\nERROR in Union_box named %s, yheight is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (zdepth <= 0) {
  printf("\nERROR in Union_box named %s, zdepth is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (xwidth2 <= 0 && xwidth2 != -1) {
  printf("\nERROR in Union_box named %s, the xwidth2 is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (yheight2 <= 0 && yheight2 != -1) {
  printf("\nERROR in Union_box named %s, yheight2 is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}

// Use sanitation
if (global_material_list.num_elements == 0) {
  printf("\nERROR: Need to define a material using Union_make_material before using a Union geometry component. \n");
  printf("       %s was defined before first use of Union_make_material.\n",NAME_CURRENT_COMP);
  exit(1);
}

this_box_volume.geometry.is_masked_volume = 0;
this_box_volume.geometry.is_exit_volume = 0;
this_box_volume.geometry.is_mask_volume = 0;
// check if the volume is a mask, if it is the material string is irelevant.
if (mask_string && strlen(mask_string) && strcmp(mask_string, "NULL") && strcmp(mask_string, "0")) {
    // A mask volume is used to limit the extend of other volumes, called the masked volumes. These are specified in the mask_string.
    // In order for a ray to enter a masked volume, it needs to be both in the region covered by that volume AND the mask volume.
    // When more than
    this_box_volume.geometry.mask_mode = 1; // Default is mask mode is ALL
    if (mask_setting && strlen(mask_setting) && strcmp(mask_setting, "NULL") && strcmp(mask_setting, "0")) {
        if (strcmp(mask_setting,"ALL") == 0 || strcmp(mask_setting,"All") == 0) this_box_volume.geometry.mask_mode = 1;
        else if (strcmp(mask_setting,"ANY") == 0 || strcmp(mask_setting,"Any") == 0) this_box_volume.geometry.mask_mode = 2;
        else {
            printf("The mask_mode of component %s is set to %s, but must be either ALL or ANY.\n",NAME_CURRENT_COMP,mask_setting);
            exit(1);
        }
    }
    
    for (loop_index=0;loop_index<global_geometry_list.num_elements;loop_index++) {
        // Add mask list
        if (1 == manual_linking_function(global_geometry_list.elements[loop_index].name,mask_string)) {
            add_element_to_int_list(&this_box_volume.geometry.mask_list,global_geometry_list.elements[loop_index].component_index);
            add_element_to_int_list(&global_geometry_list.elements[loop_index].Volume->geometry.masked_by_list,INDEX_CURRENT_COMP);
            global_geometry_list.elements[loop_index].Volume->geometry.is_masked_volume = 1;
            if (this_box_volume.geometry.mask_mode == 2)
                global_geometry_list.elements[loop_index].Volume->geometry.mask_mode = 2;
            if (this_box_volume.geometry.mask_mode == 1) {
                if (global_geometry_list.elements[loop_index].Volume->geometry.is_masked_volume == 1 && global_geometry_list.elements[loop_index].Volume->geometry.mask_mode != 2)
                    // If more than one mask is added to one volume, the ANY mode overwrites the (default) ALL mode.
                    global_geometry_list.elements[loop_index].Volume->geometry.mask_mode = 1;
            }
            
            found_geometries = 1;
        }
    }
    if (found_geometries == 0) {
        printf("The mask_string in geometry: %s did not find any of the specified volumes in the mask_string %s \n",NAME_CURRENT_COMP,mask_string);
        exit(1);
    }
    this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
    this_box_volume.p_physics->is_vacuum = 0; // Makes this volume a vacuum
    this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
    this_box_volume.p_physics->my_a = 0; // Should not be used.
    sprintf(this_box_volume.p_physics->name,"Mask");
    this_box_volume.geometry.is_mask_volume = 1;
    
    
// Read the material input, or if it lacks, use automatic linking.
} else if (material_string && strlen(material_string) && strcmp(material_string, "NULL") && strcmp(material_string, "0")) {
    // A geometry string was given, use it to determine which material
    if (0 == strcmp(material_string,"vacuum") || 0 == strcmp(material_string,"Vacuum")) {
        // One could have a global physics struct for vacuum instead of creating one for each
        this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
        this_box_volume.p_physics->is_vacuum = 1; // Makes this volume a vacuum
        this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
        this_box_volume.p_physics->my_a = 0; // Should not be used.
        sprintf(this_box_volume.p_physics->name,"Vacuum");
    } else if (0 == strcmp(material_string,"exit") || 0 == strcmp(material_string,"Exit")) {
        // One could have a global physics struct for vacuum instead of creating one for each
        this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
        this_box_volume.p_physics->is_vacuum = 1; // Makes this volume a vacuum
        this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
        this_box_volume.p_physics->my_a = 0; // Should not be used.
        this_box_volume.geometry.is_exit_volume = 1;
        sprintf(this_box_volume.p_physics->name,"Exit");
    } else {
        #ifndef MATERIAL_DETECTOR
            printf("Need to define a material before refering to it in a geometry %s.\n",NAME_CURRENT_COMP);
            exit(1);
        #endif
        for (loop_index=0;loop_index<global_material_list.num_elements;loop_index++) {
            if (0 == strcmp(material_string,global_material_list.elements[loop_index].name)) {
                this_box_volume.p_physics = global_material_list.elements[loop_index].physics;
                break;
            }
            if (loop_index == global_material_list.num_elements-1) {
            printf("\n");
            printf("ERROR: The material string \"%s\" in Union geometry \"%s\" did not match a specified material. \n",material_string,NAME_CURRENT_COMP);
            printf("       The materials available at this point (need to be defined before the geometry): \n");
            for (loop_index=0;loop_index<global_material_list.num_elements;loop_index++)
              printf("         %s\n",global_material_list.elements[loop_index].name);
            printf("\n");
            printf("       It is also possible to use one of the defualt materials avaiable: \n");
            printf("           Vacuum (for a Volume without scattering or absorption)\n");
            printf("           Exit (for a Volume where the ray exits the component if it enters)\n");
            printf("           Mask (for a Volume that masks existing volumes specified in the mask_string\n");
            exit(1);
          }
        }
    }
} else {
    // Automatic linking, simply using the last defined material.
    #ifndef MATERIAL_DETECTOR
        printf("Need to define a material before the geometry to use automatic linking %s.\n",NAME_CURRENT_COMP);
        exit(1);
    #endif
    this_box_volume.p_physics = global_material_list.elements[global_material_list.num_elements-1].physics;
}

sprintf(this_box_volume.name,NAME_CURRENT_COMP);
sprintf(this_box_volume.geometry.shape,"box");
this_box_volume.geometry.priority_value = priority;
this_box_volume.geometry.geometry_p_interact = p_interact;
// Currently the coordinates will be in absolute space.
this_box_volume.geometry.center = POS_A_CURRENT_COMP;

this_box_storage.z_depth = zdepth;
this_box_storage.x_width1 = xwidth;
this_box_storage.y_height1 = yheight;

this_box_storage.is_rectangle = 0;
if (xwidth2 < 0 && yheight2 < 0) this_box_storage.is_rectangle = 1;
if (xwidth == xwidth2 && yheight == yheight2) this_box_storage.is_rectangle = 1;

if (xwidth2 < 0) {
    this_box_storage.x_width2 = xwidth;
    xwidth2 = xwidth;
} else this_box_storage.x_width2 = xwidth2;

if (yheight2 < 0) {
    this_box_storage.y_height2 = yheight;
    yheight2 = yheight;
} else this_box_storage.y_height2 = yheight2;


this_box_storage.normal_vectors[0] = coords_set(0,0,1);
this_box_storage.normal_vectors[1] = coords_set(0,0,1);

// for sides with y component = 0
x_component = 2*zdepth/sqrt((xwidth-xwidth2)*(xwidth-xwidth2)+4*zdepth*zdepth);
z_component = (xwidth-xwidth2)/sqrt(4*zdepth*zdepth+(xwidth-xwidth2)*(xwidth-xwidth2));

this_box_storage.normal_vectors[2] = coords_set(x_component,0,z_component);
this_box_storage.normal_vectors[3] = coords_set(-x_component,0,z_component);

// for sides with x component = 0
y_component = 2*zdepth/sqrt((yheight-yheight2)*(yheight-yheight2)+4*zdepth*zdepth);
z_component = (yheight-yheight2)/sqrt(4*zdepth*zdepth+(yheight-yheight2)*(yheight-yheight2));

this_box_storage.normal_vectors[4] = coords_set(0,y_component,z_component);
this_box_storage.normal_vectors[5] = coords_set(0,-y_component,z_component);

this_box_volume.geometry.visualization_on = visualize;

this_box_volume.geometry.geometry_parameters.p_box_storage = &this_box_storage;

// Assign pointers to functions for intersection with the shape, checking if a point is inside the shape
if (this_box_storage.is_rectangle == 1) {
this_box_volume.geometry.intersect_function = &sample_box_intersect_simple;
this_box_volume.geometry.within_function = &r_within_box_simple;
}
else {
this_box_volume.geometry.intersect_function = &sample_box_intersect_advanced;
this_box_volume.geometry.within_function = &r_within_box_advanced;
}

this_box_volume.geometry.shell_points = &box_shell_points;
this_box_volume.geometry.mcdisplay_function = &mcdisplay_box_function;
this_box_volume.geometry.initialize_from_main_function = &initialize_box_geometry_from_main_component;
this_box_volume.geometry.process_rot_allocated = 0;

this_box_volume.geometry.copy_geometry_parameters = &allocate_box_storage_copy;

rot_copy(this_box_volume.geometry.rotation_matrix,ROT_A_CURRENT_COMP); //check how ROT_R_CURRENT_COMP would work
rot_transpose(ROT_A_CURRENT_COMP,this_box_volume.geometry.transpose_rotation_matrix);

// Initialize loggers
this_box_volume.loggers.num_elements = 0;

// packing the information into the global_geometry_element, which is then included in the global_geometry_list.
sprintf(global_geometry_element.name,NAME_CURRENT_COMP);
global_geometry_element.activation_counter = number_of_activations;
global_geometry_element.component_index = INDEX_CURRENT_COMP;
global_geometry_element.Volume = &this_box_volume; // Would be nicer if this m was a pointer, now we have the (small) data two places
add_element_to_geometry_list(&global_geometry_list,global_geometry_element);
}
#line 315560 "MACS_sample_kidney_box.c"
#undef number_of_activations
#undef mask_setting
#undef mask_string
#undef p_interact
#undef focus_r
#undef focus_xh
#undef focus_xw
#undef focus_ah
#undef focus_aw
#undef target_z
#undef target_y
#undef target_x
#undef target_index
#undef visualize
#undef yheight2
#undef xwidth2
#undef zdepth
#undef yheight
#undef xwidth
#undef priority
#undef material_string
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

  /* Initializations for component channel_17_analyzer_1_array_crystal_array_1. */
  SIG_MESSAGE("channel_17_analyzer_1_array_crystal_array_1 (Init)");
#define mccompcurname  channel_17_analyzer_1_array_crystal_array_1
#define mccompcurtype  Union_box
#define mccompcurindex 777
#define loop_index mccchannel_17_analyzer_1_array_crystal_array_1_loop_index
#define this_box_volume mccchannel_17_analyzer_1_array_crystal_array_1_this_box_volume
#define global_geometry_element mccchannel_17_analyzer_1_array_crystal_array_1_global_geometry_element
#define this_box_storage mccchannel_17_analyzer_1_array_crystal_array_1_this_box_storage
#define material_string mccchannel_17_analyzer_1_array_crystal_array_1_material_string
#define priority mccchannel_17_analyzer_1_array_crystal_array_1_priority
#define xwidth mccchannel_17_analyzer_1_array_crystal_array_1_xwidth
#define yheight mccchannel_17_analyzer_1_array_crystal_array_1_yheight
#define zdepth mccchannel_17_analyzer_1_array_crystal_array_1_zdepth
#define xwidth2 mccchannel_17_analyzer_1_array_crystal_array_1_xwidth2
#define yheight2 mccchannel_17_analyzer_1_array_crystal_array_1_yheight2
#define visualize mccchannel_17_analyzer_1_array_crystal_array_1_visualize
#define target_index mccchannel_17_analyzer_1_array_crystal_array_1_target_index
#define target_x mccchannel_17_analyzer_1_array_crystal_array_1_target_x
#define target_y mccchannel_17_analyzer_1_array_crystal_array_1_target_y
#define target_z mccchannel_17_analyzer_1_array_crystal_array_1_target_z
#define focus_aw mccchannel_17_analyzer_1_array_crystal_array_1_focus_aw
#define focus_ah mccchannel_17_analyzer_1_array_crystal_array_1_focus_ah
#define focus_xw mccchannel_17_analyzer_1_array_crystal_array_1_focus_xw
#define focus_xh mccchannel_17_analyzer_1_array_crystal_array_1_focus_xh
#define focus_r mccchannel_17_analyzer_1_array_crystal_array_1_focus_r
#define p_interact mccchannel_17_analyzer_1_array_crystal_array_1_p_interact
#define mask_string mccchannel_17_analyzer_1_array_crystal_array_1_mask_string
#define mask_setting mccchannel_17_analyzer_1_array_crystal_array_1_mask_setting
#define number_of_activations mccchannel_17_analyzer_1_array_crystal_array_1_number_of_activations
#line 224 "Union_box.comp"
{
// Initializes the focusing system for this volume including input sanitation.
focus_initialize(&this_box_volume.geometry, POS_A_COMP_INDEX(INDEX_CURRENT_COMP+target_index), POS_A_CURRENT_COMP, ROT_A_CURRENT_COMP, target_index, target_x, target_y, target_z, focus_aw, focus_ah, focus_xw, focus_xh, focus_r, NAME_CURRENT_COMP);

// Input sanitation for this geometry
if (xwidth <= 0) {
  printf("\nERROR in Union_box named %s, the xwidth is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (yheight <= 0) {
  printf("\nERROR in Union_box named %s, yheight is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (zdepth <= 0) {
  printf("\nERROR in Union_box named %s, zdepth is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (xwidth2 <= 0 && xwidth2 != -1) {
  printf("\nERROR in Union_box named %s, the xwidth2 is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (yheight2 <= 0 && yheight2 != -1) {
  printf("\nERROR in Union_box named %s, yheight2 is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}

// Use sanitation
if (global_material_list.num_elements == 0) {
  printf("\nERROR: Need to define a material using Union_make_material before using a Union geometry component. \n");
  printf("       %s was defined before first use of Union_make_material.\n",NAME_CURRENT_COMP);
  exit(1);
}

this_box_volume.geometry.is_masked_volume = 0;
this_box_volume.geometry.is_exit_volume = 0;
this_box_volume.geometry.is_mask_volume = 0;
// check if the volume is a mask, if it is the material string is irelevant.
if (mask_string && strlen(mask_string) && strcmp(mask_string, "NULL") && strcmp(mask_string, "0")) {
    // A mask volume is used to limit the extend of other volumes, called the masked volumes. These are specified in the mask_string.
    // In order for a ray to enter a masked volume, it needs to be both in the region covered by that volume AND the mask volume.
    // When more than
    this_box_volume.geometry.mask_mode = 1; // Default is mask mode is ALL
    if (mask_setting && strlen(mask_setting) && strcmp(mask_setting, "NULL") && strcmp(mask_setting, "0")) {
        if (strcmp(mask_setting,"ALL") == 0 || strcmp(mask_setting,"All") == 0) this_box_volume.geometry.mask_mode = 1;
        else if (strcmp(mask_setting,"ANY") == 0 || strcmp(mask_setting,"Any") == 0) this_box_volume.geometry.mask_mode = 2;
        else {
            printf("The mask_mode of component %s is set to %s, but must be either ALL or ANY.\n",NAME_CURRENT_COMP,mask_setting);
            exit(1);
        }
    }
    
    for (loop_index=0;loop_index<global_geometry_list.num_elements;loop_index++) {
        // Add mask list
        if (1 == manual_linking_function(global_geometry_list.elements[loop_index].name,mask_string)) {
            add_element_to_int_list(&this_box_volume.geometry.mask_list,global_geometry_list.elements[loop_index].component_index);
            add_element_to_int_list(&global_geometry_list.elements[loop_index].Volume->geometry.masked_by_list,INDEX_CURRENT_COMP);
            global_geometry_list.elements[loop_index].Volume->geometry.is_masked_volume = 1;
            if (this_box_volume.geometry.mask_mode == 2)
                global_geometry_list.elements[loop_index].Volume->geometry.mask_mode = 2;
            if (this_box_volume.geometry.mask_mode == 1) {
                if (global_geometry_list.elements[loop_index].Volume->geometry.is_masked_volume == 1 && global_geometry_list.elements[loop_index].Volume->geometry.mask_mode != 2)
                    // If more than one mask is added to one volume, the ANY mode overwrites the (default) ALL mode.
                    global_geometry_list.elements[loop_index].Volume->geometry.mask_mode = 1;
            }
            
            found_geometries = 1;
        }
    }
    if (found_geometries == 0) {
        printf("The mask_string in geometry: %s did not find any of the specified volumes in the mask_string %s \n",NAME_CURRENT_COMP,mask_string);
        exit(1);
    }
    this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
    this_box_volume.p_physics->is_vacuum = 0; // Makes this volume a vacuum
    this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
    this_box_volume.p_physics->my_a = 0; // Should not be used.
    sprintf(this_box_volume.p_physics->name,"Mask");
    this_box_volume.geometry.is_mask_volume = 1;
    
    
// Read the material input, or if it lacks, use automatic linking.
} else if (material_string && strlen(material_string) && strcmp(material_string, "NULL") && strcmp(material_string, "0")) {
    // A geometry string was given, use it to determine which material
    if (0 == strcmp(material_string,"vacuum") || 0 == strcmp(material_string,"Vacuum")) {
        // One could have a global physics struct for vacuum instead of creating one for each
        this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
        this_box_volume.p_physics->is_vacuum = 1; // Makes this volume a vacuum
        this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
        this_box_volume.p_physics->my_a = 0; // Should not be used.
        sprintf(this_box_volume.p_physics->name,"Vacuum");
    } else if (0 == strcmp(material_string,"exit") || 0 == strcmp(material_string,"Exit")) {
        // One could have a global physics struct for vacuum instead of creating one for each
        this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
        this_box_volume.p_physics->is_vacuum = 1; // Makes this volume a vacuum
        this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
        this_box_volume.p_physics->my_a = 0; // Should not be used.
        this_box_volume.geometry.is_exit_volume = 1;
        sprintf(this_box_volume.p_physics->name,"Exit");
    } else {
        #ifndef MATERIAL_DETECTOR
            printf("Need to define a material before refering to it in a geometry %s.\n",NAME_CURRENT_COMP);
            exit(1);
        #endif
        for (loop_index=0;loop_index<global_material_list.num_elements;loop_index++) {
            if (0 == strcmp(material_string,global_material_list.elements[loop_index].name)) {
                this_box_volume.p_physics = global_material_list.elements[loop_index].physics;
                break;
            }
            if (loop_index == global_material_list.num_elements-1) {
            printf("\n");
            printf("ERROR: The material string \"%s\" in Union geometry \"%s\" did not match a specified material. \n",material_string,NAME_CURRENT_COMP);
            printf("       The materials available at this point (need to be defined before the geometry): \n");
            for (loop_index=0;loop_index<global_material_list.num_elements;loop_index++)
              printf("         %s\n",global_material_list.elements[loop_index].name);
            printf("\n");
            printf("       It is also possible to use one of the defualt materials avaiable: \n");
            printf("           Vacuum (for a Volume without scattering or absorption)\n");
            printf("           Exit (for a Volume where the ray exits the component if it enters)\n");
            printf("           Mask (for a Volume that masks existing volumes specified in the mask_string\n");
            exit(1);
          }
        }
    }
} else {
    // Automatic linking, simply using the last defined material.
    #ifndef MATERIAL_DETECTOR
        printf("Need to define a material before the geometry to use automatic linking %s.\n",NAME_CURRENT_COMP);
        exit(1);
    #endif
    this_box_volume.p_physics = global_material_list.elements[global_material_list.num_elements-1].physics;
}

sprintf(this_box_volume.name,NAME_CURRENT_COMP);
sprintf(this_box_volume.geometry.shape,"box");
this_box_volume.geometry.priority_value = priority;
this_box_volume.geometry.geometry_p_interact = p_interact;
// Currently the coordinates will be in absolute space.
this_box_volume.geometry.center = POS_A_CURRENT_COMP;

this_box_storage.z_depth = zdepth;
this_box_storage.x_width1 = xwidth;
this_box_storage.y_height1 = yheight;

this_box_storage.is_rectangle = 0;
if (xwidth2 < 0 && yheight2 < 0) this_box_storage.is_rectangle = 1;
if (xwidth == xwidth2 && yheight == yheight2) this_box_storage.is_rectangle = 1;

if (xwidth2 < 0) {
    this_box_storage.x_width2 = xwidth;
    xwidth2 = xwidth;
} else this_box_storage.x_width2 = xwidth2;

if (yheight2 < 0) {
    this_box_storage.y_height2 = yheight;
    yheight2 = yheight;
} else this_box_storage.y_height2 = yheight2;


this_box_storage.normal_vectors[0] = coords_set(0,0,1);
this_box_storage.normal_vectors[1] = coords_set(0,0,1);

// for sides with y component = 0
x_component = 2*zdepth/sqrt((xwidth-xwidth2)*(xwidth-xwidth2)+4*zdepth*zdepth);
z_component = (xwidth-xwidth2)/sqrt(4*zdepth*zdepth+(xwidth-xwidth2)*(xwidth-xwidth2));

this_box_storage.normal_vectors[2] = coords_set(x_component,0,z_component);
this_box_storage.normal_vectors[3] = coords_set(-x_component,0,z_component);

// for sides with x component = 0
y_component = 2*zdepth/sqrt((yheight-yheight2)*(yheight-yheight2)+4*zdepth*zdepth);
z_component = (yheight-yheight2)/sqrt(4*zdepth*zdepth+(yheight-yheight2)*(yheight-yheight2));

this_box_storage.normal_vectors[4] = coords_set(0,y_component,z_component);
this_box_storage.normal_vectors[5] = coords_set(0,-y_component,z_component);

this_box_volume.geometry.visualization_on = visualize;

this_box_volume.geometry.geometry_parameters.p_box_storage = &this_box_storage;

// Assign pointers to functions for intersection with the shape, checking if a point is inside the shape
if (this_box_storage.is_rectangle == 1) {
this_box_volume.geometry.intersect_function = &sample_box_intersect_simple;
this_box_volume.geometry.within_function = &r_within_box_simple;
}
else {
this_box_volume.geometry.intersect_function = &sample_box_intersect_advanced;
this_box_volume.geometry.within_function = &r_within_box_advanced;
}

this_box_volume.geometry.shell_points = &box_shell_points;
this_box_volume.geometry.mcdisplay_function = &mcdisplay_box_function;
this_box_volume.geometry.initialize_from_main_function = &initialize_box_geometry_from_main_component;
this_box_volume.geometry.process_rot_allocated = 0;

this_box_volume.geometry.copy_geometry_parameters = &allocate_box_storage_copy;

rot_copy(this_box_volume.geometry.rotation_matrix,ROT_A_CURRENT_COMP); //check how ROT_R_CURRENT_COMP would work
rot_transpose(ROT_A_CURRENT_COMP,this_box_volume.geometry.transpose_rotation_matrix);

// Initialize loggers
this_box_volume.loggers.num_elements = 0;

// packing the information into the global_geometry_element, which is then included in the global_geometry_list.
sprintf(global_geometry_element.name,NAME_CURRENT_COMP);
global_geometry_element.activation_counter = number_of_activations;
global_geometry_element.component_index = INDEX_CURRENT_COMP;
global_geometry_element.Volume = &this_box_volume; // Would be nicer if this m was a pointer, now we have the (small) data two places
add_element_to_geometry_list(&global_geometry_list,global_geometry_element);
}
#line 315830 "MACS_sample_kidney_box.c"
#undef number_of_activations
#undef mask_setting
#undef mask_string
#undef p_interact
#undef focus_r
#undef focus_xh
#undef focus_xw
#undef focus_ah
#undef focus_aw
#undef target_z
#undef target_y
#undef target_x
#undef target_index
#undef visualize
#undef yheight2
#undef xwidth2
#undef zdepth
#undef yheight
#undef xwidth
#undef priority
#undef material_string
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

  /* Initializations for component channel_17_analyzer_1_array_crystal_array_2. */
  SIG_MESSAGE("channel_17_analyzer_1_array_crystal_array_2 (Init)");
#define mccompcurname  channel_17_analyzer_1_array_crystal_array_2
#define mccompcurtype  Union_box
#define mccompcurindex 778
#define loop_index mccchannel_17_analyzer_1_array_crystal_array_2_loop_index
#define this_box_volume mccchannel_17_analyzer_1_array_crystal_array_2_this_box_volume
#define global_geometry_element mccchannel_17_analyzer_1_array_crystal_array_2_global_geometry_element
#define this_box_storage mccchannel_17_analyzer_1_array_crystal_array_2_this_box_storage
#define material_string mccchannel_17_analyzer_1_array_crystal_array_2_material_string
#define priority mccchannel_17_analyzer_1_array_crystal_array_2_priority
#define xwidth mccchannel_17_analyzer_1_array_crystal_array_2_xwidth
#define yheight mccchannel_17_analyzer_1_array_crystal_array_2_yheight
#define zdepth mccchannel_17_analyzer_1_array_crystal_array_2_zdepth
#define xwidth2 mccchannel_17_analyzer_1_array_crystal_array_2_xwidth2
#define yheight2 mccchannel_17_analyzer_1_array_crystal_array_2_yheight2
#define visualize mccchannel_17_analyzer_1_array_crystal_array_2_visualize
#define target_index mccchannel_17_analyzer_1_array_crystal_array_2_target_index
#define target_x mccchannel_17_analyzer_1_array_crystal_array_2_target_x
#define target_y mccchannel_17_analyzer_1_array_crystal_array_2_target_y
#define target_z mccchannel_17_analyzer_1_array_crystal_array_2_target_z
#define focus_aw mccchannel_17_analyzer_1_array_crystal_array_2_focus_aw
#define focus_ah mccchannel_17_analyzer_1_array_crystal_array_2_focus_ah
#define focus_xw mccchannel_17_analyzer_1_array_crystal_array_2_focus_xw
#define focus_xh mccchannel_17_analyzer_1_array_crystal_array_2_focus_xh
#define focus_r mccchannel_17_analyzer_1_array_crystal_array_2_focus_r
#define p_interact mccchannel_17_analyzer_1_array_crystal_array_2_p_interact
#define mask_string mccchannel_17_analyzer_1_array_crystal_array_2_mask_string
#define mask_setting mccchannel_17_analyzer_1_array_crystal_array_2_mask_setting
#define number_of_activations mccchannel_17_analyzer_1_array_crystal_array_2_number_of_activations
#line 224 "Union_box.comp"
{
// Initializes the focusing system for this volume including input sanitation.
focus_initialize(&this_box_volume.geometry, POS_A_COMP_INDEX(INDEX_CURRENT_COMP+target_index), POS_A_CURRENT_COMP, ROT_A_CURRENT_COMP, target_index, target_x, target_y, target_z, focus_aw, focus_ah, focus_xw, focus_xh, focus_r, NAME_CURRENT_COMP);

// Input sanitation for this geometry
if (xwidth <= 0) {
  printf("\nERROR in Union_box named %s, the xwidth is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (yheight <= 0) {
  printf("\nERROR in Union_box named %s, yheight is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (zdepth <= 0) {
  printf("\nERROR in Union_box named %s, zdepth is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (xwidth2 <= 0 && xwidth2 != -1) {
  printf("\nERROR in Union_box named %s, the xwidth2 is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (yheight2 <= 0 && yheight2 != -1) {
  printf("\nERROR in Union_box named %s, yheight2 is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}

// Use sanitation
if (global_material_list.num_elements == 0) {
  printf("\nERROR: Need to define a material using Union_make_material before using a Union geometry component. \n");
  printf("       %s was defined before first use of Union_make_material.\n",NAME_CURRENT_COMP);
  exit(1);
}

this_box_volume.geometry.is_masked_volume = 0;
this_box_volume.geometry.is_exit_volume = 0;
this_box_volume.geometry.is_mask_volume = 0;
// check if the volume is a mask, if it is the material string is irelevant.
if (mask_string && strlen(mask_string) && strcmp(mask_string, "NULL") && strcmp(mask_string, "0")) {
    // A mask volume is used to limit the extend of other volumes, called the masked volumes. These are specified in the mask_string.
    // In order for a ray to enter a masked volume, it needs to be both in the region covered by that volume AND the mask volume.
    // When more than
    this_box_volume.geometry.mask_mode = 1; // Default is mask mode is ALL
    if (mask_setting && strlen(mask_setting) && strcmp(mask_setting, "NULL") && strcmp(mask_setting, "0")) {
        if (strcmp(mask_setting,"ALL") == 0 || strcmp(mask_setting,"All") == 0) this_box_volume.geometry.mask_mode = 1;
        else if (strcmp(mask_setting,"ANY") == 0 || strcmp(mask_setting,"Any") == 0) this_box_volume.geometry.mask_mode = 2;
        else {
            printf("The mask_mode of component %s is set to %s, but must be either ALL or ANY.\n",NAME_CURRENT_COMP,mask_setting);
            exit(1);
        }
    }
    
    for (loop_index=0;loop_index<global_geometry_list.num_elements;loop_index++) {
        // Add mask list
        if (1 == manual_linking_function(global_geometry_list.elements[loop_index].name,mask_string)) {
            add_element_to_int_list(&this_box_volume.geometry.mask_list,global_geometry_list.elements[loop_index].component_index);
            add_element_to_int_list(&global_geometry_list.elements[loop_index].Volume->geometry.masked_by_list,INDEX_CURRENT_COMP);
            global_geometry_list.elements[loop_index].Volume->geometry.is_masked_volume = 1;
            if (this_box_volume.geometry.mask_mode == 2)
                global_geometry_list.elements[loop_index].Volume->geometry.mask_mode = 2;
            if (this_box_volume.geometry.mask_mode == 1) {
                if (global_geometry_list.elements[loop_index].Volume->geometry.is_masked_volume == 1 && global_geometry_list.elements[loop_index].Volume->geometry.mask_mode != 2)
                    // If more than one mask is added to one volume, the ANY mode overwrites the (default) ALL mode.
                    global_geometry_list.elements[loop_index].Volume->geometry.mask_mode = 1;
            }
            
            found_geometries = 1;
        }
    }
    if (found_geometries == 0) {
        printf("The mask_string in geometry: %s did not find any of the specified volumes in the mask_string %s \n",NAME_CURRENT_COMP,mask_string);
        exit(1);
    }
    this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
    this_box_volume.p_physics->is_vacuum = 0; // Makes this volume a vacuum
    this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
    this_box_volume.p_physics->my_a = 0; // Should not be used.
    sprintf(this_box_volume.p_physics->name,"Mask");
    this_box_volume.geometry.is_mask_volume = 1;
    
    
// Read the material input, or if it lacks, use automatic linking.
} else if (material_string && strlen(material_string) && strcmp(material_string, "NULL") && strcmp(material_string, "0")) {
    // A geometry string was given, use it to determine which material
    if (0 == strcmp(material_string,"vacuum") || 0 == strcmp(material_string,"Vacuum")) {
        // One could have a global physics struct for vacuum instead of creating one for each
        this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
        this_box_volume.p_physics->is_vacuum = 1; // Makes this volume a vacuum
        this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
        this_box_volume.p_physics->my_a = 0; // Should not be used.
        sprintf(this_box_volume.p_physics->name,"Vacuum");
    } else if (0 == strcmp(material_string,"exit") || 0 == strcmp(material_string,"Exit")) {
        // One could have a global physics struct for vacuum instead of creating one for each
        this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
        this_box_volume.p_physics->is_vacuum = 1; // Makes this volume a vacuum
        this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
        this_box_volume.p_physics->my_a = 0; // Should not be used.
        this_box_volume.geometry.is_exit_volume = 1;
        sprintf(this_box_volume.p_physics->name,"Exit");
    } else {
        #ifndef MATERIAL_DETECTOR
            printf("Need to define a material before refering to it in a geometry %s.\n",NAME_CURRENT_COMP);
            exit(1);
        #endif
        for (loop_index=0;loop_index<global_material_list.num_elements;loop_index++) {
            if (0 == strcmp(material_string,global_material_list.elements[loop_index].name)) {
                this_box_volume.p_physics = global_material_list.elements[loop_index].physics;
                break;
            }
            if (loop_index == global_material_list.num_elements-1) {
            printf("\n");
            printf("ERROR: The material string \"%s\" in Union geometry \"%s\" did not match a specified material. \n",material_string,NAME_CURRENT_COMP);
            printf("       The materials available at this point (need to be defined before the geometry): \n");
            for (loop_index=0;loop_index<global_material_list.num_elements;loop_index++)
              printf("         %s\n",global_material_list.elements[loop_index].name);
            printf("\n");
            printf("       It is also possible to use one of the defualt materials avaiable: \n");
            printf("           Vacuum (for a Volume without scattering or absorption)\n");
            printf("           Exit (for a Volume where the ray exits the component if it enters)\n");
            printf("           Mask (for a Volume that masks existing volumes specified in the mask_string\n");
            exit(1);
          }
        }
    }
} else {
    // Automatic linking, simply using the last defined material.
    #ifndef MATERIAL_DETECTOR
        printf("Need to define a material before the geometry to use automatic linking %s.\n",NAME_CURRENT_COMP);
        exit(1);
    #endif
    this_box_volume.p_physics = global_material_list.elements[global_material_list.num_elements-1].physics;
}

sprintf(this_box_volume.name,NAME_CURRENT_COMP);
sprintf(this_box_volume.geometry.shape,"box");
this_box_volume.geometry.priority_value = priority;
this_box_volume.geometry.geometry_p_interact = p_interact;
// Currently the coordinates will be in absolute space.
this_box_volume.geometry.center = POS_A_CURRENT_COMP;

this_box_storage.z_depth = zdepth;
this_box_storage.x_width1 = xwidth;
this_box_storage.y_height1 = yheight;

this_box_storage.is_rectangle = 0;
if (xwidth2 < 0 && yheight2 < 0) this_box_storage.is_rectangle = 1;
if (xwidth == xwidth2 && yheight == yheight2) this_box_storage.is_rectangle = 1;

if (xwidth2 < 0) {
    this_box_storage.x_width2 = xwidth;
    xwidth2 = xwidth;
} else this_box_storage.x_width2 = xwidth2;

if (yheight2 < 0) {
    this_box_storage.y_height2 = yheight;
    yheight2 = yheight;
} else this_box_storage.y_height2 = yheight2;


this_box_storage.normal_vectors[0] = coords_set(0,0,1);
this_box_storage.normal_vectors[1] = coords_set(0,0,1);

// for sides with y component = 0
x_component = 2*zdepth/sqrt((xwidth-xwidth2)*(xwidth-xwidth2)+4*zdepth*zdepth);
z_component = (xwidth-xwidth2)/sqrt(4*zdepth*zdepth+(xwidth-xwidth2)*(xwidth-xwidth2));

this_box_storage.normal_vectors[2] = coords_set(x_component,0,z_component);
this_box_storage.normal_vectors[3] = coords_set(-x_component,0,z_component);

// for sides with x component = 0
y_component = 2*zdepth/sqrt((yheight-yheight2)*(yheight-yheight2)+4*zdepth*zdepth);
z_component = (yheight-yheight2)/sqrt(4*zdepth*zdepth+(yheight-yheight2)*(yheight-yheight2));

this_box_storage.normal_vectors[4] = coords_set(0,y_component,z_component);
this_box_storage.normal_vectors[5] = coords_set(0,-y_component,z_component);

this_box_volume.geometry.visualization_on = visualize;

this_box_volume.geometry.geometry_parameters.p_box_storage = &this_box_storage;

// Assign pointers to functions for intersection with the shape, checking if a point is inside the shape
if (this_box_storage.is_rectangle == 1) {
this_box_volume.geometry.intersect_function = &sample_box_intersect_simple;
this_box_volume.geometry.within_function = &r_within_box_simple;
}
else {
this_box_volume.geometry.intersect_function = &sample_box_intersect_advanced;
this_box_volume.geometry.within_function = &r_within_box_advanced;
}

this_box_volume.geometry.shell_points = &box_shell_points;
this_box_volume.geometry.mcdisplay_function = &mcdisplay_box_function;
this_box_volume.geometry.initialize_from_main_function = &initialize_box_geometry_from_main_component;
this_box_volume.geometry.process_rot_allocated = 0;

this_box_volume.geometry.copy_geometry_parameters = &allocate_box_storage_copy;

rot_copy(this_box_volume.geometry.rotation_matrix,ROT_A_CURRENT_COMP); //check how ROT_R_CURRENT_COMP would work
rot_transpose(ROT_A_CURRENT_COMP,this_box_volume.geometry.transpose_rotation_matrix);

// Initialize loggers
this_box_volume.loggers.num_elements = 0;

// packing the information into the global_geometry_element, which is then included in the global_geometry_list.
sprintf(global_geometry_element.name,NAME_CURRENT_COMP);
global_geometry_element.activation_counter = number_of_activations;
global_geometry_element.component_index = INDEX_CURRENT_COMP;
global_geometry_element.Volume = &this_box_volume; // Would be nicer if this m was a pointer, now we have the (small) data two places
add_element_to_geometry_list(&global_geometry_list,global_geometry_element);
}
#line 316100 "MACS_sample_kidney_box.c"
#undef number_of_activations
#undef mask_setting
#undef mask_string
#undef p_interact
#undef focus_r
#undef focus_xh
#undef focus_xw
#undef focus_ah
#undef focus_aw
#undef target_z
#undef target_y
#undef target_x
#undef target_index
#undef visualize
#undef yheight2
#undef xwidth2
#undef zdepth
#undef yheight
#undef xwidth
#undef priority
#undef material_string
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

  /* Initializations for component channel_17_analyzer_1_array_crystal_array_3. */
  SIG_MESSAGE("channel_17_analyzer_1_array_crystal_array_3 (Init)");
#define mccompcurname  channel_17_analyzer_1_array_crystal_array_3
#define mccompcurtype  Union_box
#define mccompcurindex 779
#define loop_index mccchannel_17_analyzer_1_array_crystal_array_3_loop_index
#define this_box_volume mccchannel_17_analyzer_1_array_crystal_array_3_this_box_volume
#define global_geometry_element mccchannel_17_analyzer_1_array_crystal_array_3_global_geometry_element
#define this_box_storage mccchannel_17_analyzer_1_array_crystal_array_3_this_box_storage
#define material_string mccchannel_17_analyzer_1_array_crystal_array_3_material_string
#define priority mccchannel_17_analyzer_1_array_crystal_array_3_priority
#define xwidth mccchannel_17_analyzer_1_array_crystal_array_3_xwidth
#define yheight mccchannel_17_analyzer_1_array_crystal_array_3_yheight
#define zdepth mccchannel_17_analyzer_1_array_crystal_array_3_zdepth
#define xwidth2 mccchannel_17_analyzer_1_array_crystal_array_3_xwidth2
#define yheight2 mccchannel_17_analyzer_1_array_crystal_array_3_yheight2
#define visualize mccchannel_17_analyzer_1_array_crystal_array_3_visualize
#define target_index mccchannel_17_analyzer_1_array_crystal_array_3_target_index
#define target_x mccchannel_17_analyzer_1_array_crystal_array_3_target_x
#define target_y mccchannel_17_analyzer_1_array_crystal_array_3_target_y
#define target_z mccchannel_17_analyzer_1_array_crystal_array_3_target_z
#define focus_aw mccchannel_17_analyzer_1_array_crystal_array_3_focus_aw
#define focus_ah mccchannel_17_analyzer_1_array_crystal_array_3_focus_ah
#define focus_xw mccchannel_17_analyzer_1_array_crystal_array_3_focus_xw
#define focus_xh mccchannel_17_analyzer_1_array_crystal_array_3_focus_xh
#define focus_r mccchannel_17_analyzer_1_array_crystal_array_3_focus_r
#define p_interact mccchannel_17_analyzer_1_array_crystal_array_3_p_interact
#define mask_string mccchannel_17_analyzer_1_array_crystal_array_3_mask_string
#define mask_setting mccchannel_17_analyzer_1_array_crystal_array_3_mask_setting
#define number_of_activations mccchannel_17_analyzer_1_array_crystal_array_3_number_of_activations
#line 224 "Union_box.comp"
{
// Initializes the focusing system for this volume including input sanitation.
focus_initialize(&this_box_volume.geometry, POS_A_COMP_INDEX(INDEX_CURRENT_COMP+target_index), POS_A_CURRENT_COMP, ROT_A_CURRENT_COMP, target_index, target_x, target_y, target_z, focus_aw, focus_ah, focus_xw, focus_xh, focus_r, NAME_CURRENT_COMP);

// Input sanitation for this geometry
if (xwidth <= 0) {
  printf("\nERROR in Union_box named %s, the xwidth is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (yheight <= 0) {
  printf("\nERROR in Union_box named %s, yheight is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (zdepth <= 0) {
  printf("\nERROR in Union_box named %s, zdepth is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (xwidth2 <= 0 && xwidth2 != -1) {
  printf("\nERROR in Union_box named %s, the xwidth2 is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (yheight2 <= 0 && yheight2 != -1) {
  printf("\nERROR in Union_box named %s, yheight2 is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}

// Use sanitation
if (global_material_list.num_elements == 0) {
  printf("\nERROR: Need to define a material using Union_make_material before using a Union geometry component. \n");
  printf("       %s was defined before first use of Union_make_material.\n",NAME_CURRENT_COMP);
  exit(1);
}

this_box_volume.geometry.is_masked_volume = 0;
this_box_volume.geometry.is_exit_volume = 0;
this_box_volume.geometry.is_mask_volume = 0;
// check if the volume is a mask, if it is the material string is irelevant.
if (mask_string && strlen(mask_string) && strcmp(mask_string, "NULL") && strcmp(mask_string, "0")) {
    // A mask volume is used to limit the extend of other volumes, called the masked volumes. These are specified in the mask_string.
    // In order for a ray to enter a masked volume, it needs to be both in the region covered by that volume AND the mask volume.
    // When more than
    this_box_volume.geometry.mask_mode = 1; // Default is mask mode is ALL
    if (mask_setting && strlen(mask_setting) && strcmp(mask_setting, "NULL") && strcmp(mask_setting, "0")) {
        if (strcmp(mask_setting,"ALL") == 0 || strcmp(mask_setting,"All") == 0) this_box_volume.geometry.mask_mode = 1;
        else if (strcmp(mask_setting,"ANY") == 0 || strcmp(mask_setting,"Any") == 0) this_box_volume.geometry.mask_mode = 2;
        else {
            printf("The mask_mode of component %s is set to %s, but must be either ALL or ANY.\n",NAME_CURRENT_COMP,mask_setting);
            exit(1);
        }
    }
    
    for (loop_index=0;loop_index<global_geometry_list.num_elements;loop_index++) {
        // Add mask list
        if (1 == manual_linking_function(global_geometry_list.elements[loop_index].name,mask_string)) {
            add_element_to_int_list(&this_box_volume.geometry.mask_list,global_geometry_list.elements[loop_index].component_index);
            add_element_to_int_list(&global_geometry_list.elements[loop_index].Volume->geometry.masked_by_list,INDEX_CURRENT_COMP);
            global_geometry_list.elements[loop_index].Volume->geometry.is_masked_volume = 1;
            if (this_box_volume.geometry.mask_mode == 2)
                global_geometry_list.elements[loop_index].Volume->geometry.mask_mode = 2;
            if (this_box_volume.geometry.mask_mode == 1) {
                if (global_geometry_list.elements[loop_index].Volume->geometry.is_masked_volume == 1 && global_geometry_list.elements[loop_index].Volume->geometry.mask_mode != 2)
                    // If more than one mask is added to one volume, the ANY mode overwrites the (default) ALL mode.
                    global_geometry_list.elements[loop_index].Volume->geometry.mask_mode = 1;
            }
            
            found_geometries = 1;
        }
    }
    if (found_geometries == 0) {
        printf("The mask_string in geometry: %s did not find any of the specified volumes in the mask_string %s \n",NAME_CURRENT_COMP,mask_string);
        exit(1);
    }
    this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
    this_box_volume.p_physics->is_vacuum = 0; // Makes this volume a vacuum
    this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
    this_box_volume.p_physics->my_a = 0; // Should not be used.
    sprintf(this_box_volume.p_physics->name,"Mask");
    this_box_volume.geometry.is_mask_volume = 1;
    
    
// Read the material input, or if it lacks, use automatic linking.
} else if (material_string && strlen(material_string) && strcmp(material_string, "NULL") && strcmp(material_string, "0")) {
    // A geometry string was given, use it to determine which material
    if (0 == strcmp(material_string,"vacuum") || 0 == strcmp(material_string,"Vacuum")) {
        // One could have a global physics struct for vacuum instead of creating one for each
        this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
        this_box_volume.p_physics->is_vacuum = 1; // Makes this volume a vacuum
        this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
        this_box_volume.p_physics->my_a = 0; // Should not be used.
        sprintf(this_box_volume.p_physics->name,"Vacuum");
    } else if (0 == strcmp(material_string,"exit") || 0 == strcmp(material_string,"Exit")) {
        // One could have a global physics struct for vacuum instead of creating one for each
        this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
        this_box_volume.p_physics->is_vacuum = 1; // Makes this volume a vacuum
        this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
        this_box_volume.p_physics->my_a = 0; // Should not be used.
        this_box_volume.geometry.is_exit_volume = 1;
        sprintf(this_box_volume.p_physics->name,"Exit");
    } else {
        #ifndef MATERIAL_DETECTOR
            printf("Need to define a material before refering to it in a geometry %s.\n",NAME_CURRENT_COMP);
            exit(1);
        #endif
        for (loop_index=0;loop_index<global_material_list.num_elements;loop_index++) {
            if (0 == strcmp(material_string,global_material_list.elements[loop_index].name)) {
                this_box_volume.p_physics = global_material_list.elements[loop_index].physics;
                break;
            }
            if (loop_index == global_material_list.num_elements-1) {
            printf("\n");
            printf("ERROR: The material string \"%s\" in Union geometry \"%s\" did not match a specified material. \n",material_string,NAME_CURRENT_COMP);
            printf("       The materials available at this point (need to be defined before the geometry): \n");
            for (loop_index=0;loop_index<global_material_list.num_elements;loop_index++)
              printf("         %s\n",global_material_list.elements[loop_index].name);
            printf("\n");
            printf("       It is also possible to use one of the defualt materials avaiable: \n");
            printf("           Vacuum (for a Volume without scattering or absorption)\n");
            printf("           Exit (for a Volume where the ray exits the component if it enters)\n");
            printf("           Mask (for a Volume that masks existing volumes specified in the mask_string\n");
            exit(1);
          }
        }
    }
} else {
    // Automatic linking, simply using the last defined material.
    #ifndef MATERIAL_DETECTOR
        printf("Need to define a material before the geometry to use automatic linking %s.\n",NAME_CURRENT_COMP);
        exit(1);
    #endif
    this_box_volume.p_physics = global_material_list.elements[global_material_list.num_elements-1].physics;
}

sprintf(this_box_volume.name,NAME_CURRENT_COMP);
sprintf(this_box_volume.geometry.shape,"box");
this_box_volume.geometry.priority_value = priority;
this_box_volume.geometry.geometry_p_interact = p_interact;
// Currently the coordinates will be in absolute space.
this_box_volume.geometry.center = POS_A_CURRENT_COMP;

this_box_storage.z_depth = zdepth;
this_box_storage.x_width1 = xwidth;
this_box_storage.y_height1 = yheight;

this_box_storage.is_rectangle = 0;
if (xwidth2 < 0 && yheight2 < 0) this_box_storage.is_rectangle = 1;
if (xwidth == xwidth2 && yheight == yheight2) this_box_storage.is_rectangle = 1;

if (xwidth2 < 0) {
    this_box_storage.x_width2 = xwidth;
    xwidth2 = xwidth;
} else this_box_storage.x_width2 = xwidth2;

if (yheight2 < 0) {
    this_box_storage.y_height2 = yheight;
    yheight2 = yheight;
} else this_box_storage.y_height2 = yheight2;


this_box_storage.normal_vectors[0] = coords_set(0,0,1);
this_box_storage.normal_vectors[1] = coords_set(0,0,1);

// for sides with y component = 0
x_component = 2*zdepth/sqrt((xwidth-xwidth2)*(xwidth-xwidth2)+4*zdepth*zdepth);
z_component = (xwidth-xwidth2)/sqrt(4*zdepth*zdepth+(xwidth-xwidth2)*(xwidth-xwidth2));

this_box_storage.normal_vectors[2] = coords_set(x_component,0,z_component);
this_box_storage.normal_vectors[3] = coords_set(-x_component,0,z_component);

// for sides with x component = 0
y_component = 2*zdepth/sqrt((yheight-yheight2)*(yheight-yheight2)+4*zdepth*zdepth);
z_component = (yheight-yheight2)/sqrt(4*zdepth*zdepth+(yheight-yheight2)*(yheight-yheight2));

this_box_storage.normal_vectors[4] = coords_set(0,y_component,z_component);
this_box_storage.normal_vectors[5] = coords_set(0,-y_component,z_component);

this_box_volume.geometry.visualization_on = visualize;

this_box_volume.geometry.geometry_parameters.p_box_storage = &this_box_storage;

// Assign pointers to functions for intersection with the shape, checking if a point is inside the shape
if (this_box_storage.is_rectangle == 1) {
this_box_volume.geometry.intersect_function = &sample_box_intersect_simple;
this_box_volume.geometry.within_function = &r_within_box_simple;
}
else {
this_box_volume.geometry.intersect_function = &sample_box_intersect_advanced;
this_box_volume.geometry.within_function = &r_within_box_advanced;
}

this_box_volume.geometry.shell_points = &box_shell_points;
this_box_volume.geometry.mcdisplay_function = &mcdisplay_box_function;
this_box_volume.geometry.initialize_from_main_function = &initialize_box_geometry_from_main_component;
this_box_volume.geometry.process_rot_allocated = 0;

this_box_volume.geometry.copy_geometry_parameters = &allocate_box_storage_copy;

rot_copy(this_box_volume.geometry.rotation_matrix,ROT_A_CURRENT_COMP); //check how ROT_R_CURRENT_COMP would work
rot_transpose(ROT_A_CURRENT_COMP,this_box_volume.geometry.transpose_rotation_matrix);

// Initialize loggers
this_box_volume.loggers.num_elements = 0;

// packing the information into the global_geometry_element, which is then included in the global_geometry_list.
sprintf(global_geometry_element.name,NAME_CURRENT_COMP);
global_geometry_element.activation_counter = number_of_activations;
global_geometry_element.component_index = INDEX_CURRENT_COMP;
global_geometry_element.Volume = &this_box_volume; // Would be nicer if this m was a pointer, now we have the (small) data two places
add_element_to_geometry_list(&global_geometry_list,global_geometry_element);
}
#line 316370 "MACS_sample_kidney_box.c"
#undef number_of_activations
#undef mask_setting
#undef mask_string
#undef p_interact
#undef focus_r
#undef focus_xh
#undef focus_xw
#undef focus_ah
#undef focus_aw
#undef target_z
#undef target_y
#undef target_x
#undef target_index
#undef visualize
#undef yheight2
#undef xwidth2
#undef zdepth
#undef yheight
#undef xwidth
#undef priority
#undef material_string
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

  /* Initializations for component channel_17_analyzer_1_array_crystal_array_4. */
  SIG_MESSAGE("channel_17_analyzer_1_array_crystal_array_4 (Init)");
#define mccompcurname  channel_17_analyzer_1_array_crystal_array_4
#define mccompcurtype  Union_box
#define mccompcurindex 780
#define loop_index mccchannel_17_analyzer_1_array_crystal_array_4_loop_index
#define this_box_volume mccchannel_17_analyzer_1_array_crystal_array_4_this_box_volume
#define global_geometry_element mccchannel_17_analyzer_1_array_crystal_array_4_global_geometry_element
#define this_box_storage mccchannel_17_analyzer_1_array_crystal_array_4_this_box_storage
#define material_string mccchannel_17_analyzer_1_array_crystal_array_4_material_string
#define priority mccchannel_17_analyzer_1_array_crystal_array_4_priority
#define xwidth mccchannel_17_analyzer_1_array_crystal_array_4_xwidth
#define yheight mccchannel_17_analyzer_1_array_crystal_array_4_yheight
#define zdepth mccchannel_17_analyzer_1_array_crystal_array_4_zdepth
#define xwidth2 mccchannel_17_analyzer_1_array_crystal_array_4_xwidth2
#define yheight2 mccchannel_17_analyzer_1_array_crystal_array_4_yheight2
#define visualize mccchannel_17_analyzer_1_array_crystal_array_4_visualize
#define target_index mccchannel_17_analyzer_1_array_crystal_array_4_target_index
#define target_x mccchannel_17_analyzer_1_array_crystal_array_4_target_x
#define target_y mccchannel_17_analyzer_1_array_crystal_array_4_target_y
#define target_z mccchannel_17_analyzer_1_array_crystal_array_4_target_z
#define focus_aw mccchannel_17_analyzer_1_array_crystal_array_4_focus_aw
#define focus_ah mccchannel_17_analyzer_1_array_crystal_array_4_focus_ah
#define focus_xw mccchannel_17_analyzer_1_array_crystal_array_4_focus_xw
#define focus_xh mccchannel_17_analyzer_1_array_crystal_array_4_focus_xh
#define focus_r mccchannel_17_analyzer_1_array_crystal_array_4_focus_r
#define p_interact mccchannel_17_analyzer_1_array_crystal_array_4_p_interact
#define mask_string mccchannel_17_analyzer_1_array_crystal_array_4_mask_string
#define mask_setting mccchannel_17_analyzer_1_array_crystal_array_4_mask_setting
#define number_of_activations mccchannel_17_analyzer_1_array_crystal_array_4_number_of_activations
#line 224 "Union_box.comp"
{
// Initializes the focusing system for this volume including input sanitation.
focus_initialize(&this_box_volume.geometry, POS_A_COMP_INDEX(INDEX_CURRENT_COMP+target_index), POS_A_CURRENT_COMP, ROT_A_CURRENT_COMP, target_index, target_x, target_y, target_z, focus_aw, focus_ah, focus_xw, focus_xh, focus_r, NAME_CURRENT_COMP);

// Input sanitation for this geometry
if (xwidth <= 0) {
  printf("\nERROR in Union_box named %s, the xwidth is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (yheight <= 0) {
  printf("\nERROR in Union_box named %s, yheight is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (zdepth <= 0) {
  printf("\nERROR in Union_box named %s, zdepth is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (xwidth2 <= 0 && xwidth2 != -1) {
  printf("\nERROR in Union_box named %s, the xwidth2 is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (yheight2 <= 0 && yheight2 != -1) {
  printf("\nERROR in Union_box named %s, yheight2 is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}

// Use sanitation
if (global_material_list.num_elements == 0) {
  printf("\nERROR: Need to define a material using Union_make_material before using a Union geometry component. \n");
  printf("       %s was defined before first use of Union_make_material.\n",NAME_CURRENT_COMP);
  exit(1);
}

this_box_volume.geometry.is_masked_volume = 0;
this_box_volume.geometry.is_exit_volume = 0;
this_box_volume.geometry.is_mask_volume = 0;
// check if the volume is a mask, if it is the material string is irelevant.
if (mask_string && strlen(mask_string) && strcmp(mask_string, "NULL") && strcmp(mask_string, "0")) {
    // A mask volume is used to limit the extend of other volumes, called the masked volumes. These are specified in the mask_string.
    // In order for a ray to enter a masked volume, it needs to be both in the region covered by that volume AND the mask volume.
    // When more than
    this_box_volume.geometry.mask_mode = 1; // Default is mask mode is ALL
    if (mask_setting && strlen(mask_setting) && strcmp(mask_setting, "NULL") && strcmp(mask_setting, "0")) {
        if (strcmp(mask_setting,"ALL") == 0 || strcmp(mask_setting,"All") == 0) this_box_volume.geometry.mask_mode = 1;
        else if (strcmp(mask_setting,"ANY") == 0 || strcmp(mask_setting,"Any") == 0) this_box_volume.geometry.mask_mode = 2;
        else {
            printf("The mask_mode of component %s is set to %s, but must be either ALL or ANY.\n",NAME_CURRENT_COMP,mask_setting);
            exit(1);
        }
    }
    
    for (loop_index=0;loop_index<global_geometry_list.num_elements;loop_index++) {
        // Add mask list
        if (1 == manual_linking_function(global_geometry_list.elements[loop_index].name,mask_string)) {
            add_element_to_int_list(&this_box_volume.geometry.mask_list,global_geometry_list.elements[loop_index].component_index);
            add_element_to_int_list(&global_geometry_list.elements[loop_index].Volume->geometry.masked_by_list,INDEX_CURRENT_COMP);
            global_geometry_list.elements[loop_index].Volume->geometry.is_masked_volume = 1;
            if (this_box_volume.geometry.mask_mode == 2)
                global_geometry_list.elements[loop_index].Volume->geometry.mask_mode = 2;
            if (this_box_volume.geometry.mask_mode == 1) {
                if (global_geometry_list.elements[loop_index].Volume->geometry.is_masked_volume == 1 && global_geometry_list.elements[loop_index].Volume->geometry.mask_mode != 2)
                    // If more than one mask is added to one volume, the ANY mode overwrites the (default) ALL mode.
                    global_geometry_list.elements[loop_index].Volume->geometry.mask_mode = 1;
            }
            
            found_geometries = 1;
        }
    }
    if (found_geometries == 0) {
        printf("The mask_string in geometry: %s did not find any of the specified volumes in the mask_string %s \n",NAME_CURRENT_COMP,mask_string);
        exit(1);
    }
    this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
    this_box_volume.p_physics->is_vacuum = 0; // Makes this volume a vacuum
    this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
    this_box_volume.p_physics->my_a = 0; // Should not be used.
    sprintf(this_box_volume.p_physics->name,"Mask");
    this_box_volume.geometry.is_mask_volume = 1;
    
    
// Read the material input, or if it lacks, use automatic linking.
} else if (material_string && strlen(material_string) && strcmp(material_string, "NULL") && strcmp(material_string, "0")) {
    // A geometry string was given, use it to determine which material
    if (0 == strcmp(material_string,"vacuum") || 0 == strcmp(material_string,"Vacuum")) {
        // One could have a global physics struct for vacuum instead of creating one for each
        this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
        this_box_volume.p_physics->is_vacuum = 1; // Makes this volume a vacuum
        this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
        this_box_volume.p_physics->my_a = 0; // Should not be used.
        sprintf(this_box_volume.p_physics->name,"Vacuum");
    } else if (0 == strcmp(material_string,"exit") || 0 == strcmp(material_string,"Exit")) {
        // One could have a global physics struct for vacuum instead of creating one for each
        this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
        this_box_volume.p_physics->is_vacuum = 1; // Makes this volume a vacuum
        this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
        this_box_volume.p_physics->my_a = 0; // Should not be used.
        this_box_volume.geometry.is_exit_volume = 1;
        sprintf(this_box_volume.p_physics->name,"Exit");
    } else {
        #ifndef MATERIAL_DETECTOR
            printf("Need to define a material before refering to it in a geometry %s.\n",NAME_CURRENT_COMP);
            exit(1);
        #endif
        for (loop_index=0;loop_index<global_material_list.num_elements;loop_index++) {
            if (0 == strcmp(material_string,global_material_list.elements[loop_index].name)) {
                this_box_volume.p_physics = global_material_list.elements[loop_index].physics;
                break;
            }
            if (loop_index == global_material_list.num_elements-1) {
            printf("\n");
            printf("ERROR: The material string \"%s\" in Union geometry \"%s\" did not match a specified material. \n",material_string,NAME_CURRENT_COMP);
            printf("       The materials available at this point (need to be defined before the geometry): \n");
            for (loop_index=0;loop_index<global_material_list.num_elements;loop_index++)
              printf("         %s\n",global_material_list.elements[loop_index].name);
            printf("\n");
            printf("       It is also possible to use one of the defualt materials avaiable: \n");
            printf("           Vacuum (for a Volume without scattering or absorption)\n");
            printf("           Exit (for a Volume where the ray exits the component if it enters)\n");
            printf("           Mask (for a Volume that masks existing volumes specified in the mask_string\n");
            exit(1);
          }
        }
    }
} else {
    // Automatic linking, simply using the last defined material.
    #ifndef MATERIAL_DETECTOR
        printf("Need to define a material before the geometry to use automatic linking %s.\n",NAME_CURRENT_COMP);
        exit(1);
    #endif
    this_box_volume.p_physics = global_material_list.elements[global_material_list.num_elements-1].physics;
}

sprintf(this_box_volume.name,NAME_CURRENT_COMP);
sprintf(this_box_volume.geometry.shape,"box");
this_box_volume.geometry.priority_value = priority;
this_box_volume.geometry.geometry_p_interact = p_interact;
// Currently the coordinates will be in absolute space.
this_box_volume.geometry.center = POS_A_CURRENT_COMP;

this_box_storage.z_depth = zdepth;
this_box_storage.x_width1 = xwidth;
this_box_storage.y_height1 = yheight;

this_box_storage.is_rectangle = 0;
if (xwidth2 < 0 && yheight2 < 0) this_box_storage.is_rectangle = 1;
if (xwidth == xwidth2 && yheight == yheight2) this_box_storage.is_rectangle = 1;

if (xwidth2 < 0) {
    this_box_storage.x_width2 = xwidth;
    xwidth2 = xwidth;
} else this_box_storage.x_width2 = xwidth2;

if (yheight2 < 0) {
    this_box_storage.y_height2 = yheight;
    yheight2 = yheight;
} else this_box_storage.y_height2 = yheight2;


this_box_storage.normal_vectors[0] = coords_set(0,0,1);
this_box_storage.normal_vectors[1] = coords_set(0,0,1);

// for sides with y component = 0
x_component = 2*zdepth/sqrt((xwidth-xwidth2)*(xwidth-xwidth2)+4*zdepth*zdepth);
z_component = (xwidth-xwidth2)/sqrt(4*zdepth*zdepth+(xwidth-xwidth2)*(xwidth-xwidth2));

this_box_storage.normal_vectors[2] = coords_set(x_component,0,z_component);
this_box_storage.normal_vectors[3] = coords_set(-x_component,0,z_component);

// for sides with x component = 0
y_component = 2*zdepth/sqrt((yheight-yheight2)*(yheight-yheight2)+4*zdepth*zdepth);
z_component = (yheight-yheight2)/sqrt(4*zdepth*zdepth+(yheight-yheight2)*(yheight-yheight2));

this_box_storage.normal_vectors[4] = coords_set(0,y_component,z_component);
this_box_storage.normal_vectors[5] = coords_set(0,-y_component,z_component);

this_box_volume.geometry.visualization_on = visualize;

this_box_volume.geometry.geometry_parameters.p_box_storage = &this_box_storage;

// Assign pointers to functions for intersection with the shape, checking if a point is inside the shape
if (this_box_storage.is_rectangle == 1) {
this_box_volume.geometry.intersect_function = &sample_box_intersect_simple;
this_box_volume.geometry.within_function = &r_within_box_simple;
}
else {
this_box_volume.geometry.intersect_function = &sample_box_intersect_advanced;
this_box_volume.geometry.within_function = &r_within_box_advanced;
}

this_box_volume.geometry.shell_points = &box_shell_points;
this_box_volume.geometry.mcdisplay_function = &mcdisplay_box_function;
this_box_volume.geometry.initialize_from_main_function = &initialize_box_geometry_from_main_component;
this_box_volume.geometry.process_rot_allocated = 0;

this_box_volume.geometry.copy_geometry_parameters = &allocate_box_storage_copy;

rot_copy(this_box_volume.geometry.rotation_matrix,ROT_A_CURRENT_COMP); //check how ROT_R_CURRENT_COMP would work
rot_transpose(ROT_A_CURRENT_COMP,this_box_volume.geometry.transpose_rotation_matrix);

// Initialize loggers
this_box_volume.loggers.num_elements = 0;

// packing the information into the global_geometry_element, which is then included in the global_geometry_list.
sprintf(global_geometry_element.name,NAME_CURRENT_COMP);
global_geometry_element.activation_counter = number_of_activations;
global_geometry_element.component_index = INDEX_CURRENT_COMP;
global_geometry_element.Volume = &this_box_volume; // Would be nicer if this m was a pointer, now we have the (small) data two places
add_element_to_geometry_list(&global_geometry_list,global_geometry_element);
}
#line 316640 "MACS_sample_kidney_box.c"
#undef number_of_activations
#undef mask_setting
#undef mask_string
#undef p_interact
#undef focus_r
#undef focus_xh
#undef focus_xw
#undef focus_ah
#undef focus_aw
#undef target_z
#undef target_y
#undef target_x
#undef target_index
#undef visualize
#undef yheight2
#undef xwidth2
#undef zdepth
#undef yheight
#undef xwidth
#undef priority
#undef material_string
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

  /* Initializations for component channel_17_analyzer_1_array_crystal_array_5. */
  SIG_MESSAGE("channel_17_analyzer_1_array_crystal_array_5 (Init)");
#define mccompcurname  channel_17_analyzer_1_array_crystal_array_5
#define mccompcurtype  Union_box
#define mccompcurindex 781
#define loop_index mccchannel_17_analyzer_1_array_crystal_array_5_loop_index
#define this_box_volume mccchannel_17_analyzer_1_array_crystal_array_5_this_box_volume
#define global_geometry_element mccchannel_17_analyzer_1_array_crystal_array_5_global_geometry_element
#define this_box_storage mccchannel_17_analyzer_1_array_crystal_array_5_this_box_storage
#define material_string mccchannel_17_analyzer_1_array_crystal_array_5_material_string
#define priority mccchannel_17_analyzer_1_array_crystal_array_5_priority
#define xwidth mccchannel_17_analyzer_1_array_crystal_array_5_xwidth
#define yheight mccchannel_17_analyzer_1_array_crystal_array_5_yheight
#define zdepth mccchannel_17_analyzer_1_array_crystal_array_5_zdepth
#define xwidth2 mccchannel_17_analyzer_1_array_crystal_array_5_xwidth2
#define yheight2 mccchannel_17_analyzer_1_array_crystal_array_5_yheight2
#define visualize mccchannel_17_analyzer_1_array_crystal_array_5_visualize
#define target_index mccchannel_17_analyzer_1_array_crystal_array_5_target_index
#define target_x mccchannel_17_analyzer_1_array_crystal_array_5_target_x
#define target_y mccchannel_17_analyzer_1_array_crystal_array_5_target_y
#define target_z mccchannel_17_analyzer_1_array_crystal_array_5_target_z
#define focus_aw mccchannel_17_analyzer_1_array_crystal_array_5_focus_aw
#define focus_ah mccchannel_17_analyzer_1_array_crystal_array_5_focus_ah
#define focus_xw mccchannel_17_analyzer_1_array_crystal_array_5_focus_xw
#define focus_xh mccchannel_17_analyzer_1_array_crystal_array_5_focus_xh
#define focus_r mccchannel_17_analyzer_1_array_crystal_array_5_focus_r
#define p_interact mccchannel_17_analyzer_1_array_crystal_array_5_p_interact
#define mask_string mccchannel_17_analyzer_1_array_crystal_array_5_mask_string
#define mask_setting mccchannel_17_analyzer_1_array_crystal_array_5_mask_setting
#define number_of_activations mccchannel_17_analyzer_1_array_crystal_array_5_number_of_activations
#line 224 "Union_box.comp"
{
// Initializes the focusing system for this volume including input sanitation.
focus_initialize(&this_box_volume.geometry, POS_A_COMP_INDEX(INDEX_CURRENT_COMP+target_index), POS_A_CURRENT_COMP, ROT_A_CURRENT_COMP, target_index, target_x, target_y, target_z, focus_aw, focus_ah, focus_xw, focus_xh, focus_r, NAME_CURRENT_COMP);

// Input sanitation for this geometry
if (xwidth <= 0) {
  printf("\nERROR in Union_box named %s, the xwidth is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (yheight <= 0) {
  printf("\nERROR in Union_box named %s, yheight is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (zdepth <= 0) {
  printf("\nERROR in Union_box named %s, zdepth is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (xwidth2 <= 0 && xwidth2 != -1) {
  printf("\nERROR in Union_box named %s, the xwidth2 is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (yheight2 <= 0 && yheight2 != -1) {
  printf("\nERROR in Union_box named %s, yheight2 is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}

// Use sanitation
if (global_material_list.num_elements == 0) {
  printf("\nERROR: Need to define a material using Union_make_material before using a Union geometry component. \n");
  printf("       %s was defined before first use of Union_make_material.\n",NAME_CURRENT_COMP);
  exit(1);
}

this_box_volume.geometry.is_masked_volume = 0;
this_box_volume.geometry.is_exit_volume = 0;
this_box_volume.geometry.is_mask_volume = 0;
// check if the volume is a mask, if it is the material string is irelevant.
if (mask_string && strlen(mask_string) && strcmp(mask_string, "NULL") && strcmp(mask_string, "0")) {
    // A mask volume is used to limit the extend of other volumes, called the masked volumes. These are specified in the mask_string.
    // In order for a ray to enter a masked volume, it needs to be both in the region covered by that volume AND the mask volume.
    // When more than
    this_box_volume.geometry.mask_mode = 1; // Default is mask mode is ALL
    if (mask_setting && strlen(mask_setting) && strcmp(mask_setting, "NULL") && strcmp(mask_setting, "0")) {
        if (strcmp(mask_setting,"ALL") == 0 || strcmp(mask_setting,"All") == 0) this_box_volume.geometry.mask_mode = 1;
        else if (strcmp(mask_setting,"ANY") == 0 || strcmp(mask_setting,"Any") == 0) this_box_volume.geometry.mask_mode = 2;
        else {
            printf("The mask_mode of component %s is set to %s, but must be either ALL or ANY.\n",NAME_CURRENT_COMP,mask_setting);
            exit(1);
        }
    }
    
    for (loop_index=0;loop_index<global_geometry_list.num_elements;loop_index++) {
        // Add mask list
        if (1 == manual_linking_function(global_geometry_list.elements[loop_index].name,mask_string)) {
            add_element_to_int_list(&this_box_volume.geometry.mask_list,global_geometry_list.elements[loop_index].component_index);
            add_element_to_int_list(&global_geometry_list.elements[loop_index].Volume->geometry.masked_by_list,INDEX_CURRENT_COMP);
            global_geometry_list.elements[loop_index].Volume->geometry.is_masked_volume = 1;
            if (this_box_volume.geometry.mask_mode == 2)
                global_geometry_list.elements[loop_index].Volume->geometry.mask_mode = 2;
            if (this_box_volume.geometry.mask_mode == 1) {
                if (global_geometry_list.elements[loop_index].Volume->geometry.is_masked_volume == 1 && global_geometry_list.elements[loop_index].Volume->geometry.mask_mode != 2)
                    // If more than one mask is added to one volume, the ANY mode overwrites the (default) ALL mode.
                    global_geometry_list.elements[loop_index].Volume->geometry.mask_mode = 1;
            }
            
            found_geometries = 1;
        }
    }
    if (found_geometries == 0) {
        printf("The mask_string in geometry: %s did not find any of the specified volumes in the mask_string %s \n",NAME_CURRENT_COMP,mask_string);
        exit(1);
    }
    this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
    this_box_volume.p_physics->is_vacuum = 0; // Makes this volume a vacuum
    this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
    this_box_volume.p_physics->my_a = 0; // Should not be used.
    sprintf(this_box_volume.p_physics->name,"Mask");
    this_box_volume.geometry.is_mask_volume = 1;
    
    
// Read the material input, or if it lacks, use automatic linking.
} else if (material_string && strlen(material_string) && strcmp(material_string, "NULL") && strcmp(material_string, "0")) {
    // A geometry string was given, use it to determine which material
    if (0 == strcmp(material_string,"vacuum") || 0 == strcmp(material_string,"Vacuum")) {
        // One could have a global physics struct for vacuum instead of creating one for each
        this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
        this_box_volume.p_physics->is_vacuum = 1; // Makes this volume a vacuum
        this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
        this_box_volume.p_physics->my_a = 0; // Should not be used.
        sprintf(this_box_volume.p_physics->name,"Vacuum");
    } else if (0 == strcmp(material_string,"exit") || 0 == strcmp(material_string,"Exit")) {
        // One could have a global physics struct for vacuum instead of creating one for each
        this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
        this_box_volume.p_physics->is_vacuum = 1; // Makes this volume a vacuum
        this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
        this_box_volume.p_physics->my_a = 0; // Should not be used.
        this_box_volume.geometry.is_exit_volume = 1;
        sprintf(this_box_volume.p_physics->name,"Exit");
    } else {
        #ifndef MATERIAL_DETECTOR
            printf("Need to define a material before refering to it in a geometry %s.\n",NAME_CURRENT_COMP);
            exit(1);
        #endif
        for (loop_index=0;loop_index<global_material_list.num_elements;loop_index++) {
            if (0 == strcmp(material_string,global_material_list.elements[loop_index].name)) {
                this_box_volume.p_physics = global_material_list.elements[loop_index].physics;
                break;
            }
            if (loop_index == global_material_list.num_elements-1) {
            printf("\n");
            printf("ERROR: The material string \"%s\" in Union geometry \"%s\" did not match a specified material. \n",material_string,NAME_CURRENT_COMP);
            printf("       The materials available at this point (need to be defined before the geometry): \n");
            for (loop_index=0;loop_index<global_material_list.num_elements;loop_index++)
              printf("         %s\n",global_material_list.elements[loop_index].name);
            printf("\n");
            printf("       It is also possible to use one of the defualt materials avaiable: \n");
            printf("           Vacuum (for a Volume without scattering or absorption)\n");
            printf("           Exit (for a Volume where the ray exits the component if it enters)\n");
            printf("           Mask (for a Volume that masks existing volumes specified in the mask_string\n");
            exit(1);
          }
        }
    }
} else {
    // Automatic linking, simply using the last defined material.
    #ifndef MATERIAL_DETECTOR
        printf("Need to define a material before the geometry to use automatic linking %s.\n",NAME_CURRENT_COMP);
        exit(1);
    #endif
    this_box_volume.p_physics = global_material_list.elements[global_material_list.num_elements-1].physics;
}

sprintf(this_box_volume.name,NAME_CURRENT_COMP);
sprintf(this_box_volume.geometry.shape,"box");
this_box_volume.geometry.priority_value = priority;
this_box_volume.geometry.geometry_p_interact = p_interact;
// Currently the coordinates will be in absolute space.
this_box_volume.geometry.center = POS_A_CURRENT_COMP;

this_box_storage.z_depth = zdepth;
this_box_storage.x_width1 = xwidth;
this_box_storage.y_height1 = yheight;

this_box_storage.is_rectangle = 0;
if (xwidth2 < 0 && yheight2 < 0) this_box_storage.is_rectangle = 1;
if (xwidth == xwidth2 && yheight == yheight2) this_box_storage.is_rectangle = 1;

if (xwidth2 < 0) {
    this_box_storage.x_width2 = xwidth;
    xwidth2 = xwidth;
} else this_box_storage.x_width2 = xwidth2;

if (yheight2 < 0) {
    this_box_storage.y_height2 = yheight;
    yheight2 = yheight;
} else this_box_storage.y_height2 = yheight2;


this_box_storage.normal_vectors[0] = coords_set(0,0,1);
this_box_storage.normal_vectors[1] = coords_set(0,0,1);

// for sides with y component = 0
x_component = 2*zdepth/sqrt((xwidth-xwidth2)*(xwidth-xwidth2)+4*zdepth*zdepth);
z_component = (xwidth-xwidth2)/sqrt(4*zdepth*zdepth+(xwidth-xwidth2)*(xwidth-xwidth2));

this_box_storage.normal_vectors[2] = coords_set(x_component,0,z_component);
this_box_storage.normal_vectors[3] = coords_set(-x_component,0,z_component);

// for sides with x component = 0
y_component = 2*zdepth/sqrt((yheight-yheight2)*(yheight-yheight2)+4*zdepth*zdepth);
z_component = (yheight-yheight2)/sqrt(4*zdepth*zdepth+(yheight-yheight2)*(yheight-yheight2));

this_box_storage.normal_vectors[4] = coords_set(0,y_component,z_component);
this_box_storage.normal_vectors[5] = coords_set(0,-y_component,z_component);

this_box_volume.geometry.visualization_on = visualize;

this_box_volume.geometry.geometry_parameters.p_box_storage = &this_box_storage;

// Assign pointers to functions for intersection with the shape, checking if a point is inside the shape
if (this_box_storage.is_rectangle == 1) {
this_box_volume.geometry.intersect_function = &sample_box_intersect_simple;
this_box_volume.geometry.within_function = &r_within_box_simple;
}
else {
this_box_volume.geometry.intersect_function = &sample_box_intersect_advanced;
this_box_volume.geometry.within_function = &r_within_box_advanced;
}

this_box_volume.geometry.shell_points = &box_shell_points;
this_box_volume.geometry.mcdisplay_function = &mcdisplay_box_function;
this_box_volume.geometry.initialize_from_main_function = &initialize_box_geometry_from_main_component;
this_box_volume.geometry.process_rot_allocated = 0;

this_box_volume.geometry.copy_geometry_parameters = &allocate_box_storage_copy;

rot_copy(this_box_volume.geometry.rotation_matrix,ROT_A_CURRENT_COMP); //check how ROT_R_CURRENT_COMP would work
rot_transpose(ROT_A_CURRENT_COMP,this_box_volume.geometry.transpose_rotation_matrix);

// Initialize loggers
this_box_volume.loggers.num_elements = 0;

// packing the information into the global_geometry_element, which is then included in the global_geometry_list.
sprintf(global_geometry_element.name,NAME_CURRENT_COMP);
global_geometry_element.activation_counter = number_of_activations;
global_geometry_element.component_index = INDEX_CURRENT_COMP;
global_geometry_element.Volume = &this_box_volume; // Would be nicer if this m was a pointer, now we have the (small) data two places
add_element_to_geometry_list(&global_geometry_list,global_geometry_element);
}
#line 316910 "MACS_sample_kidney_box.c"
#undef number_of_activations
#undef mask_setting
#undef mask_string
#undef p_interact
#undef focus_r
#undef focus_xh
#undef focus_xw
#undef focus_ah
#undef focus_aw
#undef target_z
#undef target_y
#undef target_x
#undef target_index
#undef visualize
#undef yheight2
#undef xwidth2
#undef zdepth
#undef yheight
#undef xwidth
#undef priority
#undef material_string
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

  /* Initializations for component channel_17_analyzer_1_array_crystal_array_6. */
  SIG_MESSAGE("channel_17_analyzer_1_array_crystal_array_6 (Init)");
#define mccompcurname  channel_17_analyzer_1_array_crystal_array_6
#define mccompcurtype  Union_box
#define mccompcurindex 782
#define loop_index mccchannel_17_analyzer_1_array_crystal_array_6_loop_index
#define this_box_volume mccchannel_17_analyzer_1_array_crystal_array_6_this_box_volume
#define global_geometry_element mccchannel_17_analyzer_1_array_crystal_array_6_global_geometry_element
#define this_box_storage mccchannel_17_analyzer_1_array_crystal_array_6_this_box_storage
#define material_string mccchannel_17_analyzer_1_array_crystal_array_6_material_string
#define priority mccchannel_17_analyzer_1_array_crystal_array_6_priority
#define xwidth mccchannel_17_analyzer_1_array_crystal_array_6_xwidth
#define yheight mccchannel_17_analyzer_1_array_crystal_array_6_yheight
#define zdepth mccchannel_17_analyzer_1_array_crystal_array_6_zdepth
#define xwidth2 mccchannel_17_analyzer_1_array_crystal_array_6_xwidth2
#define yheight2 mccchannel_17_analyzer_1_array_crystal_array_6_yheight2
#define visualize mccchannel_17_analyzer_1_array_crystal_array_6_visualize
#define target_index mccchannel_17_analyzer_1_array_crystal_array_6_target_index
#define target_x mccchannel_17_analyzer_1_array_crystal_array_6_target_x
#define target_y mccchannel_17_analyzer_1_array_crystal_array_6_target_y
#define target_z mccchannel_17_analyzer_1_array_crystal_array_6_target_z
#define focus_aw mccchannel_17_analyzer_1_array_crystal_array_6_focus_aw
#define focus_ah mccchannel_17_analyzer_1_array_crystal_array_6_focus_ah
#define focus_xw mccchannel_17_analyzer_1_array_crystal_array_6_focus_xw
#define focus_xh mccchannel_17_analyzer_1_array_crystal_array_6_focus_xh
#define focus_r mccchannel_17_analyzer_1_array_crystal_array_6_focus_r
#define p_interact mccchannel_17_analyzer_1_array_crystal_array_6_p_interact
#define mask_string mccchannel_17_analyzer_1_array_crystal_array_6_mask_string
#define mask_setting mccchannel_17_analyzer_1_array_crystal_array_6_mask_setting
#define number_of_activations mccchannel_17_analyzer_1_array_crystal_array_6_number_of_activations
#line 224 "Union_box.comp"
{
// Initializes the focusing system for this volume including input sanitation.
focus_initialize(&this_box_volume.geometry, POS_A_COMP_INDEX(INDEX_CURRENT_COMP+target_index), POS_A_CURRENT_COMP, ROT_A_CURRENT_COMP, target_index, target_x, target_y, target_z, focus_aw, focus_ah, focus_xw, focus_xh, focus_r, NAME_CURRENT_COMP);

// Input sanitation for this geometry
if (xwidth <= 0) {
  printf("\nERROR in Union_box named %s, the xwidth is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (yheight <= 0) {
  printf("\nERROR in Union_box named %s, yheight is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (zdepth <= 0) {
  printf("\nERROR in Union_box named %s, zdepth is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (xwidth2 <= 0 && xwidth2 != -1) {
  printf("\nERROR in Union_box named %s, the xwidth2 is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (yheight2 <= 0 && yheight2 != -1) {
  printf("\nERROR in Union_box named %s, yheight2 is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}

// Use sanitation
if (global_material_list.num_elements == 0) {
  printf("\nERROR: Need to define a material using Union_make_material before using a Union geometry component. \n");
  printf("       %s was defined before first use of Union_make_material.\n",NAME_CURRENT_COMP);
  exit(1);
}

this_box_volume.geometry.is_masked_volume = 0;
this_box_volume.geometry.is_exit_volume = 0;
this_box_volume.geometry.is_mask_volume = 0;
// check if the volume is a mask, if it is the material string is irelevant.
if (mask_string && strlen(mask_string) && strcmp(mask_string, "NULL") && strcmp(mask_string, "0")) {
    // A mask volume is used to limit the extend of other volumes, called the masked volumes. These are specified in the mask_string.
    // In order for a ray to enter a masked volume, it needs to be both in the region covered by that volume AND the mask volume.
    // When more than
    this_box_volume.geometry.mask_mode = 1; // Default is mask mode is ALL
    if (mask_setting && strlen(mask_setting) && strcmp(mask_setting, "NULL") && strcmp(mask_setting, "0")) {
        if (strcmp(mask_setting,"ALL") == 0 || strcmp(mask_setting,"All") == 0) this_box_volume.geometry.mask_mode = 1;
        else if (strcmp(mask_setting,"ANY") == 0 || strcmp(mask_setting,"Any") == 0) this_box_volume.geometry.mask_mode = 2;
        else {
            printf("The mask_mode of component %s is set to %s, but must be either ALL or ANY.\n",NAME_CURRENT_COMP,mask_setting);
            exit(1);
        }
    }
    
    for (loop_index=0;loop_index<global_geometry_list.num_elements;loop_index++) {
        // Add mask list
        if (1 == manual_linking_function(global_geometry_list.elements[loop_index].name,mask_string)) {
            add_element_to_int_list(&this_box_volume.geometry.mask_list,global_geometry_list.elements[loop_index].component_index);
            add_element_to_int_list(&global_geometry_list.elements[loop_index].Volume->geometry.masked_by_list,INDEX_CURRENT_COMP);
            global_geometry_list.elements[loop_index].Volume->geometry.is_masked_volume = 1;
            if (this_box_volume.geometry.mask_mode == 2)
                global_geometry_list.elements[loop_index].Volume->geometry.mask_mode = 2;
            if (this_box_volume.geometry.mask_mode == 1) {
                if (global_geometry_list.elements[loop_index].Volume->geometry.is_masked_volume == 1 && global_geometry_list.elements[loop_index].Volume->geometry.mask_mode != 2)
                    // If more than one mask is added to one volume, the ANY mode overwrites the (default) ALL mode.
                    global_geometry_list.elements[loop_index].Volume->geometry.mask_mode = 1;
            }
            
            found_geometries = 1;
        }
    }
    if (found_geometries == 0) {
        printf("The mask_string in geometry: %s did not find any of the specified volumes in the mask_string %s \n",NAME_CURRENT_COMP,mask_string);
        exit(1);
    }
    this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
    this_box_volume.p_physics->is_vacuum = 0; // Makes this volume a vacuum
    this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
    this_box_volume.p_physics->my_a = 0; // Should not be used.
    sprintf(this_box_volume.p_physics->name,"Mask");
    this_box_volume.geometry.is_mask_volume = 1;
    
    
// Read the material input, or if it lacks, use automatic linking.
} else if (material_string && strlen(material_string) && strcmp(material_string, "NULL") && strcmp(material_string, "0")) {
    // A geometry string was given, use it to determine which material
    if (0 == strcmp(material_string,"vacuum") || 0 == strcmp(material_string,"Vacuum")) {
        // One could have a global physics struct for vacuum instead of creating one for each
        this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
        this_box_volume.p_physics->is_vacuum = 1; // Makes this volume a vacuum
        this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
        this_box_volume.p_physics->my_a = 0; // Should not be used.
        sprintf(this_box_volume.p_physics->name,"Vacuum");
    } else if (0 == strcmp(material_string,"exit") || 0 == strcmp(material_string,"Exit")) {
        // One could have a global physics struct for vacuum instead of creating one for each
        this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
        this_box_volume.p_physics->is_vacuum = 1; // Makes this volume a vacuum
        this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
        this_box_volume.p_physics->my_a = 0; // Should not be used.
        this_box_volume.geometry.is_exit_volume = 1;
        sprintf(this_box_volume.p_physics->name,"Exit");
    } else {
        #ifndef MATERIAL_DETECTOR
            printf("Need to define a material before refering to it in a geometry %s.\n",NAME_CURRENT_COMP);
            exit(1);
        #endif
        for (loop_index=0;loop_index<global_material_list.num_elements;loop_index++) {
            if (0 == strcmp(material_string,global_material_list.elements[loop_index].name)) {
                this_box_volume.p_physics = global_material_list.elements[loop_index].physics;
                break;
            }
            if (loop_index == global_material_list.num_elements-1) {
            printf("\n");
            printf("ERROR: The material string \"%s\" in Union geometry \"%s\" did not match a specified material. \n",material_string,NAME_CURRENT_COMP);
            printf("       The materials available at this point (need to be defined before the geometry): \n");
            for (loop_index=0;loop_index<global_material_list.num_elements;loop_index++)
              printf("         %s\n",global_material_list.elements[loop_index].name);
            printf("\n");
            printf("       It is also possible to use one of the defualt materials avaiable: \n");
            printf("           Vacuum (for a Volume without scattering or absorption)\n");
            printf("           Exit (for a Volume where the ray exits the component if it enters)\n");
            printf("           Mask (for a Volume that masks existing volumes specified in the mask_string\n");
            exit(1);
          }
        }
    }
} else {
    // Automatic linking, simply using the last defined material.
    #ifndef MATERIAL_DETECTOR
        printf("Need to define a material before the geometry to use automatic linking %s.\n",NAME_CURRENT_COMP);
        exit(1);
    #endif
    this_box_volume.p_physics = global_material_list.elements[global_material_list.num_elements-1].physics;
}

sprintf(this_box_volume.name,NAME_CURRENT_COMP);
sprintf(this_box_volume.geometry.shape,"box");
this_box_volume.geometry.priority_value = priority;
this_box_volume.geometry.geometry_p_interact = p_interact;
// Currently the coordinates will be in absolute space.
this_box_volume.geometry.center = POS_A_CURRENT_COMP;

this_box_storage.z_depth = zdepth;
this_box_storage.x_width1 = xwidth;
this_box_storage.y_height1 = yheight;

this_box_storage.is_rectangle = 0;
if (xwidth2 < 0 && yheight2 < 0) this_box_storage.is_rectangle = 1;
if (xwidth == xwidth2 && yheight == yheight2) this_box_storage.is_rectangle = 1;

if (xwidth2 < 0) {
    this_box_storage.x_width2 = xwidth;
    xwidth2 = xwidth;
} else this_box_storage.x_width2 = xwidth2;

if (yheight2 < 0) {
    this_box_storage.y_height2 = yheight;
    yheight2 = yheight;
} else this_box_storage.y_height2 = yheight2;


this_box_storage.normal_vectors[0] = coords_set(0,0,1);
this_box_storage.normal_vectors[1] = coords_set(0,0,1);

// for sides with y component = 0
x_component = 2*zdepth/sqrt((xwidth-xwidth2)*(xwidth-xwidth2)+4*zdepth*zdepth);
z_component = (xwidth-xwidth2)/sqrt(4*zdepth*zdepth+(xwidth-xwidth2)*(xwidth-xwidth2));

this_box_storage.normal_vectors[2] = coords_set(x_component,0,z_component);
this_box_storage.normal_vectors[3] = coords_set(-x_component,0,z_component);

// for sides with x component = 0
y_component = 2*zdepth/sqrt((yheight-yheight2)*(yheight-yheight2)+4*zdepth*zdepth);
z_component = (yheight-yheight2)/sqrt(4*zdepth*zdepth+(yheight-yheight2)*(yheight-yheight2));

this_box_storage.normal_vectors[4] = coords_set(0,y_component,z_component);
this_box_storage.normal_vectors[5] = coords_set(0,-y_component,z_component);

this_box_volume.geometry.visualization_on = visualize;

this_box_volume.geometry.geometry_parameters.p_box_storage = &this_box_storage;

// Assign pointers to functions for intersection with the shape, checking if a point is inside the shape
if (this_box_storage.is_rectangle == 1) {
this_box_volume.geometry.intersect_function = &sample_box_intersect_simple;
this_box_volume.geometry.within_function = &r_within_box_simple;
}
else {
this_box_volume.geometry.intersect_function = &sample_box_intersect_advanced;
this_box_volume.geometry.within_function = &r_within_box_advanced;
}

this_box_volume.geometry.shell_points = &box_shell_points;
this_box_volume.geometry.mcdisplay_function = &mcdisplay_box_function;
this_box_volume.geometry.initialize_from_main_function = &initialize_box_geometry_from_main_component;
this_box_volume.geometry.process_rot_allocated = 0;

this_box_volume.geometry.copy_geometry_parameters = &allocate_box_storage_copy;

rot_copy(this_box_volume.geometry.rotation_matrix,ROT_A_CURRENT_COMP); //check how ROT_R_CURRENT_COMP would work
rot_transpose(ROT_A_CURRENT_COMP,this_box_volume.geometry.transpose_rotation_matrix);

// Initialize loggers
this_box_volume.loggers.num_elements = 0;

// packing the information into the global_geometry_element, which is then included in the global_geometry_list.
sprintf(global_geometry_element.name,NAME_CURRENT_COMP);
global_geometry_element.activation_counter = number_of_activations;
global_geometry_element.component_index = INDEX_CURRENT_COMP;
global_geometry_element.Volume = &this_box_volume; // Would be nicer if this m was a pointer, now we have the (small) data two places
add_element_to_geometry_list(&global_geometry_list,global_geometry_element);
}
#line 317180 "MACS_sample_kidney_box.c"
#undef number_of_activations
#undef mask_setting
#undef mask_string
#undef p_interact
#undef focus_r
#undef focus_xh
#undef focus_xw
#undef focus_ah
#undef focus_aw
#undef target_z
#undef target_y
#undef target_x
#undef target_index
#undef visualize
#undef yheight2
#undef xwidth2
#undef zdepth
#undef yheight
#undef xwidth
#undef priority
#undef material_string
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

  /* Initializations for component channel_17_analyzer_1_array_crystal_array_7. */
  SIG_MESSAGE("channel_17_analyzer_1_array_crystal_array_7 (Init)");
#define mccompcurname  channel_17_analyzer_1_array_crystal_array_7
#define mccompcurtype  Union_box
#define mccompcurindex 783
#define loop_index mccchannel_17_analyzer_1_array_crystal_array_7_loop_index
#define this_box_volume mccchannel_17_analyzer_1_array_crystal_array_7_this_box_volume
#define global_geometry_element mccchannel_17_analyzer_1_array_crystal_array_7_global_geometry_element
#define this_box_storage mccchannel_17_analyzer_1_array_crystal_array_7_this_box_storage
#define material_string mccchannel_17_analyzer_1_array_crystal_array_7_material_string
#define priority mccchannel_17_analyzer_1_array_crystal_array_7_priority
#define xwidth mccchannel_17_analyzer_1_array_crystal_array_7_xwidth
#define yheight mccchannel_17_analyzer_1_array_crystal_array_7_yheight
#define zdepth mccchannel_17_analyzer_1_array_crystal_array_7_zdepth
#define xwidth2 mccchannel_17_analyzer_1_array_crystal_array_7_xwidth2
#define yheight2 mccchannel_17_analyzer_1_array_crystal_array_7_yheight2
#define visualize mccchannel_17_analyzer_1_array_crystal_array_7_visualize
#define target_index mccchannel_17_analyzer_1_array_crystal_array_7_target_index
#define target_x mccchannel_17_analyzer_1_array_crystal_array_7_target_x
#define target_y mccchannel_17_analyzer_1_array_crystal_array_7_target_y
#define target_z mccchannel_17_analyzer_1_array_crystal_array_7_target_z
#define focus_aw mccchannel_17_analyzer_1_array_crystal_array_7_focus_aw
#define focus_ah mccchannel_17_analyzer_1_array_crystal_array_7_focus_ah
#define focus_xw mccchannel_17_analyzer_1_array_crystal_array_7_focus_xw
#define focus_xh mccchannel_17_analyzer_1_array_crystal_array_7_focus_xh
#define focus_r mccchannel_17_analyzer_1_array_crystal_array_7_focus_r
#define p_interact mccchannel_17_analyzer_1_array_crystal_array_7_p_interact
#define mask_string mccchannel_17_analyzer_1_array_crystal_array_7_mask_string
#define mask_setting mccchannel_17_analyzer_1_array_crystal_array_7_mask_setting
#define number_of_activations mccchannel_17_analyzer_1_array_crystal_array_7_number_of_activations
#line 224 "Union_box.comp"
{
// Initializes the focusing system for this volume including input sanitation.
focus_initialize(&this_box_volume.geometry, POS_A_COMP_INDEX(INDEX_CURRENT_COMP+target_index), POS_A_CURRENT_COMP, ROT_A_CURRENT_COMP, target_index, target_x, target_y, target_z, focus_aw, focus_ah, focus_xw, focus_xh, focus_r, NAME_CURRENT_COMP);

// Input sanitation for this geometry
if (xwidth <= 0) {
  printf("\nERROR in Union_box named %s, the xwidth is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (yheight <= 0) {
  printf("\nERROR in Union_box named %s, yheight is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (zdepth <= 0) {
  printf("\nERROR in Union_box named %s, zdepth is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (xwidth2 <= 0 && xwidth2 != -1) {
  printf("\nERROR in Union_box named %s, the xwidth2 is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (yheight2 <= 0 && yheight2 != -1) {
  printf("\nERROR in Union_box named %s, yheight2 is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}

// Use sanitation
if (global_material_list.num_elements == 0) {
  printf("\nERROR: Need to define a material using Union_make_material before using a Union geometry component. \n");
  printf("       %s was defined before first use of Union_make_material.\n",NAME_CURRENT_COMP);
  exit(1);
}

this_box_volume.geometry.is_masked_volume = 0;
this_box_volume.geometry.is_exit_volume = 0;
this_box_volume.geometry.is_mask_volume = 0;
// check if the volume is a mask, if it is the material string is irelevant.
if (mask_string && strlen(mask_string) && strcmp(mask_string, "NULL") && strcmp(mask_string, "0")) {
    // A mask volume is used to limit the extend of other volumes, called the masked volumes. These are specified in the mask_string.
    // In order for a ray to enter a masked volume, it needs to be both in the region covered by that volume AND the mask volume.
    // When more than
    this_box_volume.geometry.mask_mode = 1; // Default is mask mode is ALL
    if (mask_setting && strlen(mask_setting) && strcmp(mask_setting, "NULL") && strcmp(mask_setting, "0")) {
        if (strcmp(mask_setting,"ALL") == 0 || strcmp(mask_setting,"All") == 0) this_box_volume.geometry.mask_mode = 1;
        else if (strcmp(mask_setting,"ANY") == 0 || strcmp(mask_setting,"Any") == 0) this_box_volume.geometry.mask_mode = 2;
        else {
            printf("The mask_mode of component %s is set to %s, but must be either ALL or ANY.\n",NAME_CURRENT_COMP,mask_setting);
            exit(1);
        }
    }
    
    for (loop_index=0;loop_index<global_geometry_list.num_elements;loop_index++) {
        // Add mask list
        if (1 == manual_linking_function(global_geometry_list.elements[loop_index].name,mask_string)) {
            add_element_to_int_list(&this_box_volume.geometry.mask_list,global_geometry_list.elements[loop_index].component_index);
            add_element_to_int_list(&global_geometry_list.elements[loop_index].Volume->geometry.masked_by_list,INDEX_CURRENT_COMP);
            global_geometry_list.elements[loop_index].Volume->geometry.is_masked_volume = 1;
            if (this_box_volume.geometry.mask_mode == 2)
                global_geometry_list.elements[loop_index].Volume->geometry.mask_mode = 2;
            if (this_box_volume.geometry.mask_mode == 1) {
                if (global_geometry_list.elements[loop_index].Volume->geometry.is_masked_volume == 1 && global_geometry_list.elements[loop_index].Volume->geometry.mask_mode != 2)
                    // If more than one mask is added to one volume, the ANY mode overwrites the (default) ALL mode.
                    global_geometry_list.elements[loop_index].Volume->geometry.mask_mode = 1;
            }
            
            found_geometries = 1;
        }
    }
    if (found_geometries == 0) {
        printf("The mask_string in geometry: %s did not find any of the specified volumes in the mask_string %s \n",NAME_CURRENT_COMP,mask_string);
        exit(1);
    }
    this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
    this_box_volume.p_physics->is_vacuum = 0; // Makes this volume a vacuum
    this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
    this_box_volume.p_physics->my_a = 0; // Should not be used.
    sprintf(this_box_volume.p_physics->name,"Mask");
    this_box_volume.geometry.is_mask_volume = 1;
    
    
// Read the material input, or if it lacks, use automatic linking.
} else if (material_string && strlen(material_string) && strcmp(material_string, "NULL") && strcmp(material_string, "0")) {
    // A geometry string was given, use it to determine which material
    if (0 == strcmp(material_string,"vacuum") || 0 == strcmp(material_string,"Vacuum")) {
        // One could have a global physics struct for vacuum instead of creating one for each
        this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
        this_box_volume.p_physics->is_vacuum = 1; // Makes this volume a vacuum
        this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
        this_box_volume.p_physics->my_a = 0; // Should not be used.
        sprintf(this_box_volume.p_physics->name,"Vacuum");
    } else if (0 == strcmp(material_string,"exit") || 0 == strcmp(material_string,"Exit")) {
        // One could have a global physics struct for vacuum instead of creating one for each
        this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
        this_box_volume.p_physics->is_vacuum = 1; // Makes this volume a vacuum
        this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
        this_box_volume.p_physics->my_a = 0; // Should not be used.
        this_box_volume.geometry.is_exit_volume = 1;
        sprintf(this_box_volume.p_physics->name,"Exit");
    } else {
        #ifndef MATERIAL_DETECTOR
            printf("Need to define a material before refering to it in a geometry %s.\n",NAME_CURRENT_COMP);
            exit(1);
        #endif
        for (loop_index=0;loop_index<global_material_list.num_elements;loop_index++) {
            if (0 == strcmp(material_string,global_material_list.elements[loop_index].name)) {
                this_box_volume.p_physics = global_material_list.elements[loop_index].physics;
                break;
            }
            if (loop_index == global_material_list.num_elements-1) {
            printf("\n");
            printf("ERROR: The material string \"%s\" in Union geometry \"%s\" did not match a specified material. \n",material_string,NAME_CURRENT_COMP);
            printf("       The materials available at this point (need to be defined before the geometry): \n");
            for (loop_index=0;loop_index<global_material_list.num_elements;loop_index++)
              printf("         %s\n",global_material_list.elements[loop_index].name);
            printf("\n");
            printf("       It is also possible to use one of the defualt materials avaiable: \n");
            printf("           Vacuum (for a Volume without scattering or absorption)\n");
            printf("           Exit (for a Volume where the ray exits the component if it enters)\n");
            printf("           Mask (for a Volume that masks existing volumes specified in the mask_string\n");
            exit(1);
          }
        }
    }
} else {
    // Automatic linking, simply using the last defined material.
    #ifndef MATERIAL_DETECTOR
        printf("Need to define a material before the geometry to use automatic linking %s.\n",NAME_CURRENT_COMP);
        exit(1);
    #endif
    this_box_volume.p_physics = global_material_list.elements[global_material_list.num_elements-1].physics;
}

sprintf(this_box_volume.name,NAME_CURRENT_COMP);
sprintf(this_box_volume.geometry.shape,"box");
this_box_volume.geometry.priority_value = priority;
this_box_volume.geometry.geometry_p_interact = p_interact;
// Currently the coordinates will be in absolute space.
this_box_volume.geometry.center = POS_A_CURRENT_COMP;

this_box_storage.z_depth = zdepth;
this_box_storage.x_width1 = xwidth;
this_box_storage.y_height1 = yheight;

this_box_storage.is_rectangle = 0;
if (xwidth2 < 0 && yheight2 < 0) this_box_storage.is_rectangle = 1;
if (xwidth == xwidth2 && yheight == yheight2) this_box_storage.is_rectangle = 1;

if (xwidth2 < 0) {
    this_box_storage.x_width2 = xwidth;
    xwidth2 = xwidth;
} else this_box_storage.x_width2 = xwidth2;

if (yheight2 < 0) {
    this_box_storage.y_height2 = yheight;
    yheight2 = yheight;
} else this_box_storage.y_height2 = yheight2;


this_box_storage.normal_vectors[0] = coords_set(0,0,1);
this_box_storage.normal_vectors[1] = coords_set(0,0,1);

// for sides with y component = 0
x_component = 2*zdepth/sqrt((xwidth-xwidth2)*(xwidth-xwidth2)+4*zdepth*zdepth);
z_component = (xwidth-xwidth2)/sqrt(4*zdepth*zdepth+(xwidth-xwidth2)*(xwidth-xwidth2));

this_box_storage.normal_vectors[2] = coords_set(x_component,0,z_component);
this_box_storage.normal_vectors[3] = coords_set(-x_component,0,z_component);

// for sides with x component = 0
y_component = 2*zdepth/sqrt((yheight-yheight2)*(yheight-yheight2)+4*zdepth*zdepth);
z_component = (yheight-yheight2)/sqrt(4*zdepth*zdepth+(yheight-yheight2)*(yheight-yheight2));

this_box_storage.normal_vectors[4] = coords_set(0,y_component,z_component);
this_box_storage.normal_vectors[5] = coords_set(0,-y_component,z_component);

this_box_volume.geometry.visualization_on = visualize;

this_box_volume.geometry.geometry_parameters.p_box_storage = &this_box_storage;

// Assign pointers to functions for intersection with the shape, checking if a point is inside the shape
if (this_box_storage.is_rectangle == 1) {
this_box_volume.geometry.intersect_function = &sample_box_intersect_simple;
this_box_volume.geometry.within_function = &r_within_box_simple;
}
else {
this_box_volume.geometry.intersect_function = &sample_box_intersect_advanced;
this_box_volume.geometry.within_function = &r_within_box_advanced;
}

this_box_volume.geometry.shell_points = &box_shell_points;
this_box_volume.geometry.mcdisplay_function = &mcdisplay_box_function;
this_box_volume.geometry.initialize_from_main_function = &initialize_box_geometry_from_main_component;
this_box_volume.geometry.process_rot_allocated = 0;

this_box_volume.geometry.copy_geometry_parameters = &allocate_box_storage_copy;

rot_copy(this_box_volume.geometry.rotation_matrix,ROT_A_CURRENT_COMP); //check how ROT_R_CURRENT_COMP would work
rot_transpose(ROT_A_CURRENT_COMP,this_box_volume.geometry.transpose_rotation_matrix);

// Initialize loggers
this_box_volume.loggers.num_elements = 0;

// packing the information into the global_geometry_element, which is then included in the global_geometry_list.
sprintf(global_geometry_element.name,NAME_CURRENT_COMP);
global_geometry_element.activation_counter = number_of_activations;
global_geometry_element.component_index = INDEX_CURRENT_COMP;
global_geometry_element.Volume = &this_box_volume; // Would be nicer if this m was a pointer, now we have the (small) data two places
add_element_to_geometry_list(&global_geometry_list,global_geometry_element);
}
#line 317450 "MACS_sample_kidney_box.c"
#undef number_of_activations
#undef mask_setting
#undef mask_string
#undef p_interact
#undef focus_r
#undef focus_xh
#undef focus_xw
#undef focus_ah
#undef focus_aw
#undef target_z
#undef target_y
#undef target_x
#undef target_index
#undef visualize
#undef yheight2
#undef xwidth2
#undef zdepth
#undef yheight
#undef xwidth
#undef priority
#undef material_string
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

  /* Initializations for component channel_17_analyzer_1_array_crystal_array_8. */
  SIG_MESSAGE("channel_17_analyzer_1_array_crystal_array_8 (Init)");
#define mccompcurname  channel_17_analyzer_1_array_crystal_array_8
#define mccompcurtype  Union_box
#define mccompcurindex 784
#define loop_index mccchannel_17_analyzer_1_array_crystal_array_8_loop_index
#define this_box_volume mccchannel_17_analyzer_1_array_crystal_array_8_this_box_volume
#define global_geometry_element mccchannel_17_analyzer_1_array_crystal_array_8_global_geometry_element
#define this_box_storage mccchannel_17_analyzer_1_array_crystal_array_8_this_box_storage
#define material_string mccchannel_17_analyzer_1_array_crystal_array_8_material_string
#define priority mccchannel_17_analyzer_1_array_crystal_array_8_priority
#define xwidth mccchannel_17_analyzer_1_array_crystal_array_8_xwidth
#define yheight mccchannel_17_analyzer_1_array_crystal_array_8_yheight
#define zdepth mccchannel_17_analyzer_1_array_crystal_array_8_zdepth
#define xwidth2 mccchannel_17_analyzer_1_array_crystal_array_8_xwidth2
#define yheight2 mccchannel_17_analyzer_1_array_crystal_array_8_yheight2
#define visualize mccchannel_17_analyzer_1_array_crystal_array_8_visualize
#define target_index mccchannel_17_analyzer_1_array_crystal_array_8_target_index
#define target_x mccchannel_17_analyzer_1_array_crystal_array_8_target_x
#define target_y mccchannel_17_analyzer_1_array_crystal_array_8_target_y
#define target_z mccchannel_17_analyzer_1_array_crystal_array_8_target_z
#define focus_aw mccchannel_17_analyzer_1_array_crystal_array_8_focus_aw
#define focus_ah mccchannel_17_analyzer_1_array_crystal_array_8_focus_ah
#define focus_xw mccchannel_17_analyzer_1_array_crystal_array_8_focus_xw
#define focus_xh mccchannel_17_analyzer_1_array_crystal_array_8_focus_xh
#define focus_r mccchannel_17_analyzer_1_array_crystal_array_8_focus_r
#define p_interact mccchannel_17_analyzer_1_array_crystal_array_8_p_interact
#define mask_string mccchannel_17_analyzer_1_array_crystal_array_8_mask_string
#define mask_setting mccchannel_17_analyzer_1_array_crystal_array_8_mask_setting
#define number_of_activations mccchannel_17_analyzer_1_array_crystal_array_8_number_of_activations
#line 224 "Union_box.comp"
{
// Initializes the focusing system for this volume including input sanitation.
focus_initialize(&this_box_volume.geometry, POS_A_COMP_INDEX(INDEX_CURRENT_COMP+target_index), POS_A_CURRENT_COMP, ROT_A_CURRENT_COMP, target_index, target_x, target_y, target_z, focus_aw, focus_ah, focus_xw, focus_xh, focus_r, NAME_CURRENT_COMP);

// Input sanitation for this geometry
if (xwidth <= 0) {
  printf("\nERROR in Union_box named %s, the xwidth is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (yheight <= 0) {
  printf("\nERROR in Union_box named %s, yheight is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (zdepth <= 0) {
  printf("\nERROR in Union_box named %s, zdepth is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (xwidth2 <= 0 && xwidth2 != -1) {
  printf("\nERROR in Union_box named %s, the xwidth2 is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (yheight2 <= 0 && yheight2 != -1) {
  printf("\nERROR in Union_box named %s, yheight2 is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}

// Use sanitation
if (global_material_list.num_elements == 0) {
  printf("\nERROR: Need to define a material using Union_make_material before using a Union geometry component. \n");
  printf("       %s was defined before first use of Union_make_material.\n",NAME_CURRENT_COMP);
  exit(1);
}

this_box_volume.geometry.is_masked_volume = 0;
this_box_volume.geometry.is_exit_volume = 0;
this_box_volume.geometry.is_mask_volume = 0;
// check if the volume is a mask, if it is the material string is irelevant.
if (mask_string && strlen(mask_string) && strcmp(mask_string, "NULL") && strcmp(mask_string, "0")) {
    // A mask volume is used to limit the extend of other volumes, called the masked volumes. These are specified in the mask_string.
    // In order for a ray to enter a masked volume, it needs to be both in the region covered by that volume AND the mask volume.
    // When more than
    this_box_volume.geometry.mask_mode = 1; // Default is mask mode is ALL
    if (mask_setting && strlen(mask_setting) && strcmp(mask_setting, "NULL") && strcmp(mask_setting, "0")) {
        if (strcmp(mask_setting,"ALL") == 0 || strcmp(mask_setting,"All") == 0) this_box_volume.geometry.mask_mode = 1;
        else if (strcmp(mask_setting,"ANY") == 0 || strcmp(mask_setting,"Any") == 0) this_box_volume.geometry.mask_mode = 2;
        else {
            printf("The mask_mode of component %s is set to %s, but must be either ALL or ANY.\n",NAME_CURRENT_COMP,mask_setting);
            exit(1);
        }
    }
    
    for (loop_index=0;loop_index<global_geometry_list.num_elements;loop_index++) {
        // Add mask list
        if (1 == manual_linking_function(global_geometry_list.elements[loop_index].name,mask_string)) {
            add_element_to_int_list(&this_box_volume.geometry.mask_list,global_geometry_list.elements[loop_index].component_index);
            add_element_to_int_list(&global_geometry_list.elements[loop_index].Volume->geometry.masked_by_list,INDEX_CURRENT_COMP);
            global_geometry_list.elements[loop_index].Volume->geometry.is_masked_volume = 1;
            if (this_box_volume.geometry.mask_mode == 2)
                global_geometry_list.elements[loop_index].Volume->geometry.mask_mode = 2;
            if (this_box_volume.geometry.mask_mode == 1) {
                if (global_geometry_list.elements[loop_index].Volume->geometry.is_masked_volume == 1 && global_geometry_list.elements[loop_index].Volume->geometry.mask_mode != 2)
                    // If more than one mask is added to one volume, the ANY mode overwrites the (default) ALL mode.
                    global_geometry_list.elements[loop_index].Volume->geometry.mask_mode = 1;
            }
            
            found_geometries = 1;
        }
    }
    if (found_geometries == 0) {
        printf("The mask_string in geometry: %s did not find any of the specified volumes in the mask_string %s \n",NAME_CURRENT_COMP,mask_string);
        exit(1);
    }
    this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
    this_box_volume.p_physics->is_vacuum = 0; // Makes this volume a vacuum
    this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
    this_box_volume.p_physics->my_a = 0; // Should not be used.
    sprintf(this_box_volume.p_physics->name,"Mask");
    this_box_volume.geometry.is_mask_volume = 1;
    
    
// Read the material input, or if it lacks, use automatic linking.
} else if (material_string && strlen(material_string) && strcmp(material_string, "NULL") && strcmp(material_string, "0")) {
    // A geometry string was given, use it to determine which material
    if (0 == strcmp(material_string,"vacuum") || 0 == strcmp(material_string,"Vacuum")) {
        // One could have a global physics struct for vacuum instead of creating one for each
        this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
        this_box_volume.p_physics->is_vacuum = 1; // Makes this volume a vacuum
        this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
        this_box_volume.p_physics->my_a = 0; // Should not be used.
        sprintf(this_box_volume.p_physics->name,"Vacuum");
    } else if (0 == strcmp(material_string,"exit") || 0 == strcmp(material_string,"Exit")) {
        // One could have a global physics struct for vacuum instead of creating one for each
        this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
        this_box_volume.p_physics->is_vacuum = 1; // Makes this volume a vacuum
        this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
        this_box_volume.p_physics->my_a = 0; // Should not be used.
        this_box_volume.geometry.is_exit_volume = 1;
        sprintf(this_box_volume.p_physics->name,"Exit");
    } else {
        #ifndef MATERIAL_DETECTOR
            printf("Need to define a material before refering to it in a geometry %s.\n",NAME_CURRENT_COMP);
            exit(1);
        #endif
        for (loop_index=0;loop_index<global_material_list.num_elements;loop_index++) {
            if (0 == strcmp(material_string,global_material_list.elements[loop_index].name)) {
                this_box_volume.p_physics = global_material_list.elements[loop_index].physics;
                break;
            }
            if (loop_index == global_material_list.num_elements-1) {
            printf("\n");
            printf("ERROR: The material string \"%s\" in Union geometry \"%s\" did not match a specified material. \n",material_string,NAME_CURRENT_COMP);
            printf("       The materials available at this point (need to be defined before the geometry): \n");
            for (loop_index=0;loop_index<global_material_list.num_elements;loop_index++)
              printf("         %s\n",global_material_list.elements[loop_index].name);
            printf("\n");
            printf("       It is also possible to use one of the defualt materials avaiable: \n");
            printf("           Vacuum (for a Volume without scattering or absorption)\n");
            printf("           Exit (for a Volume where the ray exits the component if it enters)\n");
            printf("           Mask (for a Volume that masks existing volumes specified in the mask_string\n");
            exit(1);
          }
        }
    }
} else {
    // Automatic linking, simply using the last defined material.
    #ifndef MATERIAL_DETECTOR
        printf("Need to define a material before the geometry to use automatic linking %s.\n",NAME_CURRENT_COMP);
        exit(1);
    #endif
    this_box_volume.p_physics = global_material_list.elements[global_material_list.num_elements-1].physics;
}

sprintf(this_box_volume.name,NAME_CURRENT_COMP);
sprintf(this_box_volume.geometry.shape,"box");
this_box_volume.geometry.priority_value = priority;
this_box_volume.geometry.geometry_p_interact = p_interact;
// Currently the coordinates will be in absolute space.
this_box_volume.geometry.center = POS_A_CURRENT_COMP;

this_box_storage.z_depth = zdepth;
this_box_storage.x_width1 = xwidth;
this_box_storage.y_height1 = yheight;

this_box_storage.is_rectangle = 0;
if (xwidth2 < 0 && yheight2 < 0) this_box_storage.is_rectangle = 1;
if (xwidth == xwidth2 && yheight == yheight2) this_box_storage.is_rectangle = 1;

if (xwidth2 < 0) {
    this_box_storage.x_width2 = xwidth;
    xwidth2 = xwidth;
} else this_box_storage.x_width2 = xwidth2;

if (yheight2 < 0) {
    this_box_storage.y_height2 = yheight;
    yheight2 = yheight;
} else this_box_storage.y_height2 = yheight2;


this_box_storage.normal_vectors[0] = coords_set(0,0,1);
this_box_storage.normal_vectors[1] = coords_set(0,0,1);

// for sides with y component = 0
x_component = 2*zdepth/sqrt((xwidth-xwidth2)*(xwidth-xwidth2)+4*zdepth*zdepth);
z_component = (xwidth-xwidth2)/sqrt(4*zdepth*zdepth+(xwidth-xwidth2)*(xwidth-xwidth2));

this_box_storage.normal_vectors[2] = coords_set(x_component,0,z_component);
this_box_storage.normal_vectors[3] = coords_set(-x_component,0,z_component);

// for sides with x component = 0
y_component = 2*zdepth/sqrt((yheight-yheight2)*(yheight-yheight2)+4*zdepth*zdepth);
z_component = (yheight-yheight2)/sqrt(4*zdepth*zdepth+(yheight-yheight2)*(yheight-yheight2));

this_box_storage.normal_vectors[4] = coords_set(0,y_component,z_component);
this_box_storage.normal_vectors[5] = coords_set(0,-y_component,z_component);

this_box_volume.geometry.visualization_on = visualize;

this_box_volume.geometry.geometry_parameters.p_box_storage = &this_box_storage;

// Assign pointers to functions for intersection with the shape, checking if a point is inside the shape
if (this_box_storage.is_rectangle == 1) {
this_box_volume.geometry.intersect_function = &sample_box_intersect_simple;
this_box_volume.geometry.within_function = &r_within_box_simple;
}
else {
this_box_volume.geometry.intersect_function = &sample_box_intersect_advanced;
this_box_volume.geometry.within_function = &r_within_box_advanced;
}

this_box_volume.geometry.shell_points = &box_shell_points;
this_box_volume.geometry.mcdisplay_function = &mcdisplay_box_function;
this_box_volume.geometry.initialize_from_main_function = &initialize_box_geometry_from_main_component;
this_box_volume.geometry.process_rot_allocated = 0;

this_box_volume.geometry.copy_geometry_parameters = &allocate_box_storage_copy;

rot_copy(this_box_volume.geometry.rotation_matrix,ROT_A_CURRENT_COMP); //check how ROT_R_CURRENT_COMP would work
rot_transpose(ROT_A_CURRENT_COMP,this_box_volume.geometry.transpose_rotation_matrix);

// Initialize loggers
this_box_volume.loggers.num_elements = 0;

// packing the information into the global_geometry_element, which is then included in the global_geometry_list.
sprintf(global_geometry_element.name,NAME_CURRENT_COMP);
global_geometry_element.activation_counter = number_of_activations;
global_geometry_element.component_index = INDEX_CURRENT_COMP;
global_geometry_element.Volume = &this_box_volume; // Would be nicer if this m was a pointer, now we have the (small) data two places
add_element_to_geometry_list(&global_geometry_list,global_geometry_element);
}
#line 317720 "MACS_sample_kidney_box.c"
#undef number_of_activations
#undef mask_setting
#undef mask_string
#undef p_interact
#undef focus_r
#undef focus_xh
#undef focus_xw
#undef focus_ah
#undef focus_aw
#undef target_z
#undef target_y
#undef target_x
#undef target_index
#undef visualize
#undef yheight2
#undef xwidth2
#undef zdepth
#undef yheight
#undef xwidth
#undef priority
#undef material_string
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

  /* Initializations for component channel_17_analyzer_2_center. */
  SIG_MESSAGE("channel_17_analyzer_2_center (Init)");

  /* Initializations for component channel_17_analyzer_2_rotated. */
  SIG_MESSAGE("channel_17_analyzer_2_rotated (Init)");

  /* Initializations for component channel_17_analyzer_2_array_crystal_array_0. */
  SIG_MESSAGE("channel_17_analyzer_2_array_crystal_array_0 (Init)");
#define mccompcurname  channel_17_analyzer_2_array_crystal_array_0
#define mccompcurtype  Union_box
#define mccompcurindex 787
#define loop_index mccchannel_17_analyzer_2_array_crystal_array_0_loop_index
#define this_box_volume mccchannel_17_analyzer_2_array_crystal_array_0_this_box_volume
#define global_geometry_element mccchannel_17_analyzer_2_array_crystal_array_0_global_geometry_element
#define this_box_storage mccchannel_17_analyzer_2_array_crystal_array_0_this_box_storage
#define material_string mccchannel_17_analyzer_2_array_crystal_array_0_material_string
#define priority mccchannel_17_analyzer_2_array_crystal_array_0_priority
#define xwidth mccchannel_17_analyzer_2_array_crystal_array_0_xwidth
#define yheight mccchannel_17_analyzer_2_array_crystal_array_0_yheight
#define zdepth mccchannel_17_analyzer_2_array_crystal_array_0_zdepth
#define xwidth2 mccchannel_17_analyzer_2_array_crystal_array_0_xwidth2
#define yheight2 mccchannel_17_analyzer_2_array_crystal_array_0_yheight2
#define visualize mccchannel_17_analyzer_2_array_crystal_array_0_visualize
#define target_index mccchannel_17_analyzer_2_array_crystal_array_0_target_index
#define target_x mccchannel_17_analyzer_2_array_crystal_array_0_target_x
#define target_y mccchannel_17_analyzer_2_array_crystal_array_0_target_y
#define target_z mccchannel_17_analyzer_2_array_crystal_array_0_target_z
#define focus_aw mccchannel_17_analyzer_2_array_crystal_array_0_focus_aw
#define focus_ah mccchannel_17_analyzer_2_array_crystal_array_0_focus_ah
#define focus_xw mccchannel_17_analyzer_2_array_crystal_array_0_focus_xw
#define focus_xh mccchannel_17_analyzer_2_array_crystal_array_0_focus_xh
#define focus_r mccchannel_17_analyzer_2_array_crystal_array_0_focus_r
#define p_interact mccchannel_17_analyzer_2_array_crystal_array_0_p_interact
#define mask_string mccchannel_17_analyzer_2_array_crystal_array_0_mask_string
#define mask_setting mccchannel_17_analyzer_2_array_crystal_array_0_mask_setting
#define number_of_activations mccchannel_17_analyzer_2_array_crystal_array_0_number_of_activations
#line 224 "Union_box.comp"
{
// Initializes the focusing system for this volume including input sanitation.
focus_initialize(&this_box_volume.geometry, POS_A_COMP_INDEX(INDEX_CURRENT_COMP+target_index), POS_A_CURRENT_COMP, ROT_A_CURRENT_COMP, target_index, target_x, target_y, target_z, focus_aw, focus_ah, focus_xw, focus_xh, focus_r, NAME_CURRENT_COMP);

// Input sanitation for this geometry
if (xwidth <= 0) {
  printf("\nERROR in Union_box named %s, the xwidth is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (yheight <= 0) {
  printf("\nERROR in Union_box named %s, yheight is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (zdepth <= 0) {
  printf("\nERROR in Union_box named %s, zdepth is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (xwidth2 <= 0 && xwidth2 != -1) {
  printf("\nERROR in Union_box named %s, the xwidth2 is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (yheight2 <= 0 && yheight2 != -1) {
  printf("\nERROR in Union_box named %s, yheight2 is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}

// Use sanitation
if (global_material_list.num_elements == 0) {
  printf("\nERROR: Need to define a material using Union_make_material before using a Union geometry component. \n");
  printf("       %s was defined before first use of Union_make_material.\n",NAME_CURRENT_COMP);
  exit(1);
}

this_box_volume.geometry.is_masked_volume = 0;
this_box_volume.geometry.is_exit_volume = 0;
this_box_volume.geometry.is_mask_volume = 0;
// check if the volume is a mask, if it is the material string is irelevant.
if (mask_string && strlen(mask_string) && strcmp(mask_string, "NULL") && strcmp(mask_string, "0")) {
    // A mask volume is used to limit the extend of other volumes, called the masked volumes. These are specified in the mask_string.
    // In order for a ray to enter a masked volume, it needs to be both in the region covered by that volume AND the mask volume.
    // When more than
    this_box_volume.geometry.mask_mode = 1; // Default is mask mode is ALL
    if (mask_setting && strlen(mask_setting) && strcmp(mask_setting, "NULL") && strcmp(mask_setting, "0")) {
        if (strcmp(mask_setting,"ALL") == 0 || strcmp(mask_setting,"All") == 0) this_box_volume.geometry.mask_mode = 1;
        else if (strcmp(mask_setting,"ANY") == 0 || strcmp(mask_setting,"Any") == 0) this_box_volume.geometry.mask_mode = 2;
        else {
            printf("The mask_mode of component %s is set to %s, but must be either ALL or ANY.\n",NAME_CURRENT_COMP,mask_setting);
            exit(1);
        }
    }
    
    for (loop_index=0;loop_index<global_geometry_list.num_elements;loop_index++) {
        // Add mask list
        if (1 == manual_linking_function(global_geometry_list.elements[loop_index].name,mask_string)) {
            add_element_to_int_list(&this_box_volume.geometry.mask_list,global_geometry_list.elements[loop_index].component_index);
            add_element_to_int_list(&global_geometry_list.elements[loop_index].Volume->geometry.masked_by_list,INDEX_CURRENT_COMP);
            global_geometry_list.elements[loop_index].Volume->geometry.is_masked_volume = 1;
            if (this_box_volume.geometry.mask_mode == 2)
                global_geometry_list.elements[loop_index].Volume->geometry.mask_mode = 2;
            if (this_box_volume.geometry.mask_mode == 1) {
                if (global_geometry_list.elements[loop_index].Volume->geometry.is_masked_volume == 1 && global_geometry_list.elements[loop_index].Volume->geometry.mask_mode != 2)
                    // If more than one mask is added to one volume, the ANY mode overwrites the (default) ALL mode.
                    global_geometry_list.elements[loop_index].Volume->geometry.mask_mode = 1;
            }
            
            found_geometries = 1;
        }
    }
    if (found_geometries == 0) {
        printf("The mask_string in geometry: %s did not find any of the specified volumes in the mask_string %s \n",NAME_CURRENT_COMP,mask_string);
        exit(1);
    }
    this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
    this_box_volume.p_physics->is_vacuum = 0; // Makes this volume a vacuum
    this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
    this_box_volume.p_physics->my_a = 0; // Should not be used.
    sprintf(this_box_volume.p_physics->name,"Mask");
    this_box_volume.geometry.is_mask_volume = 1;
    
    
// Read the material input, or if it lacks, use automatic linking.
} else if (material_string && strlen(material_string) && strcmp(material_string, "NULL") && strcmp(material_string, "0")) {
    // A geometry string was given, use it to determine which material
    if (0 == strcmp(material_string,"vacuum") || 0 == strcmp(material_string,"Vacuum")) {
        // One could have a global physics struct for vacuum instead of creating one for each
        this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
        this_box_volume.p_physics->is_vacuum = 1; // Makes this volume a vacuum
        this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
        this_box_volume.p_physics->my_a = 0; // Should not be used.
        sprintf(this_box_volume.p_physics->name,"Vacuum");
    } else if (0 == strcmp(material_string,"exit") || 0 == strcmp(material_string,"Exit")) {
        // One could have a global physics struct for vacuum instead of creating one for each
        this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
        this_box_volume.p_physics->is_vacuum = 1; // Makes this volume a vacuum
        this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
        this_box_volume.p_physics->my_a = 0; // Should not be used.
        this_box_volume.geometry.is_exit_volume = 1;
        sprintf(this_box_volume.p_physics->name,"Exit");
    } else {
        #ifndef MATERIAL_DETECTOR
            printf("Need to define a material before refering to it in a geometry %s.\n",NAME_CURRENT_COMP);
            exit(1);
        #endif
        for (loop_index=0;loop_index<global_material_list.num_elements;loop_index++) {
            if (0 == strcmp(material_string,global_material_list.elements[loop_index].name)) {
                this_box_volume.p_physics = global_material_list.elements[loop_index].physics;
                break;
            }
            if (loop_index == global_material_list.num_elements-1) {
            printf("\n");
            printf("ERROR: The material string \"%s\" in Union geometry \"%s\" did not match a specified material. \n",material_string,NAME_CURRENT_COMP);
            printf("       The materials available at this point (need to be defined before the geometry): \n");
            for (loop_index=0;loop_index<global_material_list.num_elements;loop_index++)
              printf("         %s\n",global_material_list.elements[loop_index].name);
            printf("\n");
            printf("       It is also possible to use one of the defualt materials avaiable: \n");
            printf("           Vacuum (for a Volume without scattering or absorption)\n");
            printf("           Exit (for a Volume where the ray exits the component if it enters)\n");
            printf("           Mask (for a Volume that masks existing volumes specified in the mask_string\n");
            exit(1);
          }
        }
    }
} else {
    // Automatic linking, simply using the last defined material.
    #ifndef MATERIAL_DETECTOR
        printf("Need to define a material before the geometry to use automatic linking %s.\n",NAME_CURRENT_COMP);
        exit(1);
    #endif
    this_box_volume.p_physics = global_material_list.elements[global_material_list.num_elements-1].physics;
}

sprintf(this_box_volume.name,NAME_CURRENT_COMP);
sprintf(this_box_volume.geometry.shape,"box");
this_box_volume.geometry.priority_value = priority;
this_box_volume.geometry.geometry_p_interact = p_interact;
// Currently the coordinates will be in absolute space.
this_box_volume.geometry.center = POS_A_CURRENT_COMP;

this_box_storage.z_depth = zdepth;
this_box_storage.x_width1 = xwidth;
this_box_storage.y_height1 = yheight;

this_box_storage.is_rectangle = 0;
if (xwidth2 < 0 && yheight2 < 0) this_box_storage.is_rectangle = 1;
if (xwidth == xwidth2 && yheight == yheight2) this_box_storage.is_rectangle = 1;

if (xwidth2 < 0) {
    this_box_storage.x_width2 = xwidth;
    xwidth2 = xwidth;
} else this_box_storage.x_width2 = xwidth2;

if (yheight2 < 0) {
    this_box_storage.y_height2 = yheight;
    yheight2 = yheight;
} else this_box_storage.y_height2 = yheight2;


this_box_storage.normal_vectors[0] = coords_set(0,0,1);
this_box_storage.normal_vectors[1] = coords_set(0,0,1);

// for sides with y component = 0
x_component = 2*zdepth/sqrt((xwidth-xwidth2)*(xwidth-xwidth2)+4*zdepth*zdepth);
z_component = (xwidth-xwidth2)/sqrt(4*zdepth*zdepth+(xwidth-xwidth2)*(xwidth-xwidth2));

this_box_storage.normal_vectors[2] = coords_set(x_component,0,z_component);
this_box_storage.normal_vectors[3] = coords_set(-x_component,0,z_component);

// for sides with x component = 0
y_component = 2*zdepth/sqrt((yheight-yheight2)*(yheight-yheight2)+4*zdepth*zdepth);
z_component = (yheight-yheight2)/sqrt(4*zdepth*zdepth+(yheight-yheight2)*(yheight-yheight2));

this_box_storage.normal_vectors[4] = coords_set(0,y_component,z_component);
this_box_storage.normal_vectors[5] = coords_set(0,-y_component,z_component);

this_box_volume.geometry.visualization_on = visualize;

this_box_volume.geometry.geometry_parameters.p_box_storage = &this_box_storage;

// Assign pointers to functions for intersection with the shape, checking if a point is inside the shape
if (this_box_storage.is_rectangle == 1) {
this_box_volume.geometry.intersect_function = &sample_box_intersect_simple;
this_box_volume.geometry.within_function = &r_within_box_simple;
}
else {
this_box_volume.geometry.intersect_function = &sample_box_intersect_advanced;
this_box_volume.geometry.within_function = &r_within_box_advanced;
}

this_box_volume.geometry.shell_points = &box_shell_points;
this_box_volume.geometry.mcdisplay_function = &mcdisplay_box_function;
this_box_volume.geometry.initialize_from_main_function = &initialize_box_geometry_from_main_component;
this_box_volume.geometry.process_rot_allocated = 0;

this_box_volume.geometry.copy_geometry_parameters = &allocate_box_storage_copy;

rot_copy(this_box_volume.geometry.rotation_matrix,ROT_A_CURRENT_COMP); //check how ROT_R_CURRENT_COMP would work
rot_transpose(ROT_A_CURRENT_COMP,this_box_volume.geometry.transpose_rotation_matrix);

// Initialize loggers
this_box_volume.loggers.num_elements = 0;

// packing the information into the global_geometry_element, which is then included in the global_geometry_list.
sprintf(global_geometry_element.name,NAME_CURRENT_COMP);
global_geometry_element.activation_counter = number_of_activations;
global_geometry_element.component_index = INDEX_CURRENT_COMP;
global_geometry_element.Volume = &this_box_volume; // Would be nicer if this m was a pointer, now we have the (small) data two places
add_element_to_geometry_list(&global_geometry_list,global_geometry_element);
}
#line 317996 "MACS_sample_kidney_box.c"
#undef number_of_activations
#undef mask_setting
#undef mask_string
#undef p_interact
#undef focus_r
#undef focus_xh
#undef focus_xw
#undef focus_ah
#undef focus_aw
#undef target_z
#undef target_y
#undef target_x
#undef target_index
#undef visualize
#undef yheight2
#undef xwidth2
#undef zdepth
#undef yheight
#undef xwidth
#undef priority
#undef material_string
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

  /* Initializations for component channel_17_analyzer_2_array_crystal_array_1. */
  SIG_MESSAGE("channel_17_analyzer_2_array_crystal_array_1 (Init)");
#define mccompcurname  channel_17_analyzer_2_array_crystal_array_1
#define mccompcurtype  Union_box
#define mccompcurindex 788
#define loop_index mccchannel_17_analyzer_2_array_crystal_array_1_loop_index
#define this_box_volume mccchannel_17_analyzer_2_array_crystal_array_1_this_box_volume
#define global_geometry_element mccchannel_17_analyzer_2_array_crystal_array_1_global_geometry_element
#define this_box_storage mccchannel_17_analyzer_2_array_crystal_array_1_this_box_storage
#define material_string mccchannel_17_analyzer_2_array_crystal_array_1_material_string
#define priority mccchannel_17_analyzer_2_array_crystal_array_1_priority
#define xwidth mccchannel_17_analyzer_2_array_crystal_array_1_xwidth
#define yheight mccchannel_17_analyzer_2_array_crystal_array_1_yheight
#define zdepth mccchannel_17_analyzer_2_array_crystal_array_1_zdepth
#define xwidth2 mccchannel_17_analyzer_2_array_crystal_array_1_xwidth2
#define yheight2 mccchannel_17_analyzer_2_array_crystal_array_1_yheight2
#define visualize mccchannel_17_analyzer_2_array_crystal_array_1_visualize
#define target_index mccchannel_17_analyzer_2_array_crystal_array_1_target_index
#define target_x mccchannel_17_analyzer_2_array_crystal_array_1_target_x
#define target_y mccchannel_17_analyzer_2_array_crystal_array_1_target_y
#define target_z mccchannel_17_analyzer_2_array_crystal_array_1_target_z
#define focus_aw mccchannel_17_analyzer_2_array_crystal_array_1_focus_aw
#define focus_ah mccchannel_17_analyzer_2_array_crystal_array_1_focus_ah
#define focus_xw mccchannel_17_analyzer_2_array_crystal_array_1_focus_xw
#define focus_xh mccchannel_17_analyzer_2_array_crystal_array_1_focus_xh
#define focus_r mccchannel_17_analyzer_2_array_crystal_array_1_focus_r
#define p_interact mccchannel_17_analyzer_2_array_crystal_array_1_p_interact
#define mask_string mccchannel_17_analyzer_2_array_crystal_array_1_mask_string
#define mask_setting mccchannel_17_analyzer_2_array_crystal_array_1_mask_setting
#define number_of_activations mccchannel_17_analyzer_2_array_crystal_array_1_number_of_activations
#line 224 "Union_box.comp"
{
// Initializes the focusing system for this volume including input sanitation.
focus_initialize(&this_box_volume.geometry, POS_A_COMP_INDEX(INDEX_CURRENT_COMP+target_index), POS_A_CURRENT_COMP, ROT_A_CURRENT_COMP, target_index, target_x, target_y, target_z, focus_aw, focus_ah, focus_xw, focus_xh, focus_r, NAME_CURRENT_COMP);

// Input sanitation for this geometry
if (xwidth <= 0) {
  printf("\nERROR in Union_box named %s, the xwidth is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (yheight <= 0) {
  printf("\nERROR in Union_box named %s, yheight is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (zdepth <= 0) {
  printf("\nERROR in Union_box named %s, zdepth is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (xwidth2 <= 0 && xwidth2 != -1) {
  printf("\nERROR in Union_box named %s, the xwidth2 is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (yheight2 <= 0 && yheight2 != -1) {
  printf("\nERROR in Union_box named %s, yheight2 is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}

// Use sanitation
if (global_material_list.num_elements == 0) {
  printf("\nERROR: Need to define a material using Union_make_material before using a Union geometry component. \n");
  printf("       %s was defined before first use of Union_make_material.\n",NAME_CURRENT_COMP);
  exit(1);
}

this_box_volume.geometry.is_masked_volume = 0;
this_box_volume.geometry.is_exit_volume = 0;
this_box_volume.geometry.is_mask_volume = 0;
// check if the volume is a mask, if it is the material string is irelevant.
if (mask_string && strlen(mask_string) && strcmp(mask_string, "NULL") && strcmp(mask_string, "0")) {
    // A mask volume is used to limit the extend of other volumes, called the masked volumes. These are specified in the mask_string.
    // In order for a ray to enter a masked volume, it needs to be both in the region covered by that volume AND the mask volume.
    // When more than
    this_box_volume.geometry.mask_mode = 1; // Default is mask mode is ALL
    if (mask_setting && strlen(mask_setting) && strcmp(mask_setting, "NULL") && strcmp(mask_setting, "0")) {
        if (strcmp(mask_setting,"ALL") == 0 || strcmp(mask_setting,"All") == 0) this_box_volume.geometry.mask_mode = 1;
        else if (strcmp(mask_setting,"ANY") == 0 || strcmp(mask_setting,"Any") == 0) this_box_volume.geometry.mask_mode = 2;
        else {
            printf("The mask_mode of component %s is set to %s, but must be either ALL or ANY.\n",NAME_CURRENT_COMP,mask_setting);
            exit(1);
        }
    }
    
    for (loop_index=0;loop_index<global_geometry_list.num_elements;loop_index++) {
        // Add mask list
        if (1 == manual_linking_function(global_geometry_list.elements[loop_index].name,mask_string)) {
            add_element_to_int_list(&this_box_volume.geometry.mask_list,global_geometry_list.elements[loop_index].component_index);
            add_element_to_int_list(&global_geometry_list.elements[loop_index].Volume->geometry.masked_by_list,INDEX_CURRENT_COMP);
            global_geometry_list.elements[loop_index].Volume->geometry.is_masked_volume = 1;
            if (this_box_volume.geometry.mask_mode == 2)
                global_geometry_list.elements[loop_index].Volume->geometry.mask_mode = 2;
            if (this_box_volume.geometry.mask_mode == 1) {
                if (global_geometry_list.elements[loop_index].Volume->geometry.is_masked_volume == 1 && global_geometry_list.elements[loop_index].Volume->geometry.mask_mode != 2)
                    // If more than one mask is added to one volume, the ANY mode overwrites the (default) ALL mode.
                    global_geometry_list.elements[loop_index].Volume->geometry.mask_mode = 1;
            }
            
            found_geometries = 1;
        }
    }
    if (found_geometries == 0) {
        printf("The mask_string in geometry: %s did not find any of the specified volumes in the mask_string %s \n",NAME_CURRENT_COMP,mask_string);
        exit(1);
    }
    this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
    this_box_volume.p_physics->is_vacuum = 0; // Makes this volume a vacuum
    this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
    this_box_volume.p_physics->my_a = 0; // Should not be used.
    sprintf(this_box_volume.p_physics->name,"Mask");
    this_box_volume.geometry.is_mask_volume = 1;
    
    
// Read the material input, or if it lacks, use automatic linking.
} else if (material_string && strlen(material_string) && strcmp(material_string, "NULL") && strcmp(material_string, "0")) {
    // A geometry string was given, use it to determine which material
    if (0 == strcmp(material_string,"vacuum") || 0 == strcmp(material_string,"Vacuum")) {
        // One could have a global physics struct for vacuum instead of creating one for each
        this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
        this_box_volume.p_physics->is_vacuum = 1; // Makes this volume a vacuum
        this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
        this_box_volume.p_physics->my_a = 0; // Should not be used.
        sprintf(this_box_volume.p_physics->name,"Vacuum");
    } else if (0 == strcmp(material_string,"exit") || 0 == strcmp(material_string,"Exit")) {
        // One could have a global physics struct for vacuum instead of creating one for each
        this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
        this_box_volume.p_physics->is_vacuum = 1; // Makes this volume a vacuum
        this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
        this_box_volume.p_physics->my_a = 0; // Should not be used.
        this_box_volume.geometry.is_exit_volume = 1;
        sprintf(this_box_volume.p_physics->name,"Exit");
    } else {
        #ifndef MATERIAL_DETECTOR
            printf("Need to define a material before refering to it in a geometry %s.\n",NAME_CURRENT_COMP);
            exit(1);
        #endif
        for (loop_index=0;loop_index<global_material_list.num_elements;loop_index++) {
            if (0 == strcmp(material_string,global_material_list.elements[loop_index].name)) {
                this_box_volume.p_physics = global_material_list.elements[loop_index].physics;
                break;
            }
            if (loop_index == global_material_list.num_elements-1) {
            printf("\n");
            printf("ERROR: The material string \"%s\" in Union geometry \"%s\" did not match a specified material. \n",material_string,NAME_CURRENT_COMP);
            printf("       The materials available at this point (need to be defined before the geometry): \n");
            for (loop_index=0;loop_index<global_material_list.num_elements;loop_index++)
              printf("         %s\n",global_material_list.elements[loop_index].name);
            printf("\n");
            printf("       It is also possible to use one of the defualt materials avaiable: \n");
            printf("           Vacuum (for a Volume without scattering or absorption)\n");
            printf("           Exit (for a Volume where the ray exits the component if it enters)\n");
            printf("           Mask (for a Volume that masks existing volumes specified in the mask_string\n");
            exit(1);
          }
        }
    }
} else {
    // Automatic linking, simply using the last defined material.
    #ifndef MATERIAL_DETECTOR
        printf("Need to define a material before the geometry to use automatic linking %s.\n",NAME_CURRENT_COMP);
        exit(1);
    #endif
    this_box_volume.p_physics = global_material_list.elements[global_material_list.num_elements-1].physics;
}

sprintf(this_box_volume.name,NAME_CURRENT_COMP);
sprintf(this_box_volume.geometry.shape,"box");
this_box_volume.geometry.priority_value = priority;
this_box_volume.geometry.geometry_p_interact = p_interact;
// Currently the coordinates will be in absolute space.
this_box_volume.geometry.center = POS_A_CURRENT_COMP;

this_box_storage.z_depth = zdepth;
this_box_storage.x_width1 = xwidth;
this_box_storage.y_height1 = yheight;

this_box_storage.is_rectangle = 0;
if (xwidth2 < 0 && yheight2 < 0) this_box_storage.is_rectangle = 1;
if (xwidth == xwidth2 && yheight == yheight2) this_box_storage.is_rectangle = 1;

if (xwidth2 < 0) {
    this_box_storage.x_width2 = xwidth;
    xwidth2 = xwidth;
} else this_box_storage.x_width2 = xwidth2;

if (yheight2 < 0) {
    this_box_storage.y_height2 = yheight;
    yheight2 = yheight;
} else this_box_storage.y_height2 = yheight2;


this_box_storage.normal_vectors[0] = coords_set(0,0,1);
this_box_storage.normal_vectors[1] = coords_set(0,0,1);

// for sides with y component = 0
x_component = 2*zdepth/sqrt((xwidth-xwidth2)*(xwidth-xwidth2)+4*zdepth*zdepth);
z_component = (xwidth-xwidth2)/sqrt(4*zdepth*zdepth+(xwidth-xwidth2)*(xwidth-xwidth2));

this_box_storage.normal_vectors[2] = coords_set(x_component,0,z_component);
this_box_storage.normal_vectors[3] = coords_set(-x_component,0,z_component);

// for sides with x component = 0
y_component = 2*zdepth/sqrt((yheight-yheight2)*(yheight-yheight2)+4*zdepth*zdepth);
z_component = (yheight-yheight2)/sqrt(4*zdepth*zdepth+(yheight-yheight2)*(yheight-yheight2));

this_box_storage.normal_vectors[4] = coords_set(0,y_component,z_component);
this_box_storage.normal_vectors[5] = coords_set(0,-y_component,z_component);

this_box_volume.geometry.visualization_on = visualize;

this_box_volume.geometry.geometry_parameters.p_box_storage = &this_box_storage;

// Assign pointers to functions for intersection with the shape, checking if a point is inside the shape
if (this_box_storage.is_rectangle == 1) {
this_box_volume.geometry.intersect_function = &sample_box_intersect_simple;
this_box_volume.geometry.within_function = &r_within_box_simple;
}
else {
this_box_volume.geometry.intersect_function = &sample_box_intersect_advanced;
this_box_volume.geometry.within_function = &r_within_box_advanced;
}

this_box_volume.geometry.shell_points = &box_shell_points;
this_box_volume.geometry.mcdisplay_function = &mcdisplay_box_function;
this_box_volume.geometry.initialize_from_main_function = &initialize_box_geometry_from_main_component;
this_box_volume.geometry.process_rot_allocated = 0;

this_box_volume.geometry.copy_geometry_parameters = &allocate_box_storage_copy;

rot_copy(this_box_volume.geometry.rotation_matrix,ROT_A_CURRENT_COMP); //check how ROT_R_CURRENT_COMP would work
rot_transpose(ROT_A_CURRENT_COMP,this_box_volume.geometry.transpose_rotation_matrix);

// Initialize loggers
this_box_volume.loggers.num_elements = 0;

// packing the information into the global_geometry_element, which is then included in the global_geometry_list.
sprintf(global_geometry_element.name,NAME_CURRENT_COMP);
global_geometry_element.activation_counter = number_of_activations;
global_geometry_element.component_index = INDEX_CURRENT_COMP;
global_geometry_element.Volume = &this_box_volume; // Would be nicer if this m was a pointer, now we have the (small) data two places
add_element_to_geometry_list(&global_geometry_list,global_geometry_element);
}
#line 318266 "MACS_sample_kidney_box.c"
#undef number_of_activations
#undef mask_setting
#undef mask_string
#undef p_interact
#undef focus_r
#undef focus_xh
#undef focus_xw
#undef focus_ah
#undef focus_aw
#undef target_z
#undef target_y
#undef target_x
#undef target_index
#undef visualize
#undef yheight2
#undef xwidth2
#undef zdepth
#undef yheight
#undef xwidth
#undef priority
#undef material_string
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

  /* Initializations for component channel_17_analyzer_2_array_crystal_array_2. */
  SIG_MESSAGE("channel_17_analyzer_2_array_crystal_array_2 (Init)");
#define mccompcurname  channel_17_analyzer_2_array_crystal_array_2
#define mccompcurtype  Union_box
#define mccompcurindex 789
#define loop_index mccchannel_17_analyzer_2_array_crystal_array_2_loop_index
#define this_box_volume mccchannel_17_analyzer_2_array_crystal_array_2_this_box_volume
#define global_geometry_element mccchannel_17_analyzer_2_array_crystal_array_2_global_geometry_element
#define this_box_storage mccchannel_17_analyzer_2_array_crystal_array_2_this_box_storage
#define material_string mccchannel_17_analyzer_2_array_crystal_array_2_material_string
#define priority mccchannel_17_analyzer_2_array_crystal_array_2_priority
#define xwidth mccchannel_17_analyzer_2_array_crystal_array_2_xwidth
#define yheight mccchannel_17_analyzer_2_array_crystal_array_2_yheight
#define zdepth mccchannel_17_analyzer_2_array_crystal_array_2_zdepth
#define xwidth2 mccchannel_17_analyzer_2_array_crystal_array_2_xwidth2
#define yheight2 mccchannel_17_analyzer_2_array_crystal_array_2_yheight2
#define visualize mccchannel_17_analyzer_2_array_crystal_array_2_visualize
#define target_index mccchannel_17_analyzer_2_array_crystal_array_2_target_index
#define target_x mccchannel_17_analyzer_2_array_crystal_array_2_target_x
#define target_y mccchannel_17_analyzer_2_array_crystal_array_2_target_y
#define target_z mccchannel_17_analyzer_2_array_crystal_array_2_target_z
#define focus_aw mccchannel_17_analyzer_2_array_crystal_array_2_focus_aw
#define focus_ah mccchannel_17_analyzer_2_array_crystal_array_2_focus_ah
#define focus_xw mccchannel_17_analyzer_2_array_crystal_array_2_focus_xw
#define focus_xh mccchannel_17_analyzer_2_array_crystal_array_2_focus_xh
#define focus_r mccchannel_17_analyzer_2_array_crystal_array_2_focus_r
#define p_interact mccchannel_17_analyzer_2_array_crystal_array_2_p_interact
#define mask_string mccchannel_17_analyzer_2_array_crystal_array_2_mask_string
#define mask_setting mccchannel_17_analyzer_2_array_crystal_array_2_mask_setting
#define number_of_activations mccchannel_17_analyzer_2_array_crystal_array_2_number_of_activations
#line 224 "Union_box.comp"
{
// Initializes the focusing system for this volume including input sanitation.
focus_initialize(&this_box_volume.geometry, POS_A_COMP_INDEX(INDEX_CURRENT_COMP+target_index), POS_A_CURRENT_COMP, ROT_A_CURRENT_COMP, target_index, target_x, target_y, target_z, focus_aw, focus_ah, focus_xw, focus_xh, focus_r, NAME_CURRENT_COMP);

// Input sanitation for this geometry
if (xwidth <= 0) {
  printf("\nERROR in Union_box named %s, the xwidth is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (yheight <= 0) {
  printf("\nERROR in Union_box named %s, yheight is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (zdepth <= 0) {
  printf("\nERROR in Union_box named %s, zdepth is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (xwidth2 <= 0 && xwidth2 != -1) {
  printf("\nERROR in Union_box named %s, the xwidth2 is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (yheight2 <= 0 && yheight2 != -1) {
  printf("\nERROR in Union_box named %s, yheight2 is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}

// Use sanitation
if (global_material_list.num_elements == 0) {
  printf("\nERROR: Need to define a material using Union_make_material before using a Union geometry component. \n");
  printf("       %s was defined before first use of Union_make_material.\n",NAME_CURRENT_COMP);
  exit(1);
}

this_box_volume.geometry.is_masked_volume = 0;
this_box_volume.geometry.is_exit_volume = 0;
this_box_volume.geometry.is_mask_volume = 0;
// check if the volume is a mask, if it is the material string is irelevant.
if (mask_string && strlen(mask_string) && strcmp(mask_string, "NULL") && strcmp(mask_string, "0")) {
    // A mask volume is used to limit the extend of other volumes, called the masked volumes. These are specified in the mask_string.
    // In order for a ray to enter a masked volume, it needs to be both in the region covered by that volume AND the mask volume.
    // When more than
    this_box_volume.geometry.mask_mode = 1; // Default is mask mode is ALL
    if (mask_setting && strlen(mask_setting) && strcmp(mask_setting, "NULL") && strcmp(mask_setting, "0")) {
        if (strcmp(mask_setting,"ALL") == 0 || strcmp(mask_setting,"All") == 0) this_box_volume.geometry.mask_mode = 1;
        else if (strcmp(mask_setting,"ANY") == 0 || strcmp(mask_setting,"Any") == 0) this_box_volume.geometry.mask_mode = 2;
        else {
            printf("The mask_mode of component %s is set to %s, but must be either ALL or ANY.\n",NAME_CURRENT_COMP,mask_setting);
            exit(1);
        }
    }
    
    for (loop_index=0;loop_index<global_geometry_list.num_elements;loop_index++) {
        // Add mask list
        if (1 == manual_linking_function(global_geometry_list.elements[loop_index].name,mask_string)) {
            add_element_to_int_list(&this_box_volume.geometry.mask_list,global_geometry_list.elements[loop_index].component_index);
            add_element_to_int_list(&global_geometry_list.elements[loop_index].Volume->geometry.masked_by_list,INDEX_CURRENT_COMP);
            global_geometry_list.elements[loop_index].Volume->geometry.is_masked_volume = 1;
            if (this_box_volume.geometry.mask_mode == 2)
                global_geometry_list.elements[loop_index].Volume->geometry.mask_mode = 2;
            if (this_box_volume.geometry.mask_mode == 1) {
                if (global_geometry_list.elements[loop_index].Volume->geometry.is_masked_volume == 1 && global_geometry_list.elements[loop_index].Volume->geometry.mask_mode != 2)
                    // If more than one mask is added to one volume, the ANY mode overwrites the (default) ALL mode.
                    global_geometry_list.elements[loop_index].Volume->geometry.mask_mode = 1;
            }
            
            found_geometries = 1;
        }
    }
    if (found_geometries == 0) {
        printf("The mask_string in geometry: %s did not find any of the specified volumes in the mask_string %s \n",NAME_CURRENT_COMP,mask_string);
        exit(1);
    }
    this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
    this_box_volume.p_physics->is_vacuum = 0; // Makes this volume a vacuum
    this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
    this_box_volume.p_physics->my_a = 0; // Should not be used.
    sprintf(this_box_volume.p_physics->name,"Mask");
    this_box_volume.geometry.is_mask_volume = 1;
    
    
// Read the material input, or if it lacks, use automatic linking.
} else if (material_string && strlen(material_string) && strcmp(material_string, "NULL") && strcmp(material_string, "0")) {
    // A geometry string was given, use it to determine which material
    if (0 == strcmp(material_string,"vacuum") || 0 == strcmp(material_string,"Vacuum")) {
        // One could have a global physics struct for vacuum instead of creating one for each
        this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
        this_box_volume.p_physics->is_vacuum = 1; // Makes this volume a vacuum
        this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
        this_box_volume.p_physics->my_a = 0; // Should not be used.
        sprintf(this_box_volume.p_physics->name,"Vacuum");
    } else if (0 == strcmp(material_string,"exit") || 0 == strcmp(material_string,"Exit")) {
        // One could have a global physics struct for vacuum instead of creating one for each
        this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
        this_box_volume.p_physics->is_vacuum = 1; // Makes this volume a vacuum
        this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
        this_box_volume.p_physics->my_a = 0; // Should not be used.
        this_box_volume.geometry.is_exit_volume = 1;
        sprintf(this_box_volume.p_physics->name,"Exit");
    } else {
        #ifndef MATERIAL_DETECTOR
            printf("Need to define a material before refering to it in a geometry %s.\n",NAME_CURRENT_COMP);
            exit(1);
        #endif
        for (loop_index=0;loop_index<global_material_list.num_elements;loop_index++) {
            if (0 == strcmp(material_string,global_material_list.elements[loop_index].name)) {
                this_box_volume.p_physics = global_material_list.elements[loop_index].physics;
                break;
            }
            if (loop_index == global_material_list.num_elements-1) {
            printf("\n");
            printf("ERROR: The material string \"%s\" in Union geometry \"%s\" did not match a specified material. \n",material_string,NAME_CURRENT_COMP);
            printf("       The materials available at this point (need to be defined before the geometry): \n");
            for (loop_index=0;loop_index<global_material_list.num_elements;loop_index++)
              printf("         %s\n",global_material_list.elements[loop_index].name);
            printf("\n");
            printf("       It is also possible to use one of the defualt materials avaiable: \n");
            printf("           Vacuum (for a Volume without scattering or absorption)\n");
            printf("           Exit (for a Volume where the ray exits the component if it enters)\n");
            printf("           Mask (for a Volume that masks existing volumes specified in the mask_string\n");
            exit(1);
          }
        }
    }
} else {
    // Automatic linking, simply using the last defined material.
    #ifndef MATERIAL_DETECTOR
        printf("Need to define a material before the geometry to use automatic linking %s.\n",NAME_CURRENT_COMP);
        exit(1);
    #endif
    this_box_volume.p_physics = global_material_list.elements[global_material_list.num_elements-1].physics;
}

sprintf(this_box_volume.name,NAME_CURRENT_COMP);
sprintf(this_box_volume.geometry.shape,"box");
this_box_volume.geometry.priority_value = priority;
this_box_volume.geometry.geometry_p_interact = p_interact;
// Currently the coordinates will be in absolute space.
this_box_volume.geometry.center = POS_A_CURRENT_COMP;

this_box_storage.z_depth = zdepth;
this_box_storage.x_width1 = xwidth;
this_box_storage.y_height1 = yheight;

this_box_storage.is_rectangle = 0;
if (xwidth2 < 0 && yheight2 < 0) this_box_storage.is_rectangle = 1;
if (xwidth == xwidth2 && yheight == yheight2) this_box_storage.is_rectangle = 1;

if (xwidth2 < 0) {
    this_box_storage.x_width2 = xwidth;
    xwidth2 = xwidth;
} else this_box_storage.x_width2 = xwidth2;

if (yheight2 < 0) {
    this_box_storage.y_height2 = yheight;
    yheight2 = yheight;
} else this_box_storage.y_height2 = yheight2;


this_box_storage.normal_vectors[0] = coords_set(0,0,1);
this_box_storage.normal_vectors[1] = coords_set(0,0,1);

// for sides with y component = 0
x_component = 2*zdepth/sqrt((xwidth-xwidth2)*(xwidth-xwidth2)+4*zdepth*zdepth);
z_component = (xwidth-xwidth2)/sqrt(4*zdepth*zdepth+(xwidth-xwidth2)*(xwidth-xwidth2));

this_box_storage.normal_vectors[2] = coords_set(x_component,0,z_component);
this_box_storage.normal_vectors[3] = coords_set(-x_component,0,z_component);

// for sides with x component = 0
y_component = 2*zdepth/sqrt((yheight-yheight2)*(yheight-yheight2)+4*zdepth*zdepth);
z_component = (yheight-yheight2)/sqrt(4*zdepth*zdepth+(yheight-yheight2)*(yheight-yheight2));

this_box_storage.normal_vectors[4] = coords_set(0,y_component,z_component);
this_box_storage.normal_vectors[5] = coords_set(0,-y_component,z_component);

this_box_volume.geometry.visualization_on = visualize;

this_box_volume.geometry.geometry_parameters.p_box_storage = &this_box_storage;

// Assign pointers to functions for intersection with the shape, checking if a point is inside the shape
if (this_box_storage.is_rectangle == 1) {
this_box_volume.geometry.intersect_function = &sample_box_intersect_simple;
this_box_volume.geometry.within_function = &r_within_box_simple;
}
else {
this_box_volume.geometry.intersect_function = &sample_box_intersect_advanced;
this_box_volume.geometry.within_function = &r_within_box_advanced;
}

this_box_volume.geometry.shell_points = &box_shell_points;
this_box_volume.geometry.mcdisplay_function = &mcdisplay_box_function;
this_box_volume.geometry.initialize_from_main_function = &initialize_box_geometry_from_main_component;
this_box_volume.geometry.process_rot_allocated = 0;

this_box_volume.geometry.copy_geometry_parameters = &allocate_box_storage_copy;

rot_copy(this_box_volume.geometry.rotation_matrix,ROT_A_CURRENT_COMP); //check how ROT_R_CURRENT_COMP would work
rot_transpose(ROT_A_CURRENT_COMP,this_box_volume.geometry.transpose_rotation_matrix);

// Initialize loggers
this_box_volume.loggers.num_elements = 0;

// packing the information into the global_geometry_element, which is then included in the global_geometry_list.
sprintf(global_geometry_element.name,NAME_CURRENT_COMP);
global_geometry_element.activation_counter = number_of_activations;
global_geometry_element.component_index = INDEX_CURRENT_COMP;
global_geometry_element.Volume = &this_box_volume; // Would be nicer if this m was a pointer, now we have the (small) data two places
add_element_to_geometry_list(&global_geometry_list,global_geometry_element);
}
#line 318536 "MACS_sample_kidney_box.c"
#undef number_of_activations
#undef mask_setting
#undef mask_string
#undef p_interact
#undef focus_r
#undef focus_xh
#undef focus_xw
#undef focus_ah
#undef focus_aw
#undef target_z
#undef target_y
#undef target_x
#undef target_index
#undef visualize
#undef yheight2
#undef xwidth2
#undef zdepth
#undef yheight
#undef xwidth
#undef priority
#undef material_string
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

  /* Initializations for component channel_17_analyzer_2_array_crystal_array_3. */
  SIG_MESSAGE("channel_17_analyzer_2_array_crystal_array_3 (Init)");
#define mccompcurname  channel_17_analyzer_2_array_crystal_array_3
#define mccompcurtype  Union_box
#define mccompcurindex 790
#define loop_index mccchannel_17_analyzer_2_array_crystal_array_3_loop_index
#define this_box_volume mccchannel_17_analyzer_2_array_crystal_array_3_this_box_volume
#define global_geometry_element mccchannel_17_analyzer_2_array_crystal_array_3_global_geometry_element
#define this_box_storage mccchannel_17_analyzer_2_array_crystal_array_3_this_box_storage
#define material_string mccchannel_17_analyzer_2_array_crystal_array_3_material_string
#define priority mccchannel_17_analyzer_2_array_crystal_array_3_priority
#define xwidth mccchannel_17_analyzer_2_array_crystal_array_3_xwidth
#define yheight mccchannel_17_analyzer_2_array_crystal_array_3_yheight
#define zdepth mccchannel_17_analyzer_2_array_crystal_array_3_zdepth
#define xwidth2 mccchannel_17_analyzer_2_array_crystal_array_3_xwidth2
#define yheight2 mccchannel_17_analyzer_2_array_crystal_array_3_yheight2
#define visualize mccchannel_17_analyzer_2_array_crystal_array_3_visualize
#define target_index mccchannel_17_analyzer_2_array_crystal_array_3_target_index
#define target_x mccchannel_17_analyzer_2_array_crystal_array_3_target_x
#define target_y mccchannel_17_analyzer_2_array_crystal_array_3_target_y
#define target_z mccchannel_17_analyzer_2_array_crystal_array_3_target_z
#define focus_aw mccchannel_17_analyzer_2_array_crystal_array_3_focus_aw
#define focus_ah mccchannel_17_analyzer_2_array_crystal_array_3_focus_ah
#define focus_xw mccchannel_17_analyzer_2_array_crystal_array_3_focus_xw
#define focus_xh mccchannel_17_analyzer_2_array_crystal_array_3_focus_xh
#define focus_r mccchannel_17_analyzer_2_array_crystal_array_3_focus_r
#define p_interact mccchannel_17_analyzer_2_array_crystal_array_3_p_interact
#define mask_string mccchannel_17_analyzer_2_array_crystal_array_3_mask_string
#define mask_setting mccchannel_17_analyzer_2_array_crystal_array_3_mask_setting
#define number_of_activations mccchannel_17_analyzer_2_array_crystal_array_3_number_of_activations
#line 224 "Union_box.comp"
{
// Initializes the focusing system for this volume including input sanitation.
focus_initialize(&this_box_volume.geometry, POS_A_COMP_INDEX(INDEX_CURRENT_COMP+target_index), POS_A_CURRENT_COMP, ROT_A_CURRENT_COMP, target_index, target_x, target_y, target_z, focus_aw, focus_ah, focus_xw, focus_xh, focus_r, NAME_CURRENT_COMP);

// Input sanitation for this geometry
if (xwidth <= 0) {
  printf("\nERROR in Union_box named %s, the xwidth is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (yheight <= 0) {
  printf("\nERROR in Union_box named %s, yheight is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (zdepth <= 0) {
  printf("\nERROR in Union_box named %s, zdepth is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (xwidth2 <= 0 && xwidth2 != -1) {
  printf("\nERROR in Union_box named %s, the xwidth2 is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (yheight2 <= 0 && yheight2 != -1) {
  printf("\nERROR in Union_box named %s, yheight2 is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}

// Use sanitation
if (global_material_list.num_elements == 0) {
  printf("\nERROR: Need to define a material using Union_make_material before using a Union geometry component. \n");
  printf("       %s was defined before first use of Union_make_material.\n",NAME_CURRENT_COMP);
  exit(1);
}

this_box_volume.geometry.is_masked_volume = 0;
this_box_volume.geometry.is_exit_volume = 0;
this_box_volume.geometry.is_mask_volume = 0;
// check if the volume is a mask, if it is the material string is irelevant.
if (mask_string && strlen(mask_string) && strcmp(mask_string, "NULL") && strcmp(mask_string, "0")) {
    // A mask volume is used to limit the extend of other volumes, called the masked volumes. These are specified in the mask_string.
    // In order for a ray to enter a masked volume, it needs to be both in the region covered by that volume AND the mask volume.
    // When more than
    this_box_volume.geometry.mask_mode = 1; // Default is mask mode is ALL
    if (mask_setting && strlen(mask_setting) && strcmp(mask_setting, "NULL") && strcmp(mask_setting, "0")) {
        if (strcmp(mask_setting,"ALL") == 0 || strcmp(mask_setting,"All") == 0) this_box_volume.geometry.mask_mode = 1;
        else if (strcmp(mask_setting,"ANY") == 0 || strcmp(mask_setting,"Any") == 0) this_box_volume.geometry.mask_mode = 2;
        else {
            printf("The mask_mode of component %s is set to %s, but must be either ALL or ANY.\n",NAME_CURRENT_COMP,mask_setting);
            exit(1);
        }
    }
    
    for (loop_index=0;loop_index<global_geometry_list.num_elements;loop_index++) {
        // Add mask list
        if (1 == manual_linking_function(global_geometry_list.elements[loop_index].name,mask_string)) {
            add_element_to_int_list(&this_box_volume.geometry.mask_list,global_geometry_list.elements[loop_index].component_index);
            add_element_to_int_list(&global_geometry_list.elements[loop_index].Volume->geometry.masked_by_list,INDEX_CURRENT_COMP);
            global_geometry_list.elements[loop_index].Volume->geometry.is_masked_volume = 1;
            if (this_box_volume.geometry.mask_mode == 2)
                global_geometry_list.elements[loop_index].Volume->geometry.mask_mode = 2;
            if (this_box_volume.geometry.mask_mode == 1) {
                if (global_geometry_list.elements[loop_index].Volume->geometry.is_masked_volume == 1 && global_geometry_list.elements[loop_index].Volume->geometry.mask_mode != 2)
                    // If more than one mask is added to one volume, the ANY mode overwrites the (default) ALL mode.
                    global_geometry_list.elements[loop_index].Volume->geometry.mask_mode = 1;
            }
            
            found_geometries = 1;
        }
    }
    if (found_geometries == 0) {
        printf("The mask_string in geometry: %s did not find any of the specified volumes in the mask_string %s \n",NAME_CURRENT_COMP,mask_string);
        exit(1);
    }
    this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
    this_box_volume.p_physics->is_vacuum = 0; // Makes this volume a vacuum
    this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
    this_box_volume.p_physics->my_a = 0; // Should not be used.
    sprintf(this_box_volume.p_physics->name,"Mask");
    this_box_volume.geometry.is_mask_volume = 1;
    
    
// Read the material input, or if it lacks, use automatic linking.
} else if (material_string && strlen(material_string) && strcmp(material_string, "NULL") && strcmp(material_string, "0")) {
    // A geometry string was given, use it to determine which material
    if (0 == strcmp(material_string,"vacuum") || 0 == strcmp(material_string,"Vacuum")) {
        // One could have a global physics struct for vacuum instead of creating one for each
        this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
        this_box_volume.p_physics->is_vacuum = 1; // Makes this volume a vacuum
        this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
        this_box_volume.p_physics->my_a = 0; // Should not be used.
        sprintf(this_box_volume.p_physics->name,"Vacuum");
    } else if (0 == strcmp(material_string,"exit") || 0 == strcmp(material_string,"Exit")) {
        // One could have a global physics struct for vacuum instead of creating one for each
        this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
        this_box_volume.p_physics->is_vacuum = 1; // Makes this volume a vacuum
        this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
        this_box_volume.p_physics->my_a = 0; // Should not be used.
        this_box_volume.geometry.is_exit_volume = 1;
        sprintf(this_box_volume.p_physics->name,"Exit");
    } else {
        #ifndef MATERIAL_DETECTOR
            printf("Need to define a material before refering to it in a geometry %s.\n",NAME_CURRENT_COMP);
            exit(1);
        #endif
        for (loop_index=0;loop_index<global_material_list.num_elements;loop_index++) {
            if (0 == strcmp(material_string,global_material_list.elements[loop_index].name)) {
                this_box_volume.p_physics = global_material_list.elements[loop_index].physics;
                break;
            }
            if (loop_index == global_material_list.num_elements-1) {
            printf("\n");
            printf("ERROR: The material string \"%s\" in Union geometry \"%s\" did not match a specified material. \n",material_string,NAME_CURRENT_COMP);
            printf("       The materials available at this point (need to be defined before the geometry): \n");
            for (loop_index=0;loop_index<global_material_list.num_elements;loop_index++)
              printf("         %s\n",global_material_list.elements[loop_index].name);
            printf("\n");
            printf("       It is also possible to use one of the defualt materials avaiable: \n");
            printf("           Vacuum (for a Volume without scattering or absorption)\n");
            printf("           Exit (for a Volume where the ray exits the component if it enters)\n");
            printf("           Mask (for a Volume that masks existing volumes specified in the mask_string\n");
            exit(1);
          }
        }
    }
} else {
    // Automatic linking, simply using the last defined material.
    #ifndef MATERIAL_DETECTOR
        printf("Need to define a material before the geometry to use automatic linking %s.\n",NAME_CURRENT_COMP);
        exit(1);
    #endif
    this_box_volume.p_physics = global_material_list.elements[global_material_list.num_elements-1].physics;
}

sprintf(this_box_volume.name,NAME_CURRENT_COMP);
sprintf(this_box_volume.geometry.shape,"box");
this_box_volume.geometry.priority_value = priority;
this_box_volume.geometry.geometry_p_interact = p_interact;
// Currently the coordinates will be in absolute space.
this_box_volume.geometry.center = POS_A_CURRENT_COMP;

this_box_storage.z_depth = zdepth;
this_box_storage.x_width1 = xwidth;
this_box_storage.y_height1 = yheight;

this_box_storage.is_rectangle = 0;
if (xwidth2 < 0 && yheight2 < 0) this_box_storage.is_rectangle = 1;
if (xwidth == xwidth2 && yheight == yheight2) this_box_storage.is_rectangle = 1;

if (xwidth2 < 0) {
    this_box_storage.x_width2 = xwidth;
    xwidth2 = xwidth;
} else this_box_storage.x_width2 = xwidth2;

if (yheight2 < 0) {
    this_box_storage.y_height2 = yheight;
    yheight2 = yheight;
} else this_box_storage.y_height2 = yheight2;


this_box_storage.normal_vectors[0] = coords_set(0,0,1);
this_box_storage.normal_vectors[1] = coords_set(0,0,1);

// for sides with y component = 0
x_component = 2*zdepth/sqrt((xwidth-xwidth2)*(xwidth-xwidth2)+4*zdepth*zdepth);
z_component = (xwidth-xwidth2)/sqrt(4*zdepth*zdepth+(xwidth-xwidth2)*(xwidth-xwidth2));

this_box_storage.normal_vectors[2] = coords_set(x_component,0,z_component);
this_box_storage.normal_vectors[3] = coords_set(-x_component,0,z_component);

// for sides with x component = 0
y_component = 2*zdepth/sqrt((yheight-yheight2)*(yheight-yheight2)+4*zdepth*zdepth);
z_component = (yheight-yheight2)/sqrt(4*zdepth*zdepth+(yheight-yheight2)*(yheight-yheight2));

this_box_storage.normal_vectors[4] = coords_set(0,y_component,z_component);
this_box_storage.normal_vectors[5] = coords_set(0,-y_component,z_component);

this_box_volume.geometry.visualization_on = visualize;

this_box_volume.geometry.geometry_parameters.p_box_storage = &this_box_storage;

// Assign pointers to functions for intersection with the shape, checking if a point is inside the shape
if (this_box_storage.is_rectangle == 1) {
this_box_volume.geometry.intersect_function = &sample_box_intersect_simple;
this_box_volume.geometry.within_function = &r_within_box_simple;
}
else {
this_box_volume.geometry.intersect_function = &sample_box_intersect_advanced;
this_box_volume.geometry.within_function = &r_within_box_advanced;
}

this_box_volume.geometry.shell_points = &box_shell_points;
this_box_volume.geometry.mcdisplay_function = &mcdisplay_box_function;
this_box_volume.geometry.initialize_from_main_function = &initialize_box_geometry_from_main_component;
this_box_volume.geometry.process_rot_allocated = 0;

this_box_volume.geometry.copy_geometry_parameters = &allocate_box_storage_copy;

rot_copy(this_box_volume.geometry.rotation_matrix,ROT_A_CURRENT_COMP); //check how ROT_R_CURRENT_COMP would work
rot_transpose(ROT_A_CURRENT_COMP,this_box_volume.geometry.transpose_rotation_matrix);

// Initialize loggers
this_box_volume.loggers.num_elements = 0;

// packing the information into the global_geometry_element, which is then included in the global_geometry_list.
sprintf(global_geometry_element.name,NAME_CURRENT_COMP);
global_geometry_element.activation_counter = number_of_activations;
global_geometry_element.component_index = INDEX_CURRENT_COMP;
global_geometry_element.Volume = &this_box_volume; // Would be nicer if this m was a pointer, now we have the (small) data two places
add_element_to_geometry_list(&global_geometry_list,global_geometry_element);
}
#line 318806 "MACS_sample_kidney_box.c"
#undef number_of_activations
#undef mask_setting
#undef mask_string
#undef p_interact
#undef focus_r
#undef focus_xh
#undef focus_xw
#undef focus_ah
#undef focus_aw
#undef target_z
#undef target_y
#undef target_x
#undef target_index
#undef visualize
#undef yheight2
#undef xwidth2
#undef zdepth
#undef yheight
#undef xwidth
#undef priority
#undef material_string
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

  /* Initializations for component channel_17_analyzer_2_array_crystal_array_4. */
  SIG_MESSAGE("channel_17_analyzer_2_array_crystal_array_4 (Init)");
#define mccompcurname  channel_17_analyzer_2_array_crystal_array_4
#define mccompcurtype  Union_box
#define mccompcurindex 791
#define loop_index mccchannel_17_analyzer_2_array_crystal_array_4_loop_index
#define this_box_volume mccchannel_17_analyzer_2_array_crystal_array_4_this_box_volume
#define global_geometry_element mccchannel_17_analyzer_2_array_crystal_array_4_global_geometry_element
#define this_box_storage mccchannel_17_analyzer_2_array_crystal_array_4_this_box_storage
#define material_string mccchannel_17_analyzer_2_array_crystal_array_4_material_string
#define priority mccchannel_17_analyzer_2_array_crystal_array_4_priority
#define xwidth mccchannel_17_analyzer_2_array_crystal_array_4_xwidth
#define yheight mccchannel_17_analyzer_2_array_crystal_array_4_yheight
#define zdepth mccchannel_17_analyzer_2_array_crystal_array_4_zdepth
#define xwidth2 mccchannel_17_analyzer_2_array_crystal_array_4_xwidth2
#define yheight2 mccchannel_17_analyzer_2_array_crystal_array_4_yheight2
#define visualize mccchannel_17_analyzer_2_array_crystal_array_4_visualize
#define target_index mccchannel_17_analyzer_2_array_crystal_array_4_target_index
#define target_x mccchannel_17_analyzer_2_array_crystal_array_4_target_x
#define target_y mccchannel_17_analyzer_2_array_crystal_array_4_target_y
#define target_z mccchannel_17_analyzer_2_array_crystal_array_4_target_z
#define focus_aw mccchannel_17_analyzer_2_array_crystal_array_4_focus_aw
#define focus_ah mccchannel_17_analyzer_2_array_crystal_array_4_focus_ah
#define focus_xw mccchannel_17_analyzer_2_array_crystal_array_4_focus_xw
#define focus_xh mccchannel_17_analyzer_2_array_crystal_array_4_focus_xh
#define focus_r mccchannel_17_analyzer_2_array_crystal_array_4_focus_r
#define p_interact mccchannel_17_analyzer_2_array_crystal_array_4_p_interact
#define mask_string mccchannel_17_analyzer_2_array_crystal_array_4_mask_string
#define mask_setting mccchannel_17_analyzer_2_array_crystal_array_4_mask_setting
#define number_of_activations mccchannel_17_analyzer_2_array_crystal_array_4_number_of_activations
#line 224 "Union_box.comp"
{
// Initializes the focusing system for this volume including input sanitation.
focus_initialize(&this_box_volume.geometry, POS_A_COMP_INDEX(INDEX_CURRENT_COMP+target_index), POS_A_CURRENT_COMP, ROT_A_CURRENT_COMP, target_index, target_x, target_y, target_z, focus_aw, focus_ah, focus_xw, focus_xh, focus_r, NAME_CURRENT_COMP);

// Input sanitation for this geometry
if (xwidth <= 0) {
  printf("\nERROR in Union_box named %s, the xwidth is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (yheight <= 0) {
  printf("\nERROR in Union_box named %s, yheight is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (zdepth <= 0) {
  printf("\nERROR in Union_box named %s, zdepth is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (xwidth2 <= 0 && xwidth2 != -1) {
  printf("\nERROR in Union_box named %s, the xwidth2 is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (yheight2 <= 0 && yheight2 != -1) {
  printf("\nERROR in Union_box named %s, yheight2 is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}

// Use sanitation
if (global_material_list.num_elements == 0) {
  printf("\nERROR: Need to define a material using Union_make_material before using a Union geometry component. \n");
  printf("       %s was defined before first use of Union_make_material.\n",NAME_CURRENT_COMP);
  exit(1);
}

this_box_volume.geometry.is_masked_volume = 0;
this_box_volume.geometry.is_exit_volume = 0;
this_box_volume.geometry.is_mask_volume = 0;
// check if the volume is a mask, if it is the material string is irelevant.
if (mask_string && strlen(mask_string) && strcmp(mask_string, "NULL") && strcmp(mask_string, "0")) {
    // A mask volume is used to limit the extend of other volumes, called the masked volumes. These are specified in the mask_string.
    // In order for a ray to enter a masked volume, it needs to be both in the region covered by that volume AND the mask volume.
    // When more than
    this_box_volume.geometry.mask_mode = 1; // Default is mask mode is ALL
    if (mask_setting && strlen(mask_setting) && strcmp(mask_setting, "NULL") && strcmp(mask_setting, "0")) {
        if (strcmp(mask_setting,"ALL") == 0 || strcmp(mask_setting,"All") == 0) this_box_volume.geometry.mask_mode = 1;
        else if (strcmp(mask_setting,"ANY") == 0 || strcmp(mask_setting,"Any") == 0) this_box_volume.geometry.mask_mode = 2;
        else {
            printf("The mask_mode of component %s is set to %s, but must be either ALL or ANY.\n",NAME_CURRENT_COMP,mask_setting);
            exit(1);
        }
    }
    
    for (loop_index=0;loop_index<global_geometry_list.num_elements;loop_index++) {
        // Add mask list
        if (1 == manual_linking_function(global_geometry_list.elements[loop_index].name,mask_string)) {
            add_element_to_int_list(&this_box_volume.geometry.mask_list,global_geometry_list.elements[loop_index].component_index);
            add_element_to_int_list(&global_geometry_list.elements[loop_index].Volume->geometry.masked_by_list,INDEX_CURRENT_COMP);
            global_geometry_list.elements[loop_index].Volume->geometry.is_masked_volume = 1;
            if (this_box_volume.geometry.mask_mode == 2)
                global_geometry_list.elements[loop_index].Volume->geometry.mask_mode = 2;
            if (this_box_volume.geometry.mask_mode == 1) {
                if (global_geometry_list.elements[loop_index].Volume->geometry.is_masked_volume == 1 && global_geometry_list.elements[loop_index].Volume->geometry.mask_mode != 2)
                    // If more than one mask is added to one volume, the ANY mode overwrites the (default) ALL mode.
                    global_geometry_list.elements[loop_index].Volume->geometry.mask_mode = 1;
            }
            
            found_geometries = 1;
        }
    }
    if (found_geometries == 0) {
        printf("The mask_string in geometry: %s did not find any of the specified volumes in the mask_string %s \n",NAME_CURRENT_COMP,mask_string);
        exit(1);
    }
    this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
    this_box_volume.p_physics->is_vacuum = 0; // Makes this volume a vacuum
    this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
    this_box_volume.p_physics->my_a = 0; // Should not be used.
    sprintf(this_box_volume.p_physics->name,"Mask");
    this_box_volume.geometry.is_mask_volume = 1;
    
    
// Read the material input, or if it lacks, use automatic linking.
} else if (material_string && strlen(material_string) && strcmp(material_string, "NULL") && strcmp(material_string, "0")) {
    // A geometry string was given, use it to determine which material
    if (0 == strcmp(material_string,"vacuum") || 0 == strcmp(material_string,"Vacuum")) {
        // One could have a global physics struct for vacuum instead of creating one for each
        this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
        this_box_volume.p_physics->is_vacuum = 1; // Makes this volume a vacuum
        this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
        this_box_volume.p_physics->my_a = 0; // Should not be used.
        sprintf(this_box_volume.p_physics->name,"Vacuum");
    } else if (0 == strcmp(material_string,"exit") || 0 == strcmp(material_string,"Exit")) {
        // One could have a global physics struct for vacuum instead of creating one for each
        this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
        this_box_volume.p_physics->is_vacuum = 1; // Makes this volume a vacuum
        this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
        this_box_volume.p_physics->my_a = 0; // Should not be used.
        this_box_volume.geometry.is_exit_volume = 1;
        sprintf(this_box_volume.p_physics->name,"Exit");
    } else {
        #ifndef MATERIAL_DETECTOR
            printf("Need to define a material before refering to it in a geometry %s.\n",NAME_CURRENT_COMP);
            exit(1);
        #endif
        for (loop_index=0;loop_index<global_material_list.num_elements;loop_index++) {
            if (0 == strcmp(material_string,global_material_list.elements[loop_index].name)) {
                this_box_volume.p_physics = global_material_list.elements[loop_index].physics;
                break;
            }
            if (loop_index == global_material_list.num_elements-1) {
            printf("\n");
            printf("ERROR: The material string \"%s\" in Union geometry \"%s\" did not match a specified material. \n",material_string,NAME_CURRENT_COMP);
            printf("       The materials available at this point (need to be defined before the geometry): \n");
            for (loop_index=0;loop_index<global_material_list.num_elements;loop_index++)
              printf("         %s\n",global_material_list.elements[loop_index].name);
            printf("\n");
            printf("       It is also possible to use one of the defualt materials avaiable: \n");
            printf("           Vacuum (for a Volume without scattering or absorption)\n");
            printf("           Exit (for a Volume where the ray exits the component if it enters)\n");
            printf("           Mask (for a Volume that masks existing volumes specified in the mask_string\n");
            exit(1);
          }
        }
    }
} else {
    // Automatic linking, simply using the last defined material.
    #ifndef MATERIAL_DETECTOR
        printf("Need to define a material before the geometry to use automatic linking %s.\n",NAME_CURRENT_COMP);
        exit(1);
    #endif
    this_box_volume.p_physics = global_material_list.elements[global_material_list.num_elements-1].physics;
}

sprintf(this_box_volume.name,NAME_CURRENT_COMP);
sprintf(this_box_volume.geometry.shape,"box");
this_box_volume.geometry.priority_value = priority;
this_box_volume.geometry.geometry_p_interact = p_interact;
// Currently the coordinates will be in absolute space.
this_box_volume.geometry.center = POS_A_CURRENT_COMP;

this_box_storage.z_depth = zdepth;
this_box_storage.x_width1 = xwidth;
this_box_storage.y_height1 = yheight;

this_box_storage.is_rectangle = 0;
if (xwidth2 < 0 && yheight2 < 0) this_box_storage.is_rectangle = 1;
if (xwidth == xwidth2 && yheight == yheight2) this_box_storage.is_rectangle = 1;

if (xwidth2 < 0) {
    this_box_storage.x_width2 = xwidth;
    xwidth2 = xwidth;
} else this_box_storage.x_width2 = xwidth2;

if (yheight2 < 0) {
    this_box_storage.y_height2 = yheight;
    yheight2 = yheight;
} else this_box_storage.y_height2 = yheight2;


this_box_storage.normal_vectors[0] = coords_set(0,0,1);
this_box_storage.normal_vectors[1] = coords_set(0,0,1);

// for sides with y component = 0
x_component = 2*zdepth/sqrt((xwidth-xwidth2)*(xwidth-xwidth2)+4*zdepth*zdepth);
z_component = (xwidth-xwidth2)/sqrt(4*zdepth*zdepth+(xwidth-xwidth2)*(xwidth-xwidth2));

this_box_storage.normal_vectors[2] = coords_set(x_component,0,z_component);
this_box_storage.normal_vectors[3] = coords_set(-x_component,0,z_component);

// for sides with x component = 0
y_component = 2*zdepth/sqrt((yheight-yheight2)*(yheight-yheight2)+4*zdepth*zdepth);
z_component = (yheight-yheight2)/sqrt(4*zdepth*zdepth+(yheight-yheight2)*(yheight-yheight2));

this_box_storage.normal_vectors[4] = coords_set(0,y_component,z_component);
this_box_storage.normal_vectors[5] = coords_set(0,-y_component,z_component);

this_box_volume.geometry.visualization_on = visualize;

this_box_volume.geometry.geometry_parameters.p_box_storage = &this_box_storage;

// Assign pointers to functions for intersection with the shape, checking if a point is inside the shape
if (this_box_storage.is_rectangle == 1) {
this_box_volume.geometry.intersect_function = &sample_box_intersect_simple;
this_box_volume.geometry.within_function = &r_within_box_simple;
}
else {
this_box_volume.geometry.intersect_function = &sample_box_intersect_advanced;
this_box_volume.geometry.within_function = &r_within_box_advanced;
}

this_box_volume.geometry.shell_points = &box_shell_points;
this_box_volume.geometry.mcdisplay_function = &mcdisplay_box_function;
this_box_volume.geometry.initialize_from_main_function = &initialize_box_geometry_from_main_component;
this_box_volume.geometry.process_rot_allocated = 0;

this_box_volume.geometry.copy_geometry_parameters = &allocate_box_storage_copy;

rot_copy(this_box_volume.geometry.rotation_matrix,ROT_A_CURRENT_COMP); //check how ROT_R_CURRENT_COMP would work
rot_transpose(ROT_A_CURRENT_COMP,this_box_volume.geometry.transpose_rotation_matrix);

// Initialize loggers
this_box_volume.loggers.num_elements = 0;

// packing the information into the global_geometry_element, which is then included in the global_geometry_list.
sprintf(global_geometry_element.name,NAME_CURRENT_COMP);
global_geometry_element.activation_counter = number_of_activations;
global_geometry_element.component_index = INDEX_CURRENT_COMP;
global_geometry_element.Volume = &this_box_volume; // Would be nicer if this m was a pointer, now we have the (small) data two places
add_element_to_geometry_list(&global_geometry_list,global_geometry_element);
}
#line 319076 "MACS_sample_kidney_box.c"
#undef number_of_activations
#undef mask_setting
#undef mask_string
#undef p_interact
#undef focus_r
#undef focus_xh
#undef focus_xw
#undef focus_ah
#undef focus_aw
#undef target_z
#undef target_y
#undef target_x
#undef target_index
#undef visualize
#undef yheight2
#undef xwidth2
#undef zdepth
#undef yheight
#undef xwidth
#undef priority
#undef material_string
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

  /* Initializations for component channel_17_analyzer_2_array_crystal_array_5. */
  SIG_MESSAGE("channel_17_analyzer_2_array_crystal_array_5 (Init)");
#define mccompcurname  channel_17_analyzer_2_array_crystal_array_5
#define mccompcurtype  Union_box
#define mccompcurindex 792
#define loop_index mccchannel_17_analyzer_2_array_crystal_array_5_loop_index
#define this_box_volume mccchannel_17_analyzer_2_array_crystal_array_5_this_box_volume
#define global_geometry_element mccchannel_17_analyzer_2_array_crystal_array_5_global_geometry_element
#define this_box_storage mccchannel_17_analyzer_2_array_crystal_array_5_this_box_storage
#define material_string mccchannel_17_analyzer_2_array_crystal_array_5_material_string
#define priority mccchannel_17_analyzer_2_array_crystal_array_5_priority
#define xwidth mccchannel_17_analyzer_2_array_crystal_array_5_xwidth
#define yheight mccchannel_17_analyzer_2_array_crystal_array_5_yheight
#define zdepth mccchannel_17_analyzer_2_array_crystal_array_5_zdepth
#define xwidth2 mccchannel_17_analyzer_2_array_crystal_array_5_xwidth2
#define yheight2 mccchannel_17_analyzer_2_array_crystal_array_5_yheight2
#define visualize mccchannel_17_analyzer_2_array_crystal_array_5_visualize
#define target_index mccchannel_17_analyzer_2_array_crystal_array_5_target_index
#define target_x mccchannel_17_analyzer_2_array_crystal_array_5_target_x
#define target_y mccchannel_17_analyzer_2_array_crystal_array_5_target_y
#define target_z mccchannel_17_analyzer_2_array_crystal_array_5_target_z
#define focus_aw mccchannel_17_analyzer_2_array_crystal_array_5_focus_aw
#define focus_ah mccchannel_17_analyzer_2_array_crystal_array_5_focus_ah
#define focus_xw mccchannel_17_analyzer_2_array_crystal_array_5_focus_xw
#define focus_xh mccchannel_17_analyzer_2_array_crystal_array_5_focus_xh
#define focus_r mccchannel_17_analyzer_2_array_crystal_array_5_focus_r
#define p_interact mccchannel_17_analyzer_2_array_crystal_array_5_p_interact
#define mask_string mccchannel_17_analyzer_2_array_crystal_array_5_mask_string
#define mask_setting mccchannel_17_analyzer_2_array_crystal_array_5_mask_setting
#define number_of_activations mccchannel_17_analyzer_2_array_crystal_array_5_number_of_activations
#line 224 "Union_box.comp"
{
// Initializes the focusing system for this volume including input sanitation.
focus_initialize(&this_box_volume.geometry, POS_A_COMP_INDEX(INDEX_CURRENT_COMP+target_index), POS_A_CURRENT_COMP, ROT_A_CURRENT_COMP, target_index, target_x, target_y, target_z, focus_aw, focus_ah, focus_xw, focus_xh, focus_r, NAME_CURRENT_COMP);

// Input sanitation for this geometry
if (xwidth <= 0) {
  printf("\nERROR in Union_box named %s, the xwidth is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (yheight <= 0) {
  printf("\nERROR in Union_box named %s, yheight is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (zdepth <= 0) {
  printf("\nERROR in Union_box named %s, zdepth is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (xwidth2 <= 0 && xwidth2 != -1) {
  printf("\nERROR in Union_box named %s, the xwidth2 is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (yheight2 <= 0 && yheight2 != -1) {
  printf("\nERROR in Union_box named %s, yheight2 is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}

// Use sanitation
if (global_material_list.num_elements == 0) {
  printf("\nERROR: Need to define a material using Union_make_material before using a Union geometry component. \n");
  printf("       %s was defined before first use of Union_make_material.\n",NAME_CURRENT_COMP);
  exit(1);
}

this_box_volume.geometry.is_masked_volume = 0;
this_box_volume.geometry.is_exit_volume = 0;
this_box_volume.geometry.is_mask_volume = 0;
// check if the volume is a mask, if it is the material string is irelevant.
if (mask_string && strlen(mask_string) && strcmp(mask_string, "NULL") && strcmp(mask_string, "0")) {
    // A mask volume is used to limit the extend of other volumes, called the masked volumes. These are specified in the mask_string.
    // In order for a ray to enter a masked volume, it needs to be both in the region covered by that volume AND the mask volume.
    // When more than
    this_box_volume.geometry.mask_mode = 1; // Default is mask mode is ALL
    if (mask_setting && strlen(mask_setting) && strcmp(mask_setting, "NULL") && strcmp(mask_setting, "0")) {
        if (strcmp(mask_setting,"ALL") == 0 || strcmp(mask_setting,"All") == 0) this_box_volume.geometry.mask_mode = 1;
        else if (strcmp(mask_setting,"ANY") == 0 || strcmp(mask_setting,"Any") == 0) this_box_volume.geometry.mask_mode = 2;
        else {
            printf("The mask_mode of component %s is set to %s, but must be either ALL or ANY.\n",NAME_CURRENT_COMP,mask_setting);
            exit(1);
        }
    }
    
    for (loop_index=0;loop_index<global_geometry_list.num_elements;loop_index++) {
        // Add mask list
        if (1 == manual_linking_function(global_geometry_list.elements[loop_index].name,mask_string)) {
            add_element_to_int_list(&this_box_volume.geometry.mask_list,global_geometry_list.elements[loop_index].component_index);
            add_element_to_int_list(&global_geometry_list.elements[loop_index].Volume->geometry.masked_by_list,INDEX_CURRENT_COMP);
            global_geometry_list.elements[loop_index].Volume->geometry.is_masked_volume = 1;
            if (this_box_volume.geometry.mask_mode == 2)
                global_geometry_list.elements[loop_index].Volume->geometry.mask_mode = 2;
            if (this_box_volume.geometry.mask_mode == 1) {
                if (global_geometry_list.elements[loop_index].Volume->geometry.is_masked_volume == 1 && global_geometry_list.elements[loop_index].Volume->geometry.mask_mode != 2)
                    // If more than one mask is added to one volume, the ANY mode overwrites the (default) ALL mode.
                    global_geometry_list.elements[loop_index].Volume->geometry.mask_mode = 1;
            }
            
            found_geometries = 1;
        }
    }
    if (found_geometries == 0) {
        printf("The mask_string in geometry: %s did not find any of the specified volumes in the mask_string %s \n",NAME_CURRENT_COMP,mask_string);
        exit(1);
    }
    this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
    this_box_volume.p_physics->is_vacuum = 0; // Makes this volume a vacuum
    this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
    this_box_volume.p_physics->my_a = 0; // Should not be used.
    sprintf(this_box_volume.p_physics->name,"Mask");
    this_box_volume.geometry.is_mask_volume = 1;
    
    
// Read the material input, or if it lacks, use automatic linking.
} else if (material_string && strlen(material_string) && strcmp(material_string, "NULL") && strcmp(material_string, "0")) {
    // A geometry string was given, use it to determine which material
    if (0 == strcmp(material_string,"vacuum") || 0 == strcmp(material_string,"Vacuum")) {
        // One could have a global physics struct for vacuum instead of creating one for each
        this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
        this_box_volume.p_physics->is_vacuum = 1; // Makes this volume a vacuum
        this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
        this_box_volume.p_physics->my_a = 0; // Should not be used.
        sprintf(this_box_volume.p_physics->name,"Vacuum");
    } else if (0 == strcmp(material_string,"exit") || 0 == strcmp(material_string,"Exit")) {
        // One could have a global physics struct for vacuum instead of creating one for each
        this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
        this_box_volume.p_physics->is_vacuum = 1; // Makes this volume a vacuum
        this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
        this_box_volume.p_physics->my_a = 0; // Should not be used.
        this_box_volume.geometry.is_exit_volume = 1;
        sprintf(this_box_volume.p_physics->name,"Exit");
    } else {
        #ifndef MATERIAL_DETECTOR
            printf("Need to define a material before refering to it in a geometry %s.\n",NAME_CURRENT_COMP);
            exit(1);
        #endif
        for (loop_index=0;loop_index<global_material_list.num_elements;loop_index++) {
            if (0 == strcmp(material_string,global_material_list.elements[loop_index].name)) {
                this_box_volume.p_physics = global_material_list.elements[loop_index].physics;
                break;
            }
            if (loop_index == global_material_list.num_elements-1) {
            printf("\n");
            printf("ERROR: The material string \"%s\" in Union geometry \"%s\" did not match a specified material. \n",material_string,NAME_CURRENT_COMP);
            printf("       The materials available at this point (need to be defined before the geometry): \n");
            for (loop_index=0;loop_index<global_material_list.num_elements;loop_index++)
              printf("         %s\n",global_material_list.elements[loop_index].name);
            printf("\n");
            printf("       It is also possible to use one of the defualt materials avaiable: \n");
            printf("           Vacuum (for a Volume without scattering or absorption)\n");
            printf("           Exit (for a Volume where the ray exits the component if it enters)\n");
            printf("           Mask (for a Volume that masks existing volumes specified in the mask_string\n");
            exit(1);
          }
        }
    }
} else {
    // Automatic linking, simply using the last defined material.
    #ifndef MATERIAL_DETECTOR
        printf("Need to define a material before the geometry to use automatic linking %s.\n",NAME_CURRENT_COMP);
        exit(1);
    #endif
    this_box_volume.p_physics = global_material_list.elements[global_material_list.num_elements-1].physics;
}

sprintf(this_box_volume.name,NAME_CURRENT_COMP);
sprintf(this_box_volume.geometry.shape,"box");
this_box_volume.geometry.priority_value = priority;
this_box_volume.geometry.geometry_p_interact = p_interact;
// Currently the coordinates will be in absolute space.
this_box_volume.geometry.center = POS_A_CURRENT_COMP;

this_box_storage.z_depth = zdepth;
this_box_storage.x_width1 = xwidth;
this_box_storage.y_height1 = yheight;

this_box_storage.is_rectangle = 0;
if (xwidth2 < 0 && yheight2 < 0) this_box_storage.is_rectangle = 1;
if (xwidth == xwidth2 && yheight == yheight2) this_box_storage.is_rectangle = 1;

if (xwidth2 < 0) {
    this_box_storage.x_width2 = xwidth;
    xwidth2 = xwidth;
} else this_box_storage.x_width2 = xwidth2;

if (yheight2 < 0) {
    this_box_storage.y_height2 = yheight;
    yheight2 = yheight;
} else this_box_storage.y_height2 = yheight2;


this_box_storage.normal_vectors[0] = coords_set(0,0,1);
this_box_storage.normal_vectors[1] = coords_set(0,0,1);

// for sides with y component = 0
x_component = 2*zdepth/sqrt((xwidth-xwidth2)*(xwidth-xwidth2)+4*zdepth*zdepth);
z_component = (xwidth-xwidth2)/sqrt(4*zdepth*zdepth+(xwidth-xwidth2)*(xwidth-xwidth2));

this_box_storage.normal_vectors[2] = coords_set(x_component,0,z_component);
this_box_storage.normal_vectors[3] = coords_set(-x_component,0,z_component);

// for sides with x component = 0
y_component = 2*zdepth/sqrt((yheight-yheight2)*(yheight-yheight2)+4*zdepth*zdepth);
z_component = (yheight-yheight2)/sqrt(4*zdepth*zdepth+(yheight-yheight2)*(yheight-yheight2));

this_box_storage.normal_vectors[4] = coords_set(0,y_component,z_component);
this_box_storage.normal_vectors[5] = coords_set(0,-y_component,z_component);

this_box_volume.geometry.visualization_on = visualize;

this_box_volume.geometry.geometry_parameters.p_box_storage = &this_box_storage;

// Assign pointers to functions for intersection with the shape, checking if a point is inside the shape
if (this_box_storage.is_rectangle == 1) {
this_box_volume.geometry.intersect_function = &sample_box_intersect_simple;
this_box_volume.geometry.within_function = &r_within_box_simple;
}
else {
this_box_volume.geometry.intersect_function = &sample_box_intersect_advanced;
this_box_volume.geometry.within_function = &r_within_box_advanced;
}

this_box_volume.geometry.shell_points = &box_shell_points;
this_box_volume.geometry.mcdisplay_function = &mcdisplay_box_function;
this_box_volume.geometry.initialize_from_main_function = &initialize_box_geometry_from_main_component;
this_box_volume.geometry.process_rot_allocated = 0;

this_box_volume.geometry.copy_geometry_parameters = &allocate_box_storage_copy;

rot_copy(this_box_volume.geometry.rotation_matrix,ROT_A_CURRENT_COMP); //check how ROT_R_CURRENT_COMP would work
rot_transpose(ROT_A_CURRENT_COMP,this_box_volume.geometry.transpose_rotation_matrix);

// Initialize loggers
this_box_volume.loggers.num_elements = 0;

// packing the information into the global_geometry_element, which is then included in the global_geometry_list.
sprintf(global_geometry_element.name,NAME_CURRENT_COMP);
global_geometry_element.activation_counter = number_of_activations;
global_geometry_element.component_index = INDEX_CURRENT_COMP;
global_geometry_element.Volume = &this_box_volume; // Would be nicer if this m was a pointer, now we have the (small) data two places
add_element_to_geometry_list(&global_geometry_list,global_geometry_element);
}
#line 319346 "MACS_sample_kidney_box.c"
#undef number_of_activations
#undef mask_setting
#undef mask_string
#undef p_interact
#undef focus_r
#undef focus_xh
#undef focus_xw
#undef focus_ah
#undef focus_aw
#undef target_z
#undef target_y
#undef target_x
#undef target_index
#undef visualize
#undef yheight2
#undef xwidth2
#undef zdepth
#undef yheight
#undef xwidth
#undef priority
#undef material_string
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

  /* Initializations for component channel_17_analyzer_2_array_crystal_array_6. */
  SIG_MESSAGE("channel_17_analyzer_2_array_crystal_array_6 (Init)");
#define mccompcurname  channel_17_analyzer_2_array_crystal_array_6
#define mccompcurtype  Union_box
#define mccompcurindex 793
#define loop_index mccchannel_17_analyzer_2_array_crystal_array_6_loop_index
#define this_box_volume mccchannel_17_analyzer_2_array_crystal_array_6_this_box_volume
#define global_geometry_element mccchannel_17_analyzer_2_array_crystal_array_6_global_geometry_element
#define this_box_storage mccchannel_17_analyzer_2_array_crystal_array_6_this_box_storage
#define material_string mccchannel_17_analyzer_2_array_crystal_array_6_material_string
#define priority mccchannel_17_analyzer_2_array_crystal_array_6_priority
#define xwidth mccchannel_17_analyzer_2_array_crystal_array_6_xwidth
#define yheight mccchannel_17_analyzer_2_array_crystal_array_6_yheight
#define zdepth mccchannel_17_analyzer_2_array_crystal_array_6_zdepth
#define xwidth2 mccchannel_17_analyzer_2_array_crystal_array_6_xwidth2
#define yheight2 mccchannel_17_analyzer_2_array_crystal_array_6_yheight2
#define visualize mccchannel_17_analyzer_2_array_crystal_array_6_visualize
#define target_index mccchannel_17_analyzer_2_array_crystal_array_6_target_index
#define target_x mccchannel_17_analyzer_2_array_crystal_array_6_target_x
#define target_y mccchannel_17_analyzer_2_array_crystal_array_6_target_y
#define target_z mccchannel_17_analyzer_2_array_crystal_array_6_target_z
#define focus_aw mccchannel_17_analyzer_2_array_crystal_array_6_focus_aw
#define focus_ah mccchannel_17_analyzer_2_array_crystal_array_6_focus_ah
#define focus_xw mccchannel_17_analyzer_2_array_crystal_array_6_focus_xw
#define focus_xh mccchannel_17_analyzer_2_array_crystal_array_6_focus_xh
#define focus_r mccchannel_17_analyzer_2_array_crystal_array_6_focus_r
#define p_interact mccchannel_17_analyzer_2_array_crystal_array_6_p_interact
#define mask_string mccchannel_17_analyzer_2_array_crystal_array_6_mask_string
#define mask_setting mccchannel_17_analyzer_2_array_crystal_array_6_mask_setting
#define number_of_activations mccchannel_17_analyzer_2_array_crystal_array_6_number_of_activations
#line 224 "Union_box.comp"
{
// Initializes the focusing system for this volume including input sanitation.
focus_initialize(&this_box_volume.geometry, POS_A_COMP_INDEX(INDEX_CURRENT_COMP+target_index), POS_A_CURRENT_COMP, ROT_A_CURRENT_COMP, target_index, target_x, target_y, target_z, focus_aw, focus_ah, focus_xw, focus_xh, focus_r, NAME_CURRENT_COMP);

// Input sanitation for this geometry
if (xwidth <= 0) {
  printf("\nERROR in Union_box named %s, the xwidth is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (yheight <= 0) {
  printf("\nERROR in Union_box named %s, yheight is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (zdepth <= 0) {
  printf("\nERROR in Union_box named %s, zdepth is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (xwidth2 <= 0 && xwidth2 != -1) {
  printf("\nERROR in Union_box named %s, the xwidth2 is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (yheight2 <= 0 && yheight2 != -1) {
  printf("\nERROR in Union_box named %s, yheight2 is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}

// Use sanitation
if (global_material_list.num_elements == 0) {
  printf("\nERROR: Need to define a material using Union_make_material before using a Union geometry component. \n");
  printf("       %s was defined before first use of Union_make_material.\n",NAME_CURRENT_COMP);
  exit(1);
}

this_box_volume.geometry.is_masked_volume = 0;
this_box_volume.geometry.is_exit_volume = 0;
this_box_volume.geometry.is_mask_volume = 0;
// check if the volume is a mask, if it is the material string is irelevant.
if (mask_string && strlen(mask_string) && strcmp(mask_string, "NULL") && strcmp(mask_string, "0")) {
    // A mask volume is used to limit the extend of other volumes, called the masked volumes. These are specified in the mask_string.
    // In order for a ray to enter a masked volume, it needs to be both in the region covered by that volume AND the mask volume.
    // When more than
    this_box_volume.geometry.mask_mode = 1; // Default is mask mode is ALL
    if (mask_setting && strlen(mask_setting) && strcmp(mask_setting, "NULL") && strcmp(mask_setting, "0")) {
        if (strcmp(mask_setting,"ALL") == 0 || strcmp(mask_setting,"All") == 0) this_box_volume.geometry.mask_mode = 1;
        else if (strcmp(mask_setting,"ANY") == 0 || strcmp(mask_setting,"Any") == 0) this_box_volume.geometry.mask_mode = 2;
        else {
            printf("The mask_mode of component %s is set to %s, but must be either ALL or ANY.\n",NAME_CURRENT_COMP,mask_setting);
            exit(1);
        }
    }
    
    for (loop_index=0;loop_index<global_geometry_list.num_elements;loop_index++) {
        // Add mask list
        if (1 == manual_linking_function(global_geometry_list.elements[loop_index].name,mask_string)) {
            add_element_to_int_list(&this_box_volume.geometry.mask_list,global_geometry_list.elements[loop_index].component_index);
            add_element_to_int_list(&global_geometry_list.elements[loop_index].Volume->geometry.masked_by_list,INDEX_CURRENT_COMP);
            global_geometry_list.elements[loop_index].Volume->geometry.is_masked_volume = 1;
            if (this_box_volume.geometry.mask_mode == 2)
                global_geometry_list.elements[loop_index].Volume->geometry.mask_mode = 2;
            if (this_box_volume.geometry.mask_mode == 1) {
                if (global_geometry_list.elements[loop_index].Volume->geometry.is_masked_volume == 1 && global_geometry_list.elements[loop_index].Volume->geometry.mask_mode != 2)
                    // If more than one mask is added to one volume, the ANY mode overwrites the (default) ALL mode.
                    global_geometry_list.elements[loop_index].Volume->geometry.mask_mode = 1;
            }
            
            found_geometries = 1;
        }
    }
    if (found_geometries == 0) {
        printf("The mask_string in geometry: %s did not find any of the specified volumes in the mask_string %s \n",NAME_CURRENT_COMP,mask_string);
        exit(1);
    }
    this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
    this_box_volume.p_physics->is_vacuum = 0; // Makes this volume a vacuum
    this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
    this_box_volume.p_physics->my_a = 0; // Should not be used.
    sprintf(this_box_volume.p_physics->name,"Mask");
    this_box_volume.geometry.is_mask_volume = 1;
    
    
// Read the material input, or if it lacks, use automatic linking.
} else if (material_string && strlen(material_string) && strcmp(material_string, "NULL") && strcmp(material_string, "0")) {
    // A geometry string was given, use it to determine which material
    if (0 == strcmp(material_string,"vacuum") || 0 == strcmp(material_string,"Vacuum")) {
        // One could have a global physics struct for vacuum instead of creating one for each
        this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
        this_box_volume.p_physics->is_vacuum = 1; // Makes this volume a vacuum
        this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
        this_box_volume.p_physics->my_a = 0; // Should not be used.
        sprintf(this_box_volume.p_physics->name,"Vacuum");
    } else if (0 == strcmp(material_string,"exit") || 0 == strcmp(material_string,"Exit")) {
        // One could have a global physics struct for vacuum instead of creating one for each
        this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
        this_box_volume.p_physics->is_vacuum = 1; // Makes this volume a vacuum
        this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
        this_box_volume.p_physics->my_a = 0; // Should not be used.
        this_box_volume.geometry.is_exit_volume = 1;
        sprintf(this_box_volume.p_physics->name,"Exit");
    } else {
        #ifndef MATERIAL_DETECTOR
            printf("Need to define a material before refering to it in a geometry %s.\n",NAME_CURRENT_COMP);
            exit(1);
        #endif
        for (loop_index=0;loop_index<global_material_list.num_elements;loop_index++) {
            if (0 == strcmp(material_string,global_material_list.elements[loop_index].name)) {
                this_box_volume.p_physics = global_material_list.elements[loop_index].physics;
                break;
            }
            if (loop_index == global_material_list.num_elements-1) {
            printf("\n");
            printf("ERROR: The material string \"%s\" in Union geometry \"%s\" did not match a specified material. \n",material_string,NAME_CURRENT_COMP);
            printf("       The materials available at this point (need to be defined before the geometry): \n");
            for (loop_index=0;loop_index<global_material_list.num_elements;loop_index++)
              printf("         %s\n",global_material_list.elements[loop_index].name);
            printf("\n");
            printf("       It is also possible to use one of the defualt materials avaiable: \n");
            printf("           Vacuum (for a Volume without scattering or absorption)\n");
            printf("           Exit (for a Volume where the ray exits the component if it enters)\n");
            printf("           Mask (for a Volume that masks existing volumes specified in the mask_string\n");
            exit(1);
          }
        }
    }
} else {
    // Automatic linking, simply using the last defined material.
    #ifndef MATERIAL_DETECTOR
        printf("Need to define a material before the geometry to use automatic linking %s.\n",NAME_CURRENT_COMP);
        exit(1);
    #endif
    this_box_volume.p_physics = global_material_list.elements[global_material_list.num_elements-1].physics;
}

sprintf(this_box_volume.name,NAME_CURRENT_COMP);
sprintf(this_box_volume.geometry.shape,"box");
this_box_volume.geometry.priority_value = priority;
this_box_volume.geometry.geometry_p_interact = p_interact;
// Currently the coordinates will be in absolute space.
this_box_volume.geometry.center = POS_A_CURRENT_COMP;

this_box_storage.z_depth = zdepth;
this_box_storage.x_width1 = xwidth;
this_box_storage.y_height1 = yheight;

this_box_storage.is_rectangle = 0;
if (xwidth2 < 0 && yheight2 < 0) this_box_storage.is_rectangle = 1;
if (xwidth == xwidth2 && yheight == yheight2) this_box_storage.is_rectangle = 1;

if (xwidth2 < 0) {
    this_box_storage.x_width2 = xwidth;
    xwidth2 = xwidth;
} else this_box_storage.x_width2 = xwidth2;

if (yheight2 < 0) {
    this_box_storage.y_height2 = yheight;
    yheight2 = yheight;
} else this_box_storage.y_height2 = yheight2;


this_box_storage.normal_vectors[0] = coords_set(0,0,1);
this_box_storage.normal_vectors[1] = coords_set(0,0,1);

// for sides with y component = 0
x_component = 2*zdepth/sqrt((xwidth-xwidth2)*(xwidth-xwidth2)+4*zdepth*zdepth);
z_component = (xwidth-xwidth2)/sqrt(4*zdepth*zdepth+(xwidth-xwidth2)*(xwidth-xwidth2));

this_box_storage.normal_vectors[2] = coords_set(x_component,0,z_component);
this_box_storage.normal_vectors[3] = coords_set(-x_component,0,z_component);

// for sides with x component = 0
y_component = 2*zdepth/sqrt((yheight-yheight2)*(yheight-yheight2)+4*zdepth*zdepth);
z_component = (yheight-yheight2)/sqrt(4*zdepth*zdepth+(yheight-yheight2)*(yheight-yheight2));

this_box_storage.normal_vectors[4] = coords_set(0,y_component,z_component);
this_box_storage.normal_vectors[5] = coords_set(0,-y_component,z_component);

this_box_volume.geometry.visualization_on = visualize;

this_box_volume.geometry.geometry_parameters.p_box_storage = &this_box_storage;

// Assign pointers to functions for intersection with the shape, checking if a point is inside the shape
if (this_box_storage.is_rectangle == 1) {
this_box_volume.geometry.intersect_function = &sample_box_intersect_simple;
this_box_volume.geometry.within_function = &r_within_box_simple;
}
else {
this_box_volume.geometry.intersect_function = &sample_box_intersect_advanced;
this_box_volume.geometry.within_function = &r_within_box_advanced;
}

this_box_volume.geometry.shell_points = &box_shell_points;
this_box_volume.geometry.mcdisplay_function = &mcdisplay_box_function;
this_box_volume.geometry.initialize_from_main_function = &initialize_box_geometry_from_main_component;
this_box_volume.geometry.process_rot_allocated = 0;

this_box_volume.geometry.copy_geometry_parameters = &allocate_box_storage_copy;

rot_copy(this_box_volume.geometry.rotation_matrix,ROT_A_CURRENT_COMP); //check how ROT_R_CURRENT_COMP would work
rot_transpose(ROT_A_CURRENT_COMP,this_box_volume.geometry.transpose_rotation_matrix);

// Initialize loggers
this_box_volume.loggers.num_elements = 0;

// packing the information into the global_geometry_element, which is then included in the global_geometry_list.
sprintf(global_geometry_element.name,NAME_CURRENT_COMP);
global_geometry_element.activation_counter = number_of_activations;
global_geometry_element.component_index = INDEX_CURRENT_COMP;
global_geometry_element.Volume = &this_box_volume; // Would be nicer if this m was a pointer, now we have the (small) data two places
add_element_to_geometry_list(&global_geometry_list,global_geometry_element);
}
#line 319616 "MACS_sample_kidney_box.c"
#undef number_of_activations
#undef mask_setting
#undef mask_string
#undef p_interact
#undef focus_r
#undef focus_xh
#undef focus_xw
#undef focus_ah
#undef focus_aw
#undef target_z
#undef target_y
#undef target_x
#undef target_index
#undef visualize
#undef yheight2
#undef xwidth2
#undef zdepth
#undef yheight
#undef xwidth
#undef priority
#undef material_string
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

  /* Initializations for component channel_17_analyzer_2_array_crystal_array_7. */
  SIG_MESSAGE("channel_17_analyzer_2_array_crystal_array_7 (Init)");
#define mccompcurname  channel_17_analyzer_2_array_crystal_array_7
#define mccompcurtype  Union_box
#define mccompcurindex 794
#define loop_index mccchannel_17_analyzer_2_array_crystal_array_7_loop_index
#define this_box_volume mccchannel_17_analyzer_2_array_crystal_array_7_this_box_volume
#define global_geometry_element mccchannel_17_analyzer_2_array_crystal_array_7_global_geometry_element
#define this_box_storage mccchannel_17_analyzer_2_array_crystal_array_7_this_box_storage
#define material_string mccchannel_17_analyzer_2_array_crystal_array_7_material_string
#define priority mccchannel_17_analyzer_2_array_crystal_array_7_priority
#define xwidth mccchannel_17_analyzer_2_array_crystal_array_7_xwidth
#define yheight mccchannel_17_analyzer_2_array_crystal_array_7_yheight
#define zdepth mccchannel_17_analyzer_2_array_crystal_array_7_zdepth
#define xwidth2 mccchannel_17_analyzer_2_array_crystal_array_7_xwidth2
#define yheight2 mccchannel_17_analyzer_2_array_crystal_array_7_yheight2
#define visualize mccchannel_17_analyzer_2_array_crystal_array_7_visualize
#define target_index mccchannel_17_analyzer_2_array_crystal_array_7_target_index
#define target_x mccchannel_17_analyzer_2_array_crystal_array_7_target_x
#define target_y mccchannel_17_analyzer_2_array_crystal_array_7_target_y
#define target_z mccchannel_17_analyzer_2_array_crystal_array_7_target_z
#define focus_aw mccchannel_17_analyzer_2_array_crystal_array_7_focus_aw
#define focus_ah mccchannel_17_analyzer_2_array_crystal_array_7_focus_ah
#define focus_xw mccchannel_17_analyzer_2_array_crystal_array_7_focus_xw
#define focus_xh mccchannel_17_analyzer_2_array_crystal_array_7_focus_xh
#define focus_r mccchannel_17_analyzer_2_array_crystal_array_7_focus_r
#define p_interact mccchannel_17_analyzer_2_array_crystal_array_7_p_interact
#define mask_string mccchannel_17_analyzer_2_array_crystal_array_7_mask_string
#define mask_setting mccchannel_17_analyzer_2_array_crystal_array_7_mask_setting
#define number_of_activations mccchannel_17_analyzer_2_array_crystal_array_7_number_of_activations
#line 224 "Union_box.comp"
{
// Initializes the focusing system for this volume including input sanitation.
focus_initialize(&this_box_volume.geometry, POS_A_COMP_INDEX(INDEX_CURRENT_COMP+target_index), POS_A_CURRENT_COMP, ROT_A_CURRENT_COMP, target_index, target_x, target_y, target_z, focus_aw, focus_ah, focus_xw, focus_xh, focus_r, NAME_CURRENT_COMP);

// Input sanitation for this geometry
if (xwidth <= 0) {
  printf("\nERROR in Union_box named %s, the xwidth is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (yheight <= 0) {
  printf("\nERROR in Union_box named %s, yheight is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (zdepth <= 0) {
  printf("\nERROR in Union_box named %s, zdepth is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (xwidth2 <= 0 && xwidth2 != -1) {
  printf("\nERROR in Union_box named %s, the xwidth2 is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (yheight2 <= 0 && yheight2 != -1) {
  printf("\nERROR in Union_box named %s, yheight2 is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}

// Use sanitation
if (global_material_list.num_elements == 0) {
  printf("\nERROR: Need to define a material using Union_make_material before using a Union geometry component. \n");
  printf("       %s was defined before first use of Union_make_material.\n",NAME_CURRENT_COMP);
  exit(1);
}

this_box_volume.geometry.is_masked_volume = 0;
this_box_volume.geometry.is_exit_volume = 0;
this_box_volume.geometry.is_mask_volume = 0;
// check if the volume is a mask, if it is the material string is irelevant.
if (mask_string && strlen(mask_string) && strcmp(mask_string, "NULL") && strcmp(mask_string, "0")) {
    // A mask volume is used to limit the extend of other volumes, called the masked volumes. These are specified in the mask_string.
    // In order for a ray to enter a masked volume, it needs to be both in the region covered by that volume AND the mask volume.
    // When more than
    this_box_volume.geometry.mask_mode = 1; // Default is mask mode is ALL
    if (mask_setting && strlen(mask_setting) && strcmp(mask_setting, "NULL") && strcmp(mask_setting, "0")) {
        if (strcmp(mask_setting,"ALL") == 0 || strcmp(mask_setting,"All") == 0) this_box_volume.geometry.mask_mode = 1;
        else if (strcmp(mask_setting,"ANY") == 0 || strcmp(mask_setting,"Any") == 0) this_box_volume.geometry.mask_mode = 2;
        else {
            printf("The mask_mode of component %s is set to %s, but must be either ALL or ANY.\n",NAME_CURRENT_COMP,mask_setting);
            exit(1);
        }
    }
    
    for (loop_index=0;loop_index<global_geometry_list.num_elements;loop_index++) {
        // Add mask list
        if (1 == manual_linking_function(global_geometry_list.elements[loop_index].name,mask_string)) {
            add_element_to_int_list(&this_box_volume.geometry.mask_list,global_geometry_list.elements[loop_index].component_index);
            add_element_to_int_list(&global_geometry_list.elements[loop_index].Volume->geometry.masked_by_list,INDEX_CURRENT_COMP);
            global_geometry_list.elements[loop_index].Volume->geometry.is_masked_volume = 1;
            if (this_box_volume.geometry.mask_mode == 2)
                global_geometry_list.elements[loop_index].Volume->geometry.mask_mode = 2;
            if (this_box_volume.geometry.mask_mode == 1) {
                if (global_geometry_list.elements[loop_index].Volume->geometry.is_masked_volume == 1 && global_geometry_list.elements[loop_index].Volume->geometry.mask_mode != 2)
                    // If more than one mask is added to one volume, the ANY mode overwrites the (default) ALL mode.
                    global_geometry_list.elements[loop_index].Volume->geometry.mask_mode = 1;
            }
            
            found_geometries = 1;
        }
    }
    if (found_geometries == 0) {
        printf("The mask_string in geometry: %s did not find any of the specified volumes in the mask_string %s \n",NAME_CURRENT_COMP,mask_string);
        exit(1);
    }
    this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
    this_box_volume.p_physics->is_vacuum = 0; // Makes this volume a vacuum
    this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
    this_box_volume.p_physics->my_a = 0; // Should not be used.
    sprintf(this_box_volume.p_physics->name,"Mask");
    this_box_volume.geometry.is_mask_volume = 1;
    
    
// Read the material input, or if it lacks, use automatic linking.
} else if (material_string && strlen(material_string) && strcmp(material_string, "NULL") && strcmp(material_string, "0")) {
    // A geometry string was given, use it to determine which material
    if (0 == strcmp(material_string,"vacuum") || 0 == strcmp(material_string,"Vacuum")) {
        // One could have a global physics struct for vacuum instead of creating one for each
        this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
        this_box_volume.p_physics->is_vacuum = 1; // Makes this volume a vacuum
        this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
        this_box_volume.p_physics->my_a = 0; // Should not be used.
        sprintf(this_box_volume.p_physics->name,"Vacuum");
    } else if (0 == strcmp(material_string,"exit") || 0 == strcmp(material_string,"Exit")) {
        // One could have a global physics struct for vacuum instead of creating one for each
        this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
        this_box_volume.p_physics->is_vacuum = 1; // Makes this volume a vacuum
        this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
        this_box_volume.p_physics->my_a = 0; // Should not be used.
        this_box_volume.geometry.is_exit_volume = 1;
        sprintf(this_box_volume.p_physics->name,"Exit");
    } else {
        #ifndef MATERIAL_DETECTOR
            printf("Need to define a material before refering to it in a geometry %s.\n",NAME_CURRENT_COMP);
            exit(1);
        #endif
        for (loop_index=0;loop_index<global_material_list.num_elements;loop_index++) {
            if (0 == strcmp(material_string,global_material_list.elements[loop_index].name)) {
                this_box_volume.p_physics = global_material_list.elements[loop_index].physics;
                break;
            }
            if (loop_index == global_material_list.num_elements-1) {
            printf("\n");
            printf("ERROR: The material string \"%s\" in Union geometry \"%s\" did not match a specified material. \n",material_string,NAME_CURRENT_COMP);
            printf("       The materials available at this point (need to be defined before the geometry): \n");
            for (loop_index=0;loop_index<global_material_list.num_elements;loop_index++)
              printf("         %s\n",global_material_list.elements[loop_index].name);
            printf("\n");
            printf("       It is also possible to use one of the defualt materials avaiable: \n");
            printf("           Vacuum (for a Volume without scattering or absorption)\n");
            printf("           Exit (for a Volume where the ray exits the component if it enters)\n");
            printf("           Mask (for a Volume that masks existing volumes specified in the mask_string\n");
            exit(1);
          }
        }
    }
} else {
    // Automatic linking, simply using the last defined material.
    #ifndef MATERIAL_DETECTOR
        printf("Need to define a material before the geometry to use automatic linking %s.\n",NAME_CURRENT_COMP);
        exit(1);
    #endif
    this_box_volume.p_physics = global_material_list.elements[global_material_list.num_elements-1].physics;
}

sprintf(this_box_volume.name,NAME_CURRENT_COMP);
sprintf(this_box_volume.geometry.shape,"box");
this_box_volume.geometry.priority_value = priority;
this_box_volume.geometry.geometry_p_interact = p_interact;
// Currently the coordinates will be in absolute space.
this_box_volume.geometry.center = POS_A_CURRENT_COMP;

this_box_storage.z_depth = zdepth;
this_box_storage.x_width1 = xwidth;
this_box_storage.y_height1 = yheight;

this_box_storage.is_rectangle = 0;
if (xwidth2 < 0 && yheight2 < 0) this_box_storage.is_rectangle = 1;
if (xwidth == xwidth2 && yheight == yheight2) this_box_storage.is_rectangle = 1;

if (xwidth2 < 0) {
    this_box_storage.x_width2 = xwidth;
    xwidth2 = xwidth;
} else this_box_storage.x_width2 = xwidth2;

if (yheight2 < 0) {
    this_box_storage.y_height2 = yheight;
    yheight2 = yheight;
} else this_box_storage.y_height2 = yheight2;


this_box_storage.normal_vectors[0] = coords_set(0,0,1);
this_box_storage.normal_vectors[1] = coords_set(0,0,1);

// for sides with y component = 0
x_component = 2*zdepth/sqrt((xwidth-xwidth2)*(xwidth-xwidth2)+4*zdepth*zdepth);
z_component = (xwidth-xwidth2)/sqrt(4*zdepth*zdepth+(xwidth-xwidth2)*(xwidth-xwidth2));

this_box_storage.normal_vectors[2] = coords_set(x_component,0,z_component);
this_box_storage.normal_vectors[3] = coords_set(-x_component,0,z_component);

// for sides with x component = 0
y_component = 2*zdepth/sqrt((yheight-yheight2)*(yheight-yheight2)+4*zdepth*zdepth);
z_component = (yheight-yheight2)/sqrt(4*zdepth*zdepth+(yheight-yheight2)*(yheight-yheight2));

this_box_storage.normal_vectors[4] = coords_set(0,y_component,z_component);
this_box_storage.normal_vectors[5] = coords_set(0,-y_component,z_component);

this_box_volume.geometry.visualization_on = visualize;

this_box_volume.geometry.geometry_parameters.p_box_storage = &this_box_storage;

// Assign pointers to functions for intersection with the shape, checking if a point is inside the shape
if (this_box_storage.is_rectangle == 1) {
this_box_volume.geometry.intersect_function = &sample_box_intersect_simple;
this_box_volume.geometry.within_function = &r_within_box_simple;
}
else {
this_box_volume.geometry.intersect_function = &sample_box_intersect_advanced;
this_box_volume.geometry.within_function = &r_within_box_advanced;
}

this_box_volume.geometry.shell_points = &box_shell_points;
this_box_volume.geometry.mcdisplay_function = &mcdisplay_box_function;
this_box_volume.geometry.initialize_from_main_function = &initialize_box_geometry_from_main_component;
this_box_volume.geometry.process_rot_allocated = 0;

this_box_volume.geometry.copy_geometry_parameters = &allocate_box_storage_copy;

rot_copy(this_box_volume.geometry.rotation_matrix,ROT_A_CURRENT_COMP); //check how ROT_R_CURRENT_COMP would work
rot_transpose(ROT_A_CURRENT_COMP,this_box_volume.geometry.transpose_rotation_matrix);

// Initialize loggers
this_box_volume.loggers.num_elements = 0;

// packing the information into the global_geometry_element, which is then included in the global_geometry_list.
sprintf(global_geometry_element.name,NAME_CURRENT_COMP);
global_geometry_element.activation_counter = number_of_activations;
global_geometry_element.component_index = INDEX_CURRENT_COMP;
global_geometry_element.Volume = &this_box_volume; // Would be nicer if this m was a pointer, now we have the (small) data two places
add_element_to_geometry_list(&global_geometry_list,global_geometry_element);
}
#line 319886 "MACS_sample_kidney_box.c"
#undef number_of_activations
#undef mask_setting
#undef mask_string
#undef p_interact
#undef focus_r
#undef focus_xh
#undef focus_xw
#undef focus_ah
#undef focus_aw
#undef target_z
#undef target_y
#undef target_x
#undef target_index
#undef visualize
#undef yheight2
#undef xwidth2
#undef zdepth
#undef yheight
#undef xwidth
#undef priority
#undef material_string
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

  /* Initializations for component channel_17_analyzer_2_array_crystal_array_8. */
  SIG_MESSAGE("channel_17_analyzer_2_array_crystal_array_8 (Init)");
#define mccompcurname  channel_17_analyzer_2_array_crystal_array_8
#define mccompcurtype  Union_box
#define mccompcurindex 795
#define loop_index mccchannel_17_analyzer_2_array_crystal_array_8_loop_index
#define this_box_volume mccchannel_17_analyzer_2_array_crystal_array_8_this_box_volume
#define global_geometry_element mccchannel_17_analyzer_2_array_crystal_array_8_global_geometry_element
#define this_box_storage mccchannel_17_analyzer_2_array_crystal_array_8_this_box_storage
#define material_string mccchannel_17_analyzer_2_array_crystal_array_8_material_string
#define priority mccchannel_17_analyzer_2_array_crystal_array_8_priority
#define xwidth mccchannel_17_analyzer_2_array_crystal_array_8_xwidth
#define yheight mccchannel_17_analyzer_2_array_crystal_array_8_yheight
#define zdepth mccchannel_17_analyzer_2_array_crystal_array_8_zdepth
#define xwidth2 mccchannel_17_analyzer_2_array_crystal_array_8_xwidth2
#define yheight2 mccchannel_17_analyzer_2_array_crystal_array_8_yheight2
#define visualize mccchannel_17_analyzer_2_array_crystal_array_8_visualize
#define target_index mccchannel_17_analyzer_2_array_crystal_array_8_target_index
#define target_x mccchannel_17_analyzer_2_array_crystal_array_8_target_x
#define target_y mccchannel_17_analyzer_2_array_crystal_array_8_target_y
#define target_z mccchannel_17_analyzer_2_array_crystal_array_8_target_z
#define focus_aw mccchannel_17_analyzer_2_array_crystal_array_8_focus_aw
#define focus_ah mccchannel_17_analyzer_2_array_crystal_array_8_focus_ah
#define focus_xw mccchannel_17_analyzer_2_array_crystal_array_8_focus_xw
#define focus_xh mccchannel_17_analyzer_2_array_crystal_array_8_focus_xh
#define focus_r mccchannel_17_analyzer_2_array_crystal_array_8_focus_r
#define p_interact mccchannel_17_analyzer_2_array_crystal_array_8_p_interact
#define mask_string mccchannel_17_analyzer_2_array_crystal_array_8_mask_string
#define mask_setting mccchannel_17_analyzer_2_array_crystal_array_8_mask_setting
#define number_of_activations mccchannel_17_analyzer_2_array_crystal_array_8_number_of_activations
#line 224 "Union_box.comp"
{
// Initializes the focusing system for this volume including input sanitation.
focus_initialize(&this_box_volume.geometry, POS_A_COMP_INDEX(INDEX_CURRENT_COMP+target_index), POS_A_CURRENT_COMP, ROT_A_CURRENT_COMP, target_index, target_x, target_y, target_z, focus_aw, focus_ah, focus_xw, focus_xh, focus_r, NAME_CURRENT_COMP);

// Input sanitation for this geometry
if (xwidth <= 0) {
  printf("\nERROR in Union_box named %s, the xwidth is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (yheight <= 0) {
  printf("\nERROR in Union_box named %s, yheight is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (zdepth <= 0) {
  printf("\nERROR in Union_box named %s, zdepth is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (xwidth2 <= 0 && xwidth2 != -1) {
  printf("\nERROR in Union_box named %s, the xwidth2 is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (yheight2 <= 0 && yheight2 != -1) {
  printf("\nERROR in Union_box named %s, yheight2 is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}

// Use sanitation
if (global_material_list.num_elements == 0) {
  printf("\nERROR: Need to define a material using Union_make_material before using a Union geometry component. \n");
  printf("       %s was defined before first use of Union_make_material.\n",NAME_CURRENT_COMP);
  exit(1);
}

this_box_volume.geometry.is_masked_volume = 0;
this_box_volume.geometry.is_exit_volume = 0;
this_box_volume.geometry.is_mask_volume = 0;
// check if the volume is a mask, if it is the material string is irelevant.
if (mask_string && strlen(mask_string) && strcmp(mask_string, "NULL") && strcmp(mask_string, "0")) {
    // A mask volume is used to limit the extend of other volumes, called the masked volumes. These are specified in the mask_string.
    // In order for a ray to enter a masked volume, it needs to be both in the region covered by that volume AND the mask volume.
    // When more than
    this_box_volume.geometry.mask_mode = 1; // Default is mask mode is ALL
    if (mask_setting && strlen(mask_setting) && strcmp(mask_setting, "NULL") && strcmp(mask_setting, "0")) {
        if (strcmp(mask_setting,"ALL") == 0 || strcmp(mask_setting,"All") == 0) this_box_volume.geometry.mask_mode = 1;
        else if (strcmp(mask_setting,"ANY") == 0 || strcmp(mask_setting,"Any") == 0) this_box_volume.geometry.mask_mode = 2;
        else {
            printf("The mask_mode of component %s is set to %s, but must be either ALL or ANY.\n",NAME_CURRENT_COMP,mask_setting);
            exit(1);
        }
    }
    
    for (loop_index=0;loop_index<global_geometry_list.num_elements;loop_index++) {
        // Add mask list
        if (1 == manual_linking_function(global_geometry_list.elements[loop_index].name,mask_string)) {
            add_element_to_int_list(&this_box_volume.geometry.mask_list,global_geometry_list.elements[loop_index].component_index);
            add_element_to_int_list(&global_geometry_list.elements[loop_index].Volume->geometry.masked_by_list,INDEX_CURRENT_COMP);
            global_geometry_list.elements[loop_index].Volume->geometry.is_masked_volume = 1;
            if (this_box_volume.geometry.mask_mode == 2)
                global_geometry_list.elements[loop_index].Volume->geometry.mask_mode = 2;
            if (this_box_volume.geometry.mask_mode == 1) {
                if (global_geometry_list.elements[loop_index].Volume->geometry.is_masked_volume == 1 && global_geometry_list.elements[loop_index].Volume->geometry.mask_mode != 2)
                    // If more than one mask is added to one volume, the ANY mode overwrites the (default) ALL mode.
                    global_geometry_list.elements[loop_index].Volume->geometry.mask_mode = 1;
            }
            
            found_geometries = 1;
        }
    }
    if (found_geometries == 0) {
        printf("The mask_string in geometry: %s did not find any of the specified volumes in the mask_string %s \n",NAME_CURRENT_COMP,mask_string);
        exit(1);
    }
    this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
    this_box_volume.p_physics->is_vacuum = 0; // Makes this volume a vacuum
    this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
    this_box_volume.p_physics->my_a = 0; // Should not be used.
    sprintf(this_box_volume.p_physics->name,"Mask");
    this_box_volume.geometry.is_mask_volume = 1;
    
    
// Read the material input, or if it lacks, use automatic linking.
} else if (material_string && strlen(material_string) && strcmp(material_string, "NULL") && strcmp(material_string, "0")) {
    // A geometry string was given, use it to determine which material
    if (0 == strcmp(material_string,"vacuum") || 0 == strcmp(material_string,"Vacuum")) {
        // One could have a global physics struct for vacuum instead of creating one for each
        this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
        this_box_volume.p_physics->is_vacuum = 1; // Makes this volume a vacuum
        this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
        this_box_volume.p_physics->my_a = 0; // Should not be used.
        sprintf(this_box_volume.p_physics->name,"Vacuum");
    } else if (0 == strcmp(material_string,"exit") || 0 == strcmp(material_string,"Exit")) {
        // One could have a global physics struct for vacuum instead of creating one for each
        this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
        this_box_volume.p_physics->is_vacuum = 1; // Makes this volume a vacuum
        this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
        this_box_volume.p_physics->my_a = 0; // Should not be used.
        this_box_volume.geometry.is_exit_volume = 1;
        sprintf(this_box_volume.p_physics->name,"Exit");
    } else {
        #ifndef MATERIAL_DETECTOR
            printf("Need to define a material before refering to it in a geometry %s.\n",NAME_CURRENT_COMP);
            exit(1);
        #endif
        for (loop_index=0;loop_index<global_material_list.num_elements;loop_index++) {
            if (0 == strcmp(material_string,global_material_list.elements[loop_index].name)) {
                this_box_volume.p_physics = global_material_list.elements[loop_index].physics;
                break;
            }
            if (loop_index == global_material_list.num_elements-1) {
            printf("\n");
            printf("ERROR: The material string \"%s\" in Union geometry \"%s\" did not match a specified material. \n",material_string,NAME_CURRENT_COMP);
            printf("       The materials available at this point (need to be defined before the geometry): \n");
            for (loop_index=0;loop_index<global_material_list.num_elements;loop_index++)
              printf("         %s\n",global_material_list.elements[loop_index].name);
            printf("\n");
            printf("       It is also possible to use one of the defualt materials avaiable: \n");
            printf("           Vacuum (for a Volume without scattering or absorption)\n");
            printf("           Exit (for a Volume where the ray exits the component if it enters)\n");
            printf("           Mask (for a Volume that masks existing volumes specified in the mask_string\n");
            exit(1);
          }
        }
    }
} else {
    // Automatic linking, simply using the last defined material.
    #ifndef MATERIAL_DETECTOR
        printf("Need to define a material before the geometry to use automatic linking %s.\n",NAME_CURRENT_COMP);
        exit(1);
    #endif
    this_box_volume.p_physics = global_material_list.elements[global_material_list.num_elements-1].physics;
}

sprintf(this_box_volume.name,NAME_CURRENT_COMP);
sprintf(this_box_volume.geometry.shape,"box");
this_box_volume.geometry.priority_value = priority;
this_box_volume.geometry.geometry_p_interact = p_interact;
// Currently the coordinates will be in absolute space.
this_box_volume.geometry.center = POS_A_CURRENT_COMP;

this_box_storage.z_depth = zdepth;
this_box_storage.x_width1 = xwidth;
this_box_storage.y_height1 = yheight;

this_box_storage.is_rectangle = 0;
if (xwidth2 < 0 && yheight2 < 0) this_box_storage.is_rectangle = 1;
if (xwidth == xwidth2 && yheight == yheight2) this_box_storage.is_rectangle = 1;

if (xwidth2 < 0) {
    this_box_storage.x_width2 = xwidth;
    xwidth2 = xwidth;
} else this_box_storage.x_width2 = xwidth2;

if (yheight2 < 0) {
    this_box_storage.y_height2 = yheight;
    yheight2 = yheight;
} else this_box_storage.y_height2 = yheight2;


this_box_storage.normal_vectors[0] = coords_set(0,0,1);
this_box_storage.normal_vectors[1] = coords_set(0,0,1);

// for sides with y component = 0
x_component = 2*zdepth/sqrt((xwidth-xwidth2)*(xwidth-xwidth2)+4*zdepth*zdepth);
z_component = (xwidth-xwidth2)/sqrt(4*zdepth*zdepth+(xwidth-xwidth2)*(xwidth-xwidth2));

this_box_storage.normal_vectors[2] = coords_set(x_component,0,z_component);
this_box_storage.normal_vectors[3] = coords_set(-x_component,0,z_component);

// for sides with x component = 0
y_component = 2*zdepth/sqrt((yheight-yheight2)*(yheight-yheight2)+4*zdepth*zdepth);
z_component = (yheight-yheight2)/sqrt(4*zdepth*zdepth+(yheight-yheight2)*(yheight-yheight2));

this_box_storage.normal_vectors[4] = coords_set(0,y_component,z_component);
this_box_storage.normal_vectors[5] = coords_set(0,-y_component,z_component);

this_box_volume.geometry.visualization_on = visualize;

this_box_volume.geometry.geometry_parameters.p_box_storage = &this_box_storage;

// Assign pointers to functions for intersection with the shape, checking if a point is inside the shape
if (this_box_storage.is_rectangle == 1) {
this_box_volume.geometry.intersect_function = &sample_box_intersect_simple;
this_box_volume.geometry.within_function = &r_within_box_simple;
}
else {
this_box_volume.geometry.intersect_function = &sample_box_intersect_advanced;
this_box_volume.geometry.within_function = &r_within_box_advanced;
}

this_box_volume.geometry.shell_points = &box_shell_points;
this_box_volume.geometry.mcdisplay_function = &mcdisplay_box_function;
this_box_volume.geometry.initialize_from_main_function = &initialize_box_geometry_from_main_component;
this_box_volume.geometry.process_rot_allocated = 0;

this_box_volume.geometry.copy_geometry_parameters = &allocate_box_storage_copy;

rot_copy(this_box_volume.geometry.rotation_matrix,ROT_A_CURRENT_COMP); //check how ROT_R_CURRENT_COMP would work
rot_transpose(ROT_A_CURRENT_COMP,this_box_volume.geometry.transpose_rotation_matrix);

// Initialize loggers
this_box_volume.loggers.num_elements = 0;

// packing the information into the global_geometry_element, which is then included in the global_geometry_list.
sprintf(global_geometry_element.name,NAME_CURRENT_COMP);
global_geometry_element.activation_counter = number_of_activations;
global_geometry_element.component_index = INDEX_CURRENT_COMP;
global_geometry_element.Volume = &this_box_volume; // Would be nicer if this m was a pointer, now we have the (small) data two places
add_element_to_geometry_list(&global_geometry_list,global_geometry_element);
}
#line 320156 "MACS_sample_kidney_box.c"
#undef number_of_activations
#undef mask_setting
#undef mask_string
#undef p_interact
#undef focus_r
#undef focus_xh
#undef focus_xw
#undef focus_ah
#undef focus_aw
#undef target_z
#undef target_y
#undef target_x
#undef target_index
#undef visualize
#undef yheight2
#undef xwidth2
#undef zdepth
#undef yheight
#undef xwidth
#undef priority
#undef material_string
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

  /* Initializations for component channel_17_cave2_cyl1. */
  SIG_MESSAGE("channel_17_cave2_cyl1 (Init)");
#define mccompcurname  channel_17_cave2_cyl1
#define mccompcurtype  Union_cylinder
#define mccompcurindex 796
#define loop_index mccchannel_17_cave2_cyl1_loop_index
#define this_cylinder_volume mccchannel_17_cave2_cyl1_this_cylinder_volume
#define global_geometry_element mccchannel_17_cave2_cyl1_global_geometry_element
#define this_cylinder_storage mccchannel_17_cave2_cyl1_this_cylinder_storage
#define material_string mccchannel_17_cave2_cyl1_material_string
#define priority mccchannel_17_cave2_cyl1_priority
#define radius mccchannel_17_cave2_cyl1_radius
#define yheight mccchannel_17_cave2_cyl1_yheight
#define visualize mccchannel_17_cave2_cyl1_visualize
#define target_index mccchannel_17_cave2_cyl1_target_index
#define target_x mccchannel_17_cave2_cyl1_target_x
#define target_y mccchannel_17_cave2_cyl1_target_y
#define target_z mccchannel_17_cave2_cyl1_target_z
#define focus_aw mccchannel_17_cave2_cyl1_focus_aw
#define focus_ah mccchannel_17_cave2_cyl1_focus_ah
#define focus_xw mccchannel_17_cave2_cyl1_focus_xw
#define focus_xh mccchannel_17_cave2_cyl1_focus_xh
#define focus_r mccchannel_17_cave2_cyl1_focus_r
#define p_interact mccchannel_17_cave2_cyl1_p_interact
#define mask_string mccchannel_17_cave2_cyl1_mask_string
#define mask_setting mccchannel_17_cave2_cyl1_mask_setting
#define number_of_activations mccchannel_17_cave2_cyl1_number_of_activations
#line 185 "Union_cylinder.comp"
{
// Initializes the focusing system for this volume including input sanitation.
focus_initialize(&this_cylinder_volume.geometry, POS_A_COMP_INDEX(INDEX_CURRENT_COMP+target_index), POS_A_CURRENT_COMP, ROT_A_CURRENT_COMP, target_index, target_x, target_y, target_z, focus_aw, focus_ah, focus_xw, focus_xh, focus_r, NAME_CURRENT_COMP);

// Input sanitation for this geometry
if (radius <= 0) {
  printf("\nERROR in Union_cylinder named %s, the radius is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}

if (yheight <= 0) {
  printf("\nERROR in Union_cylinder named %s, yheight is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}

// Use sanitation
#ifdef MATERIAL_DETECTOR
if (global_material_list.num_elements == 0) {
  // Here if the user have defined a material, but only after this material
  printf("\nERROR: Need to define a material using Union_make_material before using a Union geometry component. \n");
  printf("       %s was defined before first use of Union_make_material.\n",NAME_CURRENT_COMP);
  exit(1);
}
#endif
#ifndef MATERIAL_DETECTOR
  printf("\nERROR: Need to define a material using Union_make_material before using a Union geometry component. \n");
  exit(1);
#endif


this_cylinder_volume.geometry.is_masked_volume = 0;
this_cylinder_volume.geometry.is_exit_volume = 0;
this_cylinder_volume.geometry.is_mask_volume = 0;

// Read the material input, or if it lacks, use automatic linking.
if (mask_string && strlen(mask_string) && strcmp(mask_string, "NULL") && strcmp(mask_string, "0")) {
    // A mask volume is used to limit the extend of other volumes, called the masked volumes. These are specified in the mask_string.
    // In order for a ray to enter a masked volume, it needs to be both in the region covered by that volume AND the mask volume.
    // When more than
    this_cylinder_volume.geometry.mask_mode = 1; // Default is mask mode is ALL
    if (mask_setting && strlen(mask_setting) && strcmp(mask_setting, "NULL") && strcmp(mask_setting, "0")) {
        if (strcmp(mask_setting,"ALL") == 0 || strcmp(mask_setting,"All") == 0) this_cylinder_volume.geometry.mask_mode = 1;
        else if (strcmp(mask_setting,"ANY") == 0 || strcmp(mask_setting,"Any") == 0) this_cylinder_volume.geometry.mask_mode = 2;
        else {
            printf("The mask_mode of component %s is set to %s, but must be either ALL or ANY.\n",NAME_CURRENT_COMP,mask_setting);
            exit(1);
        }
    }
    
    for (loop_index=0;loop_index<global_geometry_list.num_elements;loop_index++) {
        // Add mask list
        if (1 == manual_linking_function(global_geometry_list.elements[loop_index].name,mask_string)) {
            add_element_to_int_list(&this_cylinder_volume.geometry.mask_list,global_geometry_list.elements[loop_index].component_index);
            add_element_to_int_list(&global_geometry_list.elements[loop_index].Volume->geometry.masked_by_list,INDEX_CURRENT_COMP);
            global_geometry_list.elements[loop_index].Volume->geometry.is_masked_volume = 1;
            if (this_cylinder_volume.geometry.mask_mode == 2)
                global_geometry_list.elements[loop_index].Volume->geometry.mask_mode = 2;
            if (this_cylinder_volume.geometry.mask_mode == 1) {
                if (global_geometry_list.elements[loop_index].Volume->geometry.is_masked_volume == 1 && global_geometry_list.elements[loop_index].Volume->geometry.mask_mode != 2)
                    // If more than one mask is added to one volume, the ANY mode overwrites the (default) ALL mode.
                    global_geometry_list.elements[loop_index].Volume->geometry.mask_mode = 1;
            }
            
            found_geometries = 1;
        }
    }
    if (found_geometries == 0) {
        printf("The mask_string in geometry: %s did not find any of the specified volumes in the mask_string %s \n",NAME_CURRENT_COMP,mask_string);
        exit(1);
    }
    this_cylinder_volume.p_physics = malloc(sizeof(struct physics_struct));
    this_cylinder_volume.p_physics->is_vacuum = 0; // Makes this volume a vacuum
    this_cylinder_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
    this_cylinder_volume.p_physics->my_a = 0; // Should not be used.
    sprintf(this_cylinder_volume.p_physics->name,"Mask");
    this_cylinder_volume.geometry.is_mask_volume = 1;
    
    
// Read the material input, or if it lacks, use automatic linking.
} else if (material_string && strlen(material_string) && strcmp(material_string, "NULL") && strcmp(material_string, "0")) {
    // A geometry string was given, use it to determine which material
    if (0 == strcmp(material_string,"vacuum") || 0 == strcmp(material_string,"Vacuum")) {
        // One could have a global physics struct for vacuum instead of creating one for each
        this_cylinder_volume.p_physics = malloc(sizeof(struct physics_struct));
        this_cylinder_volume.p_physics->is_vacuum = 1; // Makes this volume a vacuum
        this_cylinder_volume.p_physics->number_of_processes = (int) 0;
        this_cylinder_volume.p_physics->my_a = 0; // Should not be used.
        sprintf(this_cylinder_volume.p_physics->name,"Vacuum");
    } else if (0 == strcmp(material_string,"exit") || 0 == strcmp(material_string,"Exit")) {
        // One could have a global physics struct for exit instead of creating one for each
        this_cylinder_volume.p_physics = malloc(sizeof(struct physics_struct));
        this_cylinder_volume.p_physics->is_vacuum = 1; // Makes this volume a vacuum
        this_cylinder_volume.p_physics->number_of_processes = (int) 0;
        this_cylinder_volume.p_physics->my_a = 0; // Should not be used.
        this_cylinder_volume.geometry.is_exit_volume = 1;
        sprintf(this_cylinder_volume.p_physics->name,"Exit");
    } else {
        for (loop_index=0;loop_index<global_material_list.num_elements;loop_index++) {
          if (0 == strcmp(material_string,global_material_list.elements[loop_index].name)) {
            this_cylinder_volume.p_physics = global_material_list.elements[loop_index].physics;
            break;
          }
          if (loop_index == global_material_list.num_elements-1) {
            printf("\n");
            printf("ERROR: The material string \"%s\" in Union geometry \"%s\" did not match a specified material. \n",material_string,NAME_CURRENT_COMP);
            printf("       The materials available at this point (need to be defined before the geometry): \n");
            for (loop_index=0;loop_index<global_material_list.num_elements;loop_index++)
              printf("         %s\n",global_material_list.elements[loop_index].name);
            printf("\n");
            printf("       It is also possible to use one of the defualt materials avaiable: \n");
            printf("           Vacuum (for a Volume without scattering or absorption)\n");
            printf("           Exit (for a Volume where the ray exits the component if it enters)\n");
            printf("           Mask (for a Volume that masks existing volumes specified in the mask_string\n");
            exit(1);
          }
        }
    }
} else {
    // Automatic linking, simply using the last defined material.
    #ifndef MATERIAL_DETECTOR
        printf("Need to define a material before the geometry to use automatic linking %s.\n",NAME_CURRENT_COMP);
        exit(1);
    #endif
    this_cylinder_volume.p_physics = global_material_list.elements[global_material_list.num_elements-1].physics;
}

sprintf(this_cylinder_volume.name,NAME_CURRENT_COMP);
sprintf(this_cylinder_volume.geometry.shape,"cylinder");
this_cylinder_volume.geometry.priority_value = priority;
// Currently the coordinates will be in absolute space.
this_cylinder_volume.geometry.center = POS_A_CURRENT_COMP;

this_cylinder_volume.geometry.geometry_p_interact = p_interact;
this_cylinder_storage.cyl_radius = radius;
this_cylinder_storage.height = yheight;
this_cylinder_volume.geometry.visualization_on = visualize;
this_cylinder_volume.geometry.geometry_parameters.p_cylinder_storage = &this_cylinder_storage;
this_cylinder_volume.geometry.within_function = &r_within_cylinder;
this_cylinder_volume.geometry.intersect_function = &sample_cylinder_intersect;
this_cylinder_volume.geometry.mcdisplay_function = &mcdisplay_cylinder_function;
this_cylinder_volume.geometry.shell_points = &cylinder_shell_points;
this_cylinder_volume.geometry.initialize_from_main_function = &initialize_cylinder_geometry_from_main_component;
this_cylinder_volume.geometry.process_rot_allocated = 0;
this_cylinder_volume.geometry.copy_geometry_parameters = &allocate_cylinder_storage_copy;

rot_copy(this_cylinder_volume.geometry.rotation_matrix,ROT_A_CURRENT_COMP);
rot_transpose(ROT_A_CURRENT_COMP,this_cylinder_volume.geometry.transpose_rotation_matrix);

// Initialize loggers
this_cylinder_volume.loggers.num_elements = 0;

// packing the information into the global_geometry_element, which is then included in the global_geometry_list.
sprintf(global_geometry_element.name,NAME_CURRENT_COMP);
global_geometry_element.activation_counter = number_of_activations;
global_geometry_element.component_index = INDEX_CURRENT_COMP;
global_geometry_element.Volume = &this_cylinder_volume; // Would be nicer if this m was a pointer, now we have the (small) data two places
add_element_to_geometry_list(&global_geometry_list,global_geometry_element);
}
#line 320372 "MACS_sample_kidney_box.c"
#undef number_of_activations
#undef mask_setting
#undef mask_string
#undef p_interact
#undef focus_r
#undef focus_xh
#undef focus_xw
#undef focus_ah
#undef focus_aw
#undef target_z
#undef target_y
#undef target_x
#undef target_index
#undef visualize
#undef yheight
#undef radius
#undef priority
#undef material_string
#undef this_cylinder_storage
#undef global_geometry_element
#undef this_cylinder_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

  /* Initializations for component channel_17_cave2_box1. */
  SIG_MESSAGE("channel_17_cave2_box1 (Init)");
#define mccompcurname  channel_17_cave2_box1
#define mccompcurtype  Union_box
#define mccompcurindex 797
#define loop_index mccchannel_17_cave2_box1_loop_index
#define this_box_volume mccchannel_17_cave2_box1_this_box_volume
#define global_geometry_element mccchannel_17_cave2_box1_global_geometry_element
#define this_box_storage mccchannel_17_cave2_box1_this_box_storage
#define material_string mccchannel_17_cave2_box1_material_string
#define priority mccchannel_17_cave2_box1_priority
#define xwidth mccchannel_17_cave2_box1_xwidth
#define yheight mccchannel_17_cave2_box1_yheight
#define zdepth mccchannel_17_cave2_box1_zdepth
#define xwidth2 mccchannel_17_cave2_box1_xwidth2
#define yheight2 mccchannel_17_cave2_box1_yheight2
#define visualize mccchannel_17_cave2_box1_visualize
#define target_index mccchannel_17_cave2_box1_target_index
#define target_x mccchannel_17_cave2_box1_target_x
#define target_y mccchannel_17_cave2_box1_target_y
#define target_z mccchannel_17_cave2_box1_target_z
#define focus_aw mccchannel_17_cave2_box1_focus_aw
#define focus_ah mccchannel_17_cave2_box1_focus_ah
#define focus_xw mccchannel_17_cave2_box1_focus_xw
#define focus_xh mccchannel_17_cave2_box1_focus_xh
#define focus_r mccchannel_17_cave2_box1_focus_r
#define p_interact mccchannel_17_cave2_box1_p_interact
#define mask_string mccchannel_17_cave2_box1_mask_string
#define mask_setting mccchannel_17_cave2_box1_mask_setting
#define number_of_activations mccchannel_17_cave2_box1_number_of_activations
#line 224 "Union_box.comp"
{
// Initializes the focusing system for this volume including input sanitation.
focus_initialize(&this_box_volume.geometry, POS_A_COMP_INDEX(INDEX_CURRENT_COMP+target_index), POS_A_CURRENT_COMP, ROT_A_CURRENT_COMP, target_index, target_x, target_y, target_z, focus_aw, focus_ah, focus_xw, focus_xh, focus_r, NAME_CURRENT_COMP);

// Input sanitation for this geometry
if (xwidth <= 0) {
  printf("\nERROR in Union_box named %s, the xwidth is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (yheight <= 0) {
  printf("\nERROR in Union_box named %s, yheight is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (zdepth <= 0) {
  printf("\nERROR in Union_box named %s, zdepth is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (xwidth2 <= 0 && xwidth2 != -1) {
  printf("\nERROR in Union_box named %s, the xwidth2 is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (yheight2 <= 0 && yheight2 != -1) {
  printf("\nERROR in Union_box named %s, yheight2 is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}

// Use sanitation
if (global_material_list.num_elements == 0) {
  printf("\nERROR: Need to define a material using Union_make_material before using a Union geometry component. \n");
  printf("       %s was defined before first use of Union_make_material.\n",NAME_CURRENT_COMP);
  exit(1);
}

this_box_volume.geometry.is_masked_volume = 0;
this_box_volume.geometry.is_exit_volume = 0;
this_box_volume.geometry.is_mask_volume = 0;
// check if the volume is a mask, if it is the material string is irelevant.
if (mask_string && strlen(mask_string) && strcmp(mask_string, "NULL") && strcmp(mask_string, "0")) {
    // A mask volume is used to limit the extend of other volumes, called the masked volumes. These are specified in the mask_string.
    // In order for a ray to enter a masked volume, it needs to be both in the region covered by that volume AND the mask volume.
    // When more than
    this_box_volume.geometry.mask_mode = 1; // Default is mask mode is ALL
    if (mask_setting && strlen(mask_setting) && strcmp(mask_setting, "NULL") && strcmp(mask_setting, "0")) {
        if (strcmp(mask_setting,"ALL") == 0 || strcmp(mask_setting,"All") == 0) this_box_volume.geometry.mask_mode = 1;
        else if (strcmp(mask_setting,"ANY") == 0 || strcmp(mask_setting,"Any") == 0) this_box_volume.geometry.mask_mode = 2;
        else {
            printf("The mask_mode of component %s is set to %s, but must be either ALL or ANY.\n",NAME_CURRENT_COMP,mask_setting);
            exit(1);
        }
    }
    
    for (loop_index=0;loop_index<global_geometry_list.num_elements;loop_index++) {
        // Add mask list
        if (1 == manual_linking_function(global_geometry_list.elements[loop_index].name,mask_string)) {
            add_element_to_int_list(&this_box_volume.geometry.mask_list,global_geometry_list.elements[loop_index].component_index);
            add_element_to_int_list(&global_geometry_list.elements[loop_index].Volume->geometry.masked_by_list,INDEX_CURRENT_COMP);
            global_geometry_list.elements[loop_index].Volume->geometry.is_masked_volume = 1;
            if (this_box_volume.geometry.mask_mode == 2)
                global_geometry_list.elements[loop_index].Volume->geometry.mask_mode = 2;
            if (this_box_volume.geometry.mask_mode == 1) {
                if (global_geometry_list.elements[loop_index].Volume->geometry.is_masked_volume == 1 && global_geometry_list.elements[loop_index].Volume->geometry.mask_mode != 2)
                    // If more than one mask is added to one volume, the ANY mode overwrites the (default) ALL mode.
                    global_geometry_list.elements[loop_index].Volume->geometry.mask_mode = 1;
            }
            
            found_geometries = 1;
        }
    }
    if (found_geometries == 0) {
        printf("The mask_string in geometry: %s did not find any of the specified volumes in the mask_string %s \n",NAME_CURRENT_COMP,mask_string);
        exit(1);
    }
    this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
    this_box_volume.p_physics->is_vacuum = 0; // Makes this volume a vacuum
    this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
    this_box_volume.p_physics->my_a = 0; // Should not be used.
    sprintf(this_box_volume.p_physics->name,"Mask");
    this_box_volume.geometry.is_mask_volume = 1;
    
    
// Read the material input, or if it lacks, use automatic linking.
} else if (material_string && strlen(material_string) && strcmp(material_string, "NULL") && strcmp(material_string, "0")) {
    // A geometry string was given, use it to determine which material
    if (0 == strcmp(material_string,"vacuum") || 0 == strcmp(material_string,"Vacuum")) {
        // One could have a global physics struct for vacuum instead of creating one for each
        this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
        this_box_volume.p_physics->is_vacuum = 1; // Makes this volume a vacuum
        this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
        this_box_volume.p_physics->my_a = 0; // Should not be used.
        sprintf(this_box_volume.p_physics->name,"Vacuum");
    } else if (0 == strcmp(material_string,"exit") || 0 == strcmp(material_string,"Exit")) {
        // One could have a global physics struct for vacuum instead of creating one for each
        this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
        this_box_volume.p_physics->is_vacuum = 1; // Makes this volume a vacuum
        this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
        this_box_volume.p_physics->my_a = 0; // Should not be used.
        this_box_volume.geometry.is_exit_volume = 1;
        sprintf(this_box_volume.p_physics->name,"Exit");
    } else {
        #ifndef MATERIAL_DETECTOR
            printf("Need to define a material before refering to it in a geometry %s.\n",NAME_CURRENT_COMP);
            exit(1);
        #endif
        for (loop_index=0;loop_index<global_material_list.num_elements;loop_index++) {
            if (0 == strcmp(material_string,global_material_list.elements[loop_index].name)) {
                this_box_volume.p_physics = global_material_list.elements[loop_index].physics;
                break;
            }
            if (loop_index == global_material_list.num_elements-1) {
            printf("\n");
            printf("ERROR: The material string \"%s\" in Union geometry \"%s\" did not match a specified material. \n",material_string,NAME_CURRENT_COMP);
            printf("       The materials available at this point (need to be defined before the geometry): \n");
            for (loop_index=0;loop_index<global_material_list.num_elements;loop_index++)
              printf("         %s\n",global_material_list.elements[loop_index].name);
            printf("\n");
            printf("       It is also possible to use one of the defualt materials avaiable: \n");
            printf("           Vacuum (for a Volume without scattering or absorption)\n");
            printf("           Exit (for a Volume where the ray exits the component if it enters)\n");
            printf("           Mask (for a Volume that masks existing volumes specified in the mask_string\n");
            exit(1);
          }
        }
    }
} else {
    // Automatic linking, simply using the last defined material.
    #ifndef MATERIAL_DETECTOR
        printf("Need to define a material before the geometry to use automatic linking %s.\n",NAME_CURRENT_COMP);
        exit(1);
    #endif
    this_box_volume.p_physics = global_material_list.elements[global_material_list.num_elements-1].physics;
}

sprintf(this_box_volume.name,NAME_CURRENT_COMP);
sprintf(this_box_volume.geometry.shape,"box");
this_box_volume.geometry.priority_value = priority;
this_box_volume.geometry.geometry_p_interact = p_interact;
// Currently the coordinates will be in absolute space.
this_box_volume.geometry.center = POS_A_CURRENT_COMP;

this_box_storage.z_depth = zdepth;
this_box_storage.x_width1 = xwidth;
this_box_storage.y_height1 = yheight;

this_box_storage.is_rectangle = 0;
if (xwidth2 < 0 && yheight2 < 0) this_box_storage.is_rectangle = 1;
if (xwidth == xwidth2 && yheight == yheight2) this_box_storage.is_rectangle = 1;

if (xwidth2 < 0) {
    this_box_storage.x_width2 = xwidth;
    xwidth2 = xwidth;
} else this_box_storage.x_width2 = xwidth2;

if (yheight2 < 0) {
    this_box_storage.y_height2 = yheight;
    yheight2 = yheight;
} else this_box_storage.y_height2 = yheight2;


this_box_storage.normal_vectors[0] = coords_set(0,0,1);
this_box_storage.normal_vectors[1] = coords_set(0,0,1);

// for sides with y component = 0
x_component = 2*zdepth/sqrt((xwidth-xwidth2)*(xwidth-xwidth2)+4*zdepth*zdepth);
z_component = (xwidth-xwidth2)/sqrt(4*zdepth*zdepth+(xwidth-xwidth2)*(xwidth-xwidth2));

this_box_storage.normal_vectors[2] = coords_set(x_component,0,z_component);
this_box_storage.normal_vectors[3] = coords_set(-x_component,0,z_component);

// for sides with x component = 0
y_component = 2*zdepth/sqrt((yheight-yheight2)*(yheight-yheight2)+4*zdepth*zdepth);
z_component = (yheight-yheight2)/sqrt(4*zdepth*zdepth+(yheight-yheight2)*(yheight-yheight2));

this_box_storage.normal_vectors[4] = coords_set(0,y_component,z_component);
this_box_storage.normal_vectors[5] = coords_set(0,-y_component,z_component);

this_box_volume.geometry.visualization_on = visualize;

this_box_volume.geometry.geometry_parameters.p_box_storage = &this_box_storage;

// Assign pointers to functions for intersection with the shape, checking if a point is inside the shape
if (this_box_storage.is_rectangle == 1) {
this_box_volume.geometry.intersect_function = &sample_box_intersect_simple;
this_box_volume.geometry.within_function = &r_within_box_simple;
}
else {
this_box_volume.geometry.intersect_function = &sample_box_intersect_advanced;
this_box_volume.geometry.within_function = &r_within_box_advanced;
}

this_box_volume.geometry.shell_points = &box_shell_points;
this_box_volume.geometry.mcdisplay_function = &mcdisplay_box_function;
this_box_volume.geometry.initialize_from_main_function = &initialize_box_geometry_from_main_component;
this_box_volume.geometry.process_rot_allocated = 0;

this_box_volume.geometry.copy_geometry_parameters = &allocate_box_storage_copy;

rot_copy(this_box_volume.geometry.rotation_matrix,ROT_A_CURRENT_COMP); //check how ROT_R_CURRENT_COMP would work
rot_transpose(ROT_A_CURRENT_COMP,this_box_volume.geometry.transpose_rotation_matrix);

// Initialize loggers
this_box_volume.loggers.num_elements = 0;

// packing the information into the global_geometry_element, which is then included in the global_geometry_list.
sprintf(global_geometry_element.name,NAME_CURRENT_COMP);
global_geometry_element.activation_counter = number_of_activations;
global_geometry_element.component_index = INDEX_CURRENT_COMP;
global_geometry_element.Volume = &this_box_volume; // Would be nicer if this m was a pointer, now we have the (small) data two places
add_element_to_geometry_list(&global_geometry_list,global_geometry_element);
}
#line 320639 "MACS_sample_kidney_box.c"
#undef number_of_activations
#undef mask_setting
#undef mask_string
#undef p_interact
#undef focus_r
#undef focus_xh
#undef focus_xw
#undef focus_ah
#undef focus_aw
#undef target_z
#undef target_y
#undef target_x
#undef target_index
#undef visualize
#undef yheight2
#undef xwidth2
#undef zdepth
#undef yheight
#undef xwidth
#undef priority
#undef material_string
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

  /* Initializations for component channel_17_cave2_box2. */
  SIG_MESSAGE("channel_17_cave2_box2 (Init)");
#define mccompcurname  channel_17_cave2_box2
#define mccompcurtype  Union_box
#define mccompcurindex 798
#define loop_index mccchannel_17_cave2_box2_loop_index
#define this_box_volume mccchannel_17_cave2_box2_this_box_volume
#define global_geometry_element mccchannel_17_cave2_box2_global_geometry_element
#define this_box_storage mccchannel_17_cave2_box2_this_box_storage
#define material_string mccchannel_17_cave2_box2_material_string
#define priority mccchannel_17_cave2_box2_priority
#define xwidth mccchannel_17_cave2_box2_xwidth
#define yheight mccchannel_17_cave2_box2_yheight
#define zdepth mccchannel_17_cave2_box2_zdepth
#define xwidth2 mccchannel_17_cave2_box2_xwidth2
#define yheight2 mccchannel_17_cave2_box2_yheight2
#define visualize mccchannel_17_cave2_box2_visualize
#define target_index mccchannel_17_cave2_box2_target_index
#define target_x mccchannel_17_cave2_box2_target_x
#define target_y mccchannel_17_cave2_box2_target_y
#define target_z mccchannel_17_cave2_box2_target_z
#define focus_aw mccchannel_17_cave2_box2_focus_aw
#define focus_ah mccchannel_17_cave2_box2_focus_ah
#define focus_xw mccchannel_17_cave2_box2_focus_xw
#define focus_xh mccchannel_17_cave2_box2_focus_xh
#define focus_r mccchannel_17_cave2_box2_focus_r
#define p_interact mccchannel_17_cave2_box2_p_interact
#define mask_string mccchannel_17_cave2_box2_mask_string
#define mask_setting mccchannel_17_cave2_box2_mask_setting
#define number_of_activations mccchannel_17_cave2_box2_number_of_activations
#line 224 "Union_box.comp"
{
// Initializes the focusing system for this volume including input sanitation.
focus_initialize(&this_box_volume.geometry, POS_A_COMP_INDEX(INDEX_CURRENT_COMP+target_index), POS_A_CURRENT_COMP, ROT_A_CURRENT_COMP, target_index, target_x, target_y, target_z, focus_aw, focus_ah, focus_xw, focus_xh, focus_r, NAME_CURRENT_COMP);

// Input sanitation for this geometry
if (xwidth <= 0) {
  printf("\nERROR in Union_box named %s, the xwidth is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (yheight <= 0) {
  printf("\nERROR in Union_box named %s, yheight is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (zdepth <= 0) {
  printf("\nERROR in Union_box named %s, zdepth is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (xwidth2 <= 0 && xwidth2 != -1) {
  printf("\nERROR in Union_box named %s, the xwidth2 is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (yheight2 <= 0 && yheight2 != -1) {
  printf("\nERROR in Union_box named %s, yheight2 is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}

// Use sanitation
if (global_material_list.num_elements == 0) {
  printf("\nERROR: Need to define a material using Union_make_material before using a Union geometry component. \n");
  printf("       %s was defined before first use of Union_make_material.\n",NAME_CURRENT_COMP);
  exit(1);
}

this_box_volume.geometry.is_masked_volume = 0;
this_box_volume.geometry.is_exit_volume = 0;
this_box_volume.geometry.is_mask_volume = 0;
// check if the volume is a mask, if it is the material string is irelevant.
if (mask_string && strlen(mask_string) && strcmp(mask_string, "NULL") && strcmp(mask_string, "0")) {
    // A mask volume is used to limit the extend of other volumes, called the masked volumes. These are specified in the mask_string.
    // In order for a ray to enter a masked volume, it needs to be both in the region covered by that volume AND the mask volume.
    // When more than
    this_box_volume.geometry.mask_mode = 1; // Default is mask mode is ALL
    if (mask_setting && strlen(mask_setting) && strcmp(mask_setting, "NULL") && strcmp(mask_setting, "0")) {
        if (strcmp(mask_setting,"ALL") == 0 || strcmp(mask_setting,"All") == 0) this_box_volume.geometry.mask_mode = 1;
        else if (strcmp(mask_setting,"ANY") == 0 || strcmp(mask_setting,"Any") == 0) this_box_volume.geometry.mask_mode = 2;
        else {
            printf("The mask_mode of component %s is set to %s, but must be either ALL or ANY.\n",NAME_CURRENT_COMP,mask_setting);
            exit(1);
        }
    }
    
    for (loop_index=0;loop_index<global_geometry_list.num_elements;loop_index++) {
        // Add mask list
        if (1 == manual_linking_function(global_geometry_list.elements[loop_index].name,mask_string)) {
            add_element_to_int_list(&this_box_volume.geometry.mask_list,global_geometry_list.elements[loop_index].component_index);
            add_element_to_int_list(&global_geometry_list.elements[loop_index].Volume->geometry.masked_by_list,INDEX_CURRENT_COMP);
            global_geometry_list.elements[loop_index].Volume->geometry.is_masked_volume = 1;
            if (this_box_volume.geometry.mask_mode == 2)
                global_geometry_list.elements[loop_index].Volume->geometry.mask_mode = 2;
            if (this_box_volume.geometry.mask_mode == 1) {
                if (global_geometry_list.elements[loop_index].Volume->geometry.is_masked_volume == 1 && global_geometry_list.elements[loop_index].Volume->geometry.mask_mode != 2)
                    // If more than one mask is added to one volume, the ANY mode overwrites the (default) ALL mode.
                    global_geometry_list.elements[loop_index].Volume->geometry.mask_mode = 1;
            }
            
            found_geometries = 1;
        }
    }
    if (found_geometries == 0) {
        printf("The mask_string in geometry: %s did not find any of the specified volumes in the mask_string %s \n",NAME_CURRENT_COMP,mask_string);
        exit(1);
    }
    this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
    this_box_volume.p_physics->is_vacuum = 0; // Makes this volume a vacuum
    this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
    this_box_volume.p_physics->my_a = 0; // Should not be used.
    sprintf(this_box_volume.p_physics->name,"Mask");
    this_box_volume.geometry.is_mask_volume = 1;
    
    
// Read the material input, or if it lacks, use automatic linking.
} else if (material_string && strlen(material_string) && strcmp(material_string, "NULL") && strcmp(material_string, "0")) {
    // A geometry string was given, use it to determine which material
    if (0 == strcmp(material_string,"vacuum") || 0 == strcmp(material_string,"Vacuum")) {
        // One could have a global physics struct for vacuum instead of creating one for each
        this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
        this_box_volume.p_physics->is_vacuum = 1; // Makes this volume a vacuum
        this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
        this_box_volume.p_physics->my_a = 0; // Should not be used.
        sprintf(this_box_volume.p_physics->name,"Vacuum");
    } else if (0 == strcmp(material_string,"exit") || 0 == strcmp(material_string,"Exit")) {
        // One could have a global physics struct for vacuum instead of creating one for each
        this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
        this_box_volume.p_physics->is_vacuum = 1; // Makes this volume a vacuum
        this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
        this_box_volume.p_physics->my_a = 0; // Should not be used.
        this_box_volume.geometry.is_exit_volume = 1;
        sprintf(this_box_volume.p_physics->name,"Exit");
    } else {
        #ifndef MATERIAL_DETECTOR
            printf("Need to define a material before refering to it in a geometry %s.\n",NAME_CURRENT_COMP);
            exit(1);
        #endif
        for (loop_index=0;loop_index<global_material_list.num_elements;loop_index++) {
            if (0 == strcmp(material_string,global_material_list.elements[loop_index].name)) {
                this_box_volume.p_physics = global_material_list.elements[loop_index].physics;
                break;
            }
            if (loop_index == global_material_list.num_elements-1) {
            printf("\n");
            printf("ERROR: The material string \"%s\" in Union geometry \"%s\" did not match a specified material. \n",material_string,NAME_CURRENT_COMP);
            printf("       The materials available at this point (need to be defined before the geometry): \n");
            for (loop_index=0;loop_index<global_material_list.num_elements;loop_index++)
              printf("         %s\n",global_material_list.elements[loop_index].name);
            printf("\n");
            printf("       It is also possible to use one of the defualt materials avaiable: \n");
            printf("           Vacuum (for a Volume without scattering or absorption)\n");
            printf("           Exit (for a Volume where the ray exits the component if it enters)\n");
            printf("           Mask (for a Volume that masks existing volumes specified in the mask_string\n");
            exit(1);
          }
        }
    }
} else {
    // Automatic linking, simply using the last defined material.
    #ifndef MATERIAL_DETECTOR
        printf("Need to define a material before the geometry to use automatic linking %s.\n",NAME_CURRENT_COMP);
        exit(1);
    #endif
    this_box_volume.p_physics = global_material_list.elements[global_material_list.num_elements-1].physics;
}

sprintf(this_box_volume.name,NAME_CURRENT_COMP);
sprintf(this_box_volume.geometry.shape,"box");
this_box_volume.geometry.priority_value = priority;
this_box_volume.geometry.geometry_p_interact = p_interact;
// Currently the coordinates will be in absolute space.
this_box_volume.geometry.center = POS_A_CURRENT_COMP;

this_box_storage.z_depth = zdepth;
this_box_storage.x_width1 = xwidth;
this_box_storage.y_height1 = yheight;

this_box_storage.is_rectangle = 0;
if (xwidth2 < 0 && yheight2 < 0) this_box_storage.is_rectangle = 1;
if (xwidth == xwidth2 && yheight == yheight2) this_box_storage.is_rectangle = 1;

if (xwidth2 < 0) {
    this_box_storage.x_width2 = xwidth;
    xwidth2 = xwidth;
} else this_box_storage.x_width2 = xwidth2;

if (yheight2 < 0) {
    this_box_storage.y_height2 = yheight;
    yheight2 = yheight;
} else this_box_storage.y_height2 = yheight2;


this_box_storage.normal_vectors[0] = coords_set(0,0,1);
this_box_storage.normal_vectors[1] = coords_set(0,0,1);

// for sides with y component = 0
x_component = 2*zdepth/sqrt((xwidth-xwidth2)*(xwidth-xwidth2)+4*zdepth*zdepth);
z_component = (xwidth-xwidth2)/sqrt(4*zdepth*zdepth+(xwidth-xwidth2)*(xwidth-xwidth2));

this_box_storage.normal_vectors[2] = coords_set(x_component,0,z_component);
this_box_storage.normal_vectors[3] = coords_set(-x_component,0,z_component);

// for sides with x component = 0
y_component = 2*zdepth/sqrt((yheight-yheight2)*(yheight-yheight2)+4*zdepth*zdepth);
z_component = (yheight-yheight2)/sqrt(4*zdepth*zdepth+(yheight-yheight2)*(yheight-yheight2));

this_box_storage.normal_vectors[4] = coords_set(0,y_component,z_component);
this_box_storage.normal_vectors[5] = coords_set(0,-y_component,z_component);

this_box_volume.geometry.visualization_on = visualize;

this_box_volume.geometry.geometry_parameters.p_box_storage = &this_box_storage;

// Assign pointers to functions for intersection with the shape, checking if a point is inside the shape
if (this_box_storage.is_rectangle == 1) {
this_box_volume.geometry.intersect_function = &sample_box_intersect_simple;
this_box_volume.geometry.within_function = &r_within_box_simple;
}
else {
this_box_volume.geometry.intersect_function = &sample_box_intersect_advanced;
this_box_volume.geometry.within_function = &r_within_box_advanced;
}

this_box_volume.geometry.shell_points = &box_shell_points;
this_box_volume.geometry.mcdisplay_function = &mcdisplay_box_function;
this_box_volume.geometry.initialize_from_main_function = &initialize_box_geometry_from_main_component;
this_box_volume.geometry.process_rot_allocated = 0;

this_box_volume.geometry.copy_geometry_parameters = &allocate_box_storage_copy;

rot_copy(this_box_volume.geometry.rotation_matrix,ROT_A_CURRENT_COMP); //check how ROT_R_CURRENT_COMP would work
rot_transpose(ROT_A_CURRENT_COMP,this_box_volume.geometry.transpose_rotation_matrix);

// Initialize loggers
this_box_volume.loggers.num_elements = 0;

// packing the information into the global_geometry_element, which is then included in the global_geometry_list.
sprintf(global_geometry_element.name,NAME_CURRENT_COMP);
global_geometry_element.activation_counter = number_of_activations;
global_geometry_element.component_index = INDEX_CURRENT_COMP;
global_geometry_element.Volume = &this_box_volume; // Would be nicer if this m was a pointer, now we have the (small) data two places
add_element_to_geometry_list(&global_geometry_list,global_geometry_element);
}
#line 320909 "MACS_sample_kidney_box.c"
#undef number_of_activations
#undef mask_setting
#undef mask_string
#undef p_interact
#undef focus_r
#undef focus_xh
#undef focus_xw
#undef focus_ah
#undef focus_aw
#undef target_z
#undef target_y
#undef target_x
#undef target_index
#undef visualize
#undef yheight2
#undef xwidth2
#undef zdepth
#undef yheight
#undef xwidth
#undef priority
#undef material_string
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

  /* Initializations for component channel_17_cave2_box3. */
  SIG_MESSAGE("channel_17_cave2_box3 (Init)");
#define mccompcurname  channel_17_cave2_box3
#define mccompcurtype  Union_box
#define mccompcurindex 799
#define loop_index mccchannel_17_cave2_box3_loop_index
#define this_box_volume mccchannel_17_cave2_box3_this_box_volume
#define global_geometry_element mccchannel_17_cave2_box3_global_geometry_element
#define this_box_storage mccchannel_17_cave2_box3_this_box_storage
#define material_string mccchannel_17_cave2_box3_material_string
#define priority mccchannel_17_cave2_box3_priority
#define xwidth mccchannel_17_cave2_box3_xwidth
#define yheight mccchannel_17_cave2_box3_yheight
#define zdepth mccchannel_17_cave2_box3_zdepth
#define xwidth2 mccchannel_17_cave2_box3_xwidth2
#define yheight2 mccchannel_17_cave2_box3_yheight2
#define visualize mccchannel_17_cave2_box3_visualize
#define target_index mccchannel_17_cave2_box3_target_index
#define target_x mccchannel_17_cave2_box3_target_x
#define target_y mccchannel_17_cave2_box3_target_y
#define target_z mccchannel_17_cave2_box3_target_z
#define focus_aw mccchannel_17_cave2_box3_focus_aw
#define focus_ah mccchannel_17_cave2_box3_focus_ah
#define focus_xw mccchannel_17_cave2_box3_focus_xw
#define focus_xh mccchannel_17_cave2_box3_focus_xh
#define focus_r mccchannel_17_cave2_box3_focus_r
#define p_interact mccchannel_17_cave2_box3_p_interact
#define mask_string mccchannel_17_cave2_box3_mask_string
#define mask_setting mccchannel_17_cave2_box3_mask_setting
#define number_of_activations mccchannel_17_cave2_box3_number_of_activations
#line 224 "Union_box.comp"
{
// Initializes the focusing system for this volume including input sanitation.
focus_initialize(&this_box_volume.geometry, POS_A_COMP_INDEX(INDEX_CURRENT_COMP+target_index), POS_A_CURRENT_COMP, ROT_A_CURRENT_COMP, target_index, target_x, target_y, target_z, focus_aw, focus_ah, focus_xw, focus_xh, focus_r, NAME_CURRENT_COMP);

// Input sanitation for this geometry
if (xwidth <= 0) {
  printf("\nERROR in Union_box named %s, the xwidth is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (yheight <= 0) {
  printf("\nERROR in Union_box named %s, yheight is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (zdepth <= 0) {
  printf("\nERROR in Union_box named %s, zdepth is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (xwidth2 <= 0 && xwidth2 != -1) {
  printf("\nERROR in Union_box named %s, the xwidth2 is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (yheight2 <= 0 && yheight2 != -1) {
  printf("\nERROR in Union_box named %s, yheight2 is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}

// Use sanitation
if (global_material_list.num_elements == 0) {
  printf("\nERROR: Need to define a material using Union_make_material before using a Union geometry component. \n");
  printf("       %s was defined before first use of Union_make_material.\n",NAME_CURRENT_COMP);
  exit(1);
}

this_box_volume.geometry.is_masked_volume = 0;
this_box_volume.geometry.is_exit_volume = 0;
this_box_volume.geometry.is_mask_volume = 0;
// check if the volume is a mask, if it is the material string is irelevant.
if (mask_string && strlen(mask_string) && strcmp(mask_string, "NULL") && strcmp(mask_string, "0")) {
    // A mask volume is used to limit the extend of other volumes, called the masked volumes. These are specified in the mask_string.
    // In order for a ray to enter a masked volume, it needs to be both in the region covered by that volume AND the mask volume.
    // When more than
    this_box_volume.geometry.mask_mode = 1; // Default is mask mode is ALL
    if (mask_setting && strlen(mask_setting) && strcmp(mask_setting, "NULL") && strcmp(mask_setting, "0")) {
        if (strcmp(mask_setting,"ALL") == 0 || strcmp(mask_setting,"All") == 0) this_box_volume.geometry.mask_mode = 1;
        else if (strcmp(mask_setting,"ANY") == 0 || strcmp(mask_setting,"Any") == 0) this_box_volume.geometry.mask_mode = 2;
        else {
            printf("The mask_mode of component %s is set to %s, but must be either ALL or ANY.\n",NAME_CURRENT_COMP,mask_setting);
            exit(1);
        }
    }
    
    for (loop_index=0;loop_index<global_geometry_list.num_elements;loop_index++) {
        // Add mask list
        if (1 == manual_linking_function(global_geometry_list.elements[loop_index].name,mask_string)) {
            add_element_to_int_list(&this_box_volume.geometry.mask_list,global_geometry_list.elements[loop_index].component_index);
            add_element_to_int_list(&global_geometry_list.elements[loop_index].Volume->geometry.masked_by_list,INDEX_CURRENT_COMP);
            global_geometry_list.elements[loop_index].Volume->geometry.is_masked_volume = 1;
            if (this_box_volume.geometry.mask_mode == 2)
                global_geometry_list.elements[loop_index].Volume->geometry.mask_mode = 2;
            if (this_box_volume.geometry.mask_mode == 1) {
                if (global_geometry_list.elements[loop_index].Volume->geometry.is_masked_volume == 1 && global_geometry_list.elements[loop_index].Volume->geometry.mask_mode != 2)
                    // If more than one mask is added to one volume, the ANY mode overwrites the (default) ALL mode.
                    global_geometry_list.elements[loop_index].Volume->geometry.mask_mode = 1;
            }
            
            found_geometries = 1;
        }
    }
    if (found_geometries == 0) {
        printf("The mask_string in geometry: %s did not find any of the specified volumes in the mask_string %s \n",NAME_CURRENT_COMP,mask_string);
        exit(1);
    }
    this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
    this_box_volume.p_physics->is_vacuum = 0; // Makes this volume a vacuum
    this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
    this_box_volume.p_physics->my_a = 0; // Should not be used.
    sprintf(this_box_volume.p_physics->name,"Mask");
    this_box_volume.geometry.is_mask_volume = 1;
    
    
// Read the material input, or if it lacks, use automatic linking.
} else if (material_string && strlen(material_string) && strcmp(material_string, "NULL") && strcmp(material_string, "0")) {
    // A geometry string was given, use it to determine which material
    if (0 == strcmp(material_string,"vacuum") || 0 == strcmp(material_string,"Vacuum")) {
        // One could have a global physics struct for vacuum instead of creating one for each
        this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
        this_box_volume.p_physics->is_vacuum = 1; // Makes this volume a vacuum
        this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
        this_box_volume.p_physics->my_a = 0; // Should not be used.
        sprintf(this_box_volume.p_physics->name,"Vacuum");
    } else if (0 == strcmp(material_string,"exit") || 0 == strcmp(material_string,"Exit")) {
        // One could have a global physics struct for vacuum instead of creating one for each
        this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
        this_box_volume.p_physics->is_vacuum = 1; // Makes this volume a vacuum
        this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
        this_box_volume.p_physics->my_a = 0; // Should not be used.
        this_box_volume.geometry.is_exit_volume = 1;
        sprintf(this_box_volume.p_physics->name,"Exit");
    } else {
        #ifndef MATERIAL_DETECTOR
            printf("Need to define a material before refering to it in a geometry %s.\n",NAME_CURRENT_COMP);
            exit(1);
        #endif
        for (loop_index=0;loop_index<global_material_list.num_elements;loop_index++) {
            if (0 == strcmp(material_string,global_material_list.elements[loop_index].name)) {
                this_box_volume.p_physics = global_material_list.elements[loop_index].physics;
                break;
            }
            if (loop_index == global_material_list.num_elements-1) {
            printf("\n");
            printf("ERROR: The material string \"%s\" in Union geometry \"%s\" did not match a specified material. \n",material_string,NAME_CURRENT_COMP);
            printf("       The materials available at this point (need to be defined before the geometry): \n");
            for (loop_index=0;loop_index<global_material_list.num_elements;loop_index++)
              printf("         %s\n",global_material_list.elements[loop_index].name);
            printf("\n");
            printf("       It is also possible to use one of the defualt materials avaiable: \n");
            printf("           Vacuum (for a Volume without scattering or absorption)\n");
            printf("           Exit (for a Volume where the ray exits the component if it enters)\n");
            printf("           Mask (for a Volume that masks existing volumes specified in the mask_string\n");
            exit(1);
          }
        }
    }
} else {
    // Automatic linking, simply using the last defined material.
    #ifndef MATERIAL_DETECTOR
        printf("Need to define a material before the geometry to use automatic linking %s.\n",NAME_CURRENT_COMP);
        exit(1);
    #endif
    this_box_volume.p_physics = global_material_list.elements[global_material_list.num_elements-1].physics;
}

sprintf(this_box_volume.name,NAME_CURRENT_COMP);
sprintf(this_box_volume.geometry.shape,"box");
this_box_volume.geometry.priority_value = priority;
this_box_volume.geometry.geometry_p_interact = p_interact;
// Currently the coordinates will be in absolute space.
this_box_volume.geometry.center = POS_A_CURRENT_COMP;

this_box_storage.z_depth = zdepth;
this_box_storage.x_width1 = xwidth;
this_box_storage.y_height1 = yheight;

this_box_storage.is_rectangle = 0;
if (xwidth2 < 0 && yheight2 < 0) this_box_storage.is_rectangle = 1;
if (xwidth == xwidth2 && yheight == yheight2) this_box_storage.is_rectangle = 1;

if (xwidth2 < 0) {
    this_box_storage.x_width2 = xwidth;
    xwidth2 = xwidth;
} else this_box_storage.x_width2 = xwidth2;

if (yheight2 < 0) {
    this_box_storage.y_height2 = yheight;
    yheight2 = yheight;
} else this_box_storage.y_height2 = yheight2;


this_box_storage.normal_vectors[0] = coords_set(0,0,1);
this_box_storage.normal_vectors[1] = coords_set(0,0,1);

// for sides with y component = 0
x_component = 2*zdepth/sqrt((xwidth-xwidth2)*(xwidth-xwidth2)+4*zdepth*zdepth);
z_component = (xwidth-xwidth2)/sqrt(4*zdepth*zdepth+(xwidth-xwidth2)*(xwidth-xwidth2));

this_box_storage.normal_vectors[2] = coords_set(x_component,0,z_component);
this_box_storage.normal_vectors[3] = coords_set(-x_component,0,z_component);

// for sides with x component = 0
y_component = 2*zdepth/sqrt((yheight-yheight2)*(yheight-yheight2)+4*zdepth*zdepth);
z_component = (yheight-yheight2)/sqrt(4*zdepth*zdepth+(yheight-yheight2)*(yheight-yheight2));

this_box_storage.normal_vectors[4] = coords_set(0,y_component,z_component);
this_box_storage.normal_vectors[5] = coords_set(0,-y_component,z_component);

this_box_volume.geometry.visualization_on = visualize;

this_box_volume.geometry.geometry_parameters.p_box_storage = &this_box_storage;

// Assign pointers to functions for intersection with the shape, checking if a point is inside the shape
if (this_box_storage.is_rectangle == 1) {
this_box_volume.geometry.intersect_function = &sample_box_intersect_simple;
this_box_volume.geometry.within_function = &r_within_box_simple;
}
else {
this_box_volume.geometry.intersect_function = &sample_box_intersect_advanced;
this_box_volume.geometry.within_function = &r_within_box_advanced;
}

this_box_volume.geometry.shell_points = &box_shell_points;
this_box_volume.geometry.mcdisplay_function = &mcdisplay_box_function;
this_box_volume.geometry.initialize_from_main_function = &initialize_box_geometry_from_main_component;
this_box_volume.geometry.process_rot_allocated = 0;

this_box_volume.geometry.copy_geometry_parameters = &allocate_box_storage_copy;

rot_copy(this_box_volume.geometry.rotation_matrix,ROT_A_CURRENT_COMP); //check how ROT_R_CURRENT_COMP would work
rot_transpose(ROT_A_CURRENT_COMP,this_box_volume.geometry.transpose_rotation_matrix);

// Initialize loggers
this_box_volume.loggers.num_elements = 0;

// packing the information into the global_geometry_element, which is then included in the global_geometry_list.
sprintf(global_geometry_element.name,NAME_CURRENT_COMP);
global_geometry_element.activation_counter = number_of_activations;
global_geometry_element.component_index = INDEX_CURRENT_COMP;
global_geometry_element.Volume = &this_box_volume; // Would be nicer if this m was a pointer, now we have the (small) data two places
add_element_to_geometry_list(&global_geometry_list,global_geometry_element);
}
#line 321179 "MACS_sample_kidney_box.c"
#undef number_of_activations
#undef mask_setting
#undef mask_string
#undef p_interact
#undef focus_r
#undef focus_xh
#undef focus_xw
#undef focus_ah
#undef focus_aw
#undef target_z
#undef target_y
#undef target_x
#undef target_index
#undef visualize
#undef yheight2
#undef xwidth2
#undef zdepth
#undef yheight
#undef xwidth
#undef priority
#undef material_string
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

  /* Initializations for component inter_analyzer_colimator_center_17. */
  SIG_MESSAGE("inter_analyzer_colimator_center_17 (Init)");

  /* Initializations for component inter_analyzer_colimator_17_blade_0. */
  SIG_MESSAGE("inter_analyzer_colimator_17_blade_0 (Init)");
#define mccompcurname  inter_analyzer_colimator_17_blade_0
#define mccompcurtype  Union_box
#define mccompcurindex 801
#define loop_index mccinter_analyzer_colimator_17_blade_0_loop_index
#define this_box_volume mccinter_analyzer_colimator_17_blade_0_this_box_volume
#define global_geometry_element mccinter_analyzer_colimator_17_blade_0_global_geometry_element
#define this_box_storage mccinter_analyzer_colimator_17_blade_0_this_box_storage
#define material_string mccinter_analyzer_colimator_17_blade_0_material_string
#define priority mccinter_analyzer_colimator_17_blade_0_priority
#define xwidth mccinter_analyzer_colimator_17_blade_0_xwidth
#define yheight mccinter_analyzer_colimator_17_blade_0_yheight
#define zdepth mccinter_analyzer_colimator_17_blade_0_zdepth
#define xwidth2 mccinter_analyzer_colimator_17_blade_0_xwidth2
#define yheight2 mccinter_analyzer_colimator_17_blade_0_yheight2
#define visualize mccinter_analyzer_colimator_17_blade_0_visualize
#define target_index mccinter_analyzer_colimator_17_blade_0_target_index
#define target_x mccinter_analyzer_colimator_17_blade_0_target_x
#define target_y mccinter_analyzer_colimator_17_blade_0_target_y
#define target_z mccinter_analyzer_colimator_17_blade_0_target_z
#define focus_aw mccinter_analyzer_colimator_17_blade_0_focus_aw
#define focus_ah mccinter_analyzer_colimator_17_blade_0_focus_ah
#define focus_xw mccinter_analyzer_colimator_17_blade_0_focus_xw
#define focus_xh mccinter_analyzer_colimator_17_blade_0_focus_xh
#define focus_r mccinter_analyzer_colimator_17_blade_0_focus_r
#define p_interact mccinter_analyzer_colimator_17_blade_0_p_interact
#define mask_string mccinter_analyzer_colimator_17_blade_0_mask_string
#define mask_setting mccinter_analyzer_colimator_17_blade_0_mask_setting
#define number_of_activations mccinter_analyzer_colimator_17_blade_0_number_of_activations
#line 224 "Union_box.comp"
{
// Initializes the focusing system for this volume including input sanitation.
focus_initialize(&this_box_volume.geometry, POS_A_COMP_INDEX(INDEX_CURRENT_COMP+target_index), POS_A_CURRENT_COMP, ROT_A_CURRENT_COMP, target_index, target_x, target_y, target_z, focus_aw, focus_ah, focus_xw, focus_xh, focus_r, NAME_CURRENT_COMP);

// Input sanitation for this geometry
if (xwidth <= 0) {
  printf("\nERROR in Union_box named %s, the xwidth is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (yheight <= 0) {
  printf("\nERROR in Union_box named %s, yheight is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (zdepth <= 0) {
  printf("\nERROR in Union_box named %s, zdepth is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (xwidth2 <= 0 && xwidth2 != -1) {
  printf("\nERROR in Union_box named %s, the xwidth2 is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (yheight2 <= 0 && yheight2 != -1) {
  printf("\nERROR in Union_box named %s, yheight2 is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}

// Use sanitation
if (global_material_list.num_elements == 0) {
  printf("\nERROR: Need to define a material using Union_make_material before using a Union geometry component. \n");
  printf("       %s was defined before first use of Union_make_material.\n",NAME_CURRENT_COMP);
  exit(1);
}

this_box_volume.geometry.is_masked_volume = 0;
this_box_volume.geometry.is_exit_volume = 0;
this_box_volume.geometry.is_mask_volume = 0;
// check if the volume is a mask, if it is the material string is irelevant.
if (mask_string && strlen(mask_string) && strcmp(mask_string, "NULL") && strcmp(mask_string, "0")) {
    // A mask volume is used to limit the extend of other volumes, called the masked volumes. These are specified in the mask_string.
    // In order for a ray to enter a masked volume, it needs to be both in the region covered by that volume AND the mask volume.
    // When more than
    this_box_volume.geometry.mask_mode = 1; // Default is mask mode is ALL
    if (mask_setting && strlen(mask_setting) && strcmp(mask_setting, "NULL") && strcmp(mask_setting, "0")) {
        if (strcmp(mask_setting,"ALL") == 0 || strcmp(mask_setting,"All") == 0) this_box_volume.geometry.mask_mode = 1;
        else if (strcmp(mask_setting,"ANY") == 0 || strcmp(mask_setting,"Any") == 0) this_box_volume.geometry.mask_mode = 2;
        else {
            printf("The mask_mode of component %s is set to %s, but must be either ALL or ANY.\n",NAME_CURRENT_COMP,mask_setting);
            exit(1);
        }
    }
    
    for (loop_index=0;loop_index<global_geometry_list.num_elements;loop_index++) {
        // Add mask list
        if (1 == manual_linking_function(global_geometry_list.elements[loop_index].name,mask_string)) {
            add_element_to_int_list(&this_box_volume.geometry.mask_list,global_geometry_list.elements[loop_index].component_index);
            add_element_to_int_list(&global_geometry_list.elements[loop_index].Volume->geometry.masked_by_list,INDEX_CURRENT_COMP);
            global_geometry_list.elements[loop_index].Volume->geometry.is_masked_volume = 1;
            if (this_box_volume.geometry.mask_mode == 2)
                global_geometry_list.elements[loop_index].Volume->geometry.mask_mode = 2;
            if (this_box_volume.geometry.mask_mode == 1) {
                if (global_geometry_list.elements[loop_index].Volume->geometry.is_masked_volume == 1 && global_geometry_list.elements[loop_index].Volume->geometry.mask_mode != 2)
                    // If more than one mask is added to one volume, the ANY mode overwrites the (default) ALL mode.
                    global_geometry_list.elements[loop_index].Volume->geometry.mask_mode = 1;
            }
            
            found_geometries = 1;
        }
    }
    if (found_geometries == 0) {
        printf("The mask_string in geometry: %s did not find any of the specified volumes in the mask_string %s \n",NAME_CURRENT_COMP,mask_string);
        exit(1);
    }
    this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
    this_box_volume.p_physics->is_vacuum = 0; // Makes this volume a vacuum
    this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
    this_box_volume.p_physics->my_a = 0; // Should not be used.
    sprintf(this_box_volume.p_physics->name,"Mask");
    this_box_volume.geometry.is_mask_volume = 1;
    
    
// Read the material input, or if it lacks, use automatic linking.
} else if (material_string && strlen(material_string) && strcmp(material_string, "NULL") && strcmp(material_string, "0")) {
    // A geometry string was given, use it to determine which material
    if (0 == strcmp(material_string,"vacuum") || 0 == strcmp(material_string,"Vacuum")) {
        // One could have a global physics struct for vacuum instead of creating one for each
        this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
        this_box_volume.p_physics->is_vacuum = 1; // Makes this volume a vacuum
        this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
        this_box_volume.p_physics->my_a = 0; // Should not be used.
        sprintf(this_box_volume.p_physics->name,"Vacuum");
    } else if (0 == strcmp(material_string,"exit") || 0 == strcmp(material_string,"Exit")) {
        // One could have a global physics struct for vacuum instead of creating one for each
        this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
        this_box_volume.p_physics->is_vacuum = 1; // Makes this volume a vacuum
        this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
        this_box_volume.p_physics->my_a = 0; // Should not be used.
        this_box_volume.geometry.is_exit_volume = 1;
        sprintf(this_box_volume.p_physics->name,"Exit");
    } else {
        #ifndef MATERIAL_DETECTOR
            printf("Need to define a material before refering to it in a geometry %s.\n",NAME_CURRENT_COMP);
            exit(1);
        #endif
        for (loop_index=0;loop_index<global_material_list.num_elements;loop_index++) {
            if (0 == strcmp(material_string,global_material_list.elements[loop_index].name)) {
                this_box_volume.p_physics = global_material_list.elements[loop_index].physics;
                break;
            }
            if (loop_index == global_material_list.num_elements-1) {
            printf("\n");
            printf("ERROR: The material string \"%s\" in Union geometry \"%s\" did not match a specified material. \n",material_string,NAME_CURRENT_COMP);
            printf("       The materials available at this point (need to be defined before the geometry): \n");
            for (loop_index=0;loop_index<global_material_list.num_elements;loop_index++)
              printf("         %s\n",global_material_list.elements[loop_index].name);
            printf("\n");
            printf("       It is also possible to use one of the defualt materials avaiable: \n");
            printf("           Vacuum (for a Volume without scattering or absorption)\n");
            printf("           Exit (for a Volume where the ray exits the component if it enters)\n");
            printf("           Mask (for a Volume that masks existing volumes specified in the mask_string\n");
            exit(1);
          }
        }
    }
} else {
    // Automatic linking, simply using the last defined material.
    #ifndef MATERIAL_DETECTOR
        printf("Need to define a material before the geometry to use automatic linking %s.\n",NAME_CURRENT_COMP);
        exit(1);
    #endif
    this_box_volume.p_physics = global_material_list.elements[global_material_list.num_elements-1].physics;
}

sprintf(this_box_volume.name,NAME_CURRENT_COMP);
sprintf(this_box_volume.geometry.shape,"box");
this_box_volume.geometry.priority_value = priority;
this_box_volume.geometry.geometry_p_interact = p_interact;
// Currently the coordinates will be in absolute space.
this_box_volume.geometry.center = POS_A_CURRENT_COMP;

this_box_storage.z_depth = zdepth;
this_box_storage.x_width1 = xwidth;
this_box_storage.y_height1 = yheight;

this_box_storage.is_rectangle = 0;
if (xwidth2 < 0 && yheight2 < 0) this_box_storage.is_rectangle = 1;
if (xwidth == xwidth2 && yheight == yheight2) this_box_storage.is_rectangle = 1;

if (xwidth2 < 0) {
    this_box_storage.x_width2 = xwidth;
    xwidth2 = xwidth;
} else this_box_storage.x_width2 = xwidth2;

if (yheight2 < 0) {
    this_box_storage.y_height2 = yheight;
    yheight2 = yheight;
} else this_box_storage.y_height2 = yheight2;


this_box_storage.normal_vectors[0] = coords_set(0,0,1);
this_box_storage.normal_vectors[1] = coords_set(0,0,1);

// for sides with y component = 0
x_component = 2*zdepth/sqrt((xwidth-xwidth2)*(xwidth-xwidth2)+4*zdepth*zdepth);
z_component = (xwidth-xwidth2)/sqrt(4*zdepth*zdepth+(xwidth-xwidth2)*(xwidth-xwidth2));

this_box_storage.normal_vectors[2] = coords_set(x_component,0,z_component);
this_box_storage.normal_vectors[3] = coords_set(-x_component,0,z_component);

// for sides with x component = 0
y_component = 2*zdepth/sqrt((yheight-yheight2)*(yheight-yheight2)+4*zdepth*zdepth);
z_component = (yheight-yheight2)/sqrt(4*zdepth*zdepth+(yheight-yheight2)*(yheight-yheight2));

this_box_storage.normal_vectors[4] = coords_set(0,y_component,z_component);
this_box_storage.normal_vectors[5] = coords_set(0,-y_component,z_component);

this_box_volume.geometry.visualization_on = visualize;

this_box_volume.geometry.geometry_parameters.p_box_storage = &this_box_storage;

// Assign pointers to functions for intersection with the shape, checking if a point is inside the shape
if (this_box_storage.is_rectangle == 1) {
this_box_volume.geometry.intersect_function = &sample_box_intersect_simple;
this_box_volume.geometry.within_function = &r_within_box_simple;
}
else {
this_box_volume.geometry.intersect_function = &sample_box_intersect_advanced;
this_box_volume.geometry.within_function = &r_within_box_advanced;
}

this_box_volume.geometry.shell_points = &box_shell_points;
this_box_volume.geometry.mcdisplay_function = &mcdisplay_box_function;
this_box_volume.geometry.initialize_from_main_function = &initialize_box_geometry_from_main_component;
this_box_volume.geometry.process_rot_allocated = 0;

this_box_volume.geometry.copy_geometry_parameters = &allocate_box_storage_copy;

rot_copy(this_box_volume.geometry.rotation_matrix,ROT_A_CURRENT_COMP); //check how ROT_R_CURRENT_COMP would work
rot_transpose(ROT_A_CURRENT_COMP,this_box_volume.geometry.transpose_rotation_matrix);

// Initialize loggers
this_box_volume.loggers.num_elements = 0;

// packing the information into the global_geometry_element, which is then included in the global_geometry_list.
sprintf(global_geometry_element.name,NAME_CURRENT_COMP);
global_geometry_element.activation_counter = number_of_activations;
global_geometry_element.component_index = INDEX_CURRENT_COMP;
global_geometry_element.Volume = &this_box_volume; // Would be nicer if this m was a pointer, now we have the (small) data two places
add_element_to_geometry_list(&global_geometry_list,global_geometry_element);
}
#line 321452 "MACS_sample_kidney_box.c"
#undef number_of_activations
#undef mask_setting
#undef mask_string
#undef p_interact
#undef focus_r
#undef focus_xh
#undef focus_xw
#undef focus_ah
#undef focus_aw
#undef target_z
#undef target_y
#undef target_x
#undef target_index
#undef visualize
#undef yheight2
#undef xwidth2
#undef zdepth
#undef yheight
#undef xwidth
#undef priority
#undef material_string
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

  /* Initializations for component inter_analyzer_colimator_17_blade_1. */
  SIG_MESSAGE("inter_analyzer_colimator_17_blade_1 (Init)");
#define mccompcurname  inter_analyzer_colimator_17_blade_1
#define mccompcurtype  Union_box
#define mccompcurindex 802
#define loop_index mccinter_analyzer_colimator_17_blade_1_loop_index
#define this_box_volume mccinter_analyzer_colimator_17_blade_1_this_box_volume
#define global_geometry_element mccinter_analyzer_colimator_17_blade_1_global_geometry_element
#define this_box_storage mccinter_analyzer_colimator_17_blade_1_this_box_storage
#define material_string mccinter_analyzer_colimator_17_blade_1_material_string
#define priority mccinter_analyzer_colimator_17_blade_1_priority
#define xwidth mccinter_analyzer_colimator_17_blade_1_xwidth
#define yheight mccinter_analyzer_colimator_17_blade_1_yheight
#define zdepth mccinter_analyzer_colimator_17_blade_1_zdepth
#define xwidth2 mccinter_analyzer_colimator_17_blade_1_xwidth2
#define yheight2 mccinter_analyzer_colimator_17_blade_1_yheight2
#define visualize mccinter_analyzer_colimator_17_blade_1_visualize
#define target_index mccinter_analyzer_colimator_17_blade_1_target_index
#define target_x mccinter_analyzer_colimator_17_blade_1_target_x
#define target_y mccinter_analyzer_colimator_17_blade_1_target_y
#define target_z mccinter_analyzer_colimator_17_blade_1_target_z
#define focus_aw mccinter_analyzer_colimator_17_blade_1_focus_aw
#define focus_ah mccinter_analyzer_colimator_17_blade_1_focus_ah
#define focus_xw mccinter_analyzer_colimator_17_blade_1_focus_xw
#define focus_xh mccinter_analyzer_colimator_17_blade_1_focus_xh
#define focus_r mccinter_analyzer_colimator_17_blade_1_focus_r
#define p_interact mccinter_analyzer_colimator_17_blade_1_p_interact
#define mask_string mccinter_analyzer_colimator_17_blade_1_mask_string
#define mask_setting mccinter_analyzer_colimator_17_blade_1_mask_setting
#define number_of_activations mccinter_analyzer_colimator_17_blade_1_number_of_activations
#line 224 "Union_box.comp"
{
// Initializes the focusing system for this volume including input sanitation.
focus_initialize(&this_box_volume.geometry, POS_A_COMP_INDEX(INDEX_CURRENT_COMP+target_index), POS_A_CURRENT_COMP, ROT_A_CURRENT_COMP, target_index, target_x, target_y, target_z, focus_aw, focus_ah, focus_xw, focus_xh, focus_r, NAME_CURRENT_COMP);

// Input sanitation for this geometry
if (xwidth <= 0) {
  printf("\nERROR in Union_box named %s, the xwidth is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (yheight <= 0) {
  printf("\nERROR in Union_box named %s, yheight is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (zdepth <= 0) {
  printf("\nERROR in Union_box named %s, zdepth is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (xwidth2 <= 0 && xwidth2 != -1) {
  printf("\nERROR in Union_box named %s, the xwidth2 is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (yheight2 <= 0 && yheight2 != -1) {
  printf("\nERROR in Union_box named %s, yheight2 is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}

// Use sanitation
if (global_material_list.num_elements == 0) {
  printf("\nERROR: Need to define a material using Union_make_material before using a Union geometry component. \n");
  printf("       %s was defined before first use of Union_make_material.\n",NAME_CURRENT_COMP);
  exit(1);
}

this_box_volume.geometry.is_masked_volume = 0;
this_box_volume.geometry.is_exit_volume = 0;
this_box_volume.geometry.is_mask_volume = 0;
// check if the volume is a mask, if it is the material string is irelevant.
if (mask_string && strlen(mask_string) && strcmp(mask_string, "NULL") && strcmp(mask_string, "0")) {
    // A mask volume is used to limit the extend of other volumes, called the masked volumes. These are specified in the mask_string.
    // In order for a ray to enter a masked volume, it needs to be both in the region covered by that volume AND the mask volume.
    // When more than
    this_box_volume.geometry.mask_mode = 1; // Default is mask mode is ALL
    if (mask_setting && strlen(mask_setting) && strcmp(mask_setting, "NULL") && strcmp(mask_setting, "0")) {
        if (strcmp(mask_setting,"ALL") == 0 || strcmp(mask_setting,"All") == 0) this_box_volume.geometry.mask_mode = 1;
        else if (strcmp(mask_setting,"ANY") == 0 || strcmp(mask_setting,"Any") == 0) this_box_volume.geometry.mask_mode = 2;
        else {
            printf("The mask_mode of component %s is set to %s, but must be either ALL or ANY.\n",NAME_CURRENT_COMP,mask_setting);
            exit(1);
        }
    }
    
    for (loop_index=0;loop_index<global_geometry_list.num_elements;loop_index++) {
        // Add mask list
        if (1 == manual_linking_function(global_geometry_list.elements[loop_index].name,mask_string)) {
            add_element_to_int_list(&this_box_volume.geometry.mask_list,global_geometry_list.elements[loop_index].component_index);
            add_element_to_int_list(&global_geometry_list.elements[loop_index].Volume->geometry.masked_by_list,INDEX_CURRENT_COMP);
            global_geometry_list.elements[loop_index].Volume->geometry.is_masked_volume = 1;
            if (this_box_volume.geometry.mask_mode == 2)
                global_geometry_list.elements[loop_index].Volume->geometry.mask_mode = 2;
            if (this_box_volume.geometry.mask_mode == 1) {
                if (global_geometry_list.elements[loop_index].Volume->geometry.is_masked_volume == 1 && global_geometry_list.elements[loop_index].Volume->geometry.mask_mode != 2)
                    // If more than one mask is added to one volume, the ANY mode overwrites the (default) ALL mode.
                    global_geometry_list.elements[loop_index].Volume->geometry.mask_mode = 1;
            }
            
            found_geometries = 1;
        }
    }
    if (found_geometries == 0) {
        printf("The mask_string in geometry: %s did not find any of the specified volumes in the mask_string %s \n",NAME_CURRENT_COMP,mask_string);
        exit(1);
    }
    this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
    this_box_volume.p_physics->is_vacuum = 0; // Makes this volume a vacuum
    this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
    this_box_volume.p_physics->my_a = 0; // Should not be used.
    sprintf(this_box_volume.p_physics->name,"Mask");
    this_box_volume.geometry.is_mask_volume = 1;
    
    
// Read the material input, or if it lacks, use automatic linking.
} else if (material_string && strlen(material_string) && strcmp(material_string, "NULL") && strcmp(material_string, "0")) {
    // A geometry string was given, use it to determine which material
    if (0 == strcmp(material_string,"vacuum") || 0 == strcmp(material_string,"Vacuum")) {
        // One could have a global physics struct for vacuum instead of creating one for each
        this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
        this_box_volume.p_physics->is_vacuum = 1; // Makes this volume a vacuum
        this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
        this_box_volume.p_physics->my_a = 0; // Should not be used.
        sprintf(this_box_volume.p_physics->name,"Vacuum");
    } else if (0 == strcmp(material_string,"exit") || 0 == strcmp(material_string,"Exit")) {
        // One could have a global physics struct for vacuum instead of creating one for each
        this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
        this_box_volume.p_physics->is_vacuum = 1; // Makes this volume a vacuum
        this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
        this_box_volume.p_physics->my_a = 0; // Should not be used.
        this_box_volume.geometry.is_exit_volume = 1;
        sprintf(this_box_volume.p_physics->name,"Exit");
    } else {
        #ifndef MATERIAL_DETECTOR
            printf("Need to define a material before refering to it in a geometry %s.\n",NAME_CURRENT_COMP);
            exit(1);
        #endif
        for (loop_index=0;loop_index<global_material_list.num_elements;loop_index++) {
            if (0 == strcmp(material_string,global_material_list.elements[loop_index].name)) {
                this_box_volume.p_physics = global_material_list.elements[loop_index].physics;
                break;
            }
            if (loop_index == global_material_list.num_elements-1) {
            printf("\n");
            printf("ERROR: The material string \"%s\" in Union geometry \"%s\" did not match a specified material. \n",material_string,NAME_CURRENT_COMP);
            printf("       The materials available at this point (need to be defined before the geometry): \n");
            for (loop_index=0;loop_index<global_material_list.num_elements;loop_index++)
              printf("         %s\n",global_material_list.elements[loop_index].name);
            printf("\n");
            printf("       It is also possible to use one of the defualt materials avaiable: \n");
            printf("           Vacuum (for a Volume without scattering or absorption)\n");
            printf("           Exit (for a Volume where the ray exits the component if it enters)\n");
            printf("           Mask (for a Volume that masks existing volumes specified in the mask_string\n");
            exit(1);
          }
        }
    }
} else {
    // Automatic linking, simply using the last defined material.
    #ifndef MATERIAL_DETECTOR
        printf("Need to define a material before the geometry to use automatic linking %s.\n",NAME_CURRENT_COMP);
        exit(1);
    #endif
    this_box_volume.p_physics = global_material_list.elements[global_material_list.num_elements-1].physics;
}

sprintf(this_box_volume.name,NAME_CURRENT_COMP);
sprintf(this_box_volume.geometry.shape,"box");
this_box_volume.geometry.priority_value = priority;
this_box_volume.geometry.geometry_p_interact = p_interact;
// Currently the coordinates will be in absolute space.
this_box_volume.geometry.center = POS_A_CURRENT_COMP;

this_box_storage.z_depth = zdepth;
this_box_storage.x_width1 = xwidth;
this_box_storage.y_height1 = yheight;

this_box_storage.is_rectangle = 0;
if (xwidth2 < 0 && yheight2 < 0) this_box_storage.is_rectangle = 1;
if (xwidth == xwidth2 && yheight == yheight2) this_box_storage.is_rectangle = 1;

if (xwidth2 < 0) {
    this_box_storage.x_width2 = xwidth;
    xwidth2 = xwidth;
} else this_box_storage.x_width2 = xwidth2;

if (yheight2 < 0) {
    this_box_storage.y_height2 = yheight;
    yheight2 = yheight;
} else this_box_storage.y_height2 = yheight2;


this_box_storage.normal_vectors[0] = coords_set(0,0,1);
this_box_storage.normal_vectors[1] = coords_set(0,0,1);

// for sides with y component = 0
x_component = 2*zdepth/sqrt((xwidth-xwidth2)*(xwidth-xwidth2)+4*zdepth*zdepth);
z_component = (xwidth-xwidth2)/sqrt(4*zdepth*zdepth+(xwidth-xwidth2)*(xwidth-xwidth2));

this_box_storage.normal_vectors[2] = coords_set(x_component,0,z_component);
this_box_storage.normal_vectors[3] = coords_set(-x_component,0,z_component);

// for sides with x component = 0
y_component = 2*zdepth/sqrt((yheight-yheight2)*(yheight-yheight2)+4*zdepth*zdepth);
z_component = (yheight-yheight2)/sqrt(4*zdepth*zdepth+(yheight-yheight2)*(yheight-yheight2));

this_box_storage.normal_vectors[4] = coords_set(0,y_component,z_component);
this_box_storage.normal_vectors[5] = coords_set(0,-y_component,z_component);

this_box_volume.geometry.visualization_on = visualize;

this_box_volume.geometry.geometry_parameters.p_box_storage = &this_box_storage;

// Assign pointers to functions for intersection with the shape, checking if a point is inside the shape
if (this_box_storage.is_rectangle == 1) {
this_box_volume.geometry.intersect_function = &sample_box_intersect_simple;
this_box_volume.geometry.within_function = &r_within_box_simple;
}
else {
this_box_volume.geometry.intersect_function = &sample_box_intersect_advanced;
this_box_volume.geometry.within_function = &r_within_box_advanced;
}

this_box_volume.geometry.shell_points = &box_shell_points;
this_box_volume.geometry.mcdisplay_function = &mcdisplay_box_function;
this_box_volume.geometry.initialize_from_main_function = &initialize_box_geometry_from_main_component;
this_box_volume.geometry.process_rot_allocated = 0;

this_box_volume.geometry.copy_geometry_parameters = &allocate_box_storage_copy;

rot_copy(this_box_volume.geometry.rotation_matrix,ROT_A_CURRENT_COMP); //check how ROT_R_CURRENT_COMP would work
rot_transpose(ROT_A_CURRENT_COMP,this_box_volume.geometry.transpose_rotation_matrix);

// Initialize loggers
this_box_volume.loggers.num_elements = 0;

// packing the information into the global_geometry_element, which is then included in the global_geometry_list.
sprintf(global_geometry_element.name,NAME_CURRENT_COMP);
global_geometry_element.activation_counter = number_of_activations;
global_geometry_element.component_index = INDEX_CURRENT_COMP;
global_geometry_element.Volume = &this_box_volume; // Would be nicer if this m was a pointer, now we have the (small) data two places
add_element_to_geometry_list(&global_geometry_list,global_geometry_element);
}
#line 321722 "MACS_sample_kidney_box.c"
#undef number_of_activations
#undef mask_setting
#undef mask_string
#undef p_interact
#undef focus_r
#undef focus_xh
#undef focus_xw
#undef focus_ah
#undef focus_aw
#undef target_z
#undef target_y
#undef target_x
#undef target_index
#undef visualize
#undef yheight2
#undef xwidth2
#undef zdepth
#undef yheight
#undef xwidth
#undef priority
#undef material_string
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

  /* Initializations for component inter_analyzer_colimator_17_blade_2. */
  SIG_MESSAGE("inter_analyzer_colimator_17_blade_2 (Init)");
#define mccompcurname  inter_analyzer_colimator_17_blade_2
#define mccompcurtype  Union_box
#define mccompcurindex 803
#define loop_index mccinter_analyzer_colimator_17_blade_2_loop_index
#define this_box_volume mccinter_analyzer_colimator_17_blade_2_this_box_volume
#define global_geometry_element mccinter_analyzer_colimator_17_blade_2_global_geometry_element
#define this_box_storage mccinter_analyzer_colimator_17_blade_2_this_box_storage
#define material_string mccinter_analyzer_colimator_17_blade_2_material_string
#define priority mccinter_analyzer_colimator_17_blade_2_priority
#define xwidth mccinter_analyzer_colimator_17_blade_2_xwidth
#define yheight mccinter_analyzer_colimator_17_blade_2_yheight
#define zdepth mccinter_analyzer_colimator_17_blade_2_zdepth
#define xwidth2 mccinter_analyzer_colimator_17_blade_2_xwidth2
#define yheight2 mccinter_analyzer_colimator_17_blade_2_yheight2
#define visualize mccinter_analyzer_colimator_17_blade_2_visualize
#define target_index mccinter_analyzer_colimator_17_blade_2_target_index
#define target_x mccinter_analyzer_colimator_17_blade_2_target_x
#define target_y mccinter_analyzer_colimator_17_blade_2_target_y
#define target_z mccinter_analyzer_colimator_17_blade_2_target_z
#define focus_aw mccinter_analyzer_colimator_17_blade_2_focus_aw
#define focus_ah mccinter_analyzer_colimator_17_blade_2_focus_ah
#define focus_xw mccinter_analyzer_colimator_17_blade_2_focus_xw
#define focus_xh mccinter_analyzer_colimator_17_blade_2_focus_xh
#define focus_r mccinter_analyzer_colimator_17_blade_2_focus_r
#define p_interact mccinter_analyzer_colimator_17_blade_2_p_interact
#define mask_string mccinter_analyzer_colimator_17_blade_2_mask_string
#define mask_setting mccinter_analyzer_colimator_17_blade_2_mask_setting
#define number_of_activations mccinter_analyzer_colimator_17_blade_2_number_of_activations
#line 224 "Union_box.comp"
{
// Initializes the focusing system for this volume including input sanitation.
focus_initialize(&this_box_volume.geometry, POS_A_COMP_INDEX(INDEX_CURRENT_COMP+target_index), POS_A_CURRENT_COMP, ROT_A_CURRENT_COMP, target_index, target_x, target_y, target_z, focus_aw, focus_ah, focus_xw, focus_xh, focus_r, NAME_CURRENT_COMP);

// Input sanitation for this geometry
if (xwidth <= 0) {
  printf("\nERROR in Union_box named %s, the xwidth is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (yheight <= 0) {
  printf("\nERROR in Union_box named %s, yheight is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (zdepth <= 0) {
  printf("\nERROR in Union_box named %s, zdepth is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (xwidth2 <= 0 && xwidth2 != -1) {
  printf("\nERROR in Union_box named %s, the xwidth2 is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (yheight2 <= 0 && yheight2 != -1) {
  printf("\nERROR in Union_box named %s, yheight2 is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}

// Use sanitation
if (global_material_list.num_elements == 0) {
  printf("\nERROR: Need to define a material using Union_make_material before using a Union geometry component. \n");
  printf("       %s was defined before first use of Union_make_material.\n",NAME_CURRENT_COMP);
  exit(1);
}

this_box_volume.geometry.is_masked_volume = 0;
this_box_volume.geometry.is_exit_volume = 0;
this_box_volume.geometry.is_mask_volume = 0;
// check if the volume is a mask, if it is the material string is irelevant.
if (mask_string && strlen(mask_string) && strcmp(mask_string, "NULL") && strcmp(mask_string, "0")) {
    // A mask volume is used to limit the extend of other volumes, called the masked volumes. These are specified in the mask_string.
    // In order for a ray to enter a masked volume, it needs to be both in the region covered by that volume AND the mask volume.
    // When more than
    this_box_volume.geometry.mask_mode = 1; // Default is mask mode is ALL
    if (mask_setting && strlen(mask_setting) && strcmp(mask_setting, "NULL") && strcmp(mask_setting, "0")) {
        if (strcmp(mask_setting,"ALL") == 0 || strcmp(mask_setting,"All") == 0) this_box_volume.geometry.mask_mode = 1;
        else if (strcmp(mask_setting,"ANY") == 0 || strcmp(mask_setting,"Any") == 0) this_box_volume.geometry.mask_mode = 2;
        else {
            printf("The mask_mode of component %s is set to %s, but must be either ALL or ANY.\n",NAME_CURRENT_COMP,mask_setting);
            exit(1);
        }
    }
    
    for (loop_index=0;loop_index<global_geometry_list.num_elements;loop_index++) {
        // Add mask list
        if (1 == manual_linking_function(global_geometry_list.elements[loop_index].name,mask_string)) {
            add_element_to_int_list(&this_box_volume.geometry.mask_list,global_geometry_list.elements[loop_index].component_index);
            add_element_to_int_list(&global_geometry_list.elements[loop_index].Volume->geometry.masked_by_list,INDEX_CURRENT_COMP);
            global_geometry_list.elements[loop_index].Volume->geometry.is_masked_volume = 1;
            if (this_box_volume.geometry.mask_mode == 2)
                global_geometry_list.elements[loop_index].Volume->geometry.mask_mode = 2;
            if (this_box_volume.geometry.mask_mode == 1) {
                if (global_geometry_list.elements[loop_index].Volume->geometry.is_masked_volume == 1 && global_geometry_list.elements[loop_index].Volume->geometry.mask_mode != 2)
                    // If more than one mask is added to one volume, the ANY mode overwrites the (default) ALL mode.
                    global_geometry_list.elements[loop_index].Volume->geometry.mask_mode = 1;
            }
            
            found_geometries = 1;
        }
    }
    if (found_geometries == 0) {
        printf("The mask_string in geometry: %s did not find any of the specified volumes in the mask_string %s \n",NAME_CURRENT_COMP,mask_string);
        exit(1);
    }
    this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
    this_box_volume.p_physics->is_vacuum = 0; // Makes this volume a vacuum
    this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
    this_box_volume.p_physics->my_a = 0; // Should not be used.
    sprintf(this_box_volume.p_physics->name,"Mask");
    this_box_volume.geometry.is_mask_volume = 1;
    
    
// Read the material input, or if it lacks, use automatic linking.
} else if (material_string && strlen(material_string) && strcmp(material_string, "NULL") && strcmp(material_string, "0")) {
    // A geometry string was given, use it to determine which material
    if (0 == strcmp(material_string,"vacuum") || 0 == strcmp(material_string,"Vacuum")) {
        // One could have a global physics struct for vacuum instead of creating one for each
        this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
        this_box_volume.p_physics->is_vacuum = 1; // Makes this volume a vacuum
        this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
        this_box_volume.p_physics->my_a = 0; // Should not be used.
        sprintf(this_box_volume.p_physics->name,"Vacuum");
    } else if (0 == strcmp(material_string,"exit") || 0 == strcmp(material_string,"Exit")) {
        // One could have a global physics struct for vacuum instead of creating one for each
        this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
        this_box_volume.p_physics->is_vacuum = 1; // Makes this volume a vacuum
        this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
        this_box_volume.p_physics->my_a = 0; // Should not be used.
        this_box_volume.geometry.is_exit_volume = 1;
        sprintf(this_box_volume.p_physics->name,"Exit");
    } else {
        #ifndef MATERIAL_DETECTOR
            printf("Need to define a material before refering to it in a geometry %s.\n",NAME_CURRENT_COMP);
            exit(1);
        #endif
        for (loop_index=0;loop_index<global_material_list.num_elements;loop_index++) {
            if (0 == strcmp(material_string,global_material_list.elements[loop_index].name)) {
                this_box_volume.p_physics = global_material_list.elements[loop_index].physics;
                break;
            }
            if (loop_index == global_material_list.num_elements-1) {
            printf("\n");
            printf("ERROR: The material string \"%s\" in Union geometry \"%s\" did not match a specified material. \n",material_string,NAME_CURRENT_COMP);
            printf("       The materials available at this point (need to be defined before the geometry): \n");
            for (loop_index=0;loop_index<global_material_list.num_elements;loop_index++)
              printf("         %s\n",global_material_list.elements[loop_index].name);
            printf("\n");
            printf("       It is also possible to use one of the defualt materials avaiable: \n");
            printf("           Vacuum (for a Volume without scattering or absorption)\n");
            printf("           Exit (for a Volume where the ray exits the component if it enters)\n");
            printf("           Mask (for a Volume that masks existing volumes specified in the mask_string\n");
            exit(1);
          }
        }
    }
} else {
    // Automatic linking, simply using the last defined material.
    #ifndef MATERIAL_DETECTOR
        printf("Need to define a material before the geometry to use automatic linking %s.\n",NAME_CURRENT_COMP);
        exit(1);
    #endif
    this_box_volume.p_physics = global_material_list.elements[global_material_list.num_elements-1].physics;
}

sprintf(this_box_volume.name,NAME_CURRENT_COMP);
sprintf(this_box_volume.geometry.shape,"box");
this_box_volume.geometry.priority_value = priority;
this_box_volume.geometry.geometry_p_interact = p_interact;
// Currently the coordinates will be in absolute space.
this_box_volume.geometry.center = POS_A_CURRENT_COMP;

this_box_storage.z_depth = zdepth;
this_box_storage.x_width1 = xwidth;
this_box_storage.y_height1 = yheight;

this_box_storage.is_rectangle = 0;
if (xwidth2 < 0 && yheight2 < 0) this_box_storage.is_rectangle = 1;
if (xwidth == xwidth2 && yheight == yheight2) this_box_storage.is_rectangle = 1;

if (xwidth2 < 0) {
    this_box_storage.x_width2 = xwidth;
    xwidth2 = xwidth;
} else this_box_storage.x_width2 = xwidth2;

if (yheight2 < 0) {
    this_box_storage.y_height2 = yheight;
    yheight2 = yheight;
} else this_box_storage.y_height2 = yheight2;


this_box_storage.normal_vectors[0] = coords_set(0,0,1);
this_box_storage.normal_vectors[1] = coords_set(0,0,1);

// for sides with y component = 0
x_component = 2*zdepth/sqrt((xwidth-xwidth2)*(xwidth-xwidth2)+4*zdepth*zdepth);
z_component = (xwidth-xwidth2)/sqrt(4*zdepth*zdepth+(xwidth-xwidth2)*(xwidth-xwidth2));

this_box_storage.normal_vectors[2] = coords_set(x_component,0,z_component);
this_box_storage.normal_vectors[3] = coords_set(-x_component,0,z_component);

// for sides with x component = 0
y_component = 2*zdepth/sqrt((yheight-yheight2)*(yheight-yheight2)+4*zdepth*zdepth);
z_component = (yheight-yheight2)/sqrt(4*zdepth*zdepth+(yheight-yheight2)*(yheight-yheight2));

this_box_storage.normal_vectors[4] = coords_set(0,y_component,z_component);
this_box_storage.normal_vectors[5] = coords_set(0,-y_component,z_component);

this_box_volume.geometry.visualization_on = visualize;

this_box_volume.geometry.geometry_parameters.p_box_storage = &this_box_storage;

// Assign pointers to functions for intersection with the shape, checking if a point is inside the shape
if (this_box_storage.is_rectangle == 1) {
this_box_volume.geometry.intersect_function = &sample_box_intersect_simple;
this_box_volume.geometry.within_function = &r_within_box_simple;
}
else {
this_box_volume.geometry.intersect_function = &sample_box_intersect_advanced;
this_box_volume.geometry.within_function = &r_within_box_advanced;
}

this_box_volume.geometry.shell_points = &box_shell_points;
this_box_volume.geometry.mcdisplay_function = &mcdisplay_box_function;
this_box_volume.geometry.initialize_from_main_function = &initialize_box_geometry_from_main_component;
this_box_volume.geometry.process_rot_allocated = 0;

this_box_volume.geometry.copy_geometry_parameters = &allocate_box_storage_copy;

rot_copy(this_box_volume.geometry.rotation_matrix,ROT_A_CURRENT_COMP); //check how ROT_R_CURRENT_COMP would work
rot_transpose(ROT_A_CURRENT_COMP,this_box_volume.geometry.transpose_rotation_matrix);

// Initialize loggers
this_box_volume.loggers.num_elements = 0;

// packing the information into the global_geometry_element, which is then included in the global_geometry_list.
sprintf(global_geometry_element.name,NAME_CURRENT_COMP);
global_geometry_element.activation_counter = number_of_activations;
global_geometry_element.component_index = INDEX_CURRENT_COMP;
global_geometry_element.Volume = &this_box_volume; // Would be nicer if this m was a pointer, now we have the (small) data two places
add_element_to_geometry_list(&global_geometry_list,global_geometry_element);
}
#line 321992 "MACS_sample_kidney_box.c"
#undef number_of_activations
#undef mask_setting
#undef mask_string
#undef p_interact
#undef focus_r
#undef focus_xh
#undef focus_xw
#undef focus_ah
#undef focus_aw
#undef target_z
#undef target_y
#undef target_x
#undef target_index
#undef visualize
#undef yheight2
#undef xwidth2
#undef zdepth
#undef yheight
#undef xwidth
#undef priority
#undef material_string
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

  /* Initializations for component inter_analyzer_colimator_17_blade_3. */
  SIG_MESSAGE("inter_analyzer_colimator_17_blade_3 (Init)");
#define mccompcurname  inter_analyzer_colimator_17_blade_3
#define mccompcurtype  Union_box
#define mccompcurindex 804
#define loop_index mccinter_analyzer_colimator_17_blade_3_loop_index
#define this_box_volume mccinter_analyzer_colimator_17_blade_3_this_box_volume
#define global_geometry_element mccinter_analyzer_colimator_17_blade_3_global_geometry_element
#define this_box_storage mccinter_analyzer_colimator_17_blade_3_this_box_storage
#define material_string mccinter_analyzer_colimator_17_blade_3_material_string
#define priority mccinter_analyzer_colimator_17_blade_3_priority
#define xwidth mccinter_analyzer_colimator_17_blade_3_xwidth
#define yheight mccinter_analyzer_colimator_17_blade_3_yheight
#define zdepth mccinter_analyzer_colimator_17_blade_3_zdepth
#define xwidth2 mccinter_analyzer_colimator_17_blade_3_xwidth2
#define yheight2 mccinter_analyzer_colimator_17_blade_3_yheight2
#define visualize mccinter_analyzer_colimator_17_blade_3_visualize
#define target_index mccinter_analyzer_colimator_17_blade_3_target_index
#define target_x mccinter_analyzer_colimator_17_blade_3_target_x
#define target_y mccinter_analyzer_colimator_17_blade_3_target_y
#define target_z mccinter_analyzer_colimator_17_blade_3_target_z
#define focus_aw mccinter_analyzer_colimator_17_blade_3_focus_aw
#define focus_ah mccinter_analyzer_colimator_17_blade_3_focus_ah
#define focus_xw mccinter_analyzer_colimator_17_blade_3_focus_xw
#define focus_xh mccinter_analyzer_colimator_17_blade_3_focus_xh
#define focus_r mccinter_analyzer_colimator_17_blade_3_focus_r
#define p_interact mccinter_analyzer_colimator_17_blade_3_p_interact
#define mask_string mccinter_analyzer_colimator_17_blade_3_mask_string
#define mask_setting mccinter_analyzer_colimator_17_blade_3_mask_setting
#define number_of_activations mccinter_analyzer_colimator_17_blade_3_number_of_activations
#line 224 "Union_box.comp"
{
// Initializes the focusing system for this volume including input sanitation.
focus_initialize(&this_box_volume.geometry, POS_A_COMP_INDEX(INDEX_CURRENT_COMP+target_index), POS_A_CURRENT_COMP, ROT_A_CURRENT_COMP, target_index, target_x, target_y, target_z, focus_aw, focus_ah, focus_xw, focus_xh, focus_r, NAME_CURRENT_COMP);

// Input sanitation for this geometry
if (xwidth <= 0) {
  printf("\nERROR in Union_box named %s, the xwidth is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (yheight <= 0) {
  printf("\nERROR in Union_box named %s, yheight is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (zdepth <= 0) {
  printf("\nERROR in Union_box named %s, zdepth is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (xwidth2 <= 0 && xwidth2 != -1) {
  printf("\nERROR in Union_box named %s, the xwidth2 is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (yheight2 <= 0 && yheight2 != -1) {
  printf("\nERROR in Union_box named %s, yheight2 is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}

// Use sanitation
if (global_material_list.num_elements == 0) {
  printf("\nERROR: Need to define a material using Union_make_material before using a Union geometry component. \n");
  printf("       %s was defined before first use of Union_make_material.\n",NAME_CURRENT_COMP);
  exit(1);
}

this_box_volume.geometry.is_masked_volume = 0;
this_box_volume.geometry.is_exit_volume = 0;
this_box_volume.geometry.is_mask_volume = 0;
// check if the volume is a mask, if it is the material string is irelevant.
if (mask_string && strlen(mask_string) && strcmp(mask_string, "NULL") && strcmp(mask_string, "0")) {
    // A mask volume is used to limit the extend of other volumes, called the masked volumes. These are specified in the mask_string.
    // In order for a ray to enter a masked volume, it needs to be both in the region covered by that volume AND the mask volume.
    // When more than
    this_box_volume.geometry.mask_mode = 1; // Default is mask mode is ALL
    if (mask_setting && strlen(mask_setting) && strcmp(mask_setting, "NULL") && strcmp(mask_setting, "0")) {
        if (strcmp(mask_setting,"ALL") == 0 || strcmp(mask_setting,"All") == 0) this_box_volume.geometry.mask_mode = 1;
        else if (strcmp(mask_setting,"ANY") == 0 || strcmp(mask_setting,"Any") == 0) this_box_volume.geometry.mask_mode = 2;
        else {
            printf("The mask_mode of component %s is set to %s, but must be either ALL or ANY.\n",NAME_CURRENT_COMP,mask_setting);
            exit(1);
        }
    }
    
    for (loop_index=0;loop_index<global_geometry_list.num_elements;loop_index++) {
        // Add mask list
        if (1 == manual_linking_function(global_geometry_list.elements[loop_index].name,mask_string)) {
            add_element_to_int_list(&this_box_volume.geometry.mask_list,global_geometry_list.elements[loop_index].component_index);
            add_element_to_int_list(&global_geometry_list.elements[loop_index].Volume->geometry.masked_by_list,INDEX_CURRENT_COMP);
            global_geometry_list.elements[loop_index].Volume->geometry.is_masked_volume = 1;
            if (this_box_volume.geometry.mask_mode == 2)
                global_geometry_list.elements[loop_index].Volume->geometry.mask_mode = 2;
            if (this_box_volume.geometry.mask_mode == 1) {
                if (global_geometry_list.elements[loop_index].Volume->geometry.is_masked_volume == 1 && global_geometry_list.elements[loop_index].Volume->geometry.mask_mode != 2)
                    // If more than one mask is added to one volume, the ANY mode overwrites the (default) ALL mode.
                    global_geometry_list.elements[loop_index].Volume->geometry.mask_mode = 1;
            }
            
            found_geometries = 1;
        }
    }
    if (found_geometries == 0) {
        printf("The mask_string in geometry: %s did not find any of the specified volumes in the mask_string %s \n",NAME_CURRENT_COMP,mask_string);
        exit(1);
    }
    this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
    this_box_volume.p_physics->is_vacuum = 0; // Makes this volume a vacuum
    this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
    this_box_volume.p_physics->my_a = 0; // Should not be used.
    sprintf(this_box_volume.p_physics->name,"Mask");
    this_box_volume.geometry.is_mask_volume = 1;
    
    
// Read the material input, or if it lacks, use automatic linking.
} else if (material_string && strlen(material_string) && strcmp(material_string, "NULL") && strcmp(material_string, "0")) {
    // A geometry string was given, use it to determine which material
    if (0 == strcmp(material_string,"vacuum") || 0 == strcmp(material_string,"Vacuum")) {
        // One could have a global physics struct for vacuum instead of creating one for each
        this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
        this_box_volume.p_physics->is_vacuum = 1; // Makes this volume a vacuum
        this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
        this_box_volume.p_physics->my_a = 0; // Should not be used.
        sprintf(this_box_volume.p_physics->name,"Vacuum");
    } else if (0 == strcmp(material_string,"exit") || 0 == strcmp(material_string,"Exit")) {
        // One could have a global physics struct for vacuum instead of creating one for each
        this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
        this_box_volume.p_physics->is_vacuum = 1; // Makes this volume a vacuum
        this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
        this_box_volume.p_physics->my_a = 0; // Should not be used.
        this_box_volume.geometry.is_exit_volume = 1;
        sprintf(this_box_volume.p_physics->name,"Exit");
    } else {
        #ifndef MATERIAL_DETECTOR
            printf("Need to define a material before refering to it in a geometry %s.\n",NAME_CURRENT_COMP);
            exit(1);
        #endif
        for (loop_index=0;loop_index<global_material_list.num_elements;loop_index++) {
            if (0 == strcmp(material_string,global_material_list.elements[loop_index].name)) {
                this_box_volume.p_physics = global_material_list.elements[loop_index].physics;
                break;
            }
            if (loop_index == global_material_list.num_elements-1) {
            printf("\n");
            printf("ERROR: The material string \"%s\" in Union geometry \"%s\" did not match a specified material. \n",material_string,NAME_CURRENT_COMP);
            printf("       The materials available at this point (need to be defined before the geometry): \n");
            for (loop_index=0;loop_index<global_material_list.num_elements;loop_index++)
              printf("         %s\n",global_material_list.elements[loop_index].name);
            printf("\n");
            printf("       It is also possible to use one of the defualt materials avaiable: \n");
            printf("           Vacuum (for a Volume without scattering or absorption)\n");
            printf("           Exit (for a Volume where the ray exits the component if it enters)\n");
            printf("           Mask (for a Volume that masks existing volumes specified in the mask_string\n");
            exit(1);
          }
        }
    }
} else {
    // Automatic linking, simply using the last defined material.
    #ifndef MATERIAL_DETECTOR
        printf("Need to define a material before the geometry to use automatic linking %s.\n",NAME_CURRENT_COMP);
        exit(1);
    #endif
    this_box_volume.p_physics = global_material_list.elements[global_material_list.num_elements-1].physics;
}

sprintf(this_box_volume.name,NAME_CURRENT_COMP);
sprintf(this_box_volume.geometry.shape,"box");
this_box_volume.geometry.priority_value = priority;
this_box_volume.geometry.geometry_p_interact = p_interact;
// Currently the coordinates will be in absolute space.
this_box_volume.geometry.center = POS_A_CURRENT_COMP;

this_box_storage.z_depth = zdepth;
this_box_storage.x_width1 = xwidth;
this_box_storage.y_height1 = yheight;

this_box_storage.is_rectangle = 0;
if (xwidth2 < 0 && yheight2 < 0) this_box_storage.is_rectangle = 1;
if (xwidth == xwidth2 && yheight == yheight2) this_box_storage.is_rectangle = 1;

if (xwidth2 < 0) {
    this_box_storage.x_width2 = xwidth;
    xwidth2 = xwidth;
} else this_box_storage.x_width2 = xwidth2;

if (yheight2 < 0) {
    this_box_storage.y_height2 = yheight;
    yheight2 = yheight;
} else this_box_storage.y_height2 = yheight2;


this_box_storage.normal_vectors[0] = coords_set(0,0,1);
this_box_storage.normal_vectors[1] = coords_set(0,0,1);

// for sides with y component = 0
x_component = 2*zdepth/sqrt((xwidth-xwidth2)*(xwidth-xwidth2)+4*zdepth*zdepth);
z_component = (xwidth-xwidth2)/sqrt(4*zdepth*zdepth+(xwidth-xwidth2)*(xwidth-xwidth2));

this_box_storage.normal_vectors[2] = coords_set(x_component,0,z_component);
this_box_storage.normal_vectors[3] = coords_set(-x_component,0,z_component);

// for sides with x component = 0
y_component = 2*zdepth/sqrt((yheight-yheight2)*(yheight-yheight2)+4*zdepth*zdepth);
z_component = (yheight-yheight2)/sqrt(4*zdepth*zdepth+(yheight-yheight2)*(yheight-yheight2));

this_box_storage.normal_vectors[4] = coords_set(0,y_component,z_component);
this_box_storage.normal_vectors[5] = coords_set(0,-y_component,z_component);

this_box_volume.geometry.visualization_on = visualize;

this_box_volume.geometry.geometry_parameters.p_box_storage = &this_box_storage;

// Assign pointers to functions for intersection with the shape, checking if a point is inside the shape
if (this_box_storage.is_rectangle == 1) {
this_box_volume.geometry.intersect_function = &sample_box_intersect_simple;
this_box_volume.geometry.within_function = &r_within_box_simple;
}
else {
this_box_volume.geometry.intersect_function = &sample_box_intersect_advanced;
this_box_volume.geometry.within_function = &r_within_box_advanced;
}

this_box_volume.geometry.shell_points = &box_shell_points;
this_box_volume.geometry.mcdisplay_function = &mcdisplay_box_function;
this_box_volume.geometry.initialize_from_main_function = &initialize_box_geometry_from_main_component;
this_box_volume.geometry.process_rot_allocated = 0;

this_box_volume.geometry.copy_geometry_parameters = &allocate_box_storage_copy;

rot_copy(this_box_volume.geometry.rotation_matrix,ROT_A_CURRENT_COMP); //check how ROT_R_CURRENT_COMP would work
rot_transpose(ROT_A_CURRENT_COMP,this_box_volume.geometry.transpose_rotation_matrix);

// Initialize loggers
this_box_volume.loggers.num_elements = 0;

// packing the information into the global_geometry_element, which is then included in the global_geometry_list.
sprintf(global_geometry_element.name,NAME_CURRENT_COMP);
global_geometry_element.activation_counter = number_of_activations;
global_geometry_element.component_index = INDEX_CURRENT_COMP;
global_geometry_element.Volume = &this_box_volume; // Would be nicer if this m was a pointer, now we have the (small) data two places
add_element_to_geometry_list(&global_geometry_list,global_geometry_element);
}
#line 322262 "MACS_sample_kidney_box.c"
#undef number_of_activations
#undef mask_setting
#undef mask_string
#undef p_interact
#undef focus_r
#undef focus_xh
#undef focus_xw
#undef focus_ah
#undef focus_aw
#undef target_z
#undef target_y
#undef target_x
#undef target_index
#undef visualize
#undef yheight2
#undef xwidth2
#undef zdepth
#undef yheight
#undef xwidth
#undef priority
#undef material_string
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

  /* Initializations for component inter_analyzer_colimator_17_blade_4. */
  SIG_MESSAGE("inter_analyzer_colimator_17_blade_4 (Init)");
#define mccompcurname  inter_analyzer_colimator_17_blade_4
#define mccompcurtype  Union_box
#define mccompcurindex 805
#define loop_index mccinter_analyzer_colimator_17_blade_4_loop_index
#define this_box_volume mccinter_analyzer_colimator_17_blade_4_this_box_volume
#define global_geometry_element mccinter_analyzer_colimator_17_blade_4_global_geometry_element
#define this_box_storage mccinter_analyzer_colimator_17_blade_4_this_box_storage
#define material_string mccinter_analyzer_colimator_17_blade_4_material_string
#define priority mccinter_analyzer_colimator_17_blade_4_priority
#define xwidth mccinter_analyzer_colimator_17_blade_4_xwidth
#define yheight mccinter_analyzer_colimator_17_blade_4_yheight
#define zdepth mccinter_analyzer_colimator_17_blade_4_zdepth
#define xwidth2 mccinter_analyzer_colimator_17_blade_4_xwidth2
#define yheight2 mccinter_analyzer_colimator_17_blade_4_yheight2
#define visualize mccinter_analyzer_colimator_17_blade_4_visualize
#define target_index mccinter_analyzer_colimator_17_blade_4_target_index
#define target_x mccinter_analyzer_colimator_17_blade_4_target_x
#define target_y mccinter_analyzer_colimator_17_blade_4_target_y
#define target_z mccinter_analyzer_colimator_17_blade_4_target_z
#define focus_aw mccinter_analyzer_colimator_17_blade_4_focus_aw
#define focus_ah mccinter_analyzer_colimator_17_blade_4_focus_ah
#define focus_xw mccinter_analyzer_colimator_17_blade_4_focus_xw
#define focus_xh mccinter_analyzer_colimator_17_blade_4_focus_xh
#define focus_r mccinter_analyzer_colimator_17_blade_4_focus_r
#define p_interact mccinter_analyzer_colimator_17_blade_4_p_interact
#define mask_string mccinter_analyzer_colimator_17_blade_4_mask_string
#define mask_setting mccinter_analyzer_colimator_17_blade_4_mask_setting
#define number_of_activations mccinter_analyzer_colimator_17_blade_4_number_of_activations
#line 224 "Union_box.comp"
{
// Initializes the focusing system for this volume including input sanitation.
focus_initialize(&this_box_volume.geometry, POS_A_COMP_INDEX(INDEX_CURRENT_COMP+target_index), POS_A_CURRENT_COMP, ROT_A_CURRENT_COMP, target_index, target_x, target_y, target_z, focus_aw, focus_ah, focus_xw, focus_xh, focus_r, NAME_CURRENT_COMP);

// Input sanitation for this geometry
if (xwidth <= 0) {
  printf("\nERROR in Union_box named %s, the xwidth is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (yheight <= 0) {
  printf("\nERROR in Union_box named %s, yheight is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (zdepth <= 0) {
  printf("\nERROR in Union_box named %s, zdepth is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (xwidth2 <= 0 && xwidth2 != -1) {
  printf("\nERROR in Union_box named %s, the xwidth2 is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (yheight2 <= 0 && yheight2 != -1) {
  printf("\nERROR in Union_box named %s, yheight2 is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}

// Use sanitation
if (global_material_list.num_elements == 0) {
  printf("\nERROR: Need to define a material using Union_make_material before using a Union geometry component. \n");
  printf("       %s was defined before first use of Union_make_material.\n",NAME_CURRENT_COMP);
  exit(1);
}

this_box_volume.geometry.is_masked_volume = 0;
this_box_volume.geometry.is_exit_volume = 0;
this_box_volume.geometry.is_mask_volume = 0;
// check if the volume is a mask, if it is the material string is irelevant.
if (mask_string && strlen(mask_string) && strcmp(mask_string, "NULL") && strcmp(mask_string, "0")) {
    // A mask volume is used to limit the extend of other volumes, called the masked volumes. These are specified in the mask_string.
    // In order for a ray to enter a masked volume, it needs to be both in the region covered by that volume AND the mask volume.
    // When more than
    this_box_volume.geometry.mask_mode = 1; // Default is mask mode is ALL
    if (mask_setting && strlen(mask_setting) && strcmp(mask_setting, "NULL") && strcmp(mask_setting, "0")) {
        if (strcmp(mask_setting,"ALL") == 0 || strcmp(mask_setting,"All") == 0) this_box_volume.geometry.mask_mode = 1;
        else if (strcmp(mask_setting,"ANY") == 0 || strcmp(mask_setting,"Any") == 0) this_box_volume.geometry.mask_mode = 2;
        else {
            printf("The mask_mode of component %s is set to %s, but must be either ALL or ANY.\n",NAME_CURRENT_COMP,mask_setting);
            exit(1);
        }
    }
    
    for (loop_index=0;loop_index<global_geometry_list.num_elements;loop_index++) {
        // Add mask list
        if (1 == manual_linking_function(global_geometry_list.elements[loop_index].name,mask_string)) {
            add_element_to_int_list(&this_box_volume.geometry.mask_list,global_geometry_list.elements[loop_index].component_index);
            add_element_to_int_list(&global_geometry_list.elements[loop_index].Volume->geometry.masked_by_list,INDEX_CURRENT_COMP);
            global_geometry_list.elements[loop_index].Volume->geometry.is_masked_volume = 1;
            if (this_box_volume.geometry.mask_mode == 2)
                global_geometry_list.elements[loop_index].Volume->geometry.mask_mode = 2;
            if (this_box_volume.geometry.mask_mode == 1) {
                if (global_geometry_list.elements[loop_index].Volume->geometry.is_masked_volume == 1 && global_geometry_list.elements[loop_index].Volume->geometry.mask_mode != 2)
                    // If more than one mask is added to one volume, the ANY mode overwrites the (default) ALL mode.
                    global_geometry_list.elements[loop_index].Volume->geometry.mask_mode = 1;
            }
            
            found_geometries = 1;
        }
    }
    if (found_geometries == 0) {
        printf("The mask_string in geometry: %s did not find any of the specified volumes in the mask_string %s \n",NAME_CURRENT_COMP,mask_string);
        exit(1);
    }
    this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
    this_box_volume.p_physics->is_vacuum = 0; // Makes this volume a vacuum
    this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
    this_box_volume.p_physics->my_a = 0; // Should not be used.
    sprintf(this_box_volume.p_physics->name,"Mask");
    this_box_volume.geometry.is_mask_volume = 1;
    
    
// Read the material input, or if it lacks, use automatic linking.
} else if (material_string && strlen(material_string) && strcmp(material_string, "NULL") && strcmp(material_string, "0")) {
    // A geometry string was given, use it to determine which material
    if (0 == strcmp(material_string,"vacuum") || 0 == strcmp(material_string,"Vacuum")) {
        // One could have a global physics struct for vacuum instead of creating one for each
        this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
        this_box_volume.p_physics->is_vacuum = 1; // Makes this volume a vacuum
        this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
        this_box_volume.p_physics->my_a = 0; // Should not be used.
        sprintf(this_box_volume.p_physics->name,"Vacuum");
    } else if (0 == strcmp(material_string,"exit") || 0 == strcmp(material_string,"Exit")) {
        // One could have a global physics struct for vacuum instead of creating one for each
        this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
        this_box_volume.p_physics->is_vacuum = 1; // Makes this volume a vacuum
        this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
        this_box_volume.p_physics->my_a = 0; // Should not be used.
        this_box_volume.geometry.is_exit_volume = 1;
        sprintf(this_box_volume.p_physics->name,"Exit");
    } else {
        #ifndef MATERIAL_DETECTOR
            printf("Need to define a material before refering to it in a geometry %s.\n",NAME_CURRENT_COMP);
            exit(1);
        #endif
        for (loop_index=0;loop_index<global_material_list.num_elements;loop_index++) {
            if (0 == strcmp(material_string,global_material_list.elements[loop_index].name)) {
                this_box_volume.p_physics = global_material_list.elements[loop_index].physics;
                break;
            }
            if (loop_index == global_material_list.num_elements-1) {
            printf("\n");
            printf("ERROR: The material string \"%s\" in Union geometry \"%s\" did not match a specified material. \n",material_string,NAME_CURRENT_COMP);
            printf("       The materials available at this point (need to be defined before the geometry): \n");
            for (loop_index=0;loop_index<global_material_list.num_elements;loop_index++)
              printf("         %s\n",global_material_list.elements[loop_index].name);
            printf("\n");
            printf("       It is also possible to use one of the defualt materials avaiable: \n");
            printf("           Vacuum (for a Volume without scattering or absorption)\n");
            printf("           Exit (for a Volume where the ray exits the component if it enters)\n");
            printf("           Mask (for a Volume that masks existing volumes specified in the mask_string\n");
            exit(1);
          }
        }
    }
} else {
    // Automatic linking, simply using the last defined material.
    #ifndef MATERIAL_DETECTOR
        printf("Need to define a material before the geometry to use automatic linking %s.\n",NAME_CURRENT_COMP);
        exit(1);
    #endif
    this_box_volume.p_physics = global_material_list.elements[global_material_list.num_elements-1].physics;
}

sprintf(this_box_volume.name,NAME_CURRENT_COMP);
sprintf(this_box_volume.geometry.shape,"box");
this_box_volume.geometry.priority_value = priority;
this_box_volume.geometry.geometry_p_interact = p_interact;
// Currently the coordinates will be in absolute space.
this_box_volume.geometry.center = POS_A_CURRENT_COMP;

this_box_storage.z_depth = zdepth;
this_box_storage.x_width1 = xwidth;
this_box_storage.y_height1 = yheight;

this_box_storage.is_rectangle = 0;
if (xwidth2 < 0 && yheight2 < 0) this_box_storage.is_rectangle = 1;
if (xwidth == xwidth2 && yheight == yheight2) this_box_storage.is_rectangle = 1;

if (xwidth2 < 0) {
    this_box_storage.x_width2 = xwidth;
    xwidth2 = xwidth;
} else this_box_storage.x_width2 = xwidth2;

if (yheight2 < 0) {
    this_box_storage.y_height2 = yheight;
    yheight2 = yheight;
} else this_box_storage.y_height2 = yheight2;


this_box_storage.normal_vectors[0] = coords_set(0,0,1);
this_box_storage.normal_vectors[1] = coords_set(0,0,1);

// for sides with y component = 0
x_component = 2*zdepth/sqrt((xwidth-xwidth2)*(xwidth-xwidth2)+4*zdepth*zdepth);
z_component = (xwidth-xwidth2)/sqrt(4*zdepth*zdepth+(xwidth-xwidth2)*(xwidth-xwidth2));

this_box_storage.normal_vectors[2] = coords_set(x_component,0,z_component);
this_box_storage.normal_vectors[3] = coords_set(-x_component,0,z_component);

// for sides with x component = 0
y_component = 2*zdepth/sqrt((yheight-yheight2)*(yheight-yheight2)+4*zdepth*zdepth);
z_component = (yheight-yheight2)/sqrt(4*zdepth*zdepth+(yheight-yheight2)*(yheight-yheight2));

this_box_storage.normal_vectors[4] = coords_set(0,y_component,z_component);
this_box_storage.normal_vectors[5] = coords_set(0,-y_component,z_component);

this_box_volume.geometry.visualization_on = visualize;

this_box_volume.geometry.geometry_parameters.p_box_storage = &this_box_storage;

// Assign pointers to functions for intersection with the shape, checking if a point is inside the shape
if (this_box_storage.is_rectangle == 1) {
this_box_volume.geometry.intersect_function = &sample_box_intersect_simple;
this_box_volume.geometry.within_function = &r_within_box_simple;
}
else {
this_box_volume.geometry.intersect_function = &sample_box_intersect_advanced;
this_box_volume.geometry.within_function = &r_within_box_advanced;
}

this_box_volume.geometry.shell_points = &box_shell_points;
this_box_volume.geometry.mcdisplay_function = &mcdisplay_box_function;
this_box_volume.geometry.initialize_from_main_function = &initialize_box_geometry_from_main_component;
this_box_volume.geometry.process_rot_allocated = 0;

this_box_volume.geometry.copy_geometry_parameters = &allocate_box_storage_copy;

rot_copy(this_box_volume.geometry.rotation_matrix,ROT_A_CURRENT_COMP); //check how ROT_R_CURRENT_COMP would work
rot_transpose(ROT_A_CURRENT_COMP,this_box_volume.geometry.transpose_rotation_matrix);

// Initialize loggers
this_box_volume.loggers.num_elements = 0;

// packing the information into the global_geometry_element, which is then included in the global_geometry_list.
sprintf(global_geometry_element.name,NAME_CURRENT_COMP);
global_geometry_element.activation_counter = number_of_activations;
global_geometry_element.component_index = INDEX_CURRENT_COMP;
global_geometry_element.Volume = &this_box_volume; // Would be nicer if this m was a pointer, now we have the (small) data two places
add_element_to_geometry_list(&global_geometry_list,global_geometry_element);
}
#line 322532 "MACS_sample_kidney_box.c"
#undef number_of_activations
#undef mask_setting
#undef mask_string
#undef p_interact
#undef focus_r
#undef focus_xh
#undef focus_xw
#undef focus_ah
#undef focus_aw
#undef target_z
#undef target_y
#undef target_x
#undef target_index
#undef visualize
#undef yheight2
#undef xwidth2
#undef zdepth
#undef yheight
#undef xwidth
#undef priority
#undef material_string
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

  /* Initializations for component diffraction_detector_17_exit_volume. */
  SIG_MESSAGE("diffraction_detector_17_exit_volume (Init)");
#define mccompcurname  diffraction_detector_17_exit_volume
#define mccompcurtype  Union_box
#define mccompcurindex 806
#define loop_index mccdiffraction_detector_17_exit_volume_loop_index
#define this_box_volume mccdiffraction_detector_17_exit_volume_this_box_volume
#define global_geometry_element mccdiffraction_detector_17_exit_volume_global_geometry_element
#define this_box_storage mccdiffraction_detector_17_exit_volume_this_box_storage
#define material_string mccdiffraction_detector_17_exit_volume_material_string
#define priority mccdiffraction_detector_17_exit_volume_priority
#define xwidth mccdiffraction_detector_17_exit_volume_xwidth
#define yheight mccdiffraction_detector_17_exit_volume_yheight
#define zdepth mccdiffraction_detector_17_exit_volume_zdepth
#define xwidth2 mccdiffraction_detector_17_exit_volume_xwidth2
#define yheight2 mccdiffraction_detector_17_exit_volume_yheight2
#define visualize mccdiffraction_detector_17_exit_volume_visualize
#define target_index mccdiffraction_detector_17_exit_volume_target_index
#define target_x mccdiffraction_detector_17_exit_volume_target_x
#define target_y mccdiffraction_detector_17_exit_volume_target_y
#define target_z mccdiffraction_detector_17_exit_volume_target_z
#define focus_aw mccdiffraction_detector_17_exit_volume_focus_aw
#define focus_ah mccdiffraction_detector_17_exit_volume_focus_ah
#define focus_xw mccdiffraction_detector_17_exit_volume_focus_xw
#define focus_xh mccdiffraction_detector_17_exit_volume_focus_xh
#define focus_r mccdiffraction_detector_17_exit_volume_focus_r
#define p_interact mccdiffraction_detector_17_exit_volume_p_interact
#define mask_string mccdiffraction_detector_17_exit_volume_mask_string
#define mask_setting mccdiffraction_detector_17_exit_volume_mask_setting
#define number_of_activations mccdiffraction_detector_17_exit_volume_number_of_activations
#line 224 "Union_box.comp"
{
// Initializes the focusing system for this volume including input sanitation.
focus_initialize(&this_box_volume.geometry, POS_A_COMP_INDEX(INDEX_CURRENT_COMP+target_index), POS_A_CURRENT_COMP, ROT_A_CURRENT_COMP, target_index, target_x, target_y, target_z, focus_aw, focus_ah, focus_xw, focus_xh, focus_r, NAME_CURRENT_COMP);

// Input sanitation for this geometry
if (xwidth <= 0) {
  printf("\nERROR in Union_box named %s, the xwidth is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (yheight <= 0) {
  printf("\nERROR in Union_box named %s, yheight is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (zdepth <= 0) {
  printf("\nERROR in Union_box named %s, zdepth is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (xwidth2 <= 0 && xwidth2 != -1) {
  printf("\nERROR in Union_box named %s, the xwidth2 is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (yheight2 <= 0 && yheight2 != -1) {
  printf("\nERROR in Union_box named %s, yheight2 is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}

// Use sanitation
if (global_material_list.num_elements == 0) {
  printf("\nERROR: Need to define a material using Union_make_material before using a Union geometry component. \n");
  printf("       %s was defined before first use of Union_make_material.\n",NAME_CURRENT_COMP);
  exit(1);
}

this_box_volume.geometry.is_masked_volume = 0;
this_box_volume.geometry.is_exit_volume = 0;
this_box_volume.geometry.is_mask_volume = 0;
// check if the volume is a mask, if it is the material string is irelevant.
if (mask_string && strlen(mask_string) && strcmp(mask_string, "NULL") && strcmp(mask_string, "0")) {
    // A mask volume is used to limit the extend of other volumes, called the masked volumes. These are specified in the mask_string.
    // In order for a ray to enter a masked volume, it needs to be both in the region covered by that volume AND the mask volume.
    // When more than
    this_box_volume.geometry.mask_mode = 1; // Default is mask mode is ALL
    if (mask_setting && strlen(mask_setting) && strcmp(mask_setting, "NULL") && strcmp(mask_setting, "0")) {
        if (strcmp(mask_setting,"ALL") == 0 || strcmp(mask_setting,"All") == 0) this_box_volume.geometry.mask_mode = 1;
        else if (strcmp(mask_setting,"ANY") == 0 || strcmp(mask_setting,"Any") == 0) this_box_volume.geometry.mask_mode = 2;
        else {
            printf("The mask_mode of component %s is set to %s, but must be either ALL or ANY.\n",NAME_CURRENT_COMP,mask_setting);
            exit(1);
        }
    }
    
    for (loop_index=0;loop_index<global_geometry_list.num_elements;loop_index++) {
        // Add mask list
        if (1 == manual_linking_function(global_geometry_list.elements[loop_index].name,mask_string)) {
            add_element_to_int_list(&this_box_volume.geometry.mask_list,global_geometry_list.elements[loop_index].component_index);
            add_element_to_int_list(&global_geometry_list.elements[loop_index].Volume->geometry.masked_by_list,INDEX_CURRENT_COMP);
            global_geometry_list.elements[loop_index].Volume->geometry.is_masked_volume = 1;
            if (this_box_volume.geometry.mask_mode == 2)
                global_geometry_list.elements[loop_index].Volume->geometry.mask_mode = 2;
            if (this_box_volume.geometry.mask_mode == 1) {
                if (global_geometry_list.elements[loop_index].Volume->geometry.is_masked_volume == 1 && global_geometry_list.elements[loop_index].Volume->geometry.mask_mode != 2)
                    // If more than one mask is added to one volume, the ANY mode overwrites the (default) ALL mode.
                    global_geometry_list.elements[loop_index].Volume->geometry.mask_mode = 1;
            }
            
            found_geometries = 1;
        }
    }
    if (found_geometries == 0) {
        printf("The mask_string in geometry: %s did not find any of the specified volumes in the mask_string %s \n",NAME_CURRENT_COMP,mask_string);
        exit(1);
    }
    this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
    this_box_volume.p_physics->is_vacuum = 0; // Makes this volume a vacuum
    this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
    this_box_volume.p_physics->my_a = 0; // Should not be used.
    sprintf(this_box_volume.p_physics->name,"Mask");
    this_box_volume.geometry.is_mask_volume = 1;
    
    
// Read the material input, or if it lacks, use automatic linking.
} else if (material_string && strlen(material_string) && strcmp(material_string, "NULL") && strcmp(material_string, "0")) {
    // A geometry string was given, use it to determine which material
    if (0 == strcmp(material_string,"vacuum") || 0 == strcmp(material_string,"Vacuum")) {
        // One could have a global physics struct for vacuum instead of creating one for each
        this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
        this_box_volume.p_physics->is_vacuum = 1; // Makes this volume a vacuum
        this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
        this_box_volume.p_physics->my_a = 0; // Should not be used.
        sprintf(this_box_volume.p_physics->name,"Vacuum");
    } else if (0 == strcmp(material_string,"exit") || 0 == strcmp(material_string,"Exit")) {
        // One could have a global physics struct for vacuum instead of creating one for each
        this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
        this_box_volume.p_physics->is_vacuum = 1; // Makes this volume a vacuum
        this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
        this_box_volume.p_physics->my_a = 0; // Should not be used.
        this_box_volume.geometry.is_exit_volume = 1;
        sprintf(this_box_volume.p_physics->name,"Exit");
    } else {
        #ifndef MATERIAL_DETECTOR
            printf("Need to define a material before refering to it in a geometry %s.\n",NAME_CURRENT_COMP);
            exit(1);
        #endif
        for (loop_index=0;loop_index<global_material_list.num_elements;loop_index++) {
            if (0 == strcmp(material_string,global_material_list.elements[loop_index].name)) {
                this_box_volume.p_physics = global_material_list.elements[loop_index].physics;
                break;
            }
            if (loop_index == global_material_list.num_elements-1) {
            printf("\n");
            printf("ERROR: The material string \"%s\" in Union geometry \"%s\" did not match a specified material. \n",material_string,NAME_CURRENT_COMP);
            printf("       The materials available at this point (need to be defined before the geometry): \n");
            for (loop_index=0;loop_index<global_material_list.num_elements;loop_index++)
              printf("         %s\n",global_material_list.elements[loop_index].name);
            printf("\n");
            printf("       It is also possible to use one of the defualt materials avaiable: \n");
            printf("           Vacuum (for a Volume without scattering or absorption)\n");
            printf("           Exit (for a Volume where the ray exits the component if it enters)\n");
            printf("           Mask (for a Volume that masks existing volumes specified in the mask_string\n");
            exit(1);
          }
        }
    }
} else {
    // Automatic linking, simply using the last defined material.
    #ifndef MATERIAL_DETECTOR
        printf("Need to define a material before the geometry to use automatic linking %s.\n",NAME_CURRENT_COMP);
        exit(1);
    #endif
    this_box_volume.p_physics = global_material_list.elements[global_material_list.num_elements-1].physics;
}

sprintf(this_box_volume.name,NAME_CURRENT_COMP);
sprintf(this_box_volume.geometry.shape,"box");
this_box_volume.geometry.priority_value = priority;
this_box_volume.geometry.geometry_p_interact = p_interact;
// Currently the coordinates will be in absolute space.
this_box_volume.geometry.center = POS_A_CURRENT_COMP;

this_box_storage.z_depth = zdepth;
this_box_storage.x_width1 = xwidth;
this_box_storage.y_height1 = yheight;

this_box_storage.is_rectangle = 0;
if (xwidth2 < 0 && yheight2 < 0) this_box_storage.is_rectangle = 1;
if (xwidth == xwidth2 && yheight == yheight2) this_box_storage.is_rectangle = 1;

if (xwidth2 < 0) {
    this_box_storage.x_width2 = xwidth;
    xwidth2 = xwidth;
} else this_box_storage.x_width2 = xwidth2;

if (yheight2 < 0) {
    this_box_storage.y_height2 = yheight;
    yheight2 = yheight;
} else this_box_storage.y_height2 = yheight2;


this_box_storage.normal_vectors[0] = coords_set(0,0,1);
this_box_storage.normal_vectors[1] = coords_set(0,0,1);

// for sides with y component = 0
x_component = 2*zdepth/sqrt((xwidth-xwidth2)*(xwidth-xwidth2)+4*zdepth*zdepth);
z_component = (xwidth-xwidth2)/sqrt(4*zdepth*zdepth+(xwidth-xwidth2)*(xwidth-xwidth2));

this_box_storage.normal_vectors[2] = coords_set(x_component,0,z_component);
this_box_storage.normal_vectors[3] = coords_set(-x_component,0,z_component);

// for sides with x component = 0
y_component = 2*zdepth/sqrt((yheight-yheight2)*(yheight-yheight2)+4*zdepth*zdepth);
z_component = (yheight-yheight2)/sqrt(4*zdepth*zdepth+(yheight-yheight2)*(yheight-yheight2));

this_box_storage.normal_vectors[4] = coords_set(0,y_component,z_component);
this_box_storage.normal_vectors[5] = coords_set(0,-y_component,z_component);

this_box_volume.geometry.visualization_on = visualize;

this_box_volume.geometry.geometry_parameters.p_box_storage = &this_box_storage;

// Assign pointers to functions for intersection with the shape, checking if a point is inside the shape
if (this_box_storage.is_rectangle == 1) {
this_box_volume.geometry.intersect_function = &sample_box_intersect_simple;
this_box_volume.geometry.within_function = &r_within_box_simple;
}
else {
this_box_volume.geometry.intersect_function = &sample_box_intersect_advanced;
this_box_volume.geometry.within_function = &r_within_box_advanced;
}

this_box_volume.geometry.shell_points = &box_shell_points;
this_box_volume.geometry.mcdisplay_function = &mcdisplay_box_function;
this_box_volume.geometry.initialize_from_main_function = &initialize_box_geometry_from_main_component;
this_box_volume.geometry.process_rot_allocated = 0;

this_box_volume.geometry.copy_geometry_parameters = &allocate_box_storage_copy;

rot_copy(this_box_volume.geometry.rotation_matrix,ROT_A_CURRENT_COMP); //check how ROT_R_CURRENT_COMP would work
rot_transpose(ROT_A_CURRENT_COMP,this_box_volume.geometry.transpose_rotation_matrix);

// Initialize loggers
this_box_volume.loggers.num_elements = 0;

// packing the information into the global_geometry_element, which is then included in the global_geometry_list.
sprintf(global_geometry_element.name,NAME_CURRENT_COMP);
global_geometry_element.activation_counter = number_of_activations;
global_geometry_element.component_index = INDEX_CURRENT_COMP;
global_geometry_element.Volume = &this_box_volume; // Would be nicer if this m was a pointer, now we have the (small) data two places
add_element_to_geometry_list(&global_geometry_list,global_geometry_element);
}
#line 322802 "MACS_sample_kidney_box.c"
#undef number_of_activations
#undef mask_setting
#undef mask_string
#undef p_interact
#undef focus_r
#undef focus_xh
#undef focus_xw
#undef focus_ah
#undef focus_aw
#undef target_z
#undef target_y
#undef target_x
#undef target_index
#undef visualize
#undef yheight2
#undef xwidth2
#undef zdepth
#undef yheight
#undef xwidth
#undef priority
#undef material_string
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

  /* Initializations for component spec_detector_17_exit_volume. */
  SIG_MESSAGE("spec_detector_17_exit_volume (Init)");
#define mccompcurname  spec_detector_17_exit_volume
#define mccompcurtype  Union_box
#define mccompcurindex 807
#define loop_index mccspec_detector_17_exit_volume_loop_index
#define this_box_volume mccspec_detector_17_exit_volume_this_box_volume
#define global_geometry_element mccspec_detector_17_exit_volume_global_geometry_element
#define this_box_storage mccspec_detector_17_exit_volume_this_box_storage
#define material_string mccspec_detector_17_exit_volume_material_string
#define priority mccspec_detector_17_exit_volume_priority
#define xwidth mccspec_detector_17_exit_volume_xwidth
#define yheight mccspec_detector_17_exit_volume_yheight
#define zdepth mccspec_detector_17_exit_volume_zdepth
#define xwidth2 mccspec_detector_17_exit_volume_xwidth2
#define yheight2 mccspec_detector_17_exit_volume_yheight2
#define visualize mccspec_detector_17_exit_volume_visualize
#define target_index mccspec_detector_17_exit_volume_target_index
#define target_x mccspec_detector_17_exit_volume_target_x
#define target_y mccspec_detector_17_exit_volume_target_y
#define target_z mccspec_detector_17_exit_volume_target_z
#define focus_aw mccspec_detector_17_exit_volume_focus_aw
#define focus_ah mccspec_detector_17_exit_volume_focus_ah
#define focus_xw mccspec_detector_17_exit_volume_focus_xw
#define focus_xh mccspec_detector_17_exit_volume_focus_xh
#define focus_r mccspec_detector_17_exit_volume_focus_r
#define p_interact mccspec_detector_17_exit_volume_p_interact
#define mask_string mccspec_detector_17_exit_volume_mask_string
#define mask_setting mccspec_detector_17_exit_volume_mask_setting
#define number_of_activations mccspec_detector_17_exit_volume_number_of_activations
#line 224 "Union_box.comp"
{
// Initializes the focusing system for this volume including input sanitation.
focus_initialize(&this_box_volume.geometry, POS_A_COMP_INDEX(INDEX_CURRENT_COMP+target_index), POS_A_CURRENT_COMP, ROT_A_CURRENT_COMP, target_index, target_x, target_y, target_z, focus_aw, focus_ah, focus_xw, focus_xh, focus_r, NAME_CURRENT_COMP);

// Input sanitation for this geometry
if (xwidth <= 0) {
  printf("\nERROR in Union_box named %s, the xwidth is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (yheight <= 0) {
  printf("\nERROR in Union_box named %s, yheight is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (zdepth <= 0) {
  printf("\nERROR in Union_box named %s, zdepth is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (xwidth2 <= 0 && xwidth2 != -1) {
  printf("\nERROR in Union_box named %s, the xwidth2 is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (yheight2 <= 0 && yheight2 != -1) {
  printf("\nERROR in Union_box named %s, yheight2 is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}

// Use sanitation
if (global_material_list.num_elements == 0) {
  printf("\nERROR: Need to define a material using Union_make_material before using a Union geometry component. \n");
  printf("       %s was defined before first use of Union_make_material.\n",NAME_CURRENT_COMP);
  exit(1);
}

this_box_volume.geometry.is_masked_volume = 0;
this_box_volume.geometry.is_exit_volume = 0;
this_box_volume.geometry.is_mask_volume = 0;
// check if the volume is a mask, if it is the material string is irelevant.
if (mask_string && strlen(mask_string) && strcmp(mask_string, "NULL") && strcmp(mask_string, "0")) {
    // A mask volume is used to limit the extend of other volumes, called the masked volumes. These are specified in the mask_string.
    // In order for a ray to enter a masked volume, it needs to be both in the region covered by that volume AND the mask volume.
    // When more than
    this_box_volume.geometry.mask_mode = 1; // Default is mask mode is ALL
    if (mask_setting && strlen(mask_setting) && strcmp(mask_setting, "NULL") && strcmp(mask_setting, "0")) {
        if (strcmp(mask_setting,"ALL") == 0 || strcmp(mask_setting,"All") == 0) this_box_volume.geometry.mask_mode = 1;
        else if (strcmp(mask_setting,"ANY") == 0 || strcmp(mask_setting,"Any") == 0) this_box_volume.geometry.mask_mode = 2;
        else {
            printf("The mask_mode of component %s is set to %s, but must be either ALL or ANY.\n",NAME_CURRENT_COMP,mask_setting);
            exit(1);
        }
    }
    
    for (loop_index=0;loop_index<global_geometry_list.num_elements;loop_index++) {
        // Add mask list
        if (1 == manual_linking_function(global_geometry_list.elements[loop_index].name,mask_string)) {
            add_element_to_int_list(&this_box_volume.geometry.mask_list,global_geometry_list.elements[loop_index].component_index);
            add_element_to_int_list(&global_geometry_list.elements[loop_index].Volume->geometry.masked_by_list,INDEX_CURRENT_COMP);
            global_geometry_list.elements[loop_index].Volume->geometry.is_masked_volume = 1;
            if (this_box_volume.geometry.mask_mode == 2)
                global_geometry_list.elements[loop_index].Volume->geometry.mask_mode = 2;
            if (this_box_volume.geometry.mask_mode == 1) {
                if (global_geometry_list.elements[loop_index].Volume->geometry.is_masked_volume == 1 && global_geometry_list.elements[loop_index].Volume->geometry.mask_mode != 2)
                    // If more than one mask is added to one volume, the ANY mode overwrites the (default) ALL mode.
                    global_geometry_list.elements[loop_index].Volume->geometry.mask_mode = 1;
            }
            
            found_geometries = 1;
        }
    }
    if (found_geometries == 0) {
        printf("The mask_string in geometry: %s did not find any of the specified volumes in the mask_string %s \n",NAME_CURRENT_COMP,mask_string);
        exit(1);
    }
    this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
    this_box_volume.p_physics->is_vacuum = 0; // Makes this volume a vacuum
    this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
    this_box_volume.p_physics->my_a = 0; // Should not be used.
    sprintf(this_box_volume.p_physics->name,"Mask");
    this_box_volume.geometry.is_mask_volume = 1;
    
    
// Read the material input, or if it lacks, use automatic linking.
} else if (material_string && strlen(material_string) && strcmp(material_string, "NULL") && strcmp(material_string, "0")) {
    // A geometry string was given, use it to determine which material
    if (0 == strcmp(material_string,"vacuum") || 0 == strcmp(material_string,"Vacuum")) {
        // One could have a global physics struct for vacuum instead of creating one for each
        this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
        this_box_volume.p_physics->is_vacuum = 1; // Makes this volume a vacuum
        this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
        this_box_volume.p_physics->my_a = 0; // Should not be used.
        sprintf(this_box_volume.p_physics->name,"Vacuum");
    } else if (0 == strcmp(material_string,"exit") || 0 == strcmp(material_string,"Exit")) {
        // One could have a global physics struct for vacuum instead of creating one for each
        this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
        this_box_volume.p_physics->is_vacuum = 1; // Makes this volume a vacuum
        this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
        this_box_volume.p_physics->my_a = 0; // Should not be used.
        this_box_volume.geometry.is_exit_volume = 1;
        sprintf(this_box_volume.p_physics->name,"Exit");
    } else {
        #ifndef MATERIAL_DETECTOR
            printf("Need to define a material before refering to it in a geometry %s.\n",NAME_CURRENT_COMP);
            exit(1);
        #endif
        for (loop_index=0;loop_index<global_material_list.num_elements;loop_index++) {
            if (0 == strcmp(material_string,global_material_list.elements[loop_index].name)) {
                this_box_volume.p_physics = global_material_list.elements[loop_index].physics;
                break;
            }
            if (loop_index == global_material_list.num_elements-1) {
            printf("\n");
            printf("ERROR: The material string \"%s\" in Union geometry \"%s\" did not match a specified material. \n",material_string,NAME_CURRENT_COMP);
            printf("       The materials available at this point (need to be defined before the geometry): \n");
            for (loop_index=0;loop_index<global_material_list.num_elements;loop_index++)
              printf("         %s\n",global_material_list.elements[loop_index].name);
            printf("\n");
            printf("       It is also possible to use one of the defualt materials avaiable: \n");
            printf("           Vacuum (for a Volume without scattering or absorption)\n");
            printf("           Exit (for a Volume where the ray exits the component if it enters)\n");
            printf("           Mask (for a Volume that masks existing volumes specified in the mask_string\n");
            exit(1);
          }
        }
    }
} else {
    // Automatic linking, simply using the last defined material.
    #ifndef MATERIAL_DETECTOR
        printf("Need to define a material before the geometry to use automatic linking %s.\n",NAME_CURRENT_COMP);
        exit(1);
    #endif
    this_box_volume.p_physics = global_material_list.elements[global_material_list.num_elements-1].physics;
}

sprintf(this_box_volume.name,NAME_CURRENT_COMP);
sprintf(this_box_volume.geometry.shape,"box");
this_box_volume.geometry.priority_value = priority;
this_box_volume.geometry.geometry_p_interact = p_interact;
// Currently the coordinates will be in absolute space.
this_box_volume.geometry.center = POS_A_CURRENT_COMP;

this_box_storage.z_depth = zdepth;
this_box_storage.x_width1 = xwidth;
this_box_storage.y_height1 = yheight;

this_box_storage.is_rectangle = 0;
if (xwidth2 < 0 && yheight2 < 0) this_box_storage.is_rectangle = 1;
if (xwidth == xwidth2 && yheight == yheight2) this_box_storage.is_rectangle = 1;

if (xwidth2 < 0) {
    this_box_storage.x_width2 = xwidth;
    xwidth2 = xwidth;
} else this_box_storage.x_width2 = xwidth2;

if (yheight2 < 0) {
    this_box_storage.y_height2 = yheight;
    yheight2 = yheight;
} else this_box_storage.y_height2 = yheight2;


this_box_storage.normal_vectors[0] = coords_set(0,0,1);
this_box_storage.normal_vectors[1] = coords_set(0,0,1);

// for sides with y component = 0
x_component = 2*zdepth/sqrt((xwidth-xwidth2)*(xwidth-xwidth2)+4*zdepth*zdepth);
z_component = (xwidth-xwidth2)/sqrt(4*zdepth*zdepth+(xwidth-xwidth2)*(xwidth-xwidth2));

this_box_storage.normal_vectors[2] = coords_set(x_component,0,z_component);
this_box_storage.normal_vectors[3] = coords_set(-x_component,0,z_component);

// for sides with x component = 0
y_component = 2*zdepth/sqrt((yheight-yheight2)*(yheight-yheight2)+4*zdepth*zdepth);
z_component = (yheight-yheight2)/sqrt(4*zdepth*zdepth+(yheight-yheight2)*(yheight-yheight2));

this_box_storage.normal_vectors[4] = coords_set(0,y_component,z_component);
this_box_storage.normal_vectors[5] = coords_set(0,-y_component,z_component);

this_box_volume.geometry.visualization_on = visualize;

this_box_volume.geometry.geometry_parameters.p_box_storage = &this_box_storage;

// Assign pointers to functions for intersection with the shape, checking if a point is inside the shape
if (this_box_storage.is_rectangle == 1) {
this_box_volume.geometry.intersect_function = &sample_box_intersect_simple;
this_box_volume.geometry.within_function = &r_within_box_simple;
}
else {
this_box_volume.geometry.intersect_function = &sample_box_intersect_advanced;
this_box_volume.geometry.within_function = &r_within_box_advanced;
}

this_box_volume.geometry.shell_points = &box_shell_points;
this_box_volume.geometry.mcdisplay_function = &mcdisplay_box_function;
this_box_volume.geometry.initialize_from_main_function = &initialize_box_geometry_from_main_component;
this_box_volume.geometry.process_rot_allocated = 0;

this_box_volume.geometry.copy_geometry_parameters = &allocate_box_storage_copy;

rot_copy(this_box_volume.geometry.rotation_matrix,ROT_A_CURRENT_COMP); //check how ROT_R_CURRENT_COMP would work
rot_transpose(ROT_A_CURRENT_COMP,this_box_volume.geometry.transpose_rotation_matrix);

// Initialize loggers
this_box_volume.loggers.num_elements = 0;

// packing the information into the global_geometry_element, which is then included in the global_geometry_list.
sprintf(global_geometry_element.name,NAME_CURRENT_COMP);
global_geometry_element.activation_counter = number_of_activations;
global_geometry_element.component_index = INDEX_CURRENT_COMP;
global_geometry_element.Volume = &this_box_volume; // Would be nicer if this m was a pointer, now we have the (small) data two places
add_element_to_geometry_list(&global_geometry_list,global_geometry_element);
}
#line 323072 "MACS_sample_kidney_box.c"
#undef number_of_activations
#undef mask_setting
#undef mask_string
#undef p_interact
#undef focus_r
#undef focus_xh
#undef focus_xw
#undef focus_ah
#undef focus_aw
#undef target_z
#undef target_y
#undef target_x
#undef target_index
#undef visualize
#undef yheight2
#undef xwidth2
#undef zdepth
#undef yheight
#undef xwidth
#undef priority
#undef material_string
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

  /* Initializations for component channel_18_cave1_box1. */
  SIG_MESSAGE("channel_18_cave1_box1 (Init)");
#define mccompcurname  channel_18_cave1_box1
#define mccompcurtype  Union_box
#define mccompcurindex 808
#define loop_index mccchannel_18_cave1_box1_loop_index
#define this_box_volume mccchannel_18_cave1_box1_this_box_volume
#define global_geometry_element mccchannel_18_cave1_box1_global_geometry_element
#define this_box_storage mccchannel_18_cave1_box1_this_box_storage
#define material_string mccchannel_18_cave1_box1_material_string
#define priority mccchannel_18_cave1_box1_priority
#define xwidth mccchannel_18_cave1_box1_xwidth
#define yheight mccchannel_18_cave1_box1_yheight
#define zdepth mccchannel_18_cave1_box1_zdepth
#define xwidth2 mccchannel_18_cave1_box1_xwidth2
#define yheight2 mccchannel_18_cave1_box1_yheight2
#define visualize mccchannel_18_cave1_box1_visualize
#define target_index mccchannel_18_cave1_box1_target_index
#define target_x mccchannel_18_cave1_box1_target_x
#define target_y mccchannel_18_cave1_box1_target_y
#define target_z mccchannel_18_cave1_box1_target_z
#define focus_aw mccchannel_18_cave1_box1_focus_aw
#define focus_ah mccchannel_18_cave1_box1_focus_ah
#define focus_xw mccchannel_18_cave1_box1_focus_xw
#define focus_xh mccchannel_18_cave1_box1_focus_xh
#define focus_r mccchannel_18_cave1_box1_focus_r
#define p_interact mccchannel_18_cave1_box1_p_interact
#define mask_string mccchannel_18_cave1_box1_mask_string
#define mask_setting mccchannel_18_cave1_box1_mask_setting
#define number_of_activations mccchannel_18_cave1_box1_number_of_activations
#line 224 "Union_box.comp"
{
// Initializes the focusing system for this volume including input sanitation.
focus_initialize(&this_box_volume.geometry, POS_A_COMP_INDEX(INDEX_CURRENT_COMP+target_index), POS_A_CURRENT_COMP, ROT_A_CURRENT_COMP, target_index, target_x, target_y, target_z, focus_aw, focus_ah, focus_xw, focus_xh, focus_r, NAME_CURRENT_COMP);

// Input sanitation for this geometry
if (xwidth <= 0) {
  printf("\nERROR in Union_box named %s, the xwidth is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (yheight <= 0) {
  printf("\nERROR in Union_box named %s, yheight is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (zdepth <= 0) {
  printf("\nERROR in Union_box named %s, zdepth is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (xwidth2 <= 0 && xwidth2 != -1) {
  printf("\nERROR in Union_box named %s, the xwidth2 is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (yheight2 <= 0 && yheight2 != -1) {
  printf("\nERROR in Union_box named %s, yheight2 is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}

// Use sanitation
if (global_material_list.num_elements == 0) {
  printf("\nERROR: Need to define a material using Union_make_material before using a Union geometry component. \n");
  printf("       %s was defined before first use of Union_make_material.\n",NAME_CURRENT_COMP);
  exit(1);
}

this_box_volume.geometry.is_masked_volume = 0;
this_box_volume.geometry.is_exit_volume = 0;
this_box_volume.geometry.is_mask_volume = 0;
// check if the volume is a mask, if it is the material string is irelevant.
if (mask_string && strlen(mask_string) && strcmp(mask_string, "NULL") && strcmp(mask_string, "0")) {
    // A mask volume is used to limit the extend of other volumes, called the masked volumes. These are specified in the mask_string.
    // In order for a ray to enter a masked volume, it needs to be both in the region covered by that volume AND the mask volume.
    // When more than
    this_box_volume.geometry.mask_mode = 1; // Default is mask mode is ALL
    if (mask_setting && strlen(mask_setting) && strcmp(mask_setting, "NULL") && strcmp(mask_setting, "0")) {
        if (strcmp(mask_setting,"ALL") == 0 || strcmp(mask_setting,"All") == 0) this_box_volume.geometry.mask_mode = 1;
        else if (strcmp(mask_setting,"ANY") == 0 || strcmp(mask_setting,"Any") == 0) this_box_volume.geometry.mask_mode = 2;
        else {
            printf("The mask_mode of component %s is set to %s, but must be either ALL or ANY.\n",NAME_CURRENT_COMP,mask_setting);
            exit(1);
        }
    }
    
    for (loop_index=0;loop_index<global_geometry_list.num_elements;loop_index++) {
        // Add mask list
        if (1 == manual_linking_function(global_geometry_list.elements[loop_index].name,mask_string)) {
            add_element_to_int_list(&this_box_volume.geometry.mask_list,global_geometry_list.elements[loop_index].component_index);
            add_element_to_int_list(&global_geometry_list.elements[loop_index].Volume->geometry.masked_by_list,INDEX_CURRENT_COMP);
            global_geometry_list.elements[loop_index].Volume->geometry.is_masked_volume = 1;
            if (this_box_volume.geometry.mask_mode == 2)
                global_geometry_list.elements[loop_index].Volume->geometry.mask_mode = 2;
            if (this_box_volume.geometry.mask_mode == 1) {
                if (global_geometry_list.elements[loop_index].Volume->geometry.is_masked_volume == 1 && global_geometry_list.elements[loop_index].Volume->geometry.mask_mode != 2)
                    // If more than one mask is added to one volume, the ANY mode overwrites the (default) ALL mode.
                    global_geometry_list.elements[loop_index].Volume->geometry.mask_mode = 1;
            }
            
            found_geometries = 1;
        }
    }
    if (found_geometries == 0) {
        printf("The mask_string in geometry: %s did not find any of the specified volumes in the mask_string %s \n",NAME_CURRENT_COMP,mask_string);
        exit(1);
    }
    this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
    this_box_volume.p_physics->is_vacuum = 0; // Makes this volume a vacuum
    this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
    this_box_volume.p_physics->my_a = 0; // Should not be used.
    sprintf(this_box_volume.p_physics->name,"Mask");
    this_box_volume.geometry.is_mask_volume = 1;
    
    
// Read the material input, or if it lacks, use automatic linking.
} else if (material_string && strlen(material_string) && strcmp(material_string, "NULL") && strcmp(material_string, "0")) {
    // A geometry string was given, use it to determine which material
    if (0 == strcmp(material_string,"vacuum") || 0 == strcmp(material_string,"Vacuum")) {
        // One could have a global physics struct for vacuum instead of creating one for each
        this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
        this_box_volume.p_physics->is_vacuum = 1; // Makes this volume a vacuum
        this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
        this_box_volume.p_physics->my_a = 0; // Should not be used.
        sprintf(this_box_volume.p_physics->name,"Vacuum");
    } else if (0 == strcmp(material_string,"exit") || 0 == strcmp(material_string,"Exit")) {
        // One could have a global physics struct for vacuum instead of creating one for each
        this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
        this_box_volume.p_physics->is_vacuum = 1; // Makes this volume a vacuum
        this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
        this_box_volume.p_physics->my_a = 0; // Should not be used.
        this_box_volume.geometry.is_exit_volume = 1;
        sprintf(this_box_volume.p_physics->name,"Exit");
    } else {
        #ifndef MATERIAL_DETECTOR
            printf("Need to define a material before refering to it in a geometry %s.\n",NAME_CURRENT_COMP);
            exit(1);
        #endif
        for (loop_index=0;loop_index<global_material_list.num_elements;loop_index++) {
            if (0 == strcmp(material_string,global_material_list.elements[loop_index].name)) {
                this_box_volume.p_physics = global_material_list.elements[loop_index].physics;
                break;
            }
            if (loop_index == global_material_list.num_elements-1) {
            printf("\n");
            printf("ERROR: The material string \"%s\" in Union geometry \"%s\" did not match a specified material. \n",material_string,NAME_CURRENT_COMP);
            printf("       The materials available at this point (need to be defined before the geometry): \n");
            for (loop_index=0;loop_index<global_material_list.num_elements;loop_index++)
              printf("         %s\n",global_material_list.elements[loop_index].name);
            printf("\n");
            printf("       It is also possible to use one of the defualt materials avaiable: \n");
            printf("           Vacuum (for a Volume without scattering or absorption)\n");
            printf("           Exit (for a Volume where the ray exits the component if it enters)\n");
            printf("           Mask (for a Volume that masks existing volumes specified in the mask_string\n");
            exit(1);
          }
        }
    }
} else {
    // Automatic linking, simply using the last defined material.
    #ifndef MATERIAL_DETECTOR
        printf("Need to define a material before the geometry to use automatic linking %s.\n",NAME_CURRENT_COMP);
        exit(1);
    #endif
    this_box_volume.p_physics = global_material_list.elements[global_material_list.num_elements-1].physics;
}

sprintf(this_box_volume.name,NAME_CURRENT_COMP);
sprintf(this_box_volume.geometry.shape,"box");
this_box_volume.geometry.priority_value = priority;
this_box_volume.geometry.geometry_p_interact = p_interact;
// Currently the coordinates will be in absolute space.
this_box_volume.geometry.center = POS_A_CURRENT_COMP;

this_box_storage.z_depth = zdepth;
this_box_storage.x_width1 = xwidth;
this_box_storage.y_height1 = yheight;

this_box_storage.is_rectangle = 0;
if (xwidth2 < 0 && yheight2 < 0) this_box_storage.is_rectangle = 1;
if (xwidth == xwidth2 && yheight == yheight2) this_box_storage.is_rectangle = 1;

if (xwidth2 < 0) {
    this_box_storage.x_width2 = xwidth;
    xwidth2 = xwidth;
} else this_box_storage.x_width2 = xwidth2;

if (yheight2 < 0) {
    this_box_storage.y_height2 = yheight;
    yheight2 = yheight;
} else this_box_storage.y_height2 = yheight2;


this_box_storage.normal_vectors[0] = coords_set(0,0,1);
this_box_storage.normal_vectors[1] = coords_set(0,0,1);

// for sides with y component = 0
x_component = 2*zdepth/sqrt((xwidth-xwidth2)*(xwidth-xwidth2)+4*zdepth*zdepth);
z_component = (xwidth-xwidth2)/sqrt(4*zdepth*zdepth+(xwidth-xwidth2)*(xwidth-xwidth2));

this_box_storage.normal_vectors[2] = coords_set(x_component,0,z_component);
this_box_storage.normal_vectors[3] = coords_set(-x_component,0,z_component);

// for sides with x component = 0
y_component = 2*zdepth/sqrt((yheight-yheight2)*(yheight-yheight2)+4*zdepth*zdepth);
z_component = (yheight-yheight2)/sqrt(4*zdepth*zdepth+(yheight-yheight2)*(yheight-yheight2));

this_box_storage.normal_vectors[4] = coords_set(0,y_component,z_component);
this_box_storage.normal_vectors[5] = coords_set(0,-y_component,z_component);

this_box_volume.geometry.visualization_on = visualize;

this_box_volume.geometry.geometry_parameters.p_box_storage = &this_box_storage;

// Assign pointers to functions for intersection with the shape, checking if a point is inside the shape
if (this_box_storage.is_rectangle == 1) {
this_box_volume.geometry.intersect_function = &sample_box_intersect_simple;
this_box_volume.geometry.within_function = &r_within_box_simple;
}
else {
this_box_volume.geometry.intersect_function = &sample_box_intersect_advanced;
this_box_volume.geometry.within_function = &r_within_box_advanced;
}

this_box_volume.geometry.shell_points = &box_shell_points;
this_box_volume.geometry.mcdisplay_function = &mcdisplay_box_function;
this_box_volume.geometry.initialize_from_main_function = &initialize_box_geometry_from_main_component;
this_box_volume.geometry.process_rot_allocated = 0;

this_box_volume.geometry.copy_geometry_parameters = &allocate_box_storage_copy;

rot_copy(this_box_volume.geometry.rotation_matrix,ROT_A_CURRENT_COMP); //check how ROT_R_CURRENT_COMP would work
rot_transpose(ROT_A_CURRENT_COMP,this_box_volume.geometry.transpose_rotation_matrix);

// Initialize loggers
this_box_volume.loggers.num_elements = 0;

// packing the information into the global_geometry_element, which is then included in the global_geometry_list.
sprintf(global_geometry_element.name,NAME_CURRENT_COMP);
global_geometry_element.activation_counter = number_of_activations;
global_geometry_element.component_index = INDEX_CURRENT_COMP;
global_geometry_element.Volume = &this_box_volume; // Would be nicer if this m was a pointer, now we have the (small) data two places
add_element_to_geometry_list(&global_geometry_list,global_geometry_element);
}
#line 323342 "MACS_sample_kidney_box.c"
#undef number_of_activations
#undef mask_setting
#undef mask_string
#undef p_interact
#undef focus_r
#undef focus_xh
#undef focus_xw
#undef focus_ah
#undef focus_aw
#undef target_z
#undef target_y
#undef target_x
#undef target_index
#undef visualize
#undef yheight2
#undef xwidth2
#undef zdepth
#undef yheight
#undef xwidth
#undef priority
#undef material_string
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

  /* Initializations for component channel_18_cave1_box2. */
  SIG_MESSAGE("channel_18_cave1_box2 (Init)");
#define mccompcurname  channel_18_cave1_box2
#define mccompcurtype  Union_box
#define mccompcurindex 809
#define loop_index mccchannel_18_cave1_box2_loop_index
#define this_box_volume mccchannel_18_cave1_box2_this_box_volume
#define global_geometry_element mccchannel_18_cave1_box2_global_geometry_element
#define this_box_storage mccchannel_18_cave1_box2_this_box_storage
#define material_string mccchannel_18_cave1_box2_material_string
#define priority mccchannel_18_cave1_box2_priority
#define xwidth mccchannel_18_cave1_box2_xwidth
#define yheight mccchannel_18_cave1_box2_yheight
#define zdepth mccchannel_18_cave1_box2_zdepth
#define xwidth2 mccchannel_18_cave1_box2_xwidth2
#define yheight2 mccchannel_18_cave1_box2_yheight2
#define visualize mccchannel_18_cave1_box2_visualize
#define target_index mccchannel_18_cave1_box2_target_index
#define target_x mccchannel_18_cave1_box2_target_x
#define target_y mccchannel_18_cave1_box2_target_y
#define target_z mccchannel_18_cave1_box2_target_z
#define focus_aw mccchannel_18_cave1_box2_focus_aw
#define focus_ah mccchannel_18_cave1_box2_focus_ah
#define focus_xw mccchannel_18_cave1_box2_focus_xw
#define focus_xh mccchannel_18_cave1_box2_focus_xh
#define focus_r mccchannel_18_cave1_box2_focus_r
#define p_interact mccchannel_18_cave1_box2_p_interact
#define mask_string mccchannel_18_cave1_box2_mask_string
#define mask_setting mccchannel_18_cave1_box2_mask_setting
#define number_of_activations mccchannel_18_cave1_box2_number_of_activations
#line 224 "Union_box.comp"
{
// Initializes the focusing system for this volume including input sanitation.
focus_initialize(&this_box_volume.geometry, POS_A_COMP_INDEX(INDEX_CURRENT_COMP+target_index), POS_A_CURRENT_COMP, ROT_A_CURRENT_COMP, target_index, target_x, target_y, target_z, focus_aw, focus_ah, focus_xw, focus_xh, focus_r, NAME_CURRENT_COMP);

// Input sanitation for this geometry
if (xwidth <= 0) {
  printf("\nERROR in Union_box named %s, the xwidth is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (yheight <= 0) {
  printf("\nERROR in Union_box named %s, yheight is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (zdepth <= 0) {
  printf("\nERROR in Union_box named %s, zdepth is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (xwidth2 <= 0 && xwidth2 != -1) {
  printf("\nERROR in Union_box named %s, the xwidth2 is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (yheight2 <= 0 && yheight2 != -1) {
  printf("\nERROR in Union_box named %s, yheight2 is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}

// Use sanitation
if (global_material_list.num_elements == 0) {
  printf("\nERROR: Need to define a material using Union_make_material before using a Union geometry component. \n");
  printf("       %s was defined before first use of Union_make_material.\n",NAME_CURRENT_COMP);
  exit(1);
}

this_box_volume.geometry.is_masked_volume = 0;
this_box_volume.geometry.is_exit_volume = 0;
this_box_volume.geometry.is_mask_volume = 0;
// check if the volume is a mask, if it is the material string is irelevant.
if (mask_string && strlen(mask_string) && strcmp(mask_string, "NULL") && strcmp(mask_string, "0")) {
    // A mask volume is used to limit the extend of other volumes, called the masked volumes. These are specified in the mask_string.
    // In order for a ray to enter a masked volume, it needs to be both in the region covered by that volume AND the mask volume.
    // When more than
    this_box_volume.geometry.mask_mode = 1; // Default is mask mode is ALL
    if (mask_setting && strlen(mask_setting) && strcmp(mask_setting, "NULL") && strcmp(mask_setting, "0")) {
        if (strcmp(mask_setting,"ALL") == 0 || strcmp(mask_setting,"All") == 0) this_box_volume.geometry.mask_mode = 1;
        else if (strcmp(mask_setting,"ANY") == 0 || strcmp(mask_setting,"Any") == 0) this_box_volume.geometry.mask_mode = 2;
        else {
            printf("The mask_mode of component %s is set to %s, but must be either ALL or ANY.\n",NAME_CURRENT_COMP,mask_setting);
            exit(1);
        }
    }
    
    for (loop_index=0;loop_index<global_geometry_list.num_elements;loop_index++) {
        // Add mask list
        if (1 == manual_linking_function(global_geometry_list.elements[loop_index].name,mask_string)) {
            add_element_to_int_list(&this_box_volume.geometry.mask_list,global_geometry_list.elements[loop_index].component_index);
            add_element_to_int_list(&global_geometry_list.elements[loop_index].Volume->geometry.masked_by_list,INDEX_CURRENT_COMP);
            global_geometry_list.elements[loop_index].Volume->geometry.is_masked_volume = 1;
            if (this_box_volume.geometry.mask_mode == 2)
                global_geometry_list.elements[loop_index].Volume->geometry.mask_mode = 2;
            if (this_box_volume.geometry.mask_mode == 1) {
                if (global_geometry_list.elements[loop_index].Volume->geometry.is_masked_volume == 1 && global_geometry_list.elements[loop_index].Volume->geometry.mask_mode != 2)
                    // If more than one mask is added to one volume, the ANY mode overwrites the (default) ALL mode.
                    global_geometry_list.elements[loop_index].Volume->geometry.mask_mode = 1;
            }
            
            found_geometries = 1;
        }
    }
    if (found_geometries == 0) {
        printf("The mask_string in geometry: %s did not find any of the specified volumes in the mask_string %s \n",NAME_CURRENT_COMP,mask_string);
        exit(1);
    }
    this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
    this_box_volume.p_physics->is_vacuum = 0; // Makes this volume a vacuum
    this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
    this_box_volume.p_physics->my_a = 0; // Should not be used.
    sprintf(this_box_volume.p_physics->name,"Mask");
    this_box_volume.geometry.is_mask_volume = 1;
    
    
// Read the material input, or if it lacks, use automatic linking.
} else if (material_string && strlen(material_string) && strcmp(material_string, "NULL") && strcmp(material_string, "0")) {
    // A geometry string was given, use it to determine which material
    if (0 == strcmp(material_string,"vacuum") || 0 == strcmp(material_string,"Vacuum")) {
        // One could have a global physics struct for vacuum instead of creating one for each
        this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
        this_box_volume.p_physics->is_vacuum = 1; // Makes this volume a vacuum
        this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
        this_box_volume.p_physics->my_a = 0; // Should not be used.
        sprintf(this_box_volume.p_physics->name,"Vacuum");
    } else if (0 == strcmp(material_string,"exit") || 0 == strcmp(material_string,"Exit")) {
        // One could have a global physics struct for vacuum instead of creating one for each
        this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
        this_box_volume.p_physics->is_vacuum = 1; // Makes this volume a vacuum
        this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
        this_box_volume.p_physics->my_a = 0; // Should not be used.
        this_box_volume.geometry.is_exit_volume = 1;
        sprintf(this_box_volume.p_physics->name,"Exit");
    } else {
        #ifndef MATERIAL_DETECTOR
            printf("Need to define a material before refering to it in a geometry %s.\n",NAME_CURRENT_COMP);
            exit(1);
        #endif
        for (loop_index=0;loop_index<global_material_list.num_elements;loop_index++) {
            if (0 == strcmp(material_string,global_material_list.elements[loop_index].name)) {
                this_box_volume.p_physics = global_material_list.elements[loop_index].physics;
                break;
            }
            if (loop_index == global_material_list.num_elements-1) {
            printf("\n");
            printf("ERROR: The material string \"%s\" in Union geometry \"%s\" did not match a specified material. \n",material_string,NAME_CURRENT_COMP);
            printf("       The materials available at this point (need to be defined before the geometry): \n");
            for (loop_index=0;loop_index<global_material_list.num_elements;loop_index++)
              printf("         %s\n",global_material_list.elements[loop_index].name);
            printf("\n");
            printf("       It is also possible to use one of the defualt materials avaiable: \n");
            printf("           Vacuum (for a Volume without scattering or absorption)\n");
            printf("           Exit (for a Volume where the ray exits the component if it enters)\n");
            printf("           Mask (for a Volume that masks existing volumes specified in the mask_string\n");
            exit(1);
          }
        }
    }
} else {
    // Automatic linking, simply using the last defined material.
    #ifndef MATERIAL_DETECTOR
        printf("Need to define a material before the geometry to use automatic linking %s.\n",NAME_CURRENT_COMP);
        exit(1);
    #endif
    this_box_volume.p_physics = global_material_list.elements[global_material_list.num_elements-1].physics;
}

sprintf(this_box_volume.name,NAME_CURRENT_COMP);
sprintf(this_box_volume.geometry.shape,"box");
this_box_volume.geometry.priority_value = priority;
this_box_volume.geometry.geometry_p_interact = p_interact;
// Currently the coordinates will be in absolute space.
this_box_volume.geometry.center = POS_A_CURRENT_COMP;

this_box_storage.z_depth = zdepth;
this_box_storage.x_width1 = xwidth;
this_box_storage.y_height1 = yheight;

this_box_storage.is_rectangle = 0;
if (xwidth2 < 0 && yheight2 < 0) this_box_storage.is_rectangle = 1;
if (xwidth == xwidth2 && yheight == yheight2) this_box_storage.is_rectangle = 1;

if (xwidth2 < 0) {
    this_box_storage.x_width2 = xwidth;
    xwidth2 = xwidth;
} else this_box_storage.x_width2 = xwidth2;

if (yheight2 < 0) {
    this_box_storage.y_height2 = yheight;
    yheight2 = yheight;
} else this_box_storage.y_height2 = yheight2;


this_box_storage.normal_vectors[0] = coords_set(0,0,1);
this_box_storage.normal_vectors[1] = coords_set(0,0,1);

// for sides with y component = 0
x_component = 2*zdepth/sqrt((xwidth-xwidth2)*(xwidth-xwidth2)+4*zdepth*zdepth);
z_component = (xwidth-xwidth2)/sqrt(4*zdepth*zdepth+(xwidth-xwidth2)*(xwidth-xwidth2));

this_box_storage.normal_vectors[2] = coords_set(x_component,0,z_component);
this_box_storage.normal_vectors[3] = coords_set(-x_component,0,z_component);

// for sides with x component = 0
y_component = 2*zdepth/sqrt((yheight-yheight2)*(yheight-yheight2)+4*zdepth*zdepth);
z_component = (yheight-yheight2)/sqrt(4*zdepth*zdepth+(yheight-yheight2)*(yheight-yheight2));

this_box_storage.normal_vectors[4] = coords_set(0,y_component,z_component);
this_box_storage.normal_vectors[5] = coords_set(0,-y_component,z_component);

this_box_volume.geometry.visualization_on = visualize;

this_box_volume.geometry.geometry_parameters.p_box_storage = &this_box_storage;

// Assign pointers to functions for intersection with the shape, checking if a point is inside the shape
if (this_box_storage.is_rectangle == 1) {
this_box_volume.geometry.intersect_function = &sample_box_intersect_simple;
this_box_volume.geometry.within_function = &r_within_box_simple;
}
else {
this_box_volume.geometry.intersect_function = &sample_box_intersect_advanced;
this_box_volume.geometry.within_function = &r_within_box_advanced;
}

this_box_volume.geometry.shell_points = &box_shell_points;
this_box_volume.geometry.mcdisplay_function = &mcdisplay_box_function;
this_box_volume.geometry.initialize_from_main_function = &initialize_box_geometry_from_main_component;
this_box_volume.geometry.process_rot_allocated = 0;

this_box_volume.geometry.copy_geometry_parameters = &allocate_box_storage_copy;

rot_copy(this_box_volume.geometry.rotation_matrix,ROT_A_CURRENT_COMP); //check how ROT_R_CURRENT_COMP would work
rot_transpose(ROT_A_CURRENT_COMP,this_box_volume.geometry.transpose_rotation_matrix);

// Initialize loggers
this_box_volume.loggers.num_elements = 0;

// packing the information into the global_geometry_element, which is then included in the global_geometry_list.
sprintf(global_geometry_element.name,NAME_CURRENT_COMP);
global_geometry_element.activation_counter = number_of_activations;
global_geometry_element.component_index = INDEX_CURRENT_COMP;
global_geometry_element.Volume = &this_box_volume; // Would be nicer if this m was a pointer, now we have the (small) data two places
add_element_to_geometry_list(&global_geometry_list,global_geometry_element);
}
#line 323612 "MACS_sample_kidney_box.c"
#undef number_of_activations
#undef mask_setting
#undef mask_string
#undef p_interact
#undef focus_r
#undef focus_xh
#undef focus_xw
#undef focus_ah
#undef focus_aw
#undef target_z
#undef target_y
#undef target_x
#undef target_index
#undef visualize
#undef yheight2
#undef xwidth2
#undef zdepth
#undef yheight
#undef xwidth
#undef priority
#undef material_string
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

  /* Initializations for component channel_18_cave1_box3. */
  SIG_MESSAGE("channel_18_cave1_box3 (Init)");
#define mccompcurname  channel_18_cave1_box3
#define mccompcurtype  Union_box
#define mccompcurindex 810
#define loop_index mccchannel_18_cave1_box3_loop_index
#define this_box_volume mccchannel_18_cave1_box3_this_box_volume
#define global_geometry_element mccchannel_18_cave1_box3_global_geometry_element
#define this_box_storage mccchannel_18_cave1_box3_this_box_storage
#define material_string mccchannel_18_cave1_box3_material_string
#define priority mccchannel_18_cave1_box3_priority
#define xwidth mccchannel_18_cave1_box3_xwidth
#define yheight mccchannel_18_cave1_box3_yheight
#define zdepth mccchannel_18_cave1_box3_zdepth
#define xwidth2 mccchannel_18_cave1_box3_xwidth2
#define yheight2 mccchannel_18_cave1_box3_yheight2
#define visualize mccchannel_18_cave1_box3_visualize
#define target_index mccchannel_18_cave1_box3_target_index
#define target_x mccchannel_18_cave1_box3_target_x
#define target_y mccchannel_18_cave1_box3_target_y
#define target_z mccchannel_18_cave1_box3_target_z
#define focus_aw mccchannel_18_cave1_box3_focus_aw
#define focus_ah mccchannel_18_cave1_box3_focus_ah
#define focus_xw mccchannel_18_cave1_box3_focus_xw
#define focus_xh mccchannel_18_cave1_box3_focus_xh
#define focus_r mccchannel_18_cave1_box3_focus_r
#define p_interact mccchannel_18_cave1_box3_p_interact
#define mask_string mccchannel_18_cave1_box3_mask_string
#define mask_setting mccchannel_18_cave1_box3_mask_setting
#define number_of_activations mccchannel_18_cave1_box3_number_of_activations
#line 224 "Union_box.comp"
{
// Initializes the focusing system for this volume including input sanitation.
focus_initialize(&this_box_volume.geometry, POS_A_COMP_INDEX(INDEX_CURRENT_COMP+target_index), POS_A_CURRENT_COMP, ROT_A_CURRENT_COMP, target_index, target_x, target_y, target_z, focus_aw, focus_ah, focus_xw, focus_xh, focus_r, NAME_CURRENT_COMP);

// Input sanitation for this geometry
if (xwidth <= 0) {
  printf("\nERROR in Union_box named %s, the xwidth is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (yheight <= 0) {
  printf("\nERROR in Union_box named %s, yheight is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (zdepth <= 0) {
  printf("\nERROR in Union_box named %s, zdepth is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (xwidth2 <= 0 && xwidth2 != -1) {
  printf("\nERROR in Union_box named %s, the xwidth2 is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (yheight2 <= 0 && yheight2 != -1) {
  printf("\nERROR in Union_box named %s, yheight2 is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}

// Use sanitation
if (global_material_list.num_elements == 0) {
  printf("\nERROR: Need to define a material using Union_make_material before using a Union geometry component. \n");
  printf("       %s was defined before first use of Union_make_material.\n",NAME_CURRENT_COMP);
  exit(1);
}

this_box_volume.geometry.is_masked_volume = 0;
this_box_volume.geometry.is_exit_volume = 0;
this_box_volume.geometry.is_mask_volume = 0;
// check if the volume is a mask, if it is the material string is irelevant.
if (mask_string && strlen(mask_string) && strcmp(mask_string, "NULL") && strcmp(mask_string, "0")) {
    // A mask volume is used to limit the extend of other volumes, called the masked volumes. These are specified in the mask_string.
    // In order for a ray to enter a masked volume, it needs to be both in the region covered by that volume AND the mask volume.
    // When more than
    this_box_volume.geometry.mask_mode = 1; // Default is mask mode is ALL
    if (mask_setting && strlen(mask_setting) && strcmp(mask_setting, "NULL") && strcmp(mask_setting, "0")) {
        if (strcmp(mask_setting,"ALL") == 0 || strcmp(mask_setting,"All") == 0) this_box_volume.geometry.mask_mode = 1;
        else if (strcmp(mask_setting,"ANY") == 0 || strcmp(mask_setting,"Any") == 0) this_box_volume.geometry.mask_mode = 2;
        else {
            printf("The mask_mode of component %s is set to %s, but must be either ALL or ANY.\n",NAME_CURRENT_COMP,mask_setting);
            exit(1);
        }
    }
    
    for (loop_index=0;loop_index<global_geometry_list.num_elements;loop_index++) {
        // Add mask list
        if (1 == manual_linking_function(global_geometry_list.elements[loop_index].name,mask_string)) {
            add_element_to_int_list(&this_box_volume.geometry.mask_list,global_geometry_list.elements[loop_index].component_index);
            add_element_to_int_list(&global_geometry_list.elements[loop_index].Volume->geometry.masked_by_list,INDEX_CURRENT_COMP);
            global_geometry_list.elements[loop_index].Volume->geometry.is_masked_volume = 1;
            if (this_box_volume.geometry.mask_mode == 2)
                global_geometry_list.elements[loop_index].Volume->geometry.mask_mode = 2;
            if (this_box_volume.geometry.mask_mode == 1) {
                if (global_geometry_list.elements[loop_index].Volume->geometry.is_masked_volume == 1 && global_geometry_list.elements[loop_index].Volume->geometry.mask_mode != 2)
                    // If more than one mask is added to one volume, the ANY mode overwrites the (default) ALL mode.
                    global_geometry_list.elements[loop_index].Volume->geometry.mask_mode = 1;
            }
            
            found_geometries = 1;
        }
    }
    if (found_geometries == 0) {
        printf("The mask_string in geometry: %s did not find any of the specified volumes in the mask_string %s \n",NAME_CURRENT_COMP,mask_string);
        exit(1);
    }
    this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
    this_box_volume.p_physics->is_vacuum = 0; // Makes this volume a vacuum
    this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
    this_box_volume.p_physics->my_a = 0; // Should not be used.
    sprintf(this_box_volume.p_physics->name,"Mask");
    this_box_volume.geometry.is_mask_volume = 1;
    
    
// Read the material input, or if it lacks, use automatic linking.
} else if (material_string && strlen(material_string) && strcmp(material_string, "NULL") && strcmp(material_string, "0")) {
    // A geometry string was given, use it to determine which material
    if (0 == strcmp(material_string,"vacuum") || 0 == strcmp(material_string,"Vacuum")) {
        // One could have a global physics struct for vacuum instead of creating one for each
        this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
        this_box_volume.p_physics->is_vacuum = 1; // Makes this volume a vacuum
        this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
        this_box_volume.p_physics->my_a = 0; // Should not be used.
        sprintf(this_box_volume.p_physics->name,"Vacuum");
    } else if (0 == strcmp(material_string,"exit") || 0 == strcmp(material_string,"Exit")) {
        // One could have a global physics struct for vacuum instead of creating one for each
        this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
        this_box_volume.p_physics->is_vacuum = 1; // Makes this volume a vacuum
        this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
        this_box_volume.p_physics->my_a = 0; // Should not be used.
        this_box_volume.geometry.is_exit_volume = 1;
        sprintf(this_box_volume.p_physics->name,"Exit");
    } else {
        #ifndef MATERIAL_DETECTOR
            printf("Need to define a material before refering to it in a geometry %s.\n",NAME_CURRENT_COMP);
            exit(1);
        #endif
        for (loop_index=0;loop_index<global_material_list.num_elements;loop_index++) {
            if (0 == strcmp(material_string,global_material_list.elements[loop_index].name)) {
                this_box_volume.p_physics = global_material_list.elements[loop_index].physics;
                break;
            }
            if (loop_index == global_material_list.num_elements-1) {
            printf("\n");
            printf("ERROR: The material string \"%s\" in Union geometry \"%s\" did not match a specified material. \n",material_string,NAME_CURRENT_COMP);
            printf("       The materials available at this point (need to be defined before the geometry): \n");
            for (loop_index=0;loop_index<global_material_list.num_elements;loop_index++)
              printf("         %s\n",global_material_list.elements[loop_index].name);
            printf("\n");
            printf("       It is also possible to use one of the defualt materials avaiable: \n");
            printf("           Vacuum (for a Volume without scattering or absorption)\n");
            printf("           Exit (for a Volume where the ray exits the component if it enters)\n");
            printf("           Mask (for a Volume that masks existing volumes specified in the mask_string\n");
            exit(1);
          }
        }
    }
} else {
    // Automatic linking, simply using the last defined material.
    #ifndef MATERIAL_DETECTOR
        printf("Need to define a material before the geometry to use automatic linking %s.\n",NAME_CURRENT_COMP);
        exit(1);
    #endif
    this_box_volume.p_physics = global_material_list.elements[global_material_list.num_elements-1].physics;
}

sprintf(this_box_volume.name,NAME_CURRENT_COMP);
sprintf(this_box_volume.geometry.shape,"box");
this_box_volume.geometry.priority_value = priority;
this_box_volume.geometry.geometry_p_interact = p_interact;
// Currently the coordinates will be in absolute space.
this_box_volume.geometry.center = POS_A_CURRENT_COMP;

this_box_storage.z_depth = zdepth;
this_box_storage.x_width1 = xwidth;
this_box_storage.y_height1 = yheight;

this_box_storage.is_rectangle = 0;
if (xwidth2 < 0 && yheight2 < 0) this_box_storage.is_rectangle = 1;
if (xwidth == xwidth2 && yheight == yheight2) this_box_storage.is_rectangle = 1;

if (xwidth2 < 0) {
    this_box_storage.x_width2 = xwidth;
    xwidth2 = xwidth;
} else this_box_storage.x_width2 = xwidth2;

if (yheight2 < 0) {
    this_box_storage.y_height2 = yheight;
    yheight2 = yheight;
} else this_box_storage.y_height2 = yheight2;


this_box_storage.normal_vectors[0] = coords_set(0,0,1);
this_box_storage.normal_vectors[1] = coords_set(0,0,1);

// for sides with y component = 0
x_component = 2*zdepth/sqrt((xwidth-xwidth2)*(xwidth-xwidth2)+4*zdepth*zdepth);
z_component = (xwidth-xwidth2)/sqrt(4*zdepth*zdepth+(xwidth-xwidth2)*(xwidth-xwidth2));

this_box_storage.normal_vectors[2] = coords_set(x_component,0,z_component);
this_box_storage.normal_vectors[3] = coords_set(-x_component,0,z_component);

// for sides with x component = 0
y_component = 2*zdepth/sqrt((yheight-yheight2)*(yheight-yheight2)+4*zdepth*zdepth);
z_component = (yheight-yheight2)/sqrt(4*zdepth*zdepth+(yheight-yheight2)*(yheight-yheight2));

this_box_storage.normal_vectors[4] = coords_set(0,y_component,z_component);
this_box_storage.normal_vectors[5] = coords_set(0,-y_component,z_component);

this_box_volume.geometry.visualization_on = visualize;

this_box_volume.geometry.geometry_parameters.p_box_storage = &this_box_storage;

// Assign pointers to functions for intersection with the shape, checking if a point is inside the shape
if (this_box_storage.is_rectangle == 1) {
this_box_volume.geometry.intersect_function = &sample_box_intersect_simple;
this_box_volume.geometry.within_function = &r_within_box_simple;
}
else {
this_box_volume.geometry.intersect_function = &sample_box_intersect_advanced;
this_box_volume.geometry.within_function = &r_within_box_advanced;
}

this_box_volume.geometry.shell_points = &box_shell_points;
this_box_volume.geometry.mcdisplay_function = &mcdisplay_box_function;
this_box_volume.geometry.initialize_from_main_function = &initialize_box_geometry_from_main_component;
this_box_volume.geometry.process_rot_allocated = 0;

this_box_volume.geometry.copy_geometry_parameters = &allocate_box_storage_copy;

rot_copy(this_box_volume.geometry.rotation_matrix,ROT_A_CURRENT_COMP); //check how ROT_R_CURRENT_COMP would work
rot_transpose(ROT_A_CURRENT_COMP,this_box_volume.geometry.transpose_rotation_matrix);

// Initialize loggers
this_box_volume.loggers.num_elements = 0;

// packing the information into the global_geometry_element, which is then included in the global_geometry_list.
sprintf(global_geometry_element.name,NAME_CURRENT_COMP);
global_geometry_element.activation_counter = number_of_activations;
global_geometry_element.component_index = INDEX_CURRENT_COMP;
global_geometry_element.Volume = &this_box_volume; // Would be nicer if this m was a pointer, now we have the (small) data two places
add_element_to_geometry_list(&global_geometry_list,global_geometry_element);
}
#line 323882 "MACS_sample_kidney_box.c"
#undef number_of_activations
#undef mask_setting
#undef mask_string
#undef p_interact
#undef focus_r
#undef focus_xh
#undef focus_xw
#undef focus_ah
#undef focus_aw
#undef target_z
#undef target_y
#undef target_x
#undef target_index
#undef visualize
#undef yheight2
#undef xwidth2
#undef zdepth
#undef yheight
#undef xwidth
#undef priority
#undef material_string
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

  /* Initializations for component channel_18_cave1_cyl1. */
  SIG_MESSAGE("channel_18_cave1_cyl1 (Init)");
#define mccompcurname  channel_18_cave1_cyl1
#define mccompcurtype  Union_cylinder
#define mccompcurindex 811
#define loop_index mccchannel_18_cave1_cyl1_loop_index
#define this_cylinder_volume mccchannel_18_cave1_cyl1_this_cylinder_volume
#define global_geometry_element mccchannel_18_cave1_cyl1_global_geometry_element
#define this_cylinder_storage mccchannel_18_cave1_cyl1_this_cylinder_storage
#define material_string mccchannel_18_cave1_cyl1_material_string
#define priority mccchannel_18_cave1_cyl1_priority
#define radius mccchannel_18_cave1_cyl1_radius
#define yheight mccchannel_18_cave1_cyl1_yheight
#define visualize mccchannel_18_cave1_cyl1_visualize
#define target_index mccchannel_18_cave1_cyl1_target_index
#define target_x mccchannel_18_cave1_cyl1_target_x
#define target_y mccchannel_18_cave1_cyl1_target_y
#define target_z mccchannel_18_cave1_cyl1_target_z
#define focus_aw mccchannel_18_cave1_cyl1_focus_aw
#define focus_ah mccchannel_18_cave1_cyl1_focus_ah
#define focus_xw mccchannel_18_cave1_cyl1_focus_xw
#define focus_xh mccchannel_18_cave1_cyl1_focus_xh
#define focus_r mccchannel_18_cave1_cyl1_focus_r
#define p_interact mccchannel_18_cave1_cyl1_p_interact
#define mask_string mccchannel_18_cave1_cyl1_mask_string
#define mask_setting mccchannel_18_cave1_cyl1_mask_setting
#define number_of_activations mccchannel_18_cave1_cyl1_number_of_activations
#line 185 "Union_cylinder.comp"
{
// Initializes the focusing system for this volume including input sanitation.
focus_initialize(&this_cylinder_volume.geometry, POS_A_COMP_INDEX(INDEX_CURRENT_COMP+target_index), POS_A_CURRENT_COMP, ROT_A_CURRENT_COMP, target_index, target_x, target_y, target_z, focus_aw, focus_ah, focus_xw, focus_xh, focus_r, NAME_CURRENT_COMP);

// Input sanitation for this geometry
if (radius <= 0) {
  printf("\nERROR in Union_cylinder named %s, the radius is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}

if (yheight <= 0) {
  printf("\nERROR in Union_cylinder named %s, yheight is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}

// Use sanitation
#ifdef MATERIAL_DETECTOR
if (global_material_list.num_elements == 0) {
  // Here if the user have defined a material, but only after this material
  printf("\nERROR: Need to define a material using Union_make_material before using a Union geometry component. \n");
  printf("       %s was defined before first use of Union_make_material.\n",NAME_CURRENT_COMP);
  exit(1);
}
#endif
#ifndef MATERIAL_DETECTOR
  printf("\nERROR: Need to define a material using Union_make_material before using a Union geometry component. \n");
  exit(1);
#endif


this_cylinder_volume.geometry.is_masked_volume = 0;
this_cylinder_volume.geometry.is_exit_volume = 0;
this_cylinder_volume.geometry.is_mask_volume = 0;

// Read the material input, or if it lacks, use automatic linking.
if (mask_string && strlen(mask_string) && strcmp(mask_string, "NULL") && strcmp(mask_string, "0")) {
    // A mask volume is used to limit the extend of other volumes, called the masked volumes. These are specified in the mask_string.
    // In order for a ray to enter a masked volume, it needs to be both in the region covered by that volume AND the mask volume.
    // When more than
    this_cylinder_volume.geometry.mask_mode = 1; // Default is mask mode is ALL
    if (mask_setting && strlen(mask_setting) && strcmp(mask_setting, "NULL") && strcmp(mask_setting, "0")) {
        if (strcmp(mask_setting,"ALL") == 0 || strcmp(mask_setting,"All") == 0) this_cylinder_volume.geometry.mask_mode = 1;
        else if (strcmp(mask_setting,"ANY") == 0 || strcmp(mask_setting,"Any") == 0) this_cylinder_volume.geometry.mask_mode = 2;
        else {
            printf("The mask_mode of component %s is set to %s, but must be either ALL or ANY.\n",NAME_CURRENT_COMP,mask_setting);
            exit(1);
        }
    }
    
    for (loop_index=0;loop_index<global_geometry_list.num_elements;loop_index++) {
        // Add mask list
        if (1 == manual_linking_function(global_geometry_list.elements[loop_index].name,mask_string)) {
            add_element_to_int_list(&this_cylinder_volume.geometry.mask_list,global_geometry_list.elements[loop_index].component_index);
            add_element_to_int_list(&global_geometry_list.elements[loop_index].Volume->geometry.masked_by_list,INDEX_CURRENT_COMP);
            global_geometry_list.elements[loop_index].Volume->geometry.is_masked_volume = 1;
            if (this_cylinder_volume.geometry.mask_mode == 2)
                global_geometry_list.elements[loop_index].Volume->geometry.mask_mode = 2;
            if (this_cylinder_volume.geometry.mask_mode == 1) {
                if (global_geometry_list.elements[loop_index].Volume->geometry.is_masked_volume == 1 && global_geometry_list.elements[loop_index].Volume->geometry.mask_mode != 2)
                    // If more than one mask is added to one volume, the ANY mode overwrites the (default) ALL mode.
                    global_geometry_list.elements[loop_index].Volume->geometry.mask_mode = 1;
            }
            
            found_geometries = 1;
        }
    }
    if (found_geometries == 0) {
        printf("The mask_string in geometry: %s did not find any of the specified volumes in the mask_string %s \n",NAME_CURRENT_COMP,mask_string);
        exit(1);
    }
    this_cylinder_volume.p_physics = malloc(sizeof(struct physics_struct));
    this_cylinder_volume.p_physics->is_vacuum = 0; // Makes this volume a vacuum
    this_cylinder_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
    this_cylinder_volume.p_physics->my_a = 0; // Should not be used.
    sprintf(this_cylinder_volume.p_physics->name,"Mask");
    this_cylinder_volume.geometry.is_mask_volume = 1;
    
    
// Read the material input, or if it lacks, use automatic linking.
} else if (material_string && strlen(material_string) && strcmp(material_string, "NULL") && strcmp(material_string, "0")) {
    // A geometry string was given, use it to determine which material
    if (0 == strcmp(material_string,"vacuum") || 0 == strcmp(material_string,"Vacuum")) {
        // One could have a global physics struct for vacuum instead of creating one for each
        this_cylinder_volume.p_physics = malloc(sizeof(struct physics_struct));
        this_cylinder_volume.p_physics->is_vacuum = 1; // Makes this volume a vacuum
        this_cylinder_volume.p_physics->number_of_processes = (int) 0;
        this_cylinder_volume.p_physics->my_a = 0; // Should not be used.
        sprintf(this_cylinder_volume.p_physics->name,"Vacuum");
    } else if (0 == strcmp(material_string,"exit") || 0 == strcmp(material_string,"Exit")) {
        // One could have a global physics struct for exit instead of creating one for each
        this_cylinder_volume.p_physics = malloc(sizeof(struct physics_struct));
        this_cylinder_volume.p_physics->is_vacuum = 1; // Makes this volume a vacuum
        this_cylinder_volume.p_physics->number_of_processes = (int) 0;
        this_cylinder_volume.p_physics->my_a = 0; // Should not be used.
        this_cylinder_volume.geometry.is_exit_volume = 1;
        sprintf(this_cylinder_volume.p_physics->name,"Exit");
    } else {
        for (loop_index=0;loop_index<global_material_list.num_elements;loop_index++) {
          if (0 == strcmp(material_string,global_material_list.elements[loop_index].name)) {
            this_cylinder_volume.p_physics = global_material_list.elements[loop_index].physics;
            break;
          }
          if (loop_index == global_material_list.num_elements-1) {
            printf("\n");
            printf("ERROR: The material string \"%s\" in Union geometry \"%s\" did not match a specified material. \n",material_string,NAME_CURRENT_COMP);
            printf("       The materials available at this point (need to be defined before the geometry): \n");
            for (loop_index=0;loop_index<global_material_list.num_elements;loop_index++)
              printf("         %s\n",global_material_list.elements[loop_index].name);
            printf("\n");
            printf("       It is also possible to use one of the defualt materials avaiable: \n");
            printf("           Vacuum (for a Volume without scattering or absorption)\n");
            printf("           Exit (for a Volume where the ray exits the component if it enters)\n");
            printf("           Mask (for a Volume that masks existing volumes specified in the mask_string\n");
            exit(1);
          }
        }
    }
} else {
    // Automatic linking, simply using the last defined material.
    #ifndef MATERIAL_DETECTOR
        printf("Need to define a material before the geometry to use automatic linking %s.\n",NAME_CURRENT_COMP);
        exit(1);
    #endif
    this_cylinder_volume.p_physics = global_material_list.elements[global_material_list.num_elements-1].physics;
}

sprintf(this_cylinder_volume.name,NAME_CURRENT_COMP);
sprintf(this_cylinder_volume.geometry.shape,"cylinder");
this_cylinder_volume.geometry.priority_value = priority;
// Currently the coordinates will be in absolute space.
this_cylinder_volume.geometry.center = POS_A_CURRENT_COMP;

this_cylinder_volume.geometry.geometry_p_interact = p_interact;
this_cylinder_storage.cyl_radius = radius;
this_cylinder_storage.height = yheight;
this_cylinder_volume.geometry.visualization_on = visualize;
this_cylinder_volume.geometry.geometry_parameters.p_cylinder_storage = &this_cylinder_storage;
this_cylinder_volume.geometry.within_function = &r_within_cylinder;
this_cylinder_volume.geometry.intersect_function = &sample_cylinder_intersect;
this_cylinder_volume.geometry.mcdisplay_function = &mcdisplay_cylinder_function;
this_cylinder_volume.geometry.shell_points = &cylinder_shell_points;
this_cylinder_volume.geometry.initialize_from_main_function = &initialize_cylinder_geometry_from_main_component;
this_cylinder_volume.geometry.process_rot_allocated = 0;
this_cylinder_volume.geometry.copy_geometry_parameters = &allocate_cylinder_storage_copy;

rot_copy(this_cylinder_volume.geometry.rotation_matrix,ROT_A_CURRENT_COMP);
rot_transpose(ROT_A_CURRENT_COMP,this_cylinder_volume.geometry.transpose_rotation_matrix);

// Initialize loggers
this_cylinder_volume.loggers.num_elements = 0;

// packing the information into the global_geometry_element, which is then included in the global_geometry_list.
sprintf(global_geometry_element.name,NAME_CURRENT_COMP);
global_geometry_element.activation_counter = number_of_activations;
global_geometry_element.component_index = INDEX_CURRENT_COMP;
global_geometry_element.Volume = &this_cylinder_volume; // Would be nicer if this m was a pointer, now we have the (small) data two places
add_element_to_geometry_list(&global_geometry_list,global_geometry_element);
}
#line 324098 "MACS_sample_kidney_box.c"
#undef number_of_activations
#undef mask_setting
#undef mask_string
#undef p_interact
#undef focus_r
#undef focus_xh
#undef focus_xw
#undef focus_ah
#undef focus_aw
#undef target_z
#undef target_y
#undef target_x
#undef target_index
#undef visualize
#undef yheight
#undef radius
#undef priority
#undef material_string
#undef this_cylinder_storage
#undef global_geometry_element
#undef this_cylinder_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

  /* Initializations for component channel_18_analyzer_1_center. */
  SIG_MESSAGE("channel_18_analyzer_1_center (Init)");

  /* Initializations for component channel_18_analyzer_1_rotated. */
  SIG_MESSAGE("channel_18_analyzer_1_rotated (Init)");

  /* Initializations for component channel_18_analyzer_1_array_crystal_array_0. */
  SIG_MESSAGE("channel_18_analyzer_1_array_crystal_array_0 (Init)");
#define mccompcurname  channel_18_analyzer_1_array_crystal_array_0
#define mccompcurtype  Union_box
#define mccompcurindex 814
#define loop_index mccchannel_18_analyzer_1_array_crystal_array_0_loop_index
#define this_box_volume mccchannel_18_analyzer_1_array_crystal_array_0_this_box_volume
#define global_geometry_element mccchannel_18_analyzer_1_array_crystal_array_0_global_geometry_element
#define this_box_storage mccchannel_18_analyzer_1_array_crystal_array_0_this_box_storage
#define material_string mccchannel_18_analyzer_1_array_crystal_array_0_material_string
#define priority mccchannel_18_analyzer_1_array_crystal_array_0_priority
#define xwidth mccchannel_18_analyzer_1_array_crystal_array_0_xwidth
#define yheight mccchannel_18_analyzer_1_array_crystal_array_0_yheight
#define zdepth mccchannel_18_analyzer_1_array_crystal_array_0_zdepth
#define xwidth2 mccchannel_18_analyzer_1_array_crystal_array_0_xwidth2
#define yheight2 mccchannel_18_analyzer_1_array_crystal_array_0_yheight2
#define visualize mccchannel_18_analyzer_1_array_crystal_array_0_visualize
#define target_index mccchannel_18_analyzer_1_array_crystal_array_0_target_index
#define target_x mccchannel_18_analyzer_1_array_crystal_array_0_target_x
#define target_y mccchannel_18_analyzer_1_array_crystal_array_0_target_y
#define target_z mccchannel_18_analyzer_1_array_crystal_array_0_target_z
#define focus_aw mccchannel_18_analyzer_1_array_crystal_array_0_focus_aw
#define focus_ah mccchannel_18_analyzer_1_array_crystal_array_0_focus_ah
#define focus_xw mccchannel_18_analyzer_1_array_crystal_array_0_focus_xw
#define focus_xh mccchannel_18_analyzer_1_array_crystal_array_0_focus_xh
#define focus_r mccchannel_18_analyzer_1_array_crystal_array_0_focus_r
#define p_interact mccchannel_18_analyzer_1_array_crystal_array_0_p_interact
#define mask_string mccchannel_18_analyzer_1_array_crystal_array_0_mask_string
#define mask_setting mccchannel_18_analyzer_1_array_crystal_array_0_mask_setting
#define number_of_activations mccchannel_18_analyzer_1_array_crystal_array_0_number_of_activations
#line 224 "Union_box.comp"
{
// Initializes the focusing system for this volume including input sanitation.
focus_initialize(&this_box_volume.geometry, POS_A_COMP_INDEX(INDEX_CURRENT_COMP+target_index), POS_A_CURRENT_COMP, ROT_A_CURRENT_COMP, target_index, target_x, target_y, target_z, focus_aw, focus_ah, focus_xw, focus_xh, focus_r, NAME_CURRENT_COMP);

// Input sanitation for this geometry
if (xwidth <= 0) {
  printf("\nERROR in Union_box named %s, the xwidth is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (yheight <= 0) {
  printf("\nERROR in Union_box named %s, yheight is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (zdepth <= 0) {
  printf("\nERROR in Union_box named %s, zdepth is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (xwidth2 <= 0 && xwidth2 != -1) {
  printf("\nERROR in Union_box named %s, the xwidth2 is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (yheight2 <= 0 && yheight2 != -1) {
  printf("\nERROR in Union_box named %s, yheight2 is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}

// Use sanitation
if (global_material_list.num_elements == 0) {
  printf("\nERROR: Need to define a material using Union_make_material before using a Union geometry component. \n");
  printf("       %s was defined before first use of Union_make_material.\n",NAME_CURRENT_COMP);
  exit(1);
}

this_box_volume.geometry.is_masked_volume = 0;
this_box_volume.geometry.is_exit_volume = 0;
this_box_volume.geometry.is_mask_volume = 0;
// check if the volume is a mask, if it is the material string is irelevant.
if (mask_string && strlen(mask_string) && strcmp(mask_string, "NULL") && strcmp(mask_string, "0")) {
    // A mask volume is used to limit the extend of other volumes, called the masked volumes. These are specified in the mask_string.
    // In order for a ray to enter a masked volume, it needs to be both in the region covered by that volume AND the mask volume.
    // When more than
    this_box_volume.geometry.mask_mode = 1; // Default is mask mode is ALL
    if (mask_setting && strlen(mask_setting) && strcmp(mask_setting, "NULL") && strcmp(mask_setting, "0")) {
        if (strcmp(mask_setting,"ALL") == 0 || strcmp(mask_setting,"All") == 0) this_box_volume.geometry.mask_mode = 1;
        else if (strcmp(mask_setting,"ANY") == 0 || strcmp(mask_setting,"Any") == 0) this_box_volume.geometry.mask_mode = 2;
        else {
            printf("The mask_mode of component %s is set to %s, but must be either ALL or ANY.\n",NAME_CURRENT_COMP,mask_setting);
            exit(1);
        }
    }
    
    for (loop_index=0;loop_index<global_geometry_list.num_elements;loop_index++) {
        // Add mask list
        if (1 == manual_linking_function(global_geometry_list.elements[loop_index].name,mask_string)) {
            add_element_to_int_list(&this_box_volume.geometry.mask_list,global_geometry_list.elements[loop_index].component_index);
            add_element_to_int_list(&global_geometry_list.elements[loop_index].Volume->geometry.masked_by_list,INDEX_CURRENT_COMP);
            global_geometry_list.elements[loop_index].Volume->geometry.is_masked_volume = 1;
            if (this_box_volume.geometry.mask_mode == 2)
                global_geometry_list.elements[loop_index].Volume->geometry.mask_mode = 2;
            if (this_box_volume.geometry.mask_mode == 1) {
                if (global_geometry_list.elements[loop_index].Volume->geometry.is_masked_volume == 1 && global_geometry_list.elements[loop_index].Volume->geometry.mask_mode != 2)
                    // If more than one mask is added to one volume, the ANY mode overwrites the (default) ALL mode.
                    global_geometry_list.elements[loop_index].Volume->geometry.mask_mode = 1;
            }
            
            found_geometries = 1;
        }
    }
    if (found_geometries == 0) {
        printf("The mask_string in geometry: %s did not find any of the specified volumes in the mask_string %s \n",NAME_CURRENT_COMP,mask_string);
        exit(1);
    }
    this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
    this_box_volume.p_physics->is_vacuum = 0; // Makes this volume a vacuum
    this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
    this_box_volume.p_physics->my_a = 0; // Should not be used.
    sprintf(this_box_volume.p_physics->name,"Mask");
    this_box_volume.geometry.is_mask_volume = 1;
    
    
// Read the material input, or if it lacks, use automatic linking.
} else if (material_string && strlen(material_string) && strcmp(material_string, "NULL") && strcmp(material_string, "0")) {
    // A geometry string was given, use it to determine which material
    if (0 == strcmp(material_string,"vacuum") || 0 == strcmp(material_string,"Vacuum")) {
        // One could have a global physics struct for vacuum instead of creating one for each
        this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
        this_box_volume.p_physics->is_vacuum = 1; // Makes this volume a vacuum
        this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
        this_box_volume.p_physics->my_a = 0; // Should not be used.
        sprintf(this_box_volume.p_physics->name,"Vacuum");
    } else if (0 == strcmp(material_string,"exit") || 0 == strcmp(material_string,"Exit")) {
        // One could have a global physics struct for vacuum instead of creating one for each
        this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
        this_box_volume.p_physics->is_vacuum = 1; // Makes this volume a vacuum
        this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
        this_box_volume.p_physics->my_a = 0; // Should not be used.
        this_box_volume.geometry.is_exit_volume = 1;
        sprintf(this_box_volume.p_physics->name,"Exit");
    } else {
        #ifndef MATERIAL_DETECTOR
            printf("Need to define a material before refering to it in a geometry %s.\n",NAME_CURRENT_COMP);
            exit(1);
        #endif
        for (loop_index=0;loop_index<global_material_list.num_elements;loop_index++) {
            if (0 == strcmp(material_string,global_material_list.elements[loop_index].name)) {
                this_box_volume.p_physics = global_material_list.elements[loop_index].physics;
                break;
            }
            if (loop_index == global_material_list.num_elements-1) {
            printf("\n");
            printf("ERROR: The material string \"%s\" in Union geometry \"%s\" did not match a specified material. \n",material_string,NAME_CURRENT_COMP);
            printf("       The materials available at this point (need to be defined before the geometry): \n");
            for (loop_index=0;loop_index<global_material_list.num_elements;loop_index++)
              printf("         %s\n",global_material_list.elements[loop_index].name);
            printf("\n");
            printf("       It is also possible to use one of the defualt materials avaiable: \n");
            printf("           Vacuum (for a Volume without scattering or absorption)\n");
            printf("           Exit (for a Volume where the ray exits the component if it enters)\n");
            printf("           Mask (for a Volume that masks existing volumes specified in the mask_string\n");
            exit(1);
          }
        }
    }
} else {
    // Automatic linking, simply using the last defined material.
    #ifndef MATERIAL_DETECTOR
        printf("Need to define a material before the geometry to use automatic linking %s.\n",NAME_CURRENT_COMP);
        exit(1);
    #endif
    this_box_volume.p_physics = global_material_list.elements[global_material_list.num_elements-1].physics;
}

sprintf(this_box_volume.name,NAME_CURRENT_COMP);
sprintf(this_box_volume.geometry.shape,"box");
this_box_volume.geometry.priority_value = priority;
this_box_volume.geometry.geometry_p_interact = p_interact;
// Currently the coordinates will be in absolute space.
this_box_volume.geometry.center = POS_A_CURRENT_COMP;

this_box_storage.z_depth = zdepth;
this_box_storage.x_width1 = xwidth;
this_box_storage.y_height1 = yheight;

this_box_storage.is_rectangle = 0;
if (xwidth2 < 0 && yheight2 < 0) this_box_storage.is_rectangle = 1;
if (xwidth == xwidth2 && yheight == yheight2) this_box_storage.is_rectangle = 1;

if (xwidth2 < 0) {
    this_box_storage.x_width2 = xwidth;
    xwidth2 = xwidth;
} else this_box_storage.x_width2 = xwidth2;

if (yheight2 < 0) {
    this_box_storage.y_height2 = yheight;
    yheight2 = yheight;
} else this_box_storage.y_height2 = yheight2;


this_box_storage.normal_vectors[0] = coords_set(0,0,1);
this_box_storage.normal_vectors[1] = coords_set(0,0,1);

// for sides with y component = 0
x_component = 2*zdepth/sqrt((xwidth-xwidth2)*(xwidth-xwidth2)+4*zdepth*zdepth);
z_component = (xwidth-xwidth2)/sqrt(4*zdepth*zdepth+(xwidth-xwidth2)*(xwidth-xwidth2));

this_box_storage.normal_vectors[2] = coords_set(x_component,0,z_component);
this_box_storage.normal_vectors[3] = coords_set(-x_component,0,z_component);

// for sides with x component = 0
y_component = 2*zdepth/sqrt((yheight-yheight2)*(yheight-yheight2)+4*zdepth*zdepth);
z_component = (yheight-yheight2)/sqrt(4*zdepth*zdepth+(yheight-yheight2)*(yheight-yheight2));

this_box_storage.normal_vectors[4] = coords_set(0,y_component,z_component);
this_box_storage.normal_vectors[5] = coords_set(0,-y_component,z_component);

this_box_volume.geometry.visualization_on = visualize;

this_box_volume.geometry.geometry_parameters.p_box_storage = &this_box_storage;

// Assign pointers to functions for intersection with the shape, checking if a point is inside the shape
if (this_box_storage.is_rectangle == 1) {
this_box_volume.geometry.intersect_function = &sample_box_intersect_simple;
this_box_volume.geometry.within_function = &r_within_box_simple;
}
else {
this_box_volume.geometry.intersect_function = &sample_box_intersect_advanced;
this_box_volume.geometry.within_function = &r_within_box_advanced;
}

this_box_volume.geometry.shell_points = &box_shell_points;
this_box_volume.geometry.mcdisplay_function = &mcdisplay_box_function;
this_box_volume.geometry.initialize_from_main_function = &initialize_box_geometry_from_main_component;
this_box_volume.geometry.process_rot_allocated = 0;

this_box_volume.geometry.copy_geometry_parameters = &allocate_box_storage_copy;

rot_copy(this_box_volume.geometry.rotation_matrix,ROT_A_CURRENT_COMP); //check how ROT_R_CURRENT_COMP would work
rot_transpose(ROT_A_CURRENT_COMP,this_box_volume.geometry.transpose_rotation_matrix);

// Initialize loggers
this_box_volume.loggers.num_elements = 0;

// packing the information into the global_geometry_element, which is then included in the global_geometry_list.
sprintf(global_geometry_element.name,NAME_CURRENT_COMP);
global_geometry_element.activation_counter = number_of_activations;
global_geometry_element.component_index = INDEX_CURRENT_COMP;
global_geometry_element.Volume = &this_box_volume; // Would be nicer if this m was a pointer, now we have the (small) data two places
add_element_to_geometry_list(&global_geometry_list,global_geometry_element);
}
#line 324371 "MACS_sample_kidney_box.c"
#undef number_of_activations
#undef mask_setting
#undef mask_string
#undef p_interact
#undef focus_r
#undef focus_xh
#undef focus_xw
#undef focus_ah
#undef focus_aw
#undef target_z
#undef target_y
#undef target_x
#undef target_index
#undef visualize
#undef yheight2
#undef xwidth2
#undef zdepth
#undef yheight
#undef xwidth
#undef priority
#undef material_string
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

  /* Initializations for component channel_18_analyzer_1_array_crystal_array_1. */
  SIG_MESSAGE("channel_18_analyzer_1_array_crystal_array_1 (Init)");
#define mccompcurname  channel_18_analyzer_1_array_crystal_array_1
#define mccompcurtype  Union_box
#define mccompcurindex 815
#define loop_index mccchannel_18_analyzer_1_array_crystal_array_1_loop_index
#define this_box_volume mccchannel_18_analyzer_1_array_crystal_array_1_this_box_volume
#define global_geometry_element mccchannel_18_analyzer_1_array_crystal_array_1_global_geometry_element
#define this_box_storage mccchannel_18_analyzer_1_array_crystal_array_1_this_box_storage
#define material_string mccchannel_18_analyzer_1_array_crystal_array_1_material_string
#define priority mccchannel_18_analyzer_1_array_crystal_array_1_priority
#define xwidth mccchannel_18_analyzer_1_array_crystal_array_1_xwidth
#define yheight mccchannel_18_analyzer_1_array_crystal_array_1_yheight
#define zdepth mccchannel_18_analyzer_1_array_crystal_array_1_zdepth
#define xwidth2 mccchannel_18_analyzer_1_array_crystal_array_1_xwidth2
#define yheight2 mccchannel_18_analyzer_1_array_crystal_array_1_yheight2
#define visualize mccchannel_18_analyzer_1_array_crystal_array_1_visualize
#define target_index mccchannel_18_analyzer_1_array_crystal_array_1_target_index
#define target_x mccchannel_18_analyzer_1_array_crystal_array_1_target_x
#define target_y mccchannel_18_analyzer_1_array_crystal_array_1_target_y
#define target_z mccchannel_18_analyzer_1_array_crystal_array_1_target_z
#define focus_aw mccchannel_18_analyzer_1_array_crystal_array_1_focus_aw
#define focus_ah mccchannel_18_analyzer_1_array_crystal_array_1_focus_ah
#define focus_xw mccchannel_18_analyzer_1_array_crystal_array_1_focus_xw
#define focus_xh mccchannel_18_analyzer_1_array_crystal_array_1_focus_xh
#define focus_r mccchannel_18_analyzer_1_array_crystal_array_1_focus_r
#define p_interact mccchannel_18_analyzer_1_array_crystal_array_1_p_interact
#define mask_string mccchannel_18_analyzer_1_array_crystal_array_1_mask_string
#define mask_setting mccchannel_18_analyzer_1_array_crystal_array_1_mask_setting
#define number_of_activations mccchannel_18_analyzer_1_array_crystal_array_1_number_of_activations
#line 224 "Union_box.comp"
{
// Initializes the focusing system for this volume including input sanitation.
focus_initialize(&this_box_volume.geometry, POS_A_COMP_INDEX(INDEX_CURRENT_COMP+target_index), POS_A_CURRENT_COMP, ROT_A_CURRENT_COMP, target_index, target_x, target_y, target_z, focus_aw, focus_ah, focus_xw, focus_xh, focus_r, NAME_CURRENT_COMP);

// Input sanitation for this geometry
if (xwidth <= 0) {
  printf("\nERROR in Union_box named %s, the xwidth is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (yheight <= 0) {
  printf("\nERROR in Union_box named %s, yheight is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (zdepth <= 0) {
  printf("\nERROR in Union_box named %s, zdepth is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (xwidth2 <= 0 && xwidth2 != -1) {
  printf("\nERROR in Union_box named %s, the xwidth2 is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (yheight2 <= 0 && yheight2 != -1) {
  printf("\nERROR in Union_box named %s, yheight2 is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}

// Use sanitation
if (global_material_list.num_elements == 0) {
  printf("\nERROR: Need to define a material using Union_make_material before using a Union geometry component. \n");
  printf("       %s was defined before first use of Union_make_material.\n",NAME_CURRENT_COMP);
  exit(1);
}

this_box_volume.geometry.is_masked_volume = 0;
this_box_volume.geometry.is_exit_volume = 0;
this_box_volume.geometry.is_mask_volume = 0;
// check if the volume is a mask, if it is the material string is irelevant.
if (mask_string && strlen(mask_string) && strcmp(mask_string, "NULL") && strcmp(mask_string, "0")) {
    // A mask volume is used to limit the extend of other volumes, called the masked volumes. These are specified in the mask_string.
    // In order for a ray to enter a masked volume, it needs to be both in the region covered by that volume AND the mask volume.
    // When more than
    this_box_volume.geometry.mask_mode = 1; // Default is mask mode is ALL
    if (mask_setting && strlen(mask_setting) && strcmp(mask_setting, "NULL") && strcmp(mask_setting, "0")) {
        if (strcmp(mask_setting,"ALL") == 0 || strcmp(mask_setting,"All") == 0) this_box_volume.geometry.mask_mode = 1;
        else if (strcmp(mask_setting,"ANY") == 0 || strcmp(mask_setting,"Any") == 0) this_box_volume.geometry.mask_mode = 2;
        else {
            printf("The mask_mode of component %s is set to %s, but must be either ALL or ANY.\n",NAME_CURRENT_COMP,mask_setting);
            exit(1);
        }
    }
    
    for (loop_index=0;loop_index<global_geometry_list.num_elements;loop_index++) {
        // Add mask list
        if (1 == manual_linking_function(global_geometry_list.elements[loop_index].name,mask_string)) {
            add_element_to_int_list(&this_box_volume.geometry.mask_list,global_geometry_list.elements[loop_index].component_index);
            add_element_to_int_list(&global_geometry_list.elements[loop_index].Volume->geometry.masked_by_list,INDEX_CURRENT_COMP);
            global_geometry_list.elements[loop_index].Volume->geometry.is_masked_volume = 1;
            if (this_box_volume.geometry.mask_mode == 2)
                global_geometry_list.elements[loop_index].Volume->geometry.mask_mode = 2;
            if (this_box_volume.geometry.mask_mode == 1) {
                if (global_geometry_list.elements[loop_index].Volume->geometry.is_masked_volume == 1 && global_geometry_list.elements[loop_index].Volume->geometry.mask_mode != 2)
                    // If more than one mask is added to one volume, the ANY mode overwrites the (default) ALL mode.
                    global_geometry_list.elements[loop_index].Volume->geometry.mask_mode = 1;
            }
            
            found_geometries = 1;
        }
    }
    if (found_geometries == 0) {
        printf("The mask_string in geometry: %s did not find any of the specified volumes in the mask_string %s \n",NAME_CURRENT_COMP,mask_string);
        exit(1);
    }
    this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
    this_box_volume.p_physics->is_vacuum = 0; // Makes this volume a vacuum
    this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
    this_box_volume.p_physics->my_a = 0; // Should not be used.
    sprintf(this_box_volume.p_physics->name,"Mask");
    this_box_volume.geometry.is_mask_volume = 1;
    
    
// Read the material input, or if it lacks, use automatic linking.
} else if (material_string && strlen(material_string) && strcmp(material_string, "NULL") && strcmp(material_string, "0")) {
    // A geometry string was given, use it to determine which material
    if (0 == strcmp(material_string,"vacuum") || 0 == strcmp(material_string,"Vacuum")) {
        // One could have a global physics struct for vacuum instead of creating one for each
        this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
        this_box_volume.p_physics->is_vacuum = 1; // Makes this volume a vacuum
        this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
        this_box_volume.p_physics->my_a = 0; // Should not be used.
        sprintf(this_box_volume.p_physics->name,"Vacuum");
    } else if (0 == strcmp(material_string,"exit") || 0 == strcmp(material_string,"Exit")) {
        // One could have a global physics struct for vacuum instead of creating one for each
        this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
        this_box_volume.p_physics->is_vacuum = 1; // Makes this volume a vacuum
        this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
        this_box_volume.p_physics->my_a = 0; // Should not be used.
        this_box_volume.geometry.is_exit_volume = 1;
        sprintf(this_box_volume.p_physics->name,"Exit");
    } else {
        #ifndef MATERIAL_DETECTOR
            printf("Need to define a material before refering to it in a geometry %s.\n",NAME_CURRENT_COMP);
            exit(1);
        #endif
        for (loop_index=0;loop_index<global_material_list.num_elements;loop_index++) {
            if (0 == strcmp(material_string,global_material_list.elements[loop_index].name)) {
                this_box_volume.p_physics = global_material_list.elements[loop_index].physics;
                break;
            }
            if (loop_index == global_material_list.num_elements-1) {
            printf("\n");
            printf("ERROR: The material string \"%s\" in Union geometry \"%s\" did not match a specified material. \n",material_string,NAME_CURRENT_COMP);
            printf("       The materials available at this point (need to be defined before the geometry): \n");
            for (loop_index=0;loop_index<global_material_list.num_elements;loop_index++)
              printf("         %s\n",global_material_list.elements[loop_index].name);
            printf("\n");
            printf("       It is also possible to use one of the defualt materials avaiable: \n");
            printf("           Vacuum (for a Volume without scattering or absorption)\n");
            printf("           Exit (for a Volume where the ray exits the component if it enters)\n");
            printf("           Mask (for a Volume that masks existing volumes specified in the mask_string\n");
            exit(1);
          }
        }
    }
} else {
    // Automatic linking, simply using the last defined material.
    #ifndef MATERIAL_DETECTOR
        printf("Need to define a material before the geometry to use automatic linking %s.\n",NAME_CURRENT_COMP);
        exit(1);
    #endif
    this_box_volume.p_physics = global_material_list.elements[global_material_list.num_elements-1].physics;
}

sprintf(this_box_volume.name,NAME_CURRENT_COMP);
sprintf(this_box_volume.geometry.shape,"box");
this_box_volume.geometry.priority_value = priority;
this_box_volume.geometry.geometry_p_interact = p_interact;
// Currently the coordinates will be in absolute space.
this_box_volume.geometry.center = POS_A_CURRENT_COMP;

this_box_storage.z_depth = zdepth;
this_box_storage.x_width1 = xwidth;
this_box_storage.y_height1 = yheight;

this_box_storage.is_rectangle = 0;
if (xwidth2 < 0 && yheight2 < 0) this_box_storage.is_rectangle = 1;
if (xwidth == xwidth2 && yheight == yheight2) this_box_storage.is_rectangle = 1;

if (xwidth2 < 0) {
    this_box_storage.x_width2 = xwidth;
    xwidth2 = xwidth;
} else this_box_storage.x_width2 = xwidth2;

if (yheight2 < 0) {
    this_box_storage.y_height2 = yheight;
    yheight2 = yheight;
} else this_box_storage.y_height2 = yheight2;


this_box_storage.normal_vectors[0] = coords_set(0,0,1);
this_box_storage.normal_vectors[1] = coords_set(0,0,1);

// for sides with y component = 0
x_component = 2*zdepth/sqrt((xwidth-xwidth2)*(xwidth-xwidth2)+4*zdepth*zdepth);
z_component = (xwidth-xwidth2)/sqrt(4*zdepth*zdepth+(xwidth-xwidth2)*(xwidth-xwidth2));

this_box_storage.normal_vectors[2] = coords_set(x_component,0,z_component);
this_box_storage.normal_vectors[3] = coords_set(-x_component,0,z_component);

// for sides with x component = 0
y_component = 2*zdepth/sqrt((yheight-yheight2)*(yheight-yheight2)+4*zdepth*zdepth);
z_component = (yheight-yheight2)/sqrt(4*zdepth*zdepth+(yheight-yheight2)*(yheight-yheight2));

this_box_storage.normal_vectors[4] = coords_set(0,y_component,z_component);
this_box_storage.normal_vectors[5] = coords_set(0,-y_component,z_component);

this_box_volume.geometry.visualization_on = visualize;

this_box_volume.geometry.geometry_parameters.p_box_storage = &this_box_storage;

// Assign pointers to functions for intersection with the shape, checking if a point is inside the shape
if (this_box_storage.is_rectangle == 1) {
this_box_volume.geometry.intersect_function = &sample_box_intersect_simple;
this_box_volume.geometry.within_function = &r_within_box_simple;
}
else {
this_box_volume.geometry.intersect_function = &sample_box_intersect_advanced;
this_box_volume.geometry.within_function = &r_within_box_advanced;
}

this_box_volume.geometry.shell_points = &box_shell_points;
this_box_volume.geometry.mcdisplay_function = &mcdisplay_box_function;
this_box_volume.geometry.initialize_from_main_function = &initialize_box_geometry_from_main_component;
this_box_volume.geometry.process_rot_allocated = 0;

this_box_volume.geometry.copy_geometry_parameters = &allocate_box_storage_copy;

rot_copy(this_box_volume.geometry.rotation_matrix,ROT_A_CURRENT_COMP); //check how ROT_R_CURRENT_COMP would work
rot_transpose(ROT_A_CURRENT_COMP,this_box_volume.geometry.transpose_rotation_matrix);

// Initialize loggers
this_box_volume.loggers.num_elements = 0;

// packing the information into the global_geometry_element, which is then included in the global_geometry_list.
sprintf(global_geometry_element.name,NAME_CURRENT_COMP);
global_geometry_element.activation_counter = number_of_activations;
global_geometry_element.component_index = INDEX_CURRENT_COMP;
global_geometry_element.Volume = &this_box_volume; // Would be nicer if this m was a pointer, now we have the (small) data two places
add_element_to_geometry_list(&global_geometry_list,global_geometry_element);
}
#line 324641 "MACS_sample_kidney_box.c"
#undef number_of_activations
#undef mask_setting
#undef mask_string
#undef p_interact
#undef focus_r
#undef focus_xh
#undef focus_xw
#undef focus_ah
#undef focus_aw
#undef target_z
#undef target_y
#undef target_x
#undef target_index
#undef visualize
#undef yheight2
#undef xwidth2
#undef zdepth
#undef yheight
#undef xwidth
#undef priority
#undef material_string
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

  /* Initializations for component channel_18_analyzer_1_array_crystal_array_2. */
  SIG_MESSAGE("channel_18_analyzer_1_array_crystal_array_2 (Init)");
#define mccompcurname  channel_18_analyzer_1_array_crystal_array_2
#define mccompcurtype  Union_box
#define mccompcurindex 816
#define loop_index mccchannel_18_analyzer_1_array_crystal_array_2_loop_index
#define this_box_volume mccchannel_18_analyzer_1_array_crystal_array_2_this_box_volume
#define global_geometry_element mccchannel_18_analyzer_1_array_crystal_array_2_global_geometry_element
#define this_box_storage mccchannel_18_analyzer_1_array_crystal_array_2_this_box_storage
#define material_string mccchannel_18_analyzer_1_array_crystal_array_2_material_string
#define priority mccchannel_18_analyzer_1_array_crystal_array_2_priority
#define xwidth mccchannel_18_analyzer_1_array_crystal_array_2_xwidth
#define yheight mccchannel_18_analyzer_1_array_crystal_array_2_yheight
#define zdepth mccchannel_18_analyzer_1_array_crystal_array_2_zdepth
#define xwidth2 mccchannel_18_analyzer_1_array_crystal_array_2_xwidth2
#define yheight2 mccchannel_18_analyzer_1_array_crystal_array_2_yheight2
#define visualize mccchannel_18_analyzer_1_array_crystal_array_2_visualize
#define target_index mccchannel_18_analyzer_1_array_crystal_array_2_target_index
#define target_x mccchannel_18_analyzer_1_array_crystal_array_2_target_x
#define target_y mccchannel_18_analyzer_1_array_crystal_array_2_target_y
#define target_z mccchannel_18_analyzer_1_array_crystal_array_2_target_z
#define focus_aw mccchannel_18_analyzer_1_array_crystal_array_2_focus_aw
#define focus_ah mccchannel_18_analyzer_1_array_crystal_array_2_focus_ah
#define focus_xw mccchannel_18_analyzer_1_array_crystal_array_2_focus_xw
#define focus_xh mccchannel_18_analyzer_1_array_crystal_array_2_focus_xh
#define focus_r mccchannel_18_analyzer_1_array_crystal_array_2_focus_r
#define p_interact mccchannel_18_analyzer_1_array_crystal_array_2_p_interact
#define mask_string mccchannel_18_analyzer_1_array_crystal_array_2_mask_string
#define mask_setting mccchannel_18_analyzer_1_array_crystal_array_2_mask_setting
#define number_of_activations mccchannel_18_analyzer_1_array_crystal_array_2_number_of_activations
#line 224 "Union_box.comp"
{
// Initializes the focusing system for this volume including input sanitation.
focus_initialize(&this_box_volume.geometry, POS_A_COMP_INDEX(INDEX_CURRENT_COMP+target_index), POS_A_CURRENT_COMP, ROT_A_CURRENT_COMP, target_index, target_x, target_y, target_z, focus_aw, focus_ah, focus_xw, focus_xh, focus_r, NAME_CURRENT_COMP);

// Input sanitation for this geometry
if (xwidth <= 0) {
  printf("\nERROR in Union_box named %s, the xwidth is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (yheight <= 0) {
  printf("\nERROR in Union_box named %s, yheight is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (zdepth <= 0) {
  printf("\nERROR in Union_box named %s, zdepth is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (xwidth2 <= 0 && xwidth2 != -1) {
  printf("\nERROR in Union_box named %s, the xwidth2 is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (yheight2 <= 0 && yheight2 != -1) {
  printf("\nERROR in Union_box named %s, yheight2 is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}

// Use sanitation
if (global_material_list.num_elements == 0) {
  printf("\nERROR: Need to define a material using Union_make_material before using a Union geometry component. \n");
  printf("       %s was defined before first use of Union_make_material.\n",NAME_CURRENT_COMP);
  exit(1);
}

this_box_volume.geometry.is_masked_volume = 0;
this_box_volume.geometry.is_exit_volume = 0;
this_box_volume.geometry.is_mask_volume = 0;
// check if the volume is a mask, if it is the material string is irelevant.
if (mask_string && strlen(mask_string) && strcmp(mask_string, "NULL") && strcmp(mask_string, "0")) {
    // A mask volume is used to limit the extend of other volumes, called the masked volumes. These are specified in the mask_string.
    // In order for a ray to enter a masked volume, it needs to be both in the region covered by that volume AND the mask volume.
    // When more than
    this_box_volume.geometry.mask_mode = 1; // Default is mask mode is ALL
    if (mask_setting && strlen(mask_setting) && strcmp(mask_setting, "NULL") && strcmp(mask_setting, "0")) {
        if (strcmp(mask_setting,"ALL") == 0 || strcmp(mask_setting,"All") == 0) this_box_volume.geometry.mask_mode = 1;
        else if (strcmp(mask_setting,"ANY") == 0 || strcmp(mask_setting,"Any") == 0) this_box_volume.geometry.mask_mode = 2;
        else {
            printf("The mask_mode of component %s is set to %s, but must be either ALL or ANY.\n",NAME_CURRENT_COMP,mask_setting);
            exit(1);
        }
    }
    
    for (loop_index=0;loop_index<global_geometry_list.num_elements;loop_index++) {
        // Add mask list
        if (1 == manual_linking_function(global_geometry_list.elements[loop_index].name,mask_string)) {
            add_element_to_int_list(&this_box_volume.geometry.mask_list,global_geometry_list.elements[loop_index].component_index);
            add_element_to_int_list(&global_geometry_list.elements[loop_index].Volume->geometry.masked_by_list,INDEX_CURRENT_COMP);
            global_geometry_list.elements[loop_index].Volume->geometry.is_masked_volume = 1;
            if (this_box_volume.geometry.mask_mode == 2)
                global_geometry_list.elements[loop_index].Volume->geometry.mask_mode = 2;
            if (this_box_volume.geometry.mask_mode == 1) {
                if (global_geometry_list.elements[loop_index].Volume->geometry.is_masked_volume == 1 && global_geometry_list.elements[loop_index].Volume->geometry.mask_mode != 2)
                    // If more than one mask is added to one volume, the ANY mode overwrites the (default) ALL mode.
                    global_geometry_list.elements[loop_index].Volume->geometry.mask_mode = 1;
            }
            
            found_geometries = 1;
        }
    }
    if (found_geometries == 0) {
        printf("The mask_string in geometry: %s did not find any of the specified volumes in the mask_string %s \n",NAME_CURRENT_COMP,mask_string);
        exit(1);
    }
    this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
    this_box_volume.p_physics->is_vacuum = 0; // Makes this volume a vacuum
    this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
    this_box_volume.p_physics->my_a = 0; // Should not be used.
    sprintf(this_box_volume.p_physics->name,"Mask");
    this_box_volume.geometry.is_mask_volume = 1;
    
    
// Read the material input, or if it lacks, use automatic linking.
} else if (material_string && strlen(material_string) && strcmp(material_string, "NULL") && strcmp(material_string, "0")) {
    // A geometry string was given, use it to determine which material
    if (0 == strcmp(material_string,"vacuum") || 0 == strcmp(material_string,"Vacuum")) {
        // One could have a global physics struct for vacuum instead of creating one for each
        this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
        this_box_volume.p_physics->is_vacuum = 1; // Makes this volume a vacuum
        this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
        this_box_volume.p_physics->my_a = 0; // Should not be used.
        sprintf(this_box_volume.p_physics->name,"Vacuum");
    } else if (0 == strcmp(material_string,"exit") || 0 == strcmp(material_string,"Exit")) {
        // One could have a global physics struct for vacuum instead of creating one for each
        this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
        this_box_volume.p_physics->is_vacuum = 1; // Makes this volume a vacuum
        this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
        this_box_volume.p_physics->my_a = 0; // Should not be used.
        this_box_volume.geometry.is_exit_volume = 1;
        sprintf(this_box_volume.p_physics->name,"Exit");
    } else {
        #ifndef MATERIAL_DETECTOR
            printf("Need to define a material before refering to it in a geometry %s.\n",NAME_CURRENT_COMP);
            exit(1);
        #endif
        for (loop_index=0;loop_index<global_material_list.num_elements;loop_index++) {
            if (0 == strcmp(material_string,global_material_list.elements[loop_index].name)) {
                this_box_volume.p_physics = global_material_list.elements[loop_index].physics;
                break;
            }
            if (loop_index == global_material_list.num_elements-1) {
            printf("\n");
            printf("ERROR: The material string \"%s\" in Union geometry \"%s\" did not match a specified material. \n",material_string,NAME_CURRENT_COMP);
            printf("       The materials available at this point (need to be defined before the geometry): \n");
            for (loop_index=0;loop_index<global_material_list.num_elements;loop_index++)
              printf("         %s\n",global_material_list.elements[loop_index].name);
            printf("\n");
            printf("       It is also possible to use one of the defualt materials avaiable: \n");
            printf("           Vacuum (for a Volume without scattering or absorption)\n");
            printf("           Exit (for a Volume where the ray exits the component if it enters)\n");
            printf("           Mask (for a Volume that masks existing volumes specified in the mask_string\n");
            exit(1);
          }
        }
    }
} else {
    // Automatic linking, simply using the last defined material.
    #ifndef MATERIAL_DETECTOR
        printf("Need to define a material before the geometry to use automatic linking %s.\n",NAME_CURRENT_COMP);
        exit(1);
    #endif
    this_box_volume.p_physics = global_material_list.elements[global_material_list.num_elements-1].physics;
}

sprintf(this_box_volume.name,NAME_CURRENT_COMP);
sprintf(this_box_volume.geometry.shape,"box");
this_box_volume.geometry.priority_value = priority;
this_box_volume.geometry.geometry_p_interact = p_interact;
// Currently the coordinates will be in absolute space.
this_box_volume.geometry.center = POS_A_CURRENT_COMP;

this_box_storage.z_depth = zdepth;
this_box_storage.x_width1 = xwidth;
this_box_storage.y_height1 = yheight;

this_box_storage.is_rectangle = 0;
if (xwidth2 < 0 && yheight2 < 0) this_box_storage.is_rectangle = 1;
if (xwidth == xwidth2 && yheight == yheight2) this_box_storage.is_rectangle = 1;

if (xwidth2 < 0) {
    this_box_storage.x_width2 = xwidth;
    xwidth2 = xwidth;
} else this_box_storage.x_width2 = xwidth2;

if (yheight2 < 0) {
    this_box_storage.y_height2 = yheight;
    yheight2 = yheight;
} else this_box_storage.y_height2 = yheight2;


this_box_storage.normal_vectors[0] = coords_set(0,0,1);
this_box_storage.normal_vectors[1] = coords_set(0,0,1);

// for sides with y component = 0
x_component = 2*zdepth/sqrt((xwidth-xwidth2)*(xwidth-xwidth2)+4*zdepth*zdepth);
z_component = (xwidth-xwidth2)/sqrt(4*zdepth*zdepth+(xwidth-xwidth2)*(xwidth-xwidth2));

this_box_storage.normal_vectors[2] = coords_set(x_component,0,z_component);
this_box_storage.normal_vectors[3] = coords_set(-x_component,0,z_component);

// for sides with x component = 0
y_component = 2*zdepth/sqrt((yheight-yheight2)*(yheight-yheight2)+4*zdepth*zdepth);
z_component = (yheight-yheight2)/sqrt(4*zdepth*zdepth+(yheight-yheight2)*(yheight-yheight2));

this_box_storage.normal_vectors[4] = coords_set(0,y_component,z_component);
this_box_storage.normal_vectors[5] = coords_set(0,-y_component,z_component);

this_box_volume.geometry.visualization_on = visualize;

this_box_volume.geometry.geometry_parameters.p_box_storage = &this_box_storage;

// Assign pointers to functions for intersection with the shape, checking if a point is inside the shape
if (this_box_storage.is_rectangle == 1) {
this_box_volume.geometry.intersect_function = &sample_box_intersect_simple;
this_box_volume.geometry.within_function = &r_within_box_simple;
}
else {
this_box_volume.geometry.intersect_function = &sample_box_intersect_advanced;
this_box_volume.geometry.within_function = &r_within_box_advanced;
}

this_box_volume.geometry.shell_points = &box_shell_points;
this_box_volume.geometry.mcdisplay_function = &mcdisplay_box_function;
this_box_volume.geometry.initialize_from_main_function = &initialize_box_geometry_from_main_component;
this_box_volume.geometry.process_rot_allocated = 0;

this_box_volume.geometry.copy_geometry_parameters = &allocate_box_storage_copy;

rot_copy(this_box_volume.geometry.rotation_matrix,ROT_A_CURRENT_COMP); //check how ROT_R_CURRENT_COMP would work
rot_transpose(ROT_A_CURRENT_COMP,this_box_volume.geometry.transpose_rotation_matrix);

// Initialize loggers
this_box_volume.loggers.num_elements = 0;

// packing the information into the global_geometry_element, which is then included in the global_geometry_list.
sprintf(global_geometry_element.name,NAME_CURRENT_COMP);
global_geometry_element.activation_counter = number_of_activations;
global_geometry_element.component_index = INDEX_CURRENT_COMP;
global_geometry_element.Volume = &this_box_volume; // Would be nicer if this m was a pointer, now we have the (small) data two places
add_element_to_geometry_list(&global_geometry_list,global_geometry_element);
}
#line 324911 "MACS_sample_kidney_box.c"
#undef number_of_activations
#undef mask_setting
#undef mask_string
#undef p_interact
#undef focus_r
#undef focus_xh
#undef focus_xw
#undef focus_ah
#undef focus_aw
#undef target_z
#undef target_y
#undef target_x
#undef target_index
#undef visualize
#undef yheight2
#undef xwidth2
#undef zdepth
#undef yheight
#undef xwidth
#undef priority
#undef material_string
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

  /* Initializations for component channel_18_analyzer_1_array_crystal_array_3. */
  SIG_MESSAGE("channel_18_analyzer_1_array_crystal_array_3 (Init)");
#define mccompcurname  channel_18_analyzer_1_array_crystal_array_3
#define mccompcurtype  Union_box
#define mccompcurindex 817
#define loop_index mccchannel_18_analyzer_1_array_crystal_array_3_loop_index
#define this_box_volume mccchannel_18_analyzer_1_array_crystal_array_3_this_box_volume
#define global_geometry_element mccchannel_18_analyzer_1_array_crystal_array_3_global_geometry_element
#define this_box_storage mccchannel_18_analyzer_1_array_crystal_array_3_this_box_storage
#define material_string mccchannel_18_analyzer_1_array_crystal_array_3_material_string
#define priority mccchannel_18_analyzer_1_array_crystal_array_3_priority
#define xwidth mccchannel_18_analyzer_1_array_crystal_array_3_xwidth
#define yheight mccchannel_18_analyzer_1_array_crystal_array_3_yheight
#define zdepth mccchannel_18_analyzer_1_array_crystal_array_3_zdepth
#define xwidth2 mccchannel_18_analyzer_1_array_crystal_array_3_xwidth2
#define yheight2 mccchannel_18_analyzer_1_array_crystal_array_3_yheight2
#define visualize mccchannel_18_analyzer_1_array_crystal_array_3_visualize
#define target_index mccchannel_18_analyzer_1_array_crystal_array_3_target_index
#define target_x mccchannel_18_analyzer_1_array_crystal_array_3_target_x
#define target_y mccchannel_18_analyzer_1_array_crystal_array_3_target_y
#define target_z mccchannel_18_analyzer_1_array_crystal_array_3_target_z
#define focus_aw mccchannel_18_analyzer_1_array_crystal_array_3_focus_aw
#define focus_ah mccchannel_18_analyzer_1_array_crystal_array_3_focus_ah
#define focus_xw mccchannel_18_analyzer_1_array_crystal_array_3_focus_xw
#define focus_xh mccchannel_18_analyzer_1_array_crystal_array_3_focus_xh
#define focus_r mccchannel_18_analyzer_1_array_crystal_array_3_focus_r
#define p_interact mccchannel_18_analyzer_1_array_crystal_array_3_p_interact
#define mask_string mccchannel_18_analyzer_1_array_crystal_array_3_mask_string
#define mask_setting mccchannel_18_analyzer_1_array_crystal_array_3_mask_setting
#define number_of_activations mccchannel_18_analyzer_1_array_crystal_array_3_number_of_activations
#line 224 "Union_box.comp"
{
// Initializes the focusing system for this volume including input sanitation.
focus_initialize(&this_box_volume.geometry, POS_A_COMP_INDEX(INDEX_CURRENT_COMP+target_index), POS_A_CURRENT_COMP, ROT_A_CURRENT_COMP, target_index, target_x, target_y, target_z, focus_aw, focus_ah, focus_xw, focus_xh, focus_r, NAME_CURRENT_COMP);

// Input sanitation for this geometry
if (xwidth <= 0) {
  printf("\nERROR in Union_box named %s, the xwidth is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (yheight <= 0) {
  printf("\nERROR in Union_box named %s, yheight is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (zdepth <= 0) {
  printf("\nERROR in Union_box named %s, zdepth is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (xwidth2 <= 0 && xwidth2 != -1) {
  printf("\nERROR in Union_box named %s, the xwidth2 is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (yheight2 <= 0 && yheight2 != -1) {
  printf("\nERROR in Union_box named %s, yheight2 is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}

// Use sanitation
if (global_material_list.num_elements == 0) {
  printf("\nERROR: Need to define a material using Union_make_material before using a Union geometry component. \n");
  printf("       %s was defined before first use of Union_make_material.\n",NAME_CURRENT_COMP);
  exit(1);
}

this_box_volume.geometry.is_masked_volume = 0;
this_box_volume.geometry.is_exit_volume = 0;
this_box_volume.geometry.is_mask_volume = 0;
// check if the volume is a mask, if it is the material string is irelevant.
if (mask_string && strlen(mask_string) && strcmp(mask_string, "NULL") && strcmp(mask_string, "0")) {
    // A mask volume is used to limit the extend of other volumes, called the masked volumes. These are specified in the mask_string.
    // In order for a ray to enter a masked volume, it needs to be both in the region covered by that volume AND the mask volume.
    // When more than
    this_box_volume.geometry.mask_mode = 1; // Default is mask mode is ALL
    if (mask_setting && strlen(mask_setting) && strcmp(mask_setting, "NULL") && strcmp(mask_setting, "0")) {
        if (strcmp(mask_setting,"ALL") == 0 || strcmp(mask_setting,"All") == 0) this_box_volume.geometry.mask_mode = 1;
        else if (strcmp(mask_setting,"ANY") == 0 || strcmp(mask_setting,"Any") == 0) this_box_volume.geometry.mask_mode = 2;
        else {
            printf("The mask_mode of component %s is set to %s, but must be either ALL or ANY.\n",NAME_CURRENT_COMP,mask_setting);
            exit(1);
        }
    }
    
    for (loop_index=0;loop_index<global_geometry_list.num_elements;loop_index++) {
        // Add mask list
        if (1 == manual_linking_function(global_geometry_list.elements[loop_index].name,mask_string)) {
            add_element_to_int_list(&this_box_volume.geometry.mask_list,global_geometry_list.elements[loop_index].component_index);
            add_element_to_int_list(&global_geometry_list.elements[loop_index].Volume->geometry.masked_by_list,INDEX_CURRENT_COMP);
            global_geometry_list.elements[loop_index].Volume->geometry.is_masked_volume = 1;
            if (this_box_volume.geometry.mask_mode == 2)
                global_geometry_list.elements[loop_index].Volume->geometry.mask_mode = 2;
            if (this_box_volume.geometry.mask_mode == 1) {
                if (global_geometry_list.elements[loop_index].Volume->geometry.is_masked_volume == 1 && global_geometry_list.elements[loop_index].Volume->geometry.mask_mode != 2)
                    // If more than one mask is added to one volume, the ANY mode overwrites the (default) ALL mode.
                    global_geometry_list.elements[loop_index].Volume->geometry.mask_mode = 1;
            }
            
            found_geometries = 1;
        }
    }
    if (found_geometries == 0) {
        printf("The mask_string in geometry: %s did not find any of the specified volumes in the mask_string %s \n",NAME_CURRENT_COMP,mask_string);
        exit(1);
    }
    this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
    this_box_volume.p_physics->is_vacuum = 0; // Makes this volume a vacuum
    this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
    this_box_volume.p_physics->my_a = 0; // Should not be used.
    sprintf(this_box_volume.p_physics->name,"Mask");
    this_box_volume.geometry.is_mask_volume = 1;
    
    
// Read the material input, or if it lacks, use automatic linking.
} else if (material_string && strlen(material_string) && strcmp(material_string, "NULL") && strcmp(material_string, "0")) {
    // A geometry string was given, use it to determine which material
    if (0 == strcmp(material_string,"vacuum") || 0 == strcmp(material_string,"Vacuum")) {
        // One could have a global physics struct for vacuum instead of creating one for each
        this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
        this_box_volume.p_physics->is_vacuum = 1; // Makes this volume a vacuum
        this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
        this_box_volume.p_physics->my_a = 0; // Should not be used.
        sprintf(this_box_volume.p_physics->name,"Vacuum");
    } else if (0 == strcmp(material_string,"exit") || 0 == strcmp(material_string,"Exit")) {
        // One could have a global physics struct for vacuum instead of creating one for each
        this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
        this_box_volume.p_physics->is_vacuum = 1; // Makes this volume a vacuum
        this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
        this_box_volume.p_physics->my_a = 0; // Should not be used.
        this_box_volume.geometry.is_exit_volume = 1;
        sprintf(this_box_volume.p_physics->name,"Exit");
    } else {
        #ifndef MATERIAL_DETECTOR
            printf("Need to define a material before refering to it in a geometry %s.\n",NAME_CURRENT_COMP);
            exit(1);
        #endif
        for (loop_index=0;loop_index<global_material_list.num_elements;loop_index++) {
            if (0 == strcmp(material_string,global_material_list.elements[loop_index].name)) {
                this_box_volume.p_physics = global_material_list.elements[loop_index].physics;
                break;
            }
            if (loop_index == global_material_list.num_elements-1) {
            printf("\n");
            printf("ERROR: The material string \"%s\" in Union geometry \"%s\" did not match a specified material. \n",material_string,NAME_CURRENT_COMP);
            printf("       The materials available at this point (need to be defined before the geometry): \n");
            for (loop_index=0;loop_index<global_material_list.num_elements;loop_index++)
              printf("         %s\n",global_material_list.elements[loop_index].name);
            printf("\n");
            printf("       It is also possible to use one of the defualt materials avaiable: \n");
            printf("           Vacuum (for a Volume without scattering or absorption)\n");
            printf("           Exit (for a Volume where the ray exits the component if it enters)\n");
            printf("           Mask (for a Volume that masks existing volumes specified in the mask_string\n");
            exit(1);
          }
        }
    }
} else {
    // Automatic linking, simply using the last defined material.
    #ifndef MATERIAL_DETECTOR
        printf("Need to define a material before the geometry to use automatic linking %s.\n",NAME_CURRENT_COMP);
        exit(1);
    #endif
    this_box_volume.p_physics = global_material_list.elements[global_material_list.num_elements-1].physics;
}

sprintf(this_box_volume.name,NAME_CURRENT_COMP);
sprintf(this_box_volume.geometry.shape,"box");
this_box_volume.geometry.priority_value = priority;
this_box_volume.geometry.geometry_p_interact = p_interact;
// Currently the coordinates will be in absolute space.
this_box_volume.geometry.center = POS_A_CURRENT_COMP;

this_box_storage.z_depth = zdepth;
this_box_storage.x_width1 = xwidth;
this_box_storage.y_height1 = yheight;

this_box_storage.is_rectangle = 0;
if (xwidth2 < 0 && yheight2 < 0) this_box_storage.is_rectangle = 1;
if (xwidth == xwidth2 && yheight == yheight2) this_box_storage.is_rectangle = 1;

if (xwidth2 < 0) {
    this_box_storage.x_width2 = xwidth;
    xwidth2 = xwidth;
} else this_box_storage.x_width2 = xwidth2;

if (yheight2 < 0) {
    this_box_storage.y_height2 = yheight;
    yheight2 = yheight;
} else this_box_storage.y_height2 = yheight2;


this_box_storage.normal_vectors[0] = coords_set(0,0,1);
this_box_storage.normal_vectors[1] = coords_set(0,0,1);

// for sides with y component = 0
x_component = 2*zdepth/sqrt((xwidth-xwidth2)*(xwidth-xwidth2)+4*zdepth*zdepth);
z_component = (xwidth-xwidth2)/sqrt(4*zdepth*zdepth+(xwidth-xwidth2)*(xwidth-xwidth2));

this_box_storage.normal_vectors[2] = coords_set(x_component,0,z_component);
this_box_storage.normal_vectors[3] = coords_set(-x_component,0,z_component);

// for sides with x component = 0
y_component = 2*zdepth/sqrt((yheight-yheight2)*(yheight-yheight2)+4*zdepth*zdepth);
z_component = (yheight-yheight2)/sqrt(4*zdepth*zdepth+(yheight-yheight2)*(yheight-yheight2));

this_box_storage.normal_vectors[4] = coords_set(0,y_component,z_component);
this_box_storage.normal_vectors[5] = coords_set(0,-y_component,z_component);

this_box_volume.geometry.visualization_on = visualize;

this_box_volume.geometry.geometry_parameters.p_box_storage = &this_box_storage;

// Assign pointers to functions for intersection with the shape, checking if a point is inside the shape
if (this_box_storage.is_rectangle == 1) {
this_box_volume.geometry.intersect_function = &sample_box_intersect_simple;
this_box_volume.geometry.within_function = &r_within_box_simple;
}
else {
this_box_volume.geometry.intersect_function = &sample_box_intersect_advanced;
this_box_volume.geometry.within_function = &r_within_box_advanced;
}

this_box_volume.geometry.shell_points = &box_shell_points;
this_box_volume.geometry.mcdisplay_function = &mcdisplay_box_function;
this_box_volume.geometry.initialize_from_main_function = &initialize_box_geometry_from_main_component;
this_box_volume.geometry.process_rot_allocated = 0;

this_box_volume.geometry.copy_geometry_parameters = &allocate_box_storage_copy;

rot_copy(this_box_volume.geometry.rotation_matrix,ROT_A_CURRENT_COMP); //check how ROT_R_CURRENT_COMP would work
rot_transpose(ROT_A_CURRENT_COMP,this_box_volume.geometry.transpose_rotation_matrix);

// Initialize loggers
this_box_volume.loggers.num_elements = 0;

// packing the information into the global_geometry_element, which is then included in the global_geometry_list.
sprintf(global_geometry_element.name,NAME_CURRENT_COMP);
global_geometry_element.activation_counter = number_of_activations;
global_geometry_element.component_index = INDEX_CURRENT_COMP;
global_geometry_element.Volume = &this_box_volume; // Would be nicer if this m was a pointer, now we have the (small) data two places
add_element_to_geometry_list(&global_geometry_list,global_geometry_element);
}
#line 325181 "MACS_sample_kidney_box.c"
#undef number_of_activations
#undef mask_setting
#undef mask_string
#undef p_interact
#undef focus_r
#undef focus_xh
#undef focus_xw
#undef focus_ah
#undef focus_aw
#undef target_z
#undef target_y
#undef target_x
#undef target_index
#undef visualize
#undef yheight2
#undef xwidth2
#undef zdepth
#undef yheight
#undef xwidth
#undef priority
#undef material_string
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

  /* Initializations for component channel_18_analyzer_1_array_crystal_array_4. */
  SIG_MESSAGE("channel_18_analyzer_1_array_crystal_array_4 (Init)");
#define mccompcurname  channel_18_analyzer_1_array_crystal_array_4
#define mccompcurtype  Union_box
#define mccompcurindex 818
#define loop_index mccchannel_18_analyzer_1_array_crystal_array_4_loop_index
#define this_box_volume mccchannel_18_analyzer_1_array_crystal_array_4_this_box_volume
#define global_geometry_element mccchannel_18_analyzer_1_array_crystal_array_4_global_geometry_element
#define this_box_storage mccchannel_18_analyzer_1_array_crystal_array_4_this_box_storage
#define material_string mccchannel_18_analyzer_1_array_crystal_array_4_material_string
#define priority mccchannel_18_analyzer_1_array_crystal_array_4_priority
#define xwidth mccchannel_18_analyzer_1_array_crystal_array_4_xwidth
#define yheight mccchannel_18_analyzer_1_array_crystal_array_4_yheight
#define zdepth mccchannel_18_analyzer_1_array_crystal_array_4_zdepth
#define xwidth2 mccchannel_18_analyzer_1_array_crystal_array_4_xwidth2
#define yheight2 mccchannel_18_analyzer_1_array_crystal_array_4_yheight2
#define visualize mccchannel_18_analyzer_1_array_crystal_array_4_visualize
#define target_index mccchannel_18_analyzer_1_array_crystal_array_4_target_index
#define target_x mccchannel_18_analyzer_1_array_crystal_array_4_target_x
#define target_y mccchannel_18_analyzer_1_array_crystal_array_4_target_y
#define target_z mccchannel_18_analyzer_1_array_crystal_array_4_target_z
#define focus_aw mccchannel_18_analyzer_1_array_crystal_array_4_focus_aw
#define focus_ah mccchannel_18_analyzer_1_array_crystal_array_4_focus_ah
#define focus_xw mccchannel_18_analyzer_1_array_crystal_array_4_focus_xw
#define focus_xh mccchannel_18_analyzer_1_array_crystal_array_4_focus_xh
#define focus_r mccchannel_18_analyzer_1_array_crystal_array_4_focus_r
#define p_interact mccchannel_18_analyzer_1_array_crystal_array_4_p_interact
#define mask_string mccchannel_18_analyzer_1_array_crystal_array_4_mask_string
#define mask_setting mccchannel_18_analyzer_1_array_crystal_array_4_mask_setting
#define number_of_activations mccchannel_18_analyzer_1_array_crystal_array_4_number_of_activations
#line 224 "Union_box.comp"
{
// Initializes the focusing system for this volume including input sanitation.
focus_initialize(&this_box_volume.geometry, POS_A_COMP_INDEX(INDEX_CURRENT_COMP+target_index), POS_A_CURRENT_COMP, ROT_A_CURRENT_COMP, target_index, target_x, target_y, target_z, focus_aw, focus_ah, focus_xw, focus_xh, focus_r, NAME_CURRENT_COMP);

// Input sanitation for this geometry
if (xwidth <= 0) {
  printf("\nERROR in Union_box named %s, the xwidth is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (yheight <= 0) {
  printf("\nERROR in Union_box named %s, yheight is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (zdepth <= 0) {
  printf("\nERROR in Union_box named %s, zdepth is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (xwidth2 <= 0 && xwidth2 != -1) {
  printf("\nERROR in Union_box named %s, the xwidth2 is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (yheight2 <= 0 && yheight2 != -1) {
  printf("\nERROR in Union_box named %s, yheight2 is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}

// Use sanitation
if (global_material_list.num_elements == 0) {
  printf("\nERROR: Need to define a material using Union_make_material before using a Union geometry component. \n");
  printf("       %s was defined before first use of Union_make_material.\n",NAME_CURRENT_COMP);
  exit(1);
}

this_box_volume.geometry.is_masked_volume = 0;
this_box_volume.geometry.is_exit_volume = 0;
this_box_volume.geometry.is_mask_volume = 0;
// check if the volume is a mask, if it is the material string is irelevant.
if (mask_string && strlen(mask_string) && strcmp(mask_string, "NULL") && strcmp(mask_string, "0")) {
    // A mask volume is used to limit the extend of other volumes, called the masked volumes. These are specified in the mask_string.
    // In order for a ray to enter a masked volume, it needs to be both in the region covered by that volume AND the mask volume.
    // When more than
    this_box_volume.geometry.mask_mode = 1; // Default is mask mode is ALL
    if (mask_setting && strlen(mask_setting) && strcmp(mask_setting, "NULL") && strcmp(mask_setting, "0")) {
        if (strcmp(mask_setting,"ALL") == 0 || strcmp(mask_setting,"All") == 0) this_box_volume.geometry.mask_mode = 1;
        else if (strcmp(mask_setting,"ANY") == 0 || strcmp(mask_setting,"Any") == 0) this_box_volume.geometry.mask_mode = 2;
        else {
            printf("The mask_mode of component %s is set to %s, but must be either ALL or ANY.\n",NAME_CURRENT_COMP,mask_setting);
            exit(1);
        }
    }
    
    for (loop_index=0;loop_index<global_geometry_list.num_elements;loop_index++) {
        // Add mask list
        if (1 == manual_linking_function(global_geometry_list.elements[loop_index].name,mask_string)) {
            add_element_to_int_list(&this_box_volume.geometry.mask_list,global_geometry_list.elements[loop_index].component_index);
            add_element_to_int_list(&global_geometry_list.elements[loop_index].Volume->geometry.masked_by_list,INDEX_CURRENT_COMP);
            global_geometry_list.elements[loop_index].Volume->geometry.is_masked_volume = 1;
            if (this_box_volume.geometry.mask_mode == 2)
                global_geometry_list.elements[loop_index].Volume->geometry.mask_mode = 2;
            if (this_box_volume.geometry.mask_mode == 1) {
                if (global_geometry_list.elements[loop_index].Volume->geometry.is_masked_volume == 1 && global_geometry_list.elements[loop_index].Volume->geometry.mask_mode != 2)
                    // If more than one mask is added to one volume, the ANY mode overwrites the (default) ALL mode.
                    global_geometry_list.elements[loop_index].Volume->geometry.mask_mode = 1;
            }
            
            found_geometries = 1;
        }
    }
    if (found_geometries == 0) {
        printf("The mask_string in geometry: %s did not find any of the specified volumes in the mask_string %s \n",NAME_CURRENT_COMP,mask_string);
        exit(1);
    }
    this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
    this_box_volume.p_physics->is_vacuum = 0; // Makes this volume a vacuum
    this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
    this_box_volume.p_physics->my_a = 0; // Should not be used.
    sprintf(this_box_volume.p_physics->name,"Mask");
    this_box_volume.geometry.is_mask_volume = 1;
    
    
// Read the material input, or if it lacks, use automatic linking.
} else if (material_string && strlen(material_string) && strcmp(material_string, "NULL") && strcmp(material_string, "0")) {
    // A geometry string was given, use it to determine which material
    if (0 == strcmp(material_string,"vacuum") || 0 == strcmp(material_string,"Vacuum")) {
        // One could have a global physics struct for vacuum instead of creating one for each
        this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
        this_box_volume.p_physics->is_vacuum = 1; // Makes this volume a vacuum
        this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
        this_box_volume.p_physics->my_a = 0; // Should not be used.
        sprintf(this_box_volume.p_physics->name,"Vacuum");
    } else if (0 == strcmp(material_string,"exit") || 0 == strcmp(material_string,"Exit")) {
        // One could have a global physics struct for vacuum instead of creating one for each
        this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
        this_box_volume.p_physics->is_vacuum = 1; // Makes this volume a vacuum
        this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
        this_box_volume.p_physics->my_a = 0; // Should not be used.
        this_box_volume.geometry.is_exit_volume = 1;
        sprintf(this_box_volume.p_physics->name,"Exit");
    } else {
        #ifndef MATERIAL_DETECTOR
            printf("Need to define a material before refering to it in a geometry %s.\n",NAME_CURRENT_COMP);
            exit(1);
        #endif
        for (loop_index=0;loop_index<global_material_list.num_elements;loop_index++) {
            if (0 == strcmp(material_string,global_material_list.elements[loop_index].name)) {
                this_box_volume.p_physics = global_material_list.elements[loop_index].physics;
                break;
            }
            if (loop_index == global_material_list.num_elements-1) {
            printf("\n");
            printf("ERROR: The material string \"%s\" in Union geometry \"%s\" did not match a specified material. \n",material_string,NAME_CURRENT_COMP);
            printf("       The materials available at this point (need to be defined before the geometry): \n");
            for (loop_index=0;loop_index<global_material_list.num_elements;loop_index++)
              printf("         %s\n",global_material_list.elements[loop_index].name);
            printf("\n");
            printf("       It is also possible to use one of the defualt materials avaiable: \n");
            printf("           Vacuum (for a Volume without scattering or absorption)\n");
            printf("           Exit (for a Volume where the ray exits the component if it enters)\n");
            printf("           Mask (for a Volume that masks existing volumes specified in the mask_string\n");
            exit(1);
          }
        }
    }
} else {
    // Automatic linking, simply using the last defined material.
    #ifndef MATERIAL_DETECTOR
        printf("Need to define a material before the geometry to use automatic linking %s.\n",NAME_CURRENT_COMP);
        exit(1);
    #endif
    this_box_volume.p_physics = global_material_list.elements[global_material_list.num_elements-1].physics;
}

sprintf(this_box_volume.name,NAME_CURRENT_COMP);
sprintf(this_box_volume.geometry.shape,"box");
this_box_volume.geometry.priority_value = priority;
this_box_volume.geometry.geometry_p_interact = p_interact;
// Currently the coordinates will be in absolute space.
this_box_volume.geometry.center = POS_A_CURRENT_COMP;

this_box_storage.z_depth = zdepth;
this_box_storage.x_width1 = xwidth;
this_box_storage.y_height1 = yheight;

this_box_storage.is_rectangle = 0;
if (xwidth2 < 0 && yheight2 < 0) this_box_storage.is_rectangle = 1;
if (xwidth == xwidth2 && yheight == yheight2) this_box_storage.is_rectangle = 1;

if (xwidth2 < 0) {
    this_box_storage.x_width2 = xwidth;
    xwidth2 = xwidth;
} else this_box_storage.x_width2 = xwidth2;

if (yheight2 < 0) {
    this_box_storage.y_height2 = yheight;
    yheight2 = yheight;
} else this_box_storage.y_height2 = yheight2;


this_box_storage.normal_vectors[0] = coords_set(0,0,1);
this_box_storage.normal_vectors[1] = coords_set(0,0,1);

// for sides with y component = 0
x_component = 2*zdepth/sqrt((xwidth-xwidth2)*(xwidth-xwidth2)+4*zdepth*zdepth);
z_component = (xwidth-xwidth2)/sqrt(4*zdepth*zdepth+(xwidth-xwidth2)*(xwidth-xwidth2));

this_box_storage.normal_vectors[2] = coords_set(x_component,0,z_component);
this_box_storage.normal_vectors[3] = coords_set(-x_component,0,z_component);

// for sides with x component = 0
y_component = 2*zdepth/sqrt((yheight-yheight2)*(yheight-yheight2)+4*zdepth*zdepth);
z_component = (yheight-yheight2)/sqrt(4*zdepth*zdepth+(yheight-yheight2)*(yheight-yheight2));

this_box_storage.normal_vectors[4] = coords_set(0,y_component,z_component);
this_box_storage.normal_vectors[5] = coords_set(0,-y_component,z_component);

this_box_volume.geometry.visualization_on = visualize;

this_box_volume.geometry.geometry_parameters.p_box_storage = &this_box_storage;

// Assign pointers to functions for intersection with the shape, checking if a point is inside the shape
if (this_box_storage.is_rectangle == 1) {
this_box_volume.geometry.intersect_function = &sample_box_intersect_simple;
this_box_volume.geometry.within_function = &r_within_box_simple;
}
else {
this_box_volume.geometry.intersect_function = &sample_box_intersect_advanced;
this_box_volume.geometry.within_function = &r_within_box_advanced;
}

this_box_volume.geometry.shell_points = &box_shell_points;
this_box_volume.geometry.mcdisplay_function = &mcdisplay_box_function;
this_box_volume.geometry.initialize_from_main_function = &initialize_box_geometry_from_main_component;
this_box_volume.geometry.process_rot_allocated = 0;

this_box_volume.geometry.copy_geometry_parameters = &allocate_box_storage_copy;

rot_copy(this_box_volume.geometry.rotation_matrix,ROT_A_CURRENT_COMP); //check how ROT_R_CURRENT_COMP would work
rot_transpose(ROT_A_CURRENT_COMP,this_box_volume.geometry.transpose_rotation_matrix);

// Initialize loggers
this_box_volume.loggers.num_elements = 0;

// packing the information into the global_geometry_element, which is then included in the global_geometry_list.
sprintf(global_geometry_element.name,NAME_CURRENT_COMP);
global_geometry_element.activation_counter = number_of_activations;
global_geometry_element.component_index = INDEX_CURRENT_COMP;
global_geometry_element.Volume = &this_box_volume; // Would be nicer if this m was a pointer, now we have the (small) data two places
add_element_to_geometry_list(&global_geometry_list,global_geometry_element);
}
#line 325451 "MACS_sample_kidney_box.c"
#undef number_of_activations
#undef mask_setting
#undef mask_string
#undef p_interact
#undef focus_r
#undef focus_xh
#undef focus_xw
#undef focus_ah
#undef focus_aw
#undef target_z
#undef target_y
#undef target_x
#undef target_index
#undef visualize
#undef yheight2
#undef xwidth2
#undef zdepth
#undef yheight
#undef xwidth
#undef priority
#undef material_string
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

  /* Initializations for component channel_18_analyzer_1_array_crystal_array_5. */
  SIG_MESSAGE("channel_18_analyzer_1_array_crystal_array_5 (Init)");
#define mccompcurname  channel_18_analyzer_1_array_crystal_array_5
#define mccompcurtype  Union_box
#define mccompcurindex 819
#define loop_index mccchannel_18_analyzer_1_array_crystal_array_5_loop_index
#define this_box_volume mccchannel_18_analyzer_1_array_crystal_array_5_this_box_volume
#define global_geometry_element mccchannel_18_analyzer_1_array_crystal_array_5_global_geometry_element
#define this_box_storage mccchannel_18_analyzer_1_array_crystal_array_5_this_box_storage
#define material_string mccchannel_18_analyzer_1_array_crystal_array_5_material_string
#define priority mccchannel_18_analyzer_1_array_crystal_array_5_priority
#define xwidth mccchannel_18_analyzer_1_array_crystal_array_5_xwidth
#define yheight mccchannel_18_analyzer_1_array_crystal_array_5_yheight
#define zdepth mccchannel_18_analyzer_1_array_crystal_array_5_zdepth
#define xwidth2 mccchannel_18_analyzer_1_array_crystal_array_5_xwidth2
#define yheight2 mccchannel_18_analyzer_1_array_crystal_array_5_yheight2
#define visualize mccchannel_18_analyzer_1_array_crystal_array_5_visualize
#define target_index mccchannel_18_analyzer_1_array_crystal_array_5_target_index
#define target_x mccchannel_18_analyzer_1_array_crystal_array_5_target_x
#define target_y mccchannel_18_analyzer_1_array_crystal_array_5_target_y
#define target_z mccchannel_18_analyzer_1_array_crystal_array_5_target_z
#define focus_aw mccchannel_18_analyzer_1_array_crystal_array_5_focus_aw
#define focus_ah mccchannel_18_analyzer_1_array_crystal_array_5_focus_ah
#define focus_xw mccchannel_18_analyzer_1_array_crystal_array_5_focus_xw
#define focus_xh mccchannel_18_analyzer_1_array_crystal_array_5_focus_xh
#define focus_r mccchannel_18_analyzer_1_array_crystal_array_5_focus_r
#define p_interact mccchannel_18_analyzer_1_array_crystal_array_5_p_interact
#define mask_string mccchannel_18_analyzer_1_array_crystal_array_5_mask_string
#define mask_setting mccchannel_18_analyzer_1_array_crystal_array_5_mask_setting
#define number_of_activations mccchannel_18_analyzer_1_array_crystal_array_5_number_of_activations
#line 224 "Union_box.comp"
{
// Initializes the focusing system for this volume including input sanitation.
focus_initialize(&this_box_volume.geometry, POS_A_COMP_INDEX(INDEX_CURRENT_COMP+target_index), POS_A_CURRENT_COMP, ROT_A_CURRENT_COMP, target_index, target_x, target_y, target_z, focus_aw, focus_ah, focus_xw, focus_xh, focus_r, NAME_CURRENT_COMP);

// Input sanitation for this geometry
if (xwidth <= 0) {
  printf("\nERROR in Union_box named %s, the xwidth is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (yheight <= 0) {
  printf("\nERROR in Union_box named %s, yheight is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (zdepth <= 0) {
  printf("\nERROR in Union_box named %s, zdepth is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (xwidth2 <= 0 && xwidth2 != -1) {
  printf("\nERROR in Union_box named %s, the xwidth2 is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (yheight2 <= 0 && yheight2 != -1) {
  printf("\nERROR in Union_box named %s, yheight2 is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}

// Use sanitation
if (global_material_list.num_elements == 0) {
  printf("\nERROR: Need to define a material using Union_make_material before using a Union geometry component. \n");
  printf("       %s was defined before first use of Union_make_material.\n",NAME_CURRENT_COMP);
  exit(1);
}

this_box_volume.geometry.is_masked_volume = 0;
this_box_volume.geometry.is_exit_volume = 0;
this_box_volume.geometry.is_mask_volume = 0;
// check if the volume is a mask, if it is the material string is irelevant.
if (mask_string && strlen(mask_string) && strcmp(mask_string, "NULL") && strcmp(mask_string, "0")) {
    // A mask volume is used to limit the extend of other volumes, called the masked volumes. These are specified in the mask_string.
    // In order for a ray to enter a masked volume, it needs to be both in the region covered by that volume AND the mask volume.
    // When more than
    this_box_volume.geometry.mask_mode = 1; // Default is mask mode is ALL
    if (mask_setting && strlen(mask_setting) && strcmp(mask_setting, "NULL") && strcmp(mask_setting, "0")) {
        if (strcmp(mask_setting,"ALL") == 0 || strcmp(mask_setting,"All") == 0) this_box_volume.geometry.mask_mode = 1;
        else if (strcmp(mask_setting,"ANY") == 0 || strcmp(mask_setting,"Any") == 0) this_box_volume.geometry.mask_mode = 2;
        else {
            printf("The mask_mode of component %s is set to %s, but must be either ALL or ANY.\n",NAME_CURRENT_COMP,mask_setting);
            exit(1);
        }
    }
    
    for (loop_index=0;loop_index<global_geometry_list.num_elements;loop_index++) {
        // Add mask list
        if (1 == manual_linking_function(global_geometry_list.elements[loop_index].name,mask_string)) {
            add_element_to_int_list(&this_box_volume.geometry.mask_list,global_geometry_list.elements[loop_index].component_index);
            add_element_to_int_list(&global_geometry_list.elements[loop_index].Volume->geometry.masked_by_list,INDEX_CURRENT_COMP);
            global_geometry_list.elements[loop_index].Volume->geometry.is_masked_volume = 1;
            if (this_box_volume.geometry.mask_mode == 2)
                global_geometry_list.elements[loop_index].Volume->geometry.mask_mode = 2;
            if (this_box_volume.geometry.mask_mode == 1) {
                if (global_geometry_list.elements[loop_index].Volume->geometry.is_masked_volume == 1 && global_geometry_list.elements[loop_index].Volume->geometry.mask_mode != 2)
                    // If more than one mask is added to one volume, the ANY mode overwrites the (default) ALL mode.
                    global_geometry_list.elements[loop_index].Volume->geometry.mask_mode = 1;
            }
            
            found_geometries = 1;
        }
    }
    if (found_geometries == 0) {
        printf("The mask_string in geometry: %s did not find any of the specified volumes in the mask_string %s \n",NAME_CURRENT_COMP,mask_string);
        exit(1);
    }
    this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
    this_box_volume.p_physics->is_vacuum = 0; // Makes this volume a vacuum
    this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
    this_box_volume.p_physics->my_a = 0; // Should not be used.
    sprintf(this_box_volume.p_physics->name,"Mask");
    this_box_volume.geometry.is_mask_volume = 1;
    
    
// Read the material input, or if it lacks, use automatic linking.
} else if (material_string && strlen(material_string) && strcmp(material_string, "NULL") && strcmp(material_string, "0")) {
    // A geometry string was given, use it to determine which material
    if (0 == strcmp(material_string,"vacuum") || 0 == strcmp(material_string,"Vacuum")) {
        // One could have a global physics struct for vacuum instead of creating one for each
        this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
        this_box_volume.p_physics->is_vacuum = 1; // Makes this volume a vacuum
        this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
        this_box_volume.p_physics->my_a = 0; // Should not be used.
        sprintf(this_box_volume.p_physics->name,"Vacuum");
    } else if (0 == strcmp(material_string,"exit") || 0 == strcmp(material_string,"Exit")) {
        // One could have a global physics struct for vacuum instead of creating one for each
        this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
        this_box_volume.p_physics->is_vacuum = 1; // Makes this volume a vacuum
        this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
        this_box_volume.p_physics->my_a = 0; // Should not be used.
        this_box_volume.geometry.is_exit_volume = 1;
        sprintf(this_box_volume.p_physics->name,"Exit");
    } else {
        #ifndef MATERIAL_DETECTOR
            printf("Need to define a material before refering to it in a geometry %s.\n",NAME_CURRENT_COMP);
            exit(1);
        #endif
        for (loop_index=0;loop_index<global_material_list.num_elements;loop_index++) {
            if (0 == strcmp(material_string,global_material_list.elements[loop_index].name)) {
                this_box_volume.p_physics = global_material_list.elements[loop_index].physics;
                break;
            }
            if (loop_index == global_material_list.num_elements-1) {
            printf("\n");
            printf("ERROR: The material string \"%s\" in Union geometry \"%s\" did not match a specified material. \n",material_string,NAME_CURRENT_COMP);
            printf("       The materials available at this point (need to be defined before the geometry): \n");
            for (loop_index=0;loop_index<global_material_list.num_elements;loop_index++)
              printf("         %s\n",global_material_list.elements[loop_index].name);
            printf("\n");
            printf("       It is also possible to use one of the defualt materials avaiable: \n");
            printf("           Vacuum (for a Volume without scattering or absorption)\n");
            printf("           Exit (for a Volume where the ray exits the component if it enters)\n");
            printf("           Mask (for a Volume that masks existing volumes specified in the mask_string\n");
            exit(1);
          }
        }
    }
} else {
    // Automatic linking, simply using the last defined material.
    #ifndef MATERIAL_DETECTOR
        printf("Need to define a material before the geometry to use automatic linking %s.\n",NAME_CURRENT_COMP);
        exit(1);
    #endif
    this_box_volume.p_physics = global_material_list.elements[global_material_list.num_elements-1].physics;
}

sprintf(this_box_volume.name,NAME_CURRENT_COMP);
sprintf(this_box_volume.geometry.shape,"box");
this_box_volume.geometry.priority_value = priority;
this_box_volume.geometry.geometry_p_interact = p_interact;
// Currently the coordinates will be in absolute space.
this_box_volume.geometry.center = POS_A_CURRENT_COMP;

this_box_storage.z_depth = zdepth;
this_box_storage.x_width1 = xwidth;
this_box_storage.y_height1 = yheight;

this_box_storage.is_rectangle = 0;
if (xwidth2 < 0 && yheight2 < 0) this_box_storage.is_rectangle = 1;
if (xwidth == xwidth2 && yheight == yheight2) this_box_storage.is_rectangle = 1;

if (xwidth2 < 0) {
    this_box_storage.x_width2 = xwidth;
    xwidth2 = xwidth;
} else this_box_storage.x_width2 = xwidth2;

if (yheight2 < 0) {
    this_box_storage.y_height2 = yheight;
    yheight2 = yheight;
} else this_box_storage.y_height2 = yheight2;


this_box_storage.normal_vectors[0] = coords_set(0,0,1);
this_box_storage.normal_vectors[1] = coords_set(0,0,1);

// for sides with y component = 0
x_component = 2*zdepth/sqrt((xwidth-xwidth2)*(xwidth-xwidth2)+4*zdepth*zdepth);
z_component = (xwidth-xwidth2)/sqrt(4*zdepth*zdepth+(xwidth-xwidth2)*(xwidth-xwidth2));

this_box_storage.normal_vectors[2] = coords_set(x_component,0,z_component);
this_box_storage.normal_vectors[3] = coords_set(-x_component,0,z_component);

// for sides with x component = 0
y_component = 2*zdepth/sqrt((yheight-yheight2)*(yheight-yheight2)+4*zdepth*zdepth);
z_component = (yheight-yheight2)/sqrt(4*zdepth*zdepth+(yheight-yheight2)*(yheight-yheight2));

this_box_storage.normal_vectors[4] = coords_set(0,y_component,z_component);
this_box_storage.normal_vectors[5] = coords_set(0,-y_component,z_component);

this_box_volume.geometry.visualization_on = visualize;

this_box_volume.geometry.geometry_parameters.p_box_storage = &this_box_storage;

// Assign pointers to functions for intersection with the shape, checking if a point is inside the shape
if (this_box_storage.is_rectangle == 1) {
this_box_volume.geometry.intersect_function = &sample_box_intersect_simple;
this_box_volume.geometry.within_function = &r_within_box_simple;
}
else {
this_box_volume.geometry.intersect_function = &sample_box_intersect_advanced;
this_box_volume.geometry.within_function = &r_within_box_advanced;
}

this_box_volume.geometry.shell_points = &box_shell_points;
this_box_volume.geometry.mcdisplay_function = &mcdisplay_box_function;
this_box_volume.geometry.initialize_from_main_function = &initialize_box_geometry_from_main_component;
this_box_volume.geometry.process_rot_allocated = 0;

this_box_volume.geometry.copy_geometry_parameters = &allocate_box_storage_copy;

rot_copy(this_box_volume.geometry.rotation_matrix,ROT_A_CURRENT_COMP); //check how ROT_R_CURRENT_COMP would work
rot_transpose(ROT_A_CURRENT_COMP,this_box_volume.geometry.transpose_rotation_matrix);

// Initialize loggers
this_box_volume.loggers.num_elements = 0;

// packing the information into the global_geometry_element, which is then included in the global_geometry_list.
sprintf(global_geometry_element.name,NAME_CURRENT_COMP);
global_geometry_element.activation_counter = number_of_activations;
global_geometry_element.component_index = INDEX_CURRENT_COMP;
global_geometry_element.Volume = &this_box_volume; // Would be nicer if this m was a pointer, now we have the (small) data two places
add_element_to_geometry_list(&global_geometry_list,global_geometry_element);
}
#line 325721 "MACS_sample_kidney_box.c"
#undef number_of_activations
#undef mask_setting
#undef mask_string
#undef p_interact
#undef focus_r
#undef focus_xh
#undef focus_xw
#undef focus_ah
#undef focus_aw
#undef target_z
#undef target_y
#undef target_x
#undef target_index
#undef visualize
#undef yheight2
#undef xwidth2
#undef zdepth
#undef yheight
#undef xwidth
#undef priority
#undef material_string
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

  /* Initializations for component channel_18_analyzer_1_array_crystal_array_6. */
  SIG_MESSAGE("channel_18_analyzer_1_array_crystal_array_6 (Init)");
#define mccompcurname  channel_18_analyzer_1_array_crystal_array_6
#define mccompcurtype  Union_box
#define mccompcurindex 820
#define loop_index mccchannel_18_analyzer_1_array_crystal_array_6_loop_index
#define this_box_volume mccchannel_18_analyzer_1_array_crystal_array_6_this_box_volume
#define global_geometry_element mccchannel_18_analyzer_1_array_crystal_array_6_global_geometry_element
#define this_box_storage mccchannel_18_analyzer_1_array_crystal_array_6_this_box_storage
#define material_string mccchannel_18_analyzer_1_array_crystal_array_6_material_string
#define priority mccchannel_18_analyzer_1_array_crystal_array_6_priority
#define xwidth mccchannel_18_analyzer_1_array_crystal_array_6_xwidth
#define yheight mccchannel_18_analyzer_1_array_crystal_array_6_yheight
#define zdepth mccchannel_18_analyzer_1_array_crystal_array_6_zdepth
#define xwidth2 mccchannel_18_analyzer_1_array_crystal_array_6_xwidth2
#define yheight2 mccchannel_18_analyzer_1_array_crystal_array_6_yheight2
#define visualize mccchannel_18_analyzer_1_array_crystal_array_6_visualize
#define target_index mccchannel_18_analyzer_1_array_crystal_array_6_target_index
#define target_x mccchannel_18_analyzer_1_array_crystal_array_6_target_x
#define target_y mccchannel_18_analyzer_1_array_crystal_array_6_target_y
#define target_z mccchannel_18_analyzer_1_array_crystal_array_6_target_z
#define focus_aw mccchannel_18_analyzer_1_array_crystal_array_6_focus_aw
#define focus_ah mccchannel_18_analyzer_1_array_crystal_array_6_focus_ah
#define focus_xw mccchannel_18_analyzer_1_array_crystal_array_6_focus_xw
#define focus_xh mccchannel_18_analyzer_1_array_crystal_array_6_focus_xh
#define focus_r mccchannel_18_analyzer_1_array_crystal_array_6_focus_r
#define p_interact mccchannel_18_analyzer_1_array_crystal_array_6_p_interact
#define mask_string mccchannel_18_analyzer_1_array_crystal_array_6_mask_string
#define mask_setting mccchannel_18_analyzer_1_array_crystal_array_6_mask_setting
#define number_of_activations mccchannel_18_analyzer_1_array_crystal_array_6_number_of_activations
#line 224 "Union_box.comp"
{
// Initializes the focusing system for this volume including input sanitation.
focus_initialize(&this_box_volume.geometry, POS_A_COMP_INDEX(INDEX_CURRENT_COMP+target_index), POS_A_CURRENT_COMP, ROT_A_CURRENT_COMP, target_index, target_x, target_y, target_z, focus_aw, focus_ah, focus_xw, focus_xh, focus_r, NAME_CURRENT_COMP);

// Input sanitation for this geometry
if (xwidth <= 0) {
  printf("\nERROR in Union_box named %s, the xwidth is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (yheight <= 0) {
  printf("\nERROR in Union_box named %s, yheight is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (zdepth <= 0) {
  printf("\nERROR in Union_box named %s, zdepth is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (xwidth2 <= 0 && xwidth2 != -1) {
  printf("\nERROR in Union_box named %s, the xwidth2 is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (yheight2 <= 0 && yheight2 != -1) {
  printf("\nERROR in Union_box named %s, yheight2 is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}

// Use sanitation
if (global_material_list.num_elements == 0) {
  printf("\nERROR: Need to define a material using Union_make_material before using a Union geometry component. \n");
  printf("       %s was defined before first use of Union_make_material.\n",NAME_CURRENT_COMP);
  exit(1);
}

this_box_volume.geometry.is_masked_volume = 0;
this_box_volume.geometry.is_exit_volume = 0;
this_box_volume.geometry.is_mask_volume = 0;
// check if the volume is a mask, if it is the material string is irelevant.
if (mask_string && strlen(mask_string) && strcmp(mask_string, "NULL") && strcmp(mask_string, "0")) {
    // A mask volume is used to limit the extend of other volumes, called the masked volumes. These are specified in the mask_string.
    // In order for a ray to enter a masked volume, it needs to be both in the region covered by that volume AND the mask volume.
    // When more than
    this_box_volume.geometry.mask_mode = 1; // Default is mask mode is ALL
    if (mask_setting && strlen(mask_setting) && strcmp(mask_setting, "NULL") && strcmp(mask_setting, "0")) {
        if (strcmp(mask_setting,"ALL") == 0 || strcmp(mask_setting,"All") == 0) this_box_volume.geometry.mask_mode = 1;
        else if (strcmp(mask_setting,"ANY") == 0 || strcmp(mask_setting,"Any") == 0) this_box_volume.geometry.mask_mode = 2;
        else {
            printf("The mask_mode of component %s is set to %s, but must be either ALL or ANY.\n",NAME_CURRENT_COMP,mask_setting);
            exit(1);
        }
    }
    
    for (loop_index=0;loop_index<global_geometry_list.num_elements;loop_index++) {
        // Add mask list
        if (1 == manual_linking_function(global_geometry_list.elements[loop_index].name,mask_string)) {
            add_element_to_int_list(&this_box_volume.geometry.mask_list,global_geometry_list.elements[loop_index].component_index);
            add_element_to_int_list(&global_geometry_list.elements[loop_index].Volume->geometry.masked_by_list,INDEX_CURRENT_COMP);
            global_geometry_list.elements[loop_index].Volume->geometry.is_masked_volume = 1;
            if (this_box_volume.geometry.mask_mode == 2)
                global_geometry_list.elements[loop_index].Volume->geometry.mask_mode = 2;
            if (this_box_volume.geometry.mask_mode == 1) {
                if (global_geometry_list.elements[loop_index].Volume->geometry.is_masked_volume == 1 && global_geometry_list.elements[loop_index].Volume->geometry.mask_mode != 2)
                    // If more than one mask is added to one volume, the ANY mode overwrites the (default) ALL mode.
                    global_geometry_list.elements[loop_index].Volume->geometry.mask_mode = 1;
            }
            
            found_geometries = 1;
        }
    }
    if (found_geometries == 0) {
        printf("The mask_string in geometry: %s did not find any of the specified volumes in the mask_string %s \n",NAME_CURRENT_COMP,mask_string);
        exit(1);
    }
    this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
    this_box_volume.p_physics->is_vacuum = 0; // Makes this volume a vacuum
    this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
    this_box_volume.p_physics->my_a = 0; // Should not be used.
    sprintf(this_box_volume.p_physics->name,"Mask");
    this_box_volume.geometry.is_mask_volume = 1;
    
    
// Read the material input, or if it lacks, use automatic linking.
} else if (material_string && strlen(material_string) && strcmp(material_string, "NULL") && strcmp(material_string, "0")) {
    // A geometry string was given, use it to determine which material
    if (0 == strcmp(material_string,"vacuum") || 0 == strcmp(material_string,"Vacuum")) {
        // One could have a global physics struct for vacuum instead of creating one for each
        this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
        this_box_volume.p_physics->is_vacuum = 1; // Makes this volume a vacuum
        this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
        this_box_volume.p_physics->my_a = 0; // Should not be used.
        sprintf(this_box_volume.p_physics->name,"Vacuum");
    } else if (0 == strcmp(material_string,"exit") || 0 == strcmp(material_string,"Exit")) {
        // One could have a global physics struct for vacuum instead of creating one for each
        this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
        this_box_volume.p_physics->is_vacuum = 1; // Makes this volume a vacuum
        this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
        this_box_volume.p_physics->my_a = 0; // Should not be used.
        this_box_volume.geometry.is_exit_volume = 1;
        sprintf(this_box_volume.p_physics->name,"Exit");
    } else {
        #ifndef MATERIAL_DETECTOR
            printf("Need to define a material before refering to it in a geometry %s.\n",NAME_CURRENT_COMP);
            exit(1);
        #endif
        for (loop_index=0;loop_index<global_material_list.num_elements;loop_index++) {
            if (0 == strcmp(material_string,global_material_list.elements[loop_index].name)) {
                this_box_volume.p_physics = global_material_list.elements[loop_index].physics;
                break;
            }
            if (loop_index == global_material_list.num_elements-1) {
            printf("\n");
            printf("ERROR: The material string \"%s\" in Union geometry \"%s\" did not match a specified material. \n",material_string,NAME_CURRENT_COMP);
            printf("       The materials available at this point (need to be defined before the geometry): \n");
            for (loop_index=0;loop_index<global_material_list.num_elements;loop_index++)
              printf("         %s\n",global_material_list.elements[loop_index].name);
            printf("\n");
            printf("       It is also possible to use one of the defualt materials avaiable: \n");
            printf("           Vacuum (for a Volume without scattering or absorption)\n");
            printf("           Exit (for a Volume where the ray exits the component if it enters)\n");
            printf("           Mask (for a Volume that masks existing volumes specified in the mask_string\n");
            exit(1);
          }
        }
    }
} else {
    // Automatic linking, simply using the last defined material.
    #ifndef MATERIAL_DETECTOR
        printf("Need to define a material before the geometry to use automatic linking %s.\n",NAME_CURRENT_COMP);
        exit(1);
    #endif
    this_box_volume.p_physics = global_material_list.elements[global_material_list.num_elements-1].physics;
}

sprintf(this_box_volume.name,NAME_CURRENT_COMP);
sprintf(this_box_volume.geometry.shape,"box");
this_box_volume.geometry.priority_value = priority;
this_box_volume.geometry.geometry_p_interact = p_interact;
// Currently the coordinates will be in absolute space.
this_box_volume.geometry.center = POS_A_CURRENT_COMP;

this_box_storage.z_depth = zdepth;
this_box_storage.x_width1 = xwidth;
this_box_storage.y_height1 = yheight;

this_box_storage.is_rectangle = 0;
if (xwidth2 < 0 && yheight2 < 0) this_box_storage.is_rectangle = 1;
if (xwidth == xwidth2 && yheight == yheight2) this_box_storage.is_rectangle = 1;

if (xwidth2 < 0) {
    this_box_storage.x_width2 = xwidth;
    xwidth2 = xwidth;
} else this_box_storage.x_width2 = xwidth2;

if (yheight2 < 0) {
    this_box_storage.y_height2 = yheight;
    yheight2 = yheight;
} else this_box_storage.y_height2 = yheight2;


this_box_storage.normal_vectors[0] = coords_set(0,0,1);
this_box_storage.normal_vectors[1] = coords_set(0,0,1);

// for sides with y component = 0
x_component = 2*zdepth/sqrt((xwidth-xwidth2)*(xwidth-xwidth2)+4*zdepth*zdepth);
z_component = (xwidth-xwidth2)/sqrt(4*zdepth*zdepth+(xwidth-xwidth2)*(xwidth-xwidth2));

this_box_storage.normal_vectors[2] = coords_set(x_component,0,z_component);
this_box_storage.normal_vectors[3] = coords_set(-x_component,0,z_component);

// for sides with x component = 0
y_component = 2*zdepth/sqrt((yheight-yheight2)*(yheight-yheight2)+4*zdepth*zdepth);
z_component = (yheight-yheight2)/sqrt(4*zdepth*zdepth+(yheight-yheight2)*(yheight-yheight2));

this_box_storage.normal_vectors[4] = coords_set(0,y_component,z_component);
this_box_storage.normal_vectors[5] = coords_set(0,-y_component,z_component);

this_box_volume.geometry.visualization_on = visualize;

this_box_volume.geometry.geometry_parameters.p_box_storage = &this_box_storage;

// Assign pointers to functions for intersection with the shape, checking if a point is inside the shape
if (this_box_storage.is_rectangle == 1) {
this_box_volume.geometry.intersect_function = &sample_box_intersect_simple;
this_box_volume.geometry.within_function = &r_within_box_simple;
}
else {
this_box_volume.geometry.intersect_function = &sample_box_intersect_advanced;
this_box_volume.geometry.within_function = &r_within_box_advanced;
}

this_box_volume.geometry.shell_points = &box_shell_points;
this_box_volume.geometry.mcdisplay_function = &mcdisplay_box_function;
this_box_volume.geometry.initialize_from_main_function = &initialize_box_geometry_from_main_component;
this_box_volume.geometry.process_rot_allocated = 0;

this_box_volume.geometry.copy_geometry_parameters = &allocate_box_storage_copy;

rot_copy(this_box_volume.geometry.rotation_matrix,ROT_A_CURRENT_COMP); //check how ROT_R_CURRENT_COMP would work
rot_transpose(ROT_A_CURRENT_COMP,this_box_volume.geometry.transpose_rotation_matrix);

// Initialize loggers
this_box_volume.loggers.num_elements = 0;

// packing the information into the global_geometry_element, which is then included in the global_geometry_list.
sprintf(global_geometry_element.name,NAME_CURRENT_COMP);
global_geometry_element.activation_counter = number_of_activations;
global_geometry_element.component_index = INDEX_CURRENT_COMP;
global_geometry_element.Volume = &this_box_volume; // Would be nicer if this m was a pointer, now we have the (small) data two places
add_element_to_geometry_list(&global_geometry_list,global_geometry_element);
}
#line 325991 "MACS_sample_kidney_box.c"
#undef number_of_activations
#undef mask_setting
#undef mask_string
#undef p_interact
#undef focus_r
#undef focus_xh
#undef focus_xw
#undef focus_ah
#undef focus_aw
#undef target_z
#undef target_y
#undef target_x
#undef target_index
#undef visualize
#undef yheight2
#undef xwidth2
#undef zdepth
#undef yheight
#undef xwidth
#undef priority
#undef material_string
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

  /* Initializations for component channel_18_analyzer_1_array_crystal_array_7. */
  SIG_MESSAGE("channel_18_analyzer_1_array_crystal_array_7 (Init)");
#define mccompcurname  channel_18_analyzer_1_array_crystal_array_7
#define mccompcurtype  Union_box
#define mccompcurindex 821
#define loop_index mccchannel_18_analyzer_1_array_crystal_array_7_loop_index
#define this_box_volume mccchannel_18_analyzer_1_array_crystal_array_7_this_box_volume
#define global_geometry_element mccchannel_18_analyzer_1_array_crystal_array_7_global_geometry_element
#define this_box_storage mccchannel_18_analyzer_1_array_crystal_array_7_this_box_storage
#define material_string mccchannel_18_analyzer_1_array_crystal_array_7_material_string
#define priority mccchannel_18_analyzer_1_array_crystal_array_7_priority
#define xwidth mccchannel_18_analyzer_1_array_crystal_array_7_xwidth
#define yheight mccchannel_18_analyzer_1_array_crystal_array_7_yheight
#define zdepth mccchannel_18_analyzer_1_array_crystal_array_7_zdepth
#define xwidth2 mccchannel_18_analyzer_1_array_crystal_array_7_xwidth2
#define yheight2 mccchannel_18_analyzer_1_array_crystal_array_7_yheight2
#define visualize mccchannel_18_analyzer_1_array_crystal_array_7_visualize
#define target_index mccchannel_18_analyzer_1_array_crystal_array_7_target_index
#define target_x mccchannel_18_analyzer_1_array_crystal_array_7_target_x
#define target_y mccchannel_18_analyzer_1_array_crystal_array_7_target_y
#define target_z mccchannel_18_analyzer_1_array_crystal_array_7_target_z
#define focus_aw mccchannel_18_analyzer_1_array_crystal_array_7_focus_aw
#define focus_ah mccchannel_18_analyzer_1_array_crystal_array_7_focus_ah
#define focus_xw mccchannel_18_analyzer_1_array_crystal_array_7_focus_xw
#define focus_xh mccchannel_18_analyzer_1_array_crystal_array_7_focus_xh
#define focus_r mccchannel_18_analyzer_1_array_crystal_array_7_focus_r
#define p_interact mccchannel_18_analyzer_1_array_crystal_array_7_p_interact
#define mask_string mccchannel_18_analyzer_1_array_crystal_array_7_mask_string
#define mask_setting mccchannel_18_analyzer_1_array_crystal_array_7_mask_setting
#define number_of_activations mccchannel_18_analyzer_1_array_crystal_array_7_number_of_activations
#line 224 "Union_box.comp"
{
// Initializes the focusing system for this volume including input sanitation.
focus_initialize(&this_box_volume.geometry, POS_A_COMP_INDEX(INDEX_CURRENT_COMP+target_index), POS_A_CURRENT_COMP, ROT_A_CURRENT_COMP, target_index, target_x, target_y, target_z, focus_aw, focus_ah, focus_xw, focus_xh, focus_r, NAME_CURRENT_COMP);

// Input sanitation for this geometry
if (xwidth <= 0) {
  printf("\nERROR in Union_box named %s, the xwidth is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (yheight <= 0) {
  printf("\nERROR in Union_box named %s, yheight is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (zdepth <= 0) {
  printf("\nERROR in Union_box named %s, zdepth is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (xwidth2 <= 0 && xwidth2 != -1) {
  printf("\nERROR in Union_box named %s, the xwidth2 is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (yheight2 <= 0 && yheight2 != -1) {
  printf("\nERROR in Union_box named %s, yheight2 is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}

// Use sanitation
if (global_material_list.num_elements == 0) {
  printf("\nERROR: Need to define a material using Union_make_material before using a Union geometry component. \n");
  printf("       %s was defined before first use of Union_make_material.\n",NAME_CURRENT_COMP);
  exit(1);
}

this_box_volume.geometry.is_masked_volume = 0;
this_box_volume.geometry.is_exit_volume = 0;
this_box_volume.geometry.is_mask_volume = 0;
// check if the volume is a mask, if it is the material string is irelevant.
if (mask_string && strlen(mask_string) && strcmp(mask_string, "NULL") && strcmp(mask_string, "0")) {
    // A mask volume is used to limit the extend of other volumes, called the masked volumes. These are specified in the mask_string.
    // In order for a ray to enter a masked volume, it needs to be both in the region covered by that volume AND the mask volume.
    // When more than
    this_box_volume.geometry.mask_mode = 1; // Default is mask mode is ALL
    if (mask_setting && strlen(mask_setting) && strcmp(mask_setting, "NULL") && strcmp(mask_setting, "0")) {
        if (strcmp(mask_setting,"ALL") == 0 || strcmp(mask_setting,"All") == 0) this_box_volume.geometry.mask_mode = 1;
        else if (strcmp(mask_setting,"ANY") == 0 || strcmp(mask_setting,"Any") == 0) this_box_volume.geometry.mask_mode = 2;
        else {
            printf("The mask_mode of component %s is set to %s, but must be either ALL or ANY.\n",NAME_CURRENT_COMP,mask_setting);
            exit(1);
        }
    }
    
    for (loop_index=0;loop_index<global_geometry_list.num_elements;loop_index++) {
        // Add mask list
        if (1 == manual_linking_function(global_geometry_list.elements[loop_index].name,mask_string)) {
            add_element_to_int_list(&this_box_volume.geometry.mask_list,global_geometry_list.elements[loop_index].component_index);
            add_element_to_int_list(&global_geometry_list.elements[loop_index].Volume->geometry.masked_by_list,INDEX_CURRENT_COMP);
            global_geometry_list.elements[loop_index].Volume->geometry.is_masked_volume = 1;
            if (this_box_volume.geometry.mask_mode == 2)
                global_geometry_list.elements[loop_index].Volume->geometry.mask_mode = 2;
            if (this_box_volume.geometry.mask_mode == 1) {
                if (global_geometry_list.elements[loop_index].Volume->geometry.is_masked_volume == 1 && global_geometry_list.elements[loop_index].Volume->geometry.mask_mode != 2)
                    // If more than one mask is added to one volume, the ANY mode overwrites the (default) ALL mode.
                    global_geometry_list.elements[loop_index].Volume->geometry.mask_mode = 1;
            }
            
            found_geometries = 1;
        }
    }
    if (found_geometries == 0) {
        printf("The mask_string in geometry: %s did not find any of the specified volumes in the mask_string %s \n",NAME_CURRENT_COMP,mask_string);
        exit(1);
    }
    this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
    this_box_volume.p_physics->is_vacuum = 0; // Makes this volume a vacuum
    this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
    this_box_volume.p_physics->my_a = 0; // Should not be used.
    sprintf(this_box_volume.p_physics->name,"Mask");
    this_box_volume.geometry.is_mask_volume = 1;
    
    
// Read the material input, or if it lacks, use automatic linking.
} else if (material_string && strlen(material_string) && strcmp(material_string, "NULL") && strcmp(material_string, "0")) {
    // A geometry string was given, use it to determine which material
    if (0 == strcmp(material_string,"vacuum") || 0 == strcmp(material_string,"Vacuum")) {
        // One could have a global physics struct for vacuum instead of creating one for each
        this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
        this_box_volume.p_physics->is_vacuum = 1; // Makes this volume a vacuum
        this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
        this_box_volume.p_physics->my_a = 0; // Should not be used.
        sprintf(this_box_volume.p_physics->name,"Vacuum");
    } else if (0 == strcmp(material_string,"exit") || 0 == strcmp(material_string,"Exit")) {
        // One could have a global physics struct for vacuum instead of creating one for each
        this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
        this_box_volume.p_physics->is_vacuum = 1; // Makes this volume a vacuum
        this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
        this_box_volume.p_physics->my_a = 0; // Should not be used.
        this_box_volume.geometry.is_exit_volume = 1;
        sprintf(this_box_volume.p_physics->name,"Exit");
    } else {
        #ifndef MATERIAL_DETECTOR
            printf("Need to define a material before refering to it in a geometry %s.\n",NAME_CURRENT_COMP);
            exit(1);
        #endif
        for (loop_index=0;loop_index<global_material_list.num_elements;loop_index++) {
            if (0 == strcmp(material_string,global_material_list.elements[loop_index].name)) {
                this_box_volume.p_physics = global_material_list.elements[loop_index].physics;
                break;
            }
            if (loop_index == global_material_list.num_elements-1) {
            printf("\n");
            printf("ERROR: The material string \"%s\" in Union geometry \"%s\" did not match a specified material. \n",material_string,NAME_CURRENT_COMP);
            printf("       The materials available at this point (need to be defined before the geometry): \n");
            for (loop_index=0;loop_index<global_material_list.num_elements;loop_index++)
              printf("         %s\n",global_material_list.elements[loop_index].name);
            printf("\n");
            printf("       It is also possible to use one of the defualt materials avaiable: \n");
            printf("           Vacuum (for a Volume without scattering or absorption)\n");
            printf("           Exit (for a Volume where the ray exits the component if it enters)\n");
            printf("           Mask (for a Volume that masks existing volumes specified in the mask_string\n");
            exit(1);
          }
        }
    }
} else {
    // Automatic linking, simply using the last defined material.
    #ifndef MATERIAL_DETECTOR
        printf("Need to define a material before the geometry to use automatic linking %s.\n",NAME_CURRENT_COMP);
        exit(1);
    #endif
    this_box_volume.p_physics = global_material_list.elements[global_material_list.num_elements-1].physics;
}

sprintf(this_box_volume.name,NAME_CURRENT_COMP);
sprintf(this_box_volume.geometry.shape,"box");
this_box_volume.geometry.priority_value = priority;
this_box_volume.geometry.geometry_p_interact = p_interact;
// Currently the coordinates will be in absolute space.
this_box_volume.geometry.center = POS_A_CURRENT_COMP;

this_box_storage.z_depth = zdepth;
this_box_storage.x_width1 = xwidth;
this_box_storage.y_height1 = yheight;

this_box_storage.is_rectangle = 0;
if (xwidth2 < 0 && yheight2 < 0) this_box_storage.is_rectangle = 1;
if (xwidth == xwidth2 && yheight == yheight2) this_box_storage.is_rectangle = 1;

if (xwidth2 < 0) {
    this_box_storage.x_width2 = xwidth;
    xwidth2 = xwidth;
} else this_box_storage.x_width2 = xwidth2;

if (yheight2 < 0) {
    this_box_storage.y_height2 = yheight;
    yheight2 = yheight;
} else this_box_storage.y_height2 = yheight2;


this_box_storage.normal_vectors[0] = coords_set(0,0,1);
this_box_storage.normal_vectors[1] = coords_set(0,0,1);

// for sides with y component = 0
x_component = 2*zdepth/sqrt((xwidth-xwidth2)*(xwidth-xwidth2)+4*zdepth*zdepth);
z_component = (xwidth-xwidth2)/sqrt(4*zdepth*zdepth+(xwidth-xwidth2)*(xwidth-xwidth2));

this_box_storage.normal_vectors[2] = coords_set(x_component,0,z_component);
this_box_storage.normal_vectors[3] = coords_set(-x_component,0,z_component);

// for sides with x component = 0
y_component = 2*zdepth/sqrt((yheight-yheight2)*(yheight-yheight2)+4*zdepth*zdepth);
z_component = (yheight-yheight2)/sqrt(4*zdepth*zdepth+(yheight-yheight2)*(yheight-yheight2));

this_box_storage.normal_vectors[4] = coords_set(0,y_component,z_component);
this_box_storage.normal_vectors[5] = coords_set(0,-y_component,z_component);

this_box_volume.geometry.visualization_on = visualize;

this_box_volume.geometry.geometry_parameters.p_box_storage = &this_box_storage;

// Assign pointers to functions for intersection with the shape, checking if a point is inside the shape
if (this_box_storage.is_rectangle == 1) {
this_box_volume.geometry.intersect_function = &sample_box_intersect_simple;
this_box_volume.geometry.within_function = &r_within_box_simple;
}
else {
this_box_volume.geometry.intersect_function = &sample_box_intersect_advanced;
this_box_volume.geometry.within_function = &r_within_box_advanced;
}

this_box_volume.geometry.shell_points = &box_shell_points;
this_box_volume.geometry.mcdisplay_function = &mcdisplay_box_function;
this_box_volume.geometry.initialize_from_main_function = &initialize_box_geometry_from_main_component;
this_box_volume.geometry.process_rot_allocated = 0;

this_box_volume.geometry.copy_geometry_parameters = &allocate_box_storage_copy;

rot_copy(this_box_volume.geometry.rotation_matrix,ROT_A_CURRENT_COMP); //check how ROT_R_CURRENT_COMP would work
rot_transpose(ROT_A_CURRENT_COMP,this_box_volume.geometry.transpose_rotation_matrix);

// Initialize loggers
this_box_volume.loggers.num_elements = 0;

// packing the information into the global_geometry_element, which is then included in the global_geometry_list.
sprintf(global_geometry_element.name,NAME_CURRENT_COMP);
global_geometry_element.activation_counter = number_of_activations;
global_geometry_element.component_index = INDEX_CURRENT_COMP;
global_geometry_element.Volume = &this_box_volume; // Would be nicer if this m was a pointer, now we have the (small) data two places
add_element_to_geometry_list(&global_geometry_list,global_geometry_element);
}
#line 326261 "MACS_sample_kidney_box.c"
#undef number_of_activations
#undef mask_setting
#undef mask_string
#undef p_interact
#undef focus_r
#undef focus_xh
#undef focus_xw
#undef focus_ah
#undef focus_aw
#undef target_z
#undef target_y
#undef target_x
#undef target_index
#undef visualize
#undef yheight2
#undef xwidth2
#undef zdepth
#undef yheight
#undef xwidth
#undef priority
#undef material_string
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

  /* Initializations for component channel_18_analyzer_1_array_crystal_array_8. */
  SIG_MESSAGE("channel_18_analyzer_1_array_crystal_array_8 (Init)");
#define mccompcurname  channel_18_analyzer_1_array_crystal_array_8
#define mccompcurtype  Union_box
#define mccompcurindex 822
#define loop_index mccchannel_18_analyzer_1_array_crystal_array_8_loop_index
#define this_box_volume mccchannel_18_analyzer_1_array_crystal_array_8_this_box_volume
#define global_geometry_element mccchannel_18_analyzer_1_array_crystal_array_8_global_geometry_element
#define this_box_storage mccchannel_18_analyzer_1_array_crystal_array_8_this_box_storage
#define material_string mccchannel_18_analyzer_1_array_crystal_array_8_material_string
#define priority mccchannel_18_analyzer_1_array_crystal_array_8_priority
#define xwidth mccchannel_18_analyzer_1_array_crystal_array_8_xwidth
#define yheight mccchannel_18_analyzer_1_array_crystal_array_8_yheight
#define zdepth mccchannel_18_analyzer_1_array_crystal_array_8_zdepth
#define xwidth2 mccchannel_18_analyzer_1_array_crystal_array_8_xwidth2
#define yheight2 mccchannel_18_analyzer_1_array_crystal_array_8_yheight2
#define visualize mccchannel_18_analyzer_1_array_crystal_array_8_visualize
#define target_index mccchannel_18_analyzer_1_array_crystal_array_8_target_index
#define target_x mccchannel_18_analyzer_1_array_crystal_array_8_target_x
#define target_y mccchannel_18_analyzer_1_array_crystal_array_8_target_y
#define target_z mccchannel_18_analyzer_1_array_crystal_array_8_target_z
#define focus_aw mccchannel_18_analyzer_1_array_crystal_array_8_focus_aw
#define focus_ah mccchannel_18_analyzer_1_array_crystal_array_8_focus_ah
#define focus_xw mccchannel_18_analyzer_1_array_crystal_array_8_focus_xw
#define focus_xh mccchannel_18_analyzer_1_array_crystal_array_8_focus_xh
#define focus_r mccchannel_18_analyzer_1_array_crystal_array_8_focus_r
#define p_interact mccchannel_18_analyzer_1_array_crystal_array_8_p_interact
#define mask_string mccchannel_18_analyzer_1_array_crystal_array_8_mask_string
#define mask_setting mccchannel_18_analyzer_1_array_crystal_array_8_mask_setting
#define number_of_activations mccchannel_18_analyzer_1_array_crystal_array_8_number_of_activations
#line 224 "Union_box.comp"
{
// Initializes the focusing system for this volume including input sanitation.
focus_initialize(&this_box_volume.geometry, POS_A_COMP_INDEX(INDEX_CURRENT_COMP+target_index), POS_A_CURRENT_COMP, ROT_A_CURRENT_COMP, target_index, target_x, target_y, target_z, focus_aw, focus_ah, focus_xw, focus_xh, focus_r, NAME_CURRENT_COMP);

// Input sanitation for this geometry
if (xwidth <= 0) {
  printf("\nERROR in Union_box named %s, the xwidth is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (yheight <= 0) {
  printf("\nERROR in Union_box named %s, yheight is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (zdepth <= 0) {
  printf("\nERROR in Union_box named %s, zdepth is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (xwidth2 <= 0 && xwidth2 != -1) {
  printf("\nERROR in Union_box named %s, the xwidth2 is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (yheight2 <= 0 && yheight2 != -1) {
  printf("\nERROR in Union_box named %s, yheight2 is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}

// Use sanitation
if (global_material_list.num_elements == 0) {
  printf("\nERROR: Need to define a material using Union_make_material before using a Union geometry component. \n");
  printf("       %s was defined before first use of Union_make_material.\n",NAME_CURRENT_COMP);
  exit(1);
}

this_box_volume.geometry.is_masked_volume = 0;
this_box_volume.geometry.is_exit_volume = 0;
this_box_volume.geometry.is_mask_volume = 0;
// check if the volume is a mask, if it is the material string is irelevant.
if (mask_string && strlen(mask_string) && strcmp(mask_string, "NULL") && strcmp(mask_string, "0")) {
    // A mask volume is used to limit the extend of other volumes, called the masked volumes. These are specified in the mask_string.
    // In order for a ray to enter a masked volume, it needs to be both in the region covered by that volume AND the mask volume.
    // When more than
    this_box_volume.geometry.mask_mode = 1; // Default is mask mode is ALL
    if (mask_setting && strlen(mask_setting) && strcmp(mask_setting, "NULL") && strcmp(mask_setting, "0")) {
        if (strcmp(mask_setting,"ALL") == 0 || strcmp(mask_setting,"All") == 0) this_box_volume.geometry.mask_mode = 1;
        else if (strcmp(mask_setting,"ANY") == 0 || strcmp(mask_setting,"Any") == 0) this_box_volume.geometry.mask_mode = 2;
        else {
            printf("The mask_mode of component %s is set to %s, but must be either ALL or ANY.\n",NAME_CURRENT_COMP,mask_setting);
            exit(1);
        }
    }
    
    for (loop_index=0;loop_index<global_geometry_list.num_elements;loop_index++) {
        // Add mask list
        if (1 == manual_linking_function(global_geometry_list.elements[loop_index].name,mask_string)) {
            add_element_to_int_list(&this_box_volume.geometry.mask_list,global_geometry_list.elements[loop_index].component_index);
            add_element_to_int_list(&global_geometry_list.elements[loop_index].Volume->geometry.masked_by_list,INDEX_CURRENT_COMP);
            global_geometry_list.elements[loop_index].Volume->geometry.is_masked_volume = 1;
            if (this_box_volume.geometry.mask_mode == 2)
                global_geometry_list.elements[loop_index].Volume->geometry.mask_mode = 2;
            if (this_box_volume.geometry.mask_mode == 1) {
                if (global_geometry_list.elements[loop_index].Volume->geometry.is_masked_volume == 1 && global_geometry_list.elements[loop_index].Volume->geometry.mask_mode != 2)
                    // If more than one mask is added to one volume, the ANY mode overwrites the (default) ALL mode.
                    global_geometry_list.elements[loop_index].Volume->geometry.mask_mode = 1;
            }
            
            found_geometries = 1;
        }
    }
    if (found_geometries == 0) {
        printf("The mask_string in geometry: %s did not find any of the specified volumes in the mask_string %s \n",NAME_CURRENT_COMP,mask_string);
        exit(1);
    }
    this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
    this_box_volume.p_physics->is_vacuum = 0; // Makes this volume a vacuum
    this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
    this_box_volume.p_physics->my_a = 0; // Should not be used.
    sprintf(this_box_volume.p_physics->name,"Mask");
    this_box_volume.geometry.is_mask_volume = 1;
    
    
// Read the material input, or if it lacks, use automatic linking.
} else if (material_string && strlen(material_string) && strcmp(material_string, "NULL") && strcmp(material_string, "0")) {
    // A geometry string was given, use it to determine which material
    if (0 == strcmp(material_string,"vacuum") || 0 == strcmp(material_string,"Vacuum")) {
        // One could have a global physics struct for vacuum instead of creating one for each
        this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
        this_box_volume.p_physics->is_vacuum = 1; // Makes this volume a vacuum
        this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
        this_box_volume.p_physics->my_a = 0; // Should not be used.
        sprintf(this_box_volume.p_physics->name,"Vacuum");
    } else if (0 == strcmp(material_string,"exit") || 0 == strcmp(material_string,"Exit")) {
        // One could have a global physics struct for vacuum instead of creating one for each
        this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
        this_box_volume.p_physics->is_vacuum = 1; // Makes this volume a vacuum
        this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
        this_box_volume.p_physics->my_a = 0; // Should not be used.
        this_box_volume.geometry.is_exit_volume = 1;
        sprintf(this_box_volume.p_physics->name,"Exit");
    } else {
        #ifndef MATERIAL_DETECTOR
            printf("Need to define a material before refering to it in a geometry %s.\n",NAME_CURRENT_COMP);
            exit(1);
        #endif
        for (loop_index=0;loop_index<global_material_list.num_elements;loop_index++) {
            if (0 == strcmp(material_string,global_material_list.elements[loop_index].name)) {
                this_box_volume.p_physics = global_material_list.elements[loop_index].physics;
                break;
            }
            if (loop_index == global_material_list.num_elements-1) {
            printf("\n");
            printf("ERROR: The material string \"%s\" in Union geometry \"%s\" did not match a specified material. \n",material_string,NAME_CURRENT_COMP);
            printf("       The materials available at this point (need to be defined before the geometry): \n");
            for (loop_index=0;loop_index<global_material_list.num_elements;loop_index++)
              printf("         %s\n",global_material_list.elements[loop_index].name);
            printf("\n");
            printf("       It is also possible to use one of the defualt materials avaiable: \n");
            printf("           Vacuum (for a Volume without scattering or absorption)\n");
            printf("           Exit (for a Volume where the ray exits the component if it enters)\n");
            printf("           Mask (for a Volume that masks existing volumes specified in the mask_string\n");
            exit(1);
          }
        }
    }
} else {
    // Automatic linking, simply using the last defined material.
    #ifndef MATERIAL_DETECTOR
        printf("Need to define a material before the geometry to use automatic linking %s.\n",NAME_CURRENT_COMP);
        exit(1);
    #endif
    this_box_volume.p_physics = global_material_list.elements[global_material_list.num_elements-1].physics;
}

sprintf(this_box_volume.name,NAME_CURRENT_COMP);
sprintf(this_box_volume.geometry.shape,"box");
this_box_volume.geometry.priority_value = priority;
this_box_volume.geometry.geometry_p_interact = p_interact;
// Currently the coordinates will be in absolute space.
this_box_volume.geometry.center = POS_A_CURRENT_COMP;

this_box_storage.z_depth = zdepth;
this_box_storage.x_width1 = xwidth;
this_box_storage.y_height1 = yheight;

this_box_storage.is_rectangle = 0;
if (xwidth2 < 0 && yheight2 < 0) this_box_storage.is_rectangle = 1;
if (xwidth == xwidth2 && yheight == yheight2) this_box_storage.is_rectangle = 1;

if (xwidth2 < 0) {
    this_box_storage.x_width2 = xwidth;
    xwidth2 = xwidth;
} else this_box_storage.x_width2 = xwidth2;

if (yheight2 < 0) {
    this_box_storage.y_height2 = yheight;
    yheight2 = yheight;
} else this_box_storage.y_height2 = yheight2;


this_box_storage.normal_vectors[0] = coords_set(0,0,1);
this_box_storage.normal_vectors[1] = coords_set(0,0,1);

// for sides with y component = 0
x_component = 2*zdepth/sqrt((xwidth-xwidth2)*(xwidth-xwidth2)+4*zdepth*zdepth);
z_component = (xwidth-xwidth2)/sqrt(4*zdepth*zdepth+(xwidth-xwidth2)*(xwidth-xwidth2));

this_box_storage.normal_vectors[2] = coords_set(x_component,0,z_component);
this_box_storage.normal_vectors[3] = coords_set(-x_component,0,z_component);

// for sides with x component = 0
y_component = 2*zdepth/sqrt((yheight-yheight2)*(yheight-yheight2)+4*zdepth*zdepth);
z_component = (yheight-yheight2)/sqrt(4*zdepth*zdepth+(yheight-yheight2)*(yheight-yheight2));

this_box_storage.normal_vectors[4] = coords_set(0,y_component,z_component);
this_box_storage.normal_vectors[5] = coords_set(0,-y_component,z_component);

this_box_volume.geometry.visualization_on = visualize;

this_box_volume.geometry.geometry_parameters.p_box_storage = &this_box_storage;

// Assign pointers to functions for intersection with the shape, checking if a point is inside the shape
if (this_box_storage.is_rectangle == 1) {
this_box_volume.geometry.intersect_function = &sample_box_intersect_simple;
this_box_volume.geometry.within_function = &r_within_box_simple;
}
else {
this_box_volume.geometry.intersect_function = &sample_box_intersect_advanced;
this_box_volume.geometry.within_function = &r_within_box_advanced;
}

this_box_volume.geometry.shell_points = &box_shell_points;
this_box_volume.geometry.mcdisplay_function = &mcdisplay_box_function;
this_box_volume.geometry.initialize_from_main_function = &initialize_box_geometry_from_main_component;
this_box_volume.geometry.process_rot_allocated = 0;

this_box_volume.geometry.copy_geometry_parameters = &allocate_box_storage_copy;

rot_copy(this_box_volume.geometry.rotation_matrix,ROT_A_CURRENT_COMP); //check how ROT_R_CURRENT_COMP would work
rot_transpose(ROT_A_CURRENT_COMP,this_box_volume.geometry.transpose_rotation_matrix);

// Initialize loggers
this_box_volume.loggers.num_elements = 0;

// packing the information into the global_geometry_element, which is then included in the global_geometry_list.
sprintf(global_geometry_element.name,NAME_CURRENT_COMP);
global_geometry_element.activation_counter = number_of_activations;
global_geometry_element.component_index = INDEX_CURRENT_COMP;
global_geometry_element.Volume = &this_box_volume; // Would be nicer if this m was a pointer, now we have the (small) data two places
add_element_to_geometry_list(&global_geometry_list,global_geometry_element);
}
#line 326531 "MACS_sample_kidney_box.c"
#undef number_of_activations
#undef mask_setting
#undef mask_string
#undef p_interact
#undef focus_r
#undef focus_xh
#undef focus_xw
#undef focus_ah
#undef focus_aw
#undef target_z
#undef target_y
#undef target_x
#undef target_index
#undef visualize
#undef yheight2
#undef xwidth2
#undef zdepth
#undef yheight
#undef xwidth
#undef priority
#undef material_string
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

  /* Initializations for component channel_18_analyzer_2_center. */
  SIG_MESSAGE("channel_18_analyzer_2_center (Init)");

  /* Initializations for component channel_18_analyzer_2_rotated. */
  SIG_MESSAGE("channel_18_analyzer_2_rotated (Init)");

  /* Initializations for component channel_18_analyzer_2_array_crystal_array_0. */
  SIG_MESSAGE("channel_18_analyzer_2_array_crystal_array_0 (Init)");
#define mccompcurname  channel_18_analyzer_2_array_crystal_array_0
#define mccompcurtype  Union_box
#define mccompcurindex 825
#define loop_index mccchannel_18_analyzer_2_array_crystal_array_0_loop_index
#define this_box_volume mccchannel_18_analyzer_2_array_crystal_array_0_this_box_volume
#define global_geometry_element mccchannel_18_analyzer_2_array_crystal_array_0_global_geometry_element
#define this_box_storage mccchannel_18_analyzer_2_array_crystal_array_0_this_box_storage
#define material_string mccchannel_18_analyzer_2_array_crystal_array_0_material_string
#define priority mccchannel_18_analyzer_2_array_crystal_array_0_priority
#define xwidth mccchannel_18_analyzer_2_array_crystal_array_0_xwidth
#define yheight mccchannel_18_analyzer_2_array_crystal_array_0_yheight
#define zdepth mccchannel_18_analyzer_2_array_crystal_array_0_zdepth
#define xwidth2 mccchannel_18_analyzer_2_array_crystal_array_0_xwidth2
#define yheight2 mccchannel_18_analyzer_2_array_crystal_array_0_yheight2
#define visualize mccchannel_18_analyzer_2_array_crystal_array_0_visualize
#define target_index mccchannel_18_analyzer_2_array_crystal_array_0_target_index
#define target_x mccchannel_18_analyzer_2_array_crystal_array_0_target_x
#define target_y mccchannel_18_analyzer_2_array_crystal_array_0_target_y
#define target_z mccchannel_18_analyzer_2_array_crystal_array_0_target_z
#define focus_aw mccchannel_18_analyzer_2_array_crystal_array_0_focus_aw
#define focus_ah mccchannel_18_analyzer_2_array_crystal_array_0_focus_ah
#define focus_xw mccchannel_18_analyzer_2_array_crystal_array_0_focus_xw
#define focus_xh mccchannel_18_analyzer_2_array_crystal_array_0_focus_xh
#define focus_r mccchannel_18_analyzer_2_array_crystal_array_0_focus_r
#define p_interact mccchannel_18_analyzer_2_array_crystal_array_0_p_interact
#define mask_string mccchannel_18_analyzer_2_array_crystal_array_0_mask_string
#define mask_setting mccchannel_18_analyzer_2_array_crystal_array_0_mask_setting
#define number_of_activations mccchannel_18_analyzer_2_array_crystal_array_0_number_of_activations
#line 224 "Union_box.comp"
{
// Initializes the focusing system for this volume including input sanitation.
focus_initialize(&this_box_volume.geometry, POS_A_COMP_INDEX(INDEX_CURRENT_COMP+target_index), POS_A_CURRENT_COMP, ROT_A_CURRENT_COMP, target_index, target_x, target_y, target_z, focus_aw, focus_ah, focus_xw, focus_xh, focus_r, NAME_CURRENT_COMP);

// Input sanitation for this geometry
if (xwidth <= 0) {
  printf("\nERROR in Union_box named %s, the xwidth is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (yheight <= 0) {
  printf("\nERROR in Union_box named %s, yheight is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (zdepth <= 0) {
  printf("\nERROR in Union_box named %s, zdepth is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (xwidth2 <= 0 && xwidth2 != -1) {
  printf("\nERROR in Union_box named %s, the xwidth2 is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (yheight2 <= 0 && yheight2 != -1) {
  printf("\nERROR in Union_box named %s, yheight2 is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}

// Use sanitation
if (global_material_list.num_elements == 0) {
  printf("\nERROR: Need to define a material using Union_make_material before using a Union geometry component. \n");
  printf("       %s was defined before first use of Union_make_material.\n",NAME_CURRENT_COMP);
  exit(1);
}

this_box_volume.geometry.is_masked_volume = 0;
this_box_volume.geometry.is_exit_volume = 0;
this_box_volume.geometry.is_mask_volume = 0;
// check if the volume is a mask, if it is the material string is irelevant.
if (mask_string && strlen(mask_string) && strcmp(mask_string, "NULL") && strcmp(mask_string, "0")) {
    // A mask volume is used to limit the extend of other volumes, called the masked volumes. These are specified in the mask_string.
    // In order for a ray to enter a masked volume, it needs to be both in the region covered by that volume AND the mask volume.
    // When more than
    this_box_volume.geometry.mask_mode = 1; // Default is mask mode is ALL
    if (mask_setting && strlen(mask_setting) && strcmp(mask_setting, "NULL") && strcmp(mask_setting, "0")) {
        if (strcmp(mask_setting,"ALL") == 0 || strcmp(mask_setting,"All") == 0) this_box_volume.geometry.mask_mode = 1;
        else if (strcmp(mask_setting,"ANY") == 0 || strcmp(mask_setting,"Any") == 0) this_box_volume.geometry.mask_mode = 2;
        else {
            printf("The mask_mode of component %s is set to %s, but must be either ALL or ANY.\n",NAME_CURRENT_COMP,mask_setting);
            exit(1);
        }
    }
    
    for (loop_index=0;loop_index<global_geometry_list.num_elements;loop_index++) {
        // Add mask list
        if (1 == manual_linking_function(global_geometry_list.elements[loop_index].name,mask_string)) {
            add_element_to_int_list(&this_box_volume.geometry.mask_list,global_geometry_list.elements[loop_index].component_index);
            add_element_to_int_list(&global_geometry_list.elements[loop_index].Volume->geometry.masked_by_list,INDEX_CURRENT_COMP);
            global_geometry_list.elements[loop_index].Volume->geometry.is_masked_volume = 1;
            if (this_box_volume.geometry.mask_mode == 2)
                global_geometry_list.elements[loop_index].Volume->geometry.mask_mode = 2;
            if (this_box_volume.geometry.mask_mode == 1) {
                if (global_geometry_list.elements[loop_index].Volume->geometry.is_masked_volume == 1 && global_geometry_list.elements[loop_index].Volume->geometry.mask_mode != 2)
                    // If more than one mask is added to one volume, the ANY mode overwrites the (default) ALL mode.
                    global_geometry_list.elements[loop_index].Volume->geometry.mask_mode = 1;
            }
            
            found_geometries = 1;
        }
    }
    if (found_geometries == 0) {
        printf("The mask_string in geometry: %s did not find any of the specified volumes in the mask_string %s \n",NAME_CURRENT_COMP,mask_string);
        exit(1);
    }
    this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
    this_box_volume.p_physics->is_vacuum = 0; // Makes this volume a vacuum
    this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
    this_box_volume.p_physics->my_a = 0; // Should not be used.
    sprintf(this_box_volume.p_physics->name,"Mask");
    this_box_volume.geometry.is_mask_volume = 1;
    
    
// Read the material input, or if it lacks, use automatic linking.
} else if (material_string && strlen(material_string) && strcmp(material_string, "NULL") && strcmp(material_string, "0")) {
    // A geometry string was given, use it to determine which material
    if (0 == strcmp(material_string,"vacuum") || 0 == strcmp(material_string,"Vacuum")) {
        // One could have a global physics struct for vacuum instead of creating one for each
        this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
        this_box_volume.p_physics->is_vacuum = 1; // Makes this volume a vacuum
        this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
        this_box_volume.p_physics->my_a = 0; // Should not be used.
        sprintf(this_box_volume.p_physics->name,"Vacuum");
    } else if (0 == strcmp(material_string,"exit") || 0 == strcmp(material_string,"Exit")) {
        // One could have a global physics struct for vacuum instead of creating one for each
        this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
        this_box_volume.p_physics->is_vacuum = 1; // Makes this volume a vacuum
        this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
        this_box_volume.p_physics->my_a = 0; // Should not be used.
        this_box_volume.geometry.is_exit_volume = 1;
        sprintf(this_box_volume.p_physics->name,"Exit");
    } else {
        #ifndef MATERIAL_DETECTOR
            printf("Need to define a material before refering to it in a geometry %s.\n",NAME_CURRENT_COMP);
            exit(1);
        #endif
        for (loop_index=0;loop_index<global_material_list.num_elements;loop_index++) {
            if (0 == strcmp(material_string,global_material_list.elements[loop_index].name)) {
                this_box_volume.p_physics = global_material_list.elements[loop_index].physics;
                break;
            }
            if (loop_index == global_material_list.num_elements-1) {
            printf("\n");
            printf("ERROR: The material string \"%s\" in Union geometry \"%s\" did not match a specified material. \n",material_string,NAME_CURRENT_COMP);
            printf("       The materials available at this point (need to be defined before the geometry): \n");
            for (loop_index=0;loop_index<global_material_list.num_elements;loop_index++)
              printf("         %s\n",global_material_list.elements[loop_index].name);
            printf("\n");
            printf("       It is also possible to use one of the defualt materials avaiable: \n");
            printf("           Vacuum (for a Volume without scattering or absorption)\n");
            printf("           Exit (for a Volume where the ray exits the component if it enters)\n");
            printf("           Mask (for a Volume that masks existing volumes specified in the mask_string\n");
            exit(1);
          }
        }
    }
} else {
    // Automatic linking, simply using the last defined material.
    #ifndef MATERIAL_DETECTOR
        printf("Need to define a material before the geometry to use automatic linking %s.\n",NAME_CURRENT_COMP);
        exit(1);
    #endif
    this_box_volume.p_physics = global_material_list.elements[global_material_list.num_elements-1].physics;
}

sprintf(this_box_volume.name,NAME_CURRENT_COMP);
sprintf(this_box_volume.geometry.shape,"box");
this_box_volume.geometry.priority_value = priority;
this_box_volume.geometry.geometry_p_interact = p_interact;
// Currently the coordinates will be in absolute space.
this_box_volume.geometry.center = POS_A_CURRENT_COMP;

this_box_storage.z_depth = zdepth;
this_box_storage.x_width1 = xwidth;
this_box_storage.y_height1 = yheight;

this_box_storage.is_rectangle = 0;
if (xwidth2 < 0 && yheight2 < 0) this_box_storage.is_rectangle = 1;
if (xwidth == xwidth2 && yheight == yheight2) this_box_storage.is_rectangle = 1;

if (xwidth2 < 0) {
    this_box_storage.x_width2 = xwidth;
    xwidth2 = xwidth;
} else this_box_storage.x_width2 = xwidth2;

if (yheight2 < 0) {
    this_box_storage.y_height2 = yheight;
    yheight2 = yheight;
} else this_box_storage.y_height2 = yheight2;


this_box_storage.normal_vectors[0] = coords_set(0,0,1);
this_box_storage.normal_vectors[1] = coords_set(0,0,1);

// for sides with y component = 0
x_component = 2*zdepth/sqrt((xwidth-xwidth2)*(xwidth-xwidth2)+4*zdepth*zdepth);
z_component = (xwidth-xwidth2)/sqrt(4*zdepth*zdepth+(xwidth-xwidth2)*(xwidth-xwidth2));

this_box_storage.normal_vectors[2] = coords_set(x_component,0,z_component);
this_box_storage.normal_vectors[3] = coords_set(-x_component,0,z_component);

// for sides with x component = 0
y_component = 2*zdepth/sqrt((yheight-yheight2)*(yheight-yheight2)+4*zdepth*zdepth);
z_component = (yheight-yheight2)/sqrt(4*zdepth*zdepth+(yheight-yheight2)*(yheight-yheight2));

this_box_storage.normal_vectors[4] = coords_set(0,y_component,z_component);
this_box_storage.normal_vectors[5] = coords_set(0,-y_component,z_component);

this_box_volume.geometry.visualization_on = visualize;

this_box_volume.geometry.geometry_parameters.p_box_storage = &this_box_storage;

// Assign pointers to functions for intersection with the shape, checking if a point is inside the shape
if (this_box_storage.is_rectangle == 1) {
this_box_volume.geometry.intersect_function = &sample_box_intersect_simple;
this_box_volume.geometry.within_function = &r_within_box_simple;
}
else {
this_box_volume.geometry.intersect_function = &sample_box_intersect_advanced;
this_box_volume.geometry.within_function = &r_within_box_advanced;
}

this_box_volume.geometry.shell_points = &box_shell_points;
this_box_volume.geometry.mcdisplay_function = &mcdisplay_box_function;
this_box_volume.geometry.initialize_from_main_function = &initialize_box_geometry_from_main_component;
this_box_volume.geometry.process_rot_allocated = 0;

this_box_volume.geometry.copy_geometry_parameters = &allocate_box_storage_copy;

rot_copy(this_box_volume.geometry.rotation_matrix,ROT_A_CURRENT_COMP); //check how ROT_R_CURRENT_COMP would work
rot_transpose(ROT_A_CURRENT_COMP,this_box_volume.geometry.transpose_rotation_matrix);

// Initialize loggers
this_box_volume.loggers.num_elements = 0;

// packing the information into the global_geometry_element, which is then included in the global_geometry_list.
sprintf(global_geometry_element.name,NAME_CURRENT_COMP);
global_geometry_element.activation_counter = number_of_activations;
global_geometry_element.component_index = INDEX_CURRENT_COMP;
global_geometry_element.Volume = &this_box_volume; // Would be nicer if this m was a pointer, now we have the (small) data two places
add_element_to_geometry_list(&global_geometry_list,global_geometry_element);
}
#line 326807 "MACS_sample_kidney_box.c"
#undef number_of_activations
#undef mask_setting
#undef mask_string
#undef p_interact
#undef focus_r
#undef focus_xh
#undef focus_xw
#undef focus_ah
#undef focus_aw
#undef target_z
#undef target_y
#undef target_x
#undef target_index
#undef visualize
#undef yheight2
#undef xwidth2
#undef zdepth
#undef yheight
#undef xwidth
#undef priority
#undef material_string
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

  /* Initializations for component channel_18_analyzer_2_array_crystal_array_1. */
  SIG_MESSAGE("channel_18_analyzer_2_array_crystal_array_1 (Init)");
#define mccompcurname  channel_18_analyzer_2_array_crystal_array_1
#define mccompcurtype  Union_box
#define mccompcurindex 826
#define loop_index mccchannel_18_analyzer_2_array_crystal_array_1_loop_index
#define this_box_volume mccchannel_18_analyzer_2_array_crystal_array_1_this_box_volume
#define global_geometry_element mccchannel_18_analyzer_2_array_crystal_array_1_global_geometry_element
#define this_box_storage mccchannel_18_analyzer_2_array_crystal_array_1_this_box_storage
#define material_string mccchannel_18_analyzer_2_array_crystal_array_1_material_string
#define priority mccchannel_18_analyzer_2_array_crystal_array_1_priority
#define xwidth mccchannel_18_analyzer_2_array_crystal_array_1_xwidth
#define yheight mccchannel_18_analyzer_2_array_crystal_array_1_yheight
#define zdepth mccchannel_18_analyzer_2_array_crystal_array_1_zdepth
#define xwidth2 mccchannel_18_analyzer_2_array_crystal_array_1_xwidth2
#define yheight2 mccchannel_18_analyzer_2_array_crystal_array_1_yheight2
#define visualize mccchannel_18_analyzer_2_array_crystal_array_1_visualize
#define target_index mccchannel_18_analyzer_2_array_crystal_array_1_target_index
#define target_x mccchannel_18_analyzer_2_array_crystal_array_1_target_x
#define target_y mccchannel_18_analyzer_2_array_crystal_array_1_target_y
#define target_z mccchannel_18_analyzer_2_array_crystal_array_1_target_z
#define focus_aw mccchannel_18_analyzer_2_array_crystal_array_1_focus_aw
#define focus_ah mccchannel_18_analyzer_2_array_crystal_array_1_focus_ah
#define focus_xw mccchannel_18_analyzer_2_array_crystal_array_1_focus_xw
#define focus_xh mccchannel_18_analyzer_2_array_crystal_array_1_focus_xh
#define focus_r mccchannel_18_analyzer_2_array_crystal_array_1_focus_r
#define p_interact mccchannel_18_analyzer_2_array_crystal_array_1_p_interact
#define mask_string mccchannel_18_analyzer_2_array_crystal_array_1_mask_string
#define mask_setting mccchannel_18_analyzer_2_array_crystal_array_1_mask_setting
#define number_of_activations mccchannel_18_analyzer_2_array_crystal_array_1_number_of_activations
#line 224 "Union_box.comp"
{
// Initializes the focusing system for this volume including input sanitation.
focus_initialize(&this_box_volume.geometry, POS_A_COMP_INDEX(INDEX_CURRENT_COMP+target_index), POS_A_CURRENT_COMP, ROT_A_CURRENT_COMP, target_index, target_x, target_y, target_z, focus_aw, focus_ah, focus_xw, focus_xh, focus_r, NAME_CURRENT_COMP);

// Input sanitation for this geometry
if (xwidth <= 0) {
  printf("\nERROR in Union_box named %s, the xwidth is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (yheight <= 0) {
  printf("\nERROR in Union_box named %s, yheight is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (zdepth <= 0) {
  printf("\nERROR in Union_box named %s, zdepth is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (xwidth2 <= 0 && xwidth2 != -1) {
  printf("\nERROR in Union_box named %s, the xwidth2 is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (yheight2 <= 0 && yheight2 != -1) {
  printf("\nERROR in Union_box named %s, yheight2 is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}

// Use sanitation
if (global_material_list.num_elements == 0) {
  printf("\nERROR: Need to define a material using Union_make_material before using a Union geometry component. \n");
  printf("       %s was defined before first use of Union_make_material.\n",NAME_CURRENT_COMP);
  exit(1);
}

this_box_volume.geometry.is_masked_volume = 0;
this_box_volume.geometry.is_exit_volume = 0;
this_box_volume.geometry.is_mask_volume = 0;
// check if the volume is a mask, if it is the material string is irelevant.
if (mask_string && strlen(mask_string) && strcmp(mask_string, "NULL") && strcmp(mask_string, "0")) {
    // A mask volume is used to limit the extend of other volumes, called the masked volumes. These are specified in the mask_string.
    // In order for a ray to enter a masked volume, it needs to be both in the region covered by that volume AND the mask volume.
    // When more than
    this_box_volume.geometry.mask_mode = 1; // Default is mask mode is ALL
    if (mask_setting && strlen(mask_setting) && strcmp(mask_setting, "NULL") && strcmp(mask_setting, "0")) {
        if (strcmp(mask_setting,"ALL") == 0 || strcmp(mask_setting,"All") == 0) this_box_volume.geometry.mask_mode = 1;
        else if (strcmp(mask_setting,"ANY") == 0 || strcmp(mask_setting,"Any") == 0) this_box_volume.geometry.mask_mode = 2;
        else {
            printf("The mask_mode of component %s is set to %s, but must be either ALL or ANY.\n",NAME_CURRENT_COMP,mask_setting);
            exit(1);
        }
    }
    
    for (loop_index=0;loop_index<global_geometry_list.num_elements;loop_index++) {
        // Add mask list
        if (1 == manual_linking_function(global_geometry_list.elements[loop_index].name,mask_string)) {
            add_element_to_int_list(&this_box_volume.geometry.mask_list,global_geometry_list.elements[loop_index].component_index);
            add_element_to_int_list(&global_geometry_list.elements[loop_index].Volume->geometry.masked_by_list,INDEX_CURRENT_COMP);
            global_geometry_list.elements[loop_index].Volume->geometry.is_masked_volume = 1;
            if (this_box_volume.geometry.mask_mode == 2)
                global_geometry_list.elements[loop_index].Volume->geometry.mask_mode = 2;
            if (this_box_volume.geometry.mask_mode == 1) {
                if (global_geometry_list.elements[loop_index].Volume->geometry.is_masked_volume == 1 && global_geometry_list.elements[loop_index].Volume->geometry.mask_mode != 2)
                    // If more than one mask is added to one volume, the ANY mode overwrites the (default) ALL mode.
                    global_geometry_list.elements[loop_index].Volume->geometry.mask_mode = 1;
            }
            
            found_geometries = 1;
        }
    }
    if (found_geometries == 0) {
        printf("The mask_string in geometry: %s did not find any of the specified volumes in the mask_string %s \n",NAME_CURRENT_COMP,mask_string);
        exit(1);
    }
    this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
    this_box_volume.p_physics->is_vacuum = 0; // Makes this volume a vacuum
    this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
    this_box_volume.p_physics->my_a = 0; // Should not be used.
    sprintf(this_box_volume.p_physics->name,"Mask");
    this_box_volume.geometry.is_mask_volume = 1;
    
    
// Read the material input, or if it lacks, use automatic linking.
} else if (material_string && strlen(material_string) && strcmp(material_string, "NULL") && strcmp(material_string, "0")) {
    // A geometry string was given, use it to determine which material
    if (0 == strcmp(material_string,"vacuum") || 0 == strcmp(material_string,"Vacuum")) {
        // One could have a global physics struct for vacuum instead of creating one for each
        this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
        this_box_volume.p_physics->is_vacuum = 1; // Makes this volume a vacuum
        this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
        this_box_volume.p_physics->my_a = 0; // Should not be used.
        sprintf(this_box_volume.p_physics->name,"Vacuum");
    } else if (0 == strcmp(material_string,"exit") || 0 == strcmp(material_string,"Exit")) {
        // One could have a global physics struct for vacuum instead of creating one for each
        this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
        this_box_volume.p_physics->is_vacuum = 1; // Makes this volume a vacuum
        this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
        this_box_volume.p_physics->my_a = 0; // Should not be used.
        this_box_volume.geometry.is_exit_volume = 1;
        sprintf(this_box_volume.p_physics->name,"Exit");
    } else {
        #ifndef MATERIAL_DETECTOR
            printf("Need to define a material before refering to it in a geometry %s.\n",NAME_CURRENT_COMP);
            exit(1);
        #endif
        for (loop_index=0;loop_index<global_material_list.num_elements;loop_index++) {
            if (0 == strcmp(material_string,global_material_list.elements[loop_index].name)) {
                this_box_volume.p_physics = global_material_list.elements[loop_index].physics;
                break;
            }
            if (loop_index == global_material_list.num_elements-1) {
            printf("\n");
            printf("ERROR: The material string \"%s\" in Union geometry \"%s\" did not match a specified material. \n",material_string,NAME_CURRENT_COMP);
            printf("       The materials available at this point (need to be defined before the geometry): \n");
            for (loop_index=0;loop_index<global_material_list.num_elements;loop_index++)
              printf("         %s\n",global_material_list.elements[loop_index].name);
            printf("\n");
            printf("       It is also possible to use one of the defualt materials avaiable: \n");
            printf("           Vacuum (for a Volume without scattering or absorption)\n");
            printf("           Exit (for a Volume where the ray exits the component if it enters)\n");
            printf("           Mask (for a Volume that masks existing volumes specified in the mask_string\n");
            exit(1);
          }
        }
    }
} else {
    // Automatic linking, simply using the last defined material.
    #ifndef MATERIAL_DETECTOR
        printf("Need to define a material before the geometry to use automatic linking %s.\n",NAME_CURRENT_COMP);
        exit(1);
    #endif
    this_box_volume.p_physics = global_material_list.elements[global_material_list.num_elements-1].physics;
}

sprintf(this_box_volume.name,NAME_CURRENT_COMP);
sprintf(this_box_volume.geometry.shape,"box");
this_box_volume.geometry.priority_value = priority;
this_box_volume.geometry.geometry_p_interact = p_interact;
// Currently the coordinates will be in absolute space.
this_box_volume.geometry.center = POS_A_CURRENT_COMP;

this_box_storage.z_depth = zdepth;
this_box_storage.x_width1 = xwidth;
this_box_storage.y_height1 = yheight;

this_box_storage.is_rectangle = 0;
if (xwidth2 < 0 && yheight2 < 0) this_box_storage.is_rectangle = 1;
if (xwidth == xwidth2 && yheight == yheight2) this_box_storage.is_rectangle = 1;

if (xwidth2 < 0) {
    this_box_storage.x_width2 = xwidth;
    xwidth2 = xwidth;
} else this_box_storage.x_width2 = xwidth2;

if (yheight2 < 0) {
    this_box_storage.y_height2 = yheight;
    yheight2 = yheight;
} else this_box_storage.y_height2 = yheight2;


this_box_storage.normal_vectors[0] = coords_set(0,0,1);
this_box_storage.normal_vectors[1] = coords_set(0,0,1);

// for sides with y component = 0
x_component = 2*zdepth/sqrt((xwidth-xwidth2)*(xwidth-xwidth2)+4*zdepth*zdepth);
z_component = (xwidth-xwidth2)/sqrt(4*zdepth*zdepth+(xwidth-xwidth2)*(xwidth-xwidth2));

this_box_storage.normal_vectors[2] = coords_set(x_component,0,z_component);
this_box_storage.normal_vectors[3] = coords_set(-x_component,0,z_component);

// for sides with x component = 0
y_component = 2*zdepth/sqrt((yheight-yheight2)*(yheight-yheight2)+4*zdepth*zdepth);
z_component = (yheight-yheight2)/sqrt(4*zdepth*zdepth+(yheight-yheight2)*(yheight-yheight2));

this_box_storage.normal_vectors[4] = coords_set(0,y_component,z_component);
this_box_storage.normal_vectors[5] = coords_set(0,-y_component,z_component);

this_box_volume.geometry.visualization_on = visualize;

this_box_volume.geometry.geometry_parameters.p_box_storage = &this_box_storage;

// Assign pointers to functions for intersection with the shape, checking if a point is inside the shape
if (this_box_storage.is_rectangle == 1) {
this_box_volume.geometry.intersect_function = &sample_box_intersect_simple;
this_box_volume.geometry.within_function = &r_within_box_simple;
}
else {
this_box_volume.geometry.intersect_function = &sample_box_intersect_advanced;
this_box_volume.geometry.within_function = &r_within_box_advanced;
}

this_box_volume.geometry.shell_points = &box_shell_points;
this_box_volume.geometry.mcdisplay_function = &mcdisplay_box_function;
this_box_volume.geometry.initialize_from_main_function = &initialize_box_geometry_from_main_component;
this_box_volume.geometry.process_rot_allocated = 0;

this_box_volume.geometry.copy_geometry_parameters = &allocate_box_storage_copy;

rot_copy(this_box_volume.geometry.rotation_matrix,ROT_A_CURRENT_COMP); //check how ROT_R_CURRENT_COMP would work
rot_transpose(ROT_A_CURRENT_COMP,this_box_volume.geometry.transpose_rotation_matrix);

// Initialize loggers
this_box_volume.loggers.num_elements = 0;

// packing the information into the global_geometry_element, which is then included in the global_geometry_list.
sprintf(global_geometry_element.name,NAME_CURRENT_COMP);
global_geometry_element.activation_counter = number_of_activations;
global_geometry_element.component_index = INDEX_CURRENT_COMP;
global_geometry_element.Volume = &this_box_volume; // Would be nicer if this m was a pointer, now we have the (small) data two places
add_element_to_geometry_list(&global_geometry_list,global_geometry_element);
}
#line 327077 "MACS_sample_kidney_box.c"
#undef number_of_activations
#undef mask_setting
#undef mask_string
#undef p_interact
#undef focus_r
#undef focus_xh
#undef focus_xw
#undef focus_ah
#undef focus_aw
#undef target_z
#undef target_y
#undef target_x
#undef target_index
#undef visualize
#undef yheight2
#undef xwidth2
#undef zdepth
#undef yheight
#undef xwidth
#undef priority
#undef material_string
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

  /* Initializations for component channel_18_analyzer_2_array_crystal_array_2. */
  SIG_MESSAGE("channel_18_analyzer_2_array_crystal_array_2 (Init)");
#define mccompcurname  channel_18_analyzer_2_array_crystal_array_2
#define mccompcurtype  Union_box
#define mccompcurindex 827
#define loop_index mccchannel_18_analyzer_2_array_crystal_array_2_loop_index
#define this_box_volume mccchannel_18_analyzer_2_array_crystal_array_2_this_box_volume
#define global_geometry_element mccchannel_18_analyzer_2_array_crystal_array_2_global_geometry_element
#define this_box_storage mccchannel_18_analyzer_2_array_crystal_array_2_this_box_storage
#define material_string mccchannel_18_analyzer_2_array_crystal_array_2_material_string
#define priority mccchannel_18_analyzer_2_array_crystal_array_2_priority
#define xwidth mccchannel_18_analyzer_2_array_crystal_array_2_xwidth
#define yheight mccchannel_18_analyzer_2_array_crystal_array_2_yheight
#define zdepth mccchannel_18_analyzer_2_array_crystal_array_2_zdepth
#define xwidth2 mccchannel_18_analyzer_2_array_crystal_array_2_xwidth2
#define yheight2 mccchannel_18_analyzer_2_array_crystal_array_2_yheight2
#define visualize mccchannel_18_analyzer_2_array_crystal_array_2_visualize
#define target_index mccchannel_18_analyzer_2_array_crystal_array_2_target_index
#define target_x mccchannel_18_analyzer_2_array_crystal_array_2_target_x
#define target_y mccchannel_18_analyzer_2_array_crystal_array_2_target_y
#define target_z mccchannel_18_analyzer_2_array_crystal_array_2_target_z
#define focus_aw mccchannel_18_analyzer_2_array_crystal_array_2_focus_aw
#define focus_ah mccchannel_18_analyzer_2_array_crystal_array_2_focus_ah
#define focus_xw mccchannel_18_analyzer_2_array_crystal_array_2_focus_xw
#define focus_xh mccchannel_18_analyzer_2_array_crystal_array_2_focus_xh
#define focus_r mccchannel_18_analyzer_2_array_crystal_array_2_focus_r
#define p_interact mccchannel_18_analyzer_2_array_crystal_array_2_p_interact
#define mask_string mccchannel_18_analyzer_2_array_crystal_array_2_mask_string
#define mask_setting mccchannel_18_analyzer_2_array_crystal_array_2_mask_setting
#define number_of_activations mccchannel_18_analyzer_2_array_crystal_array_2_number_of_activations
#line 224 "Union_box.comp"
{
// Initializes the focusing system for this volume including input sanitation.
focus_initialize(&this_box_volume.geometry, POS_A_COMP_INDEX(INDEX_CURRENT_COMP+target_index), POS_A_CURRENT_COMP, ROT_A_CURRENT_COMP, target_index, target_x, target_y, target_z, focus_aw, focus_ah, focus_xw, focus_xh, focus_r, NAME_CURRENT_COMP);

// Input sanitation for this geometry
if (xwidth <= 0) {
  printf("\nERROR in Union_box named %s, the xwidth is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (yheight <= 0) {
  printf("\nERROR in Union_box named %s, yheight is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (zdepth <= 0) {
  printf("\nERROR in Union_box named %s, zdepth is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (xwidth2 <= 0 && xwidth2 != -1) {
  printf("\nERROR in Union_box named %s, the xwidth2 is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (yheight2 <= 0 && yheight2 != -1) {
  printf("\nERROR in Union_box named %s, yheight2 is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}

// Use sanitation
if (global_material_list.num_elements == 0) {
  printf("\nERROR: Need to define a material using Union_make_material before using a Union geometry component. \n");
  printf("       %s was defined before first use of Union_make_material.\n",NAME_CURRENT_COMP);
  exit(1);
}

this_box_volume.geometry.is_masked_volume = 0;
this_box_volume.geometry.is_exit_volume = 0;
this_box_volume.geometry.is_mask_volume = 0;
// check if the volume is a mask, if it is the material string is irelevant.
if (mask_string && strlen(mask_string) && strcmp(mask_string, "NULL") && strcmp(mask_string, "0")) {
    // A mask volume is used to limit the extend of other volumes, called the masked volumes. These are specified in the mask_string.
    // In order for a ray to enter a masked volume, it needs to be both in the region covered by that volume AND the mask volume.
    // When more than
    this_box_volume.geometry.mask_mode = 1; // Default is mask mode is ALL
    if (mask_setting && strlen(mask_setting) && strcmp(mask_setting, "NULL") && strcmp(mask_setting, "0")) {
        if (strcmp(mask_setting,"ALL") == 0 || strcmp(mask_setting,"All") == 0) this_box_volume.geometry.mask_mode = 1;
        else if (strcmp(mask_setting,"ANY") == 0 || strcmp(mask_setting,"Any") == 0) this_box_volume.geometry.mask_mode = 2;
        else {
            printf("The mask_mode of component %s is set to %s, but must be either ALL or ANY.\n",NAME_CURRENT_COMP,mask_setting);
            exit(1);
        }
    }
    
    for (loop_index=0;loop_index<global_geometry_list.num_elements;loop_index++) {
        // Add mask list
        if (1 == manual_linking_function(global_geometry_list.elements[loop_index].name,mask_string)) {
            add_element_to_int_list(&this_box_volume.geometry.mask_list,global_geometry_list.elements[loop_index].component_index);
            add_element_to_int_list(&global_geometry_list.elements[loop_index].Volume->geometry.masked_by_list,INDEX_CURRENT_COMP);
            global_geometry_list.elements[loop_index].Volume->geometry.is_masked_volume = 1;
            if (this_box_volume.geometry.mask_mode == 2)
                global_geometry_list.elements[loop_index].Volume->geometry.mask_mode = 2;
            if (this_box_volume.geometry.mask_mode == 1) {
                if (global_geometry_list.elements[loop_index].Volume->geometry.is_masked_volume == 1 && global_geometry_list.elements[loop_index].Volume->geometry.mask_mode != 2)
                    // If more than one mask is added to one volume, the ANY mode overwrites the (default) ALL mode.
                    global_geometry_list.elements[loop_index].Volume->geometry.mask_mode = 1;
            }
            
            found_geometries = 1;
        }
    }
    if (found_geometries == 0) {
        printf("The mask_string in geometry: %s did not find any of the specified volumes in the mask_string %s \n",NAME_CURRENT_COMP,mask_string);
        exit(1);
    }
    this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
    this_box_volume.p_physics->is_vacuum = 0; // Makes this volume a vacuum
    this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
    this_box_volume.p_physics->my_a = 0; // Should not be used.
    sprintf(this_box_volume.p_physics->name,"Mask");
    this_box_volume.geometry.is_mask_volume = 1;
    
    
// Read the material input, or if it lacks, use automatic linking.
} else if (material_string && strlen(material_string) && strcmp(material_string, "NULL") && strcmp(material_string, "0")) {
    // A geometry string was given, use it to determine which material
    if (0 == strcmp(material_string,"vacuum") || 0 == strcmp(material_string,"Vacuum")) {
        // One could have a global physics struct for vacuum instead of creating one for each
        this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
        this_box_volume.p_physics->is_vacuum = 1; // Makes this volume a vacuum
        this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
        this_box_volume.p_physics->my_a = 0; // Should not be used.
        sprintf(this_box_volume.p_physics->name,"Vacuum");
    } else if (0 == strcmp(material_string,"exit") || 0 == strcmp(material_string,"Exit")) {
        // One could have a global physics struct for vacuum instead of creating one for each
        this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
        this_box_volume.p_physics->is_vacuum = 1; // Makes this volume a vacuum
        this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
        this_box_volume.p_physics->my_a = 0; // Should not be used.
        this_box_volume.geometry.is_exit_volume = 1;
        sprintf(this_box_volume.p_physics->name,"Exit");
    } else {
        #ifndef MATERIAL_DETECTOR
            printf("Need to define a material before refering to it in a geometry %s.\n",NAME_CURRENT_COMP);
            exit(1);
        #endif
        for (loop_index=0;loop_index<global_material_list.num_elements;loop_index++) {
            if (0 == strcmp(material_string,global_material_list.elements[loop_index].name)) {
                this_box_volume.p_physics = global_material_list.elements[loop_index].physics;
                break;
            }
            if (loop_index == global_material_list.num_elements-1) {
            printf("\n");
            printf("ERROR: The material string \"%s\" in Union geometry \"%s\" did not match a specified material. \n",material_string,NAME_CURRENT_COMP);
            printf("       The materials available at this point (need to be defined before the geometry): \n");
            for (loop_index=0;loop_index<global_material_list.num_elements;loop_index++)
              printf("         %s\n",global_material_list.elements[loop_index].name);
            printf("\n");
            printf("       It is also possible to use one of the defualt materials avaiable: \n");
            printf("           Vacuum (for a Volume without scattering or absorption)\n");
            printf("           Exit (for a Volume where the ray exits the component if it enters)\n");
            printf("           Mask (for a Volume that masks existing volumes specified in the mask_string\n");
            exit(1);
          }
        }
    }
} else {
    // Automatic linking, simply using the last defined material.
    #ifndef MATERIAL_DETECTOR
        printf("Need to define a material before the geometry to use automatic linking %s.\n",NAME_CURRENT_COMP);
        exit(1);
    #endif
    this_box_volume.p_physics = global_material_list.elements[global_material_list.num_elements-1].physics;
}

sprintf(this_box_volume.name,NAME_CURRENT_COMP);
sprintf(this_box_volume.geometry.shape,"box");
this_box_volume.geometry.priority_value = priority;
this_box_volume.geometry.geometry_p_interact = p_interact;
// Currently the coordinates will be in absolute space.
this_box_volume.geometry.center = POS_A_CURRENT_COMP;

this_box_storage.z_depth = zdepth;
this_box_storage.x_width1 = xwidth;
this_box_storage.y_height1 = yheight;

this_box_storage.is_rectangle = 0;
if (xwidth2 < 0 && yheight2 < 0) this_box_storage.is_rectangle = 1;
if (xwidth == xwidth2 && yheight == yheight2) this_box_storage.is_rectangle = 1;

if (xwidth2 < 0) {
    this_box_storage.x_width2 = xwidth;
    xwidth2 = xwidth;
} else this_box_storage.x_width2 = xwidth2;

if (yheight2 < 0) {
    this_box_storage.y_height2 = yheight;
    yheight2 = yheight;
} else this_box_storage.y_height2 = yheight2;


this_box_storage.normal_vectors[0] = coords_set(0,0,1);
this_box_storage.normal_vectors[1] = coords_set(0,0,1);

// for sides with y component = 0
x_component = 2*zdepth/sqrt((xwidth-xwidth2)*(xwidth-xwidth2)+4*zdepth*zdepth);
z_component = (xwidth-xwidth2)/sqrt(4*zdepth*zdepth+(xwidth-xwidth2)*(xwidth-xwidth2));

this_box_storage.normal_vectors[2] = coords_set(x_component,0,z_component);
this_box_storage.normal_vectors[3] = coords_set(-x_component,0,z_component);

// for sides with x component = 0
y_component = 2*zdepth/sqrt((yheight-yheight2)*(yheight-yheight2)+4*zdepth*zdepth);
z_component = (yheight-yheight2)/sqrt(4*zdepth*zdepth+(yheight-yheight2)*(yheight-yheight2));

this_box_storage.normal_vectors[4] = coords_set(0,y_component,z_component);
this_box_storage.normal_vectors[5] = coords_set(0,-y_component,z_component);

this_box_volume.geometry.visualization_on = visualize;

this_box_volume.geometry.geometry_parameters.p_box_storage = &this_box_storage;

// Assign pointers to functions for intersection with the shape, checking if a point is inside the shape
if (this_box_storage.is_rectangle == 1) {
this_box_volume.geometry.intersect_function = &sample_box_intersect_simple;
this_box_volume.geometry.within_function = &r_within_box_simple;
}
else {
this_box_volume.geometry.intersect_function = &sample_box_intersect_advanced;
this_box_volume.geometry.within_function = &r_within_box_advanced;
}

this_box_volume.geometry.shell_points = &box_shell_points;
this_box_volume.geometry.mcdisplay_function = &mcdisplay_box_function;
this_box_volume.geometry.initialize_from_main_function = &initialize_box_geometry_from_main_component;
this_box_volume.geometry.process_rot_allocated = 0;

this_box_volume.geometry.copy_geometry_parameters = &allocate_box_storage_copy;

rot_copy(this_box_volume.geometry.rotation_matrix,ROT_A_CURRENT_COMP); //check how ROT_R_CURRENT_COMP would work
rot_transpose(ROT_A_CURRENT_COMP,this_box_volume.geometry.transpose_rotation_matrix);

// Initialize loggers
this_box_volume.loggers.num_elements = 0;

// packing the information into the global_geometry_element, which is then included in the global_geometry_list.
sprintf(global_geometry_element.name,NAME_CURRENT_COMP);
global_geometry_element.activation_counter = number_of_activations;
global_geometry_element.component_index = INDEX_CURRENT_COMP;
global_geometry_element.Volume = &this_box_volume; // Would be nicer if this m was a pointer, now we have the (small) data two places
add_element_to_geometry_list(&global_geometry_list,global_geometry_element);
}
#line 327347 "MACS_sample_kidney_box.c"
#undef number_of_activations
#undef mask_setting
#undef mask_string
#undef p_interact
#undef focus_r
#undef focus_xh
#undef focus_xw
#undef focus_ah
#undef focus_aw
#undef target_z
#undef target_y
#undef target_x
#undef target_index
#undef visualize
#undef yheight2
#undef xwidth2
#undef zdepth
#undef yheight
#undef xwidth
#undef priority
#undef material_string
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

  /* Initializations for component channel_18_analyzer_2_array_crystal_array_3. */
  SIG_MESSAGE("channel_18_analyzer_2_array_crystal_array_3 (Init)");
#define mccompcurname  channel_18_analyzer_2_array_crystal_array_3
#define mccompcurtype  Union_box
#define mccompcurindex 828
#define loop_index mccchannel_18_analyzer_2_array_crystal_array_3_loop_index
#define this_box_volume mccchannel_18_analyzer_2_array_crystal_array_3_this_box_volume
#define global_geometry_element mccchannel_18_analyzer_2_array_crystal_array_3_global_geometry_element
#define this_box_storage mccchannel_18_analyzer_2_array_crystal_array_3_this_box_storage
#define material_string mccchannel_18_analyzer_2_array_crystal_array_3_material_string
#define priority mccchannel_18_analyzer_2_array_crystal_array_3_priority
#define xwidth mccchannel_18_analyzer_2_array_crystal_array_3_xwidth
#define yheight mccchannel_18_analyzer_2_array_crystal_array_3_yheight
#define zdepth mccchannel_18_analyzer_2_array_crystal_array_3_zdepth
#define xwidth2 mccchannel_18_analyzer_2_array_crystal_array_3_xwidth2
#define yheight2 mccchannel_18_analyzer_2_array_crystal_array_3_yheight2
#define visualize mccchannel_18_analyzer_2_array_crystal_array_3_visualize
#define target_index mccchannel_18_analyzer_2_array_crystal_array_3_target_index
#define target_x mccchannel_18_analyzer_2_array_crystal_array_3_target_x
#define target_y mccchannel_18_analyzer_2_array_crystal_array_3_target_y
#define target_z mccchannel_18_analyzer_2_array_crystal_array_3_target_z
#define focus_aw mccchannel_18_analyzer_2_array_crystal_array_3_focus_aw
#define focus_ah mccchannel_18_analyzer_2_array_crystal_array_3_focus_ah
#define focus_xw mccchannel_18_analyzer_2_array_crystal_array_3_focus_xw
#define focus_xh mccchannel_18_analyzer_2_array_crystal_array_3_focus_xh
#define focus_r mccchannel_18_analyzer_2_array_crystal_array_3_focus_r
#define p_interact mccchannel_18_analyzer_2_array_crystal_array_3_p_interact
#define mask_string mccchannel_18_analyzer_2_array_crystal_array_3_mask_string
#define mask_setting mccchannel_18_analyzer_2_array_crystal_array_3_mask_setting
#define number_of_activations mccchannel_18_analyzer_2_array_crystal_array_3_number_of_activations
#line 224 "Union_box.comp"
{
// Initializes the focusing system for this volume including input sanitation.
focus_initialize(&this_box_volume.geometry, POS_A_COMP_INDEX(INDEX_CURRENT_COMP+target_index), POS_A_CURRENT_COMP, ROT_A_CURRENT_COMP, target_index, target_x, target_y, target_z, focus_aw, focus_ah, focus_xw, focus_xh, focus_r, NAME_CURRENT_COMP);

// Input sanitation for this geometry
if (xwidth <= 0) {
  printf("\nERROR in Union_box named %s, the xwidth is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (yheight <= 0) {
  printf("\nERROR in Union_box named %s, yheight is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (zdepth <= 0) {
  printf("\nERROR in Union_box named %s, zdepth is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (xwidth2 <= 0 && xwidth2 != -1) {
  printf("\nERROR in Union_box named %s, the xwidth2 is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (yheight2 <= 0 && yheight2 != -1) {
  printf("\nERROR in Union_box named %s, yheight2 is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}

// Use sanitation
if (global_material_list.num_elements == 0) {
  printf("\nERROR: Need to define a material using Union_make_material before using a Union geometry component. \n");
  printf("       %s was defined before first use of Union_make_material.\n",NAME_CURRENT_COMP);
  exit(1);
}

this_box_volume.geometry.is_masked_volume = 0;
this_box_volume.geometry.is_exit_volume = 0;
this_box_volume.geometry.is_mask_volume = 0;
// check if the volume is a mask, if it is the material string is irelevant.
if (mask_string && strlen(mask_string) && strcmp(mask_string, "NULL") && strcmp(mask_string, "0")) {
    // A mask volume is used to limit the extend of other volumes, called the masked volumes. These are specified in the mask_string.
    // In order for a ray to enter a masked volume, it needs to be both in the region covered by that volume AND the mask volume.
    // When more than
    this_box_volume.geometry.mask_mode = 1; // Default is mask mode is ALL
    if (mask_setting && strlen(mask_setting) && strcmp(mask_setting, "NULL") && strcmp(mask_setting, "0")) {
        if (strcmp(mask_setting,"ALL") == 0 || strcmp(mask_setting,"All") == 0) this_box_volume.geometry.mask_mode = 1;
        else if (strcmp(mask_setting,"ANY") == 0 || strcmp(mask_setting,"Any") == 0) this_box_volume.geometry.mask_mode = 2;
        else {
            printf("The mask_mode of component %s is set to %s, but must be either ALL or ANY.\n",NAME_CURRENT_COMP,mask_setting);
            exit(1);
        }
    }
    
    for (loop_index=0;loop_index<global_geometry_list.num_elements;loop_index++) {
        // Add mask list
        if (1 == manual_linking_function(global_geometry_list.elements[loop_index].name,mask_string)) {
            add_element_to_int_list(&this_box_volume.geometry.mask_list,global_geometry_list.elements[loop_index].component_index);
            add_element_to_int_list(&global_geometry_list.elements[loop_index].Volume->geometry.masked_by_list,INDEX_CURRENT_COMP);
            global_geometry_list.elements[loop_index].Volume->geometry.is_masked_volume = 1;
            if (this_box_volume.geometry.mask_mode == 2)
                global_geometry_list.elements[loop_index].Volume->geometry.mask_mode = 2;
            if (this_box_volume.geometry.mask_mode == 1) {
                if (global_geometry_list.elements[loop_index].Volume->geometry.is_masked_volume == 1 && global_geometry_list.elements[loop_index].Volume->geometry.mask_mode != 2)
                    // If more than one mask is added to one volume, the ANY mode overwrites the (default) ALL mode.
                    global_geometry_list.elements[loop_index].Volume->geometry.mask_mode = 1;
            }
            
            found_geometries = 1;
        }
    }
    if (found_geometries == 0) {
        printf("The mask_string in geometry: %s did not find any of the specified volumes in the mask_string %s \n",NAME_CURRENT_COMP,mask_string);
        exit(1);
    }
    this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
    this_box_volume.p_physics->is_vacuum = 0; // Makes this volume a vacuum
    this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
    this_box_volume.p_physics->my_a = 0; // Should not be used.
    sprintf(this_box_volume.p_physics->name,"Mask");
    this_box_volume.geometry.is_mask_volume = 1;
    
    
// Read the material input, or if it lacks, use automatic linking.
} else if (material_string && strlen(material_string) && strcmp(material_string, "NULL") && strcmp(material_string, "0")) {
    // A geometry string was given, use it to determine which material
    if (0 == strcmp(material_string,"vacuum") || 0 == strcmp(material_string,"Vacuum")) {
        // One could have a global physics struct for vacuum instead of creating one for each
        this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
        this_box_volume.p_physics->is_vacuum = 1; // Makes this volume a vacuum
        this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
        this_box_volume.p_physics->my_a = 0; // Should not be used.
        sprintf(this_box_volume.p_physics->name,"Vacuum");
    } else if (0 == strcmp(material_string,"exit") || 0 == strcmp(material_string,"Exit")) {
        // One could have a global physics struct for vacuum instead of creating one for each
        this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
        this_box_volume.p_physics->is_vacuum = 1; // Makes this volume a vacuum
        this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
        this_box_volume.p_physics->my_a = 0; // Should not be used.
        this_box_volume.geometry.is_exit_volume = 1;
        sprintf(this_box_volume.p_physics->name,"Exit");
    } else {
        #ifndef MATERIAL_DETECTOR
            printf("Need to define a material before refering to it in a geometry %s.\n",NAME_CURRENT_COMP);
            exit(1);
        #endif
        for (loop_index=0;loop_index<global_material_list.num_elements;loop_index++) {
            if (0 == strcmp(material_string,global_material_list.elements[loop_index].name)) {
                this_box_volume.p_physics = global_material_list.elements[loop_index].physics;
                break;
            }
            if (loop_index == global_material_list.num_elements-1) {
            printf("\n");
            printf("ERROR: The material string \"%s\" in Union geometry \"%s\" did not match a specified material. \n",material_string,NAME_CURRENT_COMP);
            printf("       The materials available at this point (need to be defined before the geometry): \n");
            for (loop_index=0;loop_index<global_material_list.num_elements;loop_index++)
              printf("         %s\n",global_material_list.elements[loop_index].name);
            printf("\n");
            printf("       It is also possible to use one of the defualt materials avaiable: \n");
            printf("           Vacuum (for a Volume without scattering or absorption)\n");
            printf("           Exit (for a Volume where the ray exits the component if it enters)\n");
            printf("           Mask (for a Volume that masks existing volumes specified in the mask_string\n");
            exit(1);
          }
        }
    }
} else {
    // Automatic linking, simply using the last defined material.
    #ifndef MATERIAL_DETECTOR
        printf("Need to define a material before the geometry to use automatic linking %s.\n",NAME_CURRENT_COMP);
        exit(1);
    #endif
    this_box_volume.p_physics = global_material_list.elements[global_material_list.num_elements-1].physics;
}

sprintf(this_box_volume.name,NAME_CURRENT_COMP);
sprintf(this_box_volume.geometry.shape,"box");
this_box_volume.geometry.priority_value = priority;
this_box_volume.geometry.geometry_p_interact = p_interact;
// Currently the coordinates will be in absolute space.
this_box_volume.geometry.center = POS_A_CURRENT_COMP;

this_box_storage.z_depth = zdepth;
this_box_storage.x_width1 = xwidth;
this_box_storage.y_height1 = yheight;

this_box_storage.is_rectangle = 0;
if (xwidth2 < 0 && yheight2 < 0) this_box_storage.is_rectangle = 1;
if (xwidth == xwidth2 && yheight == yheight2) this_box_storage.is_rectangle = 1;

if (xwidth2 < 0) {
    this_box_storage.x_width2 = xwidth;
    xwidth2 = xwidth;
} else this_box_storage.x_width2 = xwidth2;

if (yheight2 < 0) {
    this_box_storage.y_height2 = yheight;
    yheight2 = yheight;
} else this_box_storage.y_height2 = yheight2;


this_box_storage.normal_vectors[0] = coords_set(0,0,1);
this_box_storage.normal_vectors[1] = coords_set(0,0,1);

// for sides with y component = 0
x_component = 2*zdepth/sqrt((xwidth-xwidth2)*(xwidth-xwidth2)+4*zdepth*zdepth);
z_component = (xwidth-xwidth2)/sqrt(4*zdepth*zdepth+(xwidth-xwidth2)*(xwidth-xwidth2));

this_box_storage.normal_vectors[2] = coords_set(x_component,0,z_component);
this_box_storage.normal_vectors[3] = coords_set(-x_component,0,z_component);

// for sides with x component = 0
y_component = 2*zdepth/sqrt((yheight-yheight2)*(yheight-yheight2)+4*zdepth*zdepth);
z_component = (yheight-yheight2)/sqrt(4*zdepth*zdepth+(yheight-yheight2)*(yheight-yheight2));

this_box_storage.normal_vectors[4] = coords_set(0,y_component,z_component);
this_box_storage.normal_vectors[5] = coords_set(0,-y_component,z_component);

this_box_volume.geometry.visualization_on = visualize;

this_box_volume.geometry.geometry_parameters.p_box_storage = &this_box_storage;

// Assign pointers to functions for intersection with the shape, checking if a point is inside the shape
if (this_box_storage.is_rectangle == 1) {
this_box_volume.geometry.intersect_function = &sample_box_intersect_simple;
this_box_volume.geometry.within_function = &r_within_box_simple;
}
else {
this_box_volume.geometry.intersect_function = &sample_box_intersect_advanced;
this_box_volume.geometry.within_function = &r_within_box_advanced;
}

this_box_volume.geometry.shell_points = &box_shell_points;
this_box_volume.geometry.mcdisplay_function = &mcdisplay_box_function;
this_box_volume.geometry.initialize_from_main_function = &initialize_box_geometry_from_main_component;
this_box_volume.geometry.process_rot_allocated = 0;

this_box_volume.geometry.copy_geometry_parameters = &allocate_box_storage_copy;

rot_copy(this_box_volume.geometry.rotation_matrix,ROT_A_CURRENT_COMP); //check how ROT_R_CURRENT_COMP would work
rot_transpose(ROT_A_CURRENT_COMP,this_box_volume.geometry.transpose_rotation_matrix);

// Initialize loggers
this_box_volume.loggers.num_elements = 0;

// packing the information into the global_geometry_element, which is then included in the global_geometry_list.
sprintf(global_geometry_element.name,NAME_CURRENT_COMP);
global_geometry_element.activation_counter = number_of_activations;
global_geometry_element.component_index = INDEX_CURRENT_COMP;
global_geometry_element.Volume = &this_box_volume; // Would be nicer if this m was a pointer, now we have the (small) data two places
add_element_to_geometry_list(&global_geometry_list,global_geometry_element);
}
#line 327617 "MACS_sample_kidney_box.c"
#undef number_of_activations
#undef mask_setting
#undef mask_string
#undef p_interact
#undef focus_r
#undef focus_xh
#undef focus_xw
#undef focus_ah
#undef focus_aw
#undef target_z
#undef target_y
#undef target_x
#undef target_index
#undef visualize
#undef yheight2
#undef xwidth2
#undef zdepth
#undef yheight
#undef xwidth
#undef priority
#undef material_string
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

  /* Initializations for component channel_18_analyzer_2_array_crystal_array_4. */
  SIG_MESSAGE("channel_18_analyzer_2_array_crystal_array_4 (Init)");
#define mccompcurname  channel_18_analyzer_2_array_crystal_array_4
#define mccompcurtype  Union_box
#define mccompcurindex 829
#define loop_index mccchannel_18_analyzer_2_array_crystal_array_4_loop_index
#define this_box_volume mccchannel_18_analyzer_2_array_crystal_array_4_this_box_volume
#define global_geometry_element mccchannel_18_analyzer_2_array_crystal_array_4_global_geometry_element
#define this_box_storage mccchannel_18_analyzer_2_array_crystal_array_4_this_box_storage
#define material_string mccchannel_18_analyzer_2_array_crystal_array_4_material_string
#define priority mccchannel_18_analyzer_2_array_crystal_array_4_priority
#define xwidth mccchannel_18_analyzer_2_array_crystal_array_4_xwidth
#define yheight mccchannel_18_analyzer_2_array_crystal_array_4_yheight
#define zdepth mccchannel_18_analyzer_2_array_crystal_array_4_zdepth
#define xwidth2 mccchannel_18_analyzer_2_array_crystal_array_4_xwidth2
#define yheight2 mccchannel_18_analyzer_2_array_crystal_array_4_yheight2
#define visualize mccchannel_18_analyzer_2_array_crystal_array_4_visualize
#define target_index mccchannel_18_analyzer_2_array_crystal_array_4_target_index
#define target_x mccchannel_18_analyzer_2_array_crystal_array_4_target_x
#define target_y mccchannel_18_analyzer_2_array_crystal_array_4_target_y
#define target_z mccchannel_18_analyzer_2_array_crystal_array_4_target_z
#define focus_aw mccchannel_18_analyzer_2_array_crystal_array_4_focus_aw
#define focus_ah mccchannel_18_analyzer_2_array_crystal_array_4_focus_ah
#define focus_xw mccchannel_18_analyzer_2_array_crystal_array_4_focus_xw
#define focus_xh mccchannel_18_analyzer_2_array_crystal_array_4_focus_xh
#define focus_r mccchannel_18_analyzer_2_array_crystal_array_4_focus_r
#define p_interact mccchannel_18_analyzer_2_array_crystal_array_4_p_interact
#define mask_string mccchannel_18_analyzer_2_array_crystal_array_4_mask_string
#define mask_setting mccchannel_18_analyzer_2_array_crystal_array_4_mask_setting
#define number_of_activations mccchannel_18_analyzer_2_array_crystal_array_4_number_of_activations
#line 224 "Union_box.comp"
{
// Initializes the focusing system for this volume including input sanitation.
focus_initialize(&this_box_volume.geometry, POS_A_COMP_INDEX(INDEX_CURRENT_COMP+target_index), POS_A_CURRENT_COMP, ROT_A_CURRENT_COMP, target_index, target_x, target_y, target_z, focus_aw, focus_ah, focus_xw, focus_xh, focus_r, NAME_CURRENT_COMP);

// Input sanitation for this geometry
if (xwidth <= 0) {
  printf("\nERROR in Union_box named %s, the xwidth is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (yheight <= 0) {
  printf("\nERROR in Union_box named %s, yheight is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (zdepth <= 0) {
  printf("\nERROR in Union_box named %s, zdepth is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (xwidth2 <= 0 && xwidth2 != -1) {
  printf("\nERROR in Union_box named %s, the xwidth2 is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (yheight2 <= 0 && yheight2 != -1) {
  printf("\nERROR in Union_box named %s, yheight2 is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}

// Use sanitation
if (global_material_list.num_elements == 0) {
  printf("\nERROR: Need to define a material using Union_make_material before using a Union geometry component. \n");
  printf("       %s was defined before first use of Union_make_material.\n",NAME_CURRENT_COMP);
  exit(1);
}

this_box_volume.geometry.is_masked_volume = 0;
this_box_volume.geometry.is_exit_volume = 0;
this_box_volume.geometry.is_mask_volume = 0;
// check if the volume is a mask, if it is the material string is irelevant.
if (mask_string && strlen(mask_string) && strcmp(mask_string, "NULL") && strcmp(mask_string, "0")) {
    // A mask volume is used to limit the extend of other volumes, called the masked volumes. These are specified in the mask_string.
    // In order for a ray to enter a masked volume, it needs to be both in the region covered by that volume AND the mask volume.
    // When more than
    this_box_volume.geometry.mask_mode = 1; // Default is mask mode is ALL
    if (mask_setting && strlen(mask_setting) && strcmp(mask_setting, "NULL") && strcmp(mask_setting, "0")) {
        if (strcmp(mask_setting,"ALL") == 0 || strcmp(mask_setting,"All") == 0) this_box_volume.geometry.mask_mode = 1;
        else if (strcmp(mask_setting,"ANY") == 0 || strcmp(mask_setting,"Any") == 0) this_box_volume.geometry.mask_mode = 2;
        else {
            printf("The mask_mode of component %s is set to %s, but must be either ALL or ANY.\n",NAME_CURRENT_COMP,mask_setting);
            exit(1);
        }
    }
    
    for (loop_index=0;loop_index<global_geometry_list.num_elements;loop_index++) {
        // Add mask list
        if (1 == manual_linking_function(global_geometry_list.elements[loop_index].name,mask_string)) {
            add_element_to_int_list(&this_box_volume.geometry.mask_list,global_geometry_list.elements[loop_index].component_index);
            add_element_to_int_list(&global_geometry_list.elements[loop_index].Volume->geometry.masked_by_list,INDEX_CURRENT_COMP);
            global_geometry_list.elements[loop_index].Volume->geometry.is_masked_volume = 1;
            if (this_box_volume.geometry.mask_mode == 2)
                global_geometry_list.elements[loop_index].Volume->geometry.mask_mode = 2;
            if (this_box_volume.geometry.mask_mode == 1) {
                if (global_geometry_list.elements[loop_index].Volume->geometry.is_masked_volume == 1 && global_geometry_list.elements[loop_index].Volume->geometry.mask_mode != 2)
                    // If more than one mask is added to one volume, the ANY mode overwrites the (default) ALL mode.
                    global_geometry_list.elements[loop_index].Volume->geometry.mask_mode = 1;
            }
            
            found_geometries = 1;
        }
    }
    if (found_geometries == 0) {
        printf("The mask_string in geometry: %s did not find any of the specified volumes in the mask_string %s \n",NAME_CURRENT_COMP,mask_string);
        exit(1);
    }
    this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
    this_box_volume.p_physics->is_vacuum = 0; // Makes this volume a vacuum
    this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
    this_box_volume.p_physics->my_a = 0; // Should not be used.
    sprintf(this_box_volume.p_physics->name,"Mask");
    this_box_volume.geometry.is_mask_volume = 1;
    
    
// Read the material input, or if it lacks, use automatic linking.
} else if (material_string && strlen(material_string) && strcmp(material_string, "NULL") && strcmp(material_string, "0")) {
    // A geometry string was given, use it to determine which material
    if (0 == strcmp(material_string,"vacuum") || 0 == strcmp(material_string,"Vacuum")) {
        // One could have a global physics struct for vacuum instead of creating one for each
        this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
        this_box_volume.p_physics->is_vacuum = 1; // Makes this volume a vacuum
        this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
        this_box_volume.p_physics->my_a = 0; // Should not be used.
        sprintf(this_box_volume.p_physics->name,"Vacuum");
    } else if (0 == strcmp(material_string,"exit") || 0 == strcmp(material_string,"Exit")) {
        // One could have a global physics struct for vacuum instead of creating one for each
        this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
        this_box_volume.p_physics->is_vacuum = 1; // Makes this volume a vacuum
        this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
        this_box_volume.p_physics->my_a = 0; // Should not be used.
        this_box_volume.geometry.is_exit_volume = 1;
        sprintf(this_box_volume.p_physics->name,"Exit");
    } else {
        #ifndef MATERIAL_DETECTOR
            printf("Need to define a material before refering to it in a geometry %s.\n",NAME_CURRENT_COMP);
            exit(1);
        #endif
        for (loop_index=0;loop_index<global_material_list.num_elements;loop_index++) {
            if (0 == strcmp(material_string,global_material_list.elements[loop_index].name)) {
                this_box_volume.p_physics = global_material_list.elements[loop_index].physics;
                break;
            }
            if (loop_index == global_material_list.num_elements-1) {
            printf("\n");
            printf("ERROR: The material string \"%s\" in Union geometry \"%s\" did not match a specified material. \n",material_string,NAME_CURRENT_COMP);
            printf("       The materials available at this point (need to be defined before the geometry): \n");
            for (loop_index=0;loop_index<global_material_list.num_elements;loop_index++)
              printf("         %s\n",global_material_list.elements[loop_index].name);
            printf("\n");
            printf("       It is also possible to use one of the defualt materials avaiable: \n");
            printf("           Vacuum (for a Volume without scattering or absorption)\n");
            printf("           Exit (for a Volume where the ray exits the component if it enters)\n");
            printf("           Mask (for a Volume that masks existing volumes specified in the mask_string\n");
            exit(1);
          }
        }
    }
} else {
    // Automatic linking, simply using the last defined material.
    #ifndef MATERIAL_DETECTOR
        printf("Need to define a material before the geometry to use automatic linking %s.\n",NAME_CURRENT_COMP);
        exit(1);
    #endif
    this_box_volume.p_physics = global_material_list.elements[global_material_list.num_elements-1].physics;
}

sprintf(this_box_volume.name,NAME_CURRENT_COMP);
sprintf(this_box_volume.geometry.shape,"box");
this_box_volume.geometry.priority_value = priority;
this_box_volume.geometry.geometry_p_interact = p_interact;
// Currently the coordinates will be in absolute space.
this_box_volume.geometry.center = POS_A_CURRENT_COMP;

this_box_storage.z_depth = zdepth;
this_box_storage.x_width1 = xwidth;
this_box_storage.y_height1 = yheight;

this_box_storage.is_rectangle = 0;
if (xwidth2 < 0 && yheight2 < 0) this_box_storage.is_rectangle = 1;
if (xwidth == xwidth2 && yheight == yheight2) this_box_storage.is_rectangle = 1;

if (xwidth2 < 0) {
    this_box_storage.x_width2 = xwidth;
    xwidth2 = xwidth;
} else this_box_storage.x_width2 = xwidth2;

if (yheight2 < 0) {
    this_box_storage.y_height2 = yheight;
    yheight2 = yheight;
} else this_box_storage.y_height2 = yheight2;


this_box_storage.normal_vectors[0] = coords_set(0,0,1);
this_box_storage.normal_vectors[1] = coords_set(0,0,1);

// for sides with y component = 0
x_component = 2*zdepth/sqrt((xwidth-xwidth2)*(xwidth-xwidth2)+4*zdepth*zdepth);
z_component = (xwidth-xwidth2)/sqrt(4*zdepth*zdepth+(xwidth-xwidth2)*(xwidth-xwidth2));

this_box_storage.normal_vectors[2] = coords_set(x_component,0,z_component);
this_box_storage.normal_vectors[3] = coords_set(-x_component,0,z_component);

// for sides with x component = 0
y_component = 2*zdepth/sqrt((yheight-yheight2)*(yheight-yheight2)+4*zdepth*zdepth);
z_component = (yheight-yheight2)/sqrt(4*zdepth*zdepth+(yheight-yheight2)*(yheight-yheight2));

this_box_storage.normal_vectors[4] = coords_set(0,y_component,z_component);
this_box_storage.normal_vectors[5] = coords_set(0,-y_component,z_component);

this_box_volume.geometry.visualization_on = visualize;

this_box_volume.geometry.geometry_parameters.p_box_storage = &this_box_storage;

// Assign pointers to functions for intersection with the shape, checking if a point is inside the shape
if (this_box_storage.is_rectangle == 1) {
this_box_volume.geometry.intersect_function = &sample_box_intersect_simple;
this_box_volume.geometry.within_function = &r_within_box_simple;
}
else {
this_box_volume.geometry.intersect_function = &sample_box_intersect_advanced;
this_box_volume.geometry.within_function = &r_within_box_advanced;
}

this_box_volume.geometry.shell_points = &box_shell_points;
this_box_volume.geometry.mcdisplay_function = &mcdisplay_box_function;
this_box_volume.geometry.initialize_from_main_function = &initialize_box_geometry_from_main_component;
this_box_volume.geometry.process_rot_allocated = 0;

this_box_volume.geometry.copy_geometry_parameters = &allocate_box_storage_copy;

rot_copy(this_box_volume.geometry.rotation_matrix,ROT_A_CURRENT_COMP); //check how ROT_R_CURRENT_COMP would work
rot_transpose(ROT_A_CURRENT_COMP,this_box_volume.geometry.transpose_rotation_matrix);

// Initialize loggers
this_box_volume.loggers.num_elements = 0;

// packing the information into the global_geometry_element, which is then included in the global_geometry_list.
sprintf(global_geometry_element.name,NAME_CURRENT_COMP);
global_geometry_element.activation_counter = number_of_activations;
global_geometry_element.component_index = INDEX_CURRENT_COMP;
global_geometry_element.Volume = &this_box_volume; // Would be nicer if this m was a pointer, now we have the (small) data two places
add_element_to_geometry_list(&global_geometry_list,global_geometry_element);
}
#line 327887 "MACS_sample_kidney_box.c"
#undef number_of_activations
#undef mask_setting
#undef mask_string
#undef p_interact
#undef focus_r
#undef focus_xh
#undef focus_xw
#undef focus_ah
#undef focus_aw
#undef target_z
#undef target_y
#undef target_x
#undef target_index
#undef visualize
#undef yheight2
#undef xwidth2
#undef zdepth
#undef yheight
#undef xwidth
#undef priority
#undef material_string
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

  /* Initializations for component channel_18_analyzer_2_array_crystal_array_5. */
  SIG_MESSAGE("channel_18_analyzer_2_array_crystal_array_5 (Init)");
#define mccompcurname  channel_18_analyzer_2_array_crystal_array_5
#define mccompcurtype  Union_box
#define mccompcurindex 830
#define loop_index mccchannel_18_analyzer_2_array_crystal_array_5_loop_index
#define this_box_volume mccchannel_18_analyzer_2_array_crystal_array_5_this_box_volume
#define global_geometry_element mccchannel_18_analyzer_2_array_crystal_array_5_global_geometry_element
#define this_box_storage mccchannel_18_analyzer_2_array_crystal_array_5_this_box_storage
#define material_string mccchannel_18_analyzer_2_array_crystal_array_5_material_string
#define priority mccchannel_18_analyzer_2_array_crystal_array_5_priority
#define xwidth mccchannel_18_analyzer_2_array_crystal_array_5_xwidth
#define yheight mccchannel_18_analyzer_2_array_crystal_array_5_yheight
#define zdepth mccchannel_18_analyzer_2_array_crystal_array_5_zdepth
#define xwidth2 mccchannel_18_analyzer_2_array_crystal_array_5_xwidth2
#define yheight2 mccchannel_18_analyzer_2_array_crystal_array_5_yheight2
#define visualize mccchannel_18_analyzer_2_array_crystal_array_5_visualize
#define target_index mccchannel_18_analyzer_2_array_crystal_array_5_target_index
#define target_x mccchannel_18_analyzer_2_array_crystal_array_5_target_x
#define target_y mccchannel_18_analyzer_2_array_crystal_array_5_target_y
#define target_z mccchannel_18_analyzer_2_array_crystal_array_5_target_z
#define focus_aw mccchannel_18_analyzer_2_array_crystal_array_5_focus_aw
#define focus_ah mccchannel_18_analyzer_2_array_crystal_array_5_focus_ah
#define focus_xw mccchannel_18_analyzer_2_array_crystal_array_5_focus_xw
#define focus_xh mccchannel_18_analyzer_2_array_crystal_array_5_focus_xh
#define focus_r mccchannel_18_analyzer_2_array_crystal_array_5_focus_r
#define p_interact mccchannel_18_analyzer_2_array_crystal_array_5_p_interact
#define mask_string mccchannel_18_analyzer_2_array_crystal_array_5_mask_string
#define mask_setting mccchannel_18_analyzer_2_array_crystal_array_5_mask_setting
#define number_of_activations mccchannel_18_analyzer_2_array_crystal_array_5_number_of_activations
#line 224 "Union_box.comp"
{
// Initializes the focusing system for this volume including input sanitation.
focus_initialize(&this_box_volume.geometry, POS_A_COMP_INDEX(INDEX_CURRENT_COMP+target_index), POS_A_CURRENT_COMP, ROT_A_CURRENT_COMP, target_index, target_x, target_y, target_z, focus_aw, focus_ah, focus_xw, focus_xh, focus_r, NAME_CURRENT_COMP);

// Input sanitation for this geometry
if (xwidth <= 0) {
  printf("\nERROR in Union_box named %s, the xwidth is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (yheight <= 0) {
  printf("\nERROR in Union_box named %s, yheight is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (zdepth <= 0) {
  printf("\nERROR in Union_box named %s, zdepth is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (xwidth2 <= 0 && xwidth2 != -1) {
  printf("\nERROR in Union_box named %s, the xwidth2 is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (yheight2 <= 0 && yheight2 != -1) {
  printf("\nERROR in Union_box named %s, yheight2 is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}

// Use sanitation
if (global_material_list.num_elements == 0) {
  printf("\nERROR: Need to define a material using Union_make_material before using a Union geometry component. \n");
  printf("       %s was defined before first use of Union_make_material.\n",NAME_CURRENT_COMP);
  exit(1);
}

this_box_volume.geometry.is_masked_volume = 0;
this_box_volume.geometry.is_exit_volume = 0;
this_box_volume.geometry.is_mask_volume = 0;
// check if the volume is a mask, if it is the material string is irelevant.
if (mask_string && strlen(mask_string) && strcmp(mask_string, "NULL") && strcmp(mask_string, "0")) {
    // A mask volume is used to limit the extend of other volumes, called the masked volumes. These are specified in the mask_string.
    // In order for a ray to enter a masked volume, it needs to be both in the region covered by that volume AND the mask volume.
    // When more than
    this_box_volume.geometry.mask_mode = 1; // Default is mask mode is ALL
    if (mask_setting && strlen(mask_setting) && strcmp(mask_setting, "NULL") && strcmp(mask_setting, "0")) {
        if (strcmp(mask_setting,"ALL") == 0 || strcmp(mask_setting,"All") == 0) this_box_volume.geometry.mask_mode = 1;
        else if (strcmp(mask_setting,"ANY") == 0 || strcmp(mask_setting,"Any") == 0) this_box_volume.geometry.mask_mode = 2;
        else {
            printf("The mask_mode of component %s is set to %s, but must be either ALL or ANY.\n",NAME_CURRENT_COMP,mask_setting);
            exit(1);
        }
    }
    
    for (loop_index=0;loop_index<global_geometry_list.num_elements;loop_index++) {
        // Add mask list
        if (1 == manual_linking_function(global_geometry_list.elements[loop_index].name,mask_string)) {
            add_element_to_int_list(&this_box_volume.geometry.mask_list,global_geometry_list.elements[loop_index].component_index);
            add_element_to_int_list(&global_geometry_list.elements[loop_index].Volume->geometry.masked_by_list,INDEX_CURRENT_COMP);
            global_geometry_list.elements[loop_index].Volume->geometry.is_masked_volume = 1;
            if (this_box_volume.geometry.mask_mode == 2)
                global_geometry_list.elements[loop_index].Volume->geometry.mask_mode = 2;
            if (this_box_volume.geometry.mask_mode == 1) {
                if (global_geometry_list.elements[loop_index].Volume->geometry.is_masked_volume == 1 && global_geometry_list.elements[loop_index].Volume->geometry.mask_mode != 2)
                    // If more than one mask is added to one volume, the ANY mode overwrites the (default) ALL mode.
                    global_geometry_list.elements[loop_index].Volume->geometry.mask_mode = 1;
            }
            
            found_geometries = 1;
        }
    }
    if (found_geometries == 0) {
        printf("The mask_string in geometry: %s did not find any of the specified volumes in the mask_string %s \n",NAME_CURRENT_COMP,mask_string);
        exit(1);
    }
    this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
    this_box_volume.p_physics->is_vacuum = 0; // Makes this volume a vacuum
    this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
    this_box_volume.p_physics->my_a = 0; // Should not be used.
    sprintf(this_box_volume.p_physics->name,"Mask");
    this_box_volume.geometry.is_mask_volume = 1;
    
    
// Read the material input, or if it lacks, use automatic linking.
} else if (material_string && strlen(material_string) && strcmp(material_string, "NULL") && strcmp(material_string, "0")) {
    // A geometry string was given, use it to determine which material
    if (0 == strcmp(material_string,"vacuum") || 0 == strcmp(material_string,"Vacuum")) {
        // One could have a global physics struct for vacuum instead of creating one for each
        this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
        this_box_volume.p_physics->is_vacuum = 1; // Makes this volume a vacuum
        this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
        this_box_volume.p_physics->my_a = 0; // Should not be used.
        sprintf(this_box_volume.p_physics->name,"Vacuum");
    } else if (0 == strcmp(material_string,"exit") || 0 == strcmp(material_string,"Exit")) {
        // One could have a global physics struct for vacuum instead of creating one for each
        this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
        this_box_volume.p_physics->is_vacuum = 1; // Makes this volume a vacuum
        this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
        this_box_volume.p_physics->my_a = 0; // Should not be used.
        this_box_volume.geometry.is_exit_volume = 1;
        sprintf(this_box_volume.p_physics->name,"Exit");
    } else {
        #ifndef MATERIAL_DETECTOR
            printf("Need to define a material before refering to it in a geometry %s.\n",NAME_CURRENT_COMP);
            exit(1);
        #endif
        for (loop_index=0;loop_index<global_material_list.num_elements;loop_index++) {
            if (0 == strcmp(material_string,global_material_list.elements[loop_index].name)) {
                this_box_volume.p_physics = global_material_list.elements[loop_index].physics;
                break;
            }
            if (loop_index == global_material_list.num_elements-1) {
            printf("\n");
            printf("ERROR: The material string \"%s\" in Union geometry \"%s\" did not match a specified material. \n",material_string,NAME_CURRENT_COMP);
            printf("       The materials available at this point (need to be defined before the geometry): \n");
            for (loop_index=0;loop_index<global_material_list.num_elements;loop_index++)
              printf("         %s\n",global_material_list.elements[loop_index].name);
            printf("\n");
            printf("       It is also possible to use one of the defualt materials avaiable: \n");
            printf("           Vacuum (for a Volume without scattering or absorption)\n");
            printf("           Exit (for a Volume where the ray exits the component if it enters)\n");
            printf("           Mask (for a Volume that masks existing volumes specified in the mask_string\n");
            exit(1);
          }
        }
    }
} else {
    // Automatic linking, simply using the last defined material.
    #ifndef MATERIAL_DETECTOR
        printf("Need to define a material before the geometry to use automatic linking %s.\n",NAME_CURRENT_COMP);
        exit(1);
    #endif
    this_box_volume.p_physics = global_material_list.elements[global_material_list.num_elements-1].physics;
}

sprintf(this_box_volume.name,NAME_CURRENT_COMP);
sprintf(this_box_volume.geometry.shape,"box");
this_box_volume.geometry.priority_value = priority;
this_box_volume.geometry.geometry_p_interact = p_interact;
// Currently the coordinates will be in absolute space.
this_box_volume.geometry.center = POS_A_CURRENT_COMP;

this_box_storage.z_depth = zdepth;
this_box_storage.x_width1 = xwidth;
this_box_storage.y_height1 = yheight;

this_box_storage.is_rectangle = 0;
if (xwidth2 < 0 && yheight2 < 0) this_box_storage.is_rectangle = 1;
if (xwidth == xwidth2 && yheight == yheight2) this_box_storage.is_rectangle = 1;

if (xwidth2 < 0) {
    this_box_storage.x_width2 = xwidth;
    xwidth2 = xwidth;
} else this_box_storage.x_width2 = xwidth2;

if (yheight2 < 0) {
    this_box_storage.y_height2 = yheight;
    yheight2 = yheight;
} else this_box_storage.y_height2 = yheight2;


this_box_storage.normal_vectors[0] = coords_set(0,0,1);
this_box_storage.normal_vectors[1] = coords_set(0,0,1);

// for sides with y component = 0
x_component = 2*zdepth/sqrt((xwidth-xwidth2)*(xwidth-xwidth2)+4*zdepth*zdepth);
z_component = (xwidth-xwidth2)/sqrt(4*zdepth*zdepth+(xwidth-xwidth2)*(xwidth-xwidth2));

this_box_storage.normal_vectors[2] = coords_set(x_component,0,z_component);
this_box_storage.normal_vectors[3] = coords_set(-x_component,0,z_component);

// for sides with x component = 0
y_component = 2*zdepth/sqrt((yheight-yheight2)*(yheight-yheight2)+4*zdepth*zdepth);
z_component = (yheight-yheight2)/sqrt(4*zdepth*zdepth+(yheight-yheight2)*(yheight-yheight2));

this_box_storage.normal_vectors[4] = coords_set(0,y_component,z_component);
this_box_storage.normal_vectors[5] = coords_set(0,-y_component,z_component);

this_box_volume.geometry.visualization_on = visualize;

this_box_volume.geometry.geometry_parameters.p_box_storage = &this_box_storage;

// Assign pointers to functions for intersection with the shape, checking if a point is inside the shape
if (this_box_storage.is_rectangle == 1) {
this_box_volume.geometry.intersect_function = &sample_box_intersect_simple;
this_box_volume.geometry.within_function = &r_within_box_simple;
}
else {
this_box_volume.geometry.intersect_function = &sample_box_intersect_advanced;
this_box_volume.geometry.within_function = &r_within_box_advanced;
}

this_box_volume.geometry.shell_points = &box_shell_points;
this_box_volume.geometry.mcdisplay_function = &mcdisplay_box_function;
this_box_volume.geometry.initialize_from_main_function = &initialize_box_geometry_from_main_component;
this_box_volume.geometry.process_rot_allocated = 0;

this_box_volume.geometry.copy_geometry_parameters = &allocate_box_storage_copy;

rot_copy(this_box_volume.geometry.rotation_matrix,ROT_A_CURRENT_COMP); //check how ROT_R_CURRENT_COMP would work
rot_transpose(ROT_A_CURRENT_COMP,this_box_volume.geometry.transpose_rotation_matrix);

// Initialize loggers
this_box_volume.loggers.num_elements = 0;

// packing the information into the global_geometry_element, which is then included in the global_geometry_list.
sprintf(global_geometry_element.name,NAME_CURRENT_COMP);
global_geometry_element.activation_counter = number_of_activations;
global_geometry_element.component_index = INDEX_CURRENT_COMP;
global_geometry_element.Volume = &this_box_volume; // Would be nicer if this m was a pointer, now we have the (small) data two places
add_element_to_geometry_list(&global_geometry_list,global_geometry_element);
}
#line 328157 "MACS_sample_kidney_box.c"
#undef number_of_activations
#undef mask_setting
#undef mask_string
#undef p_interact
#undef focus_r
#undef focus_xh
#undef focus_xw
#undef focus_ah
#undef focus_aw
#undef target_z
#undef target_y
#undef target_x
#undef target_index
#undef visualize
#undef yheight2
#undef xwidth2
#undef zdepth
#undef yheight
#undef xwidth
#undef priority
#undef material_string
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

  /* Initializations for component channel_18_analyzer_2_array_crystal_array_6. */
  SIG_MESSAGE("channel_18_analyzer_2_array_crystal_array_6 (Init)");
#define mccompcurname  channel_18_analyzer_2_array_crystal_array_6
#define mccompcurtype  Union_box
#define mccompcurindex 831
#define loop_index mccchannel_18_analyzer_2_array_crystal_array_6_loop_index
#define this_box_volume mccchannel_18_analyzer_2_array_crystal_array_6_this_box_volume
#define global_geometry_element mccchannel_18_analyzer_2_array_crystal_array_6_global_geometry_element
#define this_box_storage mccchannel_18_analyzer_2_array_crystal_array_6_this_box_storage
#define material_string mccchannel_18_analyzer_2_array_crystal_array_6_material_string
#define priority mccchannel_18_analyzer_2_array_crystal_array_6_priority
#define xwidth mccchannel_18_analyzer_2_array_crystal_array_6_xwidth
#define yheight mccchannel_18_analyzer_2_array_crystal_array_6_yheight
#define zdepth mccchannel_18_analyzer_2_array_crystal_array_6_zdepth
#define xwidth2 mccchannel_18_analyzer_2_array_crystal_array_6_xwidth2
#define yheight2 mccchannel_18_analyzer_2_array_crystal_array_6_yheight2
#define visualize mccchannel_18_analyzer_2_array_crystal_array_6_visualize
#define target_index mccchannel_18_analyzer_2_array_crystal_array_6_target_index
#define target_x mccchannel_18_analyzer_2_array_crystal_array_6_target_x
#define target_y mccchannel_18_analyzer_2_array_crystal_array_6_target_y
#define target_z mccchannel_18_analyzer_2_array_crystal_array_6_target_z
#define focus_aw mccchannel_18_analyzer_2_array_crystal_array_6_focus_aw
#define focus_ah mccchannel_18_analyzer_2_array_crystal_array_6_focus_ah
#define focus_xw mccchannel_18_analyzer_2_array_crystal_array_6_focus_xw
#define focus_xh mccchannel_18_analyzer_2_array_crystal_array_6_focus_xh
#define focus_r mccchannel_18_analyzer_2_array_crystal_array_6_focus_r
#define p_interact mccchannel_18_analyzer_2_array_crystal_array_6_p_interact
#define mask_string mccchannel_18_analyzer_2_array_crystal_array_6_mask_string
#define mask_setting mccchannel_18_analyzer_2_array_crystal_array_6_mask_setting
#define number_of_activations mccchannel_18_analyzer_2_array_crystal_array_6_number_of_activations
#line 224 "Union_box.comp"
{
// Initializes the focusing system for this volume including input sanitation.
focus_initialize(&this_box_volume.geometry, POS_A_COMP_INDEX(INDEX_CURRENT_COMP+target_index), POS_A_CURRENT_COMP, ROT_A_CURRENT_COMP, target_index, target_x, target_y, target_z, focus_aw, focus_ah, focus_xw, focus_xh, focus_r, NAME_CURRENT_COMP);

// Input sanitation for this geometry
if (xwidth <= 0) {
  printf("\nERROR in Union_box named %s, the xwidth is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (yheight <= 0) {
  printf("\nERROR in Union_box named %s, yheight is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (zdepth <= 0) {
  printf("\nERROR in Union_box named %s, zdepth is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (xwidth2 <= 0 && xwidth2 != -1) {
  printf("\nERROR in Union_box named %s, the xwidth2 is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (yheight2 <= 0 && yheight2 != -1) {
  printf("\nERROR in Union_box named %s, yheight2 is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}

// Use sanitation
if (global_material_list.num_elements == 0) {
  printf("\nERROR: Need to define a material using Union_make_material before using a Union geometry component. \n");
  printf("       %s was defined before first use of Union_make_material.\n",NAME_CURRENT_COMP);
  exit(1);
}

this_box_volume.geometry.is_masked_volume = 0;
this_box_volume.geometry.is_exit_volume = 0;
this_box_volume.geometry.is_mask_volume = 0;
// check if the volume is a mask, if it is the material string is irelevant.
if (mask_string && strlen(mask_string) && strcmp(mask_string, "NULL") && strcmp(mask_string, "0")) {
    // A mask volume is used to limit the extend of other volumes, called the masked volumes. These are specified in the mask_string.
    // In order for a ray to enter a masked volume, it needs to be both in the region covered by that volume AND the mask volume.
    // When more than
    this_box_volume.geometry.mask_mode = 1; // Default is mask mode is ALL
    if (mask_setting && strlen(mask_setting) && strcmp(mask_setting, "NULL") && strcmp(mask_setting, "0")) {
        if (strcmp(mask_setting,"ALL") == 0 || strcmp(mask_setting,"All") == 0) this_box_volume.geometry.mask_mode = 1;
        else if (strcmp(mask_setting,"ANY") == 0 || strcmp(mask_setting,"Any") == 0) this_box_volume.geometry.mask_mode = 2;
        else {
            printf("The mask_mode of component %s is set to %s, but must be either ALL or ANY.\n",NAME_CURRENT_COMP,mask_setting);
            exit(1);
        }
    }
    
    for (loop_index=0;loop_index<global_geometry_list.num_elements;loop_index++) {
        // Add mask list
        if (1 == manual_linking_function(global_geometry_list.elements[loop_index].name,mask_string)) {
            add_element_to_int_list(&this_box_volume.geometry.mask_list,global_geometry_list.elements[loop_index].component_index);
            add_element_to_int_list(&global_geometry_list.elements[loop_index].Volume->geometry.masked_by_list,INDEX_CURRENT_COMP);
            global_geometry_list.elements[loop_index].Volume->geometry.is_masked_volume = 1;
            if (this_box_volume.geometry.mask_mode == 2)
                global_geometry_list.elements[loop_index].Volume->geometry.mask_mode = 2;
            if (this_box_volume.geometry.mask_mode == 1) {
                if (global_geometry_list.elements[loop_index].Volume->geometry.is_masked_volume == 1 && global_geometry_list.elements[loop_index].Volume->geometry.mask_mode != 2)
                    // If more than one mask is added to one volume, the ANY mode overwrites the (default) ALL mode.
                    global_geometry_list.elements[loop_index].Volume->geometry.mask_mode = 1;
            }
            
            found_geometries = 1;
        }
    }
    if (found_geometries == 0) {
        printf("The mask_string in geometry: %s did not find any of the specified volumes in the mask_string %s \n",NAME_CURRENT_COMP,mask_string);
        exit(1);
    }
    this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
    this_box_volume.p_physics->is_vacuum = 0; // Makes this volume a vacuum
    this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
    this_box_volume.p_physics->my_a = 0; // Should not be used.
    sprintf(this_box_volume.p_physics->name,"Mask");
    this_box_volume.geometry.is_mask_volume = 1;
    
    
// Read the material input, or if it lacks, use automatic linking.
} else if (material_string && strlen(material_string) && strcmp(material_string, "NULL") && strcmp(material_string, "0")) {
    // A geometry string was given, use it to determine which material
    if (0 == strcmp(material_string,"vacuum") || 0 == strcmp(material_string,"Vacuum")) {
        // One could have a global physics struct for vacuum instead of creating one for each
        this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
        this_box_volume.p_physics->is_vacuum = 1; // Makes this volume a vacuum
        this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
        this_box_volume.p_physics->my_a = 0; // Should not be used.
        sprintf(this_box_volume.p_physics->name,"Vacuum");
    } else if (0 == strcmp(material_string,"exit") || 0 == strcmp(material_string,"Exit")) {
        // One could have a global physics struct for vacuum instead of creating one for each
        this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
        this_box_volume.p_physics->is_vacuum = 1; // Makes this volume a vacuum
        this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
        this_box_volume.p_physics->my_a = 0; // Should not be used.
        this_box_volume.geometry.is_exit_volume = 1;
        sprintf(this_box_volume.p_physics->name,"Exit");
    } else {
        #ifndef MATERIAL_DETECTOR
            printf("Need to define a material before refering to it in a geometry %s.\n",NAME_CURRENT_COMP);
            exit(1);
        #endif
        for (loop_index=0;loop_index<global_material_list.num_elements;loop_index++) {
            if (0 == strcmp(material_string,global_material_list.elements[loop_index].name)) {
                this_box_volume.p_physics = global_material_list.elements[loop_index].physics;
                break;
            }
            if (loop_index == global_material_list.num_elements-1) {
            printf("\n");
            printf("ERROR: The material string \"%s\" in Union geometry \"%s\" did not match a specified material. \n",material_string,NAME_CURRENT_COMP);
            printf("       The materials available at this point (need to be defined before the geometry): \n");
            for (loop_index=0;loop_index<global_material_list.num_elements;loop_index++)
              printf("         %s\n",global_material_list.elements[loop_index].name);
            printf("\n");
            printf("       It is also possible to use one of the defualt materials avaiable: \n");
            printf("           Vacuum (for a Volume without scattering or absorption)\n");
            printf("           Exit (for a Volume where the ray exits the component if it enters)\n");
            printf("           Mask (for a Volume that masks existing volumes specified in the mask_string\n");
            exit(1);
          }
        }
    }
} else {
    // Automatic linking, simply using the last defined material.
    #ifndef MATERIAL_DETECTOR
        printf("Need to define a material before the geometry to use automatic linking %s.\n",NAME_CURRENT_COMP);
        exit(1);
    #endif
    this_box_volume.p_physics = global_material_list.elements[global_material_list.num_elements-1].physics;
}

sprintf(this_box_volume.name,NAME_CURRENT_COMP);
sprintf(this_box_volume.geometry.shape,"box");
this_box_volume.geometry.priority_value = priority;
this_box_volume.geometry.geometry_p_interact = p_interact;
// Currently the coordinates will be in absolute space.
this_box_volume.geometry.center = POS_A_CURRENT_COMP;

this_box_storage.z_depth = zdepth;
this_box_storage.x_width1 = xwidth;
this_box_storage.y_height1 = yheight;

this_box_storage.is_rectangle = 0;
if (xwidth2 < 0 && yheight2 < 0) this_box_storage.is_rectangle = 1;
if (xwidth == xwidth2 && yheight == yheight2) this_box_storage.is_rectangle = 1;

if (xwidth2 < 0) {
    this_box_storage.x_width2 = xwidth;
    xwidth2 = xwidth;
} else this_box_storage.x_width2 = xwidth2;

if (yheight2 < 0) {
    this_box_storage.y_height2 = yheight;
    yheight2 = yheight;
} else this_box_storage.y_height2 = yheight2;


this_box_storage.normal_vectors[0] = coords_set(0,0,1);
this_box_storage.normal_vectors[1] = coords_set(0,0,1);

// for sides with y component = 0
x_component = 2*zdepth/sqrt((xwidth-xwidth2)*(xwidth-xwidth2)+4*zdepth*zdepth);
z_component = (xwidth-xwidth2)/sqrt(4*zdepth*zdepth+(xwidth-xwidth2)*(xwidth-xwidth2));

this_box_storage.normal_vectors[2] = coords_set(x_component,0,z_component);
this_box_storage.normal_vectors[3] = coords_set(-x_component,0,z_component);

// for sides with x component = 0
y_component = 2*zdepth/sqrt((yheight-yheight2)*(yheight-yheight2)+4*zdepth*zdepth);
z_component = (yheight-yheight2)/sqrt(4*zdepth*zdepth+(yheight-yheight2)*(yheight-yheight2));

this_box_storage.normal_vectors[4] = coords_set(0,y_component,z_component);
this_box_storage.normal_vectors[5] = coords_set(0,-y_component,z_component);

this_box_volume.geometry.visualization_on = visualize;

this_box_volume.geometry.geometry_parameters.p_box_storage = &this_box_storage;

// Assign pointers to functions for intersection with the shape, checking if a point is inside the shape
if (this_box_storage.is_rectangle == 1) {
this_box_volume.geometry.intersect_function = &sample_box_intersect_simple;
this_box_volume.geometry.within_function = &r_within_box_simple;
}
else {
this_box_volume.geometry.intersect_function = &sample_box_intersect_advanced;
this_box_volume.geometry.within_function = &r_within_box_advanced;
}

this_box_volume.geometry.shell_points = &box_shell_points;
this_box_volume.geometry.mcdisplay_function = &mcdisplay_box_function;
this_box_volume.geometry.initialize_from_main_function = &initialize_box_geometry_from_main_component;
this_box_volume.geometry.process_rot_allocated = 0;

this_box_volume.geometry.copy_geometry_parameters = &allocate_box_storage_copy;

rot_copy(this_box_volume.geometry.rotation_matrix,ROT_A_CURRENT_COMP); //check how ROT_R_CURRENT_COMP would work
rot_transpose(ROT_A_CURRENT_COMP,this_box_volume.geometry.transpose_rotation_matrix);

// Initialize loggers
this_box_volume.loggers.num_elements = 0;

// packing the information into the global_geometry_element, which is then included in the global_geometry_list.
sprintf(global_geometry_element.name,NAME_CURRENT_COMP);
global_geometry_element.activation_counter = number_of_activations;
global_geometry_element.component_index = INDEX_CURRENT_COMP;
global_geometry_element.Volume = &this_box_volume; // Would be nicer if this m was a pointer, now we have the (small) data two places
add_element_to_geometry_list(&global_geometry_list,global_geometry_element);
}
#line 328427 "MACS_sample_kidney_box.c"
#undef number_of_activations
#undef mask_setting
#undef mask_string
#undef p_interact
#undef focus_r
#undef focus_xh
#undef focus_xw
#undef focus_ah
#undef focus_aw
#undef target_z
#undef target_y
#undef target_x
#undef target_index
#undef visualize
#undef yheight2
#undef xwidth2
#undef zdepth
#undef yheight
#undef xwidth
#undef priority
#undef material_string
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

  /* Initializations for component channel_18_analyzer_2_array_crystal_array_7. */
  SIG_MESSAGE("channel_18_analyzer_2_array_crystal_array_7 (Init)");
#define mccompcurname  channel_18_analyzer_2_array_crystal_array_7
#define mccompcurtype  Union_box
#define mccompcurindex 832
#define loop_index mccchannel_18_analyzer_2_array_crystal_array_7_loop_index
#define this_box_volume mccchannel_18_analyzer_2_array_crystal_array_7_this_box_volume
#define global_geometry_element mccchannel_18_analyzer_2_array_crystal_array_7_global_geometry_element
#define this_box_storage mccchannel_18_analyzer_2_array_crystal_array_7_this_box_storage
#define material_string mccchannel_18_analyzer_2_array_crystal_array_7_material_string
#define priority mccchannel_18_analyzer_2_array_crystal_array_7_priority
#define xwidth mccchannel_18_analyzer_2_array_crystal_array_7_xwidth
#define yheight mccchannel_18_analyzer_2_array_crystal_array_7_yheight
#define zdepth mccchannel_18_analyzer_2_array_crystal_array_7_zdepth
#define xwidth2 mccchannel_18_analyzer_2_array_crystal_array_7_xwidth2
#define yheight2 mccchannel_18_analyzer_2_array_crystal_array_7_yheight2
#define visualize mccchannel_18_analyzer_2_array_crystal_array_7_visualize
#define target_index mccchannel_18_analyzer_2_array_crystal_array_7_target_index
#define target_x mccchannel_18_analyzer_2_array_crystal_array_7_target_x
#define target_y mccchannel_18_analyzer_2_array_crystal_array_7_target_y
#define target_z mccchannel_18_analyzer_2_array_crystal_array_7_target_z
#define focus_aw mccchannel_18_analyzer_2_array_crystal_array_7_focus_aw
#define focus_ah mccchannel_18_analyzer_2_array_crystal_array_7_focus_ah
#define focus_xw mccchannel_18_analyzer_2_array_crystal_array_7_focus_xw
#define focus_xh mccchannel_18_analyzer_2_array_crystal_array_7_focus_xh
#define focus_r mccchannel_18_analyzer_2_array_crystal_array_7_focus_r
#define p_interact mccchannel_18_analyzer_2_array_crystal_array_7_p_interact
#define mask_string mccchannel_18_analyzer_2_array_crystal_array_7_mask_string
#define mask_setting mccchannel_18_analyzer_2_array_crystal_array_7_mask_setting
#define number_of_activations mccchannel_18_analyzer_2_array_crystal_array_7_number_of_activations
#line 224 "Union_box.comp"
{
// Initializes the focusing system for this volume including input sanitation.
focus_initialize(&this_box_volume.geometry, POS_A_COMP_INDEX(INDEX_CURRENT_COMP+target_index), POS_A_CURRENT_COMP, ROT_A_CURRENT_COMP, target_index, target_x, target_y, target_z, focus_aw, focus_ah, focus_xw, focus_xh, focus_r, NAME_CURRENT_COMP);

// Input sanitation for this geometry
if (xwidth <= 0) {
  printf("\nERROR in Union_box named %s, the xwidth is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (yheight <= 0) {
  printf("\nERROR in Union_box named %s, yheight is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (zdepth <= 0) {
  printf("\nERROR in Union_box named %s, zdepth is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (xwidth2 <= 0 && xwidth2 != -1) {
  printf("\nERROR in Union_box named %s, the xwidth2 is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (yheight2 <= 0 && yheight2 != -1) {
  printf("\nERROR in Union_box named %s, yheight2 is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}

// Use sanitation
if (global_material_list.num_elements == 0) {
  printf("\nERROR: Need to define a material using Union_make_material before using a Union geometry component. \n");
  printf("       %s was defined before first use of Union_make_material.\n",NAME_CURRENT_COMP);
  exit(1);
}

this_box_volume.geometry.is_masked_volume = 0;
this_box_volume.geometry.is_exit_volume = 0;
this_box_volume.geometry.is_mask_volume = 0;
// check if the volume is a mask, if it is the material string is irelevant.
if (mask_string && strlen(mask_string) && strcmp(mask_string, "NULL") && strcmp(mask_string, "0")) {
    // A mask volume is used to limit the extend of other volumes, called the masked volumes. These are specified in the mask_string.
    // In order for a ray to enter a masked volume, it needs to be both in the region covered by that volume AND the mask volume.
    // When more than
    this_box_volume.geometry.mask_mode = 1; // Default is mask mode is ALL
    if (mask_setting && strlen(mask_setting) && strcmp(mask_setting, "NULL") && strcmp(mask_setting, "0")) {
        if (strcmp(mask_setting,"ALL") == 0 || strcmp(mask_setting,"All") == 0) this_box_volume.geometry.mask_mode = 1;
        else if (strcmp(mask_setting,"ANY") == 0 || strcmp(mask_setting,"Any") == 0) this_box_volume.geometry.mask_mode = 2;
        else {
            printf("The mask_mode of component %s is set to %s, but must be either ALL or ANY.\n",NAME_CURRENT_COMP,mask_setting);
            exit(1);
        }
    }
    
    for (loop_index=0;loop_index<global_geometry_list.num_elements;loop_index++) {
        // Add mask list
        if (1 == manual_linking_function(global_geometry_list.elements[loop_index].name,mask_string)) {
            add_element_to_int_list(&this_box_volume.geometry.mask_list,global_geometry_list.elements[loop_index].component_index);
            add_element_to_int_list(&global_geometry_list.elements[loop_index].Volume->geometry.masked_by_list,INDEX_CURRENT_COMP);
            global_geometry_list.elements[loop_index].Volume->geometry.is_masked_volume = 1;
            if (this_box_volume.geometry.mask_mode == 2)
                global_geometry_list.elements[loop_index].Volume->geometry.mask_mode = 2;
            if (this_box_volume.geometry.mask_mode == 1) {
                if (global_geometry_list.elements[loop_index].Volume->geometry.is_masked_volume == 1 && global_geometry_list.elements[loop_index].Volume->geometry.mask_mode != 2)
                    // If more than one mask is added to one volume, the ANY mode overwrites the (default) ALL mode.
                    global_geometry_list.elements[loop_index].Volume->geometry.mask_mode = 1;
            }
            
            found_geometries = 1;
        }
    }
    if (found_geometries == 0) {
        printf("The mask_string in geometry: %s did not find any of the specified volumes in the mask_string %s \n",NAME_CURRENT_COMP,mask_string);
        exit(1);
    }
    this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
    this_box_volume.p_physics->is_vacuum = 0; // Makes this volume a vacuum
    this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
    this_box_volume.p_physics->my_a = 0; // Should not be used.
    sprintf(this_box_volume.p_physics->name,"Mask");
    this_box_volume.geometry.is_mask_volume = 1;
    
    
// Read the material input, or if it lacks, use automatic linking.
} else if (material_string && strlen(material_string) && strcmp(material_string, "NULL") && strcmp(material_string, "0")) {
    // A geometry string was given, use it to determine which material
    if (0 == strcmp(material_string,"vacuum") || 0 == strcmp(material_string,"Vacuum")) {
        // One could have a global physics struct for vacuum instead of creating one for each
        this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
        this_box_volume.p_physics->is_vacuum = 1; // Makes this volume a vacuum
        this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
        this_box_volume.p_physics->my_a = 0; // Should not be used.
        sprintf(this_box_volume.p_physics->name,"Vacuum");
    } else if (0 == strcmp(material_string,"exit") || 0 == strcmp(material_string,"Exit")) {
        // One could have a global physics struct for vacuum instead of creating one for each
        this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
        this_box_volume.p_physics->is_vacuum = 1; // Makes this volume a vacuum
        this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
        this_box_volume.p_physics->my_a = 0; // Should not be used.
        this_box_volume.geometry.is_exit_volume = 1;
        sprintf(this_box_volume.p_physics->name,"Exit");
    } else {
        #ifndef MATERIAL_DETECTOR
            printf("Need to define a material before refering to it in a geometry %s.\n",NAME_CURRENT_COMP);
            exit(1);
        #endif
        for (loop_index=0;loop_index<global_material_list.num_elements;loop_index++) {
            if (0 == strcmp(material_string,global_material_list.elements[loop_index].name)) {
                this_box_volume.p_physics = global_material_list.elements[loop_index].physics;
                break;
            }
            if (loop_index == global_material_list.num_elements-1) {
            printf("\n");
            printf("ERROR: The material string \"%s\" in Union geometry \"%s\" did not match a specified material. \n",material_string,NAME_CURRENT_COMP);
            printf("       The materials available at this point (need to be defined before the geometry): \n");
            for (loop_index=0;loop_index<global_material_list.num_elements;loop_index++)
              printf("         %s\n",global_material_list.elements[loop_index].name);
            printf("\n");
            printf("       It is also possible to use one of the defualt materials avaiable: \n");
            printf("           Vacuum (for a Volume without scattering or absorption)\n");
            printf("           Exit (for a Volume where the ray exits the component if it enters)\n");
            printf("           Mask (for a Volume that masks existing volumes specified in the mask_string\n");
            exit(1);
          }
        }
    }
} else {
    // Automatic linking, simply using the last defined material.
    #ifndef MATERIAL_DETECTOR
        printf("Need to define a material before the geometry to use automatic linking %s.\n",NAME_CURRENT_COMP);
        exit(1);
    #endif
    this_box_volume.p_physics = global_material_list.elements[global_material_list.num_elements-1].physics;
}

sprintf(this_box_volume.name,NAME_CURRENT_COMP);
sprintf(this_box_volume.geometry.shape,"box");
this_box_volume.geometry.priority_value = priority;
this_box_volume.geometry.geometry_p_interact = p_interact;
// Currently the coordinates will be in absolute space.
this_box_volume.geometry.center = POS_A_CURRENT_COMP;

this_box_storage.z_depth = zdepth;
this_box_storage.x_width1 = xwidth;
this_box_storage.y_height1 = yheight;

this_box_storage.is_rectangle = 0;
if (xwidth2 < 0 && yheight2 < 0) this_box_storage.is_rectangle = 1;
if (xwidth == xwidth2 && yheight == yheight2) this_box_storage.is_rectangle = 1;

if (xwidth2 < 0) {
    this_box_storage.x_width2 = xwidth;
    xwidth2 = xwidth;
} else this_box_storage.x_width2 = xwidth2;

if (yheight2 < 0) {
    this_box_storage.y_height2 = yheight;
    yheight2 = yheight;
} else this_box_storage.y_height2 = yheight2;


this_box_storage.normal_vectors[0] = coords_set(0,0,1);
this_box_storage.normal_vectors[1] = coords_set(0,0,1);

// for sides with y component = 0
x_component = 2*zdepth/sqrt((xwidth-xwidth2)*(xwidth-xwidth2)+4*zdepth*zdepth);
z_component = (xwidth-xwidth2)/sqrt(4*zdepth*zdepth+(xwidth-xwidth2)*(xwidth-xwidth2));

this_box_storage.normal_vectors[2] = coords_set(x_component,0,z_component);
this_box_storage.normal_vectors[3] = coords_set(-x_component,0,z_component);

// for sides with x component = 0
y_component = 2*zdepth/sqrt((yheight-yheight2)*(yheight-yheight2)+4*zdepth*zdepth);
z_component = (yheight-yheight2)/sqrt(4*zdepth*zdepth+(yheight-yheight2)*(yheight-yheight2));

this_box_storage.normal_vectors[4] = coords_set(0,y_component,z_component);
this_box_storage.normal_vectors[5] = coords_set(0,-y_component,z_component);

this_box_volume.geometry.visualization_on = visualize;

this_box_volume.geometry.geometry_parameters.p_box_storage = &this_box_storage;

// Assign pointers to functions for intersection with the shape, checking if a point is inside the shape
if (this_box_storage.is_rectangle == 1) {
this_box_volume.geometry.intersect_function = &sample_box_intersect_simple;
this_box_volume.geometry.within_function = &r_within_box_simple;
}
else {
this_box_volume.geometry.intersect_function = &sample_box_intersect_advanced;
this_box_volume.geometry.within_function = &r_within_box_advanced;
}

this_box_volume.geometry.shell_points = &box_shell_points;
this_box_volume.geometry.mcdisplay_function = &mcdisplay_box_function;
this_box_volume.geometry.initialize_from_main_function = &initialize_box_geometry_from_main_component;
this_box_volume.geometry.process_rot_allocated = 0;

this_box_volume.geometry.copy_geometry_parameters = &allocate_box_storage_copy;

rot_copy(this_box_volume.geometry.rotation_matrix,ROT_A_CURRENT_COMP); //check how ROT_R_CURRENT_COMP would work
rot_transpose(ROT_A_CURRENT_COMP,this_box_volume.geometry.transpose_rotation_matrix);

// Initialize loggers
this_box_volume.loggers.num_elements = 0;

// packing the information into the global_geometry_element, which is then included in the global_geometry_list.
sprintf(global_geometry_element.name,NAME_CURRENT_COMP);
global_geometry_element.activation_counter = number_of_activations;
global_geometry_element.component_index = INDEX_CURRENT_COMP;
global_geometry_element.Volume = &this_box_volume; // Would be nicer if this m was a pointer, now we have the (small) data two places
add_element_to_geometry_list(&global_geometry_list,global_geometry_element);
}
#line 328697 "MACS_sample_kidney_box.c"
#undef number_of_activations
#undef mask_setting
#undef mask_string
#undef p_interact
#undef focus_r
#undef focus_xh
#undef focus_xw
#undef focus_ah
#undef focus_aw
#undef target_z
#undef target_y
#undef target_x
#undef target_index
#undef visualize
#undef yheight2
#undef xwidth2
#undef zdepth
#undef yheight
#undef xwidth
#undef priority
#undef material_string
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

  /* Initializations for component channel_18_analyzer_2_array_crystal_array_8. */
  SIG_MESSAGE("channel_18_analyzer_2_array_crystal_array_8 (Init)");
#define mccompcurname  channel_18_analyzer_2_array_crystal_array_8
#define mccompcurtype  Union_box
#define mccompcurindex 833
#define loop_index mccchannel_18_analyzer_2_array_crystal_array_8_loop_index
#define this_box_volume mccchannel_18_analyzer_2_array_crystal_array_8_this_box_volume
#define global_geometry_element mccchannel_18_analyzer_2_array_crystal_array_8_global_geometry_element
#define this_box_storage mccchannel_18_analyzer_2_array_crystal_array_8_this_box_storage
#define material_string mccchannel_18_analyzer_2_array_crystal_array_8_material_string
#define priority mccchannel_18_analyzer_2_array_crystal_array_8_priority
#define xwidth mccchannel_18_analyzer_2_array_crystal_array_8_xwidth
#define yheight mccchannel_18_analyzer_2_array_crystal_array_8_yheight
#define zdepth mccchannel_18_analyzer_2_array_crystal_array_8_zdepth
#define xwidth2 mccchannel_18_analyzer_2_array_crystal_array_8_xwidth2
#define yheight2 mccchannel_18_analyzer_2_array_crystal_array_8_yheight2
#define visualize mccchannel_18_analyzer_2_array_crystal_array_8_visualize
#define target_index mccchannel_18_analyzer_2_array_crystal_array_8_target_index
#define target_x mccchannel_18_analyzer_2_array_crystal_array_8_target_x
#define target_y mccchannel_18_analyzer_2_array_crystal_array_8_target_y
#define target_z mccchannel_18_analyzer_2_array_crystal_array_8_target_z
#define focus_aw mccchannel_18_analyzer_2_array_crystal_array_8_focus_aw
#define focus_ah mccchannel_18_analyzer_2_array_crystal_array_8_focus_ah
#define focus_xw mccchannel_18_analyzer_2_array_crystal_array_8_focus_xw
#define focus_xh mccchannel_18_analyzer_2_array_crystal_array_8_focus_xh
#define focus_r mccchannel_18_analyzer_2_array_crystal_array_8_focus_r
#define p_interact mccchannel_18_analyzer_2_array_crystal_array_8_p_interact
#define mask_string mccchannel_18_analyzer_2_array_crystal_array_8_mask_string
#define mask_setting mccchannel_18_analyzer_2_array_crystal_array_8_mask_setting
#define number_of_activations mccchannel_18_analyzer_2_array_crystal_array_8_number_of_activations
#line 224 "Union_box.comp"
{
// Initializes the focusing system for this volume including input sanitation.
focus_initialize(&this_box_volume.geometry, POS_A_COMP_INDEX(INDEX_CURRENT_COMP+target_index), POS_A_CURRENT_COMP, ROT_A_CURRENT_COMP, target_index, target_x, target_y, target_z, focus_aw, focus_ah, focus_xw, focus_xh, focus_r, NAME_CURRENT_COMP);

// Input sanitation for this geometry
if (xwidth <= 0) {
  printf("\nERROR in Union_box named %s, the xwidth is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (yheight <= 0) {
  printf("\nERROR in Union_box named %s, yheight is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (zdepth <= 0) {
  printf("\nERROR in Union_box named %s, zdepth is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (xwidth2 <= 0 && xwidth2 != -1) {
  printf("\nERROR in Union_box named %s, the xwidth2 is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (yheight2 <= 0 && yheight2 != -1) {
  printf("\nERROR in Union_box named %s, yheight2 is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}

// Use sanitation
if (global_material_list.num_elements == 0) {
  printf("\nERROR: Need to define a material using Union_make_material before using a Union geometry component. \n");
  printf("       %s was defined before first use of Union_make_material.\n",NAME_CURRENT_COMP);
  exit(1);
}

this_box_volume.geometry.is_masked_volume = 0;
this_box_volume.geometry.is_exit_volume = 0;
this_box_volume.geometry.is_mask_volume = 0;
// check if the volume is a mask, if it is the material string is irelevant.
if (mask_string && strlen(mask_string) && strcmp(mask_string, "NULL") && strcmp(mask_string, "0")) {
    // A mask volume is used to limit the extend of other volumes, called the masked volumes. These are specified in the mask_string.
    // In order for a ray to enter a masked volume, it needs to be both in the region covered by that volume AND the mask volume.
    // When more than
    this_box_volume.geometry.mask_mode = 1; // Default is mask mode is ALL
    if (mask_setting && strlen(mask_setting) && strcmp(mask_setting, "NULL") && strcmp(mask_setting, "0")) {
        if (strcmp(mask_setting,"ALL") == 0 || strcmp(mask_setting,"All") == 0) this_box_volume.geometry.mask_mode = 1;
        else if (strcmp(mask_setting,"ANY") == 0 || strcmp(mask_setting,"Any") == 0) this_box_volume.geometry.mask_mode = 2;
        else {
            printf("The mask_mode of component %s is set to %s, but must be either ALL or ANY.\n",NAME_CURRENT_COMP,mask_setting);
            exit(1);
        }
    }
    
    for (loop_index=0;loop_index<global_geometry_list.num_elements;loop_index++) {
        // Add mask list
        if (1 == manual_linking_function(global_geometry_list.elements[loop_index].name,mask_string)) {
            add_element_to_int_list(&this_box_volume.geometry.mask_list,global_geometry_list.elements[loop_index].component_index);
            add_element_to_int_list(&global_geometry_list.elements[loop_index].Volume->geometry.masked_by_list,INDEX_CURRENT_COMP);
            global_geometry_list.elements[loop_index].Volume->geometry.is_masked_volume = 1;
            if (this_box_volume.geometry.mask_mode == 2)
                global_geometry_list.elements[loop_index].Volume->geometry.mask_mode = 2;
            if (this_box_volume.geometry.mask_mode == 1) {
                if (global_geometry_list.elements[loop_index].Volume->geometry.is_masked_volume == 1 && global_geometry_list.elements[loop_index].Volume->geometry.mask_mode != 2)
                    // If more than one mask is added to one volume, the ANY mode overwrites the (default) ALL mode.
                    global_geometry_list.elements[loop_index].Volume->geometry.mask_mode = 1;
            }
            
            found_geometries = 1;
        }
    }
    if (found_geometries == 0) {
        printf("The mask_string in geometry: %s did not find any of the specified volumes in the mask_string %s \n",NAME_CURRENT_COMP,mask_string);
        exit(1);
    }
    this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
    this_box_volume.p_physics->is_vacuum = 0; // Makes this volume a vacuum
    this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
    this_box_volume.p_physics->my_a = 0; // Should not be used.
    sprintf(this_box_volume.p_physics->name,"Mask");
    this_box_volume.geometry.is_mask_volume = 1;
    
    
// Read the material input, or if it lacks, use automatic linking.
} else if (material_string && strlen(material_string) && strcmp(material_string, "NULL") && strcmp(material_string, "0")) {
    // A geometry string was given, use it to determine which material
    if (0 == strcmp(material_string,"vacuum") || 0 == strcmp(material_string,"Vacuum")) {
        // One could have a global physics struct for vacuum instead of creating one for each
        this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
        this_box_volume.p_physics->is_vacuum = 1; // Makes this volume a vacuum
        this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
        this_box_volume.p_physics->my_a = 0; // Should not be used.
        sprintf(this_box_volume.p_physics->name,"Vacuum");
    } else if (0 == strcmp(material_string,"exit") || 0 == strcmp(material_string,"Exit")) {
        // One could have a global physics struct for vacuum instead of creating one for each
        this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
        this_box_volume.p_physics->is_vacuum = 1; // Makes this volume a vacuum
        this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
        this_box_volume.p_physics->my_a = 0; // Should not be used.
        this_box_volume.geometry.is_exit_volume = 1;
        sprintf(this_box_volume.p_physics->name,"Exit");
    } else {
        #ifndef MATERIAL_DETECTOR
            printf("Need to define a material before refering to it in a geometry %s.\n",NAME_CURRENT_COMP);
            exit(1);
        #endif
        for (loop_index=0;loop_index<global_material_list.num_elements;loop_index++) {
            if (0 == strcmp(material_string,global_material_list.elements[loop_index].name)) {
                this_box_volume.p_physics = global_material_list.elements[loop_index].physics;
                break;
            }
            if (loop_index == global_material_list.num_elements-1) {
            printf("\n");
            printf("ERROR: The material string \"%s\" in Union geometry \"%s\" did not match a specified material. \n",material_string,NAME_CURRENT_COMP);
            printf("       The materials available at this point (need to be defined before the geometry): \n");
            for (loop_index=0;loop_index<global_material_list.num_elements;loop_index++)
              printf("         %s\n",global_material_list.elements[loop_index].name);
            printf("\n");
            printf("       It is also possible to use one of the defualt materials avaiable: \n");
            printf("           Vacuum (for a Volume without scattering or absorption)\n");
            printf("           Exit (for a Volume where the ray exits the component if it enters)\n");
            printf("           Mask (for a Volume that masks existing volumes specified in the mask_string\n");
            exit(1);
          }
        }
    }
} else {
    // Automatic linking, simply using the last defined material.
    #ifndef MATERIAL_DETECTOR
        printf("Need to define a material before the geometry to use automatic linking %s.\n",NAME_CURRENT_COMP);
        exit(1);
    #endif
    this_box_volume.p_physics = global_material_list.elements[global_material_list.num_elements-1].physics;
}

sprintf(this_box_volume.name,NAME_CURRENT_COMP);
sprintf(this_box_volume.geometry.shape,"box");
this_box_volume.geometry.priority_value = priority;
this_box_volume.geometry.geometry_p_interact = p_interact;
// Currently the coordinates will be in absolute space.
this_box_volume.geometry.center = POS_A_CURRENT_COMP;

this_box_storage.z_depth = zdepth;
this_box_storage.x_width1 = xwidth;
this_box_storage.y_height1 = yheight;

this_box_storage.is_rectangle = 0;
if (xwidth2 < 0 && yheight2 < 0) this_box_storage.is_rectangle = 1;
if (xwidth == xwidth2 && yheight == yheight2) this_box_storage.is_rectangle = 1;

if (xwidth2 < 0) {
    this_box_storage.x_width2 = xwidth;
    xwidth2 = xwidth;
} else this_box_storage.x_width2 = xwidth2;

if (yheight2 < 0) {
    this_box_storage.y_height2 = yheight;
    yheight2 = yheight;
} else this_box_storage.y_height2 = yheight2;


this_box_storage.normal_vectors[0] = coords_set(0,0,1);
this_box_storage.normal_vectors[1] = coords_set(0,0,1);

// for sides with y component = 0
x_component = 2*zdepth/sqrt((xwidth-xwidth2)*(xwidth-xwidth2)+4*zdepth*zdepth);
z_component = (xwidth-xwidth2)/sqrt(4*zdepth*zdepth+(xwidth-xwidth2)*(xwidth-xwidth2));

this_box_storage.normal_vectors[2] = coords_set(x_component,0,z_component);
this_box_storage.normal_vectors[3] = coords_set(-x_component,0,z_component);

// for sides with x component = 0
y_component = 2*zdepth/sqrt((yheight-yheight2)*(yheight-yheight2)+4*zdepth*zdepth);
z_component = (yheight-yheight2)/sqrt(4*zdepth*zdepth+(yheight-yheight2)*(yheight-yheight2));

this_box_storage.normal_vectors[4] = coords_set(0,y_component,z_component);
this_box_storage.normal_vectors[5] = coords_set(0,-y_component,z_component);

this_box_volume.geometry.visualization_on = visualize;

this_box_volume.geometry.geometry_parameters.p_box_storage = &this_box_storage;

// Assign pointers to functions for intersection with the shape, checking if a point is inside the shape
if (this_box_storage.is_rectangle == 1) {
this_box_volume.geometry.intersect_function = &sample_box_intersect_simple;
this_box_volume.geometry.within_function = &r_within_box_simple;
}
else {
this_box_volume.geometry.intersect_function = &sample_box_intersect_advanced;
this_box_volume.geometry.within_function = &r_within_box_advanced;
}

this_box_volume.geometry.shell_points = &box_shell_points;
this_box_volume.geometry.mcdisplay_function = &mcdisplay_box_function;
this_box_volume.geometry.initialize_from_main_function = &initialize_box_geometry_from_main_component;
this_box_volume.geometry.process_rot_allocated = 0;

this_box_volume.geometry.copy_geometry_parameters = &allocate_box_storage_copy;

rot_copy(this_box_volume.geometry.rotation_matrix,ROT_A_CURRENT_COMP); //check how ROT_R_CURRENT_COMP would work
rot_transpose(ROT_A_CURRENT_COMP,this_box_volume.geometry.transpose_rotation_matrix);

// Initialize loggers
this_box_volume.loggers.num_elements = 0;

// packing the information into the global_geometry_element, which is then included in the global_geometry_list.
sprintf(global_geometry_element.name,NAME_CURRENT_COMP);
global_geometry_element.activation_counter = number_of_activations;
global_geometry_element.component_index = INDEX_CURRENT_COMP;
global_geometry_element.Volume = &this_box_volume; // Would be nicer if this m was a pointer, now we have the (small) data two places
add_element_to_geometry_list(&global_geometry_list,global_geometry_element);
}
#line 328967 "MACS_sample_kidney_box.c"
#undef number_of_activations
#undef mask_setting
#undef mask_string
#undef p_interact
#undef focus_r
#undef focus_xh
#undef focus_xw
#undef focus_ah
#undef focus_aw
#undef target_z
#undef target_y
#undef target_x
#undef target_index
#undef visualize
#undef yheight2
#undef xwidth2
#undef zdepth
#undef yheight
#undef xwidth
#undef priority
#undef material_string
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

  /* Initializations for component channel_18_cave2_cyl1. */
  SIG_MESSAGE("channel_18_cave2_cyl1 (Init)");
#define mccompcurname  channel_18_cave2_cyl1
#define mccompcurtype  Union_cylinder
#define mccompcurindex 834
#define loop_index mccchannel_18_cave2_cyl1_loop_index
#define this_cylinder_volume mccchannel_18_cave2_cyl1_this_cylinder_volume
#define global_geometry_element mccchannel_18_cave2_cyl1_global_geometry_element
#define this_cylinder_storage mccchannel_18_cave2_cyl1_this_cylinder_storage
#define material_string mccchannel_18_cave2_cyl1_material_string
#define priority mccchannel_18_cave2_cyl1_priority
#define radius mccchannel_18_cave2_cyl1_radius
#define yheight mccchannel_18_cave2_cyl1_yheight
#define visualize mccchannel_18_cave2_cyl1_visualize
#define target_index mccchannel_18_cave2_cyl1_target_index
#define target_x mccchannel_18_cave2_cyl1_target_x
#define target_y mccchannel_18_cave2_cyl1_target_y
#define target_z mccchannel_18_cave2_cyl1_target_z
#define focus_aw mccchannel_18_cave2_cyl1_focus_aw
#define focus_ah mccchannel_18_cave2_cyl1_focus_ah
#define focus_xw mccchannel_18_cave2_cyl1_focus_xw
#define focus_xh mccchannel_18_cave2_cyl1_focus_xh
#define focus_r mccchannel_18_cave2_cyl1_focus_r
#define p_interact mccchannel_18_cave2_cyl1_p_interact
#define mask_string mccchannel_18_cave2_cyl1_mask_string
#define mask_setting mccchannel_18_cave2_cyl1_mask_setting
#define number_of_activations mccchannel_18_cave2_cyl1_number_of_activations
#line 185 "Union_cylinder.comp"
{
// Initializes the focusing system for this volume including input sanitation.
focus_initialize(&this_cylinder_volume.geometry, POS_A_COMP_INDEX(INDEX_CURRENT_COMP+target_index), POS_A_CURRENT_COMP, ROT_A_CURRENT_COMP, target_index, target_x, target_y, target_z, focus_aw, focus_ah, focus_xw, focus_xh, focus_r, NAME_CURRENT_COMP);

// Input sanitation for this geometry
if (radius <= 0) {
  printf("\nERROR in Union_cylinder named %s, the radius is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}

if (yheight <= 0) {
  printf("\nERROR in Union_cylinder named %s, yheight is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}

// Use sanitation
#ifdef MATERIAL_DETECTOR
if (global_material_list.num_elements == 0) {
  // Here if the user have defined a material, but only after this material
  printf("\nERROR: Need to define a material using Union_make_material before using a Union geometry component. \n");
  printf("       %s was defined before first use of Union_make_material.\n",NAME_CURRENT_COMP);
  exit(1);
}
#endif
#ifndef MATERIAL_DETECTOR
  printf("\nERROR: Need to define a material using Union_make_material before using a Union geometry component. \n");
  exit(1);
#endif


this_cylinder_volume.geometry.is_masked_volume = 0;
this_cylinder_volume.geometry.is_exit_volume = 0;
this_cylinder_volume.geometry.is_mask_volume = 0;

// Read the material input, or if it lacks, use automatic linking.
if (mask_string && strlen(mask_string) && strcmp(mask_string, "NULL") && strcmp(mask_string, "0")) {
    // A mask volume is used to limit the extend of other volumes, called the masked volumes. These are specified in the mask_string.
    // In order for a ray to enter a masked volume, it needs to be both in the region covered by that volume AND the mask volume.
    // When more than
    this_cylinder_volume.geometry.mask_mode = 1; // Default is mask mode is ALL
    if (mask_setting && strlen(mask_setting) && strcmp(mask_setting, "NULL") && strcmp(mask_setting, "0")) {
        if (strcmp(mask_setting,"ALL") == 0 || strcmp(mask_setting,"All") == 0) this_cylinder_volume.geometry.mask_mode = 1;
        else if (strcmp(mask_setting,"ANY") == 0 || strcmp(mask_setting,"Any") == 0) this_cylinder_volume.geometry.mask_mode = 2;
        else {
            printf("The mask_mode of component %s is set to %s, but must be either ALL or ANY.\n",NAME_CURRENT_COMP,mask_setting);
            exit(1);
        }
    }
    
    for (loop_index=0;loop_index<global_geometry_list.num_elements;loop_index++) {
        // Add mask list
        if (1 == manual_linking_function(global_geometry_list.elements[loop_index].name,mask_string)) {
            add_element_to_int_list(&this_cylinder_volume.geometry.mask_list,global_geometry_list.elements[loop_index].component_index);
            add_element_to_int_list(&global_geometry_list.elements[loop_index].Volume->geometry.masked_by_list,INDEX_CURRENT_COMP);
            global_geometry_list.elements[loop_index].Volume->geometry.is_masked_volume = 1;
            if (this_cylinder_volume.geometry.mask_mode == 2)
                global_geometry_list.elements[loop_index].Volume->geometry.mask_mode = 2;
            if (this_cylinder_volume.geometry.mask_mode == 1) {
                if (global_geometry_list.elements[loop_index].Volume->geometry.is_masked_volume == 1 && global_geometry_list.elements[loop_index].Volume->geometry.mask_mode != 2)
                    // If more than one mask is added to one volume, the ANY mode overwrites the (default) ALL mode.
                    global_geometry_list.elements[loop_index].Volume->geometry.mask_mode = 1;
            }
            
            found_geometries = 1;
        }
    }
    if (found_geometries == 0) {
        printf("The mask_string in geometry: %s did not find any of the specified volumes in the mask_string %s \n",NAME_CURRENT_COMP,mask_string);
        exit(1);
    }
    this_cylinder_volume.p_physics = malloc(sizeof(struct physics_struct));
    this_cylinder_volume.p_physics->is_vacuum = 0; // Makes this volume a vacuum
    this_cylinder_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
    this_cylinder_volume.p_physics->my_a = 0; // Should not be used.
    sprintf(this_cylinder_volume.p_physics->name,"Mask");
    this_cylinder_volume.geometry.is_mask_volume = 1;
    
    
// Read the material input, or if it lacks, use automatic linking.
} else if (material_string && strlen(material_string) && strcmp(material_string, "NULL") && strcmp(material_string, "0")) {
    // A geometry string was given, use it to determine which material
    if (0 == strcmp(material_string,"vacuum") || 0 == strcmp(material_string,"Vacuum")) {
        // One could have a global physics struct for vacuum instead of creating one for each
        this_cylinder_volume.p_physics = malloc(sizeof(struct physics_struct));
        this_cylinder_volume.p_physics->is_vacuum = 1; // Makes this volume a vacuum
        this_cylinder_volume.p_physics->number_of_processes = (int) 0;
        this_cylinder_volume.p_physics->my_a = 0; // Should not be used.
        sprintf(this_cylinder_volume.p_physics->name,"Vacuum");
    } else if (0 == strcmp(material_string,"exit") || 0 == strcmp(material_string,"Exit")) {
        // One could have a global physics struct for exit instead of creating one for each
        this_cylinder_volume.p_physics = malloc(sizeof(struct physics_struct));
        this_cylinder_volume.p_physics->is_vacuum = 1; // Makes this volume a vacuum
        this_cylinder_volume.p_physics->number_of_processes = (int) 0;
        this_cylinder_volume.p_physics->my_a = 0; // Should not be used.
        this_cylinder_volume.geometry.is_exit_volume = 1;
        sprintf(this_cylinder_volume.p_physics->name,"Exit");
    } else {
        for (loop_index=0;loop_index<global_material_list.num_elements;loop_index++) {
          if (0 == strcmp(material_string,global_material_list.elements[loop_index].name)) {
            this_cylinder_volume.p_physics = global_material_list.elements[loop_index].physics;
            break;
          }
          if (loop_index == global_material_list.num_elements-1) {
            printf("\n");
            printf("ERROR: The material string \"%s\" in Union geometry \"%s\" did not match a specified material. \n",material_string,NAME_CURRENT_COMP);
            printf("       The materials available at this point (need to be defined before the geometry): \n");
            for (loop_index=0;loop_index<global_material_list.num_elements;loop_index++)
              printf("         %s\n",global_material_list.elements[loop_index].name);
            printf("\n");
            printf("       It is also possible to use one of the defualt materials avaiable: \n");
            printf("           Vacuum (for a Volume without scattering or absorption)\n");
            printf("           Exit (for a Volume where the ray exits the component if it enters)\n");
            printf("           Mask (for a Volume that masks existing volumes specified in the mask_string\n");
            exit(1);
          }
        }
    }
} else {
    // Automatic linking, simply using the last defined material.
    #ifndef MATERIAL_DETECTOR
        printf("Need to define a material before the geometry to use automatic linking %s.\n",NAME_CURRENT_COMP);
        exit(1);
    #endif
    this_cylinder_volume.p_physics = global_material_list.elements[global_material_list.num_elements-1].physics;
}

sprintf(this_cylinder_volume.name,NAME_CURRENT_COMP);
sprintf(this_cylinder_volume.geometry.shape,"cylinder");
this_cylinder_volume.geometry.priority_value = priority;
// Currently the coordinates will be in absolute space.
this_cylinder_volume.geometry.center = POS_A_CURRENT_COMP;

this_cylinder_volume.geometry.geometry_p_interact = p_interact;
this_cylinder_storage.cyl_radius = radius;
this_cylinder_storage.height = yheight;
this_cylinder_volume.geometry.visualization_on = visualize;
this_cylinder_volume.geometry.geometry_parameters.p_cylinder_storage = &this_cylinder_storage;
this_cylinder_volume.geometry.within_function = &r_within_cylinder;
this_cylinder_volume.geometry.intersect_function = &sample_cylinder_intersect;
this_cylinder_volume.geometry.mcdisplay_function = &mcdisplay_cylinder_function;
this_cylinder_volume.geometry.shell_points = &cylinder_shell_points;
this_cylinder_volume.geometry.initialize_from_main_function = &initialize_cylinder_geometry_from_main_component;
this_cylinder_volume.geometry.process_rot_allocated = 0;
this_cylinder_volume.geometry.copy_geometry_parameters = &allocate_cylinder_storage_copy;

rot_copy(this_cylinder_volume.geometry.rotation_matrix,ROT_A_CURRENT_COMP);
rot_transpose(ROT_A_CURRENT_COMP,this_cylinder_volume.geometry.transpose_rotation_matrix);

// Initialize loggers
this_cylinder_volume.loggers.num_elements = 0;

// packing the information into the global_geometry_element, which is then included in the global_geometry_list.
sprintf(global_geometry_element.name,NAME_CURRENT_COMP);
global_geometry_element.activation_counter = number_of_activations;
global_geometry_element.component_index = INDEX_CURRENT_COMP;
global_geometry_element.Volume = &this_cylinder_volume; // Would be nicer if this m was a pointer, now we have the (small) data two places
add_element_to_geometry_list(&global_geometry_list,global_geometry_element);
}
#line 329183 "MACS_sample_kidney_box.c"
#undef number_of_activations
#undef mask_setting
#undef mask_string
#undef p_interact
#undef focus_r
#undef focus_xh
#undef focus_xw
#undef focus_ah
#undef focus_aw
#undef target_z
#undef target_y
#undef target_x
#undef target_index
#undef visualize
#undef yheight
#undef radius
#undef priority
#undef material_string
#undef this_cylinder_storage
#undef global_geometry_element
#undef this_cylinder_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

  /* Initializations for component channel_18_cave2_box1. */
  SIG_MESSAGE("channel_18_cave2_box1 (Init)");
#define mccompcurname  channel_18_cave2_box1
#define mccompcurtype  Union_box
#define mccompcurindex 835
#define loop_index mccchannel_18_cave2_box1_loop_index
#define this_box_volume mccchannel_18_cave2_box1_this_box_volume
#define global_geometry_element mccchannel_18_cave2_box1_global_geometry_element
#define this_box_storage mccchannel_18_cave2_box1_this_box_storage
#define material_string mccchannel_18_cave2_box1_material_string
#define priority mccchannel_18_cave2_box1_priority
#define xwidth mccchannel_18_cave2_box1_xwidth
#define yheight mccchannel_18_cave2_box1_yheight
#define zdepth mccchannel_18_cave2_box1_zdepth
#define xwidth2 mccchannel_18_cave2_box1_xwidth2
#define yheight2 mccchannel_18_cave2_box1_yheight2
#define visualize mccchannel_18_cave2_box1_visualize
#define target_index mccchannel_18_cave2_box1_target_index
#define target_x mccchannel_18_cave2_box1_target_x
#define target_y mccchannel_18_cave2_box1_target_y
#define target_z mccchannel_18_cave2_box1_target_z
#define focus_aw mccchannel_18_cave2_box1_focus_aw
#define focus_ah mccchannel_18_cave2_box1_focus_ah
#define focus_xw mccchannel_18_cave2_box1_focus_xw
#define focus_xh mccchannel_18_cave2_box1_focus_xh
#define focus_r mccchannel_18_cave2_box1_focus_r
#define p_interact mccchannel_18_cave2_box1_p_interact
#define mask_string mccchannel_18_cave2_box1_mask_string
#define mask_setting mccchannel_18_cave2_box1_mask_setting
#define number_of_activations mccchannel_18_cave2_box1_number_of_activations
#line 224 "Union_box.comp"
{
// Initializes the focusing system for this volume including input sanitation.
focus_initialize(&this_box_volume.geometry, POS_A_COMP_INDEX(INDEX_CURRENT_COMP+target_index), POS_A_CURRENT_COMP, ROT_A_CURRENT_COMP, target_index, target_x, target_y, target_z, focus_aw, focus_ah, focus_xw, focus_xh, focus_r, NAME_CURRENT_COMP);

// Input sanitation for this geometry
if (xwidth <= 0) {
  printf("\nERROR in Union_box named %s, the xwidth is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (yheight <= 0) {
  printf("\nERROR in Union_box named %s, yheight is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (zdepth <= 0) {
  printf("\nERROR in Union_box named %s, zdepth is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (xwidth2 <= 0 && xwidth2 != -1) {
  printf("\nERROR in Union_box named %s, the xwidth2 is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (yheight2 <= 0 && yheight2 != -1) {
  printf("\nERROR in Union_box named %s, yheight2 is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}

// Use sanitation
if (global_material_list.num_elements == 0) {
  printf("\nERROR: Need to define a material using Union_make_material before using a Union geometry component. \n");
  printf("       %s was defined before first use of Union_make_material.\n",NAME_CURRENT_COMP);
  exit(1);
}

this_box_volume.geometry.is_masked_volume = 0;
this_box_volume.geometry.is_exit_volume = 0;
this_box_volume.geometry.is_mask_volume = 0;
// check if the volume is a mask, if it is the material string is irelevant.
if (mask_string && strlen(mask_string) && strcmp(mask_string, "NULL") && strcmp(mask_string, "0")) {
    // A mask volume is used to limit the extend of other volumes, called the masked volumes. These are specified in the mask_string.
    // In order for a ray to enter a masked volume, it needs to be both in the region covered by that volume AND the mask volume.
    // When more than
    this_box_volume.geometry.mask_mode = 1; // Default is mask mode is ALL
    if (mask_setting && strlen(mask_setting) && strcmp(mask_setting, "NULL") && strcmp(mask_setting, "0")) {
        if (strcmp(mask_setting,"ALL") == 0 || strcmp(mask_setting,"All") == 0) this_box_volume.geometry.mask_mode = 1;
        else if (strcmp(mask_setting,"ANY") == 0 || strcmp(mask_setting,"Any") == 0) this_box_volume.geometry.mask_mode = 2;
        else {
            printf("The mask_mode of component %s is set to %s, but must be either ALL or ANY.\n",NAME_CURRENT_COMP,mask_setting);
            exit(1);
        }
    }
    
    for (loop_index=0;loop_index<global_geometry_list.num_elements;loop_index++) {
        // Add mask list
        if (1 == manual_linking_function(global_geometry_list.elements[loop_index].name,mask_string)) {
            add_element_to_int_list(&this_box_volume.geometry.mask_list,global_geometry_list.elements[loop_index].component_index);
            add_element_to_int_list(&global_geometry_list.elements[loop_index].Volume->geometry.masked_by_list,INDEX_CURRENT_COMP);
            global_geometry_list.elements[loop_index].Volume->geometry.is_masked_volume = 1;
            if (this_box_volume.geometry.mask_mode == 2)
                global_geometry_list.elements[loop_index].Volume->geometry.mask_mode = 2;
            if (this_box_volume.geometry.mask_mode == 1) {
                if (global_geometry_list.elements[loop_index].Volume->geometry.is_masked_volume == 1 && global_geometry_list.elements[loop_index].Volume->geometry.mask_mode != 2)
                    // If more than one mask is added to one volume, the ANY mode overwrites the (default) ALL mode.
                    global_geometry_list.elements[loop_index].Volume->geometry.mask_mode = 1;
            }
            
            found_geometries = 1;
        }
    }
    if (found_geometries == 0) {
        printf("The mask_string in geometry: %s did not find any of the specified volumes in the mask_string %s \n",NAME_CURRENT_COMP,mask_string);
        exit(1);
    }
    this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
    this_box_volume.p_physics->is_vacuum = 0; // Makes this volume a vacuum
    this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
    this_box_volume.p_physics->my_a = 0; // Should not be used.
    sprintf(this_box_volume.p_physics->name,"Mask");
    this_box_volume.geometry.is_mask_volume = 1;
    
    
// Read the material input, or if it lacks, use automatic linking.
} else if (material_string && strlen(material_string) && strcmp(material_string, "NULL") && strcmp(material_string, "0")) {
    // A geometry string was given, use it to determine which material
    if (0 == strcmp(material_string,"vacuum") || 0 == strcmp(material_string,"Vacuum")) {
        // One could have a global physics struct for vacuum instead of creating one for each
        this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
        this_box_volume.p_physics->is_vacuum = 1; // Makes this volume a vacuum
        this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
        this_box_volume.p_physics->my_a = 0; // Should not be used.
        sprintf(this_box_volume.p_physics->name,"Vacuum");
    } else if (0 == strcmp(material_string,"exit") || 0 == strcmp(material_string,"Exit")) {
        // One could have a global physics struct for vacuum instead of creating one for each
        this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
        this_box_volume.p_physics->is_vacuum = 1; // Makes this volume a vacuum
        this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
        this_box_volume.p_physics->my_a = 0; // Should not be used.
        this_box_volume.geometry.is_exit_volume = 1;
        sprintf(this_box_volume.p_physics->name,"Exit");
    } else {
        #ifndef MATERIAL_DETECTOR
            printf("Need to define a material before refering to it in a geometry %s.\n",NAME_CURRENT_COMP);
            exit(1);
        #endif
        for (loop_index=0;loop_index<global_material_list.num_elements;loop_index++) {
            if (0 == strcmp(material_string,global_material_list.elements[loop_index].name)) {
                this_box_volume.p_physics = global_material_list.elements[loop_index].physics;
                break;
            }
            if (loop_index == global_material_list.num_elements-1) {
            printf("\n");
            printf("ERROR: The material string \"%s\" in Union geometry \"%s\" did not match a specified material. \n",material_string,NAME_CURRENT_COMP);
            printf("       The materials available at this point (need to be defined before the geometry): \n");
            for (loop_index=0;loop_index<global_material_list.num_elements;loop_index++)
              printf("         %s\n",global_material_list.elements[loop_index].name);
            printf("\n");
            printf("       It is also possible to use one of the defualt materials avaiable: \n");
            printf("           Vacuum (for a Volume without scattering or absorption)\n");
            printf("           Exit (for a Volume where the ray exits the component if it enters)\n");
            printf("           Mask (for a Volume that masks existing volumes specified in the mask_string\n");
            exit(1);
          }
        }
    }
} else {
    // Automatic linking, simply using the last defined material.
    #ifndef MATERIAL_DETECTOR
        printf("Need to define a material before the geometry to use automatic linking %s.\n",NAME_CURRENT_COMP);
        exit(1);
    #endif
    this_box_volume.p_physics = global_material_list.elements[global_material_list.num_elements-1].physics;
}

sprintf(this_box_volume.name,NAME_CURRENT_COMP);
sprintf(this_box_volume.geometry.shape,"box");
this_box_volume.geometry.priority_value = priority;
this_box_volume.geometry.geometry_p_interact = p_interact;
// Currently the coordinates will be in absolute space.
this_box_volume.geometry.center = POS_A_CURRENT_COMP;

this_box_storage.z_depth = zdepth;
this_box_storage.x_width1 = xwidth;
this_box_storage.y_height1 = yheight;

this_box_storage.is_rectangle = 0;
if (xwidth2 < 0 && yheight2 < 0) this_box_storage.is_rectangle = 1;
if (xwidth == xwidth2 && yheight == yheight2) this_box_storage.is_rectangle = 1;

if (xwidth2 < 0) {
    this_box_storage.x_width2 = xwidth;
    xwidth2 = xwidth;
} else this_box_storage.x_width2 = xwidth2;

if (yheight2 < 0) {
    this_box_storage.y_height2 = yheight;
    yheight2 = yheight;
} else this_box_storage.y_height2 = yheight2;


this_box_storage.normal_vectors[0] = coords_set(0,0,1);
this_box_storage.normal_vectors[1] = coords_set(0,0,1);

// for sides with y component = 0
x_component = 2*zdepth/sqrt((xwidth-xwidth2)*(xwidth-xwidth2)+4*zdepth*zdepth);
z_component = (xwidth-xwidth2)/sqrt(4*zdepth*zdepth+(xwidth-xwidth2)*(xwidth-xwidth2));

this_box_storage.normal_vectors[2] = coords_set(x_component,0,z_component);
this_box_storage.normal_vectors[3] = coords_set(-x_component,0,z_component);

// for sides with x component = 0
y_component = 2*zdepth/sqrt((yheight-yheight2)*(yheight-yheight2)+4*zdepth*zdepth);
z_component = (yheight-yheight2)/sqrt(4*zdepth*zdepth+(yheight-yheight2)*(yheight-yheight2));

this_box_storage.normal_vectors[4] = coords_set(0,y_component,z_component);
this_box_storage.normal_vectors[5] = coords_set(0,-y_component,z_component);

this_box_volume.geometry.visualization_on = visualize;

this_box_volume.geometry.geometry_parameters.p_box_storage = &this_box_storage;

// Assign pointers to functions for intersection with the shape, checking if a point is inside the shape
if (this_box_storage.is_rectangle == 1) {
this_box_volume.geometry.intersect_function = &sample_box_intersect_simple;
this_box_volume.geometry.within_function = &r_within_box_simple;
}
else {
this_box_volume.geometry.intersect_function = &sample_box_intersect_advanced;
this_box_volume.geometry.within_function = &r_within_box_advanced;
}

this_box_volume.geometry.shell_points = &box_shell_points;
this_box_volume.geometry.mcdisplay_function = &mcdisplay_box_function;
this_box_volume.geometry.initialize_from_main_function = &initialize_box_geometry_from_main_component;
this_box_volume.geometry.process_rot_allocated = 0;

this_box_volume.geometry.copy_geometry_parameters = &allocate_box_storage_copy;

rot_copy(this_box_volume.geometry.rotation_matrix,ROT_A_CURRENT_COMP); //check how ROT_R_CURRENT_COMP would work
rot_transpose(ROT_A_CURRENT_COMP,this_box_volume.geometry.transpose_rotation_matrix);

// Initialize loggers
this_box_volume.loggers.num_elements = 0;

// packing the information into the global_geometry_element, which is then included in the global_geometry_list.
sprintf(global_geometry_element.name,NAME_CURRENT_COMP);
global_geometry_element.activation_counter = number_of_activations;
global_geometry_element.component_index = INDEX_CURRENT_COMP;
global_geometry_element.Volume = &this_box_volume; // Would be nicer if this m was a pointer, now we have the (small) data two places
add_element_to_geometry_list(&global_geometry_list,global_geometry_element);
}
#line 329450 "MACS_sample_kidney_box.c"
#undef number_of_activations
#undef mask_setting
#undef mask_string
#undef p_interact
#undef focus_r
#undef focus_xh
#undef focus_xw
#undef focus_ah
#undef focus_aw
#undef target_z
#undef target_y
#undef target_x
#undef target_index
#undef visualize
#undef yheight2
#undef xwidth2
#undef zdepth
#undef yheight
#undef xwidth
#undef priority
#undef material_string
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

  /* Initializations for component channel_18_cave2_box2. */
  SIG_MESSAGE("channel_18_cave2_box2 (Init)");
#define mccompcurname  channel_18_cave2_box2
#define mccompcurtype  Union_box
#define mccompcurindex 836
#define loop_index mccchannel_18_cave2_box2_loop_index
#define this_box_volume mccchannel_18_cave2_box2_this_box_volume
#define global_geometry_element mccchannel_18_cave2_box2_global_geometry_element
#define this_box_storage mccchannel_18_cave2_box2_this_box_storage
#define material_string mccchannel_18_cave2_box2_material_string
#define priority mccchannel_18_cave2_box2_priority
#define xwidth mccchannel_18_cave2_box2_xwidth
#define yheight mccchannel_18_cave2_box2_yheight
#define zdepth mccchannel_18_cave2_box2_zdepth
#define xwidth2 mccchannel_18_cave2_box2_xwidth2
#define yheight2 mccchannel_18_cave2_box2_yheight2
#define visualize mccchannel_18_cave2_box2_visualize
#define target_index mccchannel_18_cave2_box2_target_index
#define target_x mccchannel_18_cave2_box2_target_x
#define target_y mccchannel_18_cave2_box2_target_y
#define target_z mccchannel_18_cave2_box2_target_z
#define focus_aw mccchannel_18_cave2_box2_focus_aw
#define focus_ah mccchannel_18_cave2_box2_focus_ah
#define focus_xw mccchannel_18_cave2_box2_focus_xw
#define focus_xh mccchannel_18_cave2_box2_focus_xh
#define focus_r mccchannel_18_cave2_box2_focus_r
#define p_interact mccchannel_18_cave2_box2_p_interact
#define mask_string mccchannel_18_cave2_box2_mask_string
#define mask_setting mccchannel_18_cave2_box2_mask_setting
#define number_of_activations mccchannel_18_cave2_box2_number_of_activations
#line 224 "Union_box.comp"
{
// Initializes the focusing system for this volume including input sanitation.
focus_initialize(&this_box_volume.geometry, POS_A_COMP_INDEX(INDEX_CURRENT_COMP+target_index), POS_A_CURRENT_COMP, ROT_A_CURRENT_COMP, target_index, target_x, target_y, target_z, focus_aw, focus_ah, focus_xw, focus_xh, focus_r, NAME_CURRENT_COMP);

// Input sanitation for this geometry
if (xwidth <= 0) {
  printf("\nERROR in Union_box named %s, the xwidth is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (yheight <= 0) {
  printf("\nERROR in Union_box named %s, yheight is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (zdepth <= 0) {
  printf("\nERROR in Union_box named %s, zdepth is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (xwidth2 <= 0 && xwidth2 != -1) {
  printf("\nERROR in Union_box named %s, the xwidth2 is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (yheight2 <= 0 && yheight2 != -1) {
  printf("\nERROR in Union_box named %s, yheight2 is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}

// Use sanitation
if (global_material_list.num_elements == 0) {
  printf("\nERROR: Need to define a material using Union_make_material before using a Union geometry component. \n");
  printf("       %s was defined before first use of Union_make_material.\n",NAME_CURRENT_COMP);
  exit(1);
}

this_box_volume.geometry.is_masked_volume = 0;
this_box_volume.geometry.is_exit_volume = 0;
this_box_volume.geometry.is_mask_volume = 0;
// check if the volume is a mask, if it is the material string is irelevant.
if (mask_string && strlen(mask_string) && strcmp(mask_string, "NULL") && strcmp(mask_string, "0")) {
    // A mask volume is used to limit the extend of other volumes, called the masked volumes. These are specified in the mask_string.
    // In order for a ray to enter a masked volume, it needs to be both in the region covered by that volume AND the mask volume.
    // When more than
    this_box_volume.geometry.mask_mode = 1; // Default is mask mode is ALL
    if (mask_setting && strlen(mask_setting) && strcmp(mask_setting, "NULL") && strcmp(mask_setting, "0")) {
        if (strcmp(mask_setting,"ALL") == 0 || strcmp(mask_setting,"All") == 0) this_box_volume.geometry.mask_mode = 1;
        else if (strcmp(mask_setting,"ANY") == 0 || strcmp(mask_setting,"Any") == 0) this_box_volume.geometry.mask_mode = 2;
        else {
            printf("The mask_mode of component %s is set to %s, but must be either ALL or ANY.\n",NAME_CURRENT_COMP,mask_setting);
            exit(1);
        }
    }
    
    for (loop_index=0;loop_index<global_geometry_list.num_elements;loop_index++) {
        // Add mask list
        if (1 == manual_linking_function(global_geometry_list.elements[loop_index].name,mask_string)) {
            add_element_to_int_list(&this_box_volume.geometry.mask_list,global_geometry_list.elements[loop_index].component_index);
            add_element_to_int_list(&global_geometry_list.elements[loop_index].Volume->geometry.masked_by_list,INDEX_CURRENT_COMP);
            global_geometry_list.elements[loop_index].Volume->geometry.is_masked_volume = 1;
            if (this_box_volume.geometry.mask_mode == 2)
                global_geometry_list.elements[loop_index].Volume->geometry.mask_mode = 2;
            if (this_box_volume.geometry.mask_mode == 1) {
                if (global_geometry_list.elements[loop_index].Volume->geometry.is_masked_volume == 1 && global_geometry_list.elements[loop_index].Volume->geometry.mask_mode != 2)
                    // If more than one mask is added to one volume, the ANY mode overwrites the (default) ALL mode.
                    global_geometry_list.elements[loop_index].Volume->geometry.mask_mode = 1;
            }
            
            found_geometries = 1;
        }
    }
    if (found_geometries == 0) {
        printf("The mask_string in geometry: %s did not find any of the specified volumes in the mask_string %s \n",NAME_CURRENT_COMP,mask_string);
        exit(1);
    }
    this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
    this_box_volume.p_physics->is_vacuum = 0; // Makes this volume a vacuum
    this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
    this_box_volume.p_physics->my_a = 0; // Should not be used.
    sprintf(this_box_volume.p_physics->name,"Mask");
    this_box_volume.geometry.is_mask_volume = 1;
    
    
// Read the material input, or if it lacks, use automatic linking.
} else if (material_string && strlen(material_string) && strcmp(material_string, "NULL") && strcmp(material_string, "0")) {
    // A geometry string was given, use it to determine which material
    if (0 == strcmp(material_string,"vacuum") || 0 == strcmp(material_string,"Vacuum")) {
        // One could have a global physics struct for vacuum instead of creating one for each
        this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
        this_box_volume.p_physics->is_vacuum = 1; // Makes this volume a vacuum
        this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
        this_box_volume.p_physics->my_a = 0; // Should not be used.
        sprintf(this_box_volume.p_physics->name,"Vacuum");
    } else if (0 == strcmp(material_string,"exit") || 0 == strcmp(material_string,"Exit")) {
        // One could have a global physics struct for vacuum instead of creating one for each
        this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
        this_box_volume.p_physics->is_vacuum = 1; // Makes this volume a vacuum
        this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
        this_box_volume.p_physics->my_a = 0; // Should not be used.
        this_box_volume.geometry.is_exit_volume = 1;
        sprintf(this_box_volume.p_physics->name,"Exit");
    } else {
        #ifndef MATERIAL_DETECTOR
            printf("Need to define a material before refering to it in a geometry %s.\n",NAME_CURRENT_COMP);
            exit(1);
        #endif
        for (loop_index=0;loop_index<global_material_list.num_elements;loop_index++) {
            if (0 == strcmp(material_string,global_material_list.elements[loop_index].name)) {
                this_box_volume.p_physics = global_material_list.elements[loop_index].physics;
                break;
            }
            if (loop_index == global_material_list.num_elements-1) {
            printf("\n");
            printf("ERROR: The material string \"%s\" in Union geometry \"%s\" did not match a specified material. \n",material_string,NAME_CURRENT_COMP);
            printf("       The materials available at this point (need to be defined before the geometry): \n");
            for (loop_index=0;loop_index<global_material_list.num_elements;loop_index++)
              printf("         %s\n",global_material_list.elements[loop_index].name);
            printf("\n");
            printf("       It is also possible to use one of the defualt materials avaiable: \n");
            printf("           Vacuum (for a Volume without scattering or absorption)\n");
            printf("           Exit (for a Volume where the ray exits the component if it enters)\n");
            printf("           Mask (for a Volume that masks existing volumes specified in the mask_string\n");
            exit(1);
          }
        }
    }
} else {
    // Automatic linking, simply using the last defined material.
    #ifndef MATERIAL_DETECTOR
        printf("Need to define a material before the geometry to use automatic linking %s.\n",NAME_CURRENT_COMP);
        exit(1);
    #endif
    this_box_volume.p_physics = global_material_list.elements[global_material_list.num_elements-1].physics;
}

sprintf(this_box_volume.name,NAME_CURRENT_COMP);
sprintf(this_box_volume.geometry.shape,"box");
this_box_volume.geometry.priority_value = priority;
this_box_volume.geometry.geometry_p_interact = p_interact;
// Currently the coordinates will be in absolute space.
this_box_volume.geometry.center = POS_A_CURRENT_COMP;

this_box_storage.z_depth = zdepth;
this_box_storage.x_width1 = xwidth;
this_box_storage.y_height1 = yheight;

this_box_storage.is_rectangle = 0;
if (xwidth2 < 0 && yheight2 < 0) this_box_storage.is_rectangle = 1;
if (xwidth == xwidth2 && yheight == yheight2) this_box_storage.is_rectangle = 1;

if (xwidth2 < 0) {
    this_box_storage.x_width2 = xwidth;
    xwidth2 = xwidth;
} else this_box_storage.x_width2 = xwidth2;

if (yheight2 < 0) {
    this_box_storage.y_height2 = yheight;
    yheight2 = yheight;
} else this_box_storage.y_height2 = yheight2;


this_box_storage.normal_vectors[0] = coords_set(0,0,1);
this_box_storage.normal_vectors[1] = coords_set(0,0,1);

// for sides with y component = 0
x_component = 2*zdepth/sqrt((xwidth-xwidth2)*(xwidth-xwidth2)+4*zdepth*zdepth);
z_component = (xwidth-xwidth2)/sqrt(4*zdepth*zdepth+(xwidth-xwidth2)*(xwidth-xwidth2));

this_box_storage.normal_vectors[2] = coords_set(x_component,0,z_component);
this_box_storage.normal_vectors[3] = coords_set(-x_component,0,z_component);

// for sides with x component = 0
y_component = 2*zdepth/sqrt((yheight-yheight2)*(yheight-yheight2)+4*zdepth*zdepth);
z_component = (yheight-yheight2)/sqrt(4*zdepth*zdepth+(yheight-yheight2)*(yheight-yheight2));

this_box_storage.normal_vectors[4] = coords_set(0,y_component,z_component);
this_box_storage.normal_vectors[5] = coords_set(0,-y_component,z_component);

this_box_volume.geometry.visualization_on = visualize;

this_box_volume.geometry.geometry_parameters.p_box_storage = &this_box_storage;

// Assign pointers to functions for intersection with the shape, checking if a point is inside the shape
if (this_box_storage.is_rectangle == 1) {
this_box_volume.geometry.intersect_function = &sample_box_intersect_simple;
this_box_volume.geometry.within_function = &r_within_box_simple;
}
else {
this_box_volume.geometry.intersect_function = &sample_box_intersect_advanced;
this_box_volume.geometry.within_function = &r_within_box_advanced;
}

this_box_volume.geometry.shell_points = &box_shell_points;
this_box_volume.geometry.mcdisplay_function = &mcdisplay_box_function;
this_box_volume.geometry.initialize_from_main_function = &initialize_box_geometry_from_main_component;
this_box_volume.geometry.process_rot_allocated = 0;

this_box_volume.geometry.copy_geometry_parameters = &allocate_box_storage_copy;

rot_copy(this_box_volume.geometry.rotation_matrix,ROT_A_CURRENT_COMP); //check how ROT_R_CURRENT_COMP would work
rot_transpose(ROT_A_CURRENT_COMP,this_box_volume.geometry.transpose_rotation_matrix);

// Initialize loggers
this_box_volume.loggers.num_elements = 0;

// packing the information into the global_geometry_element, which is then included in the global_geometry_list.
sprintf(global_geometry_element.name,NAME_CURRENT_COMP);
global_geometry_element.activation_counter = number_of_activations;
global_geometry_element.component_index = INDEX_CURRENT_COMP;
global_geometry_element.Volume = &this_box_volume; // Would be nicer if this m was a pointer, now we have the (small) data two places
add_element_to_geometry_list(&global_geometry_list,global_geometry_element);
}
#line 329720 "MACS_sample_kidney_box.c"
#undef number_of_activations
#undef mask_setting
#undef mask_string
#undef p_interact
#undef focus_r
#undef focus_xh
#undef focus_xw
#undef focus_ah
#undef focus_aw
#undef target_z
#undef target_y
#undef target_x
#undef target_index
#undef visualize
#undef yheight2
#undef xwidth2
#undef zdepth
#undef yheight
#undef xwidth
#undef priority
#undef material_string
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

  /* Initializations for component channel_18_cave2_box3. */
  SIG_MESSAGE("channel_18_cave2_box3 (Init)");
#define mccompcurname  channel_18_cave2_box3
#define mccompcurtype  Union_box
#define mccompcurindex 837
#define loop_index mccchannel_18_cave2_box3_loop_index
#define this_box_volume mccchannel_18_cave2_box3_this_box_volume
#define global_geometry_element mccchannel_18_cave2_box3_global_geometry_element
#define this_box_storage mccchannel_18_cave2_box3_this_box_storage
#define material_string mccchannel_18_cave2_box3_material_string
#define priority mccchannel_18_cave2_box3_priority
#define xwidth mccchannel_18_cave2_box3_xwidth
#define yheight mccchannel_18_cave2_box3_yheight
#define zdepth mccchannel_18_cave2_box3_zdepth
#define xwidth2 mccchannel_18_cave2_box3_xwidth2
#define yheight2 mccchannel_18_cave2_box3_yheight2
#define visualize mccchannel_18_cave2_box3_visualize
#define target_index mccchannel_18_cave2_box3_target_index
#define target_x mccchannel_18_cave2_box3_target_x
#define target_y mccchannel_18_cave2_box3_target_y
#define target_z mccchannel_18_cave2_box3_target_z
#define focus_aw mccchannel_18_cave2_box3_focus_aw
#define focus_ah mccchannel_18_cave2_box3_focus_ah
#define focus_xw mccchannel_18_cave2_box3_focus_xw
#define focus_xh mccchannel_18_cave2_box3_focus_xh
#define focus_r mccchannel_18_cave2_box3_focus_r
#define p_interact mccchannel_18_cave2_box3_p_interact
#define mask_string mccchannel_18_cave2_box3_mask_string
#define mask_setting mccchannel_18_cave2_box3_mask_setting
#define number_of_activations mccchannel_18_cave2_box3_number_of_activations
#line 224 "Union_box.comp"
{
// Initializes the focusing system for this volume including input sanitation.
focus_initialize(&this_box_volume.geometry, POS_A_COMP_INDEX(INDEX_CURRENT_COMP+target_index), POS_A_CURRENT_COMP, ROT_A_CURRENT_COMP, target_index, target_x, target_y, target_z, focus_aw, focus_ah, focus_xw, focus_xh, focus_r, NAME_CURRENT_COMP);

// Input sanitation for this geometry
if (xwidth <= 0) {
  printf("\nERROR in Union_box named %s, the xwidth is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (yheight <= 0) {
  printf("\nERROR in Union_box named %s, yheight is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (zdepth <= 0) {
  printf("\nERROR in Union_box named %s, zdepth is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (xwidth2 <= 0 && xwidth2 != -1) {
  printf("\nERROR in Union_box named %s, the xwidth2 is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (yheight2 <= 0 && yheight2 != -1) {
  printf("\nERROR in Union_box named %s, yheight2 is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}

// Use sanitation
if (global_material_list.num_elements == 0) {
  printf("\nERROR: Need to define a material using Union_make_material before using a Union geometry component. \n");
  printf("       %s was defined before first use of Union_make_material.\n",NAME_CURRENT_COMP);
  exit(1);
}

this_box_volume.geometry.is_masked_volume = 0;
this_box_volume.geometry.is_exit_volume = 0;
this_box_volume.geometry.is_mask_volume = 0;
// check if the volume is a mask, if it is the material string is irelevant.
if (mask_string && strlen(mask_string) && strcmp(mask_string, "NULL") && strcmp(mask_string, "0")) {
    // A mask volume is used to limit the extend of other volumes, called the masked volumes. These are specified in the mask_string.
    // In order for a ray to enter a masked volume, it needs to be both in the region covered by that volume AND the mask volume.
    // When more than
    this_box_volume.geometry.mask_mode = 1; // Default is mask mode is ALL
    if (mask_setting && strlen(mask_setting) && strcmp(mask_setting, "NULL") && strcmp(mask_setting, "0")) {
        if (strcmp(mask_setting,"ALL") == 0 || strcmp(mask_setting,"All") == 0) this_box_volume.geometry.mask_mode = 1;
        else if (strcmp(mask_setting,"ANY") == 0 || strcmp(mask_setting,"Any") == 0) this_box_volume.geometry.mask_mode = 2;
        else {
            printf("The mask_mode of component %s is set to %s, but must be either ALL or ANY.\n",NAME_CURRENT_COMP,mask_setting);
            exit(1);
        }
    }
    
    for (loop_index=0;loop_index<global_geometry_list.num_elements;loop_index++) {
        // Add mask list
        if (1 == manual_linking_function(global_geometry_list.elements[loop_index].name,mask_string)) {
            add_element_to_int_list(&this_box_volume.geometry.mask_list,global_geometry_list.elements[loop_index].component_index);
            add_element_to_int_list(&global_geometry_list.elements[loop_index].Volume->geometry.masked_by_list,INDEX_CURRENT_COMP);
            global_geometry_list.elements[loop_index].Volume->geometry.is_masked_volume = 1;
            if (this_box_volume.geometry.mask_mode == 2)
                global_geometry_list.elements[loop_index].Volume->geometry.mask_mode = 2;
            if (this_box_volume.geometry.mask_mode == 1) {
                if (global_geometry_list.elements[loop_index].Volume->geometry.is_masked_volume == 1 && global_geometry_list.elements[loop_index].Volume->geometry.mask_mode != 2)
                    // If more than one mask is added to one volume, the ANY mode overwrites the (default) ALL mode.
                    global_geometry_list.elements[loop_index].Volume->geometry.mask_mode = 1;
            }
            
            found_geometries = 1;
        }
    }
    if (found_geometries == 0) {
        printf("The mask_string in geometry: %s did not find any of the specified volumes in the mask_string %s \n",NAME_CURRENT_COMP,mask_string);
        exit(1);
    }
    this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
    this_box_volume.p_physics->is_vacuum = 0; // Makes this volume a vacuum
    this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
    this_box_volume.p_physics->my_a = 0; // Should not be used.
    sprintf(this_box_volume.p_physics->name,"Mask");
    this_box_volume.geometry.is_mask_volume = 1;
    
    
// Read the material input, or if it lacks, use automatic linking.
} else if (material_string && strlen(material_string) && strcmp(material_string, "NULL") && strcmp(material_string, "0")) {
    // A geometry string was given, use it to determine which material
    if (0 == strcmp(material_string,"vacuum") || 0 == strcmp(material_string,"Vacuum")) {
        // One could have a global physics struct for vacuum instead of creating one for each
        this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
        this_box_volume.p_physics->is_vacuum = 1; // Makes this volume a vacuum
        this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
        this_box_volume.p_physics->my_a = 0; // Should not be used.
        sprintf(this_box_volume.p_physics->name,"Vacuum");
    } else if (0 == strcmp(material_string,"exit") || 0 == strcmp(material_string,"Exit")) {
        // One could have a global physics struct for vacuum instead of creating one for each
        this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
        this_box_volume.p_physics->is_vacuum = 1; // Makes this volume a vacuum
        this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
        this_box_volume.p_physics->my_a = 0; // Should not be used.
        this_box_volume.geometry.is_exit_volume = 1;
        sprintf(this_box_volume.p_physics->name,"Exit");
    } else {
        #ifndef MATERIAL_DETECTOR
            printf("Need to define a material before refering to it in a geometry %s.\n",NAME_CURRENT_COMP);
            exit(1);
        #endif
        for (loop_index=0;loop_index<global_material_list.num_elements;loop_index++) {
            if (0 == strcmp(material_string,global_material_list.elements[loop_index].name)) {
                this_box_volume.p_physics = global_material_list.elements[loop_index].physics;
                break;
            }
            if (loop_index == global_material_list.num_elements-1) {
            printf("\n");
            printf("ERROR: The material string \"%s\" in Union geometry \"%s\" did not match a specified material. \n",material_string,NAME_CURRENT_COMP);
            printf("       The materials available at this point (need to be defined before the geometry): \n");
            for (loop_index=0;loop_index<global_material_list.num_elements;loop_index++)
              printf("         %s\n",global_material_list.elements[loop_index].name);
            printf("\n");
            printf("       It is also possible to use one of the defualt materials avaiable: \n");
            printf("           Vacuum (for a Volume without scattering or absorption)\n");
            printf("           Exit (for a Volume where the ray exits the component if it enters)\n");
            printf("           Mask (for a Volume that masks existing volumes specified in the mask_string\n");
            exit(1);
          }
        }
    }
} else {
    // Automatic linking, simply using the last defined material.
    #ifndef MATERIAL_DETECTOR
        printf("Need to define a material before the geometry to use automatic linking %s.\n",NAME_CURRENT_COMP);
        exit(1);
    #endif
    this_box_volume.p_physics = global_material_list.elements[global_material_list.num_elements-1].physics;
}

sprintf(this_box_volume.name,NAME_CURRENT_COMP);
sprintf(this_box_volume.geometry.shape,"box");
this_box_volume.geometry.priority_value = priority;
this_box_volume.geometry.geometry_p_interact = p_interact;
// Currently the coordinates will be in absolute space.
this_box_volume.geometry.center = POS_A_CURRENT_COMP;

this_box_storage.z_depth = zdepth;
this_box_storage.x_width1 = xwidth;
this_box_storage.y_height1 = yheight;

this_box_storage.is_rectangle = 0;
if (xwidth2 < 0 && yheight2 < 0) this_box_storage.is_rectangle = 1;
if (xwidth == xwidth2 && yheight == yheight2) this_box_storage.is_rectangle = 1;

if (xwidth2 < 0) {
    this_box_storage.x_width2 = xwidth;
    xwidth2 = xwidth;
} else this_box_storage.x_width2 = xwidth2;

if (yheight2 < 0) {
    this_box_storage.y_height2 = yheight;
    yheight2 = yheight;
} else this_box_storage.y_height2 = yheight2;


this_box_storage.normal_vectors[0] = coords_set(0,0,1);
this_box_storage.normal_vectors[1] = coords_set(0,0,1);

// for sides with y component = 0
x_component = 2*zdepth/sqrt((xwidth-xwidth2)*(xwidth-xwidth2)+4*zdepth*zdepth);
z_component = (xwidth-xwidth2)/sqrt(4*zdepth*zdepth+(xwidth-xwidth2)*(xwidth-xwidth2));

this_box_storage.normal_vectors[2] = coords_set(x_component,0,z_component);
this_box_storage.normal_vectors[3] = coords_set(-x_component,0,z_component);

// for sides with x component = 0
y_component = 2*zdepth/sqrt((yheight-yheight2)*(yheight-yheight2)+4*zdepth*zdepth);
z_component = (yheight-yheight2)/sqrt(4*zdepth*zdepth+(yheight-yheight2)*(yheight-yheight2));

this_box_storage.normal_vectors[4] = coords_set(0,y_component,z_component);
this_box_storage.normal_vectors[5] = coords_set(0,-y_component,z_component);

this_box_volume.geometry.visualization_on = visualize;

this_box_volume.geometry.geometry_parameters.p_box_storage = &this_box_storage;

// Assign pointers to functions for intersection with the shape, checking if a point is inside the shape
if (this_box_storage.is_rectangle == 1) {
this_box_volume.geometry.intersect_function = &sample_box_intersect_simple;
this_box_volume.geometry.within_function = &r_within_box_simple;
}
else {
this_box_volume.geometry.intersect_function = &sample_box_intersect_advanced;
this_box_volume.geometry.within_function = &r_within_box_advanced;
}

this_box_volume.geometry.shell_points = &box_shell_points;
this_box_volume.geometry.mcdisplay_function = &mcdisplay_box_function;
this_box_volume.geometry.initialize_from_main_function = &initialize_box_geometry_from_main_component;
this_box_volume.geometry.process_rot_allocated = 0;

this_box_volume.geometry.copy_geometry_parameters = &allocate_box_storage_copy;

rot_copy(this_box_volume.geometry.rotation_matrix,ROT_A_CURRENT_COMP); //check how ROT_R_CURRENT_COMP would work
rot_transpose(ROT_A_CURRENT_COMP,this_box_volume.geometry.transpose_rotation_matrix);

// Initialize loggers
this_box_volume.loggers.num_elements = 0;

// packing the information into the global_geometry_element, which is then included in the global_geometry_list.
sprintf(global_geometry_element.name,NAME_CURRENT_COMP);
global_geometry_element.activation_counter = number_of_activations;
global_geometry_element.component_index = INDEX_CURRENT_COMP;
global_geometry_element.Volume = &this_box_volume; // Would be nicer if this m was a pointer, now we have the (small) data two places
add_element_to_geometry_list(&global_geometry_list,global_geometry_element);
}
#line 329990 "MACS_sample_kidney_box.c"
#undef number_of_activations
#undef mask_setting
#undef mask_string
#undef p_interact
#undef focus_r
#undef focus_xh
#undef focus_xw
#undef focus_ah
#undef focus_aw
#undef target_z
#undef target_y
#undef target_x
#undef target_index
#undef visualize
#undef yheight2
#undef xwidth2
#undef zdepth
#undef yheight
#undef xwidth
#undef priority
#undef material_string
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

  /* Initializations for component inter_analyzer_colimator_center_18. */
  SIG_MESSAGE("inter_analyzer_colimator_center_18 (Init)");

  /* Initializations for component inter_analyzer_colimator_18_blade_0. */
  SIG_MESSAGE("inter_analyzer_colimator_18_blade_0 (Init)");
#define mccompcurname  inter_analyzer_colimator_18_blade_0
#define mccompcurtype  Union_box
#define mccompcurindex 839
#define loop_index mccinter_analyzer_colimator_18_blade_0_loop_index
#define this_box_volume mccinter_analyzer_colimator_18_blade_0_this_box_volume
#define global_geometry_element mccinter_analyzer_colimator_18_blade_0_global_geometry_element
#define this_box_storage mccinter_analyzer_colimator_18_blade_0_this_box_storage
#define material_string mccinter_analyzer_colimator_18_blade_0_material_string
#define priority mccinter_analyzer_colimator_18_blade_0_priority
#define xwidth mccinter_analyzer_colimator_18_blade_0_xwidth
#define yheight mccinter_analyzer_colimator_18_blade_0_yheight
#define zdepth mccinter_analyzer_colimator_18_blade_0_zdepth
#define xwidth2 mccinter_analyzer_colimator_18_blade_0_xwidth2
#define yheight2 mccinter_analyzer_colimator_18_blade_0_yheight2
#define visualize mccinter_analyzer_colimator_18_blade_0_visualize
#define target_index mccinter_analyzer_colimator_18_blade_0_target_index
#define target_x mccinter_analyzer_colimator_18_blade_0_target_x
#define target_y mccinter_analyzer_colimator_18_blade_0_target_y
#define target_z mccinter_analyzer_colimator_18_blade_0_target_z
#define focus_aw mccinter_analyzer_colimator_18_blade_0_focus_aw
#define focus_ah mccinter_analyzer_colimator_18_blade_0_focus_ah
#define focus_xw mccinter_analyzer_colimator_18_blade_0_focus_xw
#define focus_xh mccinter_analyzer_colimator_18_blade_0_focus_xh
#define focus_r mccinter_analyzer_colimator_18_blade_0_focus_r
#define p_interact mccinter_analyzer_colimator_18_blade_0_p_interact
#define mask_string mccinter_analyzer_colimator_18_blade_0_mask_string
#define mask_setting mccinter_analyzer_colimator_18_blade_0_mask_setting
#define number_of_activations mccinter_analyzer_colimator_18_blade_0_number_of_activations
#line 224 "Union_box.comp"
{
// Initializes the focusing system for this volume including input sanitation.
focus_initialize(&this_box_volume.geometry, POS_A_COMP_INDEX(INDEX_CURRENT_COMP+target_index), POS_A_CURRENT_COMP, ROT_A_CURRENT_COMP, target_index, target_x, target_y, target_z, focus_aw, focus_ah, focus_xw, focus_xh, focus_r, NAME_CURRENT_COMP);

// Input sanitation for this geometry
if (xwidth <= 0) {
  printf("\nERROR in Union_box named %s, the xwidth is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (yheight <= 0) {
  printf("\nERROR in Union_box named %s, yheight is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (zdepth <= 0) {
  printf("\nERROR in Union_box named %s, zdepth is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (xwidth2 <= 0 && xwidth2 != -1) {
  printf("\nERROR in Union_box named %s, the xwidth2 is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (yheight2 <= 0 && yheight2 != -1) {
  printf("\nERROR in Union_box named %s, yheight2 is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}

// Use sanitation
if (global_material_list.num_elements == 0) {
  printf("\nERROR: Need to define a material using Union_make_material before using a Union geometry component. \n");
  printf("       %s was defined before first use of Union_make_material.\n",NAME_CURRENT_COMP);
  exit(1);
}

this_box_volume.geometry.is_masked_volume = 0;
this_box_volume.geometry.is_exit_volume = 0;
this_box_volume.geometry.is_mask_volume = 0;
// check if the volume is a mask, if it is the material string is irelevant.
if (mask_string && strlen(mask_string) && strcmp(mask_string, "NULL") && strcmp(mask_string, "0")) {
    // A mask volume is used to limit the extend of other volumes, called the masked volumes. These are specified in the mask_string.
    // In order for a ray to enter a masked volume, it needs to be both in the region covered by that volume AND the mask volume.
    // When more than
    this_box_volume.geometry.mask_mode = 1; // Default is mask mode is ALL
    if (mask_setting && strlen(mask_setting) && strcmp(mask_setting, "NULL") && strcmp(mask_setting, "0")) {
        if (strcmp(mask_setting,"ALL") == 0 || strcmp(mask_setting,"All") == 0) this_box_volume.geometry.mask_mode = 1;
        else if (strcmp(mask_setting,"ANY") == 0 || strcmp(mask_setting,"Any") == 0) this_box_volume.geometry.mask_mode = 2;
        else {
            printf("The mask_mode of component %s is set to %s, but must be either ALL or ANY.\n",NAME_CURRENT_COMP,mask_setting);
            exit(1);
        }
    }
    
    for (loop_index=0;loop_index<global_geometry_list.num_elements;loop_index++) {
        // Add mask list
        if (1 == manual_linking_function(global_geometry_list.elements[loop_index].name,mask_string)) {
            add_element_to_int_list(&this_box_volume.geometry.mask_list,global_geometry_list.elements[loop_index].component_index);
            add_element_to_int_list(&global_geometry_list.elements[loop_index].Volume->geometry.masked_by_list,INDEX_CURRENT_COMP);
            global_geometry_list.elements[loop_index].Volume->geometry.is_masked_volume = 1;
            if (this_box_volume.geometry.mask_mode == 2)
                global_geometry_list.elements[loop_index].Volume->geometry.mask_mode = 2;
            if (this_box_volume.geometry.mask_mode == 1) {
                if (global_geometry_list.elements[loop_index].Volume->geometry.is_masked_volume == 1 && global_geometry_list.elements[loop_index].Volume->geometry.mask_mode != 2)
                    // If more than one mask is added to one volume, the ANY mode overwrites the (default) ALL mode.
                    global_geometry_list.elements[loop_index].Volume->geometry.mask_mode = 1;
            }
            
            found_geometries = 1;
        }
    }
    if (found_geometries == 0) {
        printf("The mask_string in geometry: %s did not find any of the specified volumes in the mask_string %s \n",NAME_CURRENT_COMP,mask_string);
        exit(1);
    }
    this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
    this_box_volume.p_physics->is_vacuum = 0; // Makes this volume a vacuum
    this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
    this_box_volume.p_physics->my_a = 0; // Should not be used.
    sprintf(this_box_volume.p_physics->name,"Mask");
    this_box_volume.geometry.is_mask_volume = 1;
    
    
// Read the material input, or if it lacks, use automatic linking.
} else if (material_string && strlen(material_string) && strcmp(material_string, "NULL") && strcmp(material_string, "0")) {
    // A geometry string was given, use it to determine which material
    if (0 == strcmp(material_string,"vacuum") || 0 == strcmp(material_string,"Vacuum")) {
        // One could have a global physics struct for vacuum instead of creating one for each
        this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
        this_box_volume.p_physics->is_vacuum = 1; // Makes this volume a vacuum
        this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
        this_box_volume.p_physics->my_a = 0; // Should not be used.
        sprintf(this_box_volume.p_physics->name,"Vacuum");
    } else if (0 == strcmp(material_string,"exit") || 0 == strcmp(material_string,"Exit")) {
        // One could have a global physics struct for vacuum instead of creating one for each
        this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
        this_box_volume.p_physics->is_vacuum = 1; // Makes this volume a vacuum
        this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
        this_box_volume.p_physics->my_a = 0; // Should not be used.
        this_box_volume.geometry.is_exit_volume = 1;
        sprintf(this_box_volume.p_physics->name,"Exit");
    } else {
        #ifndef MATERIAL_DETECTOR
            printf("Need to define a material before refering to it in a geometry %s.\n",NAME_CURRENT_COMP);
            exit(1);
        #endif
        for (loop_index=0;loop_index<global_material_list.num_elements;loop_index++) {
            if (0 == strcmp(material_string,global_material_list.elements[loop_index].name)) {
                this_box_volume.p_physics = global_material_list.elements[loop_index].physics;
                break;
            }
            if (loop_index == global_material_list.num_elements-1) {
            printf("\n");
            printf("ERROR: The material string \"%s\" in Union geometry \"%s\" did not match a specified material. \n",material_string,NAME_CURRENT_COMP);
            printf("       The materials available at this point (need to be defined before the geometry): \n");
            for (loop_index=0;loop_index<global_material_list.num_elements;loop_index++)
              printf("         %s\n",global_material_list.elements[loop_index].name);
            printf("\n");
            printf("       It is also possible to use one of the defualt materials avaiable: \n");
            printf("           Vacuum (for a Volume without scattering or absorption)\n");
            printf("           Exit (for a Volume where the ray exits the component if it enters)\n");
            printf("           Mask (for a Volume that masks existing volumes specified in the mask_string\n");
            exit(1);
          }
        }
    }
} else {
    // Automatic linking, simply using the last defined material.
    #ifndef MATERIAL_DETECTOR
        printf("Need to define a material before the geometry to use automatic linking %s.\n",NAME_CURRENT_COMP);
        exit(1);
    #endif
    this_box_volume.p_physics = global_material_list.elements[global_material_list.num_elements-1].physics;
}

sprintf(this_box_volume.name,NAME_CURRENT_COMP);
sprintf(this_box_volume.geometry.shape,"box");
this_box_volume.geometry.priority_value = priority;
this_box_volume.geometry.geometry_p_interact = p_interact;
// Currently the coordinates will be in absolute space.
this_box_volume.geometry.center = POS_A_CURRENT_COMP;

this_box_storage.z_depth = zdepth;
this_box_storage.x_width1 = xwidth;
this_box_storage.y_height1 = yheight;

this_box_storage.is_rectangle = 0;
if (xwidth2 < 0 && yheight2 < 0) this_box_storage.is_rectangle = 1;
if (xwidth == xwidth2 && yheight == yheight2) this_box_storage.is_rectangle = 1;

if (xwidth2 < 0) {
    this_box_storage.x_width2 = xwidth;
    xwidth2 = xwidth;
} else this_box_storage.x_width2 = xwidth2;

if (yheight2 < 0) {
    this_box_storage.y_height2 = yheight;
    yheight2 = yheight;
} else this_box_storage.y_height2 = yheight2;


this_box_storage.normal_vectors[0] = coords_set(0,0,1);
this_box_storage.normal_vectors[1] = coords_set(0,0,1);

// for sides with y component = 0
x_component = 2*zdepth/sqrt((xwidth-xwidth2)*(xwidth-xwidth2)+4*zdepth*zdepth);
z_component = (xwidth-xwidth2)/sqrt(4*zdepth*zdepth+(xwidth-xwidth2)*(xwidth-xwidth2));

this_box_storage.normal_vectors[2] = coords_set(x_component,0,z_component);
this_box_storage.normal_vectors[3] = coords_set(-x_component,0,z_component);

// for sides with x component = 0
y_component = 2*zdepth/sqrt((yheight-yheight2)*(yheight-yheight2)+4*zdepth*zdepth);
z_component = (yheight-yheight2)/sqrt(4*zdepth*zdepth+(yheight-yheight2)*(yheight-yheight2));

this_box_storage.normal_vectors[4] = coords_set(0,y_component,z_component);
this_box_storage.normal_vectors[5] = coords_set(0,-y_component,z_component);

this_box_volume.geometry.visualization_on = visualize;

this_box_volume.geometry.geometry_parameters.p_box_storage = &this_box_storage;

// Assign pointers to functions for intersection with the shape, checking if a point is inside the shape
if (this_box_storage.is_rectangle == 1) {
this_box_volume.geometry.intersect_function = &sample_box_intersect_simple;
this_box_volume.geometry.within_function = &r_within_box_simple;
}
else {
this_box_volume.geometry.intersect_function = &sample_box_intersect_advanced;
this_box_volume.geometry.within_function = &r_within_box_advanced;
}

this_box_volume.geometry.shell_points = &box_shell_points;
this_box_volume.geometry.mcdisplay_function = &mcdisplay_box_function;
this_box_volume.geometry.initialize_from_main_function = &initialize_box_geometry_from_main_component;
this_box_volume.geometry.process_rot_allocated = 0;

this_box_volume.geometry.copy_geometry_parameters = &allocate_box_storage_copy;

rot_copy(this_box_volume.geometry.rotation_matrix,ROT_A_CURRENT_COMP); //check how ROT_R_CURRENT_COMP would work
rot_transpose(ROT_A_CURRENT_COMP,this_box_volume.geometry.transpose_rotation_matrix);

// Initialize loggers
this_box_volume.loggers.num_elements = 0;

// packing the information into the global_geometry_element, which is then included in the global_geometry_list.
sprintf(global_geometry_element.name,NAME_CURRENT_COMP);
global_geometry_element.activation_counter = number_of_activations;
global_geometry_element.component_index = INDEX_CURRENT_COMP;
global_geometry_element.Volume = &this_box_volume; // Would be nicer if this m was a pointer, now we have the (small) data two places
add_element_to_geometry_list(&global_geometry_list,global_geometry_element);
}
#line 330263 "MACS_sample_kidney_box.c"
#undef number_of_activations
#undef mask_setting
#undef mask_string
#undef p_interact
#undef focus_r
#undef focus_xh
#undef focus_xw
#undef focus_ah
#undef focus_aw
#undef target_z
#undef target_y
#undef target_x
#undef target_index
#undef visualize
#undef yheight2
#undef xwidth2
#undef zdepth
#undef yheight
#undef xwidth
#undef priority
#undef material_string
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

  /* Initializations for component inter_analyzer_colimator_18_blade_1. */
  SIG_MESSAGE("inter_analyzer_colimator_18_blade_1 (Init)");
#define mccompcurname  inter_analyzer_colimator_18_blade_1
#define mccompcurtype  Union_box
#define mccompcurindex 840
#define loop_index mccinter_analyzer_colimator_18_blade_1_loop_index
#define this_box_volume mccinter_analyzer_colimator_18_blade_1_this_box_volume
#define global_geometry_element mccinter_analyzer_colimator_18_blade_1_global_geometry_element
#define this_box_storage mccinter_analyzer_colimator_18_blade_1_this_box_storage
#define material_string mccinter_analyzer_colimator_18_blade_1_material_string
#define priority mccinter_analyzer_colimator_18_blade_1_priority
#define xwidth mccinter_analyzer_colimator_18_blade_1_xwidth
#define yheight mccinter_analyzer_colimator_18_blade_1_yheight
#define zdepth mccinter_analyzer_colimator_18_blade_1_zdepth
#define xwidth2 mccinter_analyzer_colimator_18_blade_1_xwidth2
#define yheight2 mccinter_analyzer_colimator_18_blade_1_yheight2
#define visualize mccinter_analyzer_colimator_18_blade_1_visualize
#define target_index mccinter_analyzer_colimator_18_blade_1_target_index
#define target_x mccinter_analyzer_colimator_18_blade_1_target_x
#define target_y mccinter_analyzer_colimator_18_blade_1_target_y
#define target_z mccinter_analyzer_colimator_18_blade_1_target_z
#define focus_aw mccinter_analyzer_colimator_18_blade_1_focus_aw
#define focus_ah mccinter_analyzer_colimator_18_blade_1_focus_ah
#define focus_xw mccinter_analyzer_colimator_18_blade_1_focus_xw
#define focus_xh mccinter_analyzer_colimator_18_blade_1_focus_xh
#define focus_r mccinter_analyzer_colimator_18_blade_1_focus_r
#define p_interact mccinter_analyzer_colimator_18_blade_1_p_interact
#define mask_string mccinter_analyzer_colimator_18_blade_1_mask_string
#define mask_setting mccinter_analyzer_colimator_18_blade_1_mask_setting
#define number_of_activations mccinter_analyzer_colimator_18_blade_1_number_of_activations
#line 224 "Union_box.comp"
{
// Initializes the focusing system for this volume including input sanitation.
focus_initialize(&this_box_volume.geometry, POS_A_COMP_INDEX(INDEX_CURRENT_COMP+target_index), POS_A_CURRENT_COMP, ROT_A_CURRENT_COMP, target_index, target_x, target_y, target_z, focus_aw, focus_ah, focus_xw, focus_xh, focus_r, NAME_CURRENT_COMP);

// Input sanitation for this geometry
if (xwidth <= 0) {
  printf("\nERROR in Union_box named %s, the xwidth is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (yheight <= 0) {
  printf("\nERROR in Union_box named %s, yheight is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (zdepth <= 0) {
  printf("\nERROR in Union_box named %s, zdepth is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (xwidth2 <= 0 && xwidth2 != -1) {
  printf("\nERROR in Union_box named %s, the xwidth2 is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (yheight2 <= 0 && yheight2 != -1) {
  printf("\nERROR in Union_box named %s, yheight2 is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}

// Use sanitation
if (global_material_list.num_elements == 0) {
  printf("\nERROR: Need to define a material using Union_make_material before using a Union geometry component. \n");
  printf("       %s was defined before first use of Union_make_material.\n",NAME_CURRENT_COMP);
  exit(1);
}

this_box_volume.geometry.is_masked_volume = 0;
this_box_volume.geometry.is_exit_volume = 0;
this_box_volume.geometry.is_mask_volume = 0;
// check if the volume is a mask, if it is the material string is irelevant.
if (mask_string && strlen(mask_string) && strcmp(mask_string, "NULL") && strcmp(mask_string, "0")) {
    // A mask volume is used to limit the extend of other volumes, called the masked volumes. These are specified in the mask_string.
    // In order for a ray to enter a masked volume, it needs to be both in the region covered by that volume AND the mask volume.
    // When more than
    this_box_volume.geometry.mask_mode = 1; // Default is mask mode is ALL
    if (mask_setting && strlen(mask_setting) && strcmp(mask_setting, "NULL") && strcmp(mask_setting, "0")) {
        if (strcmp(mask_setting,"ALL") == 0 || strcmp(mask_setting,"All") == 0) this_box_volume.geometry.mask_mode = 1;
        else if (strcmp(mask_setting,"ANY") == 0 || strcmp(mask_setting,"Any") == 0) this_box_volume.geometry.mask_mode = 2;
        else {
            printf("The mask_mode of component %s is set to %s, but must be either ALL or ANY.\n",NAME_CURRENT_COMP,mask_setting);
            exit(1);
        }
    }
    
    for (loop_index=0;loop_index<global_geometry_list.num_elements;loop_index++) {
        // Add mask list
        if (1 == manual_linking_function(global_geometry_list.elements[loop_index].name,mask_string)) {
            add_element_to_int_list(&this_box_volume.geometry.mask_list,global_geometry_list.elements[loop_index].component_index);
            add_element_to_int_list(&global_geometry_list.elements[loop_index].Volume->geometry.masked_by_list,INDEX_CURRENT_COMP);
            global_geometry_list.elements[loop_index].Volume->geometry.is_masked_volume = 1;
            if (this_box_volume.geometry.mask_mode == 2)
                global_geometry_list.elements[loop_index].Volume->geometry.mask_mode = 2;
            if (this_box_volume.geometry.mask_mode == 1) {
                if (global_geometry_list.elements[loop_index].Volume->geometry.is_masked_volume == 1 && global_geometry_list.elements[loop_index].Volume->geometry.mask_mode != 2)
                    // If more than one mask is added to one volume, the ANY mode overwrites the (default) ALL mode.
                    global_geometry_list.elements[loop_index].Volume->geometry.mask_mode = 1;
            }
            
            found_geometries = 1;
        }
    }
    if (found_geometries == 0) {
        printf("The mask_string in geometry: %s did not find any of the specified volumes in the mask_string %s \n",NAME_CURRENT_COMP,mask_string);
        exit(1);
    }
    this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
    this_box_volume.p_physics->is_vacuum = 0; // Makes this volume a vacuum
    this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
    this_box_volume.p_physics->my_a = 0; // Should not be used.
    sprintf(this_box_volume.p_physics->name,"Mask");
    this_box_volume.geometry.is_mask_volume = 1;
    
    
// Read the material input, or if it lacks, use automatic linking.
} else if (material_string && strlen(material_string) && strcmp(material_string, "NULL") && strcmp(material_string, "0")) {
    // A geometry string was given, use it to determine which material
    if (0 == strcmp(material_string,"vacuum") || 0 == strcmp(material_string,"Vacuum")) {
        // One could have a global physics struct for vacuum instead of creating one for each
        this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
        this_box_volume.p_physics->is_vacuum = 1; // Makes this volume a vacuum
        this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
        this_box_volume.p_physics->my_a = 0; // Should not be used.
        sprintf(this_box_volume.p_physics->name,"Vacuum");
    } else if (0 == strcmp(material_string,"exit") || 0 == strcmp(material_string,"Exit")) {
        // One could have a global physics struct for vacuum instead of creating one for each
        this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
        this_box_volume.p_physics->is_vacuum = 1; // Makes this volume a vacuum
        this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
        this_box_volume.p_physics->my_a = 0; // Should not be used.
        this_box_volume.geometry.is_exit_volume = 1;
        sprintf(this_box_volume.p_physics->name,"Exit");
    } else {
        #ifndef MATERIAL_DETECTOR
            printf("Need to define a material before refering to it in a geometry %s.\n",NAME_CURRENT_COMP);
            exit(1);
        #endif
        for (loop_index=0;loop_index<global_material_list.num_elements;loop_index++) {
            if (0 == strcmp(material_string,global_material_list.elements[loop_index].name)) {
                this_box_volume.p_physics = global_material_list.elements[loop_index].physics;
                break;
            }
            if (loop_index == global_material_list.num_elements-1) {
            printf("\n");
            printf("ERROR: The material string \"%s\" in Union geometry \"%s\" did not match a specified material. \n",material_string,NAME_CURRENT_COMP);
            printf("       The materials available at this point (need to be defined before the geometry): \n");
            for (loop_index=0;loop_index<global_material_list.num_elements;loop_index++)
              printf("         %s\n",global_material_list.elements[loop_index].name);
            printf("\n");
            printf("       It is also possible to use one of the defualt materials avaiable: \n");
            printf("           Vacuum (for a Volume without scattering or absorption)\n");
            printf("           Exit (for a Volume where the ray exits the component if it enters)\n");
            printf("           Mask (for a Volume that masks existing volumes specified in the mask_string\n");
            exit(1);
          }
        }
    }
} else {
    // Automatic linking, simply using the last defined material.
    #ifndef MATERIAL_DETECTOR
        printf("Need to define a material before the geometry to use automatic linking %s.\n",NAME_CURRENT_COMP);
        exit(1);
    #endif
    this_box_volume.p_physics = global_material_list.elements[global_material_list.num_elements-1].physics;
}

sprintf(this_box_volume.name,NAME_CURRENT_COMP);
sprintf(this_box_volume.geometry.shape,"box");
this_box_volume.geometry.priority_value = priority;
this_box_volume.geometry.geometry_p_interact = p_interact;
// Currently the coordinates will be in absolute space.
this_box_volume.geometry.center = POS_A_CURRENT_COMP;

this_box_storage.z_depth = zdepth;
this_box_storage.x_width1 = xwidth;
this_box_storage.y_height1 = yheight;

this_box_storage.is_rectangle = 0;
if (xwidth2 < 0 && yheight2 < 0) this_box_storage.is_rectangle = 1;
if (xwidth == xwidth2 && yheight == yheight2) this_box_storage.is_rectangle = 1;

if (xwidth2 < 0) {
    this_box_storage.x_width2 = xwidth;
    xwidth2 = xwidth;
} else this_box_storage.x_width2 = xwidth2;

if (yheight2 < 0) {
    this_box_storage.y_height2 = yheight;
    yheight2 = yheight;
} else this_box_storage.y_height2 = yheight2;


this_box_storage.normal_vectors[0] = coords_set(0,0,1);
this_box_storage.normal_vectors[1] = coords_set(0,0,1);

// for sides with y component = 0
x_component = 2*zdepth/sqrt((xwidth-xwidth2)*(xwidth-xwidth2)+4*zdepth*zdepth);
z_component = (xwidth-xwidth2)/sqrt(4*zdepth*zdepth+(xwidth-xwidth2)*(xwidth-xwidth2));

this_box_storage.normal_vectors[2] = coords_set(x_component,0,z_component);
this_box_storage.normal_vectors[3] = coords_set(-x_component,0,z_component);

// for sides with x component = 0
y_component = 2*zdepth/sqrt((yheight-yheight2)*(yheight-yheight2)+4*zdepth*zdepth);
z_component = (yheight-yheight2)/sqrt(4*zdepth*zdepth+(yheight-yheight2)*(yheight-yheight2));

this_box_storage.normal_vectors[4] = coords_set(0,y_component,z_component);
this_box_storage.normal_vectors[5] = coords_set(0,-y_component,z_component);

this_box_volume.geometry.visualization_on = visualize;

this_box_volume.geometry.geometry_parameters.p_box_storage = &this_box_storage;

// Assign pointers to functions for intersection with the shape, checking if a point is inside the shape
if (this_box_storage.is_rectangle == 1) {
this_box_volume.geometry.intersect_function = &sample_box_intersect_simple;
this_box_volume.geometry.within_function = &r_within_box_simple;
}
else {
this_box_volume.geometry.intersect_function = &sample_box_intersect_advanced;
this_box_volume.geometry.within_function = &r_within_box_advanced;
}

this_box_volume.geometry.shell_points = &box_shell_points;
this_box_volume.geometry.mcdisplay_function = &mcdisplay_box_function;
this_box_volume.geometry.initialize_from_main_function = &initialize_box_geometry_from_main_component;
this_box_volume.geometry.process_rot_allocated = 0;

this_box_volume.geometry.copy_geometry_parameters = &allocate_box_storage_copy;

rot_copy(this_box_volume.geometry.rotation_matrix,ROT_A_CURRENT_COMP); //check how ROT_R_CURRENT_COMP would work
rot_transpose(ROT_A_CURRENT_COMP,this_box_volume.geometry.transpose_rotation_matrix);

// Initialize loggers
this_box_volume.loggers.num_elements = 0;

// packing the information into the global_geometry_element, which is then included in the global_geometry_list.
sprintf(global_geometry_element.name,NAME_CURRENT_COMP);
global_geometry_element.activation_counter = number_of_activations;
global_geometry_element.component_index = INDEX_CURRENT_COMP;
global_geometry_element.Volume = &this_box_volume; // Would be nicer if this m was a pointer, now we have the (small) data two places
add_element_to_geometry_list(&global_geometry_list,global_geometry_element);
}
#line 330533 "MACS_sample_kidney_box.c"
#undef number_of_activations
#undef mask_setting
#undef mask_string
#undef p_interact
#undef focus_r
#undef focus_xh
#undef focus_xw
#undef focus_ah
#undef focus_aw
#undef target_z
#undef target_y
#undef target_x
#undef target_index
#undef visualize
#undef yheight2
#undef xwidth2
#undef zdepth
#undef yheight
#undef xwidth
#undef priority
#undef material_string
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

  /* Initializations for component inter_analyzer_colimator_18_blade_2. */
  SIG_MESSAGE("inter_analyzer_colimator_18_blade_2 (Init)");
#define mccompcurname  inter_analyzer_colimator_18_blade_2
#define mccompcurtype  Union_box
#define mccompcurindex 841
#define loop_index mccinter_analyzer_colimator_18_blade_2_loop_index
#define this_box_volume mccinter_analyzer_colimator_18_blade_2_this_box_volume
#define global_geometry_element mccinter_analyzer_colimator_18_blade_2_global_geometry_element
#define this_box_storage mccinter_analyzer_colimator_18_blade_2_this_box_storage
#define material_string mccinter_analyzer_colimator_18_blade_2_material_string
#define priority mccinter_analyzer_colimator_18_blade_2_priority
#define xwidth mccinter_analyzer_colimator_18_blade_2_xwidth
#define yheight mccinter_analyzer_colimator_18_blade_2_yheight
#define zdepth mccinter_analyzer_colimator_18_blade_2_zdepth
#define xwidth2 mccinter_analyzer_colimator_18_blade_2_xwidth2
#define yheight2 mccinter_analyzer_colimator_18_blade_2_yheight2
#define visualize mccinter_analyzer_colimator_18_blade_2_visualize
#define target_index mccinter_analyzer_colimator_18_blade_2_target_index
#define target_x mccinter_analyzer_colimator_18_blade_2_target_x
#define target_y mccinter_analyzer_colimator_18_blade_2_target_y
#define target_z mccinter_analyzer_colimator_18_blade_2_target_z
#define focus_aw mccinter_analyzer_colimator_18_blade_2_focus_aw
#define focus_ah mccinter_analyzer_colimator_18_blade_2_focus_ah
#define focus_xw mccinter_analyzer_colimator_18_blade_2_focus_xw
#define focus_xh mccinter_analyzer_colimator_18_blade_2_focus_xh
#define focus_r mccinter_analyzer_colimator_18_blade_2_focus_r
#define p_interact mccinter_analyzer_colimator_18_blade_2_p_interact
#define mask_string mccinter_analyzer_colimator_18_blade_2_mask_string
#define mask_setting mccinter_analyzer_colimator_18_blade_2_mask_setting
#define number_of_activations mccinter_analyzer_colimator_18_blade_2_number_of_activations
#line 224 "Union_box.comp"
{
// Initializes the focusing system for this volume including input sanitation.
focus_initialize(&this_box_volume.geometry, POS_A_COMP_INDEX(INDEX_CURRENT_COMP+target_index), POS_A_CURRENT_COMP, ROT_A_CURRENT_COMP, target_index, target_x, target_y, target_z, focus_aw, focus_ah, focus_xw, focus_xh, focus_r, NAME_CURRENT_COMP);

// Input sanitation for this geometry
if (xwidth <= 0) {
  printf("\nERROR in Union_box named %s, the xwidth is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (yheight <= 0) {
  printf("\nERROR in Union_box named %s, yheight is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (zdepth <= 0) {
  printf("\nERROR in Union_box named %s, zdepth is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (xwidth2 <= 0 && xwidth2 != -1) {
  printf("\nERROR in Union_box named %s, the xwidth2 is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (yheight2 <= 0 && yheight2 != -1) {
  printf("\nERROR in Union_box named %s, yheight2 is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}

// Use sanitation
if (global_material_list.num_elements == 0) {
  printf("\nERROR: Need to define a material using Union_make_material before using a Union geometry component. \n");
  printf("       %s was defined before first use of Union_make_material.\n",NAME_CURRENT_COMP);
  exit(1);
}

this_box_volume.geometry.is_masked_volume = 0;
this_box_volume.geometry.is_exit_volume = 0;
this_box_volume.geometry.is_mask_volume = 0;
// check if the volume is a mask, if it is the material string is irelevant.
if (mask_string && strlen(mask_string) && strcmp(mask_string, "NULL") && strcmp(mask_string, "0")) {
    // A mask volume is used to limit the extend of other volumes, called the masked volumes. These are specified in the mask_string.
    // In order for a ray to enter a masked volume, it needs to be both in the region covered by that volume AND the mask volume.
    // When more than
    this_box_volume.geometry.mask_mode = 1; // Default is mask mode is ALL
    if (mask_setting && strlen(mask_setting) && strcmp(mask_setting, "NULL") && strcmp(mask_setting, "0")) {
        if (strcmp(mask_setting,"ALL") == 0 || strcmp(mask_setting,"All") == 0) this_box_volume.geometry.mask_mode = 1;
        else if (strcmp(mask_setting,"ANY") == 0 || strcmp(mask_setting,"Any") == 0) this_box_volume.geometry.mask_mode = 2;
        else {
            printf("The mask_mode of component %s is set to %s, but must be either ALL or ANY.\n",NAME_CURRENT_COMP,mask_setting);
            exit(1);
        }
    }
    
    for (loop_index=0;loop_index<global_geometry_list.num_elements;loop_index++) {
        // Add mask list
        if (1 == manual_linking_function(global_geometry_list.elements[loop_index].name,mask_string)) {
            add_element_to_int_list(&this_box_volume.geometry.mask_list,global_geometry_list.elements[loop_index].component_index);
            add_element_to_int_list(&global_geometry_list.elements[loop_index].Volume->geometry.masked_by_list,INDEX_CURRENT_COMP);
            global_geometry_list.elements[loop_index].Volume->geometry.is_masked_volume = 1;
            if (this_box_volume.geometry.mask_mode == 2)
                global_geometry_list.elements[loop_index].Volume->geometry.mask_mode = 2;
            if (this_box_volume.geometry.mask_mode == 1) {
                if (global_geometry_list.elements[loop_index].Volume->geometry.is_masked_volume == 1 && global_geometry_list.elements[loop_index].Volume->geometry.mask_mode != 2)
                    // If more than one mask is added to one volume, the ANY mode overwrites the (default) ALL mode.
                    global_geometry_list.elements[loop_index].Volume->geometry.mask_mode = 1;
            }
            
            found_geometries = 1;
        }
    }
    if (found_geometries == 0) {
        printf("The mask_string in geometry: %s did not find any of the specified volumes in the mask_string %s \n",NAME_CURRENT_COMP,mask_string);
        exit(1);
    }
    this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
    this_box_volume.p_physics->is_vacuum = 0; // Makes this volume a vacuum
    this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
    this_box_volume.p_physics->my_a = 0; // Should not be used.
    sprintf(this_box_volume.p_physics->name,"Mask");
    this_box_volume.geometry.is_mask_volume = 1;
    
    
// Read the material input, or if it lacks, use automatic linking.
} else if (material_string && strlen(material_string) && strcmp(material_string, "NULL") && strcmp(material_string, "0")) {
    // A geometry string was given, use it to determine which material
    if (0 == strcmp(material_string,"vacuum") || 0 == strcmp(material_string,"Vacuum")) {
        // One could have a global physics struct for vacuum instead of creating one for each
        this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
        this_box_volume.p_physics->is_vacuum = 1; // Makes this volume a vacuum
        this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
        this_box_volume.p_physics->my_a = 0; // Should not be used.
        sprintf(this_box_volume.p_physics->name,"Vacuum");
    } else if (0 == strcmp(material_string,"exit") || 0 == strcmp(material_string,"Exit")) {
        // One could have a global physics struct for vacuum instead of creating one for each
        this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
        this_box_volume.p_physics->is_vacuum = 1; // Makes this volume a vacuum
        this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
        this_box_volume.p_physics->my_a = 0; // Should not be used.
        this_box_volume.geometry.is_exit_volume = 1;
        sprintf(this_box_volume.p_physics->name,"Exit");
    } else {
        #ifndef MATERIAL_DETECTOR
            printf("Need to define a material before refering to it in a geometry %s.\n",NAME_CURRENT_COMP);
            exit(1);
        #endif
        for (loop_index=0;loop_index<global_material_list.num_elements;loop_index++) {
            if (0 == strcmp(material_string,global_material_list.elements[loop_index].name)) {
                this_box_volume.p_physics = global_material_list.elements[loop_index].physics;
                break;
            }
            if (loop_index == global_material_list.num_elements-1) {
            printf("\n");
            printf("ERROR: The material string \"%s\" in Union geometry \"%s\" did not match a specified material. \n",material_string,NAME_CURRENT_COMP);
            printf("       The materials available at this point (need to be defined before the geometry): \n");
            for (loop_index=0;loop_index<global_material_list.num_elements;loop_index++)
              printf("         %s\n",global_material_list.elements[loop_index].name);
            printf("\n");
            printf("       It is also possible to use one of the defualt materials avaiable: \n");
            printf("           Vacuum (for a Volume without scattering or absorption)\n");
            printf("           Exit (for a Volume where the ray exits the component if it enters)\n");
            printf("           Mask (for a Volume that masks existing volumes specified in the mask_string\n");
            exit(1);
          }
        }
    }
} else {
    // Automatic linking, simply using the last defined material.
    #ifndef MATERIAL_DETECTOR
        printf("Need to define a material before the geometry to use automatic linking %s.\n",NAME_CURRENT_COMP);
        exit(1);
    #endif
    this_box_volume.p_physics = global_material_list.elements[global_material_list.num_elements-1].physics;
}

sprintf(this_box_volume.name,NAME_CURRENT_COMP);
sprintf(this_box_volume.geometry.shape,"box");
this_box_volume.geometry.priority_value = priority;
this_box_volume.geometry.geometry_p_interact = p_interact;
// Currently the coordinates will be in absolute space.
this_box_volume.geometry.center = POS_A_CURRENT_COMP;

this_box_storage.z_depth = zdepth;
this_box_storage.x_width1 = xwidth;
this_box_storage.y_height1 = yheight;

this_box_storage.is_rectangle = 0;
if (xwidth2 < 0 && yheight2 < 0) this_box_storage.is_rectangle = 1;
if (xwidth == xwidth2 && yheight == yheight2) this_box_storage.is_rectangle = 1;

if (xwidth2 < 0) {
    this_box_storage.x_width2 = xwidth;
    xwidth2 = xwidth;
} else this_box_storage.x_width2 = xwidth2;

if (yheight2 < 0) {
    this_box_storage.y_height2 = yheight;
    yheight2 = yheight;
} else this_box_storage.y_height2 = yheight2;


this_box_storage.normal_vectors[0] = coords_set(0,0,1);
this_box_storage.normal_vectors[1] = coords_set(0,0,1);

// for sides with y component = 0
x_component = 2*zdepth/sqrt((xwidth-xwidth2)*(xwidth-xwidth2)+4*zdepth*zdepth);
z_component = (xwidth-xwidth2)/sqrt(4*zdepth*zdepth+(xwidth-xwidth2)*(xwidth-xwidth2));

this_box_storage.normal_vectors[2] = coords_set(x_component,0,z_component);
this_box_storage.normal_vectors[3] = coords_set(-x_component,0,z_component);

// for sides with x component = 0
y_component = 2*zdepth/sqrt((yheight-yheight2)*(yheight-yheight2)+4*zdepth*zdepth);
z_component = (yheight-yheight2)/sqrt(4*zdepth*zdepth+(yheight-yheight2)*(yheight-yheight2));

this_box_storage.normal_vectors[4] = coords_set(0,y_component,z_component);
this_box_storage.normal_vectors[5] = coords_set(0,-y_component,z_component);

this_box_volume.geometry.visualization_on = visualize;

this_box_volume.geometry.geometry_parameters.p_box_storage = &this_box_storage;

// Assign pointers to functions for intersection with the shape, checking if a point is inside the shape
if (this_box_storage.is_rectangle == 1) {
this_box_volume.geometry.intersect_function = &sample_box_intersect_simple;
this_box_volume.geometry.within_function = &r_within_box_simple;
}
else {
this_box_volume.geometry.intersect_function = &sample_box_intersect_advanced;
this_box_volume.geometry.within_function = &r_within_box_advanced;
}

this_box_volume.geometry.shell_points = &box_shell_points;
this_box_volume.geometry.mcdisplay_function = &mcdisplay_box_function;
this_box_volume.geometry.initialize_from_main_function = &initialize_box_geometry_from_main_component;
this_box_volume.geometry.process_rot_allocated = 0;

this_box_volume.geometry.copy_geometry_parameters = &allocate_box_storage_copy;

rot_copy(this_box_volume.geometry.rotation_matrix,ROT_A_CURRENT_COMP); //check how ROT_R_CURRENT_COMP would work
rot_transpose(ROT_A_CURRENT_COMP,this_box_volume.geometry.transpose_rotation_matrix);

// Initialize loggers
this_box_volume.loggers.num_elements = 0;

// packing the information into the global_geometry_element, which is then included in the global_geometry_list.
sprintf(global_geometry_element.name,NAME_CURRENT_COMP);
global_geometry_element.activation_counter = number_of_activations;
global_geometry_element.component_index = INDEX_CURRENT_COMP;
global_geometry_element.Volume = &this_box_volume; // Would be nicer if this m was a pointer, now we have the (small) data two places
add_element_to_geometry_list(&global_geometry_list,global_geometry_element);
}
#line 330803 "MACS_sample_kidney_box.c"
#undef number_of_activations
#undef mask_setting
#undef mask_string
#undef p_interact
#undef focus_r
#undef focus_xh
#undef focus_xw
#undef focus_ah
#undef focus_aw
#undef target_z
#undef target_y
#undef target_x
#undef target_index
#undef visualize
#undef yheight2
#undef xwidth2
#undef zdepth
#undef yheight
#undef xwidth
#undef priority
#undef material_string
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

  /* Initializations for component inter_analyzer_colimator_18_blade_3. */
  SIG_MESSAGE("inter_analyzer_colimator_18_blade_3 (Init)");
#define mccompcurname  inter_analyzer_colimator_18_blade_3
#define mccompcurtype  Union_box
#define mccompcurindex 842
#define loop_index mccinter_analyzer_colimator_18_blade_3_loop_index
#define this_box_volume mccinter_analyzer_colimator_18_blade_3_this_box_volume
#define global_geometry_element mccinter_analyzer_colimator_18_blade_3_global_geometry_element
#define this_box_storage mccinter_analyzer_colimator_18_blade_3_this_box_storage
#define material_string mccinter_analyzer_colimator_18_blade_3_material_string
#define priority mccinter_analyzer_colimator_18_blade_3_priority
#define xwidth mccinter_analyzer_colimator_18_blade_3_xwidth
#define yheight mccinter_analyzer_colimator_18_blade_3_yheight
#define zdepth mccinter_analyzer_colimator_18_blade_3_zdepth
#define xwidth2 mccinter_analyzer_colimator_18_blade_3_xwidth2
#define yheight2 mccinter_analyzer_colimator_18_blade_3_yheight2
#define visualize mccinter_analyzer_colimator_18_blade_3_visualize
#define target_index mccinter_analyzer_colimator_18_blade_3_target_index
#define target_x mccinter_analyzer_colimator_18_blade_3_target_x
#define target_y mccinter_analyzer_colimator_18_blade_3_target_y
#define target_z mccinter_analyzer_colimator_18_blade_3_target_z
#define focus_aw mccinter_analyzer_colimator_18_blade_3_focus_aw
#define focus_ah mccinter_analyzer_colimator_18_blade_3_focus_ah
#define focus_xw mccinter_analyzer_colimator_18_blade_3_focus_xw
#define focus_xh mccinter_analyzer_colimator_18_blade_3_focus_xh
#define focus_r mccinter_analyzer_colimator_18_blade_3_focus_r
#define p_interact mccinter_analyzer_colimator_18_blade_3_p_interact
#define mask_string mccinter_analyzer_colimator_18_blade_3_mask_string
#define mask_setting mccinter_analyzer_colimator_18_blade_3_mask_setting
#define number_of_activations mccinter_analyzer_colimator_18_blade_3_number_of_activations
#line 224 "Union_box.comp"
{
// Initializes the focusing system for this volume including input sanitation.
focus_initialize(&this_box_volume.geometry, POS_A_COMP_INDEX(INDEX_CURRENT_COMP+target_index), POS_A_CURRENT_COMP, ROT_A_CURRENT_COMP, target_index, target_x, target_y, target_z, focus_aw, focus_ah, focus_xw, focus_xh, focus_r, NAME_CURRENT_COMP);

// Input sanitation for this geometry
if (xwidth <= 0) {
  printf("\nERROR in Union_box named %s, the xwidth is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (yheight <= 0) {
  printf("\nERROR in Union_box named %s, yheight is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (zdepth <= 0) {
  printf("\nERROR in Union_box named %s, zdepth is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (xwidth2 <= 0 && xwidth2 != -1) {
  printf("\nERROR in Union_box named %s, the xwidth2 is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (yheight2 <= 0 && yheight2 != -1) {
  printf("\nERROR in Union_box named %s, yheight2 is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}

// Use sanitation
if (global_material_list.num_elements == 0) {
  printf("\nERROR: Need to define a material using Union_make_material before using a Union geometry component. \n");
  printf("       %s was defined before first use of Union_make_material.\n",NAME_CURRENT_COMP);
  exit(1);
}

this_box_volume.geometry.is_masked_volume = 0;
this_box_volume.geometry.is_exit_volume = 0;
this_box_volume.geometry.is_mask_volume = 0;
// check if the volume is a mask, if it is the material string is irelevant.
if (mask_string && strlen(mask_string) && strcmp(mask_string, "NULL") && strcmp(mask_string, "0")) {
    // A mask volume is used to limit the extend of other volumes, called the masked volumes. These are specified in the mask_string.
    // In order for a ray to enter a masked volume, it needs to be both in the region covered by that volume AND the mask volume.
    // When more than
    this_box_volume.geometry.mask_mode = 1; // Default is mask mode is ALL
    if (mask_setting && strlen(mask_setting) && strcmp(mask_setting, "NULL") && strcmp(mask_setting, "0")) {
        if (strcmp(mask_setting,"ALL") == 0 || strcmp(mask_setting,"All") == 0) this_box_volume.geometry.mask_mode = 1;
        else if (strcmp(mask_setting,"ANY") == 0 || strcmp(mask_setting,"Any") == 0) this_box_volume.geometry.mask_mode = 2;
        else {
            printf("The mask_mode of component %s is set to %s, but must be either ALL or ANY.\n",NAME_CURRENT_COMP,mask_setting);
            exit(1);
        }
    }
    
    for (loop_index=0;loop_index<global_geometry_list.num_elements;loop_index++) {
        // Add mask list
        if (1 == manual_linking_function(global_geometry_list.elements[loop_index].name,mask_string)) {
            add_element_to_int_list(&this_box_volume.geometry.mask_list,global_geometry_list.elements[loop_index].component_index);
            add_element_to_int_list(&global_geometry_list.elements[loop_index].Volume->geometry.masked_by_list,INDEX_CURRENT_COMP);
            global_geometry_list.elements[loop_index].Volume->geometry.is_masked_volume = 1;
            if (this_box_volume.geometry.mask_mode == 2)
                global_geometry_list.elements[loop_index].Volume->geometry.mask_mode = 2;
            if (this_box_volume.geometry.mask_mode == 1) {
                if (global_geometry_list.elements[loop_index].Volume->geometry.is_masked_volume == 1 && global_geometry_list.elements[loop_index].Volume->geometry.mask_mode != 2)
                    // If more than one mask is added to one volume, the ANY mode overwrites the (default) ALL mode.
                    global_geometry_list.elements[loop_index].Volume->geometry.mask_mode = 1;
            }
            
            found_geometries = 1;
        }
    }
    if (found_geometries == 0) {
        printf("The mask_string in geometry: %s did not find any of the specified volumes in the mask_string %s \n",NAME_CURRENT_COMP,mask_string);
        exit(1);
    }
    this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
    this_box_volume.p_physics->is_vacuum = 0; // Makes this volume a vacuum
    this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
    this_box_volume.p_physics->my_a = 0; // Should not be used.
    sprintf(this_box_volume.p_physics->name,"Mask");
    this_box_volume.geometry.is_mask_volume = 1;
    
    
// Read the material input, or if it lacks, use automatic linking.
} else if (material_string && strlen(material_string) && strcmp(material_string, "NULL") && strcmp(material_string, "0")) {
    // A geometry string was given, use it to determine which material
    if (0 == strcmp(material_string,"vacuum") || 0 == strcmp(material_string,"Vacuum")) {
        // One could have a global physics struct for vacuum instead of creating one for each
        this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
        this_box_volume.p_physics->is_vacuum = 1; // Makes this volume a vacuum
        this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
        this_box_volume.p_physics->my_a = 0; // Should not be used.
        sprintf(this_box_volume.p_physics->name,"Vacuum");
    } else if (0 == strcmp(material_string,"exit") || 0 == strcmp(material_string,"Exit")) {
        // One could have a global physics struct for vacuum instead of creating one for each
        this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
        this_box_volume.p_physics->is_vacuum = 1; // Makes this volume a vacuum
        this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
        this_box_volume.p_physics->my_a = 0; // Should not be used.
        this_box_volume.geometry.is_exit_volume = 1;
        sprintf(this_box_volume.p_physics->name,"Exit");
    } else {
        #ifndef MATERIAL_DETECTOR
            printf("Need to define a material before refering to it in a geometry %s.\n",NAME_CURRENT_COMP);
            exit(1);
        #endif
        for (loop_index=0;loop_index<global_material_list.num_elements;loop_index++) {
            if (0 == strcmp(material_string,global_material_list.elements[loop_index].name)) {
                this_box_volume.p_physics = global_material_list.elements[loop_index].physics;
                break;
            }
            if (loop_index == global_material_list.num_elements-1) {
            printf("\n");
            printf("ERROR: The material string \"%s\" in Union geometry \"%s\" did not match a specified material. \n",material_string,NAME_CURRENT_COMP);
            printf("       The materials available at this point (need to be defined before the geometry): \n");
            for (loop_index=0;loop_index<global_material_list.num_elements;loop_index++)
              printf("         %s\n",global_material_list.elements[loop_index].name);
            printf("\n");
            printf("       It is also possible to use one of the defualt materials avaiable: \n");
            printf("           Vacuum (for a Volume without scattering or absorption)\n");
            printf("           Exit (for a Volume where the ray exits the component if it enters)\n");
            printf("           Mask (for a Volume that masks existing volumes specified in the mask_string\n");
            exit(1);
          }
        }
    }
} else {
    // Automatic linking, simply using the last defined material.
    #ifndef MATERIAL_DETECTOR
        printf("Need to define a material before the geometry to use automatic linking %s.\n",NAME_CURRENT_COMP);
        exit(1);
    #endif
    this_box_volume.p_physics = global_material_list.elements[global_material_list.num_elements-1].physics;
}

sprintf(this_box_volume.name,NAME_CURRENT_COMP);
sprintf(this_box_volume.geometry.shape,"box");
this_box_volume.geometry.priority_value = priority;
this_box_volume.geometry.geometry_p_interact = p_interact;
// Currently the coordinates will be in absolute space.
this_box_volume.geometry.center = POS_A_CURRENT_COMP;

this_box_storage.z_depth = zdepth;
this_box_storage.x_width1 = xwidth;
this_box_storage.y_height1 = yheight;

this_box_storage.is_rectangle = 0;
if (xwidth2 < 0 && yheight2 < 0) this_box_storage.is_rectangle = 1;
if (xwidth == xwidth2 && yheight == yheight2) this_box_storage.is_rectangle = 1;

if (xwidth2 < 0) {
    this_box_storage.x_width2 = xwidth;
    xwidth2 = xwidth;
} else this_box_storage.x_width2 = xwidth2;

if (yheight2 < 0) {
    this_box_storage.y_height2 = yheight;
    yheight2 = yheight;
} else this_box_storage.y_height2 = yheight2;


this_box_storage.normal_vectors[0] = coords_set(0,0,1);
this_box_storage.normal_vectors[1] = coords_set(0,0,1);

// for sides with y component = 0
x_component = 2*zdepth/sqrt((xwidth-xwidth2)*(xwidth-xwidth2)+4*zdepth*zdepth);
z_component = (xwidth-xwidth2)/sqrt(4*zdepth*zdepth+(xwidth-xwidth2)*(xwidth-xwidth2));

this_box_storage.normal_vectors[2] = coords_set(x_component,0,z_component);
this_box_storage.normal_vectors[3] = coords_set(-x_component,0,z_component);

// for sides with x component = 0
y_component = 2*zdepth/sqrt((yheight-yheight2)*(yheight-yheight2)+4*zdepth*zdepth);
z_component = (yheight-yheight2)/sqrt(4*zdepth*zdepth+(yheight-yheight2)*(yheight-yheight2));

this_box_storage.normal_vectors[4] = coords_set(0,y_component,z_component);
this_box_storage.normal_vectors[5] = coords_set(0,-y_component,z_component);

this_box_volume.geometry.visualization_on = visualize;

this_box_volume.geometry.geometry_parameters.p_box_storage = &this_box_storage;

// Assign pointers to functions for intersection with the shape, checking if a point is inside the shape
if (this_box_storage.is_rectangle == 1) {
this_box_volume.geometry.intersect_function = &sample_box_intersect_simple;
this_box_volume.geometry.within_function = &r_within_box_simple;
}
else {
this_box_volume.geometry.intersect_function = &sample_box_intersect_advanced;
this_box_volume.geometry.within_function = &r_within_box_advanced;
}

this_box_volume.geometry.shell_points = &box_shell_points;
this_box_volume.geometry.mcdisplay_function = &mcdisplay_box_function;
this_box_volume.geometry.initialize_from_main_function = &initialize_box_geometry_from_main_component;
this_box_volume.geometry.process_rot_allocated = 0;

this_box_volume.geometry.copy_geometry_parameters = &allocate_box_storage_copy;

rot_copy(this_box_volume.geometry.rotation_matrix,ROT_A_CURRENT_COMP); //check how ROT_R_CURRENT_COMP would work
rot_transpose(ROT_A_CURRENT_COMP,this_box_volume.geometry.transpose_rotation_matrix);

// Initialize loggers
this_box_volume.loggers.num_elements = 0;

// packing the information into the global_geometry_element, which is then included in the global_geometry_list.
sprintf(global_geometry_element.name,NAME_CURRENT_COMP);
global_geometry_element.activation_counter = number_of_activations;
global_geometry_element.component_index = INDEX_CURRENT_COMP;
global_geometry_element.Volume = &this_box_volume; // Would be nicer if this m was a pointer, now we have the (small) data two places
add_element_to_geometry_list(&global_geometry_list,global_geometry_element);
}
#line 331073 "MACS_sample_kidney_box.c"
#undef number_of_activations
#undef mask_setting
#undef mask_string
#undef p_interact
#undef focus_r
#undef focus_xh
#undef focus_xw
#undef focus_ah
#undef focus_aw
#undef target_z
#undef target_y
#undef target_x
#undef target_index
#undef visualize
#undef yheight2
#undef xwidth2
#undef zdepth
#undef yheight
#undef xwidth
#undef priority
#undef material_string
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

  /* Initializations for component inter_analyzer_colimator_18_blade_4. */
  SIG_MESSAGE("inter_analyzer_colimator_18_blade_4 (Init)");
#define mccompcurname  inter_analyzer_colimator_18_blade_4
#define mccompcurtype  Union_box
#define mccompcurindex 843
#define loop_index mccinter_analyzer_colimator_18_blade_4_loop_index
#define this_box_volume mccinter_analyzer_colimator_18_blade_4_this_box_volume
#define global_geometry_element mccinter_analyzer_colimator_18_blade_4_global_geometry_element
#define this_box_storage mccinter_analyzer_colimator_18_blade_4_this_box_storage
#define material_string mccinter_analyzer_colimator_18_blade_4_material_string
#define priority mccinter_analyzer_colimator_18_blade_4_priority
#define xwidth mccinter_analyzer_colimator_18_blade_4_xwidth
#define yheight mccinter_analyzer_colimator_18_blade_4_yheight
#define zdepth mccinter_analyzer_colimator_18_blade_4_zdepth
#define xwidth2 mccinter_analyzer_colimator_18_blade_4_xwidth2
#define yheight2 mccinter_analyzer_colimator_18_blade_4_yheight2
#define visualize mccinter_analyzer_colimator_18_blade_4_visualize
#define target_index mccinter_analyzer_colimator_18_blade_4_target_index
#define target_x mccinter_analyzer_colimator_18_blade_4_target_x
#define target_y mccinter_analyzer_colimator_18_blade_4_target_y
#define target_z mccinter_analyzer_colimator_18_blade_4_target_z
#define focus_aw mccinter_analyzer_colimator_18_blade_4_focus_aw
#define focus_ah mccinter_analyzer_colimator_18_blade_4_focus_ah
#define focus_xw mccinter_analyzer_colimator_18_blade_4_focus_xw
#define focus_xh mccinter_analyzer_colimator_18_blade_4_focus_xh
#define focus_r mccinter_analyzer_colimator_18_blade_4_focus_r
#define p_interact mccinter_analyzer_colimator_18_blade_4_p_interact
#define mask_string mccinter_analyzer_colimator_18_blade_4_mask_string
#define mask_setting mccinter_analyzer_colimator_18_blade_4_mask_setting
#define number_of_activations mccinter_analyzer_colimator_18_blade_4_number_of_activations
#line 224 "Union_box.comp"
{
// Initializes the focusing system for this volume including input sanitation.
focus_initialize(&this_box_volume.geometry, POS_A_COMP_INDEX(INDEX_CURRENT_COMP+target_index), POS_A_CURRENT_COMP, ROT_A_CURRENT_COMP, target_index, target_x, target_y, target_z, focus_aw, focus_ah, focus_xw, focus_xh, focus_r, NAME_CURRENT_COMP);

// Input sanitation for this geometry
if (xwidth <= 0) {
  printf("\nERROR in Union_box named %s, the xwidth is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (yheight <= 0) {
  printf("\nERROR in Union_box named %s, yheight is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (zdepth <= 0) {
  printf("\nERROR in Union_box named %s, zdepth is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (xwidth2 <= 0 && xwidth2 != -1) {
  printf("\nERROR in Union_box named %s, the xwidth2 is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (yheight2 <= 0 && yheight2 != -1) {
  printf("\nERROR in Union_box named %s, yheight2 is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}

// Use sanitation
if (global_material_list.num_elements == 0) {
  printf("\nERROR: Need to define a material using Union_make_material before using a Union geometry component. \n");
  printf("       %s was defined before first use of Union_make_material.\n",NAME_CURRENT_COMP);
  exit(1);
}

this_box_volume.geometry.is_masked_volume = 0;
this_box_volume.geometry.is_exit_volume = 0;
this_box_volume.geometry.is_mask_volume = 0;
// check if the volume is a mask, if it is the material string is irelevant.
if (mask_string && strlen(mask_string) && strcmp(mask_string, "NULL") && strcmp(mask_string, "0")) {
    // A mask volume is used to limit the extend of other volumes, called the masked volumes. These are specified in the mask_string.
    // In order for a ray to enter a masked volume, it needs to be both in the region covered by that volume AND the mask volume.
    // When more than
    this_box_volume.geometry.mask_mode = 1; // Default is mask mode is ALL
    if (mask_setting && strlen(mask_setting) && strcmp(mask_setting, "NULL") && strcmp(mask_setting, "0")) {
        if (strcmp(mask_setting,"ALL") == 0 || strcmp(mask_setting,"All") == 0) this_box_volume.geometry.mask_mode = 1;
        else if (strcmp(mask_setting,"ANY") == 0 || strcmp(mask_setting,"Any") == 0) this_box_volume.geometry.mask_mode = 2;
        else {
            printf("The mask_mode of component %s is set to %s, but must be either ALL or ANY.\n",NAME_CURRENT_COMP,mask_setting);
            exit(1);
        }
    }
    
    for (loop_index=0;loop_index<global_geometry_list.num_elements;loop_index++) {
        // Add mask list
        if (1 == manual_linking_function(global_geometry_list.elements[loop_index].name,mask_string)) {
            add_element_to_int_list(&this_box_volume.geometry.mask_list,global_geometry_list.elements[loop_index].component_index);
            add_element_to_int_list(&global_geometry_list.elements[loop_index].Volume->geometry.masked_by_list,INDEX_CURRENT_COMP);
            global_geometry_list.elements[loop_index].Volume->geometry.is_masked_volume = 1;
            if (this_box_volume.geometry.mask_mode == 2)
                global_geometry_list.elements[loop_index].Volume->geometry.mask_mode = 2;
            if (this_box_volume.geometry.mask_mode == 1) {
                if (global_geometry_list.elements[loop_index].Volume->geometry.is_masked_volume == 1 && global_geometry_list.elements[loop_index].Volume->geometry.mask_mode != 2)
                    // If more than one mask is added to one volume, the ANY mode overwrites the (default) ALL mode.
                    global_geometry_list.elements[loop_index].Volume->geometry.mask_mode = 1;
            }
            
            found_geometries = 1;
        }
    }
    if (found_geometries == 0) {
        printf("The mask_string in geometry: %s did not find any of the specified volumes in the mask_string %s \n",NAME_CURRENT_COMP,mask_string);
        exit(1);
    }
    this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
    this_box_volume.p_physics->is_vacuum = 0; // Makes this volume a vacuum
    this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
    this_box_volume.p_physics->my_a = 0; // Should not be used.
    sprintf(this_box_volume.p_physics->name,"Mask");
    this_box_volume.geometry.is_mask_volume = 1;
    
    
// Read the material input, or if it lacks, use automatic linking.
} else if (material_string && strlen(material_string) && strcmp(material_string, "NULL") && strcmp(material_string, "0")) {
    // A geometry string was given, use it to determine which material
    if (0 == strcmp(material_string,"vacuum") || 0 == strcmp(material_string,"Vacuum")) {
        // One could have a global physics struct for vacuum instead of creating one for each
        this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
        this_box_volume.p_physics->is_vacuum = 1; // Makes this volume a vacuum
        this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
        this_box_volume.p_physics->my_a = 0; // Should not be used.
        sprintf(this_box_volume.p_physics->name,"Vacuum");
    } else if (0 == strcmp(material_string,"exit") || 0 == strcmp(material_string,"Exit")) {
        // One could have a global physics struct for vacuum instead of creating one for each
        this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
        this_box_volume.p_physics->is_vacuum = 1; // Makes this volume a vacuum
        this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
        this_box_volume.p_physics->my_a = 0; // Should not be used.
        this_box_volume.geometry.is_exit_volume = 1;
        sprintf(this_box_volume.p_physics->name,"Exit");
    } else {
        #ifndef MATERIAL_DETECTOR
            printf("Need to define a material before refering to it in a geometry %s.\n",NAME_CURRENT_COMP);
            exit(1);
        #endif
        for (loop_index=0;loop_index<global_material_list.num_elements;loop_index++) {
            if (0 == strcmp(material_string,global_material_list.elements[loop_index].name)) {
                this_box_volume.p_physics = global_material_list.elements[loop_index].physics;
                break;
            }
            if (loop_index == global_material_list.num_elements-1) {
            printf("\n");
            printf("ERROR: The material string \"%s\" in Union geometry \"%s\" did not match a specified material. \n",material_string,NAME_CURRENT_COMP);
            printf("       The materials available at this point (need to be defined before the geometry): \n");
            for (loop_index=0;loop_index<global_material_list.num_elements;loop_index++)
              printf("         %s\n",global_material_list.elements[loop_index].name);
            printf("\n");
            printf("       It is also possible to use one of the defualt materials avaiable: \n");
            printf("           Vacuum (for a Volume without scattering or absorption)\n");
            printf("           Exit (for a Volume where the ray exits the component if it enters)\n");
            printf("           Mask (for a Volume that masks existing volumes specified in the mask_string\n");
            exit(1);
          }
        }
    }
} else {
    // Automatic linking, simply using the last defined material.
    #ifndef MATERIAL_DETECTOR
        printf("Need to define a material before the geometry to use automatic linking %s.\n",NAME_CURRENT_COMP);
        exit(1);
    #endif
    this_box_volume.p_physics = global_material_list.elements[global_material_list.num_elements-1].physics;
}

sprintf(this_box_volume.name,NAME_CURRENT_COMP);
sprintf(this_box_volume.geometry.shape,"box");
this_box_volume.geometry.priority_value = priority;
this_box_volume.geometry.geometry_p_interact = p_interact;
// Currently the coordinates will be in absolute space.
this_box_volume.geometry.center = POS_A_CURRENT_COMP;

this_box_storage.z_depth = zdepth;
this_box_storage.x_width1 = xwidth;
this_box_storage.y_height1 = yheight;

this_box_storage.is_rectangle = 0;
if (xwidth2 < 0 && yheight2 < 0) this_box_storage.is_rectangle = 1;
if (xwidth == xwidth2 && yheight == yheight2) this_box_storage.is_rectangle = 1;

if (xwidth2 < 0) {
    this_box_storage.x_width2 = xwidth;
    xwidth2 = xwidth;
} else this_box_storage.x_width2 = xwidth2;

if (yheight2 < 0) {
    this_box_storage.y_height2 = yheight;
    yheight2 = yheight;
} else this_box_storage.y_height2 = yheight2;


this_box_storage.normal_vectors[0] = coords_set(0,0,1);
this_box_storage.normal_vectors[1] = coords_set(0,0,1);

// for sides with y component = 0
x_component = 2*zdepth/sqrt((xwidth-xwidth2)*(xwidth-xwidth2)+4*zdepth*zdepth);
z_component = (xwidth-xwidth2)/sqrt(4*zdepth*zdepth+(xwidth-xwidth2)*(xwidth-xwidth2));

this_box_storage.normal_vectors[2] = coords_set(x_component,0,z_component);
this_box_storage.normal_vectors[3] = coords_set(-x_component,0,z_component);

// for sides with x component = 0
y_component = 2*zdepth/sqrt((yheight-yheight2)*(yheight-yheight2)+4*zdepth*zdepth);
z_component = (yheight-yheight2)/sqrt(4*zdepth*zdepth+(yheight-yheight2)*(yheight-yheight2));

this_box_storage.normal_vectors[4] = coords_set(0,y_component,z_component);
this_box_storage.normal_vectors[5] = coords_set(0,-y_component,z_component);

this_box_volume.geometry.visualization_on = visualize;

this_box_volume.geometry.geometry_parameters.p_box_storage = &this_box_storage;

// Assign pointers to functions for intersection with the shape, checking if a point is inside the shape
if (this_box_storage.is_rectangle == 1) {
this_box_volume.geometry.intersect_function = &sample_box_intersect_simple;
this_box_volume.geometry.within_function = &r_within_box_simple;
}
else {
this_box_volume.geometry.intersect_function = &sample_box_intersect_advanced;
this_box_volume.geometry.within_function = &r_within_box_advanced;
}

this_box_volume.geometry.shell_points = &box_shell_points;
this_box_volume.geometry.mcdisplay_function = &mcdisplay_box_function;
this_box_volume.geometry.initialize_from_main_function = &initialize_box_geometry_from_main_component;
this_box_volume.geometry.process_rot_allocated = 0;

this_box_volume.geometry.copy_geometry_parameters = &allocate_box_storage_copy;

rot_copy(this_box_volume.geometry.rotation_matrix,ROT_A_CURRENT_COMP); //check how ROT_R_CURRENT_COMP would work
rot_transpose(ROT_A_CURRENT_COMP,this_box_volume.geometry.transpose_rotation_matrix);

// Initialize loggers
this_box_volume.loggers.num_elements = 0;

// packing the information into the global_geometry_element, which is then included in the global_geometry_list.
sprintf(global_geometry_element.name,NAME_CURRENT_COMP);
global_geometry_element.activation_counter = number_of_activations;
global_geometry_element.component_index = INDEX_CURRENT_COMP;
global_geometry_element.Volume = &this_box_volume; // Would be nicer if this m was a pointer, now we have the (small) data two places
add_element_to_geometry_list(&global_geometry_list,global_geometry_element);
}
#line 331343 "MACS_sample_kidney_box.c"
#undef number_of_activations
#undef mask_setting
#undef mask_string
#undef p_interact
#undef focus_r
#undef focus_xh
#undef focus_xw
#undef focus_ah
#undef focus_aw
#undef target_z
#undef target_y
#undef target_x
#undef target_index
#undef visualize
#undef yheight2
#undef xwidth2
#undef zdepth
#undef yheight
#undef xwidth
#undef priority
#undef material_string
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

  /* Initializations for component diffraction_detector_18_exit_volume. */
  SIG_MESSAGE("diffraction_detector_18_exit_volume (Init)");
#define mccompcurname  diffraction_detector_18_exit_volume
#define mccompcurtype  Union_box
#define mccompcurindex 844
#define loop_index mccdiffraction_detector_18_exit_volume_loop_index
#define this_box_volume mccdiffraction_detector_18_exit_volume_this_box_volume
#define global_geometry_element mccdiffraction_detector_18_exit_volume_global_geometry_element
#define this_box_storage mccdiffraction_detector_18_exit_volume_this_box_storage
#define material_string mccdiffraction_detector_18_exit_volume_material_string
#define priority mccdiffraction_detector_18_exit_volume_priority
#define xwidth mccdiffraction_detector_18_exit_volume_xwidth
#define yheight mccdiffraction_detector_18_exit_volume_yheight
#define zdepth mccdiffraction_detector_18_exit_volume_zdepth
#define xwidth2 mccdiffraction_detector_18_exit_volume_xwidth2
#define yheight2 mccdiffraction_detector_18_exit_volume_yheight2
#define visualize mccdiffraction_detector_18_exit_volume_visualize
#define target_index mccdiffraction_detector_18_exit_volume_target_index
#define target_x mccdiffraction_detector_18_exit_volume_target_x
#define target_y mccdiffraction_detector_18_exit_volume_target_y
#define target_z mccdiffraction_detector_18_exit_volume_target_z
#define focus_aw mccdiffraction_detector_18_exit_volume_focus_aw
#define focus_ah mccdiffraction_detector_18_exit_volume_focus_ah
#define focus_xw mccdiffraction_detector_18_exit_volume_focus_xw
#define focus_xh mccdiffraction_detector_18_exit_volume_focus_xh
#define focus_r mccdiffraction_detector_18_exit_volume_focus_r
#define p_interact mccdiffraction_detector_18_exit_volume_p_interact
#define mask_string mccdiffraction_detector_18_exit_volume_mask_string
#define mask_setting mccdiffraction_detector_18_exit_volume_mask_setting
#define number_of_activations mccdiffraction_detector_18_exit_volume_number_of_activations
#line 224 "Union_box.comp"
{
// Initializes the focusing system for this volume including input sanitation.
focus_initialize(&this_box_volume.geometry, POS_A_COMP_INDEX(INDEX_CURRENT_COMP+target_index), POS_A_CURRENT_COMP, ROT_A_CURRENT_COMP, target_index, target_x, target_y, target_z, focus_aw, focus_ah, focus_xw, focus_xh, focus_r, NAME_CURRENT_COMP);

// Input sanitation for this geometry
if (xwidth <= 0) {
  printf("\nERROR in Union_box named %s, the xwidth is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (yheight <= 0) {
  printf("\nERROR in Union_box named %s, yheight is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (zdepth <= 0) {
  printf("\nERROR in Union_box named %s, zdepth is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (xwidth2 <= 0 && xwidth2 != -1) {
  printf("\nERROR in Union_box named %s, the xwidth2 is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (yheight2 <= 0 && yheight2 != -1) {
  printf("\nERROR in Union_box named %s, yheight2 is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}

// Use sanitation
if (global_material_list.num_elements == 0) {
  printf("\nERROR: Need to define a material using Union_make_material before using a Union geometry component. \n");
  printf("       %s was defined before first use of Union_make_material.\n",NAME_CURRENT_COMP);
  exit(1);
}

this_box_volume.geometry.is_masked_volume = 0;
this_box_volume.geometry.is_exit_volume = 0;
this_box_volume.geometry.is_mask_volume = 0;
// check if the volume is a mask, if it is the material string is irelevant.
if (mask_string && strlen(mask_string) && strcmp(mask_string, "NULL") && strcmp(mask_string, "0")) {
    // A mask volume is used to limit the extend of other volumes, called the masked volumes. These are specified in the mask_string.
    // In order for a ray to enter a masked volume, it needs to be both in the region covered by that volume AND the mask volume.
    // When more than
    this_box_volume.geometry.mask_mode = 1; // Default is mask mode is ALL
    if (mask_setting && strlen(mask_setting) && strcmp(mask_setting, "NULL") && strcmp(mask_setting, "0")) {
        if (strcmp(mask_setting,"ALL") == 0 || strcmp(mask_setting,"All") == 0) this_box_volume.geometry.mask_mode = 1;
        else if (strcmp(mask_setting,"ANY") == 0 || strcmp(mask_setting,"Any") == 0) this_box_volume.geometry.mask_mode = 2;
        else {
            printf("The mask_mode of component %s is set to %s, but must be either ALL or ANY.\n",NAME_CURRENT_COMP,mask_setting);
            exit(1);
        }
    }
    
    for (loop_index=0;loop_index<global_geometry_list.num_elements;loop_index++) {
        // Add mask list
        if (1 == manual_linking_function(global_geometry_list.elements[loop_index].name,mask_string)) {
            add_element_to_int_list(&this_box_volume.geometry.mask_list,global_geometry_list.elements[loop_index].component_index);
            add_element_to_int_list(&global_geometry_list.elements[loop_index].Volume->geometry.masked_by_list,INDEX_CURRENT_COMP);
            global_geometry_list.elements[loop_index].Volume->geometry.is_masked_volume = 1;
            if (this_box_volume.geometry.mask_mode == 2)
                global_geometry_list.elements[loop_index].Volume->geometry.mask_mode = 2;
            if (this_box_volume.geometry.mask_mode == 1) {
                if (global_geometry_list.elements[loop_index].Volume->geometry.is_masked_volume == 1 && global_geometry_list.elements[loop_index].Volume->geometry.mask_mode != 2)
                    // If more than one mask is added to one volume, the ANY mode overwrites the (default) ALL mode.
                    global_geometry_list.elements[loop_index].Volume->geometry.mask_mode = 1;
            }
            
            found_geometries = 1;
        }
    }
    if (found_geometries == 0) {
        printf("The mask_string in geometry: %s did not find any of the specified volumes in the mask_string %s \n",NAME_CURRENT_COMP,mask_string);
        exit(1);
    }
    this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
    this_box_volume.p_physics->is_vacuum = 0; // Makes this volume a vacuum
    this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
    this_box_volume.p_physics->my_a = 0; // Should not be used.
    sprintf(this_box_volume.p_physics->name,"Mask");
    this_box_volume.geometry.is_mask_volume = 1;
    
    
// Read the material input, or if it lacks, use automatic linking.
} else if (material_string && strlen(material_string) && strcmp(material_string, "NULL") && strcmp(material_string, "0")) {
    // A geometry string was given, use it to determine which material
    if (0 == strcmp(material_string,"vacuum") || 0 == strcmp(material_string,"Vacuum")) {
        // One could have a global physics struct for vacuum instead of creating one for each
        this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
        this_box_volume.p_physics->is_vacuum = 1; // Makes this volume a vacuum
        this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
        this_box_volume.p_physics->my_a = 0; // Should not be used.
        sprintf(this_box_volume.p_physics->name,"Vacuum");
    } else if (0 == strcmp(material_string,"exit") || 0 == strcmp(material_string,"Exit")) {
        // One could have a global physics struct for vacuum instead of creating one for each
        this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
        this_box_volume.p_physics->is_vacuum = 1; // Makes this volume a vacuum
        this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
        this_box_volume.p_physics->my_a = 0; // Should not be used.
        this_box_volume.geometry.is_exit_volume = 1;
        sprintf(this_box_volume.p_physics->name,"Exit");
    } else {
        #ifndef MATERIAL_DETECTOR
            printf("Need to define a material before refering to it in a geometry %s.\n",NAME_CURRENT_COMP);
            exit(1);
        #endif
        for (loop_index=0;loop_index<global_material_list.num_elements;loop_index++) {
            if (0 == strcmp(material_string,global_material_list.elements[loop_index].name)) {
                this_box_volume.p_physics = global_material_list.elements[loop_index].physics;
                break;
            }
            if (loop_index == global_material_list.num_elements-1) {
            printf("\n");
            printf("ERROR: The material string \"%s\" in Union geometry \"%s\" did not match a specified material. \n",material_string,NAME_CURRENT_COMP);
            printf("       The materials available at this point (need to be defined before the geometry): \n");
            for (loop_index=0;loop_index<global_material_list.num_elements;loop_index++)
              printf("         %s\n",global_material_list.elements[loop_index].name);
            printf("\n");
            printf("       It is also possible to use one of the defualt materials avaiable: \n");
            printf("           Vacuum (for a Volume without scattering or absorption)\n");
            printf("           Exit (for a Volume where the ray exits the component if it enters)\n");
            printf("           Mask (for a Volume that masks existing volumes specified in the mask_string\n");
            exit(1);
          }
        }
    }
} else {
    // Automatic linking, simply using the last defined material.
    #ifndef MATERIAL_DETECTOR
        printf("Need to define a material before the geometry to use automatic linking %s.\n",NAME_CURRENT_COMP);
        exit(1);
    #endif
    this_box_volume.p_physics = global_material_list.elements[global_material_list.num_elements-1].physics;
}

sprintf(this_box_volume.name,NAME_CURRENT_COMP);
sprintf(this_box_volume.geometry.shape,"box");
this_box_volume.geometry.priority_value = priority;
this_box_volume.geometry.geometry_p_interact = p_interact;
// Currently the coordinates will be in absolute space.
this_box_volume.geometry.center = POS_A_CURRENT_COMP;

this_box_storage.z_depth = zdepth;
this_box_storage.x_width1 = xwidth;
this_box_storage.y_height1 = yheight;

this_box_storage.is_rectangle = 0;
if (xwidth2 < 0 && yheight2 < 0) this_box_storage.is_rectangle = 1;
if (xwidth == xwidth2 && yheight == yheight2) this_box_storage.is_rectangle = 1;

if (xwidth2 < 0) {
    this_box_storage.x_width2 = xwidth;
    xwidth2 = xwidth;
} else this_box_storage.x_width2 = xwidth2;

if (yheight2 < 0) {
    this_box_storage.y_height2 = yheight;
    yheight2 = yheight;
} else this_box_storage.y_height2 = yheight2;


this_box_storage.normal_vectors[0] = coords_set(0,0,1);
this_box_storage.normal_vectors[1] = coords_set(0,0,1);

// for sides with y component = 0
x_component = 2*zdepth/sqrt((xwidth-xwidth2)*(xwidth-xwidth2)+4*zdepth*zdepth);
z_component = (xwidth-xwidth2)/sqrt(4*zdepth*zdepth+(xwidth-xwidth2)*(xwidth-xwidth2));

this_box_storage.normal_vectors[2] = coords_set(x_component,0,z_component);
this_box_storage.normal_vectors[3] = coords_set(-x_component,0,z_component);

// for sides with x component = 0
y_component = 2*zdepth/sqrt((yheight-yheight2)*(yheight-yheight2)+4*zdepth*zdepth);
z_component = (yheight-yheight2)/sqrt(4*zdepth*zdepth+(yheight-yheight2)*(yheight-yheight2));

this_box_storage.normal_vectors[4] = coords_set(0,y_component,z_component);
this_box_storage.normal_vectors[5] = coords_set(0,-y_component,z_component);

this_box_volume.geometry.visualization_on = visualize;

this_box_volume.geometry.geometry_parameters.p_box_storage = &this_box_storage;

// Assign pointers to functions for intersection with the shape, checking if a point is inside the shape
if (this_box_storage.is_rectangle == 1) {
this_box_volume.geometry.intersect_function = &sample_box_intersect_simple;
this_box_volume.geometry.within_function = &r_within_box_simple;
}
else {
this_box_volume.geometry.intersect_function = &sample_box_intersect_advanced;
this_box_volume.geometry.within_function = &r_within_box_advanced;
}

this_box_volume.geometry.shell_points = &box_shell_points;
this_box_volume.geometry.mcdisplay_function = &mcdisplay_box_function;
this_box_volume.geometry.initialize_from_main_function = &initialize_box_geometry_from_main_component;
this_box_volume.geometry.process_rot_allocated = 0;

this_box_volume.geometry.copy_geometry_parameters = &allocate_box_storage_copy;

rot_copy(this_box_volume.geometry.rotation_matrix,ROT_A_CURRENT_COMP); //check how ROT_R_CURRENT_COMP would work
rot_transpose(ROT_A_CURRENT_COMP,this_box_volume.geometry.transpose_rotation_matrix);

// Initialize loggers
this_box_volume.loggers.num_elements = 0;

// packing the information into the global_geometry_element, which is then included in the global_geometry_list.
sprintf(global_geometry_element.name,NAME_CURRENT_COMP);
global_geometry_element.activation_counter = number_of_activations;
global_geometry_element.component_index = INDEX_CURRENT_COMP;
global_geometry_element.Volume = &this_box_volume; // Would be nicer if this m was a pointer, now we have the (small) data two places
add_element_to_geometry_list(&global_geometry_list,global_geometry_element);
}
#line 331613 "MACS_sample_kidney_box.c"
#undef number_of_activations
#undef mask_setting
#undef mask_string
#undef p_interact
#undef focus_r
#undef focus_xh
#undef focus_xw
#undef focus_ah
#undef focus_aw
#undef target_z
#undef target_y
#undef target_x
#undef target_index
#undef visualize
#undef yheight2
#undef xwidth2
#undef zdepth
#undef yheight
#undef xwidth
#undef priority
#undef material_string
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

  /* Initializations for component spec_detector_18_exit_volume. */
  SIG_MESSAGE("spec_detector_18_exit_volume (Init)");
#define mccompcurname  spec_detector_18_exit_volume
#define mccompcurtype  Union_box
#define mccompcurindex 845
#define loop_index mccspec_detector_18_exit_volume_loop_index
#define this_box_volume mccspec_detector_18_exit_volume_this_box_volume
#define global_geometry_element mccspec_detector_18_exit_volume_global_geometry_element
#define this_box_storage mccspec_detector_18_exit_volume_this_box_storage
#define material_string mccspec_detector_18_exit_volume_material_string
#define priority mccspec_detector_18_exit_volume_priority
#define xwidth mccspec_detector_18_exit_volume_xwidth
#define yheight mccspec_detector_18_exit_volume_yheight
#define zdepth mccspec_detector_18_exit_volume_zdepth
#define xwidth2 mccspec_detector_18_exit_volume_xwidth2
#define yheight2 mccspec_detector_18_exit_volume_yheight2
#define visualize mccspec_detector_18_exit_volume_visualize
#define target_index mccspec_detector_18_exit_volume_target_index
#define target_x mccspec_detector_18_exit_volume_target_x
#define target_y mccspec_detector_18_exit_volume_target_y
#define target_z mccspec_detector_18_exit_volume_target_z
#define focus_aw mccspec_detector_18_exit_volume_focus_aw
#define focus_ah mccspec_detector_18_exit_volume_focus_ah
#define focus_xw mccspec_detector_18_exit_volume_focus_xw
#define focus_xh mccspec_detector_18_exit_volume_focus_xh
#define focus_r mccspec_detector_18_exit_volume_focus_r
#define p_interact mccspec_detector_18_exit_volume_p_interact
#define mask_string mccspec_detector_18_exit_volume_mask_string
#define mask_setting mccspec_detector_18_exit_volume_mask_setting
#define number_of_activations mccspec_detector_18_exit_volume_number_of_activations
#line 224 "Union_box.comp"
{
// Initializes the focusing system for this volume including input sanitation.
focus_initialize(&this_box_volume.geometry, POS_A_COMP_INDEX(INDEX_CURRENT_COMP+target_index), POS_A_CURRENT_COMP, ROT_A_CURRENT_COMP, target_index, target_x, target_y, target_z, focus_aw, focus_ah, focus_xw, focus_xh, focus_r, NAME_CURRENT_COMP);

// Input sanitation for this geometry
if (xwidth <= 0) {
  printf("\nERROR in Union_box named %s, the xwidth is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (yheight <= 0) {
  printf("\nERROR in Union_box named %s, yheight is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (zdepth <= 0) {
  printf("\nERROR in Union_box named %s, zdepth is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (xwidth2 <= 0 && xwidth2 != -1) {
  printf("\nERROR in Union_box named %s, the xwidth2 is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (yheight2 <= 0 && yheight2 != -1) {
  printf("\nERROR in Union_box named %s, yheight2 is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}

// Use sanitation
if (global_material_list.num_elements == 0) {
  printf("\nERROR: Need to define a material using Union_make_material before using a Union geometry component. \n");
  printf("       %s was defined before first use of Union_make_material.\n",NAME_CURRENT_COMP);
  exit(1);
}

this_box_volume.geometry.is_masked_volume = 0;
this_box_volume.geometry.is_exit_volume = 0;
this_box_volume.geometry.is_mask_volume = 0;
// check if the volume is a mask, if it is the material string is irelevant.
if (mask_string && strlen(mask_string) && strcmp(mask_string, "NULL") && strcmp(mask_string, "0")) {
    // A mask volume is used to limit the extend of other volumes, called the masked volumes. These are specified in the mask_string.
    // In order for a ray to enter a masked volume, it needs to be both in the region covered by that volume AND the mask volume.
    // When more than
    this_box_volume.geometry.mask_mode = 1; // Default is mask mode is ALL
    if (mask_setting && strlen(mask_setting) && strcmp(mask_setting, "NULL") && strcmp(mask_setting, "0")) {
        if (strcmp(mask_setting,"ALL") == 0 || strcmp(mask_setting,"All") == 0) this_box_volume.geometry.mask_mode = 1;
        else if (strcmp(mask_setting,"ANY") == 0 || strcmp(mask_setting,"Any") == 0) this_box_volume.geometry.mask_mode = 2;
        else {
            printf("The mask_mode of component %s is set to %s, but must be either ALL or ANY.\n",NAME_CURRENT_COMP,mask_setting);
            exit(1);
        }
    }
    
    for (loop_index=0;loop_index<global_geometry_list.num_elements;loop_index++) {
        // Add mask list
        if (1 == manual_linking_function(global_geometry_list.elements[loop_index].name,mask_string)) {
            add_element_to_int_list(&this_box_volume.geometry.mask_list,global_geometry_list.elements[loop_index].component_index);
            add_element_to_int_list(&global_geometry_list.elements[loop_index].Volume->geometry.masked_by_list,INDEX_CURRENT_COMP);
            global_geometry_list.elements[loop_index].Volume->geometry.is_masked_volume = 1;
            if (this_box_volume.geometry.mask_mode == 2)
                global_geometry_list.elements[loop_index].Volume->geometry.mask_mode = 2;
            if (this_box_volume.geometry.mask_mode == 1) {
                if (global_geometry_list.elements[loop_index].Volume->geometry.is_masked_volume == 1 && global_geometry_list.elements[loop_index].Volume->geometry.mask_mode != 2)
                    // If more than one mask is added to one volume, the ANY mode overwrites the (default) ALL mode.
                    global_geometry_list.elements[loop_index].Volume->geometry.mask_mode = 1;
            }
            
            found_geometries = 1;
        }
    }
    if (found_geometries == 0) {
        printf("The mask_string in geometry: %s did not find any of the specified volumes in the mask_string %s \n",NAME_CURRENT_COMP,mask_string);
        exit(1);
    }
    this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
    this_box_volume.p_physics->is_vacuum = 0; // Makes this volume a vacuum
    this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
    this_box_volume.p_physics->my_a = 0; // Should not be used.
    sprintf(this_box_volume.p_physics->name,"Mask");
    this_box_volume.geometry.is_mask_volume = 1;
    
    
// Read the material input, or if it lacks, use automatic linking.
} else if (material_string && strlen(material_string) && strcmp(material_string, "NULL") && strcmp(material_string, "0")) {
    // A geometry string was given, use it to determine which material
    if (0 == strcmp(material_string,"vacuum") || 0 == strcmp(material_string,"Vacuum")) {
        // One could have a global physics struct for vacuum instead of creating one for each
        this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
        this_box_volume.p_physics->is_vacuum = 1; // Makes this volume a vacuum
        this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
        this_box_volume.p_physics->my_a = 0; // Should not be used.
        sprintf(this_box_volume.p_physics->name,"Vacuum");
    } else if (0 == strcmp(material_string,"exit") || 0 == strcmp(material_string,"Exit")) {
        // One could have a global physics struct for vacuum instead of creating one for each
        this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
        this_box_volume.p_physics->is_vacuum = 1; // Makes this volume a vacuum
        this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
        this_box_volume.p_physics->my_a = 0; // Should not be used.
        this_box_volume.geometry.is_exit_volume = 1;
        sprintf(this_box_volume.p_physics->name,"Exit");
    } else {
        #ifndef MATERIAL_DETECTOR
            printf("Need to define a material before refering to it in a geometry %s.\n",NAME_CURRENT_COMP);
            exit(1);
        #endif
        for (loop_index=0;loop_index<global_material_list.num_elements;loop_index++) {
            if (0 == strcmp(material_string,global_material_list.elements[loop_index].name)) {
                this_box_volume.p_physics = global_material_list.elements[loop_index].physics;
                break;
            }
            if (loop_index == global_material_list.num_elements-1) {
            printf("\n");
            printf("ERROR: The material string \"%s\" in Union geometry \"%s\" did not match a specified material. \n",material_string,NAME_CURRENT_COMP);
            printf("       The materials available at this point (need to be defined before the geometry): \n");
            for (loop_index=0;loop_index<global_material_list.num_elements;loop_index++)
              printf("         %s\n",global_material_list.elements[loop_index].name);
            printf("\n");
            printf("       It is also possible to use one of the defualt materials avaiable: \n");
            printf("           Vacuum (for a Volume without scattering or absorption)\n");
            printf("           Exit (for a Volume where the ray exits the component if it enters)\n");
            printf("           Mask (for a Volume that masks existing volumes specified in the mask_string\n");
            exit(1);
          }
        }
    }
} else {
    // Automatic linking, simply using the last defined material.
    #ifndef MATERIAL_DETECTOR
        printf("Need to define a material before the geometry to use automatic linking %s.\n",NAME_CURRENT_COMP);
        exit(1);
    #endif
    this_box_volume.p_physics = global_material_list.elements[global_material_list.num_elements-1].physics;
}

sprintf(this_box_volume.name,NAME_CURRENT_COMP);
sprintf(this_box_volume.geometry.shape,"box");
this_box_volume.geometry.priority_value = priority;
this_box_volume.geometry.geometry_p_interact = p_interact;
// Currently the coordinates will be in absolute space.
this_box_volume.geometry.center = POS_A_CURRENT_COMP;

this_box_storage.z_depth = zdepth;
this_box_storage.x_width1 = xwidth;
this_box_storage.y_height1 = yheight;

this_box_storage.is_rectangle = 0;
if (xwidth2 < 0 && yheight2 < 0) this_box_storage.is_rectangle = 1;
if (xwidth == xwidth2 && yheight == yheight2) this_box_storage.is_rectangle = 1;

if (xwidth2 < 0) {
    this_box_storage.x_width2 = xwidth;
    xwidth2 = xwidth;
} else this_box_storage.x_width2 = xwidth2;

if (yheight2 < 0) {
    this_box_storage.y_height2 = yheight;
    yheight2 = yheight;
} else this_box_storage.y_height2 = yheight2;


this_box_storage.normal_vectors[0] = coords_set(0,0,1);
this_box_storage.normal_vectors[1] = coords_set(0,0,1);

// for sides with y component = 0
x_component = 2*zdepth/sqrt((xwidth-xwidth2)*(xwidth-xwidth2)+4*zdepth*zdepth);
z_component = (xwidth-xwidth2)/sqrt(4*zdepth*zdepth+(xwidth-xwidth2)*(xwidth-xwidth2));

this_box_storage.normal_vectors[2] = coords_set(x_component,0,z_component);
this_box_storage.normal_vectors[3] = coords_set(-x_component,0,z_component);

// for sides with x component = 0
y_component = 2*zdepth/sqrt((yheight-yheight2)*(yheight-yheight2)+4*zdepth*zdepth);
z_component = (yheight-yheight2)/sqrt(4*zdepth*zdepth+(yheight-yheight2)*(yheight-yheight2));

this_box_storage.normal_vectors[4] = coords_set(0,y_component,z_component);
this_box_storage.normal_vectors[5] = coords_set(0,-y_component,z_component);

this_box_volume.geometry.visualization_on = visualize;

this_box_volume.geometry.geometry_parameters.p_box_storage = &this_box_storage;

// Assign pointers to functions for intersection with the shape, checking if a point is inside the shape
if (this_box_storage.is_rectangle == 1) {
this_box_volume.geometry.intersect_function = &sample_box_intersect_simple;
this_box_volume.geometry.within_function = &r_within_box_simple;
}
else {
this_box_volume.geometry.intersect_function = &sample_box_intersect_advanced;
this_box_volume.geometry.within_function = &r_within_box_advanced;
}

this_box_volume.geometry.shell_points = &box_shell_points;
this_box_volume.geometry.mcdisplay_function = &mcdisplay_box_function;
this_box_volume.geometry.initialize_from_main_function = &initialize_box_geometry_from_main_component;
this_box_volume.geometry.process_rot_allocated = 0;

this_box_volume.geometry.copy_geometry_parameters = &allocate_box_storage_copy;

rot_copy(this_box_volume.geometry.rotation_matrix,ROT_A_CURRENT_COMP); //check how ROT_R_CURRENT_COMP would work
rot_transpose(ROT_A_CURRENT_COMP,this_box_volume.geometry.transpose_rotation_matrix);

// Initialize loggers
this_box_volume.loggers.num_elements = 0;

// packing the information into the global_geometry_element, which is then included in the global_geometry_list.
sprintf(global_geometry_element.name,NAME_CURRENT_COMP);
global_geometry_element.activation_counter = number_of_activations;
global_geometry_element.component_index = INDEX_CURRENT_COMP;
global_geometry_element.Volume = &this_box_volume; // Would be nicer if this m was a pointer, now we have the (small) data two places
add_element_to_geometry_list(&global_geometry_list,global_geometry_element);
}
#line 331883 "MACS_sample_kidney_box.c"
#undef number_of_activations
#undef mask_setting
#undef mask_string
#undef p_interact
#undef focus_r
#undef focus_xh
#undef focus_xw
#undef focus_ah
#undef focus_aw
#undef target_z
#undef target_y
#undef target_x
#undef target_index
#undef visualize
#undef yheight2
#undef xwidth2
#undef zdepth
#undef yheight
#undef xwidth
#undef priority
#undef material_string
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

  /* Initializations for component channel_19_cave1_box1. */
  SIG_MESSAGE("channel_19_cave1_box1 (Init)");
#define mccompcurname  channel_19_cave1_box1
#define mccompcurtype  Union_box
#define mccompcurindex 846
#define loop_index mccchannel_19_cave1_box1_loop_index
#define this_box_volume mccchannel_19_cave1_box1_this_box_volume
#define global_geometry_element mccchannel_19_cave1_box1_global_geometry_element
#define this_box_storage mccchannel_19_cave1_box1_this_box_storage
#define material_string mccchannel_19_cave1_box1_material_string
#define priority mccchannel_19_cave1_box1_priority
#define xwidth mccchannel_19_cave1_box1_xwidth
#define yheight mccchannel_19_cave1_box1_yheight
#define zdepth mccchannel_19_cave1_box1_zdepth
#define xwidth2 mccchannel_19_cave1_box1_xwidth2
#define yheight2 mccchannel_19_cave1_box1_yheight2
#define visualize mccchannel_19_cave1_box1_visualize
#define target_index mccchannel_19_cave1_box1_target_index
#define target_x mccchannel_19_cave1_box1_target_x
#define target_y mccchannel_19_cave1_box1_target_y
#define target_z mccchannel_19_cave1_box1_target_z
#define focus_aw mccchannel_19_cave1_box1_focus_aw
#define focus_ah mccchannel_19_cave1_box1_focus_ah
#define focus_xw mccchannel_19_cave1_box1_focus_xw
#define focus_xh mccchannel_19_cave1_box1_focus_xh
#define focus_r mccchannel_19_cave1_box1_focus_r
#define p_interact mccchannel_19_cave1_box1_p_interact
#define mask_string mccchannel_19_cave1_box1_mask_string
#define mask_setting mccchannel_19_cave1_box1_mask_setting
#define number_of_activations mccchannel_19_cave1_box1_number_of_activations
#line 224 "Union_box.comp"
{
// Initializes the focusing system for this volume including input sanitation.
focus_initialize(&this_box_volume.geometry, POS_A_COMP_INDEX(INDEX_CURRENT_COMP+target_index), POS_A_CURRENT_COMP, ROT_A_CURRENT_COMP, target_index, target_x, target_y, target_z, focus_aw, focus_ah, focus_xw, focus_xh, focus_r, NAME_CURRENT_COMP);

// Input sanitation for this geometry
if (xwidth <= 0) {
  printf("\nERROR in Union_box named %s, the xwidth is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (yheight <= 0) {
  printf("\nERROR in Union_box named %s, yheight is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (zdepth <= 0) {
  printf("\nERROR in Union_box named %s, zdepth is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (xwidth2 <= 0 && xwidth2 != -1) {
  printf("\nERROR in Union_box named %s, the xwidth2 is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (yheight2 <= 0 && yheight2 != -1) {
  printf("\nERROR in Union_box named %s, yheight2 is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}

// Use sanitation
if (global_material_list.num_elements == 0) {
  printf("\nERROR: Need to define a material using Union_make_material before using a Union geometry component. \n");
  printf("       %s was defined before first use of Union_make_material.\n",NAME_CURRENT_COMP);
  exit(1);
}

this_box_volume.geometry.is_masked_volume = 0;
this_box_volume.geometry.is_exit_volume = 0;
this_box_volume.geometry.is_mask_volume = 0;
// check if the volume is a mask, if it is the material string is irelevant.
if (mask_string && strlen(mask_string) && strcmp(mask_string, "NULL") && strcmp(mask_string, "0")) {
    // A mask volume is used to limit the extend of other volumes, called the masked volumes. These are specified in the mask_string.
    // In order for a ray to enter a masked volume, it needs to be both in the region covered by that volume AND the mask volume.
    // When more than
    this_box_volume.geometry.mask_mode = 1; // Default is mask mode is ALL
    if (mask_setting && strlen(mask_setting) && strcmp(mask_setting, "NULL") && strcmp(mask_setting, "0")) {
        if (strcmp(mask_setting,"ALL") == 0 || strcmp(mask_setting,"All") == 0) this_box_volume.geometry.mask_mode = 1;
        else if (strcmp(mask_setting,"ANY") == 0 || strcmp(mask_setting,"Any") == 0) this_box_volume.geometry.mask_mode = 2;
        else {
            printf("The mask_mode of component %s is set to %s, but must be either ALL or ANY.\n",NAME_CURRENT_COMP,mask_setting);
            exit(1);
        }
    }
    
    for (loop_index=0;loop_index<global_geometry_list.num_elements;loop_index++) {
        // Add mask list
        if (1 == manual_linking_function(global_geometry_list.elements[loop_index].name,mask_string)) {
            add_element_to_int_list(&this_box_volume.geometry.mask_list,global_geometry_list.elements[loop_index].component_index);
            add_element_to_int_list(&global_geometry_list.elements[loop_index].Volume->geometry.masked_by_list,INDEX_CURRENT_COMP);
            global_geometry_list.elements[loop_index].Volume->geometry.is_masked_volume = 1;
            if (this_box_volume.geometry.mask_mode == 2)
                global_geometry_list.elements[loop_index].Volume->geometry.mask_mode = 2;
            if (this_box_volume.geometry.mask_mode == 1) {
                if (global_geometry_list.elements[loop_index].Volume->geometry.is_masked_volume == 1 && global_geometry_list.elements[loop_index].Volume->geometry.mask_mode != 2)
                    // If more than one mask is added to one volume, the ANY mode overwrites the (default) ALL mode.
                    global_geometry_list.elements[loop_index].Volume->geometry.mask_mode = 1;
            }
            
            found_geometries = 1;
        }
    }
    if (found_geometries == 0) {
        printf("The mask_string in geometry: %s did not find any of the specified volumes in the mask_string %s \n",NAME_CURRENT_COMP,mask_string);
        exit(1);
    }
    this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
    this_box_volume.p_physics->is_vacuum = 0; // Makes this volume a vacuum
    this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
    this_box_volume.p_physics->my_a = 0; // Should not be used.
    sprintf(this_box_volume.p_physics->name,"Mask");
    this_box_volume.geometry.is_mask_volume = 1;
    
    
// Read the material input, or if it lacks, use automatic linking.
} else if (material_string && strlen(material_string) && strcmp(material_string, "NULL") && strcmp(material_string, "0")) {
    // A geometry string was given, use it to determine which material
    if (0 == strcmp(material_string,"vacuum") || 0 == strcmp(material_string,"Vacuum")) {
        // One could have a global physics struct for vacuum instead of creating one for each
        this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
        this_box_volume.p_physics->is_vacuum = 1; // Makes this volume a vacuum
        this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
        this_box_volume.p_physics->my_a = 0; // Should not be used.
        sprintf(this_box_volume.p_physics->name,"Vacuum");
    } else if (0 == strcmp(material_string,"exit") || 0 == strcmp(material_string,"Exit")) {
        // One could have a global physics struct for vacuum instead of creating one for each
        this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
        this_box_volume.p_physics->is_vacuum = 1; // Makes this volume a vacuum
        this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
        this_box_volume.p_physics->my_a = 0; // Should not be used.
        this_box_volume.geometry.is_exit_volume = 1;
        sprintf(this_box_volume.p_physics->name,"Exit");
    } else {
        #ifndef MATERIAL_DETECTOR
            printf("Need to define a material before refering to it in a geometry %s.\n",NAME_CURRENT_COMP);
            exit(1);
        #endif
        for (loop_index=0;loop_index<global_material_list.num_elements;loop_index++) {
            if (0 == strcmp(material_string,global_material_list.elements[loop_index].name)) {
                this_box_volume.p_physics = global_material_list.elements[loop_index].physics;
                break;
            }
            if (loop_index == global_material_list.num_elements-1) {
            printf("\n");
            printf("ERROR: The material string \"%s\" in Union geometry \"%s\" did not match a specified material. \n",material_string,NAME_CURRENT_COMP);
            printf("       The materials available at this point (need to be defined before the geometry): \n");
            for (loop_index=0;loop_index<global_material_list.num_elements;loop_index++)
              printf("         %s\n",global_material_list.elements[loop_index].name);
            printf("\n");
            printf("       It is also possible to use one of the defualt materials avaiable: \n");
            printf("           Vacuum (for a Volume without scattering or absorption)\n");
            printf("           Exit (for a Volume where the ray exits the component if it enters)\n");
            printf("           Mask (for a Volume that masks existing volumes specified in the mask_string\n");
            exit(1);
          }
        }
    }
} else {
    // Automatic linking, simply using the last defined material.
    #ifndef MATERIAL_DETECTOR
        printf("Need to define a material before the geometry to use automatic linking %s.\n",NAME_CURRENT_COMP);
        exit(1);
    #endif
    this_box_volume.p_physics = global_material_list.elements[global_material_list.num_elements-1].physics;
}

sprintf(this_box_volume.name,NAME_CURRENT_COMP);
sprintf(this_box_volume.geometry.shape,"box");
this_box_volume.geometry.priority_value = priority;
this_box_volume.geometry.geometry_p_interact = p_interact;
// Currently the coordinates will be in absolute space.
this_box_volume.geometry.center = POS_A_CURRENT_COMP;

this_box_storage.z_depth = zdepth;
this_box_storage.x_width1 = xwidth;
this_box_storage.y_height1 = yheight;

this_box_storage.is_rectangle = 0;
if (xwidth2 < 0 && yheight2 < 0) this_box_storage.is_rectangle = 1;
if (xwidth == xwidth2 && yheight == yheight2) this_box_storage.is_rectangle = 1;

if (xwidth2 < 0) {
    this_box_storage.x_width2 = xwidth;
    xwidth2 = xwidth;
} else this_box_storage.x_width2 = xwidth2;

if (yheight2 < 0) {
    this_box_storage.y_height2 = yheight;
    yheight2 = yheight;
} else this_box_storage.y_height2 = yheight2;


this_box_storage.normal_vectors[0] = coords_set(0,0,1);
this_box_storage.normal_vectors[1] = coords_set(0,0,1);

// for sides with y component = 0
x_component = 2*zdepth/sqrt((xwidth-xwidth2)*(xwidth-xwidth2)+4*zdepth*zdepth);
z_component = (xwidth-xwidth2)/sqrt(4*zdepth*zdepth+(xwidth-xwidth2)*(xwidth-xwidth2));

this_box_storage.normal_vectors[2] = coords_set(x_component,0,z_component);
this_box_storage.normal_vectors[3] = coords_set(-x_component,0,z_component);

// for sides with x component = 0
y_component = 2*zdepth/sqrt((yheight-yheight2)*(yheight-yheight2)+4*zdepth*zdepth);
z_component = (yheight-yheight2)/sqrt(4*zdepth*zdepth+(yheight-yheight2)*(yheight-yheight2));

this_box_storage.normal_vectors[4] = coords_set(0,y_component,z_component);
this_box_storage.normal_vectors[5] = coords_set(0,-y_component,z_component);

this_box_volume.geometry.visualization_on = visualize;

this_box_volume.geometry.geometry_parameters.p_box_storage = &this_box_storage;

// Assign pointers to functions for intersection with the shape, checking if a point is inside the shape
if (this_box_storage.is_rectangle == 1) {
this_box_volume.geometry.intersect_function = &sample_box_intersect_simple;
this_box_volume.geometry.within_function = &r_within_box_simple;
}
else {
this_box_volume.geometry.intersect_function = &sample_box_intersect_advanced;
this_box_volume.geometry.within_function = &r_within_box_advanced;
}

this_box_volume.geometry.shell_points = &box_shell_points;
this_box_volume.geometry.mcdisplay_function = &mcdisplay_box_function;
this_box_volume.geometry.initialize_from_main_function = &initialize_box_geometry_from_main_component;
this_box_volume.geometry.process_rot_allocated = 0;

this_box_volume.geometry.copy_geometry_parameters = &allocate_box_storage_copy;

rot_copy(this_box_volume.geometry.rotation_matrix,ROT_A_CURRENT_COMP); //check how ROT_R_CURRENT_COMP would work
rot_transpose(ROT_A_CURRENT_COMP,this_box_volume.geometry.transpose_rotation_matrix);

// Initialize loggers
this_box_volume.loggers.num_elements = 0;

// packing the information into the global_geometry_element, which is then included in the global_geometry_list.
sprintf(global_geometry_element.name,NAME_CURRENT_COMP);
global_geometry_element.activation_counter = number_of_activations;
global_geometry_element.component_index = INDEX_CURRENT_COMP;
global_geometry_element.Volume = &this_box_volume; // Would be nicer if this m was a pointer, now we have the (small) data two places
add_element_to_geometry_list(&global_geometry_list,global_geometry_element);
}
#line 332153 "MACS_sample_kidney_box.c"
#undef number_of_activations
#undef mask_setting
#undef mask_string
#undef p_interact
#undef focus_r
#undef focus_xh
#undef focus_xw
#undef focus_ah
#undef focus_aw
#undef target_z
#undef target_y
#undef target_x
#undef target_index
#undef visualize
#undef yheight2
#undef xwidth2
#undef zdepth
#undef yheight
#undef xwidth
#undef priority
#undef material_string
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

  /* Initializations for component channel_19_cave1_box2. */
  SIG_MESSAGE("channel_19_cave1_box2 (Init)");
#define mccompcurname  channel_19_cave1_box2
#define mccompcurtype  Union_box
#define mccompcurindex 847
#define loop_index mccchannel_19_cave1_box2_loop_index
#define this_box_volume mccchannel_19_cave1_box2_this_box_volume
#define global_geometry_element mccchannel_19_cave1_box2_global_geometry_element
#define this_box_storage mccchannel_19_cave1_box2_this_box_storage
#define material_string mccchannel_19_cave1_box2_material_string
#define priority mccchannel_19_cave1_box2_priority
#define xwidth mccchannel_19_cave1_box2_xwidth
#define yheight mccchannel_19_cave1_box2_yheight
#define zdepth mccchannel_19_cave1_box2_zdepth
#define xwidth2 mccchannel_19_cave1_box2_xwidth2
#define yheight2 mccchannel_19_cave1_box2_yheight2
#define visualize mccchannel_19_cave1_box2_visualize
#define target_index mccchannel_19_cave1_box2_target_index
#define target_x mccchannel_19_cave1_box2_target_x
#define target_y mccchannel_19_cave1_box2_target_y
#define target_z mccchannel_19_cave1_box2_target_z
#define focus_aw mccchannel_19_cave1_box2_focus_aw
#define focus_ah mccchannel_19_cave1_box2_focus_ah
#define focus_xw mccchannel_19_cave1_box2_focus_xw
#define focus_xh mccchannel_19_cave1_box2_focus_xh
#define focus_r mccchannel_19_cave1_box2_focus_r
#define p_interact mccchannel_19_cave1_box2_p_interact
#define mask_string mccchannel_19_cave1_box2_mask_string
#define mask_setting mccchannel_19_cave1_box2_mask_setting
#define number_of_activations mccchannel_19_cave1_box2_number_of_activations
#line 224 "Union_box.comp"
{
// Initializes the focusing system for this volume including input sanitation.
focus_initialize(&this_box_volume.geometry, POS_A_COMP_INDEX(INDEX_CURRENT_COMP+target_index), POS_A_CURRENT_COMP, ROT_A_CURRENT_COMP, target_index, target_x, target_y, target_z, focus_aw, focus_ah, focus_xw, focus_xh, focus_r, NAME_CURRENT_COMP);

// Input sanitation for this geometry
if (xwidth <= 0) {
  printf("\nERROR in Union_box named %s, the xwidth is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (yheight <= 0) {
  printf("\nERROR in Union_box named %s, yheight is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (zdepth <= 0) {
  printf("\nERROR in Union_box named %s, zdepth is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (xwidth2 <= 0 && xwidth2 != -1) {
  printf("\nERROR in Union_box named %s, the xwidth2 is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (yheight2 <= 0 && yheight2 != -1) {
  printf("\nERROR in Union_box named %s, yheight2 is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}

// Use sanitation
if (global_material_list.num_elements == 0) {
  printf("\nERROR: Need to define a material using Union_make_material before using a Union geometry component. \n");
  printf("       %s was defined before first use of Union_make_material.\n",NAME_CURRENT_COMP);
  exit(1);
}

this_box_volume.geometry.is_masked_volume = 0;
this_box_volume.geometry.is_exit_volume = 0;
this_box_volume.geometry.is_mask_volume = 0;
// check if the volume is a mask, if it is the material string is irelevant.
if (mask_string && strlen(mask_string) && strcmp(mask_string, "NULL") && strcmp(mask_string, "0")) {
    // A mask volume is used to limit the extend of other volumes, called the masked volumes. These are specified in the mask_string.
    // In order for a ray to enter a masked volume, it needs to be both in the region covered by that volume AND the mask volume.
    // When more than
    this_box_volume.geometry.mask_mode = 1; // Default is mask mode is ALL
    if (mask_setting && strlen(mask_setting) && strcmp(mask_setting, "NULL") && strcmp(mask_setting, "0")) {
        if (strcmp(mask_setting,"ALL") == 0 || strcmp(mask_setting,"All") == 0) this_box_volume.geometry.mask_mode = 1;
        else if (strcmp(mask_setting,"ANY") == 0 || strcmp(mask_setting,"Any") == 0) this_box_volume.geometry.mask_mode = 2;
        else {
            printf("The mask_mode of component %s is set to %s, but must be either ALL or ANY.\n",NAME_CURRENT_COMP,mask_setting);
            exit(1);
        }
    }
    
    for (loop_index=0;loop_index<global_geometry_list.num_elements;loop_index++) {
        // Add mask list
        if (1 == manual_linking_function(global_geometry_list.elements[loop_index].name,mask_string)) {
            add_element_to_int_list(&this_box_volume.geometry.mask_list,global_geometry_list.elements[loop_index].component_index);
            add_element_to_int_list(&global_geometry_list.elements[loop_index].Volume->geometry.masked_by_list,INDEX_CURRENT_COMP);
            global_geometry_list.elements[loop_index].Volume->geometry.is_masked_volume = 1;
            if (this_box_volume.geometry.mask_mode == 2)
                global_geometry_list.elements[loop_index].Volume->geometry.mask_mode = 2;
            if (this_box_volume.geometry.mask_mode == 1) {
                if (global_geometry_list.elements[loop_index].Volume->geometry.is_masked_volume == 1 && global_geometry_list.elements[loop_index].Volume->geometry.mask_mode != 2)
                    // If more than one mask is added to one volume, the ANY mode overwrites the (default) ALL mode.
                    global_geometry_list.elements[loop_index].Volume->geometry.mask_mode = 1;
            }
            
            found_geometries = 1;
        }
    }
    if (found_geometries == 0) {
        printf("The mask_string in geometry: %s did not find any of the specified volumes in the mask_string %s \n",NAME_CURRENT_COMP,mask_string);
        exit(1);
    }
    this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
    this_box_volume.p_physics->is_vacuum = 0; // Makes this volume a vacuum
    this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
    this_box_volume.p_physics->my_a = 0; // Should not be used.
    sprintf(this_box_volume.p_physics->name,"Mask");
    this_box_volume.geometry.is_mask_volume = 1;
    
    
// Read the material input, or if it lacks, use automatic linking.
} else if (material_string && strlen(material_string) && strcmp(material_string, "NULL") && strcmp(material_string, "0")) {
    // A geometry string was given, use it to determine which material
    if (0 == strcmp(material_string,"vacuum") || 0 == strcmp(material_string,"Vacuum")) {
        // One could have a global physics struct for vacuum instead of creating one for each
        this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
        this_box_volume.p_physics->is_vacuum = 1; // Makes this volume a vacuum
        this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
        this_box_volume.p_physics->my_a = 0; // Should not be used.
        sprintf(this_box_volume.p_physics->name,"Vacuum");
    } else if (0 == strcmp(material_string,"exit") || 0 == strcmp(material_string,"Exit")) {
        // One could have a global physics struct for vacuum instead of creating one for each
        this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
        this_box_volume.p_physics->is_vacuum = 1; // Makes this volume a vacuum
        this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
        this_box_volume.p_physics->my_a = 0; // Should not be used.
        this_box_volume.geometry.is_exit_volume = 1;
        sprintf(this_box_volume.p_physics->name,"Exit");
    } else {
        #ifndef MATERIAL_DETECTOR
            printf("Need to define a material before refering to it in a geometry %s.\n",NAME_CURRENT_COMP);
            exit(1);
        #endif
        for (loop_index=0;loop_index<global_material_list.num_elements;loop_index++) {
            if (0 == strcmp(material_string,global_material_list.elements[loop_index].name)) {
                this_box_volume.p_physics = global_material_list.elements[loop_index].physics;
                break;
            }
            if (loop_index == global_material_list.num_elements-1) {
            printf("\n");
            printf("ERROR: The material string \"%s\" in Union geometry \"%s\" did not match a specified material. \n",material_string,NAME_CURRENT_COMP);
            printf("       The materials available at this point (need to be defined before the geometry): \n");
            for (loop_index=0;loop_index<global_material_list.num_elements;loop_index++)
              printf("         %s\n",global_material_list.elements[loop_index].name);
            printf("\n");
            printf("       It is also possible to use one of the defualt materials avaiable: \n");
            printf("           Vacuum (for a Volume without scattering or absorption)\n");
            printf("           Exit (for a Volume where the ray exits the component if it enters)\n");
            printf("           Mask (for a Volume that masks existing volumes specified in the mask_string\n");
            exit(1);
          }
        }
    }
} else {
    // Automatic linking, simply using the last defined material.
    #ifndef MATERIAL_DETECTOR
        printf("Need to define a material before the geometry to use automatic linking %s.\n",NAME_CURRENT_COMP);
        exit(1);
    #endif
    this_box_volume.p_physics = global_material_list.elements[global_material_list.num_elements-1].physics;
}

sprintf(this_box_volume.name,NAME_CURRENT_COMP);
sprintf(this_box_volume.geometry.shape,"box");
this_box_volume.geometry.priority_value = priority;
this_box_volume.geometry.geometry_p_interact = p_interact;
// Currently the coordinates will be in absolute space.
this_box_volume.geometry.center = POS_A_CURRENT_COMP;

this_box_storage.z_depth = zdepth;
this_box_storage.x_width1 = xwidth;
this_box_storage.y_height1 = yheight;

this_box_storage.is_rectangle = 0;
if (xwidth2 < 0 && yheight2 < 0) this_box_storage.is_rectangle = 1;
if (xwidth == xwidth2 && yheight == yheight2) this_box_storage.is_rectangle = 1;

if (xwidth2 < 0) {
    this_box_storage.x_width2 = xwidth;
    xwidth2 = xwidth;
} else this_box_storage.x_width2 = xwidth2;

if (yheight2 < 0) {
    this_box_storage.y_height2 = yheight;
    yheight2 = yheight;
} else this_box_storage.y_height2 = yheight2;


this_box_storage.normal_vectors[0] = coords_set(0,0,1);
this_box_storage.normal_vectors[1] = coords_set(0,0,1);

// for sides with y component = 0
x_component = 2*zdepth/sqrt((xwidth-xwidth2)*(xwidth-xwidth2)+4*zdepth*zdepth);
z_component = (xwidth-xwidth2)/sqrt(4*zdepth*zdepth+(xwidth-xwidth2)*(xwidth-xwidth2));

this_box_storage.normal_vectors[2] = coords_set(x_component,0,z_component);
this_box_storage.normal_vectors[3] = coords_set(-x_component,0,z_component);

// for sides with x component = 0
y_component = 2*zdepth/sqrt((yheight-yheight2)*(yheight-yheight2)+4*zdepth*zdepth);
z_component = (yheight-yheight2)/sqrt(4*zdepth*zdepth+(yheight-yheight2)*(yheight-yheight2));

this_box_storage.normal_vectors[4] = coords_set(0,y_component,z_component);
this_box_storage.normal_vectors[5] = coords_set(0,-y_component,z_component);

this_box_volume.geometry.visualization_on = visualize;

this_box_volume.geometry.geometry_parameters.p_box_storage = &this_box_storage;

// Assign pointers to functions for intersection with the shape, checking if a point is inside the shape
if (this_box_storage.is_rectangle == 1) {
this_box_volume.geometry.intersect_function = &sample_box_intersect_simple;
this_box_volume.geometry.within_function = &r_within_box_simple;
}
else {
this_box_volume.geometry.intersect_function = &sample_box_intersect_advanced;
this_box_volume.geometry.within_function = &r_within_box_advanced;
}

this_box_volume.geometry.shell_points = &box_shell_points;
this_box_volume.geometry.mcdisplay_function = &mcdisplay_box_function;
this_box_volume.geometry.initialize_from_main_function = &initialize_box_geometry_from_main_component;
this_box_volume.geometry.process_rot_allocated = 0;

this_box_volume.geometry.copy_geometry_parameters = &allocate_box_storage_copy;

rot_copy(this_box_volume.geometry.rotation_matrix,ROT_A_CURRENT_COMP); //check how ROT_R_CURRENT_COMP would work
rot_transpose(ROT_A_CURRENT_COMP,this_box_volume.geometry.transpose_rotation_matrix);

// Initialize loggers
this_box_volume.loggers.num_elements = 0;

// packing the information into the global_geometry_element, which is then included in the global_geometry_list.
sprintf(global_geometry_element.name,NAME_CURRENT_COMP);
global_geometry_element.activation_counter = number_of_activations;
global_geometry_element.component_index = INDEX_CURRENT_COMP;
global_geometry_element.Volume = &this_box_volume; // Would be nicer if this m was a pointer, now we have the (small) data two places
add_element_to_geometry_list(&global_geometry_list,global_geometry_element);
}
#line 332423 "MACS_sample_kidney_box.c"
#undef number_of_activations
#undef mask_setting
#undef mask_string
#undef p_interact
#undef focus_r
#undef focus_xh
#undef focus_xw
#undef focus_ah
#undef focus_aw
#undef target_z
#undef target_y
#undef target_x
#undef target_index
#undef visualize
#undef yheight2
#undef xwidth2
#undef zdepth
#undef yheight
#undef xwidth
#undef priority
#undef material_string
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

  /* Initializations for component channel_19_cave1_box3. */
  SIG_MESSAGE("channel_19_cave1_box3 (Init)");
#define mccompcurname  channel_19_cave1_box3
#define mccompcurtype  Union_box
#define mccompcurindex 848
#define loop_index mccchannel_19_cave1_box3_loop_index
#define this_box_volume mccchannel_19_cave1_box3_this_box_volume
#define global_geometry_element mccchannel_19_cave1_box3_global_geometry_element
#define this_box_storage mccchannel_19_cave1_box3_this_box_storage
#define material_string mccchannel_19_cave1_box3_material_string
#define priority mccchannel_19_cave1_box3_priority
#define xwidth mccchannel_19_cave1_box3_xwidth
#define yheight mccchannel_19_cave1_box3_yheight
#define zdepth mccchannel_19_cave1_box3_zdepth
#define xwidth2 mccchannel_19_cave1_box3_xwidth2
#define yheight2 mccchannel_19_cave1_box3_yheight2
#define visualize mccchannel_19_cave1_box3_visualize
#define target_index mccchannel_19_cave1_box3_target_index
#define target_x mccchannel_19_cave1_box3_target_x
#define target_y mccchannel_19_cave1_box3_target_y
#define target_z mccchannel_19_cave1_box3_target_z
#define focus_aw mccchannel_19_cave1_box3_focus_aw
#define focus_ah mccchannel_19_cave1_box3_focus_ah
#define focus_xw mccchannel_19_cave1_box3_focus_xw
#define focus_xh mccchannel_19_cave1_box3_focus_xh
#define focus_r mccchannel_19_cave1_box3_focus_r
#define p_interact mccchannel_19_cave1_box3_p_interact
#define mask_string mccchannel_19_cave1_box3_mask_string
#define mask_setting mccchannel_19_cave1_box3_mask_setting
#define number_of_activations mccchannel_19_cave1_box3_number_of_activations
#line 224 "Union_box.comp"
{
// Initializes the focusing system for this volume including input sanitation.
focus_initialize(&this_box_volume.geometry, POS_A_COMP_INDEX(INDEX_CURRENT_COMP+target_index), POS_A_CURRENT_COMP, ROT_A_CURRENT_COMP, target_index, target_x, target_y, target_z, focus_aw, focus_ah, focus_xw, focus_xh, focus_r, NAME_CURRENT_COMP);

// Input sanitation for this geometry
if (xwidth <= 0) {
  printf("\nERROR in Union_box named %s, the xwidth is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (yheight <= 0) {
  printf("\nERROR in Union_box named %s, yheight is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (zdepth <= 0) {
  printf("\nERROR in Union_box named %s, zdepth is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (xwidth2 <= 0 && xwidth2 != -1) {
  printf("\nERROR in Union_box named %s, the xwidth2 is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (yheight2 <= 0 && yheight2 != -1) {
  printf("\nERROR in Union_box named %s, yheight2 is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}

// Use sanitation
if (global_material_list.num_elements == 0) {
  printf("\nERROR: Need to define a material using Union_make_material before using a Union geometry component. \n");
  printf("       %s was defined before first use of Union_make_material.\n",NAME_CURRENT_COMP);
  exit(1);
}

this_box_volume.geometry.is_masked_volume = 0;
this_box_volume.geometry.is_exit_volume = 0;
this_box_volume.geometry.is_mask_volume = 0;
// check if the volume is a mask, if it is the material string is irelevant.
if (mask_string && strlen(mask_string) && strcmp(mask_string, "NULL") && strcmp(mask_string, "0")) {
    // A mask volume is used to limit the extend of other volumes, called the masked volumes. These are specified in the mask_string.
    // In order for a ray to enter a masked volume, it needs to be both in the region covered by that volume AND the mask volume.
    // When more than
    this_box_volume.geometry.mask_mode = 1; // Default is mask mode is ALL
    if (mask_setting && strlen(mask_setting) && strcmp(mask_setting, "NULL") && strcmp(mask_setting, "0")) {
        if (strcmp(mask_setting,"ALL") == 0 || strcmp(mask_setting,"All") == 0) this_box_volume.geometry.mask_mode = 1;
        else if (strcmp(mask_setting,"ANY") == 0 || strcmp(mask_setting,"Any") == 0) this_box_volume.geometry.mask_mode = 2;
        else {
            printf("The mask_mode of component %s is set to %s, but must be either ALL or ANY.\n",NAME_CURRENT_COMP,mask_setting);
            exit(1);
        }
    }
    
    for (loop_index=0;loop_index<global_geometry_list.num_elements;loop_index++) {
        // Add mask list
        if (1 == manual_linking_function(global_geometry_list.elements[loop_index].name,mask_string)) {
            add_element_to_int_list(&this_box_volume.geometry.mask_list,global_geometry_list.elements[loop_index].component_index);
            add_element_to_int_list(&global_geometry_list.elements[loop_index].Volume->geometry.masked_by_list,INDEX_CURRENT_COMP);
            global_geometry_list.elements[loop_index].Volume->geometry.is_masked_volume = 1;
            if (this_box_volume.geometry.mask_mode == 2)
                global_geometry_list.elements[loop_index].Volume->geometry.mask_mode = 2;
            if (this_box_volume.geometry.mask_mode == 1) {
                if (global_geometry_list.elements[loop_index].Volume->geometry.is_masked_volume == 1 && global_geometry_list.elements[loop_index].Volume->geometry.mask_mode != 2)
                    // If more than one mask is added to one volume, the ANY mode overwrites the (default) ALL mode.
                    global_geometry_list.elements[loop_index].Volume->geometry.mask_mode = 1;
            }
            
            found_geometries = 1;
        }
    }
    if (found_geometries == 0) {
        printf("The mask_string in geometry: %s did not find any of the specified volumes in the mask_string %s \n",NAME_CURRENT_COMP,mask_string);
        exit(1);
    }
    this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
    this_box_volume.p_physics->is_vacuum = 0; // Makes this volume a vacuum
    this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
    this_box_volume.p_physics->my_a = 0; // Should not be used.
    sprintf(this_box_volume.p_physics->name,"Mask");
    this_box_volume.geometry.is_mask_volume = 1;
    
    
// Read the material input, or if it lacks, use automatic linking.
} else if (material_string && strlen(material_string) && strcmp(material_string, "NULL") && strcmp(material_string, "0")) {
    // A geometry string was given, use it to determine which material
    if (0 == strcmp(material_string,"vacuum") || 0 == strcmp(material_string,"Vacuum")) {
        // One could have a global physics struct for vacuum instead of creating one for each
        this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
        this_box_volume.p_physics->is_vacuum = 1; // Makes this volume a vacuum
        this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
        this_box_volume.p_physics->my_a = 0; // Should not be used.
        sprintf(this_box_volume.p_physics->name,"Vacuum");
    } else if (0 == strcmp(material_string,"exit") || 0 == strcmp(material_string,"Exit")) {
        // One could have a global physics struct for vacuum instead of creating one for each
        this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
        this_box_volume.p_physics->is_vacuum = 1; // Makes this volume a vacuum
        this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
        this_box_volume.p_physics->my_a = 0; // Should not be used.
        this_box_volume.geometry.is_exit_volume = 1;
        sprintf(this_box_volume.p_physics->name,"Exit");
    } else {
        #ifndef MATERIAL_DETECTOR
            printf("Need to define a material before refering to it in a geometry %s.\n",NAME_CURRENT_COMP);
            exit(1);
        #endif
        for (loop_index=0;loop_index<global_material_list.num_elements;loop_index++) {
            if (0 == strcmp(material_string,global_material_list.elements[loop_index].name)) {
                this_box_volume.p_physics = global_material_list.elements[loop_index].physics;
                break;
            }
            if (loop_index == global_material_list.num_elements-1) {
            printf("\n");
            printf("ERROR: The material string \"%s\" in Union geometry \"%s\" did not match a specified material. \n",material_string,NAME_CURRENT_COMP);
            printf("       The materials available at this point (need to be defined before the geometry): \n");
            for (loop_index=0;loop_index<global_material_list.num_elements;loop_index++)
              printf("         %s\n",global_material_list.elements[loop_index].name);
            printf("\n");
            printf("       It is also possible to use one of the defualt materials avaiable: \n");
            printf("           Vacuum (for a Volume without scattering or absorption)\n");
            printf("           Exit (for a Volume where the ray exits the component if it enters)\n");
            printf("           Mask (for a Volume that masks existing volumes specified in the mask_string\n");
            exit(1);
          }
        }
    }
} else {
    // Automatic linking, simply using the last defined material.
    #ifndef MATERIAL_DETECTOR
        printf("Need to define a material before the geometry to use automatic linking %s.\n",NAME_CURRENT_COMP);
        exit(1);
    #endif
    this_box_volume.p_physics = global_material_list.elements[global_material_list.num_elements-1].physics;
}

sprintf(this_box_volume.name,NAME_CURRENT_COMP);
sprintf(this_box_volume.geometry.shape,"box");
this_box_volume.geometry.priority_value = priority;
this_box_volume.geometry.geometry_p_interact = p_interact;
// Currently the coordinates will be in absolute space.
this_box_volume.geometry.center = POS_A_CURRENT_COMP;

this_box_storage.z_depth = zdepth;
this_box_storage.x_width1 = xwidth;
this_box_storage.y_height1 = yheight;

this_box_storage.is_rectangle = 0;
if (xwidth2 < 0 && yheight2 < 0) this_box_storage.is_rectangle = 1;
if (xwidth == xwidth2 && yheight == yheight2) this_box_storage.is_rectangle = 1;

if (xwidth2 < 0) {
    this_box_storage.x_width2 = xwidth;
    xwidth2 = xwidth;
} else this_box_storage.x_width2 = xwidth2;

if (yheight2 < 0) {
    this_box_storage.y_height2 = yheight;
    yheight2 = yheight;
} else this_box_storage.y_height2 = yheight2;


this_box_storage.normal_vectors[0] = coords_set(0,0,1);
this_box_storage.normal_vectors[1] = coords_set(0,0,1);

// for sides with y component = 0
x_component = 2*zdepth/sqrt((xwidth-xwidth2)*(xwidth-xwidth2)+4*zdepth*zdepth);
z_component = (xwidth-xwidth2)/sqrt(4*zdepth*zdepth+(xwidth-xwidth2)*(xwidth-xwidth2));

this_box_storage.normal_vectors[2] = coords_set(x_component,0,z_component);
this_box_storage.normal_vectors[3] = coords_set(-x_component,0,z_component);

// for sides with x component = 0
y_component = 2*zdepth/sqrt((yheight-yheight2)*(yheight-yheight2)+4*zdepth*zdepth);
z_component = (yheight-yheight2)/sqrt(4*zdepth*zdepth+(yheight-yheight2)*(yheight-yheight2));

this_box_storage.normal_vectors[4] = coords_set(0,y_component,z_component);
this_box_storage.normal_vectors[5] = coords_set(0,-y_component,z_component);

this_box_volume.geometry.visualization_on = visualize;

this_box_volume.geometry.geometry_parameters.p_box_storage = &this_box_storage;

// Assign pointers to functions for intersection with the shape, checking if a point is inside the shape
if (this_box_storage.is_rectangle == 1) {
this_box_volume.geometry.intersect_function = &sample_box_intersect_simple;
this_box_volume.geometry.within_function = &r_within_box_simple;
}
else {
this_box_volume.geometry.intersect_function = &sample_box_intersect_advanced;
this_box_volume.geometry.within_function = &r_within_box_advanced;
}

this_box_volume.geometry.shell_points = &box_shell_points;
this_box_volume.geometry.mcdisplay_function = &mcdisplay_box_function;
this_box_volume.geometry.initialize_from_main_function = &initialize_box_geometry_from_main_component;
this_box_volume.geometry.process_rot_allocated = 0;

this_box_volume.geometry.copy_geometry_parameters = &allocate_box_storage_copy;

rot_copy(this_box_volume.geometry.rotation_matrix,ROT_A_CURRENT_COMP); //check how ROT_R_CURRENT_COMP would work
rot_transpose(ROT_A_CURRENT_COMP,this_box_volume.geometry.transpose_rotation_matrix);

// Initialize loggers
this_box_volume.loggers.num_elements = 0;

// packing the information into the global_geometry_element, which is then included in the global_geometry_list.
sprintf(global_geometry_element.name,NAME_CURRENT_COMP);
global_geometry_element.activation_counter = number_of_activations;
global_geometry_element.component_index = INDEX_CURRENT_COMP;
global_geometry_element.Volume = &this_box_volume; // Would be nicer if this m was a pointer, now we have the (small) data two places
add_element_to_geometry_list(&global_geometry_list,global_geometry_element);
}
#line 332693 "MACS_sample_kidney_box.c"
#undef number_of_activations
#undef mask_setting
#undef mask_string
#undef p_interact
#undef focus_r
#undef focus_xh
#undef focus_xw
#undef focus_ah
#undef focus_aw
#undef target_z
#undef target_y
#undef target_x
#undef target_index
#undef visualize
#undef yheight2
#undef xwidth2
#undef zdepth
#undef yheight
#undef xwidth
#undef priority
#undef material_string
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

  /* Initializations for component channel_19_cave1_cyl1. */
  SIG_MESSAGE("channel_19_cave1_cyl1 (Init)");
#define mccompcurname  channel_19_cave1_cyl1
#define mccompcurtype  Union_cylinder
#define mccompcurindex 849
#define loop_index mccchannel_19_cave1_cyl1_loop_index
#define this_cylinder_volume mccchannel_19_cave1_cyl1_this_cylinder_volume
#define global_geometry_element mccchannel_19_cave1_cyl1_global_geometry_element
#define this_cylinder_storage mccchannel_19_cave1_cyl1_this_cylinder_storage
#define material_string mccchannel_19_cave1_cyl1_material_string
#define priority mccchannel_19_cave1_cyl1_priority
#define radius mccchannel_19_cave1_cyl1_radius
#define yheight mccchannel_19_cave1_cyl1_yheight
#define visualize mccchannel_19_cave1_cyl1_visualize
#define target_index mccchannel_19_cave1_cyl1_target_index
#define target_x mccchannel_19_cave1_cyl1_target_x
#define target_y mccchannel_19_cave1_cyl1_target_y
#define target_z mccchannel_19_cave1_cyl1_target_z
#define focus_aw mccchannel_19_cave1_cyl1_focus_aw
#define focus_ah mccchannel_19_cave1_cyl1_focus_ah
#define focus_xw mccchannel_19_cave1_cyl1_focus_xw
#define focus_xh mccchannel_19_cave1_cyl1_focus_xh
#define focus_r mccchannel_19_cave1_cyl1_focus_r
#define p_interact mccchannel_19_cave1_cyl1_p_interact
#define mask_string mccchannel_19_cave1_cyl1_mask_string
#define mask_setting mccchannel_19_cave1_cyl1_mask_setting
#define number_of_activations mccchannel_19_cave1_cyl1_number_of_activations
#line 185 "Union_cylinder.comp"
{
// Initializes the focusing system for this volume including input sanitation.
focus_initialize(&this_cylinder_volume.geometry, POS_A_COMP_INDEX(INDEX_CURRENT_COMP+target_index), POS_A_CURRENT_COMP, ROT_A_CURRENT_COMP, target_index, target_x, target_y, target_z, focus_aw, focus_ah, focus_xw, focus_xh, focus_r, NAME_CURRENT_COMP);

// Input sanitation for this geometry
if (radius <= 0) {
  printf("\nERROR in Union_cylinder named %s, the radius is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}

if (yheight <= 0) {
  printf("\nERROR in Union_cylinder named %s, yheight is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}

// Use sanitation
#ifdef MATERIAL_DETECTOR
if (global_material_list.num_elements == 0) {
  // Here if the user have defined a material, but only after this material
  printf("\nERROR: Need to define a material using Union_make_material before using a Union geometry component. \n");
  printf("       %s was defined before first use of Union_make_material.\n",NAME_CURRENT_COMP);
  exit(1);
}
#endif
#ifndef MATERIAL_DETECTOR
  printf("\nERROR: Need to define a material using Union_make_material before using a Union geometry component. \n");
  exit(1);
#endif


this_cylinder_volume.geometry.is_masked_volume = 0;
this_cylinder_volume.geometry.is_exit_volume = 0;
this_cylinder_volume.geometry.is_mask_volume = 0;

// Read the material input, or if it lacks, use automatic linking.
if (mask_string && strlen(mask_string) && strcmp(mask_string, "NULL") && strcmp(mask_string, "0")) {
    // A mask volume is used to limit the extend of other volumes, called the masked volumes. These are specified in the mask_string.
    // In order for a ray to enter a masked volume, it needs to be both in the region covered by that volume AND the mask volume.
    // When more than
    this_cylinder_volume.geometry.mask_mode = 1; // Default is mask mode is ALL
    if (mask_setting && strlen(mask_setting) && strcmp(mask_setting, "NULL") && strcmp(mask_setting, "0")) {
        if (strcmp(mask_setting,"ALL") == 0 || strcmp(mask_setting,"All") == 0) this_cylinder_volume.geometry.mask_mode = 1;
        else if (strcmp(mask_setting,"ANY") == 0 || strcmp(mask_setting,"Any") == 0) this_cylinder_volume.geometry.mask_mode = 2;
        else {
            printf("The mask_mode of component %s is set to %s, but must be either ALL or ANY.\n",NAME_CURRENT_COMP,mask_setting);
            exit(1);
        }
    }
    
    for (loop_index=0;loop_index<global_geometry_list.num_elements;loop_index++) {
        // Add mask list
        if (1 == manual_linking_function(global_geometry_list.elements[loop_index].name,mask_string)) {
            add_element_to_int_list(&this_cylinder_volume.geometry.mask_list,global_geometry_list.elements[loop_index].component_index);
            add_element_to_int_list(&global_geometry_list.elements[loop_index].Volume->geometry.masked_by_list,INDEX_CURRENT_COMP);
            global_geometry_list.elements[loop_index].Volume->geometry.is_masked_volume = 1;
            if (this_cylinder_volume.geometry.mask_mode == 2)
                global_geometry_list.elements[loop_index].Volume->geometry.mask_mode = 2;
            if (this_cylinder_volume.geometry.mask_mode == 1) {
                if (global_geometry_list.elements[loop_index].Volume->geometry.is_masked_volume == 1 && global_geometry_list.elements[loop_index].Volume->geometry.mask_mode != 2)
                    // If more than one mask is added to one volume, the ANY mode overwrites the (default) ALL mode.
                    global_geometry_list.elements[loop_index].Volume->geometry.mask_mode = 1;
            }
            
            found_geometries = 1;
        }
    }
    if (found_geometries == 0) {
        printf("The mask_string in geometry: %s did not find any of the specified volumes in the mask_string %s \n",NAME_CURRENT_COMP,mask_string);
        exit(1);
    }
    this_cylinder_volume.p_physics = malloc(sizeof(struct physics_struct));
    this_cylinder_volume.p_physics->is_vacuum = 0; // Makes this volume a vacuum
    this_cylinder_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
    this_cylinder_volume.p_physics->my_a = 0; // Should not be used.
    sprintf(this_cylinder_volume.p_physics->name,"Mask");
    this_cylinder_volume.geometry.is_mask_volume = 1;
    
    
// Read the material input, or if it lacks, use automatic linking.
} else if (material_string && strlen(material_string) && strcmp(material_string, "NULL") && strcmp(material_string, "0")) {
    // A geometry string was given, use it to determine which material
    if (0 == strcmp(material_string,"vacuum") || 0 == strcmp(material_string,"Vacuum")) {
        // One could have a global physics struct for vacuum instead of creating one for each
        this_cylinder_volume.p_physics = malloc(sizeof(struct physics_struct));
        this_cylinder_volume.p_physics->is_vacuum = 1; // Makes this volume a vacuum
        this_cylinder_volume.p_physics->number_of_processes = (int) 0;
        this_cylinder_volume.p_physics->my_a = 0; // Should not be used.
        sprintf(this_cylinder_volume.p_physics->name,"Vacuum");
    } else if (0 == strcmp(material_string,"exit") || 0 == strcmp(material_string,"Exit")) {
        // One could have a global physics struct for exit instead of creating one for each
        this_cylinder_volume.p_physics = malloc(sizeof(struct physics_struct));
        this_cylinder_volume.p_physics->is_vacuum = 1; // Makes this volume a vacuum
        this_cylinder_volume.p_physics->number_of_processes = (int) 0;
        this_cylinder_volume.p_physics->my_a = 0; // Should not be used.
        this_cylinder_volume.geometry.is_exit_volume = 1;
        sprintf(this_cylinder_volume.p_physics->name,"Exit");
    } else {
        for (loop_index=0;loop_index<global_material_list.num_elements;loop_index++) {
          if (0 == strcmp(material_string,global_material_list.elements[loop_index].name)) {
            this_cylinder_volume.p_physics = global_material_list.elements[loop_index].physics;
            break;
          }
          if (loop_index == global_material_list.num_elements-1) {
            printf("\n");
            printf("ERROR: The material string \"%s\" in Union geometry \"%s\" did not match a specified material. \n",material_string,NAME_CURRENT_COMP);
            printf("       The materials available at this point (need to be defined before the geometry): \n");
            for (loop_index=0;loop_index<global_material_list.num_elements;loop_index++)
              printf("         %s\n",global_material_list.elements[loop_index].name);
            printf("\n");
            printf("       It is also possible to use one of the defualt materials avaiable: \n");
            printf("           Vacuum (for a Volume without scattering or absorption)\n");
            printf("           Exit (for a Volume where the ray exits the component if it enters)\n");
            printf("           Mask (for a Volume that masks existing volumes specified in the mask_string\n");
            exit(1);
          }
        }
    }
} else {
    // Automatic linking, simply using the last defined material.
    #ifndef MATERIAL_DETECTOR
        printf("Need to define a material before the geometry to use automatic linking %s.\n",NAME_CURRENT_COMP);
        exit(1);
    #endif
    this_cylinder_volume.p_physics = global_material_list.elements[global_material_list.num_elements-1].physics;
}

sprintf(this_cylinder_volume.name,NAME_CURRENT_COMP);
sprintf(this_cylinder_volume.geometry.shape,"cylinder");
this_cylinder_volume.geometry.priority_value = priority;
// Currently the coordinates will be in absolute space.
this_cylinder_volume.geometry.center = POS_A_CURRENT_COMP;

this_cylinder_volume.geometry.geometry_p_interact = p_interact;
this_cylinder_storage.cyl_radius = radius;
this_cylinder_storage.height = yheight;
this_cylinder_volume.geometry.visualization_on = visualize;
this_cylinder_volume.geometry.geometry_parameters.p_cylinder_storage = &this_cylinder_storage;
this_cylinder_volume.geometry.within_function = &r_within_cylinder;
this_cylinder_volume.geometry.intersect_function = &sample_cylinder_intersect;
this_cylinder_volume.geometry.mcdisplay_function = &mcdisplay_cylinder_function;
this_cylinder_volume.geometry.shell_points = &cylinder_shell_points;
this_cylinder_volume.geometry.initialize_from_main_function = &initialize_cylinder_geometry_from_main_component;
this_cylinder_volume.geometry.process_rot_allocated = 0;
this_cylinder_volume.geometry.copy_geometry_parameters = &allocate_cylinder_storage_copy;

rot_copy(this_cylinder_volume.geometry.rotation_matrix,ROT_A_CURRENT_COMP);
rot_transpose(ROT_A_CURRENT_COMP,this_cylinder_volume.geometry.transpose_rotation_matrix);

// Initialize loggers
this_cylinder_volume.loggers.num_elements = 0;

// packing the information into the global_geometry_element, which is then included in the global_geometry_list.
sprintf(global_geometry_element.name,NAME_CURRENT_COMP);
global_geometry_element.activation_counter = number_of_activations;
global_geometry_element.component_index = INDEX_CURRENT_COMP;
global_geometry_element.Volume = &this_cylinder_volume; // Would be nicer if this m was a pointer, now we have the (small) data two places
add_element_to_geometry_list(&global_geometry_list,global_geometry_element);
}
#line 332909 "MACS_sample_kidney_box.c"
#undef number_of_activations
#undef mask_setting
#undef mask_string
#undef p_interact
#undef focus_r
#undef focus_xh
#undef focus_xw
#undef focus_ah
#undef focus_aw
#undef target_z
#undef target_y
#undef target_x
#undef target_index
#undef visualize
#undef yheight
#undef radius
#undef priority
#undef material_string
#undef this_cylinder_storage
#undef global_geometry_element
#undef this_cylinder_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

  /* Initializations for component channel_19_analyzer_1_center. */
  SIG_MESSAGE("channel_19_analyzer_1_center (Init)");

  /* Initializations for component channel_19_analyzer_1_rotated. */
  SIG_MESSAGE("channel_19_analyzer_1_rotated (Init)");

  /* Initializations for component channel_19_analyzer_1_array_crystal_array_0. */
  SIG_MESSAGE("channel_19_analyzer_1_array_crystal_array_0 (Init)");
#define mccompcurname  channel_19_analyzer_1_array_crystal_array_0
#define mccompcurtype  Union_box
#define mccompcurindex 852
#define loop_index mccchannel_19_analyzer_1_array_crystal_array_0_loop_index
#define this_box_volume mccchannel_19_analyzer_1_array_crystal_array_0_this_box_volume
#define global_geometry_element mccchannel_19_analyzer_1_array_crystal_array_0_global_geometry_element
#define this_box_storage mccchannel_19_analyzer_1_array_crystal_array_0_this_box_storage
#define material_string mccchannel_19_analyzer_1_array_crystal_array_0_material_string
#define priority mccchannel_19_analyzer_1_array_crystal_array_0_priority
#define xwidth mccchannel_19_analyzer_1_array_crystal_array_0_xwidth
#define yheight mccchannel_19_analyzer_1_array_crystal_array_0_yheight
#define zdepth mccchannel_19_analyzer_1_array_crystal_array_0_zdepth
#define xwidth2 mccchannel_19_analyzer_1_array_crystal_array_0_xwidth2
#define yheight2 mccchannel_19_analyzer_1_array_crystal_array_0_yheight2
#define visualize mccchannel_19_analyzer_1_array_crystal_array_0_visualize
#define target_index mccchannel_19_analyzer_1_array_crystal_array_0_target_index
#define target_x mccchannel_19_analyzer_1_array_crystal_array_0_target_x
#define target_y mccchannel_19_analyzer_1_array_crystal_array_0_target_y
#define target_z mccchannel_19_analyzer_1_array_crystal_array_0_target_z
#define focus_aw mccchannel_19_analyzer_1_array_crystal_array_0_focus_aw
#define focus_ah mccchannel_19_analyzer_1_array_crystal_array_0_focus_ah
#define focus_xw mccchannel_19_analyzer_1_array_crystal_array_0_focus_xw
#define focus_xh mccchannel_19_analyzer_1_array_crystal_array_0_focus_xh
#define focus_r mccchannel_19_analyzer_1_array_crystal_array_0_focus_r
#define p_interact mccchannel_19_analyzer_1_array_crystal_array_0_p_interact
#define mask_string mccchannel_19_analyzer_1_array_crystal_array_0_mask_string
#define mask_setting mccchannel_19_analyzer_1_array_crystal_array_0_mask_setting
#define number_of_activations mccchannel_19_analyzer_1_array_crystal_array_0_number_of_activations
#line 224 "Union_box.comp"
{
// Initializes the focusing system for this volume including input sanitation.
focus_initialize(&this_box_volume.geometry, POS_A_COMP_INDEX(INDEX_CURRENT_COMP+target_index), POS_A_CURRENT_COMP, ROT_A_CURRENT_COMP, target_index, target_x, target_y, target_z, focus_aw, focus_ah, focus_xw, focus_xh, focus_r, NAME_CURRENT_COMP);

// Input sanitation for this geometry
if (xwidth <= 0) {
  printf("\nERROR in Union_box named %s, the xwidth is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (yheight <= 0) {
  printf("\nERROR in Union_box named %s, yheight is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (zdepth <= 0) {
  printf("\nERROR in Union_box named %s, zdepth is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (xwidth2 <= 0 && xwidth2 != -1) {
  printf("\nERROR in Union_box named %s, the xwidth2 is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (yheight2 <= 0 && yheight2 != -1) {
  printf("\nERROR in Union_box named %s, yheight2 is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}

// Use sanitation
if (global_material_list.num_elements == 0) {
  printf("\nERROR: Need to define a material using Union_make_material before using a Union geometry component. \n");
  printf("       %s was defined before first use of Union_make_material.\n",NAME_CURRENT_COMP);
  exit(1);
}

this_box_volume.geometry.is_masked_volume = 0;
this_box_volume.geometry.is_exit_volume = 0;
this_box_volume.geometry.is_mask_volume = 0;
// check if the volume is a mask, if it is the material string is irelevant.
if (mask_string && strlen(mask_string) && strcmp(mask_string, "NULL") && strcmp(mask_string, "0")) {
    // A mask volume is used to limit the extend of other volumes, called the masked volumes. These are specified in the mask_string.
    // In order for a ray to enter a masked volume, it needs to be both in the region covered by that volume AND the mask volume.
    // When more than
    this_box_volume.geometry.mask_mode = 1; // Default is mask mode is ALL
    if (mask_setting && strlen(mask_setting) && strcmp(mask_setting, "NULL") && strcmp(mask_setting, "0")) {
        if (strcmp(mask_setting,"ALL") == 0 || strcmp(mask_setting,"All") == 0) this_box_volume.geometry.mask_mode = 1;
        else if (strcmp(mask_setting,"ANY") == 0 || strcmp(mask_setting,"Any") == 0) this_box_volume.geometry.mask_mode = 2;
        else {
            printf("The mask_mode of component %s is set to %s, but must be either ALL or ANY.\n",NAME_CURRENT_COMP,mask_setting);
            exit(1);
        }
    }
    
    for (loop_index=0;loop_index<global_geometry_list.num_elements;loop_index++) {
        // Add mask list
        if (1 == manual_linking_function(global_geometry_list.elements[loop_index].name,mask_string)) {
            add_element_to_int_list(&this_box_volume.geometry.mask_list,global_geometry_list.elements[loop_index].component_index);
            add_element_to_int_list(&global_geometry_list.elements[loop_index].Volume->geometry.masked_by_list,INDEX_CURRENT_COMP);
            global_geometry_list.elements[loop_index].Volume->geometry.is_masked_volume = 1;
            if (this_box_volume.geometry.mask_mode == 2)
                global_geometry_list.elements[loop_index].Volume->geometry.mask_mode = 2;
            if (this_box_volume.geometry.mask_mode == 1) {
                if (global_geometry_list.elements[loop_index].Volume->geometry.is_masked_volume == 1 && global_geometry_list.elements[loop_index].Volume->geometry.mask_mode != 2)
                    // If more than one mask is added to one volume, the ANY mode overwrites the (default) ALL mode.
                    global_geometry_list.elements[loop_index].Volume->geometry.mask_mode = 1;
            }
            
            found_geometries = 1;
        }
    }
    if (found_geometries == 0) {
        printf("The mask_string in geometry: %s did not find any of the specified volumes in the mask_string %s \n",NAME_CURRENT_COMP,mask_string);
        exit(1);
    }
    this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
    this_box_volume.p_physics->is_vacuum = 0; // Makes this volume a vacuum
    this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
    this_box_volume.p_physics->my_a = 0; // Should not be used.
    sprintf(this_box_volume.p_physics->name,"Mask");
    this_box_volume.geometry.is_mask_volume = 1;
    
    
// Read the material input, or if it lacks, use automatic linking.
} else if (material_string && strlen(material_string) && strcmp(material_string, "NULL") && strcmp(material_string, "0")) {
    // A geometry string was given, use it to determine which material
    if (0 == strcmp(material_string,"vacuum") || 0 == strcmp(material_string,"Vacuum")) {
        // One could have a global physics struct for vacuum instead of creating one for each
        this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
        this_box_volume.p_physics->is_vacuum = 1; // Makes this volume a vacuum
        this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
        this_box_volume.p_physics->my_a = 0; // Should not be used.
        sprintf(this_box_volume.p_physics->name,"Vacuum");
    } else if (0 == strcmp(material_string,"exit") || 0 == strcmp(material_string,"Exit")) {
        // One could have a global physics struct for vacuum instead of creating one for each
        this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
        this_box_volume.p_physics->is_vacuum = 1; // Makes this volume a vacuum
        this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
        this_box_volume.p_physics->my_a = 0; // Should not be used.
        this_box_volume.geometry.is_exit_volume = 1;
        sprintf(this_box_volume.p_physics->name,"Exit");
    } else {
        #ifndef MATERIAL_DETECTOR
            printf("Need to define a material before refering to it in a geometry %s.\n",NAME_CURRENT_COMP);
            exit(1);
        #endif
        for (loop_index=0;loop_index<global_material_list.num_elements;loop_index++) {
            if (0 == strcmp(material_string,global_material_list.elements[loop_index].name)) {
                this_box_volume.p_physics = global_material_list.elements[loop_index].physics;
                break;
            }
            if (loop_index == global_material_list.num_elements-1) {
            printf("\n");
            printf("ERROR: The material string \"%s\" in Union geometry \"%s\" did not match a specified material. \n",material_string,NAME_CURRENT_COMP);
            printf("       The materials available at this point (need to be defined before the geometry): \n");
            for (loop_index=0;loop_index<global_material_list.num_elements;loop_index++)
              printf("         %s\n",global_material_list.elements[loop_index].name);
            printf("\n");
            printf("       It is also possible to use one of the defualt materials avaiable: \n");
            printf("           Vacuum (for a Volume without scattering or absorption)\n");
            printf("           Exit (for a Volume where the ray exits the component if it enters)\n");
            printf("           Mask (for a Volume that masks existing volumes specified in the mask_string\n");
            exit(1);
          }
        }
    }
} else {
    // Automatic linking, simply using the last defined material.
    #ifndef MATERIAL_DETECTOR
        printf("Need to define a material before the geometry to use automatic linking %s.\n",NAME_CURRENT_COMP);
        exit(1);
    #endif
    this_box_volume.p_physics = global_material_list.elements[global_material_list.num_elements-1].physics;
}

sprintf(this_box_volume.name,NAME_CURRENT_COMP);
sprintf(this_box_volume.geometry.shape,"box");
this_box_volume.geometry.priority_value = priority;
this_box_volume.geometry.geometry_p_interact = p_interact;
// Currently the coordinates will be in absolute space.
this_box_volume.geometry.center = POS_A_CURRENT_COMP;

this_box_storage.z_depth = zdepth;
this_box_storage.x_width1 = xwidth;
this_box_storage.y_height1 = yheight;

this_box_storage.is_rectangle = 0;
if (xwidth2 < 0 && yheight2 < 0) this_box_storage.is_rectangle = 1;
if (xwidth == xwidth2 && yheight == yheight2) this_box_storage.is_rectangle = 1;

if (xwidth2 < 0) {
    this_box_storage.x_width2 = xwidth;
    xwidth2 = xwidth;
} else this_box_storage.x_width2 = xwidth2;

if (yheight2 < 0) {
    this_box_storage.y_height2 = yheight;
    yheight2 = yheight;
} else this_box_storage.y_height2 = yheight2;


this_box_storage.normal_vectors[0] = coords_set(0,0,1);
this_box_storage.normal_vectors[1] = coords_set(0,0,1);

// for sides with y component = 0
x_component = 2*zdepth/sqrt((xwidth-xwidth2)*(xwidth-xwidth2)+4*zdepth*zdepth);
z_component = (xwidth-xwidth2)/sqrt(4*zdepth*zdepth+(xwidth-xwidth2)*(xwidth-xwidth2));

this_box_storage.normal_vectors[2] = coords_set(x_component,0,z_component);
this_box_storage.normal_vectors[3] = coords_set(-x_component,0,z_component);

// for sides with x component = 0
y_component = 2*zdepth/sqrt((yheight-yheight2)*(yheight-yheight2)+4*zdepth*zdepth);
z_component = (yheight-yheight2)/sqrt(4*zdepth*zdepth+(yheight-yheight2)*(yheight-yheight2));

this_box_storage.normal_vectors[4] = coords_set(0,y_component,z_component);
this_box_storage.normal_vectors[5] = coords_set(0,-y_component,z_component);

this_box_volume.geometry.visualization_on = visualize;

this_box_volume.geometry.geometry_parameters.p_box_storage = &this_box_storage;

// Assign pointers to functions for intersection with the shape, checking if a point is inside the shape
if (this_box_storage.is_rectangle == 1) {
this_box_volume.geometry.intersect_function = &sample_box_intersect_simple;
this_box_volume.geometry.within_function = &r_within_box_simple;
}
else {
this_box_volume.geometry.intersect_function = &sample_box_intersect_advanced;
this_box_volume.geometry.within_function = &r_within_box_advanced;
}

this_box_volume.geometry.shell_points = &box_shell_points;
this_box_volume.geometry.mcdisplay_function = &mcdisplay_box_function;
this_box_volume.geometry.initialize_from_main_function = &initialize_box_geometry_from_main_component;
this_box_volume.geometry.process_rot_allocated = 0;

this_box_volume.geometry.copy_geometry_parameters = &allocate_box_storage_copy;

rot_copy(this_box_volume.geometry.rotation_matrix,ROT_A_CURRENT_COMP); //check how ROT_R_CURRENT_COMP would work
rot_transpose(ROT_A_CURRENT_COMP,this_box_volume.geometry.transpose_rotation_matrix);

// Initialize loggers
this_box_volume.loggers.num_elements = 0;

// packing the information into the global_geometry_element, which is then included in the global_geometry_list.
sprintf(global_geometry_element.name,NAME_CURRENT_COMP);
global_geometry_element.activation_counter = number_of_activations;
global_geometry_element.component_index = INDEX_CURRENT_COMP;
global_geometry_element.Volume = &this_box_volume; // Would be nicer if this m was a pointer, now we have the (small) data two places
add_element_to_geometry_list(&global_geometry_list,global_geometry_element);
}
#line 333182 "MACS_sample_kidney_box.c"
#undef number_of_activations
#undef mask_setting
#undef mask_string
#undef p_interact
#undef focus_r
#undef focus_xh
#undef focus_xw
#undef focus_ah
#undef focus_aw
#undef target_z
#undef target_y
#undef target_x
#undef target_index
#undef visualize
#undef yheight2
#undef xwidth2
#undef zdepth
#undef yheight
#undef xwidth
#undef priority
#undef material_string
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

  /* Initializations for component channel_19_analyzer_1_array_crystal_array_1. */
  SIG_MESSAGE("channel_19_analyzer_1_array_crystal_array_1 (Init)");
#define mccompcurname  channel_19_analyzer_1_array_crystal_array_1
#define mccompcurtype  Union_box
#define mccompcurindex 853
#define loop_index mccchannel_19_analyzer_1_array_crystal_array_1_loop_index
#define this_box_volume mccchannel_19_analyzer_1_array_crystal_array_1_this_box_volume
#define global_geometry_element mccchannel_19_analyzer_1_array_crystal_array_1_global_geometry_element
#define this_box_storage mccchannel_19_analyzer_1_array_crystal_array_1_this_box_storage
#define material_string mccchannel_19_analyzer_1_array_crystal_array_1_material_string
#define priority mccchannel_19_analyzer_1_array_crystal_array_1_priority
#define xwidth mccchannel_19_analyzer_1_array_crystal_array_1_xwidth
#define yheight mccchannel_19_analyzer_1_array_crystal_array_1_yheight
#define zdepth mccchannel_19_analyzer_1_array_crystal_array_1_zdepth
#define xwidth2 mccchannel_19_analyzer_1_array_crystal_array_1_xwidth2
#define yheight2 mccchannel_19_analyzer_1_array_crystal_array_1_yheight2
#define visualize mccchannel_19_analyzer_1_array_crystal_array_1_visualize
#define target_index mccchannel_19_analyzer_1_array_crystal_array_1_target_index
#define target_x mccchannel_19_analyzer_1_array_crystal_array_1_target_x
#define target_y mccchannel_19_analyzer_1_array_crystal_array_1_target_y
#define target_z mccchannel_19_analyzer_1_array_crystal_array_1_target_z
#define focus_aw mccchannel_19_analyzer_1_array_crystal_array_1_focus_aw
#define focus_ah mccchannel_19_analyzer_1_array_crystal_array_1_focus_ah
#define focus_xw mccchannel_19_analyzer_1_array_crystal_array_1_focus_xw
#define focus_xh mccchannel_19_analyzer_1_array_crystal_array_1_focus_xh
#define focus_r mccchannel_19_analyzer_1_array_crystal_array_1_focus_r
#define p_interact mccchannel_19_analyzer_1_array_crystal_array_1_p_interact
#define mask_string mccchannel_19_analyzer_1_array_crystal_array_1_mask_string
#define mask_setting mccchannel_19_analyzer_1_array_crystal_array_1_mask_setting
#define number_of_activations mccchannel_19_analyzer_1_array_crystal_array_1_number_of_activations
#line 224 "Union_box.comp"
{
// Initializes the focusing system for this volume including input sanitation.
focus_initialize(&this_box_volume.geometry, POS_A_COMP_INDEX(INDEX_CURRENT_COMP+target_index), POS_A_CURRENT_COMP, ROT_A_CURRENT_COMP, target_index, target_x, target_y, target_z, focus_aw, focus_ah, focus_xw, focus_xh, focus_r, NAME_CURRENT_COMP);

// Input sanitation for this geometry
if (xwidth <= 0) {
  printf("\nERROR in Union_box named %s, the xwidth is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (yheight <= 0) {
  printf("\nERROR in Union_box named %s, yheight is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (zdepth <= 0) {
  printf("\nERROR in Union_box named %s, zdepth is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (xwidth2 <= 0 && xwidth2 != -1) {
  printf("\nERROR in Union_box named %s, the xwidth2 is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (yheight2 <= 0 && yheight2 != -1) {
  printf("\nERROR in Union_box named %s, yheight2 is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}

// Use sanitation
if (global_material_list.num_elements == 0) {
  printf("\nERROR: Need to define a material using Union_make_material before using a Union geometry component. \n");
  printf("       %s was defined before first use of Union_make_material.\n",NAME_CURRENT_COMP);
  exit(1);
}

this_box_volume.geometry.is_masked_volume = 0;
this_box_volume.geometry.is_exit_volume = 0;
this_box_volume.geometry.is_mask_volume = 0;
// check if the volume is a mask, if it is the material string is irelevant.
if (mask_string && strlen(mask_string) && strcmp(mask_string, "NULL") && strcmp(mask_string, "0")) {
    // A mask volume is used to limit the extend of other volumes, called the masked volumes. These are specified in the mask_string.
    // In order for a ray to enter a masked volume, it needs to be both in the region covered by that volume AND the mask volume.
    // When more than
    this_box_volume.geometry.mask_mode = 1; // Default is mask mode is ALL
    if (mask_setting && strlen(mask_setting) && strcmp(mask_setting, "NULL") && strcmp(mask_setting, "0")) {
        if (strcmp(mask_setting,"ALL") == 0 || strcmp(mask_setting,"All") == 0) this_box_volume.geometry.mask_mode = 1;
        else if (strcmp(mask_setting,"ANY") == 0 || strcmp(mask_setting,"Any") == 0) this_box_volume.geometry.mask_mode = 2;
        else {
            printf("The mask_mode of component %s is set to %s, but must be either ALL or ANY.\n",NAME_CURRENT_COMP,mask_setting);
            exit(1);
        }
    }
    
    for (loop_index=0;loop_index<global_geometry_list.num_elements;loop_index++) {
        // Add mask list
        if (1 == manual_linking_function(global_geometry_list.elements[loop_index].name,mask_string)) {
            add_element_to_int_list(&this_box_volume.geometry.mask_list,global_geometry_list.elements[loop_index].component_index);
            add_element_to_int_list(&global_geometry_list.elements[loop_index].Volume->geometry.masked_by_list,INDEX_CURRENT_COMP);
            global_geometry_list.elements[loop_index].Volume->geometry.is_masked_volume = 1;
            if (this_box_volume.geometry.mask_mode == 2)
                global_geometry_list.elements[loop_index].Volume->geometry.mask_mode = 2;
            if (this_box_volume.geometry.mask_mode == 1) {
                if (global_geometry_list.elements[loop_index].Volume->geometry.is_masked_volume == 1 && global_geometry_list.elements[loop_index].Volume->geometry.mask_mode != 2)
                    // If more than one mask is added to one volume, the ANY mode overwrites the (default) ALL mode.
                    global_geometry_list.elements[loop_index].Volume->geometry.mask_mode = 1;
            }
            
            found_geometries = 1;
        }
    }
    if (found_geometries == 0) {
        printf("The mask_string in geometry: %s did not find any of the specified volumes in the mask_string %s \n",NAME_CURRENT_COMP,mask_string);
        exit(1);
    }
    this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
    this_box_volume.p_physics->is_vacuum = 0; // Makes this volume a vacuum
    this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
    this_box_volume.p_physics->my_a = 0; // Should not be used.
    sprintf(this_box_volume.p_physics->name,"Mask");
    this_box_volume.geometry.is_mask_volume = 1;
    
    
// Read the material input, or if it lacks, use automatic linking.
} else if (material_string && strlen(material_string) && strcmp(material_string, "NULL") && strcmp(material_string, "0")) {
    // A geometry string was given, use it to determine which material
    if (0 == strcmp(material_string,"vacuum") || 0 == strcmp(material_string,"Vacuum")) {
        // One could have a global physics struct for vacuum instead of creating one for each
        this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
        this_box_volume.p_physics->is_vacuum = 1; // Makes this volume a vacuum
        this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
        this_box_volume.p_physics->my_a = 0; // Should not be used.
        sprintf(this_box_volume.p_physics->name,"Vacuum");
    } else if (0 == strcmp(material_string,"exit") || 0 == strcmp(material_string,"Exit")) {
        // One could have a global physics struct for vacuum instead of creating one for each
        this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
        this_box_volume.p_physics->is_vacuum = 1; // Makes this volume a vacuum
        this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
        this_box_volume.p_physics->my_a = 0; // Should not be used.
        this_box_volume.geometry.is_exit_volume = 1;
        sprintf(this_box_volume.p_physics->name,"Exit");
    } else {
        #ifndef MATERIAL_DETECTOR
            printf("Need to define a material before refering to it in a geometry %s.\n",NAME_CURRENT_COMP);
            exit(1);
        #endif
        for (loop_index=0;loop_index<global_material_list.num_elements;loop_index++) {
            if (0 == strcmp(material_string,global_material_list.elements[loop_index].name)) {
                this_box_volume.p_physics = global_material_list.elements[loop_index].physics;
                break;
            }
            if (loop_index == global_material_list.num_elements-1) {
            printf("\n");
            printf("ERROR: The material string \"%s\" in Union geometry \"%s\" did not match a specified material. \n",material_string,NAME_CURRENT_COMP);
            printf("       The materials available at this point (need to be defined before the geometry): \n");
            for (loop_index=0;loop_index<global_material_list.num_elements;loop_index++)
              printf("         %s\n",global_material_list.elements[loop_index].name);
            printf("\n");
            printf("       It is also possible to use one of the defualt materials avaiable: \n");
            printf("           Vacuum (for a Volume without scattering or absorption)\n");
            printf("           Exit (for a Volume where the ray exits the component if it enters)\n");
            printf("           Mask (for a Volume that masks existing volumes specified in the mask_string\n");
            exit(1);
          }
        }
    }
} else {
    // Automatic linking, simply using the last defined material.
    #ifndef MATERIAL_DETECTOR
        printf("Need to define a material before the geometry to use automatic linking %s.\n",NAME_CURRENT_COMP);
        exit(1);
    #endif
    this_box_volume.p_physics = global_material_list.elements[global_material_list.num_elements-1].physics;
}

sprintf(this_box_volume.name,NAME_CURRENT_COMP);
sprintf(this_box_volume.geometry.shape,"box");
this_box_volume.geometry.priority_value = priority;
this_box_volume.geometry.geometry_p_interact = p_interact;
// Currently the coordinates will be in absolute space.
this_box_volume.geometry.center = POS_A_CURRENT_COMP;

this_box_storage.z_depth = zdepth;
this_box_storage.x_width1 = xwidth;
this_box_storage.y_height1 = yheight;

this_box_storage.is_rectangle = 0;
if (xwidth2 < 0 && yheight2 < 0) this_box_storage.is_rectangle = 1;
if (xwidth == xwidth2 && yheight == yheight2) this_box_storage.is_rectangle = 1;

if (xwidth2 < 0) {
    this_box_storage.x_width2 = xwidth;
    xwidth2 = xwidth;
} else this_box_storage.x_width2 = xwidth2;

if (yheight2 < 0) {
    this_box_storage.y_height2 = yheight;
    yheight2 = yheight;
} else this_box_storage.y_height2 = yheight2;


this_box_storage.normal_vectors[0] = coords_set(0,0,1);
this_box_storage.normal_vectors[1] = coords_set(0,0,1);

// for sides with y component = 0
x_component = 2*zdepth/sqrt((xwidth-xwidth2)*(xwidth-xwidth2)+4*zdepth*zdepth);
z_component = (xwidth-xwidth2)/sqrt(4*zdepth*zdepth+(xwidth-xwidth2)*(xwidth-xwidth2));

this_box_storage.normal_vectors[2] = coords_set(x_component,0,z_component);
this_box_storage.normal_vectors[3] = coords_set(-x_component,0,z_component);

// for sides with x component = 0
y_component = 2*zdepth/sqrt((yheight-yheight2)*(yheight-yheight2)+4*zdepth*zdepth);
z_component = (yheight-yheight2)/sqrt(4*zdepth*zdepth+(yheight-yheight2)*(yheight-yheight2));

this_box_storage.normal_vectors[4] = coords_set(0,y_component,z_component);
this_box_storage.normal_vectors[5] = coords_set(0,-y_component,z_component);

this_box_volume.geometry.visualization_on = visualize;

this_box_volume.geometry.geometry_parameters.p_box_storage = &this_box_storage;

// Assign pointers to functions for intersection with the shape, checking if a point is inside the shape
if (this_box_storage.is_rectangle == 1) {
this_box_volume.geometry.intersect_function = &sample_box_intersect_simple;
this_box_volume.geometry.within_function = &r_within_box_simple;
}
else {
this_box_volume.geometry.intersect_function = &sample_box_intersect_advanced;
this_box_volume.geometry.within_function = &r_within_box_advanced;
}

this_box_volume.geometry.shell_points = &box_shell_points;
this_box_volume.geometry.mcdisplay_function = &mcdisplay_box_function;
this_box_volume.geometry.initialize_from_main_function = &initialize_box_geometry_from_main_component;
this_box_volume.geometry.process_rot_allocated = 0;

this_box_volume.geometry.copy_geometry_parameters = &allocate_box_storage_copy;

rot_copy(this_box_volume.geometry.rotation_matrix,ROT_A_CURRENT_COMP); //check how ROT_R_CURRENT_COMP would work
rot_transpose(ROT_A_CURRENT_COMP,this_box_volume.geometry.transpose_rotation_matrix);

// Initialize loggers
this_box_volume.loggers.num_elements = 0;

// packing the information into the global_geometry_element, which is then included in the global_geometry_list.
sprintf(global_geometry_element.name,NAME_CURRENT_COMP);
global_geometry_element.activation_counter = number_of_activations;
global_geometry_element.component_index = INDEX_CURRENT_COMP;
global_geometry_element.Volume = &this_box_volume; // Would be nicer if this m was a pointer, now we have the (small) data two places
add_element_to_geometry_list(&global_geometry_list,global_geometry_element);
}
#line 333452 "MACS_sample_kidney_box.c"
#undef number_of_activations
#undef mask_setting
#undef mask_string
#undef p_interact
#undef focus_r
#undef focus_xh
#undef focus_xw
#undef focus_ah
#undef focus_aw
#undef target_z
#undef target_y
#undef target_x
#undef target_index
#undef visualize
#undef yheight2
#undef xwidth2
#undef zdepth
#undef yheight
#undef xwidth
#undef priority
#undef material_string
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

  /* Initializations for component channel_19_analyzer_1_array_crystal_array_2. */
  SIG_MESSAGE("channel_19_analyzer_1_array_crystal_array_2 (Init)");
#define mccompcurname  channel_19_analyzer_1_array_crystal_array_2
#define mccompcurtype  Union_box
#define mccompcurindex 854
#define loop_index mccchannel_19_analyzer_1_array_crystal_array_2_loop_index
#define this_box_volume mccchannel_19_analyzer_1_array_crystal_array_2_this_box_volume
#define global_geometry_element mccchannel_19_analyzer_1_array_crystal_array_2_global_geometry_element
#define this_box_storage mccchannel_19_analyzer_1_array_crystal_array_2_this_box_storage
#define material_string mccchannel_19_analyzer_1_array_crystal_array_2_material_string
#define priority mccchannel_19_analyzer_1_array_crystal_array_2_priority
#define xwidth mccchannel_19_analyzer_1_array_crystal_array_2_xwidth
#define yheight mccchannel_19_analyzer_1_array_crystal_array_2_yheight
#define zdepth mccchannel_19_analyzer_1_array_crystal_array_2_zdepth
#define xwidth2 mccchannel_19_analyzer_1_array_crystal_array_2_xwidth2
#define yheight2 mccchannel_19_analyzer_1_array_crystal_array_2_yheight2
#define visualize mccchannel_19_analyzer_1_array_crystal_array_2_visualize
#define target_index mccchannel_19_analyzer_1_array_crystal_array_2_target_index
#define target_x mccchannel_19_analyzer_1_array_crystal_array_2_target_x
#define target_y mccchannel_19_analyzer_1_array_crystal_array_2_target_y
#define target_z mccchannel_19_analyzer_1_array_crystal_array_2_target_z
#define focus_aw mccchannel_19_analyzer_1_array_crystal_array_2_focus_aw
#define focus_ah mccchannel_19_analyzer_1_array_crystal_array_2_focus_ah
#define focus_xw mccchannel_19_analyzer_1_array_crystal_array_2_focus_xw
#define focus_xh mccchannel_19_analyzer_1_array_crystal_array_2_focus_xh
#define focus_r mccchannel_19_analyzer_1_array_crystal_array_2_focus_r
#define p_interact mccchannel_19_analyzer_1_array_crystal_array_2_p_interact
#define mask_string mccchannel_19_analyzer_1_array_crystal_array_2_mask_string
#define mask_setting mccchannel_19_analyzer_1_array_crystal_array_2_mask_setting
#define number_of_activations mccchannel_19_analyzer_1_array_crystal_array_2_number_of_activations
#line 224 "Union_box.comp"
{
// Initializes the focusing system for this volume including input sanitation.
focus_initialize(&this_box_volume.geometry, POS_A_COMP_INDEX(INDEX_CURRENT_COMP+target_index), POS_A_CURRENT_COMP, ROT_A_CURRENT_COMP, target_index, target_x, target_y, target_z, focus_aw, focus_ah, focus_xw, focus_xh, focus_r, NAME_CURRENT_COMP);

// Input sanitation for this geometry
if (xwidth <= 0) {
  printf("\nERROR in Union_box named %s, the xwidth is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (yheight <= 0) {
  printf("\nERROR in Union_box named %s, yheight is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (zdepth <= 0) {
  printf("\nERROR in Union_box named %s, zdepth is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (xwidth2 <= 0 && xwidth2 != -1) {
  printf("\nERROR in Union_box named %s, the xwidth2 is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (yheight2 <= 0 && yheight2 != -1) {
  printf("\nERROR in Union_box named %s, yheight2 is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}

// Use sanitation
if (global_material_list.num_elements == 0) {
  printf("\nERROR: Need to define a material using Union_make_material before using a Union geometry component. \n");
  printf("       %s was defined before first use of Union_make_material.\n",NAME_CURRENT_COMP);
  exit(1);
}

this_box_volume.geometry.is_masked_volume = 0;
this_box_volume.geometry.is_exit_volume = 0;
this_box_volume.geometry.is_mask_volume = 0;
// check if the volume is a mask, if it is the material string is irelevant.
if (mask_string && strlen(mask_string) && strcmp(mask_string, "NULL") && strcmp(mask_string, "0")) {
    // A mask volume is used to limit the extend of other volumes, called the masked volumes. These are specified in the mask_string.
    // In order for a ray to enter a masked volume, it needs to be both in the region covered by that volume AND the mask volume.
    // When more than
    this_box_volume.geometry.mask_mode = 1; // Default is mask mode is ALL
    if (mask_setting && strlen(mask_setting) && strcmp(mask_setting, "NULL") && strcmp(mask_setting, "0")) {
        if (strcmp(mask_setting,"ALL") == 0 || strcmp(mask_setting,"All") == 0) this_box_volume.geometry.mask_mode = 1;
        else if (strcmp(mask_setting,"ANY") == 0 || strcmp(mask_setting,"Any") == 0) this_box_volume.geometry.mask_mode = 2;
        else {
            printf("The mask_mode of component %s is set to %s, but must be either ALL or ANY.\n",NAME_CURRENT_COMP,mask_setting);
            exit(1);
        }
    }
    
    for (loop_index=0;loop_index<global_geometry_list.num_elements;loop_index++) {
        // Add mask list
        if (1 == manual_linking_function(global_geometry_list.elements[loop_index].name,mask_string)) {
            add_element_to_int_list(&this_box_volume.geometry.mask_list,global_geometry_list.elements[loop_index].component_index);
            add_element_to_int_list(&global_geometry_list.elements[loop_index].Volume->geometry.masked_by_list,INDEX_CURRENT_COMP);
            global_geometry_list.elements[loop_index].Volume->geometry.is_masked_volume = 1;
            if (this_box_volume.geometry.mask_mode == 2)
                global_geometry_list.elements[loop_index].Volume->geometry.mask_mode = 2;
            if (this_box_volume.geometry.mask_mode == 1) {
                if (global_geometry_list.elements[loop_index].Volume->geometry.is_masked_volume == 1 && global_geometry_list.elements[loop_index].Volume->geometry.mask_mode != 2)
                    // If more than one mask is added to one volume, the ANY mode overwrites the (default) ALL mode.
                    global_geometry_list.elements[loop_index].Volume->geometry.mask_mode = 1;
            }
            
            found_geometries = 1;
        }
    }
    if (found_geometries == 0) {
        printf("The mask_string in geometry: %s did not find any of the specified volumes in the mask_string %s \n",NAME_CURRENT_COMP,mask_string);
        exit(1);
    }
    this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
    this_box_volume.p_physics->is_vacuum = 0; // Makes this volume a vacuum
    this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
    this_box_volume.p_physics->my_a = 0; // Should not be used.
    sprintf(this_box_volume.p_physics->name,"Mask");
    this_box_volume.geometry.is_mask_volume = 1;
    
    
// Read the material input, or if it lacks, use automatic linking.
} else if (material_string && strlen(material_string) && strcmp(material_string, "NULL") && strcmp(material_string, "0")) {
    // A geometry string was given, use it to determine which material
    if (0 == strcmp(material_string,"vacuum") || 0 == strcmp(material_string,"Vacuum")) {
        // One could have a global physics struct for vacuum instead of creating one for each
        this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
        this_box_volume.p_physics->is_vacuum = 1; // Makes this volume a vacuum
        this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
        this_box_volume.p_physics->my_a = 0; // Should not be used.
        sprintf(this_box_volume.p_physics->name,"Vacuum");
    } else if (0 == strcmp(material_string,"exit") || 0 == strcmp(material_string,"Exit")) {
        // One could have a global physics struct for vacuum instead of creating one for each
        this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
        this_box_volume.p_physics->is_vacuum = 1; // Makes this volume a vacuum
        this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
        this_box_volume.p_physics->my_a = 0; // Should not be used.
        this_box_volume.geometry.is_exit_volume = 1;
        sprintf(this_box_volume.p_physics->name,"Exit");
    } else {
        #ifndef MATERIAL_DETECTOR
            printf("Need to define a material before refering to it in a geometry %s.\n",NAME_CURRENT_COMP);
            exit(1);
        #endif
        for (loop_index=0;loop_index<global_material_list.num_elements;loop_index++) {
            if (0 == strcmp(material_string,global_material_list.elements[loop_index].name)) {
                this_box_volume.p_physics = global_material_list.elements[loop_index].physics;
                break;
            }
            if (loop_index == global_material_list.num_elements-1) {
            printf("\n");
            printf("ERROR: The material string \"%s\" in Union geometry \"%s\" did not match a specified material. \n",material_string,NAME_CURRENT_COMP);
            printf("       The materials available at this point (need to be defined before the geometry): \n");
            for (loop_index=0;loop_index<global_material_list.num_elements;loop_index++)
              printf("         %s\n",global_material_list.elements[loop_index].name);
            printf("\n");
            printf("       It is also possible to use one of the defualt materials avaiable: \n");
            printf("           Vacuum (for a Volume without scattering or absorption)\n");
            printf("           Exit (for a Volume where the ray exits the component if it enters)\n");
            printf("           Mask (for a Volume that masks existing volumes specified in the mask_string\n");
            exit(1);
          }
        }
    }
} else {
    // Automatic linking, simply using the last defined material.
    #ifndef MATERIAL_DETECTOR
        printf("Need to define a material before the geometry to use automatic linking %s.\n",NAME_CURRENT_COMP);
        exit(1);
    #endif
    this_box_volume.p_physics = global_material_list.elements[global_material_list.num_elements-1].physics;
}

sprintf(this_box_volume.name,NAME_CURRENT_COMP);
sprintf(this_box_volume.geometry.shape,"box");
this_box_volume.geometry.priority_value = priority;
this_box_volume.geometry.geometry_p_interact = p_interact;
// Currently the coordinates will be in absolute space.
this_box_volume.geometry.center = POS_A_CURRENT_COMP;

this_box_storage.z_depth = zdepth;
this_box_storage.x_width1 = xwidth;
this_box_storage.y_height1 = yheight;

this_box_storage.is_rectangle = 0;
if (xwidth2 < 0 && yheight2 < 0) this_box_storage.is_rectangle = 1;
if (xwidth == xwidth2 && yheight == yheight2) this_box_storage.is_rectangle = 1;

if (xwidth2 < 0) {
    this_box_storage.x_width2 = xwidth;
    xwidth2 = xwidth;
} else this_box_storage.x_width2 = xwidth2;

if (yheight2 < 0) {
    this_box_storage.y_height2 = yheight;
    yheight2 = yheight;
} else this_box_storage.y_height2 = yheight2;


this_box_storage.normal_vectors[0] = coords_set(0,0,1);
this_box_storage.normal_vectors[1] = coords_set(0,0,1);

// for sides with y component = 0
x_component = 2*zdepth/sqrt((xwidth-xwidth2)*(xwidth-xwidth2)+4*zdepth*zdepth);
z_component = (xwidth-xwidth2)/sqrt(4*zdepth*zdepth+(xwidth-xwidth2)*(xwidth-xwidth2));

this_box_storage.normal_vectors[2] = coords_set(x_component,0,z_component);
this_box_storage.normal_vectors[3] = coords_set(-x_component,0,z_component);

// for sides with x component = 0
y_component = 2*zdepth/sqrt((yheight-yheight2)*(yheight-yheight2)+4*zdepth*zdepth);
z_component = (yheight-yheight2)/sqrt(4*zdepth*zdepth+(yheight-yheight2)*(yheight-yheight2));

this_box_storage.normal_vectors[4] = coords_set(0,y_component,z_component);
this_box_storage.normal_vectors[5] = coords_set(0,-y_component,z_component);

this_box_volume.geometry.visualization_on = visualize;

this_box_volume.geometry.geometry_parameters.p_box_storage = &this_box_storage;

// Assign pointers to functions for intersection with the shape, checking if a point is inside the shape
if (this_box_storage.is_rectangle == 1) {
this_box_volume.geometry.intersect_function = &sample_box_intersect_simple;
this_box_volume.geometry.within_function = &r_within_box_simple;
}
else {
this_box_volume.geometry.intersect_function = &sample_box_intersect_advanced;
this_box_volume.geometry.within_function = &r_within_box_advanced;
}

this_box_volume.geometry.shell_points = &box_shell_points;
this_box_volume.geometry.mcdisplay_function = &mcdisplay_box_function;
this_box_volume.geometry.initialize_from_main_function = &initialize_box_geometry_from_main_component;
this_box_volume.geometry.process_rot_allocated = 0;

this_box_volume.geometry.copy_geometry_parameters = &allocate_box_storage_copy;

rot_copy(this_box_volume.geometry.rotation_matrix,ROT_A_CURRENT_COMP); //check how ROT_R_CURRENT_COMP would work
rot_transpose(ROT_A_CURRENT_COMP,this_box_volume.geometry.transpose_rotation_matrix);

// Initialize loggers
this_box_volume.loggers.num_elements = 0;

// packing the information into the global_geometry_element, which is then included in the global_geometry_list.
sprintf(global_geometry_element.name,NAME_CURRENT_COMP);
global_geometry_element.activation_counter = number_of_activations;
global_geometry_element.component_index = INDEX_CURRENT_COMP;
global_geometry_element.Volume = &this_box_volume; // Would be nicer if this m was a pointer, now we have the (small) data two places
add_element_to_geometry_list(&global_geometry_list,global_geometry_element);
}
#line 333722 "MACS_sample_kidney_box.c"
#undef number_of_activations
#undef mask_setting
#undef mask_string
#undef p_interact
#undef focus_r
#undef focus_xh
#undef focus_xw
#undef focus_ah
#undef focus_aw
#undef target_z
#undef target_y
#undef target_x
#undef target_index
#undef visualize
#undef yheight2
#undef xwidth2
#undef zdepth
#undef yheight
#undef xwidth
#undef priority
#undef material_string
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

  /* Initializations for component channel_19_analyzer_1_array_crystal_array_3. */
  SIG_MESSAGE("channel_19_analyzer_1_array_crystal_array_3 (Init)");
#define mccompcurname  channel_19_analyzer_1_array_crystal_array_3
#define mccompcurtype  Union_box
#define mccompcurindex 855
#define loop_index mccchannel_19_analyzer_1_array_crystal_array_3_loop_index
#define this_box_volume mccchannel_19_analyzer_1_array_crystal_array_3_this_box_volume
#define global_geometry_element mccchannel_19_analyzer_1_array_crystal_array_3_global_geometry_element
#define this_box_storage mccchannel_19_analyzer_1_array_crystal_array_3_this_box_storage
#define material_string mccchannel_19_analyzer_1_array_crystal_array_3_material_string
#define priority mccchannel_19_analyzer_1_array_crystal_array_3_priority
#define xwidth mccchannel_19_analyzer_1_array_crystal_array_3_xwidth
#define yheight mccchannel_19_analyzer_1_array_crystal_array_3_yheight
#define zdepth mccchannel_19_analyzer_1_array_crystal_array_3_zdepth
#define xwidth2 mccchannel_19_analyzer_1_array_crystal_array_3_xwidth2
#define yheight2 mccchannel_19_analyzer_1_array_crystal_array_3_yheight2
#define visualize mccchannel_19_analyzer_1_array_crystal_array_3_visualize
#define target_index mccchannel_19_analyzer_1_array_crystal_array_3_target_index
#define target_x mccchannel_19_analyzer_1_array_crystal_array_3_target_x
#define target_y mccchannel_19_analyzer_1_array_crystal_array_3_target_y
#define target_z mccchannel_19_analyzer_1_array_crystal_array_3_target_z
#define focus_aw mccchannel_19_analyzer_1_array_crystal_array_3_focus_aw
#define focus_ah mccchannel_19_analyzer_1_array_crystal_array_3_focus_ah
#define focus_xw mccchannel_19_analyzer_1_array_crystal_array_3_focus_xw
#define focus_xh mccchannel_19_analyzer_1_array_crystal_array_3_focus_xh
#define focus_r mccchannel_19_analyzer_1_array_crystal_array_3_focus_r
#define p_interact mccchannel_19_analyzer_1_array_crystal_array_3_p_interact
#define mask_string mccchannel_19_analyzer_1_array_crystal_array_3_mask_string
#define mask_setting mccchannel_19_analyzer_1_array_crystal_array_3_mask_setting
#define number_of_activations mccchannel_19_analyzer_1_array_crystal_array_3_number_of_activations
#line 224 "Union_box.comp"
{
// Initializes the focusing system for this volume including input sanitation.
focus_initialize(&this_box_volume.geometry, POS_A_COMP_INDEX(INDEX_CURRENT_COMP+target_index), POS_A_CURRENT_COMP, ROT_A_CURRENT_COMP, target_index, target_x, target_y, target_z, focus_aw, focus_ah, focus_xw, focus_xh, focus_r, NAME_CURRENT_COMP);

// Input sanitation for this geometry
if (xwidth <= 0) {
  printf("\nERROR in Union_box named %s, the xwidth is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (yheight <= 0) {
  printf("\nERROR in Union_box named %s, yheight is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (zdepth <= 0) {
  printf("\nERROR in Union_box named %s, zdepth is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (xwidth2 <= 0 && xwidth2 != -1) {
  printf("\nERROR in Union_box named %s, the xwidth2 is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (yheight2 <= 0 && yheight2 != -1) {
  printf("\nERROR in Union_box named %s, yheight2 is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}

// Use sanitation
if (global_material_list.num_elements == 0) {
  printf("\nERROR: Need to define a material using Union_make_material before using a Union geometry component. \n");
  printf("       %s was defined before first use of Union_make_material.\n",NAME_CURRENT_COMP);
  exit(1);
}

this_box_volume.geometry.is_masked_volume = 0;
this_box_volume.geometry.is_exit_volume = 0;
this_box_volume.geometry.is_mask_volume = 0;
// check if the volume is a mask, if it is the material string is irelevant.
if (mask_string && strlen(mask_string) && strcmp(mask_string, "NULL") && strcmp(mask_string, "0")) {
    // A mask volume is used to limit the extend of other volumes, called the masked volumes. These are specified in the mask_string.
    // In order for a ray to enter a masked volume, it needs to be both in the region covered by that volume AND the mask volume.
    // When more than
    this_box_volume.geometry.mask_mode = 1; // Default is mask mode is ALL
    if (mask_setting && strlen(mask_setting) && strcmp(mask_setting, "NULL") && strcmp(mask_setting, "0")) {
        if (strcmp(mask_setting,"ALL") == 0 || strcmp(mask_setting,"All") == 0) this_box_volume.geometry.mask_mode = 1;
        else if (strcmp(mask_setting,"ANY") == 0 || strcmp(mask_setting,"Any") == 0) this_box_volume.geometry.mask_mode = 2;
        else {
            printf("The mask_mode of component %s is set to %s, but must be either ALL or ANY.\n",NAME_CURRENT_COMP,mask_setting);
            exit(1);
        }
    }
    
    for (loop_index=0;loop_index<global_geometry_list.num_elements;loop_index++) {
        // Add mask list
        if (1 == manual_linking_function(global_geometry_list.elements[loop_index].name,mask_string)) {
            add_element_to_int_list(&this_box_volume.geometry.mask_list,global_geometry_list.elements[loop_index].component_index);
            add_element_to_int_list(&global_geometry_list.elements[loop_index].Volume->geometry.masked_by_list,INDEX_CURRENT_COMP);
            global_geometry_list.elements[loop_index].Volume->geometry.is_masked_volume = 1;
            if (this_box_volume.geometry.mask_mode == 2)
                global_geometry_list.elements[loop_index].Volume->geometry.mask_mode = 2;
            if (this_box_volume.geometry.mask_mode == 1) {
                if (global_geometry_list.elements[loop_index].Volume->geometry.is_masked_volume == 1 && global_geometry_list.elements[loop_index].Volume->geometry.mask_mode != 2)
                    // If more than one mask is added to one volume, the ANY mode overwrites the (default) ALL mode.
                    global_geometry_list.elements[loop_index].Volume->geometry.mask_mode = 1;
            }
            
            found_geometries = 1;
        }
    }
    if (found_geometries == 0) {
        printf("The mask_string in geometry: %s did not find any of the specified volumes in the mask_string %s \n",NAME_CURRENT_COMP,mask_string);
        exit(1);
    }
    this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
    this_box_volume.p_physics->is_vacuum = 0; // Makes this volume a vacuum
    this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
    this_box_volume.p_physics->my_a = 0; // Should not be used.
    sprintf(this_box_volume.p_physics->name,"Mask");
    this_box_volume.geometry.is_mask_volume = 1;
    
    
// Read the material input, or if it lacks, use automatic linking.
} else if (material_string && strlen(material_string) && strcmp(material_string, "NULL") && strcmp(material_string, "0")) {
    // A geometry string was given, use it to determine which material
    if (0 == strcmp(material_string,"vacuum") || 0 == strcmp(material_string,"Vacuum")) {
        // One could have a global physics struct for vacuum instead of creating one for each
        this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
        this_box_volume.p_physics->is_vacuum = 1; // Makes this volume a vacuum
        this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
        this_box_volume.p_physics->my_a = 0; // Should not be used.
        sprintf(this_box_volume.p_physics->name,"Vacuum");
    } else if (0 == strcmp(material_string,"exit") || 0 == strcmp(material_string,"Exit")) {
        // One could have a global physics struct for vacuum instead of creating one for each
        this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
        this_box_volume.p_physics->is_vacuum = 1; // Makes this volume a vacuum
        this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
        this_box_volume.p_physics->my_a = 0; // Should not be used.
        this_box_volume.geometry.is_exit_volume = 1;
        sprintf(this_box_volume.p_physics->name,"Exit");
    } else {
        #ifndef MATERIAL_DETECTOR
            printf("Need to define a material before refering to it in a geometry %s.\n",NAME_CURRENT_COMP);
            exit(1);
        #endif
        for (loop_index=0;loop_index<global_material_list.num_elements;loop_index++) {
            if (0 == strcmp(material_string,global_material_list.elements[loop_index].name)) {
                this_box_volume.p_physics = global_material_list.elements[loop_index].physics;
                break;
            }
            if (loop_index == global_material_list.num_elements-1) {
            printf("\n");
            printf("ERROR: The material string \"%s\" in Union geometry \"%s\" did not match a specified material. \n",material_string,NAME_CURRENT_COMP);
            printf("       The materials available at this point (need to be defined before the geometry): \n");
            for (loop_index=0;loop_index<global_material_list.num_elements;loop_index++)
              printf("         %s\n",global_material_list.elements[loop_index].name);
            printf("\n");
            printf("       It is also possible to use one of the defualt materials avaiable: \n");
            printf("           Vacuum (for a Volume without scattering or absorption)\n");
            printf("           Exit (for a Volume where the ray exits the component if it enters)\n");
            printf("           Mask (for a Volume that masks existing volumes specified in the mask_string\n");
            exit(1);
          }
        }
    }
} else {
    // Automatic linking, simply using the last defined material.
    #ifndef MATERIAL_DETECTOR
        printf("Need to define a material before the geometry to use automatic linking %s.\n",NAME_CURRENT_COMP);
        exit(1);
    #endif
    this_box_volume.p_physics = global_material_list.elements[global_material_list.num_elements-1].physics;
}

sprintf(this_box_volume.name,NAME_CURRENT_COMP);
sprintf(this_box_volume.geometry.shape,"box");
this_box_volume.geometry.priority_value = priority;
this_box_volume.geometry.geometry_p_interact = p_interact;
// Currently the coordinates will be in absolute space.
this_box_volume.geometry.center = POS_A_CURRENT_COMP;

this_box_storage.z_depth = zdepth;
this_box_storage.x_width1 = xwidth;
this_box_storage.y_height1 = yheight;

this_box_storage.is_rectangle = 0;
if (xwidth2 < 0 && yheight2 < 0) this_box_storage.is_rectangle = 1;
if (xwidth == xwidth2 && yheight == yheight2) this_box_storage.is_rectangle = 1;

if (xwidth2 < 0) {
    this_box_storage.x_width2 = xwidth;
    xwidth2 = xwidth;
} else this_box_storage.x_width2 = xwidth2;

if (yheight2 < 0) {
    this_box_storage.y_height2 = yheight;
    yheight2 = yheight;
} else this_box_storage.y_height2 = yheight2;


this_box_storage.normal_vectors[0] = coords_set(0,0,1);
this_box_storage.normal_vectors[1] = coords_set(0,0,1);

// for sides with y component = 0
x_component = 2*zdepth/sqrt((xwidth-xwidth2)*(xwidth-xwidth2)+4*zdepth*zdepth);
z_component = (xwidth-xwidth2)/sqrt(4*zdepth*zdepth+(xwidth-xwidth2)*(xwidth-xwidth2));

this_box_storage.normal_vectors[2] = coords_set(x_component,0,z_component);
this_box_storage.normal_vectors[3] = coords_set(-x_component,0,z_component);

// for sides with x component = 0
y_component = 2*zdepth/sqrt((yheight-yheight2)*(yheight-yheight2)+4*zdepth*zdepth);
z_component = (yheight-yheight2)/sqrt(4*zdepth*zdepth+(yheight-yheight2)*(yheight-yheight2));

this_box_storage.normal_vectors[4] = coords_set(0,y_component,z_component);
this_box_storage.normal_vectors[5] = coords_set(0,-y_component,z_component);

this_box_volume.geometry.visualization_on = visualize;

this_box_volume.geometry.geometry_parameters.p_box_storage = &this_box_storage;

// Assign pointers to functions for intersection with the shape, checking if a point is inside the shape
if (this_box_storage.is_rectangle == 1) {
this_box_volume.geometry.intersect_function = &sample_box_intersect_simple;
this_box_volume.geometry.within_function = &r_within_box_simple;
}
else {
this_box_volume.geometry.intersect_function = &sample_box_intersect_advanced;
this_box_volume.geometry.within_function = &r_within_box_advanced;
}

this_box_volume.geometry.shell_points = &box_shell_points;
this_box_volume.geometry.mcdisplay_function = &mcdisplay_box_function;
this_box_volume.geometry.initialize_from_main_function = &initialize_box_geometry_from_main_component;
this_box_volume.geometry.process_rot_allocated = 0;

this_box_volume.geometry.copy_geometry_parameters = &allocate_box_storage_copy;

rot_copy(this_box_volume.geometry.rotation_matrix,ROT_A_CURRENT_COMP); //check how ROT_R_CURRENT_COMP would work
rot_transpose(ROT_A_CURRENT_COMP,this_box_volume.geometry.transpose_rotation_matrix);

// Initialize loggers
this_box_volume.loggers.num_elements = 0;

// packing the information into the global_geometry_element, which is then included in the global_geometry_list.
sprintf(global_geometry_element.name,NAME_CURRENT_COMP);
global_geometry_element.activation_counter = number_of_activations;
global_geometry_element.component_index = INDEX_CURRENT_COMP;
global_geometry_element.Volume = &this_box_volume; // Would be nicer if this m was a pointer, now we have the (small) data two places
add_element_to_geometry_list(&global_geometry_list,global_geometry_element);
}
#line 333992 "MACS_sample_kidney_box.c"
#undef number_of_activations
#undef mask_setting
#undef mask_string
#undef p_interact
#undef focus_r
#undef focus_xh
#undef focus_xw
#undef focus_ah
#undef focus_aw
#undef target_z
#undef target_y
#undef target_x
#undef target_index
#undef visualize
#undef yheight2
#undef xwidth2
#undef zdepth
#undef yheight
#undef xwidth
#undef priority
#undef material_string
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

  /* Initializations for component channel_19_analyzer_1_array_crystal_array_4. */
  SIG_MESSAGE("channel_19_analyzer_1_array_crystal_array_4 (Init)");
#define mccompcurname  channel_19_analyzer_1_array_crystal_array_4
#define mccompcurtype  Union_box
#define mccompcurindex 856
#define loop_index mccchannel_19_analyzer_1_array_crystal_array_4_loop_index
#define this_box_volume mccchannel_19_analyzer_1_array_crystal_array_4_this_box_volume
#define global_geometry_element mccchannel_19_analyzer_1_array_crystal_array_4_global_geometry_element
#define this_box_storage mccchannel_19_analyzer_1_array_crystal_array_4_this_box_storage
#define material_string mccchannel_19_analyzer_1_array_crystal_array_4_material_string
#define priority mccchannel_19_analyzer_1_array_crystal_array_4_priority
#define xwidth mccchannel_19_analyzer_1_array_crystal_array_4_xwidth
#define yheight mccchannel_19_analyzer_1_array_crystal_array_4_yheight
#define zdepth mccchannel_19_analyzer_1_array_crystal_array_4_zdepth
#define xwidth2 mccchannel_19_analyzer_1_array_crystal_array_4_xwidth2
#define yheight2 mccchannel_19_analyzer_1_array_crystal_array_4_yheight2
#define visualize mccchannel_19_analyzer_1_array_crystal_array_4_visualize
#define target_index mccchannel_19_analyzer_1_array_crystal_array_4_target_index
#define target_x mccchannel_19_analyzer_1_array_crystal_array_4_target_x
#define target_y mccchannel_19_analyzer_1_array_crystal_array_4_target_y
#define target_z mccchannel_19_analyzer_1_array_crystal_array_4_target_z
#define focus_aw mccchannel_19_analyzer_1_array_crystal_array_4_focus_aw
#define focus_ah mccchannel_19_analyzer_1_array_crystal_array_4_focus_ah
#define focus_xw mccchannel_19_analyzer_1_array_crystal_array_4_focus_xw
#define focus_xh mccchannel_19_analyzer_1_array_crystal_array_4_focus_xh
#define focus_r mccchannel_19_analyzer_1_array_crystal_array_4_focus_r
#define p_interact mccchannel_19_analyzer_1_array_crystal_array_4_p_interact
#define mask_string mccchannel_19_analyzer_1_array_crystal_array_4_mask_string
#define mask_setting mccchannel_19_analyzer_1_array_crystal_array_4_mask_setting
#define number_of_activations mccchannel_19_analyzer_1_array_crystal_array_4_number_of_activations
#line 224 "Union_box.comp"
{
// Initializes the focusing system for this volume including input sanitation.
focus_initialize(&this_box_volume.geometry, POS_A_COMP_INDEX(INDEX_CURRENT_COMP+target_index), POS_A_CURRENT_COMP, ROT_A_CURRENT_COMP, target_index, target_x, target_y, target_z, focus_aw, focus_ah, focus_xw, focus_xh, focus_r, NAME_CURRENT_COMP);

// Input sanitation for this geometry
if (xwidth <= 0) {
  printf("\nERROR in Union_box named %s, the xwidth is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (yheight <= 0) {
  printf("\nERROR in Union_box named %s, yheight is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (zdepth <= 0) {
  printf("\nERROR in Union_box named %s, zdepth is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (xwidth2 <= 0 && xwidth2 != -1) {
  printf("\nERROR in Union_box named %s, the xwidth2 is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (yheight2 <= 0 && yheight2 != -1) {
  printf("\nERROR in Union_box named %s, yheight2 is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}

// Use sanitation
if (global_material_list.num_elements == 0) {
  printf("\nERROR: Need to define a material using Union_make_material before using a Union geometry component. \n");
  printf("       %s was defined before first use of Union_make_material.\n",NAME_CURRENT_COMP);
  exit(1);
}

this_box_volume.geometry.is_masked_volume = 0;
this_box_volume.geometry.is_exit_volume = 0;
this_box_volume.geometry.is_mask_volume = 0;
// check if the volume is a mask, if it is the material string is irelevant.
if (mask_string && strlen(mask_string) && strcmp(mask_string, "NULL") && strcmp(mask_string, "0")) {
    // A mask volume is used to limit the extend of other volumes, called the masked volumes. These are specified in the mask_string.
    // In order for a ray to enter a masked volume, it needs to be both in the region covered by that volume AND the mask volume.
    // When more than
    this_box_volume.geometry.mask_mode = 1; // Default is mask mode is ALL
    if (mask_setting && strlen(mask_setting) && strcmp(mask_setting, "NULL") && strcmp(mask_setting, "0")) {
        if (strcmp(mask_setting,"ALL") == 0 || strcmp(mask_setting,"All") == 0) this_box_volume.geometry.mask_mode = 1;
        else if (strcmp(mask_setting,"ANY") == 0 || strcmp(mask_setting,"Any") == 0) this_box_volume.geometry.mask_mode = 2;
        else {
            printf("The mask_mode of component %s is set to %s, but must be either ALL or ANY.\n",NAME_CURRENT_COMP,mask_setting);
            exit(1);
        }
    }
    
    for (loop_index=0;loop_index<global_geometry_list.num_elements;loop_index++) {
        // Add mask list
        if (1 == manual_linking_function(global_geometry_list.elements[loop_index].name,mask_string)) {
            add_element_to_int_list(&this_box_volume.geometry.mask_list,global_geometry_list.elements[loop_index].component_index);
            add_element_to_int_list(&global_geometry_list.elements[loop_index].Volume->geometry.masked_by_list,INDEX_CURRENT_COMP);
            global_geometry_list.elements[loop_index].Volume->geometry.is_masked_volume = 1;
            if (this_box_volume.geometry.mask_mode == 2)
                global_geometry_list.elements[loop_index].Volume->geometry.mask_mode = 2;
            if (this_box_volume.geometry.mask_mode == 1) {
                if (global_geometry_list.elements[loop_index].Volume->geometry.is_masked_volume == 1 && global_geometry_list.elements[loop_index].Volume->geometry.mask_mode != 2)
                    // If more than one mask is added to one volume, the ANY mode overwrites the (default) ALL mode.
                    global_geometry_list.elements[loop_index].Volume->geometry.mask_mode = 1;
            }
            
            found_geometries = 1;
        }
    }
    if (found_geometries == 0) {
        printf("The mask_string in geometry: %s did not find any of the specified volumes in the mask_string %s \n",NAME_CURRENT_COMP,mask_string);
        exit(1);
    }
    this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
    this_box_volume.p_physics->is_vacuum = 0; // Makes this volume a vacuum
    this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
    this_box_volume.p_physics->my_a = 0; // Should not be used.
    sprintf(this_box_volume.p_physics->name,"Mask");
    this_box_volume.geometry.is_mask_volume = 1;
    
    
// Read the material input, or if it lacks, use automatic linking.
} else if (material_string && strlen(material_string) && strcmp(material_string, "NULL") && strcmp(material_string, "0")) {
    // A geometry string was given, use it to determine which material
    if (0 == strcmp(material_string,"vacuum") || 0 == strcmp(material_string,"Vacuum")) {
        // One could have a global physics struct for vacuum instead of creating one for each
        this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
        this_box_volume.p_physics->is_vacuum = 1; // Makes this volume a vacuum
        this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
        this_box_volume.p_physics->my_a = 0; // Should not be used.
        sprintf(this_box_volume.p_physics->name,"Vacuum");
    } else if (0 == strcmp(material_string,"exit") || 0 == strcmp(material_string,"Exit")) {
        // One could have a global physics struct for vacuum instead of creating one for each
        this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
        this_box_volume.p_physics->is_vacuum = 1; // Makes this volume a vacuum
        this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
        this_box_volume.p_physics->my_a = 0; // Should not be used.
        this_box_volume.geometry.is_exit_volume = 1;
        sprintf(this_box_volume.p_physics->name,"Exit");
    } else {
        #ifndef MATERIAL_DETECTOR
            printf("Need to define a material before refering to it in a geometry %s.\n",NAME_CURRENT_COMP);
            exit(1);
        #endif
        for (loop_index=0;loop_index<global_material_list.num_elements;loop_index++) {
            if (0 == strcmp(material_string,global_material_list.elements[loop_index].name)) {
                this_box_volume.p_physics = global_material_list.elements[loop_index].physics;
                break;
            }
            if (loop_index == global_material_list.num_elements-1) {
            printf("\n");
            printf("ERROR: The material string \"%s\" in Union geometry \"%s\" did not match a specified material. \n",material_string,NAME_CURRENT_COMP);
            printf("       The materials available at this point (need to be defined before the geometry): \n");
            for (loop_index=0;loop_index<global_material_list.num_elements;loop_index++)
              printf("         %s\n",global_material_list.elements[loop_index].name);
            printf("\n");
            printf("       It is also possible to use one of the defualt materials avaiable: \n");
            printf("           Vacuum (for a Volume without scattering or absorption)\n");
            printf("           Exit (for a Volume where the ray exits the component if it enters)\n");
            printf("           Mask (for a Volume that masks existing volumes specified in the mask_string\n");
            exit(1);
          }
        }
    }
} else {
    // Automatic linking, simply using the last defined material.
    #ifndef MATERIAL_DETECTOR
        printf("Need to define a material before the geometry to use automatic linking %s.\n",NAME_CURRENT_COMP);
        exit(1);
    #endif
    this_box_volume.p_physics = global_material_list.elements[global_material_list.num_elements-1].physics;
}

sprintf(this_box_volume.name,NAME_CURRENT_COMP);
sprintf(this_box_volume.geometry.shape,"box");
this_box_volume.geometry.priority_value = priority;
this_box_volume.geometry.geometry_p_interact = p_interact;
// Currently the coordinates will be in absolute space.
this_box_volume.geometry.center = POS_A_CURRENT_COMP;

this_box_storage.z_depth = zdepth;
this_box_storage.x_width1 = xwidth;
this_box_storage.y_height1 = yheight;

this_box_storage.is_rectangle = 0;
if (xwidth2 < 0 && yheight2 < 0) this_box_storage.is_rectangle = 1;
if (xwidth == xwidth2 && yheight == yheight2) this_box_storage.is_rectangle = 1;

if (xwidth2 < 0) {
    this_box_storage.x_width2 = xwidth;
    xwidth2 = xwidth;
} else this_box_storage.x_width2 = xwidth2;

if (yheight2 < 0) {
    this_box_storage.y_height2 = yheight;
    yheight2 = yheight;
} else this_box_storage.y_height2 = yheight2;


this_box_storage.normal_vectors[0] = coords_set(0,0,1);
this_box_storage.normal_vectors[1] = coords_set(0,0,1);

// for sides with y component = 0
x_component = 2*zdepth/sqrt((xwidth-xwidth2)*(xwidth-xwidth2)+4*zdepth*zdepth);
z_component = (xwidth-xwidth2)/sqrt(4*zdepth*zdepth+(xwidth-xwidth2)*(xwidth-xwidth2));

this_box_storage.normal_vectors[2] = coords_set(x_component,0,z_component);
this_box_storage.normal_vectors[3] = coords_set(-x_component,0,z_component);

// for sides with x component = 0
y_component = 2*zdepth/sqrt((yheight-yheight2)*(yheight-yheight2)+4*zdepth*zdepth);
z_component = (yheight-yheight2)/sqrt(4*zdepth*zdepth+(yheight-yheight2)*(yheight-yheight2));

this_box_storage.normal_vectors[4] = coords_set(0,y_component,z_component);
this_box_storage.normal_vectors[5] = coords_set(0,-y_component,z_component);

this_box_volume.geometry.visualization_on = visualize;

this_box_volume.geometry.geometry_parameters.p_box_storage = &this_box_storage;

// Assign pointers to functions for intersection with the shape, checking if a point is inside the shape
if (this_box_storage.is_rectangle == 1) {
this_box_volume.geometry.intersect_function = &sample_box_intersect_simple;
this_box_volume.geometry.within_function = &r_within_box_simple;
}
else {
this_box_volume.geometry.intersect_function = &sample_box_intersect_advanced;
this_box_volume.geometry.within_function = &r_within_box_advanced;
}

this_box_volume.geometry.shell_points = &box_shell_points;
this_box_volume.geometry.mcdisplay_function = &mcdisplay_box_function;
this_box_volume.geometry.initialize_from_main_function = &initialize_box_geometry_from_main_component;
this_box_volume.geometry.process_rot_allocated = 0;

this_box_volume.geometry.copy_geometry_parameters = &allocate_box_storage_copy;

rot_copy(this_box_volume.geometry.rotation_matrix,ROT_A_CURRENT_COMP); //check how ROT_R_CURRENT_COMP would work
rot_transpose(ROT_A_CURRENT_COMP,this_box_volume.geometry.transpose_rotation_matrix);

// Initialize loggers
this_box_volume.loggers.num_elements = 0;

// packing the information into the global_geometry_element, which is then included in the global_geometry_list.
sprintf(global_geometry_element.name,NAME_CURRENT_COMP);
global_geometry_element.activation_counter = number_of_activations;
global_geometry_element.component_index = INDEX_CURRENT_COMP;
global_geometry_element.Volume = &this_box_volume; // Would be nicer if this m was a pointer, now we have the (small) data two places
add_element_to_geometry_list(&global_geometry_list,global_geometry_element);
}
#line 334262 "MACS_sample_kidney_box.c"
#undef number_of_activations
#undef mask_setting
#undef mask_string
#undef p_interact
#undef focus_r
#undef focus_xh
#undef focus_xw
#undef focus_ah
#undef focus_aw
#undef target_z
#undef target_y
#undef target_x
#undef target_index
#undef visualize
#undef yheight2
#undef xwidth2
#undef zdepth
#undef yheight
#undef xwidth
#undef priority
#undef material_string
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

  /* Initializations for component channel_19_analyzer_1_array_crystal_array_5. */
  SIG_MESSAGE("channel_19_analyzer_1_array_crystal_array_5 (Init)");
#define mccompcurname  channel_19_analyzer_1_array_crystal_array_5
#define mccompcurtype  Union_box
#define mccompcurindex 857
#define loop_index mccchannel_19_analyzer_1_array_crystal_array_5_loop_index
#define this_box_volume mccchannel_19_analyzer_1_array_crystal_array_5_this_box_volume
#define global_geometry_element mccchannel_19_analyzer_1_array_crystal_array_5_global_geometry_element
#define this_box_storage mccchannel_19_analyzer_1_array_crystal_array_5_this_box_storage
#define material_string mccchannel_19_analyzer_1_array_crystal_array_5_material_string
#define priority mccchannel_19_analyzer_1_array_crystal_array_5_priority
#define xwidth mccchannel_19_analyzer_1_array_crystal_array_5_xwidth
#define yheight mccchannel_19_analyzer_1_array_crystal_array_5_yheight
#define zdepth mccchannel_19_analyzer_1_array_crystal_array_5_zdepth
#define xwidth2 mccchannel_19_analyzer_1_array_crystal_array_5_xwidth2
#define yheight2 mccchannel_19_analyzer_1_array_crystal_array_5_yheight2
#define visualize mccchannel_19_analyzer_1_array_crystal_array_5_visualize
#define target_index mccchannel_19_analyzer_1_array_crystal_array_5_target_index
#define target_x mccchannel_19_analyzer_1_array_crystal_array_5_target_x
#define target_y mccchannel_19_analyzer_1_array_crystal_array_5_target_y
#define target_z mccchannel_19_analyzer_1_array_crystal_array_5_target_z
#define focus_aw mccchannel_19_analyzer_1_array_crystal_array_5_focus_aw
#define focus_ah mccchannel_19_analyzer_1_array_crystal_array_5_focus_ah
#define focus_xw mccchannel_19_analyzer_1_array_crystal_array_5_focus_xw
#define focus_xh mccchannel_19_analyzer_1_array_crystal_array_5_focus_xh
#define focus_r mccchannel_19_analyzer_1_array_crystal_array_5_focus_r
#define p_interact mccchannel_19_analyzer_1_array_crystal_array_5_p_interact
#define mask_string mccchannel_19_analyzer_1_array_crystal_array_5_mask_string
#define mask_setting mccchannel_19_analyzer_1_array_crystal_array_5_mask_setting
#define number_of_activations mccchannel_19_analyzer_1_array_crystal_array_5_number_of_activations
#line 224 "Union_box.comp"
{
// Initializes the focusing system for this volume including input sanitation.
focus_initialize(&this_box_volume.geometry, POS_A_COMP_INDEX(INDEX_CURRENT_COMP+target_index), POS_A_CURRENT_COMP, ROT_A_CURRENT_COMP, target_index, target_x, target_y, target_z, focus_aw, focus_ah, focus_xw, focus_xh, focus_r, NAME_CURRENT_COMP);

// Input sanitation for this geometry
if (xwidth <= 0) {
  printf("\nERROR in Union_box named %s, the xwidth is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (yheight <= 0) {
  printf("\nERROR in Union_box named %s, yheight is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (zdepth <= 0) {
  printf("\nERROR in Union_box named %s, zdepth is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (xwidth2 <= 0 && xwidth2 != -1) {
  printf("\nERROR in Union_box named %s, the xwidth2 is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (yheight2 <= 0 && yheight2 != -1) {
  printf("\nERROR in Union_box named %s, yheight2 is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}

// Use sanitation
if (global_material_list.num_elements == 0) {
  printf("\nERROR: Need to define a material using Union_make_material before using a Union geometry component. \n");
  printf("       %s was defined before first use of Union_make_material.\n",NAME_CURRENT_COMP);
  exit(1);
}

this_box_volume.geometry.is_masked_volume = 0;
this_box_volume.geometry.is_exit_volume = 0;
this_box_volume.geometry.is_mask_volume = 0;
// check if the volume is a mask, if it is the material string is irelevant.
if (mask_string && strlen(mask_string) && strcmp(mask_string, "NULL") && strcmp(mask_string, "0")) {
    // A mask volume is used to limit the extend of other volumes, called the masked volumes. These are specified in the mask_string.
    // In order for a ray to enter a masked volume, it needs to be both in the region covered by that volume AND the mask volume.
    // When more than
    this_box_volume.geometry.mask_mode = 1; // Default is mask mode is ALL
    if (mask_setting && strlen(mask_setting) && strcmp(mask_setting, "NULL") && strcmp(mask_setting, "0")) {
        if (strcmp(mask_setting,"ALL") == 0 || strcmp(mask_setting,"All") == 0) this_box_volume.geometry.mask_mode = 1;
        else if (strcmp(mask_setting,"ANY") == 0 || strcmp(mask_setting,"Any") == 0) this_box_volume.geometry.mask_mode = 2;
        else {
            printf("The mask_mode of component %s is set to %s, but must be either ALL or ANY.\n",NAME_CURRENT_COMP,mask_setting);
            exit(1);
        }
    }
    
    for (loop_index=0;loop_index<global_geometry_list.num_elements;loop_index++) {
        // Add mask list
        if (1 == manual_linking_function(global_geometry_list.elements[loop_index].name,mask_string)) {
            add_element_to_int_list(&this_box_volume.geometry.mask_list,global_geometry_list.elements[loop_index].component_index);
            add_element_to_int_list(&global_geometry_list.elements[loop_index].Volume->geometry.masked_by_list,INDEX_CURRENT_COMP);
            global_geometry_list.elements[loop_index].Volume->geometry.is_masked_volume = 1;
            if (this_box_volume.geometry.mask_mode == 2)
                global_geometry_list.elements[loop_index].Volume->geometry.mask_mode = 2;
            if (this_box_volume.geometry.mask_mode == 1) {
                if (global_geometry_list.elements[loop_index].Volume->geometry.is_masked_volume == 1 && global_geometry_list.elements[loop_index].Volume->geometry.mask_mode != 2)
                    // If more than one mask is added to one volume, the ANY mode overwrites the (default) ALL mode.
                    global_geometry_list.elements[loop_index].Volume->geometry.mask_mode = 1;
            }
            
            found_geometries = 1;
        }
    }
    if (found_geometries == 0) {
        printf("The mask_string in geometry: %s did not find any of the specified volumes in the mask_string %s \n",NAME_CURRENT_COMP,mask_string);
        exit(1);
    }
    this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
    this_box_volume.p_physics->is_vacuum = 0; // Makes this volume a vacuum
    this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
    this_box_volume.p_physics->my_a = 0; // Should not be used.
    sprintf(this_box_volume.p_physics->name,"Mask");
    this_box_volume.geometry.is_mask_volume = 1;
    
    
// Read the material input, or if it lacks, use automatic linking.
} else if (material_string && strlen(material_string) && strcmp(material_string, "NULL") && strcmp(material_string, "0")) {
    // A geometry string was given, use it to determine which material
    if (0 == strcmp(material_string,"vacuum") || 0 == strcmp(material_string,"Vacuum")) {
        // One could have a global physics struct for vacuum instead of creating one for each
        this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
        this_box_volume.p_physics->is_vacuum = 1; // Makes this volume a vacuum
        this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
        this_box_volume.p_physics->my_a = 0; // Should not be used.
        sprintf(this_box_volume.p_physics->name,"Vacuum");
    } else if (0 == strcmp(material_string,"exit") || 0 == strcmp(material_string,"Exit")) {
        // One could have a global physics struct for vacuum instead of creating one for each
        this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
        this_box_volume.p_physics->is_vacuum = 1; // Makes this volume a vacuum
        this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
        this_box_volume.p_physics->my_a = 0; // Should not be used.
        this_box_volume.geometry.is_exit_volume = 1;
        sprintf(this_box_volume.p_physics->name,"Exit");
    } else {
        #ifndef MATERIAL_DETECTOR
            printf("Need to define a material before refering to it in a geometry %s.\n",NAME_CURRENT_COMP);
            exit(1);
        #endif
        for (loop_index=0;loop_index<global_material_list.num_elements;loop_index++) {
            if (0 == strcmp(material_string,global_material_list.elements[loop_index].name)) {
                this_box_volume.p_physics = global_material_list.elements[loop_index].physics;
                break;
            }
            if (loop_index == global_material_list.num_elements-1) {
            printf("\n");
            printf("ERROR: The material string \"%s\" in Union geometry \"%s\" did not match a specified material. \n",material_string,NAME_CURRENT_COMP);
            printf("       The materials available at this point (need to be defined before the geometry): \n");
            for (loop_index=0;loop_index<global_material_list.num_elements;loop_index++)
              printf("         %s\n",global_material_list.elements[loop_index].name);
            printf("\n");
            printf("       It is also possible to use one of the defualt materials avaiable: \n");
            printf("           Vacuum (for a Volume without scattering or absorption)\n");
            printf("           Exit (for a Volume where the ray exits the component if it enters)\n");
            printf("           Mask (for a Volume that masks existing volumes specified in the mask_string\n");
            exit(1);
          }
        }
    }
} else {
    // Automatic linking, simply using the last defined material.
    #ifndef MATERIAL_DETECTOR
        printf("Need to define a material before the geometry to use automatic linking %s.\n",NAME_CURRENT_COMP);
        exit(1);
    #endif
    this_box_volume.p_physics = global_material_list.elements[global_material_list.num_elements-1].physics;
}

sprintf(this_box_volume.name,NAME_CURRENT_COMP);
sprintf(this_box_volume.geometry.shape,"box");
this_box_volume.geometry.priority_value = priority;
this_box_volume.geometry.geometry_p_interact = p_interact;
// Currently the coordinates will be in absolute space.
this_box_volume.geometry.center = POS_A_CURRENT_COMP;

this_box_storage.z_depth = zdepth;
this_box_storage.x_width1 = xwidth;
this_box_storage.y_height1 = yheight;

this_box_storage.is_rectangle = 0;
if (xwidth2 < 0 && yheight2 < 0) this_box_storage.is_rectangle = 1;
if (xwidth == xwidth2 && yheight == yheight2) this_box_storage.is_rectangle = 1;

if (xwidth2 < 0) {
    this_box_storage.x_width2 = xwidth;
    xwidth2 = xwidth;
} else this_box_storage.x_width2 = xwidth2;

if (yheight2 < 0) {
    this_box_storage.y_height2 = yheight;
    yheight2 = yheight;
} else this_box_storage.y_height2 = yheight2;


this_box_storage.normal_vectors[0] = coords_set(0,0,1);
this_box_storage.normal_vectors[1] = coords_set(0,0,1);

// for sides with y component = 0
x_component = 2*zdepth/sqrt((xwidth-xwidth2)*(xwidth-xwidth2)+4*zdepth*zdepth);
z_component = (xwidth-xwidth2)/sqrt(4*zdepth*zdepth+(xwidth-xwidth2)*(xwidth-xwidth2));

this_box_storage.normal_vectors[2] = coords_set(x_component,0,z_component);
this_box_storage.normal_vectors[3] = coords_set(-x_component,0,z_component);

// for sides with x component = 0
y_component = 2*zdepth/sqrt((yheight-yheight2)*(yheight-yheight2)+4*zdepth*zdepth);
z_component = (yheight-yheight2)/sqrt(4*zdepth*zdepth+(yheight-yheight2)*(yheight-yheight2));

this_box_storage.normal_vectors[4] = coords_set(0,y_component,z_component);
this_box_storage.normal_vectors[5] = coords_set(0,-y_component,z_component);

this_box_volume.geometry.visualization_on = visualize;

this_box_volume.geometry.geometry_parameters.p_box_storage = &this_box_storage;

// Assign pointers to functions for intersection with the shape, checking if a point is inside the shape
if (this_box_storage.is_rectangle == 1) {
this_box_volume.geometry.intersect_function = &sample_box_intersect_simple;
this_box_volume.geometry.within_function = &r_within_box_simple;
}
else {
this_box_volume.geometry.intersect_function = &sample_box_intersect_advanced;
this_box_volume.geometry.within_function = &r_within_box_advanced;
}

this_box_volume.geometry.shell_points = &box_shell_points;
this_box_volume.geometry.mcdisplay_function = &mcdisplay_box_function;
this_box_volume.geometry.initialize_from_main_function = &initialize_box_geometry_from_main_component;
this_box_volume.geometry.process_rot_allocated = 0;

this_box_volume.geometry.copy_geometry_parameters = &allocate_box_storage_copy;

rot_copy(this_box_volume.geometry.rotation_matrix,ROT_A_CURRENT_COMP); //check how ROT_R_CURRENT_COMP would work
rot_transpose(ROT_A_CURRENT_COMP,this_box_volume.geometry.transpose_rotation_matrix);

// Initialize loggers
this_box_volume.loggers.num_elements = 0;

// packing the information into the global_geometry_element, which is then included in the global_geometry_list.
sprintf(global_geometry_element.name,NAME_CURRENT_COMP);
global_geometry_element.activation_counter = number_of_activations;
global_geometry_element.component_index = INDEX_CURRENT_COMP;
global_geometry_element.Volume = &this_box_volume; // Would be nicer if this m was a pointer, now we have the (small) data two places
add_element_to_geometry_list(&global_geometry_list,global_geometry_element);
}
#line 334532 "MACS_sample_kidney_box.c"
#undef number_of_activations
#undef mask_setting
#undef mask_string
#undef p_interact
#undef focus_r
#undef focus_xh
#undef focus_xw
#undef focus_ah
#undef focus_aw
#undef target_z
#undef target_y
#undef target_x
#undef target_index
#undef visualize
#undef yheight2
#undef xwidth2
#undef zdepth
#undef yheight
#undef xwidth
#undef priority
#undef material_string
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

  /* Initializations for component channel_19_analyzer_1_array_crystal_array_6. */
  SIG_MESSAGE("channel_19_analyzer_1_array_crystal_array_6 (Init)");
#define mccompcurname  channel_19_analyzer_1_array_crystal_array_6
#define mccompcurtype  Union_box
#define mccompcurindex 858
#define loop_index mccchannel_19_analyzer_1_array_crystal_array_6_loop_index
#define this_box_volume mccchannel_19_analyzer_1_array_crystal_array_6_this_box_volume
#define global_geometry_element mccchannel_19_analyzer_1_array_crystal_array_6_global_geometry_element
#define this_box_storage mccchannel_19_analyzer_1_array_crystal_array_6_this_box_storage
#define material_string mccchannel_19_analyzer_1_array_crystal_array_6_material_string
#define priority mccchannel_19_analyzer_1_array_crystal_array_6_priority
#define xwidth mccchannel_19_analyzer_1_array_crystal_array_6_xwidth
#define yheight mccchannel_19_analyzer_1_array_crystal_array_6_yheight
#define zdepth mccchannel_19_analyzer_1_array_crystal_array_6_zdepth
#define xwidth2 mccchannel_19_analyzer_1_array_crystal_array_6_xwidth2
#define yheight2 mccchannel_19_analyzer_1_array_crystal_array_6_yheight2
#define visualize mccchannel_19_analyzer_1_array_crystal_array_6_visualize
#define target_index mccchannel_19_analyzer_1_array_crystal_array_6_target_index
#define target_x mccchannel_19_analyzer_1_array_crystal_array_6_target_x
#define target_y mccchannel_19_analyzer_1_array_crystal_array_6_target_y
#define target_z mccchannel_19_analyzer_1_array_crystal_array_6_target_z
#define focus_aw mccchannel_19_analyzer_1_array_crystal_array_6_focus_aw
#define focus_ah mccchannel_19_analyzer_1_array_crystal_array_6_focus_ah
#define focus_xw mccchannel_19_analyzer_1_array_crystal_array_6_focus_xw
#define focus_xh mccchannel_19_analyzer_1_array_crystal_array_6_focus_xh
#define focus_r mccchannel_19_analyzer_1_array_crystal_array_6_focus_r
#define p_interact mccchannel_19_analyzer_1_array_crystal_array_6_p_interact
#define mask_string mccchannel_19_analyzer_1_array_crystal_array_6_mask_string
#define mask_setting mccchannel_19_analyzer_1_array_crystal_array_6_mask_setting
#define number_of_activations mccchannel_19_analyzer_1_array_crystal_array_6_number_of_activations
#line 224 "Union_box.comp"
{
// Initializes the focusing system for this volume including input sanitation.
focus_initialize(&this_box_volume.geometry, POS_A_COMP_INDEX(INDEX_CURRENT_COMP+target_index), POS_A_CURRENT_COMP, ROT_A_CURRENT_COMP, target_index, target_x, target_y, target_z, focus_aw, focus_ah, focus_xw, focus_xh, focus_r, NAME_CURRENT_COMP);

// Input sanitation for this geometry
if (xwidth <= 0) {
  printf("\nERROR in Union_box named %s, the xwidth is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (yheight <= 0) {
  printf("\nERROR in Union_box named %s, yheight is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (zdepth <= 0) {
  printf("\nERROR in Union_box named %s, zdepth is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (xwidth2 <= 0 && xwidth2 != -1) {
  printf("\nERROR in Union_box named %s, the xwidth2 is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (yheight2 <= 0 && yheight2 != -1) {
  printf("\nERROR in Union_box named %s, yheight2 is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}

// Use sanitation
if (global_material_list.num_elements == 0) {
  printf("\nERROR: Need to define a material using Union_make_material before using a Union geometry component. \n");
  printf("       %s was defined before first use of Union_make_material.\n",NAME_CURRENT_COMP);
  exit(1);
}

this_box_volume.geometry.is_masked_volume = 0;
this_box_volume.geometry.is_exit_volume = 0;
this_box_volume.geometry.is_mask_volume = 0;
// check if the volume is a mask, if it is the material string is irelevant.
if (mask_string && strlen(mask_string) && strcmp(mask_string, "NULL") && strcmp(mask_string, "0")) {
    // A mask volume is used to limit the extend of other volumes, called the masked volumes. These are specified in the mask_string.
    // In order for a ray to enter a masked volume, it needs to be both in the region covered by that volume AND the mask volume.
    // When more than
    this_box_volume.geometry.mask_mode = 1; // Default is mask mode is ALL
    if (mask_setting && strlen(mask_setting) && strcmp(mask_setting, "NULL") && strcmp(mask_setting, "0")) {
        if (strcmp(mask_setting,"ALL") == 0 || strcmp(mask_setting,"All") == 0) this_box_volume.geometry.mask_mode = 1;
        else if (strcmp(mask_setting,"ANY") == 0 || strcmp(mask_setting,"Any") == 0) this_box_volume.geometry.mask_mode = 2;
        else {
            printf("The mask_mode of component %s is set to %s, but must be either ALL or ANY.\n",NAME_CURRENT_COMP,mask_setting);
            exit(1);
        }
    }
    
    for (loop_index=0;loop_index<global_geometry_list.num_elements;loop_index++) {
        // Add mask list
        if (1 == manual_linking_function(global_geometry_list.elements[loop_index].name,mask_string)) {
            add_element_to_int_list(&this_box_volume.geometry.mask_list,global_geometry_list.elements[loop_index].component_index);
            add_element_to_int_list(&global_geometry_list.elements[loop_index].Volume->geometry.masked_by_list,INDEX_CURRENT_COMP);
            global_geometry_list.elements[loop_index].Volume->geometry.is_masked_volume = 1;
            if (this_box_volume.geometry.mask_mode == 2)
                global_geometry_list.elements[loop_index].Volume->geometry.mask_mode = 2;
            if (this_box_volume.geometry.mask_mode == 1) {
                if (global_geometry_list.elements[loop_index].Volume->geometry.is_masked_volume == 1 && global_geometry_list.elements[loop_index].Volume->geometry.mask_mode != 2)
                    // If more than one mask is added to one volume, the ANY mode overwrites the (default) ALL mode.
                    global_geometry_list.elements[loop_index].Volume->geometry.mask_mode = 1;
            }
            
            found_geometries = 1;
        }
    }
    if (found_geometries == 0) {
        printf("The mask_string in geometry: %s did not find any of the specified volumes in the mask_string %s \n",NAME_CURRENT_COMP,mask_string);
        exit(1);
    }
    this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
    this_box_volume.p_physics->is_vacuum = 0; // Makes this volume a vacuum
    this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
    this_box_volume.p_physics->my_a = 0; // Should not be used.
    sprintf(this_box_volume.p_physics->name,"Mask");
    this_box_volume.geometry.is_mask_volume = 1;
    
    
// Read the material input, or if it lacks, use automatic linking.
} else if (material_string && strlen(material_string) && strcmp(material_string, "NULL") && strcmp(material_string, "0")) {
    // A geometry string was given, use it to determine which material
    if (0 == strcmp(material_string,"vacuum") || 0 == strcmp(material_string,"Vacuum")) {
        // One could have a global physics struct for vacuum instead of creating one for each
        this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
        this_box_volume.p_physics->is_vacuum = 1; // Makes this volume a vacuum
        this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
        this_box_volume.p_physics->my_a = 0; // Should not be used.
        sprintf(this_box_volume.p_physics->name,"Vacuum");
    } else if (0 == strcmp(material_string,"exit") || 0 == strcmp(material_string,"Exit")) {
        // One could have a global physics struct for vacuum instead of creating one for each
        this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
        this_box_volume.p_physics->is_vacuum = 1; // Makes this volume a vacuum
        this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
        this_box_volume.p_physics->my_a = 0; // Should not be used.
        this_box_volume.geometry.is_exit_volume = 1;
        sprintf(this_box_volume.p_physics->name,"Exit");
    } else {
        #ifndef MATERIAL_DETECTOR
            printf("Need to define a material before refering to it in a geometry %s.\n",NAME_CURRENT_COMP);
            exit(1);
        #endif
        for (loop_index=0;loop_index<global_material_list.num_elements;loop_index++) {
            if (0 == strcmp(material_string,global_material_list.elements[loop_index].name)) {
                this_box_volume.p_physics = global_material_list.elements[loop_index].physics;
                break;
            }
            if (loop_index == global_material_list.num_elements-1) {
            printf("\n");
            printf("ERROR: The material string \"%s\" in Union geometry \"%s\" did not match a specified material. \n",material_string,NAME_CURRENT_COMP);
            printf("       The materials available at this point (need to be defined before the geometry): \n");
            for (loop_index=0;loop_index<global_material_list.num_elements;loop_index++)
              printf("         %s\n",global_material_list.elements[loop_index].name);
            printf("\n");
            printf("       It is also possible to use one of the defualt materials avaiable: \n");
            printf("           Vacuum (for a Volume without scattering or absorption)\n");
            printf("           Exit (for a Volume where the ray exits the component if it enters)\n");
            printf("           Mask (for a Volume that masks existing volumes specified in the mask_string\n");
            exit(1);
          }
        }
    }
} else {
    // Automatic linking, simply using the last defined material.
    #ifndef MATERIAL_DETECTOR
        printf("Need to define a material before the geometry to use automatic linking %s.\n",NAME_CURRENT_COMP);
        exit(1);
    #endif
    this_box_volume.p_physics = global_material_list.elements[global_material_list.num_elements-1].physics;
}

sprintf(this_box_volume.name,NAME_CURRENT_COMP);
sprintf(this_box_volume.geometry.shape,"box");
this_box_volume.geometry.priority_value = priority;
this_box_volume.geometry.geometry_p_interact = p_interact;
// Currently the coordinates will be in absolute space.
this_box_volume.geometry.center = POS_A_CURRENT_COMP;

this_box_storage.z_depth = zdepth;
this_box_storage.x_width1 = xwidth;
this_box_storage.y_height1 = yheight;

this_box_storage.is_rectangle = 0;
if (xwidth2 < 0 && yheight2 < 0) this_box_storage.is_rectangle = 1;
if (xwidth == xwidth2 && yheight == yheight2) this_box_storage.is_rectangle = 1;

if (xwidth2 < 0) {
    this_box_storage.x_width2 = xwidth;
    xwidth2 = xwidth;
} else this_box_storage.x_width2 = xwidth2;

if (yheight2 < 0) {
    this_box_storage.y_height2 = yheight;
    yheight2 = yheight;
} else this_box_storage.y_height2 = yheight2;


this_box_storage.normal_vectors[0] = coords_set(0,0,1);
this_box_storage.normal_vectors[1] = coords_set(0,0,1);

// for sides with y component = 0
x_component = 2*zdepth/sqrt((xwidth-xwidth2)*(xwidth-xwidth2)+4*zdepth*zdepth);
z_component = (xwidth-xwidth2)/sqrt(4*zdepth*zdepth+(xwidth-xwidth2)*(xwidth-xwidth2));

this_box_storage.normal_vectors[2] = coords_set(x_component,0,z_component);
this_box_storage.normal_vectors[3] = coords_set(-x_component,0,z_component);

// for sides with x component = 0
y_component = 2*zdepth/sqrt((yheight-yheight2)*(yheight-yheight2)+4*zdepth*zdepth);
z_component = (yheight-yheight2)/sqrt(4*zdepth*zdepth+(yheight-yheight2)*(yheight-yheight2));

this_box_storage.normal_vectors[4] = coords_set(0,y_component,z_component);
this_box_storage.normal_vectors[5] = coords_set(0,-y_component,z_component);

this_box_volume.geometry.visualization_on = visualize;

this_box_volume.geometry.geometry_parameters.p_box_storage = &this_box_storage;

// Assign pointers to functions for intersection with the shape, checking if a point is inside the shape
if (this_box_storage.is_rectangle == 1) {
this_box_volume.geometry.intersect_function = &sample_box_intersect_simple;
this_box_volume.geometry.within_function = &r_within_box_simple;
}
else {
this_box_volume.geometry.intersect_function = &sample_box_intersect_advanced;
this_box_volume.geometry.within_function = &r_within_box_advanced;
}

this_box_volume.geometry.shell_points = &box_shell_points;
this_box_volume.geometry.mcdisplay_function = &mcdisplay_box_function;
this_box_volume.geometry.initialize_from_main_function = &initialize_box_geometry_from_main_component;
this_box_volume.geometry.process_rot_allocated = 0;

this_box_volume.geometry.copy_geometry_parameters = &allocate_box_storage_copy;

rot_copy(this_box_volume.geometry.rotation_matrix,ROT_A_CURRENT_COMP); //check how ROT_R_CURRENT_COMP would work
rot_transpose(ROT_A_CURRENT_COMP,this_box_volume.geometry.transpose_rotation_matrix);

// Initialize loggers
this_box_volume.loggers.num_elements = 0;

// packing the information into the global_geometry_element, which is then included in the global_geometry_list.
sprintf(global_geometry_element.name,NAME_CURRENT_COMP);
global_geometry_element.activation_counter = number_of_activations;
global_geometry_element.component_index = INDEX_CURRENT_COMP;
global_geometry_element.Volume = &this_box_volume; // Would be nicer if this m was a pointer, now we have the (small) data two places
add_element_to_geometry_list(&global_geometry_list,global_geometry_element);
}
#line 334802 "MACS_sample_kidney_box.c"
#undef number_of_activations
#undef mask_setting
#undef mask_string
#undef p_interact
#undef focus_r
#undef focus_xh
#undef focus_xw
#undef focus_ah
#undef focus_aw
#undef target_z
#undef target_y
#undef target_x
#undef target_index
#undef visualize
#undef yheight2
#undef xwidth2
#undef zdepth
#undef yheight
#undef xwidth
#undef priority
#undef material_string
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

  /* Initializations for component channel_19_analyzer_1_array_crystal_array_7. */
  SIG_MESSAGE("channel_19_analyzer_1_array_crystal_array_7 (Init)");
#define mccompcurname  channel_19_analyzer_1_array_crystal_array_7
#define mccompcurtype  Union_box
#define mccompcurindex 859
#define loop_index mccchannel_19_analyzer_1_array_crystal_array_7_loop_index
#define this_box_volume mccchannel_19_analyzer_1_array_crystal_array_7_this_box_volume
#define global_geometry_element mccchannel_19_analyzer_1_array_crystal_array_7_global_geometry_element
#define this_box_storage mccchannel_19_analyzer_1_array_crystal_array_7_this_box_storage
#define material_string mccchannel_19_analyzer_1_array_crystal_array_7_material_string
#define priority mccchannel_19_analyzer_1_array_crystal_array_7_priority
#define xwidth mccchannel_19_analyzer_1_array_crystal_array_7_xwidth
#define yheight mccchannel_19_analyzer_1_array_crystal_array_7_yheight
#define zdepth mccchannel_19_analyzer_1_array_crystal_array_7_zdepth
#define xwidth2 mccchannel_19_analyzer_1_array_crystal_array_7_xwidth2
#define yheight2 mccchannel_19_analyzer_1_array_crystal_array_7_yheight2
#define visualize mccchannel_19_analyzer_1_array_crystal_array_7_visualize
#define target_index mccchannel_19_analyzer_1_array_crystal_array_7_target_index
#define target_x mccchannel_19_analyzer_1_array_crystal_array_7_target_x
#define target_y mccchannel_19_analyzer_1_array_crystal_array_7_target_y
#define target_z mccchannel_19_analyzer_1_array_crystal_array_7_target_z
#define focus_aw mccchannel_19_analyzer_1_array_crystal_array_7_focus_aw
#define focus_ah mccchannel_19_analyzer_1_array_crystal_array_7_focus_ah
#define focus_xw mccchannel_19_analyzer_1_array_crystal_array_7_focus_xw
#define focus_xh mccchannel_19_analyzer_1_array_crystal_array_7_focus_xh
#define focus_r mccchannel_19_analyzer_1_array_crystal_array_7_focus_r
#define p_interact mccchannel_19_analyzer_1_array_crystal_array_7_p_interact
#define mask_string mccchannel_19_analyzer_1_array_crystal_array_7_mask_string
#define mask_setting mccchannel_19_analyzer_1_array_crystal_array_7_mask_setting
#define number_of_activations mccchannel_19_analyzer_1_array_crystal_array_7_number_of_activations
#line 224 "Union_box.comp"
{
// Initializes the focusing system for this volume including input sanitation.
focus_initialize(&this_box_volume.geometry, POS_A_COMP_INDEX(INDEX_CURRENT_COMP+target_index), POS_A_CURRENT_COMP, ROT_A_CURRENT_COMP, target_index, target_x, target_y, target_z, focus_aw, focus_ah, focus_xw, focus_xh, focus_r, NAME_CURRENT_COMP);

// Input sanitation for this geometry
if (xwidth <= 0) {
  printf("\nERROR in Union_box named %s, the xwidth is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (yheight <= 0) {
  printf("\nERROR in Union_box named %s, yheight is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (zdepth <= 0) {
  printf("\nERROR in Union_box named %s, zdepth is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (xwidth2 <= 0 && xwidth2 != -1) {
  printf("\nERROR in Union_box named %s, the xwidth2 is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (yheight2 <= 0 && yheight2 != -1) {
  printf("\nERROR in Union_box named %s, yheight2 is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}

// Use sanitation
if (global_material_list.num_elements == 0) {
  printf("\nERROR: Need to define a material using Union_make_material before using a Union geometry component. \n");
  printf("       %s was defined before first use of Union_make_material.\n",NAME_CURRENT_COMP);
  exit(1);
}

this_box_volume.geometry.is_masked_volume = 0;
this_box_volume.geometry.is_exit_volume = 0;
this_box_volume.geometry.is_mask_volume = 0;
// check if the volume is a mask, if it is the material string is irelevant.
if (mask_string && strlen(mask_string) && strcmp(mask_string, "NULL") && strcmp(mask_string, "0")) {
    // A mask volume is used to limit the extend of other volumes, called the masked volumes. These are specified in the mask_string.
    // In order for a ray to enter a masked volume, it needs to be both in the region covered by that volume AND the mask volume.
    // When more than
    this_box_volume.geometry.mask_mode = 1; // Default is mask mode is ALL
    if (mask_setting && strlen(mask_setting) && strcmp(mask_setting, "NULL") && strcmp(mask_setting, "0")) {
        if (strcmp(mask_setting,"ALL") == 0 || strcmp(mask_setting,"All") == 0) this_box_volume.geometry.mask_mode = 1;
        else if (strcmp(mask_setting,"ANY") == 0 || strcmp(mask_setting,"Any") == 0) this_box_volume.geometry.mask_mode = 2;
        else {
            printf("The mask_mode of component %s is set to %s, but must be either ALL or ANY.\n",NAME_CURRENT_COMP,mask_setting);
            exit(1);
        }
    }
    
    for (loop_index=0;loop_index<global_geometry_list.num_elements;loop_index++) {
        // Add mask list
        if (1 == manual_linking_function(global_geometry_list.elements[loop_index].name,mask_string)) {
            add_element_to_int_list(&this_box_volume.geometry.mask_list,global_geometry_list.elements[loop_index].component_index);
            add_element_to_int_list(&global_geometry_list.elements[loop_index].Volume->geometry.masked_by_list,INDEX_CURRENT_COMP);
            global_geometry_list.elements[loop_index].Volume->geometry.is_masked_volume = 1;
            if (this_box_volume.geometry.mask_mode == 2)
                global_geometry_list.elements[loop_index].Volume->geometry.mask_mode = 2;
            if (this_box_volume.geometry.mask_mode == 1) {
                if (global_geometry_list.elements[loop_index].Volume->geometry.is_masked_volume == 1 && global_geometry_list.elements[loop_index].Volume->geometry.mask_mode != 2)
                    // If more than one mask is added to one volume, the ANY mode overwrites the (default) ALL mode.
                    global_geometry_list.elements[loop_index].Volume->geometry.mask_mode = 1;
            }
            
            found_geometries = 1;
        }
    }
    if (found_geometries == 0) {
        printf("The mask_string in geometry: %s did not find any of the specified volumes in the mask_string %s \n",NAME_CURRENT_COMP,mask_string);
        exit(1);
    }
    this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
    this_box_volume.p_physics->is_vacuum = 0; // Makes this volume a vacuum
    this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
    this_box_volume.p_physics->my_a = 0; // Should not be used.
    sprintf(this_box_volume.p_physics->name,"Mask");
    this_box_volume.geometry.is_mask_volume = 1;
    
    
// Read the material input, or if it lacks, use automatic linking.
} else if (material_string && strlen(material_string) && strcmp(material_string, "NULL") && strcmp(material_string, "0")) {
    // A geometry string was given, use it to determine which material
    if (0 == strcmp(material_string,"vacuum") || 0 == strcmp(material_string,"Vacuum")) {
        // One could have a global physics struct for vacuum instead of creating one for each
        this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
        this_box_volume.p_physics->is_vacuum = 1; // Makes this volume a vacuum
        this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
        this_box_volume.p_physics->my_a = 0; // Should not be used.
        sprintf(this_box_volume.p_physics->name,"Vacuum");
    } else if (0 == strcmp(material_string,"exit") || 0 == strcmp(material_string,"Exit")) {
        // One could have a global physics struct for vacuum instead of creating one for each
        this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
        this_box_volume.p_physics->is_vacuum = 1; // Makes this volume a vacuum
        this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
        this_box_volume.p_physics->my_a = 0; // Should not be used.
        this_box_volume.geometry.is_exit_volume = 1;
        sprintf(this_box_volume.p_physics->name,"Exit");
    } else {
        #ifndef MATERIAL_DETECTOR
            printf("Need to define a material before refering to it in a geometry %s.\n",NAME_CURRENT_COMP);
            exit(1);
        #endif
        for (loop_index=0;loop_index<global_material_list.num_elements;loop_index++) {
            if (0 == strcmp(material_string,global_material_list.elements[loop_index].name)) {
                this_box_volume.p_physics = global_material_list.elements[loop_index].physics;
                break;
            }
            if (loop_index == global_material_list.num_elements-1) {
            printf("\n");
            printf("ERROR: The material string \"%s\" in Union geometry \"%s\" did not match a specified material. \n",material_string,NAME_CURRENT_COMP);
            printf("       The materials available at this point (need to be defined before the geometry): \n");
            for (loop_index=0;loop_index<global_material_list.num_elements;loop_index++)
              printf("         %s\n",global_material_list.elements[loop_index].name);
            printf("\n");
            printf("       It is also possible to use one of the defualt materials avaiable: \n");
            printf("           Vacuum (for a Volume without scattering or absorption)\n");
            printf("           Exit (for a Volume where the ray exits the component if it enters)\n");
            printf("           Mask (for a Volume that masks existing volumes specified in the mask_string\n");
            exit(1);
          }
        }
    }
} else {
    // Automatic linking, simply using the last defined material.
    #ifndef MATERIAL_DETECTOR
        printf("Need to define a material before the geometry to use automatic linking %s.\n",NAME_CURRENT_COMP);
        exit(1);
    #endif
    this_box_volume.p_physics = global_material_list.elements[global_material_list.num_elements-1].physics;
}

sprintf(this_box_volume.name,NAME_CURRENT_COMP);
sprintf(this_box_volume.geometry.shape,"box");
this_box_volume.geometry.priority_value = priority;
this_box_volume.geometry.geometry_p_interact = p_interact;
// Currently the coordinates will be in absolute space.
this_box_volume.geometry.center = POS_A_CURRENT_COMP;

this_box_storage.z_depth = zdepth;
this_box_storage.x_width1 = xwidth;
this_box_storage.y_height1 = yheight;

this_box_storage.is_rectangle = 0;
if (xwidth2 < 0 && yheight2 < 0) this_box_storage.is_rectangle = 1;
if (xwidth == xwidth2 && yheight == yheight2) this_box_storage.is_rectangle = 1;

if (xwidth2 < 0) {
    this_box_storage.x_width2 = xwidth;
    xwidth2 = xwidth;
} else this_box_storage.x_width2 = xwidth2;

if (yheight2 < 0) {
    this_box_storage.y_height2 = yheight;
    yheight2 = yheight;
} else this_box_storage.y_height2 = yheight2;


this_box_storage.normal_vectors[0] = coords_set(0,0,1);
this_box_storage.normal_vectors[1] = coords_set(0,0,1);

// for sides with y component = 0
x_component = 2*zdepth/sqrt((xwidth-xwidth2)*(xwidth-xwidth2)+4*zdepth*zdepth);
z_component = (xwidth-xwidth2)/sqrt(4*zdepth*zdepth+(xwidth-xwidth2)*(xwidth-xwidth2));

this_box_storage.normal_vectors[2] = coords_set(x_component,0,z_component);
this_box_storage.normal_vectors[3] = coords_set(-x_component,0,z_component);

// for sides with x component = 0
y_component = 2*zdepth/sqrt((yheight-yheight2)*(yheight-yheight2)+4*zdepth*zdepth);
z_component = (yheight-yheight2)/sqrt(4*zdepth*zdepth+(yheight-yheight2)*(yheight-yheight2));

this_box_storage.normal_vectors[4] = coords_set(0,y_component,z_component);
this_box_storage.normal_vectors[5] = coords_set(0,-y_component,z_component);

this_box_volume.geometry.visualization_on = visualize;

this_box_volume.geometry.geometry_parameters.p_box_storage = &this_box_storage;

// Assign pointers to functions for intersection with the shape, checking if a point is inside the shape
if (this_box_storage.is_rectangle == 1) {
this_box_volume.geometry.intersect_function = &sample_box_intersect_simple;
this_box_volume.geometry.within_function = &r_within_box_simple;
}
else {
this_box_volume.geometry.intersect_function = &sample_box_intersect_advanced;
this_box_volume.geometry.within_function = &r_within_box_advanced;
}

this_box_volume.geometry.shell_points = &box_shell_points;
this_box_volume.geometry.mcdisplay_function = &mcdisplay_box_function;
this_box_volume.geometry.initialize_from_main_function = &initialize_box_geometry_from_main_component;
this_box_volume.geometry.process_rot_allocated = 0;

this_box_volume.geometry.copy_geometry_parameters = &allocate_box_storage_copy;

rot_copy(this_box_volume.geometry.rotation_matrix,ROT_A_CURRENT_COMP); //check how ROT_R_CURRENT_COMP would work
rot_transpose(ROT_A_CURRENT_COMP,this_box_volume.geometry.transpose_rotation_matrix);

// Initialize loggers
this_box_volume.loggers.num_elements = 0;

// packing the information into the global_geometry_element, which is then included in the global_geometry_list.
sprintf(global_geometry_element.name,NAME_CURRENT_COMP);
global_geometry_element.activation_counter = number_of_activations;
global_geometry_element.component_index = INDEX_CURRENT_COMP;
global_geometry_element.Volume = &this_box_volume; // Would be nicer if this m was a pointer, now we have the (small) data two places
add_element_to_geometry_list(&global_geometry_list,global_geometry_element);
}
#line 335072 "MACS_sample_kidney_box.c"
#undef number_of_activations
#undef mask_setting
#undef mask_string
#undef p_interact
#undef focus_r
#undef focus_xh
#undef focus_xw
#undef focus_ah
#undef focus_aw
#undef target_z
#undef target_y
#undef target_x
#undef target_index
#undef visualize
#undef yheight2
#undef xwidth2
#undef zdepth
#undef yheight
#undef xwidth
#undef priority
#undef material_string
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

  /* Initializations for component channel_19_analyzer_1_array_crystal_array_8. */
  SIG_MESSAGE("channel_19_analyzer_1_array_crystal_array_8 (Init)");
#define mccompcurname  channel_19_analyzer_1_array_crystal_array_8
#define mccompcurtype  Union_box
#define mccompcurindex 860
#define loop_index mccchannel_19_analyzer_1_array_crystal_array_8_loop_index
#define this_box_volume mccchannel_19_analyzer_1_array_crystal_array_8_this_box_volume
#define global_geometry_element mccchannel_19_analyzer_1_array_crystal_array_8_global_geometry_element
#define this_box_storage mccchannel_19_analyzer_1_array_crystal_array_8_this_box_storage
#define material_string mccchannel_19_analyzer_1_array_crystal_array_8_material_string
#define priority mccchannel_19_analyzer_1_array_crystal_array_8_priority
#define xwidth mccchannel_19_analyzer_1_array_crystal_array_8_xwidth
#define yheight mccchannel_19_analyzer_1_array_crystal_array_8_yheight
#define zdepth mccchannel_19_analyzer_1_array_crystal_array_8_zdepth
#define xwidth2 mccchannel_19_analyzer_1_array_crystal_array_8_xwidth2
#define yheight2 mccchannel_19_analyzer_1_array_crystal_array_8_yheight2
#define visualize mccchannel_19_analyzer_1_array_crystal_array_8_visualize
#define target_index mccchannel_19_analyzer_1_array_crystal_array_8_target_index
#define target_x mccchannel_19_analyzer_1_array_crystal_array_8_target_x
#define target_y mccchannel_19_analyzer_1_array_crystal_array_8_target_y
#define target_z mccchannel_19_analyzer_1_array_crystal_array_8_target_z
#define focus_aw mccchannel_19_analyzer_1_array_crystal_array_8_focus_aw
#define focus_ah mccchannel_19_analyzer_1_array_crystal_array_8_focus_ah
#define focus_xw mccchannel_19_analyzer_1_array_crystal_array_8_focus_xw
#define focus_xh mccchannel_19_analyzer_1_array_crystal_array_8_focus_xh
#define focus_r mccchannel_19_analyzer_1_array_crystal_array_8_focus_r
#define p_interact mccchannel_19_analyzer_1_array_crystal_array_8_p_interact
#define mask_string mccchannel_19_analyzer_1_array_crystal_array_8_mask_string
#define mask_setting mccchannel_19_analyzer_1_array_crystal_array_8_mask_setting
#define number_of_activations mccchannel_19_analyzer_1_array_crystal_array_8_number_of_activations
#line 224 "Union_box.comp"
{
// Initializes the focusing system for this volume including input sanitation.
focus_initialize(&this_box_volume.geometry, POS_A_COMP_INDEX(INDEX_CURRENT_COMP+target_index), POS_A_CURRENT_COMP, ROT_A_CURRENT_COMP, target_index, target_x, target_y, target_z, focus_aw, focus_ah, focus_xw, focus_xh, focus_r, NAME_CURRENT_COMP);

// Input sanitation for this geometry
if (xwidth <= 0) {
  printf("\nERROR in Union_box named %s, the xwidth is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (yheight <= 0) {
  printf("\nERROR in Union_box named %s, yheight is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (zdepth <= 0) {
  printf("\nERROR in Union_box named %s, zdepth is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (xwidth2 <= 0 && xwidth2 != -1) {
  printf("\nERROR in Union_box named %s, the xwidth2 is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (yheight2 <= 0 && yheight2 != -1) {
  printf("\nERROR in Union_box named %s, yheight2 is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}

// Use sanitation
if (global_material_list.num_elements == 0) {
  printf("\nERROR: Need to define a material using Union_make_material before using a Union geometry component. \n");
  printf("       %s was defined before first use of Union_make_material.\n",NAME_CURRENT_COMP);
  exit(1);
}

this_box_volume.geometry.is_masked_volume = 0;
this_box_volume.geometry.is_exit_volume = 0;
this_box_volume.geometry.is_mask_volume = 0;
// check if the volume is a mask, if it is the material string is irelevant.
if (mask_string && strlen(mask_string) && strcmp(mask_string, "NULL") && strcmp(mask_string, "0")) {
    // A mask volume is used to limit the extend of other volumes, called the masked volumes. These are specified in the mask_string.
    // In order for a ray to enter a masked volume, it needs to be both in the region covered by that volume AND the mask volume.
    // When more than
    this_box_volume.geometry.mask_mode = 1; // Default is mask mode is ALL
    if (mask_setting && strlen(mask_setting) && strcmp(mask_setting, "NULL") && strcmp(mask_setting, "0")) {
        if (strcmp(mask_setting,"ALL") == 0 || strcmp(mask_setting,"All") == 0) this_box_volume.geometry.mask_mode = 1;
        else if (strcmp(mask_setting,"ANY") == 0 || strcmp(mask_setting,"Any") == 0) this_box_volume.geometry.mask_mode = 2;
        else {
            printf("The mask_mode of component %s is set to %s, but must be either ALL or ANY.\n",NAME_CURRENT_COMP,mask_setting);
            exit(1);
        }
    }
    
    for (loop_index=0;loop_index<global_geometry_list.num_elements;loop_index++) {
        // Add mask list
        if (1 == manual_linking_function(global_geometry_list.elements[loop_index].name,mask_string)) {
            add_element_to_int_list(&this_box_volume.geometry.mask_list,global_geometry_list.elements[loop_index].component_index);
            add_element_to_int_list(&global_geometry_list.elements[loop_index].Volume->geometry.masked_by_list,INDEX_CURRENT_COMP);
            global_geometry_list.elements[loop_index].Volume->geometry.is_masked_volume = 1;
            if (this_box_volume.geometry.mask_mode == 2)
                global_geometry_list.elements[loop_index].Volume->geometry.mask_mode = 2;
            if (this_box_volume.geometry.mask_mode == 1) {
                if (global_geometry_list.elements[loop_index].Volume->geometry.is_masked_volume == 1 && global_geometry_list.elements[loop_index].Volume->geometry.mask_mode != 2)
                    // If more than one mask is added to one volume, the ANY mode overwrites the (default) ALL mode.
                    global_geometry_list.elements[loop_index].Volume->geometry.mask_mode = 1;
            }
            
            found_geometries = 1;
        }
    }
    if (found_geometries == 0) {
        printf("The mask_string in geometry: %s did not find any of the specified volumes in the mask_string %s \n",NAME_CURRENT_COMP,mask_string);
        exit(1);
    }
    this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
    this_box_volume.p_physics->is_vacuum = 0; // Makes this volume a vacuum
    this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
    this_box_volume.p_physics->my_a = 0; // Should not be used.
    sprintf(this_box_volume.p_physics->name,"Mask");
    this_box_volume.geometry.is_mask_volume = 1;
    
    
// Read the material input, or if it lacks, use automatic linking.
} else if (material_string && strlen(material_string) && strcmp(material_string, "NULL") && strcmp(material_string, "0")) {
    // A geometry string was given, use it to determine which material
    if (0 == strcmp(material_string,"vacuum") || 0 == strcmp(material_string,"Vacuum")) {
        // One could have a global physics struct for vacuum instead of creating one for each
        this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
        this_box_volume.p_physics->is_vacuum = 1; // Makes this volume a vacuum
        this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
        this_box_volume.p_physics->my_a = 0; // Should not be used.
        sprintf(this_box_volume.p_physics->name,"Vacuum");
    } else if (0 == strcmp(material_string,"exit") || 0 == strcmp(material_string,"Exit")) {
        // One could have a global physics struct for vacuum instead of creating one for each
        this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
        this_box_volume.p_physics->is_vacuum = 1; // Makes this volume a vacuum
        this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
        this_box_volume.p_physics->my_a = 0; // Should not be used.
        this_box_volume.geometry.is_exit_volume = 1;
        sprintf(this_box_volume.p_physics->name,"Exit");
    } else {
        #ifndef MATERIAL_DETECTOR
            printf("Need to define a material before refering to it in a geometry %s.\n",NAME_CURRENT_COMP);
            exit(1);
        #endif
        for (loop_index=0;loop_index<global_material_list.num_elements;loop_index++) {
            if (0 == strcmp(material_string,global_material_list.elements[loop_index].name)) {
                this_box_volume.p_physics = global_material_list.elements[loop_index].physics;
                break;
            }
            if (loop_index == global_material_list.num_elements-1) {
            printf("\n");
            printf("ERROR: The material string \"%s\" in Union geometry \"%s\" did not match a specified material. \n",material_string,NAME_CURRENT_COMP);
            printf("       The materials available at this point (need to be defined before the geometry): \n");
            for (loop_index=0;loop_index<global_material_list.num_elements;loop_index++)
              printf("         %s\n",global_material_list.elements[loop_index].name);
            printf("\n");
            printf("       It is also possible to use one of the defualt materials avaiable: \n");
            printf("           Vacuum (for a Volume without scattering or absorption)\n");
            printf("           Exit (for a Volume where the ray exits the component if it enters)\n");
            printf("           Mask (for a Volume that masks existing volumes specified in the mask_string\n");
            exit(1);
          }
        }
    }
} else {
    // Automatic linking, simply using the last defined material.
    #ifndef MATERIAL_DETECTOR
        printf("Need to define a material before the geometry to use automatic linking %s.\n",NAME_CURRENT_COMP);
        exit(1);
    #endif
    this_box_volume.p_physics = global_material_list.elements[global_material_list.num_elements-1].physics;
}

sprintf(this_box_volume.name,NAME_CURRENT_COMP);
sprintf(this_box_volume.geometry.shape,"box");
this_box_volume.geometry.priority_value = priority;
this_box_volume.geometry.geometry_p_interact = p_interact;
// Currently the coordinates will be in absolute space.
this_box_volume.geometry.center = POS_A_CURRENT_COMP;

this_box_storage.z_depth = zdepth;
this_box_storage.x_width1 = xwidth;
this_box_storage.y_height1 = yheight;

this_box_storage.is_rectangle = 0;
if (xwidth2 < 0 && yheight2 < 0) this_box_storage.is_rectangle = 1;
if (xwidth == xwidth2 && yheight == yheight2) this_box_storage.is_rectangle = 1;

if (xwidth2 < 0) {
    this_box_storage.x_width2 = xwidth;
    xwidth2 = xwidth;
} else this_box_storage.x_width2 = xwidth2;

if (yheight2 < 0) {
    this_box_storage.y_height2 = yheight;
    yheight2 = yheight;
} else this_box_storage.y_height2 = yheight2;


this_box_storage.normal_vectors[0] = coords_set(0,0,1);
this_box_storage.normal_vectors[1] = coords_set(0,0,1);

// for sides with y component = 0
x_component = 2*zdepth/sqrt((xwidth-xwidth2)*(xwidth-xwidth2)+4*zdepth*zdepth);
z_component = (xwidth-xwidth2)/sqrt(4*zdepth*zdepth+(xwidth-xwidth2)*(xwidth-xwidth2));

this_box_storage.normal_vectors[2] = coords_set(x_component,0,z_component);
this_box_storage.normal_vectors[3] = coords_set(-x_component,0,z_component);

// for sides with x component = 0
y_component = 2*zdepth/sqrt((yheight-yheight2)*(yheight-yheight2)+4*zdepth*zdepth);
z_component = (yheight-yheight2)/sqrt(4*zdepth*zdepth+(yheight-yheight2)*(yheight-yheight2));

this_box_storage.normal_vectors[4] = coords_set(0,y_component,z_component);
this_box_storage.normal_vectors[5] = coords_set(0,-y_component,z_component);

this_box_volume.geometry.visualization_on = visualize;

this_box_volume.geometry.geometry_parameters.p_box_storage = &this_box_storage;

// Assign pointers to functions for intersection with the shape, checking if a point is inside the shape
if (this_box_storage.is_rectangle == 1) {
this_box_volume.geometry.intersect_function = &sample_box_intersect_simple;
this_box_volume.geometry.within_function = &r_within_box_simple;
}
else {
this_box_volume.geometry.intersect_function = &sample_box_intersect_advanced;
this_box_volume.geometry.within_function = &r_within_box_advanced;
}

this_box_volume.geometry.shell_points = &box_shell_points;
this_box_volume.geometry.mcdisplay_function = &mcdisplay_box_function;
this_box_volume.geometry.initialize_from_main_function = &initialize_box_geometry_from_main_component;
this_box_volume.geometry.process_rot_allocated = 0;

this_box_volume.geometry.copy_geometry_parameters = &allocate_box_storage_copy;

rot_copy(this_box_volume.geometry.rotation_matrix,ROT_A_CURRENT_COMP); //check how ROT_R_CURRENT_COMP would work
rot_transpose(ROT_A_CURRENT_COMP,this_box_volume.geometry.transpose_rotation_matrix);

// Initialize loggers
this_box_volume.loggers.num_elements = 0;

// packing the information into the global_geometry_element, which is then included in the global_geometry_list.
sprintf(global_geometry_element.name,NAME_CURRENT_COMP);
global_geometry_element.activation_counter = number_of_activations;
global_geometry_element.component_index = INDEX_CURRENT_COMP;
global_geometry_element.Volume = &this_box_volume; // Would be nicer if this m was a pointer, now we have the (small) data two places
add_element_to_geometry_list(&global_geometry_list,global_geometry_element);
}
#line 335342 "MACS_sample_kidney_box.c"
#undef number_of_activations
#undef mask_setting
#undef mask_string
#undef p_interact
#undef focus_r
#undef focus_xh
#undef focus_xw
#undef focus_ah
#undef focus_aw
#undef target_z
#undef target_y
#undef target_x
#undef target_index
#undef visualize
#undef yheight2
#undef xwidth2
#undef zdepth
#undef yheight
#undef xwidth
#undef priority
#undef material_string
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

  /* Initializations for component channel_19_analyzer_2_center. */
  SIG_MESSAGE("channel_19_analyzer_2_center (Init)");

  /* Initializations for component channel_19_analyzer_2_rotated. */
  SIG_MESSAGE("channel_19_analyzer_2_rotated (Init)");

  /* Initializations for component channel_19_analyzer_2_array_crystal_array_0. */
  SIG_MESSAGE("channel_19_analyzer_2_array_crystal_array_0 (Init)");
#define mccompcurname  channel_19_analyzer_2_array_crystal_array_0
#define mccompcurtype  Union_box
#define mccompcurindex 863
#define loop_index mccchannel_19_analyzer_2_array_crystal_array_0_loop_index
#define this_box_volume mccchannel_19_analyzer_2_array_crystal_array_0_this_box_volume
#define global_geometry_element mccchannel_19_analyzer_2_array_crystal_array_0_global_geometry_element
#define this_box_storage mccchannel_19_analyzer_2_array_crystal_array_0_this_box_storage
#define material_string mccchannel_19_analyzer_2_array_crystal_array_0_material_string
#define priority mccchannel_19_analyzer_2_array_crystal_array_0_priority
#define xwidth mccchannel_19_analyzer_2_array_crystal_array_0_xwidth
#define yheight mccchannel_19_analyzer_2_array_crystal_array_0_yheight
#define zdepth mccchannel_19_analyzer_2_array_crystal_array_0_zdepth
#define xwidth2 mccchannel_19_analyzer_2_array_crystal_array_0_xwidth2
#define yheight2 mccchannel_19_analyzer_2_array_crystal_array_0_yheight2
#define visualize mccchannel_19_analyzer_2_array_crystal_array_0_visualize
#define target_index mccchannel_19_analyzer_2_array_crystal_array_0_target_index
#define target_x mccchannel_19_analyzer_2_array_crystal_array_0_target_x
#define target_y mccchannel_19_analyzer_2_array_crystal_array_0_target_y
#define target_z mccchannel_19_analyzer_2_array_crystal_array_0_target_z
#define focus_aw mccchannel_19_analyzer_2_array_crystal_array_0_focus_aw
#define focus_ah mccchannel_19_analyzer_2_array_crystal_array_0_focus_ah
#define focus_xw mccchannel_19_analyzer_2_array_crystal_array_0_focus_xw
#define focus_xh mccchannel_19_analyzer_2_array_crystal_array_0_focus_xh
#define focus_r mccchannel_19_analyzer_2_array_crystal_array_0_focus_r
#define p_interact mccchannel_19_analyzer_2_array_crystal_array_0_p_interact
#define mask_string mccchannel_19_analyzer_2_array_crystal_array_0_mask_string
#define mask_setting mccchannel_19_analyzer_2_array_crystal_array_0_mask_setting
#define number_of_activations mccchannel_19_analyzer_2_array_crystal_array_0_number_of_activations
#line 224 "Union_box.comp"
{
// Initializes the focusing system for this volume including input sanitation.
focus_initialize(&this_box_volume.geometry, POS_A_COMP_INDEX(INDEX_CURRENT_COMP+target_index), POS_A_CURRENT_COMP, ROT_A_CURRENT_COMP, target_index, target_x, target_y, target_z, focus_aw, focus_ah, focus_xw, focus_xh, focus_r, NAME_CURRENT_COMP);

// Input sanitation for this geometry
if (xwidth <= 0) {
  printf("\nERROR in Union_box named %s, the xwidth is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (yheight <= 0) {
  printf("\nERROR in Union_box named %s, yheight is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (zdepth <= 0) {
  printf("\nERROR in Union_box named %s, zdepth is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (xwidth2 <= 0 && xwidth2 != -1) {
  printf("\nERROR in Union_box named %s, the xwidth2 is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (yheight2 <= 0 && yheight2 != -1) {
  printf("\nERROR in Union_box named %s, yheight2 is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}

// Use sanitation
if (global_material_list.num_elements == 0) {
  printf("\nERROR: Need to define a material using Union_make_material before using a Union geometry component. \n");
  printf("       %s was defined before first use of Union_make_material.\n",NAME_CURRENT_COMP);
  exit(1);
}

this_box_volume.geometry.is_masked_volume = 0;
this_box_volume.geometry.is_exit_volume = 0;
this_box_volume.geometry.is_mask_volume = 0;
// check if the volume is a mask, if it is the material string is irelevant.
if (mask_string && strlen(mask_string) && strcmp(mask_string, "NULL") && strcmp(mask_string, "0")) {
    // A mask volume is used to limit the extend of other volumes, called the masked volumes. These are specified in the mask_string.
    // In order for a ray to enter a masked volume, it needs to be both in the region covered by that volume AND the mask volume.
    // When more than
    this_box_volume.geometry.mask_mode = 1; // Default is mask mode is ALL
    if (mask_setting && strlen(mask_setting) && strcmp(mask_setting, "NULL") && strcmp(mask_setting, "0")) {
        if (strcmp(mask_setting,"ALL") == 0 || strcmp(mask_setting,"All") == 0) this_box_volume.geometry.mask_mode = 1;
        else if (strcmp(mask_setting,"ANY") == 0 || strcmp(mask_setting,"Any") == 0) this_box_volume.geometry.mask_mode = 2;
        else {
            printf("The mask_mode of component %s is set to %s, but must be either ALL or ANY.\n",NAME_CURRENT_COMP,mask_setting);
            exit(1);
        }
    }
    
    for (loop_index=0;loop_index<global_geometry_list.num_elements;loop_index++) {
        // Add mask list
        if (1 == manual_linking_function(global_geometry_list.elements[loop_index].name,mask_string)) {
            add_element_to_int_list(&this_box_volume.geometry.mask_list,global_geometry_list.elements[loop_index].component_index);
            add_element_to_int_list(&global_geometry_list.elements[loop_index].Volume->geometry.masked_by_list,INDEX_CURRENT_COMP);
            global_geometry_list.elements[loop_index].Volume->geometry.is_masked_volume = 1;
            if (this_box_volume.geometry.mask_mode == 2)
                global_geometry_list.elements[loop_index].Volume->geometry.mask_mode = 2;
            if (this_box_volume.geometry.mask_mode == 1) {
                if (global_geometry_list.elements[loop_index].Volume->geometry.is_masked_volume == 1 && global_geometry_list.elements[loop_index].Volume->geometry.mask_mode != 2)
                    // If more than one mask is added to one volume, the ANY mode overwrites the (default) ALL mode.
                    global_geometry_list.elements[loop_index].Volume->geometry.mask_mode = 1;
            }
            
            found_geometries = 1;
        }
    }
    if (found_geometries == 0) {
        printf("The mask_string in geometry: %s did not find any of the specified volumes in the mask_string %s \n",NAME_CURRENT_COMP,mask_string);
        exit(1);
    }
    this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
    this_box_volume.p_physics->is_vacuum = 0; // Makes this volume a vacuum
    this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
    this_box_volume.p_physics->my_a = 0; // Should not be used.
    sprintf(this_box_volume.p_physics->name,"Mask");
    this_box_volume.geometry.is_mask_volume = 1;
    
    
// Read the material input, or if it lacks, use automatic linking.
} else if (material_string && strlen(material_string) && strcmp(material_string, "NULL") && strcmp(material_string, "0")) {
    // A geometry string was given, use it to determine which material
    if (0 == strcmp(material_string,"vacuum") || 0 == strcmp(material_string,"Vacuum")) {
        // One could have a global physics struct for vacuum instead of creating one for each
        this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
        this_box_volume.p_physics->is_vacuum = 1; // Makes this volume a vacuum
        this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
        this_box_volume.p_physics->my_a = 0; // Should not be used.
        sprintf(this_box_volume.p_physics->name,"Vacuum");
    } else if (0 == strcmp(material_string,"exit") || 0 == strcmp(material_string,"Exit")) {
        // One could have a global physics struct for vacuum instead of creating one for each
        this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
        this_box_volume.p_physics->is_vacuum = 1; // Makes this volume a vacuum
        this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
        this_box_volume.p_physics->my_a = 0; // Should not be used.
        this_box_volume.geometry.is_exit_volume = 1;
        sprintf(this_box_volume.p_physics->name,"Exit");
    } else {
        #ifndef MATERIAL_DETECTOR
            printf("Need to define a material before refering to it in a geometry %s.\n",NAME_CURRENT_COMP);
            exit(1);
        #endif
        for (loop_index=0;loop_index<global_material_list.num_elements;loop_index++) {
            if (0 == strcmp(material_string,global_material_list.elements[loop_index].name)) {
                this_box_volume.p_physics = global_material_list.elements[loop_index].physics;
                break;
            }
            if (loop_index == global_material_list.num_elements-1) {
            printf("\n");
            printf("ERROR: The material string \"%s\" in Union geometry \"%s\" did not match a specified material. \n",material_string,NAME_CURRENT_COMP);
            printf("       The materials available at this point (need to be defined before the geometry): \n");
            for (loop_index=0;loop_index<global_material_list.num_elements;loop_index++)
              printf("         %s\n",global_material_list.elements[loop_index].name);
            printf("\n");
            printf("       It is also possible to use one of the defualt materials avaiable: \n");
            printf("           Vacuum (for a Volume without scattering or absorption)\n");
            printf("           Exit (for a Volume where the ray exits the component if it enters)\n");
            printf("           Mask (for a Volume that masks existing volumes specified in the mask_string\n");
            exit(1);
          }
        }
    }
} else {
    // Automatic linking, simply using the last defined material.
    #ifndef MATERIAL_DETECTOR
        printf("Need to define a material before the geometry to use automatic linking %s.\n",NAME_CURRENT_COMP);
        exit(1);
    #endif
    this_box_volume.p_physics = global_material_list.elements[global_material_list.num_elements-1].physics;
}

sprintf(this_box_volume.name,NAME_CURRENT_COMP);
sprintf(this_box_volume.geometry.shape,"box");
this_box_volume.geometry.priority_value = priority;
this_box_volume.geometry.geometry_p_interact = p_interact;
// Currently the coordinates will be in absolute space.
this_box_volume.geometry.center = POS_A_CURRENT_COMP;

this_box_storage.z_depth = zdepth;
this_box_storage.x_width1 = xwidth;
this_box_storage.y_height1 = yheight;

this_box_storage.is_rectangle = 0;
if (xwidth2 < 0 && yheight2 < 0) this_box_storage.is_rectangle = 1;
if (xwidth == xwidth2 && yheight == yheight2) this_box_storage.is_rectangle = 1;

if (xwidth2 < 0) {
    this_box_storage.x_width2 = xwidth;
    xwidth2 = xwidth;
} else this_box_storage.x_width2 = xwidth2;

if (yheight2 < 0) {
    this_box_storage.y_height2 = yheight;
    yheight2 = yheight;
} else this_box_storage.y_height2 = yheight2;


this_box_storage.normal_vectors[0] = coords_set(0,0,1);
this_box_storage.normal_vectors[1] = coords_set(0,0,1);

// for sides with y component = 0
x_component = 2*zdepth/sqrt((xwidth-xwidth2)*(xwidth-xwidth2)+4*zdepth*zdepth);
z_component = (xwidth-xwidth2)/sqrt(4*zdepth*zdepth+(xwidth-xwidth2)*(xwidth-xwidth2));

this_box_storage.normal_vectors[2] = coords_set(x_component,0,z_component);
this_box_storage.normal_vectors[3] = coords_set(-x_component,0,z_component);

// for sides with x component = 0
y_component = 2*zdepth/sqrt((yheight-yheight2)*(yheight-yheight2)+4*zdepth*zdepth);
z_component = (yheight-yheight2)/sqrt(4*zdepth*zdepth+(yheight-yheight2)*(yheight-yheight2));

this_box_storage.normal_vectors[4] = coords_set(0,y_component,z_component);
this_box_storage.normal_vectors[5] = coords_set(0,-y_component,z_component);

this_box_volume.geometry.visualization_on = visualize;

this_box_volume.geometry.geometry_parameters.p_box_storage = &this_box_storage;

// Assign pointers to functions for intersection with the shape, checking if a point is inside the shape
if (this_box_storage.is_rectangle == 1) {
this_box_volume.geometry.intersect_function = &sample_box_intersect_simple;
this_box_volume.geometry.within_function = &r_within_box_simple;
}
else {
this_box_volume.geometry.intersect_function = &sample_box_intersect_advanced;
this_box_volume.geometry.within_function = &r_within_box_advanced;
}

this_box_volume.geometry.shell_points = &box_shell_points;
this_box_volume.geometry.mcdisplay_function = &mcdisplay_box_function;
this_box_volume.geometry.initialize_from_main_function = &initialize_box_geometry_from_main_component;
this_box_volume.geometry.process_rot_allocated = 0;

this_box_volume.geometry.copy_geometry_parameters = &allocate_box_storage_copy;

rot_copy(this_box_volume.geometry.rotation_matrix,ROT_A_CURRENT_COMP); //check how ROT_R_CURRENT_COMP would work
rot_transpose(ROT_A_CURRENT_COMP,this_box_volume.geometry.transpose_rotation_matrix);

// Initialize loggers
this_box_volume.loggers.num_elements = 0;

// packing the information into the global_geometry_element, which is then included in the global_geometry_list.
sprintf(global_geometry_element.name,NAME_CURRENT_COMP);
global_geometry_element.activation_counter = number_of_activations;
global_geometry_element.component_index = INDEX_CURRENT_COMP;
global_geometry_element.Volume = &this_box_volume; // Would be nicer if this m was a pointer, now we have the (small) data two places
add_element_to_geometry_list(&global_geometry_list,global_geometry_element);
}
#line 335618 "MACS_sample_kidney_box.c"
#undef number_of_activations
#undef mask_setting
#undef mask_string
#undef p_interact
#undef focus_r
#undef focus_xh
#undef focus_xw
#undef focus_ah
#undef focus_aw
#undef target_z
#undef target_y
#undef target_x
#undef target_index
#undef visualize
#undef yheight2
#undef xwidth2
#undef zdepth
#undef yheight
#undef xwidth
#undef priority
#undef material_string
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

  /* Initializations for component channel_19_analyzer_2_array_crystal_array_1. */
  SIG_MESSAGE("channel_19_analyzer_2_array_crystal_array_1 (Init)");
#define mccompcurname  channel_19_analyzer_2_array_crystal_array_1
#define mccompcurtype  Union_box
#define mccompcurindex 864
#define loop_index mccchannel_19_analyzer_2_array_crystal_array_1_loop_index
#define this_box_volume mccchannel_19_analyzer_2_array_crystal_array_1_this_box_volume
#define global_geometry_element mccchannel_19_analyzer_2_array_crystal_array_1_global_geometry_element
#define this_box_storage mccchannel_19_analyzer_2_array_crystal_array_1_this_box_storage
#define material_string mccchannel_19_analyzer_2_array_crystal_array_1_material_string
#define priority mccchannel_19_analyzer_2_array_crystal_array_1_priority
#define xwidth mccchannel_19_analyzer_2_array_crystal_array_1_xwidth
#define yheight mccchannel_19_analyzer_2_array_crystal_array_1_yheight
#define zdepth mccchannel_19_analyzer_2_array_crystal_array_1_zdepth
#define xwidth2 mccchannel_19_analyzer_2_array_crystal_array_1_xwidth2
#define yheight2 mccchannel_19_analyzer_2_array_crystal_array_1_yheight2
#define visualize mccchannel_19_analyzer_2_array_crystal_array_1_visualize
#define target_index mccchannel_19_analyzer_2_array_crystal_array_1_target_index
#define target_x mccchannel_19_analyzer_2_array_crystal_array_1_target_x
#define target_y mccchannel_19_analyzer_2_array_crystal_array_1_target_y
#define target_z mccchannel_19_analyzer_2_array_crystal_array_1_target_z
#define focus_aw mccchannel_19_analyzer_2_array_crystal_array_1_focus_aw
#define focus_ah mccchannel_19_analyzer_2_array_crystal_array_1_focus_ah
#define focus_xw mccchannel_19_analyzer_2_array_crystal_array_1_focus_xw
#define focus_xh mccchannel_19_analyzer_2_array_crystal_array_1_focus_xh
#define focus_r mccchannel_19_analyzer_2_array_crystal_array_1_focus_r
#define p_interact mccchannel_19_analyzer_2_array_crystal_array_1_p_interact
#define mask_string mccchannel_19_analyzer_2_array_crystal_array_1_mask_string
#define mask_setting mccchannel_19_analyzer_2_array_crystal_array_1_mask_setting
#define number_of_activations mccchannel_19_analyzer_2_array_crystal_array_1_number_of_activations
#line 224 "Union_box.comp"
{
// Initializes the focusing system for this volume including input sanitation.
focus_initialize(&this_box_volume.geometry, POS_A_COMP_INDEX(INDEX_CURRENT_COMP+target_index), POS_A_CURRENT_COMP, ROT_A_CURRENT_COMP, target_index, target_x, target_y, target_z, focus_aw, focus_ah, focus_xw, focus_xh, focus_r, NAME_CURRENT_COMP);

// Input sanitation for this geometry
if (xwidth <= 0) {
  printf("\nERROR in Union_box named %s, the xwidth is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (yheight <= 0) {
  printf("\nERROR in Union_box named %s, yheight is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (zdepth <= 0) {
  printf("\nERROR in Union_box named %s, zdepth is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (xwidth2 <= 0 && xwidth2 != -1) {
  printf("\nERROR in Union_box named %s, the xwidth2 is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (yheight2 <= 0 && yheight2 != -1) {
  printf("\nERROR in Union_box named %s, yheight2 is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}

// Use sanitation
if (global_material_list.num_elements == 0) {
  printf("\nERROR: Need to define a material using Union_make_material before using a Union geometry component. \n");
  printf("       %s was defined before first use of Union_make_material.\n",NAME_CURRENT_COMP);
  exit(1);
}

this_box_volume.geometry.is_masked_volume = 0;
this_box_volume.geometry.is_exit_volume = 0;
this_box_volume.geometry.is_mask_volume = 0;
// check if the volume is a mask, if it is the material string is irelevant.
if (mask_string && strlen(mask_string) && strcmp(mask_string, "NULL") && strcmp(mask_string, "0")) {
    // A mask volume is used to limit the extend of other volumes, called the masked volumes. These are specified in the mask_string.
    // In order for a ray to enter a masked volume, it needs to be both in the region covered by that volume AND the mask volume.
    // When more than
    this_box_volume.geometry.mask_mode = 1; // Default is mask mode is ALL
    if (mask_setting && strlen(mask_setting) && strcmp(mask_setting, "NULL") && strcmp(mask_setting, "0")) {
        if (strcmp(mask_setting,"ALL") == 0 || strcmp(mask_setting,"All") == 0) this_box_volume.geometry.mask_mode = 1;
        else if (strcmp(mask_setting,"ANY") == 0 || strcmp(mask_setting,"Any") == 0) this_box_volume.geometry.mask_mode = 2;
        else {
            printf("The mask_mode of component %s is set to %s, but must be either ALL or ANY.\n",NAME_CURRENT_COMP,mask_setting);
            exit(1);
        }
    }
    
    for (loop_index=0;loop_index<global_geometry_list.num_elements;loop_index++) {
        // Add mask list
        if (1 == manual_linking_function(global_geometry_list.elements[loop_index].name,mask_string)) {
            add_element_to_int_list(&this_box_volume.geometry.mask_list,global_geometry_list.elements[loop_index].component_index);
            add_element_to_int_list(&global_geometry_list.elements[loop_index].Volume->geometry.masked_by_list,INDEX_CURRENT_COMP);
            global_geometry_list.elements[loop_index].Volume->geometry.is_masked_volume = 1;
            if (this_box_volume.geometry.mask_mode == 2)
                global_geometry_list.elements[loop_index].Volume->geometry.mask_mode = 2;
            if (this_box_volume.geometry.mask_mode == 1) {
                if (global_geometry_list.elements[loop_index].Volume->geometry.is_masked_volume == 1 && global_geometry_list.elements[loop_index].Volume->geometry.mask_mode != 2)
                    // If more than one mask is added to one volume, the ANY mode overwrites the (default) ALL mode.
                    global_geometry_list.elements[loop_index].Volume->geometry.mask_mode = 1;
            }
            
            found_geometries = 1;
        }
    }
    if (found_geometries == 0) {
        printf("The mask_string in geometry: %s did not find any of the specified volumes in the mask_string %s \n",NAME_CURRENT_COMP,mask_string);
        exit(1);
    }
    this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
    this_box_volume.p_physics->is_vacuum = 0; // Makes this volume a vacuum
    this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
    this_box_volume.p_physics->my_a = 0; // Should not be used.
    sprintf(this_box_volume.p_physics->name,"Mask");
    this_box_volume.geometry.is_mask_volume = 1;
    
    
// Read the material input, or if it lacks, use automatic linking.
} else if (material_string && strlen(material_string) && strcmp(material_string, "NULL") && strcmp(material_string, "0")) {
    // A geometry string was given, use it to determine which material
    if (0 == strcmp(material_string,"vacuum") || 0 == strcmp(material_string,"Vacuum")) {
        // One could have a global physics struct for vacuum instead of creating one for each
        this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
        this_box_volume.p_physics->is_vacuum = 1; // Makes this volume a vacuum
        this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
        this_box_volume.p_physics->my_a = 0; // Should not be used.
        sprintf(this_box_volume.p_physics->name,"Vacuum");
    } else if (0 == strcmp(material_string,"exit") || 0 == strcmp(material_string,"Exit")) {
        // One could have a global physics struct for vacuum instead of creating one for each
        this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
        this_box_volume.p_physics->is_vacuum = 1; // Makes this volume a vacuum
        this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
        this_box_volume.p_physics->my_a = 0; // Should not be used.
        this_box_volume.geometry.is_exit_volume = 1;
        sprintf(this_box_volume.p_physics->name,"Exit");
    } else {
        #ifndef MATERIAL_DETECTOR
            printf("Need to define a material before refering to it in a geometry %s.\n",NAME_CURRENT_COMP);
            exit(1);
        #endif
        for (loop_index=0;loop_index<global_material_list.num_elements;loop_index++) {
            if (0 == strcmp(material_string,global_material_list.elements[loop_index].name)) {
                this_box_volume.p_physics = global_material_list.elements[loop_index].physics;
                break;
            }
            if (loop_index == global_material_list.num_elements-1) {
            printf("\n");
            printf("ERROR: The material string \"%s\" in Union geometry \"%s\" did not match a specified material. \n",material_string,NAME_CURRENT_COMP);
            printf("       The materials available at this point (need to be defined before the geometry): \n");
            for (loop_index=0;loop_index<global_material_list.num_elements;loop_index++)
              printf("         %s\n",global_material_list.elements[loop_index].name);
            printf("\n");
            printf("       It is also possible to use one of the defualt materials avaiable: \n");
            printf("           Vacuum (for a Volume without scattering or absorption)\n");
            printf("           Exit (for a Volume where the ray exits the component if it enters)\n");
            printf("           Mask (for a Volume that masks existing volumes specified in the mask_string\n");
            exit(1);
          }
        }
    }
} else {
    // Automatic linking, simply using the last defined material.
    #ifndef MATERIAL_DETECTOR
        printf("Need to define a material before the geometry to use automatic linking %s.\n",NAME_CURRENT_COMP);
        exit(1);
    #endif
    this_box_volume.p_physics = global_material_list.elements[global_material_list.num_elements-1].physics;
}

sprintf(this_box_volume.name,NAME_CURRENT_COMP);
sprintf(this_box_volume.geometry.shape,"box");
this_box_volume.geometry.priority_value = priority;
this_box_volume.geometry.geometry_p_interact = p_interact;
// Currently the coordinates will be in absolute space.
this_box_volume.geometry.center = POS_A_CURRENT_COMP;

this_box_storage.z_depth = zdepth;
this_box_storage.x_width1 = xwidth;
this_box_storage.y_height1 = yheight;

this_box_storage.is_rectangle = 0;
if (xwidth2 < 0 && yheight2 < 0) this_box_storage.is_rectangle = 1;
if (xwidth == xwidth2 && yheight == yheight2) this_box_storage.is_rectangle = 1;

if (xwidth2 < 0) {
    this_box_storage.x_width2 = xwidth;
    xwidth2 = xwidth;
} else this_box_storage.x_width2 = xwidth2;

if (yheight2 < 0) {
    this_box_storage.y_height2 = yheight;
    yheight2 = yheight;
} else this_box_storage.y_height2 = yheight2;


this_box_storage.normal_vectors[0] = coords_set(0,0,1);
this_box_storage.normal_vectors[1] = coords_set(0,0,1);

// for sides with y component = 0
x_component = 2*zdepth/sqrt((xwidth-xwidth2)*(xwidth-xwidth2)+4*zdepth*zdepth);
z_component = (xwidth-xwidth2)/sqrt(4*zdepth*zdepth+(xwidth-xwidth2)*(xwidth-xwidth2));

this_box_storage.normal_vectors[2] = coords_set(x_component,0,z_component);
this_box_storage.normal_vectors[3] = coords_set(-x_component,0,z_component);

// for sides with x component = 0
y_component = 2*zdepth/sqrt((yheight-yheight2)*(yheight-yheight2)+4*zdepth*zdepth);
z_component = (yheight-yheight2)/sqrt(4*zdepth*zdepth+(yheight-yheight2)*(yheight-yheight2));

this_box_storage.normal_vectors[4] = coords_set(0,y_component,z_component);
this_box_storage.normal_vectors[5] = coords_set(0,-y_component,z_component);

this_box_volume.geometry.visualization_on = visualize;

this_box_volume.geometry.geometry_parameters.p_box_storage = &this_box_storage;

// Assign pointers to functions for intersection with the shape, checking if a point is inside the shape
if (this_box_storage.is_rectangle == 1) {
this_box_volume.geometry.intersect_function = &sample_box_intersect_simple;
this_box_volume.geometry.within_function = &r_within_box_simple;
}
else {
this_box_volume.geometry.intersect_function = &sample_box_intersect_advanced;
this_box_volume.geometry.within_function = &r_within_box_advanced;
}

this_box_volume.geometry.shell_points = &box_shell_points;
this_box_volume.geometry.mcdisplay_function = &mcdisplay_box_function;
this_box_volume.geometry.initialize_from_main_function = &initialize_box_geometry_from_main_component;
this_box_volume.geometry.process_rot_allocated = 0;

this_box_volume.geometry.copy_geometry_parameters = &allocate_box_storage_copy;

rot_copy(this_box_volume.geometry.rotation_matrix,ROT_A_CURRENT_COMP); //check how ROT_R_CURRENT_COMP would work
rot_transpose(ROT_A_CURRENT_COMP,this_box_volume.geometry.transpose_rotation_matrix);

// Initialize loggers
this_box_volume.loggers.num_elements = 0;

// packing the information into the global_geometry_element, which is then included in the global_geometry_list.
sprintf(global_geometry_element.name,NAME_CURRENT_COMP);
global_geometry_element.activation_counter = number_of_activations;
global_geometry_element.component_index = INDEX_CURRENT_COMP;
global_geometry_element.Volume = &this_box_volume; // Would be nicer if this m was a pointer, now we have the (small) data two places
add_element_to_geometry_list(&global_geometry_list,global_geometry_element);
}
#line 335888 "MACS_sample_kidney_box.c"
#undef number_of_activations
#undef mask_setting
#undef mask_string
#undef p_interact
#undef focus_r
#undef focus_xh
#undef focus_xw
#undef focus_ah
#undef focus_aw
#undef target_z
#undef target_y
#undef target_x
#undef target_index
#undef visualize
#undef yheight2
#undef xwidth2
#undef zdepth
#undef yheight
#undef xwidth
#undef priority
#undef material_string
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

  /* Initializations for component channel_19_analyzer_2_array_crystal_array_2. */
  SIG_MESSAGE("channel_19_analyzer_2_array_crystal_array_2 (Init)");
#define mccompcurname  channel_19_analyzer_2_array_crystal_array_2
#define mccompcurtype  Union_box
#define mccompcurindex 865
#define loop_index mccchannel_19_analyzer_2_array_crystal_array_2_loop_index
#define this_box_volume mccchannel_19_analyzer_2_array_crystal_array_2_this_box_volume
#define global_geometry_element mccchannel_19_analyzer_2_array_crystal_array_2_global_geometry_element
#define this_box_storage mccchannel_19_analyzer_2_array_crystal_array_2_this_box_storage
#define material_string mccchannel_19_analyzer_2_array_crystal_array_2_material_string
#define priority mccchannel_19_analyzer_2_array_crystal_array_2_priority
#define xwidth mccchannel_19_analyzer_2_array_crystal_array_2_xwidth
#define yheight mccchannel_19_analyzer_2_array_crystal_array_2_yheight
#define zdepth mccchannel_19_analyzer_2_array_crystal_array_2_zdepth
#define xwidth2 mccchannel_19_analyzer_2_array_crystal_array_2_xwidth2
#define yheight2 mccchannel_19_analyzer_2_array_crystal_array_2_yheight2
#define visualize mccchannel_19_analyzer_2_array_crystal_array_2_visualize
#define target_index mccchannel_19_analyzer_2_array_crystal_array_2_target_index
#define target_x mccchannel_19_analyzer_2_array_crystal_array_2_target_x
#define target_y mccchannel_19_analyzer_2_array_crystal_array_2_target_y
#define target_z mccchannel_19_analyzer_2_array_crystal_array_2_target_z
#define focus_aw mccchannel_19_analyzer_2_array_crystal_array_2_focus_aw
#define focus_ah mccchannel_19_analyzer_2_array_crystal_array_2_focus_ah
#define focus_xw mccchannel_19_analyzer_2_array_crystal_array_2_focus_xw
#define focus_xh mccchannel_19_analyzer_2_array_crystal_array_2_focus_xh
#define focus_r mccchannel_19_analyzer_2_array_crystal_array_2_focus_r
#define p_interact mccchannel_19_analyzer_2_array_crystal_array_2_p_interact
#define mask_string mccchannel_19_analyzer_2_array_crystal_array_2_mask_string
#define mask_setting mccchannel_19_analyzer_2_array_crystal_array_2_mask_setting
#define number_of_activations mccchannel_19_analyzer_2_array_crystal_array_2_number_of_activations
#line 224 "Union_box.comp"
{
// Initializes the focusing system for this volume including input sanitation.
focus_initialize(&this_box_volume.geometry, POS_A_COMP_INDEX(INDEX_CURRENT_COMP+target_index), POS_A_CURRENT_COMP, ROT_A_CURRENT_COMP, target_index, target_x, target_y, target_z, focus_aw, focus_ah, focus_xw, focus_xh, focus_r, NAME_CURRENT_COMP);

// Input sanitation for this geometry
if (xwidth <= 0) {
  printf("\nERROR in Union_box named %s, the xwidth is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (yheight <= 0) {
  printf("\nERROR in Union_box named %s, yheight is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (zdepth <= 0) {
  printf("\nERROR in Union_box named %s, zdepth is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (xwidth2 <= 0 && xwidth2 != -1) {
  printf("\nERROR in Union_box named %s, the xwidth2 is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (yheight2 <= 0 && yheight2 != -1) {
  printf("\nERROR in Union_box named %s, yheight2 is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}

// Use sanitation
if (global_material_list.num_elements == 0) {
  printf("\nERROR: Need to define a material using Union_make_material before using a Union geometry component. \n");
  printf("       %s was defined before first use of Union_make_material.\n",NAME_CURRENT_COMP);
  exit(1);
}

this_box_volume.geometry.is_masked_volume = 0;
this_box_volume.geometry.is_exit_volume = 0;
this_box_volume.geometry.is_mask_volume = 0;
// check if the volume is a mask, if it is the material string is irelevant.
if (mask_string && strlen(mask_string) && strcmp(mask_string, "NULL") && strcmp(mask_string, "0")) {
    // A mask volume is used to limit the extend of other volumes, called the masked volumes. These are specified in the mask_string.
    // In order for a ray to enter a masked volume, it needs to be both in the region covered by that volume AND the mask volume.
    // When more than
    this_box_volume.geometry.mask_mode = 1; // Default is mask mode is ALL
    if (mask_setting && strlen(mask_setting) && strcmp(mask_setting, "NULL") && strcmp(mask_setting, "0")) {
        if (strcmp(mask_setting,"ALL") == 0 || strcmp(mask_setting,"All") == 0) this_box_volume.geometry.mask_mode = 1;
        else if (strcmp(mask_setting,"ANY") == 0 || strcmp(mask_setting,"Any") == 0) this_box_volume.geometry.mask_mode = 2;
        else {
            printf("The mask_mode of component %s is set to %s, but must be either ALL or ANY.\n",NAME_CURRENT_COMP,mask_setting);
            exit(1);
        }
    }
    
    for (loop_index=0;loop_index<global_geometry_list.num_elements;loop_index++) {
        // Add mask list
        if (1 == manual_linking_function(global_geometry_list.elements[loop_index].name,mask_string)) {
            add_element_to_int_list(&this_box_volume.geometry.mask_list,global_geometry_list.elements[loop_index].component_index);
            add_element_to_int_list(&global_geometry_list.elements[loop_index].Volume->geometry.masked_by_list,INDEX_CURRENT_COMP);
            global_geometry_list.elements[loop_index].Volume->geometry.is_masked_volume = 1;
            if (this_box_volume.geometry.mask_mode == 2)
                global_geometry_list.elements[loop_index].Volume->geometry.mask_mode = 2;
            if (this_box_volume.geometry.mask_mode == 1) {
                if (global_geometry_list.elements[loop_index].Volume->geometry.is_masked_volume == 1 && global_geometry_list.elements[loop_index].Volume->geometry.mask_mode != 2)
                    // If more than one mask is added to one volume, the ANY mode overwrites the (default) ALL mode.
                    global_geometry_list.elements[loop_index].Volume->geometry.mask_mode = 1;
            }
            
            found_geometries = 1;
        }
    }
    if (found_geometries == 0) {
        printf("The mask_string in geometry: %s did not find any of the specified volumes in the mask_string %s \n",NAME_CURRENT_COMP,mask_string);
        exit(1);
    }
    this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
    this_box_volume.p_physics->is_vacuum = 0; // Makes this volume a vacuum
    this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
    this_box_volume.p_physics->my_a = 0; // Should not be used.
    sprintf(this_box_volume.p_physics->name,"Mask");
    this_box_volume.geometry.is_mask_volume = 1;
    
    
// Read the material input, or if it lacks, use automatic linking.
} else if (material_string && strlen(material_string) && strcmp(material_string, "NULL") && strcmp(material_string, "0")) {
    // A geometry string was given, use it to determine which material
    if (0 == strcmp(material_string,"vacuum") || 0 == strcmp(material_string,"Vacuum")) {
        // One could have a global physics struct for vacuum instead of creating one for each
        this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
        this_box_volume.p_physics->is_vacuum = 1; // Makes this volume a vacuum
        this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
        this_box_volume.p_physics->my_a = 0; // Should not be used.
        sprintf(this_box_volume.p_physics->name,"Vacuum");
    } else if (0 == strcmp(material_string,"exit") || 0 == strcmp(material_string,"Exit")) {
        // One could have a global physics struct for vacuum instead of creating one for each
        this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
        this_box_volume.p_physics->is_vacuum = 1; // Makes this volume a vacuum
        this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
        this_box_volume.p_physics->my_a = 0; // Should not be used.
        this_box_volume.geometry.is_exit_volume = 1;
        sprintf(this_box_volume.p_physics->name,"Exit");
    } else {
        #ifndef MATERIAL_DETECTOR
            printf("Need to define a material before refering to it in a geometry %s.\n",NAME_CURRENT_COMP);
            exit(1);
        #endif
        for (loop_index=0;loop_index<global_material_list.num_elements;loop_index++) {
            if (0 == strcmp(material_string,global_material_list.elements[loop_index].name)) {
                this_box_volume.p_physics = global_material_list.elements[loop_index].physics;
                break;
            }
            if (loop_index == global_material_list.num_elements-1) {
            printf("\n");
            printf("ERROR: The material string \"%s\" in Union geometry \"%s\" did not match a specified material. \n",material_string,NAME_CURRENT_COMP);
            printf("       The materials available at this point (need to be defined before the geometry): \n");
            for (loop_index=0;loop_index<global_material_list.num_elements;loop_index++)
              printf("         %s\n",global_material_list.elements[loop_index].name);
            printf("\n");
            printf("       It is also possible to use one of the defualt materials avaiable: \n");
            printf("           Vacuum (for a Volume without scattering or absorption)\n");
            printf("           Exit (for a Volume where the ray exits the component if it enters)\n");
            printf("           Mask (for a Volume that masks existing volumes specified in the mask_string\n");
            exit(1);
          }
        }
    }
} else {
    // Automatic linking, simply using the last defined material.
    #ifndef MATERIAL_DETECTOR
        printf("Need to define a material before the geometry to use automatic linking %s.\n",NAME_CURRENT_COMP);
        exit(1);
    #endif
    this_box_volume.p_physics = global_material_list.elements[global_material_list.num_elements-1].physics;
}

sprintf(this_box_volume.name,NAME_CURRENT_COMP);
sprintf(this_box_volume.geometry.shape,"box");
this_box_volume.geometry.priority_value = priority;
this_box_volume.geometry.geometry_p_interact = p_interact;
// Currently the coordinates will be in absolute space.
this_box_volume.geometry.center = POS_A_CURRENT_COMP;

this_box_storage.z_depth = zdepth;
this_box_storage.x_width1 = xwidth;
this_box_storage.y_height1 = yheight;

this_box_storage.is_rectangle = 0;
if (xwidth2 < 0 && yheight2 < 0) this_box_storage.is_rectangle = 1;
if (xwidth == xwidth2 && yheight == yheight2) this_box_storage.is_rectangle = 1;

if (xwidth2 < 0) {
    this_box_storage.x_width2 = xwidth;
    xwidth2 = xwidth;
} else this_box_storage.x_width2 = xwidth2;

if (yheight2 < 0) {
    this_box_storage.y_height2 = yheight;
    yheight2 = yheight;
} else this_box_storage.y_height2 = yheight2;


this_box_storage.normal_vectors[0] = coords_set(0,0,1);
this_box_storage.normal_vectors[1] = coords_set(0,0,1);

// for sides with y component = 0
x_component = 2*zdepth/sqrt((xwidth-xwidth2)*(xwidth-xwidth2)+4*zdepth*zdepth);
z_component = (xwidth-xwidth2)/sqrt(4*zdepth*zdepth+(xwidth-xwidth2)*(xwidth-xwidth2));

this_box_storage.normal_vectors[2] = coords_set(x_component,0,z_component);
this_box_storage.normal_vectors[3] = coords_set(-x_component,0,z_component);

// for sides with x component = 0
y_component = 2*zdepth/sqrt((yheight-yheight2)*(yheight-yheight2)+4*zdepth*zdepth);
z_component = (yheight-yheight2)/sqrt(4*zdepth*zdepth+(yheight-yheight2)*(yheight-yheight2));

this_box_storage.normal_vectors[4] = coords_set(0,y_component,z_component);
this_box_storage.normal_vectors[5] = coords_set(0,-y_component,z_component);

this_box_volume.geometry.visualization_on = visualize;

this_box_volume.geometry.geometry_parameters.p_box_storage = &this_box_storage;

// Assign pointers to functions for intersection with the shape, checking if a point is inside the shape
if (this_box_storage.is_rectangle == 1) {
this_box_volume.geometry.intersect_function = &sample_box_intersect_simple;
this_box_volume.geometry.within_function = &r_within_box_simple;
}
else {
this_box_volume.geometry.intersect_function = &sample_box_intersect_advanced;
this_box_volume.geometry.within_function = &r_within_box_advanced;
}

this_box_volume.geometry.shell_points = &box_shell_points;
this_box_volume.geometry.mcdisplay_function = &mcdisplay_box_function;
this_box_volume.geometry.initialize_from_main_function = &initialize_box_geometry_from_main_component;
this_box_volume.geometry.process_rot_allocated = 0;

this_box_volume.geometry.copy_geometry_parameters = &allocate_box_storage_copy;

rot_copy(this_box_volume.geometry.rotation_matrix,ROT_A_CURRENT_COMP); //check how ROT_R_CURRENT_COMP would work
rot_transpose(ROT_A_CURRENT_COMP,this_box_volume.geometry.transpose_rotation_matrix);

// Initialize loggers
this_box_volume.loggers.num_elements = 0;

// packing the information into the global_geometry_element, which is then included in the global_geometry_list.
sprintf(global_geometry_element.name,NAME_CURRENT_COMP);
global_geometry_element.activation_counter = number_of_activations;
global_geometry_element.component_index = INDEX_CURRENT_COMP;
global_geometry_element.Volume = &this_box_volume; // Would be nicer if this m was a pointer, now we have the (small) data two places
add_element_to_geometry_list(&global_geometry_list,global_geometry_element);
}
#line 336158 "MACS_sample_kidney_box.c"
#undef number_of_activations
#undef mask_setting
#undef mask_string
#undef p_interact
#undef focus_r
#undef focus_xh
#undef focus_xw
#undef focus_ah
#undef focus_aw
#undef target_z
#undef target_y
#undef target_x
#undef target_index
#undef visualize
#undef yheight2
#undef xwidth2
#undef zdepth
#undef yheight
#undef xwidth
#undef priority
#undef material_string
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

  /* Initializations for component channel_19_analyzer_2_array_crystal_array_3. */
  SIG_MESSAGE("channel_19_analyzer_2_array_crystal_array_3 (Init)");
#define mccompcurname  channel_19_analyzer_2_array_crystal_array_3
#define mccompcurtype  Union_box
#define mccompcurindex 866
#define loop_index mccchannel_19_analyzer_2_array_crystal_array_3_loop_index
#define this_box_volume mccchannel_19_analyzer_2_array_crystal_array_3_this_box_volume
#define global_geometry_element mccchannel_19_analyzer_2_array_crystal_array_3_global_geometry_element
#define this_box_storage mccchannel_19_analyzer_2_array_crystal_array_3_this_box_storage
#define material_string mccchannel_19_analyzer_2_array_crystal_array_3_material_string
#define priority mccchannel_19_analyzer_2_array_crystal_array_3_priority
#define xwidth mccchannel_19_analyzer_2_array_crystal_array_3_xwidth
#define yheight mccchannel_19_analyzer_2_array_crystal_array_3_yheight
#define zdepth mccchannel_19_analyzer_2_array_crystal_array_3_zdepth
#define xwidth2 mccchannel_19_analyzer_2_array_crystal_array_3_xwidth2
#define yheight2 mccchannel_19_analyzer_2_array_crystal_array_3_yheight2
#define visualize mccchannel_19_analyzer_2_array_crystal_array_3_visualize
#define target_index mccchannel_19_analyzer_2_array_crystal_array_3_target_index
#define target_x mccchannel_19_analyzer_2_array_crystal_array_3_target_x
#define target_y mccchannel_19_analyzer_2_array_crystal_array_3_target_y
#define target_z mccchannel_19_analyzer_2_array_crystal_array_3_target_z
#define focus_aw mccchannel_19_analyzer_2_array_crystal_array_3_focus_aw
#define focus_ah mccchannel_19_analyzer_2_array_crystal_array_3_focus_ah
#define focus_xw mccchannel_19_analyzer_2_array_crystal_array_3_focus_xw
#define focus_xh mccchannel_19_analyzer_2_array_crystal_array_3_focus_xh
#define focus_r mccchannel_19_analyzer_2_array_crystal_array_3_focus_r
#define p_interact mccchannel_19_analyzer_2_array_crystal_array_3_p_interact
#define mask_string mccchannel_19_analyzer_2_array_crystal_array_3_mask_string
#define mask_setting mccchannel_19_analyzer_2_array_crystal_array_3_mask_setting
#define number_of_activations mccchannel_19_analyzer_2_array_crystal_array_3_number_of_activations
#line 224 "Union_box.comp"
{
// Initializes the focusing system for this volume including input sanitation.
focus_initialize(&this_box_volume.geometry, POS_A_COMP_INDEX(INDEX_CURRENT_COMP+target_index), POS_A_CURRENT_COMP, ROT_A_CURRENT_COMP, target_index, target_x, target_y, target_z, focus_aw, focus_ah, focus_xw, focus_xh, focus_r, NAME_CURRENT_COMP);

// Input sanitation for this geometry
if (xwidth <= 0) {
  printf("\nERROR in Union_box named %s, the xwidth is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (yheight <= 0) {
  printf("\nERROR in Union_box named %s, yheight is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (zdepth <= 0) {
  printf("\nERROR in Union_box named %s, zdepth is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (xwidth2 <= 0 && xwidth2 != -1) {
  printf("\nERROR in Union_box named %s, the xwidth2 is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (yheight2 <= 0 && yheight2 != -1) {
  printf("\nERROR in Union_box named %s, yheight2 is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}

// Use sanitation
if (global_material_list.num_elements == 0) {
  printf("\nERROR: Need to define a material using Union_make_material before using a Union geometry component. \n");
  printf("       %s was defined before first use of Union_make_material.\n",NAME_CURRENT_COMP);
  exit(1);
}

this_box_volume.geometry.is_masked_volume = 0;
this_box_volume.geometry.is_exit_volume = 0;
this_box_volume.geometry.is_mask_volume = 0;
// check if the volume is a mask, if it is the material string is irelevant.
if (mask_string && strlen(mask_string) && strcmp(mask_string, "NULL") && strcmp(mask_string, "0")) {
    // A mask volume is used to limit the extend of other volumes, called the masked volumes. These are specified in the mask_string.
    // In order for a ray to enter a masked volume, it needs to be both in the region covered by that volume AND the mask volume.
    // When more than
    this_box_volume.geometry.mask_mode = 1; // Default is mask mode is ALL
    if (mask_setting && strlen(mask_setting) && strcmp(mask_setting, "NULL") && strcmp(mask_setting, "0")) {
        if (strcmp(mask_setting,"ALL") == 0 || strcmp(mask_setting,"All") == 0) this_box_volume.geometry.mask_mode = 1;
        else if (strcmp(mask_setting,"ANY") == 0 || strcmp(mask_setting,"Any") == 0) this_box_volume.geometry.mask_mode = 2;
        else {
            printf("The mask_mode of component %s is set to %s, but must be either ALL or ANY.\n",NAME_CURRENT_COMP,mask_setting);
            exit(1);
        }
    }
    
    for (loop_index=0;loop_index<global_geometry_list.num_elements;loop_index++) {
        // Add mask list
        if (1 == manual_linking_function(global_geometry_list.elements[loop_index].name,mask_string)) {
            add_element_to_int_list(&this_box_volume.geometry.mask_list,global_geometry_list.elements[loop_index].component_index);
            add_element_to_int_list(&global_geometry_list.elements[loop_index].Volume->geometry.masked_by_list,INDEX_CURRENT_COMP);
            global_geometry_list.elements[loop_index].Volume->geometry.is_masked_volume = 1;
            if (this_box_volume.geometry.mask_mode == 2)
                global_geometry_list.elements[loop_index].Volume->geometry.mask_mode = 2;
            if (this_box_volume.geometry.mask_mode == 1) {
                if (global_geometry_list.elements[loop_index].Volume->geometry.is_masked_volume == 1 && global_geometry_list.elements[loop_index].Volume->geometry.mask_mode != 2)
                    // If more than one mask is added to one volume, the ANY mode overwrites the (default) ALL mode.
                    global_geometry_list.elements[loop_index].Volume->geometry.mask_mode = 1;
            }
            
            found_geometries = 1;
        }
    }
    if (found_geometries == 0) {
        printf("The mask_string in geometry: %s did not find any of the specified volumes in the mask_string %s \n",NAME_CURRENT_COMP,mask_string);
        exit(1);
    }
    this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
    this_box_volume.p_physics->is_vacuum = 0; // Makes this volume a vacuum
    this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
    this_box_volume.p_physics->my_a = 0; // Should not be used.
    sprintf(this_box_volume.p_physics->name,"Mask");
    this_box_volume.geometry.is_mask_volume = 1;
    
    
// Read the material input, or if it lacks, use automatic linking.
} else if (material_string && strlen(material_string) && strcmp(material_string, "NULL") && strcmp(material_string, "0")) {
    // A geometry string was given, use it to determine which material
    if (0 == strcmp(material_string,"vacuum") || 0 == strcmp(material_string,"Vacuum")) {
        // One could have a global physics struct for vacuum instead of creating one for each
        this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
        this_box_volume.p_physics->is_vacuum = 1; // Makes this volume a vacuum
        this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
        this_box_volume.p_physics->my_a = 0; // Should not be used.
        sprintf(this_box_volume.p_physics->name,"Vacuum");
    } else if (0 == strcmp(material_string,"exit") || 0 == strcmp(material_string,"Exit")) {
        // One could have a global physics struct for vacuum instead of creating one for each
        this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
        this_box_volume.p_physics->is_vacuum = 1; // Makes this volume a vacuum
        this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
        this_box_volume.p_physics->my_a = 0; // Should not be used.
        this_box_volume.geometry.is_exit_volume = 1;
        sprintf(this_box_volume.p_physics->name,"Exit");
    } else {
        #ifndef MATERIAL_DETECTOR
            printf("Need to define a material before refering to it in a geometry %s.\n",NAME_CURRENT_COMP);
            exit(1);
        #endif
        for (loop_index=0;loop_index<global_material_list.num_elements;loop_index++) {
            if (0 == strcmp(material_string,global_material_list.elements[loop_index].name)) {
                this_box_volume.p_physics = global_material_list.elements[loop_index].physics;
                break;
            }
            if (loop_index == global_material_list.num_elements-1) {
            printf("\n");
            printf("ERROR: The material string \"%s\" in Union geometry \"%s\" did not match a specified material. \n",material_string,NAME_CURRENT_COMP);
            printf("       The materials available at this point (need to be defined before the geometry): \n");
            for (loop_index=0;loop_index<global_material_list.num_elements;loop_index++)
              printf("         %s\n",global_material_list.elements[loop_index].name);
            printf("\n");
            printf("       It is also possible to use one of the defualt materials avaiable: \n");
            printf("           Vacuum (for a Volume without scattering or absorption)\n");
            printf("           Exit (for a Volume where the ray exits the component if it enters)\n");
            printf("           Mask (for a Volume that masks existing volumes specified in the mask_string\n");
            exit(1);
          }
        }
    }
} else {
    // Automatic linking, simply using the last defined material.
    #ifndef MATERIAL_DETECTOR
        printf("Need to define a material before the geometry to use automatic linking %s.\n",NAME_CURRENT_COMP);
        exit(1);
    #endif
    this_box_volume.p_physics = global_material_list.elements[global_material_list.num_elements-1].physics;
}

sprintf(this_box_volume.name,NAME_CURRENT_COMP);
sprintf(this_box_volume.geometry.shape,"box");
this_box_volume.geometry.priority_value = priority;
this_box_volume.geometry.geometry_p_interact = p_interact;
// Currently the coordinates will be in absolute space.
this_box_volume.geometry.center = POS_A_CURRENT_COMP;

this_box_storage.z_depth = zdepth;
this_box_storage.x_width1 = xwidth;
this_box_storage.y_height1 = yheight;

this_box_storage.is_rectangle = 0;
if (xwidth2 < 0 && yheight2 < 0) this_box_storage.is_rectangle = 1;
if (xwidth == xwidth2 && yheight == yheight2) this_box_storage.is_rectangle = 1;

if (xwidth2 < 0) {
    this_box_storage.x_width2 = xwidth;
    xwidth2 = xwidth;
} else this_box_storage.x_width2 = xwidth2;

if (yheight2 < 0) {
    this_box_storage.y_height2 = yheight;
    yheight2 = yheight;
} else this_box_storage.y_height2 = yheight2;


this_box_storage.normal_vectors[0] = coords_set(0,0,1);
this_box_storage.normal_vectors[1] = coords_set(0,0,1);

// for sides with y component = 0
x_component = 2*zdepth/sqrt((xwidth-xwidth2)*(xwidth-xwidth2)+4*zdepth*zdepth);
z_component = (xwidth-xwidth2)/sqrt(4*zdepth*zdepth+(xwidth-xwidth2)*(xwidth-xwidth2));

this_box_storage.normal_vectors[2] = coords_set(x_component,0,z_component);
this_box_storage.normal_vectors[3] = coords_set(-x_component,0,z_component);

// for sides with x component = 0
y_component = 2*zdepth/sqrt((yheight-yheight2)*(yheight-yheight2)+4*zdepth*zdepth);
z_component = (yheight-yheight2)/sqrt(4*zdepth*zdepth+(yheight-yheight2)*(yheight-yheight2));

this_box_storage.normal_vectors[4] = coords_set(0,y_component,z_component);
this_box_storage.normal_vectors[5] = coords_set(0,-y_component,z_component);

this_box_volume.geometry.visualization_on = visualize;

this_box_volume.geometry.geometry_parameters.p_box_storage = &this_box_storage;

// Assign pointers to functions for intersection with the shape, checking if a point is inside the shape
if (this_box_storage.is_rectangle == 1) {
this_box_volume.geometry.intersect_function = &sample_box_intersect_simple;
this_box_volume.geometry.within_function = &r_within_box_simple;
}
else {
this_box_volume.geometry.intersect_function = &sample_box_intersect_advanced;
this_box_volume.geometry.within_function = &r_within_box_advanced;
}

this_box_volume.geometry.shell_points = &box_shell_points;
this_box_volume.geometry.mcdisplay_function = &mcdisplay_box_function;
this_box_volume.geometry.initialize_from_main_function = &initialize_box_geometry_from_main_component;
this_box_volume.geometry.process_rot_allocated = 0;

this_box_volume.geometry.copy_geometry_parameters = &allocate_box_storage_copy;

rot_copy(this_box_volume.geometry.rotation_matrix,ROT_A_CURRENT_COMP); //check how ROT_R_CURRENT_COMP would work
rot_transpose(ROT_A_CURRENT_COMP,this_box_volume.geometry.transpose_rotation_matrix);

// Initialize loggers
this_box_volume.loggers.num_elements = 0;

// packing the information into the global_geometry_element, which is then included in the global_geometry_list.
sprintf(global_geometry_element.name,NAME_CURRENT_COMP);
global_geometry_element.activation_counter = number_of_activations;
global_geometry_element.component_index = INDEX_CURRENT_COMP;
global_geometry_element.Volume = &this_box_volume; // Would be nicer if this m was a pointer, now we have the (small) data two places
add_element_to_geometry_list(&global_geometry_list,global_geometry_element);
}
#line 336428 "MACS_sample_kidney_box.c"
#undef number_of_activations
#undef mask_setting
#undef mask_string
#undef p_interact
#undef focus_r
#undef focus_xh
#undef focus_xw
#undef focus_ah
#undef focus_aw
#undef target_z
#undef target_y
#undef target_x
#undef target_index
#undef visualize
#undef yheight2
#undef xwidth2
#undef zdepth
#undef yheight
#undef xwidth
#undef priority
#undef material_string
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

  /* Initializations for component channel_19_analyzer_2_array_crystal_array_4. */
  SIG_MESSAGE("channel_19_analyzer_2_array_crystal_array_4 (Init)");
#define mccompcurname  channel_19_analyzer_2_array_crystal_array_4
#define mccompcurtype  Union_box
#define mccompcurindex 867
#define loop_index mccchannel_19_analyzer_2_array_crystal_array_4_loop_index
#define this_box_volume mccchannel_19_analyzer_2_array_crystal_array_4_this_box_volume
#define global_geometry_element mccchannel_19_analyzer_2_array_crystal_array_4_global_geometry_element
#define this_box_storage mccchannel_19_analyzer_2_array_crystal_array_4_this_box_storage
#define material_string mccchannel_19_analyzer_2_array_crystal_array_4_material_string
#define priority mccchannel_19_analyzer_2_array_crystal_array_4_priority
#define xwidth mccchannel_19_analyzer_2_array_crystal_array_4_xwidth
#define yheight mccchannel_19_analyzer_2_array_crystal_array_4_yheight
#define zdepth mccchannel_19_analyzer_2_array_crystal_array_4_zdepth
#define xwidth2 mccchannel_19_analyzer_2_array_crystal_array_4_xwidth2
#define yheight2 mccchannel_19_analyzer_2_array_crystal_array_4_yheight2
#define visualize mccchannel_19_analyzer_2_array_crystal_array_4_visualize
#define target_index mccchannel_19_analyzer_2_array_crystal_array_4_target_index
#define target_x mccchannel_19_analyzer_2_array_crystal_array_4_target_x
#define target_y mccchannel_19_analyzer_2_array_crystal_array_4_target_y
#define target_z mccchannel_19_analyzer_2_array_crystal_array_4_target_z
#define focus_aw mccchannel_19_analyzer_2_array_crystal_array_4_focus_aw
#define focus_ah mccchannel_19_analyzer_2_array_crystal_array_4_focus_ah
#define focus_xw mccchannel_19_analyzer_2_array_crystal_array_4_focus_xw
#define focus_xh mccchannel_19_analyzer_2_array_crystal_array_4_focus_xh
#define focus_r mccchannel_19_analyzer_2_array_crystal_array_4_focus_r
#define p_interact mccchannel_19_analyzer_2_array_crystal_array_4_p_interact
#define mask_string mccchannel_19_analyzer_2_array_crystal_array_4_mask_string
#define mask_setting mccchannel_19_analyzer_2_array_crystal_array_4_mask_setting
#define number_of_activations mccchannel_19_analyzer_2_array_crystal_array_4_number_of_activations
#line 224 "Union_box.comp"
{
// Initializes the focusing system for this volume including input sanitation.
focus_initialize(&this_box_volume.geometry, POS_A_COMP_INDEX(INDEX_CURRENT_COMP+target_index), POS_A_CURRENT_COMP, ROT_A_CURRENT_COMP, target_index, target_x, target_y, target_z, focus_aw, focus_ah, focus_xw, focus_xh, focus_r, NAME_CURRENT_COMP);

// Input sanitation for this geometry
if (xwidth <= 0) {
  printf("\nERROR in Union_box named %s, the xwidth is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (yheight <= 0) {
  printf("\nERROR in Union_box named %s, yheight is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (zdepth <= 0) {
  printf("\nERROR in Union_box named %s, zdepth is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (xwidth2 <= 0 && xwidth2 != -1) {
  printf("\nERROR in Union_box named %s, the xwidth2 is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (yheight2 <= 0 && yheight2 != -1) {
  printf("\nERROR in Union_box named %s, yheight2 is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}

// Use sanitation
if (global_material_list.num_elements == 0) {
  printf("\nERROR: Need to define a material using Union_make_material before using a Union geometry component. \n");
  printf("       %s was defined before first use of Union_make_material.\n",NAME_CURRENT_COMP);
  exit(1);
}

this_box_volume.geometry.is_masked_volume = 0;
this_box_volume.geometry.is_exit_volume = 0;
this_box_volume.geometry.is_mask_volume = 0;
// check if the volume is a mask, if it is the material string is irelevant.
if (mask_string && strlen(mask_string) && strcmp(mask_string, "NULL") && strcmp(mask_string, "0")) {
    // A mask volume is used to limit the extend of other volumes, called the masked volumes. These are specified in the mask_string.
    // In order for a ray to enter a masked volume, it needs to be both in the region covered by that volume AND the mask volume.
    // When more than
    this_box_volume.geometry.mask_mode = 1; // Default is mask mode is ALL
    if (mask_setting && strlen(mask_setting) && strcmp(mask_setting, "NULL") && strcmp(mask_setting, "0")) {
        if (strcmp(mask_setting,"ALL") == 0 || strcmp(mask_setting,"All") == 0) this_box_volume.geometry.mask_mode = 1;
        else if (strcmp(mask_setting,"ANY") == 0 || strcmp(mask_setting,"Any") == 0) this_box_volume.geometry.mask_mode = 2;
        else {
            printf("The mask_mode of component %s is set to %s, but must be either ALL or ANY.\n",NAME_CURRENT_COMP,mask_setting);
            exit(1);
        }
    }
    
    for (loop_index=0;loop_index<global_geometry_list.num_elements;loop_index++) {
        // Add mask list
        if (1 == manual_linking_function(global_geometry_list.elements[loop_index].name,mask_string)) {
            add_element_to_int_list(&this_box_volume.geometry.mask_list,global_geometry_list.elements[loop_index].component_index);
            add_element_to_int_list(&global_geometry_list.elements[loop_index].Volume->geometry.masked_by_list,INDEX_CURRENT_COMP);
            global_geometry_list.elements[loop_index].Volume->geometry.is_masked_volume = 1;
            if (this_box_volume.geometry.mask_mode == 2)
                global_geometry_list.elements[loop_index].Volume->geometry.mask_mode = 2;
            if (this_box_volume.geometry.mask_mode == 1) {
                if (global_geometry_list.elements[loop_index].Volume->geometry.is_masked_volume == 1 && global_geometry_list.elements[loop_index].Volume->geometry.mask_mode != 2)
                    // If more than one mask is added to one volume, the ANY mode overwrites the (default) ALL mode.
                    global_geometry_list.elements[loop_index].Volume->geometry.mask_mode = 1;
            }
            
            found_geometries = 1;
        }
    }
    if (found_geometries == 0) {
        printf("The mask_string in geometry: %s did not find any of the specified volumes in the mask_string %s \n",NAME_CURRENT_COMP,mask_string);
        exit(1);
    }
    this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
    this_box_volume.p_physics->is_vacuum = 0; // Makes this volume a vacuum
    this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
    this_box_volume.p_physics->my_a = 0; // Should not be used.
    sprintf(this_box_volume.p_physics->name,"Mask");
    this_box_volume.geometry.is_mask_volume = 1;
    
    
// Read the material input, or if it lacks, use automatic linking.
} else if (material_string && strlen(material_string) && strcmp(material_string, "NULL") && strcmp(material_string, "0")) {
    // A geometry string was given, use it to determine which material
    if (0 == strcmp(material_string,"vacuum") || 0 == strcmp(material_string,"Vacuum")) {
        // One could have a global physics struct for vacuum instead of creating one for each
        this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
        this_box_volume.p_physics->is_vacuum = 1; // Makes this volume a vacuum
        this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
        this_box_volume.p_physics->my_a = 0; // Should not be used.
        sprintf(this_box_volume.p_physics->name,"Vacuum");
    } else if (0 == strcmp(material_string,"exit") || 0 == strcmp(material_string,"Exit")) {
        // One could have a global physics struct for vacuum instead of creating one for each
        this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
        this_box_volume.p_physics->is_vacuum = 1; // Makes this volume a vacuum
        this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
        this_box_volume.p_physics->my_a = 0; // Should not be used.
        this_box_volume.geometry.is_exit_volume = 1;
        sprintf(this_box_volume.p_physics->name,"Exit");
    } else {
        #ifndef MATERIAL_DETECTOR
            printf("Need to define a material before refering to it in a geometry %s.\n",NAME_CURRENT_COMP);
            exit(1);
        #endif
        for (loop_index=0;loop_index<global_material_list.num_elements;loop_index++) {
            if (0 == strcmp(material_string,global_material_list.elements[loop_index].name)) {
                this_box_volume.p_physics = global_material_list.elements[loop_index].physics;
                break;
            }
            if (loop_index == global_material_list.num_elements-1) {
            printf("\n");
            printf("ERROR: The material string \"%s\" in Union geometry \"%s\" did not match a specified material. \n",material_string,NAME_CURRENT_COMP);
            printf("       The materials available at this point (need to be defined before the geometry): \n");
            for (loop_index=0;loop_index<global_material_list.num_elements;loop_index++)
              printf("         %s\n",global_material_list.elements[loop_index].name);
            printf("\n");
            printf("       It is also possible to use one of the defualt materials avaiable: \n");
            printf("           Vacuum (for a Volume without scattering or absorption)\n");
            printf("           Exit (for a Volume where the ray exits the component if it enters)\n");
            printf("           Mask (for a Volume that masks existing volumes specified in the mask_string\n");
            exit(1);
          }
        }
    }
} else {
    // Automatic linking, simply using the last defined material.
    #ifndef MATERIAL_DETECTOR
        printf("Need to define a material before the geometry to use automatic linking %s.\n",NAME_CURRENT_COMP);
        exit(1);
    #endif
    this_box_volume.p_physics = global_material_list.elements[global_material_list.num_elements-1].physics;
}

sprintf(this_box_volume.name,NAME_CURRENT_COMP);
sprintf(this_box_volume.geometry.shape,"box");
this_box_volume.geometry.priority_value = priority;
this_box_volume.geometry.geometry_p_interact = p_interact;
// Currently the coordinates will be in absolute space.
this_box_volume.geometry.center = POS_A_CURRENT_COMP;

this_box_storage.z_depth = zdepth;
this_box_storage.x_width1 = xwidth;
this_box_storage.y_height1 = yheight;

this_box_storage.is_rectangle = 0;
if (xwidth2 < 0 && yheight2 < 0) this_box_storage.is_rectangle = 1;
if (xwidth == xwidth2 && yheight == yheight2) this_box_storage.is_rectangle = 1;

if (xwidth2 < 0) {
    this_box_storage.x_width2 = xwidth;
    xwidth2 = xwidth;
} else this_box_storage.x_width2 = xwidth2;

if (yheight2 < 0) {
    this_box_storage.y_height2 = yheight;
    yheight2 = yheight;
} else this_box_storage.y_height2 = yheight2;


this_box_storage.normal_vectors[0] = coords_set(0,0,1);
this_box_storage.normal_vectors[1] = coords_set(0,0,1);

// for sides with y component = 0
x_component = 2*zdepth/sqrt((xwidth-xwidth2)*(xwidth-xwidth2)+4*zdepth*zdepth);
z_component = (xwidth-xwidth2)/sqrt(4*zdepth*zdepth+(xwidth-xwidth2)*(xwidth-xwidth2));

this_box_storage.normal_vectors[2] = coords_set(x_component,0,z_component);
this_box_storage.normal_vectors[3] = coords_set(-x_component,0,z_component);

// for sides with x component = 0
y_component = 2*zdepth/sqrt((yheight-yheight2)*(yheight-yheight2)+4*zdepth*zdepth);
z_component = (yheight-yheight2)/sqrt(4*zdepth*zdepth+(yheight-yheight2)*(yheight-yheight2));

this_box_storage.normal_vectors[4] = coords_set(0,y_component,z_component);
this_box_storage.normal_vectors[5] = coords_set(0,-y_component,z_component);

this_box_volume.geometry.visualization_on = visualize;

this_box_volume.geometry.geometry_parameters.p_box_storage = &this_box_storage;

// Assign pointers to functions for intersection with the shape, checking if a point is inside the shape
if (this_box_storage.is_rectangle == 1) {
this_box_volume.geometry.intersect_function = &sample_box_intersect_simple;
this_box_volume.geometry.within_function = &r_within_box_simple;
}
else {
this_box_volume.geometry.intersect_function = &sample_box_intersect_advanced;
this_box_volume.geometry.within_function = &r_within_box_advanced;
}

this_box_volume.geometry.shell_points = &box_shell_points;
this_box_volume.geometry.mcdisplay_function = &mcdisplay_box_function;
this_box_volume.geometry.initialize_from_main_function = &initialize_box_geometry_from_main_component;
this_box_volume.geometry.process_rot_allocated = 0;

this_box_volume.geometry.copy_geometry_parameters = &allocate_box_storage_copy;

rot_copy(this_box_volume.geometry.rotation_matrix,ROT_A_CURRENT_COMP); //check how ROT_R_CURRENT_COMP would work
rot_transpose(ROT_A_CURRENT_COMP,this_box_volume.geometry.transpose_rotation_matrix);

// Initialize loggers
this_box_volume.loggers.num_elements = 0;

// packing the information into the global_geometry_element, which is then included in the global_geometry_list.
sprintf(global_geometry_element.name,NAME_CURRENT_COMP);
global_geometry_element.activation_counter = number_of_activations;
global_geometry_element.component_index = INDEX_CURRENT_COMP;
global_geometry_element.Volume = &this_box_volume; // Would be nicer if this m was a pointer, now we have the (small) data two places
add_element_to_geometry_list(&global_geometry_list,global_geometry_element);
}
#line 336698 "MACS_sample_kidney_box.c"
#undef number_of_activations
#undef mask_setting
#undef mask_string
#undef p_interact
#undef focus_r
#undef focus_xh
#undef focus_xw
#undef focus_ah
#undef focus_aw
#undef target_z
#undef target_y
#undef target_x
#undef target_index
#undef visualize
#undef yheight2
#undef xwidth2
#undef zdepth
#undef yheight
#undef xwidth
#undef priority
#undef material_string
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

  /* Initializations for component channel_19_analyzer_2_array_crystal_array_5. */
  SIG_MESSAGE("channel_19_analyzer_2_array_crystal_array_5 (Init)");
#define mccompcurname  channel_19_analyzer_2_array_crystal_array_5
#define mccompcurtype  Union_box
#define mccompcurindex 868
#define loop_index mccchannel_19_analyzer_2_array_crystal_array_5_loop_index
#define this_box_volume mccchannel_19_analyzer_2_array_crystal_array_5_this_box_volume
#define global_geometry_element mccchannel_19_analyzer_2_array_crystal_array_5_global_geometry_element
#define this_box_storage mccchannel_19_analyzer_2_array_crystal_array_5_this_box_storage
#define material_string mccchannel_19_analyzer_2_array_crystal_array_5_material_string
#define priority mccchannel_19_analyzer_2_array_crystal_array_5_priority
#define xwidth mccchannel_19_analyzer_2_array_crystal_array_5_xwidth
#define yheight mccchannel_19_analyzer_2_array_crystal_array_5_yheight
#define zdepth mccchannel_19_analyzer_2_array_crystal_array_5_zdepth
#define xwidth2 mccchannel_19_analyzer_2_array_crystal_array_5_xwidth2
#define yheight2 mccchannel_19_analyzer_2_array_crystal_array_5_yheight2
#define visualize mccchannel_19_analyzer_2_array_crystal_array_5_visualize
#define target_index mccchannel_19_analyzer_2_array_crystal_array_5_target_index
#define target_x mccchannel_19_analyzer_2_array_crystal_array_5_target_x
#define target_y mccchannel_19_analyzer_2_array_crystal_array_5_target_y
#define target_z mccchannel_19_analyzer_2_array_crystal_array_5_target_z
#define focus_aw mccchannel_19_analyzer_2_array_crystal_array_5_focus_aw
#define focus_ah mccchannel_19_analyzer_2_array_crystal_array_5_focus_ah
#define focus_xw mccchannel_19_analyzer_2_array_crystal_array_5_focus_xw
#define focus_xh mccchannel_19_analyzer_2_array_crystal_array_5_focus_xh
#define focus_r mccchannel_19_analyzer_2_array_crystal_array_5_focus_r
#define p_interact mccchannel_19_analyzer_2_array_crystal_array_5_p_interact
#define mask_string mccchannel_19_analyzer_2_array_crystal_array_5_mask_string
#define mask_setting mccchannel_19_analyzer_2_array_crystal_array_5_mask_setting
#define number_of_activations mccchannel_19_analyzer_2_array_crystal_array_5_number_of_activations
#line 224 "Union_box.comp"
{
// Initializes the focusing system for this volume including input sanitation.
focus_initialize(&this_box_volume.geometry, POS_A_COMP_INDEX(INDEX_CURRENT_COMP+target_index), POS_A_CURRENT_COMP, ROT_A_CURRENT_COMP, target_index, target_x, target_y, target_z, focus_aw, focus_ah, focus_xw, focus_xh, focus_r, NAME_CURRENT_COMP);

// Input sanitation for this geometry
if (xwidth <= 0) {
  printf("\nERROR in Union_box named %s, the xwidth is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (yheight <= 0) {
  printf("\nERROR in Union_box named %s, yheight is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (zdepth <= 0) {
  printf("\nERROR in Union_box named %s, zdepth is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (xwidth2 <= 0 && xwidth2 != -1) {
  printf("\nERROR in Union_box named %s, the xwidth2 is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (yheight2 <= 0 && yheight2 != -1) {
  printf("\nERROR in Union_box named %s, yheight2 is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}

// Use sanitation
if (global_material_list.num_elements == 0) {
  printf("\nERROR: Need to define a material using Union_make_material before using a Union geometry component. \n");
  printf("       %s was defined before first use of Union_make_material.\n",NAME_CURRENT_COMP);
  exit(1);
}

this_box_volume.geometry.is_masked_volume = 0;
this_box_volume.geometry.is_exit_volume = 0;
this_box_volume.geometry.is_mask_volume = 0;
// check if the volume is a mask, if it is the material string is irelevant.
if (mask_string && strlen(mask_string) && strcmp(mask_string, "NULL") && strcmp(mask_string, "0")) {
    // A mask volume is used to limit the extend of other volumes, called the masked volumes. These are specified in the mask_string.
    // In order for a ray to enter a masked volume, it needs to be both in the region covered by that volume AND the mask volume.
    // When more than
    this_box_volume.geometry.mask_mode = 1; // Default is mask mode is ALL
    if (mask_setting && strlen(mask_setting) && strcmp(mask_setting, "NULL") && strcmp(mask_setting, "0")) {
        if (strcmp(mask_setting,"ALL") == 0 || strcmp(mask_setting,"All") == 0) this_box_volume.geometry.mask_mode = 1;
        else if (strcmp(mask_setting,"ANY") == 0 || strcmp(mask_setting,"Any") == 0) this_box_volume.geometry.mask_mode = 2;
        else {
            printf("The mask_mode of component %s is set to %s, but must be either ALL or ANY.\n",NAME_CURRENT_COMP,mask_setting);
            exit(1);
        }
    }
    
    for (loop_index=0;loop_index<global_geometry_list.num_elements;loop_index++) {
        // Add mask list
        if (1 == manual_linking_function(global_geometry_list.elements[loop_index].name,mask_string)) {
            add_element_to_int_list(&this_box_volume.geometry.mask_list,global_geometry_list.elements[loop_index].component_index);
            add_element_to_int_list(&global_geometry_list.elements[loop_index].Volume->geometry.masked_by_list,INDEX_CURRENT_COMP);
            global_geometry_list.elements[loop_index].Volume->geometry.is_masked_volume = 1;
            if (this_box_volume.geometry.mask_mode == 2)
                global_geometry_list.elements[loop_index].Volume->geometry.mask_mode = 2;
            if (this_box_volume.geometry.mask_mode == 1) {
                if (global_geometry_list.elements[loop_index].Volume->geometry.is_masked_volume == 1 && global_geometry_list.elements[loop_index].Volume->geometry.mask_mode != 2)
                    // If more than one mask is added to one volume, the ANY mode overwrites the (default) ALL mode.
                    global_geometry_list.elements[loop_index].Volume->geometry.mask_mode = 1;
            }
            
            found_geometries = 1;
        }
    }
    if (found_geometries == 0) {
        printf("The mask_string in geometry: %s did not find any of the specified volumes in the mask_string %s \n",NAME_CURRENT_COMP,mask_string);
        exit(1);
    }
    this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
    this_box_volume.p_physics->is_vacuum = 0; // Makes this volume a vacuum
    this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
    this_box_volume.p_physics->my_a = 0; // Should not be used.
    sprintf(this_box_volume.p_physics->name,"Mask");
    this_box_volume.geometry.is_mask_volume = 1;
    
    
// Read the material input, or if it lacks, use automatic linking.
} else if (material_string && strlen(material_string) && strcmp(material_string, "NULL") && strcmp(material_string, "0")) {
    // A geometry string was given, use it to determine which material
    if (0 == strcmp(material_string,"vacuum") || 0 == strcmp(material_string,"Vacuum")) {
        // One could have a global physics struct for vacuum instead of creating one for each
        this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
        this_box_volume.p_physics->is_vacuum = 1; // Makes this volume a vacuum
        this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
        this_box_volume.p_physics->my_a = 0; // Should not be used.
        sprintf(this_box_volume.p_physics->name,"Vacuum");
    } else if (0 == strcmp(material_string,"exit") || 0 == strcmp(material_string,"Exit")) {
        // One could have a global physics struct for vacuum instead of creating one for each
        this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
        this_box_volume.p_physics->is_vacuum = 1; // Makes this volume a vacuum
        this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
        this_box_volume.p_physics->my_a = 0; // Should not be used.
        this_box_volume.geometry.is_exit_volume = 1;
        sprintf(this_box_volume.p_physics->name,"Exit");
    } else {
        #ifndef MATERIAL_DETECTOR
            printf("Need to define a material before refering to it in a geometry %s.\n",NAME_CURRENT_COMP);
            exit(1);
        #endif
        for (loop_index=0;loop_index<global_material_list.num_elements;loop_index++) {
            if (0 == strcmp(material_string,global_material_list.elements[loop_index].name)) {
                this_box_volume.p_physics = global_material_list.elements[loop_index].physics;
                break;
            }
            if (loop_index == global_material_list.num_elements-1) {
            printf("\n");
            printf("ERROR: The material string \"%s\" in Union geometry \"%s\" did not match a specified material. \n",material_string,NAME_CURRENT_COMP);
            printf("       The materials available at this point (need to be defined before the geometry): \n");
            for (loop_index=0;loop_index<global_material_list.num_elements;loop_index++)
              printf("         %s\n",global_material_list.elements[loop_index].name);
            printf("\n");
            printf("       It is also possible to use one of the defualt materials avaiable: \n");
            printf("           Vacuum (for a Volume without scattering or absorption)\n");
            printf("           Exit (for a Volume where the ray exits the component if it enters)\n");
            printf("           Mask (for a Volume that masks existing volumes specified in the mask_string\n");
            exit(1);
          }
        }
    }
} else {
    // Automatic linking, simply using the last defined material.
    #ifndef MATERIAL_DETECTOR
        printf("Need to define a material before the geometry to use automatic linking %s.\n",NAME_CURRENT_COMP);
        exit(1);
    #endif
    this_box_volume.p_physics = global_material_list.elements[global_material_list.num_elements-1].physics;
}

sprintf(this_box_volume.name,NAME_CURRENT_COMP);
sprintf(this_box_volume.geometry.shape,"box");
this_box_volume.geometry.priority_value = priority;
this_box_volume.geometry.geometry_p_interact = p_interact;
// Currently the coordinates will be in absolute space.
this_box_volume.geometry.center = POS_A_CURRENT_COMP;

this_box_storage.z_depth = zdepth;
this_box_storage.x_width1 = xwidth;
this_box_storage.y_height1 = yheight;

this_box_storage.is_rectangle = 0;
if (xwidth2 < 0 && yheight2 < 0) this_box_storage.is_rectangle = 1;
if (xwidth == xwidth2 && yheight == yheight2) this_box_storage.is_rectangle = 1;

if (xwidth2 < 0) {
    this_box_storage.x_width2 = xwidth;
    xwidth2 = xwidth;
} else this_box_storage.x_width2 = xwidth2;

if (yheight2 < 0) {
    this_box_storage.y_height2 = yheight;
    yheight2 = yheight;
} else this_box_storage.y_height2 = yheight2;


this_box_storage.normal_vectors[0] = coords_set(0,0,1);
this_box_storage.normal_vectors[1] = coords_set(0,0,1);

// for sides with y component = 0
x_component = 2*zdepth/sqrt((xwidth-xwidth2)*(xwidth-xwidth2)+4*zdepth*zdepth);
z_component = (xwidth-xwidth2)/sqrt(4*zdepth*zdepth+(xwidth-xwidth2)*(xwidth-xwidth2));

this_box_storage.normal_vectors[2] = coords_set(x_component,0,z_component);
this_box_storage.normal_vectors[3] = coords_set(-x_component,0,z_component);

// for sides with x component = 0
y_component = 2*zdepth/sqrt((yheight-yheight2)*(yheight-yheight2)+4*zdepth*zdepth);
z_component = (yheight-yheight2)/sqrt(4*zdepth*zdepth+(yheight-yheight2)*(yheight-yheight2));

this_box_storage.normal_vectors[4] = coords_set(0,y_component,z_component);
this_box_storage.normal_vectors[5] = coords_set(0,-y_component,z_component);

this_box_volume.geometry.visualization_on = visualize;

this_box_volume.geometry.geometry_parameters.p_box_storage = &this_box_storage;

// Assign pointers to functions for intersection with the shape, checking if a point is inside the shape
if (this_box_storage.is_rectangle == 1) {
this_box_volume.geometry.intersect_function = &sample_box_intersect_simple;
this_box_volume.geometry.within_function = &r_within_box_simple;
}
else {
this_box_volume.geometry.intersect_function = &sample_box_intersect_advanced;
this_box_volume.geometry.within_function = &r_within_box_advanced;
}

this_box_volume.geometry.shell_points = &box_shell_points;
this_box_volume.geometry.mcdisplay_function = &mcdisplay_box_function;
this_box_volume.geometry.initialize_from_main_function = &initialize_box_geometry_from_main_component;
this_box_volume.geometry.process_rot_allocated = 0;

this_box_volume.geometry.copy_geometry_parameters = &allocate_box_storage_copy;

rot_copy(this_box_volume.geometry.rotation_matrix,ROT_A_CURRENT_COMP); //check how ROT_R_CURRENT_COMP would work
rot_transpose(ROT_A_CURRENT_COMP,this_box_volume.geometry.transpose_rotation_matrix);

// Initialize loggers
this_box_volume.loggers.num_elements = 0;

// packing the information into the global_geometry_element, which is then included in the global_geometry_list.
sprintf(global_geometry_element.name,NAME_CURRENT_COMP);
global_geometry_element.activation_counter = number_of_activations;
global_geometry_element.component_index = INDEX_CURRENT_COMP;
global_geometry_element.Volume = &this_box_volume; // Would be nicer if this m was a pointer, now we have the (small) data two places
add_element_to_geometry_list(&global_geometry_list,global_geometry_element);
}
#line 336968 "MACS_sample_kidney_box.c"
#undef number_of_activations
#undef mask_setting
#undef mask_string
#undef p_interact
#undef focus_r
#undef focus_xh
#undef focus_xw
#undef focus_ah
#undef focus_aw
#undef target_z
#undef target_y
#undef target_x
#undef target_index
#undef visualize
#undef yheight2
#undef xwidth2
#undef zdepth
#undef yheight
#undef xwidth
#undef priority
#undef material_string
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

  /* Initializations for component channel_19_analyzer_2_array_crystal_array_6. */
  SIG_MESSAGE("channel_19_analyzer_2_array_crystal_array_6 (Init)");
#define mccompcurname  channel_19_analyzer_2_array_crystal_array_6
#define mccompcurtype  Union_box
#define mccompcurindex 869
#define loop_index mccchannel_19_analyzer_2_array_crystal_array_6_loop_index
#define this_box_volume mccchannel_19_analyzer_2_array_crystal_array_6_this_box_volume
#define global_geometry_element mccchannel_19_analyzer_2_array_crystal_array_6_global_geometry_element
#define this_box_storage mccchannel_19_analyzer_2_array_crystal_array_6_this_box_storage
#define material_string mccchannel_19_analyzer_2_array_crystal_array_6_material_string
#define priority mccchannel_19_analyzer_2_array_crystal_array_6_priority
#define xwidth mccchannel_19_analyzer_2_array_crystal_array_6_xwidth
#define yheight mccchannel_19_analyzer_2_array_crystal_array_6_yheight
#define zdepth mccchannel_19_analyzer_2_array_crystal_array_6_zdepth
#define xwidth2 mccchannel_19_analyzer_2_array_crystal_array_6_xwidth2
#define yheight2 mccchannel_19_analyzer_2_array_crystal_array_6_yheight2
#define visualize mccchannel_19_analyzer_2_array_crystal_array_6_visualize
#define target_index mccchannel_19_analyzer_2_array_crystal_array_6_target_index
#define target_x mccchannel_19_analyzer_2_array_crystal_array_6_target_x
#define target_y mccchannel_19_analyzer_2_array_crystal_array_6_target_y
#define target_z mccchannel_19_analyzer_2_array_crystal_array_6_target_z
#define focus_aw mccchannel_19_analyzer_2_array_crystal_array_6_focus_aw
#define focus_ah mccchannel_19_analyzer_2_array_crystal_array_6_focus_ah
#define focus_xw mccchannel_19_analyzer_2_array_crystal_array_6_focus_xw
#define focus_xh mccchannel_19_analyzer_2_array_crystal_array_6_focus_xh
#define focus_r mccchannel_19_analyzer_2_array_crystal_array_6_focus_r
#define p_interact mccchannel_19_analyzer_2_array_crystal_array_6_p_interact
#define mask_string mccchannel_19_analyzer_2_array_crystal_array_6_mask_string
#define mask_setting mccchannel_19_analyzer_2_array_crystal_array_6_mask_setting
#define number_of_activations mccchannel_19_analyzer_2_array_crystal_array_6_number_of_activations
#line 224 "Union_box.comp"
{
// Initializes the focusing system for this volume including input sanitation.
focus_initialize(&this_box_volume.geometry, POS_A_COMP_INDEX(INDEX_CURRENT_COMP+target_index), POS_A_CURRENT_COMP, ROT_A_CURRENT_COMP, target_index, target_x, target_y, target_z, focus_aw, focus_ah, focus_xw, focus_xh, focus_r, NAME_CURRENT_COMP);

// Input sanitation for this geometry
if (xwidth <= 0) {
  printf("\nERROR in Union_box named %s, the xwidth is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (yheight <= 0) {
  printf("\nERROR in Union_box named %s, yheight is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (zdepth <= 0) {
  printf("\nERROR in Union_box named %s, zdepth is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (xwidth2 <= 0 && xwidth2 != -1) {
  printf("\nERROR in Union_box named %s, the xwidth2 is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (yheight2 <= 0 && yheight2 != -1) {
  printf("\nERROR in Union_box named %s, yheight2 is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}

// Use sanitation
if (global_material_list.num_elements == 0) {
  printf("\nERROR: Need to define a material using Union_make_material before using a Union geometry component. \n");
  printf("       %s was defined before first use of Union_make_material.\n",NAME_CURRENT_COMP);
  exit(1);
}

this_box_volume.geometry.is_masked_volume = 0;
this_box_volume.geometry.is_exit_volume = 0;
this_box_volume.geometry.is_mask_volume = 0;
// check if the volume is a mask, if it is the material string is irelevant.
if (mask_string && strlen(mask_string) && strcmp(mask_string, "NULL") && strcmp(mask_string, "0")) {
    // A mask volume is used to limit the extend of other volumes, called the masked volumes. These are specified in the mask_string.
    // In order for a ray to enter a masked volume, it needs to be both in the region covered by that volume AND the mask volume.
    // When more than
    this_box_volume.geometry.mask_mode = 1; // Default is mask mode is ALL
    if (mask_setting && strlen(mask_setting) && strcmp(mask_setting, "NULL") && strcmp(mask_setting, "0")) {
        if (strcmp(mask_setting,"ALL") == 0 || strcmp(mask_setting,"All") == 0) this_box_volume.geometry.mask_mode = 1;
        else if (strcmp(mask_setting,"ANY") == 0 || strcmp(mask_setting,"Any") == 0) this_box_volume.geometry.mask_mode = 2;
        else {
            printf("The mask_mode of component %s is set to %s, but must be either ALL or ANY.\n",NAME_CURRENT_COMP,mask_setting);
            exit(1);
        }
    }
    
    for (loop_index=0;loop_index<global_geometry_list.num_elements;loop_index++) {
        // Add mask list
        if (1 == manual_linking_function(global_geometry_list.elements[loop_index].name,mask_string)) {
            add_element_to_int_list(&this_box_volume.geometry.mask_list,global_geometry_list.elements[loop_index].component_index);
            add_element_to_int_list(&global_geometry_list.elements[loop_index].Volume->geometry.masked_by_list,INDEX_CURRENT_COMP);
            global_geometry_list.elements[loop_index].Volume->geometry.is_masked_volume = 1;
            if (this_box_volume.geometry.mask_mode == 2)
                global_geometry_list.elements[loop_index].Volume->geometry.mask_mode = 2;
            if (this_box_volume.geometry.mask_mode == 1) {
                if (global_geometry_list.elements[loop_index].Volume->geometry.is_masked_volume == 1 && global_geometry_list.elements[loop_index].Volume->geometry.mask_mode != 2)
                    // If more than one mask is added to one volume, the ANY mode overwrites the (default) ALL mode.
                    global_geometry_list.elements[loop_index].Volume->geometry.mask_mode = 1;
            }
            
            found_geometries = 1;
        }
    }
    if (found_geometries == 0) {
        printf("The mask_string in geometry: %s did not find any of the specified volumes in the mask_string %s \n",NAME_CURRENT_COMP,mask_string);
        exit(1);
    }
    this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
    this_box_volume.p_physics->is_vacuum = 0; // Makes this volume a vacuum
    this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
    this_box_volume.p_physics->my_a = 0; // Should not be used.
    sprintf(this_box_volume.p_physics->name,"Mask");
    this_box_volume.geometry.is_mask_volume = 1;
    
    
// Read the material input, or if it lacks, use automatic linking.
} else if (material_string && strlen(material_string) && strcmp(material_string, "NULL") && strcmp(material_string, "0")) {
    // A geometry string was given, use it to determine which material
    if (0 == strcmp(material_string,"vacuum") || 0 == strcmp(material_string,"Vacuum")) {
        // One could have a global physics struct for vacuum instead of creating one for each
        this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
        this_box_volume.p_physics->is_vacuum = 1; // Makes this volume a vacuum
        this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
        this_box_volume.p_physics->my_a = 0; // Should not be used.
        sprintf(this_box_volume.p_physics->name,"Vacuum");
    } else if (0 == strcmp(material_string,"exit") || 0 == strcmp(material_string,"Exit")) {
        // One could have a global physics struct for vacuum instead of creating one for each
        this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
        this_box_volume.p_physics->is_vacuum = 1; // Makes this volume a vacuum
        this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
        this_box_volume.p_physics->my_a = 0; // Should not be used.
        this_box_volume.geometry.is_exit_volume = 1;
        sprintf(this_box_volume.p_physics->name,"Exit");
    } else {
        #ifndef MATERIAL_DETECTOR
            printf("Need to define a material before refering to it in a geometry %s.\n",NAME_CURRENT_COMP);
            exit(1);
        #endif
        for (loop_index=0;loop_index<global_material_list.num_elements;loop_index++) {
            if (0 == strcmp(material_string,global_material_list.elements[loop_index].name)) {
                this_box_volume.p_physics = global_material_list.elements[loop_index].physics;
                break;
            }
            if (loop_index == global_material_list.num_elements-1) {
            printf("\n");
            printf("ERROR: The material string \"%s\" in Union geometry \"%s\" did not match a specified material. \n",material_string,NAME_CURRENT_COMP);
            printf("       The materials available at this point (need to be defined before the geometry): \n");
            for (loop_index=0;loop_index<global_material_list.num_elements;loop_index++)
              printf("         %s\n",global_material_list.elements[loop_index].name);
            printf("\n");
            printf("       It is also possible to use one of the defualt materials avaiable: \n");
            printf("           Vacuum (for a Volume without scattering or absorption)\n");
            printf("           Exit (for a Volume where the ray exits the component if it enters)\n");
            printf("           Mask (for a Volume that masks existing volumes specified in the mask_string\n");
            exit(1);
          }
        }
    }
} else {
    // Automatic linking, simply using the last defined material.
    #ifndef MATERIAL_DETECTOR
        printf("Need to define a material before the geometry to use automatic linking %s.\n",NAME_CURRENT_COMP);
        exit(1);
    #endif
    this_box_volume.p_physics = global_material_list.elements[global_material_list.num_elements-1].physics;
}

sprintf(this_box_volume.name,NAME_CURRENT_COMP);
sprintf(this_box_volume.geometry.shape,"box");
this_box_volume.geometry.priority_value = priority;
this_box_volume.geometry.geometry_p_interact = p_interact;
// Currently the coordinates will be in absolute space.
this_box_volume.geometry.center = POS_A_CURRENT_COMP;

this_box_storage.z_depth = zdepth;
this_box_storage.x_width1 = xwidth;
this_box_storage.y_height1 = yheight;

this_box_storage.is_rectangle = 0;
if (xwidth2 < 0 && yheight2 < 0) this_box_storage.is_rectangle = 1;
if (xwidth == xwidth2 && yheight == yheight2) this_box_storage.is_rectangle = 1;

if (xwidth2 < 0) {
    this_box_storage.x_width2 = xwidth;
    xwidth2 = xwidth;
} else this_box_storage.x_width2 = xwidth2;

if (yheight2 < 0) {
    this_box_storage.y_height2 = yheight;
    yheight2 = yheight;
} else this_box_storage.y_height2 = yheight2;


this_box_storage.normal_vectors[0] = coords_set(0,0,1);
this_box_storage.normal_vectors[1] = coords_set(0,0,1);

// for sides with y component = 0
x_component = 2*zdepth/sqrt((xwidth-xwidth2)*(xwidth-xwidth2)+4*zdepth*zdepth);
z_component = (xwidth-xwidth2)/sqrt(4*zdepth*zdepth+(xwidth-xwidth2)*(xwidth-xwidth2));

this_box_storage.normal_vectors[2] = coords_set(x_component,0,z_component);
this_box_storage.normal_vectors[3] = coords_set(-x_component,0,z_component);

// for sides with x component = 0
y_component = 2*zdepth/sqrt((yheight-yheight2)*(yheight-yheight2)+4*zdepth*zdepth);
z_component = (yheight-yheight2)/sqrt(4*zdepth*zdepth+(yheight-yheight2)*(yheight-yheight2));

this_box_storage.normal_vectors[4] = coords_set(0,y_component,z_component);
this_box_storage.normal_vectors[5] = coords_set(0,-y_component,z_component);

this_box_volume.geometry.visualization_on = visualize;

this_box_volume.geometry.geometry_parameters.p_box_storage = &this_box_storage;

// Assign pointers to functions for intersection with the shape, checking if a point is inside the shape
if (this_box_storage.is_rectangle == 1) {
this_box_volume.geometry.intersect_function = &sample_box_intersect_simple;
this_box_volume.geometry.within_function = &r_within_box_simple;
}
else {
this_box_volume.geometry.intersect_function = &sample_box_intersect_advanced;
this_box_volume.geometry.within_function = &r_within_box_advanced;
}

this_box_volume.geometry.shell_points = &box_shell_points;
this_box_volume.geometry.mcdisplay_function = &mcdisplay_box_function;
this_box_volume.geometry.initialize_from_main_function = &initialize_box_geometry_from_main_component;
this_box_volume.geometry.process_rot_allocated = 0;

this_box_volume.geometry.copy_geometry_parameters = &allocate_box_storage_copy;

rot_copy(this_box_volume.geometry.rotation_matrix,ROT_A_CURRENT_COMP); //check how ROT_R_CURRENT_COMP would work
rot_transpose(ROT_A_CURRENT_COMP,this_box_volume.geometry.transpose_rotation_matrix);

// Initialize loggers
this_box_volume.loggers.num_elements = 0;

// packing the information into the global_geometry_element, which is then included in the global_geometry_list.
sprintf(global_geometry_element.name,NAME_CURRENT_COMP);
global_geometry_element.activation_counter = number_of_activations;
global_geometry_element.component_index = INDEX_CURRENT_COMP;
global_geometry_element.Volume = &this_box_volume; // Would be nicer if this m was a pointer, now we have the (small) data two places
add_element_to_geometry_list(&global_geometry_list,global_geometry_element);
}
#line 337238 "MACS_sample_kidney_box.c"
#undef number_of_activations
#undef mask_setting
#undef mask_string
#undef p_interact
#undef focus_r
#undef focus_xh
#undef focus_xw
#undef focus_ah
#undef focus_aw
#undef target_z
#undef target_y
#undef target_x
#undef target_index
#undef visualize
#undef yheight2
#undef xwidth2
#undef zdepth
#undef yheight
#undef xwidth
#undef priority
#undef material_string
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

  /* Initializations for component channel_19_analyzer_2_array_crystal_array_7. */
  SIG_MESSAGE("channel_19_analyzer_2_array_crystal_array_7 (Init)");
#define mccompcurname  channel_19_analyzer_2_array_crystal_array_7
#define mccompcurtype  Union_box
#define mccompcurindex 870
#define loop_index mccchannel_19_analyzer_2_array_crystal_array_7_loop_index
#define this_box_volume mccchannel_19_analyzer_2_array_crystal_array_7_this_box_volume
#define global_geometry_element mccchannel_19_analyzer_2_array_crystal_array_7_global_geometry_element
#define this_box_storage mccchannel_19_analyzer_2_array_crystal_array_7_this_box_storage
#define material_string mccchannel_19_analyzer_2_array_crystal_array_7_material_string
#define priority mccchannel_19_analyzer_2_array_crystal_array_7_priority
#define xwidth mccchannel_19_analyzer_2_array_crystal_array_7_xwidth
#define yheight mccchannel_19_analyzer_2_array_crystal_array_7_yheight
#define zdepth mccchannel_19_analyzer_2_array_crystal_array_7_zdepth
#define xwidth2 mccchannel_19_analyzer_2_array_crystal_array_7_xwidth2
#define yheight2 mccchannel_19_analyzer_2_array_crystal_array_7_yheight2
#define visualize mccchannel_19_analyzer_2_array_crystal_array_7_visualize
#define target_index mccchannel_19_analyzer_2_array_crystal_array_7_target_index
#define target_x mccchannel_19_analyzer_2_array_crystal_array_7_target_x
#define target_y mccchannel_19_analyzer_2_array_crystal_array_7_target_y
#define target_z mccchannel_19_analyzer_2_array_crystal_array_7_target_z
#define focus_aw mccchannel_19_analyzer_2_array_crystal_array_7_focus_aw
#define focus_ah mccchannel_19_analyzer_2_array_crystal_array_7_focus_ah
#define focus_xw mccchannel_19_analyzer_2_array_crystal_array_7_focus_xw
#define focus_xh mccchannel_19_analyzer_2_array_crystal_array_7_focus_xh
#define focus_r mccchannel_19_analyzer_2_array_crystal_array_7_focus_r
#define p_interact mccchannel_19_analyzer_2_array_crystal_array_7_p_interact
#define mask_string mccchannel_19_analyzer_2_array_crystal_array_7_mask_string
#define mask_setting mccchannel_19_analyzer_2_array_crystal_array_7_mask_setting
#define number_of_activations mccchannel_19_analyzer_2_array_crystal_array_7_number_of_activations
#line 224 "Union_box.comp"
{
// Initializes the focusing system for this volume including input sanitation.
focus_initialize(&this_box_volume.geometry, POS_A_COMP_INDEX(INDEX_CURRENT_COMP+target_index), POS_A_CURRENT_COMP, ROT_A_CURRENT_COMP, target_index, target_x, target_y, target_z, focus_aw, focus_ah, focus_xw, focus_xh, focus_r, NAME_CURRENT_COMP);

// Input sanitation for this geometry
if (xwidth <= 0) {
  printf("\nERROR in Union_box named %s, the xwidth is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (yheight <= 0) {
  printf("\nERROR in Union_box named %s, yheight is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (zdepth <= 0) {
  printf("\nERROR in Union_box named %s, zdepth is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (xwidth2 <= 0 && xwidth2 != -1) {
  printf("\nERROR in Union_box named %s, the xwidth2 is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (yheight2 <= 0 && yheight2 != -1) {
  printf("\nERROR in Union_box named %s, yheight2 is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}

// Use sanitation
if (global_material_list.num_elements == 0) {
  printf("\nERROR: Need to define a material using Union_make_material before using a Union geometry component. \n");
  printf("       %s was defined before first use of Union_make_material.\n",NAME_CURRENT_COMP);
  exit(1);
}

this_box_volume.geometry.is_masked_volume = 0;
this_box_volume.geometry.is_exit_volume = 0;
this_box_volume.geometry.is_mask_volume = 0;
// check if the volume is a mask, if it is the material string is irelevant.
if (mask_string && strlen(mask_string) && strcmp(mask_string, "NULL") && strcmp(mask_string, "0")) {
    // A mask volume is used to limit the extend of other volumes, called the masked volumes. These are specified in the mask_string.
    // In order for a ray to enter a masked volume, it needs to be both in the region covered by that volume AND the mask volume.
    // When more than
    this_box_volume.geometry.mask_mode = 1; // Default is mask mode is ALL
    if (mask_setting && strlen(mask_setting) && strcmp(mask_setting, "NULL") && strcmp(mask_setting, "0")) {
        if (strcmp(mask_setting,"ALL") == 0 || strcmp(mask_setting,"All") == 0) this_box_volume.geometry.mask_mode = 1;
        else if (strcmp(mask_setting,"ANY") == 0 || strcmp(mask_setting,"Any") == 0) this_box_volume.geometry.mask_mode = 2;
        else {
            printf("The mask_mode of component %s is set to %s, but must be either ALL or ANY.\n",NAME_CURRENT_COMP,mask_setting);
            exit(1);
        }
    }
    
    for (loop_index=0;loop_index<global_geometry_list.num_elements;loop_index++) {
        // Add mask list
        if (1 == manual_linking_function(global_geometry_list.elements[loop_index].name,mask_string)) {
            add_element_to_int_list(&this_box_volume.geometry.mask_list,global_geometry_list.elements[loop_index].component_index);
            add_element_to_int_list(&global_geometry_list.elements[loop_index].Volume->geometry.masked_by_list,INDEX_CURRENT_COMP);
            global_geometry_list.elements[loop_index].Volume->geometry.is_masked_volume = 1;
            if (this_box_volume.geometry.mask_mode == 2)
                global_geometry_list.elements[loop_index].Volume->geometry.mask_mode = 2;
            if (this_box_volume.geometry.mask_mode == 1) {
                if (global_geometry_list.elements[loop_index].Volume->geometry.is_masked_volume == 1 && global_geometry_list.elements[loop_index].Volume->geometry.mask_mode != 2)
                    // If more than one mask is added to one volume, the ANY mode overwrites the (default) ALL mode.
                    global_geometry_list.elements[loop_index].Volume->geometry.mask_mode = 1;
            }
            
            found_geometries = 1;
        }
    }
    if (found_geometries == 0) {
        printf("The mask_string in geometry: %s did not find any of the specified volumes in the mask_string %s \n",NAME_CURRENT_COMP,mask_string);
        exit(1);
    }
    this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
    this_box_volume.p_physics->is_vacuum = 0; // Makes this volume a vacuum
    this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
    this_box_volume.p_physics->my_a = 0; // Should not be used.
    sprintf(this_box_volume.p_physics->name,"Mask");
    this_box_volume.geometry.is_mask_volume = 1;
    
    
// Read the material input, or if it lacks, use automatic linking.
} else if (material_string && strlen(material_string) && strcmp(material_string, "NULL") && strcmp(material_string, "0")) {
    // A geometry string was given, use it to determine which material
    if (0 == strcmp(material_string,"vacuum") || 0 == strcmp(material_string,"Vacuum")) {
        // One could have a global physics struct for vacuum instead of creating one for each
        this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
        this_box_volume.p_physics->is_vacuum = 1; // Makes this volume a vacuum
        this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
        this_box_volume.p_physics->my_a = 0; // Should not be used.
        sprintf(this_box_volume.p_physics->name,"Vacuum");
    } else if (0 == strcmp(material_string,"exit") || 0 == strcmp(material_string,"Exit")) {
        // One could have a global physics struct for vacuum instead of creating one for each
        this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
        this_box_volume.p_physics->is_vacuum = 1; // Makes this volume a vacuum
        this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
        this_box_volume.p_physics->my_a = 0; // Should not be used.
        this_box_volume.geometry.is_exit_volume = 1;
        sprintf(this_box_volume.p_physics->name,"Exit");
    } else {
        #ifndef MATERIAL_DETECTOR
            printf("Need to define a material before refering to it in a geometry %s.\n",NAME_CURRENT_COMP);
            exit(1);
        #endif
        for (loop_index=0;loop_index<global_material_list.num_elements;loop_index++) {
            if (0 == strcmp(material_string,global_material_list.elements[loop_index].name)) {
                this_box_volume.p_physics = global_material_list.elements[loop_index].physics;
                break;
            }
            if (loop_index == global_material_list.num_elements-1) {
            printf("\n");
            printf("ERROR: The material string \"%s\" in Union geometry \"%s\" did not match a specified material. \n",material_string,NAME_CURRENT_COMP);
            printf("       The materials available at this point (need to be defined before the geometry): \n");
            for (loop_index=0;loop_index<global_material_list.num_elements;loop_index++)
              printf("         %s\n",global_material_list.elements[loop_index].name);
            printf("\n");
            printf("       It is also possible to use one of the defualt materials avaiable: \n");
            printf("           Vacuum (for a Volume without scattering or absorption)\n");
            printf("           Exit (for a Volume where the ray exits the component if it enters)\n");
            printf("           Mask (for a Volume that masks existing volumes specified in the mask_string\n");
            exit(1);
          }
        }
    }
} else {
    // Automatic linking, simply using the last defined material.
    #ifndef MATERIAL_DETECTOR
        printf("Need to define a material before the geometry to use automatic linking %s.\n",NAME_CURRENT_COMP);
        exit(1);
    #endif
    this_box_volume.p_physics = global_material_list.elements[global_material_list.num_elements-1].physics;
}

sprintf(this_box_volume.name,NAME_CURRENT_COMP);
sprintf(this_box_volume.geometry.shape,"box");
this_box_volume.geometry.priority_value = priority;
this_box_volume.geometry.geometry_p_interact = p_interact;
// Currently the coordinates will be in absolute space.
this_box_volume.geometry.center = POS_A_CURRENT_COMP;

this_box_storage.z_depth = zdepth;
this_box_storage.x_width1 = xwidth;
this_box_storage.y_height1 = yheight;

this_box_storage.is_rectangle = 0;
if (xwidth2 < 0 && yheight2 < 0) this_box_storage.is_rectangle = 1;
if (xwidth == xwidth2 && yheight == yheight2) this_box_storage.is_rectangle = 1;

if (xwidth2 < 0) {
    this_box_storage.x_width2 = xwidth;
    xwidth2 = xwidth;
} else this_box_storage.x_width2 = xwidth2;

if (yheight2 < 0) {
    this_box_storage.y_height2 = yheight;
    yheight2 = yheight;
} else this_box_storage.y_height2 = yheight2;


this_box_storage.normal_vectors[0] = coords_set(0,0,1);
this_box_storage.normal_vectors[1] = coords_set(0,0,1);

// for sides with y component = 0
x_component = 2*zdepth/sqrt((xwidth-xwidth2)*(xwidth-xwidth2)+4*zdepth*zdepth);
z_component = (xwidth-xwidth2)/sqrt(4*zdepth*zdepth+(xwidth-xwidth2)*(xwidth-xwidth2));

this_box_storage.normal_vectors[2] = coords_set(x_component,0,z_component);
this_box_storage.normal_vectors[3] = coords_set(-x_component,0,z_component);

// for sides with x component = 0
y_component = 2*zdepth/sqrt((yheight-yheight2)*(yheight-yheight2)+4*zdepth*zdepth);
z_component = (yheight-yheight2)/sqrt(4*zdepth*zdepth+(yheight-yheight2)*(yheight-yheight2));

this_box_storage.normal_vectors[4] = coords_set(0,y_component,z_component);
this_box_storage.normal_vectors[5] = coords_set(0,-y_component,z_component);

this_box_volume.geometry.visualization_on = visualize;

this_box_volume.geometry.geometry_parameters.p_box_storage = &this_box_storage;

// Assign pointers to functions for intersection with the shape, checking if a point is inside the shape
if (this_box_storage.is_rectangle == 1) {
this_box_volume.geometry.intersect_function = &sample_box_intersect_simple;
this_box_volume.geometry.within_function = &r_within_box_simple;
}
else {
this_box_volume.geometry.intersect_function = &sample_box_intersect_advanced;
this_box_volume.geometry.within_function = &r_within_box_advanced;
}

this_box_volume.geometry.shell_points = &box_shell_points;
this_box_volume.geometry.mcdisplay_function = &mcdisplay_box_function;
this_box_volume.geometry.initialize_from_main_function = &initialize_box_geometry_from_main_component;
this_box_volume.geometry.process_rot_allocated = 0;

this_box_volume.geometry.copy_geometry_parameters = &allocate_box_storage_copy;

rot_copy(this_box_volume.geometry.rotation_matrix,ROT_A_CURRENT_COMP); //check how ROT_R_CURRENT_COMP would work
rot_transpose(ROT_A_CURRENT_COMP,this_box_volume.geometry.transpose_rotation_matrix);

// Initialize loggers
this_box_volume.loggers.num_elements = 0;

// packing the information into the global_geometry_element, which is then included in the global_geometry_list.
sprintf(global_geometry_element.name,NAME_CURRENT_COMP);
global_geometry_element.activation_counter = number_of_activations;
global_geometry_element.component_index = INDEX_CURRENT_COMP;
global_geometry_element.Volume = &this_box_volume; // Would be nicer if this m was a pointer, now we have the (small) data two places
add_element_to_geometry_list(&global_geometry_list,global_geometry_element);
}
#line 337508 "MACS_sample_kidney_box.c"
#undef number_of_activations
#undef mask_setting
#undef mask_string
#undef p_interact
#undef focus_r
#undef focus_xh
#undef focus_xw
#undef focus_ah
#undef focus_aw
#undef target_z
#undef target_y
#undef target_x
#undef target_index
#undef visualize
#undef yheight2
#undef xwidth2
#undef zdepth
#undef yheight
#undef xwidth
#undef priority
#undef material_string
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

  /* Initializations for component channel_19_analyzer_2_array_crystal_array_8. */
  SIG_MESSAGE("channel_19_analyzer_2_array_crystal_array_8 (Init)");
#define mccompcurname  channel_19_analyzer_2_array_crystal_array_8
#define mccompcurtype  Union_box
#define mccompcurindex 871
#define loop_index mccchannel_19_analyzer_2_array_crystal_array_8_loop_index
#define this_box_volume mccchannel_19_analyzer_2_array_crystal_array_8_this_box_volume
#define global_geometry_element mccchannel_19_analyzer_2_array_crystal_array_8_global_geometry_element
#define this_box_storage mccchannel_19_analyzer_2_array_crystal_array_8_this_box_storage
#define material_string mccchannel_19_analyzer_2_array_crystal_array_8_material_string
#define priority mccchannel_19_analyzer_2_array_crystal_array_8_priority
#define xwidth mccchannel_19_analyzer_2_array_crystal_array_8_xwidth
#define yheight mccchannel_19_analyzer_2_array_crystal_array_8_yheight
#define zdepth mccchannel_19_analyzer_2_array_crystal_array_8_zdepth
#define xwidth2 mccchannel_19_analyzer_2_array_crystal_array_8_xwidth2
#define yheight2 mccchannel_19_analyzer_2_array_crystal_array_8_yheight2
#define visualize mccchannel_19_analyzer_2_array_crystal_array_8_visualize
#define target_index mccchannel_19_analyzer_2_array_crystal_array_8_target_index
#define target_x mccchannel_19_analyzer_2_array_crystal_array_8_target_x
#define target_y mccchannel_19_analyzer_2_array_crystal_array_8_target_y
#define target_z mccchannel_19_analyzer_2_array_crystal_array_8_target_z
#define focus_aw mccchannel_19_analyzer_2_array_crystal_array_8_focus_aw
#define focus_ah mccchannel_19_analyzer_2_array_crystal_array_8_focus_ah
#define focus_xw mccchannel_19_analyzer_2_array_crystal_array_8_focus_xw
#define focus_xh mccchannel_19_analyzer_2_array_crystal_array_8_focus_xh
#define focus_r mccchannel_19_analyzer_2_array_crystal_array_8_focus_r
#define p_interact mccchannel_19_analyzer_2_array_crystal_array_8_p_interact
#define mask_string mccchannel_19_analyzer_2_array_crystal_array_8_mask_string
#define mask_setting mccchannel_19_analyzer_2_array_crystal_array_8_mask_setting
#define number_of_activations mccchannel_19_analyzer_2_array_crystal_array_8_number_of_activations
#line 224 "Union_box.comp"
{
// Initializes the focusing system for this volume including input sanitation.
focus_initialize(&this_box_volume.geometry, POS_A_COMP_INDEX(INDEX_CURRENT_COMP+target_index), POS_A_CURRENT_COMP, ROT_A_CURRENT_COMP, target_index, target_x, target_y, target_z, focus_aw, focus_ah, focus_xw, focus_xh, focus_r, NAME_CURRENT_COMP);

// Input sanitation for this geometry
if (xwidth <= 0) {
  printf("\nERROR in Union_box named %s, the xwidth is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (yheight <= 0) {
  printf("\nERROR in Union_box named %s, yheight is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (zdepth <= 0) {
  printf("\nERROR in Union_box named %s, zdepth is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (xwidth2 <= 0 && xwidth2 != -1) {
  printf("\nERROR in Union_box named %s, the xwidth2 is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (yheight2 <= 0 && yheight2 != -1) {
  printf("\nERROR in Union_box named %s, yheight2 is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}

// Use sanitation
if (global_material_list.num_elements == 0) {
  printf("\nERROR: Need to define a material using Union_make_material before using a Union geometry component. \n");
  printf("       %s was defined before first use of Union_make_material.\n",NAME_CURRENT_COMP);
  exit(1);
}

this_box_volume.geometry.is_masked_volume = 0;
this_box_volume.geometry.is_exit_volume = 0;
this_box_volume.geometry.is_mask_volume = 0;
// check if the volume is a mask, if it is the material string is irelevant.
if (mask_string && strlen(mask_string) && strcmp(mask_string, "NULL") && strcmp(mask_string, "0")) {
    // A mask volume is used to limit the extend of other volumes, called the masked volumes. These are specified in the mask_string.
    // In order for a ray to enter a masked volume, it needs to be both in the region covered by that volume AND the mask volume.
    // When more than
    this_box_volume.geometry.mask_mode = 1; // Default is mask mode is ALL
    if (mask_setting && strlen(mask_setting) && strcmp(mask_setting, "NULL") && strcmp(mask_setting, "0")) {
        if (strcmp(mask_setting,"ALL") == 0 || strcmp(mask_setting,"All") == 0) this_box_volume.geometry.mask_mode = 1;
        else if (strcmp(mask_setting,"ANY") == 0 || strcmp(mask_setting,"Any") == 0) this_box_volume.geometry.mask_mode = 2;
        else {
            printf("The mask_mode of component %s is set to %s, but must be either ALL or ANY.\n",NAME_CURRENT_COMP,mask_setting);
            exit(1);
        }
    }
    
    for (loop_index=0;loop_index<global_geometry_list.num_elements;loop_index++) {
        // Add mask list
        if (1 == manual_linking_function(global_geometry_list.elements[loop_index].name,mask_string)) {
            add_element_to_int_list(&this_box_volume.geometry.mask_list,global_geometry_list.elements[loop_index].component_index);
            add_element_to_int_list(&global_geometry_list.elements[loop_index].Volume->geometry.masked_by_list,INDEX_CURRENT_COMP);
            global_geometry_list.elements[loop_index].Volume->geometry.is_masked_volume = 1;
            if (this_box_volume.geometry.mask_mode == 2)
                global_geometry_list.elements[loop_index].Volume->geometry.mask_mode = 2;
            if (this_box_volume.geometry.mask_mode == 1) {
                if (global_geometry_list.elements[loop_index].Volume->geometry.is_masked_volume == 1 && global_geometry_list.elements[loop_index].Volume->geometry.mask_mode != 2)
                    // If more than one mask is added to one volume, the ANY mode overwrites the (default) ALL mode.
                    global_geometry_list.elements[loop_index].Volume->geometry.mask_mode = 1;
            }
            
            found_geometries = 1;
        }
    }
    if (found_geometries == 0) {
        printf("The mask_string in geometry: %s did not find any of the specified volumes in the mask_string %s \n",NAME_CURRENT_COMP,mask_string);
        exit(1);
    }
    this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
    this_box_volume.p_physics->is_vacuum = 0; // Makes this volume a vacuum
    this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
    this_box_volume.p_physics->my_a = 0; // Should not be used.
    sprintf(this_box_volume.p_physics->name,"Mask");
    this_box_volume.geometry.is_mask_volume = 1;
    
    
// Read the material input, or if it lacks, use automatic linking.
} else if (material_string && strlen(material_string) && strcmp(material_string, "NULL") && strcmp(material_string, "0")) {
    // A geometry string was given, use it to determine which material
    if (0 == strcmp(material_string,"vacuum") || 0 == strcmp(material_string,"Vacuum")) {
        // One could have a global physics struct for vacuum instead of creating one for each
        this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
        this_box_volume.p_physics->is_vacuum = 1; // Makes this volume a vacuum
        this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
        this_box_volume.p_physics->my_a = 0; // Should not be used.
        sprintf(this_box_volume.p_physics->name,"Vacuum");
    } else if (0 == strcmp(material_string,"exit") || 0 == strcmp(material_string,"Exit")) {
        // One could have a global physics struct for vacuum instead of creating one for each
        this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
        this_box_volume.p_physics->is_vacuum = 1; // Makes this volume a vacuum
        this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
        this_box_volume.p_physics->my_a = 0; // Should not be used.
        this_box_volume.geometry.is_exit_volume = 1;
        sprintf(this_box_volume.p_physics->name,"Exit");
    } else {
        #ifndef MATERIAL_DETECTOR
            printf("Need to define a material before refering to it in a geometry %s.\n",NAME_CURRENT_COMP);
            exit(1);
        #endif
        for (loop_index=0;loop_index<global_material_list.num_elements;loop_index++) {
            if (0 == strcmp(material_string,global_material_list.elements[loop_index].name)) {
                this_box_volume.p_physics = global_material_list.elements[loop_index].physics;
                break;
            }
            if (loop_index == global_material_list.num_elements-1) {
            printf("\n");
            printf("ERROR: The material string \"%s\" in Union geometry \"%s\" did not match a specified material. \n",material_string,NAME_CURRENT_COMP);
            printf("       The materials available at this point (need to be defined before the geometry): \n");
            for (loop_index=0;loop_index<global_material_list.num_elements;loop_index++)
              printf("         %s\n",global_material_list.elements[loop_index].name);
            printf("\n");
            printf("       It is also possible to use one of the defualt materials avaiable: \n");
            printf("           Vacuum (for a Volume without scattering or absorption)\n");
            printf("           Exit (for a Volume where the ray exits the component if it enters)\n");
            printf("           Mask (for a Volume that masks existing volumes specified in the mask_string\n");
            exit(1);
          }
        }
    }
} else {
    // Automatic linking, simply using the last defined material.
    #ifndef MATERIAL_DETECTOR
        printf("Need to define a material before the geometry to use automatic linking %s.\n",NAME_CURRENT_COMP);
        exit(1);
    #endif
    this_box_volume.p_physics = global_material_list.elements[global_material_list.num_elements-1].physics;
}

sprintf(this_box_volume.name,NAME_CURRENT_COMP);
sprintf(this_box_volume.geometry.shape,"box");
this_box_volume.geometry.priority_value = priority;
this_box_volume.geometry.geometry_p_interact = p_interact;
// Currently the coordinates will be in absolute space.
this_box_volume.geometry.center = POS_A_CURRENT_COMP;

this_box_storage.z_depth = zdepth;
this_box_storage.x_width1 = xwidth;
this_box_storage.y_height1 = yheight;

this_box_storage.is_rectangle = 0;
if (xwidth2 < 0 && yheight2 < 0) this_box_storage.is_rectangle = 1;
if (xwidth == xwidth2 && yheight == yheight2) this_box_storage.is_rectangle = 1;

if (xwidth2 < 0) {
    this_box_storage.x_width2 = xwidth;
    xwidth2 = xwidth;
} else this_box_storage.x_width2 = xwidth2;

if (yheight2 < 0) {
    this_box_storage.y_height2 = yheight;
    yheight2 = yheight;
} else this_box_storage.y_height2 = yheight2;


this_box_storage.normal_vectors[0] = coords_set(0,0,1);
this_box_storage.normal_vectors[1] = coords_set(0,0,1);

// for sides with y component = 0
x_component = 2*zdepth/sqrt((xwidth-xwidth2)*(xwidth-xwidth2)+4*zdepth*zdepth);
z_component = (xwidth-xwidth2)/sqrt(4*zdepth*zdepth+(xwidth-xwidth2)*(xwidth-xwidth2));

this_box_storage.normal_vectors[2] = coords_set(x_component,0,z_component);
this_box_storage.normal_vectors[3] = coords_set(-x_component,0,z_component);

// for sides with x component = 0
y_component = 2*zdepth/sqrt((yheight-yheight2)*(yheight-yheight2)+4*zdepth*zdepth);
z_component = (yheight-yheight2)/sqrt(4*zdepth*zdepth+(yheight-yheight2)*(yheight-yheight2));

this_box_storage.normal_vectors[4] = coords_set(0,y_component,z_component);
this_box_storage.normal_vectors[5] = coords_set(0,-y_component,z_component);

this_box_volume.geometry.visualization_on = visualize;

this_box_volume.geometry.geometry_parameters.p_box_storage = &this_box_storage;

// Assign pointers to functions for intersection with the shape, checking if a point is inside the shape
if (this_box_storage.is_rectangle == 1) {
this_box_volume.geometry.intersect_function = &sample_box_intersect_simple;
this_box_volume.geometry.within_function = &r_within_box_simple;
}
else {
this_box_volume.geometry.intersect_function = &sample_box_intersect_advanced;
this_box_volume.geometry.within_function = &r_within_box_advanced;
}

this_box_volume.geometry.shell_points = &box_shell_points;
this_box_volume.geometry.mcdisplay_function = &mcdisplay_box_function;
this_box_volume.geometry.initialize_from_main_function = &initialize_box_geometry_from_main_component;
this_box_volume.geometry.process_rot_allocated = 0;

this_box_volume.geometry.copy_geometry_parameters = &allocate_box_storage_copy;

rot_copy(this_box_volume.geometry.rotation_matrix,ROT_A_CURRENT_COMP); //check how ROT_R_CURRENT_COMP would work
rot_transpose(ROT_A_CURRENT_COMP,this_box_volume.geometry.transpose_rotation_matrix);

// Initialize loggers
this_box_volume.loggers.num_elements = 0;

// packing the information into the global_geometry_element, which is then included in the global_geometry_list.
sprintf(global_geometry_element.name,NAME_CURRENT_COMP);
global_geometry_element.activation_counter = number_of_activations;
global_geometry_element.component_index = INDEX_CURRENT_COMP;
global_geometry_element.Volume = &this_box_volume; // Would be nicer if this m was a pointer, now we have the (small) data two places
add_element_to_geometry_list(&global_geometry_list,global_geometry_element);
}
#line 337778 "MACS_sample_kidney_box.c"
#undef number_of_activations
#undef mask_setting
#undef mask_string
#undef p_interact
#undef focus_r
#undef focus_xh
#undef focus_xw
#undef focus_ah
#undef focus_aw
#undef target_z
#undef target_y
#undef target_x
#undef target_index
#undef visualize
#undef yheight2
#undef xwidth2
#undef zdepth
#undef yheight
#undef xwidth
#undef priority
#undef material_string
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

  /* Initializations for component channel_19_cave2_cyl1. */
  SIG_MESSAGE("channel_19_cave2_cyl1 (Init)");
#define mccompcurname  channel_19_cave2_cyl1
#define mccompcurtype  Union_cylinder
#define mccompcurindex 872
#define loop_index mccchannel_19_cave2_cyl1_loop_index
#define this_cylinder_volume mccchannel_19_cave2_cyl1_this_cylinder_volume
#define global_geometry_element mccchannel_19_cave2_cyl1_global_geometry_element
#define this_cylinder_storage mccchannel_19_cave2_cyl1_this_cylinder_storage
#define material_string mccchannel_19_cave2_cyl1_material_string
#define priority mccchannel_19_cave2_cyl1_priority
#define radius mccchannel_19_cave2_cyl1_radius
#define yheight mccchannel_19_cave2_cyl1_yheight
#define visualize mccchannel_19_cave2_cyl1_visualize
#define target_index mccchannel_19_cave2_cyl1_target_index
#define target_x mccchannel_19_cave2_cyl1_target_x
#define target_y mccchannel_19_cave2_cyl1_target_y
#define target_z mccchannel_19_cave2_cyl1_target_z
#define focus_aw mccchannel_19_cave2_cyl1_focus_aw
#define focus_ah mccchannel_19_cave2_cyl1_focus_ah
#define focus_xw mccchannel_19_cave2_cyl1_focus_xw
#define focus_xh mccchannel_19_cave2_cyl1_focus_xh
#define focus_r mccchannel_19_cave2_cyl1_focus_r
#define p_interact mccchannel_19_cave2_cyl1_p_interact
#define mask_string mccchannel_19_cave2_cyl1_mask_string
#define mask_setting mccchannel_19_cave2_cyl1_mask_setting
#define number_of_activations mccchannel_19_cave2_cyl1_number_of_activations
#line 185 "Union_cylinder.comp"
{
// Initializes the focusing system for this volume including input sanitation.
focus_initialize(&this_cylinder_volume.geometry, POS_A_COMP_INDEX(INDEX_CURRENT_COMP+target_index), POS_A_CURRENT_COMP, ROT_A_CURRENT_COMP, target_index, target_x, target_y, target_z, focus_aw, focus_ah, focus_xw, focus_xh, focus_r, NAME_CURRENT_COMP);

// Input sanitation for this geometry
if (radius <= 0) {
  printf("\nERROR in Union_cylinder named %s, the radius is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}

if (yheight <= 0) {
  printf("\nERROR in Union_cylinder named %s, yheight is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}

// Use sanitation
#ifdef MATERIAL_DETECTOR
if (global_material_list.num_elements == 0) {
  // Here if the user have defined a material, but only after this material
  printf("\nERROR: Need to define a material using Union_make_material before using a Union geometry component. \n");
  printf("       %s was defined before first use of Union_make_material.\n",NAME_CURRENT_COMP);
  exit(1);
}
#endif
#ifndef MATERIAL_DETECTOR
  printf("\nERROR: Need to define a material using Union_make_material before using a Union geometry component. \n");
  exit(1);
#endif


this_cylinder_volume.geometry.is_masked_volume = 0;
this_cylinder_volume.geometry.is_exit_volume = 0;
this_cylinder_volume.geometry.is_mask_volume = 0;

// Read the material input, or if it lacks, use automatic linking.
if (mask_string && strlen(mask_string) && strcmp(mask_string, "NULL") && strcmp(mask_string, "0")) {
    // A mask volume is used to limit the extend of other volumes, called the masked volumes. These are specified in the mask_string.
    // In order for a ray to enter a masked volume, it needs to be both in the region covered by that volume AND the mask volume.
    // When more than
    this_cylinder_volume.geometry.mask_mode = 1; // Default is mask mode is ALL
    if (mask_setting && strlen(mask_setting) && strcmp(mask_setting, "NULL") && strcmp(mask_setting, "0")) {
        if (strcmp(mask_setting,"ALL") == 0 || strcmp(mask_setting,"All") == 0) this_cylinder_volume.geometry.mask_mode = 1;
        else if (strcmp(mask_setting,"ANY") == 0 || strcmp(mask_setting,"Any") == 0) this_cylinder_volume.geometry.mask_mode = 2;
        else {
            printf("The mask_mode of component %s is set to %s, but must be either ALL or ANY.\n",NAME_CURRENT_COMP,mask_setting);
            exit(1);
        }
    }
    
    for (loop_index=0;loop_index<global_geometry_list.num_elements;loop_index++) {
        // Add mask list
        if (1 == manual_linking_function(global_geometry_list.elements[loop_index].name,mask_string)) {
            add_element_to_int_list(&this_cylinder_volume.geometry.mask_list,global_geometry_list.elements[loop_index].component_index);
            add_element_to_int_list(&global_geometry_list.elements[loop_index].Volume->geometry.masked_by_list,INDEX_CURRENT_COMP);
            global_geometry_list.elements[loop_index].Volume->geometry.is_masked_volume = 1;
            if (this_cylinder_volume.geometry.mask_mode == 2)
                global_geometry_list.elements[loop_index].Volume->geometry.mask_mode = 2;
            if (this_cylinder_volume.geometry.mask_mode == 1) {
                if (global_geometry_list.elements[loop_index].Volume->geometry.is_masked_volume == 1 && global_geometry_list.elements[loop_index].Volume->geometry.mask_mode != 2)
                    // If more than one mask is added to one volume, the ANY mode overwrites the (default) ALL mode.
                    global_geometry_list.elements[loop_index].Volume->geometry.mask_mode = 1;
            }
            
            found_geometries = 1;
        }
    }
    if (found_geometries == 0) {
        printf("The mask_string in geometry: %s did not find any of the specified volumes in the mask_string %s \n",NAME_CURRENT_COMP,mask_string);
        exit(1);
    }
    this_cylinder_volume.p_physics = malloc(sizeof(struct physics_struct));
    this_cylinder_volume.p_physics->is_vacuum = 0; // Makes this volume a vacuum
    this_cylinder_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
    this_cylinder_volume.p_physics->my_a = 0; // Should not be used.
    sprintf(this_cylinder_volume.p_physics->name,"Mask");
    this_cylinder_volume.geometry.is_mask_volume = 1;
    
    
// Read the material input, or if it lacks, use automatic linking.
} else if (material_string && strlen(material_string) && strcmp(material_string, "NULL") && strcmp(material_string, "0")) {
    // A geometry string was given, use it to determine which material
    if (0 == strcmp(material_string,"vacuum") || 0 == strcmp(material_string,"Vacuum")) {
        // One could have a global physics struct for vacuum instead of creating one for each
        this_cylinder_volume.p_physics = malloc(sizeof(struct physics_struct));
        this_cylinder_volume.p_physics->is_vacuum = 1; // Makes this volume a vacuum
        this_cylinder_volume.p_physics->number_of_processes = (int) 0;
        this_cylinder_volume.p_physics->my_a = 0; // Should not be used.
        sprintf(this_cylinder_volume.p_physics->name,"Vacuum");
    } else if (0 == strcmp(material_string,"exit") || 0 == strcmp(material_string,"Exit")) {
        // One could have a global physics struct for exit instead of creating one for each
        this_cylinder_volume.p_physics = malloc(sizeof(struct physics_struct));
        this_cylinder_volume.p_physics->is_vacuum = 1; // Makes this volume a vacuum
        this_cylinder_volume.p_physics->number_of_processes = (int) 0;
        this_cylinder_volume.p_physics->my_a = 0; // Should not be used.
        this_cylinder_volume.geometry.is_exit_volume = 1;
        sprintf(this_cylinder_volume.p_physics->name,"Exit");
    } else {
        for (loop_index=0;loop_index<global_material_list.num_elements;loop_index++) {
          if (0 == strcmp(material_string,global_material_list.elements[loop_index].name)) {
            this_cylinder_volume.p_physics = global_material_list.elements[loop_index].physics;
            break;
          }
          if (loop_index == global_material_list.num_elements-1) {
            printf("\n");
            printf("ERROR: The material string \"%s\" in Union geometry \"%s\" did not match a specified material. \n",material_string,NAME_CURRENT_COMP);
            printf("       The materials available at this point (need to be defined before the geometry): \n");
            for (loop_index=0;loop_index<global_material_list.num_elements;loop_index++)
              printf("         %s\n",global_material_list.elements[loop_index].name);
            printf("\n");
            printf("       It is also possible to use one of the defualt materials avaiable: \n");
            printf("           Vacuum (for a Volume without scattering or absorption)\n");
            printf("           Exit (for a Volume where the ray exits the component if it enters)\n");
            printf("           Mask (for a Volume that masks existing volumes specified in the mask_string\n");
            exit(1);
          }
        }
    }
} else {
    // Automatic linking, simply using the last defined material.
    #ifndef MATERIAL_DETECTOR
        printf("Need to define a material before the geometry to use automatic linking %s.\n",NAME_CURRENT_COMP);
        exit(1);
    #endif
    this_cylinder_volume.p_physics = global_material_list.elements[global_material_list.num_elements-1].physics;
}

sprintf(this_cylinder_volume.name,NAME_CURRENT_COMP);
sprintf(this_cylinder_volume.geometry.shape,"cylinder");
this_cylinder_volume.geometry.priority_value = priority;
// Currently the coordinates will be in absolute space.
this_cylinder_volume.geometry.center = POS_A_CURRENT_COMP;

this_cylinder_volume.geometry.geometry_p_interact = p_interact;
this_cylinder_storage.cyl_radius = radius;
this_cylinder_storage.height = yheight;
this_cylinder_volume.geometry.visualization_on = visualize;
this_cylinder_volume.geometry.geometry_parameters.p_cylinder_storage = &this_cylinder_storage;
this_cylinder_volume.geometry.within_function = &r_within_cylinder;
this_cylinder_volume.geometry.intersect_function = &sample_cylinder_intersect;
this_cylinder_volume.geometry.mcdisplay_function = &mcdisplay_cylinder_function;
this_cylinder_volume.geometry.shell_points = &cylinder_shell_points;
this_cylinder_volume.geometry.initialize_from_main_function = &initialize_cylinder_geometry_from_main_component;
this_cylinder_volume.geometry.process_rot_allocated = 0;
this_cylinder_volume.geometry.copy_geometry_parameters = &allocate_cylinder_storage_copy;

rot_copy(this_cylinder_volume.geometry.rotation_matrix,ROT_A_CURRENT_COMP);
rot_transpose(ROT_A_CURRENT_COMP,this_cylinder_volume.geometry.transpose_rotation_matrix);

// Initialize loggers
this_cylinder_volume.loggers.num_elements = 0;

// packing the information into the global_geometry_element, which is then included in the global_geometry_list.
sprintf(global_geometry_element.name,NAME_CURRENT_COMP);
global_geometry_element.activation_counter = number_of_activations;
global_geometry_element.component_index = INDEX_CURRENT_COMP;
global_geometry_element.Volume = &this_cylinder_volume; // Would be nicer if this m was a pointer, now we have the (small) data two places
add_element_to_geometry_list(&global_geometry_list,global_geometry_element);
}
#line 337994 "MACS_sample_kidney_box.c"
#undef number_of_activations
#undef mask_setting
#undef mask_string
#undef p_interact
#undef focus_r
#undef focus_xh
#undef focus_xw
#undef focus_ah
#undef focus_aw
#undef target_z
#undef target_y
#undef target_x
#undef target_index
#undef visualize
#undef yheight
#undef radius
#undef priority
#undef material_string
#undef this_cylinder_storage
#undef global_geometry_element
#undef this_cylinder_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

  /* Initializations for component channel_19_cave2_box1. */
  SIG_MESSAGE("channel_19_cave2_box1 (Init)");
#define mccompcurname  channel_19_cave2_box1
#define mccompcurtype  Union_box
#define mccompcurindex 873
#define loop_index mccchannel_19_cave2_box1_loop_index
#define this_box_volume mccchannel_19_cave2_box1_this_box_volume
#define global_geometry_element mccchannel_19_cave2_box1_global_geometry_element
#define this_box_storage mccchannel_19_cave2_box1_this_box_storage
#define material_string mccchannel_19_cave2_box1_material_string
#define priority mccchannel_19_cave2_box1_priority
#define xwidth mccchannel_19_cave2_box1_xwidth
#define yheight mccchannel_19_cave2_box1_yheight
#define zdepth mccchannel_19_cave2_box1_zdepth
#define xwidth2 mccchannel_19_cave2_box1_xwidth2
#define yheight2 mccchannel_19_cave2_box1_yheight2
#define visualize mccchannel_19_cave2_box1_visualize
#define target_index mccchannel_19_cave2_box1_target_index
#define target_x mccchannel_19_cave2_box1_target_x
#define target_y mccchannel_19_cave2_box1_target_y
#define target_z mccchannel_19_cave2_box1_target_z
#define focus_aw mccchannel_19_cave2_box1_focus_aw
#define focus_ah mccchannel_19_cave2_box1_focus_ah
#define focus_xw mccchannel_19_cave2_box1_focus_xw
#define focus_xh mccchannel_19_cave2_box1_focus_xh
#define focus_r mccchannel_19_cave2_box1_focus_r
#define p_interact mccchannel_19_cave2_box1_p_interact
#define mask_string mccchannel_19_cave2_box1_mask_string
#define mask_setting mccchannel_19_cave2_box1_mask_setting
#define number_of_activations mccchannel_19_cave2_box1_number_of_activations
#line 224 "Union_box.comp"
{
// Initializes the focusing system for this volume including input sanitation.
focus_initialize(&this_box_volume.geometry, POS_A_COMP_INDEX(INDEX_CURRENT_COMP+target_index), POS_A_CURRENT_COMP, ROT_A_CURRENT_COMP, target_index, target_x, target_y, target_z, focus_aw, focus_ah, focus_xw, focus_xh, focus_r, NAME_CURRENT_COMP);

// Input sanitation for this geometry
if (xwidth <= 0) {
  printf("\nERROR in Union_box named %s, the xwidth is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (yheight <= 0) {
  printf("\nERROR in Union_box named %s, yheight is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (zdepth <= 0) {
  printf("\nERROR in Union_box named %s, zdepth is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (xwidth2 <= 0 && xwidth2 != -1) {
  printf("\nERROR in Union_box named %s, the xwidth2 is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (yheight2 <= 0 && yheight2 != -1) {
  printf("\nERROR in Union_box named %s, yheight2 is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}

// Use sanitation
if (global_material_list.num_elements == 0) {
  printf("\nERROR: Need to define a material using Union_make_material before using a Union geometry component. \n");
  printf("       %s was defined before first use of Union_make_material.\n",NAME_CURRENT_COMP);
  exit(1);
}

this_box_volume.geometry.is_masked_volume = 0;
this_box_volume.geometry.is_exit_volume = 0;
this_box_volume.geometry.is_mask_volume = 0;
// check if the volume is a mask, if it is the material string is irelevant.
if (mask_string && strlen(mask_string) && strcmp(mask_string, "NULL") && strcmp(mask_string, "0")) {
    // A mask volume is used to limit the extend of other volumes, called the masked volumes. These are specified in the mask_string.
    // In order for a ray to enter a masked volume, it needs to be both in the region covered by that volume AND the mask volume.
    // When more than
    this_box_volume.geometry.mask_mode = 1; // Default is mask mode is ALL
    if (mask_setting && strlen(mask_setting) && strcmp(mask_setting, "NULL") && strcmp(mask_setting, "0")) {
        if (strcmp(mask_setting,"ALL") == 0 || strcmp(mask_setting,"All") == 0) this_box_volume.geometry.mask_mode = 1;
        else if (strcmp(mask_setting,"ANY") == 0 || strcmp(mask_setting,"Any") == 0) this_box_volume.geometry.mask_mode = 2;
        else {
            printf("The mask_mode of component %s is set to %s, but must be either ALL or ANY.\n",NAME_CURRENT_COMP,mask_setting);
            exit(1);
        }
    }
    
    for (loop_index=0;loop_index<global_geometry_list.num_elements;loop_index++) {
        // Add mask list
        if (1 == manual_linking_function(global_geometry_list.elements[loop_index].name,mask_string)) {
            add_element_to_int_list(&this_box_volume.geometry.mask_list,global_geometry_list.elements[loop_index].component_index);
            add_element_to_int_list(&global_geometry_list.elements[loop_index].Volume->geometry.masked_by_list,INDEX_CURRENT_COMP);
            global_geometry_list.elements[loop_index].Volume->geometry.is_masked_volume = 1;
            if (this_box_volume.geometry.mask_mode == 2)
                global_geometry_list.elements[loop_index].Volume->geometry.mask_mode = 2;
            if (this_box_volume.geometry.mask_mode == 1) {
                if (global_geometry_list.elements[loop_index].Volume->geometry.is_masked_volume == 1 && global_geometry_list.elements[loop_index].Volume->geometry.mask_mode != 2)
                    // If more than one mask is added to one volume, the ANY mode overwrites the (default) ALL mode.
                    global_geometry_list.elements[loop_index].Volume->geometry.mask_mode = 1;
            }
            
            found_geometries = 1;
        }
    }
    if (found_geometries == 0) {
        printf("The mask_string in geometry: %s did not find any of the specified volumes in the mask_string %s \n",NAME_CURRENT_COMP,mask_string);
        exit(1);
    }
    this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
    this_box_volume.p_physics->is_vacuum = 0; // Makes this volume a vacuum
    this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
    this_box_volume.p_physics->my_a = 0; // Should not be used.
    sprintf(this_box_volume.p_physics->name,"Mask");
    this_box_volume.geometry.is_mask_volume = 1;
    
    
// Read the material input, or if it lacks, use automatic linking.
} else if (material_string && strlen(material_string) && strcmp(material_string, "NULL") && strcmp(material_string, "0")) {
    // A geometry string was given, use it to determine which material
    if (0 == strcmp(material_string,"vacuum") || 0 == strcmp(material_string,"Vacuum")) {
        // One could have a global physics struct for vacuum instead of creating one for each
        this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
        this_box_volume.p_physics->is_vacuum = 1; // Makes this volume a vacuum
        this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
        this_box_volume.p_physics->my_a = 0; // Should not be used.
        sprintf(this_box_volume.p_physics->name,"Vacuum");
    } else if (0 == strcmp(material_string,"exit") || 0 == strcmp(material_string,"Exit")) {
        // One could have a global physics struct for vacuum instead of creating one for each
        this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
        this_box_volume.p_physics->is_vacuum = 1; // Makes this volume a vacuum
        this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
        this_box_volume.p_physics->my_a = 0; // Should not be used.
        this_box_volume.geometry.is_exit_volume = 1;
        sprintf(this_box_volume.p_physics->name,"Exit");
    } else {
        #ifndef MATERIAL_DETECTOR
            printf("Need to define a material before refering to it in a geometry %s.\n",NAME_CURRENT_COMP);
            exit(1);
        #endif
        for (loop_index=0;loop_index<global_material_list.num_elements;loop_index++) {
            if (0 == strcmp(material_string,global_material_list.elements[loop_index].name)) {
                this_box_volume.p_physics = global_material_list.elements[loop_index].physics;
                break;
            }
            if (loop_index == global_material_list.num_elements-1) {
            printf("\n");
            printf("ERROR: The material string \"%s\" in Union geometry \"%s\" did not match a specified material. \n",material_string,NAME_CURRENT_COMP);
            printf("       The materials available at this point (need to be defined before the geometry): \n");
            for (loop_index=0;loop_index<global_material_list.num_elements;loop_index++)
              printf("         %s\n",global_material_list.elements[loop_index].name);
            printf("\n");
            printf("       It is also possible to use one of the defualt materials avaiable: \n");
            printf("           Vacuum (for a Volume without scattering or absorption)\n");
            printf("           Exit (for a Volume where the ray exits the component if it enters)\n");
            printf("           Mask (for a Volume that masks existing volumes specified in the mask_string\n");
            exit(1);
          }
        }
    }
} else {
    // Automatic linking, simply using the last defined material.
    #ifndef MATERIAL_DETECTOR
        printf("Need to define a material before the geometry to use automatic linking %s.\n",NAME_CURRENT_COMP);
        exit(1);
    #endif
    this_box_volume.p_physics = global_material_list.elements[global_material_list.num_elements-1].physics;
}

sprintf(this_box_volume.name,NAME_CURRENT_COMP);
sprintf(this_box_volume.geometry.shape,"box");
this_box_volume.geometry.priority_value = priority;
this_box_volume.geometry.geometry_p_interact = p_interact;
// Currently the coordinates will be in absolute space.
this_box_volume.geometry.center = POS_A_CURRENT_COMP;

this_box_storage.z_depth = zdepth;
this_box_storage.x_width1 = xwidth;
this_box_storage.y_height1 = yheight;

this_box_storage.is_rectangle = 0;
if (xwidth2 < 0 && yheight2 < 0) this_box_storage.is_rectangle = 1;
if (xwidth == xwidth2 && yheight == yheight2) this_box_storage.is_rectangle = 1;

if (xwidth2 < 0) {
    this_box_storage.x_width2 = xwidth;
    xwidth2 = xwidth;
} else this_box_storage.x_width2 = xwidth2;

if (yheight2 < 0) {
    this_box_storage.y_height2 = yheight;
    yheight2 = yheight;
} else this_box_storage.y_height2 = yheight2;


this_box_storage.normal_vectors[0] = coords_set(0,0,1);
this_box_storage.normal_vectors[1] = coords_set(0,0,1);

// for sides with y component = 0
x_component = 2*zdepth/sqrt((xwidth-xwidth2)*(xwidth-xwidth2)+4*zdepth*zdepth);
z_component = (xwidth-xwidth2)/sqrt(4*zdepth*zdepth+(xwidth-xwidth2)*(xwidth-xwidth2));

this_box_storage.normal_vectors[2] = coords_set(x_component,0,z_component);
this_box_storage.normal_vectors[3] = coords_set(-x_component,0,z_component);

// for sides with x component = 0
y_component = 2*zdepth/sqrt((yheight-yheight2)*(yheight-yheight2)+4*zdepth*zdepth);
z_component = (yheight-yheight2)/sqrt(4*zdepth*zdepth+(yheight-yheight2)*(yheight-yheight2));

this_box_storage.normal_vectors[4] = coords_set(0,y_component,z_component);
this_box_storage.normal_vectors[5] = coords_set(0,-y_component,z_component);

this_box_volume.geometry.visualization_on = visualize;

this_box_volume.geometry.geometry_parameters.p_box_storage = &this_box_storage;

// Assign pointers to functions for intersection with the shape, checking if a point is inside the shape
if (this_box_storage.is_rectangle == 1) {
this_box_volume.geometry.intersect_function = &sample_box_intersect_simple;
this_box_volume.geometry.within_function = &r_within_box_simple;
}
else {
this_box_volume.geometry.intersect_function = &sample_box_intersect_advanced;
this_box_volume.geometry.within_function = &r_within_box_advanced;
}

this_box_volume.geometry.shell_points = &box_shell_points;
this_box_volume.geometry.mcdisplay_function = &mcdisplay_box_function;
this_box_volume.geometry.initialize_from_main_function = &initialize_box_geometry_from_main_component;
this_box_volume.geometry.process_rot_allocated = 0;

this_box_volume.geometry.copy_geometry_parameters = &allocate_box_storage_copy;

rot_copy(this_box_volume.geometry.rotation_matrix,ROT_A_CURRENT_COMP); //check how ROT_R_CURRENT_COMP would work
rot_transpose(ROT_A_CURRENT_COMP,this_box_volume.geometry.transpose_rotation_matrix);

// Initialize loggers
this_box_volume.loggers.num_elements = 0;

// packing the information into the global_geometry_element, which is then included in the global_geometry_list.
sprintf(global_geometry_element.name,NAME_CURRENT_COMP);
global_geometry_element.activation_counter = number_of_activations;
global_geometry_element.component_index = INDEX_CURRENT_COMP;
global_geometry_element.Volume = &this_box_volume; // Would be nicer if this m was a pointer, now we have the (small) data two places
add_element_to_geometry_list(&global_geometry_list,global_geometry_element);
}
#line 338261 "MACS_sample_kidney_box.c"
#undef number_of_activations
#undef mask_setting
#undef mask_string
#undef p_interact
#undef focus_r
#undef focus_xh
#undef focus_xw
#undef focus_ah
#undef focus_aw
#undef target_z
#undef target_y
#undef target_x
#undef target_index
#undef visualize
#undef yheight2
#undef xwidth2
#undef zdepth
#undef yheight
#undef xwidth
#undef priority
#undef material_string
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

  /* Initializations for component channel_19_cave2_box2. */
  SIG_MESSAGE("channel_19_cave2_box2 (Init)");
#define mccompcurname  channel_19_cave2_box2
#define mccompcurtype  Union_box
#define mccompcurindex 874
#define loop_index mccchannel_19_cave2_box2_loop_index
#define this_box_volume mccchannel_19_cave2_box2_this_box_volume
#define global_geometry_element mccchannel_19_cave2_box2_global_geometry_element
#define this_box_storage mccchannel_19_cave2_box2_this_box_storage
#define material_string mccchannel_19_cave2_box2_material_string
#define priority mccchannel_19_cave2_box2_priority
#define xwidth mccchannel_19_cave2_box2_xwidth
#define yheight mccchannel_19_cave2_box2_yheight
#define zdepth mccchannel_19_cave2_box2_zdepth
#define xwidth2 mccchannel_19_cave2_box2_xwidth2
#define yheight2 mccchannel_19_cave2_box2_yheight2
#define visualize mccchannel_19_cave2_box2_visualize
#define target_index mccchannel_19_cave2_box2_target_index
#define target_x mccchannel_19_cave2_box2_target_x
#define target_y mccchannel_19_cave2_box2_target_y
#define target_z mccchannel_19_cave2_box2_target_z
#define focus_aw mccchannel_19_cave2_box2_focus_aw
#define focus_ah mccchannel_19_cave2_box2_focus_ah
#define focus_xw mccchannel_19_cave2_box2_focus_xw
#define focus_xh mccchannel_19_cave2_box2_focus_xh
#define focus_r mccchannel_19_cave2_box2_focus_r
#define p_interact mccchannel_19_cave2_box2_p_interact
#define mask_string mccchannel_19_cave2_box2_mask_string
#define mask_setting mccchannel_19_cave2_box2_mask_setting
#define number_of_activations mccchannel_19_cave2_box2_number_of_activations
#line 224 "Union_box.comp"
{
// Initializes the focusing system for this volume including input sanitation.
focus_initialize(&this_box_volume.geometry, POS_A_COMP_INDEX(INDEX_CURRENT_COMP+target_index), POS_A_CURRENT_COMP, ROT_A_CURRENT_COMP, target_index, target_x, target_y, target_z, focus_aw, focus_ah, focus_xw, focus_xh, focus_r, NAME_CURRENT_COMP);

// Input sanitation for this geometry
if (xwidth <= 0) {
  printf("\nERROR in Union_box named %s, the xwidth is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (yheight <= 0) {
  printf("\nERROR in Union_box named %s, yheight is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (zdepth <= 0) {
  printf("\nERROR in Union_box named %s, zdepth is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (xwidth2 <= 0 && xwidth2 != -1) {
  printf("\nERROR in Union_box named %s, the xwidth2 is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (yheight2 <= 0 && yheight2 != -1) {
  printf("\nERROR in Union_box named %s, yheight2 is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}

// Use sanitation
if (global_material_list.num_elements == 0) {
  printf("\nERROR: Need to define a material using Union_make_material before using a Union geometry component. \n");
  printf("       %s was defined before first use of Union_make_material.\n",NAME_CURRENT_COMP);
  exit(1);
}

this_box_volume.geometry.is_masked_volume = 0;
this_box_volume.geometry.is_exit_volume = 0;
this_box_volume.geometry.is_mask_volume = 0;
// check if the volume is a mask, if it is the material string is irelevant.
if (mask_string && strlen(mask_string) && strcmp(mask_string, "NULL") && strcmp(mask_string, "0")) {
    // A mask volume is used to limit the extend of other volumes, called the masked volumes. These are specified in the mask_string.
    // In order for a ray to enter a masked volume, it needs to be both in the region covered by that volume AND the mask volume.
    // When more than
    this_box_volume.geometry.mask_mode = 1; // Default is mask mode is ALL
    if (mask_setting && strlen(mask_setting) && strcmp(mask_setting, "NULL") && strcmp(mask_setting, "0")) {
        if (strcmp(mask_setting,"ALL") == 0 || strcmp(mask_setting,"All") == 0) this_box_volume.geometry.mask_mode = 1;
        else if (strcmp(mask_setting,"ANY") == 0 || strcmp(mask_setting,"Any") == 0) this_box_volume.geometry.mask_mode = 2;
        else {
            printf("The mask_mode of component %s is set to %s, but must be either ALL or ANY.\n",NAME_CURRENT_COMP,mask_setting);
            exit(1);
        }
    }
    
    for (loop_index=0;loop_index<global_geometry_list.num_elements;loop_index++) {
        // Add mask list
        if (1 == manual_linking_function(global_geometry_list.elements[loop_index].name,mask_string)) {
            add_element_to_int_list(&this_box_volume.geometry.mask_list,global_geometry_list.elements[loop_index].component_index);
            add_element_to_int_list(&global_geometry_list.elements[loop_index].Volume->geometry.masked_by_list,INDEX_CURRENT_COMP);
            global_geometry_list.elements[loop_index].Volume->geometry.is_masked_volume = 1;
            if (this_box_volume.geometry.mask_mode == 2)
                global_geometry_list.elements[loop_index].Volume->geometry.mask_mode = 2;
            if (this_box_volume.geometry.mask_mode == 1) {
                if (global_geometry_list.elements[loop_index].Volume->geometry.is_masked_volume == 1 && global_geometry_list.elements[loop_index].Volume->geometry.mask_mode != 2)
                    // If more than one mask is added to one volume, the ANY mode overwrites the (default) ALL mode.
                    global_geometry_list.elements[loop_index].Volume->geometry.mask_mode = 1;
            }
            
            found_geometries = 1;
        }
    }
    if (found_geometries == 0) {
        printf("The mask_string in geometry: %s did not find any of the specified volumes in the mask_string %s \n",NAME_CURRENT_COMP,mask_string);
        exit(1);
    }
    this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
    this_box_volume.p_physics->is_vacuum = 0; // Makes this volume a vacuum
    this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
    this_box_volume.p_physics->my_a = 0; // Should not be used.
    sprintf(this_box_volume.p_physics->name,"Mask");
    this_box_volume.geometry.is_mask_volume = 1;
    
    
// Read the material input, or if it lacks, use automatic linking.
} else if (material_string && strlen(material_string) && strcmp(material_string, "NULL") && strcmp(material_string, "0")) {
    // A geometry string was given, use it to determine which material
    if (0 == strcmp(material_string,"vacuum") || 0 == strcmp(material_string,"Vacuum")) {
        // One could have a global physics struct for vacuum instead of creating one for each
        this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
        this_box_volume.p_physics->is_vacuum = 1; // Makes this volume a vacuum
        this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
        this_box_volume.p_physics->my_a = 0; // Should not be used.
        sprintf(this_box_volume.p_physics->name,"Vacuum");
    } else if (0 == strcmp(material_string,"exit") || 0 == strcmp(material_string,"Exit")) {
        // One could have a global physics struct for vacuum instead of creating one for each
        this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
        this_box_volume.p_physics->is_vacuum = 1; // Makes this volume a vacuum
        this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
        this_box_volume.p_physics->my_a = 0; // Should not be used.
        this_box_volume.geometry.is_exit_volume = 1;
        sprintf(this_box_volume.p_physics->name,"Exit");
    } else {
        #ifndef MATERIAL_DETECTOR
            printf("Need to define a material before refering to it in a geometry %s.\n",NAME_CURRENT_COMP);
            exit(1);
        #endif
        for (loop_index=0;loop_index<global_material_list.num_elements;loop_index++) {
            if (0 == strcmp(material_string,global_material_list.elements[loop_index].name)) {
                this_box_volume.p_physics = global_material_list.elements[loop_index].physics;
                break;
            }
            if (loop_index == global_material_list.num_elements-1) {
            printf("\n");
            printf("ERROR: The material string \"%s\" in Union geometry \"%s\" did not match a specified material. \n",material_string,NAME_CURRENT_COMP);
            printf("       The materials available at this point (need to be defined before the geometry): \n");
            for (loop_index=0;loop_index<global_material_list.num_elements;loop_index++)
              printf("         %s\n",global_material_list.elements[loop_index].name);
            printf("\n");
            printf("       It is also possible to use one of the defualt materials avaiable: \n");
            printf("           Vacuum (for a Volume without scattering or absorption)\n");
            printf("           Exit (for a Volume where the ray exits the component if it enters)\n");
            printf("           Mask (for a Volume that masks existing volumes specified in the mask_string\n");
            exit(1);
          }
        }
    }
} else {
    // Automatic linking, simply using the last defined material.
    #ifndef MATERIAL_DETECTOR
        printf("Need to define a material before the geometry to use automatic linking %s.\n",NAME_CURRENT_COMP);
        exit(1);
    #endif
    this_box_volume.p_physics = global_material_list.elements[global_material_list.num_elements-1].physics;
}

sprintf(this_box_volume.name,NAME_CURRENT_COMP);
sprintf(this_box_volume.geometry.shape,"box");
this_box_volume.geometry.priority_value = priority;
this_box_volume.geometry.geometry_p_interact = p_interact;
// Currently the coordinates will be in absolute space.
this_box_volume.geometry.center = POS_A_CURRENT_COMP;

this_box_storage.z_depth = zdepth;
this_box_storage.x_width1 = xwidth;
this_box_storage.y_height1 = yheight;

this_box_storage.is_rectangle = 0;
if (xwidth2 < 0 && yheight2 < 0) this_box_storage.is_rectangle = 1;
if (xwidth == xwidth2 && yheight == yheight2) this_box_storage.is_rectangle = 1;

if (xwidth2 < 0) {
    this_box_storage.x_width2 = xwidth;
    xwidth2 = xwidth;
} else this_box_storage.x_width2 = xwidth2;

if (yheight2 < 0) {
    this_box_storage.y_height2 = yheight;
    yheight2 = yheight;
} else this_box_storage.y_height2 = yheight2;


this_box_storage.normal_vectors[0] = coords_set(0,0,1);
this_box_storage.normal_vectors[1] = coords_set(0,0,1);

// for sides with y component = 0
x_component = 2*zdepth/sqrt((xwidth-xwidth2)*(xwidth-xwidth2)+4*zdepth*zdepth);
z_component = (xwidth-xwidth2)/sqrt(4*zdepth*zdepth+(xwidth-xwidth2)*(xwidth-xwidth2));

this_box_storage.normal_vectors[2] = coords_set(x_component,0,z_component);
this_box_storage.normal_vectors[3] = coords_set(-x_component,0,z_component);

// for sides with x component = 0
y_component = 2*zdepth/sqrt((yheight-yheight2)*(yheight-yheight2)+4*zdepth*zdepth);
z_component = (yheight-yheight2)/sqrt(4*zdepth*zdepth+(yheight-yheight2)*(yheight-yheight2));

this_box_storage.normal_vectors[4] = coords_set(0,y_component,z_component);
this_box_storage.normal_vectors[5] = coords_set(0,-y_component,z_component);

this_box_volume.geometry.visualization_on = visualize;

this_box_volume.geometry.geometry_parameters.p_box_storage = &this_box_storage;

// Assign pointers to functions for intersection with the shape, checking if a point is inside the shape
if (this_box_storage.is_rectangle == 1) {
this_box_volume.geometry.intersect_function = &sample_box_intersect_simple;
this_box_volume.geometry.within_function = &r_within_box_simple;
}
else {
this_box_volume.geometry.intersect_function = &sample_box_intersect_advanced;
this_box_volume.geometry.within_function = &r_within_box_advanced;
}

this_box_volume.geometry.shell_points = &box_shell_points;
this_box_volume.geometry.mcdisplay_function = &mcdisplay_box_function;
this_box_volume.geometry.initialize_from_main_function = &initialize_box_geometry_from_main_component;
this_box_volume.geometry.process_rot_allocated = 0;

this_box_volume.geometry.copy_geometry_parameters = &allocate_box_storage_copy;

rot_copy(this_box_volume.geometry.rotation_matrix,ROT_A_CURRENT_COMP); //check how ROT_R_CURRENT_COMP would work
rot_transpose(ROT_A_CURRENT_COMP,this_box_volume.geometry.transpose_rotation_matrix);

// Initialize loggers
this_box_volume.loggers.num_elements = 0;

// packing the information into the global_geometry_element, which is then included in the global_geometry_list.
sprintf(global_geometry_element.name,NAME_CURRENT_COMP);
global_geometry_element.activation_counter = number_of_activations;
global_geometry_element.component_index = INDEX_CURRENT_COMP;
global_geometry_element.Volume = &this_box_volume; // Would be nicer if this m was a pointer, now we have the (small) data two places
add_element_to_geometry_list(&global_geometry_list,global_geometry_element);
}
#line 338531 "MACS_sample_kidney_box.c"
#undef number_of_activations
#undef mask_setting
#undef mask_string
#undef p_interact
#undef focus_r
#undef focus_xh
#undef focus_xw
#undef focus_ah
#undef focus_aw
#undef target_z
#undef target_y
#undef target_x
#undef target_index
#undef visualize
#undef yheight2
#undef xwidth2
#undef zdepth
#undef yheight
#undef xwidth
#undef priority
#undef material_string
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

  /* Initializations for component channel_19_cave2_box3. */
  SIG_MESSAGE("channel_19_cave2_box3 (Init)");
#define mccompcurname  channel_19_cave2_box3
#define mccompcurtype  Union_box
#define mccompcurindex 875
#define loop_index mccchannel_19_cave2_box3_loop_index
#define this_box_volume mccchannel_19_cave2_box3_this_box_volume
#define global_geometry_element mccchannel_19_cave2_box3_global_geometry_element
#define this_box_storage mccchannel_19_cave2_box3_this_box_storage
#define material_string mccchannel_19_cave2_box3_material_string
#define priority mccchannel_19_cave2_box3_priority
#define xwidth mccchannel_19_cave2_box3_xwidth
#define yheight mccchannel_19_cave2_box3_yheight
#define zdepth mccchannel_19_cave2_box3_zdepth
#define xwidth2 mccchannel_19_cave2_box3_xwidth2
#define yheight2 mccchannel_19_cave2_box3_yheight2
#define visualize mccchannel_19_cave2_box3_visualize
#define target_index mccchannel_19_cave2_box3_target_index
#define target_x mccchannel_19_cave2_box3_target_x
#define target_y mccchannel_19_cave2_box3_target_y
#define target_z mccchannel_19_cave2_box3_target_z
#define focus_aw mccchannel_19_cave2_box3_focus_aw
#define focus_ah mccchannel_19_cave2_box3_focus_ah
#define focus_xw mccchannel_19_cave2_box3_focus_xw
#define focus_xh mccchannel_19_cave2_box3_focus_xh
#define focus_r mccchannel_19_cave2_box3_focus_r
#define p_interact mccchannel_19_cave2_box3_p_interact
#define mask_string mccchannel_19_cave2_box3_mask_string
#define mask_setting mccchannel_19_cave2_box3_mask_setting
#define number_of_activations mccchannel_19_cave2_box3_number_of_activations
#line 224 "Union_box.comp"
{
// Initializes the focusing system for this volume including input sanitation.
focus_initialize(&this_box_volume.geometry, POS_A_COMP_INDEX(INDEX_CURRENT_COMP+target_index), POS_A_CURRENT_COMP, ROT_A_CURRENT_COMP, target_index, target_x, target_y, target_z, focus_aw, focus_ah, focus_xw, focus_xh, focus_r, NAME_CURRENT_COMP);

// Input sanitation for this geometry
if (xwidth <= 0) {
  printf("\nERROR in Union_box named %s, the xwidth is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (yheight <= 0) {
  printf("\nERROR in Union_box named %s, yheight is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (zdepth <= 0) {
  printf("\nERROR in Union_box named %s, zdepth is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (xwidth2 <= 0 && xwidth2 != -1) {
  printf("\nERROR in Union_box named %s, the xwidth2 is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (yheight2 <= 0 && yheight2 != -1) {
  printf("\nERROR in Union_box named %s, yheight2 is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}

// Use sanitation
if (global_material_list.num_elements == 0) {
  printf("\nERROR: Need to define a material using Union_make_material before using a Union geometry component. \n");
  printf("       %s was defined before first use of Union_make_material.\n",NAME_CURRENT_COMP);
  exit(1);
}

this_box_volume.geometry.is_masked_volume = 0;
this_box_volume.geometry.is_exit_volume = 0;
this_box_volume.geometry.is_mask_volume = 0;
// check if the volume is a mask, if it is the material string is irelevant.
if (mask_string && strlen(mask_string) && strcmp(mask_string, "NULL") && strcmp(mask_string, "0")) {
    // A mask volume is used to limit the extend of other volumes, called the masked volumes. These are specified in the mask_string.
    // In order for a ray to enter a masked volume, it needs to be both in the region covered by that volume AND the mask volume.
    // When more than
    this_box_volume.geometry.mask_mode = 1; // Default is mask mode is ALL
    if (mask_setting && strlen(mask_setting) && strcmp(mask_setting, "NULL") && strcmp(mask_setting, "0")) {
        if (strcmp(mask_setting,"ALL") == 0 || strcmp(mask_setting,"All") == 0) this_box_volume.geometry.mask_mode = 1;
        else if (strcmp(mask_setting,"ANY") == 0 || strcmp(mask_setting,"Any") == 0) this_box_volume.geometry.mask_mode = 2;
        else {
            printf("The mask_mode of component %s is set to %s, but must be either ALL or ANY.\n",NAME_CURRENT_COMP,mask_setting);
            exit(1);
        }
    }
    
    for (loop_index=0;loop_index<global_geometry_list.num_elements;loop_index++) {
        // Add mask list
        if (1 == manual_linking_function(global_geometry_list.elements[loop_index].name,mask_string)) {
            add_element_to_int_list(&this_box_volume.geometry.mask_list,global_geometry_list.elements[loop_index].component_index);
            add_element_to_int_list(&global_geometry_list.elements[loop_index].Volume->geometry.masked_by_list,INDEX_CURRENT_COMP);
            global_geometry_list.elements[loop_index].Volume->geometry.is_masked_volume = 1;
            if (this_box_volume.geometry.mask_mode == 2)
                global_geometry_list.elements[loop_index].Volume->geometry.mask_mode = 2;
            if (this_box_volume.geometry.mask_mode == 1) {
                if (global_geometry_list.elements[loop_index].Volume->geometry.is_masked_volume == 1 && global_geometry_list.elements[loop_index].Volume->geometry.mask_mode != 2)
                    // If more than one mask is added to one volume, the ANY mode overwrites the (default) ALL mode.
                    global_geometry_list.elements[loop_index].Volume->geometry.mask_mode = 1;
            }
            
            found_geometries = 1;
        }
    }
    if (found_geometries == 0) {
        printf("The mask_string in geometry: %s did not find any of the specified volumes in the mask_string %s \n",NAME_CURRENT_COMP,mask_string);
        exit(1);
    }
    this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
    this_box_volume.p_physics->is_vacuum = 0; // Makes this volume a vacuum
    this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
    this_box_volume.p_physics->my_a = 0; // Should not be used.
    sprintf(this_box_volume.p_physics->name,"Mask");
    this_box_volume.geometry.is_mask_volume = 1;
    
    
// Read the material input, or if it lacks, use automatic linking.
} else if (material_string && strlen(material_string) && strcmp(material_string, "NULL") && strcmp(material_string, "0")) {
    // A geometry string was given, use it to determine which material
    if (0 == strcmp(material_string,"vacuum") || 0 == strcmp(material_string,"Vacuum")) {
        // One could have a global physics struct for vacuum instead of creating one for each
        this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
        this_box_volume.p_physics->is_vacuum = 1; // Makes this volume a vacuum
        this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
        this_box_volume.p_physics->my_a = 0; // Should not be used.
        sprintf(this_box_volume.p_physics->name,"Vacuum");
    } else if (0 == strcmp(material_string,"exit") || 0 == strcmp(material_string,"Exit")) {
        // One could have a global physics struct for vacuum instead of creating one for each
        this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
        this_box_volume.p_physics->is_vacuum = 1; // Makes this volume a vacuum
        this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
        this_box_volume.p_physics->my_a = 0; // Should not be used.
        this_box_volume.geometry.is_exit_volume = 1;
        sprintf(this_box_volume.p_physics->name,"Exit");
    } else {
        #ifndef MATERIAL_DETECTOR
            printf("Need to define a material before refering to it in a geometry %s.\n",NAME_CURRENT_COMP);
            exit(1);
        #endif
        for (loop_index=0;loop_index<global_material_list.num_elements;loop_index++) {
            if (0 == strcmp(material_string,global_material_list.elements[loop_index].name)) {
                this_box_volume.p_physics = global_material_list.elements[loop_index].physics;
                break;
            }
            if (loop_index == global_material_list.num_elements-1) {
            printf("\n");
            printf("ERROR: The material string \"%s\" in Union geometry \"%s\" did not match a specified material. \n",material_string,NAME_CURRENT_COMP);
            printf("       The materials available at this point (need to be defined before the geometry): \n");
            for (loop_index=0;loop_index<global_material_list.num_elements;loop_index++)
              printf("         %s\n",global_material_list.elements[loop_index].name);
            printf("\n");
            printf("       It is also possible to use one of the defualt materials avaiable: \n");
            printf("           Vacuum (for a Volume without scattering or absorption)\n");
            printf("           Exit (for a Volume where the ray exits the component if it enters)\n");
            printf("           Mask (for a Volume that masks existing volumes specified in the mask_string\n");
            exit(1);
          }
        }
    }
} else {
    // Automatic linking, simply using the last defined material.
    #ifndef MATERIAL_DETECTOR
        printf("Need to define a material before the geometry to use automatic linking %s.\n",NAME_CURRENT_COMP);
        exit(1);
    #endif
    this_box_volume.p_physics = global_material_list.elements[global_material_list.num_elements-1].physics;
}

sprintf(this_box_volume.name,NAME_CURRENT_COMP);
sprintf(this_box_volume.geometry.shape,"box");
this_box_volume.geometry.priority_value = priority;
this_box_volume.geometry.geometry_p_interact = p_interact;
// Currently the coordinates will be in absolute space.
this_box_volume.geometry.center = POS_A_CURRENT_COMP;

this_box_storage.z_depth = zdepth;
this_box_storage.x_width1 = xwidth;
this_box_storage.y_height1 = yheight;

this_box_storage.is_rectangle = 0;
if (xwidth2 < 0 && yheight2 < 0) this_box_storage.is_rectangle = 1;
if (xwidth == xwidth2 && yheight == yheight2) this_box_storage.is_rectangle = 1;

if (xwidth2 < 0) {
    this_box_storage.x_width2 = xwidth;
    xwidth2 = xwidth;
} else this_box_storage.x_width2 = xwidth2;

if (yheight2 < 0) {
    this_box_storage.y_height2 = yheight;
    yheight2 = yheight;
} else this_box_storage.y_height2 = yheight2;


this_box_storage.normal_vectors[0] = coords_set(0,0,1);
this_box_storage.normal_vectors[1] = coords_set(0,0,1);

// for sides with y component = 0
x_component = 2*zdepth/sqrt((xwidth-xwidth2)*(xwidth-xwidth2)+4*zdepth*zdepth);
z_component = (xwidth-xwidth2)/sqrt(4*zdepth*zdepth+(xwidth-xwidth2)*(xwidth-xwidth2));

this_box_storage.normal_vectors[2] = coords_set(x_component,0,z_component);
this_box_storage.normal_vectors[3] = coords_set(-x_component,0,z_component);

// for sides with x component = 0
y_component = 2*zdepth/sqrt((yheight-yheight2)*(yheight-yheight2)+4*zdepth*zdepth);
z_component = (yheight-yheight2)/sqrt(4*zdepth*zdepth+(yheight-yheight2)*(yheight-yheight2));

this_box_storage.normal_vectors[4] = coords_set(0,y_component,z_component);
this_box_storage.normal_vectors[5] = coords_set(0,-y_component,z_component);

this_box_volume.geometry.visualization_on = visualize;

this_box_volume.geometry.geometry_parameters.p_box_storage = &this_box_storage;

// Assign pointers to functions for intersection with the shape, checking if a point is inside the shape
if (this_box_storage.is_rectangle == 1) {
this_box_volume.geometry.intersect_function = &sample_box_intersect_simple;
this_box_volume.geometry.within_function = &r_within_box_simple;
}
else {
this_box_volume.geometry.intersect_function = &sample_box_intersect_advanced;
this_box_volume.geometry.within_function = &r_within_box_advanced;
}

this_box_volume.geometry.shell_points = &box_shell_points;
this_box_volume.geometry.mcdisplay_function = &mcdisplay_box_function;
this_box_volume.geometry.initialize_from_main_function = &initialize_box_geometry_from_main_component;
this_box_volume.geometry.process_rot_allocated = 0;

this_box_volume.geometry.copy_geometry_parameters = &allocate_box_storage_copy;

rot_copy(this_box_volume.geometry.rotation_matrix,ROT_A_CURRENT_COMP); //check how ROT_R_CURRENT_COMP would work
rot_transpose(ROT_A_CURRENT_COMP,this_box_volume.geometry.transpose_rotation_matrix);

// Initialize loggers
this_box_volume.loggers.num_elements = 0;

// packing the information into the global_geometry_element, which is then included in the global_geometry_list.
sprintf(global_geometry_element.name,NAME_CURRENT_COMP);
global_geometry_element.activation_counter = number_of_activations;
global_geometry_element.component_index = INDEX_CURRENT_COMP;
global_geometry_element.Volume = &this_box_volume; // Would be nicer if this m was a pointer, now we have the (small) data two places
add_element_to_geometry_list(&global_geometry_list,global_geometry_element);
}
#line 338801 "MACS_sample_kidney_box.c"
#undef number_of_activations
#undef mask_setting
#undef mask_string
#undef p_interact
#undef focus_r
#undef focus_xh
#undef focus_xw
#undef focus_ah
#undef focus_aw
#undef target_z
#undef target_y
#undef target_x
#undef target_index
#undef visualize
#undef yheight2
#undef xwidth2
#undef zdepth
#undef yheight
#undef xwidth
#undef priority
#undef material_string
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

  /* Initializations for component inter_analyzer_colimator_center_19. */
  SIG_MESSAGE("inter_analyzer_colimator_center_19 (Init)");

  /* Initializations for component inter_analyzer_colimator_19_blade_0. */
  SIG_MESSAGE("inter_analyzer_colimator_19_blade_0 (Init)");
#define mccompcurname  inter_analyzer_colimator_19_blade_0
#define mccompcurtype  Union_box
#define mccompcurindex 877
#define loop_index mccinter_analyzer_colimator_19_blade_0_loop_index
#define this_box_volume mccinter_analyzer_colimator_19_blade_0_this_box_volume
#define global_geometry_element mccinter_analyzer_colimator_19_blade_0_global_geometry_element
#define this_box_storage mccinter_analyzer_colimator_19_blade_0_this_box_storage
#define material_string mccinter_analyzer_colimator_19_blade_0_material_string
#define priority mccinter_analyzer_colimator_19_blade_0_priority
#define xwidth mccinter_analyzer_colimator_19_blade_0_xwidth
#define yheight mccinter_analyzer_colimator_19_blade_0_yheight
#define zdepth mccinter_analyzer_colimator_19_blade_0_zdepth
#define xwidth2 mccinter_analyzer_colimator_19_blade_0_xwidth2
#define yheight2 mccinter_analyzer_colimator_19_blade_0_yheight2
#define visualize mccinter_analyzer_colimator_19_blade_0_visualize
#define target_index mccinter_analyzer_colimator_19_blade_0_target_index
#define target_x mccinter_analyzer_colimator_19_blade_0_target_x
#define target_y mccinter_analyzer_colimator_19_blade_0_target_y
#define target_z mccinter_analyzer_colimator_19_blade_0_target_z
#define focus_aw mccinter_analyzer_colimator_19_blade_0_focus_aw
#define focus_ah mccinter_analyzer_colimator_19_blade_0_focus_ah
#define focus_xw mccinter_analyzer_colimator_19_blade_0_focus_xw
#define focus_xh mccinter_analyzer_colimator_19_blade_0_focus_xh
#define focus_r mccinter_analyzer_colimator_19_blade_0_focus_r
#define p_interact mccinter_analyzer_colimator_19_blade_0_p_interact
#define mask_string mccinter_analyzer_colimator_19_blade_0_mask_string
#define mask_setting mccinter_analyzer_colimator_19_blade_0_mask_setting
#define number_of_activations mccinter_analyzer_colimator_19_blade_0_number_of_activations
#line 224 "Union_box.comp"
{
// Initializes the focusing system for this volume including input sanitation.
focus_initialize(&this_box_volume.geometry, POS_A_COMP_INDEX(INDEX_CURRENT_COMP+target_index), POS_A_CURRENT_COMP, ROT_A_CURRENT_COMP, target_index, target_x, target_y, target_z, focus_aw, focus_ah, focus_xw, focus_xh, focus_r, NAME_CURRENT_COMP);

// Input sanitation for this geometry
if (xwidth <= 0) {
  printf("\nERROR in Union_box named %s, the xwidth is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (yheight <= 0) {
  printf("\nERROR in Union_box named %s, yheight is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (zdepth <= 0) {
  printf("\nERROR in Union_box named %s, zdepth is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (xwidth2 <= 0 && xwidth2 != -1) {
  printf("\nERROR in Union_box named %s, the xwidth2 is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (yheight2 <= 0 && yheight2 != -1) {
  printf("\nERROR in Union_box named %s, yheight2 is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}

// Use sanitation
if (global_material_list.num_elements == 0) {
  printf("\nERROR: Need to define a material using Union_make_material before using a Union geometry component. \n");
  printf("       %s was defined before first use of Union_make_material.\n",NAME_CURRENT_COMP);
  exit(1);
}

this_box_volume.geometry.is_masked_volume = 0;
this_box_volume.geometry.is_exit_volume = 0;
this_box_volume.geometry.is_mask_volume = 0;
// check if the volume is a mask, if it is the material string is irelevant.
if (mask_string && strlen(mask_string) && strcmp(mask_string, "NULL") && strcmp(mask_string, "0")) {
    // A mask volume is used to limit the extend of other volumes, called the masked volumes. These are specified in the mask_string.
    // In order for a ray to enter a masked volume, it needs to be both in the region covered by that volume AND the mask volume.
    // When more than
    this_box_volume.geometry.mask_mode = 1; // Default is mask mode is ALL
    if (mask_setting && strlen(mask_setting) && strcmp(mask_setting, "NULL") && strcmp(mask_setting, "0")) {
        if (strcmp(mask_setting,"ALL") == 0 || strcmp(mask_setting,"All") == 0) this_box_volume.geometry.mask_mode = 1;
        else if (strcmp(mask_setting,"ANY") == 0 || strcmp(mask_setting,"Any") == 0) this_box_volume.geometry.mask_mode = 2;
        else {
            printf("The mask_mode of component %s is set to %s, but must be either ALL or ANY.\n",NAME_CURRENT_COMP,mask_setting);
            exit(1);
        }
    }
    
    for (loop_index=0;loop_index<global_geometry_list.num_elements;loop_index++) {
        // Add mask list
        if (1 == manual_linking_function(global_geometry_list.elements[loop_index].name,mask_string)) {
            add_element_to_int_list(&this_box_volume.geometry.mask_list,global_geometry_list.elements[loop_index].component_index);
            add_element_to_int_list(&global_geometry_list.elements[loop_index].Volume->geometry.masked_by_list,INDEX_CURRENT_COMP);
            global_geometry_list.elements[loop_index].Volume->geometry.is_masked_volume = 1;
            if (this_box_volume.geometry.mask_mode == 2)
                global_geometry_list.elements[loop_index].Volume->geometry.mask_mode = 2;
            if (this_box_volume.geometry.mask_mode == 1) {
                if (global_geometry_list.elements[loop_index].Volume->geometry.is_masked_volume == 1 && global_geometry_list.elements[loop_index].Volume->geometry.mask_mode != 2)
                    // If more than one mask is added to one volume, the ANY mode overwrites the (default) ALL mode.
                    global_geometry_list.elements[loop_index].Volume->geometry.mask_mode = 1;
            }
            
            found_geometries = 1;
        }
    }
    if (found_geometries == 0) {
        printf("The mask_string in geometry: %s did not find any of the specified volumes in the mask_string %s \n",NAME_CURRENT_COMP,mask_string);
        exit(1);
    }
    this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
    this_box_volume.p_physics->is_vacuum = 0; // Makes this volume a vacuum
    this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
    this_box_volume.p_physics->my_a = 0; // Should not be used.
    sprintf(this_box_volume.p_physics->name,"Mask");
    this_box_volume.geometry.is_mask_volume = 1;
    
    
// Read the material input, or if it lacks, use automatic linking.
} else if (material_string && strlen(material_string) && strcmp(material_string, "NULL") && strcmp(material_string, "0")) {
    // A geometry string was given, use it to determine which material
    if (0 == strcmp(material_string,"vacuum") || 0 == strcmp(material_string,"Vacuum")) {
        // One could have a global physics struct for vacuum instead of creating one for each
        this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
        this_box_volume.p_physics->is_vacuum = 1; // Makes this volume a vacuum
        this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
        this_box_volume.p_physics->my_a = 0; // Should not be used.
        sprintf(this_box_volume.p_physics->name,"Vacuum");
    } else if (0 == strcmp(material_string,"exit") || 0 == strcmp(material_string,"Exit")) {
        // One could have a global physics struct for vacuum instead of creating one for each
        this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
        this_box_volume.p_physics->is_vacuum = 1; // Makes this volume a vacuum
        this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
        this_box_volume.p_physics->my_a = 0; // Should not be used.
        this_box_volume.geometry.is_exit_volume = 1;
        sprintf(this_box_volume.p_physics->name,"Exit");
    } else {
        #ifndef MATERIAL_DETECTOR
            printf("Need to define a material before refering to it in a geometry %s.\n",NAME_CURRENT_COMP);
            exit(1);
        #endif
        for (loop_index=0;loop_index<global_material_list.num_elements;loop_index++) {
            if (0 == strcmp(material_string,global_material_list.elements[loop_index].name)) {
                this_box_volume.p_physics = global_material_list.elements[loop_index].physics;
                break;
            }
            if (loop_index == global_material_list.num_elements-1) {
            printf("\n");
            printf("ERROR: The material string \"%s\" in Union geometry \"%s\" did not match a specified material. \n",material_string,NAME_CURRENT_COMP);
            printf("       The materials available at this point (need to be defined before the geometry): \n");
            for (loop_index=0;loop_index<global_material_list.num_elements;loop_index++)
              printf("         %s\n",global_material_list.elements[loop_index].name);
            printf("\n");
            printf("       It is also possible to use one of the defualt materials avaiable: \n");
            printf("           Vacuum (for a Volume without scattering or absorption)\n");
            printf("           Exit (for a Volume where the ray exits the component if it enters)\n");
            printf("           Mask (for a Volume that masks existing volumes specified in the mask_string\n");
            exit(1);
          }
        }
    }
} else {
    // Automatic linking, simply using the last defined material.
    #ifndef MATERIAL_DETECTOR
        printf("Need to define a material before the geometry to use automatic linking %s.\n",NAME_CURRENT_COMP);
        exit(1);
    #endif
    this_box_volume.p_physics = global_material_list.elements[global_material_list.num_elements-1].physics;
}

sprintf(this_box_volume.name,NAME_CURRENT_COMP);
sprintf(this_box_volume.geometry.shape,"box");
this_box_volume.geometry.priority_value = priority;
this_box_volume.geometry.geometry_p_interact = p_interact;
// Currently the coordinates will be in absolute space.
this_box_volume.geometry.center = POS_A_CURRENT_COMP;

this_box_storage.z_depth = zdepth;
this_box_storage.x_width1 = xwidth;
this_box_storage.y_height1 = yheight;

this_box_storage.is_rectangle = 0;
if (xwidth2 < 0 && yheight2 < 0) this_box_storage.is_rectangle = 1;
if (xwidth == xwidth2 && yheight == yheight2) this_box_storage.is_rectangle = 1;

if (xwidth2 < 0) {
    this_box_storage.x_width2 = xwidth;
    xwidth2 = xwidth;
} else this_box_storage.x_width2 = xwidth2;

if (yheight2 < 0) {
    this_box_storage.y_height2 = yheight;
    yheight2 = yheight;
} else this_box_storage.y_height2 = yheight2;


this_box_storage.normal_vectors[0] = coords_set(0,0,1);
this_box_storage.normal_vectors[1] = coords_set(0,0,1);

// for sides with y component = 0
x_component = 2*zdepth/sqrt((xwidth-xwidth2)*(xwidth-xwidth2)+4*zdepth*zdepth);
z_component = (xwidth-xwidth2)/sqrt(4*zdepth*zdepth+(xwidth-xwidth2)*(xwidth-xwidth2));

this_box_storage.normal_vectors[2] = coords_set(x_component,0,z_component);
this_box_storage.normal_vectors[3] = coords_set(-x_component,0,z_component);

// for sides with x component = 0
y_component = 2*zdepth/sqrt((yheight-yheight2)*(yheight-yheight2)+4*zdepth*zdepth);
z_component = (yheight-yheight2)/sqrt(4*zdepth*zdepth+(yheight-yheight2)*(yheight-yheight2));

this_box_storage.normal_vectors[4] = coords_set(0,y_component,z_component);
this_box_storage.normal_vectors[5] = coords_set(0,-y_component,z_component);

this_box_volume.geometry.visualization_on = visualize;

this_box_volume.geometry.geometry_parameters.p_box_storage = &this_box_storage;

// Assign pointers to functions for intersection with the shape, checking if a point is inside the shape
if (this_box_storage.is_rectangle == 1) {
this_box_volume.geometry.intersect_function = &sample_box_intersect_simple;
this_box_volume.geometry.within_function = &r_within_box_simple;
}
else {
this_box_volume.geometry.intersect_function = &sample_box_intersect_advanced;
this_box_volume.geometry.within_function = &r_within_box_advanced;
}

this_box_volume.geometry.shell_points = &box_shell_points;
this_box_volume.geometry.mcdisplay_function = &mcdisplay_box_function;
this_box_volume.geometry.initialize_from_main_function = &initialize_box_geometry_from_main_component;
this_box_volume.geometry.process_rot_allocated = 0;

this_box_volume.geometry.copy_geometry_parameters = &allocate_box_storage_copy;

rot_copy(this_box_volume.geometry.rotation_matrix,ROT_A_CURRENT_COMP); //check how ROT_R_CURRENT_COMP would work
rot_transpose(ROT_A_CURRENT_COMP,this_box_volume.geometry.transpose_rotation_matrix);

// Initialize loggers
this_box_volume.loggers.num_elements = 0;

// packing the information into the global_geometry_element, which is then included in the global_geometry_list.
sprintf(global_geometry_element.name,NAME_CURRENT_COMP);
global_geometry_element.activation_counter = number_of_activations;
global_geometry_element.component_index = INDEX_CURRENT_COMP;
global_geometry_element.Volume = &this_box_volume; // Would be nicer if this m was a pointer, now we have the (small) data two places
add_element_to_geometry_list(&global_geometry_list,global_geometry_element);
}
#line 339074 "MACS_sample_kidney_box.c"
#undef number_of_activations
#undef mask_setting
#undef mask_string
#undef p_interact
#undef focus_r
#undef focus_xh
#undef focus_xw
#undef focus_ah
#undef focus_aw
#undef target_z
#undef target_y
#undef target_x
#undef target_index
#undef visualize
#undef yheight2
#undef xwidth2
#undef zdepth
#undef yheight
#undef xwidth
#undef priority
#undef material_string
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

  /* Initializations for component inter_analyzer_colimator_19_blade_1. */
  SIG_MESSAGE("inter_analyzer_colimator_19_blade_1 (Init)");
#define mccompcurname  inter_analyzer_colimator_19_blade_1
#define mccompcurtype  Union_box
#define mccompcurindex 878
#define loop_index mccinter_analyzer_colimator_19_blade_1_loop_index
#define this_box_volume mccinter_analyzer_colimator_19_blade_1_this_box_volume
#define global_geometry_element mccinter_analyzer_colimator_19_blade_1_global_geometry_element
#define this_box_storage mccinter_analyzer_colimator_19_blade_1_this_box_storage
#define material_string mccinter_analyzer_colimator_19_blade_1_material_string
#define priority mccinter_analyzer_colimator_19_blade_1_priority
#define xwidth mccinter_analyzer_colimator_19_blade_1_xwidth
#define yheight mccinter_analyzer_colimator_19_blade_1_yheight
#define zdepth mccinter_analyzer_colimator_19_blade_1_zdepth
#define xwidth2 mccinter_analyzer_colimator_19_blade_1_xwidth2
#define yheight2 mccinter_analyzer_colimator_19_blade_1_yheight2
#define visualize mccinter_analyzer_colimator_19_blade_1_visualize
#define target_index mccinter_analyzer_colimator_19_blade_1_target_index
#define target_x mccinter_analyzer_colimator_19_blade_1_target_x
#define target_y mccinter_analyzer_colimator_19_blade_1_target_y
#define target_z mccinter_analyzer_colimator_19_blade_1_target_z
#define focus_aw mccinter_analyzer_colimator_19_blade_1_focus_aw
#define focus_ah mccinter_analyzer_colimator_19_blade_1_focus_ah
#define focus_xw mccinter_analyzer_colimator_19_blade_1_focus_xw
#define focus_xh mccinter_analyzer_colimator_19_blade_1_focus_xh
#define focus_r mccinter_analyzer_colimator_19_blade_1_focus_r
#define p_interact mccinter_analyzer_colimator_19_blade_1_p_interact
#define mask_string mccinter_analyzer_colimator_19_blade_1_mask_string
#define mask_setting mccinter_analyzer_colimator_19_blade_1_mask_setting
#define number_of_activations mccinter_analyzer_colimator_19_blade_1_number_of_activations
#line 224 "Union_box.comp"
{
// Initializes the focusing system for this volume including input sanitation.
focus_initialize(&this_box_volume.geometry, POS_A_COMP_INDEX(INDEX_CURRENT_COMP+target_index), POS_A_CURRENT_COMP, ROT_A_CURRENT_COMP, target_index, target_x, target_y, target_z, focus_aw, focus_ah, focus_xw, focus_xh, focus_r, NAME_CURRENT_COMP);

// Input sanitation for this geometry
if (xwidth <= 0) {
  printf("\nERROR in Union_box named %s, the xwidth is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (yheight <= 0) {
  printf("\nERROR in Union_box named %s, yheight is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (zdepth <= 0) {
  printf("\nERROR in Union_box named %s, zdepth is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (xwidth2 <= 0 && xwidth2 != -1) {
  printf("\nERROR in Union_box named %s, the xwidth2 is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (yheight2 <= 0 && yheight2 != -1) {
  printf("\nERROR in Union_box named %s, yheight2 is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}

// Use sanitation
if (global_material_list.num_elements == 0) {
  printf("\nERROR: Need to define a material using Union_make_material before using a Union geometry component. \n");
  printf("       %s was defined before first use of Union_make_material.\n",NAME_CURRENT_COMP);
  exit(1);
}

this_box_volume.geometry.is_masked_volume = 0;
this_box_volume.geometry.is_exit_volume = 0;
this_box_volume.geometry.is_mask_volume = 0;
// check if the volume is a mask, if it is the material string is irelevant.
if (mask_string && strlen(mask_string) && strcmp(mask_string, "NULL") && strcmp(mask_string, "0")) {
    // A mask volume is used to limit the extend of other volumes, called the masked volumes. These are specified in the mask_string.
    // In order for a ray to enter a masked volume, it needs to be both in the region covered by that volume AND the mask volume.
    // When more than
    this_box_volume.geometry.mask_mode = 1; // Default is mask mode is ALL
    if (mask_setting && strlen(mask_setting) && strcmp(mask_setting, "NULL") && strcmp(mask_setting, "0")) {
        if (strcmp(mask_setting,"ALL") == 0 || strcmp(mask_setting,"All") == 0) this_box_volume.geometry.mask_mode = 1;
        else if (strcmp(mask_setting,"ANY") == 0 || strcmp(mask_setting,"Any") == 0) this_box_volume.geometry.mask_mode = 2;
        else {
            printf("The mask_mode of component %s is set to %s, but must be either ALL or ANY.\n",NAME_CURRENT_COMP,mask_setting);
            exit(1);
        }
    }
    
    for (loop_index=0;loop_index<global_geometry_list.num_elements;loop_index++) {
        // Add mask list
        if (1 == manual_linking_function(global_geometry_list.elements[loop_index].name,mask_string)) {
            add_element_to_int_list(&this_box_volume.geometry.mask_list,global_geometry_list.elements[loop_index].component_index);
            add_element_to_int_list(&global_geometry_list.elements[loop_index].Volume->geometry.masked_by_list,INDEX_CURRENT_COMP);
            global_geometry_list.elements[loop_index].Volume->geometry.is_masked_volume = 1;
            if (this_box_volume.geometry.mask_mode == 2)
                global_geometry_list.elements[loop_index].Volume->geometry.mask_mode = 2;
            if (this_box_volume.geometry.mask_mode == 1) {
                if (global_geometry_list.elements[loop_index].Volume->geometry.is_masked_volume == 1 && global_geometry_list.elements[loop_index].Volume->geometry.mask_mode != 2)
                    // If more than one mask is added to one volume, the ANY mode overwrites the (default) ALL mode.
                    global_geometry_list.elements[loop_index].Volume->geometry.mask_mode = 1;
            }
            
            found_geometries = 1;
        }
    }
    if (found_geometries == 0) {
        printf("The mask_string in geometry: %s did not find any of the specified volumes in the mask_string %s \n",NAME_CURRENT_COMP,mask_string);
        exit(1);
    }
    this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
    this_box_volume.p_physics->is_vacuum = 0; // Makes this volume a vacuum
    this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
    this_box_volume.p_physics->my_a = 0; // Should not be used.
    sprintf(this_box_volume.p_physics->name,"Mask");
    this_box_volume.geometry.is_mask_volume = 1;
    
    
// Read the material input, or if it lacks, use automatic linking.
} else if (material_string && strlen(material_string) && strcmp(material_string, "NULL") && strcmp(material_string, "0")) {
    // A geometry string was given, use it to determine which material
    if (0 == strcmp(material_string,"vacuum") || 0 == strcmp(material_string,"Vacuum")) {
        // One could have a global physics struct for vacuum instead of creating one for each
        this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
        this_box_volume.p_physics->is_vacuum = 1; // Makes this volume a vacuum
        this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
        this_box_volume.p_physics->my_a = 0; // Should not be used.
        sprintf(this_box_volume.p_physics->name,"Vacuum");
    } else if (0 == strcmp(material_string,"exit") || 0 == strcmp(material_string,"Exit")) {
        // One could have a global physics struct for vacuum instead of creating one for each
        this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
        this_box_volume.p_physics->is_vacuum = 1; // Makes this volume a vacuum
        this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
        this_box_volume.p_physics->my_a = 0; // Should not be used.
        this_box_volume.geometry.is_exit_volume = 1;
        sprintf(this_box_volume.p_physics->name,"Exit");
    } else {
        #ifndef MATERIAL_DETECTOR
            printf("Need to define a material before refering to it in a geometry %s.\n",NAME_CURRENT_COMP);
            exit(1);
        #endif
        for (loop_index=0;loop_index<global_material_list.num_elements;loop_index++) {
            if (0 == strcmp(material_string,global_material_list.elements[loop_index].name)) {
                this_box_volume.p_physics = global_material_list.elements[loop_index].physics;
                break;
            }
            if (loop_index == global_material_list.num_elements-1) {
            printf("\n");
            printf("ERROR: The material string \"%s\" in Union geometry \"%s\" did not match a specified material. \n",material_string,NAME_CURRENT_COMP);
            printf("       The materials available at this point (need to be defined before the geometry): \n");
            for (loop_index=0;loop_index<global_material_list.num_elements;loop_index++)
              printf("         %s\n",global_material_list.elements[loop_index].name);
            printf("\n");
            printf("       It is also possible to use one of the defualt materials avaiable: \n");
            printf("           Vacuum (for a Volume without scattering or absorption)\n");
            printf("           Exit (for a Volume where the ray exits the component if it enters)\n");
            printf("           Mask (for a Volume that masks existing volumes specified in the mask_string\n");
            exit(1);
          }
        }
    }
} else {
    // Automatic linking, simply using the last defined material.
    #ifndef MATERIAL_DETECTOR
        printf("Need to define a material before the geometry to use automatic linking %s.\n",NAME_CURRENT_COMP);
        exit(1);
    #endif
    this_box_volume.p_physics = global_material_list.elements[global_material_list.num_elements-1].physics;
}

sprintf(this_box_volume.name,NAME_CURRENT_COMP);
sprintf(this_box_volume.geometry.shape,"box");
this_box_volume.geometry.priority_value = priority;
this_box_volume.geometry.geometry_p_interact = p_interact;
// Currently the coordinates will be in absolute space.
this_box_volume.geometry.center = POS_A_CURRENT_COMP;

this_box_storage.z_depth = zdepth;
this_box_storage.x_width1 = xwidth;
this_box_storage.y_height1 = yheight;

this_box_storage.is_rectangle = 0;
if (xwidth2 < 0 && yheight2 < 0) this_box_storage.is_rectangle = 1;
if (xwidth == xwidth2 && yheight == yheight2) this_box_storage.is_rectangle = 1;

if (xwidth2 < 0) {
    this_box_storage.x_width2 = xwidth;
    xwidth2 = xwidth;
} else this_box_storage.x_width2 = xwidth2;

if (yheight2 < 0) {
    this_box_storage.y_height2 = yheight;
    yheight2 = yheight;
} else this_box_storage.y_height2 = yheight2;


this_box_storage.normal_vectors[0] = coords_set(0,0,1);
this_box_storage.normal_vectors[1] = coords_set(0,0,1);

// for sides with y component = 0
x_component = 2*zdepth/sqrt((xwidth-xwidth2)*(xwidth-xwidth2)+4*zdepth*zdepth);
z_component = (xwidth-xwidth2)/sqrt(4*zdepth*zdepth+(xwidth-xwidth2)*(xwidth-xwidth2));

this_box_storage.normal_vectors[2] = coords_set(x_component,0,z_component);
this_box_storage.normal_vectors[3] = coords_set(-x_component,0,z_component);

// for sides with x component = 0
y_component = 2*zdepth/sqrt((yheight-yheight2)*(yheight-yheight2)+4*zdepth*zdepth);
z_component = (yheight-yheight2)/sqrt(4*zdepth*zdepth+(yheight-yheight2)*(yheight-yheight2));

this_box_storage.normal_vectors[4] = coords_set(0,y_component,z_component);
this_box_storage.normal_vectors[5] = coords_set(0,-y_component,z_component);

this_box_volume.geometry.visualization_on = visualize;

this_box_volume.geometry.geometry_parameters.p_box_storage = &this_box_storage;

// Assign pointers to functions for intersection with the shape, checking if a point is inside the shape
if (this_box_storage.is_rectangle == 1) {
this_box_volume.geometry.intersect_function = &sample_box_intersect_simple;
this_box_volume.geometry.within_function = &r_within_box_simple;
}
else {
this_box_volume.geometry.intersect_function = &sample_box_intersect_advanced;
this_box_volume.geometry.within_function = &r_within_box_advanced;
}

this_box_volume.geometry.shell_points = &box_shell_points;
this_box_volume.geometry.mcdisplay_function = &mcdisplay_box_function;
this_box_volume.geometry.initialize_from_main_function = &initialize_box_geometry_from_main_component;
this_box_volume.geometry.process_rot_allocated = 0;

this_box_volume.geometry.copy_geometry_parameters = &allocate_box_storage_copy;

rot_copy(this_box_volume.geometry.rotation_matrix,ROT_A_CURRENT_COMP); //check how ROT_R_CURRENT_COMP would work
rot_transpose(ROT_A_CURRENT_COMP,this_box_volume.geometry.transpose_rotation_matrix);

// Initialize loggers
this_box_volume.loggers.num_elements = 0;

// packing the information into the global_geometry_element, which is then included in the global_geometry_list.
sprintf(global_geometry_element.name,NAME_CURRENT_COMP);
global_geometry_element.activation_counter = number_of_activations;
global_geometry_element.component_index = INDEX_CURRENT_COMP;
global_geometry_element.Volume = &this_box_volume; // Would be nicer if this m was a pointer, now we have the (small) data two places
add_element_to_geometry_list(&global_geometry_list,global_geometry_element);
}
#line 339344 "MACS_sample_kidney_box.c"
#undef number_of_activations
#undef mask_setting
#undef mask_string
#undef p_interact
#undef focus_r
#undef focus_xh
#undef focus_xw
#undef focus_ah
#undef focus_aw
#undef target_z
#undef target_y
#undef target_x
#undef target_index
#undef visualize
#undef yheight2
#undef xwidth2
#undef zdepth
#undef yheight
#undef xwidth
#undef priority
#undef material_string
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

  /* Initializations for component inter_analyzer_colimator_19_blade_2. */
  SIG_MESSAGE("inter_analyzer_colimator_19_blade_2 (Init)");
#define mccompcurname  inter_analyzer_colimator_19_blade_2
#define mccompcurtype  Union_box
#define mccompcurindex 879
#define loop_index mccinter_analyzer_colimator_19_blade_2_loop_index
#define this_box_volume mccinter_analyzer_colimator_19_blade_2_this_box_volume
#define global_geometry_element mccinter_analyzer_colimator_19_blade_2_global_geometry_element
#define this_box_storage mccinter_analyzer_colimator_19_blade_2_this_box_storage
#define material_string mccinter_analyzer_colimator_19_blade_2_material_string
#define priority mccinter_analyzer_colimator_19_blade_2_priority
#define xwidth mccinter_analyzer_colimator_19_blade_2_xwidth
#define yheight mccinter_analyzer_colimator_19_blade_2_yheight
#define zdepth mccinter_analyzer_colimator_19_blade_2_zdepth
#define xwidth2 mccinter_analyzer_colimator_19_blade_2_xwidth2
#define yheight2 mccinter_analyzer_colimator_19_blade_2_yheight2
#define visualize mccinter_analyzer_colimator_19_blade_2_visualize
#define target_index mccinter_analyzer_colimator_19_blade_2_target_index
#define target_x mccinter_analyzer_colimator_19_blade_2_target_x
#define target_y mccinter_analyzer_colimator_19_blade_2_target_y
#define target_z mccinter_analyzer_colimator_19_blade_2_target_z
#define focus_aw mccinter_analyzer_colimator_19_blade_2_focus_aw
#define focus_ah mccinter_analyzer_colimator_19_blade_2_focus_ah
#define focus_xw mccinter_analyzer_colimator_19_blade_2_focus_xw
#define focus_xh mccinter_analyzer_colimator_19_blade_2_focus_xh
#define focus_r mccinter_analyzer_colimator_19_blade_2_focus_r
#define p_interact mccinter_analyzer_colimator_19_blade_2_p_interact
#define mask_string mccinter_analyzer_colimator_19_blade_2_mask_string
#define mask_setting mccinter_analyzer_colimator_19_blade_2_mask_setting
#define number_of_activations mccinter_analyzer_colimator_19_blade_2_number_of_activations
#line 224 "Union_box.comp"
{
// Initializes the focusing system for this volume including input sanitation.
focus_initialize(&this_box_volume.geometry, POS_A_COMP_INDEX(INDEX_CURRENT_COMP+target_index), POS_A_CURRENT_COMP, ROT_A_CURRENT_COMP, target_index, target_x, target_y, target_z, focus_aw, focus_ah, focus_xw, focus_xh, focus_r, NAME_CURRENT_COMP);

// Input sanitation for this geometry
if (xwidth <= 0) {
  printf("\nERROR in Union_box named %s, the xwidth is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (yheight <= 0) {
  printf("\nERROR in Union_box named %s, yheight is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (zdepth <= 0) {
  printf("\nERROR in Union_box named %s, zdepth is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (xwidth2 <= 0 && xwidth2 != -1) {
  printf("\nERROR in Union_box named %s, the xwidth2 is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (yheight2 <= 0 && yheight2 != -1) {
  printf("\nERROR in Union_box named %s, yheight2 is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}

// Use sanitation
if (global_material_list.num_elements == 0) {
  printf("\nERROR: Need to define a material using Union_make_material before using a Union geometry component. \n");
  printf("       %s was defined before first use of Union_make_material.\n",NAME_CURRENT_COMP);
  exit(1);
}

this_box_volume.geometry.is_masked_volume = 0;
this_box_volume.geometry.is_exit_volume = 0;
this_box_volume.geometry.is_mask_volume = 0;
// check if the volume is a mask, if it is the material string is irelevant.
if (mask_string && strlen(mask_string) && strcmp(mask_string, "NULL") && strcmp(mask_string, "0")) {
    // A mask volume is used to limit the extend of other volumes, called the masked volumes. These are specified in the mask_string.
    // In order for a ray to enter a masked volume, it needs to be both in the region covered by that volume AND the mask volume.
    // When more than
    this_box_volume.geometry.mask_mode = 1; // Default is mask mode is ALL
    if (mask_setting && strlen(mask_setting) && strcmp(mask_setting, "NULL") && strcmp(mask_setting, "0")) {
        if (strcmp(mask_setting,"ALL") == 0 || strcmp(mask_setting,"All") == 0) this_box_volume.geometry.mask_mode = 1;
        else if (strcmp(mask_setting,"ANY") == 0 || strcmp(mask_setting,"Any") == 0) this_box_volume.geometry.mask_mode = 2;
        else {
            printf("The mask_mode of component %s is set to %s, but must be either ALL or ANY.\n",NAME_CURRENT_COMP,mask_setting);
            exit(1);
        }
    }
    
    for (loop_index=0;loop_index<global_geometry_list.num_elements;loop_index++) {
        // Add mask list
        if (1 == manual_linking_function(global_geometry_list.elements[loop_index].name,mask_string)) {
            add_element_to_int_list(&this_box_volume.geometry.mask_list,global_geometry_list.elements[loop_index].component_index);
            add_element_to_int_list(&global_geometry_list.elements[loop_index].Volume->geometry.masked_by_list,INDEX_CURRENT_COMP);
            global_geometry_list.elements[loop_index].Volume->geometry.is_masked_volume = 1;
            if (this_box_volume.geometry.mask_mode == 2)
                global_geometry_list.elements[loop_index].Volume->geometry.mask_mode = 2;
            if (this_box_volume.geometry.mask_mode == 1) {
                if (global_geometry_list.elements[loop_index].Volume->geometry.is_masked_volume == 1 && global_geometry_list.elements[loop_index].Volume->geometry.mask_mode != 2)
                    // If more than one mask is added to one volume, the ANY mode overwrites the (default) ALL mode.
                    global_geometry_list.elements[loop_index].Volume->geometry.mask_mode = 1;
            }
            
            found_geometries = 1;
        }
    }
    if (found_geometries == 0) {
        printf("The mask_string in geometry: %s did not find any of the specified volumes in the mask_string %s \n",NAME_CURRENT_COMP,mask_string);
        exit(1);
    }
    this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
    this_box_volume.p_physics->is_vacuum = 0; // Makes this volume a vacuum
    this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
    this_box_volume.p_physics->my_a = 0; // Should not be used.
    sprintf(this_box_volume.p_physics->name,"Mask");
    this_box_volume.geometry.is_mask_volume = 1;
    
    
// Read the material input, or if it lacks, use automatic linking.
} else if (material_string && strlen(material_string) && strcmp(material_string, "NULL") && strcmp(material_string, "0")) {
    // A geometry string was given, use it to determine which material
    if (0 == strcmp(material_string,"vacuum") || 0 == strcmp(material_string,"Vacuum")) {
        // One could have a global physics struct for vacuum instead of creating one for each
        this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
        this_box_volume.p_physics->is_vacuum = 1; // Makes this volume a vacuum
        this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
        this_box_volume.p_physics->my_a = 0; // Should not be used.
        sprintf(this_box_volume.p_physics->name,"Vacuum");
    } else if (0 == strcmp(material_string,"exit") || 0 == strcmp(material_string,"Exit")) {
        // One could have a global physics struct for vacuum instead of creating one for each
        this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
        this_box_volume.p_physics->is_vacuum = 1; // Makes this volume a vacuum
        this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
        this_box_volume.p_physics->my_a = 0; // Should not be used.
        this_box_volume.geometry.is_exit_volume = 1;
        sprintf(this_box_volume.p_physics->name,"Exit");
    } else {
        #ifndef MATERIAL_DETECTOR
            printf("Need to define a material before refering to it in a geometry %s.\n",NAME_CURRENT_COMP);
            exit(1);
        #endif
        for (loop_index=0;loop_index<global_material_list.num_elements;loop_index++) {
            if (0 == strcmp(material_string,global_material_list.elements[loop_index].name)) {
                this_box_volume.p_physics = global_material_list.elements[loop_index].physics;
                break;
            }
            if (loop_index == global_material_list.num_elements-1) {
            printf("\n");
            printf("ERROR: The material string \"%s\" in Union geometry \"%s\" did not match a specified material. \n",material_string,NAME_CURRENT_COMP);
            printf("       The materials available at this point (need to be defined before the geometry): \n");
            for (loop_index=0;loop_index<global_material_list.num_elements;loop_index++)
              printf("         %s\n",global_material_list.elements[loop_index].name);
            printf("\n");
            printf("       It is also possible to use one of the defualt materials avaiable: \n");
            printf("           Vacuum (for a Volume without scattering or absorption)\n");
            printf("           Exit (for a Volume where the ray exits the component if it enters)\n");
            printf("           Mask (for a Volume that masks existing volumes specified in the mask_string\n");
            exit(1);
          }
        }
    }
} else {
    // Automatic linking, simply using the last defined material.
    #ifndef MATERIAL_DETECTOR
        printf("Need to define a material before the geometry to use automatic linking %s.\n",NAME_CURRENT_COMP);
        exit(1);
    #endif
    this_box_volume.p_physics = global_material_list.elements[global_material_list.num_elements-1].physics;
}

sprintf(this_box_volume.name,NAME_CURRENT_COMP);
sprintf(this_box_volume.geometry.shape,"box");
this_box_volume.geometry.priority_value = priority;
this_box_volume.geometry.geometry_p_interact = p_interact;
// Currently the coordinates will be in absolute space.
this_box_volume.geometry.center = POS_A_CURRENT_COMP;

this_box_storage.z_depth = zdepth;
this_box_storage.x_width1 = xwidth;
this_box_storage.y_height1 = yheight;

this_box_storage.is_rectangle = 0;
if (xwidth2 < 0 && yheight2 < 0) this_box_storage.is_rectangle = 1;
if (xwidth == xwidth2 && yheight == yheight2) this_box_storage.is_rectangle = 1;

if (xwidth2 < 0) {
    this_box_storage.x_width2 = xwidth;
    xwidth2 = xwidth;
} else this_box_storage.x_width2 = xwidth2;

if (yheight2 < 0) {
    this_box_storage.y_height2 = yheight;
    yheight2 = yheight;
} else this_box_storage.y_height2 = yheight2;


this_box_storage.normal_vectors[0] = coords_set(0,0,1);
this_box_storage.normal_vectors[1] = coords_set(0,0,1);

// for sides with y component = 0
x_component = 2*zdepth/sqrt((xwidth-xwidth2)*(xwidth-xwidth2)+4*zdepth*zdepth);
z_component = (xwidth-xwidth2)/sqrt(4*zdepth*zdepth+(xwidth-xwidth2)*(xwidth-xwidth2));

this_box_storage.normal_vectors[2] = coords_set(x_component,0,z_component);
this_box_storage.normal_vectors[3] = coords_set(-x_component,0,z_component);

// for sides with x component = 0
y_component = 2*zdepth/sqrt((yheight-yheight2)*(yheight-yheight2)+4*zdepth*zdepth);
z_component = (yheight-yheight2)/sqrt(4*zdepth*zdepth+(yheight-yheight2)*(yheight-yheight2));

this_box_storage.normal_vectors[4] = coords_set(0,y_component,z_component);
this_box_storage.normal_vectors[5] = coords_set(0,-y_component,z_component);

this_box_volume.geometry.visualization_on = visualize;

this_box_volume.geometry.geometry_parameters.p_box_storage = &this_box_storage;

// Assign pointers to functions for intersection with the shape, checking if a point is inside the shape
if (this_box_storage.is_rectangle == 1) {
this_box_volume.geometry.intersect_function = &sample_box_intersect_simple;
this_box_volume.geometry.within_function = &r_within_box_simple;
}
else {
this_box_volume.geometry.intersect_function = &sample_box_intersect_advanced;
this_box_volume.geometry.within_function = &r_within_box_advanced;
}

this_box_volume.geometry.shell_points = &box_shell_points;
this_box_volume.geometry.mcdisplay_function = &mcdisplay_box_function;
this_box_volume.geometry.initialize_from_main_function = &initialize_box_geometry_from_main_component;
this_box_volume.geometry.process_rot_allocated = 0;

this_box_volume.geometry.copy_geometry_parameters = &allocate_box_storage_copy;

rot_copy(this_box_volume.geometry.rotation_matrix,ROT_A_CURRENT_COMP); //check how ROT_R_CURRENT_COMP would work
rot_transpose(ROT_A_CURRENT_COMP,this_box_volume.geometry.transpose_rotation_matrix);

// Initialize loggers
this_box_volume.loggers.num_elements = 0;

// packing the information into the global_geometry_element, which is then included in the global_geometry_list.
sprintf(global_geometry_element.name,NAME_CURRENT_COMP);
global_geometry_element.activation_counter = number_of_activations;
global_geometry_element.component_index = INDEX_CURRENT_COMP;
global_geometry_element.Volume = &this_box_volume; // Would be nicer if this m was a pointer, now we have the (small) data two places
add_element_to_geometry_list(&global_geometry_list,global_geometry_element);
}
#line 339614 "MACS_sample_kidney_box.c"
#undef number_of_activations
#undef mask_setting
#undef mask_string
#undef p_interact
#undef focus_r
#undef focus_xh
#undef focus_xw
#undef focus_ah
#undef focus_aw
#undef target_z
#undef target_y
#undef target_x
#undef target_index
#undef visualize
#undef yheight2
#undef xwidth2
#undef zdepth
#undef yheight
#undef xwidth
#undef priority
#undef material_string
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

  /* Initializations for component inter_analyzer_colimator_19_blade_3. */
  SIG_MESSAGE("inter_analyzer_colimator_19_blade_3 (Init)");
#define mccompcurname  inter_analyzer_colimator_19_blade_3
#define mccompcurtype  Union_box
#define mccompcurindex 880
#define loop_index mccinter_analyzer_colimator_19_blade_3_loop_index
#define this_box_volume mccinter_analyzer_colimator_19_blade_3_this_box_volume
#define global_geometry_element mccinter_analyzer_colimator_19_blade_3_global_geometry_element
#define this_box_storage mccinter_analyzer_colimator_19_blade_3_this_box_storage
#define material_string mccinter_analyzer_colimator_19_blade_3_material_string
#define priority mccinter_analyzer_colimator_19_blade_3_priority
#define xwidth mccinter_analyzer_colimator_19_blade_3_xwidth
#define yheight mccinter_analyzer_colimator_19_blade_3_yheight
#define zdepth mccinter_analyzer_colimator_19_blade_3_zdepth
#define xwidth2 mccinter_analyzer_colimator_19_blade_3_xwidth2
#define yheight2 mccinter_analyzer_colimator_19_blade_3_yheight2
#define visualize mccinter_analyzer_colimator_19_blade_3_visualize
#define target_index mccinter_analyzer_colimator_19_blade_3_target_index
#define target_x mccinter_analyzer_colimator_19_blade_3_target_x
#define target_y mccinter_analyzer_colimator_19_blade_3_target_y
#define target_z mccinter_analyzer_colimator_19_blade_3_target_z
#define focus_aw mccinter_analyzer_colimator_19_blade_3_focus_aw
#define focus_ah mccinter_analyzer_colimator_19_blade_3_focus_ah
#define focus_xw mccinter_analyzer_colimator_19_blade_3_focus_xw
#define focus_xh mccinter_analyzer_colimator_19_blade_3_focus_xh
#define focus_r mccinter_analyzer_colimator_19_blade_3_focus_r
#define p_interact mccinter_analyzer_colimator_19_blade_3_p_interact
#define mask_string mccinter_analyzer_colimator_19_blade_3_mask_string
#define mask_setting mccinter_analyzer_colimator_19_blade_3_mask_setting
#define number_of_activations mccinter_analyzer_colimator_19_blade_3_number_of_activations
#line 224 "Union_box.comp"
{
// Initializes the focusing system for this volume including input sanitation.
focus_initialize(&this_box_volume.geometry, POS_A_COMP_INDEX(INDEX_CURRENT_COMP+target_index), POS_A_CURRENT_COMP, ROT_A_CURRENT_COMP, target_index, target_x, target_y, target_z, focus_aw, focus_ah, focus_xw, focus_xh, focus_r, NAME_CURRENT_COMP);

// Input sanitation for this geometry
if (xwidth <= 0) {
  printf("\nERROR in Union_box named %s, the xwidth is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (yheight <= 0) {
  printf("\nERROR in Union_box named %s, yheight is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (zdepth <= 0) {
  printf("\nERROR in Union_box named %s, zdepth is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (xwidth2 <= 0 && xwidth2 != -1) {
  printf("\nERROR in Union_box named %s, the xwidth2 is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (yheight2 <= 0 && yheight2 != -1) {
  printf("\nERROR in Union_box named %s, yheight2 is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}

// Use sanitation
if (global_material_list.num_elements == 0) {
  printf("\nERROR: Need to define a material using Union_make_material before using a Union geometry component. \n");
  printf("       %s was defined before first use of Union_make_material.\n",NAME_CURRENT_COMP);
  exit(1);
}

this_box_volume.geometry.is_masked_volume = 0;
this_box_volume.geometry.is_exit_volume = 0;
this_box_volume.geometry.is_mask_volume = 0;
// check if the volume is a mask, if it is the material string is irelevant.
if (mask_string && strlen(mask_string) && strcmp(mask_string, "NULL") && strcmp(mask_string, "0")) {
    // A mask volume is used to limit the extend of other volumes, called the masked volumes. These are specified in the mask_string.
    // In order for a ray to enter a masked volume, it needs to be both in the region covered by that volume AND the mask volume.
    // When more than
    this_box_volume.geometry.mask_mode = 1; // Default is mask mode is ALL
    if (mask_setting && strlen(mask_setting) && strcmp(mask_setting, "NULL") && strcmp(mask_setting, "0")) {
        if (strcmp(mask_setting,"ALL") == 0 || strcmp(mask_setting,"All") == 0) this_box_volume.geometry.mask_mode = 1;
        else if (strcmp(mask_setting,"ANY") == 0 || strcmp(mask_setting,"Any") == 0) this_box_volume.geometry.mask_mode = 2;
        else {
            printf("The mask_mode of component %s is set to %s, but must be either ALL or ANY.\n",NAME_CURRENT_COMP,mask_setting);
            exit(1);
        }
    }
    
    for (loop_index=0;loop_index<global_geometry_list.num_elements;loop_index++) {
        // Add mask list
        if (1 == manual_linking_function(global_geometry_list.elements[loop_index].name,mask_string)) {
            add_element_to_int_list(&this_box_volume.geometry.mask_list,global_geometry_list.elements[loop_index].component_index);
            add_element_to_int_list(&global_geometry_list.elements[loop_index].Volume->geometry.masked_by_list,INDEX_CURRENT_COMP);
            global_geometry_list.elements[loop_index].Volume->geometry.is_masked_volume = 1;
            if (this_box_volume.geometry.mask_mode == 2)
                global_geometry_list.elements[loop_index].Volume->geometry.mask_mode = 2;
            if (this_box_volume.geometry.mask_mode == 1) {
                if (global_geometry_list.elements[loop_index].Volume->geometry.is_masked_volume == 1 && global_geometry_list.elements[loop_index].Volume->geometry.mask_mode != 2)
                    // If more than one mask is added to one volume, the ANY mode overwrites the (default) ALL mode.
                    global_geometry_list.elements[loop_index].Volume->geometry.mask_mode = 1;
            }
            
            found_geometries = 1;
        }
    }
    if (found_geometries == 0) {
        printf("The mask_string in geometry: %s did not find any of the specified volumes in the mask_string %s \n",NAME_CURRENT_COMP,mask_string);
        exit(1);
    }
    this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
    this_box_volume.p_physics->is_vacuum = 0; // Makes this volume a vacuum
    this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
    this_box_volume.p_physics->my_a = 0; // Should not be used.
    sprintf(this_box_volume.p_physics->name,"Mask");
    this_box_volume.geometry.is_mask_volume = 1;
    
    
// Read the material input, or if it lacks, use automatic linking.
} else if (material_string && strlen(material_string) && strcmp(material_string, "NULL") && strcmp(material_string, "0")) {
    // A geometry string was given, use it to determine which material
    if (0 == strcmp(material_string,"vacuum") || 0 == strcmp(material_string,"Vacuum")) {
        // One could have a global physics struct for vacuum instead of creating one for each
        this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
        this_box_volume.p_physics->is_vacuum = 1; // Makes this volume a vacuum
        this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
        this_box_volume.p_physics->my_a = 0; // Should not be used.
        sprintf(this_box_volume.p_physics->name,"Vacuum");
    } else if (0 == strcmp(material_string,"exit") || 0 == strcmp(material_string,"Exit")) {
        // One could have a global physics struct for vacuum instead of creating one for each
        this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
        this_box_volume.p_physics->is_vacuum = 1; // Makes this volume a vacuum
        this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
        this_box_volume.p_physics->my_a = 0; // Should not be used.
        this_box_volume.geometry.is_exit_volume = 1;
        sprintf(this_box_volume.p_physics->name,"Exit");
    } else {
        #ifndef MATERIAL_DETECTOR
            printf("Need to define a material before refering to it in a geometry %s.\n",NAME_CURRENT_COMP);
            exit(1);
        #endif
        for (loop_index=0;loop_index<global_material_list.num_elements;loop_index++) {
            if (0 == strcmp(material_string,global_material_list.elements[loop_index].name)) {
                this_box_volume.p_physics = global_material_list.elements[loop_index].physics;
                break;
            }
            if (loop_index == global_material_list.num_elements-1) {
            printf("\n");
            printf("ERROR: The material string \"%s\" in Union geometry \"%s\" did not match a specified material. \n",material_string,NAME_CURRENT_COMP);
            printf("       The materials available at this point (need to be defined before the geometry): \n");
            for (loop_index=0;loop_index<global_material_list.num_elements;loop_index++)
              printf("         %s\n",global_material_list.elements[loop_index].name);
            printf("\n");
            printf("       It is also possible to use one of the defualt materials avaiable: \n");
            printf("           Vacuum (for a Volume without scattering or absorption)\n");
            printf("           Exit (for a Volume where the ray exits the component if it enters)\n");
            printf("           Mask (for a Volume that masks existing volumes specified in the mask_string\n");
            exit(1);
          }
        }
    }
} else {
    // Automatic linking, simply using the last defined material.
    #ifndef MATERIAL_DETECTOR
        printf("Need to define a material before the geometry to use automatic linking %s.\n",NAME_CURRENT_COMP);
        exit(1);
    #endif
    this_box_volume.p_physics = global_material_list.elements[global_material_list.num_elements-1].physics;
}

sprintf(this_box_volume.name,NAME_CURRENT_COMP);
sprintf(this_box_volume.geometry.shape,"box");
this_box_volume.geometry.priority_value = priority;
this_box_volume.geometry.geometry_p_interact = p_interact;
// Currently the coordinates will be in absolute space.
this_box_volume.geometry.center = POS_A_CURRENT_COMP;

this_box_storage.z_depth = zdepth;
this_box_storage.x_width1 = xwidth;
this_box_storage.y_height1 = yheight;

this_box_storage.is_rectangle = 0;
if (xwidth2 < 0 && yheight2 < 0) this_box_storage.is_rectangle = 1;
if (xwidth == xwidth2 && yheight == yheight2) this_box_storage.is_rectangle = 1;

if (xwidth2 < 0) {
    this_box_storage.x_width2 = xwidth;
    xwidth2 = xwidth;
} else this_box_storage.x_width2 = xwidth2;

if (yheight2 < 0) {
    this_box_storage.y_height2 = yheight;
    yheight2 = yheight;
} else this_box_storage.y_height2 = yheight2;


this_box_storage.normal_vectors[0] = coords_set(0,0,1);
this_box_storage.normal_vectors[1] = coords_set(0,0,1);

// for sides with y component = 0
x_component = 2*zdepth/sqrt((xwidth-xwidth2)*(xwidth-xwidth2)+4*zdepth*zdepth);
z_component = (xwidth-xwidth2)/sqrt(4*zdepth*zdepth+(xwidth-xwidth2)*(xwidth-xwidth2));

this_box_storage.normal_vectors[2] = coords_set(x_component,0,z_component);
this_box_storage.normal_vectors[3] = coords_set(-x_component,0,z_component);

// for sides with x component = 0
y_component = 2*zdepth/sqrt((yheight-yheight2)*(yheight-yheight2)+4*zdepth*zdepth);
z_component = (yheight-yheight2)/sqrt(4*zdepth*zdepth+(yheight-yheight2)*(yheight-yheight2));

this_box_storage.normal_vectors[4] = coords_set(0,y_component,z_component);
this_box_storage.normal_vectors[5] = coords_set(0,-y_component,z_component);

this_box_volume.geometry.visualization_on = visualize;

this_box_volume.geometry.geometry_parameters.p_box_storage = &this_box_storage;

// Assign pointers to functions for intersection with the shape, checking if a point is inside the shape
if (this_box_storage.is_rectangle == 1) {
this_box_volume.geometry.intersect_function = &sample_box_intersect_simple;
this_box_volume.geometry.within_function = &r_within_box_simple;
}
else {
this_box_volume.geometry.intersect_function = &sample_box_intersect_advanced;
this_box_volume.geometry.within_function = &r_within_box_advanced;
}

this_box_volume.geometry.shell_points = &box_shell_points;
this_box_volume.geometry.mcdisplay_function = &mcdisplay_box_function;
this_box_volume.geometry.initialize_from_main_function = &initialize_box_geometry_from_main_component;
this_box_volume.geometry.process_rot_allocated = 0;

this_box_volume.geometry.copy_geometry_parameters = &allocate_box_storage_copy;

rot_copy(this_box_volume.geometry.rotation_matrix,ROT_A_CURRENT_COMP); //check how ROT_R_CURRENT_COMP would work
rot_transpose(ROT_A_CURRENT_COMP,this_box_volume.geometry.transpose_rotation_matrix);

// Initialize loggers
this_box_volume.loggers.num_elements = 0;

// packing the information into the global_geometry_element, which is then included in the global_geometry_list.
sprintf(global_geometry_element.name,NAME_CURRENT_COMP);
global_geometry_element.activation_counter = number_of_activations;
global_geometry_element.component_index = INDEX_CURRENT_COMP;
global_geometry_element.Volume = &this_box_volume; // Would be nicer if this m was a pointer, now we have the (small) data two places
add_element_to_geometry_list(&global_geometry_list,global_geometry_element);
}
#line 339884 "MACS_sample_kidney_box.c"
#undef number_of_activations
#undef mask_setting
#undef mask_string
#undef p_interact
#undef focus_r
#undef focus_xh
#undef focus_xw
#undef focus_ah
#undef focus_aw
#undef target_z
#undef target_y
#undef target_x
#undef target_index
#undef visualize
#undef yheight2
#undef xwidth2
#undef zdepth
#undef yheight
#undef xwidth
#undef priority
#undef material_string
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

  /* Initializations for component inter_analyzer_colimator_19_blade_4. */
  SIG_MESSAGE("inter_analyzer_colimator_19_blade_4 (Init)");
#define mccompcurname  inter_analyzer_colimator_19_blade_4
#define mccompcurtype  Union_box
#define mccompcurindex 881
#define loop_index mccinter_analyzer_colimator_19_blade_4_loop_index
#define this_box_volume mccinter_analyzer_colimator_19_blade_4_this_box_volume
#define global_geometry_element mccinter_analyzer_colimator_19_blade_4_global_geometry_element
#define this_box_storage mccinter_analyzer_colimator_19_blade_4_this_box_storage
#define material_string mccinter_analyzer_colimator_19_blade_4_material_string
#define priority mccinter_analyzer_colimator_19_blade_4_priority
#define xwidth mccinter_analyzer_colimator_19_blade_4_xwidth
#define yheight mccinter_analyzer_colimator_19_blade_4_yheight
#define zdepth mccinter_analyzer_colimator_19_blade_4_zdepth
#define xwidth2 mccinter_analyzer_colimator_19_blade_4_xwidth2
#define yheight2 mccinter_analyzer_colimator_19_blade_4_yheight2
#define visualize mccinter_analyzer_colimator_19_blade_4_visualize
#define target_index mccinter_analyzer_colimator_19_blade_4_target_index
#define target_x mccinter_analyzer_colimator_19_blade_4_target_x
#define target_y mccinter_analyzer_colimator_19_blade_4_target_y
#define target_z mccinter_analyzer_colimator_19_blade_4_target_z
#define focus_aw mccinter_analyzer_colimator_19_blade_4_focus_aw
#define focus_ah mccinter_analyzer_colimator_19_blade_4_focus_ah
#define focus_xw mccinter_analyzer_colimator_19_blade_4_focus_xw
#define focus_xh mccinter_analyzer_colimator_19_blade_4_focus_xh
#define focus_r mccinter_analyzer_colimator_19_blade_4_focus_r
#define p_interact mccinter_analyzer_colimator_19_blade_4_p_interact
#define mask_string mccinter_analyzer_colimator_19_blade_4_mask_string
#define mask_setting mccinter_analyzer_colimator_19_blade_4_mask_setting
#define number_of_activations mccinter_analyzer_colimator_19_blade_4_number_of_activations
#line 224 "Union_box.comp"
{
// Initializes the focusing system for this volume including input sanitation.
focus_initialize(&this_box_volume.geometry, POS_A_COMP_INDEX(INDEX_CURRENT_COMP+target_index), POS_A_CURRENT_COMP, ROT_A_CURRENT_COMP, target_index, target_x, target_y, target_z, focus_aw, focus_ah, focus_xw, focus_xh, focus_r, NAME_CURRENT_COMP);

// Input sanitation for this geometry
if (xwidth <= 0) {
  printf("\nERROR in Union_box named %s, the xwidth is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (yheight <= 0) {
  printf("\nERROR in Union_box named %s, yheight is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (zdepth <= 0) {
  printf("\nERROR in Union_box named %s, zdepth is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (xwidth2 <= 0 && xwidth2 != -1) {
  printf("\nERROR in Union_box named %s, the xwidth2 is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (yheight2 <= 0 && yheight2 != -1) {
  printf("\nERROR in Union_box named %s, yheight2 is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}

// Use sanitation
if (global_material_list.num_elements == 0) {
  printf("\nERROR: Need to define a material using Union_make_material before using a Union geometry component. \n");
  printf("       %s was defined before first use of Union_make_material.\n",NAME_CURRENT_COMP);
  exit(1);
}

this_box_volume.geometry.is_masked_volume = 0;
this_box_volume.geometry.is_exit_volume = 0;
this_box_volume.geometry.is_mask_volume = 0;
// check if the volume is a mask, if it is the material string is irelevant.
if (mask_string && strlen(mask_string) && strcmp(mask_string, "NULL") && strcmp(mask_string, "0")) {
    // A mask volume is used to limit the extend of other volumes, called the masked volumes. These are specified in the mask_string.
    // In order for a ray to enter a masked volume, it needs to be both in the region covered by that volume AND the mask volume.
    // When more than
    this_box_volume.geometry.mask_mode = 1; // Default is mask mode is ALL
    if (mask_setting && strlen(mask_setting) && strcmp(mask_setting, "NULL") && strcmp(mask_setting, "0")) {
        if (strcmp(mask_setting,"ALL") == 0 || strcmp(mask_setting,"All") == 0) this_box_volume.geometry.mask_mode = 1;
        else if (strcmp(mask_setting,"ANY") == 0 || strcmp(mask_setting,"Any") == 0) this_box_volume.geometry.mask_mode = 2;
        else {
            printf("The mask_mode of component %s is set to %s, but must be either ALL or ANY.\n",NAME_CURRENT_COMP,mask_setting);
            exit(1);
        }
    }
    
    for (loop_index=0;loop_index<global_geometry_list.num_elements;loop_index++) {
        // Add mask list
        if (1 == manual_linking_function(global_geometry_list.elements[loop_index].name,mask_string)) {
            add_element_to_int_list(&this_box_volume.geometry.mask_list,global_geometry_list.elements[loop_index].component_index);
            add_element_to_int_list(&global_geometry_list.elements[loop_index].Volume->geometry.masked_by_list,INDEX_CURRENT_COMP);
            global_geometry_list.elements[loop_index].Volume->geometry.is_masked_volume = 1;
            if (this_box_volume.geometry.mask_mode == 2)
                global_geometry_list.elements[loop_index].Volume->geometry.mask_mode = 2;
            if (this_box_volume.geometry.mask_mode == 1) {
                if (global_geometry_list.elements[loop_index].Volume->geometry.is_masked_volume == 1 && global_geometry_list.elements[loop_index].Volume->geometry.mask_mode != 2)
                    // If more than one mask is added to one volume, the ANY mode overwrites the (default) ALL mode.
                    global_geometry_list.elements[loop_index].Volume->geometry.mask_mode = 1;
            }
            
            found_geometries = 1;
        }
    }
    if (found_geometries == 0) {
        printf("The mask_string in geometry: %s did not find any of the specified volumes in the mask_string %s \n",NAME_CURRENT_COMP,mask_string);
        exit(1);
    }
    this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
    this_box_volume.p_physics->is_vacuum = 0; // Makes this volume a vacuum
    this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
    this_box_volume.p_physics->my_a = 0; // Should not be used.
    sprintf(this_box_volume.p_physics->name,"Mask");
    this_box_volume.geometry.is_mask_volume = 1;
    
    
// Read the material input, or if it lacks, use automatic linking.
} else if (material_string && strlen(material_string) && strcmp(material_string, "NULL") && strcmp(material_string, "0")) {
    // A geometry string was given, use it to determine which material
    if (0 == strcmp(material_string,"vacuum") || 0 == strcmp(material_string,"Vacuum")) {
        // One could have a global physics struct for vacuum instead of creating one for each
        this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
        this_box_volume.p_physics->is_vacuum = 1; // Makes this volume a vacuum
        this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
        this_box_volume.p_physics->my_a = 0; // Should not be used.
        sprintf(this_box_volume.p_physics->name,"Vacuum");
    } else if (0 == strcmp(material_string,"exit") || 0 == strcmp(material_string,"Exit")) {
        // One could have a global physics struct for vacuum instead of creating one for each
        this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
        this_box_volume.p_physics->is_vacuum = 1; // Makes this volume a vacuum
        this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
        this_box_volume.p_physics->my_a = 0; // Should not be used.
        this_box_volume.geometry.is_exit_volume = 1;
        sprintf(this_box_volume.p_physics->name,"Exit");
    } else {
        #ifndef MATERIAL_DETECTOR
            printf("Need to define a material before refering to it in a geometry %s.\n",NAME_CURRENT_COMP);
            exit(1);
        #endif
        for (loop_index=0;loop_index<global_material_list.num_elements;loop_index++) {
            if (0 == strcmp(material_string,global_material_list.elements[loop_index].name)) {
                this_box_volume.p_physics = global_material_list.elements[loop_index].physics;
                break;
            }
            if (loop_index == global_material_list.num_elements-1) {
            printf("\n");
            printf("ERROR: The material string \"%s\" in Union geometry \"%s\" did not match a specified material. \n",material_string,NAME_CURRENT_COMP);
            printf("       The materials available at this point (need to be defined before the geometry): \n");
            for (loop_index=0;loop_index<global_material_list.num_elements;loop_index++)
              printf("         %s\n",global_material_list.elements[loop_index].name);
            printf("\n");
            printf("       It is also possible to use one of the defualt materials avaiable: \n");
            printf("           Vacuum (for a Volume without scattering or absorption)\n");
            printf("           Exit (for a Volume where the ray exits the component if it enters)\n");
            printf("           Mask (for a Volume that masks existing volumes specified in the mask_string\n");
            exit(1);
          }
        }
    }
} else {
    // Automatic linking, simply using the last defined material.
    #ifndef MATERIAL_DETECTOR
        printf("Need to define a material before the geometry to use automatic linking %s.\n",NAME_CURRENT_COMP);
        exit(1);
    #endif
    this_box_volume.p_physics = global_material_list.elements[global_material_list.num_elements-1].physics;
}

sprintf(this_box_volume.name,NAME_CURRENT_COMP);
sprintf(this_box_volume.geometry.shape,"box");
this_box_volume.geometry.priority_value = priority;
this_box_volume.geometry.geometry_p_interact = p_interact;
// Currently the coordinates will be in absolute space.
this_box_volume.geometry.center = POS_A_CURRENT_COMP;

this_box_storage.z_depth = zdepth;
this_box_storage.x_width1 = xwidth;
this_box_storage.y_height1 = yheight;

this_box_storage.is_rectangle = 0;
if (xwidth2 < 0 && yheight2 < 0) this_box_storage.is_rectangle = 1;
if (xwidth == xwidth2 && yheight == yheight2) this_box_storage.is_rectangle = 1;

if (xwidth2 < 0) {
    this_box_storage.x_width2 = xwidth;
    xwidth2 = xwidth;
} else this_box_storage.x_width2 = xwidth2;

if (yheight2 < 0) {
    this_box_storage.y_height2 = yheight;
    yheight2 = yheight;
} else this_box_storage.y_height2 = yheight2;


this_box_storage.normal_vectors[0] = coords_set(0,0,1);
this_box_storage.normal_vectors[1] = coords_set(0,0,1);

// for sides with y component = 0
x_component = 2*zdepth/sqrt((xwidth-xwidth2)*(xwidth-xwidth2)+4*zdepth*zdepth);
z_component = (xwidth-xwidth2)/sqrt(4*zdepth*zdepth+(xwidth-xwidth2)*(xwidth-xwidth2));

this_box_storage.normal_vectors[2] = coords_set(x_component,0,z_component);
this_box_storage.normal_vectors[3] = coords_set(-x_component,0,z_component);

// for sides with x component = 0
y_component = 2*zdepth/sqrt((yheight-yheight2)*(yheight-yheight2)+4*zdepth*zdepth);
z_component = (yheight-yheight2)/sqrt(4*zdepth*zdepth+(yheight-yheight2)*(yheight-yheight2));

this_box_storage.normal_vectors[4] = coords_set(0,y_component,z_component);
this_box_storage.normal_vectors[5] = coords_set(0,-y_component,z_component);

this_box_volume.geometry.visualization_on = visualize;

this_box_volume.geometry.geometry_parameters.p_box_storage = &this_box_storage;

// Assign pointers to functions for intersection with the shape, checking if a point is inside the shape
if (this_box_storage.is_rectangle == 1) {
this_box_volume.geometry.intersect_function = &sample_box_intersect_simple;
this_box_volume.geometry.within_function = &r_within_box_simple;
}
else {
this_box_volume.geometry.intersect_function = &sample_box_intersect_advanced;
this_box_volume.geometry.within_function = &r_within_box_advanced;
}

this_box_volume.geometry.shell_points = &box_shell_points;
this_box_volume.geometry.mcdisplay_function = &mcdisplay_box_function;
this_box_volume.geometry.initialize_from_main_function = &initialize_box_geometry_from_main_component;
this_box_volume.geometry.process_rot_allocated = 0;

this_box_volume.geometry.copy_geometry_parameters = &allocate_box_storage_copy;

rot_copy(this_box_volume.geometry.rotation_matrix,ROT_A_CURRENT_COMP); //check how ROT_R_CURRENT_COMP would work
rot_transpose(ROT_A_CURRENT_COMP,this_box_volume.geometry.transpose_rotation_matrix);

// Initialize loggers
this_box_volume.loggers.num_elements = 0;

// packing the information into the global_geometry_element, which is then included in the global_geometry_list.
sprintf(global_geometry_element.name,NAME_CURRENT_COMP);
global_geometry_element.activation_counter = number_of_activations;
global_geometry_element.component_index = INDEX_CURRENT_COMP;
global_geometry_element.Volume = &this_box_volume; // Would be nicer if this m was a pointer, now we have the (small) data two places
add_element_to_geometry_list(&global_geometry_list,global_geometry_element);
}
#line 340154 "MACS_sample_kidney_box.c"
#undef number_of_activations
#undef mask_setting
#undef mask_string
#undef p_interact
#undef focus_r
#undef focus_xh
#undef focus_xw
#undef focus_ah
#undef focus_aw
#undef target_z
#undef target_y
#undef target_x
#undef target_index
#undef visualize
#undef yheight2
#undef xwidth2
#undef zdepth
#undef yheight
#undef xwidth
#undef priority
#undef material_string
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

  /* Initializations for component diffraction_detector_19_exit_volume. */
  SIG_MESSAGE("diffraction_detector_19_exit_volume (Init)");
#define mccompcurname  diffraction_detector_19_exit_volume
#define mccompcurtype  Union_box
#define mccompcurindex 882
#define loop_index mccdiffraction_detector_19_exit_volume_loop_index
#define this_box_volume mccdiffraction_detector_19_exit_volume_this_box_volume
#define global_geometry_element mccdiffraction_detector_19_exit_volume_global_geometry_element
#define this_box_storage mccdiffraction_detector_19_exit_volume_this_box_storage
#define material_string mccdiffraction_detector_19_exit_volume_material_string
#define priority mccdiffraction_detector_19_exit_volume_priority
#define xwidth mccdiffraction_detector_19_exit_volume_xwidth
#define yheight mccdiffraction_detector_19_exit_volume_yheight
#define zdepth mccdiffraction_detector_19_exit_volume_zdepth
#define xwidth2 mccdiffraction_detector_19_exit_volume_xwidth2
#define yheight2 mccdiffraction_detector_19_exit_volume_yheight2
#define visualize mccdiffraction_detector_19_exit_volume_visualize
#define target_index mccdiffraction_detector_19_exit_volume_target_index
#define target_x mccdiffraction_detector_19_exit_volume_target_x
#define target_y mccdiffraction_detector_19_exit_volume_target_y
#define target_z mccdiffraction_detector_19_exit_volume_target_z
#define focus_aw mccdiffraction_detector_19_exit_volume_focus_aw
#define focus_ah mccdiffraction_detector_19_exit_volume_focus_ah
#define focus_xw mccdiffraction_detector_19_exit_volume_focus_xw
#define focus_xh mccdiffraction_detector_19_exit_volume_focus_xh
#define focus_r mccdiffraction_detector_19_exit_volume_focus_r
#define p_interact mccdiffraction_detector_19_exit_volume_p_interact
#define mask_string mccdiffraction_detector_19_exit_volume_mask_string
#define mask_setting mccdiffraction_detector_19_exit_volume_mask_setting
#define number_of_activations mccdiffraction_detector_19_exit_volume_number_of_activations
#line 224 "Union_box.comp"
{
// Initializes the focusing system for this volume including input sanitation.
focus_initialize(&this_box_volume.geometry, POS_A_COMP_INDEX(INDEX_CURRENT_COMP+target_index), POS_A_CURRENT_COMP, ROT_A_CURRENT_COMP, target_index, target_x, target_y, target_z, focus_aw, focus_ah, focus_xw, focus_xh, focus_r, NAME_CURRENT_COMP);

// Input sanitation for this geometry
if (xwidth <= 0) {
  printf("\nERROR in Union_box named %s, the xwidth is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (yheight <= 0) {
  printf("\nERROR in Union_box named %s, yheight is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (zdepth <= 0) {
  printf("\nERROR in Union_box named %s, zdepth is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (xwidth2 <= 0 && xwidth2 != -1) {
  printf("\nERROR in Union_box named %s, the xwidth2 is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (yheight2 <= 0 && yheight2 != -1) {
  printf("\nERROR in Union_box named %s, yheight2 is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}

// Use sanitation
if (global_material_list.num_elements == 0) {
  printf("\nERROR: Need to define a material using Union_make_material before using a Union geometry component. \n");
  printf("       %s was defined before first use of Union_make_material.\n",NAME_CURRENT_COMP);
  exit(1);
}

this_box_volume.geometry.is_masked_volume = 0;
this_box_volume.geometry.is_exit_volume = 0;
this_box_volume.geometry.is_mask_volume = 0;
// check if the volume is a mask, if it is the material string is irelevant.
if (mask_string && strlen(mask_string) && strcmp(mask_string, "NULL") && strcmp(mask_string, "0")) {
    // A mask volume is used to limit the extend of other volumes, called the masked volumes. These are specified in the mask_string.
    // In order for a ray to enter a masked volume, it needs to be both in the region covered by that volume AND the mask volume.
    // When more than
    this_box_volume.geometry.mask_mode = 1; // Default is mask mode is ALL
    if (mask_setting && strlen(mask_setting) && strcmp(mask_setting, "NULL") && strcmp(mask_setting, "0")) {
        if (strcmp(mask_setting,"ALL") == 0 || strcmp(mask_setting,"All") == 0) this_box_volume.geometry.mask_mode = 1;
        else if (strcmp(mask_setting,"ANY") == 0 || strcmp(mask_setting,"Any") == 0) this_box_volume.geometry.mask_mode = 2;
        else {
            printf("The mask_mode of component %s is set to %s, but must be either ALL or ANY.\n",NAME_CURRENT_COMP,mask_setting);
            exit(1);
        }
    }
    
    for (loop_index=0;loop_index<global_geometry_list.num_elements;loop_index++) {
        // Add mask list
        if (1 == manual_linking_function(global_geometry_list.elements[loop_index].name,mask_string)) {
            add_element_to_int_list(&this_box_volume.geometry.mask_list,global_geometry_list.elements[loop_index].component_index);
            add_element_to_int_list(&global_geometry_list.elements[loop_index].Volume->geometry.masked_by_list,INDEX_CURRENT_COMP);
            global_geometry_list.elements[loop_index].Volume->geometry.is_masked_volume = 1;
            if (this_box_volume.geometry.mask_mode == 2)
                global_geometry_list.elements[loop_index].Volume->geometry.mask_mode = 2;
            if (this_box_volume.geometry.mask_mode == 1) {
                if (global_geometry_list.elements[loop_index].Volume->geometry.is_masked_volume == 1 && global_geometry_list.elements[loop_index].Volume->geometry.mask_mode != 2)
                    // If more than one mask is added to one volume, the ANY mode overwrites the (default) ALL mode.
                    global_geometry_list.elements[loop_index].Volume->geometry.mask_mode = 1;
            }
            
            found_geometries = 1;
        }
    }
    if (found_geometries == 0) {
        printf("The mask_string in geometry: %s did not find any of the specified volumes in the mask_string %s \n",NAME_CURRENT_COMP,mask_string);
        exit(1);
    }
    this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
    this_box_volume.p_physics->is_vacuum = 0; // Makes this volume a vacuum
    this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
    this_box_volume.p_physics->my_a = 0; // Should not be used.
    sprintf(this_box_volume.p_physics->name,"Mask");
    this_box_volume.geometry.is_mask_volume = 1;
    
    
// Read the material input, or if it lacks, use automatic linking.
} else if (material_string && strlen(material_string) && strcmp(material_string, "NULL") && strcmp(material_string, "0")) {
    // A geometry string was given, use it to determine which material
    if (0 == strcmp(material_string,"vacuum") || 0 == strcmp(material_string,"Vacuum")) {
        // One could have a global physics struct for vacuum instead of creating one for each
        this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
        this_box_volume.p_physics->is_vacuum = 1; // Makes this volume a vacuum
        this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
        this_box_volume.p_physics->my_a = 0; // Should not be used.
        sprintf(this_box_volume.p_physics->name,"Vacuum");
    } else if (0 == strcmp(material_string,"exit") || 0 == strcmp(material_string,"Exit")) {
        // One could have a global physics struct for vacuum instead of creating one for each
        this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
        this_box_volume.p_physics->is_vacuum = 1; // Makes this volume a vacuum
        this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
        this_box_volume.p_physics->my_a = 0; // Should not be used.
        this_box_volume.geometry.is_exit_volume = 1;
        sprintf(this_box_volume.p_physics->name,"Exit");
    } else {
        #ifndef MATERIAL_DETECTOR
            printf("Need to define a material before refering to it in a geometry %s.\n",NAME_CURRENT_COMP);
            exit(1);
        #endif
        for (loop_index=0;loop_index<global_material_list.num_elements;loop_index++) {
            if (0 == strcmp(material_string,global_material_list.elements[loop_index].name)) {
                this_box_volume.p_physics = global_material_list.elements[loop_index].physics;
                break;
            }
            if (loop_index == global_material_list.num_elements-1) {
            printf("\n");
            printf("ERROR: The material string \"%s\" in Union geometry \"%s\" did not match a specified material. \n",material_string,NAME_CURRENT_COMP);
            printf("       The materials available at this point (need to be defined before the geometry): \n");
            for (loop_index=0;loop_index<global_material_list.num_elements;loop_index++)
              printf("         %s\n",global_material_list.elements[loop_index].name);
            printf("\n");
            printf("       It is also possible to use one of the defualt materials avaiable: \n");
            printf("           Vacuum (for a Volume without scattering or absorption)\n");
            printf("           Exit (for a Volume where the ray exits the component if it enters)\n");
            printf("           Mask (for a Volume that masks existing volumes specified in the mask_string\n");
            exit(1);
          }
        }
    }
} else {
    // Automatic linking, simply using the last defined material.
    #ifndef MATERIAL_DETECTOR
        printf("Need to define a material before the geometry to use automatic linking %s.\n",NAME_CURRENT_COMP);
        exit(1);
    #endif
    this_box_volume.p_physics = global_material_list.elements[global_material_list.num_elements-1].physics;
}

sprintf(this_box_volume.name,NAME_CURRENT_COMP);
sprintf(this_box_volume.geometry.shape,"box");
this_box_volume.geometry.priority_value = priority;
this_box_volume.geometry.geometry_p_interact = p_interact;
// Currently the coordinates will be in absolute space.
this_box_volume.geometry.center = POS_A_CURRENT_COMP;

this_box_storage.z_depth = zdepth;
this_box_storage.x_width1 = xwidth;
this_box_storage.y_height1 = yheight;

this_box_storage.is_rectangle = 0;
if (xwidth2 < 0 && yheight2 < 0) this_box_storage.is_rectangle = 1;
if (xwidth == xwidth2 && yheight == yheight2) this_box_storage.is_rectangle = 1;

if (xwidth2 < 0) {
    this_box_storage.x_width2 = xwidth;
    xwidth2 = xwidth;
} else this_box_storage.x_width2 = xwidth2;

if (yheight2 < 0) {
    this_box_storage.y_height2 = yheight;
    yheight2 = yheight;
} else this_box_storage.y_height2 = yheight2;


this_box_storage.normal_vectors[0] = coords_set(0,0,1);
this_box_storage.normal_vectors[1] = coords_set(0,0,1);

// for sides with y component = 0
x_component = 2*zdepth/sqrt((xwidth-xwidth2)*(xwidth-xwidth2)+4*zdepth*zdepth);
z_component = (xwidth-xwidth2)/sqrt(4*zdepth*zdepth+(xwidth-xwidth2)*(xwidth-xwidth2));

this_box_storage.normal_vectors[2] = coords_set(x_component,0,z_component);
this_box_storage.normal_vectors[3] = coords_set(-x_component,0,z_component);

// for sides with x component = 0
y_component = 2*zdepth/sqrt((yheight-yheight2)*(yheight-yheight2)+4*zdepth*zdepth);
z_component = (yheight-yheight2)/sqrt(4*zdepth*zdepth+(yheight-yheight2)*(yheight-yheight2));

this_box_storage.normal_vectors[4] = coords_set(0,y_component,z_component);
this_box_storage.normal_vectors[5] = coords_set(0,-y_component,z_component);

this_box_volume.geometry.visualization_on = visualize;

this_box_volume.geometry.geometry_parameters.p_box_storage = &this_box_storage;

// Assign pointers to functions for intersection with the shape, checking if a point is inside the shape
if (this_box_storage.is_rectangle == 1) {
this_box_volume.geometry.intersect_function = &sample_box_intersect_simple;
this_box_volume.geometry.within_function = &r_within_box_simple;
}
else {
this_box_volume.geometry.intersect_function = &sample_box_intersect_advanced;
this_box_volume.geometry.within_function = &r_within_box_advanced;
}

this_box_volume.geometry.shell_points = &box_shell_points;
this_box_volume.geometry.mcdisplay_function = &mcdisplay_box_function;
this_box_volume.geometry.initialize_from_main_function = &initialize_box_geometry_from_main_component;
this_box_volume.geometry.process_rot_allocated = 0;

this_box_volume.geometry.copy_geometry_parameters = &allocate_box_storage_copy;

rot_copy(this_box_volume.geometry.rotation_matrix,ROT_A_CURRENT_COMP); //check how ROT_R_CURRENT_COMP would work
rot_transpose(ROT_A_CURRENT_COMP,this_box_volume.geometry.transpose_rotation_matrix);

// Initialize loggers
this_box_volume.loggers.num_elements = 0;

// packing the information into the global_geometry_element, which is then included in the global_geometry_list.
sprintf(global_geometry_element.name,NAME_CURRENT_COMP);
global_geometry_element.activation_counter = number_of_activations;
global_geometry_element.component_index = INDEX_CURRENT_COMP;
global_geometry_element.Volume = &this_box_volume; // Would be nicer if this m was a pointer, now we have the (small) data two places
add_element_to_geometry_list(&global_geometry_list,global_geometry_element);
}
#line 340424 "MACS_sample_kidney_box.c"
#undef number_of_activations
#undef mask_setting
#undef mask_string
#undef p_interact
#undef focus_r
#undef focus_xh
#undef focus_xw
#undef focus_ah
#undef focus_aw
#undef target_z
#undef target_y
#undef target_x
#undef target_index
#undef visualize
#undef yheight2
#undef xwidth2
#undef zdepth
#undef yheight
#undef xwidth
#undef priority
#undef material_string
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

  /* Initializations for component spec_detector_19_exit_volume. */
  SIG_MESSAGE("spec_detector_19_exit_volume (Init)");
#define mccompcurname  spec_detector_19_exit_volume
#define mccompcurtype  Union_box
#define mccompcurindex 883
#define loop_index mccspec_detector_19_exit_volume_loop_index
#define this_box_volume mccspec_detector_19_exit_volume_this_box_volume
#define global_geometry_element mccspec_detector_19_exit_volume_global_geometry_element
#define this_box_storage mccspec_detector_19_exit_volume_this_box_storage
#define material_string mccspec_detector_19_exit_volume_material_string
#define priority mccspec_detector_19_exit_volume_priority
#define xwidth mccspec_detector_19_exit_volume_xwidth
#define yheight mccspec_detector_19_exit_volume_yheight
#define zdepth mccspec_detector_19_exit_volume_zdepth
#define xwidth2 mccspec_detector_19_exit_volume_xwidth2
#define yheight2 mccspec_detector_19_exit_volume_yheight2
#define visualize mccspec_detector_19_exit_volume_visualize
#define target_index mccspec_detector_19_exit_volume_target_index
#define target_x mccspec_detector_19_exit_volume_target_x
#define target_y mccspec_detector_19_exit_volume_target_y
#define target_z mccspec_detector_19_exit_volume_target_z
#define focus_aw mccspec_detector_19_exit_volume_focus_aw
#define focus_ah mccspec_detector_19_exit_volume_focus_ah
#define focus_xw mccspec_detector_19_exit_volume_focus_xw
#define focus_xh mccspec_detector_19_exit_volume_focus_xh
#define focus_r mccspec_detector_19_exit_volume_focus_r
#define p_interact mccspec_detector_19_exit_volume_p_interact
#define mask_string mccspec_detector_19_exit_volume_mask_string
#define mask_setting mccspec_detector_19_exit_volume_mask_setting
#define number_of_activations mccspec_detector_19_exit_volume_number_of_activations
#line 224 "Union_box.comp"
{
// Initializes the focusing system for this volume including input sanitation.
focus_initialize(&this_box_volume.geometry, POS_A_COMP_INDEX(INDEX_CURRENT_COMP+target_index), POS_A_CURRENT_COMP, ROT_A_CURRENT_COMP, target_index, target_x, target_y, target_z, focus_aw, focus_ah, focus_xw, focus_xh, focus_r, NAME_CURRENT_COMP);

// Input sanitation for this geometry
if (xwidth <= 0) {
  printf("\nERROR in Union_box named %s, the xwidth is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (yheight <= 0) {
  printf("\nERROR in Union_box named %s, yheight is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (zdepth <= 0) {
  printf("\nERROR in Union_box named %s, zdepth is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (xwidth2 <= 0 && xwidth2 != -1) {
  printf("\nERROR in Union_box named %s, the xwidth2 is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}
if (yheight2 <= 0 && yheight2 != -1) {
  printf("\nERROR in Union_box named %s, yheight2 is <= 0. \n",NAME_CURRENT_COMP);
  exit(1);
}

// Use sanitation
if (global_material_list.num_elements == 0) {
  printf("\nERROR: Need to define a material using Union_make_material before using a Union geometry component. \n");
  printf("       %s was defined before first use of Union_make_material.\n",NAME_CURRENT_COMP);
  exit(1);
}

this_box_volume.geometry.is_masked_volume = 0;
this_box_volume.geometry.is_exit_volume = 0;
this_box_volume.geometry.is_mask_volume = 0;
// check if the volume is a mask, if it is the material string is irelevant.
if (mask_string && strlen(mask_string) && strcmp(mask_string, "NULL") && strcmp(mask_string, "0")) {
    // A mask volume is used to limit the extend of other volumes, called the masked volumes. These are specified in the mask_string.
    // In order for a ray to enter a masked volume, it needs to be both in the region covered by that volume AND the mask volume.
    // When more than
    this_box_volume.geometry.mask_mode = 1; // Default is mask mode is ALL
    if (mask_setting && strlen(mask_setting) && strcmp(mask_setting, "NULL") && strcmp(mask_setting, "0")) {
        if (strcmp(mask_setting,"ALL") == 0 || strcmp(mask_setting,"All") == 0) this_box_volume.geometry.mask_mode = 1;
        else if (strcmp(mask_setting,"ANY") == 0 || strcmp(mask_setting,"Any") == 0) this_box_volume.geometry.mask_mode = 2;
        else {
            printf("The mask_mode of component %s is set to %s, but must be either ALL or ANY.\n",NAME_CURRENT_COMP,mask_setting);
            exit(1);
        }
    }
    
    for (loop_index=0;loop_index<global_geometry_list.num_elements;loop_index++) {
        // Add mask list
        if (1 == manual_linking_function(global_geometry_list.elements[loop_index].name,mask_string)) {
            add_element_to_int_list(&this_box_volume.geometry.mask_list,global_geometry_list.elements[loop_index].component_index);
            add_element_to_int_list(&global_geometry_list.elements[loop_index].Volume->geometry.masked_by_list,INDEX_CURRENT_COMP);
            global_geometry_list.elements[loop_index].Volume->geometry.is_masked_volume = 1;
            if (this_box_volume.geometry.mask_mode == 2)
                global_geometry_list.elements[loop_index].Volume->geometry.mask_mode = 2;
            if (this_box_volume.geometry.mask_mode == 1) {
                if (global_geometry_list.elements[loop_index].Volume->geometry.is_masked_volume == 1 && global_geometry_list.elements[loop_index].Volume->geometry.mask_mode != 2)
                    // If more than one mask is added to one volume, the ANY mode overwrites the (default) ALL mode.
                    global_geometry_list.elements[loop_index].Volume->geometry.mask_mode = 1;
            }
            
            found_geometries = 1;
        }
    }
    if (found_geometries == 0) {
        printf("The mask_string in geometry: %s did not find any of the specified volumes in the mask_string %s \n",NAME_CURRENT_COMP,mask_string);
        exit(1);
    }
    this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
    this_box_volume.p_physics->is_vacuum = 0; // Makes this volume a vacuum
    this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
    this_box_volume.p_physics->my_a = 0; // Should not be used.
    sprintf(this_box_volume.p_physics->name,"Mask");
    this_box_volume.geometry.is_mask_volume = 1;
    
    
// Read the material input, or if it lacks, use automatic linking.
} else if (material_string && strlen(material_string) && strcmp(material_string, "NULL") && strcmp(material_string, "0")) {
    // A geometry string was given, use it to determine which material
    if (0 == strcmp(material_string,"vacuum") || 0 == strcmp(material_string,"Vacuum")) {
        // One could have a global physics struct for vacuum instead of creating one for each
        this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
        this_box_volume.p_physics->is_vacuum = 1; // Makes this volume a vacuum
        this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
        this_box_volume.p_physics->my_a = 0; // Should not be used.
        sprintf(this_box_volume.p_physics->name,"Vacuum");
    } else if (0 == strcmp(material_string,"exit") || 0 == strcmp(material_string,"Exit")) {
        // One could have a global physics struct for vacuum instead of creating one for each
        this_box_volume.p_physics = malloc(sizeof(struct physics_struct));
        this_box_volume.p_physics->is_vacuum = 1; // Makes this volume a vacuum
        this_box_volume.p_physics->number_of_processes = (int) 0; // Should not be used.
        this_box_volume.p_physics->my_a = 0; // Should not be used.
        this_box_volume.geometry.is_exit_volume = 1;
        sprintf(this_box_volume.p_physics->name,"Exit");
    } else {
        #ifndef MATERIAL_DETECTOR
            printf("Need to define a material before refering to it in a geometry %s.\n",NAME_CURRENT_COMP);
            exit(1);
        #endif
        for (loop_index=0;loop_index<global_material_list.num_elements;loop_index++) {
            if (0 == strcmp(material_string,global_material_list.elements[loop_index].name)) {
                this_box_volume.p_physics = global_material_list.elements[loop_index].physics;
                break;
            }
            if (loop_index == global_material_list.num_elements-1) {
            printf("\n");
            printf("ERROR: The material string \"%s\" in Union geometry \"%s\" did not match a specified material. \n",material_string,NAME_CURRENT_COMP);
            printf("       The materials available at this point (need to be defined before the geometry): \n");
            for (loop_index=0;loop_index<global_material_list.num_elements;loop_index++)
              printf("         %s\n",global_material_list.elements[loop_index].name);
            printf("\n");
            printf("       It is also possible to use one of the defualt materials avaiable: \n");
            printf("           Vacuum (for a Volume without scattering or absorption)\n");
            printf("           Exit (for a Volume where the ray exits the component if it enters)\n");
            printf("           Mask (for a Volume that masks existing volumes specified in the mask_string\n");
            exit(1);
          }
        }
    }
} else {
    // Automatic linking, simply using the last defined material.
    #ifndef MATERIAL_DETECTOR
        printf("Need to define a material before the geometry to use automatic linking %s.\n",NAME_CURRENT_COMP);
        exit(1);
    #endif
    this_box_volume.p_physics = global_material_list.elements[global_material_list.num_elements-1].physics;
}

sprintf(this_box_volume.name,NAME_CURRENT_COMP);
sprintf(this_box_volume.geometry.shape,"box");
this_box_volume.geometry.priority_value = priority;
this_box_volume.geometry.geometry_p_interact = p_interact;
// Currently the coordinates will be in absolute space.
this_box_volume.geometry.center = POS_A_CURRENT_COMP;

this_box_storage.z_depth = zdepth;
this_box_storage.x_width1 = xwidth;
this_box_storage.y_height1 = yheight;

this_box_storage.is_rectangle = 0;
if (xwidth2 < 0 && yheight2 < 0) this_box_storage.is_rectangle = 1;
if (xwidth == xwidth2 && yheight == yheight2) this_box_storage.is_rectangle = 1;

if (xwidth2 < 0) {
    this_box_storage.x_width2 = xwidth;
    xwidth2 = xwidth;
} else this_box_storage.x_width2 = xwidth2;

if (yheight2 < 0) {
    this_box_storage.y_height2 = yheight;
    yheight2 = yheight;
} else this_box_storage.y_height2 = yheight2;


this_box_storage.normal_vectors[0] = coords_set(0,0,1);
this_box_storage.normal_vectors[1] = coords_set(0,0,1);

// for sides with y component = 0
x_component = 2*zdepth/sqrt((xwidth-xwidth2)*(xwidth-xwidth2)+4*zdepth*zdepth);
z_component = (xwidth-xwidth2)/sqrt(4*zdepth*zdepth+(xwidth-xwidth2)*(xwidth-xwidth2));

this_box_storage.normal_vectors[2] = coords_set(x_component,0,z_component);
this_box_storage.normal_vectors[3] = coords_set(-x_component,0,z_component);

// for sides with x component = 0
y_component = 2*zdepth/sqrt((yheight-yheight2)*(yheight-yheight2)+4*zdepth*zdepth);
z_component = (yheight-yheight2)/sqrt(4*zdepth*zdepth+(yheight-yheight2)*(yheight-yheight2));

this_box_storage.normal_vectors[4] = coords_set(0,y_component,z_component);
this_box_storage.normal_vectors[5] = coords_set(0,-y_component,z_component);

this_box_volume.geometry.visualization_on = visualize;

this_box_volume.geometry.geometry_parameters.p_box_storage = &this_box_storage;

// Assign pointers to functions for intersection with the shape, checking if a point is inside the shape
if (this_box_storage.is_rectangle == 1) {
this_box_volume.geometry.intersect_function = &sample_box_intersect_simple;
this_box_volume.geometry.within_function = &r_within_box_simple;
}
else {
this_box_volume.geometry.intersect_function = &sample_box_intersect_advanced;
this_box_volume.geometry.within_function = &r_within_box_advanced;
}

this_box_volume.geometry.shell_points = &box_shell_points;
this_box_volume.geometry.mcdisplay_function = &mcdisplay_box_function;
this_box_volume.geometry.initialize_from_main_function = &initialize_box_geometry_from_main_component;
this_box_volume.geometry.process_rot_allocated = 0;

this_box_volume.geometry.copy_geometry_parameters = &allocate_box_storage_copy;

rot_copy(this_box_volume.geometry.rotation_matrix,ROT_A_CURRENT_COMP); //check how ROT_R_CURRENT_COMP would work
rot_transpose(ROT_A_CURRENT_COMP,this_box_volume.geometry.transpose_rotation_matrix);

// Initialize loggers
this_box_volume.loggers.num_elements = 0;

// packing the information into the global_geometry_element, which is then included in the global_geometry_list.
sprintf(global_geometry_element.name,NAME_CURRENT_COMP);
global_geometry_element.activation_counter = number_of_activations;
global_geometry_element.component_index = INDEX_CURRENT_COMP;
global_geometry_element.Volume = &this_box_volume; // Would be nicer if this m was a pointer, now we have the (small) data two places
add_element_to_geometry_list(&global_geometry_list,global_geometry_element);
}
#line 340694 "MACS_sample_kidney_box.c"
#undef number_of_activations
#undef mask_setting
#undef mask_string
#undef p_interact
#undef focus_r
#undef focus_xh
#undef focus_xw
#undef focus_ah
#undef focus_aw
#undef target_z
#undef target_y
#undef target_x
#undef target_index
#undef visualize
#undef yheight2
#undef xwidth2
#undef zdepth
#undef yheight
#undef xwidth
#undef priority
#undef material_string
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

  /* Initializations for component kidney_union_master. */
  SIG_MESSAGE("kidney_union_master (Init)");
#define mccompcurname  kidney_union_master
#define mccompcurtype  Union_master
#define mccompcurindex 884
#define verbal mcckidney_union_master_verbal
#define list_verbal mcckidney_union_master_list_verbal
#define trace_verbal mcckidney_union_master_trace_verbal
#define finally_verbal mcckidney_union_master_finally_verbal
#define starting_volume_warning mcckidney_union_master_starting_volume_warning
#define global_master_element mcckidney_union_master_global_master_element
#define this_global_master_index mcckidney_union_master_this_global_master_index
#define previous_master_index mcckidney_union_master_previous_master_index
#define geometry_list_index mcckidney_union_master_geometry_list_index
#define intersection_time_table mcckidney_union_master_intersection_time_table
#define Volumes mcckidney_union_master_Volumes
#define Geometries mcckidney_union_master_Geometries
#define starting_lists mcckidney_union_master_starting_lists
#define r mcckidney_union_master_r
#define r_start mcckidney_union_master_r_start
#define v mcckidney_union_master_v
#define error_msg mcckidney_union_master_error_msg
#define component_error_msg mcckidney_union_master_component_error_msg
#define string_output mcckidney_union_master_string_output
#define number_of_volumes mcckidney_union_master_number_of_volumes
#define volume_index mcckidney_union_master_volume_index
#define process_index mcckidney_union_master_process_index
#define solutions mcckidney_union_master_solutions
#define max_number_of_processes mcckidney_union_master_max_number_of_processes
#define limit mcckidney_union_master_limit
#define solution mcckidney_union_master_solution
#define min_solution mcckidney_union_master_min_solution
#define min_volume mcckidney_union_master_min_volume
#define time_found mcckidney_union_master_time_found
#define intersection_time mcckidney_union_master_intersection_time
#define min_intersection_time mcckidney_union_master_min_intersection_time
#define process mcckidney_union_master_process
#define process_start mcckidney_union_master_process_start
#define my_trace mcckidney_union_master_my_trace
#define p_my_trace mcckidney_union_master_p_my_trace
#define my_trace_fraction_control mcckidney_union_master_my_trace_fraction_control
#define k mcckidney_union_master_k
#define k_new mcckidney_union_master_k_new
#define k_old mcckidney_union_master_k_old
#define v_length mcckidney_union_master_v_length
#define my_sum mcckidney_union_master_my_sum
#define my_sum_plus_abs mcckidney_union_master_my_sum_plus_abs
#define culmative_probability mcckidney_union_master_culmative_probability
#define mc_prop mcckidney_union_master_mc_prop
#define time_to_scattering mcckidney_union_master_time_to_scattering
#define length_to_scattering mcckidney_union_master_length_to_scattering
#define length_to_boundery mcckidney_union_master_length_to_boundery
#define time_to_boundery mcckidney_union_master_time_to_boundery
#define selected_process mcckidney_union_master_selected_process
#define scattering_event mcckidney_union_master_scattering_event
#define time_propagated_without_scattering mcckidney_union_master_time_propagated_without_scattering
#define a_next_volume_found mcckidney_union_master_a_next_volume_found
#define next_volume mcckidney_union_master_next_volume
#define next_volume_priority mcckidney_union_master_next_volume_priority
#define done mcckidney_union_master_done
#define current_volume mcckidney_union_master_current_volume
#define number_of_solutions mcckidney_union_master_number_of_solutions
#define number_of_solutions_static mcckidney_union_master_number_of_solutions_static
#define check mcckidney_union_master_check
#define start mcckidney_union_master_start
#define intersection_with_children mcckidney_union_master_intersection_with_children
#define geometry_output mcckidney_union_master_geometry_output
#define tree_next_volume mcckidney_union_master_tree_next_volume
#define pre_allocated1 mcckidney_union_master_pre_allocated1
#define pre_allocated2 mcckidney_union_master_pre_allocated2
#define pre_allocated3 mcckidney_union_master_pre_allocated3
#define ray_position mcckidney_union_master_ray_position
#define ray_velocity mcckidney_union_master_ray_velocity
#define ray_velocity_final mcckidney_union_master_ray_velocity_final
#define volume_0_found mcckidney_union_master_volume_0_found
#define scattered_flag mcckidney_union_master_scattered_flag
#define scattered_flag_VP mcckidney_union_master_scattered_flag_VP
#define master_transposed_rotation_matrix mcckidney_union_master_master_transposed_rotation_matrix
#define temp_rotation_matrix mcckidney_union_master_temp_rotation_matrix
#define non_rotated_position mcckidney_union_master_non_rotated_position
#define rotated_position mcckidney_union_master_rotated_position
#define enable_tagging mcckidney_union_master_enable_tagging
#define stop_tagging_ray mcckidney_union_master_stop_tagging_ray
#define stop_creating_nodes mcckidney_union_master_stop_creating_nodes
#define enable_tagging_check mcckidney_union_master_enable_tagging_check
#define master_tagging_node_list mcckidney_union_master_master_tagging_node_list
#define current_tagging_node mcckidney_union_master_current_tagging_node
#define tagging_leaf_counter mcckidney_union_master_tagging_leaf_counter
#define number_of_scattering_events mcckidney_union_master_number_of_scattering_events
#define real_transmission_probability mcckidney_union_master_real_transmission_probability
#define mc_transmission_probability mcckidney_union_master_mc_transmission_probability
#define number_of_masks mcckidney_union_master_number_of_masks
#define number_of_masked_volumes mcckidney_union_master_number_of_masked_volumes
#define need_to_run_within_which_volume mcckidney_union_master_need_to_run_within_which_volume
#define mask_index_main mcckidney_union_master_mask_index_main
#define mask_iterate mcckidney_union_master_mask_iterate
#define mask_status_list mcckidney_union_master_mask_status_list
#define current_mask_intersect_list_status mcckidney_union_master_current_mask_intersect_list_status
#define mask_volume_index_list mcckidney_union_master_mask_volume_index_list
#define geometry_component_index_list mcckidney_union_master_geometry_component_index_list
#define Volume_copies_allocated mcckidney_union_master_Volume_copies_allocated
#define p_old mcckidney_union_master_p_old
#define this_logger mcckidney_union_master_this_logger
#define conditional_status mcckidney_union_master_conditional_status
#define tagging_conditional_list mcckidney_union_master_tagging_conditional_list
#define free_tagging_conditioanl_list mcckidney_union_master_free_tagging_conditioanl_list
#define logger_conditional_extend_array mcckidney_union_master_logger_conditional_extend_array
#define tagging_conditional_extend mcckidney_union_master_tagging_conditional_extend
#define max_conditional_extend_index mcckidney_union_master_max_conditional_extend_index
#define safty_distance mcckidney_union_master_safty_distance
#define safty_distance2 mcckidney_union_master_safty_distance2
#define number_of_processes_array mcckidney_union_master_number_of_processes_array
#define temporary_focus_data mcckidney_union_master_temporary_focus_data
#define focus_data_index mcckidney_union_master_focus_data_index
#define allow_inside_start mcckidney_union_master_allow_inside_start
#define history_limit mcckidney_union_master_history_limit
#define enable_conditionals mcckidney_union_master_enable_conditionals
#define inherit_number_of_scattering_events mcckidney_union_master_inherit_number_of_scattering_events
#line 208 "Union_master.comp"
{
  // Use sanitation
  #ifndef ANY_GEOMETRY_DETECTOR_DECLARE
    printf("\nERROR: Need to define at least one Volume using Union_cylinder or Union_box before using the Union_master component. \n");
    exit(1);
  #endif
  #ifdef ANY_GEOMETRY_DETECTOR_DECLARE
    if (global_geometry_list.num_elements == 0) {
      printf("\nERROR: Need to define at least one Volume using Union_cylinder or Union_box before using the Union_master component. \n");
      printf("       Union_master component named \"%s\" is before any Volumes in the instrument file. At least one Volume need to be defined before\n",NAME_CURRENT_COMP);
    
      exit(1);
    }
  #endif
  
  // Parameters describing the safety distances close to surfaces, as scattering should not occur closer to a surface than the
  //  accuracy of the intersection calculation.
  safty_distance = 1E-11;
  safty_distance2 = safty_distance*2;
  
  // Write information to the global_master_list about the current Union_master
  sprintf(global_master_element.name,NAME_CURRENT_COMP);
  global_master_element.component_index = INDEX_CURRENT_COMP;
  add_element_to_master_list(&global_master_list,global_master_element);
  if (inherit_number_of_scattering_events == 1 && global_master_list.num_elements == 1) {
     printf("ERROR in Union_master with name %s. Inherit_number_of_scattering_events set to 1 for first Union_master component, but there is no preceeding Union_master component. Aborting.\n",NAME_CURRENT_COMP);
     exit(1);
  }
  this_global_master_index = global_master_list.num_elements - 1; // Save the index for this master in global master list
  
  // Set the component index of the previous Union_master component if one exists
  if (global_master_list.num_elements == 1) previous_master_index = 0; // no previous index
  else previous_master_index = global_master_list.elements[global_master_list.num_elements-2].component_index; // -2 because of zero indexing and needing the previous index.
  //printf("Assigned previous_master_index = %d \n",previous_master_index);
  
  // All volumes in the global_geometry_list is being check for activity using the number_of_activations input made for each geometry (default is 1)
  // In addition it is counted how many volumes, mask volumes and masked volumes are active in this Union_master.
  number_of_volumes = 1; // Starting with 1 as the surrounding vacuum is considered a volume
  number_of_masks = 0;   // Starting with 0 mask volumes
  number_of_masked_volumes = 0; // Starting with 0 masked volumes
  for (iterate=0;iterate<global_geometry_list.num_elements;iterate++) {
    if (global_geometry_list.elements[iterate].component_index < INDEX_CURRENT_COMP && global_geometry_list.elements[iterate].activation_counter > 0) {
        global_geometry_list.elements[iterate].active = 1;
        global_geometry_list.elements[iterate].activation_counter--;
        number_of_volumes++;
        if (global_geometry_list.elements[iterate].Volume->geometry.is_mask_volume == 1) number_of_masks++;
        if (global_geometry_list.elements[iterate].Volume->geometry.is_masked_volume == 1) number_of_masked_volumes++;
    } else global_geometry_list.elements[iterate].active = 0;
  }
  //printf("Found number of volumes to be %d \n",number_of_volumes);
  
  // Allocation of global lists
  geometry_component_index_list.num_elements = number_of_volumes;
  geometry_component_index_list.elements = malloc( geometry_component_index_list.num_elements * sizeof(int));
  mask_volume_index_list.num_elements = number_of_masks;
  if (number_of_masks >0) mask_volume_index_list.elements = malloc( number_of_masks * sizeof(int));
  mask_status_list.num_elements = number_of_masks;
  if (number_of_masks >0) mask_status_list.elements = malloc( number_of_masks * sizeof(int));
  current_mask_intersect_list_status.num_elements = number_of_masked_volumes;
  if (number_of_masked_volumes >0) current_mask_intersect_list_status.elements = malloc( number_of_masked_volumes * sizeof(int));
  
  // Make a list of component index from each volume index
  volume_index = 0;
  for (iterate=0;iterate<global_geometry_list.num_elements;iterate++) {
    if (global_geometry_list.elements[iterate].active == 1)
        geometry_component_index_list.elements[++volume_index] = global_geometry_list.elements[iterate].component_index;
      
  }
  geometry_component_index_list.elements[0] = 0; // Volume 0 is never set in the above code, but should never be used.
  
  // The input for this component is done through a series of input components
  // All information needed is stored in global lists, some of which is printed here for an overview to the user.
  MPI_MASTER( // MPI_MASTER ensures just one thread output this information to the user
  if (verbal == 1) {
      printf("---------------------------------------------------------------------\n");
      printf("global_process_list.num_elements: %d\n",global_process_list.num_elements);
      for (iterate=0;iterate<global_process_list.num_elements;iterate++) {
      printf("name of process [%d]: %s \n",iterate,global_process_list.elements[iterate].name);
      printf("component index [%d]: %d \n",iterate,global_process_list.elements[iterate].component_index);
      }
      
      printf("---------------------------------------------------------------------\n");
      printf("global_material_list.num_elements: %d\n",global_material_list.num_elements);
      for (iterate=0;iterate<global_material_list.num_elements;iterate++) {
      printf("name of material    [%d]: %s \n",iterate,global_material_list.elements[iterate].name);
      printf("component index     [%d]: %d \n",iterate,global_material_list.elements[iterate].component_index);
      printf("my_absoprtion       [%d]: %f \n",iterate,global_material_list.elements[iterate].physics->my_a);
      printf("number of processes [%d]: %d \n",iterate,global_material_list.elements[iterate].physics->number_of_processes);
      }

      printf("---------------------------------------------------------------------\n");
      printf("global_geometry_list.num_elements: %d\n",global_material_list.num_elements);
      for (iterate=0;iterate<global_geometry_list.num_elements;iterate++) {
        if (global_geometry_list.elements[iterate].active == 1) {
          printf("\n");
          printf("name of geometry    [%d]: %s \n",iterate,global_geometry_list.elements[iterate].name);
          printf("component index     [%d]: %d \n",iterate,global_geometry_list.elements[iterate].component_index);
          printf("Volume.name         [%d]: %s \n",iterate,global_geometry_list.elements[iterate].Volume->name);
          if (global_geometry_list.elements[iterate].Volume->geometry.is_mask_volume == 0) {
          printf("Volume.p_physics.is_vacuum           [%d]: %d \n",iterate,global_geometry_list.elements[iterate].Volume->p_physics->is_vacuum);
          printf("Volume.p_physics.my_absoprtion       [%d]: %f \n",iterate,global_geometry_list.elements[iterate].Volume->p_physics->my_a);
          printf("Volume.p_physics.number of processes [%d]: %d \n",iterate,global_geometry_list.elements[iterate].Volume->p_physics->number_of_processes);
          }
          printf("Volume.geometry.shape                [%d]: %s \n",iterate,global_geometry_list.elements[iterate].Volume->geometry.shape);
          printf("Volume.geometry.center.x             [%d]: %f \n",iterate,global_geometry_list.elements[iterate].Volume->geometry.center.x);
          printf("Volume.geometry.center.y             [%d]: %f \n",iterate,global_geometry_list.elements[iterate].Volume->geometry.center.y);
          printf("Volume.geometry.center.z             [%d]: %f \n",iterate,global_geometry_list.elements[iterate].Volume->geometry.center.z);
          printf("Volume.geometry.rotation_matrix[0]           [%d]: [%f %f %f] \n",iterate,global_geometry_list.elements[iterate].Volume->geometry.rotation_matrix[0][0],global_geometry_list.elements[iterate].Volume->geometry.rotation_matrix[0][1],global_geometry_list.elements[iterate].Volume->geometry.rotation_matrix[0][2]);
          printf("Volume.geometry.rotation_matrix[1]           [%d]: [%f %f %f] \n",iterate,global_geometry_list.elements[iterate].Volume->geometry.rotation_matrix[1][0],global_geometry_list.elements[iterate].Volume->geometry.rotation_matrix[1][1],global_geometry_list.elements[iterate].Volume->geometry.rotation_matrix[1][2]);
          printf("Volume.geometry.rotation_matrix[2]           [%d]: [%f %f %f] \n",iterate,global_geometry_list.elements[iterate].Volume->geometry.rotation_matrix[2][0],global_geometry_list.elements[iterate].Volume->geometry.rotation_matrix[2][1],global_geometry_list.elements[iterate].Volume->geometry.rotation_matrix[2][2]);
          if (strcmp(global_geometry_list.elements[iterate].Volume->geometry.shape,"cylinder") == 0) {
          printf("Volume.geometry.geometry_parameters.cyl_radius [%d]: %f \n",iterate,global_geometry_list.elements[iterate].Volume->geometry.geometry_parameters.p_cylinder_storage->cyl_radius);
          printf("Volume.geometry.geometry_parameters.height [%d]: %f \n",iterate,global_geometry_list.elements[iterate].Volume->geometry.geometry_parameters.p_cylinder_storage->height);
          }
          printf("Volume.geometry.focus_data_array.elements[0].Aim             [%d]: [%f %f %f] \n",iterate,global_geometry_list.elements[iterate].Volume->geometry.focus_data_array.elements[0].Aim.x,global_geometry_list.elements[iterate].Volume->geometry.focus_data_array.elements[0].Aim.y,global_geometry_list.elements[iterate].Volume->geometry.focus_data_array.elements[0].Aim.z);
        }
      }
      printf("---------------------------------------------------------------------\n");
      printf("number_of_volumes = %d\n",number_of_volumes);
      printf("number_of_masks = %d\n",number_of_masks);
      printf("number_of_masked_volumes = %d\n",number_of_masked_volumes);
  }
  ); // End MPI_MASTER
  
  
  // --- Initialization tasks independent of volume stucture -----------------------

  // Store a pointer to the conditional list and update the current index in that structure
  // If no tagging_conditionals were defined between this and the previous master, a dummy is allocated instead
  if (global_tagging_conditional_list.num_elements == global_tagging_conditional_list.current_index + 1) {
    tagging_conditional_list = &global_tagging_conditional_list.elements[global_tagging_conditional_list.current_index++].conditional_list;
    free_tagging_conditioanl_list = 0;
  } else {
    tagging_conditional_list = malloc(sizeof(struct conditional_list_struct));
    tagging_conditional_list->num_elements = 0;
    free_tagging_conditioanl_list = 1;
  }
  
  // Find the maximum logger extend index so that the correct memory allocation can be performed later
  // Here the loggers applied to all volumes are searched, later this result is compared to volume specific loggers and updated
  max_conditional_extend_index = -1;
  for (iterate=0;iterate<global_all_volume_logger_list.num_elements;iterate++) {
    if (global_all_volume_logger_list.elements[iterate].logger->logger_extend_index > max_conditional_extend_index) {
      max_conditional_extend_index = global_all_volume_logger_list.elements[iterate].logger->logger_extend_index;
    }
  }
  
  // The absolute rotation of this component is saved for use in initialization
  rot_transpose(ROT_A_CURRENT_COMP,master_transposed_rotation_matrix);
  
  // Preceeding componnets can add coordinates and rotations to global_positions_to_transform and global_rotations_to_transform
  //  in order to have these transformed into the coordinate system of the next master compoent in the instrument file.
  // Here these transformations are performed, and the lists are cleared so no transformed information is further altered by
  //  next master components.
  
  // Position transformation
  for (iterate=0;iterate<global_positions_to_transform_list.num_elements;iterate++) {
    //print_position(*global_positions_to_transform_list.positions[iterate],"Position to transform before");
    non_rotated_position = coords_sub(*(global_positions_to_transform_list.positions[iterate]),POS_A_CURRENT_COMP);
    *(global_positions_to_transform_list.positions[iterate]) = rot_apply(ROT_A_CURRENT_COMP,non_rotated_position);
    //print_position(*global_positions_to_transform_list.positions[iterate],"Position to transform after");
  }
  if (global_positions_to_transform_list.num_elements > 0) {
    global_positions_to_transform_list.num_elements = 0;
    free(global_positions_to_transform_list.positions);
  }
  // Rotation transformation
  for (iterate=0;iterate<global_rotations_to_transform_list.num_elements;iterate++) {
    //print_rotation(*(global_rotations_to_transform_list.rotations[iterate]),"rotation matrix to be updated");
    rot_mul(master_transposed_rotation_matrix,*(global_rotations_to_transform_list.rotations[iterate]),temp_rotation_matrix);
    rot_copy(*(global_rotations_to_transform_list.rotations[iterate]),temp_rotation_matrix);
  }
  if (global_rotations_to_transform_list.num_elements > 0) {
    global_rotations_to_transform_list.num_elements = 0;
    free(global_rotations_to_transform_list.rotations);
  }

  
  // --- Definition of volumes and loading of appropriate data  -----------------------
  
  // The information stored in global lists is to be stored in one array of structures that is allocated here
  Volumes = malloc(number_of_volumes * sizeof(struct Volume_struct*));
  scattered_flag = malloc(number_of_volumes*sizeof(int));
  scattered_flag_VP = (int**) malloc(number_of_volumes * sizeof(int*));
  number_of_processes_array = malloc(number_of_volumes*sizeof(int));
  
  // The mcdisplay functions need access to the other geomtries, but can not use the Volumes struct because of order of definition.
  // A separate list of pointers to the geometry structures is thus allocated
  Geometries = malloc(number_of_volumes * sizeof(struct geometry_struct *));
  
  // When activation counter is used to have several copies of one volume, it can become necessary to have soft copies of volumes
  // Not all of these will necessarily be allocated or used.
  Volume_copies = malloc(number_of_volumes * sizeof(struct Volume_struct *));
  Volume_copies_allocated.num_elements = 0;
  
  // The central structure is called a "Volume", it describes a region in space with certain scattering processes and absorption cross section

  // ---  Volume 0 ------------------------------------------------------------------------------------------------
  // Volume 0 is the vacuum surrounding the experiment (infinite, everywhere) and its properties are hardcoded here
  Volumes[0] = malloc(sizeof(struct Volume_struct));
  strcpy(Volumes[0]->name,"Surrounding vacuum");
  // Assign geometry
  
  // This information is meaningless for volume 0, and is never be acsessed in the logic.
  Volumes[0]->geometry.priority_value = 0.0;
  Volumes[0]->geometry.center.x = 0;
  Volumes[0]->geometry.center.y = 0;
  Volumes[0]->geometry.center.z = 0;
  strcpy(Volumes[0]->geometry.shape,"vacuum");
  Volumes[0]->geometry.within_function = &r_within_surroundings; // Always returns 1
  // No physics struct allocated
  Volumes[0]->p_physics = NULL;
  number_of_processes_array[volume_index] = 0;
  
  // These are never used for volume 0, but by setting the length to 0 it is automatically skipped in many forloops without the need for an if statement
  Volumes[0]->geometry.children.num_elements=0;
  Volumes[0]->geometry.direct_children.num_elements=0;
  Volumes[0]->geometry.destinations_list.num_elements=0;
  Volumes[0]->geometry.reduced_destinations_list.num_elements=0;
  
  Volumes[0]->geometry.masked_by_list.num_elements = 0;
  Volumes[0]->geometry.mask_list.num_elements = 0;
  Volumes[0]->geometry.masked_by_mask_index_list.num_elements = 0;
  Volumes[0]->geometry.mask_mode=0;
  Volumes[0]->geometry.is_mask_volume=0;
  Volumes[0]->geometry.is_masked_volume=0;
  
  // A pointer to the geometry structure
  Geometries[0] = &Volumes[0]->geometry;
  
  // Logging initialization
  Volumes[0]->loggers.num_elements = 0;
  
  
  // --- Loop over user defined volumes ------------------------------------------------------------------------
  // Here the user defined volumes are loaded into the volume structure that is used in the ray-tracing
  //  algorithm. Not all user defined volumes are used, some could be used by a previous master, some
  //  could be used by the previous master, this one, and perhaps more. This is controlled by the
  //  activation counter input for geometries, and is here condensed to the active variable.
  // Volumes that were used before
  
  
  max_number_of_processes = 0; // The maximum number of processes in a volume is assumed 0 and updated during the following loop
  
  volume_index = 0;
  mask_index_main = 0;
  for (geometry_list_index=0;geometry_list_index<global_geometry_list.num_elements;geometry_list_index++) {
    if (global_geometry_list.elements[geometry_list_index].active == 1) { // Only include the volume if it is active
      volume_index++;
      // Connect a volume for each of the geometry.comp instances in the McStas instrument files
      if (global_geometry_list.elements[geometry_list_index].activation_counter == 0) {
        // This is the last time this volume is used, use the hard copy from the geometry component
        Volumes[volume_index] = global_geometry_list.elements[geometry_list_index].Volume;
        //printf("used hard copy of volume %d \n",volume_index);
      } else {
        // Since this volume is still needed more than this once, we need to make a shallow copy and use instead
        
        //printf("\n");
        //printf("making local copy of volume %d \n",volume_index);
        Volume_copies[volume_index] = malloc(sizeof(struct Volume_struct));
        *(Volume_copies[volume_index]) = *global_geometry_list.elements[geometry_list_index].Volume; // Makes shallow copy
        Volumes[volume_index] = Volume_copies[volume_index];
        add_element_to_int_list(&Volume_copies_allocated,volume_index); // Keep track of dynamically allocated volumes in order to free them in FINALLY.
        
        // The geometry storage needs a shallow copy as well (hard copy not necessary for any current geometries), may need changes in future
        // A simple copy_geometry_parameters function is added to the geometry in each geometry component
        Volumes[volume_index]->geometry.geometry_parameters = Volumes[volume_index]->geometry.copy_geometry_parameters(&global_geometry_list.elements[geometry_list_index].Volume->geometry.geometry_parameters);
          
      }
      
      // This section identifies the different non isotropic processes in the current volume and give them appropriate transformation matrices
      // Identify the number of non isotropic processes in a material (this code can be safely executed for the same material many times)
      // A setting of -1 means no transformation necessary, other settings are assigned a unique identifier instead
      non_isotropic_found = 0;
      for (iterate=0;iterate<Volumes[volume_index]->p_physics->number_of_processes;iterate++) {
        if (Volumes[volume_index]->p_physics->p_scattering_array[iterate].non_isotropic_rot_index != -1) {
            Volumes[volume_index]->p_physics->p_scattering_array[iterate].non_isotropic_rot_index = non_isotropic_found;
            non_isotropic_found++;
        }
      }
      
      Volumes[volume_index]->geometry.focus_array_indices.num_elements=0;
      // For the non_isotropic volumes found, rotation matrices need to be allocated and calculated
      if (non_isotropic_found > 0) {
        // Allocation of rotation and transpose rotation matrices
        if (Volumes[volume_index]->geometry.process_rot_allocated == 0) {
          Volumes[volume_index]->geometry.process_rot_matrix_array = malloc(non_isotropic_found * sizeof(Rotation));
          Volumes[volume_index]->geometry.transpose_process_rot_matrix_array = malloc(non_isotropic_found * sizeof(Rotation));
          Volumes[volume_index]->geometry.process_rot_allocated = 1;
        }
      
        // Calculation of the appropriate rotation matrices for transformation between Union_master and the process in a given volume.
        non_isotropic_found = 0;
        for (iterate=0;iterate<Volumes[volume_index]->p_physics->number_of_processes;iterate++) {
          if (Volumes[volume_index]->p_physics->p_scattering_array[iterate].non_isotropic_rot_index != -1) {
            // Transformation for each process / geometry combination
            
            // The focus vector is given in relation to the geometry and needs to be transformed to the process
            // Work on temporary_focus_data_element which is added to the focus_data_array_at the end
            temporary_focus_data = Volumes[volume_index]->geometry.focus_data_array.elements[0];
            
            // Correct for process rotation
            temporary_focus_data.Aim = rot_apply(Volumes[volume_index]->p_physics->p_scattering_array[iterate].rotation_matrix,temporary_focus_data.Aim);
            
            // Add element to focus_array_indices
            // focus_array_indices refers to the correct element in focus_data_array for this volume/process combination
            // focus_data_array[0] is the isotropic version in all cases, so the first non_isotropic goes to focus_data_array[1]
            //  and so forth. When a process is isotropic, this array is appended with a zero.
            // The focus_array_indices maps process numbers to the correct focus_data_array index.
            add_element_to_int_list(&Volumes[volume_index]->geometry.focus_array_indices,non_isotropic_found+1);
            
            // Add the new focus_data element to this volumes focus_data_array.
            add_element_to_focus_data_array(&Volumes[volume_index]->geometry.focus_data_array,temporary_focus_data);
            
            // Quick error check to see the length is correct which indirectly confirms the indices are correct
            if (Volumes[volume_index]->geometry.focus_data_array.num_elements != non_isotropic_found + 2) {
              printf("ERROR, focus_data_array length for volume %s inconsistent with number of non isotropic processes found!\n",Volumes[volume_index]->name);
              exit(1);
            }
            
            // Create rotation matrix for this specific volume / process combination to transform from master coordinate system to the non-isotropics process coordinate system
            // This is done by multipling the transpose master component roration matrix, the volume rotation, and then the process rotation matrix onto the velocity / wavevector
            rot_mul(Volumes[volume_index]->geometry.rotation_matrix,master_transposed_rotation_matrix,temp_rotation_matrix);
            rot_mul(Volumes[volume_index]->p_physics->p_scattering_array[iterate].rotation_matrix,temp_rotation_matrix,Volumes[volume_index]->geometry.process_rot_matrix_array[non_isotropic_found]);
            
            // Need to transpose as well to transform back to the master coordinate system
            rot_transpose(Volumes[volume_index]->geometry.process_rot_matrix_array[non_isotropic_found],Volumes[volume_index]->geometry.transpose_process_rot_matrix_array[non_isotropic_found]);

            // Debug print
            //print_rotation(Volumes[volume_index]->geometry.process_rot_matrix_array[non_isotropic_found],"Process rotation matrix");
            //print_rotation(Volumes[volume_index]->geometry.transpose_process_rot_matrix_array[non_isotropic_found],"Transpose process rotation matrix");
            
            non_isotropic_found++;
          } else {
            // This process can use the standard isotropic focus_data_array which is indexed zero.
            add_element_to_int_list(&Volumes[volume_index]->geometry.focus_array_indices,0);
          }
        }
      } else {
      // No non isotropic volumes found, focus_array_indices should just be a list of 0's of same length as the number of processes.
      // In this way all processes use the isotropic focus_data structure
        Volumes[volume_index]->geometry.focus_array_indices.elements = malloc(Volumes[volume_index]->p_physics->number_of_processes * sizeof(int));
        for (iterate=0;iterate<Volumes[volume_index]->p_physics->number_of_processes;iterate++)
          Volumes[volume_index]->geometry.focus_array_indices.elements[iterate] = 0;
          
      }
      //print_1d_int_list(Volumes[volume_index]->geometry.focus_array_indices,"focus_array_indices");
      
      
      // This component works in its local coordinate system, and thus all information from the input components should be transformed to its coordinate system.
      // All the input components saved their absolute rotation/position into their Volume structure, and the absolute rotation of the current component is known.
      // The next section finds the relative rotation and translation of all the volumes and the master component.
      
      // Transform the rotation matrices for each volume
      rot_mul(ROT_A_CURRENT_COMP,Volumes[volume_index]->geometry.transpose_rotation_matrix,temp_rotation_matrix);
      // Copy the result back to the volumes structure
      rot_copy(Volumes[volume_index]->geometry.rotation_matrix,temp_rotation_matrix);
      // Now update the transpose as well
      rot_transpose(Volumes[volume_index]->geometry.rotation_matrix,temp_rotation_matrix);
      rot_copy(Volumes[volume_index]->geometry.transpose_rotation_matrix,temp_rotation_matrix);
        
      // Transform the position for each volume
      non_rotated_position.x = Volumes[volume_index]->geometry.center.x - POS_A_CURRENT_COMP.x;
      non_rotated_position.y = Volumes[volume_index]->geometry.center.y - POS_A_CURRENT_COMP.y;
      non_rotated_position.z = Volumes[volume_index]->geometry.center.z - POS_A_CURRENT_COMP.z;

      rot_transpose(ROT_A_CURRENT_COMP,temp_rotation_matrix); // REVIEW LINE
      rotated_position = rot_apply(ROT_A_CURRENT_COMP,non_rotated_position);

      Volumes[volume_index]->geometry.center.x = rotated_position.x;
      Volumes[volume_index]->geometry.center.y = rotated_position.y;
      Volumes[volume_index]->geometry.center.z = rotated_position.z;
      
      // The focus_data information need to be updated as well
      rot_mul(ROT_A_CURRENT_COMP,Volumes[volume_index]->geometry.focus_data_array.elements[0].absolute_rotation,temp_rotation_matrix);
      // Copy the result back to the volumes structure
      rot_copy(Volumes[volume_index]->geometry.focus_data_array.elements[0].absolute_rotation,temp_rotation_matrix);
      
      // Use same rotation on the aim vector of the isotropic focus_data element
      Volumes[volume_index]->geometry.focus_data_array.elements[0].Aim = rot_apply(Volumes[volume_index]->geometry.rotation_matrix,Volumes[volume_index]->geometry.focus_data_array.elements[0].Aim);
      
      // To allocate enough memory to hold information on all processes, the maximum of these is updated if this volume has more
      if (Volumes[volume_index]->p_physics->number_of_processes > max_number_of_processes)
          max_number_of_processes = Volumes[volume_index]->p_physics->number_of_processes;
        
      // Allocate memory to scattered_flag_VP (holds statistics for scatterings in each process of the volume)
      scattered_flag_VP[volume_index] = malloc(Volumes[volume_index]->p_physics->number_of_processes * sizeof(int));
      number_of_processes_array[volume_index] = Volumes[volume_index]->p_physics->number_of_processes;
      
      // Normalizing and error checking process interact fraction
      number_of_process_interacts_set = 0; total_process_interact=0;
      for (process_index=0;process_index<Volumes[volume_index]->p_physics->number_of_processes;process_index++) {
        if (Volumes[volume_index]->p_physics->p_scattering_array[process_index].process_p_interact != -1) {
          number_of_process_interacts_set++;
          total_process_interact += Volumes[volume_index]->p_physics->p_scattering_array[process_index].process_p_interact;
        } else {
          index_of_lacking_process = process_index;
        }
      }
      
      if (number_of_process_interacts_set == 0) Volumes[volume_index]->p_physics->interact_control = 0;
      else Volumes[volume_index]->p_physics->interact_control = 1;
      
      // If all are set, check if they need renormalization so that the sum is one.
      if (number_of_process_interacts_set == Volumes[volume_index]->p_physics->number_of_processes) {
        if (total_process_interact > 1.001 || total_process_interact < 0.999) {
          for (process_index=0;process_index<Volumes[volume_index]->p_physics->number_of_processes;process_index++) {
            Volumes[volume_index]->p_physics->p_scattering_array[process_index].process_p_interact = Volumes[volume_index]->p_physics->p_scattering_array[process_index].process_p_interact/total_process_interact;
          }
        }
      } else if ( number_of_process_interacts_set != 0) {
        if (number_of_process_interacts_set == Volumes[volume_index]->p_physics->number_of_processes - 1) {// If all but one is set, it is an easy fix
          Volumes[volume_index]->p_physics->p_scattering_array[index_of_lacking_process].process_p_interact = 1 - total_process_interact;
          if (total_process_interact >= 1) {
            printf("ERROR, material %s has a total interact_fraction above 1 and a process without an interact_fraction. Either set all so they can be renormalized, or have a sum below 1, so that the last can have 1 - sum.\n",Volumes[volume_index]->p_physics->name);
            exit(1);
          }
        } else {
            printf("ERROR, material %s needs to have all, all minus one or none of its processes with an interact_fraction \n",Volumes[volume_index]->p_physics->name);
            exit(1);
        }
      }
        
      // Some initialization can only happen after the rotation matrix relative to the master is known
      // Such initialization is placed in the geometry component, and executed here through a function pointer
      Volumes[volume_index]->geometry.initialize_from_main_function(&Volumes[volume_index]->geometry);
      
      // Add pointer to geometry to Geometries
      Geometries[volume_index] = &Volumes[volume_index]->geometry;
      
      // Initialize mask intersect list
      Volumes[volume_index]->geometry.mask_intersect_list.num_elements = 0;
      
      // Here the mask_list and masked_by_list for the volume is updated from component index values to volume indexes
      for (iterate=0;iterate<Volumes[volume_index]->geometry.mask_list.num_elements;iterate++)
        Volumes[volume_index]->geometry.mask_list.elements[iterate] = find_on_int_list(geometry_component_index_list,Volumes[volume_index]->geometry.mask_list.elements[iterate]);
      
      for (iterate=0;iterate<Volumes[volume_index]->geometry.masked_by_list.num_elements;iterate++)
        Volumes[volume_index]->geometry.masked_by_list.elements[iterate] = find_on_int_list(geometry_component_index_list,Volumes[volume_index]->geometry.masked_by_list.elements[iterate]);
      
      // If the volume is a mask, its volume number is added to the mask_volume_index list so volume index can be converted to mask_index.
      if (Volumes[volume_index]->geometry.is_mask_volume == 1) Volumes[volume_index]->geometry.mask_index = mask_index_main;
      if (Volumes[volume_index]->geometry.is_mask_volume == 1) mask_volume_index_list.elements[mask_index_main++] = volume_index;
     
      // Check all loggers assosiated with this volume and update the max_conditional_extend_index if necessary
      //printf("reached max_test for volume %d \n",volume_index);
      for (iterate=0;iterate<Volumes[volume_index]->loggers.num_elements;iterate++) {
        //printf("iterate = %d \n",iterate);
        for (process_index=0;process_index<Volumes[volume_index]->loggers.p_logger_volume[iterate].num_elements;process_index++) {
        //printf("process_index = %d \n",process_index);
          if (Volumes[volume_index]->loggers.p_logger_volume[iterate].p_logger_process[process_index] != NULL) {
            if (Volumes[volume_index]->loggers.p_logger_volume[iterate].p_logger_process[process_index]->logger_extend_index > max_conditional_extend_index)
              max_conditional_extend_index = Volumes[volume_index]->loggers.p_logger_volume[iterate].p_logger_process[process_index]->logger_extend_index;
          }
        }
      }
      //printf("did max_test for volume %d\n",volume_index);
      
    
    }
  } // Initialization for each volume done
  
  // ------- Initialization of ray-tracing algorithm ------------------------------------
   
  my_trace = malloc(max_number_of_processes*sizeof(double));
  my_trace_fraction_control = malloc(max_number_of_processes*sizeof(double));
  
  // All geometries can have 2 intersections currently, when this changes the maximum number of solutions need to be reported to the Union_master.
  number_of_solutions = &number_of_solutions_static;
  component_error_msg = 0;
  
  // Pre allocated memory for destination list search
  pre_allocated1 = malloc(number_of_volumes * sizeof(int));
  pre_allocated2 = malloc(number_of_volumes * sizeof(int));
  pre_allocated3 = malloc(number_of_volumes * sizeof(int));
  
  // Allocate memory for logger_conditional_extend_array used in the extend section of the master component, if it is needed.
  if (max_conditional_extend_index > -1) {
    logger_conditional_extend_array = malloc((max_conditional_extend_index + 1)*sizeof(int));
  }
  
  // In this function different lists of volume indecies are generated. They are the key to the speed of the component and central for the logic.
  // They use simple set algebra to generate these lists for each volume:
  // Children list for volume n: Indicies of volumes that are entirely within the set described by volume n
  // Overlap list for volume n: Indicies of volume that contains some of the set described by volume n (excluding volume n)
  // Intersect check list for volume n: Indicies of volumes to check for intersection if a ray originates from volume n (is generated from the children and overlap lists)
  // Parents list for volume n: Indicies of volumes that contain the entire set of volume n
  // Grandparents lists for volume n: Indicies of volumes that contain the entire set of at least one parent of volume n
  // Destination list for volume n: Indicies of volumes that could be the destination volume when a ray leaves volume n
  // The overlap, parents and grandparents lists are local variables in the function, and not in the main scope.
  
  generate_lists(Volumes, &starting_lists, number_of_volumes, list_verbal);
  
  // Generate "safe starting list", which contains all volumes that the ray may enter from other components
  // These are all volumes without scattering or absorption
  
  // Updating mask lists from volume index to global_mask_indices
  // Filling out the masked_by list that uses mask indices
  for (volume_index=0;volume_index<number_of_volumes;volume_index++) {
    Volumes[volume_index]->geometry.masked_by_mask_index_list.num_elements = Volumes[volume_index]->geometry.masked_by_list.num_elements;
    Volumes[volume_index]->geometry.masked_by_mask_index_list.elements = malloc(Volumes[volume_index]->geometry.masked_by_mask_index_list.num_elements * sizeof(int));
    for (iterate=0;iterate<Volumes[volume_index]->geometry.masked_by_list.num_elements;iterate++)
        Volumes[volume_index]->geometry.masked_by_mask_index_list.elements[iterate] = find_on_int_list(mask_volume_index_list,Volumes[volume_index]->geometry.masked_by_list.elements[iterate]);
  }
  
  // Optimizing speed of the within_which_volume search algorithm
  int volume_index_main; // REVIEW_LINE
  /*
  for (volume_index_main=0;volume_index_main<number_of_volumes;volume_index_main++) {
    Volumes[volume_index_main]->geometry.destinations_logic_list.elements[0] = 0;
  }
  */
  
  // Checking for equal priorities in order to alert the user to a potential input error
  for (volume_index_main=0;volume_index_main<number_of_volumes;volume_index_main++) {
    for (volume_index=0;volume_index<number_of_volumes;volume_index++)
        if (Volumes[volume_index_main]->geometry.priority_value == Volumes[volume_index]->geometry.priority_value && volume_index_main != volume_index) {
            if (Volumes[volume_index_main]->geometry.is_mask_volume == 0 && Volumes[volume_index]->geometry.is_mask_volume == 0) {
              // Priority of masks do not matter
              printf("ERROR in Union_master with name %s. The volumes named %s and %s have the same priority. Change the priorities so the one present in case of overlap has highest priority.\n",NAME_CURRENT_COMP,Volumes[volume_index_main]->name,Volumes[volume_index]->name);
              exit(1);
            }
        }
  }
  
  
  // Printing the generated lists for all volumes.
  MPI_MASTER(
  if (verbal) printf("\n ---- Overview of the lists generated for each volume ---- \n");
  
  for (volume_index_main=0;volume_index_main<number_of_volumes;volume_index_main++) {
      if (verbal) sprintf(string_output,"Children for Volume                  %d",volume_index_main);
      if (verbal) print_1d_int_list(Volumes[volume_index_main]->geometry.children,string_output);
      
      if (verbal) sprintf(string_output,"Direct_children for Volume           %d",volume_index_main);
      if (verbal) print_1d_int_list(Volumes[volume_index_main]->geometry.direct_children,string_output);
      
      if (verbal) sprintf(string_output,"Intersect_check_list for Volume      %d",volume_index_main);
      if (verbal) print_1d_int_list(Volumes[volume_index_main]->geometry.intersect_check_list,string_output);
      
      if (verbal) sprintf(string_output,"Mask_intersect_list for Volume       %d",volume_index_main);
      if (verbal) print_1d_int_list(Volumes[volume_index_main]->geometry.mask_intersect_list,string_output);
      
      if (verbal) sprintf(string_output,"Destinations_list for Volume         %d",volume_index_main);
      if (verbal) print_1d_int_list(Volumes[volume_index_main]->geometry.destinations_list,string_output);
      
      //if (verbal) sprintf(string_output,"Destinations_logic_list for Volume   %d",volume_index_main);
      //if (verbal) print_1d_int_list(Volumes[volume_index_main]->geometry.destinations_logic_list,string_output);
      
      if (verbal) sprintf(string_output,"Reduced_destinations_list for Volume %d",volume_index_main);
      if (verbal) print_1d_int_list(Volumes[volume_index_main]->geometry.reduced_destinations_list,string_output);
      
      if (verbal) sprintf(string_output,"Next_volume_list for Volume          %d",volume_index_main);
      if (verbal) print_1d_int_list(Volumes[volume_index_main]->geometry.next_volume_list,string_output);
      
      if (verbal) {
        if (volume_index_main != 0)
                           printf("      Is_vacuum for Volume                 %d = %d\n",volume_index_main,Volumes[volume_index_main]->p_physics->is_vacuum);
      }
      if (verbal) {
        if (volume_index_main != 0)
                           printf("      is_mask_volume for Volume            %d = %d\n",volume_index_main,Volumes[volume_index_main]->geometry.is_mask_volume);
      }
      if (verbal) {
        if (volume_index_main != 0)
                           printf("      is_masked_volume for Volume          %d = %d\n",volume_index_main,Volumes[volume_index_main]->geometry.is_masked_volume);
      }
      if (verbal) {
        if (volume_index_main != 0)
                           printf("      is_exit_volume for Volume            %d = %d\n",volume_index_main,Volumes[volume_index_main]->geometry.is_exit_volume);
      }
      
      if (verbal) sprintf(string_output,"mask_list for Volume                 %d",volume_index_main);
      if (verbal) print_1d_int_list(Volumes[volume_index_main]->geometry.mask_list,string_output);
      
      if (verbal) sprintf(string_output,"masked_by_list for Volume            %d",volume_index_main);
      if (verbal) print_1d_int_list(Volumes[volume_index_main]->geometry.masked_by_list,string_output);
      
      if (verbal) sprintf(string_output,"masked_by_mask_index_list for Volume %d",volume_index_main);
      if (verbal) print_1d_int_list(Volumes[volume_index_main]->geometry.masked_by_mask_index_list,string_output);
      
      if (verbal)          printf("      mask_mode for Volume                 %d = %d\n",volume_index_main,Volumes[volume_index_main]->geometry.mask_mode);
      if (verbal) printf("\n");
  }
  ) // End of MPI_MASTER
  

  // Initializing intersection_time_table
  // The intersection time table contains all information on intersection times for the current position/direction, and is cleared everytime a ray changes direction.
  // Not all entries needs to be calculated, so there is a variable that keeps track of which intersection times have been calculated in order to avoid redoing that.
  // When the intersections times are calculated for a volume, all future intersections are kept in the time table.
  // Thus the memory allocation have to take into account how many intersections there can be with each volume, but it is currently set to 2, but can easily be changed. This may need to be reported by individual geometry components in the future.
  
  intersection_time_table.num_volumes = number_of_volumes;
  
  intersection_time_table.n_elements = (int*) malloc(intersection_time_table.num_volumes * sizeof(int));
  intersection_time_table.calculated = (int*) malloc(intersection_time_table.num_volumes * sizeof(int));
  intersection_time_table.intersection_times = (double**) malloc(intersection_time_table.num_volumes * sizeof(double));
  for (iterate = 0;iterate < intersection_time_table.num_volumes;iterate++){
      intersection_time_table.n_elements[iterate] = (int) 2; // number of intersection solutions
      if (iterate == 0) intersection_time_table.n_elements[iterate] = (int) 0; // number of intersection solutions
      intersection_time_table.calculated[iterate] = (int) 0; // Initializing calculated logic
      
      if (iterate == 0) {
           intersection_time_table.intersection_times[0] = NULL;
      }
      else {
        intersection_time_table.intersection_times[iterate] = (double*) malloc(intersection_time_table.n_elements[iterate]*sizeof(double));
        for (solutions = 0;solutions < intersection_time_table.n_elements[iterate];solutions++) {
              intersection_time_table.intersection_times[iterate][solutions] = -1.0;
        }
      }
  }
  
  
  
  
  // If enabled, the tagging system tracks all different histories sampled by the program.

  // Initialize the tagging tree
  // Allocate a list of host nodes with the same length as the number of volumes
  
  stop_creating_nodes = 0; stop_tagging_ray = 0; tagging_leaf_counter = 0;
  if (enable_tagging) {
    master_tagging_node_list.num_elements = number_of_volumes;
    master_tagging_node_list.elements = malloc(master_tagging_node_list.num_elements * sizeof(struct tagging_tree_node_struct*));
  
    // Initialize
    for (volume_index=0;volume_index<number_of_volumes;volume_index++) {
      //if (verbal) printf("Allocating master tagging node for volume number %d \n",volume_index);
      master_tagging_node_list.elements[volume_index] = initialize_tagging_tree_node(master_tagging_node_list.elements[volume_index], NULL, Volumes[volume_index]);
      //if (verbal) printf("Allocated master tagging node for volume number %d \n",volume_index);
    }
  }
  
  // Initialize loggers
  loggers_with_data_array.allocated_elements = 0;
  loggers_with_data_array.used_elements = 0;
  
  
  // Signal initialization complete
  MPI_MASTER(
    printf("Union_master component %s initialized sucessfully\n",NAME_CURRENT_COMP);
  )

}
#line 341489 "MACS_sample_kidney_box.c"
#undef inherit_number_of_scattering_events
#undef enable_conditionals
#undef history_limit
#undef allow_inside_start
#undef focus_data_index
#undef temporary_focus_data
#undef number_of_processes_array
#undef safty_distance2
#undef safty_distance
#undef max_conditional_extend_index
#undef tagging_conditional_extend
#undef logger_conditional_extend_array
#undef free_tagging_conditioanl_list
#undef tagging_conditional_list
#undef conditional_status
#undef this_logger
#undef p_old
#undef Volume_copies_allocated
#undef geometry_component_index_list
#undef mask_volume_index_list
#undef current_mask_intersect_list_status
#undef mask_status_list
#undef mask_iterate
#undef mask_index_main
#undef need_to_run_within_which_volume
#undef number_of_masked_volumes
#undef number_of_masks
#undef mc_transmission_probability
#undef real_transmission_probability
#undef number_of_scattering_events
#undef tagging_leaf_counter
#undef current_tagging_node
#undef master_tagging_node_list
#undef enable_tagging_check
#undef stop_creating_nodes
#undef stop_tagging_ray
#undef enable_tagging
#undef rotated_position
#undef non_rotated_position
#undef temp_rotation_matrix
#undef master_transposed_rotation_matrix
#undef scattered_flag_VP
#undef scattered_flag
#undef volume_0_found
#undef ray_velocity_final
#undef ray_velocity
#undef ray_position
#undef pre_allocated3
#undef pre_allocated2
#undef pre_allocated1
#undef tree_next_volume
#undef geometry_output
#undef intersection_with_children
#undef start
#undef check
#undef number_of_solutions_static
#undef number_of_solutions
#undef current_volume
#undef done
#undef next_volume_priority
#undef next_volume
#undef a_next_volume_found
#undef time_propagated_without_scattering
#undef scattering_event
#undef selected_process
#undef time_to_boundery
#undef length_to_boundery
#undef length_to_scattering
#undef time_to_scattering
#undef mc_prop
#undef culmative_probability
#undef my_sum_plus_abs
#undef my_sum
#undef v_length
#undef k_old
#undef k_new
#undef k
#undef my_trace_fraction_control
#undef p_my_trace
#undef my_trace
#undef process_start
#undef process
#undef min_intersection_time
#undef intersection_time
#undef time_found
#undef min_volume
#undef min_solution
#undef solution
#undef limit
#undef max_number_of_processes
#undef solutions
#undef process_index
#undef volume_index
#undef number_of_volumes
#undef string_output
#undef component_error_msg
#undef error_msg
#undef v
#undef r_start
#undef r
#undef starting_lists
#undef Geometries
#undef Volumes
#undef intersection_time_table
#undef geometry_list_index
#undef previous_master_index
#undef this_global_master_index
#undef global_master_element
#undef starting_volume_warning
#undef finally_verbal
#undef trace_verbal
#undef list_verbal
#undef verbal
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

  /* Initializations for component diffraction_detector_0. */
  SIG_MESSAGE("diffraction_detector_0 (Init)");
#define mccompcurname  diffraction_detector_0
#define mccompcurtype  PSD_monitor
#define mccompcurindex 885
#define PSD_N mccdiffraction_detector_0_PSD_N
#define PSD_p mccdiffraction_detector_0_PSD_p
#define PSD_p2 mccdiffraction_detector_0_PSD_p2
#define nx mccdiffraction_detector_0_nx
#define ny mccdiffraction_detector_0_ny
#define filename mccdiffraction_detector_0_filename
#define xmin mccdiffraction_detector_0_xmin
#define xmax mccdiffraction_detector_0_xmax
#define ymin mccdiffraction_detector_0_ymin
#define ymax mccdiffraction_detector_0_ymax
#define xwidth mccdiffraction_detector_0_xwidth
#define yheight mccdiffraction_detector_0_yheight
#define restore_neutron mccdiffraction_detector_0_restore_neutron
#line 68 "/usr/share/mcstas/2.7/monitors/PSD_monitor.comp"
{
  if (xwidth  > 0) { xmax = xwidth/2;  xmin = -xmax; }
  if (yheight > 0) { ymax = yheight/2; ymin = -ymax; }

  if ((xmin >= xmax) || (ymin >= ymax)){
    printf("PSD_monitor: %s: Null detection area !\n"
           "ERROR        (xwidth,yheight,xmin,xmax,ymin,ymax). Exiting",
    NAME_CURRENT_COMP);
    exit(-1);
  }

  PSD_N = create_darr2d(nx, ny);
  PSD_p = create_darr2d(nx, ny);
  PSD_p2 = create_darr2d(nx, ny);

  int i, j;
  for (i=0; i<nx; i++){
    for (j=0; j<ny; j++){
      PSD_N[i][j] = 0;
      PSD_p[i][j] = 0;
      PSD_p2[i][j] = 0;
    }
  }
}
#line 341650 "MACS_sample_kidney_box.c"
#undef restore_neutron
#undef yheight
#undef xwidth
#undef ymax
#undef ymin
#undef xmax
#undef xmin
#undef filename
#undef ny
#undef nx
#undef PSD_p2
#undef PSD_p
#undef PSD_N
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

  /* Initializations for component spec_detector_0. */
  SIG_MESSAGE("spec_detector_0 (Init)");
#define mccompcurname  spec_detector_0
#define mccompcurtype  PSD_monitor
#define mccompcurindex 886
#define PSD_N mccspec_detector_0_PSD_N
#define PSD_p mccspec_detector_0_PSD_p
#define PSD_p2 mccspec_detector_0_PSD_p2
#define nx mccspec_detector_0_nx
#define ny mccspec_detector_0_ny
#define filename mccspec_detector_0_filename
#define xmin mccspec_detector_0_xmin
#define xmax mccspec_detector_0_xmax
#define ymin mccspec_detector_0_ymin
#define ymax mccspec_detector_0_ymax
#define xwidth mccspec_detector_0_xwidth
#define yheight mccspec_detector_0_yheight
#define restore_neutron mccspec_detector_0_restore_neutron
#line 68 "/usr/share/mcstas/2.7/monitors/PSD_monitor.comp"
{
  if (xwidth  > 0) { xmax = xwidth/2;  xmin = -xmax; }
  if (yheight > 0) { ymax = yheight/2; ymin = -ymax; }

  if ((xmin >= xmax) || (ymin >= ymax)){
    printf("PSD_monitor: %s: Null detection area !\n"
           "ERROR        (xwidth,yheight,xmin,xmax,ymin,ymax). Exiting",
    NAME_CURRENT_COMP);
    exit(-1);
  }

  PSD_N = create_darr2d(nx, ny);
  PSD_p = create_darr2d(nx, ny);
  PSD_p2 = create_darr2d(nx, ny);

  int i, j;
  for (i=0; i<nx; i++){
    for (j=0; j<ny; j++){
      PSD_N[i][j] = 0;
      PSD_p[i][j] = 0;
      PSD_p2[i][j] = 0;
    }
  }
}
#line 341711 "MACS_sample_kidney_box.c"
#undef restore_neutron
#undef yheight
#undef xwidth
#undef ymax
#undef ymin
#undef xmax
#undef xmin
#undef filename
#undef ny
#undef nx
#undef PSD_p2
#undef PSD_p
#undef PSD_N
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

  /* Initializations for component diffraction_detector_1. */
  SIG_MESSAGE("diffraction_detector_1 (Init)");
#define mccompcurname  diffraction_detector_1
#define mccompcurtype  PSD_monitor
#define mccompcurindex 887
#define PSD_N mccdiffraction_detector_1_PSD_N
#define PSD_p mccdiffraction_detector_1_PSD_p
#define PSD_p2 mccdiffraction_detector_1_PSD_p2
#define nx mccdiffraction_detector_1_nx
#define ny mccdiffraction_detector_1_ny
#define filename mccdiffraction_detector_1_filename
#define xmin mccdiffraction_detector_1_xmin
#define xmax mccdiffraction_detector_1_xmax
#define ymin mccdiffraction_detector_1_ymin
#define ymax mccdiffraction_detector_1_ymax
#define xwidth mccdiffraction_detector_1_xwidth
#define yheight mccdiffraction_detector_1_yheight
#define restore_neutron mccdiffraction_detector_1_restore_neutron
#line 68 "/usr/share/mcstas/2.7/monitors/PSD_monitor.comp"
{
  if (xwidth  > 0) { xmax = xwidth/2;  xmin = -xmax; }
  if (yheight > 0) { ymax = yheight/2; ymin = -ymax; }

  if ((xmin >= xmax) || (ymin >= ymax)){
    printf("PSD_monitor: %s: Null detection area !\n"
           "ERROR        (xwidth,yheight,xmin,xmax,ymin,ymax). Exiting",
    NAME_CURRENT_COMP);
    exit(-1);
  }

  PSD_N = create_darr2d(nx, ny);
  PSD_p = create_darr2d(nx, ny);
  PSD_p2 = create_darr2d(nx, ny);

  int i, j;
  for (i=0; i<nx; i++){
    for (j=0; j<ny; j++){
      PSD_N[i][j] = 0;
      PSD_p[i][j] = 0;
      PSD_p2[i][j] = 0;
    }
  }
}
#line 341772 "MACS_sample_kidney_box.c"
#undef restore_neutron
#undef yheight
#undef xwidth
#undef ymax
#undef ymin
#undef xmax
#undef xmin
#undef filename
#undef ny
#undef nx
#undef PSD_p2
#undef PSD_p
#undef PSD_N
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

  /* Initializations for component spec_detector_1. */
  SIG_MESSAGE("spec_detector_1 (Init)");
#define mccompcurname  spec_detector_1
#define mccompcurtype  PSD_monitor
#define mccompcurindex 888
#define PSD_N mccspec_detector_1_PSD_N
#define PSD_p mccspec_detector_1_PSD_p
#define PSD_p2 mccspec_detector_1_PSD_p2
#define nx mccspec_detector_1_nx
#define ny mccspec_detector_1_ny
#define filename mccspec_detector_1_filename
#define xmin mccspec_detector_1_xmin
#define xmax mccspec_detector_1_xmax
#define ymin mccspec_detector_1_ymin
#define ymax mccspec_detector_1_ymax
#define xwidth mccspec_detector_1_xwidth
#define yheight mccspec_detector_1_yheight
#define restore_neutron mccspec_detector_1_restore_neutron
#line 68 "/usr/share/mcstas/2.7/monitors/PSD_monitor.comp"
{
  if (xwidth  > 0) { xmax = xwidth/2;  xmin = -xmax; }
  if (yheight > 0) { ymax = yheight/2; ymin = -ymax; }

  if ((xmin >= xmax) || (ymin >= ymax)){
    printf("PSD_monitor: %s: Null detection area !\n"
           "ERROR        (xwidth,yheight,xmin,xmax,ymin,ymax). Exiting",
    NAME_CURRENT_COMP);
    exit(-1);
  }

  PSD_N = create_darr2d(nx, ny);
  PSD_p = create_darr2d(nx, ny);
  PSD_p2 = create_darr2d(nx, ny);

  int i, j;
  for (i=0; i<nx; i++){
    for (j=0; j<ny; j++){
      PSD_N[i][j] = 0;
      PSD_p[i][j] = 0;
      PSD_p2[i][j] = 0;
    }
  }
}
#line 341833 "MACS_sample_kidney_box.c"
#undef restore_neutron
#undef yheight
#undef xwidth
#undef ymax
#undef ymin
#undef xmax
#undef xmin
#undef filename
#undef ny
#undef nx
#undef PSD_p2
#undef PSD_p
#undef PSD_N
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

  /* Initializations for component diffraction_detector_2. */
  SIG_MESSAGE("diffraction_detector_2 (Init)");
#define mccompcurname  diffraction_detector_2
#define mccompcurtype  PSD_monitor
#define mccompcurindex 889
#define PSD_N mccdiffraction_detector_2_PSD_N
#define PSD_p mccdiffraction_detector_2_PSD_p
#define PSD_p2 mccdiffraction_detector_2_PSD_p2
#define nx mccdiffraction_detector_2_nx
#define ny mccdiffraction_detector_2_ny
#define filename mccdiffraction_detector_2_filename
#define xmin mccdiffraction_detector_2_xmin
#define xmax mccdiffraction_detector_2_xmax
#define ymin mccdiffraction_detector_2_ymin
#define ymax mccdiffraction_detector_2_ymax
#define xwidth mccdiffraction_detector_2_xwidth
#define yheight mccdiffraction_detector_2_yheight
#define restore_neutron mccdiffraction_detector_2_restore_neutron
#line 68 "/usr/share/mcstas/2.7/monitors/PSD_monitor.comp"
{
  if (xwidth  > 0) { xmax = xwidth/2;  xmin = -xmax; }
  if (yheight > 0) { ymax = yheight/2; ymin = -ymax; }

  if ((xmin >= xmax) || (ymin >= ymax)){
    printf("PSD_monitor: %s: Null detection area !\n"
           "ERROR        (xwidth,yheight,xmin,xmax,ymin,ymax). Exiting",
    NAME_CURRENT_COMP);
    exit(-1);
  }

  PSD_N = create_darr2d(nx, ny);
  PSD_p = create_darr2d(nx, ny);
  PSD_p2 = create_darr2d(nx, ny);

  int i, j;
  for (i=0; i<nx; i++){
    for (j=0; j<ny; j++){
      PSD_N[i][j] = 0;
      PSD_p[i][j] = 0;
      PSD_p2[i][j] = 0;
    }
  }
}
#line 341894 "MACS_sample_kidney_box.c"
#undef restore_neutron
#undef yheight
#undef xwidth
#undef ymax
#undef ymin
#undef xmax
#undef xmin
#undef filename
#undef ny
#undef nx
#undef PSD_p2
#undef PSD_p
#undef PSD_N
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

  /* Initializations for component spec_detector_2. */
  SIG_MESSAGE("spec_detector_2 (Init)");
#define mccompcurname  spec_detector_2
#define mccompcurtype  PSD_monitor
#define mccompcurindex 890
#define PSD_N mccspec_detector_2_PSD_N
#define PSD_p mccspec_detector_2_PSD_p
#define PSD_p2 mccspec_detector_2_PSD_p2
#define nx mccspec_detector_2_nx
#define ny mccspec_detector_2_ny
#define filename mccspec_detector_2_filename
#define xmin mccspec_detector_2_xmin
#define xmax mccspec_detector_2_xmax
#define ymin mccspec_detector_2_ymin
#define ymax mccspec_detector_2_ymax
#define xwidth mccspec_detector_2_xwidth
#define yheight mccspec_detector_2_yheight
#define restore_neutron mccspec_detector_2_restore_neutron
#line 68 "/usr/share/mcstas/2.7/monitors/PSD_monitor.comp"
{
  if (xwidth  > 0) { xmax = xwidth/2;  xmin = -xmax; }
  if (yheight > 0) { ymax = yheight/2; ymin = -ymax; }

  if ((xmin >= xmax) || (ymin >= ymax)){
    printf("PSD_monitor: %s: Null detection area !\n"
           "ERROR        (xwidth,yheight,xmin,xmax,ymin,ymax). Exiting",
    NAME_CURRENT_COMP);
    exit(-1);
  }

  PSD_N = create_darr2d(nx, ny);
  PSD_p = create_darr2d(nx, ny);
  PSD_p2 = create_darr2d(nx, ny);

  int i, j;
  for (i=0; i<nx; i++){
    for (j=0; j<ny; j++){
      PSD_N[i][j] = 0;
      PSD_p[i][j] = 0;
      PSD_p2[i][j] = 0;
    }
  }
}
#line 341955 "MACS_sample_kidney_box.c"
#undef restore_neutron
#undef yheight
#undef xwidth
#undef ymax
#undef ymin
#undef xmax
#undef xmin
#undef filename
#undef ny
#undef nx
#undef PSD_p2
#undef PSD_p
#undef PSD_N
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

  /* Initializations for component diffraction_detector_3. */
  SIG_MESSAGE("diffraction_detector_3 (Init)");
#define mccompcurname  diffraction_detector_3
#define mccompcurtype  PSD_monitor
#define mccompcurindex 891
#define PSD_N mccdiffraction_detector_3_PSD_N
#define PSD_p mccdiffraction_detector_3_PSD_p
#define PSD_p2 mccdiffraction_detector_3_PSD_p2
#define nx mccdiffraction_detector_3_nx
#define ny mccdiffraction_detector_3_ny
#define filename mccdiffraction_detector_3_filename
#define xmin mccdiffraction_detector_3_xmin
#define xmax mccdiffraction_detector_3_xmax
#define ymin mccdiffraction_detector_3_ymin
#define ymax mccdiffraction_detector_3_ymax
#define xwidth mccdiffraction_detector_3_xwidth
#define yheight mccdiffraction_detector_3_yheight
#define restore_neutron mccdiffraction_detector_3_restore_neutron
#line 68 "/usr/share/mcstas/2.7/monitors/PSD_monitor.comp"
{
  if (xwidth  > 0) { xmax = xwidth/2;  xmin = -xmax; }
  if (yheight > 0) { ymax = yheight/2; ymin = -ymax; }

  if ((xmin >= xmax) || (ymin >= ymax)){
    printf("PSD_monitor: %s: Null detection area !\n"
           "ERROR        (xwidth,yheight,xmin,xmax,ymin,ymax). Exiting",
    NAME_CURRENT_COMP);
    exit(-1);
  }

  PSD_N = create_darr2d(nx, ny);
  PSD_p = create_darr2d(nx, ny);
  PSD_p2 = create_darr2d(nx, ny);

  int i, j;
  for (i=0; i<nx; i++){
    for (j=0; j<ny; j++){
      PSD_N[i][j] = 0;
      PSD_p[i][j] = 0;
      PSD_p2[i][j] = 0;
    }
  }
}
#line 342016 "MACS_sample_kidney_box.c"
#undef restore_neutron
#undef yheight
#undef xwidth
#undef ymax
#undef ymin
#undef xmax
#undef xmin
#undef filename
#undef ny
#undef nx
#undef PSD_p2
#undef PSD_p
#undef PSD_N
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

  /* Initializations for component spec_detector_3. */
  SIG_MESSAGE("spec_detector_3 (Init)");
#define mccompcurname  spec_detector_3
#define mccompcurtype  PSD_monitor
#define mccompcurindex 892
#define PSD_N mccspec_detector_3_PSD_N
#define PSD_p mccspec_detector_3_PSD_p
#define PSD_p2 mccspec_detector_3_PSD_p2
#define nx mccspec_detector_3_nx
#define ny mccspec_detector_3_ny
#define filename mccspec_detector_3_filename
#define xmin mccspec_detector_3_xmin
#define xmax mccspec_detector_3_xmax
#define ymin mccspec_detector_3_ymin
#define ymax mccspec_detector_3_ymax
#define xwidth mccspec_detector_3_xwidth
#define yheight mccspec_detector_3_yheight
#define restore_neutron mccspec_detector_3_restore_neutron
#line 68 "/usr/share/mcstas/2.7/monitors/PSD_monitor.comp"
{
  if (xwidth  > 0) { xmax = xwidth/2;  xmin = -xmax; }
  if (yheight > 0) { ymax = yheight/2; ymin = -ymax; }

  if ((xmin >= xmax) || (ymin >= ymax)){
    printf("PSD_monitor: %s: Null detection area !\n"
           "ERROR        (xwidth,yheight,xmin,xmax,ymin,ymax). Exiting",
    NAME_CURRENT_COMP);
    exit(-1);
  }

  PSD_N = create_darr2d(nx, ny);
  PSD_p = create_darr2d(nx, ny);
  PSD_p2 = create_darr2d(nx, ny);

  int i, j;
  for (i=0; i<nx; i++){
    for (j=0; j<ny; j++){
      PSD_N[i][j] = 0;
      PSD_p[i][j] = 0;
      PSD_p2[i][j] = 0;
    }
  }
}
#line 342077 "MACS_sample_kidney_box.c"
#undef restore_neutron
#undef yheight
#undef xwidth
#undef ymax
#undef ymin
#undef xmax
#undef xmin
#undef filename
#undef ny
#undef nx
#undef PSD_p2
#undef PSD_p
#undef PSD_N
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

  /* Initializations for component diffraction_detector_4. */
  SIG_MESSAGE("diffraction_detector_4 (Init)");
#define mccompcurname  diffraction_detector_4
#define mccompcurtype  PSD_monitor
#define mccompcurindex 893
#define PSD_N mccdiffraction_detector_4_PSD_N
#define PSD_p mccdiffraction_detector_4_PSD_p
#define PSD_p2 mccdiffraction_detector_4_PSD_p2
#define nx mccdiffraction_detector_4_nx
#define ny mccdiffraction_detector_4_ny
#define filename mccdiffraction_detector_4_filename
#define xmin mccdiffraction_detector_4_xmin
#define xmax mccdiffraction_detector_4_xmax
#define ymin mccdiffraction_detector_4_ymin
#define ymax mccdiffraction_detector_4_ymax
#define xwidth mccdiffraction_detector_4_xwidth
#define yheight mccdiffraction_detector_4_yheight
#define restore_neutron mccdiffraction_detector_4_restore_neutron
#line 68 "/usr/share/mcstas/2.7/monitors/PSD_monitor.comp"
{
  if (xwidth  > 0) { xmax = xwidth/2;  xmin = -xmax; }
  if (yheight > 0) { ymax = yheight/2; ymin = -ymax; }

  if ((xmin >= xmax) || (ymin >= ymax)){
    printf("PSD_monitor: %s: Null detection area !\n"
           "ERROR        (xwidth,yheight,xmin,xmax,ymin,ymax). Exiting",
    NAME_CURRENT_COMP);
    exit(-1);
  }

  PSD_N = create_darr2d(nx, ny);
  PSD_p = create_darr2d(nx, ny);
  PSD_p2 = create_darr2d(nx, ny);

  int i, j;
  for (i=0; i<nx; i++){
    for (j=0; j<ny; j++){
      PSD_N[i][j] = 0;
      PSD_p[i][j] = 0;
      PSD_p2[i][j] = 0;
    }
  }
}
#line 342138 "MACS_sample_kidney_box.c"
#undef restore_neutron
#undef yheight
#undef xwidth
#undef ymax
#undef ymin
#undef xmax
#undef xmin
#undef filename
#undef ny
#undef nx
#undef PSD_p2
#undef PSD_p
#undef PSD_N
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

  /* Initializations for component spec_detector_4. */
  SIG_MESSAGE("spec_detector_4 (Init)");
#define mccompcurname  spec_detector_4
#define mccompcurtype  PSD_monitor
#define mccompcurindex 894
#define PSD_N mccspec_detector_4_PSD_N
#define PSD_p mccspec_detector_4_PSD_p
#define PSD_p2 mccspec_detector_4_PSD_p2
#define nx mccspec_detector_4_nx
#define ny mccspec_detector_4_ny
#define filename mccspec_detector_4_filename
#define xmin mccspec_detector_4_xmin
#define xmax mccspec_detector_4_xmax
#define ymin mccspec_detector_4_ymin
#define ymax mccspec_detector_4_ymax
#define xwidth mccspec_detector_4_xwidth
#define yheight mccspec_detector_4_yheight
#define restore_neutron mccspec_detector_4_restore_neutron
#line 68 "/usr/share/mcstas/2.7/monitors/PSD_monitor.comp"
{
  if (xwidth  > 0) { xmax = xwidth/2;  xmin = -xmax; }
  if (yheight > 0) { ymax = yheight/2; ymin = -ymax; }

  if ((xmin >= xmax) || (ymin >= ymax)){
    printf("PSD_monitor: %s: Null detection area !\n"
           "ERROR        (xwidth,yheight,xmin,xmax,ymin,ymax). Exiting",
    NAME_CURRENT_COMP);
    exit(-1);
  }

  PSD_N = create_darr2d(nx, ny);
  PSD_p = create_darr2d(nx, ny);
  PSD_p2 = create_darr2d(nx, ny);

  int i, j;
  for (i=0; i<nx; i++){
    for (j=0; j<ny; j++){
      PSD_N[i][j] = 0;
      PSD_p[i][j] = 0;
      PSD_p2[i][j] = 0;
    }
  }
}
#line 342199 "MACS_sample_kidney_box.c"
#undef restore_neutron
#undef yheight
#undef xwidth
#undef ymax
#undef ymin
#undef xmax
#undef xmin
#undef filename
#undef ny
#undef nx
#undef PSD_p2
#undef PSD_p
#undef PSD_N
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

  /* Initializations for component diffraction_detector_5. */
  SIG_MESSAGE("diffraction_detector_5 (Init)");
#define mccompcurname  diffraction_detector_5
#define mccompcurtype  PSD_monitor
#define mccompcurindex 895
#define PSD_N mccdiffraction_detector_5_PSD_N
#define PSD_p mccdiffraction_detector_5_PSD_p
#define PSD_p2 mccdiffraction_detector_5_PSD_p2
#define nx mccdiffraction_detector_5_nx
#define ny mccdiffraction_detector_5_ny
#define filename mccdiffraction_detector_5_filename
#define xmin mccdiffraction_detector_5_xmin
#define xmax mccdiffraction_detector_5_xmax
#define ymin mccdiffraction_detector_5_ymin
#define ymax mccdiffraction_detector_5_ymax
#define xwidth mccdiffraction_detector_5_xwidth
#define yheight mccdiffraction_detector_5_yheight
#define restore_neutron mccdiffraction_detector_5_restore_neutron
#line 68 "/usr/share/mcstas/2.7/monitors/PSD_monitor.comp"
{
  if (xwidth  > 0) { xmax = xwidth/2;  xmin = -xmax; }
  if (yheight > 0) { ymax = yheight/2; ymin = -ymax; }

  if ((xmin >= xmax) || (ymin >= ymax)){
    printf("PSD_monitor: %s: Null detection area !\n"
           "ERROR        (xwidth,yheight,xmin,xmax,ymin,ymax). Exiting",
    NAME_CURRENT_COMP);
    exit(-1);
  }

  PSD_N = create_darr2d(nx, ny);
  PSD_p = create_darr2d(nx, ny);
  PSD_p2 = create_darr2d(nx, ny);

  int i, j;
  for (i=0; i<nx; i++){
    for (j=0; j<ny; j++){
      PSD_N[i][j] = 0;
      PSD_p[i][j] = 0;
      PSD_p2[i][j] = 0;
    }
  }
}
#line 342260 "MACS_sample_kidney_box.c"
#undef restore_neutron
#undef yheight
#undef xwidth
#undef ymax
#undef ymin
#undef xmax
#undef xmin
#undef filename
#undef ny
#undef nx
#undef PSD_p2
#undef PSD_p
#undef PSD_N
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

  /* Initializations for component spec_detector_5. */
  SIG_MESSAGE("spec_detector_5 (Init)");
#define mccompcurname  spec_detector_5
#define mccompcurtype  PSD_monitor
#define mccompcurindex 896
#define PSD_N mccspec_detector_5_PSD_N
#define PSD_p mccspec_detector_5_PSD_p
#define PSD_p2 mccspec_detector_5_PSD_p2
#define nx mccspec_detector_5_nx
#define ny mccspec_detector_5_ny
#define filename mccspec_detector_5_filename
#define xmin mccspec_detector_5_xmin
#define xmax mccspec_detector_5_xmax
#define ymin mccspec_detector_5_ymin
#define ymax mccspec_detector_5_ymax
#define xwidth mccspec_detector_5_xwidth
#define yheight mccspec_detector_5_yheight
#define restore_neutron mccspec_detector_5_restore_neutron
#line 68 "/usr/share/mcstas/2.7/monitors/PSD_monitor.comp"
{
  if (xwidth  > 0) { xmax = xwidth/2;  xmin = -xmax; }
  if (yheight > 0) { ymax = yheight/2; ymin = -ymax; }

  if ((xmin >= xmax) || (ymin >= ymax)){
    printf("PSD_monitor: %s: Null detection area !\n"
           "ERROR        (xwidth,yheight,xmin,xmax,ymin,ymax). Exiting",
    NAME_CURRENT_COMP);
    exit(-1);
  }

  PSD_N = create_darr2d(nx, ny);
  PSD_p = create_darr2d(nx, ny);
  PSD_p2 = create_darr2d(nx, ny);

  int i, j;
  for (i=0; i<nx; i++){
    for (j=0; j<ny; j++){
      PSD_N[i][j] = 0;
      PSD_p[i][j] = 0;
      PSD_p2[i][j] = 0;
    }
  }
}
#line 342321 "MACS_sample_kidney_box.c"
#undef restore_neutron
#undef yheight
#undef xwidth
#undef ymax
#undef ymin
#undef xmax
#undef xmin
#undef filename
#undef ny
#undef nx
#undef PSD_p2
#undef PSD_p
#undef PSD_N
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

  /* Initializations for component diffraction_detector_6. */
  SIG_MESSAGE("diffraction_detector_6 (Init)");
#define mccompcurname  diffraction_detector_6
#define mccompcurtype  PSD_monitor
#define mccompcurindex 897
#define PSD_N mccdiffraction_detector_6_PSD_N
#define PSD_p mccdiffraction_detector_6_PSD_p
#define PSD_p2 mccdiffraction_detector_6_PSD_p2
#define nx mccdiffraction_detector_6_nx
#define ny mccdiffraction_detector_6_ny
#define filename mccdiffraction_detector_6_filename
#define xmin mccdiffraction_detector_6_xmin
#define xmax mccdiffraction_detector_6_xmax
#define ymin mccdiffraction_detector_6_ymin
#define ymax mccdiffraction_detector_6_ymax
#define xwidth mccdiffraction_detector_6_xwidth
#define yheight mccdiffraction_detector_6_yheight
#define restore_neutron mccdiffraction_detector_6_restore_neutron
#line 68 "/usr/share/mcstas/2.7/monitors/PSD_monitor.comp"
{
  if (xwidth  > 0) { xmax = xwidth/2;  xmin = -xmax; }
  if (yheight > 0) { ymax = yheight/2; ymin = -ymax; }

  if ((xmin >= xmax) || (ymin >= ymax)){
    printf("PSD_monitor: %s: Null detection area !\n"
           "ERROR        (xwidth,yheight,xmin,xmax,ymin,ymax). Exiting",
    NAME_CURRENT_COMP);
    exit(-1);
  }

  PSD_N = create_darr2d(nx, ny);
  PSD_p = create_darr2d(nx, ny);
  PSD_p2 = create_darr2d(nx, ny);

  int i, j;
  for (i=0; i<nx; i++){
    for (j=0; j<ny; j++){
      PSD_N[i][j] = 0;
      PSD_p[i][j] = 0;
      PSD_p2[i][j] = 0;
    }
  }
}
#line 342382 "MACS_sample_kidney_box.c"
#undef restore_neutron
#undef yheight
#undef xwidth
#undef ymax
#undef ymin
#undef xmax
#undef xmin
#undef filename
#undef ny
#undef nx
#undef PSD_p2
#undef PSD_p
#undef PSD_N
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

  /* Initializations for component spec_detector_6. */
  SIG_MESSAGE("spec_detector_6 (Init)");
#define mccompcurname  spec_detector_6
#define mccompcurtype  PSD_monitor
#define mccompcurindex 898
#define PSD_N mccspec_detector_6_PSD_N
#define PSD_p mccspec_detector_6_PSD_p
#define PSD_p2 mccspec_detector_6_PSD_p2
#define nx mccspec_detector_6_nx
#define ny mccspec_detector_6_ny
#define filename mccspec_detector_6_filename
#define xmin mccspec_detector_6_xmin
#define xmax mccspec_detector_6_xmax
#define ymin mccspec_detector_6_ymin
#define ymax mccspec_detector_6_ymax
#define xwidth mccspec_detector_6_xwidth
#define yheight mccspec_detector_6_yheight
#define restore_neutron mccspec_detector_6_restore_neutron
#line 68 "/usr/share/mcstas/2.7/monitors/PSD_monitor.comp"
{
  if (xwidth  > 0) { xmax = xwidth/2;  xmin = -xmax; }
  if (yheight > 0) { ymax = yheight/2; ymin = -ymax; }

  if ((xmin >= xmax) || (ymin >= ymax)){
    printf("PSD_monitor: %s: Null detection area !\n"
           "ERROR        (xwidth,yheight,xmin,xmax,ymin,ymax). Exiting",
    NAME_CURRENT_COMP);
    exit(-1);
  }

  PSD_N = create_darr2d(nx, ny);
  PSD_p = create_darr2d(nx, ny);
  PSD_p2 = create_darr2d(nx, ny);

  int i, j;
  for (i=0; i<nx; i++){
    for (j=0; j<ny; j++){
      PSD_N[i][j] = 0;
      PSD_p[i][j] = 0;
      PSD_p2[i][j] = 0;
    }
  }
}
#line 342443 "MACS_sample_kidney_box.c"
#undef restore_neutron
#undef yheight
#undef xwidth
#undef ymax
#undef ymin
#undef xmax
#undef xmin
#undef filename
#undef ny
#undef nx
#undef PSD_p2
#undef PSD_p
#undef PSD_N
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

  /* Initializations for component diffraction_detector_7. */
  SIG_MESSAGE("diffraction_detector_7 (Init)");
#define mccompcurname  diffraction_detector_7
#define mccompcurtype  PSD_monitor
#define mccompcurindex 899
#define PSD_N mccdiffraction_detector_7_PSD_N
#define PSD_p mccdiffraction_detector_7_PSD_p
#define PSD_p2 mccdiffraction_detector_7_PSD_p2
#define nx mccdiffraction_detector_7_nx
#define ny mccdiffraction_detector_7_ny
#define filename mccdiffraction_detector_7_filename
#define xmin mccdiffraction_detector_7_xmin
#define xmax mccdiffraction_detector_7_xmax
#define ymin mccdiffraction_detector_7_ymin
#define ymax mccdiffraction_detector_7_ymax
#define xwidth mccdiffraction_detector_7_xwidth
#define yheight mccdiffraction_detector_7_yheight
#define restore_neutron mccdiffraction_detector_7_restore_neutron
#line 68 "/usr/share/mcstas/2.7/monitors/PSD_monitor.comp"
{
  if (xwidth  > 0) { xmax = xwidth/2;  xmin = -xmax; }
  if (yheight > 0) { ymax = yheight/2; ymin = -ymax; }

  if ((xmin >= xmax) || (ymin >= ymax)){
    printf("PSD_monitor: %s: Null detection area !\n"
           "ERROR        (xwidth,yheight,xmin,xmax,ymin,ymax). Exiting",
    NAME_CURRENT_COMP);
    exit(-1);
  }

  PSD_N = create_darr2d(nx, ny);
  PSD_p = create_darr2d(nx, ny);
  PSD_p2 = create_darr2d(nx, ny);

  int i, j;
  for (i=0; i<nx; i++){
    for (j=0; j<ny; j++){
      PSD_N[i][j] = 0;
      PSD_p[i][j] = 0;
      PSD_p2[i][j] = 0;
    }
  }
}
#line 342504 "MACS_sample_kidney_box.c"
#undef restore_neutron
#undef yheight
#undef xwidth
#undef ymax
#undef ymin
#undef xmax
#undef xmin
#undef filename
#undef ny
#undef nx
#undef PSD_p2
#undef PSD_p
#undef PSD_N
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

  /* Initializations for component spec_detector_7. */
  SIG_MESSAGE("spec_detector_7 (Init)");
#define mccompcurname  spec_detector_7
#define mccompcurtype  PSD_monitor
#define mccompcurindex 900
#define PSD_N mccspec_detector_7_PSD_N
#define PSD_p mccspec_detector_7_PSD_p
#define PSD_p2 mccspec_detector_7_PSD_p2
#define nx mccspec_detector_7_nx
#define ny mccspec_detector_7_ny
#define filename mccspec_detector_7_filename
#define xmin mccspec_detector_7_xmin
#define xmax mccspec_detector_7_xmax
#define ymin mccspec_detector_7_ymin
#define ymax mccspec_detector_7_ymax
#define xwidth mccspec_detector_7_xwidth
#define yheight mccspec_detector_7_yheight
#define restore_neutron mccspec_detector_7_restore_neutron
#line 68 "/usr/share/mcstas/2.7/monitors/PSD_monitor.comp"
{
  if (xwidth  > 0) { xmax = xwidth/2;  xmin = -xmax; }
  if (yheight > 0) { ymax = yheight/2; ymin = -ymax; }

  if ((xmin >= xmax) || (ymin >= ymax)){
    printf("PSD_monitor: %s: Null detection area !\n"
           "ERROR        (xwidth,yheight,xmin,xmax,ymin,ymax). Exiting",
    NAME_CURRENT_COMP);
    exit(-1);
  }

  PSD_N = create_darr2d(nx, ny);
  PSD_p = create_darr2d(nx, ny);
  PSD_p2 = create_darr2d(nx, ny);

  int i, j;
  for (i=0; i<nx; i++){
    for (j=0; j<ny; j++){
      PSD_N[i][j] = 0;
      PSD_p[i][j] = 0;
      PSD_p2[i][j] = 0;
    }
  }
}
#line 342565 "MACS_sample_kidney_box.c"
#undef restore_neutron
#undef yheight
#undef xwidth
#undef ymax
#undef ymin
#undef xmax
#undef xmin
#undef filename
#undef ny
#undef nx
#undef PSD_p2
#undef PSD_p
#undef PSD_N
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

  /* Initializations for component diffraction_detector_8. */
  SIG_MESSAGE("diffraction_detector_8 (Init)");
#define mccompcurname  diffraction_detector_8
#define mccompcurtype  PSD_monitor
#define mccompcurindex 901
#define PSD_N mccdiffraction_detector_8_PSD_N
#define PSD_p mccdiffraction_detector_8_PSD_p
#define PSD_p2 mccdiffraction_detector_8_PSD_p2
#define nx mccdiffraction_detector_8_nx
#define ny mccdiffraction_detector_8_ny
#define filename mccdiffraction_detector_8_filename
#define xmin mccdiffraction_detector_8_xmin
#define xmax mccdiffraction_detector_8_xmax
#define ymin mccdiffraction_detector_8_ymin
#define ymax mccdiffraction_detector_8_ymax
#define xwidth mccdiffraction_detector_8_xwidth
#define yheight mccdiffraction_detector_8_yheight
#define restore_neutron mccdiffraction_detector_8_restore_neutron
#line 68 "/usr/share/mcstas/2.7/monitors/PSD_monitor.comp"
{
  if (xwidth  > 0) { xmax = xwidth/2;  xmin = -xmax; }
  if (yheight > 0) { ymax = yheight/2; ymin = -ymax; }

  if ((xmin >= xmax) || (ymin >= ymax)){
    printf("PSD_monitor: %s: Null detection area !\n"
           "ERROR        (xwidth,yheight,xmin,xmax,ymin,ymax). Exiting",
    NAME_CURRENT_COMP);
    exit(-1);
  }

  PSD_N = create_darr2d(nx, ny);
  PSD_p = create_darr2d(nx, ny);
  PSD_p2 = create_darr2d(nx, ny);

  int i, j;
  for (i=0; i<nx; i++){
    for (j=0; j<ny; j++){
      PSD_N[i][j] = 0;
      PSD_p[i][j] = 0;
      PSD_p2[i][j] = 0;
    }
  }
}
#line 342626 "MACS_sample_kidney_box.c"
#undef restore_neutron
#undef yheight
#undef xwidth
#undef ymax
#undef ymin
#undef xmax
#undef xmin
#undef filename
#undef ny
#undef nx
#undef PSD_p2
#undef PSD_p
#undef PSD_N
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

  /* Initializations for component spec_detector_8. */
  SIG_MESSAGE("spec_detector_8 (Init)");
#define mccompcurname  spec_detector_8
#define mccompcurtype  PSD_monitor
#define mccompcurindex 902
#define PSD_N mccspec_detector_8_PSD_N
#define PSD_p mccspec_detector_8_PSD_p
#define PSD_p2 mccspec_detector_8_PSD_p2
#define nx mccspec_detector_8_nx
#define ny mccspec_detector_8_ny
#define filename mccspec_detector_8_filename
#define xmin mccspec_detector_8_xmin
#define xmax mccspec_detector_8_xmax
#define ymin mccspec_detector_8_ymin
#define ymax mccspec_detector_8_ymax
#define xwidth mccspec_detector_8_xwidth
#define yheight mccspec_detector_8_yheight
#define restore_neutron mccspec_detector_8_restore_neutron
#line 68 "/usr/share/mcstas/2.7/monitors/PSD_monitor.comp"
{
  if (xwidth  > 0) { xmax = xwidth/2;  xmin = -xmax; }
  if (yheight > 0) { ymax = yheight/2; ymin = -ymax; }

  if ((xmin >= xmax) || (ymin >= ymax)){
    printf("PSD_monitor: %s: Null detection area !\n"
           "ERROR        (xwidth,yheight,xmin,xmax,ymin,ymax). Exiting",
    NAME_CURRENT_COMP);
    exit(-1);
  }

  PSD_N = create_darr2d(nx, ny);
  PSD_p = create_darr2d(nx, ny);
  PSD_p2 = create_darr2d(nx, ny);

  int i, j;
  for (i=0; i<nx; i++){
    for (j=0; j<ny; j++){
      PSD_N[i][j] = 0;
      PSD_p[i][j] = 0;
      PSD_p2[i][j] = 0;
    }
  }
}
#line 342687 "MACS_sample_kidney_box.c"
#undef restore_neutron
#undef yheight
#undef xwidth
#undef ymax
#undef ymin
#undef xmax
#undef xmin
#undef filename
#undef ny
#undef nx
#undef PSD_p2
#undef PSD_p
#undef PSD_N
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

  /* Initializations for component diffraction_detector_9. */
  SIG_MESSAGE("diffraction_detector_9 (Init)");
#define mccompcurname  diffraction_detector_9
#define mccompcurtype  PSD_monitor
#define mccompcurindex 903
#define PSD_N mccdiffraction_detector_9_PSD_N
#define PSD_p mccdiffraction_detector_9_PSD_p
#define PSD_p2 mccdiffraction_detector_9_PSD_p2
#define nx mccdiffraction_detector_9_nx
#define ny mccdiffraction_detector_9_ny
#define filename mccdiffraction_detector_9_filename
#define xmin mccdiffraction_detector_9_xmin
#define xmax mccdiffraction_detector_9_xmax
#define ymin mccdiffraction_detector_9_ymin
#define ymax mccdiffraction_detector_9_ymax
#define xwidth mccdiffraction_detector_9_xwidth
#define yheight mccdiffraction_detector_9_yheight
#define restore_neutron mccdiffraction_detector_9_restore_neutron
#line 68 "/usr/share/mcstas/2.7/monitors/PSD_monitor.comp"
{
  if (xwidth  > 0) { xmax = xwidth/2;  xmin = -xmax; }
  if (yheight > 0) { ymax = yheight/2; ymin = -ymax; }

  if ((xmin >= xmax) || (ymin >= ymax)){
    printf("PSD_monitor: %s: Null detection area !\n"
           "ERROR        (xwidth,yheight,xmin,xmax,ymin,ymax). Exiting",
    NAME_CURRENT_COMP);
    exit(-1);
  }

  PSD_N = create_darr2d(nx, ny);
  PSD_p = create_darr2d(nx, ny);
  PSD_p2 = create_darr2d(nx, ny);

  int i, j;
  for (i=0; i<nx; i++){
    for (j=0; j<ny; j++){
      PSD_N[i][j] = 0;
      PSD_p[i][j] = 0;
      PSD_p2[i][j] = 0;
    }
  }
}
#line 342748 "MACS_sample_kidney_box.c"
#undef restore_neutron
#undef yheight
#undef xwidth
#undef ymax
#undef ymin
#undef xmax
#undef xmin
#undef filename
#undef ny
#undef nx
#undef PSD_p2
#undef PSD_p
#undef PSD_N
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

  /* Initializations for component spec_detector_9. */
  SIG_MESSAGE("spec_detector_9 (Init)");
#define mccompcurname  spec_detector_9
#define mccompcurtype  PSD_monitor
#define mccompcurindex 904
#define PSD_N mccspec_detector_9_PSD_N
#define PSD_p mccspec_detector_9_PSD_p
#define PSD_p2 mccspec_detector_9_PSD_p2
#define nx mccspec_detector_9_nx
#define ny mccspec_detector_9_ny
#define filename mccspec_detector_9_filename
#define xmin mccspec_detector_9_xmin
#define xmax mccspec_detector_9_xmax
#define ymin mccspec_detector_9_ymin
#define ymax mccspec_detector_9_ymax
#define xwidth mccspec_detector_9_xwidth
#define yheight mccspec_detector_9_yheight
#define restore_neutron mccspec_detector_9_restore_neutron
#line 68 "/usr/share/mcstas/2.7/monitors/PSD_monitor.comp"
{
  if (xwidth  > 0) { xmax = xwidth/2;  xmin = -xmax; }
  if (yheight > 0) { ymax = yheight/2; ymin = -ymax; }

  if ((xmin >= xmax) || (ymin >= ymax)){
    printf("PSD_monitor: %s: Null detection area !\n"
           "ERROR        (xwidth,yheight,xmin,xmax,ymin,ymax). Exiting",
    NAME_CURRENT_COMP);
    exit(-1);
  }

  PSD_N = create_darr2d(nx, ny);
  PSD_p = create_darr2d(nx, ny);
  PSD_p2 = create_darr2d(nx, ny);

  int i, j;
  for (i=0; i<nx; i++){
    for (j=0; j<ny; j++){
      PSD_N[i][j] = 0;
      PSD_p[i][j] = 0;
      PSD_p2[i][j] = 0;
    }
  }
}
#line 342809 "MACS_sample_kidney_box.c"
#undef restore_neutron
#undef yheight
#undef xwidth
#undef ymax
#undef ymin
#undef xmax
#undef xmin
#undef filename
#undef ny
#undef nx
#undef PSD_p2
#undef PSD_p
#undef PSD_N
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

  /* Initializations for component diffraction_detector_10. */
  SIG_MESSAGE("diffraction_detector_10 (Init)");
#define mccompcurname  diffraction_detector_10
#define mccompcurtype  PSD_monitor
#define mccompcurindex 905
#define PSD_N mccdiffraction_detector_10_PSD_N
#define PSD_p mccdiffraction_detector_10_PSD_p
#define PSD_p2 mccdiffraction_detector_10_PSD_p2
#define nx mccdiffraction_detector_10_nx
#define ny mccdiffraction_detector_10_ny
#define filename mccdiffraction_detector_10_filename
#define xmin mccdiffraction_detector_10_xmin
#define xmax mccdiffraction_detector_10_xmax
#define ymin mccdiffraction_detector_10_ymin
#define ymax mccdiffraction_detector_10_ymax
#define xwidth mccdiffraction_detector_10_xwidth
#define yheight mccdiffraction_detector_10_yheight
#define restore_neutron mccdiffraction_detector_10_restore_neutron
#line 68 "/usr/share/mcstas/2.7/monitors/PSD_monitor.comp"
{
  if (xwidth  > 0) { xmax = xwidth/2;  xmin = -xmax; }
  if (yheight > 0) { ymax = yheight/2; ymin = -ymax; }

  if ((xmin >= xmax) || (ymin >= ymax)){
    printf("PSD_monitor: %s: Null detection area !\n"
           "ERROR        (xwidth,yheight,xmin,xmax,ymin,ymax). Exiting",
    NAME_CURRENT_COMP);
    exit(-1);
  }

  PSD_N = create_darr2d(nx, ny);
  PSD_p = create_darr2d(nx, ny);
  PSD_p2 = create_darr2d(nx, ny);

  int i, j;
  for (i=0; i<nx; i++){
    for (j=0; j<ny; j++){
      PSD_N[i][j] = 0;
      PSD_p[i][j] = 0;
      PSD_p2[i][j] = 0;
    }
  }
}
#line 342870 "MACS_sample_kidney_box.c"
#undef restore_neutron
#undef yheight
#undef xwidth
#undef ymax
#undef ymin
#undef xmax
#undef xmin
#undef filename
#undef ny
#undef nx
#undef PSD_p2
#undef PSD_p
#undef PSD_N
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

  /* Initializations for component spec_detector_10. */
  SIG_MESSAGE("spec_detector_10 (Init)");
#define mccompcurname  spec_detector_10
#define mccompcurtype  PSD_monitor
#define mccompcurindex 906
#define PSD_N mccspec_detector_10_PSD_N
#define PSD_p mccspec_detector_10_PSD_p
#define PSD_p2 mccspec_detector_10_PSD_p2
#define nx mccspec_detector_10_nx
#define ny mccspec_detector_10_ny
#define filename mccspec_detector_10_filename
#define xmin mccspec_detector_10_xmin
#define xmax mccspec_detector_10_xmax
#define ymin mccspec_detector_10_ymin
#define ymax mccspec_detector_10_ymax
#define xwidth mccspec_detector_10_xwidth
#define yheight mccspec_detector_10_yheight
#define restore_neutron mccspec_detector_10_restore_neutron
#line 68 "/usr/share/mcstas/2.7/monitors/PSD_monitor.comp"
{
  if (xwidth  > 0) { xmax = xwidth/2;  xmin = -xmax; }
  if (yheight > 0) { ymax = yheight/2; ymin = -ymax; }

  if ((xmin >= xmax) || (ymin >= ymax)){
    printf("PSD_monitor: %s: Null detection area !\n"
           "ERROR        (xwidth,yheight,xmin,xmax,ymin,ymax). Exiting",
    NAME_CURRENT_COMP);
    exit(-1);
  }

  PSD_N = create_darr2d(nx, ny);
  PSD_p = create_darr2d(nx, ny);
  PSD_p2 = create_darr2d(nx, ny);

  int i, j;
  for (i=0; i<nx; i++){
    for (j=0; j<ny; j++){
      PSD_N[i][j] = 0;
      PSD_p[i][j] = 0;
      PSD_p2[i][j] = 0;
    }
  }
}
#line 342931 "MACS_sample_kidney_box.c"
#undef restore_neutron
#undef yheight
#undef xwidth
#undef ymax
#undef ymin
#undef xmax
#undef xmin
#undef filename
#undef ny
#undef nx
#undef PSD_p2
#undef PSD_p
#undef PSD_N
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

  /* Initializations for component diffraction_detector_11. */
  SIG_MESSAGE("diffraction_detector_11 (Init)");
#define mccompcurname  diffraction_detector_11
#define mccompcurtype  PSD_monitor
#define mccompcurindex 907
#define PSD_N mccdiffraction_detector_11_PSD_N
#define PSD_p mccdiffraction_detector_11_PSD_p
#define PSD_p2 mccdiffraction_detector_11_PSD_p2
#define nx mccdiffraction_detector_11_nx
#define ny mccdiffraction_detector_11_ny
#define filename mccdiffraction_detector_11_filename
#define xmin mccdiffraction_detector_11_xmin
#define xmax mccdiffraction_detector_11_xmax
#define ymin mccdiffraction_detector_11_ymin
#define ymax mccdiffraction_detector_11_ymax
#define xwidth mccdiffraction_detector_11_xwidth
#define yheight mccdiffraction_detector_11_yheight
#define restore_neutron mccdiffraction_detector_11_restore_neutron
#line 68 "/usr/share/mcstas/2.7/monitors/PSD_monitor.comp"
{
  if (xwidth  > 0) { xmax = xwidth/2;  xmin = -xmax; }
  if (yheight > 0) { ymax = yheight/2; ymin = -ymax; }

  if ((xmin >= xmax) || (ymin >= ymax)){
    printf("PSD_monitor: %s: Null detection area !\n"
           "ERROR        (xwidth,yheight,xmin,xmax,ymin,ymax). Exiting",
    NAME_CURRENT_COMP);
    exit(-1);
  }

  PSD_N = create_darr2d(nx, ny);
  PSD_p = create_darr2d(nx, ny);
  PSD_p2 = create_darr2d(nx, ny);

  int i, j;
  for (i=0; i<nx; i++){
    for (j=0; j<ny; j++){
      PSD_N[i][j] = 0;
      PSD_p[i][j] = 0;
      PSD_p2[i][j] = 0;
    }
  }
}
#line 342992 "MACS_sample_kidney_box.c"
#undef restore_neutron
#undef yheight
#undef xwidth
#undef ymax
#undef ymin
#undef xmax
#undef xmin
#undef filename
#undef ny
#undef nx
#undef PSD_p2
#undef PSD_p
#undef PSD_N
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

  /* Initializations for component spec_detector_11. */
  SIG_MESSAGE("spec_detector_11 (Init)");
#define mccompcurname  spec_detector_11
#define mccompcurtype  PSD_monitor
#define mccompcurindex 908
#define PSD_N mccspec_detector_11_PSD_N
#define PSD_p mccspec_detector_11_PSD_p
#define PSD_p2 mccspec_detector_11_PSD_p2
#define nx mccspec_detector_11_nx
#define ny mccspec_detector_11_ny
#define filename mccspec_detector_11_filename
#define xmin mccspec_detector_11_xmin
#define xmax mccspec_detector_11_xmax
#define ymin mccspec_detector_11_ymin
#define ymax mccspec_detector_11_ymax
#define xwidth mccspec_detector_11_xwidth
#define yheight mccspec_detector_11_yheight
#define restore_neutron mccspec_detector_11_restore_neutron
#line 68 "/usr/share/mcstas/2.7/monitors/PSD_monitor.comp"
{
  if (xwidth  > 0) { xmax = xwidth/2;  xmin = -xmax; }
  if (yheight > 0) { ymax = yheight/2; ymin = -ymax; }

  if ((xmin >= xmax) || (ymin >= ymax)){
    printf("PSD_monitor: %s: Null detection area !\n"
           "ERROR        (xwidth,yheight,xmin,xmax,ymin,ymax). Exiting",
    NAME_CURRENT_COMP);
    exit(-1);
  }

  PSD_N = create_darr2d(nx, ny);
  PSD_p = create_darr2d(nx, ny);
  PSD_p2 = create_darr2d(nx, ny);

  int i, j;
  for (i=0; i<nx; i++){
    for (j=0; j<ny; j++){
      PSD_N[i][j] = 0;
      PSD_p[i][j] = 0;
      PSD_p2[i][j] = 0;
    }
  }
}
#line 343053 "MACS_sample_kidney_box.c"
#undef restore_neutron
#undef yheight
#undef xwidth
#undef ymax
#undef ymin
#undef xmax
#undef xmin
#undef filename
#undef ny
#undef nx
#undef PSD_p2
#undef PSD_p
#undef PSD_N
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

  /* Initializations for component diffraction_detector_12. */
  SIG_MESSAGE("diffraction_detector_12 (Init)");
#define mccompcurname  diffraction_detector_12
#define mccompcurtype  PSD_monitor
#define mccompcurindex 909
#define PSD_N mccdiffraction_detector_12_PSD_N
#define PSD_p mccdiffraction_detector_12_PSD_p
#define PSD_p2 mccdiffraction_detector_12_PSD_p2
#define nx mccdiffraction_detector_12_nx
#define ny mccdiffraction_detector_12_ny
#define filename mccdiffraction_detector_12_filename
#define xmin mccdiffraction_detector_12_xmin
#define xmax mccdiffraction_detector_12_xmax
#define ymin mccdiffraction_detector_12_ymin
#define ymax mccdiffraction_detector_12_ymax
#define xwidth mccdiffraction_detector_12_xwidth
#define yheight mccdiffraction_detector_12_yheight
#define restore_neutron mccdiffraction_detector_12_restore_neutron
#line 68 "/usr/share/mcstas/2.7/monitors/PSD_monitor.comp"
{
  if (xwidth  > 0) { xmax = xwidth/2;  xmin = -xmax; }
  if (yheight > 0) { ymax = yheight/2; ymin = -ymax; }

  if ((xmin >= xmax) || (ymin >= ymax)){
    printf("PSD_monitor: %s: Null detection area !\n"
           "ERROR        (xwidth,yheight,xmin,xmax,ymin,ymax). Exiting",
    NAME_CURRENT_COMP);
    exit(-1);
  }

  PSD_N = create_darr2d(nx, ny);
  PSD_p = create_darr2d(nx, ny);
  PSD_p2 = create_darr2d(nx, ny);

  int i, j;
  for (i=0; i<nx; i++){
    for (j=0; j<ny; j++){
      PSD_N[i][j] = 0;
      PSD_p[i][j] = 0;
      PSD_p2[i][j] = 0;
    }
  }
}
#line 343114 "MACS_sample_kidney_box.c"
#undef restore_neutron
#undef yheight
#undef xwidth
#undef ymax
#undef ymin
#undef xmax
#undef xmin
#undef filename
#undef ny
#undef nx
#undef PSD_p2
#undef PSD_p
#undef PSD_N
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

  /* Initializations for component spec_detector_12. */
  SIG_MESSAGE("spec_detector_12 (Init)");
#define mccompcurname  spec_detector_12
#define mccompcurtype  PSD_monitor
#define mccompcurindex 910
#define PSD_N mccspec_detector_12_PSD_N
#define PSD_p mccspec_detector_12_PSD_p
#define PSD_p2 mccspec_detector_12_PSD_p2
#define nx mccspec_detector_12_nx
#define ny mccspec_detector_12_ny
#define filename mccspec_detector_12_filename
#define xmin mccspec_detector_12_xmin
#define xmax mccspec_detector_12_xmax
#define ymin mccspec_detector_12_ymin
#define ymax mccspec_detector_12_ymax
#define xwidth mccspec_detector_12_xwidth
#define yheight mccspec_detector_12_yheight
#define restore_neutron mccspec_detector_12_restore_neutron
#line 68 "/usr/share/mcstas/2.7/monitors/PSD_monitor.comp"
{
  if (xwidth  > 0) { xmax = xwidth/2;  xmin = -xmax; }
  if (yheight > 0) { ymax = yheight/2; ymin = -ymax; }

  if ((xmin >= xmax) || (ymin >= ymax)){
    printf("PSD_monitor: %s: Null detection area !\n"
           "ERROR        (xwidth,yheight,xmin,xmax,ymin,ymax). Exiting",
    NAME_CURRENT_COMP);
    exit(-1);
  }

  PSD_N = create_darr2d(nx, ny);
  PSD_p = create_darr2d(nx, ny);
  PSD_p2 = create_darr2d(nx, ny);

  int i, j;
  for (i=0; i<nx; i++){
    for (j=0; j<ny; j++){
      PSD_N[i][j] = 0;
      PSD_p[i][j] = 0;
      PSD_p2[i][j] = 0;
    }
  }
}
#line 343175 "MACS_sample_kidney_box.c"
#undef restore_neutron
#undef yheight
#undef xwidth
#undef ymax
#undef ymin
#undef xmax
#undef xmin
#undef filename
#undef ny
#undef nx
#undef PSD_p2
#undef PSD_p
#undef PSD_N
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

  /* Initializations for component diffraction_detector_13. */
  SIG_MESSAGE("diffraction_detector_13 (Init)");
#define mccompcurname  diffraction_detector_13
#define mccompcurtype  PSD_monitor
#define mccompcurindex 911
#define PSD_N mccdiffraction_detector_13_PSD_N
#define PSD_p mccdiffraction_detector_13_PSD_p
#define PSD_p2 mccdiffraction_detector_13_PSD_p2
#define nx mccdiffraction_detector_13_nx
#define ny mccdiffraction_detector_13_ny
#define filename mccdiffraction_detector_13_filename
#define xmin mccdiffraction_detector_13_xmin
#define xmax mccdiffraction_detector_13_xmax
#define ymin mccdiffraction_detector_13_ymin
#define ymax mccdiffraction_detector_13_ymax
#define xwidth mccdiffraction_detector_13_xwidth
#define yheight mccdiffraction_detector_13_yheight
#define restore_neutron mccdiffraction_detector_13_restore_neutron
#line 68 "/usr/share/mcstas/2.7/monitors/PSD_monitor.comp"
{
  if (xwidth  > 0) { xmax = xwidth/2;  xmin = -xmax; }
  if (yheight > 0) { ymax = yheight/2; ymin = -ymax; }

  if ((xmin >= xmax) || (ymin >= ymax)){
    printf("PSD_monitor: %s: Null detection area !\n"
           "ERROR        (xwidth,yheight,xmin,xmax,ymin,ymax). Exiting",
    NAME_CURRENT_COMP);
    exit(-1);
  }

  PSD_N = create_darr2d(nx, ny);
  PSD_p = create_darr2d(nx, ny);
  PSD_p2 = create_darr2d(nx, ny);

  int i, j;
  for (i=0; i<nx; i++){
    for (j=0; j<ny; j++){
      PSD_N[i][j] = 0;
      PSD_p[i][j] = 0;
      PSD_p2[i][j] = 0;
    }
  }
}
#line 343236 "MACS_sample_kidney_box.c"
#undef restore_neutron
#undef yheight
#undef xwidth
#undef ymax
#undef ymin
#undef xmax
#undef xmin
#undef filename
#undef ny
#undef nx
#undef PSD_p2
#undef PSD_p
#undef PSD_N
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

  /* Initializations for component spec_detector_13. */
  SIG_MESSAGE("spec_detector_13 (Init)");
#define mccompcurname  spec_detector_13
#define mccompcurtype  PSD_monitor
#define mccompcurindex 912
#define PSD_N mccspec_detector_13_PSD_N
#define PSD_p mccspec_detector_13_PSD_p
#define PSD_p2 mccspec_detector_13_PSD_p2
#define nx mccspec_detector_13_nx
#define ny mccspec_detector_13_ny
#define filename mccspec_detector_13_filename
#define xmin mccspec_detector_13_xmin
#define xmax mccspec_detector_13_xmax
#define ymin mccspec_detector_13_ymin
#define ymax mccspec_detector_13_ymax
#define xwidth mccspec_detector_13_xwidth
#define yheight mccspec_detector_13_yheight
#define restore_neutron mccspec_detector_13_restore_neutron
#line 68 "/usr/share/mcstas/2.7/monitors/PSD_monitor.comp"
{
  if (xwidth  > 0) { xmax = xwidth/2;  xmin = -xmax; }
  if (yheight > 0) { ymax = yheight/2; ymin = -ymax; }

  if ((xmin >= xmax) || (ymin >= ymax)){
    printf("PSD_monitor: %s: Null detection area !\n"
           "ERROR        (xwidth,yheight,xmin,xmax,ymin,ymax). Exiting",
    NAME_CURRENT_COMP);
    exit(-1);
  }

  PSD_N = create_darr2d(nx, ny);
  PSD_p = create_darr2d(nx, ny);
  PSD_p2 = create_darr2d(nx, ny);

  int i, j;
  for (i=0; i<nx; i++){
    for (j=0; j<ny; j++){
      PSD_N[i][j] = 0;
      PSD_p[i][j] = 0;
      PSD_p2[i][j] = 0;
    }
  }
}
#line 343297 "MACS_sample_kidney_box.c"
#undef restore_neutron
#undef yheight
#undef xwidth
#undef ymax
#undef ymin
#undef xmax
#undef xmin
#undef filename
#undef ny
#undef nx
#undef PSD_p2
#undef PSD_p
#undef PSD_N
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

  /* Initializations for component diffraction_detector_14. */
  SIG_MESSAGE("diffraction_detector_14 (Init)");
#define mccompcurname  diffraction_detector_14
#define mccompcurtype  PSD_monitor
#define mccompcurindex 913
#define PSD_N mccdiffraction_detector_14_PSD_N
#define PSD_p mccdiffraction_detector_14_PSD_p
#define PSD_p2 mccdiffraction_detector_14_PSD_p2
#define nx mccdiffraction_detector_14_nx
#define ny mccdiffraction_detector_14_ny
#define filename mccdiffraction_detector_14_filename
#define xmin mccdiffraction_detector_14_xmin
#define xmax mccdiffraction_detector_14_xmax
#define ymin mccdiffraction_detector_14_ymin
#define ymax mccdiffraction_detector_14_ymax
#define xwidth mccdiffraction_detector_14_xwidth
#define yheight mccdiffraction_detector_14_yheight
#define restore_neutron mccdiffraction_detector_14_restore_neutron
#line 68 "/usr/share/mcstas/2.7/monitors/PSD_monitor.comp"
{
  if (xwidth  > 0) { xmax = xwidth/2;  xmin = -xmax; }
  if (yheight > 0) { ymax = yheight/2; ymin = -ymax; }

  if ((xmin >= xmax) || (ymin >= ymax)){
    printf("PSD_monitor: %s: Null detection area !\n"
           "ERROR        (xwidth,yheight,xmin,xmax,ymin,ymax). Exiting",
    NAME_CURRENT_COMP);
    exit(-1);
  }

  PSD_N = create_darr2d(nx, ny);
  PSD_p = create_darr2d(nx, ny);
  PSD_p2 = create_darr2d(nx, ny);

  int i, j;
  for (i=0; i<nx; i++){
    for (j=0; j<ny; j++){
      PSD_N[i][j] = 0;
      PSD_p[i][j] = 0;
      PSD_p2[i][j] = 0;
    }
  }
}
#line 343358 "MACS_sample_kidney_box.c"
#undef restore_neutron
#undef yheight
#undef xwidth
#undef ymax
#undef ymin
#undef xmax
#undef xmin
#undef filename
#undef ny
#undef nx
#undef PSD_p2
#undef PSD_p
#undef PSD_N
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

  /* Initializations for component spec_detector_14. */
  SIG_MESSAGE("spec_detector_14 (Init)");
#define mccompcurname  spec_detector_14
#define mccompcurtype  PSD_monitor
#define mccompcurindex 914
#define PSD_N mccspec_detector_14_PSD_N
#define PSD_p mccspec_detector_14_PSD_p
#define PSD_p2 mccspec_detector_14_PSD_p2
#define nx mccspec_detector_14_nx
#define ny mccspec_detector_14_ny
#define filename mccspec_detector_14_filename
#define xmin mccspec_detector_14_xmin
#define xmax mccspec_detector_14_xmax
#define ymin mccspec_detector_14_ymin
#define ymax mccspec_detector_14_ymax
#define xwidth mccspec_detector_14_xwidth
#define yheight mccspec_detector_14_yheight
#define restore_neutron mccspec_detector_14_restore_neutron
#line 68 "/usr/share/mcstas/2.7/monitors/PSD_monitor.comp"
{
  if (xwidth  > 0) { xmax = xwidth/2;  xmin = -xmax; }
  if (yheight > 0) { ymax = yheight/2; ymin = -ymax; }

  if ((xmin >= xmax) || (ymin >= ymax)){
    printf("PSD_monitor: %s: Null detection area !\n"
           "ERROR        (xwidth,yheight,xmin,xmax,ymin,ymax). Exiting",
    NAME_CURRENT_COMP);
    exit(-1);
  }

  PSD_N = create_darr2d(nx, ny);
  PSD_p = create_darr2d(nx, ny);
  PSD_p2 = create_darr2d(nx, ny);

  int i, j;
  for (i=0; i<nx; i++){
    for (j=0; j<ny; j++){
      PSD_N[i][j] = 0;
      PSD_p[i][j] = 0;
      PSD_p2[i][j] = 0;
    }
  }
}
#line 343419 "MACS_sample_kidney_box.c"
#undef restore_neutron
#undef yheight
#undef xwidth
#undef ymax
#undef ymin
#undef xmax
#undef xmin
#undef filename
#undef ny
#undef nx
#undef PSD_p2
#undef PSD_p
#undef PSD_N
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

  /* Initializations for component diffraction_detector_15. */
  SIG_MESSAGE("diffraction_detector_15 (Init)");
#define mccompcurname  diffraction_detector_15
#define mccompcurtype  PSD_monitor
#define mccompcurindex 915
#define PSD_N mccdiffraction_detector_15_PSD_N
#define PSD_p mccdiffraction_detector_15_PSD_p
#define PSD_p2 mccdiffraction_detector_15_PSD_p2
#define nx mccdiffraction_detector_15_nx
#define ny mccdiffraction_detector_15_ny
#define filename mccdiffraction_detector_15_filename
#define xmin mccdiffraction_detector_15_xmin
#define xmax mccdiffraction_detector_15_xmax
#define ymin mccdiffraction_detector_15_ymin
#define ymax mccdiffraction_detector_15_ymax
#define xwidth mccdiffraction_detector_15_xwidth
#define yheight mccdiffraction_detector_15_yheight
#define restore_neutron mccdiffraction_detector_15_restore_neutron
#line 68 "/usr/share/mcstas/2.7/monitors/PSD_monitor.comp"
{
  if (xwidth  > 0) { xmax = xwidth/2;  xmin = -xmax; }
  if (yheight > 0) { ymax = yheight/2; ymin = -ymax; }

  if ((xmin >= xmax) || (ymin >= ymax)){
    printf("PSD_monitor: %s: Null detection area !\n"
           "ERROR        (xwidth,yheight,xmin,xmax,ymin,ymax). Exiting",
    NAME_CURRENT_COMP);
    exit(-1);
  }

  PSD_N = create_darr2d(nx, ny);
  PSD_p = create_darr2d(nx, ny);
  PSD_p2 = create_darr2d(nx, ny);

  int i, j;
  for (i=0; i<nx; i++){
    for (j=0; j<ny; j++){
      PSD_N[i][j] = 0;
      PSD_p[i][j] = 0;
      PSD_p2[i][j] = 0;
    }
  }
}
#line 343480 "MACS_sample_kidney_box.c"
#undef restore_neutron
#undef yheight
#undef xwidth
#undef ymax
#undef ymin
#undef xmax
#undef xmin
#undef filename
#undef ny
#undef nx
#undef PSD_p2
#undef PSD_p
#undef PSD_N
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

  /* Initializations for component spec_detector_15. */
  SIG_MESSAGE("spec_detector_15 (Init)");
#define mccompcurname  spec_detector_15
#define mccompcurtype  PSD_monitor
#define mccompcurindex 916
#define PSD_N mccspec_detector_15_PSD_N
#define PSD_p mccspec_detector_15_PSD_p
#define PSD_p2 mccspec_detector_15_PSD_p2
#define nx mccspec_detector_15_nx
#define ny mccspec_detector_15_ny
#define filename mccspec_detector_15_filename
#define xmin mccspec_detector_15_xmin
#define xmax mccspec_detector_15_xmax
#define ymin mccspec_detector_15_ymin
#define ymax mccspec_detector_15_ymax
#define xwidth mccspec_detector_15_xwidth
#define yheight mccspec_detector_15_yheight
#define restore_neutron mccspec_detector_15_restore_neutron
#line 68 "/usr/share/mcstas/2.7/monitors/PSD_monitor.comp"
{
  if (xwidth  > 0) { xmax = xwidth/2;  xmin = -xmax; }
  if (yheight > 0) { ymax = yheight/2; ymin = -ymax; }

  if ((xmin >= xmax) || (ymin >= ymax)){
    printf("PSD_monitor: %s: Null detection area !\n"
           "ERROR        (xwidth,yheight,xmin,xmax,ymin,ymax). Exiting",
    NAME_CURRENT_COMP);
    exit(-1);
  }

  PSD_N = create_darr2d(nx, ny);
  PSD_p = create_darr2d(nx, ny);
  PSD_p2 = create_darr2d(nx, ny);

  int i, j;
  for (i=0; i<nx; i++){
    for (j=0; j<ny; j++){
      PSD_N[i][j] = 0;
      PSD_p[i][j] = 0;
      PSD_p2[i][j] = 0;
    }
  }
}
#line 343541 "MACS_sample_kidney_box.c"
#undef restore_neutron
#undef yheight
#undef xwidth
#undef ymax
#undef ymin
#undef xmax
#undef xmin
#undef filename
#undef ny
#undef nx
#undef PSD_p2
#undef PSD_p
#undef PSD_N
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

  /* Initializations for component diffraction_detector_16. */
  SIG_MESSAGE("diffraction_detector_16 (Init)");
#define mccompcurname  diffraction_detector_16
#define mccompcurtype  PSD_monitor
#define mccompcurindex 917
#define PSD_N mccdiffraction_detector_16_PSD_N
#define PSD_p mccdiffraction_detector_16_PSD_p
#define PSD_p2 mccdiffraction_detector_16_PSD_p2
#define nx mccdiffraction_detector_16_nx
#define ny mccdiffraction_detector_16_ny
#define filename mccdiffraction_detector_16_filename
#define xmin mccdiffraction_detector_16_xmin
#define xmax mccdiffraction_detector_16_xmax
#define ymin mccdiffraction_detector_16_ymin
#define ymax mccdiffraction_detector_16_ymax
#define xwidth mccdiffraction_detector_16_xwidth
#define yheight mccdiffraction_detector_16_yheight
#define restore_neutron mccdiffraction_detector_16_restore_neutron
#line 68 "/usr/share/mcstas/2.7/monitors/PSD_monitor.comp"
{
  if (xwidth  > 0) { xmax = xwidth/2;  xmin = -xmax; }
  if (yheight > 0) { ymax = yheight/2; ymin = -ymax; }

  if ((xmin >= xmax) || (ymin >= ymax)){
    printf("PSD_monitor: %s: Null detection area !\n"
           "ERROR        (xwidth,yheight,xmin,xmax,ymin,ymax). Exiting",
    NAME_CURRENT_COMP);
    exit(-1);
  }

  PSD_N = create_darr2d(nx, ny);
  PSD_p = create_darr2d(nx, ny);
  PSD_p2 = create_darr2d(nx, ny);

  int i, j;
  for (i=0; i<nx; i++){
    for (j=0; j<ny; j++){
      PSD_N[i][j] = 0;
      PSD_p[i][j] = 0;
      PSD_p2[i][j] = 0;
    }
  }
}
#line 343602 "MACS_sample_kidney_box.c"
#undef restore_neutron
#undef yheight
#undef xwidth
#undef ymax
#undef ymin
#undef xmax
#undef xmin
#undef filename
#undef ny
#undef nx
#undef PSD_p2
#undef PSD_p
#undef PSD_N
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

  /* Initializations for component spec_detector_16. */
  SIG_MESSAGE("spec_detector_16 (Init)");
#define mccompcurname  spec_detector_16
#define mccompcurtype  PSD_monitor
#define mccompcurindex 918
#define PSD_N mccspec_detector_16_PSD_N
#define PSD_p mccspec_detector_16_PSD_p
#define PSD_p2 mccspec_detector_16_PSD_p2
#define nx mccspec_detector_16_nx
#define ny mccspec_detector_16_ny
#define filename mccspec_detector_16_filename
#define xmin mccspec_detector_16_xmin
#define xmax mccspec_detector_16_xmax
#define ymin mccspec_detector_16_ymin
#define ymax mccspec_detector_16_ymax
#define xwidth mccspec_detector_16_xwidth
#define yheight mccspec_detector_16_yheight
#define restore_neutron mccspec_detector_16_restore_neutron
#line 68 "/usr/share/mcstas/2.7/monitors/PSD_monitor.comp"
{
  if (xwidth  > 0) { xmax = xwidth/2;  xmin = -xmax; }
  if (yheight > 0) { ymax = yheight/2; ymin = -ymax; }

  if ((xmin >= xmax) || (ymin >= ymax)){
    printf("PSD_monitor: %s: Null detection area !\n"
           "ERROR        (xwidth,yheight,xmin,xmax,ymin,ymax). Exiting",
    NAME_CURRENT_COMP);
    exit(-1);
  }

  PSD_N = create_darr2d(nx, ny);
  PSD_p = create_darr2d(nx, ny);
  PSD_p2 = create_darr2d(nx, ny);

  int i, j;
  for (i=0; i<nx; i++){
    for (j=0; j<ny; j++){
      PSD_N[i][j] = 0;
      PSD_p[i][j] = 0;
      PSD_p2[i][j] = 0;
    }
  }
}
#line 343663 "MACS_sample_kidney_box.c"
#undef restore_neutron
#undef yheight
#undef xwidth
#undef ymax
#undef ymin
#undef xmax
#undef xmin
#undef filename
#undef ny
#undef nx
#undef PSD_p2
#undef PSD_p
#undef PSD_N
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

  /* Initializations for component diffraction_detector_17. */
  SIG_MESSAGE("diffraction_detector_17 (Init)");
#define mccompcurname  diffraction_detector_17
#define mccompcurtype  PSD_monitor
#define mccompcurindex 919
#define PSD_N mccdiffraction_detector_17_PSD_N
#define PSD_p mccdiffraction_detector_17_PSD_p
#define PSD_p2 mccdiffraction_detector_17_PSD_p2
#define nx mccdiffraction_detector_17_nx
#define ny mccdiffraction_detector_17_ny
#define filename mccdiffraction_detector_17_filename
#define xmin mccdiffraction_detector_17_xmin
#define xmax mccdiffraction_detector_17_xmax
#define ymin mccdiffraction_detector_17_ymin
#define ymax mccdiffraction_detector_17_ymax
#define xwidth mccdiffraction_detector_17_xwidth
#define yheight mccdiffraction_detector_17_yheight
#define restore_neutron mccdiffraction_detector_17_restore_neutron
#line 68 "/usr/share/mcstas/2.7/monitors/PSD_monitor.comp"
{
  if (xwidth  > 0) { xmax = xwidth/2;  xmin = -xmax; }
  if (yheight > 0) { ymax = yheight/2; ymin = -ymax; }

  if ((xmin >= xmax) || (ymin >= ymax)){
    printf("PSD_monitor: %s: Null detection area !\n"
           "ERROR        (xwidth,yheight,xmin,xmax,ymin,ymax). Exiting",
    NAME_CURRENT_COMP);
    exit(-1);
  }

  PSD_N = create_darr2d(nx, ny);
  PSD_p = create_darr2d(nx, ny);
  PSD_p2 = create_darr2d(nx, ny);

  int i, j;
  for (i=0; i<nx; i++){
    for (j=0; j<ny; j++){
      PSD_N[i][j] = 0;
      PSD_p[i][j] = 0;
      PSD_p2[i][j] = 0;
    }
  }
}
#line 343724 "MACS_sample_kidney_box.c"
#undef restore_neutron
#undef yheight
#undef xwidth
#undef ymax
#undef ymin
#undef xmax
#undef xmin
#undef filename
#undef ny
#undef nx
#undef PSD_p2
#undef PSD_p
#undef PSD_N
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

  /* Initializations for component spec_detector_17. */
  SIG_MESSAGE("spec_detector_17 (Init)");
#define mccompcurname  spec_detector_17
#define mccompcurtype  PSD_monitor
#define mccompcurindex 920
#define PSD_N mccspec_detector_17_PSD_N
#define PSD_p mccspec_detector_17_PSD_p
#define PSD_p2 mccspec_detector_17_PSD_p2
#define nx mccspec_detector_17_nx
#define ny mccspec_detector_17_ny
#define filename mccspec_detector_17_filename
#define xmin mccspec_detector_17_xmin
#define xmax mccspec_detector_17_xmax
#define ymin mccspec_detector_17_ymin
#define ymax mccspec_detector_17_ymax
#define xwidth mccspec_detector_17_xwidth
#define yheight mccspec_detector_17_yheight
#define restore_neutron mccspec_detector_17_restore_neutron
#line 68 "/usr/share/mcstas/2.7/monitors/PSD_monitor.comp"
{
  if (xwidth  > 0) { xmax = xwidth/2;  xmin = -xmax; }
  if (yheight > 0) { ymax = yheight/2; ymin = -ymax; }

  if ((xmin >= xmax) || (ymin >= ymax)){
    printf("PSD_monitor: %s: Null detection area !\n"
           "ERROR        (xwidth,yheight,xmin,xmax,ymin,ymax). Exiting",
    NAME_CURRENT_COMP);
    exit(-1);
  }

  PSD_N = create_darr2d(nx, ny);
  PSD_p = create_darr2d(nx, ny);
  PSD_p2 = create_darr2d(nx, ny);

  int i, j;
  for (i=0; i<nx; i++){
    for (j=0; j<ny; j++){
      PSD_N[i][j] = 0;
      PSD_p[i][j] = 0;
      PSD_p2[i][j] = 0;
    }
  }
}
#line 343785 "MACS_sample_kidney_box.c"
#undef restore_neutron
#undef yheight
#undef xwidth
#undef ymax
#undef ymin
#undef xmax
#undef xmin
#undef filename
#undef ny
#undef nx
#undef PSD_p2
#undef PSD_p
#undef PSD_N
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

  /* Initializations for component diffraction_detector_18. */
  SIG_MESSAGE("diffraction_detector_18 (Init)");
#define mccompcurname  diffraction_detector_18
#define mccompcurtype  PSD_monitor
#define mccompcurindex 921
#define PSD_N mccdiffraction_detector_18_PSD_N
#define PSD_p mccdiffraction_detector_18_PSD_p
#define PSD_p2 mccdiffraction_detector_18_PSD_p2
#define nx mccdiffraction_detector_18_nx
#define ny mccdiffraction_detector_18_ny
#define filename mccdiffraction_detector_18_filename
#define xmin mccdiffraction_detector_18_xmin
#define xmax mccdiffraction_detector_18_xmax
#define ymin mccdiffraction_detector_18_ymin
#define ymax mccdiffraction_detector_18_ymax
#define xwidth mccdiffraction_detector_18_xwidth
#define yheight mccdiffraction_detector_18_yheight
#define restore_neutron mccdiffraction_detector_18_restore_neutron
#line 68 "/usr/share/mcstas/2.7/monitors/PSD_monitor.comp"
{
  if (xwidth  > 0) { xmax = xwidth/2;  xmin = -xmax; }
  if (yheight > 0) { ymax = yheight/2; ymin = -ymax; }

  if ((xmin >= xmax) || (ymin >= ymax)){
    printf("PSD_monitor: %s: Null detection area !\n"
           "ERROR        (xwidth,yheight,xmin,xmax,ymin,ymax). Exiting",
    NAME_CURRENT_COMP);
    exit(-1);
  }

  PSD_N = create_darr2d(nx, ny);
  PSD_p = create_darr2d(nx, ny);
  PSD_p2 = create_darr2d(nx, ny);

  int i, j;
  for (i=0; i<nx; i++){
    for (j=0; j<ny; j++){
      PSD_N[i][j] = 0;
      PSD_p[i][j] = 0;
      PSD_p2[i][j] = 0;
    }
  }
}
#line 343846 "MACS_sample_kidney_box.c"
#undef restore_neutron
#undef yheight
#undef xwidth
#undef ymax
#undef ymin
#undef xmax
#undef xmin
#undef filename
#undef ny
#undef nx
#undef PSD_p2
#undef PSD_p
#undef PSD_N
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

  /* Initializations for component spec_detector_18. */
  SIG_MESSAGE("spec_detector_18 (Init)");
#define mccompcurname  spec_detector_18
#define mccompcurtype  PSD_monitor
#define mccompcurindex 922
#define PSD_N mccspec_detector_18_PSD_N
#define PSD_p mccspec_detector_18_PSD_p
#define PSD_p2 mccspec_detector_18_PSD_p2
#define nx mccspec_detector_18_nx
#define ny mccspec_detector_18_ny
#define filename mccspec_detector_18_filename
#define xmin mccspec_detector_18_xmin
#define xmax mccspec_detector_18_xmax
#define ymin mccspec_detector_18_ymin
#define ymax mccspec_detector_18_ymax
#define xwidth mccspec_detector_18_xwidth
#define yheight mccspec_detector_18_yheight
#define restore_neutron mccspec_detector_18_restore_neutron
#line 68 "/usr/share/mcstas/2.7/monitors/PSD_monitor.comp"
{
  if (xwidth  > 0) { xmax = xwidth/2;  xmin = -xmax; }
  if (yheight > 0) { ymax = yheight/2; ymin = -ymax; }

  if ((xmin >= xmax) || (ymin >= ymax)){
    printf("PSD_monitor: %s: Null detection area !\n"
           "ERROR        (xwidth,yheight,xmin,xmax,ymin,ymax). Exiting",
    NAME_CURRENT_COMP);
    exit(-1);
  }

  PSD_N = create_darr2d(nx, ny);
  PSD_p = create_darr2d(nx, ny);
  PSD_p2 = create_darr2d(nx, ny);

  int i, j;
  for (i=0; i<nx; i++){
    for (j=0; j<ny; j++){
      PSD_N[i][j] = 0;
      PSD_p[i][j] = 0;
      PSD_p2[i][j] = 0;
    }
  }
}
#line 343907 "MACS_sample_kidney_box.c"
#undef restore_neutron
#undef yheight
#undef xwidth
#undef ymax
#undef ymin
#undef xmax
#undef xmin
#undef filename
#undef ny
#undef nx
#undef PSD_p2
#undef PSD_p
#undef PSD_N
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

  /* Initializations for component diffraction_detector_19. */
  SIG_MESSAGE("diffraction_detector_19 (Init)");
#define mccompcurname  diffraction_detector_19
#define mccompcurtype  PSD_monitor
#define mccompcurindex 923
#define PSD_N mccdiffraction_detector_19_PSD_N
#define PSD_p mccdiffraction_detector_19_PSD_p
#define PSD_p2 mccdiffraction_detector_19_PSD_p2
#define nx mccdiffraction_detector_19_nx
#define ny mccdiffraction_detector_19_ny
#define filename mccdiffraction_detector_19_filename
#define xmin mccdiffraction_detector_19_xmin
#define xmax mccdiffraction_detector_19_xmax
#define ymin mccdiffraction_detector_19_ymin
#define ymax mccdiffraction_detector_19_ymax
#define xwidth mccdiffraction_detector_19_xwidth
#define yheight mccdiffraction_detector_19_yheight
#define restore_neutron mccdiffraction_detector_19_restore_neutron
#line 68 "/usr/share/mcstas/2.7/monitors/PSD_monitor.comp"
{
  if (xwidth  > 0) { xmax = xwidth/2;  xmin = -xmax; }
  if (yheight > 0) { ymax = yheight/2; ymin = -ymax; }

  if ((xmin >= xmax) || (ymin >= ymax)){
    printf("PSD_monitor: %s: Null detection area !\n"
           "ERROR        (xwidth,yheight,xmin,xmax,ymin,ymax). Exiting",
    NAME_CURRENT_COMP);
    exit(-1);
  }

  PSD_N = create_darr2d(nx, ny);
  PSD_p = create_darr2d(nx, ny);
  PSD_p2 = create_darr2d(nx, ny);

  int i, j;
  for (i=0; i<nx; i++){
    for (j=0; j<ny; j++){
      PSD_N[i][j] = 0;
      PSD_p[i][j] = 0;
      PSD_p2[i][j] = 0;
    }
  }
}
#line 343968 "MACS_sample_kidney_box.c"
#undef restore_neutron
#undef yheight
#undef xwidth
#undef ymax
#undef ymin
#undef xmax
#undef xmin
#undef filename
#undef ny
#undef nx
#undef PSD_p2
#undef PSD_p
#undef PSD_N
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

  /* Initializations for component spec_detector_19. */
  SIG_MESSAGE("spec_detector_19 (Init)");
#define mccompcurname  spec_detector_19
#define mccompcurtype  PSD_monitor
#define mccompcurindex 924
#define PSD_N mccspec_detector_19_PSD_N
#define PSD_p mccspec_detector_19_PSD_p
#define PSD_p2 mccspec_detector_19_PSD_p2
#define nx mccspec_detector_19_nx
#define ny mccspec_detector_19_ny
#define filename mccspec_detector_19_filename
#define xmin mccspec_detector_19_xmin
#define xmax mccspec_detector_19_xmax
#define ymin mccspec_detector_19_ymin
#define ymax mccspec_detector_19_ymax
#define xwidth mccspec_detector_19_xwidth
#define yheight mccspec_detector_19_yheight
#define restore_neutron mccspec_detector_19_restore_neutron
#line 68 "/usr/share/mcstas/2.7/monitors/PSD_monitor.comp"
{
  if (xwidth  > 0) { xmax = xwidth/2;  xmin = -xmax; }
  if (yheight > 0) { ymax = yheight/2; ymin = -ymax; }

  if ((xmin >= xmax) || (ymin >= ymax)){
    printf("PSD_monitor: %s: Null detection area !\n"
           "ERROR        (xwidth,yheight,xmin,xmax,ymin,ymax). Exiting",
    NAME_CURRENT_COMP);
    exit(-1);
  }

  PSD_N = create_darr2d(nx, ny);
  PSD_p = create_darr2d(nx, ny);
  PSD_p2 = create_darr2d(nx, ny);

  int i, j;
  for (i=0; i<nx; i++){
    for (j=0; j<ny; j++){
      PSD_N[i][j] = 0;
      PSD_p[i][j] = 0;
      PSD_p2[i][j] = 0;
    }
  }
}
#line 344029 "MACS_sample_kidney_box.c"
#undef restore_neutron
#undef yheight
#undef xwidth
#undef ymax
#undef ymin
#undef xmax
#undef xmin
#undef filename
#undef ny
#undef nx
#undef PSD_p2
#undef PSD_p
#undef PSD_N
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

  /* Initializations for component spec_detector_history_0. */
  SIG_MESSAGE("spec_detector_history_0 (Init)");
#define mccompcurname  spec_detector_history_0
#define mccompcurtype  extend_monitor
#define mccompcurindex 925
#define nb mccspec_detector_history_0_nb
#define C_N mccspec_detector_history_0_C_N
#define C_p mccspec_detector_history_0_C_p
#define C_p2 mccspec_detector_history_0_C_p2
#define filename mccspec_detector_history_0_filename
#define xmin mccspec_detector_history_0_xmin
#define xmax mccspec_detector_history_0_xmax
#define ymin mccspec_detector_history_0_ymin
#define ymax mccspec_detector_history_0_ymax
#define xwidth mccspec_detector_history_0_xwidth
#define yheight mccspec_detector_history_0_yheight
#define restore_neutron mccspec_detector_history_0_restore_neutron
#line 63 "extend_monitor.comp"
{
    int i;

    if (xwidth  > 0) { xmax = xwidth/2;  xmin = -xmax; }
    if (yheight > 0) { ymax = yheight/2; ymin = -ymax; }

    if ((xmin >= xmax) || (ymin >= ymax)) {
            printf("extend_monitor: %s: Null detection area !\n"
                   "ERROR        (xwidth,yheight,xmin,xmax,ymin,ymax). Exiting",
           NAME_CURRENT_COMP);
      exit(0);
    }

    for (i=0; i<nb; i++)
    {
      C_N[i] = 0;
      C_p[i] = 0;
      C_p2[i] = 0;
    }
}
#line 344085 "MACS_sample_kidney_box.c"
#undef restore_neutron
#undef yheight
#undef xwidth
#undef ymax
#undef ymin
#undef xmax
#undef xmin
#undef filename
#undef C_p2
#undef C_p
#undef C_N
#undef nb
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

  /* Initializations for component spec_detector_history_1. */
  SIG_MESSAGE("spec_detector_history_1 (Init)");
#define mccompcurname  spec_detector_history_1
#define mccompcurtype  extend_monitor
#define mccompcurindex 926
#define nb mccspec_detector_history_1_nb
#define C_N mccspec_detector_history_1_C_N
#define C_p mccspec_detector_history_1_C_p
#define C_p2 mccspec_detector_history_1_C_p2
#define filename mccspec_detector_history_1_filename
#define xmin mccspec_detector_history_1_xmin
#define xmax mccspec_detector_history_1_xmax
#define ymin mccspec_detector_history_1_ymin
#define ymax mccspec_detector_history_1_ymax
#define xwidth mccspec_detector_history_1_xwidth
#define yheight mccspec_detector_history_1_yheight
#define restore_neutron mccspec_detector_history_1_restore_neutron
#line 63 "extend_monitor.comp"
{
    int i;

    if (xwidth  > 0) { xmax = xwidth/2;  xmin = -xmax; }
    if (yheight > 0) { ymax = yheight/2; ymin = -ymax; }

    if ((xmin >= xmax) || (ymin >= ymax)) {
            printf("extend_monitor: %s: Null detection area !\n"
                   "ERROR        (xwidth,yheight,xmin,xmax,ymin,ymax). Exiting",
           NAME_CURRENT_COMP);
      exit(0);
    }

    for (i=0; i<nb; i++)
    {
      C_N[i] = 0;
      C_p[i] = 0;
      C_p2[i] = 0;
    }
}
#line 344140 "MACS_sample_kidney_box.c"
#undef restore_neutron
#undef yheight
#undef xwidth
#undef ymax
#undef ymin
#undef xmax
#undef xmin
#undef filename
#undef C_p2
#undef C_p
#undef C_N
#undef nb
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

  /* Initializations for component spec_detector_history_2. */
  SIG_MESSAGE("spec_detector_history_2 (Init)");
#define mccompcurname  spec_detector_history_2
#define mccompcurtype  extend_monitor
#define mccompcurindex 927
#define nb mccspec_detector_history_2_nb
#define C_N mccspec_detector_history_2_C_N
#define C_p mccspec_detector_history_2_C_p
#define C_p2 mccspec_detector_history_2_C_p2
#define filename mccspec_detector_history_2_filename
#define xmin mccspec_detector_history_2_xmin
#define xmax mccspec_detector_history_2_xmax
#define ymin mccspec_detector_history_2_ymin
#define ymax mccspec_detector_history_2_ymax
#define xwidth mccspec_detector_history_2_xwidth
#define yheight mccspec_detector_history_2_yheight
#define restore_neutron mccspec_detector_history_2_restore_neutron
#line 63 "extend_monitor.comp"
{
    int i;

    if (xwidth  > 0) { xmax = xwidth/2;  xmin = -xmax; }
    if (yheight > 0) { ymax = yheight/2; ymin = -ymax; }

    if ((xmin >= xmax) || (ymin >= ymax)) {
            printf("extend_monitor: %s: Null detection area !\n"
                   "ERROR        (xwidth,yheight,xmin,xmax,ymin,ymax). Exiting",
           NAME_CURRENT_COMP);
      exit(0);
    }

    for (i=0; i<nb; i++)
    {
      C_N[i] = 0;
      C_p[i] = 0;
      C_p2[i] = 0;
    }
}
#line 344195 "MACS_sample_kidney_box.c"
#undef restore_neutron
#undef yheight
#undef xwidth
#undef ymax
#undef ymin
#undef xmax
#undef xmin
#undef filename
#undef C_p2
#undef C_p
#undef C_N
#undef nb
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

  /* Initializations for component spec_detector_history_3. */
  SIG_MESSAGE("spec_detector_history_3 (Init)");
#define mccompcurname  spec_detector_history_3
#define mccompcurtype  extend_monitor
#define mccompcurindex 928
#define nb mccspec_detector_history_3_nb
#define C_N mccspec_detector_history_3_C_N
#define C_p mccspec_detector_history_3_C_p
#define C_p2 mccspec_detector_history_3_C_p2
#define filename mccspec_detector_history_3_filename
#define xmin mccspec_detector_history_3_xmin
#define xmax mccspec_detector_history_3_xmax
#define ymin mccspec_detector_history_3_ymin
#define ymax mccspec_detector_history_3_ymax
#define xwidth mccspec_detector_history_3_xwidth
#define yheight mccspec_detector_history_3_yheight
#define restore_neutron mccspec_detector_history_3_restore_neutron
#line 63 "extend_monitor.comp"
{
    int i;

    if (xwidth  > 0) { xmax = xwidth/2;  xmin = -xmax; }
    if (yheight > 0) { ymax = yheight/2; ymin = -ymax; }

    if ((xmin >= xmax) || (ymin >= ymax)) {
            printf("extend_monitor: %s: Null detection area !\n"
                   "ERROR        (xwidth,yheight,xmin,xmax,ymin,ymax). Exiting",
           NAME_CURRENT_COMP);
      exit(0);
    }

    for (i=0; i<nb; i++)
    {
      C_N[i] = 0;
      C_p[i] = 0;
      C_p2[i] = 0;
    }
}
#line 344250 "MACS_sample_kidney_box.c"
#undef restore_neutron
#undef yheight
#undef xwidth
#undef ymax
#undef ymin
#undef xmax
#undef xmin
#undef filename
#undef C_p2
#undef C_p
#undef C_N
#undef nb
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

  /* Initializations for component spec_detector_history_4. */
  SIG_MESSAGE("spec_detector_history_4 (Init)");
#define mccompcurname  spec_detector_history_4
#define mccompcurtype  extend_monitor
#define mccompcurindex 929
#define nb mccspec_detector_history_4_nb
#define C_N mccspec_detector_history_4_C_N
#define C_p mccspec_detector_history_4_C_p
#define C_p2 mccspec_detector_history_4_C_p2
#define filename mccspec_detector_history_4_filename
#define xmin mccspec_detector_history_4_xmin
#define xmax mccspec_detector_history_4_xmax
#define ymin mccspec_detector_history_4_ymin
#define ymax mccspec_detector_history_4_ymax
#define xwidth mccspec_detector_history_4_xwidth
#define yheight mccspec_detector_history_4_yheight
#define restore_neutron mccspec_detector_history_4_restore_neutron
#line 63 "extend_monitor.comp"
{
    int i;

    if (xwidth  > 0) { xmax = xwidth/2;  xmin = -xmax; }
    if (yheight > 0) { ymax = yheight/2; ymin = -ymax; }

    if ((xmin >= xmax) || (ymin >= ymax)) {
            printf("extend_monitor: %s: Null detection area !\n"
                   "ERROR        (xwidth,yheight,xmin,xmax,ymin,ymax). Exiting",
           NAME_CURRENT_COMP);
      exit(0);
    }

    for (i=0; i<nb; i++)
    {
      C_N[i] = 0;
      C_p[i] = 0;
      C_p2[i] = 0;
    }
}
#line 344305 "MACS_sample_kidney_box.c"
#undef restore_neutron
#undef yheight
#undef xwidth
#undef ymax
#undef ymin
#undef xmax
#undef xmin
#undef filename
#undef C_p2
#undef C_p
#undef C_N
#undef nb
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

  /* Initializations for component spec_detector_history_5. */
  SIG_MESSAGE("spec_detector_history_5 (Init)");
#define mccompcurname  spec_detector_history_5
#define mccompcurtype  extend_monitor
#define mccompcurindex 930
#define nb mccspec_detector_history_5_nb
#define C_N mccspec_detector_history_5_C_N
#define C_p mccspec_detector_history_5_C_p
#define C_p2 mccspec_detector_history_5_C_p2
#define filename mccspec_detector_history_5_filename
#define xmin mccspec_detector_history_5_xmin
#define xmax mccspec_detector_history_5_xmax
#define ymin mccspec_detector_history_5_ymin
#define ymax mccspec_detector_history_5_ymax
#define xwidth mccspec_detector_history_5_xwidth
#define yheight mccspec_detector_history_5_yheight
#define restore_neutron mccspec_detector_history_5_restore_neutron
#line 63 "extend_monitor.comp"
{
    int i;

    if (xwidth  > 0) { xmax = xwidth/2;  xmin = -xmax; }
    if (yheight > 0) { ymax = yheight/2; ymin = -ymax; }

    if ((xmin >= xmax) || (ymin >= ymax)) {
            printf("extend_monitor: %s: Null detection area !\n"
                   "ERROR        (xwidth,yheight,xmin,xmax,ymin,ymax). Exiting",
           NAME_CURRENT_COMP);
      exit(0);
    }

    for (i=0; i<nb; i++)
    {
      C_N[i] = 0;
      C_p[i] = 0;
      C_p2[i] = 0;
    }
}
#line 344360 "MACS_sample_kidney_box.c"
#undef restore_neutron
#undef yheight
#undef xwidth
#undef ymax
#undef ymin
#undef xmax
#undef xmin
#undef filename
#undef C_p2
#undef C_p
#undef C_N
#undef nb
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

  /* Initializations for component spec_detector_history_6. */
  SIG_MESSAGE("spec_detector_history_6 (Init)");
#define mccompcurname  spec_detector_history_6
#define mccompcurtype  extend_monitor
#define mccompcurindex 931
#define nb mccspec_detector_history_6_nb
#define C_N mccspec_detector_history_6_C_N
#define C_p mccspec_detector_history_6_C_p
#define C_p2 mccspec_detector_history_6_C_p2
#define filename mccspec_detector_history_6_filename
#define xmin mccspec_detector_history_6_xmin
#define xmax mccspec_detector_history_6_xmax
#define ymin mccspec_detector_history_6_ymin
#define ymax mccspec_detector_history_6_ymax
#define xwidth mccspec_detector_history_6_xwidth
#define yheight mccspec_detector_history_6_yheight
#define restore_neutron mccspec_detector_history_6_restore_neutron
#line 63 "extend_monitor.comp"
{
    int i;

    if (xwidth  > 0) { xmax = xwidth/2;  xmin = -xmax; }
    if (yheight > 0) { ymax = yheight/2; ymin = -ymax; }

    if ((xmin >= xmax) || (ymin >= ymax)) {
            printf("extend_monitor: %s: Null detection area !\n"
                   "ERROR        (xwidth,yheight,xmin,xmax,ymin,ymax). Exiting",
           NAME_CURRENT_COMP);
      exit(0);
    }

    for (i=0; i<nb; i++)
    {
      C_N[i] = 0;
      C_p[i] = 0;
      C_p2[i] = 0;
    }
}
#line 344415 "MACS_sample_kidney_box.c"
#undef restore_neutron
#undef yheight
#undef xwidth
#undef ymax
#undef ymin
#undef xmax
#undef xmin
#undef filename
#undef C_p2
#undef C_p
#undef C_N
#undef nb
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

  /* Initializations for component spec_detector_history_7. */
  SIG_MESSAGE("spec_detector_history_7 (Init)");
#define mccompcurname  spec_detector_history_7
#define mccompcurtype  extend_monitor
#define mccompcurindex 932
#define nb mccspec_detector_history_7_nb
#define C_N mccspec_detector_history_7_C_N
#define C_p mccspec_detector_history_7_C_p
#define C_p2 mccspec_detector_history_7_C_p2
#define filename mccspec_detector_history_7_filename
#define xmin mccspec_detector_history_7_xmin
#define xmax mccspec_detector_history_7_xmax
#define ymin mccspec_detector_history_7_ymin
#define ymax mccspec_detector_history_7_ymax
#define xwidth mccspec_detector_history_7_xwidth
#define yheight mccspec_detector_history_7_yheight
#define restore_neutron mccspec_detector_history_7_restore_neutron
#line 63 "extend_monitor.comp"
{
    int i;

    if (xwidth  > 0) { xmax = xwidth/2;  xmin = -xmax; }
    if (yheight > 0) { ymax = yheight/2; ymin = -ymax; }

    if ((xmin >= xmax) || (ymin >= ymax)) {
            printf("extend_monitor: %s: Null detection area !\n"
                   "ERROR        (xwidth,yheight,xmin,xmax,ymin,ymax). Exiting",
           NAME_CURRENT_COMP);
      exit(0);
    }

    for (i=0; i<nb; i++)
    {
      C_N[i] = 0;
      C_p[i] = 0;
      C_p2[i] = 0;
    }
}
#line 344470 "MACS_sample_kidney_box.c"
#undef restore_neutron
#undef yheight
#undef xwidth
#undef ymax
#undef ymin
#undef xmax
#undef xmin
#undef filename
#undef C_p2
#undef C_p
#undef C_N
#undef nb
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

  /* Initializations for component spec_detector_history_8. */
  SIG_MESSAGE("spec_detector_history_8 (Init)");
#define mccompcurname  spec_detector_history_8
#define mccompcurtype  extend_monitor
#define mccompcurindex 933
#define nb mccspec_detector_history_8_nb
#define C_N mccspec_detector_history_8_C_N
#define C_p mccspec_detector_history_8_C_p
#define C_p2 mccspec_detector_history_8_C_p2
#define filename mccspec_detector_history_8_filename
#define xmin mccspec_detector_history_8_xmin
#define xmax mccspec_detector_history_8_xmax
#define ymin mccspec_detector_history_8_ymin
#define ymax mccspec_detector_history_8_ymax
#define xwidth mccspec_detector_history_8_xwidth
#define yheight mccspec_detector_history_8_yheight
#define restore_neutron mccspec_detector_history_8_restore_neutron
#line 63 "extend_monitor.comp"
{
    int i;

    if (xwidth  > 0) { xmax = xwidth/2;  xmin = -xmax; }
    if (yheight > 0) { ymax = yheight/2; ymin = -ymax; }

    if ((xmin >= xmax) || (ymin >= ymax)) {
            printf("extend_monitor: %s: Null detection area !\n"
                   "ERROR        (xwidth,yheight,xmin,xmax,ymin,ymax). Exiting",
           NAME_CURRENT_COMP);
      exit(0);
    }

    for (i=0; i<nb; i++)
    {
      C_N[i] = 0;
      C_p[i] = 0;
      C_p2[i] = 0;
    }
}
#line 344525 "MACS_sample_kidney_box.c"
#undef restore_neutron
#undef yheight
#undef xwidth
#undef ymax
#undef ymin
#undef xmax
#undef xmin
#undef filename
#undef C_p2
#undef C_p
#undef C_N
#undef nb
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

  /* Initializations for component spec_detector_history_9. */
  SIG_MESSAGE("spec_detector_history_9 (Init)");
#define mccompcurname  spec_detector_history_9
#define mccompcurtype  extend_monitor
#define mccompcurindex 934
#define nb mccspec_detector_history_9_nb
#define C_N mccspec_detector_history_9_C_N
#define C_p mccspec_detector_history_9_C_p
#define C_p2 mccspec_detector_history_9_C_p2
#define filename mccspec_detector_history_9_filename
#define xmin mccspec_detector_history_9_xmin
#define xmax mccspec_detector_history_9_xmax
#define ymin mccspec_detector_history_9_ymin
#define ymax mccspec_detector_history_9_ymax
#define xwidth mccspec_detector_history_9_xwidth
#define yheight mccspec_detector_history_9_yheight
#define restore_neutron mccspec_detector_history_9_restore_neutron
#line 63 "extend_monitor.comp"
{
    int i;

    if (xwidth  > 0) { xmax = xwidth/2;  xmin = -xmax; }
    if (yheight > 0) { ymax = yheight/2; ymin = -ymax; }

    if ((xmin >= xmax) || (ymin >= ymax)) {
            printf("extend_monitor: %s: Null detection area !\n"
                   "ERROR        (xwidth,yheight,xmin,xmax,ymin,ymax). Exiting",
           NAME_CURRENT_COMP);
      exit(0);
    }

    for (i=0; i<nb; i++)
    {
      C_N[i] = 0;
      C_p[i] = 0;
      C_p2[i] = 0;
    }
}
#line 344580 "MACS_sample_kidney_box.c"
#undef restore_neutron
#undef yheight
#undef xwidth
#undef ymax
#undef ymin
#undef xmax
#undef xmin
#undef filename
#undef C_p2
#undef C_p
#undef C_N
#undef nb
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

  /* Initializations for component spec_detector_history_10. */
  SIG_MESSAGE("spec_detector_history_10 (Init)");
#define mccompcurname  spec_detector_history_10
#define mccompcurtype  extend_monitor
#define mccompcurindex 935
#define nb mccspec_detector_history_10_nb
#define C_N mccspec_detector_history_10_C_N
#define C_p mccspec_detector_history_10_C_p
#define C_p2 mccspec_detector_history_10_C_p2
#define filename mccspec_detector_history_10_filename
#define xmin mccspec_detector_history_10_xmin
#define xmax mccspec_detector_history_10_xmax
#define ymin mccspec_detector_history_10_ymin
#define ymax mccspec_detector_history_10_ymax
#define xwidth mccspec_detector_history_10_xwidth
#define yheight mccspec_detector_history_10_yheight
#define restore_neutron mccspec_detector_history_10_restore_neutron
#line 63 "extend_monitor.comp"
{
    int i;

    if (xwidth  > 0) { xmax = xwidth/2;  xmin = -xmax; }
    if (yheight > 0) { ymax = yheight/2; ymin = -ymax; }

    if ((xmin >= xmax) || (ymin >= ymax)) {
            printf("extend_monitor: %s: Null detection area !\n"
                   "ERROR        (xwidth,yheight,xmin,xmax,ymin,ymax). Exiting",
           NAME_CURRENT_COMP);
      exit(0);
    }

    for (i=0; i<nb; i++)
    {
      C_N[i] = 0;
      C_p[i] = 0;
      C_p2[i] = 0;
    }
}
#line 344635 "MACS_sample_kidney_box.c"
#undef restore_neutron
#undef yheight
#undef xwidth
#undef ymax
#undef ymin
#undef xmax
#undef xmin
#undef filename
#undef C_p2
#undef C_p
#undef C_N
#undef nb
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

  /* Initializations for component spec_detector_history_11. */
  SIG_MESSAGE("spec_detector_history_11 (Init)");
#define mccompcurname  spec_detector_history_11
#define mccompcurtype  extend_monitor
#define mccompcurindex 936
#define nb mccspec_detector_history_11_nb
#define C_N mccspec_detector_history_11_C_N
#define C_p mccspec_detector_history_11_C_p
#define C_p2 mccspec_detector_history_11_C_p2
#define filename mccspec_detector_history_11_filename
#define xmin mccspec_detector_history_11_xmin
#define xmax mccspec_detector_history_11_xmax
#define ymin mccspec_detector_history_11_ymin
#define ymax mccspec_detector_history_11_ymax
#define xwidth mccspec_detector_history_11_xwidth
#define yheight mccspec_detector_history_11_yheight
#define restore_neutron mccspec_detector_history_11_restore_neutron
#line 63 "extend_monitor.comp"
{
    int i;

    if (xwidth  > 0) { xmax = xwidth/2;  xmin = -xmax; }
    if (yheight > 0) { ymax = yheight/2; ymin = -ymax; }

    if ((xmin >= xmax) || (ymin >= ymax)) {
            printf("extend_monitor: %s: Null detection area !\n"
                   "ERROR        (xwidth,yheight,xmin,xmax,ymin,ymax). Exiting",
           NAME_CURRENT_COMP);
      exit(0);
    }

    for (i=0; i<nb; i++)
    {
      C_N[i] = 0;
      C_p[i] = 0;
      C_p2[i] = 0;
    }
}
#line 344690 "MACS_sample_kidney_box.c"
#undef restore_neutron
#undef yheight
#undef xwidth
#undef ymax
#undef ymin
#undef xmax
#undef xmin
#undef filename
#undef C_p2
#undef C_p
#undef C_N
#undef nb
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

  /* Initializations for component spec_detector_history_12. */
  SIG_MESSAGE("spec_detector_history_12 (Init)");
#define mccompcurname  spec_detector_history_12
#define mccompcurtype  extend_monitor
#define mccompcurindex 937
#define nb mccspec_detector_history_12_nb
#define C_N mccspec_detector_history_12_C_N
#define C_p mccspec_detector_history_12_C_p
#define C_p2 mccspec_detector_history_12_C_p2
#define filename mccspec_detector_history_12_filename
#define xmin mccspec_detector_history_12_xmin
#define xmax mccspec_detector_history_12_xmax
#define ymin mccspec_detector_history_12_ymin
#define ymax mccspec_detector_history_12_ymax
#define xwidth mccspec_detector_history_12_xwidth
#define yheight mccspec_detector_history_12_yheight
#define restore_neutron mccspec_detector_history_12_restore_neutron
#line 63 "extend_monitor.comp"
{
    int i;

    if (xwidth  > 0) { xmax = xwidth/2;  xmin = -xmax; }
    if (yheight > 0) { ymax = yheight/2; ymin = -ymax; }

    if ((xmin >= xmax) || (ymin >= ymax)) {
            printf("extend_monitor: %s: Null detection area !\n"
                   "ERROR        (xwidth,yheight,xmin,xmax,ymin,ymax). Exiting",
           NAME_CURRENT_COMP);
      exit(0);
    }

    for (i=0; i<nb; i++)
    {
      C_N[i] = 0;
      C_p[i] = 0;
      C_p2[i] = 0;
    }
}
#line 344745 "MACS_sample_kidney_box.c"
#undef restore_neutron
#undef yheight
#undef xwidth
#undef ymax
#undef ymin
#undef xmax
#undef xmin
#undef filename
#undef C_p2
#undef C_p
#undef C_N
#undef nb
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

  /* Initializations for component spec_detector_history_13. */
  SIG_MESSAGE("spec_detector_history_13 (Init)");
#define mccompcurname  spec_detector_history_13
#define mccompcurtype  extend_monitor
#define mccompcurindex 938
#define nb mccspec_detector_history_13_nb
#define C_N mccspec_detector_history_13_C_N
#define C_p mccspec_detector_history_13_C_p
#define C_p2 mccspec_detector_history_13_C_p2
#define filename mccspec_detector_history_13_filename
#define xmin mccspec_detector_history_13_xmin
#define xmax mccspec_detector_history_13_xmax
#define ymin mccspec_detector_history_13_ymin
#define ymax mccspec_detector_history_13_ymax
#define xwidth mccspec_detector_history_13_xwidth
#define yheight mccspec_detector_history_13_yheight
#define restore_neutron mccspec_detector_history_13_restore_neutron
#line 63 "extend_monitor.comp"
{
    int i;

    if (xwidth  > 0) { xmax = xwidth/2;  xmin = -xmax; }
    if (yheight > 0) { ymax = yheight/2; ymin = -ymax; }

    if ((xmin >= xmax) || (ymin >= ymax)) {
            printf("extend_monitor: %s: Null detection area !\n"
                   "ERROR        (xwidth,yheight,xmin,xmax,ymin,ymax). Exiting",
           NAME_CURRENT_COMP);
      exit(0);
    }

    for (i=0; i<nb; i++)
    {
      C_N[i] = 0;
      C_p[i] = 0;
      C_p2[i] = 0;
    }
}
#line 344800 "MACS_sample_kidney_box.c"
#undef restore_neutron
#undef yheight
#undef xwidth
#undef ymax
#undef ymin
#undef xmax
#undef xmin
#undef filename
#undef C_p2
#undef C_p
#undef C_N
#undef nb
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

  /* Initializations for component spec_detector_history_14. */
  SIG_MESSAGE("spec_detector_history_14 (Init)");
#define mccompcurname  spec_detector_history_14
#define mccompcurtype  extend_monitor
#define mccompcurindex 939
#define nb mccspec_detector_history_14_nb
#define C_N mccspec_detector_history_14_C_N
#define C_p mccspec_detector_history_14_C_p
#define C_p2 mccspec_detector_history_14_C_p2
#define filename mccspec_detector_history_14_filename
#define xmin mccspec_detector_history_14_xmin
#define xmax mccspec_detector_history_14_xmax
#define ymin mccspec_detector_history_14_ymin
#define ymax mccspec_detector_history_14_ymax
#define xwidth mccspec_detector_history_14_xwidth
#define yheight mccspec_detector_history_14_yheight
#define restore_neutron mccspec_detector_history_14_restore_neutron
#line 63 "extend_monitor.comp"
{
    int i;

    if (xwidth  > 0) { xmax = xwidth/2;  xmin = -xmax; }
    if (yheight > 0) { ymax = yheight/2; ymin = -ymax; }

    if ((xmin >= xmax) || (ymin >= ymax)) {
            printf("extend_monitor: %s: Null detection area !\n"
                   "ERROR        (xwidth,yheight,xmin,xmax,ymin,ymax). Exiting",
           NAME_CURRENT_COMP);
      exit(0);
    }

    for (i=0; i<nb; i++)
    {
      C_N[i] = 0;
      C_p[i] = 0;
      C_p2[i] = 0;
    }
}
#line 344855 "MACS_sample_kidney_box.c"
#undef restore_neutron
#undef yheight
#undef xwidth
#undef ymax
#undef ymin
#undef xmax
#undef xmin
#undef filename
#undef C_p2
#undef C_p
#undef C_N
#undef nb
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

  /* Initializations for component spec_detector_history_15. */
  SIG_MESSAGE("spec_detector_history_15 (Init)");
#define mccompcurname  spec_detector_history_15
#define mccompcurtype  extend_monitor
#define mccompcurindex 940
#define nb mccspec_detector_history_15_nb
#define C_N mccspec_detector_history_15_C_N
#define C_p mccspec_detector_history_15_C_p
#define C_p2 mccspec_detector_history_15_C_p2
#define filename mccspec_detector_history_15_filename
#define xmin mccspec_detector_history_15_xmin
#define xmax mccspec_detector_history_15_xmax
#define ymin mccspec_detector_history_15_ymin
#define ymax mccspec_detector_history_15_ymax
#define xwidth mccspec_detector_history_15_xwidth
#define yheight mccspec_detector_history_15_yheight
#define restore_neutron mccspec_detector_history_15_restore_neutron
#line 63 "extend_monitor.comp"
{
    int i;

    if (xwidth  > 0) { xmax = xwidth/2;  xmin = -xmax; }
    if (yheight > 0) { ymax = yheight/2; ymin = -ymax; }

    if ((xmin >= xmax) || (ymin >= ymax)) {
            printf("extend_monitor: %s: Null detection area !\n"
                   "ERROR        (xwidth,yheight,xmin,xmax,ymin,ymax). Exiting",
           NAME_CURRENT_COMP);
      exit(0);
    }

    for (i=0; i<nb; i++)
    {
      C_N[i] = 0;
      C_p[i] = 0;
      C_p2[i] = 0;
    }
}
#line 344910 "MACS_sample_kidney_box.c"
#undef restore_neutron
#undef yheight
#undef xwidth
#undef ymax
#undef ymin
#undef xmax
#undef xmin
#undef filename
#undef C_p2
#undef C_p
#undef C_N
#undef nb
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

  /* Initializations for component spec_detector_history_16. */
  SIG_MESSAGE("spec_detector_history_16 (Init)");
#define mccompcurname  spec_detector_history_16
#define mccompcurtype  extend_monitor
#define mccompcurindex 941
#define nb mccspec_detector_history_16_nb
#define C_N mccspec_detector_history_16_C_N
#define C_p mccspec_detector_history_16_C_p
#define C_p2 mccspec_detector_history_16_C_p2
#define filename mccspec_detector_history_16_filename
#define xmin mccspec_detector_history_16_xmin
#define xmax mccspec_detector_history_16_xmax
#define ymin mccspec_detector_history_16_ymin
#define ymax mccspec_detector_history_16_ymax
#define xwidth mccspec_detector_history_16_xwidth
#define yheight mccspec_detector_history_16_yheight
#define restore_neutron mccspec_detector_history_16_restore_neutron
#line 63 "extend_monitor.comp"
{
    int i;

    if (xwidth  > 0) { xmax = xwidth/2;  xmin = -xmax; }
    if (yheight > 0) { ymax = yheight/2; ymin = -ymax; }

    if ((xmin >= xmax) || (ymin >= ymax)) {
            printf("extend_monitor: %s: Null detection area !\n"
                   "ERROR        (xwidth,yheight,xmin,xmax,ymin,ymax). Exiting",
           NAME_CURRENT_COMP);
      exit(0);
    }

    for (i=0; i<nb; i++)
    {
      C_N[i] = 0;
      C_p[i] = 0;
      C_p2[i] = 0;
    }
}
#line 344965 "MACS_sample_kidney_box.c"
#undef restore_neutron
#undef yheight
#undef xwidth
#undef ymax
#undef ymin
#undef xmax
#undef xmin
#undef filename
#undef C_p2
#undef C_p
#undef C_N
#undef nb
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

  /* Initializations for component spec_detector_history_17. */
  SIG_MESSAGE("spec_detector_history_17 (Init)");
#define mccompcurname  spec_detector_history_17
#define mccompcurtype  extend_monitor
#define mccompcurindex 942
#define nb mccspec_detector_history_17_nb
#define C_N mccspec_detector_history_17_C_N
#define C_p mccspec_detector_history_17_C_p
#define C_p2 mccspec_detector_history_17_C_p2
#define filename mccspec_detector_history_17_filename
#define xmin mccspec_detector_history_17_xmin
#define xmax mccspec_detector_history_17_xmax
#define ymin mccspec_detector_history_17_ymin
#define ymax mccspec_detector_history_17_ymax
#define xwidth mccspec_detector_history_17_xwidth
#define yheight mccspec_detector_history_17_yheight
#define restore_neutron mccspec_detector_history_17_restore_neutron
#line 63 "extend_monitor.comp"
{
    int i;

    if (xwidth  > 0) { xmax = xwidth/2;  xmin = -xmax; }
    if (yheight > 0) { ymax = yheight/2; ymin = -ymax; }

    if ((xmin >= xmax) || (ymin >= ymax)) {
            printf("extend_monitor: %s: Null detection area !\n"
                   "ERROR        (xwidth,yheight,xmin,xmax,ymin,ymax). Exiting",
           NAME_CURRENT_COMP);
      exit(0);
    }

    for (i=0; i<nb; i++)
    {
      C_N[i] = 0;
      C_p[i] = 0;
      C_p2[i] = 0;
    }
}
#line 345020 "MACS_sample_kidney_box.c"
#undef restore_neutron
#undef yheight
#undef xwidth
#undef ymax
#undef ymin
#undef xmax
#undef xmin
#undef filename
#undef C_p2
#undef C_p
#undef C_N
#undef nb
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

  /* Initializations for component spec_detector_history_18. */
  SIG_MESSAGE("spec_detector_history_18 (Init)");
#define mccompcurname  spec_detector_history_18
#define mccompcurtype  extend_monitor
#define mccompcurindex 943
#define nb mccspec_detector_history_18_nb
#define C_N mccspec_detector_history_18_C_N
#define C_p mccspec_detector_history_18_C_p
#define C_p2 mccspec_detector_history_18_C_p2
#define filename mccspec_detector_history_18_filename
#define xmin mccspec_detector_history_18_xmin
#define xmax mccspec_detector_history_18_xmax
#define ymin mccspec_detector_history_18_ymin
#define ymax mccspec_detector_history_18_ymax
#define xwidth mccspec_detector_history_18_xwidth
#define yheight mccspec_detector_history_18_yheight
#define restore_neutron mccspec_detector_history_18_restore_neutron
#line 63 "extend_monitor.comp"
{
    int i;

    if (xwidth  > 0) { xmax = xwidth/2;  xmin = -xmax; }
    if (yheight > 0) { ymax = yheight/2; ymin = -ymax; }

    if ((xmin >= xmax) || (ymin >= ymax)) {
            printf("extend_monitor: %s: Null detection area !\n"
                   "ERROR        (xwidth,yheight,xmin,xmax,ymin,ymax). Exiting",
           NAME_CURRENT_COMP);
      exit(0);
    }

    for (i=0; i<nb; i++)
    {
      C_N[i] = 0;
      C_p[i] = 0;
      C_p2[i] = 0;
    }
}
#line 345075 "MACS_sample_kidney_box.c"
#undef restore_neutron
#undef yheight
#undef xwidth
#undef ymax
#undef ymin
#undef xmax
#undef xmin
#undef filename
#undef C_p2
#undef C_p
#undef C_N
#undef nb
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

  /* Initializations for component spec_detector_history_19. */
  SIG_MESSAGE("spec_detector_history_19 (Init)");
#define mccompcurname  spec_detector_history_19
#define mccompcurtype  extend_monitor
#define mccompcurindex 944
#define nb mccspec_detector_history_19_nb
#define C_N mccspec_detector_history_19_C_N
#define C_p mccspec_detector_history_19_C_p
#define C_p2 mccspec_detector_history_19_C_p2
#define filename mccspec_detector_history_19_filename
#define xmin mccspec_detector_history_19_xmin
#define xmax mccspec_detector_history_19_xmax
#define ymin mccspec_detector_history_19_ymin
#define ymax mccspec_detector_history_19_ymax
#define xwidth mccspec_detector_history_19_xwidth
#define yheight mccspec_detector_history_19_yheight
#define restore_neutron mccspec_detector_history_19_restore_neutron
#line 63 "extend_monitor.comp"
{
    int i;

    if (xwidth  > 0) { xmax = xwidth/2;  xmin = -xmax; }
    if (yheight > 0) { ymax = yheight/2; ymin = -ymax; }

    if ((xmin >= xmax) || (ymin >= ymax)) {
            printf("extend_monitor: %s: Null detection area !\n"
                   "ERROR        (xwidth,yheight,xmin,xmax,ymin,ymax). Exiting",
           NAME_CURRENT_COMP);
      exit(0);
    }

    for (i=0; i<nb; i++)
    {
      C_N[i] = 0;
      C_p[i] = 0;
      C_p2[i] = 0;
    }
}
#line 345130 "MACS_sample_kidney_box.c"
#undef restore_neutron
#undef yheight
#undef xwidth
#undef ymax
#undef ymin
#undef xmax
#undef xmin
#undef filename
#undef C_p2
#undef C_p
#undef C_N
#undef nb
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

    if(mcdotrace) mcdisplay();
    mcDEBUG_INSTR_END()
  }

} /* end init */

void mcraytrace(void) {
  /* Neutronics-specific defines */
#ifdef NEUTRONICS
extern double mcnx, mcny, mcnz, mcnvx, mcnvy, mcnvz;
extern double mcnt, mcnsx, mcnsy, mcnsz, mcnp;
#endif
  /* End of Neutronics-specific defines */
  /* Copy neutron state to local variables. */
  MCNUM mcnlx = mcnx;
  MCNUM mcnly = mcny;
  MCNUM mcnlz = mcnz;
  MCNUM mcnlvx = mcnvx;
  MCNUM mcnlvy = mcnvy;
  MCNUM mcnlvz = mcnvz;
  MCNUM mcnlt = mcnt;
  MCNUM mcnlsx = mcnsx;
  MCNUM mcnlsy = mcnsy;
  MCNUM mcnlsz = mcnsz;
  MCNUM mcnlp = mcnp;

  mcDEBUG_ENTER()
  mcDEBUG_STATE(
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp)
/* Set Component group definitions (flags) */
  mcGroupfilter_group=0; /* equals index of scattering comp when in group */
  mcGroupdetector_group=0; /* equals index of scattering comp when in group */
#define mcabsorb mcabsorbAll
  /* TRACE Component Al_incoherent [1] */
  mccoordschange(mcposrAl_incoherent, mcrotrAl_incoherent,
    &mcnlx,
    &mcnly,
    &mcnlz,
    &mcnlvx,
    &mcnlvy,
    &mcnlvz,
    &mcnlsx,
    &mcnlsy,
    &mcnlsz);
  /* define label inside component Al_incoherent (without coords transformations) */
  mcJumpTrace_Al_incoherent:
  SIG_MESSAGE("Al_incoherent (Trace)");
  mcDEBUG_COMP("Al_incoherent")
  mcDEBUG_STATE(
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp)
#define x mcnlx
#define y mcnly
#define z mcnlz
#define vx mcnlvx
#define vy mcnlvy
#define vz mcnlvz
#define t mcnlt
#define sx mcnlsx
#define sy mcnlsy
#define sz mcnlsz
#define p mcnlp

#define mcabsorbComp mcabsorbCompAl_incoherent
  STORE_NEUTRON(1,
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp);
  mcScattered=0;
  mcRestore=0;
  mcNCounter[1]++;
  mcPCounter[1] += p;
  mcP2Counter[1] += p*p;
#define mccompcurname  Al_incoherent
#define mccompcurtype  Incoherent_process
#define mccompcurindex 1
#define This_process mccAl_incoherent_This_process
#define Incoherent_storage mccAl_incoherent_Incoherent_storage
#define effective_my_scattering mccAl_incoherent_effective_my_scattering
{   /* Declarations of Al_incoherent=Incoherent_process() SETTING parameters. */
MCNUM sigma = mccAl_incoherent_sigma;
MCNUM f_QE = mccAl_incoherent_f_QE;
MCNUM gamma = mccAl_incoherent_gamma;
MCNUM packing_factor = mccAl_incoherent_packing_factor;
MCNUM unit_cell_volume = mccAl_incoherent_unit_cell_volume;
MCNUM interact_fraction = mccAl_incoherent_interact_fraction;
}   /* End of Al_incoherent=Incoherent_process() SETTING parameter declarations. */
#undef effective_my_scattering
#undef Incoherent_storage
#undef This_process
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex
  /* Label for restoring  neutron */
  mcabsorbCompAl_incoherent:
  if (RESTORE) /* restore if needed */
  { RESTORE_NEUTRON(1,
      mcnlx,
      mcnly,
      mcnlz,
      mcnlvx,
      mcnlvy,
      mcnlvz,
      mcnlt,
      mcnlsx,
      mcnlsy,
      mcnlsz,
      mcnlp); }
#undef mcabsorbComp
#undef p
#undef sz
#undef sy
#undef sx
#undef t
#undef vz
#undef vy
#undef vx
#undef z
#undef y
#undef x
  mcDEBUG_STATE(
mcnlx,
mcnly,
mcnlz,
mcnlvx,
mcnlvy,
mcnlvz,
mcnlt,
mcnlsx,
mcnlsy,
mcnlsz,
mcnlp)

  /* TRACE Component Al_powder [2] */
  mccoordschange(mcposrAl_powder, mcrotrAl_powder,
    &mcnlx,
    &mcnly,
    &mcnlz,
    &mcnlvx,
    &mcnlvy,
    &mcnlvz,
    &mcnlsx,
    &mcnlsy,
    &mcnlsz);
  /* define label inside component Al_powder (without coords transformations) */
  mcJumpTrace_Al_powder:
  SIG_MESSAGE("Al_powder (Trace)");
  mcDEBUG_COMP("Al_powder")
  mcDEBUG_STATE(
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp)
#define x mcnlx
#define y mcnly
#define z mcnlz
#define vx mcnlvx
#define vy mcnlvy
#define vz mcnlvz
#define t mcnlt
#define sx mcnlsx
#define sy mcnlsy
#define sz mcnlsz
#define p mcnlp

#define mcabsorbComp mcabsorbCompAl_powder
  STORE_NEUTRON(2,
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp);
  mcScattered=0;
  mcRestore=0;
  mcNCounter[2]++;
  mcPCounter[2] += p;
  mcP2Counter[2] += p*p;
#define mccompcurname  Al_powder
#define mccompcurtype  Powder_process
#define mccompcurindex 2
#define format mccAl_powder_format
#define This_process mccAl_powder_This_process
#define Powder_storage mccAl_powder_Powder_storage
#define effective_my_scattering mccAl_powder_effective_my_scattering
#define d_phi mccAl_powder_d_phi
#define line_info mccAl_powder_line_info
#define columns mccAl_powder_columns
{   /* Declarations of Al_powder=Powder_process() SETTING parameters. */
char* reflections = mccAl_powder_reflections;
MCNUM packing_factor = mccAl_powder_packing_factor;
MCNUM Vc = mccAl_powder_Vc;
MCNUM delta_d_d = mccAl_powder_delta_d_d;
MCNUM DW = mccAl_powder_DW;
MCNUM nb_atoms = mccAl_powder_nb_atoms;
MCNUM d_phi = mccAl_powder_d_phi;
MCNUM density = mccAl_powder_density;
MCNUM weight = mccAl_powder_weight;
MCNUM barns = mccAl_powder_barns;
MCNUM Strain = mccAl_powder_Strain;
MCNUM interact_fraction = mccAl_powder_interact_fraction;
}   /* End of Al_powder=Powder_process() SETTING parameter declarations. */
#undef columns
#undef line_info
#undef d_phi
#undef effective_my_scattering
#undef Powder_storage
#undef This_process
#undef format
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex
  /* Label for restoring  neutron */
  mcabsorbCompAl_powder:
  if (RESTORE) /* restore if needed */
  { RESTORE_NEUTRON(2,
      mcnlx,
      mcnly,
      mcnlz,
      mcnlvx,
      mcnlvy,
      mcnlvz,
      mcnlt,
      mcnlsx,
      mcnlsy,
      mcnlsz,
      mcnlp); }
#undef mcabsorbComp
#undef p
#undef sz
#undef sy
#undef sx
#undef t
#undef vz
#undef vy
#undef vx
#undef z
#undef y
#undef x
  mcDEBUG_STATE(
mcnlx,
mcnly,
mcnlz,
mcnlvx,
mcnlvy,
mcnlvz,
mcnlt,
mcnlsx,
mcnlsy,
mcnlsz,
mcnlp)

  /* TRACE Component Al [3] */
  mccoordschange(mcposrAl, mcrotrAl,
    &mcnlx,
    &mcnly,
    &mcnlz,
    &mcnlvx,
    &mcnlvy,
    &mcnlvz,
    &mcnlsx,
    &mcnlsy,
    &mcnlsz);
  /* define label inside component Al (without coords transformations) */
  mcJumpTrace_Al:
  SIG_MESSAGE("Al (Trace)");
  mcDEBUG_COMP("Al")
  mcDEBUG_STATE(
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp)
#define x mcnlx
#define y mcnly
#define z mcnlz
#define vx mcnlvx
#define vy mcnlvy
#define vz mcnlvz
#define t mcnlt
#define sx mcnlsx
#define sy mcnlsy
#define sz mcnlsz
#define p mcnlp

#define mcabsorbComp mcabsorbCompAl
  STORE_NEUTRON(3,
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp);
  mcScattered=0;
  mcRestore=0;
  mcNCounter[3]++;
  mcPCounter[3] += p;
  mcP2Counter[3] += p*p;
#define mccompcurname  Al
#define mccompcurtype  Union_make_material
#define mccompcurindex 3
#define loop_index mccAl_loop_index
#define this_material mccAl_this_material
#define accepted_processes mccAl_accepted_processes
#define global_material_element mccAl_global_material_element
{   /* Declarations of Al=Union_make_material() SETTING parameters. */
char* process_string = mccAl_process_string;
MCNUM my_absorption = mccAl_my_absorption;
MCNUM absorber = mccAl_absorber;
}   /* End of Al=Union_make_material() SETTING parameter declarations. */
#undef global_material_element
#undef accepted_processes
#undef this_material
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex
  /* Label for restoring  neutron */
  mcabsorbCompAl:
  if (RESTORE) /* restore if needed */
  { RESTORE_NEUTRON(3,
      mcnlx,
      mcnly,
      mcnlz,
      mcnlvx,
      mcnlvy,
      mcnlvz,
      mcnlt,
      mcnlsx,
      mcnlsy,
      mcnlsz,
      mcnlp); }
#undef mcabsorbComp
#undef p
#undef sz
#undef sy
#undef sx
#undef t
#undef vz
#undef vy
#undef vx
#undef z
#undef y
#undef x
  mcDEBUG_STATE(
mcnlx,
mcnly,
mcnlz,
mcnlvx,
mcnlvy,
mcnlvz,
mcnlt,
mcnlsx,
mcnlsy,
mcnlsz,
mcnlp)

  /* TRACE Component TiO2_incoherent [4] */
  mccoordschange(mcposrTiO2_incoherent, mcrotrTiO2_incoherent,
    &mcnlx,
    &mcnly,
    &mcnlz,
    &mcnlvx,
    &mcnlvy,
    &mcnlvz,
    &mcnlsx,
    &mcnlsy,
    &mcnlsz);
  /* define label inside component TiO2_incoherent (without coords transformations) */
  mcJumpTrace_TiO2_incoherent:
  SIG_MESSAGE("TiO2_incoherent (Trace)");
  mcDEBUG_COMP("TiO2_incoherent")
  mcDEBUG_STATE(
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp)
#define x mcnlx
#define y mcnly
#define z mcnlz
#define vx mcnlvx
#define vy mcnlvy
#define vz mcnlvz
#define t mcnlt
#define sx mcnlsx
#define sy mcnlsy
#define sz mcnlsz
#define p mcnlp

#define mcabsorbComp mcabsorbCompTiO2_incoherent
  STORE_NEUTRON(4,
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp);
  mcScattered=0;
  mcRestore=0;
  mcNCounter[4]++;
  mcPCounter[4] += p;
  mcP2Counter[4] += p*p;
#define mccompcurname  TiO2_incoherent
#define mccompcurtype  Incoherent_process
#define mccompcurindex 4
#define This_process mccTiO2_incoherent_This_process
#define Incoherent_storage mccTiO2_incoherent_Incoherent_storage
#define effective_my_scattering mccTiO2_incoherent_effective_my_scattering
{   /* Declarations of TiO2_incoherent=Incoherent_process() SETTING parameters. */
MCNUM sigma = mccTiO2_incoherent_sigma;
MCNUM f_QE = mccTiO2_incoherent_f_QE;
MCNUM gamma = mccTiO2_incoherent_gamma;
MCNUM packing_factor = mccTiO2_incoherent_packing_factor;
MCNUM unit_cell_volume = mccTiO2_incoherent_unit_cell_volume;
MCNUM interact_fraction = mccTiO2_incoherent_interact_fraction;
}   /* End of TiO2_incoherent=Incoherent_process() SETTING parameter declarations. */
#undef effective_my_scattering
#undef Incoherent_storage
#undef This_process
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex
  /* Label for restoring  neutron */
  mcabsorbCompTiO2_incoherent:
  if (RESTORE) /* restore if needed */
  { RESTORE_NEUTRON(4,
      mcnlx,
      mcnly,
      mcnlz,
      mcnlvx,
      mcnlvy,
      mcnlvz,
      mcnlt,
      mcnlsx,
      mcnlsy,
      mcnlsz,
      mcnlp); }
#undef mcabsorbComp
#undef p
#undef sz
#undef sy
#undef sx
#undef t
#undef vz
#undef vy
#undef vx
#undef z
#undef y
#undef x
  mcDEBUG_STATE(
mcnlx,
mcnly,
mcnlz,
mcnlvx,
mcnlvy,
mcnlvz,
mcnlt,
mcnlsx,
mcnlsy,
mcnlsz,
mcnlp)

  /* TRACE Component TiO2_single_crystal [5] */
  mccoordschange(mcposrTiO2_single_crystal, mcrotrTiO2_single_crystal,
    &mcnlx,
    &mcnly,
    &mcnlz,
    &mcnlvx,
    &mcnlvy,
    &mcnlvz,
    &mcnlsx,
    &mcnlsy,
    &mcnlsz);
  /* define label inside component TiO2_single_crystal (without coords transformations) */
  mcJumpTrace_TiO2_single_crystal:
  SIG_MESSAGE("TiO2_single_crystal (Trace)");
  mcDEBUG_COMP("TiO2_single_crystal")
  mcDEBUG_STATE(
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp)
#define x mcnlx
#define y mcnly
#define z mcnlz
#define vx mcnlvx
#define vy mcnlvy
#define vz mcnlvz
#define t mcnlt
#define sx mcnlsx
#define sy mcnlsy
#define sz mcnlsz
#define p mcnlp

#define mcabsorbComp mcabsorbCompTiO2_single_crystal
  STORE_NEUTRON(5,
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp);
  mcScattered=0;
  mcRestore=0;
  mcNCounter[5]++;
  mcPCounter[5] += p;
  mcP2Counter[5] += p*p;
#define mccompcurname  TiO2_single_crystal
#define mccompcurtype  Single_crystal_process
#define mccompcurindex 5
#define mosaic_AB mccTiO2_single_crystal_mosaic_AB
#define This_process mccTiO2_single_crystal_This_process
#define Single_crystal_storage mccTiO2_single_crystal_Single_crystal_storage
#define effective_my_scattering mccTiO2_single_crystal_effective_my_scattering
#define hkl_info_union mccTiO2_single_crystal_hkl_info_union
#define packing_factor mccTiO2_single_crystal_packing_factor
{   /* Declarations of TiO2_single_crystal=Single_crystal_process() SETTING parameters. */
char* reflections = mccTiO2_single_crystal_reflections;
MCNUM delta_d_d = mccTiO2_single_crystal_delta_d_d;
MCNUM mosaic = mccTiO2_single_crystal_mosaic;
MCNUM mosaic_a = mccTiO2_single_crystal_mosaic_a;
MCNUM mosaic_b = mccTiO2_single_crystal_mosaic_b;
MCNUM mosaic_c = mccTiO2_single_crystal_mosaic_c;
MCNUM recip_cell = mccTiO2_single_crystal_recip_cell;
MCNUM barns = mccTiO2_single_crystal_barns;
MCNUM ax = mccTiO2_single_crystal_ax;
MCNUM ay = mccTiO2_single_crystal_ay;
MCNUM az = mccTiO2_single_crystal_az;
MCNUM bx = mccTiO2_single_crystal_bx;
MCNUM by = mccTiO2_single_crystal_by;
MCNUM bz = mccTiO2_single_crystal_bz;
MCNUM cx = mccTiO2_single_crystal_cx;
MCNUM cy = mccTiO2_single_crystal_cy;
MCNUM cz = mccTiO2_single_crystal_cz;
MCNUM aa = mccTiO2_single_crystal_aa;
MCNUM bb = mccTiO2_single_crystal_bb;
MCNUM cc = mccTiO2_single_crystal_cc;
MCNUM order = mccTiO2_single_crystal_order;
MCNUM RX = mccTiO2_single_crystal_RX;
MCNUM RY = mccTiO2_single_crystal_RY;
MCNUM RZ = mccTiO2_single_crystal_RZ;
MCNUM powder = mccTiO2_single_crystal_powder;
MCNUM PG = mccTiO2_single_crystal_PG;
MCNUM interact_fraction = mccTiO2_single_crystal_interact_fraction;
MCNUM packing_factor = mccTiO2_single_crystal_packing_factor;
#line 1069 "Single_crystal_process.comp"
{
    // Trace should be empty, the simulation is done in Union_master
}
#line 345770 "MACS_sample_kidney_box.c"
}   /* End of TiO2_single_crystal=Single_crystal_process() SETTING parameter declarations. */
#undef packing_factor
#undef hkl_info_union
#undef effective_my_scattering
#undef Single_crystal_storage
#undef This_process
#undef mosaic_AB
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex
  /* Label for restoring  neutron */
  mcabsorbCompTiO2_single_crystal:
  if (RESTORE) /* restore if needed */
  { RESTORE_NEUTRON(5,
      mcnlx,
      mcnly,
      mcnlz,
      mcnlvx,
      mcnlvy,
      mcnlvz,
      mcnlt,
      mcnlsx,
      mcnlsy,
      mcnlsz,
      mcnlp); }
#undef mcabsorbComp
#undef p
#undef sz
#undef sy
#undef sx
#undef t
#undef vz
#undef vy
#undef vx
#undef z
#undef y
#undef x
  mcDEBUG_STATE(
mcnlx,
mcnly,
mcnlz,
mcnlvx,
mcnlvy,
mcnlvz,
mcnlt,
mcnlsx,
mcnlsy,
mcnlsz,
mcnlp)

  /* TRACE Component TiO2 [6] */
  mccoordschange(mcposrTiO2, mcrotrTiO2,
    &mcnlx,
    &mcnly,
    &mcnlz,
    &mcnlvx,
    &mcnlvy,
    &mcnlvz,
    &mcnlsx,
    &mcnlsy,
    &mcnlsz);
  /* define label inside component TiO2 (without coords transformations) */
  mcJumpTrace_TiO2:
  SIG_MESSAGE("TiO2 (Trace)");
  mcDEBUG_COMP("TiO2")
  mcDEBUG_STATE(
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp)
#define x mcnlx
#define y mcnly
#define z mcnlz
#define vx mcnlvx
#define vy mcnlvy
#define vz mcnlvz
#define t mcnlt
#define sx mcnlsx
#define sy mcnlsy
#define sz mcnlsz
#define p mcnlp

#define mcabsorbComp mcabsorbCompTiO2
  STORE_NEUTRON(6,
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp);
  mcScattered=0;
  mcRestore=0;
  mcNCounter[6]++;
  mcPCounter[6] += p;
  mcP2Counter[6] += p*p;
#define mccompcurname  TiO2
#define mccompcurtype  Union_make_material
#define mccompcurindex 6
#define loop_index mccTiO2_loop_index
#define this_material mccTiO2_this_material
#define accepted_processes mccTiO2_accepted_processes
#define global_material_element mccTiO2_global_material_element
{   /* Declarations of TiO2=Union_make_material() SETTING parameters. */
char* process_string = mccTiO2_process_string;
MCNUM my_absorption = mccTiO2_my_absorption;
MCNUM absorber = mccTiO2_absorber;
}   /* End of TiO2=Union_make_material() SETTING parameter declarations. */
#undef global_material_element
#undef accepted_processes
#undef this_material
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex
  /* Label for restoring  neutron */
  mcabsorbCompTiO2:
  if (RESTORE) /* restore if needed */
  { RESTORE_NEUTRON(6,
      mcnlx,
      mcnly,
      mcnlz,
      mcnlvx,
      mcnlvy,
      mcnlvz,
      mcnlt,
      mcnlsx,
      mcnlsy,
      mcnlsz,
      mcnlp); }
#undef mcabsorbComp
#undef p
#undef sz
#undef sy
#undef sx
#undef t
#undef vz
#undef vy
#undef vx
#undef z
#undef y
#undef x
  mcDEBUG_STATE(
mcnlx,
mcnly,
mcnlz,
mcnlvx,
mcnlvy,
mcnlvz,
mcnlt,
mcnlsx,
mcnlsy,
mcnlsz,
mcnlp)

  /* TRACE Component TiO2_poly_incoherent [7] */
  mccoordschange(mcposrTiO2_poly_incoherent, mcrotrTiO2_poly_incoherent,
    &mcnlx,
    &mcnly,
    &mcnlz,
    &mcnlvx,
    &mcnlvy,
    &mcnlvz,
    &mcnlsx,
    &mcnlsy,
    &mcnlsz);
  /* define label inside component TiO2_poly_incoherent (without coords transformations) */
  mcJumpTrace_TiO2_poly_incoherent:
  SIG_MESSAGE("TiO2_poly_incoherent (Trace)");
  mcDEBUG_COMP("TiO2_poly_incoherent")
  mcDEBUG_STATE(
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp)
#define x mcnlx
#define y mcnly
#define z mcnlz
#define vx mcnlvx
#define vy mcnlvy
#define vz mcnlvz
#define t mcnlt
#define sx mcnlsx
#define sy mcnlsy
#define sz mcnlsz
#define p mcnlp

#define mcabsorbComp mcabsorbCompTiO2_poly_incoherent
  STORE_NEUTRON(7,
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp);
  mcScattered=0;
  mcRestore=0;
  mcNCounter[7]++;
  mcPCounter[7] += p;
  mcP2Counter[7] += p*p;
#define mccompcurname  TiO2_poly_incoherent
#define mccompcurtype  Incoherent_process
#define mccompcurindex 7
#define This_process mccTiO2_poly_incoherent_This_process
#define Incoherent_storage mccTiO2_poly_incoherent_Incoherent_storage
#define effective_my_scattering mccTiO2_poly_incoherent_effective_my_scattering
{   /* Declarations of TiO2_poly_incoherent=Incoherent_process() SETTING parameters. */
MCNUM sigma = mccTiO2_poly_incoherent_sigma;
MCNUM f_QE = mccTiO2_poly_incoherent_f_QE;
MCNUM gamma = mccTiO2_poly_incoherent_gamma;
MCNUM packing_factor = mccTiO2_poly_incoherent_packing_factor;
MCNUM unit_cell_volume = mccTiO2_poly_incoherent_unit_cell_volume;
MCNUM interact_fraction = mccTiO2_poly_incoherent_interact_fraction;
}   /* End of TiO2_poly_incoherent=Incoherent_process() SETTING parameter declarations. */
#undef effective_my_scattering
#undef Incoherent_storage
#undef This_process
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex
  /* Label for restoring  neutron */
  mcabsorbCompTiO2_poly_incoherent:
  if (RESTORE) /* restore if needed */
  { RESTORE_NEUTRON(7,
      mcnlx,
      mcnly,
      mcnlz,
      mcnlvx,
      mcnlvy,
      mcnlvz,
      mcnlt,
      mcnlsx,
      mcnlsy,
      mcnlsz,
      mcnlp); }
#undef mcabsorbComp
#undef p
#undef sz
#undef sy
#undef sx
#undef t
#undef vz
#undef vy
#undef vx
#undef z
#undef y
#undef x
  mcDEBUG_STATE(
mcnlx,
mcnly,
mcnlz,
mcnlvx,
mcnlvy,
mcnlvz,
mcnlt,
mcnlsx,
mcnlsy,
mcnlsz,
mcnlp)

  /* TRACE Component TiO2_poly [8] */
  mccoordschange(mcposrTiO2_poly, mcrotrTiO2_poly,
    &mcnlx,
    &mcnly,
    &mcnlz,
    &mcnlvx,
    &mcnlvy,
    &mcnlvz,
    &mcnlsx,
    &mcnlsy,
    &mcnlsz);
  /* define label inside component TiO2_poly (without coords transformations) */
  mcJumpTrace_TiO2_poly:
  SIG_MESSAGE("TiO2_poly (Trace)");
  mcDEBUG_COMP("TiO2_poly")
  mcDEBUG_STATE(
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp)
#define x mcnlx
#define y mcnly
#define z mcnlz
#define vx mcnlvx
#define vy mcnlvy
#define vz mcnlvz
#define t mcnlt
#define sx mcnlsx
#define sy mcnlsy
#define sz mcnlsz
#define p mcnlp

#define mcabsorbComp mcabsorbCompTiO2_poly
  STORE_NEUTRON(8,
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp);
  mcScattered=0;
  mcRestore=0;
  mcNCounter[8]++;
  mcPCounter[8] += p;
  mcP2Counter[8] += p*p;
#define mccompcurname  TiO2_poly
#define mccompcurtype  Union_make_material
#define mccompcurindex 8
#define loop_index mccTiO2_poly_loop_index
#define this_material mccTiO2_poly_this_material
#define accepted_processes mccTiO2_poly_accepted_processes
#define global_material_element mccTiO2_poly_global_material_element
{   /* Declarations of TiO2_poly=Union_make_material() SETTING parameters. */
char* process_string = mccTiO2_poly_process_string;
MCNUM my_absorption = mccTiO2_poly_my_absorption;
MCNUM absorber = mccTiO2_poly_absorber;
}   /* End of TiO2_poly=Union_make_material() SETTING parameter declarations. */
#undef global_material_element
#undef accepted_processes
#undef this_material
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex
  /* Label for restoring  neutron */
  mcabsorbCompTiO2_poly:
  if (RESTORE) /* restore if needed */
  { RESTORE_NEUTRON(8,
      mcnlx,
      mcnly,
      mcnlz,
      mcnlvx,
      mcnlvy,
      mcnlvz,
      mcnlt,
      mcnlsx,
      mcnlsy,
      mcnlsz,
      mcnlp); }
#undef mcabsorbComp
#undef p
#undef sz
#undef sy
#undef sx
#undef t
#undef vz
#undef vy
#undef vx
#undef z
#undef y
#undef x
  mcDEBUG_STATE(
mcnlx,
mcnly,
mcnlz,
mcnlvx,
mcnlvy,
mcnlvz,
mcnlt,
mcnlsx,
mcnlsy,
mcnlsz,
mcnlp)

  /* TRACE Component Al_incoherent_B [9] */
  mccoordschange(mcposrAl_incoherent_B, mcrotrAl_incoherent_B,
    &mcnlx,
    &mcnly,
    &mcnlz,
    &mcnlvx,
    &mcnlvy,
    &mcnlvz,
    &mcnlsx,
    &mcnlsy,
    &mcnlsz);
  /* define label inside component Al_incoherent_B (without coords transformations) */
  mcJumpTrace_Al_incoherent_B:
  SIG_MESSAGE("Al_incoherent_B (Trace)");
  mcDEBUG_COMP("Al_incoherent_B")
  mcDEBUG_STATE(
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp)
#define x mcnlx
#define y mcnly
#define z mcnlz
#define vx mcnlvx
#define vy mcnlvy
#define vz mcnlvz
#define t mcnlt
#define sx mcnlsx
#define sy mcnlsy
#define sz mcnlsz
#define p mcnlp

#define mcabsorbComp mcabsorbCompAl_incoherent_B
  STORE_NEUTRON(9,
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp);
  mcScattered=0;
  mcRestore=0;
  mcNCounter[9]++;
  mcPCounter[9] += p;
  mcP2Counter[9] += p*p;
#define mccompcurname  Al_incoherent_B
#define mccompcurtype  Incoherent_process
#define mccompcurindex 9
#define This_process mccAl_incoherent_B_This_process
#define Incoherent_storage mccAl_incoherent_B_Incoherent_storage
#define effective_my_scattering mccAl_incoherent_B_effective_my_scattering
{   /* Declarations of Al_incoherent_B=Incoherent_process() SETTING parameters. */
MCNUM sigma = mccAl_incoherent_B_sigma;
MCNUM f_QE = mccAl_incoherent_B_f_QE;
MCNUM gamma = mccAl_incoherent_B_gamma;
MCNUM packing_factor = mccAl_incoherent_B_packing_factor;
MCNUM unit_cell_volume = mccAl_incoherent_B_unit_cell_volume;
MCNUM interact_fraction = mccAl_incoherent_B_interact_fraction;
}   /* End of Al_incoherent_B=Incoherent_process() SETTING parameter declarations. */
#undef effective_my_scattering
#undef Incoherent_storage
#undef This_process
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex
  /* Label for restoring  neutron */
  mcabsorbCompAl_incoherent_B:
  if (RESTORE) /* restore if needed */
  { RESTORE_NEUTRON(9,
      mcnlx,
      mcnly,
      mcnlz,
      mcnlvx,
      mcnlvy,
      mcnlvz,
      mcnlt,
      mcnlsx,
      mcnlsy,
      mcnlsz,
      mcnlp); }
#undef mcabsorbComp
#undef p
#undef sz
#undef sy
#undef sx
#undef t
#undef vz
#undef vy
#undef vx
#undef z
#undef y
#undef x
  mcDEBUG_STATE(
mcnlx,
mcnly,
mcnlz,
mcnlvx,
mcnlvy,
mcnlvz,
mcnlt,
mcnlsx,
mcnlsy,
mcnlsz,
mcnlp)

  /* TRACE Component Al_powder_B [10] */
  mccoordschange(mcposrAl_powder_B, mcrotrAl_powder_B,
    &mcnlx,
    &mcnly,
    &mcnlz,
    &mcnlvx,
    &mcnlvy,
    &mcnlvz,
    &mcnlsx,
    &mcnlsy,
    &mcnlsz);
  /* define label inside component Al_powder_B (without coords transformations) */
  mcJumpTrace_Al_powder_B:
  SIG_MESSAGE("Al_powder_B (Trace)");
  mcDEBUG_COMP("Al_powder_B")
  mcDEBUG_STATE(
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp)
#define x mcnlx
#define y mcnly
#define z mcnlz
#define vx mcnlvx
#define vy mcnlvy
#define vz mcnlvz
#define t mcnlt
#define sx mcnlsx
#define sy mcnlsy
#define sz mcnlsz
#define p mcnlp

#define mcabsorbComp mcabsorbCompAl_powder_B
  STORE_NEUTRON(10,
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp);
  mcScattered=0;
  mcRestore=0;
  mcNCounter[10]++;
  mcPCounter[10] += p;
  mcP2Counter[10] += p*p;
#define mccompcurname  Al_powder_B
#define mccompcurtype  Powder_process
#define mccompcurindex 10
#define format mccAl_powder_B_format
#define This_process mccAl_powder_B_This_process
#define Powder_storage mccAl_powder_B_Powder_storage
#define effective_my_scattering mccAl_powder_B_effective_my_scattering
#define d_phi mccAl_powder_B_d_phi
#define line_info mccAl_powder_B_line_info
#define columns mccAl_powder_B_columns
{   /* Declarations of Al_powder_B=Powder_process() SETTING parameters. */
char* reflections = mccAl_powder_B_reflections;
MCNUM packing_factor = mccAl_powder_B_packing_factor;
MCNUM Vc = mccAl_powder_B_Vc;
MCNUM delta_d_d = mccAl_powder_B_delta_d_d;
MCNUM DW = mccAl_powder_B_DW;
MCNUM nb_atoms = mccAl_powder_B_nb_atoms;
MCNUM d_phi = mccAl_powder_B_d_phi;
MCNUM density = mccAl_powder_B_density;
MCNUM weight = mccAl_powder_B_weight;
MCNUM barns = mccAl_powder_B_barns;
MCNUM Strain = mccAl_powder_B_Strain;
MCNUM interact_fraction = mccAl_powder_B_interact_fraction;
}   /* End of Al_powder_B=Powder_process() SETTING parameter declarations. */
#undef columns
#undef line_info
#undef d_phi
#undef effective_my_scattering
#undef Powder_storage
#undef This_process
#undef format
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex
  /* Label for restoring  neutron */
  mcabsorbCompAl_powder_B:
  if (RESTORE) /* restore if needed */
  { RESTORE_NEUTRON(10,
      mcnlx,
      mcnly,
      mcnlz,
      mcnlvx,
      mcnlvy,
      mcnlvz,
      mcnlt,
      mcnlsx,
      mcnlsy,
      mcnlsz,
      mcnlp); }
#undef mcabsorbComp
#undef p
#undef sz
#undef sy
#undef sx
#undef t
#undef vz
#undef vy
#undef vx
#undef z
#undef y
#undef x
  mcDEBUG_STATE(
mcnlx,
mcnly,
mcnlz,
mcnlvx,
mcnlvy,
mcnlvz,
mcnlt,
mcnlsx,
mcnlsy,
mcnlsz,
mcnlp)

  /* TRACE Component Al_B [11] */
  mccoordschange(mcposrAl_B, mcrotrAl_B,
    &mcnlx,
    &mcnly,
    &mcnlz,
    &mcnlvx,
    &mcnlvy,
    &mcnlvz,
    &mcnlsx,
    &mcnlsy,
    &mcnlsz);
  /* define label inside component Al_B (without coords transformations) */
  mcJumpTrace_Al_B:
  SIG_MESSAGE("Al_B (Trace)");
  mcDEBUG_COMP("Al_B")
  mcDEBUG_STATE(
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp)
#define x mcnlx
#define y mcnly
#define z mcnlz
#define vx mcnlvx
#define vy mcnlvy
#define vz mcnlvz
#define t mcnlt
#define sx mcnlsx
#define sy mcnlsy
#define sz mcnlsz
#define p mcnlp

#define mcabsorbComp mcabsorbCompAl_B
  STORE_NEUTRON(11,
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp);
  mcScattered=0;
  mcRestore=0;
  mcNCounter[11]++;
  mcPCounter[11] += p;
  mcP2Counter[11] += p*p;
#define mccompcurname  Al_B
#define mccompcurtype  Union_make_material
#define mccompcurindex 11
#define loop_index mccAl_B_loop_index
#define this_material mccAl_B_this_material
#define accepted_processes mccAl_B_accepted_processes
#define global_material_element mccAl_B_global_material_element
{   /* Declarations of Al_B=Union_make_material() SETTING parameters. */
char* process_string = mccAl_B_process_string;
MCNUM my_absorption = mccAl_B_my_absorption;
MCNUM absorber = mccAl_B_absorber;
}   /* End of Al_B=Union_make_material() SETTING parameter declarations. */
#undef global_material_element
#undef accepted_processes
#undef this_material
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex
  /* Label for restoring  neutron */
  mcabsorbCompAl_B:
  if (RESTORE) /* restore if needed */
  { RESTORE_NEUTRON(11,
      mcnlx,
      mcnly,
      mcnlz,
      mcnlvx,
      mcnlvy,
      mcnlvz,
      mcnlt,
      mcnlsx,
      mcnlsy,
      mcnlsz,
      mcnlp); }
#undef mcabsorbComp
#undef p
#undef sz
#undef sy
#undef sx
#undef t
#undef vz
#undef vy
#undef vx
#undef z
#undef y
#undef x
  mcDEBUG_STATE(
mcnlx,
mcnly,
mcnlz,
mcnlvx,
mcnlvy,
mcnlvz,
mcnlt,
mcnlsx,
mcnlsy,
mcnlsz,
mcnlp)

  /* TRACE Component Arm0 [12] */
  mccoordschange(mcposrArm0, mcrotrArm0,
    &mcnlx,
    &mcnly,
    &mcnlz,
    &mcnlvx,
    &mcnlvy,
    &mcnlvz,
    &mcnlsx,
    &mcnlsy,
    &mcnlsz);
  /* define label inside component Arm0 (without coords transformations) */
  mcJumpTrace_Arm0:
  SIG_MESSAGE("Arm0 (Trace)");
  mcDEBUG_COMP("Arm0")
  mcDEBUG_STATE(
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp)
#define x mcnlx
#define y mcnly
#define z mcnlz
#define vx mcnlvx
#define vy mcnlvy
#define vz mcnlvz
#define t mcnlt
#define sx mcnlsx
#define sy mcnlsy
#define sz mcnlsz
#define p mcnlp

#define mcabsorbComp mcabsorbCompArm0
  STORE_NEUTRON(12,
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp);
  mcScattered=0;
  mcRestore=0;
  mcNCounter[12]++;
  mcPCounter[12] += p;
  mcP2Counter[12] += p*p;
#define mccompcurname  Arm0
#define mccompcurtype  Progress_bar
#define mccompcurindex 12
#define IntermediateCnts mccArm0_IntermediateCnts
#define StartTime mccArm0_StartTime
#define EndTime mccArm0_EndTime
#define CurrentTime mccArm0_CurrentTime
{   /* Declarations of Arm0=Progress_bar() SETTING parameters. */
char* profile = mccArm0_profile;
MCNUM percent = mccArm0_percent;
MCNUM flag_save = mccArm0_flag_save;
MCNUM minutes = mccArm0_minutes;
#line 70 "/usr/share/mcstas/2.7/misc/Progress_bar.comp"
{
  double ncount;
  ncount = mcget_run_num();
  if (!StartTime) {
    time(&StartTime); /* compute starting time */
    IntermediateCnts = 1e3;
  }
  time_t NowTime;
  time(&NowTime);
  /* compute initial estimate of computation duration */
  if (!EndTime && ncount >= IntermediateCnts) {
    CurrentTime = NowTime;
    if (difftime(NowTime,StartTime) > 10 && ncount) { /* wait 10 sec before writing ETA */
      EndTime = StartTime + (time_t)(difftime(NowTime,StartTime)
				     *(double)mcget_ncount()/ncount);
      IntermediateCnts = 0;
      fprintf(stdout, "\nTrace ETA ");
      if (difftime(EndTime,StartTime) < 60.0)
        fprintf(stdout, "%g [s] %% ", difftime(EndTime,StartTime));
      else if (difftime(EndTime,StartTime) > 3600.0)
        fprintf(stdout, "%g [h] %% ", difftime(EndTime,StartTime)/3600.0);
      else
        fprintf(stdout, "%g [min] %% ", difftime(EndTime,StartTime)/60.0);
    } else IntermediateCnts += 1e3;
    fflush(stdout);
  }

  /* display percentage when percent or minutes have reached step */
  if (EndTime && mcget_ncount() &&
    (    (minutes && difftime(NowTime,CurrentTime) > minutes*60)
      || (percent && !minutes && ncount >= IntermediateCnts))   )
  {
    fprintf(stdout, "%d ", (int)(ncount*100.0/mcget_ncount())); fflush(stdout);
    CurrentTime = NowTime;

    IntermediateCnts = ncount + percent*mcget_ncount()/100;
    /* check that next intermediate ncount check is a multiple of the desired percentage */
    IntermediateCnts = floor(IntermediateCnts*100/percent/mcget_ncount())*percent*mcget_ncount()/100;
    /* raise flag to indicate that we did something */
    SCATTER;
    if (flag_save) mcsave(NULL);
  }
}
#line 346647 "MACS_sample_kidney_box.c"
}   /* End of Arm0=Progress_bar() SETTING parameter declarations. */
#undef CurrentTime
#undef EndTime
#undef StartTime
#undef IntermediateCnts
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex
  /* Label for restoring  neutron */
  mcabsorbCompArm0:
  if (RESTORE) /* restore if needed */
  { RESTORE_NEUTRON(12,
      mcnlx,
      mcnly,
      mcnlz,
      mcnlvx,
      mcnlvy,
      mcnlvz,
      mcnlt,
      mcnlsx,
      mcnlsy,
      mcnlsz,
      mcnlp); }
#undef mcabsorbComp
#undef p
#undef sz
#undef sy
#undef sx
#undef t
#undef vz
#undef vy
#undef vx
#undef z
#undef y
#undef x
  mcDEBUG_STATE(
mcnlx,
mcnly,
mcnlz,
mcnlvx,
mcnlvy,
mcnlvz,
mcnlt,
mcnlsx,
mcnlsy,
mcnlsz,
mcnlp)

  /* TRACE Component Guide_end [13] */
  mccoordschange(mcposrGuide_end, mcrotrGuide_end,
    &mcnlx,
    &mcnly,
    &mcnlz,
    &mcnlvx,
    &mcnlvy,
    &mcnlvz,
    &mcnlsx,
    &mcnlsy,
    &mcnlsz);
  /* define label inside component Guide_end (without coords transformations) */
  mcJumpTrace_Guide_end:
  SIG_MESSAGE("Guide_end (Trace)");
  mcDEBUG_COMP("Guide_end")
  mcDEBUG_STATE(
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp)
#define x mcnlx
#define y mcnly
#define z mcnlz
#define vx mcnlvx
#define vy mcnlvy
#define vz mcnlvz
#define t mcnlt
#define sx mcnlsx
#define sy mcnlsy
#define sz mcnlsz
#define p mcnlp

#define mcabsorbComp mcabsorbCompGuide_end
  STORE_NEUTRON(13,
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp);
  mcScattered=0;
  mcRestore=0;
  mcNCounter[13]++;
  mcPCounter[13] += p;
  mcP2Counter[13] += p*p;
#define mccompcurname  Guide_end
#define mccompcurtype  Virtual_input
#define mccompcurindex 13
#define read_block mccGuide_end_read_block
#define pos mccGuide_end_pos
#define nrows mccGuide_end_nrows
#define Offset mccGuide_end_Offset
#define rTable mccGuide_end_rTable
#define repeat_number mccGuide_end_repeat_number
#define filename_ncount mccGuide_end_filename_ncount
#define mean_vx mccGuide_end_mean_vx
#define mean_vy mccGuide_end_mean_vy
#define mean_vz mccGuide_end_mean_vz
#define mean_dx mccGuide_end_mean_dx
#define mean_dy mccGuide_end_mean_dy
#define mean_dz mccGuide_end_mean_dz
#define n_neutrons mccGuide_end_n_neutrons
#define min_x mccGuide_end_min_x
#define min_y mccGuide_end_min_y
#define min_z mccGuide_end_min_z
#define max_x mccGuide_end_max_x
#define max_y mccGuide_end_max_y
#define max_z mccGuide_end_max_z
#define min_vx mccGuide_end_min_vx
#define min_vy mccGuide_end_min_vy
#define min_vz mccGuide_end_min_vz
#define max_vx mccGuide_end_max_vx
#define max_vy mccGuide_end_max_vy
#define max_vz mccGuide_end_max_vz
#define first_block mccGuide_end_first_block
#define mean_x mccGuide_end_mean_x
#define mean_y mccGuide_end_mean_y
#define mean_z mccGuide_end_mean_z
#define end_reading mccGuide_end_end_reading
#define n_count_extrapolated mccGuide_end_n_count_extrapolated
#define repeat_cnt mccGuide_end_repeat_cnt
{   /* Declarations of Guide_end=Virtual_input() SETTING parameters. */
char* filename = mccGuide_end_filename;
MCNUM verbose = mccGuide_end_verbose;
MCNUM repeat_count = mccGuide_end_repeat_count;
MCNUM smooth = mccGuide_end_smooth;
MCNUM display = mccGuide_end_display;
#line 202 "/usr/share/mcstas/2.7/obsolete/Virtual_input.comp"
{
  if (filename && strlen(filename) && strcmp(filename, "NULL") && strcmp(filename,"0")) {
    while (read_block && !end_reading) {
      /* read block and increase Offset for next reading */
      nrows = Virtual_input_Read_Input(filename, type, &rTable, &Offset);

      if (!nrows) { /* nrows is 0 if end of filename/no filename */
        if (!filename_ncount) {
          filename_ncount = (double)mcget_run_num();  /* ncount in filename */
          if (verbose)
            printf("Virtual_input: %s: filename '%s' contains %g events\n", NAME_CURRENT_COMP, filename, filename_ncount);
          /* set ncount from filename length */
          mcset_ncount(filename_ncount*repeat_cnt);
        }
        Offset = 0;       /* reposition to begining of filename */
        repeat_number++;  /* we start a new repeat_cnt loop */

        /* end of simulation if ... */
        if (repeat_number > repeat_cnt) {
          if (verbose)
            printf("Virtual_input: %s: Ending after %g events (%li repeat count)\n", NAME_CURRENT_COMP, (double)mcget_run_num(), (long)repeat_cnt);
          read_block=0; mcset_ncount(mcget_run_num()); pos=0;
          end_reading = 1;
        }
        /* else continue reading blocks */

      } else { /* block at Offset could be read */
        pos = 0;  /* position at begining of new block */
        read_block = 0;
      }
    }

      /* &p, &x, &y, &z, &vx, &vy, &vz, &t, &sx, &sy, &sz */
    if (!end_reading) {
      /* BEWARE! This is a non-standard way of using mcrestore_neutron, order of parameters
	 MUST be  &p, &x, &y, &z, &vx, &vy, &vz, &t, &sx, &sy,  &sz
         to match the data format from the Virtual_input files */
      mcrestore_neutron(rTable.data,pos, &p, &x, &y, &z, &vx, &vy, &vz, &t, &sx, &sy,  &sz);

      if (first_block) {
        double v;
        mean_x  += p*x;  mean_y  += p*y;  mean_z  += p*z;
        mean_vx += p*vx; mean_vy += p*vy; mean_vz += p*vz;
        v = sqrt(vx*vx+vy*vy+vz*vz);
        if (v)
          { mean_dx += p*fabs(vx/v); mean_dy += p*fabs(vy/v); mean_dz += p*fabs(vz/v); }
        if (x  < min_x)  min_x  = x;
        if (y  < min_y)  min_y  = y;
        if (z  < min_z)  min_z  = z;
        if (vx < min_vx) min_vx = vx;
        if (vy < min_vy) min_vy = vy;
        if (vz < min_vz) min_vz = z;
        if (x  > max_x)  max_x  = x;
        if (y  > max_y)  max_y  = y;
        if (z  > max_z)  max_z  = z;
        if (vx > max_vx) max_vx = vx;
        if (vy > max_vy) max_vy = vy;
        if (vz > max_vz) max_vz = z;
        n_neutrons += p;
      }

      pos++;
      p /= repeat_cnt;
#ifdef USE_MPI
      /* We always repeat by the number of nodes in an MPI run */
      p /= mpi_node_count;
#endif

      SCATTER;

      if (pos >= nrows) { /* reached end of block */
        read_block = 1;
        if (first_block) {
          double mean_v;
          /* display statitics for 1st block */
          mean_x  /= n_neutrons;
          mean_y  /= n_neutrons;
          mean_z  /= n_neutrons;
          mean_vx /= n_neutrons;
          mean_vy /= n_neutrons;
          mean_vz /= n_neutrons;
          mean_dx /= n_neutrons;
          mean_dy /= n_neutrons;
          mean_dz /= n_neutrons;
          /* now estimates total ncount */
          mean_v = sqrt(mean_vx*mean_vx+mean_vy*mean_vy+mean_vz*mean_vz);
          n_count_extrapolated = (double)nrows*rTable.filesize/Offset;
          if (verbose) {
            double mean_k, mean_w=0, mean_L=0;

            mean_k = V2K*mean_v;
            if (mean_k) mean_L = 2*PI/mean_k;
            mean_w = VS2E*mean_v*mean_v;
            printf("McStas Virtual Source filename %s\nContains about %g events, intensity=%g\n", filename, n_count_extrapolated, n_neutrons*rTable.filesize/Offset);

            printf("  Source size (full width in [m]):      ");
            printf("    dX=%g dY=%g dZ=%g\n", max_x-min_x, max_y-min_y, max_z-min_z);
            printf("  Source center (in [m]):               ");
            printf("    X0=%g Y0=%g Z0=%g\n", mean_x, mean_y, mean_z);
            printf("  Beam divergence (full width in [deg]):");
            printf("    dVx=%g dVy=%g dVz=%g\n",
              atan(mean_dx)*RAD2DEG,
              atan(mean_dy)*RAD2DEG,
              atan(mean_dz)*RAD2DEG);
            printf("  Beam speed (in [m/s]):                ");
            printf("    Vx=%g Vy=%g Vz=%g\n", mean_vx, mean_vy, mean_vz);
            printf("  Beam mean energy:\n");
            printf("    speed=%g [m/s] energy=%g [meV]\n    wavelength=%g [Angs] wavevector=%g [Angs-1]\n", mean_v, mean_w, mean_L, mean_k);
          }
          /* set ncount from estimate with security margin 10 % */
          mcset_ncount(n_count_extrapolated*repeat_cnt*1.1);
        }
        first_block= 0;
      }
  #if defined (USE_MPI)
      if (smooth && n_count_extrapolated)
  #else
      if (smooth && repeat_number>1 && n_count_extrapolated)
  #endif
      {
        /* apply smmothing */
        x += randnorm()*(max_x-min_x)/n_count_extrapolated/2;
        y += randnorm()*(max_y-min_y)/n_count_extrapolated/2;
        z += randnorm()*(max_z-min_z)/n_count_extrapolated/2;
        vx += randnorm()*min_vx/n_count_extrapolated/2;
        vy += randnorm()*min_vx/n_count_extrapolated/2;
        vx += randnorm()*min_vx/n_count_extrapolated/2;
      }
    } else { ABSORB; }
  }
}
#line 346927 "MACS_sample_kidney_box.c"
}   /* End of Guide_end=Virtual_input() SETTING parameter declarations. */
#undef repeat_cnt
#undef n_count_extrapolated
#undef end_reading
#undef mean_z
#undef mean_y
#undef mean_x
#undef first_block
#undef max_vz
#undef max_vy
#undef max_vx
#undef min_vz
#undef min_vy
#undef min_vx
#undef max_z
#undef max_y
#undef max_x
#undef min_z
#undef min_y
#undef min_x
#undef n_neutrons
#undef mean_dz
#undef mean_dy
#undef mean_dx
#undef mean_vz
#undef mean_vy
#undef mean_vx
#undef filename_ncount
#undef repeat_number
#undef rTable
#undef Offset
#undef nrows
#undef pos
#undef read_block
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex
  /* Label for restoring  neutron */
  mcabsorbCompGuide_end:
  if (RESTORE) /* restore if needed */
  { RESTORE_NEUTRON(13,
      mcnlx,
      mcnly,
      mcnlz,
      mcnlvx,
      mcnlvy,
      mcnlvz,
      mcnlt,
      mcnlsx,
      mcnlsy,
      mcnlsz,
      mcnlp); }
#undef mcabsorbComp
#undef p
#undef sz
#undef sy
#undef sx
#undef t
#undef vz
#undef vy
#undef vx
#undef z
#undef y
#undef x
  mcDEBUG_STATE(
mcnlx,
mcnly,
mcnlz,
mcnlvx,
mcnlvy,
mcnlvz,
mcnlt,
mcnlsx,
mcnlsy,
mcnlsz,
mcnlp)

  /* TRACE Component main_slit [14] */
  mccoordschange(mcposrmain_slit, mcrotrmain_slit,
    &mcnlx,
    &mcnly,
    &mcnlz,
    &mcnlvx,
    &mcnlvy,
    &mcnlvz,
    &mcnlsx,
    &mcnlsy,
    &mcnlsz);
  /* define label inside component main_slit (without coords transformations) */
  mcJumpTrace_main_slit:
  SIG_MESSAGE("main_slit (Trace)");
  mcDEBUG_COMP("main_slit")
  mcDEBUG_STATE(
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp)
#define x mcnlx
#define y mcnly
#define z mcnlz
#define vx mcnlvx
#define vy mcnlvy
#define vz mcnlvz
#define t mcnlt
#define sx mcnlsx
#define sy mcnlsy
#define sz mcnlsz
#define p mcnlp

#define mcabsorbComp mcabsorbCompmain_slit
  STORE_NEUTRON(14,
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp);
  mcScattered=0;
  mcRestore=0;
  mcNCounter[14]++;
  mcPCounter[14] += p;
  mcP2Counter[14] += p*p;
#define mccompcurname  main_slit
#define mccompcurtype  Slit
#define mccompcurindex 14
{   /* Declarations of main_slit=Slit() SETTING parameters. */
MCNUM xmin = mccmain_slit_xmin;
MCNUM xmax = mccmain_slit_xmax;
MCNUM ymin = mccmain_slit_ymin;
MCNUM ymax = mccmain_slit_ymax;
MCNUM radius = mccmain_slit_radius;
MCNUM xwidth = mccmain_slit_xwidth;
MCNUM yheight = mccmain_slit_yheight;
#line 71 "/usr/share/mcstas/2.7/optics/Slit.comp"
{
    PROP_Z0;
    if (((radius == 0) && (x<xmin || x>xmax || y<ymin || y>ymax))
	|| ((radius != 0) && (x*x + y*y > radius*radius))) {
      RESTORE_NEUTRON(INDEX_CURRENT_COMP, x, y, z, vx, vy, vz, t, sx, sy, sz, p);
      ABSORB;
    }
    else
        SCATTER;
}
#line 347084 "MACS_sample_kidney_box.c"
}   /* End of main_slit=Slit() SETTING parameter declarations. */
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex
  /* Label for restoring  neutron */
  mcabsorbCompmain_slit:
  if (RESTORE) /* restore if needed */
  { RESTORE_NEUTRON(14,
      mcnlx,
      mcnly,
      mcnlz,
      mcnlvx,
      mcnlvy,
      mcnlvz,
      mcnlt,
      mcnlsx,
      mcnlsy,
      mcnlsz,
      mcnlp); }
#undef mcabsorbComp
#undef p
#undef sz
#undef sy
#undef sx
#undef t
#undef vz
#undef vy
#undef vx
#undef z
#undef y
#undef x
  mcDEBUG_STATE(
mcnlx,
mcnly,
mcnlz,
mcnlvx,
mcnlvy,
mcnlvz,
mcnlt,
mcnlsx,
mcnlsy,
mcnlsz,
mcnlp)

  /* TRACE Component target [15] */
  mccoordschange(mcposrtarget, mcrotrtarget,
    &mcnlx,
    &mcnly,
    &mcnlz,
    &mcnlvx,
    &mcnlvy,
    &mcnlvz,
    &mcnlsx,
    &mcnlsy,
    &mcnlsz);
  /* define label inside component target (without coords transformations) */
  mcJumpTrace_target:
  SIG_MESSAGE("target (Trace)");
  mcDEBUG_COMP("target")
  mcDEBUG_STATE(
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp)
#define x mcnlx
#define y mcnly
#define z mcnlz
#define vx mcnlvx
#define vy mcnlvy
#define vz mcnlvz
#define t mcnlt
#define sx mcnlsx
#define sy mcnlsy
#define sz mcnlsz
#define p mcnlp

#define mcabsorbComp mcabsorbComptarget
  STORE_NEUTRON(15,
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp);
  mcScattered=0;
  mcRestore=0;
  mcNCounter[15]++;
  mcPCounter[15] += p;
  mcP2Counter[15] += p*p;
#define mccompcurname  target
#define mccompcurtype  Arm
#define mccompcurindex 15
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex
  /* Label for restoring  neutron */
  mcabsorbComptarget:
  if (RESTORE) /* restore if needed */
  { RESTORE_NEUTRON(15,
      mcnlx,
      mcnly,
      mcnlz,
      mcnlvx,
      mcnlvy,
      mcnlvz,
      mcnlt,
      mcnlsx,
      mcnlsy,
      mcnlsz,
      mcnlp); }
#undef mcabsorbComp
#undef p
#undef sz
#undef sy
#undef sx
#undef t
#undef vz
#undef vy
#undef vx
#undef z
#undef y
#undef x
  mcDEBUG_STATE(
mcnlx,
mcnly,
mcnlz,
mcnlvx,
mcnlvy,
mcnlvz,
mcnlt,
mcnlsx,
mcnlsy,
mcnlsz,
mcnlp)

  /* TRACE Component cryostat_center [16] */
  mccoordschange(mcposrcryostat_center, mcrotrcryostat_center,
    &mcnlx,
    &mcnly,
    &mcnlz,
    &mcnlvx,
    &mcnlvy,
    &mcnlvz,
    &mcnlsx,
    &mcnlsy,
    &mcnlsz);
  /* define label inside component cryostat_center (without coords transformations) */
  mcJumpTrace_cryostat_center:
  SIG_MESSAGE("cryostat_center (Trace)");
  mcDEBUG_COMP("cryostat_center")
  mcDEBUG_STATE(
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp)
#define x mcnlx
#define y mcnly
#define z mcnlz
#define vx mcnlvx
#define vy mcnlvy
#define vz mcnlvz
#define t mcnlt
#define sx mcnlsx
#define sy mcnlsy
#define sz mcnlsz
#define p mcnlp

#define mcabsorbComp mcabsorbCompcryostat_center
  STORE_NEUTRON(16,
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp);
  mcScattered=0;
  mcRestore=0;
  mcNCounter[16]++;
  mcPCounter[16] += p;
  mcP2Counter[16] += p*p;
#define mccompcurname  cryostat_center
#define mccompcurtype  Arm
#define mccompcurindex 16
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex
  /* Label for restoring  neutron */
  mcabsorbCompcryostat_center:
  if (RESTORE) /* restore if needed */
  { RESTORE_NEUTRON(16,
      mcnlx,
      mcnly,
      mcnlz,
      mcnlvx,
      mcnlvy,
      mcnlvz,
      mcnlt,
      mcnlsx,
      mcnlsy,
      mcnlsz,
      mcnlp); }
#undef mcabsorbComp
#undef p
#undef sz
#undef sy
#undef sx
#undef t
#undef vz
#undef vy
#undef vx
#undef z
#undef y
#undef x
  mcDEBUG_STATE(
mcnlx,
mcnly,
mcnlz,
mcnlvx,
mcnlvy,
mcnlvz,
mcnlt,
mcnlsx,
mcnlsy,
mcnlsz,
mcnlp)

  /* TRACE Component drum_center [17] */
  mccoordschange(mcposrdrum_center, mcrotrdrum_center,
    &mcnlx,
    &mcnly,
    &mcnlz,
    &mcnlvx,
    &mcnlvy,
    &mcnlvz,
    &mcnlsx,
    &mcnlsy,
    &mcnlsz);
  /* define label inside component drum_center (without coords transformations) */
  mcJumpTrace_drum_center:
  SIG_MESSAGE("drum_center (Trace)");
  mcDEBUG_COMP("drum_center")
  mcDEBUG_STATE(
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp)
#define x mcnlx
#define y mcnly
#define z mcnlz
#define vx mcnlvx
#define vy mcnlvy
#define vz mcnlvz
#define t mcnlt
#define sx mcnlsx
#define sy mcnlsy
#define sz mcnlsz
#define p mcnlp

#define mcabsorbComp mcabsorbCompdrum_center
  STORE_NEUTRON(17,
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp);
  mcScattered=0;
  mcRestore=0;
  mcNCounter[17]++;
  mcPCounter[17] += p;
  mcP2Counter[17] += p*p;
#define mccompcurname  drum_center
#define mccompcurtype  Arm
#define mccompcurindex 17
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex
  /* Label for restoring  neutron */
  mcabsorbCompdrum_center:
  if (RESTORE) /* restore if needed */
  { RESTORE_NEUTRON(17,
      mcnlx,
      mcnly,
      mcnlz,
      mcnlvx,
      mcnlvy,
      mcnlvz,
      mcnlt,
      mcnlsx,
      mcnlsy,
      mcnlsz,
      mcnlp); }
#undef mcabsorbComp
#undef p
#undef sz
#undef sy
#undef sx
#undef t
#undef vz
#undef vy
#undef vx
#undef z
#undef y
#undef x
  mcDEBUG_STATE(
mcnlx,
mcnly,
mcnlz,
mcnlvx,
mcnlvy,
mcnlvz,
mcnlt,
mcnlsx,
mcnlsy,
mcnlsz,
mcnlp)

  /* TRACE Component crystal_assembly [18] */
  mccoordschange(mcposrcrystal_assembly, mcrotrcrystal_assembly,
    &mcnlx,
    &mcnly,
    &mcnlz,
    &mcnlvx,
    &mcnlvy,
    &mcnlvz,
    &mcnlsx,
    &mcnlsy,
    &mcnlsz);
  /* define label inside component crystal_assembly (without coords transformations) */
  mcJumpTrace_crystal_assembly:
  SIG_MESSAGE("crystal_assembly (Trace)");
  mcDEBUG_COMP("crystal_assembly")
  mcDEBUG_STATE(
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp)
#define x mcnlx
#define y mcnly
#define z mcnlz
#define vx mcnlvx
#define vy mcnlvy
#define vz mcnlvz
#define t mcnlt
#define sx mcnlsx
#define sy mcnlsy
#define sz mcnlsz
#define p mcnlp

#define mcabsorbComp mcabsorbCompcrystal_assembly
  STORE_NEUTRON(18,
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp);
  mcScattered=0;
  mcRestore=0;
  mcNCounter[18]++;
  mcPCounter[18] += p;
  mcP2Counter[18] += p*p;
#define mccompcurname  crystal_assembly
#define mccompcurtype  Arm
#define mccompcurindex 18
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex
  /* Label for restoring  neutron */
  mcabsorbCompcrystal_assembly:
  if (RESTORE) /* restore if needed */
  { RESTORE_NEUTRON(18,
      mcnlx,
      mcnly,
      mcnlz,
      mcnlvx,
      mcnlvy,
      mcnlvz,
      mcnlt,
      mcnlsx,
      mcnlsy,
      mcnlsz,
      mcnlp); }
#undef mcabsorbComp
#undef p
#undef sz
#undef sy
#undef sx
#undef t
#undef vz
#undef vy
#undef vx
#undef z
#undef y
#undef x
  mcDEBUG_STATE(
mcnlx,
mcnly,
mcnlz,
mcnlvx,
mcnlvy,
mcnlvz,
mcnlt,
mcnlsx,
mcnlsy,
mcnlsz,
mcnlp)

  /* TRACE Component crystal_axis [19] */
  mccoordschange(mcposrcrystal_axis, mcrotrcrystal_axis,
    &mcnlx,
    &mcnly,
    &mcnlz,
    &mcnlvx,
    &mcnlvy,
    &mcnlvz,
    &mcnlsx,
    &mcnlsy,
    &mcnlsz);
  /* define label inside component crystal_axis (without coords transformations) */
  mcJumpTrace_crystal_axis:
  SIG_MESSAGE("crystal_axis (Trace)");
  mcDEBUG_COMP("crystal_axis")
  mcDEBUG_STATE(
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp)
#define x mcnlx
#define y mcnly
#define z mcnlz
#define vx mcnlvx
#define vy mcnlvy
#define vz mcnlvz
#define t mcnlt
#define sx mcnlsx
#define sy mcnlsy
#define sz mcnlsz
#define p mcnlp

#define mcabsorbComp mcabsorbCompcrystal_axis
  STORE_NEUTRON(19,
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp);
  mcScattered=0;
  mcRestore=0;
  mcNCounter[19]++;
  mcPCounter[19] += p;
  mcP2Counter[19] += p*p;
#define mccompcurname  crystal_axis
#define mccompcurtype  Arm
#define mccompcurindex 19
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex
  /* Label for restoring  neutron */
  mcabsorbCompcrystal_axis:
  if (RESTORE) /* restore if needed */
  { RESTORE_NEUTRON(19,
      mcnlx,
      mcnly,
      mcnlz,
      mcnlvx,
      mcnlvy,
      mcnlvz,
      mcnlt,
      mcnlsx,
      mcnlsy,
      mcnlsz,
      mcnlp); }
#undef mcabsorbComp
#undef p
#undef sz
#undef sy
#undef sx
#undef t
#undef vz
#undef vy
#undef vx
#undef z
#undef y
#undef x
  mcDEBUG_STATE(
mcnlx,
mcnly,
mcnlz,
mcnlvx,
mcnlvy,
mcnlvz,
mcnlt,
mcnlsx,
mcnlsy,
mcnlsz,
mcnlp)

  /* TRACE Component sample [20] */
  mccoordschange(mcposrsample, mcrotrsample,
    &mcnlx,
    &mcnly,
    &mcnlz,
    &mcnlvx,
    &mcnlvy,
    &mcnlvz,
    &mcnlsx,
    &mcnlsy,
    &mcnlsz);
  /* define label inside component sample (without coords transformations) */
  mcJumpTrace_sample:
  SIG_MESSAGE("sample (Trace)");
  mcDEBUG_COMP("sample")
  mcDEBUG_STATE(
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp)
#define x mcnlx
#define y mcnly
#define z mcnlz
#define vx mcnlvx
#define vy mcnlvy
#define vz mcnlvz
#define t mcnlt
#define sx mcnlsx
#define sy mcnlsy
#define sz mcnlsz
#define p mcnlp

#define mcabsorbComp mcabsorbCompsample
  STORE_NEUTRON(20,
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp);
  mcScattered=0;
  mcRestore=0;
  mcNCounter[20]++;
  mcPCounter[20] += p;
  mcP2Counter[20] += p*p;
#define mccompcurname  sample
#define mccompcurtype  Union_box
#define mccompcurindex 20
#define loop_index mccsample_loop_index
#define this_box_volume mccsample_this_box_volume
#define global_geometry_element mccsample_global_geometry_element
#define this_box_storage mccsample_this_box_storage
{   /* Declarations of sample=Union_box() SETTING parameters. */
char* material_string = mccsample_material_string;
MCNUM priority = mccsample_priority;
MCNUM xwidth = mccsample_xwidth;
MCNUM yheight = mccsample_yheight;
MCNUM zdepth = mccsample_zdepth;
MCNUM xwidth2 = mccsample_xwidth2;
MCNUM yheight2 = mccsample_yheight2;
MCNUM visualize = mccsample_visualize;
int target_index = mccsample_target_index;
MCNUM target_x = mccsample_target_x;
MCNUM target_y = mccsample_target_y;
MCNUM target_z = mccsample_target_z;
MCNUM focus_aw = mccsample_focus_aw;
MCNUM focus_ah = mccsample_focus_ah;
MCNUM focus_xw = mccsample_focus_xw;
MCNUM focus_xh = mccsample_focus_xh;
MCNUM focus_r = mccsample_focus_r;
MCNUM p_interact = mccsample_p_interact;
char* mask_string = mccsample_mask_string;
char* mask_setting = mccsample_mask_setting;
MCNUM number_of_activations = mccsample_number_of_activations;
}   /* End of sample=Union_box() SETTING parameter declarations. */
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex
  /* Label for restoring  neutron */
  mcabsorbCompsample:
  if (RESTORE) /* restore if needed */
  { RESTORE_NEUTRON(20,
      mcnlx,
      mcnly,
      mcnlz,
      mcnlvx,
      mcnlvy,
      mcnlvz,
      mcnlt,
      mcnlsx,
      mcnlsy,
      mcnlsz,
      mcnlp); }
#undef mcabsorbComp
#undef p
#undef sz
#undef sy
#undef sx
#undef t
#undef vz
#undef vy
#undef vx
#undef z
#undef y
#undef x
  mcDEBUG_STATE(
mcnlx,
mcnly,
mcnlz,
mcnlvx,
mcnlvy,
mcnlvz,
mcnlt,
mcnlsx,
mcnlsy,
mcnlsz,
mcnlp)

  /* TRACE Component sample_plate [21] */
  mccoordschange(mcposrsample_plate, mcrotrsample_plate,
    &mcnlx,
    &mcnly,
    &mcnlz,
    &mcnlvx,
    &mcnlvy,
    &mcnlvz,
    &mcnlsx,
    &mcnlsy,
    &mcnlsz);
  /* define label inside component sample_plate (without coords transformations) */
  mcJumpTrace_sample_plate:
  SIG_MESSAGE("sample_plate (Trace)");
  mcDEBUG_COMP("sample_plate")
  mcDEBUG_STATE(
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp)
#define x mcnlx
#define y mcnly
#define z mcnlz
#define vx mcnlvx
#define vy mcnlvy
#define vz mcnlvz
#define t mcnlt
#define sx mcnlsx
#define sy mcnlsy
#define sz mcnlsz
#define p mcnlp

#define mcabsorbComp mcabsorbCompsample_plate
  STORE_NEUTRON(21,
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp);
  mcScattered=0;
  mcRestore=0;
  mcNCounter[21]++;
  mcPCounter[21] += p;
  mcP2Counter[21] += p*p;
#define mccompcurname  sample_plate
#define mccompcurtype  Union_cylinder
#define mccompcurindex 21
#define loop_index mccsample_plate_loop_index
#define this_cylinder_volume mccsample_plate_this_cylinder_volume
#define global_geometry_element mccsample_plate_global_geometry_element
#define this_cylinder_storage mccsample_plate_this_cylinder_storage
{   /* Declarations of sample_plate=Union_cylinder() SETTING parameters. */
char* material_string = mccsample_plate_material_string;
MCNUM priority = mccsample_plate_priority;
MCNUM radius = mccsample_plate_radius;
MCNUM yheight = mccsample_plate_yheight;
MCNUM visualize = mccsample_plate_visualize;
int target_index = mccsample_plate_target_index;
MCNUM target_x = mccsample_plate_target_x;
MCNUM target_y = mccsample_plate_target_y;
MCNUM target_z = mccsample_plate_target_z;
MCNUM focus_aw = mccsample_plate_focus_aw;
MCNUM focus_ah = mccsample_plate_focus_ah;
MCNUM focus_xw = mccsample_plate_focus_xw;
MCNUM focus_xh = mccsample_plate_focus_xh;
MCNUM focus_r = mccsample_plate_focus_r;
MCNUM p_interact = mccsample_plate_p_interact;
char* mask_string = mccsample_plate_mask_string;
char* mask_setting = mccsample_plate_mask_setting;
MCNUM number_of_activations = mccsample_plate_number_of_activations;
#line 345 "Union_cylinder.comp"
{
dummy = 1;
}
#line 347865 "MACS_sample_kidney_box.c"
}   /* End of sample_plate=Union_cylinder() SETTING parameter declarations. */
#undef this_cylinder_storage
#undef global_geometry_element
#undef this_cylinder_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex
  /* Label for restoring  neutron */
  mcabsorbCompsample_plate:
  if (RESTORE) /* restore if needed */
  { RESTORE_NEUTRON(21,
      mcnlx,
      mcnly,
      mcnlz,
      mcnlvx,
      mcnlvy,
      mcnlvz,
      mcnlt,
      mcnlsx,
      mcnlsy,
      mcnlsz,
      mcnlp); }
#undef mcabsorbComp
#undef p
#undef sz
#undef sy
#undef sx
#undef t
#undef vz
#undef vy
#undef vx
#undef z
#undef y
#undef x
  mcDEBUG_STATE(
mcnlx,
mcnly,
mcnlz,
mcnlvx,
mcnlvy,
mcnlvz,
mcnlt,
mcnlsx,
mcnlsy,
mcnlsz,
mcnlp)

  /* TRACE Component sample_plate_rod [22] */
  mccoordschange(mcposrsample_plate_rod, mcrotrsample_plate_rod,
    &mcnlx,
    &mcnly,
    &mcnlz,
    &mcnlvx,
    &mcnlvy,
    &mcnlvz,
    &mcnlsx,
    &mcnlsy,
    &mcnlsz);
  /* define label inside component sample_plate_rod (without coords transformations) */
  mcJumpTrace_sample_plate_rod:
  SIG_MESSAGE("sample_plate_rod (Trace)");
  mcDEBUG_COMP("sample_plate_rod")
  mcDEBUG_STATE(
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp)
#define x mcnlx
#define y mcnly
#define z mcnlz
#define vx mcnlvx
#define vy mcnlvy
#define vz mcnlvz
#define t mcnlt
#define sx mcnlsx
#define sy mcnlsy
#define sz mcnlsz
#define p mcnlp

#define mcabsorbComp mcabsorbCompsample_plate_rod
  STORE_NEUTRON(22,
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp);
  mcScattered=0;
  mcRestore=0;
  mcNCounter[22]++;
  mcPCounter[22] += p;
  mcP2Counter[22] += p*p;
#define mccompcurname  sample_plate_rod
#define mccompcurtype  Union_cylinder
#define mccompcurindex 22
#define loop_index mccsample_plate_rod_loop_index
#define this_cylinder_volume mccsample_plate_rod_this_cylinder_volume
#define global_geometry_element mccsample_plate_rod_global_geometry_element
#define this_cylinder_storage mccsample_plate_rod_this_cylinder_storage
{   /* Declarations of sample_plate_rod=Union_cylinder() SETTING parameters. */
char* material_string = mccsample_plate_rod_material_string;
MCNUM priority = mccsample_plate_rod_priority;
MCNUM radius = mccsample_plate_rod_radius;
MCNUM yheight = mccsample_plate_rod_yheight;
MCNUM visualize = mccsample_plate_rod_visualize;
int target_index = mccsample_plate_rod_target_index;
MCNUM target_x = mccsample_plate_rod_target_x;
MCNUM target_y = mccsample_plate_rod_target_y;
MCNUM target_z = mccsample_plate_rod_target_z;
MCNUM focus_aw = mccsample_plate_rod_focus_aw;
MCNUM focus_ah = mccsample_plate_rod_focus_ah;
MCNUM focus_xw = mccsample_plate_rod_focus_xw;
MCNUM focus_xh = mccsample_plate_rod_focus_xh;
MCNUM focus_r = mccsample_plate_rod_focus_r;
MCNUM p_interact = mccsample_plate_rod_p_interact;
char* mask_string = mccsample_plate_rod_mask_string;
char* mask_setting = mccsample_plate_rod_mask_setting;
MCNUM number_of_activations = mccsample_plate_rod_number_of_activations;
#line 345 "Union_cylinder.comp"
{
dummy = 1;
}
#line 348001 "MACS_sample_kidney_box.c"
}   /* End of sample_plate_rod=Union_cylinder() SETTING parameter declarations. */
#undef this_cylinder_storage
#undef global_geometry_element
#undef this_cylinder_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex
  /* Label for restoring  neutron */
  mcabsorbCompsample_plate_rod:
  if (RESTORE) /* restore if needed */
  { RESTORE_NEUTRON(22,
      mcnlx,
      mcnly,
      mcnlz,
      mcnlvx,
      mcnlvy,
      mcnlvz,
      mcnlt,
      mcnlsx,
      mcnlsy,
      mcnlsz,
      mcnlp); }
#undef mcabsorbComp
#undef p
#undef sz
#undef sy
#undef sx
#undef t
#undef vz
#undef vy
#undef vx
#undef z
#undef y
#undef x
  mcDEBUG_STATE(
mcnlx,
mcnly,
mcnlz,
mcnlvx,
mcnlvy,
mcnlvz,
mcnlt,
mcnlsx,
mcnlsy,
mcnlsz,
mcnlp)

  /* TRACE Component sample_base [23] */
  mccoordschange(mcposrsample_base, mcrotrsample_base,
    &mcnlx,
    &mcnly,
    &mcnlz,
    &mcnlvx,
    &mcnlvy,
    &mcnlvz,
    &mcnlsx,
    &mcnlsy,
    &mcnlsz);
  /* define label inside component sample_base (without coords transformations) */
  mcJumpTrace_sample_base:
  SIG_MESSAGE("sample_base (Trace)");
  mcDEBUG_COMP("sample_base")
  mcDEBUG_STATE(
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp)
#define x mcnlx
#define y mcnly
#define z mcnlz
#define vx mcnlvx
#define vy mcnlvy
#define vz mcnlvz
#define t mcnlt
#define sx mcnlsx
#define sy mcnlsy
#define sz mcnlsz
#define p mcnlp

#define mcabsorbComp mcabsorbCompsample_base
  STORE_NEUTRON(23,
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp);
  mcScattered=0;
  mcRestore=0;
  mcNCounter[23]++;
  mcPCounter[23] += p;
  mcP2Counter[23] += p*p;
#define mccompcurname  sample_base
#define mccompcurtype  Union_cylinder
#define mccompcurindex 23
#define loop_index mccsample_base_loop_index
#define this_cylinder_volume mccsample_base_this_cylinder_volume
#define global_geometry_element mccsample_base_global_geometry_element
#define this_cylinder_storage mccsample_base_this_cylinder_storage
{   /* Declarations of sample_base=Union_cylinder() SETTING parameters. */
char* material_string = mccsample_base_material_string;
MCNUM priority = mccsample_base_priority;
MCNUM radius = mccsample_base_radius;
MCNUM yheight = mccsample_base_yheight;
MCNUM visualize = mccsample_base_visualize;
int target_index = mccsample_base_target_index;
MCNUM target_x = mccsample_base_target_x;
MCNUM target_y = mccsample_base_target_y;
MCNUM target_z = mccsample_base_target_z;
MCNUM focus_aw = mccsample_base_focus_aw;
MCNUM focus_ah = mccsample_base_focus_ah;
MCNUM focus_xw = mccsample_base_focus_xw;
MCNUM focus_xh = mccsample_base_focus_xh;
MCNUM focus_r = mccsample_base_focus_r;
MCNUM p_interact = mccsample_base_p_interact;
char* mask_string = mccsample_base_mask_string;
char* mask_setting = mccsample_base_mask_setting;
MCNUM number_of_activations = mccsample_base_number_of_activations;
#line 345 "Union_cylinder.comp"
{
dummy = 1;
}
#line 348137 "MACS_sample_kidney_box.c"
}   /* End of sample_base=Union_cylinder() SETTING parameter declarations. */
#undef this_cylinder_storage
#undef global_geometry_element
#undef this_cylinder_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex
  /* Label for restoring  neutron */
  mcabsorbCompsample_base:
  if (RESTORE) /* restore if needed */
  { RESTORE_NEUTRON(23,
      mcnlx,
      mcnly,
      mcnlz,
      mcnlvx,
      mcnlvy,
      mcnlvz,
      mcnlt,
      mcnlsx,
      mcnlsy,
      mcnlsz,
      mcnlp); }
#undef mcabsorbComp
#undef p
#undef sz
#undef sy
#undef sx
#undef t
#undef vz
#undef vy
#undef vx
#undef z
#undef y
#undef x
  mcDEBUG_STATE(
mcnlx,
mcnly,
mcnlz,
mcnlvx,
mcnlvy,
mcnlvz,
mcnlt,
mcnlsx,
mcnlsy,
mcnlsz,
mcnlp)

  /* TRACE Component sample_base_gap [24] */
  mccoordschange(mcposrsample_base_gap, mcrotrsample_base_gap,
    &mcnlx,
    &mcnly,
    &mcnlz,
    &mcnlvx,
    &mcnlvy,
    &mcnlvz,
    &mcnlsx,
    &mcnlsy,
    &mcnlsz);
  /* define label inside component sample_base_gap (without coords transformations) */
  mcJumpTrace_sample_base_gap:
  SIG_MESSAGE("sample_base_gap (Trace)");
  mcDEBUG_COMP("sample_base_gap")
  mcDEBUG_STATE(
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp)
#define x mcnlx
#define y mcnly
#define z mcnlz
#define vx mcnlvx
#define vy mcnlvy
#define vz mcnlvz
#define t mcnlt
#define sx mcnlsx
#define sy mcnlsy
#define sz mcnlsz
#define p mcnlp

#define mcabsorbComp mcabsorbCompsample_base_gap
  STORE_NEUTRON(24,
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp);
  mcScattered=0;
  mcRestore=0;
  mcNCounter[24]++;
  mcPCounter[24] += p;
  mcP2Counter[24] += p*p;
#define mccompcurname  sample_base_gap
#define mccompcurtype  Union_cylinder
#define mccompcurindex 24
#define loop_index mccsample_base_gap_loop_index
#define this_cylinder_volume mccsample_base_gap_this_cylinder_volume
#define global_geometry_element mccsample_base_gap_global_geometry_element
#define this_cylinder_storage mccsample_base_gap_this_cylinder_storage
{   /* Declarations of sample_base_gap=Union_cylinder() SETTING parameters. */
char* material_string = mccsample_base_gap_material_string;
MCNUM priority = mccsample_base_gap_priority;
MCNUM radius = mccsample_base_gap_radius;
MCNUM yheight = mccsample_base_gap_yheight;
MCNUM visualize = mccsample_base_gap_visualize;
int target_index = mccsample_base_gap_target_index;
MCNUM target_x = mccsample_base_gap_target_x;
MCNUM target_y = mccsample_base_gap_target_y;
MCNUM target_z = mccsample_base_gap_target_z;
MCNUM focus_aw = mccsample_base_gap_focus_aw;
MCNUM focus_ah = mccsample_base_gap_focus_ah;
MCNUM focus_xw = mccsample_base_gap_focus_xw;
MCNUM focus_xh = mccsample_base_gap_focus_xh;
MCNUM focus_r = mccsample_base_gap_focus_r;
MCNUM p_interact = mccsample_base_gap_p_interact;
char* mask_string = mccsample_base_gap_mask_string;
char* mask_setting = mccsample_base_gap_mask_setting;
MCNUM number_of_activations = mccsample_base_gap_number_of_activations;
#line 345 "Union_cylinder.comp"
{
dummy = 1;
}
#line 348273 "MACS_sample_kidney_box.c"
}   /* End of sample_base_gap=Union_cylinder() SETTING parameter declarations. */
#undef this_cylinder_storage
#undef global_geometry_element
#undef this_cylinder_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex
  /* Label for restoring  neutron */
  mcabsorbCompsample_base_gap:
  if (RESTORE) /* restore if needed */
  { RESTORE_NEUTRON(24,
      mcnlx,
      mcnly,
      mcnlz,
      mcnlvx,
      mcnlvy,
      mcnlvz,
      mcnlt,
      mcnlsx,
      mcnlsy,
      mcnlsz,
      mcnlp); }
#undef mcabsorbComp
#undef p
#undef sz
#undef sy
#undef sx
#undef t
#undef vz
#undef vy
#undef vx
#undef z
#undef y
#undef x
  mcDEBUG_STATE(
mcnlx,
mcnly,
mcnlz,
mcnlvx,
mcnlvy,
mcnlvz,
mcnlt,
mcnlsx,
mcnlsy,
mcnlsz,
mcnlp)

  /* TRACE Component cryostat_mountin_plate [25] */
  mccoordschange(mcposrcryostat_mountin_plate, mcrotrcryostat_mountin_plate,
    &mcnlx,
    &mcnly,
    &mcnlz,
    &mcnlvx,
    &mcnlvy,
    &mcnlvz,
    &mcnlsx,
    &mcnlsy,
    &mcnlsz);
  /* define label inside component cryostat_mountin_plate (without coords transformations) */
  mcJumpTrace_cryostat_mountin_plate:
  SIG_MESSAGE("cryostat_mountin_plate (Trace)");
  mcDEBUG_COMP("cryostat_mountin_plate")
  mcDEBUG_STATE(
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp)
#define x mcnlx
#define y mcnly
#define z mcnlz
#define vx mcnlvx
#define vy mcnlvy
#define vz mcnlvz
#define t mcnlt
#define sx mcnlsx
#define sy mcnlsy
#define sz mcnlsz
#define p mcnlp

#define mcabsorbComp mcabsorbCompcryostat_mountin_plate
  STORE_NEUTRON(25,
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp);
  mcScattered=0;
  mcRestore=0;
  mcNCounter[25]++;
  mcPCounter[25] += p;
  mcP2Counter[25] += p*p;
#define mccompcurname  cryostat_mountin_plate
#define mccompcurtype  Union_cylinder
#define mccompcurindex 25
#define loop_index mcccryostat_mountin_plate_loop_index
#define this_cylinder_volume mcccryostat_mountin_plate_this_cylinder_volume
#define global_geometry_element mcccryostat_mountin_plate_global_geometry_element
#define this_cylinder_storage mcccryostat_mountin_plate_this_cylinder_storage
{   /* Declarations of cryostat_mountin_plate=Union_cylinder() SETTING parameters. */
char* material_string = mcccryostat_mountin_plate_material_string;
MCNUM priority = mcccryostat_mountin_plate_priority;
MCNUM radius = mcccryostat_mountin_plate_radius;
MCNUM yheight = mcccryostat_mountin_plate_yheight;
MCNUM visualize = mcccryostat_mountin_plate_visualize;
int target_index = mcccryostat_mountin_plate_target_index;
MCNUM target_x = mcccryostat_mountin_plate_target_x;
MCNUM target_y = mcccryostat_mountin_plate_target_y;
MCNUM target_z = mcccryostat_mountin_plate_target_z;
MCNUM focus_aw = mcccryostat_mountin_plate_focus_aw;
MCNUM focus_ah = mcccryostat_mountin_plate_focus_ah;
MCNUM focus_xw = mcccryostat_mountin_plate_focus_xw;
MCNUM focus_xh = mcccryostat_mountin_plate_focus_xh;
MCNUM focus_r = mcccryostat_mountin_plate_focus_r;
MCNUM p_interact = mcccryostat_mountin_plate_p_interact;
char* mask_string = mcccryostat_mountin_plate_mask_string;
char* mask_setting = mcccryostat_mountin_plate_mask_setting;
MCNUM number_of_activations = mcccryostat_mountin_plate_number_of_activations;
#line 345 "Union_cylinder.comp"
{
dummy = 1;
}
#line 348409 "MACS_sample_kidney_box.c"
}   /* End of cryostat_mountin_plate=Union_cylinder() SETTING parameter declarations. */
#undef this_cylinder_storage
#undef global_geometry_element
#undef this_cylinder_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex
  /* Label for restoring  neutron */
  mcabsorbCompcryostat_mountin_plate:
  if (RESTORE) /* restore if needed */
  { RESTORE_NEUTRON(25,
      mcnlx,
      mcnly,
      mcnlz,
      mcnlvx,
      mcnlvy,
      mcnlvz,
      mcnlt,
      mcnlsx,
      mcnlsy,
      mcnlsz,
      mcnlp); }
#undef mcabsorbComp
#undef p
#undef sz
#undef sy
#undef sx
#undef t
#undef vz
#undef vy
#undef vx
#undef z
#undef y
#undef x
  mcDEBUG_STATE(
mcnlx,
mcnly,
mcnlz,
mcnlvx,
mcnlvy,
mcnlvz,
mcnlt,
mcnlsx,
mcnlsy,
mcnlsz,
mcnlp)

  /* TRACE Component cryostat_drum_walls [26] */
  mccoordschange(mcposrcryostat_drum_walls, mcrotrcryostat_drum_walls,
    &mcnlx,
    &mcnly,
    &mcnlz,
    &mcnlvx,
    &mcnlvy,
    &mcnlvz,
    &mcnlsx,
    &mcnlsy,
    &mcnlsz);
  /* define label inside component cryostat_drum_walls (without coords transformations) */
  mcJumpTrace_cryostat_drum_walls:
  SIG_MESSAGE("cryostat_drum_walls (Trace)");
  mcDEBUG_COMP("cryostat_drum_walls")
  mcDEBUG_STATE(
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp)
#define x mcnlx
#define y mcnly
#define z mcnlz
#define vx mcnlvx
#define vy mcnlvy
#define vz mcnlvz
#define t mcnlt
#define sx mcnlsx
#define sy mcnlsy
#define sz mcnlsz
#define p mcnlp

#define mcabsorbComp mcabsorbCompcryostat_drum_walls
  STORE_NEUTRON(26,
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp);
  mcScattered=0;
  mcRestore=0;
  mcNCounter[26]++;
  mcPCounter[26] += p;
  mcP2Counter[26] += p*p;
#define mccompcurname  cryostat_drum_walls
#define mccompcurtype  Union_cylinder
#define mccompcurindex 26
#define loop_index mcccryostat_drum_walls_loop_index
#define this_cylinder_volume mcccryostat_drum_walls_this_cylinder_volume
#define global_geometry_element mcccryostat_drum_walls_global_geometry_element
#define this_cylinder_storage mcccryostat_drum_walls_this_cylinder_storage
{   /* Declarations of cryostat_drum_walls=Union_cylinder() SETTING parameters. */
char* material_string = mcccryostat_drum_walls_material_string;
MCNUM priority = mcccryostat_drum_walls_priority;
MCNUM radius = mcccryostat_drum_walls_radius;
MCNUM yheight = mcccryostat_drum_walls_yheight;
MCNUM visualize = mcccryostat_drum_walls_visualize;
int target_index = mcccryostat_drum_walls_target_index;
MCNUM target_x = mcccryostat_drum_walls_target_x;
MCNUM target_y = mcccryostat_drum_walls_target_y;
MCNUM target_z = mcccryostat_drum_walls_target_z;
MCNUM focus_aw = mcccryostat_drum_walls_focus_aw;
MCNUM focus_ah = mcccryostat_drum_walls_focus_ah;
MCNUM focus_xw = mcccryostat_drum_walls_focus_xw;
MCNUM focus_xh = mcccryostat_drum_walls_focus_xh;
MCNUM focus_r = mcccryostat_drum_walls_focus_r;
MCNUM p_interact = mcccryostat_drum_walls_p_interact;
char* mask_string = mcccryostat_drum_walls_mask_string;
char* mask_setting = mcccryostat_drum_walls_mask_setting;
MCNUM number_of_activations = mcccryostat_drum_walls_number_of_activations;
#line 345 "Union_cylinder.comp"
{
dummy = 1;
}
#line 348545 "MACS_sample_kidney_box.c"
}   /* End of cryostat_drum_walls=Union_cylinder() SETTING parameter declarations. */
#undef this_cylinder_storage
#undef global_geometry_element
#undef this_cylinder_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex
  /* Label for restoring  neutron */
  mcabsorbCompcryostat_drum_walls:
  if (RESTORE) /* restore if needed */
  { RESTORE_NEUTRON(26,
      mcnlx,
      mcnly,
      mcnlz,
      mcnlvx,
      mcnlvy,
      mcnlvz,
      mcnlt,
      mcnlsx,
      mcnlsy,
      mcnlsz,
      mcnlp); }
#undef mcabsorbComp
#undef p
#undef sz
#undef sy
#undef sx
#undef t
#undef vz
#undef vy
#undef vx
#undef z
#undef y
#undef x
  mcDEBUG_STATE(
mcnlx,
mcnly,
mcnlz,
mcnlvx,
mcnlvy,
mcnlvz,
mcnlt,
mcnlsx,
mcnlsy,
mcnlsz,
mcnlp)

  /* TRACE Component cryostat_drum_vacuum [27] */
  mccoordschange(mcposrcryostat_drum_vacuum, mcrotrcryostat_drum_vacuum,
    &mcnlx,
    &mcnly,
    &mcnlz,
    &mcnlvx,
    &mcnlvy,
    &mcnlvz,
    &mcnlsx,
    &mcnlsy,
    &mcnlsz);
  /* define label inside component cryostat_drum_vacuum (without coords transformations) */
  mcJumpTrace_cryostat_drum_vacuum:
  SIG_MESSAGE("cryostat_drum_vacuum (Trace)");
  mcDEBUG_COMP("cryostat_drum_vacuum")
  mcDEBUG_STATE(
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp)
#define x mcnlx
#define y mcnly
#define z mcnlz
#define vx mcnlvx
#define vy mcnlvy
#define vz mcnlvz
#define t mcnlt
#define sx mcnlsx
#define sy mcnlsy
#define sz mcnlsz
#define p mcnlp

#define mcabsorbComp mcabsorbCompcryostat_drum_vacuum
  STORE_NEUTRON(27,
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp);
  mcScattered=0;
  mcRestore=0;
  mcNCounter[27]++;
  mcPCounter[27] += p;
  mcP2Counter[27] += p*p;
#define mccompcurname  cryostat_drum_vacuum
#define mccompcurtype  Union_cylinder
#define mccompcurindex 27
#define loop_index mcccryostat_drum_vacuum_loop_index
#define this_cylinder_volume mcccryostat_drum_vacuum_this_cylinder_volume
#define global_geometry_element mcccryostat_drum_vacuum_global_geometry_element
#define this_cylinder_storage mcccryostat_drum_vacuum_this_cylinder_storage
{   /* Declarations of cryostat_drum_vacuum=Union_cylinder() SETTING parameters. */
char* material_string = mcccryostat_drum_vacuum_material_string;
MCNUM priority = mcccryostat_drum_vacuum_priority;
MCNUM radius = mcccryostat_drum_vacuum_radius;
MCNUM yheight = mcccryostat_drum_vacuum_yheight;
MCNUM visualize = mcccryostat_drum_vacuum_visualize;
int target_index = mcccryostat_drum_vacuum_target_index;
MCNUM target_x = mcccryostat_drum_vacuum_target_x;
MCNUM target_y = mcccryostat_drum_vacuum_target_y;
MCNUM target_z = mcccryostat_drum_vacuum_target_z;
MCNUM focus_aw = mcccryostat_drum_vacuum_focus_aw;
MCNUM focus_ah = mcccryostat_drum_vacuum_focus_ah;
MCNUM focus_xw = mcccryostat_drum_vacuum_focus_xw;
MCNUM focus_xh = mcccryostat_drum_vacuum_focus_xh;
MCNUM focus_r = mcccryostat_drum_vacuum_focus_r;
MCNUM p_interact = mcccryostat_drum_vacuum_p_interact;
char* mask_string = mcccryostat_drum_vacuum_mask_string;
char* mask_setting = mcccryostat_drum_vacuum_mask_setting;
MCNUM number_of_activations = mcccryostat_drum_vacuum_number_of_activations;
#line 345 "Union_cylinder.comp"
{
dummy = 1;
}
#line 348681 "MACS_sample_kidney_box.c"
}   /* End of cryostat_drum_vacuum=Union_cylinder() SETTING parameter declarations. */
#undef this_cylinder_storage
#undef global_geometry_element
#undef this_cylinder_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex
  /* Label for restoring  neutron */
  mcabsorbCompcryostat_drum_vacuum:
  if (RESTORE) /* restore if needed */
  { RESTORE_NEUTRON(27,
      mcnlx,
      mcnly,
      mcnlz,
      mcnlvx,
      mcnlvy,
      mcnlvz,
      mcnlt,
      mcnlsx,
      mcnlsy,
      mcnlsz,
      mcnlp); }
#undef mcabsorbComp
#undef p
#undef sz
#undef sy
#undef sx
#undef t
#undef vz
#undef vy
#undef vx
#undef z
#undef y
#undef x
  mcDEBUG_STATE(
mcnlx,
mcnly,
mcnlz,
mcnlvx,
mcnlvy,
mcnlvz,
mcnlt,
mcnlsx,
mcnlsy,
mcnlsz,
mcnlp)

  /* TRACE Component outer_cryostat_wall [28] */
  mccoordschange(mcposrouter_cryostat_wall, mcrotrouter_cryostat_wall,
    &mcnlx,
    &mcnly,
    &mcnlz,
    &mcnlvx,
    &mcnlvy,
    &mcnlvz,
    &mcnlsx,
    &mcnlsy,
    &mcnlsz);
  /* define label inside component outer_cryostat_wall (without coords transformations) */
  mcJumpTrace_outer_cryostat_wall:
  SIG_MESSAGE("outer_cryostat_wall (Trace)");
  mcDEBUG_COMP("outer_cryostat_wall")
  mcDEBUG_STATE(
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp)
#define x mcnlx
#define y mcnly
#define z mcnlz
#define vx mcnlvx
#define vy mcnlvy
#define vz mcnlvz
#define t mcnlt
#define sx mcnlsx
#define sy mcnlsy
#define sz mcnlsz
#define p mcnlp

#define mcabsorbComp mcabsorbCompouter_cryostat_wall
  STORE_NEUTRON(28,
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp);
  mcScattered=0;
  mcRestore=0;
  mcNCounter[28]++;
  mcPCounter[28] += p;
  mcP2Counter[28] += p*p;
#define mccompcurname  outer_cryostat_wall
#define mccompcurtype  Union_cylinder
#define mccompcurindex 28
#define loop_index mccouter_cryostat_wall_loop_index
#define this_cylinder_volume mccouter_cryostat_wall_this_cylinder_volume
#define global_geometry_element mccouter_cryostat_wall_global_geometry_element
#define this_cylinder_storage mccouter_cryostat_wall_this_cylinder_storage
{   /* Declarations of outer_cryostat_wall=Union_cylinder() SETTING parameters. */
char* material_string = mccouter_cryostat_wall_material_string;
MCNUM priority = mccouter_cryostat_wall_priority;
MCNUM radius = mccouter_cryostat_wall_radius;
MCNUM yheight = mccouter_cryostat_wall_yheight;
MCNUM visualize = mccouter_cryostat_wall_visualize;
int target_index = mccouter_cryostat_wall_target_index;
MCNUM target_x = mccouter_cryostat_wall_target_x;
MCNUM target_y = mccouter_cryostat_wall_target_y;
MCNUM target_z = mccouter_cryostat_wall_target_z;
MCNUM focus_aw = mccouter_cryostat_wall_focus_aw;
MCNUM focus_ah = mccouter_cryostat_wall_focus_ah;
MCNUM focus_xw = mccouter_cryostat_wall_focus_xw;
MCNUM focus_xh = mccouter_cryostat_wall_focus_xh;
MCNUM focus_r = mccouter_cryostat_wall_focus_r;
MCNUM p_interact = mccouter_cryostat_wall_p_interact;
char* mask_string = mccouter_cryostat_wall_mask_string;
char* mask_setting = mccouter_cryostat_wall_mask_setting;
MCNUM number_of_activations = mccouter_cryostat_wall_number_of_activations;
#line 345 "Union_cylinder.comp"
{
dummy = 1;
}
#line 348817 "MACS_sample_kidney_box.c"
}   /* End of outer_cryostat_wall=Union_cylinder() SETTING parameter declarations. */
#undef this_cylinder_storage
#undef global_geometry_element
#undef this_cylinder_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex
  /* Label for restoring  neutron */
  mcabsorbCompouter_cryostat_wall:
  if (RESTORE) /* restore if needed */
  { RESTORE_NEUTRON(28,
      mcnlx,
      mcnly,
      mcnlz,
      mcnlvx,
      mcnlvy,
      mcnlvz,
      mcnlt,
      mcnlsx,
      mcnlsy,
      mcnlsz,
      mcnlp); }
#undef mcabsorbComp
#undef p
#undef sz
#undef sy
#undef sx
#undef t
#undef vz
#undef vy
#undef vx
#undef z
#undef y
#undef x
  mcDEBUG_STATE(
mcnlx,
mcnly,
mcnlz,
mcnlvx,
mcnlvy,
mcnlvz,
mcnlt,
mcnlsx,
mcnlsy,
mcnlsz,
mcnlp)

  /* TRACE Component outer_cryostat_vacuum [29] */
  mccoordschange(mcposrouter_cryostat_vacuum, mcrotrouter_cryostat_vacuum,
    &mcnlx,
    &mcnly,
    &mcnlz,
    &mcnlvx,
    &mcnlvy,
    &mcnlvz,
    &mcnlsx,
    &mcnlsy,
    &mcnlsz);
  /* define label inside component outer_cryostat_vacuum (without coords transformations) */
  mcJumpTrace_outer_cryostat_vacuum:
  SIG_MESSAGE("outer_cryostat_vacuum (Trace)");
  mcDEBUG_COMP("outer_cryostat_vacuum")
  mcDEBUG_STATE(
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp)
#define x mcnlx
#define y mcnly
#define z mcnlz
#define vx mcnlvx
#define vy mcnlvy
#define vz mcnlvz
#define t mcnlt
#define sx mcnlsx
#define sy mcnlsy
#define sz mcnlsz
#define p mcnlp

#define mcabsorbComp mcabsorbCompouter_cryostat_vacuum
  STORE_NEUTRON(29,
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp);
  mcScattered=0;
  mcRestore=0;
  mcNCounter[29]++;
  mcPCounter[29] += p;
  mcP2Counter[29] += p*p;
#define mccompcurname  outer_cryostat_vacuum
#define mccompcurtype  Union_cylinder
#define mccompcurindex 29
#define loop_index mccouter_cryostat_vacuum_loop_index
#define this_cylinder_volume mccouter_cryostat_vacuum_this_cylinder_volume
#define global_geometry_element mccouter_cryostat_vacuum_global_geometry_element
#define this_cylinder_storage mccouter_cryostat_vacuum_this_cylinder_storage
{   /* Declarations of outer_cryostat_vacuum=Union_cylinder() SETTING parameters. */
char* material_string = mccouter_cryostat_vacuum_material_string;
MCNUM priority = mccouter_cryostat_vacuum_priority;
MCNUM radius = mccouter_cryostat_vacuum_radius;
MCNUM yheight = mccouter_cryostat_vacuum_yheight;
MCNUM visualize = mccouter_cryostat_vacuum_visualize;
int target_index = mccouter_cryostat_vacuum_target_index;
MCNUM target_x = mccouter_cryostat_vacuum_target_x;
MCNUM target_y = mccouter_cryostat_vacuum_target_y;
MCNUM target_z = mccouter_cryostat_vacuum_target_z;
MCNUM focus_aw = mccouter_cryostat_vacuum_focus_aw;
MCNUM focus_ah = mccouter_cryostat_vacuum_focus_ah;
MCNUM focus_xw = mccouter_cryostat_vacuum_focus_xw;
MCNUM focus_xh = mccouter_cryostat_vacuum_focus_xh;
MCNUM focus_r = mccouter_cryostat_vacuum_focus_r;
MCNUM p_interact = mccouter_cryostat_vacuum_p_interact;
char* mask_string = mccouter_cryostat_vacuum_mask_string;
char* mask_setting = mccouter_cryostat_vacuum_mask_setting;
MCNUM number_of_activations = mccouter_cryostat_vacuum_number_of_activations;
#line 345 "Union_cylinder.comp"
{
dummy = 1;
}
#line 348953 "MACS_sample_kidney_box.c"
}   /* End of outer_cryostat_vacuum=Union_cylinder() SETTING parameter declarations. */
#undef this_cylinder_storage
#undef global_geometry_element
#undef this_cylinder_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex
  /* Label for restoring  neutron */
  mcabsorbCompouter_cryostat_vacuum:
  if (RESTORE) /* restore if needed */
  { RESTORE_NEUTRON(29,
      mcnlx,
      mcnly,
      mcnlz,
      mcnlvx,
      mcnlvy,
      mcnlvz,
      mcnlt,
      mcnlsx,
      mcnlsy,
      mcnlsz,
      mcnlp); }
#undef mcabsorbComp
#undef p
#undef sz
#undef sy
#undef sx
#undef t
#undef vz
#undef vy
#undef vx
#undef z
#undef y
#undef x
  mcDEBUG_STATE(
mcnlx,
mcnly,
mcnlz,
mcnlvx,
mcnlvy,
mcnlvz,
mcnlt,
mcnlsx,
mcnlsy,
mcnlsz,
mcnlp)

  /* TRACE Component inner_cryostat_wall [30] */
  mccoordschange(mcposrinner_cryostat_wall, mcrotrinner_cryostat_wall,
    &mcnlx,
    &mcnly,
    &mcnlz,
    &mcnlvx,
    &mcnlvy,
    &mcnlvz,
    &mcnlsx,
    &mcnlsy,
    &mcnlsz);
  /* define label inside component inner_cryostat_wall (without coords transformations) */
  mcJumpTrace_inner_cryostat_wall:
  SIG_MESSAGE("inner_cryostat_wall (Trace)");
  mcDEBUG_COMP("inner_cryostat_wall")
  mcDEBUG_STATE(
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp)
#define x mcnlx
#define y mcnly
#define z mcnlz
#define vx mcnlvx
#define vy mcnlvy
#define vz mcnlvz
#define t mcnlt
#define sx mcnlsx
#define sy mcnlsy
#define sz mcnlsz
#define p mcnlp

#define mcabsorbComp mcabsorbCompinner_cryostat_wall
  STORE_NEUTRON(30,
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp);
  mcScattered=0;
  mcRestore=0;
  mcNCounter[30]++;
  mcPCounter[30] += p;
  mcP2Counter[30] += p*p;
#define mccompcurname  inner_cryostat_wall
#define mccompcurtype  Union_cylinder
#define mccompcurindex 30
#define loop_index mccinner_cryostat_wall_loop_index
#define this_cylinder_volume mccinner_cryostat_wall_this_cylinder_volume
#define global_geometry_element mccinner_cryostat_wall_global_geometry_element
#define this_cylinder_storage mccinner_cryostat_wall_this_cylinder_storage
{   /* Declarations of inner_cryostat_wall=Union_cylinder() SETTING parameters. */
char* material_string = mccinner_cryostat_wall_material_string;
MCNUM priority = mccinner_cryostat_wall_priority;
MCNUM radius = mccinner_cryostat_wall_radius;
MCNUM yheight = mccinner_cryostat_wall_yheight;
MCNUM visualize = mccinner_cryostat_wall_visualize;
int target_index = mccinner_cryostat_wall_target_index;
MCNUM target_x = mccinner_cryostat_wall_target_x;
MCNUM target_y = mccinner_cryostat_wall_target_y;
MCNUM target_z = mccinner_cryostat_wall_target_z;
MCNUM focus_aw = mccinner_cryostat_wall_focus_aw;
MCNUM focus_ah = mccinner_cryostat_wall_focus_ah;
MCNUM focus_xw = mccinner_cryostat_wall_focus_xw;
MCNUM focus_xh = mccinner_cryostat_wall_focus_xh;
MCNUM focus_r = mccinner_cryostat_wall_focus_r;
MCNUM p_interact = mccinner_cryostat_wall_p_interact;
char* mask_string = mccinner_cryostat_wall_mask_string;
char* mask_setting = mccinner_cryostat_wall_mask_setting;
MCNUM number_of_activations = mccinner_cryostat_wall_number_of_activations;
#line 345 "Union_cylinder.comp"
{
dummy = 1;
}
#line 349089 "MACS_sample_kidney_box.c"
}   /* End of inner_cryostat_wall=Union_cylinder() SETTING parameter declarations. */
#undef this_cylinder_storage
#undef global_geometry_element
#undef this_cylinder_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex
  /* Label for restoring  neutron */
  mcabsorbCompinner_cryostat_wall:
  if (RESTORE) /* restore if needed */
  { RESTORE_NEUTRON(30,
      mcnlx,
      mcnly,
      mcnlz,
      mcnlvx,
      mcnlvy,
      mcnlvz,
      mcnlt,
      mcnlsx,
      mcnlsy,
      mcnlsz,
      mcnlp); }
#undef mcabsorbComp
#undef p
#undef sz
#undef sy
#undef sx
#undef t
#undef vz
#undef vy
#undef vx
#undef z
#undef y
#undef x
  mcDEBUG_STATE(
mcnlx,
mcnly,
mcnlz,
mcnlvx,
mcnlvy,
mcnlvz,
mcnlt,
mcnlsx,
mcnlsy,
mcnlsz,
mcnlp)

  /* TRACE Component inner_cryostat_vacuum [31] */
  mccoordschange(mcposrinner_cryostat_vacuum, mcrotrinner_cryostat_vacuum,
    &mcnlx,
    &mcnly,
    &mcnlz,
    &mcnlvx,
    &mcnlvy,
    &mcnlvz,
    &mcnlsx,
    &mcnlsy,
    &mcnlsz);
  /* define label inside component inner_cryostat_vacuum (without coords transformations) */
  mcJumpTrace_inner_cryostat_vacuum:
  SIG_MESSAGE("inner_cryostat_vacuum (Trace)");
  mcDEBUG_COMP("inner_cryostat_vacuum")
  mcDEBUG_STATE(
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp)
#define x mcnlx
#define y mcnly
#define z mcnlz
#define vx mcnlvx
#define vy mcnlvy
#define vz mcnlvz
#define t mcnlt
#define sx mcnlsx
#define sy mcnlsy
#define sz mcnlsz
#define p mcnlp

#define mcabsorbComp mcabsorbCompinner_cryostat_vacuum
  STORE_NEUTRON(31,
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp);
  mcScattered=0;
  mcRestore=0;
  mcNCounter[31]++;
  mcPCounter[31] += p;
  mcP2Counter[31] += p*p;
#define mccompcurname  inner_cryostat_vacuum
#define mccompcurtype  Union_cylinder
#define mccompcurindex 31
#define loop_index mccinner_cryostat_vacuum_loop_index
#define this_cylinder_volume mccinner_cryostat_vacuum_this_cylinder_volume
#define global_geometry_element mccinner_cryostat_vacuum_global_geometry_element
#define this_cylinder_storage mccinner_cryostat_vacuum_this_cylinder_storage
{   /* Declarations of inner_cryostat_vacuum=Union_cylinder() SETTING parameters. */
char* material_string = mccinner_cryostat_vacuum_material_string;
MCNUM priority = mccinner_cryostat_vacuum_priority;
MCNUM radius = mccinner_cryostat_vacuum_radius;
MCNUM yheight = mccinner_cryostat_vacuum_yheight;
MCNUM visualize = mccinner_cryostat_vacuum_visualize;
int target_index = mccinner_cryostat_vacuum_target_index;
MCNUM target_x = mccinner_cryostat_vacuum_target_x;
MCNUM target_y = mccinner_cryostat_vacuum_target_y;
MCNUM target_z = mccinner_cryostat_vacuum_target_z;
MCNUM focus_aw = mccinner_cryostat_vacuum_focus_aw;
MCNUM focus_ah = mccinner_cryostat_vacuum_focus_ah;
MCNUM focus_xw = mccinner_cryostat_vacuum_focus_xw;
MCNUM focus_xh = mccinner_cryostat_vacuum_focus_xh;
MCNUM focus_r = mccinner_cryostat_vacuum_focus_r;
MCNUM p_interact = mccinner_cryostat_vacuum_p_interact;
char* mask_string = mccinner_cryostat_vacuum_mask_string;
char* mask_setting = mccinner_cryostat_vacuum_mask_setting;
MCNUM number_of_activations = mccinner_cryostat_vacuum_number_of_activations;
#line 345 "Union_cylinder.comp"
{
dummy = 1;
}
#line 349225 "MACS_sample_kidney_box.c"
}   /* End of inner_cryostat_vacuum=Union_cylinder() SETTING parameter declarations. */
#undef this_cylinder_storage
#undef global_geometry_element
#undef this_cylinder_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex
  /* Label for restoring  neutron */
  mcabsorbCompinner_cryostat_vacuum:
  if (RESTORE) /* restore if needed */
  { RESTORE_NEUTRON(31,
      mcnlx,
      mcnly,
      mcnlz,
      mcnlvx,
      mcnlvy,
      mcnlvz,
      mcnlt,
      mcnlsx,
      mcnlsy,
      mcnlsz,
      mcnlp); }
#undef mcabsorbComp
#undef p
#undef sz
#undef sy
#undef sx
#undef t
#undef vz
#undef vy
#undef vx
#undef z
#undef y
#undef x
  mcDEBUG_STATE(
mcnlx,
mcnly,
mcnlz,
mcnlvx,
mcnlvy,
mcnlvz,
mcnlt,
mcnlsx,
mcnlsy,
mcnlsz,
mcnlp)

  /* TRACE Component sample_stick_walls [32] */
  mccoordschange(mcposrsample_stick_walls, mcrotrsample_stick_walls,
    &mcnlx,
    &mcnly,
    &mcnlz,
    &mcnlvx,
    &mcnlvy,
    &mcnlvz,
    &mcnlsx,
    &mcnlsy,
    &mcnlsz);
  /* define label inside component sample_stick_walls (without coords transformations) */
  mcJumpTrace_sample_stick_walls:
  SIG_MESSAGE("sample_stick_walls (Trace)");
  mcDEBUG_COMP("sample_stick_walls")
  mcDEBUG_STATE(
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp)
#define x mcnlx
#define y mcnly
#define z mcnlz
#define vx mcnlvx
#define vy mcnlvy
#define vz mcnlvz
#define t mcnlt
#define sx mcnlsx
#define sy mcnlsy
#define sz mcnlsz
#define p mcnlp

#define mcabsorbComp mcabsorbCompsample_stick_walls
  STORE_NEUTRON(32,
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp);
  mcScattered=0;
  mcRestore=0;
  mcNCounter[32]++;
  mcPCounter[32] += p;
  mcP2Counter[32] += p*p;
#define mccompcurname  sample_stick_walls
#define mccompcurtype  Union_cylinder
#define mccompcurindex 32
#define loop_index mccsample_stick_walls_loop_index
#define this_cylinder_volume mccsample_stick_walls_this_cylinder_volume
#define global_geometry_element mccsample_stick_walls_global_geometry_element
#define this_cylinder_storage mccsample_stick_walls_this_cylinder_storage
{   /* Declarations of sample_stick_walls=Union_cylinder() SETTING parameters. */
char* material_string = mccsample_stick_walls_material_string;
MCNUM priority = mccsample_stick_walls_priority;
MCNUM radius = mccsample_stick_walls_radius;
MCNUM yheight = mccsample_stick_walls_yheight;
MCNUM visualize = mccsample_stick_walls_visualize;
int target_index = mccsample_stick_walls_target_index;
MCNUM target_x = mccsample_stick_walls_target_x;
MCNUM target_y = mccsample_stick_walls_target_y;
MCNUM target_z = mccsample_stick_walls_target_z;
MCNUM focus_aw = mccsample_stick_walls_focus_aw;
MCNUM focus_ah = mccsample_stick_walls_focus_ah;
MCNUM focus_xw = mccsample_stick_walls_focus_xw;
MCNUM focus_xh = mccsample_stick_walls_focus_xh;
MCNUM focus_r = mccsample_stick_walls_focus_r;
MCNUM p_interact = mccsample_stick_walls_p_interact;
char* mask_string = mccsample_stick_walls_mask_string;
char* mask_setting = mccsample_stick_walls_mask_setting;
MCNUM number_of_activations = mccsample_stick_walls_number_of_activations;
#line 345 "Union_cylinder.comp"
{
dummy = 1;
}
#line 349361 "MACS_sample_kidney_box.c"
}   /* End of sample_stick_walls=Union_cylinder() SETTING parameter declarations. */
#undef this_cylinder_storage
#undef global_geometry_element
#undef this_cylinder_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex
  /* Label for restoring  neutron */
  mcabsorbCompsample_stick_walls:
  if (RESTORE) /* restore if needed */
  { RESTORE_NEUTRON(32,
      mcnlx,
      mcnly,
      mcnlz,
      mcnlvx,
      mcnlvy,
      mcnlvz,
      mcnlt,
      mcnlsx,
      mcnlsy,
      mcnlsz,
      mcnlp); }
#undef mcabsorbComp
#undef p
#undef sz
#undef sy
#undef sx
#undef t
#undef vz
#undef vy
#undef vx
#undef z
#undef y
#undef x
  mcDEBUG_STATE(
mcnlx,
mcnly,
mcnlz,
mcnlvx,
mcnlvy,
mcnlvz,
mcnlt,
mcnlsx,
mcnlsy,
mcnlsz,
mcnlp)

  /* TRACE Component sample_stick_vacuum [33] */
  mccoordschange(mcposrsample_stick_vacuum, mcrotrsample_stick_vacuum,
    &mcnlx,
    &mcnly,
    &mcnlz,
    &mcnlvx,
    &mcnlvy,
    &mcnlvz,
    &mcnlsx,
    &mcnlsy,
    &mcnlsz);
  /* define label inside component sample_stick_vacuum (without coords transformations) */
  mcJumpTrace_sample_stick_vacuum:
  SIG_MESSAGE("sample_stick_vacuum (Trace)");
  mcDEBUG_COMP("sample_stick_vacuum")
  mcDEBUG_STATE(
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp)
#define x mcnlx
#define y mcnly
#define z mcnlz
#define vx mcnlvx
#define vy mcnlvy
#define vz mcnlvz
#define t mcnlt
#define sx mcnlsx
#define sy mcnlsy
#define sz mcnlsz
#define p mcnlp

#define mcabsorbComp mcabsorbCompsample_stick_vacuum
  STORE_NEUTRON(33,
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp);
  mcScattered=0;
  mcRestore=0;
  mcNCounter[33]++;
  mcPCounter[33] += p;
  mcP2Counter[33] += p*p;
#define mccompcurname  sample_stick_vacuum
#define mccompcurtype  Union_cylinder
#define mccompcurindex 33
#define loop_index mccsample_stick_vacuum_loop_index
#define this_cylinder_volume mccsample_stick_vacuum_this_cylinder_volume
#define global_geometry_element mccsample_stick_vacuum_global_geometry_element
#define this_cylinder_storage mccsample_stick_vacuum_this_cylinder_storage
{   /* Declarations of sample_stick_vacuum=Union_cylinder() SETTING parameters. */
char* material_string = mccsample_stick_vacuum_material_string;
MCNUM priority = mccsample_stick_vacuum_priority;
MCNUM radius = mccsample_stick_vacuum_radius;
MCNUM yheight = mccsample_stick_vacuum_yheight;
MCNUM visualize = mccsample_stick_vacuum_visualize;
int target_index = mccsample_stick_vacuum_target_index;
MCNUM target_x = mccsample_stick_vacuum_target_x;
MCNUM target_y = mccsample_stick_vacuum_target_y;
MCNUM target_z = mccsample_stick_vacuum_target_z;
MCNUM focus_aw = mccsample_stick_vacuum_focus_aw;
MCNUM focus_ah = mccsample_stick_vacuum_focus_ah;
MCNUM focus_xw = mccsample_stick_vacuum_focus_xw;
MCNUM focus_xh = mccsample_stick_vacuum_focus_xh;
MCNUM focus_r = mccsample_stick_vacuum_focus_r;
MCNUM p_interact = mccsample_stick_vacuum_p_interact;
char* mask_string = mccsample_stick_vacuum_mask_string;
char* mask_setting = mccsample_stick_vacuum_mask_setting;
MCNUM number_of_activations = mccsample_stick_vacuum_number_of_activations;
#line 345 "Union_cylinder.comp"
{
dummy = 1;
}
#line 349497 "MACS_sample_kidney_box.c"
}   /* End of sample_stick_vacuum=Union_cylinder() SETTING parameter declarations. */
#undef this_cylinder_storage
#undef global_geometry_element
#undef this_cylinder_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex
  /* Label for restoring  neutron */
  mcabsorbCompsample_stick_vacuum:
  if (RESTORE) /* restore if needed */
  { RESTORE_NEUTRON(33,
      mcnlx,
      mcnly,
      mcnlz,
      mcnlvx,
      mcnlvy,
      mcnlvz,
      mcnlt,
      mcnlsx,
      mcnlsy,
      mcnlsz,
      mcnlp); }
#undef mcabsorbComp
#undef p
#undef sz
#undef sy
#undef sx
#undef t
#undef vz
#undef vy
#undef vx
#undef z
#undef y
#undef x
  mcDEBUG_STATE(
mcnlx,
mcnly,
mcnlz,
mcnlvx,
mcnlvy,
mcnlvz,
mcnlt,
mcnlsx,
mcnlsy,
mcnlsz,
mcnlp)

  /* TRACE Component sample_rod_bottom [34] */
  mccoordschange(mcposrsample_rod_bottom, mcrotrsample_rod_bottom,
    &mcnlx,
    &mcnly,
    &mcnlz,
    &mcnlvx,
    &mcnlvy,
    &mcnlvz,
    &mcnlsx,
    &mcnlsy,
    &mcnlsz);
  /* define label inside component sample_rod_bottom (without coords transformations) */
  mcJumpTrace_sample_rod_bottom:
  SIG_MESSAGE("sample_rod_bottom (Trace)");
  mcDEBUG_COMP("sample_rod_bottom")
  mcDEBUG_STATE(
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp)
#define x mcnlx
#define y mcnly
#define z mcnlz
#define vx mcnlvx
#define vy mcnlvy
#define vz mcnlvz
#define t mcnlt
#define sx mcnlsx
#define sy mcnlsy
#define sz mcnlsz
#define p mcnlp

#define mcabsorbComp mcabsorbCompsample_rod_bottom
  STORE_NEUTRON(34,
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp);
  mcScattered=0;
  mcRestore=0;
  mcNCounter[34]++;
  mcPCounter[34] += p;
  mcP2Counter[34] += p*p;
#define mccompcurname  sample_rod_bottom
#define mccompcurtype  Arm
#define mccompcurindex 34
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex
  /* Label for restoring  neutron */
  mcabsorbCompsample_rod_bottom:
  if (RESTORE) /* restore if needed */
  { RESTORE_NEUTRON(34,
      mcnlx,
      mcnly,
      mcnlz,
      mcnlvx,
      mcnlvy,
      mcnlvz,
      mcnlt,
      mcnlsx,
      mcnlsy,
      mcnlsz,
      mcnlp); }
#undef mcabsorbComp
#undef p
#undef sz
#undef sy
#undef sx
#undef t
#undef vz
#undef vy
#undef vx
#undef z
#undef y
#undef x
  mcDEBUG_STATE(
mcnlx,
mcnly,
mcnlz,
mcnlvx,
mcnlvy,
mcnlvz,
mcnlt,
mcnlsx,
mcnlsy,
mcnlsz,
mcnlp)

  /* TRACE Component sample_rod [35] */
  mccoordschange(mcposrsample_rod, mcrotrsample_rod,
    &mcnlx,
    &mcnly,
    &mcnlz,
    &mcnlvx,
    &mcnlvy,
    &mcnlvz,
    &mcnlsx,
    &mcnlsy,
    &mcnlsz);
  /* define label inside component sample_rod (without coords transformations) */
  mcJumpTrace_sample_rod:
  SIG_MESSAGE("sample_rod (Trace)");
  mcDEBUG_COMP("sample_rod")
  mcDEBUG_STATE(
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp)
#define x mcnlx
#define y mcnly
#define z mcnlz
#define vx mcnlvx
#define vy mcnlvy
#define vz mcnlvz
#define t mcnlt
#define sx mcnlsx
#define sy mcnlsy
#define sz mcnlsz
#define p mcnlp

#define mcabsorbComp mcabsorbCompsample_rod
  STORE_NEUTRON(35,
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp);
  mcScattered=0;
  mcRestore=0;
  mcNCounter[35]++;
  mcPCounter[35] += p;
  mcP2Counter[35] += p*p;
#define mccompcurname  sample_rod
#define mccompcurtype  Union_cylinder
#define mccompcurindex 35
#define loop_index mccsample_rod_loop_index
#define this_cylinder_volume mccsample_rod_this_cylinder_volume
#define global_geometry_element mccsample_rod_global_geometry_element
#define this_cylinder_storage mccsample_rod_this_cylinder_storage
{   /* Declarations of sample_rod=Union_cylinder() SETTING parameters. */
char* material_string = mccsample_rod_material_string;
MCNUM priority = mccsample_rod_priority;
MCNUM radius = mccsample_rod_radius;
MCNUM yheight = mccsample_rod_yheight;
MCNUM visualize = mccsample_rod_visualize;
int target_index = mccsample_rod_target_index;
MCNUM target_x = mccsample_rod_target_x;
MCNUM target_y = mccsample_rod_target_y;
MCNUM target_z = mccsample_rod_target_z;
MCNUM focus_aw = mccsample_rod_focus_aw;
MCNUM focus_ah = mccsample_rod_focus_ah;
MCNUM focus_xw = mccsample_rod_focus_xw;
MCNUM focus_xh = mccsample_rod_focus_xh;
MCNUM focus_r = mccsample_rod_focus_r;
MCNUM p_interact = mccsample_rod_p_interact;
char* mask_string = mccsample_rod_mask_string;
char* mask_setting = mccsample_rod_mask_setting;
MCNUM number_of_activations = mccsample_rod_number_of_activations;
#line 345 "Union_cylinder.comp"
{
dummy = 1;
}
#line 349736 "MACS_sample_kidney_box.c"
}   /* End of sample_rod=Union_cylinder() SETTING parameter declarations. */
#undef this_cylinder_storage
#undef global_geometry_element
#undef this_cylinder_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex
  /* Label for restoring  neutron */
  mcabsorbCompsample_rod:
  if (RESTORE) /* restore if needed */
  { RESTORE_NEUTRON(35,
      mcnlx,
      mcnly,
      mcnlz,
      mcnlvx,
      mcnlvy,
      mcnlvz,
      mcnlt,
      mcnlsx,
      mcnlsy,
      mcnlsz,
      mcnlp); }
#undef mcabsorbComp
#undef p
#undef sz
#undef sy
#undef sx
#undef t
#undef vz
#undef vy
#undef vx
#undef z
#undef y
#undef x
  mcDEBUG_STATE(
mcnlx,
mcnly,
mcnlz,
mcnlvx,
mcnlvy,
mcnlvz,
mcnlt,
mcnlsx,
mcnlsy,
mcnlsz,
mcnlp)

  /* TRACE Component sample_rod_collar_1 [36] */
  mccoordschange(mcposrsample_rod_collar_1, mcrotrsample_rod_collar_1,
    &mcnlx,
    &mcnly,
    &mcnlz,
    &mcnlvx,
    &mcnlvy,
    &mcnlvz,
    &mcnlsx,
    &mcnlsy,
    &mcnlsz);
  /* define label inside component sample_rod_collar_1 (without coords transformations) */
  mcJumpTrace_sample_rod_collar_1:
  SIG_MESSAGE("sample_rod_collar_1 (Trace)");
  mcDEBUG_COMP("sample_rod_collar_1")
  mcDEBUG_STATE(
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp)
#define x mcnlx
#define y mcnly
#define z mcnlz
#define vx mcnlvx
#define vy mcnlvy
#define vz mcnlvz
#define t mcnlt
#define sx mcnlsx
#define sy mcnlsy
#define sz mcnlsz
#define p mcnlp

#define mcabsorbComp mcabsorbCompsample_rod_collar_1
  STORE_NEUTRON(36,
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp);
  mcScattered=0;
  mcRestore=0;
  mcNCounter[36]++;
  mcPCounter[36] += p;
  mcP2Counter[36] += p*p;
#define mccompcurname  sample_rod_collar_1
#define mccompcurtype  Union_cylinder
#define mccompcurindex 36
#define loop_index mccsample_rod_collar_1_loop_index
#define this_cylinder_volume mccsample_rod_collar_1_this_cylinder_volume
#define global_geometry_element mccsample_rod_collar_1_global_geometry_element
#define this_cylinder_storage mccsample_rod_collar_1_this_cylinder_storage
{   /* Declarations of sample_rod_collar_1=Union_cylinder() SETTING parameters. */
char* material_string = mccsample_rod_collar_1_material_string;
MCNUM priority = mccsample_rod_collar_1_priority;
MCNUM radius = mccsample_rod_collar_1_radius;
MCNUM yheight = mccsample_rod_collar_1_yheight;
MCNUM visualize = mccsample_rod_collar_1_visualize;
int target_index = mccsample_rod_collar_1_target_index;
MCNUM target_x = mccsample_rod_collar_1_target_x;
MCNUM target_y = mccsample_rod_collar_1_target_y;
MCNUM target_z = mccsample_rod_collar_1_target_z;
MCNUM focus_aw = mccsample_rod_collar_1_focus_aw;
MCNUM focus_ah = mccsample_rod_collar_1_focus_ah;
MCNUM focus_xw = mccsample_rod_collar_1_focus_xw;
MCNUM focus_xh = mccsample_rod_collar_1_focus_xh;
MCNUM focus_r = mccsample_rod_collar_1_focus_r;
MCNUM p_interact = mccsample_rod_collar_1_p_interact;
char* mask_string = mccsample_rod_collar_1_mask_string;
char* mask_setting = mccsample_rod_collar_1_mask_setting;
MCNUM number_of_activations = mccsample_rod_collar_1_number_of_activations;
#line 345 "Union_cylinder.comp"
{
dummy = 1;
}
#line 349872 "MACS_sample_kidney_box.c"
}   /* End of sample_rod_collar_1=Union_cylinder() SETTING parameter declarations. */
#undef this_cylinder_storage
#undef global_geometry_element
#undef this_cylinder_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex
  /* Label for restoring  neutron */
  mcabsorbCompsample_rod_collar_1:
  if (RESTORE) /* restore if needed */
  { RESTORE_NEUTRON(36,
      mcnlx,
      mcnly,
      mcnlz,
      mcnlvx,
      mcnlvy,
      mcnlvz,
      mcnlt,
      mcnlsx,
      mcnlsy,
      mcnlsz,
      mcnlp); }
#undef mcabsorbComp
#undef p
#undef sz
#undef sy
#undef sx
#undef t
#undef vz
#undef vy
#undef vx
#undef z
#undef y
#undef x
  mcDEBUG_STATE(
mcnlx,
mcnly,
mcnlz,
mcnlvx,
mcnlvy,
mcnlvz,
mcnlt,
mcnlsx,
mcnlsy,
mcnlsz,
mcnlp)

  /* TRACE Component sample_rod_collar_2 [37] */
  mccoordschange(mcposrsample_rod_collar_2, mcrotrsample_rod_collar_2,
    &mcnlx,
    &mcnly,
    &mcnlz,
    &mcnlvx,
    &mcnlvy,
    &mcnlvz,
    &mcnlsx,
    &mcnlsy,
    &mcnlsz);
  /* define label inside component sample_rod_collar_2 (without coords transformations) */
  mcJumpTrace_sample_rod_collar_2:
  SIG_MESSAGE("sample_rod_collar_2 (Trace)");
  mcDEBUG_COMP("sample_rod_collar_2")
  mcDEBUG_STATE(
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp)
#define x mcnlx
#define y mcnly
#define z mcnlz
#define vx mcnlvx
#define vy mcnlvy
#define vz mcnlvz
#define t mcnlt
#define sx mcnlsx
#define sy mcnlsy
#define sz mcnlsz
#define p mcnlp

#define mcabsorbComp mcabsorbCompsample_rod_collar_2
  STORE_NEUTRON(37,
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp);
  mcScattered=0;
  mcRestore=0;
  mcNCounter[37]++;
  mcPCounter[37] += p;
  mcP2Counter[37] += p*p;
#define mccompcurname  sample_rod_collar_2
#define mccompcurtype  Union_cylinder
#define mccompcurindex 37
#define loop_index mccsample_rod_collar_2_loop_index
#define this_cylinder_volume mccsample_rod_collar_2_this_cylinder_volume
#define global_geometry_element mccsample_rod_collar_2_global_geometry_element
#define this_cylinder_storage mccsample_rod_collar_2_this_cylinder_storage
{   /* Declarations of sample_rod_collar_2=Union_cylinder() SETTING parameters. */
char* material_string = mccsample_rod_collar_2_material_string;
MCNUM priority = mccsample_rod_collar_2_priority;
MCNUM radius = mccsample_rod_collar_2_radius;
MCNUM yheight = mccsample_rod_collar_2_yheight;
MCNUM visualize = mccsample_rod_collar_2_visualize;
int target_index = mccsample_rod_collar_2_target_index;
MCNUM target_x = mccsample_rod_collar_2_target_x;
MCNUM target_y = mccsample_rod_collar_2_target_y;
MCNUM target_z = mccsample_rod_collar_2_target_z;
MCNUM focus_aw = mccsample_rod_collar_2_focus_aw;
MCNUM focus_ah = mccsample_rod_collar_2_focus_ah;
MCNUM focus_xw = mccsample_rod_collar_2_focus_xw;
MCNUM focus_xh = mccsample_rod_collar_2_focus_xh;
MCNUM focus_r = mccsample_rod_collar_2_focus_r;
MCNUM p_interact = mccsample_rod_collar_2_p_interact;
char* mask_string = mccsample_rod_collar_2_mask_string;
char* mask_setting = mccsample_rod_collar_2_mask_setting;
MCNUM number_of_activations = mccsample_rod_collar_2_number_of_activations;
#line 345 "Union_cylinder.comp"
{
dummy = 1;
}
#line 350008 "MACS_sample_kidney_box.c"
}   /* End of sample_rod_collar_2=Union_cylinder() SETTING parameter declarations. */
#undef this_cylinder_storage
#undef global_geometry_element
#undef this_cylinder_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex
  /* Label for restoring  neutron */
  mcabsorbCompsample_rod_collar_2:
  if (RESTORE) /* restore if needed */
  { RESTORE_NEUTRON(37,
      mcnlx,
      mcnly,
      mcnlz,
      mcnlvx,
      mcnlvy,
      mcnlvz,
      mcnlt,
      mcnlsx,
      mcnlsy,
      mcnlsz,
      mcnlp); }
#undef mcabsorbComp
#undef p
#undef sz
#undef sy
#undef sx
#undef t
#undef vz
#undef vy
#undef vx
#undef z
#undef y
#undef x
  mcDEBUG_STATE(
mcnlx,
mcnly,
mcnlz,
mcnlvx,
mcnlvy,
mcnlvz,
mcnlt,
mcnlsx,
mcnlsy,
mcnlsz,
mcnlp)

  /* TRACE Component sample_rod_collar_3 [38] */
  mccoordschange(mcposrsample_rod_collar_3, mcrotrsample_rod_collar_3,
    &mcnlx,
    &mcnly,
    &mcnlz,
    &mcnlvx,
    &mcnlvy,
    &mcnlvz,
    &mcnlsx,
    &mcnlsy,
    &mcnlsz);
  /* define label inside component sample_rod_collar_3 (without coords transformations) */
  mcJumpTrace_sample_rod_collar_3:
  SIG_MESSAGE("sample_rod_collar_3 (Trace)");
  mcDEBUG_COMP("sample_rod_collar_3")
  mcDEBUG_STATE(
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp)
#define x mcnlx
#define y mcnly
#define z mcnlz
#define vx mcnlvx
#define vy mcnlvy
#define vz mcnlvz
#define t mcnlt
#define sx mcnlsx
#define sy mcnlsy
#define sz mcnlsz
#define p mcnlp

#define mcabsorbComp mcabsorbCompsample_rod_collar_3
  STORE_NEUTRON(38,
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp);
  mcScattered=0;
  mcRestore=0;
  mcNCounter[38]++;
  mcPCounter[38] += p;
  mcP2Counter[38] += p*p;
#define mccompcurname  sample_rod_collar_3
#define mccompcurtype  Union_cylinder
#define mccompcurindex 38
#define loop_index mccsample_rod_collar_3_loop_index
#define this_cylinder_volume mccsample_rod_collar_3_this_cylinder_volume
#define global_geometry_element mccsample_rod_collar_3_global_geometry_element
#define this_cylinder_storage mccsample_rod_collar_3_this_cylinder_storage
{   /* Declarations of sample_rod_collar_3=Union_cylinder() SETTING parameters. */
char* material_string = mccsample_rod_collar_3_material_string;
MCNUM priority = mccsample_rod_collar_3_priority;
MCNUM radius = mccsample_rod_collar_3_radius;
MCNUM yheight = mccsample_rod_collar_3_yheight;
MCNUM visualize = mccsample_rod_collar_3_visualize;
int target_index = mccsample_rod_collar_3_target_index;
MCNUM target_x = mccsample_rod_collar_3_target_x;
MCNUM target_y = mccsample_rod_collar_3_target_y;
MCNUM target_z = mccsample_rod_collar_3_target_z;
MCNUM focus_aw = mccsample_rod_collar_3_focus_aw;
MCNUM focus_ah = mccsample_rod_collar_3_focus_ah;
MCNUM focus_xw = mccsample_rod_collar_3_focus_xw;
MCNUM focus_xh = mccsample_rod_collar_3_focus_xh;
MCNUM focus_r = mccsample_rod_collar_3_focus_r;
MCNUM p_interact = mccsample_rod_collar_3_p_interact;
char* mask_string = mccsample_rod_collar_3_mask_string;
char* mask_setting = mccsample_rod_collar_3_mask_setting;
MCNUM number_of_activations = mccsample_rod_collar_3_number_of_activations;
#line 345 "Union_cylinder.comp"
{
dummy = 1;
}
#line 350144 "MACS_sample_kidney_box.c"
}   /* End of sample_rod_collar_3=Union_cylinder() SETTING parameter declarations. */
#undef this_cylinder_storage
#undef global_geometry_element
#undef this_cylinder_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex
  /* Label for restoring  neutron */
  mcabsorbCompsample_rod_collar_3:
  if (RESTORE) /* restore if needed */
  { RESTORE_NEUTRON(38,
      mcnlx,
      mcnly,
      mcnlz,
      mcnlvx,
      mcnlvy,
      mcnlvz,
      mcnlt,
      mcnlsx,
      mcnlsy,
      mcnlsz,
      mcnlp); }
#undef mcabsorbComp
#undef p
#undef sz
#undef sy
#undef sx
#undef t
#undef vz
#undef vy
#undef vx
#undef z
#undef y
#undef x
  mcDEBUG_STATE(
mcnlx,
mcnly,
mcnlz,
mcnlvx,
mcnlvy,
mcnlvz,
mcnlt,
mcnlsx,
mcnlsy,
mcnlsz,
mcnlp)

  /* TRACE Component sample_rod_collar_4 [39] */
  mccoordschange(mcposrsample_rod_collar_4, mcrotrsample_rod_collar_4,
    &mcnlx,
    &mcnly,
    &mcnlz,
    &mcnlvx,
    &mcnlvy,
    &mcnlvz,
    &mcnlsx,
    &mcnlsy,
    &mcnlsz);
  /* define label inside component sample_rod_collar_4 (without coords transformations) */
  mcJumpTrace_sample_rod_collar_4:
  SIG_MESSAGE("sample_rod_collar_4 (Trace)");
  mcDEBUG_COMP("sample_rod_collar_4")
  mcDEBUG_STATE(
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp)
#define x mcnlx
#define y mcnly
#define z mcnlz
#define vx mcnlvx
#define vy mcnlvy
#define vz mcnlvz
#define t mcnlt
#define sx mcnlsx
#define sy mcnlsy
#define sz mcnlsz
#define p mcnlp

#define mcabsorbComp mcabsorbCompsample_rod_collar_4
  STORE_NEUTRON(39,
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp);
  mcScattered=0;
  mcRestore=0;
  mcNCounter[39]++;
  mcPCounter[39] += p;
  mcP2Counter[39] += p*p;
#define mccompcurname  sample_rod_collar_4
#define mccompcurtype  Union_cylinder
#define mccompcurindex 39
#define loop_index mccsample_rod_collar_4_loop_index
#define this_cylinder_volume mccsample_rod_collar_4_this_cylinder_volume
#define global_geometry_element mccsample_rod_collar_4_global_geometry_element
#define this_cylinder_storage mccsample_rod_collar_4_this_cylinder_storage
{   /* Declarations of sample_rod_collar_4=Union_cylinder() SETTING parameters. */
char* material_string = mccsample_rod_collar_4_material_string;
MCNUM priority = mccsample_rod_collar_4_priority;
MCNUM radius = mccsample_rod_collar_4_radius;
MCNUM yheight = mccsample_rod_collar_4_yheight;
MCNUM visualize = mccsample_rod_collar_4_visualize;
int target_index = mccsample_rod_collar_4_target_index;
MCNUM target_x = mccsample_rod_collar_4_target_x;
MCNUM target_y = mccsample_rod_collar_4_target_y;
MCNUM target_z = mccsample_rod_collar_4_target_z;
MCNUM focus_aw = mccsample_rod_collar_4_focus_aw;
MCNUM focus_ah = mccsample_rod_collar_4_focus_ah;
MCNUM focus_xw = mccsample_rod_collar_4_focus_xw;
MCNUM focus_xh = mccsample_rod_collar_4_focus_xh;
MCNUM focus_r = mccsample_rod_collar_4_focus_r;
MCNUM p_interact = mccsample_rod_collar_4_p_interact;
char* mask_string = mccsample_rod_collar_4_mask_string;
char* mask_setting = mccsample_rod_collar_4_mask_setting;
MCNUM number_of_activations = mccsample_rod_collar_4_number_of_activations;
#line 345 "Union_cylinder.comp"
{
dummy = 1;
}
#line 350280 "MACS_sample_kidney_box.c"
}   /* End of sample_rod_collar_4=Union_cylinder() SETTING parameter declarations. */
#undef this_cylinder_storage
#undef global_geometry_element
#undef this_cylinder_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex
  /* Label for restoring  neutron */
  mcabsorbCompsample_rod_collar_4:
  if (RESTORE) /* restore if needed */
  { RESTORE_NEUTRON(39,
      mcnlx,
      mcnly,
      mcnlz,
      mcnlvx,
      mcnlvy,
      mcnlvz,
      mcnlt,
      mcnlsx,
      mcnlsy,
      mcnlsz,
      mcnlp); }
#undef mcabsorbComp
#undef p
#undef sz
#undef sy
#undef sx
#undef t
#undef vz
#undef vy
#undef vx
#undef z
#undef y
#undef x
  mcDEBUG_STATE(
mcnlx,
mcnly,
mcnlz,
mcnlvx,
mcnlvy,
mcnlvz,
mcnlt,
mcnlsx,
mcnlsy,
mcnlsz,
mcnlp)

  /* TRACE Component sample_rod_collar_1_vacuum [40] */
  mccoordschange(mcposrsample_rod_collar_1_vacuum, mcrotrsample_rod_collar_1_vacuum,
    &mcnlx,
    &mcnly,
    &mcnlz,
    &mcnlvx,
    &mcnlvy,
    &mcnlvz,
    &mcnlsx,
    &mcnlsy,
    &mcnlsz);
  /* define label inside component sample_rod_collar_1_vacuum (without coords transformations) */
  mcJumpTrace_sample_rod_collar_1_vacuum:
  SIG_MESSAGE("sample_rod_collar_1_vacuum (Trace)");
  mcDEBUG_COMP("sample_rod_collar_1_vacuum")
  mcDEBUG_STATE(
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp)
#define x mcnlx
#define y mcnly
#define z mcnlz
#define vx mcnlvx
#define vy mcnlvy
#define vz mcnlvz
#define t mcnlt
#define sx mcnlsx
#define sy mcnlsy
#define sz mcnlsz
#define p mcnlp

#define mcabsorbComp mcabsorbCompsample_rod_collar_1_vacuum
  STORE_NEUTRON(40,
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp);
  mcScattered=0;
  mcRestore=0;
  mcNCounter[40]++;
  mcPCounter[40] += p;
  mcP2Counter[40] += p*p;
#define mccompcurname  sample_rod_collar_1_vacuum
#define mccompcurtype  Union_cylinder
#define mccompcurindex 40
#define loop_index mccsample_rod_collar_1_vacuum_loop_index
#define this_cylinder_volume mccsample_rod_collar_1_vacuum_this_cylinder_volume
#define global_geometry_element mccsample_rod_collar_1_vacuum_global_geometry_element
#define this_cylinder_storage mccsample_rod_collar_1_vacuum_this_cylinder_storage
{   /* Declarations of sample_rod_collar_1_vacuum=Union_cylinder() SETTING parameters. */
char* material_string = mccsample_rod_collar_1_vacuum_material_string;
MCNUM priority = mccsample_rod_collar_1_vacuum_priority;
MCNUM radius = mccsample_rod_collar_1_vacuum_radius;
MCNUM yheight = mccsample_rod_collar_1_vacuum_yheight;
MCNUM visualize = mccsample_rod_collar_1_vacuum_visualize;
int target_index = mccsample_rod_collar_1_vacuum_target_index;
MCNUM target_x = mccsample_rod_collar_1_vacuum_target_x;
MCNUM target_y = mccsample_rod_collar_1_vacuum_target_y;
MCNUM target_z = mccsample_rod_collar_1_vacuum_target_z;
MCNUM focus_aw = mccsample_rod_collar_1_vacuum_focus_aw;
MCNUM focus_ah = mccsample_rod_collar_1_vacuum_focus_ah;
MCNUM focus_xw = mccsample_rod_collar_1_vacuum_focus_xw;
MCNUM focus_xh = mccsample_rod_collar_1_vacuum_focus_xh;
MCNUM focus_r = mccsample_rod_collar_1_vacuum_focus_r;
MCNUM p_interact = mccsample_rod_collar_1_vacuum_p_interact;
char* mask_string = mccsample_rod_collar_1_vacuum_mask_string;
char* mask_setting = mccsample_rod_collar_1_vacuum_mask_setting;
MCNUM number_of_activations = mccsample_rod_collar_1_vacuum_number_of_activations;
#line 345 "Union_cylinder.comp"
{
dummy = 1;
}
#line 350416 "MACS_sample_kidney_box.c"
}   /* End of sample_rod_collar_1_vacuum=Union_cylinder() SETTING parameter declarations. */
#undef this_cylinder_storage
#undef global_geometry_element
#undef this_cylinder_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex
  /* Label for restoring  neutron */
  mcabsorbCompsample_rod_collar_1_vacuum:
  if (RESTORE) /* restore if needed */
  { RESTORE_NEUTRON(40,
      mcnlx,
      mcnly,
      mcnlz,
      mcnlvx,
      mcnlvy,
      mcnlvz,
      mcnlt,
      mcnlsx,
      mcnlsy,
      mcnlsz,
      mcnlp); }
#undef mcabsorbComp
#undef p
#undef sz
#undef sy
#undef sx
#undef t
#undef vz
#undef vy
#undef vx
#undef z
#undef y
#undef x
  mcDEBUG_STATE(
mcnlx,
mcnly,
mcnlz,
mcnlvx,
mcnlvy,
mcnlvz,
mcnlt,
mcnlsx,
mcnlsy,
mcnlsz,
mcnlp)

  /* TRACE Component sample_rod_collar_2_vacuum [41] */
  mccoordschange(mcposrsample_rod_collar_2_vacuum, mcrotrsample_rod_collar_2_vacuum,
    &mcnlx,
    &mcnly,
    &mcnlz,
    &mcnlvx,
    &mcnlvy,
    &mcnlvz,
    &mcnlsx,
    &mcnlsy,
    &mcnlsz);
  /* define label inside component sample_rod_collar_2_vacuum (without coords transformations) */
  mcJumpTrace_sample_rod_collar_2_vacuum:
  SIG_MESSAGE("sample_rod_collar_2_vacuum (Trace)");
  mcDEBUG_COMP("sample_rod_collar_2_vacuum")
  mcDEBUG_STATE(
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp)
#define x mcnlx
#define y mcnly
#define z mcnlz
#define vx mcnlvx
#define vy mcnlvy
#define vz mcnlvz
#define t mcnlt
#define sx mcnlsx
#define sy mcnlsy
#define sz mcnlsz
#define p mcnlp

#define mcabsorbComp mcabsorbCompsample_rod_collar_2_vacuum
  STORE_NEUTRON(41,
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp);
  mcScattered=0;
  mcRestore=0;
  mcNCounter[41]++;
  mcPCounter[41] += p;
  mcP2Counter[41] += p*p;
#define mccompcurname  sample_rod_collar_2_vacuum
#define mccompcurtype  Union_cylinder
#define mccompcurindex 41
#define loop_index mccsample_rod_collar_2_vacuum_loop_index
#define this_cylinder_volume mccsample_rod_collar_2_vacuum_this_cylinder_volume
#define global_geometry_element mccsample_rod_collar_2_vacuum_global_geometry_element
#define this_cylinder_storage mccsample_rod_collar_2_vacuum_this_cylinder_storage
{   /* Declarations of sample_rod_collar_2_vacuum=Union_cylinder() SETTING parameters. */
char* material_string = mccsample_rod_collar_2_vacuum_material_string;
MCNUM priority = mccsample_rod_collar_2_vacuum_priority;
MCNUM radius = mccsample_rod_collar_2_vacuum_radius;
MCNUM yheight = mccsample_rod_collar_2_vacuum_yheight;
MCNUM visualize = mccsample_rod_collar_2_vacuum_visualize;
int target_index = mccsample_rod_collar_2_vacuum_target_index;
MCNUM target_x = mccsample_rod_collar_2_vacuum_target_x;
MCNUM target_y = mccsample_rod_collar_2_vacuum_target_y;
MCNUM target_z = mccsample_rod_collar_2_vacuum_target_z;
MCNUM focus_aw = mccsample_rod_collar_2_vacuum_focus_aw;
MCNUM focus_ah = mccsample_rod_collar_2_vacuum_focus_ah;
MCNUM focus_xw = mccsample_rod_collar_2_vacuum_focus_xw;
MCNUM focus_xh = mccsample_rod_collar_2_vacuum_focus_xh;
MCNUM focus_r = mccsample_rod_collar_2_vacuum_focus_r;
MCNUM p_interact = mccsample_rod_collar_2_vacuum_p_interact;
char* mask_string = mccsample_rod_collar_2_vacuum_mask_string;
char* mask_setting = mccsample_rod_collar_2_vacuum_mask_setting;
MCNUM number_of_activations = mccsample_rod_collar_2_vacuum_number_of_activations;
#line 345 "Union_cylinder.comp"
{
dummy = 1;
}
#line 350552 "MACS_sample_kidney_box.c"
}   /* End of sample_rod_collar_2_vacuum=Union_cylinder() SETTING parameter declarations. */
#undef this_cylinder_storage
#undef global_geometry_element
#undef this_cylinder_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex
  /* Label for restoring  neutron */
  mcabsorbCompsample_rod_collar_2_vacuum:
  if (RESTORE) /* restore if needed */
  { RESTORE_NEUTRON(41,
      mcnlx,
      mcnly,
      mcnlz,
      mcnlvx,
      mcnlvy,
      mcnlvz,
      mcnlt,
      mcnlsx,
      mcnlsy,
      mcnlsz,
      mcnlp); }
#undef mcabsorbComp
#undef p
#undef sz
#undef sy
#undef sx
#undef t
#undef vz
#undef vy
#undef vx
#undef z
#undef y
#undef x
  mcDEBUG_STATE(
mcnlx,
mcnly,
mcnlz,
mcnlvx,
mcnlvy,
mcnlvz,
mcnlt,
mcnlsx,
mcnlsy,
mcnlsz,
mcnlp)

  /* TRACE Component sample_rod_collar_3_vacuum [42] */
  mccoordschange(mcposrsample_rod_collar_3_vacuum, mcrotrsample_rod_collar_3_vacuum,
    &mcnlx,
    &mcnly,
    &mcnlz,
    &mcnlvx,
    &mcnlvy,
    &mcnlvz,
    &mcnlsx,
    &mcnlsy,
    &mcnlsz);
  /* define label inside component sample_rod_collar_3_vacuum (without coords transformations) */
  mcJumpTrace_sample_rod_collar_3_vacuum:
  SIG_MESSAGE("sample_rod_collar_3_vacuum (Trace)");
  mcDEBUG_COMP("sample_rod_collar_3_vacuum")
  mcDEBUG_STATE(
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp)
#define x mcnlx
#define y mcnly
#define z mcnlz
#define vx mcnlvx
#define vy mcnlvy
#define vz mcnlvz
#define t mcnlt
#define sx mcnlsx
#define sy mcnlsy
#define sz mcnlsz
#define p mcnlp

#define mcabsorbComp mcabsorbCompsample_rod_collar_3_vacuum
  STORE_NEUTRON(42,
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp);
  mcScattered=0;
  mcRestore=0;
  mcNCounter[42]++;
  mcPCounter[42] += p;
  mcP2Counter[42] += p*p;
#define mccompcurname  sample_rod_collar_3_vacuum
#define mccompcurtype  Union_cylinder
#define mccompcurindex 42
#define loop_index mccsample_rod_collar_3_vacuum_loop_index
#define this_cylinder_volume mccsample_rod_collar_3_vacuum_this_cylinder_volume
#define global_geometry_element mccsample_rod_collar_3_vacuum_global_geometry_element
#define this_cylinder_storage mccsample_rod_collar_3_vacuum_this_cylinder_storage
{   /* Declarations of sample_rod_collar_3_vacuum=Union_cylinder() SETTING parameters. */
char* material_string = mccsample_rod_collar_3_vacuum_material_string;
MCNUM priority = mccsample_rod_collar_3_vacuum_priority;
MCNUM radius = mccsample_rod_collar_3_vacuum_radius;
MCNUM yheight = mccsample_rod_collar_3_vacuum_yheight;
MCNUM visualize = mccsample_rod_collar_3_vacuum_visualize;
int target_index = mccsample_rod_collar_3_vacuum_target_index;
MCNUM target_x = mccsample_rod_collar_3_vacuum_target_x;
MCNUM target_y = mccsample_rod_collar_3_vacuum_target_y;
MCNUM target_z = mccsample_rod_collar_3_vacuum_target_z;
MCNUM focus_aw = mccsample_rod_collar_3_vacuum_focus_aw;
MCNUM focus_ah = mccsample_rod_collar_3_vacuum_focus_ah;
MCNUM focus_xw = mccsample_rod_collar_3_vacuum_focus_xw;
MCNUM focus_xh = mccsample_rod_collar_3_vacuum_focus_xh;
MCNUM focus_r = mccsample_rod_collar_3_vacuum_focus_r;
MCNUM p_interact = mccsample_rod_collar_3_vacuum_p_interact;
char* mask_string = mccsample_rod_collar_3_vacuum_mask_string;
char* mask_setting = mccsample_rod_collar_3_vacuum_mask_setting;
MCNUM number_of_activations = mccsample_rod_collar_3_vacuum_number_of_activations;
#line 345 "Union_cylinder.comp"
{
dummy = 1;
}
#line 350688 "MACS_sample_kidney_box.c"
}   /* End of sample_rod_collar_3_vacuum=Union_cylinder() SETTING parameter declarations. */
#undef this_cylinder_storage
#undef global_geometry_element
#undef this_cylinder_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex
  /* Label for restoring  neutron */
  mcabsorbCompsample_rod_collar_3_vacuum:
  if (RESTORE) /* restore if needed */
  { RESTORE_NEUTRON(42,
      mcnlx,
      mcnly,
      mcnlz,
      mcnlvx,
      mcnlvy,
      mcnlvz,
      mcnlt,
      mcnlsx,
      mcnlsy,
      mcnlsz,
      mcnlp); }
#undef mcabsorbComp
#undef p
#undef sz
#undef sy
#undef sx
#undef t
#undef vz
#undef vy
#undef vx
#undef z
#undef y
#undef x
  mcDEBUG_STATE(
mcnlx,
mcnly,
mcnlz,
mcnlvx,
mcnlvy,
mcnlvz,
mcnlt,
mcnlsx,
mcnlsy,
mcnlsz,
mcnlp)

  /* TRACE Component sample_rod_collar_4_vacuum [43] */
  mccoordschange(mcposrsample_rod_collar_4_vacuum, mcrotrsample_rod_collar_4_vacuum,
    &mcnlx,
    &mcnly,
    &mcnlz,
    &mcnlvx,
    &mcnlvy,
    &mcnlvz,
    &mcnlsx,
    &mcnlsy,
    &mcnlsz);
  /* define label inside component sample_rod_collar_4_vacuum (without coords transformations) */
  mcJumpTrace_sample_rod_collar_4_vacuum:
  SIG_MESSAGE("sample_rod_collar_4_vacuum (Trace)");
  mcDEBUG_COMP("sample_rod_collar_4_vacuum")
  mcDEBUG_STATE(
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp)
#define x mcnlx
#define y mcnly
#define z mcnlz
#define vx mcnlvx
#define vy mcnlvy
#define vz mcnlvz
#define t mcnlt
#define sx mcnlsx
#define sy mcnlsy
#define sz mcnlsz
#define p mcnlp

#define mcabsorbComp mcabsorbCompsample_rod_collar_4_vacuum
  STORE_NEUTRON(43,
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp);
  mcScattered=0;
  mcRestore=0;
  mcNCounter[43]++;
  mcPCounter[43] += p;
  mcP2Counter[43] += p*p;
#define mccompcurname  sample_rod_collar_4_vacuum
#define mccompcurtype  Union_cylinder
#define mccompcurindex 43
#define loop_index mccsample_rod_collar_4_vacuum_loop_index
#define this_cylinder_volume mccsample_rod_collar_4_vacuum_this_cylinder_volume
#define global_geometry_element mccsample_rod_collar_4_vacuum_global_geometry_element
#define this_cylinder_storage mccsample_rod_collar_4_vacuum_this_cylinder_storage
{   /* Declarations of sample_rod_collar_4_vacuum=Union_cylinder() SETTING parameters. */
char* material_string = mccsample_rod_collar_4_vacuum_material_string;
MCNUM priority = mccsample_rod_collar_4_vacuum_priority;
MCNUM radius = mccsample_rod_collar_4_vacuum_radius;
MCNUM yheight = mccsample_rod_collar_4_vacuum_yheight;
MCNUM visualize = mccsample_rod_collar_4_vacuum_visualize;
int target_index = mccsample_rod_collar_4_vacuum_target_index;
MCNUM target_x = mccsample_rod_collar_4_vacuum_target_x;
MCNUM target_y = mccsample_rod_collar_4_vacuum_target_y;
MCNUM target_z = mccsample_rod_collar_4_vacuum_target_z;
MCNUM focus_aw = mccsample_rod_collar_4_vacuum_focus_aw;
MCNUM focus_ah = mccsample_rod_collar_4_vacuum_focus_ah;
MCNUM focus_xw = mccsample_rod_collar_4_vacuum_focus_xw;
MCNUM focus_xh = mccsample_rod_collar_4_vacuum_focus_xh;
MCNUM focus_r = mccsample_rod_collar_4_vacuum_focus_r;
MCNUM p_interact = mccsample_rod_collar_4_vacuum_p_interact;
char* mask_string = mccsample_rod_collar_4_vacuum_mask_string;
char* mask_setting = mccsample_rod_collar_4_vacuum_mask_setting;
MCNUM number_of_activations = mccsample_rod_collar_4_vacuum_number_of_activations;
#line 345 "Union_cylinder.comp"
{
dummy = 1;
}
#line 350824 "MACS_sample_kidney_box.c"
}   /* End of sample_rod_collar_4_vacuum=Union_cylinder() SETTING parameter declarations. */
#undef this_cylinder_storage
#undef global_geometry_element
#undef this_cylinder_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex
  /* Label for restoring  neutron */
  mcabsorbCompsample_rod_collar_4_vacuum:
  if (RESTORE) /* restore if needed */
  { RESTORE_NEUTRON(43,
      mcnlx,
      mcnly,
      mcnlz,
      mcnlvx,
      mcnlvy,
      mcnlvz,
      mcnlt,
      mcnlsx,
      mcnlsy,
      mcnlsz,
      mcnlp); }
#undef mcabsorbComp
#undef p
#undef sz
#undef sy
#undef sx
#undef t
#undef vz
#undef vy
#undef vx
#undef z
#undef y
#undef x
  mcDEBUG_STATE(
mcnlx,
mcnly,
mcnlz,
mcnlvx,
mcnlvy,
mcnlvz,
mcnlt,
mcnlsx,
mcnlsy,
mcnlsz,
mcnlp)

  /* TRACE Component resolution_sample_exit [44] */
  mccoordschange(mcposrresolution_sample_exit, mcrotrresolution_sample_exit,
    &mcnlx,
    &mcnly,
    &mcnlz,
    &mcnlvx,
    &mcnlvy,
    &mcnlvz,
    &mcnlsx,
    &mcnlsy,
    &mcnlsz);
  /* define label inside component resolution_sample_exit (without coords transformations) */
  mcJumpTrace_resolution_sample_exit:
  SIG_MESSAGE("resolution_sample_exit (Trace)");
  mcDEBUG_COMP("resolution_sample_exit")
  mcDEBUG_STATE(
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp)
#define x mcnlx
#define y mcnly
#define z mcnlz
#define vx mcnlvx
#define vy mcnlvy
#define vz mcnlvz
#define t mcnlt
#define sx mcnlsx
#define sy mcnlsy
#define sz mcnlsz
#define p mcnlp

#define mcabsorbComp mcabsorbCompresolution_sample_exit
  STORE_NEUTRON(44,
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp);
  mcScattered=0;
  mcRestore=0;
  mcNCounter[44]++;
  mcPCounter[44] += p;
  mcP2Counter[44] += p*p;
#define mccompcurname  resolution_sample_exit
#define mccompcurtype  Union_cylinder
#define mccompcurindex 44
#define loop_index mccresolution_sample_exit_loop_index
#define this_cylinder_volume mccresolution_sample_exit_this_cylinder_volume
#define global_geometry_element mccresolution_sample_exit_global_geometry_element
#define this_cylinder_storage mccresolution_sample_exit_this_cylinder_storage
{   /* Declarations of resolution_sample_exit=Union_cylinder() SETTING parameters. */
char* material_string = mccresolution_sample_exit_material_string;
MCNUM priority = mccresolution_sample_exit_priority;
MCNUM radius = mccresolution_sample_exit_radius;
MCNUM yheight = mccresolution_sample_exit_yheight;
MCNUM visualize = mccresolution_sample_exit_visualize;
int target_index = mccresolution_sample_exit_target_index;
MCNUM target_x = mccresolution_sample_exit_target_x;
MCNUM target_y = mccresolution_sample_exit_target_y;
MCNUM target_z = mccresolution_sample_exit_target_z;
MCNUM focus_aw = mccresolution_sample_exit_focus_aw;
MCNUM focus_ah = mccresolution_sample_exit_focus_ah;
MCNUM focus_xw = mccresolution_sample_exit_focus_xw;
MCNUM focus_xh = mccresolution_sample_exit_focus_xh;
MCNUM focus_r = mccresolution_sample_exit_focus_r;
MCNUM p_interact = mccresolution_sample_exit_p_interact;
char* mask_string = mccresolution_sample_exit_mask_string;
char* mask_setting = mccresolution_sample_exit_mask_setting;
MCNUM number_of_activations = mccresolution_sample_exit_number_of_activations;
#line 345 "Union_cylinder.comp"
{
dummy = 1;
}
#line 350960 "MACS_sample_kidney_box.c"
}   /* End of resolution_sample_exit=Union_cylinder() SETTING parameter declarations. */
#undef this_cylinder_storage
#undef global_geometry_element
#undef this_cylinder_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex
  /* Label for restoring  neutron */
  mcabsorbCompresolution_sample_exit:
  if (RESTORE) /* restore if needed */
  { RESTORE_NEUTRON(44,
      mcnlx,
      mcnly,
      mcnlz,
      mcnlvx,
      mcnlvy,
      mcnlvz,
      mcnlt,
      mcnlsx,
      mcnlsy,
      mcnlsz,
      mcnlp); }
#undef mcabsorbComp
#undef p
#undef sz
#undef sy
#undef sx
#undef t
#undef vz
#undef vy
#undef vx
#undef z
#undef y
#undef x
  mcDEBUG_STATE(
mcnlx,
mcnly,
mcnlz,
mcnlvx,
mcnlvy,
mcnlvz,
mcnlt,
mcnlsx,
mcnlsy,
mcnlsz,
mcnlp)

  /* TRACE Component sample_cryostat [45] */
  mccoordschange(mcposrsample_cryostat, mcrotrsample_cryostat,
    &mcnlx,
    &mcnly,
    &mcnlz,
    &mcnlvx,
    &mcnlvy,
    &mcnlvz,
    &mcnlsx,
    &mcnlsy,
    &mcnlsz);
  /* define label inside component sample_cryostat (without coords transformations) */
  mcJumpTrace_sample_cryostat:
  SIG_MESSAGE("sample_cryostat (Trace)");
  mcDEBUG_COMP("sample_cryostat")
  mcDEBUG_STATE(
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp)
#define x mcnlx
#define y mcnly
#define z mcnlz
#define vx mcnlvx
#define vy mcnlvy
#define vz mcnlvz
#define t mcnlt
#define sx mcnlsx
#define sy mcnlsy
#define sz mcnlsz
#define p mcnlp

#define mcabsorbComp mcabsorbCompsample_cryostat
  STORE_NEUTRON(45,
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp);
  mcScattered=0;
  mcRestore=0;
  mcNCounter[45]++;
  mcPCounter[45] += p;
  mcP2Counter[45] += p*p;
#define mccompcurname  sample_cryostat
#define mccompcurtype  Union_master
#define mccompcurindex 45
#define verbal mccsample_cryostat_verbal
#define list_verbal mccsample_cryostat_list_verbal
#define trace_verbal mccsample_cryostat_trace_verbal
#define finally_verbal mccsample_cryostat_finally_verbal
#define starting_volume_warning mccsample_cryostat_starting_volume_warning
#define global_master_element mccsample_cryostat_global_master_element
#define this_global_master_index mccsample_cryostat_this_global_master_index
#define previous_master_index mccsample_cryostat_previous_master_index
#define geometry_list_index mccsample_cryostat_geometry_list_index
#define intersection_time_table mccsample_cryostat_intersection_time_table
#define Volumes mccsample_cryostat_Volumes
#define Geometries mccsample_cryostat_Geometries
#define starting_lists mccsample_cryostat_starting_lists
#define r mccsample_cryostat_r
#define r_start mccsample_cryostat_r_start
#define v mccsample_cryostat_v
#define error_msg mccsample_cryostat_error_msg
#define component_error_msg mccsample_cryostat_component_error_msg
#define string_output mccsample_cryostat_string_output
#define number_of_volumes mccsample_cryostat_number_of_volumes
#define volume_index mccsample_cryostat_volume_index
#define process_index mccsample_cryostat_process_index
#define solutions mccsample_cryostat_solutions
#define max_number_of_processes mccsample_cryostat_max_number_of_processes
#define limit mccsample_cryostat_limit
#define solution mccsample_cryostat_solution
#define min_solution mccsample_cryostat_min_solution
#define min_volume mccsample_cryostat_min_volume
#define time_found mccsample_cryostat_time_found
#define intersection_time mccsample_cryostat_intersection_time
#define min_intersection_time mccsample_cryostat_min_intersection_time
#define process mccsample_cryostat_process
#define process_start mccsample_cryostat_process_start
#define my_trace mccsample_cryostat_my_trace
#define p_my_trace mccsample_cryostat_p_my_trace
#define my_trace_fraction_control mccsample_cryostat_my_trace_fraction_control
#define k mccsample_cryostat_k
#define k_new mccsample_cryostat_k_new
#define k_old mccsample_cryostat_k_old
#define v_length mccsample_cryostat_v_length
#define my_sum mccsample_cryostat_my_sum
#define my_sum_plus_abs mccsample_cryostat_my_sum_plus_abs
#define culmative_probability mccsample_cryostat_culmative_probability
#define mc_prop mccsample_cryostat_mc_prop
#define time_to_scattering mccsample_cryostat_time_to_scattering
#define length_to_scattering mccsample_cryostat_length_to_scattering
#define length_to_boundery mccsample_cryostat_length_to_boundery
#define time_to_boundery mccsample_cryostat_time_to_boundery
#define selected_process mccsample_cryostat_selected_process
#define scattering_event mccsample_cryostat_scattering_event
#define time_propagated_without_scattering mccsample_cryostat_time_propagated_without_scattering
#define a_next_volume_found mccsample_cryostat_a_next_volume_found
#define next_volume mccsample_cryostat_next_volume
#define next_volume_priority mccsample_cryostat_next_volume_priority
#define done mccsample_cryostat_done
#define current_volume mccsample_cryostat_current_volume
#define number_of_solutions mccsample_cryostat_number_of_solutions
#define number_of_solutions_static mccsample_cryostat_number_of_solutions_static
#define check mccsample_cryostat_check
#define start mccsample_cryostat_start
#define intersection_with_children mccsample_cryostat_intersection_with_children
#define geometry_output mccsample_cryostat_geometry_output
#define tree_next_volume mccsample_cryostat_tree_next_volume
#define pre_allocated1 mccsample_cryostat_pre_allocated1
#define pre_allocated2 mccsample_cryostat_pre_allocated2
#define pre_allocated3 mccsample_cryostat_pre_allocated3
#define ray_position mccsample_cryostat_ray_position
#define ray_velocity mccsample_cryostat_ray_velocity
#define ray_velocity_final mccsample_cryostat_ray_velocity_final
#define volume_0_found mccsample_cryostat_volume_0_found
#define scattered_flag mccsample_cryostat_scattered_flag
#define scattered_flag_VP mccsample_cryostat_scattered_flag_VP
#define master_transposed_rotation_matrix mccsample_cryostat_master_transposed_rotation_matrix
#define temp_rotation_matrix mccsample_cryostat_temp_rotation_matrix
#define non_rotated_position mccsample_cryostat_non_rotated_position
#define rotated_position mccsample_cryostat_rotated_position
#define enable_tagging mccsample_cryostat_enable_tagging
#define stop_tagging_ray mccsample_cryostat_stop_tagging_ray
#define stop_creating_nodes mccsample_cryostat_stop_creating_nodes
#define enable_tagging_check mccsample_cryostat_enable_tagging_check
#define master_tagging_node_list mccsample_cryostat_master_tagging_node_list
#define current_tagging_node mccsample_cryostat_current_tagging_node
#define tagging_leaf_counter mccsample_cryostat_tagging_leaf_counter
#define number_of_scattering_events mccsample_cryostat_number_of_scattering_events
#define real_transmission_probability mccsample_cryostat_real_transmission_probability
#define mc_transmission_probability mccsample_cryostat_mc_transmission_probability
#define number_of_masks mccsample_cryostat_number_of_masks
#define number_of_masked_volumes mccsample_cryostat_number_of_masked_volumes
#define need_to_run_within_which_volume mccsample_cryostat_need_to_run_within_which_volume
#define mask_index_main mccsample_cryostat_mask_index_main
#define mask_iterate mccsample_cryostat_mask_iterate
#define mask_status_list mccsample_cryostat_mask_status_list
#define current_mask_intersect_list_status mccsample_cryostat_current_mask_intersect_list_status
#define mask_volume_index_list mccsample_cryostat_mask_volume_index_list
#define geometry_component_index_list mccsample_cryostat_geometry_component_index_list
#define Volume_copies_allocated mccsample_cryostat_Volume_copies_allocated
#define p_old mccsample_cryostat_p_old
#define this_logger mccsample_cryostat_this_logger
#define conditional_status mccsample_cryostat_conditional_status
#define tagging_conditional_list mccsample_cryostat_tagging_conditional_list
#define free_tagging_conditioanl_list mccsample_cryostat_free_tagging_conditioanl_list
#define logger_conditional_extend_array mccsample_cryostat_logger_conditional_extend_array
#define tagging_conditional_extend mccsample_cryostat_tagging_conditional_extend
#define max_conditional_extend_index mccsample_cryostat_max_conditional_extend_index
#define safty_distance mccsample_cryostat_safty_distance
#define safty_distance2 mccsample_cryostat_safty_distance2
#define number_of_processes_array mccsample_cryostat_number_of_processes_array
#define temporary_focus_data mccsample_cryostat_temporary_focus_data
#define focus_data_index mccsample_cryostat_focus_data_index
{   /* Declarations of sample_cryostat=Union_master() SETTING parameters. */
MCNUM allow_inside_start = mccsample_cryostat_allow_inside_start;
MCNUM history_limit = mccsample_cryostat_history_limit;
MCNUM enable_conditionals = mccsample_cryostat_enable_conditionals;
MCNUM inherit_number_of_scattering_events = mccsample_cryostat_inherit_number_of_scattering_events;
#line 856 "Union_master.comp"
{
  
  #ifdef Union_trace_verbal_setting
    printf("\n\n\n\n\n----------- NEW RAY -------------------------------------------------\n");
    printf("Union_master component name: %s \n \n",NAME_CURRENT_COMP);
  #endif
  
  // Initialize logic
  done = 0;
  error_msg = 0;
  clear_intersection_table(&intersection_time_table);
  
  time_propagated_without_scattering = 0;
  v_length = sqrt(vx*vx+vy*vy+vz*vz);
  
  // Initialize logger system / Statistics
  number_of_scattering_events = 0;
  
  if (inherit_number_of_scattering_events==1) // Continue number of scattering from previous Union_master
    number_of_scattering_events = global_master_list.elements[this_global_master_index-1].stored_number_of_scattering_events;
  
  // Zero scattered_flag_VP data
  for (volume_index = 1;volume_index<number_of_volumes;volume_index++) { // No reason to update volume 0, as scattering doesn't happen there
    scattered_flag[volume_index] = 0;
    for (process_index=0;process_index<number_of_processes_array[volume_index];process_index++)
      scattered_flag_VP[volume_index][process_index] = 0;
  }
  
  // If first Union_master in instrument, reset loggers_with_data_array and clean unused data.
  // Unused data happens when logging data is passed to the next Union_master, but the ray is absorbed on the way.
  // Could be improved by using the precompiler instead as ncount times the number of Union_masters could be avoided.
  if (global_master_list.elements[0].component_index == INDEX_CURRENT_COMP) {
    // If this is the first Union master, clean up logger data for rays that did not make it through Union components
    for (log_index=loggers_with_data_array.used_elements-1;log_index>-1;log_index--) {
      loggers_with_data_array.logger_pointers[log_index]->function_pointers.clear_temp(&loggers_with_data_array.logger_pointers[log_index]->data_union);
    }
    loggers_with_data_array.used_elements = 0;
  }
    
  tagging_conditional_extend = 0;
  for (iterate=0;iterate<max_conditional_extend_index+1;iterate++) {
    logger_conditional_extend_array[iterate] = 0;
  }

  // Need to clean up the double notation for position and velocity. // REVIEW_LINE
  r_start[0] = x; r_start[1] = y; r_start[2] = z;
  r[0]=x;r[1]=y;r[2]=z;v[0]=vx;v[1]=vy;v[2]=vz; // REVIEW_LINE r and v are bad names
  
  ray_position = coords_set(x,y,z);
  ray_velocity = coords_set(vx,vy,vz);
  
  // Mask update: need to check the mask status for the initial position
  // mask status for a mask is 1 if the ray position is inside, 0 if it is outside
  for (iterate=0;iterate<number_of_masks;iterate++) {
    if(Volumes[mask_volume_index_list.elements[iterate]]->geometry.within_function(ray_position,&Volumes[mask_volume_index_list.elements[iterate]]->geometry) == 1) {
      mask_status_list.elements[iterate] = 1;
    } else {
      mask_status_list.elements[iterate] = 0;
    }
  }
  
  #ifdef Union_trace_verbal_setting
    print_1d_int_list(mask_status_list,"Initial mask status list");
  #endif
  
  // Now the initial current_volume can be found, which requires the up to date mask_status_list
  current_volume = within_which_volume(ray_position,starting_lists.reduced_start_list,starting_lists.starting_destinations_list,Volumes,&mask_status_list,number_of_volumes,pre_allocated1,pre_allocated2,pre_allocated3);
  
  // Using the mask_status_list and the current volume, the current_mask_intersect_list_status can be made
  //  it contains the effective mask status of all volumes on the current volumes mask intersect list, which needs to be calculated,
  //  but only when the current volume or mask status changes, not under for example scattering inside the current volume
  update_current_mask_intersect_status(&current_mask_intersect_list_status, &mask_status_list, Volumes, &current_volume);
  
  #ifdef Union_trace_verbal_setting
    printf("Starting current_volume = %d\n",current_volume);
  #endif
  
  // Check if the ray appeared in an allowed starting volume, unless this check is disabled by the user for advanced cases
  if (allow_inside_start == 0 && starting_lists.allowed_starting_volume_logic_list.elements[current_volume] == 0) {
    printf("ERROR, ray ''teleported'' into Union component %s, if intentional, set allow_inside_start=1\n",NAME_CURRENT_COMP);
    exit(1);
  }
  // Warn the user that rays have appeared inside a volume instead of outside as expected
  if (starting_volume_warning == 0 && current_volume != 0) {
        printf("WARNING: Ray started in volume ''%s'' rather than the surrounding vacuum in component %s. This warning is only shown once.\n",Volumes[current_volume]->name,NAME_CURRENT_COMP);
        starting_volume_warning = 1;
  }
  
  // Placing the new ray at the start of the tagging tree corresponding to current volume
  // A history limit can be imposed so that no new nodes are created after this limit (may be necessary to fit in memory)
  // Rays can still follow the nodes created before even when no additional nodes are created, but if a situation that
  //  requires a new node is encountered, stop_tagging_ray is set to 1, stopping further tagging and preventing the data
  //  for that ray to be used further.
  if (enable_tagging) {
    current_tagging_node = master_tagging_node_list.elements[current_volume];
    stop_tagging_ray = 0; // Allow this ray to be tracked
    if (tagging_leaf_counter > history_limit) stop_creating_nodes = 1;
  }
  
  #ifdef Union_trace_verbal_setting
    if (enable_tagging) printf("current_tagging_node->intensity = %f\n",current_tagging_node->intensity);
    if (enable_tagging) printf("current_tagging_node->number_of_rays = %d \n",current_tagging_node->number_of_rays);
  #endif
  
  // Propagation loop including scattering
  // This while loop continues until the ray leaves the ensamble of user defined volumes either through volume 0
  //  or a dedicated exit volume. The loop is cancelled after a large number of iterations as a failsafe for errors.
  // A single run of the loop will either be a propagation to the next volume along the path of the ray, or a
  //  scattering event at some point along the path of the ray in the current volume.
  limit = 100000;
  while (done == 0) {
    limit--;
    
    #ifdef Union_trace_verbal_setting
      printf("----------- START OF WHILE LOOP --------------------------------------\n");
      print_intersection_table(intersection_time_table);
      printf("current_volume = %d \n",current_volume);
    #endif
    
    // Calculating intersections with the necessary volumes. The relevant set of volumes depend on the current volume and the mask status array.
    // First the volumes on the current volumes intersect list is checked, then its mask interset list. Before checking the volume itself, it is
    //  checked if any children of the current volume is intersected, in which case the intersection calculation with the current volume can be
    //  skipped.
    
    // Checking intersections for all volumes in the intersect list.
    for (start=check=Volumes[current_volume]->geometry.intersect_check_list.elements;check-start<Volumes[current_volume]->geometry.intersect_check_list.num_elements;check++) {
    // This will leave check as a pointer to the intergers in the intersect_check_list and iccrement nicely
        #ifdef Union_trace_verbal_setting
          printf("Intersect_list = %d being checked \n",*check);
        #endif
    
        if (intersection_time_table.calculated[*check] == 0) {
             #ifdef Union_trace_verbal_setting
               printf("running intersection for intersect_list with *check = %d \n",*check);
               // if (trace_verbal) printf("r = (%f,%f,%f) v = (%f,%f,%f) \n",r[0],r[1],r[2],v[0],v[1],v[2]);
             #endif
            // Calculate intersections using intersect function imbedded in the relevant volume structure using parameters
            //  that are also imbedded in the structure.
            geometry_output = Volumes[*check]->geometry.intersect_function(intersection_time_table.intersection_times[*check],number_of_solutions,r_start,v,&Volumes[*check]->geometry);
            intersection_time_table.calculated[*check] = 1;
            // if (trace_verbal) printf("succesfully calculated intersection times for volume *check = %d \n",*check);
        }
    }
    
    // Mask update: add additional loop for checking intersections with masked volumes depending on mask statuses
    for (mask_iterate=0;mask_iterate<Volumes[current_volume]->geometry.mask_intersect_list.num_elements;mask_iterate++) {
      if (current_mask_intersect_list_status.elements[mask_iterate] == 1) { // Only check if the mask is active
        #ifdef Union_trace_verbal_setting
          printf("Mask Intersect_list = %d being checked \n",Volumes[current_volume]->geometry.mask_intersect_list.elements[mask_iterate]);
        #endif
        if (intersection_time_table.calculated[Volumes[current_volume]->geometry.mask_intersect_list.elements[mask_iterate]] == 0) {
          #ifdef Union_trace_verbal_setting
            printf("running intersection for mask_intersect_list element = %d \n",Volumes[current_volume]->geometry.mask_intersect_list.elements[mask_iterate]);
          //  printf("r = (%f,%f,%f) v = (%f,%f,%f) \n",r[0],r[1],r[2],v[0],v[1],v[2]);
          #endif
          // Calculate intersections using intersect function imbedded in the relevant volume structure using parameters
            //  that are also imbedded in the structure.
          geometry_output = Volumes[Volumes[current_volume]->geometry.mask_intersect_list.elements[mask_iterate]]->geometry.intersect_function(intersection_time_table.intersection_times[Volumes[current_volume]->geometry.mask_intersect_list.elements[mask_iterate]],number_of_solutions,r_start,v,&Volumes[Volumes[current_volume]->geometry.mask_intersect_list.elements[mask_iterate]]->geometry);
          intersection_time_table.calculated[Volumes[current_volume]->geometry.mask_intersect_list.elements[mask_iterate]] = 1;
          // if (trace_verbal) printf("succesfully calculated intersection times for volume *check = %d \n",*check);
        }
      }
    }
    
    // Checking if there are intersections with children of current volume, which means there is an intersection before current_volume, and thus can be skipped. But only if they have not been overwritten. In case current_volume is 0, there is no need to do this regardless.
    if (current_volume != 0 && intersection_time_table.calculated[current_volume] == 0) {
        #ifdef Union_trace_verbal_setting
          printf("Checking if children of current_volume = %d have intersections. \n",current_volume);
        #endif
        intersection_with_children = 0;
        //for (start = check = Volumes[current_volume]->geometry.direct_children.elements;check - start < Volumes[current_volume]->geometry.children.num_elements;check++) { // REVIEW LINE. Caused bug with masks.
        for (start = check = Volumes[current_volume]->geometry.children.elements;check - start < Volumes[current_volume]->geometry.children.num_elements;check++) {
            #ifdef Union_trace_verbal_setting
              printf("Checking if child %d of current_volume = %d have intersections. \n",*check,current_volume);
            #endif
            // Only check the first of the two results in the intersection table, as they are ordered, and the second is of no interest
            if (intersection_time_table.calculated[*check] == 1 && intersection_time_table.intersection_times[*check][0] > time_propagated_without_scattering) {
                // If this child is masked, its mask status need to be 1 in order to be taken into account
                if (Volumes[*check]->geometry.is_masked_volume == 0) {
                  #ifdef Union_trace_verbal_setting
                    printf("Found an child of current_volume with an intersection. Skips calculating for current_volume \n");
                  #endif
                  intersection_with_children = 1;
                  break; // No need to check more, if there is just one it is not necessary to calculate intersection with current_volume yet
                } else {
                  #ifdef Union_trace_verbal_setting
                    printf("Found an child of current_volume with an intersection, but it is masked. Check to see if it can skip calculating for current_volume \n");
                  #endif
                  
                  if (Volumes[*check]->geometry.mask_mode == 2) { // ANY mask mode
                    tree_next_volume = 0;
                    for (mask_start=mask_check=Volumes[*check]->geometry.masked_by_mask_index_list.elements;mask_check-mask_start<Volumes[*check]->geometry.masked_by_mask_index_list.num_elements;mask_check++) {
                       if (mask_status_list.elements[*mask_check] == 1) {
                         intersection_with_children = 1;
                         break;
                       }
                    }
                  } else { // ALL mask mode
                    intersection_with_children = 1;
                    for (mask_start=mask_check=Volumes[*check]->geometry.masked_by_mask_index_list.elements;mask_check-mask_start<Volumes[*check]->geometry.masked_by_mask_index_list.num_elements;mask_check++) {
                      if (mask_status_list.elements[*mask_check] == 0) {
                        intersection_with_children = 0;
                        break;
                      }
                    }
                  }
                  #ifdef Union_trace_verbal_setting
                    printf("The mask status was 1, can actually skip intersection calculation for current volume \n");
                  #endif
                  if (intersection_with_children == 1) break;
                }
            }
        }
        #ifdef Union_trace_verbal_setting
          printf("intersection_with_children = %d \n",intersection_with_children);
        #endif
        if (intersection_with_children == 0) {
            geometry_output = Volumes[current_volume]->geometry.intersect_function(intersection_time_table.intersection_times[current_volume],number_of_solutions,r_start,v,&Volumes[current_volume]->geometry);
            intersection_time_table.calculated[current_volume] = 1;
        }
    }

    // At this point, intersection_time_table is updated with intersection times of all possible intersections.
    #ifdef Union_trace_verbal_setting
      print_intersection_table(intersection_time_table);
    #endif
    
    // Next task is to find the next intersection time. The next intersection must be greater than the time_propagated_without_scattering (0 at start of loop)
    // Loops are eqvialent to the 3 intersection calculation loops already completed
    
    // First loop for checking intersect_check_list
    time_found = 0;
    for (start=check=Volumes[current_volume]->geometry.intersect_check_list.elements;check-start<Volumes[current_volume]->geometry.intersect_check_list.num_elements;check++) {
        for (solution = 0;solution<intersection_time_table.n_elements[*check];solution++) {
            if (time_found) {
                if ((intersection_time = intersection_time_table.intersection_times[*check][solution]) > time_propagated_without_scattering &&  intersection_time < min_intersection_time) {
                    min_intersection_time = intersection_time;min_solution = solution;min_volume = *check;
                }
            } else {
                if ((intersection_time = intersection_time_table.intersection_times[*check][solution]) > time_propagated_without_scattering) {
                    min_intersection_time = intersection_time;min_solution = solution;min_volume = *check;
                    time_found = 1;
                }
            }
        }
    }
    
    // Now check the masked_intersect_list, but only the ones that are currently active
    for (mask_iterate=0;mask_iterate<Volumes[current_volume]->geometry.mask_intersect_list.num_elements;mask_iterate++) {
      if (current_mask_intersect_list_status.elements[mask_iterate] == 1) {
        for (solution = 0;solution<intersection_time_table.n_elements[Volumes[current_volume]->geometry.mask_intersect_list.elements[mask_iterate]];solution++) {
            if (time_found) {
                if ((intersection_time = intersection_time_table.intersection_times[Volumes[current_volume]->geometry.mask_intersect_list.elements[mask_iterate]][solution]) > time_propagated_without_scattering &&  intersection_time < min_intersection_time) {
                    min_intersection_time = intersection_time;min_solution = solution;min_volume = Volumes[current_volume]->geometry.mask_intersect_list.elements[mask_iterate];
                }
            } else {
                if ((intersection_time = intersection_time_table.intersection_times[Volumes[current_volume]->geometry.mask_intersect_list.elements[mask_iterate]][solution]) > time_propagated_without_scattering) {
                    min_intersection_time = intersection_time;min_solution = solution;min_volume = Volumes[current_volume]->geometry.mask_intersect_list.elements[mask_iterate];
                    time_found = 1;
                }
            }
        }
      }
    }
    
    // And check the current_volume
    for (solution = 0;solution<intersection_time_table.n_elements[current_volume];solution++) {
        if (time_found) {
            if ((intersection_time = intersection_time_table.intersection_times[current_volume][solution]) > time_propagated_without_scattering && intersection_time < min_intersection_time) {
                min_intersection_time = intersection_time;min_solution = solution;min_volume = current_volume;
            }
        } else {
            if ((intersection_time = intersection_time_table.intersection_times[current_volume][solution]) > time_propagated_without_scattering) {
                min_intersection_time = intersection_time;min_solution = solution;min_volume = current_volume;
                time_found = 1;
            }
        }
    }
    
    #ifdef Union_trace_verbal_setting
      printf("min_intersection_time = %f \n",min_intersection_time);
      printf("min_solution          = %d \n",min_solution);
      printf("min_volume            = %d \n",min_volume);
      printf("time_found            = %d \n",time_found);
    #endif

    // If a time is found, propagation continues, and it will be checked if a scattering occurs before the next intersection.
    // If a time is not found, the ray must be leaving the ensamble of volumes and the loop will be concluded
    if (time_found) {
        time_to_boundery = min_intersection_time - time_propagated_without_scattering; // calculate the time remaining before the next intersection
        scattering_event = 0; // Assume a scattering event will not occur
        
        // Check if a scattering event should occur
        if (current_volume != 0) { // Volume 0 is always vacuum, and if this is the current volume, an event will not occur
          if (Volumes[current_volume]->p_physics->number_of_processes == 0) { // If there are no processes, the volume could be vacuum or an absorber
            if (Volumes[current_volume]->p_physics->is_vacuum == 0)
              // This volume does not have physical processes but does have an absorption cross section, so the ray weight is reduced accordingly
              p *= exp(-Volumes[current_volume]->p_physics->my_a*2200*time_to_boundery);
    
    
              //#ifdef Union_trace_verbal_setting
              //printf("name of material: %s \n",Volumes[current_volume]->name);
              //printf("length to boundery  = %f\n",length_to_boundery);
              //printf("absorption cross section  = %f\n",Volumes[current_volume]->p_physics->my_a);
              //printf("chance to get through this length of absorber: %f \%\n",100*exp(-Volumes[current_volume]->p_physics->my_a*length_to_boundery));
              //#endif
                    
          } else {
            // Since there is a non-zero number of processes in this material, all the scattering cross section for these are calculated
            my_sum = 0; k[0] = V2K*vx; k[1] = V2K*vy; k[2] = V2K*vz; p_my_trace = my_trace; wavevector = coords_set(k[0],k[1],k[2]);
            for (process_start = process = Volumes[current_volume]->p_physics->p_scattering_array;process - process_start < Volumes[current_volume]->p_physics->number_of_processes;process++) {
            
              if (Volumes[current_volume]->p_physics->p_scattering_array[process - process_start].non_isotropic_rot_index != -1) {
                // If the process is not isotropic, the wavevector is transformed into the local coordinate system of the process
                wavevector_rotated = rot_apply(Volumes[current_volume]->geometry.process_rot_matrix_array[Volumes[current_volume]->p_physics->p_scattering_array[process - process_start].non_isotropic_rot_index],wavevector);
                
                coords_get(wavevector_rotated,&k_rotated[0],&k_rotated[1],&k_rotated[2]);

              } else {
                k_rotated[0] = k[0]; k_rotated[1] = k[1]; k_rotated[2] = k[2];
              }
              
              // Find correct focus_data_array index for this volume/process
              focus_data_index = Volumes[current_volume]->geometry.focus_array_indices.elements[process - process_start];
              
              // Call the probability for scattering function assighed to this specific procress (the process pointer is updated in the for loop)
              process->probability_for_scattering_function(p_my_trace,k_rotated,process->data_transfer,&Volumes[current_volume]->geometry.focus_data_array.elements[focus_data_index]);
              
              my_sum += *p_my_trace;
              #ifdef Union_trace_verbal_setting
                printf("my_trace = %f, my_sum = %f\n",*p_my_trace,my_sum);
              #endif
              p_my_trace++; // increment the pointer so that it point to the next element (max number of process in any material is allocated)
            }
            
            #ifdef Union_trace_verbal_setting
              printf("time_propagated_without_scattering = %f.\n",time_propagated_without_scattering);
              printf("v_length                           = %f.\n",v_length);
            #endif
            
            length_to_boundery = time_to_boundery * v_length;
            
            #ifdef Union_trace_verbal_setting
              printf("exp(- length_to_boundery*my_sum) = %f. length_to_boundery = %f. my_sum = %f.\n",exp(-length_to_boundery*my_sum),length_to_boundery,my_sum);
            #endif
            
            // Selecting if a scattering takes place, and what scattering process.
            // This section have too many if statements, and unessecary calculations
            // Could make seperate functions for p_interact on/off and interact_fraction on/off,
            //   and set function pointers to these in initialize, thus avoiding many unessecary if statements and calculations of x/x.
            
            my_sum_plus_abs = my_sum + Volumes[current_volume]->p_physics->my_a*(2200/v_length);
            
            if (my_sum < 1E-18) {
                // The scattering cross section is basicly zero, no scattering should occur.
                scattering_event = 0;
                p *= exp(-length_to_boundery*my_sum_plus_abs); // Correct for absorption and the almost zero scattering
            } else if (length_to_boundery < safty_distance2) {
                // Too close to boundery to safly make another scattering, attenuate
                p *= exp(-length_to_boundery*my_sum_plus_abs); // Attentuate the beam for the small distance
                scattering_event = 0;
            } else {
                // The scattering cross section is above zero and the distance to the boundery is sufficient for a scattering
                if (Volumes[current_volume]->geometry.geometry_p_interact != 0) {
                    // a fraction of the beam (geometry_p_interact) is forced to scatter
                    real_transmission_probability = exp(-length_to_boundery*my_sum_plus_abs);
                    mc_transmission_probability = (1.0 - Volumes[current_volume]->geometry.geometry_p_interact);
                    if ((scattering_event = (rand01() > mc_transmission_probability))) {
                        // Scattering event happens, this is the correction for the weight
                        p *= (1.0-real_transmission_probability)/(1.0-mc_transmission_probability); // Absorption simulated in weight
                        // Find length to next scattering knowing the ray will scatter.
                        length_to_scattering = safty_distance -log(1.0 - rand0max((1.0 - exp(-my_sum_plus_abs*(length_to_boundery-safty_distance2))))) / my_sum_plus_abs;
                    } else {
                        // Scattering event does not happen, this is the appropriate correction
                        p *= real_transmission_probability/mc_transmission_probability; // Absorption simulated in weight
                    }
                } else {
                    // probability to scatter is the natural value
                    if(my_sum*length_to_boundery < 1e-6) { // Scattering probability very small, linear method is used as exponential is unreliable
                      if (length_to_boundery > safty_distance2) {
                        if (rand01() < exp(-length_to_boundery*my_sum_plus_abs)) {
                          // Scattering happens, use linear description to select scattering position
                          length_to_scattering = safty_distance + rand0max(length_to_boundery - safty_distance2);
                          // Weight factor necessary to correct for using the linear scattering position distribution
                          p *= length_to_boundery*my_sum*exp(-length_to_scattering*my_sum_plus_abs); // Absorption simulated in weight
                          scattering_event = 1;
                        } else scattering_event = 0;
                      } else {
                        // The distance is too short to reliably make a scattering event (in comparison to accuraccy of intersect functions)
                        p *= exp(-length_to_boundery*my_sum_plus_abs); // Attentuate the beam for the small distance
                        scattering_event = 0;
                      }
                    } else {
                        // Strong scattering, use exponential description to select scattering position between safetydistance and infinity
                        length_to_scattering = safty_distance -log(1 - rand01() ) / my_sum_plus_abs;
                        // Scattering happens if the scattering position is before the boundery (and safty distance)
                        if (length_to_scattering < length_to_boundery - safty_distance) scattering_event = 1;
                        else scattering_event = 0;
                    }
                }
                
                if (scattering_event == 1) {
                  // Adjust weight for absorption
                  p *= my_sum/my_sum_plus_abs;
                  // Safety feature, alert in case of nonsense my results / negative absorption
                  if (my_sum/my_sum_plus_abs > 1.0) printf("WARNING: Absorption weight factor above 1! Should not happen! \n");
                  // Select process
                  if (Volumes[current_volume]->p_physics->number_of_processes == 1) { // trivial case
                    // Select the only available process, which will always have index 0
                    selected_process = 0;
                  } else {
                    if (Volumes[current_volume]->p_physics->interact_control == 1) {
                      // Interact_fraction is used to influence the choice of process in this material
                      mc_prop = rand01();culmative_probability=0;total_process_interact=1.0;
                  
                      // If any of the processes have probability 0, they are excluded from the selection
                      for (iterate = 0;iterate < Volumes[current_volume]->p_physics->number_of_processes;iterate++) {
                        if (my_trace[iterate] < 1E-18) {
                          // When this happens, the total force probability is corrected and the probability for this particular instance is set to 0
                          total_process_interact -= Volumes[current_volume]->p_physics->p_scattering_array[iterate].process_p_interact;
                          my_trace_fraction_control[iterate] = 0;
                          // In cases where my_trace is not zero, the forced fraction is still used.
                        } else my_trace_fraction_control[iterate] = Volumes[current_volume]->p_physics->p_scattering_array[iterate].process_p_interact;
                      }
                      // Randomly select a process using the weights stored in my_trace_fraction_control divided by total_process_interact
                      for (iterate = 0;iterate < Volumes[current_volume]->p_physics->number_of_processes;iterate++) {
                        culmative_probability += my_trace_fraction_control[iterate]/total_process_interact;
                        if (culmative_probability > mc_prop) {
                          selected_process = iterate;
                          p *= (my_trace[iterate]/my_sum)*(total_process_interact/my_trace_fraction_control[iterate]);
                          break;
                        }
                      }
                    
                    } else {
                      // Select a process based on their relative attenuations factors
                      mc_prop = rand01();culmative_probability=0;
                      for (iterate = 0;iterate < Volumes[current_volume]->p_physics->number_of_processes;iterate++) {
                        culmative_probability += my_trace[iterate]/my_sum;
                        if (culmative_probability > mc_prop) {
                          selected_process = iterate;
                          break;
                        }
                      }
                    }
                  }
                } // end of select process
            }
            
          }
        } // Done checking for scttering event and in case of scattering selecting a process
     
        if (scattering_event == 1) {
            #ifdef Union_trace_verbal_setting
              printf("SCATTERING EVENT \n");
              printf("current_volume            = %d \n",current_volume);
              printf("r = (%f,%f,%f) v = (%f,%f,%f) \n",r[0],r[1],r[2],v[0],v[1],v[2]);
            // printf("did scatter: my_trace = %E = %f \n",my_trace[selected_process],my_trace[selected_process]);
            #endif
            
            // Calculate the time to scattering
            time_to_scattering = length_to_scattering/v_length;
            
            #ifdef Union_trace_verbal_setting
              printf("time to scattering        = %2.20f \n",time_to_scattering);
            #endif
            
            //#ifdef Union_trace_verbal_setting
            //printf("length to boundery = %f, length to scattering = %f \n",length_to_boundery,length_to_scattering);
            //#endif
            
            //PROP_DT(time_to_scattering); // May be replace by version without gravity
            
            // Reduce the double book keeping done here // REVIEW LINE
            x += time_to_scattering*vx; y += time_to_scattering*vy; z += time_to_scattering*vz; t += time_to_scattering;
            r_start[0] = x; r_start[1] = y; r_start[2] = z;
            r[0] = x; r[1] = y; r[2] = z;
            ray_position = coords_set(x,y,z);
            ray_velocity = coords_set(vx,vy,vz);
            
            // Safe check that should be unecessary. Used to fine tune how close to the edge of a volume a scattering event is allowed to take place (1E-14 m away currently).
            if (Volumes[current_volume]->geometry.within_function(ray_position,&Volumes[current_volume]->geometry) == 0) {
              printf("\nERROR, propagated out of current volume instead of to a point within!\n");
              printf("length_to_scattering_specified = %2.20f\n             length propagated = %2.20f\n            length_to_boundery = %2.20f \n   current_position = (%lf,%lf,%lf) \n",length_to_scattering,sqrt(time_to_scattering*time_to_scattering*vx*vx+time_to_scattering*time_to_scattering*vy*vy+time_to_scattering*time_to_scattering*vz*vz),length_to_boundery,x,y,z);
              
              volume_index = within_which_volume(ray_position,starting_lists.reduced_start_list,starting_lists.starting_destinations_list,Volumes,&mask_status_list,number_of_volumes,pre_allocated1,pre_allocated2,pre_allocated3);
              
              printf("Debug info: Volumes[current_volume]->name = %s, but now inside volume number %d named %s.\n",Volumes[current_volume]->name,volume_index,Volumes[volume_index]->name);
              printf("Ray absorbed \n");
              ABSORB;
            }
            
            // Save information before scattering event needed in logging section
            p_old = p;
            k_old[0] = k[0];k_old[1] = k[1];k_old[2] = k[2];
            
            // Find correct focus_data_array index for this volume/process
            focus_data_index = Volumes[current_volume]->geometry.focus_array_indices.elements[selected_process];
        
            // Rotation to local process coordinate system (for non isotropic processes)
            if (Volumes[current_volume]->p_physics->p_scattering_array[selected_process].non_isotropic_rot_index != -1) {
                ray_velocity_rotated = rot_apply(Volumes[current_volume]->geometry.process_rot_matrix_array[Volumes[current_volume]->p_physics->p_scattering_array[selected_process].non_isotropic_rot_index],ray_velocity);
            } else {
                ray_velocity_rotated = ray_velocity;
            }
                
            // test_physics_scattering(double *k_final, double *k_initial, union data_transfer_union data_transfer) {
            //k[0] = V2K*ray_velocity.x; k[1] = V2K*ray_velocity.y; k[2] = V2K*ray_velocity.z;
            coords_get(coords_scalar_mult(ray_velocity_rotated,V2K),&k[0],&k[1],&k[2]);
            
            // I may replace a intial and final k with one instance that serves as both input and output
            if (0 == Volumes[current_volume]->p_physics->p_scattering_array[selected_process].scattering_function(k_new,k,&p,Volumes[current_volume]->p_physics->p_scattering_array[selected_process].data_transfer,&Volumes[current_volume]->geometry.focus_data_array.elements[0])) {
              /*
              // PowderN and Single_crystal requires the option of absorbing the neutron, which is weird. If there is a scattering probability, there should be a new direction.
              // It can arise from need to simplify sampling process and end up in cases where weight factor is 0, and the ray should be absorbed in these cases
              printf("ERROR: Union_master: %s.Absorbed ray because scattering function returned 0 (error/absorb)\n",NAME_CURRENT_COMP);
              component_error_msg++;
              if (component_error_msg > 100) {
                printf("To many errors encountered, exiting. \n");
                exit(1);
              }
              */
              ABSORB;
            }
            
            // Update velocity using k
            ray_velocity_rotated = coords_set(K2V*k_new[0],K2V*k_new[1],K2V*k_new[2]);
            
            // Transformation back to main coordinate system (maybe one should only do this when multiple scattering in that volume was over, especially if there is only one non isotropic frame)
            if (Volumes[current_volume]->p_physics->p_scattering_array[selected_process].non_isotropic_rot_index != -1) {
                ray_velocity_final = rot_apply(Volumes[current_volume]->geometry.transpose_process_rot_matrix_array[Volumes[current_volume]->p_physics->p_scattering_array[selected_process].non_isotropic_rot_index],ray_velocity_rotated);
            } else {
               ray_velocity_final = ray_velocity_rotated;
            }
            
            // Write velocity to global variable (temp, only really necessary at final)
            //vx = ray_velocity.x; vy = ray_velocity.y; vz = ray_velocity.z;
            coords_get(ray_velocity_final,&vx,&vy,&vz);
            
            // Write velocity in array format as it is still used by intersect functions (temp, they need to be updated to ray_position / ray_velocity)
            v[0] = vx; v[1] = vy; v[2] = vz;
            v_length = sqrt(vx*vx+vy*vy+vz*vz);
            k_new[0] = V2K*vx; k_new[1] = V2K*vy; k_new[2] = V2K*vz;
            if (verbal) if (v_length < 1) printf("velocity set to less than 1\n");
            
            #ifdef Union_trace_verbal_setting
              printf("Running logger system for specific volumes \n");
            #endif
            // Logging for detector components assosiated with this volume
            for (log_index=0;log_index<Volumes[current_volume]->loggers.num_elements;log_index++) {
              //printf("logging time! Volume specific version. Volume name = %s \n",Volumes[current_volume]->name);
              //printf("  log_index = %d \n",log_index);
              if (Volumes[current_volume]->loggers.p_logger_volume[log_index].p_logger_process[selected_process] != NULL) {
                // Technically the scattering function could edit k, the wavevector before the scattering, even though there would be little point to doing that.
                // Could save a secure copy and pass that instead to be certain that no scattering process accidently tampers with the logging.
                // printf("  the logging function pointer was not NULL \n");
                // PV (number of time scattered in this volume/process combination is not recorded. Need to expand scattering_flag to contain 2D, volume and process
                
                // This function calls a logger function which in turn stores some data among the passed, and possibly performs some basic data analysis
                Volumes[current_volume]->loggers.p_logger_volume[log_index].p_logger_process[selected_process]->function_pointers.active_record_function(&ray_position,k_new,k_old,p,p_old,t,scattered_flag[current_volume],scattered_flag_VP[current_volume][selected_process],number_of_scattering_events,Volumes[current_volume]->loggers.p_logger_volume[log_index].p_logger_process[selected_process],&loggers_with_data_array);
                // If the logging component have a conditional attatched, the collected data will be written to a temporary place
                // At the end of the rays life, it will be checked if the condition is met
                //  if it is met, the temporary data is transfered to permanent, and temp is cleared.
                //  if it is not met, the temporary data is cleared.
              }
            }
            
            #ifdef Union_trace_verbal_setting
              printf("Running logger system for all volumes \n");
            #endif
            for (log_index=0;log_index<global_all_volume_logger_list.num_elements;log_index++) {
              //printf("logging time! Global version. log_index = %d \n",log_index);
              // As above, but on a global scale, meaning scattering in all volumes are logged
              
              // Problems with VN, PV, as there is no assosiated volume or process. The functions however need to have the same input to make the logger components general.
              // Could be interesting to have a monitor that just globally measurres the second scattering event in any volume (must be two in the same). Weird but not meaningless.
              global_all_volume_logger_list.elements[log_index].logger->function_pointers.active_record_function(&ray_position,k_new,k_old,p,p_old,t,scattered_flag[current_volume],scattered_flag_VP[current_volume][selected_process],number_of_scattering_events,global_all_volume_logger_list.elements[log_index].logger,&loggers_with_data_array);
            }
            
            
            SCATTER;
            ++number_of_scattering_events;
            ++scattered_flag[current_volume];
            ++scattered_flag_VP[current_volume][selected_process];
            

            // Empty intersection time lists
            clear_intersection_table(&intersection_time_table);
            time_propagated_without_scattering = 0.0;
            #ifdef Union_trace_verbal_setting
              printf("SCATTERED SUCSSESFULLY \n");
              printf("r = (%f,%f,%f) v = (%f,%f,%f) \n",x,y,z,vx,vy,vz);
            
              if (enable_tagging && stop_tagging_ray == 0) printf("Before new process node: current_tagging_node->intensity = %f\n",current_tagging_node->intensity);
              if (enable_tagging && stop_tagging_ray == 0) printf("Before new process node: current_tagging_node->number_of_rays = %d\n",current_tagging_node->number_of_rays);
            #endif
            
            if (enable_tagging && stop_tagging_ray == 0)
                current_tagging_node = goto_process_node(current_tagging_node,selected_process,Volumes[current_volume],&stop_tagging_ray,stop_creating_nodes);
            
            #ifdef Union_trace_verbal_setting
              if (enable_tagging && stop_tagging_ray == 0) printf("After new process node: current_tagging_node->intensity = %f\n",current_tagging_node->intensity);
              if (enable_tagging && stop_tagging_ray == 0) printf("After new process node: current_tagging_node->number_of_rays = %d\n",current_tagging_node->number_of_rays);
            #endif
            
        } else {
            #ifdef Union_trace_verbal_setting
              printf("Propagate out of volume %d\n", current_volume);
              printf("r = (%f,%f,%f) v = (%f,%f,%f) \n",x,y,z,vx,vy,vz);
            #endif
            // Propagate neutron to found minimum time
            // PROP_DT(min_intersection_time - time_propagated_without_scattering);
            //time_to_boundery = min_intersection_time - time_propagated_without_scattering;
            x += time_to_boundery*vx;
            y += time_to_boundery*vy;
            z += time_to_boundery*vz;
            t += time_to_boundery;
            r[0] = x; r[1] = y; r[2] = z;
            ray_position = coords_set(x,y,z);
            ray_velocity = coords_set(vx,vy,vz);
            
            /*
            // Absorption moved to before testing if scattering occurs
            if (current_volume != 0) {
                if (Volumes[current_volume]->p_physics->is_vacuum == 0) {
                    // Absorption is done explicitly when propagating out of a volume, but between all scattering events is done implicitly
                   
                    // Old version
                    //length_to_boundery = (min_intersection_time - time_propagated_without_scattering) * v_length;
                    //p *= exp(-Volumes[current_volume]->p_physics->my_a*(2200/v_length)*length_to_boundery);
                    
                    if (Volumes[current_volume]->p_physics->number_of_processes == 0) {
                      // Optimized version
                      //p *= exp(-Volumes[current_volume]->p_physics->my_a*2200*time_to_boundery);
                    
                    //printf("name of material: %s \n",Volumes[current_volume]->name);
                    //printf("length to boundery  = %f\n",length_to_boundery);
                    //printf("absorption cross section  = %f\n",Volumes[current_volume]->p_physics->my_a);
                    //printf("chance to get through this length of absorber: %f \%\n",100*exp(-Volumes[current_volume]->p_physics->my_a*length_to_boundery));
                    }
                }
            }
            */
            
            time_propagated_without_scattering = min_intersection_time;
            SCATTER; // For debugging purposes
            #ifdef Union_trace_verbal_setting
              printf("r = (%f,%f,%f) v = (%f,%f,%f) \n",x,y,z,vx,vy,vz);
            #endif
            // Remove this entry from the intersection_time_table
            intersection_time_table.intersection_times[min_volume][min_solution] = -1;
            
            // Use destination list for corresponding intersection entry n,i) to find next volume
            #ifdef Union_trace_verbal_setting
              printf("PROPAGATION FROM VOLUME %d \n",current_volume);
            #endif
            if (min_volume == current_volume) {
                #ifdef Union_trace_verbal_setting
                  printf("min_volume == current_volume \n");
                #endif
                // List approach to finding the next volume.
                // When the ray intersects the current volume, the next volume must be on the destination list of the current volume
                // However, the reduced_destination_list can be investigated first, and depending on the results, the
                //  direct children of the volumes on the reduced destination list are investigated.
                // In the worst case, all direct children are investigated, which is eqvivalent to the entire destination list.
                // There is however a certain overhead in the logic needed to set up this tree, avoid duplicates of direct children, and so on.
                // This method is only faster than just checking the destination list when there are direct children (nested structures),
                //  but in general the tree method scales better with complexity, and is only slightly slower in simple cases.
                
                if (Volumes[current_volume]->geometry.destinations_list.num_elements == 1)
                    tree_next_volume = Volumes[current_volume]->geometry.destinations_list.elements[0];
                else {
                    ray_position = coords_set(x,y,z);
                    ray_velocity = coords_set(vx,vy,vz);
                    tree_next_volume = within_which_volume(ray_position,Volumes[current_volume]->geometry.reduced_destinations_list,Volumes[current_volume]->geometry.destinations_list,Volumes,&mask_status_list,number_of_volumes,pre_allocated1,pre_allocated2,pre_allocated3);
                }

                #ifdef Union_trace_verbal_setting
                  if (trace_verbal) printf("tree method moves from %d to %d\n",current_volume,tree_next_volume);
                
                  if (enable_tagging && stop_tagging_ray == 0) printf("Before new tree volume node: current_tagging_node->intensity = %f\n",current_tagging_node->intensity);
                  if (enable_tagging && stop_tagging_ray == 0) printf("Before new tree volume node: current_tagging_node->number_of_rays = %d\n",current_tagging_node->number_of_rays);
                #endif
                
                if (enable_tagging && stop_tagging_ray == 0)
                    current_tagging_node = goto_volume_node(current_tagging_node, current_volume, tree_next_volume, Volumes,&stop_tagging_ray,stop_creating_nodes);
                
                #ifdef Union_trace_verbal_setting
                  if (enable_tagging && stop_tagging_ray == 0) printf("After new tree volume node: current_tagging_node->intensity = %f\n",current_tagging_node->intensity);
                  if (enable_tagging && stop_tagging_ray == 0) printf("After new tree volume node: current_tagging_node->number_of_rays = %d\n",current_tagging_node->number_of_rays);
                #endif
                
                // Set next volume to the solution found in the tree method
                current_volume = tree_next_volume;
                update_current_mask_intersect_status(&current_mask_intersect_list_status, &mask_status_list, Volumes, &current_volume);
                #ifdef Union_trace_verbal_setting
                  print_1d_int_list(current_mask_intersect_list_status,"Updated current_mask_intersect_list_status");
                #endif
                
                
                // Debugging phase
                /*
                if (tree_next_volume == 0) {
                    volume_0_found=0;
                    for (start = check = Volumes[current_volume]->geometry.destinations_list.elements;check - start < Volumes[current_volume]->geometry.destinations_list.num_elements;check++) {
                        if (*check == 0) {
                            volume_0_found = 1;
                        }
                    }
                    if (volume_0_found==0) printf("ERROR The within_which_volume function returned 0 for a volume where volume 0 is not on the destination list!\n");
                }
                */
                
            } else {
                #ifdef Union_trace_verbal_setting
                  if (enable_tagging && stop_tagging_ray == 0) printf("Before new intersection volume node: current_tagging_node->intensity = %f\n",current_tagging_node->intensity);
                  if (enable_tagging && stop_tagging_ray == 0) printf("Before new intersection volume node: current_tagging_node->number_of_rays = %d\n",current_tagging_node->number_of_rays);
                #endif
            
                //if (enable_tagging) current_tagging_node = goto_volume_node(current_tagging_node, current_volume, min_volume, Volumes);
                
                
                
                // Mask update: If the min_volume is not a mask, things are simple, current_volume = min_volume.
                //               however, if it is a mask, the mask status will switch.
                //               if the mask status becomes one, the masked volumes inside may be the next volume (unless they are children of the mask)
                //               if the mask status becomes zero (and the current volume is masked by min_volume), the destinations list of the mask is searched
                //               if the mask status becomes zero (and the current volume is NOT masked by min volume), the current volume doesn't change
                
                
                if (Volumes[min_volume]->geometry.is_mask_volume == 0) {
                  #ifdef Union_trace_verbal_setting
                    printf("Min volume is not a mask, next volume = min volume\n");
                  #endif
                  if (enable_tagging && stop_tagging_ray == 0) current_tagging_node = goto_volume_node(current_tagging_node, current_volume, min_volume, Volumes,&stop_tagging_ray,stop_creating_nodes);
                  current_volume = min_volume;
                  //update_current_mask_intersect_status(&current_mask_intersect_list_status, &mask_status_list, Volumes, &current_volume);
                } else {
                  #ifdef Union_trace_verbal_setting
                    printf("Current volume is not a mask, complex decision tree\n");
                  #endif
                  if (mask_status_list.elements[Volumes[min_volume]->geometry.mask_index] == 1) {
                    // We are leaving the mask, change the status
                    #ifdef Union_trace_verbal_setting
                      printf("mask status changed from 1 to 0 as a mask is left\n");
                    #endif
                    mask_status_list.elements[Volumes[min_volume]->geometry.mask_index] = 0;
                    // If the current volume is masked by this mask, run within_which_volume using the masks destination list, otherwise keep the current volume
                    //if (on_int_list(Volumes[min_volume]->geometry.mask_list,current_volume))
                    if (on_int_list(Volumes[current_volume]->geometry.masked_by_list,min_volume) == 1) {
                      #ifdef Union_trace_verbal_setting
                        printf("The current volume was masked by this mask, and my need updating\n");
                      #endif
                      // In case of ANY mode, need to see if another mask on the masked_by list of the current volume is active, and if so, nothing happens
                      need_to_run_within_which_volume = 1;
                      if (Volumes[current_volume]->geometry.mask_mode == 2) {
                        for (mask_start=mask_check=Volumes[current_volume]->geometry.masked_by_mask_index_list.elements;mask_check-mask_start<Volumes[current_volume]->geometry.masked_by_mask_index_list.num_elements;mask_check++) {
                          if (mask_status_list.elements[*mask_check] == 1) {
                            // Nothing needs to be done, the effective mask status of the current volume is still 1
                            need_to_run_within_which_volume = 0;
                            break;
                          }
                        }
                      }
                      if (need_to_run_within_which_volume == 1) {
                        #ifdef Union_trace_verbal_setting
                          printf("The current volume was masked by this mask, and does need updating\n");
                        #endif
                        if (Volumes[min_volume]->geometry.destinations_list.num_elements == 1) {
                          #ifdef Union_trace_verbal_setting
                            printf("Only one element in the destination tree of the mask\n");
                          #endif
                          // If there is only one element on the destinations list (quite common) there is no reason to run within_which_volume
                          // Instead the mask status is calculated here
                          if (Volumes[Volumes[min_volume]->geometry.destinations_list.elements[0]]->geometry.is_masked_volume == 1) {
                            #ifdef Union_trace_verbal_setting
                              printf("The one element is however masked, so the mask status need to be calculated\n");
                            #endif
                            // figure out the effective mask status of this volume
                            if (Volumes[Volumes[min_volume]->geometry.destinations_list.elements[0]]->geometry.mask_mode == 2) { // ANY mask mode
                              tree_next_volume = 0;
                              for (mask_start=mask_check=Volumes[Volumes[min_volume]->geometry.destinations_list.elements[0]]->geometry.masked_by_mask_index_list.elements;mask_check-mask_start<Volumes[Volumes[min_volume]->geometry.destinations_list.elements[0]]->geometry.masked_by_mask_index_list.num_elements;mask_check++) {
                                if (mask_status_list.elements[*mask_check] == 1) {
                                  tree_next_volume = Volumes[min_volume]->geometry.destinations_list.elements[0];
                                  break;
                                }
                              }
                            } else { // ALL mask mode
                              tree_next_volume = Volumes[min_volume]->geometry.destinations_list.elements[0];
                              for (mask_start=mask_check=Volumes[Volumes[min_volume]->geometry.destinations_list.elements[0]]->geometry.masked_by_mask_index_list.elements;mask_check-mask_start<Volumes[Volumes[min_volume]->geometry.destinations_list.elements[0]]->geometry.masked_by_mask_index_list.num_elements;mask_check++) {
                                if (mask_status_list.elements[*mask_check] == 0) {
                                  tree_next_volume = 0;
                                  break;
                                }
                              }
                            }
                          } else tree_next_volume = Volumes[min_volume]->geometry.destinations_list.elements[0];
                          #ifdef Union_trace_verbal_setting
                            printf("The method found the next tree volume to be %d\n",tree_next_volume);
                          #endif
                          if (enable_tagging && stop_tagging_ray == 0) current_tagging_node = goto_volume_node(current_tagging_node, current_volume, tree_next_volume, Volumes,&stop_tagging_ray,stop_creating_nodes);
                          current_volume = tree_next_volume;
                          //update_current_mask_intersect_status(&current_mask_intersect_list_status, &mask_status_list, Volumes, &current_volume);
                        } else {
                          #ifdef Union_trace_verbal_setting
                            printf("Many elements in destinations list, use within_which_volume\n");
                          #endif
                          ray_position = coords_set(x,y,z);
                          ray_velocity = coords_set(vx,vy,vz);
                          tree_next_volume = within_which_volume(ray_position,Volumes[min_volume]->geometry.reduced_destinations_list,Volumes[min_volume]->geometry.destinations_list,Volumes,&mask_status_list,number_of_volumes,pre_allocated1,pre_allocated2,pre_allocated3);
                        // } Bug fixed on 27/11/2016
                          if (enable_tagging && stop_tagging_ray == 0) current_tagging_node = goto_volume_node(current_tagging_node, current_volume, tree_next_volume, Volumes,&stop_tagging_ray,stop_creating_nodes);
                          current_volume = tree_next_volume;
                          #ifdef Union_trace_verbal_setting
                            printf("Set new new volume to %d\n",tree_next_volume);
                          #endif
                        } // Moved here on 27/11/2016, problem was two calls to current_tagging_node when only one element in destinations list
                        //update_current_mask_intersect_status(&current_mask_intersect_list_status, &mask_status_list, Volumes, &current_volume);
                      } else {
                        #ifdef Union_trace_verbal_setting
                          printf("Did not need updating, as another mask was covering the volume\n");
                        #endif
                      }
                    }

                  } else {
                    // Here beccause the mask status of the mask that is intersected was 0, and it is thus switched to 1
                    mask_status_list.elements[Volumes[min_volume]->geometry.mask_index] = 1;
                    // When entering a mask, the new highest priority volume may be one of the masked volumes, if not we keep the current volume
                    ray_position = coords_set(x,y,z);
                    ray_velocity = coords_set(vx,vy,vz);
                    //tree_next_volume = within_which_volume(ray_position,Volumes[min_volume]->geometry.mask_list,Volumes[min_volume]->geometry.destinations_list,Volumes,&mask_status_list,number_of_volumes,pre_allocated1,pre_allocated2,pre_allocated3);
                    // Bug found on the 2/9 2016, the destinations_list of a mask does not contain the volumes inside it. Could make an additional list for this.
                    // The temporary fix will be to use the mask list for both reduced destinations list and destinations list.
                    tree_next_volume = within_which_volume(ray_position,Volumes[min_volume]->geometry.mask_list,Volumes[min_volume]->geometry.mask_list,Volumes,&mask_status_list,number_of_volumes,pre_allocated1,pre_allocated2,pre_allocated3);
                    // if within_which_volume returns 0, no result was found (volume 0 can not be masked, so it could not be on the mask list)
                    if (tree_next_volume != 0) {
                      if (Volumes[tree_next_volume]->geometry.priority_value > Volumes[current_volume]->geometry.priority_value) {
                        // In case the current volume has a higher priority, nothing happens, otherwise change current volume
                        if (enable_tagging && stop_tagging_ray == 0) current_tagging_node = goto_volume_node(current_tagging_node, current_volume, tree_next_volume, Volumes,&stop_tagging_ray,stop_creating_nodes);
                        current_volume = tree_next_volume;
                      }
                    }
                    //update_current_mask_intersect_status(&current_mask_intersect_list_status, &mask_status_list, Volumes, &current_volume);
                  }
                }
                
                // Regardless of the outcome of the above code, either the mask status or current volume have changed, and thus a effective mask update is needed.
                update_current_mask_intersect_status(&current_mask_intersect_list_status, &mask_status_list, Volumes, &current_volume);
                #ifdef Union_trace_verbal_setting
                  print_1d_int_list(mask_status_list,"Updated mask status list");
                  print_1d_int_list(current_mask_intersect_list_status,"Updated current_mask_intersect_list_status");
                
                  if (enable_tagging) printf("After new intersection volume node: current_tagging_node->intensity = %f\n",current_tagging_node->intensity);
                  if (enable_tagging) printf("After new intersection volume node: current_tagging_node->number_of_rays = %d\n",current_tagging_node->number_of_rays);
                #endif
                
            }
            if (Volumes[current_volume]->geometry.is_exit_volume==1) {
                    done = 1; // Exit volumes allow the ray to escape the component
                    ray_sucseeded = 1; // Allows the ray to
                    /*
                    // Moved to after while loop to collect code
                    if (enable_tagging && stop_tagging_ray == 0)
                        add_statistics_to_node(current_tagging_node,&ray_position, &ray_velocity, &p, &tagging_leaf_counter);
                
                    x += vx*1E-9; y += vy*1E-9; z += vz*1E-9; t += 1E-9;
                    */
            }
            #ifdef Union_trace_verbal_setting
              printf(" TO VOLUME %d \n",current_volume);
            #endif
        }
    } else { // Here because a shortest time is not found
        if (current_volume == 0) {
            done = 1;
            ray_sucseeded = 1;
            
        } else { // Check for errors (debugging phase)
            if (error_msg == 0) {
              component_error_msg++;
              ray_sucseeded = 0;
              done = 1; // stop the loop
              printf("\n----------------------------------------------------------------------------------------------------\n");
              printf("Union_master %s: Somehow reached a situation with no intersection time found, but still inside volume %d instead of 0\n",NAME_CURRENT_COMP,current_volume);
              for (volume_index = 1; volume_index < number_of_volumes; volume_index++) {
                if (Volumes[volume_index]->geometry.within_function(ray_position,&Volumes[volume_index]->geometry) == 1)
                    printf("The ray is in volume       %d\n",volume_index);
              }
              
              print_1d_int_list(mask_status_list,"mask status list");
              for (iterate=0;iterate<number_of_volumes;iterate++)
                 printf("%d:%d - ",iterate,scattered_flag[iterate]);
              printf("\n");
              printf("r = (%f,%f,%f) v = (%f,%f,%f) \n",x,y,z,vx,vy,vz);
              
              printf("Trace error number (%d/100) \n",component_error_msg);
              //print_intersection_table(intersection_time_table);
              //printf("Cluster is loosing the thread, debug for this behavior\n");
              //printf("global_all_volume_logger_list.num_elements = %d\n",global_all_volume_logger_list.num_elements);
              //printf("global_specific_volumes_logger_list.num_elements = %d\n",global_specific_volumes_logger_list.num_elements);
              
              //exit(1); // Temporary
            }
            error_msg++;
            
            //exit(1); // temp for debug
            
            if (component_error_msg > 100) {
                printf("To many errors encountered, exiting. \n");
                exit(1);
            }
        }
    }
    /*
    */
    if (limit == 0) {done = 1; ray_sucseeded = 0; printf("Reached limit on number of interactions, and discarded the neutron, was in volume %d\n",current_volume);ABSORB;}
    #ifdef Union_trace_verbal_setting
      printf("----------- END OF WHILE LOOP --------------------------------------\n");
    #endif
    //printf("This ray did %d iterations in the while loop\n",1000-limit);
    
  }
  // Could move all add_statistics and similar to this point, but need to filter for failed rays
  if (ray_sucseeded == 1) {
    
    /*
    // Instead of keeping global and specific loggers apart, lets do them in one loop using the loggers_with_data_array
    // Only needed for conditionals
    // Loop over global loggers, may or may not have a conditional, only necessary to do anything here when they do.
    for (log_index=0;log_index<global_all_volume_logger_list.num_elements;log_index++) {
      if (global_all_volume_logger_list.elements[log_index].logger->has_conditional == 1) {
        if (1 == conditional_return = global_all_volume_logger_list.elements[log_index].logger->conditional(scattered_flag,scattered_flag_VP,global_loggers.elements[log_index].conditional_data_union,k_final,current_volume,x,y,z)) {
          global_all_volume_logger_list.elements[log_index].logger->function_pointers->temp_to_perm(global_loggers.elements[log_index].logger_data_union);
          
        }
        if (global_all_volume_logger_list.elements[log_index].logger->conditional_extend_index != -1)
          // The user can set a condtional_extend_index, so that the evaluation of this specific conditional can be taken easily from extend
          conditional_extend_array.elements[global_all_volume_logger_list.elements[log_index].logger->conditional_extend_index] = conditional_return;
          // Do not need to reset these to 0, as they will be manually set to 0 if not fulfilled
      }
    }
    */
    #ifdef Union_trace_verbal_setting
      printf("----------- logger loop --------------------------------------\n");
    #endif
    // Loggers attatched to specific volumes need to be handled with care to avoid looping over all loggers for every ray
    //for (log_index=0;log_index<loggers_with_data_array.used_elements;log_index++) {
    // TEST
    if (enable_conditionals == 1) {
      for (log_index=loggers_with_data_array.used_elements-1;log_index>-1;log_index--) {
        // Check all conditionals attatched to the current logger
        this_logger = loggers_with_data_array.logger_pointers[log_index];
        conditional_status = 1;
        for (iterate=0;iterate<loggers_with_data_array.logger_pointers[log_index]->conditional_list.num_elements;iterate++) {
          // Call this particular conditional. If it fails, report the status and break
          //printf("checking conditional! \n");
          #ifdef Union_trace_verbal_setting
            printf("Checking conditional number %d for logger named %s \n",iterate,loggers_with_data_array.logger_pointers[log_index]->name);
          #endif
          if (0 == this_logger->conditional_list.conditional_functions[iterate](
                         this_logger->conditional_list.p_data_unions[iterate],
                         &ray_position,&ray_velocity,&p,&t,&current_volume,
                         &number_of_scattering_events,scattered_flag,scattered_flag_VP)) {
            conditional_status = 0;
            break;
          }
        }
        if (conditional_status == 1) {
          // If a logger does not have a conditional, it will write directly to perm, and not even add it to the loggers_with_data_array, thus we know the temp_to_perm function needs to be called
          // The input for the temp_to_perm function is a pointer to the logger_data_union for the appropriate logger
          
          if (loggers_with_data_array.logger_pointers[log_index]->function_pointers.select_t_to_p == 1) {
            loggers_with_data_array.logger_pointers[log_index]->function_pointers.temp_to_perm(&loggers_with_data_array.logger_pointers[log_index]->data_union);
          }
          else if (loggers_with_data_array.logger_pointers[log_index]->function_pointers.select_t_to_p == 2) {
            loggers_with_data_array.logger_pointers[log_index]->function_pointers.temp_to_perm_final_p(&loggers_with_data_array.logger_pointers[log_index]->data_union,p);
          }
        
          // Luxury feature to be added later
          if (loggers_with_data_array.logger_pointers[log_index]->logger_extend_index != -1) {
            #ifdef Union_trace_verbal_setting
              printf("Updating logger_conditional_extend_array[%d] to 1 (max length = %d)\n",loggers_with_data_array.logger_pointers[log_index]->logger_extend_index,max_conditional_extend_index);
            #endif
            // The user can set a condtional_extend_index, so that the evaluation of this specific conditional can be taken easily from extend
            logger_conditional_extend_array[loggers_with_data_array.logger_pointers[log_index]->logger_extend_index] = 1;
            // Are all reset to 0 for each new ray
            #ifdef Union_trace_verbal_setting
              printf("Updated extend index sucessfully\n");
            #endif
          
            //printf("extend_array[%d] = 1 \n",loggers_with_data_array.logger_pointers[log_index]->logger_extend_index);
          }
        
          // Need to remove the current element from logger_with_data as it has been cleared and written to disk
          // The remaining elements is passed on to the next Union_master as it may fulfill the conditional after that master
          if (global_master_list.elements[global_master_list.num_elements-1].component_index != INDEX_CURRENT_COMP) {
            // Move current logger pointer in logger_with_data to end position
            loggers_with_data_array.logger_pointers[log_index] = loggers_with_data_array.logger_pointers[loggers_with_data_array.used_elements-1];
            // Decrease logger_with_data.used_elements with 1
            loggers_with_data_array.used_elements--;
          
          }
        
        
        } else {
           // Conditional status was 0, clear temp data for this logger, but only if this is the last Union_master,
           //  as the logger data can be written if one of the ray fulfills the conditional afer one of the
           //  subsequent Union masters.
           // The job of cleaning was moved to the start of trace on 15/5/2017
           //if (global_master_list.elements[global_master_list.num_elements-1].component_index == INDEX_CURRENT_COMP)
           //  loggers_with_data_array.logger_pointers[log_index]->function_pointers.clear_temp(&loggers_with_data_array.logger_pointers[log_index]->data_union);
        }
      }
    }
    
    if (enable_tagging && stop_tagging_ray == 0) {
      conditional_status = 1;
      for (iterate=0;iterate<tagging_conditional_list->num_elements;iterate++) {
        // Call this particular conditional. If it fails, report the status and break
        // Since a conditional can work for a logger and master_tagging at the same time, it may be evaluated twice
        //printf("checking conditional! \n");
        #ifdef Union_trace_verbal_setting
          printf("Checking tagging conditional number %d\n",iterate);
        #endif
        if (0 == tagging_conditional_list->conditional_functions[iterate](
                         tagging_conditional_list->p_data_unions[iterate],
                         &ray_position,&ray_velocity,&p,&t,&current_volume,
                         &number_of_scattering_events,scattered_flag,scattered_flag_VP)) {
          conditional_status = 0;
          break;
        }
      }
      if (conditional_status == 1) {
        tagging_conditional_extend = 1;
        #ifdef Union_trace_verbal_setting
          printf("Before adding statistics to node: current_tagging_nodbe->intensity = %f\n",current_tagging_node->intensity);
          printf("Before adding statistics to node: current_tagging_node->number_of_rays = %d\n",current_tagging_node->number_of_rays);
        #endif
        
          add_statistics_to_node(current_tagging_node,&ray_position, &ray_velocity, &p, &tagging_leaf_counter);
        
        #ifdef Union_trace_verbal_setting
          printf("After adding statistics to node: current_tagging_node->intensity = %f\n",current_tagging_node->intensity);
          printf("After adding statistics to node: current_tagging_node->number_of_rays = %d\n",current_tagging_node->number_of_rays);
        #endif
      }
    }
    
    // Move the rays a nano meter away from the surface it left, in case activation counter > 1, this will prevent the ray from starting on a volume boundery
    x += vx*1E-9; y += vy*1E-9; z += vz*1E-9; t += 1E-9;
        
  } else {
    ABSORB; // Absorb rays that didn't exit correctly for whatever reason
    // Could error log here
  }
  
  // TEST
  // Stores nubmer of scattering events in global master list so that another master with inherit_number_of_scattering_events can continue
  global_master_list.elements[this_global_master_index].stored_number_of_scattering_events = number_of_scattering_events;
  
  
}
#line 352247 "MACS_sample_kidney_box.c"
/* 'sample_cryostat=Union_master()' component instance extend code */
    SIG_MESSAGE("sample_cryostat (Trace:Extend)");
#line 730 "MACS_sample_kidney_box.instr"
  scatter_events_in_sample = scattered_flag[1];
  scatter_events_in_sample_environment = number_of_scattering_events - scatter_events_in_sample;
  if (scatter_events_in_sample_environment == 0) only_sample_scattering = 1;
  else only_sample_scattering = 0;
  
  //number_of_volumes_sample_main = number_of_volumes;
  
  for (flag_index=0;flag_index<number_of_volumes;flag_index++) scattering_history_sample_master[flag_index] = scattered_flag[flag_index];
#line 352259 "MACS_sample_kidney_box.c"
}   /* End of sample_cryostat=Union_master() SETTING parameter declarations. */
#undef focus_data_index
#undef temporary_focus_data
#undef number_of_processes_array
#undef safty_distance2
#undef safty_distance
#undef max_conditional_extend_index
#undef tagging_conditional_extend
#undef logger_conditional_extend_array
#undef free_tagging_conditioanl_list
#undef tagging_conditional_list
#undef conditional_status
#undef this_logger
#undef p_old
#undef Volume_copies_allocated
#undef geometry_component_index_list
#undef mask_volume_index_list
#undef current_mask_intersect_list_status
#undef mask_status_list
#undef mask_iterate
#undef mask_index_main
#undef need_to_run_within_which_volume
#undef number_of_masked_volumes
#undef number_of_masks
#undef mc_transmission_probability
#undef real_transmission_probability
#undef number_of_scattering_events
#undef tagging_leaf_counter
#undef current_tagging_node
#undef master_tagging_node_list
#undef enable_tagging_check
#undef stop_creating_nodes
#undef stop_tagging_ray
#undef enable_tagging
#undef rotated_position
#undef non_rotated_position
#undef temp_rotation_matrix
#undef master_transposed_rotation_matrix
#undef scattered_flag_VP
#undef scattered_flag
#undef volume_0_found
#undef ray_velocity_final
#undef ray_velocity
#undef ray_position
#undef pre_allocated3
#undef pre_allocated2
#undef pre_allocated1
#undef tree_next_volume
#undef geometry_output
#undef intersection_with_children
#undef start
#undef check
#undef number_of_solutions_static
#undef number_of_solutions
#undef current_volume
#undef done
#undef next_volume_priority
#undef next_volume
#undef a_next_volume_found
#undef time_propagated_without_scattering
#undef scattering_event
#undef selected_process
#undef time_to_boundery
#undef length_to_boundery
#undef length_to_scattering
#undef time_to_scattering
#undef mc_prop
#undef culmative_probability
#undef my_sum_plus_abs
#undef my_sum
#undef v_length
#undef k_old
#undef k_new
#undef k
#undef my_trace_fraction_control
#undef p_my_trace
#undef my_trace
#undef process_start
#undef process
#undef min_intersection_time
#undef intersection_time
#undef time_found
#undef min_volume
#undef min_solution
#undef solution
#undef limit
#undef max_number_of_processes
#undef solutions
#undef process_index
#undef volume_index
#undef number_of_volumes
#undef string_output
#undef component_error_msg
#undef error_msg
#undef v
#undef r_start
#undef r
#undef starting_lists
#undef Geometries
#undef Volumes
#undef intersection_time_table
#undef geometry_list_index
#undef previous_master_index
#undef this_global_master_index
#undef global_master_element
#undef starting_volume_warning
#undef finally_verbal
#undef trace_verbal
#undef list_verbal
#undef verbal
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex
  /* Label for restoring  neutron */
  mcabsorbCompsample_cryostat:
  if (RESTORE) /* restore if needed */
  { RESTORE_NEUTRON(45,
      mcnlx,
      mcnly,
      mcnlz,
      mcnlvx,
      mcnlvy,
      mcnlvz,
      mcnlt,
      mcnlsx,
      mcnlsy,
      mcnlsz,
      mcnlp); }
#undef mcabsorbComp
#undef p
#undef sz
#undef sy
#undef sx
#undef t
#undef vz
#undef vy
#undef vx
#undef z
#undef y
#undef x
  mcDEBUG_STATE(
mcnlx,
mcnly,
mcnlz,
mcnlvx,
mcnlvy,
mcnlvz,
mcnlt,
mcnlsx,
mcnlsy,
mcnlsz,
mcnlp)

  /* TRACE Component Resolution_sample [46] */
  mccoordschange(mcposrResolution_sample, mcrotrResolution_sample,
    &mcnlx,
    &mcnly,
    &mcnlz,
    &mcnlvx,
    &mcnlvy,
    &mcnlvz,
    &mcnlsx,
    &mcnlsy,
    &mcnlsz);
  /* define label inside component Resolution_sample (without coords transformations) */
  mcJumpTrace_Resolution_sample:
  SIG_MESSAGE("Resolution_sample (Trace)");
  mcDEBUG_COMP("Resolution_sample")
  mcDEBUG_STATE(
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp)
#define x mcnlx
#define y mcnly
#define z mcnlz
#define vx mcnlvx
#define vy mcnlvy
#define vz mcnlvz
#define t mcnlt
#define sx mcnlsx
#define sy mcnlsy
#define sz mcnlsz
#define p mcnlp

#define mcabsorbComp mcabsorbCompResolution_sample
  STORE_NEUTRON(46,
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp);
  mcScattered=0;
  mcRestore=0;
  mcNCounter[46]++;
  mcPCounter[46] += p;
  mcP2Counter[46] += p*p;
#define mccompcurname  Resolution_sample
#define mccompcurtype  Res_sample
#define mccompcurindex 46
#define res_struct mccResolution_sample_res_struct
{   /* Declarations of Resolution_sample=Res_sample() SETTING parameters. */
MCNUM thickness = mccResolution_sample_thickness;
MCNUM radius = mccResolution_sample_radius;
MCNUM focus_r = mccResolution_sample_focus_r;
MCNUM E0 = mccResolution_sample_E0;
MCNUM dE = mccResolution_sample_dE;
MCNUM target_x = mccResolution_sample_target_x;
MCNUM target_y = mccResolution_sample_target_y;
MCNUM target_z = mccResolution_sample_target_z;
MCNUM focus_xw = mccResolution_sample_focus_xw;
MCNUM focus_yh = mccResolution_sample_focus_yh;
MCNUM focus_aw = mccResolution_sample_focus_aw;
MCNUM focus_ah = mccResolution_sample_focus_ah;
MCNUM xwidth = mccResolution_sample_xwidth;
MCNUM yheight = mccResolution_sample_yheight;
MCNUM zdepth = mccResolution_sample_zdepth;
int target_index = mccResolution_sample_target_index;
/* 'Resolution_sample=Res_sample()' component instance has conditional execution */
if (( mcipresolution_mode == 1 ))

#line 129 "/usr/share/mcstas/2.7/samples/Res_sample.comp"
{
  double t0, t3;                /* Entry/exit time for outer cylinder */
  double t1, t2;                /* Entry/exit time for inner cylinder */
  double v;                     /* Neutron velocity */
  double E;
  double l_full;                /* Flight path length for non-scattered neutron */
  double dt0, dt1, dt2, dt;     /* Flight times through sample */
  double solid_angle=0;         /* Solid angle of target as seen from scattering point */
  double aim_x, aim_y, aim_z;   /* Position of target relative to scattering point */
  double scat_factor;           /* Simple cross-section model */
  int    intersect=0;

  if(res_struct.isrect)
    intersect = box_intersect(&t0, &t3, x, y, z, vx, vy, vz, xwidth, yheight, zdepth);
  else
    intersect = cylinder_intersect(&t0, &t3, x, y, z, vx, vy, vz, radius, yheight);

  if(intersect)
  {
    if(t0 < 0) ABSORB;
    if(res_struct.isrect) { t1 = t2 = t3; scat_factor = 2*zdepth; } /* box sample */
    else {  /* Hollow cylinder sample */
      /* Neutron enters at t=t0. */
      if(!thickness || !cylinder_intersect(&t1, &t2, x, y, z, vx, vy, vz, radius-thickness, yheight))
        t1 = t2 = t3;
      scat_factor = 2*radius; }
    dt0 = t1-t0;                  /* Time in sample, ingoing */
    dt1 = t2-t1;                  /* Time in hole */
    dt2 = t3-t2;                  /* Time in sample, outgoing */
    v = sqrt(vx*vx + vy*vy + vz*vz);
    l_full = v * (dt0 + dt2);     /* Length of full path through sample */
    p *= l_full/scat_factor;      /* Scattering probability */
    dt = rand01()*(dt0+dt2);      /* Time of scattering (relative to t0) */
    if (dt > dt0)
      dt += dt1;

    PROP_DT(dt+t0);             /* Point of scattering */

    /* Store initial neutron state. */
    if(p == 0) ABSORB;
    res_struct.pi = p;
    res_struct.ki_x = V2K*vx;
    res_struct.ki_y = V2K*vy;
    res_struct.ki_z = V2K*vz;
    res_struct.rx = x;
    res_struct.ry = y;
    res_struct.rz = z;

    aim_x = res_struct.tx-x;         /* Vector pointing at target (anal./det.) */
    aim_y = res_struct.ty-y;
    aim_z = res_struct.tz-z;
    if(res_struct.aw && res_struct.ah) {
        randvec_target_rect_angular(&vx, &vy, &vz, &solid_angle,
          aim_x, aim_y, aim_z, res_struct.aw, res_struct.ah, ROT_A_CURRENT_COMP);
    } else if(res_struct.xw && res_struct.yh) {
        randvec_target_rect(&vx, &vy, &vz, &solid_angle,
          aim_x, aim_y, aim_z, res_struct.xw, res_struct.yh, ROT_A_CURRENT_COMP);
    } else {
        randvec_target_circle(&vx, &vy, &vz, &solid_angle,
          aim_x, aim_y, aim_z, focus_r);
    }
    NORM(vx, vy, vz);
    E=E0+dE*randpm1();
    v=sqrt(E)*SE2V;
    vx *= v;
    vy *= v;
    vz *= v;
    SCATTER;

      /* Store final neutron state. */
    res_struct.kf_x = V2K*vx;
    res_struct.kf_y = V2K*vy;
    res_struct.kf_z = V2K*vz;
  }
}
#line 352569 "MACS_sample_kidney_box.c"
}   /* End of Resolution_sample=Res_sample() SETTING parameter declarations. */
#undef res_struct
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex
  /* Label for restoring  neutron */
  mcabsorbCompResolution_sample:
  if (RESTORE) /* restore if needed */
  { RESTORE_NEUTRON(46,
      mcnlx,
      mcnly,
      mcnlz,
      mcnlvx,
      mcnlvy,
      mcnlvz,
      mcnlt,
      mcnlsx,
      mcnlsy,
      mcnlsz,
      mcnlp); }
#undef mcabsorbComp
#undef p
#undef sz
#undef sy
#undef sx
#undef t
#undef vz
#undef vy
#undef vx
#undef z
#undef y
#undef x
  mcDEBUG_STATE(
mcnlx,
mcnly,
mcnlz,
mcnlvx,
mcnlvy,
mcnlvz,
mcnlt,
mcnlsx,
mcnlsy,
mcnlsz,
mcnlp)

  /* TRACE Component post_sample_beamstop [47] */
  mccoordschange(mcposrpost_sample_beamstop, mcrotrpost_sample_beamstop,
    &mcnlx,
    &mcnly,
    &mcnlz,
    &mcnlvx,
    &mcnlvy,
    &mcnlvz,
    &mcnlsx,
    &mcnlsy,
    &mcnlsz);
  /* define label inside component post_sample_beamstop (without coords transformations) */
  mcJumpTrace_post_sample_beamstop:
  SIG_MESSAGE("post_sample_beamstop (Trace)");
  mcDEBUG_COMP("post_sample_beamstop")
  mcDEBUG_STATE(
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp)
#define x mcnlx
#define y mcnly
#define z mcnlz
#define vx mcnlvx
#define vy mcnlvy
#define vz mcnlvz
#define t mcnlt
#define sx mcnlsx
#define sy mcnlsy
#define sz mcnlsz
#define p mcnlp

#define mcabsorbComp mcabsorbComppost_sample_beamstop
  STORE_NEUTRON(47,
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp);
  mcScattered=0;
  mcRestore=0;
  mcNCounter[47]++;
  mcPCounter[47] += p;
  mcP2Counter[47] += p*p;
#define mccompcurname  post_sample_beamstop
#define mccompcurtype  Beamstop
#define mccompcurindex 47
{   /* Declarations of post_sample_beamstop=Beamstop() SETTING parameters. */
MCNUM xmin = mccpost_sample_beamstop_xmin;
MCNUM xmax = mccpost_sample_beamstop_xmax;
MCNUM ymin = mccpost_sample_beamstop_ymin;
MCNUM ymax = mccpost_sample_beamstop_ymax;
MCNUM xwidth = mccpost_sample_beamstop_xwidth;
MCNUM yheight = mccpost_sample_beamstop_yheight;
MCNUM radius = mccpost_sample_beamstop_radius;
#line 59 "/usr/share/mcstas/2.7/optics/Beamstop.comp"
{
    double Time = t;
    ALLOW_BACKPROP;
    PROP_Z0;
    Time = t - Time;
    if (((Time>=0) && ((radius!=0) && (x*x + y*y <= radius*radius)))
    || ((Time>=0) && (radius==0) && (x>xmin && x<xmax && y>ymin && y<ymax)))
      ABSORB;
    else
      RESTORE_NEUTRON(INDEX_CURRENT_COMP, x, y, z, vx, vy, vz, t, sx, sy, sz, p);
}
#line 352695 "MACS_sample_kidney_box.c"
}   /* End of post_sample_beamstop=Beamstop() SETTING parameter declarations. */
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex
  /* Label for restoring  neutron */
  mcabsorbComppost_sample_beamstop:
  if (RESTORE) /* restore if needed */
  { RESTORE_NEUTRON(47,
      mcnlx,
      mcnly,
      mcnlz,
      mcnlvx,
      mcnlvy,
      mcnlvz,
      mcnlt,
      mcnlsx,
      mcnlsy,
      mcnlsz,
      mcnlp); }
#undef mcabsorbComp
#undef p
#undef sz
#undef sy
#undef sx
#undef t
#undef vz
#undef vy
#undef vx
#undef z
#undef y
#undef x
  mcDEBUG_STATE(
mcnlx,
mcnly,
mcnlz,
mcnlvx,
mcnlvy,
mcnlvz,
mcnlt,
mcnlsx,
mcnlsy,
mcnlsz,
mcnlp)

  /* TRACE Component kidney_master [48] */
  mccoordschange(mcposrkidney_master, mcrotrkidney_master,
    &mcnlx,
    &mcnly,
    &mcnlz,
    &mcnlvx,
    &mcnlvy,
    &mcnlvz,
    &mcnlsx,
    &mcnlsy,
    &mcnlsz);
  /* define label inside component kidney_master (without coords transformations) */
  mcJumpTrace_kidney_master:
  SIG_MESSAGE("kidney_master (Trace)");
  mcDEBUG_COMP("kidney_master")
  mcDEBUG_STATE(
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp)
#define x mcnlx
#define y mcnly
#define z mcnlz
#define vx mcnlvx
#define vy mcnlvy
#define vz mcnlvz
#define t mcnlt
#define sx mcnlsx
#define sy mcnlsy
#define sz mcnlsz
#define p mcnlp

#define mcabsorbComp mcabsorbCompkidney_master
  STORE_NEUTRON(48,
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp);
  mcScattered=0;
  mcRestore=0;
  mcNCounter[48]++;
  mcPCounter[48] += p;
  mcP2Counter[48] += p*p;
#define mccompcurname  kidney_master
#define mccompcurtype  Arm
#define mccompcurindex 48
/* 'kidney_master=Arm()' component instance extend code */
    SIG_MESSAGE("kidney_master (Trace:Extend)");
#line 6 "generated_includes/kidney_trace.c"
    channel_selected = -1;
#line 352804 "MACS_sample_kidney_box.c"
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex
  /* Label for restoring  neutron */
  mcabsorbCompkidney_master:
  if (RESTORE) /* restore if needed */
  { RESTORE_NEUTRON(48,
      mcnlx,
      mcnly,
      mcnlz,
      mcnlvx,
      mcnlvy,
      mcnlvz,
      mcnlt,
      mcnlsx,
      mcnlsy,
      mcnlsz,
      mcnlp); }
#undef mcabsorbComp
#undef p
#undef sz
#undef sy
#undef sx
#undef t
#undef vz
#undef vy
#undef vx
#undef z
#undef y
#undef x
  mcDEBUG_STATE(
mcnlx,
mcnly,
mcnlz,
mcnlvx,
mcnlvy,
mcnlvz,
mcnlt,
mcnlsx,
mcnlsy,
mcnlsz,
mcnlp)

  /* TRACE Component kidney_channel_0 [49] */
  mccoordschange(mcposrkidney_channel_0, mcrotrkidney_channel_0,
    &mcnlx,
    &mcnly,
    &mcnlz,
    &mcnlvx,
    &mcnlvy,
    &mcnlvz,
    &mcnlsx,
    &mcnlsy,
    &mcnlsz);
  /* define label inside component kidney_channel_0 (without coords transformations) */
  mcJumpTrace_kidney_channel_0:
  SIG_MESSAGE("kidney_channel_0 (Trace)");
  mcDEBUG_COMP("kidney_channel_0")
  mcDEBUG_STATE(
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp)
#define x mcnlx
#define y mcnly
#define z mcnlz
#define vx mcnlvx
#define vy mcnlvy
#define vz mcnlvz
#define t mcnlt
#define sx mcnlsx
#define sy mcnlsy
#define sz mcnlsz
#define p mcnlp

#define mcabsorbComp mcabsorbCompkidney_channel_0
  STORE_NEUTRON(49,
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp);
  mcScattered=0;
  mcRestore=0;
  mcNCounter[49]++;
  mcPCounter[49] += p;
  mcP2Counter[49] += p*p;
#define mccompcurname  kidney_channel_0
#define mccompcurtype  Arm
#define mccompcurindex 49
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex
  /* Label for restoring  neutron */
  mcabsorbCompkidney_channel_0:
  if (RESTORE) /* restore if needed */
  { RESTORE_NEUTRON(49,
      mcnlx,
      mcnly,
      mcnlz,
      mcnlvx,
      mcnlvy,
      mcnlvz,
      mcnlt,
      mcnlsx,
      mcnlsy,
      mcnlsz,
      mcnlp); }
#undef mcabsorbComp
#undef p
#undef sz
#undef sy
#undef sx
#undef t
#undef vz
#undef vy
#undef vx
#undef z
#undef y
#undef x
  mcDEBUG_STATE(
mcnlx,
mcnly,
mcnlz,
mcnlvx,
mcnlvy,
mcnlvz,
mcnlt,
mcnlsx,
mcnlsy,
mcnlsz,
mcnlp)

  /* TRACE Component kidney_channel_1 [50] */
  mccoordschange(mcposrkidney_channel_1, mcrotrkidney_channel_1,
    &mcnlx,
    &mcnly,
    &mcnlz,
    &mcnlvx,
    &mcnlvy,
    &mcnlvz,
    &mcnlsx,
    &mcnlsy,
    &mcnlsz);
  /* define label inside component kidney_channel_1 (without coords transformations) */
  mcJumpTrace_kidney_channel_1:
  SIG_MESSAGE("kidney_channel_1 (Trace)");
  mcDEBUG_COMP("kidney_channel_1")
  mcDEBUG_STATE(
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp)
#define x mcnlx
#define y mcnly
#define z mcnlz
#define vx mcnlvx
#define vy mcnlvy
#define vz mcnlvz
#define t mcnlt
#define sx mcnlsx
#define sy mcnlsy
#define sz mcnlsz
#define p mcnlp

#define mcabsorbComp mcabsorbCompkidney_channel_1
  STORE_NEUTRON(50,
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp);
  mcScattered=0;
  mcRestore=0;
  mcNCounter[50]++;
  mcPCounter[50] += p;
  mcP2Counter[50] += p*p;
#define mccompcurname  kidney_channel_1
#define mccompcurtype  Arm
#define mccompcurindex 50
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex
  /* Label for restoring  neutron */
  mcabsorbCompkidney_channel_1:
  if (RESTORE) /* restore if needed */
  { RESTORE_NEUTRON(50,
      mcnlx,
      mcnly,
      mcnlz,
      mcnlvx,
      mcnlvy,
      mcnlvz,
      mcnlt,
      mcnlsx,
      mcnlsy,
      mcnlsz,
      mcnlp); }
#undef mcabsorbComp
#undef p
#undef sz
#undef sy
#undef sx
#undef t
#undef vz
#undef vy
#undef vx
#undef z
#undef y
#undef x
  mcDEBUG_STATE(
mcnlx,
mcnly,
mcnlz,
mcnlvx,
mcnlvy,
mcnlvz,
mcnlt,
mcnlsx,
mcnlsy,
mcnlsz,
mcnlp)

  /* TRACE Component kidney_channel_2 [51] */
  mccoordschange(mcposrkidney_channel_2, mcrotrkidney_channel_2,
    &mcnlx,
    &mcnly,
    &mcnlz,
    &mcnlvx,
    &mcnlvy,
    &mcnlvz,
    &mcnlsx,
    &mcnlsy,
    &mcnlsz);
  /* define label inside component kidney_channel_2 (without coords transformations) */
  mcJumpTrace_kidney_channel_2:
  SIG_MESSAGE("kidney_channel_2 (Trace)");
  mcDEBUG_COMP("kidney_channel_2")
  mcDEBUG_STATE(
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp)
#define x mcnlx
#define y mcnly
#define z mcnlz
#define vx mcnlvx
#define vy mcnlvy
#define vz mcnlvz
#define t mcnlt
#define sx mcnlsx
#define sy mcnlsy
#define sz mcnlsz
#define p mcnlp

#define mcabsorbComp mcabsorbCompkidney_channel_2
  STORE_NEUTRON(51,
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp);
  mcScattered=0;
  mcRestore=0;
  mcNCounter[51]++;
  mcPCounter[51] += p;
  mcP2Counter[51] += p*p;
#define mccompcurname  kidney_channel_2
#define mccompcurtype  Arm
#define mccompcurindex 51
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex
  /* Label for restoring  neutron */
  mcabsorbCompkidney_channel_2:
  if (RESTORE) /* restore if needed */
  { RESTORE_NEUTRON(51,
      mcnlx,
      mcnly,
      mcnlz,
      mcnlvx,
      mcnlvy,
      mcnlvz,
      mcnlt,
      mcnlsx,
      mcnlsy,
      mcnlsz,
      mcnlp); }
#undef mcabsorbComp
#undef p
#undef sz
#undef sy
#undef sx
#undef t
#undef vz
#undef vy
#undef vx
#undef z
#undef y
#undef x
  mcDEBUG_STATE(
mcnlx,
mcnly,
mcnlz,
mcnlvx,
mcnlvy,
mcnlvz,
mcnlt,
mcnlsx,
mcnlsy,
mcnlsz,
mcnlp)

  /* TRACE Component kidney_channel_3 [52] */
  mccoordschange(mcposrkidney_channel_3, mcrotrkidney_channel_3,
    &mcnlx,
    &mcnly,
    &mcnlz,
    &mcnlvx,
    &mcnlvy,
    &mcnlvz,
    &mcnlsx,
    &mcnlsy,
    &mcnlsz);
  /* define label inside component kidney_channel_3 (without coords transformations) */
  mcJumpTrace_kidney_channel_3:
  SIG_MESSAGE("kidney_channel_3 (Trace)");
  mcDEBUG_COMP("kidney_channel_3")
  mcDEBUG_STATE(
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp)
#define x mcnlx
#define y mcnly
#define z mcnlz
#define vx mcnlvx
#define vy mcnlvy
#define vz mcnlvz
#define t mcnlt
#define sx mcnlsx
#define sy mcnlsy
#define sz mcnlsz
#define p mcnlp

#define mcabsorbComp mcabsorbCompkidney_channel_3
  STORE_NEUTRON(52,
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp);
  mcScattered=0;
  mcRestore=0;
  mcNCounter[52]++;
  mcPCounter[52] += p;
  mcP2Counter[52] += p*p;
#define mccompcurname  kidney_channel_3
#define mccompcurtype  Arm
#define mccompcurindex 52
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex
  /* Label for restoring  neutron */
  mcabsorbCompkidney_channel_3:
  if (RESTORE) /* restore if needed */
  { RESTORE_NEUTRON(52,
      mcnlx,
      mcnly,
      mcnlz,
      mcnlvx,
      mcnlvy,
      mcnlvz,
      mcnlt,
      mcnlsx,
      mcnlsy,
      mcnlsz,
      mcnlp); }
#undef mcabsorbComp
#undef p
#undef sz
#undef sy
#undef sx
#undef t
#undef vz
#undef vy
#undef vx
#undef z
#undef y
#undef x
  mcDEBUG_STATE(
mcnlx,
mcnly,
mcnlz,
mcnlvx,
mcnlvy,
mcnlvz,
mcnlt,
mcnlsx,
mcnlsy,
mcnlsz,
mcnlp)

  /* TRACE Component kidney_channel_4 [53] */
  mccoordschange(mcposrkidney_channel_4, mcrotrkidney_channel_4,
    &mcnlx,
    &mcnly,
    &mcnlz,
    &mcnlvx,
    &mcnlvy,
    &mcnlvz,
    &mcnlsx,
    &mcnlsy,
    &mcnlsz);
  /* define label inside component kidney_channel_4 (without coords transformations) */
  mcJumpTrace_kidney_channel_4:
  SIG_MESSAGE("kidney_channel_4 (Trace)");
  mcDEBUG_COMP("kidney_channel_4")
  mcDEBUG_STATE(
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp)
#define x mcnlx
#define y mcnly
#define z mcnlz
#define vx mcnlvx
#define vy mcnlvy
#define vz mcnlvz
#define t mcnlt
#define sx mcnlsx
#define sy mcnlsy
#define sz mcnlsz
#define p mcnlp

#define mcabsorbComp mcabsorbCompkidney_channel_4
  STORE_NEUTRON(53,
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp);
  mcScattered=0;
  mcRestore=0;
  mcNCounter[53]++;
  mcPCounter[53] += p;
  mcP2Counter[53] += p*p;
#define mccompcurname  kidney_channel_4
#define mccompcurtype  Arm
#define mccompcurindex 53
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex
  /* Label for restoring  neutron */
  mcabsorbCompkidney_channel_4:
  if (RESTORE) /* restore if needed */
  { RESTORE_NEUTRON(53,
      mcnlx,
      mcnly,
      mcnlz,
      mcnlvx,
      mcnlvy,
      mcnlvz,
      mcnlt,
      mcnlsx,
      mcnlsy,
      mcnlsz,
      mcnlp); }
#undef mcabsorbComp
#undef p
#undef sz
#undef sy
#undef sx
#undef t
#undef vz
#undef vy
#undef vx
#undef z
#undef y
#undef x
  mcDEBUG_STATE(
mcnlx,
mcnly,
mcnlz,
mcnlvx,
mcnlvy,
mcnlvz,
mcnlt,
mcnlsx,
mcnlsy,
mcnlsz,
mcnlp)

  /* TRACE Component kidney_channel_5 [54] */
  mccoordschange(mcposrkidney_channel_5, mcrotrkidney_channel_5,
    &mcnlx,
    &mcnly,
    &mcnlz,
    &mcnlvx,
    &mcnlvy,
    &mcnlvz,
    &mcnlsx,
    &mcnlsy,
    &mcnlsz);
  /* define label inside component kidney_channel_5 (without coords transformations) */
  mcJumpTrace_kidney_channel_5:
  SIG_MESSAGE("kidney_channel_5 (Trace)");
  mcDEBUG_COMP("kidney_channel_5")
  mcDEBUG_STATE(
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp)
#define x mcnlx
#define y mcnly
#define z mcnlz
#define vx mcnlvx
#define vy mcnlvy
#define vz mcnlvz
#define t mcnlt
#define sx mcnlsx
#define sy mcnlsy
#define sz mcnlsz
#define p mcnlp

#define mcabsorbComp mcabsorbCompkidney_channel_5
  STORE_NEUTRON(54,
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp);
  mcScattered=0;
  mcRestore=0;
  mcNCounter[54]++;
  mcPCounter[54] += p;
  mcP2Counter[54] += p*p;
#define mccompcurname  kidney_channel_5
#define mccompcurtype  Arm
#define mccompcurindex 54
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex
  /* Label for restoring  neutron */
  mcabsorbCompkidney_channel_5:
  if (RESTORE) /* restore if needed */
  { RESTORE_NEUTRON(54,
      mcnlx,
      mcnly,
      mcnlz,
      mcnlvx,
      mcnlvy,
      mcnlvz,
      mcnlt,
      mcnlsx,
      mcnlsy,
      mcnlsz,
      mcnlp); }
#undef mcabsorbComp
#undef p
#undef sz
#undef sy
#undef sx
#undef t
#undef vz
#undef vy
#undef vx
#undef z
#undef y
#undef x
  mcDEBUG_STATE(
mcnlx,
mcnly,
mcnlz,
mcnlvx,
mcnlvy,
mcnlvz,
mcnlt,
mcnlsx,
mcnlsy,
mcnlsz,
mcnlp)

  /* TRACE Component kidney_channel_6 [55] */
  mccoordschange(mcposrkidney_channel_6, mcrotrkidney_channel_6,
    &mcnlx,
    &mcnly,
    &mcnlz,
    &mcnlvx,
    &mcnlvy,
    &mcnlvz,
    &mcnlsx,
    &mcnlsy,
    &mcnlsz);
  /* define label inside component kidney_channel_6 (without coords transformations) */
  mcJumpTrace_kidney_channel_6:
  SIG_MESSAGE("kidney_channel_6 (Trace)");
  mcDEBUG_COMP("kidney_channel_6")
  mcDEBUG_STATE(
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp)
#define x mcnlx
#define y mcnly
#define z mcnlz
#define vx mcnlvx
#define vy mcnlvy
#define vz mcnlvz
#define t mcnlt
#define sx mcnlsx
#define sy mcnlsy
#define sz mcnlsz
#define p mcnlp

#define mcabsorbComp mcabsorbCompkidney_channel_6
  STORE_NEUTRON(55,
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp);
  mcScattered=0;
  mcRestore=0;
  mcNCounter[55]++;
  mcPCounter[55] += p;
  mcP2Counter[55] += p*p;
#define mccompcurname  kidney_channel_6
#define mccompcurtype  Arm
#define mccompcurindex 55
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex
  /* Label for restoring  neutron */
  mcabsorbCompkidney_channel_6:
  if (RESTORE) /* restore if needed */
  { RESTORE_NEUTRON(55,
      mcnlx,
      mcnly,
      mcnlz,
      mcnlvx,
      mcnlvy,
      mcnlvz,
      mcnlt,
      mcnlsx,
      mcnlsy,
      mcnlsz,
      mcnlp); }
#undef mcabsorbComp
#undef p
#undef sz
#undef sy
#undef sx
#undef t
#undef vz
#undef vy
#undef vx
#undef z
#undef y
#undef x
  mcDEBUG_STATE(
mcnlx,
mcnly,
mcnlz,
mcnlvx,
mcnlvy,
mcnlvz,
mcnlt,
mcnlsx,
mcnlsy,
mcnlsz,
mcnlp)

  /* TRACE Component kidney_channel_7 [56] */
  mccoordschange(mcposrkidney_channel_7, mcrotrkidney_channel_7,
    &mcnlx,
    &mcnly,
    &mcnlz,
    &mcnlvx,
    &mcnlvy,
    &mcnlvz,
    &mcnlsx,
    &mcnlsy,
    &mcnlsz);
  /* define label inside component kidney_channel_7 (without coords transformations) */
  mcJumpTrace_kidney_channel_7:
  SIG_MESSAGE("kidney_channel_7 (Trace)");
  mcDEBUG_COMP("kidney_channel_7")
  mcDEBUG_STATE(
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp)
#define x mcnlx
#define y mcnly
#define z mcnlz
#define vx mcnlvx
#define vy mcnlvy
#define vz mcnlvz
#define t mcnlt
#define sx mcnlsx
#define sy mcnlsy
#define sz mcnlsz
#define p mcnlp

#define mcabsorbComp mcabsorbCompkidney_channel_7
  STORE_NEUTRON(56,
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp);
  mcScattered=0;
  mcRestore=0;
  mcNCounter[56]++;
  mcPCounter[56] += p;
  mcP2Counter[56] += p*p;
#define mccompcurname  kidney_channel_7
#define mccompcurtype  Arm
#define mccompcurindex 56
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex
  /* Label for restoring  neutron */
  mcabsorbCompkidney_channel_7:
  if (RESTORE) /* restore if needed */
  { RESTORE_NEUTRON(56,
      mcnlx,
      mcnly,
      mcnlz,
      mcnlvx,
      mcnlvy,
      mcnlvz,
      mcnlt,
      mcnlsx,
      mcnlsy,
      mcnlsz,
      mcnlp); }
#undef mcabsorbComp
#undef p
#undef sz
#undef sy
#undef sx
#undef t
#undef vz
#undef vy
#undef vx
#undef z
#undef y
#undef x
  mcDEBUG_STATE(
mcnlx,
mcnly,
mcnlz,
mcnlvx,
mcnlvy,
mcnlvz,
mcnlt,
mcnlsx,
mcnlsy,
mcnlsz,
mcnlp)

  /* TRACE Component kidney_channel_8 [57] */
  mccoordschange(mcposrkidney_channel_8, mcrotrkidney_channel_8,
    &mcnlx,
    &mcnly,
    &mcnlz,
    &mcnlvx,
    &mcnlvy,
    &mcnlvz,
    &mcnlsx,
    &mcnlsy,
    &mcnlsz);
  /* define label inside component kidney_channel_8 (without coords transformations) */
  mcJumpTrace_kidney_channel_8:
  SIG_MESSAGE("kidney_channel_8 (Trace)");
  mcDEBUG_COMP("kidney_channel_8")
  mcDEBUG_STATE(
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp)
#define x mcnlx
#define y mcnly
#define z mcnlz
#define vx mcnlvx
#define vy mcnlvy
#define vz mcnlvz
#define t mcnlt
#define sx mcnlsx
#define sy mcnlsy
#define sz mcnlsz
#define p mcnlp

#define mcabsorbComp mcabsorbCompkidney_channel_8
  STORE_NEUTRON(57,
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp);
  mcScattered=0;
  mcRestore=0;
  mcNCounter[57]++;
  mcPCounter[57] += p;
  mcP2Counter[57] += p*p;
#define mccompcurname  kidney_channel_8
#define mccompcurtype  Arm
#define mccompcurindex 57
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex
  /* Label for restoring  neutron */
  mcabsorbCompkidney_channel_8:
  if (RESTORE) /* restore if needed */
  { RESTORE_NEUTRON(57,
      mcnlx,
      mcnly,
      mcnlz,
      mcnlvx,
      mcnlvy,
      mcnlvz,
      mcnlt,
      mcnlsx,
      mcnlsy,
      mcnlsz,
      mcnlp); }
#undef mcabsorbComp
#undef p
#undef sz
#undef sy
#undef sx
#undef t
#undef vz
#undef vy
#undef vx
#undef z
#undef y
#undef x
  mcDEBUG_STATE(
mcnlx,
mcnly,
mcnlz,
mcnlvx,
mcnlvy,
mcnlvz,
mcnlt,
mcnlsx,
mcnlsy,
mcnlsz,
mcnlp)

  /* TRACE Component kidney_channel_9 [58] */
  mccoordschange(mcposrkidney_channel_9, mcrotrkidney_channel_9,
    &mcnlx,
    &mcnly,
    &mcnlz,
    &mcnlvx,
    &mcnlvy,
    &mcnlvz,
    &mcnlsx,
    &mcnlsy,
    &mcnlsz);
  /* define label inside component kidney_channel_9 (without coords transformations) */
  mcJumpTrace_kidney_channel_9:
  SIG_MESSAGE("kidney_channel_9 (Trace)");
  mcDEBUG_COMP("kidney_channel_9")
  mcDEBUG_STATE(
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp)
#define x mcnlx
#define y mcnly
#define z mcnlz
#define vx mcnlvx
#define vy mcnlvy
#define vz mcnlvz
#define t mcnlt
#define sx mcnlsx
#define sy mcnlsy
#define sz mcnlsz
#define p mcnlp

#define mcabsorbComp mcabsorbCompkidney_channel_9
  STORE_NEUTRON(58,
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp);
  mcScattered=0;
  mcRestore=0;
  mcNCounter[58]++;
  mcPCounter[58] += p;
  mcP2Counter[58] += p*p;
#define mccompcurname  kidney_channel_9
#define mccompcurtype  Arm
#define mccompcurindex 58
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex
  /* Label for restoring  neutron */
  mcabsorbCompkidney_channel_9:
  if (RESTORE) /* restore if needed */
  { RESTORE_NEUTRON(58,
      mcnlx,
      mcnly,
      mcnlz,
      mcnlvx,
      mcnlvy,
      mcnlvz,
      mcnlt,
      mcnlsx,
      mcnlsy,
      mcnlsz,
      mcnlp); }
#undef mcabsorbComp
#undef p
#undef sz
#undef sy
#undef sx
#undef t
#undef vz
#undef vy
#undef vx
#undef z
#undef y
#undef x
  mcDEBUG_STATE(
mcnlx,
mcnly,
mcnlz,
mcnlvx,
mcnlvy,
mcnlvz,
mcnlt,
mcnlsx,
mcnlsy,
mcnlsz,
mcnlp)

  /* TRACE Component kidney_channel_10 [59] */
  mccoordschange(mcposrkidney_channel_10, mcrotrkidney_channel_10,
    &mcnlx,
    &mcnly,
    &mcnlz,
    &mcnlvx,
    &mcnlvy,
    &mcnlvz,
    &mcnlsx,
    &mcnlsy,
    &mcnlsz);
  /* define label inside component kidney_channel_10 (without coords transformations) */
  mcJumpTrace_kidney_channel_10:
  SIG_MESSAGE("kidney_channel_10 (Trace)");
  mcDEBUG_COMP("kidney_channel_10")
  mcDEBUG_STATE(
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp)
#define x mcnlx
#define y mcnly
#define z mcnlz
#define vx mcnlvx
#define vy mcnlvy
#define vz mcnlvz
#define t mcnlt
#define sx mcnlsx
#define sy mcnlsy
#define sz mcnlsz
#define p mcnlp

#define mcabsorbComp mcabsorbCompkidney_channel_10
  STORE_NEUTRON(59,
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp);
  mcScattered=0;
  mcRestore=0;
  mcNCounter[59]++;
  mcPCounter[59] += p;
  mcP2Counter[59] += p*p;
#define mccompcurname  kidney_channel_10
#define mccompcurtype  Arm
#define mccompcurindex 59
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex
  /* Label for restoring  neutron */
  mcabsorbCompkidney_channel_10:
  if (RESTORE) /* restore if needed */
  { RESTORE_NEUTRON(59,
      mcnlx,
      mcnly,
      mcnlz,
      mcnlvx,
      mcnlvy,
      mcnlvz,
      mcnlt,
      mcnlsx,
      mcnlsy,
      mcnlsz,
      mcnlp); }
#undef mcabsorbComp
#undef p
#undef sz
#undef sy
#undef sx
#undef t
#undef vz
#undef vy
#undef vx
#undef z
#undef y
#undef x
  mcDEBUG_STATE(
mcnlx,
mcnly,
mcnlz,
mcnlvx,
mcnlvy,
mcnlvz,
mcnlt,
mcnlsx,
mcnlsy,
mcnlsz,
mcnlp)

  /* TRACE Component kidney_channel_11 [60] */
  mccoordschange(mcposrkidney_channel_11, mcrotrkidney_channel_11,
    &mcnlx,
    &mcnly,
    &mcnlz,
    &mcnlvx,
    &mcnlvy,
    &mcnlvz,
    &mcnlsx,
    &mcnlsy,
    &mcnlsz);
  /* define label inside component kidney_channel_11 (without coords transformations) */
  mcJumpTrace_kidney_channel_11:
  SIG_MESSAGE("kidney_channel_11 (Trace)");
  mcDEBUG_COMP("kidney_channel_11")
  mcDEBUG_STATE(
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp)
#define x mcnlx
#define y mcnly
#define z mcnlz
#define vx mcnlvx
#define vy mcnlvy
#define vz mcnlvz
#define t mcnlt
#define sx mcnlsx
#define sy mcnlsy
#define sz mcnlsz
#define p mcnlp

#define mcabsorbComp mcabsorbCompkidney_channel_11
  STORE_NEUTRON(60,
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp);
  mcScattered=0;
  mcRestore=0;
  mcNCounter[60]++;
  mcPCounter[60] += p;
  mcP2Counter[60] += p*p;
#define mccompcurname  kidney_channel_11
#define mccompcurtype  Arm
#define mccompcurindex 60
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex
  /* Label for restoring  neutron */
  mcabsorbCompkidney_channel_11:
  if (RESTORE) /* restore if needed */
  { RESTORE_NEUTRON(60,
      mcnlx,
      mcnly,
      mcnlz,
      mcnlvx,
      mcnlvy,
      mcnlvz,
      mcnlt,
      mcnlsx,
      mcnlsy,
      mcnlsz,
      mcnlp); }
#undef mcabsorbComp
#undef p
#undef sz
#undef sy
#undef sx
#undef t
#undef vz
#undef vy
#undef vx
#undef z
#undef y
#undef x
  mcDEBUG_STATE(
mcnlx,
mcnly,
mcnlz,
mcnlvx,
mcnlvy,
mcnlvz,
mcnlt,
mcnlsx,
mcnlsy,
mcnlsz,
mcnlp)

  /* TRACE Component kidney_channel_12 [61] */
  mccoordschange(mcposrkidney_channel_12, mcrotrkidney_channel_12,
    &mcnlx,
    &mcnly,
    &mcnlz,
    &mcnlvx,
    &mcnlvy,
    &mcnlvz,
    &mcnlsx,
    &mcnlsy,
    &mcnlsz);
  /* define label inside component kidney_channel_12 (without coords transformations) */
  mcJumpTrace_kidney_channel_12:
  SIG_MESSAGE("kidney_channel_12 (Trace)");
  mcDEBUG_COMP("kidney_channel_12")
  mcDEBUG_STATE(
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp)
#define x mcnlx
#define y mcnly
#define z mcnlz
#define vx mcnlvx
#define vy mcnlvy
#define vz mcnlvz
#define t mcnlt
#define sx mcnlsx
#define sy mcnlsy
#define sz mcnlsz
#define p mcnlp

#define mcabsorbComp mcabsorbCompkidney_channel_12
  STORE_NEUTRON(61,
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp);
  mcScattered=0;
  mcRestore=0;
  mcNCounter[61]++;
  mcPCounter[61] += p;
  mcP2Counter[61] += p*p;
#define mccompcurname  kidney_channel_12
#define mccompcurtype  Arm
#define mccompcurindex 61
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex
  /* Label for restoring  neutron */
  mcabsorbCompkidney_channel_12:
  if (RESTORE) /* restore if needed */
  { RESTORE_NEUTRON(61,
      mcnlx,
      mcnly,
      mcnlz,
      mcnlvx,
      mcnlvy,
      mcnlvz,
      mcnlt,
      mcnlsx,
      mcnlsy,
      mcnlsz,
      mcnlp); }
#undef mcabsorbComp
#undef p
#undef sz
#undef sy
#undef sx
#undef t
#undef vz
#undef vy
#undef vx
#undef z
#undef y
#undef x
  mcDEBUG_STATE(
mcnlx,
mcnly,
mcnlz,
mcnlvx,
mcnlvy,
mcnlvz,
mcnlt,
mcnlsx,
mcnlsy,
mcnlsz,
mcnlp)

  /* TRACE Component kidney_channel_13 [62] */
  mccoordschange(mcposrkidney_channel_13, mcrotrkidney_channel_13,
    &mcnlx,
    &mcnly,
    &mcnlz,
    &mcnlvx,
    &mcnlvy,
    &mcnlvz,
    &mcnlsx,
    &mcnlsy,
    &mcnlsz);
  /* define label inside component kidney_channel_13 (without coords transformations) */
  mcJumpTrace_kidney_channel_13:
  SIG_MESSAGE("kidney_channel_13 (Trace)");
  mcDEBUG_COMP("kidney_channel_13")
  mcDEBUG_STATE(
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp)
#define x mcnlx
#define y mcnly
#define z mcnlz
#define vx mcnlvx
#define vy mcnlvy
#define vz mcnlvz
#define t mcnlt
#define sx mcnlsx
#define sy mcnlsy
#define sz mcnlsz
#define p mcnlp

#define mcabsorbComp mcabsorbCompkidney_channel_13
  STORE_NEUTRON(62,
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp);
  mcScattered=0;
  mcRestore=0;
  mcNCounter[62]++;
  mcPCounter[62] += p;
  mcP2Counter[62] += p*p;
#define mccompcurname  kidney_channel_13
#define mccompcurtype  Arm
#define mccompcurindex 62
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex
  /* Label for restoring  neutron */
  mcabsorbCompkidney_channel_13:
  if (RESTORE) /* restore if needed */
  { RESTORE_NEUTRON(62,
      mcnlx,
      mcnly,
      mcnlz,
      mcnlvx,
      mcnlvy,
      mcnlvz,
      mcnlt,
      mcnlsx,
      mcnlsy,
      mcnlsz,
      mcnlp); }
#undef mcabsorbComp
#undef p
#undef sz
#undef sy
#undef sx
#undef t
#undef vz
#undef vy
#undef vx
#undef z
#undef y
#undef x
  mcDEBUG_STATE(
mcnlx,
mcnly,
mcnlz,
mcnlvx,
mcnlvy,
mcnlvz,
mcnlt,
mcnlsx,
mcnlsy,
mcnlsz,
mcnlp)

  /* TRACE Component kidney_channel_14 [63] */
  mccoordschange(mcposrkidney_channel_14, mcrotrkidney_channel_14,
    &mcnlx,
    &mcnly,
    &mcnlz,
    &mcnlvx,
    &mcnlvy,
    &mcnlvz,
    &mcnlsx,
    &mcnlsy,
    &mcnlsz);
  /* define label inside component kidney_channel_14 (without coords transformations) */
  mcJumpTrace_kidney_channel_14:
  SIG_MESSAGE("kidney_channel_14 (Trace)");
  mcDEBUG_COMP("kidney_channel_14")
  mcDEBUG_STATE(
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp)
#define x mcnlx
#define y mcnly
#define z mcnlz
#define vx mcnlvx
#define vy mcnlvy
#define vz mcnlvz
#define t mcnlt
#define sx mcnlsx
#define sy mcnlsy
#define sz mcnlsz
#define p mcnlp

#define mcabsorbComp mcabsorbCompkidney_channel_14
  STORE_NEUTRON(63,
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp);
  mcScattered=0;
  mcRestore=0;
  mcNCounter[63]++;
  mcPCounter[63] += p;
  mcP2Counter[63] += p*p;
#define mccompcurname  kidney_channel_14
#define mccompcurtype  Arm
#define mccompcurindex 63
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex
  /* Label for restoring  neutron */
  mcabsorbCompkidney_channel_14:
  if (RESTORE) /* restore if needed */
  { RESTORE_NEUTRON(63,
      mcnlx,
      mcnly,
      mcnlz,
      mcnlvx,
      mcnlvy,
      mcnlvz,
      mcnlt,
      mcnlsx,
      mcnlsy,
      mcnlsz,
      mcnlp); }
#undef mcabsorbComp
#undef p
#undef sz
#undef sy
#undef sx
#undef t
#undef vz
#undef vy
#undef vx
#undef z
#undef y
#undef x
  mcDEBUG_STATE(
mcnlx,
mcnly,
mcnlz,
mcnlvx,
mcnlvy,
mcnlvz,
mcnlt,
mcnlsx,
mcnlsy,
mcnlsz,
mcnlp)

  /* TRACE Component kidney_channel_15 [64] */
  mccoordschange(mcposrkidney_channel_15, mcrotrkidney_channel_15,
    &mcnlx,
    &mcnly,
    &mcnlz,
    &mcnlvx,
    &mcnlvy,
    &mcnlvz,
    &mcnlsx,
    &mcnlsy,
    &mcnlsz);
  /* define label inside component kidney_channel_15 (without coords transformations) */
  mcJumpTrace_kidney_channel_15:
  SIG_MESSAGE("kidney_channel_15 (Trace)");
  mcDEBUG_COMP("kidney_channel_15")
  mcDEBUG_STATE(
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp)
#define x mcnlx
#define y mcnly
#define z mcnlz
#define vx mcnlvx
#define vy mcnlvy
#define vz mcnlvz
#define t mcnlt
#define sx mcnlsx
#define sy mcnlsy
#define sz mcnlsz
#define p mcnlp

#define mcabsorbComp mcabsorbCompkidney_channel_15
  STORE_NEUTRON(64,
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp);
  mcScattered=0;
  mcRestore=0;
  mcNCounter[64]++;
  mcPCounter[64] += p;
  mcP2Counter[64] += p*p;
#define mccompcurname  kidney_channel_15
#define mccompcurtype  Arm
#define mccompcurindex 64
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex
  /* Label for restoring  neutron */
  mcabsorbCompkidney_channel_15:
  if (RESTORE) /* restore if needed */
  { RESTORE_NEUTRON(64,
      mcnlx,
      mcnly,
      mcnlz,
      mcnlvx,
      mcnlvy,
      mcnlvz,
      mcnlt,
      mcnlsx,
      mcnlsy,
      mcnlsz,
      mcnlp); }
#undef mcabsorbComp
#undef p
#undef sz
#undef sy
#undef sx
#undef t
#undef vz
#undef vy
#undef vx
#undef z
#undef y
#undef x
  mcDEBUG_STATE(
mcnlx,
mcnly,
mcnlz,
mcnlvx,
mcnlvy,
mcnlvz,
mcnlt,
mcnlsx,
mcnlsy,
mcnlsz,
mcnlp)

  /* TRACE Component kidney_channel_16 [65] */
  mccoordschange(mcposrkidney_channel_16, mcrotrkidney_channel_16,
    &mcnlx,
    &mcnly,
    &mcnlz,
    &mcnlvx,
    &mcnlvy,
    &mcnlvz,
    &mcnlsx,
    &mcnlsy,
    &mcnlsz);
  /* define label inside component kidney_channel_16 (without coords transformations) */
  mcJumpTrace_kidney_channel_16:
  SIG_MESSAGE("kidney_channel_16 (Trace)");
  mcDEBUG_COMP("kidney_channel_16")
  mcDEBUG_STATE(
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp)
#define x mcnlx
#define y mcnly
#define z mcnlz
#define vx mcnlvx
#define vy mcnlvy
#define vz mcnlvz
#define t mcnlt
#define sx mcnlsx
#define sy mcnlsy
#define sz mcnlsz
#define p mcnlp

#define mcabsorbComp mcabsorbCompkidney_channel_16
  STORE_NEUTRON(65,
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp);
  mcScattered=0;
  mcRestore=0;
  mcNCounter[65]++;
  mcPCounter[65] += p;
  mcP2Counter[65] += p*p;
#define mccompcurname  kidney_channel_16
#define mccompcurtype  Arm
#define mccompcurindex 65
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex
  /* Label for restoring  neutron */
  mcabsorbCompkidney_channel_16:
  if (RESTORE) /* restore if needed */
  { RESTORE_NEUTRON(65,
      mcnlx,
      mcnly,
      mcnlz,
      mcnlvx,
      mcnlvy,
      mcnlvz,
      mcnlt,
      mcnlsx,
      mcnlsy,
      mcnlsz,
      mcnlp); }
#undef mcabsorbComp
#undef p
#undef sz
#undef sy
#undef sx
#undef t
#undef vz
#undef vy
#undef vx
#undef z
#undef y
#undef x
  mcDEBUG_STATE(
mcnlx,
mcnly,
mcnlz,
mcnlvx,
mcnlvy,
mcnlvz,
mcnlt,
mcnlsx,
mcnlsy,
mcnlsz,
mcnlp)

  /* TRACE Component kidney_channel_17 [66] */
  mccoordschange(mcposrkidney_channel_17, mcrotrkidney_channel_17,
    &mcnlx,
    &mcnly,
    &mcnlz,
    &mcnlvx,
    &mcnlvy,
    &mcnlvz,
    &mcnlsx,
    &mcnlsy,
    &mcnlsz);
  /* define label inside component kidney_channel_17 (without coords transformations) */
  mcJumpTrace_kidney_channel_17:
  SIG_MESSAGE("kidney_channel_17 (Trace)");
  mcDEBUG_COMP("kidney_channel_17")
  mcDEBUG_STATE(
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp)
#define x mcnlx
#define y mcnly
#define z mcnlz
#define vx mcnlvx
#define vy mcnlvy
#define vz mcnlvz
#define t mcnlt
#define sx mcnlsx
#define sy mcnlsy
#define sz mcnlsz
#define p mcnlp

#define mcabsorbComp mcabsorbCompkidney_channel_17
  STORE_NEUTRON(66,
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp);
  mcScattered=0;
  mcRestore=0;
  mcNCounter[66]++;
  mcPCounter[66] += p;
  mcP2Counter[66] += p*p;
#define mccompcurname  kidney_channel_17
#define mccompcurtype  Arm
#define mccompcurindex 66
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex
  /* Label for restoring  neutron */
  mcabsorbCompkidney_channel_17:
  if (RESTORE) /* restore if needed */
  { RESTORE_NEUTRON(66,
      mcnlx,
      mcnly,
      mcnlz,
      mcnlvx,
      mcnlvy,
      mcnlvz,
      mcnlt,
      mcnlsx,
      mcnlsy,
      mcnlsz,
      mcnlp); }
#undef mcabsorbComp
#undef p
#undef sz
#undef sy
#undef sx
#undef t
#undef vz
#undef vy
#undef vx
#undef z
#undef y
#undef x
  mcDEBUG_STATE(
mcnlx,
mcnly,
mcnlz,
mcnlvx,
mcnlvy,
mcnlvz,
mcnlt,
mcnlsx,
mcnlsy,
mcnlsz,
mcnlp)

  /* TRACE Component kidney_channel_18 [67] */
  mccoordschange(mcposrkidney_channel_18, mcrotrkidney_channel_18,
    &mcnlx,
    &mcnly,
    &mcnlz,
    &mcnlvx,
    &mcnlvy,
    &mcnlvz,
    &mcnlsx,
    &mcnlsy,
    &mcnlsz);
  /* define label inside component kidney_channel_18 (without coords transformations) */
  mcJumpTrace_kidney_channel_18:
  SIG_MESSAGE("kidney_channel_18 (Trace)");
  mcDEBUG_COMP("kidney_channel_18")
  mcDEBUG_STATE(
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp)
#define x mcnlx
#define y mcnly
#define z mcnlz
#define vx mcnlvx
#define vy mcnlvy
#define vz mcnlvz
#define t mcnlt
#define sx mcnlsx
#define sy mcnlsy
#define sz mcnlsz
#define p mcnlp

#define mcabsorbComp mcabsorbCompkidney_channel_18
  STORE_NEUTRON(67,
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp);
  mcScattered=0;
  mcRestore=0;
  mcNCounter[67]++;
  mcPCounter[67] += p;
  mcP2Counter[67] += p*p;
#define mccompcurname  kidney_channel_18
#define mccompcurtype  Arm
#define mccompcurindex 67
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex
  /* Label for restoring  neutron */
  mcabsorbCompkidney_channel_18:
  if (RESTORE) /* restore if needed */
  { RESTORE_NEUTRON(67,
      mcnlx,
      mcnly,
      mcnlz,
      mcnlvx,
      mcnlvy,
      mcnlvz,
      mcnlt,
      mcnlsx,
      mcnlsy,
      mcnlsz,
      mcnlp); }
#undef mcabsorbComp
#undef p
#undef sz
#undef sy
#undef sx
#undef t
#undef vz
#undef vy
#undef vx
#undef z
#undef y
#undef x
  mcDEBUG_STATE(
mcnlx,
mcnly,
mcnlz,
mcnlvx,
mcnlvy,
mcnlvz,
mcnlt,
mcnlsx,
mcnlsy,
mcnlsz,
mcnlp)

  /* TRACE Component kidney_channel_19 [68] */
  mccoordschange(mcposrkidney_channel_19, mcrotrkidney_channel_19,
    &mcnlx,
    &mcnly,
    &mcnlz,
    &mcnlvx,
    &mcnlvy,
    &mcnlvz,
    &mcnlsx,
    &mcnlsy,
    &mcnlsz);
  /* define label inside component kidney_channel_19 (without coords transformations) */
  mcJumpTrace_kidney_channel_19:
  SIG_MESSAGE("kidney_channel_19 (Trace)");
  mcDEBUG_COMP("kidney_channel_19")
  mcDEBUG_STATE(
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp)
#define x mcnlx
#define y mcnly
#define z mcnlz
#define vx mcnlvx
#define vy mcnlvy
#define vz mcnlvz
#define t mcnlt
#define sx mcnlsx
#define sy mcnlsy
#define sz mcnlsz
#define p mcnlp

#define mcabsorbComp mcabsorbCompkidney_channel_19
  STORE_NEUTRON(68,
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp);
  mcScattered=0;
  mcRestore=0;
  mcNCounter[68]++;
  mcPCounter[68] += p;
  mcP2Counter[68] += p*p;
#define mccompcurname  kidney_channel_19
#define mccompcurtype  Arm
#define mccompcurindex 68
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex
  /* Label for restoring  neutron */
  mcabsorbCompkidney_channel_19:
  if (RESTORE) /* restore if needed */
  { RESTORE_NEUTRON(68,
      mcnlx,
      mcnly,
      mcnlz,
      mcnlvx,
      mcnlvy,
      mcnlvz,
      mcnlt,
      mcnlsx,
      mcnlsy,
      mcnlsz,
      mcnlp); }
#undef mcabsorbComp
#undef p
#undef sz
#undef sy
#undef sx
#undef t
#undef vz
#undef vy
#undef vx
#undef z
#undef y
#undef x
  mcDEBUG_STATE(
mcnlx,
mcnly,
mcnlz,
mcnlvx,
mcnlvy,
mcnlvz,
mcnlt,
mcnlsx,
mcnlsy,
mcnlsz,
mcnlp)

  /* TRACE Component channel_0_filter [69] */
  mccoordschange(mcposrchannel_0_filter, mcrotrchannel_0_filter,
    &mcnlx,
    &mcnly,
    &mcnlz,
    &mcnlvx,
    &mcnlvy,
    &mcnlvz,
    &mcnlsx,
    &mcnlsy,
    &mcnlsz);
  /* define label inside component channel_0_filter (without coords transformations) */
  mcJumpTrace_channel_0_filter:
  SIG_MESSAGE("channel_0_filter (Trace)");
  mcDEBUG_COMP("channel_0_filter")
  mcDEBUG_STATE(
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp)
#define x mcnlx
#define y mcnly
#define z mcnlz
#define vx mcnlvx
#define vy mcnlvy
#define vz mcnlvz
#define t mcnlt
#define sx mcnlsx
#define sy mcnlsy
#define sz mcnlsz
#define p mcnlp

#define mcabsorbComp mcabsorbCompchannel_0_filter
  STORE_NEUTRON(69,
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp);
  mcScattered=0;
  mcRestore=0;
  mcNCounter[69]++;
  mcPCounter[69] += p;
  mcP2Counter[69] += p*p;
  if (!mcGroupfilter_group) { /* previous comps of GROUP have not SCATTERED yet */
#undef mcabsorb
/* if ABSORBed in GROUP/comp, will go to end of component */
RESTORE=1;
#define mcabsorb mcabsorbCompchannel_0_filter
#define mccompcurname  channel_0_filter
#define mccompcurtype  Slit_MACS
#define mccompcurindex 69
{   /* Declarations of channel_0_filter=Slit_MACS() SETTING parameters. */
MCNUM xmin = mccchannel_0_filter_xmin;
MCNUM xmax = mccchannel_0_filter_xmax;
MCNUM ymin = mccchannel_0_filter_ymin;
MCNUM ymax = mccchannel_0_filter_ymax;
MCNUM radius = mccchannel_0_filter_radius;
MCNUM xwidth = mccchannel_0_filter_xwidth;
MCNUM yheight = mccchannel_0_filter_yheight;
#line 71 "Slit_MACS.comp"
{
    PROP_Z0;
    if (!(((radius == 0) && (x<xmin || x>xmax || y<ymin || y>ymax))
    || ((radius != 0) && (x*x + y*y > radius*radius)))) {
        SCATTER;
    }
    
      //ABSORB;
    //else
        //SCATTER;
}
#line 354993 "MACS_sample_kidney_box.c"
/* 'channel_0_filter=Slit_MACS()' component instance extend code */
    SIG_MESSAGE("channel_0_filter (Trace:Extend)");
#line 96 "generated_includes/kidney_trace.c"
    if (SCATTERED) {
        channel_selected = 0;
    }
#line 355000 "MACS_sample_kidney_box.c"
}   /* End of channel_0_filter=Slit_MACS() SETTING parameter declarations. */
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex
#undef mcabsorb
#define mcabsorb mcabsorbAll
  } /* end comp channel_0_filter in GROUP filter_group */
  if (SCATTERED) {
    mcGroupfilter_group=69;
    RESTORE=0;
  }
  /* Label for restoring  neutron */
  mcabsorbCompchannel_0_filter:
  if (RESTORE) /* restore if needed */
  { RESTORE_NEUTRON(69,
      mcnlx,
      mcnly,
      mcnlz,
      mcnlvx,
      mcnlvy,
      mcnlvz,
      mcnlt,
      mcnlsx,
      mcnlsy,
      mcnlsz,
      mcnlp); }
#undef mcabsorbComp
#undef p
#undef sz
#undef sy
#undef sx
#undef t
#undef vz
#undef vy
#undef vx
#undef z
#undef y
#undef x
  mcDEBUG_STATE(
mcnlx,
mcnly,
mcnlz,
mcnlvx,
mcnlvy,
mcnlvz,
mcnlt,
mcnlsx,
mcnlsy,
mcnlsz,
mcnlp)

  /* TRACE Component channel_1_filter [70] */
  mccoordschange(mcposrchannel_1_filter, mcrotrchannel_1_filter,
    &mcnlx,
    &mcnly,
    &mcnlz,
    &mcnlvx,
    &mcnlvy,
    &mcnlvz,
    &mcnlsx,
    &mcnlsy,
    &mcnlsz);
  /* define label inside component channel_1_filter (without coords transformations) */
  mcJumpTrace_channel_1_filter:
  SIG_MESSAGE("channel_1_filter (Trace)");
  mcDEBUG_COMP("channel_1_filter")
  mcDEBUG_STATE(
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp)
#define x mcnlx
#define y mcnly
#define z mcnlz
#define vx mcnlvx
#define vy mcnlvy
#define vz mcnlvz
#define t mcnlt
#define sx mcnlsx
#define sy mcnlsy
#define sz mcnlsz
#define p mcnlp

#define mcabsorbComp mcabsorbCompchannel_1_filter
  STORE_NEUTRON(70,
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp);
  mcScattered=0;
  mcRestore=0;
  mcNCounter[70]++;
  mcPCounter[70] += p;
  mcP2Counter[70] += p*p;
  if (!mcGroupfilter_group) { /* previous comps of GROUP have not SCATTERED yet */
#undef mcabsorb
/* if ABSORBed in GROUP/comp, will go to end of component */
RESTORE=1;
#define mcabsorb mcabsorbCompchannel_1_filter
#define mccompcurname  channel_1_filter
#define mccompcurtype  Slit_MACS
#define mccompcurindex 70
{   /* Declarations of channel_1_filter=Slit_MACS() SETTING parameters. */
MCNUM xmin = mccchannel_1_filter_xmin;
MCNUM xmax = mccchannel_1_filter_xmax;
MCNUM ymin = mccchannel_1_filter_ymin;
MCNUM ymax = mccchannel_1_filter_ymax;
MCNUM radius = mccchannel_1_filter_radius;
MCNUM xwidth = mccchannel_1_filter_xwidth;
MCNUM yheight = mccchannel_1_filter_yheight;
#line 71 "Slit_MACS.comp"
{
    PROP_Z0;
    if (!(((radius == 0) && (x<xmin || x>xmax || y<ymin || y>ymax))
    || ((radius != 0) && (x*x + y*y > radius*radius)))) {
        SCATTER;
    }
    
      //ABSORB;
    //else
        //SCATTER;
}
#line 355134 "MACS_sample_kidney_box.c"
/* 'channel_1_filter=Slit_MACS()' component instance extend code */
    SIG_MESSAGE("channel_1_filter (Trace:Extend)");
#line 106 "generated_includes/kidney_trace.c"
    if (SCATTERED) channel_selected = 1;
#line 355139 "MACS_sample_kidney_box.c"
}   /* End of channel_1_filter=Slit_MACS() SETTING parameter declarations. */
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex
#undef mcabsorb
#define mcabsorb mcabsorbAll
  } /* end comp channel_1_filter in GROUP filter_group */
  if (SCATTERED) {
    mcGroupfilter_group=70;
    RESTORE=0;
  }
  /* Label for restoring  neutron */
  mcabsorbCompchannel_1_filter:
  if (RESTORE) /* restore if needed */
  { RESTORE_NEUTRON(70,
      mcnlx,
      mcnly,
      mcnlz,
      mcnlvx,
      mcnlvy,
      mcnlvz,
      mcnlt,
      mcnlsx,
      mcnlsy,
      mcnlsz,
      mcnlp); }
#undef mcabsorbComp
#undef p
#undef sz
#undef sy
#undef sx
#undef t
#undef vz
#undef vy
#undef vx
#undef z
#undef y
#undef x
  mcDEBUG_STATE(
mcnlx,
mcnly,
mcnlz,
mcnlvx,
mcnlvy,
mcnlvz,
mcnlt,
mcnlsx,
mcnlsy,
mcnlsz,
mcnlp)

  /* TRACE Component channel_2_filter [71] */
  mccoordschange(mcposrchannel_2_filter, mcrotrchannel_2_filter,
    &mcnlx,
    &mcnly,
    &mcnlz,
    &mcnlvx,
    &mcnlvy,
    &mcnlvz,
    &mcnlsx,
    &mcnlsy,
    &mcnlsz);
  /* define label inside component channel_2_filter (without coords transformations) */
  mcJumpTrace_channel_2_filter:
  SIG_MESSAGE("channel_2_filter (Trace)");
  mcDEBUG_COMP("channel_2_filter")
  mcDEBUG_STATE(
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp)
#define x mcnlx
#define y mcnly
#define z mcnlz
#define vx mcnlvx
#define vy mcnlvy
#define vz mcnlvz
#define t mcnlt
#define sx mcnlsx
#define sy mcnlsy
#define sz mcnlsz
#define p mcnlp

#define mcabsorbComp mcabsorbCompchannel_2_filter
  STORE_NEUTRON(71,
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp);
  mcScattered=0;
  mcRestore=0;
  mcNCounter[71]++;
  mcPCounter[71] += p;
  mcP2Counter[71] += p*p;
  if (!mcGroupfilter_group) { /* previous comps of GROUP have not SCATTERED yet */
#undef mcabsorb
/* if ABSORBed in GROUP/comp, will go to end of component */
RESTORE=1;
#define mcabsorb mcabsorbCompchannel_2_filter
#define mccompcurname  channel_2_filter
#define mccompcurtype  Slit_MACS
#define mccompcurindex 71
{   /* Declarations of channel_2_filter=Slit_MACS() SETTING parameters. */
MCNUM xmin = mccchannel_2_filter_xmin;
MCNUM xmax = mccchannel_2_filter_xmax;
MCNUM ymin = mccchannel_2_filter_ymin;
MCNUM ymax = mccchannel_2_filter_ymax;
MCNUM radius = mccchannel_2_filter_radius;
MCNUM xwidth = mccchannel_2_filter_xwidth;
MCNUM yheight = mccchannel_2_filter_yheight;
#line 71 "Slit_MACS.comp"
{
    PROP_Z0;
    if (!(((radius == 0) && (x<xmin || x>xmax || y<ymin || y>ymax))
    || ((radius != 0) && (x*x + y*y > radius*radius)))) {
        SCATTER;
    }
    
      //ABSORB;
    //else
        //SCATTER;
}
#line 355273 "MACS_sample_kidney_box.c"
/* 'channel_2_filter=Slit_MACS()' component instance extend code */
    SIG_MESSAGE("channel_2_filter (Trace:Extend)");
#line 114 "generated_includes/kidney_trace.c"
    if (SCATTERED) channel_selected = 2;
#line 355278 "MACS_sample_kidney_box.c"
}   /* End of channel_2_filter=Slit_MACS() SETTING parameter declarations. */
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex
#undef mcabsorb
#define mcabsorb mcabsorbAll
  } /* end comp channel_2_filter in GROUP filter_group */
  if (SCATTERED) {
    mcGroupfilter_group=71;
    RESTORE=0;
  }
  /* Label for restoring  neutron */
  mcabsorbCompchannel_2_filter:
  if (RESTORE) /* restore if needed */
  { RESTORE_NEUTRON(71,
      mcnlx,
      mcnly,
      mcnlz,
      mcnlvx,
      mcnlvy,
      mcnlvz,
      mcnlt,
      mcnlsx,
      mcnlsy,
      mcnlsz,
      mcnlp); }
#undef mcabsorbComp
#undef p
#undef sz
#undef sy
#undef sx
#undef t
#undef vz
#undef vy
#undef vx
#undef z
#undef y
#undef x
  mcDEBUG_STATE(
mcnlx,
mcnly,
mcnlz,
mcnlvx,
mcnlvy,
mcnlvz,
mcnlt,
mcnlsx,
mcnlsy,
mcnlsz,
mcnlp)

  /* TRACE Component channel_3_filter [72] */
  mccoordschange(mcposrchannel_3_filter, mcrotrchannel_3_filter,
    &mcnlx,
    &mcnly,
    &mcnlz,
    &mcnlvx,
    &mcnlvy,
    &mcnlvz,
    &mcnlsx,
    &mcnlsy,
    &mcnlsz);
  /* define label inside component channel_3_filter (without coords transformations) */
  mcJumpTrace_channel_3_filter:
  SIG_MESSAGE("channel_3_filter (Trace)");
  mcDEBUG_COMP("channel_3_filter")
  mcDEBUG_STATE(
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp)
#define x mcnlx
#define y mcnly
#define z mcnlz
#define vx mcnlvx
#define vy mcnlvy
#define vz mcnlvz
#define t mcnlt
#define sx mcnlsx
#define sy mcnlsy
#define sz mcnlsz
#define p mcnlp

#define mcabsorbComp mcabsorbCompchannel_3_filter
  STORE_NEUTRON(72,
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp);
  mcScattered=0;
  mcRestore=0;
  mcNCounter[72]++;
  mcPCounter[72] += p;
  mcP2Counter[72] += p*p;
  if (!mcGroupfilter_group) { /* previous comps of GROUP have not SCATTERED yet */
#undef mcabsorb
/* if ABSORBed in GROUP/comp, will go to end of component */
RESTORE=1;
#define mcabsorb mcabsorbCompchannel_3_filter
#define mccompcurname  channel_3_filter
#define mccompcurtype  Slit_MACS
#define mccompcurindex 72
{   /* Declarations of channel_3_filter=Slit_MACS() SETTING parameters. */
MCNUM xmin = mccchannel_3_filter_xmin;
MCNUM xmax = mccchannel_3_filter_xmax;
MCNUM ymin = mccchannel_3_filter_ymin;
MCNUM ymax = mccchannel_3_filter_ymax;
MCNUM radius = mccchannel_3_filter_radius;
MCNUM xwidth = mccchannel_3_filter_xwidth;
MCNUM yheight = mccchannel_3_filter_yheight;
#line 71 "Slit_MACS.comp"
{
    PROP_Z0;
    if (!(((radius == 0) && (x<xmin || x>xmax || y<ymin || y>ymax))
    || ((radius != 0) && (x*x + y*y > radius*radius)))) {
        SCATTER;
    }
    
      //ABSORB;
    //else
        //SCATTER;
}
#line 355412 "MACS_sample_kidney_box.c"
/* 'channel_3_filter=Slit_MACS()' component instance extend code */
    SIG_MESSAGE("channel_3_filter (Trace:Extend)");
#line 122 "generated_includes/kidney_trace.c"
    if (SCATTERED) channel_selected = 3;
#line 355417 "MACS_sample_kidney_box.c"
}   /* End of channel_3_filter=Slit_MACS() SETTING parameter declarations. */
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex
#undef mcabsorb
#define mcabsorb mcabsorbAll
  } /* end comp channel_3_filter in GROUP filter_group */
  if (SCATTERED) {
    mcGroupfilter_group=72;
    RESTORE=0;
  }
  /* Label for restoring  neutron */
  mcabsorbCompchannel_3_filter:
  if (RESTORE) /* restore if needed */
  { RESTORE_NEUTRON(72,
      mcnlx,
      mcnly,
      mcnlz,
      mcnlvx,
      mcnlvy,
      mcnlvz,
      mcnlt,
      mcnlsx,
      mcnlsy,
      mcnlsz,
      mcnlp); }
#undef mcabsorbComp
#undef p
#undef sz
#undef sy
#undef sx
#undef t
#undef vz
#undef vy
#undef vx
#undef z
#undef y
#undef x
  mcDEBUG_STATE(
mcnlx,
mcnly,
mcnlz,
mcnlvx,
mcnlvy,
mcnlvz,
mcnlt,
mcnlsx,
mcnlsy,
mcnlsz,
mcnlp)

  /* TRACE Component channel_4_filter [73] */
  mccoordschange(mcposrchannel_4_filter, mcrotrchannel_4_filter,
    &mcnlx,
    &mcnly,
    &mcnlz,
    &mcnlvx,
    &mcnlvy,
    &mcnlvz,
    &mcnlsx,
    &mcnlsy,
    &mcnlsz);
  /* define label inside component channel_4_filter (without coords transformations) */
  mcJumpTrace_channel_4_filter:
  SIG_MESSAGE("channel_4_filter (Trace)");
  mcDEBUG_COMP("channel_4_filter")
  mcDEBUG_STATE(
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp)
#define x mcnlx
#define y mcnly
#define z mcnlz
#define vx mcnlvx
#define vy mcnlvy
#define vz mcnlvz
#define t mcnlt
#define sx mcnlsx
#define sy mcnlsy
#define sz mcnlsz
#define p mcnlp

#define mcabsorbComp mcabsorbCompchannel_4_filter
  STORE_NEUTRON(73,
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp);
  mcScattered=0;
  mcRestore=0;
  mcNCounter[73]++;
  mcPCounter[73] += p;
  mcP2Counter[73] += p*p;
  if (!mcGroupfilter_group) { /* previous comps of GROUP have not SCATTERED yet */
#undef mcabsorb
/* if ABSORBed in GROUP/comp, will go to end of component */
RESTORE=1;
#define mcabsorb mcabsorbCompchannel_4_filter
#define mccompcurname  channel_4_filter
#define mccompcurtype  Slit_MACS
#define mccompcurindex 73
{   /* Declarations of channel_4_filter=Slit_MACS() SETTING parameters. */
MCNUM xmin = mccchannel_4_filter_xmin;
MCNUM xmax = mccchannel_4_filter_xmax;
MCNUM ymin = mccchannel_4_filter_ymin;
MCNUM ymax = mccchannel_4_filter_ymax;
MCNUM radius = mccchannel_4_filter_radius;
MCNUM xwidth = mccchannel_4_filter_xwidth;
MCNUM yheight = mccchannel_4_filter_yheight;
#line 71 "Slit_MACS.comp"
{
    PROP_Z0;
    if (!(((radius == 0) && (x<xmin || x>xmax || y<ymin || y>ymax))
    || ((radius != 0) && (x*x + y*y > radius*radius)))) {
        SCATTER;
    }
    
      //ABSORB;
    //else
        //SCATTER;
}
#line 355551 "MACS_sample_kidney_box.c"
/* 'channel_4_filter=Slit_MACS()' component instance extend code */
    SIG_MESSAGE("channel_4_filter (Trace:Extend)");
#line 130 "generated_includes/kidney_trace.c"
    if (SCATTERED) channel_selected = 4;
#line 355556 "MACS_sample_kidney_box.c"
}   /* End of channel_4_filter=Slit_MACS() SETTING parameter declarations. */
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex
#undef mcabsorb
#define mcabsorb mcabsorbAll
  } /* end comp channel_4_filter in GROUP filter_group */
  if (SCATTERED) {
    mcGroupfilter_group=73;
    RESTORE=0;
  }
  /* Label for restoring  neutron */
  mcabsorbCompchannel_4_filter:
  if (RESTORE) /* restore if needed */
  { RESTORE_NEUTRON(73,
      mcnlx,
      mcnly,
      mcnlz,
      mcnlvx,
      mcnlvy,
      mcnlvz,
      mcnlt,
      mcnlsx,
      mcnlsy,
      mcnlsz,
      mcnlp); }
#undef mcabsorbComp
#undef p
#undef sz
#undef sy
#undef sx
#undef t
#undef vz
#undef vy
#undef vx
#undef z
#undef y
#undef x
  mcDEBUG_STATE(
mcnlx,
mcnly,
mcnlz,
mcnlvx,
mcnlvy,
mcnlvz,
mcnlt,
mcnlsx,
mcnlsy,
mcnlsz,
mcnlp)

  /* TRACE Component channel_5_filter [74] */
  mccoordschange(mcposrchannel_5_filter, mcrotrchannel_5_filter,
    &mcnlx,
    &mcnly,
    &mcnlz,
    &mcnlvx,
    &mcnlvy,
    &mcnlvz,
    &mcnlsx,
    &mcnlsy,
    &mcnlsz);
  /* define label inside component channel_5_filter (without coords transformations) */
  mcJumpTrace_channel_5_filter:
  SIG_MESSAGE("channel_5_filter (Trace)");
  mcDEBUG_COMP("channel_5_filter")
  mcDEBUG_STATE(
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp)
#define x mcnlx
#define y mcnly
#define z mcnlz
#define vx mcnlvx
#define vy mcnlvy
#define vz mcnlvz
#define t mcnlt
#define sx mcnlsx
#define sy mcnlsy
#define sz mcnlsz
#define p mcnlp

#define mcabsorbComp mcabsorbCompchannel_5_filter
  STORE_NEUTRON(74,
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp);
  mcScattered=0;
  mcRestore=0;
  mcNCounter[74]++;
  mcPCounter[74] += p;
  mcP2Counter[74] += p*p;
  if (!mcGroupfilter_group) { /* previous comps of GROUP have not SCATTERED yet */
#undef mcabsorb
/* if ABSORBed in GROUP/comp, will go to end of component */
RESTORE=1;
#define mcabsorb mcabsorbCompchannel_5_filter
#define mccompcurname  channel_5_filter
#define mccompcurtype  Slit_MACS
#define mccompcurindex 74
{   /* Declarations of channel_5_filter=Slit_MACS() SETTING parameters. */
MCNUM xmin = mccchannel_5_filter_xmin;
MCNUM xmax = mccchannel_5_filter_xmax;
MCNUM ymin = mccchannel_5_filter_ymin;
MCNUM ymax = mccchannel_5_filter_ymax;
MCNUM radius = mccchannel_5_filter_radius;
MCNUM xwidth = mccchannel_5_filter_xwidth;
MCNUM yheight = mccchannel_5_filter_yheight;
#line 71 "Slit_MACS.comp"
{
    PROP_Z0;
    if (!(((radius == 0) && (x<xmin || x>xmax || y<ymin || y>ymax))
    || ((radius != 0) && (x*x + y*y > radius*radius)))) {
        SCATTER;
    }
    
      //ABSORB;
    //else
        //SCATTER;
}
#line 355690 "MACS_sample_kidney_box.c"
/* 'channel_5_filter=Slit_MACS()' component instance extend code */
    SIG_MESSAGE("channel_5_filter (Trace:Extend)");
#line 138 "generated_includes/kidney_trace.c"
    if (SCATTERED) channel_selected = 5;
    //printf("channel_selected = %d\n",channel_selected);
#line 355696 "MACS_sample_kidney_box.c"
}   /* End of channel_5_filter=Slit_MACS() SETTING parameter declarations. */
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex
#undef mcabsorb
#define mcabsorb mcabsorbAll
  } /* end comp channel_5_filter in GROUP filter_group */
  if (SCATTERED) {
    mcGroupfilter_group=74;
    RESTORE=0;
  }
  /* Label for restoring  neutron */
  mcabsorbCompchannel_5_filter:
  if (RESTORE) /* restore if needed */
  { RESTORE_NEUTRON(74,
      mcnlx,
      mcnly,
      mcnlz,
      mcnlvx,
      mcnlvy,
      mcnlvz,
      mcnlt,
      mcnlsx,
      mcnlsy,
      mcnlsz,
      mcnlp); }
#undef mcabsorbComp
#undef p
#undef sz
#undef sy
#undef sx
#undef t
#undef vz
#undef vy
#undef vx
#undef z
#undef y
#undef x
  mcDEBUG_STATE(
mcnlx,
mcnly,
mcnlz,
mcnlvx,
mcnlvy,
mcnlvz,
mcnlt,
mcnlsx,
mcnlsy,
mcnlsz,
mcnlp)

  /* TRACE Component channel_6_filter [75] */
  mccoordschange(mcposrchannel_6_filter, mcrotrchannel_6_filter,
    &mcnlx,
    &mcnly,
    &mcnlz,
    &mcnlvx,
    &mcnlvy,
    &mcnlvz,
    &mcnlsx,
    &mcnlsy,
    &mcnlsz);
  /* define label inside component channel_6_filter (without coords transformations) */
  mcJumpTrace_channel_6_filter:
  SIG_MESSAGE("channel_6_filter (Trace)");
  mcDEBUG_COMP("channel_6_filter")
  mcDEBUG_STATE(
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp)
#define x mcnlx
#define y mcnly
#define z mcnlz
#define vx mcnlvx
#define vy mcnlvy
#define vz mcnlvz
#define t mcnlt
#define sx mcnlsx
#define sy mcnlsy
#define sz mcnlsz
#define p mcnlp

#define mcabsorbComp mcabsorbCompchannel_6_filter
  STORE_NEUTRON(75,
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp);
  mcScattered=0;
  mcRestore=0;
  mcNCounter[75]++;
  mcPCounter[75] += p;
  mcP2Counter[75] += p*p;
  if (!mcGroupfilter_group) { /* previous comps of GROUP have not SCATTERED yet */
#undef mcabsorb
/* if ABSORBed in GROUP/comp, will go to end of component */
RESTORE=1;
#define mcabsorb mcabsorbCompchannel_6_filter
#define mccompcurname  channel_6_filter
#define mccompcurtype  Slit_MACS
#define mccompcurindex 75
{   /* Declarations of channel_6_filter=Slit_MACS() SETTING parameters. */
MCNUM xmin = mccchannel_6_filter_xmin;
MCNUM xmax = mccchannel_6_filter_xmax;
MCNUM ymin = mccchannel_6_filter_ymin;
MCNUM ymax = mccchannel_6_filter_ymax;
MCNUM radius = mccchannel_6_filter_radius;
MCNUM xwidth = mccchannel_6_filter_xwidth;
MCNUM yheight = mccchannel_6_filter_yheight;
#line 71 "Slit_MACS.comp"
{
    PROP_Z0;
    if (!(((radius == 0) && (x<xmin || x>xmax || y<ymin || y>ymax))
    || ((radius != 0) && (x*x + y*y > radius*radius)))) {
        SCATTER;
    }
    
      //ABSORB;
    //else
        //SCATTER;
}
#line 355830 "MACS_sample_kidney_box.c"
/* 'channel_6_filter=Slit_MACS()' component instance extend code */
    SIG_MESSAGE("channel_6_filter (Trace:Extend)");
#line 147 "generated_includes/kidney_trace.c"
    if (SCATTERED) channel_selected = 6;
    //printf("channel_selected = %d\n",channel_selected);
#line 355836 "MACS_sample_kidney_box.c"
}   /* End of channel_6_filter=Slit_MACS() SETTING parameter declarations. */
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex
#undef mcabsorb
#define mcabsorb mcabsorbAll
  } /* end comp channel_6_filter in GROUP filter_group */
  if (SCATTERED) {
    mcGroupfilter_group=75;
    RESTORE=0;
  }
  /* Label for restoring  neutron */
  mcabsorbCompchannel_6_filter:
  if (RESTORE) /* restore if needed */
  { RESTORE_NEUTRON(75,
      mcnlx,
      mcnly,
      mcnlz,
      mcnlvx,
      mcnlvy,
      mcnlvz,
      mcnlt,
      mcnlsx,
      mcnlsy,
      mcnlsz,
      mcnlp); }
#undef mcabsorbComp
#undef p
#undef sz
#undef sy
#undef sx
#undef t
#undef vz
#undef vy
#undef vx
#undef z
#undef y
#undef x
  mcDEBUG_STATE(
mcnlx,
mcnly,
mcnlz,
mcnlvx,
mcnlvy,
mcnlvz,
mcnlt,
mcnlsx,
mcnlsy,
mcnlsz,
mcnlp)

  /* TRACE Component channel_7_filter [76] */
  mccoordschange(mcposrchannel_7_filter, mcrotrchannel_7_filter,
    &mcnlx,
    &mcnly,
    &mcnlz,
    &mcnlvx,
    &mcnlvy,
    &mcnlvz,
    &mcnlsx,
    &mcnlsy,
    &mcnlsz);
  /* define label inside component channel_7_filter (without coords transformations) */
  mcJumpTrace_channel_7_filter:
  SIG_MESSAGE("channel_7_filter (Trace)");
  mcDEBUG_COMP("channel_7_filter")
  mcDEBUG_STATE(
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp)
#define x mcnlx
#define y mcnly
#define z mcnlz
#define vx mcnlvx
#define vy mcnlvy
#define vz mcnlvz
#define t mcnlt
#define sx mcnlsx
#define sy mcnlsy
#define sz mcnlsz
#define p mcnlp

#define mcabsorbComp mcabsorbCompchannel_7_filter
  STORE_NEUTRON(76,
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp);
  mcScattered=0;
  mcRestore=0;
  mcNCounter[76]++;
  mcPCounter[76] += p;
  mcP2Counter[76] += p*p;
  if (!mcGroupfilter_group) { /* previous comps of GROUP have not SCATTERED yet */
#undef mcabsorb
/* if ABSORBed in GROUP/comp, will go to end of component */
RESTORE=1;
#define mcabsorb mcabsorbCompchannel_7_filter
#define mccompcurname  channel_7_filter
#define mccompcurtype  Slit_MACS
#define mccompcurindex 76
{   /* Declarations of channel_7_filter=Slit_MACS() SETTING parameters. */
MCNUM xmin = mccchannel_7_filter_xmin;
MCNUM xmax = mccchannel_7_filter_xmax;
MCNUM ymin = mccchannel_7_filter_ymin;
MCNUM ymax = mccchannel_7_filter_ymax;
MCNUM radius = mccchannel_7_filter_radius;
MCNUM xwidth = mccchannel_7_filter_xwidth;
MCNUM yheight = mccchannel_7_filter_yheight;
#line 71 "Slit_MACS.comp"
{
    PROP_Z0;
    if (!(((radius == 0) && (x<xmin || x>xmax || y<ymin || y>ymax))
    || ((radius != 0) && (x*x + y*y > radius*radius)))) {
        SCATTER;
    }
    
      //ABSORB;
    //else
        //SCATTER;
}
#line 355970 "MACS_sample_kidney_box.c"
/* 'channel_7_filter=Slit_MACS()' component instance extend code */
    SIG_MESSAGE("channel_7_filter (Trace:Extend)");
#line 156 "generated_includes/kidney_trace.c"
    if (SCATTERED) channel_selected = 7;
    //printf("channel_selected = %d\n",channel_selected);
#line 355976 "MACS_sample_kidney_box.c"
}   /* End of channel_7_filter=Slit_MACS() SETTING parameter declarations. */
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex
#undef mcabsorb
#define mcabsorb mcabsorbAll
  } /* end comp channel_7_filter in GROUP filter_group */
  if (SCATTERED) {
    mcGroupfilter_group=76;
    RESTORE=0;
  }
  /* Label for restoring  neutron */
  mcabsorbCompchannel_7_filter:
  if (RESTORE) /* restore if needed */
  { RESTORE_NEUTRON(76,
      mcnlx,
      mcnly,
      mcnlz,
      mcnlvx,
      mcnlvy,
      mcnlvz,
      mcnlt,
      mcnlsx,
      mcnlsy,
      mcnlsz,
      mcnlp); }
#undef mcabsorbComp
#undef p
#undef sz
#undef sy
#undef sx
#undef t
#undef vz
#undef vy
#undef vx
#undef z
#undef y
#undef x
  mcDEBUG_STATE(
mcnlx,
mcnly,
mcnlz,
mcnlvx,
mcnlvy,
mcnlvz,
mcnlt,
mcnlsx,
mcnlsy,
mcnlsz,
mcnlp)

  /* TRACE Component channel_8_filter [77] */
  mccoordschange(mcposrchannel_8_filter, mcrotrchannel_8_filter,
    &mcnlx,
    &mcnly,
    &mcnlz,
    &mcnlvx,
    &mcnlvy,
    &mcnlvz,
    &mcnlsx,
    &mcnlsy,
    &mcnlsz);
  /* define label inside component channel_8_filter (without coords transformations) */
  mcJumpTrace_channel_8_filter:
  SIG_MESSAGE("channel_8_filter (Trace)");
  mcDEBUG_COMP("channel_8_filter")
  mcDEBUG_STATE(
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp)
#define x mcnlx
#define y mcnly
#define z mcnlz
#define vx mcnlvx
#define vy mcnlvy
#define vz mcnlvz
#define t mcnlt
#define sx mcnlsx
#define sy mcnlsy
#define sz mcnlsz
#define p mcnlp

#define mcabsorbComp mcabsorbCompchannel_8_filter
  STORE_NEUTRON(77,
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp);
  mcScattered=0;
  mcRestore=0;
  mcNCounter[77]++;
  mcPCounter[77] += p;
  mcP2Counter[77] += p*p;
  if (!mcGroupfilter_group) { /* previous comps of GROUP have not SCATTERED yet */
#undef mcabsorb
/* if ABSORBed in GROUP/comp, will go to end of component */
RESTORE=1;
#define mcabsorb mcabsorbCompchannel_8_filter
#define mccompcurname  channel_8_filter
#define mccompcurtype  Slit_MACS
#define mccompcurindex 77
{   /* Declarations of channel_8_filter=Slit_MACS() SETTING parameters. */
MCNUM xmin = mccchannel_8_filter_xmin;
MCNUM xmax = mccchannel_8_filter_xmax;
MCNUM ymin = mccchannel_8_filter_ymin;
MCNUM ymax = mccchannel_8_filter_ymax;
MCNUM radius = mccchannel_8_filter_radius;
MCNUM xwidth = mccchannel_8_filter_xwidth;
MCNUM yheight = mccchannel_8_filter_yheight;
#line 71 "Slit_MACS.comp"
{
    PROP_Z0;
    if (!(((radius == 0) && (x<xmin || x>xmax || y<ymin || y>ymax))
    || ((radius != 0) && (x*x + y*y > radius*radius)))) {
        SCATTER;
    }
    
      //ABSORB;
    //else
        //SCATTER;
}
#line 356110 "MACS_sample_kidney_box.c"
/* 'channel_8_filter=Slit_MACS()' component instance extend code */
    SIG_MESSAGE("channel_8_filter (Trace:Extend)");
#line 165 "generated_includes/kidney_trace.c"
    if (SCATTERED) channel_selected = 8;
    //printf("channel_selected = %d\n",channel_selected);
#line 356116 "MACS_sample_kidney_box.c"
}   /* End of channel_8_filter=Slit_MACS() SETTING parameter declarations. */
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex
#undef mcabsorb
#define mcabsorb mcabsorbAll
  } /* end comp channel_8_filter in GROUP filter_group */
  if (SCATTERED) {
    mcGroupfilter_group=77;
    RESTORE=0;
  }
  /* Label for restoring  neutron */
  mcabsorbCompchannel_8_filter:
  if (RESTORE) /* restore if needed */
  { RESTORE_NEUTRON(77,
      mcnlx,
      mcnly,
      mcnlz,
      mcnlvx,
      mcnlvy,
      mcnlvz,
      mcnlt,
      mcnlsx,
      mcnlsy,
      mcnlsz,
      mcnlp); }
#undef mcabsorbComp
#undef p
#undef sz
#undef sy
#undef sx
#undef t
#undef vz
#undef vy
#undef vx
#undef z
#undef y
#undef x
  mcDEBUG_STATE(
mcnlx,
mcnly,
mcnlz,
mcnlvx,
mcnlvy,
mcnlvz,
mcnlt,
mcnlsx,
mcnlsy,
mcnlsz,
mcnlp)

  /* TRACE Component channel_9_filter [78] */
  mccoordschange(mcposrchannel_9_filter, mcrotrchannel_9_filter,
    &mcnlx,
    &mcnly,
    &mcnlz,
    &mcnlvx,
    &mcnlvy,
    &mcnlvz,
    &mcnlsx,
    &mcnlsy,
    &mcnlsz);
  /* define label inside component channel_9_filter (without coords transformations) */
  mcJumpTrace_channel_9_filter:
  SIG_MESSAGE("channel_9_filter (Trace)");
  mcDEBUG_COMP("channel_9_filter")
  mcDEBUG_STATE(
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp)
#define x mcnlx
#define y mcnly
#define z mcnlz
#define vx mcnlvx
#define vy mcnlvy
#define vz mcnlvz
#define t mcnlt
#define sx mcnlsx
#define sy mcnlsy
#define sz mcnlsz
#define p mcnlp

#define mcabsorbComp mcabsorbCompchannel_9_filter
  STORE_NEUTRON(78,
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp);
  mcScattered=0;
  mcRestore=0;
  mcNCounter[78]++;
  mcPCounter[78] += p;
  mcP2Counter[78] += p*p;
  if (!mcGroupfilter_group) { /* previous comps of GROUP have not SCATTERED yet */
#undef mcabsorb
/* if ABSORBed in GROUP/comp, will go to end of component */
RESTORE=1;
#define mcabsorb mcabsorbCompchannel_9_filter
#define mccompcurname  channel_9_filter
#define mccompcurtype  Slit_MACS
#define mccompcurindex 78
{   /* Declarations of channel_9_filter=Slit_MACS() SETTING parameters. */
MCNUM xmin = mccchannel_9_filter_xmin;
MCNUM xmax = mccchannel_9_filter_xmax;
MCNUM ymin = mccchannel_9_filter_ymin;
MCNUM ymax = mccchannel_9_filter_ymax;
MCNUM radius = mccchannel_9_filter_radius;
MCNUM xwidth = mccchannel_9_filter_xwidth;
MCNUM yheight = mccchannel_9_filter_yheight;
#line 71 "Slit_MACS.comp"
{
    PROP_Z0;
    if (!(((radius == 0) && (x<xmin || x>xmax || y<ymin || y>ymax))
    || ((radius != 0) && (x*x + y*y > radius*radius)))) {
        SCATTER;
    }
    
      //ABSORB;
    //else
        //SCATTER;
}
#line 356250 "MACS_sample_kidney_box.c"
/* 'channel_9_filter=Slit_MACS()' component instance extend code */
    SIG_MESSAGE("channel_9_filter (Trace:Extend)");
#line 174 "generated_includes/kidney_trace.c"
    if (SCATTERED) channel_selected = 9;
    //printf("channel_selected = %d\n",channel_selected);
#line 356256 "MACS_sample_kidney_box.c"
}   /* End of channel_9_filter=Slit_MACS() SETTING parameter declarations. */
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex
#undef mcabsorb
#define mcabsorb mcabsorbAll
  } /* end comp channel_9_filter in GROUP filter_group */
  if (SCATTERED) {
    mcGroupfilter_group=78;
    RESTORE=0;
  }
  /* Label for restoring  neutron */
  mcabsorbCompchannel_9_filter:
  if (RESTORE) /* restore if needed */
  { RESTORE_NEUTRON(78,
      mcnlx,
      mcnly,
      mcnlz,
      mcnlvx,
      mcnlvy,
      mcnlvz,
      mcnlt,
      mcnlsx,
      mcnlsy,
      mcnlsz,
      mcnlp); }
#undef mcabsorbComp
#undef p
#undef sz
#undef sy
#undef sx
#undef t
#undef vz
#undef vy
#undef vx
#undef z
#undef y
#undef x
  mcDEBUG_STATE(
mcnlx,
mcnly,
mcnlz,
mcnlvx,
mcnlvy,
mcnlvz,
mcnlt,
mcnlsx,
mcnlsy,
mcnlsz,
mcnlp)

  /* TRACE Component channel_10_filter [79] */
  mccoordschange(mcposrchannel_10_filter, mcrotrchannel_10_filter,
    &mcnlx,
    &mcnly,
    &mcnlz,
    &mcnlvx,
    &mcnlvy,
    &mcnlvz,
    &mcnlsx,
    &mcnlsy,
    &mcnlsz);
  /* define label inside component channel_10_filter (without coords transformations) */
  mcJumpTrace_channel_10_filter:
  SIG_MESSAGE("channel_10_filter (Trace)");
  mcDEBUG_COMP("channel_10_filter")
  mcDEBUG_STATE(
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp)
#define x mcnlx
#define y mcnly
#define z mcnlz
#define vx mcnlvx
#define vy mcnlvy
#define vz mcnlvz
#define t mcnlt
#define sx mcnlsx
#define sy mcnlsy
#define sz mcnlsz
#define p mcnlp

#define mcabsorbComp mcabsorbCompchannel_10_filter
  STORE_NEUTRON(79,
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp);
  mcScattered=0;
  mcRestore=0;
  mcNCounter[79]++;
  mcPCounter[79] += p;
  mcP2Counter[79] += p*p;
  if (!mcGroupfilter_group) { /* previous comps of GROUP have not SCATTERED yet */
#undef mcabsorb
/* if ABSORBed in GROUP/comp, will go to end of component */
RESTORE=1;
#define mcabsorb mcabsorbCompchannel_10_filter
#define mccompcurname  channel_10_filter
#define mccompcurtype  Slit_MACS
#define mccompcurindex 79
{   /* Declarations of channel_10_filter=Slit_MACS() SETTING parameters. */
MCNUM xmin = mccchannel_10_filter_xmin;
MCNUM xmax = mccchannel_10_filter_xmax;
MCNUM ymin = mccchannel_10_filter_ymin;
MCNUM ymax = mccchannel_10_filter_ymax;
MCNUM radius = mccchannel_10_filter_radius;
MCNUM xwidth = mccchannel_10_filter_xwidth;
MCNUM yheight = mccchannel_10_filter_yheight;
#line 71 "Slit_MACS.comp"
{
    PROP_Z0;
    if (!(((radius == 0) && (x<xmin || x>xmax || y<ymin || y>ymax))
    || ((radius != 0) && (x*x + y*y > radius*radius)))) {
        SCATTER;
    }
    
      //ABSORB;
    //else
        //SCATTER;
}
#line 356390 "MACS_sample_kidney_box.c"
/* 'channel_10_filter=Slit_MACS()' component instance extend code */
    SIG_MESSAGE("channel_10_filter (Trace:Extend)");
#line 183 "generated_includes/kidney_trace.c"
    if (SCATTERED) channel_selected = 10;
    //printf("channel_selected = %d\n",channel_selected);
#line 356396 "MACS_sample_kidney_box.c"
}   /* End of channel_10_filter=Slit_MACS() SETTING parameter declarations. */
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex
#undef mcabsorb
#define mcabsorb mcabsorbAll
  } /* end comp channel_10_filter in GROUP filter_group */
  if (SCATTERED) {
    mcGroupfilter_group=79;
    RESTORE=0;
  }
  /* Label for restoring  neutron */
  mcabsorbCompchannel_10_filter:
  if (RESTORE) /* restore if needed */
  { RESTORE_NEUTRON(79,
      mcnlx,
      mcnly,
      mcnlz,
      mcnlvx,
      mcnlvy,
      mcnlvz,
      mcnlt,
      mcnlsx,
      mcnlsy,
      mcnlsz,
      mcnlp); }
#undef mcabsorbComp
#undef p
#undef sz
#undef sy
#undef sx
#undef t
#undef vz
#undef vy
#undef vx
#undef z
#undef y
#undef x
  mcDEBUG_STATE(
mcnlx,
mcnly,
mcnlz,
mcnlvx,
mcnlvy,
mcnlvz,
mcnlt,
mcnlsx,
mcnlsy,
mcnlsz,
mcnlp)

  /* TRACE Component channel_11_filter [80] */
  mccoordschange(mcposrchannel_11_filter, mcrotrchannel_11_filter,
    &mcnlx,
    &mcnly,
    &mcnlz,
    &mcnlvx,
    &mcnlvy,
    &mcnlvz,
    &mcnlsx,
    &mcnlsy,
    &mcnlsz);
  /* define label inside component channel_11_filter (without coords transformations) */
  mcJumpTrace_channel_11_filter:
  SIG_MESSAGE("channel_11_filter (Trace)");
  mcDEBUG_COMP("channel_11_filter")
  mcDEBUG_STATE(
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp)
#define x mcnlx
#define y mcnly
#define z mcnlz
#define vx mcnlvx
#define vy mcnlvy
#define vz mcnlvz
#define t mcnlt
#define sx mcnlsx
#define sy mcnlsy
#define sz mcnlsz
#define p mcnlp

#define mcabsorbComp mcabsorbCompchannel_11_filter
  STORE_NEUTRON(80,
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp);
  mcScattered=0;
  mcRestore=0;
  mcNCounter[80]++;
  mcPCounter[80] += p;
  mcP2Counter[80] += p*p;
  if (!mcGroupfilter_group) { /* previous comps of GROUP have not SCATTERED yet */
#undef mcabsorb
/* if ABSORBed in GROUP/comp, will go to end of component */
RESTORE=1;
#define mcabsorb mcabsorbCompchannel_11_filter
#define mccompcurname  channel_11_filter
#define mccompcurtype  Slit_MACS
#define mccompcurindex 80
{   /* Declarations of channel_11_filter=Slit_MACS() SETTING parameters. */
MCNUM xmin = mccchannel_11_filter_xmin;
MCNUM xmax = mccchannel_11_filter_xmax;
MCNUM ymin = mccchannel_11_filter_ymin;
MCNUM ymax = mccchannel_11_filter_ymax;
MCNUM radius = mccchannel_11_filter_radius;
MCNUM xwidth = mccchannel_11_filter_xwidth;
MCNUM yheight = mccchannel_11_filter_yheight;
#line 71 "Slit_MACS.comp"
{
    PROP_Z0;
    if (!(((radius == 0) && (x<xmin || x>xmax || y<ymin || y>ymax))
    || ((radius != 0) && (x*x + y*y > radius*radius)))) {
        SCATTER;
    }
    
      //ABSORB;
    //else
        //SCATTER;
}
#line 356530 "MACS_sample_kidney_box.c"
/* 'channel_11_filter=Slit_MACS()' component instance extend code */
    SIG_MESSAGE("channel_11_filter (Trace:Extend)");
#line 192 "generated_includes/kidney_trace.c"
    if (SCATTERED) channel_selected = 11;
    //printf("channel_selected = %d\n",channel_selected);
#line 356536 "MACS_sample_kidney_box.c"
}   /* End of channel_11_filter=Slit_MACS() SETTING parameter declarations. */
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex
#undef mcabsorb
#define mcabsorb mcabsorbAll
  } /* end comp channel_11_filter in GROUP filter_group */
  if (SCATTERED) {
    mcGroupfilter_group=80;
    RESTORE=0;
  }
  /* Label for restoring  neutron */
  mcabsorbCompchannel_11_filter:
  if (RESTORE) /* restore if needed */
  { RESTORE_NEUTRON(80,
      mcnlx,
      mcnly,
      mcnlz,
      mcnlvx,
      mcnlvy,
      mcnlvz,
      mcnlt,
      mcnlsx,
      mcnlsy,
      mcnlsz,
      mcnlp); }
#undef mcabsorbComp
#undef p
#undef sz
#undef sy
#undef sx
#undef t
#undef vz
#undef vy
#undef vx
#undef z
#undef y
#undef x
  mcDEBUG_STATE(
mcnlx,
mcnly,
mcnlz,
mcnlvx,
mcnlvy,
mcnlvz,
mcnlt,
mcnlsx,
mcnlsy,
mcnlsz,
mcnlp)

  /* TRACE Component channel_12_filter [81] */
  mccoordschange(mcposrchannel_12_filter, mcrotrchannel_12_filter,
    &mcnlx,
    &mcnly,
    &mcnlz,
    &mcnlvx,
    &mcnlvy,
    &mcnlvz,
    &mcnlsx,
    &mcnlsy,
    &mcnlsz);
  /* define label inside component channel_12_filter (without coords transformations) */
  mcJumpTrace_channel_12_filter:
  SIG_MESSAGE("channel_12_filter (Trace)");
  mcDEBUG_COMP("channel_12_filter")
  mcDEBUG_STATE(
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp)
#define x mcnlx
#define y mcnly
#define z mcnlz
#define vx mcnlvx
#define vy mcnlvy
#define vz mcnlvz
#define t mcnlt
#define sx mcnlsx
#define sy mcnlsy
#define sz mcnlsz
#define p mcnlp

#define mcabsorbComp mcabsorbCompchannel_12_filter
  STORE_NEUTRON(81,
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp);
  mcScattered=0;
  mcRestore=0;
  mcNCounter[81]++;
  mcPCounter[81] += p;
  mcP2Counter[81] += p*p;
  if (!mcGroupfilter_group) { /* previous comps of GROUP have not SCATTERED yet */
#undef mcabsorb
/* if ABSORBed in GROUP/comp, will go to end of component */
RESTORE=1;
#define mcabsorb mcabsorbCompchannel_12_filter
#define mccompcurname  channel_12_filter
#define mccompcurtype  Slit_MACS
#define mccompcurindex 81
{   /* Declarations of channel_12_filter=Slit_MACS() SETTING parameters. */
MCNUM xmin = mccchannel_12_filter_xmin;
MCNUM xmax = mccchannel_12_filter_xmax;
MCNUM ymin = mccchannel_12_filter_ymin;
MCNUM ymax = mccchannel_12_filter_ymax;
MCNUM radius = mccchannel_12_filter_radius;
MCNUM xwidth = mccchannel_12_filter_xwidth;
MCNUM yheight = mccchannel_12_filter_yheight;
#line 71 "Slit_MACS.comp"
{
    PROP_Z0;
    if (!(((radius == 0) && (x<xmin || x>xmax || y<ymin || y>ymax))
    || ((radius != 0) && (x*x + y*y > radius*radius)))) {
        SCATTER;
    }
    
      //ABSORB;
    //else
        //SCATTER;
}
#line 356670 "MACS_sample_kidney_box.c"
/* 'channel_12_filter=Slit_MACS()' component instance extend code */
    SIG_MESSAGE("channel_12_filter (Trace:Extend)");
#line 201 "generated_includes/kidney_trace.c"
    if (SCATTERED) channel_selected = 12;
    //printf("channel_selected = %d\n",channel_selected);
#line 356676 "MACS_sample_kidney_box.c"
}   /* End of channel_12_filter=Slit_MACS() SETTING parameter declarations. */
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex
#undef mcabsorb
#define mcabsorb mcabsorbAll
  } /* end comp channel_12_filter in GROUP filter_group */
  if (SCATTERED) {
    mcGroupfilter_group=81;
    RESTORE=0;
  }
  /* Label for restoring  neutron */
  mcabsorbCompchannel_12_filter:
  if (RESTORE) /* restore if needed */
  { RESTORE_NEUTRON(81,
      mcnlx,
      mcnly,
      mcnlz,
      mcnlvx,
      mcnlvy,
      mcnlvz,
      mcnlt,
      mcnlsx,
      mcnlsy,
      mcnlsz,
      mcnlp); }
#undef mcabsorbComp
#undef p
#undef sz
#undef sy
#undef sx
#undef t
#undef vz
#undef vy
#undef vx
#undef z
#undef y
#undef x
  mcDEBUG_STATE(
mcnlx,
mcnly,
mcnlz,
mcnlvx,
mcnlvy,
mcnlvz,
mcnlt,
mcnlsx,
mcnlsy,
mcnlsz,
mcnlp)

  /* TRACE Component channel_13_filter [82] */
  mccoordschange(mcposrchannel_13_filter, mcrotrchannel_13_filter,
    &mcnlx,
    &mcnly,
    &mcnlz,
    &mcnlvx,
    &mcnlvy,
    &mcnlvz,
    &mcnlsx,
    &mcnlsy,
    &mcnlsz);
  /* define label inside component channel_13_filter (without coords transformations) */
  mcJumpTrace_channel_13_filter:
  SIG_MESSAGE("channel_13_filter (Trace)");
  mcDEBUG_COMP("channel_13_filter")
  mcDEBUG_STATE(
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp)
#define x mcnlx
#define y mcnly
#define z mcnlz
#define vx mcnlvx
#define vy mcnlvy
#define vz mcnlvz
#define t mcnlt
#define sx mcnlsx
#define sy mcnlsy
#define sz mcnlsz
#define p mcnlp

#define mcabsorbComp mcabsorbCompchannel_13_filter
  STORE_NEUTRON(82,
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp);
  mcScattered=0;
  mcRestore=0;
  mcNCounter[82]++;
  mcPCounter[82] += p;
  mcP2Counter[82] += p*p;
  if (!mcGroupfilter_group) { /* previous comps of GROUP have not SCATTERED yet */
#undef mcabsorb
/* if ABSORBed in GROUP/comp, will go to end of component */
RESTORE=1;
#define mcabsorb mcabsorbCompchannel_13_filter
#define mccompcurname  channel_13_filter
#define mccompcurtype  Slit_MACS
#define mccompcurindex 82
{   /* Declarations of channel_13_filter=Slit_MACS() SETTING parameters. */
MCNUM xmin = mccchannel_13_filter_xmin;
MCNUM xmax = mccchannel_13_filter_xmax;
MCNUM ymin = mccchannel_13_filter_ymin;
MCNUM ymax = mccchannel_13_filter_ymax;
MCNUM radius = mccchannel_13_filter_radius;
MCNUM xwidth = mccchannel_13_filter_xwidth;
MCNUM yheight = mccchannel_13_filter_yheight;
#line 71 "Slit_MACS.comp"
{
    PROP_Z0;
    if (!(((radius == 0) && (x<xmin || x>xmax || y<ymin || y>ymax))
    || ((radius != 0) && (x*x + y*y > radius*radius)))) {
        SCATTER;
    }
    
      //ABSORB;
    //else
        //SCATTER;
}
#line 356810 "MACS_sample_kidney_box.c"
/* 'channel_13_filter=Slit_MACS()' component instance extend code */
    SIG_MESSAGE("channel_13_filter (Trace:Extend)");
#line 210 "generated_includes/kidney_trace.c"
    if (SCATTERED) channel_selected = 13;
    //printf("channel_selected = %d\n",channel_selected);
#line 356816 "MACS_sample_kidney_box.c"
}   /* End of channel_13_filter=Slit_MACS() SETTING parameter declarations. */
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex
#undef mcabsorb
#define mcabsorb mcabsorbAll
  } /* end comp channel_13_filter in GROUP filter_group */
  if (SCATTERED) {
    mcGroupfilter_group=82;
    RESTORE=0;
  }
  /* Label for restoring  neutron */
  mcabsorbCompchannel_13_filter:
  if (RESTORE) /* restore if needed */
  { RESTORE_NEUTRON(82,
      mcnlx,
      mcnly,
      mcnlz,
      mcnlvx,
      mcnlvy,
      mcnlvz,
      mcnlt,
      mcnlsx,
      mcnlsy,
      mcnlsz,
      mcnlp); }
#undef mcabsorbComp
#undef p
#undef sz
#undef sy
#undef sx
#undef t
#undef vz
#undef vy
#undef vx
#undef z
#undef y
#undef x
  mcDEBUG_STATE(
mcnlx,
mcnly,
mcnlz,
mcnlvx,
mcnlvy,
mcnlvz,
mcnlt,
mcnlsx,
mcnlsy,
mcnlsz,
mcnlp)

  /* TRACE Component channel_14_filter [83] */
  mccoordschange(mcposrchannel_14_filter, mcrotrchannel_14_filter,
    &mcnlx,
    &mcnly,
    &mcnlz,
    &mcnlvx,
    &mcnlvy,
    &mcnlvz,
    &mcnlsx,
    &mcnlsy,
    &mcnlsz);
  /* define label inside component channel_14_filter (without coords transformations) */
  mcJumpTrace_channel_14_filter:
  SIG_MESSAGE("channel_14_filter (Trace)");
  mcDEBUG_COMP("channel_14_filter")
  mcDEBUG_STATE(
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp)
#define x mcnlx
#define y mcnly
#define z mcnlz
#define vx mcnlvx
#define vy mcnlvy
#define vz mcnlvz
#define t mcnlt
#define sx mcnlsx
#define sy mcnlsy
#define sz mcnlsz
#define p mcnlp

#define mcabsorbComp mcabsorbCompchannel_14_filter
  STORE_NEUTRON(83,
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp);
  mcScattered=0;
  mcRestore=0;
  mcNCounter[83]++;
  mcPCounter[83] += p;
  mcP2Counter[83] += p*p;
  if (!mcGroupfilter_group) { /* previous comps of GROUP have not SCATTERED yet */
#undef mcabsorb
/* if ABSORBed in GROUP/comp, will go to end of component */
RESTORE=1;
#define mcabsorb mcabsorbCompchannel_14_filter
#define mccompcurname  channel_14_filter
#define mccompcurtype  Slit_MACS
#define mccompcurindex 83
{   /* Declarations of channel_14_filter=Slit_MACS() SETTING parameters. */
MCNUM xmin = mccchannel_14_filter_xmin;
MCNUM xmax = mccchannel_14_filter_xmax;
MCNUM ymin = mccchannel_14_filter_ymin;
MCNUM ymax = mccchannel_14_filter_ymax;
MCNUM radius = mccchannel_14_filter_radius;
MCNUM xwidth = mccchannel_14_filter_xwidth;
MCNUM yheight = mccchannel_14_filter_yheight;
#line 71 "Slit_MACS.comp"
{
    PROP_Z0;
    if (!(((radius == 0) && (x<xmin || x>xmax || y<ymin || y>ymax))
    || ((radius != 0) && (x*x + y*y > radius*radius)))) {
        SCATTER;
    }
    
      //ABSORB;
    //else
        //SCATTER;
}
#line 356950 "MACS_sample_kidney_box.c"
/* 'channel_14_filter=Slit_MACS()' component instance extend code */
    SIG_MESSAGE("channel_14_filter (Trace:Extend)");
#line 219 "generated_includes/kidney_trace.c"
    if (SCATTERED) channel_selected = 14;
    //printf("channel_selected = %d\n",channel_selected);
#line 356956 "MACS_sample_kidney_box.c"
}   /* End of channel_14_filter=Slit_MACS() SETTING parameter declarations. */
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex
#undef mcabsorb
#define mcabsorb mcabsorbAll
  } /* end comp channel_14_filter in GROUP filter_group */
  if (SCATTERED) {
    mcGroupfilter_group=83;
    RESTORE=0;
  }
  /* Label for restoring  neutron */
  mcabsorbCompchannel_14_filter:
  if (RESTORE) /* restore if needed */
  { RESTORE_NEUTRON(83,
      mcnlx,
      mcnly,
      mcnlz,
      mcnlvx,
      mcnlvy,
      mcnlvz,
      mcnlt,
      mcnlsx,
      mcnlsy,
      mcnlsz,
      mcnlp); }
#undef mcabsorbComp
#undef p
#undef sz
#undef sy
#undef sx
#undef t
#undef vz
#undef vy
#undef vx
#undef z
#undef y
#undef x
  mcDEBUG_STATE(
mcnlx,
mcnly,
mcnlz,
mcnlvx,
mcnlvy,
mcnlvz,
mcnlt,
mcnlsx,
mcnlsy,
mcnlsz,
mcnlp)

  /* TRACE Component channel_15_filter [84] */
  mccoordschange(mcposrchannel_15_filter, mcrotrchannel_15_filter,
    &mcnlx,
    &mcnly,
    &mcnlz,
    &mcnlvx,
    &mcnlvy,
    &mcnlvz,
    &mcnlsx,
    &mcnlsy,
    &mcnlsz);
  /* define label inside component channel_15_filter (without coords transformations) */
  mcJumpTrace_channel_15_filter:
  SIG_MESSAGE("channel_15_filter (Trace)");
  mcDEBUG_COMP("channel_15_filter")
  mcDEBUG_STATE(
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp)
#define x mcnlx
#define y mcnly
#define z mcnlz
#define vx mcnlvx
#define vy mcnlvy
#define vz mcnlvz
#define t mcnlt
#define sx mcnlsx
#define sy mcnlsy
#define sz mcnlsz
#define p mcnlp

#define mcabsorbComp mcabsorbCompchannel_15_filter
  STORE_NEUTRON(84,
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp);
  mcScattered=0;
  mcRestore=0;
  mcNCounter[84]++;
  mcPCounter[84] += p;
  mcP2Counter[84] += p*p;
  if (!mcGroupfilter_group) { /* previous comps of GROUP have not SCATTERED yet */
#undef mcabsorb
/* if ABSORBed in GROUP/comp, will go to end of component */
RESTORE=1;
#define mcabsorb mcabsorbCompchannel_15_filter
#define mccompcurname  channel_15_filter
#define mccompcurtype  Slit_MACS
#define mccompcurindex 84
{   /* Declarations of channel_15_filter=Slit_MACS() SETTING parameters. */
MCNUM xmin = mccchannel_15_filter_xmin;
MCNUM xmax = mccchannel_15_filter_xmax;
MCNUM ymin = mccchannel_15_filter_ymin;
MCNUM ymax = mccchannel_15_filter_ymax;
MCNUM radius = mccchannel_15_filter_radius;
MCNUM xwidth = mccchannel_15_filter_xwidth;
MCNUM yheight = mccchannel_15_filter_yheight;
#line 71 "Slit_MACS.comp"
{
    PROP_Z0;
    if (!(((radius == 0) && (x<xmin || x>xmax || y<ymin || y>ymax))
    || ((radius != 0) && (x*x + y*y > radius*radius)))) {
        SCATTER;
    }
    
      //ABSORB;
    //else
        //SCATTER;
}
#line 357090 "MACS_sample_kidney_box.c"
/* 'channel_15_filter=Slit_MACS()' component instance extend code */
    SIG_MESSAGE("channel_15_filter (Trace:Extend)");
#line 228 "generated_includes/kidney_trace.c"
    if (SCATTERED) channel_selected = 15;
    //printf("channel_selected = %d\n",channel_selected);
#line 357096 "MACS_sample_kidney_box.c"
}   /* End of channel_15_filter=Slit_MACS() SETTING parameter declarations. */
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex
#undef mcabsorb
#define mcabsorb mcabsorbAll
  } /* end comp channel_15_filter in GROUP filter_group */
  if (SCATTERED) {
    mcGroupfilter_group=84;
    RESTORE=0;
  }
  /* Label for restoring  neutron */
  mcabsorbCompchannel_15_filter:
  if (RESTORE) /* restore if needed */
  { RESTORE_NEUTRON(84,
      mcnlx,
      mcnly,
      mcnlz,
      mcnlvx,
      mcnlvy,
      mcnlvz,
      mcnlt,
      mcnlsx,
      mcnlsy,
      mcnlsz,
      mcnlp); }
#undef mcabsorbComp
#undef p
#undef sz
#undef sy
#undef sx
#undef t
#undef vz
#undef vy
#undef vx
#undef z
#undef y
#undef x
  mcDEBUG_STATE(
mcnlx,
mcnly,
mcnlz,
mcnlvx,
mcnlvy,
mcnlvz,
mcnlt,
mcnlsx,
mcnlsy,
mcnlsz,
mcnlp)

  /* TRACE Component channel_16_filter [85] */
  mccoordschange(mcposrchannel_16_filter, mcrotrchannel_16_filter,
    &mcnlx,
    &mcnly,
    &mcnlz,
    &mcnlvx,
    &mcnlvy,
    &mcnlvz,
    &mcnlsx,
    &mcnlsy,
    &mcnlsz);
  /* define label inside component channel_16_filter (without coords transformations) */
  mcJumpTrace_channel_16_filter:
  SIG_MESSAGE("channel_16_filter (Trace)");
  mcDEBUG_COMP("channel_16_filter")
  mcDEBUG_STATE(
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp)
#define x mcnlx
#define y mcnly
#define z mcnlz
#define vx mcnlvx
#define vy mcnlvy
#define vz mcnlvz
#define t mcnlt
#define sx mcnlsx
#define sy mcnlsy
#define sz mcnlsz
#define p mcnlp

#define mcabsorbComp mcabsorbCompchannel_16_filter
  STORE_NEUTRON(85,
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp);
  mcScattered=0;
  mcRestore=0;
  mcNCounter[85]++;
  mcPCounter[85] += p;
  mcP2Counter[85] += p*p;
  if (!mcGroupfilter_group) { /* previous comps of GROUP have not SCATTERED yet */
#undef mcabsorb
/* if ABSORBed in GROUP/comp, will go to end of component */
RESTORE=1;
#define mcabsorb mcabsorbCompchannel_16_filter
#define mccompcurname  channel_16_filter
#define mccompcurtype  Slit_MACS
#define mccompcurindex 85
{   /* Declarations of channel_16_filter=Slit_MACS() SETTING parameters. */
MCNUM xmin = mccchannel_16_filter_xmin;
MCNUM xmax = mccchannel_16_filter_xmax;
MCNUM ymin = mccchannel_16_filter_ymin;
MCNUM ymax = mccchannel_16_filter_ymax;
MCNUM radius = mccchannel_16_filter_radius;
MCNUM xwidth = mccchannel_16_filter_xwidth;
MCNUM yheight = mccchannel_16_filter_yheight;
#line 71 "Slit_MACS.comp"
{
    PROP_Z0;
    if (!(((radius == 0) && (x<xmin || x>xmax || y<ymin || y>ymax))
    || ((radius != 0) && (x*x + y*y > radius*radius)))) {
        SCATTER;
    }
    
      //ABSORB;
    //else
        //SCATTER;
}
#line 357230 "MACS_sample_kidney_box.c"
/* 'channel_16_filter=Slit_MACS()' component instance extend code */
    SIG_MESSAGE("channel_16_filter (Trace:Extend)");
#line 237 "generated_includes/kidney_trace.c"
    if (SCATTERED) channel_selected = 16;
    //printf("channel_selected = %d\n",channel_selected);
#line 357236 "MACS_sample_kidney_box.c"
}   /* End of channel_16_filter=Slit_MACS() SETTING parameter declarations. */
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex
#undef mcabsorb
#define mcabsorb mcabsorbAll
  } /* end comp channel_16_filter in GROUP filter_group */
  if (SCATTERED) {
    mcGroupfilter_group=85;
    RESTORE=0;
  }
  /* Label for restoring  neutron */
  mcabsorbCompchannel_16_filter:
  if (RESTORE) /* restore if needed */
  { RESTORE_NEUTRON(85,
      mcnlx,
      mcnly,
      mcnlz,
      mcnlvx,
      mcnlvy,
      mcnlvz,
      mcnlt,
      mcnlsx,
      mcnlsy,
      mcnlsz,
      mcnlp); }
#undef mcabsorbComp
#undef p
#undef sz
#undef sy
#undef sx
#undef t
#undef vz
#undef vy
#undef vx
#undef z
#undef y
#undef x
  mcDEBUG_STATE(
mcnlx,
mcnly,
mcnlz,
mcnlvx,
mcnlvy,
mcnlvz,
mcnlt,
mcnlsx,
mcnlsy,
mcnlsz,
mcnlp)

  /* TRACE Component channel_17_filter [86] */
  mccoordschange(mcposrchannel_17_filter, mcrotrchannel_17_filter,
    &mcnlx,
    &mcnly,
    &mcnlz,
    &mcnlvx,
    &mcnlvy,
    &mcnlvz,
    &mcnlsx,
    &mcnlsy,
    &mcnlsz);
  /* define label inside component channel_17_filter (without coords transformations) */
  mcJumpTrace_channel_17_filter:
  SIG_MESSAGE("channel_17_filter (Trace)");
  mcDEBUG_COMP("channel_17_filter")
  mcDEBUG_STATE(
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp)
#define x mcnlx
#define y mcnly
#define z mcnlz
#define vx mcnlvx
#define vy mcnlvy
#define vz mcnlvz
#define t mcnlt
#define sx mcnlsx
#define sy mcnlsy
#define sz mcnlsz
#define p mcnlp

#define mcabsorbComp mcabsorbCompchannel_17_filter
  STORE_NEUTRON(86,
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp);
  mcScattered=0;
  mcRestore=0;
  mcNCounter[86]++;
  mcPCounter[86] += p;
  mcP2Counter[86] += p*p;
  if (!mcGroupfilter_group) { /* previous comps of GROUP have not SCATTERED yet */
#undef mcabsorb
/* if ABSORBed in GROUP/comp, will go to end of component */
RESTORE=1;
#define mcabsorb mcabsorbCompchannel_17_filter
#define mccompcurname  channel_17_filter
#define mccompcurtype  Slit_MACS
#define mccompcurindex 86
{   /* Declarations of channel_17_filter=Slit_MACS() SETTING parameters. */
MCNUM xmin = mccchannel_17_filter_xmin;
MCNUM xmax = mccchannel_17_filter_xmax;
MCNUM ymin = mccchannel_17_filter_ymin;
MCNUM ymax = mccchannel_17_filter_ymax;
MCNUM radius = mccchannel_17_filter_radius;
MCNUM xwidth = mccchannel_17_filter_xwidth;
MCNUM yheight = mccchannel_17_filter_yheight;
#line 71 "Slit_MACS.comp"
{
    PROP_Z0;
    if (!(((radius == 0) && (x<xmin || x>xmax || y<ymin || y>ymax))
    || ((radius != 0) && (x*x + y*y > radius*radius)))) {
        SCATTER;
    }
    
      //ABSORB;
    //else
        //SCATTER;
}
#line 357370 "MACS_sample_kidney_box.c"
/* 'channel_17_filter=Slit_MACS()' component instance extend code */
    SIG_MESSAGE("channel_17_filter (Trace:Extend)");
#line 246 "generated_includes/kidney_trace.c"
    if (SCATTERED) channel_selected = 17;
    //printf("channel_selected = %d\n",channel_selected);
#line 357376 "MACS_sample_kidney_box.c"
}   /* End of channel_17_filter=Slit_MACS() SETTING parameter declarations. */
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex
#undef mcabsorb
#define mcabsorb mcabsorbAll
  } /* end comp channel_17_filter in GROUP filter_group */
  if (SCATTERED) {
    mcGroupfilter_group=86;
    RESTORE=0;
  }
  /* Label for restoring  neutron */
  mcabsorbCompchannel_17_filter:
  if (RESTORE) /* restore if needed */
  { RESTORE_NEUTRON(86,
      mcnlx,
      mcnly,
      mcnlz,
      mcnlvx,
      mcnlvy,
      mcnlvz,
      mcnlt,
      mcnlsx,
      mcnlsy,
      mcnlsz,
      mcnlp); }
#undef mcabsorbComp
#undef p
#undef sz
#undef sy
#undef sx
#undef t
#undef vz
#undef vy
#undef vx
#undef z
#undef y
#undef x
  mcDEBUG_STATE(
mcnlx,
mcnly,
mcnlz,
mcnlvx,
mcnlvy,
mcnlvz,
mcnlt,
mcnlsx,
mcnlsy,
mcnlsz,
mcnlp)

  /* TRACE Component channel_18_filter [87] */
  mccoordschange(mcposrchannel_18_filter, mcrotrchannel_18_filter,
    &mcnlx,
    &mcnly,
    &mcnlz,
    &mcnlvx,
    &mcnlvy,
    &mcnlvz,
    &mcnlsx,
    &mcnlsy,
    &mcnlsz);
  /* define label inside component channel_18_filter (without coords transformations) */
  mcJumpTrace_channel_18_filter:
  SIG_MESSAGE("channel_18_filter (Trace)");
  mcDEBUG_COMP("channel_18_filter")
  mcDEBUG_STATE(
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp)
#define x mcnlx
#define y mcnly
#define z mcnlz
#define vx mcnlvx
#define vy mcnlvy
#define vz mcnlvz
#define t mcnlt
#define sx mcnlsx
#define sy mcnlsy
#define sz mcnlsz
#define p mcnlp

#define mcabsorbComp mcabsorbCompchannel_18_filter
  STORE_NEUTRON(87,
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp);
  mcScattered=0;
  mcRestore=0;
  mcNCounter[87]++;
  mcPCounter[87] += p;
  mcP2Counter[87] += p*p;
  if (!mcGroupfilter_group) { /* previous comps of GROUP have not SCATTERED yet */
#undef mcabsorb
/* if ABSORBed in GROUP/comp, will go to end of component */
RESTORE=1;
#define mcabsorb mcabsorbCompchannel_18_filter
#define mccompcurname  channel_18_filter
#define mccompcurtype  Slit_MACS
#define mccompcurindex 87
{   /* Declarations of channel_18_filter=Slit_MACS() SETTING parameters. */
MCNUM xmin = mccchannel_18_filter_xmin;
MCNUM xmax = mccchannel_18_filter_xmax;
MCNUM ymin = mccchannel_18_filter_ymin;
MCNUM ymax = mccchannel_18_filter_ymax;
MCNUM radius = mccchannel_18_filter_radius;
MCNUM xwidth = mccchannel_18_filter_xwidth;
MCNUM yheight = mccchannel_18_filter_yheight;
#line 71 "Slit_MACS.comp"
{
    PROP_Z0;
    if (!(((radius == 0) && (x<xmin || x>xmax || y<ymin || y>ymax))
    || ((radius != 0) && (x*x + y*y > radius*radius)))) {
        SCATTER;
    }
    
      //ABSORB;
    //else
        //SCATTER;
}
#line 357510 "MACS_sample_kidney_box.c"
/* 'channel_18_filter=Slit_MACS()' component instance extend code */
    SIG_MESSAGE("channel_18_filter (Trace:Extend)");
#line 255 "generated_includes/kidney_trace.c"
    if (SCATTERED) channel_selected = 18;
    //printf("channel_selected = %d\n",channel_selected);
#line 357516 "MACS_sample_kidney_box.c"
}   /* End of channel_18_filter=Slit_MACS() SETTING parameter declarations. */
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex
#undef mcabsorb
#define mcabsorb mcabsorbAll
  } /* end comp channel_18_filter in GROUP filter_group */
  if (SCATTERED) {
    mcGroupfilter_group=87;
    RESTORE=0;
  }
  /* Label for restoring  neutron */
  mcabsorbCompchannel_18_filter:
  if (RESTORE) /* restore if needed */
  { RESTORE_NEUTRON(87,
      mcnlx,
      mcnly,
      mcnlz,
      mcnlvx,
      mcnlvy,
      mcnlvz,
      mcnlt,
      mcnlsx,
      mcnlsy,
      mcnlsz,
      mcnlp); }
#undef mcabsorbComp
#undef p
#undef sz
#undef sy
#undef sx
#undef t
#undef vz
#undef vy
#undef vx
#undef z
#undef y
#undef x
  mcDEBUG_STATE(
mcnlx,
mcnly,
mcnlz,
mcnlvx,
mcnlvy,
mcnlvz,
mcnlt,
mcnlsx,
mcnlsy,
mcnlsz,
mcnlp)

  /* TRACE Component channel_19_filter [88] */
  mccoordschange(mcposrchannel_19_filter, mcrotrchannel_19_filter,
    &mcnlx,
    &mcnly,
    &mcnlz,
    &mcnlvx,
    &mcnlvy,
    &mcnlvz,
    &mcnlsx,
    &mcnlsy,
    &mcnlsz);
  /* define label inside component channel_19_filter (without coords transformations) */
  mcJumpTrace_channel_19_filter:
  SIG_MESSAGE("channel_19_filter (Trace)");
  mcDEBUG_COMP("channel_19_filter")
  mcDEBUG_STATE(
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp)
#define x mcnlx
#define y mcnly
#define z mcnlz
#define vx mcnlvx
#define vy mcnlvy
#define vz mcnlvz
#define t mcnlt
#define sx mcnlsx
#define sy mcnlsy
#define sz mcnlsz
#define p mcnlp

#define mcabsorbComp mcabsorbCompchannel_19_filter
  STORE_NEUTRON(88,
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp);
  mcScattered=0;
  mcRestore=0;
  mcNCounter[88]++;
  mcPCounter[88] += p;
  mcP2Counter[88] += p*p;
  if (!mcGroupfilter_group) { /* previous comps of GROUP have not SCATTERED yet */
#undef mcabsorb
/* if ABSORBed in GROUP/comp, will go to end of component */
RESTORE=1;
#define mcabsorb mcabsorbCompchannel_19_filter
#define mccompcurname  channel_19_filter
#define mccompcurtype  Slit_MACS
#define mccompcurindex 88
{   /* Declarations of channel_19_filter=Slit_MACS() SETTING parameters. */
MCNUM xmin = mccchannel_19_filter_xmin;
MCNUM xmax = mccchannel_19_filter_xmax;
MCNUM ymin = mccchannel_19_filter_ymin;
MCNUM ymax = mccchannel_19_filter_ymax;
MCNUM radius = mccchannel_19_filter_radius;
MCNUM xwidth = mccchannel_19_filter_xwidth;
MCNUM yheight = mccchannel_19_filter_yheight;
#line 71 "Slit_MACS.comp"
{
    PROP_Z0;
    if (!(((radius == 0) && (x<xmin || x>xmax || y<ymin || y>ymax))
    || ((radius != 0) && (x*x + y*y > radius*radius)))) {
        SCATTER;
    }
    
      //ABSORB;
    //else
        //SCATTER;
}
#line 357650 "MACS_sample_kidney_box.c"
/* 'channel_19_filter=Slit_MACS()' component instance extend code */
    SIG_MESSAGE("channel_19_filter (Trace:Extend)");
#line 264 "generated_includes/kidney_trace.c"
    if (SCATTERED) channel_selected = 19;
    //printf("channel_selected = %d\n",channel_selected);
#line 357656 "MACS_sample_kidney_box.c"
}   /* End of channel_19_filter=Slit_MACS() SETTING parameter declarations. */
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex
#undef mcabsorb
#define mcabsorb mcabsorbAll
  } /* end comp channel_19_filter in GROUP filter_group */
  if (SCATTERED) {
    mcGroupfilter_group=88;
    RESTORE=0;
  }
  /* Label for restoring  neutron */
  mcabsorbCompchannel_19_filter:
  if (RESTORE) /* restore if needed */
  { RESTORE_NEUTRON(88,
      mcnlx,
      mcnly,
      mcnlz,
      mcnlvx,
      mcnlvy,
      mcnlvz,
      mcnlt,
      mcnlsx,
      mcnlsy,
      mcnlsz,
      mcnlp); }
/* end of GROUP filter_group */
  if (!mcGroupfilter_group) ABSORB; /* absorb neutron non scattered in GROUP */
  mcGroupfilter_group=0; /* reset group scattered flag */
#undef mcabsorbComp
#undef p
#undef sz
#undef sy
#undef sx
#undef t
#undef vz
#undef vy
#undef vx
#undef z
#undef y
#undef x
  mcDEBUG_STATE(
mcnlx,
mcnly,
mcnlz,
mcnlvx,
mcnlvy,
mcnlvz,
mcnlt,
mcnlsx,
mcnlsy,
mcnlsz,
mcnlp)

  /* TRACE Component channel_selector [89] */
  mccoordschange(mcposrchannel_selector, mcrotrchannel_selector,
    &mcnlx,
    &mcnly,
    &mcnlz,
    &mcnlvx,
    &mcnlvy,
    &mcnlvz,
    &mcnlsx,
    &mcnlsy,
    &mcnlsz);
  /* define label inside component channel_selector (without coords transformations) */
  mcJumpTrace_channel_selector:
  SIG_MESSAGE("channel_selector (Trace)");
  mcDEBUG_COMP("channel_selector")
  mcDEBUG_STATE(
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp)
#define x mcnlx
#define y mcnly
#define z mcnlz
#define vx mcnlvx
#define vy mcnlvy
#define vz mcnlvz
#define t mcnlt
#define sx mcnlsx
#define sy mcnlsy
#define sz mcnlsz
#define p mcnlp

#define mcabsorbComp mcabsorbCompchannel_selector
  STORE_NEUTRON(89,
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp);
  mcScattered=0;
  mcRestore=0;
  mcNCounter[89]++;
  mcPCounter[89] += p;
  mcP2Counter[89] += p*p;
#define mccompcurname  channel_selector
#define mccompcurtype  Arm
#define mccompcurindex 89
/* 'channel_selector=Arm()' component instance extend code */
    SIG_MESSAGE("channel_selector (Trace:Extend)");
#line 273 "generated_includes/kidney_trace.c"
    //printf("channel_selected after slits: %d\n", channel_selected);
    if (channel_selected == -1) ABSORB;
    detector_found = 0;
#line 357774 "MACS_sample_kidney_box.c"
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex
  /* Label for restoring  neutron */
  mcabsorbCompchannel_selector:
  if (RESTORE) /* restore if needed */
  { RESTORE_NEUTRON(89,
      mcnlx,
      mcnly,
      mcnlz,
      mcnlvx,
      mcnlvy,
      mcnlvz,
      mcnlt,
      mcnlsx,
      mcnlsy,
      mcnlsz,
      mcnlp); }
#undef mcabsorbComp
#undef p
#undef sz
#undef sy
#undef sx
#undef t
#undef vz
#undef vy
#undef vx
#undef z
#undef y
#undef x
  mcDEBUG_STATE(
mcnlx,
mcnly,
mcnlz,
mcnlvx,
mcnlvy,
mcnlvz,
mcnlt,
mcnlsx,
mcnlsy,
mcnlsz,
mcnlp)

  /* TRACE Component channel_0_colimator [90] */
  mccoordschange(mcposrchannel_0_colimator, mcrotrchannel_0_colimator,
    &mcnlx,
    &mcnly,
    &mcnlz,
    &mcnlvx,
    &mcnlvy,
    &mcnlvz,
    &mcnlsx,
    &mcnlsy,
    &mcnlsz);
  /* define label inside component channel_0_colimator (without coords transformations) */
  mcJumpTrace_channel_0_colimator:
  SIG_MESSAGE("channel_0_colimator (Trace)");
  mcDEBUG_COMP("channel_0_colimator")
  mcDEBUG_STATE(
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp)
#define x mcnlx
#define y mcnly
#define z mcnlz
#define vx mcnlvx
#define vy mcnlvy
#define vz mcnlvz
#define t mcnlt
#define sx mcnlsx
#define sy mcnlsy
#define sz mcnlsz
#define p mcnlp

#define mcabsorbComp mcabsorbCompchannel_0_colimator
  STORE_NEUTRON(90,
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp);
  mcScattered=0;
  mcRestore=0;
  mcNCounter[90]++;
  mcPCounter[90] += p;
  mcP2Counter[90] += p*p;
#define mccompcurname  channel_0_colimator
#define mccompcurtype  Collimator_linear
#define mccompcurindex 90
#define slope mccchannel_0_colimator_slope
#define slopeV mccchannel_0_colimator_slopeV
{   /* Declarations of channel_0_colimator=Collimator_linear() SETTING parameters. */
MCNUM xmin = mccchannel_0_colimator_xmin;
MCNUM xmax = mccchannel_0_colimator_xmax;
MCNUM ymin = mccchannel_0_colimator_ymin;
MCNUM ymax = mccchannel_0_colimator_ymax;
MCNUM xwidth = mccchannel_0_colimator_xwidth;
MCNUM yheight = mccchannel_0_colimator_yheight;
MCNUM length = mccchannel_0_colimator_length;
MCNUM divergence = mccchannel_0_colimator_divergence;
MCNUM transmission = mccchannel_0_colimator_transmission;
MCNUM divergenceV = mccchannel_0_colimator_divergenceV;
/* 'channel_0_colimator=Collimator_linear()' component instance has conditional execution */
if (( channel_selected == 0 ))

#line 69 "/usr/share/mcstas/2.7/optics/Collimator_linear.comp"
{
    double phi, dt;

    PROP_Z0;
    if (x<xmin || x>xmax || y<ymin || y>ymax)
      ABSORB;
    dt = length/vz;
    PROP_DT(dt);
    if (x<xmin || x>xmax || y<ymin || y>ymax)
      ABSORB;

    if(slope > 0.0)
    {
      phi = fabs(vx/vz);
      if (phi > slope)
        ABSORB;
      else
        p *= transmission*(1.0 - phi/slope);
      SCATTER;
    }
    if (slopeV > 0) {
      phi = fabs(vy/vz);
      if (phi > slopeV)
        ABSORB;
      else
        p *= transmission*(1.0 - phi/slopeV);
      SCATTER;
    }
}
#line 357923 "MACS_sample_kidney_box.c"
}   /* End of channel_0_colimator=Collimator_linear() SETTING parameter declarations. */
#undef slopeV
#undef slope
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex
  /* Label for restoring  neutron */
  mcabsorbCompchannel_0_colimator:
  if (RESTORE) /* restore if needed */
  { RESTORE_NEUTRON(90,
      mcnlx,
      mcnly,
      mcnlz,
      mcnlvx,
      mcnlvy,
      mcnlvz,
      mcnlt,
      mcnlsx,
      mcnlsy,
      mcnlsz,
      mcnlp); }
#undef mcabsorbComp
#undef p
#undef sz
#undef sy
#undef sx
#undef t
#undef vz
#undef vy
#undef vx
#undef z
#undef y
#undef x
  mcDEBUG_STATE(
mcnlx,
mcnly,
mcnlz,
mcnlvx,
mcnlvy,
mcnlvz,
mcnlt,
mcnlsx,
mcnlsy,
mcnlsz,
mcnlp)

  /* TRACE Component channel_1_colimator [91] */
  mccoordschange(mcposrchannel_1_colimator, mcrotrchannel_1_colimator,
    &mcnlx,
    &mcnly,
    &mcnlz,
    &mcnlvx,
    &mcnlvy,
    &mcnlvz,
    &mcnlsx,
    &mcnlsy,
    &mcnlsz);
  /* define label inside component channel_1_colimator (without coords transformations) */
  mcJumpTrace_channel_1_colimator:
  SIG_MESSAGE("channel_1_colimator (Trace)");
  mcDEBUG_COMP("channel_1_colimator")
  mcDEBUG_STATE(
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp)
#define x mcnlx
#define y mcnly
#define z mcnlz
#define vx mcnlvx
#define vy mcnlvy
#define vz mcnlvz
#define t mcnlt
#define sx mcnlsx
#define sy mcnlsy
#define sz mcnlsz
#define p mcnlp

#define mcabsorbComp mcabsorbCompchannel_1_colimator
  STORE_NEUTRON(91,
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp);
  mcScattered=0;
  mcRestore=0;
  mcNCounter[91]++;
  mcPCounter[91] += p;
  mcP2Counter[91] += p*p;
#define mccompcurname  channel_1_colimator
#define mccompcurtype  Collimator_linear
#define mccompcurindex 91
#define slope mccchannel_1_colimator_slope
#define slopeV mccchannel_1_colimator_slopeV
{   /* Declarations of channel_1_colimator=Collimator_linear() SETTING parameters. */
MCNUM xmin = mccchannel_1_colimator_xmin;
MCNUM xmax = mccchannel_1_colimator_xmax;
MCNUM ymin = mccchannel_1_colimator_ymin;
MCNUM ymax = mccchannel_1_colimator_ymax;
MCNUM xwidth = mccchannel_1_colimator_xwidth;
MCNUM yheight = mccchannel_1_colimator_yheight;
MCNUM length = mccchannel_1_colimator_length;
MCNUM divergence = mccchannel_1_colimator_divergence;
MCNUM transmission = mccchannel_1_colimator_transmission;
MCNUM divergenceV = mccchannel_1_colimator_divergenceV;
/* 'channel_1_colimator=Collimator_linear()' component instance has conditional execution */
if (( channel_selected == 1 ))

#line 69 "/usr/share/mcstas/2.7/optics/Collimator_linear.comp"
{
    double phi, dt;

    PROP_Z0;
    if (x<xmin || x>xmax || y<ymin || y>ymax)
      ABSORB;
    dt = length/vz;
    PROP_DT(dt);
    if (x<xmin || x>xmax || y<ymin || y>ymax)
      ABSORB;

    if(slope > 0.0)
    {
      phi = fabs(vx/vz);
      if (phi > slope)
        ABSORB;
      else
        p *= transmission*(1.0 - phi/slope);
      SCATTER;
    }
    if (slopeV > 0) {
      phi = fabs(vy/vz);
      if (phi > slopeV)
        ABSORB;
      else
        p *= transmission*(1.0 - phi/slopeV);
      SCATTER;
    }
}
#line 358075 "MACS_sample_kidney_box.c"
}   /* End of channel_1_colimator=Collimator_linear() SETTING parameter declarations. */
#undef slopeV
#undef slope
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex
  /* Label for restoring  neutron */
  mcabsorbCompchannel_1_colimator:
  if (RESTORE) /* restore if needed */
  { RESTORE_NEUTRON(91,
      mcnlx,
      mcnly,
      mcnlz,
      mcnlvx,
      mcnlvy,
      mcnlvz,
      mcnlt,
      mcnlsx,
      mcnlsy,
      mcnlsz,
      mcnlp); }
#undef mcabsorbComp
#undef p
#undef sz
#undef sy
#undef sx
#undef t
#undef vz
#undef vy
#undef vx
#undef z
#undef y
#undef x
  mcDEBUG_STATE(
mcnlx,
mcnly,
mcnlz,
mcnlvx,
mcnlvy,
mcnlvz,
mcnlt,
mcnlsx,
mcnlsy,
mcnlsz,
mcnlp)

  /* TRACE Component channel_2_colimator [92] */
  mccoordschange(mcposrchannel_2_colimator, mcrotrchannel_2_colimator,
    &mcnlx,
    &mcnly,
    &mcnlz,
    &mcnlvx,
    &mcnlvy,
    &mcnlvz,
    &mcnlsx,
    &mcnlsy,
    &mcnlsz);
  /* define label inside component channel_2_colimator (without coords transformations) */
  mcJumpTrace_channel_2_colimator:
  SIG_MESSAGE("channel_2_colimator (Trace)");
  mcDEBUG_COMP("channel_2_colimator")
  mcDEBUG_STATE(
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp)
#define x mcnlx
#define y mcnly
#define z mcnlz
#define vx mcnlvx
#define vy mcnlvy
#define vz mcnlvz
#define t mcnlt
#define sx mcnlsx
#define sy mcnlsy
#define sz mcnlsz
#define p mcnlp

#define mcabsorbComp mcabsorbCompchannel_2_colimator
  STORE_NEUTRON(92,
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp);
  mcScattered=0;
  mcRestore=0;
  mcNCounter[92]++;
  mcPCounter[92] += p;
  mcP2Counter[92] += p*p;
#define mccompcurname  channel_2_colimator
#define mccompcurtype  Collimator_linear
#define mccompcurindex 92
#define slope mccchannel_2_colimator_slope
#define slopeV mccchannel_2_colimator_slopeV
{   /* Declarations of channel_2_colimator=Collimator_linear() SETTING parameters. */
MCNUM xmin = mccchannel_2_colimator_xmin;
MCNUM xmax = mccchannel_2_colimator_xmax;
MCNUM ymin = mccchannel_2_colimator_ymin;
MCNUM ymax = mccchannel_2_colimator_ymax;
MCNUM xwidth = mccchannel_2_colimator_xwidth;
MCNUM yheight = mccchannel_2_colimator_yheight;
MCNUM length = mccchannel_2_colimator_length;
MCNUM divergence = mccchannel_2_colimator_divergence;
MCNUM transmission = mccchannel_2_colimator_transmission;
MCNUM divergenceV = mccchannel_2_colimator_divergenceV;
/* 'channel_2_colimator=Collimator_linear()' component instance has conditional execution */
if (( channel_selected == 2 ))

#line 69 "/usr/share/mcstas/2.7/optics/Collimator_linear.comp"
{
    double phi, dt;

    PROP_Z0;
    if (x<xmin || x>xmax || y<ymin || y>ymax)
      ABSORB;
    dt = length/vz;
    PROP_DT(dt);
    if (x<xmin || x>xmax || y<ymin || y>ymax)
      ABSORB;

    if(slope > 0.0)
    {
      phi = fabs(vx/vz);
      if (phi > slope)
        ABSORB;
      else
        p *= transmission*(1.0 - phi/slope);
      SCATTER;
    }
    if (slopeV > 0) {
      phi = fabs(vy/vz);
      if (phi > slopeV)
        ABSORB;
      else
        p *= transmission*(1.0 - phi/slopeV);
      SCATTER;
    }
}
#line 358227 "MACS_sample_kidney_box.c"
}   /* End of channel_2_colimator=Collimator_linear() SETTING parameter declarations. */
#undef slopeV
#undef slope
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex
  /* Label for restoring  neutron */
  mcabsorbCompchannel_2_colimator:
  if (RESTORE) /* restore if needed */
  { RESTORE_NEUTRON(92,
      mcnlx,
      mcnly,
      mcnlz,
      mcnlvx,
      mcnlvy,
      mcnlvz,
      mcnlt,
      mcnlsx,
      mcnlsy,
      mcnlsz,
      mcnlp); }
#undef mcabsorbComp
#undef p
#undef sz
#undef sy
#undef sx
#undef t
#undef vz
#undef vy
#undef vx
#undef z
#undef y
#undef x
  mcDEBUG_STATE(
mcnlx,
mcnly,
mcnlz,
mcnlvx,
mcnlvy,
mcnlvz,
mcnlt,
mcnlsx,
mcnlsy,
mcnlsz,
mcnlp)

  /* TRACE Component channel_3_colimator [93] */
  mccoordschange(mcposrchannel_3_colimator, mcrotrchannel_3_colimator,
    &mcnlx,
    &mcnly,
    &mcnlz,
    &mcnlvx,
    &mcnlvy,
    &mcnlvz,
    &mcnlsx,
    &mcnlsy,
    &mcnlsz);
  /* define label inside component channel_3_colimator (without coords transformations) */
  mcJumpTrace_channel_3_colimator:
  SIG_MESSAGE("channel_3_colimator (Trace)");
  mcDEBUG_COMP("channel_3_colimator")
  mcDEBUG_STATE(
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp)
#define x mcnlx
#define y mcnly
#define z mcnlz
#define vx mcnlvx
#define vy mcnlvy
#define vz mcnlvz
#define t mcnlt
#define sx mcnlsx
#define sy mcnlsy
#define sz mcnlsz
#define p mcnlp

#define mcabsorbComp mcabsorbCompchannel_3_colimator
  STORE_NEUTRON(93,
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp);
  mcScattered=0;
  mcRestore=0;
  mcNCounter[93]++;
  mcPCounter[93] += p;
  mcP2Counter[93] += p*p;
#define mccompcurname  channel_3_colimator
#define mccompcurtype  Collimator_linear
#define mccompcurindex 93
#define slope mccchannel_3_colimator_slope
#define slopeV mccchannel_3_colimator_slopeV
{   /* Declarations of channel_3_colimator=Collimator_linear() SETTING parameters. */
MCNUM xmin = mccchannel_3_colimator_xmin;
MCNUM xmax = mccchannel_3_colimator_xmax;
MCNUM ymin = mccchannel_3_colimator_ymin;
MCNUM ymax = mccchannel_3_colimator_ymax;
MCNUM xwidth = mccchannel_3_colimator_xwidth;
MCNUM yheight = mccchannel_3_colimator_yheight;
MCNUM length = mccchannel_3_colimator_length;
MCNUM divergence = mccchannel_3_colimator_divergence;
MCNUM transmission = mccchannel_3_colimator_transmission;
MCNUM divergenceV = mccchannel_3_colimator_divergenceV;
/* 'channel_3_colimator=Collimator_linear()' component instance has conditional execution */
if (( channel_selected == 3 ))

#line 69 "/usr/share/mcstas/2.7/optics/Collimator_linear.comp"
{
    double phi, dt;

    PROP_Z0;
    if (x<xmin || x>xmax || y<ymin || y>ymax)
      ABSORB;
    dt = length/vz;
    PROP_DT(dt);
    if (x<xmin || x>xmax || y<ymin || y>ymax)
      ABSORB;

    if(slope > 0.0)
    {
      phi = fabs(vx/vz);
      if (phi > slope)
        ABSORB;
      else
        p *= transmission*(1.0 - phi/slope);
      SCATTER;
    }
    if (slopeV > 0) {
      phi = fabs(vy/vz);
      if (phi > slopeV)
        ABSORB;
      else
        p *= transmission*(1.0 - phi/slopeV);
      SCATTER;
    }
}
#line 358379 "MACS_sample_kidney_box.c"
}   /* End of channel_3_colimator=Collimator_linear() SETTING parameter declarations. */
#undef slopeV
#undef slope
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex
  /* Label for restoring  neutron */
  mcabsorbCompchannel_3_colimator:
  if (RESTORE) /* restore if needed */
  { RESTORE_NEUTRON(93,
      mcnlx,
      mcnly,
      mcnlz,
      mcnlvx,
      mcnlvy,
      mcnlvz,
      mcnlt,
      mcnlsx,
      mcnlsy,
      mcnlsz,
      mcnlp); }
#undef mcabsorbComp
#undef p
#undef sz
#undef sy
#undef sx
#undef t
#undef vz
#undef vy
#undef vx
#undef z
#undef y
#undef x
  mcDEBUG_STATE(
mcnlx,
mcnly,
mcnlz,
mcnlvx,
mcnlvy,
mcnlvz,
mcnlt,
mcnlsx,
mcnlsy,
mcnlsz,
mcnlp)

  /* TRACE Component channel_4_colimator [94] */
  mccoordschange(mcposrchannel_4_colimator, mcrotrchannel_4_colimator,
    &mcnlx,
    &mcnly,
    &mcnlz,
    &mcnlvx,
    &mcnlvy,
    &mcnlvz,
    &mcnlsx,
    &mcnlsy,
    &mcnlsz);
  /* define label inside component channel_4_colimator (without coords transformations) */
  mcJumpTrace_channel_4_colimator:
  SIG_MESSAGE("channel_4_colimator (Trace)");
  mcDEBUG_COMP("channel_4_colimator")
  mcDEBUG_STATE(
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp)
#define x mcnlx
#define y mcnly
#define z mcnlz
#define vx mcnlvx
#define vy mcnlvy
#define vz mcnlvz
#define t mcnlt
#define sx mcnlsx
#define sy mcnlsy
#define sz mcnlsz
#define p mcnlp

#define mcabsorbComp mcabsorbCompchannel_4_colimator
  STORE_NEUTRON(94,
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp);
  mcScattered=0;
  mcRestore=0;
  mcNCounter[94]++;
  mcPCounter[94] += p;
  mcP2Counter[94] += p*p;
#define mccompcurname  channel_4_colimator
#define mccompcurtype  Collimator_linear
#define mccompcurindex 94
#define slope mccchannel_4_colimator_slope
#define slopeV mccchannel_4_colimator_slopeV
{   /* Declarations of channel_4_colimator=Collimator_linear() SETTING parameters. */
MCNUM xmin = mccchannel_4_colimator_xmin;
MCNUM xmax = mccchannel_4_colimator_xmax;
MCNUM ymin = mccchannel_4_colimator_ymin;
MCNUM ymax = mccchannel_4_colimator_ymax;
MCNUM xwidth = mccchannel_4_colimator_xwidth;
MCNUM yheight = mccchannel_4_colimator_yheight;
MCNUM length = mccchannel_4_colimator_length;
MCNUM divergence = mccchannel_4_colimator_divergence;
MCNUM transmission = mccchannel_4_colimator_transmission;
MCNUM divergenceV = mccchannel_4_colimator_divergenceV;
/* 'channel_4_colimator=Collimator_linear()' component instance has conditional execution */
if (( channel_selected == 4 ))

#line 69 "/usr/share/mcstas/2.7/optics/Collimator_linear.comp"
{
    double phi, dt;

    PROP_Z0;
    if (x<xmin || x>xmax || y<ymin || y>ymax)
      ABSORB;
    dt = length/vz;
    PROP_DT(dt);
    if (x<xmin || x>xmax || y<ymin || y>ymax)
      ABSORB;

    if(slope > 0.0)
    {
      phi = fabs(vx/vz);
      if (phi > slope)
        ABSORB;
      else
        p *= transmission*(1.0 - phi/slope);
      SCATTER;
    }
    if (slopeV > 0) {
      phi = fabs(vy/vz);
      if (phi > slopeV)
        ABSORB;
      else
        p *= transmission*(1.0 - phi/slopeV);
      SCATTER;
    }
}
#line 358531 "MACS_sample_kidney_box.c"
}   /* End of channel_4_colimator=Collimator_linear() SETTING parameter declarations. */
#undef slopeV
#undef slope
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex
  /* Label for restoring  neutron */
  mcabsorbCompchannel_4_colimator:
  if (RESTORE) /* restore if needed */
  { RESTORE_NEUTRON(94,
      mcnlx,
      mcnly,
      mcnlz,
      mcnlvx,
      mcnlvy,
      mcnlvz,
      mcnlt,
      mcnlsx,
      mcnlsy,
      mcnlsz,
      mcnlp); }
#undef mcabsorbComp
#undef p
#undef sz
#undef sy
#undef sx
#undef t
#undef vz
#undef vy
#undef vx
#undef z
#undef y
#undef x
  mcDEBUG_STATE(
mcnlx,
mcnly,
mcnlz,
mcnlvx,
mcnlvy,
mcnlvz,
mcnlt,
mcnlsx,
mcnlsy,
mcnlsz,
mcnlp)

  /* TRACE Component channel_5_colimator [95] */
  mccoordschange(mcposrchannel_5_colimator, mcrotrchannel_5_colimator,
    &mcnlx,
    &mcnly,
    &mcnlz,
    &mcnlvx,
    &mcnlvy,
    &mcnlvz,
    &mcnlsx,
    &mcnlsy,
    &mcnlsz);
  /* define label inside component channel_5_colimator (without coords transformations) */
  mcJumpTrace_channel_5_colimator:
  SIG_MESSAGE("channel_5_colimator (Trace)");
  mcDEBUG_COMP("channel_5_colimator")
  mcDEBUG_STATE(
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp)
#define x mcnlx
#define y mcnly
#define z mcnlz
#define vx mcnlvx
#define vy mcnlvy
#define vz mcnlvz
#define t mcnlt
#define sx mcnlsx
#define sy mcnlsy
#define sz mcnlsz
#define p mcnlp

#define mcabsorbComp mcabsorbCompchannel_5_colimator
  STORE_NEUTRON(95,
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp);
  mcScattered=0;
  mcRestore=0;
  mcNCounter[95]++;
  mcPCounter[95] += p;
  mcP2Counter[95] += p*p;
#define mccompcurname  channel_5_colimator
#define mccompcurtype  Collimator_linear
#define mccompcurindex 95
#define slope mccchannel_5_colimator_slope
#define slopeV mccchannel_5_colimator_slopeV
{   /* Declarations of channel_5_colimator=Collimator_linear() SETTING parameters. */
MCNUM xmin = mccchannel_5_colimator_xmin;
MCNUM xmax = mccchannel_5_colimator_xmax;
MCNUM ymin = mccchannel_5_colimator_ymin;
MCNUM ymax = mccchannel_5_colimator_ymax;
MCNUM xwidth = mccchannel_5_colimator_xwidth;
MCNUM yheight = mccchannel_5_colimator_yheight;
MCNUM length = mccchannel_5_colimator_length;
MCNUM divergence = mccchannel_5_colimator_divergence;
MCNUM transmission = mccchannel_5_colimator_transmission;
MCNUM divergenceV = mccchannel_5_colimator_divergenceV;
/* 'channel_5_colimator=Collimator_linear()' component instance has conditional execution */
if (( channel_selected == 5 ))

#line 69 "/usr/share/mcstas/2.7/optics/Collimator_linear.comp"
{
    double phi, dt;

    PROP_Z0;
    if (x<xmin || x>xmax || y<ymin || y>ymax)
      ABSORB;
    dt = length/vz;
    PROP_DT(dt);
    if (x<xmin || x>xmax || y<ymin || y>ymax)
      ABSORB;

    if(slope > 0.0)
    {
      phi = fabs(vx/vz);
      if (phi > slope)
        ABSORB;
      else
        p *= transmission*(1.0 - phi/slope);
      SCATTER;
    }
    if (slopeV > 0) {
      phi = fabs(vy/vz);
      if (phi > slopeV)
        ABSORB;
      else
        p *= transmission*(1.0 - phi/slopeV);
      SCATTER;
    }
}
#line 358683 "MACS_sample_kidney_box.c"
}   /* End of channel_5_colimator=Collimator_linear() SETTING parameter declarations. */
#undef slopeV
#undef slope
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex
  /* Label for restoring  neutron */
  mcabsorbCompchannel_5_colimator:
  if (RESTORE) /* restore if needed */
  { RESTORE_NEUTRON(95,
      mcnlx,
      mcnly,
      mcnlz,
      mcnlvx,
      mcnlvy,
      mcnlvz,
      mcnlt,
      mcnlsx,
      mcnlsy,
      mcnlsz,
      mcnlp); }
#undef mcabsorbComp
#undef p
#undef sz
#undef sy
#undef sx
#undef t
#undef vz
#undef vy
#undef vx
#undef z
#undef y
#undef x
  mcDEBUG_STATE(
mcnlx,
mcnly,
mcnlz,
mcnlvx,
mcnlvy,
mcnlvz,
mcnlt,
mcnlsx,
mcnlsy,
mcnlsz,
mcnlp)

  /* TRACE Component channel_6_colimator [96] */
  mccoordschange(mcposrchannel_6_colimator, mcrotrchannel_6_colimator,
    &mcnlx,
    &mcnly,
    &mcnlz,
    &mcnlvx,
    &mcnlvy,
    &mcnlvz,
    &mcnlsx,
    &mcnlsy,
    &mcnlsz);
  /* define label inside component channel_6_colimator (without coords transformations) */
  mcJumpTrace_channel_6_colimator:
  SIG_MESSAGE("channel_6_colimator (Trace)");
  mcDEBUG_COMP("channel_6_colimator")
  mcDEBUG_STATE(
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp)
#define x mcnlx
#define y mcnly
#define z mcnlz
#define vx mcnlvx
#define vy mcnlvy
#define vz mcnlvz
#define t mcnlt
#define sx mcnlsx
#define sy mcnlsy
#define sz mcnlsz
#define p mcnlp

#define mcabsorbComp mcabsorbCompchannel_6_colimator
  STORE_NEUTRON(96,
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp);
  mcScattered=0;
  mcRestore=0;
  mcNCounter[96]++;
  mcPCounter[96] += p;
  mcP2Counter[96] += p*p;
#define mccompcurname  channel_6_colimator
#define mccompcurtype  Collimator_linear
#define mccompcurindex 96
#define slope mccchannel_6_colimator_slope
#define slopeV mccchannel_6_colimator_slopeV
{   /* Declarations of channel_6_colimator=Collimator_linear() SETTING parameters. */
MCNUM xmin = mccchannel_6_colimator_xmin;
MCNUM xmax = mccchannel_6_colimator_xmax;
MCNUM ymin = mccchannel_6_colimator_ymin;
MCNUM ymax = mccchannel_6_colimator_ymax;
MCNUM xwidth = mccchannel_6_colimator_xwidth;
MCNUM yheight = mccchannel_6_colimator_yheight;
MCNUM length = mccchannel_6_colimator_length;
MCNUM divergence = mccchannel_6_colimator_divergence;
MCNUM transmission = mccchannel_6_colimator_transmission;
MCNUM divergenceV = mccchannel_6_colimator_divergenceV;
/* 'channel_6_colimator=Collimator_linear()' component instance has conditional execution */
if (( channel_selected == 6 ))

#line 69 "/usr/share/mcstas/2.7/optics/Collimator_linear.comp"
{
    double phi, dt;

    PROP_Z0;
    if (x<xmin || x>xmax || y<ymin || y>ymax)
      ABSORB;
    dt = length/vz;
    PROP_DT(dt);
    if (x<xmin || x>xmax || y<ymin || y>ymax)
      ABSORB;

    if(slope > 0.0)
    {
      phi = fabs(vx/vz);
      if (phi > slope)
        ABSORB;
      else
        p *= transmission*(1.0 - phi/slope);
      SCATTER;
    }
    if (slopeV > 0) {
      phi = fabs(vy/vz);
      if (phi > slopeV)
        ABSORB;
      else
        p *= transmission*(1.0 - phi/slopeV);
      SCATTER;
    }
}
#line 358835 "MACS_sample_kidney_box.c"
}   /* End of channel_6_colimator=Collimator_linear() SETTING parameter declarations. */
#undef slopeV
#undef slope
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex
  /* Label for restoring  neutron */
  mcabsorbCompchannel_6_colimator:
  if (RESTORE) /* restore if needed */
  { RESTORE_NEUTRON(96,
      mcnlx,
      mcnly,
      mcnlz,
      mcnlvx,
      mcnlvy,
      mcnlvz,
      mcnlt,
      mcnlsx,
      mcnlsy,
      mcnlsz,
      mcnlp); }
#undef mcabsorbComp
#undef p
#undef sz
#undef sy
#undef sx
#undef t
#undef vz
#undef vy
#undef vx
#undef z
#undef y
#undef x
  mcDEBUG_STATE(
mcnlx,
mcnly,
mcnlz,
mcnlvx,
mcnlvy,
mcnlvz,
mcnlt,
mcnlsx,
mcnlsy,
mcnlsz,
mcnlp)

  /* TRACE Component channel_7_colimator [97] */
  mccoordschange(mcposrchannel_7_colimator, mcrotrchannel_7_colimator,
    &mcnlx,
    &mcnly,
    &mcnlz,
    &mcnlvx,
    &mcnlvy,
    &mcnlvz,
    &mcnlsx,
    &mcnlsy,
    &mcnlsz);
  /* define label inside component channel_7_colimator (without coords transformations) */
  mcJumpTrace_channel_7_colimator:
  SIG_MESSAGE("channel_7_colimator (Trace)");
  mcDEBUG_COMP("channel_7_colimator")
  mcDEBUG_STATE(
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp)
#define x mcnlx
#define y mcnly
#define z mcnlz
#define vx mcnlvx
#define vy mcnlvy
#define vz mcnlvz
#define t mcnlt
#define sx mcnlsx
#define sy mcnlsy
#define sz mcnlsz
#define p mcnlp

#define mcabsorbComp mcabsorbCompchannel_7_colimator
  STORE_NEUTRON(97,
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp);
  mcScattered=0;
  mcRestore=0;
  mcNCounter[97]++;
  mcPCounter[97] += p;
  mcP2Counter[97] += p*p;
#define mccompcurname  channel_7_colimator
#define mccompcurtype  Collimator_linear
#define mccompcurindex 97
#define slope mccchannel_7_colimator_slope
#define slopeV mccchannel_7_colimator_slopeV
{   /* Declarations of channel_7_colimator=Collimator_linear() SETTING parameters. */
MCNUM xmin = mccchannel_7_colimator_xmin;
MCNUM xmax = mccchannel_7_colimator_xmax;
MCNUM ymin = mccchannel_7_colimator_ymin;
MCNUM ymax = mccchannel_7_colimator_ymax;
MCNUM xwidth = mccchannel_7_colimator_xwidth;
MCNUM yheight = mccchannel_7_colimator_yheight;
MCNUM length = mccchannel_7_colimator_length;
MCNUM divergence = mccchannel_7_colimator_divergence;
MCNUM transmission = mccchannel_7_colimator_transmission;
MCNUM divergenceV = mccchannel_7_colimator_divergenceV;
/* 'channel_7_colimator=Collimator_linear()' component instance has conditional execution */
if (( channel_selected == 7 ))

#line 69 "/usr/share/mcstas/2.7/optics/Collimator_linear.comp"
{
    double phi, dt;

    PROP_Z0;
    if (x<xmin || x>xmax || y<ymin || y>ymax)
      ABSORB;
    dt = length/vz;
    PROP_DT(dt);
    if (x<xmin || x>xmax || y<ymin || y>ymax)
      ABSORB;

    if(slope > 0.0)
    {
      phi = fabs(vx/vz);
      if (phi > slope)
        ABSORB;
      else
        p *= transmission*(1.0 - phi/slope);
      SCATTER;
    }
    if (slopeV > 0) {
      phi = fabs(vy/vz);
      if (phi > slopeV)
        ABSORB;
      else
        p *= transmission*(1.0 - phi/slopeV);
      SCATTER;
    }
}
#line 358987 "MACS_sample_kidney_box.c"
}   /* End of channel_7_colimator=Collimator_linear() SETTING parameter declarations. */
#undef slopeV
#undef slope
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex
  /* Label for restoring  neutron */
  mcabsorbCompchannel_7_colimator:
  if (RESTORE) /* restore if needed */
  { RESTORE_NEUTRON(97,
      mcnlx,
      mcnly,
      mcnlz,
      mcnlvx,
      mcnlvy,
      mcnlvz,
      mcnlt,
      mcnlsx,
      mcnlsy,
      mcnlsz,
      mcnlp); }
#undef mcabsorbComp
#undef p
#undef sz
#undef sy
#undef sx
#undef t
#undef vz
#undef vy
#undef vx
#undef z
#undef y
#undef x
  mcDEBUG_STATE(
mcnlx,
mcnly,
mcnlz,
mcnlvx,
mcnlvy,
mcnlvz,
mcnlt,
mcnlsx,
mcnlsy,
mcnlsz,
mcnlp)

  /* TRACE Component channel_8_colimator [98] */
  mccoordschange(mcposrchannel_8_colimator, mcrotrchannel_8_colimator,
    &mcnlx,
    &mcnly,
    &mcnlz,
    &mcnlvx,
    &mcnlvy,
    &mcnlvz,
    &mcnlsx,
    &mcnlsy,
    &mcnlsz);
  /* define label inside component channel_8_colimator (without coords transformations) */
  mcJumpTrace_channel_8_colimator:
  SIG_MESSAGE("channel_8_colimator (Trace)");
  mcDEBUG_COMP("channel_8_colimator")
  mcDEBUG_STATE(
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp)
#define x mcnlx
#define y mcnly
#define z mcnlz
#define vx mcnlvx
#define vy mcnlvy
#define vz mcnlvz
#define t mcnlt
#define sx mcnlsx
#define sy mcnlsy
#define sz mcnlsz
#define p mcnlp

#define mcabsorbComp mcabsorbCompchannel_8_colimator
  STORE_NEUTRON(98,
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp);
  mcScattered=0;
  mcRestore=0;
  mcNCounter[98]++;
  mcPCounter[98] += p;
  mcP2Counter[98] += p*p;
#define mccompcurname  channel_8_colimator
#define mccompcurtype  Collimator_linear
#define mccompcurindex 98
#define slope mccchannel_8_colimator_slope
#define slopeV mccchannel_8_colimator_slopeV
{   /* Declarations of channel_8_colimator=Collimator_linear() SETTING parameters. */
MCNUM xmin = mccchannel_8_colimator_xmin;
MCNUM xmax = mccchannel_8_colimator_xmax;
MCNUM ymin = mccchannel_8_colimator_ymin;
MCNUM ymax = mccchannel_8_colimator_ymax;
MCNUM xwidth = mccchannel_8_colimator_xwidth;
MCNUM yheight = mccchannel_8_colimator_yheight;
MCNUM length = mccchannel_8_colimator_length;
MCNUM divergence = mccchannel_8_colimator_divergence;
MCNUM transmission = mccchannel_8_colimator_transmission;
MCNUM divergenceV = mccchannel_8_colimator_divergenceV;
/* 'channel_8_colimator=Collimator_linear()' component instance has conditional execution */
if (( channel_selected == 8 ))

#line 69 "/usr/share/mcstas/2.7/optics/Collimator_linear.comp"
{
    double phi, dt;

    PROP_Z0;
    if (x<xmin || x>xmax || y<ymin || y>ymax)
      ABSORB;
    dt = length/vz;
    PROP_DT(dt);
    if (x<xmin || x>xmax || y<ymin || y>ymax)
      ABSORB;

    if(slope > 0.0)
    {
      phi = fabs(vx/vz);
      if (phi > slope)
        ABSORB;
      else
        p *= transmission*(1.0 - phi/slope);
      SCATTER;
    }
    if (slopeV > 0) {
      phi = fabs(vy/vz);
      if (phi > slopeV)
        ABSORB;
      else
        p *= transmission*(1.0 - phi/slopeV);
      SCATTER;
    }
}
#line 359139 "MACS_sample_kidney_box.c"
}   /* End of channel_8_colimator=Collimator_linear() SETTING parameter declarations. */
#undef slopeV
#undef slope
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex
  /* Label for restoring  neutron */
  mcabsorbCompchannel_8_colimator:
  if (RESTORE) /* restore if needed */
  { RESTORE_NEUTRON(98,
      mcnlx,
      mcnly,
      mcnlz,
      mcnlvx,
      mcnlvy,
      mcnlvz,
      mcnlt,
      mcnlsx,
      mcnlsy,
      mcnlsz,
      mcnlp); }
#undef mcabsorbComp
#undef p
#undef sz
#undef sy
#undef sx
#undef t
#undef vz
#undef vy
#undef vx
#undef z
#undef y
#undef x
  mcDEBUG_STATE(
mcnlx,
mcnly,
mcnlz,
mcnlvx,
mcnlvy,
mcnlvz,
mcnlt,
mcnlsx,
mcnlsy,
mcnlsz,
mcnlp)

  /* TRACE Component channel_9_colimator [99] */
  mccoordschange(mcposrchannel_9_colimator, mcrotrchannel_9_colimator,
    &mcnlx,
    &mcnly,
    &mcnlz,
    &mcnlvx,
    &mcnlvy,
    &mcnlvz,
    &mcnlsx,
    &mcnlsy,
    &mcnlsz);
  /* define label inside component channel_9_colimator (without coords transformations) */
  mcJumpTrace_channel_9_colimator:
  SIG_MESSAGE("channel_9_colimator (Trace)");
  mcDEBUG_COMP("channel_9_colimator")
  mcDEBUG_STATE(
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp)
#define x mcnlx
#define y mcnly
#define z mcnlz
#define vx mcnlvx
#define vy mcnlvy
#define vz mcnlvz
#define t mcnlt
#define sx mcnlsx
#define sy mcnlsy
#define sz mcnlsz
#define p mcnlp

#define mcabsorbComp mcabsorbCompchannel_9_colimator
  STORE_NEUTRON(99,
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp);
  mcScattered=0;
  mcRestore=0;
  mcNCounter[99]++;
  mcPCounter[99] += p;
  mcP2Counter[99] += p*p;
#define mccompcurname  channel_9_colimator
#define mccompcurtype  Collimator_linear
#define mccompcurindex 99
#define slope mccchannel_9_colimator_slope
#define slopeV mccchannel_9_colimator_slopeV
{   /* Declarations of channel_9_colimator=Collimator_linear() SETTING parameters. */
MCNUM xmin = mccchannel_9_colimator_xmin;
MCNUM xmax = mccchannel_9_colimator_xmax;
MCNUM ymin = mccchannel_9_colimator_ymin;
MCNUM ymax = mccchannel_9_colimator_ymax;
MCNUM xwidth = mccchannel_9_colimator_xwidth;
MCNUM yheight = mccchannel_9_colimator_yheight;
MCNUM length = mccchannel_9_colimator_length;
MCNUM divergence = mccchannel_9_colimator_divergence;
MCNUM transmission = mccchannel_9_colimator_transmission;
MCNUM divergenceV = mccchannel_9_colimator_divergenceV;
/* 'channel_9_colimator=Collimator_linear()' component instance has conditional execution */
if (( channel_selected == 9 ))

#line 69 "/usr/share/mcstas/2.7/optics/Collimator_linear.comp"
{
    double phi, dt;

    PROP_Z0;
    if (x<xmin || x>xmax || y<ymin || y>ymax)
      ABSORB;
    dt = length/vz;
    PROP_DT(dt);
    if (x<xmin || x>xmax || y<ymin || y>ymax)
      ABSORB;

    if(slope > 0.0)
    {
      phi = fabs(vx/vz);
      if (phi > slope)
        ABSORB;
      else
        p *= transmission*(1.0 - phi/slope);
      SCATTER;
    }
    if (slopeV > 0) {
      phi = fabs(vy/vz);
      if (phi > slopeV)
        ABSORB;
      else
        p *= transmission*(1.0 - phi/slopeV);
      SCATTER;
    }
}
#line 359291 "MACS_sample_kidney_box.c"
}   /* End of channel_9_colimator=Collimator_linear() SETTING parameter declarations. */
#undef slopeV
#undef slope
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex
  /* Label for restoring  neutron */
  mcabsorbCompchannel_9_colimator:
  if (RESTORE) /* restore if needed */
  { RESTORE_NEUTRON(99,
      mcnlx,
      mcnly,
      mcnlz,
      mcnlvx,
      mcnlvy,
      mcnlvz,
      mcnlt,
      mcnlsx,
      mcnlsy,
      mcnlsz,
      mcnlp); }
#undef mcabsorbComp
#undef p
#undef sz
#undef sy
#undef sx
#undef t
#undef vz
#undef vy
#undef vx
#undef z
#undef y
#undef x
  mcDEBUG_STATE(
mcnlx,
mcnly,
mcnlz,
mcnlvx,
mcnlvy,
mcnlvz,
mcnlt,
mcnlsx,
mcnlsy,
mcnlsz,
mcnlp)

  /* TRACE Component channel_10_colimator [100] */
  mccoordschange(mcposrchannel_10_colimator, mcrotrchannel_10_colimator,
    &mcnlx,
    &mcnly,
    &mcnlz,
    &mcnlvx,
    &mcnlvy,
    &mcnlvz,
    &mcnlsx,
    &mcnlsy,
    &mcnlsz);
  /* define label inside component channel_10_colimator (without coords transformations) */
  mcJumpTrace_channel_10_colimator:
  SIG_MESSAGE("channel_10_colimator (Trace)");
  mcDEBUG_COMP("channel_10_colimator")
  mcDEBUG_STATE(
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp)
#define x mcnlx
#define y mcnly
#define z mcnlz
#define vx mcnlvx
#define vy mcnlvy
#define vz mcnlvz
#define t mcnlt
#define sx mcnlsx
#define sy mcnlsy
#define sz mcnlsz
#define p mcnlp

#define mcabsorbComp mcabsorbCompchannel_10_colimator
  STORE_NEUTRON(100,
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp);
  mcScattered=0;
  mcRestore=0;
  mcNCounter[100]++;
  mcPCounter[100] += p;
  mcP2Counter[100] += p*p;
#define mccompcurname  channel_10_colimator
#define mccompcurtype  Collimator_linear
#define mccompcurindex 100
#define slope mccchannel_10_colimator_slope
#define slopeV mccchannel_10_colimator_slopeV
{   /* Declarations of channel_10_colimator=Collimator_linear() SETTING parameters. */
MCNUM xmin = mccchannel_10_colimator_xmin;
MCNUM xmax = mccchannel_10_colimator_xmax;
MCNUM ymin = mccchannel_10_colimator_ymin;
MCNUM ymax = mccchannel_10_colimator_ymax;
MCNUM xwidth = mccchannel_10_colimator_xwidth;
MCNUM yheight = mccchannel_10_colimator_yheight;
MCNUM length = mccchannel_10_colimator_length;
MCNUM divergence = mccchannel_10_colimator_divergence;
MCNUM transmission = mccchannel_10_colimator_transmission;
MCNUM divergenceV = mccchannel_10_colimator_divergenceV;
/* 'channel_10_colimator=Collimator_linear()' component instance has conditional execution */
if (( channel_selected == 10 ))

#line 69 "/usr/share/mcstas/2.7/optics/Collimator_linear.comp"
{
    double phi, dt;

    PROP_Z0;
    if (x<xmin || x>xmax || y<ymin || y>ymax)
      ABSORB;
    dt = length/vz;
    PROP_DT(dt);
    if (x<xmin || x>xmax || y<ymin || y>ymax)
      ABSORB;

    if(slope > 0.0)
    {
      phi = fabs(vx/vz);
      if (phi > slope)
        ABSORB;
      else
        p *= transmission*(1.0 - phi/slope);
      SCATTER;
    }
    if (slopeV > 0) {
      phi = fabs(vy/vz);
      if (phi > slopeV)
        ABSORB;
      else
        p *= transmission*(1.0 - phi/slopeV);
      SCATTER;
    }
}
#line 359443 "MACS_sample_kidney_box.c"
}   /* End of channel_10_colimator=Collimator_linear() SETTING parameter declarations. */
#undef slopeV
#undef slope
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex
  /* Label for restoring  neutron */
  mcabsorbCompchannel_10_colimator:
  if (RESTORE) /* restore if needed */
  { RESTORE_NEUTRON(100,
      mcnlx,
      mcnly,
      mcnlz,
      mcnlvx,
      mcnlvy,
      mcnlvz,
      mcnlt,
      mcnlsx,
      mcnlsy,
      mcnlsz,
      mcnlp); }
#undef mcabsorbComp
#undef p
#undef sz
#undef sy
#undef sx
#undef t
#undef vz
#undef vy
#undef vx
#undef z
#undef y
#undef x
  mcDEBUG_STATE(
mcnlx,
mcnly,
mcnlz,
mcnlvx,
mcnlvy,
mcnlvz,
mcnlt,
mcnlsx,
mcnlsy,
mcnlsz,
mcnlp)

  /* TRACE Component channel_11_colimator [101] */
  mccoordschange(mcposrchannel_11_colimator, mcrotrchannel_11_colimator,
    &mcnlx,
    &mcnly,
    &mcnlz,
    &mcnlvx,
    &mcnlvy,
    &mcnlvz,
    &mcnlsx,
    &mcnlsy,
    &mcnlsz);
  /* define label inside component channel_11_colimator (without coords transformations) */
  mcJumpTrace_channel_11_colimator:
  SIG_MESSAGE("channel_11_colimator (Trace)");
  mcDEBUG_COMP("channel_11_colimator")
  mcDEBUG_STATE(
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp)
#define x mcnlx
#define y mcnly
#define z mcnlz
#define vx mcnlvx
#define vy mcnlvy
#define vz mcnlvz
#define t mcnlt
#define sx mcnlsx
#define sy mcnlsy
#define sz mcnlsz
#define p mcnlp

#define mcabsorbComp mcabsorbCompchannel_11_colimator
  STORE_NEUTRON(101,
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp);
  mcScattered=0;
  mcRestore=0;
  mcNCounter[101]++;
  mcPCounter[101] += p;
  mcP2Counter[101] += p*p;
#define mccompcurname  channel_11_colimator
#define mccompcurtype  Collimator_linear
#define mccompcurindex 101
#define slope mccchannel_11_colimator_slope
#define slopeV mccchannel_11_colimator_slopeV
{   /* Declarations of channel_11_colimator=Collimator_linear() SETTING parameters. */
MCNUM xmin = mccchannel_11_colimator_xmin;
MCNUM xmax = mccchannel_11_colimator_xmax;
MCNUM ymin = mccchannel_11_colimator_ymin;
MCNUM ymax = mccchannel_11_colimator_ymax;
MCNUM xwidth = mccchannel_11_colimator_xwidth;
MCNUM yheight = mccchannel_11_colimator_yheight;
MCNUM length = mccchannel_11_colimator_length;
MCNUM divergence = mccchannel_11_colimator_divergence;
MCNUM transmission = mccchannel_11_colimator_transmission;
MCNUM divergenceV = mccchannel_11_colimator_divergenceV;
/* 'channel_11_colimator=Collimator_linear()' component instance has conditional execution */
if (( channel_selected == 11 ))

#line 69 "/usr/share/mcstas/2.7/optics/Collimator_linear.comp"
{
    double phi, dt;

    PROP_Z0;
    if (x<xmin || x>xmax || y<ymin || y>ymax)
      ABSORB;
    dt = length/vz;
    PROP_DT(dt);
    if (x<xmin || x>xmax || y<ymin || y>ymax)
      ABSORB;

    if(slope > 0.0)
    {
      phi = fabs(vx/vz);
      if (phi > slope)
        ABSORB;
      else
        p *= transmission*(1.0 - phi/slope);
      SCATTER;
    }
    if (slopeV > 0) {
      phi = fabs(vy/vz);
      if (phi > slopeV)
        ABSORB;
      else
        p *= transmission*(1.0 - phi/slopeV);
      SCATTER;
    }
}
#line 359595 "MACS_sample_kidney_box.c"
}   /* End of channel_11_colimator=Collimator_linear() SETTING parameter declarations. */
#undef slopeV
#undef slope
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex
  /* Label for restoring  neutron */
  mcabsorbCompchannel_11_colimator:
  if (RESTORE) /* restore if needed */
  { RESTORE_NEUTRON(101,
      mcnlx,
      mcnly,
      mcnlz,
      mcnlvx,
      mcnlvy,
      mcnlvz,
      mcnlt,
      mcnlsx,
      mcnlsy,
      mcnlsz,
      mcnlp); }
#undef mcabsorbComp
#undef p
#undef sz
#undef sy
#undef sx
#undef t
#undef vz
#undef vy
#undef vx
#undef z
#undef y
#undef x
  mcDEBUG_STATE(
mcnlx,
mcnly,
mcnlz,
mcnlvx,
mcnlvy,
mcnlvz,
mcnlt,
mcnlsx,
mcnlsy,
mcnlsz,
mcnlp)

  /* TRACE Component channel_12_colimator [102] */
  mccoordschange(mcposrchannel_12_colimator, mcrotrchannel_12_colimator,
    &mcnlx,
    &mcnly,
    &mcnlz,
    &mcnlvx,
    &mcnlvy,
    &mcnlvz,
    &mcnlsx,
    &mcnlsy,
    &mcnlsz);
  /* define label inside component channel_12_colimator (without coords transformations) */
  mcJumpTrace_channel_12_colimator:
  SIG_MESSAGE("channel_12_colimator (Trace)");
  mcDEBUG_COMP("channel_12_colimator")
  mcDEBUG_STATE(
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp)
#define x mcnlx
#define y mcnly
#define z mcnlz
#define vx mcnlvx
#define vy mcnlvy
#define vz mcnlvz
#define t mcnlt
#define sx mcnlsx
#define sy mcnlsy
#define sz mcnlsz
#define p mcnlp

#define mcabsorbComp mcabsorbCompchannel_12_colimator
  STORE_NEUTRON(102,
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp);
  mcScattered=0;
  mcRestore=0;
  mcNCounter[102]++;
  mcPCounter[102] += p;
  mcP2Counter[102] += p*p;
#define mccompcurname  channel_12_colimator
#define mccompcurtype  Collimator_linear
#define mccompcurindex 102
#define slope mccchannel_12_colimator_slope
#define slopeV mccchannel_12_colimator_slopeV
{   /* Declarations of channel_12_colimator=Collimator_linear() SETTING parameters. */
MCNUM xmin = mccchannel_12_colimator_xmin;
MCNUM xmax = mccchannel_12_colimator_xmax;
MCNUM ymin = mccchannel_12_colimator_ymin;
MCNUM ymax = mccchannel_12_colimator_ymax;
MCNUM xwidth = mccchannel_12_colimator_xwidth;
MCNUM yheight = mccchannel_12_colimator_yheight;
MCNUM length = mccchannel_12_colimator_length;
MCNUM divergence = mccchannel_12_colimator_divergence;
MCNUM transmission = mccchannel_12_colimator_transmission;
MCNUM divergenceV = mccchannel_12_colimator_divergenceV;
/* 'channel_12_colimator=Collimator_linear()' component instance has conditional execution */
if (( channel_selected == 12 ))

#line 69 "/usr/share/mcstas/2.7/optics/Collimator_linear.comp"
{
    double phi, dt;

    PROP_Z0;
    if (x<xmin || x>xmax || y<ymin || y>ymax)
      ABSORB;
    dt = length/vz;
    PROP_DT(dt);
    if (x<xmin || x>xmax || y<ymin || y>ymax)
      ABSORB;

    if(slope > 0.0)
    {
      phi = fabs(vx/vz);
      if (phi > slope)
        ABSORB;
      else
        p *= transmission*(1.0 - phi/slope);
      SCATTER;
    }
    if (slopeV > 0) {
      phi = fabs(vy/vz);
      if (phi > slopeV)
        ABSORB;
      else
        p *= transmission*(1.0 - phi/slopeV);
      SCATTER;
    }
}
#line 359747 "MACS_sample_kidney_box.c"
}   /* End of channel_12_colimator=Collimator_linear() SETTING parameter declarations. */
#undef slopeV
#undef slope
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex
  /* Label for restoring  neutron */
  mcabsorbCompchannel_12_colimator:
  if (RESTORE) /* restore if needed */
  { RESTORE_NEUTRON(102,
      mcnlx,
      mcnly,
      mcnlz,
      mcnlvx,
      mcnlvy,
      mcnlvz,
      mcnlt,
      mcnlsx,
      mcnlsy,
      mcnlsz,
      mcnlp); }
#undef mcabsorbComp
#undef p
#undef sz
#undef sy
#undef sx
#undef t
#undef vz
#undef vy
#undef vx
#undef z
#undef y
#undef x
  mcDEBUG_STATE(
mcnlx,
mcnly,
mcnlz,
mcnlvx,
mcnlvy,
mcnlvz,
mcnlt,
mcnlsx,
mcnlsy,
mcnlsz,
mcnlp)

  /* TRACE Component channel_13_colimator [103] */
  mccoordschange(mcposrchannel_13_colimator, mcrotrchannel_13_colimator,
    &mcnlx,
    &mcnly,
    &mcnlz,
    &mcnlvx,
    &mcnlvy,
    &mcnlvz,
    &mcnlsx,
    &mcnlsy,
    &mcnlsz);
  /* define label inside component channel_13_colimator (without coords transformations) */
  mcJumpTrace_channel_13_colimator:
  SIG_MESSAGE("channel_13_colimator (Trace)");
  mcDEBUG_COMP("channel_13_colimator")
  mcDEBUG_STATE(
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp)
#define x mcnlx
#define y mcnly
#define z mcnlz
#define vx mcnlvx
#define vy mcnlvy
#define vz mcnlvz
#define t mcnlt
#define sx mcnlsx
#define sy mcnlsy
#define sz mcnlsz
#define p mcnlp

#define mcabsorbComp mcabsorbCompchannel_13_colimator
  STORE_NEUTRON(103,
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp);
  mcScattered=0;
  mcRestore=0;
  mcNCounter[103]++;
  mcPCounter[103] += p;
  mcP2Counter[103] += p*p;
#define mccompcurname  channel_13_colimator
#define mccompcurtype  Collimator_linear
#define mccompcurindex 103
#define slope mccchannel_13_colimator_slope
#define slopeV mccchannel_13_colimator_slopeV
{   /* Declarations of channel_13_colimator=Collimator_linear() SETTING parameters. */
MCNUM xmin = mccchannel_13_colimator_xmin;
MCNUM xmax = mccchannel_13_colimator_xmax;
MCNUM ymin = mccchannel_13_colimator_ymin;
MCNUM ymax = mccchannel_13_colimator_ymax;
MCNUM xwidth = mccchannel_13_colimator_xwidth;
MCNUM yheight = mccchannel_13_colimator_yheight;
MCNUM length = mccchannel_13_colimator_length;
MCNUM divergence = mccchannel_13_colimator_divergence;
MCNUM transmission = mccchannel_13_colimator_transmission;
MCNUM divergenceV = mccchannel_13_colimator_divergenceV;
/* 'channel_13_colimator=Collimator_linear()' component instance has conditional execution */
if (( channel_selected == 13 ))

#line 69 "/usr/share/mcstas/2.7/optics/Collimator_linear.comp"
{
    double phi, dt;

    PROP_Z0;
    if (x<xmin || x>xmax || y<ymin || y>ymax)
      ABSORB;
    dt = length/vz;
    PROP_DT(dt);
    if (x<xmin || x>xmax || y<ymin || y>ymax)
      ABSORB;

    if(slope > 0.0)
    {
      phi = fabs(vx/vz);
      if (phi > slope)
        ABSORB;
      else
        p *= transmission*(1.0 - phi/slope);
      SCATTER;
    }
    if (slopeV > 0) {
      phi = fabs(vy/vz);
      if (phi > slopeV)
        ABSORB;
      else
        p *= transmission*(1.0 - phi/slopeV);
      SCATTER;
    }
}
#line 359899 "MACS_sample_kidney_box.c"
}   /* End of channel_13_colimator=Collimator_linear() SETTING parameter declarations. */
#undef slopeV
#undef slope
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex
  /* Label for restoring  neutron */
  mcabsorbCompchannel_13_colimator:
  if (RESTORE) /* restore if needed */
  { RESTORE_NEUTRON(103,
      mcnlx,
      mcnly,
      mcnlz,
      mcnlvx,
      mcnlvy,
      mcnlvz,
      mcnlt,
      mcnlsx,
      mcnlsy,
      mcnlsz,
      mcnlp); }
#undef mcabsorbComp
#undef p
#undef sz
#undef sy
#undef sx
#undef t
#undef vz
#undef vy
#undef vx
#undef z
#undef y
#undef x
  mcDEBUG_STATE(
mcnlx,
mcnly,
mcnlz,
mcnlvx,
mcnlvy,
mcnlvz,
mcnlt,
mcnlsx,
mcnlsy,
mcnlsz,
mcnlp)

  /* TRACE Component channel_14_colimator [104] */
  mccoordschange(mcposrchannel_14_colimator, mcrotrchannel_14_colimator,
    &mcnlx,
    &mcnly,
    &mcnlz,
    &mcnlvx,
    &mcnlvy,
    &mcnlvz,
    &mcnlsx,
    &mcnlsy,
    &mcnlsz);
  /* define label inside component channel_14_colimator (without coords transformations) */
  mcJumpTrace_channel_14_colimator:
  SIG_MESSAGE("channel_14_colimator (Trace)");
  mcDEBUG_COMP("channel_14_colimator")
  mcDEBUG_STATE(
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp)
#define x mcnlx
#define y mcnly
#define z mcnlz
#define vx mcnlvx
#define vy mcnlvy
#define vz mcnlvz
#define t mcnlt
#define sx mcnlsx
#define sy mcnlsy
#define sz mcnlsz
#define p mcnlp

#define mcabsorbComp mcabsorbCompchannel_14_colimator
  STORE_NEUTRON(104,
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp);
  mcScattered=0;
  mcRestore=0;
  mcNCounter[104]++;
  mcPCounter[104] += p;
  mcP2Counter[104] += p*p;
#define mccompcurname  channel_14_colimator
#define mccompcurtype  Collimator_linear
#define mccompcurindex 104
#define slope mccchannel_14_colimator_slope
#define slopeV mccchannel_14_colimator_slopeV
{   /* Declarations of channel_14_colimator=Collimator_linear() SETTING parameters. */
MCNUM xmin = mccchannel_14_colimator_xmin;
MCNUM xmax = mccchannel_14_colimator_xmax;
MCNUM ymin = mccchannel_14_colimator_ymin;
MCNUM ymax = mccchannel_14_colimator_ymax;
MCNUM xwidth = mccchannel_14_colimator_xwidth;
MCNUM yheight = mccchannel_14_colimator_yheight;
MCNUM length = mccchannel_14_colimator_length;
MCNUM divergence = mccchannel_14_colimator_divergence;
MCNUM transmission = mccchannel_14_colimator_transmission;
MCNUM divergenceV = mccchannel_14_colimator_divergenceV;
/* 'channel_14_colimator=Collimator_linear()' component instance has conditional execution */
if (( channel_selected == 14 ))

#line 69 "/usr/share/mcstas/2.7/optics/Collimator_linear.comp"
{
    double phi, dt;

    PROP_Z0;
    if (x<xmin || x>xmax || y<ymin || y>ymax)
      ABSORB;
    dt = length/vz;
    PROP_DT(dt);
    if (x<xmin || x>xmax || y<ymin || y>ymax)
      ABSORB;

    if(slope > 0.0)
    {
      phi = fabs(vx/vz);
      if (phi > slope)
        ABSORB;
      else
        p *= transmission*(1.0 - phi/slope);
      SCATTER;
    }
    if (slopeV > 0) {
      phi = fabs(vy/vz);
      if (phi > slopeV)
        ABSORB;
      else
        p *= transmission*(1.0 - phi/slopeV);
      SCATTER;
    }
}
#line 360051 "MACS_sample_kidney_box.c"
}   /* End of channel_14_colimator=Collimator_linear() SETTING parameter declarations. */
#undef slopeV
#undef slope
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex
  /* Label for restoring  neutron */
  mcabsorbCompchannel_14_colimator:
  if (RESTORE) /* restore if needed */
  { RESTORE_NEUTRON(104,
      mcnlx,
      mcnly,
      mcnlz,
      mcnlvx,
      mcnlvy,
      mcnlvz,
      mcnlt,
      mcnlsx,
      mcnlsy,
      mcnlsz,
      mcnlp); }
#undef mcabsorbComp
#undef p
#undef sz
#undef sy
#undef sx
#undef t
#undef vz
#undef vy
#undef vx
#undef z
#undef y
#undef x
  mcDEBUG_STATE(
mcnlx,
mcnly,
mcnlz,
mcnlvx,
mcnlvy,
mcnlvz,
mcnlt,
mcnlsx,
mcnlsy,
mcnlsz,
mcnlp)

  /* TRACE Component channel_15_colimator [105] */
  mccoordschange(mcposrchannel_15_colimator, mcrotrchannel_15_colimator,
    &mcnlx,
    &mcnly,
    &mcnlz,
    &mcnlvx,
    &mcnlvy,
    &mcnlvz,
    &mcnlsx,
    &mcnlsy,
    &mcnlsz);
  /* define label inside component channel_15_colimator (without coords transformations) */
  mcJumpTrace_channel_15_colimator:
  SIG_MESSAGE("channel_15_colimator (Trace)");
  mcDEBUG_COMP("channel_15_colimator")
  mcDEBUG_STATE(
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp)
#define x mcnlx
#define y mcnly
#define z mcnlz
#define vx mcnlvx
#define vy mcnlvy
#define vz mcnlvz
#define t mcnlt
#define sx mcnlsx
#define sy mcnlsy
#define sz mcnlsz
#define p mcnlp

#define mcabsorbComp mcabsorbCompchannel_15_colimator
  STORE_NEUTRON(105,
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp);
  mcScattered=0;
  mcRestore=0;
  mcNCounter[105]++;
  mcPCounter[105] += p;
  mcP2Counter[105] += p*p;
#define mccompcurname  channel_15_colimator
#define mccompcurtype  Collimator_linear
#define mccompcurindex 105
#define slope mccchannel_15_colimator_slope
#define slopeV mccchannel_15_colimator_slopeV
{   /* Declarations of channel_15_colimator=Collimator_linear() SETTING parameters. */
MCNUM xmin = mccchannel_15_colimator_xmin;
MCNUM xmax = mccchannel_15_colimator_xmax;
MCNUM ymin = mccchannel_15_colimator_ymin;
MCNUM ymax = mccchannel_15_colimator_ymax;
MCNUM xwidth = mccchannel_15_colimator_xwidth;
MCNUM yheight = mccchannel_15_colimator_yheight;
MCNUM length = mccchannel_15_colimator_length;
MCNUM divergence = mccchannel_15_colimator_divergence;
MCNUM transmission = mccchannel_15_colimator_transmission;
MCNUM divergenceV = mccchannel_15_colimator_divergenceV;
/* 'channel_15_colimator=Collimator_linear()' component instance has conditional execution */
if (( channel_selected == 15 ))

#line 69 "/usr/share/mcstas/2.7/optics/Collimator_linear.comp"
{
    double phi, dt;

    PROP_Z0;
    if (x<xmin || x>xmax || y<ymin || y>ymax)
      ABSORB;
    dt = length/vz;
    PROP_DT(dt);
    if (x<xmin || x>xmax || y<ymin || y>ymax)
      ABSORB;

    if(slope > 0.0)
    {
      phi = fabs(vx/vz);
      if (phi > slope)
        ABSORB;
      else
        p *= transmission*(1.0 - phi/slope);
      SCATTER;
    }
    if (slopeV > 0) {
      phi = fabs(vy/vz);
      if (phi > slopeV)
        ABSORB;
      else
        p *= transmission*(1.0 - phi/slopeV);
      SCATTER;
    }
}
#line 360203 "MACS_sample_kidney_box.c"
}   /* End of channel_15_colimator=Collimator_linear() SETTING parameter declarations. */
#undef slopeV
#undef slope
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex
  /* Label for restoring  neutron */
  mcabsorbCompchannel_15_colimator:
  if (RESTORE) /* restore if needed */
  { RESTORE_NEUTRON(105,
      mcnlx,
      mcnly,
      mcnlz,
      mcnlvx,
      mcnlvy,
      mcnlvz,
      mcnlt,
      mcnlsx,
      mcnlsy,
      mcnlsz,
      mcnlp); }
#undef mcabsorbComp
#undef p
#undef sz
#undef sy
#undef sx
#undef t
#undef vz
#undef vy
#undef vx
#undef z
#undef y
#undef x
  mcDEBUG_STATE(
mcnlx,
mcnly,
mcnlz,
mcnlvx,
mcnlvy,
mcnlvz,
mcnlt,
mcnlsx,
mcnlsy,
mcnlsz,
mcnlp)

  /* TRACE Component channel_16_colimator [106] */
  mccoordschange(mcposrchannel_16_colimator, mcrotrchannel_16_colimator,
    &mcnlx,
    &mcnly,
    &mcnlz,
    &mcnlvx,
    &mcnlvy,
    &mcnlvz,
    &mcnlsx,
    &mcnlsy,
    &mcnlsz);
  /* define label inside component channel_16_colimator (without coords transformations) */
  mcJumpTrace_channel_16_colimator:
  SIG_MESSAGE("channel_16_colimator (Trace)");
  mcDEBUG_COMP("channel_16_colimator")
  mcDEBUG_STATE(
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp)
#define x mcnlx
#define y mcnly
#define z mcnlz
#define vx mcnlvx
#define vy mcnlvy
#define vz mcnlvz
#define t mcnlt
#define sx mcnlsx
#define sy mcnlsy
#define sz mcnlsz
#define p mcnlp

#define mcabsorbComp mcabsorbCompchannel_16_colimator
  STORE_NEUTRON(106,
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp);
  mcScattered=0;
  mcRestore=0;
  mcNCounter[106]++;
  mcPCounter[106] += p;
  mcP2Counter[106] += p*p;
#define mccompcurname  channel_16_colimator
#define mccompcurtype  Collimator_linear
#define mccompcurindex 106
#define slope mccchannel_16_colimator_slope
#define slopeV mccchannel_16_colimator_slopeV
{   /* Declarations of channel_16_colimator=Collimator_linear() SETTING parameters. */
MCNUM xmin = mccchannel_16_colimator_xmin;
MCNUM xmax = mccchannel_16_colimator_xmax;
MCNUM ymin = mccchannel_16_colimator_ymin;
MCNUM ymax = mccchannel_16_colimator_ymax;
MCNUM xwidth = mccchannel_16_colimator_xwidth;
MCNUM yheight = mccchannel_16_colimator_yheight;
MCNUM length = mccchannel_16_colimator_length;
MCNUM divergence = mccchannel_16_colimator_divergence;
MCNUM transmission = mccchannel_16_colimator_transmission;
MCNUM divergenceV = mccchannel_16_colimator_divergenceV;
/* 'channel_16_colimator=Collimator_linear()' component instance has conditional execution */
if (( channel_selected == 16 ))

#line 69 "/usr/share/mcstas/2.7/optics/Collimator_linear.comp"
{
    double phi, dt;

    PROP_Z0;
    if (x<xmin || x>xmax || y<ymin || y>ymax)
      ABSORB;
    dt = length/vz;
    PROP_DT(dt);
    if (x<xmin || x>xmax || y<ymin || y>ymax)
      ABSORB;

    if(slope > 0.0)
    {
      phi = fabs(vx/vz);
      if (phi > slope)
        ABSORB;
      else
        p *= transmission*(1.0 - phi/slope);
      SCATTER;
    }
    if (slopeV > 0) {
      phi = fabs(vy/vz);
      if (phi > slopeV)
        ABSORB;
      else
        p *= transmission*(1.0 - phi/slopeV);
      SCATTER;
    }
}
#line 360355 "MACS_sample_kidney_box.c"
}   /* End of channel_16_colimator=Collimator_linear() SETTING parameter declarations. */
#undef slopeV
#undef slope
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex
  /* Label for restoring  neutron */
  mcabsorbCompchannel_16_colimator:
  if (RESTORE) /* restore if needed */
  { RESTORE_NEUTRON(106,
      mcnlx,
      mcnly,
      mcnlz,
      mcnlvx,
      mcnlvy,
      mcnlvz,
      mcnlt,
      mcnlsx,
      mcnlsy,
      mcnlsz,
      mcnlp); }
#undef mcabsorbComp
#undef p
#undef sz
#undef sy
#undef sx
#undef t
#undef vz
#undef vy
#undef vx
#undef z
#undef y
#undef x
  mcDEBUG_STATE(
mcnlx,
mcnly,
mcnlz,
mcnlvx,
mcnlvy,
mcnlvz,
mcnlt,
mcnlsx,
mcnlsy,
mcnlsz,
mcnlp)

  /* TRACE Component channel_17_colimator [107] */
  mccoordschange(mcposrchannel_17_colimator, mcrotrchannel_17_colimator,
    &mcnlx,
    &mcnly,
    &mcnlz,
    &mcnlvx,
    &mcnlvy,
    &mcnlvz,
    &mcnlsx,
    &mcnlsy,
    &mcnlsz);
  /* define label inside component channel_17_colimator (without coords transformations) */
  mcJumpTrace_channel_17_colimator:
  SIG_MESSAGE("channel_17_colimator (Trace)");
  mcDEBUG_COMP("channel_17_colimator")
  mcDEBUG_STATE(
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp)
#define x mcnlx
#define y mcnly
#define z mcnlz
#define vx mcnlvx
#define vy mcnlvy
#define vz mcnlvz
#define t mcnlt
#define sx mcnlsx
#define sy mcnlsy
#define sz mcnlsz
#define p mcnlp

#define mcabsorbComp mcabsorbCompchannel_17_colimator
  STORE_NEUTRON(107,
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp);
  mcScattered=0;
  mcRestore=0;
  mcNCounter[107]++;
  mcPCounter[107] += p;
  mcP2Counter[107] += p*p;
#define mccompcurname  channel_17_colimator
#define mccompcurtype  Collimator_linear
#define mccompcurindex 107
#define slope mccchannel_17_colimator_slope
#define slopeV mccchannel_17_colimator_slopeV
{   /* Declarations of channel_17_colimator=Collimator_linear() SETTING parameters. */
MCNUM xmin = mccchannel_17_colimator_xmin;
MCNUM xmax = mccchannel_17_colimator_xmax;
MCNUM ymin = mccchannel_17_colimator_ymin;
MCNUM ymax = mccchannel_17_colimator_ymax;
MCNUM xwidth = mccchannel_17_colimator_xwidth;
MCNUM yheight = mccchannel_17_colimator_yheight;
MCNUM length = mccchannel_17_colimator_length;
MCNUM divergence = mccchannel_17_colimator_divergence;
MCNUM transmission = mccchannel_17_colimator_transmission;
MCNUM divergenceV = mccchannel_17_colimator_divergenceV;
/* 'channel_17_colimator=Collimator_linear()' component instance has conditional execution */
if (( channel_selected == 17 ))

#line 69 "/usr/share/mcstas/2.7/optics/Collimator_linear.comp"
{
    double phi, dt;

    PROP_Z0;
    if (x<xmin || x>xmax || y<ymin || y>ymax)
      ABSORB;
    dt = length/vz;
    PROP_DT(dt);
    if (x<xmin || x>xmax || y<ymin || y>ymax)
      ABSORB;

    if(slope > 0.0)
    {
      phi = fabs(vx/vz);
      if (phi > slope)
        ABSORB;
      else
        p *= transmission*(1.0 - phi/slope);
      SCATTER;
    }
    if (slopeV > 0) {
      phi = fabs(vy/vz);
      if (phi > slopeV)
        ABSORB;
      else
        p *= transmission*(1.0 - phi/slopeV);
      SCATTER;
    }
}
#line 360507 "MACS_sample_kidney_box.c"
}   /* End of channel_17_colimator=Collimator_linear() SETTING parameter declarations. */
#undef slopeV
#undef slope
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex
  /* Label for restoring  neutron */
  mcabsorbCompchannel_17_colimator:
  if (RESTORE) /* restore if needed */
  { RESTORE_NEUTRON(107,
      mcnlx,
      mcnly,
      mcnlz,
      mcnlvx,
      mcnlvy,
      mcnlvz,
      mcnlt,
      mcnlsx,
      mcnlsy,
      mcnlsz,
      mcnlp); }
#undef mcabsorbComp
#undef p
#undef sz
#undef sy
#undef sx
#undef t
#undef vz
#undef vy
#undef vx
#undef z
#undef y
#undef x
  mcDEBUG_STATE(
mcnlx,
mcnly,
mcnlz,
mcnlvx,
mcnlvy,
mcnlvz,
mcnlt,
mcnlsx,
mcnlsy,
mcnlsz,
mcnlp)

  /* TRACE Component channel_18_colimator [108] */
  mccoordschange(mcposrchannel_18_colimator, mcrotrchannel_18_colimator,
    &mcnlx,
    &mcnly,
    &mcnlz,
    &mcnlvx,
    &mcnlvy,
    &mcnlvz,
    &mcnlsx,
    &mcnlsy,
    &mcnlsz);
  /* define label inside component channel_18_colimator (without coords transformations) */
  mcJumpTrace_channel_18_colimator:
  SIG_MESSAGE("channel_18_colimator (Trace)");
  mcDEBUG_COMP("channel_18_colimator")
  mcDEBUG_STATE(
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp)
#define x mcnlx
#define y mcnly
#define z mcnlz
#define vx mcnlvx
#define vy mcnlvy
#define vz mcnlvz
#define t mcnlt
#define sx mcnlsx
#define sy mcnlsy
#define sz mcnlsz
#define p mcnlp

#define mcabsorbComp mcabsorbCompchannel_18_colimator
  STORE_NEUTRON(108,
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp);
  mcScattered=0;
  mcRestore=0;
  mcNCounter[108]++;
  mcPCounter[108] += p;
  mcP2Counter[108] += p*p;
#define mccompcurname  channel_18_colimator
#define mccompcurtype  Collimator_linear
#define mccompcurindex 108
#define slope mccchannel_18_colimator_slope
#define slopeV mccchannel_18_colimator_slopeV
{   /* Declarations of channel_18_colimator=Collimator_linear() SETTING parameters. */
MCNUM xmin = mccchannel_18_colimator_xmin;
MCNUM xmax = mccchannel_18_colimator_xmax;
MCNUM ymin = mccchannel_18_colimator_ymin;
MCNUM ymax = mccchannel_18_colimator_ymax;
MCNUM xwidth = mccchannel_18_colimator_xwidth;
MCNUM yheight = mccchannel_18_colimator_yheight;
MCNUM length = mccchannel_18_colimator_length;
MCNUM divergence = mccchannel_18_colimator_divergence;
MCNUM transmission = mccchannel_18_colimator_transmission;
MCNUM divergenceV = mccchannel_18_colimator_divergenceV;
/* 'channel_18_colimator=Collimator_linear()' component instance has conditional execution */
if (( channel_selected == 18 ))

#line 69 "/usr/share/mcstas/2.7/optics/Collimator_linear.comp"
{
    double phi, dt;

    PROP_Z0;
    if (x<xmin || x>xmax || y<ymin || y>ymax)
      ABSORB;
    dt = length/vz;
    PROP_DT(dt);
    if (x<xmin || x>xmax || y<ymin || y>ymax)
      ABSORB;

    if(slope > 0.0)
    {
      phi = fabs(vx/vz);
      if (phi > slope)
        ABSORB;
      else
        p *= transmission*(1.0 - phi/slope);
      SCATTER;
    }
    if (slopeV > 0) {
      phi = fabs(vy/vz);
      if (phi > slopeV)
        ABSORB;
      else
        p *= transmission*(1.0 - phi/slopeV);
      SCATTER;
    }
}
#line 360659 "MACS_sample_kidney_box.c"
}   /* End of channel_18_colimator=Collimator_linear() SETTING parameter declarations. */
#undef slopeV
#undef slope
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex
  /* Label for restoring  neutron */
  mcabsorbCompchannel_18_colimator:
  if (RESTORE) /* restore if needed */
  { RESTORE_NEUTRON(108,
      mcnlx,
      mcnly,
      mcnlz,
      mcnlvx,
      mcnlvy,
      mcnlvz,
      mcnlt,
      mcnlsx,
      mcnlsy,
      mcnlsz,
      mcnlp); }
#undef mcabsorbComp
#undef p
#undef sz
#undef sy
#undef sx
#undef t
#undef vz
#undef vy
#undef vx
#undef z
#undef y
#undef x
  mcDEBUG_STATE(
mcnlx,
mcnly,
mcnlz,
mcnlvx,
mcnlvy,
mcnlvz,
mcnlt,
mcnlsx,
mcnlsy,
mcnlsz,
mcnlp)

  /* TRACE Component channel_19_colimator [109] */
  mccoordschange(mcposrchannel_19_colimator, mcrotrchannel_19_colimator,
    &mcnlx,
    &mcnly,
    &mcnlz,
    &mcnlvx,
    &mcnlvy,
    &mcnlvz,
    &mcnlsx,
    &mcnlsy,
    &mcnlsz);
  /* define label inside component channel_19_colimator (without coords transformations) */
  mcJumpTrace_channel_19_colimator:
  SIG_MESSAGE("channel_19_colimator (Trace)");
  mcDEBUG_COMP("channel_19_colimator")
  mcDEBUG_STATE(
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp)
#define x mcnlx
#define y mcnly
#define z mcnlz
#define vx mcnlvx
#define vy mcnlvy
#define vz mcnlvz
#define t mcnlt
#define sx mcnlsx
#define sy mcnlsy
#define sz mcnlsz
#define p mcnlp

#define mcabsorbComp mcabsorbCompchannel_19_colimator
  STORE_NEUTRON(109,
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp);
  mcScattered=0;
  mcRestore=0;
  mcNCounter[109]++;
  mcPCounter[109] += p;
  mcP2Counter[109] += p*p;
#define mccompcurname  channel_19_colimator
#define mccompcurtype  Collimator_linear
#define mccompcurindex 109
#define slope mccchannel_19_colimator_slope
#define slopeV mccchannel_19_colimator_slopeV
{   /* Declarations of channel_19_colimator=Collimator_linear() SETTING parameters. */
MCNUM xmin = mccchannel_19_colimator_xmin;
MCNUM xmax = mccchannel_19_colimator_xmax;
MCNUM ymin = mccchannel_19_colimator_ymin;
MCNUM ymax = mccchannel_19_colimator_ymax;
MCNUM xwidth = mccchannel_19_colimator_xwidth;
MCNUM yheight = mccchannel_19_colimator_yheight;
MCNUM length = mccchannel_19_colimator_length;
MCNUM divergence = mccchannel_19_colimator_divergence;
MCNUM transmission = mccchannel_19_colimator_transmission;
MCNUM divergenceV = mccchannel_19_colimator_divergenceV;
/* 'channel_19_colimator=Collimator_linear()' component instance has conditional execution */
if (( channel_selected == 19 ))

#line 69 "/usr/share/mcstas/2.7/optics/Collimator_linear.comp"
{
    double phi, dt;

    PROP_Z0;
    if (x<xmin || x>xmax || y<ymin || y>ymax)
      ABSORB;
    dt = length/vz;
    PROP_DT(dt);
    if (x<xmin || x>xmax || y<ymin || y>ymax)
      ABSORB;

    if(slope > 0.0)
    {
      phi = fabs(vx/vz);
      if (phi > slope)
        ABSORB;
      else
        p *= transmission*(1.0 - phi/slope);
      SCATTER;
    }
    if (slopeV > 0) {
      phi = fabs(vy/vz);
      if (phi > slopeV)
        ABSORB;
      else
        p *= transmission*(1.0 - phi/slopeV);
      SCATTER;
    }
}
#line 360811 "MACS_sample_kidney_box.c"
}   /* End of channel_19_colimator=Collimator_linear() SETTING parameter declarations. */
#undef slopeV
#undef slope
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex
  /* Label for restoring  neutron */
  mcabsorbCompchannel_19_colimator:
  if (RESTORE) /* restore if needed */
  { RESTORE_NEUTRON(109,
      mcnlx,
      mcnly,
      mcnlz,
      mcnlvx,
      mcnlvy,
      mcnlvz,
      mcnlt,
      mcnlsx,
      mcnlsy,
      mcnlsz,
      mcnlp); }
#undef mcabsorbComp
#undef p
#undef sz
#undef sy
#undef sx
#undef t
#undef vz
#undef vy
#undef vx
#undef z
#undef y
#undef x
  mcDEBUG_STATE(
mcnlx,
mcnly,
mcnlz,
mcnlvx,
mcnlvy,
mcnlvz,
mcnlt,
mcnlsx,
mcnlsy,
mcnlsz,
mcnlp)

  /* TRACE Component boron_plastic_incoherent [110] */
  mccoordschange(mcposrboron_plastic_incoherent, mcrotrboron_plastic_incoherent,
    &mcnlx,
    &mcnly,
    &mcnlz,
    &mcnlvx,
    &mcnlvy,
    &mcnlvz,
    &mcnlsx,
    &mcnlsy,
    &mcnlsz);
  /* define label inside component boron_plastic_incoherent (without coords transformations) */
  mcJumpTrace_boron_plastic_incoherent:
  SIG_MESSAGE("boron_plastic_incoherent (Trace)");
  mcDEBUG_COMP("boron_plastic_incoherent")
  mcDEBUG_STATE(
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp)
#define x mcnlx
#define y mcnly
#define z mcnlz
#define vx mcnlvx
#define vy mcnlvy
#define vz mcnlvz
#define t mcnlt
#define sx mcnlsx
#define sy mcnlsy
#define sz mcnlsz
#define p mcnlp

#define mcabsorbComp mcabsorbCompboron_plastic_incoherent
  STORE_NEUTRON(110,
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp);
  mcScattered=0;
  mcRestore=0;
  mcNCounter[110]++;
  mcPCounter[110] += p;
  mcP2Counter[110] += p*p;
#define mccompcurname  boron_plastic_incoherent
#define mccompcurtype  Incoherent_process
#define mccompcurindex 110
#define This_process mccboron_plastic_incoherent_This_process
#define Incoherent_storage mccboron_plastic_incoherent_Incoherent_storage
#define effective_my_scattering mccboron_plastic_incoherent_effective_my_scattering
{   /* Declarations of boron_plastic_incoherent=Incoherent_process() SETTING parameters. */
MCNUM sigma = mccboron_plastic_incoherent_sigma;
MCNUM f_QE = mccboron_plastic_incoherent_f_QE;
MCNUM gamma = mccboron_plastic_incoherent_gamma;
MCNUM packing_factor = mccboron_plastic_incoherent_packing_factor;
MCNUM unit_cell_volume = mccboron_plastic_incoherent_unit_cell_volume;
MCNUM interact_fraction = mccboron_plastic_incoherent_interact_fraction;
}   /* End of boron_plastic_incoherent=Incoherent_process() SETTING parameter declarations. */
#undef effective_my_scattering
#undef Incoherent_storage
#undef This_process
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex
  /* Label for restoring  neutron */
  mcabsorbCompboron_plastic_incoherent:
  if (RESTORE) /* restore if needed */
  { RESTORE_NEUTRON(110,
      mcnlx,
      mcnly,
      mcnlz,
      mcnlvx,
      mcnlvy,
      mcnlvz,
      mcnlt,
      mcnlsx,
      mcnlsy,
      mcnlsz,
      mcnlp); }
#undef mcabsorbComp
#undef p
#undef sz
#undef sy
#undef sx
#undef t
#undef vz
#undef vy
#undef vx
#undef z
#undef y
#undef x
  mcDEBUG_STATE(
mcnlx,
mcnly,
mcnlz,
mcnlvx,
mcnlvy,
mcnlvz,
mcnlt,
mcnlsx,
mcnlsy,
mcnlsz,
mcnlp)

  /* TRACE Component boron_plastic [111] */
  mccoordschange(mcposrboron_plastic, mcrotrboron_plastic,
    &mcnlx,
    &mcnly,
    &mcnlz,
    &mcnlvx,
    &mcnlvy,
    &mcnlvz,
    &mcnlsx,
    &mcnlsy,
    &mcnlsz);
  /* define label inside component boron_plastic (without coords transformations) */
  mcJumpTrace_boron_plastic:
  SIG_MESSAGE("boron_plastic (Trace)");
  mcDEBUG_COMP("boron_plastic")
  mcDEBUG_STATE(
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp)
#define x mcnlx
#define y mcnly
#define z mcnlz
#define vx mcnlvx
#define vy mcnlvy
#define vz mcnlvz
#define t mcnlt
#define sx mcnlsx
#define sy mcnlsy
#define sz mcnlsz
#define p mcnlp

#define mcabsorbComp mcabsorbCompboron_plastic
  STORE_NEUTRON(111,
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp);
  mcScattered=0;
  mcRestore=0;
  mcNCounter[111]++;
  mcPCounter[111] += p;
  mcP2Counter[111] += p*p;
#define mccompcurname  boron_plastic
#define mccompcurtype  Union_make_material
#define mccompcurindex 111
#define loop_index mccboron_plastic_loop_index
#define this_material mccboron_plastic_this_material
#define accepted_processes mccboron_plastic_accepted_processes
#define global_material_element mccboron_plastic_global_material_element
{   /* Declarations of boron_plastic=Union_make_material() SETTING parameters. */
char* process_string = mccboron_plastic_process_string;
MCNUM my_absorption = mccboron_plastic_my_absorption;
MCNUM absorber = mccboron_plastic_absorber;
}   /* End of boron_plastic=Union_make_material() SETTING parameter declarations. */
#undef global_material_element
#undef accepted_processes
#undef this_material
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex
  /* Label for restoring  neutron */
  mcabsorbCompboron_plastic:
  if (RESTORE) /* restore if needed */
  { RESTORE_NEUTRON(111,
      mcnlx,
      mcnly,
      mcnlz,
      mcnlvx,
      mcnlvy,
      mcnlvz,
      mcnlt,
      mcnlsx,
      mcnlsy,
      mcnlsz,
      mcnlp); }
#undef mcabsorbComp
#undef p
#undef sz
#undef sy
#undef sx
#undef t
#undef vz
#undef vy
#undef vx
#undef z
#undef y
#undef x
  mcDEBUG_STATE(
mcnlx,
mcnly,
mcnlz,
mcnlvx,
mcnlvy,
mcnlvz,
mcnlt,
mcnlsx,
mcnlsy,
mcnlsz,
mcnlp)

  /* TRACE Component boron_plastic_enriched_incoherent [112] */
  mccoordschange(mcposrboron_plastic_enriched_incoherent, mcrotrboron_plastic_enriched_incoherent,
    &mcnlx,
    &mcnly,
    &mcnlz,
    &mcnlvx,
    &mcnlvy,
    &mcnlvz,
    &mcnlsx,
    &mcnlsy,
    &mcnlsz);
  /* define label inside component boron_plastic_enriched_incoherent (without coords transformations) */
  mcJumpTrace_boron_plastic_enriched_incoherent:
  SIG_MESSAGE("boron_plastic_enriched_incoherent (Trace)");
  mcDEBUG_COMP("boron_plastic_enriched_incoherent")
  mcDEBUG_STATE(
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp)
#define x mcnlx
#define y mcnly
#define z mcnlz
#define vx mcnlvx
#define vy mcnlvy
#define vz mcnlvz
#define t mcnlt
#define sx mcnlsx
#define sy mcnlsy
#define sz mcnlsz
#define p mcnlp

#define mcabsorbComp mcabsorbCompboron_plastic_enriched_incoherent
  STORE_NEUTRON(112,
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp);
  mcScattered=0;
  mcRestore=0;
  mcNCounter[112]++;
  mcPCounter[112] += p;
  mcP2Counter[112] += p*p;
#define mccompcurname  boron_plastic_enriched_incoherent
#define mccompcurtype  Incoherent_process
#define mccompcurindex 112
#define This_process mccboron_plastic_enriched_incoherent_This_process
#define Incoherent_storage mccboron_plastic_enriched_incoherent_Incoherent_storage
#define effective_my_scattering mccboron_plastic_enriched_incoherent_effective_my_scattering
{   /* Declarations of boron_plastic_enriched_incoherent=Incoherent_process() SETTING parameters. */
MCNUM sigma = mccboron_plastic_enriched_incoherent_sigma;
MCNUM f_QE = mccboron_plastic_enriched_incoherent_f_QE;
MCNUM gamma = mccboron_plastic_enriched_incoherent_gamma;
MCNUM packing_factor = mccboron_plastic_enriched_incoherent_packing_factor;
MCNUM unit_cell_volume = mccboron_plastic_enriched_incoherent_unit_cell_volume;
MCNUM interact_fraction = mccboron_plastic_enriched_incoherent_interact_fraction;
}   /* End of boron_plastic_enriched_incoherent=Incoherent_process() SETTING parameter declarations. */
#undef effective_my_scattering
#undef Incoherent_storage
#undef This_process
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex
  /* Label for restoring  neutron */
  mcabsorbCompboron_plastic_enriched_incoherent:
  if (RESTORE) /* restore if needed */
  { RESTORE_NEUTRON(112,
      mcnlx,
      mcnly,
      mcnlz,
      mcnlvx,
      mcnlvy,
      mcnlvz,
      mcnlt,
      mcnlsx,
      mcnlsy,
      mcnlsz,
      mcnlp); }
#undef mcabsorbComp
#undef p
#undef sz
#undef sy
#undef sx
#undef t
#undef vz
#undef vy
#undef vx
#undef z
#undef y
#undef x
  mcDEBUG_STATE(
mcnlx,
mcnly,
mcnlz,
mcnlvx,
mcnlvy,
mcnlvz,
mcnlt,
mcnlsx,
mcnlsy,
mcnlsz,
mcnlp)

  /* TRACE Component boron_plastic_enriched [113] */
  mccoordschange(mcposrboron_plastic_enriched, mcrotrboron_plastic_enriched,
    &mcnlx,
    &mcnly,
    &mcnlz,
    &mcnlvx,
    &mcnlvy,
    &mcnlvz,
    &mcnlsx,
    &mcnlsy,
    &mcnlsz);
  /* define label inside component boron_plastic_enriched (without coords transformations) */
  mcJumpTrace_boron_plastic_enriched:
  SIG_MESSAGE("boron_plastic_enriched (Trace)");
  mcDEBUG_COMP("boron_plastic_enriched")
  mcDEBUG_STATE(
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp)
#define x mcnlx
#define y mcnly
#define z mcnlz
#define vx mcnlvx
#define vy mcnlvy
#define vz mcnlvz
#define t mcnlt
#define sx mcnlsx
#define sy mcnlsy
#define sz mcnlsz
#define p mcnlp

#define mcabsorbComp mcabsorbCompboron_plastic_enriched
  STORE_NEUTRON(113,
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp);
  mcScattered=0;
  mcRestore=0;
  mcNCounter[113]++;
  mcPCounter[113] += p;
  mcP2Counter[113] += p*p;
#define mccompcurname  boron_plastic_enriched
#define mccompcurtype  Union_make_material
#define mccompcurindex 113
#define loop_index mccboron_plastic_enriched_loop_index
#define this_material mccboron_plastic_enriched_this_material
#define accepted_processes mccboron_plastic_enriched_accepted_processes
#define global_material_element mccboron_plastic_enriched_global_material_element
{   /* Declarations of boron_plastic_enriched=Union_make_material() SETTING parameters. */
char* process_string = mccboron_plastic_enriched_process_string;
MCNUM my_absorption = mccboron_plastic_enriched_my_absorption;
MCNUM absorber = mccboron_plastic_enriched_absorber;
}   /* End of boron_plastic_enriched=Union_make_material() SETTING parameter declarations. */
#undef global_material_element
#undef accepted_processes
#undef this_material
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex
  /* Label for restoring  neutron */
  mcabsorbCompboron_plastic_enriched:
  if (RESTORE) /* restore if needed */
  { RESTORE_NEUTRON(113,
      mcnlx,
      mcnly,
      mcnlz,
      mcnlvx,
      mcnlvy,
      mcnlvz,
      mcnlt,
      mcnlsx,
      mcnlsy,
      mcnlsz,
      mcnlp); }
#undef mcabsorbComp
#undef p
#undef sz
#undef sy
#undef sx
#undef t
#undef vz
#undef vy
#undef vx
#undef z
#undef y
#undef x
  mcDEBUG_STATE(
mcnlx,
mcnly,
mcnlz,
mcnlvx,
mcnlvy,
mcnlvz,
mcnlt,
mcnlsx,
mcnlsy,
mcnlsz,
mcnlp)

  /* TRACE Component Collimator_gad [114] */
  mccoordschange(mcposrCollimator_gad, mcrotrCollimator_gad,
    &mcnlx,
    &mcnly,
    &mcnlz,
    &mcnlvx,
    &mcnlvy,
    &mcnlvz,
    &mcnlsx,
    &mcnlsy,
    &mcnlsz);
  /* define label inside component Collimator_gad (without coords transformations) */
  mcJumpTrace_Collimator_gad:
  SIG_MESSAGE("Collimator_gad (Trace)");
  mcDEBUG_COMP("Collimator_gad")
  mcDEBUG_STATE(
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp)
#define x mcnlx
#define y mcnly
#define z mcnlz
#define vx mcnlvx
#define vy mcnlvy
#define vz mcnlvz
#define t mcnlt
#define sx mcnlsx
#define sy mcnlsy
#define sz mcnlsz
#define p mcnlp

#define mcabsorbComp mcabsorbCompCollimator_gad
  STORE_NEUTRON(114,
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp);
  mcScattered=0;
  mcRestore=0;
  mcNCounter[114]++;
  mcPCounter[114] += p;
  mcP2Counter[114] += p*p;
#define mccompcurname  Collimator_gad
#define mccompcurtype  Union_make_material
#define mccompcurindex 114
#define loop_index mccCollimator_gad_loop_index
#define this_material mccCollimator_gad_this_material
#define accepted_processes mccCollimator_gad_accepted_processes
#define global_material_element mccCollimator_gad_global_material_element
{   /* Declarations of Collimator_gad=Union_make_material() SETTING parameters. */
char* process_string = mccCollimator_gad_process_string;
MCNUM my_absorption = mccCollimator_gad_my_absorption;
MCNUM absorber = mccCollimator_gad_absorber;
}   /* End of Collimator_gad=Union_make_material() SETTING parameter declarations. */
#undef global_material_element
#undef accepted_processes
#undef this_material
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex
  /* Label for restoring  neutron */
  mcabsorbCompCollimator_gad:
  if (RESTORE) /* restore if needed */
  { RESTORE_NEUTRON(114,
      mcnlx,
      mcnly,
      mcnlz,
      mcnlvx,
      mcnlvy,
      mcnlvz,
      mcnlt,
      mcnlsx,
      mcnlsy,
      mcnlsz,
      mcnlp); }
#undef mcabsorbComp
#undef p
#undef sz
#undef sy
#undef sx
#undef t
#undef vz
#undef vy
#undef vx
#undef z
#undef y
#undef x
  mcDEBUG_STATE(
mcnlx,
mcnly,
mcnlz,
mcnlvx,
mcnlvy,
mcnlvz,
mcnlt,
mcnlsx,
mcnlsy,
mcnlsz,
mcnlp)

  /* TRACE Component Incoherent_PG_analyzer [115] */
  mccoordschange(mcposrIncoherent_PG_analyzer, mcrotrIncoherent_PG_analyzer,
    &mcnlx,
    &mcnly,
    &mcnlz,
    &mcnlvx,
    &mcnlvy,
    &mcnlvz,
    &mcnlsx,
    &mcnlsy,
    &mcnlsz);
  /* define label inside component Incoherent_PG_analyzer (without coords transformations) */
  mcJumpTrace_Incoherent_PG_analyzer:
  SIG_MESSAGE("Incoherent_PG_analyzer (Trace)");
  mcDEBUG_COMP("Incoherent_PG_analyzer")
  mcDEBUG_STATE(
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp)
#define x mcnlx
#define y mcnly
#define z mcnlz
#define vx mcnlvx
#define vy mcnlvy
#define vz mcnlvz
#define t mcnlt
#define sx mcnlsx
#define sy mcnlsy
#define sz mcnlsz
#define p mcnlp

#define mcabsorbComp mcabsorbCompIncoherent_PG_analyzer
  STORE_NEUTRON(115,
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp);
  mcScattered=0;
  mcRestore=0;
  mcNCounter[115]++;
  mcPCounter[115] += p;
  mcP2Counter[115] += p*p;
#define mccompcurname  Incoherent_PG_analyzer
#define mccompcurtype  Incoherent_process
#define mccompcurindex 115
#define This_process mccIncoherent_PG_analyzer_This_process
#define Incoherent_storage mccIncoherent_PG_analyzer_Incoherent_storage
#define effective_my_scattering mccIncoherent_PG_analyzer_effective_my_scattering
{   /* Declarations of Incoherent_PG_analyzer=Incoherent_process() SETTING parameters. */
MCNUM sigma = mccIncoherent_PG_analyzer_sigma;
MCNUM f_QE = mccIncoherent_PG_analyzer_f_QE;
MCNUM gamma = mccIncoherent_PG_analyzer_gamma;
MCNUM packing_factor = mccIncoherent_PG_analyzer_packing_factor;
MCNUM unit_cell_volume = mccIncoherent_PG_analyzer_unit_cell_volume;
MCNUM interact_fraction = mccIncoherent_PG_analyzer_interact_fraction;
}   /* End of Incoherent_PG_analyzer=Incoherent_process() SETTING parameter declarations. */
#undef effective_my_scattering
#undef Incoherent_storage
#undef This_process
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex
  /* Label for restoring  neutron */
  mcabsorbCompIncoherent_PG_analyzer:
  if (RESTORE) /* restore if needed */
  { RESTORE_NEUTRON(115,
      mcnlx,
      mcnly,
      mcnlz,
      mcnlvx,
      mcnlvy,
      mcnlvz,
      mcnlt,
      mcnlsx,
      mcnlsy,
      mcnlsz,
      mcnlp); }
#undef mcabsorbComp
#undef p
#undef sz
#undef sy
#undef sx
#undef t
#undef vz
#undef vy
#undef vx
#undef z
#undef y
#undef x
  mcDEBUG_STATE(
mcnlx,
mcnly,
mcnlz,
mcnlvx,
mcnlvy,
mcnlvz,
mcnlt,
mcnlsx,
mcnlsy,
mcnlsz,
mcnlp)

  /* TRACE Component Single_crystal_PG_analyzer [116] */
  mccoordschange(mcposrSingle_crystal_PG_analyzer, mcrotrSingle_crystal_PG_analyzer,
    &mcnlx,
    &mcnly,
    &mcnlz,
    &mcnlvx,
    &mcnlvy,
    &mcnlvz,
    &mcnlsx,
    &mcnlsy,
    &mcnlsz);
  /* define label inside component Single_crystal_PG_analyzer (without coords transformations) */
  mcJumpTrace_Single_crystal_PG_analyzer:
  SIG_MESSAGE("Single_crystal_PG_analyzer (Trace)");
  mcDEBUG_COMP("Single_crystal_PG_analyzer")
  mcDEBUG_STATE(
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp)
#define x mcnlx
#define y mcnly
#define z mcnlz
#define vx mcnlvx
#define vy mcnlvy
#define vz mcnlvz
#define t mcnlt
#define sx mcnlsx
#define sy mcnlsy
#define sz mcnlsz
#define p mcnlp

#define mcabsorbComp mcabsorbCompSingle_crystal_PG_analyzer
  STORE_NEUTRON(116,
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp);
  mcScattered=0;
  mcRestore=0;
  mcNCounter[116]++;
  mcPCounter[116] += p;
  mcP2Counter[116] += p*p;
#define mccompcurname  Single_crystal_PG_analyzer
#define mccompcurtype  Single_crystal_process
#define mccompcurindex 116
#define mosaic_AB mccSingle_crystal_PG_analyzer_mosaic_AB
#define This_process mccSingle_crystal_PG_analyzer_This_process
#define Single_crystal_storage mccSingle_crystal_PG_analyzer_Single_crystal_storage
#define effective_my_scattering mccSingle_crystal_PG_analyzer_effective_my_scattering
#define hkl_info_union mccSingle_crystal_PG_analyzer_hkl_info_union
#define packing_factor mccSingle_crystal_PG_analyzer_packing_factor
{   /* Declarations of Single_crystal_PG_analyzer=Single_crystal_process() SETTING parameters. */
char* reflections = mccSingle_crystal_PG_analyzer_reflections;
MCNUM delta_d_d = mccSingle_crystal_PG_analyzer_delta_d_d;
MCNUM mosaic = mccSingle_crystal_PG_analyzer_mosaic;
MCNUM mosaic_a = mccSingle_crystal_PG_analyzer_mosaic_a;
MCNUM mosaic_b = mccSingle_crystal_PG_analyzer_mosaic_b;
MCNUM mosaic_c = mccSingle_crystal_PG_analyzer_mosaic_c;
MCNUM recip_cell = mccSingle_crystal_PG_analyzer_recip_cell;
MCNUM barns = mccSingle_crystal_PG_analyzer_barns;
MCNUM ax = mccSingle_crystal_PG_analyzer_ax;
MCNUM ay = mccSingle_crystal_PG_analyzer_ay;
MCNUM az = mccSingle_crystal_PG_analyzer_az;
MCNUM bx = mccSingle_crystal_PG_analyzer_bx;
MCNUM by = mccSingle_crystal_PG_analyzer_by;
MCNUM bz = mccSingle_crystal_PG_analyzer_bz;
MCNUM cx = mccSingle_crystal_PG_analyzer_cx;
MCNUM cy = mccSingle_crystal_PG_analyzer_cy;
MCNUM cz = mccSingle_crystal_PG_analyzer_cz;
MCNUM aa = mccSingle_crystal_PG_analyzer_aa;
MCNUM bb = mccSingle_crystal_PG_analyzer_bb;
MCNUM cc = mccSingle_crystal_PG_analyzer_cc;
MCNUM order = mccSingle_crystal_PG_analyzer_order;
MCNUM RX = mccSingle_crystal_PG_analyzer_RX;
MCNUM RY = mccSingle_crystal_PG_analyzer_RY;
MCNUM RZ = mccSingle_crystal_PG_analyzer_RZ;
MCNUM powder = mccSingle_crystal_PG_analyzer_powder;
MCNUM PG = mccSingle_crystal_PG_analyzer_PG;
MCNUM interact_fraction = mccSingle_crystal_PG_analyzer_interact_fraction;
MCNUM packing_factor = mccSingle_crystal_PG_analyzer_packing_factor;
#line 1069 "Single_crystal_process.comp"
{
    // Trace should be empty, the simulation is done in Union_master
}
#line 361656 "MACS_sample_kidney_box.c"
}   /* End of Single_crystal_PG_analyzer=Single_crystal_process() SETTING parameter declarations. */
#undef packing_factor
#undef hkl_info_union
#undef effective_my_scattering
#undef Single_crystal_storage
#undef This_process
#undef mosaic_AB
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex
  /* Label for restoring  neutron */
  mcabsorbCompSingle_crystal_PG_analyzer:
  if (RESTORE) /* restore if needed */
  { RESTORE_NEUTRON(116,
      mcnlx,
      mcnly,
      mcnlz,
      mcnlvx,
      mcnlvy,
      mcnlvz,
      mcnlt,
      mcnlsx,
      mcnlsy,
      mcnlsz,
      mcnlp); }
#undef mcabsorbComp
#undef p
#undef sz
#undef sy
#undef sx
#undef t
#undef vz
#undef vy
#undef vx
#undef z
#undef y
#undef x
  mcDEBUG_STATE(
mcnlx,
mcnly,
mcnlz,
mcnlvx,
mcnlvy,
mcnlvz,
mcnlt,
mcnlsx,
mcnlsy,
mcnlsz,
mcnlp)

  /* TRACE Component PG_analyzer [117] */
  mccoordschange(mcposrPG_analyzer, mcrotrPG_analyzer,
    &mcnlx,
    &mcnly,
    &mcnlz,
    &mcnlvx,
    &mcnlvy,
    &mcnlvz,
    &mcnlsx,
    &mcnlsy,
    &mcnlsz);
  /* define label inside component PG_analyzer (without coords transformations) */
  mcJumpTrace_PG_analyzer:
  SIG_MESSAGE("PG_analyzer (Trace)");
  mcDEBUG_COMP("PG_analyzer")
  mcDEBUG_STATE(
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp)
#define x mcnlx
#define y mcnly
#define z mcnlz
#define vx mcnlvx
#define vy mcnlvy
#define vz mcnlvz
#define t mcnlt
#define sx mcnlsx
#define sy mcnlsy
#define sz mcnlsz
#define p mcnlp

#define mcabsorbComp mcabsorbCompPG_analyzer
  STORE_NEUTRON(117,
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp);
  mcScattered=0;
  mcRestore=0;
  mcNCounter[117]++;
  mcPCounter[117] += p;
  mcP2Counter[117] += p*p;
#define mccompcurname  PG_analyzer
#define mccompcurtype  Union_make_material
#define mccompcurindex 117
#define loop_index mccPG_analyzer_loop_index
#define this_material mccPG_analyzer_this_material
#define accepted_processes mccPG_analyzer_accepted_processes
#define global_material_element mccPG_analyzer_global_material_element
{   /* Declarations of PG_analyzer=Union_make_material() SETTING parameters. */
char* process_string = mccPG_analyzer_process_string;
MCNUM my_absorption = mccPG_analyzer_my_absorption;
MCNUM absorber = mccPG_analyzer_absorber;
}   /* End of PG_analyzer=Union_make_material() SETTING parameter declarations. */
#undef global_material_element
#undef accepted_processes
#undef this_material
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex
  /* Label for restoring  neutron */
  mcabsorbCompPG_analyzer:
  if (RESTORE) /* restore if needed */
  { RESTORE_NEUTRON(117,
      mcnlx,
      mcnly,
      mcnlz,
      mcnlvx,
      mcnlvy,
      mcnlvz,
      mcnlt,
      mcnlsx,
      mcnlsy,
      mcnlsz,
      mcnlp); }
#undef mcabsorbComp
#undef p
#undef sz
#undef sy
#undef sx
#undef t
#undef vz
#undef vy
#undef vx
#undef z
#undef y
#undef x
  mcDEBUG_STATE(
mcnlx,
mcnly,
mcnlz,
mcnlvx,
mcnlvy,
mcnlvz,
mcnlt,
mcnlsx,
mcnlsy,
mcnlsz,
mcnlp)

  /* TRACE Component kidney_hull [118] */
  mccoordschange(mcposrkidney_hull, mcrotrkidney_hull,
    &mcnlx,
    &mcnly,
    &mcnlz,
    &mcnlvx,
    &mcnlvy,
    &mcnlvz,
    &mcnlsx,
    &mcnlsy,
    &mcnlsz);
  /* define label inside component kidney_hull (without coords transformations) */
  mcJumpTrace_kidney_hull:
  SIG_MESSAGE("kidney_hull (Trace)");
  mcDEBUG_COMP("kidney_hull")
  mcDEBUG_STATE(
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp)
#define x mcnlx
#define y mcnly
#define z mcnlz
#define vx mcnlvx
#define vy mcnlvy
#define vz mcnlvz
#define t mcnlt
#define sx mcnlsx
#define sy mcnlsy
#define sz mcnlsz
#define p mcnlp

#define mcabsorbComp mcabsorbCompkidney_hull
  STORE_NEUTRON(118,
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp);
  mcScattered=0;
  mcRestore=0;
  mcNCounter[118]++;
  mcPCounter[118] += p;
  mcP2Counter[118] += p*p;
#define mccompcurname  kidney_hull
#define mccompcurtype  Union_cylinder
#define mccompcurindex 118
#define loop_index mcckidney_hull_loop_index
#define this_cylinder_volume mcckidney_hull_this_cylinder_volume
#define global_geometry_element mcckidney_hull_global_geometry_element
#define this_cylinder_storage mcckidney_hull_this_cylinder_storage
{   /* Declarations of kidney_hull=Union_cylinder() SETTING parameters. */
char* material_string = mcckidney_hull_material_string;
MCNUM priority = mcckidney_hull_priority;
MCNUM radius = mcckidney_hull_radius;
MCNUM yheight = mcckidney_hull_yheight;
MCNUM visualize = mcckidney_hull_visualize;
int target_index = mcckidney_hull_target_index;
MCNUM target_x = mcckidney_hull_target_x;
MCNUM target_y = mcckidney_hull_target_y;
MCNUM target_z = mcckidney_hull_target_z;
MCNUM focus_aw = mcckidney_hull_focus_aw;
MCNUM focus_ah = mcckidney_hull_focus_ah;
MCNUM focus_xw = mcckidney_hull_focus_xw;
MCNUM focus_xh = mcckidney_hull_focus_xh;
MCNUM focus_r = mcckidney_hull_focus_r;
MCNUM p_interact = mcckidney_hull_p_interact;
char* mask_string = mcckidney_hull_mask_string;
char* mask_setting = mcckidney_hull_mask_setting;
MCNUM number_of_activations = mcckidney_hull_number_of_activations;
#line 345 "Union_cylinder.comp"
{
dummy = 1;
}
#line 361910 "MACS_sample_kidney_box.c"
}   /* End of kidney_hull=Union_cylinder() SETTING parameter declarations. */
#undef this_cylinder_storage
#undef global_geometry_element
#undef this_cylinder_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex
  /* Label for restoring  neutron */
  mcabsorbCompkidney_hull:
  if (RESTORE) /* restore if needed */
  { RESTORE_NEUTRON(118,
      mcnlx,
      mcnly,
      mcnlz,
      mcnlvx,
      mcnlvy,
      mcnlvz,
      mcnlt,
      mcnlsx,
      mcnlsy,
      mcnlsz,
      mcnlp); }
#undef mcabsorbComp
#undef p
#undef sz
#undef sy
#undef sx
#undef t
#undef vz
#undef vy
#undef vx
#undef z
#undef y
#undef x
  mcDEBUG_STATE(
mcnlx,
mcnly,
mcnlz,
mcnlvx,
mcnlvy,
mcnlvz,
mcnlt,
mcnlsx,
mcnlsy,
mcnlsz,
mcnlp)

  /* TRACE Component kidney_hull_cut [119] */
  mccoordschange(mcposrkidney_hull_cut, mcrotrkidney_hull_cut,
    &mcnlx,
    &mcnly,
    &mcnlz,
    &mcnlvx,
    &mcnlvy,
    &mcnlvz,
    &mcnlsx,
    &mcnlsy,
    &mcnlsz);
  /* define label inside component kidney_hull_cut (without coords transformations) */
  mcJumpTrace_kidney_hull_cut:
  SIG_MESSAGE("kidney_hull_cut (Trace)");
  mcDEBUG_COMP("kidney_hull_cut")
  mcDEBUG_STATE(
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp)
#define x mcnlx
#define y mcnly
#define z mcnlz
#define vx mcnlvx
#define vy mcnlvy
#define vz mcnlvz
#define t mcnlt
#define sx mcnlsx
#define sy mcnlsy
#define sz mcnlsz
#define p mcnlp

#define mcabsorbComp mcabsorbCompkidney_hull_cut
  STORE_NEUTRON(119,
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp);
  mcScattered=0;
  mcRestore=0;
  mcNCounter[119]++;
  mcPCounter[119] += p;
  mcP2Counter[119] += p*p;
#define mccompcurname  kidney_hull_cut
#define mccompcurtype  Union_cylinder
#define mccompcurindex 119
#define loop_index mcckidney_hull_cut_loop_index
#define this_cylinder_volume mcckidney_hull_cut_this_cylinder_volume
#define global_geometry_element mcckidney_hull_cut_global_geometry_element
#define this_cylinder_storage mcckidney_hull_cut_this_cylinder_storage
{   /* Declarations of kidney_hull_cut=Union_cylinder() SETTING parameters. */
char* material_string = mcckidney_hull_cut_material_string;
MCNUM priority = mcckidney_hull_cut_priority;
MCNUM radius = mcckidney_hull_cut_radius;
MCNUM yheight = mcckidney_hull_cut_yheight;
MCNUM visualize = mcckidney_hull_cut_visualize;
int target_index = mcckidney_hull_cut_target_index;
MCNUM target_x = mcckidney_hull_cut_target_x;
MCNUM target_y = mcckidney_hull_cut_target_y;
MCNUM target_z = mcckidney_hull_cut_target_z;
MCNUM focus_aw = mcckidney_hull_cut_focus_aw;
MCNUM focus_ah = mcckidney_hull_cut_focus_ah;
MCNUM focus_xw = mcckidney_hull_cut_focus_xw;
MCNUM focus_xh = mcckidney_hull_cut_focus_xh;
MCNUM focus_r = mcckidney_hull_cut_focus_r;
MCNUM p_interact = mcckidney_hull_cut_p_interact;
char* mask_string = mcckidney_hull_cut_mask_string;
char* mask_setting = mcckidney_hull_cut_mask_setting;
MCNUM number_of_activations = mcckidney_hull_cut_number_of_activations;
#line 345 "Union_cylinder.comp"
{
dummy = 1;
}
#line 362046 "MACS_sample_kidney_box.c"
}   /* End of kidney_hull_cut=Union_cylinder() SETTING parameter declarations. */
#undef this_cylinder_storage
#undef global_geometry_element
#undef this_cylinder_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex
  /* Label for restoring  neutron */
  mcabsorbCompkidney_hull_cut:
  if (RESTORE) /* restore if needed */
  { RESTORE_NEUTRON(119,
      mcnlx,
      mcnly,
      mcnlz,
      mcnlvx,
      mcnlvy,
      mcnlvz,
      mcnlt,
      mcnlsx,
      mcnlsy,
      mcnlsz,
      mcnlp); }
#undef mcabsorbComp
#undef p
#undef sz
#undef sy
#undef sx
#undef t
#undef vz
#undef vy
#undef vx
#undef z
#undef y
#undef x
  mcDEBUG_STATE(
mcnlx,
mcnly,
mcnlz,
mcnlvx,
mcnlvy,
mcnlvz,
mcnlt,
mcnlsx,
mcnlsy,
mcnlsz,
mcnlp)

  /* TRACE Component kidney_hull_box_cut_arm1 [120] */
  mccoordschange(mcposrkidney_hull_box_cut_arm1, mcrotrkidney_hull_box_cut_arm1,
    &mcnlx,
    &mcnly,
    &mcnlz,
    &mcnlvx,
    &mcnlvy,
    &mcnlvz,
    &mcnlsx,
    &mcnlsy,
    &mcnlsz);
  /* define label inside component kidney_hull_box_cut_arm1 (without coords transformations) */
  mcJumpTrace_kidney_hull_box_cut_arm1:
  SIG_MESSAGE("kidney_hull_box_cut_arm1 (Trace)");
  mcDEBUG_COMP("kidney_hull_box_cut_arm1")
  mcDEBUG_STATE(
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp)
#define x mcnlx
#define y mcnly
#define z mcnlz
#define vx mcnlvx
#define vy mcnlvy
#define vz mcnlvz
#define t mcnlt
#define sx mcnlsx
#define sy mcnlsy
#define sz mcnlsz
#define p mcnlp

#define mcabsorbComp mcabsorbCompkidney_hull_box_cut_arm1
  STORE_NEUTRON(120,
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp);
  mcScattered=0;
  mcRestore=0;
  mcNCounter[120]++;
  mcPCounter[120] += p;
  mcP2Counter[120] += p*p;
#define mccompcurname  kidney_hull_box_cut_arm1
#define mccompcurtype  Arm
#define mccompcurindex 120
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex
  /* Label for restoring  neutron */
  mcabsorbCompkidney_hull_box_cut_arm1:
  if (RESTORE) /* restore if needed */
  { RESTORE_NEUTRON(120,
      mcnlx,
      mcnly,
      mcnlz,
      mcnlvx,
      mcnlvy,
      mcnlvz,
      mcnlt,
      mcnlsx,
      mcnlsy,
      mcnlsz,
      mcnlp); }
#undef mcabsorbComp
#undef p
#undef sz
#undef sy
#undef sx
#undef t
#undef vz
#undef vy
#undef vx
#undef z
#undef y
#undef x
  mcDEBUG_STATE(
mcnlx,
mcnly,
mcnlz,
mcnlvx,
mcnlvy,
mcnlvz,
mcnlt,
mcnlsx,
mcnlsy,
mcnlsz,
mcnlp)

  /* TRACE Component kidney_hull_box_cut1 [121] */
  mccoordschange(mcposrkidney_hull_box_cut1, mcrotrkidney_hull_box_cut1,
    &mcnlx,
    &mcnly,
    &mcnlz,
    &mcnlvx,
    &mcnlvy,
    &mcnlvz,
    &mcnlsx,
    &mcnlsy,
    &mcnlsz);
  /* define label inside component kidney_hull_box_cut1 (without coords transformations) */
  mcJumpTrace_kidney_hull_box_cut1:
  SIG_MESSAGE("kidney_hull_box_cut1 (Trace)");
  mcDEBUG_COMP("kidney_hull_box_cut1")
  mcDEBUG_STATE(
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp)
#define x mcnlx
#define y mcnly
#define z mcnlz
#define vx mcnlvx
#define vy mcnlvy
#define vz mcnlvz
#define t mcnlt
#define sx mcnlsx
#define sy mcnlsy
#define sz mcnlsz
#define p mcnlp

#define mcabsorbComp mcabsorbCompkidney_hull_box_cut1
  STORE_NEUTRON(121,
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp);
  mcScattered=0;
  mcRestore=0;
  mcNCounter[121]++;
  mcPCounter[121] += p;
  mcP2Counter[121] += p*p;
#define mccompcurname  kidney_hull_box_cut1
#define mccompcurtype  Union_box
#define mccompcurindex 121
#define loop_index mcckidney_hull_box_cut1_loop_index
#define this_box_volume mcckidney_hull_box_cut1_this_box_volume
#define global_geometry_element mcckidney_hull_box_cut1_global_geometry_element
#define this_box_storage mcckidney_hull_box_cut1_this_box_storage
{   /* Declarations of kidney_hull_box_cut1=Union_box() SETTING parameters. */
char* material_string = mcckidney_hull_box_cut1_material_string;
MCNUM priority = mcckidney_hull_box_cut1_priority;
MCNUM xwidth = mcckidney_hull_box_cut1_xwidth;
MCNUM yheight = mcckidney_hull_box_cut1_yheight;
MCNUM zdepth = mcckidney_hull_box_cut1_zdepth;
MCNUM xwidth2 = mcckidney_hull_box_cut1_xwidth2;
MCNUM yheight2 = mcckidney_hull_box_cut1_yheight2;
MCNUM visualize = mcckidney_hull_box_cut1_visualize;
int target_index = mcckidney_hull_box_cut1_target_index;
MCNUM target_x = mcckidney_hull_box_cut1_target_x;
MCNUM target_y = mcckidney_hull_box_cut1_target_y;
MCNUM target_z = mcckidney_hull_box_cut1_target_z;
MCNUM focus_aw = mcckidney_hull_box_cut1_focus_aw;
MCNUM focus_ah = mcckidney_hull_box_cut1_focus_ah;
MCNUM focus_xw = mcckidney_hull_box_cut1_focus_xw;
MCNUM focus_xh = mcckidney_hull_box_cut1_focus_xh;
MCNUM focus_r = mcckidney_hull_box_cut1_focus_r;
MCNUM p_interact = mcckidney_hull_box_cut1_p_interact;
char* mask_string = mcckidney_hull_box_cut1_mask_string;
char* mask_setting = mcckidney_hull_box_cut1_mask_setting;
MCNUM number_of_activations = mcckidney_hull_box_cut1_number_of_activations;
}   /* End of kidney_hull_box_cut1=Union_box() SETTING parameter declarations. */
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex
  /* Label for restoring  neutron */
  mcabsorbCompkidney_hull_box_cut1:
  if (RESTORE) /* restore if needed */
  { RESTORE_NEUTRON(121,
      mcnlx,
      mcnly,
      mcnlz,
      mcnlvx,
      mcnlvy,
      mcnlvz,
      mcnlt,
      mcnlsx,
      mcnlsy,
      mcnlsz,
      mcnlp); }
#undef mcabsorbComp
#undef p
#undef sz
#undef sy
#undef sx
#undef t
#undef vz
#undef vy
#undef vx
#undef z
#undef y
#undef x
  mcDEBUG_STATE(
mcnlx,
mcnly,
mcnlz,
mcnlvx,
mcnlvy,
mcnlvz,
mcnlt,
mcnlsx,
mcnlsy,
mcnlsz,
mcnlp)

  /* TRACE Component kidney_hull_box_cut_arm2 [122] */
  mccoordschange(mcposrkidney_hull_box_cut_arm2, mcrotrkidney_hull_box_cut_arm2,
    &mcnlx,
    &mcnly,
    &mcnlz,
    &mcnlvx,
    &mcnlvy,
    &mcnlvz,
    &mcnlsx,
    &mcnlsy,
    &mcnlsz);
  /* define label inside component kidney_hull_box_cut_arm2 (without coords transformations) */
  mcJumpTrace_kidney_hull_box_cut_arm2:
  SIG_MESSAGE("kidney_hull_box_cut_arm2 (Trace)");
  mcDEBUG_COMP("kidney_hull_box_cut_arm2")
  mcDEBUG_STATE(
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp)
#define x mcnlx
#define y mcnly
#define z mcnlz
#define vx mcnlvx
#define vy mcnlvy
#define vz mcnlvz
#define t mcnlt
#define sx mcnlsx
#define sy mcnlsy
#define sz mcnlsz
#define p mcnlp

#define mcabsorbComp mcabsorbCompkidney_hull_box_cut_arm2
  STORE_NEUTRON(122,
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp);
  mcScattered=0;
  mcRestore=0;
  mcNCounter[122]++;
  mcPCounter[122] += p;
  mcP2Counter[122] += p*p;
#define mccompcurname  kidney_hull_box_cut_arm2
#define mccompcurtype  Arm
#define mccompcurindex 122
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex
  /* Label for restoring  neutron */
  mcabsorbCompkidney_hull_box_cut_arm2:
  if (RESTORE) /* restore if needed */
  { RESTORE_NEUTRON(122,
      mcnlx,
      mcnly,
      mcnlz,
      mcnlvx,
      mcnlvy,
      mcnlvz,
      mcnlt,
      mcnlsx,
      mcnlsy,
      mcnlsz,
      mcnlp); }
#undef mcabsorbComp
#undef p
#undef sz
#undef sy
#undef sx
#undef t
#undef vz
#undef vy
#undef vx
#undef z
#undef y
#undef x
  mcDEBUG_STATE(
mcnlx,
mcnly,
mcnlz,
mcnlvx,
mcnlvy,
mcnlvz,
mcnlt,
mcnlsx,
mcnlsy,
mcnlsz,
mcnlp)

  /* TRACE Component kidney_hull_box_cut2 [123] */
  mccoordschange(mcposrkidney_hull_box_cut2, mcrotrkidney_hull_box_cut2,
    &mcnlx,
    &mcnly,
    &mcnlz,
    &mcnlvx,
    &mcnlvy,
    &mcnlvz,
    &mcnlsx,
    &mcnlsy,
    &mcnlsz);
  /* define label inside component kidney_hull_box_cut2 (without coords transformations) */
  mcJumpTrace_kidney_hull_box_cut2:
  SIG_MESSAGE("kidney_hull_box_cut2 (Trace)");
  mcDEBUG_COMP("kidney_hull_box_cut2")
  mcDEBUG_STATE(
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp)
#define x mcnlx
#define y mcnly
#define z mcnlz
#define vx mcnlvx
#define vy mcnlvy
#define vz mcnlvz
#define t mcnlt
#define sx mcnlsx
#define sy mcnlsy
#define sz mcnlsz
#define p mcnlp

#define mcabsorbComp mcabsorbCompkidney_hull_box_cut2
  STORE_NEUTRON(123,
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp);
  mcScattered=0;
  mcRestore=0;
  mcNCounter[123]++;
  mcPCounter[123] += p;
  mcP2Counter[123] += p*p;
#define mccompcurname  kidney_hull_box_cut2
#define mccompcurtype  Union_box
#define mccompcurindex 123
#define loop_index mcckidney_hull_box_cut2_loop_index
#define this_box_volume mcckidney_hull_box_cut2_this_box_volume
#define global_geometry_element mcckidney_hull_box_cut2_global_geometry_element
#define this_box_storage mcckidney_hull_box_cut2_this_box_storage
{   /* Declarations of kidney_hull_box_cut2=Union_box() SETTING parameters. */
char* material_string = mcckidney_hull_box_cut2_material_string;
MCNUM priority = mcckidney_hull_box_cut2_priority;
MCNUM xwidth = mcckidney_hull_box_cut2_xwidth;
MCNUM yheight = mcckidney_hull_box_cut2_yheight;
MCNUM zdepth = mcckidney_hull_box_cut2_zdepth;
MCNUM xwidth2 = mcckidney_hull_box_cut2_xwidth2;
MCNUM yheight2 = mcckidney_hull_box_cut2_yheight2;
MCNUM visualize = mcckidney_hull_box_cut2_visualize;
int target_index = mcckidney_hull_box_cut2_target_index;
MCNUM target_x = mcckidney_hull_box_cut2_target_x;
MCNUM target_y = mcckidney_hull_box_cut2_target_y;
MCNUM target_z = mcckidney_hull_box_cut2_target_z;
MCNUM focus_aw = mcckidney_hull_box_cut2_focus_aw;
MCNUM focus_ah = mcckidney_hull_box_cut2_focus_ah;
MCNUM focus_xw = mcckidney_hull_box_cut2_focus_xw;
MCNUM focus_xh = mcckidney_hull_box_cut2_focus_xh;
MCNUM focus_r = mcckidney_hull_box_cut2_focus_r;
MCNUM p_interact = mcckidney_hull_box_cut2_p_interact;
char* mask_string = mcckidney_hull_box_cut2_mask_string;
char* mask_setting = mcckidney_hull_box_cut2_mask_setting;
MCNUM number_of_activations = mcckidney_hull_box_cut2_number_of_activations;
}   /* End of kidney_hull_box_cut2=Union_box() SETTING parameter declarations. */
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex
  /* Label for restoring  neutron */
  mcabsorbCompkidney_hull_box_cut2:
  if (RESTORE) /* restore if needed */
  { RESTORE_NEUTRON(123,
      mcnlx,
      mcnly,
      mcnlz,
      mcnlvx,
      mcnlvy,
      mcnlvz,
      mcnlt,
      mcnlsx,
      mcnlsy,
      mcnlsz,
      mcnlp); }
#undef mcabsorbComp
#undef p
#undef sz
#undef sy
#undef sx
#undef t
#undef vz
#undef vy
#undef vx
#undef z
#undef y
#undef x
  mcDEBUG_STATE(
mcnlx,
mcnly,
mcnlz,
mcnlvx,
mcnlvy,
mcnlvz,
mcnlt,
mcnlsx,
mcnlsy,
mcnlsz,
mcnlp)

  /* TRACE Component channel_0_cave1_box1 [124] */
  mccoordschange(mcposrchannel_0_cave1_box1, mcrotrchannel_0_cave1_box1,
    &mcnlx,
    &mcnly,
    &mcnlz,
    &mcnlvx,
    &mcnlvy,
    &mcnlvz,
    &mcnlsx,
    &mcnlsy,
    &mcnlsz);
  /* define label inside component channel_0_cave1_box1 (without coords transformations) */
  mcJumpTrace_channel_0_cave1_box1:
  SIG_MESSAGE("channel_0_cave1_box1 (Trace)");
  mcDEBUG_COMP("channel_0_cave1_box1")
  mcDEBUG_STATE(
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp)
#define x mcnlx
#define y mcnly
#define z mcnlz
#define vx mcnlvx
#define vy mcnlvy
#define vz mcnlvz
#define t mcnlt
#define sx mcnlsx
#define sy mcnlsy
#define sz mcnlsz
#define p mcnlp

#define mcabsorbComp mcabsorbCompchannel_0_cave1_box1
  STORE_NEUTRON(124,
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp);
  mcScattered=0;
  mcRestore=0;
  mcNCounter[124]++;
  mcPCounter[124] += p;
  mcP2Counter[124] += p*p;
#define mccompcurname  channel_0_cave1_box1
#define mccompcurtype  Union_box
#define mccompcurindex 124
#define loop_index mccchannel_0_cave1_box1_loop_index
#define this_box_volume mccchannel_0_cave1_box1_this_box_volume
#define global_geometry_element mccchannel_0_cave1_box1_global_geometry_element
#define this_box_storage mccchannel_0_cave1_box1_this_box_storage
{   /* Declarations of channel_0_cave1_box1=Union_box() SETTING parameters. */
char* material_string = mccchannel_0_cave1_box1_material_string;
MCNUM priority = mccchannel_0_cave1_box1_priority;
MCNUM xwidth = mccchannel_0_cave1_box1_xwidth;
MCNUM yheight = mccchannel_0_cave1_box1_yheight;
MCNUM zdepth = mccchannel_0_cave1_box1_zdepth;
MCNUM xwidth2 = mccchannel_0_cave1_box1_xwidth2;
MCNUM yheight2 = mccchannel_0_cave1_box1_yheight2;
MCNUM visualize = mccchannel_0_cave1_box1_visualize;
int target_index = mccchannel_0_cave1_box1_target_index;
MCNUM target_x = mccchannel_0_cave1_box1_target_x;
MCNUM target_y = mccchannel_0_cave1_box1_target_y;
MCNUM target_z = mccchannel_0_cave1_box1_target_z;
MCNUM focus_aw = mccchannel_0_cave1_box1_focus_aw;
MCNUM focus_ah = mccchannel_0_cave1_box1_focus_ah;
MCNUM focus_xw = mccchannel_0_cave1_box1_focus_xw;
MCNUM focus_xh = mccchannel_0_cave1_box1_focus_xh;
MCNUM focus_r = mccchannel_0_cave1_box1_focus_r;
MCNUM p_interact = mccchannel_0_cave1_box1_p_interact;
char* mask_string = mccchannel_0_cave1_box1_mask_string;
char* mask_setting = mccchannel_0_cave1_box1_mask_setting;
MCNUM number_of_activations = mccchannel_0_cave1_box1_number_of_activations;
}   /* End of channel_0_cave1_box1=Union_box() SETTING parameter declarations. */
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex
  /* Label for restoring  neutron */
  mcabsorbCompchannel_0_cave1_box1:
  if (RESTORE) /* restore if needed */
  { RESTORE_NEUTRON(124,
      mcnlx,
      mcnly,
      mcnlz,
      mcnlvx,
      mcnlvy,
      mcnlvz,
      mcnlt,
      mcnlsx,
      mcnlsy,
      mcnlsz,
      mcnlp); }
#undef mcabsorbComp
#undef p
#undef sz
#undef sy
#undef sx
#undef t
#undef vz
#undef vy
#undef vx
#undef z
#undef y
#undef x
  mcDEBUG_STATE(
mcnlx,
mcnly,
mcnlz,
mcnlvx,
mcnlvy,
mcnlvz,
mcnlt,
mcnlsx,
mcnlsy,
mcnlsz,
mcnlp)

  /* TRACE Component channel_0_cave1_box2 [125] */
  mccoordschange(mcposrchannel_0_cave1_box2, mcrotrchannel_0_cave1_box2,
    &mcnlx,
    &mcnly,
    &mcnlz,
    &mcnlvx,
    &mcnlvy,
    &mcnlvz,
    &mcnlsx,
    &mcnlsy,
    &mcnlsz);
  /* define label inside component channel_0_cave1_box2 (without coords transformations) */
  mcJumpTrace_channel_0_cave1_box2:
  SIG_MESSAGE("channel_0_cave1_box2 (Trace)");
  mcDEBUG_COMP("channel_0_cave1_box2")
  mcDEBUG_STATE(
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp)
#define x mcnlx
#define y mcnly
#define z mcnlz
#define vx mcnlvx
#define vy mcnlvy
#define vz mcnlvz
#define t mcnlt
#define sx mcnlsx
#define sy mcnlsy
#define sz mcnlsz
#define p mcnlp

#define mcabsorbComp mcabsorbCompchannel_0_cave1_box2
  STORE_NEUTRON(125,
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp);
  mcScattered=0;
  mcRestore=0;
  mcNCounter[125]++;
  mcPCounter[125] += p;
  mcP2Counter[125] += p*p;
#define mccompcurname  channel_0_cave1_box2
#define mccompcurtype  Union_box
#define mccompcurindex 125
#define loop_index mccchannel_0_cave1_box2_loop_index
#define this_box_volume mccchannel_0_cave1_box2_this_box_volume
#define global_geometry_element mccchannel_0_cave1_box2_global_geometry_element
#define this_box_storage mccchannel_0_cave1_box2_this_box_storage
{   /* Declarations of channel_0_cave1_box2=Union_box() SETTING parameters. */
char* material_string = mccchannel_0_cave1_box2_material_string;
MCNUM priority = mccchannel_0_cave1_box2_priority;
MCNUM xwidth = mccchannel_0_cave1_box2_xwidth;
MCNUM yheight = mccchannel_0_cave1_box2_yheight;
MCNUM zdepth = mccchannel_0_cave1_box2_zdepth;
MCNUM xwidth2 = mccchannel_0_cave1_box2_xwidth2;
MCNUM yheight2 = mccchannel_0_cave1_box2_yheight2;
MCNUM visualize = mccchannel_0_cave1_box2_visualize;
int target_index = mccchannel_0_cave1_box2_target_index;
MCNUM target_x = mccchannel_0_cave1_box2_target_x;
MCNUM target_y = mccchannel_0_cave1_box2_target_y;
MCNUM target_z = mccchannel_0_cave1_box2_target_z;
MCNUM focus_aw = mccchannel_0_cave1_box2_focus_aw;
MCNUM focus_ah = mccchannel_0_cave1_box2_focus_ah;
MCNUM focus_xw = mccchannel_0_cave1_box2_focus_xw;
MCNUM focus_xh = mccchannel_0_cave1_box2_focus_xh;
MCNUM focus_r = mccchannel_0_cave1_box2_focus_r;
MCNUM p_interact = mccchannel_0_cave1_box2_p_interact;
char* mask_string = mccchannel_0_cave1_box2_mask_string;
char* mask_setting = mccchannel_0_cave1_box2_mask_setting;
MCNUM number_of_activations = mccchannel_0_cave1_box2_number_of_activations;
}   /* End of channel_0_cave1_box2=Union_box() SETTING parameter declarations. */
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex
  /* Label for restoring  neutron */
  mcabsorbCompchannel_0_cave1_box2:
  if (RESTORE) /* restore if needed */
  { RESTORE_NEUTRON(125,
      mcnlx,
      mcnly,
      mcnlz,
      mcnlvx,
      mcnlvy,
      mcnlvz,
      mcnlt,
      mcnlsx,
      mcnlsy,
      mcnlsz,
      mcnlp); }
#undef mcabsorbComp
#undef p
#undef sz
#undef sy
#undef sx
#undef t
#undef vz
#undef vy
#undef vx
#undef z
#undef y
#undef x
  mcDEBUG_STATE(
mcnlx,
mcnly,
mcnlz,
mcnlvx,
mcnlvy,
mcnlvz,
mcnlt,
mcnlsx,
mcnlsy,
mcnlsz,
mcnlp)

  /* TRACE Component channel_0_cave1_box3 [126] */
  mccoordschange(mcposrchannel_0_cave1_box3, mcrotrchannel_0_cave1_box3,
    &mcnlx,
    &mcnly,
    &mcnlz,
    &mcnlvx,
    &mcnlvy,
    &mcnlvz,
    &mcnlsx,
    &mcnlsy,
    &mcnlsz);
  /* define label inside component channel_0_cave1_box3 (without coords transformations) */
  mcJumpTrace_channel_0_cave1_box3:
  SIG_MESSAGE("channel_0_cave1_box3 (Trace)");
  mcDEBUG_COMP("channel_0_cave1_box3")
  mcDEBUG_STATE(
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp)
#define x mcnlx
#define y mcnly
#define z mcnlz
#define vx mcnlvx
#define vy mcnlvy
#define vz mcnlvz
#define t mcnlt
#define sx mcnlsx
#define sy mcnlsy
#define sz mcnlsz
#define p mcnlp

#define mcabsorbComp mcabsorbCompchannel_0_cave1_box3
  STORE_NEUTRON(126,
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp);
  mcScattered=0;
  mcRestore=0;
  mcNCounter[126]++;
  mcPCounter[126] += p;
  mcP2Counter[126] += p*p;
#define mccompcurname  channel_0_cave1_box3
#define mccompcurtype  Union_box
#define mccompcurindex 126
#define loop_index mccchannel_0_cave1_box3_loop_index
#define this_box_volume mccchannel_0_cave1_box3_this_box_volume
#define global_geometry_element mccchannel_0_cave1_box3_global_geometry_element
#define this_box_storage mccchannel_0_cave1_box3_this_box_storage
{   /* Declarations of channel_0_cave1_box3=Union_box() SETTING parameters. */
char* material_string = mccchannel_0_cave1_box3_material_string;
MCNUM priority = mccchannel_0_cave1_box3_priority;
MCNUM xwidth = mccchannel_0_cave1_box3_xwidth;
MCNUM yheight = mccchannel_0_cave1_box3_yheight;
MCNUM zdepth = mccchannel_0_cave1_box3_zdepth;
MCNUM xwidth2 = mccchannel_0_cave1_box3_xwidth2;
MCNUM yheight2 = mccchannel_0_cave1_box3_yheight2;
MCNUM visualize = mccchannel_0_cave1_box3_visualize;
int target_index = mccchannel_0_cave1_box3_target_index;
MCNUM target_x = mccchannel_0_cave1_box3_target_x;
MCNUM target_y = mccchannel_0_cave1_box3_target_y;
MCNUM target_z = mccchannel_0_cave1_box3_target_z;
MCNUM focus_aw = mccchannel_0_cave1_box3_focus_aw;
MCNUM focus_ah = mccchannel_0_cave1_box3_focus_ah;
MCNUM focus_xw = mccchannel_0_cave1_box3_focus_xw;
MCNUM focus_xh = mccchannel_0_cave1_box3_focus_xh;
MCNUM focus_r = mccchannel_0_cave1_box3_focus_r;
MCNUM p_interact = mccchannel_0_cave1_box3_p_interact;
char* mask_string = mccchannel_0_cave1_box3_mask_string;
char* mask_setting = mccchannel_0_cave1_box3_mask_setting;
MCNUM number_of_activations = mccchannel_0_cave1_box3_number_of_activations;
}   /* End of channel_0_cave1_box3=Union_box() SETTING parameter declarations. */
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex
  /* Label for restoring  neutron */
  mcabsorbCompchannel_0_cave1_box3:
  if (RESTORE) /* restore if needed */
  { RESTORE_NEUTRON(126,
      mcnlx,
      mcnly,
      mcnlz,
      mcnlvx,
      mcnlvy,
      mcnlvz,
      mcnlt,
      mcnlsx,
      mcnlsy,
      mcnlsz,
      mcnlp); }
#undef mcabsorbComp
#undef p
#undef sz
#undef sy
#undef sx
#undef t
#undef vz
#undef vy
#undef vx
#undef z
#undef y
#undef x
  mcDEBUG_STATE(
mcnlx,
mcnly,
mcnlz,
mcnlvx,
mcnlvy,
mcnlvz,
mcnlt,
mcnlsx,
mcnlsy,
mcnlsz,
mcnlp)

  /* TRACE Component channel_0_cave1_cyl1 [127] */
  mccoordschange(mcposrchannel_0_cave1_cyl1, mcrotrchannel_0_cave1_cyl1,
    &mcnlx,
    &mcnly,
    &mcnlz,
    &mcnlvx,
    &mcnlvy,
    &mcnlvz,
    &mcnlsx,
    &mcnlsy,
    &mcnlsz);
  /* define label inside component channel_0_cave1_cyl1 (without coords transformations) */
  mcJumpTrace_channel_0_cave1_cyl1:
  SIG_MESSAGE("channel_0_cave1_cyl1 (Trace)");
  mcDEBUG_COMP("channel_0_cave1_cyl1")
  mcDEBUG_STATE(
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp)
#define x mcnlx
#define y mcnly
#define z mcnlz
#define vx mcnlvx
#define vy mcnlvy
#define vz mcnlvz
#define t mcnlt
#define sx mcnlsx
#define sy mcnlsy
#define sz mcnlsz
#define p mcnlp

#define mcabsorbComp mcabsorbCompchannel_0_cave1_cyl1
  STORE_NEUTRON(127,
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp);
  mcScattered=0;
  mcRestore=0;
  mcNCounter[127]++;
  mcPCounter[127] += p;
  mcP2Counter[127] += p*p;
#define mccompcurname  channel_0_cave1_cyl1
#define mccompcurtype  Union_cylinder
#define mccompcurindex 127
#define loop_index mccchannel_0_cave1_cyl1_loop_index
#define this_cylinder_volume mccchannel_0_cave1_cyl1_this_cylinder_volume
#define global_geometry_element mccchannel_0_cave1_cyl1_global_geometry_element
#define this_cylinder_storage mccchannel_0_cave1_cyl1_this_cylinder_storage
{   /* Declarations of channel_0_cave1_cyl1=Union_cylinder() SETTING parameters. */
char* material_string = mccchannel_0_cave1_cyl1_material_string;
MCNUM priority = mccchannel_0_cave1_cyl1_priority;
MCNUM radius = mccchannel_0_cave1_cyl1_radius;
MCNUM yheight = mccchannel_0_cave1_cyl1_yheight;
MCNUM visualize = mccchannel_0_cave1_cyl1_visualize;
int target_index = mccchannel_0_cave1_cyl1_target_index;
MCNUM target_x = mccchannel_0_cave1_cyl1_target_x;
MCNUM target_y = mccchannel_0_cave1_cyl1_target_y;
MCNUM target_z = mccchannel_0_cave1_cyl1_target_z;
MCNUM focus_aw = mccchannel_0_cave1_cyl1_focus_aw;
MCNUM focus_ah = mccchannel_0_cave1_cyl1_focus_ah;
MCNUM focus_xw = mccchannel_0_cave1_cyl1_focus_xw;
MCNUM focus_xh = mccchannel_0_cave1_cyl1_focus_xh;
MCNUM focus_r = mccchannel_0_cave1_cyl1_focus_r;
MCNUM p_interact = mccchannel_0_cave1_cyl1_p_interact;
char* mask_string = mccchannel_0_cave1_cyl1_mask_string;
char* mask_setting = mccchannel_0_cave1_cyl1_mask_setting;
MCNUM number_of_activations = mccchannel_0_cave1_cyl1_number_of_activations;
#line 345 "Union_cylinder.comp"
{
dummy = 1;
}
#line 363058 "MACS_sample_kidney_box.c"
}   /* End of channel_0_cave1_cyl1=Union_cylinder() SETTING parameter declarations. */
#undef this_cylinder_storage
#undef global_geometry_element
#undef this_cylinder_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex
  /* Label for restoring  neutron */
  mcabsorbCompchannel_0_cave1_cyl1:
  if (RESTORE) /* restore if needed */
  { RESTORE_NEUTRON(127,
      mcnlx,
      mcnly,
      mcnlz,
      mcnlvx,
      mcnlvy,
      mcnlvz,
      mcnlt,
      mcnlsx,
      mcnlsy,
      mcnlsz,
      mcnlp); }
#undef mcabsorbComp
#undef p
#undef sz
#undef sy
#undef sx
#undef t
#undef vz
#undef vy
#undef vx
#undef z
#undef y
#undef x
  mcDEBUG_STATE(
mcnlx,
mcnly,
mcnlz,
mcnlvx,
mcnlvy,
mcnlvz,
mcnlt,
mcnlsx,
mcnlsy,
mcnlsz,
mcnlp)

  /* TRACE Component channel_0_analyzer_1_center [128] */
  mccoordschange(mcposrchannel_0_analyzer_1_center, mcrotrchannel_0_analyzer_1_center,
    &mcnlx,
    &mcnly,
    &mcnlz,
    &mcnlvx,
    &mcnlvy,
    &mcnlvz,
    &mcnlsx,
    &mcnlsy,
    &mcnlsz);
  /* define label inside component channel_0_analyzer_1_center (without coords transformations) */
  mcJumpTrace_channel_0_analyzer_1_center:
  SIG_MESSAGE("channel_0_analyzer_1_center (Trace)");
  mcDEBUG_COMP("channel_0_analyzer_1_center")
  mcDEBUG_STATE(
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp)
#define x mcnlx
#define y mcnly
#define z mcnlz
#define vx mcnlvx
#define vy mcnlvy
#define vz mcnlvz
#define t mcnlt
#define sx mcnlsx
#define sy mcnlsy
#define sz mcnlsz
#define p mcnlp

#define mcabsorbComp mcabsorbCompchannel_0_analyzer_1_center
  STORE_NEUTRON(128,
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp);
  mcScattered=0;
  mcRestore=0;
  mcNCounter[128]++;
  mcPCounter[128] += p;
  mcP2Counter[128] += p*p;
#define mccompcurname  channel_0_analyzer_1_center
#define mccompcurtype  Arm
#define mccompcurindex 128
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex
  /* Label for restoring  neutron */
  mcabsorbCompchannel_0_analyzer_1_center:
  if (RESTORE) /* restore if needed */
  { RESTORE_NEUTRON(128,
      mcnlx,
      mcnly,
      mcnlz,
      mcnlvx,
      mcnlvy,
      mcnlvz,
      mcnlt,
      mcnlsx,
      mcnlsy,
      mcnlsz,
      mcnlp); }
#undef mcabsorbComp
#undef p
#undef sz
#undef sy
#undef sx
#undef t
#undef vz
#undef vy
#undef vx
#undef z
#undef y
#undef x
  mcDEBUG_STATE(
mcnlx,
mcnly,
mcnlz,
mcnlvx,
mcnlvy,
mcnlvz,
mcnlt,
mcnlsx,
mcnlsy,
mcnlsz,
mcnlp)

  /* TRACE Component channel_0_analyzer_1_rotated [129] */
  mccoordschange(mcposrchannel_0_analyzer_1_rotated, mcrotrchannel_0_analyzer_1_rotated,
    &mcnlx,
    &mcnly,
    &mcnlz,
    &mcnlvx,
    &mcnlvy,
    &mcnlvz,
    &mcnlsx,
    &mcnlsy,
    &mcnlsz);
  /* define label inside component channel_0_analyzer_1_rotated (without coords transformations) */
  mcJumpTrace_channel_0_analyzer_1_rotated:
  SIG_MESSAGE("channel_0_analyzer_1_rotated (Trace)");
  mcDEBUG_COMP("channel_0_analyzer_1_rotated")
  mcDEBUG_STATE(
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp)
#define x mcnlx
#define y mcnly
#define z mcnlz
#define vx mcnlvx
#define vy mcnlvy
#define vz mcnlvz
#define t mcnlt
#define sx mcnlsx
#define sy mcnlsy
#define sz mcnlsz
#define p mcnlp

#define mcabsorbComp mcabsorbCompchannel_0_analyzer_1_rotated
  STORE_NEUTRON(129,
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp);
  mcScattered=0;
  mcRestore=0;
  mcNCounter[129]++;
  mcPCounter[129] += p;
  mcP2Counter[129] += p*p;
#define mccompcurname  channel_0_analyzer_1_rotated
#define mccompcurtype  Arm
#define mccompcurindex 129
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex
  /* Label for restoring  neutron */
  mcabsorbCompchannel_0_analyzer_1_rotated:
  if (RESTORE) /* restore if needed */
  { RESTORE_NEUTRON(129,
      mcnlx,
      mcnly,
      mcnlz,
      mcnlvx,
      mcnlvy,
      mcnlvz,
      mcnlt,
      mcnlsx,
      mcnlsy,
      mcnlsz,
      mcnlp); }
#undef mcabsorbComp
#undef p
#undef sz
#undef sy
#undef sx
#undef t
#undef vz
#undef vy
#undef vx
#undef z
#undef y
#undef x
  mcDEBUG_STATE(
mcnlx,
mcnly,
mcnlz,
mcnlvx,
mcnlvy,
mcnlvz,
mcnlt,
mcnlsx,
mcnlsy,
mcnlsz,
mcnlp)

  /* TRACE Component channel_0_analyzer_1_array_crystal_array_0 [130] */
  mccoordschange(mcposrchannel_0_analyzer_1_array_crystal_array_0, mcrotrchannel_0_analyzer_1_array_crystal_array_0,
    &mcnlx,
    &mcnly,
    &mcnlz,
    &mcnlvx,
    &mcnlvy,
    &mcnlvz,
    &mcnlsx,
    &mcnlsy,
    &mcnlsz);
  /* define label inside component channel_0_analyzer_1_array_crystal_array_0 (without coords transformations) */
  mcJumpTrace_channel_0_analyzer_1_array_crystal_array_0:
  SIG_MESSAGE("channel_0_analyzer_1_array_crystal_array_0 (Trace)");
  mcDEBUG_COMP("channel_0_analyzer_1_array_crystal_array_0")
  mcDEBUG_STATE(
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp)
#define x mcnlx
#define y mcnly
#define z mcnlz
#define vx mcnlvx
#define vy mcnlvy
#define vz mcnlvz
#define t mcnlt
#define sx mcnlsx
#define sy mcnlsy
#define sz mcnlsz
#define p mcnlp

#define mcabsorbComp mcabsorbCompchannel_0_analyzer_1_array_crystal_array_0
  STORE_NEUTRON(130,
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp);
  mcScattered=0;
  mcRestore=0;
  mcNCounter[130]++;
  mcPCounter[130] += p;
  mcP2Counter[130] += p*p;
#define mccompcurname  channel_0_analyzer_1_array_crystal_array_0
#define mccompcurtype  Union_box
#define mccompcurindex 130
#define loop_index mccchannel_0_analyzer_1_array_crystal_array_0_loop_index
#define this_box_volume mccchannel_0_analyzer_1_array_crystal_array_0_this_box_volume
#define global_geometry_element mccchannel_0_analyzer_1_array_crystal_array_0_global_geometry_element
#define this_box_storage mccchannel_0_analyzer_1_array_crystal_array_0_this_box_storage
{   /* Declarations of channel_0_analyzer_1_array_crystal_array_0=Union_box() SETTING parameters. */
char* material_string = mccchannel_0_analyzer_1_array_crystal_array_0_material_string;
MCNUM priority = mccchannel_0_analyzer_1_array_crystal_array_0_priority;
MCNUM xwidth = mccchannel_0_analyzer_1_array_crystal_array_0_xwidth;
MCNUM yheight = mccchannel_0_analyzer_1_array_crystal_array_0_yheight;
MCNUM zdepth = mccchannel_0_analyzer_1_array_crystal_array_0_zdepth;
MCNUM xwidth2 = mccchannel_0_analyzer_1_array_crystal_array_0_xwidth2;
MCNUM yheight2 = mccchannel_0_analyzer_1_array_crystal_array_0_yheight2;
MCNUM visualize = mccchannel_0_analyzer_1_array_crystal_array_0_visualize;
int target_index = mccchannel_0_analyzer_1_array_crystal_array_0_target_index;
MCNUM target_x = mccchannel_0_analyzer_1_array_crystal_array_0_target_x;
MCNUM target_y = mccchannel_0_analyzer_1_array_crystal_array_0_target_y;
MCNUM target_z = mccchannel_0_analyzer_1_array_crystal_array_0_target_z;
MCNUM focus_aw = mccchannel_0_analyzer_1_array_crystal_array_0_focus_aw;
MCNUM focus_ah = mccchannel_0_analyzer_1_array_crystal_array_0_focus_ah;
MCNUM focus_xw = mccchannel_0_analyzer_1_array_crystal_array_0_focus_xw;
MCNUM focus_xh = mccchannel_0_analyzer_1_array_crystal_array_0_focus_xh;
MCNUM focus_r = mccchannel_0_analyzer_1_array_crystal_array_0_focus_r;
MCNUM p_interact = mccchannel_0_analyzer_1_array_crystal_array_0_p_interact;
char* mask_string = mccchannel_0_analyzer_1_array_crystal_array_0_mask_string;
char* mask_setting = mccchannel_0_analyzer_1_array_crystal_array_0_mask_setting;
MCNUM number_of_activations = mccchannel_0_analyzer_1_array_crystal_array_0_number_of_activations;
}   /* End of channel_0_analyzer_1_array_crystal_array_0=Union_box() SETTING parameter declarations. */
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex
  /* Label for restoring  neutron */
  mcabsorbCompchannel_0_analyzer_1_array_crystal_array_0:
  if (RESTORE) /* restore if needed */
  { RESTORE_NEUTRON(130,
      mcnlx,
      mcnly,
      mcnlz,
      mcnlvx,
      mcnlvy,
      mcnlvz,
      mcnlt,
      mcnlsx,
      mcnlsy,
      mcnlsz,
      mcnlp); }
#undef mcabsorbComp
#undef p
#undef sz
#undef sy
#undef sx
#undef t
#undef vz
#undef vy
#undef vx
#undef z
#undef y
#undef x
  mcDEBUG_STATE(
mcnlx,
mcnly,
mcnlz,
mcnlvx,
mcnlvy,
mcnlvz,
mcnlt,
mcnlsx,
mcnlsy,
mcnlsz,
mcnlp)

  /* TRACE Component channel_0_analyzer_1_array_crystal_array_1 [131] */
  mccoordschange(mcposrchannel_0_analyzer_1_array_crystal_array_1, mcrotrchannel_0_analyzer_1_array_crystal_array_1,
    &mcnlx,
    &mcnly,
    &mcnlz,
    &mcnlvx,
    &mcnlvy,
    &mcnlvz,
    &mcnlsx,
    &mcnlsy,
    &mcnlsz);
  /* define label inside component channel_0_analyzer_1_array_crystal_array_1 (without coords transformations) */
  mcJumpTrace_channel_0_analyzer_1_array_crystal_array_1:
  SIG_MESSAGE("channel_0_analyzer_1_array_crystal_array_1 (Trace)");
  mcDEBUG_COMP("channel_0_analyzer_1_array_crystal_array_1")
  mcDEBUG_STATE(
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp)
#define x mcnlx
#define y mcnly
#define z mcnlz
#define vx mcnlvx
#define vy mcnlvy
#define vz mcnlvz
#define t mcnlt
#define sx mcnlsx
#define sy mcnlsy
#define sz mcnlsz
#define p mcnlp

#define mcabsorbComp mcabsorbCompchannel_0_analyzer_1_array_crystal_array_1
  STORE_NEUTRON(131,
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp);
  mcScattered=0;
  mcRestore=0;
  mcNCounter[131]++;
  mcPCounter[131] += p;
  mcP2Counter[131] += p*p;
#define mccompcurname  channel_0_analyzer_1_array_crystal_array_1
#define mccompcurtype  Union_box
#define mccompcurindex 131
#define loop_index mccchannel_0_analyzer_1_array_crystal_array_1_loop_index
#define this_box_volume mccchannel_0_analyzer_1_array_crystal_array_1_this_box_volume
#define global_geometry_element mccchannel_0_analyzer_1_array_crystal_array_1_global_geometry_element
#define this_box_storage mccchannel_0_analyzer_1_array_crystal_array_1_this_box_storage
{   /* Declarations of channel_0_analyzer_1_array_crystal_array_1=Union_box() SETTING parameters. */
char* material_string = mccchannel_0_analyzer_1_array_crystal_array_1_material_string;
MCNUM priority = mccchannel_0_analyzer_1_array_crystal_array_1_priority;
MCNUM xwidth = mccchannel_0_analyzer_1_array_crystal_array_1_xwidth;
MCNUM yheight = mccchannel_0_analyzer_1_array_crystal_array_1_yheight;
MCNUM zdepth = mccchannel_0_analyzer_1_array_crystal_array_1_zdepth;
MCNUM xwidth2 = mccchannel_0_analyzer_1_array_crystal_array_1_xwidth2;
MCNUM yheight2 = mccchannel_0_analyzer_1_array_crystal_array_1_yheight2;
MCNUM visualize = mccchannel_0_analyzer_1_array_crystal_array_1_visualize;
int target_index = mccchannel_0_analyzer_1_array_crystal_array_1_target_index;
MCNUM target_x = mccchannel_0_analyzer_1_array_crystal_array_1_target_x;
MCNUM target_y = mccchannel_0_analyzer_1_array_crystal_array_1_target_y;
MCNUM target_z = mccchannel_0_analyzer_1_array_crystal_array_1_target_z;
MCNUM focus_aw = mccchannel_0_analyzer_1_array_crystal_array_1_focus_aw;
MCNUM focus_ah = mccchannel_0_analyzer_1_array_crystal_array_1_focus_ah;
MCNUM focus_xw = mccchannel_0_analyzer_1_array_crystal_array_1_focus_xw;
MCNUM focus_xh = mccchannel_0_analyzer_1_array_crystal_array_1_focus_xh;
MCNUM focus_r = mccchannel_0_analyzer_1_array_crystal_array_1_focus_r;
MCNUM p_interact = mccchannel_0_analyzer_1_array_crystal_array_1_p_interact;
char* mask_string = mccchannel_0_analyzer_1_array_crystal_array_1_mask_string;
char* mask_setting = mccchannel_0_analyzer_1_array_crystal_array_1_mask_setting;
MCNUM number_of_activations = mccchannel_0_analyzer_1_array_crystal_array_1_number_of_activations;
}   /* End of channel_0_analyzer_1_array_crystal_array_1=Union_box() SETTING parameter declarations. */
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex
  /* Label for restoring  neutron */
  mcabsorbCompchannel_0_analyzer_1_array_crystal_array_1:
  if (RESTORE) /* restore if needed */
  { RESTORE_NEUTRON(131,
      mcnlx,
      mcnly,
      mcnlz,
      mcnlvx,
      mcnlvy,
      mcnlvz,
      mcnlt,
      mcnlsx,
      mcnlsy,
      mcnlsz,
      mcnlp); }
#undef mcabsorbComp
#undef p
#undef sz
#undef sy
#undef sx
#undef t
#undef vz
#undef vy
#undef vx
#undef z
#undef y
#undef x
  mcDEBUG_STATE(
mcnlx,
mcnly,
mcnlz,
mcnlvx,
mcnlvy,
mcnlvz,
mcnlt,
mcnlsx,
mcnlsy,
mcnlsz,
mcnlp)

  /* TRACE Component channel_0_analyzer_1_array_crystal_array_2 [132] */
  mccoordschange(mcposrchannel_0_analyzer_1_array_crystal_array_2, mcrotrchannel_0_analyzer_1_array_crystal_array_2,
    &mcnlx,
    &mcnly,
    &mcnlz,
    &mcnlvx,
    &mcnlvy,
    &mcnlvz,
    &mcnlsx,
    &mcnlsy,
    &mcnlsz);
  /* define label inside component channel_0_analyzer_1_array_crystal_array_2 (without coords transformations) */
  mcJumpTrace_channel_0_analyzer_1_array_crystal_array_2:
  SIG_MESSAGE("channel_0_analyzer_1_array_crystal_array_2 (Trace)");
  mcDEBUG_COMP("channel_0_analyzer_1_array_crystal_array_2")
  mcDEBUG_STATE(
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp)
#define x mcnlx
#define y mcnly
#define z mcnlz
#define vx mcnlvx
#define vy mcnlvy
#define vz mcnlvz
#define t mcnlt
#define sx mcnlsx
#define sy mcnlsy
#define sz mcnlsz
#define p mcnlp

#define mcabsorbComp mcabsorbCompchannel_0_analyzer_1_array_crystal_array_2
  STORE_NEUTRON(132,
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp);
  mcScattered=0;
  mcRestore=0;
  mcNCounter[132]++;
  mcPCounter[132] += p;
  mcP2Counter[132] += p*p;
#define mccompcurname  channel_0_analyzer_1_array_crystal_array_2
#define mccompcurtype  Union_box
#define mccompcurindex 132
#define loop_index mccchannel_0_analyzer_1_array_crystal_array_2_loop_index
#define this_box_volume mccchannel_0_analyzer_1_array_crystal_array_2_this_box_volume
#define global_geometry_element mccchannel_0_analyzer_1_array_crystal_array_2_global_geometry_element
#define this_box_storage mccchannel_0_analyzer_1_array_crystal_array_2_this_box_storage
{   /* Declarations of channel_0_analyzer_1_array_crystal_array_2=Union_box() SETTING parameters. */
char* material_string = mccchannel_0_analyzer_1_array_crystal_array_2_material_string;
MCNUM priority = mccchannel_0_analyzer_1_array_crystal_array_2_priority;
MCNUM xwidth = mccchannel_0_analyzer_1_array_crystal_array_2_xwidth;
MCNUM yheight = mccchannel_0_analyzer_1_array_crystal_array_2_yheight;
MCNUM zdepth = mccchannel_0_analyzer_1_array_crystal_array_2_zdepth;
MCNUM xwidth2 = mccchannel_0_analyzer_1_array_crystal_array_2_xwidth2;
MCNUM yheight2 = mccchannel_0_analyzer_1_array_crystal_array_2_yheight2;
MCNUM visualize = mccchannel_0_analyzer_1_array_crystal_array_2_visualize;
int target_index = mccchannel_0_analyzer_1_array_crystal_array_2_target_index;
MCNUM target_x = mccchannel_0_analyzer_1_array_crystal_array_2_target_x;
MCNUM target_y = mccchannel_0_analyzer_1_array_crystal_array_2_target_y;
MCNUM target_z = mccchannel_0_analyzer_1_array_crystal_array_2_target_z;
MCNUM focus_aw = mccchannel_0_analyzer_1_array_crystal_array_2_focus_aw;
MCNUM focus_ah = mccchannel_0_analyzer_1_array_crystal_array_2_focus_ah;
MCNUM focus_xw = mccchannel_0_analyzer_1_array_crystal_array_2_focus_xw;
MCNUM focus_xh = mccchannel_0_analyzer_1_array_crystal_array_2_focus_xh;
MCNUM focus_r = mccchannel_0_analyzer_1_array_crystal_array_2_focus_r;
MCNUM p_interact = mccchannel_0_analyzer_1_array_crystal_array_2_p_interact;
char* mask_string = mccchannel_0_analyzer_1_array_crystal_array_2_mask_string;
char* mask_setting = mccchannel_0_analyzer_1_array_crystal_array_2_mask_setting;
MCNUM number_of_activations = mccchannel_0_analyzer_1_array_crystal_array_2_number_of_activations;
}   /* End of channel_0_analyzer_1_array_crystal_array_2=Union_box() SETTING parameter declarations. */
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex
  /* Label for restoring  neutron */
  mcabsorbCompchannel_0_analyzer_1_array_crystal_array_2:
  if (RESTORE) /* restore if needed */
  { RESTORE_NEUTRON(132,
      mcnlx,
      mcnly,
      mcnlz,
      mcnlvx,
      mcnlvy,
      mcnlvz,
      mcnlt,
      mcnlsx,
      mcnlsy,
      mcnlsz,
      mcnlp); }
#undef mcabsorbComp
#undef p
#undef sz
#undef sy
#undef sx
#undef t
#undef vz
#undef vy
#undef vx
#undef z
#undef y
#undef x
  mcDEBUG_STATE(
mcnlx,
mcnly,
mcnlz,
mcnlvx,
mcnlvy,
mcnlvz,
mcnlt,
mcnlsx,
mcnlsy,
mcnlsz,
mcnlp)

  /* TRACE Component channel_0_analyzer_1_array_crystal_array_3 [133] */
  mccoordschange(mcposrchannel_0_analyzer_1_array_crystal_array_3, mcrotrchannel_0_analyzer_1_array_crystal_array_3,
    &mcnlx,
    &mcnly,
    &mcnlz,
    &mcnlvx,
    &mcnlvy,
    &mcnlvz,
    &mcnlsx,
    &mcnlsy,
    &mcnlsz);
  /* define label inside component channel_0_analyzer_1_array_crystal_array_3 (without coords transformations) */
  mcJumpTrace_channel_0_analyzer_1_array_crystal_array_3:
  SIG_MESSAGE("channel_0_analyzer_1_array_crystal_array_3 (Trace)");
  mcDEBUG_COMP("channel_0_analyzer_1_array_crystal_array_3")
  mcDEBUG_STATE(
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp)
#define x mcnlx
#define y mcnly
#define z mcnlz
#define vx mcnlvx
#define vy mcnlvy
#define vz mcnlvz
#define t mcnlt
#define sx mcnlsx
#define sy mcnlsy
#define sz mcnlsz
#define p mcnlp

#define mcabsorbComp mcabsorbCompchannel_0_analyzer_1_array_crystal_array_3
  STORE_NEUTRON(133,
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp);
  mcScattered=0;
  mcRestore=0;
  mcNCounter[133]++;
  mcPCounter[133] += p;
  mcP2Counter[133] += p*p;
#define mccompcurname  channel_0_analyzer_1_array_crystal_array_3
#define mccompcurtype  Union_box
#define mccompcurindex 133
#define loop_index mccchannel_0_analyzer_1_array_crystal_array_3_loop_index
#define this_box_volume mccchannel_0_analyzer_1_array_crystal_array_3_this_box_volume
#define global_geometry_element mccchannel_0_analyzer_1_array_crystal_array_3_global_geometry_element
#define this_box_storage mccchannel_0_analyzer_1_array_crystal_array_3_this_box_storage
{   /* Declarations of channel_0_analyzer_1_array_crystal_array_3=Union_box() SETTING parameters. */
char* material_string = mccchannel_0_analyzer_1_array_crystal_array_3_material_string;
MCNUM priority = mccchannel_0_analyzer_1_array_crystal_array_3_priority;
MCNUM xwidth = mccchannel_0_analyzer_1_array_crystal_array_3_xwidth;
MCNUM yheight = mccchannel_0_analyzer_1_array_crystal_array_3_yheight;
MCNUM zdepth = mccchannel_0_analyzer_1_array_crystal_array_3_zdepth;
MCNUM xwidth2 = mccchannel_0_analyzer_1_array_crystal_array_3_xwidth2;
MCNUM yheight2 = mccchannel_0_analyzer_1_array_crystal_array_3_yheight2;
MCNUM visualize = mccchannel_0_analyzer_1_array_crystal_array_3_visualize;
int target_index = mccchannel_0_analyzer_1_array_crystal_array_3_target_index;
MCNUM target_x = mccchannel_0_analyzer_1_array_crystal_array_3_target_x;
MCNUM target_y = mccchannel_0_analyzer_1_array_crystal_array_3_target_y;
MCNUM target_z = mccchannel_0_analyzer_1_array_crystal_array_3_target_z;
MCNUM focus_aw = mccchannel_0_analyzer_1_array_crystal_array_3_focus_aw;
MCNUM focus_ah = mccchannel_0_analyzer_1_array_crystal_array_3_focus_ah;
MCNUM focus_xw = mccchannel_0_analyzer_1_array_crystal_array_3_focus_xw;
MCNUM focus_xh = mccchannel_0_analyzer_1_array_crystal_array_3_focus_xh;
MCNUM focus_r = mccchannel_0_analyzer_1_array_crystal_array_3_focus_r;
MCNUM p_interact = mccchannel_0_analyzer_1_array_crystal_array_3_p_interact;
char* mask_string = mccchannel_0_analyzer_1_array_crystal_array_3_mask_string;
char* mask_setting = mccchannel_0_analyzer_1_array_crystal_array_3_mask_setting;
MCNUM number_of_activations = mccchannel_0_analyzer_1_array_crystal_array_3_number_of_activations;
}   /* End of channel_0_analyzer_1_array_crystal_array_3=Union_box() SETTING parameter declarations. */
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex
  /* Label for restoring  neutron */
  mcabsorbCompchannel_0_analyzer_1_array_crystal_array_3:
  if (RESTORE) /* restore if needed */
  { RESTORE_NEUTRON(133,
      mcnlx,
      mcnly,
      mcnlz,
      mcnlvx,
      mcnlvy,
      mcnlvz,
      mcnlt,
      mcnlsx,
      mcnlsy,
      mcnlsz,
      mcnlp); }
#undef mcabsorbComp
#undef p
#undef sz
#undef sy
#undef sx
#undef t
#undef vz
#undef vy
#undef vx
#undef z
#undef y
#undef x
  mcDEBUG_STATE(
mcnlx,
mcnly,
mcnlz,
mcnlvx,
mcnlvy,
mcnlvz,
mcnlt,
mcnlsx,
mcnlsy,
mcnlsz,
mcnlp)

  /* TRACE Component channel_0_analyzer_1_array_crystal_array_4 [134] */
  mccoordschange(mcposrchannel_0_analyzer_1_array_crystal_array_4, mcrotrchannel_0_analyzer_1_array_crystal_array_4,
    &mcnlx,
    &mcnly,
    &mcnlz,
    &mcnlvx,
    &mcnlvy,
    &mcnlvz,
    &mcnlsx,
    &mcnlsy,
    &mcnlsz);
  /* define label inside component channel_0_analyzer_1_array_crystal_array_4 (without coords transformations) */
  mcJumpTrace_channel_0_analyzer_1_array_crystal_array_4:
  SIG_MESSAGE("channel_0_analyzer_1_array_crystal_array_4 (Trace)");
  mcDEBUG_COMP("channel_0_analyzer_1_array_crystal_array_4")
  mcDEBUG_STATE(
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp)
#define x mcnlx
#define y mcnly
#define z mcnlz
#define vx mcnlvx
#define vy mcnlvy
#define vz mcnlvz
#define t mcnlt
#define sx mcnlsx
#define sy mcnlsy
#define sz mcnlsz
#define p mcnlp

#define mcabsorbComp mcabsorbCompchannel_0_analyzer_1_array_crystal_array_4
  STORE_NEUTRON(134,
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp);
  mcScattered=0;
  mcRestore=0;
  mcNCounter[134]++;
  mcPCounter[134] += p;
  mcP2Counter[134] += p*p;
#define mccompcurname  channel_0_analyzer_1_array_crystal_array_4
#define mccompcurtype  Union_box
#define mccompcurindex 134
#define loop_index mccchannel_0_analyzer_1_array_crystal_array_4_loop_index
#define this_box_volume mccchannel_0_analyzer_1_array_crystal_array_4_this_box_volume
#define global_geometry_element mccchannel_0_analyzer_1_array_crystal_array_4_global_geometry_element
#define this_box_storage mccchannel_0_analyzer_1_array_crystal_array_4_this_box_storage
{   /* Declarations of channel_0_analyzer_1_array_crystal_array_4=Union_box() SETTING parameters. */
char* material_string = mccchannel_0_analyzer_1_array_crystal_array_4_material_string;
MCNUM priority = mccchannel_0_analyzer_1_array_crystal_array_4_priority;
MCNUM xwidth = mccchannel_0_analyzer_1_array_crystal_array_4_xwidth;
MCNUM yheight = mccchannel_0_analyzer_1_array_crystal_array_4_yheight;
MCNUM zdepth = mccchannel_0_analyzer_1_array_crystal_array_4_zdepth;
MCNUM xwidth2 = mccchannel_0_analyzer_1_array_crystal_array_4_xwidth2;
MCNUM yheight2 = mccchannel_0_analyzer_1_array_crystal_array_4_yheight2;
MCNUM visualize = mccchannel_0_analyzer_1_array_crystal_array_4_visualize;
int target_index = mccchannel_0_analyzer_1_array_crystal_array_4_target_index;
MCNUM target_x = mccchannel_0_analyzer_1_array_crystal_array_4_target_x;
MCNUM target_y = mccchannel_0_analyzer_1_array_crystal_array_4_target_y;
MCNUM target_z = mccchannel_0_analyzer_1_array_crystal_array_4_target_z;
MCNUM focus_aw = mccchannel_0_analyzer_1_array_crystal_array_4_focus_aw;
MCNUM focus_ah = mccchannel_0_analyzer_1_array_crystal_array_4_focus_ah;
MCNUM focus_xw = mccchannel_0_analyzer_1_array_crystal_array_4_focus_xw;
MCNUM focus_xh = mccchannel_0_analyzer_1_array_crystal_array_4_focus_xh;
MCNUM focus_r = mccchannel_0_analyzer_1_array_crystal_array_4_focus_r;
MCNUM p_interact = mccchannel_0_analyzer_1_array_crystal_array_4_p_interact;
char* mask_string = mccchannel_0_analyzer_1_array_crystal_array_4_mask_string;
char* mask_setting = mccchannel_0_analyzer_1_array_crystal_array_4_mask_setting;
MCNUM number_of_activations = mccchannel_0_analyzer_1_array_crystal_array_4_number_of_activations;
}   /* End of channel_0_analyzer_1_array_crystal_array_4=Union_box() SETTING parameter declarations. */
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex
  /* Label for restoring  neutron */
  mcabsorbCompchannel_0_analyzer_1_array_crystal_array_4:
  if (RESTORE) /* restore if needed */
  { RESTORE_NEUTRON(134,
      mcnlx,
      mcnly,
      mcnlz,
      mcnlvx,
      mcnlvy,
      mcnlvz,
      mcnlt,
      mcnlsx,
      mcnlsy,
      mcnlsz,
      mcnlp); }
#undef mcabsorbComp
#undef p
#undef sz
#undef sy
#undef sx
#undef t
#undef vz
#undef vy
#undef vx
#undef z
#undef y
#undef x
  mcDEBUG_STATE(
mcnlx,
mcnly,
mcnlz,
mcnlvx,
mcnlvy,
mcnlvz,
mcnlt,
mcnlsx,
mcnlsy,
mcnlsz,
mcnlp)

  /* TRACE Component channel_0_analyzer_1_array_crystal_array_5 [135] */
  mccoordschange(mcposrchannel_0_analyzer_1_array_crystal_array_5, mcrotrchannel_0_analyzer_1_array_crystal_array_5,
    &mcnlx,
    &mcnly,
    &mcnlz,
    &mcnlvx,
    &mcnlvy,
    &mcnlvz,
    &mcnlsx,
    &mcnlsy,
    &mcnlsz);
  /* define label inside component channel_0_analyzer_1_array_crystal_array_5 (without coords transformations) */
  mcJumpTrace_channel_0_analyzer_1_array_crystal_array_5:
  SIG_MESSAGE("channel_0_analyzer_1_array_crystal_array_5 (Trace)");
  mcDEBUG_COMP("channel_0_analyzer_1_array_crystal_array_5")
  mcDEBUG_STATE(
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp)
#define x mcnlx
#define y mcnly
#define z mcnlz
#define vx mcnlvx
#define vy mcnlvy
#define vz mcnlvz
#define t mcnlt
#define sx mcnlsx
#define sy mcnlsy
#define sz mcnlsz
#define p mcnlp

#define mcabsorbComp mcabsorbCompchannel_0_analyzer_1_array_crystal_array_5
  STORE_NEUTRON(135,
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp);
  mcScattered=0;
  mcRestore=0;
  mcNCounter[135]++;
  mcPCounter[135] += p;
  mcP2Counter[135] += p*p;
#define mccompcurname  channel_0_analyzer_1_array_crystal_array_5
#define mccompcurtype  Union_box
#define mccompcurindex 135
#define loop_index mccchannel_0_analyzer_1_array_crystal_array_5_loop_index
#define this_box_volume mccchannel_0_analyzer_1_array_crystal_array_5_this_box_volume
#define global_geometry_element mccchannel_0_analyzer_1_array_crystal_array_5_global_geometry_element
#define this_box_storage mccchannel_0_analyzer_1_array_crystal_array_5_this_box_storage
{   /* Declarations of channel_0_analyzer_1_array_crystal_array_5=Union_box() SETTING parameters. */
char* material_string = mccchannel_0_analyzer_1_array_crystal_array_5_material_string;
MCNUM priority = mccchannel_0_analyzer_1_array_crystal_array_5_priority;
MCNUM xwidth = mccchannel_0_analyzer_1_array_crystal_array_5_xwidth;
MCNUM yheight = mccchannel_0_analyzer_1_array_crystal_array_5_yheight;
MCNUM zdepth = mccchannel_0_analyzer_1_array_crystal_array_5_zdepth;
MCNUM xwidth2 = mccchannel_0_analyzer_1_array_crystal_array_5_xwidth2;
MCNUM yheight2 = mccchannel_0_analyzer_1_array_crystal_array_5_yheight2;
MCNUM visualize = mccchannel_0_analyzer_1_array_crystal_array_5_visualize;
int target_index = mccchannel_0_analyzer_1_array_crystal_array_5_target_index;
MCNUM target_x = mccchannel_0_analyzer_1_array_crystal_array_5_target_x;
MCNUM target_y = mccchannel_0_analyzer_1_array_crystal_array_5_target_y;
MCNUM target_z = mccchannel_0_analyzer_1_array_crystal_array_5_target_z;
MCNUM focus_aw = mccchannel_0_analyzer_1_array_crystal_array_5_focus_aw;
MCNUM focus_ah = mccchannel_0_analyzer_1_array_crystal_array_5_focus_ah;
MCNUM focus_xw = mccchannel_0_analyzer_1_array_crystal_array_5_focus_xw;
MCNUM focus_xh = mccchannel_0_analyzer_1_array_crystal_array_5_focus_xh;
MCNUM focus_r = mccchannel_0_analyzer_1_array_crystal_array_5_focus_r;
MCNUM p_interact = mccchannel_0_analyzer_1_array_crystal_array_5_p_interact;
char* mask_string = mccchannel_0_analyzer_1_array_crystal_array_5_mask_string;
char* mask_setting = mccchannel_0_analyzer_1_array_crystal_array_5_mask_setting;
MCNUM number_of_activations = mccchannel_0_analyzer_1_array_crystal_array_5_number_of_activations;
}   /* End of channel_0_analyzer_1_array_crystal_array_5=Union_box() SETTING parameter declarations. */
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex
  /* Label for restoring  neutron */
  mcabsorbCompchannel_0_analyzer_1_array_crystal_array_5:
  if (RESTORE) /* restore if needed */
  { RESTORE_NEUTRON(135,
      mcnlx,
      mcnly,
      mcnlz,
      mcnlvx,
      mcnlvy,
      mcnlvz,
      mcnlt,
      mcnlsx,
      mcnlsy,
      mcnlsz,
      mcnlp); }
#undef mcabsorbComp
#undef p
#undef sz
#undef sy
#undef sx
#undef t
#undef vz
#undef vy
#undef vx
#undef z
#undef y
#undef x
  mcDEBUG_STATE(
mcnlx,
mcnly,
mcnlz,
mcnlvx,
mcnlvy,
mcnlvz,
mcnlt,
mcnlsx,
mcnlsy,
mcnlsz,
mcnlp)

  /* TRACE Component channel_0_analyzer_1_array_crystal_array_6 [136] */
  mccoordschange(mcposrchannel_0_analyzer_1_array_crystal_array_6, mcrotrchannel_0_analyzer_1_array_crystal_array_6,
    &mcnlx,
    &mcnly,
    &mcnlz,
    &mcnlvx,
    &mcnlvy,
    &mcnlvz,
    &mcnlsx,
    &mcnlsy,
    &mcnlsz);
  /* define label inside component channel_0_analyzer_1_array_crystal_array_6 (without coords transformations) */
  mcJumpTrace_channel_0_analyzer_1_array_crystal_array_6:
  SIG_MESSAGE("channel_0_analyzer_1_array_crystal_array_6 (Trace)");
  mcDEBUG_COMP("channel_0_analyzer_1_array_crystal_array_6")
  mcDEBUG_STATE(
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp)
#define x mcnlx
#define y mcnly
#define z mcnlz
#define vx mcnlvx
#define vy mcnlvy
#define vz mcnlvz
#define t mcnlt
#define sx mcnlsx
#define sy mcnlsy
#define sz mcnlsz
#define p mcnlp

#define mcabsorbComp mcabsorbCompchannel_0_analyzer_1_array_crystal_array_6
  STORE_NEUTRON(136,
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp);
  mcScattered=0;
  mcRestore=0;
  mcNCounter[136]++;
  mcPCounter[136] += p;
  mcP2Counter[136] += p*p;
#define mccompcurname  channel_0_analyzer_1_array_crystal_array_6
#define mccompcurtype  Union_box
#define mccompcurindex 136
#define loop_index mccchannel_0_analyzer_1_array_crystal_array_6_loop_index
#define this_box_volume mccchannel_0_analyzer_1_array_crystal_array_6_this_box_volume
#define global_geometry_element mccchannel_0_analyzer_1_array_crystal_array_6_global_geometry_element
#define this_box_storage mccchannel_0_analyzer_1_array_crystal_array_6_this_box_storage
{   /* Declarations of channel_0_analyzer_1_array_crystal_array_6=Union_box() SETTING parameters. */
char* material_string = mccchannel_0_analyzer_1_array_crystal_array_6_material_string;
MCNUM priority = mccchannel_0_analyzer_1_array_crystal_array_6_priority;
MCNUM xwidth = mccchannel_0_analyzer_1_array_crystal_array_6_xwidth;
MCNUM yheight = mccchannel_0_analyzer_1_array_crystal_array_6_yheight;
MCNUM zdepth = mccchannel_0_analyzer_1_array_crystal_array_6_zdepth;
MCNUM xwidth2 = mccchannel_0_analyzer_1_array_crystal_array_6_xwidth2;
MCNUM yheight2 = mccchannel_0_analyzer_1_array_crystal_array_6_yheight2;
MCNUM visualize = mccchannel_0_analyzer_1_array_crystal_array_6_visualize;
int target_index = mccchannel_0_analyzer_1_array_crystal_array_6_target_index;
MCNUM target_x = mccchannel_0_analyzer_1_array_crystal_array_6_target_x;
MCNUM target_y = mccchannel_0_analyzer_1_array_crystal_array_6_target_y;
MCNUM target_z = mccchannel_0_analyzer_1_array_crystal_array_6_target_z;
MCNUM focus_aw = mccchannel_0_analyzer_1_array_crystal_array_6_focus_aw;
MCNUM focus_ah = mccchannel_0_analyzer_1_array_crystal_array_6_focus_ah;
MCNUM focus_xw = mccchannel_0_analyzer_1_array_crystal_array_6_focus_xw;
MCNUM focus_xh = mccchannel_0_analyzer_1_array_crystal_array_6_focus_xh;
MCNUM focus_r = mccchannel_0_analyzer_1_array_crystal_array_6_focus_r;
MCNUM p_interact = mccchannel_0_analyzer_1_array_crystal_array_6_p_interact;
char* mask_string = mccchannel_0_analyzer_1_array_crystal_array_6_mask_string;
char* mask_setting = mccchannel_0_analyzer_1_array_crystal_array_6_mask_setting;
MCNUM number_of_activations = mccchannel_0_analyzer_1_array_crystal_array_6_number_of_activations;
}   /* End of channel_0_analyzer_1_array_crystal_array_6=Union_box() SETTING parameter declarations. */
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex
  /* Label for restoring  neutron */
  mcabsorbCompchannel_0_analyzer_1_array_crystal_array_6:
  if (RESTORE) /* restore if needed */
  { RESTORE_NEUTRON(136,
      mcnlx,
      mcnly,
      mcnlz,
      mcnlvx,
      mcnlvy,
      mcnlvz,
      mcnlt,
      mcnlsx,
      mcnlsy,
      mcnlsz,
      mcnlp); }
#undef mcabsorbComp
#undef p
#undef sz
#undef sy
#undef sx
#undef t
#undef vz
#undef vy
#undef vx
#undef z
#undef y
#undef x
  mcDEBUG_STATE(
mcnlx,
mcnly,
mcnlz,
mcnlvx,
mcnlvy,
mcnlvz,
mcnlt,
mcnlsx,
mcnlsy,
mcnlsz,
mcnlp)

  /* TRACE Component channel_0_analyzer_1_array_crystal_array_7 [137] */
  mccoordschange(mcposrchannel_0_analyzer_1_array_crystal_array_7, mcrotrchannel_0_analyzer_1_array_crystal_array_7,
    &mcnlx,
    &mcnly,
    &mcnlz,
    &mcnlvx,
    &mcnlvy,
    &mcnlvz,
    &mcnlsx,
    &mcnlsy,
    &mcnlsz);
  /* define label inside component channel_0_analyzer_1_array_crystal_array_7 (without coords transformations) */
  mcJumpTrace_channel_0_analyzer_1_array_crystal_array_7:
  SIG_MESSAGE("channel_0_analyzer_1_array_crystal_array_7 (Trace)");
  mcDEBUG_COMP("channel_0_analyzer_1_array_crystal_array_7")
  mcDEBUG_STATE(
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp)
#define x mcnlx
#define y mcnly
#define z mcnlz
#define vx mcnlvx
#define vy mcnlvy
#define vz mcnlvz
#define t mcnlt
#define sx mcnlsx
#define sy mcnlsy
#define sz mcnlsz
#define p mcnlp

#define mcabsorbComp mcabsorbCompchannel_0_analyzer_1_array_crystal_array_7
  STORE_NEUTRON(137,
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp);
  mcScattered=0;
  mcRestore=0;
  mcNCounter[137]++;
  mcPCounter[137] += p;
  mcP2Counter[137] += p*p;
#define mccompcurname  channel_0_analyzer_1_array_crystal_array_7
#define mccompcurtype  Union_box
#define mccompcurindex 137
#define loop_index mccchannel_0_analyzer_1_array_crystal_array_7_loop_index
#define this_box_volume mccchannel_0_analyzer_1_array_crystal_array_7_this_box_volume
#define global_geometry_element mccchannel_0_analyzer_1_array_crystal_array_7_global_geometry_element
#define this_box_storage mccchannel_0_analyzer_1_array_crystal_array_7_this_box_storage
{   /* Declarations of channel_0_analyzer_1_array_crystal_array_7=Union_box() SETTING parameters. */
char* material_string = mccchannel_0_analyzer_1_array_crystal_array_7_material_string;
MCNUM priority = mccchannel_0_analyzer_1_array_crystal_array_7_priority;
MCNUM xwidth = mccchannel_0_analyzer_1_array_crystal_array_7_xwidth;
MCNUM yheight = mccchannel_0_analyzer_1_array_crystal_array_7_yheight;
MCNUM zdepth = mccchannel_0_analyzer_1_array_crystal_array_7_zdepth;
MCNUM xwidth2 = mccchannel_0_analyzer_1_array_crystal_array_7_xwidth2;
MCNUM yheight2 = mccchannel_0_analyzer_1_array_crystal_array_7_yheight2;
MCNUM visualize = mccchannel_0_analyzer_1_array_crystal_array_7_visualize;
int target_index = mccchannel_0_analyzer_1_array_crystal_array_7_target_index;
MCNUM target_x = mccchannel_0_analyzer_1_array_crystal_array_7_target_x;
MCNUM target_y = mccchannel_0_analyzer_1_array_crystal_array_7_target_y;
MCNUM target_z = mccchannel_0_analyzer_1_array_crystal_array_7_target_z;
MCNUM focus_aw = mccchannel_0_analyzer_1_array_crystal_array_7_focus_aw;
MCNUM focus_ah = mccchannel_0_analyzer_1_array_crystal_array_7_focus_ah;
MCNUM focus_xw = mccchannel_0_analyzer_1_array_crystal_array_7_focus_xw;
MCNUM focus_xh = mccchannel_0_analyzer_1_array_crystal_array_7_focus_xh;
MCNUM focus_r = mccchannel_0_analyzer_1_array_crystal_array_7_focus_r;
MCNUM p_interact = mccchannel_0_analyzer_1_array_crystal_array_7_p_interact;
char* mask_string = mccchannel_0_analyzer_1_array_crystal_array_7_mask_string;
char* mask_setting = mccchannel_0_analyzer_1_array_crystal_array_7_mask_setting;
MCNUM number_of_activations = mccchannel_0_analyzer_1_array_crystal_array_7_number_of_activations;
}   /* End of channel_0_analyzer_1_array_crystal_array_7=Union_box() SETTING parameter declarations. */
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex
  /* Label for restoring  neutron */
  mcabsorbCompchannel_0_analyzer_1_array_crystal_array_7:
  if (RESTORE) /* restore if needed */
  { RESTORE_NEUTRON(137,
      mcnlx,
      mcnly,
      mcnlz,
      mcnlvx,
      mcnlvy,
      mcnlvz,
      mcnlt,
      mcnlsx,
      mcnlsy,
      mcnlsz,
      mcnlp); }
#undef mcabsorbComp
#undef p
#undef sz
#undef sy
#undef sx
#undef t
#undef vz
#undef vy
#undef vx
#undef z
#undef y
#undef x
  mcDEBUG_STATE(
mcnlx,
mcnly,
mcnlz,
mcnlvx,
mcnlvy,
mcnlvz,
mcnlt,
mcnlsx,
mcnlsy,
mcnlsz,
mcnlp)

  /* TRACE Component channel_0_analyzer_1_array_crystal_array_8 [138] */
  mccoordschange(mcposrchannel_0_analyzer_1_array_crystal_array_8, mcrotrchannel_0_analyzer_1_array_crystal_array_8,
    &mcnlx,
    &mcnly,
    &mcnlz,
    &mcnlvx,
    &mcnlvy,
    &mcnlvz,
    &mcnlsx,
    &mcnlsy,
    &mcnlsz);
  /* define label inside component channel_0_analyzer_1_array_crystal_array_8 (without coords transformations) */
  mcJumpTrace_channel_0_analyzer_1_array_crystal_array_8:
  SIG_MESSAGE("channel_0_analyzer_1_array_crystal_array_8 (Trace)");
  mcDEBUG_COMP("channel_0_analyzer_1_array_crystal_array_8")
  mcDEBUG_STATE(
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp)
#define x mcnlx
#define y mcnly
#define z mcnlz
#define vx mcnlvx
#define vy mcnlvy
#define vz mcnlvz
#define t mcnlt
#define sx mcnlsx
#define sy mcnlsy
#define sz mcnlsz
#define p mcnlp

#define mcabsorbComp mcabsorbCompchannel_0_analyzer_1_array_crystal_array_8
  STORE_NEUTRON(138,
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp);
  mcScattered=0;
  mcRestore=0;
  mcNCounter[138]++;
  mcPCounter[138] += p;
  mcP2Counter[138] += p*p;
#define mccompcurname  channel_0_analyzer_1_array_crystal_array_8
#define mccompcurtype  Union_box
#define mccompcurindex 138
#define loop_index mccchannel_0_analyzer_1_array_crystal_array_8_loop_index
#define this_box_volume mccchannel_0_analyzer_1_array_crystal_array_8_this_box_volume
#define global_geometry_element mccchannel_0_analyzer_1_array_crystal_array_8_global_geometry_element
#define this_box_storage mccchannel_0_analyzer_1_array_crystal_array_8_this_box_storage
{   /* Declarations of channel_0_analyzer_1_array_crystal_array_8=Union_box() SETTING parameters. */
char* material_string = mccchannel_0_analyzer_1_array_crystal_array_8_material_string;
MCNUM priority = mccchannel_0_analyzer_1_array_crystal_array_8_priority;
MCNUM xwidth = mccchannel_0_analyzer_1_array_crystal_array_8_xwidth;
MCNUM yheight = mccchannel_0_analyzer_1_array_crystal_array_8_yheight;
MCNUM zdepth = mccchannel_0_analyzer_1_array_crystal_array_8_zdepth;
MCNUM xwidth2 = mccchannel_0_analyzer_1_array_crystal_array_8_xwidth2;
MCNUM yheight2 = mccchannel_0_analyzer_1_array_crystal_array_8_yheight2;
MCNUM visualize = mccchannel_0_analyzer_1_array_crystal_array_8_visualize;
int target_index = mccchannel_0_analyzer_1_array_crystal_array_8_target_index;
MCNUM target_x = mccchannel_0_analyzer_1_array_crystal_array_8_target_x;
MCNUM target_y = mccchannel_0_analyzer_1_array_crystal_array_8_target_y;
MCNUM target_z = mccchannel_0_analyzer_1_array_crystal_array_8_target_z;
MCNUM focus_aw = mccchannel_0_analyzer_1_array_crystal_array_8_focus_aw;
MCNUM focus_ah = mccchannel_0_analyzer_1_array_crystal_array_8_focus_ah;
MCNUM focus_xw = mccchannel_0_analyzer_1_array_crystal_array_8_focus_xw;
MCNUM focus_xh = mccchannel_0_analyzer_1_array_crystal_array_8_focus_xh;
MCNUM focus_r = mccchannel_0_analyzer_1_array_crystal_array_8_focus_r;
MCNUM p_interact = mccchannel_0_analyzer_1_array_crystal_array_8_p_interact;
char* mask_string = mccchannel_0_analyzer_1_array_crystal_array_8_mask_string;
char* mask_setting = mccchannel_0_analyzer_1_array_crystal_array_8_mask_setting;
MCNUM number_of_activations = mccchannel_0_analyzer_1_array_crystal_array_8_number_of_activations;
}   /* End of channel_0_analyzer_1_array_crystal_array_8=Union_box() SETTING parameter declarations. */
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex
  /* Label for restoring  neutron */
  mcabsorbCompchannel_0_analyzer_1_array_crystal_array_8:
  if (RESTORE) /* restore if needed */
  { RESTORE_NEUTRON(138,
      mcnlx,
      mcnly,
      mcnlz,
      mcnlvx,
      mcnlvy,
      mcnlvz,
      mcnlt,
      mcnlsx,
      mcnlsy,
      mcnlsz,
      mcnlp); }
#undef mcabsorbComp
#undef p
#undef sz
#undef sy
#undef sx
#undef t
#undef vz
#undef vy
#undef vx
#undef z
#undef y
#undef x
  mcDEBUG_STATE(
mcnlx,
mcnly,
mcnlz,
mcnlvx,
mcnlvy,
mcnlvz,
mcnlt,
mcnlsx,
mcnlsy,
mcnlsz,
mcnlp)

  /* TRACE Component channel_0_analyzer_2_center [139] */
  mccoordschange(mcposrchannel_0_analyzer_2_center, mcrotrchannel_0_analyzer_2_center,
    &mcnlx,
    &mcnly,
    &mcnlz,
    &mcnlvx,
    &mcnlvy,
    &mcnlvz,
    &mcnlsx,
    &mcnlsy,
    &mcnlsz);
  /* define label inside component channel_0_analyzer_2_center (without coords transformations) */
  mcJumpTrace_channel_0_analyzer_2_center:
  SIG_MESSAGE("channel_0_analyzer_2_center (Trace)");
  mcDEBUG_COMP("channel_0_analyzer_2_center")
  mcDEBUG_STATE(
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp)
#define x mcnlx
#define y mcnly
#define z mcnlz
#define vx mcnlvx
#define vy mcnlvy
#define vz mcnlvz
#define t mcnlt
#define sx mcnlsx
#define sy mcnlsy
#define sz mcnlsz
#define p mcnlp

#define mcabsorbComp mcabsorbCompchannel_0_analyzer_2_center
  STORE_NEUTRON(139,
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp);
  mcScattered=0;
  mcRestore=0;
  mcNCounter[139]++;
  mcPCounter[139] += p;
  mcP2Counter[139] += p*p;
#define mccompcurname  channel_0_analyzer_2_center
#define mccompcurtype  Arm
#define mccompcurindex 139
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex
  /* Label for restoring  neutron */
  mcabsorbCompchannel_0_analyzer_2_center:
  if (RESTORE) /* restore if needed */
  { RESTORE_NEUTRON(139,
      mcnlx,
      mcnly,
      mcnlz,
      mcnlvx,
      mcnlvy,
      mcnlvz,
      mcnlt,
      mcnlsx,
      mcnlsy,
      mcnlsz,
      mcnlp); }
#undef mcabsorbComp
#undef p
#undef sz
#undef sy
#undef sx
#undef t
#undef vz
#undef vy
#undef vx
#undef z
#undef y
#undef x
  mcDEBUG_STATE(
mcnlx,
mcnly,
mcnlz,
mcnlvx,
mcnlvy,
mcnlvz,
mcnlt,
mcnlsx,
mcnlsy,
mcnlsz,
mcnlp)

  /* TRACE Component channel_0_analyzer_2_rotated [140] */
  mccoordschange(mcposrchannel_0_analyzer_2_rotated, mcrotrchannel_0_analyzer_2_rotated,
    &mcnlx,
    &mcnly,
    &mcnlz,
    &mcnlvx,
    &mcnlvy,
    &mcnlvz,
    &mcnlsx,
    &mcnlsy,
    &mcnlsz);
  /* define label inside component channel_0_analyzer_2_rotated (without coords transformations) */
  mcJumpTrace_channel_0_analyzer_2_rotated:
  SIG_MESSAGE("channel_0_analyzer_2_rotated (Trace)");
  mcDEBUG_COMP("channel_0_analyzer_2_rotated")
  mcDEBUG_STATE(
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp)
#define x mcnlx
#define y mcnly
#define z mcnlz
#define vx mcnlvx
#define vy mcnlvy
#define vz mcnlvz
#define t mcnlt
#define sx mcnlsx
#define sy mcnlsy
#define sz mcnlsz
#define p mcnlp

#define mcabsorbComp mcabsorbCompchannel_0_analyzer_2_rotated
  STORE_NEUTRON(140,
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp);
  mcScattered=0;
  mcRestore=0;
  mcNCounter[140]++;
  mcPCounter[140] += p;
  mcP2Counter[140] += p*p;
#define mccompcurname  channel_0_analyzer_2_rotated
#define mccompcurtype  Arm
#define mccompcurindex 140
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex
  /* Label for restoring  neutron */
  mcabsorbCompchannel_0_analyzer_2_rotated:
  if (RESTORE) /* restore if needed */
  { RESTORE_NEUTRON(140,
      mcnlx,
      mcnly,
      mcnlz,
      mcnlvx,
      mcnlvy,
      mcnlvz,
      mcnlt,
      mcnlsx,
      mcnlsy,
      mcnlsz,
      mcnlp); }
#undef mcabsorbComp
#undef p
#undef sz
#undef sy
#undef sx
#undef t
#undef vz
#undef vy
#undef vx
#undef z
#undef y
#undef x
  mcDEBUG_STATE(
mcnlx,
mcnly,
mcnlz,
mcnlvx,
mcnlvy,
mcnlvz,
mcnlt,
mcnlsx,
mcnlsy,
mcnlsz,
mcnlp)

  /* TRACE Component channel_0_analyzer_2_array_crystal_array_0 [141] */
  mccoordschange(mcposrchannel_0_analyzer_2_array_crystal_array_0, mcrotrchannel_0_analyzer_2_array_crystal_array_0,
    &mcnlx,
    &mcnly,
    &mcnlz,
    &mcnlvx,
    &mcnlvy,
    &mcnlvz,
    &mcnlsx,
    &mcnlsy,
    &mcnlsz);
  /* define label inside component channel_0_analyzer_2_array_crystal_array_0 (without coords transformations) */
  mcJumpTrace_channel_0_analyzer_2_array_crystal_array_0:
  SIG_MESSAGE("channel_0_analyzer_2_array_crystal_array_0 (Trace)");
  mcDEBUG_COMP("channel_0_analyzer_2_array_crystal_array_0")
  mcDEBUG_STATE(
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp)
#define x mcnlx
#define y mcnly
#define z mcnlz
#define vx mcnlvx
#define vy mcnlvy
#define vz mcnlvz
#define t mcnlt
#define sx mcnlsx
#define sy mcnlsy
#define sz mcnlsz
#define p mcnlp

#define mcabsorbComp mcabsorbCompchannel_0_analyzer_2_array_crystal_array_0
  STORE_NEUTRON(141,
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp);
  mcScattered=0;
  mcRestore=0;
  mcNCounter[141]++;
  mcPCounter[141] += p;
  mcP2Counter[141] += p*p;
#define mccompcurname  channel_0_analyzer_2_array_crystal_array_0
#define mccompcurtype  Union_box
#define mccompcurindex 141
#define loop_index mccchannel_0_analyzer_2_array_crystal_array_0_loop_index
#define this_box_volume mccchannel_0_analyzer_2_array_crystal_array_0_this_box_volume
#define global_geometry_element mccchannel_0_analyzer_2_array_crystal_array_0_global_geometry_element
#define this_box_storage mccchannel_0_analyzer_2_array_crystal_array_0_this_box_storage
{   /* Declarations of channel_0_analyzer_2_array_crystal_array_0=Union_box() SETTING parameters. */
char* material_string = mccchannel_0_analyzer_2_array_crystal_array_0_material_string;
MCNUM priority = mccchannel_0_analyzer_2_array_crystal_array_0_priority;
MCNUM xwidth = mccchannel_0_analyzer_2_array_crystal_array_0_xwidth;
MCNUM yheight = mccchannel_0_analyzer_2_array_crystal_array_0_yheight;
MCNUM zdepth = mccchannel_0_analyzer_2_array_crystal_array_0_zdepth;
MCNUM xwidth2 = mccchannel_0_analyzer_2_array_crystal_array_0_xwidth2;
MCNUM yheight2 = mccchannel_0_analyzer_2_array_crystal_array_0_yheight2;
MCNUM visualize = mccchannel_0_analyzer_2_array_crystal_array_0_visualize;
int target_index = mccchannel_0_analyzer_2_array_crystal_array_0_target_index;
MCNUM target_x = mccchannel_0_analyzer_2_array_crystal_array_0_target_x;
MCNUM target_y = mccchannel_0_analyzer_2_array_crystal_array_0_target_y;
MCNUM target_z = mccchannel_0_analyzer_2_array_crystal_array_0_target_z;
MCNUM focus_aw = mccchannel_0_analyzer_2_array_crystal_array_0_focus_aw;
MCNUM focus_ah = mccchannel_0_analyzer_2_array_crystal_array_0_focus_ah;
MCNUM focus_xw = mccchannel_0_analyzer_2_array_crystal_array_0_focus_xw;
MCNUM focus_xh = mccchannel_0_analyzer_2_array_crystal_array_0_focus_xh;
MCNUM focus_r = mccchannel_0_analyzer_2_array_crystal_array_0_focus_r;
MCNUM p_interact = mccchannel_0_analyzer_2_array_crystal_array_0_p_interact;
char* mask_string = mccchannel_0_analyzer_2_array_crystal_array_0_mask_string;
char* mask_setting = mccchannel_0_analyzer_2_array_crystal_array_0_mask_setting;
MCNUM number_of_activations = mccchannel_0_analyzer_2_array_crystal_array_0_number_of_activations;
}   /* End of channel_0_analyzer_2_array_crystal_array_0=Union_box() SETTING parameter declarations. */
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex
  /* Label for restoring  neutron */
  mcabsorbCompchannel_0_analyzer_2_array_crystal_array_0:
  if (RESTORE) /* restore if needed */
  { RESTORE_NEUTRON(141,
      mcnlx,
      mcnly,
      mcnlz,
      mcnlvx,
      mcnlvy,
      mcnlvz,
      mcnlt,
      mcnlsx,
      mcnlsy,
      mcnlsz,
      mcnlp); }
#undef mcabsorbComp
#undef p
#undef sz
#undef sy
#undef sx
#undef t
#undef vz
#undef vy
#undef vx
#undef z
#undef y
#undef x
  mcDEBUG_STATE(
mcnlx,
mcnly,
mcnlz,
mcnlvx,
mcnlvy,
mcnlvz,
mcnlt,
mcnlsx,
mcnlsy,
mcnlsz,
mcnlp)

  /* TRACE Component channel_0_analyzer_2_array_crystal_array_1 [142] */
  mccoordschange(mcposrchannel_0_analyzer_2_array_crystal_array_1, mcrotrchannel_0_analyzer_2_array_crystal_array_1,
    &mcnlx,
    &mcnly,
    &mcnlz,
    &mcnlvx,
    &mcnlvy,
    &mcnlvz,
    &mcnlsx,
    &mcnlsy,
    &mcnlsz);
  /* define label inside component channel_0_analyzer_2_array_crystal_array_1 (without coords transformations) */
  mcJumpTrace_channel_0_analyzer_2_array_crystal_array_1:
  SIG_MESSAGE("channel_0_analyzer_2_array_crystal_array_1 (Trace)");
  mcDEBUG_COMP("channel_0_analyzer_2_array_crystal_array_1")
  mcDEBUG_STATE(
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp)
#define x mcnlx
#define y mcnly
#define z mcnlz
#define vx mcnlvx
#define vy mcnlvy
#define vz mcnlvz
#define t mcnlt
#define sx mcnlsx
#define sy mcnlsy
#define sz mcnlsz
#define p mcnlp

#define mcabsorbComp mcabsorbCompchannel_0_analyzer_2_array_crystal_array_1
  STORE_NEUTRON(142,
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp);
  mcScattered=0;
  mcRestore=0;
  mcNCounter[142]++;
  mcPCounter[142] += p;
  mcP2Counter[142] += p*p;
#define mccompcurname  channel_0_analyzer_2_array_crystal_array_1
#define mccompcurtype  Union_box
#define mccompcurindex 142
#define loop_index mccchannel_0_analyzer_2_array_crystal_array_1_loop_index
#define this_box_volume mccchannel_0_analyzer_2_array_crystal_array_1_this_box_volume
#define global_geometry_element mccchannel_0_analyzer_2_array_crystal_array_1_global_geometry_element
#define this_box_storage mccchannel_0_analyzer_2_array_crystal_array_1_this_box_storage
{   /* Declarations of channel_0_analyzer_2_array_crystal_array_1=Union_box() SETTING parameters. */
char* material_string = mccchannel_0_analyzer_2_array_crystal_array_1_material_string;
MCNUM priority = mccchannel_0_analyzer_2_array_crystal_array_1_priority;
MCNUM xwidth = mccchannel_0_analyzer_2_array_crystal_array_1_xwidth;
MCNUM yheight = mccchannel_0_analyzer_2_array_crystal_array_1_yheight;
MCNUM zdepth = mccchannel_0_analyzer_2_array_crystal_array_1_zdepth;
MCNUM xwidth2 = mccchannel_0_analyzer_2_array_crystal_array_1_xwidth2;
MCNUM yheight2 = mccchannel_0_analyzer_2_array_crystal_array_1_yheight2;
MCNUM visualize = mccchannel_0_analyzer_2_array_crystal_array_1_visualize;
int target_index = mccchannel_0_analyzer_2_array_crystal_array_1_target_index;
MCNUM target_x = mccchannel_0_analyzer_2_array_crystal_array_1_target_x;
MCNUM target_y = mccchannel_0_analyzer_2_array_crystal_array_1_target_y;
MCNUM target_z = mccchannel_0_analyzer_2_array_crystal_array_1_target_z;
MCNUM focus_aw = mccchannel_0_analyzer_2_array_crystal_array_1_focus_aw;
MCNUM focus_ah = mccchannel_0_analyzer_2_array_crystal_array_1_focus_ah;
MCNUM focus_xw = mccchannel_0_analyzer_2_array_crystal_array_1_focus_xw;
MCNUM focus_xh = mccchannel_0_analyzer_2_array_crystal_array_1_focus_xh;
MCNUM focus_r = mccchannel_0_analyzer_2_array_crystal_array_1_focus_r;
MCNUM p_interact = mccchannel_0_analyzer_2_array_crystal_array_1_p_interact;
char* mask_string = mccchannel_0_analyzer_2_array_crystal_array_1_mask_string;
char* mask_setting = mccchannel_0_analyzer_2_array_crystal_array_1_mask_setting;
MCNUM number_of_activations = mccchannel_0_analyzer_2_array_crystal_array_1_number_of_activations;
}   /* End of channel_0_analyzer_2_array_crystal_array_1=Union_box() SETTING parameter declarations. */
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex
  /* Label for restoring  neutron */
  mcabsorbCompchannel_0_analyzer_2_array_crystal_array_1:
  if (RESTORE) /* restore if needed */
  { RESTORE_NEUTRON(142,
      mcnlx,
      mcnly,
      mcnlz,
      mcnlvx,
      mcnlvy,
      mcnlvz,
      mcnlt,
      mcnlsx,
      mcnlsy,
      mcnlsz,
      mcnlp); }
#undef mcabsorbComp
#undef p
#undef sz
#undef sy
#undef sx
#undef t
#undef vz
#undef vy
#undef vx
#undef z
#undef y
#undef x
  mcDEBUG_STATE(
mcnlx,
mcnly,
mcnlz,
mcnlvx,
mcnlvy,
mcnlvz,
mcnlt,
mcnlsx,
mcnlsy,
mcnlsz,
mcnlp)

  /* TRACE Component channel_0_analyzer_2_array_crystal_array_2 [143] */
  mccoordschange(mcposrchannel_0_analyzer_2_array_crystal_array_2, mcrotrchannel_0_analyzer_2_array_crystal_array_2,
    &mcnlx,
    &mcnly,
    &mcnlz,
    &mcnlvx,
    &mcnlvy,
    &mcnlvz,
    &mcnlsx,
    &mcnlsy,
    &mcnlsz);
  /* define label inside component channel_0_analyzer_2_array_crystal_array_2 (without coords transformations) */
  mcJumpTrace_channel_0_analyzer_2_array_crystal_array_2:
  SIG_MESSAGE("channel_0_analyzer_2_array_crystal_array_2 (Trace)");
  mcDEBUG_COMP("channel_0_analyzer_2_array_crystal_array_2")
  mcDEBUG_STATE(
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp)
#define x mcnlx
#define y mcnly
#define z mcnlz
#define vx mcnlvx
#define vy mcnlvy
#define vz mcnlvz
#define t mcnlt
#define sx mcnlsx
#define sy mcnlsy
#define sz mcnlsz
#define p mcnlp

#define mcabsorbComp mcabsorbCompchannel_0_analyzer_2_array_crystal_array_2
  STORE_NEUTRON(143,
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp);
  mcScattered=0;
  mcRestore=0;
  mcNCounter[143]++;
  mcPCounter[143] += p;
  mcP2Counter[143] += p*p;
#define mccompcurname  channel_0_analyzer_2_array_crystal_array_2
#define mccompcurtype  Union_box
#define mccompcurindex 143
#define loop_index mccchannel_0_analyzer_2_array_crystal_array_2_loop_index
#define this_box_volume mccchannel_0_analyzer_2_array_crystal_array_2_this_box_volume
#define global_geometry_element mccchannel_0_analyzer_2_array_crystal_array_2_global_geometry_element
#define this_box_storage mccchannel_0_analyzer_2_array_crystal_array_2_this_box_storage
{   /* Declarations of channel_0_analyzer_2_array_crystal_array_2=Union_box() SETTING parameters. */
char* material_string = mccchannel_0_analyzer_2_array_crystal_array_2_material_string;
MCNUM priority = mccchannel_0_analyzer_2_array_crystal_array_2_priority;
MCNUM xwidth = mccchannel_0_analyzer_2_array_crystal_array_2_xwidth;
MCNUM yheight = mccchannel_0_analyzer_2_array_crystal_array_2_yheight;
MCNUM zdepth = mccchannel_0_analyzer_2_array_crystal_array_2_zdepth;
MCNUM xwidth2 = mccchannel_0_analyzer_2_array_crystal_array_2_xwidth2;
MCNUM yheight2 = mccchannel_0_analyzer_2_array_crystal_array_2_yheight2;
MCNUM visualize = mccchannel_0_analyzer_2_array_crystal_array_2_visualize;
int target_index = mccchannel_0_analyzer_2_array_crystal_array_2_target_index;
MCNUM target_x = mccchannel_0_analyzer_2_array_crystal_array_2_target_x;
MCNUM target_y = mccchannel_0_analyzer_2_array_crystal_array_2_target_y;
MCNUM target_z = mccchannel_0_analyzer_2_array_crystal_array_2_target_z;
MCNUM focus_aw = mccchannel_0_analyzer_2_array_crystal_array_2_focus_aw;
MCNUM focus_ah = mccchannel_0_analyzer_2_array_crystal_array_2_focus_ah;
MCNUM focus_xw = mccchannel_0_analyzer_2_array_crystal_array_2_focus_xw;
MCNUM focus_xh = mccchannel_0_analyzer_2_array_crystal_array_2_focus_xh;
MCNUM focus_r = mccchannel_0_analyzer_2_array_crystal_array_2_focus_r;
MCNUM p_interact = mccchannel_0_analyzer_2_array_crystal_array_2_p_interact;
char* mask_string = mccchannel_0_analyzer_2_array_crystal_array_2_mask_string;
char* mask_setting = mccchannel_0_analyzer_2_array_crystal_array_2_mask_setting;
MCNUM number_of_activations = mccchannel_0_analyzer_2_array_crystal_array_2_number_of_activations;
}   /* End of channel_0_analyzer_2_array_crystal_array_2=Union_box() SETTING parameter declarations. */
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex
  /* Label for restoring  neutron */
  mcabsorbCompchannel_0_analyzer_2_array_crystal_array_2:
  if (RESTORE) /* restore if needed */
  { RESTORE_NEUTRON(143,
      mcnlx,
      mcnly,
      mcnlz,
      mcnlvx,
      mcnlvy,
      mcnlvz,
      mcnlt,
      mcnlsx,
      mcnlsy,
      mcnlsz,
      mcnlp); }
#undef mcabsorbComp
#undef p
#undef sz
#undef sy
#undef sx
#undef t
#undef vz
#undef vy
#undef vx
#undef z
#undef y
#undef x
  mcDEBUG_STATE(
mcnlx,
mcnly,
mcnlz,
mcnlvx,
mcnlvy,
mcnlvz,
mcnlt,
mcnlsx,
mcnlsy,
mcnlsz,
mcnlp)

  /* TRACE Component channel_0_analyzer_2_array_crystal_array_3 [144] */
  mccoordschange(mcposrchannel_0_analyzer_2_array_crystal_array_3, mcrotrchannel_0_analyzer_2_array_crystal_array_3,
    &mcnlx,
    &mcnly,
    &mcnlz,
    &mcnlvx,
    &mcnlvy,
    &mcnlvz,
    &mcnlsx,
    &mcnlsy,
    &mcnlsz);
  /* define label inside component channel_0_analyzer_2_array_crystal_array_3 (without coords transformations) */
  mcJumpTrace_channel_0_analyzer_2_array_crystal_array_3:
  SIG_MESSAGE("channel_0_analyzer_2_array_crystal_array_3 (Trace)");
  mcDEBUG_COMP("channel_0_analyzer_2_array_crystal_array_3")
  mcDEBUG_STATE(
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp)
#define x mcnlx
#define y mcnly
#define z mcnlz
#define vx mcnlvx
#define vy mcnlvy
#define vz mcnlvz
#define t mcnlt
#define sx mcnlsx
#define sy mcnlsy
#define sz mcnlsz
#define p mcnlp

#define mcabsorbComp mcabsorbCompchannel_0_analyzer_2_array_crystal_array_3
  STORE_NEUTRON(144,
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp);
  mcScattered=0;
  mcRestore=0;
  mcNCounter[144]++;
  mcPCounter[144] += p;
  mcP2Counter[144] += p*p;
#define mccompcurname  channel_0_analyzer_2_array_crystal_array_3
#define mccompcurtype  Union_box
#define mccompcurindex 144
#define loop_index mccchannel_0_analyzer_2_array_crystal_array_3_loop_index
#define this_box_volume mccchannel_0_analyzer_2_array_crystal_array_3_this_box_volume
#define global_geometry_element mccchannel_0_analyzer_2_array_crystal_array_3_global_geometry_element
#define this_box_storage mccchannel_0_analyzer_2_array_crystal_array_3_this_box_storage
{   /* Declarations of channel_0_analyzer_2_array_crystal_array_3=Union_box() SETTING parameters. */
char* material_string = mccchannel_0_analyzer_2_array_crystal_array_3_material_string;
MCNUM priority = mccchannel_0_analyzer_2_array_crystal_array_3_priority;
MCNUM xwidth = mccchannel_0_analyzer_2_array_crystal_array_3_xwidth;
MCNUM yheight = mccchannel_0_analyzer_2_array_crystal_array_3_yheight;
MCNUM zdepth = mccchannel_0_analyzer_2_array_crystal_array_3_zdepth;
MCNUM xwidth2 = mccchannel_0_analyzer_2_array_crystal_array_3_xwidth2;
MCNUM yheight2 = mccchannel_0_analyzer_2_array_crystal_array_3_yheight2;
MCNUM visualize = mccchannel_0_analyzer_2_array_crystal_array_3_visualize;
int target_index = mccchannel_0_analyzer_2_array_crystal_array_3_target_index;
MCNUM target_x = mccchannel_0_analyzer_2_array_crystal_array_3_target_x;
MCNUM target_y = mccchannel_0_analyzer_2_array_crystal_array_3_target_y;
MCNUM target_z = mccchannel_0_analyzer_2_array_crystal_array_3_target_z;
MCNUM focus_aw = mccchannel_0_analyzer_2_array_crystal_array_3_focus_aw;
MCNUM focus_ah = mccchannel_0_analyzer_2_array_crystal_array_3_focus_ah;
MCNUM focus_xw = mccchannel_0_analyzer_2_array_crystal_array_3_focus_xw;
MCNUM focus_xh = mccchannel_0_analyzer_2_array_crystal_array_3_focus_xh;
MCNUM focus_r = mccchannel_0_analyzer_2_array_crystal_array_3_focus_r;
MCNUM p_interact = mccchannel_0_analyzer_2_array_crystal_array_3_p_interact;
char* mask_string = mccchannel_0_analyzer_2_array_crystal_array_3_mask_string;
char* mask_setting = mccchannel_0_analyzer_2_array_crystal_array_3_mask_setting;
MCNUM number_of_activations = mccchannel_0_analyzer_2_array_crystal_array_3_number_of_activations;
}   /* End of channel_0_analyzer_2_array_crystal_array_3=Union_box() SETTING parameter declarations. */
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex
  /* Label for restoring  neutron */
  mcabsorbCompchannel_0_analyzer_2_array_crystal_array_3:
  if (RESTORE) /* restore if needed */
  { RESTORE_NEUTRON(144,
      mcnlx,
      mcnly,
      mcnlz,
      mcnlvx,
      mcnlvy,
      mcnlvz,
      mcnlt,
      mcnlsx,
      mcnlsy,
      mcnlsz,
      mcnlp); }
#undef mcabsorbComp
#undef p
#undef sz
#undef sy
#undef sx
#undef t
#undef vz
#undef vy
#undef vx
#undef z
#undef y
#undef x
  mcDEBUG_STATE(
mcnlx,
mcnly,
mcnlz,
mcnlvx,
mcnlvy,
mcnlvz,
mcnlt,
mcnlsx,
mcnlsy,
mcnlsz,
mcnlp)

  /* TRACE Component channel_0_analyzer_2_array_crystal_array_4 [145] */
  mccoordschange(mcposrchannel_0_analyzer_2_array_crystal_array_4, mcrotrchannel_0_analyzer_2_array_crystal_array_4,
    &mcnlx,
    &mcnly,
    &mcnlz,
    &mcnlvx,
    &mcnlvy,
    &mcnlvz,
    &mcnlsx,
    &mcnlsy,
    &mcnlsz);
  /* define label inside component channel_0_analyzer_2_array_crystal_array_4 (without coords transformations) */
  mcJumpTrace_channel_0_analyzer_2_array_crystal_array_4:
  SIG_MESSAGE("channel_0_analyzer_2_array_crystal_array_4 (Trace)");
  mcDEBUG_COMP("channel_0_analyzer_2_array_crystal_array_4")
  mcDEBUG_STATE(
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp)
#define x mcnlx
#define y mcnly
#define z mcnlz
#define vx mcnlvx
#define vy mcnlvy
#define vz mcnlvz
#define t mcnlt
#define sx mcnlsx
#define sy mcnlsy
#define sz mcnlsz
#define p mcnlp

#define mcabsorbComp mcabsorbCompchannel_0_analyzer_2_array_crystal_array_4
  STORE_NEUTRON(145,
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp);
  mcScattered=0;
  mcRestore=0;
  mcNCounter[145]++;
  mcPCounter[145] += p;
  mcP2Counter[145] += p*p;
#define mccompcurname  channel_0_analyzer_2_array_crystal_array_4
#define mccompcurtype  Union_box
#define mccompcurindex 145
#define loop_index mccchannel_0_analyzer_2_array_crystal_array_4_loop_index
#define this_box_volume mccchannel_0_analyzer_2_array_crystal_array_4_this_box_volume
#define global_geometry_element mccchannel_0_analyzer_2_array_crystal_array_4_global_geometry_element
#define this_box_storage mccchannel_0_analyzer_2_array_crystal_array_4_this_box_storage
{   /* Declarations of channel_0_analyzer_2_array_crystal_array_4=Union_box() SETTING parameters. */
char* material_string = mccchannel_0_analyzer_2_array_crystal_array_4_material_string;
MCNUM priority = mccchannel_0_analyzer_2_array_crystal_array_4_priority;
MCNUM xwidth = mccchannel_0_analyzer_2_array_crystal_array_4_xwidth;
MCNUM yheight = mccchannel_0_analyzer_2_array_crystal_array_4_yheight;
MCNUM zdepth = mccchannel_0_analyzer_2_array_crystal_array_4_zdepth;
MCNUM xwidth2 = mccchannel_0_analyzer_2_array_crystal_array_4_xwidth2;
MCNUM yheight2 = mccchannel_0_analyzer_2_array_crystal_array_4_yheight2;
MCNUM visualize = mccchannel_0_analyzer_2_array_crystal_array_4_visualize;
int target_index = mccchannel_0_analyzer_2_array_crystal_array_4_target_index;
MCNUM target_x = mccchannel_0_analyzer_2_array_crystal_array_4_target_x;
MCNUM target_y = mccchannel_0_analyzer_2_array_crystal_array_4_target_y;
MCNUM target_z = mccchannel_0_analyzer_2_array_crystal_array_4_target_z;
MCNUM focus_aw = mccchannel_0_analyzer_2_array_crystal_array_4_focus_aw;
MCNUM focus_ah = mccchannel_0_analyzer_2_array_crystal_array_4_focus_ah;
MCNUM focus_xw = mccchannel_0_analyzer_2_array_crystal_array_4_focus_xw;
MCNUM focus_xh = mccchannel_0_analyzer_2_array_crystal_array_4_focus_xh;
MCNUM focus_r = mccchannel_0_analyzer_2_array_crystal_array_4_focus_r;
MCNUM p_interact = mccchannel_0_analyzer_2_array_crystal_array_4_p_interact;
char* mask_string = mccchannel_0_analyzer_2_array_crystal_array_4_mask_string;
char* mask_setting = mccchannel_0_analyzer_2_array_crystal_array_4_mask_setting;
MCNUM number_of_activations = mccchannel_0_analyzer_2_array_crystal_array_4_number_of_activations;
}   /* End of channel_0_analyzer_2_array_crystal_array_4=Union_box() SETTING parameter declarations. */
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex
  /* Label for restoring  neutron */
  mcabsorbCompchannel_0_analyzer_2_array_crystal_array_4:
  if (RESTORE) /* restore if needed */
  { RESTORE_NEUTRON(145,
      mcnlx,
      mcnly,
      mcnlz,
      mcnlvx,
      mcnlvy,
      mcnlvz,
      mcnlt,
      mcnlsx,
      mcnlsy,
      mcnlsz,
      mcnlp); }
#undef mcabsorbComp
#undef p
#undef sz
#undef sy
#undef sx
#undef t
#undef vz
#undef vy
#undef vx
#undef z
#undef y
#undef x
  mcDEBUG_STATE(
mcnlx,
mcnly,
mcnlz,
mcnlvx,
mcnlvy,
mcnlvz,
mcnlt,
mcnlsx,
mcnlsy,
mcnlsz,
mcnlp)

  /* TRACE Component channel_0_analyzer_2_array_crystal_array_5 [146] */
  mccoordschange(mcposrchannel_0_analyzer_2_array_crystal_array_5, mcrotrchannel_0_analyzer_2_array_crystal_array_5,
    &mcnlx,
    &mcnly,
    &mcnlz,
    &mcnlvx,
    &mcnlvy,
    &mcnlvz,
    &mcnlsx,
    &mcnlsy,
    &mcnlsz);
  /* define label inside component channel_0_analyzer_2_array_crystal_array_5 (without coords transformations) */
  mcJumpTrace_channel_0_analyzer_2_array_crystal_array_5:
  SIG_MESSAGE("channel_0_analyzer_2_array_crystal_array_5 (Trace)");
  mcDEBUG_COMP("channel_0_analyzer_2_array_crystal_array_5")
  mcDEBUG_STATE(
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp)
#define x mcnlx
#define y mcnly
#define z mcnlz
#define vx mcnlvx
#define vy mcnlvy
#define vz mcnlvz
#define t mcnlt
#define sx mcnlsx
#define sy mcnlsy
#define sz mcnlsz
#define p mcnlp

#define mcabsorbComp mcabsorbCompchannel_0_analyzer_2_array_crystal_array_5
  STORE_NEUTRON(146,
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp);
  mcScattered=0;
  mcRestore=0;
  mcNCounter[146]++;
  mcPCounter[146] += p;
  mcP2Counter[146] += p*p;
#define mccompcurname  channel_0_analyzer_2_array_crystal_array_5
#define mccompcurtype  Union_box
#define mccompcurindex 146
#define loop_index mccchannel_0_analyzer_2_array_crystal_array_5_loop_index
#define this_box_volume mccchannel_0_analyzer_2_array_crystal_array_5_this_box_volume
#define global_geometry_element mccchannel_0_analyzer_2_array_crystal_array_5_global_geometry_element
#define this_box_storage mccchannel_0_analyzer_2_array_crystal_array_5_this_box_storage
{   /* Declarations of channel_0_analyzer_2_array_crystal_array_5=Union_box() SETTING parameters. */
char* material_string = mccchannel_0_analyzer_2_array_crystal_array_5_material_string;
MCNUM priority = mccchannel_0_analyzer_2_array_crystal_array_5_priority;
MCNUM xwidth = mccchannel_0_analyzer_2_array_crystal_array_5_xwidth;
MCNUM yheight = mccchannel_0_analyzer_2_array_crystal_array_5_yheight;
MCNUM zdepth = mccchannel_0_analyzer_2_array_crystal_array_5_zdepth;
MCNUM xwidth2 = mccchannel_0_analyzer_2_array_crystal_array_5_xwidth2;
MCNUM yheight2 = mccchannel_0_analyzer_2_array_crystal_array_5_yheight2;
MCNUM visualize = mccchannel_0_analyzer_2_array_crystal_array_5_visualize;
int target_index = mccchannel_0_analyzer_2_array_crystal_array_5_target_index;
MCNUM target_x = mccchannel_0_analyzer_2_array_crystal_array_5_target_x;
MCNUM target_y = mccchannel_0_analyzer_2_array_crystal_array_5_target_y;
MCNUM target_z = mccchannel_0_analyzer_2_array_crystal_array_5_target_z;
MCNUM focus_aw = mccchannel_0_analyzer_2_array_crystal_array_5_focus_aw;
MCNUM focus_ah = mccchannel_0_analyzer_2_array_crystal_array_5_focus_ah;
MCNUM focus_xw = mccchannel_0_analyzer_2_array_crystal_array_5_focus_xw;
MCNUM focus_xh = mccchannel_0_analyzer_2_array_crystal_array_5_focus_xh;
MCNUM focus_r = mccchannel_0_analyzer_2_array_crystal_array_5_focus_r;
MCNUM p_interact = mccchannel_0_analyzer_2_array_crystal_array_5_p_interact;
char* mask_string = mccchannel_0_analyzer_2_array_crystal_array_5_mask_string;
char* mask_setting = mccchannel_0_analyzer_2_array_crystal_array_5_mask_setting;
MCNUM number_of_activations = mccchannel_0_analyzer_2_array_crystal_array_5_number_of_activations;
}   /* End of channel_0_analyzer_2_array_crystal_array_5=Union_box() SETTING parameter declarations. */
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex
  /* Label for restoring  neutron */
  mcabsorbCompchannel_0_analyzer_2_array_crystal_array_5:
  if (RESTORE) /* restore if needed */
  { RESTORE_NEUTRON(146,
      mcnlx,
      mcnly,
      mcnlz,
      mcnlvx,
      mcnlvy,
      mcnlvz,
      mcnlt,
      mcnlsx,
      mcnlsy,
      mcnlsz,
      mcnlp); }
#undef mcabsorbComp
#undef p
#undef sz
#undef sy
#undef sx
#undef t
#undef vz
#undef vy
#undef vx
#undef z
#undef y
#undef x
  mcDEBUG_STATE(
mcnlx,
mcnly,
mcnlz,
mcnlvx,
mcnlvy,
mcnlvz,
mcnlt,
mcnlsx,
mcnlsy,
mcnlsz,
mcnlp)

  /* TRACE Component channel_0_analyzer_2_array_crystal_array_6 [147] */
  mccoordschange(mcposrchannel_0_analyzer_2_array_crystal_array_6, mcrotrchannel_0_analyzer_2_array_crystal_array_6,
    &mcnlx,
    &mcnly,
    &mcnlz,
    &mcnlvx,
    &mcnlvy,
    &mcnlvz,
    &mcnlsx,
    &mcnlsy,
    &mcnlsz);
  /* define label inside component channel_0_analyzer_2_array_crystal_array_6 (without coords transformations) */
  mcJumpTrace_channel_0_analyzer_2_array_crystal_array_6:
  SIG_MESSAGE("channel_0_analyzer_2_array_crystal_array_6 (Trace)");
  mcDEBUG_COMP("channel_0_analyzer_2_array_crystal_array_6")
  mcDEBUG_STATE(
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp)
#define x mcnlx
#define y mcnly
#define z mcnlz
#define vx mcnlvx
#define vy mcnlvy
#define vz mcnlvz
#define t mcnlt
#define sx mcnlsx
#define sy mcnlsy
#define sz mcnlsz
#define p mcnlp

#define mcabsorbComp mcabsorbCompchannel_0_analyzer_2_array_crystal_array_6
  STORE_NEUTRON(147,
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp);
  mcScattered=0;
  mcRestore=0;
  mcNCounter[147]++;
  mcPCounter[147] += p;
  mcP2Counter[147] += p*p;
#define mccompcurname  channel_0_analyzer_2_array_crystal_array_6
#define mccompcurtype  Union_box
#define mccompcurindex 147
#define loop_index mccchannel_0_analyzer_2_array_crystal_array_6_loop_index
#define this_box_volume mccchannel_0_analyzer_2_array_crystal_array_6_this_box_volume
#define global_geometry_element mccchannel_0_analyzer_2_array_crystal_array_6_global_geometry_element
#define this_box_storage mccchannel_0_analyzer_2_array_crystal_array_6_this_box_storage
{   /* Declarations of channel_0_analyzer_2_array_crystal_array_6=Union_box() SETTING parameters. */
char* material_string = mccchannel_0_analyzer_2_array_crystal_array_6_material_string;
MCNUM priority = mccchannel_0_analyzer_2_array_crystal_array_6_priority;
MCNUM xwidth = mccchannel_0_analyzer_2_array_crystal_array_6_xwidth;
MCNUM yheight = mccchannel_0_analyzer_2_array_crystal_array_6_yheight;
MCNUM zdepth = mccchannel_0_analyzer_2_array_crystal_array_6_zdepth;
MCNUM xwidth2 = mccchannel_0_analyzer_2_array_crystal_array_6_xwidth2;
MCNUM yheight2 = mccchannel_0_analyzer_2_array_crystal_array_6_yheight2;
MCNUM visualize = mccchannel_0_analyzer_2_array_crystal_array_6_visualize;
int target_index = mccchannel_0_analyzer_2_array_crystal_array_6_target_index;
MCNUM target_x = mccchannel_0_analyzer_2_array_crystal_array_6_target_x;
MCNUM target_y = mccchannel_0_analyzer_2_array_crystal_array_6_target_y;
MCNUM target_z = mccchannel_0_analyzer_2_array_crystal_array_6_target_z;
MCNUM focus_aw = mccchannel_0_analyzer_2_array_crystal_array_6_focus_aw;
MCNUM focus_ah = mccchannel_0_analyzer_2_array_crystal_array_6_focus_ah;
MCNUM focus_xw = mccchannel_0_analyzer_2_array_crystal_array_6_focus_xw;
MCNUM focus_xh = mccchannel_0_analyzer_2_array_crystal_array_6_focus_xh;
MCNUM focus_r = mccchannel_0_analyzer_2_array_crystal_array_6_focus_r;
MCNUM p_interact = mccchannel_0_analyzer_2_array_crystal_array_6_p_interact;
char* mask_string = mccchannel_0_analyzer_2_array_crystal_array_6_mask_string;
char* mask_setting = mccchannel_0_analyzer_2_array_crystal_array_6_mask_setting;
MCNUM number_of_activations = mccchannel_0_analyzer_2_array_crystal_array_6_number_of_activations;
}   /* End of channel_0_analyzer_2_array_crystal_array_6=Union_box() SETTING parameter declarations. */
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex
  /* Label for restoring  neutron */
  mcabsorbCompchannel_0_analyzer_2_array_crystal_array_6:
  if (RESTORE) /* restore if needed */
  { RESTORE_NEUTRON(147,
      mcnlx,
      mcnly,
      mcnlz,
      mcnlvx,
      mcnlvy,
      mcnlvz,
      mcnlt,
      mcnlsx,
      mcnlsy,
      mcnlsz,
      mcnlp); }
#undef mcabsorbComp
#undef p
#undef sz
#undef sy
#undef sx
#undef t
#undef vz
#undef vy
#undef vx
#undef z
#undef y
#undef x
  mcDEBUG_STATE(
mcnlx,
mcnly,
mcnlz,
mcnlvx,
mcnlvy,
mcnlvz,
mcnlt,
mcnlsx,
mcnlsy,
mcnlsz,
mcnlp)

  /* TRACE Component channel_0_analyzer_2_array_crystal_array_7 [148] */
  mccoordschange(mcposrchannel_0_analyzer_2_array_crystal_array_7, mcrotrchannel_0_analyzer_2_array_crystal_array_7,
    &mcnlx,
    &mcnly,
    &mcnlz,
    &mcnlvx,
    &mcnlvy,
    &mcnlvz,
    &mcnlsx,
    &mcnlsy,
    &mcnlsz);
  /* define label inside component channel_0_analyzer_2_array_crystal_array_7 (without coords transformations) */
  mcJumpTrace_channel_0_analyzer_2_array_crystal_array_7:
  SIG_MESSAGE("channel_0_analyzer_2_array_crystal_array_7 (Trace)");
  mcDEBUG_COMP("channel_0_analyzer_2_array_crystal_array_7")
  mcDEBUG_STATE(
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp)
#define x mcnlx
#define y mcnly
#define z mcnlz
#define vx mcnlvx
#define vy mcnlvy
#define vz mcnlvz
#define t mcnlt
#define sx mcnlsx
#define sy mcnlsy
#define sz mcnlsz
#define p mcnlp

#define mcabsorbComp mcabsorbCompchannel_0_analyzer_2_array_crystal_array_7
  STORE_NEUTRON(148,
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp);
  mcScattered=0;
  mcRestore=0;
  mcNCounter[148]++;
  mcPCounter[148] += p;
  mcP2Counter[148] += p*p;
#define mccompcurname  channel_0_analyzer_2_array_crystal_array_7
#define mccompcurtype  Union_box
#define mccompcurindex 148
#define loop_index mccchannel_0_analyzer_2_array_crystal_array_7_loop_index
#define this_box_volume mccchannel_0_analyzer_2_array_crystal_array_7_this_box_volume
#define global_geometry_element mccchannel_0_analyzer_2_array_crystal_array_7_global_geometry_element
#define this_box_storage mccchannel_0_analyzer_2_array_crystal_array_7_this_box_storage
{   /* Declarations of channel_0_analyzer_2_array_crystal_array_7=Union_box() SETTING parameters. */
char* material_string = mccchannel_0_analyzer_2_array_crystal_array_7_material_string;
MCNUM priority = mccchannel_0_analyzer_2_array_crystal_array_7_priority;
MCNUM xwidth = mccchannel_0_analyzer_2_array_crystal_array_7_xwidth;
MCNUM yheight = mccchannel_0_analyzer_2_array_crystal_array_7_yheight;
MCNUM zdepth = mccchannel_0_analyzer_2_array_crystal_array_7_zdepth;
MCNUM xwidth2 = mccchannel_0_analyzer_2_array_crystal_array_7_xwidth2;
MCNUM yheight2 = mccchannel_0_analyzer_2_array_crystal_array_7_yheight2;
MCNUM visualize = mccchannel_0_analyzer_2_array_crystal_array_7_visualize;
int target_index = mccchannel_0_analyzer_2_array_crystal_array_7_target_index;
MCNUM target_x = mccchannel_0_analyzer_2_array_crystal_array_7_target_x;
MCNUM target_y = mccchannel_0_analyzer_2_array_crystal_array_7_target_y;
MCNUM target_z = mccchannel_0_analyzer_2_array_crystal_array_7_target_z;
MCNUM focus_aw = mccchannel_0_analyzer_2_array_crystal_array_7_focus_aw;
MCNUM focus_ah = mccchannel_0_analyzer_2_array_crystal_array_7_focus_ah;
MCNUM focus_xw = mccchannel_0_analyzer_2_array_crystal_array_7_focus_xw;
MCNUM focus_xh = mccchannel_0_analyzer_2_array_crystal_array_7_focus_xh;
MCNUM focus_r = mccchannel_0_analyzer_2_array_crystal_array_7_focus_r;
MCNUM p_interact = mccchannel_0_analyzer_2_array_crystal_array_7_p_interact;
char* mask_string = mccchannel_0_analyzer_2_array_crystal_array_7_mask_string;
char* mask_setting = mccchannel_0_analyzer_2_array_crystal_array_7_mask_setting;
MCNUM number_of_activations = mccchannel_0_analyzer_2_array_crystal_array_7_number_of_activations;
}   /* End of channel_0_analyzer_2_array_crystal_array_7=Union_box() SETTING parameter declarations. */
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex
  /* Label for restoring  neutron */
  mcabsorbCompchannel_0_analyzer_2_array_crystal_array_7:
  if (RESTORE) /* restore if needed */
  { RESTORE_NEUTRON(148,
      mcnlx,
      mcnly,
      mcnlz,
      mcnlvx,
      mcnlvy,
      mcnlvz,
      mcnlt,
      mcnlsx,
      mcnlsy,
      mcnlsz,
      mcnlp); }
#undef mcabsorbComp
#undef p
#undef sz
#undef sy
#undef sx
#undef t
#undef vz
#undef vy
#undef vx
#undef z
#undef y
#undef x
  mcDEBUG_STATE(
mcnlx,
mcnly,
mcnlz,
mcnlvx,
mcnlvy,
mcnlvz,
mcnlt,
mcnlsx,
mcnlsy,
mcnlsz,
mcnlp)

  /* TRACE Component channel_0_analyzer_2_array_crystal_array_8 [149] */
  mccoordschange(mcposrchannel_0_analyzer_2_array_crystal_array_8, mcrotrchannel_0_analyzer_2_array_crystal_array_8,
    &mcnlx,
    &mcnly,
    &mcnlz,
    &mcnlvx,
    &mcnlvy,
    &mcnlvz,
    &mcnlsx,
    &mcnlsy,
    &mcnlsz);
  /* define label inside component channel_0_analyzer_2_array_crystal_array_8 (without coords transformations) */
  mcJumpTrace_channel_0_analyzer_2_array_crystal_array_8:
  SIG_MESSAGE("channel_0_analyzer_2_array_crystal_array_8 (Trace)");
  mcDEBUG_COMP("channel_0_analyzer_2_array_crystal_array_8")
  mcDEBUG_STATE(
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp)
#define x mcnlx
#define y mcnly
#define z mcnlz
#define vx mcnlvx
#define vy mcnlvy
#define vz mcnlvz
#define t mcnlt
#define sx mcnlsx
#define sy mcnlsy
#define sz mcnlsz
#define p mcnlp

#define mcabsorbComp mcabsorbCompchannel_0_analyzer_2_array_crystal_array_8
  STORE_NEUTRON(149,
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp);
  mcScattered=0;
  mcRestore=0;
  mcNCounter[149]++;
  mcPCounter[149] += p;
  mcP2Counter[149] += p*p;
#define mccompcurname  channel_0_analyzer_2_array_crystal_array_8
#define mccompcurtype  Union_box
#define mccompcurindex 149
#define loop_index mccchannel_0_analyzer_2_array_crystal_array_8_loop_index
#define this_box_volume mccchannel_0_analyzer_2_array_crystal_array_8_this_box_volume
#define global_geometry_element mccchannel_0_analyzer_2_array_crystal_array_8_global_geometry_element
#define this_box_storage mccchannel_0_analyzer_2_array_crystal_array_8_this_box_storage
{   /* Declarations of channel_0_analyzer_2_array_crystal_array_8=Union_box() SETTING parameters. */
char* material_string = mccchannel_0_analyzer_2_array_crystal_array_8_material_string;
MCNUM priority = mccchannel_0_analyzer_2_array_crystal_array_8_priority;
MCNUM xwidth = mccchannel_0_analyzer_2_array_crystal_array_8_xwidth;
MCNUM yheight = mccchannel_0_analyzer_2_array_crystal_array_8_yheight;
MCNUM zdepth = mccchannel_0_analyzer_2_array_crystal_array_8_zdepth;
MCNUM xwidth2 = mccchannel_0_analyzer_2_array_crystal_array_8_xwidth2;
MCNUM yheight2 = mccchannel_0_analyzer_2_array_crystal_array_8_yheight2;
MCNUM visualize = mccchannel_0_analyzer_2_array_crystal_array_8_visualize;
int target_index = mccchannel_0_analyzer_2_array_crystal_array_8_target_index;
MCNUM target_x = mccchannel_0_analyzer_2_array_crystal_array_8_target_x;
MCNUM target_y = mccchannel_0_analyzer_2_array_crystal_array_8_target_y;
MCNUM target_z = mccchannel_0_analyzer_2_array_crystal_array_8_target_z;
MCNUM focus_aw = mccchannel_0_analyzer_2_array_crystal_array_8_focus_aw;
MCNUM focus_ah = mccchannel_0_analyzer_2_array_crystal_array_8_focus_ah;
MCNUM focus_xw = mccchannel_0_analyzer_2_array_crystal_array_8_focus_xw;
MCNUM focus_xh = mccchannel_0_analyzer_2_array_crystal_array_8_focus_xh;
MCNUM focus_r = mccchannel_0_analyzer_2_array_crystal_array_8_focus_r;
MCNUM p_interact = mccchannel_0_analyzer_2_array_crystal_array_8_p_interact;
char* mask_string = mccchannel_0_analyzer_2_array_crystal_array_8_mask_string;
char* mask_setting = mccchannel_0_analyzer_2_array_crystal_array_8_mask_setting;
MCNUM number_of_activations = mccchannel_0_analyzer_2_array_crystal_array_8_number_of_activations;
}   /* End of channel_0_analyzer_2_array_crystal_array_8=Union_box() SETTING parameter declarations. */
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex
  /* Label for restoring  neutron */
  mcabsorbCompchannel_0_analyzer_2_array_crystal_array_8:
  if (RESTORE) /* restore if needed */
  { RESTORE_NEUTRON(149,
      mcnlx,
      mcnly,
      mcnlz,
      mcnlvx,
      mcnlvy,
      mcnlvz,
      mcnlt,
      mcnlsx,
      mcnlsy,
      mcnlsz,
      mcnlp); }
#undef mcabsorbComp
#undef p
#undef sz
#undef sy
#undef sx
#undef t
#undef vz
#undef vy
#undef vx
#undef z
#undef y
#undef x
  mcDEBUG_STATE(
mcnlx,
mcnly,
mcnlz,
mcnlvx,
mcnlvy,
mcnlvz,
mcnlt,
mcnlsx,
mcnlsy,
mcnlsz,
mcnlp)

  /* TRACE Component channel_0_cave2_cyl1 [150] */
  mccoordschange(mcposrchannel_0_cave2_cyl1, mcrotrchannel_0_cave2_cyl1,
    &mcnlx,
    &mcnly,
    &mcnlz,
    &mcnlvx,
    &mcnlvy,
    &mcnlvz,
    &mcnlsx,
    &mcnlsy,
    &mcnlsz);
  /* define label inside component channel_0_cave2_cyl1 (without coords transformations) */
  mcJumpTrace_channel_0_cave2_cyl1:
  SIG_MESSAGE("channel_0_cave2_cyl1 (Trace)");
  mcDEBUG_COMP("channel_0_cave2_cyl1")
  mcDEBUG_STATE(
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp)
#define x mcnlx
#define y mcnly
#define z mcnlz
#define vx mcnlvx
#define vy mcnlvy
#define vz mcnlvz
#define t mcnlt
#define sx mcnlsx
#define sy mcnlsy
#define sz mcnlsz
#define p mcnlp

#define mcabsorbComp mcabsorbCompchannel_0_cave2_cyl1
  STORE_NEUTRON(150,
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp);
  mcScattered=0;
  mcRestore=0;
  mcNCounter[150]++;
  mcPCounter[150] += p;
  mcP2Counter[150] += p*p;
#define mccompcurname  channel_0_cave2_cyl1
#define mccompcurtype  Union_cylinder
#define mccompcurindex 150
#define loop_index mccchannel_0_cave2_cyl1_loop_index
#define this_cylinder_volume mccchannel_0_cave2_cyl1_this_cylinder_volume
#define global_geometry_element mccchannel_0_cave2_cyl1_global_geometry_element
#define this_cylinder_storage mccchannel_0_cave2_cyl1_this_cylinder_storage
{   /* Declarations of channel_0_cave2_cyl1=Union_cylinder() SETTING parameters. */
char* material_string = mccchannel_0_cave2_cyl1_material_string;
MCNUM priority = mccchannel_0_cave2_cyl1_priority;
MCNUM radius = mccchannel_0_cave2_cyl1_radius;
MCNUM yheight = mccchannel_0_cave2_cyl1_yheight;
MCNUM visualize = mccchannel_0_cave2_cyl1_visualize;
int target_index = mccchannel_0_cave2_cyl1_target_index;
MCNUM target_x = mccchannel_0_cave2_cyl1_target_x;
MCNUM target_y = mccchannel_0_cave2_cyl1_target_y;
MCNUM target_z = mccchannel_0_cave2_cyl1_target_z;
MCNUM focus_aw = mccchannel_0_cave2_cyl1_focus_aw;
MCNUM focus_ah = mccchannel_0_cave2_cyl1_focus_ah;
MCNUM focus_xw = mccchannel_0_cave2_cyl1_focus_xw;
MCNUM focus_xh = mccchannel_0_cave2_cyl1_focus_xh;
MCNUM focus_r = mccchannel_0_cave2_cyl1_focus_r;
MCNUM p_interact = mccchannel_0_cave2_cyl1_p_interact;
char* mask_string = mccchannel_0_cave2_cyl1_mask_string;
char* mask_setting = mccchannel_0_cave2_cyl1_mask_setting;
MCNUM number_of_activations = mccchannel_0_cave2_cyl1_number_of_activations;
#line 345 "Union_cylinder.comp"
{
dummy = 1;
}
#line 366018 "MACS_sample_kidney_box.c"
}   /* End of channel_0_cave2_cyl1=Union_cylinder() SETTING parameter declarations. */
#undef this_cylinder_storage
#undef global_geometry_element
#undef this_cylinder_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex
  /* Label for restoring  neutron */
  mcabsorbCompchannel_0_cave2_cyl1:
  if (RESTORE) /* restore if needed */
  { RESTORE_NEUTRON(150,
      mcnlx,
      mcnly,
      mcnlz,
      mcnlvx,
      mcnlvy,
      mcnlvz,
      mcnlt,
      mcnlsx,
      mcnlsy,
      mcnlsz,
      mcnlp); }
#undef mcabsorbComp
#undef p
#undef sz
#undef sy
#undef sx
#undef t
#undef vz
#undef vy
#undef vx
#undef z
#undef y
#undef x
  mcDEBUG_STATE(
mcnlx,
mcnly,
mcnlz,
mcnlvx,
mcnlvy,
mcnlvz,
mcnlt,
mcnlsx,
mcnlsy,
mcnlsz,
mcnlp)

  /* TRACE Component channel_0_cave2_box1 [151] */
  mccoordschange(mcposrchannel_0_cave2_box1, mcrotrchannel_0_cave2_box1,
    &mcnlx,
    &mcnly,
    &mcnlz,
    &mcnlvx,
    &mcnlvy,
    &mcnlvz,
    &mcnlsx,
    &mcnlsy,
    &mcnlsz);
  /* define label inside component channel_0_cave2_box1 (without coords transformations) */
  mcJumpTrace_channel_0_cave2_box1:
  SIG_MESSAGE("channel_0_cave2_box1 (Trace)");
  mcDEBUG_COMP("channel_0_cave2_box1")
  mcDEBUG_STATE(
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp)
#define x mcnlx
#define y mcnly
#define z mcnlz
#define vx mcnlvx
#define vy mcnlvy
#define vz mcnlvz
#define t mcnlt
#define sx mcnlsx
#define sy mcnlsy
#define sz mcnlsz
#define p mcnlp

#define mcabsorbComp mcabsorbCompchannel_0_cave2_box1
  STORE_NEUTRON(151,
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp);
  mcScattered=0;
  mcRestore=0;
  mcNCounter[151]++;
  mcPCounter[151] += p;
  mcP2Counter[151] += p*p;
#define mccompcurname  channel_0_cave2_box1
#define mccompcurtype  Union_box
#define mccompcurindex 151
#define loop_index mccchannel_0_cave2_box1_loop_index
#define this_box_volume mccchannel_0_cave2_box1_this_box_volume
#define global_geometry_element mccchannel_0_cave2_box1_global_geometry_element
#define this_box_storage mccchannel_0_cave2_box1_this_box_storage
{   /* Declarations of channel_0_cave2_box1=Union_box() SETTING parameters. */
char* material_string = mccchannel_0_cave2_box1_material_string;
MCNUM priority = mccchannel_0_cave2_box1_priority;
MCNUM xwidth = mccchannel_0_cave2_box1_xwidth;
MCNUM yheight = mccchannel_0_cave2_box1_yheight;
MCNUM zdepth = mccchannel_0_cave2_box1_zdepth;
MCNUM xwidth2 = mccchannel_0_cave2_box1_xwidth2;
MCNUM yheight2 = mccchannel_0_cave2_box1_yheight2;
MCNUM visualize = mccchannel_0_cave2_box1_visualize;
int target_index = mccchannel_0_cave2_box1_target_index;
MCNUM target_x = mccchannel_0_cave2_box1_target_x;
MCNUM target_y = mccchannel_0_cave2_box1_target_y;
MCNUM target_z = mccchannel_0_cave2_box1_target_z;
MCNUM focus_aw = mccchannel_0_cave2_box1_focus_aw;
MCNUM focus_ah = mccchannel_0_cave2_box1_focus_ah;
MCNUM focus_xw = mccchannel_0_cave2_box1_focus_xw;
MCNUM focus_xh = mccchannel_0_cave2_box1_focus_xh;
MCNUM focus_r = mccchannel_0_cave2_box1_focus_r;
MCNUM p_interact = mccchannel_0_cave2_box1_p_interact;
char* mask_string = mccchannel_0_cave2_box1_mask_string;
char* mask_setting = mccchannel_0_cave2_box1_mask_setting;
MCNUM number_of_activations = mccchannel_0_cave2_box1_number_of_activations;
}   /* End of channel_0_cave2_box1=Union_box() SETTING parameter declarations. */
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex
  /* Label for restoring  neutron */
  mcabsorbCompchannel_0_cave2_box1:
  if (RESTORE) /* restore if needed */
  { RESTORE_NEUTRON(151,
      mcnlx,
      mcnly,
      mcnlz,
      mcnlvx,
      mcnlvy,
      mcnlvz,
      mcnlt,
      mcnlsx,
      mcnlsy,
      mcnlsz,
      mcnlp); }
#undef mcabsorbComp
#undef p
#undef sz
#undef sy
#undef sx
#undef t
#undef vz
#undef vy
#undef vx
#undef z
#undef y
#undef x
  mcDEBUG_STATE(
mcnlx,
mcnly,
mcnlz,
mcnlvx,
mcnlvy,
mcnlvz,
mcnlt,
mcnlsx,
mcnlsy,
mcnlsz,
mcnlp)

  /* TRACE Component channel_0_cave2_box2 [152] */
  mccoordschange(mcposrchannel_0_cave2_box2, mcrotrchannel_0_cave2_box2,
    &mcnlx,
    &mcnly,
    &mcnlz,
    &mcnlvx,
    &mcnlvy,
    &mcnlvz,
    &mcnlsx,
    &mcnlsy,
    &mcnlsz);
  /* define label inside component channel_0_cave2_box2 (without coords transformations) */
  mcJumpTrace_channel_0_cave2_box2:
  SIG_MESSAGE("channel_0_cave2_box2 (Trace)");
  mcDEBUG_COMP("channel_0_cave2_box2")
  mcDEBUG_STATE(
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp)
#define x mcnlx
#define y mcnly
#define z mcnlz
#define vx mcnlvx
#define vy mcnlvy
#define vz mcnlvz
#define t mcnlt
#define sx mcnlsx
#define sy mcnlsy
#define sz mcnlsz
#define p mcnlp

#define mcabsorbComp mcabsorbCompchannel_0_cave2_box2
  STORE_NEUTRON(152,
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp);
  mcScattered=0;
  mcRestore=0;
  mcNCounter[152]++;
  mcPCounter[152] += p;
  mcP2Counter[152] += p*p;
#define mccompcurname  channel_0_cave2_box2
#define mccompcurtype  Union_box
#define mccompcurindex 152
#define loop_index mccchannel_0_cave2_box2_loop_index
#define this_box_volume mccchannel_0_cave2_box2_this_box_volume
#define global_geometry_element mccchannel_0_cave2_box2_global_geometry_element
#define this_box_storage mccchannel_0_cave2_box2_this_box_storage
{   /* Declarations of channel_0_cave2_box2=Union_box() SETTING parameters. */
char* material_string = mccchannel_0_cave2_box2_material_string;
MCNUM priority = mccchannel_0_cave2_box2_priority;
MCNUM xwidth = mccchannel_0_cave2_box2_xwidth;
MCNUM yheight = mccchannel_0_cave2_box2_yheight;
MCNUM zdepth = mccchannel_0_cave2_box2_zdepth;
MCNUM xwidth2 = mccchannel_0_cave2_box2_xwidth2;
MCNUM yheight2 = mccchannel_0_cave2_box2_yheight2;
MCNUM visualize = mccchannel_0_cave2_box2_visualize;
int target_index = mccchannel_0_cave2_box2_target_index;
MCNUM target_x = mccchannel_0_cave2_box2_target_x;
MCNUM target_y = mccchannel_0_cave2_box2_target_y;
MCNUM target_z = mccchannel_0_cave2_box2_target_z;
MCNUM focus_aw = mccchannel_0_cave2_box2_focus_aw;
MCNUM focus_ah = mccchannel_0_cave2_box2_focus_ah;
MCNUM focus_xw = mccchannel_0_cave2_box2_focus_xw;
MCNUM focus_xh = mccchannel_0_cave2_box2_focus_xh;
MCNUM focus_r = mccchannel_0_cave2_box2_focus_r;
MCNUM p_interact = mccchannel_0_cave2_box2_p_interact;
char* mask_string = mccchannel_0_cave2_box2_mask_string;
char* mask_setting = mccchannel_0_cave2_box2_mask_setting;
MCNUM number_of_activations = mccchannel_0_cave2_box2_number_of_activations;
}   /* End of channel_0_cave2_box2=Union_box() SETTING parameter declarations. */
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex
  /* Label for restoring  neutron */
  mcabsorbCompchannel_0_cave2_box2:
  if (RESTORE) /* restore if needed */
  { RESTORE_NEUTRON(152,
      mcnlx,
      mcnly,
      mcnlz,
      mcnlvx,
      mcnlvy,
      mcnlvz,
      mcnlt,
      mcnlsx,
      mcnlsy,
      mcnlsz,
      mcnlp); }
#undef mcabsorbComp
#undef p
#undef sz
#undef sy
#undef sx
#undef t
#undef vz
#undef vy
#undef vx
#undef z
#undef y
#undef x
  mcDEBUG_STATE(
mcnlx,
mcnly,
mcnlz,
mcnlvx,
mcnlvy,
mcnlvz,
mcnlt,
mcnlsx,
mcnlsy,
mcnlsz,
mcnlp)

  /* TRACE Component channel_0_cave2_box3 [153] */
  mccoordschange(mcposrchannel_0_cave2_box3, mcrotrchannel_0_cave2_box3,
    &mcnlx,
    &mcnly,
    &mcnlz,
    &mcnlvx,
    &mcnlvy,
    &mcnlvz,
    &mcnlsx,
    &mcnlsy,
    &mcnlsz);
  /* define label inside component channel_0_cave2_box3 (without coords transformations) */
  mcJumpTrace_channel_0_cave2_box3:
  SIG_MESSAGE("channel_0_cave2_box3 (Trace)");
  mcDEBUG_COMP("channel_0_cave2_box3")
  mcDEBUG_STATE(
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp)
#define x mcnlx
#define y mcnly
#define z mcnlz
#define vx mcnlvx
#define vy mcnlvy
#define vz mcnlvz
#define t mcnlt
#define sx mcnlsx
#define sy mcnlsy
#define sz mcnlsz
#define p mcnlp

#define mcabsorbComp mcabsorbCompchannel_0_cave2_box3
  STORE_NEUTRON(153,
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp);
  mcScattered=0;
  mcRestore=0;
  mcNCounter[153]++;
  mcPCounter[153] += p;
  mcP2Counter[153] += p*p;
#define mccompcurname  channel_0_cave2_box3
#define mccompcurtype  Union_box
#define mccompcurindex 153
#define loop_index mccchannel_0_cave2_box3_loop_index
#define this_box_volume mccchannel_0_cave2_box3_this_box_volume
#define global_geometry_element mccchannel_0_cave2_box3_global_geometry_element
#define this_box_storage mccchannel_0_cave2_box3_this_box_storage
{   /* Declarations of channel_0_cave2_box3=Union_box() SETTING parameters. */
char* material_string = mccchannel_0_cave2_box3_material_string;
MCNUM priority = mccchannel_0_cave2_box3_priority;
MCNUM xwidth = mccchannel_0_cave2_box3_xwidth;
MCNUM yheight = mccchannel_0_cave2_box3_yheight;
MCNUM zdepth = mccchannel_0_cave2_box3_zdepth;
MCNUM xwidth2 = mccchannel_0_cave2_box3_xwidth2;
MCNUM yheight2 = mccchannel_0_cave2_box3_yheight2;
MCNUM visualize = mccchannel_0_cave2_box3_visualize;
int target_index = mccchannel_0_cave2_box3_target_index;
MCNUM target_x = mccchannel_0_cave2_box3_target_x;
MCNUM target_y = mccchannel_0_cave2_box3_target_y;
MCNUM target_z = mccchannel_0_cave2_box3_target_z;
MCNUM focus_aw = mccchannel_0_cave2_box3_focus_aw;
MCNUM focus_ah = mccchannel_0_cave2_box3_focus_ah;
MCNUM focus_xw = mccchannel_0_cave2_box3_focus_xw;
MCNUM focus_xh = mccchannel_0_cave2_box3_focus_xh;
MCNUM focus_r = mccchannel_0_cave2_box3_focus_r;
MCNUM p_interact = mccchannel_0_cave2_box3_p_interact;
char* mask_string = mccchannel_0_cave2_box3_mask_string;
char* mask_setting = mccchannel_0_cave2_box3_mask_setting;
MCNUM number_of_activations = mccchannel_0_cave2_box3_number_of_activations;
}   /* End of channel_0_cave2_box3=Union_box() SETTING parameter declarations. */
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex
  /* Label for restoring  neutron */
  mcabsorbCompchannel_0_cave2_box3:
  if (RESTORE) /* restore if needed */
  { RESTORE_NEUTRON(153,
      mcnlx,
      mcnly,
      mcnlz,
      mcnlvx,
      mcnlvy,
      mcnlvz,
      mcnlt,
      mcnlsx,
      mcnlsy,
      mcnlsz,
      mcnlp); }
#undef mcabsorbComp
#undef p
#undef sz
#undef sy
#undef sx
#undef t
#undef vz
#undef vy
#undef vx
#undef z
#undef y
#undef x
  mcDEBUG_STATE(
mcnlx,
mcnly,
mcnlz,
mcnlvx,
mcnlvy,
mcnlvz,
mcnlt,
mcnlsx,
mcnlsy,
mcnlsz,
mcnlp)

  /* TRACE Component inter_analyzer_colimator_center_0 [154] */
  mccoordschange(mcposrinter_analyzer_colimator_center_0, mcrotrinter_analyzer_colimator_center_0,
    &mcnlx,
    &mcnly,
    &mcnlz,
    &mcnlvx,
    &mcnlvy,
    &mcnlvz,
    &mcnlsx,
    &mcnlsy,
    &mcnlsz);
  /* define label inside component inter_analyzer_colimator_center_0 (without coords transformations) */
  mcJumpTrace_inter_analyzer_colimator_center_0:
  SIG_MESSAGE("inter_analyzer_colimator_center_0 (Trace)");
  mcDEBUG_COMP("inter_analyzer_colimator_center_0")
  mcDEBUG_STATE(
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp)
#define x mcnlx
#define y mcnly
#define z mcnlz
#define vx mcnlvx
#define vy mcnlvy
#define vz mcnlvz
#define t mcnlt
#define sx mcnlsx
#define sy mcnlsy
#define sz mcnlsz
#define p mcnlp

#define mcabsorbComp mcabsorbCompinter_analyzer_colimator_center_0
  STORE_NEUTRON(154,
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp);
  mcScattered=0;
  mcRestore=0;
  mcNCounter[154]++;
  mcPCounter[154] += p;
  mcP2Counter[154] += p*p;
#define mccompcurname  inter_analyzer_colimator_center_0
#define mccompcurtype  Arm
#define mccompcurindex 154
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex
  /* Label for restoring  neutron */
  mcabsorbCompinter_analyzer_colimator_center_0:
  if (RESTORE) /* restore if needed */
  { RESTORE_NEUTRON(154,
      mcnlx,
      mcnly,
      mcnlz,
      mcnlvx,
      mcnlvy,
      mcnlvz,
      mcnlt,
      mcnlsx,
      mcnlsy,
      mcnlsz,
      mcnlp); }
#undef mcabsorbComp
#undef p
#undef sz
#undef sy
#undef sx
#undef t
#undef vz
#undef vy
#undef vx
#undef z
#undef y
#undef x
  mcDEBUG_STATE(
mcnlx,
mcnly,
mcnlz,
mcnlvx,
mcnlvy,
mcnlvz,
mcnlt,
mcnlsx,
mcnlsy,
mcnlsz,
mcnlp)

  /* TRACE Component inter_analyzer_colimator_0_blade_0 [155] */
  mccoordschange(mcposrinter_analyzer_colimator_0_blade_0, mcrotrinter_analyzer_colimator_0_blade_0,
    &mcnlx,
    &mcnly,
    &mcnlz,
    &mcnlvx,
    &mcnlvy,
    &mcnlvz,
    &mcnlsx,
    &mcnlsy,
    &mcnlsz);
  /* define label inside component inter_analyzer_colimator_0_blade_0 (without coords transformations) */
  mcJumpTrace_inter_analyzer_colimator_0_blade_0:
  SIG_MESSAGE("inter_analyzer_colimator_0_blade_0 (Trace)");
  mcDEBUG_COMP("inter_analyzer_colimator_0_blade_0")
  mcDEBUG_STATE(
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp)
#define x mcnlx
#define y mcnly
#define z mcnlz
#define vx mcnlvx
#define vy mcnlvy
#define vz mcnlvz
#define t mcnlt
#define sx mcnlsx
#define sy mcnlsy
#define sz mcnlsz
#define p mcnlp

#define mcabsorbComp mcabsorbCompinter_analyzer_colimator_0_blade_0
  STORE_NEUTRON(155,
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp);
  mcScattered=0;
  mcRestore=0;
  mcNCounter[155]++;
  mcPCounter[155] += p;
  mcP2Counter[155] += p*p;
#define mccompcurname  inter_analyzer_colimator_0_blade_0
#define mccompcurtype  Union_box
#define mccompcurindex 155
#define loop_index mccinter_analyzer_colimator_0_blade_0_loop_index
#define this_box_volume mccinter_analyzer_colimator_0_blade_0_this_box_volume
#define global_geometry_element mccinter_analyzer_colimator_0_blade_0_global_geometry_element
#define this_box_storage mccinter_analyzer_colimator_0_blade_0_this_box_storage
{   /* Declarations of inter_analyzer_colimator_0_blade_0=Union_box() SETTING parameters. */
char* material_string = mccinter_analyzer_colimator_0_blade_0_material_string;
MCNUM priority = mccinter_analyzer_colimator_0_blade_0_priority;
MCNUM xwidth = mccinter_analyzer_colimator_0_blade_0_xwidth;
MCNUM yheight = mccinter_analyzer_colimator_0_blade_0_yheight;
MCNUM zdepth = mccinter_analyzer_colimator_0_blade_0_zdepth;
MCNUM xwidth2 = mccinter_analyzer_colimator_0_blade_0_xwidth2;
MCNUM yheight2 = mccinter_analyzer_colimator_0_blade_0_yheight2;
MCNUM visualize = mccinter_analyzer_colimator_0_blade_0_visualize;
int target_index = mccinter_analyzer_colimator_0_blade_0_target_index;
MCNUM target_x = mccinter_analyzer_colimator_0_blade_0_target_x;
MCNUM target_y = mccinter_analyzer_colimator_0_blade_0_target_y;
MCNUM target_z = mccinter_analyzer_colimator_0_blade_0_target_z;
MCNUM focus_aw = mccinter_analyzer_colimator_0_blade_0_focus_aw;
MCNUM focus_ah = mccinter_analyzer_colimator_0_blade_0_focus_ah;
MCNUM focus_xw = mccinter_analyzer_colimator_0_blade_0_focus_xw;
MCNUM focus_xh = mccinter_analyzer_colimator_0_blade_0_focus_xh;
MCNUM focus_r = mccinter_analyzer_colimator_0_blade_0_focus_r;
MCNUM p_interact = mccinter_analyzer_colimator_0_blade_0_p_interact;
char* mask_string = mccinter_analyzer_colimator_0_blade_0_mask_string;
char* mask_setting = mccinter_analyzer_colimator_0_blade_0_mask_setting;
MCNUM number_of_activations = mccinter_analyzer_colimator_0_blade_0_number_of_activations;
}   /* End of inter_analyzer_colimator_0_blade_0=Union_box() SETTING parameter declarations. */
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex
  /* Label for restoring  neutron */
  mcabsorbCompinter_analyzer_colimator_0_blade_0:
  if (RESTORE) /* restore if needed */
  { RESTORE_NEUTRON(155,
      mcnlx,
      mcnly,
      mcnlz,
      mcnlvx,
      mcnlvy,
      mcnlvz,
      mcnlt,
      mcnlsx,
      mcnlsy,
      mcnlsz,
      mcnlp); }
#undef mcabsorbComp
#undef p
#undef sz
#undef sy
#undef sx
#undef t
#undef vz
#undef vy
#undef vx
#undef z
#undef y
#undef x
  mcDEBUG_STATE(
mcnlx,
mcnly,
mcnlz,
mcnlvx,
mcnlvy,
mcnlvz,
mcnlt,
mcnlsx,
mcnlsy,
mcnlsz,
mcnlp)

  /* TRACE Component inter_analyzer_colimator_0_blade_1 [156] */
  mccoordschange(mcposrinter_analyzer_colimator_0_blade_1, mcrotrinter_analyzer_colimator_0_blade_1,
    &mcnlx,
    &mcnly,
    &mcnlz,
    &mcnlvx,
    &mcnlvy,
    &mcnlvz,
    &mcnlsx,
    &mcnlsy,
    &mcnlsz);
  /* define label inside component inter_analyzer_colimator_0_blade_1 (without coords transformations) */
  mcJumpTrace_inter_analyzer_colimator_0_blade_1:
  SIG_MESSAGE("inter_analyzer_colimator_0_blade_1 (Trace)");
  mcDEBUG_COMP("inter_analyzer_colimator_0_blade_1")
  mcDEBUG_STATE(
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp)
#define x mcnlx
#define y mcnly
#define z mcnlz
#define vx mcnlvx
#define vy mcnlvy
#define vz mcnlvz
#define t mcnlt
#define sx mcnlsx
#define sy mcnlsy
#define sz mcnlsz
#define p mcnlp

#define mcabsorbComp mcabsorbCompinter_analyzer_colimator_0_blade_1
  STORE_NEUTRON(156,
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp);
  mcScattered=0;
  mcRestore=0;
  mcNCounter[156]++;
  mcPCounter[156] += p;
  mcP2Counter[156] += p*p;
#define mccompcurname  inter_analyzer_colimator_0_blade_1
#define mccompcurtype  Union_box
#define mccompcurindex 156
#define loop_index mccinter_analyzer_colimator_0_blade_1_loop_index
#define this_box_volume mccinter_analyzer_colimator_0_blade_1_this_box_volume
#define global_geometry_element mccinter_analyzer_colimator_0_blade_1_global_geometry_element
#define this_box_storage mccinter_analyzer_colimator_0_blade_1_this_box_storage
{   /* Declarations of inter_analyzer_colimator_0_blade_1=Union_box() SETTING parameters. */
char* material_string = mccinter_analyzer_colimator_0_blade_1_material_string;
MCNUM priority = mccinter_analyzer_colimator_0_blade_1_priority;
MCNUM xwidth = mccinter_analyzer_colimator_0_blade_1_xwidth;
MCNUM yheight = mccinter_analyzer_colimator_0_blade_1_yheight;
MCNUM zdepth = mccinter_analyzer_colimator_0_blade_1_zdepth;
MCNUM xwidth2 = mccinter_analyzer_colimator_0_blade_1_xwidth2;
MCNUM yheight2 = mccinter_analyzer_colimator_0_blade_1_yheight2;
MCNUM visualize = mccinter_analyzer_colimator_0_blade_1_visualize;
int target_index = mccinter_analyzer_colimator_0_blade_1_target_index;
MCNUM target_x = mccinter_analyzer_colimator_0_blade_1_target_x;
MCNUM target_y = mccinter_analyzer_colimator_0_blade_1_target_y;
MCNUM target_z = mccinter_analyzer_colimator_0_blade_1_target_z;
MCNUM focus_aw = mccinter_analyzer_colimator_0_blade_1_focus_aw;
MCNUM focus_ah = mccinter_analyzer_colimator_0_blade_1_focus_ah;
MCNUM focus_xw = mccinter_analyzer_colimator_0_blade_1_focus_xw;
MCNUM focus_xh = mccinter_analyzer_colimator_0_blade_1_focus_xh;
MCNUM focus_r = mccinter_analyzer_colimator_0_blade_1_focus_r;
MCNUM p_interact = mccinter_analyzer_colimator_0_blade_1_p_interact;
char* mask_string = mccinter_analyzer_colimator_0_blade_1_mask_string;
char* mask_setting = mccinter_analyzer_colimator_0_blade_1_mask_setting;
MCNUM number_of_activations = mccinter_analyzer_colimator_0_blade_1_number_of_activations;
}   /* End of inter_analyzer_colimator_0_blade_1=Union_box() SETTING parameter declarations. */
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex
  /* Label for restoring  neutron */
  mcabsorbCompinter_analyzer_colimator_0_blade_1:
  if (RESTORE) /* restore if needed */
  { RESTORE_NEUTRON(156,
      mcnlx,
      mcnly,
      mcnlz,
      mcnlvx,
      mcnlvy,
      mcnlvz,
      mcnlt,
      mcnlsx,
      mcnlsy,
      mcnlsz,
      mcnlp); }
#undef mcabsorbComp
#undef p
#undef sz
#undef sy
#undef sx
#undef t
#undef vz
#undef vy
#undef vx
#undef z
#undef y
#undef x
  mcDEBUG_STATE(
mcnlx,
mcnly,
mcnlz,
mcnlvx,
mcnlvy,
mcnlvz,
mcnlt,
mcnlsx,
mcnlsy,
mcnlsz,
mcnlp)

  /* TRACE Component inter_analyzer_colimator_0_blade_2 [157] */
  mccoordschange(mcposrinter_analyzer_colimator_0_blade_2, mcrotrinter_analyzer_colimator_0_blade_2,
    &mcnlx,
    &mcnly,
    &mcnlz,
    &mcnlvx,
    &mcnlvy,
    &mcnlvz,
    &mcnlsx,
    &mcnlsy,
    &mcnlsz);
  /* define label inside component inter_analyzer_colimator_0_blade_2 (without coords transformations) */
  mcJumpTrace_inter_analyzer_colimator_0_blade_2:
  SIG_MESSAGE("inter_analyzer_colimator_0_blade_2 (Trace)");
  mcDEBUG_COMP("inter_analyzer_colimator_0_blade_2")
  mcDEBUG_STATE(
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp)
#define x mcnlx
#define y mcnly
#define z mcnlz
#define vx mcnlvx
#define vy mcnlvy
#define vz mcnlvz
#define t mcnlt
#define sx mcnlsx
#define sy mcnlsy
#define sz mcnlsz
#define p mcnlp

#define mcabsorbComp mcabsorbCompinter_analyzer_colimator_0_blade_2
  STORE_NEUTRON(157,
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp);
  mcScattered=0;
  mcRestore=0;
  mcNCounter[157]++;
  mcPCounter[157] += p;
  mcP2Counter[157] += p*p;
#define mccompcurname  inter_analyzer_colimator_0_blade_2
#define mccompcurtype  Union_box
#define mccompcurindex 157
#define loop_index mccinter_analyzer_colimator_0_blade_2_loop_index
#define this_box_volume mccinter_analyzer_colimator_0_blade_2_this_box_volume
#define global_geometry_element mccinter_analyzer_colimator_0_blade_2_global_geometry_element
#define this_box_storage mccinter_analyzer_colimator_0_blade_2_this_box_storage
{   /* Declarations of inter_analyzer_colimator_0_blade_2=Union_box() SETTING parameters. */
char* material_string = mccinter_analyzer_colimator_0_blade_2_material_string;
MCNUM priority = mccinter_analyzer_colimator_0_blade_2_priority;
MCNUM xwidth = mccinter_analyzer_colimator_0_blade_2_xwidth;
MCNUM yheight = mccinter_analyzer_colimator_0_blade_2_yheight;
MCNUM zdepth = mccinter_analyzer_colimator_0_blade_2_zdepth;
MCNUM xwidth2 = mccinter_analyzer_colimator_0_blade_2_xwidth2;
MCNUM yheight2 = mccinter_analyzer_colimator_0_blade_2_yheight2;
MCNUM visualize = mccinter_analyzer_colimator_0_blade_2_visualize;
int target_index = mccinter_analyzer_colimator_0_blade_2_target_index;
MCNUM target_x = mccinter_analyzer_colimator_0_blade_2_target_x;
MCNUM target_y = mccinter_analyzer_colimator_0_blade_2_target_y;
MCNUM target_z = mccinter_analyzer_colimator_0_blade_2_target_z;
MCNUM focus_aw = mccinter_analyzer_colimator_0_blade_2_focus_aw;
MCNUM focus_ah = mccinter_analyzer_colimator_0_blade_2_focus_ah;
MCNUM focus_xw = mccinter_analyzer_colimator_0_blade_2_focus_xw;
MCNUM focus_xh = mccinter_analyzer_colimator_0_blade_2_focus_xh;
MCNUM focus_r = mccinter_analyzer_colimator_0_blade_2_focus_r;
MCNUM p_interact = mccinter_analyzer_colimator_0_blade_2_p_interact;
char* mask_string = mccinter_analyzer_colimator_0_blade_2_mask_string;
char* mask_setting = mccinter_analyzer_colimator_0_blade_2_mask_setting;
MCNUM number_of_activations = mccinter_analyzer_colimator_0_blade_2_number_of_activations;
}   /* End of inter_analyzer_colimator_0_blade_2=Union_box() SETTING parameter declarations. */
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex
  /* Label for restoring  neutron */
  mcabsorbCompinter_analyzer_colimator_0_blade_2:
  if (RESTORE) /* restore if needed */
  { RESTORE_NEUTRON(157,
      mcnlx,
      mcnly,
      mcnlz,
      mcnlvx,
      mcnlvy,
      mcnlvz,
      mcnlt,
      mcnlsx,
      mcnlsy,
      mcnlsz,
      mcnlp); }
#undef mcabsorbComp
#undef p
#undef sz
#undef sy
#undef sx
#undef t
#undef vz
#undef vy
#undef vx
#undef z
#undef y
#undef x
  mcDEBUG_STATE(
mcnlx,
mcnly,
mcnlz,
mcnlvx,
mcnlvy,
mcnlvz,
mcnlt,
mcnlsx,
mcnlsy,
mcnlsz,
mcnlp)

  /* TRACE Component inter_analyzer_colimator_0_blade_3 [158] */
  mccoordschange(mcposrinter_analyzer_colimator_0_blade_3, mcrotrinter_analyzer_colimator_0_blade_3,
    &mcnlx,
    &mcnly,
    &mcnlz,
    &mcnlvx,
    &mcnlvy,
    &mcnlvz,
    &mcnlsx,
    &mcnlsy,
    &mcnlsz);
  /* define label inside component inter_analyzer_colimator_0_blade_3 (without coords transformations) */
  mcJumpTrace_inter_analyzer_colimator_0_blade_3:
  SIG_MESSAGE("inter_analyzer_colimator_0_blade_3 (Trace)");
  mcDEBUG_COMP("inter_analyzer_colimator_0_blade_3")
  mcDEBUG_STATE(
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp)
#define x mcnlx
#define y mcnly
#define z mcnlz
#define vx mcnlvx
#define vy mcnlvy
#define vz mcnlvz
#define t mcnlt
#define sx mcnlsx
#define sy mcnlsy
#define sz mcnlsz
#define p mcnlp

#define mcabsorbComp mcabsorbCompinter_analyzer_colimator_0_blade_3
  STORE_NEUTRON(158,
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp);
  mcScattered=0;
  mcRestore=0;
  mcNCounter[158]++;
  mcPCounter[158] += p;
  mcP2Counter[158] += p*p;
#define mccompcurname  inter_analyzer_colimator_0_blade_3
#define mccompcurtype  Union_box
#define mccompcurindex 158
#define loop_index mccinter_analyzer_colimator_0_blade_3_loop_index
#define this_box_volume mccinter_analyzer_colimator_0_blade_3_this_box_volume
#define global_geometry_element mccinter_analyzer_colimator_0_blade_3_global_geometry_element
#define this_box_storage mccinter_analyzer_colimator_0_blade_3_this_box_storage
{   /* Declarations of inter_analyzer_colimator_0_blade_3=Union_box() SETTING parameters. */
char* material_string = mccinter_analyzer_colimator_0_blade_3_material_string;
MCNUM priority = mccinter_analyzer_colimator_0_blade_3_priority;
MCNUM xwidth = mccinter_analyzer_colimator_0_blade_3_xwidth;
MCNUM yheight = mccinter_analyzer_colimator_0_blade_3_yheight;
MCNUM zdepth = mccinter_analyzer_colimator_0_blade_3_zdepth;
MCNUM xwidth2 = mccinter_analyzer_colimator_0_blade_3_xwidth2;
MCNUM yheight2 = mccinter_analyzer_colimator_0_blade_3_yheight2;
MCNUM visualize = mccinter_analyzer_colimator_0_blade_3_visualize;
int target_index = mccinter_analyzer_colimator_0_blade_3_target_index;
MCNUM target_x = mccinter_analyzer_colimator_0_blade_3_target_x;
MCNUM target_y = mccinter_analyzer_colimator_0_blade_3_target_y;
MCNUM target_z = mccinter_analyzer_colimator_0_blade_3_target_z;
MCNUM focus_aw = mccinter_analyzer_colimator_0_blade_3_focus_aw;
MCNUM focus_ah = mccinter_analyzer_colimator_0_blade_3_focus_ah;
MCNUM focus_xw = mccinter_analyzer_colimator_0_blade_3_focus_xw;
MCNUM focus_xh = mccinter_analyzer_colimator_0_blade_3_focus_xh;
MCNUM focus_r = mccinter_analyzer_colimator_0_blade_3_focus_r;
MCNUM p_interact = mccinter_analyzer_colimator_0_blade_3_p_interact;
char* mask_string = mccinter_analyzer_colimator_0_blade_3_mask_string;
char* mask_setting = mccinter_analyzer_colimator_0_blade_3_mask_setting;
MCNUM number_of_activations = mccinter_analyzer_colimator_0_blade_3_number_of_activations;
}   /* End of inter_analyzer_colimator_0_blade_3=Union_box() SETTING parameter declarations. */
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex
  /* Label for restoring  neutron */
  mcabsorbCompinter_analyzer_colimator_0_blade_3:
  if (RESTORE) /* restore if needed */
  { RESTORE_NEUTRON(158,
      mcnlx,
      mcnly,
      mcnlz,
      mcnlvx,
      mcnlvy,
      mcnlvz,
      mcnlt,
      mcnlsx,
      mcnlsy,
      mcnlsz,
      mcnlp); }
#undef mcabsorbComp
#undef p
#undef sz
#undef sy
#undef sx
#undef t
#undef vz
#undef vy
#undef vx
#undef z
#undef y
#undef x
  mcDEBUG_STATE(
mcnlx,
mcnly,
mcnlz,
mcnlvx,
mcnlvy,
mcnlvz,
mcnlt,
mcnlsx,
mcnlsy,
mcnlsz,
mcnlp)

  /* TRACE Component inter_analyzer_colimator_0_blade_4 [159] */
  mccoordschange(mcposrinter_analyzer_colimator_0_blade_4, mcrotrinter_analyzer_colimator_0_blade_4,
    &mcnlx,
    &mcnly,
    &mcnlz,
    &mcnlvx,
    &mcnlvy,
    &mcnlvz,
    &mcnlsx,
    &mcnlsy,
    &mcnlsz);
  /* define label inside component inter_analyzer_colimator_0_blade_4 (without coords transformations) */
  mcJumpTrace_inter_analyzer_colimator_0_blade_4:
  SIG_MESSAGE("inter_analyzer_colimator_0_blade_4 (Trace)");
  mcDEBUG_COMP("inter_analyzer_colimator_0_blade_4")
  mcDEBUG_STATE(
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp)
#define x mcnlx
#define y mcnly
#define z mcnlz
#define vx mcnlvx
#define vy mcnlvy
#define vz mcnlvz
#define t mcnlt
#define sx mcnlsx
#define sy mcnlsy
#define sz mcnlsz
#define p mcnlp

#define mcabsorbComp mcabsorbCompinter_analyzer_colimator_0_blade_4
  STORE_NEUTRON(159,
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp);
  mcScattered=0;
  mcRestore=0;
  mcNCounter[159]++;
  mcPCounter[159] += p;
  mcP2Counter[159] += p*p;
#define mccompcurname  inter_analyzer_colimator_0_blade_4
#define mccompcurtype  Union_box
#define mccompcurindex 159
#define loop_index mccinter_analyzer_colimator_0_blade_4_loop_index
#define this_box_volume mccinter_analyzer_colimator_0_blade_4_this_box_volume
#define global_geometry_element mccinter_analyzer_colimator_0_blade_4_global_geometry_element
#define this_box_storage mccinter_analyzer_colimator_0_blade_4_this_box_storage
{   /* Declarations of inter_analyzer_colimator_0_blade_4=Union_box() SETTING parameters. */
char* material_string = mccinter_analyzer_colimator_0_blade_4_material_string;
MCNUM priority = mccinter_analyzer_colimator_0_blade_4_priority;
MCNUM xwidth = mccinter_analyzer_colimator_0_blade_4_xwidth;
MCNUM yheight = mccinter_analyzer_colimator_0_blade_4_yheight;
MCNUM zdepth = mccinter_analyzer_colimator_0_blade_4_zdepth;
MCNUM xwidth2 = mccinter_analyzer_colimator_0_blade_4_xwidth2;
MCNUM yheight2 = mccinter_analyzer_colimator_0_blade_4_yheight2;
MCNUM visualize = mccinter_analyzer_colimator_0_blade_4_visualize;
int target_index = mccinter_analyzer_colimator_0_blade_4_target_index;
MCNUM target_x = mccinter_analyzer_colimator_0_blade_4_target_x;
MCNUM target_y = mccinter_analyzer_colimator_0_blade_4_target_y;
MCNUM target_z = mccinter_analyzer_colimator_0_blade_4_target_z;
MCNUM focus_aw = mccinter_analyzer_colimator_0_blade_4_focus_aw;
MCNUM focus_ah = mccinter_analyzer_colimator_0_blade_4_focus_ah;
MCNUM focus_xw = mccinter_analyzer_colimator_0_blade_4_focus_xw;
MCNUM focus_xh = mccinter_analyzer_colimator_0_blade_4_focus_xh;
MCNUM focus_r = mccinter_analyzer_colimator_0_blade_4_focus_r;
MCNUM p_interact = mccinter_analyzer_colimator_0_blade_4_p_interact;
char* mask_string = mccinter_analyzer_colimator_0_blade_4_mask_string;
char* mask_setting = mccinter_analyzer_colimator_0_blade_4_mask_setting;
MCNUM number_of_activations = mccinter_analyzer_colimator_0_blade_4_number_of_activations;
}   /* End of inter_analyzer_colimator_0_blade_4=Union_box() SETTING parameter declarations. */
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex
  /* Label for restoring  neutron */
  mcabsorbCompinter_analyzer_colimator_0_blade_4:
  if (RESTORE) /* restore if needed */
  { RESTORE_NEUTRON(159,
      mcnlx,
      mcnly,
      mcnlz,
      mcnlvx,
      mcnlvy,
      mcnlvz,
      mcnlt,
      mcnlsx,
      mcnlsy,
      mcnlsz,
      mcnlp); }
#undef mcabsorbComp
#undef p
#undef sz
#undef sy
#undef sx
#undef t
#undef vz
#undef vy
#undef vx
#undef z
#undef y
#undef x
  mcDEBUG_STATE(
mcnlx,
mcnly,
mcnlz,
mcnlvx,
mcnlvy,
mcnlvz,
mcnlt,
mcnlsx,
mcnlsy,
mcnlsz,
mcnlp)

  /* TRACE Component diffraction_detector_0_exit_volume [160] */
  mccoordschange(mcposrdiffraction_detector_0_exit_volume, mcrotrdiffraction_detector_0_exit_volume,
    &mcnlx,
    &mcnly,
    &mcnlz,
    &mcnlvx,
    &mcnlvy,
    &mcnlvz,
    &mcnlsx,
    &mcnlsy,
    &mcnlsz);
  /* define label inside component diffraction_detector_0_exit_volume (without coords transformations) */
  mcJumpTrace_diffraction_detector_0_exit_volume:
  SIG_MESSAGE("diffraction_detector_0_exit_volume (Trace)");
  mcDEBUG_COMP("diffraction_detector_0_exit_volume")
  mcDEBUG_STATE(
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp)
#define x mcnlx
#define y mcnly
#define z mcnlz
#define vx mcnlvx
#define vy mcnlvy
#define vz mcnlvz
#define t mcnlt
#define sx mcnlsx
#define sy mcnlsy
#define sz mcnlsz
#define p mcnlp

#define mcabsorbComp mcabsorbCompdiffraction_detector_0_exit_volume
  STORE_NEUTRON(160,
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp);
  mcScattered=0;
  mcRestore=0;
  mcNCounter[160]++;
  mcPCounter[160] += p;
  mcP2Counter[160] += p*p;
#define mccompcurname  diffraction_detector_0_exit_volume
#define mccompcurtype  Union_box
#define mccompcurindex 160
#define loop_index mccdiffraction_detector_0_exit_volume_loop_index
#define this_box_volume mccdiffraction_detector_0_exit_volume_this_box_volume
#define global_geometry_element mccdiffraction_detector_0_exit_volume_global_geometry_element
#define this_box_storage mccdiffraction_detector_0_exit_volume_this_box_storage
{   /* Declarations of diffraction_detector_0_exit_volume=Union_box() SETTING parameters. */
char* material_string = mccdiffraction_detector_0_exit_volume_material_string;
MCNUM priority = mccdiffraction_detector_0_exit_volume_priority;
MCNUM xwidth = mccdiffraction_detector_0_exit_volume_xwidth;
MCNUM yheight = mccdiffraction_detector_0_exit_volume_yheight;
MCNUM zdepth = mccdiffraction_detector_0_exit_volume_zdepth;
MCNUM xwidth2 = mccdiffraction_detector_0_exit_volume_xwidth2;
MCNUM yheight2 = mccdiffraction_detector_0_exit_volume_yheight2;
MCNUM visualize = mccdiffraction_detector_0_exit_volume_visualize;
int target_index = mccdiffraction_detector_0_exit_volume_target_index;
MCNUM target_x = mccdiffraction_detector_0_exit_volume_target_x;
MCNUM target_y = mccdiffraction_detector_0_exit_volume_target_y;
MCNUM target_z = mccdiffraction_detector_0_exit_volume_target_z;
MCNUM focus_aw = mccdiffraction_detector_0_exit_volume_focus_aw;
MCNUM focus_ah = mccdiffraction_detector_0_exit_volume_focus_ah;
MCNUM focus_xw = mccdiffraction_detector_0_exit_volume_focus_xw;
MCNUM focus_xh = mccdiffraction_detector_0_exit_volume_focus_xh;
MCNUM focus_r = mccdiffraction_detector_0_exit_volume_focus_r;
MCNUM p_interact = mccdiffraction_detector_0_exit_volume_p_interact;
char* mask_string = mccdiffraction_detector_0_exit_volume_mask_string;
char* mask_setting = mccdiffraction_detector_0_exit_volume_mask_setting;
MCNUM number_of_activations = mccdiffraction_detector_0_exit_volume_number_of_activations;
}   /* End of diffraction_detector_0_exit_volume=Union_box() SETTING parameter declarations. */
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex
  /* Label for restoring  neutron */
  mcabsorbCompdiffraction_detector_0_exit_volume:
  if (RESTORE) /* restore if needed */
  { RESTORE_NEUTRON(160,
      mcnlx,
      mcnly,
      mcnlz,
      mcnlvx,
      mcnlvy,
      mcnlvz,
      mcnlt,
      mcnlsx,
      mcnlsy,
      mcnlsz,
      mcnlp); }
#undef mcabsorbComp
#undef p
#undef sz
#undef sy
#undef sx
#undef t
#undef vz
#undef vy
#undef vx
#undef z
#undef y
#undef x
  mcDEBUG_STATE(
mcnlx,
mcnly,
mcnlz,
mcnlvx,
mcnlvy,
mcnlvz,
mcnlt,
mcnlsx,
mcnlsy,
mcnlsz,
mcnlp)

  /* TRACE Component spec_detector_0_exit_volume [161] */
  mccoordschange(mcposrspec_detector_0_exit_volume, mcrotrspec_detector_0_exit_volume,
    &mcnlx,
    &mcnly,
    &mcnlz,
    &mcnlvx,
    &mcnlvy,
    &mcnlvz,
    &mcnlsx,
    &mcnlsy,
    &mcnlsz);
  /* define label inside component spec_detector_0_exit_volume (without coords transformations) */
  mcJumpTrace_spec_detector_0_exit_volume:
  SIG_MESSAGE("spec_detector_0_exit_volume (Trace)");
  mcDEBUG_COMP("spec_detector_0_exit_volume")
  mcDEBUG_STATE(
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp)
#define x mcnlx
#define y mcnly
#define z mcnlz
#define vx mcnlvx
#define vy mcnlvy
#define vz mcnlvz
#define t mcnlt
#define sx mcnlsx
#define sy mcnlsy
#define sz mcnlsz
#define p mcnlp

#define mcabsorbComp mcabsorbCompspec_detector_0_exit_volume
  STORE_NEUTRON(161,
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp);
  mcScattered=0;
  mcRestore=0;
  mcNCounter[161]++;
  mcPCounter[161] += p;
  mcP2Counter[161] += p*p;
#define mccompcurname  spec_detector_0_exit_volume
#define mccompcurtype  Union_box
#define mccompcurindex 161
#define loop_index mccspec_detector_0_exit_volume_loop_index
#define this_box_volume mccspec_detector_0_exit_volume_this_box_volume
#define global_geometry_element mccspec_detector_0_exit_volume_global_geometry_element
#define this_box_storage mccspec_detector_0_exit_volume_this_box_storage
{   /* Declarations of spec_detector_0_exit_volume=Union_box() SETTING parameters. */
char* material_string = mccspec_detector_0_exit_volume_material_string;
MCNUM priority = mccspec_detector_0_exit_volume_priority;
MCNUM xwidth = mccspec_detector_0_exit_volume_xwidth;
MCNUM yheight = mccspec_detector_0_exit_volume_yheight;
MCNUM zdepth = mccspec_detector_0_exit_volume_zdepth;
MCNUM xwidth2 = mccspec_detector_0_exit_volume_xwidth2;
MCNUM yheight2 = mccspec_detector_0_exit_volume_yheight2;
MCNUM visualize = mccspec_detector_0_exit_volume_visualize;
int target_index = mccspec_detector_0_exit_volume_target_index;
MCNUM target_x = mccspec_detector_0_exit_volume_target_x;
MCNUM target_y = mccspec_detector_0_exit_volume_target_y;
MCNUM target_z = mccspec_detector_0_exit_volume_target_z;
MCNUM focus_aw = mccspec_detector_0_exit_volume_focus_aw;
MCNUM focus_ah = mccspec_detector_0_exit_volume_focus_ah;
MCNUM focus_xw = mccspec_detector_0_exit_volume_focus_xw;
MCNUM focus_xh = mccspec_detector_0_exit_volume_focus_xh;
MCNUM focus_r = mccspec_detector_0_exit_volume_focus_r;
MCNUM p_interact = mccspec_detector_0_exit_volume_p_interact;
char* mask_string = mccspec_detector_0_exit_volume_mask_string;
char* mask_setting = mccspec_detector_0_exit_volume_mask_setting;
MCNUM number_of_activations = mccspec_detector_0_exit_volume_number_of_activations;
}   /* End of spec_detector_0_exit_volume=Union_box() SETTING parameter declarations. */
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex
  /* Label for restoring  neutron */
  mcabsorbCompspec_detector_0_exit_volume:
  if (RESTORE) /* restore if needed */
  { RESTORE_NEUTRON(161,
      mcnlx,
      mcnly,
      mcnlz,
      mcnlvx,
      mcnlvy,
      mcnlvz,
      mcnlt,
      mcnlsx,
      mcnlsy,
      mcnlsz,
      mcnlp); }
#undef mcabsorbComp
#undef p
#undef sz
#undef sy
#undef sx
#undef t
#undef vz
#undef vy
#undef vx
#undef z
#undef y
#undef x
  mcDEBUG_STATE(
mcnlx,
mcnly,
mcnlz,
mcnlvx,
mcnlvy,
mcnlvz,
mcnlt,
mcnlsx,
mcnlsy,
mcnlsz,
mcnlp)

  /* TRACE Component channel_1_cave1_box1 [162] */
  mccoordschange(mcposrchannel_1_cave1_box1, mcrotrchannel_1_cave1_box1,
    &mcnlx,
    &mcnly,
    &mcnlz,
    &mcnlvx,
    &mcnlvy,
    &mcnlvz,
    &mcnlsx,
    &mcnlsy,
    &mcnlsz);
  /* define label inside component channel_1_cave1_box1 (without coords transformations) */
  mcJumpTrace_channel_1_cave1_box1:
  SIG_MESSAGE("channel_1_cave1_box1 (Trace)");
  mcDEBUG_COMP("channel_1_cave1_box1")
  mcDEBUG_STATE(
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp)
#define x mcnlx
#define y mcnly
#define z mcnlz
#define vx mcnlvx
#define vy mcnlvy
#define vz mcnlvz
#define t mcnlt
#define sx mcnlsx
#define sy mcnlsy
#define sz mcnlsz
#define p mcnlp

#define mcabsorbComp mcabsorbCompchannel_1_cave1_box1
  STORE_NEUTRON(162,
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp);
  mcScattered=0;
  mcRestore=0;
  mcNCounter[162]++;
  mcPCounter[162] += p;
  mcP2Counter[162] += p*p;
#define mccompcurname  channel_1_cave1_box1
#define mccompcurtype  Union_box
#define mccompcurindex 162
#define loop_index mccchannel_1_cave1_box1_loop_index
#define this_box_volume mccchannel_1_cave1_box1_this_box_volume
#define global_geometry_element mccchannel_1_cave1_box1_global_geometry_element
#define this_box_storage mccchannel_1_cave1_box1_this_box_storage
{   /* Declarations of channel_1_cave1_box1=Union_box() SETTING parameters. */
char* material_string = mccchannel_1_cave1_box1_material_string;
MCNUM priority = mccchannel_1_cave1_box1_priority;
MCNUM xwidth = mccchannel_1_cave1_box1_xwidth;
MCNUM yheight = mccchannel_1_cave1_box1_yheight;
MCNUM zdepth = mccchannel_1_cave1_box1_zdepth;
MCNUM xwidth2 = mccchannel_1_cave1_box1_xwidth2;
MCNUM yheight2 = mccchannel_1_cave1_box1_yheight2;
MCNUM visualize = mccchannel_1_cave1_box1_visualize;
int target_index = mccchannel_1_cave1_box1_target_index;
MCNUM target_x = mccchannel_1_cave1_box1_target_x;
MCNUM target_y = mccchannel_1_cave1_box1_target_y;
MCNUM target_z = mccchannel_1_cave1_box1_target_z;
MCNUM focus_aw = mccchannel_1_cave1_box1_focus_aw;
MCNUM focus_ah = mccchannel_1_cave1_box1_focus_ah;
MCNUM focus_xw = mccchannel_1_cave1_box1_focus_xw;
MCNUM focus_xh = mccchannel_1_cave1_box1_focus_xh;
MCNUM focus_r = mccchannel_1_cave1_box1_focus_r;
MCNUM p_interact = mccchannel_1_cave1_box1_p_interact;
char* mask_string = mccchannel_1_cave1_box1_mask_string;
char* mask_setting = mccchannel_1_cave1_box1_mask_setting;
MCNUM number_of_activations = mccchannel_1_cave1_box1_number_of_activations;
}   /* End of channel_1_cave1_box1=Union_box() SETTING parameter declarations. */
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex
  /* Label for restoring  neutron */
  mcabsorbCompchannel_1_cave1_box1:
  if (RESTORE) /* restore if needed */
  { RESTORE_NEUTRON(162,
      mcnlx,
      mcnly,
      mcnlz,
      mcnlvx,
      mcnlvy,
      mcnlvz,
      mcnlt,
      mcnlsx,
      mcnlsy,
      mcnlsz,
      mcnlp); }
#undef mcabsorbComp
#undef p
#undef sz
#undef sy
#undef sx
#undef t
#undef vz
#undef vy
#undef vx
#undef z
#undef y
#undef x
  mcDEBUG_STATE(
mcnlx,
mcnly,
mcnlz,
mcnlvx,
mcnlvy,
mcnlvz,
mcnlt,
mcnlsx,
mcnlsy,
mcnlsz,
mcnlp)

  /* TRACE Component channel_1_cave1_box2 [163] */
  mccoordschange(mcposrchannel_1_cave1_box2, mcrotrchannel_1_cave1_box2,
    &mcnlx,
    &mcnly,
    &mcnlz,
    &mcnlvx,
    &mcnlvy,
    &mcnlvz,
    &mcnlsx,
    &mcnlsy,
    &mcnlsz);
  /* define label inside component channel_1_cave1_box2 (without coords transformations) */
  mcJumpTrace_channel_1_cave1_box2:
  SIG_MESSAGE("channel_1_cave1_box2 (Trace)");
  mcDEBUG_COMP("channel_1_cave1_box2")
  mcDEBUG_STATE(
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp)
#define x mcnlx
#define y mcnly
#define z mcnlz
#define vx mcnlvx
#define vy mcnlvy
#define vz mcnlvz
#define t mcnlt
#define sx mcnlsx
#define sy mcnlsy
#define sz mcnlsz
#define p mcnlp

#define mcabsorbComp mcabsorbCompchannel_1_cave1_box2
  STORE_NEUTRON(163,
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp);
  mcScattered=0;
  mcRestore=0;
  mcNCounter[163]++;
  mcPCounter[163] += p;
  mcP2Counter[163] += p*p;
#define mccompcurname  channel_1_cave1_box2
#define mccompcurtype  Union_box
#define mccompcurindex 163
#define loop_index mccchannel_1_cave1_box2_loop_index
#define this_box_volume mccchannel_1_cave1_box2_this_box_volume
#define global_geometry_element mccchannel_1_cave1_box2_global_geometry_element
#define this_box_storage mccchannel_1_cave1_box2_this_box_storage
{   /* Declarations of channel_1_cave1_box2=Union_box() SETTING parameters. */
char* material_string = mccchannel_1_cave1_box2_material_string;
MCNUM priority = mccchannel_1_cave1_box2_priority;
MCNUM xwidth = mccchannel_1_cave1_box2_xwidth;
MCNUM yheight = mccchannel_1_cave1_box2_yheight;
MCNUM zdepth = mccchannel_1_cave1_box2_zdepth;
MCNUM xwidth2 = mccchannel_1_cave1_box2_xwidth2;
MCNUM yheight2 = mccchannel_1_cave1_box2_yheight2;
MCNUM visualize = mccchannel_1_cave1_box2_visualize;
int target_index = mccchannel_1_cave1_box2_target_index;
MCNUM target_x = mccchannel_1_cave1_box2_target_x;
MCNUM target_y = mccchannel_1_cave1_box2_target_y;
MCNUM target_z = mccchannel_1_cave1_box2_target_z;
MCNUM focus_aw = mccchannel_1_cave1_box2_focus_aw;
MCNUM focus_ah = mccchannel_1_cave1_box2_focus_ah;
MCNUM focus_xw = mccchannel_1_cave1_box2_focus_xw;
MCNUM focus_xh = mccchannel_1_cave1_box2_focus_xh;
MCNUM focus_r = mccchannel_1_cave1_box2_focus_r;
MCNUM p_interact = mccchannel_1_cave1_box2_p_interact;
char* mask_string = mccchannel_1_cave1_box2_mask_string;
char* mask_setting = mccchannel_1_cave1_box2_mask_setting;
MCNUM number_of_activations = mccchannel_1_cave1_box2_number_of_activations;
}   /* End of channel_1_cave1_box2=Union_box() SETTING parameter declarations. */
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex
  /* Label for restoring  neutron */
  mcabsorbCompchannel_1_cave1_box2:
  if (RESTORE) /* restore if needed */
  { RESTORE_NEUTRON(163,
      mcnlx,
      mcnly,
      mcnlz,
      mcnlvx,
      mcnlvy,
      mcnlvz,
      mcnlt,
      mcnlsx,
      mcnlsy,
      mcnlsz,
      mcnlp); }
#undef mcabsorbComp
#undef p
#undef sz
#undef sy
#undef sx
#undef t
#undef vz
#undef vy
#undef vx
#undef z
#undef y
#undef x
  mcDEBUG_STATE(
mcnlx,
mcnly,
mcnlz,
mcnlvx,
mcnlvy,
mcnlvz,
mcnlt,
mcnlsx,
mcnlsy,
mcnlsz,
mcnlp)

  /* TRACE Component channel_1_cave1_box3 [164] */
  mccoordschange(mcposrchannel_1_cave1_box3, mcrotrchannel_1_cave1_box3,
    &mcnlx,
    &mcnly,
    &mcnlz,
    &mcnlvx,
    &mcnlvy,
    &mcnlvz,
    &mcnlsx,
    &mcnlsy,
    &mcnlsz);
  /* define label inside component channel_1_cave1_box3 (without coords transformations) */
  mcJumpTrace_channel_1_cave1_box3:
  SIG_MESSAGE("channel_1_cave1_box3 (Trace)");
  mcDEBUG_COMP("channel_1_cave1_box3")
  mcDEBUG_STATE(
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp)
#define x mcnlx
#define y mcnly
#define z mcnlz
#define vx mcnlvx
#define vy mcnlvy
#define vz mcnlvz
#define t mcnlt
#define sx mcnlsx
#define sy mcnlsy
#define sz mcnlsz
#define p mcnlp

#define mcabsorbComp mcabsorbCompchannel_1_cave1_box3
  STORE_NEUTRON(164,
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp);
  mcScattered=0;
  mcRestore=0;
  mcNCounter[164]++;
  mcPCounter[164] += p;
  mcP2Counter[164] += p*p;
#define mccompcurname  channel_1_cave1_box3
#define mccompcurtype  Union_box
#define mccompcurindex 164
#define loop_index mccchannel_1_cave1_box3_loop_index
#define this_box_volume mccchannel_1_cave1_box3_this_box_volume
#define global_geometry_element mccchannel_1_cave1_box3_global_geometry_element
#define this_box_storage mccchannel_1_cave1_box3_this_box_storage
{   /* Declarations of channel_1_cave1_box3=Union_box() SETTING parameters. */
char* material_string = mccchannel_1_cave1_box3_material_string;
MCNUM priority = mccchannel_1_cave1_box3_priority;
MCNUM xwidth = mccchannel_1_cave1_box3_xwidth;
MCNUM yheight = mccchannel_1_cave1_box3_yheight;
MCNUM zdepth = mccchannel_1_cave1_box3_zdepth;
MCNUM xwidth2 = mccchannel_1_cave1_box3_xwidth2;
MCNUM yheight2 = mccchannel_1_cave1_box3_yheight2;
MCNUM visualize = mccchannel_1_cave1_box3_visualize;
int target_index = mccchannel_1_cave1_box3_target_index;
MCNUM target_x = mccchannel_1_cave1_box3_target_x;
MCNUM target_y = mccchannel_1_cave1_box3_target_y;
MCNUM target_z = mccchannel_1_cave1_box3_target_z;
MCNUM focus_aw = mccchannel_1_cave1_box3_focus_aw;
MCNUM focus_ah = mccchannel_1_cave1_box3_focus_ah;
MCNUM focus_xw = mccchannel_1_cave1_box3_focus_xw;
MCNUM focus_xh = mccchannel_1_cave1_box3_focus_xh;
MCNUM focus_r = mccchannel_1_cave1_box3_focus_r;
MCNUM p_interact = mccchannel_1_cave1_box3_p_interact;
char* mask_string = mccchannel_1_cave1_box3_mask_string;
char* mask_setting = mccchannel_1_cave1_box3_mask_setting;
MCNUM number_of_activations = mccchannel_1_cave1_box3_number_of_activations;
}   /* End of channel_1_cave1_box3=Union_box() SETTING parameter declarations. */
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex
  /* Label for restoring  neutron */
  mcabsorbCompchannel_1_cave1_box3:
  if (RESTORE) /* restore if needed */
  { RESTORE_NEUTRON(164,
      mcnlx,
      mcnly,
      mcnlz,
      mcnlvx,
      mcnlvy,
      mcnlvz,
      mcnlt,
      mcnlsx,
      mcnlsy,
      mcnlsz,
      mcnlp); }
#undef mcabsorbComp
#undef p
#undef sz
#undef sy
#undef sx
#undef t
#undef vz
#undef vy
#undef vx
#undef z
#undef y
#undef x
  mcDEBUG_STATE(
mcnlx,
mcnly,
mcnlz,
mcnlvx,
mcnlvy,
mcnlvz,
mcnlt,
mcnlsx,
mcnlsy,
mcnlsz,
mcnlp)

  /* TRACE Component channel_1_cave1_cyl1 [165] */
  mccoordschange(mcposrchannel_1_cave1_cyl1, mcrotrchannel_1_cave1_cyl1,
    &mcnlx,
    &mcnly,
    &mcnlz,
    &mcnlvx,
    &mcnlvy,
    &mcnlvz,
    &mcnlsx,
    &mcnlsy,
    &mcnlsz);
  /* define label inside component channel_1_cave1_cyl1 (without coords transformations) */
  mcJumpTrace_channel_1_cave1_cyl1:
  SIG_MESSAGE("channel_1_cave1_cyl1 (Trace)");
  mcDEBUG_COMP("channel_1_cave1_cyl1")
  mcDEBUG_STATE(
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp)
#define x mcnlx
#define y mcnly
#define z mcnlz
#define vx mcnlvx
#define vy mcnlvy
#define vz mcnlvz
#define t mcnlt
#define sx mcnlsx
#define sy mcnlsy
#define sz mcnlsz
#define p mcnlp

#define mcabsorbComp mcabsorbCompchannel_1_cave1_cyl1
  STORE_NEUTRON(165,
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp);
  mcScattered=0;
  mcRestore=0;
  mcNCounter[165]++;
  mcPCounter[165] += p;
  mcP2Counter[165] += p*p;
#define mccompcurname  channel_1_cave1_cyl1
#define mccompcurtype  Union_cylinder
#define mccompcurindex 165
#define loop_index mccchannel_1_cave1_cyl1_loop_index
#define this_cylinder_volume mccchannel_1_cave1_cyl1_this_cylinder_volume
#define global_geometry_element mccchannel_1_cave1_cyl1_global_geometry_element
#define this_cylinder_storage mccchannel_1_cave1_cyl1_this_cylinder_storage
{   /* Declarations of channel_1_cave1_cyl1=Union_cylinder() SETTING parameters. */
char* material_string = mccchannel_1_cave1_cyl1_material_string;
MCNUM priority = mccchannel_1_cave1_cyl1_priority;
MCNUM radius = mccchannel_1_cave1_cyl1_radius;
MCNUM yheight = mccchannel_1_cave1_cyl1_yheight;
MCNUM visualize = mccchannel_1_cave1_cyl1_visualize;
int target_index = mccchannel_1_cave1_cyl1_target_index;
MCNUM target_x = mccchannel_1_cave1_cyl1_target_x;
MCNUM target_y = mccchannel_1_cave1_cyl1_target_y;
MCNUM target_z = mccchannel_1_cave1_cyl1_target_z;
MCNUM focus_aw = mccchannel_1_cave1_cyl1_focus_aw;
MCNUM focus_ah = mccchannel_1_cave1_cyl1_focus_ah;
MCNUM focus_xw = mccchannel_1_cave1_cyl1_focus_xw;
MCNUM focus_xh = mccchannel_1_cave1_cyl1_focus_xh;
MCNUM focus_r = mccchannel_1_cave1_cyl1_focus_r;
MCNUM p_interact = mccchannel_1_cave1_cyl1_p_interact;
char* mask_string = mccchannel_1_cave1_cyl1_mask_string;
char* mask_setting = mccchannel_1_cave1_cyl1_mask_setting;
MCNUM number_of_activations = mccchannel_1_cave1_cyl1_number_of_activations;
#line 345 "Union_cylinder.comp"
{
dummy = 1;
}
#line 367999 "MACS_sample_kidney_box.c"
}   /* End of channel_1_cave1_cyl1=Union_cylinder() SETTING parameter declarations. */
#undef this_cylinder_storage
#undef global_geometry_element
#undef this_cylinder_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex
  /* Label for restoring  neutron */
  mcabsorbCompchannel_1_cave1_cyl1:
  if (RESTORE) /* restore if needed */
  { RESTORE_NEUTRON(165,
      mcnlx,
      mcnly,
      mcnlz,
      mcnlvx,
      mcnlvy,
      mcnlvz,
      mcnlt,
      mcnlsx,
      mcnlsy,
      mcnlsz,
      mcnlp); }
#undef mcabsorbComp
#undef p
#undef sz
#undef sy
#undef sx
#undef t
#undef vz
#undef vy
#undef vx
#undef z
#undef y
#undef x
  mcDEBUG_STATE(
mcnlx,
mcnly,
mcnlz,
mcnlvx,
mcnlvy,
mcnlvz,
mcnlt,
mcnlsx,
mcnlsy,
mcnlsz,
mcnlp)

  /* TRACE Component channel_1_analyzer_1_center [166] */
  mccoordschange(mcposrchannel_1_analyzer_1_center, mcrotrchannel_1_analyzer_1_center,
    &mcnlx,
    &mcnly,
    &mcnlz,
    &mcnlvx,
    &mcnlvy,
    &mcnlvz,
    &mcnlsx,
    &mcnlsy,
    &mcnlsz);
  /* define label inside component channel_1_analyzer_1_center (without coords transformations) */
  mcJumpTrace_channel_1_analyzer_1_center:
  SIG_MESSAGE("channel_1_analyzer_1_center (Trace)");
  mcDEBUG_COMP("channel_1_analyzer_1_center")
  mcDEBUG_STATE(
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp)
#define x mcnlx
#define y mcnly
#define z mcnlz
#define vx mcnlvx
#define vy mcnlvy
#define vz mcnlvz
#define t mcnlt
#define sx mcnlsx
#define sy mcnlsy
#define sz mcnlsz
#define p mcnlp

#define mcabsorbComp mcabsorbCompchannel_1_analyzer_1_center
  STORE_NEUTRON(166,
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp);
  mcScattered=0;
  mcRestore=0;
  mcNCounter[166]++;
  mcPCounter[166] += p;
  mcP2Counter[166] += p*p;
#define mccompcurname  channel_1_analyzer_1_center
#define mccompcurtype  Arm
#define mccompcurindex 166
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex
  /* Label for restoring  neutron */
  mcabsorbCompchannel_1_analyzer_1_center:
  if (RESTORE) /* restore if needed */
  { RESTORE_NEUTRON(166,
      mcnlx,
      mcnly,
      mcnlz,
      mcnlvx,
      mcnlvy,
      mcnlvz,
      mcnlt,
      mcnlsx,
      mcnlsy,
      mcnlsz,
      mcnlp); }
#undef mcabsorbComp
#undef p
#undef sz
#undef sy
#undef sx
#undef t
#undef vz
#undef vy
#undef vx
#undef z
#undef y
#undef x
  mcDEBUG_STATE(
mcnlx,
mcnly,
mcnlz,
mcnlvx,
mcnlvy,
mcnlvz,
mcnlt,
mcnlsx,
mcnlsy,
mcnlsz,
mcnlp)

  /* TRACE Component channel_1_analyzer_1_rotated [167] */
  mccoordschange(mcposrchannel_1_analyzer_1_rotated, mcrotrchannel_1_analyzer_1_rotated,
    &mcnlx,
    &mcnly,
    &mcnlz,
    &mcnlvx,
    &mcnlvy,
    &mcnlvz,
    &mcnlsx,
    &mcnlsy,
    &mcnlsz);
  /* define label inside component channel_1_analyzer_1_rotated (without coords transformations) */
  mcJumpTrace_channel_1_analyzer_1_rotated:
  SIG_MESSAGE("channel_1_analyzer_1_rotated (Trace)");
  mcDEBUG_COMP("channel_1_analyzer_1_rotated")
  mcDEBUG_STATE(
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp)
#define x mcnlx
#define y mcnly
#define z mcnlz
#define vx mcnlvx
#define vy mcnlvy
#define vz mcnlvz
#define t mcnlt
#define sx mcnlsx
#define sy mcnlsy
#define sz mcnlsz
#define p mcnlp

#define mcabsorbComp mcabsorbCompchannel_1_analyzer_1_rotated
  STORE_NEUTRON(167,
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp);
  mcScattered=0;
  mcRestore=0;
  mcNCounter[167]++;
  mcPCounter[167] += p;
  mcP2Counter[167] += p*p;
#define mccompcurname  channel_1_analyzer_1_rotated
#define mccompcurtype  Arm
#define mccompcurindex 167
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex
  /* Label for restoring  neutron */
  mcabsorbCompchannel_1_analyzer_1_rotated:
  if (RESTORE) /* restore if needed */
  { RESTORE_NEUTRON(167,
      mcnlx,
      mcnly,
      mcnlz,
      mcnlvx,
      mcnlvy,
      mcnlvz,
      mcnlt,
      mcnlsx,
      mcnlsy,
      mcnlsz,
      mcnlp); }
#undef mcabsorbComp
#undef p
#undef sz
#undef sy
#undef sx
#undef t
#undef vz
#undef vy
#undef vx
#undef z
#undef y
#undef x
  mcDEBUG_STATE(
mcnlx,
mcnly,
mcnlz,
mcnlvx,
mcnlvy,
mcnlvz,
mcnlt,
mcnlsx,
mcnlsy,
mcnlsz,
mcnlp)

  /* TRACE Component channel_1_analyzer_1_array_crystal_array_0 [168] */
  mccoordschange(mcposrchannel_1_analyzer_1_array_crystal_array_0, mcrotrchannel_1_analyzer_1_array_crystal_array_0,
    &mcnlx,
    &mcnly,
    &mcnlz,
    &mcnlvx,
    &mcnlvy,
    &mcnlvz,
    &mcnlsx,
    &mcnlsy,
    &mcnlsz);
  /* define label inside component channel_1_analyzer_1_array_crystal_array_0 (without coords transformations) */
  mcJumpTrace_channel_1_analyzer_1_array_crystal_array_0:
  SIG_MESSAGE("channel_1_analyzer_1_array_crystal_array_0 (Trace)");
  mcDEBUG_COMP("channel_1_analyzer_1_array_crystal_array_0")
  mcDEBUG_STATE(
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp)
#define x mcnlx
#define y mcnly
#define z mcnlz
#define vx mcnlvx
#define vy mcnlvy
#define vz mcnlvz
#define t mcnlt
#define sx mcnlsx
#define sy mcnlsy
#define sz mcnlsz
#define p mcnlp

#define mcabsorbComp mcabsorbCompchannel_1_analyzer_1_array_crystal_array_0
  STORE_NEUTRON(168,
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp);
  mcScattered=0;
  mcRestore=0;
  mcNCounter[168]++;
  mcPCounter[168] += p;
  mcP2Counter[168] += p*p;
#define mccompcurname  channel_1_analyzer_1_array_crystal_array_0
#define mccompcurtype  Union_box
#define mccompcurindex 168
#define loop_index mccchannel_1_analyzer_1_array_crystal_array_0_loop_index
#define this_box_volume mccchannel_1_analyzer_1_array_crystal_array_0_this_box_volume
#define global_geometry_element mccchannel_1_analyzer_1_array_crystal_array_0_global_geometry_element
#define this_box_storage mccchannel_1_analyzer_1_array_crystal_array_0_this_box_storage
{   /* Declarations of channel_1_analyzer_1_array_crystal_array_0=Union_box() SETTING parameters. */
char* material_string = mccchannel_1_analyzer_1_array_crystal_array_0_material_string;
MCNUM priority = mccchannel_1_analyzer_1_array_crystal_array_0_priority;
MCNUM xwidth = mccchannel_1_analyzer_1_array_crystal_array_0_xwidth;
MCNUM yheight = mccchannel_1_analyzer_1_array_crystal_array_0_yheight;
MCNUM zdepth = mccchannel_1_analyzer_1_array_crystal_array_0_zdepth;
MCNUM xwidth2 = mccchannel_1_analyzer_1_array_crystal_array_0_xwidth2;
MCNUM yheight2 = mccchannel_1_analyzer_1_array_crystal_array_0_yheight2;
MCNUM visualize = mccchannel_1_analyzer_1_array_crystal_array_0_visualize;
int target_index = mccchannel_1_analyzer_1_array_crystal_array_0_target_index;
MCNUM target_x = mccchannel_1_analyzer_1_array_crystal_array_0_target_x;
MCNUM target_y = mccchannel_1_analyzer_1_array_crystal_array_0_target_y;
MCNUM target_z = mccchannel_1_analyzer_1_array_crystal_array_0_target_z;
MCNUM focus_aw = mccchannel_1_analyzer_1_array_crystal_array_0_focus_aw;
MCNUM focus_ah = mccchannel_1_analyzer_1_array_crystal_array_0_focus_ah;
MCNUM focus_xw = mccchannel_1_analyzer_1_array_crystal_array_0_focus_xw;
MCNUM focus_xh = mccchannel_1_analyzer_1_array_crystal_array_0_focus_xh;
MCNUM focus_r = mccchannel_1_analyzer_1_array_crystal_array_0_focus_r;
MCNUM p_interact = mccchannel_1_analyzer_1_array_crystal_array_0_p_interact;
char* mask_string = mccchannel_1_analyzer_1_array_crystal_array_0_mask_string;
char* mask_setting = mccchannel_1_analyzer_1_array_crystal_array_0_mask_setting;
MCNUM number_of_activations = mccchannel_1_analyzer_1_array_crystal_array_0_number_of_activations;
}   /* End of channel_1_analyzer_1_array_crystal_array_0=Union_box() SETTING parameter declarations. */
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex
  /* Label for restoring  neutron */
  mcabsorbCompchannel_1_analyzer_1_array_crystal_array_0:
  if (RESTORE) /* restore if needed */
  { RESTORE_NEUTRON(168,
      mcnlx,
      mcnly,
      mcnlz,
      mcnlvx,
      mcnlvy,
      mcnlvz,
      mcnlt,
      mcnlsx,
      mcnlsy,
      mcnlsz,
      mcnlp); }
#undef mcabsorbComp
#undef p
#undef sz
#undef sy
#undef sx
#undef t
#undef vz
#undef vy
#undef vx
#undef z
#undef y
#undef x
  mcDEBUG_STATE(
mcnlx,
mcnly,
mcnlz,
mcnlvx,
mcnlvy,
mcnlvz,
mcnlt,
mcnlsx,
mcnlsy,
mcnlsz,
mcnlp)

  /* TRACE Component channel_1_analyzer_1_array_crystal_array_1 [169] */
  mccoordschange(mcposrchannel_1_analyzer_1_array_crystal_array_1, mcrotrchannel_1_analyzer_1_array_crystal_array_1,
    &mcnlx,
    &mcnly,
    &mcnlz,
    &mcnlvx,
    &mcnlvy,
    &mcnlvz,
    &mcnlsx,
    &mcnlsy,
    &mcnlsz);
  /* define label inside component channel_1_analyzer_1_array_crystal_array_1 (without coords transformations) */
  mcJumpTrace_channel_1_analyzer_1_array_crystal_array_1:
  SIG_MESSAGE("channel_1_analyzer_1_array_crystal_array_1 (Trace)");
  mcDEBUG_COMP("channel_1_analyzer_1_array_crystal_array_1")
  mcDEBUG_STATE(
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp)
#define x mcnlx
#define y mcnly
#define z mcnlz
#define vx mcnlvx
#define vy mcnlvy
#define vz mcnlvz
#define t mcnlt
#define sx mcnlsx
#define sy mcnlsy
#define sz mcnlsz
#define p mcnlp

#define mcabsorbComp mcabsorbCompchannel_1_analyzer_1_array_crystal_array_1
  STORE_NEUTRON(169,
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp);
  mcScattered=0;
  mcRestore=0;
  mcNCounter[169]++;
  mcPCounter[169] += p;
  mcP2Counter[169] += p*p;
#define mccompcurname  channel_1_analyzer_1_array_crystal_array_1
#define mccompcurtype  Union_box
#define mccompcurindex 169
#define loop_index mccchannel_1_analyzer_1_array_crystal_array_1_loop_index
#define this_box_volume mccchannel_1_analyzer_1_array_crystal_array_1_this_box_volume
#define global_geometry_element mccchannel_1_analyzer_1_array_crystal_array_1_global_geometry_element
#define this_box_storage mccchannel_1_analyzer_1_array_crystal_array_1_this_box_storage
{   /* Declarations of channel_1_analyzer_1_array_crystal_array_1=Union_box() SETTING parameters. */
char* material_string = mccchannel_1_analyzer_1_array_crystal_array_1_material_string;
MCNUM priority = mccchannel_1_analyzer_1_array_crystal_array_1_priority;
MCNUM xwidth = mccchannel_1_analyzer_1_array_crystal_array_1_xwidth;
MCNUM yheight = mccchannel_1_analyzer_1_array_crystal_array_1_yheight;
MCNUM zdepth = mccchannel_1_analyzer_1_array_crystal_array_1_zdepth;
MCNUM xwidth2 = mccchannel_1_analyzer_1_array_crystal_array_1_xwidth2;
MCNUM yheight2 = mccchannel_1_analyzer_1_array_crystal_array_1_yheight2;
MCNUM visualize = mccchannel_1_analyzer_1_array_crystal_array_1_visualize;
int target_index = mccchannel_1_analyzer_1_array_crystal_array_1_target_index;
MCNUM target_x = mccchannel_1_analyzer_1_array_crystal_array_1_target_x;
MCNUM target_y = mccchannel_1_analyzer_1_array_crystal_array_1_target_y;
MCNUM target_z = mccchannel_1_analyzer_1_array_crystal_array_1_target_z;
MCNUM focus_aw = mccchannel_1_analyzer_1_array_crystal_array_1_focus_aw;
MCNUM focus_ah = mccchannel_1_analyzer_1_array_crystal_array_1_focus_ah;
MCNUM focus_xw = mccchannel_1_analyzer_1_array_crystal_array_1_focus_xw;
MCNUM focus_xh = mccchannel_1_analyzer_1_array_crystal_array_1_focus_xh;
MCNUM focus_r = mccchannel_1_analyzer_1_array_crystal_array_1_focus_r;
MCNUM p_interact = mccchannel_1_analyzer_1_array_crystal_array_1_p_interact;
char* mask_string = mccchannel_1_analyzer_1_array_crystal_array_1_mask_string;
char* mask_setting = mccchannel_1_analyzer_1_array_crystal_array_1_mask_setting;
MCNUM number_of_activations = mccchannel_1_analyzer_1_array_crystal_array_1_number_of_activations;
}   /* End of channel_1_analyzer_1_array_crystal_array_1=Union_box() SETTING parameter declarations. */
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex
  /* Label for restoring  neutron */
  mcabsorbCompchannel_1_analyzer_1_array_crystal_array_1:
  if (RESTORE) /* restore if needed */
  { RESTORE_NEUTRON(169,
      mcnlx,
      mcnly,
      mcnlz,
      mcnlvx,
      mcnlvy,
      mcnlvz,
      mcnlt,
      mcnlsx,
      mcnlsy,
      mcnlsz,
      mcnlp); }
#undef mcabsorbComp
#undef p
#undef sz
#undef sy
#undef sx
#undef t
#undef vz
#undef vy
#undef vx
#undef z
#undef y
#undef x
  mcDEBUG_STATE(
mcnlx,
mcnly,
mcnlz,
mcnlvx,
mcnlvy,
mcnlvz,
mcnlt,
mcnlsx,
mcnlsy,
mcnlsz,
mcnlp)

  /* TRACE Component channel_1_analyzer_1_array_crystal_array_2 [170] */
  mccoordschange(mcposrchannel_1_analyzer_1_array_crystal_array_2, mcrotrchannel_1_analyzer_1_array_crystal_array_2,
    &mcnlx,
    &mcnly,
    &mcnlz,
    &mcnlvx,
    &mcnlvy,
    &mcnlvz,
    &mcnlsx,
    &mcnlsy,
    &mcnlsz);
  /* define label inside component channel_1_analyzer_1_array_crystal_array_2 (without coords transformations) */
  mcJumpTrace_channel_1_analyzer_1_array_crystal_array_2:
  SIG_MESSAGE("channel_1_analyzer_1_array_crystal_array_2 (Trace)");
  mcDEBUG_COMP("channel_1_analyzer_1_array_crystal_array_2")
  mcDEBUG_STATE(
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp)
#define x mcnlx
#define y mcnly
#define z mcnlz
#define vx mcnlvx
#define vy mcnlvy
#define vz mcnlvz
#define t mcnlt
#define sx mcnlsx
#define sy mcnlsy
#define sz mcnlsz
#define p mcnlp

#define mcabsorbComp mcabsorbCompchannel_1_analyzer_1_array_crystal_array_2
  STORE_NEUTRON(170,
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp);
  mcScattered=0;
  mcRestore=0;
  mcNCounter[170]++;
  mcPCounter[170] += p;
  mcP2Counter[170] += p*p;
#define mccompcurname  channel_1_analyzer_1_array_crystal_array_2
#define mccompcurtype  Union_box
#define mccompcurindex 170
#define loop_index mccchannel_1_analyzer_1_array_crystal_array_2_loop_index
#define this_box_volume mccchannel_1_analyzer_1_array_crystal_array_2_this_box_volume
#define global_geometry_element mccchannel_1_analyzer_1_array_crystal_array_2_global_geometry_element
#define this_box_storage mccchannel_1_analyzer_1_array_crystal_array_2_this_box_storage
{   /* Declarations of channel_1_analyzer_1_array_crystal_array_2=Union_box() SETTING parameters. */
char* material_string = mccchannel_1_analyzer_1_array_crystal_array_2_material_string;
MCNUM priority = mccchannel_1_analyzer_1_array_crystal_array_2_priority;
MCNUM xwidth = mccchannel_1_analyzer_1_array_crystal_array_2_xwidth;
MCNUM yheight = mccchannel_1_analyzer_1_array_crystal_array_2_yheight;
MCNUM zdepth = mccchannel_1_analyzer_1_array_crystal_array_2_zdepth;
MCNUM xwidth2 = mccchannel_1_analyzer_1_array_crystal_array_2_xwidth2;
MCNUM yheight2 = mccchannel_1_analyzer_1_array_crystal_array_2_yheight2;
MCNUM visualize = mccchannel_1_analyzer_1_array_crystal_array_2_visualize;
int target_index = mccchannel_1_analyzer_1_array_crystal_array_2_target_index;
MCNUM target_x = mccchannel_1_analyzer_1_array_crystal_array_2_target_x;
MCNUM target_y = mccchannel_1_analyzer_1_array_crystal_array_2_target_y;
MCNUM target_z = mccchannel_1_analyzer_1_array_crystal_array_2_target_z;
MCNUM focus_aw = mccchannel_1_analyzer_1_array_crystal_array_2_focus_aw;
MCNUM focus_ah = mccchannel_1_analyzer_1_array_crystal_array_2_focus_ah;
MCNUM focus_xw = mccchannel_1_analyzer_1_array_crystal_array_2_focus_xw;
MCNUM focus_xh = mccchannel_1_analyzer_1_array_crystal_array_2_focus_xh;
MCNUM focus_r = mccchannel_1_analyzer_1_array_crystal_array_2_focus_r;
MCNUM p_interact = mccchannel_1_analyzer_1_array_crystal_array_2_p_interact;
char* mask_string = mccchannel_1_analyzer_1_array_crystal_array_2_mask_string;
char* mask_setting = mccchannel_1_analyzer_1_array_crystal_array_2_mask_setting;
MCNUM number_of_activations = mccchannel_1_analyzer_1_array_crystal_array_2_number_of_activations;
}   /* End of channel_1_analyzer_1_array_crystal_array_2=Union_box() SETTING parameter declarations. */
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex
  /* Label for restoring  neutron */
  mcabsorbCompchannel_1_analyzer_1_array_crystal_array_2:
  if (RESTORE) /* restore if needed */
  { RESTORE_NEUTRON(170,
      mcnlx,
      mcnly,
      mcnlz,
      mcnlvx,
      mcnlvy,
      mcnlvz,
      mcnlt,
      mcnlsx,
      mcnlsy,
      mcnlsz,
      mcnlp); }
#undef mcabsorbComp
#undef p
#undef sz
#undef sy
#undef sx
#undef t
#undef vz
#undef vy
#undef vx
#undef z
#undef y
#undef x
  mcDEBUG_STATE(
mcnlx,
mcnly,
mcnlz,
mcnlvx,
mcnlvy,
mcnlvz,
mcnlt,
mcnlsx,
mcnlsy,
mcnlsz,
mcnlp)

  /* TRACE Component channel_1_analyzer_1_array_crystal_array_3 [171] */
  mccoordschange(mcposrchannel_1_analyzer_1_array_crystal_array_3, mcrotrchannel_1_analyzer_1_array_crystal_array_3,
    &mcnlx,
    &mcnly,
    &mcnlz,
    &mcnlvx,
    &mcnlvy,
    &mcnlvz,
    &mcnlsx,
    &mcnlsy,
    &mcnlsz);
  /* define label inside component channel_1_analyzer_1_array_crystal_array_3 (without coords transformations) */
  mcJumpTrace_channel_1_analyzer_1_array_crystal_array_3:
  SIG_MESSAGE("channel_1_analyzer_1_array_crystal_array_3 (Trace)");
  mcDEBUG_COMP("channel_1_analyzer_1_array_crystal_array_3")
  mcDEBUG_STATE(
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp)
#define x mcnlx
#define y mcnly
#define z mcnlz
#define vx mcnlvx
#define vy mcnlvy
#define vz mcnlvz
#define t mcnlt
#define sx mcnlsx
#define sy mcnlsy
#define sz mcnlsz
#define p mcnlp

#define mcabsorbComp mcabsorbCompchannel_1_analyzer_1_array_crystal_array_3
  STORE_NEUTRON(171,
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp);
  mcScattered=0;
  mcRestore=0;
  mcNCounter[171]++;
  mcPCounter[171] += p;
  mcP2Counter[171] += p*p;
#define mccompcurname  channel_1_analyzer_1_array_crystal_array_3
#define mccompcurtype  Union_box
#define mccompcurindex 171
#define loop_index mccchannel_1_analyzer_1_array_crystal_array_3_loop_index
#define this_box_volume mccchannel_1_analyzer_1_array_crystal_array_3_this_box_volume
#define global_geometry_element mccchannel_1_analyzer_1_array_crystal_array_3_global_geometry_element
#define this_box_storage mccchannel_1_analyzer_1_array_crystal_array_3_this_box_storage
{   /* Declarations of channel_1_analyzer_1_array_crystal_array_3=Union_box() SETTING parameters. */
char* material_string = mccchannel_1_analyzer_1_array_crystal_array_3_material_string;
MCNUM priority = mccchannel_1_analyzer_1_array_crystal_array_3_priority;
MCNUM xwidth = mccchannel_1_analyzer_1_array_crystal_array_3_xwidth;
MCNUM yheight = mccchannel_1_analyzer_1_array_crystal_array_3_yheight;
MCNUM zdepth = mccchannel_1_analyzer_1_array_crystal_array_3_zdepth;
MCNUM xwidth2 = mccchannel_1_analyzer_1_array_crystal_array_3_xwidth2;
MCNUM yheight2 = mccchannel_1_analyzer_1_array_crystal_array_3_yheight2;
MCNUM visualize = mccchannel_1_analyzer_1_array_crystal_array_3_visualize;
int target_index = mccchannel_1_analyzer_1_array_crystal_array_3_target_index;
MCNUM target_x = mccchannel_1_analyzer_1_array_crystal_array_3_target_x;
MCNUM target_y = mccchannel_1_analyzer_1_array_crystal_array_3_target_y;
MCNUM target_z = mccchannel_1_analyzer_1_array_crystal_array_3_target_z;
MCNUM focus_aw = mccchannel_1_analyzer_1_array_crystal_array_3_focus_aw;
MCNUM focus_ah = mccchannel_1_analyzer_1_array_crystal_array_3_focus_ah;
MCNUM focus_xw = mccchannel_1_analyzer_1_array_crystal_array_3_focus_xw;
MCNUM focus_xh = mccchannel_1_analyzer_1_array_crystal_array_3_focus_xh;
MCNUM focus_r = mccchannel_1_analyzer_1_array_crystal_array_3_focus_r;
MCNUM p_interact = mccchannel_1_analyzer_1_array_crystal_array_3_p_interact;
char* mask_string = mccchannel_1_analyzer_1_array_crystal_array_3_mask_string;
char* mask_setting = mccchannel_1_analyzer_1_array_crystal_array_3_mask_setting;
MCNUM number_of_activations = mccchannel_1_analyzer_1_array_crystal_array_3_number_of_activations;
}   /* End of channel_1_analyzer_1_array_crystal_array_3=Union_box() SETTING parameter declarations. */
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex
  /* Label for restoring  neutron */
  mcabsorbCompchannel_1_analyzer_1_array_crystal_array_3:
  if (RESTORE) /* restore if needed */
  { RESTORE_NEUTRON(171,
      mcnlx,
      mcnly,
      mcnlz,
      mcnlvx,
      mcnlvy,
      mcnlvz,
      mcnlt,
      mcnlsx,
      mcnlsy,
      mcnlsz,
      mcnlp); }
#undef mcabsorbComp
#undef p
#undef sz
#undef sy
#undef sx
#undef t
#undef vz
#undef vy
#undef vx
#undef z
#undef y
#undef x
  mcDEBUG_STATE(
mcnlx,
mcnly,
mcnlz,
mcnlvx,
mcnlvy,
mcnlvz,
mcnlt,
mcnlsx,
mcnlsy,
mcnlsz,
mcnlp)

  /* TRACE Component channel_1_analyzer_1_array_crystal_array_4 [172] */
  mccoordschange(mcposrchannel_1_analyzer_1_array_crystal_array_4, mcrotrchannel_1_analyzer_1_array_crystal_array_4,
    &mcnlx,
    &mcnly,
    &mcnlz,
    &mcnlvx,
    &mcnlvy,
    &mcnlvz,
    &mcnlsx,
    &mcnlsy,
    &mcnlsz);
  /* define label inside component channel_1_analyzer_1_array_crystal_array_4 (without coords transformations) */
  mcJumpTrace_channel_1_analyzer_1_array_crystal_array_4:
  SIG_MESSAGE("channel_1_analyzer_1_array_crystal_array_4 (Trace)");
  mcDEBUG_COMP("channel_1_analyzer_1_array_crystal_array_4")
  mcDEBUG_STATE(
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp)
#define x mcnlx
#define y mcnly
#define z mcnlz
#define vx mcnlvx
#define vy mcnlvy
#define vz mcnlvz
#define t mcnlt
#define sx mcnlsx
#define sy mcnlsy
#define sz mcnlsz
#define p mcnlp

#define mcabsorbComp mcabsorbCompchannel_1_analyzer_1_array_crystal_array_4
  STORE_NEUTRON(172,
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp);
  mcScattered=0;
  mcRestore=0;
  mcNCounter[172]++;
  mcPCounter[172] += p;
  mcP2Counter[172] += p*p;
#define mccompcurname  channel_1_analyzer_1_array_crystal_array_4
#define mccompcurtype  Union_box
#define mccompcurindex 172
#define loop_index mccchannel_1_analyzer_1_array_crystal_array_4_loop_index
#define this_box_volume mccchannel_1_analyzer_1_array_crystal_array_4_this_box_volume
#define global_geometry_element mccchannel_1_analyzer_1_array_crystal_array_4_global_geometry_element
#define this_box_storage mccchannel_1_analyzer_1_array_crystal_array_4_this_box_storage
{   /* Declarations of channel_1_analyzer_1_array_crystal_array_4=Union_box() SETTING parameters. */
char* material_string = mccchannel_1_analyzer_1_array_crystal_array_4_material_string;
MCNUM priority = mccchannel_1_analyzer_1_array_crystal_array_4_priority;
MCNUM xwidth = mccchannel_1_analyzer_1_array_crystal_array_4_xwidth;
MCNUM yheight = mccchannel_1_analyzer_1_array_crystal_array_4_yheight;
MCNUM zdepth = mccchannel_1_analyzer_1_array_crystal_array_4_zdepth;
MCNUM xwidth2 = mccchannel_1_analyzer_1_array_crystal_array_4_xwidth2;
MCNUM yheight2 = mccchannel_1_analyzer_1_array_crystal_array_4_yheight2;
MCNUM visualize = mccchannel_1_analyzer_1_array_crystal_array_4_visualize;
int target_index = mccchannel_1_analyzer_1_array_crystal_array_4_target_index;
MCNUM target_x = mccchannel_1_analyzer_1_array_crystal_array_4_target_x;
MCNUM target_y = mccchannel_1_analyzer_1_array_crystal_array_4_target_y;
MCNUM target_z = mccchannel_1_analyzer_1_array_crystal_array_4_target_z;
MCNUM focus_aw = mccchannel_1_analyzer_1_array_crystal_array_4_focus_aw;
MCNUM focus_ah = mccchannel_1_analyzer_1_array_crystal_array_4_focus_ah;
MCNUM focus_xw = mccchannel_1_analyzer_1_array_crystal_array_4_focus_xw;
MCNUM focus_xh = mccchannel_1_analyzer_1_array_crystal_array_4_focus_xh;
MCNUM focus_r = mccchannel_1_analyzer_1_array_crystal_array_4_focus_r;
MCNUM p_interact = mccchannel_1_analyzer_1_array_crystal_array_4_p_interact;
char* mask_string = mccchannel_1_analyzer_1_array_crystal_array_4_mask_string;
char* mask_setting = mccchannel_1_analyzer_1_array_crystal_array_4_mask_setting;
MCNUM number_of_activations = mccchannel_1_analyzer_1_array_crystal_array_4_number_of_activations;
}   /* End of channel_1_analyzer_1_array_crystal_array_4=Union_box() SETTING parameter declarations. */
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex
  /* Label for restoring  neutron */
  mcabsorbCompchannel_1_analyzer_1_array_crystal_array_4:
  if (RESTORE) /* restore if needed */
  { RESTORE_NEUTRON(172,
      mcnlx,
      mcnly,
      mcnlz,
      mcnlvx,
      mcnlvy,
      mcnlvz,
      mcnlt,
      mcnlsx,
      mcnlsy,
      mcnlsz,
      mcnlp); }
#undef mcabsorbComp
#undef p
#undef sz
#undef sy
#undef sx
#undef t
#undef vz
#undef vy
#undef vx
#undef z
#undef y
#undef x
  mcDEBUG_STATE(
mcnlx,
mcnly,
mcnlz,
mcnlvx,
mcnlvy,
mcnlvz,
mcnlt,
mcnlsx,
mcnlsy,
mcnlsz,
mcnlp)

  /* TRACE Component channel_1_analyzer_1_array_crystal_array_5 [173] */
  mccoordschange(mcposrchannel_1_analyzer_1_array_crystal_array_5, mcrotrchannel_1_analyzer_1_array_crystal_array_5,
    &mcnlx,
    &mcnly,
    &mcnlz,
    &mcnlvx,
    &mcnlvy,
    &mcnlvz,
    &mcnlsx,
    &mcnlsy,
    &mcnlsz);
  /* define label inside component channel_1_analyzer_1_array_crystal_array_5 (without coords transformations) */
  mcJumpTrace_channel_1_analyzer_1_array_crystal_array_5:
  SIG_MESSAGE("channel_1_analyzer_1_array_crystal_array_5 (Trace)");
  mcDEBUG_COMP("channel_1_analyzer_1_array_crystal_array_5")
  mcDEBUG_STATE(
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp)
#define x mcnlx
#define y mcnly
#define z mcnlz
#define vx mcnlvx
#define vy mcnlvy
#define vz mcnlvz
#define t mcnlt
#define sx mcnlsx
#define sy mcnlsy
#define sz mcnlsz
#define p mcnlp

#define mcabsorbComp mcabsorbCompchannel_1_analyzer_1_array_crystal_array_5
  STORE_NEUTRON(173,
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp);
  mcScattered=0;
  mcRestore=0;
  mcNCounter[173]++;
  mcPCounter[173] += p;
  mcP2Counter[173] += p*p;
#define mccompcurname  channel_1_analyzer_1_array_crystal_array_5
#define mccompcurtype  Union_box
#define mccompcurindex 173
#define loop_index mccchannel_1_analyzer_1_array_crystal_array_5_loop_index
#define this_box_volume mccchannel_1_analyzer_1_array_crystal_array_5_this_box_volume
#define global_geometry_element mccchannel_1_analyzer_1_array_crystal_array_5_global_geometry_element
#define this_box_storage mccchannel_1_analyzer_1_array_crystal_array_5_this_box_storage
{   /* Declarations of channel_1_analyzer_1_array_crystal_array_5=Union_box() SETTING parameters. */
char* material_string = mccchannel_1_analyzer_1_array_crystal_array_5_material_string;
MCNUM priority = mccchannel_1_analyzer_1_array_crystal_array_5_priority;
MCNUM xwidth = mccchannel_1_analyzer_1_array_crystal_array_5_xwidth;
MCNUM yheight = mccchannel_1_analyzer_1_array_crystal_array_5_yheight;
MCNUM zdepth = mccchannel_1_analyzer_1_array_crystal_array_5_zdepth;
MCNUM xwidth2 = mccchannel_1_analyzer_1_array_crystal_array_5_xwidth2;
MCNUM yheight2 = mccchannel_1_analyzer_1_array_crystal_array_5_yheight2;
MCNUM visualize = mccchannel_1_analyzer_1_array_crystal_array_5_visualize;
int target_index = mccchannel_1_analyzer_1_array_crystal_array_5_target_index;
MCNUM target_x = mccchannel_1_analyzer_1_array_crystal_array_5_target_x;
MCNUM target_y = mccchannel_1_analyzer_1_array_crystal_array_5_target_y;
MCNUM target_z = mccchannel_1_analyzer_1_array_crystal_array_5_target_z;
MCNUM focus_aw = mccchannel_1_analyzer_1_array_crystal_array_5_focus_aw;
MCNUM focus_ah = mccchannel_1_analyzer_1_array_crystal_array_5_focus_ah;
MCNUM focus_xw = mccchannel_1_analyzer_1_array_crystal_array_5_focus_xw;
MCNUM focus_xh = mccchannel_1_analyzer_1_array_crystal_array_5_focus_xh;
MCNUM focus_r = mccchannel_1_analyzer_1_array_crystal_array_5_focus_r;
MCNUM p_interact = mccchannel_1_analyzer_1_array_crystal_array_5_p_interact;
char* mask_string = mccchannel_1_analyzer_1_array_crystal_array_5_mask_string;
char* mask_setting = mccchannel_1_analyzer_1_array_crystal_array_5_mask_setting;
MCNUM number_of_activations = mccchannel_1_analyzer_1_array_crystal_array_5_number_of_activations;
}   /* End of channel_1_analyzer_1_array_crystal_array_5=Union_box() SETTING parameter declarations. */
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex
  /* Label for restoring  neutron */
  mcabsorbCompchannel_1_analyzer_1_array_crystal_array_5:
  if (RESTORE) /* restore if needed */
  { RESTORE_NEUTRON(173,
      mcnlx,
      mcnly,
      mcnlz,
      mcnlvx,
      mcnlvy,
      mcnlvz,
      mcnlt,
      mcnlsx,
      mcnlsy,
      mcnlsz,
      mcnlp); }
#undef mcabsorbComp
#undef p
#undef sz
#undef sy
#undef sx
#undef t
#undef vz
#undef vy
#undef vx
#undef z
#undef y
#undef x
  mcDEBUG_STATE(
mcnlx,
mcnly,
mcnlz,
mcnlvx,
mcnlvy,
mcnlvz,
mcnlt,
mcnlsx,
mcnlsy,
mcnlsz,
mcnlp)

  /* TRACE Component channel_1_analyzer_1_array_crystal_array_6 [174] */
  mccoordschange(mcposrchannel_1_analyzer_1_array_crystal_array_6, mcrotrchannel_1_analyzer_1_array_crystal_array_6,
    &mcnlx,
    &mcnly,
    &mcnlz,
    &mcnlvx,
    &mcnlvy,
    &mcnlvz,
    &mcnlsx,
    &mcnlsy,
    &mcnlsz);
  /* define label inside component channel_1_analyzer_1_array_crystal_array_6 (without coords transformations) */
  mcJumpTrace_channel_1_analyzer_1_array_crystal_array_6:
  SIG_MESSAGE("channel_1_analyzer_1_array_crystal_array_6 (Trace)");
  mcDEBUG_COMP("channel_1_analyzer_1_array_crystal_array_6")
  mcDEBUG_STATE(
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp)
#define x mcnlx
#define y mcnly
#define z mcnlz
#define vx mcnlvx
#define vy mcnlvy
#define vz mcnlvz
#define t mcnlt
#define sx mcnlsx
#define sy mcnlsy
#define sz mcnlsz
#define p mcnlp

#define mcabsorbComp mcabsorbCompchannel_1_analyzer_1_array_crystal_array_6
  STORE_NEUTRON(174,
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp);
  mcScattered=0;
  mcRestore=0;
  mcNCounter[174]++;
  mcPCounter[174] += p;
  mcP2Counter[174] += p*p;
#define mccompcurname  channel_1_analyzer_1_array_crystal_array_6
#define mccompcurtype  Union_box
#define mccompcurindex 174
#define loop_index mccchannel_1_analyzer_1_array_crystal_array_6_loop_index
#define this_box_volume mccchannel_1_analyzer_1_array_crystal_array_6_this_box_volume
#define global_geometry_element mccchannel_1_analyzer_1_array_crystal_array_6_global_geometry_element
#define this_box_storage mccchannel_1_analyzer_1_array_crystal_array_6_this_box_storage
{   /* Declarations of channel_1_analyzer_1_array_crystal_array_6=Union_box() SETTING parameters. */
char* material_string = mccchannel_1_analyzer_1_array_crystal_array_6_material_string;
MCNUM priority = mccchannel_1_analyzer_1_array_crystal_array_6_priority;
MCNUM xwidth = mccchannel_1_analyzer_1_array_crystal_array_6_xwidth;
MCNUM yheight = mccchannel_1_analyzer_1_array_crystal_array_6_yheight;
MCNUM zdepth = mccchannel_1_analyzer_1_array_crystal_array_6_zdepth;
MCNUM xwidth2 = mccchannel_1_analyzer_1_array_crystal_array_6_xwidth2;
MCNUM yheight2 = mccchannel_1_analyzer_1_array_crystal_array_6_yheight2;
MCNUM visualize = mccchannel_1_analyzer_1_array_crystal_array_6_visualize;
int target_index = mccchannel_1_analyzer_1_array_crystal_array_6_target_index;
MCNUM target_x = mccchannel_1_analyzer_1_array_crystal_array_6_target_x;
MCNUM target_y = mccchannel_1_analyzer_1_array_crystal_array_6_target_y;
MCNUM target_z = mccchannel_1_analyzer_1_array_crystal_array_6_target_z;
MCNUM focus_aw = mccchannel_1_analyzer_1_array_crystal_array_6_focus_aw;
MCNUM focus_ah = mccchannel_1_analyzer_1_array_crystal_array_6_focus_ah;
MCNUM focus_xw = mccchannel_1_analyzer_1_array_crystal_array_6_focus_xw;
MCNUM focus_xh = mccchannel_1_analyzer_1_array_crystal_array_6_focus_xh;
MCNUM focus_r = mccchannel_1_analyzer_1_array_crystal_array_6_focus_r;
MCNUM p_interact = mccchannel_1_analyzer_1_array_crystal_array_6_p_interact;
char* mask_string = mccchannel_1_analyzer_1_array_crystal_array_6_mask_string;
char* mask_setting = mccchannel_1_analyzer_1_array_crystal_array_6_mask_setting;
MCNUM number_of_activations = mccchannel_1_analyzer_1_array_crystal_array_6_number_of_activations;
}   /* End of channel_1_analyzer_1_array_crystal_array_6=Union_box() SETTING parameter declarations. */
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex
  /* Label for restoring  neutron */
  mcabsorbCompchannel_1_analyzer_1_array_crystal_array_6:
  if (RESTORE) /* restore if needed */
  { RESTORE_NEUTRON(174,
      mcnlx,
      mcnly,
      mcnlz,
      mcnlvx,
      mcnlvy,
      mcnlvz,
      mcnlt,
      mcnlsx,
      mcnlsy,
      mcnlsz,
      mcnlp); }
#undef mcabsorbComp
#undef p
#undef sz
#undef sy
#undef sx
#undef t
#undef vz
#undef vy
#undef vx
#undef z
#undef y
#undef x
  mcDEBUG_STATE(
mcnlx,
mcnly,
mcnlz,
mcnlvx,
mcnlvy,
mcnlvz,
mcnlt,
mcnlsx,
mcnlsy,
mcnlsz,
mcnlp)

  /* TRACE Component channel_1_analyzer_1_array_crystal_array_7 [175] */
  mccoordschange(mcposrchannel_1_analyzer_1_array_crystal_array_7, mcrotrchannel_1_analyzer_1_array_crystal_array_7,
    &mcnlx,
    &mcnly,
    &mcnlz,
    &mcnlvx,
    &mcnlvy,
    &mcnlvz,
    &mcnlsx,
    &mcnlsy,
    &mcnlsz);
  /* define label inside component channel_1_analyzer_1_array_crystal_array_7 (without coords transformations) */
  mcJumpTrace_channel_1_analyzer_1_array_crystal_array_7:
  SIG_MESSAGE("channel_1_analyzer_1_array_crystal_array_7 (Trace)");
  mcDEBUG_COMP("channel_1_analyzer_1_array_crystal_array_7")
  mcDEBUG_STATE(
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp)
#define x mcnlx
#define y mcnly
#define z mcnlz
#define vx mcnlvx
#define vy mcnlvy
#define vz mcnlvz
#define t mcnlt
#define sx mcnlsx
#define sy mcnlsy
#define sz mcnlsz
#define p mcnlp

#define mcabsorbComp mcabsorbCompchannel_1_analyzer_1_array_crystal_array_7
  STORE_NEUTRON(175,
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp);
  mcScattered=0;
  mcRestore=0;
  mcNCounter[175]++;
  mcPCounter[175] += p;
  mcP2Counter[175] += p*p;
#define mccompcurname  channel_1_analyzer_1_array_crystal_array_7
#define mccompcurtype  Union_box
#define mccompcurindex 175
#define loop_index mccchannel_1_analyzer_1_array_crystal_array_7_loop_index
#define this_box_volume mccchannel_1_analyzer_1_array_crystal_array_7_this_box_volume
#define global_geometry_element mccchannel_1_analyzer_1_array_crystal_array_7_global_geometry_element
#define this_box_storage mccchannel_1_analyzer_1_array_crystal_array_7_this_box_storage
{   /* Declarations of channel_1_analyzer_1_array_crystal_array_7=Union_box() SETTING parameters. */
char* material_string = mccchannel_1_analyzer_1_array_crystal_array_7_material_string;
MCNUM priority = mccchannel_1_analyzer_1_array_crystal_array_7_priority;
MCNUM xwidth = mccchannel_1_analyzer_1_array_crystal_array_7_xwidth;
MCNUM yheight = mccchannel_1_analyzer_1_array_crystal_array_7_yheight;
MCNUM zdepth = mccchannel_1_analyzer_1_array_crystal_array_7_zdepth;
MCNUM xwidth2 = mccchannel_1_analyzer_1_array_crystal_array_7_xwidth2;
MCNUM yheight2 = mccchannel_1_analyzer_1_array_crystal_array_7_yheight2;
MCNUM visualize = mccchannel_1_analyzer_1_array_crystal_array_7_visualize;
int target_index = mccchannel_1_analyzer_1_array_crystal_array_7_target_index;
MCNUM target_x = mccchannel_1_analyzer_1_array_crystal_array_7_target_x;
MCNUM target_y = mccchannel_1_analyzer_1_array_crystal_array_7_target_y;
MCNUM target_z = mccchannel_1_analyzer_1_array_crystal_array_7_target_z;
MCNUM focus_aw = mccchannel_1_analyzer_1_array_crystal_array_7_focus_aw;
MCNUM focus_ah = mccchannel_1_analyzer_1_array_crystal_array_7_focus_ah;
MCNUM focus_xw = mccchannel_1_analyzer_1_array_crystal_array_7_focus_xw;
MCNUM focus_xh = mccchannel_1_analyzer_1_array_crystal_array_7_focus_xh;
MCNUM focus_r = mccchannel_1_analyzer_1_array_crystal_array_7_focus_r;
MCNUM p_interact = mccchannel_1_analyzer_1_array_crystal_array_7_p_interact;
char* mask_string = mccchannel_1_analyzer_1_array_crystal_array_7_mask_string;
char* mask_setting = mccchannel_1_analyzer_1_array_crystal_array_7_mask_setting;
MCNUM number_of_activations = mccchannel_1_analyzer_1_array_crystal_array_7_number_of_activations;
}   /* End of channel_1_analyzer_1_array_crystal_array_7=Union_box() SETTING parameter declarations. */
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex
  /* Label for restoring  neutron */
  mcabsorbCompchannel_1_analyzer_1_array_crystal_array_7:
  if (RESTORE) /* restore if needed */
  { RESTORE_NEUTRON(175,
      mcnlx,
      mcnly,
      mcnlz,
      mcnlvx,
      mcnlvy,
      mcnlvz,
      mcnlt,
      mcnlsx,
      mcnlsy,
      mcnlsz,
      mcnlp); }
#undef mcabsorbComp
#undef p
#undef sz
#undef sy
#undef sx
#undef t
#undef vz
#undef vy
#undef vx
#undef z
#undef y
#undef x
  mcDEBUG_STATE(
mcnlx,
mcnly,
mcnlz,
mcnlvx,
mcnlvy,
mcnlvz,
mcnlt,
mcnlsx,
mcnlsy,
mcnlsz,
mcnlp)

  /* TRACE Component channel_1_analyzer_1_array_crystal_array_8 [176] */
  mccoordschange(mcposrchannel_1_analyzer_1_array_crystal_array_8, mcrotrchannel_1_analyzer_1_array_crystal_array_8,
    &mcnlx,
    &mcnly,
    &mcnlz,
    &mcnlvx,
    &mcnlvy,
    &mcnlvz,
    &mcnlsx,
    &mcnlsy,
    &mcnlsz);
  /* define label inside component channel_1_analyzer_1_array_crystal_array_8 (without coords transformations) */
  mcJumpTrace_channel_1_analyzer_1_array_crystal_array_8:
  SIG_MESSAGE("channel_1_analyzer_1_array_crystal_array_8 (Trace)");
  mcDEBUG_COMP("channel_1_analyzer_1_array_crystal_array_8")
  mcDEBUG_STATE(
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp)
#define x mcnlx
#define y mcnly
#define z mcnlz
#define vx mcnlvx
#define vy mcnlvy
#define vz mcnlvz
#define t mcnlt
#define sx mcnlsx
#define sy mcnlsy
#define sz mcnlsz
#define p mcnlp

#define mcabsorbComp mcabsorbCompchannel_1_analyzer_1_array_crystal_array_8
  STORE_NEUTRON(176,
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp);
  mcScattered=0;
  mcRestore=0;
  mcNCounter[176]++;
  mcPCounter[176] += p;
  mcP2Counter[176] += p*p;
#define mccompcurname  channel_1_analyzer_1_array_crystal_array_8
#define mccompcurtype  Union_box
#define mccompcurindex 176
#define loop_index mccchannel_1_analyzer_1_array_crystal_array_8_loop_index
#define this_box_volume mccchannel_1_analyzer_1_array_crystal_array_8_this_box_volume
#define global_geometry_element mccchannel_1_analyzer_1_array_crystal_array_8_global_geometry_element
#define this_box_storage mccchannel_1_analyzer_1_array_crystal_array_8_this_box_storage
{   /* Declarations of channel_1_analyzer_1_array_crystal_array_8=Union_box() SETTING parameters. */
char* material_string = mccchannel_1_analyzer_1_array_crystal_array_8_material_string;
MCNUM priority = mccchannel_1_analyzer_1_array_crystal_array_8_priority;
MCNUM xwidth = mccchannel_1_analyzer_1_array_crystal_array_8_xwidth;
MCNUM yheight = mccchannel_1_analyzer_1_array_crystal_array_8_yheight;
MCNUM zdepth = mccchannel_1_analyzer_1_array_crystal_array_8_zdepth;
MCNUM xwidth2 = mccchannel_1_analyzer_1_array_crystal_array_8_xwidth2;
MCNUM yheight2 = mccchannel_1_analyzer_1_array_crystal_array_8_yheight2;
MCNUM visualize = mccchannel_1_analyzer_1_array_crystal_array_8_visualize;
int target_index = mccchannel_1_analyzer_1_array_crystal_array_8_target_index;
MCNUM target_x = mccchannel_1_analyzer_1_array_crystal_array_8_target_x;
MCNUM target_y = mccchannel_1_analyzer_1_array_crystal_array_8_target_y;
MCNUM target_z = mccchannel_1_analyzer_1_array_crystal_array_8_target_z;
MCNUM focus_aw = mccchannel_1_analyzer_1_array_crystal_array_8_focus_aw;
MCNUM focus_ah = mccchannel_1_analyzer_1_array_crystal_array_8_focus_ah;
MCNUM focus_xw = mccchannel_1_analyzer_1_array_crystal_array_8_focus_xw;
MCNUM focus_xh = mccchannel_1_analyzer_1_array_crystal_array_8_focus_xh;
MCNUM focus_r = mccchannel_1_analyzer_1_array_crystal_array_8_focus_r;
MCNUM p_interact = mccchannel_1_analyzer_1_array_crystal_array_8_p_interact;
char* mask_string = mccchannel_1_analyzer_1_array_crystal_array_8_mask_string;
char* mask_setting = mccchannel_1_analyzer_1_array_crystal_array_8_mask_setting;
MCNUM number_of_activations = mccchannel_1_analyzer_1_array_crystal_array_8_number_of_activations;
}   /* End of channel_1_analyzer_1_array_crystal_array_8=Union_box() SETTING parameter declarations. */
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex
  /* Label for restoring  neutron */
  mcabsorbCompchannel_1_analyzer_1_array_crystal_array_8:
  if (RESTORE) /* restore if needed */
  { RESTORE_NEUTRON(176,
      mcnlx,
      mcnly,
      mcnlz,
      mcnlvx,
      mcnlvy,
      mcnlvz,
      mcnlt,
      mcnlsx,
      mcnlsy,
      mcnlsz,
      mcnlp); }
#undef mcabsorbComp
#undef p
#undef sz
#undef sy
#undef sx
#undef t
#undef vz
#undef vy
#undef vx
#undef z
#undef y
#undef x
  mcDEBUG_STATE(
mcnlx,
mcnly,
mcnlz,
mcnlvx,
mcnlvy,
mcnlvz,
mcnlt,
mcnlsx,
mcnlsy,
mcnlsz,
mcnlp)

  /* TRACE Component channel_1_analyzer_2_center [177] */
  mccoordschange(mcposrchannel_1_analyzer_2_center, mcrotrchannel_1_analyzer_2_center,
    &mcnlx,
    &mcnly,
    &mcnlz,
    &mcnlvx,
    &mcnlvy,
    &mcnlvz,
    &mcnlsx,
    &mcnlsy,
    &mcnlsz);
  /* define label inside component channel_1_analyzer_2_center (without coords transformations) */
  mcJumpTrace_channel_1_analyzer_2_center:
  SIG_MESSAGE("channel_1_analyzer_2_center (Trace)");
  mcDEBUG_COMP("channel_1_analyzer_2_center")
  mcDEBUG_STATE(
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp)
#define x mcnlx
#define y mcnly
#define z mcnlz
#define vx mcnlvx
#define vy mcnlvy
#define vz mcnlvz
#define t mcnlt
#define sx mcnlsx
#define sy mcnlsy
#define sz mcnlsz
#define p mcnlp

#define mcabsorbComp mcabsorbCompchannel_1_analyzer_2_center
  STORE_NEUTRON(177,
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp);
  mcScattered=0;
  mcRestore=0;
  mcNCounter[177]++;
  mcPCounter[177] += p;
  mcP2Counter[177] += p*p;
#define mccompcurname  channel_1_analyzer_2_center
#define mccompcurtype  Arm
#define mccompcurindex 177
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex
  /* Label for restoring  neutron */
  mcabsorbCompchannel_1_analyzer_2_center:
  if (RESTORE) /* restore if needed */
  { RESTORE_NEUTRON(177,
      mcnlx,
      mcnly,
      mcnlz,
      mcnlvx,
      mcnlvy,
      mcnlvz,
      mcnlt,
      mcnlsx,
      mcnlsy,
      mcnlsz,
      mcnlp); }
#undef mcabsorbComp
#undef p
#undef sz
#undef sy
#undef sx
#undef t
#undef vz
#undef vy
#undef vx
#undef z
#undef y
#undef x
  mcDEBUG_STATE(
mcnlx,
mcnly,
mcnlz,
mcnlvx,
mcnlvy,
mcnlvz,
mcnlt,
mcnlsx,
mcnlsy,
mcnlsz,
mcnlp)

  /* TRACE Component channel_1_analyzer_2_rotated [178] */
  mccoordschange(mcposrchannel_1_analyzer_2_rotated, mcrotrchannel_1_analyzer_2_rotated,
    &mcnlx,
    &mcnly,
    &mcnlz,
    &mcnlvx,
    &mcnlvy,
    &mcnlvz,
    &mcnlsx,
    &mcnlsy,
    &mcnlsz);
  /* define label inside component channel_1_analyzer_2_rotated (without coords transformations) */
  mcJumpTrace_channel_1_analyzer_2_rotated:
  SIG_MESSAGE("channel_1_analyzer_2_rotated (Trace)");
  mcDEBUG_COMP("channel_1_analyzer_2_rotated")
  mcDEBUG_STATE(
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp)
#define x mcnlx
#define y mcnly
#define z mcnlz
#define vx mcnlvx
#define vy mcnlvy
#define vz mcnlvz
#define t mcnlt
#define sx mcnlsx
#define sy mcnlsy
#define sz mcnlsz
#define p mcnlp

#define mcabsorbComp mcabsorbCompchannel_1_analyzer_2_rotated
  STORE_NEUTRON(178,
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp);
  mcScattered=0;
  mcRestore=0;
  mcNCounter[178]++;
  mcPCounter[178] += p;
  mcP2Counter[178] += p*p;
#define mccompcurname  channel_1_analyzer_2_rotated
#define mccompcurtype  Arm
#define mccompcurindex 178
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex
  /* Label for restoring  neutron */
  mcabsorbCompchannel_1_analyzer_2_rotated:
  if (RESTORE) /* restore if needed */
  { RESTORE_NEUTRON(178,
      mcnlx,
      mcnly,
      mcnlz,
      mcnlvx,
      mcnlvy,
      mcnlvz,
      mcnlt,
      mcnlsx,
      mcnlsy,
      mcnlsz,
      mcnlp); }
#undef mcabsorbComp
#undef p
#undef sz
#undef sy
#undef sx
#undef t
#undef vz
#undef vy
#undef vx
#undef z
#undef y
#undef x
  mcDEBUG_STATE(
mcnlx,
mcnly,
mcnlz,
mcnlvx,
mcnlvy,
mcnlvz,
mcnlt,
mcnlsx,
mcnlsy,
mcnlsz,
mcnlp)

  /* TRACE Component channel_1_analyzer_2_array_crystal_array_0 [179] */
  mccoordschange(mcposrchannel_1_analyzer_2_array_crystal_array_0, mcrotrchannel_1_analyzer_2_array_crystal_array_0,
    &mcnlx,
    &mcnly,
    &mcnlz,
    &mcnlvx,
    &mcnlvy,
    &mcnlvz,
    &mcnlsx,
    &mcnlsy,
    &mcnlsz);
  /* define label inside component channel_1_analyzer_2_array_crystal_array_0 (without coords transformations) */
  mcJumpTrace_channel_1_analyzer_2_array_crystal_array_0:
  SIG_MESSAGE("channel_1_analyzer_2_array_crystal_array_0 (Trace)");
  mcDEBUG_COMP("channel_1_analyzer_2_array_crystal_array_0")
  mcDEBUG_STATE(
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp)
#define x mcnlx
#define y mcnly
#define z mcnlz
#define vx mcnlvx
#define vy mcnlvy
#define vz mcnlvz
#define t mcnlt
#define sx mcnlsx
#define sy mcnlsy
#define sz mcnlsz
#define p mcnlp

#define mcabsorbComp mcabsorbCompchannel_1_analyzer_2_array_crystal_array_0
  STORE_NEUTRON(179,
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp);
  mcScattered=0;
  mcRestore=0;
  mcNCounter[179]++;
  mcPCounter[179] += p;
  mcP2Counter[179] += p*p;
#define mccompcurname  channel_1_analyzer_2_array_crystal_array_0
#define mccompcurtype  Union_box
#define mccompcurindex 179
#define loop_index mccchannel_1_analyzer_2_array_crystal_array_0_loop_index
#define this_box_volume mccchannel_1_analyzer_2_array_crystal_array_0_this_box_volume
#define global_geometry_element mccchannel_1_analyzer_2_array_crystal_array_0_global_geometry_element
#define this_box_storage mccchannel_1_analyzer_2_array_crystal_array_0_this_box_storage
{   /* Declarations of channel_1_analyzer_2_array_crystal_array_0=Union_box() SETTING parameters. */
char* material_string = mccchannel_1_analyzer_2_array_crystal_array_0_material_string;
MCNUM priority = mccchannel_1_analyzer_2_array_crystal_array_0_priority;
MCNUM xwidth = mccchannel_1_analyzer_2_array_crystal_array_0_xwidth;
MCNUM yheight = mccchannel_1_analyzer_2_array_crystal_array_0_yheight;
MCNUM zdepth = mccchannel_1_analyzer_2_array_crystal_array_0_zdepth;
MCNUM xwidth2 = mccchannel_1_analyzer_2_array_crystal_array_0_xwidth2;
MCNUM yheight2 = mccchannel_1_analyzer_2_array_crystal_array_0_yheight2;
MCNUM visualize = mccchannel_1_analyzer_2_array_crystal_array_0_visualize;
int target_index = mccchannel_1_analyzer_2_array_crystal_array_0_target_index;
MCNUM target_x = mccchannel_1_analyzer_2_array_crystal_array_0_target_x;
MCNUM target_y = mccchannel_1_analyzer_2_array_crystal_array_0_target_y;
MCNUM target_z = mccchannel_1_analyzer_2_array_crystal_array_0_target_z;
MCNUM focus_aw = mccchannel_1_analyzer_2_array_crystal_array_0_focus_aw;
MCNUM focus_ah = mccchannel_1_analyzer_2_array_crystal_array_0_focus_ah;
MCNUM focus_xw = mccchannel_1_analyzer_2_array_crystal_array_0_focus_xw;
MCNUM focus_xh = mccchannel_1_analyzer_2_array_crystal_array_0_focus_xh;
MCNUM focus_r = mccchannel_1_analyzer_2_array_crystal_array_0_focus_r;
MCNUM p_interact = mccchannel_1_analyzer_2_array_crystal_array_0_p_interact;
char* mask_string = mccchannel_1_analyzer_2_array_crystal_array_0_mask_string;
char* mask_setting = mccchannel_1_analyzer_2_array_crystal_array_0_mask_setting;
MCNUM number_of_activations = mccchannel_1_analyzer_2_array_crystal_array_0_number_of_activations;
}   /* End of channel_1_analyzer_2_array_crystal_array_0=Union_box() SETTING parameter declarations. */
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex
  /* Label for restoring  neutron */
  mcabsorbCompchannel_1_analyzer_2_array_crystal_array_0:
  if (RESTORE) /* restore if needed */
  { RESTORE_NEUTRON(179,
      mcnlx,
      mcnly,
      mcnlz,
      mcnlvx,
      mcnlvy,
      mcnlvz,
      mcnlt,
      mcnlsx,
      mcnlsy,
      mcnlsz,
      mcnlp); }
#undef mcabsorbComp
#undef p
#undef sz
#undef sy
#undef sx
#undef t
#undef vz
#undef vy
#undef vx
#undef z
#undef y
#undef x
  mcDEBUG_STATE(
mcnlx,
mcnly,
mcnlz,
mcnlvx,
mcnlvy,
mcnlvz,
mcnlt,
mcnlsx,
mcnlsy,
mcnlsz,
mcnlp)

  /* TRACE Component channel_1_analyzer_2_array_crystal_array_1 [180] */
  mccoordschange(mcposrchannel_1_analyzer_2_array_crystal_array_1, mcrotrchannel_1_analyzer_2_array_crystal_array_1,
    &mcnlx,
    &mcnly,
    &mcnlz,
    &mcnlvx,
    &mcnlvy,
    &mcnlvz,
    &mcnlsx,
    &mcnlsy,
    &mcnlsz);
  /* define label inside component channel_1_analyzer_2_array_crystal_array_1 (without coords transformations) */
  mcJumpTrace_channel_1_analyzer_2_array_crystal_array_1:
  SIG_MESSAGE("channel_1_analyzer_2_array_crystal_array_1 (Trace)");
  mcDEBUG_COMP("channel_1_analyzer_2_array_crystal_array_1")
  mcDEBUG_STATE(
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp)
#define x mcnlx
#define y mcnly
#define z mcnlz
#define vx mcnlvx
#define vy mcnlvy
#define vz mcnlvz
#define t mcnlt
#define sx mcnlsx
#define sy mcnlsy
#define sz mcnlsz
#define p mcnlp

#define mcabsorbComp mcabsorbCompchannel_1_analyzer_2_array_crystal_array_1
  STORE_NEUTRON(180,
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp);
  mcScattered=0;
  mcRestore=0;
  mcNCounter[180]++;
  mcPCounter[180] += p;
  mcP2Counter[180] += p*p;
#define mccompcurname  channel_1_analyzer_2_array_crystal_array_1
#define mccompcurtype  Union_box
#define mccompcurindex 180
#define loop_index mccchannel_1_analyzer_2_array_crystal_array_1_loop_index
#define this_box_volume mccchannel_1_analyzer_2_array_crystal_array_1_this_box_volume
#define global_geometry_element mccchannel_1_analyzer_2_array_crystal_array_1_global_geometry_element
#define this_box_storage mccchannel_1_analyzer_2_array_crystal_array_1_this_box_storage
{   /* Declarations of channel_1_analyzer_2_array_crystal_array_1=Union_box() SETTING parameters. */
char* material_string = mccchannel_1_analyzer_2_array_crystal_array_1_material_string;
MCNUM priority = mccchannel_1_analyzer_2_array_crystal_array_1_priority;
MCNUM xwidth = mccchannel_1_analyzer_2_array_crystal_array_1_xwidth;
MCNUM yheight = mccchannel_1_analyzer_2_array_crystal_array_1_yheight;
MCNUM zdepth = mccchannel_1_analyzer_2_array_crystal_array_1_zdepth;
MCNUM xwidth2 = mccchannel_1_analyzer_2_array_crystal_array_1_xwidth2;
MCNUM yheight2 = mccchannel_1_analyzer_2_array_crystal_array_1_yheight2;
MCNUM visualize = mccchannel_1_analyzer_2_array_crystal_array_1_visualize;
int target_index = mccchannel_1_analyzer_2_array_crystal_array_1_target_index;
MCNUM target_x = mccchannel_1_analyzer_2_array_crystal_array_1_target_x;
MCNUM target_y = mccchannel_1_analyzer_2_array_crystal_array_1_target_y;
MCNUM target_z = mccchannel_1_analyzer_2_array_crystal_array_1_target_z;
MCNUM focus_aw = mccchannel_1_analyzer_2_array_crystal_array_1_focus_aw;
MCNUM focus_ah = mccchannel_1_analyzer_2_array_crystal_array_1_focus_ah;
MCNUM focus_xw = mccchannel_1_analyzer_2_array_crystal_array_1_focus_xw;
MCNUM focus_xh = mccchannel_1_analyzer_2_array_crystal_array_1_focus_xh;
MCNUM focus_r = mccchannel_1_analyzer_2_array_crystal_array_1_focus_r;
MCNUM p_interact = mccchannel_1_analyzer_2_array_crystal_array_1_p_interact;
char* mask_string = mccchannel_1_analyzer_2_array_crystal_array_1_mask_string;
char* mask_setting = mccchannel_1_analyzer_2_array_crystal_array_1_mask_setting;
MCNUM number_of_activations = mccchannel_1_analyzer_2_array_crystal_array_1_number_of_activations;
}   /* End of channel_1_analyzer_2_array_crystal_array_1=Union_box() SETTING parameter declarations. */
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex
  /* Label for restoring  neutron */
  mcabsorbCompchannel_1_analyzer_2_array_crystal_array_1:
  if (RESTORE) /* restore if needed */
  { RESTORE_NEUTRON(180,
      mcnlx,
      mcnly,
      mcnlz,
      mcnlvx,
      mcnlvy,
      mcnlvz,
      mcnlt,
      mcnlsx,
      mcnlsy,
      mcnlsz,
      mcnlp); }
#undef mcabsorbComp
#undef p
#undef sz
#undef sy
#undef sx
#undef t
#undef vz
#undef vy
#undef vx
#undef z
#undef y
#undef x
  mcDEBUG_STATE(
mcnlx,
mcnly,
mcnlz,
mcnlvx,
mcnlvy,
mcnlvz,
mcnlt,
mcnlsx,
mcnlsy,
mcnlsz,
mcnlp)

  /* TRACE Component channel_1_analyzer_2_array_crystal_array_2 [181] */
  mccoordschange(mcposrchannel_1_analyzer_2_array_crystal_array_2, mcrotrchannel_1_analyzer_2_array_crystal_array_2,
    &mcnlx,
    &mcnly,
    &mcnlz,
    &mcnlvx,
    &mcnlvy,
    &mcnlvz,
    &mcnlsx,
    &mcnlsy,
    &mcnlsz);
  /* define label inside component channel_1_analyzer_2_array_crystal_array_2 (without coords transformations) */
  mcJumpTrace_channel_1_analyzer_2_array_crystal_array_2:
  SIG_MESSAGE("channel_1_analyzer_2_array_crystal_array_2 (Trace)");
  mcDEBUG_COMP("channel_1_analyzer_2_array_crystal_array_2")
  mcDEBUG_STATE(
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp)
#define x mcnlx
#define y mcnly
#define z mcnlz
#define vx mcnlvx
#define vy mcnlvy
#define vz mcnlvz
#define t mcnlt
#define sx mcnlsx
#define sy mcnlsy
#define sz mcnlsz
#define p mcnlp

#define mcabsorbComp mcabsorbCompchannel_1_analyzer_2_array_crystal_array_2
  STORE_NEUTRON(181,
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp);
  mcScattered=0;
  mcRestore=0;
  mcNCounter[181]++;
  mcPCounter[181] += p;
  mcP2Counter[181] += p*p;
#define mccompcurname  channel_1_analyzer_2_array_crystal_array_2
#define mccompcurtype  Union_box
#define mccompcurindex 181
#define loop_index mccchannel_1_analyzer_2_array_crystal_array_2_loop_index
#define this_box_volume mccchannel_1_analyzer_2_array_crystal_array_2_this_box_volume
#define global_geometry_element mccchannel_1_analyzer_2_array_crystal_array_2_global_geometry_element
#define this_box_storage mccchannel_1_analyzer_2_array_crystal_array_2_this_box_storage
{   /* Declarations of channel_1_analyzer_2_array_crystal_array_2=Union_box() SETTING parameters. */
char* material_string = mccchannel_1_analyzer_2_array_crystal_array_2_material_string;
MCNUM priority = mccchannel_1_analyzer_2_array_crystal_array_2_priority;
MCNUM xwidth = mccchannel_1_analyzer_2_array_crystal_array_2_xwidth;
MCNUM yheight = mccchannel_1_analyzer_2_array_crystal_array_2_yheight;
MCNUM zdepth = mccchannel_1_analyzer_2_array_crystal_array_2_zdepth;
MCNUM xwidth2 = mccchannel_1_analyzer_2_array_crystal_array_2_xwidth2;
MCNUM yheight2 = mccchannel_1_analyzer_2_array_crystal_array_2_yheight2;
MCNUM visualize = mccchannel_1_analyzer_2_array_crystal_array_2_visualize;
int target_index = mccchannel_1_analyzer_2_array_crystal_array_2_target_index;
MCNUM target_x = mccchannel_1_analyzer_2_array_crystal_array_2_target_x;
MCNUM target_y = mccchannel_1_analyzer_2_array_crystal_array_2_target_y;
MCNUM target_z = mccchannel_1_analyzer_2_array_crystal_array_2_target_z;
MCNUM focus_aw = mccchannel_1_analyzer_2_array_crystal_array_2_focus_aw;
MCNUM focus_ah = mccchannel_1_analyzer_2_array_crystal_array_2_focus_ah;
MCNUM focus_xw = mccchannel_1_analyzer_2_array_crystal_array_2_focus_xw;
MCNUM focus_xh = mccchannel_1_analyzer_2_array_crystal_array_2_focus_xh;
MCNUM focus_r = mccchannel_1_analyzer_2_array_crystal_array_2_focus_r;
MCNUM p_interact = mccchannel_1_analyzer_2_array_crystal_array_2_p_interact;
char* mask_string = mccchannel_1_analyzer_2_array_crystal_array_2_mask_string;
char* mask_setting = mccchannel_1_analyzer_2_array_crystal_array_2_mask_setting;
MCNUM number_of_activations = mccchannel_1_analyzer_2_array_crystal_array_2_number_of_activations;
}   /* End of channel_1_analyzer_2_array_crystal_array_2=Union_box() SETTING parameter declarations. */
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex
  /* Label for restoring  neutron */
  mcabsorbCompchannel_1_analyzer_2_array_crystal_array_2:
  if (RESTORE) /* restore if needed */
  { RESTORE_NEUTRON(181,
      mcnlx,
      mcnly,
      mcnlz,
      mcnlvx,
      mcnlvy,
      mcnlvz,
      mcnlt,
      mcnlsx,
      mcnlsy,
      mcnlsz,
      mcnlp); }
#undef mcabsorbComp
#undef p
#undef sz
#undef sy
#undef sx
#undef t
#undef vz
#undef vy
#undef vx
#undef z
#undef y
#undef x
  mcDEBUG_STATE(
mcnlx,
mcnly,
mcnlz,
mcnlvx,
mcnlvy,
mcnlvz,
mcnlt,
mcnlsx,
mcnlsy,
mcnlsz,
mcnlp)

  /* TRACE Component channel_1_analyzer_2_array_crystal_array_3 [182] */
  mccoordschange(mcposrchannel_1_analyzer_2_array_crystal_array_3, mcrotrchannel_1_analyzer_2_array_crystal_array_3,
    &mcnlx,
    &mcnly,
    &mcnlz,
    &mcnlvx,
    &mcnlvy,
    &mcnlvz,
    &mcnlsx,
    &mcnlsy,
    &mcnlsz);
  /* define label inside component channel_1_analyzer_2_array_crystal_array_3 (without coords transformations) */
  mcJumpTrace_channel_1_analyzer_2_array_crystal_array_3:
  SIG_MESSAGE("channel_1_analyzer_2_array_crystal_array_3 (Trace)");
  mcDEBUG_COMP("channel_1_analyzer_2_array_crystal_array_3")
  mcDEBUG_STATE(
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp)
#define x mcnlx
#define y mcnly
#define z mcnlz
#define vx mcnlvx
#define vy mcnlvy
#define vz mcnlvz
#define t mcnlt
#define sx mcnlsx
#define sy mcnlsy
#define sz mcnlsz
#define p mcnlp

#define mcabsorbComp mcabsorbCompchannel_1_analyzer_2_array_crystal_array_3
  STORE_NEUTRON(182,
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp);
  mcScattered=0;
  mcRestore=0;
  mcNCounter[182]++;
  mcPCounter[182] += p;
  mcP2Counter[182] += p*p;
#define mccompcurname  channel_1_analyzer_2_array_crystal_array_3
#define mccompcurtype  Union_box
#define mccompcurindex 182
#define loop_index mccchannel_1_analyzer_2_array_crystal_array_3_loop_index
#define this_box_volume mccchannel_1_analyzer_2_array_crystal_array_3_this_box_volume
#define global_geometry_element mccchannel_1_analyzer_2_array_crystal_array_3_global_geometry_element
#define this_box_storage mccchannel_1_analyzer_2_array_crystal_array_3_this_box_storage
{   /* Declarations of channel_1_analyzer_2_array_crystal_array_3=Union_box() SETTING parameters. */
char* material_string = mccchannel_1_analyzer_2_array_crystal_array_3_material_string;
MCNUM priority = mccchannel_1_analyzer_2_array_crystal_array_3_priority;
MCNUM xwidth = mccchannel_1_analyzer_2_array_crystal_array_3_xwidth;
MCNUM yheight = mccchannel_1_analyzer_2_array_crystal_array_3_yheight;
MCNUM zdepth = mccchannel_1_analyzer_2_array_crystal_array_3_zdepth;
MCNUM xwidth2 = mccchannel_1_analyzer_2_array_crystal_array_3_xwidth2;
MCNUM yheight2 = mccchannel_1_analyzer_2_array_crystal_array_3_yheight2;
MCNUM visualize = mccchannel_1_analyzer_2_array_crystal_array_3_visualize;
int target_index = mccchannel_1_analyzer_2_array_crystal_array_3_target_index;
MCNUM target_x = mccchannel_1_analyzer_2_array_crystal_array_3_target_x;
MCNUM target_y = mccchannel_1_analyzer_2_array_crystal_array_3_target_y;
MCNUM target_z = mccchannel_1_analyzer_2_array_crystal_array_3_target_z;
MCNUM focus_aw = mccchannel_1_analyzer_2_array_crystal_array_3_focus_aw;
MCNUM focus_ah = mccchannel_1_analyzer_2_array_crystal_array_3_focus_ah;
MCNUM focus_xw = mccchannel_1_analyzer_2_array_crystal_array_3_focus_xw;
MCNUM focus_xh = mccchannel_1_analyzer_2_array_crystal_array_3_focus_xh;
MCNUM focus_r = mccchannel_1_analyzer_2_array_crystal_array_3_focus_r;
MCNUM p_interact = mccchannel_1_analyzer_2_array_crystal_array_3_p_interact;
char* mask_string = mccchannel_1_analyzer_2_array_crystal_array_3_mask_string;
char* mask_setting = mccchannel_1_analyzer_2_array_crystal_array_3_mask_setting;
MCNUM number_of_activations = mccchannel_1_analyzer_2_array_crystal_array_3_number_of_activations;
}   /* End of channel_1_analyzer_2_array_crystal_array_3=Union_box() SETTING parameter declarations. */
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex
  /* Label for restoring  neutron */
  mcabsorbCompchannel_1_analyzer_2_array_crystal_array_3:
  if (RESTORE) /* restore if needed */
  { RESTORE_NEUTRON(182,
      mcnlx,
      mcnly,
      mcnlz,
      mcnlvx,
      mcnlvy,
      mcnlvz,
      mcnlt,
      mcnlsx,
      mcnlsy,
      mcnlsz,
      mcnlp); }
#undef mcabsorbComp
#undef p
#undef sz
#undef sy
#undef sx
#undef t
#undef vz
#undef vy
#undef vx
#undef z
#undef y
#undef x
  mcDEBUG_STATE(
mcnlx,
mcnly,
mcnlz,
mcnlvx,
mcnlvy,
mcnlvz,
mcnlt,
mcnlsx,
mcnlsy,
mcnlsz,
mcnlp)

  /* TRACE Component channel_1_analyzer_2_array_crystal_array_4 [183] */
  mccoordschange(mcposrchannel_1_analyzer_2_array_crystal_array_4, mcrotrchannel_1_analyzer_2_array_crystal_array_4,
    &mcnlx,
    &mcnly,
    &mcnlz,
    &mcnlvx,
    &mcnlvy,
    &mcnlvz,
    &mcnlsx,
    &mcnlsy,
    &mcnlsz);
  /* define label inside component channel_1_analyzer_2_array_crystal_array_4 (without coords transformations) */
  mcJumpTrace_channel_1_analyzer_2_array_crystal_array_4:
  SIG_MESSAGE("channel_1_analyzer_2_array_crystal_array_4 (Trace)");
  mcDEBUG_COMP("channel_1_analyzer_2_array_crystal_array_4")
  mcDEBUG_STATE(
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp)
#define x mcnlx
#define y mcnly
#define z mcnlz
#define vx mcnlvx
#define vy mcnlvy
#define vz mcnlvz
#define t mcnlt
#define sx mcnlsx
#define sy mcnlsy
#define sz mcnlsz
#define p mcnlp

#define mcabsorbComp mcabsorbCompchannel_1_analyzer_2_array_crystal_array_4
  STORE_NEUTRON(183,
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp);
  mcScattered=0;
  mcRestore=0;
  mcNCounter[183]++;
  mcPCounter[183] += p;
  mcP2Counter[183] += p*p;
#define mccompcurname  channel_1_analyzer_2_array_crystal_array_4
#define mccompcurtype  Union_box
#define mccompcurindex 183
#define loop_index mccchannel_1_analyzer_2_array_crystal_array_4_loop_index
#define this_box_volume mccchannel_1_analyzer_2_array_crystal_array_4_this_box_volume
#define global_geometry_element mccchannel_1_analyzer_2_array_crystal_array_4_global_geometry_element
#define this_box_storage mccchannel_1_analyzer_2_array_crystal_array_4_this_box_storage
{   /* Declarations of channel_1_analyzer_2_array_crystal_array_4=Union_box() SETTING parameters. */
char* material_string = mccchannel_1_analyzer_2_array_crystal_array_4_material_string;
MCNUM priority = mccchannel_1_analyzer_2_array_crystal_array_4_priority;
MCNUM xwidth = mccchannel_1_analyzer_2_array_crystal_array_4_xwidth;
MCNUM yheight = mccchannel_1_analyzer_2_array_crystal_array_4_yheight;
MCNUM zdepth = mccchannel_1_analyzer_2_array_crystal_array_4_zdepth;
MCNUM xwidth2 = mccchannel_1_analyzer_2_array_crystal_array_4_xwidth2;
MCNUM yheight2 = mccchannel_1_analyzer_2_array_crystal_array_4_yheight2;
MCNUM visualize = mccchannel_1_analyzer_2_array_crystal_array_4_visualize;
int target_index = mccchannel_1_analyzer_2_array_crystal_array_4_target_index;
MCNUM target_x = mccchannel_1_analyzer_2_array_crystal_array_4_target_x;
MCNUM target_y = mccchannel_1_analyzer_2_array_crystal_array_4_target_y;
MCNUM target_z = mccchannel_1_analyzer_2_array_crystal_array_4_target_z;
MCNUM focus_aw = mccchannel_1_analyzer_2_array_crystal_array_4_focus_aw;
MCNUM focus_ah = mccchannel_1_analyzer_2_array_crystal_array_4_focus_ah;
MCNUM focus_xw = mccchannel_1_analyzer_2_array_crystal_array_4_focus_xw;
MCNUM focus_xh = mccchannel_1_analyzer_2_array_crystal_array_4_focus_xh;
MCNUM focus_r = mccchannel_1_analyzer_2_array_crystal_array_4_focus_r;
MCNUM p_interact = mccchannel_1_analyzer_2_array_crystal_array_4_p_interact;
char* mask_string = mccchannel_1_analyzer_2_array_crystal_array_4_mask_string;
char* mask_setting = mccchannel_1_analyzer_2_array_crystal_array_4_mask_setting;
MCNUM number_of_activations = mccchannel_1_analyzer_2_array_crystal_array_4_number_of_activations;
}   /* End of channel_1_analyzer_2_array_crystal_array_4=Union_box() SETTING parameter declarations. */
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex
  /* Label for restoring  neutron */
  mcabsorbCompchannel_1_analyzer_2_array_crystal_array_4:
  if (RESTORE) /* restore if needed */
  { RESTORE_NEUTRON(183,
      mcnlx,
      mcnly,
      mcnlz,
      mcnlvx,
      mcnlvy,
      mcnlvz,
      mcnlt,
      mcnlsx,
      mcnlsy,
      mcnlsz,
      mcnlp); }
#undef mcabsorbComp
#undef p
#undef sz
#undef sy
#undef sx
#undef t
#undef vz
#undef vy
#undef vx
#undef z
#undef y
#undef x
  mcDEBUG_STATE(
mcnlx,
mcnly,
mcnlz,
mcnlvx,
mcnlvy,
mcnlvz,
mcnlt,
mcnlsx,
mcnlsy,
mcnlsz,
mcnlp)

  /* TRACE Component channel_1_analyzer_2_array_crystal_array_5 [184] */
  mccoordschange(mcposrchannel_1_analyzer_2_array_crystal_array_5, mcrotrchannel_1_analyzer_2_array_crystal_array_5,
    &mcnlx,
    &mcnly,
    &mcnlz,
    &mcnlvx,
    &mcnlvy,
    &mcnlvz,
    &mcnlsx,
    &mcnlsy,
    &mcnlsz);
  /* define label inside component channel_1_analyzer_2_array_crystal_array_5 (without coords transformations) */
  mcJumpTrace_channel_1_analyzer_2_array_crystal_array_5:
  SIG_MESSAGE("channel_1_analyzer_2_array_crystal_array_5 (Trace)");
  mcDEBUG_COMP("channel_1_analyzer_2_array_crystal_array_5")
  mcDEBUG_STATE(
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp)
#define x mcnlx
#define y mcnly
#define z mcnlz
#define vx mcnlvx
#define vy mcnlvy
#define vz mcnlvz
#define t mcnlt
#define sx mcnlsx
#define sy mcnlsy
#define sz mcnlsz
#define p mcnlp

#define mcabsorbComp mcabsorbCompchannel_1_analyzer_2_array_crystal_array_5
  STORE_NEUTRON(184,
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp);
  mcScattered=0;
  mcRestore=0;
  mcNCounter[184]++;
  mcPCounter[184] += p;
  mcP2Counter[184] += p*p;
#define mccompcurname  channel_1_analyzer_2_array_crystal_array_5
#define mccompcurtype  Union_box
#define mccompcurindex 184
#define loop_index mccchannel_1_analyzer_2_array_crystal_array_5_loop_index
#define this_box_volume mccchannel_1_analyzer_2_array_crystal_array_5_this_box_volume
#define global_geometry_element mccchannel_1_analyzer_2_array_crystal_array_5_global_geometry_element
#define this_box_storage mccchannel_1_analyzer_2_array_crystal_array_5_this_box_storage
{   /* Declarations of channel_1_analyzer_2_array_crystal_array_5=Union_box() SETTING parameters. */
char* material_string = mccchannel_1_analyzer_2_array_crystal_array_5_material_string;
MCNUM priority = mccchannel_1_analyzer_2_array_crystal_array_5_priority;
MCNUM xwidth = mccchannel_1_analyzer_2_array_crystal_array_5_xwidth;
MCNUM yheight = mccchannel_1_analyzer_2_array_crystal_array_5_yheight;
MCNUM zdepth = mccchannel_1_analyzer_2_array_crystal_array_5_zdepth;
MCNUM xwidth2 = mccchannel_1_analyzer_2_array_crystal_array_5_xwidth2;
MCNUM yheight2 = mccchannel_1_analyzer_2_array_crystal_array_5_yheight2;
MCNUM visualize = mccchannel_1_analyzer_2_array_crystal_array_5_visualize;
int target_index = mccchannel_1_analyzer_2_array_crystal_array_5_target_index;
MCNUM target_x = mccchannel_1_analyzer_2_array_crystal_array_5_target_x;
MCNUM target_y = mccchannel_1_analyzer_2_array_crystal_array_5_target_y;
MCNUM target_z = mccchannel_1_analyzer_2_array_crystal_array_5_target_z;
MCNUM focus_aw = mccchannel_1_analyzer_2_array_crystal_array_5_focus_aw;
MCNUM focus_ah = mccchannel_1_analyzer_2_array_crystal_array_5_focus_ah;
MCNUM focus_xw = mccchannel_1_analyzer_2_array_crystal_array_5_focus_xw;
MCNUM focus_xh = mccchannel_1_analyzer_2_array_crystal_array_5_focus_xh;
MCNUM focus_r = mccchannel_1_analyzer_2_array_crystal_array_5_focus_r;
MCNUM p_interact = mccchannel_1_analyzer_2_array_crystal_array_5_p_interact;
char* mask_string = mccchannel_1_analyzer_2_array_crystal_array_5_mask_string;
char* mask_setting = mccchannel_1_analyzer_2_array_crystal_array_5_mask_setting;
MCNUM number_of_activations = mccchannel_1_analyzer_2_array_crystal_array_5_number_of_activations;
}   /* End of channel_1_analyzer_2_array_crystal_array_5=Union_box() SETTING parameter declarations. */
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex
  /* Label for restoring  neutron */
  mcabsorbCompchannel_1_analyzer_2_array_crystal_array_5:
  if (RESTORE) /* restore if needed */
  { RESTORE_NEUTRON(184,
      mcnlx,
      mcnly,
      mcnlz,
      mcnlvx,
      mcnlvy,
      mcnlvz,
      mcnlt,
      mcnlsx,
      mcnlsy,
      mcnlsz,
      mcnlp); }
#undef mcabsorbComp
#undef p
#undef sz
#undef sy
#undef sx
#undef t
#undef vz
#undef vy
#undef vx
#undef z
#undef y
#undef x
  mcDEBUG_STATE(
mcnlx,
mcnly,
mcnlz,
mcnlvx,
mcnlvy,
mcnlvz,
mcnlt,
mcnlsx,
mcnlsy,
mcnlsz,
mcnlp)

  /* TRACE Component channel_1_analyzer_2_array_crystal_array_6 [185] */
  mccoordschange(mcposrchannel_1_analyzer_2_array_crystal_array_6, mcrotrchannel_1_analyzer_2_array_crystal_array_6,
    &mcnlx,
    &mcnly,
    &mcnlz,
    &mcnlvx,
    &mcnlvy,
    &mcnlvz,
    &mcnlsx,
    &mcnlsy,
    &mcnlsz);
  /* define label inside component channel_1_analyzer_2_array_crystal_array_6 (without coords transformations) */
  mcJumpTrace_channel_1_analyzer_2_array_crystal_array_6:
  SIG_MESSAGE("channel_1_analyzer_2_array_crystal_array_6 (Trace)");
  mcDEBUG_COMP("channel_1_analyzer_2_array_crystal_array_6")
  mcDEBUG_STATE(
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp)
#define x mcnlx
#define y mcnly
#define z mcnlz
#define vx mcnlvx
#define vy mcnlvy
#define vz mcnlvz
#define t mcnlt
#define sx mcnlsx
#define sy mcnlsy
#define sz mcnlsz
#define p mcnlp

#define mcabsorbComp mcabsorbCompchannel_1_analyzer_2_array_crystal_array_6
  STORE_NEUTRON(185,
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp);
  mcScattered=0;
  mcRestore=0;
  mcNCounter[185]++;
  mcPCounter[185] += p;
  mcP2Counter[185] += p*p;
#define mccompcurname  channel_1_analyzer_2_array_crystal_array_6
#define mccompcurtype  Union_box
#define mccompcurindex 185
#define loop_index mccchannel_1_analyzer_2_array_crystal_array_6_loop_index
#define this_box_volume mccchannel_1_analyzer_2_array_crystal_array_6_this_box_volume
#define global_geometry_element mccchannel_1_analyzer_2_array_crystal_array_6_global_geometry_element
#define this_box_storage mccchannel_1_analyzer_2_array_crystal_array_6_this_box_storage
{   /* Declarations of channel_1_analyzer_2_array_crystal_array_6=Union_box() SETTING parameters. */
char* material_string = mccchannel_1_analyzer_2_array_crystal_array_6_material_string;
MCNUM priority = mccchannel_1_analyzer_2_array_crystal_array_6_priority;
MCNUM xwidth = mccchannel_1_analyzer_2_array_crystal_array_6_xwidth;
MCNUM yheight = mccchannel_1_analyzer_2_array_crystal_array_6_yheight;
MCNUM zdepth = mccchannel_1_analyzer_2_array_crystal_array_6_zdepth;
MCNUM xwidth2 = mccchannel_1_analyzer_2_array_crystal_array_6_xwidth2;
MCNUM yheight2 = mccchannel_1_analyzer_2_array_crystal_array_6_yheight2;
MCNUM visualize = mccchannel_1_analyzer_2_array_crystal_array_6_visualize;
int target_index = mccchannel_1_analyzer_2_array_crystal_array_6_target_index;
MCNUM target_x = mccchannel_1_analyzer_2_array_crystal_array_6_target_x;
MCNUM target_y = mccchannel_1_analyzer_2_array_crystal_array_6_target_y;
MCNUM target_z = mccchannel_1_analyzer_2_array_crystal_array_6_target_z;
MCNUM focus_aw = mccchannel_1_analyzer_2_array_crystal_array_6_focus_aw;
MCNUM focus_ah = mccchannel_1_analyzer_2_array_crystal_array_6_focus_ah;
MCNUM focus_xw = mccchannel_1_analyzer_2_array_crystal_array_6_focus_xw;
MCNUM focus_xh = mccchannel_1_analyzer_2_array_crystal_array_6_focus_xh;
MCNUM focus_r = mccchannel_1_analyzer_2_array_crystal_array_6_focus_r;
MCNUM p_interact = mccchannel_1_analyzer_2_array_crystal_array_6_p_interact;
char* mask_string = mccchannel_1_analyzer_2_array_crystal_array_6_mask_string;
char* mask_setting = mccchannel_1_analyzer_2_array_crystal_array_6_mask_setting;
MCNUM number_of_activations = mccchannel_1_analyzer_2_array_crystal_array_6_number_of_activations;
}   /* End of channel_1_analyzer_2_array_crystal_array_6=Union_box() SETTING parameter declarations. */
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex
  /* Label for restoring  neutron */
  mcabsorbCompchannel_1_analyzer_2_array_crystal_array_6:
  if (RESTORE) /* restore if needed */
  { RESTORE_NEUTRON(185,
      mcnlx,
      mcnly,
      mcnlz,
      mcnlvx,
      mcnlvy,
      mcnlvz,
      mcnlt,
      mcnlsx,
      mcnlsy,
      mcnlsz,
      mcnlp); }
#undef mcabsorbComp
#undef p
#undef sz
#undef sy
#undef sx
#undef t
#undef vz
#undef vy
#undef vx
#undef z
#undef y
#undef x
  mcDEBUG_STATE(
mcnlx,
mcnly,
mcnlz,
mcnlvx,
mcnlvy,
mcnlvz,
mcnlt,
mcnlsx,
mcnlsy,
mcnlsz,
mcnlp)

  /* TRACE Component channel_1_analyzer_2_array_crystal_array_7 [186] */
  mccoordschange(mcposrchannel_1_analyzer_2_array_crystal_array_7, mcrotrchannel_1_analyzer_2_array_crystal_array_7,
    &mcnlx,
    &mcnly,
    &mcnlz,
    &mcnlvx,
    &mcnlvy,
    &mcnlvz,
    &mcnlsx,
    &mcnlsy,
    &mcnlsz);
  /* define label inside component channel_1_analyzer_2_array_crystal_array_7 (without coords transformations) */
  mcJumpTrace_channel_1_analyzer_2_array_crystal_array_7:
  SIG_MESSAGE("channel_1_analyzer_2_array_crystal_array_7 (Trace)");
  mcDEBUG_COMP("channel_1_analyzer_2_array_crystal_array_7")
  mcDEBUG_STATE(
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp)
#define x mcnlx
#define y mcnly
#define z mcnlz
#define vx mcnlvx
#define vy mcnlvy
#define vz mcnlvz
#define t mcnlt
#define sx mcnlsx
#define sy mcnlsy
#define sz mcnlsz
#define p mcnlp

#define mcabsorbComp mcabsorbCompchannel_1_analyzer_2_array_crystal_array_7
  STORE_NEUTRON(186,
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp);
  mcScattered=0;
  mcRestore=0;
  mcNCounter[186]++;
  mcPCounter[186] += p;
  mcP2Counter[186] += p*p;
#define mccompcurname  channel_1_analyzer_2_array_crystal_array_7
#define mccompcurtype  Union_box
#define mccompcurindex 186
#define loop_index mccchannel_1_analyzer_2_array_crystal_array_7_loop_index
#define this_box_volume mccchannel_1_analyzer_2_array_crystal_array_7_this_box_volume
#define global_geometry_element mccchannel_1_analyzer_2_array_crystal_array_7_global_geometry_element
#define this_box_storage mccchannel_1_analyzer_2_array_crystal_array_7_this_box_storage
{   /* Declarations of channel_1_analyzer_2_array_crystal_array_7=Union_box() SETTING parameters. */
char* material_string = mccchannel_1_analyzer_2_array_crystal_array_7_material_string;
MCNUM priority = mccchannel_1_analyzer_2_array_crystal_array_7_priority;
MCNUM xwidth = mccchannel_1_analyzer_2_array_crystal_array_7_xwidth;
MCNUM yheight = mccchannel_1_analyzer_2_array_crystal_array_7_yheight;
MCNUM zdepth = mccchannel_1_analyzer_2_array_crystal_array_7_zdepth;
MCNUM xwidth2 = mccchannel_1_analyzer_2_array_crystal_array_7_xwidth2;
MCNUM yheight2 = mccchannel_1_analyzer_2_array_crystal_array_7_yheight2;
MCNUM visualize = mccchannel_1_analyzer_2_array_crystal_array_7_visualize;
int target_index = mccchannel_1_analyzer_2_array_crystal_array_7_target_index;
MCNUM target_x = mccchannel_1_analyzer_2_array_crystal_array_7_target_x;
MCNUM target_y = mccchannel_1_analyzer_2_array_crystal_array_7_target_y;
MCNUM target_z = mccchannel_1_analyzer_2_array_crystal_array_7_target_z;
MCNUM focus_aw = mccchannel_1_analyzer_2_array_crystal_array_7_focus_aw;
MCNUM focus_ah = mccchannel_1_analyzer_2_array_crystal_array_7_focus_ah;
MCNUM focus_xw = mccchannel_1_analyzer_2_array_crystal_array_7_focus_xw;
MCNUM focus_xh = mccchannel_1_analyzer_2_array_crystal_array_7_focus_xh;
MCNUM focus_r = mccchannel_1_analyzer_2_array_crystal_array_7_focus_r;
MCNUM p_interact = mccchannel_1_analyzer_2_array_crystal_array_7_p_interact;
char* mask_string = mccchannel_1_analyzer_2_array_crystal_array_7_mask_string;
char* mask_setting = mccchannel_1_analyzer_2_array_crystal_array_7_mask_setting;
MCNUM number_of_activations = mccchannel_1_analyzer_2_array_crystal_array_7_number_of_activations;
}   /* End of channel_1_analyzer_2_array_crystal_array_7=Union_box() SETTING parameter declarations. */
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex
  /* Label for restoring  neutron */
  mcabsorbCompchannel_1_analyzer_2_array_crystal_array_7:
  if (RESTORE) /* restore if needed */
  { RESTORE_NEUTRON(186,
      mcnlx,
      mcnly,
      mcnlz,
      mcnlvx,
      mcnlvy,
      mcnlvz,
      mcnlt,
      mcnlsx,
      mcnlsy,
      mcnlsz,
      mcnlp); }
#undef mcabsorbComp
#undef p
#undef sz
#undef sy
#undef sx
#undef t
#undef vz
#undef vy
#undef vx
#undef z
#undef y
#undef x
  mcDEBUG_STATE(
mcnlx,
mcnly,
mcnlz,
mcnlvx,
mcnlvy,
mcnlvz,
mcnlt,
mcnlsx,
mcnlsy,
mcnlsz,
mcnlp)

  /* TRACE Component channel_1_analyzer_2_array_crystal_array_8 [187] */
  mccoordschange(mcposrchannel_1_analyzer_2_array_crystal_array_8, mcrotrchannel_1_analyzer_2_array_crystal_array_8,
    &mcnlx,
    &mcnly,
    &mcnlz,
    &mcnlvx,
    &mcnlvy,
    &mcnlvz,
    &mcnlsx,
    &mcnlsy,
    &mcnlsz);
  /* define label inside component channel_1_analyzer_2_array_crystal_array_8 (without coords transformations) */
  mcJumpTrace_channel_1_analyzer_2_array_crystal_array_8:
  SIG_MESSAGE("channel_1_analyzer_2_array_crystal_array_8 (Trace)");
  mcDEBUG_COMP("channel_1_analyzer_2_array_crystal_array_8")
  mcDEBUG_STATE(
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp)
#define x mcnlx
#define y mcnly
#define z mcnlz
#define vx mcnlvx
#define vy mcnlvy
#define vz mcnlvz
#define t mcnlt
#define sx mcnlsx
#define sy mcnlsy
#define sz mcnlsz
#define p mcnlp

#define mcabsorbComp mcabsorbCompchannel_1_analyzer_2_array_crystal_array_8
  STORE_NEUTRON(187,
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp);
  mcScattered=0;
  mcRestore=0;
  mcNCounter[187]++;
  mcPCounter[187] += p;
  mcP2Counter[187] += p*p;
#define mccompcurname  channel_1_analyzer_2_array_crystal_array_8
#define mccompcurtype  Union_box
#define mccompcurindex 187
#define loop_index mccchannel_1_analyzer_2_array_crystal_array_8_loop_index
#define this_box_volume mccchannel_1_analyzer_2_array_crystal_array_8_this_box_volume
#define global_geometry_element mccchannel_1_analyzer_2_array_crystal_array_8_global_geometry_element
#define this_box_storage mccchannel_1_analyzer_2_array_crystal_array_8_this_box_storage
{   /* Declarations of channel_1_analyzer_2_array_crystal_array_8=Union_box() SETTING parameters. */
char* material_string = mccchannel_1_analyzer_2_array_crystal_array_8_material_string;
MCNUM priority = mccchannel_1_analyzer_2_array_crystal_array_8_priority;
MCNUM xwidth = mccchannel_1_analyzer_2_array_crystal_array_8_xwidth;
MCNUM yheight = mccchannel_1_analyzer_2_array_crystal_array_8_yheight;
MCNUM zdepth = mccchannel_1_analyzer_2_array_crystal_array_8_zdepth;
MCNUM xwidth2 = mccchannel_1_analyzer_2_array_crystal_array_8_xwidth2;
MCNUM yheight2 = mccchannel_1_analyzer_2_array_crystal_array_8_yheight2;
MCNUM visualize = mccchannel_1_analyzer_2_array_crystal_array_8_visualize;
int target_index = mccchannel_1_analyzer_2_array_crystal_array_8_target_index;
MCNUM target_x = mccchannel_1_analyzer_2_array_crystal_array_8_target_x;
MCNUM target_y = mccchannel_1_analyzer_2_array_crystal_array_8_target_y;
MCNUM target_z = mccchannel_1_analyzer_2_array_crystal_array_8_target_z;
MCNUM focus_aw = mccchannel_1_analyzer_2_array_crystal_array_8_focus_aw;
MCNUM focus_ah = mccchannel_1_analyzer_2_array_crystal_array_8_focus_ah;
MCNUM focus_xw = mccchannel_1_analyzer_2_array_crystal_array_8_focus_xw;
MCNUM focus_xh = mccchannel_1_analyzer_2_array_crystal_array_8_focus_xh;
MCNUM focus_r = mccchannel_1_analyzer_2_array_crystal_array_8_focus_r;
MCNUM p_interact = mccchannel_1_analyzer_2_array_crystal_array_8_p_interact;
char* mask_string = mccchannel_1_analyzer_2_array_crystal_array_8_mask_string;
char* mask_setting = mccchannel_1_analyzer_2_array_crystal_array_8_mask_setting;
MCNUM number_of_activations = mccchannel_1_analyzer_2_array_crystal_array_8_number_of_activations;
}   /* End of channel_1_analyzer_2_array_crystal_array_8=Union_box() SETTING parameter declarations. */
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex
  /* Label for restoring  neutron */
  mcabsorbCompchannel_1_analyzer_2_array_crystal_array_8:
  if (RESTORE) /* restore if needed */
  { RESTORE_NEUTRON(187,
      mcnlx,
      mcnly,
      mcnlz,
      mcnlvx,
      mcnlvy,
      mcnlvz,
      mcnlt,
      mcnlsx,
      mcnlsy,
      mcnlsz,
      mcnlp); }
#undef mcabsorbComp
#undef p
#undef sz
#undef sy
#undef sx
#undef t
#undef vz
#undef vy
#undef vx
#undef z
#undef y
#undef x
  mcDEBUG_STATE(
mcnlx,
mcnly,
mcnlz,
mcnlvx,
mcnlvy,
mcnlvz,
mcnlt,
mcnlsx,
mcnlsy,
mcnlsz,
mcnlp)

  /* TRACE Component channel_1_cave2_cyl1 [188] */
  mccoordschange(mcposrchannel_1_cave2_cyl1, mcrotrchannel_1_cave2_cyl1,
    &mcnlx,
    &mcnly,
    &mcnlz,
    &mcnlvx,
    &mcnlvy,
    &mcnlvz,
    &mcnlsx,
    &mcnlsy,
    &mcnlsz);
  /* define label inside component channel_1_cave2_cyl1 (without coords transformations) */
  mcJumpTrace_channel_1_cave2_cyl1:
  SIG_MESSAGE("channel_1_cave2_cyl1 (Trace)");
  mcDEBUG_COMP("channel_1_cave2_cyl1")
  mcDEBUG_STATE(
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp)
#define x mcnlx
#define y mcnly
#define z mcnlz
#define vx mcnlvx
#define vy mcnlvy
#define vz mcnlvz
#define t mcnlt
#define sx mcnlsx
#define sy mcnlsy
#define sz mcnlsz
#define p mcnlp

#define mcabsorbComp mcabsorbCompchannel_1_cave2_cyl1
  STORE_NEUTRON(188,
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp);
  mcScattered=0;
  mcRestore=0;
  mcNCounter[188]++;
  mcPCounter[188] += p;
  mcP2Counter[188] += p*p;
#define mccompcurname  channel_1_cave2_cyl1
#define mccompcurtype  Union_cylinder
#define mccompcurindex 188
#define loop_index mccchannel_1_cave2_cyl1_loop_index
#define this_cylinder_volume mccchannel_1_cave2_cyl1_this_cylinder_volume
#define global_geometry_element mccchannel_1_cave2_cyl1_global_geometry_element
#define this_cylinder_storage mccchannel_1_cave2_cyl1_this_cylinder_storage
{   /* Declarations of channel_1_cave2_cyl1=Union_cylinder() SETTING parameters. */
char* material_string = mccchannel_1_cave2_cyl1_material_string;
MCNUM priority = mccchannel_1_cave2_cyl1_priority;
MCNUM radius = mccchannel_1_cave2_cyl1_radius;
MCNUM yheight = mccchannel_1_cave2_cyl1_yheight;
MCNUM visualize = mccchannel_1_cave2_cyl1_visualize;
int target_index = mccchannel_1_cave2_cyl1_target_index;
MCNUM target_x = mccchannel_1_cave2_cyl1_target_x;
MCNUM target_y = mccchannel_1_cave2_cyl1_target_y;
MCNUM target_z = mccchannel_1_cave2_cyl1_target_z;
MCNUM focus_aw = mccchannel_1_cave2_cyl1_focus_aw;
MCNUM focus_ah = mccchannel_1_cave2_cyl1_focus_ah;
MCNUM focus_xw = mccchannel_1_cave2_cyl1_focus_xw;
MCNUM focus_xh = mccchannel_1_cave2_cyl1_focus_xh;
MCNUM focus_r = mccchannel_1_cave2_cyl1_focus_r;
MCNUM p_interact = mccchannel_1_cave2_cyl1_p_interact;
char* mask_string = mccchannel_1_cave2_cyl1_mask_string;
char* mask_setting = mccchannel_1_cave2_cyl1_mask_setting;
MCNUM number_of_activations = mccchannel_1_cave2_cyl1_number_of_activations;
#line 345 "Union_cylinder.comp"
{
dummy = 1;
}
#line 370959 "MACS_sample_kidney_box.c"
}   /* End of channel_1_cave2_cyl1=Union_cylinder() SETTING parameter declarations. */
#undef this_cylinder_storage
#undef global_geometry_element
#undef this_cylinder_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex
  /* Label for restoring  neutron */
  mcabsorbCompchannel_1_cave2_cyl1:
  if (RESTORE) /* restore if needed */
  { RESTORE_NEUTRON(188,
      mcnlx,
      mcnly,
      mcnlz,
      mcnlvx,
      mcnlvy,
      mcnlvz,
      mcnlt,
      mcnlsx,
      mcnlsy,
      mcnlsz,
      mcnlp); }
#undef mcabsorbComp
#undef p
#undef sz
#undef sy
#undef sx
#undef t
#undef vz
#undef vy
#undef vx
#undef z
#undef y
#undef x
  mcDEBUG_STATE(
mcnlx,
mcnly,
mcnlz,
mcnlvx,
mcnlvy,
mcnlvz,
mcnlt,
mcnlsx,
mcnlsy,
mcnlsz,
mcnlp)

  /* TRACE Component channel_1_cave2_box1 [189] */
  mccoordschange(mcposrchannel_1_cave2_box1, mcrotrchannel_1_cave2_box1,
    &mcnlx,
    &mcnly,
    &mcnlz,
    &mcnlvx,
    &mcnlvy,
    &mcnlvz,
    &mcnlsx,
    &mcnlsy,
    &mcnlsz);
  /* define label inside component channel_1_cave2_box1 (without coords transformations) */
  mcJumpTrace_channel_1_cave2_box1:
  SIG_MESSAGE("channel_1_cave2_box1 (Trace)");
  mcDEBUG_COMP("channel_1_cave2_box1")
  mcDEBUG_STATE(
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp)
#define x mcnlx
#define y mcnly
#define z mcnlz
#define vx mcnlvx
#define vy mcnlvy
#define vz mcnlvz
#define t mcnlt
#define sx mcnlsx
#define sy mcnlsy
#define sz mcnlsz
#define p mcnlp

#define mcabsorbComp mcabsorbCompchannel_1_cave2_box1
  STORE_NEUTRON(189,
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp);
  mcScattered=0;
  mcRestore=0;
  mcNCounter[189]++;
  mcPCounter[189] += p;
  mcP2Counter[189] += p*p;
#define mccompcurname  channel_1_cave2_box1
#define mccompcurtype  Union_box
#define mccompcurindex 189
#define loop_index mccchannel_1_cave2_box1_loop_index
#define this_box_volume mccchannel_1_cave2_box1_this_box_volume
#define global_geometry_element mccchannel_1_cave2_box1_global_geometry_element
#define this_box_storage mccchannel_1_cave2_box1_this_box_storage
{   /* Declarations of channel_1_cave2_box1=Union_box() SETTING parameters. */
char* material_string = mccchannel_1_cave2_box1_material_string;
MCNUM priority = mccchannel_1_cave2_box1_priority;
MCNUM xwidth = mccchannel_1_cave2_box1_xwidth;
MCNUM yheight = mccchannel_1_cave2_box1_yheight;
MCNUM zdepth = mccchannel_1_cave2_box1_zdepth;
MCNUM xwidth2 = mccchannel_1_cave2_box1_xwidth2;
MCNUM yheight2 = mccchannel_1_cave2_box1_yheight2;
MCNUM visualize = mccchannel_1_cave2_box1_visualize;
int target_index = mccchannel_1_cave2_box1_target_index;
MCNUM target_x = mccchannel_1_cave2_box1_target_x;
MCNUM target_y = mccchannel_1_cave2_box1_target_y;
MCNUM target_z = mccchannel_1_cave2_box1_target_z;
MCNUM focus_aw = mccchannel_1_cave2_box1_focus_aw;
MCNUM focus_ah = mccchannel_1_cave2_box1_focus_ah;
MCNUM focus_xw = mccchannel_1_cave2_box1_focus_xw;
MCNUM focus_xh = mccchannel_1_cave2_box1_focus_xh;
MCNUM focus_r = mccchannel_1_cave2_box1_focus_r;
MCNUM p_interact = mccchannel_1_cave2_box1_p_interact;
char* mask_string = mccchannel_1_cave2_box1_mask_string;
char* mask_setting = mccchannel_1_cave2_box1_mask_setting;
MCNUM number_of_activations = mccchannel_1_cave2_box1_number_of_activations;
}   /* End of channel_1_cave2_box1=Union_box() SETTING parameter declarations. */
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex
  /* Label for restoring  neutron */
  mcabsorbCompchannel_1_cave2_box1:
  if (RESTORE) /* restore if needed */
  { RESTORE_NEUTRON(189,
      mcnlx,
      mcnly,
      mcnlz,
      mcnlvx,
      mcnlvy,
      mcnlvz,
      mcnlt,
      mcnlsx,
      mcnlsy,
      mcnlsz,
      mcnlp); }
#undef mcabsorbComp
#undef p
#undef sz
#undef sy
#undef sx
#undef t
#undef vz
#undef vy
#undef vx
#undef z
#undef y
#undef x
  mcDEBUG_STATE(
mcnlx,
mcnly,
mcnlz,
mcnlvx,
mcnlvy,
mcnlvz,
mcnlt,
mcnlsx,
mcnlsy,
mcnlsz,
mcnlp)

  /* TRACE Component channel_1_cave2_box2 [190] */
  mccoordschange(mcposrchannel_1_cave2_box2, mcrotrchannel_1_cave2_box2,
    &mcnlx,
    &mcnly,
    &mcnlz,
    &mcnlvx,
    &mcnlvy,
    &mcnlvz,
    &mcnlsx,
    &mcnlsy,
    &mcnlsz);
  /* define label inside component channel_1_cave2_box2 (without coords transformations) */
  mcJumpTrace_channel_1_cave2_box2:
  SIG_MESSAGE("channel_1_cave2_box2 (Trace)");
  mcDEBUG_COMP("channel_1_cave2_box2")
  mcDEBUG_STATE(
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp)
#define x mcnlx
#define y mcnly
#define z mcnlz
#define vx mcnlvx
#define vy mcnlvy
#define vz mcnlvz
#define t mcnlt
#define sx mcnlsx
#define sy mcnlsy
#define sz mcnlsz
#define p mcnlp

#define mcabsorbComp mcabsorbCompchannel_1_cave2_box2
  STORE_NEUTRON(190,
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp);
  mcScattered=0;
  mcRestore=0;
  mcNCounter[190]++;
  mcPCounter[190] += p;
  mcP2Counter[190] += p*p;
#define mccompcurname  channel_1_cave2_box2
#define mccompcurtype  Union_box
#define mccompcurindex 190
#define loop_index mccchannel_1_cave2_box2_loop_index
#define this_box_volume mccchannel_1_cave2_box2_this_box_volume
#define global_geometry_element mccchannel_1_cave2_box2_global_geometry_element
#define this_box_storage mccchannel_1_cave2_box2_this_box_storage
{   /* Declarations of channel_1_cave2_box2=Union_box() SETTING parameters. */
char* material_string = mccchannel_1_cave2_box2_material_string;
MCNUM priority = mccchannel_1_cave2_box2_priority;
MCNUM xwidth = mccchannel_1_cave2_box2_xwidth;
MCNUM yheight = mccchannel_1_cave2_box2_yheight;
MCNUM zdepth = mccchannel_1_cave2_box2_zdepth;
MCNUM xwidth2 = mccchannel_1_cave2_box2_xwidth2;
MCNUM yheight2 = mccchannel_1_cave2_box2_yheight2;
MCNUM visualize = mccchannel_1_cave2_box2_visualize;
int target_index = mccchannel_1_cave2_box2_target_index;
MCNUM target_x = mccchannel_1_cave2_box2_target_x;
MCNUM target_y = mccchannel_1_cave2_box2_target_y;
MCNUM target_z = mccchannel_1_cave2_box2_target_z;
MCNUM focus_aw = mccchannel_1_cave2_box2_focus_aw;
MCNUM focus_ah = mccchannel_1_cave2_box2_focus_ah;
MCNUM focus_xw = mccchannel_1_cave2_box2_focus_xw;
MCNUM focus_xh = mccchannel_1_cave2_box2_focus_xh;
MCNUM focus_r = mccchannel_1_cave2_box2_focus_r;
MCNUM p_interact = mccchannel_1_cave2_box2_p_interact;
char* mask_string = mccchannel_1_cave2_box2_mask_string;
char* mask_setting = mccchannel_1_cave2_box2_mask_setting;
MCNUM number_of_activations = mccchannel_1_cave2_box2_number_of_activations;
}   /* End of channel_1_cave2_box2=Union_box() SETTING parameter declarations. */
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex
  /* Label for restoring  neutron */
  mcabsorbCompchannel_1_cave2_box2:
  if (RESTORE) /* restore if needed */
  { RESTORE_NEUTRON(190,
      mcnlx,
      mcnly,
      mcnlz,
      mcnlvx,
      mcnlvy,
      mcnlvz,
      mcnlt,
      mcnlsx,
      mcnlsy,
      mcnlsz,
      mcnlp); }
#undef mcabsorbComp
#undef p
#undef sz
#undef sy
#undef sx
#undef t
#undef vz
#undef vy
#undef vx
#undef z
#undef y
#undef x
  mcDEBUG_STATE(
mcnlx,
mcnly,
mcnlz,
mcnlvx,
mcnlvy,
mcnlvz,
mcnlt,
mcnlsx,
mcnlsy,
mcnlsz,
mcnlp)

  /* TRACE Component channel_1_cave2_box3 [191] */
  mccoordschange(mcposrchannel_1_cave2_box3, mcrotrchannel_1_cave2_box3,
    &mcnlx,
    &mcnly,
    &mcnlz,
    &mcnlvx,
    &mcnlvy,
    &mcnlvz,
    &mcnlsx,
    &mcnlsy,
    &mcnlsz);
  /* define label inside component channel_1_cave2_box3 (without coords transformations) */
  mcJumpTrace_channel_1_cave2_box3:
  SIG_MESSAGE("channel_1_cave2_box3 (Trace)");
  mcDEBUG_COMP("channel_1_cave2_box3")
  mcDEBUG_STATE(
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp)
#define x mcnlx
#define y mcnly
#define z mcnlz
#define vx mcnlvx
#define vy mcnlvy
#define vz mcnlvz
#define t mcnlt
#define sx mcnlsx
#define sy mcnlsy
#define sz mcnlsz
#define p mcnlp

#define mcabsorbComp mcabsorbCompchannel_1_cave2_box3
  STORE_NEUTRON(191,
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp);
  mcScattered=0;
  mcRestore=0;
  mcNCounter[191]++;
  mcPCounter[191] += p;
  mcP2Counter[191] += p*p;
#define mccompcurname  channel_1_cave2_box3
#define mccompcurtype  Union_box
#define mccompcurindex 191
#define loop_index mccchannel_1_cave2_box3_loop_index
#define this_box_volume mccchannel_1_cave2_box3_this_box_volume
#define global_geometry_element mccchannel_1_cave2_box3_global_geometry_element
#define this_box_storage mccchannel_1_cave2_box3_this_box_storage
{   /* Declarations of channel_1_cave2_box3=Union_box() SETTING parameters. */
char* material_string = mccchannel_1_cave2_box3_material_string;
MCNUM priority = mccchannel_1_cave2_box3_priority;
MCNUM xwidth = mccchannel_1_cave2_box3_xwidth;
MCNUM yheight = mccchannel_1_cave2_box3_yheight;
MCNUM zdepth = mccchannel_1_cave2_box3_zdepth;
MCNUM xwidth2 = mccchannel_1_cave2_box3_xwidth2;
MCNUM yheight2 = mccchannel_1_cave2_box3_yheight2;
MCNUM visualize = mccchannel_1_cave2_box3_visualize;
int target_index = mccchannel_1_cave2_box3_target_index;
MCNUM target_x = mccchannel_1_cave2_box3_target_x;
MCNUM target_y = mccchannel_1_cave2_box3_target_y;
MCNUM target_z = mccchannel_1_cave2_box3_target_z;
MCNUM focus_aw = mccchannel_1_cave2_box3_focus_aw;
MCNUM focus_ah = mccchannel_1_cave2_box3_focus_ah;
MCNUM focus_xw = mccchannel_1_cave2_box3_focus_xw;
MCNUM focus_xh = mccchannel_1_cave2_box3_focus_xh;
MCNUM focus_r = mccchannel_1_cave2_box3_focus_r;
MCNUM p_interact = mccchannel_1_cave2_box3_p_interact;
char* mask_string = mccchannel_1_cave2_box3_mask_string;
char* mask_setting = mccchannel_1_cave2_box3_mask_setting;
MCNUM number_of_activations = mccchannel_1_cave2_box3_number_of_activations;
}   /* End of channel_1_cave2_box3=Union_box() SETTING parameter declarations. */
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex
  /* Label for restoring  neutron */
  mcabsorbCompchannel_1_cave2_box3:
  if (RESTORE) /* restore if needed */
  { RESTORE_NEUTRON(191,
      mcnlx,
      mcnly,
      mcnlz,
      mcnlvx,
      mcnlvy,
      mcnlvz,
      mcnlt,
      mcnlsx,
      mcnlsy,
      mcnlsz,
      mcnlp); }
#undef mcabsorbComp
#undef p
#undef sz
#undef sy
#undef sx
#undef t
#undef vz
#undef vy
#undef vx
#undef z
#undef y
#undef x
  mcDEBUG_STATE(
mcnlx,
mcnly,
mcnlz,
mcnlvx,
mcnlvy,
mcnlvz,
mcnlt,
mcnlsx,
mcnlsy,
mcnlsz,
mcnlp)

  /* TRACE Component inter_analyzer_colimator_center_1 [192] */
  mccoordschange(mcposrinter_analyzer_colimator_center_1, mcrotrinter_analyzer_colimator_center_1,
    &mcnlx,
    &mcnly,
    &mcnlz,
    &mcnlvx,
    &mcnlvy,
    &mcnlvz,
    &mcnlsx,
    &mcnlsy,
    &mcnlsz);
  /* define label inside component inter_analyzer_colimator_center_1 (without coords transformations) */
  mcJumpTrace_inter_analyzer_colimator_center_1:
  SIG_MESSAGE("inter_analyzer_colimator_center_1 (Trace)");
  mcDEBUG_COMP("inter_analyzer_colimator_center_1")
  mcDEBUG_STATE(
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp)
#define x mcnlx
#define y mcnly
#define z mcnlz
#define vx mcnlvx
#define vy mcnlvy
#define vz mcnlvz
#define t mcnlt
#define sx mcnlsx
#define sy mcnlsy
#define sz mcnlsz
#define p mcnlp

#define mcabsorbComp mcabsorbCompinter_analyzer_colimator_center_1
  STORE_NEUTRON(192,
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp);
  mcScattered=0;
  mcRestore=0;
  mcNCounter[192]++;
  mcPCounter[192] += p;
  mcP2Counter[192] += p*p;
#define mccompcurname  inter_analyzer_colimator_center_1
#define mccompcurtype  Arm
#define mccompcurindex 192
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex
  /* Label for restoring  neutron */
  mcabsorbCompinter_analyzer_colimator_center_1:
  if (RESTORE) /* restore if needed */
  { RESTORE_NEUTRON(192,
      mcnlx,
      mcnly,
      mcnlz,
      mcnlvx,
      mcnlvy,
      mcnlvz,
      mcnlt,
      mcnlsx,
      mcnlsy,
      mcnlsz,
      mcnlp); }
#undef mcabsorbComp
#undef p
#undef sz
#undef sy
#undef sx
#undef t
#undef vz
#undef vy
#undef vx
#undef z
#undef y
#undef x
  mcDEBUG_STATE(
mcnlx,
mcnly,
mcnlz,
mcnlvx,
mcnlvy,
mcnlvz,
mcnlt,
mcnlsx,
mcnlsy,
mcnlsz,
mcnlp)

  /* TRACE Component inter_analyzer_colimator_1_blade_0 [193] */
  mccoordschange(mcposrinter_analyzer_colimator_1_blade_0, mcrotrinter_analyzer_colimator_1_blade_0,
    &mcnlx,
    &mcnly,
    &mcnlz,
    &mcnlvx,
    &mcnlvy,
    &mcnlvz,
    &mcnlsx,
    &mcnlsy,
    &mcnlsz);
  /* define label inside component inter_analyzer_colimator_1_blade_0 (without coords transformations) */
  mcJumpTrace_inter_analyzer_colimator_1_blade_0:
  SIG_MESSAGE("inter_analyzer_colimator_1_blade_0 (Trace)");
  mcDEBUG_COMP("inter_analyzer_colimator_1_blade_0")
  mcDEBUG_STATE(
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp)
#define x mcnlx
#define y mcnly
#define z mcnlz
#define vx mcnlvx
#define vy mcnlvy
#define vz mcnlvz
#define t mcnlt
#define sx mcnlsx
#define sy mcnlsy
#define sz mcnlsz
#define p mcnlp

#define mcabsorbComp mcabsorbCompinter_analyzer_colimator_1_blade_0
  STORE_NEUTRON(193,
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp);
  mcScattered=0;
  mcRestore=0;
  mcNCounter[193]++;
  mcPCounter[193] += p;
  mcP2Counter[193] += p*p;
#define mccompcurname  inter_analyzer_colimator_1_blade_0
#define mccompcurtype  Union_box
#define mccompcurindex 193
#define loop_index mccinter_analyzer_colimator_1_blade_0_loop_index
#define this_box_volume mccinter_analyzer_colimator_1_blade_0_this_box_volume
#define global_geometry_element mccinter_analyzer_colimator_1_blade_0_global_geometry_element
#define this_box_storage mccinter_analyzer_colimator_1_blade_0_this_box_storage
{   /* Declarations of inter_analyzer_colimator_1_blade_0=Union_box() SETTING parameters. */
char* material_string = mccinter_analyzer_colimator_1_blade_0_material_string;
MCNUM priority = mccinter_analyzer_colimator_1_blade_0_priority;
MCNUM xwidth = mccinter_analyzer_colimator_1_blade_0_xwidth;
MCNUM yheight = mccinter_analyzer_colimator_1_blade_0_yheight;
MCNUM zdepth = mccinter_analyzer_colimator_1_blade_0_zdepth;
MCNUM xwidth2 = mccinter_analyzer_colimator_1_blade_0_xwidth2;
MCNUM yheight2 = mccinter_analyzer_colimator_1_blade_0_yheight2;
MCNUM visualize = mccinter_analyzer_colimator_1_blade_0_visualize;
int target_index = mccinter_analyzer_colimator_1_blade_0_target_index;
MCNUM target_x = mccinter_analyzer_colimator_1_blade_0_target_x;
MCNUM target_y = mccinter_analyzer_colimator_1_blade_0_target_y;
MCNUM target_z = mccinter_analyzer_colimator_1_blade_0_target_z;
MCNUM focus_aw = mccinter_analyzer_colimator_1_blade_0_focus_aw;
MCNUM focus_ah = mccinter_analyzer_colimator_1_blade_0_focus_ah;
MCNUM focus_xw = mccinter_analyzer_colimator_1_blade_0_focus_xw;
MCNUM focus_xh = mccinter_analyzer_colimator_1_blade_0_focus_xh;
MCNUM focus_r = mccinter_analyzer_colimator_1_blade_0_focus_r;
MCNUM p_interact = mccinter_analyzer_colimator_1_blade_0_p_interact;
char* mask_string = mccinter_analyzer_colimator_1_blade_0_mask_string;
char* mask_setting = mccinter_analyzer_colimator_1_blade_0_mask_setting;
MCNUM number_of_activations = mccinter_analyzer_colimator_1_blade_0_number_of_activations;
}   /* End of inter_analyzer_colimator_1_blade_0=Union_box() SETTING parameter declarations. */
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex
  /* Label for restoring  neutron */
  mcabsorbCompinter_analyzer_colimator_1_blade_0:
  if (RESTORE) /* restore if needed */
  { RESTORE_NEUTRON(193,
      mcnlx,
      mcnly,
      mcnlz,
      mcnlvx,
      mcnlvy,
      mcnlvz,
      mcnlt,
      mcnlsx,
      mcnlsy,
      mcnlsz,
      mcnlp); }
#undef mcabsorbComp
#undef p
#undef sz
#undef sy
#undef sx
#undef t
#undef vz
#undef vy
#undef vx
#undef z
#undef y
#undef x
  mcDEBUG_STATE(
mcnlx,
mcnly,
mcnlz,
mcnlvx,
mcnlvy,
mcnlvz,
mcnlt,
mcnlsx,
mcnlsy,
mcnlsz,
mcnlp)

  /* TRACE Component inter_analyzer_colimator_1_blade_1 [194] */
  mccoordschange(mcposrinter_analyzer_colimator_1_blade_1, mcrotrinter_analyzer_colimator_1_blade_1,
    &mcnlx,
    &mcnly,
    &mcnlz,
    &mcnlvx,
    &mcnlvy,
    &mcnlvz,
    &mcnlsx,
    &mcnlsy,
    &mcnlsz);
  /* define label inside component inter_analyzer_colimator_1_blade_1 (without coords transformations) */
  mcJumpTrace_inter_analyzer_colimator_1_blade_1:
  SIG_MESSAGE("inter_analyzer_colimator_1_blade_1 (Trace)");
  mcDEBUG_COMP("inter_analyzer_colimator_1_blade_1")
  mcDEBUG_STATE(
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp)
#define x mcnlx
#define y mcnly
#define z mcnlz
#define vx mcnlvx
#define vy mcnlvy
#define vz mcnlvz
#define t mcnlt
#define sx mcnlsx
#define sy mcnlsy
#define sz mcnlsz
#define p mcnlp

#define mcabsorbComp mcabsorbCompinter_analyzer_colimator_1_blade_1
  STORE_NEUTRON(194,
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp);
  mcScattered=0;
  mcRestore=0;
  mcNCounter[194]++;
  mcPCounter[194] += p;
  mcP2Counter[194] += p*p;
#define mccompcurname  inter_analyzer_colimator_1_blade_1
#define mccompcurtype  Union_box
#define mccompcurindex 194
#define loop_index mccinter_analyzer_colimator_1_blade_1_loop_index
#define this_box_volume mccinter_analyzer_colimator_1_blade_1_this_box_volume
#define global_geometry_element mccinter_analyzer_colimator_1_blade_1_global_geometry_element
#define this_box_storage mccinter_analyzer_colimator_1_blade_1_this_box_storage
{   /* Declarations of inter_analyzer_colimator_1_blade_1=Union_box() SETTING parameters. */
char* material_string = mccinter_analyzer_colimator_1_blade_1_material_string;
MCNUM priority = mccinter_analyzer_colimator_1_blade_1_priority;
MCNUM xwidth = mccinter_analyzer_colimator_1_blade_1_xwidth;
MCNUM yheight = mccinter_analyzer_colimator_1_blade_1_yheight;
MCNUM zdepth = mccinter_analyzer_colimator_1_blade_1_zdepth;
MCNUM xwidth2 = mccinter_analyzer_colimator_1_blade_1_xwidth2;
MCNUM yheight2 = mccinter_analyzer_colimator_1_blade_1_yheight2;
MCNUM visualize = mccinter_analyzer_colimator_1_blade_1_visualize;
int target_index = mccinter_analyzer_colimator_1_blade_1_target_index;
MCNUM target_x = mccinter_analyzer_colimator_1_blade_1_target_x;
MCNUM target_y = mccinter_analyzer_colimator_1_blade_1_target_y;
MCNUM target_z = mccinter_analyzer_colimator_1_blade_1_target_z;
MCNUM focus_aw = mccinter_analyzer_colimator_1_blade_1_focus_aw;
MCNUM focus_ah = mccinter_analyzer_colimator_1_blade_1_focus_ah;
MCNUM focus_xw = mccinter_analyzer_colimator_1_blade_1_focus_xw;
MCNUM focus_xh = mccinter_analyzer_colimator_1_blade_1_focus_xh;
MCNUM focus_r = mccinter_analyzer_colimator_1_blade_1_focus_r;
MCNUM p_interact = mccinter_analyzer_colimator_1_blade_1_p_interact;
char* mask_string = mccinter_analyzer_colimator_1_blade_1_mask_string;
char* mask_setting = mccinter_analyzer_colimator_1_blade_1_mask_setting;
MCNUM number_of_activations = mccinter_analyzer_colimator_1_blade_1_number_of_activations;
}   /* End of inter_analyzer_colimator_1_blade_1=Union_box() SETTING parameter declarations. */
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex
  /* Label for restoring  neutron */
  mcabsorbCompinter_analyzer_colimator_1_blade_1:
  if (RESTORE) /* restore if needed */
  { RESTORE_NEUTRON(194,
      mcnlx,
      mcnly,
      mcnlz,
      mcnlvx,
      mcnlvy,
      mcnlvz,
      mcnlt,
      mcnlsx,
      mcnlsy,
      mcnlsz,
      mcnlp); }
#undef mcabsorbComp
#undef p
#undef sz
#undef sy
#undef sx
#undef t
#undef vz
#undef vy
#undef vx
#undef z
#undef y
#undef x
  mcDEBUG_STATE(
mcnlx,
mcnly,
mcnlz,
mcnlvx,
mcnlvy,
mcnlvz,
mcnlt,
mcnlsx,
mcnlsy,
mcnlsz,
mcnlp)

  /* TRACE Component inter_analyzer_colimator_1_blade_2 [195] */
  mccoordschange(mcposrinter_analyzer_colimator_1_blade_2, mcrotrinter_analyzer_colimator_1_blade_2,
    &mcnlx,
    &mcnly,
    &mcnlz,
    &mcnlvx,
    &mcnlvy,
    &mcnlvz,
    &mcnlsx,
    &mcnlsy,
    &mcnlsz);
  /* define label inside component inter_analyzer_colimator_1_blade_2 (without coords transformations) */
  mcJumpTrace_inter_analyzer_colimator_1_blade_2:
  SIG_MESSAGE("inter_analyzer_colimator_1_blade_2 (Trace)");
  mcDEBUG_COMP("inter_analyzer_colimator_1_blade_2")
  mcDEBUG_STATE(
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp)
#define x mcnlx
#define y mcnly
#define z mcnlz
#define vx mcnlvx
#define vy mcnlvy
#define vz mcnlvz
#define t mcnlt
#define sx mcnlsx
#define sy mcnlsy
#define sz mcnlsz
#define p mcnlp

#define mcabsorbComp mcabsorbCompinter_analyzer_colimator_1_blade_2
  STORE_NEUTRON(195,
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp);
  mcScattered=0;
  mcRestore=0;
  mcNCounter[195]++;
  mcPCounter[195] += p;
  mcP2Counter[195] += p*p;
#define mccompcurname  inter_analyzer_colimator_1_blade_2
#define mccompcurtype  Union_box
#define mccompcurindex 195
#define loop_index mccinter_analyzer_colimator_1_blade_2_loop_index
#define this_box_volume mccinter_analyzer_colimator_1_blade_2_this_box_volume
#define global_geometry_element mccinter_analyzer_colimator_1_blade_2_global_geometry_element
#define this_box_storage mccinter_analyzer_colimator_1_blade_2_this_box_storage
{   /* Declarations of inter_analyzer_colimator_1_blade_2=Union_box() SETTING parameters. */
char* material_string = mccinter_analyzer_colimator_1_blade_2_material_string;
MCNUM priority = mccinter_analyzer_colimator_1_blade_2_priority;
MCNUM xwidth = mccinter_analyzer_colimator_1_blade_2_xwidth;
MCNUM yheight = mccinter_analyzer_colimator_1_blade_2_yheight;
MCNUM zdepth = mccinter_analyzer_colimator_1_blade_2_zdepth;
MCNUM xwidth2 = mccinter_analyzer_colimator_1_blade_2_xwidth2;
MCNUM yheight2 = mccinter_analyzer_colimator_1_blade_2_yheight2;
MCNUM visualize = mccinter_analyzer_colimator_1_blade_2_visualize;
int target_index = mccinter_analyzer_colimator_1_blade_2_target_index;
MCNUM target_x = mccinter_analyzer_colimator_1_blade_2_target_x;
MCNUM target_y = mccinter_analyzer_colimator_1_blade_2_target_y;
MCNUM target_z = mccinter_analyzer_colimator_1_blade_2_target_z;
MCNUM focus_aw = mccinter_analyzer_colimator_1_blade_2_focus_aw;
MCNUM focus_ah = mccinter_analyzer_colimator_1_blade_2_focus_ah;
MCNUM focus_xw = mccinter_analyzer_colimator_1_blade_2_focus_xw;
MCNUM focus_xh = mccinter_analyzer_colimator_1_blade_2_focus_xh;
MCNUM focus_r = mccinter_analyzer_colimator_1_blade_2_focus_r;
MCNUM p_interact = mccinter_analyzer_colimator_1_blade_2_p_interact;
char* mask_string = mccinter_analyzer_colimator_1_blade_2_mask_string;
char* mask_setting = mccinter_analyzer_colimator_1_blade_2_mask_setting;
MCNUM number_of_activations = mccinter_analyzer_colimator_1_blade_2_number_of_activations;
}   /* End of inter_analyzer_colimator_1_blade_2=Union_box() SETTING parameter declarations. */
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex
  /* Label for restoring  neutron */
  mcabsorbCompinter_analyzer_colimator_1_blade_2:
  if (RESTORE) /* restore if needed */
  { RESTORE_NEUTRON(195,
      mcnlx,
      mcnly,
      mcnlz,
      mcnlvx,
      mcnlvy,
      mcnlvz,
      mcnlt,
      mcnlsx,
      mcnlsy,
      mcnlsz,
      mcnlp); }
#undef mcabsorbComp
#undef p
#undef sz
#undef sy
#undef sx
#undef t
#undef vz
#undef vy
#undef vx
#undef z
#undef y
#undef x
  mcDEBUG_STATE(
mcnlx,
mcnly,
mcnlz,
mcnlvx,
mcnlvy,
mcnlvz,
mcnlt,
mcnlsx,
mcnlsy,
mcnlsz,
mcnlp)

  /* TRACE Component inter_analyzer_colimator_1_blade_3 [196] */
  mccoordschange(mcposrinter_analyzer_colimator_1_blade_3, mcrotrinter_analyzer_colimator_1_blade_3,
    &mcnlx,
    &mcnly,
    &mcnlz,
    &mcnlvx,
    &mcnlvy,
    &mcnlvz,
    &mcnlsx,
    &mcnlsy,
    &mcnlsz);
  /* define label inside component inter_analyzer_colimator_1_blade_3 (without coords transformations) */
  mcJumpTrace_inter_analyzer_colimator_1_blade_3:
  SIG_MESSAGE("inter_analyzer_colimator_1_blade_3 (Trace)");
  mcDEBUG_COMP("inter_analyzer_colimator_1_blade_3")
  mcDEBUG_STATE(
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp)
#define x mcnlx
#define y mcnly
#define z mcnlz
#define vx mcnlvx
#define vy mcnlvy
#define vz mcnlvz
#define t mcnlt
#define sx mcnlsx
#define sy mcnlsy
#define sz mcnlsz
#define p mcnlp

#define mcabsorbComp mcabsorbCompinter_analyzer_colimator_1_blade_3
  STORE_NEUTRON(196,
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp);
  mcScattered=0;
  mcRestore=0;
  mcNCounter[196]++;
  mcPCounter[196] += p;
  mcP2Counter[196] += p*p;
#define mccompcurname  inter_analyzer_colimator_1_blade_3
#define mccompcurtype  Union_box
#define mccompcurindex 196
#define loop_index mccinter_analyzer_colimator_1_blade_3_loop_index
#define this_box_volume mccinter_analyzer_colimator_1_blade_3_this_box_volume
#define global_geometry_element mccinter_analyzer_colimator_1_blade_3_global_geometry_element
#define this_box_storage mccinter_analyzer_colimator_1_blade_3_this_box_storage
{   /* Declarations of inter_analyzer_colimator_1_blade_3=Union_box() SETTING parameters. */
char* material_string = mccinter_analyzer_colimator_1_blade_3_material_string;
MCNUM priority = mccinter_analyzer_colimator_1_blade_3_priority;
MCNUM xwidth = mccinter_analyzer_colimator_1_blade_3_xwidth;
MCNUM yheight = mccinter_analyzer_colimator_1_blade_3_yheight;
MCNUM zdepth = mccinter_analyzer_colimator_1_blade_3_zdepth;
MCNUM xwidth2 = mccinter_analyzer_colimator_1_blade_3_xwidth2;
MCNUM yheight2 = mccinter_analyzer_colimator_1_blade_3_yheight2;
MCNUM visualize = mccinter_analyzer_colimator_1_blade_3_visualize;
int target_index = mccinter_analyzer_colimator_1_blade_3_target_index;
MCNUM target_x = mccinter_analyzer_colimator_1_blade_3_target_x;
MCNUM target_y = mccinter_analyzer_colimator_1_blade_3_target_y;
MCNUM target_z = mccinter_analyzer_colimator_1_blade_3_target_z;
MCNUM focus_aw = mccinter_analyzer_colimator_1_blade_3_focus_aw;
MCNUM focus_ah = mccinter_analyzer_colimator_1_blade_3_focus_ah;
MCNUM focus_xw = mccinter_analyzer_colimator_1_blade_3_focus_xw;
MCNUM focus_xh = mccinter_analyzer_colimator_1_blade_3_focus_xh;
MCNUM focus_r = mccinter_analyzer_colimator_1_blade_3_focus_r;
MCNUM p_interact = mccinter_analyzer_colimator_1_blade_3_p_interact;
char* mask_string = mccinter_analyzer_colimator_1_blade_3_mask_string;
char* mask_setting = mccinter_analyzer_colimator_1_blade_3_mask_setting;
MCNUM number_of_activations = mccinter_analyzer_colimator_1_blade_3_number_of_activations;
}   /* End of inter_analyzer_colimator_1_blade_3=Union_box() SETTING parameter declarations. */
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex
  /* Label for restoring  neutron */
  mcabsorbCompinter_analyzer_colimator_1_blade_3:
  if (RESTORE) /* restore if needed */
  { RESTORE_NEUTRON(196,
      mcnlx,
      mcnly,
      mcnlz,
      mcnlvx,
      mcnlvy,
      mcnlvz,
      mcnlt,
      mcnlsx,
      mcnlsy,
      mcnlsz,
      mcnlp); }
#undef mcabsorbComp
#undef p
#undef sz
#undef sy
#undef sx
#undef t
#undef vz
#undef vy
#undef vx
#undef z
#undef y
#undef x
  mcDEBUG_STATE(
mcnlx,
mcnly,
mcnlz,
mcnlvx,
mcnlvy,
mcnlvz,
mcnlt,
mcnlsx,
mcnlsy,
mcnlsz,
mcnlp)

  /* TRACE Component inter_analyzer_colimator_1_blade_4 [197] */
  mccoordschange(mcposrinter_analyzer_colimator_1_blade_4, mcrotrinter_analyzer_colimator_1_blade_4,
    &mcnlx,
    &mcnly,
    &mcnlz,
    &mcnlvx,
    &mcnlvy,
    &mcnlvz,
    &mcnlsx,
    &mcnlsy,
    &mcnlsz);
  /* define label inside component inter_analyzer_colimator_1_blade_4 (without coords transformations) */
  mcJumpTrace_inter_analyzer_colimator_1_blade_4:
  SIG_MESSAGE("inter_analyzer_colimator_1_blade_4 (Trace)");
  mcDEBUG_COMP("inter_analyzer_colimator_1_blade_4")
  mcDEBUG_STATE(
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp)
#define x mcnlx
#define y mcnly
#define z mcnlz
#define vx mcnlvx
#define vy mcnlvy
#define vz mcnlvz
#define t mcnlt
#define sx mcnlsx
#define sy mcnlsy
#define sz mcnlsz
#define p mcnlp

#define mcabsorbComp mcabsorbCompinter_analyzer_colimator_1_blade_4
  STORE_NEUTRON(197,
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp);
  mcScattered=0;
  mcRestore=0;
  mcNCounter[197]++;
  mcPCounter[197] += p;
  mcP2Counter[197] += p*p;
#define mccompcurname  inter_analyzer_colimator_1_blade_4
#define mccompcurtype  Union_box
#define mccompcurindex 197
#define loop_index mccinter_analyzer_colimator_1_blade_4_loop_index
#define this_box_volume mccinter_analyzer_colimator_1_blade_4_this_box_volume
#define global_geometry_element mccinter_analyzer_colimator_1_blade_4_global_geometry_element
#define this_box_storage mccinter_analyzer_colimator_1_blade_4_this_box_storage
{   /* Declarations of inter_analyzer_colimator_1_blade_4=Union_box() SETTING parameters. */
char* material_string = mccinter_analyzer_colimator_1_blade_4_material_string;
MCNUM priority = mccinter_analyzer_colimator_1_blade_4_priority;
MCNUM xwidth = mccinter_analyzer_colimator_1_blade_4_xwidth;
MCNUM yheight = mccinter_analyzer_colimator_1_blade_4_yheight;
MCNUM zdepth = mccinter_analyzer_colimator_1_blade_4_zdepth;
MCNUM xwidth2 = mccinter_analyzer_colimator_1_blade_4_xwidth2;
MCNUM yheight2 = mccinter_analyzer_colimator_1_blade_4_yheight2;
MCNUM visualize = mccinter_analyzer_colimator_1_blade_4_visualize;
int target_index = mccinter_analyzer_colimator_1_blade_4_target_index;
MCNUM target_x = mccinter_analyzer_colimator_1_blade_4_target_x;
MCNUM target_y = mccinter_analyzer_colimator_1_blade_4_target_y;
MCNUM target_z = mccinter_analyzer_colimator_1_blade_4_target_z;
MCNUM focus_aw = mccinter_analyzer_colimator_1_blade_4_focus_aw;
MCNUM focus_ah = mccinter_analyzer_colimator_1_blade_4_focus_ah;
MCNUM focus_xw = mccinter_analyzer_colimator_1_blade_4_focus_xw;
MCNUM focus_xh = mccinter_analyzer_colimator_1_blade_4_focus_xh;
MCNUM focus_r = mccinter_analyzer_colimator_1_blade_4_focus_r;
MCNUM p_interact = mccinter_analyzer_colimator_1_blade_4_p_interact;
char* mask_string = mccinter_analyzer_colimator_1_blade_4_mask_string;
char* mask_setting = mccinter_analyzer_colimator_1_blade_4_mask_setting;
MCNUM number_of_activations = mccinter_analyzer_colimator_1_blade_4_number_of_activations;
}   /* End of inter_analyzer_colimator_1_blade_4=Union_box() SETTING parameter declarations. */
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex
  /* Label for restoring  neutron */
  mcabsorbCompinter_analyzer_colimator_1_blade_4:
  if (RESTORE) /* restore if needed */
  { RESTORE_NEUTRON(197,
      mcnlx,
      mcnly,
      mcnlz,
      mcnlvx,
      mcnlvy,
      mcnlvz,
      mcnlt,
      mcnlsx,
      mcnlsy,
      mcnlsz,
      mcnlp); }
#undef mcabsorbComp
#undef p
#undef sz
#undef sy
#undef sx
#undef t
#undef vz
#undef vy
#undef vx
#undef z
#undef y
#undef x
  mcDEBUG_STATE(
mcnlx,
mcnly,
mcnlz,
mcnlvx,
mcnlvy,
mcnlvz,
mcnlt,
mcnlsx,
mcnlsy,
mcnlsz,
mcnlp)

  /* TRACE Component diffraction_detector_1_exit_volume [198] */
  mccoordschange(mcposrdiffraction_detector_1_exit_volume, mcrotrdiffraction_detector_1_exit_volume,
    &mcnlx,
    &mcnly,
    &mcnlz,
    &mcnlvx,
    &mcnlvy,
    &mcnlvz,
    &mcnlsx,
    &mcnlsy,
    &mcnlsz);
  /* define label inside component diffraction_detector_1_exit_volume (without coords transformations) */
  mcJumpTrace_diffraction_detector_1_exit_volume:
  SIG_MESSAGE("diffraction_detector_1_exit_volume (Trace)");
  mcDEBUG_COMP("diffraction_detector_1_exit_volume")
  mcDEBUG_STATE(
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp)
#define x mcnlx
#define y mcnly
#define z mcnlz
#define vx mcnlvx
#define vy mcnlvy
#define vz mcnlvz
#define t mcnlt
#define sx mcnlsx
#define sy mcnlsy
#define sz mcnlsz
#define p mcnlp

#define mcabsorbComp mcabsorbCompdiffraction_detector_1_exit_volume
  STORE_NEUTRON(198,
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp);
  mcScattered=0;
  mcRestore=0;
  mcNCounter[198]++;
  mcPCounter[198] += p;
  mcP2Counter[198] += p*p;
#define mccompcurname  diffraction_detector_1_exit_volume
#define mccompcurtype  Union_box
#define mccompcurindex 198
#define loop_index mccdiffraction_detector_1_exit_volume_loop_index
#define this_box_volume mccdiffraction_detector_1_exit_volume_this_box_volume
#define global_geometry_element mccdiffraction_detector_1_exit_volume_global_geometry_element
#define this_box_storage mccdiffraction_detector_1_exit_volume_this_box_storage
{   /* Declarations of diffraction_detector_1_exit_volume=Union_box() SETTING parameters. */
char* material_string = mccdiffraction_detector_1_exit_volume_material_string;
MCNUM priority = mccdiffraction_detector_1_exit_volume_priority;
MCNUM xwidth = mccdiffraction_detector_1_exit_volume_xwidth;
MCNUM yheight = mccdiffraction_detector_1_exit_volume_yheight;
MCNUM zdepth = mccdiffraction_detector_1_exit_volume_zdepth;
MCNUM xwidth2 = mccdiffraction_detector_1_exit_volume_xwidth2;
MCNUM yheight2 = mccdiffraction_detector_1_exit_volume_yheight2;
MCNUM visualize = mccdiffraction_detector_1_exit_volume_visualize;
int target_index = mccdiffraction_detector_1_exit_volume_target_index;
MCNUM target_x = mccdiffraction_detector_1_exit_volume_target_x;
MCNUM target_y = mccdiffraction_detector_1_exit_volume_target_y;
MCNUM target_z = mccdiffraction_detector_1_exit_volume_target_z;
MCNUM focus_aw = mccdiffraction_detector_1_exit_volume_focus_aw;
MCNUM focus_ah = mccdiffraction_detector_1_exit_volume_focus_ah;
MCNUM focus_xw = mccdiffraction_detector_1_exit_volume_focus_xw;
MCNUM focus_xh = mccdiffraction_detector_1_exit_volume_focus_xh;
MCNUM focus_r = mccdiffraction_detector_1_exit_volume_focus_r;
MCNUM p_interact = mccdiffraction_detector_1_exit_volume_p_interact;
char* mask_string = mccdiffraction_detector_1_exit_volume_mask_string;
char* mask_setting = mccdiffraction_detector_1_exit_volume_mask_setting;
MCNUM number_of_activations = mccdiffraction_detector_1_exit_volume_number_of_activations;
}   /* End of diffraction_detector_1_exit_volume=Union_box() SETTING parameter declarations. */
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex
  /* Label for restoring  neutron */
  mcabsorbCompdiffraction_detector_1_exit_volume:
  if (RESTORE) /* restore if needed */
  { RESTORE_NEUTRON(198,
      mcnlx,
      mcnly,
      mcnlz,
      mcnlvx,
      mcnlvy,
      mcnlvz,
      mcnlt,
      mcnlsx,
      mcnlsy,
      mcnlsz,
      mcnlp); }
#undef mcabsorbComp
#undef p
#undef sz
#undef sy
#undef sx
#undef t
#undef vz
#undef vy
#undef vx
#undef z
#undef y
#undef x
  mcDEBUG_STATE(
mcnlx,
mcnly,
mcnlz,
mcnlvx,
mcnlvy,
mcnlvz,
mcnlt,
mcnlsx,
mcnlsy,
mcnlsz,
mcnlp)

  /* TRACE Component spec_detector_1_exit_volume [199] */
  mccoordschange(mcposrspec_detector_1_exit_volume, mcrotrspec_detector_1_exit_volume,
    &mcnlx,
    &mcnly,
    &mcnlz,
    &mcnlvx,
    &mcnlvy,
    &mcnlvz,
    &mcnlsx,
    &mcnlsy,
    &mcnlsz);
  /* define label inside component spec_detector_1_exit_volume (without coords transformations) */
  mcJumpTrace_spec_detector_1_exit_volume:
  SIG_MESSAGE("spec_detector_1_exit_volume (Trace)");
  mcDEBUG_COMP("spec_detector_1_exit_volume")
  mcDEBUG_STATE(
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp)
#define x mcnlx
#define y mcnly
#define z mcnlz
#define vx mcnlvx
#define vy mcnlvy
#define vz mcnlvz
#define t mcnlt
#define sx mcnlsx
#define sy mcnlsy
#define sz mcnlsz
#define p mcnlp

#define mcabsorbComp mcabsorbCompspec_detector_1_exit_volume
  STORE_NEUTRON(199,
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp);
  mcScattered=0;
  mcRestore=0;
  mcNCounter[199]++;
  mcPCounter[199] += p;
  mcP2Counter[199] += p*p;
#define mccompcurname  spec_detector_1_exit_volume
#define mccompcurtype  Union_box
#define mccompcurindex 199
#define loop_index mccspec_detector_1_exit_volume_loop_index
#define this_box_volume mccspec_detector_1_exit_volume_this_box_volume
#define global_geometry_element mccspec_detector_1_exit_volume_global_geometry_element
#define this_box_storage mccspec_detector_1_exit_volume_this_box_storage
{   /* Declarations of spec_detector_1_exit_volume=Union_box() SETTING parameters. */
char* material_string = mccspec_detector_1_exit_volume_material_string;
MCNUM priority = mccspec_detector_1_exit_volume_priority;
MCNUM xwidth = mccspec_detector_1_exit_volume_xwidth;
MCNUM yheight = mccspec_detector_1_exit_volume_yheight;
MCNUM zdepth = mccspec_detector_1_exit_volume_zdepth;
MCNUM xwidth2 = mccspec_detector_1_exit_volume_xwidth2;
MCNUM yheight2 = mccspec_detector_1_exit_volume_yheight2;
MCNUM visualize = mccspec_detector_1_exit_volume_visualize;
int target_index = mccspec_detector_1_exit_volume_target_index;
MCNUM target_x = mccspec_detector_1_exit_volume_target_x;
MCNUM target_y = mccspec_detector_1_exit_volume_target_y;
MCNUM target_z = mccspec_detector_1_exit_volume_target_z;
MCNUM focus_aw = mccspec_detector_1_exit_volume_focus_aw;
MCNUM focus_ah = mccspec_detector_1_exit_volume_focus_ah;
MCNUM focus_xw = mccspec_detector_1_exit_volume_focus_xw;
MCNUM focus_xh = mccspec_detector_1_exit_volume_focus_xh;
MCNUM focus_r = mccspec_detector_1_exit_volume_focus_r;
MCNUM p_interact = mccspec_detector_1_exit_volume_p_interact;
char* mask_string = mccspec_detector_1_exit_volume_mask_string;
char* mask_setting = mccspec_detector_1_exit_volume_mask_setting;
MCNUM number_of_activations = mccspec_detector_1_exit_volume_number_of_activations;
}   /* End of spec_detector_1_exit_volume=Union_box() SETTING parameter declarations. */
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex
  /* Label for restoring  neutron */
  mcabsorbCompspec_detector_1_exit_volume:
  if (RESTORE) /* restore if needed */
  { RESTORE_NEUTRON(199,
      mcnlx,
      mcnly,
      mcnlz,
      mcnlvx,
      mcnlvy,
      mcnlvz,
      mcnlt,
      mcnlsx,
      mcnlsy,
      mcnlsz,
      mcnlp); }
#undef mcabsorbComp
#undef p
#undef sz
#undef sy
#undef sx
#undef t
#undef vz
#undef vy
#undef vx
#undef z
#undef y
#undef x
  mcDEBUG_STATE(
mcnlx,
mcnly,
mcnlz,
mcnlvx,
mcnlvy,
mcnlvz,
mcnlt,
mcnlsx,
mcnlsy,
mcnlsz,
mcnlp)

  /* TRACE Component channel_2_cave1_box1 [200] */
  mccoordschange(mcposrchannel_2_cave1_box1, mcrotrchannel_2_cave1_box1,
    &mcnlx,
    &mcnly,
    &mcnlz,
    &mcnlvx,
    &mcnlvy,
    &mcnlvz,
    &mcnlsx,
    &mcnlsy,
    &mcnlsz);
  /* define label inside component channel_2_cave1_box1 (without coords transformations) */
  mcJumpTrace_channel_2_cave1_box1:
  SIG_MESSAGE("channel_2_cave1_box1 (Trace)");
  mcDEBUG_COMP("channel_2_cave1_box1")
  mcDEBUG_STATE(
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp)
#define x mcnlx
#define y mcnly
#define z mcnlz
#define vx mcnlvx
#define vy mcnlvy
#define vz mcnlvz
#define t mcnlt
#define sx mcnlsx
#define sy mcnlsy
#define sz mcnlsz
#define p mcnlp

#define mcabsorbComp mcabsorbCompchannel_2_cave1_box1
  STORE_NEUTRON(200,
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp);
  mcScattered=0;
  mcRestore=0;
  mcNCounter[200]++;
  mcPCounter[200] += p;
  mcP2Counter[200] += p*p;
#define mccompcurname  channel_2_cave1_box1
#define mccompcurtype  Union_box
#define mccompcurindex 200
#define loop_index mccchannel_2_cave1_box1_loop_index
#define this_box_volume mccchannel_2_cave1_box1_this_box_volume
#define global_geometry_element mccchannel_2_cave1_box1_global_geometry_element
#define this_box_storage mccchannel_2_cave1_box1_this_box_storage
{   /* Declarations of channel_2_cave1_box1=Union_box() SETTING parameters. */
char* material_string = mccchannel_2_cave1_box1_material_string;
MCNUM priority = mccchannel_2_cave1_box1_priority;
MCNUM xwidth = mccchannel_2_cave1_box1_xwidth;
MCNUM yheight = mccchannel_2_cave1_box1_yheight;
MCNUM zdepth = mccchannel_2_cave1_box1_zdepth;
MCNUM xwidth2 = mccchannel_2_cave1_box1_xwidth2;
MCNUM yheight2 = mccchannel_2_cave1_box1_yheight2;
MCNUM visualize = mccchannel_2_cave1_box1_visualize;
int target_index = mccchannel_2_cave1_box1_target_index;
MCNUM target_x = mccchannel_2_cave1_box1_target_x;
MCNUM target_y = mccchannel_2_cave1_box1_target_y;
MCNUM target_z = mccchannel_2_cave1_box1_target_z;
MCNUM focus_aw = mccchannel_2_cave1_box1_focus_aw;
MCNUM focus_ah = mccchannel_2_cave1_box1_focus_ah;
MCNUM focus_xw = mccchannel_2_cave1_box1_focus_xw;
MCNUM focus_xh = mccchannel_2_cave1_box1_focus_xh;
MCNUM focus_r = mccchannel_2_cave1_box1_focus_r;
MCNUM p_interact = mccchannel_2_cave1_box1_p_interact;
char* mask_string = mccchannel_2_cave1_box1_mask_string;
char* mask_setting = mccchannel_2_cave1_box1_mask_setting;
MCNUM number_of_activations = mccchannel_2_cave1_box1_number_of_activations;
}   /* End of channel_2_cave1_box1=Union_box() SETTING parameter declarations. */
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex
  /* Label for restoring  neutron */
  mcabsorbCompchannel_2_cave1_box1:
  if (RESTORE) /* restore if needed */
  { RESTORE_NEUTRON(200,
      mcnlx,
      mcnly,
      mcnlz,
      mcnlvx,
      mcnlvy,
      mcnlvz,
      mcnlt,
      mcnlsx,
      mcnlsy,
      mcnlsz,
      mcnlp); }
#undef mcabsorbComp
#undef p
#undef sz
#undef sy
#undef sx
#undef t
#undef vz
#undef vy
#undef vx
#undef z
#undef y
#undef x
  mcDEBUG_STATE(
mcnlx,
mcnly,
mcnlz,
mcnlvx,
mcnlvy,
mcnlvz,
mcnlt,
mcnlsx,
mcnlsy,
mcnlsz,
mcnlp)

  /* TRACE Component channel_2_cave1_box2 [201] */
  mccoordschange(mcposrchannel_2_cave1_box2, mcrotrchannel_2_cave1_box2,
    &mcnlx,
    &mcnly,
    &mcnlz,
    &mcnlvx,
    &mcnlvy,
    &mcnlvz,
    &mcnlsx,
    &mcnlsy,
    &mcnlsz);
  /* define label inside component channel_2_cave1_box2 (without coords transformations) */
  mcJumpTrace_channel_2_cave1_box2:
  SIG_MESSAGE("channel_2_cave1_box2 (Trace)");
  mcDEBUG_COMP("channel_2_cave1_box2")
  mcDEBUG_STATE(
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp)
#define x mcnlx
#define y mcnly
#define z mcnlz
#define vx mcnlvx
#define vy mcnlvy
#define vz mcnlvz
#define t mcnlt
#define sx mcnlsx
#define sy mcnlsy
#define sz mcnlsz
#define p mcnlp

#define mcabsorbComp mcabsorbCompchannel_2_cave1_box2
  STORE_NEUTRON(201,
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp);
  mcScattered=0;
  mcRestore=0;
  mcNCounter[201]++;
  mcPCounter[201] += p;
  mcP2Counter[201] += p*p;
#define mccompcurname  channel_2_cave1_box2
#define mccompcurtype  Union_box
#define mccompcurindex 201
#define loop_index mccchannel_2_cave1_box2_loop_index
#define this_box_volume mccchannel_2_cave1_box2_this_box_volume
#define global_geometry_element mccchannel_2_cave1_box2_global_geometry_element
#define this_box_storage mccchannel_2_cave1_box2_this_box_storage
{   /* Declarations of channel_2_cave1_box2=Union_box() SETTING parameters. */
char* material_string = mccchannel_2_cave1_box2_material_string;
MCNUM priority = mccchannel_2_cave1_box2_priority;
MCNUM xwidth = mccchannel_2_cave1_box2_xwidth;
MCNUM yheight = mccchannel_2_cave1_box2_yheight;
MCNUM zdepth = mccchannel_2_cave1_box2_zdepth;
MCNUM xwidth2 = mccchannel_2_cave1_box2_xwidth2;
MCNUM yheight2 = mccchannel_2_cave1_box2_yheight2;
MCNUM visualize = mccchannel_2_cave1_box2_visualize;
int target_index = mccchannel_2_cave1_box2_target_index;
MCNUM target_x = mccchannel_2_cave1_box2_target_x;
MCNUM target_y = mccchannel_2_cave1_box2_target_y;
MCNUM target_z = mccchannel_2_cave1_box2_target_z;
MCNUM focus_aw = mccchannel_2_cave1_box2_focus_aw;
MCNUM focus_ah = mccchannel_2_cave1_box2_focus_ah;
MCNUM focus_xw = mccchannel_2_cave1_box2_focus_xw;
MCNUM focus_xh = mccchannel_2_cave1_box2_focus_xh;
MCNUM focus_r = mccchannel_2_cave1_box2_focus_r;
MCNUM p_interact = mccchannel_2_cave1_box2_p_interact;
char* mask_string = mccchannel_2_cave1_box2_mask_string;
char* mask_setting = mccchannel_2_cave1_box2_mask_setting;
MCNUM number_of_activations = mccchannel_2_cave1_box2_number_of_activations;
}   /* End of channel_2_cave1_box2=Union_box() SETTING parameter declarations. */
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex
  /* Label for restoring  neutron */
  mcabsorbCompchannel_2_cave1_box2:
  if (RESTORE) /* restore if needed */
  { RESTORE_NEUTRON(201,
      mcnlx,
      mcnly,
      mcnlz,
      mcnlvx,
      mcnlvy,
      mcnlvz,
      mcnlt,
      mcnlsx,
      mcnlsy,
      mcnlsz,
      mcnlp); }
#undef mcabsorbComp
#undef p
#undef sz
#undef sy
#undef sx
#undef t
#undef vz
#undef vy
#undef vx
#undef z
#undef y
#undef x
  mcDEBUG_STATE(
mcnlx,
mcnly,
mcnlz,
mcnlvx,
mcnlvy,
mcnlvz,
mcnlt,
mcnlsx,
mcnlsy,
mcnlsz,
mcnlp)

  /* TRACE Component channel_2_cave1_box3 [202] */
  mccoordschange(mcposrchannel_2_cave1_box3, mcrotrchannel_2_cave1_box3,
    &mcnlx,
    &mcnly,
    &mcnlz,
    &mcnlvx,
    &mcnlvy,
    &mcnlvz,
    &mcnlsx,
    &mcnlsy,
    &mcnlsz);
  /* define label inside component channel_2_cave1_box3 (without coords transformations) */
  mcJumpTrace_channel_2_cave1_box3:
  SIG_MESSAGE("channel_2_cave1_box3 (Trace)");
  mcDEBUG_COMP("channel_2_cave1_box3")
  mcDEBUG_STATE(
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp)
#define x mcnlx
#define y mcnly
#define z mcnlz
#define vx mcnlvx
#define vy mcnlvy
#define vz mcnlvz
#define t mcnlt
#define sx mcnlsx
#define sy mcnlsy
#define sz mcnlsz
#define p mcnlp

#define mcabsorbComp mcabsorbCompchannel_2_cave1_box3
  STORE_NEUTRON(202,
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp);
  mcScattered=0;
  mcRestore=0;
  mcNCounter[202]++;
  mcPCounter[202] += p;
  mcP2Counter[202] += p*p;
#define mccompcurname  channel_2_cave1_box3
#define mccompcurtype  Union_box
#define mccompcurindex 202
#define loop_index mccchannel_2_cave1_box3_loop_index
#define this_box_volume mccchannel_2_cave1_box3_this_box_volume
#define global_geometry_element mccchannel_2_cave1_box3_global_geometry_element
#define this_box_storage mccchannel_2_cave1_box3_this_box_storage
{   /* Declarations of channel_2_cave1_box3=Union_box() SETTING parameters. */
char* material_string = mccchannel_2_cave1_box3_material_string;
MCNUM priority = mccchannel_2_cave1_box3_priority;
MCNUM xwidth = mccchannel_2_cave1_box3_xwidth;
MCNUM yheight = mccchannel_2_cave1_box3_yheight;
MCNUM zdepth = mccchannel_2_cave1_box3_zdepth;
MCNUM xwidth2 = mccchannel_2_cave1_box3_xwidth2;
MCNUM yheight2 = mccchannel_2_cave1_box3_yheight2;
MCNUM visualize = mccchannel_2_cave1_box3_visualize;
int target_index = mccchannel_2_cave1_box3_target_index;
MCNUM target_x = mccchannel_2_cave1_box3_target_x;
MCNUM target_y = mccchannel_2_cave1_box3_target_y;
MCNUM target_z = mccchannel_2_cave1_box3_target_z;
MCNUM focus_aw = mccchannel_2_cave1_box3_focus_aw;
MCNUM focus_ah = mccchannel_2_cave1_box3_focus_ah;
MCNUM focus_xw = mccchannel_2_cave1_box3_focus_xw;
MCNUM focus_xh = mccchannel_2_cave1_box3_focus_xh;
MCNUM focus_r = mccchannel_2_cave1_box3_focus_r;
MCNUM p_interact = mccchannel_2_cave1_box3_p_interact;
char* mask_string = mccchannel_2_cave1_box3_mask_string;
char* mask_setting = mccchannel_2_cave1_box3_mask_setting;
MCNUM number_of_activations = mccchannel_2_cave1_box3_number_of_activations;
}   /* End of channel_2_cave1_box3=Union_box() SETTING parameter declarations. */
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex
  /* Label for restoring  neutron */
  mcabsorbCompchannel_2_cave1_box3:
  if (RESTORE) /* restore if needed */
  { RESTORE_NEUTRON(202,
      mcnlx,
      mcnly,
      mcnlz,
      mcnlvx,
      mcnlvy,
      mcnlvz,
      mcnlt,
      mcnlsx,
      mcnlsy,
      mcnlsz,
      mcnlp); }
#undef mcabsorbComp
#undef p
#undef sz
#undef sy
#undef sx
#undef t
#undef vz
#undef vy
#undef vx
#undef z
#undef y
#undef x
  mcDEBUG_STATE(
mcnlx,
mcnly,
mcnlz,
mcnlvx,
mcnlvy,
mcnlvz,
mcnlt,
mcnlsx,
mcnlsy,
mcnlsz,
mcnlp)

  /* TRACE Component channel_2_cave1_cyl1 [203] */
  mccoordschange(mcposrchannel_2_cave1_cyl1, mcrotrchannel_2_cave1_cyl1,
    &mcnlx,
    &mcnly,
    &mcnlz,
    &mcnlvx,
    &mcnlvy,
    &mcnlvz,
    &mcnlsx,
    &mcnlsy,
    &mcnlsz);
  /* define label inside component channel_2_cave1_cyl1 (without coords transformations) */
  mcJumpTrace_channel_2_cave1_cyl1:
  SIG_MESSAGE("channel_2_cave1_cyl1 (Trace)");
  mcDEBUG_COMP("channel_2_cave1_cyl1")
  mcDEBUG_STATE(
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp)
#define x mcnlx
#define y mcnly
#define z mcnlz
#define vx mcnlvx
#define vy mcnlvy
#define vz mcnlvz
#define t mcnlt
#define sx mcnlsx
#define sy mcnlsy
#define sz mcnlsz
#define p mcnlp

#define mcabsorbComp mcabsorbCompchannel_2_cave1_cyl1
  STORE_NEUTRON(203,
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp);
  mcScattered=0;
  mcRestore=0;
  mcNCounter[203]++;
  mcPCounter[203] += p;
  mcP2Counter[203] += p*p;
#define mccompcurname  channel_2_cave1_cyl1
#define mccompcurtype  Union_cylinder
#define mccompcurindex 203
#define loop_index mccchannel_2_cave1_cyl1_loop_index
#define this_cylinder_volume mccchannel_2_cave1_cyl1_this_cylinder_volume
#define global_geometry_element mccchannel_2_cave1_cyl1_global_geometry_element
#define this_cylinder_storage mccchannel_2_cave1_cyl1_this_cylinder_storage
{   /* Declarations of channel_2_cave1_cyl1=Union_cylinder() SETTING parameters. */
char* material_string = mccchannel_2_cave1_cyl1_material_string;
MCNUM priority = mccchannel_2_cave1_cyl1_priority;
MCNUM radius = mccchannel_2_cave1_cyl1_radius;
MCNUM yheight = mccchannel_2_cave1_cyl1_yheight;
MCNUM visualize = mccchannel_2_cave1_cyl1_visualize;
int target_index = mccchannel_2_cave1_cyl1_target_index;
MCNUM target_x = mccchannel_2_cave1_cyl1_target_x;
MCNUM target_y = mccchannel_2_cave1_cyl1_target_y;
MCNUM target_z = mccchannel_2_cave1_cyl1_target_z;
MCNUM focus_aw = mccchannel_2_cave1_cyl1_focus_aw;
MCNUM focus_ah = mccchannel_2_cave1_cyl1_focus_ah;
MCNUM focus_xw = mccchannel_2_cave1_cyl1_focus_xw;
MCNUM focus_xh = mccchannel_2_cave1_cyl1_focus_xh;
MCNUM focus_r = mccchannel_2_cave1_cyl1_focus_r;
MCNUM p_interact = mccchannel_2_cave1_cyl1_p_interact;
char* mask_string = mccchannel_2_cave1_cyl1_mask_string;
char* mask_setting = mccchannel_2_cave1_cyl1_mask_setting;
MCNUM number_of_activations = mccchannel_2_cave1_cyl1_number_of_activations;
#line 345 "Union_cylinder.comp"
{
dummy = 1;
}
#line 372940 "MACS_sample_kidney_box.c"
}   /* End of channel_2_cave1_cyl1=Union_cylinder() SETTING parameter declarations. */
#undef this_cylinder_storage
#undef global_geometry_element
#undef this_cylinder_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex
  /* Label for restoring  neutron */
  mcabsorbCompchannel_2_cave1_cyl1:
  if (RESTORE) /* restore if needed */
  { RESTORE_NEUTRON(203,
      mcnlx,
      mcnly,
      mcnlz,
      mcnlvx,
      mcnlvy,
      mcnlvz,
      mcnlt,
      mcnlsx,
      mcnlsy,
      mcnlsz,
      mcnlp); }
#undef mcabsorbComp
#undef p
#undef sz
#undef sy
#undef sx
#undef t
#undef vz
#undef vy
#undef vx
#undef z
#undef y
#undef x
  mcDEBUG_STATE(
mcnlx,
mcnly,
mcnlz,
mcnlvx,
mcnlvy,
mcnlvz,
mcnlt,
mcnlsx,
mcnlsy,
mcnlsz,
mcnlp)

  /* TRACE Component channel_2_analyzer_1_center [204] */
  mccoordschange(mcposrchannel_2_analyzer_1_center, mcrotrchannel_2_analyzer_1_center,
    &mcnlx,
    &mcnly,
    &mcnlz,
    &mcnlvx,
    &mcnlvy,
    &mcnlvz,
    &mcnlsx,
    &mcnlsy,
    &mcnlsz);
  /* define label inside component channel_2_analyzer_1_center (without coords transformations) */
  mcJumpTrace_channel_2_analyzer_1_center:
  SIG_MESSAGE("channel_2_analyzer_1_center (Trace)");
  mcDEBUG_COMP("channel_2_analyzer_1_center")
  mcDEBUG_STATE(
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp)
#define x mcnlx
#define y mcnly
#define z mcnlz
#define vx mcnlvx
#define vy mcnlvy
#define vz mcnlvz
#define t mcnlt
#define sx mcnlsx
#define sy mcnlsy
#define sz mcnlsz
#define p mcnlp

#define mcabsorbComp mcabsorbCompchannel_2_analyzer_1_center
  STORE_NEUTRON(204,
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp);
  mcScattered=0;
  mcRestore=0;
  mcNCounter[204]++;
  mcPCounter[204] += p;
  mcP2Counter[204] += p*p;
#define mccompcurname  channel_2_analyzer_1_center
#define mccompcurtype  Arm
#define mccompcurindex 204
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex
  /* Label for restoring  neutron */
  mcabsorbCompchannel_2_analyzer_1_center:
  if (RESTORE) /* restore if needed */
  { RESTORE_NEUTRON(204,
      mcnlx,
      mcnly,
      mcnlz,
      mcnlvx,
      mcnlvy,
      mcnlvz,
      mcnlt,
      mcnlsx,
      mcnlsy,
      mcnlsz,
      mcnlp); }
#undef mcabsorbComp
#undef p
#undef sz
#undef sy
#undef sx
#undef t
#undef vz
#undef vy
#undef vx
#undef z
#undef y
#undef x
  mcDEBUG_STATE(
mcnlx,
mcnly,
mcnlz,
mcnlvx,
mcnlvy,
mcnlvz,
mcnlt,
mcnlsx,
mcnlsy,
mcnlsz,
mcnlp)

  /* TRACE Component channel_2_analyzer_1_rotated [205] */
  mccoordschange(mcposrchannel_2_analyzer_1_rotated, mcrotrchannel_2_analyzer_1_rotated,
    &mcnlx,
    &mcnly,
    &mcnlz,
    &mcnlvx,
    &mcnlvy,
    &mcnlvz,
    &mcnlsx,
    &mcnlsy,
    &mcnlsz);
  /* define label inside component channel_2_analyzer_1_rotated (without coords transformations) */
  mcJumpTrace_channel_2_analyzer_1_rotated:
  SIG_MESSAGE("channel_2_analyzer_1_rotated (Trace)");
  mcDEBUG_COMP("channel_2_analyzer_1_rotated")
  mcDEBUG_STATE(
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp)
#define x mcnlx
#define y mcnly
#define z mcnlz
#define vx mcnlvx
#define vy mcnlvy
#define vz mcnlvz
#define t mcnlt
#define sx mcnlsx
#define sy mcnlsy
#define sz mcnlsz
#define p mcnlp

#define mcabsorbComp mcabsorbCompchannel_2_analyzer_1_rotated
  STORE_NEUTRON(205,
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp);
  mcScattered=0;
  mcRestore=0;
  mcNCounter[205]++;
  mcPCounter[205] += p;
  mcP2Counter[205] += p*p;
#define mccompcurname  channel_2_analyzer_1_rotated
#define mccompcurtype  Arm
#define mccompcurindex 205
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex
  /* Label for restoring  neutron */
  mcabsorbCompchannel_2_analyzer_1_rotated:
  if (RESTORE) /* restore if needed */
  { RESTORE_NEUTRON(205,
      mcnlx,
      mcnly,
      mcnlz,
      mcnlvx,
      mcnlvy,
      mcnlvz,
      mcnlt,
      mcnlsx,
      mcnlsy,
      mcnlsz,
      mcnlp); }
#undef mcabsorbComp
#undef p
#undef sz
#undef sy
#undef sx
#undef t
#undef vz
#undef vy
#undef vx
#undef z
#undef y
#undef x
  mcDEBUG_STATE(
mcnlx,
mcnly,
mcnlz,
mcnlvx,
mcnlvy,
mcnlvz,
mcnlt,
mcnlsx,
mcnlsy,
mcnlsz,
mcnlp)

  /* TRACE Component channel_2_analyzer_1_array_crystal_array_0 [206] */
  mccoordschange(mcposrchannel_2_analyzer_1_array_crystal_array_0, mcrotrchannel_2_analyzer_1_array_crystal_array_0,
    &mcnlx,
    &mcnly,
    &mcnlz,
    &mcnlvx,
    &mcnlvy,
    &mcnlvz,
    &mcnlsx,
    &mcnlsy,
    &mcnlsz);
  /* define label inside component channel_2_analyzer_1_array_crystal_array_0 (without coords transformations) */
  mcJumpTrace_channel_2_analyzer_1_array_crystal_array_0:
  SIG_MESSAGE("channel_2_analyzer_1_array_crystal_array_0 (Trace)");
  mcDEBUG_COMP("channel_2_analyzer_1_array_crystal_array_0")
  mcDEBUG_STATE(
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp)
#define x mcnlx
#define y mcnly
#define z mcnlz
#define vx mcnlvx
#define vy mcnlvy
#define vz mcnlvz
#define t mcnlt
#define sx mcnlsx
#define sy mcnlsy
#define sz mcnlsz
#define p mcnlp

#define mcabsorbComp mcabsorbCompchannel_2_analyzer_1_array_crystal_array_0
  STORE_NEUTRON(206,
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp);
  mcScattered=0;
  mcRestore=0;
  mcNCounter[206]++;
  mcPCounter[206] += p;
  mcP2Counter[206] += p*p;
#define mccompcurname  channel_2_analyzer_1_array_crystal_array_0
#define mccompcurtype  Union_box
#define mccompcurindex 206
#define loop_index mccchannel_2_analyzer_1_array_crystal_array_0_loop_index
#define this_box_volume mccchannel_2_analyzer_1_array_crystal_array_0_this_box_volume
#define global_geometry_element mccchannel_2_analyzer_1_array_crystal_array_0_global_geometry_element
#define this_box_storage mccchannel_2_analyzer_1_array_crystal_array_0_this_box_storage
{   /* Declarations of channel_2_analyzer_1_array_crystal_array_0=Union_box() SETTING parameters. */
char* material_string = mccchannel_2_analyzer_1_array_crystal_array_0_material_string;
MCNUM priority = mccchannel_2_analyzer_1_array_crystal_array_0_priority;
MCNUM xwidth = mccchannel_2_analyzer_1_array_crystal_array_0_xwidth;
MCNUM yheight = mccchannel_2_analyzer_1_array_crystal_array_0_yheight;
MCNUM zdepth = mccchannel_2_analyzer_1_array_crystal_array_0_zdepth;
MCNUM xwidth2 = mccchannel_2_analyzer_1_array_crystal_array_0_xwidth2;
MCNUM yheight2 = mccchannel_2_analyzer_1_array_crystal_array_0_yheight2;
MCNUM visualize = mccchannel_2_analyzer_1_array_crystal_array_0_visualize;
int target_index = mccchannel_2_analyzer_1_array_crystal_array_0_target_index;
MCNUM target_x = mccchannel_2_analyzer_1_array_crystal_array_0_target_x;
MCNUM target_y = mccchannel_2_analyzer_1_array_crystal_array_0_target_y;
MCNUM target_z = mccchannel_2_analyzer_1_array_crystal_array_0_target_z;
MCNUM focus_aw = mccchannel_2_analyzer_1_array_crystal_array_0_focus_aw;
MCNUM focus_ah = mccchannel_2_analyzer_1_array_crystal_array_0_focus_ah;
MCNUM focus_xw = mccchannel_2_analyzer_1_array_crystal_array_0_focus_xw;
MCNUM focus_xh = mccchannel_2_analyzer_1_array_crystal_array_0_focus_xh;
MCNUM focus_r = mccchannel_2_analyzer_1_array_crystal_array_0_focus_r;
MCNUM p_interact = mccchannel_2_analyzer_1_array_crystal_array_0_p_interact;
char* mask_string = mccchannel_2_analyzer_1_array_crystal_array_0_mask_string;
char* mask_setting = mccchannel_2_analyzer_1_array_crystal_array_0_mask_setting;
MCNUM number_of_activations = mccchannel_2_analyzer_1_array_crystal_array_0_number_of_activations;
}   /* End of channel_2_analyzer_1_array_crystal_array_0=Union_box() SETTING parameter declarations. */
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex
  /* Label for restoring  neutron */
  mcabsorbCompchannel_2_analyzer_1_array_crystal_array_0:
  if (RESTORE) /* restore if needed */
  { RESTORE_NEUTRON(206,
      mcnlx,
      mcnly,
      mcnlz,
      mcnlvx,
      mcnlvy,
      mcnlvz,
      mcnlt,
      mcnlsx,
      mcnlsy,
      mcnlsz,
      mcnlp); }
#undef mcabsorbComp
#undef p
#undef sz
#undef sy
#undef sx
#undef t
#undef vz
#undef vy
#undef vx
#undef z
#undef y
#undef x
  mcDEBUG_STATE(
mcnlx,
mcnly,
mcnlz,
mcnlvx,
mcnlvy,
mcnlvz,
mcnlt,
mcnlsx,
mcnlsy,
mcnlsz,
mcnlp)

  /* TRACE Component channel_2_analyzer_1_array_crystal_array_1 [207] */
  mccoordschange(mcposrchannel_2_analyzer_1_array_crystal_array_1, mcrotrchannel_2_analyzer_1_array_crystal_array_1,
    &mcnlx,
    &mcnly,
    &mcnlz,
    &mcnlvx,
    &mcnlvy,
    &mcnlvz,
    &mcnlsx,
    &mcnlsy,
    &mcnlsz);
  /* define label inside component channel_2_analyzer_1_array_crystal_array_1 (without coords transformations) */
  mcJumpTrace_channel_2_analyzer_1_array_crystal_array_1:
  SIG_MESSAGE("channel_2_analyzer_1_array_crystal_array_1 (Trace)");
  mcDEBUG_COMP("channel_2_analyzer_1_array_crystal_array_1")
  mcDEBUG_STATE(
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp)
#define x mcnlx
#define y mcnly
#define z mcnlz
#define vx mcnlvx
#define vy mcnlvy
#define vz mcnlvz
#define t mcnlt
#define sx mcnlsx
#define sy mcnlsy
#define sz mcnlsz
#define p mcnlp

#define mcabsorbComp mcabsorbCompchannel_2_analyzer_1_array_crystal_array_1
  STORE_NEUTRON(207,
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp);
  mcScattered=0;
  mcRestore=0;
  mcNCounter[207]++;
  mcPCounter[207] += p;
  mcP2Counter[207] += p*p;
#define mccompcurname  channel_2_analyzer_1_array_crystal_array_1
#define mccompcurtype  Union_box
#define mccompcurindex 207
#define loop_index mccchannel_2_analyzer_1_array_crystal_array_1_loop_index
#define this_box_volume mccchannel_2_analyzer_1_array_crystal_array_1_this_box_volume
#define global_geometry_element mccchannel_2_analyzer_1_array_crystal_array_1_global_geometry_element
#define this_box_storage mccchannel_2_analyzer_1_array_crystal_array_1_this_box_storage
{   /* Declarations of channel_2_analyzer_1_array_crystal_array_1=Union_box() SETTING parameters. */
char* material_string = mccchannel_2_analyzer_1_array_crystal_array_1_material_string;
MCNUM priority = mccchannel_2_analyzer_1_array_crystal_array_1_priority;
MCNUM xwidth = mccchannel_2_analyzer_1_array_crystal_array_1_xwidth;
MCNUM yheight = mccchannel_2_analyzer_1_array_crystal_array_1_yheight;
MCNUM zdepth = mccchannel_2_analyzer_1_array_crystal_array_1_zdepth;
MCNUM xwidth2 = mccchannel_2_analyzer_1_array_crystal_array_1_xwidth2;
MCNUM yheight2 = mccchannel_2_analyzer_1_array_crystal_array_1_yheight2;
MCNUM visualize = mccchannel_2_analyzer_1_array_crystal_array_1_visualize;
int target_index = mccchannel_2_analyzer_1_array_crystal_array_1_target_index;
MCNUM target_x = mccchannel_2_analyzer_1_array_crystal_array_1_target_x;
MCNUM target_y = mccchannel_2_analyzer_1_array_crystal_array_1_target_y;
MCNUM target_z = mccchannel_2_analyzer_1_array_crystal_array_1_target_z;
MCNUM focus_aw = mccchannel_2_analyzer_1_array_crystal_array_1_focus_aw;
MCNUM focus_ah = mccchannel_2_analyzer_1_array_crystal_array_1_focus_ah;
MCNUM focus_xw = mccchannel_2_analyzer_1_array_crystal_array_1_focus_xw;
MCNUM focus_xh = mccchannel_2_analyzer_1_array_crystal_array_1_focus_xh;
MCNUM focus_r = mccchannel_2_analyzer_1_array_crystal_array_1_focus_r;
MCNUM p_interact = mccchannel_2_analyzer_1_array_crystal_array_1_p_interact;
char* mask_string = mccchannel_2_analyzer_1_array_crystal_array_1_mask_string;
char* mask_setting = mccchannel_2_analyzer_1_array_crystal_array_1_mask_setting;
MCNUM number_of_activations = mccchannel_2_analyzer_1_array_crystal_array_1_number_of_activations;
}   /* End of channel_2_analyzer_1_array_crystal_array_1=Union_box() SETTING parameter declarations. */
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex
  /* Label for restoring  neutron */
  mcabsorbCompchannel_2_analyzer_1_array_crystal_array_1:
  if (RESTORE) /* restore if needed */
  { RESTORE_NEUTRON(207,
      mcnlx,
      mcnly,
      mcnlz,
      mcnlvx,
      mcnlvy,
      mcnlvz,
      mcnlt,
      mcnlsx,
      mcnlsy,
      mcnlsz,
      mcnlp); }
#undef mcabsorbComp
#undef p
#undef sz
#undef sy
#undef sx
#undef t
#undef vz
#undef vy
#undef vx
#undef z
#undef y
#undef x
  mcDEBUG_STATE(
mcnlx,
mcnly,
mcnlz,
mcnlvx,
mcnlvy,
mcnlvz,
mcnlt,
mcnlsx,
mcnlsy,
mcnlsz,
mcnlp)

  /* TRACE Component channel_2_analyzer_1_array_crystal_array_2 [208] */
  mccoordschange(mcposrchannel_2_analyzer_1_array_crystal_array_2, mcrotrchannel_2_analyzer_1_array_crystal_array_2,
    &mcnlx,
    &mcnly,
    &mcnlz,
    &mcnlvx,
    &mcnlvy,
    &mcnlvz,
    &mcnlsx,
    &mcnlsy,
    &mcnlsz);
  /* define label inside component channel_2_analyzer_1_array_crystal_array_2 (without coords transformations) */
  mcJumpTrace_channel_2_analyzer_1_array_crystal_array_2:
  SIG_MESSAGE("channel_2_analyzer_1_array_crystal_array_2 (Trace)");
  mcDEBUG_COMP("channel_2_analyzer_1_array_crystal_array_2")
  mcDEBUG_STATE(
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp)
#define x mcnlx
#define y mcnly
#define z mcnlz
#define vx mcnlvx
#define vy mcnlvy
#define vz mcnlvz
#define t mcnlt
#define sx mcnlsx
#define sy mcnlsy
#define sz mcnlsz
#define p mcnlp

#define mcabsorbComp mcabsorbCompchannel_2_analyzer_1_array_crystal_array_2
  STORE_NEUTRON(208,
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp);
  mcScattered=0;
  mcRestore=0;
  mcNCounter[208]++;
  mcPCounter[208] += p;
  mcP2Counter[208] += p*p;
#define mccompcurname  channel_2_analyzer_1_array_crystal_array_2
#define mccompcurtype  Union_box
#define mccompcurindex 208
#define loop_index mccchannel_2_analyzer_1_array_crystal_array_2_loop_index
#define this_box_volume mccchannel_2_analyzer_1_array_crystal_array_2_this_box_volume
#define global_geometry_element mccchannel_2_analyzer_1_array_crystal_array_2_global_geometry_element
#define this_box_storage mccchannel_2_analyzer_1_array_crystal_array_2_this_box_storage
{   /* Declarations of channel_2_analyzer_1_array_crystal_array_2=Union_box() SETTING parameters. */
char* material_string = mccchannel_2_analyzer_1_array_crystal_array_2_material_string;
MCNUM priority = mccchannel_2_analyzer_1_array_crystal_array_2_priority;
MCNUM xwidth = mccchannel_2_analyzer_1_array_crystal_array_2_xwidth;
MCNUM yheight = mccchannel_2_analyzer_1_array_crystal_array_2_yheight;
MCNUM zdepth = mccchannel_2_analyzer_1_array_crystal_array_2_zdepth;
MCNUM xwidth2 = mccchannel_2_analyzer_1_array_crystal_array_2_xwidth2;
MCNUM yheight2 = mccchannel_2_analyzer_1_array_crystal_array_2_yheight2;
MCNUM visualize = mccchannel_2_analyzer_1_array_crystal_array_2_visualize;
int target_index = mccchannel_2_analyzer_1_array_crystal_array_2_target_index;
MCNUM target_x = mccchannel_2_analyzer_1_array_crystal_array_2_target_x;
MCNUM target_y = mccchannel_2_analyzer_1_array_crystal_array_2_target_y;
MCNUM target_z = mccchannel_2_analyzer_1_array_crystal_array_2_target_z;
MCNUM focus_aw = mccchannel_2_analyzer_1_array_crystal_array_2_focus_aw;
MCNUM focus_ah = mccchannel_2_analyzer_1_array_crystal_array_2_focus_ah;
MCNUM focus_xw = mccchannel_2_analyzer_1_array_crystal_array_2_focus_xw;
MCNUM focus_xh = mccchannel_2_analyzer_1_array_crystal_array_2_focus_xh;
MCNUM focus_r = mccchannel_2_analyzer_1_array_crystal_array_2_focus_r;
MCNUM p_interact = mccchannel_2_analyzer_1_array_crystal_array_2_p_interact;
char* mask_string = mccchannel_2_analyzer_1_array_crystal_array_2_mask_string;
char* mask_setting = mccchannel_2_analyzer_1_array_crystal_array_2_mask_setting;
MCNUM number_of_activations = mccchannel_2_analyzer_1_array_crystal_array_2_number_of_activations;
}   /* End of channel_2_analyzer_1_array_crystal_array_2=Union_box() SETTING parameter declarations. */
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex
  /* Label for restoring  neutron */
  mcabsorbCompchannel_2_analyzer_1_array_crystal_array_2:
  if (RESTORE) /* restore if needed */
  { RESTORE_NEUTRON(208,
      mcnlx,
      mcnly,
      mcnlz,
      mcnlvx,
      mcnlvy,
      mcnlvz,
      mcnlt,
      mcnlsx,
      mcnlsy,
      mcnlsz,
      mcnlp); }
#undef mcabsorbComp
#undef p
#undef sz
#undef sy
#undef sx
#undef t
#undef vz
#undef vy
#undef vx
#undef z
#undef y
#undef x
  mcDEBUG_STATE(
mcnlx,
mcnly,
mcnlz,
mcnlvx,
mcnlvy,
mcnlvz,
mcnlt,
mcnlsx,
mcnlsy,
mcnlsz,
mcnlp)

  /* TRACE Component channel_2_analyzer_1_array_crystal_array_3 [209] */
  mccoordschange(mcposrchannel_2_analyzer_1_array_crystal_array_3, mcrotrchannel_2_analyzer_1_array_crystal_array_3,
    &mcnlx,
    &mcnly,
    &mcnlz,
    &mcnlvx,
    &mcnlvy,
    &mcnlvz,
    &mcnlsx,
    &mcnlsy,
    &mcnlsz);
  /* define label inside component channel_2_analyzer_1_array_crystal_array_3 (without coords transformations) */
  mcJumpTrace_channel_2_analyzer_1_array_crystal_array_3:
  SIG_MESSAGE("channel_2_analyzer_1_array_crystal_array_3 (Trace)");
  mcDEBUG_COMP("channel_2_analyzer_1_array_crystal_array_3")
  mcDEBUG_STATE(
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp)
#define x mcnlx
#define y mcnly
#define z mcnlz
#define vx mcnlvx
#define vy mcnlvy
#define vz mcnlvz
#define t mcnlt
#define sx mcnlsx
#define sy mcnlsy
#define sz mcnlsz
#define p mcnlp

#define mcabsorbComp mcabsorbCompchannel_2_analyzer_1_array_crystal_array_3
  STORE_NEUTRON(209,
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp);
  mcScattered=0;
  mcRestore=0;
  mcNCounter[209]++;
  mcPCounter[209] += p;
  mcP2Counter[209] += p*p;
#define mccompcurname  channel_2_analyzer_1_array_crystal_array_3
#define mccompcurtype  Union_box
#define mccompcurindex 209
#define loop_index mccchannel_2_analyzer_1_array_crystal_array_3_loop_index
#define this_box_volume mccchannel_2_analyzer_1_array_crystal_array_3_this_box_volume
#define global_geometry_element mccchannel_2_analyzer_1_array_crystal_array_3_global_geometry_element
#define this_box_storage mccchannel_2_analyzer_1_array_crystal_array_3_this_box_storage
{   /* Declarations of channel_2_analyzer_1_array_crystal_array_3=Union_box() SETTING parameters. */
char* material_string = mccchannel_2_analyzer_1_array_crystal_array_3_material_string;
MCNUM priority = mccchannel_2_analyzer_1_array_crystal_array_3_priority;
MCNUM xwidth = mccchannel_2_analyzer_1_array_crystal_array_3_xwidth;
MCNUM yheight = mccchannel_2_analyzer_1_array_crystal_array_3_yheight;
MCNUM zdepth = mccchannel_2_analyzer_1_array_crystal_array_3_zdepth;
MCNUM xwidth2 = mccchannel_2_analyzer_1_array_crystal_array_3_xwidth2;
MCNUM yheight2 = mccchannel_2_analyzer_1_array_crystal_array_3_yheight2;
MCNUM visualize = mccchannel_2_analyzer_1_array_crystal_array_3_visualize;
int target_index = mccchannel_2_analyzer_1_array_crystal_array_3_target_index;
MCNUM target_x = mccchannel_2_analyzer_1_array_crystal_array_3_target_x;
MCNUM target_y = mccchannel_2_analyzer_1_array_crystal_array_3_target_y;
MCNUM target_z = mccchannel_2_analyzer_1_array_crystal_array_3_target_z;
MCNUM focus_aw = mccchannel_2_analyzer_1_array_crystal_array_3_focus_aw;
MCNUM focus_ah = mccchannel_2_analyzer_1_array_crystal_array_3_focus_ah;
MCNUM focus_xw = mccchannel_2_analyzer_1_array_crystal_array_3_focus_xw;
MCNUM focus_xh = mccchannel_2_analyzer_1_array_crystal_array_3_focus_xh;
MCNUM focus_r = mccchannel_2_analyzer_1_array_crystal_array_3_focus_r;
MCNUM p_interact = mccchannel_2_analyzer_1_array_crystal_array_3_p_interact;
char* mask_string = mccchannel_2_analyzer_1_array_crystal_array_3_mask_string;
char* mask_setting = mccchannel_2_analyzer_1_array_crystal_array_3_mask_setting;
MCNUM number_of_activations = mccchannel_2_analyzer_1_array_crystal_array_3_number_of_activations;
}   /* End of channel_2_analyzer_1_array_crystal_array_3=Union_box() SETTING parameter declarations. */
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex
  /* Label for restoring  neutron */
  mcabsorbCompchannel_2_analyzer_1_array_crystal_array_3:
  if (RESTORE) /* restore if needed */
  { RESTORE_NEUTRON(209,
      mcnlx,
      mcnly,
      mcnlz,
      mcnlvx,
      mcnlvy,
      mcnlvz,
      mcnlt,
      mcnlsx,
      mcnlsy,
      mcnlsz,
      mcnlp); }
#undef mcabsorbComp
#undef p
#undef sz
#undef sy
#undef sx
#undef t
#undef vz
#undef vy
#undef vx
#undef z
#undef y
#undef x
  mcDEBUG_STATE(
mcnlx,
mcnly,
mcnlz,
mcnlvx,
mcnlvy,
mcnlvz,
mcnlt,
mcnlsx,
mcnlsy,
mcnlsz,
mcnlp)

  /* TRACE Component channel_2_analyzer_1_array_crystal_array_4 [210] */
  mccoordschange(mcposrchannel_2_analyzer_1_array_crystal_array_4, mcrotrchannel_2_analyzer_1_array_crystal_array_4,
    &mcnlx,
    &mcnly,
    &mcnlz,
    &mcnlvx,
    &mcnlvy,
    &mcnlvz,
    &mcnlsx,
    &mcnlsy,
    &mcnlsz);
  /* define label inside component channel_2_analyzer_1_array_crystal_array_4 (without coords transformations) */
  mcJumpTrace_channel_2_analyzer_1_array_crystal_array_4:
  SIG_MESSAGE("channel_2_analyzer_1_array_crystal_array_4 (Trace)");
  mcDEBUG_COMP("channel_2_analyzer_1_array_crystal_array_4")
  mcDEBUG_STATE(
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp)
#define x mcnlx
#define y mcnly
#define z mcnlz
#define vx mcnlvx
#define vy mcnlvy
#define vz mcnlvz
#define t mcnlt
#define sx mcnlsx
#define sy mcnlsy
#define sz mcnlsz
#define p mcnlp

#define mcabsorbComp mcabsorbCompchannel_2_analyzer_1_array_crystal_array_4
  STORE_NEUTRON(210,
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp);
  mcScattered=0;
  mcRestore=0;
  mcNCounter[210]++;
  mcPCounter[210] += p;
  mcP2Counter[210] += p*p;
#define mccompcurname  channel_2_analyzer_1_array_crystal_array_4
#define mccompcurtype  Union_box
#define mccompcurindex 210
#define loop_index mccchannel_2_analyzer_1_array_crystal_array_4_loop_index
#define this_box_volume mccchannel_2_analyzer_1_array_crystal_array_4_this_box_volume
#define global_geometry_element mccchannel_2_analyzer_1_array_crystal_array_4_global_geometry_element
#define this_box_storage mccchannel_2_analyzer_1_array_crystal_array_4_this_box_storage
{   /* Declarations of channel_2_analyzer_1_array_crystal_array_4=Union_box() SETTING parameters. */
char* material_string = mccchannel_2_analyzer_1_array_crystal_array_4_material_string;
MCNUM priority = mccchannel_2_analyzer_1_array_crystal_array_4_priority;
MCNUM xwidth = mccchannel_2_analyzer_1_array_crystal_array_4_xwidth;
MCNUM yheight = mccchannel_2_analyzer_1_array_crystal_array_4_yheight;
MCNUM zdepth = mccchannel_2_analyzer_1_array_crystal_array_4_zdepth;
MCNUM xwidth2 = mccchannel_2_analyzer_1_array_crystal_array_4_xwidth2;
MCNUM yheight2 = mccchannel_2_analyzer_1_array_crystal_array_4_yheight2;
MCNUM visualize = mccchannel_2_analyzer_1_array_crystal_array_4_visualize;
int target_index = mccchannel_2_analyzer_1_array_crystal_array_4_target_index;
MCNUM target_x = mccchannel_2_analyzer_1_array_crystal_array_4_target_x;
MCNUM target_y = mccchannel_2_analyzer_1_array_crystal_array_4_target_y;
MCNUM target_z = mccchannel_2_analyzer_1_array_crystal_array_4_target_z;
MCNUM focus_aw = mccchannel_2_analyzer_1_array_crystal_array_4_focus_aw;
MCNUM focus_ah = mccchannel_2_analyzer_1_array_crystal_array_4_focus_ah;
MCNUM focus_xw = mccchannel_2_analyzer_1_array_crystal_array_4_focus_xw;
MCNUM focus_xh = mccchannel_2_analyzer_1_array_crystal_array_4_focus_xh;
MCNUM focus_r = mccchannel_2_analyzer_1_array_crystal_array_4_focus_r;
MCNUM p_interact = mccchannel_2_analyzer_1_array_crystal_array_4_p_interact;
char* mask_string = mccchannel_2_analyzer_1_array_crystal_array_4_mask_string;
char* mask_setting = mccchannel_2_analyzer_1_array_crystal_array_4_mask_setting;
MCNUM number_of_activations = mccchannel_2_analyzer_1_array_crystal_array_4_number_of_activations;
}   /* End of channel_2_analyzer_1_array_crystal_array_4=Union_box() SETTING parameter declarations. */
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex
  /* Label for restoring  neutron */
  mcabsorbCompchannel_2_analyzer_1_array_crystal_array_4:
  if (RESTORE) /* restore if needed */
  { RESTORE_NEUTRON(210,
      mcnlx,
      mcnly,
      mcnlz,
      mcnlvx,
      mcnlvy,
      mcnlvz,
      mcnlt,
      mcnlsx,
      mcnlsy,
      mcnlsz,
      mcnlp); }
#undef mcabsorbComp
#undef p
#undef sz
#undef sy
#undef sx
#undef t
#undef vz
#undef vy
#undef vx
#undef z
#undef y
#undef x
  mcDEBUG_STATE(
mcnlx,
mcnly,
mcnlz,
mcnlvx,
mcnlvy,
mcnlvz,
mcnlt,
mcnlsx,
mcnlsy,
mcnlsz,
mcnlp)

  /* TRACE Component channel_2_analyzer_1_array_crystal_array_5 [211] */
  mccoordschange(mcposrchannel_2_analyzer_1_array_crystal_array_5, mcrotrchannel_2_analyzer_1_array_crystal_array_5,
    &mcnlx,
    &mcnly,
    &mcnlz,
    &mcnlvx,
    &mcnlvy,
    &mcnlvz,
    &mcnlsx,
    &mcnlsy,
    &mcnlsz);
  /* define label inside component channel_2_analyzer_1_array_crystal_array_5 (without coords transformations) */
  mcJumpTrace_channel_2_analyzer_1_array_crystal_array_5:
  SIG_MESSAGE("channel_2_analyzer_1_array_crystal_array_5 (Trace)");
  mcDEBUG_COMP("channel_2_analyzer_1_array_crystal_array_5")
  mcDEBUG_STATE(
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp)
#define x mcnlx
#define y mcnly
#define z mcnlz
#define vx mcnlvx
#define vy mcnlvy
#define vz mcnlvz
#define t mcnlt
#define sx mcnlsx
#define sy mcnlsy
#define sz mcnlsz
#define p mcnlp

#define mcabsorbComp mcabsorbCompchannel_2_analyzer_1_array_crystal_array_5
  STORE_NEUTRON(211,
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp);
  mcScattered=0;
  mcRestore=0;
  mcNCounter[211]++;
  mcPCounter[211] += p;
  mcP2Counter[211] += p*p;
#define mccompcurname  channel_2_analyzer_1_array_crystal_array_5
#define mccompcurtype  Union_box
#define mccompcurindex 211
#define loop_index mccchannel_2_analyzer_1_array_crystal_array_5_loop_index
#define this_box_volume mccchannel_2_analyzer_1_array_crystal_array_5_this_box_volume
#define global_geometry_element mccchannel_2_analyzer_1_array_crystal_array_5_global_geometry_element
#define this_box_storage mccchannel_2_analyzer_1_array_crystal_array_5_this_box_storage
{   /* Declarations of channel_2_analyzer_1_array_crystal_array_5=Union_box() SETTING parameters. */
char* material_string = mccchannel_2_analyzer_1_array_crystal_array_5_material_string;
MCNUM priority = mccchannel_2_analyzer_1_array_crystal_array_5_priority;
MCNUM xwidth = mccchannel_2_analyzer_1_array_crystal_array_5_xwidth;
MCNUM yheight = mccchannel_2_analyzer_1_array_crystal_array_5_yheight;
MCNUM zdepth = mccchannel_2_analyzer_1_array_crystal_array_5_zdepth;
MCNUM xwidth2 = mccchannel_2_analyzer_1_array_crystal_array_5_xwidth2;
MCNUM yheight2 = mccchannel_2_analyzer_1_array_crystal_array_5_yheight2;
MCNUM visualize = mccchannel_2_analyzer_1_array_crystal_array_5_visualize;
int target_index = mccchannel_2_analyzer_1_array_crystal_array_5_target_index;
MCNUM target_x = mccchannel_2_analyzer_1_array_crystal_array_5_target_x;
MCNUM target_y = mccchannel_2_analyzer_1_array_crystal_array_5_target_y;
MCNUM target_z = mccchannel_2_analyzer_1_array_crystal_array_5_target_z;
MCNUM focus_aw = mccchannel_2_analyzer_1_array_crystal_array_5_focus_aw;
MCNUM focus_ah = mccchannel_2_analyzer_1_array_crystal_array_5_focus_ah;
MCNUM focus_xw = mccchannel_2_analyzer_1_array_crystal_array_5_focus_xw;
MCNUM focus_xh = mccchannel_2_analyzer_1_array_crystal_array_5_focus_xh;
MCNUM focus_r = mccchannel_2_analyzer_1_array_crystal_array_5_focus_r;
MCNUM p_interact = mccchannel_2_analyzer_1_array_crystal_array_5_p_interact;
char* mask_string = mccchannel_2_analyzer_1_array_crystal_array_5_mask_string;
char* mask_setting = mccchannel_2_analyzer_1_array_crystal_array_5_mask_setting;
MCNUM number_of_activations = mccchannel_2_analyzer_1_array_crystal_array_5_number_of_activations;
}   /* End of channel_2_analyzer_1_array_crystal_array_5=Union_box() SETTING parameter declarations. */
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex
  /* Label for restoring  neutron */
  mcabsorbCompchannel_2_analyzer_1_array_crystal_array_5:
  if (RESTORE) /* restore if needed */
  { RESTORE_NEUTRON(211,
      mcnlx,
      mcnly,
      mcnlz,
      mcnlvx,
      mcnlvy,
      mcnlvz,
      mcnlt,
      mcnlsx,
      mcnlsy,
      mcnlsz,
      mcnlp); }
#undef mcabsorbComp
#undef p
#undef sz
#undef sy
#undef sx
#undef t
#undef vz
#undef vy
#undef vx
#undef z
#undef y
#undef x
  mcDEBUG_STATE(
mcnlx,
mcnly,
mcnlz,
mcnlvx,
mcnlvy,
mcnlvz,
mcnlt,
mcnlsx,
mcnlsy,
mcnlsz,
mcnlp)

  /* TRACE Component channel_2_analyzer_1_array_crystal_array_6 [212] */
  mccoordschange(mcposrchannel_2_analyzer_1_array_crystal_array_6, mcrotrchannel_2_analyzer_1_array_crystal_array_6,
    &mcnlx,
    &mcnly,
    &mcnlz,
    &mcnlvx,
    &mcnlvy,
    &mcnlvz,
    &mcnlsx,
    &mcnlsy,
    &mcnlsz);
  /* define label inside component channel_2_analyzer_1_array_crystal_array_6 (without coords transformations) */
  mcJumpTrace_channel_2_analyzer_1_array_crystal_array_6:
  SIG_MESSAGE("channel_2_analyzer_1_array_crystal_array_6 (Trace)");
  mcDEBUG_COMP("channel_2_analyzer_1_array_crystal_array_6")
  mcDEBUG_STATE(
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp)
#define x mcnlx
#define y mcnly
#define z mcnlz
#define vx mcnlvx
#define vy mcnlvy
#define vz mcnlvz
#define t mcnlt
#define sx mcnlsx
#define sy mcnlsy
#define sz mcnlsz
#define p mcnlp

#define mcabsorbComp mcabsorbCompchannel_2_analyzer_1_array_crystal_array_6
  STORE_NEUTRON(212,
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp);
  mcScattered=0;
  mcRestore=0;
  mcNCounter[212]++;
  mcPCounter[212] += p;
  mcP2Counter[212] += p*p;
#define mccompcurname  channel_2_analyzer_1_array_crystal_array_6
#define mccompcurtype  Union_box
#define mccompcurindex 212
#define loop_index mccchannel_2_analyzer_1_array_crystal_array_6_loop_index
#define this_box_volume mccchannel_2_analyzer_1_array_crystal_array_6_this_box_volume
#define global_geometry_element mccchannel_2_analyzer_1_array_crystal_array_6_global_geometry_element
#define this_box_storage mccchannel_2_analyzer_1_array_crystal_array_6_this_box_storage
{   /* Declarations of channel_2_analyzer_1_array_crystal_array_6=Union_box() SETTING parameters. */
char* material_string = mccchannel_2_analyzer_1_array_crystal_array_6_material_string;
MCNUM priority = mccchannel_2_analyzer_1_array_crystal_array_6_priority;
MCNUM xwidth = mccchannel_2_analyzer_1_array_crystal_array_6_xwidth;
MCNUM yheight = mccchannel_2_analyzer_1_array_crystal_array_6_yheight;
MCNUM zdepth = mccchannel_2_analyzer_1_array_crystal_array_6_zdepth;
MCNUM xwidth2 = mccchannel_2_analyzer_1_array_crystal_array_6_xwidth2;
MCNUM yheight2 = mccchannel_2_analyzer_1_array_crystal_array_6_yheight2;
MCNUM visualize = mccchannel_2_analyzer_1_array_crystal_array_6_visualize;
int target_index = mccchannel_2_analyzer_1_array_crystal_array_6_target_index;
MCNUM target_x = mccchannel_2_analyzer_1_array_crystal_array_6_target_x;
MCNUM target_y = mccchannel_2_analyzer_1_array_crystal_array_6_target_y;
MCNUM target_z = mccchannel_2_analyzer_1_array_crystal_array_6_target_z;
MCNUM focus_aw = mccchannel_2_analyzer_1_array_crystal_array_6_focus_aw;
MCNUM focus_ah = mccchannel_2_analyzer_1_array_crystal_array_6_focus_ah;
MCNUM focus_xw = mccchannel_2_analyzer_1_array_crystal_array_6_focus_xw;
MCNUM focus_xh = mccchannel_2_analyzer_1_array_crystal_array_6_focus_xh;
MCNUM focus_r = mccchannel_2_analyzer_1_array_crystal_array_6_focus_r;
MCNUM p_interact = mccchannel_2_analyzer_1_array_crystal_array_6_p_interact;
char* mask_string = mccchannel_2_analyzer_1_array_crystal_array_6_mask_string;
char* mask_setting = mccchannel_2_analyzer_1_array_crystal_array_6_mask_setting;
MCNUM number_of_activations = mccchannel_2_analyzer_1_array_crystal_array_6_number_of_activations;
}   /* End of channel_2_analyzer_1_array_crystal_array_6=Union_box() SETTING parameter declarations. */
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex
  /* Label for restoring  neutron */
  mcabsorbCompchannel_2_analyzer_1_array_crystal_array_6:
  if (RESTORE) /* restore if needed */
  { RESTORE_NEUTRON(212,
      mcnlx,
      mcnly,
      mcnlz,
      mcnlvx,
      mcnlvy,
      mcnlvz,
      mcnlt,
      mcnlsx,
      mcnlsy,
      mcnlsz,
      mcnlp); }
#undef mcabsorbComp
#undef p
#undef sz
#undef sy
#undef sx
#undef t
#undef vz
#undef vy
#undef vx
#undef z
#undef y
#undef x
  mcDEBUG_STATE(
mcnlx,
mcnly,
mcnlz,
mcnlvx,
mcnlvy,
mcnlvz,
mcnlt,
mcnlsx,
mcnlsy,
mcnlsz,
mcnlp)

  /* TRACE Component channel_2_analyzer_1_array_crystal_array_7 [213] */
  mccoordschange(mcposrchannel_2_analyzer_1_array_crystal_array_7, mcrotrchannel_2_analyzer_1_array_crystal_array_7,
    &mcnlx,
    &mcnly,
    &mcnlz,
    &mcnlvx,
    &mcnlvy,
    &mcnlvz,
    &mcnlsx,
    &mcnlsy,
    &mcnlsz);
  /* define label inside component channel_2_analyzer_1_array_crystal_array_7 (without coords transformations) */
  mcJumpTrace_channel_2_analyzer_1_array_crystal_array_7:
  SIG_MESSAGE("channel_2_analyzer_1_array_crystal_array_7 (Trace)");
  mcDEBUG_COMP("channel_2_analyzer_1_array_crystal_array_7")
  mcDEBUG_STATE(
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp)
#define x mcnlx
#define y mcnly
#define z mcnlz
#define vx mcnlvx
#define vy mcnlvy
#define vz mcnlvz
#define t mcnlt
#define sx mcnlsx
#define sy mcnlsy
#define sz mcnlsz
#define p mcnlp

#define mcabsorbComp mcabsorbCompchannel_2_analyzer_1_array_crystal_array_7
  STORE_NEUTRON(213,
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp);
  mcScattered=0;
  mcRestore=0;
  mcNCounter[213]++;
  mcPCounter[213] += p;
  mcP2Counter[213] += p*p;
#define mccompcurname  channel_2_analyzer_1_array_crystal_array_7
#define mccompcurtype  Union_box
#define mccompcurindex 213
#define loop_index mccchannel_2_analyzer_1_array_crystal_array_7_loop_index
#define this_box_volume mccchannel_2_analyzer_1_array_crystal_array_7_this_box_volume
#define global_geometry_element mccchannel_2_analyzer_1_array_crystal_array_7_global_geometry_element
#define this_box_storage mccchannel_2_analyzer_1_array_crystal_array_7_this_box_storage
{   /* Declarations of channel_2_analyzer_1_array_crystal_array_7=Union_box() SETTING parameters. */
char* material_string = mccchannel_2_analyzer_1_array_crystal_array_7_material_string;
MCNUM priority = mccchannel_2_analyzer_1_array_crystal_array_7_priority;
MCNUM xwidth = mccchannel_2_analyzer_1_array_crystal_array_7_xwidth;
MCNUM yheight = mccchannel_2_analyzer_1_array_crystal_array_7_yheight;
MCNUM zdepth = mccchannel_2_analyzer_1_array_crystal_array_7_zdepth;
MCNUM xwidth2 = mccchannel_2_analyzer_1_array_crystal_array_7_xwidth2;
MCNUM yheight2 = mccchannel_2_analyzer_1_array_crystal_array_7_yheight2;
MCNUM visualize = mccchannel_2_analyzer_1_array_crystal_array_7_visualize;
int target_index = mccchannel_2_analyzer_1_array_crystal_array_7_target_index;
MCNUM target_x = mccchannel_2_analyzer_1_array_crystal_array_7_target_x;
MCNUM target_y = mccchannel_2_analyzer_1_array_crystal_array_7_target_y;
MCNUM target_z = mccchannel_2_analyzer_1_array_crystal_array_7_target_z;
MCNUM focus_aw = mccchannel_2_analyzer_1_array_crystal_array_7_focus_aw;
MCNUM focus_ah = mccchannel_2_analyzer_1_array_crystal_array_7_focus_ah;
MCNUM focus_xw = mccchannel_2_analyzer_1_array_crystal_array_7_focus_xw;
MCNUM focus_xh = mccchannel_2_analyzer_1_array_crystal_array_7_focus_xh;
MCNUM focus_r = mccchannel_2_analyzer_1_array_crystal_array_7_focus_r;
MCNUM p_interact = mccchannel_2_analyzer_1_array_crystal_array_7_p_interact;
char* mask_string = mccchannel_2_analyzer_1_array_crystal_array_7_mask_string;
char* mask_setting = mccchannel_2_analyzer_1_array_crystal_array_7_mask_setting;
MCNUM number_of_activations = mccchannel_2_analyzer_1_array_crystal_array_7_number_of_activations;
}   /* End of channel_2_analyzer_1_array_crystal_array_7=Union_box() SETTING parameter declarations. */
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex
  /* Label for restoring  neutron */
  mcabsorbCompchannel_2_analyzer_1_array_crystal_array_7:
  if (RESTORE) /* restore if needed */
  { RESTORE_NEUTRON(213,
      mcnlx,
      mcnly,
      mcnlz,
      mcnlvx,
      mcnlvy,
      mcnlvz,
      mcnlt,
      mcnlsx,
      mcnlsy,
      mcnlsz,
      mcnlp); }
#undef mcabsorbComp
#undef p
#undef sz
#undef sy
#undef sx
#undef t
#undef vz
#undef vy
#undef vx
#undef z
#undef y
#undef x
  mcDEBUG_STATE(
mcnlx,
mcnly,
mcnlz,
mcnlvx,
mcnlvy,
mcnlvz,
mcnlt,
mcnlsx,
mcnlsy,
mcnlsz,
mcnlp)

  /* TRACE Component channel_2_analyzer_1_array_crystal_array_8 [214] */
  mccoordschange(mcposrchannel_2_analyzer_1_array_crystal_array_8, mcrotrchannel_2_analyzer_1_array_crystal_array_8,
    &mcnlx,
    &mcnly,
    &mcnlz,
    &mcnlvx,
    &mcnlvy,
    &mcnlvz,
    &mcnlsx,
    &mcnlsy,
    &mcnlsz);
  /* define label inside component channel_2_analyzer_1_array_crystal_array_8 (without coords transformations) */
  mcJumpTrace_channel_2_analyzer_1_array_crystal_array_8:
  SIG_MESSAGE("channel_2_analyzer_1_array_crystal_array_8 (Trace)");
  mcDEBUG_COMP("channel_2_analyzer_1_array_crystal_array_8")
  mcDEBUG_STATE(
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp)
#define x mcnlx
#define y mcnly
#define z mcnlz
#define vx mcnlvx
#define vy mcnlvy
#define vz mcnlvz
#define t mcnlt
#define sx mcnlsx
#define sy mcnlsy
#define sz mcnlsz
#define p mcnlp

#define mcabsorbComp mcabsorbCompchannel_2_analyzer_1_array_crystal_array_8
  STORE_NEUTRON(214,
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp);
  mcScattered=0;
  mcRestore=0;
  mcNCounter[214]++;
  mcPCounter[214] += p;
  mcP2Counter[214] += p*p;
#define mccompcurname  channel_2_analyzer_1_array_crystal_array_8
#define mccompcurtype  Union_box
#define mccompcurindex 214
#define loop_index mccchannel_2_analyzer_1_array_crystal_array_8_loop_index
#define this_box_volume mccchannel_2_analyzer_1_array_crystal_array_8_this_box_volume
#define global_geometry_element mccchannel_2_analyzer_1_array_crystal_array_8_global_geometry_element
#define this_box_storage mccchannel_2_analyzer_1_array_crystal_array_8_this_box_storage
{   /* Declarations of channel_2_analyzer_1_array_crystal_array_8=Union_box() SETTING parameters. */
char* material_string = mccchannel_2_analyzer_1_array_crystal_array_8_material_string;
MCNUM priority = mccchannel_2_analyzer_1_array_crystal_array_8_priority;
MCNUM xwidth = mccchannel_2_analyzer_1_array_crystal_array_8_xwidth;
MCNUM yheight = mccchannel_2_analyzer_1_array_crystal_array_8_yheight;
MCNUM zdepth = mccchannel_2_analyzer_1_array_crystal_array_8_zdepth;
MCNUM xwidth2 = mccchannel_2_analyzer_1_array_crystal_array_8_xwidth2;
MCNUM yheight2 = mccchannel_2_analyzer_1_array_crystal_array_8_yheight2;
MCNUM visualize = mccchannel_2_analyzer_1_array_crystal_array_8_visualize;
int target_index = mccchannel_2_analyzer_1_array_crystal_array_8_target_index;
MCNUM target_x = mccchannel_2_analyzer_1_array_crystal_array_8_target_x;
MCNUM target_y = mccchannel_2_analyzer_1_array_crystal_array_8_target_y;
MCNUM target_z = mccchannel_2_analyzer_1_array_crystal_array_8_target_z;
MCNUM focus_aw = mccchannel_2_analyzer_1_array_crystal_array_8_focus_aw;
MCNUM focus_ah = mccchannel_2_analyzer_1_array_crystal_array_8_focus_ah;
MCNUM focus_xw = mccchannel_2_analyzer_1_array_crystal_array_8_focus_xw;
MCNUM focus_xh = mccchannel_2_analyzer_1_array_crystal_array_8_focus_xh;
MCNUM focus_r = mccchannel_2_analyzer_1_array_crystal_array_8_focus_r;
MCNUM p_interact = mccchannel_2_analyzer_1_array_crystal_array_8_p_interact;
char* mask_string = mccchannel_2_analyzer_1_array_crystal_array_8_mask_string;
char* mask_setting = mccchannel_2_analyzer_1_array_crystal_array_8_mask_setting;
MCNUM number_of_activations = mccchannel_2_analyzer_1_array_crystal_array_8_number_of_activations;
}   /* End of channel_2_analyzer_1_array_crystal_array_8=Union_box() SETTING parameter declarations. */
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex
  /* Label for restoring  neutron */
  mcabsorbCompchannel_2_analyzer_1_array_crystal_array_8:
  if (RESTORE) /* restore if needed */
  { RESTORE_NEUTRON(214,
      mcnlx,
      mcnly,
      mcnlz,
      mcnlvx,
      mcnlvy,
      mcnlvz,
      mcnlt,
      mcnlsx,
      mcnlsy,
      mcnlsz,
      mcnlp); }
#undef mcabsorbComp
#undef p
#undef sz
#undef sy
#undef sx
#undef t
#undef vz
#undef vy
#undef vx
#undef z
#undef y
#undef x
  mcDEBUG_STATE(
mcnlx,
mcnly,
mcnlz,
mcnlvx,
mcnlvy,
mcnlvz,
mcnlt,
mcnlsx,
mcnlsy,
mcnlsz,
mcnlp)

  /* TRACE Component channel_2_analyzer_2_center [215] */
  mccoordschange(mcposrchannel_2_analyzer_2_center, mcrotrchannel_2_analyzer_2_center,
    &mcnlx,
    &mcnly,
    &mcnlz,
    &mcnlvx,
    &mcnlvy,
    &mcnlvz,
    &mcnlsx,
    &mcnlsy,
    &mcnlsz);
  /* define label inside component channel_2_analyzer_2_center (without coords transformations) */
  mcJumpTrace_channel_2_analyzer_2_center:
  SIG_MESSAGE("channel_2_analyzer_2_center (Trace)");
  mcDEBUG_COMP("channel_2_analyzer_2_center")
  mcDEBUG_STATE(
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp)
#define x mcnlx
#define y mcnly
#define z mcnlz
#define vx mcnlvx
#define vy mcnlvy
#define vz mcnlvz
#define t mcnlt
#define sx mcnlsx
#define sy mcnlsy
#define sz mcnlsz
#define p mcnlp

#define mcabsorbComp mcabsorbCompchannel_2_analyzer_2_center
  STORE_NEUTRON(215,
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp);
  mcScattered=0;
  mcRestore=0;
  mcNCounter[215]++;
  mcPCounter[215] += p;
  mcP2Counter[215] += p*p;
#define mccompcurname  channel_2_analyzer_2_center
#define mccompcurtype  Arm
#define mccompcurindex 215
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex
  /* Label for restoring  neutron */
  mcabsorbCompchannel_2_analyzer_2_center:
  if (RESTORE) /* restore if needed */
  { RESTORE_NEUTRON(215,
      mcnlx,
      mcnly,
      mcnlz,
      mcnlvx,
      mcnlvy,
      mcnlvz,
      mcnlt,
      mcnlsx,
      mcnlsy,
      mcnlsz,
      mcnlp); }
#undef mcabsorbComp
#undef p
#undef sz
#undef sy
#undef sx
#undef t
#undef vz
#undef vy
#undef vx
#undef z
#undef y
#undef x
  mcDEBUG_STATE(
mcnlx,
mcnly,
mcnlz,
mcnlvx,
mcnlvy,
mcnlvz,
mcnlt,
mcnlsx,
mcnlsy,
mcnlsz,
mcnlp)

  /* TRACE Component channel_2_analyzer_2_rotated [216] */
  mccoordschange(mcposrchannel_2_analyzer_2_rotated, mcrotrchannel_2_analyzer_2_rotated,
    &mcnlx,
    &mcnly,
    &mcnlz,
    &mcnlvx,
    &mcnlvy,
    &mcnlvz,
    &mcnlsx,
    &mcnlsy,
    &mcnlsz);
  /* define label inside component channel_2_analyzer_2_rotated (without coords transformations) */
  mcJumpTrace_channel_2_analyzer_2_rotated:
  SIG_MESSAGE("channel_2_analyzer_2_rotated (Trace)");
  mcDEBUG_COMP("channel_2_analyzer_2_rotated")
  mcDEBUG_STATE(
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp)
#define x mcnlx
#define y mcnly
#define z mcnlz
#define vx mcnlvx
#define vy mcnlvy
#define vz mcnlvz
#define t mcnlt
#define sx mcnlsx
#define sy mcnlsy
#define sz mcnlsz
#define p mcnlp

#define mcabsorbComp mcabsorbCompchannel_2_analyzer_2_rotated
  STORE_NEUTRON(216,
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp);
  mcScattered=0;
  mcRestore=0;
  mcNCounter[216]++;
  mcPCounter[216] += p;
  mcP2Counter[216] += p*p;
#define mccompcurname  channel_2_analyzer_2_rotated
#define mccompcurtype  Arm
#define mccompcurindex 216
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex
  /* Label for restoring  neutron */
  mcabsorbCompchannel_2_analyzer_2_rotated:
  if (RESTORE) /* restore if needed */
  { RESTORE_NEUTRON(216,
      mcnlx,
      mcnly,
      mcnlz,
      mcnlvx,
      mcnlvy,
      mcnlvz,
      mcnlt,
      mcnlsx,
      mcnlsy,
      mcnlsz,
      mcnlp); }
#undef mcabsorbComp
#undef p
#undef sz
#undef sy
#undef sx
#undef t
#undef vz
#undef vy
#undef vx
#undef z
#undef y
#undef x
  mcDEBUG_STATE(
mcnlx,
mcnly,
mcnlz,
mcnlvx,
mcnlvy,
mcnlvz,
mcnlt,
mcnlsx,
mcnlsy,
mcnlsz,
mcnlp)

  /* TRACE Component channel_2_analyzer_2_array_crystal_array_0 [217] */
  mccoordschange(mcposrchannel_2_analyzer_2_array_crystal_array_0, mcrotrchannel_2_analyzer_2_array_crystal_array_0,
    &mcnlx,
    &mcnly,
    &mcnlz,
    &mcnlvx,
    &mcnlvy,
    &mcnlvz,
    &mcnlsx,
    &mcnlsy,
    &mcnlsz);
  /* define label inside component channel_2_analyzer_2_array_crystal_array_0 (without coords transformations) */
  mcJumpTrace_channel_2_analyzer_2_array_crystal_array_0:
  SIG_MESSAGE("channel_2_analyzer_2_array_crystal_array_0 (Trace)");
  mcDEBUG_COMP("channel_2_analyzer_2_array_crystal_array_0")
  mcDEBUG_STATE(
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp)
#define x mcnlx
#define y mcnly
#define z mcnlz
#define vx mcnlvx
#define vy mcnlvy
#define vz mcnlvz
#define t mcnlt
#define sx mcnlsx
#define sy mcnlsy
#define sz mcnlsz
#define p mcnlp

#define mcabsorbComp mcabsorbCompchannel_2_analyzer_2_array_crystal_array_0
  STORE_NEUTRON(217,
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp);
  mcScattered=0;
  mcRestore=0;
  mcNCounter[217]++;
  mcPCounter[217] += p;
  mcP2Counter[217] += p*p;
#define mccompcurname  channel_2_analyzer_2_array_crystal_array_0
#define mccompcurtype  Union_box
#define mccompcurindex 217
#define loop_index mccchannel_2_analyzer_2_array_crystal_array_0_loop_index
#define this_box_volume mccchannel_2_analyzer_2_array_crystal_array_0_this_box_volume
#define global_geometry_element mccchannel_2_analyzer_2_array_crystal_array_0_global_geometry_element
#define this_box_storage mccchannel_2_analyzer_2_array_crystal_array_0_this_box_storage
{   /* Declarations of channel_2_analyzer_2_array_crystal_array_0=Union_box() SETTING parameters. */
char* material_string = mccchannel_2_analyzer_2_array_crystal_array_0_material_string;
MCNUM priority = mccchannel_2_analyzer_2_array_crystal_array_0_priority;
MCNUM xwidth = mccchannel_2_analyzer_2_array_crystal_array_0_xwidth;
MCNUM yheight = mccchannel_2_analyzer_2_array_crystal_array_0_yheight;
MCNUM zdepth = mccchannel_2_analyzer_2_array_crystal_array_0_zdepth;
MCNUM xwidth2 = mccchannel_2_analyzer_2_array_crystal_array_0_xwidth2;
MCNUM yheight2 = mccchannel_2_analyzer_2_array_crystal_array_0_yheight2;
MCNUM visualize = mccchannel_2_analyzer_2_array_crystal_array_0_visualize;
int target_index = mccchannel_2_analyzer_2_array_crystal_array_0_target_index;
MCNUM target_x = mccchannel_2_analyzer_2_array_crystal_array_0_target_x;
MCNUM target_y = mccchannel_2_analyzer_2_array_crystal_array_0_target_y;
MCNUM target_z = mccchannel_2_analyzer_2_array_crystal_array_0_target_z;
MCNUM focus_aw = mccchannel_2_analyzer_2_array_crystal_array_0_focus_aw;
MCNUM focus_ah = mccchannel_2_analyzer_2_array_crystal_array_0_focus_ah;
MCNUM focus_xw = mccchannel_2_analyzer_2_array_crystal_array_0_focus_xw;
MCNUM focus_xh = mccchannel_2_analyzer_2_array_crystal_array_0_focus_xh;
MCNUM focus_r = mccchannel_2_analyzer_2_array_crystal_array_0_focus_r;
MCNUM p_interact = mccchannel_2_analyzer_2_array_crystal_array_0_p_interact;
char* mask_string = mccchannel_2_analyzer_2_array_crystal_array_0_mask_string;
char* mask_setting = mccchannel_2_analyzer_2_array_crystal_array_0_mask_setting;
MCNUM number_of_activations = mccchannel_2_analyzer_2_array_crystal_array_0_number_of_activations;
}   /* End of channel_2_analyzer_2_array_crystal_array_0=Union_box() SETTING parameter declarations. */
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex
  /* Label for restoring  neutron */
  mcabsorbCompchannel_2_analyzer_2_array_crystal_array_0:
  if (RESTORE) /* restore if needed */
  { RESTORE_NEUTRON(217,
      mcnlx,
      mcnly,
      mcnlz,
      mcnlvx,
      mcnlvy,
      mcnlvz,
      mcnlt,
      mcnlsx,
      mcnlsy,
      mcnlsz,
      mcnlp); }
#undef mcabsorbComp
#undef p
#undef sz
#undef sy
#undef sx
#undef t
#undef vz
#undef vy
#undef vx
#undef z
#undef y
#undef x
  mcDEBUG_STATE(
mcnlx,
mcnly,
mcnlz,
mcnlvx,
mcnlvy,
mcnlvz,
mcnlt,
mcnlsx,
mcnlsy,
mcnlsz,
mcnlp)

  /* TRACE Component channel_2_analyzer_2_array_crystal_array_1 [218] */
  mccoordschange(mcposrchannel_2_analyzer_2_array_crystal_array_1, mcrotrchannel_2_analyzer_2_array_crystal_array_1,
    &mcnlx,
    &mcnly,
    &mcnlz,
    &mcnlvx,
    &mcnlvy,
    &mcnlvz,
    &mcnlsx,
    &mcnlsy,
    &mcnlsz);
  /* define label inside component channel_2_analyzer_2_array_crystal_array_1 (without coords transformations) */
  mcJumpTrace_channel_2_analyzer_2_array_crystal_array_1:
  SIG_MESSAGE("channel_2_analyzer_2_array_crystal_array_1 (Trace)");
  mcDEBUG_COMP("channel_2_analyzer_2_array_crystal_array_1")
  mcDEBUG_STATE(
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp)
#define x mcnlx
#define y mcnly
#define z mcnlz
#define vx mcnlvx
#define vy mcnlvy
#define vz mcnlvz
#define t mcnlt
#define sx mcnlsx
#define sy mcnlsy
#define sz mcnlsz
#define p mcnlp

#define mcabsorbComp mcabsorbCompchannel_2_analyzer_2_array_crystal_array_1
  STORE_NEUTRON(218,
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp);
  mcScattered=0;
  mcRestore=0;
  mcNCounter[218]++;
  mcPCounter[218] += p;
  mcP2Counter[218] += p*p;
#define mccompcurname  channel_2_analyzer_2_array_crystal_array_1
#define mccompcurtype  Union_box
#define mccompcurindex 218
#define loop_index mccchannel_2_analyzer_2_array_crystal_array_1_loop_index
#define this_box_volume mccchannel_2_analyzer_2_array_crystal_array_1_this_box_volume
#define global_geometry_element mccchannel_2_analyzer_2_array_crystal_array_1_global_geometry_element
#define this_box_storage mccchannel_2_analyzer_2_array_crystal_array_1_this_box_storage
{   /* Declarations of channel_2_analyzer_2_array_crystal_array_1=Union_box() SETTING parameters. */
char* material_string = mccchannel_2_analyzer_2_array_crystal_array_1_material_string;
MCNUM priority = mccchannel_2_analyzer_2_array_crystal_array_1_priority;
MCNUM xwidth = mccchannel_2_analyzer_2_array_crystal_array_1_xwidth;
MCNUM yheight = mccchannel_2_analyzer_2_array_crystal_array_1_yheight;
MCNUM zdepth = mccchannel_2_analyzer_2_array_crystal_array_1_zdepth;
MCNUM xwidth2 = mccchannel_2_analyzer_2_array_crystal_array_1_xwidth2;
MCNUM yheight2 = mccchannel_2_analyzer_2_array_crystal_array_1_yheight2;
MCNUM visualize = mccchannel_2_analyzer_2_array_crystal_array_1_visualize;
int target_index = mccchannel_2_analyzer_2_array_crystal_array_1_target_index;
MCNUM target_x = mccchannel_2_analyzer_2_array_crystal_array_1_target_x;
MCNUM target_y = mccchannel_2_analyzer_2_array_crystal_array_1_target_y;
MCNUM target_z = mccchannel_2_analyzer_2_array_crystal_array_1_target_z;
MCNUM focus_aw = mccchannel_2_analyzer_2_array_crystal_array_1_focus_aw;
MCNUM focus_ah = mccchannel_2_analyzer_2_array_crystal_array_1_focus_ah;
MCNUM focus_xw = mccchannel_2_analyzer_2_array_crystal_array_1_focus_xw;
MCNUM focus_xh = mccchannel_2_analyzer_2_array_crystal_array_1_focus_xh;
MCNUM focus_r = mccchannel_2_analyzer_2_array_crystal_array_1_focus_r;
MCNUM p_interact = mccchannel_2_analyzer_2_array_crystal_array_1_p_interact;
char* mask_string = mccchannel_2_analyzer_2_array_crystal_array_1_mask_string;
char* mask_setting = mccchannel_2_analyzer_2_array_crystal_array_1_mask_setting;
MCNUM number_of_activations = mccchannel_2_analyzer_2_array_crystal_array_1_number_of_activations;
}   /* End of channel_2_analyzer_2_array_crystal_array_1=Union_box() SETTING parameter declarations. */
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex
  /* Label for restoring  neutron */
  mcabsorbCompchannel_2_analyzer_2_array_crystal_array_1:
  if (RESTORE) /* restore if needed */
  { RESTORE_NEUTRON(218,
      mcnlx,
      mcnly,
      mcnlz,
      mcnlvx,
      mcnlvy,
      mcnlvz,
      mcnlt,
      mcnlsx,
      mcnlsy,
      mcnlsz,
      mcnlp); }
#undef mcabsorbComp
#undef p
#undef sz
#undef sy
#undef sx
#undef t
#undef vz
#undef vy
#undef vx
#undef z
#undef y
#undef x
  mcDEBUG_STATE(
mcnlx,
mcnly,
mcnlz,
mcnlvx,
mcnlvy,
mcnlvz,
mcnlt,
mcnlsx,
mcnlsy,
mcnlsz,
mcnlp)

  /* TRACE Component channel_2_analyzer_2_array_crystal_array_2 [219] */
  mccoordschange(mcposrchannel_2_analyzer_2_array_crystal_array_2, mcrotrchannel_2_analyzer_2_array_crystal_array_2,
    &mcnlx,
    &mcnly,
    &mcnlz,
    &mcnlvx,
    &mcnlvy,
    &mcnlvz,
    &mcnlsx,
    &mcnlsy,
    &mcnlsz);
  /* define label inside component channel_2_analyzer_2_array_crystal_array_2 (without coords transformations) */
  mcJumpTrace_channel_2_analyzer_2_array_crystal_array_2:
  SIG_MESSAGE("channel_2_analyzer_2_array_crystal_array_2 (Trace)");
  mcDEBUG_COMP("channel_2_analyzer_2_array_crystal_array_2")
  mcDEBUG_STATE(
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp)
#define x mcnlx
#define y mcnly
#define z mcnlz
#define vx mcnlvx
#define vy mcnlvy
#define vz mcnlvz
#define t mcnlt
#define sx mcnlsx
#define sy mcnlsy
#define sz mcnlsz
#define p mcnlp

#define mcabsorbComp mcabsorbCompchannel_2_analyzer_2_array_crystal_array_2
  STORE_NEUTRON(219,
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp);
  mcScattered=0;
  mcRestore=0;
  mcNCounter[219]++;
  mcPCounter[219] += p;
  mcP2Counter[219] += p*p;
#define mccompcurname  channel_2_analyzer_2_array_crystal_array_2
#define mccompcurtype  Union_box
#define mccompcurindex 219
#define loop_index mccchannel_2_analyzer_2_array_crystal_array_2_loop_index
#define this_box_volume mccchannel_2_analyzer_2_array_crystal_array_2_this_box_volume
#define global_geometry_element mccchannel_2_analyzer_2_array_crystal_array_2_global_geometry_element
#define this_box_storage mccchannel_2_analyzer_2_array_crystal_array_2_this_box_storage
{   /* Declarations of channel_2_analyzer_2_array_crystal_array_2=Union_box() SETTING parameters. */
char* material_string = mccchannel_2_analyzer_2_array_crystal_array_2_material_string;
MCNUM priority = mccchannel_2_analyzer_2_array_crystal_array_2_priority;
MCNUM xwidth = mccchannel_2_analyzer_2_array_crystal_array_2_xwidth;
MCNUM yheight = mccchannel_2_analyzer_2_array_crystal_array_2_yheight;
MCNUM zdepth = mccchannel_2_analyzer_2_array_crystal_array_2_zdepth;
MCNUM xwidth2 = mccchannel_2_analyzer_2_array_crystal_array_2_xwidth2;
MCNUM yheight2 = mccchannel_2_analyzer_2_array_crystal_array_2_yheight2;
MCNUM visualize = mccchannel_2_analyzer_2_array_crystal_array_2_visualize;
int target_index = mccchannel_2_analyzer_2_array_crystal_array_2_target_index;
MCNUM target_x = mccchannel_2_analyzer_2_array_crystal_array_2_target_x;
MCNUM target_y = mccchannel_2_analyzer_2_array_crystal_array_2_target_y;
MCNUM target_z = mccchannel_2_analyzer_2_array_crystal_array_2_target_z;
MCNUM focus_aw = mccchannel_2_analyzer_2_array_crystal_array_2_focus_aw;
MCNUM focus_ah = mccchannel_2_analyzer_2_array_crystal_array_2_focus_ah;
MCNUM focus_xw = mccchannel_2_analyzer_2_array_crystal_array_2_focus_xw;
MCNUM focus_xh = mccchannel_2_analyzer_2_array_crystal_array_2_focus_xh;
MCNUM focus_r = mccchannel_2_analyzer_2_array_crystal_array_2_focus_r;
MCNUM p_interact = mccchannel_2_analyzer_2_array_crystal_array_2_p_interact;
char* mask_string = mccchannel_2_analyzer_2_array_crystal_array_2_mask_string;
char* mask_setting = mccchannel_2_analyzer_2_array_crystal_array_2_mask_setting;
MCNUM number_of_activations = mccchannel_2_analyzer_2_array_crystal_array_2_number_of_activations;
}   /* End of channel_2_analyzer_2_array_crystal_array_2=Union_box() SETTING parameter declarations. */
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex
  /* Label for restoring  neutron */
  mcabsorbCompchannel_2_analyzer_2_array_crystal_array_2:
  if (RESTORE) /* restore if needed */
  { RESTORE_NEUTRON(219,
      mcnlx,
      mcnly,
      mcnlz,
      mcnlvx,
      mcnlvy,
      mcnlvz,
      mcnlt,
      mcnlsx,
      mcnlsy,
      mcnlsz,
      mcnlp); }
#undef mcabsorbComp
#undef p
#undef sz
#undef sy
#undef sx
#undef t
#undef vz
#undef vy
#undef vx
#undef z
#undef y
#undef x
  mcDEBUG_STATE(
mcnlx,
mcnly,
mcnlz,
mcnlvx,
mcnlvy,
mcnlvz,
mcnlt,
mcnlsx,
mcnlsy,
mcnlsz,
mcnlp)

  /* TRACE Component channel_2_analyzer_2_array_crystal_array_3 [220] */
  mccoordschange(mcposrchannel_2_analyzer_2_array_crystal_array_3, mcrotrchannel_2_analyzer_2_array_crystal_array_3,
    &mcnlx,
    &mcnly,
    &mcnlz,
    &mcnlvx,
    &mcnlvy,
    &mcnlvz,
    &mcnlsx,
    &mcnlsy,
    &mcnlsz);
  /* define label inside component channel_2_analyzer_2_array_crystal_array_3 (without coords transformations) */
  mcJumpTrace_channel_2_analyzer_2_array_crystal_array_3:
  SIG_MESSAGE("channel_2_analyzer_2_array_crystal_array_3 (Trace)");
  mcDEBUG_COMP("channel_2_analyzer_2_array_crystal_array_3")
  mcDEBUG_STATE(
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp)
#define x mcnlx
#define y mcnly
#define z mcnlz
#define vx mcnlvx
#define vy mcnlvy
#define vz mcnlvz
#define t mcnlt
#define sx mcnlsx
#define sy mcnlsy
#define sz mcnlsz
#define p mcnlp

#define mcabsorbComp mcabsorbCompchannel_2_analyzer_2_array_crystal_array_3
  STORE_NEUTRON(220,
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp);
  mcScattered=0;
  mcRestore=0;
  mcNCounter[220]++;
  mcPCounter[220] += p;
  mcP2Counter[220] += p*p;
#define mccompcurname  channel_2_analyzer_2_array_crystal_array_3
#define mccompcurtype  Union_box
#define mccompcurindex 220
#define loop_index mccchannel_2_analyzer_2_array_crystal_array_3_loop_index
#define this_box_volume mccchannel_2_analyzer_2_array_crystal_array_3_this_box_volume
#define global_geometry_element mccchannel_2_analyzer_2_array_crystal_array_3_global_geometry_element
#define this_box_storage mccchannel_2_analyzer_2_array_crystal_array_3_this_box_storage
{   /* Declarations of channel_2_analyzer_2_array_crystal_array_3=Union_box() SETTING parameters. */
char* material_string = mccchannel_2_analyzer_2_array_crystal_array_3_material_string;
MCNUM priority = mccchannel_2_analyzer_2_array_crystal_array_3_priority;
MCNUM xwidth = mccchannel_2_analyzer_2_array_crystal_array_3_xwidth;
MCNUM yheight = mccchannel_2_analyzer_2_array_crystal_array_3_yheight;
MCNUM zdepth = mccchannel_2_analyzer_2_array_crystal_array_3_zdepth;
MCNUM xwidth2 = mccchannel_2_analyzer_2_array_crystal_array_3_xwidth2;
MCNUM yheight2 = mccchannel_2_analyzer_2_array_crystal_array_3_yheight2;
MCNUM visualize = mccchannel_2_analyzer_2_array_crystal_array_3_visualize;
int target_index = mccchannel_2_analyzer_2_array_crystal_array_3_target_index;
MCNUM target_x = mccchannel_2_analyzer_2_array_crystal_array_3_target_x;
MCNUM target_y = mccchannel_2_analyzer_2_array_crystal_array_3_target_y;
MCNUM target_z = mccchannel_2_analyzer_2_array_crystal_array_3_target_z;
MCNUM focus_aw = mccchannel_2_analyzer_2_array_crystal_array_3_focus_aw;
MCNUM focus_ah = mccchannel_2_analyzer_2_array_crystal_array_3_focus_ah;
MCNUM focus_xw = mccchannel_2_analyzer_2_array_crystal_array_3_focus_xw;
MCNUM focus_xh = mccchannel_2_analyzer_2_array_crystal_array_3_focus_xh;
MCNUM focus_r = mccchannel_2_analyzer_2_array_crystal_array_3_focus_r;
MCNUM p_interact = mccchannel_2_analyzer_2_array_crystal_array_3_p_interact;
char* mask_string = mccchannel_2_analyzer_2_array_crystal_array_3_mask_string;
char* mask_setting = mccchannel_2_analyzer_2_array_crystal_array_3_mask_setting;
MCNUM number_of_activations = mccchannel_2_analyzer_2_array_crystal_array_3_number_of_activations;
}   /* End of channel_2_analyzer_2_array_crystal_array_3=Union_box() SETTING parameter declarations. */
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex
  /* Label for restoring  neutron */
  mcabsorbCompchannel_2_analyzer_2_array_crystal_array_3:
  if (RESTORE) /* restore if needed */
  { RESTORE_NEUTRON(220,
      mcnlx,
      mcnly,
      mcnlz,
      mcnlvx,
      mcnlvy,
      mcnlvz,
      mcnlt,
      mcnlsx,
      mcnlsy,
      mcnlsz,
      mcnlp); }
#undef mcabsorbComp
#undef p
#undef sz
#undef sy
#undef sx
#undef t
#undef vz
#undef vy
#undef vx
#undef z
#undef y
#undef x
  mcDEBUG_STATE(
mcnlx,
mcnly,
mcnlz,
mcnlvx,
mcnlvy,
mcnlvz,
mcnlt,
mcnlsx,
mcnlsy,
mcnlsz,
mcnlp)

  /* TRACE Component channel_2_analyzer_2_array_crystal_array_4 [221] */
  mccoordschange(mcposrchannel_2_analyzer_2_array_crystal_array_4, mcrotrchannel_2_analyzer_2_array_crystal_array_4,
    &mcnlx,
    &mcnly,
    &mcnlz,
    &mcnlvx,
    &mcnlvy,
    &mcnlvz,
    &mcnlsx,
    &mcnlsy,
    &mcnlsz);
  /* define label inside component channel_2_analyzer_2_array_crystal_array_4 (without coords transformations) */
  mcJumpTrace_channel_2_analyzer_2_array_crystal_array_4:
  SIG_MESSAGE("channel_2_analyzer_2_array_crystal_array_4 (Trace)");
  mcDEBUG_COMP("channel_2_analyzer_2_array_crystal_array_4")
  mcDEBUG_STATE(
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp)
#define x mcnlx
#define y mcnly
#define z mcnlz
#define vx mcnlvx
#define vy mcnlvy
#define vz mcnlvz
#define t mcnlt
#define sx mcnlsx
#define sy mcnlsy
#define sz mcnlsz
#define p mcnlp

#define mcabsorbComp mcabsorbCompchannel_2_analyzer_2_array_crystal_array_4
  STORE_NEUTRON(221,
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp);
  mcScattered=0;
  mcRestore=0;
  mcNCounter[221]++;
  mcPCounter[221] += p;
  mcP2Counter[221] += p*p;
#define mccompcurname  channel_2_analyzer_2_array_crystal_array_4
#define mccompcurtype  Union_box
#define mccompcurindex 221
#define loop_index mccchannel_2_analyzer_2_array_crystal_array_4_loop_index
#define this_box_volume mccchannel_2_analyzer_2_array_crystal_array_4_this_box_volume
#define global_geometry_element mccchannel_2_analyzer_2_array_crystal_array_4_global_geometry_element
#define this_box_storage mccchannel_2_analyzer_2_array_crystal_array_4_this_box_storage
{   /* Declarations of channel_2_analyzer_2_array_crystal_array_4=Union_box() SETTING parameters. */
char* material_string = mccchannel_2_analyzer_2_array_crystal_array_4_material_string;
MCNUM priority = mccchannel_2_analyzer_2_array_crystal_array_4_priority;
MCNUM xwidth = mccchannel_2_analyzer_2_array_crystal_array_4_xwidth;
MCNUM yheight = mccchannel_2_analyzer_2_array_crystal_array_4_yheight;
MCNUM zdepth = mccchannel_2_analyzer_2_array_crystal_array_4_zdepth;
MCNUM xwidth2 = mccchannel_2_analyzer_2_array_crystal_array_4_xwidth2;
MCNUM yheight2 = mccchannel_2_analyzer_2_array_crystal_array_4_yheight2;
MCNUM visualize = mccchannel_2_analyzer_2_array_crystal_array_4_visualize;
int target_index = mccchannel_2_analyzer_2_array_crystal_array_4_target_index;
MCNUM target_x = mccchannel_2_analyzer_2_array_crystal_array_4_target_x;
MCNUM target_y = mccchannel_2_analyzer_2_array_crystal_array_4_target_y;
MCNUM target_z = mccchannel_2_analyzer_2_array_crystal_array_4_target_z;
MCNUM focus_aw = mccchannel_2_analyzer_2_array_crystal_array_4_focus_aw;
MCNUM focus_ah = mccchannel_2_analyzer_2_array_crystal_array_4_focus_ah;
MCNUM focus_xw = mccchannel_2_analyzer_2_array_crystal_array_4_focus_xw;
MCNUM focus_xh = mccchannel_2_analyzer_2_array_crystal_array_4_focus_xh;
MCNUM focus_r = mccchannel_2_analyzer_2_array_crystal_array_4_focus_r;
MCNUM p_interact = mccchannel_2_analyzer_2_array_crystal_array_4_p_interact;
char* mask_string = mccchannel_2_analyzer_2_array_crystal_array_4_mask_string;
char* mask_setting = mccchannel_2_analyzer_2_array_crystal_array_4_mask_setting;
MCNUM number_of_activations = mccchannel_2_analyzer_2_array_crystal_array_4_number_of_activations;
}   /* End of channel_2_analyzer_2_array_crystal_array_4=Union_box() SETTING parameter declarations. */
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex
  /* Label for restoring  neutron */
  mcabsorbCompchannel_2_analyzer_2_array_crystal_array_4:
  if (RESTORE) /* restore if needed */
  { RESTORE_NEUTRON(221,
      mcnlx,
      mcnly,
      mcnlz,
      mcnlvx,
      mcnlvy,
      mcnlvz,
      mcnlt,
      mcnlsx,
      mcnlsy,
      mcnlsz,
      mcnlp); }
#undef mcabsorbComp
#undef p
#undef sz
#undef sy
#undef sx
#undef t
#undef vz
#undef vy
#undef vx
#undef z
#undef y
#undef x
  mcDEBUG_STATE(
mcnlx,
mcnly,
mcnlz,
mcnlvx,
mcnlvy,
mcnlvz,
mcnlt,
mcnlsx,
mcnlsy,
mcnlsz,
mcnlp)

  /* TRACE Component channel_2_analyzer_2_array_crystal_array_5 [222] */
  mccoordschange(mcposrchannel_2_analyzer_2_array_crystal_array_5, mcrotrchannel_2_analyzer_2_array_crystal_array_5,
    &mcnlx,
    &mcnly,
    &mcnlz,
    &mcnlvx,
    &mcnlvy,
    &mcnlvz,
    &mcnlsx,
    &mcnlsy,
    &mcnlsz);
  /* define label inside component channel_2_analyzer_2_array_crystal_array_5 (without coords transformations) */
  mcJumpTrace_channel_2_analyzer_2_array_crystal_array_5:
  SIG_MESSAGE("channel_2_analyzer_2_array_crystal_array_5 (Trace)");
  mcDEBUG_COMP("channel_2_analyzer_2_array_crystal_array_5")
  mcDEBUG_STATE(
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp)
#define x mcnlx
#define y mcnly
#define z mcnlz
#define vx mcnlvx
#define vy mcnlvy
#define vz mcnlvz
#define t mcnlt
#define sx mcnlsx
#define sy mcnlsy
#define sz mcnlsz
#define p mcnlp

#define mcabsorbComp mcabsorbCompchannel_2_analyzer_2_array_crystal_array_5
  STORE_NEUTRON(222,
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp);
  mcScattered=0;
  mcRestore=0;
  mcNCounter[222]++;
  mcPCounter[222] += p;
  mcP2Counter[222] += p*p;
#define mccompcurname  channel_2_analyzer_2_array_crystal_array_5
#define mccompcurtype  Union_box
#define mccompcurindex 222
#define loop_index mccchannel_2_analyzer_2_array_crystal_array_5_loop_index
#define this_box_volume mccchannel_2_analyzer_2_array_crystal_array_5_this_box_volume
#define global_geometry_element mccchannel_2_analyzer_2_array_crystal_array_5_global_geometry_element
#define this_box_storage mccchannel_2_analyzer_2_array_crystal_array_5_this_box_storage
{   /* Declarations of channel_2_analyzer_2_array_crystal_array_5=Union_box() SETTING parameters. */
char* material_string = mccchannel_2_analyzer_2_array_crystal_array_5_material_string;
MCNUM priority = mccchannel_2_analyzer_2_array_crystal_array_5_priority;
MCNUM xwidth = mccchannel_2_analyzer_2_array_crystal_array_5_xwidth;
MCNUM yheight = mccchannel_2_analyzer_2_array_crystal_array_5_yheight;
MCNUM zdepth = mccchannel_2_analyzer_2_array_crystal_array_5_zdepth;
MCNUM xwidth2 = mccchannel_2_analyzer_2_array_crystal_array_5_xwidth2;
MCNUM yheight2 = mccchannel_2_analyzer_2_array_crystal_array_5_yheight2;
MCNUM visualize = mccchannel_2_analyzer_2_array_crystal_array_5_visualize;
int target_index = mccchannel_2_analyzer_2_array_crystal_array_5_target_index;
MCNUM target_x = mccchannel_2_analyzer_2_array_crystal_array_5_target_x;
MCNUM target_y = mccchannel_2_analyzer_2_array_crystal_array_5_target_y;
MCNUM target_z = mccchannel_2_analyzer_2_array_crystal_array_5_target_z;
MCNUM focus_aw = mccchannel_2_analyzer_2_array_crystal_array_5_focus_aw;
MCNUM focus_ah = mccchannel_2_analyzer_2_array_crystal_array_5_focus_ah;
MCNUM focus_xw = mccchannel_2_analyzer_2_array_crystal_array_5_focus_xw;
MCNUM focus_xh = mccchannel_2_analyzer_2_array_crystal_array_5_focus_xh;
MCNUM focus_r = mccchannel_2_analyzer_2_array_crystal_array_5_focus_r;
MCNUM p_interact = mccchannel_2_analyzer_2_array_crystal_array_5_p_interact;
char* mask_string = mccchannel_2_analyzer_2_array_crystal_array_5_mask_string;
char* mask_setting = mccchannel_2_analyzer_2_array_crystal_array_5_mask_setting;
MCNUM number_of_activations = mccchannel_2_analyzer_2_array_crystal_array_5_number_of_activations;
}   /* End of channel_2_analyzer_2_array_crystal_array_5=Union_box() SETTING parameter declarations. */
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex
  /* Label for restoring  neutron */
  mcabsorbCompchannel_2_analyzer_2_array_crystal_array_5:
  if (RESTORE) /* restore if needed */
  { RESTORE_NEUTRON(222,
      mcnlx,
      mcnly,
      mcnlz,
      mcnlvx,
      mcnlvy,
      mcnlvz,
      mcnlt,
      mcnlsx,
      mcnlsy,
      mcnlsz,
      mcnlp); }
#undef mcabsorbComp
#undef p
#undef sz
#undef sy
#undef sx
#undef t
#undef vz
#undef vy
#undef vx
#undef z
#undef y
#undef x
  mcDEBUG_STATE(
mcnlx,
mcnly,
mcnlz,
mcnlvx,
mcnlvy,
mcnlvz,
mcnlt,
mcnlsx,
mcnlsy,
mcnlsz,
mcnlp)

  /* TRACE Component channel_2_analyzer_2_array_crystal_array_6 [223] */
  mccoordschange(mcposrchannel_2_analyzer_2_array_crystal_array_6, mcrotrchannel_2_analyzer_2_array_crystal_array_6,
    &mcnlx,
    &mcnly,
    &mcnlz,
    &mcnlvx,
    &mcnlvy,
    &mcnlvz,
    &mcnlsx,
    &mcnlsy,
    &mcnlsz);
  /* define label inside component channel_2_analyzer_2_array_crystal_array_6 (without coords transformations) */
  mcJumpTrace_channel_2_analyzer_2_array_crystal_array_6:
  SIG_MESSAGE("channel_2_analyzer_2_array_crystal_array_6 (Trace)");
  mcDEBUG_COMP("channel_2_analyzer_2_array_crystal_array_6")
  mcDEBUG_STATE(
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp)
#define x mcnlx
#define y mcnly
#define z mcnlz
#define vx mcnlvx
#define vy mcnlvy
#define vz mcnlvz
#define t mcnlt
#define sx mcnlsx
#define sy mcnlsy
#define sz mcnlsz
#define p mcnlp

#define mcabsorbComp mcabsorbCompchannel_2_analyzer_2_array_crystal_array_6
  STORE_NEUTRON(223,
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp);
  mcScattered=0;
  mcRestore=0;
  mcNCounter[223]++;
  mcPCounter[223] += p;
  mcP2Counter[223] += p*p;
#define mccompcurname  channel_2_analyzer_2_array_crystal_array_6
#define mccompcurtype  Union_box
#define mccompcurindex 223
#define loop_index mccchannel_2_analyzer_2_array_crystal_array_6_loop_index
#define this_box_volume mccchannel_2_analyzer_2_array_crystal_array_6_this_box_volume
#define global_geometry_element mccchannel_2_analyzer_2_array_crystal_array_6_global_geometry_element
#define this_box_storage mccchannel_2_analyzer_2_array_crystal_array_6_this_box_storage
{   /* Declarations of channel_2_analyzer_2_array_crystal_array_6=Union_box() SETTING parameters. */
char* material_string = mccchannel_2_analyzer_2_array_crystal_array_6_material_string;
MCNUM priority = mccchannel_2_analyzer_2_array_crystal_array_6_priority;
MCNUM xwidth = mccchannel_2_analyzer_2_array_crystal_array_6_xwidth;
MCNUM yheight = mccchannel_2_analyzer_2_array_crystal_array_6_yheight;
MCNUM zdepth = mccchannel_2_analyzer_2_array_crystal_array_6_zdepth;
MCNUM xwidth2 = mccchannel_2_analyzer_2_array_crystal_array_6_xwidth2;
MCNUM yheight2 = mccchannel_2_analyzer_2_array_crystal_array_6_yheight2;
MCNUM visualize = mccchannel_2_analyzer_2_array_crystal_array_6_visualize;
int target_index = mccchannel_2_analyzer_2_array_crystal_array_6_target_index;
MCNUM target_x = mccchannel_2_analyzer_2_array_crystal_array_6_target_x;
MCNUM target_y = mccchannel_2_analyzer_2_array_crystal_array_6_target_y;
MCNUM target_z = mccchannel_2_analyzer_2_array_crystal_array_6_target_z;
MCNUM focus_aw = mccchannel_2_analyzer_2_array_crystal_array_6_focus_aw;
MCNUM focus_ah = mccchannel_2_analyzer_2_array_crystal_array_6_focus_ah;
MCNUM focus_xw = mccchannel_2_analyzer_2_array_crystal_array_6_focus_xw;
MCNUM focus_xh = mccchannel_2_analyzer_2_array_crystal_array_6_focus_xh;
MCNUM focus_r = mccchannel_2_analyzer_2_array_crystal_array_6_focus_r;
MCNUM p_interact = mccchannel_2_analyzer_2_array_crystal_array_6_p_interact;
char* mask_string = mccchannel_2_analyzer_2_array_crystal_array_6_mask_string;
char* mask_setting = mccchannel_2_analyzer_2_array_crystal_array_6_mask_setting;
MCNUM number_of_activations = mccchannel_2_analyzer_2_array_crystal_array_6_number_of_activations;
}   /* End of channel_2_analyzer_2_array_crystal_array_6=Union_box() SETTING parameter declarations. */
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex
  /* Label for restoring  neutron */
  mcabsorbCompchannel_2_analyzer_2_array_crystal_array_6:
  if (RESTORE) /* restore if needed */
  { RESTORE_NEUTRON(223,
      mcnlx,
      mcnly,
      mcnlz,
      mcnlvx,
      mcnlvy,
      mcnlvz,
      mcnlt,
      mcnlsx,
      mcnlsy,
      mcnlsz,
      mcnlp); }
#undef mcabsorbComp
#undef p
#undef sz
#undef sy
#undef sx
#undef t
#undef vz
#undef vy
#undef vx
#undef z
#undef y
#undef x
  mcDEBUG_STATE(
mcnlx,
mcnly,
mcnlz,
mcnlvx,
mcnlvy,
mcnlvz,
mcnlt,
mcnlsx,
mcnlsy,
mcnlsz,
mcnlp)

  /* TRACE Component channel_2_analyzer_2_array_crystal_array_7 [224] */
  mccoordschange(mcposrchannel_2_analyzer_2_array_crystal_array_7, mcrotrchannel_2_analyzer_2_array_crystal_array_7,
    &mcnlx,
    &mcnly,
    &mcnlz,
    &mcnlvx,
    &mcnlvy,
    &mcnlvz,
    &mcnlsx,
    &mcnlsy,
    &mcnlsz);
  /* define label inside component channel_2_analyzer_2_array_crystal_array_7 (without coords transformations) */
  mcJumpTrace_channel_2_analyzer_2_array_crystal_array_7:
  SIG_MESSAGE("channel_2_analyzer_2_array_crystal_array_7 (Trace)");
  mcDEBUG_COMP("channel_2_analyzer_2_array_crystal_array_7")
  mcDEBUG_STATE(
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp)
#define x mcnlx
#define y mcnly
#define z mcnlz
#define vx mcnlvx
#define vy mcnlvy
#define vz mcnlvz
#define t mcnlt
#define sx mcnlsx
#define sy mcnlsy
#define sz mcnlsz
#define p mcnlp

#define mcabsorbComp mcabsorbCompchannel_2_analyzer_2_array_crystal_array_7
  STORE_NEUTRON(224,
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp);
  mcScattered=0;
  mcRestore=0;
  mcNCounter[224]++;
  mcPCounter[224] += p;
  mcP2Counter[224] += p*p;
#define mccompcurname  channel_2_analyzer_2_array_crystal_array_7
#define mccompcurtype  Union_box
#define mccompcurindex 224
#define loop_index mccchannel_2_analyzer_2_array_crystal_array_7_loop_index
#define this_box_volume mccchannel_2_analyzer_2_array_crystal_array_7_this_box_volume
#define global_geometry_element mccchannel_2_analyzer_2_array_crystal_array_7_global_geometry_element
#define this_box_storage mccchannel_2_analyzer_2_array_crystal_array_7_this_box_storage
{   /* Declarations of channel_2_analyzer_2_array_crystal_array_7=Union_box() SETTING parameters. */
char* material_string = mccchannel_2_analyzer_2_array_crystal_array_7_material_string;
MCNUM priority = mccchannel_2_analyzer_2_array_crystal_array_7_priority;
MCNUM xwidth = mccchannel_2_analyzer_2_array_crystal_array_7_xwidth;
MCNUM yheight = mccchannel_2_analyzer_2_array_crystal_array_7_yheight;
MCNUM zdepth = mccchannel_2_analyzer_2_array_crystal_array_7_zdepth;
MCNUM xwidth2 = mccchannel_2_analyzer_2_array_crystal_array_7_xwidth2;
MCNUM yheight2 = mccchannel_2_analyzer_2_array_crystal_array_7_yheight2;
MCNUM visualize = mccchannel_2_analyzer_2_array_crystal_array_7_visualize;
int target_index = mccchannel_2_analyzer_2_array_crystal_array_7_target_index;
MCNUM target_x = mccchannel_2_analyzer_2_array_crystal_array_7_target_x;
MCNUM target_y = mccchannel_2_analyzer_2_array_crystal_array_7_target_y;
MCNUM target_z = mccchannel_2_analyzer_2_array_crystal_array_7_target_z;
MCNUM focus_aw = mccchannel_2_analyzer_2_array_crystal_array_7_focus_aw;
MCNUM focus_ah = mccchannel_2_analyzer_2_array_crystal_array_7_focus_ah;
MCNUM focus_xw = mccchannel_2_analyzer_2_array_crystal_array_7_focus_xw;
MCNUM focus_xh = mccchannel_2_analyzer_2_array_crystal_array_7_focus_xh;
MCNUM focus_r = mccchannel_2_analyzer_2_array_crystal_array_7_focus_r;
MCNUM p_interact = mccchannel_2_analyzer_2_array_crystal_array_7_p_interact;
char* mask_string = mccchannel_2_analyzer_2_array_crystal_array_7_mask_string;
char* mask_setting = mccchannel_2_analyzer_2_array_crystal_array_7_mask_setting;
MCNUM number_of_activations = mccchannel_2_analyzer_2_array_crystal_array_7_number_of_activations;
}   /* End of channel_2_analyzer_2_array_crystal_array_7=Union_box() SETTING parameter declarations. */
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex
  /* Label for restoring  neutron */
  mcabsorbCompchannel_2_analyzer_2_array_crystal_array_7:
  if (RESTORE) /* restore if needed */
  { RESTORE_NEUTRON(224,
      mcnlx,
      mcnly,
      mcnlz,
      mcnlvx,
      mcnlvy,
      mcnlvz,
      mcnlt,
      mcnlsx,
      mcnlsy,
      mcnlsz,
      mcnlp); }
#undef mcabsorbComp
#undef p
#undef sz
#undef sy
#undef sx
#undef t
#undef vz
#undef vy
#undef vx
#undef z
#undef y
#undef x
  mcDEBUG_STATE(
mcnlx,
mcnly,
mcnlz,
mcnlvx,
mcnlvy,
mcnlvz,
mcnlt,
mcnlsx,
mcnlsy,
mcnlsz,
mcnlp)

  /* TRACE Component channel_2_analyzer_2_array_crystal_array_8 [225] */
  mccoordschange(mcposrchannel_2_analyzer_2_array_crystal_array_8, mcrotrchannel_2_analyzer_2_array_crystal_array_8,
    &mcnlx,
    &mcnly,
    &mcnlz,
    &mcnlvx,
    &mcnlvy,
    &mcnlvz,
    &mcnlsx,
    &mcnlsy,
    &mcnlsz);
  /* define label inside component channel_2_analyzer_2_array_crystal_array_8 (without coords transformations) */
  mcJumpTrace_channel_2_analyzer_2_array_crystal_array_8:
  SIG_MESSAGE("channel_2_analyzer_2_array_crystal_array_8 (Trace)");
  mcDEBUG_COMP("channel_2_analyzer_2_array_crystal_array_8")
  mcDEBUG_STATE(
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp)
#define x mcnlx
#define y mcnly
#define z mcnlz
#define vx mcnlvx
#define vy mcnlvy
#define vz mcnlvz
#define t mcnlt
#define sx mcnlsx
#define sy mcnlsy
#define sz mcnlsz
#define p mcnlp

#define mcabsorbComp mcabsorbCompchannel_2_analyzer_2_array_crystal_array_8
  STORE_NEUTRON(225,
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp);
  mcScattered=0;
  mcRestore=0;
  mcNCounter[225]++;
  mcPCounter[225] += p;
  mcP2Counter[225] += p*p;
#define mccompcurname  channel_2_analyzer_2_array_crystal_array_8
#define mccompcurtype  Union_box
#define mccompcurindex 225
#define loop_index mccchannel_2_analyzer_2_array_crystal_array_8_loop_index
#define this_box_volume mccchannel_2_analyzer_2_array_crystal_array_8_this_box_volume
#define global_geometry_element mccchannel_2_analyzer_2_array_crystal_array_8_global_geometry_element
#define this_box_storage mccchannel_2_analyzer_2_array_crystal_array_8_this_box_storage
{   /* Declarations of channel_2_analyzer_2_array_crystal_array_8=Union_box() SETTING parameters. */
char* material_string = mccchannel_2_analyzer_2_array_crystal_array_8_material_string;
MCNUM priority = mccchannel_2_analyzer_2_array_crystal_array_8_priority;
MCNUM xwidth = mccchannel_2_analyzer_2_array_crystal_array_8_xwidth;
MCNUM yheight = mccchannel_2_analyzer_2_array_crystal_array_8_yheight;
MCNUM zdepth = mccchannel_2_analyzer_2_array_crystal_array_8_zdepth;
MCNUM xwidth2 = mccchannel_2_analyzer_2_array_crystal_array_8_xwidth2;
MCNUM yheight2 = mccchannel_2_analyzer_2_array_crystal_array_8_yheight2;
MCNUM visualize = mccchannel_2_analyzer_2_array_crystal_array_8_visualize;
int target_index = mccchannel_2_analyzer_2_array_crystal_array_8_target_index;
MCNUM target_x = mccchannel_2_analyzer_2_array_crystal_array_8_target_x;
MCNUM target_y = mccchannel_2_analyzer_2_array_crystal_array_8_target_y;
MCNUM target_z = mccchannel_2_analyzer_2_array_crystal_array_8_target_z;
MCNUM focus_aw = mccchannel_2_analyzer_2_array_crystal_array_8_focus_aw;
MCNUM focus_ah = mccchannel_2_analyzer_2_array_crystal_array_8_focus_ah;
MCNUM focus_xw = mccchannel_2_analyzer_2_array_crystal_array_8_focus_xw;
MCNUM focus_xh = mccchannel_2_analyzer_2_array_crystal_array_8_focus_xh;
MCNUM focus_r = mccchannel_2_analyzer_2_array_crystal_array_8_focus_r;
MCNUM p_interact = mccchannel_2_analyzer_2_array_crystal_array_8_p_interact;
char* mask_string = mccchannel_2_analyzer_2_array_crystal_array_8_mask_string;
char* mask_setting = mccchannel_2_analyzer_2_array_crystal_array_8_mask_setting;
MCNUM number_of_activations = mccchannel_2_analyzer_2_array_crystal_array_8_number_of_activations;
}   /* End of channel_2_analyzer_2_array_crystal_array_8=Union_box() SETTING parameter declarations. */
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex
  /* Label for restoring  neutron */
  mcabsorbCompchannel_2_analyzer_2_array_crystal_array_8:
  if (RESTORE) /* restore if needed */
  { RESTORE_NEUTRON(225,
      mcnlx,
      mcnly,
      mcnlz,
      mcnlvx,
      mcnlvy,
      mcnlvz,
      mcnlt,
      mcnlsx,
      mcnlsy,
      mcnlsz,
      mcnlp); }
#undef mcabsorbComp
#undef p
#undef sz
#undef sy
#undef sx
#undef t
#undef vz
#undef vy
#undef vx
#undef z
#undef y
#undef x
  mcDEBUG_STATE(
mcnlx,
mcnly,
mcnlz,
mcnlvx,
mcnlvy,
mcnlvz,
mcnlt,
mcnlsx,
mcnlsy,
mcnlsz,
mcnlp)

  /* TRACE Component channel_2_cave2_cyl1 [226] */
  mccoordschange(mcposrchannel_2_cave2_cyl1, mcrotrchannel_2_cave2_cyl1,
    &mcnlx,
    &mcnly,
    &mcnlz,
    &mcnlvx,
    &mcnlvy,
    &mcnlvz,
    &mcnlsx,
    &mcnlsy,
    &mcnlsz);
  /* define label inside component channel_2_cave2_cyl1 (without coords transformations) */
  mcJumpTrace_channel_2_cave2_cyl1:
  SIG_MESSAGE("channel_2_cave2_cyl1 (Trace)");
  mcDEBUG_COMP("channel_2_cave2_cyl1")
  mcDEBUG_STATE(
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp)
#define x mcnlx
#define y mcnly
#define z mcnlz
#define vx mcnlvx
#define vy mcnlvy
#define vz mcnlvz
#define t mcnlt
#define sx mcnlsx
#define sy mcnlsy
#define sz mcnlsz
#define p mcnlp

#define mcabsorbComp mcabsorbCompchannel_2_cave2_cyl1
  STORE_NEUTRON(226,
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp);
  mcScattered=0;
  mcRestore=0;
  mcNCounter[226]++;
  mcPCounter[226] += p;
  mcP2Counter[226] += p*p;
#define mccompcurname  channel_2_cave2_cyl1
#define mccompcurtype  Union_cylinder
#define mccompcurindex 226
#define loop_index mccchannel_2_cave2_cyl1_loop_index
#define this_cylinder_volume mccchannel_2_cave2_cyl1_this_cylinder_volume
#define global_geometry_element mccchannel_2_cave2_cyl1_global_geometry_element
#define this_cylinder_storage mccchannel_2_cave2_cyl1_this_cylinder_storage
{   /* Declarations of channel_2_cave2_cyl1=Union_cylinder() SETTING parameters. */
char* material_string = mccchannel_2_cave2_cyl1_material_string;
MCNUM priority = mccchannel_2_cave2_cyl1_priority;
MCNUM radius = mccchannel_2_cave2_cyl1_radius;
MCNUM yheight = mccchannel_2_cave2_cyl1_yheight;
MCNUM visualize = mccchannel_2_cave2_cyl1_visualize;
int target_index = mccchannel_2_cave2_cyl1_target_index;
MCNUM target_x = mccchannel_2_cave2_cyl1_target_x;
MCNUM target_y = mccchannel_2_cave2_cyl1_target_y;
MCNUM target_z = mccchannel_2_cave2_cyl1_target_z;
MCNUM focus_aw = mccchannel_2_cave2_cyl1_focus_aw;
MCNUM focus_ah = mccchannel_2_cave2_cyl1_focus_ah;
MCNUM focus_xw = mccchannel_2_cave2_cyl1_focus_xw;
MCNUM focus_xh = mccchannel_2_cave2_cyl1_focus_xh;
MCNUM focus_r = mccchannel_2_cave2_cyl1_focus_r;
MCNUM p_interact = mccchannel_2_cave2_cyl1_p_interact;
char* mask_string = mccchannel_2_cave2_cyl1_mask_string;
char* mask_setting = mccchannel_2_cave2_cyl1_mask_setting;
MCNUM number_of_activations = mccchannel_2_cave2_cyl1_number_of_activations;
#line 345 "Union_cylinder.comp"
{
dummy = 1;
}
#line 375900 "MACS_sample_kidney_box.c"
}   /* End of channel_2_cave2_cyl1=Union_cylinder() SETTING parameter declarations. */
#undef this_cylinder_storage
#undef global_geometry_element
#undef this_cylinder_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex
  /* Label for restoring  neutron */
  mcabsorbCompchannel_2_cave2_cyl1:
  if (RESTORE) /* restore if needed */
  { RESTORE_NEUTRON(226,
      mcnlx,
      mcnly,
      mcnlz,
      mcnlvx,
      mcnlvy,
      mcnlvz,
      mcnlt,
      mcnlsx,
      mcnlsy,
      mcnlsz,
      mcnlp); }
#undef mcabsorbComp
#undef p
#undef sz
#undef sy
#undef sx
#undef t
#undef vz
#undef vy
#undef vx
#undef z
#undef y
#undef x
  mcDEBUG_STATE(
mcnlx,
mcnly,
mcnlz,
mcnlvx,
mcnlvy,
mcnlvz,
mcnlt,
mcnlsx,
mcnlsy,
mcnlsz,
mcnlp)

  /* TRACE Component channel_2_cave2_box1 [227] */
  mccoordschange(mcposrchannel_2_cave2_box1, mcrotrchannel_2_cave2_box1,
    &mcnlx,
    &mcnly,
    &mcnlz,
    &mcnlvx,
    &mcnlvy,
    &mcnlvz,
    &mcnlsx,
    &mcnlsy,
    &mcnlsz);
  /* define label inside component channel_2_cave2_box1 (without coords transformations) */
  mcJumpTrace_channel_2_cave2_box1:
  SIG_MESSAGE("channel_2_cave2_box1 (Trace)");
  mcDEBUG_COMP("channel_2_cave2_box1")
  mcDEBUG_STATE(
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp)
#define x mcnlx
#define y mcnly
#define z mcnlz
#define vx mcnlvx
#define vy mcnlvy
#define vz mcnlvz
#define t mcnlt
#define sx mcnlsx
#define sy mcnlsy
#define sz mcnlsz
#define p mcnlp

#define mcabsorbComp mcabsorbCompchannel_2_cave2_box1
  STORE_NEUTRON(227,
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp);
  mcScattered=0;
  mcRestore=0;
  mcNCounter[227]++;
  mcPCounter[227] += p;
  mcP2Counter[227] += p*p;
#define mccompcurname  channel_2_cave2_box1
#define mccompcurtype  Union_box
#define mccompcurindex 227
#define loop_index mccchannel_2_cave2_box1_loop_index
#define this_box_volume mccchannel_2_cave2_box1_this_box_volume
#define global_geometry_element mccchannel_2_cave2_box1_global_geometry_element
#define this_box_storage mccchannel_2_cave2_box1_this_box_storage
{   /* Declarations of channel_2_cave2_box1=Union_box() SETTING parameters. */
char* material_string = mccchannel_2_cave2_box1_material_string;
MCNUM priority = mccchannel_2_cave2_box1_priority;
MCNUM xwidth = mccchannel_2_cave2_box1_xwidth;
MCNUM yheight = mccchannel_2_cave2_box1_yheight;
MCNUM zdepth = mccchannel_2_cave2_box1_zdepth;
MCNUM xwidth2 = mccchannel_2_cave2_box1_xwidth2;
MCNUM yheight2 = mccchannel_2_cave2_box1_yheight2;
MCNUM visualize = mccchannel_2_cave2_box1_visualize;
int target_index = mccchannel_2_cave2_box1_target_index;
MCNUM target_x = mccchannel_2_cave2_box1_target_x;
MCNUM target_y = mccchannel_2_cave2_box1_target_y;
MCNUM target_z = mccchannel_2_cave2_box1_target_z;
MCNUM focus_aw = mccchannel_2_cave2_box1_focus_aw;
MCNUM focus_ah = mccchannel_2_cave2_box1_focus_ah;
MCNUM focus_xw = mccchannel_2_cave2_box1_focus_xw;
MCNUM focus_xh = mccchannel_2_cave2_box1_focus_xh;
MCNUM focus_r = mccchannel_2_cave2_box1_focus_r;
MCNUM p_interact = mccchannel_2_cave2_box1_p_interact;
char* mask_string = mccchannel_2_cave2_box1_mask_string;
char* mask_setting = mccchannel_2_cave2_box1_mask_setting;
MCNUM number_of_activations = mccchannel_2_cave2_box1_number_of_activations;
}   /* End of channel_2_cave2_box1=Union_box() SETTING parameter declarations. */
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex
  /* Label for restoring  neutron */
  mcabsorbCompchannel_2_cave2_box1:
  if (RESTORE) /* restore if needed */
  { RESTORE_NEUTRON(227,
      mcnlx,
      mcnly,
      mcnlz,
      mcnlvx,
      mcnlvy,
      mcnlvz,
      mcnlt,
      mcnlsx,
      mcnlsy,
      mcnlsz,
      mcnlp); }
#undef mcabsorbComp
#undef p
#undef sz
#undef sy
#undef sx
#undef t
#undef vz
#undef vy
#undef vx
#undef z
#undef y
#undef x
  mcDEBUG_STATE(
mcnlx,
mcnly,
mcnlz,
mcnlvx,
mcnlvy,
mcnlvz,
mcnlt,
mcnlsx,
mcnlsy,
mcnlsz,
mcnlp)

  /* TRACE Component channel_2_cave2_box2 [228] */
  mccoordschange(mcposrchannel_2_cave2_box2, mcrotrchannel_2_cave2_box2,
    &mcnlx,
    &mcnly,
    &mcnlz,
    &mcnlvx,
    &mcnlvy,
    &mcnlvz,
    &mcnlsx,
    &mcnlsy,
    &mcnlsz);
  /* define label inside component channel_2_cave2_box2 (without coords transformations) */
  mcJumpTrace_channel_2_cave2_box2:
  SIG_MESSAGE("channel_2_cave2_box2 (Trace)");
  mcDEBUG_COMP("channel_2_cave2_box2")
  mcDEBUG_STATE(
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp)
#define x mcnlx
#define y mcnly
#define z mcnlz
#define vx mcnlvx
#define vy mcnlvy
#define vz mcnlvz
#define t mcnlt
#define sx mcnlsx
#define sy mcnlsy
#define sz mcnlsz
#define p mcnlp

#define mcabsorbComp mcabsorbCompchannel_2_cave2_box2
  STORE_NEUTRON(228,
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp);
  mcScattered=0;
  mcRestore=0;
  mcNCounter[228]++;
  mcPCounter[228] += p;
  mcP2Counter[228] += p*p;
#define mccompcurname  channel_2_cave2_box2
#define mccompcurtype  Union_box
#define mccompcurindex 228
#define loop_index mccchannel_2_cave2_box2_loop_index
#define this_box_volume mccchannel_2_cave2_box2_this_box_volume
#define global_geometry_element mccchannel_2_cave2_box2_global_geometry_element
#define this_box_storage mccchannel_2_cave2_box2_this_box_storage
{   /* Declarations of channel_2_cave2_box2=Union_box() SETTING parameters. */
char* material_string = mccchannel_2_cave2_box2_material_string;
MCNUM priority = mccchannel_2_cave2_box2_priority;
MCNUM xwidth = mccchannel_2_cave2_box2_xwidth;
MCNUM yheight = mccchannel_2_cave2_box2_yheight;
MCNUM zdepth = mccchannel_2_cave2_box2_zdepth;
MCNUM xwidth2 = mccchannel_2_cave2_box2_xwidth2;
MCNUM yheight2 = mccchannel_2_cave2_box2_yheight2;
MCNUM visualize = mccchannel_2_cave2_box2_visualize;
int target_index = mccchannel_2_cave2_box2_target_index;
MCNUM target_x = mccchannel_2_cave2_box2_target_x;
MCNUM target_y = mccchannel_2_cave2_box2_target_y;
MCNUM target_z = mccchannel_2_cave2_box2_target_z;
MCNUM focus_aw = mccchannel_2_cave2_box2_focus_aw;
MCNUM focus_ah = mccchannel_2_cave2_box2_focus_ah;
MCNUM focus_xw = mccchannel_2_cave2_box2_focus_xw;
MCNUM focus_xh = mccchannel_2_cave2_box2_focus_xh;
MCNUM focus_r = mccchannel_2_cave2_box2_focus_r;
MCNUM p_interact = mccchannel_2_cave2_box2_p_interact;
char* mask_string = mccchannel_2_cave2_box2_mask_string;
char* mask_setting = mccchannel_2_cave2_box2_mask_setting;
MCNUM number_of_activations = mccchannel_2_cave2_box2_number_of_activations;
}   /* End of channel_2_cave2_box2=Union_box() SETTING parameter declarations. */
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex
  /* Label for restoring  neutron */
  mcabsorbCompchannel_2_cave2_box2:
  if (RESTORE) /* restore if needed */
  { RESTORE_NEUTRON(228,
      mcnlx,
      mcnly,
      mcnlz,
      mcnlvx,
      mcnlvy,
      mcnlvz,
      mcnlt,
      mcnlsx,
      mcnlsy,
      mcnlsz,
      mcnlp); }
#undef mcabsorbComp
#undef p
#undef sz
#undef sy
#undef sx
#undef t
#undef vz
#undef vy
#undef vx
#undef z
#undef y
#undef x
  mcDEBUG_STATE(
mcnlx,
mcnly,
mcnlz,
mcnlvx,
mcnlvy,
mcnlvz,
mcnlt,
mcnlsx,
mcnlsy,
mcnlsz,
mcnlp)

  /* TRACE Component channel_2_cave2_box3 [229] */
  mccoordschange(mcposrchannel_2_cave2_box3, mcrotrchannel_2_cave2_box3,
    &mcnlx,
    &mcnly,
    &mcnlz,
    &mcnlvx,
    &mcnlvy,
    &mcnlvz,
    &mcnlsx,
    &mcnlsy,
    &mcnlsz);
  /* define label inside component channel_2_cave2_box3 (without coords transformations) */
  mcJumpTrace_channel_2_cave2_box3:
  SIG_MESSAGE("channel_2_cave2_box3 (Trace)");
  mcDEBUG_COMP("channel_2_cave2_box3")
  mcDEBUG_STATE(
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp)
#define x mcnlx
#define y mcnly
#define z mcnlz
#define vx mcnlvx
#define vy mcnlvy
#define vz mcnlvz
#define t mcnlt
#define sx mcnlsx
#define sy mcnlsy
#define sz mcnlsz
#define p mcnlp

#define mcabsorbComp mcabsorbCompchannel_2_cave2_box3
  STORE_NEUTRON(229,
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp);
  mcScattered=0;
  mcRestore=0;
  mcNCounter[229]++;
  mcPCounter[229] += p;
  mcP2Counter[229] += p*p;
#define mccompcurname  channel_2_cave2_box3
#define mccompcurtype  Union_box
#define mccompcurindex 229
#define loop_index mccchannel_2_cave2_box3_loop_index
#define this_box_volume mccchannel_2_cave2_box3_this_box_volume
#define global_geometry_element mccchannel_2_cave2_box3_global_geometry_element
#define this_box_storage mccchannel_2_cave2_box3_this_box_storage
{   /* Declarations of channel_2_cave2_box3=Union_box() SETTING parameters. */
char* material_string = mccchannel_2_cave2_box3_material_string;
MCNUM priority = mccchannel_2_cave2_box3_priority;
MCNUM xwidth = mccchannel_2_cave2_box3_xwidth;
MCNUM yheight = mccchannel_2_cave2_box3_yheight;
MCNUM zdepth = mccchannel_2_cave2_box3_zdepth;
MCNUM xwidth2 = mccchannel_2_cave2_box3_xwidth2;
MCNUM yheight2 = mccchannel_2_cave2_box3_yheight2;
MCNUM visualize = mccchannel_2_cave2_box3_visualize;
int target_index = mccchannel_2_cave2_box3_target_index;
MCNUM target_x = mccchannel_2_cave2_box3_target_x;
MCNUM target_y = mccchannel_2_cave2_box3_target_y;
MCNUM target_z = mccchannel_2_cave2_box3_target_z;
MCNUM focus_aw = mccchannel_2_cave2_box3_focus_aw;
MCNUM focus_ah = mccchannel_2_cave2_box3_focus_ah;
MCNUM focus_xw = mccchannel_2_cave2_box3_focus_xw;
MCNUM focus_xh = mccchannel_2_cave2_box3_focus_xh;
MCNUM focus_r = mccchannel_2_cave2_box3_focus_r;
MCNUM p_interact = mccchannel_2_cave2_box3_p_interact;
char* mask_string = mccchannel_2_cave2_box3_mask_string;
char* mask_setting = mccchannel_2_cave2_box3_mask_setting;
MCNUM number_of_activations = mccchannel_2_cave2_box3_number_of_activations;
}   /* End of channel_2_cave2_box3=Union_box() SETTING parameter declarations. */
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex
  /* Label for restoring  neutron */
  mcabsorbCompchannel_2_cave2_box3:
  if (RESTORE) /* restore if needed */
  { RESTORE_NEUTRON(229,
      mcnlx,
      mcnly,
      mcnlz,
      mcnlvx,
      mcnlvy,
      mcnlvz,
      mcnlt,
      mcnlsx,
      mcnlsy,
      mcnlsz,
      mcnlp); }
#undef mcabsorbComp
#undef p
#undef sz
#undef sy
#undef sx
#undef t
#undef vz
#undef vy
#undef vx
#undef z
#undef y
#undef x
  mcDEBUG_STATE(
mcnlx,
mcnly,
mcnlz,
mcnlvx,
mcnlvy,
mcnlvz,
mcnlt,
mcnlsx,
mcnlsy,
mcnlsz,
mcnlp)

  /* TRACE Component inter_analyzer_colimator_center_2 [230] */
  mccoordschange(mcposrinter_analyzer_colimator_center_2, mcrotrinter_analyzer_colimator_center_2,
    &mcnlx,
    &mcnly,
    &mcnlz,
    &mcnlvx,
    &mcnlvy,
    &mcnlvz,
    &mcnlsx,
    &mcnlsy,
    &mcnlsz);
  /* define label inside component inter_analyzer_colimator_center_2 (without coords transformations) */
  mcJumpTrace_inter_analyzer_colimator_center_2:
  SIG_MESSAGE("inter_analyzer_colimator_center_2 (Trace)");
  mcDEBUG_COMP("inter_analyzer_colimator_center_2")
  mcDEBUG_STATE(
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp)
#define x mcnlx
#define y mcnly
#define z mcnlz
#define vx mcnlvx
#define vy mcnlvy
#define vz mcnlvz
#define t mcnlt
#define sx mcnlsx
#define sy mcnlsy
#define sz mcnlsz
#define p mcnlp

#define mcabsorbComp mcabsorbCompinter_analyzer_colimator_center_2
  STORE_NEUTRON(230,
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp);
  mcScattered=0;
  mcRestore=0;
  mcNCounter[230]++;
  mcPCounter[230] += p;
  mcP2Counter[230] += p*p;
#define mccompcurname  inter_analyzer_colimator_center_2
#define mccompcurtype  Arm
#define mccompcurindex 230
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex
  /* Label for restoring  neutron */
  mcabsorbCompinter_analyzer_colimator_center_2:
  if (RESTORE) /* restore if needed */
  { RESTORE_NEUTRON(230,
      mcnlx,
      mcnly,
      mcnlz,
      mcnlvx,
      mcnlvy,
      mcnlvz,
      mcnlt,
      mcnlsx,
      mcnlsy,
      mcnlsz,
      mcnlp); }
#undef mcabsorbComp
#undef p
#undef sz
#undef sy
#undef sx
#undef t
#undef vz
#undef vy
#undef vx
#undef z
#undef y
#undef x
  mcDEBUG_STATE(
mcnlx,
mcnly,
mcnlz,
mcnlvx,
mcnlvy,
mcnlvz,
mcnlt,
mcnlsx,
mcnlsy,
mcnlsz,
mcnlp)

  /* TRACE Component inter_analyzer_colimator_2_blade_0 [231] */
  mccoordschange(mcposrinter_analyzer_colimator_2_blade_0, mcrotrinter_analyzer_colimator_2_blade_0,
    &mcnlx,
    &mcnly,
    &mcnlz,
    &mcnlvx,
    &mcnlvy,
    &mcnlvz,
    &mcnlsx,
    &mcnlsy,
    &mcnlsz);
  /* define label inside component inter_analyzer_colimator_2_blade_0 (without coords transformations) */
  mcJumpTrace_inter_analyzer_colimator_2_blade_0:
  SIG_MESSAGE("inter_analyzer_colimator_2_blade_0 (Trace)");
  mcDEBUG_COMP("inter_analyzer_colimator_2_blade_0")
  mcDEBUG_STATE(
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp)
#define x mcnlx
#define y mcnly
#define z mcnlz
#define vx mcnlvx
#define vy mcnlvy
#define vz mcnlvz
#define t mcnlt
#define sx mcnlsx
#define sy mcnlsy
#define sz mcnlsz
#define p mcnlp

#define mcabsorbComp mcabsorbCompinter_analyzer_colimator_2_blade_0
  STORE_NEUTRON(231,
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp);
  mcScattered=0;
  mcRestore=0;
  mcNCounter[231]++;
  mcPCounter[231] += p;
  mcP2Counter[231] += p*p;
#define mccompcurname  inter_analyzer_colimator_2_blade_0
#define mccompcurtype  Union_box
#define mccompcurindex 231
#define loop_index mccinter_analyzer_colimator_2_blade_0_loop_index
#define this_box_volume mccinter_analyzer_colimator_2_blade_0_this_box_volume
#define global_geometry_element mccinter_analyzer_colimator_2_blade_0_global_geometry_element
#define this_box_storage mccinter_analyzer_colimator_2_blade_0_this_box_storage
{   /* Declarations of inter_analyzer_colimator_2_blade_0=Union_box() SETTING parameters. */
char* material_string = mccinter_analyzer_colimator_2_blade_0_material_string;
MCNUM priority = mccinter_analyzer_colimator_2_blade_0_priority;
MCNUM xwidth = mccinter_analyzer_colimator_2_blade_0_xwidth;
MCNUM yheight = mccinter_analyzer_colimator_2_blade_0_yheight;
MCNUM zdepth = mccinter_analyzer_colimator_2_blade_0_zdepth;
MCNUM xwidth2 = mccinter_analyzer_colimator_2_blade_0_xwidth2;
MCNUM yheight2 = mccinter_analyzer_colimator_2_blade_0_yheight2;
MCNUM visualize = mccinter_analyzer_colimator_2_blade_0_visualize;
int target_index = mccinter_analyzer_colimator_2_blade_0_target_index;
MCNUM target_x = mccinter_analyzer_colimator_2_blade_0_target_x;
MCNUM target_y = mccinter_analyzer_colimator_2_blade_0_target_y;
MCNUM target_z = mccinter_analyzer_colimator_2_blade_0_target_z;
MCNUM focus_aw = mccinter_analyzer_colimator_2_blade_0_focus_aw;
MCNUM focus_ah = mccinter_analyzer_colimator_2_blade_0_focus_ah;
MCNUM focus_xw = mccinter_analyzer_colimator_2_blade_0_focus_xw;
MCNUM focus_xh = mccinter_analyzer_colimator_2_blade_0_focus_xh;
MCNUM focus_r = mccinter_analyzer_colimator_2_blade_0_focus_r;
MCNUM p_interact = mccinter_analyzer_colimator_2_blade_0_p_interact;
char* mask_string = mccinter_analyzer_colimator_2_blade_0_mask_string;
char* mask_setting = mccinter_analyzer_colimator_2_blade_0_mask_setting;
MCNUM number_of_activations = mccinter_analyzer_colimator_2_blade_0_number_of_activations;
}   /* End of inter_analyzer_colimator_2_blade_0=Union_box() SETTING parameter declarations. */
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex
  /* Label for restoring  neutron */
  mcabsorbCompinter_analyzer_colimator_2_blade_0:
  if (RESTORE) /* restore if needed */
  { RESTORE_NEUTRON(231,
      mcnlx,
      mcnly,
      mcnlz,
      mcnlvx,
      mcnlvy,
      mcnlvz,
      mcnlt,
      mcnlsx,
      mcnlsy,
      mcnlsz,
      mcnlp); }
#undef mcabsorbComp
#undef p
#undef sz
#undef sy
#undef sx
#undef t
#undef vz
#undef vy
#undef vx
#undef z
#undef y
#undef x
  mcDEBUG_STATE(
mcnlx,
mcnly,
mcnlz,
mcnlvx,
mcnlvy,
mcnlvz,
mcnlt,
mcnlsx,
mcnlsy,
mcnlsz,
mcnlp)

  /* TRACE Component inter_analyzer_colimator_2_blade_1 [232] */
  mccoordschange(mcposrinter_analyzer_colimator_2_blade_1, mcrotrinter_analyzer_colimator_2_blade_1,
    &mcnlx,
    &mcnly,
    &mcnlz,
    &mcnlvx,
    &mcnlvy,
    &mcnlvz,
    &mcnlsx,
    &mcnlsy,
    &mcnlsz);
  /* define label inside component inter_analyzer_colimator_2_blade_1 (without coords transformations) */
  mcJumpTrace_inter_analyzer_colimator_2_blade_1:
  SIG_MESSAGE("inter_analyzer_colimator_2_blade_1 (Trace)");
  mcDEBUG_COMP("inter_analyzer_colimator_2_blade_1")
  mcDEBUG_STATE(
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp)
#define x mcnlx
#define y mcnly
#define z mcnlz
#define vx mcnlvx
#define vy mcnlvy
#define vz mcnlvz
#define t mcnlt
#define sx mcnlsx
#define sy mcnlsy
#define sz mcnlsz
#define p mcnlp

#define mcabsorbComp mcabsorbCompinter_analyzer_colimator_2_blade_1
  STORE_NEUTRON(232,
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp);
  mcScattered=0;
  mcRestore=0;
  mcNCounter[232]++;
  mcPCounter[232] += p;
  mcP2Counter[232] += p*p;
#define mccompcurname  inter_analyzer_colimator_2_blade_1
#define mccompcurtype  Union_box
#define mccompcurindex 232
#define loop_index mccinter_analyzer_colimator_2_blade_1_loop_index
#define this_box_volume mccinter_analyzer_colimator_2_blade_1_this_box_volume
#define global_geometry_element mccinter_analyzer_colimator_2_blade_1_global_geometry_element
#define this_box_storage mccinter_analyzer_colimator_2_blade_1_this_box_storage
{   /* Declarations of inter_analyzer_colimator_2_blade_1=Union_box() SETTING parameters. */
char* material_string = mccinter_analyzer_colimator_2_blade_1_material_string;
MCNUM priority = mccinter_analyzer_colimator_2_blade_1_priority;
MCNUM xwidth = mccinter_analyzer_colimator_2_blade_1_xwidth;
MCNUM yheight = mccinter_analyzer_colimator_2_blade_1_yheight;
MCNUM zdepth = mccinter_analyzer_colimator_2_blade_1_zdepth;
MCNUM xwidth2 = mccinter_analyzer_colimator_2_blade_1_xwidth2;
MCNUM yheight2 = mccinter_analyzer_colimator_2_blade_1_yheight2;
MCNUM visualize = mccinter_analyzer_colimator_2_blade_1_visualize;
int target_index = mccinter_analyzer_colimator_2_blade_1_target_index;
MCNUM target_x = mccinter_analyzer_colimator_2_blade_1_target_x;
MCNUM target_y = mccinter_analyzer_colimator_2_blade_1_target_y;
MCNUM target_z = mccinter_analyzer_colimator_2_blade_1_target_z;
MCNUM focus_aw = mccinter_analyzer_colimator_2_blade_1_focus_aw;
MCNUM focus_ah = mccinter_analyzer_colimator_2_blade_1_focus_ah;
MCNUM focus_xw = mccinter_analyzer_colimator_2_blade_1_focus_xw;
MCNUM focus_xh = mccinter_analyzer_colimator_2_blade_1_focus_xh;
MCNUM focus_r = mccinter_analyzer_colimator_2_blade_1_focus_r;
MCNUM p_interact = mccinter_analyzer_colimator_2_blade_1_p_interact;
char* mask_string = mccinter_analyzer_colimator_2_blade_1_mask_string;
char* mask_setting = mccinter_analyzer_colimator_2_blade_1_mask_setting;
MCNUM number_of_activations = mccinter_analyzer_colimator_2_blade_1_number_of_activations;
}   /* End of inter_analyzer_colimator_2_blade_1=Union_box() SETTING parameter declarations. */
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex
  /* Label for restoring  neutron */
  mcabsorbCompinter_analyzer_colimator_2_blade_1:
  if (RESTORE) /* restore if needed */
  { RESTORE_NEUTRON(232,
      mcnlx,
      mcnly,
      mcnlz,
      mcnlvx,
      mcnlvy,
      mcnlvz,
      mcnlt,
      mcnlsx,
      mcnlsy,
      mcnlsz,
      mcnlp); }
#undef mcabsorbComp
#undef p
#undef sz
#undef sy
#undef sx
#undef t
#undef vz
#undef vy
#undef vx
#undef z
#undef y
#undef x
  mcDEBUG_STATE(
mcnlx,
mcnly,
mcnlz,
mcnlvx,
mcnlvy,
mcnlvz,
mcnlt,
mcnlsx,
mcnlsy,
mcnlsz,
mcnlp)

  /* TRACE Component inter_analyzer_colimator_2_blade_2 [233] */
  mccoordschange(mcposrinter_analyzer_colimator_2_blade_2, mcrotrinter_analyzer_colimator_2_blade_2,
    &mcnlx,
    &mcnly,
    &mcnlz,
    &mcnlvx,
    &mcnlvy,
    &mcnlvz,
    &mcnlsx,
    &mcnlsy,
    &mcnlsz);
  /* define label inside component inter_analyzer_colimator_2_blade_2 (without coords transformations) */
  mcJumpTrace_inter_analyzer_colimator_2_blade_2:
  SIG_MESSAGE("inter_analyzer_colimator_2_blade_2 (Trace)");
  mcDEBUG_COMP("inter_analyzer_colimator_2_blade_2")
  mcDEBUG_STATE(
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp)
#define x mcnlx
#define y mcnly
#define z mcnlz
#define vx mcnlvx
#define vy mcnlvy
#define vz mcnlvz
#define t mcnlt
#define sx mcnlsx
#define sy mcnlsy
#define sz mcnlsz
#define p mcnlp

#define mcabsorbComp mcabsorbCompinter_analyzer_colimator_2_blade_2
  STORE_NEUTRON(233,
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp);
  mcScattered=0;
  mcRestore=0;
  mcNCounter[233]++;
  mcPCounter[233] += p;
  mcP2Counter[233] += p*p;
#define mccompcurname  inter_analyzer_colimator_2_blade_2
#define mccompcurtype  Union_box
#define mccompcurindex 233
#define loop_index mccinter_analyzer_colimator_2_blade_2_loop_index
#define this_box_volume mccinter_analyzer_colimator_2_blade_2_this_box_volume
#define global_geometry_element mccinter_analyzer_colimator_2_blade_2_global_geometry_element
#define this_box_storage mccinter_analyzer_colimator_2_blade_2_this_box_storage
{   /* Declarations of inter_analyzer_colimator_2_blade_2=Union_box() SETTING parameters. */
char* material_string = mccinter_analyzer_colimator_2_blade_2_material_string;
MCNUM priority = mccinter_analyzer_colimator_2_blade_2_priority;
MCNUM xwidth = mccinter_analyzer_colimator_2_blade_2_xwidth;
MCNUM yheight = mccinter_analyzer_colimator_2_blade_2_yheight;
MCNUM zdepth = mccinter_analyzer_colimator_2_blade_2_zdepth;
MCNUM xwidth2 = mccinter_analyzer_colimator_2_blade_2_xwidth2;
MCNUM yheight2 = mccinter_analyzer_colimator_2_blade_2_yheight2;
MCNUM visualize = mccinter_analyzer_colimator_2_blade_2_visualize;
int target_index = mccinter_analyzer_colimator_2_blade_2_target_index;
MCNUM target_x = mccinter_analyzer_colimator_2_blade_2_target_x;
MCNUM target_y = mccinter_analyzer_colimator_2_blade_2_target_y;
MCNUM target_z = mccinter_analyzer_colimator_2_blade_2_target_z;
MCNUM focus_aw = mccinter_analyzer_colimator_2_blade_2_focus_aw;
MCNUM focus_ah = mccinter_analyzer_colimator_2_blade_2_focus_ah;
MCNUM focus_xw = mccinter_analyzer_colimator_2_blade_2_focus_xw;
MCNUM focus_xh = mccinter_analyzer_colimator_2_blade_2_focus_xh;
MCNUM focus_r = mccinter_analyzer_colimator_2_blade_2_focus_r;
MCNUM p_interact = mccinter_analyzer_colimator_2_blade_2_p_interact;
char* mask_string = mccinter_analyzer_colimator_2_blade_2_mask_string;
char* mask_setting = mccinter_analyzer_colimator_2_blade_2_mask_setting;
MCNUM number_of_activations = mccinter_analyzer_colimator_2_blade_2_number_of_activations;
}   /* End of inter_analyzer_colimator_2_blade_2=Union_box() SETTING parameter declarations. */
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex
  /* Label for restoring  neutron */
  mcabsorbCompinter_analyzer_colimator_2_blade_2:
  if (RESTORE) /* restore if needed */
  { RESTORE_NEUTRON(233,
      mcnlx,
      mcnly,
      mcnlz,
      mcnlvx,
      mcnlvy,
      mcnlvz,
      mcnlt,
      mcnlsx,
      mcnlsy,
      mcnlsz,
      mcnlp); }
#undef mcabsorbComp
#undef p
#undef sz
#undef sy
#undef sx
#undef t
#undef vz
#undef vy
#undef vx
#undef z
#undef y
#undef x
  mcDEBUG_STATE(
mcnlx,
mcnly,
mcnlz,
mcnlvx,
mcnlvy,
mcnlvz,
mcnlt,
mcnlsx,
mcnlsy,
mcnlsz,
mcnlp)

  /* TRACE Component inter_analyzer_colimator_2_blade_3 [234] */
  mccoordschange(mcposrinter_analyzer_colimator_2_blade_3, mcrotrinter_analyzer_colimator_2_blade_3,
    &mcnlx,
    &mcnly,
    &mcnlz,
    &mcnlvx,
    &mcnlvy,
    &mcnlvz,
    &mcnlsx,
    &mcnlsy,
    &mcnlsz);
  /* define label inside component inter_analyzer_colimator_2_blade_3 (without coords transformations) */
  mcJumpTrace_inter_analyzer_colimator_2_blade_3:
  SIG_MESSAGE("inter_analyzer_colimator_2_blade_3 (Trace)");
  mcDEBUG_COMP("inter_analyzer_colimator_2_blade_3")
  mcDEBUG_STATE(
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp)
#define x mcnlx
#define y mcnly
#define z mcnlz
#define vx mcnlvx
#define vy mcnlvy
#define vz mcnlvz
#define t mcnlt
#define sx mcnlsx
#define sy mcnlsy
#define sz mcnlsz
#define p mcnlp

#define mcabsorbComp mcabsorbCompinter_analyzer_colimator_2_blade_3
  STORE_NEUTRON(234,
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp);
  mcScattered=0;
  mcRestore=0;
  mcNCounter[234]++;
  mcPCounter[234] += p;
  mcP2Counter[234] += p*p;
#define mccompcurname  inter_analyzer_colimator_2_blade_3
#define mccompcurtype  Union_box
#define mccompcurindex 234
#define loop_index mccinter_analyzer_colimator_2_blade_3_loop_index
#define this_box_volume mccinter_analyzer_colimator_2_blade_3_this_box_volume
#define global_geometry_element mccinter_analyzer_colimator_2_blade_3_global_geometry_element
#define this_box_storage mccinter_analyzer_colimator_2_blade_3_this_box_storage
{   /* Declarations of inter_analyzer_colimator_2_blade_3=Union_box() SETTING parameters. */
char* material_string = mccinter_analyzer_colimator_2_blade_3_material_string;
MCNUM priority = mccinter_analyzer_colimator_2_blade_3_priority;
MCNUM xwidth = mccinter_analyzer_colimator_2_blade_3_xwidth;
MCNUM yheight = mccinter_analyzer_colimator_2_blade_3_yheight;
MCNUM zdepth = mccinter_analyzer_colimator_2_blade_3_zdepth;
MCNUM xwidth2 = mccinter_analyzer_colimator_2_blade_3_xwidth2;
MCNUM yheight2 = mccinter_analyzer_colimator_2_blade_3_yheight2;
MCNUM visualize = mccinter_analyzer_colimator_2_blade_3_visualize;
int target_index = mccinter_analyzer_colimator_2_blade_3_target_index;
MCNUM target_x = mccinter_analyzer_colimator_2_blade_3_target_x;
MCNUM target_y = mccinter_analyzer_colimator_2_blade_3_target_y;
MCNUM target_z = mccinter_analyzer_colimator_2_blade_3_target_z;
MCNUM focus_aw = mccinter_analyzer_colimator_2_blade_3_focus_aw;
MCNUM focus_ah = mccinter_analyzer_colimator_2_blade_3_focus_ah;
MCNUM focus_xw = mccinter_analyzer_colimator_2_blade_3_focus_xw;
MCNUM focus_xh = mccinter_analyzer_colimator_2_blade_3_focus_xh;
MCNUM focus_r = mccinter_analyzer_colimator_2_blade_3_focus_r;
MCNUM p_interact = mccinter_analyzer_colimator_2_blade_3_p_interact;
char* mask_string = mccinter_analyzer_colimator_2_blade_3_mask_string;
char* mask_setting = mccinter_analyzer_colimator_2_blade_3_mask_setting;
MCNUM number_of_activations = mccinter_analyzer_colimator_2_blade_3_number_of_activations;
}   /* End of inter_analyzer_colimator_2_blade_3=Union_box() SETTING parameter declarations. */
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex
  /* Label for restoring  neutron */
  mcabsorbCompinter_analyzer_colimator_2_blade_3:
  if (RESTORE) /* restore if needed */
  { RESTORE_NEUTRON(234,
      mcnlx,
      mcnly,
      mcnlz,
      mcnlvx,
      mcnlvy,
      mcnlvz,
      mcnlt,
      mcnlsx,
      mcnlsy,
      mcnlsz,
      mcnlp); }
#undef mcabsorbComp
#undef p
#undef sz
#undef sy
#undef sx
#undef t
#undef vz
#undef vy
#undef vx
#undef z
#undef y
#undef x
  mcDEBUG_STATE(
mcnlx,
mcnly,
mcnlz,
mcnlvx,
mcnlvy,
mcnlvz,
mcnlt,
mcnlsx,
mcnlsy,
mcnlsz,
mcnlp)

  /* TRACE Component inter_analyzer_colimator_2_blade_4 [235] */
  mccoordschange(mcposrinter_analyzer_colimator_2_blade_4, mcrotrinter_analyzer_colimator_2_blade_4,
    &mcnlx,
    &mcnly,
    &mcnlz,
    &mcnlvx,
    &mcnlvy,
    &mcnlvz,
    &mcnlsx,
    &mcnlsy,
    &mcnlsz);
  /* define label inside component inter_analyzer_colimator_2_blade_4 (without coords transformations) */
  mcJumpTrace_inter_analyzer_colimator_2_blade_4:
  SIG_MESSAGE("inter_analyzer_colimator_2_blade_4 (Trace)");
  mcDEBUG_COMP("inter_analyzer_colimator_2_blade_4")
  mcDEBUG_STATE(
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp)
#define x mcnlx
#define y mcnly
#define z mcnlz
#define vx mcnlvx
#define vy mcnlvy
#define vz mcnlvz
#define t mcnlt
#define sx mcnlsx
#define sy mcnlsy
#define sz mcnlsz
#define p mcnlp

#define mcabsorbComp mcabsorbCompinter_analyzer_colimator_2_blade_4
  STORE_NEUTRON(235,
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp);
  mcScattered=0;
  mcRestore=0;
  mcNCounter[235]++;
  mcPCounter[235] += p;
  mcP2Counter[235] += p*p;
#define mccompcurname  inter_analyzer_colimator_2_blade_4
#define mccompcurtype  Union_box
#define mccompcurindex 235
#define loop_index mccinter_analyzer_colimator_2_blade_4_loop_index
#define this_box_volume mccinter_analyzer_colimator_2_blade_4_this_box_volume
#define global_geometry_element mccinter_analyzer_colimator_2_blade_4_global_geometry_element
#define this_box_storage mccinter_analyzer_colimator_2_blade_4_this_box_storage
{   /* Declarations of inter_analyzer_colimator_2_blade_4=Union_box() SETTING parameters. */
char* material_string = mccinter_analyzer_colimator_2_blade_4_material_string;
MCNUM priority = mccinter_analyzer_colimator_2_blade_4_priority;
MCNUM xwidth = mccinter_analyzer_colimator_2_blade_4_xwidth;
MCNUM yheight = mccinter_analyzer_colimator_2_blade_4_yheight;
MCNUM zdepth = mccinter_analyzer_colimator_2_blade_4_zdepth;
MCNUM xwidth2 = mccinter_analyzer_colimator_2_blade_4_xwidth2;
MCNUM yheight2 = mccinter_analyzer_colimator_2_blade_4_yheight2;
MCNUM visualize = mccinter_analyzer_colimator_2_blade_4_visualize;
int target_index = mccinter_analyzer_colimator_2_blade_4_target_index;
MCNUM target_x = mccinter_analyzer_colimator_2_blade_4_target_x;
MCNUM target_y = mccinter_analyzer_colimator_2_blade_4_target_y;
MCNUM target_z = mccinter_analyzer_colimator_2_blade_4_target_z;
MCNUM focus_aw = mccinter_analyzer_colimator_2_blade_4_focus_aw;
MCNUM focus_ah = mccinter_analyzer_colimator_2_blade_4_focus_ah;
MCNUM focus_xw = mccinter_analyzer_colimator_2_blade_4_focus_xw;
MCNUM focus_xh = mccinter_analyzer_colimator_2_blade_4_focus_xh;
MCNUM focus_r = mccinter_analyzer_colimator_2_blade_4_focus_r;
MCNUM p_interact = mccinter_analyzer_colimator_2_blade_4_p_interact;
char* mask_string = mccinter_analyzer_colimator_2_blade_4_mask_string;
char* mask_setting = mccinter_analyzer_colimator_2_blade_4_mask_setting;
MCNUM number_of_activations = mccinter_analyzer_colimator_2_blade_4_number_of_activations;
}   /* End of inter_analyzer_colimator_2_blade_4=Union_box() SETTING parameter declarations. */
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex
  /* Label for restoring  neutron */
  mcabsorbCompinter_analyzer_colimator_2_blade_4:
  if (RESTORE) /* restore if needed */
  { RESTORE_NEUTRON(235,
      mcnlx,
      mcnly,
      mcnlz,
      mcnlvx,
      mcnlvy,
      mcnlvz,
      mcnlt,
      mcnlsx,
      mcnlsy,
      mcnlsz,
      mcnlp); }
#undef mcabsorbComp
#undef p
#undef sz
#undef sy
#undef sx
#undef t
#undef vz
#undef vy
#undef vx
#undef z
#undef y
#undef x
  mcDEBUG_STATE(
mcnlx,
mcnly,
mcnlz,
mcnlvx,
mcnlvy,
mcnlvz,
mcnlt,
mcnlsx,
mcnlsy,
mcnlsz,
mcnlp)

  /* TRACE Component diffraction_detector_2_exit_volume [236] */
  mccoordschange(mcposrdiffraction_detector_2_exit_volume, mcrotrdiffraction_detector_2_exit_volume,
    &mcnlx,
    &mcnly,
    &mcnlz,
    &mcnlvx,
    &mcnlvy,
    &mcnlvz,
    &mcnlsx,
    &mcnlsy,
    &mcnlsz);
  /* define label inside component diffraction_detector_2_exit_volume (without coords transformations) */
  mcJumpTrace_diffraction_detector_2_exit_volume:
  SIG_MESSAGE("diffraction_detector_2_exit_volume (Trace)");
  mcDEBUG_COMP("diffraction_detector_2_exit_volume")
  mcDEBUG_STATE(
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp)
#define x mcnlx
#define y mcnly
#define z mcnlz
#define vx mcnlvx
#define vy mcnlvy
#define vz mcnlvz
#define t mcnlt
#define sx mcnlsx
#define sy mcnlsy
#define sz mcnlsz
#define p mcnlp

#define mcabsorbComp mcabsorbCompdiffraction_detector_2_exit_volume
  STORE_NEUTRON(236,
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp);
  mcScattered=0;
  mcRestore=0;
  mcNCounter[236]++;
  mcPCounter[236] += p;
  mcP2Counter[236] += p*p;
#define mccompcurname  diffraction_detector_2_exit_volume
#define mccompcurtype  Union_box
#define mccompcurindex 236
#define loop_index mccdiffraction_detector_2_exit_volume_loop_index
#define this_box_volume mccdiffraction_detector_2_exit_volume_this_box_volume
#define global_geometry_element mccdiffraction_detector_2_exit_volume_global_geometry_element
#define this_box_storage mccdiffraction_detector_2_exit_volume_this_box_storage
{   /* Declarations of diffraction_detector_2_exit_volume=Union_box() SETTING parameters. */
char* material_string = mccdiffraction_detector_2_exit_volume_material_string;
MCNUM priority = mccdiffraction_detector_2_exit_volume_priority;
MCNUM xwidth = mccdiffraction_detector_2_exit_volume_xwidth;
MCNUM yheight = mccdiffraction_detector_2_exit_volume_yheight;
MCNUM zdepth = mccdiffraction_detector_2_exit_volume_zdepth;
MCNUM xwidth2 = mccdiffraction_detector_2_exit_volume_xwidth2;
MCNUM yheight2 = mccdiffraction_detector_2_exit_volume_yheight2;
MCNUM visualize = mccdiffraction_detector_2_exit_volume_visualize;
int target_index = mccdiffraction_detector_2_exit_volume_target_index;
MCNUM target_x = mccdiffraction_detector_2_exit_volume_target_x;
MCNUM target_y = mccdiffraction_detector_2_exit_volume_target_y;
MCNUM target_z = mccdiffraction_detector_2_exit_volume_target_z;
MCNUM focus_aw = mccdiffraction_detector_2_exit_volume_focus_aw;
MCNUM focus_ah = mccdiffraction_detector_2_exit_volume_focus_ah;
MCNUM focus_xw = mccdiffraction_detector_2_exit_volume_focus_xw;
MCNUM focus_xh = mccdiffraction_detector_2_exit_volume_focus_xh;
MCNUM focus_r = mccdiffraction_detector_2_exit_volume_focus_r;
MCNUM p_interact = mccdiffraction_detector_2_exit_volume_p_interact;
char* mask_string = mccdiffraction_detector_2_exit_volume_mask_string;
char* mask_setting = mccdiffraction_detector_2_exit_volume_mask_setting;
MCNUM number_of_activations = mccdiffraction_detector_2_exit_volume_number_of_activations;
}   /* End of diffraction_detector_2_exit_volume=Union_box() SETTING parameter declarations. */
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex
  /* Label for restoring  neutron */
  mcabsorbCompdiffraction_detector_2_exit_volume:
  if (RESTORE) /* restore if needed */
  { RESTORE_NEUTRON(236,
      mcnlx,
      mcnly,
      mcnlz,
      mcnlvx,
      mcnlvy,
      mcnlvz,
      mcnlt,
      mcnlsx,
      mcnlsy,
      mcnlsz,
      mcnlp); }
#undef mcabsorbComp
#undef p
#undef sz
#undef sy
#undef sx
#undef t
#undef vz
#undef vy
#undef vx
#undef z
#undef y
#undef x
  mcDEBUG_STATE(
mcnlx,
mcnly,
mcnlz,
mcnlvx,
mcnlvy,
mcnlvz,
mcnlt,
mcnlsx,
mcnlsy,
mcnlsz,
mcnlp)

  /* TRACE Component spec_detector_2_exit_volume [237] */
  mccoordschange(mcposrspec_detector_2_exit_volume, mcrotrspec_detector_2_exit_volume,
    &mcnlx,
    &mcnly,
    &mcnlz,
    &mcnlvx,
    &mcnlvy,
    &mcnlvz,
    &mcnlsx,
    &mcnlsy,
    &mcnlsz);
  /* define label inside component spec_detector_2_exit_volume (without coords transformations) */
  mcJumpTrace_spec_detector_2_exit_volume:
  SIG_MESSAGE("spec_detector_2_exit_volume (Trace)");
  mcDEBUG_COMP("spec_detector_2_exit_volume")
  mcDEBUG_STATE(
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp)
#define x mcnlx
#define y mcnly
#define z mcnlz
#define vx mcnlvx
#define vy mcnlvy
#define vz mcnlvz
#define t mcnlt
#define sx mcnlsx
#define sy mcnlsy
#define sz mcnlsz
#define p mcnlp

#define mcabsorbComp mcabsorbCompspec_detector_2_exit_volume
  STORE_NEUTRON(237,
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp);
  mcScattered=0;
  mcRestore=0;
  mcNCounter[237]++;
  mcPCounter[237] += p;
  mcP2Counter[237] += p*p;
#define mccompcurname  spec_detector_2_exit_volume
#define mccompcurtype  Union_box
#define mccompcurindex 237
#define loop_index mccspec_detector_2_exit_volume_loop_index
#define this_box_volume mccspec_detector_2_exit_volume_this_box_volume
#define global_geometry_element mccspec_detector_2_exit_volume_global_geometry_element
#define this_box_storage mccspec_detector_2_exit_volume_this_box_storage
{   /* Declarations of spec_detector_2_exit_volume=Union_box() SETTING parameters. */
char* material_string = mccspec_detector_2_exit_volume_material_string;
MCNUM priority = mccspec_detector_2_exit_volume_priority;
MCNUM xwidth = mccspec_detector_2_exit_volume_xwidth;
MCNUM yheight = mccspec_detector_2_exit_volume_yheight;
MCNUM zdepth = mccspec_detector_2_exit_volume_zdepth;
MCNUM xwidth2 = mccspec_detector_2_exit_volume_xwidth2;
MCNUM yheight2 = mccspec_detector_2_exit_volume_yheight2;
MCNUM visualize = mccspec_detector_2_exit_volume_visualize;
int target_index = mccspec_detector_2_exit_volume_target_index;
MCNUM target_x = mccspec_detector_2_exit_volume_target_x;
MCNUM target_y = mccspec_detector_2_exit_volume_target_y;
MCNUM target_z = mccspec_detector_2_exit_volume_target_z;
MCNUM focus_aw = mccspec_detector_2_exit_volume_focus_aw;
MCNUM focus_ah = mccspec_detector_2_exit_volume_focus_ah;
MCNUM focus_xw = mccspec_detector_2_exit_volume_focus_xw;
MCNUM focus_xh = mccspec_detector_2_exit_volume_focus_xh;
MCNUM focus_r = mccspec_detector_2_exit_volume_focus_r;
MCNUM p_interact = mccspec_detector_2_exit_volume_p_interact;
char* mask_string = mccspec_detector_2_exit_volume_mask_string;
char* mask_setting = mccspec_detector_2_exit_volume_mask_setting;
MCNUM number_of_activations = mccspec_detector_2_exit_volume_number_of_activations;
}   /* End of spec_detector_2_exit_volume=Union_box() SETTING parameter declarations. */
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex
  /* Label for restoring  neutron */
  mcabsorbCompspec_detector_2_exit_volume:
  if (RESTORE) /* restore if needed */
  { RESTORE_NEUTRON(237,
      mcnlx,
      mcnly,
      mcnlz,
      mcnlvx,
      mcnlvy,
      mcnlvz,
      mcnlt,
      mcnlsx,
      mcnlsy,
      mcnlsz,
      mcnlp); }
#undef mcabsorbComp
#undef p
#undef sz
#undef sy
#undef sx
#undef t
#undef vz
#undef vy
#undef vx
#undef z
#undef y
#undef x
  mcDEBUG_STATE(
mcnlx,
mcnly,
mcnlz,
mcnlvx,
mcnlvy,
mcnlvz,
mcnlt,
mcnlsx,
mcnlsy,
mcnlsz,
mcnlp)

  /* TRACE Component channel_3_cave1_box1 [238] */
  mccoordschange(mcposrchannel_3_cave1_box1, mcrotrchannel_3_cave1_box1,
    &mcnlx,
    &mcnly,
    &mcnlz,
    &mcnlvx,
    &mcnlvy,
    &mcnlvz,
    &mcnlsx,
    &mcnlsy,
    &mcnlsz);
  /* define label inside component channel_3_cave1_box1 (without coords transformations) */
  mcJumpTrace_channel_3_cave1_box1:
  SIG_MESSAGE("channel_3_cave1_box1 (Trace)");
  mcDEBUG_COMP("channel_3_cave1_box1")
  mcDEBUG_STATE(
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp)
#define x mcnlx
#define y mcnly
#define z mcnlz
#define vx mcnlvx
#define vy mcnlvy
#define vz mcnlvz
#define t mcnlt
#define sx mcnlsx
#define sy mcnlsy
#define sz mcnlsz
#define p mcnlp

#define mcabsorbComp mcabsorbCompchannel_3_cave1_box1
  STORE_NEUTRON(238,
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp);
  mcScattered=0;
  mcRestore=0;
  mcNCounter[238]++;
  mcPCounter[238] += p;
  mcP2Counter[238] += p*p;
#define mccompcurname  channel_3_cave1_box1
#define mccompcurtype  Union_box
#define mccompcurindex 238
#define loop_index mccchannel_3_cave1_box1_loop_index
#define this_box_volume mccchannel_3_cave1_box1_this_box_volume
#define global_geometry_element mccchannel_3_cave1_box1_global_geometry_element
#define this_box_storage mccchannel_3_cave1_box1_this_box_storage
{   /* Declarations of channel_3_cave1_box1=Union_box() SETTING parameters. */
char* material_string = mccchannel_3_cave1_box1_material_string;
MCNUM priority = mccchannel_3_cave1_box1_priority;
MCNUM xwidth = mccchannel_3_cave1_box1_xwidth;
MCNUM yheight = mccchannel_3_cave1_box1_yheight;
MCNUM zdepth = mccchannel_3_cave1_box1_zdepth;
MCNUM xwidth2 = mccchannel_3_cave1_box1_xwidth2;
MCNUM yheight2 = mccchannel_3_cave1_box1_yheight2;
MCNUM visualize = mccchannel_3_cave1_box1_visualize;
int target_index = mccchannel_3_cave1_box1_target_index;
MCNUM target_x = mccchannel_3_cave1_box1_target_x;
MCNUM target_y = mccchannel_3_cave1_box1_target_y;
MCNUM target_z = mccchannel_3_cave1_box1_target_z;
MCNUM focus_aw = mccchannel_3_cave1_box1_focus_aw;
MCNUM focus_ah = mccchannel_3_cave1_box1_focus_ah;
MCNUM focus_xw = mccchannel_3_cave1_box1_focus_xw;
MCNUM focus_xh = mccchannel_3_cave1_box1_focus_xh;
MCNUM focus_r = mccchannel_3_cave1_box1_focus_r;
MCNUM p_interact = mccchannel_3_cave1_box1_p_interact;
char* mask_string = mccchannel_3_cave1_box1_mask_string;
char* mask_setting = mccchannel_3_cave1_box1_mask_setting;
MCNUM number_of_activations = mccchannel_3_cave1_box1_number_of_activations;
}   /* End of channel_3_cave1_box1=Union_box() SETTING parameter declarations. */
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex
  /* Label for restoring  neutron */
  mcabsorbCompchannel_3_cave1_box1:
  if (RESTORE) /* restore if needed */
  { RESTORE_NEUTRON(238,
      mcnlx,
      mcnly,
      mcnlz,
      mcnlvx,
      mcnlvy,
      mcnlvz,
      mcnlt,
      mcnlsx,
      mcnlsy,
      mcnlsz,
      mcnlp); }
#undef mcabsorbComp
#undef p
#undef sz
#undef sy
#undef sx
#undef t
#undef vz
#undef vy
#undef vx
#undef z
#undef y
#undef x
  mcDEBUG_STATE(
mcnlx,
mcnly,
mcnlz,
mcnlvx,
mcnlvy,
mcnlvz,
mcnlt,
mcnlsx,
mcnlsy,
mcnlsz,
mcnlp)

  /* TRACE Component channel_3_cave1_box2 [239] */
  mccoordschange(mcposrchannel_3_cave1_box2, mcrotrchannel_3_cave1_box2,
    &mcnlx,
    &mcnly,
    &mcnlz,
    &mcnlvx,
    &mcnlvy,
    &mcnlvz,
    &mcnlsx,
    &mcnlsy,
    &mcnlsz);
  /* define label inside component channel_3_cave1_box2 (without coords transformations) */
  mcJumpTrace_channel_3_cave1_box2:
  SIG_MESSAGE("channel_3_cave1_box2 (Trace)");
  mcDEBUG_COMP("channel_3_cave1_box2")
  mcDEBUG_STATE(
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp)
#define x mcnlx
#define y mcnly
#define z mcnlz
#define vx mcnlvx
#define vy mcnlvy
#define vz mcnlvz
#define t mcnlt
#define sx mcnlsx
#define sy mcnlsy
#define sz mcnlsz
#define p mcnlp

#define mcabsorbComp mcabsorbCompchannel_3_cave1_box2
  STORE_NEUTRON(239,
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp);
  mcScattered=0;
  mcRestore=0;
  mcNCounter[239]++;
  mcPCounter[239] += p;
  mcP2Counter[239] += p*p;
#define mccompcurname  channel_3_cave1_box2
#define mccompcurtype  Union_box
#define mccompcurindex 239
#define loop_index mccchannel_3_cave1_box2_loop_index
#define this_box_volume mccchannel_3_cave1_box2_this_box_volume
#define global_geometry_element mccchannel_3_cave1_box2_global_geometry_element
#define this_box_storage mccchannel_3_cave1_box2_this_box_storage
{   /* Declarations of channel_3_cave1_box2=Union_box() SETTING parameters. */
char* material_string = mccchannel_3_cave1_box2_material_string;
MCNUM priority = mccchannel_3_cave1_box2_priority;
MCNUM xwidth = mccchannel_3_cave1_box2_xwidth;
MCNUM yheight = mccchannel_3_cave1_box2_yheight;
MCNUM zdepth = mccchannel_3_cave1_box2_zdepth;
MCNUM xwidth2 = mccchannel_3_cave1_box2_xwidth2;
MCNUM yheight2 = mccchannel_3_cave1_box2_yheight2;
MCNUM visualize = mccchannel_3_cave1_box2_visualize;
int target_index = mccchannel_3_cave1_box2_target_index;
MCNUM target_x = mccchannel_3_cave1_box2_target_x;
MCNUM target_y = mccchannel_3_cave1_box2_target_y;
MCNUM target_z = mccchannel_3_cave1_box2_target_z;
MCNUM focus_aw = mccchannel_3_cave1_box2_focus_aw;
MCNUM focus_ah = mccchannel_3_cave1_box2_focus_ah;
MCNUM focus_xw = mccchannel_3_cave1_box2_focus_xw;
MCNUM focus_xh = mccchannel_3_cave1_box2_focus_xh;
MCNUM focus_r = mccchannel_3_cave1_box2_focus_r;
MCNUM p_interact = mccchannel_3_cave1_box2_p_interact;
char* mask_string = mccchannel_3_cave1_box2_mask_string;
char* mask_setting = mccchannel_3_cave1_box2_mask_setting;
MCNUM number_of_activations = mccchannel_3_cave1_box2_number_of_activations;
}   /* End of channel_3_cave1_box2=Union_box() SETTING parameter declarations. */
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex
  /* Label for restoring  neutron */
  mcabsorbCompchannel_3_cave1_box2:
  if (RESTORE) /* restore if needed */
  { RESTORE_NEUTRON(239,
      mcnlx,
      mcnly,
      mcnlz,
      mcnlvx,
      mcnlvy,
      mcnlvz,
      mcnlt,
      mcnlsx,
      mcnlsy,
      mcnlsz,
      mcnlp); }
#undef mcabsorbComp
#undef p
#undef sz
#undef sy
#undef sx
#undef t
#undef vz
#undef vy
#undef vx
#undef z
#undef y
#undef x
  mcDEBUG_STATE(
mcnlx,
mcnly,
mcnlz,
mcnlvx,
mcnlvy,
mcnlvz,
mcnlt,
mcnlsx,
mcnlsy,
mcnlsz,
mcnlp)

  /* TRACE Component channel_3_cave1_box3 [240] */
  mccoordschange(mcposrchannel_3_cave1_box3, mcrotrchannel_3_cave1_box3,
    &mcnlx,
    &mcnly,
    &mcnlz,
    &mcnlvx,
    &mcnlvy,
    &mcnlvz,
    &mcnlsx,
    &mcnlsy,
    &mcnlsz);
  /* define label inside component channel_3_cave1_box3 (without coords transformations) */
  mcJumpTrace_channel_3_cave1_box3:
  SIG_MESSAGE("channel_3_cave1_box3 (Trace)");
  mcDEBUG_COMP("channel_3_cave1_box3")
  mcDEBUG_STATE(
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp)
#define x mcnlx
#define y mcnly
#define z mcnlz
#define vx mcnlvx
#define vy mcnlvy
#define vz mcnlvz
#define t mcnlt
#define sx mcnlsx
#define sy mcnlsy
#define sz mcnlsz
#define p mcnlp

#define mcabsorbComp mcabsorbCompchannel_3_cave1_box3
  STORE_NEUTRON(240,
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp);
  mcScattered=0;
  mcRestore=0;
  mcNCounter[240]++;
  mcPCounter[240] += p;
  mcP2Counter[240] += p*p;
#define mccompcurname  channel_3_cave1_box3
#define mccompcurtype  Union_box
#define mccompcurindex 240
#define loop_index mccchannel_3_cave1_box3_loop_index
#define this_box_volume mccchannel_3_cave1_box3_this_box_volume
#define global_geometry_element mccchannel_3_cave1_box3_global_geometry_element
#define this_box_storage mccchannel_3_cave1_box3_this_box_storage
{   /* Declarations of channel_3_cave1_box3=Union_box() SETTING parameters. */
char* material_string = mccchannel_3_cave1_box3_material_string;
MCNUM priority = mccchannel_3_cave1_box3_priority;
MCNUM xwidth = mccchannel_3_cave1_box3_xwidth;
MCNUM yheight = mccchannel_3_cave1_box3_yheight;
MCNUM zdepth = mccchannel_3_cave1_box3_zdepth;
MCNUM xwidth2 = mccchannel_3_cave1_box3_xwidth2;
MCNUM yheight2 = mccchannel_3_cave1_box3_yheight2;
MCNUM visualize = mccchannel_3_cave1_box3_visualize;
int target_index = mccchannel_3_cave1_box3_target_index;
MCNUM target_x = mccchannel_3_cave1_box3_target_x;
MCNUM target_y = mccchannel_3_cave1_box3_target_y;
MCNUM target_z = mccchannel_3_cave1_box3_target_z;
MCNUM focus_aw = mccchannel_3_cave1_box3_focus_aw;
MCNUM focus_ah = mccchannel_3_cave1_box3_focus_ah;
MCNUM focus_xw = mccchannel_3_cave1_box3_focus_xw;
MCNUM focus_xh = mccchannel_3_cave1_box3_focus_xh;
MCNUM focus_r = mccchannel_3_cave1_box3_focus_r;
MCNUM p_interact = mccchannel_3_cave1_box3_p_interact;
char* mask_string = mccchannel_3_cave1_box3_mask_string;
char* mask_setting = mccchannel_3_cave1_box3_mask_setting;
MCNUM number_of_activations = mccchannel_3_cave1_box3_number_of_activations;
}   /* End of channel_3_cave1_box3=Union_box() SETTING parameter declarations. */
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex
  /* Label for restoring  neutron */
  mcabsorbCompchannel_3_cave1_box3:
  if (RESTORE) /* restore if needed */
  { RESTORE_NEUTRON(240,
      mcnlx,
      mcnly,
      mcnlz,
      mcnlvx,
      mcnlvy,
      mcnlvz,
      mcnlt,
      mcnlsx,
      mcnlsy,
      mcnlsz,
      mcnlp); }
#undef mcabsorbComp
#undef p
#undef sz
#undef sy
#undef sx
#undef t
#undef vz
#undef vy
#undef vx
#undef z
#undef y
#undef x
  mcDEBUG_STATE(
mcnlx,
mcnly,
mcnlz,
mcnlvx,
mcnlvy,
mcnlvz,
mcnlt,
mcnlsx,
mcnlsy,
mcnlsz,
mcnlp)

  /* TRACE Component channel_3_cave1_cyl1 [241] */
  mccoordschange(mcposrchannel_3_cave1_cyl1, mcrotrchannel_3_cave1_cyl1,
    &mcnlx,
    &mcnly,
    &mcnlz,
    &mcnlvx,
    &mcnlvy,
    &mcnlvz,
    &mcnlsx,
    &mcnlsy,
    &mcnlsz);
  /* define label inside component channel_3_cave1_cyl1 (without coords transformations) */
  mcJumpTrace_channel_3_cave1_cyl1:
  SIG_MESSAGE("channel_3_cave1_cyl1 (Trace)");
  mcDEBUG_COMP("channel_3_cave1_cyl1")
  mcDEBUG_STATE(
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp)
#define x mcnlx
#define y mcnly
#define z mcnlz
#define vx mcnlvx
#define vy mcnlvy
#define vz mcnlvz
#define t mcnlt
#define sx mcnlsx
#define sy mcnlsy
#define sz mcnlsz
#define p mcnlp

#define mcabsorbComp mcabsorbCompchannel_3_cave1_cyl1
  STORE_NEUTRON(241,
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp);
  mcScattered=0;
  mcRestore=0;
  mcNCounter[241]++;
  mcPCounter[241] += p;
  mcP2Counter[241] += p*p;
#define mccompcurname  channel_3_cave1_cyl1
#define mccompcurtype  Union_cylinder
#define mccompcurindex 241
#define loop_index mccchannel_3_cave1_cyl1_loop_index
#define this_cylinder_volume mccchannel_3_cave1_cyl1_this_cylinder_volume
#define global_geometry_element mccchannel_3_cave1_cyl1_global_geometry_element
#define this_cylinder_storage mccchannel_3_cave1_cyl1_this_cylinder_storage
{   /* Declarations of channel_3_cave1_cyl1=Union_cylinder() SETTING parameters. */
char* material_string = mccchannel_3_cave1_cyl1_material_string;
MCNUM priority = mccchannel_3_cave1_cyl1_priority;
MCNUM radius = mccchannel_3_cave1_cyl1_radius;
MCNUM yheight = mccchannel_3_cave1_cyl1_yheight;
MCNUM visualize = mccchannel_3_cave1_cyl1_visualize;
int target_index = mccchannel_3_cave1_cyl1_target_index;
MCNUM target_x = mccchannel_3_cave1_cyl1_target_x;
MCNUM target_y = mccchannel_3_cave1_cyl1_target_y;
MCNUM target_z = mccchannel_3_cave1_cyl1_target_z;
MCNUM focus_aw = mccchannel_3_cave1_cyl1_focus_aw;
MCNUM focus_ah = mccchannel_3_cave1_cyl1_focus_ah;
MCNUM focus_xw = mccchannel_3_cave1_cyl1_focus_xw;
MCNUM focus_xh = mccchannel_3_cave1_cyl1_focus_xh;
MCNUM focus_r = mccchannel_3_cave1_cyl1_focus_r;
MCNUM p_interact = mccchannel_3_cave1_cyl1_p_interact;
char* mask_string = mccchannel_3_cave1_cyl1_mask_string;
char* mask_setting = mccchannel_3_cave1_cyl1_mask_setting;
MCNUM number_of_activations = mccchannel_3_cave1_cyl1_number_of_activations;
#line 345 "Union_cylinder.comp"
{
dummy = 1;
}
#line 377881 "MACS_sample_kidney_box.c"
}   /* End of channel_3_cave1_cyl1=Union_cylinder() SETTING parameter declarations. */
#undef this_cylinder_storage
#undef global_geometry_element
#undef this_cylinder_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex
  /* Label for restoring  neutron */
  mcabsorbCompchannel_3_cave1_cyl1:
  if (RESTORE) /* restore if needed */
  { RESTORE_NEUTRON(241,
      mcnlx,
      mcnly,
      mcnlz,
      mcnlvx,
      mcnlvy,
      mcnlvz,
      mcnlt,
      mcnlsx,
      mcnlsy,
      mcnlsz,
      mcnlp); }
#undef mcabsorbComp
#undef p
#undef sz
#undef sy
#undef sx
#undef t
#undef vz
#undef vy
#undef vx
#undef z
#undef y
#undef x
  mcDEBUG_STATE(
mcnlx,
mcnly,
mcnlz,
mcnlvx,
mcnlvy,
mcnlvz,
mcnlt,
mcnlsx,
mcnlsy,
mcnlsz,
mcnlp)

  /* TRACE Component channel_3_analyzer_1_center [242] */
  mccoordschange(mcposrchannel_3_analyzer_1_center, mcrotrchannel_3_analyzer_1_center,
    &mcnlx,
    &mcnly,
    &mcnlz,
    &mcnlvx,
    &mcnlvy,
    &mcnlvz,
    &mcnlsx,
    &mcnlsy,
    &mcnlsz);
  /* define label inside component channel_3_analyzer_1_center (without coords transformations) */
  mcJumpTrace_channel_3_analyzer_1_center:
  SIG_MESSAGE("channel_3_analyzer_1_center (Trace)");
  mcDEBUG_COMP("channel_3_analyzer_1_center")
  mcDEBUG_STATE(
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp)
#define x mcnlx
#define y mcnly
#define z mcnlz
#define vx mcnlvx
#define vy mcnlvy
#define vz mcnlvz
#define t mcnlt
#define sx mcnlsx
#define sy mcnlsy
#define sz mcnlsz
#define p mcnlp

#define mcabsorbComp mcabsorbCompchannel_3_analyzer_1_center
  STORE_NEUTRON(242,
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp);
  mcScattered=0;
  mcRestore=0;
  mcNCounter[242]++;
  mcPCounter[242] += p;
  mcP2Counter[242] += p*p;
#define mccompcurname  channel_3_analyzer_1_center
#define mccompcurtype  Arm
#define mccompcurindex 242
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex
  /* Label for restoring  neutron */
  mcabsorbCompchannel_3_analyzer_1_center:
  if (RESTORE) /* restore if needed */
  { RESTORE_NEUTRON(242,
      mcnlx,
      mcnly,
      mcnlz,
      mcnlvx,
      mcnlvy,
      mcnlvz,
      mcnlt,
      mcnlsx,
      mcnlsy,
      mcnlsz,
      mcnlp); }
#undef mcabsorbComp
#undef p
#undef sz
#undef sy
#undef sx
#undef t
#undef vz
#undef vy
#undef vx
#undef z
#undef y
#undef x
  mcDEBUG_STATE(
mcnlx,
mcnly,
mcnlz,
mcnlvx,
mcnlvy,
mcnlvz,
mcnlt,
mcnlsx,
mcnlsy,
mcnlsz,
mcnlp)

  /* TRACE Component channel_3_analyzer_1_rotated [243] */
  mccoordschange(mcposrchannel_3_analyzer_1_rotated, mcrotrchannel_3_analyzer_1_rotated,
    &mcnlx,
    &mcnly,
    &mcnlz,
    &mcnlvx,
    &mcnlvy,
    &mcnlvz,
    &mcnlsx,
    &mcnlsy,
    &mcnlsz);
  /* define label inside component channel_3_analyzer_1_rotated (without coords transformations) */
  mcJumpTrace_channel_3_analyzer_1_rotated:
  SIG_MESSAGE("channel_3_analyzer_1_rotated (Trace)");
  mcDEBUG_COMP("channel_3_analyzer_1_rotated")
  mcDEBUG_STATE(
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp)
#define x mcnlx
#define y mcnly
#define z mcnlz
#define vx mcnlvx
#define vy mcnlvy
#define vz mcnlvz
#define t mcnlt
#define sx mcnlsx
#define sy mcnlsy
#define sz mcnlsz
#define p mcnlp

#define mcabsorbComp mcabsorbCompchannel_3_analyzer_1_rotated
  STORE_NEUTRON(243,
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp);
  mcScattered=0;
  mcRestore=0;
  mcNCounter[243]++;
  mcPCounter[243] += p;
  mcP2Counter[243] += p*p;
#define mccompcurname  channel_3_analyzer_1_rotated
#define mccompcurtype  Arm
#define mccompcurindex 243
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex
  /* Label for restoring  neutron */
  mcabsorbCompchannel_3_analyzer_1_rotated:
  if (RESTORE) /* restore if needed */
  { RESTORE_NEUTRON(243,
      mcnlx,
      mcnly,
      mcnlz,
      mcnlvx,
      mcnlvy,
      mcnlvz,
      mcnlt,
      mcnlsx,
      mcnlsy,
      mcnlsz,
      mcnlp); }
#undef mcabsorbComp
#undef p
#undef sz
#undef sy
#undef sx
#undef t
#undef vz
#undef vy
#undef vx
#undef z
#undef y
#undef x
  mcDEBUG_STATE(
mcnlx,
mcnly,
mcnlz,
mcnlvx,
mcnlvy,
mcnlvz,
mcnlt,
mcnlsx,
mcnlsy,
mcnlsz,
mcnlp)

  /* TRACE Component channel_3_analyzer_1_array_crystal_array_0 [244] */
  mccoordschange(mcposrchannel_3_analyzer_1_array_crystal_array_0, mcrotrchannel_3_analyzer_1_array_crystal_array_0,
    &mcnlx,
    &mcnly,
    &mcnlz,
    &mcnlvx,
    &mcnlvy,
    &mcnlvz,
    &mcnlsx,
    &mcnlsy,
    &mcnlsz);
  /* define label inside component channel_3_analyzer_1_array_crystal_array_0 (without coords transformations) */
  mcJumpTrace_channel_3_analyzer_1_array_crystal_array_0:
  SIG_MESSAGE("channel_3_analyzer_1_array_crystal_array_0 (Trace)");
  mcDEBUG_COMP("channel_3_analyzer_1_array_crystal_array_0")
  mcDEBUG_STATE(
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp)
#define x mcnlx
#define y mcnly
#define z mcnlz
#define vx mcnlvx
#define vy mcnlvy
#define vz mcnlvz
#define t mcnlt
#define sx mcnlsx
#define sy mcnlsy
#define sz mcnlsz
#define p mcnlp

#define mcabsorbComp mcabsorbCompchannel_3_analyzer_1_array_crystal_array_0
  STORE_NEUTRON(244,
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp);
  mcScattered=0;
  mcRestore=0;
  mcNCounter[244]++;
  mcPCounter[244] += p;
  mcP2Counter[244] += p*p;
#define mccompcurname  channel_3_analyzer_1_array_crystal_array_0
#define mccompcurtype  Union_box
#define mccompcurindex 244
#define loop_index mccchannel_3_analyzer_1_array_crystal_array_0_loop_index
#define this_box_volume mccchannel_3_analyzer_1_array_crystal_array_0_this_box_volume
#define global_geometry_element mccchannel_3_analyzer_1_array_crystal_array_0_global_geometry_element
#define this_box_storage mccchannel_3_analyzer_1_array_crystal_array_0_this_box_storage
{   /* Declarations of channel_3_analyzer_1_array_crystal_array_0=Union_box() SETTING parameters. */
char* material_string = mccchannel_3_analyzer_1_array_crystal_array_0_material_string;
MCNUM priority = mccchannel_3_analyzer_1_array_crystal_array_0_priority;
MCNUM xwidth = mccchannel_3_analyzer_1_array_crystal_array_0_xwidth;
MCNUM yheight = mccchannel_3_analyzer_1_array_crystal_array_0_yheight;
MCNUM zdepth = mccchannel_3_analyzer_1_array_crystal_array_0_zdepth;
MCNUM xwidth2 = mccchannel_3_analyzer_1_array_crystal_array_0_xwidth2;
MCNUM yheight2 = mccchannel_3_analyzer_1_array_crystal_array_0_yheight2;
MCNUM visualize = mccchannel_3_analyzer_1_array_crystal_array_0_visualize;
int target_index = mccchannel_3_analyzer_1_array_crystal_array_0_target_index;
MCNUM target_x = mccchannel_3_analyzer_1_array_crystal_array_0_target_x;
MCNUM target_y = mccchannel_3_analyzer_1_array_crystal_array_0_target_y;
MCNUM target_z = mccchannel_3_analyzer_1_array_crystal_array_0_target_z;
MCNUM focus_aw = mccchannel_3_analyzer_1_array_crystal_array_0_focus_aw;
MCNUM focus_ah = mccchannel_3_analyzer_1_array_crystal_array_0_focus_ah;
MCNUM focus_xw = mccchannel_3_analyzer_1_array_crystal_array_0_focus_xw;
MCNUM focus_xh = mccchannel_3_analyzer_1_array_crystal_array_0_focus_xh;
MCNUM focus_r = mccchannel_3_analyzer_1_array_crystal_array_0_focus_r;
MCNUM p_interact = mccchannel_3_analyzer_1_array_crystal_array_0_p_interact;
char* mask_string = mccchannel_3_analyzer_1_array_crystal_array_0_mask_string;
char* mask_setting = mccchannel_3_analyzer_1_array_crystal_array_0_mask_setting;
MCNUM number_of_activations = mccchannel_3_analyzer_1_array_crystal_array_0_number_of_activations;
}   /* End of channel_3_analyzer_1_array_crystal_array_0=Union_box() SETTING parameter declarations. */
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex
  /* Label for restoring  neutron */
  mcabsorbCompchannel_3_analyzer_1_array_crystal_array_0:
  if (RESTORE) /* restore if needed */
  { RESTORE_NEUTRON(244,
      mcnlx,
      mcnly,
      mcnlz,
      mcnlvx,
      mcnlvy,
      mcnlvz,
      mcnlt,
      mcnlsx,
      mcnlsy,
      mcnlsz,
      mcnlp); }
#undef mcabsorbComp
#undef p
#undef sz
#undef sy
#undef sx
#undef t
#undef vz
#undef vy
#undef vx
#undef z
#undef y
#undef x
  mcDEBUG_STATE(
mcnlx,
mcnly,
mcnlz,
mcnlvx,
mcnlvy,
mcnlvz,
mcnlt,
mcnlsx,
mcnlsy,
mcnlsz,
mcnlp)

  /* TRACE Component channel_3_analyzer_1_array_crystal_array_1 [245] */
  mccoordschange(mcposrchannel_3_analyzer_1_array_crystal_array_1, mcrotrchannel_3_analyzer_1_array_crystal_array_1,
    &mcnlx,
    &mcnly,
    &mcnlz,
    &mcnlvx,
    &mcnlvy,
    &mcnlvz,
    &mcnlsx,
    &mcnlsy,
    &mcnlsz);
  /* define label inside component channel_3_analyzer_1_array_crystal_array_1 (without coords transformations) */
  mcJumpTrace_channel_3_analyzer_1_array_crystal_array_1:
  SIG_MESSAGE("channel_3_analyzer_1_array_crystal_array_1 (Trace)");
  mcDEBUG_COMP("channel_3_analyzer_1_array_crystal_array_1")
  mcDEBUG_STATE(
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp)
#define x mcnlx
#define y mcnly
#define z mcnlz
#define vx mcnlvx
#define vy mcnlvy
#define vz mcnlvz
#define t mcnlt
#define sx mcnlsx
#define sy mcnlsy
#define sz mcnlsz
#define p mcnlp

#define mcabsorbComp mcabsorbCompchannel_3_analyzer_1_array_crystal_array_1
  STORE_NEUTRON(245,
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp);
  mcScattered=0;
  mcRestore=0;
  mcNCounter[245]++;
  mcPCounter[245] += p;
  mcP2Counter[245] += p*p;
#define mccompcurname  channel_3_analyzer_1_array_crystal_array_1
#define mccompcurtype  Union_box
#define mccompcurindex 245
#define loop_index mccchannel_3_analyzer_1_array_crystal_array_1_loop_index
#define this_box_volume mccchannel_3_analyzer_1_array_crystal_array_1_this_box_volume
#define global_geometry_element mccchannel_3_analyzer_1_array_crystal_array_1_global_geometry_element
#define this_box_storage mccchannel_3_analyzer_1_array_crystal_array_1_this_box_storage
{   /* Declarations of channel_3_analyzer_1_array_crystal_array_1=Union_box() SETTING parameters. */
char* material_string = mccchannel_3_analyzer_1_array_crystal_array_1_material_string;
MCNUM priority = mccchannel_3_analyzer_1_array_crystal_array_1_priority;
MCNUM xwidth = mccchannel_3_analyzer_1_array_crystal_array_1_xwidth;
MCNUM yheight = mccchannel_3_analyzer_1_array_crystal_array_1_yheight;
MCNUM zdepth = mccchannel_3_analyzer_1_array_crystal_array_1_zdepth;
MCNUM xwidth2 = mccchannel_3_analyzer_1_array_crystal_array_1_xwidth2;
MCNUM yheight2 = mccchannel_3_analyzer_1_array_crystal_array_1_yheight2;
MCNUM visualize = mccchannel_3_analyzer_1_array_crystal_array_1_visualize;
int target_index = mccchannel_3_analyzer_1_array_crystal_array_1_target_index;
MCNUM target_x = mccchannel_3_analyzer_1_array_crystal_array_1_target_x;
MCNUM target_y = mccchannel_3_analyzer_1_array_crystal_array_1_target_y;
MCNUM target_z = mccchannel_3_analyzer_1_array_crystal_array_1_target_z;
MCNUM focus_aw = mccchannel_3_analyzer_1_array_crystal_array_1_focus_aw;
MCNUM focus_ah = mccchannel_3_analyzer_1_array_crystal_array_1_focus_ah;
MCNUM focus_xw = mccchannel_3_analyzer_1_array_crystal_array_1_focus_xw;
MCNUM focus_xh = mccchannel_3_analyzer_1_array_crystal_array_1_focus_xh;
MCNUM focus_r = mccchannel_3_analyzer_1_array_crystal_array_1_focus_r;
MCNUM p_interact = mccchannel_3_analyzer_1_array_crystal_array_1_p_interact;
char* mask_string = mccchannel_3_analyzer_1_array_crystal_array_1_mask_string;
char* mask_setting = mccchannel_3_analyzer_1_array_crystal_array_1_mask_setting;
MCNUM number_of_activations = mccchannel_3_analyzer_1_array_crystal_array_1_number_of_activations;
}   /* End of channel_3_analyzer_1_array_crystal_array_1=Union_box() SETTING parameter declarations. */
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex
  /* Label for restoring  neutron */
  mcabsorbCompchannel_3_analyzer_1_array_crystal_array_1:
  if (RESTORE) /* restore if needed */
  { RESTORE_NEUTRON(245,
      mcnlx,
      mcnly,
      mcnlz,
      mcnlvx,
      mcnlvy,
      mcnlvz,
      mcnlt,
      mcnlsx,
      mcnlsy,
      mcnlsz,
      mcnlp); }
#undef mcabsorbComp
#undef p
#undef sz
#undef sy
#undef sx
#undef t
#undef vz
#undef vy
#undef vx
#undef z
#undef y
#undef x
  mcDEBUG_STATE(
mcnlx,
mcnly,
mcnlz,
mcnlvx,
mcnlvy,
mcnlvz,
mcnlt,
mcnlsx,
mcnlsy,
mcnlsz,
mcnlp)

  /* TRACE Component channel_3_analyzer_1_array_crystal_array_2 [246] */
  mccoordschange(mcposrchannel_3_analyzer_1_array_crystal_array_2, mcrotrchannel_3_analyzer_1_array_crystal_array_2,
    &mcnlx,
    &mcnly,
    &mcnlz,
    &mcnlvx,
    &mcnlvy,
    &mcnlvz,
    &mcnlsx,
    &mcnlsy,
    &mcnlsz);
  /* define label inside component channel_3_analyzer_1_array_crystal_array_2 (without coords transformations) */
  mcJumpTrace_channel_3_analyzer_1_array_crystal_array_2:
  SIG_MESSAGE("channel_3_analyzer_1_array_crystal_array_2 (Trace)");
  mcDEBUG_COMP("channel_3_analyzer_1_array_crystal_array_2")
  mcDEBUG_STATE(
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp)
#define x mcnlx
#define y mcnly
#define z mcnlz
#define vx mcnlvx
#define vy mcnlvy
#define vz mcnlvz
#define t mcnlt
#define sx mcnlsx
#define sy mcnlsy
#define sz mcnlsz
#define p mcnlp

#define mcabsorbComp mcabsorbCompchannel_3_analyzer_1_array_crystal_array_2
  STORE_NEUTRON(246,
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp);
  mcScattered=0;
  mcRestore=0;
  mcNCounter[246]++;
  mcPCounter[246] += p;
  mcP2Counter[246] += p*p;
#define mccompcurname  channel_3_analyzer_1_array_crystal_array_2
#define mccompcurtype  Union_box
#define mccompcurindex 246
#define loop_index mccchannel_3_analyzer_1_array_crystal_array_2_loop_index
#define this_box_volume mccchannel_3_analyzer_1_array_crystal_array_2_this_box_volume
#define global_geometry_element mccchannel_3_analyzer_1_array_crystal_array_2_global_geometry_element
#define this_box_storage mccchannel_3_analyzer_1_array_crystal_array_2_this_box_storage
{   /* Declarations of channel_3_analyzer_1_array_crystal_array_2=Union_box() SETTING parameters. */
char* material_string = mccchannel_3_analyzer_1_array_crystal_array_2_material_string;
MCNUM priority = mccchannel_3_analyzer_1_array_crystal_array_2_priority;
MCNUM xwidth = mccchannel_3_analyzer_1_array_crystal_array_2_xwidth;
MCNUM yheight = mccchannel_3_analyzer_1_array_crystal_array_2_yheight;
MCNUM zdepth = mccchannel_3_analyzer_1_array_crystal_array_2_zdepth;
MCNUM xwidth2 = mccchannel_3_analyzer_1_array_crystal_array_2_xwidth2;
MCNUM yheight2 = mccchannel_3_analyzer_1_array_crystal_array_2_yheight2;
MCNUM visualize = mccchannel_3_analyzer_1_array_crystal_array_2_visualize;
int target_index = mccchannel_3_analyzer_1_array_crystal_array_2_target_index;
MCNUM target_x = mccchannel_3_analyzer_1_array_crystal_array_2_target_x;
MCNUM target_y = mccchannel_3_analyzer_1_array_crystal_array_2_target_y;
MCNUM target_z = mccchannel_3_analyzer_1_array_crystal_array_2_target_z;
MCNUM focus_aw = mccchannel_3_analyzer_1_array_crystal_array_2_focus_aw;
MCNUM focus_ah = mccchannel_3_analyzer_1_array_crystal_array_2_focus_ah;
MCNUM focus_xw = mccchannel_3_analyzer_1_array_crystal_array_2_focus_xw;
MCNUM focus_xh = mccchannel_3_analyzer_1_array_crystal_array_2_focus_xh;
MCNUM focus_r = mccchannel_3_analyzer_1_array_crystal_array_2_focus_r;
MCNUM p_interact = mccchannel_3_analyzer_1_array_crystal_array_2_p_interact;
char* mask_string = mccchannel_3_analyzer_1_array_crystal_array_2_mask_string;
char* mask_setting = mccchannel_3_analyzer_1_array_crystal_array_2_mask_setting;
MCNUM number_of_activations = mccchannel_3_analyzer_1_array_crystal_array_2_number_of_activations;
}   /* End of channel_3_analyzer_1_array_crystal_array_2=Union_box() SETTING parameter declarations. */
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex
  /* Label for restoring  neutron */
  mcabsorbCompchannel_3_analyzer_1_array_crystal_array_2:
  if (RESTORE) /* restore if needed */
  { RESTORE_NEUTRON(246,
      mcnlx,
      mcnly,
      mcnlz,
      mcnlvx,
      mcnlvy,
      mcnlvz,
      mcnlt,
      mcnlsx,
      mcnlsy,
      mcnlsz,
      mcnlp); }
#undef mcabsorbComp
#undef p
#undef sz
#undef sy
#undef sx
#undef t
#undef vz
#undef vy
#undef vx
#undef z
#undef y
#undef x
  mcDEBUG_STATE(
mcnlx,
mcnly,
mcnlz,
mcnlvx,
mcnlvy,
mcnlvz,
mcnlt,
mcnlsx,
mcnlsy,
mcnlsz,
mcnlp)

  /* TRACE Component channel_3_analyzer_1_array_crystal_array_3 [247] */
  mccoordschange(mcposrchannel_3_analyzer_1_array_crystal_array_3, mcrotrchannel_3_analyzer_1_array_crystal_array_3,
    &mcnlx,
    &mcnly,
    &mcnlz,
    &mcnlvx,
    &mcnlvy,
    &mcnlvz,
    &mcnlsx,
    &mcnlsy,
    &mcnlsz);
  /* define label inside component channel_3_analyzer_1_array_crystal_array_3 (without coords transformations) */
  mcJumpTrace_channel_3_analyzer_1_array_crystal_array_3:
  SIG_MESSAGE("channel_3_analyzer_1_array_crystal_array_3 (Trace)");
  mcDEBUG_COMP("channel_3_analyzer_1_array_crystal_array_3")
  mcDEBUG_STATE(
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp)
#define x mcnlx
#define y mcnly
#define z mcnlz
#define vx mcnlvx
#define vy mcnlvy
#define vz mcnlvz
#define t mcnlt
#define sx mcnlsx
#define sy mcnlsy
#define sz mcnlsz
#define p mcnlp

#define mcabsorbComp mcabsorbCompchannel_3_analyzer_1_array_crystal_array_3
  STORE_NEUTRON(247,
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp);
  mcScattered=0;
  mcRestore=0;
  mcNCounter[247]++;
  mcPCounter[247] += p;
  mcP2Counter[247] += p*p;
#define mccompcurname  channel_3_analyzer_1_array_crystal_array_3
#define mccompcurtype  Union_box
#define mccompcurindex 247
#define loop_index mccchannel_3_analyzer_1_array_crystal_array_3_loop_index
#define this_box_volume mccchannel_3_analyzer_1_array_crystal_array_3_this_box_volume
#define global_geometry_element mccchannel_3_analyzer_1_array_crystal_array_3_global_geometry_element
#define this_box_storage mccchannel_3_analyzer_1_array_crystal_array_3_this_box_storage
{   /* Declarations of channel_3_analyzer_1_array_crystal_array_3=Union_box() SETTING parameters. */
char* material_string = mccchannel_3_analyzer_1_array_crystal_array_3_material_string;
MCNUM priority = mccchannel_3_analyzer_1_array_crystal_array_3_priority;
MCNUM xwidth = mccchannel_3_analyzer_1_array_crystal_array_3_xwidth;
MCNUM yheight = mccchannel_3_analyzer_1_array_crystal_array_3_yheight;
MCNUM zdepth = mccchannel_3_analyzer_1_array_crystal_array_3_zdepth;
MCNUM xwidth2 = mccchannel_3_analyzer_1_array_crystal_array_3_xwidth2;
MCNUM yheight2 = mccchannel_3_analyzer_1_array_crystal_array_3_yheight2;
MCNUM visualize = mccchannel_3_analyzer_1_array_crystal_array_3_visualize;
int target_index = mccchannel_3_analyzer_1_array_crystal_array_3_target_index;
MCNUM target_x = mccchannel_3_analyzer_1_array_crystal_array_3_target_x;
MCNUM target_y = mccchannel_3_analyzer_1_array_crystal_array_3_target_y;
MCNUM target_z = mccchannel_3_analyzer_1_array_crystal_array_3_target_z;
MCNUM focus_aw = mccchannel_3_analyzer_1_array_crystal_array_3_focus_aw;
MCNUM focus_ah = mccchannel_3_analyzer_1_array_crystal_array_3_focus_ah;
MCNUM focus_xw = mccchannel_3_analyzer_1_array_crystal_array_3_focus_xw;
MCNUM focus_xh = mccchannel_3_analyzer_1_array_crystal_array_3_focus_xh;
MCNUM focus_r = mccchannel_3_analyzer_1_array_crystal_array_3_focus_r;
MCNUM p_interact = mccchannel_3_analyzer_1_array_crystal_array_3_p_interact;
char* mask_string = mccchannel_3_analyzer_1_array_crystal_array_3_mask_string;
char* mask_setting = mccchannel_3_analyzer_1_array_crystal_array_3_mask_setting;
MCNUM number_of_activations = mccchannel_3_analyzer_1_array_crystal_array_3_number_of_activations;
}   /* End of channel_3_analyzer_1_array_crystal_array_3=Union_box() SETTING parameter declarations. */
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex
  /* Label for restoring  neutron */
  mcabsorbCompchannel_3_analyzer_1_array_crystal_array_3:
  if (RESTORE) /* restore if needed */
  { RESTORE_NEUTRON(247,
      mcnlx,
      mcnly,
      mcnlz,
      mcnlvx,
      mcnlvy,
      mcnlvz,
      mcnlt,
      mcnlsx,
      mcnlsy,
      mcnlsz,
      mcnlp); }
#undef mcabsorbComp
#undef p
#undef sz
#undef sy
#undef sx
#undef t
#undef vz
#undef vy
#undef vx
#undef z
#undef y
#undef x
  mcDEBUG_STATE(
mcnlx,
mcnly,
mcnlz,
mcnlvx,
mcnlvy,
mcnlvz,
mcnlt,
mcnlsx,
mcnlsy,
mcnlsz,
mcnlp)

  /* TRACE Component channel_3_analyzer_1_array_crystal_array_4 [248] */
  mccoordschange(mcposrchannel_3_analyzer_1_array_crystal_array_4, mcrotrchannel_3_analyzer_1_array_crystal_array_4,
    &mcnlx,
    &mcnly,
    &mcnlz,
    &mcnlvx,
    &mcnlvy,
    &mcnlvz,
    &mcnlsx,
    &mcnlsy,
    &mcnlsz);
  /* define label inside component channel_3_analyzer_1_array_crystal_array_4 (without coords transformations) */
  mcJumpTrace_channel_3_analyzer_1_array_crystal_array_4:
  SIG_MESSAGE("channel_3_analyzer_1_array_crystal_array_4 (Trace)");
  mcDEBUG_COMP("channel_3_analyzer_1_array_crystal_array_4")
  mcDEBUG_STATE(
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp)
#define x mcnlx
#define y mcnly
#define z mcnlz
#define vx mcnlvx
#define vy mcnlvy
#define vz mcnlvz
#define t mcnlt
#define sx mcnlsx
#define sy mcnlsy
#define sz mcnlsz
#define p mcnlp

#define mcabsorbComp mcabsorbCompchannel_3_analyzer_1_array_crystal_array_4
  STORE_NEUTRON(248,
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp);
  mcScattered=0;
  mcRestore=0;
  mcNCounter[248]++;
  mcPCounter[248] += p;
  mcP2Counter[248] += p*p;
#define mccompcurname  channel_3_analyzer_1_array_crystal_array_4
#define mccompcurtype  Union_box
#define mccompcurindex 248
#define loop_index mccchannel_3_analyzer_1_array_crystal_array_4_loop_index
#define this_box_volume mccchannel_3_analyzer_1_array_crystal_array_4_this_box_volume
#define global_geometry_element mccchannel_3_analyzer_1_array_crystal_array_4_global_geometry_element
#define this_box_storage mccchannel_3_analyzer_1_array_crystal_array_4_this_box_storage
{   /* Declarations of channel_3_analyzer_1_array_crystal_array_4=Union_box() SETTING parameters. */
char* material_string = mccchannel_3_analyzer_1_array_crystal_array_4_material_string;
MCNUM priority = mccchannel_3_analyzer_1_array_crystal_array_4_priority;
MCNUM xwidth = mccchannel_3_analyzer_1_array_crystal_array_4_xwidth;
MCNUM yheight = mccchannel_3_analyzer_1_array_crystal_array_4_yheight;
MCNUM zdepth = mccchannel_3_analyzer_1_array_crystal_array_4_zdepth;
MCNUM xwidth2 = mccchannel_3_analyzer_1_array_crystal_array_4_xwidth2;
MCNUM yheight2 = mccchannel_3_analyzer_1_array_crystal_array_4_yheight2;
MCNUM visualize = mccchannel_3_analyzer_1_array_crystal_array_4_visualize;
int target_index = mccchannel_3_analyzer_1_array_crystal_array_4_target_index;
MCNUM target_x = mccchannel_3_analyzer_1_array_crystal_array_4_target_x;
MCNUM target_y = mccchannel_3_analyzer_1_array_crystal_array_4_target_y;
MCNUM target_z = mccchannel_3_analyzer_1_array_crystal_array_4_target_z;
MCNUM focus_aw = mccchannel_3_analyzer_1_array_crystal_array_4_focus_aw;
MCNUM focus_ah = mccchannel_3_analyzer_1_array_crystal_array_4_focus_ah;
MCNUM focus_xw = mccchannel_3_analyzer_1_array_crystal_array_4_focus_xw;
MCNUM focus_xh = mccchannel_3_analyzer_1_array_crystal_array_4_focus_xh;
MCNUM focus_r = mccchannel_3_analyzer_1_array_crystal_array_4_focus_r;
MCNUM p_interact = mccchannel_3_analyzer_1_array_crystal_array_4_p_interact;
char* mask_string = mccchannel_3_analyzer_1_array_crystal_array_4_mask_string;
char* mask_setting = mccchannel_3_analyzer_1_array_crystal_array_4_mask_setting;
MCNUM number_of_activations = mccchannel_3_analyzer_1_array_crystal_array_4_number_of_activations;
}   /* End of channel_3_analyzer_1_array_crystal_array_4=Union_box() SETTING parameter declarations. */
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex
  /* Label for restoring  neutron */
  mcabsorbCompchannel_3_analyzer_1_array_crystal_array_4:
  if (RESTORE) /* restore if needed */
  { RESTORE_NEUTRON(248,
      mcnlx,
      mcnly,
      mcnlz,
      mcnlvx,
      mcnlvy,
      mcnlvz,
      mcnlt,
      mcnlsx,
      mcnlsy,
      mcnlsz,
      mcnlp); }
#undef mcabsorbComp
#undef p
#undef sz
#undef sy
#undef sx
#undef t
#undef vz
#undef vy
#undef vx
#undef z
#undef y
#undef x
  mcDEBUG_STATE(
mcnlx,
mcnly,
mcnlz,
mcnlvx,
mcnlvy,
mcnlvz,
mcnlt,
mcnlsx,
mcnlsy,
mcnlsz,
mcnlp)

  /* TRACE Component channel_3_analyzer_1_array_crystal_array_5 [249] */
  mccoordschange(mcposrchannel_3_analyzer_1_array_crystal_array_5, mcrotrchannel_3_analyzer_1_array_crystal_array_5,
    &mcnlx,
    &mcnly,
    &mcnlz,
    &mcnlvx,
    &mcnlvy,
    &mcnlvz,
    &mcnlsx,
    &mcnlsy,
    &mcnlsz);
  /* define label inside component channel_3_analyzer_1_array_crystal_array_5 (without coords transformations) */
  mcJumpTrace_channel_3_analyzer_1_array_crystal_array_5:
  SIG_MESSAGE("channel_3_analyzer_1_array_crystal_array_5 (Trace)");
  mcDEBUG_COMP("channel_3_analyzer_1_array_crystal_array_5")
  mcDEBUG_STATE(
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp)
#define x mcnlx
#define y mcnly
#define z mcnlz
#define vx mcnlvx
#define vy mcnlvy
#define vz mcnlvz
#define t mcnlt
#define sx mcnlsx
#define sy mcnlsy
#define sz mcnlsz
#define p mcnlp

#define mcabsorbComp mcabsorbCompchannel_3_analyzer_1_array_crystal_array_5
  STORE_NEUTRON(249,
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp);
  mcScattered=0;
  mcRestore=0;
  mcNCounter[249]++;
  mcPCounter[249] += p;
  mcP2Counter[249] += p*p;
#define mccompcurname  channel_3_analyzer_1_array_crystal_array_5
#define mccompcurtype  Union_box
#define mccompcurindex 249
#define loop_index mccchannel_3_analyzer_1_array_crystal_array_5_loop_index
#define this_box_volume mccchannel_3_analyzer_1_array_crystal_array_5_this_box_volume
#define global_geometry_element mccchannel_3_analyzer_1_array_crystal_array_5_global_geometry_element
#define this_box_storage mccchannel_3_analyzer_1_array_crystal_array_5_this_box_storage
{   /* Declarations of channel_3_analyzer_1_array_crystal_array_5=Union_box() SETTING parameters. */
char* material_string = mccchannel_3_analyzer_1_array_crystal_array_5_material_string;
MCNUM priority = mccchannel_3_analyzer_1_array_crystal_array_5_priority;
MCNUM xwidth = mccchannel_3_analyzer_1_array_crystal_array_5_xwidth;
MCNUM yheight = mccchannel_3_analyzer_1_array_crystal_array_5_yheight;
MCNUM zdepth = mccchannel_3_analyzer_1_array_crystal_array_5_zdepth;
MCNUM xwidth2 = mccchannel_3_analyzer_1_array_crystal_array_5_xwidth2;
MCNUM yheight2 = mccchannel_3_analyzer_1_array_crystal_array_5_yheight2;
MCNUM visualize = mccchannel_3_analyzer_1_array_crystal_array_5_visualize;
int target_index = mccchannel_3_analyzer_1_array_crystal_array_5_target_index;
MCNUM target_x = mccchannel_3_analyzer_1_array_crystal_array_5_target_x;
MCNUM target_y = mccchannel_3_analyzer_1_array_crystal_array_5_target_y;
MCNUM target_z = mccchannel_3_analyzer_1_array_crystal_array_5_target_z;
MCNUM focus_aw = mccchannel_3_analyzer_1_array_crystal_array_5_focus_aw;
MCNUM focus_ah = mccchannel_3_analyzer_1_array_crystal_array_5_focus_ah;
MCNUM focus_xw = mccchannel_3_analyzer_1_array_crystal_array_5_focus_xw;
MCNUM focus_xh = mccchannel_3_analyzer_1_array_crystal_array_5_focus_xh;
MCNUM focus_r = mccchannel_3_analyzer_1_array_crystal_array_5_focus_r;
MCNUM p_interact = mccchannel_3_analyzer_1_array_crystal_array_5_p_interact;
char* mask_string = mccchannel_3_analyzer_1_array_crystal_array_5_mask_string;
char* mask_setting = mccchannel_3_analyzer_1_array_crystal_array_5_mask_setting;
MCNUM number_of_activations = mccchannel_3_analyzer_1_array_crystal_array_5_number_of_activations;
}   /* End of channel_3_analyzer_1_array_crystal_array_5=Union_box() SETTING parameter declarations. */
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex
  /* Label for restoring  neutron */
  mcabsorbCompchannel_3_analyzer_1_array_crystal_array_5:
  if (RESTORE) /* restore if needed */
  { RESTORE_NEUTRON(249,
      mcnlx,
      mcnly,
      mcnlz,
      mcnlvx,
      mcnlvy,
      mcnlvz,
      mcnlt,
      mcnlsx,
      mcnlsy,
      mcnlsz,
      mcnlp); }
#undef mcabsorbComp
#undef p
#undef sz
#undef sy
#undef sx
#undef t
#undef vz
#undef vy
#undef vx
#undef z
#undef y
#undef x
  mcDEBUG_STATE(
mcnlx,
mcnly,
mcnlz,
mcnlvx,
mcnlvy,
mcnlvz,
mcnlt,
mcnlsx,
mcnlsy,
mcnlsz,
mcnlp)

  /* TRACE Component channel_3_analyzer_1_array_crystal_array_6 [250] */
  mccoordschange(mcposrchannel_3_analyzer_1_array_crystal_array_6, mcrotrchannel_3_analyzer_1_array_crystal_array_6,
    &mcnlx,
    &mcnly,
    &mcnlz,
    &mcnlvx,
    &mcnlvy,
    &mcnlvz,
    &mcnlsx,
    &mcnlsy,
    &mcnlsz);
  /* define label inside component channel_3_analyzer_1_array_crystal_array_6 (without coords transformations) */
  mcJumpTrace_channel_3_analyzer_1_array_crystal_array_6:
  SIG_MESSAGE("channel_3_analyzer_1_array_crystal_array_6 (Trace)");
  mcDEBUG_COMP("channel_3_analyzer_1_array_crystal_array_6")
  mcDEBUG_STATE(
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp)
#define x mcnlx
#define y mcnly
#define z mcnlz
#define vx mcnlvx
#define vy mcnlvy
#define vz mcnlvz
#define t mcnlt
#define sx mcnlsx
#define sy mcnlsy
#define sz mcnlsz
#define p mcnlp

#define mcabsorbComp mcabsorbCompchannel_3_analyzer_1_array_crystal_array_6
  STORE_NEUTRON(250,
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp);
  mcScattered=0;
  mcRestore=0;
  mcNCounter[250]++;
  mcPCounter[250] += p;
  mcP2Counter[250] += p*p;
#define mccompcurname  channel_3_analyzer_1_array_crystal_array_6
#define mccompcurtype  Union_box
#define mccompcurindex 250
#define loop_index mccchannel_3_analyzer_1_array_crystal_array_6_loop_index
#define this_box_volume mccchannel_3_analyzer_1_array_crystal_array_6_this_box_volume
#define global_geometry_element mccchannel_3_analyzer_1_array_crystal_array_6_global_geometry_element
#define this_box_storage mccchannel_3_analyzer_1_array_crystal_array_6_this_box_storage
{   /* Declarations of channel_3_analyzer_1_array_crystal_array_6=Union_box() SETTING parameters. */
char* material_string = mccchannel_3_analyzer_1_array_crystal_array_6_material_string;
MCNUM priority = mccchannel_3_analyzer_1_array_crystal_array_6_priority;
MCNUM xwidth = mccchannel_3_analyzer_1_array_crystal_array_6_xwidth;
MCNUM yheight = mccchannel_3_analyzer_1_array_crystal_array_6_yheight;
MCNUM zdepth = mccchannel_3_analyzer_1_array_crystal_array_6_zdepth;
MCNUM xwidth2 = mccchannel_3_analyzer_1_array_crystal_array_6_xwidth2;
MCNUM yheight2 = mccchannel_3_analyzer_1_array_crystal_array_6_yheight2;
MCNUM visualize = mccchannel_3_analyzer_1_array_crystal_array_6_visualize;
int target_index = mccchannel_3_analyzer_1_array_crystal_array_6_target_index;
MCNUM target_x = mccchannel_3_analyzer_1_array_crystal_array_6_target_x;
MCNUM target_y = mccchannel_3_analyzer_1_array_crystal_array_6_target_y;
MCNUM target_z = mccchannel_3_analyzer_1_array_crystal_array_6_target_z;
MCNUM focus_aw = mccchannel_3_analyzer_1_array_crystal_array_6_focus_aw;
MCNUM focus_ah = mccchannel_3_analyzer_1_array_crystal_array_6_focus_ah;
MCNUM focus_xw = mccchannel_3_analyzer_1_array_crystal_array_6_focus_xw;
MCNUM focus_xh = mccchannel_3_analyzer_1_array_crystal_array_6_focus_xh;
MCNUM focus_r = mccchannel_3_analyzer_1_array_crystal_array_6_focus_r;
MCNUM p_interact = mccchannel_3_analyzer_1_array_crystal_array_6_p_interact;
char* mask_string = mccchannel_3_analyzer_1_array_crystal_array_6_mask_string;
char* mask_setting = mccchannel_3_analyzer_1_array_crystal_array_6_mask_setting;
MCNUM number_of_activations = mccchannel_3_analyzer_1_array_crystal_array_6_number_of_activations;
}   /* End of channel_3_analyzer_1_array_crystal_array_6=Union_box() SETTING parameter declarations. */
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex
  /* Label for restoring  neutron */
  mcabsorbCompchannel_3_analyzer_1_array_crystal_array_6:
  if (RESTORE) /* restore if needed */
  { RESTORE_NEUTRON(250,
      mcnlx,
      mcnly,
      mcnlz,
      mcnlvx,
      mcnlvy,
      mcnlvz,
      mcnlt,
      mcnlsx,
      mcnlsy,
      mcnlsz,
      mcnlp); }
#undef mcabsorbComp
#undef p
#undef sz
#undef sy
#undef sx
#undef t
#undef vz
#undef vy
#undef vx
#undef z
#undef y
#undef x
  mcDEBUG_STATE(
mcnlx,
mcnly,
mcnlz,
mcnlvx,
mcnlvy,
mcnlvz,
mcnlt,
mcnlsx,
mcnlsy,
mcnlsz,
mcnlp)

  /* TRACE Component channel_3_analyzer_1_array_crystal_array_7 [251] */
  mccoordschange(mcposrchannel_3_analyzer_1_array_crystal_array_7, mcrotrchannel_3_analyzer_1_array_crystal_array_7,
    &mcnlx,
    &mcnly,
    &mcnlz,
    &mcnlvx,
    &mcnlvy,
    &mcnlvz,
    &mcnlsx,
    &mcnlsy,
    &mcnlsz);
  /* define label inside component channel_3_analyzer_1_array_crystal_array_7 (without coords transformations) */
  mcJumpTrace_channel_3_analyzer_1_array_crystal_array_7:
  SIG_MESSAGE("channel_3_analyzer_1_array_crystal_array_7 (Trace)");
  mcDEBUG_COMP("channel_3_analyzer_1_array_crystal_array_7")
  mcDEBUG_STATE(
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp)
#define x mcnlx
#define y mcnly
#define z mcnlz
#define vx mcnlvx
#define vy mcnlvy
#define vz mcnlvz
#define t mcnlt
#define sx mcnlsx
#define sy mcnlsy
#define sz mcnlsz
#define p mcnlp

#define mcabsorbComp mcabsorbCompchannel_3_analyzer_1_array_crystal_array_7
  STORE_NEUTRON(251,
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp);
  mcScattered=0;
  mcRestore=0;
  mcNCounter[251]++;
  mcPCounter[251] += p;
  mcP2Counter[251] += p*p;
#define mccompcurname  channel_3_analyzer_1_array_crystal_array_7
#define mccompcurtype  Union_box
#define mccompcurindex 251
#define loop_index mccchannel_3_analyzer_1_array_crystal_array_7_loop_index
#define this_box_volume mccchannel_3_analyzer_1_array_crystal_array_7_this_box_volume
#define global_geometry_element mccchannel_3_analyzer_1_array_crystal_array_7_global_geometry_element
#define this_box_storage mccchannel_3_analyzer_1_array_crystal_array_7_this_box_storage
{   /* Declarations of channel_3_analyzer_1_array_crystal_array_7=Union_box() SETTING parameters. */
char* material_string = mccchannel_3_analyzer_1_array_crystal_array_7_material_string;
MCNUM priority = mccchannel_3_analyzer_1_array_crystal_array_7_priority;
MCNUM xwidth = mccchannel_3_analyzer_1_array_crystal_array_7_xwidth;
MCNUM yheight = mccchannel_3_analyzer_1_array_crystal_array_7_yheight;
MCNUM zdepth = mccchannel_3_analyzer_1_array_crystal_array_7_zdepth;
MCNUM xwidth2 = mccchannel_3_analyzer_1_array_crystal_array_7_xwidth2;
MCNUM yheight2 = mccchannel_3_analyzer_1_array_crystal_array_7_yheight2;
MCNUM visualize = mccchannel_3_analyzer_1_array_crystal_array_7_visualize;
int target_index = mccchannel_3_analyzer_1_array_crystal_array_7_target_index;
MCNUM target_x = mccchannel_3_analyzer_1_array_crystal_array_7_target_x;
MCNUM target_y = mccchannel_3_analyzer_1_array_crystal_array_7_target_y;
MCNUM target_z = mccchannel_3_analyzer_1_array_crystal_array_7_target_z;
MCNUM focus_aw = mccchannel_3_analyzer_1_array_crystal_array_7_focus_aw;
MCNUM focus_ah = mccchannel_3_analyzer_1_array_crystal_array_7_focus_ah;
MCNUM focus_xw = mccchannel_3_analyzer_1_array_crystal_array_7_focus_xw;
MCNUM focus_xh = mccchannel_3_analyzer_1_array_crystal_array_7_focus_xh;
MCNUM focus_r = mccchannel_3_analyzer_1_array_crystal_array_7_focus_r;
MCNUM p_interact = mccchannel_3_analyzer_1_array_crystal_array_7_p_interact;
char* mask_string = mccchannel_3_analyzer_1_array_crystal_array_7_mask_string;
char* mask_setting = mccchannel_3_analyzer_1_array_crystal_array_7_mask_setting;
MCNUM number_of_activations = mccchannel_3_analyzer_1_array_crystal_array_7_number_of_activations;
}   /* End of channel_3_analyzer_1_array_crystal_array_7=Union_box() SETTING parameter declarations. */
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex
  /* Label for restoring  neutron */
  mcabsorbCompchannel_3_analyzer_1_array_crystal_array_7:
  if (RESTORE) /* restore if needed */
  { RESTORE_NEUTRON(251,
      mcnlx,
      mcnly,
      mcnlz,
      mcnlvx,
      mcnlvy,
      mcnlvz,
      mcnlt,
      mcnlsx,
      mcnlsy,
      mcnlsz,
      mcnlp); }
#undef mcabsorbComp
#undef p
#undef sz
#undef sy
#undef sx
#undef t
#undef vz
#undef vy
#undef vx
#undef z
#undef y
#undef x
  mcDEBUG_STATE(
mcnlx,
mcnly,
mcnlz,
mcnlvx,
mcnlvy,
mcnlvz,
mcnlt,
mcnlsx,
mcnlsy,
mcnlsz,
mcnlp)

  /* TRACE Component channel_3_analyzer_1_array_crystal_array_8 [252] */
  mccoordschange(mcposrchannel_3_analyzer_1_array_crystal_array_8, mcrotrchannel_3_analyzer_1_array_crystal_array_8,
    &mcnlx,
    &mcnly,
    &mcnlz,
    &mcnlvx,
    &mcnlvy,
    &mcnlvz,
    &mcnlsx,
    &mcnlsy,
    &mcnlsz);
  /* define label inside component channel_3_analyzer_1_array_crystal_array_8 (without coords transformations) */
  mcJumpTrace_channel_3_analyzer_1_array_crystal_array_8:
  SIG_MESSAGE("channel_3_analyzer_1_array_crystal_array_8 (Trace)");
  mcDEBUG_COMP("channel_3_analyzer_1_array_crystal_array_8")
  mcDEBUG_STATE(
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp)
#define x mcnlx
#define y mcnly
#define z mcnlz
#define vx mcnlvx
#define vy mcnlvy
#define vz mcnlvz
#define t mcnlt
#define sx mcnlsx
#define sy mcnlsy
#define sz mcnlsz
#define p mcnlp

#define mcabsorbComp mcabsorbCompchannel_3_analyzer_1_array_crystal_array_8
  STORE_NEUTRON(252,
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp);
  mcScattered=0;
  mcRestore=0;
  mcNCounter[252]++;
  mcPCounter[252] += p;
  mcP2Counter[252] += p*p;
#define mccompcurname  channel_3_analyzer_1_array_crystal_array_8
#define mccompcurtype  Union_box
#define mccompcurindex 252
#define loop_index mccchannel_3_analyzer_1_array_crystal_array_8_loop_index
#define this_box_volume mccchannel_3_analyzer_1_array_crystal_array_8_this_box_volume
#define global_geometry_element mccchannel_3_analyzer_1_array_crystal_array_8_global_geometry_element
#define this_box_storage mccchannel_3_analyzer_1_array_crystal_array_8_this_box_storage
{   /* Declarations of channel_3_analyzer_1_array_crystal_array_8=Union_box() SETTING parameters. */
char* material_string = mccchannel_3_analyzer_1_array_crystal_array_8_material_string;
MCNUM priority = mccchannel_3_analyzer_1_array_crystal_array_8_priority;
MCNUM xwidth = mccchannel_3_analyzer_1_array_crystal_array_8_xwidth;
MCNUM yheight = mccchannel_3_analyzer_1_array_crystal_array_8_yheight;
MCNUM zdepth = mccchannel_3_analyzer_1_array_crystal_array_8_zdepth;
MCNUM xwidth2 = mccchannel_3_analyzer_1_array_crystal_array_8_xwidth2;
MCNUM yheight2 = mccchannel_3_analyzer_1_array_crystal_array_8_yheight2;
MCNUM visualize = mccchannel_3_analyzer_1_array_crystal_array_8_visualize;
int target_index = mccchannel_3_analyzer_1_array_crystal_array_8_target_index;
MCNUM target_x = mccchannel_3_analyzer_1_array_crystal_array_8_target_x;
MCNUM target_y = mccchannel_3_analyzer_1_array_crystal_array_8_target_y;
MCNUM target_z = mccchannel_3_analyzer_1_array_crystal_array_8_target_z;
MCNUM focus_aw = mccchannel_3_analyzer_1_array_crystal_array_8_focus_aw;
MCNUM focus_ah = mccchannel_3_analyzer_1_array_crystal_array_8_focus_ah;
MCNUM focus_xw = mccchannel_3_analyzer_1_array_crystal_array_8_focus_xw;
MCNUM focus_xh = mccchannel_3_analyzer_1_array_crystal_array_8_focus_xh;
MCNUM focus_r = mccchannel_3_analyzer_1_array_crystal_array_8_focus_r;
MCNUM p_interact = mccchannel_3_analyzer_1_array_crystal_array_8_p_interact;
char* mask_string = mccchannel_3_analyzer_1_array_crystal_array_8_mask_string;
char* mask_setting = mccchannel_3_analyzer_1_array_crystal_array_8_mask_setting;
MCNUM number_of_activations = mccchannel_3_analyzer_1_array_crystal_array_8_number_of_activations;
}   /* End of channel_3_analyzer_1_array_crystal_array_8=Union_box() SETTING parameter declarations. */
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex
  /* Label for restoring  neutron */
  mcabsorbCompchannel_3_analyzer_1_array_crystal_array_8:
  if (RESTORE) /* restore if needed */
  { RESTORE_NEUTRON(252,
      mcnlx,
      mcnly,
      mcnlz,
      mcnlvx,
      mcnlvy,
      mcnlvz,
      mcnlt,
      mcnlsx,
      mcnlsy,
      mcnlsz,
      mcnlp); }
#undef mcabsorbComp
#undef p
#undef sz
#undef sy
#undef sx
#undef t
#undef vz
#undef vy
#undef vx
#undef z
#undef y
#undef x
  mcDEBUG_STATE(
mcnlx,
mcnly,
mcnlz,
mcnlvx,
mcnlvy,
mcnlvz,
mcnlt,
mcnlsx,
mcnlsy,
mcnlsz,
mcnlp)

  /* TRACE Component channel_3_analyzer_2_center [253] */
  mccoordschange(mcposrchannel_3_analyzer_2_center, mcrotrchannel_3_analyzer_2_center,
    &mcnlx,
    &mcnly,
    &mcnlz,
    &mcnlvx,
    &mcnlvy,
    &mcnlvz,
    &mcnlsx,
    &mcnlsy,
    &mcnlsz);
  /* define label inside component channel_3_analyzer_2_center (without coords transformations) */
  mcJumpTrace_channel_3_analyzer_2_center:
  SIG_MESSAGE("channel_3_analyzer_2_center (Trace)");
  mcDEBUG_COMP("channel_3_analyzer_2_center")
  mcDEBUG_STATE(
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp)
#define x mcnlx
#define y mcnly
#define z mcnlz
#define vx mcnlvx
#define vy mcnlvy
#define vz mcnlvz
#define t mcnlt
#define sx mcnlsx
#define sy mcnlsy
#define sz mcnlsz
#define p mcnlp

#define mcabsorbComp mcabsorbCompchannel_3_analyzer_2_center
  STORE_NEUTRON(253,
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp);
  mcScattered=0;
  mcRestore=0;
  mcNCounter[253]++;
  mcPCounter[253] += p;
  mcP2Counter[253] += p*p;
#define mccompcurname  channel_3_analyzer_2_center
#define mccompcurtype  Arm
#define mccompcurindex 253
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex
  /* Label for restoring  neutron */
  mcabsorbCompchannel_3_analyzer_2_center:
  if (RESTORE) /* restore if needed */
  { RESTORE_NEUTRON(253,
      mcnlx,
      mcnly,
      mcnlz,
      mcnlvx,
      mcnlvy,
      mcnlvz,
      mcnlt,
      mcnlsx,
      mcnlsy,
      mcnlsz,
      mcnlp); }
#undef mcabsorbComp
#undef p
#undef sz
#undef sy
#undef sx
#undef t
#undef vz
#undef vy
#undef vx
#undef z
#undef y
#undef x
  mcDEBUG_STATE(
mcnlx,
mcnly,
mcnlz,
mcnlvx,
mcnlvy,
mcnlvz,
mcnlt,
mcnlsx,
mcnlsy,
mcnlsz,
mcnlp)

  /* TRACE Component channel_3_analyzer_2_rotated [254] */
  mccoordschange(mcposrchannel_3_analyzer_2_rotated, mcrotrchannel_3_analyzer_2_rotated,
    &mcnlx,
    &mcnly,
    &mcnlz,
    &mcnlvx,
    &mcnlvy,
    &mcnlvz,
    &mcnlsx,
    &mcnlsy,
    &mcnlsz);
  /* define label inside component channel_3_analyzer_2_rotated (without coords transformations) */
  mcJumpTrace_channel_3_analyzer_2_rotated:
  SIG_MESSAGE("channel_3_analyzer_2_rotated (Trace)");
  mcDEBUG_COMP("channel_3_analyzer_2_rotated")
  mcDEBUG_STATE(
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp)
#define x mcnlx
#define y mcnly
#define z mcnlz
#define vx mcnlvx
#define vy mcnlvy
#define vz mcnlvz
#define t mcnlt
#define sx mcnlsx
#define sy mcnlsy
#define sz mcnlsz
#define p mcnlp

#define mcabsorbComp mcabsorbCompchannel_3_analyzer_2_rotated
  STORE_NEUTRON(254,
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp);
  mcScattered=0;
  mcRestore=0;
  mcNCounter[254]++;
  mcPCounter[254] += p;
  mcP2Counter[254] += p*p;
#define mccompcurname  channel_3_analyzer_2_rotated
#define mccompcurtype  Arm
#define mccompcurindex 254
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex
  /* Label for restoring  neutron */
  mcabsorbCompchannel_3_analyzer_2_rotated:
  if (RESTORE) /* restore if needed */
  { RESTORE_NEUTRON(254,
      mcnlx,
      mcnly,
      mcnlz,
      mcnlvx,
      mcnlvy,
      mcnlvz,
      mcnlt,
      mcnlsx,
      mcnlsy,
      mcnlsz,
      mcnlp); }
#undef mcabsorbComp
#undef p
#undef sz
#undef sy
#undef sx
#undef t
#undef vz
#undef vy
#undef vx
#undef z
#undef y
#undef x
  mcDEBUG_STATE(
mcnlx,
mcnly,
mcnlz,
mcnlvx,
mcnlvy,
mcnlvz,
mcnlt,
mcnlsx,
mcnlsy,
mcnlsz,
mcnlp)

  /* TRACE Component channel_3_analyzer_2_array_crystal_array_0 [255] */
  mccoordschange(mcposrchannel_3_analyzer_2_array_crystal_array_0, mcrotrchannel_3_analyzer_2_array_crystal_array_0,
    &mcnlx,
    &mcnly,
    &mcnlz,
    &mcnlvx,
    &mcnlvy,
    &mcnlvz,
    &mcnlsx,
    &mcnlsy,
    &mcnlsz);
  /* define label inside component channel_3_analyzer_2_array_crystal_array_0 (without coords transformations) */
  mcJumpTrace_channel_3_analyzer_2_array_crystal_array_0:
  SIG_MESSAGE("channel_3_analyzer_2_array_crystal_array_0 (Trace)");
  mcDEBUG_COMP("channel_3_analyzer_2_array_crystal_array_0")
  mcDEBUG_STATE(
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp)
#define x mcnlx
#define y mcnly
#define z mcnlz
#define vx mcnlvx
#define vy mcnlvy
#define vz mcnlvz
#define t mcnlt
#define sx mcnlsx
#define sy mcnlsy
#define sz mcnlsz
#define p mcnlp

#define mcabsorbComp mcabsorbCompchannel_3_analyzer_2_array_crystal_array_0
  STORE_NEUTRON(255,
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp);
  mcScattered=0;
  mcRestore=0;
  mcNCounter[255]++;
  mcPCounter[255] += p;
  mcP2Counter[255] += p*p;
#define mccompcurname  channel_3_analyzer_2_array_crystal_array_0
#define mccompcurtype  Union_box
#define mccompcurindex 255
#define loop_index mccchannel_3_analyzer_2_array_crystal_array_0_loop_index
#define this_box_volume mccchannel_3_analyzer_2_array_crystal_array_0_this_box_volume
#define global_geometry_element mccchannel_3_analyzer_2_array_crystal_array_0_global_geometry_element
#define this_box_storage mccchannel_3_analyzer_2_array_crystal_array_0_this_box_storage
{   /* Declarations of channel_3_analyzer_2_array_crystal_array_0=Union_box() SETTING parameters. */
char* material_string = mccchannel_3_analyzer_2_array_crystal_array_0_material_string;
MCNUM priority = mccchannel_3_analyzer_2_array_crystal_array_0_priority;
MCNUM xwidth = mccchannel_3_analyzer_2_array_crystal_array_0_xwidth;
MCNUM yheight = mccchannel_3_analyzer_2_array_crystal_array_0_yheight;
MCNUM zdepth = mccchannel_3_analyzer_2_array_crystal_array_0_zdepth;
MCNUM xwidth2 = mccchannel_3_analyzer_2_array_crystal_array_0_xwidth2;
MCNUM yheight2 = mccchannel_3_analyzer_2_array_crystal_array_0_yheight2;
MCNUM visualize = mccchannel_3_analyzer_2_array_crystal_array_0_visualize;
int target_index = mccchannel_3_analyzer_2_array_crystal_array_0_target_index;
MCNUM target_x = mccchannel_3_analyzer_2_array_crystal_array_0_target_x;
MCNUM target_y = mccchannel_3_analyzer_2_array_crystal_array_0_target_y;
MCNUM target_z = mccchannel_3_analyzer_2_array_crystal_array_0_target_z;
MCNUM focus_aw = mccchannel_3_analyzer_2_array_crystal_array_0_focus_aw;
MCNUM focus_ah = mccchannel_3_analyzer_2_array_crystal_array_0_focus_ah;
MCNUM focus_xw = mccchannel_3_analyzer_2_array_crystal_array_0_focus_xw;
MCNUM focus_xh = mccchannel_3_analyzer_2_array_crystal_array_0_focus_xh;
MCNUM focus_r = mccchannel_3_analyzer_2_array_crystal_array_0_focus_r;
MCNUM p_interact = mccchannel_3_analyzer_2_array_crystal_array_0_p_interact;
char* mask_string = mccchannel_3_analyzer_2_array_crystal_array_0_mask_string;
char* mask_setting = mccchannel_3_analyzer_2_array_crystal_array_0_mask_setting;
MCNUM number_of_activations = mccchannel_3_analyzer_2_array_crystal_array_0_number_of_activations;
}   /* End of channel_3_analyzer_2_array_crystal_array_0=Union_box() SETTING parameter declarations. */
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex
  /* Label for restoring  neutron */
  mcabsorbCompchannel_3_analyzer_2_array_crystal_array_0:
  if (RESTORE) /* restore if needed */
  { RESTORE_NEUTRON(255,
      mcnlx,
      mcnly,
      mcnlz,
      mcnlvx,
      mcnlvy,
      mcnlvz,
      mcnlt,
      mcnlsx,
      mcnlsy,
      mcnlsz,
      mcnlp); }
#undef mcabsorbComp
#undef p
#undef sz
#undef sy
#undef sx
#undef t
#undef vz
#undef vy
#undef vx
#undef z
#undef y
#undef x
  mcDEBUG_STATE(
mcnlx,
mcnly,
mcnlz,
mcnlvx,
mcnlvy,
mcnlvz,
mcnlt,
mcnlsx,
mcnlsy,
mcnlsz,
mcnlp)

  /* TRACE Component channel_3_analyzer_2_array_crystal_array_1 [256] */
  mccoordschange(mcposrchannel_3_analyzer_2_array_crystal_array_1, mcrotrchannel_3_analyzer_2_array_crystal_array_1,
    &mcnlx,
    &mcnly,
    &mcnlz,
    &mcnlvx,
    &mcnlvy,
    &mcnlvz,
    &mcnlsx,
    &mcnlsy,
    &mcnlsz);
  /* define label inside component channel_3_analyzer_2_array_crystal_array_1 (without coords transformations) */
  mcJumpTrace_channel_3_analyzer_2_array_crystal_array_1:
  SIG_MESSAGE("channel_3_analyzer_2_array_crystal_array_1 (Trace)");
  mcDEBUG_COMP("channel_3_analyzer_2_array_crystal_array_1")
  mcDEBUG_STATE(
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp)
#define x mcnlx
#define y mcnly
#define z mcnlz
#define vx mcnlvx
#define vy mcnlvy
#define vz mcnlvz
#define t mcnlt
#define sx mcnlsx
#define sy mcnlsy
#define sz mcnlsz
#define p mcnlp

#define mcabsorbComp mcabsorbCompchannel_3_analyzer_2_array_crystal_array_1
  STORE_NEUTRON(256,
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp);
  mcScattered=0;
  mcRestore=0;
  mcNCounter[256]++;
  mcPCounter[256] += p;
  mcP2Counter[256] += p*p;
#define mccompcurname  channel_3_analyzer_2_array_crystal_array_1
#define mccompcurtype  Union_box
#define mccompcurindex 256
#define loop_index mccchannel_3_analyzer_2_array_crystal_array_1_loop_index
#define this_box_volume mccchannel_3_analyzer_2_array_crystal_array_1_this_box_volume
#define global_geometry_element mccchannel_3_analyzer_2_array_crystal_array_1_global_geometry_element
#define this_box_storage mccchannel_3_analyzer_2_array_crystal_array_1_this_box_storage
{   /* Declarations of channel_3_analyzer_2_array_crystal_array_1=Union_box() SETTING parameters. */
char* material_string = mccchannel_3_analyzer_2_array_crystal_array_1_material_string;
MCNUM priority = mccchannel_3_analyzer_2_array_crystal_array_1_priority;
MCNUM xwidth = mccchannel_3_analyzer_2_array_crystal_array_1_xwidth;
MCNUM yheight = mccchannel_3_analyzer_2_array_crystal_array_1_yheight;
MCNUM zdepth = mccchannel_3_analyzer_2_array_crystal_array_1_zdepth;
MCNUM xwidth2 = mccchannel_3_analyzer_2_array_crystal_array_1_xwidth2;
MCNUM yheight2 = mccchannel_3_analyzer_2_array_crystal_array_1_yheight2;
MCNUM visualize = mccchannel_3_analyzer_2_array_crystal_array_1_visualize;
int target_index = mccchannel_3_analyzer_2_array_crystal_array_1_target_index;
MCNUM target_x = mccchannel_3_analyzer_2_array_crystal_array_1_target_x;
MCNUM target_y = mccchannel_3_analyzer_2_array_crystal_array_1_target_y;
MCNUM target_z = mccchannel_3_analyzer_2_array_crystal_array_1_target_z;
MCNUM focus_aw = mccchannel_3_analyzer_2_array_crystal_array_1_focus_aw;
MCNUM focus_ah = mccchannel_3_analyzer_2_array_crystal_array_1_focus_ah;
MCNUM focus_xw = mccchannel_3_analyzer_2_array_crystal_array_1_focus_xw;
MCNUM focus_xh = mccchannel_3_analyzer_2_array_crystal_array_1_focus_xh;
MCNUM focus_r = mccchannel_3_analyzer_2_array_crystal_array_1_focus_r;
MCNUM p_interact = mccchannel_3_analyzer_2_array_crystal_array_1_p_interact;
char* mask_string = mccchannel_3_analyzer_2_array_crystal_array_1_mask_string;
char* mask_setting = mccchannel_3_analyzer_2_array_crystal_array_1_mask_setting;
MCNUM number_of_activations = mccchannel_3_analyzer_2_array_crystal_array_1_number_of_activations;
}   /* End of channel_3_analyzer_2_array_crystal_array_1=Union_box() SETTING parameter declarations. */
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex
  /* Label for restoring  neutron */
  mcabsorbCompchannel_3_analyzer_2_array_crystal_array_1:
  if (RESTORE) /* restore if needed */
  { RESTORE_NEUTRON(256,
      mcnlx,
      mcnly,
      mcnlz,
      mcnlvx,
      mcnlvy,
      mcnlvz,
      mcnlt,
      mcnlsx,
      mcnlsy,
      mcnlsz,
      mcnlp); }
#undef mcabsorbComp
#undef p
#undef sz
#undef sy
#undef sx
#undef t
#undef vz
#undef vy
#undef vx
#undef z
#undef y
#undef x
  mcDEBUG_STATE(
mcnlx,
mcnly,
mcnlz,
mcnlvx,
mcnlvy,
mcnlvz,
mcnlt,
mcnlsx,
mcnlsy,
mcnlsz,
mcnlp)

  /* TRACE Component channel_3_analyzer_2_array_crystal_array_2 [257] */
  mccoordschange(mcposrchannel_3_analyzer_2_array_crystal_array_2, mcrotrchannel_3_analyzer_2_array_crystal_array_2,
    &mcnlx,
    &mcnly,
    &mcnlz,
    &mcnlvx,
    &mcnlvy,
    &mcnlvz,
    &mcnlsx,
    &mcnlsy,
    &mcnlsz);
  /* define label inside component channel_3_analyzer_2_array_crystal_array_2 (without coords transformations) */
  mcJumpTrace_channel_3_analyzer_2_array_crystal_array_2:
  SIG_MESSAGE("channel_3_analyzer_2_array_crystal_array_2 (Trace)");
  mcDEBUG_COMP("channel_3_analyzer_2_array_crystal_array_2")
  mcDEBUG_STATE(
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp)
#define x mcnlx
#define y mcnly
#define z mcnlz
#define vx mcnlvx
#define vy mcnlvy
#define vz mcnlvz
#define t mcnlt
#define sx mcnlsx
#define sy mcnlsy
#define sz mcnlsz
#define p mcnlp

#define mcabsorbComp mcabsorbCompchannel_3_analyzer_2_array_crystal_array_2
  STORE_NEUTRON(257,
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp);
  mcScattered=0;
  mcRestore=0;
  mcNCounter[257]++;
  mcPCounter[257] += p;
  mcP2Counter[257] += p*p;
#define mccompcurname  channel_3_analyzer_2_array_crystal_array_2
#define mccompcurtype  Union_box
#define mccompcurindex 257
#define loop_index mccchannel_3_analyzer_2_array_crystal_array_2_loop_index
#define this_box_volume mccchannel_3_analyzer_2_array_crystal_array_2_this_box_volume
#define global_geometry_element mccchannel_3_analyzer_2_array_crystal_array_2_global_geometry_element
#define this_box_storage mccchannel_3_analyzer_2_array_crystal_array_2_this_box_storage
{   /* Declarations of channel_3_analyzer_2_array_crystal_array_2=Union_box() SETTING parameters. */
char* material_string = mccchannel_3_analyzer_2_array_crystal_array_2_material_string;
MCNUM priority = mccchannel_3_analyzer_2_array_crystal_array_2_priority;
MCNUM xwidth = mccchannel_3_analyzer_2_array_crystal_array_2_xwidth;
MCNUM yheight = mccchannel_3_analyzer_2_array_crystal_array_2_yheight;
MCNUM zdepth = mccchannel_3_analyzer_2_array_crystal_array_2_zdepth;
MCNUM xwidth2 = mccchannel_3_analyzer_2_array_crystal_array_2_xwidth2;
MCNUM yheight2 = mccchannel_3_analyzer_2_array_crystal_array_2_yheight2;
MCNUM visualize = mccchannel_3_analyzer_2_array_crystal_array_2_visualize;
int target_index = mccchannel_3_analyzer_2_array_crystal_array_2_target_index;
MCNUM target_x = mccchannel_3_analyzer_2_array_crystal_array_2_target_x;
MCNUM target_y = mccchannel_3_analyzer_2_array_crystal_array_2_target_y;
MCNUM target_z = mccchannel_3_analyzer_2_array_crystal_array_2_target_z;
MCNUM focus_aw = mccchannel_3_analyzer_2_array_crystal_array_2_focus_aw;
MCNUM focus_ah = mccchannel_3_analyzer_2_array_crystal_array_2_focus_ah;
MCNUM focus_xw = mccchannel_3_analyzer_2_array_crystal_array_2_focus_xw;
MCNUM focus_xh = mccchannel_3_analyzer_2_array_crystal_array_2_focus_xh;
MCNUM focus_r = mccchannel_3_analyzer_2_array_crystal_array_2_focus_r;
MCNUM p_interact = mccchannel_3_analyzer_2_array_crystal_array_2_p_interact;
char* mask_string = mccchannel_3_analyzer_2_array_crystal_array_2_mask_string;
char* mask_setting = mccchannel_3_analyzer_2_array_crystal_array_2_mask_setting;
MCNUM number_of_activations = mccchannel_3_analyzer_2_array_crystal_array_2_number_of_activations;
}   /* End of channel_3_analyzer_2_array_crystal_array_2=Union_box() SETTING parameter declarations. */
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex
  /* Label for restoring  neutron */
  mcabsorbCompchannel_3_analyzer_2_array_crystal_array_2:
  if (RESTORE) /* restore if needed */
  { RESTORE_NEUTRON(257,
      mcnlx,
      mcnly,
      mcnlz,
      mcnlvx,
      mcnlvy,
      mcnlvz,
      mcnlt,
      mcnlsx,
      mcnlsy,
      mcnlsz,
      mcnlp); }
#undef mcabsorbComp
#undef p
#undef sz
#undef sy
#undef sx
#undef t
#undef vz
#undef vy
#undef vx
#undef z
#undef y
#undef x
  mcDEBUG_STATE(
mcnlx,
mcnly,
mcnlz,
mcnlvx,
mcnlvy,
mcnlvz,
mcnlt,
mcnlsx,
mcnlsy,
mcnlsz,
mcnlp)

  /* TRACE Component channel_3_analyzer_2_array_crystal_array_3 [258] */
  mccoordschange(mcposrchannel_3_analyzer_2_array_crystal_array_3, mcrotrchannel_3_analyzer_2_array_crystal_array_3,
    &mcnlx,
    &mcnly,
    &mcnlz,
    &mcnlvx,
    &mcnlvy,
    &mcnlvz,
    &mcnlsx,
    &mcnlsy,
    &mcnlsz);
  /* define label inside component channel_3_analyzer_2_array_crystal_array_3 (without coords transformations) */
  mcJumpTrace_channel_3_analyzer_2_array_crystal_array_3:
  SIG_MESSAGE("channel_3_analyzer_2_array_crystal_array_3 (Trace)");
  mcDEBUG_COMP("channel_3_analyzer_2_array_crystal_array_3")
  mcDEBUG_STATE(
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp)
#define x mcnlx
#define y mcnly
#define z mcnlz
#define vx mcnlvx
#define vy mcnlvy
#define vz mcnlvz
#define t mcnlt
#define sx mcnlsx
#define sy mcnlsy
#define sz mcnlsz
#define p mcnlp

#define mcabsorbComp mcabsorbCompchannel_3_analyzer_2_array_crystal_array_3
  STORE_NEUTRON(258,
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp);
  mcScattered=0;
  mcRestore=0;
  mcNCounter[258]++;
  mcPCounter[258] += p;
  mcP2Counter[258] += p*p;
#define mccompcurname  channel_3_analyzer_2_array_crystal_array_3
#define mccompcurtype  Union_box
#define mccompcurindex 258
#define loop_index mccchannel_3_analyzer_2_array_crystal_array_3_loop_index
#define this_box_volume mccchannel_3_analyzer_2_array_crystal_array_3_this_box_volume
#define global_geometry_element mccchannel_3_analyzer_2_array_crystal_array_3_global_geometry_element
#define this_box_storage mccchannel_3_analyzer_2_array_crystal_array_3_this_box_storage
{   /* Declarations of channel_3_analyzer_2_array_crystal_array_3=Union_box() SETTING parameters. */
char* material_string = mccchannel_3_analyzer_2_array_crystal_array_3_material_string;
MCNUM priority = mccchannel_3_analyzer_2_array_crystal_array_3_priority;
MCNUM xwidth = mccchannel_3_analyzer_2_array_crystal_array_3_xwidth;
MCNUM yheight = mccchannel_3_analyzer_2_array_crystal_array_3_yheight;
MCNUM zdepth = mccchannel_3_analyzer_2_array_crystal_array_3_zdepth;
MCNUM xwidth2 = mccchannel_3_analyzer_2_array_crystal_array_3_xwidth2;
MCNUM yheight2 = mccchannel_3_analyzer_2_array_crystal_array_3_yheight2;
MCNUM visualize = mccchannel_3_analyzer_2_array_crystal_array_3_visualize;
int target_index = mccchannel_3_analyzer_2_array_crystal_array_3_target_index;
MCNUM target_x = mccchannel_3_analyzer_2_array_crystal_array_3_target_x;
MCNUM target_y = mccchannel_3_analyzer_2_array_crystal_array_3_target_y;
MCNUM target_z = mccchannel_3_analyzer_2_array_crystal_array_3_target_z;
MCNUM focus_aw = mccchannel_3_analyzer_2_array_crystal_array_3_focus_aw;
MCNUM focus_ah = mccchannel_3_analyzer_2_array_crystal_array_3_focus_ah;
MCNUM focus_xw = mccchannel_3_analyzer_2_array_crystal_array_3_focus_xw;
MCNUM focus_xh = mccchannel_3_analyzer_2_array_crystal_array_3_focus_xh;
MCNUM focus_r = mccchannel_3_analyzer_2_array_crystal_array_3_focus_r;
MCNUM p_interact = mccchannel_3_analyzer_2_array_crystal_array_3_p_interact;
char* mask_string = mccchannel_3_analyzer_2_array_crystal_array_3_mask_string;
char* mask_setting = mccchannel_3_analyzer_2_array_crystal_array_3_mask_setting;
MCNUM number_of_activations = mccchannel_3_analyzer_2_array_crystal_array_3_number_of_activations;
}   /* End of channel_3_analyzer_2_array_crystal_array_3=Union_box() SETTING parameter declarations. */
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex
  /* Label for restoring  neutron */
  mcabsorbCompchannel_3_analyzer_2_array_crystal_array_3:
  if (RESTORE) /* restore if needed */
  { RESTORE_NEUTRON(258,
      mcnlx,
      mcnly,
      mcnlz,
      mcnlvx,
      mcnlvy,
      mcnlvz,
      mcnlt,
      mcnlsx,
      mcnlsy,
      mcnlsz,
      mcnlp); }
#undef mcabsorbComp
#undef p
#undef sz
#undef sy
#undef sx
#undef t
#undef vz
#undef vy
#undef vx
#undef z
#undef y
#undef x
  mcDEBUG_STATE(
mcnlx,
mcnly,
mcnlz,
mcnlvx,
mcnlvy,
mcnlvz,
mcnlt,
mcnlsx,
mcnlsy,
mcnlsz,
mcnlp)

  /* TRACE Component channel_3_analyzer_2_array_crystal_array_4 [259] */
  mccoordschange(mcposrchannel_3_analyzer_2_array_crystal_array_4, mcrotrchannel_3_analyzer_2_array_crystal_array_4,
    &mcnlx,
    &mcnly,
    &mcnlz,
    &mcnlvx,
    &mcnlvy,
    &mcnlvz,
    &mcnlsx,
    &mcnlsy,
    &mcnlsz);
  /* define label inside component channel_3_analyzer_2_array_crystal_array_4 (without coords transformations) */
  mcJumpTrace_channel_3_analyzer_2_array_crystal_array_4:
  SIG_MESSAGE("channel_3_analyzer_2_array_crystal_array_4 (Trace)");
  mcDEBUG_COMP("channel_3_analyzer_2_array_crystal_array_4")
  mcDEBUG_STATE(
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp)
#define x mcnlx
#define y mcnly
#define z mcnlz
#define vx mcnlvx
#define vy mcnlvy
#define vz mcnlvz
#define t mcnlt
#define sx mcnlsx
#define sy mcnlsy
#define sz mcnlsz
#define p mcnlp

#define mcabsorbComp mcabsorbCompchannel_3_analyzer_2_array_crystal_array_4
  STORE_NEUTRON(259,
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp);
  mcScattered=0;
  mcRestore=0;
  mcNCounter[259]++;
  mcPCounter[259] += p;
  mcP2Counter[259] += p*p;
#define mccompcurname  channel_3_analyzer_2_array_crystal_array_4
#define mccompcurtype  Union_box
#define mccompcurindex 259
#define loop_index mccchannel_3_analyzer_2_array_crystal_array_4_loop_index
#define this_box_volume mccchannel_3_analyzer_2_array_crystal_array_4_this_box_volume
#define global_geometry_element mccchannel_3_analyzer_2_array_crystal_array_4_global_geometry_element
#define this_box_storage mccchannel_3_analyzer_2_array_crystal_array_4_this_box_storage
{   /* Declarations of channel_3_analyzer_2_array_crystal_array_4=Union_box() SETTING parameters. */
char* material_string = mccchannel_3_analyzer_2_array_crystal_array_4_material_string;
MCNUM priority = mccchannel_3_analyzer_2_array_crystal_array_4_priority;
MCNUM xwidth = mccchannel_3_analyzer_2_array_crystal_array_4_xwidth;
MCNUM yheight = mccchannel_3_analyzer_2_array_crystal_array_4_yheight;
MCNUM zdepth = mccchannel_3_analyzer_2_array_crystal_array_4_zdepth;
MCNUM xwidth2 = mccchannel_3_analyzer_2_array_crystal_array_4_xwidth2;
MCNUM yheight2 = mccchannel_3_analyzer_2_array_crystal_array_4_yheight2;
MCNUM visualize = mccchannel_3_analyzer_2_array_crystal_array_4_visualize;
int target_index = mccchannel_3_analyzer_2_array_crystal_array_4_target_index;
MCNUM target_x = mccchannel_3_analyzer_2_array_crystal_array_4_target_x;
MCNUM target_y = mccchannel_3_analyzer_2_array_crystal_array_4_target_y;
MCNUM target_z = mccchannel_3_analyzer_2_array_crystal_array_4_target_z;
MCNUM focus_aw = mccchannel_3_analyzer_2_array_crystal_array_4_focus_aw;
MCNUM focus_ah = mccchannel_3_analyzer_2_array_crystal_array_4_focus_ah;
MCNUM focus_xw = mccchannel_3_analyzer_2_array_crystal_array_4_focus_xw;
MCNUM focus_xh = mccchannel_3_analyzer_2_array_crystal_array_4_focus_xh;
MCNUM focus_r = mccchannel_3_analyzer_2_array_crystal_array_4_focus_r;
MCNUM p_interact = mccchannel_3_analyzer_2_array_crystal_array_4_p_interact;
char* mask_string = mccchannel_3_analyzer_2_array_crystal_array_4_mask_string;
char* mask_setting = mccchannel_3_analyzer_2_array_crystal_array_4_mask_setting;
MCNUM number_of_activations = mccchannel_3_analyzer_2_array_crystal_array_4_number_of_activations;
}   /* End of channel_3_analyzer_2_array_crystal_array_4=Union_box() SETTING parameter declarations. */
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex
  /* Label for restoring  neutron */
  mcabsorbCompchannel_3_analyzer_2_array_crystal_array_4:
  if (RESTORE) /* restore if needed */
  { RESTORE_NEUTRON(259,
      mcnlx,
      mcnly,
      mcnlz,
      mcnlvx,
      mcnlvy,
      mcnlvz,
      mcnlt,
      mcnlsx,
      mcnlsy,
      mcnlsz,
      mcnlp); }
#undef mcabsorbComp
#undef p
#undef sz
#undef sy
#undef sx
#undef t
#undef vz
#undef vy
#undef vx
#undef z
#undef y
#undef x
  mcDEBUG_STATE(
mcnlx,
mcnly,
mcnlz,
mcnlvx,
mcnlvy,
mcnlvz,
mcnlt,
mcnlsx,
mcnlsy,
mcnlsz,
mcnlp)

  /* TRACE Component channel_3_analyzer_2_array_crystal_array_5 [260] */
  mccoordschange(mcposrchannel_3_analyzer_2_array_crystal_array_5, mcrotrchannel_3_analyzer_2_array_crystal_array_5,
    &mcnlx,
    &mcnly,
    &mcnlz,
    &mcnlvx,
    &mcnlvy,
    &mcnlvz,
    &mcnlsx,
    &mcnlsy,
    &mcnlsz);
  /* define label inside component channel_3_analyzer_2_array_crystal_array_5 (without coords transformations) */
  mcJumpTrace_channel_3_analyzer_2_array_crystal_array_5:
  SIG_MESSAGE("channel_3_analyzer_2_array_crystal_array_5 (Trace)");
  mcDEBUG_COMP("channel_3_analyzer_2_array_crystal_array_5")
  mcDEBUG_STATE(
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp)
#define x mcnlx
#define y mcnly
#define z mcnlz
#define vx mcnlvx
#define vy mcnlvy
#define vz mcnlvz
#define t mcnlt
#define sx mcnlsx
#define sy mcnlsy
#define sz mcnlsz
#define p mcnlp

#define mcabsorbComp mcabsorbCompchannel_3_analyzer_2_array_crystal_array_5
  STORE_NEUTRON(260,
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp);
  mcScattered=0;
  mcRestore=0;
  mcNCounter[260]++;
  mcPCounter[260] += p;
  mcP2Counter[260] += p*p;
#define mccompcurname  channel_3_analyzer_2_array_crystal_array_5
#define mccompcurtype  Union_box
#define mccompcurindex 260
#define loop_index mccchannel_3_analyzer_2_array_crystal_array_5_loop_index
#define this_box_volume mccchannel_3_analyzer_2_array_crystal_array_5_this_box_volume
#define global_geometry_element mccchannel_3_analyzer_2_array_crystal_array_5_global_geometry_element
#define this_box_storage mccchannel_3_analyzer_2_array_crystal_array_5_this_box_storage
{   /* Declarations of channel_3_analyzer_2_array_crystal_array_5=Union_box() SETTING parameters. */
char* material_string = mccchannel_3_analyzer_2_array_crystal_array_5_material_string;
MCNUM priority = mccchannel_3_analyzer_2_array_crystal_array_5_priority;
MCNUM xwidth = mccchannel_3_analyzer_2_array_crystal_array_5_xwidth;
MCNUM yheight = mccchannel_3_analyzer_2_array_crystal_array_5_yheight;
MCNUM zdepth = mccchannel_3_analyzer_2_array_crystal_array_5_zdepth;
MCNUM xwidth2 = mccchannel_3_analyzer_2_array_crystal_array_5_xwidth2;
MCNUM yheight2 = mccchannel_3_analyzer_2_array_crystal_array_5_yheight2;
MCNUM visualize = mccchannel_3_analyzer_2_array_crystal_array_5_visualize;
int target_index = mccchannel_3_analyzer_2_array_crystal_array_5_target_index;
MCNUM target_x = mccchannel_3_analyzer_2_array_crystal_array_5_target_x;
MCNUM target_y = mccchannel_3_analyzer_2_array_crystal_array_5_target_y;
MCNUM target_z = mccchannel_3_analyzer_2_array_crystal_array_5_target_z;
MCNUM focus_aw = mccchannel_3_analyzer_2_array_crystal_array_5_focus_aw;
MCNUM focus_ah = mccchannel_3_analyzer_2_array_crystal_array_5_focus_ah;
MCNUM focus_xw = mccchannel_3_analyzer_2_array_crystal_array_5_focus_xw;
MCNUM focus_xh = mccchannel_3_analyzer_2_array_crystal_array_5_focus_xh;
MCNUM focus_r = mccchannel_3_analyzer_2_array_crystal_array_5_focus_r;
MCNUM p_interact = mccchannel_3_analyzer_2_array_crystal_array_5_p_interact;
char* mask_string = mccchannel_3_analyzer_2_array_crystal_array_5_mask_string;
char* mask_setting = mccchannel_3_analyzer_2_array_crystal_array_5_mask_setting;
MCNUM number_of_activations = mccchannel_3_analyzer_2_array_crystal_array_5_number_of_activations;
}   /* End of channel_3_analyzer_2_array_crystal_array_5=Union_box() SETTING parameter declarations. */
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex
  /* Label for restoring  neutron */
  mcabsorbCompchannel_3_analyzer_2_array_crystal_array_5:
  if (RESTORE) /* restore if needed */
  { RESTORE_NEUTRON(260,
      mcnlx,
      mcnly,
      mcnlz,
      mcnlvx,
      mcnlvy,
      mcnlvz,
      mcnlt,
      mcnlsx,
      mcnlsy,
      mcnlsz,
      mcnlp); }
#undef mcabsorbComp
#undef p
#undef sz
#undef sy
#undef sx
#undef t
#undef vz
#undef vy
#undef vx
#undef z
#undef y
#undef x
  mcDEBUG_STATE(
mcnlx,
mcnly,
mcnlz,
mcnlvx,
mcnlvy,
mcnlvz,
mcnlt,
mcnlsx,
mcnlsy,
mcnlsz,
mcnlp)

  /* TRACE Component channel_3_analyzer_2_array_crystal_array_6 [261] */
  mccoordschange(mcposrchannel_3_analyzer_2_array_crystal_array_6, mcrotrchannel_3_analyzer_2_array_crystal_array_6,
    &mcnlx,
    &mcnly,
    &mcnlz,
    &mcnlvx,
    &mcnlvy,
    &mcnlvz,
    &mcnlsx,
    &mcnlsy,
    &mcnlsz);
  /* define label inside component channel_3_analyzer_2_array_crystal_array_6 (without coords transformations) */
  mcJumpTrace_channel_3_analyzer_2_array_crystal_array_6:
  SIG_MESSAGE("channel_3_analyzer_2_array_crystal_array_6 (Trace)");
  mcDEBUG_COMP("channel_3_analyzer_2_array_crystal_array_6")
  mcDEBUG_STATE(
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp)
#define x mcnlx
#define y mcnly
#define z mcnlz
#define vx mcnlvx
#define vy mcnlvy
#define vz mcnlvz
#define t mcnlt
#define sx mcnlsx
#define sy mcnlsy
#define sz mcnlsz
#define p mcnlp

#define mcabsorbComp mcabsorbCompchannel_3_analyzer_2_array_crystal_array_6
  STORE_NEUTRON(261,
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp);
  mcScattered=0;
  mcRestore=0;
  mcNCounter[261]++;
  mcPCounter[261] += p;
  mcP2Counter[261] += p*p;
#define mccompcurname  channel_3_analyzer_2_array_crystal_array_6
#define mccompcurtype  Union_box
#define mccompcurindex 261
#define loop_index mccchannel_3_analyzer_2_array_crystal_array_6_loop_index
#define this_box_volume mccchannel_3_analyzer_2_array_crystal_array_6_this_box_volume
#define global_geometry_element mccchannel_3_analyzer_2_array_crystal_array_6_global_geometry_element
#define this_box_storage mccchannel_3_analyzer_2_array_crystal_array_6_this_box_storage
{   /* Declarations of channel_3_analyzer_2_array_crystal_array_6=Union_box() SETTING parameters. */
char* material_string = mccchannel_3_analyzer_2_array_crystal_array_6_material_string;
MCNUM priority = mccchannel_3_analyzer_2_array_crystal_array_6_priority;
MCNUM xwidth = mccchannel_3_analyzer_2_array_crystal_array_6_xwidth;
MCNUM yheight = mccchannel_3_analyzer_2_array_crystal_array_6_yheight;
MCNUM zdepth = mccchannel_3_analyzer_2_array_crystal_array_6_zdepth;
MCNUM xwidth2 = mccchannel_3_analyzer_2_array_crystal_array_6_xwidth2;
MCNUM yheight2 = mccchannel_3_analyzer_2_array_crystal_array_6_yheight2;
MCNUM visualize = mccchannel_3_analyzer_2_array_crystal_array_6_visualize;
int target_index = mccchannel_3_analyzer_2_array_crystal_array_6_target_index;
MCNUM target_x = mccchannel_3_analyzer_2_array_crystal_array_6_target_x;
MCNUM target_y = mccchannel_3_analyzer_2_array_crystal_array_6_target_y;
MCNUM target_z = mccchannel_3_analyzer_2_array_crystal_array_6_target_z;
MCNUM focus_aw = mccchannel_3_analyzer_2_array_crystal_array_6_focus_aw;
MCNUM focus_ah = mccchannel_3_analyzer_2_array_crystal_array_6_focus_ah;
MCNUM focus_xw = mccchannel_3_analyzer_2_array_crystal_array_6_focus_xw;
MCNUM focus_xh = mccchannel_3_analyzer_2_array_crystal_array_6_focus_xh;
MCNUM focus_r = mccchannel_3_analyzer_2_array_crystal_array_6_focus_r;
MCNUM p_interact = mccchannel_3_analyzer_2_array_crystal_array_6_p_interact;
char* mask_string = mccchannel_3_analyzer_2_array_crystal_array_6_mask_string;
char* mask_setting = mccchannel_3_analyzer_2_array_crystal_array_6_mask_setting;
MCNUM number_of_activations = mccchannel_3_analyzer_2_array_crystal_array_6_number_of_activations;
}   /* End of channel_3_analyzer_2_array_crystal_array_6=Union_box() SETTING parameter declarations. */
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex
  /* Label for restoring  neutron */
  mcabsorbCompchannel_3_analyzer_2_array_crystal_array_6:
  if (RESTORE) /* restore if needed */
  { RESTORE_NEUTRON(261,
      mcnlx,
      mcnly,
      mcnlz,
      mcnlvx,
      mcnlvy,
      mcnlvz,
      mcnlt,
      mcnlsx,
      mcnlsy,
      mcnlsz,
      mcnlp); }
#undef mcabsorbComp
#undef p
#undef sz
#undef sy
#undef sx
#undef t
#undef vz
#undef vy
#undef vx
#undef z
#undef y
#undef x
  mcDEBUG_STATE(
mcnlx,
mcnly,
mcnlz,
mcnlvx,
mcnlvy,
mcnlvz,
mcnlt,
mcnlsx,
mcnlsy,
mcnlsz,
mcnlp)

  /* TRACE Component channel_3_analyzer_2_array_crystal_array_7 [262] */
  mccoordschange(mcposrchannel_3_analyzer_2_array_crystal_array_7, mcrotrchannel_3_analyzer_2_array_crystal_array_7,
    &mcnlx,
    &mcnly,
    &mcnlz,
    &mcnlvx,
    &mcnlvy,
    &mcnlvz,
    &mcnlsx,
    &mcnlsy,
    &mcnlsz);
  /* define label inside component channel_3_analyzer_2_array_crystal_array_7 (without coords transformations) */
  mcJumpTrace_channel_3_analyzer_2_array_crystal_array_7:
  SIG_MESSAGE("channel_3_analyzer_2_array_crystal_array_7 (Trace)");
  mcDEBUG_COMP("channel_3_analyzer_2_array_crystal_array_7")
  mcDEBUG_STATE(
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp)
#define x mcnlx
#define y mcnly
#define z mcnlz
#define vx mcnlvx
#define vy mcnlvy
#define vz mcnlvz
#define t mcnlt
#define sx mcnlsx
#define sy mcnlsy
#define sz mcnlsz
#define p mcnlp

#define mcabsorbComp mcabsorbCompchannel_3_analyzer_2_array_crystal_array_7
  STORE_NEUTRON(262,
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp);
  mcScattered=0;
  mcRestore=0;
  mcNCounter[262]++;
  mcPCounter[262] += p;
  mcP2Counter[262] += p*p;
#define mccompcurname  channel_3_analyzer_2_array_crystal_array_7
#define mccompcurtype  Union_box
#define mccompcurindex 262
#define loop_index mccchannel_3_analyzer_2_array_crystal_array_7_loop_index
#define this_box_volume mccchannel_3_analyzer_2_array_crystal_array_7_this_box_volume
#define global_geometry_element mccchannel_3_analyzer_2_array_crystal_array_7_global_geometry_element
#define this_box_storage mccchannel_3_analyzer_2_array_crystal_array_7_this_box_storage
{   /* Declarations of channel_3_analyzer_2_array_crystal_array_7=Union_box() SETTING parameters. */
char* material_string = mccchannel_3_analyzer_2_array_crystal_array_7_material_string;
MCNUM priority = mccchannel_3_analyzer_2_array_crystal_array_7_priority;
MCNUM xwidth = mccchannel_3_analyzer_2_array_crystal_array_7_xwidth;
MCNUM yheight = mccchannel_3_analyzer_2_array_crystal_array_7_yheight;
MCNUM zdepth = mccchannel_3_analyzer_2_array_crystal_array_7_zdepth;
MCNUM xwidth2 = mccchannel_3_analyzer_2_array_crystal_array_7_xwidth2;
MCNUM yheight2 = mccchannel_3_analyzer_2_array_crystal_array_7_yheight2;
MCNUM visualize = mccchannel_3_analyzer_2_array_crystal_array_7_visualize;
int target_index = mccchannel_3_analyzer_2_array_crystal_array_7_target_index;
MCNUM target_x = mccchannel_3_analyzer_2_array_crystal_array_7_target_x;
MCNUM target_y = mccchannel_3_analyzer_2_array_crystal_array_7_target_y;
MCNUM target_z = mccchannel_3_analyzer_2_array_crystal_array_7_target_z;
MCNUM focus_aw = mccchannel_3_analyzer_2_array_crystal_array_7_focus_aw;
MCNUM focus_ah = mccchannel_3_analyzer_2_array_crystal_array_7_focus_ah;
MCNUM focus_xw = mccchannel_3_analyzer_2_array_crystal_array_7_focus_xw;
MCNUM focus_xh = mccchannel_3_analyzer_2_array_crystal_array_7_focus_xh;
MCNUM focus_r = mccchannel_3_analyzer_2_array_crystal_array_7_focus_r;
MCNUM p_interact = mccchannel_3_analyzer_2_array_crystal_array_7_p_interact;
char* mask_string = mccchannel_3_analyzer_2_array_crystal_array_7_mask_string;
char* mask_setting = mccchannel_3_analyzer_2_array_crystal_array_7_mask_setting;
MCNUM number_of_activations = mccchannel_3_analyzer_2_array_crystal_array_7_number_of_activations;
}   /* End of channel_3_analyzer_2_array_crystal_array_7=Union_box() SETTING parameter declarations. */
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex
  /* Label for restoring  neutron */
  mcabsorbCompchannel_3_analyzer_2_array_crystal_array_7:
  if (RESTORE) /* restore if needed */
  { RESTORE_NEUTRON(262,
      mcnlx,
      mcnly,
      mcnlz,
      mcnlvx,
      mcnlvy,
      mcnlvz,
      mcnlt,
      mcnlsx,
      mcnlsy,
      mcnlsz,
      mcnlp); }
#undef mcabsorbComp
#undef p
#undef sz
#undef sy
#undef sx
#undef t
#undef vz
#undef vy
#undef vx
#undef z
#undef y
#undef x
  mcDEBUG_STATE(
mcnlx,
mcnly,
mcnlz,
mcnlvx,
mcnlvy,
mcnlvz,
mcnlt,
mcnlsx,
mcnlsy,
mcnlsz,
mcnlp)

  /* TRACE Component channel_3_analyzer_2_array_crystal_array_8 [263] */
  mccoordschange(mcposrchannel_3_analyzer_2_array_crystal_array_8, mcrotrchannel_3_analyzer_2_array_crystal_array_8,
    &mcnlx,
    &mcnly,
    &mcnlz,
    &mcnlvx,
    &mcnlvy,
    &mcnlvz,
    &mcnlsx,
    &mcnlsy,
    &mcnlsz);
  /* define label inside component channel_3_analyzer_2_array_crystal_array_8 (without coords transformations) */
  mcJumpTrace_channel_3_analyzer_2_array_crystal_array_8:
  SIG_MESSAGE("channel_3_analyzer_2_array_crystal_array_8 (Trace)");
  mcDEBUG_COMP("channel_3_analyzer_2_array_crystal_array_8")
  mcDEBUG_STATE(
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp)
#define x mcnlx
#define y mcnly
#define z mcnlz
#define vx mcnlvx
#define vy mcnlvy
#define vz mcnlvz
#define t mcnlt
#define sx mcnlsx
#define sy mcnlsy
#define sz mcnlsz
#define p mcnlp

#define mcabsorbComp mcabsorbCompchannel_3_analyzer_2_array_crystal_array_8
  STORE_NEUTRON(263,
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp);
  mcScattered=0;
  mcRestore=0;
  mcNCounter[263]++;
  mcPCounter[263] += p;
  mcP2Counter[263] += p*p;
#define mccompcurname  channel_3_analyzer_2_array_crystal_array_8
#define mccompcurtype  Union_box
#define mccompcurindex 263
#define loop_index mccchannel_3_analyzer_2_array_crystal_array_8_loop_index
#define this_box_volume mccchannel_3_analyzer_2_array_crystal_array_8_this_box_volume
#define global_geometry_element mccchannel_3_analyzer_2_array_crystal_array_8_global_geometry_element
#define this_box_storage mccchannel_3_analyzer_2_array_crystal_array_8_this_box_storage
{   /* Declarations of channel_3_analyzer_2_array_crystal_array_8=Union_box() SETTING parameters. */
char* material_string = mccchannel_3_analyzer_2_array_crystal_array_8_material_string;
MCNUM priority = mccchannel_3_analyzer_2_array_crystal_array_8_priority;
MCNUM xwidth = mccchannel_3_analyzer_2_array_crystal_array_8_xwidth;
MCNUM yheight = mccchannel_3_analyzer_2_array_crystal_array_8_yheight;
MCNUM zdepth = mccchannel_3_analyzer_2_array_crystal_array_8_zdepth;
MCNUM xwidth2 = mccchannel_3_analyzer_2_array_crystal_array_8_xwidth2;
MCNUM yheight2 = mccchannel_3_analyzer_2_array_crystal_array_8_yheight2;
MCNUM visualize = mccchannel_3_analyzer_2_array_crystal_array_8_visualize;
int target_index = mccchannel_3_analyzer_2_array_crystal_array_8_target_index;
MCNUM target_x = mccchannel_3_analyzer_2_array_crystal_array_8_target_x;
MCNUM target_y = mccchannel_3_analyzer_2_array_crystal_array_8_target_y;
MCNUM target_z = mccchannel_3_analyzer_2_array_crystal_array_8_target_z;
MCNUM focus_aw = mccchannel_3_analyzer_2_array_crystal_array_8_focus_aw;
MCNUM focus_ah = mccchannel_3_analyzer_2_array_crystal_array_8_focus_ah;
MCNUM focus_xw = mccchannel_3_analyzer_2_array_crystal_array_8_focus_xw;
MCNUM focus_xh = mccchannel_3_analyzer_2_array_crystal_array_8_focus_xh;
MCNUM focus_r = mccchannel_3_analyzer_2_array_crystal_array_8_focus_r;
MCNUM p_interact = mccchannel_3_analyzer_2_array_crystal_array_8_p_interact;
char* mask_string = mccchannel_3_analyzer_2_array_crystal_array_8_mask_string;
char* mask_setting = mccchannel_3_analyzer_2_array_crystal_array_8_mask_setting;
MCNUM number_of_activations = mccchannel_3_analyzer_2_array_crystal_array_8_number_of_activations;
}   /* End of channel_3_analyzer_2_array_crystal_array_8=Union_box() SETTING parameter declarations. */
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex
  /* Label for restoring  neutron */
  mcabsorbCompchannel_3_analyzer_2_array_crystal_array_8:
  if (RESTORE) /* restore if needed */
  { RESTORE_NEUTRON(263,
      mcnlx,
      mcnly,
      mcnlz,
      mcnlvx,
      mcnlvy,
      mcnlvz,
      mcnlt,
      mcnlsx,
      mcnlsy,
      mcnlsz,
      mcnlp); }
#undef mcabsorbComp
#undef p
#undef sz
#undef sy
#undef sx
#undef t
#undef vz
#undef vy
#undef vx
#undef z
#undef y
#undef x
  mcDEBUG_STATE(
mcnlx,
mcnly,
mcnlz,
mcnlvx,
mcnlvy,
mcnlvz,
mcnlt,
mcnlsx,
mcnlsy,
mcnlsz,
mcnlp)

  /* TRACE Component channel_3_cave2_cyl1 [264] */
  mccoordschange(mcposrchannel_3_cave2_cyl1, mcrotrchannel_3_cave2_cyl1,
    &mcnlx,
    &mcnly,
    &mcnlz,
    &mcnlvx,
    &mcnlvy,
    &mcnlvz,
    &mcnlsx,
    &mcnlsy,
    &mcnlsz);
  /* define label inside component channel_3_cave2_cyl1 (without coords transformations) */
  mcJumpTrace_channel_3_cave2_cyl1:
  SIG_MESSAGE("channel_3_cave2_cyl1 (Trace)");
  mcDEBUG_COMP("channel_3_cave2_cyl1")
  mcDEBUG_STATE(
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp)
#define x mcnlx
#define y mcnly
#define z mcnlz
#define vx mcnlvx
#define vy mcnlvy
#define vz mcnlvz
#define t mcnlt
#define sx mcnlsx
#define sy mcnlsy
#define sz mcnlsz
#define p mcnlp

#define mcabsorbComp mcabsorbCompchannel_3_cave2_cyl1
  STORE_NEUTRON(264,
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp);
  mcScattered=0;
  mcRestore=0;
  mcNCounter[264]++;
  mcPCounter[264] += p;
  mcP2Counter[264] += p*p;
#define mccompcurname  channel_3_cave2_cyl1
#define mccompcurtype  Union_cylinder
#define mccompcurindex 264
#define loop_index mccchannel_3_cave2_cyl1_loop_index
#define this_cylinder_volume mccchannel_3_cave2_cyl1_this_cylinder_volume
#define global_geometry_element mccchannel_3_cave2_cyl1_global_geometry_element
#define this_cylinder_storage mccchannel_3_cave2_cyl1_this_cylinder_storage
{   /* Declarations of channel_3_cave2_cyl1=Union_cylinder() SETTING parameters. */
char* material_string = mccchannel_3_cave2_cyl1_material_string;
MCNUM priority = mccchannel_3_cave2_cyl1_priority;
MCNUM radius = mccchannel_3_cave2_cyl1_radius;
MCNUM yheight = mccchannel_3_cave2_cyl1_yheight;
MCNUM visualize = mccchannel_3_cave2_cyl1_visualize;
int target_index = mccchannel_3_cave2_cyl1_target_index;
MCNUM target_x = mccchannel_3_cave2_cyl1_target_x;
MCNUM target_y = mccchannel_3_cave2_cyl1_target_y;
MCNUM target_z = mccchannel_3_cave2_cyl1_target_z;
MCNUM focus_aw = mccchannel_3_cave2_cyl1_focus_aw;
MCNUM focus_ah = mccchannel_3_cave2_cyl1_focus_ah;
MCNUM focus_xw = mccchannel_3_cave2_cyl1_focus_xw;
MCNUM focus_xh = mccchannel_3_cave2_cyl1_focus_xh;
MCNUM focus_r = mccchannel_3_cave2_cyl1_focus_r;
MCNUM p_interact = mccchannel_3_cave2_cyl1_p_interact;
char* mask_string = mccchannel_3_cave2_cyl1_mask_string;
char* mask_setting = mccchannel_3_cave2_cyl1_mask_setting;
MCNUM number_of_activations = mccchannel_3_cave2_cyl1_number_of_activations;
#line 345 "Union_cylinder.comp"
{
dummy = 1;
}
#line 380841 "MACS_sample_kidney_box.c"
}   /* End of channel_3_cave2_cyl1=Union_cylinder() SETTING parameter declarations. */
#undef this_cylinder_storage
#undef global_geometry_element
#undef this_cylinder_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex
  /* Label for restoring  neutron */
  mcabsorbCompchannel_3_cave2_cyl1:
  if (RESTORE) /* restore if needed */
  { RESTORE_NEUTRON(264,
      mcnlx,
      mcnly,
      mcnlz,
      mcnlvx,
      mcnlvy,
      mcnlvz,
      mcnlt,
      mcnlsx,
      mcnlsy,
      mcnlsz,
      mcnlp); }
#undef mcabsorbComp
#undef p
#undef sz
#undef sy
#undef sx
#undef t
#undef vz
#undef vy
#undef vx
#undef z
#undef y
#undef x
  mcDEBUG_STATE(
mcnlx,
mcnly,
mcnlz,
mcnlvx,
mcnlvy,
mcnlvz,
mcnlt,
mcnlsx,
mcnlsy,
mcnlsz,
mcnlp)

  /* TRACE Component channel_3_cave2_box1 [265] */
  mccoordschange(mcposrchannel_3_cave2_box1, mcrotrchannel_3_cave2_box1,
    &mcnlx,
    &mcnly,
    &mcnlz,
    &mcnlvx,
    &mcnlvy,
    &mcnlvz,
    &mcnlsx,
    &mcnlsy,
    &mcnlsz);
  /* define label inside component channel_3_cave2_box1 (without coords transformations) */
  mcJumpTrace_channel_3_cave2_box1:
  SIG_MESSAGE("channel_3_cave2_box1 (Trace)");
  mcDEBUG_COMP("channel_3_cave2_box1")
  mcDEBUG_STATE(
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp)
#define x mcnlx
#define y mcnly
#define z mcnlz
#define vx mcnlvx
#define vy mcnlvy
#define vz mcnlvz
#define t mcnlt
#define sx mcnlsx
#define sy mcnlsy
#define sz mcnlsz
#define p mcnlp

#define mcabsorbComp mcabsorbCompchannel_3_cave2_box1
  STORE_NEUTRON(265,
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp);
  mcScattered=0;
  mcRestore=0;
  mcNCounter[265]++;
  mcPCounter[265] += p;
  mcP2Counter[265] += p*p;
#define mccompcurname  channel_3_cave2_box1
#define mccompcurtype  Union_box
#define mccompcurindex 265
#define loop_index mccchannel_3_cave2_box1_loop_index
#define this_box_volume mccchannel_3_cave2_box1_this_box_volume
#define global_geometry_element mccchannel_3_cave2_box1_global_geometry_element
#define this_box_storage mccchannel_3_cave2_box1_this_box_storage
{   /* Declarations of channel_3_cave2_box1=Union_box() SETTING parameters. */
char* material_string = mccchannel_3_cave2_box1_material_string;
MCNUM priority = mccchannel_3_cave2_box1_priority;
MCNUM xwidth = mccchannel_3_cave2_box1_xwidth;
MCNUM yheight = mccchannel_3_cave2_box1_yheight;
MCNUM zdepth = mccchannel_3_cave2_box1_zdepth;
MCNUM xwidth2 = mccchannel_3_cave2_box1_xwidth2;
MCNUM yheight2 = mccchannel_3_cave2_box1_yheight2;
MCNUM visualize = mccchannel_3_cave2_box1_visualize;
int target_index = mccchannel_3_cave2_box1_target_index;
MCNUM target_x = mccchannel_3_cave2_box1_target_x;
MCNUM target_y = mccchannel_3_cave2_box1_target_y;
MCNUM target_z = mccchannel_3_cave2_box1_target_z;
MCNUM focus_aw = mccchannel_3_cave2_box1_focus_aw;
MCNUM focus_ah = mccchannel_3_cave2_box1_focus_ah;
MCNUM focus_xw = mccchannel_3_cave2_box1_focus_xw;
MCNUM focus_xh = mccchannel_3_cave2_box1_focus_xh;
MCNUM focus_r = mccchannel_3_cave2_box1_focus_r;
MCNUM p_interact = mccchannel_3_cave2_box1_p_interact;
char* mask_string = mccchannel_3_cave2_box1_mask_string;
char* mask_setting = mccchannel_3_cave2_box1_mask_setting;
MCNUM number_of_activations = mccchannel_3_cave2_box1_number_of_activations;
}   /* End of channel_3_cave2_box1=Union_box() SETTING parameter declarations. */
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex
  /* Label for restoring  neutron */
  mcabsorbCompchannel_3_cave2_box1:
  if (RESTORE) /* restore if needed */
  { RESTORE_NEUTRON(265,
      mcnlx,
      mcnly,
      mcnlz,
      mcnlvx,
      mcnlvy,
      mcnlvz,
      mcnlt,
      mcnlsx,
      mcnlsy,
      mcnlsz,
      mcnlp); }
#undef mcabsorbComp
#undef p
#undef sz
#undef sy
#undef sx
#undef t
#undef vz
#undef vy
#undef vx
#undef z
#undef y
#undef x
  mcDEBUG_STATE(
mcnlx,
mcnly,
mcnlz,
mcnlvx,
mcnlvy,
mcnlvz,
mcnlt,
mcnlsx,
mcnlsy,
mcnlsz,
mcnlp)

  /* TRACE Component channel_3_cave2_box2 [266] */
  mccoordschange(mcposrchannel_3_cave2_box2, mcrotrchannel_3_cave2_box2,
    &mcnlx,
    &mcnly,
    &mcnlz,
    &mcnlvx,
    &mcnlvy,
    &mcnlvz,
    &mcnlsx,
    &mcnlsy,
    &mcnlsz);
  /* define label inside component channel_3_cave2_box2 (without coords transformations) */
  mcJumpTrace_channel_3_cave2_box2:
  SIG_MESSAGE("channel_3_cave2_box2 (Trace)");
  mcDEBUG_COMP("channel_3_cave2_box2")
  mcDEBUG_STATE(
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp)
#define x mcnlx
#define y mcnly
#define z mcnlz
#define vx mcnlvx
#define vy mcnlvy
#define vz mcnlvz
#define t mcnlt
#define sx mcnlsx
#define sy mcnlsy
#define sz mcnlsz
#define p mcnlp

#define mcabsorbComp mcabsorbCompchannel_3_cave2_box2
  STORE_NEUTRON(266,
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp);
  mcScattered=0;
  mcRestore=0;
  mcNCounter[266]++;
  mcPCounter[266] += p;
  mcP2Counter[266] += p*p;
#define mccompcurname  channel_3_cave2_box2
#define mccompcurtype  Union_box
#define mccompcurindex 266
#define loop_index mccchannel_3_cave2_box2_loop_index
#define this_box_volume mccchannel_3_cave2_box2_this_box_volume
#define global_geometry_element mccchannel_3_cave2_box2_global_geometry_element
#define this_box_storage mccchannel_3_cave2_box2_this_box_storage
{   /* Declarations of channel_3_cave2_box2=Union_box() SETTING parameters. */
char* material_string = mccchannel_3_cave2_box2_material_string;
MCNUM priority = mccchannel_3_cave2_box2_priority;
MCNUM xwidth = mccchannel_3_cave2_box2_xwidth;
MCNUM yheight = mccchannel_3_cave2_box2_yheight;
MCNUM zdepth = mccchannel_3_cave2_box2_zdepth;
MCNUM xwidth2 = mccchannel_3_cave2_box2_xwidth2;
MCNUM yheight2 = mccchannel_3_cave2_box2_yheight2;
MCNUM visualize = mccchannel_3_cave2_box2_visualize;
int target_index = mccchannel_3_cave2_box2_target_index;
MCNUM target_x = mccchannel_3_cave2_box2_target_x;
MCNUM target_y = mccchannel_3_cave2_box2_target_y;
MCNUM target_z = mccchannel_3_cave2_box2_target_z;
MCNUM focus_aw = mccchannel_3_cave2_box2_focus_aw;
MCNUM focus_ah = mccchannel_3_cave2_box2_focus_ah;
MCNUM focus_xw = mccchannel_3_cave2_box2_focus_xw;
MCNUM focus_xh = mccchannel_3_cave2_box2_focus_xh;
MCNUM focus_r = mccchannel_3_cave2_box2_focus_r;
MCNUM p_interact = mccchannel_3_cave2_box2_p_interact;
char* mask_string = mccchannel_3_cave2_box2_mask_string;
char* mask_setting = mccchannel_3_cave2_box2_mask_setting;
MCNUM number_of_activations = mccchannel_3_cave2_box2_number_of_activations;
}   /* End of channel_3_cave2_box2=Union_box() SETTING parameter declarations. */
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex
  /* Label for restoring  neutron */
  mcabsorbCompchannel_3_cave2_box2:
  if (RESTORE) /* restore if needed */
  { RESTORE_NEUTRON(266,
      mcnlx,
      mcnly,
      mcnlz,
      mcnlvx,
      mcnlvy,
      mcnlvz,
      mcnlt,
      mcnlsx,
      mcnlsy,
      mcnlsz,
      mcnlp); }
#undef mcabsorbComp
#undef p
#undef sz
#undef sy
#undef sx
#undef t
#undef vz
#undef vy
#undef vx
#undef z
#undef y
#undef x
  mcDEBUG_STATE(
mcnlx,
mcnly,
mcnlz,
mcnlvx,
mcnlvy,
mcnlvz,
mcnlt,
mcnlsx,
mcnlsy,
mcnlsz,
mcnlp)

  /* TRACE Component channel_3_cave2_box3 [267] */
  mccoordschange(mcposrchannel_3_cave2_box3, mcrotrchannel_3_cave2_box3,
    &mcnlx,
    &mcnly,
    &mcnlz,
    &mcnlvx,
    &mcnlvy,
    &mcnlvz,
    &mcnlsx,
    &mcnlsy,
    &mcnlsz);
  /* define label inside component channel_3_cave2_box3 (without coords transformations) */
  mcJumpTrace_channel_3_cave2_box3:
  SIG_MESSAGE("channel_3_cave2_box3 (Trace)");
  mcDEBUG_COMP("channel_3_cave2_box3")
  mcDEBUG_STATE(
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp)
#define x mcnlx
#define y mcnly
#define z mcnlz
#define vx mcnlvx
#define vy mcnlvy
#define vz mcnlvz
#define t mcnlt
#define sx mcnlsx
#define sy mcnlsy
#define sz mcnlsz
#define p mcnlp

#define mcabsorbComp mcabsorbCompchannel_3_cave2_box3
  STORE_NEUTRON(267,
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp);
  mcScattered=0;
  mcRestore=0;
  mcNCounter[267]++;
  mcPCounter[267] += p;
  mcP2Counter[267] += p*p;
#define mccompcurname  channel_3_cave2_box3
#define mccompcurtype  Union_box
#define mccompcurindex 267
#define loop_index mccchannel_3_cave2_box3_loop_index
#define this_box_volume mccchannel_3_cave2_box3_this_box_volume
#define global_geometry_element mccchannel_3_cave2_box3_global_geometry_element
#define this_box_storage mccchannel_3_cave2_box3_this_box_storage
{   /* Declarations of channel_3_cave2_box3=Union_box() SETTING parameters. */
char* material_string = mccchannel_3_cave2_box3_material_string;
MCNUM priority = mccchannel_3_cave2_box3_priority;
MCNUM xwidth = mccchannel_3_cave2_box3_xwidth;
MCNUM yheight = mccchannel_3_cave2_box3_yheight;
MCNUM zdepth = mccchannel_3_cave2_box3_zdepth;
MCNUM xwidth2 = mccchannel_3_cave2_box3_xwidth2;
MCNUM yheight2 = mccchannel_3_cave2_box3_yheight2;
MCNUM visualize = mccchannel_3_cave2_box3_visualize;
int target_index = mccchannel_3_cave2_box3_target_index;
MCNUM target_x = mccchannel_3_cave2_box3_target_x;
MCNUM target_y = mccchannel_3_cave2_box3_target_y;
MCNUM target_z = mccchannel_3_cave2_box3_target_z;
MCNUM focus_aw = mccchannel_3_cave2_box3_focus_aw;
MCNUM focus_ah = mccchannel_3_cave2_box3_focus_ah;
MCNUM focus_xw = mccchannel_3_cave2_box3_focus_xw;
MCNUM focus_xh = mccchannel_3_cave2_box3_focus_xh;
MCNUM focus_r = mccchannel_3_cave2_box3_focus_r;
MCNUM p_interact = mccchannel_3_cave2_box3_p_interact;
char* mask_string = mccchannel_3_cave2_box3_mask_string;
char* mask_setting = mccchannel_3_cave2_box3_mask_setting;
MCNUM number_of_activations = mccchannel_3_cave2_box3_number_of_activations;
}   /* End of channel_3_cave2_box3=Union_box() SETTING parameter declarations. */
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex
  /* Label for restoring  neutron */
  mcabsorbCompchannel_3_cave2_box3:
  if (RESTORE) /* restore if needed */
  { RESTORE_NEUTRON(267,
      mcnlx,
      mcnly,
      mcnlz,
      mcnlvx,
      mcnlvy,
      mcnlvz,
      mcnlt,
      mcnlsx,
      mcnlsy,
      mcnlsz,
      mcnlp); }
#undef mcabsorbComp
#undef p
#undef sz
#undef sy
#undef sx
#undef t
#undef vz
#undef vy
#undef vx
#undef z
#undef y
#undef x
  mcDEBUG_STATE(
mcnlx,
mcnly,
mcnlz,
mcnlvx,
mcnlvy,
mcnlvz,
mcnlt,
mcnlsx,
mcnlsy,
mcnlsz,
mcnlp)

  /* TRACE Component inter_analyzer_colimator_center_3 [268] */
  mccoordschange(mcposrinter_analyzer_colimator_center_3, mcrotrinter_analyzer_colimator_center_3,
    &mcnlx,
    &mcnly,
    &mcnlz,
    &mcnlvx,
    &mcnlvy,
    &mcnlvz,
    &mcnlsx,
    &mcnlsy,
    &mcnlsz);
  /* define label inside component inter_analyzer_colimator_center_3 (without coords transformations) */
  mcJumpTrace_inter_analyzer_colimator_center_3:
  SIG_MESSAGE("inter_analyzer_colimator_center_3 (Trace)");
  mcDEBUG_COMP("inter_analyzer_colimator_center_3")
  mcDEBUG_STATE(
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp)
#define x mcnlx
#define y mcnly
#define z mcnlz
#define vx mcnlvx
#define vy mcnlvy
#define vz mcnlvz
#define t mcnlt
#define sx mcnlsx
#define sy mcnlsy
#define sz mcnlsz
#define p mcnlp

#define mcabsorbComp mcabsorbCompinter_analyzer_colimator_center_3
  STORE_NEUTRON(268,
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp);
  mcScattered=0;
  mcRestore=0;
  mcNCounter[268]++;
  mcPCounter[268] += p;
  mcP2Counter[268] += p*p;
#define mccompcurname  inter_analyzer_colimator_center_3
#define mccompcurtype  Arm
#define mccompcurindex 268
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex
  /* Label for restoring  neutron */
  mcabsorbCompinter_analyzer_colimator_center_3:
  if (RESTORE) /* restore if needed */
  { RESTORE_NEUTRON(268,
      mcnlx,
      mcnly,
      mcnlz,
      mcnlvx,
      mcnlvy,
      mcnlvz,
      mcnlt,
      mcnlsx,
      mcnlsy,
      mcnlsz,
      mcnlp); }
#undef mcabsorbComp
#undef p
#undef sz
#undef sy
#undef sx
#undef t
#undef vz
#undef vy
#undef vx
#undef z
#undef y
#undef x
  mcDEBUG_STATE(
mcnlx,
mcnly,
mcnlz,
mcnlvx,
mcnlvy,
mcnlvz,
mcnlt,
mcnlsx,
mcnlsy,
mcnlsz,
mcnlp)

  /* TRACE Component inter_analyzer_colimator_3_blade_0 [269] */
  mccoordschange(mcposrinter_analyzer_colimator_3_blade_0, mcrotrinter_analyzer_colimator_3_blade_0,
    &mcnlx,
    &mcnly,
    &mcnlz,
    &mcnlvx,
    &mcnlvy,
    &mcnlvz,
    &mcnlsx,
    &mcnlsy,
    &mcnlsz);
  /* define label inside component inter_analyzer_colimator_3_blade_0 (without coords transformations) */
  mcJumpTrace_inter_analyzer_colimator_3_blade_0:
  SIG_MESSAGE("inter_analyzer_colimator_3_blade_0 (Trace)");
  mcDEBUG_COMP("inter_analyzer_colimator_3_blade_0")
  mcDEBUG_STATE(
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp)
#define x mcnlx
#define y mcnly
#define z mcnlz
#define vx mcnlvx
#define vy mcnlvy
#define vz mcnlvz
#define t mcnlt
#define sx mcnlsx
#define sy mcnlsy
#define sz mcnlsz
#define p mcnlp

#define mcabsorbComp mcabsorbCompinter_analyzer_colimator_3_blade_0
  STORE_NEUTRON(269,
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp);
  mcScattered=0;
  mcRestore=0;
  mcNCounter[269]++;
  mcPCounter[269] += p;
  mcP2Counter[269] += p*p;
#define mccompcurname  inter_analyzer_colimator_3_blade_0
#define mccompcurtype  Union_box
#define mccompcurindex 269
#define loop_index mccinter_analyzer_colimator_3_blade_0_loop_index
#define this_box_volume mccinter_analyzer_colimator_3_blade_0_this_box_volume
#define global_geometry_element mccinter_analyzer_colimator_3_blade_0_global_geometry_element
#define this_box_storage mccinter_analyzer_colimator_3_blade_0_this_box_storage
{   /* Declarations of inter_analyzer_colimator_3_blade_0=Union_box() SETTING parameters. */
char* material_string = mccinter_analyzer_colimator_3_blade_0_material_string;
MCNUM priority = mccinter_analyzer_colimator_3_blade_0_priority;
MCNUM xwidth = mccinter_analyzer_colimator_3_blade_0_xwidth;
MCNUM yheight = mccinter_analyzer_colimator_3_blade_0_yheight;
MCNUM zdepth = mccinter_analyzer_colimator_3_blade_0_zdepth;
MCNUM xwidth2 = mccinter_analyzer_colimator_3_blade_0_xwidth2;
MCNUM yheight2 = mccinter_analyzer_colimator_3_blade_0_yheight2;
MCNUM visualize = mccinter_analyzer_colimator_3_blade_0_visualize;
int target_index = mccinter_analyzer_colimator_3_blade_0_target_index;
MCNUM target_x = mccinter_analyzer_colimator_3_blade_0_target_x;
MCNUM target_y = mccinter_analyzer_colimator_3_blade_0_target_y;
MCNUM target_z = mccinter_analyzer_colimator_3_blade_0_target_z;
MCNUM focus_aw = mccinter_analyzer_colimator_3_blade_0_focus_aw;
MCNUM focus_ah = mccinter_analyzer_colimator_3_blade_0_focus_ah;
MCNUM focus_xw = mccinter_analyzer_colimator_3_blade_0_focus_xw;
MCNUM focus_xh = mccinter_analyzer_colimator_3_blade_0_focus_xh;
MCNUM focus_r = mccinter_analyzer_colimator_3_blade_0_focus_r;
MCNUM p_interact = mccinter_analyzer_colimator_3_blade_0_p_interact;
char* mask_string = mccinter_analyzer_colimator_3_blade_0_mask_string;
char* mask_setting = mccinter_analyzer_colimator_3_blade_0_mask_setting;
MCNUM number_of_activations = mccinter_analyzer_colimator_3_blade_0_number_of_activations;
}   /* End of inter_analyzer_colimator_3_blade_0=Union_box() SETTING parameter declarations. */
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex
  /* Label for restoring  neutron */
  mcabsorbCompinter_analyzer_colimator_3_blade_0:
  if (RESTORE) /* restore if needed */
  { RESTORE_NEUTRON(269,
      mcnlx,
      mcnly,
      mcnlz,
      mcnlvx,
      mcnlvy,
      mcnlvz,
      mcnlt,
      mcnlsx,
      mcnlsy,
      mcnlsz,
      mcnlp); }
#undef mcabsorbComp
#undef p
#undef sz
#undef sy
#undef sx
#undef t
#undef vz
#undef vy
#undef vx
#undef z
#undef y
#undef x
  mcDEBUG_STATE(
mcnlx,
mcnly,
mcnlz,
mcnlvx,
mcnlvy,
mcnlvz,
mcnlt,
mcnlsx,
mcnlsy,
mcnlsz,
mcnlp)

  /* TRACE Component inter_analyzer_colimator_3_blade_1 [270] */
  mccoordschange(mcposrinter_analyzer_colimator_3_blade_1, mcrotrinter_analyzer_colimator_3_blade_1,
    &mcnlx,
    &mcnly,
    &mcnlz,
    &mcnlvx,
    &mcnlvy,
    &mcnlvz,
    &mcnlsx,
    &mcnlsy,
    &mcnlsz);
  /* define label inside component inter_analyzer_colimator_3_blade_1 (without coords transformations) */
  mcJumpTrace_inter_analyzer_colimator_3_blade_1:
  SIG_MESSAGE("inter_analyzer_colimator_3_blade_1 (Trace)");
  mcDEBUG_COMP("inter_analyzer_colimator_3_blade_1")
  mcDEBUG_STATE(
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp)
#define x mcnlx
#define y mcnly
#define z mcnlz
#define vx mcnlvx
#define vy mcnlvy
#define vz mcnlvz
#define t mcnlt
#define sx mcnlsx
#define sy mcnlsy
#define sz mcnlsz
#define p mcnlp

#define mcabsorbComp mcabsorbCompinter_analyzer_colimator_3_blade_1
  STORE_NEUTRON(270,
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp);
  mcScattered=0;
  mcRestore=0;
  mcNCounter[270]++;
  mcPCounter[270] += p;
  mcP2Counter[270] += p*p;
#define mccompcurname  inter_analyzer_colimator_3_blade_1
#define mccompcurtype  Union_box
#define mccompcurindex 270
#define loop_index mccinter_analyzer_colimator_3_blade_1_loop_index
#define this_box_volume mccinter_analyzer_colimator_3_blade_1_this_box_volume
#define global_geometry_element mccinter_analyzer_colimator_3_blade_1_global_geometry_element
#define this_box_storage mccinter_analyzer_colimator_3_blade_1_this_box_storage
{   /* Declarations of inter_analyzer_colimator_3_blade_1=Union_box() SETTING parameters. */
char* material_string = mccinter_analyzer_colimator_3_blade_1_material_string;
MCNUM priority = mccinter_analyzer_colimator_3_blade_1_priority;
MCNUM xwidth = mccinter_analyzer_colimator_3_blade_1_xwidth;
MCNUM yheight = mccinter_analyzer_colimator_3_blade_1_yheight;
MCNUM zdepth = mccinter_analyzer_colimator_3_blade_1_zdepth;
MCNUM xwidth2 = mccinter_analyzer_colimator_3_blade_1_xwidth2;
MCNUM yheight2 = mccinter_analyzer_colimator_3_blade_1_yheight2;
MCNUM visualize = mccinter_analyzer_colimator_3_blade_1_visualize;
int target_index = mccinter_analyzer_colimator_3_blade_1_target_index;
MCNUM target_x = mccinter_analyzer_colimator_3_blade_1_target_x;
MCNUM target_y = mccinter_analyzer_colimator_3_blade_1_target_y;
MCNUM target_z = mccinter_analyzer_colimator_3_blade_1_target_z;
MCNUM focus_aw = mccinter_analyzer_colimator_3_blade_1_focus_aw;
MCNUM focus_ah = mccinter_analyzer_colimator_3_blade_1_focus_ah;
MCNUM focus_xw = mccinter_analyzer_colimator_3_blade_1_focus_xw;
MCNUM focus_xh = mccinter_analyzer_colimator_3_blade_1_focus_xh;
MCNUM focus_r = mccinter_analyzer_colimator_3_blade_1_focus_r;
MCNUM p_interact = mccinter_analyzer_colimator_3_blade_1_p_interact;
char* mask_string = mccinter_analyzer_colimator_3_blade_1_mask_string;
char* mask_setting = mccinter_analyzer_colimator_3_blade_1_mask_setting;
MCNUM number_of_activations = mccinter_analyzer_colimator_3_blade_1_number_of_activations;
}   /* End of inter_analyzer_colimator_3_blade_1=Union_box() SETTING parameter declarations. */
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex
  /* Label for restoring  neutron */
  mcabsorbCompinter_analyzer_colimator_3_blade_1:
  if (RESTORE) /* restore if needed */
  { RESTORE_NEUTRON(270,
      mcnlx,
      mcnly,
      mcnlz,
      mcnlvx,
      mcnlvy,
      mcnlvz,
      mcnlt,
      mcnlsx,
      mcnlsy,
      mcnlsz,
      mcnlp); }
#undef mcabsorbComp
#undef p
#undef sz
#undef sy
#undef sx
#undef t
#undef vz
#undef vy
#undef vx
#undef z
#undef y
#undef x
  mcDEBUG_STATE(
mcnlx,
mcnly,
mcnlz,
mcnlvx,
mcnlvy,
mcnlvz,
mcnlt,
mcnlsx,
mcnlsy,
mcnlsz,
mcnlp)

  /* TRACE Component inter_analyzer_colimator_3_blade_2 [271] */
  mccoordschange(mcposrinter_analyzer_colimator_3_blade_2, mcrotrinter_analyzer_colimator_3_blade_2,
    &mcnlx,
    &mcnly,
    &mcnlz,
    &mcnlvx,
    &mcnlvy,
    &mcnlvz,
    &mcnlsx,
    &mcnlsy,
    &mcnlsz);
  /* define label inside component inter_analyzer_colimator_3_blade_2 (without coords transformations) */
  mcJumpTrace_inter_analyzer_colimator_3_blade_2:
  SIG_MESSAGE("inter_analyzer_colimator_3_blade_2 (Trace)");
  mcDEBUG_COMP("inter_analyzer_colimator_3_blade_2")
  mcDEBUG_STATE(
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp)
#define x mcnlx
#define y mcnly
#define z mcnlz
#define vx mcnlvx
#define vy mcnlvy
#define vz mcnlvz
#define t mcnlt
#define sx mcnlsx
#define sy mcnlsy
#define sz mcnlsz
#define p mcnlp

#define mcabsorbComp mcabsorbCompinter_analyzer_colimator_3_blade_2
  STORE_NEUTRON(271,
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp);
  mcScattered=0;
  mcRestore=0;
  mcNCounter[271]++;
  mcPCounter[271] += p;
  mcP2Counter[271] += p*p;
#define mccompcurname  inter_analyzer_colimator_3_blade_2
#define mccompcurtype  Union_box
#define mccompcurindex 271
#define loop_index mccinter_analyzer_colimator_3_blade_2_loop_index
#define this_box_volume mccinter_analyzer_colimator_3_blade_2_this_box_volume
#define global_geometry_element mccinter_analyzer_colimator_3_blade_2_global_geometry_element
#define this_box_storage mccinter_analyzer_colimator_3_blade_2_this_box_storage
{   /* Declarations of inter_analyzer_colimator_3_blade_2=Union_box() SETTING parameters. */
char* material_string = mccinter_analyzer_colimator_3_blade_2_material_string;
MCNUM priority = mccinter_analyzer_colimator_3_blade_2_priority;
MCNUM xwidth = mccinter_analyzer_colimator_3_blade_2_xwidth;
MCNUM yheight = mccinter_analyzer_colimator_3_blade_2_yheight;
MCNUM zdepth = mccinter_analyzer_colimator_3_blade_2_zdepth;
MCNUM xwidth2 = mccinter_analyzer_colimator_3_blade_2_xwidth2;
MCNUM yheight2 = mccinter_analyzer_colimator_3_blade_2_yheight2;
MCNUM visualize = mccinter_analyzer_colimator_3_blade_2_visualize;
int target_index = mccinter_analyzer_colimator_3_blade_2_target_index;
MCNUM target_x = mccinter_analyzer_colimator_3_blade_2_target_x;
MCNUM target_y = mccinter_analyzer_colimator_3_blade_2_target_y;
MCNUM target_z = mccinter_analyzer_colimator_3_blade_2_target_z;
MCNUM focus_aw = mccinter_analyzer_colimator_3_blade_2_focus_aw;
MCNUM focus_ah = mccinter_analyzer_colimator_3_blade_2_focus_ah;
MCNUM focus_xw = mccinter_analyzer_colimator_3_blade_2_focus_xw;
MCNUM focus_xh = mccinter_analyzer_colimator_3_blade_2_focus_xh;
MCNUM focus_r = mccinter_analyzer_colimator_3_blade_2_focus_r;
MCNUM p_interact = mccinter_analyzer_colimator_3_blade_2_p_interact;
char* mask_string = mccinter_analyzer_colimator_3_blade_2_mask_string;
char* mask_setting = mccinter_analyzer_colimator_3_blade_2_mask_setting;
MCNUM number_of_activations = mccinter_analyzer_colimator_3_blade_2_number_of_activations;
}   /* End of inter_analyzer_colimator_3_blade_2=Union_box() SETTING parameter declarations. */
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex
  /* Label for restoring  neutron */
  mcabsorbCompinter_analyzer_colimator_3_blade_2:
  if (RESTORE) /* restore if needed */
  { RESTORE_NEUTRON(271,
      mcnlx,
      mcnly,
      mcnlz,
      mcnlvx,
      mcnlvy,
      mcnlvz,
      mcnlt,
      mcnlsx,
      mcnlsy,
      mcnlsz,
      mcnlp); }
#undef mcabsorbComp
#undef p
#undef sz
#undef sy
#undef sx
#undef t
#undef vz
#undef vy
#undef vx
#undef z
#undef y
#undef x
  mcDEBUG_STATE(
mcnlx,
mcnly,
mcnlz,
mcnlvx,
mcnlvy,
mcnlvz,
mcnlt,
mcnlsx,
mcnlsy,
mcnlsz,
mcnlp)

  /* TRACE Component inter_analyzer_colimator_3_blade_3 [272] */
  mccoordschange(mcposrinter_analyzer_colimator_3_blade_3, mcrotrinter_analyzer_colimator_3_blade_3,
    &mcnlx,
    &mcnly,
    &mcnlz,
    &mcnlvx,
    &mcnlvy,
    &mcnlvz,
    &mcnlsx,
    &mcnlsy,
    &mcnlsz);
  /* define label inside component inter_analyzer_colimator_3_blade_3 (without coords transformations) */
  mcJumpTrace_inter_analyzer_colimator_3_blade_3:
  SIG_MESSAGE("inter_analyzer_colimator_3_blade_3 (Trace)");
  mcDEBUG_COMP("inter_analyzer_colimator_3_blade_3")
  mcDEBUG_STATE(
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp)
#define x mcnlx
#define y mcnly
#define z mcnlz
#define vx mcnlvx
#define vy mcnlvy
#define vz mcnlvz
#define t mcnlt
#define sx mcnlsx
#define sy mcnlsy
#define sz mcnlsz
#define p mcnlp

#define mcabsorbComp mcabsorbCompinter_analyzer_colimator_3_blade_3
  STORE_NEUTRON(272,
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp);
  mcScattered=0;
  mcRestore=0;
  mcNCounter[272]++;
  mcPCounter[272] += p;
  mcP2Counter[272] += p*p;
#define mccompcurname  inter_analyzer_colimator_3_blade_3
#define mccompcurtype  Union_box
#define mccompcurindex 272
#define loop_index mccinter_analyzer_colimator_3_blade_3_loop_index
#define this_box_volume mccinter_analyzer_colimator_3_blade_3_this_box_volume
#define global_geometry_element mccinter_analyzer_colimator_3_blade_3_global_geometry_element
#define this_box_storage mccinter_analyzer_colimator_3_blade_3_this_box_storage
{   /* Declarations of inter_analyzer_colimator_3_blade_3=Union_box() SETTING parameters. */
char* material_string = mccinter_analyzer_colimator_3_blade_3_material_string;
MCNUM priority = mccinter_analyzer_colimator_3_blade_3_priority;
MCNUM xwidth = mccinter_analyzer_colimator_3_blade_3_xwidth;
MCNUM yheight = mccinter_analyzer_colimator_3_blade_3_yheight;
MCNUM zdepth = mccinter_analyzer_colimator_3_blade_3_zdepth;
MCNUM xwidth2 = mccinter_analyzer_colimator_3_blade_3_xwidth2;
MCNUM yheight2 = mccinter_analyzer_colimator_3_blade_3_yheight2;
MCNUM visualize = mccinter_analyzer_colimator_3_blade_3_visualize;
int target_index = mccinter_analyzer_colimator_3_blade_3_target_index;
MCNUM target_x = mccinter_analyzer_colimator_3_blade_3_target_x;
MCNUM target_y = mccinter_analyzer_colimator_3_blade_3_target_y;
MCNUM target_z = mccinter_analyzer_colimator_3_blade_3_target_z;
MCNUM focus_aw = mccinter_analyzer_colimator_3_blade_3_focus_aw;
MCNUM focus_ah = mccinter_analyzer_colimator_3_blade_3_focus_ah;
MCNUM focus_xw = mccinter_analyzer_colimator_3_blade_3_focus_xw;
MCNUM focus_xh = mccinter_analyzer_colimator_3_blade_3_focus_xh;
MCNUM focus_r = mccinter_analyzer_colimator_3_blade_3_focus_r;
MCNUM p_interact = mccinter_analyzer_colimator_3_blade_3_p_interact;
char* mask_string = mccinter_analyzer_colimator_3_blade_3_mask_string;
char* mask_setting = mccinter_analyzer_colimator_3_blade_3_mask_setting;
MCNUM number_of_activations = mccinter_analyzer_colimator_3_blade_3_number_of_activations;
}   /* End of inter_analyzer_colimator_3_blade_3=Union_box() SETTING parameter declarations. */
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex
  /* Label for restoring  neutron */
  mcabsorbCompinter_analyzer_colimator_3_blade_3:
  if (RESTORE) /* restore if needed */
  { RESTORE_NEUTRON(272,
      mcnlx,
      mcnly,
      mcnlz,
      mcnlvx,
      mcnlvy,
      mcnlvz,
      mcnlt,
      mcnlsx,
      mcnlsy,
      mcnlsz,
      mcnlp); }
#undef mcabsorbComp
#undef p
#undef sz
#undef sy
#undef sx
#undef t
#undef vz
#undef vy
#undef vx
#undef z
#undef y
#undef x
  mcDEBUG_STATE(
mcnlx,
mcnly,
mcnlz,
mcnlvx,
mcnlvy,
mcnlvz,
mcnlt,
mcnlsx,
mcnlsy,
mcnlsz,
mcnlp)

  /* TRACE Component inter_analyzer_colimator_3_blade_4 [273] */
  mccoordschange(mcposrinter_analyzer_colimator_3_blade_4, mcrotrinter_analyzer_colimator_3_blade_4,
    &mcnlx,
    &mcnly,
    &mcnlz,
    &mcnlvx,
    &mcnlvy,
    &mcnlvz,
    &mcnlsx,
    &mcnlsy,
    &mcnlsz);
  /* define label inside component inter_analyzer_colimator_3_blade_4 (without coords transformations) */
  mcJumpTrace_inter_analyzer_colimator_3_blade_4:
  SIG_MESSAGE("inter_analyzer_colimator_3_blade_4 (Trace)");
  mcDEBUG_COMP("inter_analyzer_colimator_3_blade_4")
  mcDEBUG_STATE(
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp)
#define x mcnlx
#define y mcnly
#define z mcnlz
#define vx mcnlvx
#define vy mcnlvy
#define vz mcnlvz
#define t mcnlt
#define sx mcnlsx
#define sy mcnlsy
#define sz mcnlsz
#define p mcnlp

#define mcabsorbComp mcabsorbCompinter_analyzer_colimator_3_blade_4
  STORE_NEUTRON(273,
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp);
  mcScattered=0;
  mcRestore=0;
  mcNCounter[273]++;
  mcPCounter[273] += p;
  mcP2Counter[273] += p*p;
#define mccompcurname  inter_analyzer_colimator_3_blade_4
#define mccompcurtype  Union_box
#define mccompcurindex 273
#define loop_index mccinter_analyzer_colimator_3_blade_4_loop_index
#define this_box_volume mccinter_analyzer_colimator_3_blade_4_this_box_volume
#define global_geometry_element mccinter_analyzer_colimator_3_blade_4_global_geometry_element
#define this_box_storage mccinter_analyzer_colimator_3_blade_4_this_box_storage
{   /* Declarations of inter_analyzer_colimator_3_blade_4=Union_box() SETTING parameters. */
char* material_string = mccinter_analyzer_colimator_3_blade_4_material_string;
MCNUM priority = mccinter_analyzer_colimator_3_blade_4_priority;
MCNUM xwidth = mccinter_analyzer_colimator_3_blade_4_xwidth;
MCNUM yheight = mccinter_analyzer_colimator_3_blade_4_yheight;
MCNUM zdepth = mccinter_analyzer_colimator_3_blade_4_zdepth;
MCNUM xwidth2 = mccinter_analyzer_colimator_3_blade_4_xwidth2;
MCNUM yheight2 = mccinter_analyzer_colimator_3_blade_4_yheight2;
MCNUM visualize = mccinter_analyzer_colimator_3_blade_4_visualize;
int target_index = mccinter_analyzer_colimator_3_blade_4_target_index;
MCNUM target_x = mccinter_analyzer_colimator_3_blade_4_target_x;
MCNUM target_y = mccinter_analyzer_colimator_3_blade_4_target_y;
MCNUM target_z = mccinter_analyzer_colimator_3_blade_4_target_z;
MCNUM focus_aw = mccinter_analyzer_colimator_3_blade_4_focus_aw;
MCNUM focus_ah = mccinter_analyzer_colimator_3_blade_4_focus_ah;
MCNUM focus_xw = mccinter_analyzer_colimator_3_blade_4_focus_xw;
MCNUM focus_xh = mccinter_analyzer_colimator_3_blade_4_focus_xh;
MCNUM focus_r = mccinter_analyzer_colimator_3_blade_4_focus_r;
MCNUM p_interact = mccinter_analyzer_colimator_3_blade_4_p_interact;
char* mask_string = mccinter_analyzer_colimator_3_blade_4_mask_string;
char* mask_setting = mccinter_analyzer_colimator_3_blade_4_mask_setting;
MCNUM number_of_activations = mccinter_analyzer_colimator_3_blade_4_number_of_activations;
}   /* End of inter_analyzer_colimator_3_blade_4=Union_box() SETTING parameter declarations. */
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex
  /* Label for restoring  neutron */
  mcabsorbCompinter_analyzer_colimator_3_blade_4:
  if (RESTORE) /* restore if needed */
  { RESTORE_NEUTRON(273,
      mcnlx,
      mcnly,
      mcnlz,
      mcnlvx,
      mcnlvy,
      mcnlvz,
      mcnlt,
      mcnlsx,
      mcnlsy,
      mcnlsz,
      mcnlp); }
#undef mcabsorbComp
#undef p
#undef sz
#undef sy
#undef sx
#undef t
#undef vz
#undef vy
#undef vx
#undef z
#undef y
#undef x
  mcDEBUG_STATE(
mcnlx,
mcnly,
mcnlz,
mcnlvx,
mcnlvy,
mcnlvz,
mcnlt,
mcnlsx,
mcnlsy,
mcnlsz,
mcnlp)

  /* TRACE Component diffraction_detector_3_exit_volume [274] */
  mccoordschange(mcposrdiffraction_detector_3_exit_volume, mcrotrdiffraction_detector_3_exit_volume,
    &mcnlx,
    &mcnly,
    &mcnlz,
    &mcnlvx,
    &mcnlvy,
    &mcnlvz,
    &mcnlsx,
    &mcnlsy,
    &mcnlsz);
  /* define label inside component diffraction_detector_3_exit_volume (without coords transformations) */
  mcJumpTrace_diffraction_detector_3_exit_volume:
  SIG_MESSAGE("diffraction_detector_3_exit_volume (Trace)");
  mcDEBUG_COMP("diffraction_detector_3_exit_volume")
  mcDEBUG_STATE(
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp)
#define x mcnlx
#define y mcnly
#define z mcnlz
#define vx mcnlvx
#define vy mcnlvy
#define vz mcnlvz
#define t mcnlt
#define sx mcnlsx
#define sy mcnlsy
#define sz mcnlsz
#define p mcnlp

#define mcabsorbComp mcabsorbCompdiffraction_detector_3_exit_volume
  STORE_NEUTRON(274,
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp);
  mcScattered=0;
  mcRestore=0;
  mcNCounter[274]++;
  mcPCounter[274] += p;
  mcP2Counter[274] += p*p;
#define mccompcurname  diffraction_detector_3_exit_volume
#define mccompcurtype  Union_box
#define mccompcurindex 274
#define loop_index mccdiffraction_detector_3_exit_volume_loop_index
#define this_box_volume mccdiffraction_detector_3_exit_volume_this_box_volume
#define global_geometry_element mccdiffraction_detector_3_exit_volume_global_geometry_element
#define this_box_storage mccdiffraction_detector_3_exit_volume_this_box_storage
{   /* Declarations of diffraction_detector_3_exit_volume=Union_box() SETTING parameters. */
char* material_string = mccdiffraction_detector_3_exit_volume_material_string;
MCNUM priority = mccdiffraction_detector_3_exit_volume_priority;
MCNUM xwidth = mccdiffraction_detector_3_exit_volume_xwidth;
MCNUM yheight = mccdiffraction_detector_3_exit_volume_yheight;
MCNUM zdepth = mccdiffraction_detector_3_exit_volume_zdepth;
MCNUM xwidth2 = mccdiffraction_detector_3_exit_volume_xwidth2;
MCNUM yheight2 = mccdiffraction_detector_3_exit_volume_yheight2;
MCNUM visualize = mccdiffraction_detector_3_exit_volume_visualize;
int target_index = mccdiffraction_detector_3_exit_volume_target_index;
MCNUM target_x = mccdiffraction_detector_3_exit_volume_target_x;
MCNUM target_y = mccdiffraction_detector_3_exit_volume_target_y;
MCNUM target_z = mccdiffraction_detector_3_exit_volume_target_z;
MCNUM focus_aw = mccdiffraction_detector_3_exit_volume_focus_aw;
MCNUM focus_ah = mccdiffraction_detector_3_exit_volume_focus_ah;
MCNUM focus_xw = mccdiffraction_detector_3_exit_volume_focus_xw;
MCNUM focus_xh = mccdiffraction_detector_3_exit_volume_focus_xh;
MCNUM focus_r = mccdiffraction_detector_3_exit_volume_focus_r;
MCNUM p_interact = mccdiffraction_detector_3_exit_volume_p_interact;
char* mask_string = mccdiffraction_detector_3_exit_volume_mask_string;
char* mask_setting = mccdiffraction_detector_3_exit_volume_mask_setting;
MCNUM number_of_activations = mccdiffraction_detector_3_exit_volume_number_of_activations;
}   /* End of diffraction_detector_3_exit_volume=Union_box() SETTING parameter declarations. */
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex
  /* Label for restoring  neutron */
  mcabsorbCompdiffraction_detector_3_exit_volume:
  if (RESTORE) /* restore if needed */
  { RESTORE_NEUTRON(274,
      mcnlx,
      mcnly,
      mcnlz,
      mcnlvx,
      mcnlvy,
      mcnlvz,
      mcnlt,
      mcnlsx,
      mcnlsy,
      mcnlsz,
      mcnlp); }
#undef mcabsorbComp
#undef p
#undef sz
#undef sy
#undef sx
#undef t
#undef vz
#undef vy
#undef vx
#undef z
#undef y
#undef x
  mcDEBUG_STATE(
mcnlx,
mcnly,
mcnlz,
mcnlvx,
mcnlvy,
mcnlvz,
mcnlt,
mcnlsx,
mcnlsy,
mcnlsz,
mcnlp)

  /* TRACE Component spec_detector_3_exit_volume [275] */
  mccoordschange(mcposrspec_detector_3_exit_volume, mcrotrspec_detector_3_exit_volume,
    &mcnlx,
    &mcnly,
    &mcnlz,
    &mcnlvx,
    &mcnlvy,
    &mcnlvz,
    &mcnlsx,
    &mcnlsy,
    &mcnlsz);
  /* define label inside component spec_detector_3_exit_volume (without coords transformations) */
  mcJumpTrace_spec_detector_3_exit_volume:
  SIG_MESSAGE("spec_detector_3_exit_volume (Trace)");
  mcDEBUG_COMP("spec_detector_3_exit_volume")
  mcDEBUG_STATE(
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp)
#define x mcnlx
#define y mcnly
#define z mcnlz
#define vx mcnlvx
#define vy mcnlvy
#define vz mcnlvz
#define t mcnlt
#define sx mcnlsx
#define sy mcnlsy
#define sz mcnlsz
#define p mcnlp

#define mcabsorbComp mcabsorbCompspec_detector_3_exit_volume
  STORE_NEUTRON(275,
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp);
  mcScattered=0;
  mcRestore=0;
  mcNCounter[275]++;
  mcPCounter[275] += p;
  mcP2Counter[275] += p*p;
#define mccompcurname  spec_detector_3_exit_volume
#define mccompcurtype  Union_box
#define mccompcurindex 275
#define loop_index mccspec_detector_3_exit_volume_loop_index
#define this_box_volume mccspec_detector_3_exit_volume_this_box_volume
#define global_geometry_element mccspec_detector_3_exit_volume_global_geometry_element
#define this_box_storage mccspec_detector_3_exit_volume_this_box_storage
{   /* Declarations of spec_detector_3_exit_volume=Union_box() SETTING parameters. */
char* material_string = mccspec_detector_3_exit_volume_material_string;
MCNUM priority = mccspec_detector_3_exit_volume_priority;
MCNUM xwidth = mccspec_detector_3_exit_volume_xwidth;
MCNUM yheight = mccspec_detector_3_exit_volume_yheight;
MCNUM zdepth = mccspec_detector_3_exit_volume_zdepth;
MCNUM xwidth2 = mccspec_detector_3_exit_volume_xwidth2;
MCNUM yheight2 = mccspec_detector_3_exit_volume_yheight2;
MCNUM visualize = mccspec_detector_3_exit_volume_visualize;
int target_index = mccspec_detector_3_exit_volume_target_index;
MCNUM target_x = mccspec_detector_3_exit_volume_target_x;
MCNUM target_y = mccspec_detector_3_exit_volume_target_y;
MCNUM target_z = mccspec_detector_3_exit_volume_target_z;
MCNUM focus_aw = mccspec_detector_3_exit_volume_focus_aw;
MCNUM focus_ah = mccspec_detector_3_exit_volume_focus_ah;
MCNUM focus_xw = mccspec_detector_3_exit_volume_focus_xw;
MCNUM focus_xh = mccspec_detector_3_exit_volume_focus_xh;
MCNUM focus_r = mccspec_detector_3_exit_volume_focus_r;
MCNUM p_interact = mccspec_detector_3_exit_volume_p_interact;
char* mask_string = mccspec_detector_3_exit_volume_mask_string;
char* mask_setting = mccspec_detector_3_exit_volume_mask_setting;
MCNUM number_of_activations = mccspec_detector_3_exit_volume_number_of_activations;
}   /* End of spec_detector_3_exit_volume=Union_box() SETTING parameter declarations. */
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex
  /* Label for restoring  neutron */
  mcabsorbCompspec_detector_3_exit_volume:
  if (RESTORE) /* restore if needed */
  { RESTORE_NEUTRON(275,
      mcnlx,
      mcnly,
      mcnlz,
      mcnlvx,
      mcnlvy,
      mcnlvz,
      mcnlt,
      mcnlsx,
      mcnlsy,
      mcnlsz,
      mcnlp); }
#undef mcabsorbComp
#undef p
#undef sz
#undef sy
#undef sx
#undef t
#undef vz
#undef vy
#undef vx
#undef z
#undef y
#undef x
  mcDEBUG_STATE(
mcnlx,
mcnly,
mcnlz,
mcnlvx,
mcnlvy,
mcnlvz,
mcnlt,
mcnlsx,
mcnlsy,
mcnlsz,
mcnlp)

  /* TRACE Component channel_4_cave1_box1 [276] */
  mccoordschange(mcposrchannel_4_cave1_box1, mcrotrchannel_4_cave1_box1,
    &mcnlx,
    &mcnly,
    &mcnlz,
    &mcnlvx,
    &mcnlvy,
    &mcnlvz,
    &mcnlsx,
    &mcnlsy,
    &mcnlsz);
  /* define label inside component channel_4_cave1_box1 (without coords transformations) */
  mcJumpTrace_channel_4_cave1_box1:
  SIG_MESSAGE("channel_4_cave1_box1 (Trace)");
  mcDEBUG_COMP("channel_4_cave1_box1")
  mcDEBUG_STATE(
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp)
#define x mcnlx
#define y mcnly
#define z mcnlz
#define vx mcnlvx
#define vy mcnlvy
#define vz mcnlvz
#define t mcnlt
#define sx mcnlsx
#define sy mcnlsy
#define sz mcnlsz
#define p mcnlp

#define mcabsorbComp mcabsorbCompchannel_4_cave1_box1
  STORE_NEUTRON(276,
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp);
  mcScattered=0;
  mcRestore=0;
  mcNCounter[276]++;
  mcPCounter[276] += p;
  mcP2Counter[276] += p*p;
#define mccompcurname  channel_4_cave1_box1
#define mccompcurtype  Union_box
#define mccompcurindex 276
#define loop_index mccchannel_4_cave1_box1_loop_index
#define this_box_volume mccchannel_4_cave1_box1_this_box_volume
#define global_geometry_element mccchannel_4_cave1_box1_global_geometry_element
#define this_box_storage mccchannel_4_cave1_box1_this_box_storage
{   /* Declarations of channel_4_cave1_box1=Union_box() SETTING parameters. */
char* material_string = mccchannel_4_cave1_box1_material_string;
MCNUM priority = mccchannel_4_cave1_box1_priority;
MCNUM xwidth = mccchannel_4_cave1_box1_xwidth;
MCNUM yheight = mccchannel_4_cave1_box1_yheight;
MCNUM zdepth = mccchannel_4_cave1_box1_zdepth;
MCNUM xwidth2 = mccchannel_4_cave1_box1_xwidth2;
MCNUM yheight2 = mccchannel_4_cave1_box1_yheight2;
MCNUM visualize = mccchannel_4_cave1_box1_visualize;
int target_index = mccchannel_4_cave1_box1_target_index;
MCNUM target_x = mccchannel_4_cave1_box1_target_x;
MCNUM target_y = mccchannel_4_cave1_box1_target_y;
MCNUM target_z = mccchannel_4_cave1_box1_target_z;
MCNUM focus_aw = mccchannel_4_cave1_box1_focus_aw;
MCNUM focus_ah = mccchannel_4_cave1_box1_focus_ah;
MCNUM focus_xw = mccchannel_4_cave1_box1_focus_xw;
MCNUM focus_xh = mccchannel_4_cave1_box1_focus_xh;
MCNUM focus_r = mccchannel_4_cave1_box1_focus_r;
MCNUM p_interact = mccchannel_4_cave1_box1_p_interact;
char* mask_string = mccchannel_4_cave1_box1_mask_string;
char* mask_setting = mccchannel_4_cave1_box1_mask_setting;
MCNUM number_of_activations = mccchannel_4_cave1_box1_number_of_activations;
}   /* End of channel_4_cave1_box1=Union_box() SETTING parameter declarations. */
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex
  /* Label for restoring  neutron */
  mcabsorbCompchannel_4_cave1_box1:
  if (RESTORE) /* restore if needed */
  { RESTORE_NEUTRON(276,
      mcnlx,
      mcnly,
      mcnlz,
      mcnlvx,
      mcnlvy,
      mcnlvz,
      mcnlt,
      mcnlsx,
      mcnlsy,
      mcnlsz,
      mcnlp); }
#undef mcabsorbComp
#undef p
#undef sz
#undef sy
#undef sx
#undef t
#undef vz
#undef vy
#undef vx
#undef z
#undef y
#undef x
  mcDEBUG_STATE(
mcnlx,
mcnly,
mcnlz,
mcnlvx,
mcnlvy,
mcnlvz,
mcnlt,
mcnlsx,
mcnlsy,
mcnlsz,
mcnlp)

  /* TRACE Component channel_4_cave1_box2 [277] */
  mccoordschange(mcposrchannel_4_cave1_box2, mcrotrchannel_4_cave1_box2,
    &mcnlx,
    &mcnly,
    &mcnlz,
    &mcnlvx,
    &mcnlvy,
    &mcnlvz,
    &mcnlsx,
    &mcnlsy,
    &mcnlsz);
  /* define label inside component channel_4_cave1_box2 (without coords transformations) */
  mcJumpTrace_channel_4_cave1_box2:
  SIG_MESSAGE("channel_4_cave1_box2 (Trace)");
  mcDEBUG_COMP("channel_4_cave1_box2")
  mcDEBUG_STATE(
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp)
#define x mcnlx
#define y mcnly
#define z mcnlz
#define vx mcnlvx
#define vy mcnlvy
#define vz mcnlvz
#define t mcnlt
#define sx mcnlsx
#define sy mcnlsy
#define sz mcnlsz
#define p mcnlp

#define mcabsorbComp mcabsorbCompchannel_4_cave1_box2
  STORE_NEUTRON(277,
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp);
  mcScattered=0;
  mcRestore=0;
  mcNCounter[277]++;
  mcPCounter[277] += p;
  mcP2Counter[277] += p*p;
#define mccompcurname  channel_4_cave1_box2
#define mccompcurtype  Union_box
#define mccompcurindex 277
#define loop_index mccchannel_4_cave1_box2_loop_index
#define this_box_volume mccchannel_4_cave1_box2_this_box_volume
#define global_geometry_element mccchannel_4_cave1_box2_global_geometry_element
#define this_box_storage mccchannel_4_cave1_box2_this_box_storage
{   /* Declarations of channel_4_cave1_box2=Union_box() SETTING parameters. */
char* material_string = mccchannel_4_cave1_box2_material_string;
MCNUM priority = mccchannel_4_cave1_box2_priority;
MCNUM xwidth = mccchannel_4_cave1_box2_xwidth;
MCNUM yheight = mccchannel_4_cave1_box2_yheight;
MCNUM zdepth = mccchannel_4_cave1_box2_zdepth;
MCNUM xwidth2 = mccchannel_4_cave1_box2_xwidth2;
MCNUM yheight2 = mccchannel_4_cave1_box2_yheight2;
MCNUM visualize = mccchannel_4_cave1_box2_visualize;
int target_index = mccchannel_4_cave1_box2_target_index;
MCNUM target_x = mccchannel_4_cave1_box2_target_x;
MCNUM target_y = mccchannel_4_cave1_box2_target_y;
MCNUM target_z = mccchannel_4_cave1_box2_target_z;
MCNUM focus_aw = mccchannel_4_cave1_box2_focus_aw;
MCNUM focus_ah = mccchannel_4_cave1_box2_focus_ah;
MCNUM focus_xw = mccchannel_4_cave1_box2_focus_xw;
MCNUM focus_xh = mccchannel_4_cave1_box2_focus_xh;
MCNUM focus_r = mccchannel_4_cave1_box2_focus_r;
MCNUM p_interact = mccchannel_4_cave1_box2_p_interact;
char* mask_string = mccchannel_4_cave1_box2_mask_string;
char* mask_setting = mccchannel_4_cave1_box2_mask_setting;
MCNUM number_of_activations = mccchannel_4_cave1_box2_number_of_activations;
}   /* End of channel_4_cave1_box2=Union_box() SETTING parameter declarations. */
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex
  /* Label for restoring  neutron */
  mcabsorbCompchannel_4_cave1_box2:
  if (RESTORE) /* restore if needed */
  { RESTORE_NEUTRON(277,
      mcnlx,
      mcnly,
      mcnlz,
      mcnlvx,
      mcnlvy,
      mcnlvz,
      mcnlt,
      mcnlsx,
      mcnlsy,
      mcnlsz,
      mcnlp); }
#undef mcabsorbComp
#undef p
#undef sz
#undef sy
#undef sx
#undef t
#undef vz
#undef vy
#undef vx
#undef z
#undef y
#undef x
  mcDEBUG_STATE(
mcnlx,
mcnly,
mcnlz,
mcnlvx,
mcnlvy,
mcnlvz,
mcnlt,
mcnlsx,
mcnlsy,
mcnlsz,
mcnlp)

  /* TRACE Component channel_4_cave1_box3 [278] */
  mccoordschange(mcposrchannel_4_cave1_box3, mcrotrchannel_4_cave1_box3,
    &mcnlx,
    &mcnly,
    &mcnlz,
    &mcnlvx,
    &mcnlvy,
    &mcnlvz,
    &mcnlsx,
    &mcnlsy,
    &mcnlsz);
  /* define label inside component channel_4_cave1_box3 (without coords transformations) */
  mcJumpTrace_channel_4_cave1_box3:
  SIG_MESSAGE("channel_4_cave1_box3 (Trace)");
  mcDEBUG_COMP("channel_4_cave1_box3")
  mcDEBUG_STATE(
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp)
#define x mcnlx
#define y mcnly
#define z mcnlz
#define vx mcnlvx
#define vy mcnlvy
#define vz mcnlvz
#define t mcnlt
#define sx mcnlsx
#define sy mcnlsy
#define sz mcnlsz
#define p mcnlp

#define mcabsorbComp mcabsorbCompchannel_4_cave1_box3
  STORE_NEUTRON(278,
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp);
  mcScattered=0;
  mcRestore=0;
  mcNCounter[278]++;
  mcPCounter[278] += p;
  mcP2Counter[278] += p*p;
#define mccompcurname  channel_4_cave1_box3
#define mccompcurtype  Union_box
#define mccompcurindex 278
#define loop_index mccchannel_4_cave1_box3_loop_index
#define this_box_volume mccchannel_4_cave1_box3_this_box_volume
#define global_geometry_element mccchannel_4_cave1_box3_global_geometry_element
#define this_box_storage mccchannel_4_cave1_box3_this_box_storage
{   /* Declarations of channel_4_cave1_box3=Union_box() SETTING parameters. */
char* material_string = mccchannel_4_cave1_box3_material_string;
MCNUM priority = mccchannel_4_cave1_box3_priority;
MCNUM xwidth = mccchannel_4_cave1_box3_xwidth;
MCNUM yheight = mccchannel_4_cave1_box3_yheight;
MCNUM zdepth = mccchannel_4_cave1_box3_zdepth;
MCNUM xwidth2 = mccchannel_4_cave1_box3_xwidth2;
MCNUM yheight2 = mccchannel_4_cave1_box3_yheight2;
MCNUM visualize = mccchannel_4_cave1_box3_visualize;
int target_index = mccchannel_4_cave1_box3_target_index;
MCNUM target_x = mccchannel_4_cave1_box3_target_x;
MCNUM target_y = mccchannel_4_cave1_box3_target_y;
MCNUM target_z = mccchannel_4_cave1_box3_target_z;
MCNUM focus_aw = mccchannel_4_cave1_box3_focus_aw;
MCNUM focus_ah = mccchannel_4_cave1_box3_focus_ah;
MCNUM focus_xw = mccchannel_4_cave1_box3_focus_xw;
MCNUM focus_xh = mccchannel_4_cave1_box3_focus_xh;
MCNUM focus_r = mccchannel_4_cave1_box3_focus_r;
MCNUM p_interact = mccchannel_4_cave1_box3_p_interact;
char* mask_string = mccchannel_4_cave1_box3_mask_string;
char* mask_setting = mccchannel_4_cave1_box3_mask_setting;
MCNUM number_of_activations = mccchannel_4_cave1_box3_number_of_activations;
}   /* End of channel_4_cave1_box3=Union_box() SETTING parameter declarations. */
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex
  /* Label for restoring  neutron */
  mcabsorbCompchannel_4_cave1_box3:
  if (RESTORE) /* restore if needed */
  { RESTORE_NEUTRON(278,
      mcnlx,
      mcnly,
      mcnlz,
      mcnlvx,
      mcnlvy,
      mcnlvz,
      mcnlt,
      mcnlsx,
      mcnlsy,
      mcnlsz,
      mcnlp); }
#undef mcabsorbComp
#undef p
#undef sz
#undef sy
#undef sx
#undef t
#undef vz
#undef vy
#undef vx
#undef z
#undef y
#undef x
  mcDEBUG_STATE(
mcnlx,
mcnly,
mcnlz,
mcnlvx,
mcnlvy,
mcnlvz,
mcnlt,
mcnlsx,
mcnlsy,
mcnlsz,
mcnlp)

  /* TRACE Component channel_4_cave1_cyl1 [279] */
  mccoordschange(mcposrchannel_4_cave1_cyl1, mcrotrchannel_4_cave1_cyl1,
    &mcnlx,
    &mcnly,
    &mcnlz,
    &mcnlvx,
    &mcnlvy,
    &mcnlvz,
    &mcnlsx,
    &mcnlsy,
    &mcnlsz);
  /* define label inside component channel_4_cave1_cyl1 (without coords transformations) */
  mcJumpTrace_channel_4_cave1_cyl1:
  SIG_MESSAGE("channel_4_cave1_cyl1 (Trace)");
  mcDEBUG_COMP("channel_4_cave1_cyl1")
  mcDEBUG_STATE(
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp)
#define x mcnlx
#define y mcnly
#define z mcnlz
#define vx mcnlvx
#define vy mcnlvy
#define vz mcnlvz
#define t mcnlt
#define sx mcnlsx
#define sy mcnlsy
#define sz mcnlsz
#define p mcnlp

#define mcabsorbComp mcabsorbCompchannel_4_cave1_cyl1
  STORE_NEUTRON(279,
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp);
  mcScattered=0;
  mcRestore=0;
  mcNCounter[279]++;
  mcPCounter[279] += p;
  mcP2Counter[279] += p*p;
#define mccompcurname  channel_4_cave1_cyl1
#define mccompcurtype  Union_cylinder
#define mccompcurindex 279
#define loop_index mccchannel_4_cave1_cyl1_loop_index
#define this_cylinder_volume mccchannel_4_cave1_cyl1_this_cylinder_volume
#define global_geometry_element mccchannel_4_cave1_cyl1_global_geometry_element
#define this_cylinder_storage mccchannel_4_cave1_cyl1_this_cylinder_storage
{   /* Declarations of channel_4_cave1_cyl1=Union_cylinder() SETTING parameters. */
char* material_string = mccchannel_4_cave1_cyl1_material_string;
MCNUM priority = mccchannel_4_cave1_cyl1_priority;
MCNUM radius = mccchannel_4_cave1_cyl1_radius;
MCNUM yheight = mccchannel_4_cave1_cyl1_yheight;
MCNUM visualize = mccchannel_4_cave1_cyl1_visualize;
int target_index = mccchannel_4_cave1_cyl1_target_index;
MCNUM target_x = mccchannel_4_cave1_cyl1_target_x;
MCNUM target_y = mccchannel_4_cave1_cyl1_target_y;
MCNUM target_z = mccchannel_4_cave1_cyl1_target_z;
MCNUM focus_aw = mccchannel_4_cave1_cyl1_focus_aw;
MCNUM focus_ah = mccchannel_4_cave1_cyl1_focus_ah;
MCNUM focus_xw = mccchannel_4_cave1_cyl1_focus_xw;
MCNUM focus_xh = mccchannel_4_cave1_cyl1_focus_xh;
MCNUM focus_r = mccchannel_4_cave1_cyl1_focus_r;
MCNUM p_interact = mccchannel_4_cave1_cyl1_p_interact;
char* mask_string = mccchannel_4_cave1_cyl1_mask_string;
char* mask_setting = mccchannel_4_cave1_cyl1_mask_setting;
MCNUM number_of_activations = mccchannel_4_cave1_cyl1_number_of_activations;
#line 345 "Union_cylinder.comp"
{
dummy = 1;
}
#line 382822 "MACS_sample_kidney_box.c"
}   /* End of channel_4_cave1_cyl1=Union_cylinder() SETTING parameter declarations. */
#undef this_cylinder_storage
#undef global_geometry_element
#undef this_cylinder_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex
  /* Label for restoring  neutron */
  mcabsorbCompchannel_4_cave1_cyl1:
  if (RESTORE) /* restore if needed */
  { RESTORE_NEUTRON(279,
      mcnlx,
      mcnly,
      mcnlz,
      mcnlvx,
      mcnlvy,
      mcnlvz,
      mcnlt,
      mcnlsx,
      mcnlsy,
      mcnlsz,
      mcnlp); }
#undef mcabsorbComp
#undef p
#undef sz
#undef sy
#undef sx
#undef t
#undef vz
#undef vy
#undef vx
#undef z
#undef y
#undef x
  mcDEBUG_STATE(
mcnlx,
mcnly,
mcnlz,
mcnlvx,
mcnlvy,
mcnlvz,
mcnlt,
mcnlsx,
mcnlsy,
mcnlsz,
mcnlp)

  /* TRACE Component channel_4_analyzer_1_center [280] */
  mccoordschange(mcposrchannel_4_analyzer_1_center, mcrotrchannel_4_analyzer_1_center,
    &mcnlx,
    &mcnly,
    &mcnlz,
    &mcnlvx,
    &mcnlvy,
    &mcnlvz,
    &mcnlsx,
    &mcnlsy,
    &mcnlsz);
  /* define label inside component channel_4_analyzer_1_center (without coords transformations) */
  mcJumpTrace_channel_4_analyzer_1_center:
  SIG_MESSAGE("channel_4_analyzer_1_center (Trace)");
  mcDEBUG_COMP("channel_4_analyzer_1_center")
  mcDEBUG_STATE(
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp)
#define x mcnlx
#define y mcnly
#define z mcnlz
#define vx mcnlvx
#define vy mcnlvy
#define vz mcnlvz
#define t mcnlt
#define sx mcnlsx
#define sy mcnlsy
#define sz mcnlsz
#define p mcnlp

#define mcabsorbComp mcabsorbCompchannel_4_analyzer_1_center
  STORE_NEUTRON(280,
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp);
  mcScattered=0;
  mcRestore=0;
  mcNCounter[280]++;
  mcPCounter[280] += p;
  mcP2Counter[280] += p*p;
#define mccompcurname  channel_4_analyzer_1_center
#define mccompcurtype  Arm
#define mccompcurindex 280
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex
  /* Label for restoring  neutron */
  mcabsorbCompchannel_4_analyzer_1_center:
  if (RESTORE) /* restore if needed */
  { RESTORE_NEUTRON(280,
      mcnlx,
      mcnly,
      mcnlz,
      mcnlvx,
      mcnlvy,
      mcnlvz,
      mcnlt,
      mcnlsx,
      mcnlsy,
      mcnlsz,
      mcnlp); }
#undef mcabsorbComp
#undef p
#undef sz
#undef sy
#undef sx
#undef t
#undef vz
#undef vy
#undef vx
#undef z
#undef y
#undef x
  mcDEBUG_STATE(
mcnlx,
mcnly,
mcnlz,
mcnlvx,
mcnlvy,
mcnlvz,
mcnlt,
mcnlsx,
mcnlsy,
mcnlsz,
mcnlp)

  /* TRACE Component channel_4_analyzer_1_rotated [281] */
  mccoordschange(mcposrchannel_4_analyzer_1_rotated, mcrotrchannel_4_analyzer_1_rotated,
    &mcnlx,
    &mcnly,
    &mcnlz,
    &mcnlvx,
    &mcnlvy,
    &mcnlvz,
    &mcnlsx,
    &mcnlsy,
    &mcnlsz);
  /* define label inside component channel_4_analyzer_1_rotated (without coords transformations) */
  mcJumpTrace_channel_4_analyzer_1_rotated:
  SIG_MESSAGE("channel_4_analyzer_1_rotated (Trace)");
  mcDEBUG_COMP("channel_4_analyzer_1_rotated")
  mcDEBUG_STATE(
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp)
#define x mcnlx
#define y mcnly
#define z mcnlz
#define vx mcnlvx
#define vy mcnlvy
#define vz mcnlvz
#define t mcnlt
#define sx mcnlsx
#define sy mcnlsy
#define sz mcnlsz
#define p mcnlp

#define mcabsorbComp mcabsorbCompchannel_4_analyzer_1_rotated
  STORE_NEUTRON(281,
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp);
  mcScattered=0;
  mcRestore=0;
  mcNCounter[281]++;
  mcPCounter[281] += p;
  mcP2Counter[281] += p*p;
#define mccompcurname  channel_4_analyzer_1_rotated
#define mccompcurtype  Arm
#define mccompcurindex 281
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex
  /* Label for restoring  neutron */
  mcabsorbCompchannel_4_analyzer_1_rotated:
  if (RESTORE) /* restore if needed */
  { RESTORE_NEUTRON(281,
      mcnlx,
      mcnly,
      mcnlz,
      mcnlvx,
      mcnlvy,
      mcnlvz,
      mcnlt,
      mcnlsx,
      mcnlsy,
      mcnlsz,
      mcnlp); }
#undef mcabsorbComp
#undef p
#undef sz
#undef sy
#undef sx
#undef t
#undef vz
#undef vy
#undef vx
#undef z
#undef y
#undef x
  mcDEBUG_STATE(
mcnlx,
mcnly,
mcnlz,
mcnlvx,
mcnlvy,
mcnlvz,
mcnlt,
mcnlsx,
mcnlsy,
mcnlsz,
mcnlp)

  /* TRACE Component channel_4_analyzer_1_array_crystal_array_0 [282] */
  mccoordschange(mcposrchannel_4_analyzer_1_array_crystal_array_0, mcrotrchannel_4_analyzer_1_array_crystal_array_0,
    &mcnlx,
    &mcnly,
    &mcnlz,
    &mcnlvx,
    &mcnlvy,
    &mcnlvz,
    &mcnlsx,
    &mcnlsy,
    &mcnlsz);
  /* define label inside component channel_4_analyzer_1_array_crystal_array_0 (without coords transformations) */
  mcJumpTrace_channel_4_analyzer_1_array_crystal_array_0:
  SIG_MESSAGE("channel_4_analyzer_1_array_crystal_array_0 (Trace)");
  mcDEBUG_COMP("channel_4_analyzer_1_array_crystal_array_0")
  mcDEBUG_STATE(
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp)
#define x mcnlx
#define y mcnly
#define z mcnlz
#define vx mcnlvx
#define vy mcnlvy
#define vz mcnlvz
#define t mcnlt
#define sx mcnlsx
#define sy mcnlsy
#define sz mcnlsz
#define p mcnlp

#define mcabsorbComp mcabsorbCompchannel_4_analyzer_1_array_crystal_array_0
  STORE_NEUTRON(282,
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp);
  mcScattered=0;
  mcRestore=0;
  mcNCounter[282]++;
  mcPCounter[282] += p;
  mcP2Counter[282] += p*p;
#define mccompcurname  channel_4_analyzer_1_array_crystal_array_0
#define mccompcurtype  Union_box
#define mccompcurindex 282
#define loop_index mccchannel_4_analyzer_1_array_crystal_array_0_loop_index
#define this_box_volume mccchannel_4_analyzer_1_array_crystal_array_0_this_box_volume
#define global_geometry_element mccchannel_4_analyzer_1_array_crystal_array_0_global_geometry_element
#define this_box_storage mccchannel_4_analyzer_1_array_crystal_array_0_this_box_storage
{   /* Declarations of channel_4_analyzer_1_array_crystal_array_0=Union_box() SETTING parameters. */
char* material_string = mccchannel_4_analyzer_1_array_crystal_array_0_material_string;
MCNUM priority = mccchannel_4_analyzer_1_array_crystal_array_0_priority;
MCNUM xwidth = mccchannel_4_analyzer_1_array_crystal_array_0_xwidth;
MCNUM yheight = mccchannel_4_analyzer_1_array_crystal_array_0_yheight;
MCNUM zdepth = mccchannel_4_analyzer_1_array_crystal_array_0_zdepth;
MCNUM xwidth2 = mccchannel_4_analyzer_1_array_crystal_array_0_xwidth2;
MCNUM yheight2 = mccchannel_4_analyzer_1_array_crystal_array_0_yheight2;
MCNUM visualize = mccchannel_4_analyzer_1_array_crystal_array_0_visualize;
int target_index = mccchannel_4_analyzer_1_array_crystal_array_0_target_index;
MCNUM target_x = mccchannel_4_analyzer_1_array_crystal_array_0_target_x;
MCNUM target_y = mccchannel_4_analyzer_1_array_crystal_array_0_target_y;
MCNUM target_z = mccchannel_4_analyzer_1_array_crystal_array_0_target_z;
MCNUM focus_aw = mccchannel_4_analyzer_1_array_crystal_array_0_focus_aw;
MCNUM focus_ah = mccchannel_4_analyzer_1_array_crystal_array_0_focus_ah;
MCNUM focus_xw = mccchannel_4_analyzer_1_array_crystal_array_0_focus_xw;
MCNUM focus_xh = mccchannel_4_analyzer_1_array_crystal_array_0_focus_xh;
MCNUM focus_r = mccchannel_4_analyzer_1_array_crystal_array_0_focus_r;
MCNUM p_interact = mccchannel_4_analyzer_1_array_crystal_array_0_p_interact;
char* mask_string = mccchannel_4_analyzer_1_array_crystal_array_0_mask_string;
char* mask_setting = mccchannel_4_analyzer_1_array_crystal_array_0_mask_setting;
MCNUM number_of_activations = mccchannel_4_analyzer_1_array_crystal_array_0_number_of_activations;
}   /* End of channel_4_analyzer_1_array_crystal_array_0=Union_box() SETTING parameter declarations. */
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex
  /* Label for restoring  neutron */
  mcabsorbCompchannel_4_analyzer_1_array_crystal_array_0:
  if (RESTORE) /* restore if needed */
  { RESTORE_NEUTRON(282,
      mcnlx,
      mcnly,
      mcnlz,
      mcnlvx,
      mcnlvy,
      mcnlvz,
      mcnlt,
      mcnlsx,
      mcnlsy,
      mcnlsz,
      mcnlp); }
#undef mcabsorbComp
#undef p
#undef sz
#undef sy
#undef sx
#undef t
#undef vz
#undef vy
#undef vx
#undef z
#undef y
#undef x
  mcDEBUG_STATE(
mcnlx,
mcnly,
mcnlz,
mcnlvx,
mcnlvy,
mcnlvz,
mcnlt,
mcnlsx,
mcnlsy,
mcnlsz,
mcnlp)

  /* TRACE Component channel_4_analyzer_1_array_crystal_array_1 [283] */
  mccoordschange(mcposrchannel_4_analyzer_1_array_crystal_array_1, mcrotrchannel_4_analyzer_1_array_crystal_array_1,
    &mcnlx,
    &mcnly,
    &mcnlz,
    &mcnlvx,
    &mcnlvy,
    &mcnlvz,
    &mcnlsx,
    &mcnlsy,
    &mcnlsz);
  /* define label inside component channel_4_analyzer_1_array_crystal_array_1 (without coords transformations) */
  mcJumpTrace_channel_4_analyzer_1_array_crystal_array_1:
  SIG_MESSAGE("channel_4_analyzer_1_array_crystal_array_1 (Trace)");
  mcDEBUG_COMP("channel_4_analyzer_1_array_crystal_array_1")
  mcDEBUG_STATE(
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp)
#define x mcnlx
#define y mcnly
#define z mcnlz
#define vx mcnlvx
#define vy mcnlvy
#define vz mcnlvz
#define t mcnlt
#define sx mcnlsx
#define sy mcnlsy
#define sz mcnlsz
#define p mcnlp

#define mcabsorbComp mcabsorbCompchannel_4_analyzer_1_array_crystal_array_1
  STORE_NEUTRON(283,
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp);
  mcScattered=0;
  mcRestore=0;
  mcNCounter[283]++;
  mcPCounter[283] += p;
  mcP2Counter[283] += p*p;
#define mccompcurname  channel_4_analyzer_1_array_crystal_array_1
#define mccompcurtype  Union_box
#define mccompcurindex 283
#define loop_index mccchannel_4_analyzer_1_array_crystal_array_1_loop_index
#define this_box_volume mccchannel_4_analyzer_1_array_crystal_array_1_this_box_volume
#define global_geometry_element mccchannel_4_analyzer_1_array_crystal_array_1_global_geometry_element
#define this_box_storage mccchannel_4_analyzer_1_array_crystal_array_1_this_box_storage
{   /* Declarations of channel_4_analyzer_1_array_crystal_array_1=Union_box() SETTING parameters. */
char* material_string = mccchannel_4_analyzer_1_array_crystal_array_1_material_string;
MCNUM priority = mccchannel_4_analyzer_1_array_crystal_array_1_priority;
MCNUM xwidth = mccchannel_4_analyzer_1_array_crystal_array_1_xwidth;
MCNUM yheight = mccchannel_4_analyzer_1_array_crystal_array_1_yheight;
MCNUM zdepth = mccchannel_4_analyzer_1_array_crystal_array_1_zdepth;
MCNUM xwidth2 = mccchannel_4_analyzer_1_array_crystal_array_1_xwidth2;
MCNUM yheight2 = mccchannel_4_analyzer_1_array_crystal_array_1_yheight2;
MCNUM visualize = mccchannel_4_analyzer_1_array_crystal_array_1_visualize;
int target_index = mccchannel_4_analyzer_1_array_crystal_array_1_target_index;
MCNUM target_x = mccchannel_4_analyzer_1_array_crystal_array_1_target_x;
MCNUM target_y = mccchannel_4_analyzer_1_array_crystal_array_1_target_y;
MCNUM target_z = mccchannel_4_analyzer_1_array_crystal_array_1_target_z;
MCNUM focus_aw = mccchannel_4_analyzer_1_array_crystal_array_1_focus_aw;
MCNUM focus_ah = mccchannel_4_analyzer_1_array_crystal_array_1_focus_ah;
MCNUM focus_xw = mccchannel_4_analyzer_1_array_crystal_array_1_focus_xw;
MCNUM focus_xh = mccchannel_4_analyzer_1_array_crystal_array_1_focus_xh;
MCNUM focus_r = mccchannel_4_analyzer_1_array_crystal_array_1_focus_r;
MCNUM p_interact = mccchannel_4_analyzer_1_array_crystal_array_1_p_interact;
char* mask_string = mccchannel_4_analyzer_1_array_crystal_array_1_mask_string;
char* mask_setting = mccchannel_4_analyzer_1_array_crystal_array_1_mask_setting;
MCNUM number_of_activations = mccchannel_4_analyzer_1_array_crystal_array_1_number_of_activations;
}   /* End of channel_4_analyzer_1_array_crystal_array_1=Union_box() SETTING parameter declarations. */
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex
  /* Label for restoring  neutron */
  mcabsorbCompchannel_4_analyzer_1_array_crystal_array_1:
  if (RESTORE) /* restore if needed */
  { RESTORE_NEUTRON(283,
      mcnlx,
      mcnly,
      mcnlz,
      mcnlvx,
      mcnlvy,
      mcnlvz,
      mcnlt,
      mcnlsx,
      mcnlsy,
      mcnlsz,
      mcnlp); }
#undef mcabsorbComp
#undef p
#undef sz
#undef sy
#undef sx
#undef t
#undef vz
#undef vy
#undef vx
#undef z
#undef y
#undef x
  mcDEBUG_STATE(
mcnlx,
mcnly,
mcnlz,
mcnlvx,
mcnlvy,
mcnlvz,
mcnlt,
mcnlsx,
mcnlsy,
mcnlsz,
mcnlp)

  /* TRACE Component channel_4_analyzer_1_array_crystal_array_2 [284] */
  mccoordschange(mcposrchannel_4_analyzer_1_array_crystal_array_2, mcrotrchannel_4_analyzer_1_array_crystal_array_2,
    &mcnlx,
    &mcnly,
    &mcnlz,
    &mcnlvx,
    &mcnlvy,
    &mcnlvz,
    &mcnlsx,
    &mcnlsy,
    &mcnlsz);
  /* define label inside component channel_4_analyzer_1_array_crystal_array_2 (without coords transformations) */
  mcJumpTrace_channel_4_analyzer_1_array_crystal_array_2:
  SIG_MESSAGE("channel_4_analyzer_1_array_crystal_array_2 (Trace)");
  mcDEBUG_COMP("channel_4_analyzer_1_array_crystal_array_2")
  mcDEBUG_STATE(
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp)
#define x mcnlx
#define y mcnly
#define z mcnlz
#define vx mcnlvx
#define vy mcnlvy
#define vz mcnlvz
#define t mcnlt
#define sx mcnlsx
#define sy mcnlsy
#define sz mcnlsz
#define p mcnlp

#define mcabsorbComp mcabsorbCompchannel_4_analyzer_1_array_crystal_array_2
  STORE_NEUTRON(284,
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp);
  mcScattered=0;
  mcRestore=0;
  mcNCounter[284]++;
  mcPCounter[284] += p;
  mcP2Counter[284] += p*p;
#define mccompcurname  channel_4_analyzer_1_array_crystal_array_2
#define mccompcurtype  Union_box
#define mccompcurindex 284
#define loop_index mccchannel_4_analyzer_1_array_crystal_array_2_loop_index
#define this_box_volume mccchannel_4_analyzer_1_array_crystal_array_2_this_box_volume
#define global_geometry_element mccchannel_4_analyzer_1_array_crystal_array_2_global_geometry_element
#define this_box_storage mccchannel_4_analyzer_1_array_crystal_array_2_this_box_storage
{   /* Declarations of channel_4_analyzer_1_array_crystal_array_2=Union_box() SETTING parameters. */
char* material_string = mccchannel_4_analyzer_1_array_crystal_array_2_material_string;
MCNUM priority = mccchannel_4_analyzer_1_array_crystal_array_2_priority;
MCNUM xwidth = mccchannel_4_analyzer_1_array_crystal_array_2_xwidth;
MCNUM yheight = mccchannel_4_analyzer_1_array_crystal_array_2_yheight;
MCNUM zdepth = mccchannel_4_analyzer_1_array_crystal_array_2_zdepth;
MCNUM xwidth2 = mccchannel_4_analyzer_1_array_crystal_array_2_xwidth2;
MCNUM yheight2 = mccchannel_4_analyzer_1_array_crystal_array_2_yheight2;
MCNUM visualize = mccchannel_4_analyzer_1_array_crystal_array_2_visualize;
int target_index = mccchannel_4_analyzer_1_array_crystal_array_2_target_index;
MCNUM target_x = mccchannel_4_analyzer_1_array_crystal_array_2_target_x;
MCNUM target_y = mccchannel_4_analyzer_1_array_crystal_array_2_target_y;
MCNUM target_z = mccchannel_4_analyzer_1_array_crystal_array_2_target_z;
MCNUM focus_aw = mccchannel_4_analyzer_1_array_crystal_array_2_focus_aw;
MCNUM focus_ah = mccchannel_4_analyzer_1_array_crystal_array_2_focus_ah;
MCNUM focus_xw = mccchannel_4_analyzer_1_array_crystal_array_2_focus_xw;
MCNUM focus_xh = mccchannel_4_analyzer_1_array_crystal_array_2_focus_xh;
MCNUM focus_r = mccchannel_4_analyzer_1_array_crystal_array_2_focus_r;
MCNUM p_interact = mccchannel_4_analyzer_1_array_crystal_array_2_p_interact;
char* mask_string = mccchannel_4_analyzer_1_array_crystal_array_2_mask_string;
char* mask_setting = mccchannel_4_analyzer_1_array_crystal_array_2_mask_setting;
MCNUM number_of_activations = mccchannel_4_analyzer_1_array_crystal_array_2_number_of_activations;
}   /* End of channel_4_analyzer_1_array_crystal_array_2=Union_box() SETTING parameter declarations. */
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex
  /* Label for restoring  neutron */
  mcabsorbCompchannel_4_analyzer_1_array_crystal_array_2:
  if (RESTORE) /* restore if needed */
  { RESTORE_NEUTRON(284,
      mcnlx,
      mcnly,
      mcnlz,
      mcnlvx,
      mcnlvy,
      mcnlvz,
      mcnlt,
      mcnlsx,
      mcnlsy,
      mcnlsz,
      mcnlp); }
#undef mcabsorbComp
#undef p
#undef sz
#undef sy
#undef sx
#undef t
#undef vz
#undef vy
#undef vx
#undef z
#undef y
#undef x
  mcDEBUG_STATE(
mcnlx,
mcnly,
mcnlz,
mcnlvx,
mcnlvy,
mcnlvz,
mcnlt,
mcnlsx,
mcnlsy,
mcnlsz,
mcnlp)

  /* TRACE Component channel_4_analyzer_1_array_crystal_array_3 [285] */
  mccoordschange(mcposrchannel_4_analyzer_1_array_crystal_array_3, mcrotrchannel_4_analyzer_1_array_crystal_array_3,
    &mcnlx,
    &mcnly,
    &mcnlz,
    &mcnlvx,
    &mcnlvy,
    &mcnlvz,
    &mcnlsx,
    &mcnlsy,
    &mcnlsz);
  /* define label inside component channel_4_analyzer_1_array_crystal_array_3 (without coords transformations) */
  mcJumpTrace_channel_4_analyzer_1_array_crystal_array_3:
  SIG_MESSAGE("channel_4_analyzer_1_array_crystal_array_3 (Trace)");
  mcDEBUG_COMP("channel_4_analyzer_1_array_crystal_array_3")
  mcDEBUG_STATE(
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp)
#define x mcnlx
#define y mcnly
#define z mcnlz
#define vx mcnlvx
#define vy mcnlvy
#define vz mcnlvz
#define t mcnlt
#define sx mcnlsx
#define sy mcnlsy
#define sz mcnlsz
#define p mcnlp

#define mcabsorbComp mcabsorbCompchannel_4_analyzer_1_array_crystal_array_3
  STORE_NEUTRON(285,
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp);
  mcScattered=0;
  mcRestore=0;
  mcNCounter[285]++;
  mcPCounter[285] += p;
  mcP2Counter[285] += p*p;
#define mccompcurname  channel_4_analyzer_1_array_crystal_array_3
#define mccompcurtype  Union_box
#define mccompcurindex 285
#define loop_index mccchannel_4_analyzer_1_array_crystal_array_3_loop_index
#define this_box_volume mccchannel_4_analyzer_1_array_crystal_array_3_this_box_volume
#define global_geometry_element mccchannel_4_analyzer_1_array_crystal_array_3_global_geometry_element
#define this_box_storage mccchannel_4_analyzer_1_array_crystal_array_3_this_box_storage
{   /* Declarations of channel_4_analyzer_1_array_crystal_array_3=Union_box() SETTING parameters. */
char* material_string = mccchannel_4_analyzer_1_array_crystal_array_3_material_string;
MCNUM priority = mccchannel_4_analyzer_1_array_crystal_array_3_priority;
MCNUM xwidth = mccchannel_4_analyzer_1_array_crystal_array_3_xwidth;
MCNUM yheight = mccchannel_4_analyzer_1_array_crystal_array_3_yheight;
MCNUM zdepth = mccchannel_4_analyzer_1_array_crystal_array_3_zdepth;
MCNUM xwidth2 = mccchannel_4_analyzer_1_array_crystal_array_3_xwidth2;
MCNUM yheight2 = mccchannel_4_analyzer_1_array_crystal_array_3_yheight2;
MCNUM visualize = mccchannel_4_analyzer_1_array_crystal_array_3_visualize;
int target_index = mccchannel_4_analyzer_1_array_crystal_array_3_target_index;
MCNUM target_x = mccchannel_4_analyzer_1_array_crystal_array_3_target_x;
MCNUM target_y = mccchannel_4_analyzer_1_array_crystal_array_3_target_y;
MCNUM target_z = mccchannel_4_analyzer_1_array_crystal_array_3_target_z;
MCNUM focus_aw = mccchannel_4_analyzer_1_array_crystal_array_3_focus_aw;
MCNUM focus_ah = mccchannel_4_analyzer_1_array_crystal_array_3_focus_ah;
MCNUM focus_xw = mccchannel_4_analyzer_1_array_crystal_array_3_focus_xw;
MCNUM focus_xh = mccchannel_4_analyzer_1_array_crystal_array_3_focus_xh;
MCNUM focus_r = mccchannel_4_analyzer_1_array_crystal_array_3_focus_r;
MCNUM p_interact = mccchannel_4_analyzer_1_array_crystal_array_3_p_interact;
char* mask_string = mccchannel_4_analyzer_1_array_crystal_array_3_mask_string;
char* mask_setting = mccchannel_4_analyzer_1_array_crystal_array_3_mask_setting;
MCNUM number_of_activations = mccchannel_4_analyzer_1_array_crystal_array_3_number_of_activations;
}   /* End of channel_4_analyzer_1_array_crystal_array_3=Union_box() SETTING parameter declarations. */
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex
  /* Label for restoring  neutron */
  mcabsorbCompchannel_4_analyzer_1_array_crystal_array_3:
  if (RESTORE) /* restore if needed */
  { RESTORE_NEUTRON(285,
      mcnlx,
      mcnly,
      mcnlz,
      mcnlvx,
      mcnlvy,
      mcnlvz,
      mcnlt,
      mcnlsx,
      mcnlsy,
      mcnlsz,
      mcnlp); }
#undef mcabsorbComp
#undef p
#undef sz
#undef sy
#undef sx
#undef t
#undef vz
#undef vy
#undef vx
#undef z
#undef y
#undef x
  mcDEBUG_STATE(
mcnlx,
mcnly,
mcnlz,
mcnlvx,
mcnlvy,
mcnlvz,
mcnlt,
mcnlsx,
mcnlsy,
mcnlsz,
mcnlp)

  /* TRACE Component channel_4_analyzer_1_array_crystal_array_4 [286] */
  mccoordschange(mcposrchannel_4_analyzer_1_array_crystal_array_4, mcrotrchannel_4_analyzer_1_array_crystal_array_4,
    &mcnlx,
    &mcnly,
    &mcnlz,
    &mcnlvx,
    &mcnlvy,
    &mcnlvz,
    &mcnlsx,
    &mcnlsy,
    &mcnlsz);
  /* define label inside component channel_4_analyzer_1_array_crystal_array_4 (without coords transformations) */
  mcJumpTrace_channel_4_analyzer_1_array_crystal_array_4:
  SIG_MESSAGE("channel_4_analyzer_1_array_crystal_array_4 (Trace)");
  mcDEBUG_COMP("channel_4_analyzer_1_array_crystal_array_4")
  mcDEBUG_STATE(
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp)
#define x mcnlx
#define y mcnly
#define z mcnlz
#define vx mcnlvx
#define vy mcnlvy
#define vz mcnlvz
#define t mcnlt
#define sx mcnlsx
#define sy mcnlsy
#define sz mcnlsz
#define p mcnlp

#define mcabsorbComp mcabsorbCompchannel_4_analyzer_1_array_crystal_array_4
  STORE_NEUTRON(286,
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp);
  mcScattered=0;
  mcRestore=0;
  mcNCounter[286]++;
  mcPCounter[286] += p;
  mcP2Counter[286] += p*p;
#define mccompcurname  channel_4_analyzer_1_array_crystal_array_4
#define mccompcurtype  Union_box
#define mccompcurindex 286
#define loop_index mccchannel_4_analyzer_1_array_crystal_array_4_loop_index
#define this_box_volume mccchannel_4_analyzer_1_array_crystal_array_4_this_box_volume
#define global_geometry_element mccchannel_4_analyzer_1_array_crystal_array_4_global_geometry_element
#define this_box_storage mccchannel_4_analyzer_1_array_crystal_array_4_this_box_storage
{   /* Declarations of channel_4_analyzer_1_array_crystal_array_4=Union_box() SETTING parameters. */
char* material_string = mccchannel_4_analyzer_1_array_crystal_array_4_material_string;
MCNUM priority = mccchannel_4_analyzer_1_array_crystal_array_4_priority;
MCNUM xwidth = mccchannel_4_analyzer_1_array_crystal_array_4_xwidth;
MCNUM yheight = mccchannel_4_analyzer_1_array_crystal_array_4_yheight;
MCNUM zdepth = mccchannel_4_analyzer_1_array_crystal_array_4_zdepth;
MCNUM xwidth2 = mccchannel_4_analyzer_1_array_crystal_array_4_xwidth2;
MCNUM yheight2 = mccchannel_4_analyzer_1_array_crystal_array_4_yheight2;
MCNUM visualize = mccchannel_4_analyzer_1_array_crystal_array_4_visualize;
int target_index = mccchannel_4_analyzer_1_array_crystal_array_4_target_index;
MCNUM target_x = mccchannel_4_analyzer_1_array_crystal_array_4_target_x;
MCNUM target_y = mccchannel_4_analyzer_1_array_crystal_array_4_target_y;
MCNUM target_z = mccchannel_4_analyzer_1_array_crystal_array_4_target_z;
MCNUM focus_aw = mccchannel_4_analyzer_1_array_crystal_array_4_focus_aw;
MCNUM focus_ah = mccchannel_4_analyzer_1_array_crystal_array_4_focus_ah;
MCNUM focus_xw = mccchannel_4_analyzer_1_array_crystal_array_4_focus_xw;
MCNUM focus_xh = mccchannel_4_analyzer_1_array_crystal_array_4_focus_xh;
MCNUM focus_r = mccchannel_4_analyzer_1_array_crystal_array_4_focus_r;
MCNUM p_interact = mccchannel_4_analyzer_1_array_crystal_array_4_p_interact;
char* mask_string = mccchannel_4_analyzer_1_array_crystal_array_4_mask_string;
char* mask_setting = mccchannel_4_analyzer_1_array_crystal_array_4_mask_setting;
MCNUM number_of_activations = mccchannel_4_analyzer_1_array_crystal_array_4_number_of_activations;
}   /* End of channel_4_analyzer_1_array_crystal_array_4=Union_box() SETTING parameter declarations. */
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex
  /* Label for restoring  neutron */
  mcabsorbCompchannel_4_analyzer_1_array_crystal_array_4:
  if (RESTORE) /* restore if needed */
  { RESTORE_NEUTRON(286,
      mcnlx,
      mcnly,
      mcnlz,
      mcnlvx,
      mcnlvy,
      mcnlvz,
      mcnlt,
      mcnlsx,
      mcnlsy,
      mcnlsz,
      mcnlp); }
#undef mcabsorbComp
#undef p
#undef sz
#undef sy
#undef sx
#undef t
#undef vz
#undef vy
#undef vx
#undef z
#undef y
#undef x
  mcDEBUG_STATE(
mcnlx,
mcnly,
mcnlz,
mcnlvx,
mcnlvy,
mcnlvz,
mcnlt,
mcnlsx,
mcnlsy,
mcnlsz,
mcnlp)

  /* TRACE Component channel_4_analyzer_1_array_crystal_array_5 [287] */
  mccoordschange(mcposrchannel_4_analyzer_1_array_crystal_array_5, mcrotrchannel_4_analyzer_1_array_crystal_array_5,
    &mcnlx,
    &mcnly,
    &mcnlz,
    &mcnlvx,
    &mcnlvy,
    &mcnlvz,
    &mcnlsx,
    &mcnlsy,
    &mcnlsz);
  /* define label inside component channel_4_analyzer_1_array_crystal_array_5 (without coords transformations) */
  mcJumpTrace_channel_4_analyzer_1_array_crystal_array_5:
  SIG_MESSAGE("channel_4_analyzer_1_array_crystal_array_5 (Trace)");
  mcDEBUG_COMP("channel_4_analyzer_1_array_crystal_array_5")
  mcDEBUG_STATE(
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp)
#define x mcnlx
#define y mcnly
#define z mcnlz
#define vx mcnlvx
#define vy mcnlvy
#define vz mcnlvz
#define t mcnlt
#define sx mcnlsx
#define sy mcnlsy
#define sz mcnlsz
#define p mcnlp

#define mcabsorbComp mcabsorbCompchannel_4_analyzer_1_array_crystal_array_5
  STORE_NEUTRON(287,
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp);
  mcScattered=0;
  mcRestore=0;
  mcNCounter[287]++;
  mcPCounter[287] += p;
  mcP2Counter[287] += p*p;
#define mccompcurname  channel_4_analyzer_1_array_crystal_array_5
#define mccompcurtype  Union_box
#define mccompcurindex 287
#define loop_index mccchannel_4_analyzer_1_array_crystal_array_5_loop_index
#define this_box_volume mccchannel_4_analyzer_1_array_crystal_array_5_this_box_volume
#define global_geometry_element mccchannel_4_analyzer_1_array_crystal_array_5_global_geometry_element
#define this_box_storage mccchannel_4_analyzer_1_array_crystal_array_5_this_box_storage
{   /* Declarations of channel_4_analyzer_1_array_crystal_array_5=Union_box() SETTING parameters. */
char* material_string = mccchannel_4_analyzer_1_array_crystal_array_5_material_string;
MCNUM priority = mccchannel_4_analyzer_1_array_crystal_array_5_priority;
MCNUM xwidth = mccchannel_4_analyzer_1_array_crystal_array_5_xwidth;
MCNUM yheight = mccchannel_4_analyzer_1_array_crystal_array_5_yheight;
MCNUM zdepth = mccchannel_4_analyzer_1_array_crystal_array_5_zdepth;
MCNUM xwidth2 = mccchannel_4_analyzer_1_array_crystal_array_5_xwidth2;
MCNUM yheight2 = mccchannel_4_analyzer_1_array_crystal_array_5_yheight2;
MCNUM visualize = mccchannel_4_analyzer_1_array_crystal_array_5_visualize;
int target_index = mccchannel_4_analyzer_1_array_crystal_array_5_target_index;
MCNUM target_x = mccchannel_4_analyzer_1_array_crystal_array_5_target_x;
MCNUM target_y = mccchannel_4_analyzer_1_array_crystal_array_5_target_y;
MCNUM target_z = mccchannel_4_analyzer_1_array_crystal_array_5_target_z;
MCNUM focus_aw = mccchannel_4_analyzer_1_array_crystal_array_5_focus_aw;
MCNUM focus_ah = mccchannel_4_analyzer_1_array_crystal_array_5_focus_ah;
MCNUM focus_xw = mccchannel_4_analyzer_1_array_crystal_array_5_focus_xw;
MCNUM focus_xh = mccchannel_4_analyzer_1_array_crystal_array_5_focus_xh;
MCNUM focus_r = mccchannel_4_analyzer_1_array_crystal_array_5_focus_r;
MCNUM p_interact = mccchannel_4_analyzer_1_array_crystal_array_5_p_interact;
char* mask_string = mccchannel_4_analyzer_1_array_crystal_array_5_mask_string;
char* mask_setting = mccchannel_4_analyzer_1_array_crystal_array_5_mask_setting;
MCNUM number_of_activations = mccchannel_4_analyzer_1_array_crystal_array_5_number_of_activations;
}   /* End of channel_4_analyzer_1_array_crystal_array_5=Union_box() SETTING parameter declarations. */
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex
  /* Label for restoring  neutron */
  mcabsorbCompchannel_4_analyzer_1_array_crystal_array_5:
  if (RESTORE) /* restore if needed */
  { RESTORE_NEUTRON(287,
      mcnlx,
      mcnly,
      mcnlz,
      mcnlvx,
      mcnlvy,
      mcnlvz,
      mcnlt,
      mcnlsx,
      mcnlsy,
      mcnlsz,
      mcnlp); }
#undef mcabsorbComp
#undef p
#undef sz
#undef sy
#undef sx
#undef t
#undef vz
#undef vy
#undef vx
#undef z
#undef y
#undef x
  mcDEBUG_STATE(
mcnlx,
mcnly,
mcnlz,
mcnlvx,
mcnlvy,
mcnlvz,
mcnlt,
mcnlsx,
mcnlsy,
mcnlsz,
mcnlp)

  /* TRACE Component channel_4_analyzer_1_array_crystal_array_6 [288] */
  mccoordschange(mcposrchannel_4_analyzer_1_array_crystal_array_6, mcrotrchannel_4_analyzer_1_array_crystal_array_6,
    &mcnlx,
    &mcnly,
    &mcnlz,
    &mcnlvx,
    &mcnlvy,
    &mcnlvz,
    &mcnlsx,
    &mcnlsy,
    &mcnlsz);
  /* define label inside component channel_4_analyzer_1_array_crystal_array_6 (without coords transformations) */
  mcJumpTrace_channel_4_analyzer_1_array_crystal_array_6:
  SIG_MESSAGE("channel_4_analyzer_1_array_crystal_array_6 (Trace)");
  mcDEBUG_COMP("channel_4_analyzer_1_array_crystal_array_6")
  mcDEBUG_STATE(
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp)
#define x mcnlx
#define y mcnly
#define z mcnlz
#define vx mcnlvx
#define vy mcnlvy
#define vz mcnlvz
#define t mcnlt
#define sx mcnlsx
#define sy mcnlsy
#define sz mcnlsz
#define p mcnlp

#define mcabsorbComp mcabsorbCompchannel_4_analyzer_1_array_crystal_array_6
  STORE_NEUTRON(288,
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp);
  mcScattered=0;
  mcRestore=0;
  mcNCounter[288]++;
  mcPCounter[288] += p;
  mcP2Counter[288] += p*p;
#define mccompcurname  channel_4_analyzer_1_array_crystal_array_6
#define mccompcurtype  Union_box
#define mccompcurindex 288
#define loop_index mccchannel_4_analyzer_1_array_crystal_array_6_loop_index
#define this_box_volume mccchannel_4_analyzer_1_array_crystal_array_6_this_box_volume
#define global_geometry_element mccchannel_4_analyzer_1_array_crystal_array_6_global_geometry_element
#define this_box_storage mccchannel_4_analyzer_1_array_crystal_array_6_this_box_storage
{   /* Declarations of channel_4_analyzer_1_array_crystal_array_6=Union_box() SETTING parameters. */
char* material_string = mccchannel_4_analyzer_1_array_crystal_array_6_material_string;
MCNUM priority = mccchannel_4_analyzer_1_array_crystal_array_6_priority;
MCNUM xwidth = mccchannel_4_analyzer_1_array_crystal_array_6_xwidth;
MCNUM yheight = mccchannel_4_analyzer_1_array_crystal_array_6_yheight;
MCNUM zdepth = mccchannel_4_analyzer_1_array_crystal_array_6_zdepth;
MCNUM xwidth2 = mccchannel_4_analyzer_1_array_crystal_array_6_xwidth2;
MCNUM yheight2 = mccchannel_4_analyzer_1_array_crystal_array_6_yheight2;
MCNUM visualize = mccchannel_4_analyzer_1_array_crystal_array_6_visualize;
int target_index = mccchannel_4_analyzer_1_array_crystal_array_6_target_index;
MCNUM target_x = mccchannel_4_analyzer_1_array_crystal_array_6_target_x;
MCNUM target_y = mccchannel_4_analyzer_1_array_crystal_array_6_target_y;
MCNUM target_z = mccchannel_4_analyzer_1_array_crystal_array_6_target_z;
MCNUM focus_aw = mccchannel_4_analyzer_1_array_crystal_array_6_focus_aw;
MCNUM focus_ah = mccchannel_4_analyzer_1_array_crystal_array_6_focus_ah;
MCNUM focus_xw = mccchannel_4_analyzer_1_array_crystal_array_6_focus_xw;
MCNUM focus_xh = mccchannel_4_analyzer_1_array_crystal_array_6_focus_xh;
MCNUM focus_r = mccchannel_4_analyzer_1_array_crystal_array_6_focus_r;
MCNUM p_interact = mccchannel_4_analyzer_1_array_crystal_array_6_p_interact;
char* mask_string = mccchannel_4_analyzer_1_array_crystal_array_6_mask_string;
char* mask_setting = mccchannel_4_analyzer_1_array_crystal_array_6_mask_setting;
MCNUM number_of_activations = mccchannel_4_analyzer_1_array_crystal_array_6_number_of_activations;
}   /* End of channel_4_analyzer_1_array_crystal_array_6=Union_box() SETTING parameter declarations. */
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex
  /* Label for restoring  neutron */
  mcabsorbCompchannel_4_analyzer_1_array_crystal_array_6:
  if (RESTORE) /* restore if needed */
  { RESTORE_NEUTRON(288,
      mcnlx,
      mcnly,
      mcnlz,
      mcnlvx,
      mcnlvy,
      mcnlvz,
      mcnlt,
      mcnlsx,
      mcnlsy,
      mcnlsz,
      mcnlp); }
#undef mcabsorbComp
#undef p
#undef sz
#undef sy
#undef sx
#undef t
#undef vz
#undef vy
#undef vx
#undef z
#undef y
#undef x
  mcDEBUG_STATE(
mcnlx,
mcnly,
mcnlz,
mcnlvx,
mcnlvy,
mcnlvz,
mcnlt,
mcnlsx,
mcnlsy,
mcnlsz,
mcnlp)

  /* TRACE Component channel_4_analyzer_1_array_crystal_array_7 [289] */
  mccoordschange(mcposrchannel_4_analyzer_1_array_crystal_array_7, mcrotrchannel_4_analyzer_1_array_crystal_array_7,
    &mcnlx,
    &mcnly,
    &mcnlz,
    &mcnlvx,
    &mcnlvy,
    &mcnlvz,
    &mcnlsx,
    &mcnlsy,
    &mcnlsz);
  /* define label inside component channel_4_analyzer_1_array_crystal_array_7 (without coords transformations) */
  mcJumpTrace_channel_4_analyzer_1_array_crystal_array_7:
  SIG_MESSAGE("channel_4_analyzer_1_array_crystal_array_7 (Trace)");
  mcDEBUG_COMP("channel_4_analyzer_1_array_crystal_array_7")
  mcDEBUG_STATE(
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp)
#define x mcnlx
#define y mcnly
#define z mcnlz
#define vx mcnlvx
#define vy mcnlvy
#define vz mcnlvz
#define t mcnlt
#define sx mcnlsx
#define sy mcnlsy
#define sz mcnlsz
#define p mcnlp

#define mcabsorbComp mcabsorbCompchannel_4_analyzer_1_array_crystal_array_7
  STORE_NEUTRON(289,
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp);
  mcScattered=0;
  mcRestore=0;
  mcNCounter[289]++;
  mcPCounter[289] += p;
  mcP2Counter[289] += p*p;
#define mccompcurname  channel_4_analyzer_1_array_crystal_array_7
#define mccompcurtype  Union_box
#define mccompcurindex 289
#define loop_index mccchannel_4_analyzer_1_array_crystal_array_7_loop_index
#define this_box_volume mccchannel_4_analyzer_1_array_crystal_array_7_this_box_volume
#define global_geometry_element mccchannel_4_analyzer_1_array_crystal_array_7_global_geometry_element
#define this_box_storage mccchannel_4_analyzer_1_array_crystal_array_7_this_box_storage
{   /* Declarations of channel_4_analyzer_1_array_crystal_array_7=Union_box() SETTING parameters. */
char* material_string = mccchannel_4_analyzer_1_array_crystal_array_7_material_string;
MCNUM priority = mccchannel_4_analyzer_1_array_crystal_array_7_priority;
MCNUM xwidth = mccchannel_4_analyzer_1_array_crystal_array_7_xwidth;
MCNUM yheight = mccchannel_4_analyzer_1_array_crystal_array_7_yheight;
MCNUM zdepth = mccchannel_4_analyzer_1_array_crystal_array_7_zdepth;
MCNUM xwidth2 = mccchannel_4_analyzer_1_array_crystal_array_7_xwidth2;
MCNUM yheight2 = mccchannel_4_analyzer_1_array_crystal_array_7_yheight2;
MCNUM visualize = mccchannel_4_analyzer_1_array_crystal_array_7_visualize;
int target_index = mccchannel_4_analyzer_1_array_crystal_array_7_target_index;
MCNUM target_x = mccchannel_4_analyzer_1_array_crystal_array_7_target_x;
MCNUM target_y = mccchannel_4_analyzer_1_array_crystal_array_7_target_y;
MCNUM target_z = mccchannel_4_analyzer_1_array_crystal_array_7_target_z;
MCNUM focus_aw = mccchannel_4_analyzer_1_array_crystal_array_7_focus_aw;
MCNUM focus_ah = mccchannel_4_analyzer_1_array_crystal_array_7_focus_ah;
MCNUM focus_xw = mccchannel_4_analyzer_1_array_crystal_array_7_focus_xw;
MCNUM focus_xh = mccchannel_4_analyzer_1_array_crystal_array_7_focus_xh;
MCNUM focus_r = mccchannel_4_analyzer_1_array_crystal_array_7_focus_r;
MCNUM p_interact = mccchannel_4_analyzer_1_array_crystal_array_7_p_interact;
char* mask_string = mccchannel_4_analyzer_1_array_crystal_array_7_mask_string;
char* mask_setting = mccchannel_4_analyzer_1_array_crystal_array_7_mask_setting;
MCNUM number_of_activations = mccchannel_4_analyzer_1_array_crystal_array_7_number_of_activations;
}   /* End of channel_4_analyzer_1_array_crystal_array_7=Union_box() SETTING parameter declarations. */
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex
  /* Label for restoring  neutron */
  mcabsorbCompchannel_4_analyzer_1_array_crystal_array_7:
  if (RESTORE) /* restore if needed */
  { RESTORE_NEUTRON(289,
      mcnlx,
      mcnly,
      mcnlz,
      mcnlvx,
      mcnlvy,
      mcnlvz,
      mcnlt,
      mcnlsx,
      mcnlsy,
      mcnlsz,
      mcnlp); }
#undef mcabsorbComp
#undef p
#undef sz
#undef sy
#undef sx
#undef t
#undef vz
#undef vy
#undef vx
#undef z
#undef y
#undef x
  mcDEBUG_STATE(
mcnlx,
mcnly,
mcnlz,
mcnlvx,
mcnlvy,
mcnlvz,
mcnlt,
mcnlsx,
mcnlsy,
mcnlsz,
mcnlp)

  /* TRACE Component channel_4_analyzer_1_array_crystal_array_8 [290] */
  mccoordschange(mcposrchannel_4_analyzer_1_array_crystal_array_8, mcrotrchannel_4_analyzer_1_array_crystal_array_8,
    &mcnlx,
    &mcnly,
    &mcnlz,
    &mcnlvx,
    &mcnlvy,
    &mcnlvz,
    &mcnlsx,
    &mcnlsy,
    &mcnlsz);
  /* define label inside component channel_4_analyzer_1_array_crystal_array_8 (without coords transformations) */
  mcJumpTrace_channel_4_analyzer_1_array_crystal_array_8:
  SIG_MESSAGE("channel_4_analyzer_1_array_crystal_array_8 (Trace)");
  mcDEBUG_COMP("channel_4_analyzer_1_array_crystal_array_8")
  mcDEBUG_STATE(
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp)
#define x mcnlx
#define y mcnly
#define z mcnlz
#define vx mcnlvx
#define vy mcnlvy
#define vz mcnlvz
#define t mcnlt
#define sx mcnlsx
#define sy mcnlsy
#define sz mcnlsz
#define p mcnlp

#define mcabsorbComp mcabsorbCompchannel_4_analyzer_1_array_crystal_array_8
  STORE_NEUTRON(290,
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp);
  mcScattered=0;
  mcRestore=0;
  mcNCounter[290]++;
  mcPCounter[290] += p;
  mcP2Counter[290] += p*p;
#define mccompcurname  channel_4_analyzer_1_array_crystal_array_8
#define mccompcurtype  Union_box
#define mccompcurindex 290
#define loop_index mccchannel_4_analyzer_1_array_crystal_array_8_loop_index
#define this_box_volume mccchannel_4_analyzer_1_array_crystal_array_8_this_box_volume
#define global_geometry_element mccchannel_4_analyzer_1_array_crystal_array_8_global_geometry_element
#define this_box_storage mccchannel_4_analyzer_1_array_crystal_array_8_this_box_storage
{   /* Declarations of channel_4_analyzer_1_array_crystal_array_8=Union_box() SETTING parameters. */
char* material_string = mccchannel_4_analyzer_1_array_crystal_array_8_material_string;
MCNUM priority = mccchannel_4_analyzer_1_array_crystal_array_8_priority;
MCNUM xwidth = mccchannel_4_analyzer_1_array_crystal_array_8_xwidth;
MCNUM yheight = mccchannel_4_analyzer_1_array_crystal_array_8_yheight;
MCNUM zdepth = mccchannel_4_analyzer_1_array_crystal_array_8_zdepth;
MCNUM xwidth2 = mccchannel_4_analyzer_1_array_crystal_array_8_xwidth2;
MCNUM yheight2 = mccchannel_4_analyzer_1_array_crystal_array_8_yheight2;
MCNUM visualize = mccchannel_4_analyzer_1_array_crystal_array_8_visualize;
int target_index = mccchannel_4_analyzer_1_array_crystal_array_8_target_index;
MCNUM target_x = mccchannel_4_analyzer_1_array_crystal_array_8_target_x;
MCNUM target_y = mccchannel_4_analyzer_1_array_crystal_array_8_target_y;
MCNUM target_z = mccchannel_4_analyzer_1_array_crystal_array_8_target_z;
MCNUM focus_aw = mccchannel_4_analyzer_1_array_crystal_array_8_focus_aw;
MCNUM focus_ah = mccchannel_4_analyzer_1_array_crystal_array_8_focus_ah;
MCNUM focus_xw = mccchannel_4_analyzer_1_array_crystal_array_8_focus_xw;
MCNUM focus_xh = mccchannel_4_analyzer_1_array_crystal_array_8_focus_xh;
MCNUM focus_r = mccchannel_4_analyzer_1_array_crystal_array_8_focus_r;
MCNUM p_interact = mccchannel_4_analyzer_1_array_crystal_array_8_p_interact;
char* mask_string = mccchannel_4_analyzer_1_array_crystal_array_8_mask_string;
char* mask_setting = mccchannel_4_analyzer_1_array_crystal_array_8_mask_setting;
MCNUM number_of_activations = mccchannel_4_analyzer_1_array_crystal_array_8_number_of_activations;
}   /* End of channel_4_analyzer_1_array_crystal_array_8=Union_box() SETTING parameter declarations. */
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex
  /* Label for restoring  neutron */
  mcabsorbCompchannel_4_analyzer_1_array_crystal_array_8:
  if (RESTORE) /* restore if needed */
  { RESTORE_NEUTRON(290,
      mcnlx,
      mcnly,
      mcnlz,
      mcnlvx,
      mcnlvy,
      mcnlvz,
      mcnlt,
      mcnlsx,
      mcnlsy,
      mcnlsz,
      mcnlp); }
#undef mcabsorbComp
#undef p
#undef sz
#undef sy
#undef sx
#undef t
#undef vz
#undef vy
#undef vx
#undef z
#undef y
#undef x
  mcDEBUG_STATE(
mcnlx,
mcnly,
mcnlz,
mcnlvx,
mcnlvy,
mcnlvz,
mcnlt,
mcnlsx,
mcnlsy,
mcnlsz,
mcnlp)

  /* TRACE Component channel_4_analyzer_2_center [291] */
  mccoordschange(mcposrchannel_4_analyzer_2_center, mcrotrchannel_4_analyzer_2_center,
    &mcnlx,
    &mcnly,
    &mcnlz,
    &mcnlvx,
    &mcnlvy,
    &mcnlvz,
    &mcnlsx,
    &mcnlsy,
    &mcnlsz);
  /* define label inside component channel_4_analyzer_2_center (without coords transformations) */
  mcJumpTrace_channel_4_analyzer_2_center:
  SIG_MESSAGE("channel_4_analyzer_2_center (Trace)");
  mcDEBUG_COMP("channel_4_analyzer_2_center")
  mcDEBUG_STATE(
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp)
#define x mcnlx
#define y mcnly
#define z mcnlz
#define vx mcnlvx
#define vy mcnlvy
#define vz mcnlvz
#define t mcnlt
#define sx mcnlsx
#define sy mcnlsy
#define sz mcnlsz
#define p mcnlp

#define mcabsorbComp mcabsorbCompchannel_4_analyzer_2_center
  STORE_NEUTRON(291,
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp);
  mcScattered=0;
  mcRestore=0;
  mcNCounter[291]++;
  mcPCounter[291] += p;
  mcP2Counter[291] += p*p;
#define mccompcurname  channel_4_analyzer_2_center
#define mccompcurtype  Arm
#define mccompcurindex 291
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex
  /* Label for restoring  neutron */
  mcabsorbCompchannel_4_analyzer_2_center:
  if (RESTORE) /* restore if needed */
  { RESTORE_NEUTRON(291,
      mcnlx,
      mcnly,
      mcnlz,
      mcnlvx,
      mcnlvy,
      mcnlvz,
      mcnlt,
      mcnlsx,
      mcnlsy,
      mcnlsz,
      mcnlp); }
#undef mcabsorbComp
#undef p
#undef sz
#undef sy
#undef sx
#undef t
#undef vz
#undef vy
#undef vx
#undef z
#undef y
#undef x
  mcDEBUG_STATE(
mcnlx,
mcnly,
mcnlz,
mcnlvx,
mcnlvy,
mcnlvz,
mcnlt,
mcnlsx,
mcnlsy,
mcnlsz,
mcnlp)

  /* TRACE Component channel_4_analyzer_2_rotated [292] */
  mccoordschange(mcposrchannel_4_analyzer_2_rotated, mcrotrchannel_4_analyzer_2_rotated,
    &mcnlx,
    &mcnly,
    &mcnlz,
    &mcnlvx,
    &mcnlvy,
    &mcnlvz,
    &mcnlsx,
    &mcnlsy,
    &mcnlsz);
  /* define label inside component channel_4_analyzer_2_rotated (without coords transformations) */
  mcJumpTrace_channel_4_analyzer_2_rotated:
  SIG_MESSAGE("channel_4_analyzer_2_rotated (Trace)");
  mcDEBUG_COMP("channel_4_analyzer_2_rotated")
  mcDEBUG_STATE(
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp)
#define x mcnlx
#define y mcnly
#define z mcnlz
#define vx mcnlvx
#define vy mcnlvy
#define vz mcnlvz
#define t mcnlt
#define sx mcnlsx
#define sy mcnlsy
#define sz mcnlsz
#define p mcnlp

#define mcabsorbComp mcabsorbCompchannel_4_analyzer_2_rotated
  STORE_NEUTRON(292,
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp);
  mcScattered=0;
  mcRestore=0;
  mcNCounter[292]++;
  mcPCounter[292] += p;
  mcP2Counter[292] += p*p;
#define mccompcurname  channel_4_analyzer_2_rotated
#define mccompcurtype  Arm
#define mccompcurindex 292
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex
  /* Label for restoring  neutron */
  mcabsorbCompchannel_4_analyzer_2_rotated:
  if (RESTORE) /* restore if needed */
  { RESTORE_NEUTRON(292,
      mcnlx,
      mcnly,
      mcnlz,
      mcnlvx,
      mcnlvy,
      mcnlvz,
      mcnlt,
      mcnlsx,
      mcnlsy,
      mcnlsz,
      mcnlp); }
#undef mcabsorbComp
#undef p
#undef sz
#undef sy
#undef sx
#undef t
#undef vz
#undef vy
#undef vx
#undef z
#undef y
#undef x
  mcDEBUG_STATE(
mcnlx,
mcnly,
mcnlz,
mcnlvx,
mcnlvy,
mcnlvz,
mcnlt,
mcnlsx,
mcnlsy,
mcnlsz,
mcnlp)

  /* TRACE Component channel_4_analyzer_2_array_crystal_array_0 [293] */
  mccoordschange(mcposrchannel_4_analyzer_2_array_crystal_array_0, mcrotrchannel_4_analyzer_2_array_crystal_array_0,
    &mcnlx,
    &mcnly,
    &mcnlz,
    &mcnlvx,
    &mcnlvy,
    &mcnlvz,
    &mcnlsx,
    &mcnlsy,
    &mcnlsz);
  /* define label inside component channel_4_analyzer_2_array_crystal_array_0 (without coords transformations) */
  mcJumpTrace_channel_4_analyzer_2_array_crystal_array_0:
  SIG_MESSAGE("channel_4_analyzer_2_array_crystal_array_0 (Trace)");
  mcDEBUG_COMP("channel_4_analyzer_2_array_crystal_array_0")
  mcDEBUG_STATE(
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp)
#define x mcnlx
#define y mcnly
#define z mcnlz
#define vx mcnlvx
#define vy mcnlvy
#define vz mcnlvz
#define t mcnlt
#define sx mcnlsx
#define sy mcnlsy
#define sz mcnlsz
#define p mcnlp

#define mcabsorbComp mcabsorbCompchannel_4_analyzer_2_array_crystal_array_0
  STORE_NEUTRON(293,
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp);
  mcScattered=0;
  mcRestore=0;
  mcNCounter[293]++;
  mcPCounter[293] += p;
  mcP2Counter[293] += p*p;
#define mccompcurname  channel_4_analyzer_2_array_crystal_array_0
#define mccompcurtype  Union_box
#define mccompcurindex 293
#define loop_index mccchannel_4_analyzer_2_array_crystal_array_0_loop_index
#define this_box_volume mccchannel_4_analyzer_2_array_crystal_array_0_this_box_volume
#define global_geometry_element mccchannel_4_analyzer_2_array_crystal_array_0_global_geometry_element
#define this_box_storage mccchannel_4_analyzer_2_array_crystal_array_0_this_box_storage
{   /* Declarations of channel_4_analyzer_2_array_crystal_array_0=Union_box() SETTING parameters. */
char* material_string = mccchannel_4_analyzer_2_array_crystal_array_0_material_string;
MCNUM priority = mccchannel_4_analyzer_2_array_crystal_array_0_priority;
MCNUM xwidth = mccchannel_4_analyzer_2_array_crystal_array_0_xwidth;
MCNUM yheight = mccchannel_4_analyzer_2_array_crystal_array_0_yheight;
MCNUM zdepth = mccchannel_4_analyzer_2_array_crystal_array_0_zdepth;
MCNUM xwidth2 = mccchannel_4_analyzer_2_array_crystal_array_0_xwidth2;
MCNUM yheight2 = mccchannel_4_analyzer_2_array_crystal_array_0_yheight2;
MCNUM visualize = mccchannel_4_analyzer_2_array_crystal_array_0_visualize;
int target_index = mccchannel_4_analyzer_2_array_crystal_array_0_target_index;
MCNUM target_x = mccchannel_4_analyzer_2_array_crystal_array_0_target_x;
MCNUM target_y = mccchannel_4_analyzer_2_array_crystal_array_0_target_y;
MCNUM target_z = mccchannel_4_analyzer_2_array_crystal_array_0_target_z;
MCNUM focus_aw = mccchannel_4_analyzer_2_array_crystal_array_0_focus_aw;
MCNUM focus_ah = mccchannel_4_analyzer_2_array_crystal_array_0_focus_ah;
MCNUM focus_xw = mccchannel_4_analyzer_2_array_crystal_array_0_focus_xw;
MCNUM focus_xh = mccchannel_4_analyzer_2_array_crystal_array_0_focus_xh;
MCNUM focus_r = mccchannel_4_analyzer_2_array_crystal_array_0_focus_r;
MCNUM p_interact = mccchannel_4_analyzer_2_array_crystal_array_0_p_interact;
char* mask_string = mccchannel_4_analyzer_2_array_crystal_array_0_mask_string;
char* mask_setting = mccchannel_4_analyzer_2_array_crystal_array_0_mask_setting;
MCNUM number_of_activations = mccchannel_4_analyzer_2_array_crystal_array_0_number_of_activations;
}   /* End of channel_4_analyzer_2_array_crystal_array_0=Union_box() SETTING parameter declarations. */
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex
  /* Label for restoring  neutron */
  mcabsorbCompchannel_4_analyzer_2_array_crystal_array_0:
  if (RESTORE) /* restore if needed */
  { RESTORE_NEUTRON(293,
      mcnlx,
      mcnly,
      mcnlz,
      mcnlvx,
      mcnlvy,
      mcnlvz,
      mcnlt,
      mcnlsx,
      mcnlsy,
      mcnlsz,
      mcnlp); }
#undef mcabsorbComp
#undef p
#undef sz
#undef sy
#undef sx
#undef t
#undef vz
#undef vy
#undef vx
#undef z
#undef y
#undef x
  mcDEBUG_STATE(
mcnlx,
mcnly,
mcnlz,
mcnlvx,
mcnlvy,
mcnlvz,
mcnlt,
mcnlsx,
mcnlsy,
mcnlsz,
mcnlp)

  /* TRACE Component channel_4_analyzer_2_array_crystal_array_1 [294] */
  mccoordschange(mcposrchannel_4_analyzer_2_array_crystal_array_1, mcrotrchannel_4_analyzer_2_array_crystal_array_1,
    &mcnlx,
    &mcnly,
    &mcnlz,
    &mcnlvx,
    &mcnlvy,
    &mcnlvz,
    &mcnlsx,
    &mcnlsy,
    &mcnlsz);
  /* define label inside component channel_4_analyzer_2_array_crystal_array_1 (without coords transformations) */
  mcJumpTrace_channel_4_analyzer_2_array_crystal_array_1:
  SIG_MESSAGE("channel_4_analyzer_2_array_crystal_array_1 (Trace)");
  mcDEBUG_COMP("channel_4_analyzer_2_array_crystal_array_1")
  mcDEBUG_STATE(
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp)
#define x mcnlx
#define y mcnly
#define z mcnlz
#define vx mcnlvx
#define vy mcnlvy
#define vz mcnlvz
#define t mcnlt
#define sx mcnlsx
#define sy mcnlsy
#define sz mcnlsz
#define p mcnlp

#define mcabsorbComp mcabsorbCompchannel_4_analyzer_2_array_crystal_array_1
  STORE_NEUTRON(294,
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp);
  mcScattered=0;
  mcRestore=0;
  mcNCounter[294]++;
  mcPCounter[294] += p;
  mcP2Counter[294] += p*p;
#define mccompcurname  channel_4_analyzer_2_array_crystal_array_1
#define mccompcurtype  Union_box
#define mccompcurindex 294
#define loop_index mccchannel_4_analyzer_2_array_crystal_array_1_loop_index
#define this_box_volume mccchannel_4_analyzer_2_array_crystal_array_1_this_box_volume
#define global_geometry_element mccchannel_4_analyzer_2_array_crystal_array_1_global_geometry_element
#define this_box_storage mccchannel_4_analyzer_2_array_crystal_array_1_this_box_storage
{   /* Declarations of channel_4_analyzer_2_array_crystal_array_1=Union_box() SETTING parameters. */
char* material_string = mccchannel_4_analyzer_2_array_crystal_array_1_material_string;
MCNUM priority = mccchannel_4_analyzer_2_array_crystal_array_1_priority;
MCNUM xwidth = mccchannel_4_analyzer_2_array_crystal_array_1_xwidth;
MCNUM yheight = mccchannel_4_analyzer_2_array_crystal_array_1_yheight;
MCNUM zdepth = mccchannel_4_analyzer_2_array_crystal_array_1_zdepth;
MCNUM xwidth2 = mccchannel_4_analyzer_2_array_crystal_array_1_xwidth2;
MCNUM yheight2 = mccchannel_4_analyzer_2_array_crystal_array_1_yheight2;
MCNUM visualize = mccchannel_4_analyzer_2_array_crystal_array_1_visualize;
int target_index = mccchannel_4_analyzer_2_array_crystal_array_1_target_index;
MCNUM target_x = mccchannel_4_analyzer_2_array_crystal_array_1_target_x;
MCNUM target_y = mccchannel_4_analyzer_2_array_crystal_array_1_target_y;
MCNUM target_z = mccchannel_4_analyzer_2_array_crystal_array_1_target_z;
MCNUM focus_aw = mccchannel_4_analyzer_2_array_crystal_array_1_focus_aw;
MCNUM focus_ah = mccchannel_4_analyzer_2_array_crystal_array_1_focus_ah;
MCNUM focus_xw = mccchannel_4_analyzer_2_array_crystal_array_1_focus_xw;
MCNUM focus_xh = mccchannel_4_analyzer_2_array_crystal_array_1_focus_xh;
MCNUM focus_r = mccchannel_4_analyzer_2_array_crystal_array_1_focus_r;
MCNUM p_interact = mccchannel_4_analyzer_2_array_crystal_array_1_p_interact;
char* mask_string = mccchannel_4_analyzer_2_array_crystal_array_1_mask_string;
char* mask_setting = mccchannel_4_analyzer_2_array_crystal_array_1_mask_setting;
MCNUM number_of_activations = mccchannel_4_analyzer_2_array_crystal_array_1_number_of_activations;
}   /* End of channel_4_analyzer_2_array_crystal_array_1=Union_box() SETTING parameter declarations. */
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex
  /* Label for restoring  neutron */
  mcabsorbCompchannel_4_analyzer_2_array_crystal_array_1:
  if (RESTORE) /* restore if needed */
  { RESTORE_NEUTRON(294,
      mcnlx,
      mcnly,
      mcnlz,
      mcnlvx,
      mcnlvy,
      mcnlvz,
      mcnlt,
      mcnlsx,
      mcnlsy,
      mcnlsz,
      mcnlp); }
#undef mcabsorbComp
#undef p
#undef sz
#undef sy
#undef sx
#undef t
#undef vz
#undef vy
#undef vx
#undef z
#undef y
#undef x
  mcDEBUG_STATE(
mcnlx,
mcnly,
mcnlz,
mcnlvx,
mcnlvy,
mcnlvz,
mcnlt,
mcnlsx,
mcnlsy,
mcnlsz,
mcnlp)

  /* TRACE Component channel_4_analyzer_2_array_crystal_array_2 [295] */
  mccoordschange(mcposrchannel_4_analyzer_2_array_crystal_array_2, mcrotrchannel_4_analyzer_2_array_crystal_array_2,
    &mcnlx,
    &mcnly,
    &mcnlz,
    &mcnlvx,
    &mcnlvy,
    &mcnlvz,
    &mcnlsx,
    &mcnlsy,
    &mcnlsz);
  /* define label inside component channel_4_analyzer_2_array_crystal_array_2 (without coords transformations) */
  mcJumpTrace_channel_4_analyzer_2_array_crystal_array_2:
  SIG_MESSAGE("channel_4_analyzer_2_array_crystal_array_2 (Trace)");
  mcDEBUG_COMP("channel_4_analyzer_2_array_crystal_array_2")
  mcDEBUG_STATE(
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp)
#define x mcnlx
#define y mcnly
#define z mcnlz
#define vx mcnlvx
#define vy mcnlvy
#define vz mcnlvz
#define t mcnlt
#define sx mcnlsx
#define sy mcnlsy
#define sz mcnlsz
#define p mcnlp

#define mcabsorbComp mcabsorbCompchannel_4_analyzer_2_array_crystal_array_2
  STORE_NEUTRON(295,
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp);
  mcScattered=0;
  mcRestore=0;
  mcNCounter[295]++;
  mcPCounter[295] += p;
  mcP2Counter[295] += p*p;
#define mccompcurname  channel_4_analyzer_2_array_crystal_array_2
#define mccompcurtype  Union_box
#define mccompcurindex 295
#define loop_index mccchannel_4_analyzer_2_array_crystal_array_2_loop_index
#define this_box_volume mccchannel_4_analyzer_2_array_crystal_array_2_this_box_volume
#define global_geometry_element mccchannel_4_analyzer_2_array_crystal_array_2_global_geometry_element
#define this_box_storage mccchannel_4_analyzer_2_array_crystal_array_2_this_box_storage
{   /* Declarations of channel_4_analyzer_2_array_crystal_array_2=Union_box() SETTING parameters. */
char* material_string = mccchannel_4_analyzer_2_array_crystal_array_2_material_string;
MCNUM priority = mccchannel_4_analyzer_2_array_crystal_array_2_priority;
MCNUM xwidth = mccchannel_4_analyzer_2_array_crystal_array_2_xwidth;
MCNUM yheight = mccchannel_4_analyzer_2_array_crystal_array_2_yheight;
MCNUM zdepth = mccchannel_4_analyzer_2_array_crystal_array_2_zdepth;
MCNUM xwidth2 = mccchannel_4_analyzer_2_array_crystal_array_2_xwidth2;
MCNUM yheight2 = mccchannel_4_analyzer_2_array_crystal_array_2_yheight2;
MCNUM visualize = mccchannel_4_analyzer_2_array_crystal_array_2_visualize;
int target_index = mccchannel_4_analyzer_2_array_crystal_array_2_target_index;
MCNUM target_x = mccchannel_4_analyzer_2_array_crystal_array_2_target_x;
MCNUM target_y = mccchannel_4_analyzer_2_array_crystal_array_2_target_y;
MCNUM target_z = mccchannel_4_analyzer_2_array_crystal_array_2_target_z;
MCNUM focus_aw = mccchannel_4_analyzer_2_array_crystal_array_2_focus_aw;
MCNUM focus_ah = mccchannel_4_analyzer_2_array_crystal_array_2_focus_ah;
MCNUM focus_xw = mccchannel_4_analyzer_2_array_crystal_array_2_focus_xw;
MCNUM focus_xh = mccchannel_4_analyzer_2_array_crystal_array_2_focus_xh;
MCNUM focus_r = mccchannel_4_analyzer_2_array_crystal_array_2_focus_r;
MCNUM p_interact = mccchannel_4_analyzer_2_array_crystal_array_2_p_interact;
char* mask_string = mccchannel_4_analyzer_2_array_crystal_array_2_mask_string;
char* mask_setting = mccchannel_4_analyzer_2_array_crystal_array_2_mask_setting;
MCNUM number_of_activations = mccchannel_4_analyzer_2_array_crystal_array_2_number_of_activations;
}   /* End of channel_4_analyzer_2_array_crystal_array_2=Union_box() SETTING parameter declarations. */
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex
  /* Label for restoring  neutron */
  mcabsorbCompchannel_4_analyzer_2_array_crystal_array_2:
  if (RESTORE) /* restore if needed */
  { RESTORE_NEUTRON(295,
      mcnlx,
      mcnly,
      mcnlz,
      mcnlvx,
      mcnlvy,
      mcnlvz,
      mcnlt,
      mcnlsx,
      mcnlsy,
      mcnlsz,
      mcnlp); }
#undef mcabsorbComp
#undef p
#undef sz
#undef sy
#undef sx
#undef t
#undef vz
#undef vy
#undef vx
#undef z
#undef y
#undef x
  mcDEBUG_STATE(
mcnlx,
mcnly,
mcnlz,
mcnlvx,
mcnlvy,
mcnlvz,
mcnlt,
mcnlsx,
mcnlsy,
mcnlsz,
mcnlp)

  /* TRACE Component channel_4_analyzer_2_array_crystal_array_3 [296] */
  mccoordschange(mcposrchannel_4_analyzer_2_array_crystal_array_3, mcrotrchannel_4_analyzer_2_array_crystal_array_3,
    &mcnlx,
    &mcnly,
    &mcnlz,
    &mcnlvx,
    &mcnlvy,
    &mcnlvz,
    &mcnlsx,
    &mcnlsy,
    &mcnlsz);
  /* define label inside component channel_4_analyzer_2_array_crystal_array_3 (without coords transformations) */
  mcJumpTrace_channel_4_analyzer_2_array_crystal_array_3:
  SIG_MESSAGE("channel_4_analyzer_2_array_crystal_array_3 (Trace)");
  mcDEBUG_COMP("channel_4_analyzer_2_array_crystal_array_3")
  mcDEBUG_STATE(
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp)
#define x mcnlx
#define y mcnly
#define z mcnlz
#define vx mcnlvx
#define vy mcnlvy
#define vz mcnlvz
#define t mcnlt
#define sx mcnlsx
#define sy mcnlsy
#define sz mcnlsz
#define p mcnlp

#define mcabsorbComp mcabsorbCompchannel_4_analyzer_2_array_crystal_array_3
  STORE_NEUTRON(296,
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp);
  mcScattered=0;
  mcRestore=0;
  mcNCounter[296]++;
  mcPCounter[296] += p;
  mcP2Counter[296] += p*p;
#define mccompcurname  channel_4_analyzer_2_array_crystal_array_3
#define mccompcurtype  Union_box
#define mccompcurindex 296
#define loop_index mccchannel_4_analyzer_2_array_crystal_array_3_loop_index
#define this_box_volume mccchannel_4_analyzer_2_array_crystal_array_3_this_box_volume
#define global_geometry_element mccchannel_4_analyzer_2_array_crystal_array_3_global_geometry_element
#define this_box_storage mccchannel_4_analyzer_2_array_crystal_array_3_this_box_storage
{   /* Declarations of channel_4_analyzer_2_array_crystal_array_3=Union_box() SETTING parameters. */
char* material_string = mccchannel_4_analyzer_2_array_crystal_array_3_material_string;
MCNUM priority = mccchannel_4_analyzer_2_array_crystal_array_3_priority;
MCNUM xwidth = mccchannel_4_analyzer_2_array_crystal_array_3_xwidth;
MCNUM yheight = mccchannel_4_analyzer_2_array_crystal_array_3_yheight;
MCNUM zdepth = mccchannel_4_analyzer_2_array_crystal_array_3_zdepth;
MCNUM xwidth2 = mccchannel_4_analyzer_2_array_crystal_array_3_xwidth2;
MCNUM yheight2 = mccchannel_4_analyzer_2_array_crystal_array_3_yheight2;
MCNUM visualize = mccchannel_4_analyzer_2_array_crystal_array_3_visualize;
int target_index = mccchannel_4_analyzer_2_array_crystal_array_3_target_index;
MCNUM target_x = mccchannel_4_analyzer_2_array_crystal_array_3_target_x;
MCNUM target_y = mccchannel_4_analyzer_2_array_crystal_array_3_target_y;
MCNUM target_z = mccchannel_4_analyzer_2_array_crystal_array_3_target_z;
MCNUM focus_aw = mccchannel_4_analyzer_2_array_crystal_array_3_focus_aw;
MCNUM focus_ah = mccchannel_4_analyzer_2_array_crystal_array_3_focus_ah;
MCNUM focus_xw = mccchannel_4_analyzer_2_array_crystal_array_3_focus_xw;
MCNUM focus_xh = mccchannel_4_analyzer_2_array_crystal_array_3_focus_xh;
MCNUM focus_r = mccchannel_4_analyzer_2_array_crystal_array_3_focus_r;
MCNUM p_interact = mccchannel_4_analyzer_2_array_crystal_array_3_p_interact;
char* mask_string = mccchannel_4_analyzer_2_array_crystal_array_3_mask_string;
char* mask_setting = mccchannel_4_analyzer_2_array_crystal_array_3_mask_setting;
MCNUM number_of_activations = mccchannel_4_analyzer_2_array_crystal_array_3_number_of_activations;
}   /* End of channel_4_analyzer_2_array_crystal_array_3=Union_box() SETTING parameter declarations. */
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex
  /* Label for restoring  neutron */
  mcabsorbCompchannel_4_analyzer_2_array_crystal_array_3:
  if (RESTORE) /* restore if needed */
  { RESTORE_NEUTRON(296,
      mcnlx,
      mcnly,
      mcnlz,
      mcnlvx,
      mcnlvy,
      mcnlvz,
      mcnlt,
      mcnlsx,
      mcnlsy,
      mcnlsz,
      mcnlp); }
#undef mcabsorbComp
#undef p
#undef sz
#undef sy
#undef sx
#undef t
#undef vz
#undef vy
#undef vx
#undef z
#undef y
#undef x
  mcDEBUG_STATE(
mcnlx,
mcnly,
mcnlz,
mcnlvx,
mcnlvy,
mcnlvz,
mcnlt,
mcnlsx,
mcnlsy,
mcnlsz,
mcnlp)

  /* TRACE Component channel_4_analyzer_2_array_crystal_array_4 [297] */
  mccoordschange(mcposrchannel_4_analyzer_2_array_crystal_array_4, mcrotrchannel_4_analyzer_2_array_crystal_array_4,
    &mcnlx,
    &mcnly,
    &mcnlz,
    &mcnlvx,
    &mcnlvy,
    &mcnlvz,
    &mcnlsx,
    &mcnlsy,
    &mcnlsz);
  /* define label inside component channel_4_analyzer_2_array_crystal_array_4 (without coords transformations) */
  mcJumpTrace_channel_4_analyzer_2_array_crystal_array_4:
  SIG_MESSAGE("channel_4_analyzer_2_array_crystal_array_4 (Trace)");
  mcDEBUG_COMP("channel_4_analyzer_2_array_crystal_array_4")
  mcDEBUG_STATE(
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp)
#define x mcnlx
#define y mcnly
#define z mcnlz
#define vx mcnlvx
#define vy mcnlvy
#define vz mcnlvz
#define t mcnlt
#define sx mcnlsx
#define sy mcnlsy
#define sz mcnlsz
#define p mcnlp

#define mcabsorbComp mcabsorbCompchannel_4_analyzer_2_array_crystal_array_4
  STORE_NEUTRON(297,
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp);
  mcScattered=0;
  mcRestore=0;
  mcNCounter[297]++;
  mcPCounter[297] += p;
  mcP2Counter[297] += p*p;
#define mccompcurname  channel_4_analyzer_2_array_crystal_array_4
#define mccompcurtype  Union_box
#define mccompcurindex 297
#define loop_index mccchannel_4_analyzer_2_array_crystal_array_4_loop_index
#define this_box_volume mccchannel_4_analyzer_2_array_crystal_array_4_this_box_volume
#define global_geometry_element mccchannel_4_analyzer_2_array_crystal_array_4_global_geometry_element
#define this_box_storage mccchannel_4_analyzer_2_array_crystal_array_4_this_box_storage
{   /* Declarations of channel_4_analyzer_2_array_crystal_array_4=Union_box() SETTING parameters. */
char* material_string = mccchannel_4_analyzer_2_array_crystal_array_4_material_string;
MCNUM priority = mccchannel_4_analyzer_2_array_crystal_array_4_priority;
MCNUM xwidth = mccchannel_4_analyzer_2_array_crystal_array_4_xwidth;
MCNUM yheight = mccchannel_4_analyzer_2_array_crystal_array_4_yheight;
MCNUM zdepth = mccchannel_4_analyzer_2_array_crystal_array_4_zdepth;
MCNUM xwidth2 = mccchannel_4_analyzer_2_array_crystal_array_4_xwidth2;
MCNUM yheight2 = mccchannel_4_analyzer_2_array_crystal_array_4_yheight2;
MCNUM visualize = mccchannel_4_analyzer_2_array_crystal_array_4_visualize;
int target_index = mccchannel_4_analyzer_2_array_crystal_array_4_target_index;
MCNUM target_x = mccchannel_4_analyzer_2_array_crystal_array_4_target_x;
MCNUM target_y = mccchannel_4_analyzer_2_array_crystal_array_4_target_y;
MCNUM target_z = mccchannel_4_analyzer_2_array_crystal_array_4_target_z;
MCNUM focus_aw = mccchannel_4_analyzer_2_array_crystal_array_4_focus_aw;
MCNUM focus_ah = mccchannel_4_analyzer_2_array_crystal_array_4_focus_ah;
MCNUM focus_xw = mccchannel_4_analyzer_2_array_crystal_array_4_focus_xw;
MCNUM focus_xh = mccchannel_4_analyzer_2_array_crystal_array_4_focus_xh;
MCNUM focus_r = mccchannel_4_analyzer_2_array_crystal_array_4_focus_r;
MCNUM p_interact = mccchannel_4_analyzer_2_array_crystal_array_4_p_interact;
char* mask_string = mccchannel_4_analyzer_2_array_crystal_array_4_mask_string;
char* mask_setting = mccchannel_4_analyzer_2_array_crystal_array_4_mask_setting;
MCNUM number_of_activations = mccchannel_4_analyzer_2_array_crystal_array_4_number_of_activations;
}   /* End of channel_4_analyzer_2_array_crystal_array_4=Union_box() SETTING parameter declarations. */
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex
  /* Label for restoring  neutron */
  mcabsorbCompchannel_4_analyzer_2_array_crystal_array_4:
  if (RESTORE) /* restore if needed */
  { RESTORE_NEUTRON(297,
      mcnlx,
      mcnly,
      mcnlz,
      mcnlvx,
      mcnlvy,
      mcnlvz,
      mcnlt,
      mcnlsx,
      mcnlsy,
      mcnlsz,
      mcnlp); }
#undef mcabsorbComp
#undef p
#undef sz
#undef sy
#undef sx
#undef t
#undef vz
#undef vy
#undef vx
#undef z
#undef y
#undef x
  mcDEBUG_STATE(
mcnlx,
mcnly,
mcnlz,
mcnlvx,
mcnlvy,
mcnlvz,
mcnlt,
mcnlsx,
mcnlsy,
mcnlsz,
mcnlp)

  /* TRACE Component channel_4_analyzer_2_array_crystal_array_5 [298] */
  mccoordschange(mcposrchannel_4_analyzer_2_array_crystal_array_5, mcrotrchannel_4_analyzer_2_array_crystal_array_5,
    &mcnlx,
    &mcnly,
    &mcnlz,
    &mcnlvx,
    &mcnlvy,
    &mcnlvz,
    &mcnlsx,
    &mcnlsy,
    &mcnlsz);
  /* define label inside component channel_4_analyzer_2_array_crystal_array_5 (without coords transformations) */
  mcJumpTrace_channel_4_analyzer_2_array_crystal_array_5:
  SIG_MESSAGE("channel_4_analyzer_2_array_crystal_array_5 (Trace)");
  mcDEBUG_COMP("channel_4_analyzer_2_array_crystal_array_5")
  mcDEBUG_STATE(
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp)
#define x mcnlx
#define y mcnly
#define z mcnlz
#define vx mcnlvx
#define vy mcnlvy
#define vz mcnlvz
#define t mcnlt
#define sx mcnlsx
#define sy mcnlsy
#define sz mcnlsz
#define p mcnlp

#define mcabsorbComp mcabsorbCompchannel_4_analyzer_2_array_crystal_array_5
  STORE_NEUTRON(298,
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp);
  mcScattered=0;
  mcRestore=0;
  mcNCounter[298]++;
  mcPCounter[298] += p;
  mcP2Counter[298] += p*p;
#define mccompcurname  channel_4_analyzer_2_array_crystal_array_5
#define mccompcurtype  Union_box
#define mccompcurindex 298
#define loop_index mccchannel_4_analyzer_2_array_crystal_array_5_loop_index
#define this_box_volume mccchannel_4_analyzer_2_array_crystal_array_5_this_box_volume
#define global_geometry_element mccchannel_4_analyzer_2_array_crystal_array_5_global_geometry_element
#define this_box_storage mccchannel_4_analyzer_2_array_crystal_array_5_this_box_storage
{   /* Declarations of channel_4_analyzer_2_array_crystal_array_5=Union_box() SETTING parameters. */
char* material_string = mccchannel_4_analyzer_2_array_crystal_array_5_material_string;
MCNUM priority = mccchannel_4_analyzer_2_array_crystal_array_5_priority;
MCNUM xwidth = mccchannel_4_analyzer_2_array_crystal_array_5_xwidth;
MCNUM yheight = mccchannel_4_analyzer_2_array_crystal_array_5_yheight;
MCNUM zdepth = mccchannel_4_analyzer_2_array_crystal_array_5_zdepth;
MCNUM xwidth2 = mccchannel_4_analyzer_2_array_crystal_array_5_xwidth2;
MCNUM yheight2 = mccchannel_4_analyzer_2_array_crystal_array_5_yheight2;
MCNUM visualize = mccchannel_4_analyzer_2_array_crystal_array_5_visualize;
int target_index = mccchannel_4_analyzer_2_array_crystal_array_5_target_index;
MCNUM target_x = mccchannel_4_analyzer_2_array_crystal_array_5_target_x;
MCNUM target_y = mccchannel_4_analyzer_2_array_crystal_array_5_target_y;
MCNUM target_z = mccchannel_4_analyzer_2_array_crystal_array_5_target_z;
MCNUM focus_aw = mccchannel_4_analyzer_2_array_crystal_array_5_focus_aw;
MCNUM focus_ah = mccchannel_4_analyzer_2_array_crystal_array_5_focus_ah;
MCNUM focus_xw = mccchannel_4_analyzer_2_array_crystal_array_5_focus_xw;
MCNUM focus_xh = mccchannel_4_analyzer_2_array_crystal_array_5_focus_xh;
MCNUM focus_r = mccchannel_4_analyzer_2_array_crystal_array_5_focus_r;
MCNUM p_interact = mccchannel_4_analyzer_2_array_crystal_array_5_p_interact;
char* mask_string = mccchannel_4_analyzer_2_array_crystal_array_5_mask_string;
char* mask_setting = mccchannel_4_analyzer_2_array_crystal_array_5_mask_setting;
MCNUM number_of_activations = mccchannel_4_analyzer_2_array_crystal_array_5_number_of_activations;
}   /* End of channel_4_analyzer_2_array_crystal_array_5=Union_box() SETTING parameter declarations. */
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex
  /* Label for restoring  neutron */
  mcabsorbCompchannel_4_analyzer_2_array_crystal_array_5:
  if (RESTORE) /* restore if needed */
  { RESTORE_NEUTRON(298,
      mcnlx,
      mcnly,
      mcnlz,
      mcnlvx,
      mcnlvy,
      mcnlvz,
      mcnlt,
      mcnlsx,
      mcnlsy,
      mcnlsz,
      mcnlp); }
#undef mcabsorbComp
#undef p
#undef sz
#undef sy
#undef sx
#undef t
#undef vz
#undef vy
#undef vx
#undef z
#undef y
#undef x
  mcDEBUG_STATE(
mcnlx,
mcnly,
mcnlz,
mcnlvx,
mcnlvy,
mcnlvz,
mcnlt,
mcnlsx,
mcnlsy,
mcnlsz,
mcnlp)

  /* TRACE Component channel_4_analyzer_2_array_crystal_array_6 [299] */
  mccoordschange(mcposrchannel_4_analyzer_2_array_crystal_array_6, mcrotrchannel_4_analyzer_2_array_crystal_array_6,
    &mcnlx,
    &mcnly,
    &mcnlz,
    &mcnlvx,
    &mcnlvy,
    &mcnlvz,
    &mcnlsx,
    &mcnlsy,
    &mcnlsz);
  /* define label inside component channel_4_analyzer_2_array_crystal_array_6 (without coords transformations) */
  mcJumpTrace_channel_4_analyzer_2_array_crystal_array_6:
  SIG_MESSAGE("channel_4_analyzer_2_array_crystal_array_6 (Trace)");
  mcDEBUG_COMP("channel_4_analyzer_2_array_crystal_array_6")
  mcDEBUG_STATE(
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp)
#define x mcnlx
#define y mcnly
#define z mcnlz
#define vx mcnlvx
#define vy mcnlvy
#define vz mcnlvz
#define t mcnlt
#define sx mcnlsx
#define sy mcnlsy
#define sz mcnlsz
#define p mcnlp

#define mcabsorbComp mcabsorbCompchannel_4_analyzer_2_array_crystal_array_6
  STORE_NEUTRON(299,
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp);
  mcScattered=0;
  mcRestore=0;
  mcNCounter[299]++;
  mcPCounter[299] += p;
  mcP2Counter[299] += p*p;
#define mccompcurname  channel_4_analyzer_2_array_crystal_array_6
#define mccompcurtype  Union_box
#define mccompcurindex 299
#define loop_index mccchannel_4_analyzer_2_array_crystal_array_6_loop_index
#define this_box_volume mccchannel_4_analyzer_2_array_crystal_array_6_this_box_volume
#define global_geometry_element mccchannel_4_analyzer_2_array_crystal_array_6_global_geometry_element
#define this_box_storage mccchannel_4_analyzer_2_array_crystal_array_6_this_box_storage
{   /* Declarations of channel_4_analyzer_2_array_crystal_array_6=Union_box() SETTING parameters. */
char* material_string = mccchannel_4_analyzer_2_array_crystal_array_6_material_string;
MCNUM priority = mccchannel_4_analyzer_2_array_crystal_array_6_priority;
MCNUM xwidth = mccchannel_4_analyzer_2_array_crystal_array_6_xwidth;
MCNUM yheight = mccchannel_4_analyzer_2_array_crystal_array_6_yheight;
MCNUM zdepth = mccchannel_4_analyzer_2_array_crystal_array_6_zdepth;
MCNUM xwidth2 = mccchannel_4_analyzer_2_array_crystal_array_6_xwidth2;
MCNUM yheight2 = mccchannel_4_analyzer_2_array_crystal_array_6_yheight2;
MCNUM visualize = mccchannel_4_analyzer_2_array_crystal_array_6_visualize;
int target_index = mccchannel_4_analyzer_2_array_crystal_array_6_target_index;
MCNUM target_x = mccchannel_4_analyzer_2_array_crystal_array_6_target_x;
MCNUM target_y = mccchannel_4_analyzer_2_array_crystal_array_6_target_y;
MCNUM target_z = mccchannel_4_analyzer_2_array_crystal_array_6_target_z;
MCNUM focus_aw = mccchannel_4_analyzer_2_array_crystal_array_6_focus_aw;
MCNUM focus_ah = mccchannel_4_analyzer_2_array_crystal_array_6_focus_ah;
MCNUM focus_xw = mccchannel_4_analyzer_2_array_crystal_array_6_focus_xw;
MCNUM focus_xh = mccchannel_4_analyzer_2_array_crystal_array_6_focus_xh;
MCNUM focus_r = mccchannel_4_analyzer_2_array_crystal_array_6_focus_r;
MCNUM p_interact = mccchannel_4_analyzer_2_array_crystal_array_6_p_interact;
char* mask_string = mccchannel_4_analyzer_2_array_crystal_array_6_mask_string;
char* mask_setting = mccchannel_4_analyzer_2_array_crystal_array_6_mask_setting;
MCNUM number_of_activations = mccchannel_4_analyzer_2_array_crystal_array_6_number_of_activations;
}   /* End of channel_4_analyzer_2_array_crystal_array_6=Union_box() SETTING parameter declarations. */
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex
  /* Label for restoring  neutron */
  mcabsorbCompchannel_4_analyzer_2_array_crystal_array_6:
  if (RESTORE) /* restore if needed */
  { RESTORE_NEUTRON(299,
      mcnlx,
      mcnly,
      mcnlz,
      mcnlvx,
      mcnlvy,
      mcnlvz,
      mcnlt,
      mcnlsx,
      mcnlsy,
      mcnlsz,
      mcnlp); }
#undef mcabsorbComp
#undef p
#undef sz
#undef sy
#undef sx
#undef t
#undef vz
#undef vy
#undef vx
#undef z
#undef y
#undef x
  mcDEBUG_STATE(
mcnlx,
mcnly,
mcnlz,
mcnlvx,
mcnlvy,
mcnlvz,
mcnlt,
mcnlsx,
mcnlsy,
mcnlsz,
mcnlp)

  /* TRACE Component channel_4_analyzer_2_array_crystal_array_7 [300] */
  mccoordschange(mcposrchannel_4_analyzer_2_array_crystal_array_7, mcrotrchannel_4_analyzer_2_array_crystal_array_7,
    &mcnlx,
    &mcnly,
    &mcnlz,
    &mcnlvx,
    &mcnlvy,
    &mcnlvz,
    &mcnlsx,
    &mcnlsy,
    &mcnlsz);
  /* define label inside component channel_4_analyzer_2_array_crystal_array_7 (without coords transformations) */
  mcJumpTrace_channel_4_analyzer_2_array_crystal_array_7:
  SIG_MESSAGE("channel_4_analyzer_2_array_crystal_array_7 (Trace)");
  mcDEBUG_COMP("channel_4_analyzer_2_array_crystal_array_7")
  mcDEBUG_STATE(
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp)
#define x mcnlx
#define y mcnly
#define z mcnlz
#define vx mcnlvx
#define vy mcnlvy
#define vz mcnlvz
#define t mcnlt
#define sx mcnlsx
#define sy mcnlsy
#define sz mcnlsz
#define p mcnlp

#define mcabsorbComp mcabsorbCompchannel_4_analyzer_2_array_crystal_array_7
  STORE_NEUTRON(300,
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp);
  mcScattered=0;
  mcRestore=0;
  mcNCounter[300]++;
  mcPCounter[300] += p;
  mcP2Counter[300] += p*p;
#define mccompcurname  channel_4_analyzer_2_array_crystal_array_7
#define mccompcurtype  Union_box
#define mccompcurindex 300
#define loop_index mccchannel_4_analyzer_2_array_crystal_array_7_loop_index
#define this_box_volume mccchannel_4_analyzer_2_array_crystal_array_7_this_box_volume
#define global_geometry_element mccchannel_4_analyzer_2_array_crystal_array_7_global_geometry_element
#define this_box_storage mccchannel_4_analyzer_2_array_crystal_array_7_this_box_storage
{   /* Declarations of channel_4_analyzer_2_array_crystal_array_7=Union_box() SETTING parameters. */
char* material_string = mccchannel_4_analyzer_2_array_crystal_array_7_material_string;
MCNUM priority = mccchannel_4_analyzer_2_array_crystal_array_7_priority;
MCNUM xwidth = mccchannel_4_analyzer_2_array_crystal_array_7_xwidth;
MCNUM yheight = mccchannel_4_analyzer_2_array_crystal_array_7_yheight;
MCNUM zdepth = mccchannel_4_analyzer_2_array_crystal_array_7_zdepth;
MCNUM xwidth2 = mccchannel_4_analyzer_2_array_crystal_array_7_xwidth2;
MCNUM yheight2 = mccchannel_4_analyzer_2_array_crystal_array_7_yheight2;
MCNUM visualize = mccchannel_4_analyzer_2_array_crystal_array_7_visualize;
int target_index = mccchannel_4_analyzer_2_array_crystal_array_7_target_index;
MCNUM target_x = mccchannel_4_analyzer_2_array_crystal_array_7_target_x;
MCNUM target_y = mccchannel_4_analyzer_2_array_crystal_array_7_target_y;
MCNUM target_z = mccchannel_4_analyzer_2_array_crystal_array_7_target_z;
MCNUM focus_aw = mccchannel_4_analyzer_2_array_crystal_array_7_focus_aw;
MCNUM focus_ah = mccchannel_4_analyzer_2_array_crystal_array_7_focus_ah;
MCNUM focus_xw = mccchannel_4_analyzer_2_array_crystal_array_7_focus_xw;
MCNUM focus_xh = mccchannel_4_analyzer_2_array_crystal_array_7_focus_xh;
MCNUM focus_r = mccchannel_4_analyzer_2_array_crystal_array_7_focus_r;
MCNUM p_interact = mccchannel_4_analyzer_2_array_crystal_array_7_p_interact;
char* mask_string = mccchannel_4_analyzer_2_array_crystal_array_7_mask_string;
char* mask_setting = mccchannel_4_analyzer_2_array_crystal_array_7_mask_setting;
MCNUM number_of_activations = mccchannel_4_analyzer_2_array_crystal_array_7_number_of_activations;
}   /* End of channel_4_analyzer_2_array_crystal_array_7=Union_box() SETTING parameter declarations. */
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex
  /* Label for restoring  neutron */
  mcabsorbCompchannel_4_analyzer_2_array_crystal_array_7:
  if (RESTORE) /* restore if needed */
  { RESTORE_NEUTRON(300,
      mcnlx,
      mcnly,
      mcnlz,
      mcnlvx,
      mcnlvy,
      mcnlvz,
      mcnlt,
      mcnlsx,
      mcnlsy,
      mcnlsz,
      mcnlp); }
#undef mcabsorbComp
#undef p
#undef sz
#undef sy
#undef sx
#undef t
#undef vz
#undef vy
#undef vx
#undef z
#undef y
#undef x
  mcDEBUG_STATE(
mcnlx,
mcnly,
mcnlz,
mcnlvx,
mcnlvy,
mcnlvz,
mcnlt,
mcnlsx,
mcnlsy,
mcnlsz,
mcnlp)

  /* TRACE Component channel_4_analyzer_2_array_crystal_array_8 [301] */
  mccoordschange(mcposrchannel_4_analyzer_2_array_crystal_array_8, mcrotrchannel_4_analyzer_2_array_crystal_array_8,
    &mcnlx,
    &mcnly,
    &mcnlz,
    &mcnlvx,
    &mcnlvy,
    &mcnlvz,
    &mcnlsx,
    &mcnlsy,
    &mcnlsz);
  /* define label inside component channel_4_analyzer_2_array_crystal_array_8 (without coords transformations) */
  mcJumpTrace_channel_4_analyzer_2_array_crystal_array_8:
  SIG_MESSAGE("channel_4_analyzer_2_array_crystal_array_8 (Trace)");
  mcDEBUG_COMP("channel_4_analyzer_2_array_crystal_array_8")
  mcDEBUG_STATE(
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp)
#define x mcnlx
#define y mcnly
#define z mcnlz
#define vx mcnlvx
#define vy mcnlvy
#define vz mcnlvz
#define t mcnlt
#define sx mcnlsx
#define sy mcnlsy
#define sz mcnlsz
#define p mcnlp

#define mcabsorbComp mcabsorbCompchannel_4_analyzer_2_array_crystal_array_8
  STORE_NEUTRON(301,
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp);
  mcScattered=0;
  mcRestore=0;
  mcNCounter[301]++;
  mcPCounter[301] += p;
  mcP2Counter[301] += p*p;
#define mccompcurname  channel_4_analyzer_2_array_crystal_array_8
#define mccompcurtype  Union_box
#define mccompcurindex 301
#define loop_index mccchannel_4_analyzer_2_array_crystal_array_8_loop_index
#define this_box_volume mccchannel_4_analyzer_2_array_crystal_array_8_this_box_volume
#define global_geometry_element mccchannel_4_analyzer_2_array_crystal_array_8_global_geometry_element
#define this_box_storage mccchannel_4_analyzer_2_array_crystal_array_8_this_box_storage
{   /* Declarations of channel_4_analyzer_2_array_crystal_array_8=Union_box() SETTING parameters. */
char* material_string = mccchannel_4_analyzer_2_array_crystal_array_8_material_string;
MCNUM priority = mccchannel_4_analyzer_2_array_crystal_array_8_priority;
MCNUM xwidth = mccchannel_4_analyzer_2_array_crystal_array_8_xwidth;
MCNUM yheight = mccchannel_4_analyzer_2_array_crystal_array_8_yheight;
MCNUM zdepth = mccchannel_4_analyzer_2_array_crystal_array_8_zdepth;
MCNUM xwidth2 = mccchannel_4_analyzer_2_array_crystal_array_8_xwidth2;
MCNUM yheight2 = mccchannel_4_analyzer_2_array_crystal_array_8_yheight2;
MCNUM visualize = mccchannel_4_analyzer_2_array_crystal_array_8_visualize;
int target_index = mccchannel_4_analyzer_2_array_crystal_array_8_target_index;
MCNUM target_x = mccchannel_4_analyzer_2_array_crystal_array_8_target_x;
MCNUM target_y = mccchannel_4_analyzer_2_array_crystal_array_8_target_y;
MCNUM target_z = mccchannel_4_analyzer_2_array_crystal_array_8_target_z;
MCNUM focus_aw = mccchannel_4_analyzer_2_array_crystal_array_8_focus_aw;
MCNUM focus_ah = mccchannel_4_analyzer_2_array_crystal_array_8_focus_ah;
MCNUM focus_xw = mccchannel_4_analyzer_2_array_crystal_array_8_focus_xw;
MCNUM focus_xh = mccchannel_4_analyzer_2_array_crystal_array_8_focus_xh;
MCNUM focus_r = mccchannel_4_analyzer_2_array_crystal_array_8_focus_r;
MCNUM p_interact = mccchannel_4_analyzer_2_array_crystal_array_8_p_interact;
char* mask_string = mccchannel_4_analyzer_2_array_crystal_array_8_mask_string;
char* mask_setting = mccchannel_4_analyzer_2_array_crystal_array_8_mask_setting;
MCNUM number_of_activations = mccchannel_4_analyzer_2_array_crystal_array_8_number_of_activations;
}   /* End of channel_4_analyzer_2_array_crystal_array_8=Union_box() SETTING parameter declarations. */
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex
  /* Label for restoring  neutron */
  mcabsorbCompchannel_4_analyzer_2_array_crystal_array_8:
  if (RESTORE) /* restore if needed */
  { RESTORE_NEUTRON(301,
      mcnlx,
      mcnly,
      mcnlz,
      mcnlvx,
      mcnlvy,
      mcnlvz,
      mcnlt,
      mcnlsx,
      mcnlsy,
      mcnlsz,
      mcnlp); }
#undef mcabsorbComp
#undef p
#undef sz
#undef sy
#undef sx
#undef t
#undef vz
#undef vy
#undef vx
#undef z
#undef y
#undef x
  mcDEBUG_STATE(
mcnlx,
mcnly,
mcnlz,
mcnlvx,
mcnlvy,
mcnlvz,
mcnlt,
mcnlsx,
mcnlsy,
mcnlsz,
mcnlp)

  /* TRACE Component channel_4_cave2_cyl1 [302] */
  mccoordschange(mcposrchannel_4_cave2_cyl1, mcrotrchannel_4_cave2_cyl1,
    &mcnlx,
    &mcnly,
    &mcnlz,
    &mcnlvx,
    &mcnlvy,
    &mcnlvz,
    &mcnlsx,
    &mcnlsy,
    &mcnlsz);
  /* define label inside component channel_4_cave2_cyl1 (without coords transformations) */
  mcJumpTrace_channel_4_cave2_cyl1:
  SIG_MESSAGE("channel_4_cave2_cyl1 (Trace)");
  mcDEBUG_COMP("channel_4_cave2_cyl1")
  mcDEBUG_STATE(
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp)
#define x mcnlx
#define y mcnly
#define z mcnlz
#define vx mcnlvx
#define vy mcnlvy
#define vz mcnlvz
#define t mcnlt
#define sx mcnlsx
#define sy mcnlsy
#define sz mcnlsz
#define p mcnlp

#define mcabsorbComp mcabsorbCompchannel_4_cave2_cyl1
  STORE_NEUTRON(302,
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp);
  mcScattered=0;
  mcRestore=0;
  mcNCounter[302]++;
  mcPCounter[302] += p;
  mcP2Counter[302] += p*p;
#define mccompcurname  channel_4_cave2_cyl1
#define mccompcurtype  Union_cylinder
#define mccompcurindex 302
#define loop_index mccchannel_4_cave2_cyl1_loop_index
#define this_cylinder_volume mccchannel_4_cave2_cyl1_this_cylinder_volume
#define global_geometry_element mccchannel_4_cave2_cyl1_global_geometry_element
#define this_cylinder_storage mccchannel_4_cave2_cyl1_this_cylinder_storage
{   /* Declarations of channel_4_cave2_cyl1=Union_cylinder() SETTING parameters. */
char* material_string = mccchannel_4_cave2_cyl1_material_string;
MCNUM priority = mccchannel_4_cave2_cyl1_priority;
MCNUM radius = mccchannel_4_cave2_cyl1_radius;
MCNUM yheight = mccchannel_4_cave2_cyl1_yheight;
MCNUM visualize = mccchannel_4_cave2_cyl1_visualize;
int target_index = mccchannel_4_cave2_cyl1_target_index;
MCNUM target_x = mccchannel_4_cave2_cyl1_target_x;
MCNUM target_y = mccchannel_4_cave2_cyl1_target_y;
MCNUM target_z = mccchannel_4_cave2_cyl1_target_z;
MCNUM focus_aw = mccchannel_4_cave2_cyl1_focus_aw;
MCNUM focus_ah = mccchannel_4_cave2_cyl1_focus_ah;
MCNUM focus_xw = mccchannel_4_cave2_cyl1_focus_xw;
MCNUM focus_xh = mccchannel_4_cave2_cyl1_focus_xh;
MCNUM focus_r = mccchannel_4_cave2_cyl1_focus_r;
MCNUM p_interact = mccchannel_4_cave2_cyl1_p_interact;
char* mask_string = mccchannel_4_cave2_cyl1_mask_string;
char* mask_setting = mccchannel_4_cave2_cyl1_mask_setting;
MCNUM number_of_activations = mccchannel_4_cave2_cyl1_number_of_activations;
#line 345 "Union_cylinder.comp"
{
dummy = 1;
}
#line 385782 "MACS_sample_kidney_box.c"
}   /* End of channel_4_cave2_cyl1=Union_cylinder() SETTING parameter declarations. */
#undef this_cylinder_storage
#undef global_geometry_element
#undef this_cylinder_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex
  /* Label for restoring  neutron */
  mcabsorbCompchannel_4_cave2_cyl1:
  if (RESTORE) /* restore if needed */
  { RESTORE_NEUTRON(302,
      mcnlx,
      mcnly,
      mcnlz,
      mcnlvx,
      mcnlvy,
      mcnlvz,
      mcnlt,
      mcnlsx,
      mcnlsy,
      mcnlsz,
      mcnlp); }
#undef mcabsorbComp
#undef p
#undef sz
#undef sy
#undef sx
#undef t
#undef vz
#undef vy
#undef vx
#undef z
#undef y
#undef x
  mcDEBUG_STATE(
mcnlx,
mcnly,
mcnlz,
mcnlvx,
mcnlvy,
mcnlvz,
mcnlt,
mcnlsx,
mcnlsy,
mcnlsz,
mcnlp)

  /* TRACE Component channel_4_cave2_box1 [303] */
  mccoordschange(mcposrchannel_4_cave2_box1, mcrotrchannel_4_cave2_box1,
    &mcnlx,
    &mcnly,
    &mcnlz,
    &mcnlvx,
    &mcnlvy,
    &mcnlvz,
    &mcnlsx,
    &mcnlsy,
    &mcnlsz);
  /* define label inside component channel_4_cave2_box1 (without coords transformations) */
  mcJumpTrace_channel_4_cave2_box1:
  SIG_MESSAGE("channel_4_cave2_box1 (Trace)");
  mcDEBUG_COMP("channel_4_cave2_box1")
  mcDEBUG_STATE(
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp)
#define x mcnlx
#define y mcnly
#define z mcnlz
#define vx mcnlvx
#define vy mcnlvy
#define vz mcnlvz
#define t mcnlt
#define sx mcnlsx
#define sy mcnlsy
#define sz mcnlsz
#define p mcnlp

#define mcabsorbComp mcabsorbCompchannel_4_cave2_box1
  STORE_NEUTRON(303,
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp);
  mcScattered=0;
  mcRestore=0;
  mcNCounter[303]++;
  mcPCounter[303] += p;
  mcP2Counter[303] += p*p;
#define mccompcurname  channel_4_cave2_box1
#define mccompcurtype  Union_box
#define mccompcurindex 303
#define loop_index mccchannel_4_cave2_box1_loop_index
#define this_box_volume mccchannel_4_cave2_box1_this_box_volume
#define global_geometry_element mccchannel_4_cave2_box1_global_geometry_element
#define this_box_storage mccchannel_4_cave2_box1_this_box_storage
{   /* Declarations of channel_4_cave2_box1=Union_box() SETTING parameters. */
char* material_string = mccchannel_4_cave2_box1_material_string;
MCNUM priority = mccchannel_4_cave2_box1_priority;
MCNUM xwidth = mccchannel_4_cave2_box1_xwidth;
MCNUM yheight = mccchannel_4_cave2_box1_yheight;
MCNUM zdepth = mccchannel_4_cave2_box1_zdepth;
MCNUM xwidth2 = mccchannel_4_cave2_box1_xwidth2;
MCNUM yheight2 = mccchannel_4_cave2_box1_yheight2;
MCNUM visualize = mccchannel_4_cave2_box1_visualize;
int target_index = mccchannel_4_cave2_box1_target_index;
MCNUM target_x = mccchannel_4_cave2_box1_target_x;
MCNUM target_y = mccchannel_4_cave2_box1_target_y;
MCNUM target_z = mccchannel_4_cave2_box1_target_z;
MCNUM focus_aw = mccchannel_4_cave2_box1_focus_aw;
MCNUM focus_ah = mccchannel_4_cave2_box1_focus_ah;
MCNUM focus_xw = mccchannel_4_cave2_box1_focus_xw;
MCNUM focus_xh = mccchannel_4_cave2_box1_focus_xh;
MCNUM focus_r = mccchannel_4_cave2_box1_focus_r;
MCNUM p_interact = mccchannel_4_cave2_box1_p_interact;
char* mask_string = mccchannel_4_cave2_box1_mask_string;
char* mask_setting = mccchannel_4_cave2_box1_mask_setting;
MCNUM number_of_activations = mccchannel_4_cave2_box1_number_of_activations;
}   /* End of channel_4_cave2_box1=Union_box() SETTING parameter declarations. */
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex
  /* Label for restoring  neutron */
  mcabsorbCompchannel_4_cave2_box1:
  if (RESTORE) /* restore if needed */
  { RESTORE_NEUTRON(303,
      mcnlx,
      mcnly,
      mcnlz,
      mcnlvx,
      mcnlvy,
      mcnlvz,
      mcnlt,
      mcnlsx,
      mcnlsy,
      mcnlsz,
      mcnlp); }
#undef mcabsorbComp
#undef p
#undef sz
#undef sy
#undef sx
#undef t
#undef vz
#undef vy
#undef vx
#undef z
#undef y
#undef x
  mcDEBUG_STATE(
mcnlx,
mcnly,
mcnlz,
mcnlvx,
mcnlvy,
mcnlvz,
mcnlt,
mcnlsx,
mcnlsy,
mcnlsz,
mcnlp)

  /* TRACE Component channel_4_cave2_box2 [304] */
  mccoordschange(mcposrchannel_4_cave2_box2, mcrotrchannel_4_cave2_box2,
    &mcnlx,
    &mcnly,
    &mcnlz,
    &mcnlvx,
    &mcnlvy,
    &mcnlvz,
    &mcnlsx,
    &mcnlsy,
    &mcnlsz);
  /* define label inside component channel_4_cave2_box2 (without coords transformations) */
  mcJumpTrace_channel_4_cave2_box2:
  SIG_MESSAGE("channel_4_cave2_box2 (Trace)");
  mcDEBUG_COMP("channel_4_cave2_box2")
  mcDEBUG_STATE(
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp)
#define x mcnlx
#define y mcnly
#define z mcnlz
#define vx mcnlvx
#define vy mcnlvy
#define vz mcnlvz
#define t mcnlt
#define sx mcnlsx
#define sy mcnlsy
#define sz mcnlsz
#define p mcnlp

#define mcabsorbComp mcabsorbCompchannel_4_cave2_box2
  STORE_NEUTRON(304,
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp);
  mcScattered=0;
  mcRestore=0;
  mcNCounter[304]++;
  mcPCounter[304] += p;
  mcP2Counter[304] += p*p;
#define mccompcurname  channel_4_cave2_box2
#define mccompcurtype  Union_box
#define mccompcurindex 304
#define loop_index mccchannel_4_cave2_box2_loop_index
#define this_box_volume mccchannel_4_cave2_box2_this_box_volume
#define global_geometry_element mccchannel_4_cave2_box2_global_geometry_element
#define this_box_storage mccchannel_4_cave2_box2_this_box_storage
{   /* Declarations of channel_4_cave2_box2=Union_box() SETTING parameters. */
char* material_string = mccchannel_4_cave2_box2_material_string;
MCNUM priority = mccchannel_4_cave2_box2_priority;
MCNUM xwidth = mccchannel_4_cave2_box2_xwidth;
MCNUM yheight = mccchannel_4_cave2_box2_yheight;
MCNUM zdepth = mccchannel_4_cave2_box2_zdepth;
MCNUM xwidth2 = mccchannel_4_cave2_box2_xwidth2;
MCNUM yheight2 = mccchannel_4_cave2_box2_yheight2;
MCNUM visualize = mccchannel_4_cave2_box2_visualize;
int target_index = mccchannel_4_cave2_box2_target_index;
MCNUM target_x = mccchannel_4_cave2_box2_target_x;
MCNUM target_y = mccchannel_4_cave2_box2_target_y;
MCNUM target_z = mccchannel_4_cave2_box2_target_z;
MCNUM focus_aw = mccchannel_4_cave2_box2_focus_aw;
MCNUM focus_ah = mccchannel_4_cave2_box2_focus_ah;
MCNUM focus_xw = mccchannel_4_cave2_box2_focus_xw;
MCNUM focus_xh = mccchannel_4_cave2_box2_focus_xh;
MCNUM focus_r = mccchannel_4_cave2_box2_focus_r;
MCNUM p_interact = mccchannel_4_cave2_box2_p_interact;
char* mask_string = mccchannel_4_cave2_box2_mask_string;
char* mask_setting = mccchannel_4_cave2_box2_mask_setting;
MCNUM number_of_activations = mccchannel_4_cave2_box2_number_of_activations;
}   /* End of channel_4_cave2_box2=Union_box() SETTING parameter declarations. */
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex
  /* Label for restoring  neutron */
  mcabsorbCompchannel_4_cave2_box2:
  if (RESTORE) /* restore if needed */
  { RESTORE_NEUTRON(304,
      mcnlx,
      mcnly,
      mcnlz,
      mcnlvx,
      mcnlvy,
      mcnlvz,
      mcnlt,
      mcnlsx,
      mcnlsy,
      mcnlsz,
      mcnlp); }
#undef mcabsorbComp
#undef p
#undef sz
#undef sy
#undef sx
#undef t
#undef vz
#undef vy
#undef vx
#undef z
#undef y
#undef x
  mcDEBUG_STATE(
mcnlx,
mcnly,
mcnlz,
mcnlvx,
mcnlvy,
mcnlvz,
mcnlt,
mcnlsx,
mcnlsy,
mcnlsz,
mcnlp)

  /* TRACE Component channel_4_cave2_box3 [305] */
  mccoordschange(mcposrchannel_4_cave2_box3, mcrotrchannel_4_cave2_box3,
    &mcnlx,
    &mcnly,
    &mcnlz,
    &mcnlvx,
    &mcnlvy,
    &mcnlvz,
    &mcnlsx,
    &mcnlsy,
    &mcnlsz);
  /* define label inside component channel_4_cave2_box3 (without coords transformations) */
  mcJumpTrace_channel_4_cave2_box3:
  SIG_MESSAGE("channel_4_cave2_box3 (Trace)");
  mcDEBUG_COMP("channel_4_cave2_box3")
  mcDEBUG_STATE(
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp)
#define x mcnlx
#define y mcnly
#define z mcnlz
#define vx mcnlvx
#define vy mcnlvy
#define vz mcnlvz
#define t mcnlt
#define sx mcnlsx
#define sy mcnlsy
#define sz mcnlsz
#define p mcnlp

#define mcabsorbComp mcabsorbCompchannel_4_cave2_box3
  STORE_NEUTRON(305,
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp);
  mcScattered=0;
  mcRestore=0;
  mcNCounter[305]++;
  mcPCounter[305] += p;
  mcP2Counter[305] += p*p;
#define mccompcurname  channel_4_cave2_box3
#define mccompcurtype  Union_box
#define mccompcurindex 305
#define loop_index mccchannel_4_cave2_box3_loop_index
#define this_box_volume mccchannel_4_cave2_box3_this_box_volume
#define global_geometry_element mccchannel_4_cave2_box3_global_geometry_element
#define this_box_storage mccchannel_4_cave2_box3_this_box_storage
{   /* Declarations of channel_4_cave2_box3=Union_box() SETTING parameters. */
char* material_string = mccchannel_4_cave2_box3_material_string;
MCNUM priority = mccchannel_4_cave2_box3_priority;
MCNUM xwidth = mccchannel_4_cave2_box3_xwidth;
MCNUM yheight = mccchannel_4_cave2_box3_yheight;
MCNUM zdepth = mccchannel_4_cave2_box3_zdepth;
MCNUM xwidth2 = mccchannel_4_cave2_box3_xwidth2;
MCNUM yheight2 = mccchannel_4_cave2_box3_yheight2;
MCNUM visualize = mccchannel_4_cave2_box3_visualize;
int target_index = mccchannel_4_cave2_box3_target_index;
MCNUM target_x = mccchannel_4_cave2_box3_target_x;
MCNUM target_y = mccchannel_4_cave2_box3_target_y;
MCNUM target_z = mccchannel_4_cave2_box3_target_z;
MCNUM focus_aw = mccchannel_4_cave2_box3_focus_aw;
MCNUM focus_ah = mccchannel_4_cave2_box3_focus_ah;
MCNUM focus_xw = mccchannel_4_cave2_box3_focus_xw;
MCNUM focus_xh = mccchannel_4_cave2_box3_focus_xh;
MCNUM focus_r = mccchannel_4_cave2_box3_focus_r;
MCNUM p_interact = mccchannel_4_cave2_box3_p_interact;
char* mask_string = mccchannel_4_cave2_box3_mask_string;
char* mask_setting = mccchannel_4_cave2_box3_mask_setting;
MCNUM number_of_activations = mccchannel_4_cave2_box3_number_of_activations;
}   /* End of channel_4_cave2_box3=Union_box() SETTING parameter declarations. */
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex
  /* Label for restoring  neutron */
  mcabsorbCompchannel_4_cave2_box3:
  if (RESTORE) /* restore if needed */
  { RESTORE_NEUTRON(305,
      mcnlx,
      mcnly,
      mcnlz,
      mcnlvx,
      mcnlvy,
      mcnlvz,
      mcnlt,
      mcnlsx,
      mcnlsy,
      mcnlsz,
      mcnlp); }
#undef mcabsorbComp
#undef p
#undef sz
#undef sy
#undef sx
#undef t
#undef vz
#undef vy
#undef vx
#undef z
#undef y
#undef x
  mcDEBUG_STATE(
mcnlx,
mcnly,
mcnlz,
mcnlvx,
mcnlvy,
mcnlvz,
mcnlt,
mcnlsx,
mcnlsy,
mcnlsz,
mcnlp)

  /* TRACE Component inter_analyzer_colimator_center_4 [306] */
  mccoordschange(mcposrinter_analyzer_colimator_center_4, mcrotrinter_analyzer_colimator_center_4,
    &mcnlx,
    &mcnly,
    &mcnlz,
    &mcnlvx,
    &mcnlvy,
    &mcnlvz,
    &mcnlsx,
    &mcnlsy,
    &mcnlsz);
  /* define label inside component inter_analyzer_colimator_center_4 (without coords transformations) */
  mcJumpTrace_inter_analyzer_colimator_center_4:
  SIG_MESSAGE("inter_analyzer_colimator_center_4 (Trace)");
  mcDEBUG_COMP("inter_analyzer_colimator_center_4")
  mcDEBUG_STATE(
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp)
#define x mcnlx
#define y mcnly
#define z mcnlz
#define vx mcnlvx
#define vy mcnlvy
#define vz mcnlvz
#define t mcnlt
#define sx mcnlsx
#define sy mcnlsy
#define sz mcnlsz
#define p mcnlp

#define mcabsorbComp mcabsorbCompinter_analyzer_colimator_center_4
  STORE_NEUTRON(306,
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp);
  mcScattered=0;
  mcRestore=0;
  mcNCounter[306]++;
  mcPCounter[306] += p;
  mcP2Counter[306] += p*p;
#define mccompcurname  inter_analyzer_colimator_center_4
#define mccompcurtype  Arm
#define mccompcurindex 306
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex
  /* Label for restoring  neutron */
  mcabsorbCompinter_analyzer_colimator_center_4:
  if (RESTORE) /* restore if needed */
  { RESTORE_NEUTRON(306,
      mcnlx,
      mcnly,
      mcnlz,
      mcnlvx,
      mcnlvy,
      mcnlvz,
      mcnlt,
      mcnlsx,
      mcnlsy,
      mcnlsz,
      mcnlp); }
#undef mcabsorbComp
#undef p
#undef sz
#undef sy
#undef sx
#undef t
#undef vz
#undef vy
#undef vx
#undef z
#undef y
#undef x
  mcDEBUG_STATE(
mcnlx,
mcnly,
mcnlz,
mcnlvx,
mcnlvy,
mcnlvz,
mcnlt,
mcnlsx,
mcnlsy,
mcnlsz,
mcnlp)

  /* TRACE Component inter_analyzer_colimator_4_blade_0 [307] */
  mccoordschange(mcposrinter_analyzer_colimator_4_blade_0, mcrotrinter_analyzer_colimator_4_blade_0,
    &mcnlx,
    &mcnly,
    &mcnlz,
    &mcnlvx,
    &mcnlvy,
    &mcnlvz,
    &mcnlsx,
    &mcnlsy,
    &mcnlsz);
  /* define label inside component inter_analyzer_colimator_4_blade_0 (without coords transformations) */
  mcJumpTrace_inter_analyzer_colimator_4_blade_0:
  SIG_MESSAGE("inter_analyzer_colimator_4_blade_0 (Trace)");
  mcDEBUG_COMP("inter_analyzer_colimator_4_blade_0")
  mcDEBUG_STATE(
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp)
#define x mcnlx
#define y mcnly
#define z mcnlz
#define vx mcnlvx
#define vy mcnlvy
#define vz mcnlvz
#define t mcnlt
#define sx mcnlsx
#define sy mcnlsy
#define sz mcnlsz
#define p mcnlp

#define mcabsorbComp mcabsorbCompinter_analyzer_colimator_4_blade_0
  STORE_NEUTRON(307,
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp);
  mcScattered=0;
  mcRestore=0;
  mcNCounter[307]++;
  mcPCounter[307] += p;
  mcP2Counter[307] += p*p;
#define mccompcurname  inter_analyzer_colimator_4_blade_0
#define mccompcurtype  Union_box
#define mccompcurindex 307
#define loop_index mccinter_analyzer_colimator_4_blade_0_loop_index
#define this_box_volume mccinter_analyzer_colimator_4_blade_0_this_box_volume
#define global_geometry_element mccinter_analyzer_colimator_4_blade_0_global_geometry_element
#define this_box_storage mccinter_analyzer_colimator_4_blade_0_this_box_storage
{   /* Declarations of inter_analyzer_colimator_4_blade_0=Union_box() SETTING parameters. */
char* material_string = mccinter_analyzer_colimator_4_blade_0_material_string;
MCNUM priority = mccinter_analyzer_colimator_4_blade_0_priority;
MCNUM xwidth = mccinter_analyzer_colimator_4_blade_0_xwidth;
MCNUM yheight = mccinter_analyzer_colimator_4_blade_0_yheight;
MCNUM zdepth = mccinter_analyzer_colimator_4_blade_0_zdepth;
MCNUM xwidth2 = mccinter_analyzer_colimator_4_blade_0_xwidth2;
MCNUM yheight2 = mccinter_analyzer_colimator_4_blade_0_yheight2;
MCNUM visualize = mccinter_analyzer_colimator_4_blade_0_visualize;
int target_index = mccinter_analyzer_colimator_4_blade_0_target_index;
MCNUM target_x = mccinter_analyzer_colimator_4_blade_0_target_x;
MCNUM target_y = mccinter_analyzer_colimator_4_blade_0_target_y;
MCNUM target_z = mccinter_analyzer_colimator_4_blade_0_target_z;
MCNUM focus_aw = mccinter_analyzer_colimator_4_blade_0_focus_aw;
MCNUM focus_ah = mccinter_analyzer_colimator_4_blade_0_focus_ah;
MCNUM focus_xw = mccinter_analyzer_colimator_4_blade_0_focus_xw;
MCNUM focus_xh = mccinter_analyzer_colimator_4_blade_0_focus_xh;
MCNUM focus_r = mccinter_analyzer_colimator_4_blade_0_focus_r;
MCNUM p_interact = mccinter_analyzer_colimator_4_blade_0_p_interact;
char* mask_string = mccinter_analyzer_colimator_4_blade_0_mask_string;
char* mask_setting = mccinter_analyzer_colimator_4_blade_0_mask_setting;
MCNUM number_of_activations = mccinter_analyzer_colimator_4_blade_0_number_of_activations;
}   /* End of inter_analyzer_colimator_4_blade_0=Union_box() SETTING parameter declarations. */
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex
  /* Label for restoring  neutron */
  mcabsorbCompinter_analyzer_colimator_4_blade_0:
  if (RESTORE) /* restore if needed */
  { RESTORE_NEUTRON(307,
      mcnlx,
      mcnly,
      mcnlz,
      mcnlvx,
      mcnlvy,
      mcnlvz,
      mcnlt,
      mcnlsx,
      mcnlsy,
      mcnlsz,
      mcnlp); }
#undef mcabsorbComp
#undef p
#undef sz
#undef sy
#undef sx
#undef t
#undef vz
#undef vy
#undef vx
#undef z
#undef y
#undef x
  mcDEBUG_STATE(
mcnlx,
mcnly,
mcnlz,
mcnlvx,
mcnlvy,
mcnlvz,
mcnlt,
mcnlsx,
mcnlsy,
mcnlsz,
mcnlp)

  /* TRACE Component inter_analyzer_colimator_4_blade_1 [308] */
  mccoordschange(mcposrinter_analyzer_colimator_4_blade_1, mcrotrinter_analyzer_colimator_4_blade_1,
    &mcnlx,
    &mcnly,
    &mcnlz,
    &mcnlvx,
    &mcnlvy,
    &mcnlvz,
    &mcnlsx,
    &mcnlsy,
    &mcnlsz);
  /* define label inside component inter_analyzer_colimator_4_blade_1 (without coords transformations) */
  mcJumpTrace_inter_analyzer_colimator_4_blade_1:
  SIG_MESSAGE("inter_analyzer_colimator_4_blade_1 (Trace)");
  mcDEBUG_COMP("inter_analyzer_colimator_4_blade_1")
  mcDEBUG_STATE(
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp)
#define x mcnlx
#define y mcnly
#define z mcnlz
#define vx mcnlvx
#define vy mcnlvy
#define vz mcnlvz
#define t mcnlt
#define sx mcnlsx
#define sy mcnlsy
#define sz mcnlsz
#define p mcnlp

#define mcabsorbComp mcabsorbCompinter_analyzer_colimator_4_blade_1
  STORE_NEUTRON(308,
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp);
  mcScattered=0;
  mcRestore=0;
  mcNCounter[308]++;
  mcPCounter[308] += p;
  mcP2Counter[308] += p*p;
#define mccompcurname  inter_analyzer_colimator_4_blade_1
#define mccompcurtype  Union_box
#define mccompcurindex 308
#define loop_index mccinter_analyzer_colimator_4_blade_1_loop_index
#define this_box_volume mccinter_analyzer_colimator_4_blade_1_this_box_volume
#define global_geometry_element mccinter_analyzer_colimator_4_blade_1_global_geometry_element
#define this_box_storage mccinter_analyzer_colimator_4_blade_1_this_box_storage
{   /* Declarations of inter_analyzer_colimator_4_blade_1=Union_box() SETTING parameters. */
char* material_string = mccinter_analyzer_colimator_4_blade_1_material_string;
MCNUM priority = mccinter_analyzer_colimator_4_blade_1_priority;
MCNUM xwidth = mccinter_analyzer_colimator_4_blade_1_xwidth;
MCNUM yheight = mccinter_analyzer_colimator_4_blade_1_yheight;
MCNUM zdepth = mccinter_analyzer_colimator_4_blade_1_zdepth;
MCNUM xwidth2 = mccinter_analyzer_colimator_4_blade_1_xwidth2;
MCNUM yheight2 = mccinter_analyzer_colimator_4_blade_1_yheight2;
MCNUM visualize = mccinter_analyzer_colimator_4_blade_1_visualize;
int target_index = mccinter_analyzer_colimator_4_blade_1_target_index;
MCNUM target_x = mccinter_analyzer_colimator_4_blade_1_target_x;
MCNUM target_y = mccinter_analyzer_colimator_4_blade_1_target_y;
MCNUM target_z = mccinter_analyzer_colimator_4_blade_1_target_z;
MCNUM focus_aw = mccinter_analyzer_colimator_4_blade_1_focus_aw;
MCNUM focus_ah = mccinter_analyzer_colimator_4_blade_1_focus_ah;
MCNUM focus_xw = mccinter_analyzer_colimator_4_blade_1_focus_xw;
MCNUM focus_xh = mccinter_analyzer_colimator_4_blade_1_focus_xh;
MCNUM focus_r = mccinter_analyzer_colimator_4_blade_1_focus_r;
MCNUM p_interact = mccinter_analyzer_colimator_4_blade_1_p_interact;
char* mask_string = mccinter_analyzer_colimator_4_blade_1_mask_string;
char* mask_setting = mccinter_analyzer_colimator_4_blade_1_mask_setting;
MCNUM number_of_activations = mccinter_analyzer_colimator_4_blade_1_number_of_activations;
}   /* End of inter_analyzer_colimator_4_blade_1=Union_box() SETTING parameter declarations. */
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex
  /* Label for restoring  neutron */
  mcabsorbCompinter_analyzer_colimator_4_blade_1:
  if (RESTORE) /* restore if needed */
  { RESTORE_NEUTRON(308,
      mcnlx,
      mcnly,
      mcnlz,
      mcnlvx,
      mcnlvy,
      mcnlvz,
      mcnlt,
      mcnlsx,
      mcnlsy,
      mcnlsz,
      mcnlp); }
#undef mcabsorbComp
#undef p
#undef sz
#undef sy
#undef sx
#undef t
#undef vz
#undef vy
#undef vx
#undef z
#undef y
#undef x
  mcDEBUG_STATE(
mcnlx,
mcnly,
mcnlz,
mcnlvx,
mcnlvy,
mcnlvz,
mcnlt,
mcnlsx,
mcnlsy,
mcnlsz,
mcnlp)

  /* TRACE Component inter_analyzer_colimator_4_blade_2 [309] */
  mccoordschange(mcposrinter_analyzer_colimator_4_blade_2, mcrotrinter_analyzer_colimator_4_blade_2,
    &mcnlx,
    &mcnly,
    &mcnlz,
    &mcnlvx,
    &mcnlvy,
    &mcnlvz,
    &mcnlsx,
    &mcnlsy,
    &mcnlsz);
  /* define label inside component inter_analyzer_colimator_4_blade_2 (without coords transformations) */
  mcJumpTrace_inter_analyzer_colimator_4_blade_2:
  SIG_MESSAGE("inter_analyzer_colimator_4_blade_2 (Trace)");
  mcDEBUG_COMP("inter_analyzer_colimator_4_blade_2")
  mcDEBUG_STATE(
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp)
#define x mcnlx
#define y mcnly
#define z mcnlz
#define vx mcnlvx
#define vy mcnlvy
#define vz mcnlvz
#define t mcnlt
#define sx mcnlsx
#define sy mcnlsy
#define sz mcnlsz
#define p mcnlp

#define mcabsorbComp mcabsorbCompinter_analyzer_colimator_4_blade_2
  STORE_NEUTRON(309,
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp);
  mcScattered=0;
  mcRestore=0;
  mcNCounter[309]++;
  mcPCounter[309] += p;
  mcP2Counter[309] += p*p;
#define mccompcurname  inter_analyzer_colimator_4_blade_2
#define mccompcurtype  Union_box
#define mccompcurindex 309
#define loop_index mccinter_analyzer_colimator_4_blade_2_loop_index
#define this_box_volume mccinter_analyzer_colimator_4_blade_2_this_box_volume
#define global_geometry_element mccinter_analyzer_colimator_4_blade_2_global_geometry_element
#define this_box_storage mccinter_analyzer_colimator_4_blade_2_this_box_storage
{   /* Declarations of inter_analyzer_colimator_4_blade_2=Union_box() SETTING parameters. */
char* material_string = mccinter_analyzer_colimator_4_blade_2_material_string;
MCNUM priority = mccinter_analyzer_colimator_4_blade_2_priority;
MCNUM xwidth = mccinter_analyzer_colimator_4_blade_2_xwidth;
MCNUM yheight = mccinter_analyzer_colimator_4_blade_2_yheight;
MCNUM zdepth = mccinter_analyzer_colimator_4_blade_2_zdepth;
MCNUM xwidth2 = mccinter_analyzer_colimator_4_blade_2_xwidth2;
MCNUM yheight2 = mccinter_analyzer_colimator_4_blade_2_yheight2;
MCNUM visualize = mccinter_analyzer_colimator_4_blade_2_visualize;
int target_index = mccinter_analyzer_colimator_4_blade_2_target_index;
MCNUM target_x = mccinter_analyzer_colimator_4_blade_2_target_x;
MCNUM target_y = mccinter_analyzer_colimator_4_blade_2_target_y;
MCNUM target_z = mccinter_analyzer_colimator_4_blade_2_target_z;
MCNUM focus_aw = mccinter_analyzer_colimator_4_blade_2_focus_aw;
MCNUM focus_ah = mccinter_analyzer_colimator_4_blade_2_focus_ah;
MCNUM focus_xw = mccinter_analyzer_colimator_4_blade_2_focus_xw;
MCNUM focus_xh = mccinter_analyzer_colimator_4_blade_2_focus_xh;
MCNUM focus_r = mccinter_analyzer_colimator_4_blade_2_focus_r;
MCNUM p_interact = mccinter_analyzer_colimator_4_blade_2_p_interact;
char* mask_string = mccinter_analyzer_colimator_4_blade_2_mask_string;
char* mask_setting = mccinter_analyzer_colimator_4_blade_2_mask_setting;
MCNUM number_of_activations = mccinter_analyzer_colimator_4_blade_2_number_of_activations;
}   /* End of inter_analyzer_colimator_4_blade_2=Union_box() SETTING parameter declarations. */
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex
  /* Label for restoring  neutron */
  mcabsorbCompinter_analyzer_colimator_4_blade_2:
  if (RESTORE) /* restore if needed */
  { RESTORE_NEUTRON(309,
      mcnlx,
      mcnly,
      mcnlz,
      mcnlvx,
      mcnlvy,
      mcnlvz,
      mcnlt,
      mcnlsx,
      mcnlsy,
      mcnlsz,
      mcnlp); }
#undef mcabsorbComp
#undef p
#undef sz
#undef sy
#undef sx
#undef t
#undef vz
#undef vy
#undef vx
#undef z
#undef y
#undef x
  mcDEBUG_STATE(
mcnlx,
mcnly,
mcnlz,
mcnlvx,
mcnlvy,
mcnlvz,
mcnlt,
mcnlsx,
mcnlsy,
mcnlsz,
mcnlp)

  /* TRACE Component inter_analyzer_colimator_4_blade_3 [310] */
  mccoordschange(mcposrinter_analyzer_colimator_4_blade_3, mcrotrinter_analyzer_colimator_4_blade_3,
    &mcnlx,
    &mcnly,
    &mcnlz,
    &mcnlvx,
    &mcnlvy,
    &mcnlvz,
    &mcnlsx,
    &mcnlsy,
    &mcnlsz);
  /* define label inside component inter_analyzer_colimator_4_blade_3 (without coords transformations) */
  mcJumpTrace_inter_analyzer_colimator_4_blade_3:
  SIG_MESSAGE("inter_analyzer_colimator_4_blade_3 (Trace)");
  mcDEBUG_COMP("inter_analyzer_colimator_4_blade_3")
  mcDEBUG_STATE(
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp)
#define x mcnlx
#define y mcnly
#define z mcnlz
#define vx mcnlvx
#define vy mcnlvy
#define vz mcnlvz
#define t mcnlt
#define sx mcnlsx
#define sy mcnlsy
#define sz mcnlsz
#define p mcnlp

#define mcabsorbComp mcabsorbCompinter_analyzer_colimator_4_blade_3
  STORE_NEUTRON(310,
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp);
  mcScattered=0;
  mcRestore=0;
  mcNCounter[310]++;
  mcPCounter[310] += p;
  mcP2Counter[310] += p*p;
#define mccompcurname  inter_analyzer_colimator_4_blade_3
#define mccompcurtype  Union_box
#define mccompcurindex 310
#define loop_index mccinter_analyzer_colimator_4_blade_3_loop_index
#define this_box_volume mccinter_analyzer_colimator_4_blade_3_this_box_volume
#define global_geometry_element mccinter_analyzer_colimator_4_blade_3_global_geometry_element
#define this_box_storage mccinter_analyzer_colimator_4_blade_3_this_box_storage
{   /* Declarations of inter_analyzer_colimator_4_blade_3=Union_box() SETTING parameters. */
char* material_string = mccinter_analyzer_colimator_4_blade_3_material_string;
MCNUM priority = mccinter_analyzer_colimator_4_blade_3_priority;
MCNUM xwidth = mccinter_analyzer_colimator_4_blade_3_xwidth;
MCNUM yheight = mccinter_analyzer_colimator_4_blade_3_yheight;
MCNUM zdepth = mccinter_analyzer_colimator_4_blade_3_zdepth;
MCNUM xwidth2 = mccinter_analyzer_colimator_4_blade_3_xwidth2;
MCNUM yheight2 = mccinter_analyzer_colimator_4_blade_3_yheight2;
MCNUM visualize = mccinter_analyzer_colimator_4_blade_3_visualize;
int target_index = mccinter_analyzer_colimator_4_blade_3_target_index;
MCNUM target_x = mccinter_analyzer_colimator_4_blade_3_target_x;
MCNUM target_y = mccinter_analyzer_colimator_4_blade_3_target_y;
MCNUM target_z = mccinter_analyzer_colimator_4_blade_3_target_z;
MCNUM focus_aw = mccinter_analyzer_colimator_4_blade_3_focus_aw;
MCNUM focus_ah = mccinter_analyzer_colimator_4_blade_3_focus_ah;
MCNUM focus_xw = mccinter_analyzer_colimator_4_blade_3_focus_xw;
MCNUM focus_xh = mccinter_analyzer_colimator_4_blade_3_focus_xh;
MCNUM focus_r = mccinter_analyzer_colimator_4_blade_3_focus_r;
MCNUM p_interact = mccinter_analyzer_colimator_4_blade_3_p_interact;
char* mask_string = mccinter_analyzer_colimator_4_blade_3_mask_string;
char* mask_setting = mccinter_analyzer_colimator_4_blade_3_mask_setting;
MCNUM number_of_activations = mccinter_analyzer_colimator_4_blade_3_number_of_activations;
}   /* End of inter_analyzer_colimator_4_blade_3=Union_box() SETTING parameter declarations. */
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex
  /* Label for restoring  neutron */
  mcabsorbCompinter_analyzer_colimator_4_blade_3:
  if (RESTORE) /* restore if needed */
  { RESTORE_NEUTRON(310,
      mcnlx,
      mcnly,
      mcnlz,
      mcnlvx,
      mcnlvy,
      mcnlvz,
      mcnlt,
      mcnlsx,
      mcnlsy,
      mcnlsz,
      mcnlp); }
#undef mcabsorbComp
#undef p
#undef sz
#undef sy
#undef sx
#undef t
#undef vz
#undef vy
#undef vx
#undef z
#undef y
#undef x
  mcDEBUG_STATE(
mcnlx,
mcnly,
mcnlz,
mcnlvx,
mcnlvy,
mcnlvz,
mcnlt,
mcnlsx,
mcnlsy,
mcnlsz,
mcnlp)

  /* TRACE Component inter_analyzer_colimator_4_blade_4 [311] */
  mccoordschange(mcposrinter_analyzer_colimator_4_blade_4, mcrotrinter_analyzer_colimator_4_blade_4,
    &mcnlx,
    &mcnly,
    &mcnlz,
    &mcnlvx,
    &mcnlvy,
    &mcnlvz,
    &mcnlsx,
    &mcnlsy,
    &mcnlsz);
  /* define label inside component inter_analyzer_colimator_4_blade_4 (without coords transformations) */
  mcJumpTrace_inter_analyzer_colimator_4_blade_4:
  SIG_MESSAGE("inter_analyzer_colimator_4_blade_4 (Trace)");
  mcDEBUG_COMP("inter_analyzer_colimator_4_blade_4")
  mcDEBUG_STATE(
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp)
#define x mcnlx
#define y mcnly
#define z mcnlz
#define vx mcnlvx
#define vy mcnlvy
#define vz mcnlvz
#define t mcnlt
#define sx mcnlsx
#define sy mcnlsy
#define sz mcnlsz
#define p mcnlp

#define mcabsorbComp mcabsorbCompinter_analyzer_colimator_4_blade_4
  STORE_NEUTRON(311,
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp);
  mcScattered=0;
  mcRestore=0;
  mcNCounter[311]++;
  mcPCounter[311] += p;
  mcP2Counter[311] += p*p;
#define mccompcurname  inter_analyzer_colimator_4_blade_4
#define mccompcurtype  Union_box
#define mccompcurindex 311
#define loop_index mccinter_analyzer_colimator_4_blade_4_loop_index
#define this_box_volume mccinter_analyzer_colimator_4_blade_4_this_box_volume
#define global_geometry_element mccinter_analyzer_colimator_4_blade_4_global_geometry_element
#define this_box_storage mccinter_analyzer_colimator_4_blade_4_this_box_storage
{   /* Declarations of inter_analyzer_colimator_4_blade_4=Union_box() SETTING parameters. */
char* material_string = mccinter_analyzer_colimator_4_blade_4_material_string;
MCNUM priority = mccinter_analyzer_colimator_4_blade_4_priority;
MCNUM xwidth = mccinter_analyzer_colimator_4_blade_4_xwidth;
MCNUM yheight = mccinter_analyzer_colimator_4_blade_4_yheight;
MCNUM zdepth = mccinter_analyzer_colimator_4_blade_4_zdepth;
MCNUM xwidth2 = mccinter_analyzer_colimator_4_blade_4_xwidth2;
MCNUM yheight2 = mccinter_analyzer_colimator_4_blade_4_yheight2;
MCNUM visualize = mccinter_analyzer_colimator_4_blade_4_visualize;
int target_index = mccinter_analyzer_colimator_4_blade_4_target_index;
MCNUM target_x = mccinter_analyzer_colimator_4_blade_4_target_x;
MCNUM target_y = mccinter_analyzer_colimator_4_blade_4_target_y;
MCNUM target_z = mccinter_analyzer_colimator_4_blade_4_target_z;
MCNUM focus_aw = mccinter_analyzer_colimator_4_blade_4_focus_aw;
MCNUM focus_ah = mccinter_analyzer_colimator_4_blade_4_focus_ah;
MCNUM focus_xw = mccinter_analyzer_colimator_4_blade_4_focus_xw;
MCNUM focus_xh = mccinter_analyzer_colimator_4_blade_4_focus_xh;
MCNUM focus_r = mccinter_analyzer_colimator_4_blade_4_focus_r;
MCNUM p_interact = mccinter_analyzer_colimator_4_blade_4_p_interact;
char* mask_string = mccinter_analyzer_colimator_4_blade_4_mask_string;
char* mask_setting = mccinter_analyzer_colimator_4_blade_4_mask_setting;
MCNUM number_of_activations = mccinter_analyzer_colimator_4_blade_4_number_of_activations;
}   /* End of inter_analyzer_colimator_4_blade_4=Union_box() SETTING parameter declarations. */
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex
  /* Label for restoring  neutron */
  mcabsorbCompinter_analyzer_colimator_4_blade_4:
  if (RESTORE) /* restore if needed */
  { RESTORE_NEUTRON(311,
      mcnlx,
      mcnly,
      mcnlz,
      mcnlvx,
      mcnlvy,
      mcnlvz,
      mcnlt,
      mcnlsx,
      mcnlsy,
      mcnlsz,
      mcnlp); }
#undef mcabsorbComp
#undef p
#undef sz
#undef sy
#undef sx
#undef t
#undef vz
#undef vy
#undef vx
#undef z
#undef y
#undef x
  mcDEBUG_STATE(
mcnlx,
mcnly,
mcnlz,
mcnlvx,
mcnlvy,
mcnlvz,
mcnlt,
mcnlsx,
mcnlsy,
mcnlsz,
mcnlp)

  /* TRACE Component diffraction_detector_4_exit_volume [312] */
  mccoordschange(mcposrdiffraction_detector_4_exit_volume, mcrotrdiffraction_detector_4_exit_volume,
    &mcnlx,
    &mcnly,
    &mcnlz,
    &mcnlvx,
    &mcnlvy,
    &mcnlvz,
    &mcnlsx,
    &mcnlsy,
    &mcnlsz);
  /* define label inside component diffraction_detector_4_exit_volume (without coords transformations) */
  mcJumpTrace_diffraction_detector_4_exit_volume:
  SIG_MESSAGE("diffraction_detector_4_exit_volume (Trace)");
  mcDEBUG_COMP("diffraction_detector_4_exit_volume")
  mcDEBUG_STATE(
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp)
#define x mcnlx
#define y mcnly
#define z mcnlz
#define vx mcnlvx
#define vy mcnlvy
#define vz mcnlvz
#define t mcnlt
#define sx mcnlsx
#define sy mcnlsy
#define sz mcnlsz
#define p mcnlp

#define mcabsorbComp mcabsorbCompdiffraction_detector_4_exit_volume
  STORE_NEUTRON(312,
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp);
  mcScattered=0;
  mcRestore=0;
  mcNCounter[312]++;
  mcPCounter[312] += p;
  mcP2Counter[312] += p*p;
#define mccompcurname  diffraction_detector_4_exit_volume
#define mccompcurtype  Union_box
#define mccompcurindex 312
#define loop_index mccdiffraction_detector_4_exit_volume_loop_index
#define this_box_volume mccdiffraction_detector_4_exit_volume_this_box_volume
#define global_geometry_element mccdiffraction_detector_4_exit_volume_global_geometry_element
#define this_box_storage mccdiffraction_detector_4_exit_volume_this_box_storage
{   /* Declarations of diffraction_detector_4_exit_volume=Union_box() SETTING parameters. */
char* material_string = mccdiffraction_detector_4_exit_volume_material_string;
MCNUM priority = mccdiffraction_detector_4_exit_volume_priority;
MCNUM xwidth = mccdiffraction_detector_4_exit_volume_xwidth;
MCNUM yheight = mccdiffraction_detector_4_exit_volume_yheight;
MCNUM zdepth = mccdiffraction_detector_4_exit_volume_zdepth;
MCNUM xwidth2 = mccdiffraction_detector_4_exit_volume_xwidth2;
MCNUM yheight2 = mccdiffraction_detector_4_exit_volume_yheight2;
MCNUM visualize = mccdiffraction_detector_4_exit_volume_visualize;
int target_index = mccdiffraction_detector_4_exit_volume_target_index;
MCNUM target_x = mccdiffraction_detector_4_exit_volume_target_x;
MCNUM target_y = mccdiffraction_detector_4_exit_volume_target_y;
MCNUM target_z = mccdiffraction_detector_4_exit_volume_target_z;
MCNUM focus_aw = mccdiffraction_detector_4_exit_volume_focus_aw;
MCNUM focus_ah = mccdiffraction_detector_4_exit_volume_focus_ah;
MCNUM focus_xw = mccdiffraction_detector_4_exit_volume_focus_xw;
MCNUM focus_xh = mccdiffraction_detector_4_exit_volume_focus_xh;
MCNUM focus_r = mccdiffraction_detector_4_exit_volume_focus_r;
MCNUM p_interact = mccdiffraction_detector_4_exit_volume_p_interact;
char* mask_string = mccdiffraction_detector_4_exit_volume_mask_string;
char* mask_setting = mccdiffraction_detector_4_exit_volume_mask_setting;
MCNUM number_of_activations = mccdiffraction_detector_4_exit_volume_number_of_activations;
}   /* End of diffraction_detector_4_exit_volume=Union_box() SETTING parameter declarations. */
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex
  /* Label for restoring  neutron */
  mcabsorbCompdiffraction_detector_4_exit_volume:
  if (RESTORE) /* restore if needed */
  { RESTORE_NEUTRON(312,
      mcnlx,
      mcnly,
      mcnlz,
      mcnlvx,
      mcnlvy,
      mcnlvz,
      mcnlt,
      mcnlsx,
      mcnlsy,
      mcnlsz,
      mcnlp); }
#undef mcabsorbComp
#undef p
#undef sz
#undef sy
#undef sx
#undef t
#undef vz
#undef vy
#undef vx
#undef z
#undef y
#undef x
  mcDEBUG_STATE(
mcnlx,
mcnly,
mcnlz,
mcnlvx,
mcnlvy,
mcnlvz,
mcnlt,
mcnlsx,
mcnlsy,
mcnlsz,
mcnlp)

  /* TRACE Component spec_detector_4_exit_volume [313] */
  mccoordschange(mcposrspec_detector_4_exit_volume, mcrotrspec_detector_4_exit_volume,
    &mcnlx,
    &mcnly,
    &mcnlz,
    &mcnlvx,
    &mcnlvy,
    &mcnlvz,
    &mcnlsx,
    &mcnlsy,
    &mcnlsz);
  /* define label inside component spec_detector_4_exit_volume (without coords transformations) */
  mcJumpTrace_spec_detector_4_exit_volume:
  SIG_MESSAGE("spec_detector_4_exit_volume (Trace)");
  mcDEBUG_COMP("spec_detector_4_exit_volume")
  mcDEBUG_STATE(
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp)
#define x mcnlx
#define y mcnly
#define z mcnlz
#define vx mcnlvx
#define vy mcnlvy
#define vz mcnlvz
#define t mcnlt
#define sx mcnlsx
#define sy mcnlsy
#define sz mcnlsz
#define p mcnlp

#define mcabsorbComp mcabsorbCompspec_detector_4_exit_volume
  STORE_NEUTRON(313,
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp);
  mcScattered=0;
  mcRestore=0;
  mcNCounter[313]++;
  mcPCounter[313] += p;
  mcP2Counter[313] += p*p;
#define mccompcurname  spec_detector_4_exit_volume
#define mccompcurtype  Union_box
#define mccompcurindex 313
#define loop_index mccspec_detector_4_exit_volume_loop_index
#define this_box_volume mccspec_detector_4_exit_volume_this_box_volume
#define global_geometry_element mccspec_detector_4_exit_volume_global_geometry_element
#define this_box_storage mccspec_detector_4_exit_volume_this_box_storage
{   /* Declarations of spec_detector_4_exit_volume=Union_box() SETTING parameters. */
char* material_string = mccspec_detector_4_exit_volume_material_string;
MCNUM priority = mccspec_detector_4_exit_volume_priority;
MCNUM xwidth = mccspec_detector_4_exit_volume_xwidth;
MCNUM yheight = mccspec_detector_4_exit_volume_yheight;
MCNUM zdepth = mccspec_detector_4_exit_volume_zdepth;
MCNUM xwidth2 = mccspec_detector_4_exit_volume_xwidth2;
MCNUM yheight2 = mccspec_detector_4_exit_volume_yheight2;
MCNUM visualize = mccspec_detector_4_exit_volume_visualize;
int target_index = mccspec_detector_4_exit_volume_target_index;
MCNUM target_x = mccspec_detector_4_exit_volume_target_x;
MCNUM target_y = mccspec_detector_4_exit_volume_target_y;
MCNUM target_z = mccspec_detector_4_exit_volume_target_z;
MCNUM focus_aw = mccspec_detector_4_exit_volume_focus_aw;
MCNUM focus_ah = mccspec_detector_4_exit_volume_focus_ah;
MCNUM focus_xw = mccspec_detector_4_exit_volume_focus_xw;
MCNUM focus_xh = mccspec_detector_4_exit_volume_focus_xh;
MCNUM focus_r = mccspec_detector_4_exit_volume_focus_r;
MCNUM p_interact = mccspec_detector_4_exit_volume_p_interact;
char* mask_string = mccspec_detector_4_exit_volume_mask_string;
char* mask_setting = mccspec_detector_4_exit_volume_mask_setting;
MCNUM number_of_activations = mccspec_detector_4_exit_volume_number_of_activations;
}   /* End of spec_detector_4_exit_volume=Union_box() SETTING parameter declarations. */
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex
  /* Label for restoring  neutron */
  mcabsorbCompspec_detector_4_exit_volume:
  if (RESTORE) /* restore if needed */
  { RESTORE_NEUTRON(313,
      mcnlx,
      mcnly,
      mcnlz,
      mcnlvx,
      mcnlvy,
      mcnlvz,
      mcnlt,
      mcnlsx,
      mcnlsy,
      mcnlsz,
      mcnlp); }
#undef mcabsorbComp
#undef p
#undef sz
#undef sy
#undef sx
#undef t
#undef vz
#undef vy
#undef vx
#undef z
#undef y
#undef x
  mcDEBUG_STATE(
mcnlx,
mcnly,
mcnlz,
mcnlvx,
mcnlvy,
mcnlvz,
mcnlt,
mcnlsx,
mcnlsy,
mcnlsz,
mcnlp)

  /* TRACE Component channel_5_cave1_box1 [314] */
  mccoordschange(mcposrchannel_5_cave1_box1, mcrotrchannel_5_cave1_box1,
    &mcnlx,
    &mcnly,
    &mcnlz,
    &mcnlvx,
    &mcnlvy,
    &mcnlvz,
    &mcnlsx,
    &mcnlsy,
    &mcnlsz);
  /* define label inside component channel_5_cave1_box1 (without coords transformations) */
  mcJumpTrace_channel_5_cave1_box1:
  SIG_MESSAGE("channel_5_cave1_box1 (Trace)");
  mcDEBUG_COMP("channel_5_cave1_box1")
  mcDEBUG_STATE(
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp)
#define x mcnlx
#define y mcnly
#define z mcnlz
#define vx mcnlvx
#define vy mcnlvy
#define vz mcnlvz
#define t mcnlt
#define sx mcnlsx
#define sy mcnlsy
#define sz mcnlsz
#define p mcnlp

#define mcabsorbComp mcabsorbCompchannel_5_cave1_box1
  STORE_NEUTRON(314,
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp);
  mcScattered=0;
  mcRestore=0;
  mcNCounter[314]++;
  mcPCounter[314] += p;
  mcP2Counter[314] += p*p;
#define mccompcurname  channel_5_cave1_box1
#define mccompcurtype  Union_box
#define mccompcurindex 314
#define loop_index mccchannel_5_cave1_box1_loop_index
#define this_box_volume mccchannel_5_cave1_box1_this_box_volume
#define global_geometry_element mccchannel_5_cave1_box1_global_geometry_element
#define this_box_storage mccchannel_5_cave1_box1_this_box_storage
{   /* Declarations of channel_5_cave1_box1=Union_box() SETTING parameters. */
char* material_string = mccchannel_5_cave1_box1_material_string;
MCNUM priority = mccchannel_5_cave1_box1_priority;
MCNUM xwidth = mccchannel_5_cave1_box1_xwidth;
MCNUM yheight = mccchannel_5_cave1_box1_yheight;
MCNUM zdepth = mccchannel_5_cave1_box1_zdepth;
MCNUM xwidth2 = mccchannel_5_cave1_box1_xwidth2;
MCNUM yheight2 = mccchannel_5_cave1_box1_yheight2;
MCNUM visualize = mccchannel_5_cave1_box1_visualize;
int target_index = mccchannel_5_cave1_box1_target_index;
MCNUM target_x = mccchannel_5_cave1_box1_target_x;
MCNUM target_y = mccchannel_5_cave1_box1_target_y;
MCNUM target_z = mccchannel_5_cave1_box1_target_z;
MCNUM focus_aw = mccchannel_5_cave1_box1_focus_aw;
MCNUM focus_ah = mccchannel_5_cave1_box1_focus_ah;
MCNUM focus_xw = mccchannel_5_cave1_box1_focus_xw;
MCNUM focus_xh = mccchannel_5_cave1_box1_focus_xh;
MCNUM focus_r = mccchannel_5_cave1_box1_focus_r;
MCNUM p_interact = mccchannel_5_cave1_box1_p_interact;
char* mask_string = mccchannel_5_cave1_box1_mask_string;
char* mask_setting = mccchannel_5_cave1_box1_mask_setting;
MCNUM number_of_activations = mccchannel_5_cave1_box1_number_of_activations;
}   /* End of channel_5_cave1_box1=Union_box() SETTING parameter declarations. */
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex
  /* Label for restoring  neutron */
  mcabsorbCompchannel_5_cave1_box1:
  if (RESTORE) /* restore if needed */
  { RESTORE_NEUTRON(314,
      mcnlx,
      mcnly,
      mcnlz,
      mcnlvx,
      mcnlvy,
      mcnlvz,
      mcnlt,
      mcnlsx,
      mcnlsy,
      mcnlsz,
      mcnlp); }
#undef mcabsorbComp
#undef p
#undef sz
#undef sy
#undef sx
#undef t
#undef vz
#undef vy
#undef vx
#undef z
#undef y
#undef x
  mcDEBUG_STATE(
mcnlx,
mcnly,
mcnlz,
mcnlvx,
mcnlvy,
mcnlvz,
mcnlt,
mcnlsx,
mcnlsy,
mcnlsz,
mcnlp)

  /* TRACE Component channel_5_cave1_box2 [315] */
  mccoordschange(mcposrchannel_5_cave1_box2, mcrotrchannel_5_cave1_box2,
    &mcnlx,
    &mcnly,
    &mcnlz,
    &mcnlvx,
    &mcnlvy,
    &mcnlvz,
    &mcnlsx,
    &mcnlsy,
    &mcnlsz);
  /* define label inside component channel_5_cave1_box2 (without coords transformations) */
  mcJumpTrace_channel_5_cave1_box2:
  SIG_MESSAGE("channel_5_cave1_box2 (Trace)");
  mcDEBUG_COMP("channel_5_cave1_box2")
  mcDEBUG_STATE(
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp)
#define x mcnlx
#define y mcnly
#define z mcnlz
#define vx mcnlvx
#define vy mcnlvy
#define vz mcnlvz
#define t mcnlt
#define sx mcnlsx
#define sy mcnlsy
#define sz mcnlsz
#define p mcnlp

#define mcabsorbComp mcabsorbCompchannel_5_cave1_box2
  STORE_NEUTRON(315,
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp);
  mcScattered=0;
  mcRestore=0;
  mcNCounter[315]++;
  mcPCounter[315] += p;
  mcP2Counter[315] += p*p;
#define mccompcurname  channel_5_cave1_box2
#define mccompcurtype  Union_box
#define mccompcurindex 315
#define loop_index mccchannel_5_cave1_box2_loop_index
#define this_box_volume mccchannel_5_cave1_box2_this_box_volume
#define global_geometry_element mccchannel_5_cave1_box2_global_geometry_element
#define this_box_storage mccchannel_5_cave1_box2_this_box_storage
{   /* Declarations of channel_5_cave1_box2=Union_box() SETTING parameters. */
char* material_string = mccchannel_5_cave1_box2_material_string;
MCNUM priority = mccchannel_5_cave1_box2_priority;
MCNUM xwidth = mccchannel_5_cave1_box2_xwidth;
MCNUM yheight = mccchannel_5_cave1_box2_yheight;
MCNUM zdepth = mccchannel_5_cave1_box2_zdepth;
MCNUM xwidth2 = mccchannel_5_cave1_box2_xwidth2;
MCNUM yheight2 = mccchannel_5_cave1_box2_yheight2;
MCNUM visualize = mccchannel_5_cave1_box2_visualize;
int target_index = mccchannel_5_cave1_box2_target_index;
MCNUM target_x = mccchannel_5_cave1_box2_target_x;
MCNUM target_y = mccchannel_5_cave1_box2_target_y;
MCNUM target_z = mccchannel_5_cave1_box2_target_z;
MCNUM focus_aw = mccchannel_5_cave1_box2_focus_aw;
MCNUM focus_ah = mccchannel_5_cave1_box2_focus_ah;
MCNUM focus_xw = mccchannel_5_cave1_box2_focus_xw;
MCNUM focus_xh = mccchannel_5_cave1_box2_focus_xh;
MCNUM focus_r = mccchannel_5_cave1_box2_focus_r;
MCNUM p_interact = mccchannel_5_cave1_box2_p_interact;
char* mask_string = mccchannel_5_cave1_box2_mask_string;
char* mask_setting = mccchannel_5_cave1_box2_mask_setting;
MCNUM number_of_activations = mccchannel_5_cave1_box2_number_of_activations;
}   /* End of channel_5_cave1_box2=Union_box() SETTING parameter declarations. */
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex
  /* Label for restoring  neutron */
  mcabsorbCompchannel_5_cave1_box2:
  if (RESTORE) /* restore if needed */
  { RESTORE_NEUTRON(315,
      mcnlx,
      mcnly,
      mcnlz,
      mcnlvx,
      mcnlvy,
      mcnlvz,
      mcnlt,
      mcnlsx,
      mcnlsy,
      mcnlsz,
      mcnlp); }
#undef mcabsorbComp
#undef p
#undef sz
#undef sy
#undef sx
#undef t
#undef vz
#undef vy
#undef vx
#undef z
#undef y
#undef x
  mcDEBUG_STATE(
mcnlx,
mcnly,
mcnlz,
mcnlvx,
mcnlvy,
mcnlvz,
mcnlt,
mcnlsx,
mcnlsy,
mcnlsz,
mcnlp)

  /* TRACE Component channel_5_cave1_box3 [316] */
  mccoordschange(mcposrchannel_5_cave1_box3, mcrotrchannel_5_cave1_box3,
    &mcnlx,
    &mcnly,
    &mcnlz,
    &mcnlvx,
    &mcnlvy,
    &mcnlvz,
    &mcnlsx,
    &mcnlsy,
    &mcnlsz);
  /* define label inside component channel_5_cave1_box3 (without coords transformations) */
  mcJumpTrace_channel_5_cave1_box3:
  SIG_MESSAGE("channel_5_cave1_box3 (Trace)");
  mcDEBUG_COMP("channel_5_cave1_box3")
  mcDEBUG_STATE(
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp)
#define x mcnlx
#define y mcnly
#define z mcnlz
#define vx mcnlvx
#define vy mcnlvy
#define vz mcnlvz
#define t mcnlt
#define sx mcnlsx
#define sy mcnlsy
#define sz mcnlsz
#define p mcnlp

#define mcabsorbComp mcabsorbCompchannel_5_cave1_box3
  STORE_NEUTRON(316,
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp);
  mcScattered=0;
  mcRestore=0;
  mcNCounter[316]++;
  mcPCounter[316] += p;
  mcP2Counter[316] += p*p;
#define mccompcurname  channel_5_cave1_box3
#define mccompcurtype  Union_box
#define mccompcurindex 316
#define loop_index mccchannel_5_cave1_box3_loop_index
#define this_box_volume mccchannel_5_cave1_box3_this_box_volume
#define global_geometry_element mccchannel_5_cave1_box3_global_geometry_element
#define this_box_storage mccchannel_5_cave1_box3_this_box_storage
{   /* Declarations of channel_5_cave1_box3=Union_box() SETTING parameters. */
char* material_string = mccchannel_5_cave1_box3_material_string;
MCNUM priority = mccchannel_5_cave1_box3_priority;
MCNUM xwidth = mccchannel_5_cave1_box3_xwidth;
MCNUM yheight = mccchannel_5_cave1_box3_yheight;
MCNUM zdepth = mccchannel_5_cave1_box3_zdepth;
MCNUM xwidth2 = mccchannel_5_cave1_box3_xwidth2;
MCNUM yheight2 = mccchannel_5_cave1_box3_yheight2;
MCNUM visualize = mccchannel_5_cave1_box3_visualize;
int target_index = mccchannel_5_cave1_box3_target_index;
MCNUM target_x = mccchannel_5_cave1_box3_target_x;
MCNUM target_y = mccchannel_5_cave1_box3_target_y;
MCNUM target_z = mccchannel_5_cave1_box3_target_z;
MCNUM focus_aw = mccchannel_5_cave1_box3_focus_aw;
MCNUM focus_ah = mccchannel_5_cave1_box3_focus_ah;
MCNUM focus_xw = mccchannel_5_cave1_box3_focus_xw;
MCNUM focus_xh = mccchannel_5_cave1_box3_focus_xh;
MCNUM focus_r = mccchannel_5_cave1_box3_focus_r;
MCNUM p_interact = mccchannel_5_cave1_box3_p_interact;
char* mask_string = mccchannel_5_cave1_box3_mask_string;
char* mask_setting = mccchannel_5_cave1_box3_mask_setting;
MCNUM number_of_activations = mccchannel_5_cave1_box3_number_of_activations;
}   /* End of channel_5_cave1_box3=Union_box() SETTING parameter declarations. */
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex
  /* Label for restoring  neutron */
  mcabsorbCompchannel_5_cave1_box3:
  if (RESTORE) /* restore if needed */
  { RESTORE_NEUTRON(316,
      mcnlx,
      mcnly,
      mcnlz,
      mcnlvx,
      mcnlvy,
      mcnlvz,
      mcnlt,
      mcnlsx,
      mcnlsy,
      mcnlsz,
      mcnlp); }
#undef mcabsorbComp
#undef p
#undef sz
#undef sy
#undef sx
#undef t
#undef vz
#undef vy
#undef vx
#undef z
#undef y
#undef x
  mcDEBUG_STATE(
mcnlx,
mcnly,
mcnlz,
mcnlvx,
mcnlvy,
mcnlvz,
mcnlt,
mcnlsx,
mcnlsy,
mcnlsz,
mcnlp)

  /* TRACE Component channel_5_cave1_cyl1 [317] */
  mccoordschange(mcposrchannel_5_cave1_cyl1, mcrotrchannel_5_cave1_cyl1,
    &mcnlx,
    &mcnly,
    &mcnlz,
    &mcnlvx,
    &mcnlvy,
    &mcnlvz,
    &mcnlsx,
    &mcnlsy,
    &mcnlsz);
  /* define label inside component channel_5_cave1_cyl1 (without coords transformations) */
  mcJumpTrace_channel_5_cave1_cyl1:
  SIG_MESSAGE("channel_5_cave1_cyl1 (Trace)");
  mcDEBUG_COMP("channel_5_cave1_cyl1")
  mcDEBUG_STATE(
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp)
#define x mcnlx
#define y mcnly
#define z mcnlz
#define vx mcnlvx
#define vy mcnlvy
#define vz mcnlvz
#define t mcnlt
#define sx mcnlsx
#define sy mcnlsy
#define sz mcnlsz
#define p mcnlp

#define mcabsorbComp mcabsorbCompchannel_5_cave1_cyl1
  STORE_NEUTRON(317,
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp);
  mcScattered=0;
  mcRestore=0;
  mcNCounter[317]++;
  mcPCounter[317] += p;
  mcP2Counter[317] += p*p;
#define mccompcurname  channel_5_cave1_cyl1
#define mccompcurtype  Union_cylinder
#define mccompcurindex 317
#define loop_index mccchannel_5_cave1_cyl1_loop_index
#define this_cylinder_volume mccchannel_5_cave1_cyl1_this_cylinder_volume
#define global_geometry_element mccchannel_5_cave1_cyl1_global_geometry_element
#define this_cylinder_storage mccchannel_5_cave1_cyl1_this_cylinder_storage
{   /* Declarations of channel_5_cave1_cyl1=Union_cylinder() SETTING parameters. */
char* material_string = mccchannel_5_cave1_cyl1_material_string;
MCNUM priority = mccchannel_5_cave1_cyl1_priority;
MCNUM radius = mccchannel_5_cave1_cyl1_radius;
MCNUM yheight = mccchannel_5_cave1_cyl1_yheight;
MCNUM visualize = mccchannel_5_cave1_cyl1_visualize;
int target_index = mccchannel_5_cave1_cyl1_target_index;
MCNUM target_x = mccchannel_5_cave1_cyl1_target_x;
MCNUM target_y = mccchannel_5_cave1_cyl1_target_y;
MCNUM target_z = mccchannel_5_cave1_cyl1_target_z;
MCNUM focus_aw = mccchannel_5_cave1_cyl1_focus_aw;
MCNUM focus_ah = mccchannel_5_cave1_cyl1_focus_ah;
MCNUM focus_xw = mccchannel_5_cave1_cyl1_focus_xw;
MCNUM focus_xh = mccchannel_5_cave1_cyl1_focus_xh;
MCNUM focus_r = mccchannel_5_cave1_cyl1_focus_r;
MCNUM p_interact = mccchannel_5_cave1_cyl1_p_interact;
char* mask_string = mccchannel_5_cave1_cyl1_mask_string;
char* mask_setting = mccchannel_5_cave1_cyl1_mask_setting;
MCNUM number_of_activations = mccchannel_5_cave1_cyl1_number_of_activations;
#line 345 "Union_cylinder.comp"
{
dummy = 1;
}
#line 387763 "MACS_sample_kidney_box.c"
}   /* End of channel_5_cave1_cyl1=Union_cylinder() SETTING parameter declarations. */
#undef this_cylinder_storage
#undef global_geometry_element
#undef this_cylinder_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex
  /* Label for restoring  neutron */
  mcabsorbCompchannel_5_cave1_cyl1:
  if (RESTORE) /* restore if needed */
  { RESTORE_NEUTRON(317,
      mcnlx,
      mcnly,
      mcnlz,
      mcnlvx,
      mcnlvy,
      mcnlvz,
      mcnlt,
      mcnlsx,
      mcnlsy,
      mcnlsz,
      mcnlp); }
#undef mcabsorbComp
#undef p
#undef sz
#undef sy
#undef sx
#undef t
#undef vz
#undef vy
#undef vx
#undef z
#undef y
#undef x
  mcDEBUG_STATE(
mcnlx,
mcnly,
mcnlz,
mcnlvx,
mcnlvy,
mcnlvz,
mcnlt,
mcnlsx,
mcnlsy,
mcnlsz,
mcnlp)

  /* TRACE Component channel_5_analyzer_1_center [318] */
  mccoordschange(mcposrchannel_5_analyzer_1_center, mcrotrchannel_5_analyzer_1_center,
    &mcnlx,
    &mcnly,
    &mcnlz,
    &mcnlvx,
    &mcnlvy,
    &mcnlvz,
    &mcnlsx,
    &mcnlsy,
    &mcnlsz);
  /* define label inside component channel_5_analyzer_1_center (without coords transformations) */
  mcJumpTrace_channel_5_analyzer_1_center:
  SIG_MESSAGE("channel_5_analyzer_1_center (Trace)");
  mcDEBUG_COMP("channel_5_analyzer_1_center")
  mcDEBUG_STATE(
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp)
#define x mcnlx
#define y mcnly
#define z mcnlz
#define vx mcnlvx
#define vy mcnlvy
#define vz mcnlvz
#define t mcnlt
#define sx mcnlsx
#define sy mcnlsy
#define sz mcnlsz
#define p mcnlp

#define mcabsorbComp mcabsorbCompchannel_5_analyzer_1_center
  STORE_NEUTRON(318,
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp);
  mcScattered=0;
  mcRestore=0;
  mcNCounter[318]++;
  mcPCounter[318] += p;
  mcP2Counter[318] += p*p;
#define mccompcurname  channel_5_analyzer_1_center
#define mccompcurtype  Arm
#define mccompcurindex 318
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex
  /* Label for restoring  neutron */
  mcabsorbCompchannel_5_analyzer_1_center:
  if (RESTORE) /* restore if needed */
  { RESTORE_NEUTRON(318,
      mcnlx,
      mcnly,
      mcnlz,
      mcnlvx,
      mcnlvy,
      mcnlvz,
      mcnlt,
      mcnlsx,
      mcnlsy,
      mcnlsz,
      mcnlp); }
#undef mcabsorbComp
#undef p
#undef sz
#undef sy
#undef sx
#undef t
#undef vz
#undef vy
#undef vx
#undef z
#undef y
#undef x
  mcDEBUG_STATE(
mcnlx,
mcnly,
mcnlz,
mcnlvx,
mcnlvy,
mcnlvz,
mcnlt,
mcnlsx,
mcnlsy,
mcnlsz,
mcnlp)

  /* TRACE Component channel_5_analyzer_1_rotated [319] */
  mccoordschange(mcposrchannel_5_analyzer_1_rotated, mcrotrchannel_5_analyzer_1_rotated,
    &mcnlx,
    &mcnly,
    &mcnlz,
    &mcnlvx,
    &mcnlvy,
    &mcnlvz,
    &mcnlsx,
    &mcnlsy,
    &mcnlsz);
  /* define label inside component channel_5_analyzer_1_rotated (without coords transformations) */
  mcJumpTrace_channel_5_analyzer_1_rotated:
  SIG_MESSAGE("channel_5_analyzer_1_rotated (Trace)");
  mcDEBUG_COMP("channel_5_analyzer_1_rotated")
  mcDEBUG_STATE(
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp)
#define x mcnlx
#define y mcnly
#define z mcnlz
#define vx mcnlvx
#define vy mcnlvy
#define vz mcnlvz
#define t mcnlt
#define sx mcnlsx
#define sy mcnlsy
#define sz mcnlsz
#define p mcnlp

#define mcabsorbComp mcabsorbCompchannel_5_analyzer_1_rotated
  STORE_NEUTRON(319,
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp);
  mcScattered=0;
  mcRestore=0;
  mcNCounter[319]++;
  mcPCounter[319] += p;
  mcP2Counter[319] += p*p;
#define mccompcurname  channel_5_analyzer_1_rotated
#define mccompcurtype  Arm
#define mccompcurindex 319
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex
  /* Label for restoring  neutron */
  mcabsorbCompchannel_5_analyzer_1_rotated:
  if (RESTORE) /* restore if needed */
  { RESTORE_NEUTRON(319,
      mcnlx,
      mcnly,
      mcnlz,
      mcnlvx,
      mcnlvy,
      mcnlvz,
      mcnlt,
      mcnlsx,
      mcnlsy,
      mcnlsz,
      mcnlp); }
#undef mcabsorbComp
#undef p
#undef sz
#undef sy
#undef sx
#undef t
#undef vz
#undef vy
#undef vx
#undef z
#undef y
#undef x
  mcDEBUG_STATE(
mcnlx,
mcnly,
mcnlz,
mcnlvx,
mcnlvy,
mcnlvz,
mcnlt,
mcnlsx,
mcnlsy,
mcnlsz,
mcnlp)

  /* TRACE Component channel_5_analyzer_1_array_crystal_array_0 [320] */
  mccoordschange(mcposrchannel_5_analyzer_1_array_crystal_array_0, mcrotrchannel_5_analyzer_1_array_crystal_array_0,
    &mcnlx,
    &mcnly,
    &mcnlz,
    &mcnlvx,
    &mcnlvy,
    &mcnlvz,
    &mcnlsx,
    &mcnlsy,
    &mcnlsz);
  /* define label inside component channel_5_analyzer_1_array_crystal_array_0 (without coords transformations) */
  mcJumpTrace_channel_5_analyzer_1_array_crystal_array_0:
  SIG_MESSAGE("channel_5_analyzer_1_array_crystal_array_0 (Trace)");
  mcDEBUG_COMP("channel_5_analyzer_1_array_crystal_array_0")
  mcDEBUG_STATE(
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp)
#define x mcnlx
#define y mcnly
#define z mcnlz
#define vx mcnlvx
#define vy mcnlvy
#define vz mcnlvz
#define t mcnlt
#define sx mcnlsx
#define sy mcnlsy
#define sz mcnlsz
#define p mcnlp

#define mcabsorbComp mcabsorbCompchannel_5_analyzer_1_array_crystal_array_0
  STORE_NEUTRON(320,
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp);
  mcScattered=0;
  mcRestore=0;
  mcNCounter[320]++;
  mcPCounter[320] += p;
  mcP2Counter[320] += p*p;
#define mccompcurname  channel_5_analyzer_1_array_crystal_array_0
#define mccompcurtype  Union_box
#define mccompcurindex 320
#define loop_index mccchannel_5_analyzer_1_array_crystal_array_0_loop_index
#define this_box_volume mccchannel_5_analyzer_1_array_crystal_array_0_this_box_volume
#define global_geometry_element mccchannel_5_analyzer_1_array_crystal_array_0_global_geometry_element
#define this_box_storage mccchannel_5_analyzer_1_array_crystal_array_0_this_box_storage
{   /* Declarations of channel_5_analyzer_1_array_crystal_array_0=Union_box() SETTING parameters. */
char* material_string = mccchannel_5_analyzer_1_array_crystal_array_0_material_string;
MCNUM priority = mccchannel_5_analyzer_1_array_crystal_array_0_priority;
MCNUM xwidth = mccchannel_5_analyzer_1_array_crystal_array_0_xwidth;
MCNUM yheight = mccchannel_5_analyzer_1_array_crystal_array_0_yheight;
MCNUM zdepth = mccchannel_5_analyzer_1_array_crystal_array_0_zdepth;
MCNUM xwidth2 = mccchannel_5_analyzer_1_array_crystal_array_0_xwidth2;
MCNUM yheight2 = mccchannel_5_analyzer_1_array_crystal_array_0_yheight2;
MCNUM visualize = mccchannel_5_analyzer_1_array_crystal_array_0_visualize;
int target_index = mccchannel_5_analyzer_1_array_crystal_array_0_target_index;
MCNUM target_x = mccchannel_5_analyzer_1_array_crystal_array_0_target_x;
MCNUM target_y = mccchannel_5_analyzer_1_array_crystal_array_0_target_y;
MCNUM target_z = mccchannel_5_analyzer_1_array_crystal_array_0_target_z;
MCNUM focus_aw = mccchannel_5_analyzer_1_array_crystal_array_0_focus_aw;
MCNUM focus_ah = mccchannel_5_analyzer_1_array_crystal_array_0_focus_ah;
MCNUM focus_xw = mccchannel_5_analyzer_1_array_crystal_array_0_focus_xw;
MCNUM focus_xh = mccchannel_5_analyzer_1_array_crystal_array_0_focus_xh;
MCNUM focus_r = mccchannel_5_analyzer_1_array_crystal_array_0_focus_r;
MCNUM p_interact = mccchannel_5_analyzer_1_array_crystal_array_0_p_interact;
char* mask_string = mccchannel_5_analyzer_1_array_crystal_array_0_mask_string;
char* mask_setting = mccchannel_5_analyzer_1_array_crystal_array_0_mask_setting;
MCNUM number_of_activations = mccchannel_5_analyzer_1_array_crystal_array_0_number_of_activations;
}   /* End of channel_5_analyzer_1_array_crystal_array_0=Union_box() SETTING parameter declarations. */
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex
  /* Label for restoring  neutron */
  mcabsorbCompchannel_5_analyzer_1_array_crystal_array_0:
  if (RESTORE) /* restore if needed */
  { RESTORE_NEUTRON(320,
      mcnlx,
      mcnly,
      mcnlz,
      mcnlvx,
      mcnlvy,
      mcnlvz,
      mcnlt,
      mcnlsx,
      mcnlsy,
      mcnlsz,
      mcnlp); }
#undef mcabsorbComp
#undef p
#undef sz
#undef sy
#undef sx
#undef t
#undef vz
#undef vy
#undef vx
#undef z
#undef y
#undef x
  mcDEBUG_STATE(
mcnlx,
mcnly,
mcnlz,
mcnlvx,
mcnlvy,
mcnlvz,
mcnlt,
mcnlsx,
mcnlsy,
mcnlsz,
mcnlp)

  /* TRACE Component channel_5_analyzer_1_array_crystal_array_1 [321] */
  mccoordschange(mcposrchannel_5_analyzer_1_array_crystal_array_1, mcrotrchannel_5_analyzer_1_array_crystal_array_1,
    &mcnlx,
    &mcnly,
    &mcnlz,
    &mcnlvx,
    &mcnlvy,
    &mcnlvz,
    &mcnlsx,
    &mcnlsy,
    &mcnlsz);
  /* define label inside component channel_5_analyzer_1_array_crystal_array_1 (without coords transformations) */
  mcJumpTrace_channel_5_analyzer_1_array_crystal_array_1:
  SIG_MESSAGE("channel_5_analyzer_1_array_crystal_array_1 (Trace)");
  mcDEBUG_COMP("channel_5_analyzer_1_array_crystal_array_1")
  mcDEBUG_STATE(
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp)
#define x mcnlx
#define y mcnly
#define z mcnlz
#define vx mcnlvx
#define vy mcnlvy
#define vz mcnlvz
#define t mcnlt
#define sx mcnlsx
#define sy mcnlsy
#define sz mcnlsz
#define p mcnlp

#define mcabsorbComp mcabsorbCompchannel_5_analyzer_1_array_crystal_array_1
  STORE_NEUTRON(321,
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp);
  mcScattered=0;
  mcRestore=0;
  mcNCounter[321]++;
  mcPCounter[321] += p;
  mcP2Counter[321] += p*p;
#define mccompcurname  channel_5_analyzer_1_array_crystal_array_1
#define mccompcurtype  Union_box
#define mccompcurindex 321
#define loop_index mccchannel_5_analyzer_1_array_crystal_array_1_loop_index
#define this_box_volume mccchannel_5_analyzer_1_array_crystal_array_1_this_box_volume
#define global_geometry_element mccchannel_5_analyzer_1_array_crystal_array_1_global_geometry_element
#define this_box_storage mccchannel_5_analyzer_1_array_crystal_array_1_this_box_storage
{   /* Declarations of channel_5_analyzer_1_array_crystal_array_1=Union_box() SETTING parameters. */
char* material_string = mccchannel_5_analyzer_1_array_crystal_array_1_material_string;
MCNUM priority = mccchannel_5_analyzer_1_array_crystal_array_1_priority;
MCNUM xwidth = mccchannel_5_analyzer_1_array_crystal_array_1_xwidth;
MCNUM yheight = mccchannel_5_analyzer_1_array_crystal_array_1_yheight;
MCNUM zdepth = mccchannel_5_analyzer_1_array_crystal_array_1_zdepth;
MCNUM xwidth2 = mccchannel_5_analyzer_1_array_crystal_array_1_xwidth2;
MCNUM yheight2 = mccchannel_5_analyzer_1_array_crystal_array_1_yheight2;
MCNUM visualize = mccchannel_5_analyzer_1_array_crystal_array_1_visualize;
int target_index = mccchannel_5_analyzer_1_array_crystal_array_1_target_index;
MCNUM target_x = mccchannel_5_analyzer_1_array_crystal_array_1_target_x;
MCNUM target_y = mccchannel_5_analyzer_1_array_crystal_array_1_target_y;
MCNUM target_z = mccchannel_5_analyzer_1_array_crystal_array_1_target_z;
MCNUM focus_aw = mccchannel_5_analyzer_1_array_crystal_array_1_focus_aw;
MCNUM focus_ah = mccchannel_5_analyzer_1_array_crystal_array_1_focus_ah;
MCNUM focus_xw = mccchannel_5_analyzer_1_array_crystal_array_1_focus_xw;
MCNUM focus_xh = mccchannel_5_analyzer_1_array_crystal_array_1_focus_xh;
MCNUM focus_r = mccchannel_5_analyzer_1_array_crystal_array_1_focus_r;
MCNUM p_interact = mccchannel_5_analyzer_1_array_crystal_array_1_p_interact;
char* mask_string = mccchannel_5_analyzer_1_array_crystal_array_1_mask_string;
char* mask_setting = mccchannel_5_analyzer_1_array_crystal_array_1_mask_setting;
MCNUM number_of_activations = mccchannel_5_analyzer_1_array_crystal_array_1_number_of_activations;
}   /* End of channel_5_analyzer_1_array_crystal_array_1=Union_box() SETTING parameter declarations. */
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex
  /* Label for restoring  neutron */
  mcabsorbCompchannel_5_analyzer_1_array_crystal_array_1:
  if (RESTORE) /* restore if needed */
  { RESTORE_NEUTRON(321,
      mcnlx,
      mcnly,
      mcnlz,
      mcnlvx,
      mcnlvy,
      mcnlvz,
      mcnlt,
      mcnlsx,
      mcnlsy,
      mcnlsz,
      mcnlp); }
#undef mcabsorbComp
#undef p
#undef sz
#undef sy
#undef sx
#undef t
#undef vz
#undef vy
#undef vx
#undef z
#undef y
#undef x
  mcDEBUG_STATE(
mcnlx,
mcnly,
mcnlz,
mcnlvx,
mcnlvy,
mcnlvz,
mcnlt,
mcnlsx,
mcnlsy,
mcnlsz,
mcnlp)

  /* TRACE Component channel_5_analyzer_1_array_crystal_array_2 [322] */
  mccoordschange(mcposrchannel_5_analyzer_1_array_crystal_array_2, mcrotrchannel_5_analyzer_1_array_crystal_array_2,
    &mcnlx,
    &mcnly,
    &mcnlz,
    &mcnlvx,
    &mcnlvy,
    &mcnlvz,
    &mcnlsx,
    &mcnlsy,
    &mcnlsz);
  /* define label inside component channel_5_analyzer_1_array_crystal_array_2 (without coords transformations) */
  mcJumpTrace_channel_5_analyzer_1_array_crystal_array_2:
  SIG_MESSAGE("channel_5_analyzer_1_array_crystal_array_2 (Trace)");
  mcDEBUG_COMP("channel_5_analyzer_1_array_crystal_array_2")
  mcDEBUG_STATE(
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp)
#define x mcnlx
#define y mcnly
#define z mcnlz
#define vx mcnlvx
#define vy mcnlvy
#define vz mcnlvz
#define t mcnlt
#define sx mcnlsx
#define sy mcnlsy
#define sz mcnlsz
#define p mcnlp

#define mcabsorbComp mcabsorbCompchannel_5_analyzer_1_array_crystal_array_2
  STORE_NEUTRON(322,
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp);
  mcScattered=0;
  mcRestore=0;
  mcNCounter[322]++;
  mcPCounter[322] += p;
  mcP2Counter[322] += p*p;
#define mccompcurname  channel_5_analyzer_1_array_crystal_array_2
#define mccompcurtype  Union_box
#define mccompcurindex 322
#define loop_index mccchannel_5_analyzer_1_array_crystal_array_2_loop_index
#define this_box_volume mccchannel_5_analyzer_1_array_crystal_array_2_this_box_volume
#define global_geometry_element mccchannel_5_analyzer_1_array_crystal_array_2_global_geometry_element
#define this_box_storage mccchannel_5_analyzer_1_array_crystal_array_2_this_box_storage
{   /* Declarations of channel_5_analyzer_1_array_crystal_array_2=Union_box() SETTING parameters. */
char* material_string = mccchannel_5_analyzer_1_array_crystal_array_2_material_string;
MCNUM priority = mccchannel_5_analyzer_1_array_crystal_array_2_priority;
MCNUM xwidth = mccchannel_5_analyzer_1_array_crystal_array_2_xwidth;
MCNUM yheight = mccchannel_5_analyzer_1_array_crystal_array_2_yheight;
MCNUM zdepth = mccchannel_5_analyzer_1_array_crystal_array_2_zdepth;
MCNUM xwidth2 = mccchannel_5_analyzer_1_array_crystal_array_2_xwidth2;
MCNUM yheight2 = mccchannel_5_analyzer_1_array_crystal_array_2_yheight2;
MCNUM visualize = mccchannel_5_analyzer_1_array_crystal_array_2_visualize;
int target_index = mccchannel_5_analyzer_1_array_crystal_array_2_target_index;
MCNUM target_x = mccchannel_5_analyzer_1_array_crystal_array_2_target_x;
MCNUM target_y = mccchannel_5_analyzer_1_array_crystal_array_2_target_y;
MCNUM target_z = mccchannel_5_analyzer_1_array_crystal_array_2_target_z;
MCNUM focus_aw = mccchannel_5_analyzer_1_array_crystal_array_2_focus_aw;
MCNUM focus_ah = mccchannel_5_analyzer_1_array_crystal_array_2_focus_ah;
MCNUM focus_xw = mccchannel_5_analyzer_1_array_crystal_array_2_focus_xw;
MCNUM focus_xh = mccchannel_5_analyzer_1_array_crystal_array_2_focus_xh;
MCNUM focus_r = mccchannel_5_analyzer_1_array_crystal_array_2_focus_r;
MCNUM p_interact = mccchannel_5_analyzer_1_array_crystal_array_2_p_interact;
char* mask_string = mccchannel_5_analyzer_1_array_crystal_array_2_mask_string;
char* mask_setting = mccchannel_5_analyzer_1_array_crystal_array_2_mask_setting;
MCNUM number_of_activations = mccchannel_5_analyzer_1_array_crystal_array_2_number_of_activations;
}   /* End of channel_5_analyzer_1_array_crystal_array_2=Union_box() SETTING parameter declarations. */
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex
  /* Label for restoring  neutron */
  mcabsorbCompchannel_5_analyzer_1_array_crystal_array_2:
  if (RESTORE) /* restore if needed */
  { RESTORE_NEUTRON(322,
      mcnlx,
      mcnly,
      mcnlz,
      mcnlvx,
      mcnlvy,
      mcnlvz,
      mcnlt,
      mcnlsx,
      mcnlsy,
      mcnlsz,
      mcnlp); }
#undef mcabsorbComp
#undef p
#undef sz
#undef sy
#undef sx
#undef t
#undef vz
#undef vy
#undef vx
#undef z
#undef y
#undef x
  mcDEBUG_STATE(
mcnlx,
mcnly,
mcnlz,
mcnlvx,
mcnlvy,
mcnlvz,
mcnlt,
mcnlsx,
mcnlsy,
mcnlsz,
mcnlp)

  /* TRACE Component channel_5_analyzer_1_array_crystal_array_3 [323] */
  mccoordschange(mcposrchannel_5_analyzer_1_array_crystal_array_3, mcrotrchannel_5_analyzer_1_array_crystal_array_3,
    &mcnlx,
    &mcnly,
    &mcnlz,
    &mcnlvx,
    &mcnlvy,
    &mcnlvz,
    &mcnlsx,
    &mcnlsy,
    &mcnlsz);
  /* define label inside component channel_5_analyzer_1_array_crystal_array_3 (without coords transformations) */
  mcJumpTrace_channel_5_analyzer_1_array_crystal_array_3:
  SIG_MESSAGE("channel_5_analyzer_1_array_crystal_array_3 (Trace)");
  mcDEBUG_COMP("channel_5_analyzer_1_array_crystal_array_3")
  mcDEBUG_STATE(
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp)
#define x mcnlx
#define y mcnly
#define z mcnlz
#define vx mcnlvx
#define vy mcnlvy
#define vz mcnlvz
#define t mcnlt
#define sx mcnlsx
#define sy mcnlsy
#define sz mcnlsz
#define p mcnlp

#define mcabsorbComp mcabsorbCompchannel_5_analyzer_1_array_crystal_array_3
  STORE_NEUTRON(323,
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp);
  mcScattered=0;
  mcRestore=0;
  mcNCounter[323]++;
  mcPCounter[323] += p;
  mcP2Counter[323] += p*p;
#define mccompcurname  channel_5_analyzer_1_array_crystal_array_3
#define mccompcurtype  Union_box
#define mccompcurindex 323
#define loop_index mccchannel_5_analyzer_1_array_crystal_array_3_loop_index
#define this_box_volume mccchannel_5_analyzer_1_array_crystal_array_3_this_box_volume
#define global_geometry_element mccchannel_5_analyzer_1_array_crystal_array_3_global_geometry_element
#define this_box_storage mccchannel_5_analyzer_1_array_crystal_array_3_this_box_storage
{   /* Declarations of channel_5_analyzer_1_array_crystal_array_3=Union_box() SETTING parameters. */
char* material_string = mccchannel_5_analyzer_1_array_crystal_array_3_material_string;
MCNUM priority = mccchannel_5_analyzer_1_array_crystal_array_3_priority;
MCNUM xwidth = mccchannel_5_analyzer_1_array_crystal_array_3_xwidth;
MCNUM yheight = mccchannel_5_analyzer_1_array_crystal_array_3_yheight;
MCNUM zdepth = mccchannel_5_analyzer_1_array_crystal_array_3_zdepth;
MCNUM xwidth2 = mccchannel_5_analyzer_1_array_crystal_array_3_xwidth2;
MCNUM yheight2 = mccchannel_5_analyzer_1_array_crystal_array_3_yheight2;
MCNUM visualize = mccchannel_5_analyzer_1_array_crystal_array_3_visualize;
int target_index = mccchannel_5_analyzer_1_array_crystal_array_3_target_index;
MCNUM target_x = mccchannel_5_analyzer_1_array_crystal_array_3_target_x;
MCNUM target_y = mccchannel_5_analyzer_1_array_crystal_array_3_target_y;
MCNUM target_z = mccchannel_5_analyzer_1_array_crystal_array_3_target_z;
MCNUM focus_aw = mccchannel_5_analyzer_1_array_crystal_array_3_focus_aw;
MCNUM focus_ah = mccchannel_5_analyzer_1_array_crystal_array_3_focus_ah;
MCNUM focus_xw = mccchannel_5_analyzer_1_array_crystal_array_3_focus_xw;
MCNUM focus_xh = mccchannel_5_analyzer_1_array_crystal_array_3_focus_xh;
MCNUM focus_r = mccchannel_5_analyzer_1_array_crystal_array_3_focus_r;
MCNUM p_interact = mccchannel_5_analyzer_1_array_crystal_array_3_p_interact;
char* mask_string = mccchannel_5_analyzer_1_array_crystal_array_3_mask_string;
char* mask_setting = mccchannel_5_analyzer_1_array_crystal_array_3_mask_setting;
MCNUM number_of_activations = mccchannel_5_analyzer_1_array_crystal_array_3_number_of_activations;
}   /* End of channel_5_analyzer_1_array_crystal_array_3=Union_box() SETTING parameter declarations. */
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex
  /* Label for restoring  neutron */
  mcabsorbCompchannel_5_analyzer_1_array_crystal_array_3:
  if (RESTORE) /* restore if needed */
  { RESTORE_NEUTRON(323,
      mcnlx,
      mcnly,
      mcnlz,
      mcnlvx,
      mcnlvy,
      mcnlvz,
      mcnlt,
      mcnlsx,
      mcnlsy,
      mcnlsz,
      mcnlp); }
#undef mcabsorbComp
#undef p
#undef sz
#undef sy
#undef sx
#undef t
#undef vz
#undef vy
#undef vx
#undef z
#undef y
#undef x
  mcDEBUG_STATE(
mcnlx,
mcnly,
mcnlz,
mcnlvx,
mcnlvy,
mcnlvz,
mcnlt,
mcnlsx,
mcnlsy,
mcnlsz,
mcnlp)

  /* TRACE Component channel_5_analyzer_1_array_crystal_array_4 [324] */
  mccoordschange(mcposrchannel_5_analyzer_1_array_crystal_array_4, mcrotrchannel_5_analyzer_1_array_crystal_array_4,
    &mcnlx,
    &mcnly,
    &mcnlz,
    &mcnlvx,
    &mcnlvy,
    &mcnlvz,
    &mcnlsx,
    &mcnlsy,
    &mcnlsz);
  /* define label inside component channel_5_analyzer_1_array_crystal_array_4 (without coords transformations) */
  mcJumpTrace_channel_5_analyzer_1_array_crystal_array_4:
  SIG_MESSAGE("channel_5_analyzer_1_array_crystal_array_4 (Trace)");
  mcDEBUG_COMP("channel_5_analyzer_1_array_crystal_array_4")
  mcDEBUG_STATE(
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp)
#define x mcnlx
#define y mcnly
#define z mcnlz
#define vx mcnlvx
#define vy mcnlvy
#define vz mcnlvz
#define t mcnlt
#define sx mcnlsx
#define sy mcnlsy
#define sz mcnlsz
#define p mcnlp

#define mcabsorbComp mcabsorbCompchannel_5_analyzer_1_array_crystal_array_4
  STORE_NEUTRON(324,
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp);
  mcScattered=0;
  mcRestore=0;
  mcNCounter[324]++;
  mcPCounter[324] += p;
  mcP2Counter[324] += p*p;
#define mccompcurname  channel_5_analyzer_1_array_crystal_array_4
#define mccompcurtype  Union_box
#define mccompcurindex 324
#define loop_index mccchannel_5_analyzer_1_array_crystal_array_4_loop_index
#define this_box_volume mccchannel_5_analyzer_1_array_crystal_array_4_this_box_volume
#define global_geometry_element mccchannel_5_analyzer_1_array_crystal_array_4_global_geometry_element
#define this_box_storage mccchannel_5_analyzer_1_array_crystal_array_4_this_box_storage
{   /* Declarations of channel_5_analyzer_1_array_crystal_array_4=Union_box() SETTING parameters. */
char* material_string = mccchannel_5_analyzer_1_array_crystal_array_4_material_string;
MCNUM priority = mccchannel_5_analyzer_1_array_crystal_array_4_priority;
MCNUM xwidth = mccchannel_5_analyzer_1_array_crystal_array_4_xwidth;
MCNUM yheight = mccchannel_5_analyzer_1_array_crystal_array_4_yheight;
MCNUM zdepth = mccchannel_5_analyzer_1_array_crystal_array_4_zdepth;
MCNUM xwidth2 = mccchannel_5_analyzer_1_array_crystal_array_4_xwidth2;
MCNUM yheight2 = mccchannel_5_analyzer_1_array_crystal_array_4_yheight2;
MCNUM visualize = mccchannel_5_analyzer_1_array_crystal_array_4_visualize;
int target_index = mccchannel_5_analyzer_1_array_crystal_array_4_target_index;
MCNUM target_x = mccchannel_5_analyzer_1_array_crystal_array_4_target_x;
MCNUM target_y = mccchannel_5_analyzer_1_array_crystal_array_4_target_y;
MCNUM target_z = mccchannel_5_analyzer_1_array_crystal_array_4_target_z;
MCNUM focus_aw = mccchannel_5_analyzer_1_array_crystal_array_4_focus_aw;
MCNUM focus_ah = mccchannel_5_analyzer_1_array_crystal_array_4_focus_ah;
MCNUM focus_xw = mccchannel_5_analyzer_1_array_crystal_array_4_focus_xw;
MCNUM focus_xh = mccchannel_5_analyzer_1_array_crystal_array_4_focus_xh;
MCNUM focus_r = mccchannel_5_analyzer_1_array_crystal_array_4_focus_r;
MCNUM p_interact = mccchannel_5_analyzer_1_array_crystal_array_4_p_interact;
char* mask_string = mccchannel_5_analyzer_1_array_crystal_array_4_mask_string;
char* mask_setting = mccchannel_5_analyzer_1_array_crystal_array_4_mask_setting;
MCNUM number_of_activations = mccchannel_5_analyzer_1_array_crystal_array_4_number_of_activations;
}   /* End of channel_5_analyzer_1_array_crystal_array_4=Union_box() SETTING parameter declarations. */
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex
  /* Label for restoring  neutron */
  mcabsorbCompchannel_5_analyzer_1_array_crystal_array_4:
  if (RESTORE) /* restore if needed */
  { RESTORE_NEUTRON(324,
      mcnlx,
      mcnly,
      mcnlz,
      mcnlvx,
      mcnlvy,
      mcnlvz,
      mcnlt,
      mcnlsx,
      mcnlsy,
      mcnlsz,
      mcnlp); }
#undef mcabsorbComp
#undef p
#undef sz
#undef sy
#undef sx
#undef t
#undef vz
#undef vy
#undef vx
#undef z
#undef y
#undef x
  mcDEBUG_STATE(
mcnlx,
mcnly,
mcnlz,
mcnlvx,
mcnlvy,
mcnlvz,
mcnlt,
mcnlsx,
mcnlsy,
mcnlsz,
mcnlp)

  /* TRACE Component channel_5_analyzer_1_array_crystal_array_5 [325] */
  mccoordschange(mcposrchannel_5_analyzer_1_array_crystal_array_5, mcrotrchannel_5_analyzer_1_array_crystal_array_5,
    &mcnlx,
    &mcnly,
    &mcnlz,
    &mcnlvx,
    &mcnlvy,
    &mcnlvz,
    &mcnlsx,
    &mcnlsy,
    &mcnlsz);
  /* define label inside component channel_5_analyzer_1_array_crystal_array_5 (without coords transformations) */
  mcJumpTrace_channel_5_analyzer_1_array_crystal_array_5:
  SIG_MESSAGE("channel_5_analyzer_1_array_crystal_array_5 (Trace)");
  mcDEBUG_COMP("channel_5_analyzer_1_array_crystal_array_5")
  mcDEBUG_STATE(
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp)
#define x mcnlx
#define y mcnly
#define z mcnlz
#define vx mcnlvx
#define vy mcnlvy
#define vz mcnlvz
#define t mcnlt
#define sx mcnlsx
#define sy mcnlsy
#define sz mcnlsz
#define p mcnlp

#define mcabsorbComp mcabsorbCompchannel_5_analyzer_1_array_crystal_array_5
  STORE_NEUTRON(325,
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp);
  mcScattered=0;
  mcRestore=0;
  mcNCounter[325]++;
  mcPCounter[325] += p;
  mcP2Counter[325] += p*p;
#define mccompcurname  channel_5_analyzer_1_array_crystal_array_5
#define mccompcurtype  Union_box
#define mccompcurindex 325
#define loop_index mccchannel_5_analyzer_1_array_crystal_array_5_loop_index
#define this_box_volume mccchannel_5_analyzer_1_array_crystal_array_5_this_box_volume
#define global_geometry_element mccchannel_5_analyzer_1_array_crystal_array_5_global_geometry_element
#define this_box_storage mccchannel_5_analyzer_1_array_crystal_array_5_this_box_storage
{   /* Declarations of channel_5_analyzer_1_array_crystal_array_5=Union_box() SETTING parameters. */
char* material_string = mccchannel_5_analyzer_1_array_crystal_array_5_material_string;
MCNUM priority = mccchannel_5_analyzer_1_array_crystal_array_5_priority;
MCNUM xwidth = mccchannel_5_analyzer_1_array_crystal_array_5_xwidth;
MCNUM yheight = mccchannel_5_analyzer_1_array_crystal_array_5_yheight;
MCNUM zdepth = mccchannel_5_analyzer_1_array_crystal_array_5_zdepth;
MCNUM xwidth2 = mccchannel_5_analyzer_1_array_crystal_array_5_xwidth2;
MCNUM yheight2 = mccchannel_5_analyzer_1_array_crystal_array_5_yheight2;
MCNUM visualize = mccchannel_5_analyzer_1_array_crystal_array_5_visualize;
int target_index = mccchannel_5_analyzer_1_array_crystal_array_5_target_index;
MCNUM target_x = mccchannel_5_analyzer_1_array_crystal_array_5_target_x;
MCNUM target_y = mccchannel_5_analyzer_1_array_crystal_array_5_target_y;
MCNUM target_z = mccchannel_5_analyzer_1_array_crystal_array_5_target_z;
MCNUM focus_aw = mccchannel_5_analyzer_1_array_crystal_array_5_focus_aw;
MCNUM focus_ah = mccchannel_5_analyzer_1_array_crystal_array_5_focus_ah;
MCNUM focus_xw = mccchannel_5_analyzer_1_array_crystal_array_5_focus_xw;
MCNUM focus_xh = mccchannel_5_analyzer_1_array_crystal_array_5_focus_xh;
MCNUM focus_r = mccchannel_5_analyzer_1_array_crystal_array_5_focus_r;
MCNUM p_interact = mccchannel_5_analyzer_1_array_crystal_array_5_p_interact;
char* mask_string = mccchannel_5_analyzer_1_array_crystal_array_5_mask_string;
char* mask_setting = mccchannel_5_analyzer_1_array_crystal_array_5_mask_setting;
MCNUM number_of_activations = mccchannel_5_analyzer_1_array_crystal_array_5_number_of_activations;
}   /* End of channel_5_analyzer_1_array_crystal_array_5=Union_box() SETTING parameter declarations. */
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex
  /* Label for restoring  neutron */
  mcabsorbCompchannel_5_analyzer_1_array_crystal_array_5:
  if (RESTORE) /* restore if needed */
  { RESTORE_NEUTRON(325,
      mcnlx,
      mcnly,
      mcnlz,
      mcnlvx,
      mcnlvy,
      mcnlvz,
      mcnlt,
      mcnlsx,
      mcnlsy,
      mcnlsz,
      mcnlp); }
#undef mcabsorbComp
#undef p
#undef sz
#undef sy
#undef sx
#undef t
#undef vz
#undef vy
#undef vx
#undef z
#undef y
#undef x
  mcDEBUG_STATE(
mcnlx,
mcnly,
mcnlz,
mcnlvx,
mcnlvy,
mcnlvz,
mcnlt,
mcnlsx,
mcnlsy,
mcnlsz,
mcnlp)

  /* TRACE Component channel_5_analyzer_1_array_crystal_array_6 [326] */
  mccoordschange(mcposrchannel_5_analyzer_1_array_crystal_array_6, mcrotrchannel_5_analyzer_1_array_crystal_array_6,
    &mcnlx,
    &mcnly,
    &mcnlz,
    &mcnlvx,
    &mcnlvy,
    &mcnlvz,
    &mcnlsx,
    &mcnlsy,
    &mcnlsz);
  /* define label inside component channel_5_analyzer_1_array_crystal_array_6 (without coords transformations) */
  mcJumpTrace_channel_5_analyzer_1_array_crystal_array_6:
  SIG_MESSAGE("channel_5_analyzer_1_array_crystal_array_6 (Trace)");
  mcDEBUG_COMP("channel_5_analyzer_1_array_crystal_array_6")
  mcDEBUG_STATE(
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp)
#define x mcnlx
#define y mcnly
#define z mcnlz
#define vx mcnlvx
#define vy mcnlvy
#define vz mcnlvz
#define t mcnlt
#define sx mcnlsx
#define sy mcnlsy
#define sz mcnlsz
#define p mcnlp

#define mcabsorbComp mcabsorbCompchannel_5_analyzer_1_array_crystal_array_6
  STORE_NEUTRON(326,
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp);
  mcScattered=0;
  mcRestore=0;
  mcNCounter[326]++;
  mcPCounter[326] += p;
  mcP2Counter[326] += p*p;
#define mccompcurname  channel_5_analyzer_1_array_crystal_array_6
#define mccompcurtype  Union_box
#define mccompcurindex 326
#define loop_index mccchannel_5_analyzer_1_array_crystal_array_6_loop_index
#define this_box_volume mccchannel_5_analyzer_1_array_crystal_array_6_this_box_volume
#define global_geometry_element mccchannel_5_analyzer_1_array_crystal_array_6_global_geometry_element
#define this_box_storage mccchannel_5_analyzer_1_array_crystal_array_6_this_box_storage
{   /* Declarations of channel_5_analyzer_1_array_crystal_array_6=Union_box() SETTING parameters. */
char* material_string = mccchannel_5_analyzer_1_array_crystal_array_6_material_string;
MCNUM priority = mccchannel_5_analyzer_1_array_crystal_array_6_priority;
MCNUM xwidth = mccchannel_5_analyzer_1_array_crystal_array_6_xwidth;
MCNUM yheight = mccchannel_5_analyzer_1_array_crystal_array_6_yheight;
MCNUM zdepth = mccchannel_5_analyzer_1_array_crystal_array_6_zdepth;
MCNUM xwidth2 = mccchannel_5_analyzer_1_array_crystal_array_6_xwidth2;
MCNUM yheight2 = mccchannel_5_analyzer_1_array_crystal_array_6_yheight2;
MCNUM visualize = mccchannel_5_analyzer_1_array_crystal_array_6_visualize;
int target_index = mccchannel_5_analyzer_1_array_crystal_array_6_target_index;
MCNUM target_x = mccchannel_5_analyzer_1_array_crystal_array_6_target_x;
MCNUM target_y = mccchannel_5_analyzer_1_array_crystal_array_6_target_y;
MCNUM target_z = mccchannel_5_analyzer_1_array_crystal_array_6_target_z;
MCNUM focus_aw = mccchannel_5_analyzer_1_array_crystal_array_6_focus_aw;
MCNUM focus_ah = mccchannel_5_analyzer_1_array_crystal_array_6_focus_ah;
MCNUM focus_xw = mccchannel_5_analyzer_1_array_crystal_array_6_focus_xw;
MCNUM focus_xh = mccchannel_5_analyzer_1_array_crystal_array_6_focus_xh;
MCNUM focus_r = mccchannel_5_analyzer_1_array_crystal_array_6_focus_r;
MCNUM p_interact = mccchannel_5_analyzer_1_array_crystal_array_6_p_interact;
char* mask_string = mccchannel_5_analyzer_1_array_crystal_array_6_mask_string;
char* mask_setting = mccchannel_5_analyzer_1_array_crystal_array_6_mask_setting;
MCNUM number_of_activations = mccchannel_5_analyzer_1_array_crystal_array_6_number_of_activations;
}   /* End of channel_5_analyzer_1_array_crystal_array_6=Union_box() SETTING parameter declarations. */
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex
  /* Label for restoring  neutron */
  mcabsorbCompchannel_5_analyzer_1_array_crystal_array_6:
  if (RESTORE) /* restore if needed */
  { RESTORE_NEUTRON(326,
      mcnlx,
      mcnly,
      mcnlz,
      mcnlvx,
      mcnlvy,
      mcnlvz,
      mcnlt,
      mcnlsx,
      mcnlsy,
      mcnlsz,
      mcnlp); }
#undef mcabsorbComp
#undef p
#undef sz
#undef sy
#undef sx
#undef t
#undef vz
#undef vy
#undef vx
#undef z
#undef y
#undef x
  mcDEBUG_STATE(
mcnlx,
mcnly,
mcnlz,
mcnlvx,
mcnlvy,
mcnlvz,
mcnlt,
mcnlsx,
mcnlsy,
mcnlsz,
mcnlp)

  /* TRACE Component channel_5_analyzer_1_array_crystal_array_7 [327] */
  mccoordschange(mcposrchannel_5_analyzer_1_array_crystal_array_7, mcrotrchannel_5_analyzer_1_array_crystal_array_7,
    &mcnlx,
    &mcnly,
    &mcnlz,
    &mcnlvx,
    &mcnlvy,
    &mcnlvz,
    &mcnlsx,
    &mcnlsy,
    &mcnlsz);
  /* define label inside component channel_5_analyzer_1_array_crystal_array_7 (without coords transformations) */
  mcJumpTrace_channel_5_analyzer_1_array_crystal_array_7:
  SIG_MESSAGE("channel_5_analyzer_1_array_crystal_array_7 (Trace)");
  mcDEBUG_COMP("channel_5_analyzer_1_array_crystal_array_7")
  mcDEBUG_STATE(
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp)
#define x mcnlx
#define y mcnly
#define z mcnlz
#define vx mcnlvx
#define vy mcnlvy
#define vz mcnlvz
#define t mcnlt
#define sx mcnlsx
#define sy mcnlsy
#define sz mcnlsz
#define p mcnlp

#define mcabsorbComp mcabsorbCompchannel_5_analyzer_1_array_crystal_array_7
  STORE_NEUTRON(327,
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp);
  mcScattered=0;
  mcRestore=0;
  mcNCounter[327]++;
  mcPCounter[327] += p;
  mcP2Counter[327] += p*p;
#define mccompcurname  channel_5_analyzer_1_array_crystal_array_7
#define mccompcurtype  Union_box
#define mccompcurindex 327
#define loop_index mccchannel_5_analyzer_1_array_crystal_array_7_loop_index
#define this_box_volume mccchannel_5_analyzer_1_array_crystal_array_7_this_box_volume
#define global_geometry_element mccchannel_5_analyzer_1_array_crystal_array_7_global_geometry_element
#define this_box_storage mccchannel_5_analyzer_1_array_crystal_array_7_this_box_storage
{   /* Declarations of channel_5_analyzer_1_array_crystal_array_7=Union_box() SETTING parameters. */
char* material_string = mccchannel_5_analyzer_1_array_crystal_array_7_material_string;
MCNUM priority = mccchannel_5_analyzer_1_array_crystal_array_7_priority;
MCNUM xwidth = mccchannel_5_analyzer_1_array_crystal_array_7_xwidth;
MCNUM yheight = mccchannel_5_analyzer_1_array_crystal_array_7_yheight;
MCNUM zdepth = mccchannel_5_analyzer_1_array_crystal_array_7_zdepth;
MCNUM xwidth2 = mccchannel_5_analyzer_1_array_crystal_array_7_xwidth2;
MCNUM yheight2 = mccchannel_5_analyzer_1_array_crystal_array_7_yheight2;
MCNUM visualize = mccchannel_5_analyzer_1_array_crystal_array_7_visualize;
int target_index = mccchannel_5_analyzer_1_array_crystal_array_7_target_index;
MCNUM target_x = mccchannel_5_analyzer_1_array_crystal_array_7_target_x;
MCNUM target_y = mccchannel_5_analyzer_1_array_crystal_array_7_target_y;
MCNUM target_z = mccchannel_5_analyzer_1_array_crystal_array_7_target_z;
MCNUM focus_aw = mccchannel_5_analyzer_1_array_crystal_array_7_focus_aw;
MCNUM focus_ah = mccchannel_5_analyzer_1_array_crystal_array_7_focus_ah;
MCNUM focus_xw = mccchannel_5_analyzer_1_array_crystal_array_7_focus_xw;
MCNUM focus_xh = mccchannel_5_analyzer_1_array_crystal_array_7_focus_xh;
MCNUM focus_r = mccchannel_5_analyzer_1_array_crystal_array_7_focus_r;
MCNUM p_interact = mccchannel_5_analyzer_1_array_crystal_array_7_p_interact;
char* mask_string = mccchannel_5_analyzer_1_array_crystal_array_7_mask_string;
char* mask_setting = mccchannel_5_analyzer_1_array_crystal_array_7_mask_setting;
MCNUM number_of_activations = mccchannel_5_analyzer_1_array_crystal_array_7_number_of_activations;
}   /* End of channel_5_analyzer_1_array_crystal_array_7=Union_box() SETTING parameter declarations. */
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex
  /* Label for restoring  neutron */
  mcabsorbCompchannel_5_analyzer_1_array_crystal_array_7:
  if (RESTORE) /* restore if needed */
  { RESTORE_NEUTRON(327,
      mcnlx,
      mcnly,
      mcnlz,
      mcnlvx,
      mcnlvy,
      mcnlvz,
      mcnlt,
      mcnlsx,
      mcnlsy,
      mcnlsz,
      mcnlp); }
#undef mcabsorbComp
#undef p
#undef sz
#undef sy
#undef sx
#undef t
#undef vz
#undef vy
#undef vx
#undef z
#undef y
#undef x
  mcDEBUG_STATE(
mcnlx,
mcnly,
mcnlz,
mcnlvx,
mcnlvy,
mcnlvz,
mcnlt,
mcnlsx,
mcnlsy,
mcnlsz,
mcnlp)

  /* TRACE Component channel_5_analyzer_1_array_crystal_array_8 [328] */
  mccoordschange(mcposrchannel_5_analyzer_1_array_crystal_array_8, mcrotrchannel_5_analyzer_1_array_crystal_array_8,
    &mcnlx,
    &mcnly,
    &mcnlz,
    &mcnlvx,
    &mcnlvy,
    &mcnlvz,
    &mcnlsx,
    &mcnlsy,
    &mcnlsz);
  /* define label inside component channel_5_analyzer_1_array_crystal_array_8 (without coords transformations) */
  mcJumpTrace_channel_5_analyzer_1_array_crystal_array_8:
  SIG_MESSAGE("channel_5_analyzer_1_array_crystal_array_8 (Trace)");
  mcDEBUG_COMP("channel_5_analyzer_1_array_crystal_array_8")
  mcDEBUG_STATE(
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp)
#define x mcnlx
#define y mcnly
#define z mcnlz
#define vx mcnlvx
#define vy mcnlvy
#define vz mcnlvz
#define t mcnlt
#define sx mcnlsx
#define sy mcnlsy
#define sz mcnlsz
#define p mcnlp

#define mcabsorbComp mcabsorbCompchannel_5_analyzer_1_array_crystal_array_8
  STORE_NEUTRON(328,
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp);
  mcScattered=0;
  mcRestore=0;
  mcNCounter[328]++;
  mcPCounter[328] += p;
  mcP2Counter[328] += p*p;
#define mccompcurname  channel_5_analyzer_1_array_crystal_array_8
#define mccompcurtype  Union_box
#define mccompcurindex 328
#define loop_index mccchannel_5_analyzer_1_array_crystal_array_8_loop_index
#define this_box_volume mccchannel_5_analyzer_1_array_crystal_array_8_this_box_volume
#define global_geometry_element mccchannel_5_analyzer_1_array_crystal_array_8_global_geometry_element
#define this_box_storage mccchannel_5_analyzer_1_array_crystal_array_8_this_box_storage
{   /* Declarations of channel_5_analyzer_1_array_crystal_array_8=Union_box() SETTING parameters. */
char* material_string = mccchannel_5_analyzer_1_array_crystal_array_8_material_string;
MCNUM priority = mccchannel_5_analyzer_1_array_crystal_array_8_priority;
MCNUM xwidth = mccchannel_5_analyzer_1_array_crystal_array_8_xwidth;
MCNUM yheight = mccchannel_5_analyzer_1_array_crystal_array_8_yheight;
MCNUM zdepth = mccchannel_5_analyzer_1_array_crystal_array_8_zdepth;
MCNUM xwidth2 = mccchannel_5_analyzer_1_array_crystal_array_8_xwidth2;
MCNUM yheight2 = mccchannel_5_analyzer_1_array_crystal_array_8_yheight2;
MCNUM visualize = mccchannel_5_analyzer_1_array_crystal_array_8_visualize;
int target_index = mccchannel_5_analyzer_1_array_crystal_array_8_target_index;
MCNUM target_x = mccchannel_5_analyzer_1_array_crystal_array_8_target_x;
MCNUM target_y = mccchannel_5_analyzer_1_array_crystal_array_8_target_y;
MCNUM target_z = mccchannel_5_analyzer_1_array_crystal_array_8_target_z;
MCNUM focus_aw = mccchannel_5_analyzer_1_array_crystal_array_8_focus_aw;
MCNUM focus_ah = mccchannel_5_analyzer_1_array_crystal_array_8_focus_ah;
MCNUM focus_xw = mccchannel_5_analyzer_1_array_crystal_array_8_focus_xw;
MCNUM focus_xh = mccchannel_5_analyzer_1_array_crystal_array_8_focus_xh;
MCNUM focus_r = mccchannel_5_analyzer_1_array_crystal_array_8_focus_r;
MCNUM p_interact = mccchannel_5_analyzer_1_array_crystal_array_8_p_interact;
char* mask_string = mccchannel_5_analyzer_1_array_crystal_array_8_mask_string;
char* mask_setting = mccchannel_5_analyzer_1_array_crystal_array_8_mask_setting;
MCNUM number_of_activations = mccchannel_5_analyzer_1_array_crystal_array_8_number_of_activations;
}   /* End of channel_5_analyzer_1_array_crystal_array_8=Union_box() SETTING parameter declarations. */
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex
  /* Label for restoring  neutron */
  mcabsorbCompchannel_5_analyzer_1_array_crystal_array_8:
  if (RESTORE) /* restore if needed */
  { RESTORE_NEUTRON(328,
      mcnlx,
      mcnly,
      mcnlz,
      mcnlvx,
      mcnlvy,
      mcnlvz,
      mcnlt,
      mcnlsx,
      mcnlsy,
      mcnlsz,
      mcnlp); }
#undef mcabsorbComp
#undef p
#undef sz
#undef sy
#undef sx
#undef t
#undef vz
#undef vy
#undef vx
#undef z
#undef y
#undef x
  mcDEBUG_STATE(
mcnlx,
mcnly,
mcnlz,
mcnlvx,
mcnlvy,
mcnlvz,
mcnlt,
mcnlsx,
mcnlsy,
mcnlsz,
mcnlp)

  /* TRACE Component channel_5_analyzer_2_center [329] */
  mccoordschange(mcposrchannel_5_analyzer_2_center, mcrotrchannel_5_analyzer_2_center,
    &mcnlx,
    &mcnly,
    &mcnlz,
    &mcnlvx,
    &mcnlvy,
    &mcnlvz,
    &mcnlsx,
    &mcnlsy,
    &mcnlsz);
  /* define label inside component channel_5_analyzer_2_center (without coords transformations) */
  mcJumpTrace_channel_5_analyzer_2_center:
  SIG_MESSAGE("channel_5_analyzer_2_center (Trace)");
  mcDEBUG_COMP("channel_5_analyzer_2_center")
  mcDEBUG_STATE(
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp)
#define x mcnlx
#define y mcnly
#define z mcnlz
#define vx mcnlvx
#define vy mcnlvy
#define vz mcnlvz
#define t mcnlt
#define sx mcnlsx
#define sy mcnlsy
#define sz mcnlsz
#define p mcnlp

#define mcabsorbComp mcabsorbCompchannel_5_analyzer_2_center
  STORE_NEUTRON(329,
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp);
  mcScattered=0;
  mcRestore=0;
  mcNCounter[329]++;
  mcPCounter[329] += p;
  mcP2Counter[329] += p*p;
#define mccompcurname  channel_5_analyzer_2_center
#define mccompcurtype  Arm
#define mccompcurindex 329
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex
  /* Label for restoring  neutron */
  mcabsorbCompchannel_5_analyzer_2_center:
  if (RESTORE) /* restore if needed */
  { RESTORE_NEUTRON(329,
      mcnlx,
      mcnly,
      mcnlz,
      mcnlvx,
      mcnlvy,
      mcnlvz,
      mcnlt,
      mcnlsx,
      mcnlsy,
      mcnlsz,
      mcnlp); }
#undef mcabsorbComp
#undef p
#undef sz
#undef sy
#undef sx
#undef t
#undef vz
#undef vy
#undef vx
#undef z
#undef y
#undef x
  mcDEBUG_STATE(
mcnlx,
mcnly,
mcnlz,
mcnlvx,
mcnlvy,
mcnlvz,
mcnlt,
mcnlsx,
mcnlsy,
mcnlsz,
mcnlp)

  /* TRACE Component channel_5_analyzer_2_rotated [330] */
  mccoordschange(mcposrchannel_5_analyzer_2_rotated, mcrotrchannel_5_analyzer_2_rotated,
    &mcnlx,
    &mcnly,
    &mcnlz,
    &mcnlvx,
    &mcnlvy,
    &mcnlvz,
    &mcnlsx,
    &mcnlsy,
    &mcnlsz);
  /* define label inside component channel_5_analyzer_2_rotated (without coords transformations) */
  mcJumpTrace_channel_5_analyzer_2_rotated:
  SIG_MESSAGE("channel_5_analyzer_2_rotated (Trace)");
  mcDEBUG_COMP("channel_5_analyzer_2_rotated")
  mcDEBUG_STATE(
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp)
#define x mcnlx
#define y mcnly
#define z mcnlz
#define vx mcnlvx
#define vy mcnlvy
#define vz mcnlvz
#define t mcnlt
#define sx mcnlsx
#define sy mcnlsy
#define sz mcnlsz
#define p mcnlp

#define mcabsorbComp mcabsorbCompchannel_5_analyzer_2_rotated
  STORE_NEUTRON(330,
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp);
  mcScattered=0;
  mcRestore=0;
  mcNCounter[330]++;
  mcPCounter[330] += p;
  mcP2Counter[330] += p*p;
#define mccompcurname  channel_5_analyzer_2_rotated
#define mccompcurtype  Arm
#define mccompcurindex 330
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex
  /* Label for restoring  neutron */
  mcabsorbCompchannel_5_analyzer_2_rotated:
  if (RESTORE) /* restore if needed */
  { RESTORE_NEUTRON(330,
      mcnlx,
      mcnly,
      mcnlz,
      mcnlvx,
      mcnlvy,
      mcnlvz,
      mcnlt,
      mcnlsx,
      mcnlsy,
      mcnlsz,
      mcnlp); }
#undef mcabsorbComp
#undef p
#undef sz
#undef sy
#undef sx
#undef t
#undef vz
#undef vy
#undef vx
#undef z
#undef y
#undef x
  mcDEBUG_STATE(
mcnlx,
mcnly,
mcnlz,
mcnlvx,
mcnlvy,
mcnlvz,
mcnlt,
mcnlsx,
mcnlsy,
mcnlsz,
mcnlp)

  /* TRACE Component channel_5_analyzer_2_array_crystal_array_0 [331] */
  mccoordschange(mcposrchannel_5_analyzer_2_array_crystal_array_0, mcrotrchannel_5_analyzer_2_array_crystal_array_0,
    &mcnlx,
    &mcnly,
    &mcnlz,
    &mcnlvx,
    &mcnlvy,
    &mcnlvz,
    &mcnlsx,
    &mcnlsy,
    &mcnlsz);
  /* define label inside component channel_5_analyzer_2_array_crystal_array_0 (without coords transformations) */
  mcJumpTrace_channel_5_analyzer_2_array_crystal_array_0:
  SIG_MESSAGE("channel_5_analyzer_2_array_crystal_array_0 (Trace)");
  mcDEBUG_COMP("channel_5_analyzer_2_array_crystal_array_0")
  mcDEBUG_STATE(
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp)
#define x mcnlx
#define y mcnly
#define z mcnlz
#define vx mcnlvx
#define vy mcnlvy
#define vz mcnlvz
#define t mcnlt
#define sx mcnlsx
#define sy mcnlsy
#define sz mcnlsz
#define p mcnlp

#define mcabsorbComp mcabsorbCompchannel_5_analyzer_2_array_crystal_array_0
  STORE_NEUTRON(331,
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp);
  mcScattered=0;
  mcRestore=0;
  mcNCounter[331]++;
  mcPCounter[331] += p;
  mcP2Counter[331] += p*p;
#define mccompcurname  channel_5_analyzer_2_array_crystal_array_0
#define mccompcurtype  Union_box
#define mccompcurindex 331
#define loop_index mccchannel_5_analyzer_2_array_crystal_array_0_loop_index
#define this_box_volume mccchannel_5_analyzer_2_array_crystal_array_0_this_box_volume
#define global_geometry_element mccchannel_5_analyzer_2_array_crystal_array_0_global_geometry_element
#define this_box_storage mccchannel_5_analyzer_2_array_crystal_array_0_this_box_storage
{   /* Declarations of channel_5_analyzer_2_array_crystal_array_0=Union_box() SETTING parameters. */
char* material_string = mccchannel_5_analyzer_2_array_crystal_array_0_material_string;
MCNUM priority = mccchannel_5_analyzer_2_array_crystal_array_0_priority;
MCNUM xwidth = mccchannel_5_analyzer_2_array_crystal_array_0_xwidth;
MCNUM yheight = mccchannel_5_analyzer_2_array_crystal_array_0_yheight;
MCNUM zdepth = mccchannel_5_analyzer_2_array_crystal_array_0_zdepth;
MCNUM xwidth2 = mccchannel_5_analyzer_2_array_crystal_array_0_xwidth2;
MCNUM yheight2 = mccchannel_5_analyzer_2_array_crystal_array_0_yheight2;
MCNUM visualize = mccchannel_5_analyzer_2_array_crystal_array_0_visualize;
int target_index = mccchannel_5_analyzer_2_array_crystal_array_0_target_index;
MCNUM target_x = mccchannel_5_analyzer_2_array_crystal_array_0_target_x;
MCNUM target_y = mccchannel_5_analyzer_2_array_crystal_array_0_target_y;
MCNUM target_z = mccchannel_5_analyzer_2_array_crystal_array_0_target_z;
MCNUM focus_aw = mccchannel_5_analyzer_2_array_crystal_array_0_focus_aw;
MCNUM focus_ah = mccchannel_5_analyzer_2_array_crystal_array_0_focus_ah;
MCNUM focus_xw = mccchannel_5_analyzer_2_array_crystal_array_0_focus_xw;
MCNUM focus_xh = mccchannel_5_analyzer_2_array_crystal_array_0_focus_xh;
MCNUM focus_r = mccchannel_5_analyzer_2_array_crystal_array_0_focus_r;
MCNUM p_interact = mccchannel_5_analyzer_2_array_crystal_array_0_p_interact;
char* mask_string = mccchannel_5_analyzer_2_array_crystal_array_0_mask_string;
char* mask_setting = mccchannel_5_analyzer_2_array_crystal_array_0_mask_setting;
MCNUM number_of_activations = mccchannel_5_analyzer_2_array_crystal_array_0_number_of_activations;
}   /* End of channel_5_analyzer_2_array_crystal_array_0=Union_box() SETTING parameter declarations. */
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex
  /* Label for restoring  neutron */
  mcabsorbCompchannel_5_analyzer_2_array_crystal_array_0:
  if (RESTORE) /* restore if needed */
  { RESTORE_NEUTRON(331,
      mcnlx,
      mcnly,
      mcnlz,
      mcnlvx,
      mcnlvy,
      mcnlvz,
      mcnlt,
      mcnlsx,
      mcnlsy,
      mcnlsz,
      mcnlp); }
#undef mcabsorbComp
#undef p
#undef sz
#undef sy
#undef sx
#undef t
#undef vz
#undef vy
#undef vx
#undef z
#undef y
#undef x
  mcDEBUG_STATE(
mcnlx,
mcnly,
mcnlz,
mcnlvx,
mcnlvy,
mcnlvz,
mcnlt,
mcnlsx,
mcnlsy,
mcnlsz,
mcnlp)

  /* TRACE Component channel_5_analyzer_2_array_crystal_array_1 [332] */
  mccoordschange(mcposrchannel_5_analyzer_2_array_crystal_array_1, mcrotrchannel_5_analyzer_2_array_crystal_array_1,
    &mcnlx,
    &mcnly,
    &mcnlz,
    &mcnlvx,
    &mcnlvy,
    &mcnlvz,
    &mcnlsx,
    &mcnlsy,
    &mcnlsz);
  /* define label inside component channel_5_analyzer_2_array_crystal_array_1 (without coords transformations) */
  mcJumpTrace_channel_5_analyzer_2_array_crystal_array_1:
  SIG_MESSAGE("channel_5_analyzer_2_array_crystal_array_1 (Trace)");
  mcDEBUG_COMP("channel_5_analyzer_2_array_crystal_array_1")
  mcDEBUG_STATE(
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp)
#define x mcnlx
#define y mcnly
#define z mcnlz
#define vx mcnlvx
#define vy mcnlvy
#define vz mcnlvz
#define t mcnlt
#define sx mcnlsx
#define sy mcnlsy
#define sz mcnlsz
#define p mcnlp

#define mcabsorbComp mcabsorbCompchannel_5_analyzer_2_array_crystal_array_1
  STORE_NEUTRON(332,
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp);
  mcScattered=0;
  mcRestore=0;
  mcNCounter[332]++;
  mcPCounter[332] += p;
  mcP2Counter[332] += p*p;
#define mccompcurname  channel_5_analyzer_2_array_crystal_array_1
#define mccompcurtype  Union_box
#define mccompcurindex 332
#define loop_index mccchannel_5_analyzer_2_array_crystal_array_1_loop_index
#define this_box_volume mccchannel_5_analyzer_2_array_crystal_array_1_this_box_volume
#define global_geometry_element mccchannel_5_analyzer_2_array_crystal_array_1_global_geometry_element
#define this_box_storage mccchannel_5_analyzer_2_array_crystal_array_1_this_box_storage
{   /* Declarations of channel_5_analyzer_2_array_crystal_array_1=Union_box() SETTING parameters. */
char* material_string = mccchannel_5_analyzer_2_array_crystal_array_1_material_string;
MCNUM priority = mccchannel_5_analyzer_2_array_crystal_array_1_priority;
MCNUM xwidth = mccchannel_5_analyzer_2_array_crystal_array_1_xwidth;
MCNUM yheight = mccchannel_5_analyzer_2_array_crystal_array_1_yheight;
MCNUM zdepth = mccchannel_5_analyzer_2_array_crystal_array_1_zdepth;
MCNUM xwidth2 = mccchannel_5_analyzer_2_array_crystal_array_1_xwidth2;
MCNUM yheight2 = mccchannel_5_analyzer_2_array_crystal_array_1_yheight2;
MCNUM visualize = mccchannel_5_analyzer_2_array_crystal_array_1_visualize;
int target_index = mccchannel_5_analyzer_2_array_crystal_array_1_target_index;
MCNUM target_x = mccchannel_5_analyzer_2_array_crystal_array_1_target_x;
MCNUM target_y = mccchannel_5_analyzer_2_array_crystal_array_1_target_y;
MCNUM target_z = mccchannel_5_analyzer_2_array_crystal_array_1_target_z;
MCNUM focus_aw = mccchannel_5_analyzer_2_array_crystal_array_1_focus_aw;
MCNUM focus_ah = mccchannel_5_analyzer_2_array_crystal_array_1_focus_ah;
MCNUM focus_xw = mccchannel_5_analyzer_2_array_crystal_array_1_focus_xw;
MCNUM focus_xh = mccchannel_5_analyzer_2_array_crystal_array_1_focus_xh;
MCNUM focus_r = mccchannel_5_analyzer_2_array_crystal_array_1_focus_r;
MCNUM p_interact = mccchannel_5_analyzer_2_array_crystal_array_1_p_interact;
char* mask_string = mccchannel_5_analyzer_2_array_crystal_array_1_mask_string;
char* mask_setting = mccchannel_5_analyzer_2_array_crystal_array_1_mask_setting;
MCNUM number_of_activations = mccchannel_5_analyzer_2_array_crystal_array_1_number_of_activations;
}   /* End of channel_5_analyzer_2_array_crystal_array_1=Union_box() SETTING parameter declarations. */
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex
  /* Label for restoring  neutron */
  mcabsorbCompchannel_5_analyzer_2_array_crystal_array_1:
  if (RESTORE) /* restore if needed */
  { RESTORE_NEUTRON(332,
      mcnlx,
      mcnly,
      mcnlz,
      mcnlvx,
      mcnlvy,
      mcnlvz,
      mcnlt,
      mcnlsx,
      mcnlsy,
      mcnlsz,
      mcnlp); }
#undef mcabsorbComp
#undef p
#undef sz
#undef sy
#undef sx
#undef t
#undef vz
#undef vy
#undef vx
#undef z
#undef y
#undef x
  mcDEBUG_STATE(
mcnlx,
mcnly,
mcnlz,
mcnlvx,
mcnlvy,
mcnlvz,
mcnlt,
mcnlsx,
mcnlsy,
mcnlsz,
mcnlp)

  /* TRACE Component channel_5_analyzer_2_array_crystal_array_2 [333] */
  mccoordschange(mcposrchannel_5_analyzer_2_array_crystal_array_2, mcrotrchannel_5_analyzer_2_array_crystal_array_2,
    &mcnlx,
    &mcnly,
    &mcnlz,
    &mcnlvx,
    &mcnlvy,
    &mcnlvz,
    &mcnlsx,
    &mcnlsy,
    &mcnlsz);
  /* define label inside component channel_5_analyzer_2_array_crystal_array_2 (without coords transformations) */
  mcJumpTrace_channel_5_analyzer_2_array_crystal_array_2:
  SIG_MESSAGE("channel_5_analyzer_2_array_crystal_array_2 (Trace)");
  mcDEBUG_COMP("channel_5_analyzer_2_array_crystal_array_2")
  mcDEBUG_STATE(
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp)
#define x mcnlx
#define y mcnly
#define z mcnlz
#define vx mcnlvx
#define vy mcnlvy
#define vz mcnlvz
#define t mcnlt
#define sx mcnlsx
#define sy mcnlsy
#define sz mcnlsz
#define p mcnlp

#define mcabsorbComp mcabsorbCompchannel_5_analyzer_2_array_crystal_array_2
  STORE_NEUTRON(333,
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp);
  mcScattered=0;
  mcRestore=0;
  mcNCounter[333]++;
  mcPCounter[333] += p;
  mcP2Counter[333] += p*p;
#define mccompcurname  channel_5_analyzer_2_array_crystal_array_2
#define mccompcurtype  Union_box
#define mccompcurindex 333
#define loop_index mccchannel_5_analyzer_2_array_crystal_array_2_loop_index
#define this_box_volume mccchannel_5_analyzer_2_array_crystal_array_2_this_box_volume
#define global_geometry_element mccchannel_5_analyzer_2_array_crystal_array_2_global_geometry_element
#define this_box_storage mccchannel_5_analyzer_2_array_crystal_array_2_this_box_storage
{   /* Declarations of channel_5_analyzer_2_array_crystal_array_2=Union_box() SETTING parameters. */
char* material_string = mccchannel_5_analyzer_2_array_crystal_array_2_material_string;
MCNUM priority = mccchannel_5_analyzer_2_array_crystal_array_2_priority;
MCNUM xwidth = mccchannel_5_analyzer_2_array_crystal_array_2_xwidth;
MCNUM yheight = mccchannel_5_analyzer_2_array_crystal_array_2_yheight;
MCNUM zdepth = mccchannel_5_analyzer_2_array_crystal_array_2_zdepth;
MCNUM xwidth2 = mccchannel_5_analyzer_2_array_crystal_array_2_xwidth2;
MCNUM yheight2 = mccchannel_5_analyzer_2_array_crystal_array_2_yheight2;
MCNUM visualize = mccchannel_5_analyzer_2_array_crystal_array_2_visualize;
int target_index = mccchannel_5_analyzer_2_array_crystal_array_2_target_index;
MCNUM target_x = mccchannel_5_analyzer_2_array_crystal_array_2_target_x;
MCNUM target_y = mccchannel_5_analyzer_2_array_crystal_array_2_target_y;
MCNUM target_z = mccchannel_5_analyzer_2_array_crystal_array_2_target_z;
MCNUM focus_aw = mccchannel_5_analyzer_2_array_crystal_array_2_focus_aw;
MCNUM focus_ah = mccchannel_5_analyzer_2_array_crystal_array_2_focus_ah;
MCNUM focus_xw = mccchannel_5_analyzer_2_array_crystal_array_2_focus_xw;
MCNUM focus_xh = mccchannel_5_analyzer_2_array_crystal_array_2_focus_xh;
MCNUM focus_r = mccchannel_5_analyzer_2_array_crystal_array_2_focus_r;
MCNUM p_interact = mccchannel_5_analyzer_2_array_crystal_array_2_p_interact;
char* mask_string = mccchannel_5_analyzer_2_array_crystal_array_2_mask_string;
char* mask_setting = mccchannel_5_analyzer_2_array_crystal_array_2_mask_setting;
MCNUM number_of_activations = mccchannel_5_analyzer_2_array_crystal_array_2_number_of_activations;
}   /* End of channel_5_analyzer_2_array_crystal_array_2=Union_box() SETTING parameter declarations. */
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex
  /* Label for restoring  neutron */
  mcabsorbCompchannel_5_analyzer_2_array_crystal_array_2:
  if (RESTORE) /* restore if needed */
  { RESTORE_NEUTRON(333,
      mcnlx,
      mcnly,
      mcnlz,
      mcnlvx,
      mcnlvy,
      mcnlvz,
      mcnlt,
      mcnlsx,
      mcnlsy,
      mcnlsz,
      mcnlp); }
#undef mcabsorbComp
#undef p
#undef sz
#undef sy
#undef sx
#undef t
#undef vz
#undef vy
#undef vx
#undef z
#undef y
#undef x
  mcDEBUG_STATE(
mcnlx,
mcnly,
mcnlz,
mcnlvx,
mcnlvy,
mcnlvz,
mcnlt,
mcnlsx,
mcnlsy,
mcnlsz,
mcnlp)

  /* TRACE Component channel_5_analyzer_2_array_crystal_array_3 [334] */
  mccoordschange(mcposrchannel_5_analyzer_2_array_crystal_array_3, mcrotrchannel_5_analyzer_2_array_crystal_array_3,
    &mcnlx,
    &mcnly,
    &mcnlz,
    &mcnlvx,
    &mcnlvy,
    &mcnlvz,
    &mcnlsx,
    &mcnlsy,
    &mcnlsz);
  /* define label inside component channel_5_analyzer_2_array_crystal_array_3 (without coords transformations) */
  mcJumpTrace_channel_5_analyzer_2_array_crystal_array_3:
  SIG_MESSAGE("channel_5_analyzer_2_array_crystal_array_3 (Trace)");
  mcDEBUG_COMP("channel_5_analyzer_2_array_crystal_array_3")
  mcDEBUG_STATE(
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp)
#define x mcnlx
#define y mcnly
#define z mcnlz
#define vx mcnlvx
#define vy mcnlvy
#define vz mcnlvz
#define t mcnlt
#define sx mcnlsx
#define sy mcnlsy
#define sz mcnlsz
#define p mcnlp

#define mcabsorbComp mcabsorbCompchannel_5_analyzer_2_array_crystal_array_3
  STORE_NEUTRON(334,
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp);
  mcScattered=0;
  mcRestore=0;
  mcNCounter[334]++;
  mcPCounter[334] += p;
  mcP2Counter[334] += p*p;
#define mccompcurname  channel_5_analyzer_2_array_crystal_array_3
#define mccompcurtype  Union_box
#define mccompcurindex 334
#define loop_index mccchannel_5_analyzer_2_array_crystal_array_3_loop_index
#define this_box_volume mccchannel_5_analyzer_2_array_crystal_array_3_this_box_volume
#define global_geometry_element mccchannel_5_analyzer_2_array_crystal_array_3_global_geometry_element
#define this_box_storage mccchannel_5_analyzer_2_array_crystal_array_3_this_box_storage
{   /* Declarations of channel_5_analyzer_2_array_crystal_array_3=Union_box() SETTING parameters. */
char* material_string = mccchannel_5_analyzer_2_array_crystal_array_3_material_string;
MCNUM priority = mccchannel_5_analyzer_2_array_crystal_array_3_priority;
MCNUM xwidth = mccchannel_5_analyzer_2_array_crystal_array_3_xwidth;
MCNUM yheight = mccchannel_5_analyzer_2_array_crystal_array_3_yheight;
MCNUM zdepth = mccchannel_5_analyzer_2_array_crystal_array_3_zdepth;
MCNUM xwidth2 = mccchannel_5_analyzer_2_array_crystal_array_3_xwidth2;
MCNUM yheight2 = mccchannel_5_analyzer_2_array_crystal_array_3_yheight2;
MCNUM visualize = mccchannel_5_analyzer_2_array_crystal_array_3_visualize;
int target_index = mccchannel_5_analyzer_2_array_crystal_array_3_target_index;
MCNUM target_x = mccchannel_5_analyzer_2_array_crystal_array_3_target_x;
MCNUM target_y = mccchannel_5_analyzer_2_array_crystal_array_3_target_y;
MCNUM target_z = mccchannel_5_analyzer_2_array_crystal_array_3_target_z;
MCNUM focus_aw = mccchannel_5_analyzer_2_array_crystal_array_3_focus_aw;
MCNUM focus_ah = mccchannel_5_analyzer_2_array_crystal_array_3_focus_ah;
MCNUM focus_xw = mccchannel_5_analyzer_2_array_crystal_array_3_focus_xw;
MCNUM focus_xh = mccchannel_5_analyzer_2_array_crystal_array_3_focus_xh;
MCNUM focus_r = mccchannel_5_analyzer_2_array_crystal_array_3_focus_r;
MCNUM p_interact = mccchannel_5_analyzer_2_array_crystal_array_3_p_interact;
char* mask_string = mccchannel_5_analyzer_2_array_crystal_array_3_mask_string;
char* mask_setting = mccchannel_5_analyzer_2_array_crystal_array_3_mask_setting;
MCNUM number_of_activations = mccchannel_5_analyzer_2_array_crystal_array_3_number_of_activations;
}   /* End of channel_5_analyzer_2_array_crystal_array_3=Union_box() SETTING parameter declarations. */
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex
  /* Label for restoring  neutron */
  mcabsorbCompchannel_5_analyzer_2_array_crystal_array_3:
  if (RESTORE) /* restore if needed */
  { RESTORE_NEUTRON(334,
      mcnlx,
      mcnly,
      mcnlz,
      mcnlvx,
      mcnlvy,
      mcnlvz,
      mcnlt,
      mcnlsx,
      mcnlsy,
      mcnlsz,
      mcnlp); }
#undef mcabsorbComp
#undef p
#undef sz
#undef sy
#undef sx
#undef t
#undef vz
#undef vy
#undef vx
#undef z
#undef y
#undef x
  mcDEBUG_STATE(
mcnlx,
mcnly,
mcnlz,
mcnlvx,
mcnlvy,
mcnlvz,
mcnlt,
mcnlsx,
mcnlsy,
mcnlsz,
mcnlp)

  /* TRACE Component channel_5_analyzer_2_array_crystal_array_4 [335] */
  mccoordschange(mcposrchannel_5_analyzer_2_array_crystal_array_4, mcrotrchannel_5_analyzer_2_array_crystal_array_4,
    &mcnlx,
    &mcnly,
    &mcnlz,
    &mcnlvx,
    &mcnlvy,
    &mcnlvz,
    &mcnlsx,
    &mcnlsy,
    &mcnlsz);
  /* define label inside component channel_5_analyzer_2_array_crystal_array_4 (without coords transformations) */
  mcJumpTrace_channel_5_analyzer_2_array_crystal_array_4:
  SIG_MESSAGE("channel_5_analyzer_2_array_crystal_array_4 (Trace)");
  mcDEBUG_COMP("channel_5_analyzer_2_array_crystal_array_4")
  mcDEBUG_STATE(
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp)
#define x mcnlx
#define y mcnly
#define z mcnlz
#define vx mcnlvx
#define vy mcnlvy
#define vz mcnlvz
#define t mcnlt
#define sx mcnlsx
#define sy mcnlsy
#define sz mcnlsz
#define p mcnlp

#define mcabsorbComp mcabsorbCompchannel_5_analyzer_2_array_crystal_array_4
  STORE_NEUTRON(335,
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp);
  mcScattered=0;
  mcRestore=0;
  mcNCounter[335]++;
  mcPCounter[335] += p;
  mcP2Counter[335] += p*p;
#define mccompcurname  channel_5_analyzer_2_array_crystal_array_4
#define mccompcurtype  Union_box
#define mccompcurindex 335
#define loop_index mccchannel_5_analyzer_2_array_crystal_array_4_loop_index
#define this_box_volume mccchannel_5_analyzer_2_array_crystal_array_4_this_box_volume
#define global_geometry_element mccchannel_5_analyzer_2_array_crystal_array_4_global_geometry_element
#define this_box_storage mccchannel_5_analyzer_2_array_crystal_array_4_this_box_storage
{   /* Declarations of channel_5_analyzer_2_array_crystal_array_4=Union_box() SETTING parameters. */
char* material_string = mccchannel_5_analyzer_2_array_crystal_array_4_material_string;
MCNUM priority = mccchannel_5_analyzer_2_array_crystal_array_4_priority;
MCNUM xwidth = mccchannel_5_analyzer_2_array_crystal_array_4_xwidth;
MCNUM yheight = mccchannel_5_analyzer_2_array_crystal_array_4_yheight;
MCNUM zdepth = mccchannel_5_analyzer_2_array_crystal_array_4_zdepth;
MCNUM xwidth2 = mccchannel_5_analyzer_2_array_crystal_array_4_xwidth2;
MCNUM yheight2 = mccchannel_5_analyzer_2_array_crystal_array_4_yheight2;
MCNUM visualize = mccchannel_5_analyzer_2_array_crystal_array_4_visualize;
int target_index = mccchannel_5_analyzer_2_array_crystal_array_4_target_index;
MCNUM target_x = mccchannel_5_analyzer_2_array_crystal_array_4_target_x;
MCNUM target_y = mccchannel_5_analyzer_2_array_crystal_array_4_target_y;
MCNUM target_z = mccchannel_5_analyzer_2_array_crystal_array_4_target_z;
MCNUM focus_aw = mccchannel_5_analyzer_2_array_crystal_array_4_focus_aw;
MCNUM focus_ah = mccchannel_5_analyzer_2_array_crystal_array_4_focus_ah;
MCNUM focus_xw = mccchannel_5_analyzer_2_array_crystal_array_4_focus_xw;
MCNUM focus_xh = mccchannel_5_analyzer_2_array_crystal_array_4_focus_xh;
MCNUM focus_r = mccchannel_5_analyzer_2_array_crystal_array_4_focus_r;
MCNUM p_interact = mccchannel_5_analyzer_2_array_crystal_array_4_p_interact;
char* mask_string = mccchannel_5_analyzer_2_array_crystal_array_4_mask_string;
char* mask_setting = mccchannel_5_analyzer_2_array_crystal_array_4_mask_setting;
MCNUM number_of_activations = mccchannel_5_analyzer_2_array_crystal_array_4_number_of_activations;
}   /* End of channel_5_analyzer_2_array_crystal_array_4=Union_box() SETTING parameter declarations. */
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex
  /* Label for restoring  neutron */
  mcabsorbCompchannel_5_analyzer_2_array_crystal_array_4:
  if (RESTORE) /* restore if needed */
  { RESTORE_NEUTRON(335,
      mcnlx,
      mcnly,
      mcnlz,
      mcnlvx,
      mcnlvy,
      mcnlvz,
      mcnlt,
      mcnlsx,
      mcnlsy,
      mcnlsz,
      mcnlp); }
#undef mcabsorbComp
#undef p
#undef sz
#undef sy
#undef sx
#undef t
#undef vz
#undef vy
#undef vx
#undef z
#undef y
#undef x
  mcDEBUG_STATE(
mcnlx,
mcnly,
mcnlz,
mcnlvx,
mcnlvy,
mcnlvz,
mcnlt,
mcnlsx,
mcnlsy,
mcnlsz,
mcnlp)

  /* TRACE Component channel_5_analyzer_2_array_crystal_array_5 [336] */
  mccoordschange(mcposrchannel_5_analyzer_2_array_crystal_array_5, mcrotrchannel_5_analyzer_2_array_crystal_array_5,
    &mcnlx,
    &mcnly,
    &mcnlz,
    &mcnlvx,
    &mcnlvy,
    &mcnlvz,
    &mcnlsx,
    &mcnlsy,
    &mcnlsz);
  /* define label inside component channel_5_analyzer_2_array_crystal_array_5 (without coords transformations) */
  mcJumpTrace_channel_5_analyzer_2_array_crystal_array_5:
  SIG_MESSAGE("channel_5_analyzer_2_array_crystal_array_5 (Trace)");
  mcDEBUG_COMP("channel_5_analyzer_2_array_crystal_array_5")
  mcDEBUG_STATE(
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp)
#define x mcnlx
#define y mcnly
#define z mcnlz
#define vx mcnlvx
#define vy mcnlvy
#define vz mcnlvz
#define t mcnlt
#define sx mcnlsx
#define sy mcnlsy
#define sz mcnlsz
#define p mcnlp

#define mcabsorbComp mcabsorbCompchannel_5_analyzer_2_array_crystal_array_5
  STORE_NEUTRON(336,
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp);
  mcScattered=0;
  mcRestore=0;
  mcNCounter[336]++;
  mcPCounter[336] += p;
  mcP2Counter[336] += p*p;
#define mccompcurname  channel_5_analyzer_2_array_crystal_array_5
#define mccompcurtype  Union_box
#define mccompcurindex 336
#define loop_index mccchannel_5_analyzer_2_array_crystal_array_5_loop_index
#define this_box_volume mccchannel_5_analyzer_2_array_crystal_array_5_this_box_volume
#define global_geometry_element mccchannel_5_analyzer_2_array_crystal_array_5_global_geometry_element
#define this_box_storage mccchannel_5_analyzer_2_array_crystal_array_5_this_box_storage
{   /* Declarations of channel_5_analyzer_2_array_crystal_array_5=Union_box() SETTING parameters. */
char* material_string = mccchannel_5_analyzer_2_array_crystal_array_5_material_string;
MCNUM priority = mccchannel_5_analyzer_2_array_crystal_array_5_priority;
MCNUM xwidth = mccchannel_5_analyzer_2_array_crystal_array_5_xwidth;
MCNUM yheight = mccchannel_5_analyzer_2_array_crystal_array_5_yheight;
MCNUM zdepth = mccchannel_5_analyzer_2_array_crystal_array_5_zdepth;
MCNUM xwidth2 = mccchannel_5_analyzer_2_array_crystal_array_5_xwidth2;
MCNUM yheight2 = mccchannel_5_analyzer_2_array_crystal_array_5_yheight2;
MCNUM visualize = mccchannel_5_analyzer_2_array_crystal_array_5_visualize;
int target_index = mccchannel_5_analyzer_2_array_crystal_array_5_target_index;
MCNUM target_x = mccchannel_5_analyzer_2_array_crystal_array_5_target_x;
MCNUM target_y = mccchannel_5_analyzer_2_array_crystal_array_5_target_y;
MCNUM target_z = mccchannel_5_analyzer_2_array_crystal_array_5_target_z;
MCNUM focus_aw = mccchannel_5_analyzer_2_array_crystal_array_5_focus_aw;
MCNUM focus_ah = mccchannel_5_analyzer_2_array_crystal_array_5_focus_ah;
MCNUM focus_xw = mccchannel_5_analyzer_2_array_crystal_array_5_focus_xw;
MCNUM focus_xh = mccchannel_5_analyzer_2_array_crystal_array_5_focus_xh;
MCNUM focus_r = mccchannel_5_analyzer_2_array_crystal_array_5_focus_r;
MCNUM p_interact = mccchannel_5_analyzer_2_array_crystal_array_5_p_interact;
char* mask_string = mccchannel_5_analyzer_2_array_crystal_array_5_mask_string;
char* mask_setting = mccchannel_5_analyzer_2_array_crystal_array_5_mask_setting;
MCNUM number_of_activations = mccchannel_5_analyzer_2_array_crystal_array_5_number_of_activations;
}   /* End of channel_5_analyzer_2_array_crystal_array_5=Union_box() SETTING parameter declarations. */
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex
  /* Label for restoring  neutron */
  mcabsorbCompchannel_5_analyzer_2_array_crystal_array_5:
  if (RESTORE) /* restore if needed */
  { RESTORE_NEUTRON(336,
      mcnlx,
      mcnly,
      mcnlz,
      mcnlvx,
      mcnlvy,
      mcnlvz,
      mcnlt,
      mcnlsx,
      mcnlsy,
      mcnlsz,
      mcnlp); }
#undef mcabsorbComp
#undef p
#undef sz
#undef sy
#undef sx
#undef t
#undef vz
#undef vy
#undef vx
#undef z
#undef y
#undef x
  mcDEBUG_STATE(
mcnlx,
mcnly,
mcnlz,
mcnlvx,
mcnlvy,
mcnlvz,
mcnlt,
mcnlsx,
mcnlsy,
mcnlsz,
mcnlp)

  /* TRACE Component channel_5_analyzer_2_array_crystal_array_6 [337] */
  mccoordschange(mcposrchannel_5_analyzer_2_array_crystal_array_6, mcrotrchannel_5_analyzer_2_array_crystal_array_6,
    &mcnlx,
    &mcnly,
    &mcnlz,
    &mcnlvx,
    &mcnlvy,
    &mcnlvz,
    &mcnlsx,
    &mcnlsy,
    &mcnlsz);
  /* define label inside component channel_5_analyzer_2_array_crystal_array_6 (without coords transformations) */
  mcJumpTrace_channel_5_analyzer_2_array_crystal_array_6:
  SIG_MESSAGE("channel_5_analyzer_2_array_crystal_array_6 (Trace)");
  mcDEBUG_COMP("channel_5_analyzer_2_array_crystal_array_6")
  mcDEBUG_STATE(
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp)
#define x mcnlx
#define y mcnly
#define z mcnlz
#define vx mcnlvx
#define vy mcnlvy
#define vz mcnlvz
#define t mcnlt
#define sx mcnlsx
#define sy mcnlsy
#define sz mcnlsz
#define p mcnlp

#define mcabsorbComp mcabsorbCompchannel_5_analyzer_2_array_crystal_array_6
  STORE_NEUTRON(337,
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp);
  mcScattered=0;
  mcRestore=0;
  mcNCounter[337]++;
  mcPCounter[337] += p;
  mcP2Counter[337] += p*p;
#define mccompcurname  channel_5_analyzer_2_array_crystal_array_6
#define mccompcurtype  Union_box
#define mccompcurindex 337
#define loop_index mccchannel_5_analyzer_2_array_crystal_array_6_loop_index
#define this_box_volume mccchannel_5_analyzer_2_array_crystal_array_6_this_box_volume
#define global_geometry_element mccchannel_5_analyzer_2_array_crystal_array_6_global_geometry_element
#define this_box_storage mccchannel_5_analyzer_2_array_crystal_array_6_this_box_storage
{   /* Declarations of channel_5_analyzer_2_array_crystal_array_6=Union_box() SETTING parameters. */
char* material_string = mccchannel_5_analyzer_2_array_crystal_array_6_material_string;
MCNUM priority = mccchannel_5_analyzer_2_array_crystal_array_6_priority;
MCNUM xwidth = mccchannel_5_analyzer_2_array_crystal_array_6_xwidth;
MCNUM yheight = mccchannel_5_analyzer_2_array_crystal_array_6_yheight;
MCNUM zdepth = mccchannel_5_analyzer_2_array_crystal_array_6_zdepth;
MCNUM xwidth2 = mccchannel_5_analyzer_2_array_crystal_array_6_xwidth2;
MCNUM yheight2 = mccchannel_5_analyzer_2_array_crystal_array_6_yheight2;
MCNUM visualize = mccchannel_5_analyzer_2_array_crystal_array_6_visualize;
int target_index = mccchannel_5_analyzer_2_array_crystal_array_6_target_index;
MCNUM target_x = mccchannel_5_analyzer_2_array_crystal_array_6_target_x;
MCNUM target_y = mccchannel_5_analyzer_2_array_crystal_array_6_target_y;
MCNUM target_z = mccchannel_5_analyzer_2_array_crystal_array_6_target_z;
MCNUM focus_aw = mccchannel_5_analyzer_2_array_crystal_array_6_focus_aw;
MCNUM focus_ah = mccchannel_5_analyzer_2_array_crystal_array_6_focus_ah;
MCNUM focus_xw = mccchannel_5_analyzer_2_array_crystal_array_6_focus_xw;
MCNUM focus_xh = mccchannel_5_analyzer_2_array_crystal_array_6_focus_xh;
MCNUM focus_r = mccchannel_5_analyzer_2_array_crystal_array_6_focus_r;
MCNUM p_interact = mccchannel_5_analyzer_2_array_crystal_array_6_p_interact;
char* mask_string = mccchannel_5_analyzer_2_array_crystal_array_6_mask_string;
char* mask_setting = mccchannel_5_analyzer_2_array_crystal_array_6_mask_setting;
MCNUM number_of_activations = mccchannel_5_analyzer_2_array_crystal_array_6_number_of_activations;
}   /* End of channel_5_analyzer_2_array_crystal_array_6=Union_box() SETTING parameter declarations. */
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex
  /* Label for restoring  neutron */
  mcabsorbCompchannel_5_analyzer_2_array_crystal_array_6:
  if (RESTORE) /* restore if needed */
  { RESTORE_NEUTRON(337,
      mcnlx,
      mcnly,
      mcnlz,
      mcnlvx,
      mcnlvy,
      mcnlvz,
      mcnlt,
      mcnlsx,
      mcnlsy,
      mcnlsz,
      mcnlp); }
#undef mcabsorbComp
#undef p
#undef sz
#undef sy
#undef sx
#undef t
#undef vz
#undef vy
#undef vx
#undef z
#undef y
#undef x
  mcDEBUG_STATE(
mcnlx,
mcnly,
mcnlz,
mcnlvx,
mcnlvy,
mcnlvz,
mcnlt,
mcnlsx,
mcnlsy,
mcnlsz,
mcnlp)

  /* TRACE Component channel_5_analyzer_2_array_crystal_array_7 [338] */
  mccoordschange(mcposrchannel_5_analyzer_2_array_crystal_array_7, mcrotrchannel_5_analyzer_2_array_crystal_array_7,
    &mcnlx,
    &mcnly,
    &mcnlz,
    &mcnlvx,
    &mcnlvy,
    &mcnlvz,
    &mcnlsx,
    &mcnlsy,
    &mcnlsz);
  /* define label inside component channel_5_analyzer_2_array_crystal_array_7 (without coords transformations) */
  mcJumpTrace_channel_5_analyzer_2_array_crystal_array_7:
  SIG_MESSAGE("channel_5_analyzer_2_array_crystal_array_7 (Trace)");
  mcDEBUG_COMP("channel_5_analyzer_2_array_crystal_array_7")
  mcDEBUG_STATE(
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp)
#define x mcnlx
#define y mcnly
#define z mcnlz
#define vx mcnlvx
#define vy mcnlvy
#define vz mcnlvz
#define t mcnlt
#define sx mcnlsx
#define sy mcnlsy
#define sz mcnlsz
#define p mcnlp

#define mcabsorbComp mcabsorbCompchannel_5_analyzer_2_array_crystal_array_7
  STORE_NEUTRON(338,
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp);
  mcScattered=0;
  mcRestore=0;
  mcNCounter[338]++;
  mcPCounter[338] += p;
  mcP2Counter[338] += p*p;
#define mccompcurname  channel_5_analyzer_2_array_crystal_array_7
#define mccompcurtype  Union_box
#define mccompcurindex 338
#define loop_index mccchannel_5_analyzer_2_array_crystal_array_7_loop_index
#define this_box_volume mccchannel_5_analyzer_2_array_crystal_array_7_this_box_volume
#define global_geometry_element mccchannel_5_analyzer_2_array_crystal_array_7_global_geometry_element
#define this_box_storage mccchannel_5_analyzer_2_array_crystal_array_7_this_box_storage
{   /* Declarations of channel_5_analyzer_2_array_crystal_array_7=Union_box() SETTING parameters. */
char* material_string = mccchannel_5_analyzer_2_array_crystal_array_7_material_string;
MCNUM priority = mccchannel_5_analyzer_2_array_crystal_array_7_priority;
MCNUM xwidth = mccchannel_5_analyzer_2_array_crystal_array_7_xwidth;
MCNUM yheight = mccchannel_5_analyzer_2_array_crystal_array_7_yheight;
MCNUM zdepth = mccchannel_5_analyzer_2_array_crystal_array_7_zdepth;
MCNUM xwidth2 = mccchannel_5_analyzer_2_array_crystal_array_7_xwidth2;
MCNUM yheight2 = mccchannel_5_analyzer_2_array_crystal_array_7_yheight2;
MCNUM visualize = mccchannel_5_analyzer_2_array_crystal_array_7_visualize;
int target_index = mccchannel_5_analyzer_2_array_crystal_array_7_target_index;
MCNUM target_x = mccchannel_5_analyzer_2_array_crystal_array_7_target_x;
MCNUM target_y = mccchannel_5_analyzer_2_array_crystal_array_7_target_y;
MCNUM target_z = mccchannel_5_analyzer_2_array_crystal_array_7_target_z;
MCNUM focus_aw = mccchannel_5_analyzer_2_array_crystal_array_7_focus_aw;
MCNUM focus_ah = mccchannel_5_analyzer_2_array_crystal_array_7_focus_ah;
MCNUM focus_xw = mccchannel_5_analyzer_2_array_crystal_array_7_focus_xw;
MCNUM focus_xh = mccchannel_5_analyzer_2_array_crystal_array_7_focus_xh;
MCNUM focus_r = mccchannel_5_analyzer_2_array_crystal_array_7_focus_r;
MCNUM p_interact = mccchannel_5_analyzer_2_array_crystal_array_7_p_interact;
char* mask_string = mccchannel_5_analyzer_2_array_crystal_array_7_mask_string;
char* mask_setting = mccchannel_5_analyzer_2_array_crystal_array_7_mask_setting;
MCNUM number_of_activations = mccchannel_5_analyzer_2_array_crystal_array_7_number_of_activations;
}   /* End of channel_5_analyzer_2_array_crystal_array_7=Union_box() SETTING parameter declarations. */
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex
  /* Label for restoring  neutron */
  mcabsorbCompchannel_5_analyzer_2_array_crystal_array_7:
  if (RESTORE) /* restore if needed */
  { RESTORE_NEUTRON(338,
      mcnlx,
      mcnly,
      mcnlz,
      mcnlvx,
      mcnlvy,
      mcnlvz,
      mcnlt,
      mcnlsx,
      mcnlsy,
      mcnlsz,
      mcnlp); }
#undef mcabsorbComp
#undef p
#undef sz
#undef sy
#undef sx
#undef t
#undef vz
#undef vy
#undef vx
#undef z
#undef y
#undef x
  mcDEBUG_STATE(
mcnlx,
mcnly,
mcnlz,
mcnlvx,
mcnlvy,
mcnlvz,
mcnlt,
mcnlsx,
mcnlsy,
mcnlsz,
mcnlp)

  /* TRACE Component channel_5_analyzer_2_array_crystal_array_8 [339] */
  mccoordschange(mcposrchannel_5_analyzer_2_array_crystal_array_8, mcrotrchannel_5_analyzer_2_array_crystal_array_8,
    &mcnlx,
    &mcnly,
    &mcnlz,
    &mcnlvx,
    &mcnlvy,
    &mcnlvz,
    &mcnlsx,
    &mcnlsy,
    &mcnlsz);
  /* define label inside component channel_5_analyzer_2_array_crystal_array_8 (without coords transformations) */
  mcJumpTrace_channel_5_analyzer_2_array_crystal_array_8:
  SIG_MESSAGE("channel_5_analyzer_2_array_crystal_array_8 (Trace)");
  mcDEBUG_COMP("channel_5_analyzer_2_array_crystal_array_8")
  mcDEBUG_STATE(
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp)
#define x mcnlx
#define y mcnly
#define z mcnlz
#define vx mcnlvx
#define vy mcnlvy
#define vz mcnlvz
#define t mcnlt
#define sx mcnlsx
#define sy mcnlsy
#define sz mcnlsz
#define p mcnlp

#define mcabsorbComp mcabsorbCompchannel_5_analyzer_2_array_crystal_array_8
  STORE_NEUTRON(339,
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp);
  mcScattered=0;
  mcRestore=0;
  mcNCounter[339]++;
  mcPCounter[339] += p;
  mcP2Counter[339] += p*p;
#define mccompcurname  channel_5_analyzer_2_array_crystal_array_8
#define mccompcurtype  Union_box
#define mccompcurindex 339
#define loop_index mccchannel_5_analyzer_2_array_crystal_array_8_loop_index
#define this_box_volume mccchannel_5_analyzer_2_array_crystal_array_8_this_box_volume
#define global_geometry_element mccchannel_5_analyzer_2_array_crystal_array_8_global_geometry_element
#define this_box_storage mccchannel_5_analyzer_2_array_crystal_array_8_this_box_storage
{   /* Declarations of channel_5_analyzer_2_array_crystal_array_8=Union_box() SETTING parameters. */
char* material_string = mccchannel_5_analyzer_2_array_crystal_array_8_material_string;
MCNUM priority = mccchannel_5_analyzer_2_array_crystal_array_8_priority;
MCNUM xwidth = mccchannel_5_analyzer_2_array_crystal_array_8_xwidth;
MCNUM yheight = mccchannel_5_analyzer_2_array_crystal_array_8_yheight;
MCNUM zdepth = mccchannel_5_analyzer_2_array_crystal_array_8_zdepth;
MCNUM xwidth2 = mccchannel_5_analyzer_2_array_crystal_array_8_xwidth2;
MCNUM yheight2 = mccchannel_5_analyzer_2_array_crystal_array_8_yheight2;
MCNUM visualize = mccchannel_5_analyzer_2_array_crystal_array_8_visualize;
int target_index = mccchannel_5_analyzer_2_array_crystal_array_8_target_index;
MCNUM target_x = mccchannel_5_analyzer_2_array_crystal_array_8_target_x;
MCNUM target_y = mccchannel_5_analyzer_2_array_crystal_array_8_target_y;
MCNUM target_z = mccchannel_5_analyzer_2_array_crystal_array_8_target_z;
MCNUM focus_aw = mccchannel_5_analyzer_2_array_crystal_array_8_focus_aw;
MCNUM focus_ah = mccchannel_5_analyzer_2_array_crystal_array_8_focus_ah;
MCNUM focus_xw = mccchannel_5_analyzer_2_array_crystal_array_8_focus_xw;
MCNUM focus_xh = mccchannel_5_analyzer_2_array_crystal_array_8_focus_xh;
MCNUM focus_r = mccchannel_5_analyzer_2_array_crystal_array_8_focus_r;
MCNUM p_interact = mccchannel_5_analyzer_2_array_crystal_array_8_p_interact;
char* mask_string = mccchannel_5_analyzer_2_array_crystal_array_8_mask_string;
char* mask_setting = mccchannel_5_analyzer_2_array_crystal_array_8_mask_setting;
MCNUM number_of_activations = mccchannel_5_analyzer_2_array_crystal_array_8_number_of_activations;
}   /* End of channel_5_analyzer_2_array_crystal_array_8=Union_box() SETTING parameter declarations. */
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex
  /* Label for restoring  neutron */
  mcabsorbCompchannel_5_analyzer_2_array_crystal_array_8:
  if (RESTORE) /* restore if needed */
  { RESTORE_NEUTRON(339,
      mcnlx,
      mcnly,
      mcnlz,
      mcnlvx,
      mcnlvy,
      mcnlvz,
      mcnlt,
      mcnlsx,
      mcnlsy,
      mcnlsz,
      mcnlp); }
#undef mcabsorbComp
#undef p
#undef sz
#undef sy
#undef sx
#undef t
#undef vz
#undef vy
#undef vx
#undef z
#undef y
#undef x
  mcDEBUG_STATE(
mcnlx,
mcnly,
mcnlz,
mcnlvx,
mcnlvy,
mcnlvz,
mcnlt,
mcnlsx,
mcnlsy,
mcnlsz,
mcnlp)

  /* TRACE Component channel_5_cave2_cyl1 [340] */
  mccoordschange(mcposrchannel_5_cave2_cyl1, mcrotrchannel_5_cave2_cyl1,
    &mcnlx,
    &mcnly,
    &mcnlz,
    &mcnlvx,
    &mcnlvy,
    &mcnlvz,
    &mcnlsx,
    &mcnlsy,
    &mcnlsz);
  /* define label inside component channel_5_cave2_cyl1 (without coords transformations) */
  mcJumpTrace_channel_5_cave2_cyl1:
  SIG_MESSAGE("channel_5_cave2_cyl1 (Trace)");
  mcDEBUG_COMP("channel_5_cave2_cyl1")
  mcDEBUG_STATE(
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp)
#define x mcnlx
#define y mcnly
#define z mcnlz
#define vx mcnlvx
#define vy mcnlvy
#define vz mcnlvz
#define t mcnlt
#define sx mcnlsx
#define sy mcnlsy
#define sz mcnlsz
#define p mcnlp

#define mcabsorbComp mcabsorbCompchannel_5_cave2_cyl1
  STORE_NEUTRON(340,
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp);
  mcScattered=0;
  mcRestore=0;
  mcNCounter[340]++;
  mcPCounter[340] += p;
  mcP2Counter[340] += p*p;
#define mccompcurname  channel_5_cave2_cyl1
#define mccompcurtype  Union_cylinder
#define mccompcurindex 340
#define loop_index mccchannel_5_cave2_cyl1_loop_index
#define this_cylinder_volume mccchannel_5_cave2_cyl1_this_cylinder_volume
#define global_geometry_element mccchannel_5_cave2_cyl1_global_geometry_element
#define this_cylinder_storage mccchannel_5_cave2_cyl1_this_cylinder_storage
{   /* Declarations of channel_5_cave2_cyl1=Union_cylinder() SETTING parameters. */
char* material_string = mccchannel_5_cave2_cyl1_material_string;
MCNUM priority = mccchannel_5_cave2_cyl1_priority;
MCNUM radius = mccchannel_5_cave2_cyl1_radius;
MCNUM yheight = mccchannel_5_cave2_cyl1_yheight;
MCNUM visualize = mccchannel_5_cave2_cyl1_visualize;
int target_index = mccchannel_5_cave2_cyl1_target_index;
MCNUM target_x = mccchannel_5_cave2_cyl1_target_x;
MCNUM target_y = mccchannel_5_cave2_cyl1_target_y;
MCNUM target_z = mccchannel_5_cave2_cyl1_target_z;
MCNUM focus_aw = mccchannel_5_cave2_cyl1_focus_aw;
MCNUM focus_ah = mccchannel_5_cave2_cyl1_focus_ah;
MCNUM focus_xw = mccchannel_5_cave2_cyl1_focus_xw;
MCNUM focus_xh = mccchannel_5_cave2_cyl1_focus_xh;
MCNUM focus_r = mccchannel_5_cave2_cyl1_focus_r;
MCNUM p_interact = mccchannel_5_cave2_cyl1_p_interact;
char* mask_string = mccchannel_5_cave2_cyl1_mask_string;
char* mask_setting = mccchannel_5_cave2_cyl1_mask_setting;
MCNUM number_of_activations = mccchannel_5_cave2_cyl1_number_of_activations;
#line 345 "Union_cylinder.comp"
{
dummy = 1;
}
#line 390723 "MACS_sample_kidney_box.c"
}   /* End of channel_5_cave2_cyl1=Union_cylinder() SETTING parameter declarations. */
#undef this_cylinder_storage
#undef global_geometry_element
#undef this_cylinder_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex
  /* Label for restoring  neutron */
  mcabsorbCompchannel_5_cave2_cyl1:
  if (RESTORE) /* restore if needed */
  { RESTORE_NEUTRON(340,
      mcnlx,
      mcnly,
      mcnlz,
      mcnlvx,
      mcnlvy,
      mcnlvz,
      mcnlt,
      mcnlsx,
      mcnlsy,
      mcnlsz,
      mcnlp); }
#undef mcabsorbComp
#undef p
#undef sz
#undef sy
#undef sx
#undef t
#undef vz
#undef vy
#undef vx
#undef z
#undef y
#undef x
  mcDEBUG_STATE(
mcnlx,
mcnly,
mcnlz,
mcnlvx,
mcnlvy,
mcnlvz,
mcnlt,
mcnlsx,
mcnlsy,
mcnlsz,
mcnlp)

  /* TRACE Component channel_5_cave2_box1 [341] */
  mccoordschange(mcposrchannel_5_cave2_box1, mcrotrchannel_5_cave2_box1,
    &mcnlx,
    &mcnly,
    &mcnlz,
    &mcnlvx,
    &mcnlvy,
    &mcnlvz,
    &mcnlsx,
    &mcnlsy,
    &mcnlsz);
  /* define label inside component channel_5_cave2_box1 (without coords transformations) */
  mcJumpTrace_channel_5_cave2_box1:
  SIG_MESSAGE("channel_5_cave2_box1 (Trace)");
  mcDEBUG_COMP("channel_5_cave2_box1")
  mcDEBUG_STATE(
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp)
#define x mcnlx
#define y mcnly
#define z mcnlz
#define vx mcnlvx
#define vy mcnlvy
#define vz mcnlvz
#define t mcnlt
#define sx mcnlsx
#define sy mcnlsy
#define sz mcnlsz
#define p mcnlp

#define mcabsorbComp mcabsorbCompchannel_5_cave2_box1
  STORE_NEUTRON(341,
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp);
  mcScattered=0;
  mcRestore=0;
  mcNCounter[341]++;
  mcPCounter[341] += p;
  mcP2Counter[341] += p*p;
#define mccompcurname  channel_5_cave2_box1
#define mccompcurtype  Union_box
#define mccompcurindex 341
#define loop_index mccchannel_5_cave2_box1_loop_index
#define this_box_volume mccchannel_5_cave2_box1_this_box_volume
#define global_geometry_element mccchannel_5_cave2_box1_global_geometry_element
#define this_box_storage mccchannel_5_cave2_box1_this_box_storage
{   /* Declarations of channel_5_cave2_box1=Union_box() SETTING parameters. */
char* material_string = mccchannel_5_cave2_box1_material_string;
MCNUM priority = mccchannel_5_cave2_box1_priority;
MCNUM xwidth = mccchannel_5_cave2_box1_xwidth;
MCNUM yheight = mccchannel_5_cave2_box1_yheight;
MCNUM zdepth = mccchannel_5_cave2_box1_zdepth;
MCNUM xwidth2 = mccchannel_5_cave2_box1_xwidth2;
MCNUM yheight2 = mccchannel_5_cave2_box1_yheight2;
MCNUM visualize = mccchannel_5_cave2_box1_visualize;
int target_index = mccchannel_5_cave2_box1_target_index;
MCNUM target_x = mccchannel_5_cave2_box1_target_x;
MCNUM target_y = mccchannel_5_cave2_box1_target_y;
MCNUM target_z = mccchannel_5_cave2_box1_target_z;
MCNUM focus_aw = mccchannel_5_cave2_box1_focus_aw;
MCNUM focus_ah = mccchannel_5_cave2_box1_focus_ah;
MCNUM focus_xw = mccchannel_5_cave2_box1_focus_xw;
MCNUM focus_xh = mccchannel_5_cave2_box1_focus_xh;
MCNUM focus_r = mccchannel_5_cave2_box1_focus_r;
MCNUM p_interact = mccchannel_5_cave2_box1_p_interact;
char* mask_string = mccchannel_5_cave2_box1_mask_string;
char* mask_setting = mccchannel_5_cave2_box1_mask_setting;
MCNUM number_of_activations = mccchannel_5_cave2_box1_number_of_activations;
}   /* End of channel_5_cave2_box1=Union_box() SETTING parameter declarations. */
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex
  /* Label for restoring  neutron */
  mcabsorbCompchannel_5_cave2_box1:
  if (RESTORE) /* restore if needed */
  { RESTORE_NEUTRON(341,
      mcnlx,
      mcnly,
      mcnlz,
      mcnlvx,
      mcnlvy,
      mcnlvz,
      mcnlt,
      mcnlsx,
      mcnlsy,
      mcnlsz,
      mcnlp); }
#undef mcabsorbComp
#undef p
#undef sz
#undef sy
#undef sx
#undef t
#undef vz
#undef vy
#undef vx
#undef z
#undef y
#undef x
  mcDEBUG_STATE(
mcnlx,
mcnly,
mcnlz,
mcnlvx,
mcnlvy,
mcnlvz,
mcnlt,
mcnlsx,
mcnlsy,
mcnlsz,
mcnlp)

  /* TRACE Component channel_5_cave2_box2 [342] */
  mccoordschange(mcposrchannel_5_cave2_box2, mcrotrchannel_5_cave2_box2,
    &mcnlx,
    &mcnly,
    &mcnlz,
    &mcnlvx,
    &mcnlvy,
    &mcnlvz,
    &mcnlsx,
    &mcnlsy,
    &mcnlsz);
  /* define label inside component channel_5_cave2_box2 (without coords transformations) */
  mcJumpTrace_channel_5_cave2_box2:
  SIG_MESSAGE("channel_5_cave2_box2 (Trace)");
  mcDEBUG_COMP("channel_5_cave2_box2")
  mcDEBUG_STATE(
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp)
#define x mcnlx
#define y mcnly
#define z mcnlz
#define vx mcnlvx
#define vy mcnlvy
#define vz mcnlvz
#define t mcnlt
#define sx mcnlsx
#define sy mcnlsy
#define sz mcnlsz
#define p mcnlp

#define mcabsorbComp mcabsorbCompchannel_5_cave2_box2
  STORE_NEUTRON(342,
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp);
  mcScattered=0;
  mcRestore=0;
  mcNCounter[342]++;
  mcPCounter[342] += p;
  mcP2Counter[342] += p*p;
#define mccompcurname  channel_5_cave2_box2
#define mccompcurtype  Union_box
#define mccompcurindex 342
#define loop_index mccchannel_5_cave2_box2_loop_index
#define this_box_volume mccchannel_5_cave2_box2_this_box_volume
#define global_geometry_element mccchannel_5_cave2_box2_global_geometry_element
#define this_box_storage mccchannel_5_cave2_box2_this_box_storage
{   /* Declarations of channel_5_cave2_box2=Union_box() SETTING parameters. */
char* material_string = mccchannel_5_cave2_box2_material_string;
MCNUM priority = mccchannel_5_cave2_box2_priority;
MCNUM xwidth = mccchannel_5_cave2_box2_xwidth;
MCNUM yheight = mccchannel_5_cave2_box2_yheight;
MCNUM zdepth = mccchannel_5_cave2_box2_zdepth;
MCNUM xwidth2 = mccchannel_5_cave2_box2_xwidth2;
MCNUM yheight2 = mccchannel_5_cave2_box2_yheight2;
MCNUM visualize = mccchannel_5_cave2_box2_visualize;
int target_index = mccchannel_5_cave2_box2_target_index;
MCNUM target_x = mccchannel_5_cave2_box2_target_x;
MCNUM target_y = mccchannel_5_cave2_box2_target_y;
MCNUM target_z = mccchannel_5_cave2_box2_target_z;
MCNUM focus_aw = mccchannel_5_cave2_box2_focus_aw;
MCNUM focus_ah = mccchannel_5_cave2_box2_focus_ah;
MCNUM focus_xw = mccchannel_5_cave2_box2_focus_xw;
MCNUM focus_xh = mccchannel_5_cave2_box2_focus_xh;
MCNUM focus_r = mccchannel_5_cave2_box2_focus_r;
MCNUM p_interact = mccchannel_5_cave2_box2_p_interact;
char* mask_string = mccchannel_5_cave2_box2_mask_string;
char* mask_setting = mccchannel_5_cave2_box2_mask_setting;
MCNUM number_of_activations = mccchannel_5_cave2_box2_number_of_activations;
}   /* End of channel_5_cave2_box2=Union_box() SETTING parameter declarations. */
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex
  /* Label for restoring  neutron */
  mcabsorbCompchannel_5_cave2_box2:
  if (RESTORE) /* restore if needed */
  { RESTORE_NEUTRON(342,
      mcnlx,
      mcnly,
      mcnlz,
      mcnlvx,
      mcnlvy,
      mcnlvz,
      mcnlt,
      mcnlsx,
      mcnlsy,
      mcnlsz,
      mcnlp); }
#undef mcabsorbComp
#undef p
#undef sz
#undef sy
#undef sx
#undef t
#undef vz
#undef vy
#undef vx
#undef z
#undef y
#undef x
  mcDEBUG_STATE(
mcnlx,
mcnly,
mcnlz,
mcnlvx,
mcnlvy,
mcnlvz,
mcnlt,
mcnlsx,
mcnlsy,
mcnlsz,
mcnlp)

  /* TRACE Component channel_5_cave2_box3 [343] */
  mccoordschange(mcposrchannel_5_cave2_box3, mcrotrchannel_5_cave2_box3,
    &mcnlx,
    &mcnly,
    &mcnlz,
    &mcnlvx,
    &mcnlvy,
    &mcnlvz,
    &mcnlsx,
    &mcnlsy,
    &mcnlsz);
  /* define label inside component channel_5_cave2_box3 (without coords transformations) */
  mcJumpTrace_channel_5_cave2_box3:
  SIG_MESSAGE("channel_5_cave2_box3 (Trace)");
  mcDEBUG_COMP("channel_5_cave2_box3")
  mcDEBUG_STATE(
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp)
#define x mcnlx
#define y mcnly
#define z mcnlz
#define vx mcnlvx
#define vy mcnlvy
#define vz mcnlvz
#define t mcnlt
#define sx mcnlsx
#define sy mcnlsy
#define sz mcnlsz
#define p mcnlp

#define mcabsorbComp mcabsorbCompchannel_5_cave2_box3
  STORE_NEUTRON(343,
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp);
  mcScattered=0;
  mcRestore=0;
  mcNCounter[343]++;
  mcPCounter[343] += p;
  mcP2Counter[343] += p*p;
#define mccompcurname  channel_5_cave2_box3
#define mccompcurtype  Union_box
#define mccompcurindex 343
#define loop_index mccchannel_5_cave2_box3_loop_index
#define this_box_volume mccchannel_5_cave2_box3_this_box_volume
#define global_geometry_element mccchannel_5_cave2_box3_global_geometry_element
#define this_box_storage mccchannel_5_cave2_box3_this_box_storage
{   /* Declarations of channel_5_cave2_box3=Union_box() SETTING parameters. */
char* material_string = mccchannel_5_cave2_box3_material_string;
MCNUM priority = mccchannel_5_cave2_box3_priority;
MCNUM xwidth = mccchannel_5_cave2_box3_xwidth;
MCNUM yheight = mccchannel_5_cave2_box3_yheight;
MCNUM zdepth = mccchannel_5_cave2_box3_zdepth;
MCNUM xwidth2 = mccchannel_5_cave2_box3_xwidth2;
MCNUM yheight2 = mccchannel_5_cave2_box3_yheight2;
MCNUM visualize = mccchannel_5_cave2_box3_visualize;
int target_index = mccchannel_5_cave2_box3_target_index;
MCNUM target_x = mccchannel_5_cave2_box3_target_x;
MCNUM target_y = mccchannel_5_cave2_box3_target_y;
MCNUM target_z = mccchannel_5_cave2_box3_target_z;
MCNUM focus_aw = mccchannel_5_cave2_box3_focus_aw;
MCNUM focus_ah = mccchannel_5_cave2_box3_focus_ah;
MCNUM focus_xw = mccchannel_5_cave2_box3_focus_xw;
MCNUM focus_xh = mccchannel_5_cave2_box3_focus_xh;
MCNUM focus_r = mccchannel_5_cave2_box3_focus_r;
MCNUM p_interact = mccchannel_5_cave2_box3_p_interact;
char* mask_string = mccchannel_5_cave2_box3_mask_string;
char* mask_setting = mccchannel_5_cave2_box3_mask_setting;
MCNUM number_of_activations = mccchannel_5_cave2_box3_number_of_activations;
}   /* End of channel_5_cave2_box3=Union_box() SETTING parameter declarations. */
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex
  /* Label for restoring  neutron */
  mcabsorbCompchannel_5_cave2_box3:
  if (RESTORE) /* restore if needed */
  { RESTORE_NEUTRON(343,
      mcnlx,
      mcnly,
      mcnlz,
      mcnlvx,
      mcnlvy,
      mcnlvz,
      mcnlt,
      mcnlsx,
      mcnlsy,
      mcnlsz,
      mcnlp); }
#undef mcabsorbComp
#undef p
#undef sz
#undef sy
#undef sx
#undef t
#undef vz
#undef vy
#undef vx
#undef z
#undef y
#undef x
  mcDEBUG_STATE(
mcnlx,
mcnly,
mcnlz,
mcnlvx,
mcnlvy,
mcnlvz,
mcnlt,
mcnlsx,
mcnlsy,
mcnlsz,
mcnlp)

  /* TRACE Component inter_analyzer_colimator_center_5 [344] */
  mccoordschange(mcposrinter_analyzer_colimator_center_5, mcrotrinter_analyzer_colimator_center_5,
    &mcnlx,
    &mcnly,
    &mcnlz,
    &mcnlvx,
    &mcnlvy,
    &mcnlvz,
    &mcnlsx,
    &mcnlsy,
    &mcnlsz);
  /* define label inside component inter_analyzer_colimator_center_5 (without coords transformations) */
  mcJumpTrace_inter_analyzer_colimator_center_5:
  SIG_MESSAGE("inter_analyzer_colimator_center_5 (Trace)");
  mcDEBUG_COMP("inter_analyzer_colimator_center_5")
  mcDEBUG_STATE(
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp)
#define x mcnlx
#define y mcnly
#define z mcnlz
#define vx mcnlvx
#define vy mcnlvy
#define vz mcnlvz
#define t mcnlt
#define sx mcnlsx
#define sy mcnlsy
#define sz mcnlsz
#define p mcnlp

#define mcabsorbComp mcabsorbCompinter_analyzer_colimator_center_5
  STORE_NEUTRON(344,
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp);
  mcScattered=0;
  mcRestore=0;
  mcNCounter[344]++;
  mcPCounter[344] += p;
  mcP2Counter[344] += p*p;
#define mccompcurname  inter_analyzer_colimator_center_5
#define mccompcurtype  Arm
#define mccompcurindex 344
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex
  /* Label for restoring  neutron */
  mcabsorbCompinter_analyzer_colimator_center_5:
  if (RESTORE) /* restore if needed */
  { RESTORE_NEUTRON(344,
      mcnlx,
      mcnly,
      mcnlz,
      mcnlvx,
      mcnlvy,
      mcnlvz,
      mcnlt,
      mcnlsx,
      mcnlsy,
      mcnlsz,
      mcnlp); }
#undef mcabsorbComp
#undef p
#undef sz
#undef sy
#undef sx
#undef t
#undef vz
#undef vy
#undef vx
#undef z
#undef y
#undef x
  mcDEBUG_STATE(
mcnlx,
mcnly,
mcnlz,
mcnlvx,
mcnlvy,
mcnlvz,
mcnlt,
mcnlsx,
mcnlsy,
mcnlsz,
mcnlp)

  /* TRACE Component inter_analyzer_colimator_5_blade_0 [345] */
  mccoordschange(mcposrinter_analyzer_colimator_5_blade_0, mcrotrinter_analyzer_colimator_5_blade_0,
    &mcnlx,
    &mcnly,
    &mcnlz,
    &mcnlvx,
    &mcnlvy,
    &mcnlvz,
    &mcnlsx,
    &mcnlsy,
    &mcnlsz);
  /* define label inside component inter_analyzer_colimator_5_blade_0 (without coords transformations) */
  mcJumpTrace_inter_analyzer_colimator_5_blade_0:
  SIG_MESSAGE("inter_analyzer_colimator_5_blade_0 (Trace)");
  mcDEBUG_COMP("inter_analyzer_colimator_5_blade_0")
  mcDEBUG_STATE(
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp)
#define x mcnlx
#define y mcnly
#define z mcnlz
#define vx mcnlvx
#define vy mcnlvy
#define vz mcnlvz
#define t mcnlt
#define sx mcnlsx
#define sy mcnlsy
#define sz mcnlsz
#define p mcnlp

#define mcabsorbComp mcabsorbCompinter_analyzer_colimator_5_blade_0
  STORE_NEUTRON(345,
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp);
  mcScattered=0;
  mcRestore=0;
  mcNCounter[345]++;
  mcPCounter[345] += p;
  mcP2Counter[345] += p*p;
#define mccompcurname  inter_analyzer_colimator_5_blade_0
#define mccompcurtype  Union_box
#define mccompcurindex 345
#define loop_index mccinter_analyzer_colimator_5_blade_0_loop_index
#define this_box_volume mccinter_analyzer_colimator_5_blade_0_this_box_volume
#define global_geometry_element mccinter_analyzer_colimator_5_blade_0_global_geometry_element
#define this_box_storage mccinter_analyzer_colimator_5_blade_0_this_box_storage
{   /* Declarations of inter_analyzer_colimator_5_blade_0=Union_box() SETTING parameters. */
char* material_string = mccinter_analyzer_colimator_5_blade_0_material_string;
MCNUM priority = mccinter_analyzer_colimator_5_blade_0_priority;
MCNUM xwidth = mccinter_analyzer_colimator_5_blade_0_xwidth;
MCNUM yheight = mccinter_analyzer_colimator_5_blade_0_yheight;
MCNUM zdepth = mccinter_analyzer_colimator_5_blade_0_zdepth;
MCNUM xwidth2 = mccinter_analyzer_colimator_5_blade_0_xwidth2;
MCNUM yheight2 = mccinter_analyzer_colimator_5_blade_0_yheight2;
MCNUM visualize = mccinter_analyzer_colimator_5_blade_0_visualize;
int target_index = mccinter_analyzer_colimator_5_blade_0_target_index;
MCNUM target_x = mccinter_analyzer_colimator_5_blade_0_target_x;
MCNUM target_y = mccinter_analyzer_colimator_5_blade_0_target_y;
MCNUM target_z = mccinter_analyzer_colimator_5_blade_0_target_z;
MCNUM focus_aw = mccinter_analyzer_colimator_5_blade_0_focus_aw;
MCNUM focus_ah = mccinter_analyzer_colimator_5_blade_0_focus_ah;
MCNUM focus_xw = mccinter_analyzer_colimator_5_blade_0_focus_xw;
MCNUM focus_xh = mccinter_analyzer_colimator_5_blade_0_focus_xh;
MCNUM focus_r = mccinter_analyzer_colimator_5_blade_0_focus_r;
MCNUM p_interact = mccinter_analyzer_colimator_5_blade_0_p_interact;
char* mask_string = mccinter_analyzer_colimator_5_blade_0_mask_string;
char* mask_setting = mccinter_analyzer_colimator_5_blade_0_mask_setting;
MCNUM number_of_activations = mccinter_analyzer_colimator_5_blade_0_number_of_activations;
}   /* End of inter_analyzer_colimator_5_blade_0=Union_box() SETTING parameter declarations. */
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex
  /* Label for restoring  neutron */
  mcabsorbCompinter_analyzer_colimator_5_blade_0:
  if (RESTORE) /* restore if needed */
  { RESTORE_NEUTRON(345,
      mcnlx,
      mcnly,
      mcnlz,
      mcnlvx,
      mcnlvy,
      mcnlvz,
      mcnlt,
      mcnlsx,
      mcnlsy,
      mcnlsz,
      mcnlp); }
#undef mcabsorbComp
#undef p
#undef sz
#undef sy
#undef sx
#undef t
#undef vz
#undef vy
#undef vx
#undef z
#undef y
#undef x
  mcDEBUG_STATE(
mcnlx,
mcnly,
mcnlz,
mcnlvx,
mcnlvy,
mcnlvz,
mcnlt,
mcnlsx,
mcnlsy,
mcnlsz,
mcnlp)

  /* TRACE Component inter_analyzer_colimator_5_blade_1 [346] */
  mccoordschange(mcposrinter_analyzer_colimator_5_blade_1, mcrotrinter_analyzer_colimator_5_blade_1,
    &mcnlx,
    &mcnly,
    &mcnlz,
    &mcnlvx,
    &mcnlvy,
    &mcnlvz,
    &mcnlsx,
    &mcnlsy,
    &mcnlsz);
  /* define label inside component inter_analyzer_colimator_5_blade_1 (without coords transformations) */
  mcJumpTrace_inter_analyzer_colimator_5_blade_1:
  SIG_MESSAGE("inter_analyzer_colimator_5_blade_1 (Trace)");
  mcDEBUG_COMP("inter_analyzer_colimator_5_blade_1")
  mcDEBUG_STATE(
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp)
#define x mcnlx
#define y mcnly
#define z mcnlz
#define vx mcnlvx
#define vy mcnlvy
#define vz mcnlvz
#define t mcnlt
#define sx mcnlsx
#define sy mcnlsy
#define sz mcnlsz
#define p mcnlp

#define mcabsorbComp mcabsorbCompinter_analyzer_colimator_5_blade_1
  STORE_NEUTRON(346,
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp);
  mcScattered=0;
  mcRestore=0;
  mcNCounter[346]++;
  mcPCounter[346] += p;
  mcP2Counter[346] += p*p;
#define mccompcurname  inter_analyzer_colimator_5_blade_1
#define mccompcurtype  Union_box
#define mccompcurindex 346
#define loop_index mccinter_analyzer_colimator_5_blade_1_loop_index
#define this_box_volume mccinter_analyzer_colimator_5_blade_1_this_box_volume
#define global_geometry_element mccinter_analyzer_colimator_5_blade_1_global_geometry_element
#define this_box_storage mccinter_analyzer_colimator_5_blade_1_this_box_storage
{   /* Declarations of inter_analyzer_colimator_5_blade_1=Union_box() SETTING parameters. */
char* material_string = mccinter_analyzer_colimator_5_blade_1_material_string;
MCNUM priority = mccinter_analyzer_colimator_5_blade_1_priority;
MCNUM xwidth = mccinter_analyzer_colimator_5_blade_1_xwidth;
MCNUM yheight = mccinter_analyzer_colimator_5_blade_1_yheight;
MCNUM zdepth = mccinter_analyzer_colimator_5_blade_1_zdepth;
MCNUM xwidth2 = mccinter_analyzer_colimator_5_blade_1_xwidth2;
MCNUM yheight2 = mccinter_analyzer_colimator_5_blade_1_yheight2;
MCNUM visualize = mccinter_analyzer_colimator_5_blade_1_visualize;
int target_index = mccinter_analyzer_colimator_5_blade_1_target_index;
MCNUM target_x = mccinter_analyzer_colimator_5_blade_1_target_x;
MCNUM target_y = mccinter_analyzer_colimator_5_blade_1_target_y;
MCNUM target_z = mccinter_analyzer_colimator_5_blade_1_target_z;
MCNUM focus_aw = mccinter_analyzer_colimator_5_blade_1_focus_aw;
MCNUM focus_ah = mccinter_analyzer_colimator_5_blade_1_focus_ah;
MCNUM focus_xw = mccinter_analyzer_colimator_5_blade_1_focus_xw;
MCNUM focus_xh = mccinter_analyzer_colimator_5_blade_1_focus_xh;
MCNUM focus_r = mccinter_analyzer_colimator_5_blade_1_focus_r;
MCNUM p_interact = mccinter_analyzer_colimator_5_blade_1_p_interact;
char* mask_string = mccinter_analyzer_colimator_5_blade_1_mask_string;
char* mask_setting = mccinter_analyzer_colimator_5_blade_1_mask_setting;
MCNUM number_of_activations = mccinter_analyzer_colimator_5_blade_1_number_of_activations;
}   /* End of inter_analyzer_colimator_5_blade_1=Union_box() SETTING parameter declarations. */
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex
  /* Label for restoring  neutron */
  mcabsorbCompinter_analyzer_colimator_5_blade_1:
  if (RESTORE) /* restore if needed */
  { RESTORE_NEUTRON(346,
      mcnlx,
      mcnly,
      mcnlz,
      mcnlvx,
      mcnlvy,
      mcnlvz,
      mcnlt,
      mcnlsx,
      mcnlsy,
      mcnlsz,
      mcnlp); }
#undef mcabsorbComp
#undef p
#undef sz
#undef sy
#undef sx
#undef t
#undef vz
#undef vy
#undef vx
#undef z
#undef y
#undef x
  mcDEBUG_STATE(
mcnlx,
mcnly,
mcnlz,
mcnlvx,
mcnlvy,
mcnlvz,
mcnlt,
mcnlsx,
mcnlsy,
mcnlsz,
mcnlp)

  /* TRACE Component inter_analyzer_colimator_5_blade_2 [347] */
  mccoordschange(mcposrinter_analyzer_colimator_5_blade_2, mcrotrinter_analyzer_colimator_5_blade_2,
    &mcnlx,
    &mcnly,
    &mcnlz,
    &mcnlvx,
    &mcnlvy,
    &mcnlvz,
    &mcnlsx,
    &mcnlsy,
    &mcnlsz);
  /* define label inside component inter_analyzer_colimator_5_blade_2 (without coords transformations) */
  mcJumpTrace_inter_analyzer_colimator_5_blade_2:
  SIG_MESSAGE("inter_analyzer_colimator_5_blade_2 (Trace)");
  mcDEBUG_COMP("inter_analyzer_colimator_5_blade_2")
  mcDEBUG_STATE(
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp)
#define x mcnlx
#define y mcnly
#define z mcnlz
#define vx mcnlvx
#define vy mcnlvy
#define vz mcnlvz
#define t mcnlt
#define sx mcnlsx
#define sy mcnlsy
#define sz mcnlsz
#define p mcnlp

#define mcabsorbComp mcabsorbCompinter_analyzer_colimator_5_blade_2
  STORE_NEUTRON(347,
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp);
  mcScattered=0;
  mcRestore=0;
  mcNCounter[347]++;
  mcPCounter[347] += p;
  mcP2Counter[347] += p*p;
#define mccompcurname  inter_analyzer_colimator_5_blade_2
#define mccompcurtype  Union_box
#define mccompcurindex 347
#define loop_index mccinter_analyzer_colimator_5_blade_2_loop_index
#define this_box_volume mccinter_analyzer_colimator_5_blade_2_this_box_volume
#define global_geometry_element mccinter_analyzer_colimator_5_blade_2_global_geometry_element
#define this_box_storage mccinter_analyzer_colimator_5_blade_2_this_box_storage
{   /* Declarations of inter_analyzer_colimator_5_blade_2=Union_box() SETTING parameters. */
char* material_string = mccinter_analyzer_colimator_5_blade_2_material_string;
MCNUM priority = mccinter_analyzer_colimator_5_blade_2_priority;
MCNUM xwidth = mccinter_analyzer_colimator_5_blade_2_xwidth;
MCNUM yheight = mccinter_analyzer_colimator_5_blade_2_yheight;
MCNUM zdepth = mccinter_analyzer_colimator_5_blade_2_zdepth;
MCNUM xwidth2 = mccinter_analyzer_colimator_5_blade_2_xwidth2;
MCNUM yheight2 = mccinter_analyzer_colimator_5_blade_2_yheight2;
MCNUM visualize = mccinter_analyzer_colimator_5_blade_2_visualize;
int target_index = mccinter_analyzer_colimator_5_blade_2_target_index;
MCNUM target_x = mccinter_analyzer_colimator_5_blade_2_target_x;
MCNUM target_y = mccinter_analyzer_colimator_5_blade_2_target_y;
MCNUM target_z = mccinter_analyzer_colimator_5_blade_2_target_z;
MCNUM focus_aw = mccinter_analyzer_colimator_5_blade_2_focus_aw;
MCNUM focus_ah = mccinter_analyzer_colimator_5_blade_2_focus_ah;
MCNUM focus_xw = mccinter_analyzer_colimator_5_blade_2_focus_xw;
MCNUM focus_xh = mccinter_analyzer_colimator_5_blade_2_focus_xh;
MCNUM focus_r = mccinter_analyzer_colimator_5_blade_2_focus_r;
MCNUM p_interact = mccinter_analyzer_colimator_5_blade_2_p_interact;
char* mask_string = mccinter_analyzer_colimator_5_blade_2_mask_string;
char* mask_setting = mccinter_analyzer_colimator_5_blade_2_mask_setting;
MCNUM number_of_activations = mccinter_analyzer_colimator_5_blade_2_number_of_activations;
}   /* End of inter_analyzer_colimator_5_blade_2=Union_box() SETTING parameter declarations. */
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex
  /* Label for restoring  neutron */
  mcabsorbCompinter_analyzer_colimator_5_blade_2:
  if (RESTORE) /* restore if needed */
  { RESTORE_NEUTRON(347,
      mcnlx,
      mcnly,
      mcnlz,
      mcnlvx,
      mcnlvy,
      mcnlvz,
      mcnlt,
      mcnlsx,
      mcnlsy,
      mcnlsz,
      mcnlp); }
#undef mcabsorbComp
#undef p
#undef sz
#undef sy
#undef sx
#undef t
#undef vz
#undef vy
#undef vx
#undef z
#undef y
#undef x
  mcDEBUG_STATE(
mcnlx,
mcnly,
mcnlz,
mcnlvx,
mcnlvy,
mcnlvz,
mcnlt,
mcnlsx,
mcnlsy,
mcnlsz,
mcnlp)

  /* TRACE Component inter_analyzer_colimator_5_blade_3 [348] */
  mccoordschange(mcposrinter_analyzer_colimator_5_blade_3, mcrotrinter_analyzer_colimator_5_blade_3,
    &mcnlx,
    &mcnly,
    &mcnlz,
    &mcnlvx,
    &mcnlvy,
    &mcnlvz,
    &mcnlsx,
    &mcnlsy,
    &mcnlsz);
  /* define label inside component inter_analyzer_colimator_5_blade_3 (without coords transformations) */
  mcJumpTrace_inter_analyzer_colimator_5_blade_3:
  SIG_MESSAGE("inter_analyzer_colimator_5_blade_3 (Trace)");
  mcDEBUG_COMP("inter_analyzer_colimator_5_blade_3")
  mcDEBUG_STATE(
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp)
#define x mcnlx
#define y mcnly
#define z mcnlz
#define vx mcnlvx
#define vy mcnlvy
#define vz mcnlvz
#define t mcnlt
#define sx mcnlsx
#define sy mcnlsy
#define sz mcnlsz
#define p mcnlp

#define mcabsorbComp mcabsorbCompinter_analyzer_colimator_5_blade_3
  STORE_NEUTRON(348,
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp);
  mcScattered=0;
  mcRestore=0;
  mcNCounter[348]++;
  mcPCounter[348] += p;
  mcP2Counter[348] += p*p;
#define mccompcurname  inter_analyzer_colimator_5_blade_3
#define mccompcurtype  Union_box
#define mccompcurindex 348
#define loop_index mccinter_analyzer_colimator_5_blade_3_loop_index
#define this_box_volume mccinter_analyzer_colimator_5_blade_3_this_box_volume
#define global_geometry_element mccinter_analyzer_colimator_5_blade_3_global_geometry_element
#define this_box_storage mccinter_analyzer_colimator_5_blade_3_this_box_storage
{   /* Declarations of inter_analyzer_colimator_5_blade_3=Union_box() SETTING parameters. */
char* material_string = mccinter_analyzer_colimator_5_blade_3_material_string;
MCNUM priority = mccinter_analyzer_colimator_5_blade_3_priority;
MCNUM xwidth = mccinter_analyzer_colimator_5_blade_3_xwidth;
MCNUM yheight = mccinter_analyzer_colimator_5_blade_3_yheight;
MCNUM zdepth = mccinter_analyzer_colimator_5_blade_3_zdepth;
MCNUM xwidth2 = mccinter_analyzer_colimator_5_blade_3_xwidth2;
MCNUM yheight2 = mccinter_analyzer_colimator_5_blade_3_yheight2;
MCNUM visualize = mccinter_analyzer_colimator_5_blade_3_visualize;
int target_index = mccinter_analyzer_colimator_5_blade_3_target_index;
MCNUM target_x = mccinter_analyzer_colimator_5_blade_3_target_x;
MCNUM target_y = mccinter_analyzer_colimator_5_blade_3_target_y;
MCNUM target_z = mccinter_analyzer_colimator_5_blade_3_target_z;
MCNUM focus_aw = mccinter_analyzer_colimator_5_blade_3_focus_aw;
MCNUM focus_ah = mccinter_analyzer_colimator_5_blade_3_focus_ah;
MCNUM focus_xw = mccinter_analyzer_colimator_5_blade_3_focus_xw;
MCNUM focus_xh = mccinter_analyzer_colimator_5_blade_3_focus_xh;
MCNUM focus_r = mccinter_analyzer_colimator_5_blade_3_focus_r;
MCNUM p_interact = mccinter_analyzer_colimator_5_blade_3_p_interact;
char* mask_string = mccinter_analyzer_colimator_5_blade_3_mask_string;
char* mask_setting = mccinter_analyzer_colimator_5_blade_3_mask_setting;
MCNUM number_of_activations = mccinter_analyzer_colimator_5_blade_3_number_of_activations;
}   /* End of inter_analyzer_colimator_5_blade_3=Union_box() SETTING parameter declarations. */
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex
  /* Label for restoring  neutron */
  mcabsorbCompinter_analyzer_colimator_5_blade_3:
  if (RESTORE) /* restore if needed */
  { RESTORE_NEUTRON(348,
      mcnlx,
      mcnly,
      mcnlz,
      mcnlvx,
      mcnlvy,
      mcnlvz,
      mcnlt,
      mcnlsx,
      mcnlsy,
      mcnlsz,
      mcnlp); }
#undef mcabsorbComp
#undef p
#undef sz
#undef sy
#undef sx
#undef t
#undef vz
#undef vy
#undef vx
#undef z
#undef y
#undef x
  mcDEBUG_STATE(
mcnlx,
mcnly,
mcnlz,
mcnlvx,
mcnlvy,
mcnlvz,
mcnlt,
mcnlsx,
mcnlsy,
mcnlsz,
mcnlp)

  /* TRACE Component inter_analyzer_colimator_5_blade_4 [349] */
  mccoordschange(mcposrinter_analyzer_colimator_5_blade_4, mcrotrinter_analyzer_colimator_5_blade_4,
    &mcnlx,
    &mcnly,
    &mcnlz,
    &mcnlvx,
    &mcnlvy,
    &mcnlvz,
    &mcnlsx,
    &mcnlsy,
    &mcnlsz);
  /* define label inside component inter_analyzer_colimator_5_blade_4 (without coords transformations) */
  mcJumpTrace_inter_analyzer_colimator_5_blade_4:
  SIG_MESSAGE("inter_analyzer_colimator_5_blade_4 (Trace)");
  mcDEBUG_COMP("inter_analyzer_colimator_5_blade_4")
  mcDEBUG_STATE(
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp)
#define x mcnlx
#define y mcnly
#define z mcnlz
#define vx mcnlvx
#define vy mcnlvy
#define vz mcnlvz
#define t mcnlt
#define sx mcnlsx
#define sy mcnlsy
#define sz mcnlsz
#define p mcnlp

#define mcabsorbComp mcabsorbCompinter_analyzer_colimator_5_blade_4
  STORE_NEUTRON(349,
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp);
  mcScattered=0;
  mcRestore=0;
  mcNCounter[349]++;
  mcPCounter[349] += p;
  mcP2Counter[349] += p*p;
#define mccompcurname  inter_analyzer_colimator_5_blade_4
#define mccompcurtype  Union_box
#define mccompcurindex 349
#define loop_index mccinter_analyzer_colimator_5_blade_4_loop_index
#define this_box_volume mccinter_analyzer_colimator_5_blade_4_this_box_volume
#define global_geometry_element mccinter_analyzer_colimator_5_blade_4_global_geometry_element
#define this_box_storage mccinter_analyzer_colimator_5_blade_4_this_box_storage
{   /* Declarations of inter_analyzer_colimator_5_blade_4=Union_box() SETTING parameters. */
char* material_string = mccinter_analyzer_colimator_5_blade_4_material_string;
MCNUM priority = mccinter_analyzer_colimator_5_blade_4_priority;
MCNUM xwidth = mccinter_analyzer_colimator_5_blade_4_xwidth;
MCNUM yheight = mccinter_analyzer_colimator_5_blade_4_yheight;
MCNUM zdepth = mccinter_analyzer_colimator_5_blade_4_zdepth;
MCNUM xwidth2 = mccinter_analyzer_colimator_5_blade_4_xwidth2;
MCNUM yheight2 = mccinter_analyzer_colimator_5_blade_4_yheight2;
MCNUM visualize = mccinter_analyzer_colimator_5_blade_4_visualize;
int target_index = mccinter_analyzer_colimator_5_blade_4_target_index;
MCNUM target_x = mccinter_analyzer_colimator_5_blade_4_target_x;
MCNUM target_y = mccinter_analyzer_colimator_5_blade_4_target_y;
MCNUM target_z = mccinter_analyzer_colimator_5_blade_4_target_z;
MCNUM focus_aw = mccinter_analyzer_colimator_5_blade_4_focus_aw;
MCNUM focus_ah = mccinter_analyzer_colimator_5_blade_4_focus_ah;
MCNUM focus_xw = mccinter_analyzer_colimator_5_blade_4_focus_xw;
MCNUM focus_xh = mccinter_analyzer_colimator_5_blade_4_focus_xh;
MCNUM focus_r = mccinter_analyzer_colimator_5_blade_4_focus_r;
MCNUM p_interact = mccinter_analyzer_colimator_5_blade_4_p_interact;
char* mask_string = mccinter_analyzer_colimator_5_blade_4_mask_string;
char* mask_setting = mccinter_analyzer_colimator_5_blade_4_mask_setting;
MCNUM number_of_activations = mccinter_analyzer_colimator_5_blade_4_number_of_activations;
}   /* End of inter_analyzer_colimator_5_blade_4=Union_box() SETTING parameter declarations. */
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex
  /* Label for restoring  neutron */
  mcabsorbCompinter_analyzer_colimator_5_blade_4:
  if (RESTORE) /* restore if needed */
  { RESTORE_NEUTRON(349,
      mcnlx,
      mcnly,
      mcnlz,
      mcnlvx,
      mcnlvy,
      mcnlvz,
      mcnlt,
      mcnlsx,
      mcnlsy,
      mcnlsz,
      mcnlp); }
#undef mcabsorbComp
#undef p
#undef sz
#undef sy
#undef sx
#undef t
#undef vz
#undef vy
#undef vx
#undef z
#undef y
#undef x
  mcDEBUG_STATE(
mcnlx,
mcnly,
mcnlz,
mcnlvx,
mcnlvy,
mcnlvz,
mcnlt,
mcnlsx,
mcnlsy,
mcnlsz,
mcnlp)

  /* TRACE Component diffraction_detector_5_exit_volume [350] */
  mccoordschange(mcposrdiffraction_detector_5_exit_volume, mcrotrdiffraction_detector_5_exit_volume,
    &mcnlx,
    &mcnly,
    &mcnlz,
    &mcnlvx,
    &mcnlvy,
    &mcnlvz,
    &mcnlsx,
    &mcnlsy,
    &mcnlsz);
  /* define label inside component diffraction_detector_5_exit_volume (without coords transformations) */
  mcJumpTrace_diffraction_detector_5_exit_volume:
  SIG_MESSAGE("diffraction_detector_5_exit_volume (Trace)");
  mcDEBUG_COMP("diffraction_detector_5_exit_volume")
  mcDEBUG_STATE(
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp)
#define x mcnlx
#define y mcnly
#define z mcnlz
#define vx mcnlvx
#define vy mcnlvy
#define vz mcnlvz
#define t mcnlt
#define sx mcnlsx
#define sy mcnlsy
#define sz mcnlsz
#define p mcnlp

#define mcabsorbComp mcabsorbCompdiffraction_detector_5_exit_volume
  STORE_NEUTRON(350,
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp);
  mcScattered=0;
  mcRestore=0;
  mcNCounter[350]++;
  mcPCounter[350] += p;
  mcP2Counter[350] += p*p;
#define mccompcurname  diffraction_detector_5_exit_volume
#define mccompcurtype  Union_box
#define mccompcurindex 350
#define loop_index mccdiffraction_detector_5_exit_volume_loop_index
#define this_box_volume mccdiffraction_detector_5_exit_volume_this_box_volume
#define global_geometry_element mccdiffraction_detector_5_exit_volume_global_geometry_element
#define this_box_storage mccdiffraction_detector_5_exit_volume_this_box_storage
{   /* Declarations of diffraction_detector_5_exit_volume=Union_box() SETTING parameters. */
char* material_string = mccdiffraction_detector_5_exit_volume_material_string;
MCNUM priority = mccdiffraction_detector_5_exit_volume_priority;
MCNUM xwidth = mccdiffraction_detector_5_exit_volume_xwidth;
MCNUM yheight = mccdiffraction_detector_5_exit_volume_yheight;
MCNUM zdepth = mccdiffraction_detector_5_exit_volume_zdepth;
MCNUM xwidth2 = mccdiffraction_detector_5_exit_volume_xwidth2;
MCNUM yheight2 = mccdiffraction_detector_5_exit_volume_yheight2;
MCNUM visualize = mccdiffraction_detector_5_exit_volume_visualize;
int target_index = mccdiffraction_detector_5_exit_volume_target_index;
MCNUM target_x = mccdiffraction_detector_5_exit_volume_target_x;
MCNUM target_y = mccdiffraction_detector_5_exit_volume_target_y;
MCNUM target_z = mccdiffraction_detector_5_exit_volume_target_z;
MCNUM focus_aw = mccdiffraction_detector_5_exit_volume_focus_aw;
MCNUM focus_ah = mccdiffraction_detector_5_exit_volume_focus_ah;
MCNUM focus_xw = mccdiffraction_detector_5_exit_volume_focus_xw;
MCNUM focus_xh = mccdiffraction_detector_5_exit_volume_focus_xh;
MCNUM focus_r = mccdiffraction_detector_5_exit_volume_focus_r;
MCNUM p_interact = mccdiffraction_detector_5_exit_volume_p_interact;
char* mask_string = mccdiffraction_detector_5_exit_volume_mask_string;
char* mask_setting = mccdiffraction_detector_5_exit_volume_mask_setting;
MCNUM number_of_activations = mccdiffraction_detector_5_exit_volume_number_of_activations;
}   /* End of diffraction_detector_5_exit_volume=Union_box() SETTING parameter declarations. */
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex
  /* Label for restoring  neutron */
  mcabsorbCompdiffraction_detector_5_exit_volume:
  if (RESTORE) /* restore if needed */
  { RESTORE_NEUTRON(350,
      mcnlx,
      mcnly,
      mcnlz,
      mcnlvx,
      mcnlvy,
      mcnlvz,
      mcnlt,
      mcnlsx,
      mcnlsy,
      mcnlsz,
      mcnlp); }
#undef mcabsorbComp
#undef p
#undef sz
#undef sy
#undef sx
#undef t
#undef vz
#undef vy
#undef vx
#undef z
#undef y
#undef x
  mcDEBUG_STATE(
mcnlx,
mcnly,
mcnlz,
mcnlvx,
mcnlvy,
mcnlvz,
mcnlt,
mcnlsx,
mcnlsy,
mcnlsz,
mcnlp)

  /* TRACE Component spec_detector_5_exit_volume [351] */
  mccoordschange(mcposrspec_detector_5_exit_volume, mcrotrspec_detector_5_exit_volume,
    &mcnlx,
    &mcnly,
    &mcnlz,
    &mcnlvx,
    &mcnlvy,
    &mcnlvz,
    &mcnlsx,
    &mcnlsy,
    &mcnlsz);
  /* define label inside component spec_detector_5_exit_volume (without coords transformations) */
  mcJumpTrace_spec_detector_5_exit_volume:
  SIG_MESSAGE("spec_detector_5_exit_volume (Trace)");
  mcDEBUG_COMP("spec_detector_5_exit_volume")
  mcDEBUG_STATE(
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp)
#define x mcnlx
#define y mcnly
#define z mcnlz
#define vx mcnlvx
#define vy mcnlvy
#define vz mcnlvz
#define t mcnlt
#define sx mcnlsx
#define sy mcnlsy
#define sz mcnlsz
#define p mcnlp

#define mcabsorbComp mcabsorbCompspec_detector_5_exit_volume
  STORE_NEUTRON(351,
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp);
  mcScattered=0;
  mcRestore=0;
  mcNCounter[351]++;
  mcPCounter[351] += p;
  mcP2Counter[351] += p*p;
#define mccompcurname  spec_detector_5_exit_volume
#define mccompcurtype  Union_box
#define mccompcurindex 351
#define loop_index mccspec_detector_5_exit_volume_loop_index
#define this_box_volume mccspec_detector_5_exit_volume_this_box_volume
#define global_geometry_element mccspec_detector_5_exit_volume_global_geometry_element
#define this_box_storage mccspec_detector_5_exit_volume_this_box_storage
{   /* Declarations of spec_detector_5_exit_volume=Union_box() SETTING parameters. */
char* material_string = mccspec_detector_5_exit_volume_material_string;
MCNUM priority = mccspec_detector_5_exit_volume_priority;
MCNUM xwidth = mccspec_detector_5_exit_volume_xwidth;
MCNUM yheight = mccspec_detector_5_exit_volume_yheight;
MCNUM zdepth = mccspec_detector_5_exit_volume_zdepth;
MCNUM xwidth2 = mccspec_detector_5_exit_volume_xwidth2;
MCNUM yheight2 = mccspec_detector_5_exit_volume_yheight2;
MCNUM visualize = mccspec_detector_5_exit_volume_visualize;
int target_index = mccspec_detector_5_exit_volume_target_index;
MCNUM target_x = mccspec_detector_5_exit_volume_target_x;
MCNUM target_y = mccspec_detector_5_exit_volume_target_y;
MCNUM target_z = mccspec_detector_5_exit_volume_target_z;
MCNUM focus_aw = mccspec_detector_5_exit_volume_focus_aw;
MCNUM focus_ah = mccspec_detector_5_exit_volume_focus_ah;
MCNUM focus_xw = mccspec_detector_5_exit_volume_focus_xw;
MCNUM focus_xh = mccspec_detector_5_exit_volume_focus_xh;
MCNUM focus_r = mccspec_detector_5_exit_volume_focus_r;
MCNUM p_interact = mccspec_detector_5_exit_volume_p_interact;
char* mask_string = mccspec_detector_5_exit_volume_mask_string;
char* mask_setting = mccspec_detector_5_exit_volume_mask_setting;
MCNUM number_of_activations = mccspec_detector_5_exit_volume_number_of_activations;
}   /* End of spec_detector_5_exit_volume=Union_box() SETTING parameter declarations. */
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex
  /* Label for restoring  neutron */
  mcabsorbCompspec_detector_5_exit_volume:
  if (RESTORE) /* restore if needed */
  { RESTORE_NEUTRON(351,
      mcnlx,
      mcnly,
      mcnlz,
      mcnlvx,
      mcnlvy,
      mcnlvz,
      mcnlt,
      mcnlsx,
      mcnlsy,
      mcnlsz,
      mcnlp); }
#undef mcabsorbComp
#undef p
#undef sz
#undef sy
#undef sx
#undef t
#undef vz
#undef vy
#undef vx
#undef z
#undef y
#undef x
  mcDEBUG_STATE(
mcnlx,
mcnly,
mcnlz,
mcnlvx,
mcnlvy,
mcnlvz,
mcnlt,
mcnlsx,
mcnlsy,
mcnlsz,
mcnlp)

  /* TRACE Component channel_6_cave1_box1 [352] */
  mccoordschange(mcposrchannel_6_cave1_box1, mcrotrchannel_6_cave1_box1,
    &mcnlx,
    &mcnly,
    &mcnlz,
    &mcnlvx,
    &mcnlvy,
    &mcnlvz,
    &mcnlsx,
    &mcnlsy,
    &mcnlsz);
  /* define label inside component channel_6_cave1_box1 (without coords transformations) */
  mcJumpTrace_channel_6_cave1_box1:
  SIG_MESSAGE("channel_6_cave1_box1 (Trace)");
  mcDEBUG_COMP("channel_6_cave1_box1")
  mcDEBUG_STATE(
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp)
#define x mcnlx
#define y mcnly
#define z mcnlz
#define vx mcnlvx
#define vy mcnlvy
#define vz mcnlvz
#define t mcnlt
#define sx mcnlsx
#define sy mcnlsy
#define sz mcnlsz
#define p mcnlp

#define mcabsorbComp mcabsorbCompchannel_6_cave1_box1
  STORE_NEUTRON(352,
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp);
  mcScattered=0;
  mcRestore=0;
  mcNCounter[352]++;
  mcPCounter[352] += p;
  mcP2Counter[352] += p*p;
#define mccompcurname  channel_6_cave1_box1
#define mccompcurtype  Union_box
#define mccompcurindex 352
#define loop_index mccchannel_6_cave1_box1_loop_index
#define this_box_volume mccchannel_6_cave1_box1_this_box_volume
#define global_geometry_element mccchannel_6_cave1_box1_global_geometry_element
#define this_box_storage mccchannel_6_cave1_box1_this_box_storage
{   /* Declarations of channel_6_cave1_box1=Union_box() SETTING parameters. */
char* material_string = mccchannel_6_cave1_box1_material_string;
MCNUM priority = mccchannel_6_cave1_box1_priority;
MCNUM xwidth = mccchannel_6_cave1_box1_xwidth;
MCNUM yheight = mccchannel_6_cave1_box1_yheight;
MCNUM zdepth = mccchannel_6_cave1_box1_zdepth;
MCNUM xwidth2 = mccchannel_6_cave1_box1_xwidth2;
MCNUM yheight2 = mccchannel_6_cave1_box1_yheight2;
MCNUM visualize = mccchannel_6_cave1_box1_visualize;
int target_index = mccchannel_6_cave1_box1_target_index;
MCNUM target_x = mccchannel_6_cave1_box1_target_x;
MCNUM target_y = mccchannel_6_cave1_box1_target_y;
MCNUM target_z = mccchannel_6_cave1_box1_target_z;
MCNUM focus_aw = mccchannel_6_cave1_box1_focus_aw;
MCNUM focus_ah = mccchannel_6_cave1_box1_focus_ah;
MCNUM focus_xw = mccchannel_6_cave1_box1_focus_xw;
MCNUM focus_xh = mccchannel_6_cave1_box1_focus_xh;
MCNUM focus_r = mccchannel_6_cave1_box1_focus_r;
MCNUM p_interact = mccchannel_6_cave1_box1_p_interact;
char* mask_string = mccchannel_6_cave1_box1_mask_string;
char* mask_setting = mccchannel_6_cave1_box1_mask_setting;
MCNUM number_of_activations = mccchannel_6_cave1_box1_number_of_activations;
}   /* End of channel_6_cave1_box1=Union_box() SETTING parameter declarations. */
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex
  /* Label for restoring  neutron */
  mcabsorbCompchannel_6_cave1_box1:
  if (RESTORE) /* restore if needed */
  { RESTORE_NEUTRON(352,
      mcnlx,
      mcnly,
      mcnlz,
      mcnlvx,
      mcnlvy,
      mcnlvz,
      mcnlt,
      mcnlsx,
      mcnlsy,
      mcnlsz,
      mcnlp); }
#undef mcabsorbComp
#undef p
#undef sz
#undef sy
#undef sx
#undef t
#undef vz
#undef vy
#undef vx
#undef z
#undef y
#undef x
  mcDEBUG_STATE(
mcnlx,
mcnly,
mcnlz,
mcnlvx,
mcnlvy,
mcnlvz,
mcnlt,
mcnlsx,
mcnlsy,
mcnlsz,
mcnlp)

  /* TRACE Component channel_6_cave1_box2 [353] */
  mccoordschange(mcposrchannel_6_cave1_box2, mcrotrchannel_6_cave1_box2,
    &mcnlx,
    &mcnly,
    &mcnlz,
    &mcnlvx,
    &mcnlvy,
    &mcnlvz,
    &mcnlsx,
    &mcnlsy,
    &mcnlsz);
  /* define label inside component channel_6_cave1_box2 (without coords transformations) */
  mcJumpTrace_channel_6_cave1_box2:
  SIG_MESSAGE("channel_6_cave1_box2 (Trace)");
  mcDEBUG_COMP("channel_6_cave1_box2")
  mcDEBUG_STATE(
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp)
#define x mcnlx
#define y mcnly
#define z mcnlz
#define vx mcnlvx
#define vy mcnlvy
#define vz mcnlvz
#define t mcnlt
#define sx mcnlsx
#define sy mcnlsy
#define sz mcnlsz
#define p mcnlp

#define mcabsorbComp mcabsorbCompchannel_6_cave1_box2
  STORE_NEUTRON(353,
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp);
  mcScattered=0;
  mcRestore=0;
  mcNCounter[353]++;
  mcPCounter[353] += p;
  mcP2Counter[353] += p*p;
#define mccompcurname  channel_6_cave1_box2
#define mccompcurtype  Union_box
#define mccompcurindex 353
#define loop_index mccchannel_6_cave1_box2_loop_index
#define this_box_volume mccchannel_6_cave1_box2_this_box_volume
#define global_geometry_element mccchannel_6_cave1_box2_global_geometry_element
#define this_box_storage mccchannel_6_cave1_box2_this_box_storage
{   /* Declarations of channel_6_cave1_box2=Union_box() SETTING parameters. */
char* material_string = mccchannel_6_cave1_box2_material_string;
MCNUM priority = mccchannel_6_cave1_box2_priority;
MCNUM xwidth = mccchannel_6_cave1_box2_xwidth;
MCNUM yheight = mccchannel_6_cave1_box2_yheight;
MCNUM zdepth = mccchannel_6_cave1_box2_zdepth;
MCNUM xwidth2 = mccchannel_6_cave1_box2_xwidth2;
MCNUM yheight2 = mccchannel_6_cave1_box2_yheight2;
MCNUM visualize = mccchannel_6_cave1_box2_visualize;
int target_index = mccchannel_6_cave1_box2_target_index;
MCNUM target_x = mccchannel_6_cave1_box2_target_x;
MCNUM target_y = mccchannel_6_cave1_box2_target_y;
MCNUM target_z = mccchannel_6_cave1_box2_target_z;
MCNUM focus_aw = mccchannel_6_cave1_box2_focus_aw;
MCNUM focus_ah = mccchannel_6_cave1_box2_focus_ah;
MCNUM focus_xw = mccchannel_6_cave1_box2_focus_xw;
MCNUM focus_xh = mccchannel_6_cave1_box2_focus_xh;
MCNUM focus_r = mccchannel_6_cave1_box2_focus_r;
MCNUM p_interact = mccchannel_6_cave1_box2_p_interact;
char* mask_string = mccchannel_6_cave1_box2_mask_string;
char* mask_setting = mccchannel_6_cave1_box2_mask_setting;
MCNUM number_of_activations = mccchannel_6_cave1_box2_number_of_activations;
}   /* End of channel_6_cave1_box2=Union_box() SETTING parameter declarations. */
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex
  /* Label for restoring  neutron */
  mcabsorbCompchannel_6_cave1_box2:
  if (RESTORE) /* restore if needed */
  { RESTORE_NEUTRON(353,
      mcnlx,
      mcnly,
      mcnlz,
      mcnlvx,
      mcnlvy,
      mcnlvz,
      mcnlt,
      mcnlsx,
      mcnlsy,
      mcnlsz,
      mcnlp); }
#undef mcabsorbComp
#undef p
#undef sz
#undef sy
#undef sx
#undef t
#undef vz
#undef vy
#undef vx
#undef z
#undef y
#undef x
  mcDEBUG_STATE(
mcnlx,
mcnly,
mcnlz,
mcnlvx,
mcnlvy,
mcnlvz,
mcnlt,
mcnlsx,
mcnlsy,
mcnlsz,
mcnlp)

  /* TRACE Component channel_6_cave1_box3 [354] */
  mccoordschange(mcposrchannel_6_cave1_box3, mcrotrchannel_6_cave1_box3,
    &mcnlx,
    &mcnly,
    &mcnlz,
    &mcnlvx,
    &mcnlvy,
    &mcnlvz,
    &mcnlsx,
    &mcnlsy,
    &mcnlsz);
  /* define label inside component channel_6_cave1_box3 (without coords transformations) */
  mcJumpTrace_channel_6_cave1_box3:
  SIG_MESSAGE("channel_6_cave1_box3 (Trace)");
  mcDEBUG_COMP("channel_6_cave1_box3")
  mcDEBUG_STATE(
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp)
#define x mcnlx
#define y mcnly
#define z mcnlz
#define vx mcnlvx
#define vy mcnlvy
#define vz mcnlvz
#define t mcnlt
#define sx mcnlsx
#define sy mcnlsy
#define sz mcnlsz
#define p mcnlp

#define mcabsorbComp mcabsorbCompchannel_6_cave1_box3
  STORE_NEUTRON(354,
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp);
  mcScattered=0;
  mcRestore=0;
  mcNCounter[354]++;
  mcPCounter[354] += p;
  mcP2Counter[354] += p*p;
#define mccompcurname  channel_6_cave1_box3
#define mccompcurtype  Union_box
#define mccompcurindex 354
#define loop_index mccchannel_6_cave1_box3_loop_index
#define this_box_volume mccchannel_6_cave1_box3_this_box_volume
#define global_geometry_element mccchannel_6_cave1_box3_global_geometry_element
#define this_box_storage mccchannel_6_cave1_box3_this_box_storage
{   /* Declarations of channel_6_cave1_box3=Union_box() SETTING parameters. */
char* material_string = mccchannel_6_cave1_box3_material_string;
MCNUM priority = mccchannel_6_cave1_box3_priority;
MCNUM xwidth = mccchannel_6_cave1_box3_xwidth;
MCNUM yheight = mccchannel_6_cave1_box3_yheight;
MCNUM zdepth = mccchannel_6_cave1_box3_zdepth;
MCNUM xwidth2 = mccchannel_6_cave1_box3_xwidth2;
MCNUM yheight2 = mccchannel_6_cave1_box3_yheight2;
MCNUM visualize = mccchannel_6_cave1_box3_visualize;
int target_index = mccchannel_6_cave1_box3_target_index;
MCNUM target_x = mccchannel_6_cave1_box3_target_x;
MCNUM target_y = mccchannel_6_cave1_box3_target_y;
MCNUM target_z = mccchannel_6_cave1_box3_target_z;
MCNUM focus_aw = mccchannel_6_cave1_box3_focus_aw;
MCNUM focus_ah = mccchannel_6_cave1_box3_focus_ah;
MCNUM focus_xw = mccchannel_6_cave1_box3_focus_xw;
MCNUM focus_xh = mccchannel_6_cave1_box3_focus_xh;
MCNUM focus_r = mccchannel_6_cave1_box3_focus_r;
MCNUM p_interact = mccchannel_6_cave1_box3_p_interact;
char* mask_string = mccchannel_6_cave1_box3_mask_string;
char* mask_setting = mccchannel_6_cave1_box3_mask_setting;
MCNUM number_of_activations = mccchannel_6_cave1_box3_number_of_activations;
}   /* End of channel_6_cave1_box3=Union_box() SETTING parameter declarations. */
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex
  /* Label for restoring  neutron */
  mcabsorbCompchannel_6_cave1_box3:
  if (RESTORE) /* restore if needed */
  { RESTORE_NEUTRON(354,
      mcnlx,
      mcnly,
      mcnlz,
      mcnlvx,
      mcnlvy,
      mcnlvz,
      mcnlt,
      mcnlsx,
      mcnlsy,
      mcnlsz,
      mcnlp); }
#undef mcabsorbComp
#undef p
#undef sz
#undef sy
#undef sx
#undef t
#undef vz
#undef vy
#undef vx
#undef z
#undef y
#undef x
  mcDEBUG_STATE(
mcnlx,
mcnly,
mcnlz,
mcnlvx,
mcnlvy,
mcnlvz,
mcnlt,
mcnlsx,
mcnlsy,
mcnlsz,
mcnlp)

  /* TRACE Component channel_6_cave1_cyl1 [355] */
  mccoordschange(mcposrchannel_6_cave1_cyl1, mcrotrchannel_6_cave1_cyl1,
    &mcnlx,
    &mcnly,
    &mcnlz,
    &mcnlvx,
    &mcnlvy,
    &mcnlvz,
    &mcnlsx,
    &mcnlsy,
    &mcnlsz);
  /* define label inside component channel_6_cave1_cyl1 (without coords transformations) */
  mcJumpTrace_channel_6_cave1_cyl1:
  SIG_MESSAGE("channel_6_cave1_cyl1 (Trace)");
  mcDEBUG_COMP("channel_6_cave1_cyl1")
  mcDEBUG_STATE(
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp)
#define x mcnlx
#define y mcnly
#define z mcnlz
#define vx mcnlvx
#define vy mcnlvy
#define vz mcnlvz
#define t mcnlt
#define sx mcnlsx
#define sy mcnlsy
#define sz mcnlsz
#define p mcnlp

#define mcabsorbComp mcabsorbCompchannel_6_cave1_cyl1
  STORE_NEUTRON(355,
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp);
  mcScattered=0;
  mcRestore=0;
  mcNCounter[355]++;
  mcPCounter[355] += p;
  mcP2Counter[355] += p*p;
#define mccompcurname  channel_6_cave1_cyl1
#define mccompcurtype  Union_cylinder
#define mccompcurindex 355
#define loop_index mccchannel_6_cave1_cyl1_loop_index
#define this_cylinder_volume mccchannel_6_cave1_cyl1_this_cylinder_volume
#define global_geometry_element mccchannel_6_cave1_cyl1_global_geometry_element
#define this_cylinder_storage mccchannel_6_cave1_cyl1_this_cylinder_storage
{   /* Declarations of channel_6_cave1_cyl1=Union_cylinder() SETTING parameters. */
char* material_string = mccchannel_6_cave1_cyl1_material_string;
MCNUM priority = mccchannel_6_cave1_cyl1_priority;
MCNUM radius = mccchannel_6_cave1_cyl1_radius;
MCNUM yheight = mccchannel_6_cave1_cyl1_yheight;
MCNUM visualize = mccchannel_6_cave1_cyl1_visualize;
int target_index = mccchannel_6_cave1_cyl1_target_index;
MCNUM target_x = mccchannel_6_cave1_cyl1_target_x;
MCNUM target_y = mccchannel_6_cave1_cyl1_target_y;
MCNUM target_z = mccchannel_6_cave1_cyl1_target_z;
MCNUM focus_aw = mccchannel_6_cave1_cyl1_focus_aw;
MCNUM focus_ah = mccchannel_6_cave1_cyl1_focus_ah;
MCNUM focus_xw = mccchannel_6_cave1_cyl1_focus_xw;
MCNUM focus_xh = mccchannel_6_cave1_cyl1_focus_xh;
MCNUM focus_r = mccchannel_6_cave1_cyl1_focus_r;
MCNUM p_interact = mccchannel_6_cave1_cyl1_p_interact;
char* mask_string = mccchannel_6_cave1_cyl1_mask_string;
char* mask_setting = mccchannel_6_cave1_cyl1_mask_setting;
MCNUM number_of_activations = mccchannel_6_cave1_cyl1_number_of_activations;
#line 345 "Union_cylinder.comp"
{
dummy = 1;
}
#line 392704 "MACS_sample_kidney_box.c"
}   /* End of channel_6_cave1_cyl1=Union_cylinder() SETTING parameter declarations. */
#undef this_cylinder_storage
#undef global_geometry_element
#undef this_cylinder_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex
  /* Label for restoring  neutron */
  mcabsorbCompchannel_6_cave1_cyl1:
  if (RESTORE) /* restore if needed */
  { RESTORE_NEUTRON(355,
      mcnlx,
      mcnly,
      mcnlz,
      mcnlvx,
      mcnlvy,
      mcnlvz,
      mcnlt,
      mcnlsx,
      mcnlsy,
      mcnlsz,
      mcnlp); }
#undef mcabsorbComp
#undef p
#undef sz
#undef sy
#undef sx
#undef t
#undef vz
#undef vy
#undef vx
#undef z
#undef y
#undef x
  mcDEBUG_STATE(
mcnlx,
mcnly,
mcnlz,
mcnlvx,
mcnlvy,
mcnlvz,
mcnlt,
mcnlsx,
mcnlsy,
mcnlsz,
mcnlp)

  /* TRACE Component channel_6_analyzer_1_center [356] */
  mccoordschange(mcposrchannel_6_analyzer_1_center, mcrotrchannel_6_analyzer_1_center,
    &mcnlx,
    &mcnly,
    &mcnlz,
    &mcnlvx,
    &mcnlvy,
    &mcnlvz,
    &mcnlsx,
    &mcnlsy,
    &mcnlsz);
  /* define label inside component channel_6_analyzer_1_center (without coords transformations) */
  mcJumpTrace_channel_6_analyzer_1_center:
  SIG_MESSAGE("channel_6_analyzer_1_center (Trace)");
  mcDEBUG_COMP("channel_6_analyzer_1_center")
  mcDEBUG_STATE(
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp)
#define x mcnlx
#define y mcnly
#define z mcnlz
#define vx mcnlvx
#define vy mcnlvy
#define vz mcnlvz
#define t mcnlt
#define sx mcnlsx
#define sy mcnlsy
#define sz mcnlsz
#define p mcnlp

#define mcabsorbComp mcabsorbCompchannel_6_analyzer_1_center
  STORE_NEUTRON(356,
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp);
  mcScattered=0;
  mcRestore=0;
  mcNCounter[356]++;
  mcPCounter[356] += p;
  mcP2Counter[356] += p*p;
#define mccompcurname  channel_6_analyzer_1_center
#define mccompcurtype  Arm
#define mccompcurindex 356
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex
  /* Label for restoring  neutron */
  mcabsorbCompchannel_6_analyzer_1_center:
  if (RESTORE) /* restore if needed */
  { RESTORE_NEUTRON(356,
      mcnlx,
      mcnly,
      mcnlz,
      mcnlvx,
      mcnlvy,
      mcnlvz,
      mcnlt,
      mcnlsx,
      mcnlsy,
      mcnlsz,
      mcnlp); }
#undef mcabsorbComp
#undef p
#undef sz
#undef sy
#undef sx
#undef t
#undef vz
#undef vy
#undef vx
#undef z
#undef y
#undef x
  mcDEBUG_STATE(
mcnlx,
mcnly,
mcnlz,
mcnlvx,
mcnlvy,
mcnlvz,
mcnlt,
mcnlsx,
mcnlsy,
mcnlsz,
mcnlp)

  /* TRACE Component channel_6_analyzer_1_rotated [357] */
  mccoordschange(mcposrchannel_6_analyzer_1_rotated, mcrotrchannel_6_analyzer_1_rotated,
    &mcnlx,
    &mcnly,
    &mcnlz,
    &mcnlvx,
    &mcnlvy,
    &mcnlvz,
    &mcnlsx,
    &mcnlsy,
    &mcnlsz);
  /* define label inside component channel_6_analyzer_1_rotated (without coords transformations) */
  mcJumpTrace_channel_6_analyzer_1_rotated:
  SIG_MESSAGE("channel_6_analyzer_1_rotated (Trace)");
  mcDEBUG_COMP("channel_6_analyzer_1_rotated")
  mcDEBUG_STATE(
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp)
#define x mcnlx
#define y mcnly
#define z mcnlz
#define vx mcnlvx
#define vy mcnlvy
#define vz mcnlvz
#define t mcnlt
#define sx mcnlsx
#define sy mcnlsy
#define sz mcnlsz
#define p mcnlp

#define mcabsorbComp mcabsorbCompchannel_6_analyzer_1_rotated
  STORE_NEUTRON(357,
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp);
  mcScattered=0;
  mcRestore=0;
  mcNCounter[357]++;
  mcPCounter[357] += p;
  mcP2Counter[357] += p*p;
#define mccompcurname  channel_6_analyzer_1_rotated
#define mccompcurtype  Arm
#define mccompcurindex 357
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex
  /* Label for restoring  neutron */
  mcabsorbCompchannel_6_analyzer_1_rotated:
  if (RESTORE) /* restore if needed */
  { RESTORE_NEUTRON(357,
      mcnlx,
      mcnly,
      mcnlz,
      mcnlvx,
      mcnlvy,
      mcnlvz,
      mcnlt,
      mcnlsx,
      mcnlsy,
      mcnlsz,
      mcnlp); }
#undef mcabsorbComp
#undef p
#undef sz
#undef sy
#undef sx
#undef t
#undef vz
#undef vy
#undef vx
#undef z
#undef y
#undef x
  mcDEBUG_STATE(
mcnlx,
mcnly,
mcnlz,
mcnlvx,
mcnlvy,
mcnlvz,
mcnlt,
mcnlsx,
mcnlsy,
mcnlsz,
mcnlp)

  /* TRACE Component channel_6_analyzer_1_array_crystal_array_0 [358] */
  mccoordschange(mcposrchannel_6_analyzer_1_array_crystal_array_0, mcrotrchannel_6_analyzer_1_array_crystal_array_0,
    &mcnlx,
    &mcnly,
    &mcnlz,
    &mcnlvx,
    &mcnlvy,
    &mcnlvz,
    &mcnlsx,
    &mcnlsy,
    &mcnlsz);
  /* define label inside component channel_6_analyzer_1_array_crystal_array_0 (without coords transformations) */
  mcJumpTrace_channel_6_analyzer_1_array_crystal_array_0:
  SIG_MESSAGE("channel_6_analyzer_1_array_crystal_array_0 (Trace)");
  mcDEBUG_COMP("channel_6_analyzer_1_array_crystal_array_0")
  mcDEBUG_STATE(
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp)
#define x mcnlx
#define y mcnly
#define z mcnlz
#define vx mcnlvx
#define vy mcnlvy
#define vz mcnlvz
#define t mcnlt
#define sx mcnlsx
#define sy mcnlsy
#define sz mcnlsz
#define p mcnlp

#define mcabsorbComp mcabsorbCompchannel_6_analyzer_1_array_crystal_array_0
  STORE_NEUTRON(358,
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp);
  mcScattered=0;
  mcRestore=0;
  mcNCounter[358]++;
  mcPCounter[358] += p;
  mcP2Counter[358] += p*p;
#define mccompcurname  channel_6_analyzer_1_array_crystal_array_0
#define mccompcurtype  Union_box
#define mccompcurindex 358
#define loop_index mccchannel_6_analyzer_1_array_crystal_array_0_loop_index
#define this_box_volume mccchannel_6_analyzer_1_array_crystal_array_0_this_box_volume
#define global_geometry_element mccchannel_6_analyzer_1_array_crystal_array_0_global_geometry_element
#define this_box_storage mccchannel_6_analyzer_1_array_crystal_array_0_this_box_storage
{   /* Declarations of channel_6_analyzer_1_array_crystal_array_0=Union_box() SETTING parameters. */
char* material_string = mccchannel_6_analyzer_1_array_crystal_array_0_material_string;
MCNUM priority = mccchannel_6_analyzer_1_array_crystal_array_0_priority;
MCNUM xwidth = mccchannel_6_analyzer_1_array_crystal_array_0_xwidth;
MCNUM yheight = mccchannel_6_analyzer_1_array_crystal_array_0_yheight;
MCNUM zdepth = mccchannel_6_analyzer_1_array_crystal_array_0_zdepth;
MCNUM xwidth2 = mccchannel_6_analyzer_1_array_crystal_array_0_xwidth2;
MCNUM yheight2 = mccchannel_6_analyzer_1_array_crystal_array_0_yheight2;
MCNUM visualize = mccchannel_6_analyzer_1_array_crystal_array_0_visualize;
int target_index = mccchannel_6_analyzer_1_array_crystal_array_0_target_index;
MCNUM target_x = mccchannel_6_analyzer_1_array_crystal_array_0_target_x;
MCNUM target_y = mccchannel_6_analyzer_1_array_crystal_array_0_target_y;
MCNUM target_z = mccchannel_6_analyzer_1_array_crystal_array_0_target_z;
MCNUM focus_aw = mccchannel_6_analyzer_1_array_crystal_array_0_focus_aw;
MCNUM focus_ah = mccchannel_6_analyzer_1_array_crystal_array_0_focus_ah;
MCNUM focus_xw = mccchannel_6_analyzer_1_array_crystal_array_0_focus_xw;
MCNUM focus_xh = mccchannel_6_analyzer_1_array_crystal_array_0_focus_xh;
MCNUM focus_r = mccchannel_6_analyzer_1_array_crystal_array_0_focus_r;
MCNUM p_interact = mccchannel_6_analyzer_1_array_crystal_array_0_p_interact;
char* mask_string = mccchannel_6_analyzer_1_array_crystal_array_0_mask_string;
char* mask_setting = mccchannel_6_analyzer_1_array_crystal_array_0_mask_setting;
MCNUM number_of_activations = mccchannel_6_analyzer_1_array_crystal_array_0_number_of_activations;
}   /* End of channel_6_analyzer_1_array_crystal_array_0=Union_box() SETTING parameter declarations. */
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex
  /* Label for restoring  neutron */
  mcabsorbCompchannel_6_analyzer_1_array_crystal_array_0:
  if (RESTORE) /* restore if needed */
  { RESTORE_NEUTRON(358,
      mcnlx,
      mcnly,
      mcnlz,
      mcnlvx,
      mcnlvy,
      mcnlvz,
      mcnlt,
      mcnlsx,
      mcnlsy,
      mcnlsz,
      mcnlp); }
#undef mcabsorbComp
#undef p
#undef sz
#undef sy
#undef sx
#undef t
#undef vz
#undef vy
#undef vx
#undef z
#undef y
#undef x
  mcDEBUG_STATE(
mcnlx,
mcnly,
mcnlz,
mcnlvx,
mcnlvy,
mcnlvz,
mcnlt,
mcnlsx,
mcnlsy,
mcnlsz,
mcnlp)

  /* TRACE Component channel_6_analyzer_1_array_crystal_array_1 [359] */
  mccoordschange(mcposrchannel_6_analyzer_1_array_crystal_array_1, mcrotrchannel_6_analyzer_1_array_crystal_array_1,
    &mcnlx,
    &mcnly,
    &mcnlz,
    &mcnlvx,
    &mcnlvy,
    &mcnlvz,
    &mcnlsx,
    &mcnlsy,
    &mcnlsz);
  /* define label inside component channel_6_analyzer_1_array_crystal_array_1 (without coords transformations) */
  mcJumpTrace_channel_6_analyzer_1_array_crystal_array_1:
  SIG_MESSAGE("channel_6_analyzer_1_array_crystal_array_1 (Trace)");
  mcDEBUG_COMP("channel_6_analyzer_1_array_crystal_array_1")
  mcDEBUG_STATE(
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp)
#define x mcnlx
#define y mcnly
#define z mcnlz
#define vx mcnlvx
#define vy mcnlvy
#define vz mcnlvz
#define t mcnlt
#define sx mcnlsx
#define sy mcnlsy
#define sz mcnlsz
#define p mcnlp

#define mcabsorbComp mcabsorbCompchannel_6_analyzer_1_array_crystal_array_1
  STORE_NEUTRON(359,
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp);
  mcScattered=0;
  mcRestore=0;
  mcNCounter[359]++;
  mcPCounter[359] += p;
  mcP2Counter[359] += p*p;
#define mccompcurname  channel_6_analyzer_1_array_crystal_array_1
#define mccompcurtype  Union_box
#define mccompcurindex 359
#define loop_index mccchannel_6_analyzer_1_array_crystal_array_1_loop_index
#define this_box_volume mccchannel_6_analyzer_1_array_crystal_array_1_this_box_volume
#define global_geometry_element mccchannel_6_analyzer_1_array_crystal_array_1_global_geometry_element
#define this_box_storage mccchannel_6_analyzer_1_array_crystal_array_1_this_box_storage
{   /* Declarations of channel_6_analyzer_1_array_crystal_array_1=Union_box() SETTING parameters. */
char* material_string = mccchannel_6_analyzer_1_array_crystal_array_1_material_string;
MCNUM priority = mccchannel_6_analyzer_1_array_crystal_array_1_priority;
MCNUM xwidth = mccchannel_6_analyzer_1_array_crystal_array_1_xwidth;
MCNUM yheight = mccchannel_6_analyzer_1_array_crystal_array_1_yheight;
MCNUM zdepth = mccchannel_6_analyzer_1_array_crystal_array_1_zdepth;
MCNUM xwidth2 = mccchannel_6_analyzer_1_array_crystal_array_1_xwidth2;
MCNUM yheight2 = mccchannel_6_analyzer_1_array_crystal_array_1_yheight2;
MCNUM visualize = mccchannel_6_analyzer_1_array_crystal_array_1_visualize;
int target_index = mccchannel_6_analyzer_1_array_crystal_array_1_target_index;
MCNUM target_x = mccchannel_6_analyzer_1_array_crystal_array_1_target_x;
MCNUM target_y = mccchannel_6_analyzer_1_array_crystal_array_1_target_y;
MCNUM target_z = mccchannel_6_analyzer_1_array_crystal_array_1_target_z;
MCNUM focus_aw = mccchannel_6_analyzer_1_array_crystal_array_1_focus_aw;
MCNUM focus_ah = mccchannel_6_analyzer_1_array_crystal_array_1_focus_ah;
MCNUM focus_xw = mccchannel_6_analyzer_1_array_crystal_array_1_focus_xw;
MCNUM focus_xh = mccchannel_6_analyzer_1_array_crystal_array_1_focus_xh;
MCNUM focus_r = mccchannel_6_analyzer_1_array_crystal_array_1_focus_r;
MCNUM p_interact = mccchannel_6_analyzer_1_array_crystal_array_1_p_interact;
char* mask_string = mccchannel_6_analyzer_1_array_crystal_array_1_mask_string;
char* mask_setting = mccchannel_6_analyzer_1_array_crystal_array_1_mask_setting;
MCNUM number_of_activations = mccchannel_6_analyzer_1_array_crystal_array_1_number_of_activations;
}   /* End of channel_6_analyzer_1_array_crystal_array_1=Union_box() SETTING parameter declarations. */
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex
  /* Label for restoring  neutron */
  mcabsorbCompchannel_6_analyzer_1_array_crystal_array_1:
  if (RESTORE) /* restore if needed */
  { RESTORE_NEUTRON(359,
      mcnlx,
      mcnly,
      mcnlz,
      mcnlvx,
      mcnlvy,
      mcnlvz,
      mcnlt,
      mcnlsx,
      mcnlsy,
      mcnlsz,
      mcnlp); }
#undef mcabsorbComp
#undef p
#undef sz
#undef sy
#undef sx
#undef t
#undef vz
#undef vy
#undef vx
#undef z
#undef y
#undef x
  mcDEBUG_STATE(
mcnlx,
mcnly,
mcnlz,
mcnlvx,
mcnlvy,
mcnlvz,
mcnlt,
mcnlsx,
mcnlsy,
mcnlsz,
mcnlp)

  /* TRACE Component channel_6_analyzer_1_array_crystal_array_2 [360] */
  mccoordschange(mcposrchannel_6_analyzer_1_array_crystal_array_2, mcrotrchannel_6_analyzer_1_array_crystal_array_2,
    &mcnlx,
    &mcnly,
    &mcnlz,
    &mcnlvx,
    &mcnlvy,
    &mcnlvz,
    &mcnlsx,
    &mcnlsy,
    &mcnlsz);
  /* define label inside component channel_6_analyzer_1_array_crystal_array_2 (without coords transformations) */
  mcJumpTrace_channel_6_analyzer_1_array_crystal_array_2:
  SIG_MESSAGE("channel_6_analyzer_1_array_crystal_array_2 (Trace)");
  mcDEBUG_COMP("channel_6_analyzer_1_array_crystal_array_2")
  mcDEBUG_STATE(
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp)
#define x mcnlx
#define y mcnly
#define z mcnlz
#define vx mcnlvx
#define vy mcnlvy
#define vz mcnlvz
#define t mcnlt
#define sx mcnlsx
#define sy mcnlsy
#define sz mcnlsz
#define p mcnlp

#define mcabsorbComp mcabsorbCompchannel_6_analyzer_1_array_crystal_array_2
  STORE_NEUTRON(360,
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp);
  mcScattered=0;
  mcRestore=0;
  mcNCounter[360]++;
  mcPCounter[360] += p;
  mcP2Counter[360] += p*p;
#define mccompcurname  channel_6_analyzer_1_array_crystal_array_2
#define mccompcurtype  Union_box
#define mccompcurindex 360
#define loop_index mccchannel_6_analyzer_1_array_crystal_array_2_loop_index
#define this_box_volume mccchannel_6_analyzer_1_array_crystal_array_2_this_box_volume
#define global_geometry_element mccchannel_6_analyzer_1_array_crystal_array_2_global_geometry_element
#define this_box_storage mccchannel_6_analyzer_1_array_crystal_array_2_this_box_storage
{   /* Declarations of channel_6_analyzer_1_array_crystal_array_2=Union_box() SETTING parameters. */
char* material_string = mccchannel_6_analyzer_1_array_crystal_array_2_material_string;
MCNUM priority = mccchannel_6_analyzer_1_array_crystal_array_2_priority;
MCNUM xwidth = mccchannel_6_analyzer_1_array_crystal_array_2_xwidth;
MCNUM yheight = mccchannel_6_analyzer_1_array_crystal_array_2_yheight;
MCNUM zdepth = mccchannel_6_analyzer_1_array_crystal_array_2_zdepth;
MCNUM xwidth2 = mccchannel_6_analyzer_1_array_crystal_array_2_xwidth2;
MCNUM yheight2 = mccchannel_6_analyzer_1_array_crystal_array_2_yheight2;
MCNUM visualize = mccchannel_6_analyzer_1_array_crystal_array_2_visualize;
int target_index = mccchannel_6_analyzer_1_array_crystal_array_2_target_index;
MCNUM target_x = mccchannel_6_analyzer_1_array_crystal_array_2_target_x;
MCNUM target_y = mccchannel_6_analyzer_1_array_crystal_array_2_target_y;
MCNUM target_z = mccchannel_6_analyzer_1_array_crystal_array_2_target_z;
MCNUM focus_aw = mccchannel_6_analyzer_1_array_crystal_array_2_focus_aw;
MCNUM focus_ah = mccchannel_6_analyzer_1_array_crystal_array_2_focus_ah;
MCNUM focus_xw = mccchannel_6_analyzer_1_array_crystal_array_2_focus_xw;
MCNUM focus_xh = mccchannel_6_analyzer_1_array_crystal_array_2_focus_xh;
MCNUM focus_r = mccchannel_6_analyzer_1_array_crystal_array_2_focus_r;
MCNUM p_interact = mccchannel_6_analyzer_1_array_crystal_array_2_p_interact;
char* mask_string = mccchannel_6_analyzer_1_array_crystal_array_2_mask_string;
char* mask_setting = mccchannel_6_analyzer_1_array_crystal_array_2_mask_setting;
MCNUM number_of_activations = mccchannel_6_analyzer_1_array_crystal_array_2_number_of_activations;
}   /* End of channel_6_analyzer_1_array_crystal_array_2=Union_box() SETTING parameter declarations. */
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex
  /* Label for restoring  neutron */
  mcabsorbCompchannel_6_analyzer_1_array_crystal_array_2:
  if (RESTORE) /* restore if needed */
  { RESTORE_NEUTRON(360,
      mcnlx,
      mcnly,
      mcnlz,
      mcnlvx,
      mcnlvy,
      mcnlvz,
      mcnlt,
      mcnlsx,
      mcnlsy,
      mcnlsz,
      mcnlp); }
#undef mcabsorbComp
#undef p
#undef sz
#undef sy
#undef sx
#undef t
#undef vz
#undef vy
#undef vx
#undef z
#undef y
#undef x
  mcDEBUG_STATE(
mcnlx,
mcnly,
mcnlz,
mcnlvx,
mcnlvy,
mcnlvz,
mcnlt,
mcnlsx,
mcnlsy,
mcnlsz,
mcnlp)

  /* TRACE Component channel_6_analyzer_1_array_crystal_array_3 [361] */
  mccoordschange(mcposrchannel_6_analyzer_1_array_crystal_array_3, mcrotrchannel_6_analyzer_1_array_crystal_array_3,
    &mcnlx,
    &mcnly,
    &mcnlz,
    &mcnlvx,
    &mcnlvy,
    &mcnlvz,
    &mcnlsx,
    &mcnlsy,
    &mcnlsz);
  /* define label inside component channel_6_analyzer_1_array_crystal_array_3 (without coords transformations) */
  mcJumpTrace_channel_6_analyzer_1_array_crystal_array_3:
  SIG_MESSAGE("channel_6_analyzer_1_array_crystal_array_3 (Trace)");
  mcDEBUG_COMP("channel_6_analyzer_1_array_crystal_array_3")
  mcDEBUG_STATE(
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp)
#define x mcnlx
#define y mcnly
#define z mcnlz
#define vx mcnlvx
#define vy mcnlvy
#define vz mcnlvz
#define t mcnlt
#define sx mcnlsx
#define sy mcnlsy
#define sz mcnlsz
#define p mcnlp

#define mcabsorbComp mcabsorbCompchannel_6_analyzer_1_array_crystal_array_3
  STORE_NEUTRON(361,
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp);
  mcScattered=0;
  mcRestore=0;
  mcNCounter[361]++;
  mcPCounter[361] += p;
  mcP2Counter[361] += p*p;
#define mccompcurname  channel_6_analyzer_1_array_crystal_array_3
#define mccompcurtype  Union_box
#define mccompcurindex 361
#define loop_index mccchannel_6_analyzer_1_array_crystal_array_3_loop_index
#define this_box_volume mccchannel_6_analyzer_1_array_crystal_array_3_this_box_volume
#define global_geometry_element mccchannel_6_analyzer_1_array_crystal_array_3_global_geometry_element
#define this_box_storage mccchannel_6_analyzer_1_array_crystal_array_3_this_box_storage
{   /* Declarations of channel_6_analyzer_1_array_crystal_array_3=Union_box() SETTING parameters. */
char* material_string = mccchannel_6_analyzer_1_array_crystal_array_3_material_string;
MCNUM priority = mccchannel_6_analyzer_1_array_crystal_array_3_priority;
MCNUM xwidth = mccchannel_6_analyzer_1_array_crystal_array_3_xwidth;
MCNUM yheight = mccchannel_6_analyzer_1_array_crystal_array_3_yheight;
MCNUM zdepth = mccchannel_6_analyzer_1_array_crystal_array_3_zdepth;
MCNUM xwidth2 = mccchannel_6_analyzer_1_array_crystal_array_3_xwidth2;
MCNUM yheight2 = mccchannel_6_analyzer_1_array_crystal_array_3_yheight2;
MCNUM visualize = mccchannel_6_analyzer_1_array_crystal_array_3_visualize;
int target_index = mccchannel_6_analyzer_1_array_crystal_array_3_target_index;
MCNUM target_x = mccchannel_6_analyzer_1_array_crystal_array_3_target_x;
MCNUM target_y = mccchannel_6_analyzer_1_array_crystal_array_3_target_y;
MCNUM target_z = mccchannel_6_analyzer_1_array_crystal_array_3_target_z;
MCNUM focus_aw = mccchannel_6_analyzer_1_array_crystal_array_3_focus_aw;
MCNUM focus_ah = mccchannel_6_analyzer_1_array_crystal_array_3_focus_ah;
MCNUM focus_xw = mccchannel_6_analyzer_1_array_crystal_array_3_focus_xw;
MCNUM focus_xh = mccchannel_6_analyzer_1_array_crystal_array_3_focus_xh;
MCNUM focus_r = mccchannel_6_analyzer_1_array_crystal_array_3_focus_r;
MCNUM p_interact = mccchannel_6_analyzer_1_array_crystal_array_3_p_interact;
char* mask_string = mccchannel_6_analyzer_1_array_crystal_array_3_mask_string;
char* mask_setting = mccchannel_6_analyzer_1_array_crystal_array_3_mask_setting;
MCNUM number_of_activations = mccchannel_6_analyzer_1_array_crystal_array_3_number_of_activations;
}   /* End of channel_6_analyzer_1_array_crystal_array_3=Union_box() SETTING parameter declarations. */
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex
  /* Label for restoring  neutron */
  mcabsorbCompchannel_6_analyzer_1_array_crystal_array_3:
  if (RESTORE) /* restore if needed */
  { RESTORE_NEUTRON(361,
      mcnlx,
      mcnly,
      mcnlz,
      mcnlvx,
      mcnlvy,
      mcnlvz,
      mcnlt,
      mcnlsx,
      mcnlsy,
      mcnlsz,
      mcnlp); }
#undef mcabsorbComp
#undef p
#undef sz
#undef sy
#undef sx
#undef t
#undef vz
#undef vy
#undef vx
#undef z
#undef y
#undef x
  mcDEBUG_STATE(
mcnlx,
mcnly,
mcnlz,
mcnlvx,
mcnlvy,
mcnlvz,
mcnlt,
mcnlsx,
mcnlsy,
mcnlsz,
mcnlp)

  /* TRACE Component channel_6_analyzer_1_array_crystal_array_4 [362] */
  mccoordschange(mcposrchannel_6_analyzer_1_array_crystal_array_4, mcrotrchannel_6_analyzer_1_array_crystal_array_4,
    &mcnlx,
    &mcnly,
    &mcnlz,
    &mcnlvx,
    &mcnlvy,
    &mcnlvz,
    &mcnlsx,
    &mcnlsy,
    &mcnlsz);
  /* define label inside component channel_6_analyzer_1_array_crystal_array_4 (without coords transformations) */
  mcJumpTrace_channel_6_analyzer_1_array_crystal_array_4:
  SIG_MESSAGE("channel_6_analyzer_1_array_crystal_array_4 (Trace)");
  mcDEBUG_COMP("channel_6_analyzer_1_array_crystal_array_4")
  mcDEBUG_STATE(
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp)
#define x mcnlx
#define y mcnly
#define z mcnlz
#define vx mcnlvx
#define vy mcnlvy
#define vz mcnlvz
#define t mcnlt
#define sx mcnlsx
#define sy mcnlsy
#define sz mcnlsz
#define p mcnlp

#define mcabsorbComp mcabsorbCompchannel_6_analyzer_1_array_crystal_array_4
  STORE_NEUTRON(362,
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp);
  mcScattered=0;
  mcRestore=0;
  mcNCounter[362]++;
  mcPCounter[362] += p;
  mcP2Counter[362] += p*p;
#define mccompcurname  channel_6_analyzer_1_array_crystal_array_4
#define mccompcurtype  Union_box
#define mccompcurindex 362
#define loop_index mccchannel_6_analyzer_1_array_crystal_array_4_loop_index
#define this_box_volume mccchannel_6_analyzer_1_array_crystal_array_4_this_box_volume
#define global_geometry_element mccchannel_6_analyzer_1_array_crystal_array_4_global_geometry_element
#define this_box_storage mccchannel_6_analyzer_1_array_crystal_array_4_this_box_storage
{   /* Declarations of channel_6_analyzer_1_array_crystal_array_4=Union_box() SETTING parameters. */
char* material_string = mccchannel_6_analyzer_1_array_crystal_array_4_material_string;
MCNUM priority = mccchannel_6_analyzer_1_array_crystal_array_4_priority;
MCNUM xwidth = mccchannel_6_analyzer_1_array_crystal_array_4_xwidth;
MCNUM yheight = mccchannel_6_analyzer_1_array_crystal_array_4_yheight;
MCNUM zdepth = mccchannel_6_analyzer_1_array_crystal_array_4_zdepth;
MCNUM xwidth2 = mccchannel_6_analyzer_1_array_crystal_array_4_xwidth2;
MCNUM yheight2 = mccchannel_6_analyzer_1_array_crystal_array_4_yheight2;
MCNUM visualize = mccchannel_6_analyzer_1_array_crystal_array_4_visualize;
int target_index = mccchannel_6_analyzer_1_array_crystal_array_4_target_index;
MCNUM target_x = mccchannel_6_analyzer_1_array_crystal_array_4_target_x;
MCNUM target_y = mccchannel_6_analyzer_1_array_crystal_array_4_target_y;
MCNUM target_z = mccchannel_6_analyzer_1_array_crystal_array_4_target_z;
MCNUM focus_aw = mccchannel_6_analyzer_1_array_crystal_array_4_focus_aw;
MCNUM focus_ah = mccchannel_6_analyzer_1_array_crystal_array_4_focus_ah;
MCNUM focus_xw = mccchannel_6_analyzer_1_array_crystal_array_4_focus_xw;
MCNUM focus_xh = mccchannel_6_analyzer_1_array_crystal_array_4_focus_xh;
MCNUM focus_r = mccchannel_6_analyzer_1_array_crystal_array_4_focus_r;
MCNUM p_interact = mccchannel_6_analyzer_1_array_crystal_array_4_p_interact;
char* mask_string = mccchannel_6_analyzer_1_array_crystal_array_4_mask_string;
char* mask_setting = mccchannel_6_analyzer_1_array_crystal_array_4_mask_setting;
MCNUM number_of_activations = mccchannel_6_analyzer_1_array_crystal_array_4_number_of_activations;
}   /* End of channel_6_analyzer_1_array_crystal_array_4=Union_box() SETTING parameter declarations. */
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex
  /* Label for restoring  neutron */
  mcabsorbCompchannel_6_analyzer_1_array_crystal_array_4:
  if (RESTORE) /* restore if needed */
  { RESTORE_NEUTRON(362,
      mcnlx,
      mcnly,
      mcnlz,
      mcnlvx,
      mcnlvy,
      mcnlvz,
      mcnlt,
      mcnlsx,
      mcnlsy,
      mcnlsz,
      mcnlp); }
#undef mcabsorbComp
#undef p
#undef sz
#undef sy
#undef sx
#undef t
#undef vz
#undef vy
#undef vx
#undef z
#undef y
#undef x
  mcDEBUG_STATE(
mcnlx,
mcnly,
mcnlz,
mcnlvx,
mcnlvy,
mcnlvz,
mcnlt,
mcnlsx,
mcnlsy,
mcnlsz,
mcnlp)

  /* TRACE Component channel_6_analyzer_1_array_crystal_array_5 [363] */
  mccoordschange(mcposrchannel_6_analyzer_1_array_crystal_array_5, mcrotrchannel_6_analyzer_1_array_crystal_array_5,
    &mcnlx,
    &mcnly,
    &mcnlz,
    &mcnlvx,
    &mcnlvy,
    &mcnlvz,
    &mcnlsx,
    &mcnlsy,
    &mcnlsz);
  /* define label inside component channel_6_analyzer_1_array_crystal_array_5 (without coords transformations) */
  mcJumpTrace_channel_6_analyzer_1_array_crystal_array_5:
  SIG_MESSAGE("channel_6_analyzer_1_array_crystal_array_5 (Trace)");
  mcDEBUG_COMP("channel_6_analyzer_1_array_crystal_array_5")
  mcDEBUG_STATE(
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp)
#define x mcnlx
#define y mcnly
#define z mcnlz
#define vx mcnlvx
#define vy mcnlvy
#define vz mcnlvz
#define t mcnlt
#define sx mcnlsx
#define sy mcnlsy
#define sz mcnlsz
#define p mcnlp

#define mcabsorbComp mcabsorbCompchannel_6_analyzer_1_array_crystal_array_5
  STORE_NEUTRON(363,
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp);
  mcScattered=0;
  mcRestore=0;
  mcNCounter[363]++;
  mcPCounter[363] += p;
  mcP2Counter[363] += p*p;
#define mccompcurname  channel_6_analyzer_1_array_crystal_array_5
#define mccompcurtype  Union_box
#define mccompcurindex 363
#define loop_index mccchannel_6_analyzer_1_array_crystal_array_5_loop_index
#define this_box_volume mccchannel_6_analyzer_1_array_crystal_array_5_this_box_volume
#define global_geometry_element mccchannel_6_analyzer_1_array_crystal_array_5_global_geometry_element
#define this_box_storage mccchannel_6_analyzer_1_array_crystal_array_5_this_box_storage
{   /* Declarations of channel_6_analyzer_1_array_crystal_array_5=Union_box() SETTING parameters. */
char* material_string = mccchannel_6_analyzer_1_array_crystal_array_5_material_string;
MCNUM priority = mccchannel_6_analyzer_1_array_crystal_array_5_priority;
MCNUM xwidth = mccchannel_6_analyzer_1_array_crystal_array_5_xwidth;
MCNUM yheight = mccchannel_6_analyzer_1_array_crystal_array_5_yheight;
MCNUM zdepth = mccchannel_6_analyzer_1_array_crystal_array_5_zdepth;
MCNUM xwidth2 = mccchannel_6_analyzer_1_array_crystal_array_5_xwidth2;
MCNUM yheight2 = mccchannel_6_analyzer_1_array_crystal_array_5_yheight2;
MCNUM visualize = mccchannel_6_analyzer_1_array_crystal_array_5_visualize;
int target_index = mccchannel_6_analyzer_1_array_crystal_array_5_target_index;
MCNUM target_x = mccchannel_6_analyzer_1_array_crystal_array_5_target_x;
MCNUM target_y = mccchannel_6_analyzer_1_array_crystal_array_5_target_y;
MCNUM target_z = mccchannel_6_analyzer_1_array_crystal_array_5_target_z;
MCNUM focus_aw = mccchannel_6_analyzer_1_array_crystal_array_5_focus_aw;
MCNUM focus_ah = mccchannel_6_analyzer_1_array_crystal_array_5_focus_ah;
MCNUM focus_xw = mccchannel_6_analyzer_1_array_crystal_array_5_focus_xw;
MCNUM focus_xh = mccchannel_6_analyzer_1_array_crystal_array_5_focus_xh;
MCNUM focus_r = mccchannel_6_analyzer_1_array_crystal_array_5_focus_r;
MCNUM p_interact = mccchannel_6_analyzer_1_array_crystal_array_5_p_interact;
char* mask_string = mccchannel_6_analyzer_1_array_crystal_array_5_mask_string;
char* mask_setting = mccchannel_6_analyzer_1_array_crystal_array_5_mask_setting;
MCNUM number_of_activations = mccchannel_6_analyzer_1_array_crystal_array_5_number_of_activations;
}   /* End of channel_6_analyzer_1_array_crystal_array_5=Union_box() SETTING parameter declarations. */
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex
  /* Label for restoring  neutron */
  mcabsorbCompchannel_6_analyzer_1_array_crystal_array_5:
  if (RESTORE) /* restore if needed */
  { RESTORE_NEUTRON(363,
      mcnlx,
      mcnly,
      mcnlz,
      mcnlvx,
      mcnlvy,
      mcnlvz,
      mcnlt,
      mcnlsx,
      mcnlsy,
      mcnlsz,
      mcnlp); }
#undef mcabsorbComp
#undef p
#undef sz
#undef sy
#undef sx
#undef t
#undef vz
#undef vy
#undef vx
#undef z
#undef y
#undef x
  mcDEBUG_STATE(
mcnlx,
mcnly,
mcnlz,
mcnlvx,
mcnlvy,
mcnlvz,
mcnlt,
mcnlsx,
mcnlsy,
mcnlsz,
mcnlp)

  /* TRACE Component channel_6_analyzer_1_array_crystal_array_6 [364] */
  mccoordschange(mcposrchannel_6_analyzer_1_array_crystal_array_6, mcrotrchannel_6_analyzer_1_array_crystal_array_6,
    &mcnlx,
    &mcnly,
    &mcnlz,
    &mcnlvx,
    &mcnlvy,
    &mcnlvz,
    &mcnlsx,
    &mcnlsy,
    &mcnlsz);
  /* define label inside component channel_6_analyzer_1_array_crystal_array_6 (without coords transformations) */
  mcJumpTrace_channel_6_analyzer_1_array_crystal_array_6:
  SIG_MESSAGE("channel_6_analyzer_1_array_crystal_array_6 (Trace)");
  mcDEBUG_COMP("channel_6_analyzer_1_array_crystal_array_6")
  mcDEBUG_STATE(
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp)
#define x mcnlx
#define y mcnly
#define z mcnlz
#define vx mcnlvx
#define vy mcnlvy
#define vz mcnlvz
#define t mcnlt
#define sx mcnlsx
#define sy mcnlsy
#define sz mcnlsz
#define p mcnlp

#define mcabsorbComp mcabsorbCompchannel_6_analyzer_1_array_crystal_array_6
  STORE_NEUTRON(364,
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp);
  mcScattered=0;
  mcRestore=0;
  mcNCounter[364]++;
  mcPCounter[364] += p;
  mcP2Counter[364] += p*p;
#define mccompcurname  channel_6_analyzer_1_array_crystal_array_6
#define mccompcurtype  Union_box
#define mccompcurindex 364
#define loop_index mccchannel_6_analyzer_1_array_crystal_array_6_loop_index
#define this_box_volume mccchannel_6_analyzer_1_array_crystal_array_6_this_box_volume
#define global_geometry_element mccchannel_6_analyzer_1_array_crystal_array_6_global_geometry_element
#define this_box_storage mccchannel_6_analyzer_1_array_crystal_array_6_this_box_storage
{   /* Declarations of channel_6_analyzer_1_array_crystal_array_6=Union_box() SETTING parameters. */
char* material_string = mccchannel_6_analyzer_1_array_crystal_array_6_material_string;
MCNUM priority = mccchannel_6_analyzer_1_array_crystal_array_6_priority;
MCNUM xwidth = mccchannel_6_analyzer_1_array_crystal_array_6_xwidth;
MCNUM yheight = mccchannel_6_analyzer_1_array_crystal_array_6_yheight;
MCNUM zdepth = mccchannel_6_analyzer_1_array_crystal_array_6_zdepth;
MCNUM xwidth2 = mccchannel_6_analyzer_1_array_crystal_array_6_xwidth2;
MCNUM yheight2 = mccchannel_6_analyzer_1_array_crystal_array_6_yheight2;
MCNUM visualize = mccchannel_6_analyzer_1_array_crystal_array_6_visualize;
int target_index = mccchannel_6_analyzer_1_array_crystal_array_6_target_index;
MCNUM target_x = mccchannel_6_analyzer_1_array_crystal_array_6_target_x;
MCNUM target_y = mccchannel_6_analyzer_1_array_crystal_array_6_target_y;
MCNUM target_z = mccchannel_6_analyzer_1_array_crystal_array_6_target_z;
MCNUM focus_aw = mccchannel_6_analyzer_1_array_crystal_array_6_focus_aw;
MCNUM focus_ah = mccchannel_6_analyzer_1_array_crystal_array_6_focus_ah;
MCNUM focus_xw = mccchannel_6_analyzer_1_array_crystal_array_6_focus_xw;
MCNUM focus_xh = mccchannel_6_analyzer_1_array_crystal_array_6_focus_xh;
MCNUM focus_r = mccchannel_6_analyzer_1_array_crystal_array_6_focus_r;
MCNUM p_interact = mccchannel_6_analyzer_1_array_crystal_array_6_p_interact;
char* mask_string = mccchannel_6_analyzer_1_array_crystal_array_6_mask_string;
char* mask_setting = mccchannel_6_analyzer_1_array_crystal_array_6_mask_setting;
MCNUM number_of_activations = mccchannel_6_analyzer_1_array_crystal_array_6_number_of_activations;
}   /* End of channel_6_analyzer_1_array_crystal_array_6=Union_box() SETTING parameter declarations. */
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex
  /* Label for restoring  neutron */
  mcabsorbCompchannel_6_analyzer_1_array_crystal_array_6:
  if (RESTORE) /* restore if needed */
  { RESTORE_NEUTRON(364,
      mcnlx,
      mcnly,
      mcnlz,
      mcnlvx,
      mcnlvy,
      mcnlvz,
      mcnlt,
      mcnlsx,
      mcnlsy,
      mcnlsz,
      mcnlp); }
#undef mcabsorbComp
#undef p
#undef sz
#undef sy
#undef sx
#undef t
#undef vz
#undef vy
#undef vx
#undef z
#undef y
#undef x
  mcDEBUG_STATE(
mcnlx,
mcnly,
mcnlz,
mcnlvx,
mcnlvy,
mcnlvz,
mcnlt,
mcnlsx,
mcnlsy,
mcnlsz,
mcnlp)

  /* TRACE Component channel_6_analyzer_1_array_crystal_array_7 [365] */
  mccoordschange(mcposrchannel_6_analyzer_1_array_crystal_array_7, mcrotrchannel_6_analyzer_1_array_crystal_array_7,
    &mcnlx,
    &mcnly,
    &mcnlz,
    &mcnlvx,
    &mcnlvy,
    &mcnlvz,
    &mcnlsx,
    &mcnlsy,
    &mcnlsz);
  /* define label inside component channel_6_analyzer_1_array_crystal_array_7 (without coords transformations) */
  mcJumpTrace_channel_6_analyzer_1_array_crystal_array_7:
  SIG_MESSAGE("channel_6_analyzer_1_array_crystal_array_7 (Trace)");
  mcDEBUG_COMP("channel_6_analyzer_1_array_crystal_array_7")
  mcDEBUG_STATE(
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp)
#define x mcnlx
#define y mcnly
#define z mcnlz
#define vx mcnlvx
#define vy mcnlvy
#define vz mcnlvz
#define t mcnlt
#define sx mcnlsx
#define sy mcnlsy
#define sz mcnlsz
#define p mcnlp

#define mcabsorbComp mcabsorbCompchannel_6_analyzer_1_array_crystal_array_7
  STORE_NEUTRON(365,
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp);
  mcScattered=0;
  mcRestore=0;
  mcNCounter[365]++;
  mcPCounter[365] += p;
  mcP2Counter[365] += p*p;
#define mccompcurname  channel_6_analyzer_1_array_crystal_array_7
#define mccompcurtype  Union_box
#define mccompcurindex 365
#define loop_index mccchannel_6_analyzer_1_array_crystal_array_7_loop_index
#define this_box_volume mccchannel_6_analyzer_1_array_crystal_array_7_this_box_volume
#define global_geometry_element mccchannel_6_analyzer_1_array_crystal_array_7_global_geometry_element
#define this_box_storage mccchannel_6_analyzer_1_array_crystal_array_7_this_box_storage
{   /* Declarations of channel_6_analyzer_1_array_crystal_array_7=Union_box() SETTING parameters. */
char* material_string = mccchannel_6_analyzer_1_array_crystal_array_7_material_string;
MCNUM priority = mccchannel_6_analyzer_1_array_crystal_array_7_priority;
MCNUM xwidth = mccchannel_6_analyzer_1_array_crystal_array_7_xwidth;
MCNUM yheight = mccchannel_6_analyzer_1_array_crystal_array_7_yheight;
MCNUM zdepth = mccchannel_6_analyzer_1_array_crystal_array_7_zdepth;
MCNUM xwidth2 = mccchannel_6_analyzer_1_array_crystal_array_7_xwidth2;
MCNUM yheight2 = mccchannel_6_analyzer_1_array_crystal_array_7_yheight2;
MCNUM visualize = mccchannel_6_analyzer_1_array_crystal_array_7_visualize;
int target_index = mccchannel_6_analyzer_1_array_crystal_array_7_target_index;
MCNUM target_x = mccchannel_6_analyzer_1_array_crystal_array_7_target_x;
MCNUM target_y = mccchannel_6_analyzer_1_array_crystal_array_7_target_y;
MCNUM target_z = mccchannel_6_analyzer_1_array_crystal_array_7_target_z;
MCNUM focus_aw = mccchannel_6_analyzer_1_array_crystal_array_7_focus_aw;
MCNUM focus_ah = mccchannel_6_analyzer_1_array_crystal_array_7_focus_ah;
MCNUM focus_xw = mccchannel_6_analyzer_1_array_crystal_array_7_focus_xw;
MCNUM focus_xh = mccchannel_6_analyzer_1_array_crystal_array_7_focus_xh;
MCNUM focus_r = mccchannel_6_analyzer_1_array_crystal_array_7_focus_r;
MCNUM p_interact = mccchannel_6_analyzer_1_array_crystal_array_7_p_interact;
char* mask_string = mccchannel_6_analyzer_1_array_crystal_array_7_mask_string;
char* mask_setting = mccchannel_6_analyzer_1_array_crystal_array_7_mask_setting;
MCNUM number_of_activations = mccchannel_6_analyzer_1_array_crystal_array_7_number_of_activations;
}   /* End of channel_6_analyzer_1_array_crystal_array_7=Union_box() SETTING parameter declarations. */
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex
  /* Label for restoring  neutron */
  mcabsorbCompchannel_6_analyzer_1_array_crystal_array_7:
  if (RESTORE) /* restore if needed */
  { RESTORE_NEUTRON(365,
      mcnlx,
      mcnly,
      mcnlz,
      mcnlvx,
      mcnlvy,
      mcnlvz,
      mcnlt,
      mcnlsx,
      mcnlsy,
      mcnlsz,
      mcnlp); }
#undef mcabsorbComp
#undef p
#undef sz
#undef sy
#undef sx
#undef t
#undef vz
#undef vy
#undef vx
#undef z
#undef y
#undef x
  mcDEBUG_STATE(
mcnlx,
mcnly,
mcnlz,
mcnlvx,
mcnlvy,
mcnlvz,
mcnlt,
mcnlsx,
mcnlsy,
mcnlsz,
mcnlp)

  /* TRACE Component channel_6_analyzer_1_array_crystal_array_8 [366] */
  mccoordschange(mcposrchannel_6_analyzer_1_array_crystal_array_8, mcrotrchannel_6_analyzer_1_array_crystal_array_8,
    &mcnlx,
    &mcnly,
    &mcnlz,
    &mcnlvx,
    &mcnlvy,
    &mcnlvz,
    &mcnlsx,
    &mcnlsy,
    &mcnlsz);
  /* define label inside component channel_6_analyzer_1_array_crystal_array_8 (without coords transformations) */
  mcJumpTrace_channel_6_analyzer_1_array_crystal_array_8:
  SIG_MESSAGE("channel_6_analyzer_1_array_crystal_array_8 (Trace)");
  mcDEBUG_COMP("channel_6_analyzer_1_array_crystal_array_8")
  mcDEBUG_STATE(
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp)
#define x mcnlx
#define y mcnly
#define z mcnlz
#define vx mcnlvx
#define vy mcnlvy
#define vz mcnlvz
#define t mcnlt
#define sx mcnlsx
#define sy mcnlsy
#define sz mcnlsz
#define p mcnlp

#define mcabsorbComp mcabsorbCompchannel_6_analyzer_1_array_crystal_array_8
  STORE_NEUTRON(366,
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp);
  mcScattered=0;
  mcRestore=0;
  mcNCounter[366]++;
  mcPCounter[366] += p;
  mcP2Counter[366] += p*p;
#define mccompcurname  channel_6_analyzer_1_array_crystal_array_8
#define mccompcurtype  Union_box
#define mccompcurindex 366
#define loop_index mccchannel_6_analyzer_1_array_crystal_array_8_loop_index
#define this_box_volume mccchannel_6_analyzer_1_array_crystal_array_8_this_box_volume
#define global_geometry_element mccchannel_6_analyzer_1_array_crystal_array_8_global_geometry_element
#define this_box_storage mccchannel_6_analyzer_1_array_crystal_array_8_this_box_storage
{   /* Declarations of channel_6_analyzer_1_array_crystal_array_8=Union_box() SETTING parameters. */
char* material_string = mccchannel_6_analyzer_1_array_crystal_array_8_material_string;
MCNUM priority = mccchannel_6_analyzer_1_array_crystal_array_8_priority;
MCNUM xwidth = mccchannel_6_analyzer_1_array_crystal_array_8_xwidth;
MCNUM yheight = mccchannel_6_analyzer_1_array_crystal_array_8_yheight;
MCNUM zdepth = mccchannel_6_analyzer_1_array_crystal_array_8_zdepth;
MCNUM xwidth2 = mccchannel_6_analyzer_1_array_crystal_array_8_xwidth2;
MCNUM yheight2 = mccchannel_6_analyzer_1_array_crystal_array_8_yheight2;
MCNUM visualize = mccchannel_6_analyzer_1_array_crystal_array_8_visualize;
int target_index = mccchannel_6_analyzer_1_array_crystal_array_8_target_index;
MCNUM target_x = mccchannel_6_analyzer_1_array_crystal_array_8_target_x;
MCNUM target_y = mccchannel_6_analyzer_1_array_crystal_array_8_target_y;
MCNUM target_z = mccchannel_6_analyzer_1_array_crystal_array_8_target_z;
MCNUM focus_aw = mccchannel_6_analyzer_1_array_crystal_array_8_focus_aw;
MCNUM focus_ah = mccchannel_6_analyzer_1_array_crystal_array_8_focus_ah;
MCNUM focus_xw = mccchannel_6_analyzer_1_array_crystal_array_8_focus_xw;
MCNUM focus_xh = mccchannel_6_analyzer_1_array_crystal_array_8_focus_xh;
MCNUM focus_r = mccchannel_6_analyzer_1_array_crystal_array_8_focus_r;
MCNUM p_interact = mccchannel_6_analyzer_1_array_crystal_array_8_p_interact;
char* mask_string = mccchannel_6_analyzer_1_array_crystal_array_8_mask_string;
char* mask_setting = mccchannel_6_analyzer_1_array_crystal_array_8_mask_setting;
MCNUM number_of_activations = mccchannel_6_analyzer_1_array_crystal_array_8_number_of_activations;
}   /* End of channel_6_analyzer_1_array_crystal_array_8=Union_box() SETTING parameter declarations. */
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex
  /* Label for restoring  neutron */
  mcabsorbCompchannel_6_analyzer_1_array_crystal_array_8:
  if (RESTORE) /* restore if needed */
  { RESTORE_NEUTRON(366,
      mcnlx,
      mcnly,
      mcnlz,
      mcnlvx,
      mcnlvy,
      mcnlvz,
      mcnlt,
      mcnlsx,
      mcnlsy,
      mcnlsz,
      mcnlp); }
#undef mcabsorbComp
#undef p
#undef sz
#undef sy
#undef sx
#undef t
#undef vz
#undef vy
#undef vx
#undef z
#undef y
#undef x
  mcDEBUG_STATE(
mcnlx,
mcnly,
mcnlz,
mcnlvx,
mcnlvy,
mcnlvz,
mcnlt,
mcnlsx,
mcnlsy,
mcnlsz,
mcnlp)

  /* TRACE Component channel_6_analyzer_2_center [367] */
  mccoordschange(mcposrchannel_6_analyzer_2_center, mcrotrchannel_6_analyzer_2_center,
    &mcnlx,
    &mcnly,
    &mcnlz,
    &mcnlvx,
    &mcnlvy,
    &mcnlvz,
    &mcnlsx,
    &mcnlsy,
    &mcnlsz);
  /* define label inside component channel_6_analyzer_2_center (without coords transformations) */
  mcJumpTrace_channel_6_analyzer_2_center:
  SIG_MESSAGE("channel_6_analyzer_2_center (Trace)");
  mcDEBUG_COMP("channel_6_analyzer_2_center")
  mcDEBUG_STATE(
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp)
#define x mcnlx
#define y mcnly
#define z mcnlz
#define vx mcnlvx
#define vy mcnlvy
#define vz mcnlvz
#define t mcnlt
#define sx mcnlsx
#define sy mcnlsy
#define sz mcnlsz
#define p mcnlp

#define mcabsorbComp mcabsorbCompchannel_6_analyzer_2_center
  STORE_NEUTRON(367,
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp);
  mcScattered=0;
  mcRestore=0;
  mcNCounter[367]++;
  mcPCounter[367] += p;
  mcP2Counter[367] += p*p;
#define mccompcurname  channel_6_analyzer_2_center
#define mccompcurtype  Arm
#define mccompcurindex 367
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex
  /* Label for restoring  neutron */
  mcabsorbCompchannel_6_analyzer_2_center:
  if (RESTORE) /* restore if needed */
  { RESTORE_NEUTRON(367,
      mcnlx,
      mcnly,
      mcnlz,
      mcnlvx,
      mcnlvy,
      mcnlvz,
      mcnlt,
      mcnlsx,
      mcnlsy,
      mcnlsz,
      mcnlp); }
#undef mcabsorbComp
#undef p
#undef sz
#undef sy
#undef sx
#undef t
#undef vz
#undef vy
#undef vx
#undef z
#undef y
#undef x
  mcDEBUG_STATE(
mcnlx,
mcnly,
mcnlz,
mcnlvx,
mcnlvy,
mcnlvz,
mcnlt,
mcnlsx,
mcnlsy,
mcnlsz,
mcnlp)

  /* TRACE Component channel_6_analyzer_2_rotated [368] */
  mccoordschange(mcposrchannel_6_analyzer_2_rotated, mcrotrchannel_6_analyzer_2_rotated,
    &mcnlx,
    &mcnly,
    &mcnlz,
    &mcnlvx,
    &mcnlvy,
    &mcnlvz,
    &mcnlsx,
    &mcnlsy,
    &mcnlsz);
  /* define label inside component channel_6_analyzer_2_rotated (without coords transformations) */
  mcJumpTrace_channel_6_analyzer_2_rotated:
  SIG_MESSAGE("channel_6_analyzer_2_rotated (Trace)");
  mcDEBUG_COMP("channel_6_analyzer_2_rotated")
  mcDEBUG_STATE(
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp)
#define x mcnlx
#define y mcnly
#define z mcnlz
#define vx mcnlvx
#define vy mcnlvy
#define vz mcnlvz
#define t mcnlt
#define sx mcnlsx
#define sy mcnlsy
#define sz mcnlsz
#define p mcnlp

#define mcabsorbComp mcabsorbCompchannel_6_analyzer_2_rotated
  STORE_NEUTRON(368,
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp);
  mcScattered=0;
  mcRestore=0;
  mcNCounter[368]++;
  mcPCounter[368] += p;
  mcP2Counter[368] += p*p;
#define mccompcurname  channel_6_analyzer_2_rotated
#define mccompcurtype  Arm
#define mccompcurindex 368
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex
  /* Label for restoring  neutron */
  mcabsorbCompchannel_6_analyzer_2_rotated:
  if (RESTORE) /* restore if needed */
  { RESTORE_NEUTRON(368,
      mcnlx,
      mcnly,
      mcnlz,
      mcnlvx,
      mcnlvy,
      mcnlvz,
      mcnlt,
      mcnlsx,
      mcnlsy,
      mcnlsz,
      mcnlp); }
#undef mcabsorbComp
#undef p
#undef sz
#undef sy
#undef sx
#undef t
#undef vz
#undef vy
#undef vx
#undef z
#undef y
#undef x
  mcDEBUG_STATE(
mcnlx,
mcnly,
mcnlz,
mcnlvx,
mcnlvy,
mcnlvz,
mcnlt,
mcnlsx,
mcnlsy,
mcnlsz,
mcnlp)

  /* TRACE Component channel_6_analyzer_2_array_crystal_array_0 [369] */
  mccoordschange(mcposrchannel_6_analyzer_2_array_crystal_array_0, mcrotrchannel_6_analyzer_2_array_crystal_array_0,
    &mcnlx,
    &mcnly,
    &mcnlz,
    &mcnlvx,
    &mcnlvy,
    &mcnlvz,
    &mcnlsx,
    &mcnlsy,
    &mcnlsz);
  /* define label inside component channel_6_analyzer_2_array_crystal_array_0 (without coords transformations) */
  mcJumpTrace_channel_6_analyzer_2_array_crystal_array_0:
  SIG_MESSAGE("channel_6_analyzer_2_array_crystal_array_0 (Trace)");
  mcDEBUG_COMP("channel_6_analyzer_2_array_crystal_array_0")
  mcDEBUG_STATE(
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp)
#define x mcnlx
#define y mcnly
#define z mcnlz
#define vx mcnlvx
#define vy mcnlvy
#define vz mcnlvz
#define t mcnlt
#define sx mcnlsx
#define sy mcnlsy
#define sz mcnlsz
#define p mcnlp

#define mcabsorbComp mcabsorbCompchannel_6_analyzer_2_array_crystal_array_0
  STORE_NEUTRON(369,
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp);
  mcScattered=0;
  mcRestore=0;
  mcNCounter[369]++;
  mcPCounter[369] += p;
  mcP2Counter[369] += p*p;
#define mccompcurname  channel_6_analyzer_2_array_crystal_array_0
#define mccompcurtype  Union_box
#define mccompcurindex 369
#define loop_index mccchannel_6_analyzer_2_array_crystal_array_0_loop_index
#define this_box_volume mccchannel_6_analyzer_2_array_crystal_array_0_this_box_volume
#define global_geometry_element mccchannel_6_analyzer_2_array_crystal_array_0_global_geometry_element
#define this_box_storage mccchannel_6_analyzer_2_array_crystal_array_0_this_box_storage
{   /* Declarations of channel_6_analyzer_2_array_crystal_array_0=Union_box() SETTING parameters. */
char* material_string = mccchannel_6_analyzer_2_array_crystal_array_0_material_string;
MCNUM priority = mccchannel_6_analyzer_2_array_crystal_array_0_priority;
MCNUM xwidth = mccchannel_6_analyzer_2_array_crystal_array_0_xwidth;
MCNUM yheight = mccchannel_6_analyzer_2_array_crystal_array_0_yheight;
MCNUM zdepth = mccchannel_6_analyzer_2_array_crystal_array_0_zdepth;
MCNUM xwidth2 = mccchannel_6_analyzer_2_array_crystal_array_0_xwidth2;
MCNUM yheight2 = mccchannel_6_analyzer_2_array_crystal_array_0_yheight2;
MCNUM visualize = mccchannel_6_analyzer_2_array_crystal_array_0_visualize;
int target_index = mccchannel_6_analyzer_2_array_crystal_array_0_target_index;
MCNUM target_x = mccchannel_6_analyzer_2_array_crystal_array_0_target_x;
MCNUM target_y = mccchannel_6_analyzer_2_array_crystal_array_0_target_y;
MCNUM target_z = mccchannel_6_analyzer_2_array_crystal_array_0_target_z;
MCNUM focus_aw = mccchannel_6_analyzer_2_array_crystal_array_0_focus_aw;
MCNUM focus_ah = mccchannel_6_analyzer_2_array_crystal_array_0_focus_ah;
MCNUM focus_xw = mccchannel_6_analyzer_2_array_crystal_array_0_focus_xw;
MCNUM focus_xh = mccchannel_6_analyzer_2_array_crystal_array_0_focus_xh;
MCNUM focus_r = mccchannel_6_analyzer_2_array_crystal_array_0_focus_r;
MCNUM p_interact = mccchannel_6_analyzer_2_array_crystal_array_0_p_interact;
char* mask_string = mccchannel_6_analyzer_2_array_crystal_array_0_mask_string;
char* mask_setting = mccchannel_6_analyzer_2_array_crystal_array_0_mask_setting;
MCNUM number_of_activations = mccchannel_6_analyzer_2_array_crystal_array_0_number_of_activations;
}   /* End of channel_6_analyzer_2_array_crystal_array_0=Union_box() SETTING parameter declarations. */
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex
  /* Label for restoring  neutron */
  mcabsorbCompchannel_6_analyzer_2_array_crystal_array_0:
  if (RESTORE) /* restore if needed */
  { RESTORE_NEUTRON(369,
      mcnlx,
      mcnly,
      mcnlz,
      mcnlvx,
      mcnlvy,
      mcnlvz,
      mcnlt,
      mcnlsx,
      mcnlsy,
      mcnlsz,
      mcnlp); }
#undef mcabsorbComp
#undef p
#undef sz
#undef sy
#undef sx
#undef t
#undef vz
#undef vy
#undef vx
#undef z
#undef y
#undef x
  mcDEBUG_STATE(
mcnlx,
mcnly,
mcnlz,
mcnlvx,
mcnlvy,
mcnlvz,
mcnlt,
mcnlsx,
mcnlsy,
mcnlsz,
mcnlp)

  /* TRACE Component channel_6_analyzer_2_array_crystal_array_1 [370] */
  mccoordschange(mcposrchannel_6_analyzer_2_array_crystal_array_1, mcrotrchannel_6_analyzer_2_array_crystal_array_1,
    &mcnlx,
    &mcnly,
    &mcnlz,
    &mcnlvx,
    &mcnlvy,
    &mcnlvz,
    &mcnlsx,
    &mcnlsy,
    &mcnlsz);
  /* define label inside component channel_6_analyzer_2_array_crystal_array_1 (without coords transformations) */
  mcJumpTrace_channel_6_analyzer_2_array_crystal_array_1:
  SIG_MESSAGE("channel_6_analyzer_2_array_crystal_array_1 (Trace)");
  mcDEBUG_COMP("channel_6_analyzer_2_array_crystal_array_1")
  mcDEBUG_STATE(
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp)
#define x mcnlx
#define y mcnly
#define z mcnlz
#define vx mcnlvx
#define vy mcnlvy
#define vz mcnlvz
#define t mcnlt
#define sx mcnlsx
#define sy mcnlsy
#define sz mcnlsz
#define p mcnlp

#define mcabsorbComp mcabsorbCompchannel_6_analyzer_2_array_crystal_array_1
  STORE_NEUTRON(370,
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp);
  mcScattered=0;
  mcRestore=0;
  mcNCounter[370]++;
  mcPCounter[370] += p;
  mcP2Counter[370] += p*p;
#define mccompcurname  channel_6_analyzer_2_array_crystal_array_1
#define mccompcurtype  Union_box
#define mccompcurindex 370
#define loop_index mccchannel_6_analyzer_2_array_crystal_array_1_loop_index
#define this_box_volume mccchannel_6_analyzer_2_array_crystal_array_1_this_box_volume
#define global_geometry_element mccchannel_6_analyzer_2_array_crystal_array_1_global_geometry_element
#define this_box_storage mccchannel_6_analyzer_2_array_crystal_array_1_this_box_storage
{   /* Declarations of channel_6_analyzer_2_array_crystal_array_1=Union_box() SETTING parameters. */
char* material_string = mccchannel_6_analyzer_2_array_crystal_array_1_material_string;
MCNUM priority = mccchannel_6_analyzer_2_array_crystal_array_1_priority;
MCNUM xwidth = mccchannel_6_analyzer_2_array_crystal_array_1_xwidth;
MCNUM yheight = mccchannel_6_analyzer_2_array_crystal_array_1_yheight;
MCNUM zdepth = mccchannel_6_analyzer_2_array_crystal_array_1_zdepth;
MCNUM xwidth2 = mccchannel_6_analyzer_2_array_crystal_array_1_xwidth2;
MCNUM yheight2 = mccchannel_6_analyzer_2_array_crystal_array_1_yheight2;
MCNUM visualize = mccchannel_6_analyzer_2_array_crystal_array_1_visualize;
int target_index = mccchannel_6_analyzer_2_array_crystal_array_1_target_index;
MCNUM target_x = mccchannel_6_analyzer_2_array_crystal_array_1_target_x;
MCNUM target_y = mccchannel_6_analyzer_2_array_crystal_array_1_target_y;
MCNUM target_z = mccchannel_6_analyzer_2_array_crystal_array_1_target_z;
MCNUM focus_aw = mccchannel_6_analyzer_2_array_crystal_array_1_focus_aw;
MCNUM focus_ah = mccchannel_6_analyzer_2_array_crystal_array_1_focus_ah;
MCNUM focus_xw = mccchannel_6_analyzer_2_array_crystal_array_1_focus_xw;
MCNUM focus_xh = mccchannel_6_analyzer_2_array_crystal_array_1_focus_xh;
MCNUM focus_r = mccchannel_6_analyzer_2_array_crystal_array_1_focus_r;
MCNUM p_interact = mccchannel_6_analyzer_2_array_crystal_array_1_p_interact;
char* mask_string = mccchannel_6_analyzer_2_array_crystal_array_1_mask_string;
char* mask_setting = mccchannel_6_analyzer_2_array_crystal_array_1_mask_setting;
MCNUM number_of_activations = mccchannel_6_analyzer_2_array_crystal_array_1_number_of_activations;
}   /* End of channel_6_analyzer_2_array_crystal_array_1=Union_box() SETTING parameter declarations. */
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex
  /* Label for restoring  neutron */
  mcabsorbCompchannel_6_analyzer_2_array_crystal_array_1:
  if (RESTORE) /* restore if needed */
  { RESTORE_NEUTRON(370,
      mcnlx,
      mcnly,
      mcnlz,
      mcnlvx,
      mcnlvy,
      mcnlvz,
      mcnlt,
      mcnlsx,
      mcnlsy,
      mcnlsz,
      mcnlp); }
#undef mcabsorbComp
#undef p
#undef sz
#undef sy
#undef sx
#undef t
#undef vz
#undef vy
#undef vx
#undef z
#undef y
#undef x
  mcDEBUG_STATE(
mcnlx,
mcnly,
mcnlz,
mcnlvx,
mcnlvy,
mcnlvz,
mcnlt,
mcnlsx,
mcnlsy,
mcnlsz,
mcnlp)

  /* TRACE Component channel_6_analyzer_2_array_crystal_array_2 [371] */
  mccoordschange(mcposrchannel_6_analyzer_2_array_crystal_array_2, mcrotrchannel_6_analyzer_2_array_crystal_array_2,
    &mcnlx,
    &mcnly,
    &mcnlz,
    &mcnlvx,
    &mcnlvy,
    &mcnlvz,
    &mcnlsx,
    &mcnlsy,
    &mcnlsz);
  /* define label inside component channel_6_analyzer_2_array_crystal_array_2 (without coords transformations) */
  mcJumpTrace_channel_6_analyzer_2_array_crystal_array_2:
  SIG_MESSAGE("channel_6_analyzer_2_array_crystal_array_2 (Trace)");
  mcDEBUG_COMP("channel_6_analyzer_2_array_crystal_array_2")
  mcDEBUG_STATE(
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp)
#define x mcnlx
#define y mcnly
#define z mcnlz
#define vx mcnlvx
#define vy mcnlvy
#define vz mcnlvz
#define t mcnlt
#define sx mcnlsx
#define sy mcnlsy
#define sz mcnlsz
#define p mcnlp

#define mcabsorbComp mcabsorbCompchannel_6_analyzer_2_array_crystal_array_2
  STORE_NEUTRON(371,
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp);
  mcScattered=0;
  mcRestore=0;
  mcNCounter[371]++;
  mcPCounter[371] += p;
  mcP2Counter[371] += p*p;
#define mccompcurname  channel_6_analyzer_2_array_crystal_array_2
#define mccompcurtype  Union_box
#define mccompcurindex 371
#define loop_index mccchannel_6_analyzer_2_array_crystal_array_2_loop_index
#define this_box_volume mccchannel_6_analyzer_2_array_crystal_array_2_this_box_volume
#define global_geometry_element mccchannel_6_analyzer_2_array_crystal_array_2_global_geometry_element
#define this_box_storage mccchannel_6_analyzer_2_array_crystal_array_2_this_box_storage
{   /* Declarations of channel_6_analyzer_2_array_crystal_array_2=Union_box() SETTING parameters. */
char* material_string = mccchannel_6_analyzer_2_array_crystal_array_2_material_string;
MCNUM priority = mccchannel_6_analyzer_2_array_crystal_array_2_priority;
MCNUM xwidth = mccchannel_6_analyzer_2_array_crystal_array_2_xwidth;
MCNUM yheight = mccchannel_6_analyzer_2_array_crystal_array_2_yheight;
MCNUM zdepth = mccchannel_6_analyzer_2_array_crystal_array_2_zdepth;
MCNUM xwidth2 = mccchannel_6_analyzer_2_array_crystal_array_2_xwidth2;
MCNUM yheight2 = mccchannel_6_analyzer_2_array_crystal_array_2_yheight2;
MCNUM visualize = mccchannel_6_analyzer_2_array_crystal_array_2_visualize;
int target_index = mccchannel_6_analyzer_2_array_crystal_array_2_target_index;
MCNUM target_x = mccchannel_6_analyzer_2_array_crystal_array_2_target_x;
MCNUM target_y = mccchannel_6_analyzer_2_array_crystal_array_2_target_y;
MCNUM target_z = mccchannel_6_analyzer_2_array_crystal_array_2_target_z;
MCNUM focus_aw = mccchannel_6_analyzer_2_array_crystal_array_2_focus_aw;
MCNUM focus_ah = mccchannel_6_analyzer_2_array_crystal_array_2_focus_ah;
MCNUM focus_xw = mccchannel_6_analyzer_2_array_crystal_array_2_focus_xw;
MCNUM focus_xh = mccchannel_6_analyzer_2_array_crystal_array_2_focus_xh;
MCNUM focus_r = mccchannel_6_analyzer_2_array_crystal_array_2_focus_r;
MCNUM p_interact = mccchannel_6_analyzer_2_array_crystal_array_2_p_interact;
char* mask_string = mccchannel_6_analyzer_2_array_crystal_array_2_mask_string;
char* mask_setting = mccchannel_6_analyzer_2_array_crystal_array_2_mask_setting;
MCNUM number_of_activations = mccchannel_6_analyzer_2_array_crystal_array_2_number_of_activations;
}   /* End of channel_6_analyzer_2_array_crystal_array_2=Union_box() SETTING parameter declarations. */
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex
  /* Label for restoring  neutron */
  mcabsorbCompchannel_6_analyzer_2_array_crystal_array_2:
  if (RESTORE) /* restore if needed */
  { RESTORE_NEUTRON(371,
      mcnlx,
      mcnly,
      mcnlz,
      mcnlvx,
      mcnlvy,
      mcnlvz,
      mcnlt,
      mcnlsx,
      mcnlsy,
      mcnlsz,
      mcnlp); }
#undef mcabsorbComp
#undef p
#undef sz
#undef sy
#undef sx
#undef t
#undef vz
#undef vy
#undef vx
#undef z
#undef y
#undef x
  mcDEBUG_STATE(
mcnlx,
mcnly,
mcnlz,
mcnlvx,
mcnlvy,
mcnlvz,
mcnlt,
mcnlsx,
mcnlsy,
mcnlsz,
mcnlp)

  /* TRACE Component channel_6_analyzer_2_array_crystal_array_3 [372] */
  mccoordschange(mcposrchannel_6_analyzer_2_array_crystal_array_3, mcrotrchannel_6_analyzer_2_array_crystal_array_3,
    &mcnlx,
    &mcnly,
    &mcnlz,
    &mcnlvx,
    &mcnlvy,
    &mcnlvz,
    &mcnlsx,
    &mcnlsy,
    &mcnlsz);
  /* define label inside component channel_6_analyzer_2_array_crystal_array_3 (without coords transformations) */
  mcJumpTrace_channel_6_analyzer_2_array_crystal_array_3:
  SIG_MESSAGE("channel_6_analyzer_2_array_crystal_array_3 (Trace)");
  mcDEBUG_COMP("channel_6_analyzer_2_array_crystal_array_3")
  mcDEBUG_STATE(
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp)
#define x mcnlx
#define y mcnly
#define z mcnlz
#define vx mcnlvx
#define vy mcnlvy
#define vz mcnlvz
#define t mcnlt
#define sx mcnlsx
#define sy mcnlsy
#define sz mcnlsz
#define p mcnlp

#define mcabsorbComp mcabsorbCompchannel_6_analyzer_2_array_crystal_array_3
  STORE_NEUTRON(372,
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp);
  mcScattered=0;
  mcRestore=0;
  mcNCounter[372]++;
  mcPCounter[372] += p;
  mcP2Counter[372] += p*p;
#define mccompcurname  channel_6_analyzer_2_array_crystal_array_3
#define mccompcurtype  Union_box
#define mccompcurindex 372
#define loop_index mccchannel_6_analyzer_2_array_crystal_array_3_loop_index
#define this_box_volume mccchannel_6_analyzer_2_array_crystal_array_3_this_box_volume
#define global_geometry_element mccchannel_6_analyzer_2_array_crystal_array_3_global_geometry_element
#define this_box_storage mccchannel_6_analyzer_2_array_crystal_array_3_this_box_storage
{   /* Declarations of channel_6_analyzer_2_array_crystal_array_3=Union_box() SETTING parameters. */
char* material_string = mccchannel_6_analyzer_2_array_crystal_array_3_material_string;
MCNUM priority = mccchannel_6_analyzer_2_array_crystal_array_3_priority;
MCNUM xwidth = mccchannel_6_analyzer_2_array_crystal_array_3_xwidth;
MCNUM yheight = mccchannel_6_analyzer_2_array_crystal_array_3_yheight;
MCNUM zdepth = mccchannel_6_analyzer_2_array_crystal_array_3_zdepth;
MCNUM xwidth2 = mccchannel_6_analyzer_2_array_crystal_array_3_xwidth2;
MCNUM yheight2 = mccchannel_6_analyzer_2_array_crystal_array_3_yheight2;
MCNUM visualize = mccchannel_6_analyzer_2_array_crystal_array_3_visualize;
int target_index = mccchannel_6_analyzer_2_array_crystal_array_3_target_index;
MCNUM target_x = mccchannel_6_analyzer_2_array_crystal_array_3_target_x;
MCNUM target_y = mccchannel_6_analyzer_2_array_crystal_array_3_target_y;
MCNUM target_z = mccchannel_6_analyzer_2_array_crystal_array_3_target_z;
MCNUM focus_aw = mccchannel_6_analyzer_2_array_crystal_array_3_focus_aw;
MCNUM focus_ah = mccchannel_6_analyzer_2_array_crystal_array_3_focus_ah;
MCNUM focus_xw = mccchannel_6_analyzer_2_array_crystal_array_3_focus_xw;
MCNUM focus_xh = mccchannel_6_analyzer_2_array_crystal_array_3_focus_xh;
MCNUM focus_r = mccchannel_6_analyzer_2_array_crystal_array_3_focus_r;
MCNUM p_interact = mccchannel_6_analyzer_2_array_crystal_array_3_p_interact;
char* mask_string = mccchannel_6_analyzer_2_array_crystal_array_3_mask_string;
char* mask_setting = mccchannel_6_analyzer_2_array_crystal_array_3_mask_setting;
MCNUM number_of_activations = mccchannel_6_analyzer_2_array_crystal_array_3_number_of_activations;
}   /* End of channel_6_analyzer_2_array_crystal_array_3=Union_box() SETTING parameter declarations. */
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex
  /* Label for restoring  neutron */
  mcabsorbCompchannel_6_analyzer_2_array_crystal_array_3:
  if (RESTORE) /* restore if needed */
  { RESTORE_NEUTRON(372,
      mcnlx,
      mcnly,
      mcnlz,
      mcnlvx,
      mcnlvy,
      mcnlvz,
      mcnlt,
      mcnlsx,
      mcnlsy,
      mcnlsz,
      mcnlp); }
#undef mcabsorbComp
#undef p
#undef sz
#undef sy
#undef sx
#undef t
#undef vz
#undef vy
#undef vx
#undef z
#undef y
#undef x
  mcDEBUG_STATE(
mcnlx,
mcnly,
mcnlz,
mcnlvx,
mcnlvy,
mcnlvz,
mcnlt,
mcnlsx,
mcnlsy,
mcnlsz,
mcnlp)

  /* TRACE Component channel_6_analyzer_2_array_crystal_array_4 [373] */
  mccoordschange(mcposrchannel_6_analyzer_2_array_crystal_array_4, mcrotrchannel_6_analyzer_2_array_crystal_array_4,
    &mcnlx,
    &mcnly,
    &mcnlz,
    &mcnlvx,
    &mcnlvy,
    &mcnlvz,
    &mcnlsx,
    &mcnlsy,
    &mcnlsz);
  /* define label inside component channel_6_analyzer_2_array_crystal_array_4 (without coords transformations) */
  mcJumpTrace_channel_6_analyzer_2_array_crystal_array_4:
  SIG_MESSAGE("channel_6_analyzer_2_array_crystal_array_4 (Trace)");
  mcDEBUG_COMP("channel_6_analyzer_2_array_crystal_array_4")
  mcDEBUG_STATE(
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp)
#define x mcnlx
#define y mcnly
#define z mcnlz
#define vx mcnlvx
#define vy mcnlvy
#define vz mcnlvz
#define t mcnlt
#define sx mcnlsx
#define sy mcnlsy
#define sz mcnlsz
#define p mcnlp

#define mcabsorbComp mcabsorbCompchannel_6_analyzer_2_array_crystal_array_4
  STORE_NEUTRON(373,
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp);
  mcScattered=0;
  mcRestore=0;
  mcNCounter[373]++;
  mcPCounter[373] += p;
  mcP2Counter[373] += p*p;
#define mccompcurname  channel_6_analyzer_2_array_crystal_array_4
#define mccompcurtype  Union_box
#define mccompcurindex 373
#define loop_index mccchannel_6_analyzer_2_array_crystal_array_4_loop_index
#define this_box_volume mccchannel_6_analyzer_2_array_crystal_array_4_this_box_volume
#define global_geometry_element mccchannel_6_analyzer_2_array_crystal_array_4_global_geometry_element
#define this_box_storage mccchannel_6_analyzer_2_array_crystal_array_4_this_box_storage
{   /* Declarations of channel_6_analyzer_2_array_crystal_array_4=Union_box() SETTING parameters. */
char* material_string = mccchannel_6_analyzer_2_array_crystal_array_4_material_string;
MCNUM priority = mccchannel_6_analyzer_2_array_crystal_array_4_priority;
MCNUM xwidth = mccchannel_6_analyzer_2_array_crystal_array_4_xwidth;
MCNUM yheight = mccchannel_6_analyzer_2_array_crystal_array_4_yheight;
MCNUM zdepth = mccchannel_6_analyzer_2_array_crystal_array_4_zdepth;
MCNUM xwidth2 = mccchannel_6_analyzer_2_array_crystal_array_4_xwidth2;
MCNUM yheight2 = mccchannel_6_analyzer_2_array_crystal_array_4_yheight2;
MCNUM visualize = mccchannel_6_analyzer_2_array_crystal_array_4_visualize;
int target_index = mccchannel_6_analyzer_2_array_crystal_array_4_target_index;
MCNUM target_x = mccchannel_6_analyzer_2_array_crystal_array_4_target_x;
MCNUM target_y = mccchannel_6_analyzer_2_array_crystal_array_4_target_y;
MCNUM target_z = mccchannel_6_analyzer_2_array_crystal_array_4_target_z;
MCNUM focus_aw = mccchannel_6_analyzer_2_array_crystal_array_4_focus_aw;
MCNUM focus_ah = mccchannel_6_analyzer_2_array_crystal_array_4_focus_ah;
MCNUM focus_xw = mccchannel_6_analyzer_2_array_crystal_array_4_focus_xw;
MCNUM focus_xh = mccchannel_6_analyzer_2_array_crystal_array_4_focus_xh;
MCNUM focus_r = mccchannel_6_analyzer_2_array_crystal_array_4_focus_r;
MCNUM p_interact = mccchannel_6_analyzer_2_array_crystal_array_4_p_interact;
char* mask_string = mccchannel_6_analyzer_2_array_crystal_array_4_mask_string;
char* mask_setting = mccchannel_6_analyzer_2_array_crystal_array_4_mask_setting;
MCNUM number_of_activations = mccchannel_6_analyzer_2_array_crystal_array_4_number_of_activations;
}   /* End of channel_6_analyzer_2_array_crystal_array_4=Union_box() SETTING parameter declarations. */
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex
  /* Label for restoring  neutron */
  mcabsorbCompchannel_6_analyzer_2_array_crystal_array_4:
  if (RESTORE) /* restore if needed */
  { RESTORE_NEUTRON(373,
      mcnlx,
      mcnly,
      mcnlz,
      mcnlvx,
      mcnlvy,
      mcnlvz,
      mcnlt,
      mcnlsx,
      mcnlsy,
      mcnlsz,
      mcnlp); }
#undef mcabsorbComp
#undef p
#undef sz
#undef sy
#undef sx
#undef t
#undef vz
#undef vy
#undef vx
#undef z
#undef y
#undef x
  mcDEBUG_STATE(
mcnlx,
mcnly,
mcnlz,
mcnlvx,
mcnlvy,
mcnlvz,
mcnlt,
mcnlsx,
mcnlsy,
mcnlsz,
mcnlp)

  /* TRACE Component channel_6_analyzer_2_array_crystal_array_5 [374] */
  mccoordschange(mcposrchannel_6_analyzer_2_array_crystal_array_5, mcrotrchannel_6_analyzer_2_array_crystal_array_5,
    &mcnlx,
    &mcnly,
    &mcnlz,
    &mcnlvx,
    &mcnlvy,
    &mcnlvz,
    &mcnlsx,
    &mcnlsy,
    &mcnlsz);
  /* define label inside component channel_6_analyzer_2_array_crystal_array_5 (without coords transformations) */
  mcJumpTrace_channel_6_analyzer_2_array_crystal_array_5:
  SIG_MESSAGE("channel_6_analyzer_2_array_crystal_array_5 (Trace)");
  mcDEBUG_COMP("channel_6_analyzer_2_array_crystal_array_5")
  mcDEBUG_STATE(
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp)
#define x mcnlx
#define y mcnly
#define z mcnlz
#define vx mcnlvx
#define vy mcnlvy
#define vz mcnlvz
#define t mcnlt
#define sx mcnlsx
#define sy mcnlsy
#define sz mcnlsz
#define p mcnlp

#define mcabsorbComp mcabsorbCompchannel_6_analyzer_2_array_crystal_array_5
  STORE_NEUTRON(374,
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp);
  mcScattered=0;
  mcRestore=0;
  mcNCounter[374]++;
  mcPCounter[374] += p;
  mcP2Counter[374] += p*p;
#define mccompcurname  channel_6_analyzer_2_array_crystal_array_5
#define mccompcurtype  Union_box
#define mccompcurindex 374
#define loop_index mccchannel_6_analyzer_2_array_crystal_array_5_loop_index
#define this_box_volume mccchannel_6_analyzer_2_array_crystal_array_5_this_box_volume
#define global_geometry_element mccchannel_6_analyzer_2_array_crystal_array_5_global_geometry_element
#define this_box_storage mccchannel_6_analyzer_2_array_crystal_array_5_this_box_storage
{   /* Declarations of channel_6_analyzer_2_array_crystal_array_5=Union_box() SETTING parameters. */
char* material_string = mccchannel_6_analyzer_2_array_crystal_array_5_material_string;
MCNUM priority = mccchannel_6_analyzer_2_array_crystal_array_5_priority;
MCNUM xwidth = mccchannel_6_analyzer_2_array_crystal_array_5_xwidth;
MCNUM yheight = mccchannel_6_analyzer_2_array_crystal_array_5_yheight;
MCNUM zdepth = mccchannel_6_analyzer_2_array_crystal_array_5_zdepth;
MCNUM xwidth2 = mccchannel_6_analyzer_2_array_crystal_array_5_xwidth2;
MCNUM yheight2 = mccchannel_6_analyzer_2_array_crystal_array_5_yheight2;
MCNUM visualize = mccchannel_6_analyzer_2_array_crystal_array_5_visualize;
int target_index = mccchannel_6_analyzer_2_array_crystal_array_5_target_index;
MCNUM target_x = mccchannel_6_analyzer_2_array_crystal_array_5_target_x;
MCNUM target_y = mccchannel_6_analyzer_2_array_crystal_array_5_target_y;
MCNUM target_z = mccchannel_6_analyzer_2_array_crystal_array_5_target_z;
MCNUM focus_aw = mccchannel_6_analyzer_2_array_crystal_array_5_focus_aw;
MCNUM focus_ah = mccchannel_6_analyzer_2_array_crystal_array_5_focus_ah;
MCNUM focus_xw = mccchannel_6_analyzer_2_array_crystal_array_5_focus_xw;
MCNUM focus_xh = mccchannel_6_analyzer_2_array_crystal_array_5_focus_xh;
MCNUM focus_r = mccchannel_6_analyzer_2_array_crystal_array_5_focus_r;
MCNUM p_interact = mccchannel_6_analyzer_2_array_crystal_array_5_p_interact;
char* mask_string = mccchannel_6_analyzer_2_array_crystal_array_5_mask_string;
char* mask_setting = mccchannel_6_analyzer_2_array_crystal_array_5_mask_setting;
MCNUM number_of_activations = mccchannel_6_analyzer_2_array_crystal_array_5_number_of_activations;
}   /* End of channel_6_analyzer_2_array_crystal_array_5=Union_box() SETTING parameter declarations. */
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex
  /* Label for restoring  neutron */
  mcabsorbCompchannel_6_analyzer_2_array_crystal_array_5:
  if (RESTORE) /* restore if needed */
  { RESTORE_NEUTRON(374,
      mcnlx,
      mcnly,
      mcnlz,
      mcnlvx,
      mcnlvy,
      mcnlvz,
      mcnlt,
      mcnlsx,
      mcnlsy,
      mcnlsz,
      mcnlp); }
#undef mcabsorbComp
#undef p
#undef sz
#undef sy
#undef sx
#undef t
#undef vz
#undef vy
#undef vx
#undef z
#undef y
#undef x
  mcDEBUG_STATE(
mcnlx,
mcnly,
mcnlz,
mcnlvx,
mcnlvy,
mcnlvz,
mcnlt,
mcnlsx,
mcnlsy,
mcnlsz,
mcnlp)

  /* TRACE Component channel_6_analyzer_2_array_crystal_array_6 [375] */
  mccoordschange(mcposrchannel_6_analyzer_2_array_crystal_array_6, mcrotrchannel_6_analyzer_2_array_crystal_array_6,
    &mcnlx,
    &mcnly,
    &mcnlz,
    &mcnlvx,
    &mcnlvy,
    &mcnlvz,
    &mcnlsx,
    &mcnlsy,
    &mcnlsz);
  /* define label inside component channel_6_analyzer_2_array_crystal_array_6 (without coords transformations) */
  mcJumpTrace_channel_6_analyzer_2_array_crystal_array_6:
  SIG_MESSAGE("channel_6_analyzer_2_array_crystal_array_6 (Trace)");
  mcDEBUG_COMP("channel_6_analyzer_2_array_crystal_array_6")
  mcDEBUG_STATE(
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp)
#define x mcnlx
#define y mcnly
#define z mcnlz
#define vx mcnlvx
#define vy mcnlvy
#define vz mcnlvz
#define t mcnlt
#define sx mcnlsx
#define sy mcnlsy
#define sz mcnlsz
#define p mcnlp

#define mcabsorbComp mcabsorbCompchannel_6_analyzer_2_array_crystal_array_6
  STORE_NEUTRON(375,
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp);
  mcScattered=0;
  mcRestore=0;
  mcNCounter[375]++;
  mcPCounter[375] += p;
  mcP2Counter[375] += p*p;
#define mccompcurname  channel_6_analyzer_2_array_crystal_array_6
#define mccompcurtype  Union_box
#define mccompcurindex 375
#define loop_index mccchannel_6_analyzer_2_array_crystal_array_6_loop_index
#define this_box_volume mccchannel_6_analyzer_2_array_crystal_array_6_this_box_volume
#define global_geometry_element mccchannel_6_analyzer_2_array_crystal_array_6_global_geometry_element
#define this_box_storage mccchannel_6_analyzer_2_array_crystal_array_6_this_box_storage
{   /* Declarations of channel_6_analyzer_2_array_crystal_array_6=Union_box() SETTING parameters. */
char* material_string = mccchannel_6_analyzer_2_array_crystal_array_6_material_string;
MCNUM priority = mccchannel_6_analyzer_2_array_crystal_array_6_priority;
MCNUM xwidth = mccchannel_6_analyzer_2_array_crystal_array_6_xwidth;
MCNUM yheight = mccchannel_6_analyzer_2_array_crystal_array_6_yheight;
MCNUM zdepth = mccchannel_6_analyzer_2_array_crystal_array_6_zdepth;
MCNUM xwidth2 = mccchannel_6_analyzer_2_array_crystal_array_6_xwidth2;
MCNUM yheight2 = mccchannel_6_analyzer_2_array_crystal_array_6_yheight2;
MCNUM visualize = mccchannel_6_analyzer_2_array_crystal_array_6_visualize;
int target_index = mccchannel_6_analyzer_2_array_crystal_array_6_target_index;
MCNUM target_x = mccchannel_6_analyzer_2_array_crystal_array_6_target_x;
MCNUM target_y = mccchannel_6_analyzer_2_array_crystal_array_6_target_y;
MCNUM target_z = mccchannel_6_analyzer_2_array_crystal_array_6_target_z;
MCNUM focus_aw = mccchannel_6_analyzer_2_array_crystal_array_6_focus_aw;
MCNUM focus_ah = mccchannel_6_analyzer_2_array_crystal_array_6_focus_ah;
MCNUM focus_xw = mccchannel_6_analyzer_2_array_crystal_array_6_focus_xw;
MCNUM focus_xh = mccchannel_6_analyzer_2_array_crystal_array_6_focus_xh;
MCNUM focus_r = mccchannel_6_analyzer_2_array_crystal_array_6_focus_r;
MCNUM p_interact = mccchannel_6_analyzer_2_array_crystal_array_6_p_interact;
char* mask_string = mccchannel_6_analyzer_2_array_crystal_array_6_mask_string;
char* mask_setting = mccchannel_6_analyzer_2_array_crystal_array_6_mask_setting;
MCNUM number_of_activations = mccchannel_6_analyzer_2_array_crystal_array_6_number_of_activations;
}   /* End of channel_6_analyzer_2_array_crystal_array_6=Union_box() SETTING parameter declarations. */
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex
  /* Label for restoring  neutron */
  mcabsorbCompchannel_6_analyzer_2_array_crystal_array_6:
  if (RESTORE) /* restore if needed */
  { RESTORE_NEUTRON(375,
      mcnlx,
      mcnly,
      mcnlz,
      mcnlvx,
      mcnlvy,
      mcnlvz,
      mcnlt,
      mcnlsx,
      mcnlsy,
      mcnlsz,
      mcnlp); }
#undef mcabsorbComp
#undef p
#undef sz
#undef sy
#undef sx
#undef t
#undef vz
#undef vy
#undef vx
#undef z
#undef y
#undef x
  mcDEBUG_STATE(
mcnlx,
mcnly,
mcnlz,
mcnlvx,
mcnlvy,
mcnlvz,
mcnlt,
mcnlsx,
mcnlsy,
mcnlsz,
mcnlp)

  /* TRACE Component channel_6_analyzer_2_array_crystal_array_7 [376] */
  mccoordschange(mcposrchannel_6_analyzer_2_array_crystal_array_7, mcrotrchannel_6_analyzer_2_array_crystal_array_7,
    &mcnlx,
    &mcnly,
    &mcnlz,
    &mcnlvx,
    &mcnlvy,
    &mcnlvz,
    &mcnlsx,
    &mcnlsy,
    &mcnlsz);
  /* define label inside component channel_6_analyzer_2_array_crystal_array_7 (without coords transformations) */
  mcJumpTrace_channel_6_analyzer_2_array_crystal_array_7:
  SIG_MESSAGE("channel_6_analyzer_2_array_crystal_array_7 (Trace)");
  mcDEBUG_COMP("channel_6_analyzer_2_array_crystal_array_7")
  mcDEBUG_STATE(
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp)
#define x mcnlx
#define y mcnly
#define z mcnlz
#define vx mcnlvx
#define vy mcnlvy
#define vz mcnlvz
#define t mcnlt
#define sx mcnlsx
#define sy mcnlsy
#define sz mcnlsz
#define p mcnlp

#define mcabsorbComp mcabsorbCompchannel_6_analyzer_2_array_crystal_array_7
  STORE_NEUTRON(376,
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp);
  mcScattered=0;
  mcRestore=0;
  mcNCounter[376]++;
  mcPCounter[376] += p;
  mcP2Counter[376] += p*p;
#define mccompcurname  channel_6_analyzer_2_array_crystal_array_7
#define mccompcurtype  Union_box
#define mccompcurindex 376
#define loop_index mccchannel_6_analyzer_2_array_crystal_array_7_loop_index
#define this_box_volume mccchannel_6_analyzer_2_array_crystal_array_7_this_box_volume
#define global_geometry_element mccchannel_6_analyzer_2_array_crystal_array_7_global_geometry_element
#define this_box_storage mccchannel_6_analyzer_2_array_crystal_array_7_this_box_storage
{   /* Declarations of channel_6_analyzer_2_array_crystal_array_7=Union_box() SETTING parameters. */
char* material_string = mccchannel_6_analyzer_2_array_crystal_array_7_material_string;
MCNUM priority = mccchannel_6_analyzer_2_array_crystal_array_7_priority;
MCNUM xwidth = mccchannel_6_analyzer_2_array_crystal_array_7_xwidth;
MCNUM yheight = mccchannel_6_analyzer_2_array_crystal_array_7_yheight;
MCNUM zdepth = mccchannel_6_analyzer_2_array_crystal_array_7_zdepth;
MCNUM xwidth2 = mccchannel_6_analyzer_2_array_crystal_array_7_xwidth2;
MCNUM yheight2 = mccchannel_6_analyzer_2_array_crystal_array_7_yheight2;
MCNUM visualize = mccchannel_6_analyzer_2_array_crystal_array_7_visualize;
int target_index = mccchannel_6_analyzer_2_array_crystal_array_7_target_index;
MCNUM target_x = mccchannel_6_analyzer_2_array_crystal_array_7_target_x;
MCNUM target_y = mccchannel_6_analyzer_2_array_crystal_array_7_target_y;
MCNUM target_z = mccchannel_6_analyzer_2_array_crystal_array_7_target_z;
MCNUM focus_aw = mccchannel_6_analyzer_2_array_crystal_array_7_focus_aw;
MCNUM focus_ah = mccchannel_6_analyzer_2_array_crystal_array_7_focus_ah;
MCNUM focus_xw = mccchannel_6_analyzer_2_array_crystal_array_7_focus_xw;
MCNUM focus_xh = mccchannel_6_analyzer_2_array_crystal_array_7_focus_xh;
MCNUM focus_r = mccchannel_6_analyzer_2_array_crystal_array_7_focus_r;
MCNUM p_interact = mccchannel_6_analyzer_2_array_crystal_array_7_p_interact;
char* mask_string = mccchannel_6_analyzer_2_array_crystal_array_7_mask_string;
char* mask_setting = mccchannel_6_analyzer_2_array_crystal_array_7_mask_setting;
MCNUM number_of_activations = mccchannel_6_analyzer_2_array_crystal_array_7_number_of_activations;
}   /* End of channel_6_analyzer_2_array_crystal_array_7=Union_box() SETTING parameter declarations. */
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex
  /* Label for restoring  neutron */
  mcabsorbCompchannel_6_analyzer_2_array_crystal_array_7:
  if (RESTORE) /* restore if needed */
  { RESTORE_NEUTRON(376,
      mcnlx,
      mcnly,
      mcnlz,
      mcnlvx,
      mcnlvy,
      mcnlvz,
      mcnlt,
      mcnlsx,
      mcnlsy,
      mcnlsz,
      mcnlp); }
#undef mcabsorbComp
#undef p
#undef sz
#undef sy
#undef sx
#undef t
#undef vz
#undef vy
#undef vx
#undef z
#undef y
#undef x
  mcDEBUG_STATE(
mcnlx,
mcnly,
mcnlz,
mcnlvx,
mcnlvy,
mcnlvz,
mcnlt,
mcnlsx,
mcnlsy,
mcnlsz,
mcnlp)

  /* TRACE Component channel_6_analyzer_2_array_crystal_array_8 [377] */
  mccoordschange(mcposrchannel_6_analyzer_2_array_crystal_array_8, mcrotrchannel_6_analyzer_2_array_crystal_array_8,
    &mcnlx,
    &mcnly,
    &mcnlz,
    &mcnlvx,
    &mcnlvy,
    &mcnlvz,
    &mcnlsx,
    &mcnlsy,
    &mcnlsz);
  /* define label inside component channel_6_analyzer_2_array_crystal_array_8 (without coords transformations) */
  mcJumpTrace_channel_6_analyzer_2_array_crystal_array_8:
  SIG_MESSAGE("channel_6_analyzer_2_array_crystal_array_8 (Trace)");
  mcDEBUG_COMP("channel_6_analyzer_2_array_crystal_array_8")
  mcDEBUG_STATE(
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp)
#define x mcnlx
#define y mcnly
#define z mcnlz
#define vx mcnlvx
#define vy mcnlvy
#define vz mcnlvz
#define t mcnlt
#define sx mcnlsx
#define sy mcnlsy
#define sz mcnlsz
#define p mcnlp

#define mcabsorbComp mcabsorbCompchannel_6_analyzer_2_array_crystal_array_8
  STORE_NEUTRON(377,
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp);
  mcScattered=0;
  mcRestore=0;
  mcNCounter[377]++;
  mcPCounter[377] += p;
  mcP2Counter[377] += p*p;
#define mccompcurname  channel_6_analyzer_2_array_crystal_array_8
#define mccompcurtype  Union_box
#define mccompcurindex 377
#define loop_index mccchannel_6_analyzer_2_array_crystal_array_8_loop_index
#define this_box_volume mccchannel_6_analyzer_2_array_crystal_array_8_this_box_volume
#define global_geometry_element mccchannel_6_analyzer_2_array_crystal_array_8_global_geometry_element
#define this_box_storage mccchannel_6_analyzer_2_array_crystal_array_8_this_box_storage
{   /* Declarations of channel_6_analyzer_2_array_crystal_array_8=Union_box() SETTING parameters. */
char* material_string = mccchannel_6_analyzer_2_array_crystal_array_8_material_string;
MCNUM priority = mccchannel_6_analyzer_2_array_crystal_array_8_priority;
MCNUM xwidth = mccchannel_6_analyzer_2_array_crystal_array_8_xwidth;
MCNUM yheight = mccchannel_6_analyzer_2_array_crystal_array_8_yheight;
MCNUM zdepth = mccchannel_6_analyzer_2_array_crystal_array_8_zdepth;
MCNUM xwidth2 = mccchannel_6_analyzer_2_array_crystal_array_8_xwidth2;
MCNUM yheight2 = mccchannel_6_analyzer_2_array_crystal_array_8_yheight2;
MCNUM visualize = mccchannel_6_analyzer_2_array_crystal_array_8_visualize;
int target_index = mccchannel_6_analyzer_2_array_crystal_array_8_target_index;
MCNUM target_x = mccchannel_6_analyzer_2_array_crystal_array_8_target_x;
MCNUM target_y = mccchannel_6_analyzer_2_array_crystal_array_8_target_y;
MCNUM target_z = mccchannel_6_analyzer_2_array_crystal_array_8_target_z;
MCNUM focus_aw = mccchannel_6_analyzer_2_array_crystal_array_8_focus_aw;
MCNUM focus_ah = mccchannel_6_analyzer_2_array_crystal_array_8_focus_ah;
MCNUM focus_xw = mccchannel_6_analyzer_2_array_crystal_array_8_focus_xw;
MCNUM focus_xh = mccchannel_6_analyzer_2_array_crystal_array_8_focus_xh;
MCNUM focus_r = mccchannel_6_analyzer_2_array_crystal_array_8_focus_r;
MCNUM p_interact = mccchannel_6_analyzer_2_array_crystal_array_8_p_interact;
char* mask_string = mccchannel_6_analyzer_2_array_crystal_array_8_mask_string;
char* mask_setting = mccchannel_6_analyzer_2_array_crystal_array_8_mask_setting;
MCNUM number_of_activations = mccchannel_6_analyzer_2_array_crystal_array_8_number_of_activations;
}   /* End of channel_6_analyzer_2_array_crystal_array_8=Union_box() SETTING parameter declarations. */
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex
  /* Label for restoring  neutron */
  mcabsorbCompchannel_6_analyzer_2_array_crystal_array_8:
  if (RESTORE) /* restore if needed */
  { RESTORE_NEUTRON(377,
      mcnlx,
      mcnly,
      mcnlz,
      mcnlvx,
      mcnlvy,
      mcnlvz,
      mcnlt,
      mcnlsx,
      mcnlsy,
      mcnlsz,
      mcnlp); }
#undef mcabsorbComp
#undef p
#undef sz
#undef sy
#undef sx
#undef t
#undef vz
#undef vy
#undef vx
#undef z
#undef y
#undef x
  mcDEBUG_STATE(
mcnlx,
mcnly,
mcnlz,
mcnlvx,
mcnlvy,
mcnlvz,
mcnlt,
mcnlsx,
mcnlsy,
mcnlsz,
mcnlp)

  /* TRACE Component channel_6_cave2_cyl1 [378] */
  mccoordschange(mcposrchannel_6_cave2_cyl1, mcrotrchannel_6_cave2_cyl1,
    &mcnlx,
    &mcnly,
    &mcnlz,
    &mcnlvx,
    &mcnlvy,
    &mcnlvz,
    &mcnlsx,
    &mcnlsy,
    &mcnlsz);
  /* define label inside component channel_6_cave2_cyl1 (without coords transformations) */
  mcJumpTrace_channel_6_cave2_cyl1:
  SIG_MESSAGE("channel_6_cave2_cyl1 (Trace)");
  mcDEBUG_COMP("channel_6_cave2_cyl1")
  mcDEBUG_STATE(
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp)
#define x mcnlx
#define y mcnly
#define z mcnlz
#define vx mcnlvx
#define vy mcnlvy
#define vz mcnlvz
#define t mcnlt
#define sx mcnlsx
#define sy mcnlsy
#define sz mcnlsz
#define p mcnlp

#define mcabsorbComp mcabsorbCompchannel_6_cave2_cyl1
  STORE_NEUTRON(378,
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp);
  mcScattered=0;
  mcRestore=0;
  mcNCounter[378]++;
  mcPCounter[378] += p;
  mcP2Counter[378] += p*p;
#define mccompcurname  channel_6_cave2_cyl1
#define mccompcurtype  Union_cylinder
#define mccompcurindex 378
#define loop_index mccchannel_6_cave2_cyl1_loop_index
#define this_cylinder_volume mccchannel_6_cave2_cyl1_this_cylinder_volume
#define global_geometry_element mccchannel_6_cave2_cyl1_global_geometry_element
#define this_cylinder_storage mccchannel_6_cave2_cyl1_this_cylinder_storage
{   /* Declarations of channel_6_cave2_cyl1=Union_cylinder() SETTING parameters. */
char* material_string = mccchannel_6_cave2_cyl1_material_string;
MCNUM priority = mccchannel_6_cave2_cyl1_priority;
MCNUM radius = mccchannel_6_cave2_cyl1_radius;
MCNUM yheight = mccchannel_6_cave2_cyl1_yheight;
MCNUM visualize = mccchannel_6_cave2_cyl1_visualize;
int target_index = mccchannel_6_cave2_cyl1_target_index;
MCNUM target_x = mccchannel_6_cave2_cyl1_target_x;
MCNUM target_y = mccchannel_6_cave2_cyl1_target_y;
MCNUM target_z = mccchannel_6_cave2_cyl1_target_z;
MCNUM focus_aw = mccchannel_6_cave2_cyl1_focus_aw;
MCNUM focus_ah = mccchannel_6_cave2_cyl1_focus_ah;
MCNUM focus_xw = mccchannel_6_cave2_cyl1_focus_xw;
MCNUM focus_xh = mccchannel_6_cave2_cyl1_focus_xh;
MCNUM focus_r = mccchannel_6_cave2_cyl1_focus_r;
MCNUM p_interact = mccchannel_6_cave2_cyl1_p_interact;
char* mask_string = mccchannel_6_cave2_cyl1_mask_string;
char* mask_setting = mccchannel_6_cave2_cyl1_mask_setting;
MCNUM number_of_activations = mccchannel_6_cave2_cyl1_number_of_activations;
#line 345 "Union_cylinder.comp"
{
dummy = 1;
}
#line 395664 "MACS_sample_kidney_box.c"
}   /* End of channel_6_cave2_cyl1=Union_cylinder() SETTING parameter declarations. */
#undef this_cylinder_storage
#undef global_geometry_element
#undef this_cylinder_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex
  /* Label for restoring  neutron */
  mcabsorbCompchannel_6_cave2_cyl1:
  if (RESTORE) /* restore if needed */
  { RESTORE_NEUTRON(378,
      mcnlx,
      mcnly,
      mcnlz,
      mcnlvx,
      mcnlvy,
      mcnlvz,
      mcnlt,
      mcnlsx,
      mcnlsy,
      mcnlsz,
      mcnlp); }
#undef mcabsorbComp
#undef p
#undef sz
#undef sy
#undef sx
#undef t
#undef vz
#undef vy
#undef vx
#undef z
#undef y
#undef x
  mcDEBUG_STATE(
mcnlx,
mcnly,
mcnlz,
mcnlvx,
mcnlvy,
mcnlvz,
mcnlt,
mcnlsx,
mcnlsy,
mcnlsz,
mcnlp)

  /* TRACE Component channel_6_cave2_box1 [379] */
  mccoordschange(mcposrchannel_6_cave2_box1, mcrotrchannel_6_cave2_box1,
    &mcnlx,
    &mcnly,
    &mcnlz,
    &mcnlvx,
    &mcnlvy,
    &mcnlvz,
    &mcnlsx,
    &mcnlsy,
    &mcnlsz);
  /* define label inside component channel_6_cave2_box1 (without coords transformations) */
  mcJumpTrace_channel_6_cave2_box1:
  SIG_MESSAGE("channel_6_cave2_box1 (Trace)");
  mcDEBUG_COMP("channel_6_cave2_box1")
  mcDEBUG_STATE(
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp)
#define x mcnlx
#define y mcnly
#define z mcnlz
#define vx mcnlvx
#define vy mcnlvy
#define vz mcnlvz
#define t mcnlt
#define sx mcnlsx
#define sy mcnlsy
#define sz mcnlsz
#define p mcnlp

#define mcabsorbComp mcabsorbCompchannel_6_cave2_box1
  STORE_NEUTRON(379,
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp);
  mcScattered=0;
  mcRestore=0;
  mcNCounter[379]++;
  mcPCounter[379] += p;
  mcP2Counter[379] += p*p;
#define mccompcurname  channel_6_cave2_box1
#define mccompcurtype  Union_box
#define mccompcurindex 379
#define loop_index mccchannel_6_cave2_box1_loop_index
#define this_box_volume mccchannel_6_cave2_box1_this_box_volume
#define global_geometry_element mccchannel_6_cave2_box1_global_geometry_element
#define this_box_storage mccchannel_6_cave2_box1_this_box_storage
{   /* Declarations of channel_6_cave2_box1=Union_box() SETTING parameters. */
char* material_string = mccchannel_6_cave2_box1_material_string;
MCNUM priority = mccchannel_6_cave2_box1_priority;
MCNUM xwidth = mccchannel_6_cave2_box1_xwidth;
MCNUM yheight = mccchannel_6_cave2_box1_yheight;
MCNUM zdepth = mccchannel_6_cave2_box1_zdepth;
MCNUM xwidth2 = mccchannel_6_cave2_box1_xwidth2;
MCNUM yheight2 = mccchannel_6_cave2_box1_yheight2;
MCNUM visualize = mccchannel_6_cave2_box1_visualize;
int target_index = mccchannel_6_cave2_box1_target_index;
MCNUM target_x = mccchannel_6_cave2_box1_target_x;
MCNUM target_y = mccchannel_6_cave2_box1_target_y;
MCNUM target_z = mccchannel_6_cave2_box1_target_z;
MCNUM focus_aw = mccchannel_6_cave2_box1_focus_aw;
MCNUM focus_ah = mccchannel_6_cave2_box1_focus_ah;
MCNUM focus_xw = mccchannel_6_cave2_box1_focus_xw;
MCNUM focus_xh = mccchannel_6_cave2_box1_focus_xh;
MCNUM focus_r = mccchannel_6_cave2_box1_focus_r;
MCNUM p_interact = mccchannel_6_cave2_box1_p_interact;
char* mask_string = mccchannel_6_cave2_box1_mask_string;
char* mask_setting = mccchannel_6_cave2_box1_mask_setting;
MCNUM number_of_activations = mccchannel_6_cave2_box1_number_of_activations;
}   /* End of channel_6_cave2_box1=Union_box() SETTING parameter declarations. */
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex
  /* Label for restoring  neutron */
  mcabsorbCompchannel_6_cave2_box1:
  if (RESTORE) /* restore if needed */
  { RESTORE_NEUTRON(379,
      mcnlx,
      mcnly,
      mcnlz,
      mcnlvx,
      mcnlvy,
      mcnlvz,
      mcnlt,
      mcnlsx,
      mcnlsy,
      mcnlsz,
      mcnlp); }
#undef mcabsorbComp
#undef p
#undef sz
#undef sy
#undef sx
#undef t
#undef vz
#undef vy
#undef vx
#undef z
#undef y
#undef x
  mcDEBUG_STATE(
mcnlx,
mcnly,
mcnlz,
mcnlvx,
mcnlvy,
mcnlvz,
mcnlt,
mcnlsx,
mcnlsy,
mcnlsz,
mcnlp)

  /* TRACE Component channel_6_cave2_box2 [380] */
  mccoordschange(mcposrchannel_6_cave2_box2, mcrotrchannel_6_cave2_box2,
    &mcnlx,
    &mcnly,
    &mcnlz,
    &mcnlvx,
    &mcnlvy,
    &mcnlvz,
    &mcnlsx,
    &mcnlsy,
    &mcnlsz);
  /* define label inside component channel_6_cave2_box2 (without coords transformations) */
  mcJumpTrace_channel_6_cave2_box2:
  SIG_MESSAGE("channel_6_cave2_box2 (Trace)");
  mcDEBUG_COMP("channel_6_cave2_box2")
  mcDEBUG_STATE(
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp)
#define x mcnlx
#define y mcnly
#define z mcnlz
#define vx mcnlvx
#define vy mcnlvy
#define vz mcnlvz
#define t mcnlt
#define sx mcnlsx
#define sy mcnlsy
#define sz mcnlsz
#define p mcnlp

#define mcabsorbComp mcabsorbCompchannel_6_cave2_box2
  STORE_NEUTRON(380,
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp);
  mcScattered=0;
  mcRestore=0;
  mcNCounter[380]++;
  mcPCounter[380] += p;
  mcP2Counter[380] += p*p;
#define mccompcurname  channel_6_cave2_box2
#define mccompcurtype  Union_box
#define mccompcurindex 380
#define loop_index mccchannel_6_cave2_box2_loop_index
#define this_box_volume mccchannel_6_cave2_box2_this_box_volume
#define global_geometry_element mccchannel_6_cave2_box2_global_geometry_element
#define this_box_storage mccchannel_6_cave2_box2_this_box_storage
{   /* Declarations of channel_6_cave2_box2=Union_box() SETTING parameters. */
char* material_string = mccchannel_6_cave2_box2_material_string;
MCNUM priority = mccchannel_6_cave2_box2_priority;
MCNUM xwidth = mccchannel_6_cave2_box2_xwidth;
MCNUM yheight = mccchannel_6_cave2_box2_yheight;
MCNUM zdepth = mccchannel_6_cave2_box2_zdepth;
MCNUM xwidth2 = mccchannel_6_cave2_box2_xwidth2;
MCNUM yheight2 = mccchannel_6_cave2_box2_yheight2;
MCNUM visualize = mccchannel_6_cave2_box2_visualize;
int target_index = mccchannel_6_cave2_box2_target_index;
MCNUM target_x = mccchannel_6_cave2_box2_target_x;
MCNUM target_y = mccchannel_6_cave2_box2_target_y;
MCNUM target_z = mccchannel_6_cave2_box2_target_z;
MCNUM focus_aw = mccchannel_6_cave2_box2_focus_aw;
MCNUM focus_ah = mccchannel_6_cave2_box2_focus_ah;
MCNUM focus_xw = mccchannel_6_cave2_box2_focus_xw;
MCNUM focus_xh = mccchannel_6_cave2_box2_focus_xh;
MCNUM focus_r = mccchannel_6_cave2_box2_focus_r;
MCNUM p_interact = mccchannel_6_cave2_box2_p_interact;
char* mask_string = mccchannel_6_cave2_box2_mask_string;
char* mask_setting = mccchannel_6_cave2_box2_mask_setting;
MCNUM number_of_activations = mccchannel_6_cave2_box2_number_of_activations;
}   /* End of channel_6_cave2_box2=Union_box() SETTING parameter declarations. */
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex
  /* Label for restoring  neutron */
  mcabsorbCompchannel_6_cave2_box2:
  if (RESTORE) /* restore if needed */
  { RESTORE_NEUTRON(380,
      mcnlx,
      mcnly,
      mcnlz,
      mcnlvx,
      mcnlvy,
      mcnlvz,
      mcnlt,
      mcnlsx,
      mcnlsy,
      mcnlsz,
      mcnlp); }
#undef mcabsorbComp
#undef p
#undef sz
#undef sy
#undef sx
#undef t
#undef vz
#undef vy
#undef vx
#undef z
#undef y
#undef x
  mcDEBUG_STATE(
mcnlx,
mcnly,
mcnlz,
mcnlvx,
mcnlvy,
mcnlvz,
mcnlt,
mcnlsx,
mcnlsy,
mcnlsz,
mcnlp)

  /* TRACE Component channel_6_cave2_box3 [381] */
  mccoordschange(mcposrchannel_6_cave2_box3, mcrotrchannel_6_cave2_box3,
    &mcnlx,
    &mcnly,
    &mcnlz,
    &mcnlvx,
    &mcnlvy,
    &mcnlvz,
    &mcnlsx,
    &mcnlsy,
    &mcnlsz);
  /* define label inside component channel_6_cave2_box3 (without coords transformations) */
  mcJumpTrace_channel_6_cave2_box3:
  SIG_MESSAGE("channel_6_cave2_box3 (Trace)");
  mcDEBUG_COMP("channel_6_cave2_box3")
  mcDEBUG_STATE(
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp)
#define x mcnlx
#define y mcnly
#define z mcnlz
#define vx mcnlvx
#define vy mcnlvy
#define vz mcnlvz
#define t mcnlt
#define sx mcnlsx
#define sy mcnlsy
#define sz mcnlsz
#define p mcnlp

#define mcabsorbComp mcabsorbCompchannel_6_cave2_box3
  STORE_NEUTRON(381,
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp);
  mcScattered=0;
  mcRestore=0;
  mcNCounter[381]++;
  mcPCounter[381] += p;
  mcP2Counter[381] += p*p;
#define mccompcurname  channel_6_cave2_box3
#define mccompcurtype  Union_box
#define mccompcurindex 381
#define loop_index mccchannel_6_cave2_box3_loop_index
#define this_box_volume mccchannel_6_cave2_box3_this_box_volume
#define global_geometry_element mccchannel_6_cave2_box3_global_geometry_element
#define this_box_storage mccchannel_6_cave2_box3_this_box_storage
{   /* Declarations of channel_6_cave2_box3=Union_box() SETTING parameters. */
char* material_string = mccchannel_6_cave2_box3_material_string;
MCNUM priority = mccchannel_6_cave2_box3_priority;
MCNUM xwidth = mccchannel_6_cave2_box3_xwidth;
MCNUM yheight = mccchannel_6_cave2_box3_yheight;
MCNUM zdepth = mccchannel_6_cave2_box3_zdepth;
MCNUM xwidth2 = mccchannel_6_cave2_box3_xwidth2;
MCNUM yheight2 = mccchannel_6_cave2_box3_yheight2;
MCNUM visualize = mccchannel_6_cave2_box3_visualize;
int target_index = mccchannel_6_cave2_box3_target_index;
MCNUM target_x = mccchannel_6_cave2_box3_target_x;
MCNUM target_y = mccchannel_6_cave2_box3_target_y;
MCNUM target_z = mccchannel_6_cave2_box3_target_z;
MCNUM focus_aw = mccchannel_6_cave2_box3_focus_aw;
MCNUM focus_ah = mccchannel_6_cave2_box3_focus_ah;
MCNUM focus_xw = mccchannel_6_cave2_box3_focus_xw;
MCNUM focus_xh = mccchannel_6_cave2_box3_focus_xh;
MCNUM focus_r = mccchannel_6_cave2_box3_focus_r;
MCNUM p_interact = mccchannel_6_cave2_box3_p_interact;
char* mask_string = mccchannel_6_cave2_box3_mask_string;
char* mask_setting = mccchannel_6_cave2_box3_mask_setting;
MCNUM number_of_activations = mccchannel_6_cave2_box3_number_of_activations;
}   /* End of channel_6_cave2_box3=Union_box() SETTING parameter declarations. */
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex
  /* Label for restoring  neutron */
  mcabsorbCompchannel_6_cave2_box3:
  if (RESTORE) /* restore if needed */
  { RESTORE_NEUTRON(381,
      mcnlx,
      mcnly,
      mcnlz,
      mcnlvx,
      mcnlvy,
      mcnlvz,
      mcnlt,
      mcnlsx,
      mcnlsy,
      mcnlsz,
      mcnlp); }
#undef mcabsorbComp
#undef p
#undef sz
#undef sy
#undef sx
#undef t
#undef vz
#undef vy
#undef vx
#undef z
#undef y
#undef x
  mcDEBUG_STATE(
mcnlx,
mcnly,
mcnlz,
mcnlvx,
mcnlvy,
mcnlvz,
mcnlt,
mcnlsx,
mcnlsy,
mcnlsz,
mcnlp)

  /* TRACE Component inter_analyzer_colimator_center_6 [382] */
  mccoordschange(mcposrinter_analyzer_colimator_center_6, mcrotrinter_analyzer_colimator_center_6,
    &mcnlx,
    &mcnly,
    &mcnlz,
    &mcnlvx,
    &mcnlvy,
    &mcnlvz,
    &mcnlsx,
    &mcnlsy,
    &mcnlsz);
  /* define label inside component inter_analyzer_colimator_center_6 (without coords transformations) */
  mcJumpTrace_inter_analyzer_colimator_center_6:
  SIG_MESSAGE("inter_analyzer_colimator_center_6 (Trace)");
  mcDEBUG_COMP("inter_analyzer_colimator_center_6")
  mcDEBUG_STATE(
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp)
#define x mcnlx
#define y mcnly
#define z mcnlz
#define vx mcnlvx
#define vy mcnlvy
#define vz mcnlvz
#define t mcnlt
#define sx mcnlsx
#define sy mcnlsy
#define sz mcnlsz
#define p mcnlp

#define mcabsorbComp mcabsorbCompinter_analyzer_colimator_center_6
  STORE_NEUTRON(382,
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp);
  mcScattered=0;
  mcRestore=0;
  mcNCounter[382]++;
  mcPCounter[382] += p;
  mcP2Counter[382] += p*p;
#define mccompcurname  inter_analyzer_colimator_center_6
#define mccompcurtype  Arm
#define mccompcurindex 382
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex
  /* Label for restoring  neutron */
  mcabsorbCompinter_analyzer_colimator_center_6:
  if (RESTORE) /* restore if needed */
  { RESTORE_NEUTRON(382,
      mcnlx,
      mcnly,
      mcnlz,
      mcnlvx,
      mcnlvy,
      mcnlvz,
      mcnlt,
      mcnlsx,
      mcnlsy,
      mcnlsz,
      mcnlp); }
#undef mcabsorbComp
#undef p
#undef sz
#undef sy
#undef sx
#undef t
#undef vz
#undef vy
#undef vx
#undef z
#undef y
#undef x
  mcDEBUG_STATE(
mcnlx,
mcnly,
mcnlz,
mcnlvx,
mcnlvy,
mcnlvz,
mcnlt,
mcnlsx,
mcnlsy,
mcnlsz,
mcnlp)

  /* TRACE Component inter_analyzer_colimator_6_blade_0 [383] */
  mccoordschange(mcposrinter_analyzer_colimator_6_blade_0, mcrotrinter_analyzer_colimator_6_blade_0,
    &mcnlx,
    &mcnly,
    &mcnlz,
    &mcnlvx,
    &mcnlvy,
    &mcnlvz,
    &mcnlsx,
    &mcnlsy,
    &mcnlsz);
  /* define label inside component inter_analyzer_colimator_6_blade_0 (without coords transformations) */
  mcJumpTrace_inter_analyzer_colimator_6_blade_0:
  SIG_MESSAGE("inter_analyzer_colimator_6_blade_0 (Trace)");
  mcDEBUG_COMP("inter_analyzer_colimator_6_blade_0")
  mcDEBUG_STATE(
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp)
#define x mcnlx
#define y mcnly
#define z mcnlz
#define vx mcnlvx
#define vy mcnlvy
#define vz mcnlvz
#define t mcnlt
#define sx mcnlsx
#define sy mcnlsy
#define sz mcnlsz
#define p mcnlp

#define mcabsorbComp mcabsorbCompinter_analyzer_colimator_6_blade_0
  STORE_NEUTRON(383,
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp);
  mcScattered=0;
  mcRestore=0;
  mcNCounter[383]++;
  mcPCounter[383] += p;
  mcP2Counter[383] += p*p;
#define mccompcurname  inter_analyzer_colimator_6_blade_0
#define mccompcurtype  Union_box
#define mccompcurindex 383
#define loop_index mccinter_analyzer_colimator_6_blade_0_loop_index
#define this_box_volume mccinter_analyzer_colimator_6_blade_0_this_box_volume
#define global_geometry_element mccinter_analyzer_colimator_6_blade_0_global_geometry_element
#define this_box_storage mccinter_analyzer_colimator_6_blade_0_this_box_storage
{   /* Declarations of inter_analyzer_colimator_6_blade_0=Union_box() SETTING parameters. */
char* material_string = mccinter_analyzer_colimator_6_blade_0_material_string;
MCNUM priority = mccinter_analyzer_colimator_6_blade_0_priority;
MCNUM xwidth = mccinter_analyzer_colimator_6_blade_0_xwidth;
MCNUM yheight = mccinter_analyzer_colimator_6_blade_0_yheight;
MCNUM zdepth = mccinter_analyzer_colimator_6_blade_0_zdepth;
MCNUM xwidth2 = mccinter_analyzer_colimator_6_blade_0_xwidth2;
MCNUM yheight2 = mccinter_analyzer_colimator_6_blade_0_yheight2;
MCNUM visualize = mccinter_analyzer_colimator_6_blade_0_visualize;
int target_index = mccinter_analyzer_colimator_6_blade_0_target_index;
MCNUM target_x = mccinter_analyzer_colimator_6_blade_0_target_x;
MCNUM target_y = mccinter_analyzer_colimator_6_blade_0_target_y;
MCNUM target_z = mccinter_analyzer_colimator_6_blade_0_target_z;
MCNUM focus_aw = mccinter_analyzer_colimator_6_blade_0_focus_aw;
MCNUM focus_ah = mccinter_analyzer_colimator_6_blade_0_focus_ah;
MCNUM focus_xw = mccinter_analyzer_colimator_6_blade_0_focus_xw;
MCNUM focus_xh = mccinter_analyzer_colimator_6_blade_0_focus_xh;
MCNUM focus_r = mccinter_analyzer_colimator_6_blade_0_focus_r;
MCNUM p_interact = mccinter_analyzer_colimator_6_blade_0_p_interact;
char* mask_string = mccinter_analyzer_colimator_6_blade_0_mask_string;
char* mask_setting = mccinter_analyzer_colimator_6_blade_0_mask_setting;
MCNUM number_of_activations = mccinter_analyzer_colimator_6_blade_0_number_of_activations;
}   /* End of inter_analyzer_colimator_6_blade_0=Union_box() SETTING parameter declarations. */
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex
  /* Label for restoring  neutron */
  mcabsorbCompinter_analyzer_colimator_6_blade_0:
  if (RESTORE) /* restore if needed */
  { RESTORE_NEUTRON(383,
      mcnlx,
      mcnly,
      mcnlz,
      mcnlvx,
      mcnlvy,
      mcnlvz,
      mcnlt,
      mcnlsx,
      mcnlsy,
      mcnlsz,
      mcnlp); }
#undef mcabsorbComp
#undef p
#undef sz
#undef sy
#undef sx
#undef t
#undef vz
#undef vy
#undef vx
#undef z
#undef y
#undef x
  mcDEBUG_STATE(
mcnlx,
mcnly,
mcnlz,
mcnlvx,
mcnlvy,
mcnlvz,
mcnlt,
mcnlsx,
mcnlsy,
mcnlsz,
mcnlp)

  /* TRACE Component inter_analyzer_colimator_6_blade_1 [384] */
  mccoordschange(mcposrinter_analyzer_colimator_6_blade_1, mcrotrinter_analyzer_colimator_6_blade_1,
    &mcnlx,
    &mcnly,
    &mcnlz,
    &mcnlvx,
    &mcnlvy,
    &mcnlvz,
    &mcnlsx,
    &mcnlsy,
    &mcnlsz);
  /* define label inside component inter_analyzer_colimator_6_blade_1 (without coords transformations) */
  mcJumpTrace_inter_analyzer_colimator_6_blade_1:
  SIG_MESSAGE("inter_analyzer_colimator_6_blade_1 (Trace)");
  mcDEBUG_COMP("inter_analyzer_colimator_6_blade_1")
  mcDEBUG_STATE(
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp)
#define x mcnlx
#define y mcnly
#define z mcnlz
#define vx mcnlvx
#define vy mcnlvy
#define vz mcnlvz
#define t mcnlt
#define sx mcnlsx
#define sy mcnlsy
#define sz mcnlsz
#define p mcnlp

#define mcabsorbComp mcabsorbCompinter_analyzer_colimator_6_blade_1
  STORE_NEUTRON(384,
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp);
  mcScattered=0;
  mcRestore=0;
  mcNCounter[384]++;
  mcPCounter[384] += p;
  mcP2Counter[384] += p*p;
#define mccompcurname  inter_analyzer_colimator_6_blade_1
#define mccompcurtype  Union_box
#define mccompcurindex 384
#define loop_index mccinter_analyzer_colimator_6_blade_1_loop_index
#define this_box_volume mccinter_analyzer_colimator_6_blade_1_this_box_volume
#define global_geometry_element mccinter_analyzer_colimator_6_blade_1_global_geometry_element
#define this_box_storage mccinter_analyzer_colimator_6_blade_1_this_box_storage
{   /* Declarations of inter_analyzer_colimator_6_blade_1=Union_box() SETTING parameters. */
char* material_string = mccinter_analyzer_colimator_6_blade_1_material_string;
MCNUM priority = mccinter_analyzer_colimator_6_blade_1_priority;
MCNUM xwidth = mccinter_analyzer_colimator_6_blade_1_xwidth;
MCNUM yheight = mccinter_analyzer_colimator_6_blade_1_yheight;
MCNUM zdepth = mccinter_analyzer_colimator_6_blade_1_zdepth;
MCNUM xwidth2 = mccinter_analyzer_colimator_6_blade_1_xwidth2;
MCNUM yheight2 = mccinter_analyzer_colimator_6_blade_1_yheight2;
MCNUM visualize = mccinter_analyzer_colimator_6_blade_1_visualize;
int target_index = mccinter_analyzer_colimator_6_blade_1_target_index;
MCNUM target_x = mccinter_analyzer_colimator_6_blade_1_target_x;
MCNUM target_y = mccinter_analyzer_colimator_6_blade_1_target_y;
MCNUM target_z = mccinter_analyzer_colimator_6_blade_1_target_z;
MCNUM focus_aw = mccinter_analyzer_colimator_6_blade_1_focus_aw;
MCNUM focus_ah = mccinter_analyzer_colimator_6_blade_1_focus_ah;
MCNUM focus_xw = mccinter_analyzer_colimator_6_blade_1_focus_xw;
MCNUM focus_xh = mccinter_analyzer_colimator_6_blade_1_focus_xh;
MCNUM focus_r = mccinter_analyzer_colimator_6_blade_1_focus_r;
MCNUM p_interact = mccinter_analyzer_colimator_6_blade_1_p_interact;
char* mask_string = mccinter_analyzer_colimator_6_blade_1_mask_string;
char* mask_setting = mccinter_analyzer_colimator_6_blade_1_mask_setting;
MCNUM number_of_activations = mccinter_analyzer_colimator_6_blade_1_number_of_activations;
}   /* End of inter_analyzer_colimator_6_blade_1=Union_box() SETTING parameter declarations. */
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex
  /* Label for restoring  neutron */
  mcabsorbCompinter_analyzer_colimator_6_blade_1:
  if (RESTORE) /* restore if needed */
  { RESTORE_NEUTRON(384,
      mcnlx,
      mcnly,
      mcnlz,
      mcnlvx,
      mcnlvy,
      mcnlvz,
      mcnlt,
      mcnlsx,
      mcnlsy,
      mcnlsz,
      mcnlp); }
#undef mcabsorbComp
#undef p
#undef sz
#undef sy
#undef sx
#undef t
#undef vz
#undef vy
#undef vx
#undef z
#undef y
#undef x
  mcDEBUG_STATE(
mcnlx,
mcnly,
mcnlz,
mcnlvx,
mcnlvy,
mcnlvz,
mcnlt,
mcnlsx,
mcnlsy,
mcnlsz,
mcnlp)

  /* TRACE Component inter_analyzer_colimator_6_blade_2 [385] */
  mccoordschange(mcposrinter_analyzer_colimator_6_blade_2, mcrotrinter_analyzer_colimator_6_blade_2,
    &mcnlx,
    &mcnly,
    &mcnlz,
    &mcnlvx,
    &mcnlvy,
    &mcnlvz,
    &mcnlsx,
    &mcnlsy,
    &mcnlsz);
  /* define label inside component inter_analyzer_colimator_6_blade_2 (without coords transformations) */
  mcJumpTrace_inter_analyzer_colimator_6_blade_2:
  SIG_MESSAGE("inter_analyzer_colimator_6_blade_2 (Trace)");
  mcDEBUG_COMP("inter_analyzer_colimator_6_blade_2")
  mcDEBUG_STATE(
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp)
#define x mcnlx
#define y mcnly
#define z mcnlz
#define vx mcnlvx
#define vy mcnlvy
#define vz mcnlvz
#define t mcnlt
#define sx mcnlsx
#define sy mcnlsy
#define sz mcnlsz
#define p mcnlp

#define mcabsorbComp mcabsorbCompinter_analyzer_colimator_6_blade_2
  STORE_NEUTRON(385,
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp);
  mcScattered=0;
  mcRestore=0;
  mcNCounter[385]++;
  mcPCounter[385] += p;
  mcP2Counter[385] += p*p;
#define mccompcurname  inter_analyzer_colimator_6_blade_2
#define mccompcurtype  Union_box
#define mccompcurindex 385
#define loop_index mccinter_analyzer_colimator_6_blade_2_loop_index
#define this_box_volume mccinter_analyzer_colimator_6_blade_2_this_box_volume
#define global_geometry_element mccinter_analyzer_colimator_6_blade_2_global_geometry_element
#define this_box_storage mccinter_analyzer_colimator_6_blade_2_this_box_storage
{   /* Declarations of inter_analyzer_colimator_6_blade_2=Union_box() SETTING parameters. */
char* material_string = mccinter_analyzer_colimator_6_blade_2_material_string;
MCNUM priority = mccinter_analyzer_colimator_6_blade_2_priority;
MCNUM xwidth = mccinter_analyzer_colimator_6_blade_2_xwidth;
MCNUM yheight = mccinter_analyzer_colimator_6_blade_2_yheight;
MCNUM zdepth = mccinter_analyzer_colimator_6_blade_2_zdepth;
MCNUM xwidth2 = mccinter_analyzer_colimator_6_blade_2_xwidth2;
MCNUM yheight2 = mccinter_analyzer_colimator_6_blade_2_yheight2;
MCNUM visualize = mccinter_analyzer_colimator_6_blade_2_visualize;
int target_index = mccinter_analyzer_colimator_6_blade_2_target_index;
MCNUM target_x = mccinter_analyzer_colimator_6_blade_2_target_x;
MCNUM target_y = mccinter_analyzer_colimator_6_blade_2_target_y;
MCNUM target_z = mccinter_analyzer_colimator_6_blade_2_target_z;
MCNUM focus_aw = mccinter_analyzer_colimator_6_blade_2_focus_aw;
MCNUM focus_ah = mccinter_analyzer_colimator_6_blade_2_focus_ah;
MCNUM focus_xw = mccinter_analyzer_colimator_6_blade_2_focus_xw;
MCNUM focus_xh = mccinter_analyzer_colimator_6_blade_2_focus_xh;
MCNUM focus_r = mccinter_analyzer_colimator_6_blade_2_focus_r;
MCNUM p_interact = mccinter_analyzer_colimator_6_blade_2_p_interact;
char* mask_string = mccinter_analyzer_colimator_6_blade_2_mask_string;
char* mask_setting = mccinter_analyzer_colimator_6_blade_2_mask_setting;
MCNUM number_of_activations = mccinter_analyzer_colimator_6_blade_2_number_of_activations;
}   /* End of inter_analyzer_colimator_6_blade_2=Union_box() SETTING parameter declarations. */
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex
  /* Label for restoring  neutron */
  mcabsorbCompinter_analyzer_colimator_6_blade_2:
  if (RESTORE) /* restore if needed */
  { RESTORE_NEUTRON(385,
      mcnlx,
      mcnly,
      mcnlz,
      mcnlvx,
      mcnlvy,
      mcnlvz,
      mcnlt,
      mcnlsx,
      mcnlsy,
      mcnlsz,
      mcnlp); }
#undef mcabsorbComp
#undef p
#undef sz
#undef sy
#undef sx
#undef t
#undef vz
#undef vy
#undef vx
#undef z
#undef y
#undef x
  mcDEBUG_STATE(
mcnlx,
mcnly,
mcnlz,
mcnlvx,
mcnlvy,
mcnlvz,
mcnlt,
mcnlsx,
mcnlsy,
mcnlsz,
mcnlp)

  /* TRACE Component inter_analyzer_colimator_6_blade_3 [386] */
  mccoordschange(mcposrinter_analyzer_colimator_6_blade_3, mcrotrinter_analyzer_colimator_6_blade_3,
    &mcnlx,
    &mcnly,
    &mcnlz,
    &mcnlvx,
    &mcnlvy,
    &mcnlvz,
    &mcnlsx,
    &mcnlsy,
    &mcnlsz);
  /* define label inside component inter_analyzer_colimator_6_blade_3 (without coords transformations) */
  mcJumpTrace_inter_analyzer_colimator_6_blade_3:
  SIG_MESSAGE("inter_analyzer_colimator_6_blade_3 (Trace)");
  mcDEBUG_COMP("inter_analyzer_colimator_6_blade_3")
  mcDEBUG_STATE(
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp)
#define x mcnlx
#define y mcnly
#define z mcnlz
#define vx mcnlvx
#define vy mcnlvy
#define vz mcnlvz
#define t mcnlt
#define sx mcnlsx
#define sy mcnlsy
#define sz mcnlsz
#define p mcnlp

#define mcabsorbComp mcabsorbCompinter_analyzer_colimator_6_blade_3
  STORE_NEUTRON(386,
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp);
  mcScattered=0;
  mcRestore=0;
  mcNCounter[386]++;
  mcPCounter[386] += p;
  mcP2Counter[386] += p*p;
#define mccompcurname  inter_analyzer_colimator_6_blade_3
#define mccompcurtype  Union_box
#define mccompcurindex 386
#define loop_index mccinter_analyzer_colimator_6_blade_3_loop_index
#define this_box_volume mccinter_analyzer_colimator_6_blade_3_this_box_volume
#define global_geometry_element mccinter_analyzer_colimator_6_blade_3_global_geometry_element
#define this_box_storage mccinter_analyzer_colimator_6_blade_3_this_box_storage
{   /* Declarations of inter_analyzer_colimator_6_blade_3=Union_box() SETTING parameters. */
char* material_string = mccinter_analyzer_colimator_6_blade_3_material_string;
MCNUM priority = mccinter_analyzer_colimator_6_blade_3_priority;
MCNUM xwidth = mccinter_analyzer_colimator_6_blade_3_xwidth;
MCNUM yheight = mccinter_analyzer_colimator_6_blade_3_yheight;
MCNUM zdepth = mccinter_analyzer_colimator_6_blade_3_zdepth;
MCNUM xwidth2 = mccinter_analyzer_colimator_6_blade_3_xwidth2;
MCNUM yheight2 = mccinter_analyzer_colimator_6_blade_3_yheight2;
MCNUM visualize = mccinter_analyzer_colimator_6_blade_3_visualize;
int target_index = mccinter_analyzer_colimator_6_blade_3_target_index;
MCNUM target_x = mccinter_analyzer_colimator_6_blade_3_target_x;
MCNUM target_y = mccinter_analyzer_colimator_6_blade_3_target_y;
MCNUM target_z = mccinter_analyzer_colimator_6_blade_3_target_z;
MCNUM focus_aw = mccinter_analyzer_colimator_6_blade_3_focus_aw;
MCNUM focus_ah = mccinter_analyzer_colimator_6_blade_3_focus_ah;
MCNUM focus_xw = mccinter_analyzer_colimator_6_blade_3_focus_xw;
MCNUM focus_xh = mccinter_analyzer_colimator_6_blade_3_focus_xh;
MCNUM focus_r = mccinter_analyzer_colimator_6_blade_3_focus_r;
MCNUM p_interact = mccinter_analyzer_colimator_6_blade_3_p_interact;
char* mask_string = mccinter_analyzer_colimator_6_blade_3_mask_string;
char* mask_setting = mccinter_analyzer_colimator_6_blade_3_mask_setting;
MCNUM number_of_activations = mccinter_analyzer_colimator_6_blade_3_number_of_activations;
}   /* End of inter_analyzer_colimator_6_blade_3=Union_box() SETTING parameter declarations. */
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex
  /* Label for restoring  neutron */
  mcabsorbCompinter_analyzer_colimator_6_blade_3:
  if (RESTORE) /* restore if needed */
  { RESTORE_NEUTRON(386,
      mcnlx,
      mcnly,
      mcnlz,
      mcnlvx,
      mcnlvy,
      mcnlvz,
      mcnlt,
      mcnlsx,
      mcnlsy,
      mcnlsz,
      mcnlp); }
#undef mcabsorbComp
#undef p
#undef sz
#undef sy
#undef sx
#undef t
#undef vz
#undef vy
#undef vx
#undef z
#undef y
#undef x
  mcDEBUG_STATE(
mcnlx,
mcnly,
mcnlz,
mcnlvx,
mcnlvy,
mcnlvz,
mcnlt,
mcnlsx,
mcnlsy,
mcnlsz,
mcnlp)

  /* TRACE Component inter_analyzer_colimator_6_blade_4 [387] */
  mccoordschange(mcposrinter_analyzer_colimator_6_blade_4, mcrotrinter_analyzer_colimator_6_blade_4,
    &mcnlx,
    &mcnly,
    &mcnlz,
    &mcnlvx,
    &mcnlvy,
    &mcnlvz,
    &mcnlsx,
    &mcnlsy,
    &mcnlsz);
  /* define label inside component inter_analyzer_colimator_6_blade_4 (without coords transformations) */
  mcJumpTrace_inter_analyzer_colimator_6_blade_4:
  SIG_MESSAGE("inter_analyzer_colimator_6_blade_4 (Trace)");
  mcDEBUG_COMP("inter_analyzer_colimator_6_blade_4")
  mcDEBUG_STATE(
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp)
#define x mcnlx
#define y mcnly
#define z mcnlz
#define vx mcnlvx
#define vy mcnlvy
#define vz mcnlvz
#define t mcnlt
#define sx mcnlsx
#define sy mcnlsy
#define sz mcnlsz
#define p mcnlp

#define mcabsorbComp mcabsorbCompinter_analyzer_colimator_6_blade_4
  STORE_NEUTRON(387,
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp);
  mcScattered=0;
  mcRestore=0;
  mcNCounter[387]++;
  mcPCounter[387] += p;
  mcP2Counter[387] += p*p;
#define mccompcurname  inter_analyzer_colimator_6_blade_4
#define mccompcurtype  Union_box
#define mccompcurindex 387
#define loop_index mccinter_analyzer_colimator_6_blade_4_loop_index
#define this_box_volume mccinter_analyzer_colimator_6_blade_4_this_box_volume
#define global_geometry_element mccinter_analyzer_colimator_6_blade_4_global_geometry_element
#define this_box_storage mccinter_analyzer_colimator_6_blade_4_this_box_storage
{   /* Declarations of inter_analyzer_colimator_6_blade_4=Union_box() SETTING parameters. */
char* material_string = mccinter_analyzer_colimator_6_blade_4_material_string;
MCNUM priority = mccinter_analyzer_colimator_6_blade_4_priority;
MCNUM xwidth = mccinter_analyzer_colimator_6_blade_4_xwidth;
MCNUM yheight = mccinter_analyzer_colimator_6_blade_4_yheight;
MCNUM zdepth = mccinter_analyzer_colimator_6_blade_4_zdepth;
MCNUM xwidth2 = mccinter_analyzer_colimator_6_blade_4_xwidth2;
MCNUM yheight2 = mccinter_analyzer_colimator_6_blade_4_yheight2;
MCNUM visualize = mccinter_analyzer_colimator_6_blade_4_visualize;
int target_index = mccinter_analyzer_colimator_6_blade_4_target_index;
MCNUM target_x = mccinter_analyzer_colimator_6_blade_4_target_x;
MCNUM target_y = mccinter_analyzer_colimator_6_blade_4_target_y;
MCNUM target_z = mccinter_analyzer_colimator_6_blade_4_target_z;
MCNUM focus_aw = mccinter_analyzer_colimator_6_blade_4_focus_aw;
MCNUM focus_ah = mccinter_analyzer_colimator_6_blade_4_focus_ah;
MCNUM focus_xw = mccinter_analyzer_colimator_6_blade_4_focus_xw;
MCNUM focus_xh = mccinter_analyzer_colimator_6_blade_4_focus_xh;
MCNUM focus_r = mccinter_analyzer_colimator_6_blade_4_focus_r;
MCNUM p_interact = mccinter_analyzer_colimator_6_blade_4_p_interact;
char* mask_string = mccinter_analyzer_colimator_6_blade_4_mask_string;
char* mask_setting = mccinter_analyzer_colimator_6_blade_4_mask_setting;
MCNUM number_of_activations = mccinter_analyzer_colimator_6_blade_4_number_of_activations;
}   /* End of inter_analyzer_colimator_6_blade_4=Union_box() SETTING parameter declarations. */
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex
  /* Label for restoring  neutron */
  mcabsorbCompinter_analyzer_colimator_6_blade_4:
  if (RESTORE) /* restore if needed */
  { RESTORE_NEUTRON(387,
      mcnlx,
      mcnly,
      mcnlz,
      mcnlvx,
      mcnlvy,
      mcnlvz,
      mcnlt,
      mcnlsx,
      mcnlsy,
      mcnlsz,
      mcnlp); }
#undef mcabsorbComp
#undef p
#undef sz
#undef sy
#undef sx
#undef t
#undef vz
#undef vy
#undef vx
#undef z
#undef y
#undef x
  mcDEBUG_STATE(
mcnlx,
mcnly,
mcnlz,
mcnlvx,
mcnlvy,
mcnlvz,
mcnlt,
mcnlsx,
mcnlsy,
mcnlsz,
mcnlp)

  /* TRACE Component diffraction_detector_6_exit_volume [388] */
  mccoordschange(mcposrdiffraction_detector_6_exit_volume, mcrotrdiffraction_detector_6_exit_volume,
    &mcnlx,
    &mcnly,
    &mcnlz,
    &mcnlvx,
    &mcnlvy,
    &mcnlvz,
    &mcnlsx,
    &mcnlsy,
    &mcnlsz);
  /* define label inside component diffraction_detector_6_exit_volume (without coords transformations) */
  mcJumpTrace_diffraction_detector_6_exit_volume:
  SIG_MESSAGE("diffraction_detector_6_exit_volume (Trace)");
  mcDEBUG_COMP("diffraction_detector_6_exit_volume")
  mcDEBUG_STATE(
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp)
#define x mcnlx
#define y mcnly
#define z mcnlz
#define vx mcnlvx
#define vy mcnlvy
#define vz mcnlvz
#define t mcnlt
#define sx mcnlsx
#define sy mcnlsy
#define sz mcnlsz
#define p mcnlp

#define mcabsorbComp mcabsorbCompdiffraction_detector_6_exit_volume
  STORE_NEUTRON(388,
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp);
  mcScattered=0;
  mcRestore=0;
  mcNCounter[388]++;
  mcPCounter[388] += p;
  mcP2Counter[388] += p*p;
#define mccompcurname  diffraction_detector_6_exit_volume
#define mccompcurtype  Union_box
#define mccompcurindex 388
#define loop_index mccdiffraction_detector_6_exit_volume_loop_index
#define this_box_volume mccdiffraction_detector_6_exit_volume_this_box_volume
#define global_geometry_element mccdiffraction_detector_6_exit_volume_global_geometry_element
#define this_box_storage mccdiffraction_detector_6_exit_volume_this_box_storage
{   /* Declarations of diffraction_detector_6_exit_volume=Union_box() SETTING parameters. */
char* material_string = mccdiffraction_detector_6_exit_volume_material_string;
MCNUM priority = mccdiffraction_detector_6_exit_volume_priority;
MCNUM xwidth = mccdiffraction_detector_6_exit_volume_xwidth;
MCNUM yheight = mccdiffraction_detector_6_exit_volume_yheight;
MCNUM zdepth = mccdiffraction_detector_6_exit_volume_zdepth;
MCNUM xwidth2 = mccdiffraction_detector_6_exit_volume_xwidth2;
MCNUM yheight2 = mccdiffraction_detector_6_exit_volume_yheight2;
MCNUM visualize = mccdiffraction_detector_6_exit_volume_visualize;
int target_index = mccdiffraction_detector_6_exit_volume_target_index;
MCNUM target_x = mccdiffraction_detector_6_exit_volume_target_x;
MCNUM target_y = mccdiffraction_detector_6_exit_volume_target_y;
MCNUM target_z = mccdiffraction_detector_6_exit_volume_target_z;
MCNUM focus_aw = mccdiffraction_detector_6_exit_volume_focus_aw;
MCNUM focus_ah = mccdiffraction_detector_6_exit_volume_focus_ah;
MCNUM focus_xw = mccdiffraction_detector_6_exit_volume_focus_xw;
MCNUM focus_xh = mccdiffraction_detector_6_exit_volume_focus_xh;
MCNUM focus_r = mccdiffraction_detector_6_exit_volume_focus_r;
MCNUM p_interact = mccdiffraction_detector_6_exit_volume_p_interact;
char* mask_string = mccdiffraction_detector_6_exit_volume_mask_string;
char* mask_setting = mccdiffraction_detector_6_exit_volume_mask_setting;
MCNUM number_of_activations = mccdiffraction_detector_6_exit_volume_number_of_activations;
}   /* End of diffraction_detector_6_exit_volume=Union_box() SETTING parameter declarations. */
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex
  /* Label for restoring  neutron */
  mcabsorbCompdiffraction_detector_6_exit_volume:
  if (RESTORE) /* restore if needed */
  { RESTORE_NEUTRON(388,
      mcnlx,
      mcnly,
      mcnlz,
      mcnlvx,
      mcnlvy,
      mcnlvz,
      mcnlt,
      mcnlsx,
      mcnlsy,
      mcnlsz,
      mcnlp); }
#undef mcabsorbComp
#undef p
#undef sz
#undef sy
#undef sx
#undef t
#undef vz
#undef vy
#undef vx
#undef z
#undef y
#undef x
  mcDEBUG_STATE(
mcnlx,
mcnly,
mcnlz,
mcnlvx,
mcnlvy,
mcnlvz,
mcnlt,
mcnlsx,
mcnlsy,
mcnlsz,
mcnlp)

  /* TRACE Component spec_detector_6_exit_volume [389] */
  mccoordschange(mcposrspec_detector_6_exit_volume, mcrotrspec_detector_6_exit_volume,
    &mcnlx,
    &mcnly,
    &mcnlz,
    &mcnlvx,
    &mcnlvy,
    &mcnlvz,
    &mcnlsx,
    &mcnlsy,
    &mcnlsz);
  /* define label inside component spec_detector_6_exit_volume (without coords transformations) */
  mcJumpTrace_spec_detector_6_exit_volume:
  SIG_MESSAGE("spec_detector_6_exit_volume (Trace)");
  mcDEBUG_COMP("spec_detector_6_exit_volume")
  mcDEBUG_STATE(
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp)
#define x mcnlx
#define y mcnly
#define z mcnlz
#define vx mcnlvx
#define vy mcnlvy
#define vz mcnlvz
#define t mcnlt
#define sx mcnlsx
#define sy mcnlsy
#define sz mcnlsz
#define p mcnlp

#define mcabsorbComp mcabsorbCompspec_detector_6_exit_volume
  STORE_NEUTRON(389,
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp);
  mcScattered=0;
  mcRestore=0;
  mcNCounter[389]++;
  mcPCounter[389] += p;
  mcP2Counter[389] += p*p;
#define mccompcurname  spec_detector_6_exit_volume
#define mccompcurtype  Union_box
#define mccompcurindex 389
#define loop_index mccspec_detector_6_exit_volume_loop_index
#define this_box_volume mccspec_detector_6_exit_volume_this_box_volume
#define global_geometry_element mccspec_detector_6_exit_volume_global_geometry_element
#define this_box_storage mccspec_detector_6_exit_volume_this_box_storage
{   /* Declarations of spec_detector_6_exit_volume=Union_box() SETTING parameters. */
char* material_string = mccspec_detector_6_exit_volume_material_string;
MCNUM priority = mccspec_detector_6_exit_volume_priority;
MCNUM xwidth = mccspec_detector_6_exit_volume_xwidth;
MCNUM yheight = mccspec_detector_6_exit_volume_yheight;
MCNUM zdepth = mccspec_detector_6_exit_volume_zdepth;
MCNUM xwidth2 = mccspec_detector_6_exit_volume_xwidth2;
MCNUM yheight2 = mccspec_detector_6_exit_volume_yheight2;
MCNUM visualize = mccspec_detector_6_exit_volume_visualize;
int target_index = mccspec_detector_6_exit_volume_target_index;
MCNUM target_x = mccspec_detector_6_exit_volume_target_x;
MCNUM target_y = mccspec_detector_6_exit_volume_target_y;
MCNUM target_z = mccspec_detector_6_exit_volume_target_z;
MCNUM focus_aw = mccspec_detector_6_exit_volume_focus_aw;
MCNUM focus_ah = mccspec_detector_6_exit_volume_focus_ah;
MCNUM focus_xw = mccspec_detector_6_exit_volume_focus_xw;
MCNUM focus_xh = mccspec_detector_6_exit_volume_focus_xh;
MCNUM focus_r = mccspec_detector_6_exit_volume_focus_r;
MCNUM p_interact = mccspec_detector_6_exit_volume_p_interact;
char* mask_string = mccspec_detector_6_exit_volume_mask_string;
char* mask_setting = mccspec_detector_6_exit_volume_mask_setting;
MCNUM number_of_activations = mccspec_detector_6_exit_volume_number_of_activations;
}   /* End of spec_detector_6_exit_volume=Union_box() SETTING parameter declarations. */
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex
  /* Label for restoring  neutron */
  mcabsorbCompspec_detector_6_exit_volume:
  if (RESTORE) /* restore if needed */
  { RESTORE_NEUTRON(389,
      mcnlx,
      mcnly,
      mcnlz,
      mcnlvx,
      mcnlvy,
      mcnlvz,
      mcnlt,
      mcnlsx,
      mcnlsy,
      mcnlsz,
      mcnlp); }
#undef mcabsorbComp
#undef p
#undef sz
#undef sy
#undef sx
#undef t
#undef vz
#undef vy
#undef vx
#undef z
#undef y
#undef x
  mcDEBUG_STATE(
mcnlx,
mcnly,
mcnlz,
mcnlvx,
mcnlvy,
mcnlvz,
mcnlt,
mcnlsx,
mcnlsy,
mcnlsz,
mcnlp)

  /* TRACE Component channel_7_cave1_box1 [390] */
  mccoordschange(mcposrchannel_7_cave1_box1, mcrotrchannel_7_cave1_box1,
    &mcnlx,
    &mcnly,
    &mcnlz,
    &mcnlvx,
    &mcnlvy,
    &mcnlvz,
    &mcnlsx,
    &mcnlsy,
    &mcnlsz);
  /* define label inside component channel_7_cave1_box1 (without coords transformations) */
  mcJumpTrace_channel_7_cave1_box1:
  SIG_MESSAGE("channel_7_cave1_box1 (Trace)");
  mcDEBUG_COMP("channel_7_cave1_box1")
  mcDEBUG_STATE(
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp)
#define x mcnlx
#define y mcnly
#define z mcnlz
#define vx mcnlvx
#define vy mcnlvy
#define vz mcnlvz
#define t mcnlt
#define sx mcnlsx
#define sy mcnlsy
#define sz mcnlsz
#define p mcnlp

#define mcabsorbComp mcabsorbCompchannel_7_cave1_box1
  STORE_NEUTRON(390,
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp);
  mcScattered=0;
  mcRestore=0;
  mcNCounter[390]++;
  mcPCounter[390] += p;
  mcP2Counter[390] += p*p;
#define mccompcurname  channel_7_cave1_box1
#define mccompcurtype  Union_box
#define mccompcurindex 390
#define loop_index mccchannel_7_cave1_box1_loop_index
#define this_box_volume mccchannel_7_cave1_box1_this_box_volume
#define global_geometry_element mccchannel_7_cave1_box1_global_geometry_element
#define this_box_storage mccchannel_7_cave1_box1_this_box_storage
{   /* Declarations of channel_7_cave1_box1=Union_box() SETTING parameters. */
char* material_string = mccchannel_7_cave1_box1_material_string;
MCNUM priority = mccchannel_7_cave1_box1_priority;
MCNUM xwidth = mccchannel_7_cave1_box1_xwidth;
MCNUM yheight = mccchannel_7_cave1_box1_yheight;
MCNUM zdepth = mccchannel_7_cave1_box1_zdepth;
MCNUM xwidth2 = mccchannel_7_cave1_box1_xwidth2;
MCNUM yheight2 = mccchannel_7_cave1_box1_yheight2;
MCNUM visualize = mccchannel_7_cave1_box1_visualize;
int target_index = mccchannel_7_cave1_box1_target_index;
MCNUM target_x = mccchannel_7_cave1_box1_target_x;
MCNUM target_y = mccchannel_7_cave1_box1_target_y;
MCNUM target_z = mccchannel_7_cave1_box1_target_z;
MCNUM focus_aw = mccchannel_7_cave1_box1_focus_aw;
MCNUM focus_ah = mccchannel_7_cave1_box1_focus_ah;
MCNUM focus_xw = mccchannel_7_cave1_box1_focus_xw;
MCNUM focus_xh = mccchannel_7_cave1_box1_focus_xh;
MCNUM focus_r = mccchannel_7_cave1_box1_focus_r;
MCNUM p_interact = mccchannel_7_cave1_box1_p_interact;
char* mask_string = mccchannel_7_cave1_box1_mask_string;
char* mask_setting = mccchannel_7_cave1_box1_mask_setting;
MCNUM number_of_activations = mccchannel_7_cave1_box1_number_of_activations;
}   /* End of channel_7_cave1_box1=Union_box() SETTING parameter declarations. */
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex
  /* Label for restoring  neutron */
  mcabsorbCompchannel_7_cave1_box1:
  if (RESTORE) /* restore if needed */
  { RESTORE_NEUTRON(390,
      mcnlx,
      mcnly,
      mcnlz,
      mcnlvx,
      mcnlvy,
      mcnlvz,
      mcnlt,
      mcnlsx,
      mcnlsy,
      mcnlsz,
      mcnlp); }
#undef mcabsorbComp
#undef p
#undef sz
#undef sy
#undef sx
#undef t
#undef vz
#undef vy
#undef vx
#undef z
#undef y
#undef x
  mcDEBUG_STATE(
mcnlx,
mcnly,
mcnlz,
mcnlvx,
mcnlvy,
mcnlvz,
mcnlt,
mcnlsx,
mcnlsy,
mcnlsz,
mcnlp)

  /* TRACE Component channel_7_cave1_box2 [391] */
  mccoordschange(mcposrchannel_7_cave1_box2, mcrotrchannel_7_cave1_box2,
    &mcnlx,
    &mcnly,
    &mcnlz,
    &mcnlvx,
    &mcnlvy,
    &mcnlvz,
    &mcnlsx,
    &mcnlsy,
    &mcnlsz);
  /* define label inside component channel_7_cave1_box2 (without coords transformations) */
  mcJumpTrace_channel_7_cave1_box2:
  SIG_MESSAGE("channel_7_cave1_box2 (Trace)");
  mcDEBUG_COMP("channel_7_cave1_box2")
  mcDEBUG_STATE(
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp)
#define x mcnlx
#define y mcnly
#define z mcnlz
#define vx mcnlvx
#define vy mcnlvy
#define vz mcnlvz
#define t mcnlt
#define sx mcnlsx
#define sy mcnlsy
#define sz mcnlsz
#define p mcnlp

#define mcabsorbComp mcabsorbCompchannel_7_cave1_box2
  STORE_NEUTRON(391,
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp);
  mcScattered=0;
  mcRestore=0;
  mcNCounter[391]++;
  mcPCounter[391] += p;
  mcP2Counter[391] += p*p;
#define mccompcurname  channel_7_cave1_box2
#define mccompcurtype  Union_box
#define mccompcurindex 391
#define loop_index mccchannel_7_cave1_box2_loop_index
#define this_box_volume mccchannel_7_cave1_box2_this_box_volume
#define global_geometry_element mccchannel_7_cave1_box2_global_geometry_element
#define this_box_storage mccchannel_7_cave1_box2_this_box_storage
{   /* Declarations of channel_7_cave1_box2=Union_box() SETTING parameters. */
char* material_string = mccchannel_7_cave1_box2_material_string;
MCNUM priority = mccchannel_7_cave1_box2_priority;
MCNUM xwidth = mccchannel_7_cave1_box2_xwidth;
MCNUM yheight = mccchannel_7_cave1_box2_yheight;
MCNUM zdepth = mccchannel_7_cave1_box2_zdepth;
MCNUM xwidth2 = mccchannel_7_cave1_box2_xwidth2;
MCNUM yheight2 = mccchannel_7_cave1_box2_yheight2;
MCNUM visualize = mccchannel_7_cave1_box2_visualize;
int target_index = mccchannel_7_cave1_box2_target_index;
MCNUM target_x = mccchannel_7_cave1_box2_target_x;
MCNUM target_y = mccchannel_7_cave1_box2_target_y;
MCNUM target_z = mccchannel_7_cave1_box2_target_z;
MCNUM focus_aw = mccchannel_7_cave1_box2_focus_aw;
MCNUM focus_ah = mccchannel_7_cave1_box2_focus_ah;
MCNUM focus_xw = mccchannel_7_cave1_box2_focus_xw;
MCNUM focus_xh = mccchannel_7_cave1_box2_focus_xh;
MCNUM focus_r = mccchannel_7_cave1_box2_focus_r;
MCNUM p_interact = mccchannel_7_cave1_box2_p_interact;
char* mask_string = mccchannel_7_cave1_box2_mask_string;
char* mask_setting = mccchannel_7_cave1_box2_mask_setting;
MCNUM number_of_activations = mccchannel_7_cave1_box2_number_of_activations;
}   /* End of channel_7_cave1_box2=Union_box() SETTING parameter declarations. */
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex
  /* Label for restoring  neutron */
  mcabsorbCompchannel_7_cave1_box2:
  if (RESTORE) /* restore if needed */
  { RESTORE_NEUTRON(391,
      mcnlx,
      mcnly,
      mcnlz,
      mcnlvx,
      mcnlvy,
      mcnlvz,
      mcnlt,
      mcnlsx,
      mcnlsy,
      mcnlsz,
      mcnlp); }
#undef mcabsorbComp
#undef p
#undef sz
#undef sy
#undef sx
#undef t
#undef vz
#undef vy
#undef vx
#undef z
#undef y
#undef x
  mcDEBUG_STATE(
mcnlx,
mcnly,
mcnlz,
mcnlvx,
mcnlvy,
mcnlvz,
mcnlt,
mcnlsx,
mcnlsy,
mcnlsz,
mcnlp)

  /* TRACE Component channel_7_cave1_box3 [392] */
  mccoordschange(mcposrchannel_7_cave1_box3, mcrotrchannel_7_cave1_box3,
    &mcnlx,
    &mcnly,
    &mcnlz,
    &mcnlvx,
    &mcnlvy,
    &mcnlvz,
    &mcnlsx,
    &mcnlsy,
    &mcnlsz);
  /* define label inside component channel_7_cave1_box3 (without coords transformations) */
  mcJumpTrace_channel_7_cave1_box3:
  SIG_MESSAGE("channel_7_cave1_box3 (Trace)");
  mcDEBUG_COMP("channel_7_cave1_box3")
  mcDEBUG_STATE(
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp)
#define x mcnlx
#define y mcnly
#define z mcnlz
#define vx mcnlvx
#define vy mcnlvy
#define vz mcnlvz
#define t mcnlt
#define sx mcnlsx
#define sy mcnlsy
#define sz mcnlsz
#define p mcnlp

#define mcabsorbComp mcabsorbCompchannel_7_cave1_box3
  STORE_NEUTRON(392,
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp);
  mcScattered=0;
  mcRestore=0;
  mcNCounter[392]++;
  mcPCounter[392] += p;
  mcP2Counter[392] += p*p;
#define mccompcurname  channel_7_cave1_box3
#define mccompcurtype  Union_box
#define mccompcurindex 392
#define loop_index mccchannel_7_cave1_box3_loop_index
#define this_box_volume mccchannel_7_cave1_box3_this_box_volume
#define global_geometry_element mccchannel_7_cave1_box3_global_geometry_element
#define this_box_storage mccchannel_7_cave1_box3_this_box_storage
{   /* Declarations of channel_7_cave1_box3=Union_box() SETTING parameters. */
char* material_string = mccchannel_7_cave1_box3_material_string;
MCNUM priority = mccchannel_7_cave1_box3_priority;
MCNUM xwidth = mccchannel_7_cave1_box3_xwidth;
MCNUM yheight = mccchannel_7_cave1_box3_yheight;
MCNUM zdepth = mccchannel_7_cave1_box3_zdepth;
MCNUM xwidth2 = mccchannel_7_cave1_box3_xwidth2;
MCNUM yheight2 = mccchannel_7_cave1_box3_yheight2;
MCNUM visualize = mccchannel_7_cave1_box3_visualize;
int target_index = mccchannel_7_cave1_box3_target_index;
MCNUM target_x = mccchannel_7_cave1_box3_target_x;
MCNUM target_y = mccchannel_7_cave1_box3_target_y;
MCNUM target_z = mccchannel_7_cave1_box3_target_z;
MCNUM focus_aw = mccchannel_7_cave1_box3_focus_aw;
MCNUM focus_ah = mccchannel_7_cave1_box3_focus_ah;
MCNUM focus_xw = mccchannel_7_cave1_box3_focus_xw;
MCNUM focus_xh = mccchannel_7_cave1_box3_focus_xh;
MCNUM focus_r = mccchannel_7_cave1_box3_focus_r;
MCNUM p_interact = mccchannel_7_cave1_box3_p_interact;
char* mask_string = mccchannel_7_cave1_box3_mask_string;
char* mask_setting = mccchannel_7_cave1_box3_mask_setting;
MCNUM number_of_activations = mccchannel_7_cave1_box3_number_of_activations;
}   /* End of channel_7_cave1_box3=Union_box() SETTING parameter declarations. */
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex
  /* Label for restoring  neutron */
  mcabsorbCompchannel_7_cave1_box3:
  if (RESTORE) /* restore if needed */
  { RESTORE_NEUTRON(392,
      mcnlx,
      mcnly,
      mcnlz,
      mcnlvx,
      mcnlvy,
      mcnlvz,
      mcnlt,
      mcnlsx,
      mcnlsy,
      mcnlsz,
      mcnlp); }
#undef mcabsorbComp
#undef p
#undef sz
#undef sy
#undef sx
#undef t
#undef vz
#undef vy
#undef vx
#undef z
#undef y
#undef x
  mcDEBUG_STATE(
mcnlx,
mcnly,
mcnlz,
mcnlvx,
mcnlvy,
mcnlvz,
mcnlt,
mcnlsx,
mcnlsy,
mcnlsz,
mcnlp)

  /* TRACE Component channel_7_cave1_cyl1 [393] */
  mccoordschange(mcposrchannel_7_cave1_cyl1, mcrotrchannel_7_cave1_cyl1,
    &mcnlx,
    &mcnly,
    &mcnlz,
    &mcnlvx,
    &mcnlvy,
    &mcnlvz,
    &mcnlsx,
    &mcnlsy,
    &mcnlsz);
  /* define label inside component channel_7_cave1_cyl1 (without coords transformations) */
  mcJumpTrace_channel_7_cave1_cyl1:
  SIG_MESSAGE("channel_7_cave1_cyl1 (Trace)");
  mcDEBUG_COMP("channel_7_cave1_cyl1")
  mcDEBUG_STATE(
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp)
#define x mcnlx
#define y mcnly
#define z mcnlz
#define vx mcnlvx
#define vy mcnlvy
#define vz mcnlvz
#define t mcnlt
#define sx mcnlsx
#define sy mcnlsy
#define sz mcnlsz
#define p mcnlp

#define mcabsorbComp mcabsorbCompchannel_7_cave1_cyl1
  STORE_NEUTRON(393,
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp);
  mcScattered=0;
  mcRestore=0;
  mcNCounter[393]++;
  mcPCounter[393] += p;
  mcP2Counter[393] += p*p;
#define mccompcurname  channel_7_cave1_cyl1
#define mccompcurtype  Union_cylinder
#define mccompcurindex 393
#define loop_index mccchannel_7_cave1_cyl1_loop_index
#define this_cylinder_volume mccchannel_7_cave1_cyl1_this_cylinder_volume
#define global_geometry_element mccchannel_7_cave1_cyl1_global_geometry_element
#define this_cylinder_storage mccchannel_7_cave1_cyl1_this_cylinder_storage
{   /* Declarations of channel_7_cave1_cyl1=Union_cylinder() SETTING parameters. */
char* material_string = mccchannel_7_cave1_cyl1_material_string;
MCNUM priority = mccchannel_7_cave1_cyl1_priority;
MCNUM radius = mccchannel_7_cave1_cyl1_radius;
MCNUM yheight = mccchannel_7_cave1_cyl1_yheight;
MCNUM visualize = mccchannel_7_cave1_cyl1_visualize;
int target_index = mccchannel_7_cave1_cyl1_target_index;
MCNUM target_x = mccchannel_7_cave1_cyl1_target_x;
MCNUM target_y = mccchannel_7_cave1_cyl1_target_y;
MCNUM target_z = mccchannel_7_cave1_cyl1_target_z;
MCNUM focus_aw = mccchannel_7_cave1_cyl1_focus_aw;
MCNUM focus_ah = mccchannel_7_cave1_cyl1_focus_ah;
MCNUM focus_xw = mccchannel_7_cave1_cyl1_focus_xw;
MCNUM focus_xh = mccchannel_7_cave1_cyl1_focus_xh;
MCNUM focus_r = mccchannel_7_cave1_cyl1_focus_r;
MCNUM p_interact = mccchannel_7_cave1_cyl1_p_interact;
char* mask_string = mccchannel_7_cave1_cyl1_mask_string;
char* mask_setting = mccchannel_7_cave1_cyl1_mask_setting;
MCNUM number_of_activations = mccchannel_7_cave1_cyl1_number_of_activations;
#line 345 "Union_cylinder.comp"
{
dummy = 1;
}
#line 397645 "MACS_sample_kidney_box.c"
}   /* End of channel_7_cave1_cyl1=Union_cylinder() SETTING parameter declarations. */
#undef this_cylinder_storage
#undef global_geometry_element
#undef this_cylinder_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex
  /* Label for restoring  neutron */
  mcabsorbCompchannel_7_cave1_cyl1:
  if (RESTORE) /* restore if needed */
  { RESTORE_NEUTRON(393,
      mcnlx,
      mcnly,
      mcnlz,
      mcnlvx,
      mcnlvy,
      mcnlvz,
      mcnlt,
      mcnlsx,
      mcnlsy,
      mcnlsz,
      mcnlp); }
#undef mcabsorbComp
#undef p
#undef sz
#undef sy
#undef sx
#undef t
#undef vz
#undef vy
#undef vx
#undef z
#undef y
#undef x
  mcDEBUG_STATE(
mcnlx,
mcnly,
mcnlz,
mcnlvx,
mcnlvy,
mcnlvz,
mcnlt,
mcnlsx,
mcnlsy,
mcnlsz,
mcnlp)

  /* TRACE Component channel_7_analyzer_1_center [394] */
  mccoordschange(mcposrchannel_7_analyzer_1_center, mcrotrchannel_7_analyzer_1_center,
    &mcnlx,
    &mcnly,
    &mcnlz,
    &mcnlvx,
    &mcnlvy,
    &mcnlvz,
    &mcnlsx,
    &mcnlsy,
    &mcnlsz);
  /* define label inside component channel_7_analyzer_1_center (without coords transformations) */
  mcJumpTrace_channel_7_analyzer_1_center:
  SIG_MESSAGE("channel_7_analyzer_1_center (Trace)");
  mcDEBUG_COMP("channel_7_analyzer_1_center")
  mcDEBUG_STATE(
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp)
#define x mcnlx
#define y mcnly
#define z mcnlz
#define vx mcnlvx
#define vy mcnlvy
#define vz mcnlvz
#define t mcnlt
#define sx mcnlsx
#define sy mcnlsy
#define sz mcnlsz
#define p mcnlp

#define mcabsorbComp mcabsorbCompchannel_7_analyzer_1_center
  STORE_NEUTRON(394,
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp);
  mcScattered=0;
  mcRestore=0;
  mcNCounter[394]++;
  mcPCounter[394] += p;
  mcP2Counter[394] += p*p;
#define mccompcurname  channel_7_analyzer_1_center
#define mccompcurtype  Arm
#define mccompcurindex 394
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex
  /* Label for restoring  neutron */
  mcabsorbCompchannel_7_analyzer_1_center:
  if (RESTORE) /* restore if needed */
  { RESTORE_NEUTRON(394,
      mcnlx,
      mcnly,
      mcnlz,
      mcnlvx,
      mcnlvy,
      mcnlvz,
      mcnlt,
      mcnlsx,
      mcnlsy,
      mcnlsz,
      mcnlp); }
#undef mcabsorbComp
#undef p
#undef sz
#undef sy
#undef sx
#undef t
#undef vz
#undef vy
#undef vx
#undef z
#undef y
#undef x
  mcDEBUG_STATE(
mcnlx,
mcnly,
mcnlz,
mcnlvx,
mcnlvy,
mcnlvz,
mcnlt,
mcnlsx,
mcnlsy,
mcnlsz,
mcnlp)

  /* TRACE Component channel_7_analyzer_1_rotated [395] */
  mccoordschange(mcposrchannel_7_analyzer_1_rotated, mcrotrchannel_7_analyzer_1_rotated,
    &mcnlx,
    &mcnly,
    &mcnlz,
    &mcnlvx,
    &mcnlvy,
    &mcnlvz,
    &mcnlsx,
    &mcnlsy,
    &mcnlsz);
  /* define label inside component channel_7_analyzer_1_rotated (without coords transformations) */
  mcJumpTrace_channel_7_analyzer_1_rotated:
  SIG_MESSAGE("channel_7_analyzer_1_rotated (Trace)");
  mcDEBUG_COMP("channel_7_analyzer_1_rotated")
  mcDEBUG_STATE(
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp)
#define x mcnlx
#define y mcnly
#define z mcnlz
#define vx mcnlvx
#define vy mcnlvy
#define vz mcnlvz
#define t mcnlt
#define sx mcnlsx
#define sy mcnlsy
#define sz mcnlsz
#define p mcnlp

#define mcabsorbComp mcabsorbCompchannel_7_analyzer_1_rotated
  STORE_NEUTRON(395,
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp);
  mcScattered=0;
  mcRestore=0;
  mcNCounter[395]++;
  mcPCounter[395] += p;
  mcP2Counter[395] += p*p;
#define mccompcurname  channel_7_analyzer_1_rotated
#define mccompcurtype  Arm
#define mccompcurindex 395
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex
  /* Label for restoring  neutron */
  mcabsorbCompchannel_7_analyzer_1_rotated:
  if (RESTORE) /* restore if needed */
  { RESTORE_NEUTRON(395,
      mcnlx,
      mcnly,
      mcnlz,
      mcnlvx,
      mcnlvy,
      mcnlvz,
      mcnlt,
      mcnlsx,
      mcnlsy,
      mcnlsz,
      mcnlp); }
#undef mcabsorbComp
#undef p
#undef sz
#undef sy
#undef sx
#undef t
#undef vz
#undef vy
#undef vx
#undef z
#undef y
#undef x
  mcDEBUG_STATE(
mcnlx,
mcnly,
mcnlz,
mcnlvx,
mcnlvy,
mcnlvz,
mcnlt,
mcnlsx,
mcnlsy,
mcnlsz,
mcnlp)

  /* TRACE Component channel_7_analyzer_1_array_crystal_array_0 [396] */
  mccoordschange(mcposrchannel_7_analyzer_1_array_crystal_array_0, mcrotrchannel_7_analyzer_1_array_crystal_array_0,
    &mcnlx,
    &mcnly,
    &mcnlz,
    &mcnlvx,
    &mcnlvy,
    &mcnlvz,
    &mcnlsx,
    &mcnlsy,
    &mcnlsz);
  /* define label inside component channel_7_analyzer_1_array_crystal_array_0 (without coords transformations) */
  mcJumpTrace_channel_7_analyzer_1_array_crystal_array_0:
  SIG_MESSAGE("channel_7_analyzer_1_array_crystal_array_0 (Trace)");
  mcDEBUG_COMP("channel_7_analyzer_1_array_crystal_array_0")
  mcDEBUG_STATE(
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp)
#define x mcnlx
#define y mcnly
#define z mcnlz
#define vx mcnlvx
#define vy mcnlvy
#define vz mcnlvz
#define t mcnlt
#define sx mcnlsx
#define sy mcnlsy
#define sz mcnlsz
#define p mcnlp

#define mcabsorbComp mcabsorbCompchannel_7_analyzer_1_array_crystal_array_0
  STORE_NEUTRON(396,
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp);
  mcScattered=0;
  mcRestore=0;
  mcNCounter[396]++;
  mcPCounter[396] += p;
  mcP2Counter[396] += p*p;
#define mccompcurname  channel_7_analyzer_1_array_crystal_array_0
#define mccompcurtype  Union_box
#define mccompcurindex 396
#define loop_index mccchannel_7_analyzer_1_array_crystal_array_0_loop_index
#define this_box_volume mccchannel_7_analyzer_1_array_crystal_array_0_this_box_volume
#define global_geometry_element mccchannel_7_analyzer_1_array_crystal_array_0_global_geometry_element
#define this_box_storage mccchannel_7_analyzer_1_array_crystal_array_0_this_box_storage
{   /* Declarations of channel_7_analyzer_1_array_crystal_array_0=Union_box() SETTING parameters. */
char* material_string = mccchannel_7_analyzer_1_array_crystal_array_0_material_string;
MCNUM priority = mccchannel_7_analyzer_1_array_crystal_array_0_priority;
MCNUM xwidth = mccchannel_7_analyzer_1_array_crystal_array_0_xwidth;
MCNUM yheight = mccchannel_7_analyzer_1_array_crystal_array_0_yheight;
MCNUM zdepth = mccchannel_7_analyzer_1_array_crystal_array_0_zdepth;
MCNUM xwidth2 = mccchannel_7_analyzer_1_array_crystal_array_0_xwidth2;
MCNUM yheight2 = mccchannel_7_analyzer_1_array_crystal_array_0_yheight2;
MCNUM visualize = mccchannel_7_analyzer_1_array_crystal_array_0_visualize;
int target_index = mccchannel_7_analyzer_1_array_crystal_array_0_target_index;
MCNUM target_x = mccchannel_7_analyzer_1_array_crystal_array_0_target_x;
MCNUM target_y = mccchannel_7_analyzer_1_array_crystal_array_0_target_y;
MCNUM target_z = mccchannel_7_analyzer_1_array_crystal_array_0_target_z;
MCNUM focus_aw = mccchannel_7_analyzer_1_array_crystal_array_0_focus_aw;
MCNUM focus_ah = mccchannel_7_analyzer_1_array_crystal_array_0_focus_ah;
MCNUM focus_xw = mccchannel_7_analyzer_1_array_crystal_array_0_focus_xw;
MCNUM focus_xh = mccchannel_7_analyzer_1_array_crystal_array_0_focus_xh;
MCNUM focus_r = mccchannel_7_analyzer_1_array_crystal_array_0_focus_r;
MCNUM p_interact = mccchannel_7_analyzer_1_array_crystal_array_0_p_interact;
char* mask_string = mccchannel_7_analyzer_1_array_crystal_array_0_mask_string;
char* mask_setting = mccchannel_7_analyzer_1_array_crystal_array_0_mask_setting;
MCNUM number_of_activations = mccchannel_7_analyzer_1_array_crystal_array_0_number_of_activations;
}   /* End of channel_7_analyzer_1_array_crystal_array_0=Union_box() SETTING parameter declarations. */
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex
  /* Label for restoring  neutron */
  mcabsorbCompchannel_7_analyzer_1_array_crystal_array_0:
  if (RESTORE) /* restore if needed */
  { RESTORE_NEUTRON(396,
      mcnlx,
      mcnly,
      mcnlz,
      mcnlvx,
      mcnlvy,
      mcnlvz,
      mcnlt,
      mcnlsx,
      mcnlsy,
      mcnlsz,
      mcnlp); }
#undef mcabsorbComp
#undef p
#undef sz
#undef sy
#undef sx
#undef t
#undef vz
#undef vy
#undef vx
#undef z
#undef y
#undef x
  mcDEBUG_STATE(
mcnlx,
mcnly,
mcnlz,
mcnlvx,
mcnlvy,
mcnlvz,
mcnlt,
mcnlsx,
mcnlsy,
mcnlsz,
mcnlp)

  /* TRACE Component channel_7_analyzer_1_array_crystal_array_1 [397] */
  mccoordschange(mcposrchannel_7_analyzer_1_array_crystal_array_1, mcrotrchannel_7_analyzer_1_array_crystal_array_1,
    &mcnlx,
    &mcnly,
    &mcnlz,
    &mcnlvx,
    &mcnlvy,
    &mcnlvz,
    &mcnlsx,
    &mcnlsy,
    &mcnlsz);
  /* define label inside component channel_7_analyzer_1_array_crystal_array_1 (without coords transformations) */
  mcJumpTrace_channel_7_analyzer_1_array_crystal_array_1:
  SIG_MESSAGE("channel_7_analyzer_1_array_crystal_array_1 (Trace)");
  mcDEBUG_COMP("channel_7_analyzer_1_array_crystal_array_1")
  mcDEBUG_STATE(
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp)
#define x mcnlx
#define y mcnly
#define z mcnlz
#define vx mcnlvx
#define vy mcnlvy
#define vz mcnlvz
#define t mcnlt
#define sx mcnlsx
#define sy mcnlsy
#define sz mcnlsz
#define p mcnlp

#define mcabsorbComp mcabsorbCompchannel_7_analyzer_1_array_crystal_array_1
  STORE_NEUTRON(397,
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp);
  mcScattered=0;
  mcRestore=0;
  mcNCounter[397]++;
  mcPCounter[397] += p;
  mcP2Counter[397] += p*p;
#define mccompcurname  channel_7_analyzer_1_array_crystal_array_1
#define mccompcurtype  Union_box
#define mccompcurindex 397
#define loop_index mccchannel_7_analyzer_1_array_crystal_array_1_loop_index
#define this_box_volume mccchannel_7_analyzer_1_array_crystal_array_1_this_box_volume
#define global_geometry_element mccchannel_7_analyzer_1_array_crystal_array_1_global_geometry_element
#define this_box_storage mccchannel_7_analyzer_1_array_crystal_array_1_this_box_storage
{   /* Declarations of channel_7_analyzer_1_array_crystal_array_1=Union_box() SETTING parameters. */
char* material_string = mccchannel_7_analyzer_1_array_crystal_array_1_material_string;
MCNUM priority = mccchannel_7_analyzer_1_array_crystal_array_1_priority;
MCNUM xwidth = mccchannel_7_analyzer_1_array_crystal_array_1_xwidth;
MCNUM yheight = mccchannel_7_analyzer_1_array_crystal_array_1_yheight;
MCNUM zdepth = mccchannel_7_analyzer_1_array_crystal_array_1_zdepth;
MCNUM xwidth2 = mccchannel_7_analyzer_1_array_crystal_array_1_xwidth2;
MCNUM yheight2 = mccchannel_7_analyzer_1_array_crystal_array_1_yheight2;
MCNUM visualize = mccchannel_7_analyzer_1_array_crystal_array_1_visualize;
int target_index = mccchannel_7_analyzer_1_array_crystal_array_1_target_index;
MCNUM target_x = mccchannel_7_analyzer_1_array_crystal_array_1_target_x;
MCNUM target_y = mccchannel_7_analyzer_1_array_crystal_array_1_target_y;
MCNUM target_z = mccchannel_7_analyzer_1_array_crystal_array_1_target_z;
MCNUM focus_aw = mccchannel_7_analyzer_1_array_crystal_array_1_focus_aw;
MCNUM focus_ah = mccchannel_7_analyzer_1_array_crystal_array_1_focus_ah;
MCNUM focus_xw = mccchannel_7_analyzer_1_array_crystal_array_1_focus_xw;
MCNUM focus_xh = mccchannel_7_analyzer_1_array_crystal_array_1_focus_xh;
MCNUM focus_r = mccchannel_7_analyzer_1_array_crystal_array_1_focus_r;
MCNUM p_interact = mccchannel_7_analyzer_1_array_crystal_array_1_p_interact;
char* mask_string = mccchannel_7_analyzer_1_array_crystal_array_1_mask_string;
char* mask_setting = mccchannel_7_analyzer_1_array_crystal_array_1_mask_setting;
MCNUM number_of_activations = mccchannel_7_analyzer_1_array_crystal_array_1_number_of_activations;
}   /* End of channel_7_analyzer_1_array_crystal_array_1=Union_box() SETTING parameter declarations. */
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex
  /* Label for restoring  neutron */
  mcabsorbCompchannel_7_analyzer_1_array_crystal_array_1:
  if (RESTORE) /* restore if needed */
  { RESTORE_NEUTRON(397,
      mcnlx,
      mcnly,
      mcnlz,
      mcnlvx,
      mcnlvy,
      mcnlvz,
      mcnlt,
      mcnlsx,
      mcnlsy,
      mcnlsz,
      mcnlp); }
#undef mcabsorbComp
#undef p
#undef sz
#undef sy
#undef sx
#undef t
#undef vz
#undef vy
#undef vx
#undef z
#undef y
#undef x
  mcDEBUG_STATE(
mcnlx,
mcnly,
mcnlz,
mcnlvx,
mcnlvy,
mcnlvz,
mcnlt,
mcnlsx,
mcnlsy,
mcnlsz,
mcnlp)

  /* TRACE Component channel_7_analyzer_1_array_crystal_array_2 [398] */
  mccoordschange(mcposrchannel_7_analyzer_1_array_crystal_array_2, mcrotrchannel_7_analyzer_1_array_crystal_array_2,
    &mcnlx,
    &mcnly,
    &mcnlz,
    &mcnlvx,
    &mcnlvy,
    &mcnlvz,
    &mcnlsx,
    &mcnlsy,
    &mcnlsz);
  /* define label inside component channel_7_analyzer_1_array_crystal_array_2 (without coords transformations) */
  mcJumpTrace_channel_7_analyzer_1_array_crystal_array_2:
  SIG_MESSAGE("channel_7_analyzer_1_array_crystal_array_2 (Trace)");
  mcDEBUG_COMP("channel_7_analyzer_1_array_crystal_array_2")
  mcDEBUG_STATE(
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp)
#define x mcnlx
#define y mcnly
#define z mcnlz
#define vx mcnlvx
#define vy mcnlvy
#define vz mcnlvz
#define t mcnlt
#define sx mcnlsx
#define sy mcnlsy
#define sz mcnlsz
#define p mcnlp

#define mcabsorbComp mcabsorbCompchannel_7_analyzer_1_array_crystal_array_2
  STORE_NEUTRON(398,
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp);
  mcScattered=0;
  mcRestore=0;
  mcNCounter[398]++;
  mcPCounter[398] += p;
  mcP2Counter[398] += p*p;
#define mccompcurname  channel_7_analyzer_1_array_crystal_array_2
#define mccompcurtype  Union_box
#define mccompcurindex 398
#define loop_index mccchannel_7_analyzer_1_array_crystal_array_2_loop_index
#define this_box_volume mccchannel_7_analyzer_1_array_crystal_array_2_this_box_volume
#define global_geometry_element mccchannel_7_analyzer_1_array_crystal_array_2_global_geometry_element
#define this_box_storage mccchannel_7_analyzer_1_array_crystal_array_2_this_box_storage
{   /* Declarations of channel_7_analyzer_1_array_crystal_array_2=Union_box() SETTING parameters. */
char* material_string = mccchannel_7_analyzer_1_array_crystal_array_2_material_string;
MCNUM priority = mccchannel_7_analyzer_1_array_crystal_array_2_priority;
MCNUM xwidth = mccchannel_7_analyzer_1_array_crystal_array_2_xwidth;
MCNUM yheight = mccchannel_7_analyzer_1_array_crystal_array_2_yheight;
MCNUM zdepth = mccchannel_7_analyzer_1_array_crystal_array_2_zdepth;
MCNUM xwidth2 = mccchannel_7_analyzer_1_array_crystal_array_2_xwidth2;
MCNUM yheight2 = mccchannel_7_analyzer_1_array_crystal_array_2_yheight2;
MCNUM visualize = mccchannel_7_analyzer_1_array_crystal_array_2_visualize;
int target_index = mccchannel_7_analyzer_1_array_crystal_array_2_target_index;
MCNUM target_x = mccchannel_7_analyzer_1_array_crystal_array_2_target_x;
MCNUM target_y = mccchannel_7_analyzer_1_array_crystal_array_2_target_y;
MCNUM target_z = mccchannel_7_analyzer_1_array_crystal_array_2_target_z;
MCNUM focus_aw = mccchannel_7_analyzer_1_array_crystal_array_2_focus_aw;
MCNUM focus_ah = mccchannel_7_analyzer_1_array_crystal_array_2_focus_ah;
MCNUM focus_xw = mccchannel_7_analyzer_1_array_crystal_array_2_focus_xw;
MCNUM focus_xh = mccchannel_7_analyzer_1_array_crystal_array_2_focus_xh;
MCNUM focus_r = mccchannel_7_analyzer_1_array_crystal_array_2_focus_r;
MCNUM p_interact = mccchannel_7_analyzer_1_array_crystal_array_2_p_interact;
char* mask_string = mccchannel_7_analyzer_1_array_crystal_array_2_mask_string;
char* mask_setting = mccchannel_7_analyzer_1_array_crystal_array_2_mask_setting;
MCNUM number_of_activations = mccchannel_7_analyzer_1_array_crystal_array_2_number_of_activations;
}   /* End of channel_7_analyzer_1_array_crystal_array_2=Union_box() SETTING parameter declarations. */
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex
  /* Label for restoring  neutron */
  mcabsorbCompchannel_7_analyzer_1_array_crystal_array_2:
  if (RESTORE) /* restore if needed */
  { RESTORE_NEUTRON(398,
      mcnlx,
      mcnly,
      mcnlz,
      mcnlvx,
      mcnlvy,
      mcnlvz,
      mcnlt,
      mcnlsx,
      mcnlsy,
      mcnlsz,
      mcnlp); }
#undef mcabsorbComp
#undef p
#undef sz
#undef sy
#undef sx
#undef t
#undef vz
#undef vy
#undef vx
#undef z
#undef y
#undef x
  mcDEBUG_STATE(
mcnlx,
mcnly,
mcnlz,
mcnlvx,
mcnlvy,
mcnlvz,
mcnlt,
mcnlsx,
mcnlsy,
mcnlsz,
mcnlp)

  /* TRACE Component channel_7_analyzer_1_array_crystal_array_3 [399] */
  mccoordschange(mcposrchannel_7_analyzer_1_array_crystal_array_3, mcrotrchannel_7_analyzer_1_array_crystal_array_3,
    &mcnlx,
    &mcnly,
    &mcnlz,
    &mcnlvx,
    &mcnlvy,
    &mcnlvz,
    &mcnlsx,
    &mcnlsy,
    &mcnlsz);
  /* define label inside component channel_7_analyzer_1_array_crystal_array_3 (without coords transformations) */
  mcJumpTrace_channel_7_analyzer_1_array_crystal_array_3:
  SIG_MESSAGE("channel_7_analyzer_1_array_crystal_array_3 (Trace)");
  mcDEBUG_COMP("channel_7_analyzer_1_array_crystal_array_3")
  mcDEBUG_STATE(
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp)
#define x mcnlx
#define y mcnly
#define z mcnlz
#define vx mcnlvx
#define vy mcnlvy
#define vz mcnlvz
#define t mcnlt
#define sx mcnlsx
#define sy mcnlsy
#define sz mcnlsz
#define p mcnlp

#define mcabsorbComp mcabsorbCompchannel_7_analyzer_1_array_crystal_array_3
  STORE_NEUTRON(399,
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp);
  mcScattered=0;
  mcRestore=0;
  mcNCounter[399]++;
  mcPCounter[399] += p;
  mcP2Counter[399] += p*p;
#define mccompcurname  channel_7_analyzer_1_array_crystal_array_3
#define mccompcurtype  Union_box
#define mccompcurindex 399
#define loop_index mccchannel_7_analyzer_1_array_crystal_array_3_loop_index
#define this_box_volume mccchannel_7_analyzer_1_array_crystal_array_3_this_box_volume
#define global_geometry_element mccchannel_7_analyzer_1_array_crystal_array_3_global_geometry_element
#define this_box_storage mccchannel_7_analyzer_1_array_crystal_array_3_this_box_storage
{   /* Declarations of channel_7_analyzer_1_array_crystal_array_3=Union_box() SETTING parameters. */
char* material_string = mccchannel_7_analyzer_1_array_crystal_array_3_material_string;
MCNUM priority = mccchannel_7_analyzer_1_array_crystal_array_3_priority;
MCNUM xwidth = mccchannel_7_analyzer_1_array_crystal_array_3_xwidth;
MCNUM yheight = mccchannel_7_analyzer_1_array_crystal_array_3_yheight;
MCNUM zdepth = mccchannel_7_analyzer_1_array_crystal_array_3_zdepth;
MCNUM xwidth2 = mccchannel_7_analyzer_1_array_crystal_array_3_xwidth2;
MCNUM yheight2 = mccchannel_7_analyzer_1_array_crystal_array_3_yheight2;
MCNUM visualize = mccchannel_7_analyzer_1_array_crystal_array_3_visualize;
int target_index = mccchannel_7_analyzer_1_array_crystal_array_3_target_index;
MCNUM target_x = mccchannel_7_analyzer_1_array_crystal_array_3_target_x;
MCNUM target_y = mccchannel_7_analyzer_1_array_crystal_array_3_target_y;
MCNUM target_z = mccchannel_7_analyzer_1_array_crystal_array_3_target_z;
MCNUM focus_aw = mccchannel_7_analyzer_1_array_crystal_array_3_focus_aw;
MCNUM focus_ah = mccchannel_7_analyzer_1_array_crystal_array_3_focus_ah;
MCNUM focus_xw = mccchannel_7_analyzer_1_array_crystal_array_3_focus_xw;
MCNUM focus_xh = mccchannel_7_analyzer_1_array_crystal_array_3_focus_xh;
MCNUM focus_r = mccchannel_7_analyzer_1_array_crystal_array_3_focus_r;
MCNUM p_interact = mccchannel_7_analyzer_1_array_crystal_array_3_p_interact;
char* mask_string = mccchannel_7_analyzer_1_array_crystal_array_3_mask_string;
char* mask_setting = mccchannel_7_analyzer_1_array_crystal_array_3_mask_setting;
MCNUM number_of_activations = mccchannel_7_analyzer_1_array_crystal_array_3_number_of_activations;
}   /* End of channel_7_analyzer_1_array_crystal_array_3=Union_box() SETTING parameter declarations. */
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex
  /* Label for restoring  neutron */
  mcabsorbCompchannel_7_analyzer_1_array_crystal_array_3:
  if (RESTORE) /* restore if needed */
  { RESTORE_NEUTRON(399,
      mcnlx,
      mcnly,
      mcnlz,
      mcnlvx,
      mcnlvy,
      mcnlvz,
      mcnlt,
      mcnlsx,
      mcnlsy,
      mcnlsz,
      mcnlp); }
#undef mcabsorbComp
#undef p
#undef sz
#undef sy
#undef sx
#undef t
#undef vz
#undef vy
#undef vx
#undef z
#undef y
#undef x
  mcDEBUG_STATE(
mcnlx,
mcnly,
mcnlz,
mcnlvx,
mcnlvy,
mcnlvz,
mcnlt,
mcnlsx,
mcnlsy,
mcnlsz,
mcnlp)

  /* TRACE Component channel_7_analyzer_1_array_crystal_array_4 [400] */
  mccoordschange(mcposrchannel_7_analyzer_1_array_crystal_array_4, mcrotrchannel_7_analyzer_1_array_crystal_array_4,
    &mcnlx,
    &mcnly,
    &mcnlz,
    &mcnlvx,
    &mcnlvy,
    &mcnlvz,
    &mcnlsx,
    &mcnlsy,
    &mcnlsz);
  /* define label inside component channel_7_analyzer_1_array_crystal_array_4 (without coords transformations) */
  mcJumpTrace_channel_7_analyzer_1_array_crystal_array_4:
  SIG_MESSAGE("channel_7_analyzer_1_array_crystal_array_4 (Trace)");
  mcDEBUG_COMP("channel_7_analyzer_1_array_crystal_array_4")
  mcDEBUG_STATE(
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp)
#define x mcnlx
#define y mcnly
#define z mcnlz
#define vx mcnlvx
#define vy mcnlvy
#define vz mcnlvz
#define t mcnlt
#define sx mcnlsx
#define sy mcnlsy
#define sz mcnlsz
#define p mcnlp

#define mcabsorbComp mcabsorbCompchannel_7_analyzer_1_array_crystal_array_4
  STORE_NEUTRON(400,
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp);
  mcScattered=0;
  mcRestore=0;
  mcNCounter[400]++;
  mcPCounter[400] += p;
  mcP2Counter[400] += p*p;
#define mccompcurname  channel_7_analyzer_1_array_crystal_array_4
#define mccompcurtype  Union_box
#define mccompcurindex 400
#define loop_index mccchannel_7_analyzer_1_array_crystal_array_4_loop_index
#define this_box_volume mccchannel_7_analyzer_1_array_crystal_array_4_this_box_volume
#define global_geometry_element mccchannel_7_analyzer_1_array_crystal_array_4_global_geometry_element
#define this_box_storage mccchannel_7_analyzer_1_array_crystal_array_4_this_box_storage
{   /* Declarations of channel_7_analyzer_1_array_crystal_array_4=Union_box() SETTING parameters. */
char* material_string = mccchannel_7_analyzer_1_array_crystal_array_4_material_string;
MCNUM priority = mccchannel_7_analyzer_1_array_crystal_array_4_priority;
MCNUM xwidth = mccchannel_7_analyzer_1_array_crystal_array_4_xwidth;
MCNUM yheight = mccchannel_7_analyzer_1_array_crystal_array_4_yheight;
MCNUM zdepth = mccchannel_7_analyzer_1_array_crystal_array_4_zdepth;
MCNUM xwidth2 = mccchannel_7_analyzer_1_array_crystal_array_4_xwidth2;
MCNUM yheight2 = mccchannel_7_analyzer_1_array_crystal_array_4_yheight2;
MCNUM visualize = mccchannel_7_analyzer_1_array_crystal_array_4_visualize;
int target_index = mccchannel_7_analyzer_1_array_crystal_array_4_target_index;
MCNUM target_x = mccchannel_7_analyzer_1_array_crystal_array_4_target_x;
MCNUM target_y = mccchannel_7_analyzer_1_array_crystal_array_4_target_y;
MCNUM target_z = mccchannel_7_analyzer_1_array_crystal_array_4_target_z;
MCNUM focus_aw = mccchannel_7_analyzer_1_array_crystal_array_4_focus_aw;
MCNUM focus_ah = mccchannel_7_analyzer_1_array_crystal_array_4_focus_ah;
MCNUM focus_xw = mccchannel_7_analyzer_1_array_crystal_array_4_focus_xw;
MCNUM focus_xh = mccchannel_7_analyzer_1_array_crystal_array_4_focus_xh;
MCNUM focus_r = mccchannel_7_analyzer_1_array_crystal_array_4_focus_r;
MCNUM p_interact = mccchannel_7_analyzer_1_array_crystal_array_4_p_interact;
char* mask_string = mccchannel_7_analyzer_1_array_crystal_array_4_mask_string;
char* mask_setting = mccchannel_7_analyzer_1_array_crystal_array_4_mask_setting;
MCNUM number_of_activations = mccchannel_7_analyzer_1_array_crystal_array_4_number_of_activations;
}   /* End of channel_7_analyzer_1_array_crystal_array_4=Union_box() SETTING parameter declarations. */
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex
  /* Label for restoring  neutron */
  mcabsorbCompchannel_7_analyzer_1_array_crystal_array_4:
  if (RESTORE) /* restore if needed */
  { RESTORE_NEUTRON(400,
      mcnlx,
      mcnly,
      mcnlz,
      mcnlvx,
      mcnlvy,
      mcnlvz,
      mcnlt,
      mcnlsx,
      mcnlsy,
      mcnlsz,
      mcnlp); }
#undef mcabsorbComp
#undef p
#undef sz
#undef sy
#undef sx
#undef t
#undef vz
#undef vy
#undef vx
#undef z
#undef y
#undef x
  mcDEBUG_STATE(
mcnlx,
mcnly,
mcnlz,
mcnlvx,
mcnlvy,
mcnlvz,
mcnlt,
mcnlsx,
mcnlsy,
mcnlsz,
mcnlp)

  /* TRACE Component channel_7_analyzer_1_array_crystal_array_5 [401] */
  mccoordschange(mcposrchannel_7_analyzer_1_array_crystal_array_5, mcrotrchannel_7_analyzer_1_array_crystal_array_5,
    &mcnlx,
    &mcnly,
    &mcnlz,
    &mcnlvx,
    &mcnlvy,
    &mcnlvz,
    &mcnlsx,
    &mcnlsy,
    &mcnlsz);
  /* define label inside component channel_7_analyzer_1_array_crystal_array_5 (without coords transformations) */
  mcJumpTrace_channel_7_analyzer_1_array_crystal_array_5:
  SIG_MESSAGE("channel_7_analyzer_1_array_crystal_array_5 (Trace)");
  mcDEBUG_COMP("channel_7_analyzer_1_array_crystal_array_5")
  mcDEBUG_STATE(
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp)
#define x mcnlx
#define y mcnly
#define z mcnlz
#define vx mcnlvx
#define vy mcnlvy
#define vz mcnlvz
#define t mcnlt
#define sx mcnlsx
#define sy mcnlsy
#define sz mcnlsz
#define p mcnlp

#define mcabsorbComp mcabsorbCompchannel_7_analyzer_1_array_crystal_array_5
  STORE_NEUTRON(401,
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp);
  mcScattered=0;
  mcRestore=0;
  mcNCounter[401]++;
  mcPCounter[401] += p;
  mcP2Counter[401] += p*p;
#define mccompcurname  channel_7_analyzer_1_array_crystal_array_5
#define mccompcurtype  Union_box
#define mccompcurindex 401
#define loop_index mccchannel_7_analyzer_1_array_crystal_array_5_loop_index
#define this_box_volume mccchannel_7_analyzer_1_array_crystal_array_5_this_box_volume
#define global_geometry_element mccchannel_7_analyzer_1_array_crystal_array_5_global_geometry_element
#define this_box_storage mccchannel_7_analyzer_1_array_crystal_array_5_this_box_storage
{   /* Declarations of channel_7_analyzer_1_array_crystal_array_5=Union_box() SETTING parameters. */
char* material_string = mccchannel_7_analyzer_1_array_crystal_array_5_material_string;
MCNUM priority = mccchannel_7_analyzer_1_array_crystal_array_5_priority;
MCNUM xwidth = mccchannel_7_analyzer_1_array_crystal_array_5_xwidth;
MCNUM yheight = mccchannel_7_analyzer_1_array_crystal_array_5_yheight;
MCNUM zdepth = mccchannel_7_analyzer_1_array_crystal_array_5_zdepth;
MCNUM xwidth2 = mccchannel_7_analyzer_1_array_crystal_array_5_xwidth2;
MCNUM yheight2 = mccchannel_7_analyzer_1_array_crystal_array_5_yheight2;
MCNUM visualize = mccchannel_7_analyzer_1_array_crystal_array_5_visualize;
int target_index = mccchannel_7_analyzer_1_array_crystal_array_5_target_index;
MCNUM target_x = mccchannel_7_analyzer_1_array_crystal_array_5_target_x;
MCNUM target_y = mccchannel_7_analyzer_1_array_crystal_array_5_target_y;
MCNUM target_z = mccchannel_7_analyzer_1_array_crystal_array_5_target_z;
MCNUM focus_aw = mccchannel_7_analyzer_1_array_crystal_array_5_focus_aw;
MCNUM focus_ah = mccchannel_7_analyzer_1_array_crystal_array_5_focus_ah;
MCNUM focus_xw = mccchannel_7_analyzer_1_array_crystal_array_5_focus_xw;
MCNUM focus_xh = mccchannel_7_analyzer_1_array_crystal_array_5_focus_xh;
MCNUM focus_r = mccchannel_7_analyzer_1_array_crystal_array_5_focus_r;
MCNUM p_interact = mccchannel_7_analyzer_1_array_crystal_array_5_p_interact;
char* mask_string = mccchannel_7_analyzer_1_array_crystal_array_5_mask_string;
char* mask_setting = mccchannel_7_analyzer_1_array_crystal_array_5_mask_setting;
MCNUM number_of_activations = mccchannel_7_analyzer_1_array_crystal_array_5_number_of_activations;
}   /* End of channel_7_analyzer_1_array_crystal_array_5=Union_box() SETTING parameter declarations. */
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex
  /* Label for restoring  neutron */
  mcabsorbCompchannel_7_analyzer_1_array_crystal_array_5:
  if (RESTORE) /* restore if needed */
  { RESTORE_NEUTRON(401,
      mcnlx,
      mcnly,
      mcnlz,
      mcnlvx,
      mcnlvy,
      mcnlvz,
      mcnlt,
      mcnlsx,
      mcnlsy,
      mcnlsz,
      mcnlp); }
#undef mcabsorbComp
#undef p
#undef sz
#undef sy
#undef sx
#undef t
#undef vz
#undef vy
#undef vx
#undef z
#undef y
#undef x
  mcDEBUG_STATE(
mcnlx,
mcnly,
mcnlz,
mcnlvx,
mcnlvy,
mcnlvz,
mcnlt,
mcnlsx,
mcnlsy,
mcnlsz,
mcnlp)

  /* TRACE Component channel_7_analyzer_1_array_crystal_array_6 [402] */
  mccoordschange(mcposrchannel_7_analyzer_1_array_crystal_array_6, mcrotrchannel_7_analyzer_1_array_crystal_array_6,
    &mcnlx,
    &mcnly,
    &mcnlz,
    &mcnlvx,
    &mcnlvy,
    &mcnlvz,
    &mcnlsx,
    &mcnlsy,
    &mcnlsz);
  /* define label inside component channel_7_analyzer_1_array_crystal_array_6 (without coords transformations) */
  mcJumpTrace_channel_7_analyzer_1_array_crystal_array_6:
  SIG_MESSAGE("channel_7_analyzer_1_array_crystal_array_6 (Trace)");
  mcDEBUG_COMP("channel_7_analyzer_1_array_crystal_array_6")
  mcDEBUG_STATE(
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp)
#define x mcnlx
#define y mcnly
#define z mcnlz
#define vx mcnlvx
#define vy mcnlvy
#define vz mcnlvz
#define t mcnlt
#define sx mcnlsx
#define sy mcnlsy
#define sz mcnlsz
#define p mcnlp

#define mcabsorbComp mcabsorbCompchannel_7_analyzer_1_array_crystal_array_6
  STORE_NEUTRON(402,
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp);
  mcScattered=0;
  mcRestore=0;
  mcNCounter[402]++;
  mcPCounter[402] += p;
  mcP2Counter[402] += p*p;
#define mccompcurname  channel_7_analyzer_1_array_crystal_array_6
#define mccompcurtype  Union_box
#define mccompcurindex 402
#define loop_index mccchannel_7_analyzer_1_array_crystal_array_6_loop_index
#define this_box_volume mccchannel_7_analyzer_1_array_crystal_array_6_this_box_volume
#define global_geometry_element mccchannel_7_analyzer_1_array_crystal_array_6_global_geometry_element
#define this_box_storage mccchannel_7_analyzer_1_array_crystal_array_6_this_box_storage
{   /* Declarations of channel_7_analyzer_1_array_crystal_array_6=Union_box() SETTING parameters. */
char* material_string = mccchannel_7_analyzer_1_array_crystal_array_6_material_string;
MCNUM priority = mccchannel_7_analyzer_1_array_crystal_array_6_priority;
MCNUM xwidth = mccchannel_7_analyzer_1_array_crystal_array_6_xwidth;
MCNUM yheight = mccchannel_7_analyzer_1_array_crystal_array_6_yheight;
MCNUM zdepth = mccchannel_7_analyzer_1_array_crystal_array_6_zdepth;
MCNUM xwidth2 = mccchannel_7_analyzer_1_array_crystal_array_6_xwidth2;
MCNUM yheight2 = mccchannel_7_analyzer_1_array_crystal_array_6_yheight2;
MCNUM visualize = mccchannel_7_analyzer_1_array_crystal_array_6_visualize;
int target_index = mccchannel_7_analyzer_1_array_crystal_array_6_target_index;
MCNUM target_x = mccchannel_7_analyzer_1_array_crystal_array_6_target_x;
MCNUM target_y = mccchannel_7_analyzer_1_array_crystal_array_6_target_y;
MCNUM target_z = mccchannel_7_analyzer_1_array_crystal_array_6_target_z;
MCNUM focus_aw = mccchannel_7_analyzer_1_array_crystal_array_6_focus_aw;
MCNUM focus_ah = mccchannel_7_analyzer_1_array_crystal_array_6_focus_ah;
MCNUM focus_xw = mccchannel_7_analyzer_1_array_crystal_array_6_focus_xw;
MCNUM focus_xh = mccchannel_7_analyzer_1_array_crystal_array_6_focus_xh;
MCNUM focus_r = mccchannel_7_analyzer_1_array_crystal_array_6_focus_r;
MCNUM p_interact = mccchannel_7_analyzer_1_array_crystal_array_6_p_interact;
char* mask_string = mccchannel_7_analyzer_1_array_crystal_array_6_mask_string;
char* mask_setting = mccchannel_7_analyzer_1_array_crystal_array_6_mask_setting;
MCNUM number_of_activations = mccchannel_7_analyzer_1_array_crystal_array_6_number_of_activations;
}   /* End of channel_7_analyzer_1_array_crystal_array_6=Union_box() SETTING parameter declarations. */
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex
  /* Label for restoring  neutron */
  mcabsorbCompchannel_7_analyzer_1_array_crystal_array_6:
  if (RESTORE) /* restore if needed */
  { RESTORE_NEUTRON(402,
      mcnlx,
      mcnly,
      mcnlz,
      mcnlvx,
      mcnlvy,
      mcnlvz,
      mcnlt,
      mcnlsx,
      mcnlsy,
      mcnlsz,
      mcnlp); }
#undef mcabsorbComp
#undef p
#undef sz
#undef sy
#undef sx
#undef t
#undef vz
#undef vy
#undef vx
#undef z
#undef y
#undef x
  mcDEBUG_STATE(
mcnlx,
mcnly,
mcnlz,
mcnlvx,
mcnlvy,
mcnlvz,
mcnlt,
mcnlsx,
mcnlsy,
mcnlsz,
mcnlp)

  /* TRACE Component channel_7_analyzer_1_array_crystal_array_7 [403] */
  mccoordschange(mcposrchannel_7_analyzer_1_array_crystal_array_7, mcrotrchannel_7_analyzer_1_array_crystal_array_7,
    &mcnlx,
    &mcnly,
    &mcnlz,
    &mcnlvx,
    &mcnlvy,
    &mcnlvz,
    &mcnlsx,
    &mcnlsy,
    &mcnlsz);
  /* define label inside component channel_7_analyzer_1_array_crystal_array_7 (without coords transformations) */
  mcJumpTrace_channel_7_analyzer_1_array_crystal_array_7:
  SIG_MESSAGE("channel_7_analyzer_1_array_crystal_array_7 (Trace)");
  mcDEBUG_COMP("channel_7_analyzer_1_array_crystal_array_7")
  mcDEBUG_STATE(
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp)
#define x mcnlx
#define y mcnly
#define z mcnlz
#define vx mcnlvx
#define vy mcnlvy
#define vz mcnlvz
#define t mcnlt
#define sx mcnlsx
#define sy mcnlsy
#define sz mcnlsz
#define p mcnlp

#define mcabsorbComp mcabsorbCompchannel_7_analyzer_1_array_crystal_array_7
  STORE_NEUTRON(403,
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp);
  mcScattered=0;
  mcRestore=0;
  mcNCounter[403]++;
  mcPCounter[403] += p;
  mcP2Counter[403] += p*p;
#define mccompcurname  channel_7_analyzer_1_array_crystal_array_7
#define mccompcurtype  Union_box
#define mccompcurindex 403
#define loop_index mccchannel_7_analyzer_1_array_crystal_array_7_loop_index
#define this_box_volume mccchannel_7_analyzer_1_array_crystal_array_7_this_box_volume
#define global_geometry_element mccchannel_7_analyzer_1_array_crystal_array_7_global_geometry_element
#define this_box_storage mccchannel_7_analyzer_1_array_crystal_array_7_this_box_storage
{   /* Declarations of channel_7_analyzer_1_array_crystal_array_7=Union_box() SETTING parameters. */
char* material_string = mccchannel_7_analyzer_1_array_crystal_array_7_material_string;
MCNUM priority = mccchannel_7_analyzer_1_array_crystal_array_7_priority;
MCNUM xwidth = mccchannel_7_analyzer_1_array_crystal_array_7_xwidth;
MCNUM yheight = mccchannel_7_analyzer_1_array_crystal_array_7_yheight;
MCNUM zdepth = mccchannel_7_analyzer_1_array_crystal_array_7_zdepth;
MCNUM xwidth2 = mccchannel_7_analyzer_1_array_crystal_array_7_xwidth2;
MCNUM yheight2 = mccchannel_7_analyzer_1_array_crystal_array_7_yheight2;
MCNUM visualize = mccchannel_7_analyzer_1_array_crystal_array_7_visualize;
int target_index = mccchannel_7_analyzer_1_array_crystal_array_7_target_index;
MCNUM target_x = mccchannel_7_analyzer_1_array_crystal_array_7_target_x;
MCNUM target_y = mccchannel_7_analyzer_1_array_crystal_array_7_target_y;
MCNUM target_z = mccchannel_7_analyzer_1_array_crystal_array_7_target_z;
MCNUM focus_aw = mccchannel_7_analyzer_1_array_crystal_array_7_focus_aw;
MCNUM focus_ah = mccchannel_7_analyzer_1_array_crystal_array_7_focus_ah;
MCNUM focus_xw = mccchannel_7_analyzer_1_array_crystal_array_7_focus_xw;
MCNUM focus_xh = mccchannel_7_analyzer_1_array_crystal_array_7_focus_xh;
MCNUM focus_r = mccchannel_7_analyzer_1_array_crystal_array_7_focus_r;
MCNUM p_interact = mccchannel_7_analyzer_1_array_crystal_array_7_p_interact;
char* mask_string = mccchannel_7_analyzer_1_array_crystal_array_7_mask_string;
char* mask_setting = mccchannel_7_analyzer_1_array_crystal_array_7_mask_setting;
MCNUM number_of_activations = mccchannel_7_analyzer_1_array_crystal_array_7_number_of_activations;
}   /* End of channel_7_analyzer_1_array_crystal_array_7=Union_box() SETTING parameter declarations. */
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex
  /* Label for restoring  neutron */
  mcabsorbCompchannel_7_analyzer_1_array_crystal_array_7:
  if (RESTORE) /* restore if needed */
  { RESTORE_NEUTRON(403,
      mcnlx,
      mcnly,
      mcnlz,
      mcnlvx,
      mcnlvy,
      mcnlvz,
      mcnlt,
      mcnlsx,
      mcnlsy,
      mcnlsz,
      mcnlp); }
#undef mcabsorbComp
#undef p
#undef sz
#undef sy
#undef sx
#undef t
#undef vz
#undef vy
#undef vx
#undef z
#undef y
#undef x
  mcDEBUG_STATE(
mcnlx,
mcnly,
mcnlz,
mcnlvx,
mcnlvy,
mcnlvz,
mcnlt,
mcnlsx,
mcnlsy,
mcnlsz,
mcnlp)

  /* TRACE Component channel_7_analyzer_1_array_crystal_array_8 [404] */
  mccoordschange(mcposrchannel_7_analyzer_1_array_crystal_array_8, mcrotrchannel_7_analyzer_1_array_crystal_array_8,
    &mcnlx,
    &mcnly,
    &mcnlz,
    &mcnlvx,
    &mcnlvy,
    &mcnlvz,
    &mcnlsx,
    &mcnlsy,
    &mcnlsz);
  /* define label inside component channel_7_analyzer_1_array_crystal_array_8 (without coords transformations) */
  mcJumpTrace_channel_7_analyzer_1_array_crystal_array_8:
  SIG_MESSAGE("channel_7_analyzer_1_array_crystal_array_8 (Trace)");
  mcDEBUG_COMP("channel_7_analyzer_1_array_crystal_array_8")
  mcDEBUG_STATE(
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp)
#define x mcnlx
#define y mcnly
#define z mcnlz
#define vx mcnlvx
#define vy mcnlvy
#define vz mcnlvz
#define t mcnlt
#define sx mcnlsx
#define sy mcnlsy
#define sz mcnlsz
#define p mcnlp

#define mcabsorbComp mcabsorbCompchannel_7_analyzer_1_array_crystal_array_8
  STORE_NEUTRON(404,
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp);
  mcScattered=0;
  mcRestore=0;
  mcNCounter[404]++;
  mcPCounter[404] += p;
  mcP2Counter[404] += p*p;
#define mccompcurname  channel_7_analyzer_1_array_crystal_array_8
#define mccompcurtype  Union_box
#define mccompcurindex 404
#define loop_index mccchannel_7_analyzer_1_array_crystal_array_8_loop_index
#define this_box_volume mccchannel_7_analyzer_1_array_crystal_array_8_this_box_volume
#define global_geometry_element mccchannel_7_analyzer_1_array_crystal_array_8_global_geometry_element
#define this_box_storage mccchannel_7_analyzer_1_array_crystal_array_8_this_box_storage
{   /* Declarations of channel_7_analyzer_1_array_crystal_array_8=Union_box() SETTING parameters. */
char* material_string = mccchannel_7_analyzer_1_array_crystal_array_8_material_string;
MCNUM priority = mccchannel_7_analyzer_1_array_crystal_array_8_priority;
MCNUM xwidth = mccchannel_7_analyzer_1_array_crystal_array_8_xwidth;
MCNUM yheight = mccchannel_7_analyzer_1_array_crystal_array_8_yheight;
MCNUM zdepth = mccchannel_7_analyzer_1_array_crystal_array_8_zdepth;
MCNUM xwidth2 = mccchannel_7_analyzer_1_array_crystal_array_8_xwidth2;
MCNUM yheight2 = mccchannel_7_analyzer_1_array_crystal_array_8_yheight2;
MCNUM visualize = mccchannel_7_analyzer_1_array_crystal_array_8_visualize;
int target_index = mccchannel_7_analyzer_1_array_crystal_array_8_target_index;
MCNUM target_x = mccchannel_7_analyzer_1_array_crystal_array_8_target_x;
MCNUM target_y = mccchannel_7_analyzer_1_array_crystal_array_8_target_y;
MCNUM target_z = mccchannel_7_analyzer_1_array_crystal_array_8_target_z;
MCNUM focus_aw = mccchannel_7_analyzer_1_array_crystal_array_8_focus_aw;
MCNUM focus_ah = mccchannel_7_analyzer_1_array_crystal_array_8_focus_ah;
MCNUM focus_xw = mccchannel_7_analyzer_1_array_crystal_array_8_focus_xw;
MCNUM focus_xh = mccchannel_7_analyzer_1_array_crystal_array_8_focus_xh;
MCNUM focus_r = mccchannel_7_analyzer_1_array_crystal_array_8_focus_r;
MCNUM p_interact = mccchannel_7_analyzer_1_array_crystal_array_8_p_interact;
char* mask_string = mccchannel_7_analyzer_1_array_crystal_array_8_mask_string;
char* mask_setting = mccchannel_7_analyzer_1_array_crystal_array_8_mask_setting;
MCNUM number_of_activations = mccchannel_7_analyzer_1_array_crystal_array_8_number_of_activations;
}   /* End of channel_7_analyzer_1_array_crystal_array_8=Union_box() SETTING parameter declarations. */
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex
  /* Label for restoring  neutron */
  mcabsorbCompchannel_7_analyzer_1_array_crystal_array_8:
  if (RESTORE) /* restore if needed */
  { RESTORE_NEUTRON(404,
      mcnlx,
      mcnly,
      mcnlz,
      mcnlvx,
      mcnlvy,
      mcnlvz,
      mcnlt,
      mcnlsx,
      mcnlsy,
      mcnlsz,
      mcnlp); }
#undef mcabsorbComp
#undef p
#undef sz
#undef sy
#undef sx
#undef t
#undef vz
#undef vy
#undef vx
#undef z
#undef y
#undef x
  mcDEBUG_STATE(
mcnlx,
mcnly,
mcnlz,
mcnlvx,
mcnlvy,
mcnlvz,
mcnlt,
mcnlsx,
mcnlsy,
mcnlsz,
mcnlp)

  /* TRACE Component channel_7_analyzer_2_center [405] */
  mccoordschange(mcposrchannel_7_analyzer_2_center, mcrotrchannel_7_analyzer_2_center,
    &mcnlx,
    &mcnly,
    &mcnlz,
    &mcnlvx,
    &mcnlvy,
    &mcnlvz,
    &mcnlsx,
    &mcnlsy,
    &mcnlsz);
  /* define label inside component channel_7_analyzer_2_center (without coords transformations) */
  mcJumpTrace_channel_7_analyzer_2_center:
  SIG_MESSAGE("channel_7_analyzer_2_center (Trace)");
  mcDEBUG_COMP("channel_7_analyzer_2_center")
  mcDEBUG_STATE(
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp)
#define x mcnlx
#define y mcnly
#define z mcnlz
#define vx mcnlvx
#define vy mcnlvy
#define vz mcnlvz
#define t mcnlt
#define sx mcnlsx
#define sy mcnlsy
#define sz mcnlsz
#define p mcnlp

#define mcabsorbComp mcabsorbCompchannel_7_analyzer_2_center
  STORE_NEUTRON(405,
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp);
  mcScattered=0;
  mcRestore=0;
  mcNCounter[405]++;
  mcPCounter[405] += p;
  mcP2Counter[405] += p*p;
#define mccompcurname  channel_7_analyzer_2_center
#define mccompcurtype  Arm
#define mccompcurindex 405
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex
  /* Label for restoring  neutron */
  mcabsorbCompchannel_7_analyzer_2_center:
  if (RESTORE) /* restore if needed */
  { RESTORE_NEUTRON(405,
      mcnlx,
      mcnly,
      mcnlz,
      mcnlvx,
      mcnlvy,
      mcnlvz,
      mcnlt,
      mcnlsx,
      mcnlsy,
      mcnlsz,
      mcnlp); }
#undef mcabsorbComp
#undef p
#undef sz
#undef sy
#undef sx
#undef t
#undef vz
#undef vy
#undef vx
#undef z
#undef y
#undef x
  mcDEBUG_STATE(
mcnlx,
mcnly,
mcnlz,
mcnlvx,
mcnlvy,
mcnlvz,
mcnlt,
mcnlsx,
mcnlsy,
mcnlsz,
mcnlp)

  /* TRACE Component channel_7_analyzer_2_rotated [406] */
  mccoordschange(mcposrchannel_7_analyzer_2_rotated, mcrotrchannel_7_analyzer_2_rotated,
    &mcnlx,
    &mcnly,
    &mcnlz,
    &mcnlvx,
    &mcnlvy,
    &mcnlvz,
    &mcnlsx,
    &mcnlsy,
    &mcnlsz);
  /* define label inside component channel_7_analyzer_2_rotated (without coords transformations) */
  mcJumpTrace_channel_7_analyzer_2_rotated:
  SIG_MESSAGE("channel_7_analyzer_2_rotated (Trace)");
  mcDEBUG_COMP("channel_7_analyzer_2_rotated")
  mcDEBUG_STATE(
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp)
#define x mcnlx
#define y mcnly
#define z mcnlz
#define vx mcnlvx
#define vy mcnlvy
#define vz mcnlvz
#define t mcnlt
#define sx mcnlsx
#define sy mcnlsy
#define sz mcnlsz
#define p mcnlp

#define mcabsorbComp mcabsorbCompchannel_7_analyzer_2_rotated
  STORE_NEUTRON(406,
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp);
  mcScattered=0;
  mcRestore=0;
  mcNCounter[406]++;
  mcPCounter[406] += p;
  mcP2Counter[406] += p*p;
#define mccompcurname  channel_7_analyzer_2_rotated
#define mccompcurtype  Arm
#define mccompcurindex 406
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex
  /* Label for restoring  neutron */
  mcabsorbCompchannel_7_analyzer_2_rotated:
  if (RESTORE) /* restore if needed */
  { RESTORE_NEUTRON(406,
      mcnlx,
      mcnly,
      mcnlz,
      mcnlvx,
      mcnlvy,
      mcnlvz,
      mcnlt,
      mcnlsx,
      mcnlsy,
      mcnlsz,
      mcnlp); }
#undef mcabsorbComp
#undef p
#undef sz
#undef sy
#undef sx
#undef t
#undef vz
#undef vy
#undef vx
#undef z
#undef y
#undef x
  mcDEBUG_STATE(
mcnlx,
mcnly,
mcnlz,
mcnlvx,
mcnlvy,
mcnlvz,
mcnlt,
mcnlsx,
mcnlsy,
mcnlsz,
mcnlp)

  /* TRACE Component channel_7_analyzer_2_array_crystal_array_0 [407] */
  mccoordschange(mcposrchannel_7_analyzer_2_array_crystal_array_0, mcrotrchannel_7_analyzer_2_array_crystal_array_0,
    &mcnlx,
    &mcnly,
    &mcnlz,
    &mcnlvx,
    &mcnlvy,
    &mcnlvz,
    &mcnlsx,
    &mcnlsy,
    &mcnlsz);
  /* define label inside component channel_7_analyzer_2_array_crystal_array_0 (without coords transformations) */
  mcJumpTrace_channel_7_analyzer_2_array_crystal_array_0:
  SIG_MESSAGE("channel_7_analyzer_2_array_crystal_array_0 (Trace)");
  mcDEBUG_COMP("channel_7_analyzer_2_array_crystal_array_0")
  mcDEBUG_STATE(
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp)
#define x mcnlx
#define y mcnly
#define z mcnlz
#define vx mcnlvx
#define vy mcnlvy
#define vz mcnlvz
#define t mcnlt
#define sx mcnlsx
#define sy mcnlsy
#define sz mcnlsz
#define p mcnlp

#define mcabsorbComp mcabsorbCompchannel_7_analyzer_2_array_crystal_array_0
  STORE_NEUTRON(407,
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp);
  mcScattered=0;
  mcRestore=0;
  mcNCounter[407]++;
  mcPCounter[407] += p;
  mcP2Counter[407] += p*p;
#define mccompcurname  channel_7_analyzer_2_array_crystal_array_0
#define mccompcurtype  Union_box
#define mccompcurindex 407
#define loop_index mccchannel_7_analyzer_2_array_crystal_array_0_loop_index
#define this_box_volume mccchannel_7_analyzer_2_array_crystal_array_0_this_box_volume
#define global_geometry_element mccchannel_7_analyzer_2_array_crystal_array_0_global_geometry_element
#define this_box_storage mccchannel_7_analyzer_2_array_crystal_array_0_this_box_storage
{   /* Declarations of channel_7_analyzer_2_array_crystal_array_0=Union_box() SETTING parameters. */
char* material_string = mccchannel_7_analyzer_2_array_crystal_array_0_material_string;
MCNUM priority = mccchannel_7_analyzer_2_array_crystal_array_0_priority;
MCNUM xwidth = mccchannel_7_analyzer_2_array_crystal_array_0_xwidth;
MCNUM yheight = mccchannel_7_analyzer_2_array_crystal_array_0_yheight;
MCNUM zdepth = mccchannel_7_analyzer_2_array_crystal_array_0_zdepth;
MCNUM xwidth2 = mccchannel_7_analyzer_2_array_crystal_array_0_xwidth2;
MCNUM yheight2 = mccchannel_7_analyzer_2_array_crystal_array_0_yheight2;
MCNUM visualize = mccchannel_7_analyzer_2_array_crystal_array_0_visualize;
int target_index = mccchannel_7_analyzer_2_array_crystal_array_0_target_index;
MCNUM target_x = mccchannel_7_analyzer_2_array_crystal_array_0_target_x;
MCNUM target_y = mccchannel_7_analyzer_2_array_crystal_array_0_target_y;
MCNUM target_z = mccchannel_7_analyzer_2_array_crystal_array_0_target_z;
MCNUM focus_aw = mccchannel_7_analyzer_2_array_crystal_array_0_focus_aw;
MCNUM focus_ah = mccchannel_7_analyzer_2_array_crystal_array_0_focus_ah;
MCNUM focus_xw = mccchannel_7_analyzer_2_array_crystal_array_0_focus_xw;
MCNUM focus_xh = mccchannel_7_analyzer_2_array_crystal_array_0_focus_xh;
MCNUM focus_r = mccchannel_7_analyzer_2_array_crystal_array_0_focus_r;
MCNUM p_interact = mccchannel_7_analyzer_2_array_crystal_array_0_p_interact;
char* mask_string = mccchannel_7_analyzer_2_array_crystal_array_0_mask_string;
char* mask_setting = mccchannel_7_analyzer_2_array_crystal_array_0_mask_setting;
MCNUM number_of_activations = mccchannel_7_analyzer_2_array_crystal_array_0_number_of_activations;
}   /* End of channel_7_analyzer_2_array_crystal_array_0=Union_box() SETTING parameter declarations. */
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex
  /* Label for restoring  neutron */
  mcabsorbCompchannel_7_analyzer_2_array_crystal_array_0:
  if (RESTORE) /* restore if needed */
  { RESTORE_NEUTRON(407,
      mcnlx,
      mcnly,
      mcnlz,
      mcnlvx,
      mcnlvy,
      mcnlvz,
      mcnlt,
      mcnlsx,
      mcnlsy,
      mcnlsz,
      mcnlp); }
#undef mcabsorbComp
#undef p
#undef sz
#undef sy
#undef sx
#undef t
#undef vz
#undef vy
#undef vx
#undef z
#undef y
#undef x
  mcDEBUG_STATE(
mcnlx,
mcnly,
mcnlz,
mcnlvx,
mcnlvy,
mcnlvz,
mcnlt,
mcnlsx,
mcnlsy,
mcnlsz,
mcnlp)

  /* TRACE Component channel_7_analyzer_2_array_crystal_array_1 [408] */
  mccoordschange(mcposrchannel_7_analyzer_2_array_crystal_array_1, mcrotrchannel_7_analyzer_2_array_crystal_array_1,
    &mcnlx,
    &mcnly,
    &mcnlz,
    &mcnlvx,
    &mcnlvy,
    &mcnlvz,
    &mcnlsx,
    &mcnlsy,
    &mcnlsz);
  /* define label inside component channel_7_analyzer_2_array_crystal_array_1 (without coords transformations) */
  mcJumpTrace_channel_7_analyzer_2_array_crystal_array_1:
  SIG_MESSAGE("channel_7_analyzer_2_array_crystal_array_1 (Trace)");
  mcDEBUG_COMP("channel_7_analyzer_2_array_crystal_array_1")
  mcDEBUG_STATE(
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp)
#define x mcnlx
#define y mcnly
#define z mcnlz
#define vx mcnlvx
#define vy mcnlvy
#define vz mcnlvz
#define t mcnlt
#define sx mcnlsx
#define sy mcnlsy
#define sz mcnlsz
#define p mcnlp

#define mcabsorbComp mcabsorbCompchannel_7_analyzer_2_array_crystal_array_1
  STORE_NEUTRON(408,
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp);
  mcScattered=0;
  mcRestore=0;
  mcNCounter[408]++;
  mcPCounter[408] += p;
  mcP2Counter[408] += p*p;
#define mccompcurname  channel_7_analyzer_2_array_crystal_array_1
#define mccompcurtype  Union_box
#define mccompcurindex 408
#define loop_index mccchannel_7_analyzer_2_array_crystal_array_1_loop_index
#define this_box_volume mccchannel_7_analyzer_2_array_crystal_array_1_this_box_volume
#define global_geometry_element mccchannel_7_analyzer_2_array_crystal_array_1_global_geometry_element
#define this_box_storage mccchannel_7_analyzer_2_array_crystal_array_1_this_box_storage
{   /* Declarations of channel_7_analyzer_2_array_crystal_array_1=Union_box() SETTING parameters. */
char* material_string = mccchannel_7_analyzer_2_array_crystal_array_1_material_string;
MCNUM priority = mccchannel_7_analyzer_2_array_crystal_array_1_priority;
MCNUM xwidth = mccchannel_7_analyzer_2_array_crystal_array_1_xwidth;
MCNUM yheight = mccchannel_7_analyzer_2_array_crystal_array_1_yheight;
MCNUM zdepth = mccchannel_7_analyzer_2_array_crystal_array_1_zdepth;
MCNUM xwidth2 = mccchannel_7_analyzer_2_array_crystal_array_1_xwidth2;
MCNUM yheight2 = mccchannel_7_analyzer_2_array_crystal_array_1_yheight2;
MCNUM visualize = mccchannel_7_analyzer_2_array_crystal_array_1_visualize;
int target_index = mccchannel_7_analyzer_2_array_crystal_array_1_target_index;
MCNUM target_x = mccchannel_7_analyzer_2_array_crystal_array_1_target_x;
MCNUM target_y = mccchannel_7_analyzer_2_array_crystal_array_1_target_y;
MCNUM target_z = mccchannel_7_analyzer_2_array_crystal_array_1_target_z;
MCNUM focus_aw = mccchannel_7_analyzer_2_array_crystal_array_1_focus_aw;
MCNUM focus_ah = mccchannel_7_analyzer_2_array_crystal_array_1_focus_ah;
MCNUM focus_xw = mccchannel_7_analyzer_2_array_crystal_array_1_focus_xw;
MCNUM focus_xh = mccchannel_7_analyzer_2_array_crystal_array_1_focus_xh;
MCNUM focus_r = mccchannel_7_analyzer_2_array_crystal_array_1_focus_r;
MCNUM p_interact = mccchannel_7_analyzer_2_array_crystal_array_1_p_interact;
char* mask_string = mccchannel_7_analyzer_2_array_crystal_array_1_mask_string;
char* mask_setting = mccchannel_7_analyzer_2_array_crystal_array_1_mask_setting;
MCNUM number_of_activations = mccchannel_7_analyzer_2_array_crystal_array_1_number_of_activations;
}   /* End of channel_7_analyzer_2_array_crystal_array_1=Union_box() SETTING parameter declarations. */
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex
  /* Label for restoring  neutron */
  mcabsorbCompchannel_7_analyzer_2_array_crystal_array_1:
  if (RESTORE) /* restore if needed */
  { RESTORE_NEUTRON(408,
      mcnlx,
      mcnly,
      mcnlz,
      mcnlvx,
      mcnlvy,
      mcnlvz,
      mcnlt,
      mcnlsx,
      mcnlsy,
      mcnlsz,
      mcnlp); }
#undef mcabsorbComp
#undef p
#undef sz
#undef sy
#undef sx
#undef t
#undef vz
#undef vy
#undef vx
#undef z
#undef y
#undef x
  mcDEBUG_STATE(
mcnlx,
mcnly,
mcnlz,
mcnlvx,
mcnlvy,
mcnlvz,
mcnlt,
mcnlsx,
mcnlsy,
mcnlsz,
mcnlp)

  /* TRACE Component channel_7_analyzer_2_array_crystal_array_2 [409] */
  mccoordschange(mcposrchannel_7_analyzer_2_array_crystal_array_2, mcrotrchannel_7_analyzer_2_array_crystal_array_2,
    &mcnlx,
    &mcnly,
    &mcnlz,
    &mcnlvx,
    &mcnlvy,
    &mcnlvz,
    &mcnlsx,
    &mcnlsy,
    &mcnlsz);
  /* define label inside component channel_7_analyzer_2_array_crystal_array_2 (without coords transformations) */
  mcJumpTrace_channel_7_analyzer_2_array_crystal_array_2:
  SIG_MESSAGE("channel_7_analyzer_2_array_crystal_array_2 (Trace)");
  mcDEBUG_COMP("channel_7_analyzer_2_array_crystal_array_2")
  mcDEBUG_STATE(
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp)
#define x mcnlx
#define y mcnly
#define z mcnlz
#define vx mcnlvx
#define vy mcnlvy
#define vz mcnlvz
#define t mcnlt
#define sx mcnlsx
#define sy mcnlsy
#define sz mcnlsz
#define p mcnlp

#define mcabsorbComp mcabsorbCompchannel_7_analyzer_2_array_crystal_array_2
  STORE_NEUTRON(409,
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp);
  mcScattered=0;
  mcRestore=0;
  mcNCounter[409]++;
  mcPCounter[409] += p;
  mcP2Counter[409] += p*p;
#define mccompcurname  channel_7_analyzer_2_array_crystal_array_2
#define mccompcurtype  Union_box
#define mccompcurindex 409
#define loop_index mccchannel_7_analyzer_2_array_crystal_array_2_loop_index
#define this_box_volume mccchannel_7_analyzer_2_array_crystal_array_2_this_box_volume
#define global_geometry_element mccchannel_7_analyzer_2_array_crystal_array_2_global_geometry_element
#define this_box_storage mccchannel_7_analyzer_2_array_crystal_array_2_this_box_storage
{   /* Declarations of channel_7_analyzer_2_array_crystal_array_2=Union_box() SETTING parameters. */
char* material_string = mccchannel_7_analyzer_2_array_crystal_array_2_material_string;
MCNUM priority = mccchannel_7_analyzer_2_array_crystal_array_2_priority;
MCNUM xwidth = mccchannel_7_analyzer_2_array_crystal_array_2_xwidth;
MCNUM yheight = mccchannel_7_analyzer_2_array_crystal_array_2_yheight;
MCNUM zdepth = mccchannel_7_analyzer_2_array_crystal_array_2_zdepth;
MCNUM xwidth2 = mccchannel_7_analyzer_2_array_crystal_array_2_xwidth2;
MCNUM yheight2 = mccchannel_7_analyzer_2_array_crystal_array_2_yheight2;
MCNUM visualize = mccchannel_7_analyzer_2_array_crystal_array_2_visualize;
int target_index = mccchannel_7_analyzer_2_array_crystal_array_2_target_index;
MCNUM target_x = mccchannel_7_analyzer_2_array_crystal_array_2_target_x;
MCNUM target_y = mccchannel_7_analyzer_2_array_crystal_array_2_target_y;
MCNUM target_z = mccchannel_7_analyzer_2_array_crystal_array_2_target_z;
MCNUM focus_aw = mccchannel_7_analyzer_2_array_crystal_array_2_focus_aw;
MCNUM focus_ah = mccchannel_7_analyzer_2_array_crystal_array_2_focus_ah;
MCNUM focus_xw = mccchannel_7_analyzer_2_array_crystal_array_2_focus_xw;
MCNUM focus_xh = mccchannel_7_analyzer_2_array_crystal_array_2_focus_xh;
MCNUM focus_r = mccchannel_7_analyzer_2_array_crystal_array_2_focus_r;
MCNUM p_interact = mccchannel_7_analyzer_2_array_crystal_array_2_p_interact;
char* mask_string = mccchannel_7_analyzer_2_array_crystal_array_2_mask_string;
char* mask_setting = mccchannel_7_analyzer_2_array_crystal_array_2_mask_setting;
MCNUM number_of_activations = mccchannel_7_analyzer_2_array_crystal_array_2_number_of_activations;
}   /* End of channel_7_analyzer_2_array_crystal_array_2=Union_box() SETTING parameter declarations. */
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex
  /* Label for restoring  neutron */
  mcabsorbCompchannel_7_analyzer_2_array_crystal_array_2:
  if (RESTORE) /* restore if needed */
  { RESTORE_NEUTRON(409,
      mcnlx,
      mcnly,
      mcnlz,
      mcnlvx,
      mcnlvy,
      mcnlvz,
      mcnlt,
      mcnlsx,
      mcnlsy,
      mcnlsz,
      mcnlp); }
#undef mcabsorbComp
#undef p
#undef sz
#undef sy
#undef sx
#undef t
#undef vz
#undef vy
#undef vx
#undef z
#undef y
#undef x
  mcDEBUG_STATE(
mcnlx,
mcnly,
mcnlz,
mcnlvx,
mcnlvy,
mcnlvz,
mcnlt,
mcnlsx,
mcnlsy,
mcnlsz,
mcnlp)

  /* TRACE Component channel_7_analyzer_2_array_crystal_array_3 [410] */
  mccoordschange(mcposrchannel_7_analyzer_2_array_crystal_array_3, mcrotrchannel_7_analyzer_2_array_crystal_array_3,
    &mcnlx,
    &mcnly,
    &mcnlz,
    &mcnlvx,
    &mcnlvy,
    &mcnlvz,
    &mcnlsx,
    &mcnlsy,
    &mcnlsz);
  /* define label inside component channel_7_analyzer_2_array_crystal_array_3 (without coords transformations) */
  mcJumpTrace_channel_7_analyzer_2_array_crystal_array_3:
  SIG_MESSAGE("channel_7_analyzer_2_array_crystal_array_3 (Trace)");
  mcDEBUG_COMP("channel_7_analyzer_2_array_crystal_array_3")
  mcDEBUG_STATE(
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp)
#define x mcnlx
#define y mcnly
#define z mcnlz
#define vx mcnlvx
#define vy mcnlvy
#define vz mcnlvz
#define t mcnlt
#define sx mcnlsx
#define sy mcnlsy
#define sz mcnlsz
#define p mcnlp

#define mcabsorbComp mcabsorbCompchannel_7_analyzer_2_array_crystal_array_3
  STORE_NEUTRON(410,
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp);
  mcScattered=0;
  mcRestore=0;
  mcNCounter[410]++;
  mcPCounter[410] += p;
  mcP2Counter[410] += p*p;
#define mccompcurname  channel_7_analyzer_2_array_crystal_array_3
#define mccompcurtype  Union_box
#define mccompcurindex 410
#define loop_index mccchannel_7_analyzer_2_array_crystal_array_3_loop_index
#define this_box_volume mccchannel_7_analyzer_2_array_crystal_array_3_this_box_volume
#define global_geometry_element mccchannel_7_analyzer_2_array_crystal_array_3_global_geometry_element
#define this_box_storage mccchannel_7_analyzer_2_array_crystal_array_3_this_box_storage
{   /* Declarations of channel_7_analyzer_2_array_crystal_array_3=Union_box() SETTING parameters. */
char* material_string = mccchannel_7_analyzer_2_array_crystal_array_3_material_string;
MCNUM priority = mccchannel_7_analyzer_2_array_crystal_array_3_priority;
MCNUM xwidth = mccchannel_7_analyzer_2_array_crystal_array_3_xwidth;
MCNUM yheight = mccchannel_7_analyzer_2_array_crystal_array_3_yheight;
MCNUM zdepth = mccchannel_7_analyzer_2_array_crystal_array_3_zdepth;
MCNUM xwidth2 = mccchannel_7_analyzer_2_array_crystal_array_3_xwidth2;
MCNUM yheight2 = mccchannel_7_analyzer_2_array_crystal_array_3_yheight2;
MCNUM visualize = mccchannel_7_analyzer_2_array_crystal_array_3_visualize;
int target_index = mccchannel_7_analyzer_2_array_crystal_array_3_target_index;
MCNUM target_x = mccchannel_7_analyzer_2_array_crystal_array_3_target_x;
MCNUM target_y = mccchannel_7_analyzer_2_array_crystal_array_3_target_y;
MCNUM target_z = mccchannel_7_analyzer_2_array_crystal_array_3_target_z;
MCNUM focus_aw = mccchannel_7_analyzer_2_array_crystal_array_3_focus_aw;
MCNUM focus_ah = mccchannel_7_analyzer_2_array_crystal_array_3_focus_ah;
MCNUM focus_xw = mccchannel_7_analyzer_2_array_crystal_array_3_focus_xw;
MCNUM focus_xh = mccchannel_7_analyzer_2_array_crystal_array_3_focus_xh;
MCNUM focus_r = mccchannel_7_analyzer_2_array_crystal_array_3_focus_r;
MCNUM p_interact = mccchannel_7_analyzer_2_array_crystal_array_3_p_interact;
char* mask_string = mccchannel_7_analyzer_2_array_crystal_array_3_mask_string;
char* mask_setting = mccchannel_7_analyzer_2_array_crystal_array_3_mask_setting;
MCNUM number_of_activations = mccchannel_7_analyzer_2_array_crystal_array_3_number_of_activations;
}   /* End of channel_7_analyzer_2_array_crystal_array_3=Union_box() SETTING parameter declarations. */
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex
  /* Label for restoring  neutron */
  mcabsorbCompchannel_7_analyzer_2_array_crystal_array_3:
  if (RESTORE) /* restore if needed */
  { RESTORE_NEUTRON(410,
      mcnlx,
      mcnly,
      mcnlz,
      mcnlvx,
      mcnlvy,
      mcnlvz,
      mcnlt,
      mcnlsx,
      mcnlsy,
      mcnlsz,
      mcnlp); }
#undef mcabsorbComp
#undef p
#undef sz
#undef sy
#undef sx
#undef t
#undef vz
#undef vy
#undef vx
#undef z
#undef y
#undef x
  mcDEBUG_STATE(
mcnlx,
mcnly,
mcnlz,
mcnlvx,
mcnlvy,
mcnlvz,
mcnlt,
mcnlsx,
mcnlsy,
mcnlsz,
mcnlp)

  /* TRACE Component channel_7_analyzer_2_array_crystal_array_4 [411] */
  mccoordschange(mcposrchannel_7_analyzer_2_array_crystal_array_4, mcrotrchannel_7_analyzer_2_array_crystal_array_4,
    &mcnlx,
    &mcnly,
    &mcnlz,
    &mcnlvx,
    &mcnlvy,
    &mcnlvz,
    &mcnlsx,
    &mcnlsy,
    &mcnlsz);
  /* define label inside component channel_7_analyzer_2_array_crystal_array_4 (without coords transformations) */
  mcJumpTrace_channel_7_analyzer_2_array_crystal_array_4:
  SIG_MESSAGE("channel_7_analyzer_2_array_crystal_array_4 (Trace)");
  mcDEBUG_COMP("channel_7_analyzer_2_array_crystal_array_4")
  mcDEBUG_STATE(
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp)
#define x mcnlx
#define y mcnly
#define z mcnlz
#define vx mcnlvx
#define vy mcnlvy
#define vz mcnlvz
#define t mcnlt
#define sx mcnlsx
#define sy mcnlsy
#define sz mcnlsz
#define p mcnlp

#define mcabsorbComp mcabsorbCompchannel_7_analyzer_2_array_crystal_array_4
  STORE_NEUTRON(411,
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp);
  mcScattered=0;
  mcRestore=0;
  mcNCounter[411]++;
  mcPCounter[411] += p;
  mcP2Counter[411] += p*p;
#define mccompcurname  channel_7_analyzer_2_array_crystal_array_4
#define mccompcurtype  Union_box
#define mccompcurindex 411
#define loop_index mccchannel_7_analyzer_2_array_crystal_array_4_loop_index
#define this_box_volume mccchannel_7_analyzer_2_array_crystal_array_4_this_box_volume
#define global_geometry_element mccchannel_7_analyzer_2_array_crystal_array_4_global_geometry_element
#define this_box_storage mccchannel_7_analyzer_2_array_crystal_array_4_this_box_storage
{   /* Declarations of channel_7_analyzer_2_array_crystal_array_4=Union_box() SETTING parameters. */
char* material_string = mccchannel_7_analyzer_2_array_crystal_array_4_material_string;
MCNUM priority = mccchannel_7_analyzer_2_array_crystal_array_4_priority;
MCNUM xwidth = mccchannel_7_analyzer_2_array_crystal_array_4_xwidth;
MCNUM yheight = mccchannel_7_analyzer_2_array_crystal_array_4_yheight;
MCNUM zdepth = mccchannel_7_analyzer_2_array_crystal_array_4_zdepth;
MCNUM xwidth2 = mccchannel_7_analyzer_2_array_crystal_array_4_xwidth2;
MCNUM yheight2 = mccchannel_7_analyzer_2_array_crystal_array_4_yheight2;
MCNUM visualize = mccchannel_7_analyzer_2_array_crystal_array_4_visualize;
int target_index = mccchannel_7_analyzer_2_array_crystal_array_4_target_index;
MCNUM target_x = mccchannel_7_analyzer_2_array_crystal_array_4_target_x;
MCNUM target_y = mccchannel_7_analyzer_2_array_crystal_array_4_target_y;
MCNUM target_z = mccchannel_7_analyzer_2_array_crystal_array_4_target_z;
MCNUM focus_aw = mccchannel_7_analyzer_2_array_crystal_array_4_focus_aw;
MCNUM focus_ah = mccchannel_7_analyzer_2_array_crystal_array_4_focus_ah;
MCNUM focus_xw = mccchannel_7_analyzer_2_array_crystal_array_4_focus_xw;
MCNUM focus_xh = mccchannel_7_analyzer_2_array_crystal_array_4_focus_xh;
MCNUM focus_r = mccchannel_7_analyzer_2_array_crystal_array_4_focus_r;
MCNUM p_interact = mccchannel_7_analyzer_2_array_crystal_array_4_p_interact;
char* mask_string = mccchannel_7_analyzer_2_array_crystal_array_4_mask_string;
char* mask_setting = mccchannel_7_analyzer_2_array_crystal_array_4_mask_setting;
MCNUM number_of_activations = mccchannel_7_analyzer_2_array_crystal_array_4_number_of_activations;
}   /* End of channel_7_analyzer_2_array_crystal_array_4=Union_box() SETTING parameter declarations. */
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex
  /* Label for restoring  neutron */
  mcabsorbCompchannel_7_analyzer_2_array_crystal_array_4:
  if (RESTORE) /* restore if needed */
  { RESTORE_NEUTRON(411,
      mcnlx,
      mcnly,
      mcnlz,
      mcnlvx,
      mcnlvy,
      mcnlvz,
      mcnlt,
      mcnlsx,
      mcnlsy,
      mcnlsz,
      mcnlp); }
#undef mcabsorbComp
#undef p
#undef sz
#undef sy
#undef sx
#undef t
#undef vz
#undef vy
#undef vx
#undef z
#undef y
#undef x
  mcDEBUG_STATE(
mcnlx,
mcnly,
mcnlz,
mcnlvx,
mcnlvy,
mcnlvz,
mcnlt,
mcnlsx,
mcnlsy,
mcnlsz,
mcnlp)

  /* TRACE Component channel_7_analyzer_2_array_crystal_array_5 [412] */
  mccoordschange(mcposrchannel_7_analyzer_2_array_crystal_array_5, mcrotrchannel_7_analyzer_2_array_crystal_array_5,
    &mcnlx,
    &mcnly,
    &mcnlz,
    &mcnlvx,
    &mcnlvy,
    &mcnlvz,
    &mcnlsx,
    &mcnlsy,
    &mcnlsz);
  /* define label inside component channel_7_analyzer_2_array_crystal_array_5 (without coords transformations) */
  mcJumpTrace_channel_7_analyzer_2_array_crystal_array_5:
  SIG_MESSAGE("channel_7_analyzer_2_array_crystal_array_5 (Trace)");
  mcDEBUG_COMP("channel_7_analyzer_2_array_crystal_array_5")
  mcDEBUG_STATE(
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp)
#define x mcnlx
#define y mcnly
#define z mcnlz
#define vx mcnlvx
#define vy mcnlvy
#define vz mcnlvz
#define t mcnlt
#define sx mcnlsx
#define sy mcnlsy
#define sz mcnlsz
#define p mcnlp

#define mcabsorbComp mcabsorbCompchannel_7_analyzer_2_array_crystal_array_5
  STORE_NEUTRON(412,
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp);
  mcScattered=0;
  mcRestore=0;
  mcNCounter[412]++;
  mcPCounter[412] += p;
  mcP2Counter[412] += p*p;
#define mccompcurname  channel_7_analyzer_2_array_crystal_array_5
#define mccompcurtype  Union_box
#define mccompcurindex 412
#define loop_index mccchannel_7_analyzer_2_array_crystal_array_5_loop_index
#define this_box_volume mccchannel_7_analyzer_2_array_crystal_array_5_this_box_volume
#define global_geometry_element mccchannel_7_analyzer_2_array_crystal_array_5_global_geometry_element
#define this_box_storage mccchannel_7_analyzer_2_array_crystal_array_5_this_box_storage
{   /* Declarations of channel_7_analyzer_2_array_crystal_array_5=Union_box() SETTING parameters. */
char* material_string = mccchannel_7_analyzer_2_array_crystal_array_5_material_string;
MCNUM priority = mccchannel_7_analyzer_2_array_crystal_array_5_priority;
MCNUM xwidth = mccchannel_7_analyzer_2_array_crystal_array_5_xwidth;
MCNUM yheight = mccchannel_7_analyzer_2_array_crystal_array_5_yheight;
MCNUM zdepth = mccchannel_7_analyzer_2_array_crystal_array_5_zdepth;
MCNUM xwidth2 = mccchannel_7_analyzer_2_array_crystal_array_5_xwidth2;
MCNUM yheight2 = mccchannel_7_analyzer_2_array_crystal_array_5_yheight2;
MCNUM visualize = mccchannel_7_analyzer_2_array_crystal_array_5_visualize;
int target_index = mccchannel_7_analyzer_2_array_crystal_array_5_target_index;
MCNUM target_x = mccchannel_7_analyzer_2_array_crystal_array_5_target_x;
MCNUM target_y = mccchannel_7_analyzer_2_array_crystal_array_5_target_y;
MCNUM target_z = mccchannel_7_analyzer_2_array_crystal_array_5_target_z;
MCNUM focus_aw = mccchannel_7_analyzer_2_array_crystal_array_5_focus_aw;
MCNUM focus_ah = mccchannel_7_analyzer_2_array_crystal_array_5_focus_ah;
MCNUM focus_xw = mccchannel_7_analyzer_2_array_crystal_array_5_focus_xw;
MCNUM focus_xh = mccchannel_7_analyzer_2_array_crystal_array_5_focus_xh;
MCNUM focus_r = mccchannel_7_analyzer_2_array_crystal_array_5_focus_r;
MCNUM p_interact = mccchannel_7_analyzer_2_array_crystal_array_5_p_interact;
char* mask_string = mccchannel_7_analyzer_2_array_crystal_array_5_mask_string;
char* mask_setting = mccchannel_7_analyzer_2_array_crystal_array_5_mask_setting;
MCNUM number_of_activations = mccchannel_7_analyzer_2_array_crystal_array_5_number_of_activations;
}   /* End of channel_7_analyzer_2_array_crystal_array_5=Union_box() SETTING parameter declarations. */
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex
  /* Label for restoring  neutron */
  mcabsorbCompchannel_7_analyzer_2_array_crystal_array_5:
  if (RESTORE) /* restore if needed */
  { RESTORE_NEUTRON(412,
      mcnlx,
      mcnly,
      mcnlz,
      mcnlvx,
      mcnlvy,
      mcnlvz,
      mcnlt,
      mcnlsx,
      mcnlsy,
      mcnlsz,
      mcnlp); }
#undef mcabsorbComp
#undef p
#undef sz
#undef sy
#undef sx
#undef t
#undef vz
#undef vy
#undef vx
#undef z
#undef y
#undef x
  mcDEBUG_STATE(
mcnlx,
mcnly,
mcnlz,
mcnlvx,
mcnlvy,
mcnlvz,
mcnlt,
mcnlsx,
mcnlsy,
mcnlsz,
mcnlp)

  /* TRACE Component channel_7_analyzer_2_array_crystal_array_6 [413] */
  mccoordschange(mcposrchannel_7_analyzer_2_array_crystal_array_6, mcrotrchannel_7_analyzer_2_array_crystal_array_6,
    &mcnlx,
    &mcnly,
    &mcnlz,
    &mcnlvx,
    &mcnlvy,
    &mcnlvz,
    &mcnlsx,
    &mcnlsy,
    &mcnlsz);
  /* define label inside component channel_7_analyzer_2_array_crystal_array_6 (without coords transformations) */
  mcJumpTrace_channel_7_analyzer_2_array_crystal_array_6:
  SIG_MESSAGE("channel_7_analyzer_2_array_crystal_array_6 (Trace)");
  mcDEBUG_COMP("channel_7_analyzer_2_array_crystal_array_6")
  mcDEBUG_STATE(
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp)
#define x mcnlx
#define y mcnly
#define z mcnlz
#define vx mcnlvx
#define vy mcnlvy
#define vz mcnlvz
#define t mcnlt
#define sx mcnlsx
#define sy mcnlsy
#define sz mcnlsz
#define p mcnlp

#define mcabsorbComp mcabsorbCompchannel_7_analyzer_2_array_crystal_array_6
  STORE_NEUTRON(413,
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp);
  mcScattered=0;
  mcRestore=0;
  mcNCounter[413]++;
  mcPCounter[413] += p;
  mcP2Counter[413] += p*p;
#define mccompcurname  channel_7_analyzer_2_array_crystal_array_6
#define mccompcurtype  Union_box
#define mccompcurindex 413
#define loop_index mccchannel_7_analyzer_2_array_crystal_array_6_loop_index
#define this_box_volume mccchannel_7_analyzer_2_array_crystal_array_6_this_box_volume
#define global_geometry_element mccchannel_7_analyzer_2_array_crystal_array_6_global_geometry_element
#define this_box_storage mccchannel_7_analyzer_2_array_crystal_array_6_this_box_storage
{   /* Declarations of channel_7_analyzer_2_array_crystal_array_6=Union_box() SETTING parameters. */
char* material_string = mccchannel_7_analyzer_2_array_crystal_array_6_material_string;
MCNUM priority = mccchannel_7_analyzer_2_array_crystal_array_6_priority;
MCNUM xwidth = mccchannel_7_analyzer_2_array_crystal_array_6_xwidth;
MCNUM yheight = mccchannel_7_analyzer_2_array_crystal_array_6_yheight;
MCNUM zdepth = mccchannel_7_analyzer_2_array_crystal_array_6_zdepth;
MCNUM xwidth2 = mccchannel_7_analyzer_2_array_crystal_array_6_xwidth2;
MCNUM yheight2 = mccchannel_7_analyzer_2_array_crystal_array_6_yheight2;
MCNUM visualize = mccchannel_7_analyzer_2_array_crystal_array_6_visualize;
int target_index = mccchannel_7_analyzer_2_array_crystal_array_6_target_index;
MCNUM target_x = mccchannel_7_analyzer_2_array_crystal_array_6_target_x;
MCNUM target_y = mccchannel_7_analyzer_2_array_crystal_array_6_target_y;
MCNUM target_z = mccchannel_7_analyzer_2_array_crystal_array_6_target_z;
MCNUM focus_aw = mccchannel_7_analyzer_2_array_crystal_array_6_focus_aw;
MCNUM focus_ah = mccchannel_7_analyzer_2_array_crystal_array_6_focus_ah;
MCNUM focus_xw = mccchannel_7_analyzer_2_array_crystal_array_6_focus_xw;
MCNUM focus_xh = mccchannel_7_analyzer_2_array_crystal_array_6_focus_xh;
MCNUM focus_r = mccchannel_7_analyzer_2_array_crystal_array_6_focus_r;
MCNUM p_interact = mccchannel_7_analyzer_2_array_crystal_array_6_p_interact;
char* mask_string = mccchannel_7_analyzer_2_array_crystal_array_6_mask_string;
char* mask_setting = mccchannel_7_analyzer_2_array_crystal_array_6_mask_setting;
MCNUM number_of_activations = mccchannel_7_analyzer_2_array_crystal_array_6_number_of_activations;
}   /* End of channel_7_analyzer_2_array_crystal_array_6=Union_box() SETTING parameter declarations. */
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex
  /* Label for restoring  neutron */
  mcabsorbCompchannel_7_analyzer_2_array_crystal_array_6:
  if (RESTORE) /* restore if needed */
  { RESTORE_NEUTRON(413,
      mcnlx,
      mcnly,
      mcnlz,
      mcnlvx,
      mcnlvy,
      mcnlvz,
      mcnlt,
      mcnlsx,
      mcnlsy,
      mcnlsz,
      mcnlp); }
#undef mcabsorbComp
#undef p
#undef sz
#undef sy
#undef sx
#undef t
#undef vz
#undef vy
#undef vx
#undef z
#undef y
#undef x
  mcDEBUG_STATE(
mcnlx,
mcnly,
mcnlz,
mcnlvx,
mcnlvy,
mcnlvz,
mcnlt,
mcnlsx,
mcnlsy,
mcnlsz,
mcnlp)

  /* TRACE Component channel_7_analyzer_2_array_crystal_array_7 [414] */
  mccoordschange(mcposrchannel_7_analyzer_2_array_crystal_array_7, mcrotrchannel_7_analyzer_2_array_crystal_array_7,
    &mcnlx,
    &mcnly,
    &mcnlz,
    &mcnlvx,
    &mcnlvy,
    &mcnlvz,
    &mcnlsx,
    &mcnlsy,
    &mcnlsz);
  /* define label inside component channel_7_analyzer_2_array_crystal_array_7 (without coords transformations) */
  mcJumpTrace_channel_7_analyzer_2_array_crystal_array_7:
  SIG_MESSAGE("channel_7_analyzer_2_array_crystal_array_7 (Trace)");
  mcDEBUG_COMP("channel_7_analyzer_2_array_crystal_array_7")
  mcDEBUG_STATE(
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp)
#define x mcnlx
#define y mcnly
#define z mcnlz
#define vx mcnlvx
#define vy mcnlvy
#define vz mcnlvz
#define t mcnlt
#define sx mcnlsx
#define sy mcnlsy
#define sz mcnlsz
#define p mcnlp

#define mcabsorbComp mcabsorbCompchannel_7_analyzer_2_array_crystal_array_7
  STORE_NEUTRON(414,
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp);
  mcScattered=0;
  mcRestore=0;
  mcNCounter[414]++;
  mcPCounter[414] += p;
  mcP2Counter[414] += p*p;
#define mccompcurname  channel_7_analyzer_2_array_crystal_array_7
#define mccompcurtype  Union_box
#define mccompcurindex 414
#define loop_index mccchannel_7_analyzer_2_array_crystal_array_7_loop_index
#define this_box_volume mccchannel_7_analyzer_2_array_crystal_array_7_this_box_volume
#define global_geometry_element mccchannel_7_analyzer_2_array_crystal_array_7_global_geometry_element
#define this_box_storage mccchannel_7_analyzer_2_array_crystal_array_7_this_box_storage
{   /* Declarations of channel_7_analyzer_2_array_crystal_array_7=Union_box() SETTING parameters. */
char* material_string = mccchannel_7_analyzer_2_array_crystal_array_7_material_string;
MCNUM priority = mccchannel_7_analyzer_2_array_crystal_array_7_priority;
MCNUM xwidth = mccchannel_7_analyzer_2_array_crystal_array_7_xwidth;
MCNUM yheight = mccchannel_7_analyzer_2_array_crystal_array_7_yheight;
MCNUM zdepth = mccchannel_7_analyzer_2_array_crystal_array_7_zdepth;
MCNUM xwidth2 = mccchannel_7_analyzer_2_array_crystal_array_7_xwidth2;
MCNUM yheight2 = mccchannel_7_analyzer_2_array_crystal_array_7_yheight2;
MCNUM visualize = mccchannel_7_analyzer_2_array_crystal_array_7_visualize;
int target_index = mccchannel_7_analyzer_2_array_crystal_array_7_target_index;
MCNUM target_x = mccchannel_7_analyzer_2_array_crystal_array_7_target_x;
MCNUM target_y = mccchannel_7_analyzer_2_array_crystal_array_7_target_y;
MCNUM target_z = mccchannel_7_analyzer_2_array_crystal_array_7_target_z;
MCNUM focus_aw = mccchannel_7_analyzer_2_array_crystal_array_7_focus_aw;
MCNUM focus_ah = mccchannel_7_analyzer_2_array_crystal_array_7_focus_ah;
MCNUM focus_xw = mccchannel_7_analyzer_2_array_crystal_array_7_focus_xw;
MCNUM focus_xh = mccchannel_7_analyzer_2_array_crystal_array_7_focus_xh;
MCNUM focus_r = mccchannel_7_analyzer_2_array_crystal_array_7_focus_r;
MCNUM p_interact = mccchannel_7_analyzer_2_array_crystal_array_7_p_interact;
char* mask_string = mccchannel_7_analyzer_2_array_crystal_array_7_mask_string;
char* mask_setting = mccchannel_7_analyzer_2_array_crystal_array_7_mask_setting;
MCNUM number_of_activations = mccchannel_7_analyzer_2_array_crystal_array_7_number_of_activations;
}   /* End of channel_7_analyzer_2_array_crystal_array_7=Union_box() SETTING parameter declarations. */
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex
  /* Label for restoring  neutron */
  mcabsorbCompchannel_7_analyzer_2_array_crystal_array_7:
  if (RESTORE) /* restore if needed */
  { RESTORE_NEUTRON(414,
      mcnlx,
      mcnly,
      mcnlz,
      mcnlvx,
      mcnlvy,
      mcnlvz,
      mcnlt,
      mcnlsx,
      mcnlsy,
      mcnlsz,
      mcnlp); }
#undef mcabsorbComp
#undef p
#undef sz
#undef sy
#undef sx
#undef t
#undef vz
#undef vy
#undef vx
#undef z
#undef y
#undef x
  mcDEBUG_STATE(
mcnlx,
mcnly,
mcnlz,
mcnlvx,
mcnlvy,
mcnlvz,
mcnlt,
mcnlsx,
mcnlsy,
mcnlsz,
mcnlp)

  /* TRACE Component channel_7_analyzer_2_array_crystal_array_8 [415] */
  mccoordschange(mcposrchannel_7_analyzer_2_array_crystal_array_8, mcrotrchannel_7_analyzer_2_array_crystal_array_8,
    &mcnlx,
    &mcnly,
    &mcnlz,
    &mcnlvx,
    &mcnlvy,
    &mcnlvz,
    &mcnlsx,
    &mcnlsy,
    &mcnlsz);
  /* define label inside component channel_7_analyzer_2_array_crystal_array_8 (without coords transformations) */
  mcJumpTrace_channel_7_analyzer_2_array_crystal_array_8:
  SIG_MESSAGE("channel_7_analyzer_2_array_crystal_array_8 (Trace)");
  mcDEBUG_COMP("channel_7_analyzer_2_array_crystal_array_8")
  mcDEBUG_STATE(
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp)
#define x mcnlx
#define y mcnly
#define z mcnlz
#define vx mcnlvx
#define vy mcnlvy
#define vz mcnlvz
#define t mcnlt
#define sx mcnlsx
#define sy mcnlsy
#define sz mcnlsz
#define p mcnlp

#define mcabsorbComp mcabsorbCompchannel_7_analyzer_2_array_crystal_array_8
  STORE_NEUTRON(415,
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp);
  mcScattered=0;
  mcRestore=0;
  mcNCounter[415]++;
  mcPCounter[415] += p;
  mcP2Counter[415] += p*p;
#define mccompcurname  channel_7_analyzer_2_array_crystal_array_8
#define mccompcurtype  Union_box
#define mccompcurindex 415
#define loop_index mccchannel_7_analyzer_2_array_crystal_array_8_loop_index
#define this_box_volume mccchannel_7_analyzer_2_array_crystal_array_8_this_box_volume
#define global_geometry_element mccchannel_7_analyzer_2_array_crystal_array_8_global_geometry_element
#define this_box_storage mccchannel_7_analyzer_2_array_crystal_array_8_this_box_storage
{   /* Declarations of channel_7_analyzer_2_array_crystal_array_8=Union_box() SETTING parameters. */
char* material_string = mccchannel_7_analyzer_2_array_crystal_array_8_material_string;
MCNUM priority = mccchannel_7_analyzer_2_array_crystal_array_8_priority;
MCNUM xwidth = mccchannel_7_analyzer_2_array_crystal_array_8_xwidth;
MCNUM yheight = mccchannel_7_analyzer_2_array_crystal_array_8_yheight;
MCNUM zdepth = mccchannel_7_analyzer_2_array_crystal_array_8_zdepth;
MCNUM xwidth2 = mccchannel_7_analyzer_2_array_crystal_array_8_xwidth2;
MCNUM yheight2 = mccchannel_7_analyzer_2_array_crystal_array_8_yheight2;
MCNUM visualize = mccchannel_7_analyzer_2_array_crystal_array_8_visualize;
int target_index = mccchannel_7_analyzer_2_array_crystal_array_8_target_index;
MCNUM target_x = mccchannel_7_analyzer_2_array_crystal_array_8_target_x;
MCNUM target_y = mccchannel_7_analyzer_2_array_crystal_array_8_target_y;
MCNUM target_z = mccchannel_7_analyzer_2_array_crystal_array_8_target_z;
MCNUM focus_aw = mccchannel_7_analyzer_2_array_crystal_array_8_focus_aw;
MCNUM focus_ah = mccchannel_7_analyzer_2_array_crystal_array_8_focus_ah;
MCNUM focus_xw = mccchannel_7_analyzer_2_array_crystal_array_8_focus_xw;
MCNUM focus_xh = mccchannel_7_analyzer_2_array_crystal_array_8_focus_xh;
MCNUM focus_r = mccchannel_7_analyzer_2_array_crystal_array_8_focus_r;
MCNUM p_interact = mccchannel_7_analyzer_2_array_crystal_array_8_p_interact;
char* mask_string = mccchannel_7_analyzer_2_array_crystal_array_8_mask_string;
char* mask_setting = mccchannel_7_analyzer_2_array_crystal_array_8_mask_setting;
MCNUM number_of_activations = mccchannel_7_analyzer_2_array_crystal_array_8_number_of_activations;
}   /* End of channel_7_analyzer_2_array_crystal_array_8=Union_box() SETTING parameter declarations. */
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex
  /* Label for restoring  neutron */
  mcabsorbCompchannel_7_analyzer_2_array_crystal_array_8:
  if (RESTORE) /* restore if needed */
  { RESTORE_NEUTRON(415,
      mcnlx,
      mcnly,
      mcnlz,
      mcnlvx,
      mcnlvy,
      mcnlvz,
      mcnlt,
      mcnlsx,
      mcnlsy,
      mcnlsz,
      mcnlp); }
#undef mcabsorbComp
#undef p
#undef sz
#undef sy
#undef sx
#undef t
#undef vz
#undef vy
#undef vx
#undef z
#undef y
#undef x
  mcDEBUG_STATE(
mcnlx,
mcnly,
mcnlz,
mcnlvx,
mcnlvy,
mcnlvz,
mcnlt,
mcnlsx,
mcnlsy,
mcnlsz,
mcnlp)

  /* TRACE Component channel_7_cave2_cyl1 [416] */
  mccoordschange(mcposrchannel_7_cave2_cyl1, mcrotrchannel_7_cave2_cyl1,
    &mcnlx,
    &mcnly,
    &mcnlz,
    &mcnlvx,
    &mcnlvy,
    &mcnlvz,
    &mcnlsx,
    &mcnlsy,
    &mcnlsz);
  /* define label inside component channel_7_cave2_cyl1 (without coords transformations) */
  mcJumpTrace_channel_7_cave2_cyl1:
  SIG_MESSAGE("channel_7_cave2_cyl1 (Trace)");
  mcDEBUG_COMP("channel_7_cave2_cyl1")
  mcDEBUG_STATE(
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp)
#define x mcnlx
#define y mcnly
#define z mcnlz
#define vx mcnlvx
#define vy mcnlvy
#define vz mcnlvz
#define t mcnlt
#define sx mcnlsx
#define sy mcnlsy
#define sz mcnlsz
#define p mcnlp

#define mcabsorbComp mcabsorbCompchannel_7_cave2_cyl1
  STORE_NEUTRON(416,
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp);
  mcScattered=0;
  mcRestore=0;
  mcNCounter[416]++;
  mcPCounter[416] += p;
  mcP2Counter[416] += p*p;
#define mccompcurname  channel_7_cave2_cyl1
#define mccompcurtype  Union_cylinder
#define mccompcurindex 416
#define loop_index mccchannel_7_cave2_cyl1_loop_index
#define this_cylinder_volume mccchannel_7_cave2_cyl1_this_cylinder_volume
#define global_geometry_element mccchannel_7_cave2_cyl1_global_geometry_element
#define this_cylinder_storage mccchannel_7_cave2_cyl1_this_cylinder_storage
{   /* Declarations of channel_7_cave2_cyl1=Union_cylinder() SETTING parameters. */
char* material_string = mccchannel_7_cave2_cyl1_material_string;
MCNUM priority = mccchannel_7_cave2_cyl1_priority;
MCNUM radius = mccchannel_7_cave2_cyl1_radius;
MCNUM yheight = mccchannel_7_cave2_cyl1_yheight;
MCNUM visualize = mccchannel_7_cave2_cyl1_visualize;
int target_index = mccchannel_7_cave2_cyl1_target_index;
MCNUM target_x = mccchannel_7_cave2_cyl1_target_x;
MCNUM target_y = mccchannel_7_cave2_cyl1_target_y;
MCNUM target_z = mccchannel_7_cave2_cyl1_target_z;
MCNUM focus_aw = mccchannel_7_cave2_cyl1_focus_aw;
MCNUM focus_ah = mccchannel_7_cave2_cyl1_focus_ah;
MCNUM focus_xw = mccchannel_7_cave2_cyl1_focus_xw;
MCNUM focus_xh = mccchannel_7_cave2_cyl1_focus_xh;
MCNUM focus_r = mccchannel_7_cave2_cyl1_focus_r;
MCNUM p_interact = mccchannel_7_cave2_cyl1_p_interact;
char* mask_string = mccchannel_7_cave2_cyl1_mask_string;
char* mask_setting = mccchannel_7_cave2_cyl1_mask_setting;
MCNUM number_of_activations = mccchannel_7_cave2_cyl1_number_of_activations;
#line 345 "Union_cylinder.comp"
{
dummy = 1;
}
#line 400605 "MACS_sample_kidney_box.c"
}   /* End of channel_7_cave2_cyl1=Union_cylinder() SETTING parameter declarations. */
#undef this_cylinder_storage
#undef global_geometry_element
#undef this_cylinder_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex
  /* Label for restoring  neutron */
  mcabsorbCompchannel_7_cave2_cyl1:
  if (RESTORE) /* restore if needed */
  { RESTORE_NEUTRON(416,
      mcnlx,
      mcnly,
      mcnlz,
      mcnlvx,
      mcnlvy,
      mcnlvz,
      mcnlt,
      mcnlsx,
      mcnlsy,
      mcnlsz,
      mcnlp); }
#undef mcabsorbComp
#undef p
#undef sz
#undef sy
#undef sx
#undef t
#undef vz
#undef vy
#undef vx
#undef z
#undef y
#undef x
  mcDEBUG_STATE(
mcnlx,
mcnly,
mcnlz,
mcnlvx,
mcnlvy,
mcnlvz,
mcnlt,
mcnlsx,
mcnlsy,
mcnlsz,
mcnlp)

  /* TRACE Component channel_7_cave2_box1 [417] */
  mccoordschange(mcposrchannel_7_cave2_box1, mcrotrchannel_7_cave2_box1,
    &mcnlx,
    &mcnly,
    &mcnlz,
    &mcnlvx,
    &mcnlvy,
    &mcnlvz,
    &mcnlsx,
    &mcnlsy,
    &mcnlsz);
  /* define label inside component channel_7_cave2_box1 (without coords transformations) */
  mcJumpTrace_channel_7_cave2_box1:
  SIG_MESSAGE("channel_7_cave2_box1 (Trace)");
  mcDEBUG_COMP("channel_7_cave2_box1")
  mcDEBUG_STATE(
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp)
#define x mcnlx
#define y mcnly
#define z mcnlz
#define vx mcnlvx
#define vy mcnlvy
#define vz mcnlvz
#define t mcnlt
#define sx mcnlsx
#define sy mcnlsy
#define sz mcnlsz
#define p mcnlp

#define mcabsorbComp mcabsorbCompchannel_7_cave2_box1
  STORE_NEUTRON(417,
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp);
  mcScattered=0;
  mcRestore=0;
  mcNCounter[417]++;
  mcPCounter[417] += p;
  mcP2Counter[417] += p*p;
#define mccompcurname  channel_7_cave2_box1
#define mccompcurtype  Union_box
#define mccompcurindex 417
#define loop_index mccchannel_7_cave2_box1_loop_index
#define this_box_volume mccchannel_7_cave2_box1_this_box_volume
#define global_geometry_element mccchannel_7_cave2_box1_global_geometry_element
#define this_box_storage mccchannel_7_cave2_box1_this_box_storage
{   /* Declarations of channel_7_cave2_box1=Union_box() SETTING parameters. */
char* material_string = mccchannel_7_cave2_box1_material_string;
MCNUM priority = mccchannel_7_cave2_box1_priority;
MCNUM xwidth = mccchannel_7_cave2_box1_xwidth;
MCNUM yheight = mccchannel_7_cave2_box1_yheight;
MCNUM zdepth = mccchannel_7_cave2_box1_zdepth;
MCNUM xwidth2 = mccchannel_7_cave2_box1_xwidth2;
MCNUM yheight2 = mccchannel_7_cave2_box1_yheight2;
MCNUM visualize = mccchannel_7_cave2_box1_visualize;
int target_index = mccchannel_7_cave2_box1_target_index;
MCNUM target_x = mccchannel_7_cave2_box1_target_x;
MCNUM target_y = mccchannel_7_cave2_box1_target_y;
MCNUM target_z = mccchannel_7_cave2_box1_target_z;
MCNUM focus_aw = mccchannel_7_cave2_box1_focus_aw;
MCNUM focus_ah = mccchannel_7_cave2_box1_focus_ah;
MCNUM focus_xw = mccchannel_7_cave2_box1_focus_xw;
MCNUM focus_xh = mccchannel_7_cave2_box1_focus_xh;
MCNUM focus_r = mccchannel_7_cave2_box1_focus_r;
MCNUM p_interact = mccchannel_7_cave2_box1_p_interact;
char* mask_string = mccchannel_7_cave2_box1_mask_string;
char* mask_setting = mccchannel_7_cave2_box1_mask_setting;
MCNUM number_of_activations = mccchannel_7_cave2_box1_number_of_activations;
}   /* End of channel_7_cave2_box1=Union_box() SETTING parameter declarations. */
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex
  /* Label for restoring  neutron */
  mcabsorbCompchannel_7_cave2_box1:
  if (RESTORE) /* restore if needed */
  { RESTORE_NEUTRON(417,
      mcnlx,
      mcnly,
      mcnlz,
      mcnlvx,
      mcnlvy,
      mcnlvz,
      mcnlt,
      mcnlsx,
      mcnlsy,
      mcnlsz,
      mcnlp); }
#undef mcabsorbComp
#undef p
#undef sz
#undef sy
#undef sx
#undef t
#undef vz
#undef vy
#undef vx
#undef z
#undef y
#undef x
  mcDEBUG_STATE(
mcnlx,
mcnly,
mcnlz,
mcnlvx,
mcnlvy,
mcnlvz,
mcnlt,
mcnlsx,
mcnlsy,
mcnlsz,
mcnlp)

  /* TRACE Component channel_7_cave2_box2 [418] */
  mccoordschange(mcposrchannel_7_cave2_box2, mcrotrchannel_7_cave2_box2,
    &mcnlx,
    &mcnly,
    &mcnlz,
    &mcnlvx,
    &mcnlvy,
    &mcnlvz,
    &mcnlsx,
    &mcnlsy,
    &mcnlsz);
  /* define label inside component channel_7_cave2_box2 (without coords transformations) */
  mcJumpTrace_channel_7_cave2_box2:
  SIG_MESSAGE("channel_7_cave2_box2 (Trace)");
  mcDEBUG_COMP("channel_7_cave2_box2")
  mcDEBUG_STATE(
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp)
#define x mcnlx
#define y mcnly
#define z mcnlz
#define vx mcnlvx
#define vy mcnlvy
#define vz mcnlvz
#define t mcnlt
#define sx mcnlsx
#define sy mcnlsy
#define sz mcnlsz
#define p mcnlp

#define mcabsorbComp mcabsorbCompchannel_7_cave2_box2
  STORE_NEUTRON(418,
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp);
  mcScattered=0;
  mcRestore=0;
  mcNCounter[418]++;
  mcPCounter[418] += p;
  mcP2Counter[418] += p*p;
#define mccompcurname  channel_7_cave2_box2
#define mccompcurtype  Union_box
#define mccompcurindex 418
#define loop_index mccchannel_7_cave2_box2_loop_index
#define this_box_volume mccchannel_7_cave2_box2_this_box_volume
#define global_geometry_element mccchannel_7_cave2_box2_global_geometry_element
#define this_box_storage mccchannel_7_cave2_box2_this_box_storage
{   /* Declarations of channel_7_cave2_box2=Union_box() SETTING parameters. */
char* material_string = mccchannel_7_cave2_box2_material_string;
MCNUM priority = mccchannel_7_cave2_box2_priority;
MCNUM xwidth = mccchannel_7_cave2_box2_xwidth;
MCNUM yheight = mccchannel_7_cave2_box2_yheight;
MCNUM zdepth = mccchannel_7_cave2_box2_zdepth;
MCNUM xwidth2 = mccchannel_7_cave2_box2_xwidth2;
MCNUM yheight2 = mccchannel_7_cave2_box2_yheight2;
MCNUM visualize = mccchannel_7_cave2_box2_visualize;
int target_index = mccchannel_7_cave2_box2_target_index;
MCNUM target_x = mccchannel_7_cave2_box2_target_x;
MCNUM target_y = mccchannel_7_cave2_box2_target_y;
MCNUM target_z = mccchannel_7_cave2_box2_target_z;
MCNUM focus_aw = mccchannel_7_cave2_box2_focus_aw;
MCNUM focus_ah = mccchannel_7_cave2_box2_focus_ah;
MCNUM focus_xw = mccchannel_7_cave2_box2_focus_xw;
MCNUM focus_xh = mccchannel_7_cave2_box2_focus_xh;
MCNUM focus_r = mccchannel_7_cave2_box2_focus_r;
MCNUM p_interact = mccchannel_7_cave2_box2_p_interact;
char* mask_string = mccchannel_7_cave2_box2_mask_string;
char* mask_setting = mccchannel_7_cave2_box2_mask_setting;
MCNUM number_of_activations = mccchannel_7_cave2_box2_number_of_activations;
}   /* End of channel_7_cave2_box2=Union_box() SETTING parameter declarations. */
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex
  /* Label for restoring  neutron */
  mcabsorbCompchannel_7_cave2_box2:
  if (RESTORE) /* restore if needed */
  { RESTORE_NEUTRON(418,
      mcnlx,
      mcnly,
      mcnlz,
      mcnlvx,
      mcnlvy,
      mcnlvz,
      mcnlt,
      mcnlsx,
      mcnlsy,
      mcnlsz,
      mcnlp); }
#undef mcabsorbComp
#undef p
#undef sz
#undef sy
#undef sx
#undef t
#undef vz
#undef vy
#undef vx
#undef z
#undef y
#undef x
  mcDEBUG_STATE(
mcnlx,
mcnly,
mcnlz,
mcnlvx,
mcnlvy,
mcnlvz,
mcnlt,
mcnlsx,
mcnlsy,
mcnlsz,
mcnlp)

  /* TRACE Component channel_7_cave2_box3 [419] */
  mccoordschange(mcposrchannel_7_cave2_box3, mcrotrchannel_7_cave2_box3,
    &mcnlx,
    &mcnly,
    &mcnlz,
    &mcnlvx,
    &mcnlvy,
    &mcnlvz,
    &mcnlsx,
    &mcnlsy,
    &mcnlsz);
  /* define label inside component channel_7_cave2_box3 (without coords transformations) */
  mcJumpTrace_channel_7_cave2_box3:
  SIG_MESSAGE("channel_7_cave2_box3 (Trace)");
  mcDEBUG_COMP("channel_7_cave2_box3")
  mcDEBUG_STATE(
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp)
#define x mcnlx
#define y mcnly
#define z mcnlz
#define vx mcnlvx
#define vy mcnlvy
#define vz mcnlvz
#define t mcnlt
#define sx mcnlsx
#define sy mcnlsy
#define sz mcnlsz
#define p mcnlp

#define mcabsorbComp mcabsorbCompchannel_7_cave2_box3
  STORE_NEUTRON(419,
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp);
  mcScattered=0;
  mcRestore=0;
  mcNCounter[419]++;
  mcPCounter[419] += p;
  mcP2Counter[419] += p*p;
#define mccompcurname  channel_7_cave2_box3
#define mccompcurtype  Union_box
#define mccompcurindex 419
#define loop_index mccchannel_7_cave2_box3_loop_index
#define this_box_volume mccchannel_7_cave2_box3_this_box_volume
#define global_geometry_element mccchannel_7_cave2_box3_global_geometry_element
#define this_box_storage mccchannel_7_cave2_box3_this_box_storage
{   /* Declarations of channel_7_cave2_box3=Union_box() SETTING parameters. */
char* material_string = mccchannel_7_cave2_box3_material_string;
MCNUM priority = mccchannel_7_cave2_box3_priority;
MCNUM xwidth = mccchannel_7_cave2_box3_xwidth;
MCNUM yheight = mccchannel_7_cave2_box3_yheight;
MCNUM zdepth = mccchannel_7_cave2_box3_zdepth;
MCNUM xwidth2 = mccchannel_7_cave2_box3_xwidth2;
MCNUM yheight2 = mccchannel_7_cave2_box3_yheight2;
MCNUM visualize = mccchannel_7_cave2_box3_visualize;
int target_index = mccchannel_7_cave2_box3_target_index;
MCNUM target_x = mccchannel_7_cave2_box3_target_x;
MCNUM target_y = mccchannel_7_cave2_box3_target_y;
MCNUM target_z = mccchannel_7_cave2_box3_target_z;
MCNUM focus_aw = mccchannel_7_cave2_box3_focus_aw;
MCNUM focus_ah = mccchannel_7_cave2_box3_focus_ah;
MCNUM focus_xw = mccchannel_7_cave2_box3_focus_xw;
MCNUM focus_xh = mccchannel_7_cave2_box3_focus_xh;
MCNUM focus_r = mccchannel_7_cave2_box3_focus_r;
MCNUM p_interact = mccchannel_7_cave2_box3_p_interact;
char* mask_string = mccchannel_7_cave2_box3_mask_string;
char* mask_setting = mccchannel_7_cave2_box3_mask_setting;
MCNUM number_of_activations = mccchannel_7_cave2_box3_number_of_activations;
}   /* End of channel_7_cave2_box3=Union_box() SETTING parameter declarations. */
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex
  /* Label for restoring  neutron */
  mcabsorbCompchannel_7_cave2_box3:
  if (RESTORE) /* restore if needed */
  { RESTORE_NEUTRON(419,
      mcnlx,
      mcnly,
      mcnlz,
      mcnlvx,
      mcnlvy,
      mcnlvz,
      mcnlt,
      mcnlsx,
      mcnlsy,
      mcnlsz,
      mcnlp); }
#undef mcabsorbComp
#undef p
#undef sz
#undef sy
#undef sx
#undef t
#undef vz
#undef vy
#undef vx
#undef z
#undef y
#undef x
  mcDEBUG_STATE(
mcnlx,
mcnly,
mcnlz,
mcnlvx,
mcnlvy,
mcnlvz,
mcnlt,
mcnlsx,
mcnlsy,
mcnlsz,
mcnlp)

  /* TRACE Component inter_analyzer_colimator_center_7 [420] */
  mccoordschange(mcposrinter_analyzer_colimator_center_7, mcrotrinter_analyzer_colimator_center_7,
    &mcnlx,
    &mcnly,
    &mcnlz,
    &mcnlvx,
    &mcnlvy,
    &mcnlvz,
    &mcnlsx,
    &mcnlsy,
    &mcnlsz);
  /* define label inside component inter_analyzer_colimator_center_7 (without coords transformations) */
  mcJumpTrace_inter_analyzer_colimator_center_7:
  SIG_MESSAGE("inter_analyzer_colimator_center_7 (Trace)");
  mcDEBUG_COMP("inter_analyzer_colimator_center_7")
  mcDEBUG_STATE(
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp)
#define x mcnlx
#define y mcnly
#define z mcnlz
#define vx mcnlvx
#define vy mcnlvy
#define vz mcnlvz
#define t mcnlt
#define sx mcnlsx
#define sy mcnlsy
#define sz mcnlsz
#define p mcnlp

#define mcabsorbComp mcabsorbCompinter_analyzer_colimator_center_7
  STORE_NEUTRON(420,
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp);
  mcScattered=0;
  mcRestore=0;
  mcNCounter[420]++;
  mcPCounter[420] += p;
  mcP2Counter[420] += p*p;
#define mccompcurname  inter_analyzer_colimator_center_7
#define mccompcurtype  Arm
#define mccompcurindex 420
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex
  /* Label for restoring  neutron */
  mcabsorbCompinter_analyzer_colimator_center_7:
  if (RESTORE) /* restore if needed */
  { RESTORE_NEUTRON(420,
      mcnlx,
      mcnly,
      mcnlz,
      mcnlvx,
      mcnlvy,
      mcnlvz,
      mcnlt,
      mcnlsx,
      mcnlsy,
      mcnlsz,
      mcnlp); }
#undef mcabsorbComp
#undef p
#undef sz
#undef sy
#undef sx
#undef t
#undef vz
#undef vy
#undef vx
#undef z
#undef y
#undef x
  mcDEBUG_STATE(
mcnlx,
mcnly,
mcnlz,
mcnlvx,
mcnlvy,
mcnlvz,
mcnlt,
mcnlsx,
mcnlsy,
mcnlsz,
mcnlp)

  /* TRACE Component inter_analyzer_colimator_7_blade_0 [421] */
  mccoordschange(mcposrinter_analyzer_colimator_7_blade_0, mcrotrinter_analyzer_colimator_7_blade_0,
    &mcnlx,
    &mcnly,
    &mcnlz,
    &mcnlvx,
    &mcnlvy,
    &mcnlvz,
    &mcnlsx,
    &mcnlsy,
    &mcnlsz);
  /* define label inside component inter_analyzer_colimator_7_blade_0 (without coords transformations) */
  mcJumpTrace_inter_analyzer_colimator_7_blade_0:
  SIG_MESSAGE("inter_analyzer_colimator_7_blade_0 (Trace)");
  mcDEBUG_COMP("inter_analyzer_colimator_7_blade_0")
  mcDEBUG_STATE(
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp)
#define x mcnlx
#define y mcnly
#define z mcnlz
#define vx mcnlvx
#define vy mcnlvy
#define vz mcnlvz
#define t mcnlt
#define sx mcnlsx
#define sy mcnlsy
#define sz mcnlsz
#define p mcnlp

#define mcabsorbComp mcabsorbCompinter_analyzer_colimator_7_blade_0
  STORE_NEUTRON(421,
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp);
  mcScattered=0;
  mcRestore=0;
  mcNCounter[421]++;
  mcPCounter[421] += p;
  mcP2Counter[421] += p*p;
#define mccompcurname  inter_analyzer_colimator_7_blade_0
#define mccompcurtype  Union_box
#define mccompcurindex 421
#define loop_index mccinter_analyzer_colimator_7_blade_0_loop_index
#define this_box_volume mccinter_analyzer_colimator_7_blade_0_this_box_volume
#define global_geometry_element mccinter_analyzer_colimator_7_blade_0_global_geometry_element
#define this_box_storage mccinter_analyzer_colimator_7_blade_0_this_box_storage
{   /* Declarations of inter_analyzer_colimator_7_blade_0=Union_box() SETTING parameters. */
char* material_string = mccinter_analyzer_colimator_7_blade_0_material_string;
MCNUM priority = mccinter_analyzer_colimator_7_blade_0_priority;
MCNUM xwidth = mccinter_analyzer_colimator_7_blade_0_xwidth;
MCNUM yheight = mccinter_analyzer_colimator_7_blade_0_yheight;
MCNUM zdepth = mccinter_analyzer_colimator_7_blade_0_zdepth;
MCNUM xwidth2 = mccinter_analyzer_colimator_7_blade_0_xwidth2;
MCNUM yheight2 = mccinter_analyzer_colimator_7_blade_0_yheight2;
MCNUM visualize = mccinter_analyzer_colimator_7_blade_0_visualize;
int target_index = mccinter_analyzer_colimator_7_blade_0_target_index;
MCNUM target_x = mccinter_analyzer_colimator_7_blade_0_target_x;
MCNUM target_y = mccinter_analyzer_colimator_7_blade_0_target_y;
MCNUM target_z = mccinter_analyzer_colimator_7_blade_0_target_z;
MCNUM focus_aw = mccinter_analyzer_colimator_7_blade_0_focus_aw;
MCNUM focus_ah = mccinter_analyzer_colimator_7_blade_0_focus_ah;
MCNUM focus_xw = mccinter_analyzer_colimator_7_blade_0_focus_xw;
MCNUM focus_xh = mccinter_analyzer_colimator_7_blade_0_focus_xh;
MCNUM focus_r = mccinter_analyzer_colimator_7_blade_0_focus_r;
MCNUM p_interact = mccinter_analyzer_colimator_7_blade_0_p_interact;
char* mask_string = mccinter_analyzer_colimator_7_blade_0_mask_string;
char* mask_setting = mccinter_analyzer_colimator_7_blade_0_mask_setting;
MCNUM number_of_activations = mccinter_analyzer_colimator_7_blade_0_number_of_activations;
}   /* End of inter_analyzer_colimator_7_blade_0=Union_box() SETTING parameter declarations. */
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex
  /* Label for restoring  neutron */
  mcabsorbCompinter_analyzer_colimator_7_blade_0:
  if (RESTORE) /* restore if needed */
  { RESTORE_NEUTRON(421,
      mcnlx,
      mcnly,
      mcnlz,
      mcnlvx,
      mcnlvy,
      mcnlvz,
      mcnlt,
      mcnlsx,
      mcnlsy,
      mcnlsz,
      mcnlp); }
#undef mcabsorbComp
#undef p
#undef sz
#undef sy
#undef sx
#undef t
#undef vz
#undef vy
#undef vx
#undef z
#undef y
#undef x
  mcDEBUG_STATE(
mcnlx,
mcnly,
mcnlz,
mcnlvx,
mcnlvy,
mcnlvz,
mcnlt,
mcnlsx,
mcnlsy,
mcnlsz,
mcnlp)

  /* TRACE Component inter_analyzer_colimator_7_blade_1 [422] */
  mccoordschange(mcposrinter_analyzer_colimator_7_blade_1, mcrotrinter_analyzer_colimator_7_blade_1,
    &mcnlx,
    &mcnly,
    &mcnlz,
    &mcnlvx,
    &mcnlvy,
    &mcnlvz,
    &mcnlsx,
    &mcnlsy,
    &mcnlsz);
  /* define label inside component inter_analyzer_colimator_7_blade_1 (without coords transformations) */
  mcJumpTrace_inter_analyzer_colimator_7_blade_1:
  SIG_MESSAGE("inter_analyzer_colimator_7_blade_1 (Trace)");
  mcDEBUG_COMP("inter_analyzer_colimator_7_blade_1")
  mcDEBUG_STATE(
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp)
#define x mcnlx
#define y mcnly
#define z mcnlz
#define vx mcnlvx
#define vy mcnlvy
#define vz mcnlvz
#define t mcnlt
#define sx mcnlsx
#define sy mcnlsy
#define sz mcnlsz
#define p mcnlp

#define mcabsorbComp mcabsorbCompinter_analyzer_colimator_7_blade_1
  STORE_NEUTRON(422,
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp);
  mcScattered=0;
  mcRestore=0;
  mcNCounter[422]++;
  mcPCounter[422] += p;
  mcP2Counter[422] += p*p;
#define mccompcurname  inter_analyzer_colimator_7_blade_1
#define mccompcurtype  Union_box
#define mccompcurindex 422
#define loop_index mccinter_analyzer_colimator_7_blade_1_loop_index
#define this_box_volume mccinter_analyzer_colimator_7_blade_1_this_box_volume
#define global_geometry_element mccinter_analyzer_colimator_7_blade_1_global_geometry_element
#define this_box_storage mccinter_analyzer_colimator_7_blade_1_this_box_storage
{   /* Declarations of inter_analyzer_colimator_7_blade_1=Union_box() SETTING parameters. */
char* material_string = mccinter_analyzer_colimator_7_blade_1_material_string;
MCNUM priority = mccinter_analyzer_colimator_7_blade_1_priority;
MCNUM xwidth = mccinter_analyzer_colimator_7_blade_1_xwidth;
MCNUM yheight = mccinter_analyzer_colimator_7_blade_1_yheight;
MCNUM zdepth = mccinter_analyzer_colimator_7_blade_1_zdepth;
MCNUM xwidth2 = mccinter_analyzer_colimator_7_blade_1_xwidth2;
MCNUM yheight2 = mccinter_analyzer_colimator_7_blade_1_yheight2;
MCNUM visualize = mccinter_analyzer_colimator_7_blade_1_visualize;
int target_index = mccinter_analyzer_colimator_7_blade_1_target_index;
MCNUM target_x = mccinter_analyzer_colimator_7_blade_1_target_x;
MCNUM target_y = mccinter_analyzer_colimator_7_blade_1_target_y;
MCNUM target_z = mccinter_analyzer_colimator_7_blade_1_target_z;
MCNUM focus_aw = mccinter_analyzer_colimator_7_blade_1_focus_aw;
MCNUM focus_ah = mccinter_analyzer_colimator_7_blade_1_focus_ah;
MCNUM focus_xw = mccinter_analyzer_colimator_7_blade_1_focus_xw;
MCNUM focus_xh = mccinter_analyzer_colimator_7_blade_1_focus_xh;
MCNUM focus_r = mccinter_analyzer_colimator_7_blade_1_focus_r;
MCNUM p_interact = mccinter_analyzer_colimator_7_blade_1_p_interact;
char* mask_string = mccinter_analyzer_colimator_7_blade_1_mask_string;
char* mask_setting = mccinter_analyzer_colimator_7_blade_1_mask_setting;
MCNUM number_of_activations = mccinter_analyzer_colimator_7_blade_1_number_of_activations;
}   /* End of inter_analyzer_colimator_7_blade_1=Union_box() SETTING parameter declarations. */
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex
  /* Label for restoring  neutron */
  mcabsorbCompinter_analyzer_colimator_7_blade_1:
  if (RESTORE) /* restore if needed */
  { RESTORE_NEUTRON(422,
      mcnlx,
      mcnly,
      mcnlz,
      mcnlvx,
      mcnlvy,
      mcnlvz,
      mcnlt,
      mcnlsx,
      mcnlsy,
      mcnlsz,
      mcnlp); }
#undef mcabsorbComp
#undef p
#undef sz
#undef sy
#undef sx
#undef t
#undef vz
#undef vy
#undef vx
#undef z
#undef y
#undef x
  mcDEBUG_STATE(
mcnlx,
mcnly,
mcnlz,
mcnlvx,
mcnlvy,
mcnlvz,
mcnlt,
mcnlsx,
mcnlsy,
mcnlsz,
mcnlp)

  /* TRACE Component inter_analyzer_colimator_7_blade_2 [423] */
  mccoordschange(mcposrinter_analyzer_colimator_7_blade_2, mcrotrinter_analyzer_colimator_7_blade_2,
    &mcnlx,
    &mcnly,
    &mcnlz,
    &mcnlvx,
    &mcnlvy,
    &mcnlvz,
    &mcnlsx,
    &mcnlsy,
    &mcnlsz);
  /* define label inside component inter_analyzer_colimator_7_blade_2 (without coords transformations) */
  mcJumpTrace_inter_analyzer_colimator_7_blade_2:
  SIG_MESSAGE("inter_analyzer_colimator_7_blade_2 (Trace)");
  mcDEBUG_COMP("inter_analyzer_colimator_7_blade_2")
  mcDEBUG_STATE(
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp)
#define x mcnlx
#define y mcnly
#define z mcnlz
#define vx mcnlvx
#define vy mcnlvy
#define vz mcnlvz
#define t mcnlt
#define sx mcnlsx
#define sy mcnlsy
#define sz mcnlsz
#define p mcnlp

#define mcabsorbComp mcabsorbCompinter_analyzer_colimator_7_blade_2
  STORE_NEUTRON(423,
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp);
  mcScattered=0;
  mcRestore=0;
  mcNCounter[423]++;
  mcPCounter[423] += p;
  mcP2Counter[423] += p*p;
#define mccompcurname  inter_analyzer_colimator_7_blade_2
#define mccompcurtype  Union_box
#define mccompcurindex 423
#define loop_index mccinter_analyzer_colimator_7_blade_2_loop_index
#define this_box_volume mccinter_analyzer_colimator_7_blade_2_this_box_volume
#define global_geometry_element mccinter_analyzer_colimator_7_blade_2_global_geometry_element
#define this_box_storage mccinter_analyzer_colimator_7_blade_2_this_box_storage
{   /* Declarations of inter_analyzer_colimator_7_blade_2=Union_box() SETTING parameters. */
char* material_string = mccinter_analyzer_colimator_7_blade_2_material_string;
MCNUM priority = mccinter_analyzer_colimator_7_blade_2_priority;
MCNUM xwidth = mccinter_analyzer_colimator_7_blade_2_xwidth;
MCNUM yheight = mccinter_analyzer_colimator_7_blade_2_yheight;
MCNUM zdepth = mccinter_analyzer_colimator_7_blade_2_zdepth;
MCNUM xwidth2 = mccinter_analyzer_colimator_7_blade_2_xwidth2;
MCNUM yheight2 = mccinter_analyzer_colimator_7_blade_2_yheight2;
MCNUM visualize = mccinter_analyzer_colimator_7_blade_2_visualize;
int target_index = mccinter_analyzer_colimator_7_blade_2_target_index;
MCNUM target_x = mccinter_analyzer_colimator_7_blade_2_target_x;
MCNUM target_y = mccinter_analyzer_colimator_7_blade_2_target_y;
MCNUM target_z = mccinter_analyzer_colimator_7_blade_2_target_z;
MCNUM focus_aw = mccinter_analyzer_colimator_7_blade_2_focus_aw;
MCNUM focus_ah = mccinter_analyzer_colimator_7_blade_2_focus_ah;
MCNUM focus_xw = mccinter_analyzer_colimator_7_blade_2_focus_xw;
MCNUM focus_xh = mccinter_analyzer_colimator_7_blade_2_focus_xh;
MCNUM focus_r = mccinter_analyzer_colimator_7_blade_2_focus_r;
MCNUM p_interact = mccinter_analyzer_colimator_7_blade_2_p_interact;
char* mask_string = mccinter_analyzer_colimator_7_blade_2_mask_string;
char* mask_setting = mccinter_analyzer_colimator_7_blade_2_mask_setting;
MCNUM number_of_activations = mccinter_analyzer_colimator_7_blade_2_number_of_activations;
}   /* End of inter_analyzer_colimator_7_blade_2=Union_box() SETTING parameter declarations. */
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex
  /* Label for restoring  neutron */
  mcabsorbCompinter_analyzer_colimator_7_blade_2:
  if (RESTORE) /* restore if needed */
  { RESTORE_NEUTRON(423,
      mcnlx,
      mcnly,
      mcnlz,
      mcnlvx,
      mcnlvy,
      mcnlvz,
      mcnlt,
      mcnlsx,
      mcnlsy,
      mcnlsz,
      mcnlp); }
#undef mcabsorbComp
#undef p
#undef sz
#undef sy
#undef sx
#undef t
#undef vz
#undef vy
#undef vx
#undef z
#undef y
#undef x
  mcDEBUG_STATE(
mcnlx,
mcnly,
mcnlz,
mcnlvx,
mcnlvy,
mcnlvz,
mcnlt,
mcnlsx,
mcnlsy,
mcnlsz,
mcnlp)

  /* TRACE Component inter_analyzer_colimator_7_blade_3 [424] */
  mccoordschange(mcposrinter_analyzer_colimator_7_blade_3, mcrotrinter_analyzer_colimator_7_blade_3,
    &mcnlx,
    &mcnly,
    &mcnlz,
    &mcnlvx,
    &mcnlvy,
    &mcnlvz,
    &mcnlsx,
    &mcnlsy,
    &mcnlsz);
  /* define label inside component inter_analyzer_colimator_7_blade_3 (without coords transformations) */
  mcJumpTrace_inter_analyzer_colimator_7_blade_3:
  SIG_MESSAGE("inter_analyzer_colimator_7_blade_3 (Trace)");
  mcDEBUG_COMP("inter_analyzer_colimator_7_blade_3")
  mcDEBUG_STATE(
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp)
#define x mcnlx
#define y mcnly
#define z mcnlz
#define vx mcnlvx
#define vy mcnlvy
#define vz mcnlvz
#define t mcnlt
#define sx mcnlsx
#define sy mcnlsy
#define sz mcnlsz
#define p mcnlp

#define mcabsorbComp mcabsorbCompinter_analyzer_colimator_7_blade_3
  STORE_NEUTRON(424,
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp);
  mcScattered=0;
  mcRestore=0;
  mcNCounter[424]++;
  mcPCounter[424] += p;
  mcP2Counter[424] += p*p;
#define mccompcurname  inter_analyzer_colimator_7_blade_3
#define mccompcurtype  Union_box
#define mccompcurindex 424
#define loop_index mccinter_analyzer_colimator_7_blade_3_loop_index
#define this_box_volume mccinter_analyzer_colimator_7_blade_3_this_box_volume
#define global_geometry_element mccinter_analyzer_colimator_7_blade_3_global_geometry_element
#define this_box_storage mccinter_analyzer_colimator_7_blade_3_this_box_storage
{   /* Declarations of inter_analyzer_colimator_7_blade_3=Union_box() SETTING parameters. */
char* material_string = mccinter_analyzer_colimator_7_blade_3_material_string;
MCNUM priority = mccinter_analyzer_colimator_7_blade_3_priority;
MCNUM xwidth = mccinter_analyzer_colimator_7_blade_3_xwidth;
MCNUM yheight = mccinter_analyzer_colimator_7_blade_3_yheight;
MCNUM zdepth = mccinter_analyzer_colimator_7_blade_3_zdepth;
MCNUM xwidth2 = mccinter_analyzer_colimator_7_blade_3_xwidth2;
MCNUM yheight2 = mccinter_analyzer_colimator_7_blade_3_yheight2;
MCNUM visualize = mccinter_analyzer_colimator_7_blade_3_visualize;
int target_index = mccinter_analyzer_colimator_7_blade_3_target_index;
MCNUM target_x = mccinter_analyzer_colimator_7_blade_3_target_x;
MCNUM target_y = mccinter_analyzer_colimator_7_blade_3_target_y;
MCNUM target_z = mccinter_analyzer_colimator_7_blade_3_target_z;
MCNUM focus_aw = mccinter_analyzer_colimator_7_blade_3_focus_aw;
MCNUM focus_ah = mccinter_analyzer_colimator_7_blade_3_focus_ah;
MCNUM focus_xw = mccinter_analyzer_colimator_7_blade_3_focus_xw;
MCNUM focus_xh = mccinter_analyzer_colimator_7_blade_3_focus_xh;
MCNUM focus_r = mccinter_analyzer_colimator_7_blade_3_focus_r;
MCNUM p_interact = mccinter_analyzer_colimator_7_blade_3_p_interact;
char* mask_string = mccinter_analyzer_colimator_7_blade_3_mask_string;
char* mask_setting = mccinter_analyzer_colimator_7_blade_3_mask_setting;
MCNUM number_of_activations = mccinter_analyzer_colimator_7_blade_3_number_of_activations;
}   /* End of inter_analyzer_colimator_7_blade_3=Union_box() SETTING parameter declarations. */
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex
  /* Label for restoring  neutron */
  mcabsorbCompinter_analyzer_colimator_7_blade_3:
  if (RESTORE) /* restore if needed */
  { RESTORE_NEUTRON(424,
      mcnlx,
      mcnly,
      mcnlz,
      mcnlvx,
      mcnlvy,
      mcnlvz,
      mcnlt,
      mcnlsx,
      mcnlsy,
      mcnlsz,
      mcnlp); }
#undef mcabsorbComp
#undef p
#undef sz
#undef sy
#undef sx
#undef t
#undef vz
#undef vy
#undef vx
#undef z
#undef y
#undef x
  mcDEBUG_STATE(
mcnlx,
mcnly,
mcnlz,
mcnlvx,
mcnlvy,
mcnlvz,
mcnlt,
mcnlsx,
mcnlsy,
mcnlsz,
mcnlp)

  /* TRACE Component inter_analyzer_colimator_7_blade_4 [425] */
  mccoordschange(mcposrinter_analyzer_colimator_7_blade_4, mcrotrinter_analyzer_colimator_7_blade_4,
    &mcnlx,
    &mcnly,
    &mcnlz,
    &mcnlvx,
    &mcnlvy,
    &mcnlvz,
    &mcnlsx,
    &mcnlsy,
    &mcnlsz);
  /* define label inside component inter_analyzer_colimator_7_blade_4 (without coords transformations) */
  mcJumpTrace_inter_analyzer_colimator_7_blade_4:
  SIG_MESSAGE("inter_analyzer_colimator_7_blade_4 (Trace)");
  mcDEBUG_COMP("inter_analyzer_colimator_7_blade_4")
  mcDEBUG_STATE(
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp)
#define x mcnlx
#define y mcnly
#define z mcnlz
#define vx mcnlvx
#define vy mcnlvy
#define vz mcnlvz
#define t mcnlt
#define sx mcnlsx
#define sy mcnlsy
#define sz mcnlsz
#define p mcnlp

#define mcabsorbComp mcabsorbCompinter_analyzer_colimator_7_blade_4
  STORE_NEUTRON(425,
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp);
  mcScattered=0;
  mcRestore=0;
  mcNCounter[425]++;
  mcPCounter[425] += p;
  mcP2Counter[425] += p*p;
#define mccompcurname  inter_analyzer_colimator_7_blade_4
#define mccompcurtype  Union_box
#define mccompcurindex 425
#define loop_index mccinter_analyzer_colimator_7_blade_4_loop_index
#define this_box_volume mccinter_analyzer_colimator_7_blade_4_this_box_volume
#define global_geometry_element mccinter_analyzer_colimator_7_blade_4_global_geometry_element
#define this_box_storage mccinter_analyzer_colimator_7_blade_4_this_box_storage
{   /* Declarations of inter_analyzer_colimator_7_blade_4=Union_box() SETTING parameters. */
char* material_string = mccinter_analyzer_colimator_7_blade_4_material_string;
MCNUM priority = mccinter_analyzer_colimator_7_blade_4_priority;
MCNUM xwidth = mccinter_analyzer_colimator_7_blade_4_xwidth;
MCNUM yheight = mccinter_analyzer_colimator_7_blade_4_yheight;
MCNUM zdepth = mccinter_analyzer_colimator_7_blade_4_zdepth;
MCNUM xwidth2 = mccinter_analyzer_colimator_7_blade_4_xwidth2;
MCNUM yheight2 = mccinter_analyzer_colimator_7_blade_4_yheight2;
MCNUM visualize = mccinter_analyzer_colimator_7_blade_4_visualize;
int target_index = mccinter_analyzer_colimator_7_blade_4_target_index;
MCNUM target_x = mccinter_analyzer_colimator_7_blade_4_target_x;
MCNUM target_y = mccinter_analyzer_colimator_7_blade_4_target_y;
MCNUM target_z = mccinter_analyzer_colimator_7_blade_4_target_z;
MCNUM focus_aw = mccinter_analyzer_colimator_7_blade_4_focus_aw;
MCNUM focus_ah = mccinter_analyzer_colimator_7_blade_4_focus_ah;
MCNUM focus_xw = mccinter_analyzer_colimator_7_blade_4_focus_xw;
MCNUM focus_xh = mccinter_analyzer_colimator_7_blade_4_focus_xh;
MCNUM focus_r = mccinter_analyzer_colimator_7_blade_4_focus_r;
MCNUM p_interact = mccinter_analyzer_colimator_7_blade_4_p_interact;
char* mask_string = mccinter_analyzer_colimator_7_blade_4_mask_string;
char* mask_setting = mccinter_analyzer_colimator_7_blade_4_mask_setting;
MCNUM number_of_activations = mccinter_analyzer_colimator_7_blade_4_number_of_activations;
}   /* End of inter_analyzer_colimator_7_blade_4=Union_box() SETTING parameter declarations. */
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex
  /* Label for restoring  neutron */
  mcabsorbCompinter_analyzer_colimator_7_blade_4:
  if (RESTORE) /* restore if needed */
  { RESTORE_NEUTRON(425,
      mcnlx,
      mcnly,
      mcnlz,
      mcnlvx,
      mcnlvy,
      mcnlvz,
      mcnlt,
      mcnlsx,
      mcnlsy,
      mcnlsz,
      mcnlp); }
#undef mcabsorbComp
#undef p
#undef sz
#undef sy
#undef sx
#undef t
#undef vz
#undef vy
#undef vx
#undef z
#undef y
#undef x
  mcDEBUG_STATE(
mcnlx,
mcnly,
mcnlz,
mcnlvx,
mcnlvy,
mcnlvz,
mcnlt,
mcnlsx,
mcnlsy,
mcnlsz,
mcnlp)

  /* TRACE Component diffraction_detector_7_exit_volume [426] */
  mccoordschange(mcposrdiffraction_detector_7_exit_volume, mcrotrdiffraction_detector_7_exit_volume,
    &mcnlx,
    &mcnly,
    &mcnlz,
    &mcnlvx,
    &mcnlvy,
    &mcnlvz,
    &mcnlsx,
    &mcnlsy,
    &mcnlsz);
  /* define label inside component diffraction_detector_7_exit_volume (without coords transformations) */
  mcJumpTrace_diffraction_detector_7_exit_volume:
  SIG_MESSAGE("diffraction_detector_7_exit_volume (Trace)");
  mcDEBUG_COMP("diffraction_detector_7_exit_volume")
  mcDEBUG_STATE(
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp)
#define x mcnlx
#define y mcnly
#define z mcnlz
#define vx mcnlvx
#define vy mcnlvy
#define vz mcnlvz
#define t mcnlt
#define sx mcnlsx
#define sy mcnlsy
#define sz mcnlsz
#define p mcnlp

#define mcabsorbComp mcabsorbCompdiffraction_detector_7_exit_volume
  STORE_NEUTRON(426,
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp);
  mcScattered=0;
  mcRestore=0;
  mcNCounter[426]++;
  mcPCounter[426] += p;
  mcP2Counter[426] += p*p;
#define mccompcurname  diffraction_detector_7_exit_volume
#define mccompcurtype  Union_box
#define mccompcurindex 426
#define loop_index mccdiffraction_detector_7_exit_volume_loop_index
#define this_box_volume mccdiffraction_detector_7_exit_volume_this_box_volume
#define global_geometry_element mccdiffraction_detector_7_exit_volume_global_geometry_element
#define this_box_storage mccdiffraction_detector_7_exit_volume_this_box_storage
{   /* Declarations of diffraction_detector_7_exit_volume=Union_box() SETTING parameters. */
char* material_string = mccdiffraction_detector_7_exit_volume_material_string;
MCNUM priority = mccdiffraction_detector_7_exit_volume_priority;
MCNUM xwidth = mccdiffraction_detector_7_exit_volume_xwidth;
MCNUM yheight = mccdiffraction_detector_7_exit_volume_yheight;
MCNUM zdepth = mccdiffraction_detector_7_exit_volume_zdepth;
MCNUM xwidth2 = mccdiffraction_detector_7_exit_volume_xwidth2;
MCNUM yheight2 = mccdiffraction_detector_7_exit_volume_yheight2;
MCNUM visualize = mccdiffraction_detector_7_exit_volume_visualize;
int target_index = mccdiffraction_detector_7_exit_volume_target_index;
MCNUM target_x = mccdiffraction_detector_7_exit_volume_target_x;
MCNUM target_y = mccdiffraction_detector_7_exit_volume_target_y;
MCNUM target_z = mccdiffraction_detector_7_exit_volume_target_z;
MCNUM focus_aw = mccdiffraction_detector_7_exit_volume_focus_aw;
MCNUM focus_ah = mccdiffraction_detector_7_exit_volume_focus_ah;
MCNUM focus_xw = mccdiffraction_detector_7_exit_volume_focus_xw;
MCNUM focus_xh = mccdiffraction_detector_7_exit_volume_focus_xh;
MCNUM focus_r = mccdiffraction_detector_7_exit_volume_focus_r;
MCNUM p_interact = mccdiffraction_detector_7_exit_volume_p_interact;
char* mask_string = mccdiffraction_detector_7_exit_volume_mask_string;
char* mask_setting = mccdiffraction_detector_7_exit_volume_mask_setting;
MCNUM number_of_activations = mccdiffraction_detector_7_exit_volume_number_of_activations;
}   /* End of diffraction_detector_7_exit_volume=Union_box() SETTING parameter declarations. */
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex
  /* Label for restoring  neutron */
  mcabsorbCompdiffraction_detector_7_exit_volume:
  if (RESTORE) /* restore if needed */
  { RESTORE_NEUTRON(426,
      mcnlx,
      mcnly,
      mcnlz,
      mcnlvx,
      mcnlvy,
      mcnlvz,
      mcnlt,
      mcnlsx,
      mcnlsy,
      mcnlsz,
      mcnlp); }
#undef mcabsorbComp
#undef p
#undef sz
#undef sy
#undef sx
#undef t
#undef vz
#undef vy
#undef vx
#undef z
#undef y
#undef x
  mcDEBUG_STATE(
mcnlx,
mcnly,
mcnlz,
mcnlvx,
mcnlvy,
mcnlvz,
mcnlt,
mcnlsx,
mcnlsy,
mcnlsz,
mcnlp)

  /* TRACE Component spec_detector_7_exit_volume [427] */
  mccoordschange(mcposrspec_detector_7_exit_volume, mcrotrspec_detector_7_exit_volume,
    &mcnlx,
    &mcnly,
    &mcnlz,
    &mcnlvx,
    &mcnlvy,
    &mcnlvz,
    &mcnlsx,
    &mcnlsy,
    &mcnlsz);
  /* define label inside component spec_detector_7_exit_volume (without coords transformations) */
  mcJumpTrace_spec_detector_7_exit_volume:
  SIG_MESSAGE("spec_detector_7_exit_volume (Trace)");
  mcDEBUG_COMP("spec_detector_7_exit_volume")
  mcDEBUG_STATE(
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp)
#define x mcnlx
#define y mcnly
#define z mcnlz
#define vx mcnlvx
#define vy mcnlvy
#define vz mcnlvz
#define t mcnlt
#define sx mcnlsx
#define sy mcnlsy
#define sz mcnlsz
#define p mcnlp

#define mcabsorbComp mcabsorbCompspec_detector_7_exit_volume
  STORE_NEUTRON(427,
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp);
  mcScattered=0;
  mcRestore=0;
  mcNCounter[427]++;
  mcPCounter[427] += p;
  mcP2Counter[427] += p*p;
#define mccompcurname  spec_detector_7_exit_volume
#define mccompcurtype  Union_box
#define mccompcurindex 427
#define loop_index mccspec_detector_7_exit_volume_loop_index
#define this_box_volume mccspec_detector_7_exit_volume_this_box_volume
#define global_geometry_element mccspec_detector_7_exit_volume_global_geometry_element
#define this_box_storage mccspec_detector_7_exit_volume_this_box_storage
{   /* Declarations of spec_detector_7_exit_volume=Union_box() SETTING parameters. */
char* material_string = mccspec_detector_7_exit_volume_material_string;
MCNUM priority = mccspec_detector_7_exit_volume_priority;
MCNUM xwidth = mccspec_detector_7_exit_volume_xwidth;
MCNUM yheight = mccspec_detector_7_exit_volume_yheight;
MCNUM zdepth = mccspec_detector_7_exit_volume_zdepth;
MCNUM xwidth2 = mccspec_detector_7_exit_volume_xwidth2;
MCNUM yheight2 = mccspec_detector_7_exit_volume_yheight2;
MCNUM visualize = mccspec_detector_7_exit_volume_visualize;
int target_index = mccspec_detector_7_exit_volume_target_index;
MCNUM target_x = mccspec_detector_7_exit_volume_target_x;
MCNUM target_y = mccspec_detector_7_exit_volume_target_y;
MCNUM target_z = mccspec_detector_7_exit_volume_target_z;
MCNUM focus_aw = mccspec_detector_7_exit_volume_focus_aw;
MCNUM focus_ah = mccspec_detector_7_exit_volume_focus_ah;
MCNUM focus_xw = mccspec_detector_7_exit_volume_focus_xw;
MCNUM focus_xh = mccspec_detector_7_exit_volume_focus_xh;
MCNUM focus_r = mccspec_detector_7_exit_volume_focus_r;
MCNUM p_interact = mccspec_detector_7_exit_volume_p_interact;
char* mask_string = mccspec_detector_7_exit_volume_mask_string;
char* mask_setting = mccspec_detector_7_exit_volume_mask_setting;
MCNUM number_of_activations = mccspec_detector_7_exit_volume_number_of_activations;
}   /* End of spec_detector_7_exit_volume=Union_box() SETTING parameter declarations. */
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex
  /* Label for restoring  neutron */
  mcabsorbCompspec_detector_7_exit_volume:
  if (RESTORE) /* restore if needed */
  { RESTORE_NEUTRON(427,
      mcnlx,
      mcnly,
      mcnlz,
      mcnlvx,
      mcnlvy,
      mcnlvz,
      mcnlt,
      mcnlsx,
      mcnlsy,
      mcnlsz,
      mcnlp); }
#undef mcabsorbComp
#undef p
#undef sz
#undef sy
#undef sx
#undef t
#undef vz
#undef vy
#undef vx
#undef z
#undef y
#undef x
  mcDEBUG_STATE(
mcnlx,
mcnly,
mcnlz,
mcnlvx,
mcnlvy,
mcnlvz,
mcnlt,
mcnlsx,
mcnlsy,
mcnlsz,
mcnlp)

  /* TRACE Component channel_8_cave1_box1 [428] */
  mccoordschange(mcposrchannel_8_cave1_box1, mcrotrchannel_8_cave1_box1,
    &mcnlx,
    &mcnly,
    &mcnlz,
    &mcnlvx,
    &mcnlvy,
    &mcnlvz,
    &mcnlsx,
    &mcnlsy,
    &mcnlsz);
  /* define label inside component channel_8_cave1_box1 (without coords transformations) */
  mcJumpTrace_channel_8_cave1_box1:
  SIG_MESSAGE("channel_8_cave1_box1 (Trace)");
  mcDEBUG_COMP("channel_8_cave1_box1")
  mcDEBUG_STATE(
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp)
#define x mcnlx
#define y mcnly
#define z mcnlz
#define vx mcnlvx
#define vy mcnlvy
#define vz mcnlvz
#define t mcnlt
#define sx mcnlsx
#define sy mcnlsy
#define sz mcnlsz
#define p mcnlp

#define mcabsorbComp mcabsorbCompchannel_8_cave1_box1
  STORE_NEUTRON(428,
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp);
  mcScattered=0;
  mcRestore=0;
  mcNCounter[428]++;
  mcPCounter[428] += p;
  mcP2Counter[428] += p*p;
#define mccompcurname  channel_8_cave1_box1
#define mccompcurtype  Union_box
#define mccompcurindex 428
#define loop_index mccchannel_8_cave1_box1_loop_index
#define this_box_volume mccchannel_8_cave1_box1_this_box_volume
#define global_geometry_element mccchannel_8_cave1_box1_global_geometry_element
#define this_box_storage mccchannel_8_cave1_box1_this_box_storage
{   /* Declarations of channel_8_cave1_box1=Union_box() SETTING parameters. */
char* material_string = mccchannel_8_cave1_box1_material_string;
MCNUM priority = mccchannel_8_cave1_box1_priority;
MCNUM xwidth = mccchannel_8_cave1_box1_xwidth;
MCNUM yheight = mccchannel_8_cave1_box1_yheight;
MCNUM zdepth = mccchannel_8_cave1_box1_zdepth;
MCNUM xwidth2 = mccchannel_8_cave1_box1_xwidth2;
MCNUM yheight2 = mccchannel_8_cave1_box1_yheight2;
MCNUM visualize = mccchannel_8_cave1_box1_visualize;
int target_index = mccchannel_8_cave1_box1_target_index;
MCNUM target_x = mccchannel_8_cave1_box1_target_x;
MCNUM target_y = mccchannel_8_cave1_box1_target_y;
MCNUM target_z = mccchannel_8_cave1_box1_target_z;
MCNUM focus_aw = mccchannel_8_cave1_box1_focus_aw;
MCNUM focus_ah = mccchannel_8_cave1_box1_focus_ah;
MCNUM focus_xw = mccchannel_8_cave1_box1_focus_xw;
MCNUM focus_xh = mccchannel_8_cave1_box1_focus_xh;
MCNUM focus_r = mccchannel_8_cave1_box1_focus_r;
MCNUM p_interact = mccchannel_8_cave1_box1_p_interact;
char* mask_string = mccchannel_8_cave1_box1_mask_string;
char* mask_setting = mccchannel_8_cave1_box1_mask_setting;
MCNUM number_of_activations = mccchannel_8_cave1_box1_number_of_activations;
}   /* End of channel_8_cave1_box1=Union_box() SETTING parameter declarations. */
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex
  /* Label for restoring  neutron */
  mcabsorbCompchannel_8_cave1_box1:
  if (RESTORE) /* restore if needed */
  { RESTORE_NEUTRON(428,
      mcnlx,
      mcnly,
      mcnlz,
      mcnlvx,
      mcnlvy,
      mcnlvz,
      mcnlt,
      mcnlsx,
      mcnlsy,
      mcnlsz,
      mcnlp); }
#undef mcabsorbComp
#undef p
#undef sz
#undef sy
#undef sx
#undef t
#undef vz
#undef vy
#undef vx
#undef z
#undef y
#undef x
  mcDEBUG_STATE(
mcnlx,
mcnly,
mcnlz,
mcnlvx,
mcnlvy,
mcnlvz,
mcnlt,
mcnlsx,
mcnlsy,
mcnlsz,
mcnlp)

  /* TRACE Component channel_8_cave1_box2 [429] */
  mccoordschange(mcposrchannel_8_cave1_box2, mcrotrchannel_8_cave1_box2,
    &mcnlx,
    &mcnly,
    &mcnlz,
    &mcnlvx,
    &mcnlvy,
    &mcnlvz,
    &mcnlsx,
    &mcnlsy,
    &mcnlsz);
  /* define label inside component channel_8_cave1_box2 (without coords transformations) */
  mcJumpTrace_channel_8_cave1_box2:
  SIG_MESSAGE("channel_8_cave1_box2 (Trace)");
  mcDEBUG_COMP("channel_8_cave1_box2")
  mcDEBUG_STATE(
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp)
#define x mcnlx
#define y mcnly
#define z mcnlz
#define vx mcnlvx
#define vy mcnlvy
#define vz mcnlvz
#define t mcnlt
#define sx mcnlsx
#define sy mcnlsy
#define sz mcnlsz
#define p mcnlp

#define mcabsorbComp mcabsorbCompchannel_8_cave1_box2
  STORE_NEUTRON(429,
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp);
  mcScattered=0;
  mcRestore=0;
  mcNCounter[429]++;
  mcPCounter[429] += p;
  mcP2Counter[429] += p*p;
#define mccompcurname  channel_8_cave1_box2
#define mccompcurtype  Union_box
#define mccompcurindex 429
#define loop_index mccchannel_8_cave1_box2_loop_index
#define this_box_volume mccchannel_8_cave1_box2_this_box_volume
#define global_geometry_element mccchannel_8_cave1_box2_global_geometry_element
#define this_box_storage mccchannel_8_cave1_box2_this_box_storage
{   /* Declarations of channel_8_cave1_box2=Union_box() SETTING parameters. */
char* material_string = mccchannel_8_cave1_box2_material_string;
MCNUM priority = mccchannel_8_cave1_box2_priority;
MCNUM xwidth = mccchannel_8_cave1_box2_xwidth;
MCNUM yheight = mccchannel_8_cave1_box2_yheight;
MCNUM zdepth = mccchannel_8_cave1_box2_zdepth;
MCNUM xwidth2 = mccchannel_8_cave1_box2_xwidth2;
MCNUM yheight2 = mccchannel_8_cave1_box2_yheight2;
MCNUM visualize = mccchannel_8_cave1_box2_visualize;
int target_index = mccchannel_8_cave1_box2_target_index;
MCNUM target_x = mccchannel_8_cave1_box2_target_x;
MCNUM target_y = mccchannel_8_cave1_box2_target_y;
MCNUM target_z = mccchannel_8_cave1_box2_target_z;
MCNUM focus_aw = mccchannel_8_cave1_box2_focus_aw;
MCNUM focus_ah = mccchannel_8_cave1_box2_focus_ah;
MCNUM focus_xw = mccchannel_8_cave1_box2_focus_xw;
MCNUM focus_xh = mccchannel_8_cave1_box2_focus_xh;
MCNUM focus_r = mccchannel_8_cave1_box2_focus_r;
MCNUM p_interact = mccchannel_8_cave1_box2_p_interact;
char* mask_string = mccchannel_8_cave1_box2_mask_string;
char* mask_setting = mccchannel_8_cave1_box2_mask_setting;
MCNUM number_of_activations = mccchannel_8_cave1_box2_number_of_activations;
}   /* End of channel_8_cave1_box2=Union_box() SETTING parameter declarations. */
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex
  /* Label for restoring  neutron */
  mcabsorbCompchannel_8_cave1_box2:
  if (RESTORE) /* restore if needed */
  { RESTORE_NEUTRON(429,
      mcnlx,
      mcnly,
      mcnlz,
      mcnlvx,
      mcnlvy,
      mcnlvz,
      mcnlt,
      mcnlsx,
      mcnlsy,
      mcnlsz,
      mcnlp); }
#undef mcabsorbComp
#undef p
#undef sz
#undef sy
#undef sx
#undef t
#undef vz
#undef vy
#undef vx
#undef z
#undef y
#undef x
  mcDEBUG_STATE(
mcnlx,
mcnly,
mcnlz,
mcnlvx,
mcnlvy,
mcnlvz,
mcnlt,
mcnlsx,
mcnlsy,
mcnlsz,
mcnlp)

  /* TRACE Component channel_8_cave1_box3 [430] */
  mccoordschange(mcposrchannel_8_cave1_box3, mcrotrchannel_8_cave1_box3,
    &mcnlx,
    &mcnly,
    &mcnlz,
    &mcnlvx,
    &mcnlvy,
    &mcnlvz,
    &mcnlsx,
    &mcnlsy,
    &mcnlsz);
  /* define label inside component channel_8_cave1_box3 (without coords transformations) */
  mcJumpTrace_channel_8_cave1_box3:
  SIG_MESSAGE("channel_8_cave1_box3 (Trace)");
  mcDEBUG_COMP("channel_8_cave1_box3")
  mcDEBUG_STATE(
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp)
#define x mcnlx
#define y mcnly
#define z mcnlz
#define vx mcnlvx
#define vy mcnlvy
#define vz mcnlvz
#define t mcnlt
#define sx mcnlsx
#define sy mcnlsy
#define sz mcnlsz
#define p mcnlp

#define mcabsorbComp mcabsorbCompchannel_8_cave1_box3
  STORE_NEUTRON(430,
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp);
  mcScattered=0;
  mcRestore=0;
  mcNCounter[430]++;
  mcPCounter[430] += p;
  mcP2Counter[430] += p*p;
#define mccompcurname  channel_8_cave1_box3
#define mccompcurtype  Union_box
#define mccompcurindex 430
#define loop_index mccchannel_8_cave1_box3_loop_index
#define this_box_volume mccchannel_8_cave1_box3_this_box_volume
#define global_geometry_element mccchannel_8_cave1_box3_global_geometry_element
#define this_box_storage mccchannel_8_cave1_box3_this_box_storage
{   /* Declarations of channel_8_cave1_box3=Union_box() SETTING parameters. */
char* material_string = mccchannel_8_cave1_box3_material_string;
MCNUM priority = mccchannel_8_cave1_box3_priority;
MCNUM xwidth = mccchannel_8_cave1_box3_xwidth;
MCNUM yheight = mccchannel_8_cave1_box3_yheight;
MCNUM zdepth = mccchannel_8_cave1_box3_zdepth;
MCNUM xwidth2 = mccchannel_8_cave1_box3_xwidth2;
MCNUM yheight2 = mccchannel_8_cave1_box3_yheight2;
MCNUM visualize = mccchannel_8_cave1_box3_visualize;
int target_index = mccchannel_8_cave1_box3_target_index;
MCNUM target_x = mccchannel_8_cave1_box3_target_x;
MCNUM target_y = mccchannel_8_cave1_box3_target_y;
MCNUM target_z = mccchannel_8_cave1_box3_target_z;
MCNUM focus_aw = mccchannel_8_cave1_box3_focus_aw;
MCNUM focus_ah = mccchannel_8_cave1_box3_focus_ah;
MCNUM focus_xw = mccchannel_8_cave1_box3_focus_xw;
MCNUM focus_xh = mccchannel_8_cave1_box3_focus_xh;
MCNUM focus_r = mccchannel_8_cave1_box3_focus_r;
MCNUM p_interact = mccchannel_8_cave1_box3_p_interact;
char* mask_string = mccchannel_8_cave1_box3_mask_string;
char* mask_setting = mccchannel_8_cave1_box3_mask_setting;
MCNUM number_of_activations = mccchannel_8_cave1_box3_number_of_activations;
}   /* End of channel_8_cave1_box3=Union_box() SETTING parameter declarations. */
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex
  /* Label for restoring  neutron */
  mcabsorbCompchannel_8_cave1_box3:
  if (RESTORE) /* restore if needed */
  { RESTORE_NEUTRON(430,
      mcnlx,
      mcnly,
      mcnlz,
      mcnlvx,
      mcnlvy,
      mcnlvz,
      mcnlt,
      mcnlsx,
      mcnlsy,
      mcnlsz,
      mcnlp); }
#undef mcabsorbComp
#undef p
#undef sz
#undef sy
#undef sx
#undef t
#undef vz
#undef vy
#undef vx
#undef z
#undef y
#undef x
  mcDEBUG_STATE(
mcnlx,
mcnly,
mcnlz,
mcnlvx,
mcnlvy,
mcnlvz,
mcnlt,
mcnlsx,
mcnlsy,
mcnlsz,
mcnlp)

  /* TRACE Component channel_8_cave1_cyl1 [431] */
  mccoordschange(mcposrchannel_8_cave1_cyl1, mcrotrchannel_8_cave1_cyl1,
    &mcnlx,
    &mcnly,
    &mcnlz,
    &mcnlvx,
    &mcnlvy,
    &mcnlvz,
    &mcnlsx,
    &mcnlsy,
    &mcnlsz);
  /* define label inside component channel_8_cave1_cyl1 (without coords transformations) */
  mcJumpTrace_channel_8_cave1_cyl1:
  SIG_MESSAGE("channel_8_cave1_cyl1 (Trace)");
  mcDEBUG_COMP("channel_8_cave1_cyl1")
  mcDEBUG_STATE(
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp)
#define x mcnlx
#define y mcnly
#define z mcnlz
#define vx mcnlvx
#define vy mcnlvy
#define vz mcnlvz
#define t mcnlt
#define sx mcnlsx
#define sy mcnlsy
#define sz mcnlsz
#define p mcnlp

#define mcabsorbComp mcabsorbCompchannel_8_cave1_cyl1
  STORE_NEUTRON(431,
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp);
  mcScattered=0;
  mcRestore=0;
  mcNCounter[431]++;
  mcPCounter[431] += p;
  mcP2Counter[431] += p*p;
#define mccompcurname  channel_8_cave1_cyl1
#define mccompcurtype  Union_cylinder
#define mccompcurindex 431
#define loop_index mccchannel_8_cave1_cyl1_loop_index
#define this_cylinder_volume mccchannel_8_cave1_cyl1_this_cylinder_volume
#define global_geometry_element mccchannel_8_cave1_cyl1_global_geometry_element
#define this_cylinder_storage mccchannel_8_cave1_cyl1_this_cylinder_storage
{   /* Declarations of channel_8_cave1_cyl1=Union_cylinder() SETTING parameters. */
char* material_string = mccchannel_8_cave1_cyl1_material_string;
MCNUM priority = mccchannel_8_cave1_cyl1_priority;
MCNUM radius = mccchannel_8_cave1_cyl1_radius;
MCNUM yheight = mccchannel_8_cave1_cyl1_yheight;
MCNUM visualize = mccchannel_8_cave1_cyl1_visualize;
int target_index = mccchannel_8_cave1_cyl1_target_index;
MCNUM target_x = mccchannel_8_cave1_cyl1_target_x;
MCNUM target_y = mccchannel_8_cave1_cyl1_target_y;
MCNUM target_z = mccchannel_8_cave1_cyl1_target_z;
MCNUM focus_aw = mccchannel_8_cave1_cyl1_focus_aw;
MCNUM focus_ah = mccchannel_8_cave1_cyl1_focus_ah;
MCNUM focus_xw = mccchannel_8_cave1_cyl1_focus_xw;
MCNUM focus_xh = mccchannel_8_cave1_cyl1_focus_xh;
MCNUM focus_r = mccchannel_8_cave1_cyl1_focus_r;
MCNUM p_interact = mccchannel_8_cave1_cyl1_p_interact;
char* mask_string = mccchannel_8_cave1_cyl1_mask_string;
char* mask_setting = mccchannel_8_cave1_cyl1_mask_setting;
MCNUM number_of_activations = mccchannel_8_cave1_cyl1_number_of_activations;
#line 345 "Union_cylinder.comp"
{
dummy = 1;
}
#line 402586 "MACS_sample_kidney_box.c"
}   /* End of channel_8_cave1_cyl1=Union_cylinder() SETTING parameter declarations. */
#undef this_cylinder_storage
#undef global_geometry_element
#undef this_cylinder_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex
  /* Label for restoring  neutron */
  mcabsorbCompchannel_8_cave1_cyl1:
  if (RESTORE) /* restore if needed */
  { RESTORE_NEUTRON(431,
      mcnlx,
      mcnly,
      mcnlz,
      mcnlvx,
      mcnlvy,
      mcnlvz,
      mcnlt,
      mcnlsx,
      mcnlsy,
      mcnlsz,
      mcnlp); }
#undef mcabsorbComp
#undef p
#undef sz
#undef sy
#undef sx
#undef t
#undef vz
#undef vy
#undef vx
#undef z
#undef y
#undef x
  mcDEBUG_STATE(
mcnlx,
mcnly,
mcnlz,
mcnlvx,
mcnlvy,
mcnlvz,
mcnlt,
mcnlsx,
mcnlsy,
mcnlsz,
mcnlp)

  /* TRACE Component channel_8_analyzer_1_center [432] */
  mccoordschange(mcposrchannel_8_analyzer_1_center, mcrotrchannel_8_analyzer_1_center,
    &mcnlx,
    &mcnly,
    &mcnlz,
    &mcnlvx,
    &mcnlvy,
    &mcnlvz,
    &mcnlsx,
    &mcnlsy,
    &mcnlsz);
  /* define label inside component channel_8_analyzer_1_center (without coords transformations) */
  mcJumpTrace_channel_8_analyzer_1_center:
  SIG_MESSAGE("channel_8_analyzer_1_center (Trace)");
  mcDEBUG_COMP("channel_8_analyzer_1_center")
  mcDEBUG_STATE(
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp)
#define x mcnlx
#define y mcnly
#define z mcnlz
#define vx mcnlvx
#define vy mcnlvy
#define vz mcnlvz
#define t mcnlt
#define sx mcnlsx
#define sy mcnlsy
#define sz mcnlsz
#define p mcnlp

#define mcabsorbComp mcabsorbCompchannel_8_analyzer_1_center
  STORE_NEUTRON(432,
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp);
  mcScattered=0;
  mcRestore=0;
  mcNCounter[432]++;
  mcPCounter[432] += p;
  mcP2Counter[432] += p*p;
#define mccompcurname  channel_8_analyzer_1_center
#define mccompcurtype  Arm
#define mccompcurindex 432
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex
  /* Label for restoring  neutron */
  mcabsorbCompchannel_8_analyzer_1_center:
  if (RESTORE) /* restore if needed */
  { RESTORE_NEUTRON(432,
      mcnlx,
      mcnly,
      mcnlz,
      mcnlvx,
      mcnlvy,
      mcnlvz,
      mcnlt,
      mcnlsx,
      mcnlsy,
      mcnlsz,
      mcnlp); }
#undef mcabsorbComp
#undef p
#undef sz
#undef sy
#undef sx
#undef t
#undef vz
#undef vy
#undef vx
#undef z
#undef y
#undef x
  mcDEBUG_STATE(
mcnlx,
mcnly,
mcnlz,
mcnlvx,
mcnlvy,
mcnlvz,
mcnlt,
mcnlsx,
mcnlsy,
mcnlsz,
mcnlp)

  /* TRACE Component channel_8_analyzer_1_rotated [433] */
  mccoordschange(mcposrchannel_8_analyzer_1_rotated, mcrotrchannel_8_analyzer_1_rotated,
    &mcnlx,
    &mcnly,
    &mcnlz,
    &mcnlvx,
    &mcnlvy,
    &mcnlvz,
    &mcnlsx,
    &mcnlsy,
    &mcnlsz);
  /* define label inside component channel_8_analyzer_1_rotated (without coords transformations) */
  mcJumpTrace_channel_8_analyzer_1_rotated:
  SIG_MESSAGE("channel_8_analyzer_1_rotated (Trace)");
  mcDEBUG_COMP("channel_8_analyzer_1_rotated")
  mcDEBUG_STATE(
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp)
#define x mcnlx
#define y mcnly
#define z mcnlz
#define vx mcnlvx
#define vy mcnlvy
#define vz mcnlvz
#define t mcnlt
#define sx mcnlsx
#define sy mcnlsy
#define sz mcnlsz
#define p mcnlp

#define mcabsorbComp mcabsorbCompchannel_8_analyzer_1_rotated
  STORE_NEUTRON(433,
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp);
  mcScattered=0;
  mcRestore=0;
  mcNCounter[433]++;
  mcPCounter[433] += p;
  mcP2Counter[433] += p*p;
#define mccompcurname  channel_8_analyzer_1_rotated
#define mccompcurtype  Arm
#define mccompcurindex 433
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex
  /* Label for restoring  neutron */
  mcabsorbCompchannel_8_analyzer_1_rotated:
  if (RESTORE) /* restore if needed */
  { RESTORE_NEUTRON(433,
      mcnlx,
      mcnly,
      mcnlz,
      mcnlvx,
      mcnlvy,
      mcnlvz,
      mcnlt,
      mcnlsx,
      mcnlsy,
      mcnlsz,
      mcnlp); }
#undef mcabsorbComp
#undef p
#undef sz
#undef sy
#undef sx
#undef t
#undef vz
#undef vy
#undef vx
#undef z
#undef y
#undef x
  mcDEBUG_STATE(
mcnlx,
mcnly,
mcnlz,
mcnlvx,
mcnlvy,
mcnlvz,
mcnlt,
mcnlsx,
mcnlsy,
mcnlsz,
mcnlp)

  /* TRACE Component channel_8_analyzer_1_array_crystal_array_0 [434] */
  mccoordschange(mcposrchannel_8_analyzer_1_array_crystal_array_0, mcrotrchannel_8_analyzer_1_array_crystal_array_0,
    &mcnlx,
    &mcnly,
    &mcnlz,
    &mcnlvx,
    &mcnlvy,
    &mcnlvz,
    &mcnlsx,
    &mcnlsy,
    &mcnlsz);
  /* define label inside component channel_8_analyzer_1_array_crystal_array_0 (without coords transformations) */
  mcJumpTrace_channel_8_analyzer_1_array_crystal_array_0:
  SIG_MESSAGE("channel_8_analyzer_1_array_crystal_array_0 (Trace)");
  mcDEBUG_COMP("channel_8_analyzer_1_array_crystal_array_0")
  mcDEBUG_STATE(
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp)
#define x mcnlx
#define y mcnly
#define z mcnlz
#define vx mcnlvx
#define vy mcnlvy
#define vz mcnlvz
#define t mcnlt
#define sx mcnlsx
#define sy mcnlsy
#define sz mcnlsz
#define p mcnlp

#define mcabsorbComp mcabsorbCompchannel_8_analyzer_1_array_crystal_array_0
  STORE_NEUTRON(434,
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp);
  mcScattered=0;
  mcRestore=0;
  mcNCounter[434]++;
  mcPCounter[434] += p;
  mcP2Counter[434] += p*p;
#define mccompcurname  channel_8_analyzer_1_array_crystal_array_0
#define mccompcurtype  Union_box
#define mccompcurindex 434
#define loop_index mccchannel_8_analyzer_1_array_crystal_array_0_loop_index
#define this_box_volume mccchannel_8_analyzer_1_array_crystal_array_0_this_box_volume
#define global_geometry_element mccchannel_8_analyzer_1_array_crystal_array_0_global_geometry_element
#define this_box_storage mccchannel_8_analyzer_1_array_crystal_array_0_this_box_storage
{   /* Declarations of channel_8_analyzer_1_array_crystal_array_0=Union_box() SETTING parameters. */
char* material_string = mccchannel_8_analyzer_1_array_crystal_array_0_material_string;
MCNUM priority = mccchannel_8_analyzer_1_array_crystal_array_0_priority;
MCNUM xwidth = mccchannel_8_analyzer_1_array_crystal_array_0_xwidth;
MCNUM yheight = mccchannel_8_analyzer_1_array_crystal_array_0_yheight;
MCNUM zdepth = mccchannel_8_analyzer_1_array_crystal_array_0_zdepth;
MCNUM xwidth2 = mccchannel_8_analyzer_1_array_crystal_array_0_xwidth2;
MCNUM yheight2 = mccchannel_8_analyzer_1_array_crystal_array_0_yheight2;
MCNUM visualize = mccchannel_8_analyzer_1_array_crystal_array_0_visualize;
int target_index = mccchannel_8_analyzer_1_array_crystal_array_0_target_index;
MCNUM target_x = mccchannel_8_analyzer_1_array_crystal_array_0_target_x;
MCNUM target_y = mccchannel_8_analyzer_1_array_crystal_array_0_target_y;
MCNUM target_z = mccchannel_8_analyzer_1_array_crystal_array_0_target_z;
MCNUM focus_aw = mccchannel_8_analyzer_1_array_crystal_array_0_focus_aw;
MCNUM focus_ah = mccchannel_8_analyzer_1_array_crystal_array_0_focus_ah;
MCNUM focus_xw = mccchannel_8_analyzer_1_array_crystal_array_0_focus_xw;
MCNUM focus_xh = mccchannel_8_analyzer_1_array_crystal_array_0_focus_xh;
MCNUM focus_r = mccchannel_8_analyzer_1_array_crystal_array_0_focus_r;
MCNUM p_interact = mccchannel_8_analyzer_1_array_crystal_array_0_p_interact;
char* mask_string = mccchannel_8_analyzer_1_array_crystal_array_0_mask_string;
char* mask_setting = mccchannel_8_analyzer_1_array_crystal_array_0_mask_setting;
MCNUM number_of_activations = mccchannel_8_analyzer_1_array_crystal_array_0_number_of_activations;
}   /* End of channel_8_analyzer_1_array_crystal_array_0=Union_box() SETTING parameter declarations. */
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex
  /* Label for restoring  neutron */
  mcabsorbCompchannel_8_analyzer_1_array_crystal_array_0:
  if (RESTORE) /* restore if needed */
  { RESTORE_NEUTRON(434,
      mcnlx,
      mcnly,
      mcnlz,
      mcnlvx,
      mcnlvy,
      mcnlvz,
      mcnlt,
      mcnlsx,
      mcnlsy,
      mcnlsz,
      mcnlp); }
#undef mcabsorbComp
#undef p
#undef sz
#undef sy
#undef sx
#undef t
#undef vz
#undef vy
#undef vx
#undef z
#undef y
#undef x
  mcDEBUG_STATE(
mcnlx,
mcnly,
mcnlz,
mcnlvx,
mcnlvy,
mcnlvz,
mcnlt,
mcnlsx,
mcnlsy,
mcnlsz,
mcnlp)

  /* TRACE Component channel_8_analyzer_1_array_crystal_array_1 [435] */
  mccoordschange(mcposrchannel_8_analyzer_1_array_crystal_array_1, mcrotrchannel_8_analyzer_1_array_crystal_array_1,
    &mcnlx,
    &mcnly,
    &mcnlz,
    &mcnlvx,
    &mcnlvy,
    &mcnlvz,
    &mcnlsx,
    &mcnlsy,
    &mcnlsz);
  /* define label inside component channel_8_analyzer_1_array_crystal_array_1 (without coords transformations) */
  mcJumpTrace_channel_8_analyzer_1_array_crystal_array_1:
  SIG_MESSAGE("channel_8_analyzer_1_array_crystal_array_1 (Trace)");
  mcDEBUG_COMP("channel_8_analyzer_1_array_crystal_array_1")
  mcDEBUG_STATE(
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp)
#define x mcnlx
#define y mcnly
#define z mcnlz
#define vx mcnlvx
#define vy mcnlvy
#define vz mcnlvz
#define t mcnlt
#define sx mcnlsx
#define sy mcnlsy
#define sz mcnlsz
#define p mcnlp

#define mcabsorbComp mcabsorbCompchannel_8_analyzer_1_array_crystal_array_1
  STORE_NEUTRON(435,
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp);
  mcScattered=0;
  mcRestore=0;
  mcNCounter[435]++;
  mcPCounter[435] += p;
  mcP2Counter[435] += p*p;
#define mccompcurname  channel_8_analyzer_1_array_crystal_array_1
#define mccompcurtype  Union_box
#define mccompcurindex 435
#define loop_index mccchannel_8_analyzer_1_array_crystal_array_1_loop_index
#define this_box_volume mccchannel_8_analyzer_1_array_crystal_array_1_this_box_volume
#define global_geometry_element mccchannel_8_analyzer_1_array_crystal_array_1_global_geometry_element
#define this_box_storage mccchannel_8_analyzer_1_array_crystal_array_1_this_box_storage
{   /* Declarations of channel_8_analyzer_1_array_crystal_array_1=Union_box() SETTING parameters. */
char* material_string = mccchannel_8_analyzer_1_array_crystal_array_1_material_string;
MCNUM priority = mccchannel_8_analyzer_1_array_crystal_array_1_priority;
MCNUM xwidth = mccchannel_8_analyzer_1_array_crystal_array_1_xwidth;
MCNUM yheight = mccchannel_8_analyzer_1_array_crystal_array_1_yheight;
MCNUM zdepth = mccchannel_8_analyzer_1_array_crystal_array_1_zdepth;
MCNUM xwidth2 = mccchannel_8_analyzer_1_array_crystal_array_1_xwidth2;
MCNUM yheight2 = mccchannel_8_analyzer_1_array_crystal_array_1_yheight2;
MCNUM visualize = mccchannel_8_analyzer_1_array_crystal_array_1_visualize;
int target_index = mccchannel_8_analyzer_1_array_crystal_array_1_target_index;
MCNUM target_x = mccchannel_8_analyzer_1_array_crystal_array_1_target_x;
MCNUM target_y = mccchannel_8_analyzer_1_array_crystal_array_1_target_y;
MCNUM target_z = mccchannel_8_analyzer_1_array_crystal_array_1_target_z;
MCNUM focus_aw = mccchannel_8_analyzer_1_array_crystal_array_1_focus_aw;
MCNUM focus_ah = mccchannel_8_analyzer_1_array_crystal_array_1_focus_ah;
MCNUM focus_xw = mccchannel_8_analyzer_1_array_crystal_array_1_focus_xw;
MCNUM focus_xh = mccchannel_8_analyzer_1_array_crystal_array_1_focus_xh;
MCNUM focus_r = mccchannel_8_analyzer_1_array_crystal_array_1_focus_r;
MCNUM p_interact = mccchannel_8_analyzer_1_array_crystal_array_1_p_interact;
char* mask_string = mccchannel_8_analyzer_1_array_crystal_array_1_mask_string;
char* mask_setting = mccchannel_8_analyzer_1_array_crystal_array_1_mask_setting;
MCNUM number_of_activations = mccchannel_8_analyzer_1_array_crystal_array_1_number_of_activations;
}   /* End of channel_8_analyzer_1_array_crystal_array_1=Union_box() SETTING parameter declarations. */
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex
  /* Label for restoring  neutron */
  mcabsorbCompchannel_8_analyzer_1_array_crystal_array_1:
  if (RESTORE) /* restore if needed */
  { RESTORE_NEUTRON(435,
      mcnlx,
      mcnly,
      mcnlz,
      mcnlvx,
      mcnlvy,
      mcnlvz,
      mcnlt,
      mcnlsx,
      mcnlsy,
      mcnlsz,
      mcnlp); }
#undef mcabsorbComp
#undef p
#undef sz
#undef sy
#undef sx
#undef t
#undef vz
#undef vy
#undef vx
#undef z
#undef y
#undef x
  mcDEBUG_STATE(
mcnlx,
mcnly,
mcnlz,
mcnlvx,
mcnlvy,
mcnlvz,
mcnlt,
mcnlsx,
mcnlsy,
mcnlsz,
mcnlp)

  /* TRACE Component channel_8_analyzer_1_array_crystal_array_2 [436] */
  mccoordschange(mcposrchannel_8_analyzer_1_array_crystal_array_2, mcrotrchannel_8_analyzer_1_array_crystal_array_2,
    &mcnlx,
    &mcnly,
    &mcnlz,
    &mcnlvx,
    &mcnlvy,
    &mcnlvz,
    &mcnlsx,
    &mcnlsy,
    &mcnlsz);
  /* define label inside component channel_8_analyzer_1_array_crystal_array_2 (without coords transformations) */
  mcJumpTrace_channel_8_analyzer_1_array_crystal_array_2:
  SIG_MESSAGE("channel_8_analyzer_1_array_crystal_array_2 (Trace)");
  mcDEBUG_COMP("channel_8_analyzer_1_array_crystal_array_2")
  mcDEBUG_STATE(
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp)
#define x mcnlx
#define y mcnly
#define z mcnlz
#define vx mcnlvx
#define vy mcnlvy
#define vz mcnlvz
#define t mcnlt
#define sx mcnlsx
#define sy mcnlsy
#define sz mcnlsz
#define p mcnlp

#define mcabsorbComp mcabsorbCompchannel_8_analyzer_1_array_crystal_array_2
  STORE_NEUTRON(436,
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp);
  mcScattered=0;
  mcRestore=0;
  mcNCounter[436]++;
  mcPCounter[436] += p;
  mcP2Counter[436] += p*p;
#define mccompcurname  channel_8_analyzer_1_array_crystal_array_2
#define mccompcurtype  Union_box
#define mccompcurindex 436
#define loop_index mccchannel_8_analyzer_1_array_crystal_array_2_loop_index
#define this_box_volume mccchannel_8_analyzer_1_array_crystal_array_2_this_box_volume
#define global_geometry_element mccchannel_8_analyzer_1_array_crystal_array_2_global_geometry_element
#define this_box_storage mccchannel_8_analyzer_1_array_crystal_array_2_this_box_storage
{   /* Declarations of channel_8_analyzer_1_array_crystal_array_2=Union_box() SETTING parameters. */
char* material_string = mccchannel_8_analyzer_1_array_crystal_array_2_material_string;
MCNUM priority = mccchannel_8_analyzer_1_array_crystal_array_2_priority;
MCNUM xwidth = mccchannel_8_analyzer_1_array_crystal_array_2_xwidth;
MCNUM yheight = mccchannel_8_analyzer_1_array_crystal_array_2_yheight;
MCNUM zdepth = mccchannel_8_analyzer_1_array_crystal_array_2_zdepth;
MCNUM xwidth2 = mccchannel_8_analyzer_1_array_crystal_array_2_xwidth2;
MCNUM yheight2 = mccchannel_8_analyzer_1_array_crystal_array_2_yheight2;
MCNUM visualize = mccchannel_8_analyzer_1_array_crystal_array_2_visualize;
int target_index = mccchannel_8_analyzer_1_array_crystal_array_2_target_index;
MCNUM target_x = mccchannel_8_analyzer_1_array_crystal_array_2_target_x;
MCNUM target_y = mccchannel_8_analyzer_1_array_crystal_array_2_target_y;
MCNUM target_z = mccchannel_8_analyzer_1_array_crystal_array_2_target_z;
MCNUM focus_aw = mccchannel_8_analyzer_1_array_crystal_array_2_focus_aw;
MCNUM focus_ah = mccchannel_8_analyzer_1_array_crystal_array_2_focus_ah;
MCNUM focus_xw = mccchannel_8_analyzer_1_array_crystal_array_2_focus_xw;
MCNUM focus_xh = mccchannel_8_analyzer_1_array_crystal_array_2_focus_xh;
MCNUM focus_r = mccchannel_8_analyzer_1_array_crystal_array_2_focus_r;
MCNUM p_interact = mccchannel_8_analyzer_1_array_crystal_array_2_p_interact;
char* mask_string = mccchannel_8_analyzer_1_array_crystal_array_2_mask_string;
char* mask_setting = mccchannel_8_analyzer_1_array_crystal_array_2_mask_setting;
MCNUM number_of_activations = mccchannel_8_analyzer_1_array_crystal_array_2_number_of_activations;
}   /* End of channel_8_analyzer_1_array_crystal_array_2=Union_box() SETTING parameter declarations. */
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex
  /* Label for restoring  neutron */
  mcabsorbCompchannel_8_analyzer_1_array_crystal_array_2:
  if (RESTORE) /* restore if needed */
  { RESTORE_NEUTRON(436,
      mcnlx,
      mcnly,
      mcnlz,
      mcnlvx,
      mcnlvy,
      mcnlvz,
      mcnlt,
      mcnlsx,
      mcnlsy,
      mcnlsz,
      mcnlp); }
#undef mcabsorbComp
#undef p
#undef sz
#undef sy
#undef sx
#undef t
#undef vz
#undef vy
#undef vx
#undef z
#undef y
#undef x
  mcDEBUG_STATE(
mcnlx,
mcnly,
mcnlz,
mcnlvx,
mcnlvy,
mcnlvz,
mcnlt,
mcnlsx,
mcnlsy,
mcnlsz,
mcnlp)

  /* TRACE Component channel_8_analyzer_1_array_crystal_array_3 [437] */
  mccoordschange(mcposrchannel_8_analyzer_1_array_crystal_array_3, mcrotrchannel_8_analyzer_1_array_crystal_array_3,
    &mcnlx,
    &mcnly,
    &mcnlz,
    &mcnlvx,
    &mcnlvy,
    &mcnlvz,
    &mcnlsx,
    &mcnlsy,
    &mcnlsz);
  /* define label inside component channel_8_analyzer_1_array_crystal_array_3 (without coords transformations) */
  mcJumpTrace_channel_8_analyzer_1_array_crystal_array_3:
  SIG_MESSAGE("channel_8_analyzer_1_array_crystal_array_3 (Trace)");
  mcDEBUG_COMP("channel_8_analyzer_1_array_crystal_array_3")
  mcDEBUG_STATE(
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp)
#define x mcnlx
#define y mcnly
#define z mcnlz
#define vx mcnlvx
#define vy mcnlvy
#define vz mcnlvz
#define t mcnlt
#define sx mcnlsx
#define sy mcnlsy
#define sz mcnlsz
#define p mcnlp

#define mcabsorbComp mcabsorbCompchannel_8_analyzer_1_array_crystal_array_3
  STORE_NEUTRON(437,
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp);
  mcScattered=0;
  mcRestore=0;
  mcNCounter[437]++;
  mcPCounter[437] += p;
  mcP2Counter[437] += p*p;
#define mccompcurname  channel_8_analyzer_1_array_crystal_array_3
#define mccompcurtype  Union_box
#define mccompcurindex 437
#define loop_index mccchannel_8_analyzer_1_array_crystal_array_3_loop_index
#define this_box_volume mccchannel_8_analyzer_1_array_crystal_array_3_this_box_volume
#define global_geometry_element mccchannel_8_analyzer_1_array_crystal_array_3_global_geometry_element
#define this_box_storage mccchannel_8_analyzer_1_array_crystal_array_3_this_box_storage
{   /* Declarations of channel_8_analyzer_1_array_crystal_array_3=Union_box() SETTING parameters. */
char* material_string = mccchannel_8_analyzer_1_array_crystal_array_3_material_string;
MCNUM priority = mccchannel_8_analyzer_1_array_crystal_array_3_priority;
MCNUM xwidth = mccchannel_8_analyzer_1_array_crystal_array_3_xwidth;
MCNUM yheight = mccchannel_8_analyzer_1_array_crystal_array_3_yheight;
MCNUM zdepth = mccchannel_8_analyzer_1_array_crystal_array_3_zdepth;
MCNUM xwidth2 = mccchannel_8_analyzer_1_array_crystal_array_3_xwidth2;
MCNUM yheight2 = mccchannel_8_analyzer_1_array_crystal_array_3_yheight2;
MCNUM visualize = mccchannel_8_analyzer_1_array_crystal_array_3_visualize;
int target_index = mccchannel_8_analyzer_1_array_crystal_array_3_target_index;
MCNUM target_x = mccchannel_8_analyzer_1_array_crystal_array_3_target_x;
MCNUM target_y = mccchannel_8_analyzer_1_array_crystal_array_3_target_y;
MCNUM target_z = mccchannel_8_analyzer_1_array_crystal_array_3_target_z;
MCNUM focus_aw = mccchannel_8_analyzer_1_array_crystal_array_3_focus_aw;
MCNUM focus_ah = mccchannel_8_analyzer_1_array_crystal_array_3_focus_ah;
MCNUM focus_xw = mccchannel_8_analyzer_1_array_crystal_array_3_focus_xw;
MCNUM focus_xh = mccchannel_8_analyzer_1_array_crystal_array_3_focus_xh;
MCNUM focus_r = mccchannel_8_analyzer_1_array_crystal_array_3_focus_r;
MCNUM p_interact = mccchannel_8_analyzer_1_array_crystal_array_3_p_interact;
char* mask_string = mccchannel_8_analyzer_1_array_crystal_array_3_mask_string;
char* mask_setting = mccchannel_8_analyzer_1_array_crystal_array_3_mask_setting;
MCNUM number_of_activations = mccchannel_8_analyzer_1_array_crystal_array_3_number_of_activations;
}   /* End of channel_8_analyzer_1_array_crystal_array_3=Union_box() SETTING parameter declarations. */
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex
  /* Label for restoring  neutron */
  mcabsorbCompchannel_8_analyzer_1_array_crystal_array_3:
  if (RESTORE) /* restore if needed */
  { RESTORE_NEUTRON(437,
      mcnlx,
      mcnly,
      mcnlz,
      mcnlvx,
      mcnlvy,
      mcnlvz,
      mcnlt,
      mcnlsx,
      mcnlsy,
      mcnlsz,
      mcnlp); }
#undef mcabsorbComp
#undef p
#undef sz
#undef sy
#undef sx
#undef t
#undef vz
#undef vy
#undef vx
#undef z
#undef y
#undef x
  mcDEBUG_STATE(
mcnlx,
mcnly,
mcnlz,
mcnlvx,
mcnlvy,
mcnlvz,
mcnlt,
mcnlsx,
mcnlsy,
mcnlsz,
mcnlp)

  /* TRACE Component channel_8_analyzer_1_array_crystal_array_4 [438] */
  mccoordschange(mcposrchannel_8_analyzer_1_array_crystal_array_4, mcrotrchannel_8_analyzer_1_array_crystal_array_4,
    &mcnlx,
    &mcnly,
    &mcnlz,
    &mcnlvx,
    &mcnlvy,
    &mcnlvz,
    &mcnlsx,
    &mcnlsy,
    &mcnlsz);
  /* define label inside component channel_8_analyzer_1_array_crystal_array_4 (without coords transformations) */
  mcJumpTrace_channel_8_analyzer_1_array_crystal_array_4:
  SIG_MESSAGE("channel_8_analyzer_1_array_crystal_array_4 (Trace)");
  mcDEBUG_COMP("channel_8_analyzer_1_array_crystal_array_4")
  mcDEBUG_STATE(
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp)
#define x mcnlx
#define y mcnly
#define z mcnlz
#define vx mcnlvx
#define vy mcnlvy
#define vz mcnlvz
#define t mcnlt
#define sx mcnlsx
#define sy mcnlsy
#define sz mcnlsz
#define p mcnlp

#define mcabsorbComp mcabsorbCompchannel_8_analyzer_1_array_crystal_array_4
  STORE_NEUTRON(438,
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp);
  mcScattered=0;
  mcRestore=0;
  mcNCounter[438]++;
  mcPCounter[438] += p;
  mcP2Counter[438] += p*p;
#define mccompcurname  channel_8_analyzer_1_array_crystal_array_4
#define mccompcurtype  Union_box
#define mccompcurindex 438
#define loop_index mccchannel_8_analyzer_1_array_crystal_array_4_loop_index
#define this_box_volume mccchannel_8_analyzer_1_array_crystal_array_4_this_box_volume
#define global_geometry_element mccchannel_8_analyzer_1_array_crystal_array_4_global_geometry_element
#define this_box_storage mccchannel_8_analyzer_1_array_crystal_array_4_this_box_storage
{   /* Declarations of channel_8_analyzer_1_array_crystal_array_4=Union_box() SETTING parameters. */
char* material_string = mccchannel_8_analyzer_1_array_crystal_array_4_material_string;
MCNUM priority = mccchannel_8_analyzer_1_array_crystal_array_4_priority;
MCNUM xwidth = mccchannel_8_analyzer_1_array_crystal_array_4_xwidth;
MCNUM yheight = mccchannel_8_analyzer_1_array_crystal_array_4_yheight;
MCNUM zdepth = mccchannel_8_analyzer_1_array_crystal_array_4_zdepth;
MCNUM xwidth2 = mccchannel_8_analyzer_1_array_crystal_array_4_xwidth2;
MCNUM yheight2 = mccchannel_8_analyzer_1_array_crystal_array_4_yheight2;
MCNUM visualize = mccchannel_8_analyzer_1_array_crystal_array_4_visualize;
int target_index = mccchannel_8_analyzer_1_array_crystal_array_4_target_index;
MCNUM target_x = mccchannel_8_analyzer_1_array_crystal_array_4_target_x;
MCNUM target_y = mccchannel_8_analyzer_1_array_crystal_array_4_target_y;
MCNUM target_z = mccchannel_8_analyzer_1_array_crystal_array_4_target_z;
MCNUM focus_aw = mccchannel_8_analyzer_1_array_crystal_array_4_focus_aw;
MCNUM focus_ah = mccchannel_8_analyzer_1_array_crystal_array_4_focus_ah;
MCNUM focus_xw = mccchannel_8_analyzer_1_array_crystal_array_4_focus_xw;
MCNUM focus_xh = mccchannel_8_analyzer_1_array_crystal_array_4_focus_xh;
MCNUM focus_r = mccchannel_8_analyzer_1_array_crystal_array_4_focus_r;
MCNUM p_interact = mccchannel_8_analyzer_1_array_crystal_array_4_p_interact;
char* mask_string = mccchannel_8_analyzer_1_array_crystal_array_4_mask_string;
char* mask_setting = mccchannel_8_analyzer_1_array_crystal_array_4_mask_setting;
MCNUM number_of_activations = mccchannel_8_analyzer_1_array_crystal_array_4_number_of_activations;
}   /* End of channel_8_analyzer_1_array_crystal_array_4=Union_box() SETTING parameter declarations. */
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex
  /* Label for restoring  neutron */
  mcabsorbCompchannel_8_analyzer_1_array_crystal_array_4:
  if (RESTORE) /* restore if needed */
  { RESTORE_NEUTRON(438,
      mcnlx,
      mcnly,
      mcnlz,
      mcnlvx,
      mcnlvy,
      mcnlvz,
      mcnlt,
      mcnlsx,
      mcnlsy,
      mcnlsz,
      mcnlp); }
#undef mcabsorbComp
#undef p
#undef sz
#undef sy
#undef sx
#undef t
#undef vz
#undef vy
#undef vx
#undef z
#undef y
#undef x
  mcDEBUG_STATE(
mcnlx,
mcnly,
mcnlz,
mcnlvx,
mcnlvy,
mcnlvz,
mcnlt,
mcnlsx,
mcnlsy,
mcnlsz,
mcnlp)

  /* TRACE Component channel_8_analyzer_1_array_crystal_array_5 [439] */
  mccoordschange(mcposrchannel_8_analyzer_1_array_crystal_array_5, mcrotrchannel_8_analyzer_1_array_crystal_array_5,
    &mcnlx,
    &mcnly,
    &mcnlz,
    &mcnlvx,
    &mcnlvy,
    &mcnlvz,
    &mcnlsx,
    &mcnlsy,
    &mcnlsz);
  /* define label inside component channel_8_analyzer_1_array_crystal_array_5 (without coords transformations) */
  mcJumpTrace_channel_8_analyzer_1_array_crystal_array_5:
  SIG_MESSAGE("channel_8_analyzer_1_array_crystal_array_5 (Trace)");
  mcDEBUG_COMP("channel_8_analyzer_1_array_crystal_array_5")
  mcDEBUG_STATE(
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp)
#define x mcnlx
#define y mcnly
#define z mcnlz
#define vx mcnlvx
#define vy mcnlvy
#define vz mcnlvz
#define t mcnlt
#define sx mcnlsx
#define sy mcnlsy
#define sz mcnlsz
#define p mcnlp

#define mcabsorbComp mcabsorbCompchannel_8_analyzer_1_array_crystal_array_5
  STORE_NEUTRON(439,
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp);
  mcScattered=0;
  mcRestore=0;
  mcNCounter[439]++;
  mcPCounter[439] += p;
  mcP2Counter[439] += p*p;
#define mccompcurname  channel_8_analyzer_1_array_crystal_array_5
#define mccompcurtype  Union_box
#define mccompcurindex 439
#define loop_index mccchannel_8_analyzer_1_array_crystal_array_5_loop_index
#define this_box_volume mccchannel_8_analyzer_1_array_crystal_array_5_this_box_volume
#define global_geometry_element mccchannel_8_analyzer_1_array_crystal_array_5_global_geometry_element
#define this_box_storage mccchannel_8_analyzer_1_array_crystal_array_5_this_box_storage
{   /* Declarations of channel_8_analyzer_1_array_crystal_array_5=Union_box() SETTING parameters. */
char* material_string = mccchannel_8_analyzer_1_array_crystal_array_5_material_string;
MCNUM priority = mccchannel_8_analyzer_1_array_crystal_array_5_priority;
MCNUM xwidth = mccchannel_8_analyzer_1_array_crystal_array_5_xwidth;
MCNUM yheight = mccchannel_8_analyzer_1_array_crystal_array_5_yheight;
MCNUM zdepth = mccchannel_8_analyzer_1_array_crystal_array_5_zdepth;
MCNUM xwidth2 = mccchannel_8_analyzer_1_array_crystal_array_5_xwidth2;
MCNUM yheight2 = mccchannel_8_analyzer_1_array_crystal_array_5_yheight2;
MCNUM visualize = mccchannel_8_analyzer_1_array_crystal_array_5_visualize;
int target_index = mccchannel_8_analyzer_1_array_crystal_array_5_target_index;
MCNUM target_x = mccchannel_8_analyzer_1_array_crystal_array_5_target_x;
MCNUM target_y = mccchannel_8_analyzer_1_array_crystal_array_5_target_y;
MCNUM target_z = mccchannel_8_analyzer_1_array_crystal_array_5_target_z;
MCNUM focus_aw = mccchannel_8_analyzer_1_array_crystal_array_5_focus_aw;
MCNUM focus_ah = mccchannel_8_analyzer_1_array_crystal_array_5_focus_ah;
MCNUM focus_xw = mccchannel_8_analyzer_1_array_crystal_array_5_focus_xw;
MCNUM focus_xh = mccchannel_8_analyzer_1_array_crystal_array_5_focus_xh;
MCNUM focus_r = mccchannel_8_analyzer_1_array_crystal_array_5_focus_r;
MCNUM p_interact = mccchannel_8_analyzer_1_array_crystal_array_5_p_interact;
char* mask_string = mccchannel_8_analyzer_1_array_crystal_array_5_mask_string;
char* mask_setting = mccchannel_8_analyzer_1_array_crystal_array_5_mask_setting;
MCNUM number_of_activations = mccchannel_8_analyzer_1_array_crystal_array_5_number_of_activations;
}   /* End of channel_8_analyzer_1_array_crystal_array_5=Union_box() SETTING parameter declarations. */
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex
  /* Label for restoring  neutron */
  mcabsorbCompchannel_8_analyzer_1_array_crystal_array_5:
  if (RESTORE) /* restore if needed */
  { RESTORE_NEUTRON(439,
      mcnlx,
      mcnly,
      mcnlz,
      mcnlvx,
      mcnlvy,
      mcnlvz,
      mcnlt,
      mcnlsx,
      mcnlsy,
      mcnlsz,
      mcnlp); }
#undef mcabsorbComp
#undef p
#undef sz
#undef sy
#undef sx
#undef t
#undef vz
#undef vy
#undef vx
#undef z
#undef y
#undef x
  mcDEBUG_STATE(
mcnlx,
mcnly,
mcnlz,
mcnlvx,
mcnlvy,
mcnlvz,
mcnlt,
mcnlsx,
mcnlsy,
mcnlsz,
mcnlp)

  /* TRACE Component channel_8_analyzer_1_array_crystal_array_6 [440] */
  mccoordschange(mcposrchannel_8_analyzer_1_array_crystal_array_6, mcrotrchannel_8_analyzer_1_array_crystal_array_6,
    &mcnlx,
    &mcnly,
    &mcnlz,
    &mcnlvx,
    &mcnlvy,
    &mcnlvz,
    &mcnlsx,
    &mcnlsy,
    &mcnlsz);
  /* define label inside component channel_8_analyzer_1_array_crystal_array_6 (without coords transformations) */
  mcJumpTrace_channel_8_analyzer_1_array_crystal_array_6:
  SIG_MESSAGE("channel_8_analyzer_1_array_crystal_array_6 (Trace)");
  mcDEBUG_COMP("channel_8_analyzer_1_array_crystal_array_6")
  mcDEBUG_STATE(
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp)
#define x mcnlx
#define y mcnly
#define z mcnlz
#define vx mcnlvx
#define vy mcnlvy
#define vz mcnlvz
#define t mcnlt
#define sx mcnlsx
#define sy mcnlsy
#define sz mcnlsz
#define p mcnlp

#define mcabsorbComp mcabsorbCompchannel_8_analyzer_1_array_crystal_array_6
  STORE_NEUTRON(440,
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp);
  mcScattered=0;
  mcRestore=0;
  mcNCounter[440]++;
  mcPCounter[440] += p;
  mcP2Counter[440] += p*p;
#define mccompcurname  channel_8_analyzer_1_array_crystal_array_6
#define mccompcurtype  Union_box
#define mccompcurindex 440
#define loop_index mccchannel_8_analyzer_1_array_crystal_array_6_loop_index
#define this_box_volume mccchannel_8_analyzer_1_array_crystal_array_6_this_box_volume
#define global_geometry_element mccchannel_8_analyzer_1_array_crystal_array_6_global_geometry_element
#define this_box_storage mccchannel_8_analyzer_1_array_crystal_array_6_this_box_storage
{   /* Declarations of channel_8_analyzer_1_array_crystal_array_6=Union_box() SETTING parameters. */
char* material_string = mccchannel_8_analyzer_1_array_crystal_array_6_material_string;
MCNUM priority = mccchannel_8_analyzer_1_array_crystal_array_6_priority;
MCNUM xwidth = mccchannel_8_analyzer_1_array_crystal_array_6_xwidth;
MCNUM yheight = mccchannel_8_analyzer_1_array_crystal_array_6_yheight;
MCNUM zdepth = mccchannel_8_analyzer_1_array_crystal_array_6_zdepth;
MCNUM xwidth2 = mccchannel_8_analyzer_1_array_crystal_array_6_xwidth2;
MCNUM yheight2 = mccchannel_8_analyzer_1_array_crystal_array_6_yheight2;
MCNUM visualize = mccchannel_8_analyzer_1_array_crystal_array_6_visualize;
int target_index = mccchannel_8_analyzer_1_array_crystal_array_6_target_index;
MCNUM target_x = mccchannel_8_analyzer_1_array_crystal_array_6_target_x;
MCNUM target_y = mccchannel_8_analyzer_1_array_crystal_array_6_target_y;
MCNUM target_z = mccchannel_8_analyzer_1_array_crystal_array_6_target_z;
MCNUM focus_aw = mccchannel_8_analyzer_1_array_crystal_array_6_focus_aw;
MCNUM focus_ah = mccchannel_8_analyzer_1_array_crystal_array_6_focus_ah;
MCNUM focus_xw = mccchannel_8_analyzer_1_array_crystal_array_6_focus_xw;
MCNUM focus_xh = mccchannel_8_analyzer_1_array_crystal_array_6_focus_xh;
MCNUM focus_r = mccchannel_8_analyzer_1_array_crystal_array_6_focus_r;
MCNUM p_interact = mccchannel_8_analyzer_1_array_crystal_array_6_p_interact;
char* mask_string = mccchannel_8_analyzer_1_array_crystal_array_6_mask_string;
char* mask_setting = mccchannel_8_analyzer_1_array_crystal_array_6_mask_setting;
MCNUM number_of_activations = mccchannel_8_analyzer_1_array_crystal_array_6_number_of_activations;
}   /* End of channel_8_analyzer_1_array_crystal_array_6=Union_box() SETTING parameter declarations. */
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex
  /* Label for restoring  neutron */
  mcabsorbCompchannel_8_analyzer_1_array_crystal_array_6:
  if (RESTORE) /* restore if needed */
  { RESTORE_NEUTRON(440,
      mcnlx,
      mcnly,
      mcnlz,
      mcnlvx,
      mcnlvy,
      mcnlvz,
      mcnlt,
      mcnlsx,
      mcnlsy,
      mcnlsz,
      mcnlp); }
#undef mcabsorbComp
#undef p
#undef sz
#undef sy
#undef sx
#undef t
#undef vz
#undef vy
#undef vx
#undef z
#undef y
#undef x
  mcDEBUG_STATE(
mcnlx,
mcnly,
mcnlz,
mcnlvx,
mcnlvy,
mcnlvz,
mcnlt,
mcnlsx,
mcnlsy,
mcnlsz,
mcnlp)

  /* TRACE Component channel_8_analyzer_1_array_crystal_array_7 [441] */
  mccoordschange(mcposrchannel_8_analyzer_1_array_crystal_array_7, mcrotrchannel_8_analyzer_1_array_crystal_array_7,
    &mcnlx,
    &mcnly,
    &mcnlz,
    &mcnlvx,
    &mcnlvy,
    &mcnlvz,
    &mcnlsx,
    &mcnlsy,
    &mcnlsz);
  /* define label inside component channel_8_analyzer_1_array_crystal_array_7 (without coords transformations) */
  mcJumpTrace_channel_8_analyzer_1_array_crystal_array_7:
  SIG_MESSAGE("channel_8_analyzer_1_array_crystal_array_7 (Trace)");
  mcDEBUG_COMP("channel_8_analyzer_1_array_crystal_array_7")
  mcDEBUG_STATE(
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp)
#define x mcnlx
#define y mcnly
#define z mcnlz
#define vx mcnlvx
#define vy mcnlvy
#define vz mcnlvz
#define t mcnlt
#define sx mcnlsx
#define sy mcnlsy
#define sz mcnlsz
#define p mcnlp

#define mcabsorbComp mcabsorbCompchannel_8_analyzer_1_array_crystal_array_7
  STORE_NEUTRON(441,
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp);
  mcScattered=0;
  mcRestore=0;
  mcNCounter[441]++;
  mcPCounter[441] += p;
  mcP2Counter[441] += p*p;
#define mccompcurname  channel_8_analyzer_1_array_crystal_array_7
#define mccompcurtype  Union_box
#define mccompcurindex 441
#define loop_index mccchannel_8_analyzer_1_array_crystal_array_7_loop_index
#define this_box_volume mccchannel_8_analyzer_1_array_crystal_array_7_this_box_volume
#define global_geometry_element mccchannel_8_analyzer_1_array_crystal_array_7_global_geometry_element
#define this_box_storage mccchannel_8_analyzer_1_array_crystal_array_7_this_box_storage
{   /* Declarations of channel_8_analyzer_1_array_crystal_array_7=Union_box() SETTING parameters. */
char* material_string = mccchannel_8_analyzer_1_array_crystal_array_7_material_string;
MCNUM priority = mccchannel_8_analyzer_1_array_crystal_array_7_priority;
MCNUM xwidth = mccchannel_8_analyzer_1_array_crystal_array_7_xwidth;
MCNUM yheight = mccchannel_8_analyzer_1_array_crystal_array_7_yheight;
MCNUM zdepth = mccchannel_8_analyzer_1_array_crystal_array_7_zdepth;
MCNUM xwidth2 = mccchannel_8_analyzer_1_array_crystal_array_7_xwidth2;
MCNUM yheight2 = mccchannel_8_analyzer_1_array_crystal_array_7_yheight2;
MCNUM visualize = mccchannel_8_analyzer_1_array_crystal_array_7_visualize;
int target_index = mccchannel_8_analyzer_1_array_crystal_array_7_target_index;
MCNUM target_x = mccchannel_8_analyzer_1_array_crystal_array_7_target_x;
MCNUM target_y = mccchannel_8_analyzer_1_array_crystal_array_7_target_y;
MCNUM target_z = mccchannel_8_analyzer_1_array_crystal_array_7_target_z;
MCNUM focus_aw = mccchannel_8_analyzer_1_array_crystal_array_7_focus_aw;
MCNUM focus_ah = mccchannel_8_analyzer_1_array_crystal_array_7_focus_ah;
MCNUM focus_xw = mccchannel_8_analyzer_1_array_crystal_array_7_focus_xw;
MCNUM focus_xh = mccchannel_8_analyzer_1_array_crystal_array_7_focus_xh;
MCNUM focus_r = mccchannel_8_analyzer_1_array_crystal_array_7_focus_r;
MCNUM p_interact = mccchannel_8_analyzer_1_array_crystal_array_7_p_interact;
char* mask_string = mccchannel_8_analyzer_1_array_crystal_array_7_mask_string;
char* mask_setting = mccchannel_8_analyzer_1_array_crystal_array_7_mask_setting;
MCNUM number_of_activations = mccchannel_8_analyzer_1_array_crystal_array_7_number_of_activations;
}   /* End of channel_8_analyzer_1_array_crystal_array_7=Union_box() SETTING parameter declarations. */
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex
  /* Label for restoring  neutron */
  mcabsorbCompchannel_8_analyzer_1_array_crystal_array_7:
  if (RESTORE) /* restore if needed */
  { RESTORE_NEUTRON(441,
      mcnlx,
      mcnly,
      mcnlz,
      mcnlvx,
      mcnlvy,
      mcnlvz,
      mcnlt,
      mcnlsx,
      mcnlsy,
      mcnlsz,
      mcnlp); }
#undef mcabsorbComp
#undef p
#undef sz
#undef sy
#undef sx
#undef t
#undef vz
#undef vy
#undef vx
#undef z
#undef y
#undef x
  mcDEBUG_STATE(
mcnlx,
mcnly,
mcnlz,
mcnlvx,
mcnlvy,
mcnlvz,
mcnlt,
mcnlsx,
mcnlsy,
mcnlsz,
mcnlp)

  /* TRACE Component channel_8_analyzer_1_array_crystal_array_8 [442] */
  mccoordschange(mcposrchannel_8_analyzer_1_array_crystal_array_8, mcrotrchannel_8_analyzer_1_array_crystal_array_8,
    &mcnlx,
    &mcnly,
    &mcnlz,
    &mcnlvx,
    &mcnlvy,
    &mcnlvz,
    &mcnlsx,
    &mcnlsy,
    &mcnlsz);
  /* define label inside component channel_8_analyzer_1_array_crystal_array_8 (without coords transformations) */
  mcJumpTrace_channel_8_analyzer_1_array_crystal_array_8:
  SIG_MESSAGE("channel_8_analyzer_1_array_crystal_array_8 (Trace)");
  mcDEBUG_COMP("channel_8_analyzer_1_array_crystal_array_8")
  mcDEBUG_STATE(
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp)
#define x mcnlx
#define y mcnly
#define z mcnlz
#define vx mcnlvx
#define vy mcnlvy
#define vz mcnlvz
#define t mcnlt
#define sx mcnlsx
#define sy mcnlsy
#define sz mcnlsz
#define p mcnlp

#define mcabsorbComp mcabsorbCompchannel_8_analyzer_1_array_crystal_array_8
  STORE_NEUTRON(442,
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp);
  mcScattered=0;
  mcRestore=0;
  mcNCounter[442]++;
  mcPCounter[442] += p;
  mcP2Counter[442] += p*p;
#define mccompcurname  channel_8_analyzer_1_array_crystal_array_8
#define mccompcurtype  Union_box
#define mccompcurindex 442
#define loop_index mccchannel_8_analyzer_1_array_crystal_array_8_loop_index
#define this_box_volume mccchannel_8_analyzer_1_array_crystal_array_8_this_box_volume
#define global_geometry_element mccchannel_8_analyzer_1_array_crystal_array_8_global_geometry_element
#define this_box_storage mccchannel_8_analyzer_1_array_crystal_array_8_this_box_storage
{   /* Declarations of channel_8_analyzer_1_array_crystal_array_8=Union_box() SETTING parameters. */
char* material_string = mccchannel_8_analyzer_1_array_crystal_array_8_material_string;
MCNUM priority = mccchannel_8_analyzer_1_array_crystal_array_8_priority;
MCNUM xwidth = mccchannel_8_analyzer_1_array_crystal_array_8_xwidth;
MCNUM yheight = mccchannel_8_analyzer_1_array_crystal_array_8_yheight;
MCNUM zdepth = mccchannel_8_analyzer_1_array_crystal_array_8_zdepth;
MCNUM xwidth2 = mccchannel_8_analyzer_1_array_crystal_array_8_xwidth2;
MCNUM yheight2 = mccchannel_8_analyzer_1_array_crystal_array_8_yheight2;
MCNUM visualize = mccchannel_8_analyzer_1_array_crystal_array_8_visualize;
int target_index = mccchannel_8_analyzer_1_array_crystal_array_8_target_index;
MCNUM target_x = mccchannel_8_analyzer_1_array_crystal_array_8_target_x;
MCNUM target_y = mccchannel_8_analyzer_1_array_crystal_array_8_target_y;
MCNUM target_z = mccchannel_8_analyzer_1_array_crystal_array_8_target_z;
MCNUM focus_aw = mccchannel_8_analyzer_1_array_crystal_array_8_focus_aw;
MCNUM focus_ah = mccchannel_8_analyzer_1_array_crystal_array_8_focus_ah;
MCNUM focus_xw = mccchannel_8_analyzer_1_array_crystal_array_8_focus_xw;
MCNUM focus_xh = mccchannel_8_analyzer_1_array_crystal_array_8_focus_xh;
MCNUM focus_r = mccchannel_8_analyzer_1_array_crystal_array_8_focus_r;
MCNUM p_interact = mccchannel_8_analyzer_1_array_crystal_array_8_p_interact;
char* mask_string = mccchannel_8_analyzer_1_array_crystal_array_8_mask_string;
char* mask_setting = mccchannel_8_analyzer_1_array_crystal_array_8_mask_setting;
MCNUM number_of_activations = mccchannel_8_analyzer_1_array_crystal_array_8_number_of_activations;
}   /* End of channel_8_analyzer_1_array_crystal_array_8=Union_box() SETTING parameter declarations. */
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex
  /* Label for restoring  neutron */
  mcabsorbCompchannel_8_analyzer_1_array_crystal_array_8:
  if (RESTORE) /* restore if needed */
  { RESTORE_NEUTRON(442,
      mcnlx,
      mcnly,
      mcnlz,
      mcnlvx,
      mcnlvy,
      mcnlvz,
      mcnlt,
      mcnlsx,
      mcnlsy,
      mcnlsz,
      mcnlp); }
#undef mcabsorbComp
#undef p
#undef sz
#undef sy
#undef sx
#undef t
#undef vz
#undef vy
#undef vx
#undef z
#undef y
#undef x
  mcDEBUG_STATE(
mcnlx,
mcnly,
mcnlz,
mcnlvx,
mcnlvy,
mcnlvz,
mcnlt,
mcnlsx,
mcnlsy,
mcnlsz,
mcnlp)

  /* TRACE Component channel_8_analyzer_2_center [443] */
  mccoordschange(mcposrchannel_8_analyzer_2_center, mcrotrchannel_8_analyzer_2_center,
    &mcnlx,
    &mcnly,
    &mcnlz,
    &mcnlvx,
    &mcnlvy,
    &mcnlvz,
    &mcnlsx,
    &mcnlsy,
    &mcnlsz);
  /* define label inside component channel_8_analyzer_2_center (without coords transformations) */
  mcJumpTrace_channel_8_analyzer_2_center:
  SIG_MESSAGE("channel_8_analyzer_2_center (Trace)");
  mcDEBUG_COMP("channel_8_analyzer_2_center")
  mcDEBUG_STATE(
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp)
#define x mcnlx
#define y mcnly
#define z mcnlz
#define vx mcnlvx
#define vy mcnlvy
#define vz mcnlvz
#define t mcnlt
#define sx mcnlsx
#define sy mcnlsy
#define sz mcnlsz
#define p mcnlp

#define mcabsorbComp mcabsorbCompchannel_8_analyzer_2_center
  STORE_NEUTRON(443,
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp);
  mcScattered=0;
  mcRestore=0;
  mcNCounter[443]++;
  mcPCounter[443] += p;
  mcP2Counter[443] += p*p;
#define mccompcurname  channel_8_analyzer_2_center
#define mccompcurtype  Arm
#define mccompcurindex 443
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex
  /* Label for restoring  neutron */
  mcabsorbCompchannel_8_analyzer_2_center:
  if (RESTORE) /* restore if needed */
  { RESTORE_NEUTRON(443,
      mcnlx,
      mcnly,
      mcnlz,
      mcnlvx,
      mcnlvy,
      mcnlvz,
      mcnlt,
      mcnlsx,
      mcnlsy,
      mcnlsz,
      mcnlp); }
#undef mcabsorbComp
#undef p
#undef sz
#undef sy
#undef sx
#undef t
#undef vz
#undef vy
#undef vx
#undef z
#undef y
#undef x
  mcDEBUG_STATE(
mcnlx,
mcnly,
mcnlz,
mcnlvx,
mcnlvy,
mcnlvz,
mcnlt,
mcnlsx,
mcnlsy,
mcnlsz,
mcnlp)

  /* TRACE Component channel_8_analyzer_2_rotated [444] */
  mccoordschange(mcposrchannel_8_analyzer_2_rotated, mcrotrchannel_8_analyzer_2_rotated,
    &mcnlx,
    &mcnly,
    &mcnlz,
    &mcnlvx,
    &mcnlvy,
    &mcnlvz,
    &mcnlsx,
    &mcnlsy,
    &mcnlsz);
  /* define label inside component channel_8_analyzer_2_rotated (without coords transformations) */
  mcJumpTrace_channel_8_analyzer_2_rotated:
  SIG_MESSAGE("channel_8_analyzer_2_rotated (Trace)");
  mcDEBUG_COMP("channel_8_analyzer_2_rotated")
  mcDEBUG_STATE(
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp)
#define x mcnlx
#define y mcnly
#define z mcnlz
#define vx mcnlvx
#define vy mcnlvy
#define vz mcnlvz
#define t mcnlt
#define sx mcnlsx
#define sy mcnlsy
#define sz mcnlsz
#define p mcnlp

#define mcabsorbComp mcabsorbCompchannel_8_analyzer_2_rotated
  STORE_NEUTRON(444,
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp);
  mcScattered=0;
  mcRestore=0;
  mcNCounter[444]++;
  mcPCounter[444] += p;
  mcP2Counter[444] += p*p;
#define mccompcurname  channel_8_analyzer_2_rotated
#define mccompcurtype  Arm
#define mccompcurindex 444
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex
  /* Label for restoring  neutron */
  mcabsorbCompchannel_8_analyzer_2_rotated:
  if (RESTORE) /* restore if needed */
  { RESTORE_NEUTRON(444,
      mcnlx,
      mcnly,
      mcnlz,
      mcnlvx,
      mcnlvy,
      mcnlvz,
      mcnlt,
      mcnlsx,
      mcnlsy,
      mcnlsz,
      mcnlp); }
#undef mcabsorbComp
#undef p
#undef sz
#undef sy
#undef sx
#undef t
#undef vz
#undef vy
#undef vx
#undef z
#undef y
#undef x
  mcDEBUG_STATE(
mcnlx,
mcnly,
mcnlz,
mcnlvx,
mcnlvy,
mcnlvz,
mcnlt,
mcnlsx,
mcnlsy,
mcnlsz,
mcnlp)

  /* TRACE Component channel_8_analyzer_2_array_crystal_array_0 [445] */
  mccoordschange(mcposrchannel_8_analyzer_2_array_crystal_array_0, mcrotrchannel_8_analyzer_2_array_crystal_array_0,
    &mcnlx,
    &mcnly,
    &mcnlz,
    &mcnlvx,
    &mcnlvy,
    &mcnlvz,
    &mcnlsx,
    &mcnlsy,
    &mcnlsz);
  /* define label inside component channel_8_analyzer_2_array_crystal_array_0 (without coords transformations) */
  mcJumpTrace_channel_8_analyzer_2_array_crystal_array_0:
  SIG_MESSAGE("channel_8_analyzer_2_array_crystal_array_0 (Trace)");
  mcDEBUG_COMP("channel_8_analyzer_2_array_crystal_array_0")
  mcDEBUG_STATE(
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp)
#define x mcnlx
#define y mcnly
#define z mcnlz
#define vx mcnlvx
#define vy mcnlvy
#define vz mcnlvz
#define t mcnlt
#define sx mcnlsx
#define sy mcnlsy
#define sz mcnlsz
#define p mcnlp

#define mcabsorbComp mcabsorbCompchannel_8_analyzer_2_array_crystal_array_0
  STORE_NEUTRON(445,
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp);
  mcScattered=0;
  mcRestore=0;
  mcNCounter[445]++;
  mcPCounter[445] += p;
  mcP2Counter[445] += p*p;
#define mccompcurname  channel_8_analyzer_2_array_crystal_array_0
#define mccompcurtype  Union_box
#define mccompcurindex 445
#define loop_index mccchannel_8_analyzer_2_array_crystal_array_0_loop_index
#define this_box_volume mccchannel_8_analyzer_2_array_crystal_array_0_this_box_volume
#define global_geometry_element mccchannel_8_analyzer_2_array_crystal_array_0_global_geometry_element
#define this_box_storage mccchannel_8_analyzer_2_array_crystal_array_0_this_box_storage
{   /* Declarations of channel_8_analyzer_2_array_crystal_array_0=Union_box() SETTING parameters. */
char* material_string = mccchannel_8_analyzer_2_array_crystal_array_0_material_string;
MCNUM priority = mccchannel_8_analyzer_2_array_crystal_array_0_priority;
MCNUM xwidth = mccchannel_8_analyzer_2_array_crystal_array_0_xwidth;
MCNUM yheight = mccchannel_8_analyzer_2_array_crystal_array_0_yheight;
MCNUM zdepth = mccchannel_8_analyzer_2_array_crystal_array_0_zdepth;
MCNUM xwidth2 = mccchannel_8_analyzer_2_array_crystal_array_0_xwidth2;
MCNUM yheight2 = mccchannel_8_analyzer_2_array_crystal_array_0_yheight2;
MCNUM visualize = mccchannel_8_analyzer_2_array_crystal_array_0_visualize;
int target_index = mccchannel_8_analyzer_2_array_crystal_array_0_target_index;
MCNUM target_x = mccchannel_8_analyzer_2_array_crystal_array_0_target_x;
MCNUM target_y = mccchannel_8_analyzer_2_array_crystal_array_0_target_y;
MCNUM target_z = mccchannel_8_analyzer_2_array_crystal_array_0_target_z;
MCNUM focus_aw = mccchannel_8_analyzer_2_array_crystal_array_0_focus_aw;
MCNUM focus_ah = mccchannel_8_analyzer_2_array_crystal_array_0_focus_ah;
MCNUM focus_xw = mccchannel_8_analyzer_2_array_crystal_array_0_focus_xw;
MCNUM focus_xh = mccchannel_8_analyzer_2_array_crystal_array_0_focus_xh;
MCNUM focus_r = mccchannel_8_analyzer_2_array_crystal_array_0_focus_r;
MCNUM p_interact = mccchannel_8_analyzer_2_array_crystal_array_0_p_interact;
char* mask_string = mccchannel_8_analyzer_2_array_crystal_array_0_mask_string;
char* mask_setting = mccchannel_8_analyzer_2_array_crystal_array_0_mask_setting;
MCNUM number_of_activations = mccchannel_8_analyzer_2_array_crystal_array_0_number_of_activations;
}   /* End of channel_8_analyzer_2_array_crystal_array_0=Union_box() SETTING parameter declarations. */
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex
  /* Label for restoring  neutron */
  mcabsorbCompchannel_8_analyzer_2_array_crystal_array_0:
  if (RESTORE) /* restore if needed */
  { RESTORE_NEUTRON(445,
      mcnlx,
      mcnly,
      mcnlz,
      mcnlvx,
      mcnlvy,
      mcnlvz,
      mcnlt,
      mcnlsx,
      mcnlsy,
      mcnlsz,
      mcnlp); }
#undef mcabsorbComp
#undef p
#undef sz
#undef sy
#undef sx
#undef t
#undef vz
#undef vy
#undef vx
#undef z
#undef y
#undef x
  mcDEBUG_STATE(
mcnlx,
mcnly,
mcnlz,
mcnlvx,
mcnlvy,
mcnlvz,
mcnlt,
mcnlsx,
mcnlsy,
mcnlsz,
mcnlp)

  /* TRACE Component channel_8_analyzer_2_array_crystal_array_1 [446] */
  mccoordschange(mcposrchannel_8_analyzer_2_array_crystal_array_1, mcrotrchannel_8_analyzer_2_array_crystal_array_1,
    &mcnlx,
    &mcnly,
    &mcnlz,
    &mcnlvx,
    &mcnlvy,
    &mcnlvz,
    &mcnlsx,
    &mcnlsy,
    &mcnlsz);
  /* define label inside component channel_8_analyzer_2_array_crystal_array_1 (without coords transformations) */
  mcJumpTrace_channel_8_analyzer_2_array_crystal_array_1:
  SIG_MESSAGE("channel_8_analyzer_2_array_crystal_array_1 (Trace)");
  mcDEBUG_COMP("channel_8_analyzer_2_array_crystal_array_1")
  mcDEBUG_STATE(
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp)
#define x mcnlx
#define y mcnly
#define z mcnlz
#define vx mcnlvx
#define vy mcnlvy
#define vz mcnlvz
#define t mcnlt
#define sx mcnlsx
#define sy mcnlsy
#define sz mcnlsz
#define p mcnlp

#define mcabsorbComp mcabsorbCompchannel_8_analyzer_2_array_crystal_array_1
  STORE_NEUTRON(446,
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp);
  mcScattered=0;
  mcRestore=0;
  mcNCounter[446]++;
  mcPCounter[446] += p;
  mcP2Counter[446] += p*p;
#define mccompcurname  channel_8_analyzer_2_array_crystal_array_1
#define mccompcurtype  Union_box
#define mccompcurindex 446
#define loop_index mccchannel_8_analyzer_2_array_crystal_array_1_loop_index
#define this_box_volume mccchannel_8_analyzer_2_array_crystal_array_1_this_box_volume
#define global_geometry_element mccchannel_8_analyzer_2_array_crystal_array_1_global_geometry_element
#define this_box_storage mccchannel_8_analyzer_2_array_crystal_array_1_this_box_storage
{   /* Declarations of channel_8_analyzer_2_array_crystal_array_1=Union_box() SETTING parameters. */
char* material_string = mccchannel_8_analyzer_2_array_crystal_array_1_material_string;
MCNUM priority = mccchannel_8_analyzer_2_array_crystal_array_1_priority;
MCNUM xwidth = mccchannel_8_analyzer_2_array_crystal_array_1_xwidth;
MCNUM yheight = mccchannel_8_analyzer_2_array_crystal_array_1_yheight;
MCNUM zdepth = mccchannel_8_analyzer_2_array_crystal_array_1_zdepth;
MCNUM xwidth2 = mccchannel_8_analyzer_2_array_crystal_array_1_xwidth2;
MCNUM yheight2 = mccchannel_8_analyzer_2_array_crystal_array_1_yheight2;
MCNUM visualize = mccchannel_8_analyzer_2_array_crystal_array_1_visualize;
int target_index = mccchannel_8_analyzer_2_array_crystal_array_1_target_index;
MCNUM target_x = mccchannel_8_analyzer_2_array_crystal_array_1_target_x;
MCNUM target_y = mccchannel_8_analyzer_2_array_crystal_array_1_target_y;
MCNUM target_z = mccchannel_8_analyzer_2_array_crystal_array_1_target_z;
MCNUM focus_aw = mccchannel_8_analyzer_2_array_crystal_array_1_focus_aw;
MCNUM focus_ah = mccchannel_8_analyzer_2_array_crystal_array_1_focus_ah;
MCNUM focus_xw = mccchannel_8_analyzer_2_array_crystal_array_1_focus_xw;
MCNUM focus_xh = mccchannel_8_analyzer_2_array_crystal_array_1_focus_xh;
MCNUM focus_r = mccchannel_8_analyzer_2_array_crystal_array_1_focus_r;
MCNUM p_interact = mccchannel_8_analyzer_2_array_crystal_array_1_p_interact;
char* mask_string = mccchannel_8_analyzer_2_array_crystal_array_1_mask_string;
char* mask_setting = mccchannel_8_analyzer_2_array_crystal_array_1_mask_setting;
MCNUM number_of_activations = mccchannel_8_analyzer_2_array_crystal_array_1_number_of_activations;
}   /* End of channel_8_analyzer_2_array_crystal_array_1=Union_box() SETTING parameter declarations. */
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex
  /* Label for restoring  neutron */
  mcabsorbCompchannel_8_analyzer_2_array_crystal_array_1:
  if (RESTORE) /* restore if needed */
  { RESTORE_NEUTRON(446,
      mcnlx,
      mcnly,
      mcnlz,
      mcnlvx,
      mcnlvy,
      mcnlvz,
      mcnlt,
      mcnlsx,
      mcnlsy,
      mcnlsz,
      mcnlp); }
#undef mcabsorbComp
#undef p
#undef sz
#undef sy
#undef sx
#undef t
#undef vz
#undef vy
#undef vx
#undef z
#undef y
#undef x
  mcDEBUG_STATE(
mcnlx,
mcnly,
mcnlz,
mcnlvx,
mcnlvy,
mcnlvz,
mcnlt,
mcnlsx,
mcnlsy,
mcnlsz,
mcnlp)

  /* TRACE Component channel_8_analyzer_2_array_crystal_array_2 [447] */
  mccoordschange(mcposrchannel_8_analyzer_2_array_crystal_array_2, mcrotrchannel_8_analyzer_2_array_crystal_array_2,
    &mcnlx,
    &mcnly,
    &mcnlz,
    &mcnlvx,
    &mcnlvy,
    &mcnlvz,
    &mcnlsx,
    &mcnlsy,
    &mcnlsz);
  /* define label inside component channel_8_analyzer_2_array_crystal_array_2 (without coords transformations) */
  mcJumpTrace_channel_8_analyzer_2_array_crystal_array_2:
  SIG_MESSAGE("channel_8_analyzer_2_array_crystal_array_2 (Trace)");
  mcDEBUG_COMP("channel_8_analyzer_2_array_crystal_array_2")
  mcDEBUG_STATE(
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp)
#define x mcnlx
#define y mcnly
#define z mcnlz
#define vx mcnlvx
#define vy mcnlvy
#define vz mcnlvz
#define t mcnlt
#define sx mcnlsx
#define sy mcnlsy
#define sz mcnlsz
#define p mcnlp

#define mcabsorbComp mcabsorbCompchannel_8_analyzer_2_array_crystal_array_2
  STORE_NEUTRON(447,
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp);
  mcScattered=0;
  mcRestore=0;
  mcNCounter[447]++;
  mcPCounter[447] += p;
  mcP2Counter[447] += p*p;
#define mccompcurname  channel_8_analyzer_2_array_crystal_array_2
#define mccompcurtype  Union_box
#define mccompcurindex 447
#define loop_index mccchannel_8_analyzer_2_array_crystal_array_2_loop_index
#define this_box_volume mccchannel_8_analyzer_2_array_crystal_array_2_this_box_volume
#define global_geometry_element mccchannel_8_analyzer_2_array_crystal_array_2_global_geometry_element
#define this_box_storage mccchannel_8_analyzer_2_array_crystal_array_2_this_box_storage
{   /* Declarations of channel_8_analyzer_2_array_crystal_array_2=Union_box() SETTING parameters. */
char* material_string = mccchannel_8_analyzer_2_array_crystal_array_2_material_string;
MCNUM priority = mccchannel_8_analyzer_2_array_crystal_array_2_priority;
MCNUM xwidth = mccchannel_8_analyzer_2_array_crystal_array_2_xwidth;
MCNUM yheight = mccchannel_8_analyzer_2_array_crystal_array_2_yheight;
MCNUM zdepth = mccchannel_8_analyzer_2_array_crystal_array_2_zdepth;
MCNUM xwidth2 = mccchannel_8_analyzer_2_array_crystal_array_2_xwidth2;
MCNUM yheight2 = mccchannel_8_analyzer_2_array_crystal_array_2_yheight2;
MCNUM visualize = mccchannel_8_analyzer_2_array_crystal_array_2_visualize;
int target_index = mccchannel_8_analyzer_2_array_crystal_array_2_target_index;
MCNUM target_x = mccchannel_8_analyzer_2_array_crystal_array_2_target_x;
MCNUM target_y = mccchannel_8_analyzer_2_array_crystal_array_2_target_y;
MCNUM target_z = mccchannel_8_analyzer_2_array_crystal_array_2_target_z;
MCNUM focus_aw = mccchannel_8_analyzer_2_array_crystal_array_2_focus_aw;
MCNUM focus_ah = mccchannel_8_analyzer_2_array_crystal_array_2_focus_ah;
MCNUM focus_xw = mccchannel_8_analyzer_2_array_crystal_array_2_focus_xw;
MCNUM focus_xh = mccchannel_8_analyzer_2_array_crystal_array_2_focus_xh;
MCNUM focus_r = mccchannel_8_analyzer_2_array_crystal_array_2_focus_r;
MCNUM p_interact = mccchannel_8_analyzer_2_array_crystal_array_2_p_interact;
char* mask_string = mccchannel_8_analyzer_2_array_crystal_array_2_mask_string;
char* mask_setting = mccchannel_8_analyzer_2_array_crystal_array_2_mask_setting;
MCNUM number_of_activations = mccchannel_8_analyzer_2_array_crystal_array_2_number_of_activations;
}   /* End of channel_8_analyzer_2_array_crystal_array_2=Union_box() SETTING parameter declarations. */
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex
  /* Label for restoring  neutron */
  mcabsorbCompchannel_8_analyzer_2_array_crystal_array_2:
  if (RESTORE) /* restore if needed */
  { RESTORE_NEUTRON(447,
      mcnlx,
      mcnly,
      mcnlz,
      mcnlvx,
      mcnlvy,
      mcnlvz,
      mcnlt,
      mcnlsx,
      mcnlsy,
      mcnlsz,
      mcnlp); }
#undef mcabsorbComp
#undef p
#undef sz
#undef sy
#undef sx
#undef t
#undef vz
#undef vy
#undef vx
#undef z
#undef y
#undef x
  mcDEBUG_STATE(
mcnlx,
mcnly,
mcnlz,
mcnlvx,
mcnlvy,
mcnlvz,
mcnlt,
mcnlsx,
mcnlsy,
mcnlsz,
mcnlp)

  /* TRACE Component channel_8_analyzer_2_array_crystal_array_3 [448] */
  mccoordschange(mcposrchannel_8_analyzer_2_array_crystal_array_3, mcrotrchannel_8_analyzer_2_array_crystal_array_3,
    &mcnlx,
    &mcnly,
    &mcnlz,
    &mcnlvx,
    &mcnlvy,
    &mcnlvz,
    &mcnlsx,
    &mcnlsy,
    &mcnlsz);
  /* define label inside component channel_8_analyzer_2_array_crystal_array_3 (without coords transformations) */
  mcJumpTrace_channel_8_analyzer_2_array_crystal_array_3:
  SIG_MESSAGE("channel_8_analyzer_2_array_crystal_array_3 (Trace)");
  mcDEBUG_COMP("channel_8_analyzer_2_array_crystal_array_3")
  mcDEBUG_STATE(
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp)
#define x mcnlx
#define y mcnly
#define z mcnlz
#define vx mcnlvx
#define vy mcnlvy
#define vz mcnlvz
#define t mcnlt
#define sx mcnlsx
#define sy mcnlsy
#define sz mcnlsz
#define p mcnlp

#define mcabsorbComp mcabsorbCompchannel_8_analyzer_2_array_crystal_array_3
  STORE_NEUTRON(448,
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp);
  mcScattered=0;
  mcRestore=0;
  mcNCounter[448]++;
  mcPCounter[448] += p;
  mcP2Counter[448] += p*p;
#define mccompcurname  channel_8_analyzer_2_array_crystal_array_3
#define mccompcurtype  Union_box
#define mccompcurindex 448
#define loop_index mccchannel_8_analyzer_2_array_crystal_array_3_loop_index
#define this_box_volume mccchannel_8_analyzer_2_array_crystal_array_3_this_box_volume
#define global_geometry_element mccchannel_8_analyzer_2_array_crystal_array_3_global_geometry_element
#define this_box_storage mccchannel_8_analyzer_2_array_crystal_array_3_this_box_storage
{   /* Declarations of channel_8_analyzer_2_array_crystal_array_3=Union_box() SETTING parameters. */
char* material_string = mccchannel_8_analyzer_2_array_crystal_array_3_material_string;
MCNUM priority = mccchannel_8_analyzer_2_array_crystal_array_3_priority;
MCNUM xwidth = mccchannel_8_analyzer_2_array_crystal_array_3_xwidth;
MCNUM yheight = mccchannel_8_analyzer_2_array_crystal_array_3_yheight;
MCNUM zdepth = mccchannel_8_analyzer_2_array_crystal_array_3_zdepth;
MCNUM xwidth2 = mccchannel_8_analyzer_2_array_crystal_array_3_xwidth2;
MCNUM yheight2 = mccchannel_8_analyzer_2_array_crystal_array_3_yheight2;
MCNUM visualize = mccchannel_8_analyzer_2_array_crystal_array_3_visualize;
int target_index = mccchannel_8_analyzer_2_array_crystal_array_3_target_index;
MCNUM target_x = mccchannel_8_analyzer_2_array_crystal_array_3_target_x;
MCNUM target_y = mccchannel_8_analyzer_2_array_crystal_array_3_target_y;
MCNUM target_z = mccchannel_8_analyzer_2_array_crystal_array_3_target_z;
MCNUM focus_aw = mccchannel_8_analyzer_2_array_crystal_array_3_focus_aw;
MCNUM focus_ah = mccchannel_8_analyzer_2_array_crystal_array_3_focus_ah;
MCNUM focus_xw = mccchannel_8_analyzer_2_array_crystal_array_3_focus_xw;
MCNUM focus_xh = mccchannel_8_analyzer_2_array_crystal_array_3_focus_xh;
MCNUM focus_r = mccchannel_8_analyzer_2_array_crystal_array_3_focus_r;
MCNUM p_interact = mccchannel_8_analyzer_2_array_crystal_array_3_p_interact;
char* mask_string = mccchannel_8_analyzer_2_array_crystal_array_3_mask_string;
char* mask_setting = mccchannel_8_analyzer_2_array_crystal_array_3_mask_setting;
MCNUM number_of_activations = mccchannel_8_analyzer_2_array_crystal_array_3_number_of_activations;
}   /* End of channel_8_analyzer_2_array_crystal_array_3=Union_box() SETTING parameter declarations. */
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex
  /* Label for restoring  neutron */
  mcabsorbCompchannel_8_analyzer_2_array_crystal_array_3:
  if (RESTORE) /* restore if needed */
  { RESTORE_NEUTRON(448,
      mcnlx,
      mcnly,
      mcnlz,
      mcnlvx,
      mcnlvy,
      mcnlvz,
      mcnlt,
      mcnlsx,
      mcnlsy,
      mcnlsz,
      mcnlp); }
#undef mcabsorbComp
#undef p
#undef sz
#undef sy
#undef sx
#undef t
#undef vz
#undef vy
#undef vx
#undef z
#undef y
#undef x
  mcDEBUG_STATE(
mcnlx,
mcnly,
mcnlz,
mcnlvx,
mcnlvy,
mcnlvz,
mcnlt,
mcnlsx,
mcnlsy,
mcnlsz,
mcnlp)

  /* TRACE Component channel_8_analyzer_2_array_crystal_array_4 [449] */
  mccoordschange(mcposrchannel_8_analyzer_2_array_crystal_array_4, mcrotrchannel_8_analyzer_2_array_crystal_array_4,
    &mcnlx,
    &mcnly,
    &mcnlz,
    &mcnlvx,
    &mcnlvy,
    &mcnlvz,
    &mcnlsx,
    &mcnlsy,
    &mcnlsz);
  /* define label inside component channel_8_analyzer_2_array_crystal_array_4 (without coords transformations) */
  mcJumpTrace_channel_8_analyzer_2_array_crystal_array_4:
  SIG_MESSAGE("channel_8_analyzer_2_array_crystal_array_4 (Trace)");
  mcDEBUG_COMP("channel_8_analyzer_2_array_crystal_array_4")
  mcDEBUG_STATE(
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp)
#define x mcnlx
#define y mcnly
#define z mcnlz
#define vx mcnlvx
#define vy mcnlvy
#define vz mcnlvz
#define t mcnlt
#define sx mcnlsx
#define sy mcnlsy
#define sz mcnlsz
#define p mcnlp

#define mcabsorbComp mcabsorbCompchannel_8_analyzer_2_array_crystal_array_4
  STORE_NEUTRON(449,
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp);
  mcScattered=0;
  mcRestore=0;
  mcNCounter[449]++;
  mcPCounter[449] += p;
  mcP2Counter[449] += p*p;
#define mccompcurname  channel_8_analyzer_2_array_crystal_array_4
#define mccompcurtype  Union_box
#define mccompcurindex 449
#define loop_index mccchannel_8_analyzer_2_array_crystal_array_4_loop_index
#define this_box_volume mccchannel_8_analyzer_2_array_crystal_array_4_this_box_volume
#define global_geometry_element mccchannel_8_analyzer_2_array_crystal_array_4_global_geometry_element
#define this_box_storage mccchannel_8_analyzer_2_array_crystal_array_4_this_box_storage
{   /* Declarations of channel_8_analyzer_2_array_crystal_array_4=Union_box() SETTING parameters. */
char* material_string = mccchannel_8_analyzer_2_array_crystal_array_4_material_string;
MCNUM priority = mccchannel_8_analyzer_2_array_crystal_array_4_priority;
MCNUM xwidth = mccchannel_8_analyzer_2_array_crystal_array_4_xwidth;
MCNUM yheight = mccchannel_8_analyzer_2_array_crystal_array_4_yheight;
MCNUM zdepth = mccchannel_8_analyzer_2_array_crystal_array_4_zdepth;
MCNUM xwidth2 = mccchannel_8_analyzer_2_array_crystal_array_4_xwidth2;
MCNUM yheight2 = mccchannel_8_analyzer_2_array_crystal_array_4_yheight2;
MCNUM visualize = mccchannel_8_analyzer_2_array_crystal_array_4_visualize;
int target_index = mccchannel_8_analyzer_2_array_crystal_array_4_target_index;
MCNUM target_x = mccchannel_8_analyzer_2_array_crystal_array_4_target_x;
MCNUM target_y = mccchannel_8_analyzer_2_array_crystal_array_4_target_y;
MCNUM target_z = mccchannel_8_analyzer_2_array_crystal_array_4_target_z;
MCNUM focus_aw = mccchannel_8_analyzer_2_array_crystal_array_4_focus_aw;
MCNUM focus_ah = mccchannel_8_analyzer_2_array_crystal_array_4_focus_ah;
MCNUM focus_xw = mccchannel_8_analyzer_2_array_crystal_array_4_focus_xw;
MCNUM focus_xh = mccchannel_8_analyzer_2_array_crystal_array_4_focus_xh;
MCNUM focus_r = mccchannel_8_analyzer_2_array_crystal_array_4_focus_r;
MCNUM p_interact = mccchannel_8_analyzer_2_array_crystal_array_4_p_interact;
char* mask_string = mccchannel_8_analyzer_2_array_crystal_array_4_mask_string;
char* mask_setting = mccchannel_8_analyzer_2_array_crystal_array_4_mask_setting;
MCNUM number_of_activations = mccchannel_8_analyzer_2_array_crystal_array_4_number_of_activations;
}   /* End of channel_8_analyzer_2_array_crystal_array_4=Union_box() SETTING parameter declarations. */
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex
  /* Label for restoring  neutron */
  mcabsorbCompchannel_8_analyzer_2_array_crystal_array_4:
  if (RESTORE) /* restore if needed */
  { RESTORE_NEUTRON(449,
      mcnlx,
      mcnly,
      mcnlz,
      mcnlvx,
      mcnlvy,
      mcnlvz,
      mcnlt,
      mcnlsx,
      mcnlsy,
      mcnlsz,
      mcnlp); }
#undef mcabsorbComp
#undef p
#undef sz
#undef sy
#undef sx
#undef t
#undef vz
#undef vy
#undef vx
#undef z
#undef y
#undef x
  mcDEBUG_STATE(
mcnlx,
mcnly,
mcnlz,
mcnlvx,
mcnlvy,
mcnlvz,
mcnlt,
mcnlsx,
mcnlsy,
mcnlsz,
mcnlp)

  /* TRACE Component channel_8_analyzer_2_array_crystal_array_5 [450] */
  mccoordschange(mcposrchannel_8_analyzer_2_array_crystal_array_5, mcrotrchannel_8_analyzer_2_array_crystal_array_5,
    &mcnlx,
    &mcnly,
    &mcnlz,
    &mcnlvx,
    &mcnlvy,
    &mcnlvz,
    &mcnlsx,
    &mcnlsy,
    &mcnlsz);
  /* define label inside component channel_8_analyzer_2_array_crystal_array_5 (without coords transformations) */
  mcJumpTrace_channel_8_analyzer_2_array_crystal_array_5:
  SIG_MESSAGE("channel_8_analyzer_2_array_crystal_array_5 (Trace)");
  mcDEBUG_COMP("channel_8_analyzer_2_array_crystal_array_5")
  mcDEBUG_STATE(
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp)
#define x mcnlx
#define y mcnly
#define z mcnlz
#define vx mcnlvx
#define vy mcnlvy
#define vz mcnlvz
#define t mcnlt
#define sx mcnlsx
#define sy mcnlsy
#define sz mcnlsz
#define p mcnlp

#define mcabsorbComp mcabsorbCompchannel_8_analyzer_2_array_crystal_array_5
  STORE_NEUTRON(450,
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp);
  mcScattered=0;
  mcRestore=0;
  mcNCounter[450]++;
  mcPCounter[450] += p;
  mcP2Counter[450] += p*p;
#define mccompcurname  channel_8_analyzer_2_array_crystal_array_5
#define mccompcurtype  Union_box
#define mccompcurindex 450
#define loop_index mccchannel_8_analyzer_2_array_crystal_array_5_loop_index
#define this_box_volume mccchannel_8_analyzer_2_array_crystal_array_5_this_box_volume
#define global_geometry_element mccchannel_8_analyzer_2_array_crystal_array_5_global_geometry_element
#define this_box_storage mccchannel_8_analyzer_2_array_crystal_array_5_this_box_storage
{   /* Declarations of channel_8_analyzer_2_array_crystal_array_5=Union_box() SETTING parameters. */
char* material_string = mccchannel_8_analyzer_2_array_crystal_array_5_material_string;
MCNUM priority = mccchannel_8_analyzer_2_array_crystal_array_5_priority;
MCNUM xwidth = mccchannel_8_analyzer_2_array_crystal_array_5_xwidth;
MCNUM yheight = mccchannel_8_analyzer_2_array_crystal_array_5_yheight;
MCNUM zdepth = mccchannel_8_analyzer_2_array_crystal_array_5_zdepth;
MCNUM xwidth2 = mccchannel_8_analyzer_2_array_crystal_array_5_xwidth2;
MCNUM yheight2 = mccchannel_8_analyzer_2_array_crystal_array_5_yheight2;
MCNUM visualize = mccchannel_8_analyzer_2_array_crystal_array_5_visualize;
int target_index = mccchannel_8_analyzer_2_array_crystal_array_5_target_index;
MCNUM target_x = mccchannel_8_analyzer_2_array_crystal_array_5_target_x;
MCNUM target_y = mccchannel_8_analyzer_2_array_crystal_array_5_target_y;
MCNUM target_z = mccchannel_8_analyzer_2_array_crystal_array_5_target_z;
MCNUM focus_aw = mccchannel_8_analyzer_2_array_crystal_array_5_focus_aw;
MCNUM focus_ah = mccchannel_8_analyzer_2_array_crystal_array_5_focus_ah;
MCNUM focus_xw = mccchannel_8_analyzer_2_array_crystal_array_5_focus_xw;
MCNUM focus_xh = mccchannel_8_analyzer_2_array_crystal_array_5_focus_xh;
MCNUM focus_r = mccchannel_8_analyzer_2_array_crystal_array_5_focus_r;
MCNUM p_interact = mccchannel_8_analyzer_2_array_crystal_array_5_p_interact;
char* mask_string = mccchannel_8_analyzer_2_array_crystal_array_5_mask_string;
char* mask_setting = mccchannel_8_analyzer_2_array_crystal_array_5_mask_setting;
MCNUM number_of_activations = mccchannel_8_analyzer_2_array_crystal_array_5_number_of_activations;
}   /* End of channel_8_analyzer_2_array_crystal_array_5=Union_box() SETTING parameter declarations. */
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex
  /* Label for restoring  neutron */
  mcabsorbCompchannel_8_analyzer_2_array_crystal_array_5:
  if (RESTORE) /* restore if needed */
  { RESTORE_NEUTRON(450,
      mcnlx,
      mcnly,
      mcnlz,
      mcnlvx,
      mcnlvy,
      mcnlvz,
      mcnlt,
      mcnlsx,
      mcnlsy,
      mcnlsz,
      mcnlp); }
#undef mcabsorbComp
#undef p
#undef sz
#undef sy
#undef sx
#undef t
#undef vz
#undef vy
#undef vx
#undef z
#undef y
#undef x
  mcDEBUG_STATE(
mcnlx,
mcnly,
mcnlz,
mcnlvx,
mcnlvy,
mcnlvz,
mcnlt,
mcnlsx,
mcnlsy,
mcnlsz,
mcnlp)

  /* TRACE Component channel_8_analyzer_2_array_crystal_array_6 [451] */
  mccoordschange(mcposrchannel_8_analyzer_2_array_crystal_array_6, mcrotrchannel_8_analyzer_2_array_crystal_array_6,
    &mcnlx,
    &mcnly,
    &mcnlz,
    &mcnlvx,
    &mcnlvy,
    &mcnlvz,
    &mcnlsx,
    &mcnlsy,
    &mcnlsz);
  /* define label inside component channel_8_analyzer_2_array_crystal_array_6 (without coords transformations) */
  mcJumpTrace_channel_8_analyzer_2_array_crystal_array_6:
  SIG_MESSAGE("channel_8_analyzer_2_array_crystal_array_6 (Trace)");
  mcDEBUG_COMP("channel_8_analyzer_2_array_crystal_array_6")
  mcDEBUG_STATE(
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp)
#define x mcnlx
#define y mcnly
#define z mcnlz
#define vx mcnlvx
#define vy mcnlvy
#define vz mcnlvz
#define t mcnlt
#define sx mcnlsx
#define sy mcnlsy
#define sz mcnlsz
#define p mcnlp

#define mcabsorbComp mcabsorbCompchannel_8_analyzer_2_array_crystal_array_6
  STORE_NEUTRON(451,
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp);
  mcScattered=0;
  mcRestore=0;
  mcNCounter[451]++;
  mcPCounter[451] += p;
  mcP2Counter[451] += p*p;
#define mccompcurname  channel_8_analyzer_2_array_crystal_array_6
#define mccompcurtype  Union_box
#define mccompcurindex 451
#define loop_index mccchannel_8_analyzer_2_array_crystal_array_6_loop_index
#define this_box_volume mccchannel_8_analyzer_2_array_crystal_array_6_this_box_volume
#define global_geometry_element mccchannel_8_analyzer_2_array_crystal_array_6_global_geometry_element
#define this_box_storage mccchannel_8_analyzer_2_array_crystal_array_6_this_box_storage
{   /* Declarations of channel_8_analyzer_2_array_crystal_array_6=Union_box() SETTING parameters. */
char* material_string = mccchannel_8_analyzer_2_array_crystal_array_6_material_string;
MCNUM priority = mccchannel_8_analyzer_2_array_crystal_array_6_priority;
MCNUM xwidth = mccchannel_8_analyzer_2_array_crystal_array_6_xwidth;
MCNUM yheight = mccchannel_8_analyzer_2_array_crystal_array_6_yheight;
MCNUM zdepth = mccchannel_8_analyzer_2_array_crystal_array_6_zdepth;
MCNUM xwidth2 = mccchannel_8_analyzer_2_array_crystal_array_6_xwidth2;
MCNUM yheight2 = mccchannel_8_analyzer_2_array_crystal_array_6_yheight2;
MCNUM visualize = mccchannel_8_analyzer_2_array_crystal_array_6_visualize;
int target_index = mccchannel_8_analyzer_2_array_crystal_array_6_target_index;
MCNUM target_x = mccchannel_8_analyzer_2_array_crystal_array_6_target_x;
MCNUM target_y = mccchannel_8_analyzer_2_array_crystal_array_6_target_y;
MCNUM target_z = mccchannel_8_analyzer_2_array_crystal_array_6_target_z;
MCNUM focus_aw = mccchannel_8_analyzer_2_array_crystal_array_6_focus_aw;
MCNUM focus_ah = mccchannel_8_analyzer_2_array_crystal_array_6_focus_ah;
MCNUM focus_xw = mccchannel_8_analyzer_2_array_crystal_array_6_focus_xw;
MCNUM focus_xh = mccchannel_8_analyzer_2_array_crystal_array_6_focus_xh;
MCNUM focus_r = mccchannel_8_analyzer_2_array_crystal_array_6_focus_r;
MCNUM p_interact = mccchannel_8_analyzer_2_array_crystal_array_6_p_interact;
char* mask_string = mccchannel_8_analyzer_2_array_crystal_array_6_mask_string;
char* mask_setting = mccchannel_8_analyzer_2_array_crystal_array_6_mask_setting;
MCNUM number_of_activations = mccchannel_8_analyzer_2_array_crystal_array_6_number_of_activations;
}   /* End of channel_8_analyzer_2_array_crystal_array_6=Union_box() SETTING parameter declarations. */
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex
  /* Label for restoring  neutron */
  mcabsorbCompchannel_8_analyzer_2_array_crystal_array_6:
  if (RESTORE) /* restore if needed */
  { RESTORE_NEUTRON(451,
      mcnlx,
      mcnly,
      mcnlz,
      mcnlvx,
      mcnlvy,
      mcnlvz,
      mcnlt,
      mcnlsx,
      mcnlsy,
      mcnlsz,
      mcnlp); }
#undef mcabsorbComp
#undef p
#undef sz
#undef sy
#undef sx
#undef t
#undef vz
#undef vy
#undef vx
#undef z
#undef y
#undef x
  mcDEBUG_STATE(
mcnlx,
mcnly,
mcnlz,
mcnlvx,
mcnlvy,
mcnlvz,
mcnlt,
mcnlsx,
mcnlsy,
mcnlsz,
mcnlp)

  /* TRACE Component channel_8_analyzer_2_array_crystal_array_7 [452] */
  mccoordschange(mcposrchannel_8_analyzer_2_array_crystal_array_7, mcrotrchannel_8_analyzer_2_array_crystal_array_7,
    &mcnlx,
    &mcnly,
    &mcnlz,
    &mcnlvx,
    &mcnlvy,
    &mcnlvz,
    &mcnlsx,
    &mcnlsy,
    &mcnlsz);
  /* define label inside component channel_8_analyzer_2_array_crystal_array_7 (without coords transformations) */
  mcJumpTrace_channel_8_analyzer_2_array_crystal_array_7:
  SIG_MESSAGE("channel_8_analyzer_2_array_crystal_array_7 (Trace)");
  mcDEBUG_COMP("channel_8_analyzer_2_array_crystal_array_7")
  mcDEBUG_STATE(
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp)
#define x mcnlx
#define y mcnly
#define z mcnlz
#define vx mcnlvx
#define vy mcnlvy
#define vz mcnlvz
#define t mcnlt
#define sx mcnlsx
#define sy mcnlsy
#define sz mcnlsz
#define p mcnlp

#define mcabsorbComp mcabsorbCompchannel_8_analyzer_2_array_crystal_array_7
  STORE_NEUTRON(452,
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp);
  mcScattered=0;
  mcRestore=0;
  mcNCounter[452]++;
  mcPCounter[452] += p;
  mcP2Counter[452] += p*p;
#define mccompcurname  channel_8_analyzer_2_array_crystal_array_7
#define mccompcurtype  Union_box
#define mccompcurindex 452
#define loop_index mccchannel_8_analyzer_2_array_crystal_array_7_loop_index
#define this_box_volume mccchannel_8_analyzer_2_array_crystal_array_7_this_box_volume
#define global_geometry_element mccchannel_8_analyzer_2_array_crystal_array_7_global_geometry_element
#define this_box_storage mccchannel_8_analyzer_2_array_crystal_array_7_this_box_storage
{   /* Declarations of channel_8_analyzer_2_array_crystal_array_7=Union_box() SETTING parameters. */
char* material_string = mccchannel_8_analyzer_2_array_crystal_array_7_material_string;
MCNUM priority = mccchannel_8_analyzer_2_array_crystal_array_7_priority;
MCNUM xwidth = mccchannel_8_analyzer_2_array_crystal_array_7_xwidth;
MCNUM yheight = mccchannel_8_analyzer_2_array_crystal_array_7_yheight;
MCNUM zdepth = mccchannel_8_analyzer_2_array_crystal_array_7_zdepth;
MCNUM xwidth2 = mccchannel_8_analyzer_2_array_crystal_array_7_xwidth2;
MCNUM yheight2 = mccchannel_8_analyzer_2_array_crystal_array_7_yheight2;
MCNUM visualize = mccchannel_8_analyzer_2_array_crystal_array_7_visualize;
int target_index = mccchannel_8_analyzer_2_array_crystal_array_7_target_index;
MCNUM target_x = mccchannel_8_analyzer_2_array_crystal_array_7_target_x;
MCNUM target_y = mccchannel_8_analyzer_2_array_crystal_array_7_target_y;
MCNUM target_z = mccchannel_8_analyzer_2_array_crystal_array_7_target_z;
MCNUM focus_aw = mccchannel_8_analyzer_2_array_crystal_array_7_focus_aw;
MCNUM focus_ah = mccchannel_8_analyzer_2_array_crystal_array_7_focus_ah;
MCNUM focus_xw = mccchannel_8_analyzer_2_array_crystal_array_7_focus_xw;
MCNUM focus_xh = mccchannel_8_analyzer_2_array_crystal_array_7_focus_xh;
MCNUM focus_r = mccchannel_8_analyzer_2_array_crystal_array_7_focus_r;
MCNUM p_interact = mccchannel_8_analyzer_2_array_crystal_array_7_p_interact;
char* mask_string = mccchannel_8_analyzer_2_array_crystal_array_7_mask_string;
char* mask_setting = mccchannel_8_analyzer_2_array_crystal_array_7_mask_setting;
MCNUM number_of_activations = mccchannel_8_analyzer_2_array_crystal_array_7_number_of_activations;
}   /* End of channel_8_analyzer_2_array_crystal_array_7=Union_box() SETTING parameter declarations. */
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex
  /* Label for restoring  neutron */
  mcabsorbCompchannel_8_analyzer_2_array_crystal_array_7:
  if (RESTORE) /* restore if needed */
  { RESTORE_NEUTRON(452,
      mcnlx,
      mcnly,
      mcnlz,
      mcnlvx,
      mcnlvy,
      mcnlvz,
      mcnlt,
      mcnlsx,
      mcnlsy,
      mcnlsz,
      mcnlp); }
#undef mcabsorbComp
#undef p
#undef sz
#undef sy
#undef sx
#undef t
#undef vz
#undef vy
#undef vx
#undef z
#undef y
#undef x
  mcDEBUG_STATE(
mcnlx,
mcnly,
mcnlz,
mcnlvx,
mcnlvy,
mcnlvz,
mcnlt,
mcnlsx,
mcnlsy,
mcnlsz,
mcnlp)

  /* TRACE Component channel_8_analyzer_2_array_crystal_array_8 [453] */
  mccoordschange(mcposrchannel_8_analyzer_2_array_crystal_array_8, mcrotrchannel_8_analyzer_2_array_crystal_array_8,
    &mcnlx,
    &mcnly,
    &mcnlz,
    &mcnlvx,
    &mcnlvy,
    &mcnlvz,
    &mcnlsx,
    &mcnlsy,
    &mcnlsz);
  /* define label inside component channel_8_analyzer_2_array_crystal_array_8 (without coords transformations) */
  mcJumpTrace_channel_8_analyzer_2_array_crystal_array_8:
  SIG_MESSAGE("channel_8_analyzer_2_array_crystal_array_8 (Trace)");
  mcDEBUG_COMP("channel_8_analyzer_2_array_crystal_array_8")
  mcDEBUG_STATE(
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp)
#define x mcnlx
#define y mcnly
#define z mcnlz
#define vx mcnlvx
#define vy mcnlvy
#define vz mcnlvz
#define t mcnlt
#define sx mcnlsx
#define sy mcnlsy
#define sz mcnlsz
#define p mcnlp

#define mcabsorbComp mcabsorbCompchannel_8_analyzer_2_array_crystal_array_8
  STORE_NEUTRON(453,
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp);
  mcScattered=0;
  mcRestore=0;
  mcNCounter[453]++;
  mcPCounter[453] += p;
  mcP2Counter[453] += p*p;
#define mccompcurname  channel_8_analyzer_2_array_crystal_array_8
#define mccompcurtype  Union_box
#define mccompcurindex 453
#define loop_index mccchannel_8_analyzer_2_array_crystal_array_8_loop_index
#define this_box_volume mccchannel_8_analyzer_2_array_crystal_array_8_this_box_volume
#define global_geometry_element mccchannel_8_analyzer_2_array_crystal_array_8_global_geometry_element
#define this_box_storage mccchannel_8_analyzer_2_array_crystal_array_8_this_box_storage
{   /* Declarations of channel_8_analyzer_2_array_crystal_array_8=Union_box() SETTING parameters. */
char* material_string = mccchannel_8_analyzer_2_array_crystal_array_8_material_string;
MCNUM priority = mccchannel_8_analyzer_2_array_crystal_array_8_priority;
MCNUM xwidth = mccchannel_8_analyzer_2_array_crystal_array_8_xwidth;
MCNUM yheight = mccchannel_8_analyzer_2_array_crystal_array_8_yheight;
MCNUM zdepth = mccchannel_8_analyzer_2_array_crystal_array_8_zdepth;
MCNUM xwidth2 = mccchannel_8_analyzer_2_array_crystal_array_8_xwidth2;
MCNUM yheight2 = mccchannel_8_analyzer_2_array_crystal_array_8_yheight2;
MCNUM visualize = mccchannel_8_analyzer_2_array_crystal_array_8_visualize;
int target_index = mccchannel_8_analyzer_2_array_crystal_array_8_target_index;
MCNUM target_x = mccchannel_8_analyzer_2_array_crystal_array_8_target_x;
MCNUM target_y = mccchannel_8_analyzer_2_array_crystal_array_8_target_y;
MCNUM target_z = mccchannel_8_analyzer_2_array_crystal_array_8_target_z;
MCNUM focus_aw = mccchannel_8_analyzer_2_array_crystal_array_8_focus_aw;
MCNUM focus_ah = mccchannel_8_analyzer_2_array_crystal_array_8_focus_ah;
MCNUM focus_xw = mccchannel_8_analyzer_2_array_crystal_array_8_focus_xw;
MCNUM focus_xh = mccchannel_8_analyzer_2_array_crystal_array_8_focus_xh;
MCNUM focus_r = mccchannel_8_analyzer_2_array_crystal_array_8_focus_r;
MCNUM p_interact = mccchannel_8_analyzer_2_array_crystal_array_8_p_interact;
char* mask_string = mccchannel_8_analyzer_2_array_crystal_array_8_mask_string;
char* mask_setting = mccchannel_8_analyzer_2_array_crystal_array_8_mask_setting;
MCNUM number_of_activations = mccchannel_8_analyzer_2_array_crystal_array_8_number_of_activations;
}   /* End of channel_8_analyzer_2_array_crystal_array_8=Union_box() SETTING parameter declarations. */
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex
  /* Label for restoring  neutron */
  mcabsorbCompchannel_8_analyzer_2_array_crystal_array_8:
  if (RESTORE) /* restore if needed */
  { RESTORE_NEUTRON(453,
      mcnlx,
      mcnly,
      mcnlz,
      mcnlvx,
      mcnlvy,
      mcnlvz,
      mcnlt,
      mcnlsx,
      mcnlsy,
      mcnlsz,
      mcnlp); }
#undef mcabsorbComp
#undef p
#undef sz
#undef sy
#undef sx
#undef t
#undef vz
#undef vy
#undef vx
#undef z
#undef y
#undef x
  mcDEBUG_STATE(
mcnlx,
mcnly,
mcnlz,
mcnlvx,
mcnlvy,
mcnlvz,
mcnlt,
mcnlsx,
mcnlsy,
mcnlsz,
mcnlp)

  /* TRACE Component channel_8_cave2_cyl1 [454] */
  mccoordschange(mcposrchannel_8_cave2_cyl1, mcrotrchannel_8_cave2_cyl1,
    &mcnlx,
    &mcnly,
    &mcnlz,
    &mcnlvx,
    &mcnlvy,
    &mcnlvz,
    &mcnlsx,
    &mcnlsy,
    &mcnlsz);
  /* define label inside component channel_8_cave2_cyl1 (without coords transformations) */
  mcJumpTrace_channel_8_cave2_cyl1:
  SIG_MESSAGE("channel_8_cave2_cyl1 (Trace)");
  mcDEBUG_COMP("channel_8_cave2_cyl1")
  mcDEBUG_STATE(
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp)
#define x mcnlx
#define y mcnly
#define z mcnlz
#define vx mcnlvx
#define vy mcnlvy
#define vz mcnlvz
#define t mcnlt
#define sx mcnlsx
#define sy mcnlsy
#define sz mcnlsz
#define p mcnlp

#define mcabsorbComp mcabsorbCompchannel_8_cave2_cyl1
  STORE_NEUTRON(454,
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp);
  mcScattered=0;
  mcRestore=0;
  mcNCounter[454]++;
  mcPCounter[454] += p;
  mcP2Counter[454] += p*p;
#define mccompcurname  channel_8_cave2_cyl1
#define mccompcurtype  Union_cylinder
#define mccompcurindex 454
#define loop_index mccchannel_8_cave2_cyl1_loop_index
#define this_cylinder_volume mccchannel_8_cave2_cyl1_this_cylinder_volume
#define global_geometry_element mccchannel_8_cave2_cyl1_global_geometry_element
#define this_cylinder_storage mccchannel_8_cave2_cyl1_this_cylinder_storage
{   /* Declarations of channel_8_cave2_cyl1=Union_cylinder() SETTING parameters. */
char* material_string = mccchannel_8_cave2_cyl1_material_string;
MCNUM priority = mccchannel_8_cave2_cyl1_priority;
MCNUM radius = mccchannel_8_cave2_cyl1_radius;
MCNUM yheight = mccchannel_8_cave2_cyl1_yheight;
MCNUM visualize = mccchannel_8_cave2_cyl1_visualize;
int target_index = mccchannel_8_cave2_cyl1_target_index;
MCNUM target_x = mccchannel_8_cave2_cyl1_target_x;
MCNUM target_y = mccchannel_8_cave2_cyl1_target_y;
MCNUM target_z = mccchannel_8_cave2_cyl1_target_z;
MCNUM focus_aw = mccchannel_8_cave2_cyl1_focus_aw;
MCNUM focus_ah = mccchannel_8_cave2_cyl1_focus_ah;
MCNUM focus_xw = mccchannel_8_cave2_cyl1_focus_xw;
MCNUM focus_xh = mccchannel_8_cave2_cyl1_focus_xh;
MCNUM focus_r = mccchannel_8_cave2_cyl1_focus_r;
MCNUM p_interact = mccchannel_8_cave2_cyl1_p_interact;
char* mask_string = mccchannel_8_cave2_cyl1_mask_string;
char* mask_setting = mccchannel_8_cave2_cyl1_mask_setting;
MCNUM number_of_activations = mccchannel_8_cave2_cyl1_number_of_activations;
#line 345 "Union_cylinder.comp"
{
dummy = 1;
}
#line 405546 "MACS_sample_kidney_box.c"
}   /* End of channel_8_cave2_cyl1=Union_cylinder() SETTING parameter declarations. */
#undef this_cylinder_storage
#undef global_geometry_element
#undef this_cylinder_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex
  /* Label for restoring  neutron */
  mcabsorbCompchannel_8_cave2_cyl1:
  if (RESTORE) /* restore if needed */
  { RESTORE_NEUTRON(454,
      mcnlx,
      mcnly,
      mcnlz,
      mcnlvx,
      mcnlvy,
      mcnlvz,
      mcnlt,
      mcnlsx,
      mcnlsy,
      mcnlsz,
      mcnlp); }
#undef mcabsorbComp
#undef p
#undef sz
#undef sy
#undef sx
#undef t
#undef vz
#undef vy
#undef vx
#undef z
#undef y
#undef x
  mcDEBUG_STATE(
mcnlx,
mcnly,
mcnlz,
mcnlvx,
mcnlvy,
mcnlvz,
mcnlt,
mcnlsx,
mcnlsy,
mcnlsz,
mcnlp)

  /* TRACE Component channel_8_cave2_box1 [455] */
  mccoordschange(mcposrchannel_8_cave2_box1, mcrotrchannel_8_cave2_box1,
    &mcnlx,
    &mcnly,
    &mcnlz,
    &mcnlvx,
    &mcnlvy,
    &mcnlvz,
    &mcnlsx,
    &mcnlsy,
    &mcnlsz);
  /* define label inside component channel_8_cave2_box1 (without coords transformations) */
  mcJumpTrace_channel_8_cave2_box1:
  SIG_MESSAGE("channel_8_cave2_box1 (Trace)");
  mcDEBUG_COMP("channel_8_cave2_box1")
  mcDEBUG_STATE(
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp)
#define x mcnlx
#define y mcnly
#define z mcnlz
#define vx mcnlvx
#define vy mcnlvy
#define vz mcnlvz
#define t mcnlt
#define sx mcnlsx
#define sy mcnlsy
#define sz mcnlsz
#define p mcnlp

#define mcabsorbComp mcabsorbCompchannel_8_cave2_box1
  STORE_NEUTRON(455,
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp);
  mcScattered=0;
  mcRestore=0;
  mcNCounter[455]++;
  mcPCounter[455] += p;
  mcP2Counter[455] += p*p;
#define mccompcurname  channel_8_cave2_box1
#define mccompcurtype  Union_box
#define mccompcurindex 455
#define loop_index mccchannel_8_cave2_box1_loop_index
#define this_box_volume mccchannel_8_cave2_box1_this_box_volume
#define global_geometry_element mccchannel_8_cave2_box1_global_geometry_element
#define this_box_storage mccchannel_8_cave2_box1_this_box_storage
{   /* Declarations of channel_8_cave2_box1=Union_box() SETTING parameters. */
char* material_string = mccchannel_8_cave2_box1_material_string;
MCNUM priority = mccchannel_8_cave2_box1_priority;
MCNUM xwidth = mccchannel_8_cave2_box1_xwidth;
MCNUM yheight = mccchannel_8_cave2_box1_yheight;
MCNUM zdepth = mccchannel_8_cave2_box1_zdepth;
MCNUM xwidth2 = mccchannel_8_cave2_box1_xwidth2;
MCNUM yheight2 = mccchannel_8_cave2_box1_yheight2;
MCNUM visualize = mccchannel_8_cave2_box1_visualize;
int target_index = mccchannel_8_cave2_box1_target_index;
MCNUM target_x = mccchannel_8_cave2_box1_target_x;
MCNUM target_y = mccchannel_8_cave2_box1_target_y;
MCNUM target_z = mccchannel_8_cave2_box1_target_z;
MCNUM focus_aw = mccchannel_8_cave2_box1_focus_aw;
MCNUM focus_ah = mccchannel_8_cave2_box1_focus_ah;
MCNUM focus_xw = mccchannel_8_cave2_box1_focus_xw;
MCNUM focus_xh = mccchannel_8_cave2_box1_focus_xh;
MCNUM focus_r = mccchannel_8_cave2_box1_focus_r;
MCNUM p_interact = mccchannel_8_cave2_box1_p_interact;
char* mask_string = mccchannel_8_cave2_box1_mask_string;
char* mask_setting = mccchannel_8_cave2_box1_mask_setting;
MCNUM number_of_activations = mccchannel_8_cave2_box1_number_of_activations;
}   /* End of channel_8_cave2_box1=Union_box() SETTING parameter declarations. */
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex
  /* Label for restoring  neutron */
  mcabsorbCompchannel_8_cave2_box1:
  if (RESTORE) /* restore if needed */
  { RESTORE_NEUTRON(455,
      mcnlx,
      mcnly,
      mcnlz,
      mcnlvx,
      mcnlvy,
      mcnlvz,
      mcnlt,
      mcnlsx,
      mcnlsy,
      mcnlsz,
      mcnlp); }
#undef mcabsorbComp
#undef p
#undef sz
#undef sy
#undef sx
#undef t
#undef vz
#undef vy
#undef vx
#undef z
#undef y
#undef x
  mcDEBUG_STATE(
mcnlx,
mcnly,
mcnlz,
mcnlvx,
mcnlvy,
mcnlvz,
mcnlt,
mcnlsx,
mcnlsy,
mcnlsz,
mcnlp)

  /* TRACE Component channel_8_cave2_box2 [456] */
  mccoordschange(mcposrchannel_8_cave2_box2, mcrotrchannel_8_cave2_box2,
    &mcnlx,
    &mcnly,
    &mcnlz,
    &mcnlvx,
    &mcnlvy,
    &mcnlvz,
    &mcnlsx,
    &mcnlsy,
    &mcnlsz);
  /* define label inside component channel_8_cave2_box2 (without coords transformations) */
  mcJumpTrace_channel_8_cave2_box2:
  SIG_MESSAGE("channel_8_cave2_box2 (Trace)");
  mcDEBUG_COMP("channel_8_cave2_box2")
  mcDEBUG_STATE(
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp)
#define x mcnlx
#define y mcnly
#define z mcnlz
#define vx mcnlvx
#define vy mcnlvy
#define vz mcnlvz
#define t mcnlt
#define sx mcnlsx
#define sy mcnlsy
#define sz mcnlsz
#define p mcnlp

#define mcabsorbComp mcabsorbCompchannel_8_cave2_box2
  STORE_NEUTRON(456,
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp);
  mcScattered=0;
  mcRestore=0;
  mcNCounter[456]++;
  mcPCounter[456] += p;
  mcP2Counter[456] += p*p;
#define mccompcurname  channel_8_cave2_box2
#define mccompcurtype  Union_box
#define mccompcurindex 456
#define loop_index mccchannel_8_cave2_box2_loop_index
#define this_box_volume mccchannel_8_cave2_box2_this_box_volume
#define global_geometry_element mccchannel_8_cave2_box2_global_geometry_element
#define this_box_storage mccchannel_8_cave2_box2_this_box_storage
{   /* Declarations of channel_8_cave2_box2=Union_box() SETTING parameters. */
char* material_string = mccchannel_8_cave2_box2_material_string;
MCNUM priority = mccchannel_8_cave2_box2_priority;
MCNUM xwidth = mccchannel_8_cave2_box2_xwidth;
MCNUM yheight = mccchannel_8_cave2_box2_yheight;
MCNUM zdepth = mccchannel_8_cave2_box2_zdepth;
MCNUM xwidth2 = mccchannel_8_cave2_box2_xwidth2;
MCNUM yheight2 = mccchannel_8_cave2_box2_yheight2;
MCNUM visualize = mccchannel_8_cave2_box2_visualize;
int target_index = mccchannel_8_cave2_box2_target_index;
MCNUM target_x = mccchannel_8_cave2_box2_target_x;
MCNUM target_y = mccchannel_8_cave2_box2_target_y;
MCNUM target_z = mccchannel_8_cave2_box2_target_z;
MCNUM focus_aw = mccchannel_8_cave2_box2_focus_aw;
MCNUM focus_ah = mccchannel_8_cave2_box2_focus_ah;
MCNUM focus_xw = mccchannel_8_cave2_box2_focus_xw;
MCNUM focus_xh = mccchannel_8_cave2_box2_focus_xh;
MCNUM focus_r = mccchannel_8_cave2_box2_focus_r;
MCNUM p_interact = mccchannel_8_cave2_box2_p_interact;
char* mask_string = mccchannel_8_cave2_box2_mask_string;
char* mask_setting = mccchannel_8_cave2_box2_mask_setting;
MCNUM number_of_activations = mccchannel_8_cave2_box2_number_of_activations;
}   /* End of channel_8_cave2_box2=Union_box() SETTING parameter declarations. */
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex
  /* Label for restoring  neutron */
  mcabsorbCompchannel_8_cave2_box2:
  if (RESTORE) /* restore if needed */
  { RESTORE_NEUTRON(456,
      mcnlx,
      mcnly,
      mcnlz,
      mcnlvx,
      mcnlvy,
      mcnlvz,
      mcnlt,
      mcnlsx,
      mcnlsy,
      mcnlsz,
      mcnlp); }
#undef mcabsorbComp
#undef p
#undef sz
#undef sy
#undef sx
#undef t
#undef vz
#undef vy
#undef vx
#undef z
#undef y
#undef x
  mcDEBUG_STATE(
mcnlx,
mcnly,
mcnlz,
mcnlvx,
mcnlvy,
mcnlvz,
mcnlt,
mcnlsx,
mcnlsy,
mcnlsz,
mcnlp)

  /* TRACE Component channel_8_cave2_box3 [457] */
  mccoordschange(mcposrchannel_8_cave2_box3, mcrotrchannel_8_cave2_box3,
    &mcnlx,
    &mcnly,
    &mcnlz,
    &mcnlvx,
    &mcnlvy,
    &mcnlvz,
    &mcnlsx,
    &mcnlsy,
    &mcnlsz);
  /* define label inside component channel_8_cave2_box3 (without coords transformations) */
  mcJumpTrace_channel_8_cave2_box3:
  SIG_MESSAGE("channel_8_cave2_box3 (Trace)");
  mcDEBUG_COMP("channel_8_cave2_box3")
  mcDEBUG_STATE(
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp)
#define x mcnlx
#define y mcnly
#define z mcnlz
#define vx mcnlvx
#define vy mcnlvy
#define vz mcnlvz
#define t mcnlt
#define sx mcnlsx
#define sy mcnlsy
#define sz mcnlsz
#define p mcnlp

#define mcabsorbComp mcabsorbCompchannel_8_cave2_box3
  STORE_NEUTRON(457,
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp);
  mcScattered=0;
  mcRestore=0;
  mcNCounter[457]++;
  mcPCounter[457] += p;
  mcP2Counter[457] += p*p;
#define mccompcurname  channel_8_cave2_box3
#define mccompcurtype  Union_box
#define mccompcurindex 457
#define loop_index mccchannel_8_cave2_box3_loop_index
#define this_box_volume mccchannel_8_cave2_box3_this_box_volume
#define global_geometry_element mccchannel_8_cave2_box3_global_geometry_element
#define this_box_storage mccchannel_8_cave2_box3_this_box_storage
{   /* Declarations of channel_8_cave2_box3=Union_box() SETTING parameters. */
char* material_string = mccchannel_8_cave2_box3_material_string;
MCNUM priority = mccchannel_8_cave2_box3_priority;
MCNUM xwidth = mccchannel_8_cave2_box3_xwidth;
MCNUM yheight = mccchannel_8_cave2_box3_yheight;
MCNUM zdepth = mccchannel_8_cave2_box3_zdepth;
MCNUM xwidth2 = mccchannel_8_cave2_box3_xwidth2;
MCNUM yheight2 = mccchannel_8_cave2_box3_yheight2;
MCNUM visualize = mccchannel_8_cave2_box3_visualize;
int target_index = mccchannel_8_cave2_box3_target_index;
MCNUM target_x = mccchannel_8_cave2_box3_target_x;
MCNUM target_y = mccchannel_8_cave2_box3_target_y;
MCNUM target_z = mccchannel_8_cave2_box3_target_z;
MCNUM focus_aw = mccchannel_8_cave2_box3_focus_aw;
MCNUM focus_ah = mccchannel_8_cave2_box3_focus_ah;
MCNUM focus_xw = mccchannel_8_cave2_box3_focus_xw;
MCNUM focus_xh = mccchannel_8_cave2_box3_focus_xh;
MCNUM focus_r = mccchannel_8_cave2_box3_focus_r;
MCNUM p_interact = mccchannel_8_cave2_box3_p_interact;
char* mask_string = mccchannel_8_cave2_box3_mask_string;
char* mask_setting = mccchannel_8_cave2_box3_mask_setting;
MCNUM number_of_activations = mccchannel_8_cave2_box3_number_of_activations;
}   /* End of channel_8_cave2_box3=Union_box() SETTING parameter declarations. */
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex
  /* Label for restoring  neutron */
  mcabsorbCompchannel_8_cave2_box3:
  if (RESTORE) /* restore if needed */
  { RESTORE_NEUTRON(457,
      mcnlx,
      mcnly,
      mcnlz,
      mcnlvx,
      mcnlvy,
      mcnlvz,
      mcnlt,
      mcnlsx,
      mcnlsy,
      mcnlsz,
      mcnlp); }
#undef mcabsorbComp
#undef p
#undef sz
#undef sy
#undef sx
#undef t
#undef vz
#undef vy
#undef vx
#undef z
#undef y
#undef x
  mcDEBUG_STATE(
mcnlx,
mcnly,
mcnlz,
mcnlvx,
mcnlvy,
mcnlvz,
mcnlt,
mcnlsx,
mcnlsy,
mcnlsz,
mcnlp)

  /* TRACE Component inter_analyzer_colimator_center_8 [458] */
  mccoordschange(mcposrinter_analyzer_colimator_center_8, mcrotrinter_analyzer_colimator_center_8,
    &mcnlx,
    &mcnly,
    &mcnlz,
    &mcnlvx,
    &mcnlvy,
    &mcnlvz,
    &mcnlsx,
    &mcnlsy,
    &mcnlsz);
  /* define label inside component inter_analyzer_colimator_center_8 (without coords transformations) */
  mcJumpTrace_inter_analyzer_colimator_center_8:
  SIG_MESSAGE("inter_analyzer_colimator_center_8 (Trace)");
  mcDEBUG_COMP("inter_analyzer_colimator_center_8")
  mcDEBUG_STATE(
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp)
#define x mcnlx
#define y mcnly
#define z mcnlz
#define vx mcnlvx
#define vy mcnlvy
#define vz mcnlvz
#define t mcnlt
#define sx mcnlsx
#define sy mcnlsy
#define sz mcnlsz
#define p mcnlp

#define mcabsorbComp mcabsorbCompinter_analyzer_colimator_center_8
  STORE_NEUTRON(458,
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp);
  mcScattered=0;
  mcRestore=0;
  mcNCounter[458]++;
  mcPCounter[458] += p;
  mcP2Counter[458] += p*p;
#define mccompcurname  inter_analyzer_colimator_center_8
#define mccompcurtype  Arm
#define mccompcurindex 458
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex
  /* Label for restoring  neutron */
  mcabsorbCompinter_analyzer_colimator_center_8:
  if (RESTORE) /* restore if needed */
  { RESTORE_NEUTRON(458,
      mcnlx,
      mcnly,
      mcnlz,
      mcnlvx,
      mcnlvy,
      mcnlvz,
      mcnlt,
      mcnlsx,
      mcnlsy,
      mcnlsz,
      mcnlp); }
#undef mcabsorbComp
#undef p
#undef sz
#undef sy
#undef sx
#undef t
#undef vz
#undef vy
#undef vx
#undef z
#undef y
#undef x
  mcDEBUG_STATE(
mcnlx,
mcnly,
mcnlz,
mcnlvx,
mcnlvy,
mcnlvz,
mcnlt,
mcnlsx,
mcnlsy,
mcnlsz,
mcnlp)

  /* TRACE Component inter_analyzer_colimator_8_blade_0 [459] */
  mccoordschange(mcposrinter_analyzer_colimator_8_blade_0, mcrotrinter_analyzer_colimator_8_blade_0,
    &mcnlx,
    &mcnly,
    &mcnlz,
    &mcnlvx,
    &mcnlvy,
    &mcnlvz,
    &mcnlsx,
    &mcnlsy,
    &mcnlsz);
  /* define label inside component inter_analyzer_colimator_8_blade_0 (without coords transformations) */
  mcJumpTrace_inter_analyzer_colimator_8_blade_0:
  SIG_MESSAGE("inter_analyzer_colimator_8_blade_0 (Trace)");
  mcDEBUG_COMP("inter_analyzer_colimator_8_blade_0")
  mcDEBUG_STATE(
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp)
#define x mcnlx
#define y mcnly
#define z mcnlz
#define vx mcnlvx
#define vy mcnlvy
#define vz mcnlvz
#define t mcnlt
#define sx mcnlsx
#define sy mcnlsy
#define sz mcnlsz
#define p mcnlp

#define mcabsorbComp mcabsorbCompinter_analyzer_colimator_8_blade_0
  STORE_NEUTRON(459,
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp);
  mcScattered=0;
  mcRestore=0;
  mcNCounter[459]++;
  mcPCounter[459] += p;
  mcP2Counter[459] += p*p;
#define mccompcurname  inter_analyzer_colimator_8_blade_0
#define mccompcurtype  Union_box
#define mccompcurindex 459
#define loop_index mccinter_analyzer_colimator_8_blade_0_loop_index
#define this_box_volume mccinter_analyzer_colimator_8_blade_0_this_box_volume
#define global_geometry_element mccinter_analyzer_colimator_8_blade_0_global_geometry_element
#define this_box_storage mccinter_analyzer_colimator_8_blade_0_this_box_storage
{   /* Declarations of inter_analyzer_colimator_8_blade_0=Union_box() SETTING parameters. */
char* material_string = mccinter_analyzer_colimator_8_blade_0_material_string;
MCNUM priority = mccinter_analyzer_colimator_8_blade_0_priority;
MCNUM xwidth = mccinter_analyzer_colimator_8_blade_0_xwidth;
MCNUM yheight = mccinter_analyzer_colimator_8_blade_0_yheight;
MCNUM zdepth = mccinter_analyzer_colimator_8_blade_0_zdepth;
MCNUM xwidth2 = mccinter_analyzer_colimator_8_blade_0_xwidth2;
MCNUM yheight2 = mccinter_analyzer_colimator_8_blade_0_yheight2;
MCNUM visualize = mccinter_analyzer_colimator_8_blade_0_visualize;
int target_index = mccinter_analyzer_colimator_8_blade_0_target_index;
MCNUM target_x = mccinter_analyzer_colimator_8_blade_0_target_x;
MCNUM target_y = mccinter_analyzer_colimator_8_blade_0_target_y;
MCNUM target_z = mccinter_analyzer_colimator_8_blade_0_target_z;
MCNUM focus_aw = mccinter_analyzer_colimator_8_blade_0_focus_aw;
MCNUM focus_ah = mccinter_analyzer_colimator_8_blade_0_focus_ah;
MCNUM focus_xw = mccinter_analyzer_colimator_8_blade_0_focus_xw;
MCNUM focus_xh = mccinter_analyzer_colimator_8_blade_0_focus_xh;
MCNUM focus_r = mccinter_analyzer_colimator_8_blade_0_focus_r;
MCNUM p_interact = mccinter_analyzer_colimator_8_blade_0_p_interact;
char* mask_string = mccinter_analyzer_colimator_8_blade_0_mask_string;
char* mask_setting = mccinter_analyzer_colimator_8_blade_0_mask_setting;
MCNUM number_of_activations = mccinter_analyzer_colimator_8_blade_0_number_of_activations;
}   /* End of inter_analyzer_colimator_8_blade_0=Union_box() SETTING parameter declarations. */
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex
  /* Label for restoring  neutron */
  mcabsorbCompinter_analyzer_colimator_8_blade_0:
  if (RESTORE) /* restore if needed */
  { RESTORE_NEUTRON(459,
      mcnlx,
      mcnly,
      mcnlz,
      mcnlvx,
      mcnlvy,
      mcnlvz,
      mcnlt,
      mcnlsx,
      mcnlsy,
      mcnlsz,
      mcnlp); }
#undef mcabsorbComp
#undef p
#undef sz
#undef sy
#undef sx
#undef t
#undef vz
#undef vy
#undef vx
#undef z
#undef y
#undef x
  mcDEBUG_STATE(
mcnlx,
mcnly,
mcnlz,
mcnlvx,
mcnlvy,
mcnlvz,
mcnlt,
mcnlsx,
mcnlsy,
mcnlsz,
mcnlp)

  /* TRACE Component inter_analyzer_colimator_8_blade_1 [460] */
  mccoordschange(mcposrinter_analyzer_colimator_8_blade_1, mcrotrinter_analyzer_colimator_8_blade_1,
    &mcnlx,
    &mcnly,
    &mcnlz,
    &mcnlvx,
    &mcnlvy,
    &mcnlvz,
    &mcnlsx,
    &mcnlsy,
    &mcnlsz);
  /* define label inside component inter_analyzer_colimator_8_blade_1 (without coords transformations) */
  mcJumpTrace_inter_analyzer_colimator_8_blade_1:
  SIG_MESSAGE("inter_analyzer_colimator_8_blade_1 (Trace)");
  mcDEBUG_COMP("inter_analyzer_colimator_8_blade_1")
  mcDEBUG_STATE(
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp)
#define x mcnlx
#define y mcnly
#define z mcnlz
#define vx mcnlvx
#define vy mcnlvy
#define vz mcnlvz
#define t mcnlt
#define sx mcnlsx
#define sy mcnlsy
#define sz mcnlsz
#define p mcnlp

#define mcabsorbComp mcabsorbCompinter_analyzer_colimator_8_blade_1
  STORE_NEUTRON(460,
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp);
  mcScattered=0;
  mcRestore=0;
  mcNCounter[460]++;
  mcPCounter[460] += p;
  mcP2Counter[460] += p*p;
#define mccompcurname  inter_analyzer_colimator_8_blade_1
#define mccompcurtype  Union_box
#define mccompcurindex 460
#define loop_index mccinter_analyzer_colimator_8_blade_1_loop_index
#define this_box_volume mccinter_analyzer_colimator_8_blade_1_this_box_volume
#define global_geometry_element mccinter_analyzer_colimator_8_blade_1_global_geometry_element
#define this_box_storage mccinter_analyzer_colimator_8_blade_1_this_box_storage
{   /* Declarations of inter_analyzer_colimator_8_blade_1=Union_box() SETTING parameters. */
char* material_string = mccinter_analyzer_colimator_8_blade_1_material_string;
MCNUM priority = mccinter_analyzer_colimator_8_blade_1_priority;
MCNUM xwidth = mccinter_analyzer_colimator_8_blade_1_xwidth;
MCNUM yheight = mccinter_analyzer_colimator_8_blade_1_yheight;
MCNUM zdepth = mccinter_analyzer_colimator_8_blade_1_zdepth;
MCNUM xwidth2 = mccinter_analyzer_colimator_8_blade_1_xwidth2;
MCNUM yheight2 = mccinter_analyzer_colimator_8_blade_1_yheight2;
MCNUM visualize = mccinter_analyzer_colimator_8_blade_1_visualize;
int target_index = mccinter_analyzer_colimator_8_blade_1_target_index;
MCNUM target_x = mccinter_analyzer_colimator_8_blade_1_target_x;
MCNUM target_y = mccinter_analyzer_colimator_8_blade_1_target_y;
MCNUM target_z = mccinter_analyzer_colimator_8_blade_1_target_z;
MCNUM focus_aw = mccinter_analyzer_colimator_8_blade_1_focus_aw;
MCNUM focus_ah = mccinter_analyzer_colimator_8_blade_1_focus_ah;
MCNUM focus_xw = mccinter_analyzer_colimator_8_blade_1_focus_xw;
MCNUM focus_xh = mccinter_analyzer_colimator_8_blade_1_focus_xh;
MCNUM focus_r = mccinter_analyzer_colimator_8_blade_1_focus_r;
MCNUM p_interact = mccinter_analyzer_colimator_8_blade_1_p_interact;
char* mask_string = mccinter_analyzer_colimator_8_blade_1_mask_string;
char* mask_setting = mccinter_analyzer_colimator_8_blade_1_mask_setting;
MCNUM number_of_activations = mccinter_analyzer_colimator_8_blade_1_number_of_activations;
}   /* End of inter_analyzer_colimator_8_blade_1=Union_box() SETTING parameter declarations. */
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex
  /* Label for restoring  neutron */
  mcabsorbCompinter_analyzer_colimator_8_blade_1:
  if (RESTORE) /* restore if needed */
  { RESTORE_NEUTRON(460,
      mcnlx,
      mcnly,
      mcnlz,
      mcnlvx,
      mcnlvy,
      mcnlvz,
      mcnlt,
      mcnlsx,
      mcnlsy,
      mcnlsz,
      mcnlp); }
#undef mcabsorbComp
#undef p
#undef sz
#undef sy
#undef sx
#undef t
#undef vz
#undef vy
#undef vx
#undef z
#undef y
#undef x
  mcDEBUG_STATE(
mcnlx,
mcnly,
mcnlz,
mcnlvx,
mcnlvy,
mcnlvz,
mcnlt,
mcnlsx,
mcnlsy,
mcnlsz,
mcnlp)

  /* TRACE Component inter_analyzer_colimator_8_blade_2 [461] */
  mccoordschange(mcposrinter_analyzer_colimator_8_blade_2, mcrotrinter_analyzer_colimator_8_blade_2,
    &mcnlx,
    &mcnly,
    &mcnlz,
    &mcnlvx,
    &mcnlvy,
    &mcnlvz,
    &mcnlsx,
    &mcnlsy,
    &mcnlsz);
  /* define label inside component inter_analyzer_colimator_8_blade_2 (without coords transformations) */
  mcJumpTrace_inter_analyzer_colimator_8_blade_2:
  SIG_MESSAGE("inter_analyzer_colimator_8_blade_2 (Trace)");
  mcDEBUG_COMP("inter_analyzer_colimator_8_blade_2")
  mcDEBUG_STATE(
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp)
#define x mcnlx
#define y mcnly
#define z mcnlz
#define vx mcnlvx
#define vy mcnlvy
#define vz mcnlvz
#define t mcnlt
#define sx mcnlsx
#define sy mcnlsy
#define sz mcnlsz
#define p mcnlp

#define mcabsorbComp mcabsorbCompinter_analyzer_colimator_8_blade_2
  STORE_NEUTRON(461,
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp);
  mcScattered=0;
  mcRestore=0;
  mcNCounter[461]++;
  mcPCounter[461] += p;
  mcP2Counter[461] += p*p;
#define mccompcurname  inter_analyzer_colimator_8_blade_2
#define mccompcurtype  Union_box
#define mccompcurindex 461
#define loop_index mccinter_analyzer_colimator_8_blade_2_loop_index
#define this_box_volume mccinter_analyzer_colimator_8_blade_2_this_box_volume
#define global_geometry_element mccinter_analyzer_colimator_8_blade_2_global_geometry_element
#define this_box_storage mccinter_analyzer_colimator_8_blade_2_this_box_storage
{   /* Declarations of inter_analyzer_colimator_8_blade_2=Union_box() SETTING parameters. */
char* material_string = mccinter_analyzer_colimator_8_blade_2_material_string;
MCNUM priority = mccinter_analyzer_colimator_8_blade_2_priority;
MCNUM xwidth = mccinter_analyzer_colimator_8_blade_2_xwidth;
MCNUM yheight = mccinter_analyzer_colimator_8_blade_2_yheight;
MCNUM zdepth = mccinter_analyzer_colimator_8_blade_2_zdepth;
MCNUM xwidth2 = mccinter_analyzer_colimator_8_blade_2_xwidth2;
MCNUM yheight2 = mccinter_analyzer_colimator_8_blade_2_yheight2;
MCNUM visualize = mccinter_analyzer_colimator_8_blade_2_visualize;
int target_index = mccinter_analyzer_colimator_8_blade_2_target_index;
MCNUM target_x = mccinter_analyzer_colimator_8_blade_2_target_x;
MCNUM target_y = mccinter_analyzer_colimator_8_blade_2_target_y;
MCNUM target_z = mccinter_analyzer_colimator_8_blade_2_target_z;
MCNUM focus_aw = mccinter_analyzer_colimator_8_blade_2_focus_aw;
MCNUM focus_ah = mccinter_analyzer_colimator_8_blade_2_focus_ah;
MCNUM focus_xw = mccinter_analyzer_colimator_8_blade_2_focus_xw;
MCNUM focus_xh = mccinter_analyzer_colimator_8_blade_2_focus_xh;
MCNUM focus_r = mccinter_analyzer_colimator_8_blade_2_focus_r;
MCNUM p_interact = mccinter_analyzer_colimator_8_blade_2_p_interact;
char* mask_string = mccinter_analyzer_colimator_8_blade_2_mask_string;
char* mask_setting = mccinter_analyzer_colimator_8_blade_2_mask_setting;
MCNUM number_of_activations = mccinter_analyzer_colimator_8_blade_2_number_of_activations;
}   /* End of inter_analyzer_colimator_8_blade_2=Union_box() SETTING parameter declarations. */
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex
  /* Label for restoring  neutron */
  mcabsorbCompinter_analyzer_colimator_8_blade_2:
  if (RESTORE) /* restore if needed */
  { RESTORE_NEUTRON(461,
      mcnlx,
      mcnly,
      mcnlz,
      mcnlvx,
      mcnlvy,
      mcnlvz,
      mcnlt,
      mcnlsx,
      mcnlsy,
      mcnlsz,
      mcnlp); }
#undef mcabsorbComp
#undef p
#undef sz
#undef sy
#undef sx
#undef t
#undef vz
#undef vy
#undef vx
#undef z
#undef y
#undef x
  mcDEBUG_STATE(
mcnlx,
mcnly,
mcnlz,
mcnlvx,
mcnlvy,
mcnlvz,
mcnlt,
mcnlsx,
mcnlsy,
mcnlsz,
mcnlp)

  /* TRACE Component inter_analyzer_colimator_8_blade_3 [462] */
  mccoordschange(mcposrinter_analyzer_colimator_8_blade_3, mcrotrinter_analyzer_colimator_8_blade_3,
    &mcnlx,
    &mcnly,
    &mcnlz,
    &mcnlvx,
    &mcnlvy,
    &mcnlvz,
    &mcnlsx,
    &mcnlsy,
    &mcnlsz);
  /* define label inside component inter_analyzer_colimator_8_blade_3 (without coords transformations) */
  mcJumpTrace_inter_analyzer_colimator_8_blade_3:
  SIG_MESSAGE("inter_analyzer_colimator_8_blade_3 (Trace)");
  mcDEBUG_COMP("inter_analyzer_colimator_8_blade_3")
  mcDEBUG_STATE(
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp)
#define x mcnlx
#define y mcnly
#define z mcnlz
#define vx mcnlvx
#define vy mcnlvy
#define vz mcnlvz
#define t mcnlt
#define sx mcnlsx
#define sy mcnlsy
#define sz mcnlsz
#define p mcnlp

#define mcabsorbComp mcabsorbCompinter_analyzer_colimator_8_blade_3
  STORE_NEUTRON(462,
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp);
  mcScattered=0;
  mcRestore=0;
  mcNCounter[462]++;
  mcPCounter[462] += p;
  mcP2Counter[462] += p*p;
#define mccompcurname  inter_analyzer_colimator_8_blade_3
#define mccompcurtype  Union_box
#define mccompcurindex 462
#define loop_index mccinter_analyzer_colimator_8_blade_3_loop_index
#define this_box_volume mccinter_analyzer_colimator_8_blade_3_this_box_volume
#define global_geometry_element mccinter_analyzer_colimator_8_blade_3_global_geometry_element
#define this_box_storage mccinter_analyzer_colimator_8_blade_3_this_box_storage
{   /* Declarations of inter_analyzer_colimator_8_blade_3=Union_box() SETTING parameters. */
char* material_string = mccinter_analyzer_colimator_8_blade_3_material_string;
MCNUM priority = mccinter_analyzer_colimator_8_blade_3_priority;
MCNUM xwidth = mccinter_analyzer_colimator_8_blade_3_xwidth;
MCNUM yheight = mccinter_analyzer_colimator_8_blade_3_yheight;
MCNUM zdepth = mccinter_analyzer_colimator_8_blade_3_zdepth;
MCNUM xwidth2 = mccinter_analyzer_colimator_8_blade_3_xwidth2;
MCNUM yheight2 = mccinter_analyzer_colimator_8_blade_3_yheight2;
MCNUM visualize = mccinter_analyzer_colimator_8_blade_3_visualize;
int target_index = mccinter_analyzer_colimator_8_blade_3_target_index;
MCNUM target_x = mccinter_analyzer_colimator_8_blade_3_target_x;
MCNUM target_y = mccinter_analyzer_colimator_8_blade_3_target_y;
MCNUM target_z = mccinter_analyzer_colimator_8_blade_3_target_z;
MCNUM focus_aw = mccinter_analyzer_colimator_8_blade_3_focus_aw;
MCNUM focus_ah = mccinter_analyzer_colimator_8_blade_3_focus_ah;
MCNUM focus_xw = mccinter_analyzer_colimator_8_blade_3_focus_xw;
MCNUM focus_xh = mccinter_analyzer_colimator_8_blade_3_focus_xh;
MCNUM focus_r = mccinter_analyzer_colimator_8_blade_3_focus_r;
MCNUM p_interact = mccinter_analyzer_colimator_8_blade_3_p_interact;
char* mask_string = mccinter_analyzer_colimator_8_blade_3_mask_string;
char* mask_setting = mccinter_analyzer_colimator_8_blade_3_mask_setting;
MCNUM number_of_activations = mccinter_analyzer_colimator_8_blade_3_number_of_activations;
}   /* End of inter_analyzer_colimator_8_blade_3=Union_box() SETTING parameter declarations. */
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex
  /* Label for restoring  neutron */
  mcabsorbCompinter_analyzer_colimator_8_blade_3:
  if (RESTORE) /* restore if needed */
  { RESTORE_NEUTRON(462,
      mcnlx,
      mcnly,
      mcnlz,
      mcnlvx,
      mcnlvy,
      mcnlvz,
      mcnlt,
      mcnlsx,
      mcnlsy,
      mcnlsz,
      mcnlp); }
#undef mcabsorbComp
#undef p
#undef sz
#undef sy
#undef sx
#undef t
#undef vz
#undef vy
#undef vx
#undef z
#undef y
#undef x
  mcDEBUG_STATE(
mcnlx,
mcnly,
mcnlz,
mcnlvx,
mcnlvy,
mcnlvz,
mcnlt,
mcnlsx,
mcnlsy,
mcnlsz,
mcnlp)

  /* TRACE Component inter_analyzer_colimator_8_blade_4 [463] */
  mccoordschange(mcposrinter_analyzer_colimator_8_blade_4, mcrotrinter_analyzer_colimator_8_blade_4,
    &mcnlx,
    &mcnly,
    &mcnlz,
    &mcnlvx,
    &mcnlvy,
    &mcnlvz,
    &mcnlsx,
    &mcnlsy,
    &mcnlsz);
  /* define label inside component inter_analyzer_colimator_8_blade_4 (without coords transformations) */
  mcJumpTrace_inter_analyzer_colimator_8_blade_4:
  SIG_MESSAGE("inter_analyzer_colimator_8_blade_4 (Trace)");
  mcDEBUG_COMP("inter_analyzer_colimator_8_blade_4")
  mcDEBUG_STATE(
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp)
#define x mcnlx
#define y mcnly
#define z mcnlz
#define vx mcnlvx
#define vy mcnlvy
#define vz mcnlvz
#define t mcnlt
#define sx mcnlsx
#define sy mcnlsy
#define sz mcnlsz
#define p mcnlp

#define mcabsorbComp mcabsorbCompinter_analyzer_colimator_8_blade_4
  STORE_NEUTRON(463,
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp);
  mcScattered=0;
  mcRestore=0;
  mcNCounter[463]++;
  mcPCounter[463] += p;
  mcP2Counter[463] += p*p;
#define mccompcurname  inter_analyzer_colimator_8_blade_4
#define mccompcurtype  Union_box
#define mccompcurindex 463
#define loop_index mccinter_analyzer_colimator_8_blade_4_loop_index
#define this_box_volume mccinter_analyzer_colimator_8_blade_4_this_box_volume
#define global_geometry_element mccinter_analyzer_colimator_8_blade_4_global_geometry_element
#define this_box_storage mccinter_analyzer_colimator_8_blade_4_this_box_storage
{   /* Declarations of inter_analyzer_colimator_8_blade_4=Union_box() SETTING parameters. */
char* material_string = mccinter_analyzer_colimator_8_blade_4_material_string;
MCNUM priority = mccinter_analyzer_colimator_8_blade_4_priority;
MCNUM xwidth = mccinter_analyzer_colimator_8_blade_4_xwidth;
MCNUM yheight = mccinter_analyzer_colimator_8_blade_4_yheight;
MCNUM zdepth = mccinter_analyzer_colimator_8_blade_4_zdepth;
MCNUM xwidth2 = mccinter_analyzer_colimator_8_blade_4_xwidth2;
MCNUM yheight2 = mccinter_analyzer_colimator_8_blade_4_yheight2;
MCNUM visualize = mccinter_analyzer_colimator_8_blade_4_visualize;
int target_index = mccinter_analyzer_colimator_8_blade_4_target_index;
MCNUM target_x = mccinter_analyzer_colimator_8_blade_4_target_x;
MCNUM target_y = mccinter_analyzer_colimator_8_blade_4_target_y;
MCNUM target_z = mccinter_analyzer_colimator_8_blade_4_target_z;
MCNUM focus_aw = mccinter_analyzer_colimator_8_blade_4_focus_aw;
MCNUM focus_ah = mccinter_analyzer_colimator_8_blade_4_focus_ah;
MCNUM focus_xw = mccinter_analyzer_colimator_8_blade_4_focus_xw;
MCNUM focus_xh = mccinter_analyzer_colimator_8_blade_4_focus_xh;
MCNUM focus_r = mccinter_analyzer_colimator_8_blade_4_focus_r;
MCNUM p_interact = mccinter_analyzer_colimator_8_blade_4_p_interact;
char* mask_string = mccinter_analyzer_colimator_8_blade_4_mask_string;
char* mask_setting = mccinter_analyzer_colimator_8_blade_4_mask_setting;
MCNUM number_of_activations = mccinter_analyzer_colimator_8_blade_4_number_of_activations;
}   /* End of inter_analyzer_colimator_8_blade_4=Union_box() SETTING parameter declarations. */
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex
  /* Label for restoring  neutron */
  mcabsorbCompinter_analyzer_colimator_8_blade_4:
  if (RESTORE) /* restore if needed */
  { RESTORE_NEUTRON(463,
      mcnlx,
      mcnly,
      mcnlz,
      mcnlvx,
      mcnlvy,
      mcnlvz,
      mcnlt,
      mcnlsx,
      mcnlsy,
      mcnlsz,
      mcnlp); }
#undef mcabsorbComp
#undef p
#undef sz
#undef sy
#undef sx
#undef t
#undef vz
#undef vy
#undef vx
#undef z
#undef y
#undef x
  mcDEBUG_STATE(
mcnlx,
mcnly,
mcnlz,
mcnlvx,
mcnlvy,
mcnlvz,
mcnlt,
mcnlsx,
mcnlsy,
mcnlsz,
mcnlp)

  /* TRACE Component diffraction_detector_8_exit_volume [464] */
  mccoordschange(mcposrdiffraction_detector_8_exit_volume, mcrotrdiffraction_detector_8_exit_volume,
    &mcnlx,
    &mcnly,
    &mcnlz,
    &mcnlvx,
    &mcnlvy,
    &mcnlvz,
    &mcnlsx,
    &mcnlsy,
    &mcnlsz);
  /* define label inside component diffraction_detector_8_exit_volume (without coords transformations) */
  mcJumpTrace_diffraction_detector_8_exit_volume:
  SIG_MESSAGE("diffraction_detector_8_exit_volume (Trace)");
  mcDEBUG_COMP("diffraction_detector_8_exit_volume")
  mcDEBUG_STATE(
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp)
#define x mcnlx
#define y mcnly
#define z mcnlz
#define vx mcnlvx
#define vy mcnlvy
#define vz mcnlvz
#define t mcnlt
#define sx mcnlsx
#define sy mcnlsy
#define sz mcnlsz
#define p mcnlp

#define mcabsorbComp mcabsorbCompdiffraction_detector_8_exit_volume
  STORE_NEUTRON(464,
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp);
  mcScattered=0;
  mcRestore=0;
  mcNCounter[464]++;
  mcPCounter[464] += p;
  mcP2Counter[464] += p*p;
#define mccompcurname  diffraction_detector_8_exit_volume
#define mccompcurtype  Union_box
#define mccompcurindex 464
#define loop_index mccdiffraction_detector_8_exit_volume_loop_index
#define this_box_volume mccdiffraction_detector_8_exit_volume_this_box_volume
#define global_geometry_element mccdiffraction_detector_8_exit_volume_global_geometry_element
#define this_box_storage mccdiffraction_detector_8_exit_volume_this_box_storage
{   /* Declarations of diffraction_detector_8_exit_volume=Union_box() SETTING parameters. */
char* material_string = mccdiffraction_detector_8_exit_volume_material_string;
MCNUM priority = mccdiffraction_detector_8_exit_volume_priority;
MCNUM xwidth = mccdiffraction_detector_8_exit_volume_xwidth;
MCNUM yheight = mccdiffraction_detector_8_exit_volume_yheight;
MCNUM zdepth = mccdiffraction_detector_8_exit_volume_zdepth;
MCNUM xwidth2 = mccdiffraction_detector_8_exit_volume_xwidth2;
MCNUM yheight2 = mccdiffraction_detector_8_exit_volume_yheight2;
MCNUM visualize = mccdiffraction_detector_8_exit_volume_visualize;
int target_index = mccdiffraction_detector_8_exit_volume_target_index;
MCNUM target_x = mccdiffraction_detector_8_exit_volume_target_x;
MCNUM target_y = mccdiffraction_detector_8_exit_volume_target_y;
MCNUM target_z = mccdiffraction_detector_8_exit_volume_target_z;
MCNUM focus_aw = mccdiffraction_detector_8_exit_volume_focus_aw;
MCNUM focus_ah = mccdiffraction_detector_8_exit_volume_focus_ah;
MCNUM focus_xw = mccdiffraction_detector_8_exit_volume_focus_xw;
MCNUM focus_xh = mccdiffraction_detector_8_exit_volume_focus_xh;
MCNUM focus_r = mccdiffraction_detector_8_exit_volume_focus_r;
MCNUM p_interact = mccdiffraction_detector_8_exit_volume_p_interact;
char* mask_string = mccdiffraction_detector_8_exit_volume_mask_string;
char* mask_setting = mccdiffraction_detector_8_exit_volume_mask_setting;
MCNUM number_of_activations = mccdiffraction_detector_8_exit_volume_number_of_activations;
}   /* End of diffraction_detector_8_exit_volume=Union_box() SETTING parameter declarations. */
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex
  /* Label for restoring  neutron */
  mcabsorbCompdiffraction_detector_8_exit_volume:
  if (RESTORE) /* restore if needed */
  { RESTORE_NEUTRON(464,
      mcnlx,
      mcnly,
      mcnlz,
      mcnlvx,
      mcnlvy,
      mcnlvz,
      mcnlt,
      mcnlsx,
      mcnlsy,
      mcnlsz,
      mcnlp); }
#undef mcabsorbComp
#undef p
#undef sz
#undef sy
#undef sx
#undef t
#undef vz
#undef vy
#undef vx
#undef z
#undef y
#undef x
  mcDEBUG_STATE(
mcnlx,
mcnly,
mcnlz,
mcnlvx,
mcnlvy,
mcnlvz,
mcnlt,
mcnlsx,
mcnlsy,
mcnlsz,
mcnlp)

  /* TRACE Component spec_detector_8_exit_volume [465] */
  mccoordschange(mcposrspec_detector_8_exit_volume, mcrotrspec_detector_8_exit_volume,
    &mcnlx,
    &mcnly,
    &mcnlz,
    &mcnlvx,
    &mcnlvy,
    &mcnlvz,
    &mcnlsx,
    &mcnlsy,
    &mcnlsz);
  /* define label inside component spec_detector_8_exit_volume (without coords transformations) */
  mcJumpTrace_spec_detector_8_exit_volume:
  SIG_MESSAGE("spec_detector_8_exit_volume (Trace)");
  mcDEBUG_COMP("spec_detector_8_exit_volume")
  mcDEBUG_STATE(
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp)
#define x mcnlx
#define y mcnly
#define z mcnlz
#define vx mcnlvx
#define vy mcnlvy
#define vz mcnlvz
#define t mcnlt
#define sx mcnlsx
#define sy mcnlsy
#define sz mcnlsz
#define p mcnlp

#define mcabsorbComp mcabsorbCompspec_detector_8_exit_volume
  STORE_NEUTRON(465,
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp);
  mcScattered=0;
  mcRestore=0;
  mcNCounter[465]++;
  mcPCounter[465] += p;
  mcP2Counter[465] += p*p;
#define mccompcurname  spec_detector_8_exit_volume
#define mccompcurtype  Union_box
#define mccompcurindex 465
#define loop_index mccspec_detector_8_exit_volume_loop_index
#define this_box_volume mccspec_detector_8_exit_volume_this_box_volume
#define global_geometry_element mccspec_detector_8_exit_volume_global_geometry_element
#define this_box_storage mccspec_detector_8_exit_volume_this_box_storage
{   /* Declarations of spec_detector_8_exit_volume=Union_box() SETTING parameters. */
char* material_string = mccspec_detector_8_exit_volume_material_string;
MCNUM priority = mccspec_detector_8_exit_volume_priority;
MCNUM xwidth = mccspec_detector_8_exit_volume_xwidth;
MCNUM yheight = mccspec_detector_8_exit_volume_yheight;
MCNUM zdepth = mccspec_detector_8_exit_volume_zdepth;
MCNUM xwidth2 = mccspec_detector_8_exit_volume_xwidth2;
MCNUM yheight2 = mccspec_detector_8_exit_volume_yheight2;
MCNUM visualize = mccspec_detector_8_exit_volume_visualize;
int target_index = mccspec_detector_8_exit_volume_target_index;
MCNUM target_x = mccspec_detector_8_exit_volume_target_x;
MCNUM target_y = mccspec_detector_8_exit_volume_target_y;
MCNUM target_z = mccspec_detector_8_exit_volume_target_z;
MCNUM focus_aw = mccspec_detector_8_exit_volume_focus_aw;
MCNUM focus_ah = mccspec_detector_8_exit_volume_focus_ah;
MCNUM focus_xw = mccspec_detector_8_exit_volume_focus_xw;
MCNUM focus_xh = mccspec_detector_8_exit_volume_focus_xh;
MCNUM focus_r = mccspec_detector_8_exit_volume_focus_r;
MCNUM p_interact = mccspec_detector_8_exit_volume_p_interact;
char* mask_string = mccspec_detector_8_exit_volume_mask_string;
char* mask_setting = mccspec_detector_8_exit_volume_mask_setting;
MCNUM number_of_activations = mccspec_detector_8_exit_volume_number_of_activations;
}   /* End of spec_detector_8_exit_volume=Union_box() SETTING parameter declarations. */
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex
  /* Label for restoring  neutron */
  mcabsorbCompspec_detector_8_exit_volume:
  if (RESTORE) /* restore if needed */
  { RESTORE_NEUTRON(465,
      mcnlx,
      mcnly,
      mcnlz,
      mcnlvx,
      mcnlvy,
      mcnlvz,
      mcnlt,
      mcnlsx,
      mcnlsy,
      mcnlsz,
      mcnlp); }
#undef mcabsorbComp
#undef p
#undef sz
#undef sy
#undef sx
#undef t
#undef vz
#undef vy
#undef vx
#undef z
#undef y
#undef x
  mcDEBUG_STATE(
mcnlx,
mcnly,
mcnlz,
mcnlvx,
mcnlvy,
mcnlvz,
mcnlt,
mcnlsx,
mcnlsy,
mcnlsz,
mcnlp)

  /* TRACE Component channel_9_cave1_box1 [466] */
  mccoordschange(mcposrchannel_9_cave1_box1, mcrotrchannel_9_cave1_box1,
    &mcnlx,
    &mcnly,
    &mcnlz,
    &mcnlvx,
    &mcnlvy,
    &mcnlvz,
    &mcnlsx,
    &mcnlsy,
    &mcnlsz);
  /* define label inside component channel_9_cave1_box1 (without coords transformations) */
  mcJumpTrace_channel_9_cave1_box1:
  SIG_MESSAGE("channel_9_cave1_box1 (Trace)");
  mcDEBUG_COMP("channel_9_cave1_box1")
  mcDEBUG_STATE(
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp)
#define x mcnlx
#define y mcnly
#define z mcnlz
#define vx mcnlvx
#define vy mcnlvy
#define vz mcnlvz
#define t mcnlt
#define sx mcnlsx
#define sy mcnlsy
#define sz mcnlsz
#define p mcnlp

#define mcabsorbComp mcabsorbCompchannel_9_cave1_box1
  STORE_NEUTRON(466,
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp);
  mcScattered=0;
  mcRestore=0;
  mcNCounter[466]++;
  mcPCounter[466] += p;
  mcP2Counter[466] += p*p;
#define mccompcurname  channel_9_cave1_box1
#define mccompcurtype  Union_box
#define mccompcurindex 466
#define loop_index mccchannel_9_cave1_box1_loop_index
#define this_box_volume mccchannel_9_cave1_box1_this_box_volume
#define global_geometry_element mccchannel_9_cave1_box1_global_geometry_element
#define this_box_storage mccchannel_9_cave1_box1_this_box_storage
{   /* Declarations of channel_9_cave1_box1=Union_box() SETTING parameters. */
char* material_string = mccchannel_9_cave1_box1_material_string;
MCNUM priority = mccchannel_9_cave1_box1_priority;
MCNUM xwidth = mccchannel_9_cave1_box1_xwidth;
MCNUM yheight = mccchannel_9_cave1_box1_yheight;
MCNUM zdepth = mccchannel_9_cave1_box1_zdepth;
MCNUM xwidth2 = mccchannel_9_cave1_box1_xwidth2;
MCNUM yheight2 = mccchannel_9_cave1_box1_yheight2;
MCNUM visualize = mccchannel_9_cave1_box1_visualize;
int target_index = mccchannel_9_cave1_box1_target_index;
MCNUM target_x = mccchannel_9_cave1_box1_target_x;
MCNUM target_y = mccchannel_9_cave1_box1_target_y;
MCNUM target_z = mccchannel_9_cave1_box1_target_z;
MCNUM focus_aw = mccchannel_9_cave1_box1_focus_aw;
MCNUM focus_ah = mccchannel_9_cave1_box1_focus_ah;
MCNUM focus_xw = mccchannel_9_cave1_box1_focus_xw;
MCNUM focus_xh = mccchannel_9_cave1_box1_focus_xh;
MCNUM focus_r = mccchannel_9_cave1_box1_focus_r;
MCNUM p_interact = mccchannel_9_cave1_box1_p_interact;
char* mask_string = mccchannel_9_cave1_box1_mask_string;
char* mask_setting = mccchannel_9_cave1_box1_mask_setting;
MCNUM number_of_activations = mccchannel_9_cave1_box1_number_of_activations;
}   /* End of channel_9_cave1_box1=Union_box() SETTING parameter declarations. */
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex
  /* Label for restoring  neutron */
  mcabsorbCompchannel_9_cave1_box1:
  if (RESTORE) /* restore if needed */
  { RESTORE_NEUTRON(466,
      mcnlx,
      mcnly,
      mcnlz,
      mcnlvx,
      mcnlvy,
      mcnlvz,
      mcnlt,
      mcnlsx,
      mcnlsy,
      mcnlsz,
      mcnlp); }
#undef mcabsorbComp
#undef p
#undef sz
#undef sy
#undef sx
#undef t
#undef vz
#undef vy
#undef vx
#undef z
#undef y
#undef x
  mcDEBUG_STATE(
mcnlx,
mcnly,
mcnlz,
mcnlvx,
mcnlvy,
mcnlvz,
mcnlt,
mcnlsx,
mcnlsy,
mcnlsz,
mcnlp)

  /* TRACE Component channel_9_cave1_box2 [467] */
  mccoordschange(mcposrchannel_9_cave1_box2, mcrotrchannel_9_cave1_box2,
    &mcnlx,
    &mcnly,
    &mcnlz,
    &mcnlvx,
    &mcnlvy,
    &mcnlvz,
    &mcnlsx,
    &mcnlsy,
    &mcnlsz);
  /* define label inside component channel_9_cave1_box2 (without coords transformations) */
  mcJumpTrace_channel_9_cave1_box2:
  SIG_MESSAGE("channel_9_cave1_box2 (Trace)");
  mcDEBUG_COMP("channel_9_cave1_box2")
  mcDEBUG_STATE(
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp)
#define x mcnlx
#define y mcnly
#define z mcnlz
#define vx mcnlvx
#define vy mcnlvy
#define vz mcnlvz
#define t mcnlt
#define sx mcnlsx
#define sy mcnlsy
#define sz mcnlsz
#define p mcnlp

#define mcabsorbComp mcabsorbCompchannel_9_cave1_box2
  STORE_NEUTRON(467,
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp);
  mcScattered=0;
  mcRestore=0;
  mcNCounter[467]++;
  mcPCounter[467] += p;
  mcP2Counter[467] += p*p;
#define mccompcurname  channel_9_cave1_box2
#define mccompcurtype  Union_box
#define mccompcurindex 467
#define loop_index mccchannel_9_cave1_box2_loop_index
#define this_box_volume mccchannel_9_cave1_box2_this_box_volume
#define global_geometry_element mccchannel_9_cave1_box2_global_geometry_element
#define this_box_storage mccchannel_9_cave1_box2_this_box_storage
{   /* Declarations of channel_9_cave1_box2=Union_box() SETTING parameters. */
char* material_string = mccchannel_9_cave1_box2_material_string;
MCNUM priority = mccchannel_9_cave1_box2_priority;
MCNUM xwidth = mccchannel_9_cave1_box2_xwidth;
MCNUM yheight = mccchannel_9_cave1_box2_yheight;
MCNUM zdepth = mccchannel_9_cave1_box2_zdepth;
MCNUM xwidth2 = mccchannel_9_cave1_box2_xwidth2;
MCNUM yheight2 = mccchannel_9_cave1_box2_yheight2;
MCNUM visualize = mccchannel_9_cave1_box2_visualize;
int target_index = mccchannel_9_cave1_box2_target_index;
MCNUM target_x = mccchannel_9_cave1_box2_target_x;
MCNUM target_y = mccchannel_9_cave1_box2_target_y;
MCNUM target_z = mccchannel_9_cave1_box2_target_z;
MCNUM focus_aw = mccchannel_9_cave1_box2_focus_aw;
MCNUM focus_ah = mccchannel_9_cave1_box2_focus_ah;
MCNUM focus_xw = mccchannel_9_cave1_box2_focus_xw;
MCNUM focus_xh = mccchannel_9_cave1_box2_focus_xh;
MCNUM focus_r = mccchannel_9_cave1_box2_focus_r;
MCNUM p_interact = mccchannel_9_cave1_box2_p_interact;
char* mask_string = mccchannel_9_cave1_box2_mask_string;
char* mask_setting = mccchannel_9_cave1_box2_mask_setting;
MCNUM number_of_activations = mccchannel_9_cave1_box2_number_of_activations;
}   /* End of channel_9_cave1_box2=Union_box() SETTING parameter declarations. */
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex
  /* Label for restoring  neutron */
  mcabsorbCompchannel_9_cave1_box2:
  if (RESTORE) /* restore if needed */
  { RESTORE_NEUTRON(467,
      mcnlx,
      mcnly,
      mcnlz,
      mcnlvx,
      mcnlvy,
      mcnlvz,
      mcnlt,
      mcnlsx,
      mcnlsy,
      mcnlsz,
      mcnlp); }
#undef mcabsorbComp
#undef p
#undef sz
#undef sy
#undef sx
#undef t
#undef vz
#undef vy
#undef vx
#undef z
#undef y
#undef x
  mcDEBUG_STATE(
mcnlx,
mcnly,
mcnlz,
mcnlvx,
mcnlvy,
mcnlvz,
mcnlt,
mcnlsx,
mcnlsy,
mcnlsz,
mcnlp)

  /* TRACE Component channel_9_cave1_box3 [468] */
  mccoordschange(mcposrchannel_9_cave1_box3, mcrotrchannel_9_cave1_box3,
    &mcnlx,
    &mcnly,
    &mcnlz,
    &mcnlvx,
    &mcnlvy,
    &mcnlvz,
    &mcnlsx,
    &mcnlsy,
    &mcnlsz);
  /* define label inside component channel_9_cave1_box3 (without coords transformations) */
  mcJumpTrace_channel_9_cave1_box3:
  SIG_MESSAGE("channel_9_cave1_box3 (Trace)");
  mcDEBUG_COMP("channel_9_cave1_box3")
  mcDEBUG_STATE(
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp)
#define x mcnlx
#define y mcnly
#define z mcnlz
#define vx mcnlvx
#define vy mcnlvy
#define vz mcnlvz
#define t mcnlt
#define sx mcnlsx
#define sy mcnlsy
#define sz mcnlsz
#define p mcnlp

#define mcabsorbComp mcabsorbCompchannel_9_cave1_box3
  STORE_NEUTRON(468,
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp);
  mcScattered=0;
  mcRestore=0;
  mcNCounter[468]++;
  mcPCounter[468] += p;
  mcP2Counter[468] += p*p;
#define mccompcurname  channel_9_cave1_box3
#define mccompcurtype  Union_box
#define mccompcurindex 468
#define loop_index mccchannel_9_cave1_box3_loop_index
#define this_box_volume mccchannel_9_cave1_box3_this_box_volume
#define global_geometry_element mccchannel_9_cave1_box3_global_geometry_element
#define this_box_storage mccchannel_9_cave1_box3_this_box_storage
{   /* Declarations of channel_9_cave1_box3=Union_box() SETTING parameters. */
char* material_string = mccchannel_9_cave1_box3_material_string;
MCNUM priority = mccchannel_9_cave1_box3_priority;
MCNUM xwidth = mccchannel_9_cave1_box3_xwidth;
MCNUM yheight = mccchannel_9_cave1_box3_yheight;
MCNUM zdepth = mccchannel_9_cave1_box3_zdepth;
MCNUM xwidth2 = mccchannel_9_cave1_box3_xwidth2;
MCNUM yheight2 = mccchannel_9_cave1_box3_yheight2;
MCNUM visualize = mccchannel_9_cave1_box3_visualize;
int target_index = mccchannel_9_cave1_box3_target_index;
MCNUM target_x = mccchannel_9_cave1_box3_target_x;
MCNUM target_y = mccchannel_9_cave1_box3_target_y;
MCNUM target_z = mccchannel_9_cave1_box3_target_z;
MCNUM focus_aw = mccchannel_9_cave1_box3_focus_aw;
MCNUM focus_ah = mccchannel_9_cave1_box3_focus_ah;
MCNUM focus_xw = mccchannel_9_cave1_box3_focus_xw;
MCNUM focus_xh = mccchannel_9_cave1_box3_focus_xh;
MCNUM focus_r = mccchannel_9_cave1_box3_focus_r;
MCNUM p_interact = mccchannel_9_cave1_box3_p_interact;
char* mask_string = mccchannel_9_cave1_box3_mask_string;
char* mask_setting = mccchannel_9_cave1_box3_mask_setting;
MCNUM number_of_activations = mccchannel_9_cave1_box3_number_of_activations;
}   /* End of channel_9_cave1_box3=Union_box() SETTING parameter declarations. */
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex
  /* Label for restoring  neutron */
  mcabsorbCompchannel_9_cave1_box3:
  if (RESTORE) /* restore if needed */
  { RESTORE_NEUTRON(468,
      mcnlx,
      mcnly,
      mcnlz,
      mcnlvx,
      mcnlvy,
      mcnlvz,
      mcnlt,
      mcnlsx,
      mcnlsy,
      mcnlsz,
      mcnlp); }
#undef mcabsorbComp
#undef p
#undef sz
#undef sy
#undef sx
#undef t
#undef vz
#undef vy
#undef vx
#undef z
#undef y
#undef x
  mcDEBUG_STATE(
mcnlx,
mcnly,
mcnlz,
mcnlvx,
mcnlvy,
mcnlvz,
mcnlt,
mcnlsx,
mcnlsy,
mcnlsz,
mcnlp)

  /* TRACE Component channel_9_cave1_cyl1 [469] */
  mccoordschange(mcposrchannel_9_cave1_cyl1, mcrotrchannel_9_cave1_cyl1,
    &mcnlx,
    &mcnly,
    &mcnlz,
    &mcnlvx,
    &mcnlvy,
    &mcnlvz,
    &mcnlsx,
    &mcnlsy,
    &mcnlsz);
  /* define label inside component channel_9_cave1_cyl1 (without coords transformations) */
  mcJumpTrace_channel_9_cave1_cyl1:
  SIG_MESSAGE("channel_9_cave1_cyl1 (Trace)");
  mcDEBUG_COMP("channel_9_cave1_cyl1")
  mcDEBUG_STATE(
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp)
#define x mcnlx
#define y mcnly
#define z mcnlz
#define vx mcnlvx
#define vy mcnlvy
#define vz mcnlvz
#define t mcnlt
#define sx mcnlsx
#define sy mcnlsy
#define sz mcnlsz
#define p mcnlp

#define mcabsorbComp mcabsorbCompchannel_9_cave1_cyl1
  STORE_NEUTRON(469,
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp);
  mcScattered=0;
  mcRestore=0;
  mcNCounter[469]++;
  mcPCounter[469] += p;
  mcP2Counter[469] += p*p;
#define mccompcurname  channel_9_cave1_cyl1
#define mccompcurtype  Union_cylinder
#define mccompcurindex 469
#define loop_index mccchannel_9_cave1_cyl1_loop_index
#define this_cylinder_volume mccchannel_9_cave1_cyl1_this_cylinder_volume
#define global_geometry_element mccchannel_9_cave1_cyl1_global_geometry_element
#define this_cylinder_storage mccchannel_9_cave1_cyl1_this_cylinder_storage
{   /* Declarations of channel_9_cave1_cyl1=Union_cylinder() SETTING parameters. */
char* material_string = mccchannel_9_cave1_cyl1_material_string;
MCNUM priority = mccchannel_9_cave1_cyl1_priority;
MCNUM radius = mccchannel_9_cave1_cyl1_radius;
MCNUM yheight = mccchannel_9_cave1_cyl1_yheight;
MCNUM visualize = mccchannel_9_cave1_cyl1_visualize;
int target_index = mccchannel_9_cave1_cyl1_target_index;
MCNUM target_x = mccchannel_9_cave1_cyl1_target_x;
MCNUM target_y = mccchannel_9_cave1_cyl1_target_y;
MCNUM target_z = mccchannel_9_cave1_cyl1_target_z;
MCNUM focus_aw = mccchannel_9_cave1_cyl1_focus_aw;
MCNUM focus_ah = mccchannel_9_cave1_cyl1_focus_ah;
MCNUM focus_xw = mccchannel_9_cave1_cyl1_focus_xw;
MCNUM focus_xh = mccchannel_9_cave1_cyl1_focus_xh;
MCNUM focus_r = mccchannel_9_cave1_cyl1_focus_r;
MCNUM p_interact = mccchannel_9_cave1_cyl1_p_interact;
char* mask_string = mccchannel_9_cave1_cyl1_mask_string;
char* mask_setting = mccchannel_9_cave1_cyl1_mask_setting;
MCNUM number_of_activations = mccchannel_9_cave1_cyl1_number_of_activations;
#line 345 "Union_cylinder.comp"
{
dummy = 1;
}
#line 407527 "MACS_sample_kidney_box.c"
}   /* End of channel_9_cave1_cyl1=Union_cylinder() SETTING parameter declarations. */
#undef this_cylinder_storage
#undef global_geometry_element
#undef this_cylinder_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex
  /* Label for restoring  neutron */
  mcabsorbCompchannel_9_cave1_cyl1:
  if (RESTORE) /* restore if needed */
  { RESTORE_NEUTRON(469,
      mcnlx,
      mcnly,
      mcnlz,
      mcnlvx,
      mcnlvy,
      mcnlvz,
      mcnlt,
      mcnlsx,
      mcnlsy,
      mcnlsz,
      mcnlp); }
#undef mcabsorbComp
#undef p
#undef sz
#undef sy
#undef sx
#undef t
#undef vz
#undef vy
#undef vx
#undef z
#undef y
#undef x
  mcDEBUG_STATE(
mcnlx,
mcnly,
mcnlz,
mcnlvx,
mcnlvy,
mcnlvz,
mcnlt,
mcnlsx,
mcnlsy,
mcnlsz,
mcnlp)

  /* TRACE Component channel_9_analyzer_1_center [470] */
  mccoordschange(mcposrchannel_9_analyzer_1_center, mcrotrchannel_9_analyzer_1_center,
    &mcnlx,
    &mcnly,
    &mcnlz,
    &mcnlvx,
    &mcnlvy,
    &mcnlvz,
    &mcnlsx,
    &mcnlsy,
    &mcnlsz);
  /* define label inside component channel_9_analyzer_1_center (without coords transformations) */
  mcJumpTrace_channel_9_analyzer_1_center:
  SIG_MESSAGE("channel_9_analyzer_1_center (Trace)");
  mcDEBUG_COMP("channel_9_analyzer_1_center")
  mcDEBUG_STATE(
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp)
#define x mcnlx
#define y mcnly
#define z mcnlz
#define vx mcnlvx
#define vy mcnlvy
#define vz mcnlvz
#define t mcnlt
#define sx mcnlsx
#define sy mcnlsy
#define sz mcnlsz
#define p mcnlp

#define mcabsorbComp mcabsorbCompchannel_9_analyzer_1_center
  STORE_NEUTRON(470,
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp);
  mcScattered=0;
  mcRestore=0;
  mcNCounter[470]++;
  mcPCounter[470] += p;
  mcP2Counter[470] += p*p;
#define mccompcurname  channel_9_analyzer_1_center
#define mccompcurtype  Arm
#define mccompcurindex 470
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex
  /* Label for restoring  neutron */
  mcabsorbCompchannel_9_analyzer_1_center:
  if (RESTORE) /* restore if needed */
  { RESTORE_NEUTRON(470,
      mcnlx,
      mcnly,
      mcnlz,
      mcnlvx,
      mcnlvy,
      mcnlvz,
      mcnlt,
      mcnlsx,
      mcnlsy,
      mcnlsz,
      mcnlp); }
#undef mcabsorbComp
#undef p
#undef sz
#undef sy
#undef sx
#undef t
#undef vz
#undef vy
#undef vx
#undef z
#undef y
#undef x
  mcDEBUG_STATE(
mcnlx,
mcnly,
mcnlz,
mcnlvx,
mcnlvy,
mcnlvz,
mcnlt,
mcnlsx,
mcnlsy,
mcnlsz,
mcnlp)

  /* TRACE Component channel_9_analyzer_1_rotated [471] */
  mccoordschange(mcposrchannel_9_analyzer_1_rotated, mcrotrchannel_9_analyzer_1_rotated,
    &mcnlx,
    &mcnly,
    &mcnlz,
    &mcnlvx,
    &mcnlvy,
    &mcnlvz,
    &mcnlsx,
    &mcnlsy,
    &mcnlsz);
  /* define label inside component channel_9_analyzer_1_rotated (without coords transformations) */
  mcJumpTrace_channel_9_analyzer_1_rotated:
  SIG_MESSAGE("channel_9_analyzer_1_rotated (Trace)");
  mcDEBUG_COMP("channel_9_analyzer_1_rotated")
  mcDEBUG_STATE(
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp)
#define x mcnlx
#define y mcnly
#define z mcnlz
#define vx mcnlvx
#define vy mcnlvy
#define vz mcnlvz
#define t mcnlt
#define sx mcnlsx
#define sy mcnlsy
#define sz mcnlsz
#define p mcnlp

#define mcabsorbComp mcabsorbCompchannel_9_analyzer_1_rotated
  STORE_NEUTRON(471,
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp);
  mcScattered=0;
  mcRestore=0;
  mcNCounter[471]++;
  mcPCounter[471] += p;
  mcP2Counter[471] += p*p;
#define mccompcurname  channel_9_analyzer_1_rotated
#define mccompcurtype  Arm
#define mccompcurindex 471
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex
  /* Label for restoring  neutron */
  mcabsorbCompchannel_9_analyzer_1_rotated:
  if (RESTORE) /* restore if needed */
  { RESTORE_NEUTRON(471,
      mcnlx,
      mcnly,
      mcnlz,
      mcnlvx,
      mcnlvy,
      mcnlvz,
      mcnlt,
      mcnlsx,
      mcnlsy,
      mcnlsz,
      mcnlp); }
#undef mcabsorbComp
#undef p
#undef sz
#undef sy
#undef sx
#undef t
#undef vz
#undef vy
#undef vx
#undef z
#undef y
#undef x
  mcDEBUG_STATE(
mcnlx,
mcnly,
mcnlz,
mcnlvx,
mcnlvy,
mcnlvz,
mcnlt,
mcnlsx,
mcnlsy,
mcnlsz,
mcnlp)

  /* TRACE Component channel_9_analyzer_1_array_crystal_array_0 [472] */
  mccoordschange(mcposrchannel_9_analyzer_1_array_crystal_array_0, mcrotrchannel_9_analyzer_1_array_crystal_array_0,
    &mcnlx,
    &mcnly,
    &mcnlz,
    &mcnlvx,
    &mcnlvy,
    &mcnlvz,
    &mcnlsx,
    &mcnlsy,
    &mcnlsz);
  /* define label inside component channel_9_analyzer_1_array_crystal_array_0 (without coords transformations) */
  mcJumpTrace_channel_9_analyzer_1_array_crystal_array_0:
  SIG_MESSAGE("channel_9_analyzer_1_array_crystal_array_0 (Trace)");
  mcDEBUG_COMP("channel_9_analyzer_1_array_crystal_array_0")
  mcDEBUG_STATE(
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp)
#define x mcnlx
#define y mcnly
#define z mcnlz
#define vx mcnlvx
#define vy mcnlvy
#define vz mcnlvz
#define t mcnlt
#define sx mcnlsx
#define sy mcnlsy
#define sz mcnlsz
#define p mcnlp

#define mcabsorbComp mcabsorbCompchannel_9_analyzer_1_array_crystal_array_0
  STORE_NEUTRON(472,
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp);
  mcScattered=0;
  mcRestore=0;
  mcNCounter[472]++;
  mcPCounter[472] += p;
  mcP2Counter[472] += p*p;
#define mccompcurname  channel_9_analyzer_1_array_crystal_array_0
#define mccompcurtype  Union_box
#define mccompcurindex 472
#define loop_index mccchannel_9_analyzer_1_array_crystal_array_0_loop_index
#define this_box_volume mccchannel_9_analyzer_1_array_crystal_array_0_this_box_volume
#define global_geometry_element mccchannel_9_analyzer_1_array_crystal_array_0_global_geometry_element
#define this_box_storage mccchannel_9_analyzer_1_array_crystal_array_0_this_box_storage
{   /* Declarations of channel_9_analyzer_1_array_crystal_array_0=Union_box() SETTING parameters. */
char* material_string = mccchannel_9_analyzer_1_array_crystal_array_0_material_string;
MCNUM priority = mccchannel_9_analyzer_1_array_crystal_array_0_priority;
MCNUM xwidth = mccchannel_9_analyzer_1_array_crystal_array_0_xwidth;
MCNUM yheight = mccchannel_9_analyzer_1_array_crystal_array_0_yheight;
MCNUM zdepth = mccchannel_9_analyzer_1_array_crystal_array_0_zdepth;
MCNUM xwidth2 = mccchannel_9_analyzer_1_array_crystal_array_0_xwidth2;
MCNUM yheight2 = mccchannel_9_analyzer_1_array_crystal_array_0_yheight2;
MCNUM visualize = mccchannel_9_analyzer_1_array_crystal_array_0_visualize;
int target_index = mccchannel_9_analyzer_1_array_crystal_array_0_target_index;
MCNUM target_x = mccchannel_9_analyzer_1_array_crystal_array_0_target_x;
MCNUM target_y = mccchannel_9_analyzer_1_array_crystal_array_0_target_y;
MCNUM target_z = mccchannel_9_analyzer_1_array_crystal_array_0_target_z;
MCNUM focus_aw = mccchannel_9_analyzer_1_array_crystal_array_0_focus_aw;
MCNUM focus_ah = mccchannel_9_analyzer_1_array_crystal_array_0_focus_ah;
MCNUM focus_xw = mccchannel_9_analyzer_1_array_crystal_array_0_focus_xw;
MCNUM focus_xh = mccchannel_9_analyzer_1_array_crystal_array_0_focus_xh;
MCNUM focus_r = mccchannel_9_analyzer_1_array_crystal_array_0_focus_r;
MCNUM p_interact = mccchannel_9_analyzer_1_array_crystal_array_0_p_interact;
char* mask_string = mccchannel_9_analyzer_1_array_crystal_array_0_mask_string;
char* mask_setting = mccchannel_9_analyzer_1_array_crystal_array_0_mask_setting;
MCNUM number_of_activations = mccchannel_9_analyzer_1_array_crystal_array_0_number_of_activations;
}   /* End of channel_9_analyzer_1_array_crystal_array_0=Union_box() SETTING parameter declarations. */
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex
  /* Label for restoring  neutron */
  mcabsorbCompchannel_9_analyzer_1_array_crystal_array_0:
  if (RESTORE) /* restore if needed */
  { RESTORE_NEUTRON(472,
      mcnlx,
      mcnly,
      mcnlz,
      mcnlvx,
      mcnlvy,
      mcnlvz,
      mcnlt,
      mcnlsx,
      mcnlsy,
      mcnlsz,
      mcnlp); }
#undef mcabsorbComp
#undef p
#undef sz
#undef sy
#undef sx
#undef t
#undef vz
#undef vy
#undef vx
#undef z
#undef y
#undef x
  mcDEBUG_STATE(
mcnlx,
mcnly,
mcnlz,
mcnlvx,
mcnlvy,
mcnlvz,
mcnlt,
mcnlsx,
mcnlsy,
mcnlsz,
mcnlp)

  /* TRACE Component channel_9_analyzer_1_array_crystal_array_1 [473] */
  mccoordschange(mcposrchannel_9_analyzer_1_array_crystal_array_1, mcrotrchannel_9_analyzer_1_array_crystal_array_1,
    &mcnlx,
    &mcnly,
    &mcnlz,
    &mcnlvx,
    &mcnlvy,
    &mcnlvz,
    &mcnlsx,
    &mcnlsy,
    &mcnlsz);
  /* define label inside component channel_9_analyzer_1_array_crystal_array_1 (without coords transformations) */
  mcJumpTrace_channel_9_analyzer_1_array_crystal_array_1:
  SIG_MESSAGE("channel_9_analyzer_1_array_crystal_array_1 (Trace)");
  mcDEBUG_COMP("channel_9_analyzer_1_array_crystal_array_1")
  mcDEBUG_STATE(
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp)
#define x mcnlx
#define y mcnly
#define z mcnlz
#define vx mcnlvx
#define vy mcnlvy
#define vz mcnlvz
#define t mcnlt
#define sx mcnlsx
#define sy mcnlsy
#define sz mcnlsz
#define p mcnlp

#define mcabsorbComp mcabsorbCompchannel_9_analyzer_1_array_crystal_array_1
  STORE_NEUTRON(473,
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp);
  mcScattered=0;
  mcRestore=0;
  mcNCounter[473]++;
  mcPCounter[473] += p;
  mcP2Counter[473] += p*p;
#define mccompcurname  channel_9_analyzer_1_array_crystal_array_1
#define mccompcurtype  Union_box
#define mccompcurindex 473
#define loop_index mccchannel_9_analyzer_1_array_crystal_array_1_loop_index
#define this_box_volume mccchannel_9_analyzer_1_array_crystal_array_1_this_box_volume
#define global_geometry_element mccchannel_9_analyzer_1_array_crystal_array_1_global_geometry_element
#define this_box_storage mccchannel_9_analyzer_1_array_crystal_array_1_this_box_storage
{   /* Declarations of channel_9_analyzer_1_array_crystal_array_1=Union_box() SETTING parameters. */
char* material_string = mccchannel_9_analyzer_1_array_crystal_array_1_material_string;
MCNUM priority = mccchannel_9_analyzer_1_array_crystal_array_1_priority;
MCNUM xwidth = mccchannel_9_analyzer_1_array_crystal_array_1_xwidth;
MCNUM yheight = mccchannel_9_analyzer_1_array_crystal_array_1_yheight;
MCNUM zdepth = mccchannel_9_analyzer_1_array_crystal_array_1_zdepth;
MCNUM xwidth2 = mccchannel_9_analyzer_1_array_crystal_array_1_xwidth2;
MCNUM yheight2 = mccchannel_9_analyzer_1_array_crystal_array_1_yheight2;
MCNUM visualize = mccchannel_9_analyzer_1_array_crystal_array_1_visualize;
int target_index = mccchannel_9_analyzer_1_array_crystal_array_1_target_index;
MCNUM target_x = mccchannel_9_analyzer_1_array_crystal_array_1_target_x;
MCNUM target_y = mccchannel_9_analyzer_1_array_crystal_array_1_target_y;
MCNUM target_z = mccchannel_9_analyzer_1_array_crystal_array_1_target_z;
MCNUM focus_aw = mccchannel_9_analyzer_1_array_crystal_array_1_focus_aw;
MCNUM focus_ah = mccchannel_9_analyzer_1_array_crystal_array_1_focus_ah;
MCNUM focus_xw = mccchannel_9_analyzer_1_array_crystal_array_1_focus_xw;
MCNUM focus_xh = mccchannel_9_analyzer_1_array_crystal_array_1_focus_xh;
MCNUM focus_r = mccchannel_9_analyzer_1_array_crystal_array_1_focus_r;
MCNUM p_interact = mccchannel_9_analyzer_1_array_crystal_array_1_p_interact;
char* mask_string = mccchannel_9_analyzer_1_array_crystal_array_1_mask_string;
char* mask_setting = mccchannel_9_analyzer_1_array_crystal_array_1_mask_setting;
MCNUM number_of_activations = mccchannel_9_analyzer_1_array_crystal_array_1_number_of_activations;
}   /* End of channel_9_analyzer_1_array_crystal_array_1=Union_box() SETTING parameter declarations. */
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex
  /* Label for restoring  neutron */
  mcabsorbCompchannel_9_analyzer_1_array_crystal_array_1:
  if (RESTORE) /* restore if needed */
  { RESTORE_NEUTRON(473,
      mcnlx,
      mcnly,
      mcnlz,
      mcnlvx,
      mcnlvy,
      mcnlvz,
      mcnlt,
      mcnlsx,
      mcnlsy,
      mcnlsz,
      mcnlp); }
#undef mcabsorbComp
#undef p
#undef sz
#undef sy
#undef sx
#undef t
#undef vz
#undef vy
#undef vx
#undef z
#undef y
#undef x
  mcDEBUG_STATE(
mcnlx,
mcnly,
mcnlz,
mcnlvx,
mcnlvy,
mcnlvz,
mcnlt,
mcnlsx,
mcnlsy,
mcnlsz,
mcnlp)

  /* TRACE Component channel_9_analyzer_1_array_crystal_array_2 [474] */
  mccoordschange(mcposrchannel_9_analyzer_1_array_crystal_array_2, mcrotrchannel_9_analyzer_1_array_crystal_array_2,
    &mcnlx,
    &mcnly,
    &mcnlz,
    &mcnlvx,
    &mcnlvy,
    &mcnlvz,
    &mcnlsx,
    &mcnlsy,
    &mcnlsz);
  /* define label inside component channel_9_analyzer_1_array_crystal_array_2 (without coords transformations) */
  mcJumpTrace_channel_9_analyzer_1_array_crystal_array_2:
  SIG_MESSAGE("channel_9_analyzer_1_array_crystal_array_2 (Trace)");
  mcDEBUG_COMP("channel_9_analyzer_1_array_crystal_array_2")
  mcDEBUG_STATE(
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp)
#define x mcnlx
#define y mcnly
#define z mcnlz
#define vx mcnlvx
#define vy mcnlvy
#define vz mcnlvz
#define t mcnlt
#define sx mcnlsx
#define sy mcnlsy
#define sz mcnlsz
#define p mcnlp

#define mcabsorbComp mcabsorbCompchannel_9_analyzer_1_array_crystal_array_2
  STORE_NEUTRON(474,
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp);
  mcScattered=0;
  mcRestore=0;
  mcNCounter[474]++;
  mcPCounter[474] += p;
  mcP2Counter[474] += p*p;
#define mccompcurname  channel_9_analyzer_1_array_crystal_array_2
#define mccompcurtype  Union_box
#define mccompcurindex 474
#define loop_index mccchannel_9_analyzer_1_array_crystal_array_2_loop_index
#define this_box_volume mccchannel_9_analyzer_1_array_crystal_array_2_this_box_volume
#define global_geometry_element mccchannel_9_analyzer_1_array_crystal_array_2_global_geometry_element
#define this_box_storage mccchannel_9_analyzer_1_array_crystal_array_2_this_box_storage
{   /* Declarations of channel_9_analyzer_1_array_crystal_array_2=Union_box() SETTING parameters. */
char* material_string = mccchannel_9_analyzer_1_array_crystal_array_2_material_string;
MCNUM priority = mccchannel_9_analyzer_1_array_crystal_array_2_priority;
MCNUM xwidth = mccchannel_9_analyzer_1_array_crystal_array_2_xwidth;
MCNUM yheight = mccchannel_9_analyzer_1_array_crystal_array_2_yheight;
MCNUM zdepth = mccchannel_9_analyzer_1_array_crystal_array_2_zdepth;
MCNUM xwidth2 = mccchannel_9_analyzer_1_array_crystal_array_2_xwidth2;
MCNUM yheight2 = mccchannel_9_analyzer_1_array_crystal_array_2_yheight2;
MCNUM visualize = mccchannel_9_analyzer_1_array_crystal_array_2_visualize;
int target_index = mccchannel_9_analyzer_1_array_crystal_array_2_target_index;
MCNUM target_x = mccchannel_9_analyzer_1_array_crystal_array_2_target_x;
MCNUM target_y = mccchannel_9_analyzer_1_array_crystal_array_2_target_y;
MCNUM target_z = mccchannel_9_analyzer_1_array_crystal_array_2_target_z;
MCNUM focus_aw = mccchannel_9_analyzer_1_array_crystal_array_2_focus_aw;
MCNUM focus_ah = mccchannel_9_analyzer_1_array_crystal_array_2_focus_ah;
MCNUM focus_xw = mccchannel_9_analyzer_1_array_crystal_array_2_focus_xw;
MCNUM focus_xh = mccchannel_9_analyzer_1_array_crystal_array_2_focus_xh;
MCNUM focus_r = mccchannel_9_analyzer_1_array_crystal_array_2_focus_r;
MCNUM p_interact = mccchannel_9_analyzer_1_array_crystal_array_2_p_interact;
char* mask_string = mccchannel_9_analyzer_1_array_crystal_array_2_mask_string;
char* mask_setting = mccchannel_9_analyzer_1_array_crystal_array_2_mask_setting;
MCNUM number_of_activations = mccchannel_9_analyzer_1_array_crystal_array_2_number_of_activations;
}   /* End of channel_9_analyzer_1_array_crystal_array_2=Union_box() SETTING parameter declarations. */
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex
  /* Label for restoring  neutron */
  mcabsorbCompchannel_9_analyzer_1_array_crystal_array_2:
  if (RESTORE) /* restore if needed */
  { RESTORE_NEUTRON(474,
      mcnlx,
      mcnly,
      mcnlz,
      mcnlvx,
      mcnlvy,
      mcnlvz,
      mcnlt,
      mcnlsx,
      mcnlsy,
      mcnlsz,
      mcnlp); }
#undef mcabsorbComp
#undef p
#undef sz
#undef sy
#undef sx
#undef t
#undef vz
#undef vy
#undef vx
#undef z
#undef y
#undef x
  mcDEBUG_STATE(
mcnlx,
mcnly,
mcnlz,
mcnlvx,
mcnlvy,
mcnlvz,
mcnlt,
mcnlsx,
mcnlsy,
mcnlsz,
mcnlp)

  /* TRACE Component channel_9_analyzer_1_array_crystal_array_3 [475] */
  mccoordschange(mcposrchannel_9_analyzer_1_array_crystal_array_3, mcrotrchannel_9_analyzer_1_array_crystal_array_3,
    &mcnlx,
    &mcnly,
    &mcnlz,
    &mcnlvx,
    &mcnlvy,
    &mcnlvz,
    &mcnlsx,
    &mcnlsy,
    &mcnlsz);
  /* define label inside component channel_9_analyzer_1_array_crystal_array_3 (without coords transformations) */
  mcJumpTrace_channel_9_analyzer_1_array_crystal_array_3:
  SIG_MESSAGE("channel_9_analyzer_1_array_crystal_array_3 (Trace)");
  mcDEBUG_COMP("channel_9_analyzer_1_array_crystal_array_3")
  mcDEBUG_STATE(
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp)
#define x mcnlx
#define y mcnly
#define z mcnlz
#define vx mcnlvx
#define vy mcnlvy
#define vz mcnlvz
#define t mcnlt
#define sx mcnlsx
#define sy mcnlsy
#define sz mcnlsz
#define p mcnlp

#define mcabsorbComp mcabsorbCompchannel_9_analyzer_1_array_crystal_array_3
  STORE_NEUTRON(475,
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp);
  mcScattered=0;
  mcRestore=0;
  mcNCounter[475]++;
  mcPCounter[475] += p;
  mcP2Counter[475] += p*p;
#define mccompcurname  channel_9_analyzer_1_array_crystal_array_3
#define mccompcurtype  Union_box
#define mccompcurindex 475
#define loop_index mccchannel_9_analyzer_1_array_crystal_array_3_loop_index
#define this_box_volume mccchannel_9_analyzer_1_array_crystal_array_3_this_box_volume
#define global_geometry_element mccchannel_9_analyzer_1_array_crystal_array_3_global_geometry_element
#define this_box_storage mccchannel_9_analyzer_1_array_crystal_array_3_this_box_storage
{   /* Declarations of channel_9_analyzer_1_array_crystal_array_3=Union_box() SETTING parameters. */
char* material_string = mccchannel_9_analyzer_1_array_crystal_array_3_material_string;
MCNUM priority = mccchannel_9_analyzer_1_array_crystal_array_3_priority;
MCNUM xwidth = mccchannel_9_analyzer_1_array_crystal_array_3_xwidth;
MCNUM yheight = mccchannel_9_analyzer_1_array_crystal_array_3_yheight;
MCNUM zdepth = mccchannel_9_analyzer_1_array_crystal_array_3_zdepth;
MCNUM xwidth2 = mccchannel_9_analyzer_1_array_crystal_array_3_xwidth2;
MCNUM yheight2 = mccchannel_9_analyzer_1_array_crystal_array_3_yheight2;
MCNUM visualize = mccchannel_9_analyzer_1_array_crystal_array_3_visualize;
int target_index = mccchannel_9_analyzer_1_array_crystal_array_3_target_index;
MCNUM target_x = mccchannel_9_analyzer_1_array_crystal_array_3_target_x;
MCNUM target_y = mccchannel_9_analyzer_1_array_crystal_array_3_target_y;
MCNUM target_z = mccchannel_9_analyzer_1_array_crystal_array_3_target_z;
MCNUM focus_aw = mccchannel_9_analyzer_1_array_crystal_array_3_focus_aw;
MCNUM focus_ah = mccchannel_9_analyzer_1_array_crystal_array_3_focus_ah;
MCNUM focus_xw = mccchannel_9_analyzer_1_array_crystal_array_3_focus_xw;
MCNUM focus_xh = mccchannel_9_analyzer_1_array_crystal_array_3_focus_xh;
MCNUM focus_r = mccchannel_9_analyzer_1_array_crystal_array_3_focus_r;
MCNUM p_interact = mccchannel_9_analyzer_1_array_crystal_array_3_p_interact;
char* mask_string = mccchannel_9_analyzer_1_array_crystal_array_3_mask_string;
char* mask_setting = mccchannel_9_analyzer_1_array_crystal_array_3_mask_setting;
MCNUM number_of_activations = mccchannel_9_analyzer_1_array_crystal_array_3_number_of_activations;
}   /* End of channel_9_analyzer_1_array_crystal_array_3=Union_box() SETTING parameter declarations. */
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex
  /* Label for restoring  neutron */
  mcabsorbCompchannel_9_analyzer_1_array_crystal_array_3:
  if (RESTORE) /* restore if needed */
  { RESTORE_NEUTRON(475,
      mcnlx,
      mcnly,
      mcnlz,
      mcnlvx,
      mcnlvy,
      mcnlvz,
      mcnlt,
      mcnlsx,
      mcnlsy,
      mcnlsz,
      mcnlp); }
#undef mcabsorbComp
#undef p
#undef sz
#undef sy
#undef sx
#undef t
#undef vz
#undef vy
#undef vx
#undef z
#undef y
#undef x
  mcDEBUG_STATE(
mcnlx,
mcnly,
mcnlz,
mcnlvx,
mcnlvy,
mcnlvz,
mcnlt,
mcnlsx,
mcnlsy,
mcnlsz,
mcnlp)

  /* TRACE Component channel_9_analyzer_1_array_crystal_array_4 [476] */
  mccoordschange(mcposrchannel_9_analyzer_1_array_crystal_array_4, mcrotrchannel_9_analyzer_1_array_crystal_array_4,
    &mcnlx,
    &mcnly,
    &mcnlz,
    &mcnlvx,
    &mcnlvy,
    &mcnlvz,
    &mcnlsx,
    &mcnlsy,
    &mcnlsz);
  /* define label inside component channel_9_analyzer_1_array_crystal_array_4 (without coords transformations) */
  mcJumpTrace_channel_9_analyzer_1_array_crystal_array_4:
  SIG_MESSAGE("channel_9_analyzer_1_array_crystal_array_4 (Trace)");
  mcDEBUG_COMP("channel_9_analyzer_1_array_crystal_array_4")
  mcDEBUG_STATE(
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp)
#define x mcnlx
#define y mcnly
#define z mcnlz
#define vx mcnlvx
#define vy mcnlvy
#define vz mcnlvz
#define t mcnlt
#define sx mcnlsx
#define sy mcnlsy
#define sz mcnlsz
#define p mcnlp

#define mcabsorbComp mcabsorbCompchannel_9_analyzer_1_array_crystal_array_4
  STORE_NEUTRON(476,
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp);
  mcScattered=0;
  mcRestore=0;
  mcNCounter[476]++;
  mcPCounter[476] += p;
  mcP2Counter[476] += p*p;
#define mccompcurname  channel_9_analyzer_1_array_crystal_array_4
#define mccompcurtype  Union_box
#define mccompcurindex 476
#define loop_index mccchannel_9_analyzer_1_array_crystal_array_4_loop_index
#define this_box_volume mccchannel_9_analyzer_1_array_crystal_array_4_this_box_volume
#define global_geometry_element mccchannel_9_analyzer_1_array_crystal_array_4_global_geometry_element
#define this_box_storage mccchannel_9_analyzer_1_array_crystal_array_4_this_box_storage
{   /* Declarations of channel_9_analyzer_1_array_crystal_array_4=Union_box() SETTING parameters. */
char* material_string = mccchannel_9_analyzer_1_array_crystal_array_4_material_string;
MCNUM priority = mccchannel_9_analyzer_1_array_crystal_array_4_priority;
MCNUM xwidth = mccchannel_9_analyzer_1_array_crystal_array_4_xwidth;
MCNUM yheight = mccchannel_9_analyzer_1_array_crystal_array_4_yheight;
MCNUM zdepth = mccchannel_9_analyzer_1_array_crystal_array_4_zdepth;
MCNUM xwidth2 = mccchannel_9_analyzer_1_array_crystal_array_4_xwidth2;
MCNUM yheight2 = mccchannel_9_analyzer_1_array_crystal_array_4_yheight2;
MCNUM visualize = mccchannel_9_analyzer_1_array_crystal_array_4_visualize;
int target_index = mccchannel_9_analyzer_1_array_crystal_array_4_target_index;
MCNUM target_x = mccchannel_9_analyzer_1_array_crystal_array_4_target_x;
MCNUM target_y = mccchannel_9_analyzer_1_array_crystal_array_4_target_y;
MCNUM target_z = mccchannel_9_analyzer_1_array_crystal_array_4_target_z;
MCNUM focus_aw = mccchannel_9_analyzer_1_array_crystal_array_4_focus_aw;
MCNUM focus_ah = mccchannel_9_analyzer_1_array_crystal_array_4_focus_ah;
MCNUM focus_xw = mccchannel_9_analyzer_1_array_crystal_array_4_focus_xw;
MCNUM focus_xh = mccchannel_9_analyzer_1_array_crystal_array_4_focus_xh;
MCNUM focus_r = mccchannel_9_analyzer_1_array_crystal_array_4_focus_r;
MCNUM p_interact = mccchannel_9_analyzer_1_array_crystal_array_4_p_interact;
char* mask_string = mccchannel_9_analyzer_1_array_crystal_array_4_mask_string;
char* mask_setting = mccchannel_9_analyzer_1_array_crystal_array_4_mask_setting;
MCNUM number_of_activations = mccchannel_9_analyzer_1_array_crystal_array_4_number_of_activations;
}   /* End of channel_9_analyzer_1_array_crystal_array_4=Union_box() SETTING parameter declarations. */
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex
  /* Label for restoring  neutron */
  mcabsorbCompchannel_9_analyzer_1_array_crystal_array_4:
  if (RESTORE) /* restore if needed */
  { RESTORE_NEUTRON(476,
      mcnlx,
      mcnly,
      mcnlz,
      mcnlvx,
      mcnlvy,
      mcnlvz,
      mcnlt,
      mcnlsx,
      mcnlsy,
      mcnlsz,
      mcnlp); }
#undef mcabsorbComp
#undef p
#undef sz
#undef sy
#undef sx
#undef t
#undef vz
#undef vy
#undef vx
#undef z
#undef y
#undef x
  mcDEBUG_STATE(
mcnlx,
mcnly,
mcnlz,
mcnlvx,
mcnlvy,
mcnlvz,
mcnlt,
mcnlsx,
mcnlsy,
mcnlsz,
mcnlp)

  /* TRACE Component channel_9_analyzer_1_array_crystal_array_5 [477] */
  mccoordschange(mcposrchannel_9_analyzer_1_array_crystal_array_5, mcrotrchannel_9_analyzer_1_array_crystal_array_5,
    &mcnlx,
    &mcnly,
    &mcnlz,
    &mcnlvx,
    &mcnlvy,
    &mcnlvz,
    &mcnlsx,
    &mcnlsy,
    &mcnlsz);
  /* define label inside component channel_9_analyzer_1_array_crystal_array_5 (without coords transformations) */
  mcJumpTrace_channel_9_analyzer_1_array_crystal_array_5:
  SIG_MESSAGE("channel_9_analyzer_1_array_crystal_array_5 (Trace)");
  mcDEBUG_COMP("channel_9_analyzer_1_array_crystal_array_5")
  mcDEBUG_STATE(
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp)
#define x mcnlx
#define y mcnly
#define z mcnlz
#define vx mcnlvx
#define vy mcnlvy
#define vz mcnlvz
#define t mcnlt
#define sx mcnlsx
#define sy mcnlsy
#define sz mcnlsz
#define p mcnlp

#define mcabsorbComp mcabsorbCompchannel_9_analyzer_1_array_crystal_array_5
  STORE_NEUTRON(477,
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp);
  mcScattered=0;
  mcRestore=0;
  mcNCounter[477]++;
  mcPCounter[477] += p;
  mcP2Counter[477] += p*p;
#define mccompcurname  channel_9_analyzer_1_array_crystal_array_5
#define mccompcurtype  Union_box
#define mccompcurindex 477
#define loop_index mccchannel_9_analyzer_1_array_crystal_array_5_loop_index
#define this_box_volume mccchannel_9_analyzer_1_array_crystal_array_5_this_box_volume
#define global_geometry_element mccchannel_9_analyzer_1_array_crystal_array_5_global_geometry_element
#define this_box_storage mccchannel_9_analyzer_1_array_crystal_array_5_this_box_storage
{   /* Declarations of channel_9_analyzer_1_array_crystal_array_5=Union_box() SETTING parameters. */
char* material_string = mccchannel_9_analyzer_1_array_crystal_array_5_material_string;
MCNUM priority = mccchannel_9_analyzer_1_array_crystal_array_5_priority;
MCNUM xwidth = mccchannel_9_analyzer_1_array_crystal_array_5_xwidth;
MCNUM yheight = mccchannel_9_analyzer_1_array_crystal_array_5_yheight;
MCNUM zdepth = mccchannel_9_analyzer_1_array_crystal_array_5_zdepth;
MCNUM xwidth2 = mccchannel_9_analyzer_1_array_crystal_array_5_xwidth2;
MCNUM yheight2 = mccchannel_9_analyzer_1_array_crystal_array_5_yheight2;
MCNUM visualize = mccchannel_9_analyzer_1_array_crystal_array_5_visualize;
int target_index = mccchannel_9_analyzer_1_array_crystal_array_5_target_index;
MCNUM target_x = mccchannel_9_analyzer_1_array_crystal_array_5_target_x;
MCNUM target_y = mccchannel_9_analyzer_1_array_crystal_array_5_target_y;
MCNUM target_z = mccchannel_9_analyzer_1_array_crystal_array_5_target_z;
MCNUM focus_aw = mccchannel_9_analyzer_1_array_crystal_array_5_focus_aw;
MCNUM focus_ah = mccchannel_9_analyzer_1_array_crystal_array_5_focus_ah;
MCNUM focus_xw = mccchannel_9_analyzer_1_array_crystal_array_5_focus_xw;
MCNUM focus_xh = mccchannel_9_analyzer_1_array_crystal_array_5_focus_xh;
MCNUM focus_r = mccchannel_9_analyzer_1_array_crystal_array_5_focus_r;
MCNUM p_interact = mccchannel_9_analyzer_1_array_crystal_array_5_p_interact;
char* mask_string = mccchannel_9_analyzer_1_array_crystal_array_5_mask_string;
char* mask_setting = mccchannel_9_analyzer_1_array_crystal_array_5_mask_setting;
MCNUM number_of_activations = mccchannel_9_analyzer_1_array_crystal_array_5_number_of_activations;
}   /* End of channel_9_analyzer_1_array_crystal_array_5=Union_box() SETTING parameter declarations. */
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex
  /* Label for restoring  neutron */
  mcabsorbCompchannel_9_analyzer_1_array_crystal_array_5:
  if (RESTORE) /* restore if needed */
  { RESTORE_NEUTRON(477,
      mcnlx,
      mcnly,
      mcnlz,
      mcnlvx,
      mcnlvy,
      mcnlvz,
      mcnlt,
      mcnlsx,
      mcnlsy,
      mcnlsz,
      mcnlp); }
#undef mcabsorbComp
#undef p
#undef sz
#undef sy
#undef sx
#undef t
#undef vz
#undef vy
#undef vx
#undef z
#undef y
#undef x
  mcDEBUG_STATE(
mcnlx,
mcnly,
mcnlz,
mcnlvx,
mcnlvy,
mcnlvz,
mcnlt,
mcnlsx,
mcnlsy,
mcnlsz,
mcnlp)

  /* TRACE Component channel_9_analyzer_1_array_crystal_array_6 [478] */
  mccoordschange(mcposrchannel_9_analyzer_1_array_crystal_array_6, mcrotrchannel_9_analyzer_1_array_crystal_array_6,
    &mcnlx,
    &mcnly,
    &mcnlz,
    &mcnlvx,
    &mcnlvy,
    &mcnlvz,
    &mcnlsx,
    &mcnlsy,
    &mcnlsz);
  /* define label inside component channel_9_analyzer_1_array_crystal_array_6 (without coords transformations) */
  mcJumpTrace_channel_9_analyzer_1_array_crystal_array_6:
  SIG_MESSAGE("channel_9_analyzer_1_array_crystal_array_6 (Trace)");
  mcDEBUG_COMP("channel_9_analyzer_1_array_crystal_array_6")
  mcDEBUG_STATE(
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp)
#define x mcnlx
#define y mcnly
#define z mcnlz
#define vx mcnlvx
#define vy mcnlvy
#define vz mcnlvz
#define t mcnlt
#define sx mcnlsx
#define sy mcnlsy
#define sz mcnlsz
#define p mcnlp

#define mcabsorbComp mcabsorbCompchannel_9_analyzer_1_array_crystal_array_6
  STORE_NEUTRON(478,
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp);
  mcScattered=0;
  mcRestore=0;
  mcNCounter[478]++;
  mcPCounter[478] += p;
  mcP2Counter[478] += p*p;
#define mccompcurname  channel_9_analyzer_1_array_crystal_array_6
#define mccompcurtype  Union_box
#define mccompcurindex 478
#define loop_index mccchannel_9_analyzer_1_array_crystal_array_6_loop_index
#define this_box_volume mccchannel_9_analyzer_1_array_crystal_array_6_this_box_volume
#define global_geometry_element mccchannel_9_analyzer_1_array_crystal_array_6_global_geometry_element
#define this_box_storage mccchannel_9_analyzer_1_array_crystal_array_6_this_box_storage
{   /* Declarations of channel_9_analyzer_1_array_crystal_array_6=Union_box() SETTING parameters. */
char* material_string = mccchannel_9_analyzer_1_array_crystal_array_6_material_string;
MCNUM priority = mccchannel_9_analyzer_1_array_crystal_array_6_priority;
MCNUM xwidth = mccchannel_9_analyzer_1_array_crystal_array_6_xwidth;
MCNUM yheight = mccchannel_9_analyzer_1_array_crystal_array_6_yheight;
MCNUM zdepth = mccchannel_9_analyzer_1_array_crystal_array_6_zdepth;
MCNUM xwidth2 = mccchannel_9_analyzer_1_array_crystal_array_6_xwidth2;
MCNUM yheight2 = mccchannel_9_analyzer_1_array_crystal_array_6_yheight2;
MCNUM visualize = mccchannel_9_analyzer_1_array_crystal_array_6_visualize;
int target_index = mccchannel_9_analyzer_1_array_crystal_array_6_target_index;
MCNUM target_x = mccchannel_9_analyzer_1_array_crystal_array_6_target_x;
MCNUM target_y = mccchannel_9_analyzer_1_array_crystal_array_6_target_y;
MCNUM target_z = mccchannel_9_analyzer_1_array_crystal_array_6_target_z;
MCNUM focus_aw = mccchannel_9_analyzer_1_array_crystal_array_6_focus_aw;
MCNUM focus_ah = mccchannel_9_analyzer_1_array_crystal_array_6_focus_ah;
MCNUM focus_xw = mccchannel_9_analyzer_1_array_crystal_array_6_focus_xw;
MCNUM focus_xh = mccchannel_9_analyzer_1_array_crystal_array_6_focus_xh;
MCNUM focus_r = mccchannel_9_analyzer_1_array_crystal_array_6_focus_r;
MCNUM p_interact = mccchannel_9_analyzer_1_array_crystal_array_6_p_interact;
char* mask_string = mccchannel_9_analyzer_1_array_crystal_array_6_mask_string;
char* mask_setting = mccchannel_9_analyzer_1_array_crystal_array_6_mask_setting;
MCNUM number_of_activations = mccchannel_9_analyzer_1_array_crystal_array_6_number_of_activations;
}   /* End of channel_9_analyzer_1_array_crystal_array_6=Union_box() SETTING parameter declarations. */
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex
  /* Label for restoring  neutron */
  mcabsorbCompchannel_9_analyzer_1_array_crystal_array_6:
  if (RESTORE) /* restore if needed */
  { RESTORE_NEUTRON(478,
      mcnlx,
      mcnly,
      mcnlz,
      mcnlvx,
      mcnlvy,
      mcnlvz,
      mcnlt,
      mcnlsx,
      mcnlsy,
      mcnlsz,
      mcnlp); }
#undef mcabsorbComp
#undef p
#undef sz
#undef sy
#undef sx
#undef t
#undef vz
#undef vy
#undef vx
#undef z
#undef y
#undef x
  mcDEBUG_STATE(
mcnlx,
mcnly,
mcnlz,
mcnlvx,
mcnlvy,
mcnlvz,
mcnlt,
mcnlsx,
mcnlsy,
mcnlsz,
mcnlp)

  /* TRACE Component channel_9_analyzer_1_array_crystal_array_7 [479] */
  mccoordschange(mcposrchannel_9_analyzer_1_array_crystal_array_7, mcrotrchannel_9_analyzer_1_array_crystal_array_7,
    &mcnlx,
    &mcnly,
    &mcnlz,
    &mcnlvx,
    &mcnlvy,
    &mcnlvz,
    &mcnlsx,
    &mcnlsy,
    &mcnlsz);
  /* define label inside component channel_9_analyzer_1_array_crystal_array_7 (without coords transformations) */
  mcJumpTrace_channel_9_analyzer_1_array_crystal_array_7:
  SIG_MESSAGE("channel_9_analyzer_1_array_crystal_array_7 (Trace)");
  mcDEBUG_COMP("channel_9_analyzer_1_array_crystal_array_7")
  mcDEBUG_STATE(
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp)
#define x mcnlx
#define y mcnly
#define z mcnlz
#define vx mcnlvx
#define vy mcnlvy
#define vz mcnlvz
#define t mcnlt
#define sx mcnlsx
#define sy mcnlsy
#define sz mcnlsz
#define p mcnlp

#define mcabsorbComp mcabsorbCompchannel_9_analyzer_1_array_crystal_array_7
  STORE_NEUTRON(479,
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp);
  mcScattered=0;
  mcRestore=0;
  mcNCounter[479]++;
  mcPCounter[479] += p;
  mcP2Counter[479] += p*p;
#define mccompcurname  channel_9_analyzer_1_array_crystal_array_7
#define mccompcurtype  Union_box
#define mccompcurindex 479
#define loop_index mccchannel_9_analyzer_1_array_crystal_array_7_loop_index
#define this_box_volume mccchannel_9_analyzer_1_array_crystal_array_7_this_box_volume
#define global_geometry_element mccchannel_9_analyzer_1_array_crystal_array_7_global_geometry_element
#define this_box_storage mccchannel_9_analyzer_1_array_crystal_array_7_this_box_storage
{   /* Declarations of channel_9_analyzer_1_array_crystal_array_7=Union_box() SETTING parameters. */
char* material_string = mccchannel_9_analyzer_1_array_crystal_array_7_material_string;
MCNUM priority = mccchannel_9_analyzer_1_array_crystal_array_7_priority;
MCNUM xwidth = mccchannel_9_analyzer_1_array_crystal_array_7_xwidth;
MCNUM yheight = mccchannel_9_analyzer_1_array_crystal_array_7_yheight;
MCNUM zdepth = mccchannel_9_analyzer_1_array_crystal_array_7_zdepth;
MCNUM xwidth2 = mccchannel_9_analyzer_1_array_crystal_array_7_xwidth2;
MCNUM yheight2 = mccchannel_9_analyzer_1_array_crystal_array_7_yheight2;
MCNUM visualize = mccchannel_9_analyzer_1_array_crystal_array_7_visualize;
int target_index = mccchannel_9_analyzer_1_array_crystal_array_7_target_index;
MCNUM target_x = mccchannel_9_analyzer_1_array_crystal_array_7_target_x;
MCNUM target_y = mccchannel_9_analyzer_1_array_crystal_array_7_target_y;
MCNUM target_z = mccchannel_9_analyzer_1_array_crystal_array_7_target_z;
MCNUM focus_aw = mccchannel_9_analyzer_1_array_crystal_array_7_focus_aw;
MCNUM focus_ah = mccchannel_9_analyzer_1_array_crystal_array_7_focus_ah;
MCNUM focus_xw = mccchannel_9_analyzer_1_array_crystal_array_7_focus_xw;
MCNUM focus_xh = mccchannel_9_analyzer_1_array_crystal_array_7_focus_xh;
MCNUM focus_r = mccchannel_9_analyzer_1_array_crystal_array_7_focus_r;
MCNUM p_interact = mccchannel_9_analyzer_1_array_crystal_array_7_p_interact;
char* mask_string = mccchannel_9_analyzer_1_array_crystal_array_7_mask_string;
char* mask_setting = mccchannel_9_analyzer_1_array_crystal_array_7_mask_setting;
MCNUM number_of_activations = mccchannel_9_analyzer_1_array_crystal_array_7_number_of_activations;
}   /* End of channel_9_analyzer_1_array_crystal_array_7=Union_box() SETTING parameter declarations. */
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex
  /* Label for restoring  neutron */
  mcabsorbCompchannel_9_analyzer_1_array_crystal_array_7:
  if (RESTORE) /* restore if needed */
  { RESTORE_NEUTRON(479,
      mcnlx,
      mcnly,
      mcnlz,
      mcnlvx,
      mcnlvy,
      mcnlvz,
      mcnlt,
      mcnlsx,
      mcnlsy,
      mcnlsz,
      mcnlp); }
#undef mcabsorbComp
#undef p
#undef sz
#undef sy
#undef sx
#undef t
#undef vz
#undef vy
#undef vx
#undef z
#undef y
#undef x
  mcDEBUG_STATE(
mcnlx,
mcnly,
mcnlz,
mcnlvx,
mcnlvy,
mcnlvz,
mcnlt,
mcnlsx,
mcnlsy,
mcnlsz,
mcnlp)

  /* TRACE Component channel_9_analyzer_1_array_crystal_array_8 [480] */
  mccoordschange(mcposrchannel_9_analyzer_1_array_crystal_array_8, mcrotrchannel_9_analyzer_1_array_crystal_array_8,
    &mcnlx,
    &mcnly,
    &mcnlz,
    &mcnlvx,
    &mcnlvy,
    &mcnlvz,
    &mcnlsx,
    &mcnlsy,
    &mcnlsz);
  /* define label inside component channel_9_analyzer_1_array_crystal_array_8 (without coords transformations) */
  mcJumpTrace_channel_9_analyzer_1_array_crystal_array_8:
  SIG_MESSAGE("channel_9_analyzer_1_array_crystal_array_8 (Trace)");
  mcDEBUG_COMP("channel_9_analyzer_1_array_crystal_array_8")
  mcDEBUG_STATE(
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp)
#define x mcnlx
#define y mcnly
#define z mcnlz
#define vx mcnlvx
#define vy mcnlvy
#define vz mcnlvz
#define t mcnlt
#define sx mcnlsx
#define sy mcnlsy
#define sz mcnlsz
#define p mcnlp

#define mcabsorbComp mcabsorbCompchannel_9_analyzer_1_array_crystal_array_8
  STORE_NEUTRON(480,
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp);
  mcScattered=0;
  mcRestore=0;
  mcNCounter[480]++;
  mcPCounter[480] += p;
  mcP2Counter[480] += p*p;
#define mccompcurname  channel_9_analyzer_1_array_crystal_array_8
#define mccompcurtype  Union_box
#define mccompcurindex 480
#define loop_index mccchannel_9_analyzer_1_array_crystal_array_8_loop_index
#define this_box_volume mccchannel_9_analyzer_1_array_crystal_array_8_this_box_volume
#define global_geometry_element mccchannel_9_analyzer_1_array_crystal_array_8_global_geometry_element
#define this_box_storage mccchannel_9_analyzer_1_array_crystal_array_8_this_box_storage
{   /* Declarations of channel_9_analyzer_1_array_crystal_array_8=Union_box() SETTING parameters. */
char* material_string = mccchannel_9_analyzer_1_array_crystal_array_8_material_string;
MCNUM priority = mccchannel_9_analyzer_1_array_crystal_array_8_priority;
MCNUM xwidth = mccchannel_9_analyzer_1_array_crystal_array_8_xwidth;
MCNUM yheight = mccchannel_9_analyzer_1_array_crystal_array_8_yheight;
MCNUM zdepth = mccchannel_9_analyzer_1_array_crystal_array_8_zdepth;
MCNUM xwidth2 = mccchannel_9_analyzer_1_array_crystal_array_8_xwidth2;
MCNUM yheight2 = mccchannel_9_analyzer_1_array_crystal_array_8_yheight2;
MCNUM visualize = mccchannel_9_analyzer_1_array_crystal_array_8_visualize;
int target_index = mccchannel_9_analyzer_1_array_crystal_array_8_target_index;
MCNUM target_x = mccchannel_9_analyzer_1_array_crystal_array_8_target_x;
MCNUM target_y = mccchannel_9_analyzer_1_array_crystal_array_8_target_y;
MCNUM target_z = mccchannel_9_analyzer_1_array_crystal_array_8_target_z;
MCNUM focus_aw = mccchannel_9_analyzer_1_array_crystal_array_8_focus_aw;
MCNUM focus_ah = mccchannel_9_analyzer_1_array_crystal_array_8_focus_ah;
MCNUM focus_xw = mccchannel_9_analyzer_1_array_crystal_array_8_focus_xw;
MCNUM focus_xh = mccchannel_9_analyzer_1_array_crystal_array_8_focus_xh;
MCNUM focus_r = mccchannel_9_analyzer_1_array_crystal_array_8_focus_r;
MCNUM p_interact = mccchannel_9_analyzer_1_array_crystal_array_8_p_interact;
char* mask_string = mccchannel_9_analyzer_1_array_crystal_array_8_mask_string;
char* mask_setting = mccchannel_9_analyzer_1_array_crystal_array_8_mask_setting;
MCNUM number_of_activations = mccchannel_9_analyzer_1_array_crystal_array_8_number_of_activations;
}   /* End of channel_9_analyzer_1_array_crystal_array_8=Union_box() SETTING parameter declarations. */
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex
  /* Label for restoring  neutron */
  mcabsorbCompchannel_9_analyzer_1_array_crystal_array_8:
  if (RESTORE) /* restore if needed */
  { RESTORE_NEUTRON(480,
      mcnlx,
      mcnly,
      mcnlz,
      mcnlvx,
      mcnlvy,
      mcnlvz,
      mcnlt,
      mcnlsx,
      mcnlsy,
      mcnlsz,
      mcnlp); }
#undef mcabsorbComp
#undef p
#undef sz
#undef sy
#undef sx
#undef t
#undef vz
#undef vy
#undef vx
#undef z
#undef y
#undef x
  mcDEBUG_STATE(
mcnlx,
mcnly,
mcnlz,
mcnlvx,
mcnlvy,
mcnlvz,
mcnlt,
mcnlsx,
mcnlsy,
mcnlsz,
mcnlp)

  /* TRACE Component channel_9_analyzer_2_center [481] */
  mccoordschange(mcposrchannel_9_analyzer_2_center, mcrotrchannel_9_analyzer_2_center,
    &mcnlx,
    &mcnly,
    &mcnlz,
    &mcnlvx,
    &mcnlvy,
    &mcnlvz,
    &mcnlsx,
    &mcnlsy,
    &mcnlsz);
  /* define label inside component channel_9_analyzer_2_center (without coords transformations) */
  mcJumpTrace_channel_9_analyzer_2_center:
  SIG_MESSAGE("channel_9_analyzer_2_center (Trace)");
  mcDEBUG_COMP("channel_9_analyzer_2_center")
  mcDEBUG_STATE(
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp)
#define x mcnlx
#define y mcnly
#define z mcnlz
#define vx mcnlvx
#define vy mcnlvy
#define vz mcnlvz
#define t mcnlt
#define sx mcnlsx
#define sy mcnlsy
#define sz mcnlsz
#define p mcnlp

#define mcabsorbComp mcabsorbCompchannel_9_analyzer_2_center
  STORE_NEUTRON(481,
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp);
  mcScattered=0;
  mcRestore=0;
  mcNCounter[481]++;
  mcPCounter[481] += p;
  mcP2Counter[481] += p*p;
#define mccompcurname  channel_9_analyzer_2_center
#define mccompcurtype  Arm
#define mccompcurindex 481
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex
  /* Label for restoring  neutron */
  mcabsorbCompchannel_9_analyzer_2_center:
  if (RESTORE) /* restore if needed */
  { RESTORE_NEUTRON(481,
      mcnlx,
      mcnly,
      mcnlz,
      mcnlvx,
      mcnlvy,
      mcnlvz,
      mcnlt,
      mcnlsx,
      mcnlsy,
      mcnlsz,
      mcnlp); }
#undef mcabsorbComp
#undef p
#undef sz
#undef sy
#undef sx
#undef t
#undef vz
#undef vy
#undef vx
#undef z
#undef y
#undef x
  mcDEBUG_STATE(
mcnlx,
mcnly,
mcnlz,
mcnlvx,
mcnlvy,
mcnlvz,
mcnlt,
mcnlsx,
mcnlsy,
mcnlsz,
mcnlp)

  /* TRACE Component channel_9_analyzer_2_rotated [482] */
  mccoordschange(mcposrchannel_9_analyzer_2_rotated, mcrotrchannel_9_analyzer_2_rotated,
    &mcnlx,
    &mcnly,
    &mcnlz,
    &mcnlvx,
    &mcnlvy,
    &mcnlvz,
    &mcnlsx,
    &mcnlsy,
    &mcnlsz);
  /* define label inside component channel_9_analyzer_2_rotated (without coords transformations) */
  mcJumpTrace_channel_9_analyzer_2_rotated:
  SIG_MESSAGE("channel_9_analyzer_2_rotated (Trace)");
  mcDEBUG_COMP("channel_9_analyzer_2_rotated")
  mcDEBUG_STATE(
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp)
#define x mcnlx
#define y mcnly
#define z mcnlz
#define vx mcnlvx
#define vy mcnlvy
#define vz mcnlvz
#define t mcnlt
#define sx mcnlsx
#define sy mcnlsy
#define sz mcnlsz
#define p mcnlp

#define mcabsorbComp mcabsorbCompchannel_9_analyzer_2_rotated
  STORE_NEUTRON(482,
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp);
  mcScattered=0;
  mcRestore=0;
  mcNCounter[482]++;
  mcPCounter[482] += p;
  mcP2Counter[482] += p*p;
#define mccompcurname  channel_9_analyzer_2_rotated
#define mccompcurtype  Arm
#define mccompcurindex 482
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex
  /* Label for restoring  neutron */
  mcabsorbCompchannel_9_analyzer_2_rotated:
  if (RESTORE) /* restore if needed */
  { RESTORE_NEUTRON(482,
      mcnlx,
      mcnly,
      mcnlz,
      mcnlvx,
      mcnlvy,
      mcnlvz,
      mcnlt,
      mcnlsx,
      mcnlsy,
      mcnlsz,
      mcnlp); }
#undef mcabsorbComp
#undef p
#undef sz
#undef sy
#undef sx
#undef t
#undef vz
#undef vy
#undef vx
#undef z
#undef y
#undef x
  mcDEBUG_STATE(
mcnlx,
mcnly,
mcnlz,
mcnlvx,
mcnlvy,
mcnlvz,
mcnlt,
mcnlsx,
mcnlsy,
mcnlsz,
mcnlp)

  /* TRACE Component channel_9_analyzer_2_array_crystal_array_0 [483] */
  mccoordschange(mcposrchannel_9_analyzer_2_array_crystal_array_0, mcrotrchannel_9_analyzer_2_array_crystal_array_0,
    &mcnlx,
    &mcnly,
    &mcnlz,
    &mcnlvx,
    &mcnlvy,
    &mcnlvz,
    &mcnlsx,
    &mcnlsy,
    &mcnlsz);
  /* define label inside component channel_9_analyzer_2_array_crystal_array_0 (without coords transformations) */
  mcJumpTrace_channel_9_analyzer_2_array_crystal_array_0:
  SIG_MESSAGE("channel_9_analyzer_2_array_crystal_array_0 (Trace)");
  mcDEBUG_COMP("channel_9_analyzer_2_array_crystal_array_0")
  mcDEBUG_STATE(
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp)
#define x mcnlx
#define y mcnly
#define z mcnlz
#define vx mcnlvx
#define vy mcnlvy
#define vz mcnlvz
#define t mcnlt
#define sx mcnlsx
#define sy mcnlsy
#define sz mcnlsz
#define p mcnlp

#define mcabsorbComp mcabsorbCompchannel_9_analyzer_2_array_crystal_array_0
  STORE_NEUTRON(483,
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp);
  mcScattered=0;
  mcRestore=0;
  mcNCounter[483]++;
  mcPCounter[483] += p;
  mcP2Counter[483] += p*p;
#define mccompcurname  channel_9_analyzer_2_array_crystal_array_0
#define mccompcurtype  Union_box
#define mccompcurindex 483
#define loop_index mccchannel_9_analyzer_2_array_crystal_array_0_loop_index
#define this_box_volume mccchannel_9_analyzer_2_array_crystal_array_0_this_box_volume
#define global_geometry_element mccchannel_9_analyzer_2_array_crystal_array_0_global_geometry_element
#define this_box_storage mccchannel_9_analyzer_2_array_crystal_array_0_this_box_storage
{   /* Declarations of channel_9_analyzer_2_array_crystal_array_0=Union_box() SETTING parameters. */
char* material_string = mccchannel_9_analyzer_2_array_crystal_array_0_material_string;
MCNUM priority = mccchannel_9_analyzer_2_array_crystal_array_0_priority;
MCNUM xwidth = mccchannel_9_analyzer_2_array_crystal_array_0_xwidth;
MCNUM yheight = mccchannel_9_analyzer_2_array_crystal_array_0_yheight;
MCNUM zdepth = mccchannel_9_analyzer_2_array_crystal_array_0_zdepth;
MCNUM xwidth2 = mccchannel_9_analyzer_2_array_crystal_array_0_xwidth2;
MCNUM yheight2 = mccchannel_9_analyzer_2_array_crystal_array_0_yheight2;
MCNUM visualize = mccchannel_9_analyzer_2_array_crystal_array_0_visualize;
int target_index = mccchannel_9_analyzer_2_array_crystal_array_0_target_index;
MCNUM target_x = mccchannel_9_analyzer_2_array_crystal_array_0_target_x;
MCNUM target_y = mccchannel_9_analyzer_2_array_crystal_array_0_target_y;
MCNUM target_z = mccchannel_9_analyzer_2_array_crystal_array_0_target_z;
MCNUM focus_aw = mccchannel_9_analyzer_2_array_crystal_array_0_focus_aw;
MCNUM focus_ah = mccchannel_9_analyzer_2_array_crystal_array_0_focus_ah;
MCNUM focus_xw = mccchannel_9_analyzer_2_array_crystal_array_0_focus_xw;
MCNUM focus_xh = mccchannel_9_analyzer_2_array_crystal_array_0_focus_xh;
MCNUM focus_r = mccchannel_9_analyzer_2_array_crystal_array_0_focus_r;
MCNUM p_interact = mccchannel_9_analyzer_2_array_crystal_array_0_p_interact;
char* mask_string = mccchannel_9_analyzer_2_array_crystal_array_0_mask_string;
char* mask_setting = mccchannel_9_analyzer_2_array_crystal_array_0_mask_setting;
MCNUM number_of_activations = mccchannel_9_analyzer_2_array_crystal_array_0_number_of_activations;
}   /* End of channel_9_analyzer_2_array_crystal_array_0=Union_box() SETTING parameter declarations. */
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex
  /* Label for restoring  neutron */
  mcabsorbCompchannel_9_analyzer_2_array_crystal_array_0:
  if (RESTORE) /* restore if needed */
  { RESTORE_NEUTRON(483,
      mcnlx,
      mcnly,
      mcnlz,
      mcnlvx,
      mcnlvy,
      mcnlvz,
      mcnlt,
      mcnlsx,
      mcnlsy,
      mcnlsz,
      mcnlp); }
#undef mcabsorbComp
#undef p
#undef sz
#undef sy
#undef sx
#undef t
#undef vz
#undef vy
#undef vx
#undef z
#undef y
#undef x
  mcDEBUG_STATE(
mcnlx,
mcnly,
mcnlz,
mcnlvx,
mcnlvy,
mcnlvz,
mcnlt,
mcnlsx,
mcnlsy,
mcnlsz,
mcnlp)

  /* TRACE Component channel_9_analyzer_2_array_crystal_array_1 [484] */
  mccoordschange(mcposrchannel_9_analyzer_2_array_crystal_array_1, mcrotrchannel_9_analyzer_2_array_crystal_array_1,
    &mcnlx,
    &mcnly,
    &mcnlz,
    &mcnlvx,
    &mcnlvy,
    &mcnlvz,
    &mcnlsx,
    &mcnlsy,
    &mcnlsz);
  /* define label inside component channel_9_analyzer_2_array_crystal_array_1 (without coords transformations) */
  mcJumpTrace_channel_9_analyzer_2_array_crystal_array_1:
  SIG_MESSAGE("channel_9_analyzer_2_array_crystal_array_1 (Trace)");
  mcDEBUG_COMP("channel_9_analyzer_2_array_crystal_array_1")
  mcDEBUG_STATE(
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp)
#define x mcnlx
#define y mcnly
#define z mcnlz
#define vx mcnlvx
#define vy mcnlvy
#define vz mcnlvz
#define t mcnlt
#define sx mcnlsx
#define sy mcnlsy
#define sz mcnlsz
#define p mcnlp

#define mcabsorbComp mcabsorbCompchannel_9_analyzer_2_array_crystal_array_1
  STORE_NEUTRON(484,
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp);
  mcScattered=0;
  mcRestore=0;
  mcNCounter[484]++;
  mcPCounter[484] += p;
  mcP2Counter[484] += p*p;
#define mccompcurname  channel_9_analyzer_2_array_crystal_array_1
#define mccompcurtype  Union_box
#define mccompcurindex 484
#define loop_index mccchannel_9_analyzer_2_array_crystal_array_1_loop_index
#define this_box_volume mccchannel_9_analyzer_2_array_crystal_array_1_this_box_volume
#define global_geometry_element mccchannel_9_analyzer_2_array_crystal_array_1_global_geometry_element
#define this_box_storage mccchannel_9_analyzer_2_array_crystal_array_1_this_box_storage
{   /* Declarations of channel_9_analyzer_2_array_crystal_array_1=Union_box() SETTING parameters. */
char* material_string = mccchannel_9_analyzer_2_array_crystal_array_1_material_string;
MCNUM priority = mccchannel_9_analyzer_2_array_crystal_array_1_priority;
MCNUM xwidth = mccchannel_9_analyzer_2_array_crystal_array_1_xwidth;
MCNUM yheight = mccchannel_9_analyzer_2_array_crystal_array_1_yheight;
MCNUM zdepth = mccchannel_9_analyzer_2_array_crystal_array_1_zdepth;
MCNUM xwidth2 = mccchannel_9_analyzer_2_array_crystal_array_1_xwidth2;
MCNUM yheight2 = mccchannel_9_analyzer_2_array_crystal_array_1_yheight2;
MCNUM visualize = mccchannel_9_analyzer_2_array_crystal_array_1_visualize;
int target_index = mccchannel_9_analyzer_2_array_crystal_array_1_target_index;
MCNUM target_x = mccchannel_9_analyzer_2_array_crystal_array_1_target_x;
MCNUM target_y = mccchannel_9_analyzer_2_array_crystal_array_1_target_y;
MCNUM target_z = mccchannel_9_analyzer_2_array_crystal_array_1_target_z;
MCNUM focus_aw = mccchannel_9_analyzer_2_array_crystal_array_1_focus_aw;
MCNUM focus_ah = mccchannel_9_analyzer_2_array_crystal_array_1_focus_ah;
MCNUM focus_xw = mccchannel_9_analyzer_2_array_crystal_array_1_focus_xw;
MCNUM focus_xh = mccchannel_9_analyzer_2_array_crystal_array_1_focus_xh;
MCNUM focus_r = mccchannel_9_analyzer_2_array_crystal_array_1_focus_r;
MCNUM p_interact = mccchannel_9_analyzer_2_array_crystal_array_1_p_interact;
char* mask_string = mccchannel_9_analyzer_2_array_crystal_array_1_mask_string;
char* mask_setting = mccchannel_9_analyzer_2_array_crystal_array_1_mask_setting;
MCNUM number_of_activations = mccchannel_9_analyzer_2_array_crystal_array_1_number_of_activations;
}   /* End of channel_9_analyzer_2_array_crystal_array_1=Union_box() SETTING parameter declarations. */
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex
  /* Label for restoring  neutron */
  mcabsorbCompchannel_9_analyzer_2_array_crystal_array_1:
  if (RESTORE) /* restore if needed */
  { RESTORE_NEUTRON(484,
      mcnlx,
      mcnly,
      mcnlz,
      mcnlvx,
      mcnlvy,
      mcnlvz,
      mcnlt,
      mcnlsx,
      mcnlsy,
      mcnlsz,
      mcnlp); }
#undef mcabsorbComp
#undef p
#undef sz
#undef sy
#undef sx
#undef t
#undef vz
#undef vy
#undef vx
#undef z
#undef y
#undef x
  mcDEBUG_STATE(
mcnlx,
mcnly,
mcnlz,
mcnlvx,
mcnlvy,
mcnlvz,
mcnlt,
mcnlsx,
mcnlsy,
mcnlsz,
mcnlp)

  /* TRACE Component channel_9_analyzer_2_array_crystal_array_2 [485] */
  mccoordschange(mcposrchannel_9_analyzer_2_array_crystal_array_2, mcrotrchannel_9_analyzer_2_array_crystal_array_2,
    &mcnlx,
    &mcnly,
    &mcnlz,
    &mcnlvx,
    &mcnlvy,
    &mcnlvz,
    &mcnlsx,
    &mcnlsy,
    &mcnlsz);
  /* define label inside component channel_9_analyzer_2_array_crystal_array_2 (without coords transformations) */
  mcJumpTrace_channel_9_analyzer_2_array_crystal_array_2:
  SIG_MESSAGE("channel_9_analyzer_2_array_crystal_array_2 (Trace)");
  mcDEBUG_COMP("channel_9_analyzer_2_array_crystal_array_2")
  mcDEBUG_STATE(
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp)
#define x mcnlx
#define y mcnly
#define z mcnlz
#define vx mcnlvx
#define vy mcnlvy
#define vz mcnlvz
#define t mcnlt
#define sx mcnlsx
#define sy mcnlsy
#define sz mcnlsz
#define p mcnlp

#define mcabsorbComp mcabsorbCompchannel_9_analyzer_2_array_crystal_array_2
  STORE_NEUTRON(485,
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp);
  mcScattered=0;
  mcRestore=0;
  mcNCounter[485]++;
  mcPCounter[485] += p;
  mcP2Counter[485] += p*p;
#define mccompcurname  channel_9_analyzer_2_array_crystal_array_2
#define mccompcurtype  Union_box
#define mccompcurindex 485
#define loop_index mccchannel_9_analyzer_2_array_crystal_array_2_loop_index
#define this_box_volume mccchannel_9_analyzer_2_array_crystal_array_2_this_box_volume
#define global_geometry_element mccchannel_9_analyzer_2_array_crystal_array_2_global_geometry_element
#define this_box_storage mccchannel_9_analyzer_2_array_crystal_array_2_this_box_storage
{   /* Declarations of channel_9_analyzer_2_array_crystal_array_2=Union_box() SETTING parameters. */
char* material_string = mccchannel_9_analyzer_2_array_crystal_array_2_material_string;
MCNUM priority = mccchannel_9_analyzer_2_array_crystal_array_2_priority;
MCNUM xwidth = mccchannel_9_analyzer_2_array_crystal_array_2_xwidth;
MCNUM yheight = mccchannel_9_analyzer_2_array_crystal_array_2_yheight;
MCNUM zdepth = mccchannel_9_analyzer_2_array_crystal_array_2_zdepth;
MCNUM xwidth2 = mccchannel_9_analyzer_2_array_crystal_array_2_xwidth2;
MCNUM yheight2 = mccchannel_9_analyzer_2_array_crystal_array_2_yheight2;
MCNUM visualize = mccchannel_9_analyzer_2_array_crystal_array_2_visualize;
int target_index = mccchannel_9_analyzer_2_array_crystal_array_2_target_index;
MCNUM target_x = mccchannel_9_analyzer_2_array_crystal_array_2_target_x;
MCNUM target_y = mccchannel_9_analyzer_2_array_crystal_array_2_target_y;
MCNUM target_z = mccchannel_9_analyzer_2_array_crystal_array_2_target_z;
MCNUM focus_aw = mccchannel_9_analyzer_2_array_crystal_array_2_focus_aw;
MCNUM focus_ah = mccchannel_9_analyzer_2_array_crystal_array_2_focus_ah;
MCNUM focus_xw = mccchannel_9_analyzer_2_array_crystal_array_2_focus_xw;
MCNUM focus_xh = mccchannel_9_analyzer_2_array_crystal_array_2_focus_xh;
MCNUM focus_r = mccchannel_9_analyzer_2_array_crystal_array_2_focus_r;
MCNUM p_interact = mccchannel_9_analyzer_2_array_crystal_array_2_p_interact;
char* mask_string = mccchannel_9_analyzer_2_array_crystal_array_2_mask_string;
char* mask_setting = mccchannel_9_analyzer_2_array_crystal_array_2_mask_setting;
MCNUM number_of_activations = mccchannel_9_analyzer_2_array_crystal_array_2_number_of_activations;
}   /* End of channel_9_analyzer_2_array_crystal_array_2=Union_box() SETTING parameter declarations. */
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex
  /* Label for restoring  neutron */
  mcabsorbCompchannel_9_analyzer_2_array_crystal_array_2:
  if (RESTORE) /* restore if needed */
  { RESTORE_NEUTRON(485,
      mcnlx,
      mcnly,
      mcnlz,
      mcnlvx,
      mcnlvy,
      mcnlvz,
      mcnlt,
      mcnlsx,
      mcnlsy,
      mcnlsz,
      mcnlp); }
#undef mcabsorbComp
#undef p
#undef sz
#undef sy
#undef sx
#undef t
#undef vz
#undef vy
#undef vx
#undef z
#undef y
#undef x
  mcDEBUG_STATE(
mcnlx,
mcnly,
mcnlz,
mcnlvx,
mcnlvy,
mcnlvz,
mcnlt,
mcnlsx,
mcnlsy,
mcnlsz,
mcnlp)

  /* TRACE Component channel_9_analyzer_2_array_crystal_array_3 [486] */
  mccoordschange(mcposrchannel_9_analyzer_2_array_crystal_array_3, mcrotrchannel_9_analyzer_2_array_crystal_array_3,
    &mcnlx,
    &mcnly,
    &mcnlz,
    &mcnlvx,
    &mcnlvy,
    &mcnlvz,
    &mcnlsx,
    &mcnlsy,
    &mcnlsz);
  /* define label inside component channel_9_analyzer_2_array_crystal_array_3 (without coords transformations) */
  mcJumpTrace_channel_9_analyzer_2_array_crystal_array_3:
  SIG_MESSAGE("channel_9_analyzer_2_array_crystal_array_3 (Trace)");
  mcDEBUG_COMP("channel_9_analyzer_2_array_crystal_array_3")
  mcDEBUG_STATE(
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp)
#define x mcnlx
#define y mcnly
#define z mcnlz
#define vx mcnlvx
#define vy mcnlvy
#define vz mcnlvz
#define t mcnlt
#define sx mcnlsx
#define sy mcnlsy
#define sz mcnlsz
#define p mcnlp

#define mcabsorbComp mcabsorbCompchannel_9_analyzer_2_array_crystal_array_3
  STORE_NEUTRON(486,
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp);
  mcScattered=0;
  mcRestore=0;
  mcNCounter[486]++;
  mcPCounter[486] += p;
  mcP2Counter[486] += p*p;
#define mccompcurname  channel_9_analyzer_2_array_crystal_array_3
#define mccompcurtype  Union_box
#define mccompcurindex 486
#define loop_index mccchannel_9_analyzer_2_array_crystal_array_3_loop_index
#define this_box_volume mccchannel_9_analyzer_2_array_crystal_array_3_this_box_volume
#define global_geometry_element mccchannel_9_analyzer_2_array_crystal_array_3_global_geometry_element
#define this_box_storage mccchannel_9_analyzer_2_array_crystal_array_3_this_box_storage
{   /* Declarations of channel_9_analyzer_2_array_crystal_array_3=Union_box() SETTING parameters. */
char* material_string = mccchannel_9_analyzer_2_array_crystal_array_3_material_string;
MCNUM priority = mccchannel_9_analyzer_2_array_crystal_array_3_priority;
MCNUM xwidth = mccchannel_9_analyzer_2_array_crystal_array_3_xwidth;
MCNUM yheight = mccchannel_9_analyzer_2_array_crystal_array_3_yheight;
MCNUM zdepth = mccchannel_9_analyzer_2_array_crystal_array_3_zdepth;
MCNUM xwidth2 = mccchannel_9_analyzer_2_array_crystal_array_3_xwidth2;
MCNUM yheight2 = mccchannel_9_analyzer_2_array_crystal_array_3_yheight2;
MCNUM visualize = mccchannel_9_analyzer_2_array_crystal_array_3_visualize;
int target_index = mccchannel_9_analyzer_2_array_crystal_array_3_target_index;
MCNUM target_x = mccchannel_9_analyzer_2_array_crystal_array_3_target_x;
MCNUM target_y = mccchannel_9_analyzer_2_array_crystal_array_3_target_y;
MCNUM target_z = mccchannel_9_analyzer_2_array_crystal_array_3_target_z;
MCNUM focus_aw = mccchannel_9_analyzer_2_array_crystal_array_3_focus_aw;
MCNUM focus_ah = mccchannel_9_analyzer_2_array_crystal_array_3_focus_ah;
MCNUM focus_xw = mccchannel_9_analyzer_2_array_crystal_array_3_focus_xw;
MCNUM focus_xh = mccchannel_9_analyzer_2_array_crystal_array_3_focus_xh;
MCNUM focus_r = mccchannel_9_analyzer_2_array_crystal_array_3_focus_r;
MCNUM p_interact = mccchannel_9_analyzer_2_array_crystal_array_3_p_interact;
char* mask_string = mccchannel_9_analyzer_2_array_crystal_array_3_mask_string;
char* mask_setting = mccchannel_9_analyzer_2_array_crystal_array_3_mask_setting;
MCNUM number_of_activations = mccchannel_9_analyzer_2_array_crystal_array_3_number_of_activations;
}   /* End of channel_9_analyzer_2_array_crystal_array_3=Union_box() SETTING parameter declarations. */
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex
  /* Label for restoring  neutron */
  mcabsorbCompchannel_9_analyzer_2_array_crystal_array_3:
  if (RESTORE) /* restore if needed */
  { RESTORE_NEUTRON(486,
      mcnlx,
      mcnly,
      mcnlz,
      mcnlvx,
      mcnlvy,
      mcnlvz,
      mcnlt,
      mcnlsx,
      mcnlsy,
      mcnlsz,
      mcnlp); }
#undef mcabsorbComp
#undef p
#undef sz
#undef sy
#undef sx
#undef t
#undef vz
#undef vy
#undef vx
#undef z
#undef y
#undef x
  mcDEBUG_STATE(
mcnlx,
mcnly,
mcnlz,
mcnlvx,
mcnlvy,
mcnlvz,
mcnlt,
mcnlsx,
mcnlsy,
mcnlsz,
mcnlp)

  /* TRACE Component channel_9_analyzer_2_array_crystal_array_4 [487] */
  mccoordschange(mcposrchannel_9_analyzer_2_array_crystal_array_4, mcrotrchannel_9_analyzer_2_array_crystal_array_4,
    &mcnlx,
    &mcnly,
    &mcnlz,
    &mcnlvx,
    &mcnlvy,
    &mcnlvz,
    &mcnlsx,
    &mcnlsy,
    &mcnlsz);
  /* define label inside component channel_9_analyzer_2_array_crystal_array_4 (without coords transformations) */
  mcJumpTrace_channel_9_analyzer_2_array_crystal_array_4:
  SIG_MESSAGE("channel_9_analyzer_2_array_crystal_array_4 (Trace)");
  mcDEBUG_COMP("channel_9_analyzer_2_array_crystal_array_4")
  mcDEBUG_STATE(
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp)
#define x mcnlx
#define y mcnly
#define z mcnlz
#define vx mcnlvx
#define vy mcnlvy
#define vz mcnlvz
#define t mcnlt
#define sx mcnlsx
#define sy mcnlsy
#define sz mcnlsz
#define p mcnlp

#define mcabsorbComp mcabsorbCompchannel_9_analyzer_2_array_crystal_array_4
  STORE_NEUTRON(487,
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp);
  mcScattered=0;
  mcRestore=0;
  mcNCounter[487]++;
  mcPCounter[487] += p;
  mcP2Counter[487] += p*p;
#define mccompcurname  channel_9_analyzer_2_array_crystal_array_4
#define mccompcurtype  Union_box
#define mccompcurindex 487
#define loop_index mccchannel_9_analyzer_2_array_crystal_array_4_loop_index
#define this_box_volume mccchannel_9_analyzer_2_array_crystal_array_4_this_box_volume
#define global_geometry_element mccchannel_9_analyzer_2_array_crystal_array_4_global_geometry_element
#define this_box_storage mccchannel_9_analyzer_2_array_crystal_array_4_this_box_storage
{   /* Declarations of channel_9_analyzer_2_array_crystal_array_4=Union_box() SETTING parameters. */
char* material_string = mccchannel_9_analyzer_2_array_crystal_array_4_material_string;
MCNUM priority = mccchannel_9_analyzer_2_array_crystal_array_4_priority;
MCNUM xwidth = mccchannel_9_analyzer_2_array_crystal_array_4_xwidth;
MCNUM yheight = mccchannel_9_analyzer_2_array_crystal_array_4_yheight;
MCNUM zdepth = mccchannel_9_analyzer_2_array_crystal_array_4_zdepth;
MCNUM xwidth2 = mccchannel_9_analyzer_2_array_crystal_array_4_xwidth2;
MCNUM yheight2 = mccchannel_9_analyzer_2_array_crystal_array_4_yheight2;
MCNUM visualize = mccchannel_9_analyzer_2_array_crystal_array_4_visualize;
int target_index = mccchannel_9_analyzer_2_array_crystal_array_4_target_index;
MCNUM target_x = mccchannel_9_analyzer_2_array_crystal_array_4_target_x;
MCNUM target_y = mccchannel_9_analyzer_2_array_crystal_array_4_target_y;
MCNUM target_z = mccchannel_9_analyzer_2_array_crystal_array_4_target_z;
MCNUM focus_aw = mccchannel_9_analyzer_2_array_crystal_array_4_focus_aw;
MCNUM focus_ah = mccchannel_9_analyzer_2_array_crystal_array_4_focus_ah;
MCNUM focus_xw = mccchannel_9_analyzer_2_array_crystal_array_4_focus_xw;
MCNUM focus_xh = mccchannel_9_analyzer_2_array_crystal_array_4_focus_xh;
MCNUM focus_r = mccchannel_9_analyzer_2_array_crystal_array_4_focus_r;
MCNUM p_interact = mccchannel_9_analyzer_2_array_crystal_array_4_p_interact;
char* mask_string = mccchannel_9_analyzer_2_array_crystal_array_4_mask_string;
char* mask_setting = mccchannel_9_analyzer_2_array_crystal_array_4_mask_setting;
MCNUM number_of_activations = mccchannel_9_analyzer_2_array_crystal_array_4_number_of_activations;
}   /* End of channel_9_analyzer_2_array_crystal_array_4=Union_box() SETTING parameter declarations. */
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex
  /* Label for restoring  neutron */
  mcabsorbCompchannel_9_analyzer_2_array_crystal_array_4:
  if (RESTORE) /* restore if needed */
  { RESTORE_NEUTRON(487,
      mcnlx,
      mcnly,
      mcnlz,
      mcnlvx,
      mcnlvy,
      mcnlvz,
      mcnlt,
      mcnlsx,
      mcnlsy,
      mcnlsz,
      mcnlp); }
#undef mcabsorbComp
#undef p
#undef sz
#undef sy
#undef sx
#undef t
#undef vz
#undef vy
#undef vx
#undef z
#undef y
#undef x
  mcDEBUG_STATE(
mcnlx,
mcnly,
mcnlz,
mcnlvx,
mcnlvy,
mcnlvz,
mcnlt,
mcnlsx,
mcnlsy,
mcnlsz,
mcnlp)

  /* TRACE Component channel_9_analyzer_2_array_crystal_array_5 [488] */
  mccoordschange(mcposrchannel_9_analyzer_2_array_crystal_array_5, mcrotrchannel_9_analyzer_2_array_crystal_array_5,
    &mcnlx,
    &mcnly,
    &mcnlz,
    &mcnlvx,
    &mcnlvy,
    &mcnlvz,
    &mcnlsx,
    &mcnlsy,
    &mcnlsz);
  /* define label inside component channel_9_analyzer_2_array_crystal_array_5 (without coords transformations) */
  mcJumpTrace_channel_9_analyzer_2_array_crystal_array_5:
  SIG_MESSAGE("channel_9_analyzer_2_array_crystal_array_5 (Trace)");
  mcDEBUG_COMP("channel_9_analyzer_2_array_crystal_array_5")
  mcDEBUG_STATE(
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp)
#define x mcnlx
#define y mcnly
#define z mcnlz
#define vx mcnlvx
#define vy mcnlvy
#define vz mcnlvz
#define t mcnlt
#define sx mcnlsx
#define sy mcnlsy
#define sz mcnlsz
#define p mcnlp

#define mcabsorbComp mcabsorbCompchannel_9_analyzer_2_array_crystal_array_5
  STORE_NEUTRON(488,
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp);
  mcScattered=0;
  mcRestore=0;
  mcNCounter[488]++;
  mcPCounter[488] += p;
  mcP2Counter[488] += p*p;
#define mccompcurname  channel_9_analyzer_2_array_crystal_array_5
#define mccompcurtype  Union_box
#define mccompcurindex 488
#define loop_index mccchannel_9_analyzer_2_array_crystal_array_5_loop_index
#define this_box_volume mccchannel_9_analyzer_2_array_crystal_array_5_this_box_volume
#define global_geometry_element mccchannel_9_analyzer_2_array_crystal_array_5_global_geometry_element
#define this_box_storage mccchannel_9_analyzer_2_array_crystal_array_5_this_box_storage
{   /* Declarations of channel_9_analyzer_2_array_crystal_array_5=Union_box() SETTING parameters. */
char* material_string = mccchannel_9_analyzer_2_array_crystal_array_5_material_string;
MCNUM priority = mccchannel_9_analyzer_2_array_crystal_array_5_priority;
MCNUM xwidth = mccchannel_9_analyzer_2_array_crystal_array_5_xwidth;
MCNUM yheight = mccchannel_9_analyzer_2_array_crystal_array_5_yheight;
MCNUM zdepth = mccchannel_9_analyzer_2_array_crystal_array_5_zdepth;
MCNUM xwidth2 = mccchannel_9_analyzer_2_array_crystal_array_5_xwidth2;
MCNUM yheight2 = mccchannel_9_analyzer_2_array_crystal_array_5_yheight2;
MCNUM visualize = mccchannel_9_analyzer_2_array_crystal_array_5_visualize;
int target_index = mccchannel_9_analyzer_2_array_crystal_array_5_target_index;
MCNUM target_x = mccchannel_9_analyzer_2_array_crystal_array_5_target_x;
MCNUM target_y = mccchannel_9_analyzer_2_array_crystal_array_5_target_y;
MCNUM target_z = mccchannel_9_analyzer_2_array_crystal_array_5_target_z;
MCNUM focus_aw = mccchannel_9_analyzer_2_array_crystal_array_5_focus_aw;
MCNUM focus_ah = mccchannel_9_analyzer_2_array_crystal_array_5_focus_ah;
MCNUM focus_xw = mccchannel_9_analyzer_2_array_crystal_array_5_focus_xw;
MCNUM focus_xh = mccchannel_9_analyzer_2_array_crystal_array_5_focus_xh;
MCNUM focus_r = mccchannel_9_analyzer_2_array_crystal_array_5_focus_r;
MCNUM p_interact = mccchannel_9_analyzer_2_array_crystal_array_5_p_interact;
char* mask_string = mccchannel_9_analyzer_2_array_crystal_array_5_mask_string;
char* mask_setting = mccchannel_9_analyzer_2_array_crystal_array_5_mask_setting;
MCNUM number_of_activations = mccchannel_9_analyzer_2_array_crystal_array_5_number_of_activations;
}   /* End of channel_9_analyzer_2_array_crystal_array_5=Union_box() SETTING parameter declarations. */
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex
  /* Label for restoring  neutron */
  mcabsorbCompchannel_9_analyzer_2_array_crystal_array_5:
  if (RESTORE) /* restore if needed */
  { RESTORE_NEUTRON(488,
      mcnlx,
      mcnly,
      mcnlz,
      mcnlvx,
      mcnlvy,
      mcnlvz,
      mcnlt,
      mcnlsx,
      mcnlsy,
      mcnlsz,
      mcnlp); }
#undef mcabsorbComp
#undef p
#undef sz
#undef sy
#undef sx
#undef t
#undef vz
#undef vy
#undef vx
#undef z
#undef y
#undef x
  mcDEBUG_STATE(
mcnlx,
mcnly,
mcnlz,
mcnlvx,
mcnlvy,
mcnlvz,
mcnlt,
mcnlsx,
mcnlsy,
mcnlsz,
mcnlp)

  /* TRACE Component channel_9_analyzer_2_array_crystal_array_6 [489] */
  mccoordschange(mcposrchannel_9_analyzer_2_array_crystal_array_6, mcrotrchannel_9_analyzer_2_array_crystal_array_6,
    &mcnlx,
    &mcnly,
    &mcnlz,
    &mcnlvx,
    &mcnlvy,
    &mcnlvz,
    &mcnlsx,
    &mcnlsy,
    &mcnlsz);
  /* define label inside component channel_9_analyzer_2_array_crystal_array_6 (without coords transformations) */
  mcJumpTrace_channel_9_analyzer_2_array_crystal_array_6:
  SIG_MESSAGE("channel_9_analyzer_2_array_crystal_array_6 (Trace)");
  mcDEBUG_COMP("channel_9_analyzer_2_array_crystal_array_6")
  mcDEBUG_STATE(
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp)
#define x mcnlx
#define y mcnly
#define z mcnlz
#define vx mcnlvx
#define vy mcnlvy
#define vz mcnlvz
#define t mcnlt
#define sx mcnlsx
#define sy mcnlsy
#define sz mcnlsz
#define p mcnlp

#define mcabsorbComp mcabsorbCompchannel_9_analyzer_2_array_crystal_array_6
  STORE_NEUTRON(489,
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp);
  mcScattered=0;
  mcRestore=0;
  mcNCounter[489]++;
  mcPCounter[489] += p;
  mcP2Counter[489] += p*p;
#define mccompcurname  channel_9_analyzer_2_array_crystal_array_6
#define mccompcurtype  Union_box
#define mccompcurindex 489
#define loop_index mccchannel_9_analyzer_2_array_crystal_array_6_loop_index
#define this_box_volume mccchannel_9_analyzer_2_array_crystal_array_6_this_box_volume
#define global_geometry_element mccchannel_9_analyzer_2_array_crystal_array_6_global_geometry_element
#define this_box_storage mccchannel_9_analyzer_2_array_crystal_array_6_this_box_storage
{   /* Declarations of channel_9_analyzer_2_array_crystal_array_6=Union_box() SETTING parameters. */
char* material_string = mccchannel_9_analyzer_2_array_crystal_array_6_material_string;
MCNUM priority = mccchannel_9_analyzer_2_array_crystal_array_6_priority;
MCNUM xwidth = mccchannel_9_analyzer_2_array_crystal_array_6_xwidth;
MCNUM yheight = mccchannel_9_analyzer_2_array_crystal_array_6_yheight;
MCNUM zdepth = mccchannel_9_analyzer_2_array_crystal_array_6_zdepth;
MCNUM xwidth2 = mccchannel_9_analyzer_2_array_crystal_array_6_xwidth2;
MCNUM yheight2 = mccchannel_9_analyzer_2_array_crystal_array_6_yheight2;
MCNUM visualize = mccchannel_9_analyzer_2_array_crystal_array_6_visualize;
int target_index = mccchannel_9_analyzer_2_array_crystal_array_6_target_index;
MCNUM target_x = mccchannel_9_analyzer_2_array_crystal_array_6_target_x;
MCNUM target_y = mccchannel_9_analyzer_2_array_crystal_array_6_target_y;
MCNUM target_z = mccchannel_9_analyzer_2_array_crystal_array_6_target_z;
MCNUM focus_aw = mccchannel_9_analyzer_2_array_crystal_array_6_focus_aw;
MCNUM focus_ah = mccchannel_9_analyzer_2_array_crystal_array_6_focus_ah;
MCNUM focus_xw = mccchannel_9_analyzer_2_array_crystal_array_6_focus_xw;
MCNUM focus_xh = mccchannel_9_analyzer_2_array_crystal_array_6_focus_xh;
MCNUM focus_r = mccchannel_9_analyzer_2_array_crystal_array_6_focus_r;
MCNUM p_interact = mccchannel_9_analyzer_2_array_crystal_array_6_p_interact;
char* mask_string = mccchannel_9_analyzer_2_array_crystal_array_6_mask_string;
char* mask_setting = mccchannel_9_analyzer_2_array_crystal_array_6_mask_setting;
MCNUM number_of_activations = mccchannel_9_analyzer_2_array_crystal_array_6_number_of_activations;
}   /* End of channel_9_analyzer_2_array_crystal_array_6=Union_box() SETTING parameter declarations. */
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex
  /* Label for restoring  neutron */
  mcabsorbCompchannel_9_analyzer_2_array_crystal_array_6:
  if (RESTORE) /* restore if needed */
  { RESTORE_NEUTRON(489,
      mcnlx,
      mcnly,
      mcnlz,
      mcnlvx,
      mcnlvy,
      mcnlvz,
      mcnlt,
      mcnlsx,
      mcnlsy,
      mcnlsz,
      mcnlp); }
#undef mcabsorbComp
#undef p
#undef sz
#undef sy
#undef sx
#undef t
#undef vz
#undef vy
#undef vx
#undef z
#undef y
#undef x
  mcDEBUG_STATE(
mcnlx,
mcnly,
mcnlz,
mcnlvx,
mcnlvy,
mcnlvz,
mcnlt,
mcnlsx,
mcnlsy,
mcnlsz,
mcnlp)

  /* TRACE Component channel_9_analyzer_2_array_crystal_array_7 [490] */
  mccoordschange(mcposrchannel_9_analyzer_2_array_crystal_array_7, mcrotrchannel_9_analyzer_2_array_crystal_array_7,
    &mcnlx,
    &mcnly,
    &mcnlz,
    &mcnlvx,
    &mcnlvy,
    &mcnlvz,
    &mcnlsx,
    &mcnlsy,
    &mcnlsz);
  /* define label inside component channel_9_analyzer_2_array_crystal_array_7 (without coords transformations) */
  mcJumpTrace_channel_9_analyzer_2_array_crystal_array_7:
  SIG_MESSAGE("channel_9_analyzer_2_array_crystal_array_7 (Trace)");
  mcDEBUG_COMP("channel_9_analyzer_2_array_crystal_array_7")
  mcDEBUG_STATE(
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp)
#define x mcnlx
#define y mcnly
#define z mcnlz
#define vx mcnlvx
#define vy mcnlvy
#define vz mcnlvz
#define t mcnlt
#define sx mcnlsx
#define sy mcnlsy
#define sz mcnlsz
#define p mcnlp

#define mcabsorbComp mcabsorbCompchannel_9_analyzer_2_array_crystal_array_7
  STORE_NEUTRON(490,
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp);
  mcScattered=0;
  mcRestore=0;
  mcNCounter[490]++;
  mcPCounter[490] += p;
  mcP2Counter[490] += p*p;
#define mccompcurname  channel_9_analyzer_2_array_crystal_array_7
#define mccompcurtype  Union_box
#define mccompcurindex 490
#define loop_index mccchannel_9_analyzer_2_array_crystal_array_7_loop_index
#define this_box_volume mccchannel_9_analyzer_2_array_crystal_array_7_this_box_volume
#define global_geometry_element mccchannel_9_analyzer_2_array_crystal_array_7_global_geometry_element
#define this_box_storage mccchannel_9_analyzer_2_array_crystal_array_7_this_box_storage
{   /* Declarations of channel_9_analyzer_2_array_crystal_array_7=Union_box() SETTING parameters. */
char* material_string = mccchannel_9_analyzer_2_array_crystal_array_7_material_string;
MCNUM priority = mccchannel_9_analyzer_2_array_crystal_array_7_priority;
MCNUM xwidth = mccchannel_9_analyzer_2_array_crystal_array_7_xwidth;
MCNUM yheight = mccchannel_9_analyzer_2_array_crystal_array_7_yheight;
MCNUM zdepth = mccchannel_9_analyzer_2_array_crystal_array_7_zdepth;
MCNUM xwidth2 = mccchannel_9_analyzer_2_array_crystal_array_7_xwidth2;
MCNUM yheight2 = mccchannel_9_analyzer_2_array_crystal_array_7_yheight2;
MCNUM visualize = mccchannel_9_analyzer_2_array_crystal_array_7_visualize;
int target_index = mccchannel_9_analyzer_2_array_crystal_array_7_target_index;
MCNUM target_x = mccchannel_9_analyzer_2_array_crystal_array_7_target_x;
MCNUM target_y = mccchannel_9_analyzer_2_array_crystal_array_7_target_y;
MCNUM target_z = mccchannel_9_analyzer_2_array_crystal_array_7_target_z;
MCNUM focus_aw = mccchannel_9_analyzer_2_array_crystal_array_7_focus_aw;
MCNUM focus_ah = mccchannel_9_analyzer_2_array_crystal_array_7_focus_ah;
MCNUM focus_xw = mccchannel_9_analyzer_2_array_crystal_array_7_focus_xw;
MCNUM focus_xh = mccchannel_9_analyzer_2_array_crystal_array_7_focus_xh;
MCNUM focus_r = mccchannel_9_analyzer_2_array_crystal_array_7_focus_r;
MCNUM p_interact = mccchannel_9_analyzer_2_array_crystal_array_7_p_interact;
char* mask_string = mccchannel_9_analyzer_2_array_crystal_array_7_mask_string;
char* mask_setting = mccchannel_9_analyzer_2_array_crystal_array_7_mask_setting;
MCNUM number_of_activations = mccchannel_9_analyzer_2_array_crystal_array_7_number_of_activations;
}   /* End of channel_9_analyzer_2_array_crystal_array_7=Union_box() SETTING parameter declarations. */
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex
  /* Label for restoring  neutron */
  mcabsorbCompchannel_9_analyzer_2_array_crystal_array_7:
  if (RESTORE) /* restore if needed */
  { RESTORE_NEUTRON(490,
      mcnlx,
      mcnly,
      mcnlz,
      mcnlvx,
      mcnlvy,
      mcnlvz,
      mcnlt,
      mcnlsx,
      mcnlsy,
      mcnlsz,
      mcnlp); }
#undef mcabsorbComp
#undef p
#undef sz
#undef sy
#undef sx
#undef t
#undef vz
#undef vy
#undef vx
#undef z
#undef y
#undef x
  mcDEBUG_STATE(
mcnlx,
mcnly,
mcnlz,
mcnlvx,
mcnlvy,
mcnlvz,
mcnlt,
mcnlsx,
mcnlsy,
mcnlsz,
mcnlp)

  /* TRACE Component channel_9_analyzer_2_array_crystal_array_8 [491] */
  mccoordschange(mcposrchannel_9_analyzer_2_array_crystal_array_8, mcrotrchannel_9_analyzer_2_array_crystal_array_8,
    &mcnlx,
    &mcnly,
    &mcnlz,
    &mcnlvx,
    &mcnlvy,
    &mcnlvz,
    &mcnlsx,
    &mcnlsy,
    &mcnlsz);
  /* define label inside component channel_9_analyzer_2_array_crystal_array_8 (without coords transformations) */
  mcJumpTrace_channel_9_analyzer_2_array_crystal_array_8:
  SIG_MESSAGE("channel_9_analyzer_2_array_crystal_array_8 (Trace)");
  mcDEBUG_COMP("channel_9_analyzer_2_array_crystal_array_8")
  mcDEBUG_STATE(
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp)
#define x mcnlx
#define y mcnly
#define z mcnlz
#define vx mcnlvx
#define vy mcnlvy
#define vz mcnlvz
#define t mcnlt
#define sx mcnlsx
#define sy mcnlsy
#define sz mcnlsz
#define p mcnlp

#define mcabsorbComp mcabsorbCompchannel_9_analyzer_2_array_crystal_array_8
  STORE_NEUTRON(491,
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp);
  mcScattered=0;
  mcRestore=0;
  mcNCounter[491]++;
  mcPCounter[491] += p;
  mcP2Counter[491] += p*p;
#define mccompcurname  channel_9_analyzer_2_array_crystal_array_8
#define mccompcurtype  Union_box
#define mccompcurindex 491
#define loop_index mccchannel_9_analyzer_2_array_crystal_array_8_loop_index
#define this_box_volume mccchannel_9_analyzer_2_array_crystal_array_8_this_box_volume
#define global_geometry_element mccchannel_9_analyzer_2_array_crystal_array_8_global_geometry_element
#define this_box_storage mccchannel_9_analyzer_2_array_crystal_array_8_this_box_storage
{   /* Declarations of channel_9_analyzer_2_array_crystal_array_8=Union_box() SETTING parameters. */
char* material_string = mccchannel_9_analyzer_2_array_crystal_array_8_material_string;
MCNUM priority = mccchannel_9_analyzer_2_array_crystal_array_8_priority;
MCNUM xwidth = mccchannel_9_analyzer_2_array_crystal_array_8_xwidth;
MCNUM yheight = mccchannel_9_analyzer_2_array_crystal_array_8_yheight;
MCNUM zdepth = mccchannel_9_analyzer_2_array_crystal_array_8_zdepth;
MCNUM xwidth2 = mccchannel_9_analyzer_2_array_crystal_array_8_xwidth2;
MCNUM yheight2 = mccchannel_9_analyzer_2_array_crystal_array_8_yheight2;
MCNUM visualize = mccchannel_9_analyzer_2_array_crystal_array_8_visualize;
int target_index = mccchannel_9_analyzer_2_array_crystal_array_8_target_index;
MCNUM target_x = mccchannel_9_analyzer_2_array_crystal_array_8_target_x;
MCNUM target_y = mccchannel_9_analyzer_2_array_crystal_array_8_target_y;
MCNUM target_z = mccchannel_9_analyzer_2_array_crystal_array_8_target_z;
MCNUM focus_aw = mccchannel_9_analyzer_2_array_crystal_array_8_focus_aw;
MCNUM focus_ah = mccchannel_9_analyzer_2_array_crystal_array_8_focus_ah;
MCNUM focus_xw = mccchannel_9_analyzer_2_array_crystal_array_8_focus_xw;
MCNUM focus_xh = mccchannel_9_analyzer_2_array_crystal_array_8_focus_xh;
MCNUM focus_r = mccchannel_9_analyzer_2_array_crystal_array_8_focus_r;
MCNUM p_interact = mccchannel_9_analyzer_2_array_crystal_array_8_p_interact;
char* mask_string = mccchannel_9_analyzer_2_array_crystal_array_8_mask_string;
char* mask_setting = mccchannel_9_analyzer_2_array_crystal_array_8_mask_setting;
MCNUM number_of_activations = mccchannel_9_analyzer_2_array_crystal_array_8_number_of_activations;
}   /* End of channel_9_analyzer_2_array_crystal_array_8=Union_box() SETTING parameter declarations. */
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex
  /* Label for restoring  neutron */
  mcabsorbCompchannel_9_analyzer_2_array_crystal_array_8:
  if (RESTORE) /* restore if needed */
  { RESTORE_NEUTRON(491,
      mcnlx,
      mcnly,
      mcnlz,
      mcnlvx,
      mcnlvy,
      mcnlvz,
      mcnlt,
      mcnlsx,
      mcnlsy,
      mcnlsz,
      mcnlp); }
#undef mcabsorbComp
#undef p
#undef sz
#undef sy
#undef sx
#undef t
#undef vz
#undef vy
#undef vx
#undef z
#undef y
#undef x
  mcDEBUG_STATE(
mcnlx,
mcnly,
mcnlz,
mcnlvx,
mcnlvy,
mcnlvz,
mcnlt,
mcnlsx,
mcnlsy,
mcnlsz,
mcnlp)

  /* TRACE Component channel_9_cave2_cyl1 [492] */
  mccoordschange(mcposrchannel_9_cave2_cyl1, mcrotrchannel_9_cave2_cyl1,
    &mcnlx,
    &mcnly,
    &mcnlz,
    &mcnlvx,
    &mcnlvy,
    &mcnlvz,
    &mcnlsx,
    &mcnlsy,
    &mcnlsz);
  /* define label inside component channel_9_cave2_cyl1 (without coords transformations) */
  mcJumpTrace_channel_9_cave2_cyl1:
  SIG_MESSAGE("channel_9_cave2_cyl1 (Trace)");
  mcDEBUG_COMP("channel_9_cave2_cyl1")
  mcDEBUG_STATE(
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp)
#define x mcnlx
#define y mcnly
#define z mcnlz
#define vx mcnlvx
#define vy mcnlvy
#define vz mcnlvz
#define t mcnlt
#define sx mcnlsx
#define sy mcnlsy
#define sz mcnlsz
#define p mcnlp

#define mcabsorbComp mcabsorbCompchannel_9_cave2_cyl1
  STORE_NEUTRON(492,
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp);
  mcScattered=0;
  mcRestore=0;
  mcNCounter[492]++;
  mcPCounter[492] += p;
  mcP2Counter[492] += p*p;
#define mccompcurname  channel_9_cave2_cyl1
#define mccompcurtype  Union_cylinder
#define mccompcurindex 492
#define loop_index mccchannel_9_cave2_cyl1_loop_index
#define this_cylinder_volume mccchannel_9_cave2_cyl1_this_cylinder_volume
#define global_geometry_element mccchannel_9_cave2_cyl1_global_geometry_element
#define this_cylinder_storage mccchannel_9_cave2_cyl1_this_cylinder_storage
{   /* Declarations of channel_9_cave2_cyl1=Union_cylinder() SETTING parameters. */
char* material_string = mccchannel_9_cave2_cyl1_material_string;
MCNUM priority = mccchannel_9_cave2_cyl1_priority;
MCNUM radius = mccchannel_9_cave2_cyl1_radius;
MCNUM yheight = mccchannel_9_cave2_cyl1_yheight;
MCNUM visualize = mccchannel_9_cave2_cyl1_visualize;
int target_index = mccchannel_9_cave2_cyl1_target_index;
MCNUM target_x = mccchannel_9_cave2_cyl1_target_x;
MCNUM target_y = mccchannel_9_cave2_cyl1_target_y;
MCNUM target_z = mccchannel_9_cave2_cyl1_target_z;
MCNUM focus_aw = mccchannel_9_cave2_cyl1_focus_aw;
MCNUM focus_ah = mccchannel_9_cave2_cyl1_focus_ah;
MCNUM focus_xw = mccchannel_9_cave2_cyl1_focus_xw;
MCNUM focus_xh = mccchannel_9_cave2_cyl1_focus_xh;
MCNUM focus_r = mccchannel_9_cave2_cyl1_focus_r;
MCNUM p_interact = mccchannel_9_cave2_cyl1_p_interact;
char* mask_string = mccchannel_9_cave2_cyl1_mask_string;
char* mask_setting = mccchannel_9_cave2_cyl1_mask_setting;
MCNUM number_of_activations = mccchannel_9_cave2_cyl1_number_of_activations;
#line 345 "Union_cylinder.comp"
{
dummy = 1;
}
#line 410487 "MACS_sample_kidney_box.c"
}   /* End of channel_9_cave2_cyl1=Union_cylinder() SETTING parameter declarations. */
#undef this_cylinder_storage
#undef global_geometry_element
#undef this_cylinder_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex
  /* Label for restoring  neutron */
  mcabsorbCompchannel_9_cave2_cyl1:
  if (RESTORE) /* restore if needed */
  { RESTORE_NEUTRON(492,
      mcnlx,
      mcnly,
      mcnlz,
      mcnlvx,
      mcnlvy,
      mcnlvz,
      mcnlt,
      mcnlsx,
      mcnlsy,
      mcnlsz,
      mcnlp); }
#undef mcabsorbComp
#undef p
#undef sz
#undef sy
#undef sx
#undef t
#undef vz
#undef vy
#undef vx
#undef z
#undef y
#undef x
  mcDEBUG_STATE(
mcnlx,
mcnly,
mcnlz,
mcnlvx,
mcnlvy,
mcnlvz,
mcnlt,
mcnlsx,
mcnlsy,
mcnlsz,
mcnlp)

  /* TRACE Component channel_9_cave2_box1 [493] */
  mccoordschange(mcposrchannel_9_cave2_box1, mcrotrchannel_9_cave2_box1,
    &mcnlx,
    &mcnly,
    &mcnlz,
    &mcnlvx,
    &mcnlvy,
    &mcnlvz,
    &mcnlsx,
    &mcnlsy,
    &mcnlsz);
  /* define label inside component channel_9_cave2_box1 (without coords transformations) */
  mcJumpTrace_channel_9_cave2_box1:
  SIG_MESSAGE("channel_9_cave2_box1 (Trace)");
  mcDEBUG_COMP("channel_9_cave2_box1")
  mcDEBUG_STATE(
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp)
#define x mcnlx
#define y mcnly
#define z mcnlz
#define vx mcnlvx
#define vy mcnlvy
#define vz mcnlvz
#define t mcnlt
#define sx mcnlsx
#define sy mcnlsy
#define sz mcnlsz
#define p mcnlp

#define mcabsorbComp mcabsorbCompchannel_9_cave2_box1
  STORE_NEUTRON(493,
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp);
  mcScattered=0;
  mcRestore=0;
  mcNCounter[493]++;
  mcPCounter[493] += p;
  mcP2Counter[493] += p*p;
#define mccompcurname  channel_9_cave2_box1
#define mccompcurtype  Union_box
#define mccompcurindex 493
#define loop_index mccchannel_9_cave2_box1_loop_index
#define this_box_volume mccchannel_9_cave2_box1_this_box_volume
#define global_geometry_element mccchannel_9_cave2_box1_global_geometry_element
#define this_box_storage mccchannel_9_cave2_box1_this_box_storage
{   /* Declarations of channel_9_cave2_box1=Union_box() SETTING parameters. */
char* material_string = mccchannel_9_cave2_box1_material_string;
MCNUM priority = mccchannel_9_cave2_box1_priority;
MCNUM xwidth = mccchannel_9_cave2_box1_xwidth;
MCNUM yheight = mccchannel_9_cave2_box1_yheight;
MCNUM zdepth = mccchannel_9_cave2_box1_zdepth;
MCNUM xwidth2 = mccchannel_9_cave2_box1_xwidth2;
MCNUM yheight2 = mccchannel_9_cave2_box1_yheight2;
MCNUM visualize = mccchannel_9_cave2_box1_visualize;
int target_index = mccchannel_9_cave2_box1_target_index;
MCNUM target_x = mccchannel_9_cave2_box1_target_x;
MCNUM target_y = mccchannel_9_cave2_box1_target_y;
MCNUM target_z = mccchannel_9_cave2_box1_target_z;
MCNUM focus_aw = mccchannel_9_cave2_box1_focus_aw;
MCNUM focus_ah = mccchannel_9_cave2_box1_focus_ah;
MCNUM focus_xw = mccchannel_9_cave2_box1_focus_xw;
MCNUM focus_xh = mccchannel_9_cave2_box1_focus_xh;
MCNUM focus_r = mccchannel_9_cave2_box1_focus_r;
MCNUM p_interact = mccchannel_9_cave2_box1_p_interact;
char* mask_string = mccchannel_9_cave2_box1_mask_string;
char* mask_setting = mccchannel_9_cave2_box1_mask_setting;
MCNUM number_of_activations = mccchannel_9_cave2_box1_number_of_activations;
}   /* End of channel_9_cave2_box1=Union_box() SETTING parameter declarations. */
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex
  /* Label for restoring  neutron */
  mcabsorbCompchannel_9_cave2_box1:
  if (RESTORE) /* restore if needed */
  { RESTORE_NEUTRON(493,
      mcnlx,
      mcnly,
      mcnlz,
      mcnlvx,
      mcnlvy,
      mcnlvz,
      mcnlt,
      mcnlsx,
      mcnlsy,
      mcnlsz,
      mcnlp); }
#undef mcabsorbComp
#undef p
#undef sz
#undef sy
#undef sx
#undef t
#undef vz
#undef vy
#undef vx
#undef z
#undef y
#undef x
  mcDEBUG_STATE(
mcnlx,
mcnly,
mcnlz,
mcnlvx,
mcnlvy,
mcnlvz,
mcnlt,
mcnlsx,
mcnlsy,
mcnlsz,
mcnlp)

  /* TRACE Component channel_9_cave2_box2 [494] */
  mccoordschange(mcposrchannel_9_cave2_box2, mcrotrchannel_9_cave2_box2,
    &mcnlx,
    &mcnly,
    &mcnlz,
    &mcnlvx,
    &mcnlvy,
    &mcnlvz,
    &mcnlsx,
    &mcnlsy,
    &mcnlsz);
  /* define label inside component channel_9_cave2_box2 (without coords transformations) */
  mcJumpTrace_channel_9_cave2_box2:
  SIG_MESSAGE("channel_9_cave2_box2 (Trace)");
  mcDEBUG_COMP("channel_9_cave2_box2")
  mcDEBUG_STATE(
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp)
#define x mcnlx
#define y mcnly
#define z mcnlz
#define vx mcnlvx
#define vy mcnlvy
#define vz mcnlvz
#define t mcnlt
#define sx mcnlsx
#define sy mcnlsy
#define sz mcnlsz
#define p mcnlp

#define mcabsorbComp mcabsorbCompchannel_9_cave2_box2
  STORE_NEUTRON(494,
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp);
  mcScattered=0;
  mcRestore=0;
  mcNCounter[494]++;
  mcPCounter[494] += p;
  mcP2Counter[494] += p*p;
#define mccompcurname  channel_9_cave2_box2
#define mccompcurtype  Union_box
#define mccompcurindex 494
#define loop_index mccchannel_9_cave2_box2_loop_index
#define this_box_volume mccchannel_9_cave2_box2_this_box_volume
#define global_geometry_element mccchannel_9_cave2_box2_global_geometry_element
#define this_box_storage mccchannel_9_cave2_box2_this_box_storage
{   /* Declarations of channel_9_cave2_box2=Union_box() SETTING parameters. */
char* material_string = mccchannel_9_cave2_box2_material_string;
MCNUM priority = mccchannel_9_cave2_box2_priority;
MCNUM xwidth = mccchannel_9_cave2_box2_xwidth;
MCNUM yheight = mccchannel_9_cave2_box2_yheight;
MCNUM zdepth = mccchannel_9_cave2_box2_zdepth;
MCNUM xwidth2 = mccchannel_9_cave2_box2_xwidth2;
MCNUM yheight2 = mccchannel_9_cave2_box2_yheight2;
MCNUM visualize = mccchannel_9_cave2_box2_visualize;
int target_index = mccchannel_9_cave2_box2_target_index;
MCNUM target_x = mccchannel_9_cave2_box2_target_x;
MCNUM target_y = mccchannel_9_cave2_box2_target_y;
MCNUM target_z = mccchannel_9_cave2_box2_target_z;
MCNUM focus_aw = mccchannel_9_cave2_box2_focus_aw;
MCNUM focus_ah = mccchannel_9_cave2_box2_focus_ah;
MCNUM focus_xw = mccchannel_9_cave2_box2_focus_xw;
MCNUM focus_xh = mccchannel_9_cave2_box2_focus_xh;
MCNUM focus_r = mccchannel_9_cave2_box2_focus_r;
MCNUM p_interact = mccchannel_9_cave2_box2_p_interact;
char* mask_string = mccchannel_9_cave2_box2_mask_string;
char* mask_setting = mccchannel_9_cave2_box2_mask_setting;
MCNUM number_of_activations = mccchannel_9_cave2_box2_number_of_activations;
}   /* End of channel_9_cave2_box2=Union_box() SETTING parameter declarations. */
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex
  /* Label for restoring  neutron */
  mcabsorbCompchannel_9_cave2_box2:
  if (RESTORE) /* restore if needed */
  { RESTORE_NEUTRON(494,
      mcnlx,
      mcnly,
      mcnlz,
      mcnlvx,
      mcnlvy,
      mcnlvz,
      mcnlt,
      mcnlsx,
      mcnlsy,
      mcnlsz,
      mcnlp); }
#undef mcabsorbComp
#undef p
#undef sz
#undef sy
#undef sx
#undef t
#undef vz
#undef vy
#undef vx
#undef z
#undef y
#undef x
  mcDEBUG_STATE(
mcnlx,
mcnly,
mcnlz,
mcnlvx,
mcnlvy,
mcnlvz,
mcnlt,
mcnlsx,
mcnlsy,
mcnlsz,
mcnlp)

  /* TRACE Component channel_9_cave2_box3 [495] */
  mccoordschange(mcposrchannel_9_cave2_box3, mcrotrchannel_9_cave2_box3,
    &mcnlx,
    &mcnly,
    &mcnlz,
    &mcnlvx,
    &mcnlvy,
    &mcnlvz,
    &mcnlsx,
    &mcnlsy,
    &mcnlsz);
  /* define label inside component channel_9_cave2_box3 (without coords transformations) */
  mcJumpTrace_channel_9_cave2_box3:
  SIG_MESSAGE("channel_9_cave2_box3 (Trace)");
  mcDEBUG_COMP("channel_9_cave2_box3")
  mcDEBUG_STATE(
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp)
#define x mcnlx
#define y mcnly
#define z mcnlz
#define vx mcnlvx
#define vy mcnlvy
#define vz mcnlvz
#define t mcnlt
#define sx mcnlsx
#define sy mcnlsy
#define sz mcnlsz
#define p mcnlp

#define mcabsorbComp mcabsorbCompchannel_9_cave2_box3
  STORE_NEUTRON(495,
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp);
  mcScattered=0;
  mcRestore=0;
  mcNCounter[495]++;
  mcPCounter[495] += p;
  mcP2Counter[495] += p*p;
#define mccompcurname  channel_9_cave2_box3
#define mccompcurtype  Union_box
#define mccompcurindex 495
#define loop_index mccchannel_9_cave2_box3_loop_index
#define this_box_volume mccchannel_9_cave2_box3_this_box_volume
#define global_geometry_element mccchannel_9_cave2_box3_global_geometry_element
#define this_box_storage mccchannel_9_cave2_box3_this_box_storage
{   /* Declarations of channel_9_cave2_box3=Union_box() SETTING parameters. */
char* material_string = mccchannel_9_cave2_box3_material_string;
MCNUM priority = mccchannel_9_cave2_box3_priority;
MCNUM xwidth = mccchannel_9_cave2_box3_xwidth;
MCNUM yheight = mccchannel_9_cave2_box3_yheight;
MCNUM zdepth = mccchannel_9_cave2_box3_zdepth;
MCNUM xwidth2 = mccchannel_9_cave2_box3_xwidth2;
MCNUM yheight2 = mccchannel_9_cave2_box3_yheight2;
MCNUM visualize = mccchannel_9_cave2_box3_visualize;
int target_index = mccchannel_9_cave2_box3_target_index;
MCNUM target_x = mccchannel_9_cave2_box3_target_x;
MCNUM target_y = mccchannel_9_cave2_box3_target_y;
MCNUM target_z = mccchannel_9_cave2_box3_target_z;
MCNUM focus_aw = mccchannel_9_cave2_box3_focus_aw;
MCNUM focus_ah = mccchannel_9_cave2_box3_focus_ah;
MCNUM focus_xw = mccchannel_9_cave2_box3_focus_xw;
MCNUM focus_xh = mccchannel_9_cave2_box3_focus_xh;
MCNUM focus_r = mccchannel_9_cave2_box3_focus_r;
MCNUM p_interact = mccchannel_9_cave2_box3_p_interact;
char* mask_string = mccchannel_9_cave2_box3_mask_string;
char* mask_setting = mccchannel_9_cave2_box3_mask_setting;
MCNUM number_of_activations = mccchannel_9_cave2_box3_number_of_activations;
}   /* End of channel_9_cave2_box3=Union_box() SETTING parameter declarations. */
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex
  /* Label for restoring  neutron */
  mcabsorbCompchannel_9_cave2_box3:
  if (RESTORE) /* restore if needed */
  { RESTORE_NEUTRON(495,
      mcnlx,
      mcnly,
      mcnlz,
      mcnlvx,
      mcnlvy,
      mcnlvz,
      mcnlt,
      mcnlsx,
      mcnlsy,
      mcnlsz,
      mcnlp); }
#undef mcabsorbComp
#undef p
#undef sz
#undef sy
#undef sx
#undef t
#undef vz
#undef vy
#undef vx
#undef z
#undef y
#undef x
  mcDEBUG_STATE(
mcnlx,
mcnly,
mcnlz,
mcnlvx,
mcnlvy,
mcnlvz,
mcnlt,
mcnlsx,
mcnlsy,
mcnlsz,
mcnlp)

  /* TRACE Component inter_analyzer_colimator_center_9 [496] */
  mccoordschange(mcposrinter_analyzer_colimator_center_9, mcrotrinter_analyzer_colimator_center_9,
    &mcnlx,
    &mcnly,
    &mcnlz,
    &mcnlvx,
    &mcnlvy,
    &mcnlvz,
    &mcnlsx,
    &mcnlsy,
    &mcnlsz);
  /* define label inside component inter_analyzer_colimator_center_9 (without coords transformations) */
  mcJumpTrace_inter_analyzer_colimator_center_9:
  SIG_MESSAGE("inter_analyzer_colimator_center_9 (Trace)");
  mcDEBUG_COMP("inter_analyzer_colimator_center_9")
  mcDEBUG_STATE(
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp)
#define x mcnlx
#define y mcnly
#define z mcnlz
#define vx mcnlvx
#define vy mcnlvy
#define vz mcnlvz
#define t mcnlt
#define sx mcnlsx
#define sy mcnlsy
#define sz mcnlsz
#define p mcnlp

#define mcabsorbComp mcabsorbCompinter_analyzer_colimator_center_9
  STORE_NEUTRON(496,
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp);
  mcScattered=0;
  mcRestore=0;
  mcNCounter[496]++;
  mcPCounter[496] += p;
  mcP2Counter[496] += p*p;
#define mccompcurname  inter_analyzer_colimator_center_9
#define mccompcurtype  Arm
#define mccompcurindex 496
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex
  /* Label for restoring  neutron */
  mcabsorbCompinter_analyzer_colimator_center_9:
  if (RESTORE) /* restore if needed */
  { RESTORE_NEUTRON(496,
      mcnlx,
      mcnly,
      mcnlz,
      mcnlvx,
      mcnlvy,
      mcnlvz,
      mcnlt,
      mcnlsx,
      mcnlsy,
      mcnlsz,
      mcnlp); }
#undef mcabsorbComp
#undef p
#undef sz
#undef sy
#undef sx
#undef t
#undef vz
#undef vy
#undef vx
#undef z
#undef y
#undef x
  mcDEBUG_STATE(
mcnlx,
mcnly,
mcnlz,
mcnlvx,
mcnlvy,
mcnlvz,
mcnlt,
mcnlsx,
mcnlsy,
mcnlsz,
mcnlp)

  /* TRACE Component inter_analyzer_colimator_9_blade_0 [497] */
  mccoordschange(mcposrinter_analyzer_colimator_9_blade_0, mcrotrinter_analyzer_colimator_9_blade_0,
    &mcnlx,
    &mcnly,
    &mcnlz,
    &mcnlvx,
    &mcnlvy,
    &mcnlvz,
    &mcnlsx,
    &mcnlsy,
    &mcnlsz);
  /* define label inside component inter_analyzer_colimator_9_blade_0 (without coords transformations) */
  mcJumpTrace_inter_analyzer_colimator_9_blade_0:
  SIG_MESSAGE("inter_analyzer_colimator_9_blade_0 (Trace)");
  mcDEBUG_COMP("inter_analyzer_colimator_9_blade_0")
  mcDEBUG_STATE(
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp)
#define x mcnlx
#define y mcnly
#define z mcnlz
#define vx mcnlvx
#define vy mcnlvy
#define vz mcnlvz
#define t mcnlt
#define sx mcnlsx
#define sy mcnlsy
#define sz mcnlsz
#define p mcnlp

#define mcabsorbComp mcabsorbCompinter_analyzer_colimator_9_blade_0
  STORE_NEUTRON(497,
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp);
  mcScattered=0;
  mcRestore=0;
  mcNCounter[497]++;
  mcPCounter[497] += p;
  mcP2Counter[497] += p*p;
#define mccompcurname  inter_analyzer_colimator_9_blade_0
#define mccompcurtype  Union_box
#define mccompcurindex 497
#define loop_index mccinter_analyzer_colimator_9_blade_0_loop_index
#define this_box_volume mccinter_analyzer_colimator_9_blade_0_this_box_volume
#define global_geometry_element mccinter_analyzer_colimator_9_blade_0_global_geometry_element
#define this_box_storage mccinter_analyzer_colimator_9_blade_0_this_box_storage
{   /* Declarations of inter_analyzer_colimator_9_blade_0=Union_box() SETTING parameters. */
char* material_string = mccinter_analyzer_colimator_9_blade_0_material_string;
MCNUM priority = mccinter_analyzer_colimator_9_blade_0_priority;
MCNUM xwidth = mccinter_analyzer_colimator_9_blade_0_xwidth;
MCNUM yheight = mccinter_analyzer_colimator_9_blade_0_yheight;
MCNUM zdepth = mccinter_analyzer_colimator_9_blade_0_zdepth;
MCNUM xwidth2 = mccinter_analyzer_colimator_9_blade_0_xwidth2;
MCNUM yheight2 = mccinter_analyzer_colimator_9_blade_0_yheight2;
MCNUM visualize = mccinter_analyzer_colimator_9_blade_0_visualize;
int target_index = mccinter_analyzer_colimator_9_blade_0_target_index;
MCNUM target_x = mccinter_analyzer_colimator_9_blade_0_target_x;
MCNUM target_y = mccinter_analyzer_colimator_9_blade_0_target_y;
MCNUM target_z = mccinter_analyzer_colimator_9_blade_0_target_z;
MCNUM focus_aw = mccinter_analyzer_colimator_9_blade_0_focus_aw;
MCNUM focus_ah = mccinter_analyzer_colimator_9_blade_0_focus_ah;
MCNUM focus_xw = mccinter_analyzer_colimator_9_blade_0_focus_xw;
MCNUM focus_xh = mccinter_analyzer_colimator_9_blade_0_focus_xh;
MCNUM focus_r = mccinter_analyzer_colimator_9_blade_0_focus_r;
MCNUM p_interact = mccinter_analyzer_colimator_9_blade_0_p_interact;
char* mask_string = mccinter_analyzer_colimator_9_blade_0_mask_string;
char* mask_setting = mccinter_analyzer_colimator_9_blade_0_mask_setting;
MCNUM number_of_activations = mccinter_analyzer_colimator_9_blade_0_number_of_activations;
}   /* End of inter_analyzer_colimator_9_blade_0=Union_box() SETTING parameter declarations. */
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex
  /* Label for restoring  neutron */
  mcabsorbCompinter_analyzer_colimator_9_blade_0:
  if (RESTORE) /* restore if needed */
  { RESTORE_NEUTRON(497,
      mcnlx,
      mcnly,
      mcnlz,
      mcnlvx,
      mcnlvy,
      mcnlvz,
      mcnlt,
      mcnlsx,
      mcnlsy,
      mcnlsz,
      mcnlp); }
#undef mcabsorbComp
#undef p
#undef sz
#undef sy
#undef sx
#undef t
#undef vz
#undef vy
#undef vx
#undef z
#undef y
#undef x
  mcDEBUG_STATE(
mcnlx,
mcnly,
mcnlz,
mcnlvx,
mcnlvy,
mcnlvz,
mcnlt,
mcnlsx,
mcnlsy,
mcnlsz,
mcnlp)

  /* TRACE Component inter_analyzer_colimator_9_blade_1 [498] */
  mccoordschange(mcposrinter_analyzer_colimator_9_blade_1, mcrotrinter_analyzer_colimator_9_blade_1,
    &mcnlx,
    &mcnly,
    &mcnlz,
    &mcnlvx,
    &mcnlvy,
    &mcnlvz,
    &mcnlsx,
    &mcnlsy,
    &mcnlsz);
  /* define label inside component inter_analyzer_colimator_9_blade_1 (without coords transformations) */
  mcJumpTrace_inter_analyzer_colimator_9_blade_1:
  SIG_MESSAGE("inter_analyzer_colimator_9_blade_1 (Trace)");
  mcDEBUG_COMP("inter_analyzer_colimator_9_blade_1")
  mcDEBUG_STATE(
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp)
#define x mcnlx
#define y mcnly
#define z mcnlz
#define vx mcnlvx
#define vy mcnlvy
#define vz mcnlvz
#define t mcnlt
#define sx mcnlsx
#define sy mcnlsy
#define sz mcnlsz
#define p mcnlp

#define mcabsorbComp mcabsorbCompinter_analyzer_colimator_9_blade_1
  STORE_NEUTRON(498,
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp);
  mcScattered=0;
  mcRestore=0;
  mcNCounter[498]++;
  mcPCounter[498] += p;
  mcP2Counter[498] += p*p;
#define mccompcurname  inter_analyzer_colimator_9_blade_1
#define mccompcurtype  Union_box
#define mccompcurindex 498
#define loop_index mccinter_analyzer_colimator_9_blade_1_loop_index
#define this_box_volume mccinter_analyzer_colimator_9_blade_1_this_box_volume
#define global_geometry_element mccinter_analyzer_colimator_9_blade_1_global_geometry_element
#define this_box_storage mccinter_analyzer_colimator_9_blade_1_this_box_storage
{   /* Declarations of inter_analyzer_colimator_9_blade_1=Union_box() SETTING parameters. */
char* material_string = mccinter_analyzer_colimator_9_blade_1_material_string;
MCNUM priority = mccinter_analyzer_colimator_9_blade_1_priority;
MCNUM xwidth = mccinter_analyzer_colimator_9_blade_1_xwidth;
MCNUM yheight = mccinter_analyzer_colimator_9_blade_1_yheight;
MCNUM zdepth = mccinter_analyzer_colimator_9_blade_1_zdepth;
MCNUM xwidth2 = mccinter_analyzer_colimator_9_blade_1_xwidth2;
MCNUM yheight2 = mccinter_analyzer_colimator_9_blade_1_yheight2;
MCNUM visualize = mccinter_analyzer_colimator_9_blade_1_visualize;
int target_index = mccinter_analyzer_colimator_9_blade_1_target_index;
MCNUM target_x = mccinter_analyzer_colimator_9_blade_1_target_x;
MCNUM target_y = mccinter_analyzer_colimator_9_blade_1_target_y;
MCNUM target_z = mccinter_analyzer_colimator_9_blade_1_target_z;
MCNUM focus_aw = mccinter_analyzer_colimator_9_blade_1_focus_aw;
MCNUM focus_ah = mccinter_analyzer_colimator_9_blade_1_focus_ah;
MCNUM focus_xw = mccinter_analyzer_colimator_9_blade_1_focus_xw;
MCNUM focus_xh = mccinter_analyzer_colimator_9_blade_1_focus_xh;
MCNUM focus_r = mccinter_analyzer_colimator_9_blade_1_focus_r;
MCNUM p_interact = mccinter_analyzer_colimator_9_blade_1_p_interact;
char* mask_string = mccinter_analyzer_colimator_9_blade_1_mask_string;
char* mask_setting = mccinter_analyzer_colimator_9_blade_1_mask_setting;
MCNUM number_of_activations = mccinter_analyzer_colimator_9_blade_1_number_of_activations;
}   /* End of inter_analyzer_colimator_9_blade_1=Union_box() SETTING parameter declarations. */
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex
  /* Label for restoring  neutron */
  mcabsorbCompinter_analyzer_colimator_9_blade_1:
  if (RESTORE) /* restore if needed */
  { RESTORE_NEUTRON(498,
      mcnlx,
      mcnly,
      mcnlz,
      mcnlvx,
      mcnlvy,
      mcnlvz,
      mcnlt,
      mcnlsx,
      mcnlsy,
      mcnlsz,
      mcnlp); }
#undef mcabsorbComp
#undef p
#undef sz
#undef sy
#undef sx
#undef t
#undef vz
#undef vy
#undef vx
#undef z
#undef y
#undef x
  mcDEBUG_STATE(
mcnlx,
mcnly,
mcnlz,
mcnlvx,
mcnlvy,
mcnlvz,
mcnlt,
mcnlsx,
mcnlsy,
mcnlsz,
mcnlp)

  /* TRACE Component inter_analyzer_colimator_9_blade_2 [499] */
  mccoordschange(mcposrinter_analyzer_colimator_9_blade_2, mcrotrinter_analyzer_colimator_9_blade_2,
    &mcnlx,
    &mcnly,
    &mcnlz,
    &mcnlvx,
    &mcnlvy,
    &mcnlvz,
    &mcnlsx,
    &mcnlsy,
    &mcnlsz);
  /* define label inside component inter_analyzer_colimator_9_blade_2 (without coords transformations) */
  mcJumpTrace_inter_analyzer_colimator_9_blade_2:
  SIG_MESSAGE("inter_analyzer_colimator_9_blade_2 (Trace)");
  mcDEBUG_COMP("inter_analyzer_colimator_9_blade_2")
  mcDEBUG_STATE(
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp)
#define x mcnlx
#define y mcnly
#define z mcnlz
#define vx mcnlvx
#define vy mcnlvy
#define vz mcnlvz
#define t mcnlt
#define sx mcnlsx
#define sy mcnlsy
#define sz mcnlsz
#define p mcnlp

#define mcabsorbComp mcabsorbCompinter_analyzer_colimator_9_blade_2
  STORE_NEUTRON(499,
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp);
  mcScattered=0;
  mcRestore=0;
  mcNCounter[499]++;
  mcPCounter[499] += p;
  mcP2Counter[499] += p*p;
#define mccompcurname  inter_analyzer_colimator_9_blade_2
#define mccompcurtype  Union_box
#define mccompcurindex 499
#define loop_index mccinter_analyzer_colimator_9_blade_2_loop_index
#define this_box_volume mccinter_analyzer_colimator_9_blade_2_this_box_volume
#define global_geometry_element mccinter_analyzer_colimator_9_blade_2_global_geometry_element
#define this_box_storage mccinter_analyzer_colimator_9_blade_2_this_box_storage
{   /* Declarations of inter_analyzer_colimator_9_blade_2=Union_box() SETTING parameters. */
char* material_string = mccinter_analyzer_colimator_9_blade_2_material_string;
MCNUM priority = mccinter_analyzer_colimator_9_blade_2_priority;
MCNUM xwidth = mccinter_analyzer_colimator_9_blade_2_xwidth;
MCNUM yheight = mccinter_analyzer_colimator_9_blade_2_yheight;
MCNUM zdepth = mccinter_analyzer_colimator_9_blade_2_zdepth;
MCNUM xwidth2 = mccinter_analyzer_colimator_9_blade_2_xwidth2;
MCNUM yheight2 = mccinter_analyzer_colimator_9_blade_2_yheight2;
MCNUM visualize = mccinter_analyzer_colimator_9_blade_2_visualize;
int target_index = mccinter_analyzer_colimator_9_blade_2_target_index;
MCNUM target_x = mccinter_analyzer_colimator_9_blade_2_target_x;
MCNUM target_y = mccinter_analyzer_colimator_9_blade_2_target_y;
MCNUM target_z = mccinter_analyzer_colimator_9_blade_2_target_z;
MCNUM focus_aw = mccinter_analyzer_colimator_9_blade_2_focus_aw;
MCNUM focus_ah = mccinter_analyzer_colimator_9_blade_2_focus_ah;
MCNUM focus_xw = mccinter_analyzer_colimator_9_blade_2_focus_xw;
MCNUM focus_xh = mccinter_analyzer_colimator_9_blade_2_focus_xh;
MCNUM focus_r = mccinter_analyzer_colimator_9_blade_2_focus_r;
MCNUM p_interact = mccinter_analyzer_colimator_9_blade_2_p_interact;
char* mask_string = mccinter_analyzer_colimator_9_blade_2_mask_string;
char* mask_setting = mccinter_analyzer_colimator_9_blade_2_mask_setting;
MCNUM number_of_activations = mccinter_analyzer_colimator_9_blade_2_number_of_activations;
}   /* End of inter_analyzer_colimator_9_blade_2=Union_box() SETTING parameter declarations. */
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex
  /* Label for restoring  neutron */
  mcabsorbCompinter_analyzer_colimator_9_blade_2:
  if (RESTORE) /* restore if needed */
  { RESTORE_NEUTRON(499,
      mcnlx,
      mcnly,
      mcnlz,
      mcnlvx,
      mcnlvy,
      mcnlvz,
      mcnlt,
      mcnlsx,
      mcnlsy,
      mcnlsz,
      mcnlp); }
#undef mcabsorbComp
#undef p
#undef sz
#undef sy
#undef sx
#undef t
#undef vz
#undef vy
#undef vx
#undef z
#undef y
#undef x
  mcDEBUG_STATE(
mcnlx,
mcnly,
mcnlz,
mcnlvx,
mcnlvy,
mcnlvz,
mcnlt,
mcnlsx,
mcnlsy,
mcnlsz,
mcnlp)

  /* TRACE Component inter_analyzer_colimator_9_blade_3 [500] */
  mccoordschange(mcposrinter_analyzer_colimator_9_blade_3, mcrotrinter_analyzer_colimator_9_blade_3,
    &mcnlx,
    &mcnly,
    &mcnlz,
    &mcnlvx,
    &mcnlvy,
    &mcnlvz,
    &mcnlsx,
    &mcnlsy,
    &mcnlsz);
  /* define label inside component inter_analyzer_colimator_9_blade_3 (without coords transformations) */
  mcJumpTrace_inter_analyzer_colimator_9_blade_3:
  SIG_MESSAGE("inter_analyzer_colimator_9_blade_3 (Trace)");
  mcDEBUG_COMP("inter_analyzer_colimator_9_blade_3")
  mcDEBUG_STATE(
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp)
#define x mcnlx
#define y mcnly
#define z mcnlz
#define vx mcnlvx
#define vy mcnlvy
#define vz mcnlvz
#define t mcnlt
#define sx mcnlsx
#define sy mcnlsy
#define sz mcnlsz
#define p mcnlp

#define mcabsorbComp mcabsorbCompinter_analyzer_colimator_9_blade_3
  STORE_NEUTRON(500,
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp);
  mcScattered=0;
  mcRestore=0;
  mcNCounter[500]++;
  mcPCounter[500] += p;
  mcP2Counter[500] += p*p;
#define mccompcurname  inter_analyzer_colimator_9_blade_3
#define mccompcurtype  Union_box
#define mccompcurindex 500
#define loop_index mccinter_analyzer_colimator_9_blade_3_loop_index
#define this_box_volume mccinter_analyzer_colimator_9_blade_3_this_box_volume
#define global_geometry_element mccinter_analyzer_colimator_9_blade_3_global_geometry_element
#define this_box_storage mccinter_analyzer_colimator_9_blade_3_this_box_storage
{   /* Declarations of inter_analyzer_colimator_9_blade_3=Union_box() SETTING parameters. */
char* material_string = mccinter_analyzer_colimator_9_blade_3_material_string;
MCNUM priority = mccinter_analyzer_colimator_9_blade_3_priority;
MCNUM xwidth = mccinter_analyzer_colimator_9_blade_3_xwidth;
MCNUM yheight = mccinter_analyzer_colimator_9_blade_3_yheight;
MCNUM zdepth = mccinter_analyzer_colimator_9_blade_3_zdepth;
MCNUM xwidth2 = mccinter_analyzer_colimator_9_blade_3_xwidth2;
MCNUM yheight2 = mccinter_analyzer_colimator_9_blade_3_yheight2;
MCNUM visualize = mccinter_analyzer_colimator_9_blade_3_visualize;
int target_index = mccinter_analyzer_colimator_9_blade_3_target_index;
MCNUM target_x = mccinter_analyzer_colimator_9_blade_3_target_x;
MCNUM target_y = mccinter_analyzer_colimator_9_blade_3_target_y;
MCNUM target_z = mccinter_analyzer_colimator_9_blade_3_target_z;
MCNUM focus_aw = mccinter_analyzer_colimator_9_blade_3_focus_aw;
MCNUM focus_ah = mccinter_analyzer_colimator_9_blade_3_focus_ah;
MCNUM focus_xw = mccinter_analyzer_colimator_9_blade_3_focus_xw;
MCNUM focus_xh = mccinter_analyzer_colimator_9_blade_3_focus_xh;
MCNUM focus_r = mccinter_analyzer_colimator_9_blade_3_focus_r;
MCNUM p_interact = mccinter_analyzer_colimator_9_blade_3_p_interact;
char* mask_string = mccinter_analyzer_colimator_9_blade_3_mask_string;
char* mask_setting = mccinter_analyzer_colimator_9_blade_3_mask_setting;
MCNUM number_of_activations = mccinter_analyzer_colimator_9_blade_3_number_of_activations;
}   /* End of inter_analyzer_colimator_9_blade_3=Union_box() SETTING parameter declarations. */
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex
  /* Label for restoring  neutron */
  mcabsorbCompinter_analyzer_colimator_9_blade_3:
  if (RESTORE) /* restore if needed */
  { RESTORE_NEUTRON(500,
      mcnlx,
      mcnly,
      mcnlz,
      mcnlvx,
      mcnlvy,
      mcnlvz,
      mcnlt,
      mcnlsx,
      mcnlsy,
      mcnlsz,
      mcnlp); }
#undef mcabsorbComp
#undef p
#undef sz
#undef sy
#undef sx
#undef t
#undef vz
#undef vy
#undef vx
#undef z
#undef y
#undef x
  mcDEBUG_STATE(
mcnlx,
mcnly,
mcnlz,
mcnlvx,
mcnlvy,
mcnlvz,
mcnlt,
mcnlsx,
mcnlsy,
mcnlsz,
mcnlp)

  /* TRACE Component inter_analyzer_colimator_9_blade_4 [501] */
  mccoordschange(mcposrinter_analyzer_colimator_9_blade_4, mcrotrinter_analyzer_colimator_9_blade_4,
    &mcnlx,
    &mcnly,
    &mcnlz,
    &mcnlvx,
    &mcnlvy,
    &mcnlvz,
    &mcnlsx,
    &mcnlsy,
    &mcnlsz);
  /* define label inside component inter_analyzer_colimator_9_blade_4 (without coords transformations) */
  mcJumpTrace_inter_analyzer_colimator_9_blade_4:
  SIG_MESSAGE("inter_analyzer_colimator_9_blade_4 (Trace)");
  mcDEBUG_COMP("inter_analyzer_colimator_9_blade_4")
  mcDEBUG_STATE(
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp)
#define x mcnlx
#define y mcnly
#define z mcnlz
#define vx mcnlvx
#define vy mcnlvy
#define vz mcnlvz
#define t mcnlt
#define sx mcnlsx
#define sy mcnlsy
#define sz mcnlsz
#define p mcnlp

#define mcabsorbComp mcabsorbCompinter_analyzer_colimator_9_blade_4
  STORE_NEUTRON(501,
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp);
  mcScattered=0;
  mcRestore=0;
  mcNCounter[501]++;
  mcPCounter[501] += p;
  mcP2Counter[501] += p*p;
#define mccompcurname  inter_analyzer_colimator_9_blade_4
#define mccompcurtype  Union_box
#define mccompcurindex 501
#define loop_index mccinter_analyzer_colimator_9_blade_4_loop_index
#define this_box_volume mccinter_analyzer_colimator_9_blade_4_this_box_volume
#define global_geometry_element mccinter_analyzer_colimator_9_blade_4_global_geometry_element
#define this_box_storage mccinter_analyzer_colimator_9_blade_4_this_box_storage
{   /* Declarations of inter_analyzer_colimator_9_blade_4=Union_box() SETTING parameters. */
char* material_string = mccinter_analyzer_colimator_9_blade_4_material_string;
MCNUM priority = mccinter_analyzer_colimator_9_blade_4_priority;
MCNUM xwidth = mccinter_analyzer_colimator_9_blade_4_xwidth;
MCNUM yheight = mccinter_analyzer_colimator_9_blade_4_yheight;
MCNUM zdepth = mccinter_analyzer_colimator_9_blade_4_zdepth;
MCNUM xwidth2 = mccinter_analyzer_colimator_9_blade_4_xwidth2;
MCNUM yheight2 = mccinter_analyzer_colimator_9_blade_4_yheight2;
MCNUM visualize = mccinter_analyzer_colimator_9_blade_4_visualize;
int target_index = mccinter_analyzer_colimator_9_blade_4_target_index;
MCNUM target_x = mccinter_analyzer_colimator_9_blade_4_target_x;
MCNUM target_y = mccinter_analyzer_colimator_9_blade_4_target_y;
MCNUM target_z = mccinter_analyzer_colimator_9_blade_4_target_z;
MCNUM focus_aw = mccinter_analyzer_colimator_9_blade_4_focus_aw;
MCNUM focus_ah = mccinter_analyzer_colimator_9_blade_4_focus_ah;
MCNUM focus_xw = mccinter_analyzer_colimator_9_blade_4_focus_xw;
MCNUM focus_xh = mccinter_analyzer_colimator_9_blade_4_focus_xh;
MCNUM focus_r = mccinter_analyzer_colimator_9_blade_4_focus_r;
MCNUM p_interact = mccinter_analyzer_colimator_9_blade_4_p_interact;
char* mask_string = mccinter_analyzer_colimator_9_blade_4_mask_string;
char* mask_setting = mccinter_analyzer_colimator_9_blade_4_mask_setting;
MCNUM number_of_activations = mccinter_analyzer_colimator_9_blade_4_number_of_activations;
}   /* End of inter_analyzer_colimator_9_blade_4=Union_box() SETTING parameter declarations. */
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex
  /* Label for restoring  neutron */
  mcabsorbCompinter_analyzer_colimator_9_blade_4:
  if (RESTORE) /* restore if needed */
  { RESTORE_NEUTRON(501,
      mcnlx,
      mcnly,
      mcnlz,
      mcnlvx,
      mcnlvy,
      mcnlvz,
      mcnlt,
      mcnlsx,
      mcnlsy,
      mcnlsz,
      mcnlp); }
#undef mcabsorbComp
#undef p
#undef sz
#undef sy
#undef sx
#undef t
#undef vz
#undef vy
#undef vx
#undef z
#undef y
#undef x
  mcDEBUG_STATE(
mcnlx,
mcnly,
mcnlz,
mcnlvx,
mcnlvy,
mcnlvz,
mcnlt,
mcnlsx,
mcnlsy,
mcnlsz,
mcnlp)

  /* TRACE Component diffraction_detector_9_exit_volume [502] */
  mccoordschange(mcposrdiffraction_detector_9_exit_volume, mcrotrdiffraction_detector_9_exit_volume,
    &mcnlx,
    &mcnly,
    &mcnlz,
    &mcnlvx,
    &mcnlvy,
    &mcnlvz,
    &mcnlsx,
    &mcnlsy,
    &mcnlsz);
  /* define label inside component diffraction_detector_9_exit_volume (without coords transformations) */
  mcJumpTrace_diffraction_detector_9_exit_volume:
  SIG_MESSAGE("diffraction_detector_9_exit_volume (Trace)");
  mcDEBUG_COMP("diffraction_detector_9_exit_volume")
  mcDEBUG_STATE(
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp)
#define x mcnlx
#define y mcnly
#define z mcnlz
#define vx mcnlvx
#define vy mcnlvy
#define vz mcnlvz
#define t mcnlt
#define sx mcnlsx
#define sy mcnlsy
#define sz mcnlsz
#define p mcnlp

#define mcabsorbComp mcabsorbCompdiffraction_detector_9_exit_volume
  STORE_NEUTRON(502,
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp);
  mcScattered=0;
  mcRestore=0;
  mcNCounter[502]++;
  mcPCounter[502] += p;
  mcP2Counter[502] += p*p;
#define mccompcurname  diffraction_detector_9_exit_volume
#define mccompcurtype  Union_box
#define mccompcurindex 502
#define loop_index mccdiffraction_detector_9_exit_volume_loop_index
#define this_box_volume mccdiffraction_detector_9_exit_volume_this_box_volume
#define global_geometry_element mccdiffraction_detector_9_exit_volume_global_geometry_element
#define this_box_storage mccdiffraction_detector_9_exit_volume_this_box_storage
{   /* Declarations of diffraction_detector_9_exit_volume=Union_box() SETTING parameters. */
char* material_string = mccdiffraction_detector_9_exit_volume_material_string;
MCNUM priority = mccdiffraction_detector_9_exit_volume_priority;
MCNUM xwidth = mccdiffraction_detector_9_exit_volume_xwidth;
MCNUM yheight = mccdiffraction_detector_9_exit_volume_yheight;
MCNUM zdepth = mccdiffraction_detector_9_exit_volume_zdepth;
MCNUM xwidth2 = mccdiffraction_detector_9_exit_volume_xwidth2;
MCNUM yheight2 = mccdiffraction_detector_9_exit_volume_yheight2;
MCNUM visualize = mccdiffraction_detector_9_exit_volume_visualize;
int target_index = mccdiffraction_detector_9_exit_volume_target_index;
MCNUM target_x = mccdiffraction_detector_9_exit_volume_target_x;
MCNUM target_y = mccdiffraction_detector_9_exit_volume_target_y;
MCNUM target_z = mccdiffraction_detector_9_exit_volume_target_z;
MCNUM focus_aw = mccdiffraction_detector_9_exit_volume_focus_aw;
MCNUM focus_ah = mccdiffraction_detector_9_exit_volume_focus_ah;
MCNUM focus_xw = mccdiffraction_detector_9_exit_volume_focus_xw;
MCNUM focus_xh = mccdiffraction_detector_9_exit_volume_focus_xh;
MCNUM focus_r = mccdiffraction_detector_9_exit_volume_focus_r;
MCNUM p_interact = mccdiffraction_detector_9_exit_volume_p_interact;
char* mask_string = mccdiffraction_detector_9_exit_volume_mask_string;
char* mask_setting = mccdiffraction_detector_9_exit_volume_mask_setting;
MCNUM number_of_activations = mccdiffraction_detector_9_exit_volume_number_of_activations;
}   /* End of diffraction_detector_9_exit_volume=Union_box() SETTING parameter declarations. */
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex
  /* Label for restoring  neutron */
  mcabsorbCompdiffraction_detector_9_exit_volume:
  if (RESTORE) /* restore if needed */
  { RESTORE_NEUTRON(502,
      mcnlx,
      mcnly,
      mcnlz,
      mcnlvx,
      mcnlvy,
      mcnlvz,
      mcnlt,
      mcnlsx,
      mcnlsy,
      mcnlsz,
      mcnlp); }
#undef mcabsorbComp
#undef p
#undef sz
#undef sy
#undef sx
#undef t
#undef vz
#undef vy
#undef vx
#undef z
#undef y
#undef x
  mcDEBUG_STATE(
mcnlx,
mcnly,
mcnlz,
mcnlvx,
mcnlvy,
mcnlvz,
mcnlt,
mcnlsx,
mcnlsy,
mcnlsz,
mcnlp)

  /* TRACE Component spec_detector_9_exit_volume [503] */
  mccoordschange(mcposrspec_detector_9_exit_volume, mcrotrspec_detector_9_exit_volume,
    &mcnlx,
    &mcnly,
    &mcnlz,
    &mcnlvx,
    &mcnlvy,
    &mcnlvz,
    &mcnlsx,
    &mcnlsy,
    &mcnlsz);
  /* define label inside component spec_detector_9_exit_volume (without coords transformations) */
  mcJumpTrace_spec_detector_9_exit_volume:
  SIG_MESSAGE("spec_detector_9_exit_volume (Trace)");
  mcDEBUG_COMP("spec_detector_9_exit_volume")
  mcDEBUG_STATE(
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp)
#define x mcnlx
#define y mcnly
#define z mcnlz
#define vx mcnlvx
#define vy mcnlvy
#define vz mcnlvz
#define t mcnlt
#define sx mcnlsx
#define sy mcnlsy
#define sz mcnlsz
#define p mcnlp

#define mcabsorbComp mcabsorbCompspec_detector_9_exit_volume
  STORE_NEUTRON(503,
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp);
  mcScattered=0;
  mcRestore=0;
  mcNCounter[503]++;
  mcPCounter[503] += p;
  mcP2Counter[503] += p*p;
#define mccompcurname  spec_detector_9_exit_volume
#define mccompcurtype  Union_box
#define mccompcurindex 503
#define loop_index mccspec_detector_9_exit_volume_loop_index
#define this_box_volume mccspec_detector_9_exit_volume_this_box_volume
#define global_geometry_element mccspec_detector_9_exit_volume_global_geometry_element
#define this_box_storage mccspec_detector_9_exit_volume_this_box_storage
{   /* Declarations of spec_detector_9_exit_volume=Union_box() SETTING parameters. */
char* material_string = mccspec_detector_9_exit_volume_material_string;
MCNUM priority = mccspec_detector_9_exit_volume_priority;
MCNUM xwidth = mccspec_detector_9_exit_volume_xwidth;
MCNUM yheight = mccspec_detector_9_exit_volume_yheight;
MCNUM zdepth = mccspec_detector_9_exit_volume_zdepth;
MCNUM xwidth2 = mccspec_detector_9_exit_volume_xwidth2;
MCNUM yheight2 = mccspec_detector_9_exit_volume_yheight2;
MCNUM visualize = mccspec_detector_9_exit_volume_visualize;
int target_index = mccspec_detector_9_exit_volume_target_index;
MCNUM target_x = mccspec_detector_9_exit_volume_target_x;
MCNUM target_y = mccspec_detector_9_exit_volume_target_y;
MCNUM target_z = mccspec_detector_9_exit_volume_target_z;
MCNUM focus_aw = mccspec_detector_9_exit_volume_focus_aw;
MCNUM focus_ah = mccspec_detector_9_exit_volume_focus_ah;
MCNUM focus_xw = mccspec_detector_9_exit_volume_focus_xw;
MCNUM focus_xh = mccspec_detector_9_exit_volume_focus_xh;
MCNUM focus_r = mccspec_detector_9_exit_volume_focus_r;
MCNUM p_interact = mccspec_detector_9_exit_volume_p_interact;
char* mask_string = mccspec_detector_9_exit_volume_mask_string;
char* mask_setting = mccspec_detector_9_exit_volume_mask_setting;
MCNUM number_of_activations = mccspec_detector_9_exit_volume_number_of_activations;
}   /* End of spec_detector_9_exit_volume=Union_box() SETTING parameter declarations. */
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex
  /* Label for restoring  neutron */
  mcabsorbCompspec_detector_9_exit_volume:
  if (RESTORE) /* restore if needed */
  { RESTORE_NEUTRON(503,
      mcnlx,
      mcnly,
      mcnlz,
      mcnlvx,
      mcnlvy,
      mcnlvz,
      mcnlt,
      mcnlsx,
      mcnlsy,
      mcnlsz,
      mcnlp); }
#undef mcabsorbComp
#undef p
#undef sz
#undef sy
#undef sx
#undef t
#undef vz
#undef vy
#undef vx
#undef z
#undef y
#undef x
  mcDEBUG_STATE(
mcnlx,
mcnly,
mcnlz,
mcnlvx,
mcnlvy,
mcnlvz,
mcnlt,
mcnlsx,
mcnlsy,
mcnlsz,
mcnlp)

  /* TRACE Component channel_10_cave1_box1 [504] */
  mccoordschange(mcposrchannel_10_cave1_box1, mcrotrchannel_10_cave1_box1,
    &mcnlx,
    &mcnly,
    &mcnlz,
    &mcnlvx,
    &mcnlvy,
    &mcnlvz,
    &mcnlsx,
    &mcnlsy,
    &mcnlsz);
  /* define label inside component channel_10_cave1_box1 (without coords transformations) */
  mcJumpTrace_channel_10_cave1_box1:
  SIG_MESSAGE("channel_10_cave1_box1 (Trace)");
  mcDEBUG_COMP("channel_10_cave1_box1")
  mcDEBUG_STATE(
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp)
#define x mcnlx
#define y mcnly
#define z mcnlz
#define vx mcnlvx
#define vy mcnlvy
#define vz mcnlvz
#define t mcnlt
#define sx mcnlsx
#define sy mcnlsy
#define sz mcnlsz
#define p mcnlp

#define mcabsorbComp mcabsorbCompchannel_10_cave1_box1
  STORE_NEUTRON(504,
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp);
  mcScattered=0;
  mcRestore=0;
  mcNCounter[504]++;
  mcPCounter[504] += p;
  mcP2Counter[504] += p*p;
#define mccompcurname  channel_10_cave1_box1
#define mccompcurtype  Union_box
#define mccompcurindex 504
#define loop_index mccchannel_10_cave1_box1_loop_index
#define this_box_volume mccchannel_10_cave1_box1_this_box_volume
#define global_geometry_element mccchannel_10_cave1_box1_global_geometry_element
#define this_box_storage mccchannel_10_cave1_box1_this_box_storage
{   /* Declarations of channel_10_cave1_box1=Union_box() SETTING parameters. */
char* material_string = mccchannel_10_cave1_box1_material_string;
MCNUM priority = mccchannel_10_cave1_box1_priority;
MCNUM xwidth = mccchannel_10_cave1_box1_xwidth;
MCNUM yheight = mccchannel_10_cave1_box1_yheight;
MCNUM zdepth = mccchannel_10_cave1_box1_zdepth;
MCNUM xwidth2 = mccchannel_10_cave1_box1_xwidth2;
MCNUM yheight2 = mccchannel_10_cave1_box1_yheight2;
MCNUM visualize = mccchannel_10_cave1_box1_visualize;
int target_index = mccchannel_10_cave1_box1_target_index;
MCNUM target_x = mccchannel_10_cave1_box1_target_x;
MCNUM target_y = mccchannel_10_cave1_box1_target_y;
MCNUM target_z = mccchannel_10_cave1_box1_target_z;
MCNUM focus_aw = mccchannel_10_cave1_box1_focus_aw;
MCNUM focus_ah = mccchannel_10_cave1_box1_focus_ah;
MCNUM focus_xw = mccchannel_10_cave1_box1_focus_xw;
MCNUM focus_xh = mccchannel_10_cave1_box1_focus_xh;
MCNUM focus_r = mccchannel_10_cave1_box1_focus_r;
MCNUM p_interact = mccchannel_10_cave1_box1_p_interact;
char* mask_string = mccchannel_10_cave1_box1_mask_string;
char* mask_setting = mccchannel_10_cave1_box1_mask_setting;
MCNUM number_of_activations = mccchannel_10_cave1_box1_number_of_activations;
}   /* End of channel_10_cave1_box1=Union_box() SETTING parameter declarations. */
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex
  /* Label for restoring  neutron */
  mcabsorbCompchannel_10_cave1_box1:
  if (RESTORE) /* restore if needed */
  { RESTORE_NEUTRON(504,
      mcnlx,
      mcnly,
      mcnlz,
      mcnlvx,
      mcnlvy,
      mcnlvz,
      mcnlt,
      mcnlsx,
      mcnlsy,
      mcnlsz,
      mcnlp); }
#undef mcabsorbComp
#undef p
#undef sz
#undef sy
#undef sx
#undef t
#undef vz
#undef vy
#undef vx
#undef z
#undef y
#undef x
  mcDEBUG_STATE(
mcnlx,
mcnly,
mcnlz,
mcnlvx,
mcnlvy,
mcnlvz,
mcnlt,
mcnlsx,
mcnlsy,
mcnlsz,
mcnlp)

  /* TRACE Component channel_10_cave1_box2 [505] */
  mccoordschange(mcposrchannel_10_cave1_box2, mcrotrchannel_10_cave1_box2,
    &mcnlx,
    &mcnly,
    &mcnlz,
    &mcnlvx,
    &mcnlvy,
    &mcnlvz,
    &mcnlsx,
    &mcnlsy,
    &mcnlsz);
  /* define label inside component channel_10_cave1_box2 (without coords transformations) */
  mcJumpTrace_channel_10_cave1_box2:
  SIG_MESSAGE("channel_10_cave1_box2 (Trace)");
  mcDEBUG_COMP("channel_10_cave1_box2")
  mcDEBUG_STATE(
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp)
#define x mcnlx
#define y mcnly
#define z mcnlz
#define vx mcnlvx
#define vy mcnlvy
#define vz mcnlvz
#define t mcnlt
#define sx mcnlsx
#define sy mcnlsy
#define sz mcnlsz
#define p mcnlp

#define mcabsorbComp mcabsorbCompchannel_10_cave1_box2
  STORE_NEUTRON(505,
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp);
  mcScattered=0;
  mcRestore=0;
  mcNCounter[505]++;
  mcPCounter[505] += p;
  mcP2Counter[505] += p*p;
#define mccompcurname  channel_10_cave1_box2
#define mccompcurtype  Union_box
#define mccompcurindex 505
#define loop_index mccchannel_10_cave1_box2_loop_index
#define this_box_volume mccchannel_10_cave1_box2_this_box_volume
#define global_geometry_element mccchannel_10_cave1_box2_global_geometry_element
#define this_box_storage mccchannel_10_cave1_box2_this_box_storage
{   /* Declarations of channel_10_cave1_box2=Union_box() SETTING parameters. */
char* material_string = mccchannel_10_cave1_box2_material_string;
MCNUM priority = mccchannel_10_cave1_box2_priority;
MCNUM xwidth = mccchannel_10_cave1_box2_xwidth;
MCNUM yheight = mccchannel_10_cave1_box2_yheight;
MCNUM zdepth = mccchannel_10_cave1_box2_zdepth;
MCNUM xwidth2 = mccchannel_10_cave1_box2_xwidth2;
MCNUM yheight2 = mccchannel_10_cave1_box2_yheight2;
MCNUM visualize = mccchannel_10_cave1_box2_visualize;
int target_index = mccchannel_10_cave1_box2_target_index;
MCNUM target_x = mccchannel_10_cave1_box2_target_x;
MCNUM target_y = mccchannel_10_cave1_box2_target_y;
MCNUM target_z = mccchannel_10_cave1_box2_target_z;
MCNUM focus_aw = mccchannel_10_cave1_box2_focus_aw;
MCNUM focus_ah = mccchannel_10_cave1_box2_focus_ah;
MCNUM focus_xw = mccchannel_10_cave1_box2_focus_xw;
MCNUM focus_xh = mccchannel_10_cave1_box2_focus_xh;
MCNUM focus_r = mccchannel_10_cave1_box2_focus_r;
MCNUM p_interact = mccchannel_10_cave1_box2_p_interact;
char* mask_string = mccchannel_10_cave1_box2_mask_string;
char* mask_setting = mccchannel_10_cave1_box2_mask_setting;
MCNUM number_of_activations = mccchannel_10_cave1_box2_number_of_activations;
}   /* End of channel_10_cave1_box2=Union_box() SETTING parameter declarations. */
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex
  /* Label for restoring  neutron */
  mcabsorbCompchannel_10_cave1_box2:
  if (RESTORE) /* restore if needed */
  { RESTORE_NEUTRON(505,
      mcnlx,
      mcnly,
      mcnlz,
      mcnlvx,
      mcnlvy,
      mcnlvz,
      mcnlt,
      mcnlsx,
      mcnlsy,
      mcnlsz,
      mcnlp); }
#undef mcabsorbComp
#undef p
#undef sz
#undef sy
#undef sx
#undef t
#undef vz
#undef vy
#undef vx
#undef z
#undef y
#undef x
  mcDEBUG_STATE(
mcnlx,
mcnly,
mcnlz,
mcnlvx,
mcnlvy,
mcnlvz,
mcnlt,
mcnlsx,
mcnlsy,
mcnlsz,
mcnlp)

  /* TRACE Component channel_10_cave1_box3 [506] */
  mccoordschange(mcposrchannel_10_cave1_box3, mcrotrchannel_10_cave1_box3,
    &mcnlx,
    &mcnly,
    &mcnlz,
    &mcnlvx,
    &mcnlvy,
    &mcnlvz,
    &mcnlsx,
    &mcnlsy,
    &mcnlsz);
  /* define label inside component channel_10_cave1_box3 (without coords transformations) */
  mcJumpTrace_channel_10_cave1_box3:
  SIG_MESSAGE("channel_10_cave1_box3 (Trace)");
  mcDEBUG_COMP("channel_10_cave1_box3")
  mcDEBUG_STATE(
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp)
#define x mcnlx
#define y mcnly
#define z mcnlz
#define vx mcnlvx
#define vy mcnlvy
#define vz mcnlvz
#define t mcnlt
#define sx mcnlsx
#define sy mcnlsy
#define sz mcnlsz
#define p mcnlp

#define mcabsorbComp mcabsorbCompchannel_10_cave1_box3
  STORE_NEUTRON(506,
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp);
  mcScattered=0;
  mcRestore=0;
  mcNCounter[506]++;
  mcPCounter[506] += p;
  mcP2Counter[506] += p*p;
#define mccompcurname  channel_10_cave1_box3
#define mccompcurtype  Union_box
#define mccompcurindex 506
#define loop_index mccchannel_10_cave1_box3_loop_index
#define this_box_volume mccchannel_10_cave1_box3_this_box_volume
#define global_geometry_element mccchannel_10_cave1_box3_global_geometry_element
#define this_box_storage mccchannel_10_cave1_box3_this_box_storage
{   /* Declarations of channel_10_cave1_box3=Union_box() SETTING parameters. */
char* material_string = mccchannel_10_cave1_box3_material_string;
MCNUM priority = mccchannel_10_cave1_box3_priority;
MCNUM xwidth = mccchannel_10_cave1_box3_xwidth;
MCNUM yheight = mccchannel_10_cave1_box3_yheight;
MCNUM zdepth = mccchannel_10_cave1_box3_zdepth;
MCNUM xwidth2 = mccchannel_10_cave1_box3_xwidth2;
MCNUM yheight2 = mccchannel_10_cave1_box3_yheight2;
MCNUM visualize = mccchannel_10_cave1_box3_visualize;
int target_index = mccchannel_10_cave1_box3_target_index;
MCNUM target_x = mccchannel_10_cave1_box3_target_x;
MCNUM target_y = mccchannel_10_cave1_box3_target_y;
MCNUM target_z = mccchannel_10_cave1_box3_target_z;
MCNUM focus_aw = mccchannel_10_cave1_box3_focus_aw;
MCNUM focus_ah = mccchannel_10_cave1_box3_focus_ah;
MCNUM focus_xw = mccchannel_10_cave1_box3_focus_xw;
MCNUM focus_xh = mccchannel_10_cave1_box3_focus_xh;
MCNUM focus_r = mccchannel_10_cave1_box3_focus_r;
MCNUM p_interact = mccchannel_10_cave1_box3_p_interact;
char* mask_string = mccchannel_10_cave1_box3_mask_string;
char* mask_setting = mccchannel_10_cave1_box3_mask_setting;
MCNUM number_of_activations = mccchannel_10_cave1_box3_number_of_activations;
}   /* End of channel_10_cave1_box3=Union_box() SETTING parameter declarations. */
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex
  /* Label for restoring  neutron */
  mcabsorbCompchannel_10_cave1_box3:
  if (RESTORE) /* restore if needed */
  { RESTORE_NEUTRON(506,
      mcnlx,
      mcnly,
      mcnlz,
      mcnlvx,
      mcnlvy,
      mcnlvz,
      mcnlt,
      mcnlsx,
      mcnlsy,
      mcnlsz,
      mcnlp); }
#undef mcabsorbComp
#undef p
#undef sz
#undef sy
#undef sx
#undef t
#undef vz
#undef vy
#undef vx
#undef z
#undef y
#undef x
  mcDEBUG_STATE(
mcnlx,
mcnly,
mcnlz,
mcnlvx,
mcnlvy,
mcnlvz,
mcnlt,
mcnlsx,
mcnlsy,
mcnlsz,
mcnlp)

  /* TRACE Component channel_10_cave1_cyl1 [507] */
  mccoordschange(mcposrchannel_10_cave1_cyl1, mcrotrchannel_10_cave1_cyl1,
    &mcnlx,
    &mcnly,
    &mcnlz,
    &mcnlvx,
    &mcnlvy,
    &mcnlvz,
    &mcnlsx,
    &mcnlsy,
    &mcnlsz);
  /* define label inside component channel_10_cave1_cyl1 (without coords transformations) */
  mcJumpTrace_channel_10_cave1_cyl1:
  SIG_MESSAGE("channel_10_cave1_cyl1 (Trace)");
  mcDEBUG_COMP("channel_10_cave1_cyl1")
  mcDEBUG_STATE(
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp)
#define x mcnlx
#define y mcnly
#define z mcnlz
#define vx mcnlvx
#define vy mcnlvy
#define vz mcnlvz
#define t mcnlt
#define sx mcnlsx
#define sy mcnlsy
#define sz mcnlsz
#define p mcnlp

#define mcabsorbComp mcabsorbCompchannel_10_cave1_cyl1
  STORE_NEUTRON(507,
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp);
  mcScattered=0;
  mcRestore=0;
  mcNCounter[507]++;
  mcPCounter[507] += p;
  mcP2Counter[507] += p*p;
#define mccompcurname  channel_10_cave1_cyl1
#define mccompcurtype  Union_cylinder
#define mccompcurindex 507
#define loop_index mccchannel_10_cave1_cyl1_loop_index
#define this_cylinder_volume mccchannel_10_cave1_cyl1_this_cylinder_volume
#define global_geometry_element mccchannel_10_cave1_cyl1_global_geometry_element
#define this_cylinder_storage mccchannel_10_cave1_cyl1_this_cylinder_storage
{   /* Declarations of channel_10_cave1_cyl1=Union_cylinder() SETTING parameters. */
char* material_string = mccchannel_10_cave1_cyl1_material_string;
MCNUM priority = mccchannel_10_cave1_cyl1_priority;
MCNUM radius = mccchannel_10_cave1_cyl1_radius;
MCNUM yheight = mccchannel_10_cave1_cyl1_yheight;
MCNUM visualize = mccchannel_10_cave1_cyl1_visualize;
int target_index = mccchannel_10_cave1_cyl1_target_index;
MCNUM target_x = mccchannel_10_cave1_cyl1_target_x;
MCNUM target_y = mccchannel_10_cave1_cyl1_target_y;
MCNUM target_z = mccchannel_10_cave1_cyl1_target_z;
MCNUM focus_aw = mccchannel_10_cave1_cyl1_focus_aw;
MCNUM focus_ah = mccchannel_10_cave1_cyl1_focus_ah;
MCNUM focus_xw = mccchannel_10_cave1_cyl1_focus_xw;
MCNUM focus_xh = mccchannel_10_cave1_cyl1_focus_xh;
MCNUM focus_r = mccchannel_10_cave1_cyl1_focus_r;
MCNUM p_interact = mccchannel_10_cave1_cyl1_p_interact;
char* mask_string = mccchannel_10_cave1_cyl1_mask_string;
char* mask_setting = mccchannel_10_cave1_cyl1_mask_setting;
MCNUM number_of_activations = mccchannel_10_cave1_cyl1_number_of_activations;
#line 345 "Union_cylinder.comp"
{
dummy = 1;
}
#line 412468 "MACS_sample_kidney_box.c"
}   /* End of channel_10_cave1_cyl1=Union_cylinder() SETTING parameter declarations. */
#undef this_cylinder_storage
#undef global_geometry_element
#undef this_cylinder_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex
  /* Label for restoring  neutron */
  mcabsorbCompchannel_10_cave1_cyl1:
  if (RESTORE) /* restore if needed */
  { RESTORE_NEUTRON(507,
      mcnlx,
      mcnly,
      mcnlz,
      mcnlvx,
      mcnlvy,
      mcnlvz,
      mcnlt,
      mcnlsx,
      mcnlsy,
      mcnlsz,
      mcnlp); }
#undef mcabsorbComp
#undef p
#undef sz
#undef sy
#undef sx
#undef t
#undef vz
#undef vy
#undef vx
#undef z
#undef y
#undef x
  mcDEBUG_STATE(
mcnlx,
mcnly,
mcnlz,
mcnlvx,
mcnlvy,
mcnlvz,
mcnlt,
mcnlsx,
mcnlsy,
mcnlsz,
mcnlp)

  /* TRACE Component channel_10_analyzer_1_center [508] */
  mccoordschange(mcposrchannel_10_analyzer_1_center, mcrotrchannel_10_analyzer_1_center,
    &mcnlx,
    &mcnly,
    &mcnlz,
    &mcnlvx,
    &mcnlvy,
    &mcnlvz,
    &mcnlsx,
    &mcnlsy,
    &mcnlsz);
  /* define label inside component channel_10_analyzer_1_center (without coords transformations) */
  mcJumpTrace_channel_10_analyzer_1_center:
  SIG_MESSAGE("channel_10_analyzer_1_center (Trace)");
  mcDEBUG_COMP("channel_10_analyzer_1_center")
  mcDEBUG_STATE(
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp)
#define x mcnlx
#define y mcnly
#define z mcnlz
#define vx mcnlvx
#define vy mcnlvy
#define vz mcnlvz
#define t mcnlt
#define sx mcnlsx
#define sy mcnlsy
#define sz mcnlsz
#define p mcnlp

#define mcabsorbComp mcabsorbCompchannel_10_analyzer_1_center
  STORE_NEUTRON(508,
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp);
  mcScattered=0;
  mcRestore=0;
  mcNCounter[508]++;
  mcPCounter[508] += p;
  mcP2Counter[508] += p*p;
#define mccompcurname  channel_10_analyzer_1_center
#define mccompcurtype  Arm
#define mccompcurindex 508
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex
  /* Label for restoring  neutron */
  mcabsorbCompchannel_10_analyzer_1_center:
  if (RESTORE) /* restore if needed */
  { RESTORE_NEUTRON(508,
      mcnlx,
      mcnly,
      mcnlz,
      mcnlvx,
      mcnlvy,
      mcnlvz,
      mcnlt,
      mcnlsx,
      mcnlsy,
      mcnlsz,
      mcnlp); }
#undef mcabsorbComp
#undef p
#undef sz
#undef sy
#undef sx
#undef t
#undef vz
#undef vy
#undef vx
#undef z
#undef y
#undef x
  mcDEBUG_STATE(
mcnlx,
mcnly,
mcnlz,
mcnlvx,
mcnlvy,
mcnlvz,
mcnlt,
mcnlsx,
mcnlsy,
mcnlsz,
mcnlp)

  /* TRACE Component channel_10_analyzer_1_rotated [509] */
  mccoordschange(mcposrchannel_10_analyzer_1_rotated, mcrotrchannel_10_analyzer_1_rotated,
    &mcnlx,
    &mcnly,
    &mcnlz,
    &mcnlvx,
    &mcnlvy,
    &mcnlvz,
    &mcnlsx,
    &mcnlsy,
    &mcnlsz);
  /* define label inside component channel_10_analyzer_1_rotated (without coords transformations) */
  mcJumpTrace_channel_10_analyzer_1_rotated:
  SIG_MESSAGE("channel_10_analyzer_1_rotated (Trace)");
  mcDEBUG_COMP("channel_10_analyzer_1_rotated")
  mcDEBUG_STATE(
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp)
#define x mcnlx
#define y mcnly
#define z mcnlz
#define vx mcnlvx
#define vy mcnlvy
#define vz mcnlvz
#define t mcnlt
#define sx mcnlsx
#define sy mcnlsy
#define sz mcnlsz
#define p mcnlp

#define mcabsorbComp mcabsorbCompchannel_10_analyzer_1_rotated
  STORE_NEUTRON(509,
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp);
  mcScattered=0;
  mcRestore=0;
  mcNCounter[509]++;
  mcPCounter[509] += p;
  mcP2Counter[509] += p*p;
#define mccompcurname  channel_10_analyzer_1_rotated
#define mccompcurtype  Arm
#define mccompcurindex 509
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex
  /* Label for restoring  neutron */
  mcabsorbCompchannel_10_analyzer_1_rotated:
  if (RESTORE) /* restore if needed */
  { RESTORE_NEUTRON(509,
      mcnlx,
      mcnly,
      mcnlz,
      mcnlvx,
      mcnlvy,
      mcnlvz,
      mcnlt,
      mcnlsx,
      mcnlsy,
      mcnlsz,
      mcnlp); }
#undef mcabsorbComp
#undef p
#undef sz
#undef sy
#undef sx
#undef t
#undef vz
#undef vy
#undef vx
#undef z
#undef y
#undef x
  mcDEBUG_STATE(
mcnlx,
mcnly,
mcnlz,
mcnlvx,
mcnlvy,
mcnlvz,
mcnlt,
mcnlsx,
mcnlsy,
mcnlsz,
mcnlp)

  /* TRACE Component channel_10_analyzer_1_array_crystal_array_0 [510] */
  mccoordschange(mcposrchannel_10_analyzer_1_array_crystal_array_0, mcrotrchannel_10_analyzer_1_array_crystal_array_0,
    &mcnlx,
    &mcnly,
    &mcnlz,
    &mcnlvx,
    &mcnlvy,
    &mcnlvz,
    &mcnlsx,
    &mcnlsy,
    &mcnlsz);
  /* define label inside component channel_10_analyzer_1_array_crystal_array_0 (without coords transformations) */
  mcJumpTrace_channel_10_analyzer_1_array_crystal_array_0:
  SIG_MESSAGE("channel_10_analyzer_1_array_crystal_array_0 (Trace)");
  mcDEBUG_COMP("channel_10_analyzer_1_array_crystal_array_0")
  mcDEBUG_STATE(
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp)
#define x mcnlx
#define y mcnly
#define z mcnlz
#define vx mcnlvx
#define vy mcnlvy
#define vz mcnlvz
#define t mcnlt
#define sx mcnlsx
#define sy mcnlsy
#define sz mcnlsz
#define p mcnlp

#define mcabsorbComp mcabsorbCompchannel_10_analyzer_1_array_crystal_array_0
  STORE_NEUTRON(510,
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp);
  mcScattered=0;
  mcRestore=0;
  mcNCounter[510]++;
  mcPCounter[510] += p;
  mcP2Counter[510] += p*p;
#define mccompcurname  channel_10_analyzer_1_array_crystal_array_0
#define mccompcurtype  Union_box
#define mccompcurindex 510
#define loop_index mccchannel_10_analyzer_1_array_crystal_array_0_loop_index
#define this_box_volume mccchannel_10_analyzer_1_array_crystal_array_0_this_box_volume
#define global_geometry_element mccchannel_10_analyzer_1_array_crystal_array_0_global_geometry_element
#define this_box_storage mccchannel_10_analyzer_1_array_crystal_array_0_this_box_storage
{   /* Declarations of channel_10_analyzer_1_array_crystal_array_0=Union_box() SETTING parameters. */
char* material_string = mccchannel_10_analyzer_1_array_crystal_array_0_material_string;
MCNUM priority = mccchannel_10_analyzer_1_array_crystal_array_0_priority;
MCNUM xwidth = mccchannel_10_analyzer_1_array_crystal_array_0_xwidth;
MCNUM yheight = mccchannel_10_analyzer_1_array_crystal_array_0_yheight;
MCNUM zdepth = mccchannel_10_analyzer_1_array_crystal_array_0_zdepth;
MCNUM xwidth2 = mccchannel_10_analyzer_1_array_crystal_array_0_xwidth2;
MCNUM yheight2 = mccchannel_10_analyzer_1_array_crystal_array_0_yheight2;
MCNUM visualize = mccchannel_10_analyzer_1_array_crystal_array_0_visualize;
int target_index = mccchannel_10_analyzer_1_array_crystal_array_0_target_index;
MCNUM target_x = mccchannel_10_analyzer_1_array_crystal_array_0_target_x;
MCNUM target_y = mccchannel_10_analyzer_1_array_crystal_array_0_target_y;
MCNUM target_z = mccchannel_10_analyzer_1_array_crystal_array_0_target_z;
MCNUM focus_aw = mccchannel_10_analyzer_1_array_crystal_array_0_focus_aw;
MCNUM focus_ah = mccchannel_10_analyzer_1_array_crystal_array_0_focus_ah;
MCNUM focus_xw = mccchannel_10_analyzer_1_array_crystal_array_0_focus_xw;
MCNUM focus_xh = mccchannel_10_analyzer_1_array_crystal_array_0_focus_xh;
MCNUM focus_r = mccchannel_10_analyzer_1_array_crystal_array_0_focus_r;
MCNUM p_interact = mccchannel_10_analyzer_1_array_crystal_array_0_p_interact;
char* mask_string = mccchannel_10_analyzer_1_array_crystal_array_0_mask_string;
char* mask_setting = mccchannel_10_analyzer_1_array_crystal_array_0_mask_setting;
MCNUM number_of_activations = mccchannel_10_analyzer_1_array_crystal_array_0_number_of_activations;
}   /* End of channel_10_analyzer_1_array_crystal_array_0=Union_box() SETTING parameter declarations. */
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex
  /* Label for restoring  neutron */
  mcabsorbCompchannel_10_analyzer_1_array_crystal_array_0:
  if (RESTORE) /* restore if needed */
  { RESTORE_NEUTRON(510,
      mcnlx,
      mcnly,
      mcnlz,
      mcnlvx,
      mcnlvy,
      mcnlvz,
      mcnlt,
      mcnlsx,
      mcnlsy,
      mcnlsz,
      mcnlp); }
#undef mcabsorbComp
#undef p
#undef sz
#undef sy
#undef sx
#undef t
#undef vz
#undef vy
#undef vx
#undef z
#undef y
#undef x
  mcDEBUG_STATE(
mcnlx,
mcnly,
mcnlz,
mcnlvx,
mcnlvy,
mcnlvz,
mcnlt,
mcnlsx,
mcnlsy,
mcnlsz,
mcnlp)

  /* TRACE Component channel_10_analyzer_1_array_crystal_array_1 [511] */
  mccoordschange(mcposrchannel_10_analyzer_1_array_crystal_array_1, mcrotrchannel_10_analyzer_1_array_crystal_array_1,
    &mcnlx,
    &mcnly,
    &mcnlz,
    &mcnlvx,
    &mcnlvy,
    &mcnlvz,
    &mcnlsx,
    &mcnlsy,
    &mcnlsz);
  /* define label inside component channel_10_analyzer_1_array_crystal_array_1 (without coords transformations) */
  mcJumpTrace_channel_10_analyzer_1_array_crystal_array_1:
  SIG_MESSAGE("channel_10_analyzer_1_array_crystal_array_1 (Trace)");
  mcDEBUG_COMP("channel_10_analyzer_1_array_crystal_array_1")
  mcDEBUG_STATE(
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp)
#define x mcnlx
#define y mcnly
#define z mcnlz
#define vx mcnlvx
#define vy mcnlvy
#define vz mcnlvz
#define t mcnlt
#define sx mcnlsx
#define sy mcnlsy
#define sz mcnlsz
#define p mcnlp

#define mcabsorbComp mcabsorbCompchannel_10_analyzer_1_array_crystal_array_1
  STORE_NEUTRON(511,
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp);
  mcScattered=0;
  mcRestore=0;
  mcNCounter[511]++;
  mcPCounter[511] += p;
  mcP2Counter[511] += p*p;
#define mccompcurname  channel_10_analyzer_1_array_crystal_array_1
#define mccompcurtype  Union_box
#define mccompcurindex 511
#define loop_index mccchannel_10_analyzer_1_array_crystal_array_1_loop_index
#define this_box_volume mccchannel_10_analyzer_1_array_crystal_array_1_this_box_volume
#define global_geometry_element mccchannel_10_analyzer_1_array_crystal_array_1_global_geometry_element
#define this_box_storage mccchannel_10_analyzer_1_array_crystal_array_1_this_box_storage
{   /* Declarations of channel_10_analyzer_1_array_crystal_array_1=Union_box() SETTING parameters. */
char* material_string = mccchannel_10_analyzer_1_array_crystal_array_1_material_string;
MCNUM priority = mccchannel_10_analyzer_1_array_crystal_array_1_priority;
MCNUM xwidth = mccchannel_10_analyzer_1_array_crystal_array_1_xwidth;
MCNUM yheight = mccchannel_10_analyzer_1_array_crystal_array_1_yheight;
MCNUM zdepth = mccchannel_10_analyzer_1_array_crystal_array_1_zdepth;
MCNUM xwidth2 = mccchannel_10_analyzer_1_array_crystal_array_1_xwidth2;
MCNUM yheight2 = mccchannel_10_analyzer_1_array_crystal_array_1_yheight2;
MCNUM visualize = mccchannel_10_analyzer_1_array_crystal_array_1_visualize;
int target_index = mccchannel_10_analyzer_1_array_crystal_array_1_target_index;
MCNUM target_x = mccchannel_10_analyzer_1_array_crystal_array_1_target_x;
MCNUM target_y = mccchannel_10_analyzer_1_array_crystal_array_1_target_y;
MCNUM target_z = mccchannel_10_analyzer_1_array_crystal_array_1_target_z;
MCNUM focus_aw = mccchannel_10_analyzer_1_array_crystal_array_1_focus_aw;
MCNUM focus_ah = mccchannel_10_analyzer_1_array_crystal_array_1_focus_ah;
MCNUM focus_xw = mccchannel_10_analyzer_1_array_crystal_array_1_focus_xw;
MCNUM focus_xh = mccchannel_10_analyzer_1_array_crystal_array_1_focus_xh;
MCNUM focus_r = mccchannel_10_analyzer_1_array_crystal_array_1_focus_r;
MCNUM p_interact = mccchannel_10_analyzer_1_array_crystal_array_1_p_interact;
char* mask_string = mccchannel_10_analyzer_1_array_crystal_array_1_mask_string;
char* mask_setting = mccchannel_10_analyzer_1_array_crystal_array_1_mask_setting;
MCNUM number_of_activations = mccchannel_10_analyzer_1_array_crystal_array_1_number_of_activations;
}   /* End of channel_10_analyzer_1_array_crystal_array_1=Union_box() SETTING parameter declarations. */
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex
  /* Label for restoring  neutron */
  mcabsorbCompchannel_10_analyzer_1_array_crystal_array_1:
  if (RESTORE) /* restore if needed */
  { RESTORE_NEUTRON(511,
      mcnlx,
      mcnly,
      mcnlz,
      mcnlvx,
      mcnlvy,
      mcnlvz,
      mcnlt,
      mcnlsx,
      mcnlsy,
      mcnlsz,
      mcnlp); }
#undef mcabsorbComp
#undef p
#undef sz
#undef sy
#undef sx
#undef t
#undef vz
#undef vy
#undef vx
#undef z
#undef y
#undef x
  mcDEBUG_STATE(
mcnlx,
mcnly,
mcnlz,
mcnlvx,
mcnlvy,
mcnlvz,
mcnlt,
mcnlsx,
mcnlsy,
mcnlsz,
mcnlp)

  /* TRACE Component channel_10_analyzer_1_array_crystal_array_2 [512] */
  mccoordschange(mcposrchannel_10_analyzer_1_array_crystal_array_2, mcrotrchannel_10_analyzer_1_array_crystal_array_2,
    &mcnlx,
    &mcnly,
    &mcnlz,
    &mcnlvx,
    &mcnlvy,
    &mcnlvz,
    &mcnlsx,
    &mcnlsy,
    &mcnlsz);
  /* define label inside component channel_10_analyzer_1_array_crystal_array_2 (without coords transformations) */
  mcJumpTrace_channel_10_analyzer_1_array_crystal_array_2:
  SIG_MESSAGE("channel_10_analyzer_1_array_crystal_array_2 (Trace)");
  mcDEBUG_COMP("channel_10_analyzer_1_array_crystal_array_2")
  mcDEBUG_STATE(
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp)
#define x mcnlx
#define y mcnly
#define z mcnlz
#define vx mcnlvx
#define vy mcnlvy
#define vz mcnlvz
#define t mcnlt
#define sx mcnlsx
#define sy mcnlsy
#define sz mcnlsz
#define p mcnlp

#define mcabsorbComp mcabsorbCompchannel_10_analyzer_1_array_crystal_array_2
  STORE_NEUTRON(512,
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp);
  mcScattered=0;
  mcRestore=0;
  mcNCounter[512]++;
  mcPCounter[512] += p;
  mcP2Counter[512] += p*p;
#define mccompcurname  channel_10_analyzer_1_array_crystal_array_2
#define mccompcurtype  Union_box
#define mccompcurindex 512
#define loop_index mccchannel_10_analyzer_1_array_crystal_array_2_loop_index
#define this_box_volume mccchannel_10_analyzer_1_array_crystal_array_2_this_box_volume
#define global_geometry_element mccchannel_10_analyzer_1_array_crystal_array_2_global_geometry_element
#define this_box_storage mccchannel_10_analyzer_1_array_crystal_array_2_this_box_storage
{   /* Declarations of channel_10_analyzer_1_array_crystal_array_2=Union_box() SETTING parameters. */
char* material_string = mccchannel_10_analyzer_1_array_crystal_array_2_material_string;
MCNUM priority = mccchannel_10_analyzer_1_array_crystal_array_2_priority;
MCNUM xwidth = mccchannel_10_analyzer_1_array_crystal_array_2_xwidth;
MCNUM yheight = mccchannel_10_analyzer_1_array_crystal_array_2_yheight;
MCNUM zdepth = mccchannel_10_analyzer_1_array_crystal_array_2_zdepth;
MCNUM xwidth2 = mccchannel_10_analyzer_1_array_crystal_array_2_xwidth2;
MCNUM yheight2 = mccchannel_10_analyzer_1_array_crystal_array_2_yheight2;
MCNUM visualize = mccchannel_10_analyzer_1_array_crystal_array_2_visualize;
int target_index = mccchannel_10_analyzer_1_array_crystal_array_2_target_index;
MCNUM target_x = mccchannel_10_analyzer_1_array_crystal_array_2_target_x;
MCNUM target_y = mccchannel_10_analyzer_1_array_crystal_array_2_target_y;
MCNUM target_z = mccchannel_10_analyzer_1_array_crystal_array_2_target_z;
MCNUM focus_aw = mccchannel_10_analyzer_1_array_crystal_array_2_focus_aw;
MCNUM focus_ah = mccchannel_10_analyzer_1_array_crystal_array_2_focus_ah;
MCNUM focus_xw = mccchannel_10_analyzer_1_array_crystal_array_2_focus_xw;
MCNUM focus_xh = mccchannel_10_analyzer_1_array_crystal_array_2_focus_xh;
MCNUM focus_r = mccchannel_10_analyzer_1_array_crystal_array_2_focus_r;
MCNUM p_interact = mccchannel_10_analyzer_1_array_crystal_array_2_p_interact;
char* mask_string = mccchannel_10_analyzer_1_array_crystal_array_2_mask_string;
char* mask_setting = mccchannel_10_analyzer_1_array_crystal_array_2_mask_setting;
MCNUM number_of_activations = mccchannel_10_analyzer_1_array_crystal_array_2_number_of_activations;
}   /* End of channel_10_analyzer_1_array_crystal_array_2=Union_box() SETTING parameter declarations. */
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex
  /* Label for restoring  neutron */
  mcabsorbCompchannel_10_analyzer_1_array_crystal_array_2:
  if (RESTORE) /* restore if needed */
  { RESTORE_NEUTRON(512,
      mcnlx,
      mcnly,
      mcnlz,
      mcnlvx,
      mcnlvy,
      mcnlvz,
      mcnlt,
      mcnlsx,
      mcnlsy,
      mcnlsz,
      mcnlp); }
#undef mcabsorbComp
#undef p
#undef sz
#undef sy
#undef sx
#undef t
#undef vz
#undef vy
#undef vx
#undef z
#undef y
#undef x
  mcDEBUG_STATE(
mcnlx,
mcnly,
mcnlz,
mcnlvx,
mcnlvy,
mcnlvz,
mcnlt,
mcnlsx,
mcnlsy,
mcnlsz,
mcnlp)

  /* TRACE Component channel_10_analyzer_1_array_crystal_array_3 [513] */
  mccoordschange(mcposrchannel_10_analyzer_1_array_crystal_array_3, mcrotrchannel_10_analyzer_1_array_crystal_array_3,
    &mcnlx,
    &mcnly,
    &mcnlz,
    &mcnlvx,
    &mcnlvy,
    &mcnlvz,
    &mcnlsx,
    &mcnlsy,
    &mcnlsz);
  /* define label inside component channel_10_analyzer_1_array_crystal_array_3 (without coords transformations) */
  mcJumpTrace_channel_10_analyzer_1_array_crystal_array_3:
  SIG_MESSAGE("channel_10_analyzer_1_array_crystal_array_3 (Trace)");
  mcDEBUG_COMP("channel_10_analyzer_1_array_crystal_array_3")
  mcDEBUG_STATE(
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp)
#define x mcnlx
#define y mcnly
#define z mcnlz
#define vx mcnlvx
#define vy mcnlvy
#define vz mcnlvz
#define t mcnlt
#define sx mcnlsx
#define sy mcnlsy
#define sz mcnlsz
#define p mcnlp

#define mcabsorbComp mcabsorbCompchannel_10_analyzer_1_array_crystal_array_3
  STORE_NEUTRON(513,
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp);
  mcScattered=0;
  mcRestore=0;
  mcNCounter[513]++;
  mcPCounter[513] += p;
  mcP2Counter[513] += p*p;
#define mccompcurname  channel_10_analyzer_1_array_crystal_array_3
#define mccompcurtype  Union_box
#define mccompcurindex 513
#define loop_index mccchannel_10_analyzer_1_array_crystal_array_3_loop_index
#define this_box_volume mccchannel_10_analyzer_1_array_crystal_array_3_this_box_volume
#define global_geometry_element mccchannel_10_analyzer_1_array_crystal_array_3_global_geometry_element
#define this_box_storage mccchannel_10_analyzer_1_array_crystal_array_3_this_box_storage
{   /* Declarations of channel_10_analyzer_1_array_crystal_array_3=Union_box() SETTING parameters. */
char* material_string = mccchannel_10_analyzer_1_array_crystal_array_3_material_string;
MCNUM priority = mccchannel_10_analyzer_1_array_crystal_array_3_priority;
MCNUM xwidth = mccchannel_10_analyzer_1_array_crystal_array_3_xwidth;
MCNUM yheight = mccchannel_10_analyzer_1_array_crystal_array_3_yheight;
MCNUM zdepth = mccchannel_10_analyzer_1_array_crystal_array_3_zdepth;
MCNUM xwidth2 = mccchannel_10_analyzer_1_array_crystal_array_3_xwidth2;
MCNUM yheight2 = mccchannel_10_analyzer_1_array_crystal_array_3_yheight2;
MCNUM visualize = mccchannel_10_analyzer_1_array_crystal_array_3_visualize;
int target_index = mccchannel_10_analyzer_1_array_crystal_array_3_target_index;
MCNUM target_x = mccchannel_10_analyzer_1_array_crystal_array_3_target_x;
MCNUM target_y = mccchannel_10_analyzer_1_array_crystal_array_3_target_y;
MCNUM target_z = mccchannel_10_analyzer_1_array_crystal_array_3_target_z;
MCNUM focus_aw = mccchannel_10_analyzer_1_array_crystal_array_3_focus_aw;
MCNUM focus_ah = mccchannel_10_analyzer_1_array_crystal_array_3_focus_ah;
MCNUM focus_xw = mccchannel_10_analyzer_1_array_crystal_array_3_focus_xw;
MCNUM focus_xh = mccchannel_10_analyzer_1_array_crystal_array_3_focus_xh;
MCNUM focus_r = mccchannel_10_analyzer_1_array_crystal_array_3_focus_r;
MCNUM p_interact = mccchannel_10_analyzer_1_array_crystal_array_3_p_interact;
char* mask_string = mccchannel_10_analyzer_1_array_crystal_array_3_mask_string;
char* mask_setting = mccchannel_10_analyzer_1_array_crystal_array_3_mask_setting;
MCNUM number_of_activations = mccchannel_10_analyzer_1_array_crystal_array_3_number_of_activations;
}   /* End of channel_10_analyzer_1_array_crystal_array_3=Union_box() SETTING parameter declarations. */
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex
  /* Label for restoring  neutron */
  mcabsorbCompchannel_10_analyzer_1_array_crystal_array_3:
  if (RESTORE) /* restore if needed */
  { RESTORE_NEUTRON(513,
      mcnlx,
      mcnly,
      mcnlz,
      mcnlvx,
      mcnlvy,
      mcnlvz,
      mcnlt,
      mcnlsx,
      mcnlsy,
      mcnlsz,
      mcnlp); }
#undef mcabsorbComp
#undef p
#undef sz
#undef sy
#undef sx
#undef t
#undef vz
#undef vy
#undef vx
#undef z
#undef y
#undef x
  mcDEBUG_STATE(
mcnlx,
mcnly,
mcnlz,
mcnlvx,
mcnlvy,
mcnlvz,
mcnlt,
mcnlsx,
mcnlsy,
mcnlsz,
mcnlp)

  /* TRACE Component channel_10_analyzer_1_array_crystal_array_4 [514] */
  mccoordschange(mcposrchannel_10_analyzer_1_array_crystal_array_4, mcrotrchannel_10_analyzer_1_array_crystal_array_4,
    &mcnlx,
    &mcnly,
    &mcnlz,
    &mcnlvx,
    &mcnlvy,
    &mcnlvz,
    &mcnlsx,
    &mcnlsy,
    &mcnlsz);
  /* define label inside component channel_10_analyzer_1_array_crystal_array_4 (without coords transformations) */
  mcJumpTrace_channel_10_analyzer_1_array_crystal_array_4:
  SIG_MESSAGE("channel_10_analyzer_1_array_crystal_array_4 (Trace)");
  mcDEBUG_COMP("channel_10_analyzer_1_array_crystal_array_4")
  mcDEBUG_STATE(
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp)
#define x mcnlx
#define y mcnly
#define z mcnlz
#define vx mcnlvx
#define vy mcnlvy
#define vz mcnlvz
#define t mcnlt
#define sx mcnlsx
#define sy mcnlsy
#define sz mcnlsz
#define p mcnlp

#define mcabsorbComp mcabsorbCompchannel_10_analyzer_1_array_crystal_array_4
  STORE_NEUTRON(514,
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp);
  mcScattered=0;
  mcRestore=0;
  mcNCounter[514]++;
  mcPCounter[514] += p;
  mcP2Counter[514] += p*p;
#define mccompcurname  channel_10_analyzer_1_array_crystal_array_4
#define mccompcurtype  Union_box
#define mccompcurindex 514
#define loop_index mccchannel_10_analyzer_1_array_crystal_array_4_loop_index
#define this_box_volume mccchannel_10_analyzer_1_array_crystal_array_4_this_box_volume
#define global_geometry_element mccchannel_10_analyzer_1_array_crystal_array_4_global_geometry_element
#define this_box_storage mccchannel_10_analyzer_1_array_crystal_array_4_this_box_storage
{   /* Declarations of channel_10_analyzer_1_array_crystal_array_4=Union_box() SETTING parameters. */
char* material_string = mccchannel_10_analyzer_1_array_crystal_array_4_material_string;
MCNUM priority = mccchannel_10_analyzer_1_array_crystal_array_4_priority;
MCNUM xwidth = mccchannel_10_analyzer_1_array_crystal_array_4_xwidth;
MCNUM yheight = mccchannel_10_analyzer_1_array_crystal_array_4_yheight;
MCNUM zdepth = mccchannel_10_analyzer_1_array_crystal_array_4_zdepth;
MCNUM xwidth2 = mccchannel_10_analyzer_1_array_crystal_array_4_xwidth2;
MCNUM yheight2 = mccchannel_10_analyzer_1_array_crystal_array_4_yheight2;
MCNUM visualize = mccchannel_10_analyzer_1_array_crystal_array_4_visualize;
int target_index = mccchannel_10_analyzer_1_array_crystal_array_4_target_index;
MCNUM target_x = mccchannel_10_analyzer_1_array_crystal_array_4_target_x;
MCNUM target_y = mccchannel_10_analyzer_1_array_crystal_array_4_target_y;
MCNUM target_z = mccchannel_10_analyzer_1_array_crystal_array_4_target_z;
MCNUM focus_aw = mccchannel_10_analyzer_1_array_crystal_array_4_focus_aw;
MCNUM focus_ah = mccchannel_10_analyzer_1_array_crystal_array_4_focus_ah;
MCNUM focus_xw = mccchannel_10_analyzer_1_array_crystal_array_4_focus_xw;
MCNUM focus_xh = mccchannel_10_analyzer_1_array_crystal_array_4_focus_xh;
MCNUM focus_r = mccchannel_10_analyzer_1_array_crystal_array_4_focus_r;
MCNUM p_interact = mccchannel_10_analyzer_1_array_crystal_array_4_p_interact;
char* mask_string = mccchannel_10_analyzer_1_array_crystal_array_4_mask_string;
char* mask_setting = mccchannel_10_analyzer_1_array_crystal_array_4_mask_setting;
MCNUM number_of_activations = mccchannel_10_analyzer_1_array_crystal_array_4_number_of_activations;
}   /* End of channel_10_analyzer_1_array_crystal_array_4=Union_box() SETTING parameter declarations. */
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex
  /* Label for restoring  neutron */
  mcabsorbCompchannel_10_analyzer_1_array_crystal_array_4:
  if (RESTORE) /* restore if needed */
  { RESTORE_NEUTRON(514,
      mcnlx,
      mcnly,
      mcnlz,
      mcnlvx,
      mcnlvy,
      mcnlvz,
      mcnlt,
      mcnlsx,
      mcnlsy,
      mcnlsz,
      mcnlp); }
#undef mcabsorbComp
#undef p
#undef sz
#undef sy
#undef sx
#undef t
#undef vz
#undef vy
#undef vx
#undef z
#undef y
#undef x
  mcDEBUG_STATE(
mcnlx,
mcnly,
mcnlz,
mcnlvx,
mcnlvy,
mcnlvz,
mcnlt,
mcnlsx,
mcnlsy,
mcnlsz,
mcnlp)

  /* TRACE Component channel_10_analyzer_1_array_crystal_array_5 [515] */
  mccoordschange(mcposrchannel_10_analyzer_1_array_crystal_array_5, mcrotrchannel_10_analyzer_1_array_crystal_array_5,
    &mcnlx,
    &mcnly,
    &mcnlz,
    &mcnlvx,
    &mcnlvy,
    &mcnlvz,
    &mcnlsx,
    &mcnlsy,
    &mcnlsz);
  /* define label inside component channel_10_analyzer_1_array_crystal_array_5 (without coords transformations) */
  mcJumpTrace_channel_10_analyzer_1_array_crystal_array_5:
  SIG_MESSAGE("channel_10_analyzer_1_array_crystal_array_5 (Trace)");
  mcDEBUG_COMP("channel_10_analyzer_1_array_crystal_array_5")
  mcDEBUG_STATE(
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp)
#define x mcnlx
#define y mcnly
#define z mcnlz
#define vx mcnlvx
#define vy mcnlvy
#define vz mcnlvz
#define t mcnlt
#define sx mcnlsx
#define sy mcnlsy
#define sz mcnlsz
#define p mcnlp

#define mcabsorbComp mcabsorbCompchannel_10_analyzer_1_array_crystal_array_5
  STORE_NEUTRON(515,
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp);
  mcScattered=0;
  mcRestore=0;
  mcNCounter[515]++;
  mcPCounter[515] += p;
  mcP2Counter[515] += p*p;
#define mccompcurname  channel_10_analyzer_1_array_crystal_array_5
#define mccompcurtype  Union_box
#define mccompcurindex 515
#define loop_index mccchannel_10_analyzer_1_array_crystal_array_5_loop_index
#define this_box_volume mccchannel_10_analyzer_1_array_crystal_array_5_this_box_volume
#define global_geometry_element mccchannel_10_analyzer_1_array_crystal_array_5_global_geometry_element
#define this_box_storage mccchannel_10_analyzer_1_array_crystal_array_5_this_box_storage
{   /* Declarations of channel_10_analyzer_1_array_crystal_array_5=Union_box() SETTING parameters. */
char* material_string = mccchannel_10_analyzer_1_array_crystal_array_5_material_string;
MCNUM priority = mccchannel_10_analyzer_1_array_crystal_array_5_priority;
MCNUM xwidth = mccchannel_10_analyzer_1_array_crystal_array_5_xwidth;
MCNUM yheight = mccchannel_10_analyzer_1_array_crystal_array_5_yheight;
MCNUM zdepth = mccchannel_10_analyzer_1_array_crystal_array_5_zdepth;
MCNUM xwidth2 = mccchannel_10_analyzer_1_array_crystal_array_5_xwidth2;
MCNUM yheight2 = mccchannel_10_analyzer_1_array_crystal_array_5_yheight2;
MCNUM visualize = mccchannel_10_analyzer_1_array_crystal_array_5_visualize;
int target_index = mccchannel_10_analyzer_1_array_crystal_array_5_target_index;
MCNUM target_x = mccchannel_10_analyzer_1_array_crystal_array_5_target_x;
MCNUM target_y = mccchannel_10_analyzer_1_array_crystal_array_5_target_y;
MCNUM target_z = mccchannel_10_analyzer_1_array_crystal_array_5_target_z;
MCNUM focus_aw = mccchannel_10_analyzer_1_array_crystal_array_5_focus_aw;
MCNUM focus_ah = mccchannel_10_analyzer_1_array_crystal_array_5_focus_ah;
MCNUM focus_xw = mccchannel_10_analyzer_1_array_crystal_array_5_focus_xw;
MCNUM focus_xh = mccchannel_10_analyzer_1_array_crystal_array_5_focus_xh;
MCNUM focus_r = mccchannel_10_analyzer_1_array_crystal_array_5_focus_r;
MCNUM p_interact = mccchannel_10_analyzer_1_array_crystal_array_5_p_interact;
char* mask_string = mccchannel_10_analyzer_1_array_crystal_array_5_mask_string;
char* mask_setting = mccchannel_10_analyzer_1_array_crystal_array_5_mask_setting;
MCNUM number_of_activations = mccchannel_10_analyzer_1_array_crystal_array_5_number_of_activations;
}   /* End of channel_10_analyzer_1_array_crystal_array_5=Union_box() SETTING parameter declarations. */
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex
  /* Label for restoring  neutron */
  mcabsorbCompchannel_10_analyzer_1_array_crystal_array_5:
  if (RESTORE) /* restore if needed */
  { RESTORE_NEUTRON(515,
      mcnlx,
      mcnly,
      mcnlz,
      mcnlvx,
      mcnlvy,
      mcnlvz,
      mcnlt,
      mcnlsx,
      mcnlsy,
      mcnlsz,
      mcnlp); }
#undef mcabsorbComp
#undef p
#undef sz
#undef sy
#undef sx
#undef t
#undef vz
#undef vy
#undef vx
#undef z
#undef y
#undef x
  mcDEBUG_STATE(
mcnlx,
mcnly,
mcnlz,
mcnlvx,
mcnlvy,
mcnlvz,
mcnlt,
mcnlsx,
mcnlsy,
mcnlsz,
mcnlp)

  /* TRACE Component channel_10_analyzer_1_array_crystal_array_6 [516] */
  mccoordschange(mcposrchannel_10_analyzer_1_array_crystal_array_6, mcrotrchannel_10_analyzer_1_array_crystal_array_6,
    &mcnlx,
    &mcnly,
    &mcnlz,
    &mcnlvx,
    &mcnlvy,
    &mcnlvz,
    &mcnlsx,
    &mcnlsy,
    &mcnlsz);
  /* define label inside component channel_10_analyzer_1_array_crystal_array_6 (without coords transformations) */
  mcJumpTrace_channel_10_analyzer_1_array_crystal_array_6:
  SIG_MESSAGE("channel_10_analyzer_1_array_crystal_array_6 (Trace)");
  mcDEBUG_COMP("channel_10_analyzer_1_array_crystal_array_6")
  mcDEBUG_STATE(
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp)
#define x mcnlx
#define y mcnly
#define z mcnlz
#define vx mcnlvx
#define vy mcnlvy
#define vz mcnlvz
#define t mcnlt
#define sx mcnlsx
#define sy mcnlsy
#define sz mcnlsz
#define p mcnlp

#define mcabsorbComp mcabsorbCompchannel_10_analyzer_1_array_crystal_array_6
  STORE_NEUTRON(516,
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp);
  mcScattered=0;
  mcRestore=0;
  mcNCounter[516]++;
  mcPCounter[516] += p;
  mcP2Counter[516] += p*p;
#define mccompcurname  channel_10_analyzer_1_array_crystal_array_6
#define mccompcurtype  Union_box
#define mccompcurindex 516
#define loop_index mccchannel_10_analyzer_1_array_crystal_array_6_loop_index
#define this_box_volume mccchannel_10_analyzer_1_array_crystal_array_6_this_box_volume
#define global_geometry_element mccchannel_10_analyzer_1_array_crystal_array_6_global_geometry_element
#define this_box_storage mccchannel_10_analyzer_1_array_crystal_array_6_this_box_storage
{   /* Declarations of channel_10_analyzer_1_array_crystal_array_6=Union_box() SETTING parameters. */
char* material_string = mccchannel_10_analyzer_1_array_crystal_array_6_material_string;
MCNUM priority = mccchannel_10_analyzer_1_array_crystal_array_6_priority;
MCNUM xwidth = mccchannel_10_analyzer_1_array_crystal_array_6_xwidth;
MCNUM yheight = mccchannel_10_analyzer_1_array_crystal_array_6_yheight;
MCNUM zdepth = mccchannel_10_analyzer_1_array_crystal_array_6_zdepth;
MCNUM xwidth2 = mccchannel_10_analyzer_1_array_crystal_array_6_xwidth2;
MCNUM yheight2 = mccchannel_10_analyzer_1_array_crystal_array_6_yheight2;
MCNUM visualize = mccchannel_10_analyzer_1_array_crystal_array_6_visualize;
int target_index = mccchannel_10_analyzer_1_array_crystal_array_6_target_index;
MCNUM target_x = mccchannel_10_analyzer_1_array_crystal_array_6_target_x;
MCNUM target_y = mccchannel_10_analyzer_1_array_crystal_array_6_target_y;
MCNUM target_z = mccchannel_10_analyzer_1_array_crystal_array_6_target_z;
MCNUM focus_aw = mccchannel_10_analyzer_1_array_crystal_array_6_focus_aw;
MCNUM focus_ah = mccchannel_10_analyzer_1_array_crystal_array_6_focus_ah;
MCNUM focus_xw = mccchannel_10_analyzer_1_array_crystal_array_6_focus_xw;
MCNUM focus_xh = mccchannel_10_analyzer_1_array_crystal_array_6_focus_xh;
MCNUM focus_r = mccchannel_10_analyzer_1_array_crystal_array_6_focus_r;
MCNUM p_interact = mccchannel_10_analyzer_1_array_crystal_array_6_p_interact;
char* mask_string = mccchannel_10_analyzer_1_array_crystal_array_6_mask_string;
char* mask_setting = mccchannel_10_analyzer_1_array_crystal_array_6_mask_setting;
MCNUM number_of_activations = mccchannel_10_analyzer_1_array_crystal_array_6_number_of_activations;
}   /* End of channel_10_analyzer_1_array_crystal_array_6=Union_box() SETTING parameter declarations. */
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex
  /* Label for restoring  neutron */
  mcabsorbCompchannel_10_analyzer_1_array_crystal_array_6:
  if (RESTORE) /* restore if needed */
  { RESTORE_NEUTRON(516,
      mcnlx,
      mcnly,
      mcnlz,
      mcnlvx,
      mcnlvy,
      mcnlvz,
      mcnlt,
      mcnlsx,
      mcnlsy,
      mcnlsz,
      mcnlp); }
#undef mcabsorbComp
#undef p
#undef sz
#undef sy
#undef sx
#undef t
#undef vz
#undef vy
#undef vx
#undef z
#undef y
#undef x
  mcDEBUG_STATE(
mcnlx,
mcnly,
mcnlz,
mcnlvx,
mcnlvy,
mcnlvz,
mcnlt,
mcnlsx,
mcnlsy,
mcnlsz,
mcnlp)

  /* TRACE Component channel_10_analyzer_1_array_crystal_array_7 [517] */
  mccoordschange(mcposrchannel_10_analyzer_1_array_crystal_array_7, mcrotrchannel_10_analyzer_1_array_crystal_array_7,
    &mcnlx,
    &mcnly,
    &mcnlz,
    &mcnlvx,
    &mcnlvy,
    &mcnlvz,
    &mcnlsx,
    &mcnlsy,
    &mcnlsz);
  /* define label inside component channel_10_analyzer_1_array_crystal_array_7 (without coords transformations) */
  mcJumpTrace_channel_10_analyzer_1_array_crystal_array_7:
  SIG_MESSAGE("channel_10_analyzer_1_array_crystal_array_7 (Trace)");
  mcDEBUG_COMP("channel_10_analyzer_1_array_crystal_array_7")
  mcDEBUG_STATE(
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp)
#define x mcnlx
#define y mcnly
#define z mcnlz
#define vx mcnlvx
#define vy mcnlvy
#define vz mcnlvz
#define t mcnlt
#define sx mcnlsx
#define sy mcnlsy
#define sz mcnlsz
#define p mcnlp

#define mcabsorbComp mcabsorbCompchannel_10_analyzer_1_array_crystal_array_7
  STORE_NEUTRON(517,
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp);
  mcScattered=0;
  mcRestore=0;
  mcNCounter[517]++;
  mcPCounter[517] += p;
  mcP2Counter[517] += p*p;
#define mccompcurname  channel_10_analyzer_1_array_crystal_array_7
#define mccompcurtype  Union_box
#define mccompcurindex 517
#define loop_index mccchannel_10_analyzer_1_array_crystal_array_7_loop_index
#define this_box_volume mccchannel_10_analyzer_1_array_crystal_array_7_this_box_volume
#define global_geometry_element mccchannel_10_analyzer_1_array_crystal_array_7_global_geometry_element
#define this_box_storage mccchannel_10_analyzer_1_array_crystal_array_7_this_box_storage
{   /* Declarations of channel_10_analyzer_1_array_crystal_array_7=Union_box() SETTING parameters. */
char* material_string = mccchannel_10_analyzer_1_array_crystal_array_7_material_string;
MCNUM priority = mccchannel_10_analyzer_1_array_crystal_array_7_priority;
MCNUM xwidth = mccchannel_10_analyzer_1_array_crystal_array_7_xwidth;
MCNUM yheight = mccchannel_10_analyzer_1_array_crystal_array_7_yheight;
MCNUM zdepth = mccchannel_10_analyzer_1_array_crystal_array_7_zdepth;
MCNUM xwidth2 = mccchannel_10_analyzer_1_array_crystal_array_7_xwidth2;
MCNUM yheight2 = mccchannel_10_analyzer_1_array_crystal_array_7_yheight2;
MCNUM visualize = mccchannel_10_analyzer_1_array_crystal_array_7_visualize;
int target_index = mccchannel_10_analyzer_1_array_crystal_array_7_target_index;
MCNUM target_x = mccchannel_10_analyzer_1_array_crystal_array_7_target_x;
MCNUM target_y = mccchannel_10_analyzer_1_array_crystal_array_7_target_y;
MCNUM target_z = mccchannel_10_analyzer_1_array_crystal_array_7_target_z;
MCNUM focus_aw = mccchannel_10_analyzer_1_array_crystal_array_7_focus_aw;
MCNUM focus_ah = mccchannel_10_analyzer_1_array_crystal_array_7_focus_ah;
MCNUM focus_xw = mccchannel_10_analyzer_1_array_crystal_array_7_focus_xw;
MCNUM focus_xh = mccchannel_10_analyzer_1_array_crystal_array_7_focus_xh;
MCNUM focus_r = mccchannel_10_analyzer_1_array_crystal_array_7_focus_r;
MCNUM p_interact = mccchannel_10_analyzer_1_array_crystal_array_7_p_interact;
char* mask_string = mccchannel_10_analyzer_1_array_crystal_array_7_mask_string;
char* mask_setting = mccchannel_10_analyzer_1_array_crystal_array_7_mask_setting;
MCNUM number_of_activations = mccchannel_10_analyzer_1_array_crystal_array_7_number_of_activations;
}   /* End of channel_10_analyzer_1_array_crystal_array_7=Union_box() SETTING parameter declarations. */
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex
  /* Label for restoring  neutron */
  mcabsorbCompchannel_10_analyzer_1_array_crystal_array_7:
  if (RESTORE) /* restore if needed */
  { RESTORE_NEUTRON(517,
      mcnlx,
      mcnly,
      mcnlz,
      mcnlvx,
      mcnlvy,
      mcnlvz,
      mcnlt,
      mcnlsx,
      mcnlsy,
      mcnlsz,
      mcnlp); }
#undef mcabsorbComp
#undef p
#undef sz
#undef sy
#undef sx
#undef t
#undef vz
#undef vy
#undef vx
#undef z
#undef y
#undef x
  mcDEBUG_STATE(
mcnlx,
mcnly,
mcnlz,
mcnlvx,
mcnlvy,
mcnlvz,
mcnlt,
mcnlsx,
mcnlsy,
mcnlsz,
mcnlp)

  /* TRACE Component channel_10_analyzer_1_array_crystal_array_8 [518] */
  mccoordschange(mcposrchannel_10_analyzer_1_array_crystal_array_8, mcrotrchannel_10_analyzer_1_array_crystal_array_8,
    &mcnlx,
    &mcnly,
    &mcnlz,
    &mcnlvx,
    &mcnlvy,
    &mcnlvz,
    &mcnlsx,
    &mcnlsy,
    &mcnlsz);
  /* define label inside component channel_10_analyzer_1_array_crystal_array_8 (without coords transformations) */
  mcJumpTrace_channel_10_analyzer_1_array_crystal_array_8:
  SIG_MESSAGE("channel_10_analyzer_1_array_crystal_array_8 (Trace)");
  mcDEBUG_COMP("channel_10_analyzer_1_array_crystal_array_8")
  mcDEBUG_STATE(
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp)
#define x mcnlx
#define y mcnly
#define z mcnlz
#define vx mcnlvx
#define vy mcnlvy
#define vz mcnlvz
#define t mcnlt
#define sx mcnlsx
#define sy mcnlsy
#define sz mcnlsz
#define p mcnlp

#define mcabsorbComp mcabsorbCompchannel_10_analyzer_1_array_crystal_array_8
  STORE_NEUTRON(518,
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp);
  mcScattered=0;
  mcRestore=0;
  mcNCounter[518]++;
  mcPCounter[518] += p;
  mcP2Counter[518] += p*p;
#define mccompcurname  channel_10_analyzer_1_array_crystal_array_8
#define mccompcurtype  Union_box
#define mccompcurindex 518
#define loop_index mccchannel_10_analyzer_1_array_crystal_array_8_loop_index
#define this_box_volume mccchannel_10_analyzer_1_array_crystal_array_8_this_box_volume
#define global_geometry_element mccchannel_10_analyzer_1_array_crystal_array_8_global_geometry_element
#define this_box_storage mccchannel_10_analyzer_1_array_crystal_array_8_this_box_storage
{   /* Declarations of channel_10_analyzer_1_array_crystal_array_8=Union_box() SETTING parameters. */
char* material_string = mccchannel_10_analyzer_1_array_crystal_array_8_material_string;
MCNUM priority = mccchannel_10_analyzer_1_array_crystal_array_8_priority;
MCNUM xwidth = mccchannel_10_analyzer_1_array_crystal_array_8_xwidth;
MCNUM yheight = mccchannel_10_analyzer_1_array_crystal_array_8_yheight;
MCNUM zdepth = mccchannel_10_analyzer_1_array_crystal_array_8_zdepth;
MCNUM xwidth2 = mccchannel_10_analyzer_1_array_crystal_array_8_xwidth2;
MCNUM yheight2 = mccchannel_10_analyzer_1_array_crystal_array_8_yheight2;
MCNUM visualize = mccchannel_10_analyzer_1_array_crystal_array_8_visualize;
int target_index = mccchannel_10_analyzer_1_array_crystal_array_8_target_index;
MCNUM target_x = mccchannel_10_analyzer_1_array_crystal_array_8_target_x;
MCNUM target_y = mccchannel_10_analyzer_1_array_crystal_array_8_target_y;
MCNUM target_z = mccchannel_10_analyzer_1_array_crystal_array_8_target_z;
MCNUM focus_aw = mccchannel_10_analyzer_1_array_crystal_array_8_focus_aw;
MCNUM focus_ah = mccchannel_10_analyzer_1_array_crystal_array_8_focus_ah;
MCNUM focus_xw = mccchannel_10_analyzer_1_array_crystal_array_8_focus_xw;
MCNUM focus_xh = mccchannel_10_analyzer_1_array_crystal_array_8_focus_xh;
MCNUM focus_r = mccchannel_10_analyzer_1_array_crystal_array_8_focus_r;
MCNUM p_interact = mccchannel_10_analyzer_1_array_crystal_array_8_p_interact;
char* mask_string = mccchannel_10_analyzer_1_array_crystal_array_8_mask_string;
char* mask_setting = mccchannel_10_analyzer_1_array_crystal_array_8_mask_setting;
MCNUM number_of_activations = mccchannel_10_analyzer_1_array_crystal_array_8_number_of_activations;
}   /* End of channel_10_analyzer_1_array_crystal_array_8=Union_box() SETTING parameter declarations. */
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex
  /* Label for restoring  neutron */
  mcabsorbCompchannel_10_analyzer_1_array_crystal_array_8:
  if (RESTORE) /* restore if needed */
  { RESTORE_NEUTRON(518,
      mcnlx,
      mcnly,
      mcnlz,
      mcnlvx,
      mcnlvy,
      mcnlvz,
      mcnlt,
      mcnlsx,
      mcnlsy,
      mcnlsz,
      mcnlp); }
#undef mcabsorbComp
#undef p
#undef sz
#undef sy
#undef sx
#undef t
#undef vz
#undef vy
#undef vx
#undef z
#undef y
#undef x
  mcDEBUG_STATE(
mcnlx,
mcnly,
mcnlz,
mcnlvx,
mcnlvy,
mcnlvz,
mcnlt,
mcnlsx,
mcnlsy,
mcnlsz,
mcnlp)

  /* TRACE Component channel_10_analyzer_2_center [519] */
  mccoordschange(mcposrchannel_10_analyzer_2_center, mcrotrchannel_10_analyzer_2_center,
    &mcnlx,
    &mcnly,
    &mcnlz,
    &mcnlvx,
    &mcnlvy,
    &mcnlvz,
    &mcnlsx,
    &mcnlsy,
    &mcnlsz);
  /* define label inside component channel_10_analyzer_2_center (without coords transformations) */
  mcJumpTrace_channel_10_analyzer_2_center:
  SIG_MESSAGE("channel_10_analyzer_2_center (Trace)");
  mcDEBUG_COMP("channel_10_analyzer_2_center")
  mcDEBUG_STATE(
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp)
#define x mcnlx
#define y mcnly
#define z mcnlz
#define vx mcnlvx
#define vy mcnlvy
#define vz mcnlvz
#define t mcnlt
#define sx mcnlsx
#define sy mcnlsy
#define sz mcnlsz
#define p mcnlp

#define mcabsorbComp mcabsorbCompchannel_10_analyzer_2_center
  STORE_NEUTRON(519,
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp);
  mcScattered=0;
  mcRestore=0;
  mcNCounter[519]++;
  mcPCounter[519] += p;
  mcP2Counter[519] += p*p;
#define mccompcurname  channel_10_analyzer_2_center
#define mccompcurtype  Arm
#define mccompcurindex 519
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex
  /* Label for restoring  neutron */
  mcabsorbCompchannel_10_analyzer_2_center:
  if (RESTORE) /* restore if needed */
  { RESTORE_NEUTRON(519,
      mcnlx,
      mcnly,
      mcnlz,
      mcnlvx,
      mcnlvy,
      mcnlvz,
      mcnlt,
      mcnlsx,
      mcnlsy,
      mcnlsz,
      mcnlp); }
#undef mcabsorbComp
#undef p
#undef sz
#undef sy
#undef sx
#undef t
#undef vz
#undef vy
#undef vx
#undef z
#undef y
#undef x
  mcDEBUG_STATE(
mcnlx,
mcnly,
mcnlz,
mcnlvx,
mcnlvy,
mcnlvz,
mcnlt,
mcnlsx,
mcnlsy,
mcnlsz,
mcnlp)

  /* TRACE Component channel_10_analyzer_2_rotated [520] */
  mccoordschange(mcposrchannel_10_analyzer_2_rotated, mcrotrchannel_10_analyzer_2_rotated,
    &mcnlx,
    &mcnly,
    &mcnlz,
    &mcnlvx,
    &mcnlvy,
    &mcnlvz,
    &mcnlsx,
    &mcnlsy,
    &mcnlsz);
  /* define label inside component channel_10_analyzer_2_rotated (without coords transformations) */
  mcJumpTrace_channel_10_analyzer_2_rotated:
  SIG_MESSAGE("channel_10_analyzer_2_rotated (Trace)");
  mcDEBUG_COMP("channel_10_analyzer_2_rotated")
  mcDEBUG_STATE(
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp)
#define x mcnlx
#define y mcnly
#define z mcnlz
#define vx mcnlvx
#define vy mcnlvy
#define vz mcnlvz
#define t mcnlt
#define sx mcnlsx
#define sy mcnlsy
#define sz mcnlsz
#define p mcnlp

#define mcabsorbComp mcabsorbCompchannel_10_analyzer_2_rotated
  STORE_NEUTRON(520,
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp);
  mcScattered=0;
  mcRestore=0;
  mcNCounter[520]++;
  mcPCounter[520] += p;
  mcP2Counter[520] += p*p;
#define mccompcurname  channel_10_analyzer_2_rotated
#define mccompcurtype  Arm
#define mccompcurindex 520
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex
  /* Label for restoring  neutron */
  mcabsorbCompchannel_10_analyzer_2_rotated:
  if (RESTORE) /* restore if needed */
  { RESTORE_NEUTRON(520,
      mcnlx,
      mcnly,
      mcnlz,
      mcnlvx,
      mcnlvy,
      mcnlvz,
      mcnlt,
      mcnlsx,
      mcnlsy,
      mcnlsz,
      mcnlp); }
#undef mcabsorbComp
#undef p
#undef sz
#undef sy
#undef sx
#undef t
#undef vz
#undef vy
#undef vx
#undef z
#undef y
#undef x
  mcDEBUG_STATE(
mcnlx,
mcnly,
mcnlz,
mcnlvx,
mcnlvy,
mcnlvz,
mcnlt,
mcnlsx,
mcnlsy,
mcnlsz,
mcnlp)

  /* TRACE Component channel_10_analyzer_2_array_crystal_array_0 [521] */
  mccoordschange(mcposrchannel_10_analyzer_2_array_crystal_array_0, mcrotrchannel_10_analyzer_2_array_crystal_array_0,
    &mcnlx,
    &mcnly,
    &mcnlz,
    &mcnlvx,
    &mcnlvy,
    &mcnlvz,
    &mcnlsx,
    &mcnlsy,
    &mcnlsz);
  /* define label inside component channel_10_analyzer_2_array_crystal_array_0 (without coords transformations) */
  mcJumpTrace_channel_10_analyzer_2_array_crystal_array_0:
  SIG_MESSAGE("channel_10_analyzer_2_array_crystal_array_0 (Trace)");
  mcDEBUG_COMP("channel_10_analyzer_2_array_crystal_array_0")
  mcDEBUG_STATE(
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp)
#define x mcnlx
#define y mcnly
#define z mcnlz
#define vx mcnlvx
#define vy mcnlvy
#define vz mcnlvz
#define t mcnlt
#define sx mcnlsx
#define sy mcnlsy
#define sz mcnlsz
#define p mcnlp

#define mcabsorbComp mcabsorbCompchannel_10_analyzer_2_array_crystal_array_0
  STORE_NEUTRON(521,
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp);
  mcScattered=0;
  mcRestore=0;
  mcNCounter[521]++;
  mcPCounter[521] += p;
  mcP2Counter[521] += p*p;
#define mccompcurname  channel_10_analyzer_2_array_crystal_array_0
#define mccompcurtype  Union_box
#define mccompcurindex 521
#define loop_index mccchannel_10_analyzer_2_array_crystal_array_0_loop_index
#define this_box_volume mccchannel_10_analyzer_2_array_crystal_array_0_this_box_volume
#define global_geometry_element mccchannel_10_analyzer_2_array_crystal_array_0_global_geometry_element
#define this_box_storage mccchannel_10_analyzer_2_array_crystal_array_0_this_box_storage
{   /* Declarations of channel_10_analyzer_2_array_crystal_array_0=Union_box() SETTING parameters. */
char* material_string = mccchannel_10_analyzer_2_array_crystal_array_0_material_string;
MCNUM priority = mccchannel_10_analyzer_2_array_crystal_array_0_priority;
MCNUM xwidth = mccchannel_10_analyzer_2_array_crystal_array_0_xwidth;
MCNUM yheight = mccchannel_10_analyzer_2_array_crystal_array_0_yheight;
MCNUM zdepth = mccchannel_10_analyzer_2_array_crystal_array_0_zdepth;
MCNUM xwidth2 = mccchannel_10_analyzer_2_array_crystal_array_0_xwidth2;
MCNUM yheight2 = mccchannel_10_analyzer_2_array_crystal_array_0_yheight2;
MCNUM visualize = mccchannel_10_analyzer_2_array_crystal_array_0_visualize;
int target_index = mccchannel_10_analyzer_2_array_crystal_array_0_target_index;
MCNUM target_x = mccchannel_10_analyzer_2_array_crystal_array_0_target_x;
MCNUM target_y = mccchannel_10_analyzer_2_array_crystal_array_0_target_y;
MCNUM target_z = mccchannel_10_analyzer_2_array_crystal_array_0_target_z;
MCNUM focus_aw = mccchannel_10_analyzer_2_array_crystal_array_0_focus_aw;
MCNUM focus_ah = mccchannel_10_analyzer_2_array_crystal_array_0_focus_ah;
MCNUM focus_xw = mccchannel_10_analyzer_2_array_crystal_array_0_focus_xw;
MCNUM focus_xh = mccchannel_10_analyzer_2_array_crystal_array_0_focus_xh;
MCNUM focus_r = mccchannel_10_analyzer_2_array_crystal_array_0_focus_r;
MCNUM p_interact = mccchannel_10_analyzer_2_array_crystal_array_0_p_interact;
char* mask_string = mccchannel_10_analyzer_2_array_crystal_array_0_mask_string;
char* mask_setting = mccchannel_10_analyzer_2_array_crystal_array_0_mask_setting;
MCNUM number_of_activations = mccchannel_10_analyzer_2_array_crystal_array_0_number_of_activations;
}   /* End of channel_10_analyzer_2_array_crystal_array_0=Union_box() SETTING parameter declarations. */
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex
  /* Label for restoring  neutron */
  mcabsorbCompchannel_10_analyzer_2_array_crystal_array_0:
  if (RESTORE) /* restore if needed */
  { RESTORE_NEUTRON(521,
      mcnlx,
      mcnly,
      mcnlz,
      mcnlvx,
      mcnlvy,
      mcnlvz,
      mcnlt,
      mcnlsx,
      mcnlsy,
      mcnlsz,
      mcnlp); }
#undef mcabsorbComp
#undef p
#undef sz
#undef sy
#undef sx
#undef t
#undef vz
#undef vy
#undef vx
#undef z
#undef y
#undef x
  mcDEBUG_STATE(
mcnlx,
mcnly,
mcnlz,
mcnlvx,
mcnlvy,
mcnlvz,
mcnlt,
mcnlsx,
mcnlsy,
mcnlsz,
mcnlp)

  /* TRACE Component channel_10_analyzer_2_array_crystal_array_1 [522] */
  mccoordschange(mcposrchannel_10_analyzer_2_array_crystal_array_1, mcrotrchannel_10_analyzer_2_array_crystal_array_1,
    &mcnlx,
    &mcnly,
    &mcnlz,
    &mcnlvx,
    &mcnlvy,
    &mcnlvz,
    &mcnlsx,
    &mcnlsy,
    &mcnlsz);
  /* define label inside component channel_10_analyzer_2_array_crystal_array_1 (without coords transformations) */
  mcJumpTrace_channel_10_analyzer_2_array_crystal_array_1:
  SIG_MESSAGE("channel_10_analyzer_2_array_crystal_array_1 (Trace)");
  mcDEBUG_COMP("channel_10_analyzer_2_array_crystal_array_1")
  mcDEBUG_STATE(
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp)
#define x mcnlx
#define y mcnly
#define z mcnlz
#define vx mcnlvx
#define vy mcnlvy
#define vz mcnlvz
#define t mcnlt
#define sx mcnlsx
#define sy mcnlsy
#define sz mcnlsz
#define p mcnlp

#define mcabsorbComp mcabsorbCompchannel_10_analyzer_2_array_crystal_array_1
  STORE_NEUTRON(522,
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp);
  mcScattered=0;
  mcRestore=0;
  mcNCounter[522]++;
  mcPCounter[522] += p;
  mcP2Counter[522] += p*p;
#define mccompcurname  channel_10_analyzer_2_array_crystal_array_1
#define mccompcurtype  Union_box
#define mccompcurindex 522
#define loop_index mccchannel_10_analyzer_2_array_crystal_array_1_loop_index
#define this_box_volume mccchannel_10_analyzer_2_array_crystal_array_1_this_box_volume
#define global_geometry_element mccchannel_10_analyzer_2_array_crystal_array_1_global_geometry_element
#define this_box_storage mccchannel_10_analyzer_2_array_crystal_array_1_this_box_storage
{   /* Declarations of channel_10_analyzer_2_array_crystal_array_1=Union_box() SETTING parameters. */
char* material_string = mccchannel_10_analyzer_2_array_crystal_array_1_material_string;
MCNUM priority = mccchannel_10_analyzer_2_array_crystal_array_1_priority;
MCNUM xwidth = mccchannel_10_analyzer_2_array_crystal_array_1_xwidth;
MCNUM yheight = mccchannel_10_analyzer_2_array_crystal_array_1_yheight;
MCNUM zdepth = mccchannel_10_analyzer_2_array_crystal_array_1_zdepth;
MCNUM xwidth2 = mccchannel_10_analyzer_2_array_crystal_array_1_xwidth2;
MCNUM yheight2 = mccchannel_10_analyzer_2_array_crystal_array_1_yheight2;
MCNUM visualize = mccchannel_10_analyzer_2_array_crystal_array_1_visualize;
int target_index = mccchannel_10_analyzer_2_array_crystal_array_1_target_index;
MCNUM target_x = mccchannel_10_analyzer_2_array_crystal_array_1_target_x;
MCNUM target_y = mccchannel_10_analyzer_2_array_crystal_array_1_target_y;
MCNUM target_z = mccchannel_10_analyzer_2_array_crystal_array_1_target_z;
MCNUM focus_aw = mccchannel_10_analyzer_2_array_crystal_array_1_focus_aw;
MCNUM focus_ah = mccchannel_10_analyzer_2_array_crystal_array_1_focus_ah;
MCNUM focus_xw = mccchannel_10_analyzer_2_array_crystal_array_1_focus_xw;
MCNUM focus_xh = mccchannel_10_analyzer_2_array_crystal_array_1_focus_xh;
MCNUM focus_r = mccchannel_10_analyzer_2_array_crystal_array_1_focus_r;
MCNUM p_interact = mccchannel_10_analyzer_2_array_crystal_array_1_p_interact;
char* mask_string = mccchannel_10_analyzer_2_array_crystal_array_1_mask_string;
char* mask_setting = mccchannel_10_analyzer_2_array_crystal_array_1_mask_setting;
MCNUM number_of_activations = mccchannel_10_analyzer_2_array_crystal_array_1_number_of_activations;
}   /* End of channel_10_analyzer_2_array_crystal_array_1=Union_box() SETTING parameter declarations. */
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex
  /* Label for restoring  neutron */
  mcabsorbCompchannel_10_analyzer_2_array_crystal_array_1:
  if (RESTORE) /* restore if needed */
  { RESTORE_NEUTRON(522,
      mcnlx,
      mcnly,
      mcnlz,
      mcnlvx,
      mcnlvy,
      mcnlvz,
      mcnlt,
      mcnlsx,
      mcnlsy,
      mcnlsz,
      mcnlp); }
#undef mcabsorbComp
#undef p
#undef sz
#undef sy
#undef sx
#undef t
#undef vz
#undef vy
#undef vx
#undef z
#undef y
#undef x
  mcDEBUG_STATE(
mcnlx,
mcnly,
mcnlz,
mcnlvx,
mcnlvy,
mcnlvz,
mcnlt,
mcnlsx,
mcnlsy,
mcnlsz,
mcnlp)

  /* TRACE Component channel_10_analyzer_2_array_crystal_array_2 [523] */
  mccoordschange(mcposrchannel_10_analyzer_2_array_crystal_array_2, mcrotrchannel_10_analyzer_2_array_crystal_array_2,
    &mcnlx,
    &mcnly,
    &mcnlz,
    &mcnlvx,
    &mcnlvy,
    &mcnlvz,
    &mcnlsx,
    &mcnlsy,
    &mcnlsz);
  /* define label inside component channel_10_analyzer_2_array_crystal_array_2 (without coords transformations) */
  mcJumpTrace_channel_10_analyzer_2_array_crystal_array_2:
  SIG_MESSAGE("channel_10_analyzer_2_array_crystal_array_2 (Trace)");
  mcDEBUG_COMP("channel_10_analyzer_2_array_crystal_array_2")
  mcDEBUG_STATE(
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp)
#define x mcnlx
#define y mcnly
#define z mcnlz
#define vx mcnlvx
#define vy mcnlvy
#define vz mcnlvz
#define t mcnlt
#define sx mcnlsx
#define sy mcnlsy
#define sz mcnlsz
#define p mcnlp

#define mcabsorbComp mcabsorbCompchannel_10_analyzer_2_array_crystal_array_2
  STORE_NEUTRON(523,
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp);
  mcScattered=0;
  mcRestore=0;
  mcNCounter[523]++;
  mcPCounter[523] += p;
  mcP2Counter[523] += p*p;
#define mccompcurname  channel_10_analyzer_2_array_crystal_array_2
#define mccompcurtype  Union_box
#define mccompcurindex 523
#define loop_index mccchannel_10_analyzer_2_array_crystal_array_2_loop_index
#define this_box_volume mccchannel_10_analyzer_2_array_crystal_array_2_this_box_volume
#define global_geometry_element mccchannel_10_analyzer_2_array_crystal_array_2_global_geometry_element
#define this_box_storage mccchannel_10_analyzer_2_array_crystal_array_2_this_box_storage
{   /* Declarations of channel_10_analyzer_2_array_crystal_array_2=Union_box() SETTING parameters. */
char* material_string = mccchannel_10_analyzer_2_array_crystal_array_2_material_string;
MCNUM priority = mccchannel_10_analyzer_2_array_crystal_array_2_priority;
MCNUM xwidth = mccchannel_10_analyzer_2_array_crystal_array_2_xwidth;
MCNUM yheight = mccchannel_10_analyzer_2_array_crystal_array_2_yheight;
MCNUM zdepth = mccchannel_10_analyzer_2_array_crystal_array_2_zdepth;
MCNUM xwidth2 = mccchannel_10_analyzer_2_array_crystal_array_2_xwidth2;
MCNUM yheight2 = mccchannel_10_analyzer_2_array_crystal_array_2_yheight2;
MCNUM visualize = mccchannel_10_analyzer_2_array_crystal_array_2_visualize;
int target_index = mccchannel_10_analyzer_2_array_crystal_array_2_target_index;
MCNUM target_x = mccchannel_10_analyzer_2_array_crystal_array_2_target_x;
MCNUM target_y = mccchannel_10_analyzer_2_array_crystal_array_2_target_y;
MCNUM target_z = mccchannel_10_analyzer_2_array_crystal_array_2_target_z;
MCNUM focus_aw = mccchannel_10_analyzer_2_array_crystal_array_2_focus_aw;
MCNUM focus_ah = mccchannel_10_analyzer_2_array_crystal_array_2_focus_ah;
MCNUM focus_xw = mccchannel_10_analyzer_2_array_crystal_array_2_focus_xw;
MCNUM focus_xh = mccchannel_10_analyzer_2_array_crystal_array_2_focus_xh;
MCNUM focus_r = mccchannel_10_analyzer_2_array_crystal_array_2_focus_r;
MCNUM p_interact = mccchannel_10_analyzer_2_array_crystal_array_2_p_interact;
char* mask_string = mccchannel_10_analyzer_2_array_crystal_array_2_mask_string;
char* mask_setting = mccchannel_10_analyzer_2_array_crystal_array_2_mask_setting;
MCNUM number_of_activations = mccchannel_10_analyzer_2_array_crystal_array_2_number_of_activations;
}   /* End of channel_10_analyzer_2_array_crystal_array_2=Union_box() SETTING parameter declarations. */
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex
  /* Label for restoring  neutron */
  mcabsorbCompchannel_10_analyzer_2_array_crystal_array_2:
  if (RESTORE) /* restore if needed */
  { RESTORE_NEUTRON(523,
      mcnlx,
      mcnly,
      mcnlz,
      mcnlvx,
      mcnlvy,
      mcnlvz,
      mcnlt,
      mcnlsx,
      mcnlsy,
      mcnlsz,
      mcnlp); }
#undef mcabsorbComp
#undef p
#undef sz
#undef sy
#undef sx
#undef t
#undef vz
#undef vy
#undef vx
#undef z
#undef y
#undef x
  mcDEBUG_STATE(
mcnlx,
mcnly,
mcnlz,
mcnlvx,
mcnlvy,
mcnlvz,
mcnlt,
mcnlsx,
mcnlsy,
mcnlsz,
mcnlp)

  /* TRACE Component channel_10_analyzer_2_array_crystal_array_3 [524] */
  mccoordschange(mcposrchannel_10_analyzer_2_array_crystal_array_3, mcrotrchannel_10_analyzer_2_array_crystal_array_3,
    &mcnlx,
    &mcnly,
    &mcnlz,
    &mcnlvx,
    &mcnlvy,
    &mcnlvz,
    &mcnlsx,
    &mcnlsy,
    &mcnlsz);
  /* define label inside component channel_10_analyzer_2_array_crystal_array_3 (without coords transformations) */
  mcJumpTrace_channel_10_analyzer_2_array_crystal_array_3:
  SIG_MESSAGE("channel_10_analyzer_2_array_crystal_array_3 (Trace)");
  mcDEBUG_COMP("channel_10_analyzer_2_array_crystal_array_3")
  mcDEBUG_STATE(
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp)
#define x mcnlx
#define y mcnly
#define z mcnlz
#define vx mcnlvx
#define vy mcnlvy
#define vz mcnlvz
#define t mcnlt
#define sx mcnlsx
#define sy mcnlsy
#define sz mcnlsz
#define p mcnlp

#define mcabsorbComp mcabsorbCompchannel_10_analyzer_2_array_crystal_array_3
  STORE_NEUTRON(524,
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp);
  mcScattered=0;
  mcRestore=0;
  mcNCounter[524]++;
  mcPCounter[524] += p;
  mcP2Counter[524] += p*p;
#define mccompcurname  channel_10_analyzer_2_array_crystal_array_3
#define mccompcurtype  Union_box
#define mccompcurindex 524
#define loop_index mccchannel_10_analyzer_2_array_crystal_array_3_loop_index
#define this_box_volume mccchannel_10_analyzer_2_array_crystal_array_3_this_box_volume
#define global_geometry_element mccchannel_10_analyzer_2_array_crystal_array_3_global_geometry_element
#define this_box_storage mccchannel_10_analyzer_2_array_crystal_array_3_this_box_storage
{   /* Declarations of channel_10_analyzer_2_array_crystal_array_3=Union_box() SETTING parameters. */
char* material_string = mccchannel_10_analyzer_2_array_crystal_array_3_material_string;
MCNUM priority = mccchannel_10_analyzer_2_array_crystal_array_3_priority;
MCNUM xwidth = mccchannel_10_analyzer_2_array_crystal_array_3_xwidth;
MCNUM yheight = mccchannel_10_analyzer_2_array_crystal_array_3_yheight;
MCNUM zdepth = mccchannel_10_analyzer_2_array_crystal_array_3_zdepth;
MCNUM xwidth2 = mccchannel_10_analyzer_2_array_crystal_array_3_xwidth2;
MCNUM yheight2 = mccchannel_10_analyzer_2_array_crystal_array_3_yheight2;
MCNUM visualize = mccchannel_10_analyzer_2_array_crystal_array_3_visualize;
int target_index = mccchannel_10_analyzer_2_array_crystal_array_3_target_index;
MCNUM target_x = mccchannel_10_analyzer_2_array_crystal_array_3_target_x;
MCNUM target_y = mccchannel_10_analyzer_2_array_crystal_array_3_target_y;
MCNUM target_z = mccchannel_10_analyzer_2_array_crystal_array_3_target_z;
MCNUM focus_aw = mccchannel_10_analyzer_2_array_crystal_array_3_focus_aw;
MCNUM focus_ah = mccchannel_10_analyzer_2_array_crystal_array_3_focus_ah;
MCNUM focus_xw = mccchannel_10_analyzer_2_array_crystal_array_3_focus_xw;
MCNUM focus_xh = mccchannel_10_analyzer_2_array_crystal_array_3_focus_xh;
MCNUM focus_r = mccchannel_10_analyzer_2_array_crystal_array_3_focus_r;
MCNUM p_interact = mccchannel_10_analyzer_2_array_crystal_array_3_p_interact;
char* mask_string = mccchannel_10_analyzer_2_array_crystal_array_3_mask_string;
char* mask_setting = mccchannel_10_analyzer_2_array_crystal_array_3_mask_setting;
MCNUM number_of_activations = mccchannel_10_analyzer_2_array_crystal_array_3_number_of_activations;
}   /* End of channel_10_analyzer_2_array_crystal_array_3=Union_box() SETTING parameter declarations. */
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex
  /* Label for restoring  neutron */
  mcabsorbCompchannel_10_analyzer_2_array_crystal_array_3:
  if (RESTORE) /* restore if needed */
  { RESTORE_NEUTRON(524,
      mcnlx,
      mcnly,
      mcnlz,
      mcnlvx,
      mcnlvy,
      mcnlvz,
      mcnlt,
      mcnlsx,
      mcnlsy,
      mcnlsz,
      mcnlp); }
#undef mcabsorbComp
#undef p
#undef sz
#undef sy
#undef sx
#undef t
#undef vz
#undef vy
#undef vx
#undef z
#undef y
#undef x
  mcDEBUG_STATE(
mcnlx,
mcnly,
mcnlz,
mcnlvx,
mcnlvy,
mcnlvz,
mcnlt,
mcnlsx,
mcnlsy,
mcnlsz,
mcnlp)

  /* TRACE Component channel_10_analyzer_2_array_crystal_array_4 [525] */
  mccoordschange(mcposrchannel_10_analyzer_2_array_crystal_array_4, mcrotrchannel_10_analyzer_2_array_crystal_array_4,
    &mcnlx,
    &mcnly,
    &mcnlz,
    &mcnlvx,
    &mcnlvy,
    &mcnlvz,
    &mcnlsx,
    &mcnlsy,
    &mcnlsz);
  /* define label inside component channel_10_analyzer_2_array_crystal_array_4 (without coords transformations) */
  mcJumpTrace_channel_10_analyzer_2_array_crystal_array_4:
  SIG_MESSAGE("channel_10_analyzer_2_array_crystal_array_4 (Trace)");
  mcDEBUG_COMP("channel_10_analyzer_2_array_crystal_array_4")
  mcDEBUG_STATE(
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp)
#define x mcnlx
#define y mcnly
#define z mcnlz
#define vx mcnlvx
#define vy mcnlvy
#define vz mcnlvz
#define t mcnlt
#define sx mcnlsx
#define sy mcnlsy
#define sz mcnlsz
#define p mcnlp

#define mcabsorbComp mcabsorbCompchannel_10_analyzer_2_array_crystal_array_4
  STORE_NEUTRON(525,
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp);
  mcScattered=0;
  mcRestore=0;
  mcNCounter[525]++;
  mcPCounter[525] += p;
  mcP2Counter[525] += p*p;
#define mccompcurname  channel_10_analyzer_2_array_crystal_array_4
#define mccompcurtype  Union_box
#define mccompcurindex 525
#define loop_index mccchannel_10_analyzer_2_array_crystal_array_4_loop_index
#define this_box_volume mccchannel_10_analyzer_2_array_crystal_array_4_this_box_volume
#define global_geometry_element mccchannel_10_analyzer_2_array_crystal_array_4_global_geometry_element
#define this_box_storage mccchannel_10_analyzer_2_array_crystal_array_4_this_box_storage
{   /* Declarations of channel_10_analyzer_2_array_crystal_array_4=Union_box() SETTING parameters. */
char* material_string = mccchannel_10_analyzer_2_array_crystal_array_4_material_string;
MCNUM priority = mccchannel_10_analyzer_2_array_crystal_array_4_priority;
MCNUM xwidth = mccchannel_10_analyzer_2_array_crystal_array_4_xwidth;
MCNUM yheight = mccchannel_10_analyzer_2_array_crystal_array_4_yheight;
MCNUM zdepth = mccchannel_10_analyzer_2_array_crystal_array_4_zdepth;
MCNUM xwidth2 = mccchannel_10_analyzer_2_array_crystal_array_4_xwidth2;
MCNUM yheight2 = mccchannel_10_analyzer_2_array_crystal_array_4_yheight2;
MCNUM visualize = mccchannel_10_analyzer_2_array_crystal_array_4_visualize;
int target_index = mccchannel_10_analyzer_2_array_crystal_array_4_target_index;
MCNUM target_x = mccchannel_10_analyzer_2_array_crystal_array_4_target_x;
MCNUM target_y = mccchannel_10_analyzer_2_array_crystal_array_4_target_y;
MCNUM target_z = mccchannel_10_analyzer_2_array_crystal_array_4_target_z;
MCNUM focus_aw = mccchannel_10_analyzer_2_array_crystal_array_4_focus_aw;
MCNUM focus_ah = mccchannel_10_analyzer_2_array_crystal_array_4_focus_ah;
MCNUM focus_xw = mccchannel_10_analyzer_2_array_crystal_array_4_focus_xw;
MCNUM focus_xh = mccchannel_10_analyzer_2_array_crystal_array_4_focus_xh;
MCNUM focus_r = mccchannel_10_analyzer_2_array_crystal_array_4_focus_r;
MCNUM p_interact = mccchannel_10_analyzer_2_array_crystal_array_4_p_interact;
char* mask_string = mccchannel_10_analyzer_2_array_crystal_array_4_mask_string;
char* mask_setting = mccchannel_10_analyzer_2_array_crystal_array_4_mask_setting;
MCNUM number_of_activations = mccchannel_10_analyzer_2_array_crystal_array_4_number_of_activations;
}   /* End of channel_10_analyzer_2_array_crystal_array_4=Union_box() SETTING parameter declarations. */
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex
  /* Label for restoring  neutron */
  mcabsorbCompchannel_10_analyzer_2_array_crystal_array_4:
  if (RESTORE) /* restore if needed */
  { RESTORE_NEUTRON(525,
      mcnlx,
      mcnly,
      mcnlz,
      mcnlvx,
      mcnlvy,
      mcnlvz,
      mcnlt,
      mcnlsx,
      mcnlsy,
      mcnlsz,
      mcnlp); }
#undef mcabsorbComp
#undef p
#undef sz
#undef sy
#undef sx
#undef t
#undef vz
#undef vy
#undef vx
#undef z
#undef y
#undef x
  mcDEBUG_STATE(
mcnlx,
mcnly,
mcnlz,
mcnlvx,
mcnlvy,
mcnlvz,
mcnlt,
mcnlsx,
mcnlsy,
mcnlsz,
mcnlp)

  /* TRACE Component channel_10_analyzer_2_array_crystal_array_5 [526] */
  mccoordschange(mcposrchannel_10_analyzer_2_array_crystal_array_5, mcrotrchannel_10_analyzer_2_array_crystal_array_5,
    &mcnlx,
    &mcnly,
    &mcnlz,
    &mcnlvx,
    &mcnlvy,
    &mcnlvz,
    &mcnlsx,
    &mcnlsy,
    &mcnlsz);
  /* define label inside component channel_10_analyzer_2_array_crystal_array_5 (without coords transformations) */
  mcJumpTrace_channel_10_analyzer_2_array_crystal_array_5:
  SIG_MESSAGE("channel_10_analyzer_2_array_crystal_array_5 (Trace)");
  mcDEBUG_COMP("channel_10_analyzer_2_array_crystal_array_5")
  mcDEBUG_STATE(
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp)
#define x mcnlx
#define y mcnly
#define z mcnlz
#define vx mcnlvx
#define vy mcnlvy
#define vz mcnlvz
#define t mcnlt
#define sx mcnlsx
#define sy mcnlsy
#define sz mcnlsz
#define p mcnlp

#define mcabsorbComp mcabsorbCompchannel_10_analyzer_2_array_crystal_array_5
  STORE_NEUTRON(526,
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp);
  mcScattered=0;
  mcRestore=0;
  mcNCounter[526]++;
  mcPCounter[526] += p;
  mcP2Counter[526] += p*p;
#define mccompcurname  channel_10_analyzer_2_array_crystal_array_5
#define mccompcurtype  Union_box
#define mccompcurindex 526
#define loop_index mccchannel_10_analyzer_2_array_crystal_array_5_loop_index
#define this_box_volume mccchannel_10_analyzer_2_array_crystal_array_5_this_box_volume
#define global_geometry_element mccchannel_10_analyzer_2_array_crystal_array_5_global_geometry_element
#define this_box_storage mccchannel_10_analyzer_2_array_crystal_array_5_this_box_storage
{   /* Declarations of channel_10_analyzer_2_array_crystal_array_5=Union_box() SETTING parameters. */
char* material_string = mccchannel_10_analyzer_2_array_crystal_array_5_material_string;
MCNUM priority = mccchannel_10_analyzer_2_array_crystal_array_5_priority;
MCNUM xwidth = mccchannel_10_analyzer_2_array_crystal_array_5_xwidth;
MCNUM yheight = mccchannel_10_analyzer_2_array_crystal_array_5_yheight;
MCNUM zdepth = mccchannel_10_analyzer_2_array_crystal_array_5_zdepth;
MCNUM xwidth2 = mccchannel_10_analyzer_2_array_crystal_array_5_xwidth2;
MCNUM yheight2 = mccchannel_10_analyzer_2_array_crystal_array_5_yheight2;
MCNUM visualize = mccchannel_10_analyzer_2_array_crystal_array_5_visualize;
int target_index = mccchannel_10_analyzer_2_array_crystal_array_5_target_index;
MCNUM target_x = mccchannel_10_analyzer_2_array_crystal_array_5_target_x;
MCNUM target_y = mccchannel_10_analyzer_2_array_crystal_array_5_target_y;
MCNUM target_z = mccchannel_10_analyzer_2_array_crystal_array_5_target_z;
MCNUM focus_aw = mccchannel_10_analyzer_2_array_crystal_array_5_focus_aw;
MCNUM focus_ah = mccchannel_10_analyzer_2_array_crystal_array_5_focus_ah;
MCNUM focus_xw = mccchannel_10_analyzer_2_array_crystal_array_5_focus_xw;
MCNUM focus_xh = mccchannel_10_analyzer_2_array_crystal_array_5_focus_xh;
MCNUM focus_r = mccchannel_10_analyzer_2_array_crystal_array_5_focus_r;
MCNUM p_interact = mccchannel_10_analyzer_2_array_crystal_array_5_p_interact;
char* mask_string = mccchannel_10_analyzer_2_array_crystal_array_5_mask_string;
char* mask_setting = mccchannel_10_analyzer_2_array_crystal_array_5_mask_setting;
MCNUM number_of_activations = mccchannel_10_analyzer_2_array_crystal_array_5_number_of_activations;
}   /* End of channel_10_analyzer_2_array_crystal_array_5=Union_box() SETTING parameter declarations. */
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex
  /* Label for restoring  neutron */
  mcabsorbCompchannel_10_analyzer_2_array_crystal_array_5:
  if (RESTORE) /* restore if needed */
  { RESTORE_NEUTRON(526,
      mcnlx,
      mcnly,
      mcnlz,
      mcnlvx,
      mcnlvy,
      mcnlvz,
      mcnlt,
      mcnlsx,
      mcnlsy,
      mcnlsz,
      mcnlp); }
#undef mcabsorbComp
#undef p
#undef sz
#undef sy
#undef sx
#undef t
#undef vz
#undef vy
#undef vx
#undef z
#undef y
#undef x
  mcDEBUG_STATE(
mcnlx,
mcnly,
mcnlz,
mcnlvx,
mcnlvy,
mcnlvz,
mcnlt,
mcnlsx,
mcnlsy,
mcnlsz,
mcnlp)

  /* TRACE Component channel_10_analyzer_2_array_crystal_array_6 [527] */
  mccoordschange(mcposrchannel_10_analyzer_2_array_crystal_array_6, mcrotrchannel_10_analyzer_2_array_crystal_array_6,
    &mcnlx,
    &mcnly,
    &mcnlz,
    &mcnlvx,
    &mcnlvy,
    &mcnlvz,
    &mcnlsx,
    &mcnlsy,
    &mcnlsz);
  /* define label inside component channel_10_analyzer_2_array_crystal_array_6 (without coords transformations) */
  mcJumpTrace_channel_10_analyzer_2_array_crystal_array_6:
  SIG_MESSAGE("channel_10_analyzer_2_array_crystal_array_6 (Trace)");
  mcDEBUG_COMP("channel_10_analyzer_2_array_crystal_array_6")
  mcDEBUG_STATE(
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp)
#define x mcnlx
#define y mcnly
#define z mcnlz
#define vx mcnlvx
#define vy mcnlvy
#define vz mcnlvz
#define t mcnlt
#define sx mcnlsx
#define sy mcnlsy
#define sz mcnlsz
#define p mcnlp

#define mcabsorbComp mcabsorbCompchannel_10_analyzer_2_array_crystal_array_6
  STORE_NEUTRON(527,
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp);
  mcScattered=0;
  mcRestore=0;
  mcNCounter[527]++;
  mcPCounter[527] += p;
  mcP2Counter[527] += p*p;
#define mccompcurname  channel_10_analyzer_2_array_crystal_array_6
#define mccompcurtype  Union_box
#define mccompcurindex 527
#define loop_index mccchannel_10_analyzer_2_array_crystal_array_6_loop_index
#define this_box_volume mccchannel_10_analyzer_2_array_crystal_array_6_this_box_volume
#define global_geometry_element mccchannel_10_analyzer_2_array_crystal_array_6_global_geometry_element
#define this_box_storage mccchannel_10_analyzer_2_array_crystal_array_6_this_box_storage
{   /* Declarations of channel_10_analyzer_2_array_crystal_array_6=Union_box() SETTING parameters. */
char* material_string = mccchannel_10_analyzer_2_array_crystal_array_6_material_string;
MCNUM priority = mccchannel_10_analyzer_2_array_crystal_array_6_priority;
MCNUM xwidth = mccchannel_10_analyzer_2_array_crystal_array_6_xwidth;
MCNUM yheight = mccchannel_10_analyzer_2_array_crystal_array_6_yheight;
MCNUM zdepth = mccchannel_10_analyzer_2_array_crystal_array_6_zdepth;
MCNUM xwidth2 = mccchannel_10_analyzer_2_array_crystal_array_6_xwidth2;
MCNUM yheight2 = mccchannel_10_analyzer_2_array_crystal_array_6_yheight2;
MCNUM visualize = mccchannel_10_analyzer_2_array_crystal_array_6_visualize;
int target_index = mccchannel_10_analyzer_2_array_crystal_array_6_target_index;
MCNUM target_x = mccchannel_10_analyzer_2_array_crystal_array_6_target_x;
MCNUM target_y = mccchannel_10_analyzer_2_array_crystal_array_6_target_y;
MCNUM target_z = mccchannel_10_analyzer_2_array_crystal_array_6_target_z;
MCNUM focus_aw = mccchannel_10_analyzer_2_array_crystal_array_6_focus_aw;
MCNUM focus_ah = mccchannel_10_analyzer_2_array_crystal_array_6_focus_ah;
MCNUM focus_xw = mccchannel_10_analyzer_2_array_crystal_array_6_focus_xw;
MCNUM focus_xh = mccchannel_10_analyzer_2_array_crystal_array_6_focus_xh;
MCNUM focus_r = mccchannel_10_analyzer_2_array_crystal_array_6_focus_r;
MCNUM p_interact = mccchannel_10_analyzer_2_array_crystal_array_6_p_interact;
char* mask_string = mccchannel_10_analyzer_2_array_crystal_array_6_mask_string;
char* mask_setting = mccchannel_10_analyzer_2_array_crystal_array_6_mask_setting;
MCNUM number_of_activations = mccchannel_10_analyzer_2_array_crystal_array_6_number_of_activations;
}   /* End of channel_10_analyzer_2_array_crystal_array_6=Union_box() SETTING parameter declarations. */
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex
  /* Label for restoring  neutron */
  mcabsorbCompchannel_10_analyzer_2_array_crystal_array_6:
  if (RESTORE) /* restore if needed */
  { RESTORE_NEUTRON(527,
      mcnlx,
      mcnly,
      mcnlz,
      mcnlvx,
      mcnlvy,
      mcnlvz,
      mcnlt,
      mcnlsx,
      mcnlsy,
      mcnlsz,
      mcnlp); }
#undef mcabsorbComp
#undef p
#undef sz
#undef sy
#undef sx
#undef t
#undef vz
#undef vy
#undef vx
#undef z
#undef y
#undef x
  mcDEBUG_STATE(
mcnlx,
mcnly,
mcnlz,
mcnlvx,
mcnlvy,
mcnlvz,
mcnlt,
mcnlsx,
mcnlsy,
mcnlsz,
mcnlp)

  /* TRACE Component channel_10_analyzer_2_array_crystal_array_7 [528] */
  mccoordschange(mcposrchannel_10_analyzer_2_array_crystal_array_7, mcrotrchannel_10_analyzer_2_array_crystal_array_7,
    &mcnlx,
    &mcnly,
    &mcnlz,
    &mcnlvx,
    &mcnlvy,
    &mcnlvz,
    &mcnlsx,
    &mcnlsy,
    &mcnlsz);
  /* define label inside component channel_10_analyzer_2_array_crystal_array_7 (without coords transformations) */
  mcJumpTrace_channel_10_analyzer_2_array_crystal_array_7:
  SIG_MESSAGE("channel_10_analyzer_2_array_crystal_array_7 (Trace)");
  mcDEBUG_COMP("channel_10_analyzer_2_array_crystal_array_7")
  mcDEBUG_STATE(
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp)
#define x mcnlx
#define y mcnly
#define z mcnlz
#define vx mcnlvx
#define vy mcnlvy
#define vz mcnlvz
#define t mcnlt
#define sx mcnlsx
#define sy mcnlsy
#define sz mcnlsz
#define p mcnlp

#define mcabsorbComp mcabsorbCompchannel_10_analyzer_2_array_crystal_array_7
  STORE_NEUTRON(528,
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp);
  mcScattered=0;
  mcRestore=0;
  mcNCounter[528]++;
  mcPCounter[528] += p;
  mcP2Counter[528] += p*p;
#define mccompcurname  channel_10_analyzer_2_array_crystal_array_7
#define mccompcurtype  Union_box
#define mccompcurindex 528
#define loop_index mccchannel_10_analyzer_2_array_crystal_array_7_loop_index
#define this_box_volume mccchannel_10_analyzer_2_array_crystal_array_7_this_box_volume
#define global_geometry_element mccchannel_10_analyzer_2_array_crystal_array_7_global_geometry_element
#define this_box_storage mccchannel_10_analyzer_2_array_crystal_array_7_this_box_storage
{   /* Declarations of channel_10_analyzer_2_array_crystal_array_7=Union_box() SETTING parameters. */
char* material_string = mccchannel_10_analyzer_2_array_crystal_array_7_material_string;
MCNUM priority = mccchannel_10_analyzer_2_array_crystal_array_7_priority;
MCNUM xwidth = mccchannel_10_analyzer_2_array_crystal_array_7_xwidth;
MCNUM yheight = mccchannel_10_analyzer_2_array_crystal_array_7_yheight;
MCNUM zdepth = mccchannel_10_analyzer_2_array_crystal_array_7_zdepth;
MCNUM xwidth2 = mccchannel_10_analyzer_2_array_crystal_array_7_xwidth2;
MCNUM yheight2 = mccchannel_10_analyzer_2_array_crystal_array_7_yheight2;
MCNUM visualize = mccchannel_10_analyzer_2_array_crystal_array_7_visualize;
int target_index = mccchannel_10_analyzer_2_array_crystal_array_7_target_index;
MCNUM target_x = mccchannel_10_analyzer_2_array_crystal_array_7_target_x;
MCNUM target_y = mccchannel_10_analyzer_2_array_crystal_array_7_target_y;
MCNUM target_z = mccchannel_10_analyzer_2_array_crystal_array_7_target_z;
MCNUM focus_aw = mccchannel_10_analyzer_2_array_crystal_array_7_focus_aw;
MCNUM focus_ah = mccchannel_10_analyzer_2_array_crystal_array_7_focus_ah;
MCNUM focus_xw = mccchannel_10_analyzer_2_array_crystal_array_7_focus_xw;
MCNUM focus_xh = mccchannel_10_analyzer_2_array_crystal_array_7_focus_xh;
MCNUM focus_r = mccchannel_10_analyzer_2_array_crystal_array_7_focus_r;
MCNUM p_interact = mccchannel_10_analyzer_2_array_crystal_array_7_p_interact;
char* mask_string = mccchannel_10_analyzer_2_array_crystal_array_7_mask_string;
char* mask_setting = mccchannel_10_analyzer_2_array_crystal_array_7_mask_setting;
MCNUM number_of_activations = mccchannel_10_analyzer_2_array_crystal_array_7_number_of_activations;
}   /* End of channel_10_analyzer_2_array_crystal_array_7=Union_box() SETTING parameter declarations. */
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex
  /* Label for restoring  neutron */
  mcabsorbCompchannel_10_analyzer_2_array_crystal_array_7:
  if (RESTORE) /* restore if needed */
  { RESTORE_NEUTRON(528,
      mcnlx,
      mcnly,
      mcnlz,
      mcnlvx,
      mcnlvy,
      mcnlvz,
      mcnlt,
      mcnlsx,
      mcnlsy,
      mcnlsz,
      mcnlp); }
#undef mcabsorbComp
#undef p
#undef sz
#undef sy
#undef sx
#undef t
#undef vz
#undef vy
#undef vx
#undef z
#undef y
#undef x
  mcDEBUG_STATE(
mcnlx,
mcnly,
mcnlz,
mcnlvx,
mcnlvy,
mcnlvz,
mcnlt,
mcnlsx,
mcnlsy,
mcnlsz,
mcnlp)

  /* TRACE Component channel_10_analyzer_2_array_crystal_array_8 [529] */
  mccoordschange(mcposrchannel_10_analyzer_2_array_crystal_array_8, mcrotrchannel_10_analyzer_2_array_crystal_array_8,
    &mcnlx,
    &mcnly,
    &mcnlz,
    &mcnlvx,
    &mcnlvy,
    &mcnlvz,
    &mcnlsx,
    &mcnlsy,
    &mcnlsz);
  /* define label inside component channel_10_analyzer_2_array_crystal_array_8 (without coords transformations) */
  mcJumpTrace_channel_10_analyzer_2_array_crystal_array_8:
  SIG_MESSAGE("channel_10_analyzer_2_array_crystal_array_8 (Trace)");
  mcDEBUG_COMP("channel_10_analyzer_2_array_crystal_array_8")
  mcDEBUG_STATE(
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp)
#define x mcnlx
#define y mcnly
#define z mcnlz
#define vx mcnlvx
#define vy mcnlvy
#define vz mcnlvz
#define t mcnlt
#define sx mcnlsx
#define sy mcnlsy
#define sz mcnlsz
#define p mcnlp

#define mcabsorbComp mcabsorbCompchannel_10_analyzer_2_array_crystal_array_8
  STORE_NEUTRON(529,
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp);
  mcScattered=0;
  mcRestore=0;
  mcNCounter[529]++;
  mcPCounter[529] += p;
  mcP2Counter[529] += p*p;
#define mccompcurname  channel_10_analyzer_2_array_crystal_array_8
#define mccompcurtype  Union_box
#define mccompcurindex 529
#define loop_index mccchannel_10_analyzer_2_array_crystal_array_8_loop_index
#define this_box_volume mccchannel_10_analyzer_2_array_crystal_array_8_this_box_volume
#define global_geometry_element mccchannel_10_analyzer_2_array_crystal_array_8_global_geometry_element
#define this_box_storage mccchannel_10_analyzer_2_array_crystal_array_8_this_box_storage
{   /* Declarations of channel_10_analyzer_2_array_crystal_array_8=Union_box() SETTING parameters. */
char* material_string = mccchannel_10_analyzer_2_array_crystal_array_8_material_string;
MCNUM priority = mccchannel_10_analyzer_2_array_crystal_array_8_priority;
MCNUM xwidth = mccchannel_10_analyzer_2_array_crystal_array_8_xwidth;
MCNUM yheight = mccchannel_10_analyzer_2_array_crystal_array_8_yheight;
MCNUM zdepth = mccchannel_10_analyzer_2_array_crystal_array_8_zdepth;
MCNUM xwidth2 = mccchannel_10_analyzer_2_array_crystal_array_8_xwidth2;
MCNUM yheight2 = mccchannel_10_analyzer_2_array_crystal_array_8_yheight2;
MCNUM visualize = mccchannel_10_analyzer_2_array_crystal_array_8_visualize;
int target_index = mccchannel_10_analyzer_2_array_crystal_array_8_target_index;
MCNUM target_x = mccchannel_10_analyzer_2_array_crystal_array_8_target_x;
MCNUM target_y = mccchannel_10_analyzer_2_array_crystal_array_8_target_y;
MCNUM target_z = mccchannel_10_analyzer_2_array_crystal_array_8_target_z;
MCNUM focus_aw = mccchannel_10_analyzer_2_array_crystal_array_8_focus_aw;
MCNUM focus_ah = mccchannel_10_analyzer_2_array_crystal_array_8_focus_ah;
MCNUM focus_xw = mccchannel_10_analyzer_2_array_crystal_array_8_focus_xw;
MCNUM focus_xh = mccchannel_10_analyzer_2_array_crystal_array_8_focus_xh;
MCNUM focus_r = mccchannel_10_analyzer_2_array_crystal_array_8_focus_r;
MCNUM p_interact = mccchannel_10_analyzer_2_array_crystal_array_8_p_interact;
char* mask_string = mccchannel_10_analyzer_2_array_crystal_array_8_mask_string;
char* mask_setting = mccchannel_10_analyzer_2_array_crystal_array_8_mask_setting;
MCNUM number_of_activations = mccchannel_10_analyzer_2_array_crystal_array_8_number_of_activations;
}   /* End of channel_10_analyzer_2_array_crystal_array_8=Union_box() SETTING parameter declarations. */
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex
  /* Label for restoring  neutron */
  mcabsorbCompchannel_10_analyzer_2_array_crystal_array_8:
  if (RESTORE) /* restore if needed */
  { RESTORE_NEUTRON(529,
      mcnlx,
      mcnly,
      mcnlz,
      mcnlvx,
      mcnlvy,
      mcnlvz,
      mcnlt,
      mcnlsx,
      mcnlsy,
      mcnlsz,
      mcnlp); }
#undef mcabsorbComp
#undef p
#undef sz
#undef sy
#undef sx
#undef t
#undef vz
#undef vy
#undef vx
#undef z
#undef y
#undef x
  mcDEBUG_STATE(
mcnlx,
mcnly,
mcnlz,
mcnlvx,
mcnlvy,
mcnlvz,
mcnlt,
mcnlsx,
mcnlsy,
mcnlsz,
mcnlp)

  /* TRACE Component channel_10_cave2_cyl1 [530] */
  mccoordschange(mcposrchannel_10_cave2_cyl1, mcrotrchannel_10_cave2_cyl1,
    &mcnlx,
    &mcnly,
    &mcnlz,
    &mcnlvx,
    &mcnlvy,
    &mcnlvz,
    &mcnlsx,
    &mcnlsy,
    &mcnlsz);
  /* define label inside component channel_10_cave2_cyl1 (without coords transformations) */
  mcJumpTrace_channel_10_cave2_cyl1:
  SIG_MESSAGE("channel_10_cave2_cyl1 (Trace)");
  mcDEBUG_COMP("channel_10_cave2_cyl1")
  mcDEBUG_STATE(
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp)
#define x mcnlx
#define y mcnly
#define z mcnlz
#define vx mcnlvx
#define vy mcnlvy
#define vz mcnlvz
#define t mcnlt
#define sx mcnlsx
#define sy mcnlsy
#define sz mcnlsz
#define p mcnlp

#define mcabsorbComp mcabsorbCompchannel_10_cave2_cyl1
  STORE_NEUTRON(530,
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp);
  mcScattered=0;
  mcRestore=0;
  mcNCounter[530]++;
  mcPCounter[530] += p;
  mcP2Counter[530] += p*p;
#define mccompcurname  channel_10_cave2_cyl1
#define mccompcurtype  Union_cylinder
#define mccompcurindex 530
#define loop_index mccchannel_10_cave2_cyl1_loop_index
#define this_cylinder_volume mccchannel_10_cave2_cyl1_this_cylinder_volume
#define global_geometry_element mccchannel_10_cave2_cyl1_global_geometry_element
#define this_cylinder_storage mccchannel_10_cave2_cyl1_this_cylinder_storage
{   /* Declarations of channel_10_cave2_cyl1=Union_cylinder() SETTING parameters. */
char* material_string = mccchannel_10_cave2_cyl1_material_string;
MCNUM priority = mccchannel_10_cave2_cyl1_priority;
MCNUM radius = mccchannel_10_cave2_cyl1_radius;
MCNUM yheight = mccchannel_10_cave2_cyl1_yheight;
MCNUM visualize = mccchannel_10_cave2_cyl1_visualize;
int target_index = mccchannel_10_cave2_cyl1_target_index;
MCNUM target_x = mccchannel_10_cave2_cyl1_target_x;
MCNUM target_y = mccchannel_10_cave2_cyl1_target_y;
MCNUM target_z = mccchannel_10_cave2_cyl1_target_z;
MCNUM focus_aw = mccchannel_10_cave2_cyl1_focus_aw;
MCNUM focus_ah = mccchannel_10_cave2_cyl1_focus_ah;
MCNUM focus_xw = mccchannel_10_cave2_cyl1_focus_xw;
MCNUM focus_xh = mccchannel_10_cave2_cyl1_focus_xh;
MCNUM focus_r = mccchannel_10_cave2_cyl1_focus_r;
MCNUM p_interact = mccchannel_10_cave2_cyl1_p_interact;
char* mask_string = mccchannel_10_cave2_cyl1_mask_string;
char* mask_setting = mccchannel_10_cave2_cyl1_mask_setting;
MCNUM number_of_activations = mccchannel_10_cave2_cyl1_number_of_activations;
#line 345 "Union_cylinder.comp"
{
dummy = 1;
}
#line 415428 "MACS_sample_kidney_box.c"
}   /* End of channel_10_cave2_cyl1=Union_cylinder() SETTING parameter declarations. */
#undef this_cylinder_storage
#undef global_geometry_element
#undef this_cylinder_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex
  /* Label for restoring  neutron */
  mcabsorbCompchannel_10_cave2_cyl1:
  if (RESTORE) /* restore if needed */
  { RESTORE_NEUTRON(530,
      mcnlx,
      mcnly,
      mcnlz,
      mcnlvx,
      mcnlvy,
      mcnlvz,
      mcnlt,
      mcnlsx,
      mcnlsy,
      mcnlsz,
      mcnlp); }
#undef mcabsorbComp
#undef p
#undef sz
#undef sy
#undef sx
#undef t
#undef vz
#undef vy
#undef vx
#undef z
#undef y
#undef x
  mcDEBUG_STATE(
mcnlx,
mcnly,
mcnlz,
mcnlvx,
mcnlvy,
mcnlvz,
mcnlt,
mcnlsx,
mcnlsy,
mcnlsz,
mcnlp)

  /* TRACE Component channel_10_cave2_box1 [531] */
  mccoordschange(mcposrchannel_10_cave2_box1, mcrotrchannel_10_cave2_box1,
    &mcnlx,
    &mcnly,
    &mcnlz,
    &mcnlvx,
    &mcnlvy,
    &mcnlvz,
    &mcnlsx,
    &mcnlsy,
    &mcnlsz);
  /* define label inside component channel_10_cave2_box1 (without coords transformations) */
  mcJumpTrace_channel_10_cave2_box1:
  SIG_MESSAGE("channel_10_cave2_box1 (Trace)");
  mcDEBUG_COMP("channel_10_cave2_box1")
  mcDEBUG_STATE(
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp)
#define x mcnlx
#define y mcnly
#define z mcnlz
#define vx mcnlvx
#define vy mcnlvy
#define vz mcnlvz
#define t mcnlt
#define sx mcnlsx
#define sy mcnlsy
#define sz mcnlsz
#define p mcnlp

#define mcabsorbComp mcabsorbCompchannel_10_cave2_box1
  STORE_NEUTRON(531,
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp);
  mcScattered=0;
  mcRestore=0;
  mcNCounter[531]++;
  mcPCounter[531] += p;
  mcP2Counter[531] += p*p;
#define mccompcurname  channel_10_cave2_box1
#define mccompcurtype  Union_box
#define mccompcurindex 531
#define loop_index mccchannel_10_cave2_box1_loop_index
#define this_box_volume mccchannel_10_cave2_box1_this_box_volume
#define global_geometry_element mccchannel_10_cave2_box1_global_geometry_element
#define this_box_storage mccchannel_10_cave2_box1_this_box_storage
{   /* Declarations of channel_10_cave2_box1=Union_box() SETTING parameters. */
char* material_string = mccchannel_10_cave2_box1_material_string;
MCNUM priority = mccchannel_10_cave2_box1_priority;
MCNUM xwidth = mccchannel_10_cave2_box1_xwidth;
MCNUM yheight = mccchannel_10_cave2_box1_yheight;
MCNUM zdepth = mccchannel_10_cave2_box1_zdepth;
MCNUM xwidth2 = mccchannel_10_cave2_box1_xwidth2;
MCNUM yheight2 = mccchannel_10_cave2_box1_yheight2;
MCNUM visualize = mccchannel_10_cave2_box1_visualize;
int target_index = mccchannel_10_cave2_box1_target_index;
MCNUM target_x = mccchannel_10_cave2_box1_target_x;
MCNUM target_y = mccchannel_10_cave2_box1_target_y;
MCNUM target_z = mccchannel_10_cave2_box1_target_z;
MCNUM focus_aw = mccchannel_10_cave2_box1_focus_aw;
MCNUM focus_ah = mccchannel_10_cave2_box1_focus_ah;
MCNUM focus_xw = mccchannel_10_cave2_box1_focus_xw;
MCNUM focus_xh = mccchannel_10_cave2_box1_focus_xh;
MCNUM focus_r = mccchannel_10_cave2_box1_focus_r;
MCNUM p_interact = mccchannel_10_cave2_box1_p_interact;
char* mask_string = mccchannel_10_cave2_box1_mask_string;
char* mask_setting = mccchannel_10_cave2_box1_mask_setting;
MCNUM number_of_activations = mccchannel_10_cave2_box1_number_of_activations;
}   /* End of channel_10_cave2_box1=Union_box() SETTING parameter declarations. */
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex
  /* Label for restoring  neutron */
  mcabsorbCompchannel_10_cave2_box1:
  if (RESTORE) /* restore if needed */
  { RESTORE_NEUTRON(531,
      mcnlx,
      mcnly,
      mcnlz,
      mcnlvx,
      mcnlvy,
      mcnlvz,
      mcnlt,
      mcnlsx,
      mcnlsy,
      mcnlsz,
      mcnlp); }
#undef mcabsorbComp
#undef p
#undef sz
#undef sy
#undef sx
#undef t
#undef vz
#undef vy
#undef vx
#undef z
#undef y
#undef x
  mcDEBUG_STATE(
mcnlx,
mcnly,
mcnlz,
mcnlvx,
mcnlvy,
mcnlvz,
mcnlt,
mcnlsx,
mcnlsy,
mcnlsz,
mcnlp)

  /* TRACE Component channel_10_cave2_box2 [532] */
  mccoordschange(mcposrchannel_10_cave2_box2, mcrotrchannel_10_cave2_box2,
    &mcnlx,
    &mcnly,
    &mcnlz,
    &mcnlvx,
    &mcnlvy,
    &mcnlvz,
    &mcnlsx,
    &mcnlsy,
    &mcnlsz);
  /* define label inside component channel_10_cave2_box2 (without coords transformations) */
  mcJumpTrace_channel_10_cave2_box2:
  SIG_MESSAGE("channel_10_cave2_box2 (Trace)");
  mcDEBUG_COMP("channel_10_cave2_box2")
  mcDEBUG_STATE(
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp)
#define x mcnlx
#define y mcnly
#define z mcnlz
#define vx mcnlvx
#define vy mcnlvy
#define vz mcnlvz
#define t mcnlt
#define sx mcnlsx
#define sy mcnlsy
#define sz mcnlsz
#define p mcnlp

#define mcabsorbComp mcabsorbCompchannel_10_cave2_box2
  STORE_NEUTRON(532,
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp);
  mcScattered=0;
  mcRestore=0;
  mcNCounter[532]++;
  mcPCounter[532] += p;
  mcP2Counter[532] += p*p;
#define mccompcurname  channel_10_cave2_box2
#define mccompcurtype  Union_box
#define mccompcurindex 532
#define loop_index mccchannel_10_cave2_box2_loop_index
#define this_box_volume mccchannel_10_cave2_box2_this_box_volume
#define global_geometry_element mccchannel_10_cave2_box2_global_geometry_element
#define this_box_storage mccchannel_10_cave2_box2_this_box_storage
{   /* Declarations of channel_10_cave2_box2=Union_box() SETTING parameters. */
char* material_string = mccchannel_10_cave2_box2_material_string;
MCNUM priority = mccchannel_10_cave2_box2_priority;
MCNUM xwidth = mccchannel_10_cave2_box2_xwidth;
MCNUM yheight = mccchannel_10_cave2_box2_yheight;
MCNUM zdepth = mccchannel_10_cave2_box2_zdepth;
MCNUM xwidth2 = mccchannel_10_cave2_box2_xwidth2;
MCNUM yheight2 = mccchannel_10_cave2_box2_yheight2;
MCNUM visualize = mccchannel_10_cave2_box2_visualize;
int target_index = mccchannel_10_cave2_box2_target_index;
MCNUM target_x = mccchannel_10_cave2_box2_target_x;
MCNUM target_y = mccchannel_10_cave2_box2_target_y;
MCNUM target_z = mccchannel_10_cave2_box2_target_z;
MCNUM focus_aw = mccchannel_10_cave2_box2_focus_aw;
MCNUM focus_ah = mccchannel_10_cave2_box2_focus_ah;
MCNUM focus_xw = mccchannel_10_cave2_box2_focus_xw;
MCNUM focus_xh = mccchannel_10_cave2_box2_focus_xh;
MCNUM focus_r = mccchannel_10_cave2_box2_focus_r;
MCNUM p_interact = mccchannel_10_cave2_box2_p_interact;
char* mask_string = mccchannel_10_cave2_box2_mask_string;
char* mask_setting = mccchannel_10_cave2_box2_mask_setting;
MCNUM number_of_activations = mccchannel_10_cave2_box2_number_of_activations;
}   /* End of channel_10_cave2_box2=Union_box() SETTING parameter declarations. */
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex
  /* Label for restoring  neutron */
  mcabsorbCompchannel_10_cave2_box2:
  if (RESTORE) /* restore if needed */
  { RESTORE_NEUTRON(532,
      mcnlx,
      mcnly,
      mcnlz,
      mcnlvx,
      mcnlvy,
      mcnlvz,
      mcnlt,
      mcnlsx,
      mcnlsy,
      mcnlsz,
      mcnlp); }
#undef mcabsorbComp
#undef p
#undef sz
#undef sy
#undef sx
#undef t
#undef vz
#undef vy
#undef vx
#undef z
#undef y
#undef x
  mcDEBUG_STATE(
mcnlx,
mcnly,
mcnlz,
mcnlvx,
mcnlvy,
mcnlvz,
mcnlt,
mcnlsx,
mcnlsy,
mcnlsz,
mcnlp)

  /* TRACE Component channel_10_cave2_box3 [533] */
  mccoordschange(mcposrchannel_10_cave2_box3, mcrotrchannel_10_cave2_box3,
    &mcnlx,
    &mcnly,
    &mcnlz,
    &mcnlvx,
    &mcnlvy,
    &mcnlvz,
    &mcnlsx,
    &mcnlsy,
    &mcnlsz);
  /* define label inside component channel_10_cave2_box3 (without coords transformations) */
  mcJumpTrace_channel_10_cave2_box3:
  SIG_MESSAGE("channel_10_cave2_box3 (Trace)");
  mcDEBUG_COMP("channel_10_cave2_box3")
  mcDEBUG_STATE(
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp)
#define x mcnlx
#define y mcnly
#define z mcnlz
#define vx mcnlvx
#define vy mcnlvy
#define vz mcnlvz
#define t mcnlt
#define sx mcnlsx
#define sy mcnlsy
#define sz mcnlsz
#define p mcnlp

#define mcabsorbComp mcabsorbCompchannel_10_cave2_box3
  STORE_NEUTRON(533,
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp);
  mcScattered=0;
  mcRestore=0;
  mcNCounter[533]++;
  mcPCounter[533] += p;
  mcP2Counter[533] += p*p;
#define mccompcurname  channel_10_cave2_box3
#define mccompcurtype  Union_box
#define mccompcurindex 533
#define loop_index mccchannel_10_cave2_box3_loop_index
#define this_box_volume mccchannel_10_cave2_box3_this_box_volume
#define global_geometry_element mccchannel_10_cave2_box3_global_geometry_element
#define this_box_storage mccchannel_10_cave2_box3_this_box_storage
{   /* Declarations of channel_10_cave2_box3=Union_box() SETTING parameters. */
char* material_string = mccchannel_10_cave2_box3_material_string;
MCNUM priority = mccchannel_10_cave2_box3_priority;
MCNUM xwidth = mccchannel_10_cave2_box3_xwidth;
MCNUM yheight = mccchannel_10_cave2_box3_yheight;
MCNUM zdepth = mccchannel_10_cave2_box3_zdepth;
MCNUM xwidth2 = mccchannel_10_cave2_box3_xwidth2;
MCNUM yheight2 = mccchannel_10_cave2_box3_yheight2;
MCNUM visualize = mccchannel_10_cave2_box3_visualize;
int target_index = mccchannel_10_cave2_box3_target_index;
MCNUM target_x = mccchannel_10_cave2_box3_target_x;
MCNUM target_y = mccchannel_10_cave2_box3_target_y;
MCNUM target_z = mccchannel_10_cave2_box3_target_z;
MCNUM focus_aw = mccchannel_10_cave2_box3_focus_aw;
MCNUM focus_ah = mccchannel_10_cave2_box3_focus_ah;
MCNUM focus_xw = mccchannel_10_cave2_box3_focus_xw;
MCNUM focus_xh = mccchannel_10_cave2_box3_focus_xh;
MCNUM focus_r = mccchannel_10_cave2_box3_focus_r;
MCNUM p_interact = mccchannel_10_cave2_box3_p_interact;
char* mask_string = mccchannel_10_cave2_box3_mask_string;
char* mask_setting = mccchannel_10_cave2_box3_mask_setting;
MCNUM number_of_activations = mccchannel_10_cave2_box3_number_of_activations;
}   /* End of channel_10_cave2_box3=Union_box() SETTING parameter declarations. */
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex
  /* Label for restoring  neutron */
  mcabsorbCompchannel_10_cave2_box3:
  if (RESTORE) /* restore if needed */
  { RESTORE_NEUTRON(533,
      mcnlx,
      mcnly,
      mcnlz,
      mcnlvx,
      mcnlvy,
      mcnlvz,
      mcnlt,
      mcnlsx,
      mcnlsy,
      mcnlsz,
      mcnlp); }
#undef mcabsorbComp
#undef p
#undef sz
#undef sy
#undef sx
#undef t
#undef vz
#undef vy
#undef vx
#undef z
#undef y
#undef x
  mcDEBUG_STATE(
mcnlx,
mcnly,
mcnlz,
mcnlvx,
mcnlvy,
mcnlvz,
mcnlt,
mcnlsx,
mcnlsy,
mcnlsz,
mcnlp)

  /* TRACE Component inter_analyzer_colimator_center_10 [534] */
  mccoordschange(mcposrinter_analyzer_colimator_center_10, mcrotrinter_analyzer_colimator_center_10,
    &mcnlx,
    &mcnly,
    &mcnlz,
    &mcnlvx,
    &mcnlvy,
    &mcnlvz,
    &mcnlsx,
    &mcnlsy,
    &mcnlsz);
  /* define label inside component inter_analyzer_colimator_center_10 (without coords transformations) */
  mcJumpTrace_inter_analyzer_colimator_center_10:
  SIG_MESSAGE("inter_analyzer_colimator_center_10 (Trace)");
  mcDEBUG_COMP("inter_analyzer_colimator_center_10")
  mcDEBUG_STATE(
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp)
#define x mcnlx
#define y mcnly
#define z mcnlz
#define vx mcnlvx
#define vy mcnlvy
#define vz mcnlvz
#define t mcnlt
#define sx mcnlsx
#define sy mcnlsy
#define sz mcnlsz
#define p mcnlp

#define mcabsorbComp mcabsorbCompinter_analyzer_colimator_center_10
  STORE_NEUTRON(534,
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp);
  mcScattered=0;
  mcRestore=0;
  mcNCounter[534]++;
  mcPCounter[534] += p;
  mcP2Counter[534] += p*p;
#define mccompcurname  inter_analyzer_colimator_center_10
#define mccompcurtype  Arm
#define mccompcurindex 534
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex
  /* Label for restoring  neutron */
  mcabsorbCompinter_analyzer_colimator_center_10:
  if (RESTORE) /* restore if needed */
  { RESTORE_NEUTRON(534,
      mcnlx,
      mcnly,
      mcnlz,
      mcnlvx,
      mcnlvy,
      mcnlvz,
      mcnlt,
      mcnlsx,
      mcnlsy,
      mcnlsz,
      mcnlp); }
#undef mcabsorbComp
#undef p
#undef sz
#undef sy
#undef sx
#undef t
#undef vz
#undef vy
#undef vx
#undef z
#undef y
#undef x
  mcDEBUG_STATE(
mcnlx,
mcnly,
mcnlz,
mcnlvx,
mcnlvy,
mcnlvz,
mcnlt,
mcnlsx,
mcnlsy,
mcnlsz,
mcnlp)

  /* TRACE Component inter_analyzer_colimator_10_blade_0 [535] */
  mccoordschange(mcposrinter_analyzer_colimator_10_blade_0, mcrotrinter_analyzer_colimator_10_blade_0,
    &mcnlx,
    &mcnly,
    &mcnlz,
    &mcnlvx,
    &mcnlvy,
    &mcnlvz,
    &mcnlsx,
    &mcnlsy,
    &mcnlsz);
  /* define label inside component inter_analyzer_colimator_10_blade_0 (without coords transformations) */
  mcJumpTrace_inter_analyzer_colimator_10_blade_0:
  SIG_MESSAGE("inter_analyzer_colimator_10_blade_0 (Trace)");
  mcDEBUG_COMP("inter_analyzer_colimator_10_blade_0")
  mcDEBUG_STATE(
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp)
#define x mcnlx
#define y mcnly
#define z mcnlz
#define vx mcnlvx
#define vy mcnlvy
#define vz mcnlvz
#define t mcnlt
#define sx mcnlsx
#define sy mcnlsy
#define sz mcnlsz
#define p mcnlp

#define mcabsorbComp mcabsorbCompinter_analyzer_colimator_10_blade_0
  STORE_NEUTRON(535,
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp);
  mcScattered=0;
  mcRestore=0;
  mcNCounter[535]++;
  mcPCounter[535] += p;
  mcP2Counter[535] += p*p;
#define mccompcurname  inter_analyzer_colimator_10_blade_0
#define mccompcurtype  Union_box
#define mccompcurindex 535
#define loop_index mccinter_analyzer_colimator_10_blade_0_loop_index
#define this_box_volume mccinter_analyzer_colimator_10_blade_0_this_box_volume
#define global_geometry_element mccinter_analyzer_colimator_10_blade_0_global_geometry_element
#define this_box_storage mccinter_analyzer_colimator_10_blade_0_this_box_storage
{   /* Declarations of inter_analyzer_colimator_10_blade_0=Union_box() SETTING parameters. */
char* material_string = mccinter_analyzer_colimator_10_blade_0_material_string;
MCNUM priority = mccinter_analyzer_colimator_10_blade_0_priority;
MCNUM xwidth = mccinter_analyzer_colimator_10_blade_0_xwidth;
MCNUM yheight = mccinter_analyzer_colimator_10_blade_0_yheight;
MCNUM zdepth = mccinter_analyzer_colimator_10_blade_0_zdepth;
MCNUM xwidth2 = mccinter_analyzer_colimator_10_blade_0_xwidth2;
MCNUM yheight2 = mccinter_analyzer_colimator_10_blade_0_yheight2;
MCNUM visualize = mccinter_analyzer_colimator_10_blade_0_visualize;
int target_index = mccinter_analyzer_colimator_10_blade_0_target_index;
MCNUM target_x = mccinter_analyzer_colimator_10_blade_0_target_x;
MCNUM target_y = mccinter_analyzer_colimator_10_blade_0_target_y;
MCNUM target_z = mccinter_analyzer_colimator_10_blade_0_target_z;
MCNUM focus_aw = mccinter_analyzer_colimator_10_blade_0_focus_aw;
MCNUM focus_ah = mccinter_analyzer_colimator_10_blade_0_focus_ah;
MCNUM focus_xw = mccinter_analyzer_colimator_10_blade_0_focus_xw;
MCNUM focus_xh = mccinter_analyzer_colimator_10_blade_0_focus_xh;
MCNUM focus_r = mccinter_analyzer_colimator_10_blade_0_focus_r;
MCNUM p_interact = mccinter_analyzer_colimator_10_blade_0_p_interact;
char* mask_string = mccinter_analyzer_colimator_10_blade_0_mask_string;
char* mask_setting = mccinter_analyzer_colimator_10_blade_0_mask_setting;
MCNUM number_of_activations = mccinter_analyzer_colimator_10_blade_0_number_of_activations;
}   /* End of inter_analyzer_colimator_10_blade_0=Union_box() SETTING parameter declarations. */
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex
  /* Label for restoring  neutron */
  mcabsorbCompinter_analyzer_colimator_10_blade_0:
  if (RESTORE) /* restore if needed */
  { RESTORE_NEUTRON(535,
      mcnlx,
      mcnly,
      mcnlz,
      mcnlvx,
      mcnlvy,
      mcnlvz,
      mcnlt,
      mcnlsx,
      mcnlsy,
      mcnlsz,
      mcnlp); }
#undef mcabsorbComp
#undef p
#undef sz
#undef sy
#undef sx
#undef t
#undef vz
#undef vy
#undef vx
#undef z
#undef y
#undef x
  mcDEBUG_STATE(
mcnlx,
mcnly,
mcnlz,
mcnlvx,
mcnlvy,
mcnlvz,
mcnlt,
mcnlsx,
mcnlsy,
mcnlsz,
mcnlp)

  /* TRACE Component inter_analyzer_colimator_10_blade_1 [536] */
  mccoordschange(mcposrinter_analyzer_colimator_10_blade_1, mcrotrinter_analyzer_colimator_10_blade_1,
    &mcnlx,
    &mcnly,
    &mcnlz,
    &mcnlvx,
    &mcnlvy,
    &mcnlvz,
    &mcnlsx,
    &mcnlsy,
    &mcnlsz);
  /* define label inside component inter_analyzer_colimator_10_blade_1 (without coords transformations) */
  mcJumpTrace_inter_analyzer_colimator_10_blade_1:
  SIG_MESSAGE("inter_analyzer_colimator_10_blade_1 (Trace)");
  mcDEBUG_COMP("inter_analyzer_colimator_10_blade_1")
  mcDEBUG_STATE(
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp)
#define x mcnlx
#define y mcnly
#define z mcnlz
#define vx mcnlvx
#define vy mcnlvy
#define vz mcnlvz
#define t mcnlt
#define sx mcnlsx
#define sy mcnlsy
#define sz mcnlsz
#define p mcnlp

#define mcabsorbComp mcabsorbCompinter_analyzer_colimator_10_blade_1
  STORE_NEUTRON(536,
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp);
  mcScattered=0;
  mcRestore=0;
  mcNCounter[536]++;
  mcPCounter[536] += p;
  mcP2Counter[536] += p*p;
#define mccompcurname  inter_analyzer_colimator_10_blade_1
#define mccompcurtype  Union_box
#define mccompcurindex 536
#define loop_index mccinter_analyzer_colimator_10_blade_1_loop_index
#define this_box_volume mccinter_analyzer_colimator_10_blade_1_this_box_volume
#define global_geometry_element mccinter_analyzer_colimator_10_blade_1_global_geometry_element
#define this_box_storage mccinter_analyzer_colimator_10_blade_1_this_box_storage
{   /* Declarations of inter_analyzer_colimator_10_blade_1=Union_box() SETTING parameters. */
char* material_string = mccinter_analyzer_colimator_10_blade_1_material_string;
MCNUM priority = mccinter_analyzer_colimator_10_blade_1_priority;
MCNUM xwidth = mccinter_analyzer_colimator_10_blade_1_xwidth;
MCNUM yheight = mccinter_analyzer_colimator_10_blade_1_yheight;
MCNUM zdepth = mccinter_analyzer_colimator_10_blade_1_zdepth;
MCNUM xwidth2 = mccinter_analyzer_colimator_10_blade_1_xwidth2;
MCNUM yheight2 = mccinter_analyzer_colimator_10_blade_1_yheight2;
MCNUM visualize = mccinter_analyzer_colimator_10_blade_1_visualize;
int target_index = mccinter_analyzer_colimator_10_blade_1_target_index;
MCNUM target_x = mccinter_analyzer_colimator_10_blade_1_target_x;
MCNUM target_y = mccinter_analyzer_colimator_10_blade_1_target_y;
MCNUM target_z = mccinter_analyzer_colimator_10_blade_1_target_z;
MCNUM focus_aw = mccinter_analyzer_colimator_10_blade_1_focus_aw;
MCNUM focus_ah = mccinter_analyzer_colimator_10_blade_1_focus_ah;
MCNUM focus_xw = mccinter_analyzer_colimator_10_blade_1_focus_xw;
MCNUM focus_xh = mccinter_analyzer_colimator_10_blade_1_focus_xh;
MCNUM focus_r = mccinter_analyzer_colimator_10_blade_1_focus_r;
MCNUM p_interact = mccinter_analyzer_colimator_10_blade_1_p_interact;
char* mask_string = mccinter_analyzer_colimator_10_blade_1_mask_string;
char* mask_setting = mccinter_analyzer_colimator_10_blade_1_mask_setting;
MCNUM number_of_activations = mccinter_analyzer_colimator_10_blade_1_number_of_activations;
}   /* End of inter_analyzer_colimator_10_blade_1=Union_box() SETTING parameter declarations. */
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex
  /* Label for restoring  neutron */
  mcabsorbCompinter_analyzer_colimator_10_blade_1:
  if (RESTORE) /* restore if needed */
  { RESTORE_NEUTRON(536,
      mcnlx,
      mcnly,
      mcnlz,
      mcnlvx,
      mcnlvy,
      mcnlvz,
      mcnlt,
      mcnlsx,
      mcnlsy,
      mcnlsz,
      mcnlp); }
#undef mcabsorbComp
#undef p
#undef sz
#undef sy
#undef sx
#undef t
#undef vz
#undef vy
#undef vx
#undef z
#undef y
#undef x
  mcDEBUG_STATE(
mcnlx,
mcnly,
mcnlz,
mcnlvx,
mcnlvy,
mcnlvz,
mcnlt,
mcnlsx,
mcnlsy,
mcnlsz,
mcnlp)

  /* TRACE Component inter_analyzer_colimator_10_blade_2 [537] */
  mccoordschange(mcposrinter_analyzer_colimator_10_blade_2, mcrotrinter_analyzer_colimator_10_blade_2,
    &mcnlx,
    &mcnly,
    &mcnlz,
    &mcnlvx,
    &mcnlvy,
    &mcnlvz,
    &mcnlsx,
    &mcnlsy,
    &mcnlsz);
  /* define label inside component inter_analyzer_colimator_10_blade_2 (without coords transformations) */
  mcJumpTrace_inter_analyzer_colimator_10_blade_2:
  SIG_MESSAGE("inter_analyzer_colimator_10_blade_2 (Trace)");
  mcDEBUG_COMP("inter_analyzer_colimator_10_blade_2")
  mcDEBUG_STATE(
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp)
#define x mcnlx
#define y mcnly
#define z mcnlz
#define vx mcnlvx
#define vy mcnlvy
#define vz mcnlvz
#define t mcnlt
#define sx mcnlsx
#define sy mcnlsy
#define sz mcnlsz
#define p mcnlp

#define mcabsorbComp mcabsorbCompinter_analyzer_colimator_10_blade_2
  STORE_NEUTRON(537,
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp);
  mcScattered=0;
  mcRestore=0;
  mcNCounter[537]++;
  mcPCounter[537] += p;
  mcP2Counter[537] += p*p;
#define mccompcurname  inter_analyzer_colimator_10_blade_2
#define mccompcurtype  Union_box
#define mccompcurindex 537
#define loop_index mccinter_analyzer_colimator_10_blade_2_loop_index
#define this_box_volume mccinter_analyzer_colimator_10_blade_2_this_box_volume
#define global_geometry_element mccinter_analyzer_colimator_10_blade_2_global_geometry_element
#define this_box_storage mccinter_analyzer_colimator_10_blade_2_this_box_storage
{   /* Declarations of inter_analyzer_colimator_10_blade_2=Union_box() SETTING parameters. */
char* material_string = mccinter_analyzer_colimator_10_blade_2_material_string;
MCNUM priority = mccinter_analyzer_colimator_10_blade_2_priority;
MCNUM xwidth = mccinter_analyzer_colimator_10_blade_2_xwidth;
MCNUM yheight = mccinter_analyzer_colimator_10_blade_2_yheight;
MCNUM zdepth = mccinter_analyzer_colimator_10_blade_2_zdepth;
MCNUM xwidth2 = mccinter_analyzer_colimator_10_blade_2_xwidth2;
MCNUM yheight2 = mccinter_analyzer_colimator_10_blade_2_yheight2;
MCNUM visualize = mccinter_analyzer_colimator_10_blade_2_visualize;
int target_index = mccinter_analyzer_colimator_10_blade_2_target_index;
MCNUM target_x = mccinter_analyzer_colimator_10_blade_2_target_x;
MCNUM target_y = mccinter_analyzer_colimator_10_blade_2_target_y;
MCNUM target_z = mccinter_analyzer_colimator_10_blade_2_target_z;
MCNUM focus_aw = mccinter_analyzer_colimator_10_blade_2_focus_aw;
MCNUM focus_ah = mccinter_analyzer_colimator_10_blade_2_focus_ah;
MCNUM focus_xw = mccinter_analyzer_colimator_10_blade_2_focus_xw;
MCNUM focus_xh = mccinter_analyzer_colimator_10_blade_2_focus_xh;
MCNUM focus_r = mccinter_analyzer_colimator_10_blade_2_focus_r;
MCNUM p_interact = mccinter_analyzer_colimator_10_blade_2_p_interact;
char* mask_string = mccinter_analyzer_colimator_10_blade_2_mask_string;
char* mask_setting = mccinter_analyzer_colimator_10_blade_2_mask_setting;
MCNUM number_of_activations = mccinter_analyzer_colimator_10_blade_2_number_of_activations;
}   /* End of inter_analyzer_colimator_10_blade_2=Union_box() SETTING parameter declarations. */
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex
  /* Label for restoring  neutron */
  mcabsorbCompinter_analyzer_colimator_10_blade_2:
  if (RESTORE) /* restore if needed */
  { RESTORE_NEUTRON(537,
      mcnlx,
      mcnly,
      mcnlz,
      mcnlvx,
      mcnlvy,
      mcnlvz,
      mcnlt,
      mcnlsx,
      mcnlsy,
      mcnlsz,
      mcnlp); }
#undef mcabsorbComp
#undef p
#undef sz
#undef sy
#undef sx
#undef t
#undef vz
#undef vy
#undef vx
#undef z
#undef y
#undef x
  mcDEBUG_STATE(
mcnlx,
mcnly,
mcnlz,
mcnlvx,
mcnlvy,
mcnlvz,
mcnlt,
mcnlsx,
mcnlsy,
mcnlsz,
mcnlp)

  /* TRACE Component inter_analyzer_colimator_10_blade_3 [538] */
  mccoordschange(mcposrinter_analyzer_colimator_10_blade_3, mcrotrinter_analyzer_colimator_10_blade_3,
    &mcnlx,
    &mcnly,
    &mcnlz,
    &mcnlvx,
    &mcnlvy,
    &mcnlvz,
    &mcnlsx,
    &mcnlsy,
    &mcnlsz);
  /* define label inside component inter_analyzer_colimator_10_blade_3 (without coords transformations) */
  mcJumpTrace_inter_analyzer_colimator_10_blade_3:
  SIG_MESSAGE("inter_analyzer_colimator_10_blade_3 (Trace)");
  mcDEBUG_COMP("inter_analyzer_colimator_10_blade_3")
  mcDEBUG_STATE(
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp)
#define x mcnlx
#define y mcnly
#define z mcnlz
#define vx mcnlvx
#define vy mcnlvy
#define vz mcnlvz
#define t mcnlt
#define sx mcnlsx
#define sy mcnlsy
#define sz mcnlsz
#define p mcnlp

#define mcabsorbComp mcabsorbCompinter_analyzer_colimator_10_blade_3
  STORE_NEUTRON(538,
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp);
  mcScattered=0;
  mcRestore=0;
  mcNCounter[538]++;
  mcPCounter[538] += p;
  mcP2Counter[538] += p*p;
#define mccompcurname  inter_analyzer_colimator_10_blade_3
#define mccompcurtype  Union_box
#define mccompcurindex 538
#define loop_index mccinter_analyzer_colimator_10_blade_3_loop_index
#define this_box_volume mccinter_analyzer_colimator_10_blade_3_this_box_volume
#define global_geometry_element mccinter_analyzer_colimator_10_blade_3_global_geometry_element
#define this_box_storage mccinter_analyzer_colimator_10_blade_3_this_box_storage
{   /* Declarations of inter_analyzer_colimator_10_blade_3=Union_box() SETTING parameters. */
char* material_string = mccinter_analyzer_colimator_10_blade_3_material_string;
MCNUM priority = mccinter_analyzer_colimator_10_blade_3_priority;
MCNUM xwidth = mccinter_analyzer_colimator_10_blade_3_xwidth;
MCNUM yheight = mccinter_analyzer_colimator_10_blade_3_yheight;
MCNUM zdepth = mccinter_analyzer_colimator_10_blade_3_zdepth;
MCNUM xwidth2 = mccinter_analyzer_colimator_10_blade_3_xwidth2;
MCNUM yheight2 = mccinter_analyzer_colimator_10_blade_3_yheight2;
MCNUM visualize = mccinter_analyzer_colimator_10_blade_3_visualize;
int target_index = mccinter_analyzer_colimator_10_blade_3_target_index;
MCNUM target_x = mccinter_analyzer_colimator_10_blade_3_target_x;
MCNUM target_y = mccinter_analyzer_colimator_10_blade_3_target_y;
MCNUM target_z = mccinter_analyzer_colimator_10_blade_3_target_z;
MCNUM focus_aw = mccinter_analyzer_colimator_10_blade_3_focus_aw;
MCNUM focus_ah = mccinter_analyzer_colimator_10_blade_3_focus_ah;
MCNUM focus_xw = mccinter_analyzer_colimator_10_blade_3_focus_xw;
MCNUM focus_xh = mccinter_analyzer_colimator_10_blade_3_focus_xh;
MCNUM focus_r = mccinter_analyzer_colimator_10_blade_3_focus_r;
MCNUM p_interact = mccinter_analyzer_colimator_10_blade_3_p_interact;
char* mask_string = mccinter_analyzer_colimator_10_blade_3_mask_string;
char* mask_setting = mccinter_analyzer_colimator_10_blade_3_mask_setting;
MCNUM number_of_activations = mccinter_analyzer_colimator_10_blade_3_number_of_activations;
}   /* End of inter_analyzer_colimator_10_blade_3=Union_box() SETTING parameter declarations. */
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex
  /* Label for restoring  neutron */
  mcabsorbCompinter_analyzer_colimator_10_blade_3:
  if (RESTORE) /* restore if needed */
  { RESTORE_NEUTRON(538,
      mcnlx,
      mcnly,
      mcnlz,
      mcnlvx,
      mcnlvy,
      mcnlvz,
      mcnlt,
      mcnlsx,
      mcnlsy,
      mcnlsz,
      mcnlp); }
#undef mcabsorbComp
#undef p
#undef sz
#undef sy
#undef sx
#undef t
#undef vz
#undef vy
#undef vx
#undef z
#undef y
#undef x
  mcDEBUG_STATE(
mcnlx,
mcnly,
mcnlz,
mcnlvx,
mcnlvy,
mcnlvz,
mcnlt,
mcnlsx,
mcnlsy,
mcnlsz,
mcnlp)

  /* TRACE Component inter_analyzer_colimator_10_blade_4 [539] */
  mccoordschange(mcposrinter_analyzer_colimator_10_blade_4, mcrotrinter_analyzer_colimator_10_blade_4,
    &mcnlx,
    &mcnly,
    &mcnlz,
    &mcnlvx,
    &mcnlvy,
    &mcnlvz,
    &mcnlsx,
    &mcnlsy,
    &mcnlsz);
  /* define label inside component inter_analyzer_colimator_10_blade_4 (without coords transformations) */
  mcJumpTrace_inter_analyzer_colimator_10_blade_4:
  SIG_MESSAGE("inter_analyzer_colimator_10_blade_4 (Trace)");
  mcDEBUG_COMP("inter_analyzer_colimator_10_blade_4")
  mcDEBUG_STATE(
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp)
#define x mcnlx
#define y mcnly
#define z mcnlz
#define vx mcnlvx
#define vy mcnlvy
#define vz mcnlvz
#define t mcnlt
#define sx mcnlsx
#define sy mcnlsy
#define sz mcnlsz
#define p mcnlp

#define mcabsorbComp mcabsorbCompinter_analyzer_colimator_10_blade_4
  STORE_NEUTRON(539,
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp);
  mcScattered=0;
  mcRestore=0;
  mcNCounter[539]++;
  mcPCounter[539] += p;
  mcP2Counter[539] += p*p;
#define mccompcurname  inter_analyzer_colimator_10_blade_4
#define mccompcurtype  Union_box
#define mccompcurindex 539
#define loop_index mccinter_analyzer_colimator_10_blade_4_loop_index
#define this_box_volume mccinter_analyzer_colimator_10_blade_4_this_box_volume
#define global_geometry_element mccinter_analyzer_colimator_10_blade_4_global_geometry_element
#define this_box_storage mccinter_analyzer_colimator_10_blade_4_this_box_storage
{   /* Declarations of inter_analyzer_colimator_10_blade_4=Union_box() SETTING parameters. */
char* material_string = mccinter_analyzer_colimator_10_blade_4_material_string;
MCNUM priority = mccinter_analyzer_colimator_10_blade_4_priority;
MCNUM xwidth = mccinter_analyzer_colimator_10_blade_4_xwidth;
MCNUM yheight = mccinter_analyzer_colimator_10_blade_4_yheight;
MCNUM zdepth = mccinter_analyzer_colimator_10_blade_4_zdepth;
MCNUM xwidth2 = mccinter_analyzer_colimator_10_blade_4_xwidth2;
MCNUM yheight2 = mccinter_analyzer_colimator_10_blade_4_yheight2;
MCNUM visualize = mccinter_analyzer_colimator_10_blade_4_visualize;
int target_index = mccinter_analyzer_colimator_10_blade_4_target_index;
MCNUM target_x = mccinter_analyzer_colimator_10_blade_4_target_x;
MCNUM target_y = mccinter_analyzer_colimator_10_blade_4_target_y;
MCNUM target_z = mccinter_analyzer_colimator_10_blade_4_target_z;
MCNUM focus_aw = mccinter_analyzer_colimator_10_blade_4_focus_aw;
MCNUM focus_ah = mccinter_analyzer_colimator_10_blade_4_focus_ah;
MCNUM focus_xw = mccinter_analyzer_colimator_10_blade_4_focus_xw;
MCNUM focus_xh = mccinter_analyzer_colimator_10_blade_4_focus_xh;
MCNUM focus_r = mccinter_analyzer_colimator_10_blade_4_focus_r;
MCNUM p_interact = mccinter_analyzer_colimator_10_blade_4_p_interact;
char* mask_string = mccinter_analyzer_colimator_10_blade_4_mask_string;
char* mask_setting = mccinter_analyzer_colimator_10_blade_4_mask_setting;
MCNUM number_of_activations = mccinter_analyzer_colimator_10_blade_4_number_of_activations;
}   /* End of inter_analyzer_colimator_10_blade_4=Union_box() SETTING parameter declarations. */
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex
  /* Label for restoring  neutron */
  mcabsorbCompinter_analyzer_colimator_10_blade_4:
  if (RESTORE) /* restore if needed */
  { RESTORE_NEUTRON(539,
      mcnlx,
      mcnly,
      mcnlz,
      mcnlvx,
      mcnlvy,
      mcnlvz,
      mcnlt,
      mcnlsx,
      mcnlsy,
      mcnlsz,
      mcnlp); }
#undef mcabsorbComp
#undef p
#undef sz
#undef sy
#undef sx
#undef t
#undef vz
#undef vy
#undef vx
#undef z
#undef y
#undef x
  mcDEBUG_STATE(
mcnlx,
mcnly,
mcnlz,
mcnlvx,
mcnlvy,
mcnlvz,
mcnlt,
mcnlsx,
mcnlsy,
mcnlsz,
mcnlp)

  /* TRACE Component diffraction_detector_10_exit_volume [540] */
  mccoordschange(mcposrdiffraction_detector_10_exit_volume, mcrotrdiffraction_detector_10_exit_volume,
    &mcnlx,
    &mcnly,
    &mcnlz,
    &mcnlvx,
    &mcnlvy,
    &mcnlvz,
    &mcnlsx,
    &mcnlsy,
    &mcnlsz);
  /* define label inside component diffraction_detector_10_exit_volume (without coords transformations) */
  mcJumpTrace_diffraction_detector_10_exit_volume:
  SIG_MESSAGE("diffraction_detector_10_exit_volume (Trace)");
  mcDEBUG_COMP("diffraction_detector_10_exit_volume")
  mcDEBUG_STATE(
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp)
#define x mcnlx
#define y mcnly
#define z mcnlz
#define vx mcnlvx
#define vy mcnlvy
#define vz mcnlvz
#define t mcnlt
#define sx mcnlsx
#define sy mcnlsy
#define sz mcnlsz
#define p mcnlp

#define mcabsorbComp mcabsorbCompdiffraction_detector_10_exit_volume
  STORE_NEUTRON(540,
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp);
  mcScattered=0;
  mcRestore=0;
  mcNCounter[540]++;
  mcPCounter[540] += p;
  mcP2Counter[540] += p*p;
#define mccompcurname  diffraction_detector_10_exit_volume
#define mccompcurtype  Union_box
#define mccompcurindex 540
#define loop_index mccdiffraction_detector_10_exit_volume_loop_index
#define this_box_volume mccdiffraction_detector_10_exit_volume_this_box_volume
#define global_geometry_element mccdiffraction_detector_10_exit_volume_global_geometry_element
#define this_box_storage mccdiffraction_detector_10_exit_volume_this_box_storage
{   /* Declarations of diffraction_detector_10_exit_volume=Union_box() SETTING parameters. */
char* material_string = mccdiffraction_detector_10_exit_volume_material_string;
MCNUM priority = mccdiffraction_detector_10_exit_volume_priority;
MCNUM xwidth = mccdiffraction_detector_10_exit_volume_xwidth;
MCNUM yheight = mccdiffraction_detector_10_exit_volume_yheight;
MCNUM zdepth = mccdiffraction_detector_10_exit_volume_zdepth;
MCNUM xwidth2 = mccdiffraction_detector_10_exit_volume_xwidth2;
MCNUM yheight2 = mccdiffraction_detector_10_exit_volume_yheight2;
MCNUM visualize = mccdiffraction_detector_10_exit_volume_visualize;
int target_index = mccdiffraction_detector_10_exit_volume_target_index;
MCNUM target_x = mccdiffraction_detector_10_exit_volume_target_x;
MCNUM target_y = mccdiffraction_detector_10_exit_volume_target_y;
MCNUM target_z = mccdiffraction_detector_10_exit_volume_target_z;
MCNUM focus_aw = mccdiffraction_detector_10_exit_volume_focus_aw;
MCNUM focus_ah = mccdiffraction_detector_10_exit_volume_focus_ah;
MCNUM focus_xw = mccdiffraction_detector_10_exit_volume_focus_xw;
MCNUM focus_xh = mccdiffraction_detector_10_exit_volume_focus_xh;
MCNUM focus_r = mccdiffraction_detector_10_exit_volume_focus_r;
MCNUM p_interact = mccdiffraction_detector_10_exit_volume_p_interact;
char* mask_string = mccdiffraction_detector_10_exit_volume_mask_string;
char* mask_setting = mccdiffraction_detector_10_exit_volume_mask_setting;
MCNUM number_of_activations = mccdiffraction_detector_10_exit_volume_number_of_activations;
}   /* End of diffraction_detector_10_exit_volume=Union_box() SETTING parameter declarations. */
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex
  /* Label for restoring  neutron */
  mcabsorbCompdiffraction_detector_10_exit_volume:
  if (RESTORE) /* restore if needed */
  { RESTORE_NEUTRON(540,
      mcnlx,
      mcnly,
      mcnlz,
      mcnlvx,
      mcnlvy,
      mcnlvz,
      mcnlt,
      mcnlsx,
      mcnlsy,
      mcnlsz,
      mcnlp); }
#undef mcabsorbComp
#undef p
#undef sz
#undef sy
#undef sx
#undef t
#undef vz
#undef vy
#undef vx
#undef z
#undef y
#undef x
  mcDEBUG_STATE(
mcnlx,
mcnly,
mcnlz,
mcnlvx,
mcnlvy,
mcnlvz,
mcnlt,
mcnlsx,
mcnlsy,
mcnlsz,
mcnlp)

  /* TRACE Component spec_detector_10_exit_volume [541] */
  mccoordschange(mcposrspec_detector_10_exit_volume, mcrotrspec_detector_10_exit_volume,
    &mcnlx,
    &mcnly,
    &mcnlz,
    &mcnlvx,
    &mcnlvy,
    &mcnlvz,
    &mcnlsx,
    &mcnlsy,
    &mcnlsz);
  /* define label inside component spec_detector_10_exit_volume (without coords transformations) */
  mcJumpTrace_spec_detector_10_exit_volume:
  SIG_MESSAGE("spec_detector_10_exit_volume (Trace)");
  mcDEBUG_COMP("spec_detector_10_exit_volume")
  mcDEBUG_STATE(
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp)
#define x mcnlx
#define y mcnly
#define z mcnlz
#define vx mcnlvx
#define vy mcnlvy
#define vz mcnlvz
#define t mcnlt
#define sx mcnlsx
#define sy mcnlsy
#define sz mcnlsz
#define p mcnlp

#define mcabsorbComp mcabsorbCompspec_detector_10_exit_volume
  STORE_NEUTRON(541,
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp);
  mcScattered=0;
  mcRestore=0;
  mcNCounter[541]++;
  mcPCounter[541] += p;
  mcP2Counter[541] += p*p;
#define mccompcurname  spec_detector_10_exit_volume
#define mccompcurtype  Union_box
#define mccompcurindex 541
#define loop_index mccspec_detector_10_exit_volume_loop_index
#define this_box_volume mccspec_detector_10_exit_volume_this_box_volume
#define global_geometry_element mccspec_detector_10_exit_volume_global_geometry_element
#define this_box_storage mccspec_detector_10_exit_volume_this_box_storage
{   /* Declarations of spec_detector_10_exit_volume=Union_box() SETTING parameters. */
char* material_string = mccspec_detector_10_exit_volume_material_string;
MCNUM priority = mccspec_detector_10_exit_volume_priority;
MCNUM xwidth = mccspec_detector_10_exit_volume_xwidth;
MCNUM yheight = mccspec_detector_10_exit_volume_yheight;
MCNUM zdepth = mccspec_detector_10_exit_volume_zdepth;
MCNUM xwidth2 = mccspec_detector_10_exit_volume_xwidth2;
MCNUM yheight2 = mccspec_detector_10_exit_volume_yheight2;
MCNUM visualize = mccspec_detector_10_exit_volume_visualize;
int target_index = mccspec_detector_10_exit_volume_target_index;
MCNUM target_x = mccspec_detector_10_exit_volume_target_x;
MCNUM target_y = mccspec_detector_10_exit_volume_target_y;
MCNUM target_z = mccspec_detector_10_exit_volume_target_z;
MCNUM focus_aw = mccspec_detector_10_exit_volume_focus_aw;
MCNUM focus_ah = mccspec_detector_10_exit_volume_focus_ah;
MCNUM focus_xw = mccspec_detector_10_exit_volume_focus_xw;
MCNUM focus_xh = mccspec_detector_10_exit_volume_focus_xh;
MCNUM focus_r = mccspec_detector_10_exit_volume_focus_r;
MCNUM p_interact = mccspec_detector_10_exit_volume_p_interact;
char* mask_string = mccspec_detector_10_exit_volume_mask_string;
char* mask_setting = mccspec_detector_10_exit_volume_mask_setting;
MCNUM number_of_activations = mccspec_detector_10_exit_volume_number_of_activations;
}   /* End of spec_detector_10_exit_volume=Union_box() SETTING parameter declarations. */
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex
  /* Label for restoring  neutron */
  mcabsorbCompspec_detector_10_exit_volume:
  if (RESTORE) /* restore if needed */
  { RESTORE_NEUTRON(541,
      mcnlx,
      mcnly,
      mcnlz,
      mcnlvx,
      mcnlvy,
      mcnlvz,
      mcnlt,
      mcnlsx,
      mcnlsy,
      mcnlsz,
      mcnlp); }
#undef mcabsorbComp
#undef p
#undef sz
#undef sy
#undef sx
#undef t
#undef vz
#undef vy
#undef vx
#undef z
#undef y
#undef x
  mcDEBUG_STATE(
mcnlx,
mcnly,
mcnlz,
mcnlvx,
mcnlvy,
mcnlvz,
mcnlt,
mcnlsx,
mcnlsy,
mcnlsz,
mcnlp)

  /* TRACE Component channel_11_cave1_box1 [542] */
  mccoordschange(mcposrchannel_11_cave1_box1, mcrotrchannel_11_cave1_box1,
    &mcnlx,
    &mcnly,
    &mcnlz,
    &mcnlvx,
    &mcnlvy,
    &mcnlvz,
    &mcnlsx,
    &mcnlsy,
    &mcnlsz);
  /* define label inside component channel_11_cave1_box1 (without coords transformations) */
  mcJumpTrace_channel_11_cave1_box1:
  SIG_MESSAGE("channel_11_cave1_box1 (Trace)");
  mcDEBUG_COMP("channel_11_cave1_box1")
  mcDEBUG_STATE(
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp)
#define x mcnlx
#define y mcnly
#define z mcnlz
#define vx mcnlvx
#define vy mcnlvy
#define vz mcnlvz
#define t mcnlt
#define sx mcnlsx
#define sy mcnlsy
#define sz mcnlsz
#define p mcnlp

#define mcabsorbComp mcabsorbCompchannel_11_cave1_box1
  STORE_NEUTRON(542,
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp);
  mcScattered=0;
  mcRestore=0;
  mcNCounter[542]++;
  mcPCounter[542] += p;
  mcP2Counter[542] += p*p;
#define mccompcurname  channel_11_cave1_box1
#define mccompcurtype  Union_box
#define mccompcurindex 542
#define loop_index mccchannel_11_cave1_box1_loop_index
#define this_box_volume mccchannel_11_cave1_box1_this_box_volume
#define global_geometry_element mccchannel_11_cave1_box1_global_geometry_element
#define this_box_storage mccchannel_11_cave1_box1_this_box_storage
{   /* Declarations of channel_11_cave1_box1=Union_box() SETTING parameters. */
char* material_string = mccchannel_11_cave1_box1_material_string;
MCNUM priority = mccchannel_11_cave1_box1_priority;
MCNUM xwidth = mccchannel_11_cave1_box1_xwidth;
MCNUM yheight = mccchannel_11_cave1_box1_yheight;
MCNUM zdepth = mccchannel_11_cave1_box1_zdepth;
MCNUM xwidth2 = mccchannel_11_cave1_box1_xwidth2;
MCNUM yheight2 = mccchannel_11_cave1_box1_yheight2;
MCNUM visualize = mccchannel_11_cave1_box1_visualize;
int target_index = mccchannel_11_cave1_box1_target_index;
MCNUM target_x = mccchannel_11_cave1_box1_target_x;
MCNUM target_y = mccchannel_11_cave1_box1_target_y;
MCNUM target_z = mccchannel_11_cave1_box1_target_z;
MCNUM focus_aw = mccchannel_11_cave1_box1_focus_aw;
MCNUM focus_ah = mccchannel_11_cave1_box1_focus_ah;
MCNUM focus_xw = mccchannel_11_cave1_box1_focus_xw;
MCNUM focus_xh = mccchannel_11_cave1_box1_focus_xh;
MCNUM focus_r = mccchannel_11_cave1_box1_focus_r;
MCNUM p_interact = mccchannel_11_cave1_box1_p_interact;
char* mask_string = mccchannel_11_cave1_box1_mask_string;
char* mask_setting = mccchannel_11_cave1_box1_mask_setting;
MCNUM number_of_activations = mccchannel_11_cave1_box1_number_of_activations;
}   /* End of channel_11_cave1_box1=Union_box() SETTING parameter declarations. */
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex
  /* Label for restoring  neutron */
  mcabsorbCompchannel_11_cave1_box1:
  if (RESTORE) /* restore if needed */
  { RESTORE_NEUTRON(542,
      mcnlx,
      mcnly,
      mcnlz,
      mcnlvx,
      mcnlvy,
      mcnlvz,
      mcnlt,
      mcnlsx,
      mcnlsy,
      mcnlsz,
      mcnlp); }
#undef mcabsorbComp
#undef p
#undef sz
#undef sy
#undef sx
#undef t
#undef vz
#undef vy
#undef vx
#undef z
#undef y
#undef x
  mcDEBUG_STATE(
mcnlx,
mcnly,
mcnlz,
mcnlvx,
mcnlvy,
mcnlvz,
mcnlt,
mcnlsx,
mcnlsy,
mcnlsz,
mcnlp)

  /* TRACE Component channel_11_cave1_box2 [543] */
  mccoordschange(mcposrchannel_11_cave1_box2, mcrotrchannel_11_cave1_box2,
    &mcnlx,
    &mcnly,
    &mcnlz,
    &mcnlvx,
    &mcnlvy,
    &mcnlvz,
    &mcnlsx,
    &mcnlsy,
    &mcnlsz);
  /* define label inside component channel_11_cave1_box2 (without coords transformations) */
  mcJumpTrace_channel_11_cave1_box2:
  SIG_MESSAGE("channel_11_cave1_box2 (Trace)");
  mcDEBUG_COMP("channel_11_cave1_box2")
  mcDEBUG_STATE(
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp)
#define x mcnlx
#define y mcnly
#define z mcnlz
#define vx mcnlvx
#define vy mcnlvy
#define vz mcnlvz
#define t mcnlt
#define sx mcnlsx
#define sy mcnlsy
#define sz mcnlsz
#define p mcnlp

#define mcabsorbComp mcabsorbCompchannel_11_cave1_box2
  STORE_NEUTRON(543,
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp);
  mcScattered=0;
  mcRestore=0;
  mcNCounter[543]++;
  mcPCounter[543] += p;
  mcP2Counter[543] += p*p;
#define mccompcurname  channel_11_cave1_box2
#define mccompcurtype  Union_box
#define mccompcurindex 543
#define loop_index mccchannel_11_cave1_box2_loop_index
#define this_box_volume mccchannel_11_cave1_box2_this_box_volume
#define global_geometry_element mccchannel_11_cave1_box2_global_geometry_element
#define this_box_storage mccchannel_11_cave1_box2_this_box_storage
{   /* Declarations of channel_11_cave1_box2=Union_box() SETTING parameters. */
char* material_string = mccchannel_11_cave1_box2_material_string;
MCNUM priority = mccchannel_11_cave1_box2_priority;
MCNUM xwidth = mccchannel_11_cave1_box2_xwidth;
MCNUM yheight = mccchannel_11_cave1_box2_yheight;
MCNUM zdepth = mccchannel_11_cave1_box2_zdepth;
MCNUM xwidth2 = mccchannel_11_cave1_box2_xwidth2;
MCNUM yheight2 = mccchannel_11_cave1_box2_yheight2;
MCNUM visualize = mccchannel_11_cave1_box2_visualize;
int target_index = mccchannel_11_cave1_box2_target_index;
MCNUM target_x = mccchannel_11_cave1_box2_target_x;
MCNUM target_y = mccchannel_11_cave1_box2_target_y;
MCNUM target_z = mccchannel_11_cave1_box2_target_z;
MCNUM focus_aw = mccchannel_11_cave1_box2_focus_aw;
MCNUM focus_ah = mccchannel_11_cave1_box2_focus_ah;
MCNUM focus_xw = mccchannel_11_cave1_box2_focus_xw;
MCNUM focus_xh = mccchannel_11_cave1_box2_focus_xh;
MCNUM focus_r = mccchannel_11_cave1_box2_focus_r;
MCNUM p_interact = mccchannel_11_cave1_box2_p_interact;
char* mask_string = mccchannel_11_cave1_box2_mask_string;
char* mask_setting = mccchannel_11_cave1_box2_mask_setting;
MCNUM number_of_activations = mccchannel_11_cave1_box2_number_of_activations;
}   /* End of channel_11_cave1_box2=Union_box() SETTING parameter declarations. */
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex
  /* Label for restoring  neutron */
  mcabsorbCompchannel_11_cave1_box2:
  if (RESTORE) /* restore if needed */
  { RESTORE_NEUTRON(543,
      mcnlx,
      mcnly,
      mcnlz,
      mcnlvx,
      mcnlvy,
      mcnlvz,
      mcnlt,
      mcnlsx,
      mcnlsy,
      mcnlsz,
      mcnlp); }
#undef mcabsorbComp
#undef p
#undef sz
#undef sy
#undef sx
#undef t
#undef vz
#undef vy
#undef vx
#undef z
#undef y
#undef x
  mcDEBUG_STATE(
mcnlx,
mcnly,
mcnlz,
mcnlvx,
mcnlvy,
mcnlvz,
mcnlt,
mcnlsx,
mcnlsy,
mcnlsz,
mcnlp)

  /* TRACE Component channel_11_cave1_box3 [544] */
  mccoordschange(mcposrchannel_11_cave1_box3, mcrotrchannel_11_cave1_box3,
    &mcnlx,
    &mcnly,
    &mcnlz,
    &mcnlvx,
    &mcnlvy,
    &mcnlvz,
    &mcnlsx,
    &mcnlsy,
    &mcnlsz);
  /* define label inside component channel_11_cave1_box3 (without coords transformations) */
  mcJumpTrace_channel_11_cave1_box3:
  SIG_MESSAGE("channel_11_cave1_box3 (Trace)");
  mcDEBUG_COMP("channel_11_cave1_box3")
  mcDEBUG_STATE(
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp)
#define x mcnlx
#define y mcnly
#define z mcnlz
#define vx mcnlvx
#define vy mcnlvy
#define vz mcnlvz
#define t mcnlt
#define sx mcnlsx
#define sy mcnlsy
#define sz mcnlsz
#define p mcnlp

#define mcabsorbComp mcabsorbCompchannel_11_cave1_box3
  STORE_NEUTRON(544,
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp);
  mcScattered=0;
  mcRestore=0;
  mcNCounter[544]++;
  mcPCounter[544] += p;
  mcP2Counter[544] += p*p;
#define mccompcurname  channel_11_cave1_box3
#define mccompcurtype  Union_box
#define mccompcurindex 544
#define loop_index mccchannel_11_cave1_box3_loop_index
#define this_box_volume mccchannel_11_cave1_box3_this_box_volume
#define global_geometry_element mccchannel_11_cave1_box3_global_geometry_element
#define this_box_storage mccchannel_11_cave1_box3_this_box_storage
{   /* Declarations of channel_11_cave1_box3=Union_box() SETTING parameters. */
char* material_string = mccchannel_11_cave1_box3_material_string;
MCNUM priority = mccchannel_11_cave1_box3_priority;
MCNUM xwidth = mccchannel_11_cave1_box3_xwidth;
MCNUM yheight = mccchannel_11_cave1_box3_yheight;
MCNUM zdepth = mccchannel_11_cave1_box3_zdepth;
MCNUM xwidth2 = mccchannel_11_cave1_box3_xwidth2;
MCNUM yheight2 = mccchannel_11_cave1_box3_yheight2;
MCNUM visualize = mccchannel_11_cave1_box3_visualize;
int target_index = mccchannel_11_cave1_box3_target_index;
MCNUM target_x = mccchannel_11_cave1_box3_target_x;
MCNUM target_y = mccchannel_11_cave1_box3_target_y;
MCNUM target_z = mccchannel_11_cave1_box3_target_z;
MCNUM focus_aw = mccchannel_11_cave1_box3_focus_aw;
MCNUM focus_ah = mccchannel_11_cave1_box3_focus_ah;
MCNUM focus_xw = mccchannel_11_cave1_box3_focus_xw;
MCNUM focus_xh = mccchannel_11_cave1_box3_focus_xh;
MCNUM focus_r = mccchannel_11_cave1_box3_focus_r;
MCNUM p_interact = mccchannel_11_cave1_box3_p_interact;
char* mask_string = mccchannel_11_cave1_box3_mask_string;
char* mask_setting = mccchannel_11_cave1_box3_mask_setting;
MCNUM number_of_activations = mccchannel_11_cave1_box3_number_of_activations;
}   /* End of channel_11_cave1_box3=Union_box() SETTING parameter declarations. */
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex
  /* Label for restoring  neutron */
  mcabsorbCompchannel_11_cave1_box3:
  if (RESTORE) /* restore if needed */
  { RESTORE_NEUTRON(544,
      mcnlx,
      mcnly,
      mcnlz,
      mcnlvx,
      mcnlvy,
      mcnlvz,
      mcnlt,
      mcnlsx,
      mcnlsy,
      mcnlsz,
      mcnlp); }
#undef mcabsorbComp
#undef p
#undef sz
#undef sy
#undef sx
#undef t
#undef vz
#undef vy
#undef vx
#undef z
#undef y
#undef x
  mcDEBUG_STATE(
mcnlx,
mcnly,
mcnlz,
mcnlvx,
mcnlvy,
mcnlvz,
mcnlt,
mcnlsx,
mcnlsy,
mcnlsz,
mcnlp)

  /* TRACE Component channel_11_cave1_cyl1 [545] */
  mccoordschange(mcposrchannel_11_cave1_cyl1, mcrotrchannel_11_cave1_cyl1,
    &mcnlx,
    &mcnly,
    &mcnlz,
    &mcnlvx,
    &mcnlvy,
    &mcnlvz,
    &mcnlsx,
    &mcnlsy,
    &mcnlsz);
  /* define label inside component channel_11_cave1_cyl1 (without coords transformations) */
  mcJumpTrace_channel_11_cave1_cyl1:
  SIG_MESSAGE("channel_11_cave1_cyl1 (Trace)");
  mcDEBUG_COMP("channel_11_cave1_cyl1")
  mcDEBUG_STATE(
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp)
#define x mcnlx
#define y mcnly
#define z mcnlz
#define vx mcnlvx
#define vy mcnlvy
#define vz mcnlvz
#define t mcnlt
#define sx mcnlsx
#define sy mcnlsy
#define sz mcnlsz
#define p mcnlp

#define mcabsorbComp mcabsorbCompchannel_11_cave1_cyl1
  STORE_NEUTRON(545,
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp);
  mcScattered=0;
  mcRestore=0;
  mcNCounter[545]++;
  mcPCounter[545] += p;
  mcP2Counter[545] += p*p;
#define mccompcurname  channel_11_cave1_cyl1
#define mccompcurtype  Union_cylinder
#define mccompcurindex 545
#define loop_index mccchannel_11_cave1_cyl1_loop_index
#define this_cylinder_volume mccchannel_11_cave1_cyl1_this_cylinder_volume
#define global_geometry_element mccchannel_11_cave1_cyl1_global_geometry_element
#define this_cylinder_storage mccchannel_11_cave1_cyl1_this_cylinder_storage
{   /* Declarations of channel_11_cave1_cyl1=Union_cylinder() SETTING parameters. */
char* material_string = mccchannel_11_cave1_cyl1_material_string;
MCNUM priority = mccchannel_11_cave1_cyl1_priority;
MCNUM radius = mccchannel_11_cave1_cyl1_radius;
MCNUM yheight = mccchannel_11_cave1_cyl1_yheight;
MCNUM visualize = mccchannel_11_cave1_cyl1_visualize;
int target_index = mccchannel_11_cave1_cyl1_target_index;
MCNUM target_x = mccchannel_11_cave1_cyl1_target_x;
MCNUM target_y = mccchannel_11_cave1_cyl1_target_y;
MCNUM target_z = mccchannel_11_cave1_cyl1_target_z;
MCNUM focus_aw = mccchannel_11_cave1_cyl1_focus_aw;
MCNUM focus_ah = mccchannel_11_cave1_cyl1_focus_ah;
MCNUM focus_xw = mccchannel_11_cave1_cyl1_focus_xw;
MCNUM focus_xh = mccchannel_11_cave1_cyl1_focus_xh;
MCNUM focus_r = mccchannel_11_cave1_cyl1_focus_r;
MCNUM p_interact = mccchannel_11_cave1_cyl1_p_interact;
char* mask_string = mccchannel_11_cave1_cyl1_mask_string;
char* mask_setting = mccchannel_11_cave1_cyl1_mask_setting;
MCNUM number_of_activations = mccchannel_11_cave1_cyl1_number_of_activations;
#line 345 "Union_cylinder.comp"
{
dummy = 1;
}
#line 417409 "MACS_sample_kidney_box.c"
}   /* End of channel_11_cave1_cyl1=Union_cylinder() SETTING parameter declarations. */
#undef this_cylinder_storage
#undef global_geometry_element
#undef this_cylinder_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex
  /* Label for restoring  neutron */
  mcabsorbCompchannel_11_cave1_cyl1:
  if (RESTORE) /* restore if needed */
  { RESTORE_NEUTRON(545,
      mcnlx,
      mcnly,
      mcnlz,
      mcnlvx,
      mcnlvy,
      mcnlvz,
      mcnlt,
      mcnlsx,
      mcnlsy,
      mcnlsz,
      mcnlp); }
#undef mcabsorbComp
#undef p
#undef sz
#undef sy
#undef sx
#undef t
#undef vz
#undef vy
#undef vx
#undef z
#undef y
#undef x
  mcDEBUG_STATE(
mcnlx,
mcnly,
mcnlz,
mcnlvx,
mcnlvy,
mcnlvz,
mcnlt,
mcnlsx,
mcnlsy,
mcnlsz,
mcnlp)

  /* TRACE Component channel_11_analyzer_1_center [546] */
  mccoordschange(mcposrchannel_11_analyzer_1_center, mcrotrchannel_11_analyzer_1_center,
    &mcnlx,
    &mcnly,
    &mcnlz,
    &mcnlvx,
    &mcnlvy,
    &mcnlvz,
    &mcnlsx,
    &mcnlsy,
    &mcnlsz);
  /* define label inside component channel_11_analyzer_1_center (without coords transformations) */
  mcJumpTrace_channel_11_analyzer_1_center:
  SIG_MESSAGE("channel_11_analyzer_1_center (Trace)");
  mcDEBUG_COMP("channel_11_analyzer_1_center")
  mcDEBUG_STATE(
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp)
#define x mcnlx
#define y mcnly
#define z mcnlz
#define vx mcnlvx
#define vy mcnlvy
#define vz mcnlvz
#define t mcnlt
#define sx mcnlsx
#define sy mcnlsy
#define sz mcnlsz
#define p mcnlp

#define mcabsorbComp mcabsorbCompchannel_11_analyzer_1_center
  STORE_NEUTRON(546,
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp);
  mcScattered=0;
  mcRestore=0;
  mcNCounter[546]++;
  mcPCounter[546] += p;
  mcP2Counter[546] += p*p;
#define mccompcurname  channel_11_analyzer_1_center
#define mccompcurtype  Arm
#define mccompcurindex 546
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex
  /* Label for restoring  neutron */
  mcabsorbCompchannel_11_analyzer_1_center:
  if (RESTORE) /* restore if needed */
  { RESTORE_NEUTRON(546,
      mcnlx,
      mcnly,
      mcnlz,
      mcnlvx,
      mcnlvy,
      mcnlvz,
      mcnlt,
      mcnlsx,
      mcnlsy,
      mcnlsz,
      mcnlp); }
#undef mcabsorbComp
#undef p
#undef sz
#undef sy
#undef sx
#undef t
#undef vz
#undef vy
#undef vx
#undef z
#undef y
#undef x
  mcDEBUG_STATE(
mcnlx,
mcnly,
mcnlz,
mcnlvx,
mcnlvy,
mcnlvz,
mcnlt,
mcnlsx,
mcnlsy,
mcnlsz,
mcnlp)

  /* TRACE Component channel_11_analyzer_1_rotated [547] */
  mccoordschange(mcposrchannel_11_analyzer_1_rotated, mcrotrchannel_11_analyzer_1_rotated,
    &mcnlx,
    &mcnly,
    &mcnlz,
    &mcnlvx,
    &mcnlvy,
    &mcnlvz,
    &mcnlsx,
    &mcnlsy,
    &mcnlsz);
  /* define label inside component channel_11_analyzer_1_rotated (without coords transformations) */
  mcJumpTrace_channel_11_analyzer_1_rotated:
  SIG_MESSAGE("channel_11_analyzer_1_rotated (Trace)");
  mcDEBUG_COMP("channel_11_analyzer_1_rotated")
  mcDEBUG_STATE(
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp)
#define x mcnlx
#define y mcnly
#define z mcnlz
#define vx mcnlvx
#define vy mcnlvy
#define vz mcnlvz
#define t mcnlt
#define sx mcnlsx
#define sy mcnlsy
#define sz mcnlsz
#define p mcnlp

#define mcabsorbComp mcabsorbCompchannel_11_analyzer_1_rotated
  STORE_NEUTRON(547,
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp);
  mcScattered=0;
  mcRestore=0;
  mcNCounter[547]++;
  mcPCounter[547] += p;
  mcP2Counter[547] += p*p;
#define mccompcurname  channel_11_analyzer_1_rotated
#define mccompcurtype  Arm
#define mccompcurindex 547
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex
  /* Label for restoring  neutron */
  mcabsorbCompchannel_11_analyzer_1_rotated:
  if (RESTORE) /* restore if needed */
  { RESTORE_NEUTRON(547,
      mcnlx,
      mcnly,
      mcnlz,
      mcnlvx,
      mcnlvy,
      mcnlvz,
      mcnlt,
      mcnlsx,
      mcnlsy,
      mcnlsz,
      mcnlp); }
#undef mcabsorbComp
#undef p
#undef sz
#undef sy
#undef sx
#undef t
#undef vz
#undef vy
#undef vx
#undef z
#undef y
#undef x
  mcDEBUG_STATE(
mcnlx,
mcnly,
mcnlz,
mcnlvx,
mcnlvy,
mcnlvz,
mcnlt,
mcnlsx,
mcnlsy,
mcnlsz,
mcnlp)

  /* TRACE Component channel_11_analyzer_1_array_crystal_array_0 [548] */
  mccoordschange(mcposrchannel_11_analyzer_1_array_crystal_array_0, mcrotrchannel_11_analyzer_1_array_crystal_array_0,
    &mcnlx,
    &mcnly,
    &mcnlz,
    &mcnlvx,
    &mcnlvy,
    &mcnlvz,
    &mcnlsx,
    &mcnlsy,
    &mcnlsz);
  /* define label inside component channel_11_analyzer_1_array_crystal_array_0 (without coords transformations) */
  mcJumpTrace_channel_11_analyzer_1_array_crystal_array_0:
  SIG_MESSAGE("channel_11_analyzer_1_array_crystal_array_0 (Trace)");
  mcDEBUG_COMP("channel_11_analyzer_1_array_crystal_array_0")
  mcDEBUG_STATE(
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp)
#define x mcnlx
#define y mcnly
#define z mcnlz
#define vx mcnlvx
#define vy mcnlvy
#define vz mcnlvz
#define t mcnlt
#define sx mcnlsx
#define sy mcnlsy
#define sz mcnlsz
#define p mcnlp

#define mcabsorbComp mcabsorbCompchannel_11_analyzer_1_array_crystal_array_0
  STORE_NEUTRON(548,
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp);
  mcScattered=0;
  mcRestore=0;
  mcNCounter[548]++;
  mcPCounter[548] += p;
  mcP2Counter[548] += p*p;
#define mccompcurname  channel_11_analyzer_1_array_crystal_array_0
#define mccompcurtype  Union_box
#define mccompcurindex 548
#define loop_index mccchannel_11_analyzer_1_array_crystal_array_0_loop_index
#define this_box_volume mccchannel_11_analyzer_1_array_crystal_array_0_this_box_volume
#define global_geometry_element mccchannel_11_analyzer_1_array_crystal_array_0_global_geometry_element
#define this_box_storage mccchannel_11_analyzer_1_array_crystal_array_0_this_box_storage
{   /* Declarations of channel_11_analyzer_1_array_crystal_array_0=Union_box() SETTING parameters. */
char* material_string = mccchannel_11_analyzer_1_array_crystal_array_0_material_string;
MCNUM priority = mccchannel_11_analyzer_1_array_crystal_array_0_priority;
MCNUM xwidth = mccchannel_11_analyzer_1_array_crystal_array_0_xwidth;
MCNUM yheight = mccchannel_11_analyzer_1_array_crystal_array_0_yheight;
MCNUM zdepth = mccchannel_11_analyzer_1_array_crystal_array_0_zdepth;
MCNUM xwidth2 = mccchannel_11_analyzer_1_array_crystal_array_0_xwidth2;
MCNUM yheight2 = mccchannel_11_analyzer_1_array_crystal_array_0_yheight2;
MCNUM visualize = mccchannel_11_analyzer_1_array_crystal_array_0_visualize;
int target_index = mccchannel_11_analyzer_1_array_crystal_array_0_target_index;
MCNUM target_x = mccchannel_11_analyzer_1_array_crystal_array_0_target_x;
MCNUM target_y = mccchannel_11_analyzer_1_array_crystal_array_0_target_y;
MCNUM target_z = mccchannel_11_analyzer_1_array_crystal_array_0_target_z;
MCNUM focus_aw = mccchannel_11_analyzer_1_array_crystal_array_0_focus_aw;
MCNUM focus_ah = mccchannel_11_analyzer_1_array_crystal_array_0_focus_ah;
MCNUM focus_xw = mccchannel_11_analyzer_1_array_crystal_array_0_focus_xw;
MCNUM focus_xh = mccchannel_11_analyzer_1_array_crystal_array_0_focus_xh;
MCNUM focus_r = mccchannel_11_analyzer_1_array_crystal_array_0_focus_r;
MCNUM p_interact = mccchannel_11_analyzer_1_array_crystal_array_0_p_interact;
char* mask_string = mccchannel_11_analyzer_1_array_crystal_array_0_mask_string;
char* mask_setting = mccchannel_11_analyzer_1_array_crystal_array_0_mask_setting;
MCNUM number_of_activations = mccchannel_11_analyzer_1_array_crystal_array_0_number_of_activations;
}   /* End of channel_11_analyzer_1_array_crystal_array_0=Union_box() SETTING parameter declarations. */
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex
  /* Label for restoring  neutron */
  mcabsorbCompchannel_11_analyzer_1_array_crystal_array_0:
  if (RESTORE) /* restore if needed */
  { RESTORE_NEUTRON(548,
      mcnlx,
      mcnly,
      mcnlz,
      mcnlvx,
      mcnlvy,
      mcnlvz,
      mcnlt,
      mcnlsx,
      mcnlsy,
      mcnlsz,
      mcnlp); }
#undef mcabsorbComp
#undef p
#undef sz
#undef sy
#undef sx
#undef t
#undef vz
#undef vy
#undef vx
#undef z
#undef y
#undef x
  mcDEBUG_STATE(
mcnlx,
mcnly,
mcnlz,
mcnlvx,
mcnlvy,
mcnlvz,
mcnlt,
mcnlsx,
mcnlsy,
mcnlsz,
mcnlp)

  /* TRACE Component channel_11_analyzer_1_array_crystal_array_1 [549] */
  mccoordschange(mcposrchannel_11_analyzer_1_array_crystal_array_1, mcrotrchannel_11_analyzer_1_array_crystal_array_1,
    &mcnlx,
    &mcnly,
    &mcnlz,
    &mcnlvx,
    &mcnlvy,
    &mcnlvz,
    &mcnlsx,
    &mcnlsy,
    &mcnlsz);
  /* define label inside component channel_11_analyzer_1_array_crystal_array_1 (without coords transformations) */
  mcJumpTrace_channel_11_analyzer_1_array_crystal_array_1:
  SIG_MESSAGE("channel_11_analyzer_1_array_crystal_array_1 (Trace)");
  mcDEBUG_COMP("channel_11_analyzer_1_array_crystal_array_1")
  mcDEBUG_STATE(
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp)
#define x mcnlx
#define y mcnly
#define z mcnlz
#define vx mcnlvx
#define vy mcnlvy
#define vz mcnlvz
#define t mcnlt
#define sx mcnlsx
#define sy mcnlsy
#define sz mcnlsz
#define p mcnlp

#define mcabsorbComp mcabsorbCompchannel_11_analyzer_1_array_crystal_array_1
  STORE_NEUTRON(549,
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp);
  mcScattered=0;
  mcRestore=0;
  mcNCounter[549]++;
  mcPCounter[549] += p;
  mcP2Counter[549] += p*p;
#define mccompcurname  channel_11_analyzer_1_array_crystal_array_1
#define mccompcurtype  Union_box
#define mccompcurindex 549
#define loop_index mccchannel_11_analyzer_1_array_crystal_array_1_loop_index
#define this_box_volume mccchannel_11_analyzer_1_array_crystal_array_1_this_box_volume
#define global_geometry_element mccchannel_11_analyzer_1_array_crystal_array_1_global_geometry_element
#define this_box_storage mccchannel_11_analyzer_1_array_crystal_array_1_this_box_storage
{   /* Declarations of channel_11_analyzer_1_array_crystal_array_1=Union_box() SETTING parameters. */
char* material_string = mccchannel_11_analyzer_1_array_crystal_array_1_material_string;
MCNUM priority = mccchannel_11_analyzer_1_array_crystal_array_1_priority;
MCNUM xwidth = mccchannel_11_analyzer_1_array_crystal_array_1_xwidth;
MCNUM yheight = mccchannel_11_analyzer_1_array_crystal_array_1_yheight;
MCNUM zdepth = mccchannel_11_analyzer_1_array_crystal_array_1_zdepth;
MCNUM xwidth2 = mccchannel_11_analyzer_1_array_crystal_array_1_xwidth2;
MCNUM yheight2 = mccchannel_11_analyzer_1_array_crystal_array_1_yheight2;
MCNUM visualize = mccchannel_11_analyzer_1_array_crystal_array_1_visualize;
int target_index = mccchannel_11_analyzer_1_array_crystal_array_1_target_index;
MCNUM target_x = mccchannel_11_analyzer_1_array_crystal_array_1_target_x;
MCNUM target_y = mccchannel_11_analyzer_1_array_crystal_array_1_target_y;
MCNUM target_z = mccchannel_11_analyzer_1_array_crystal_array_1_target_z;
MCNUM focus_aw = mccchannel_11_analyzer_1_array_crystal_array_1_focus_aw;
MCNUM focus_ah = mccchannel_11_analyzer_1_array_crystal_array_1_focus_ah;
MCNUM focus_xw = mccchannel_11_analyzer_1_array_crystal_array_1_focus_xw;
MCNUM focus_xh = mccchannel_11_analyzer_1_array_crystal_array_1_focus_xh;
MCNUM focus_r = mccchannel_11_analyzer_1_array_crystal_array_1_focus_r;
MCNUM p_interact = mccchannel_11_analyzer_1_array_crystal_array_1_p_interact;
char* mask_string = mccchannel_11_analyzer_1_array_crystal_array_1_mask_string;
char* mask_setting = mccchannel_11_analyzer_1_array_crystal_array_1_mask_setting;
MCNUM number_of_activations = mccchannel_11_analyzer_1_array_crystal_array_1_number_of_activations;
}   /* End of channel_11_analyzer_1_array_crystal_array_1=Union_box() SETTING parameter declarations. */
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex
  /* Label for restoring  neutron */
  mcabsorbCompchannel_11_analyzer_1_array_crystal_array_1:
  if (RESTORE) /* restore if needed */
  { RESTORE_NEUTRON(549,
      mcnlx,
      mcnly,
      mcnlz,
      mcnlvx,
      mcnlvy,
      mcnlvz,
      mcnlt,
      mcnlsx,
      mcnlsy,
      mcnlsz,
      mcnlp); }
#undef mcabsorbComp
#undef p
#undef sz
#undef sy
#undef sx
#undef t
#undef vz
#undef vy
#undef vx
#undef z
#undef y
#undef x
  mcDEBUG_STATE(
mcnlx,
mcnly,
mcnlz,
mcnlvx,
mcnlvy,
mcnlvz,
mcnlt,
mcnlsx,
mcnlsy,
mcnlsz,
mcnlp)

  /* TRACE Component channel_11_analyzer_1_array_crystal_array_2 [550] */
  mccoordschange(mcposrchannel_11_analyzer_1_array_crystal_array_2, mcrotrchannel_11_analyzer_1_array_crystal_array_2,
    &mcnlx,
    &mcnly,
    &mcnlz,
    &mcnlvx,
    &mcnlvy,
    &mcnlvz,
    &mcnlsx,
    &mcnlsy,
    &mcnlsz);
  /* define label inside component channel_11_analyzer_1_array_crystal_array_2 (without coords transformations) */
  mcJumpTrace_channel_11_analyzer_1_array_crystal_array_2:
  SIG_MESSAGE("channel_11_analyzer_1_array_crystal_array_2 (Trace)");
  mcDEBUG_COMP("channel_11_analyzer_1_array_crystal_array_2")
  mcDEBUG_STATE(
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp)
#define x mcnlx
#define y mcnly
#define z mcnlz
#define vx mcnlvx
#define vy mcnlvy
#define vz mcnlvz
#define t mcnlt
#define sx mcnlsx
#define sy mcnlsy
#define sz mcnlsz
#define p mcnlp

#define mcabsorbComp mcabsorbCompchannel_11_analyzer_1_array_crystal_array_2
  STORE_NEUTRON(550,
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp);
  mcScattered=0;
  mcRestore=0;
  mcNCounter[550]++;
  mcPCounter[550] += p;
  mcP2Counter[550] += p*p;
#define mccompcurname  channel_11_analyzer_1_array_crystal_array_2
#define mccompcurtype  Union_box
#define mccompcurindex 550
#define loop_index mccchannel_11_analyzer_1_array_crystal_array_2_loop_index
#define this_box_volume mccchannel_11_analyzer_1_array_crystal_array_2_this_box_volume
#define global_geometry_element mccchannel_11_analyzer_1_array_crystal_array_2_global_geometry_element
#define this_box_storage mccchannel_11_analyzer_1_array_crystal_array_2_this_box_storage
{   /* Declarations of channel_11_analyzer_1_array_crystal_array_2=Union_box() SETTING parameters. */
char* material_string = mccchannel_11_analyzer_1_array_crystal_array_2_material_string;
MCNUM priority = mccchannel_11_analyzer_1_array_crystal_array_2_priority;
MCNUM xwidth = mccchannel_11_analyzer_1_array_crystal_array_2_xwidth;
MCNUM yheight = mccchannel_11_analyzer_1_array_crystal_array_2_yheight;
MCNUM zdepth = mccchannel_11_analyzer_1_array_crystal_array_2_zdepth;
MCNUM xwidth2 = mccchannel_11_analyzer_1_array_crystal_array_2_xwidth2;
MCNUM yheight2 = mccchannel_11_analyzer_1_array_crystal_array_2_yheight2;
MCNUM visualize = mccchannel_11_analyzer_1_array_crystal_array_2_visualize;
int target_index = mccchannel_11_analyzer_1_array_crystal_array_2_target_index;
MCNUM target_x = mccchannel_11_analyzer_1_array_crystal_array_2_target_x;
MCNUM target_y = mccchannel_11_analyzer_1_array_crystal_array_2_target_y;
MCNUM target_z = mccchannel_11_analyzer_1_array_crystal_array_2_target_z;
MCNUM focus_aw = mccchannel_11_analyzer_1_array_crystal_array_2_focus_aw;
MCNUM focus_ah = mccchannel_11_analyzer_1_array_crystal_array_2_focus_ah;
MCNUM focus_xw = mccchannel_11_analyzer_1_array_crystal_array_2_focus_xw;
MCNUM focus_xh = mccchannel_11_analyzer_1_array_crystal_array_2_focus_xh;
MCNUM focus_r = mccchannel_11_analyzer_1_array_crystal_array_2_focus_r;
MCNUM p_interact = mccchannel_11_analyzer_1_array_crystal_array_2_p_interact;
char* mask_string = mccchannel_11_analyzer_1_array_crystal_array_2_mask_string;
char* mask_setting = mccchannel_11_analyzer_1_array_crystal_array_2_mask_setting;
MCNUM number_of_activations = mccchannel_11_analyzer_1_array_crystal_array_2_number_of_activations;
}   /* End of channel_11_analyzer_1_array_crystal_array_2=Union_box() SETTING parameter declarations. */
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex
  /* Label for restoring  neutron */
  mcabsorbCompchannel_11_analyzer_1_array_crystal_array_2:
  if (RESTORE) /* restore if needed */
  { RESTORE_NEUTRON(550,
      mcnlx,
      mcnly,
      mcnlz,
      mcnlvx,
      mcnlvy,
      mcnlvz,
      mcnlt,
      mcnlsx,
      mcnlsy,
      mcnlsz,
      mcnlp); }
#undef mcabsorbComp
#undef p
#undef sz
#undef sy
#undef sx
#undef t
#undef vz
#undef vy
#undef vx
#undef z
#undef y
#undef x
  mcDEBUG_STATE(
mcnlx,
mcnly,
mcnlz,
mcnlvx,
mcnlvy,
mcnlvz,
mcnlt,
mcnlsx,
mcnlsy,
mcnlsz,
mcnlp)

  /* TRACE Component channel_11_analyzer_1_array_crystal_array_3 [551] */
  mccoordschange(mcposrchannel_11_analyzer_1_array_crystal_array_3, mcrotrchannel_11_analyzer_1_array_crystal_array_3,
    &mcnlx,
    &mcnly,
    &mcnlz,
    &mcnlvx,
    &mcnlvy,
    &mcnlvz,
    &mcnlsx,
    &mcnlsy,
    &mcnlsz);
  /* define label inside component channel_11_analyzer_1_array_crystal_array_3 (without coords transformations) */
  mcJumpTrace_channel_11_analyzer_1_array_crystal_array_3:
  SIG_MESSAGE("channel_11_analyzer_1_array_crystal_array_3 (Trace)");
  mcDEBUG_COMP("channel_11_analyzer_1_array_crystal_array_3")
  mcDEBUG_STATE(
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp)
#define x mcnlx
#define y mcnly
#define z mcnlz
#define vx mcnlvx
#define vy mcnlvy
#define vz mcnlvz
#define t mcnlt
#define sx mcnlsx
#define sy mcnlsy
#define sz mcnlsz
#define p mcnlp

#define mcabsorbComp mcabsorbCompchannel_11_analyzer_1_array_crystal_array_3
  STORE_NEUTRON(551,
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp);
  mcScattered=0;
  mcRestore=0;
  mcNCounter[551]++;
  mcPCounter[551] += p;
  mcP2Counter[551] += p*p;
#define mccompcurname  channel_11_analyzer_1_array_crystal_array_3
#define mccompcurtype  Union_box
#define mccompcurindex 551
#define loop_index mccchannel_11_analyzer_1_array_crystal_array_3_loop_index
#define this_box_volume mccchannel_11_analyzer_1_array_crystal_array_3_this_box_volume
#define global_geometry_element mccchannel_11_analyzer_1_array_crystal_array_3_global_geometry_element
#define this_box_storage mccchannel_11_analyzer_1_array_crystal_array_3_this_box_storage
{   /* Declarations of channel_11_analyzer_1_array_crystal_array_3=Union_box() SETTING parameters. */
char* material_string = mccchannel_11_analyzer_1_array_crystal_array_3_material_string;
MCNUM priority = mccchannel_11_analyzer_1_array_crystal_array_3_priority;
MCNUM xwidth = mccchannel_11_analyzer_1_array_crystal_array_3_xwidth;
MCNUM yheight = mccchannel_11_analyzer_1_array_crystal_array_3_yheight;
MCNUM zdepth = mccchannel_11_analyzer_1_array_crystal_array_3_zdepth;
MCNUM xwidth2 = mccchannel_11_analyzer_1_array_crystal_array_3_xwidth2;
MCNUM yheight2 = mccchannel_11_analyzer_1_array_crystal_array_3_yheight2;
MCNUM visualize = mccchannel_11_analyzer_1_array_crystal_array_3_visualize;
int target_index = mccchannel_11_analyzer_1_array_crystal_array_3_target_index;
MCNUM target_x = mccchannel_11_analyzer_1_array_crystal_array_3_target_x;
MCNUM target_y = mccchannel_11_analyzer_1_array_crystal_array_3_target_y;
MCNUM target_z = mccchannel_11_analyzer_1_array_crystal_array_3_target_z;
MCNUM focus_aw = mccchannel_11_analyzer_1_array_crystal_array_3_focus_aw;
MCNUM focus_ah = mccchannel_11_analyzer_1_array_crystal_array_3_focus_ah;
MCNUM focus_xw = mccchannel_11_analyzer_1_array_crystal_array_3_focus_xw;
MCNUM focus_xh = mccchannel_11_analyzer_1_array_crystal_array_3_focus_xh;
MCNUM focus_r = mccchannel_11_analyzer_1_array_crystal_array_3_focus_r;
MCNUM p_interact = mccchannel_11_analyzer_1_array_crystal_array_3_p_interact;
char* mask_string = mccchannel_11_analyzer_1_array_crystal_array_3_mask_string;
char* mask_setting = mccchannel_11_analyzer_1_array_crystal_array_3_mask_setting;
MCNUM number_of_activations = mccchannel_11_analyzer_1_array_crystal_array_3_number_of_activations;
}   /* End of channel_11_analyzer_1_array_crystal_array_3=Union_box() SETTING parameter declarations. */
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex
  /* Label for restoring  neutron */
  mcabsorbCompchannel_11_analyzer_1_array_crystal_array_3:
  if (RESTORE) /* restore if needed */
  { RESTORE_NEUTRON(551,
      mcnlx,
      mcnly,
      mcnlz,
      mcnlvx,
      mcnlvy,
      mcnlvz,
      mcnlt,
      mcnlsx,
      mcnlsy,
      mcnlsz,
      mcnlp); }
#undef mcabsorbComp
#undef p
#undef sz
#undef sy
#undef sx
#undef t
#undef vz
#undef vy
#undef vx
#undef z
#undef y
#undef x
  mcDEBUG_STATE(
mcnlx,
mcnly,
mcnlz,
mcnlvx,
mcnlvy,
mcnlvz,
mcnlt,
mcnlsx,
mcnlsy,
mcnlsz,
mcnlp)

  /* TRACE Component channel_11_analyzer_1_array_crystal_array_4 [552] */
  mccoordschange(mcposrchannel_11_analyzer_1_array_crystal_array_4, mcrotrchannel_11_analyzer_1_array_crystal_array_4,
    &mcnlx,
    &mcnly,
    &mcnlz,
    &mcnlvx,
    &mcnlvy,
    &mcnlvz,
    &mcnlsx,
    &mcnlsy,
    &mcnlsz);
  /* define label inside component channel_11_analyzer_1_array_crystal_array_4 (without coords transformations) */
  mcJumpTrace_channel_11_analyzer_1_array_crystal_array_4:
  SIG_MESSAGE("channel_11_analyzer_1_array_crystal_array_4 (Trace)");
  mcDEBUG_COMP("channel_11_analyzer_1_array_crystal_array_4")
  mcDEBUG_STATE(
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp)
#define x mcnlx
#define y mcnly
#define z mcnlz
#define vx mcnlvx
#define vy mcnlvy
#define vz mcnlvz
#define t mcnlt
#define sx mcnlsx
#define sy mcnlsy
#define sz mcnlsz
#define p mcnlp

#define mcabsorbComp mcabsorbCompchannel_11_analyzer_1_array_crystal_array_4
  STORE_NEUTRON(552,
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp);
  mcScattered=0;
  mcRestore=0;
  mcNCounter[552]++;
  mcPCounter[552] += p;
  mcP2Counter[552] += p*p;
#define mccompcurname  channel_11_analyzer_1_array_crystal_array_4
#define mccompcurtype  Union_box
#define mccompcurindex 552
#define loop_index mccchannel_11_analyzer_1_array_crystal_array_4_loop_index
#define this_box_volume mccchannel_11_analyzer_1_array_crystal_array_4_this_box_volume
#define global_geometry_element mccchannel_11_analyzer_1_array_crystal_array_4_global_geometry_element
#define this_box_storage mccchannel_11_analyzer_1_array_crystal_array_4_this_box_storage
{   /* Declarations of channel_11_analyzer_1_array_crystal_array_4=Union_box() SETTING parameters. */
char* material_string = mccchannel_11_analyzer_1_array_crystal_array_4_material_string;
MCNUM priority = mccchannel_11_analyzer_1_array_crystal_array_4_priority;
MCNUM xwidth = mccchannel_11_analyzer_1_array_crystal_array_4_xwidth;
MCNUM yheight = mccchannel_11_analyzer_1_array_crystal_array_4_yheight;
MCNUM zdepth = mccchannel_11_analyzer_1_array_crystal_array_4_zdepth;
MCNUM xwidth2 = mccchannel_11_analyzer_1_array_crystal_array_4_xwidth2;
MCNUM yheight2 = mccchannel_11_analyzer_1_array_crystal_array_4_yheight2;
MCNUM visualize = mccchannel_11_analyzer_1_array_crystal_array_4_visualize;
int target_index = mccchannel_11_analyzer_1_array_crystal_array_4_target_index;
MCNUM target_x = mccchannel_11_analyzer_1_array_crystal_array_4_target_x;
MCNUM target_y = mccchannel_11_analyzer_1_array_crystal_array_4_target_y;
MCNUM target_z = mccchannel_11_analyzer_1_array_crystal_array_4_target_z;
MCNUM focus_aw = mccchannel_11_analyzer_1_array_crystal_array_4_focus_aw;
MCNUM focus_ah = mccchannel_11_analyzer_1_array_crystal_array_4_focus_ah;
MCNUM focus_xw = mccchannel_11_analyzer_1_array_crystal_array_4_focus_xw;
MCNUM focus_xh = mccchannel_11_analyzer_1_array_crystal_array_4_focus_xh;
MCNUM focus_r = mccchannel_11_analyzer_1_array_crystal_array_4_focus_r;
MCNUM p_interact = mccchannel_11_analyzer_1_array_crystal_array_4_p_interact;
char* mask_string = mccchannel_11_analyzer_1_array_crystal_array_4_mask_string;
char* mask_setting = mccchannel_11_analyzer_1_array_crystal_array_4_mask_setting;
MCNUM number_of_activations = mccchannel_11_analyzer_1_array_crystal_array_4_number_of_activations;
}   /* End of channel_11_analyzer_1_array_crystal_array_4=Union_box() SETTING parameter declarations. */
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex
  /* Label for restoring  neutron */
  mcabsorbCompchannel_11_analyzer_1_array_crystal_array_4:
  if (RESTORE) /* restore if needed */
  { RESTORE_NEUTRON(552,
      mcnlx,
      mcnly,
      mcnlz,
      mcnlvx,
      mcnlvy,
      mcnlvz,
      mcnlt,
      mcnlsx,
      mcnlsy,
      mcnlsz,
      mcnlp); }
#undef mcabsorbComp
#undef p
#undef sz
#undef sy
#undef sx
#undef t
#undef vz
#undef vy
#undef vx
#undef z
#undef y
#undef x
  mcDEBUG_STATE(
mcnlx,
mcnly,
mcnlz,
mcnlvx,
mcnlvy,
mcnlvz,
mcnlt,
mcnlsx,
mcnlsy,
mcnlsz,
mcnlp)

  /* TRACE Component channel_11_analyzer_1_array_crystal_array_5 [553] */
  mccoordschange(mcposrchannel_11_analyzer_1_array_crystal_array_5, mcrotrchannel_11_analyzer_1_array_crystal_array_5,
    &mcnlx,
    &mcnly,
    &mcnlz,
    &mcnlvx,
    &mcnlvy,
    &mcnlvz,
    &mcnlsx,
    &mcnlsy,
    &mcnlsz);
  /* define label inside component channel_11_analyzer_1_array_crystal_array_5 (without coords transformations) */
  mcJumpTrace_channel_11_analyzer_1_array_crystal_array_5:
  SIG_MESSAGE("channel_11_analyzer_1_array_crystal_array_5 (Trace)");
  mcDEBUG_COMP("channel_11_analyzer_1_array_crystal_array_5")
  mcDEBUG_STATE(
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp)
#define x mcnlx
#define y mcnly
#define z mcnlz
#define vx mcnlvx
#define vy mcnlvy
#define vz mcnlvz
#define t mcnlt
#define sx mcnlsx
#define sy mcnlsy
#define sz mcnlsz
#define p mcnlp

#define mcabsorbComp mcabsorbCompchannel_11_analyzer_1_array_crystal_array_5
  STORE_NEUTRON(553,
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp);
  mcScattered=0;
  mcRestore=0;
  mcNCounter[553]++;
  mcPCounter[553] += p;
  mcP2Counter[553] += p*p;
#define mccompcurname  channel_11_analyzer_1_array_crystal_array_5
#define mccompcurtype  Union_box
#define mccompcurindex 553
#define loop_index mccchannel_11_analyzer_1_array_crystal_array_5_loop_index
#define this_box_volume mccchannel_11_analyzer_1_array_crystal_array_5_this_box_volume
#define global_geometry_element mccchannel_11_analyzer_1_array_crystal_array_5_global_geometry_element
#define this_box_storage mccchannel_11_analyzer_1_array_crystal_array_5_this_box_storage
{   /* Declarations of channel_11_analyzer_1_array_crystal_array_5=Union_box() SETTING parameters. */
char* material_string = mccchannel_11_analyzer_1_array_crystal_array_5_material_string;
MCNUM priority = mccchannel_11_analyzer_1_array_crystal_array_5_priority;
MCNUM xwidth = mccchannel_11_analyzer_1_array_crystal_array_5_xwidth;
MCNUM yheight = mccchannel_11_analyzer_1_array_crystal_array_5_yheight;
MCNUM zdepth = mccchannel_11_analyzer_1_array_crystal_array_5_zdepth;
MCNUM xwidth2 = mccchannel_11_analyzer_1_array_crystal_array_5_xwidth2;
MCNUM yheight2 = mccchannel_11_analyzer_1_array_crystal_array_5_yheight2;
MCNUM visualize = mccchannel_11_analyzer_1_array_crystal_array_5_visualize;
int target_index = mccchannel_11_analyzer_1_array_crystal_array_5_target_index;
MCNUM target_x = mccchannel_11_analyzer_1_array_crystal_array_5_target_x;
MCNUM target_y = mccchannel_11_analyzer_1_array_crystal_array_5_target_y;
MCNUM target_z = mccchannel_11_analyzer_1_array_crystal_array_5_target_z;
MCNUM focus_aw = mccchannel_11_analyzer_1_array_crystal_array_5_focus_aw;
MCNUM focus_ah = mccchannel_11_analyzer_1_array_crystal_array_5_focus_ah;
MCNUM focus_xw = mccchannel_11_analyzer_1_array_crystal_array_5_focus_xw;
MCNUM focus_xh = mccchannel_11_analyzer_1_array_crystal_array_5_focus_xh;
MCNUM focus_r = mccchannel_11_analyzer_1_array_crystal_array_5_focus_r;
MCNUM p_interact = mccchannel_11_analyzer_1_array_crystal_array_5_p_interact;
char* mask_string = mccchannel_11_analyzer_1_array_crystal_array_5_mask_string;
char* mask_setting = mccchannel_11_analyzer_1_array_crystal_array_5_mask_setting;
MCNUM number_of_activations = mccchannel_11_analyzer_1_array_crystal_array_5_number_of_activations;
}   /* End of channel_11_analyzer_1_array_crystal_array_5=Union_box() SETTING parameter declarations. */
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex
  /* Label for restoring  neutron */
  mcabsorbCompchannel_11_analyzer_1_array_crystal_array_5:
  if (RESTORE) /* restore if needed */
  { RESTORE_NEUTRON(553,
      mcnlx,
      mcnly,
      mcnlz,
      mcnlvx,
      mcnlvy,
      mcnlvz,
      mcnlt,
      mcnlsx,
      mcnlsy,
      mcnlsz,
      mcnlp); }
#undef mcabsorbComp
#undef p
#undef sz
#undef sy
#undef sx
#undef t
#undef vz
#undef vy
#undef vx
#undef z
#undef y
#undef x
  mcDEBUG_STATE(
mcnlx,
mcnly,
mcnlz,
mcnlvx,
mcnlvy,
mcnlvz,
mcnlt,
mcnlsx,
mcnlsy,
mcnlsz,
mcnlp)

  /* TRACE Component channel_11_analyzer_1_array_crystal_array_6 [554] */
  mccoordschange(mcposrchannel_11_analyzer_1_array_crystal_array_6, mcrotrchannel_11_analyzer_1_array_crystal_array_6,
    &mcnlx,
    &mcnly,
    &mcnlz,
    &mcnlvx,
    &mcnlvy,
    &mcnlvz,
    &mcnlsx,
    &mcnlsy,
    &mcnlsz);
  /* define label inside component channel_11_analyzer_1_array_crystal_array_6 (without coords transformations) */
  mcJumpTrace_channel_11_analyzer_1_array_crystal_array_6:
  SIG_MESSAGE("channel_11_analyzer_1_array_crystal_array_6 (Trace)");
  mcDEBUG_COMP("channel_11_analyzer_1_array_crystal_array_6")
  mcDEBUG_STATE(
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp)
#define x mcnlx
#define y mcnly
#define z mcnlz
#define vx mcnlvx
#define vy mcnlvy
#define vz mcnlvz
#define t mcnlt
#define sx mcnlsx
#define sy mcnlsy
#define sz mcnlsz
#define p mcnlp

#define mcabsorbComp mcabsorbCompchannel_11_analyzer_1_array_crystal_array_6
  STORE_NEUTRON(554,
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp);
  mcScattered=0;
  mcRestore=0;
  mcNCounter[554]++;
  mcPCounter[554] += p;
  mcP2Counter[554] += p*p;
#define mccompcurname  channel_11_analyzer_1_array_crystal_array_6
#define mccompcurtype  Union_box
#define mccompcurindex 554
#define loop_index mccchannel_11_analyzer_1_array_crystal_array_6_loop_index
#define this_box_volume mccchannel_11_analyzer_1_array_crystal_array_6_this_box_volume
#define global_geometry_element mccchannel_11_analyzer_1_array_crystal_array_6_global_geometry_element
#define this_box_storage mccchannel_11_analyzer_1_array_crystal_array_6_this_box_storage
{   /* Declarations of channel_11_analyzer_1_array_crystal_array_6=Union_box() SETTING parameters. */
char* material_string = mccchannel_11_analyzer_1_array_crystal_array_6_material_string;
MCNUM priority = mccchannel_11_analyzer_1_array_crystal_array_6_priority;
MCNUM xwidth = mccchannel_11_analyzer_1_array_crystal_array_6_xwidth;
MCNUM yheight = mccchannel_11_analyzer_1_array_crystal_array_6_yheight;
MCNUM zdepth = mccchannel_11_analyzer_1_array_crystal_array_6_zdepth;
MCNUM xwidth2 = mccchannel_11_analyzer_1_array_crystal_array_6_xwidth2;
MCNUM yheight2 = mccchannel_11_analyzer_1_array_crystal_array_6_yheight2;
MCNUM visualize = mccchannel_11_analyzer_1_array_crystal_array_6_visualize;
int target_index = mccchannel_11_analyzer_1_array_crystal_array_6_target_index;
MCNUM target_x = mccchannel_11_analyzer_1_array_crystal_array_6_target_x;
MCNUM target_y = mccchannel_11_analyzer_1_array_crystal_array_6_target_y;
MCNUM target_z = mccchannel_11_analyzer_1_array_crystal_array_6_target_z;
MCNUM focus_aw = mccchannel_11_analyzer_1_array_crystal_array_6_focus_aw;
MCNUM focus_ah = mccchannel_11_analyzer_1_array_crystal_array_6_focus_ah;
MCNUM focus_xw = mccchannel_11_analyzer_1_array_crystal_array_6_focus_xw;
MCNUM focus_xh = mccchannel_11_analyzer_1_array_crystal_array_6_focus_xh;
MCNUM focus_r = mccchannel_11_analyzer_1_array_crystal_array_6_focus_r;
MCNUM p_interact = mccchannel_11_analyzer_1_array_crystal_array_6_p_interact;
char* mask_string = mccchannel_11_analyzer_1_array_crystal_array_6_mask_string;
char* mask_setting = mccchannel_11_analyzer_1_array_crystal_array_6_mask_setting;
MCNUM number_of_activations = mccchannel_11_analyzer_1_array_crystal_array_6_number_of_activations;
}   /* End of channel_11_analyzer_1_array_crystal_array_6=Union_box() SETTING parameter declarations. */
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex
  /* Label for restoring  neutron */
  mcabsorbCompchannel_11_analyzer_1_array_crystal_array_6:
  if (RESTORE) /* restore if needed */
  { RESTORE_NEUTRON(554,
      mcnlx,
      mcnly,
      mcnlz,
      mcnlvx,
      mcnlvy,
      mcnlvz,
      mcnlt,
      mcnlsx,
      mcnlsy,
      mcnlsz,
      mcnlp); }
#undef mcabsorbComp
#undef p
#undef sz
#undef sy
#undef sx
#undef t
#undef vz
#undef vy
#undef vx
#undef z
#undef y
#undef x
  mcDEBUG_STATE(
mcnlx,
mcnly,
mcnlz,
mcnlvx,
mcnlvy,
mcnlvz,
mcnlt,
mcnlsx,
mcnlsy,
mcnlsz,
mcnlp)

  /* TRACE Component channel_11_analyzer_1_array_crystal_array_7 [555] */
  mccoordschange(mcposrchannel_11_analyzer_1_array_crystal_array_7, mcrotrchannel_11_analyzer_1_array_crystal_array_7,
    &mcnlx,
    &mcnly,
    &mcnlz,
    &mcnlvx,
    &mcnlvy,
    &mcnlvz,
    &mcnlsx,
    &mcnlsy,
    &mcnlsz);
  /* define label inside component channel_11_analyzer_1_array_crystal_array_7 (without coords transformations) */
  mcJumpTrace_channel_11_analyzer_1_array_crystal_array_7:
  SIG_MESSAGE("channel_11_analyzer_1_array_crystal_array_7 (Trace)");
  mcDEBUG_COMP("channel_11_analyzer_1_array_crystal_array_7")
  mcDEBUG_STATE(
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp)
#define x mcnlx
#define y mcnly
#define z mcnlz
#define vx mcnlvx
#define vy mcnlvy
#define vz mcnlvz
#define t mcnlt
#define sx mcnlsx
#define sy mcnlsy
#define sz mcnlsz
#define p mcnlp

#define mcabsorbComp mcabsorbCompchannel_11_analyzer_1_array_crystal_array_7
  STORE_NEUTRON(555,
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp);
  mcScattered=0;
  mcRestore=0;
  mcNCounter[555]++;
  mcPCounter[555] += p;
  mcP2Counter[555] += p*p;
#define mccompcurname  channel_11_analyzer_1_array_crystal_array_7
#define mccompcurtype  Union_box
#define mccompcurindex 555
#define loop_index mccchannel_11_analyzer_1_array_crystal_array_7_loop_index
#define this_box_volume mccchannel_11_analyzer_1_array_crystal_array_7_this_box_volume
#define global_geometry_element mccchannel_11_analyzer_1_array_crystal_array_7_global_geometry_element
#define this_box_storage mccchannel_11_analyzer_1_array_crystal_array_7_this_box_storage
{   /* Declarations of channel_11_analyzer_1_array_crystal_array_7=Union_box() SETTING parameters. */
char* material_string = mccchannel_11_analyzer_1_array_crystal_array_7_material_string;
MCNUM priority = mccchannel_11_analyzer_1_array_crystal_array_7_priority;
MCNUM xwidth = mccchannel_11_analyzer_1_array_crystal_array_7_xwidth;
MCNUM yheight = mccchannel_11_analyzer_1_array_crystal_array_7_yheight;
MCNUM zdepth = mccchannel_11_analyzer_1_array_crystal_array_7_zdepth;
MCNUM xwidth2 = mccchannel_11_analyzer_1_array_crystal_array_7_xwidth2;
MCNUM yheight2 = mccchannel_11_analyzer_1_array_crystal_array_7_yheight2;
MCNUM visualize = mccchannel_11_analyzer_1_array_crystal_array_7_visualize;
int target_index = mccchannel_11_analyzer_1_array_crystal_array_7_target_index;
MCNUM target_x = mccchannel_11_analyzer_1_array_crystal_array_7_target_x;
MCNUM target_y = mccchannel_11_analyzer_1_array_crystal_array_7_target_y;
MCNUM target_z = mccchannel_11_analyzer_1_array_crystal_array_7_target_z;
MCNUM focus_aw = mccchannel_11_analyzer_1_array_crystal_array_7_focus_aw;
MCNUM focus_ah = mccchannel_11_analyzer_1_array_crystal_array_7_focus_ah;
MCNUM focus_xw = mccchannel_11_analyzer_1_array_crystal_array_7_focus_xw;
MCNUM focus_xh = mccchannel_11_analyzer_1_array_crystal_array_7_focus_xh;
MCNUM focus_r = mccchannel_11_analyzer_1_array_crystal_array_7_focus_r;
MCNUM p_interact = mccchannel_11_analyzer_1_array_crystal_array_7_p_interact;
char* mask_string = mccchannel_11_analyzer_1_array_crystal_array_7_mask_string;
char* mask_setting = mccchannel_11_analyzer_1_array_crystal_array_7_mask_setting;
MCNUM number_of_activations = mccchannel_11_analyzer_1_array_crystal_array_7_number_of_activations;
}   /* End of channel_11_analyzer_1_array_crystal_array_7=Union_box() SETTING parameter declarations. */
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex
  /* Label for restoring  neutron */
  mcabsorbCompchannel_11_analyzer_1_array_crystal_array_7:
  if (RESTORE) /* restore if needed */
  { RESTORE_NEUTRON(555,
      mcnlx,
      mcnly,
      mcnlz,
      mcnlvx,
      mcnlvy,
      mcnlvz,
      mcnlt,
      mcnlsx,
      mcnlsy,
      mcnlsz,
      mcnlp); }
#undef mcabsorbComp
#undef p
#undef sz
#undef sy
#undef sx
#undef t
#undef vz
#undef vy
#undef vx
#undef z
#undef y
#undef x
  mcDEBUG_STATE(
mcnlx,
mcnly,
mcnlz,
mcnlvx,
mcnlvy,
mcnlvz,
mcnlt,
mcnlsx,
mcnlsy,
mcnlsz,
mcnlp)

  /* TRACE Component channel_11_analyzer_1_array_crystal_array_8 [556] */
  mccoordschange(mcposrchannel_11_analyzer_1_array_crystal_array_8, mcrotrchannel_11_analyzer_1_array_crystal_array_8,
    &mcnlx,
    &mcnly,
    &mcnlz,
    &mcnlvx,
    &mcnlvy,
    &mcnlvz,
    &mcnlsx,
    &mcnlsy,
    &mcnlsz);
  /* define label inside component channel_11_analyzer_1_array_crystal_array_8 (without coords transformations) */
  mcJumpTrace_channel_11_analyzer_1_array_crystal_array_8:
  SIG_MESSAGE("channel_11_analyzer_1_array_crystal_array_8 (Trace)");
  mcDEBUG_COMP("channel_11_analyzer_1_array_crystal_array_8")
  mcDEBUG_STATE(
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp)
#define x mcnlx
#define y mcnly
#define z mcnlz
#define vx mcnlvx
#define vy mcnlvy
#define vz mcnlvz
#define t mcnlt
#define sx mcnlsx
#define sy mcnlsy
#define sz mcnlsz
#define p mcnlp

#define mcabsorbComp mcabsorbCompchannel_11_analyzer_1_array_crystal_array_8
  STORE_NEUTRON(556,
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp);
  mcScattered=0;
  mcRestore=0;
  mcNCounter[556]++;
  mcPCounter[556] += p;
  mcP2Counter[556] += p*p;
#define mccompcurname  channel_11_analyzer_1_array_crystal_array_8
#define mccompcurtype  Union_box
#define mccompcurindex 556
#define loop_index mccchannel_11_analyzer_1_array_crystal_array_8_loop_index
#define this_box_volume mccchannel_11_analyzer_1_array_crystal_array_8_this_box_volume
#define global_geometry_element mccchannel_11_analyzer_1_array_crystal_array_8_global_geometry_element
#define this_box_storage mccchannel_11_analyzer_1_array_crystal_array_8_this_box_storage
{   /* Declarations of channel_11_analyzer_1_array_crystal_array_8=Union_box() SETTING parameters. */
char* material_string = mccchannel_11_analyzer_1_array_crystal_array_8_material_string;
MCNUM priority = mccchannel_11_analyzer_1_array_crystal_array_8_priority;
MCNUM xwidth = mccchannel_11_analyzer_1_array_crystal_array_8_xwidth;
MCNUM yheight = mccchannel_11_analyzer_1_array_crystal_array_8_yheight;
MCNUM zdepth = mccchannel_11_analyzer_1_array_crystal_array_8_zdepth;
MCNUM xwidth2 = mccchannel_11_analyzer_1_array_crystal_array_8_xwidth2;
MCNUM yheight2 = mccchannel_11_analyzer_1_array_crystal_array_8_yheight2;
MCNUM visualize = mccchannel_11_analyzer_1_array_crystal_array_8_visualize;
int target_index = mccchannel_11_analyzer_1_array_crystal_array_8_target_index;
MCNUM target_x = mccchannel_11_analyzer_1_array_crystal_array_8_target_x;
MCNUM target_y = mccchannel_11_analyzer_1_array_crystal_array_8_target_y;
MCNUM target_z = mccchannel_11_analyzer_1_array_crystal_array_8_target_z;
MCNUM focus_aw = mccchannel_11_analyzer_1_array_crystal_array_8_focus_aw;
MCNUM focus_ah = mccchannel_11_analyzer_1_array_crystal_array_8_focus_ah;
MCNUM focus_xw = mccchannel_11_analyzer_1_array_crystal_array_8_focus_xw;
MCNUM focus_xh = mccchannel_11_analyzer_1_array_crystal_array_8_focus_xh;
MCNUM focus_r = mccchannel_11_analyzer_1_array_crystal_array_8_focus_r;
MCNUM p_interact = mccchannel_11_analyzer_1_array_crystal_array_8_p_interact;
char* mask_string = mccchannel_11_analyzer_1_array_crystal_array_8_mask_string;
char* mask_setting = mccchannel_11_analyzer_1_array_crystal_array_8_mask_setting;
MCNUM number_of_activations = mccchannel_11_analyzer_1_array_crystal_array_8_number_of_activations;
}   /* End of channel_11_analyzer_1_array_crystal_array_8=Union_box() SETTING parameter declarations. */
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex
  /* Label for restoring  neutron */
  mcabsorbCompchannel_11_analyzer_1_array_crystal_array_8:
  if (RESTORE) /* restore if needed */
  { RESTORE_NEUTRON(556,
      mcnlx,
      mcnly,
      mcnlz,
      mcnlvx,
      mcnlvy,
      mcnlvz,
      mcnlt,
      mcnlsx,
      mcnlsy,
      mcnlsz,
      mcnlp); }
#undef mcabsorbComp
#undef p
#undef sz
#undef sy
#undef sx
#undef t
#undef vz
#undef vy
#undef vx
#undef z
#undef y
#undef x
  mcDEBUG_STATE(
mcnlx,
mcnly,
mcnlz,
mcnlvx,
mcnlvy,
mcnlvz,
mcnlt,
mcnlsx,
mcnlsy,
mcnlsz,
mcnlp)

  /* TRACE Component channel_11_analyzer_2_center [557] */
  mccoordschange(mcposrchannel_11_analyzer_2_center, mcrotrchannel_11_analyzer_2_center,
    &mcnlx,
    &mcnly,
    &mcnlz,
    &mcnlvx,
    &mcnlvy,
    &mcnlvz,
    &mcnlsx,
    &mcnlsy,
    &mcnlsz);
  /* define label inside component channel_11_analyzer_2_center (without coords transformations) */
  mcJumpTrace_channel_11_analyzer_2_center:
  SIG_MESSAGE("channel_11_analyzer_2_center (Trace)");
  mcDEBUG_COMP("channel_11_analyzer_2_center")
  mcDEBUG_STATE(
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp)
#define x mcnlx
#define y mcnly
#define z mcnlz
#define vx mcnlvx
#define vy mcnlvy
#define vz mcnlvz
#define t mcnlt
#define sx mcnlsx
#define sy mcnlsy
#define sz mcnlsz
#define p mcnlp

#define mcabsorbComp mcabsorbCompchannel_11_analyzer_2_center
  STORE_NEUTRON(557,
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp);
  mcScattered=0;
  mcRestore=0;
  mcNCounter[557]++;
  mcPCounter[557] += p;
  mcP2Counter[557] += p*p;
#define mccompcurname  channel_11_analyzer_2_center
#define mccompcurtype  Arm
#define mccompcurindex 557
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex
  /* Label for restoring  neutron */
  mcabsorbCompchannel_11_analyzer_2_center:
  if (RESTORE) /* restore if needed */
  { RESTORE_NEUTRON(557,
      mcnlx,
      mcnly,
      mcnlz,
      mcnlvx,
      mcnlvy,
      mcnlvz,
      mcnlt,
      mcnlsx,
      mcnlsy,
      mcnlsz,
      mcnlp); }
#undef mcabsorbComp
#undef p
#undef sz
#undef sy
#undef sx
#undef t
#undef vz
#undef vy
#undef vx
#undef z
#undef y
#undef x
  mcDEBUG_STATE(
mcnlx,
mcnly,
mcnlz,
mcnlvx,
mcnlvy,
mcnlvz,
mcnlt,
mcnlsx,
mcnlsy,
mcnlsz,
mcnlp)

  /* TRACE Component channel_11_analyzer_2_rotated [558] */
  mccoordschange(mcposrchannel_11_analyzer_2_rotated, mcrotrchannel_11_analyzer_2_rotated,
    &mcnlx,
    &mcnly,
    &mcnlz,
    &mcnlvx,
    &mcnlvy,
    &mcnlvz,
    &mcnlsx,
    &mcnlsy,
    &mcnlsz);
  /* define label inside component channel_11_analyzer_2_rotated (without coords transformations) */
  mcJumpTrace_channel_11_analyzer_2_rotated:
  SIG_MESSAGE("channel_11_analyzer_2_rotated (Trace)");
  mcDEBUG_COMP("channel_11_analyzer_2_rotated")
  mcDEBUG_STATE(
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp)
#define x mcnlx
#define y mcnly
#define z mcnlz
#define vx mcnlvx
#define vy mcnlvy
#define vz mcnlvz
#define t mcnlt
#define sx mcnlsx
#define sy mcnlsy
#define sz mcnlsz
#define p mcnlp

#define mcabsorbComp mcabsorbCompchannel_11_analyzer_2_rotated
  STORE_NEUTRON(558,
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp);
  mcScattered=0;
  mcRestore=0;
  mcNCounter[558]++;
  mcPCounter[558] += p;
  mcP2Counter[558] += p*p;
#define mccompcurname  channel_11_analyzer_2_rotated
#define mccompcurtype  Arm
#define mccompcurindex 558
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex
  /* Label for restoring  neutron */
  mcabsorbCompchannel_11_analyzer_2_rotated:
  if (RESTORE) /* restore if needed */
  { RESTORE_NEUTRON(558,
      mcnlx,
      mcnly,
      mcnlz,
      mcnlvx,
      mcnlvy,
      mcnlvz,
      mcnlt,
      mcnlsx,
      mcnlsy,
      mcnlsz,
      mcnlp); }
#undef mcabsorbComp
#undef p
#undef sz
#undef sy
#undef sx
#undef t
#undef vz
#undef vy
#undef vx
#undef z
#undef y
#undef x
  mcDEBUG_STATE(
mcnlx,
mcnly,
mcnlz,
mcnlvx,
mcnlvy,
mcnlvz,
mcnlt,
mcnlsx,
mcnlsy,
mcnlsz,
mcnlp)

  /* TRACE Component channel_11_analyzer_2_array_crystal_array_0 [559] */
  mccoordschange(mcposrchannel_11_analyzer_2_array_crystal_array_0, mcrotrchannel_11_analyzer_2_array_crystal_array_0,
    &mcnlx,
    &mcnly,
    &mcnlz,
    &mcnlvx,
    &mcnlvy,
    &mcnlvz,
    &mcnlsx,
    &mcnlsy,
    &mcnlsz);
  /* define label inside component channel_11_analyzer_2_array_crystal_array_0 (without coords transformations) */
  mcJumpTrace_channel_11_analyzer_2_array_crystal_array_0:
  SIG_MESSAGE("channel_11_analyzer_2_array_crystal_array_0 (Trace)");
  mcDEBUG_COMP("channel_11_analyzer_2_array_crystal_array_0")
  mcDEBUG_STATE(
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp)
#define x mcnlx
#define y mcnly
#define z mcnlz
#define vx mcnlvx
#define vy mcnlvy
#define vz mcnlvz
#define t mcnlt
#define sx mcnlsx
#define sy mcnlsy
#define sz mcnlsz
#define p mcnlp

#define mcabsorbComp mcabsorbCompchannel_11_analyzer_2_array_crystal_array_0
  STORE_NEUTRON(559,
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp);
  mcScattered=0;
  mcRestore=0;
  mcNCounter[559]++;
  mcPCounter[559] += p;
  mcP2Counter[559] += p*p;
#define mccompcurname  channel_11_analyzer_2_array_crystal_array_0
#define mccompcurtype  Union_box
#define mccompcurindex 559
#define loop_index mccchannel_11_analyzer_2_array_crystal_array_0_loop_index
#define this_box_volume mccchannel_11_analyzer_2_array_crystal_array_0_this_box_volume
#define global_geometry_element mccchannel_11_analyzer_2_array_crystal_array_0_global_geometry_element
#define this_box_storage mccchannel_11_analyzer_2_array_crystal_array_0_this_box_storage
{   /* Declarations of channel_11_analyzer_2_array_crystal_array_0=Union_box() SETTING parameters. */
char* material_string = mccchannel_11_analyzer_2_array_crystal_array_0_material_string;
MCNUM priority = mccchannel_11_analyzer_2_array_crystal_array_0_priority;
MCNUM xwidth = mccchannel_11_analyzer_2_array_crystal_array_0_xwidth;
MCNUM yheight = mccchannel_11_analyzer_2_array_crystal_array_0_yheight;
MCNUM zdepth = mccchannel_11_analyzer_2_array_crystal_array_0_zdepth;
MCNUM xwidth2 = mccchannel_11_analyzer_2_array_crystal_array_0_xwidth2;
MCNUM yheight2 = mccchannel_11_analyzer_2_array_crystal_array_0_yheight2;
MCNUM visualize = mccchannel_11_analyzer_2_array_crystal_array_0_visualize;
int target_index = mccchannel_11_analyzer_2_array_crystal_array_0_target_index;
MCNUM target_x = mccchannel_11_analyzer_2_array_crystal_array_0_target_x;
MCNUM target_y = mccchannel_11_analyzer_2_array_crystal_array_0_target_y;
MCNUM target_z = mccchannel_11_analyzer_2_array_crystal_array_0_target_z;
MCNUM focus_aw = mccchannel_11_analyzer_2_array_crystal_array_0_focus_aw;
MCNUM focus_ah = mccchannel_11_analyzer_2_array_crystal_array_0_focus_ah;
MCNUM focus_xw = mccchannel_11_analyzer_2_array_crystal_array_0_focus_xw;
MCNUM focus_xh = mccchannel_11_analyzer_2_array_crystal_array_0_focus_xh;
MCNUM focus_r = mccchannel_11_analyzer_2_array_crystal_array_0_focus_r;
MCNUM p_interact = mccchannel_11_analyzer_2_array_crystal_array_0_p_interact;
char* mask_string = mccchannel_11_analyzer_2_array_crystal_array_0_mask_string;
char* mask_setting = mccchannel_11_analyzer_2_array_crystal_array_0_mask_setting;
MCNUM number_of_activations = mccchannel_11_analyzer_2_array_crystal_array_0_number_of_activations;
}   /* End of channel_11_analyzer_2_array_crystal_array_0=Union_box() SETTING parameter declarations. */
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex
  /* Label for restoring  neutron */
  mcabsorbCompchannel_11_analyzer_2_array_crystal_array_0:
  if (RESTORE) /* restore if needed */
  { RESTORE_NEUTRON(559,
      mcnlx,
      mcnly,
      mcnlz,
      mcnlvx,
      mcnlvy,
      mcnlvz,
      mcnlt,
      mcnlsx,
      mcnlsy,
      mcnlsz,
      mcnlp); }
#undef mcabsorbComp
#undef p
#undef sz
#undef sy
#undef sx
#undef t
#undef vz
#undef vy
#undef vx
#undef z
#undef y
#undef x
  mcDEBUG_STATE(
mcnlx,
mcnly,
mcnlz,
mcnlvx,
mcnlvy,
mcnlvz,
mcnlt,
mcnlsx,
mcnlsy,
mcnlsz,
mcnlp)

  /* TRACE Component channel_11_analyzer_2_array_crystal_array_1 [560] */
  mccoordschange(mcposrchannel_11_analyzer_2_array_crystal_array_1, mcrotrchannel_11_analyzer_2_array_crystal_array_1,
    &mcnlx,
    &mcnly,
    &mcnlz,
    &mcnlvx,
    &mcnlvy,
    &mcnlvz,
    &mcnlsx,
    &mcnlsy,
    &mcnlsz);
  /* define label inside component channel_11_analyzer_2_array_crystal_array_1 (without coords transformations) */
  mcJumpTrace_channel_11_analyzer_2_array_crystal_array_1:
  SIG_MESSAGE("channel_11_analyzer_2_array_crystal_array_1 (Trace)");
  mcDEBUG_COMP("channel_11_analyzer_2_array_crystal_array_1")
  mcDEBUG_STATE(
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp)
#define x mcnlx
#define y mcnly
#define z mcnlz
#define vx mcnlvx
#define vy mcnlvy
#define vz mcnlvz
#define t mcnlt
#define sx mcnlsx
#define sy mcnlsy
#define sz mcnlsz
#define p mcnlp

#define mcabsorbComp mcabsorbCompchannel_11_analyzer_2_array_crystal_array_1
  STORE_NEUTRON(560,
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp);
  mcScattered=0;
  mcRestore=0;
  mcNCounter[560]++;
  mcPCounter[560] += p;
  mcP2Counter[560] += p*p;
#define mccompcurname  channel_11_analyzer_2_array_crystal_array_1
#define mccompcurtype  Union_box
#define mccompcurindex 560
#define loop_index mccchannel_11_analyzer_2_array_crystal_array_1_loop_index
#define this_box_volume mccchannel_11_analyzer_2_array_crystal_array_1_this_box_volume
#define global_geometry_element mccchannel_11_analyzer_2_array_crystal_array_1_global_geometry_element
#define this_box_storage mccchannel_11_analyzer_2_array_crystal_array_1_this_box_storage
{   /* Declarations of channel_11_analyzer_2_array_crystal_array_1=Union_box() SETTING parameters. */
char* material_string = mccchannel_11_analyzer_2_array_crystal_array_1_material_string;
MCNUM priority = mccchannel_11_analyzer_2_array_crystal_array_1_priority;
MCNUM xwidth = mccchannel_11_analyzer_2_array_crystal_array_1_xwidth;
MCNUM yheight = mccchannel_11_analyzer_2_array_crystal_array_1_yheight;
MCNUM zdepth = mccchannel_11_analyzer_2_array_crystal_array_1_zdepth;
MCNUM xwidth2 = mccchannel_11_analyzer_2_array_crystal_array_1_xwidth2;
MCNUM yheight2 = mccchannel_11_analyzer_2_array_crystal_array_1_yheight2;
MCNUM visualize = mccchannel_11_analyzer_2_array_crystal_array_1_visualize;
int target_index = mccchannel_11_analyzer_2_array_crystal_array_1_target_index;
MCNUM target_x = mccchannel_11_analyzer_2_array_crystal_array_1_target_x;
MCNUM target_y = mccchannel_11_analyzer_2_array_crystal_array_1_target_y;
MCNUM target_z = mccchannel_11_analyzer_2_array_crystal_array_1_target_z;
MCNUM focus_aw = mccchannel_11_analyzer_2_array_crystal_array_1_focus_aw;
MCNUM focus_ah = mccchannel_11_analyzer_2_array_crystal_array_1_focus_ah;
MCNUM focus_xw = mccchannel_11_analyzer_2_array_crystal_array_1_focus_xw;
MCNUM focus_xh = mccchannel_11_analyzer_2_array_crystal_array_1_focus_xh;
MCNUM focus_r = mccchannel_11_analyzer_2_array_crystal_array_1_focus_r;
MCNUM p_interact = mccchannel_11_analyzer_2_array_crystal_array_1_p_interact;
char* mask_string = mccchannel_11_analyzer_2_array_crystal_array_1_mask_string;
char* mask_setting = mccchannel_11_analyzer_2_array_crystal_array_1_mask_setting;
MCNUM number_of_activations = mccchannel_11_analyzer_2_array_crystal_array_1_number_of_activations;
}   /* End of channel_11_analyzer_2_array_crystal_array_1=Union_box() SETTING parameter declarations. */
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex
  /* Label for restoring  neutron */
  mcabsorbCompchannel_11_analyzer_2_array_crystal_array_1:
  if (RESTORE) /* restore if needed */
  { RESTORE_NEUTRON(560,
      mcnlx,
      mcnly,
      mcnlz,
      mcnlvx,
      mcnlvy,
      mcnlvz,
      mcnlt,
      mcnlsx,
      mcnlsy,
      mcnlsz,
      mcnlp); }
#undef mcabsorbComp
#undef p
#undef sz
#undef sy
#undef sx
#undef t
#undef vz
#undef vy
#undef vx
#undef z
#undef y
#undef x
  mcDEBUG_STATE(
mcnlx,
mcnly,
mcnlz,
mcnlvx,
mcnlvy,
mcnlvz,
mcnlt,
mcnlsx,
mcnlsy,
mcnlsz,
mcnlp)

  /* TRACE Component channel_11_analyzer_2_array_crystal_array_2 [561] */
  mccoordschange(mcposrchannel_11_analyzer_2_array_crystal_array_2, mcrotrchannel_11_analyzer_2_array_crystal_array_2,
    &mcnlx,
    &mcnly,
    &mcnlz,
    &mcnlvx,
    &mcnlvy,
    &mcnlvz,
    &mcnlsx,
    &mcnlsy,
    &mcnlsz);
  /* define label inside component channel_11_analyzer_2_array_crystal_array_2 (without coords transformations) */
  mcJumpTrace_channel_11_analyzer_2_array_crystal_array_2:
  SIG_MESSAGE("channel_11_analyzer_2_array_crystal_array_2 (Trace)");
  mcDEBUG_COMP("channel_11_analyzer_2_array_crystal_array_2")
  mcDEBUG_STATE(
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp)
#define x mcnlx
#define y mcnly
#define z mcnlz
#define vx mcnlvx
#define vy mcnlvy
#define vz mcnlvz
#define t mcnlt
#define sx mcnlsx
#define sy mcnlsy
#define sz mcnlsz
#define p mcnlp

#define mcabsorbComp mcabsorbCompchannel_11_analyzer_2_array_crystal_array_2
  STORE_NEUTRON(561,
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp);
  mcScattered=0;
  mcRestore=0;
  mcNCounter[561]++;
  mcPCounter[561] += p;
  mcP2Counter[561] += p*p;
#define mccompcurname  channel_11_analyzer_2_array_crystal_array_2
#define mccompcurtype  Union_box
#define mccompcurindex 561
#define loop_index mccchannel_11_analyzer_2_array_crystal_array_2_loop_index
#define this_box_volume mccchannel_11_analyzer_2_array_crystal_array_2_this_box_volume
#define global_geometry_element mccchannel_11_analyzer_2_array_crystal_array_2_global_geometry_element
#define this_box_storage mccchannel_11_analyzer_2_array_crystal_array_2_this_box_storage
{   /* Declarations of channel_11_analyzer_2_array_crystal_array_2=Union_box() SETTING parameters. */
char* material_string = mccchannel_11_analyzer_2_array_crystal_array_2_material_string;
MCNUM priority = mccchannel_11_analyzer_2_array_crystal_array_2_priority;
MCNUM xwidth = mccchannel_11_analyzer_2_array_crystal_array_2_xwidth;
MCNUM yheight = mccchannel_11_analyzer_2_array_crystal_array_2_yheight;
MCNUM zdepth = mccchannel_11_analyzer_2_array_crystal_array_2_zdepth;
MCNUM xwidth2 = mccchannel_11_analyzer_2_array_crystal_array_2_xwidth2;
MCNUM yheight2 = mccchannel_11_analyzer_2_array_crystal_array_2_yheight2;
MCNUM visualize = mccchannel_11_analyzer_2_array_crystal_array_2_visualize;
int target_index = mccchannel_11_analyzer_2_array_crystal_array_2_target_index;
MCNUM target_x = mccchannel_11_analyzer_2_array_crystal_array_2_target_x;
MCNUM target_y = mccchannel_11_analyzer_2_array_crystal_array_2_target_y;
MCNUM target_z = mccchannel_11_analyzer_2_array_crystal_array_2_target_z;
MCNUM focus_aw = mccchannel_11_analyzer_2_array_crystal_array_2_focus_aw;
MCNUM focus_ah = mccchannel_11_analyzer_2_array_crystal_array_2_focus_ah;
MCNUM focus_xw = mccchannel_11_analyzer_2_array_crystal_array_2_focus_xw;
MCNUM focus_xh = mccchannel_11_analyzer_2_array_crystal_array_2_focus_xh;
MCNUM focus_r = mccchannel_11_analyzer_2_array_crystal_array_2_focus_r;
MCNUM p_interact = mccchannel_11_analyzer_2_array_crystal_array_2_p_interact;
char* mask_string = mccchannel_11_analyzer_2_array_crystal_array_2_mask_string;
char* mask_setting = mccchannel_11_analyzer_2_array_crystal_array_2_mask_setting;
MCNUM number_of_activations = mccchannel_11_analyzer_2_array_crystal_array_2_number_of_activations;
}   /* End of channel_11_analyzer_2_array_crystal_array_2=Union_box() SETTING parameter declarations. */
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex
  /* Label for restoring  neutron */
  mcabsorbCompchannel_11_analyzer_2_array_crystal_array_2:
  if (RESTORE) /* restore if needed */
  { RESTORE_NEUTRON(561,
      mcnlx,
      mcnly,
      mcnlz,
      mcnlvx,
      mcnlvy,
      mcnlvz,
      mcnlt,
      mcnlsx,
      mcnlsy,
      mcnlsz,
      mcnlp); }
#undef mcabsorbComp
#undef p
#undef sz
#undef sy
#undef sx
#undef t
#undef vz
#undef vy
#undef vx
#undef z
#undef y
#undef x
  mcDEBUG_STATE(
mcnlx,
mcnly,
mcnlz,
mcnlvx,
mcnlvy,
mcnlvz,
mcnlt,
mcnlsx,
mcnlsy,
mcnlsz,
mcnlp)

  /* TRACE Component channel_11_analyzer_2_array_crystal_array_3 [562] */
  mccoordschange(mcposrchannel_11_analyzer_2_array_crystal_array_3, mcrotrchannel_11_analyzer_2_array_crystal_array_3,
    &mcnlx,
    &mcnly,
    &mcnlz,
    &mcnlvx,
    &mcnlvy,
    &mcnlvz,
    &mcnlsx,
    &mcnlsy,
    &mcnlsz);
  /* define label inside component channel_11_analyzer_2_array_crystal_array_3 (without coords transformations) */
  mcJumpTrace_channel_11_analyzer_2_array_crystal_array_3:
  SIG_MESSAGE("channel_11_analyzer_2_array_crystal_array_3 (Trace)");
  mcDEBUG_COMP("channel_11_analyzer_2_array_crystal_array_3")
  mcDEBUG_STATE(
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp)
#define x mcnlx
#define y mcnly
#define z mcnlz
#define vx mcnlvx
#define vy mcnlvy
#define vz mcnlvz
#define t mcnlt
#define sx mcnlsx
#define sy mcnlsy
#define sz mcnlsz
#define p mcnlp

#define mcabsorbComp mcabsorbCompchannel_11_analyzer_2_array_crystal_array_3
  STORE_NEUTRON(562,
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp);
  mcScattered=0;
  mcRestore=0;
  mcNCounter[562]++;
  mcPCounter[562] += p;
  mcP2Counter[562] += p*p;
#define mccompcurname  channel_11_analyzer_2_array_crystal_array_3
#define mccompcurtype  Union_box
#define mccompcurindex 562
#define loop_index mccchannel_11_analyzer_2_array_crystal_array_3_loop_index
#define this_box_volume mccchannel_11_analyzer_2_array_crystal_array_3_this_box_volume
#define global_geometry_element mccchannel_11_analyzer_2_array_crystal_array_3_global_geometry_element
#define this_box_storage mccchannel_11_analyzer_2_array_crystal_array_3_this_box_storage
{   /* Declarations of channel_11_analyzer_2_array_crystal_array_3=Union_box() SETTING parameters. */
char* material_string = mccchannel_11_analyzer_2_array_crystal_array_3_material_string;
MCNUM priority = mccchannel_11_analyzer_2_array_crystal_array_3_priority;
MCNUM xwidth = mccchannel_11_analyzer_2_array_crystal_array_3_xwidth;
MCNUM yheight = mccchannel_11_analyzer_2_array_crystal_array_3_yheight;
MCNUM zdepth = mccchannel_11_analyzer_2_array_crystal_array_3_zdepth;
MCNUM xwidth2 = mccchannel_11_analyzer_2_array_crystal_array_3_xwidth2;
MCNUM yheight2 = mccchannel_11_analyzer_2_array_crystal_array_3_yheight2;
MCNUM visualize = mccchannel_11_analyzer_2_array_crystal_array_3_visualize;
int target_index = mccchannel_11_analyzer_2_array_crystal_array_3_target_index;
MCNUM target_x = mccchannel_11_analyzer_2_array_crystal_array_3_target_x;
MCNUM target_y = mccchannel_11_analyzer_2_array_crystal_array_3_target_y;
MCNUM target_z = mccchannel_11_analyzer_2_array_crystal_array_3_target_z;
MCNUM focus_aw = mccchannel_11_analyzer_2_array_crystal_array_3_focus_aw;
MCNUM focus_ah = mccchannel_11_analyzer_2_array_crystal_array_3_focus_ah;
MCNUM focus_xw = mccchannel_11_analyzer_2_array_crystal_array_3_focus_xw;
MCNUM focus_xh = mccchannel_11_analyzer_2_array_crystal_array_3_focus_xh;
MCNUM focus_r = mccchannel_11_analyzer_2_array_crystal_array_3_focus_r;
MCNUM p_interact = mccchannel_11_analyzer_2_array_crystal_array_3_p_interact;
char* mask_string = mccchannel_11_analyzer_2_array_crystal_array_3_mask_string;
char* mask_setting = mccchannel_11_analyzer_2_array_crystal_array_3_mask_setting;
MCNUM number_of_activations = mccchannel_11_analyzer_2_array_crystal_array_3_number_of_activations;
}   /* End of channel_11_analyzer_2_array_crystal_array_3=Union_box() SETTING parameter declarations. */
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex
  /* Label for restoring  neutron */
  mcabsorbCompchannel_11_analyzer_2_array_crystal_array_3:
  if (RESTORE) /* restore if needed */
  { RESTORE_NEUTRON(562,
      mcnlx,
      mcnly,
      mcnlz,
      mcnlvx,
      mcnlvy,
      mcnlvz,
      mcnlt,
      mcnlsx,
      mcnlsy,
      mcnlsz,
      mcnlp); }
#undef mcabsorbComp
#undef p
#undef sz
#undef sy
#undef sx
#undef t
#undef vz
#undef vy
#undef vx
#undef z
#undef y
#undef x
  mcDEBUG_STATE(
mcnlx,
mcnly,
mcnlz,
mcnlvx,
mcnlvy,
mcnlvz,
mcnlt,
mcnlsx,
mcnlsy,
mcnlsz,
mcnlp)

  /* TRACE Component channel_11_analyzer_2_array_crystal_array_4 [563] */
  mccoordschange(mcposrchannel_11_analyzer_2_array_crystal_array_4, mcrotrchannel_11_analyzer_2_array_crystal_array_4,
    &mcnlx,
    &mcnly,
    &mcnlz,
    &mcnlvx,
    &mcnlvy,
    &mcnlvz,
    &mcnlsx,
    &mcnlsy,
    &mcnlsz);
  /* define label inside component channel_11_analyzer_2_array_crystal_array_4 (without coords transformations) */
  mcJumpTrace_channel_11_analyzer_2_array_crystal_array_4:
  SIG_MESSAGE("channel_11_analyzer_2_array_crystal_array_4 (Trace)");
  mcDEBUG_COMP("channel_11_analyzer_2_array_crystal_array_4")
  mcDEBUG_STATE(
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp)
#define x mcnlx
#define y mcnly
#define z mcnlz
#define vx mcnlvx
#define vy mcnlvy
#define vz mcnlvz
#define t mcnlt
#define sx mcnlsx
#define sy mcnlsy
#define sz mcnlsz
#define p mcnlp

#define mcabsorbComp mcabsorbCompchannel_11_analyzer_2_array_crystal_array_4
  STORE_NEUTRON(563,
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp);
  mcScattered=0;
  mcRestore=0;
  mcNCounter[563]++;
  mcPCounter[563] += p;
  mcP2Counter[563] += p*p;
#define mccompcurname  channel_11_analyzer_2_array_crystal_array_4
#define mccompcurtype  Union_box
#define mccompcurindex 563
#define loop_index mccchannel_11_analyzer_2_array_crystal_array_4_loop_index
#define this_box_volume mccchannel_11_analyzer_2_array_crystal_array_4_this_box_volume
#define global_geometry_element mccchannel_11_analyzer_2_array_crystal_array_4_global_geometry_element
#define this_box_storage mccchannel_11_analyzer_2_array_crystal_array_4_this_box_storage
{   /* Declarations of channel_11_analyzer_2_array_crystal_array_4=Union_box() SETTING parameters. */
char* material_string = mccchannel_11_analyzer_2_array_crystal_array_4_material_string;
MCNUM priority = mccchannel_11_analyzer_2_array_crystal_array_4_priority;
MCNUM xwidth = mccchannel_11_analyzer_2_array_crystal_array_4_xwidth;
MCNUM yheight = mccchannel_11_analyzer_2_array_crystal_array_4_yheight;
MCNUM zdepth = mccchannel_11_analyzer_2_array_crystal_array_4_zdepth;
MCNUM xwidth2 = mccchannel_11_analyzer_2_array_crystal_array_4_xwidth2;
MCNUM yheight2 = mccchannel_11_analyzer_2_array_crystal_array_4_yheight2;
MCNUM visualize = mccchannel_11_analyzer_2_array_crystal_array_4_visualize;
int target_index = mccchannel_11_analyzer_2_array_crystal_array_4_target_index;
MCNUM target_x = mccchannel_11_analyzer_2_array_crystal_array_4_target_x;
MCNUM target_y = mccchannel_11_analyzer_2_array_crystal_array_4_target_y;
MCNUM target_z = mccchannel_11_analyzer_2_array_crystal_array_4_target_z;
MCNUM focus_aw = mccchannel_11_analyzer_2_array_crystal_array_4_focus_aw;
MCNUM focus_ah = mccchannel_11_analyzer_2_array_crystal_array_4_focus_ah;
MCNUM focus_xw = mccchannel_11_analyzer_2_array_crystal_array_4_focus_xw;
MCNUM focus_xh = mccchannel_11_analyzer_2_array_crystal_array_4_focus_xh;
MCNUM focus_r = mccchannel_11_analyzer_2_array_crystal_array_4_focus_r;
MCNUM p_interact = mccchannel_11_analyzer_2_array_crystal_array_4_p_interact;
char* mask_string = mccchannel_11_analyzer_2_array_crystal_array_4_mask_string;
char* mask_setting = mccchannel_11_analyzer_2_array_crystal_array_4_mask_setting;
MCNUM number_of_activations = mccchannel_11_analyzer_2_array_crystal_array_4_number_of_activations;
}   /* End of channel_11_analyzer_2_array_crystal_array_4=Union_box() SETTING parameter declarations. */
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex
  /* Label for restoring  neutron */
  mcabsorbCompchannel_11_analyzer_2_array_crystal_array_4:
  if (RESTORE) /* restore if needed */
  { RESTORE_NEUTRON(563,
      mcnlx,
      mcnly,
      mcnlz,
      mcnlvx,
      mcnlvy,
      mcnlvz,
      mcnlt,
      mcnlsx,
      mcnlsy,
      mcnlsz,
      mcnlp); }
#undef mcabsorbComp
#undef p
#undef sz
#undef sy
#undef sx
#undef t
#undef vz
#undef vy
#undef vx
#undef z
#undef y
#undef x
  mcDEBUG_STATE(
mcnlx,
mcnly,
mcnlz,
mcnlvx,
mcnlvy,
mcnlvz,
mcnlt,
mcnlsx,
mcnlsy,
mcnlsz,
mcnlp)

  /* TRACE Component channel_11_analyzer_2_array_crystal_array_5 [564] */
  mccoordschange(mcposrchannel_11_analyzer_2_array_crystal_array_5, mcrotrchannel_11_analyzer_2_array_crystal_array_5,
    &mcnlx,
    &mcnly,
    &mcnlz,
    &mcnlvx,
    &mcnlvy,
    &mcnlvz,
    &mcnlsx,
    &mcnlsy,
    &mcnlsz);
  /* define label inside component channel_11_analyzer_2_array_crystal_array_5 (without coords transformations) */
  mcJumpTrace_channel_11_analyzer_2_array_crystal_array_5:
  SIG_MESSAGE("channel_11_analyzer_2_array_crystal_array_5 (Trace)");
  mcDEBUG_COMP("channel_11_analyzer_2_array_crystal_array_5")
  mcDEBUG_STATE(
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp)
#define x mcnlx
#define y mcnly
#define z mcnlz
#define vx mcnlvx
#define vy mcnlvy
#define vz mcnlvz
#define t mcnlt
#define sx mcnlsx
#define sy mcnlsy
#define sz mcnlsz
#define p mcnlp

#define mcabsorbComp mcabsorbCompchannel_11_analyzer_2_array_crystal_array_5
  STORE_NEUTRON(564,
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp);
  mcScattered=0;
  mcRestore=0;
  mcNCounter[564]++;
  mcPCounter[564] += p;
  mcP2Counter[564] += p*p;
#define mccompcurname  channel_11_analyzer_2_array_crystal_array_5
#define mccompcurtype  Union_box
#define mccompcurindex 564
#define loop_index mccchannel_11_analyzer_2_array_crystal_array_5_loop_index
#define this_box_volume mccchannel_11_analyzer_2_array_crystal_array_5_this_box_volume
#define global_geometry_element mccchannel_11_analyzer_2_array_crystal_array_5_global_geometry_element
#define this_box_storage mccchannel_11_analyzer_2_array_crystal_array_5_this_box_storage
{   /* Declarations of channel_11_analyzer_2_array_crystal_array_5=Union_box() SETTING parameters. */
char* material_string = mccchannel_11_analyzer_2_array_crystal_array_5_material_string;
MCNUM priority = mccchannel_11_analyzer_2_array_crystal_array_5_priority;
MCNUM xwidth = mccchannel_11_analyzer_2_array_crystal_array_5_xwidth;
MCNUM yheight = mccchannel_11_analyzer_2_array_crystal_array_5_yheight;
MCNUM zdepth = mccchannel_11_analyzer_2_array_crystal_array_5_zdepth;
MCNUM xwidth2 = mccchannel_11_analyzer_2_array_crystal_array_5_xwidth2;
MCNUM yheight2 = mccchannel_11_analyzer_2_array_crystal_array_5_yheight2;
MCNUM visualize = mccchannel_11_analyzer_2_array_crystal_array_5_visualize;
int target_index = mccchannel_11_analyzer_2_array_crystal_array_5_target_index;
MCNUM target_x = mccchannel_11_analyzer_2_array_crystal_array_5_target_x;
MCNUM target_y = mccchannel_11_analyzer_2_array_crystal_array_5_target_y;
MCNUM target_z = mccchannel_11_analyzer_2_array_crystal_array_5_target_z;
MCNUM focus_aw = mccchannel_11_analyzer_2_array_crystal_array_5_focus_aw;
MCNUM focus_ah = mccchannel_11_analyzer_2_array_crystal_array_5_focus_ah;
MCNUM focus_xw = mccchannel_11_analyzer_2_array_crystal_array_5_focus_xw;
MCNUM focus_xh = mccchannel_11_analyzer_2_array_crystal_array_5_focus_xh;
MCNUM focus_r = mccchannel_11_analyzer_2_array_crystal_array_5_focus_r;
MCNUM p_interact = mccchannel_11_analyzer_2_array_crystal_array_5_p_interact;
char* mask_string = mccchannel_11_analyzer_2_array_crystal_array_5_mask_string;
char* mask_setting = mccchannel_11_analyzer_2_array_crystal_array_5_mask_setting;
MCNUM number_of_activations = mccchannel_11_analyzer_2_array_crystal_array_5_number_of_activations;
}   /* End of channel_11_analyzer_2_array_crystal_array_5=Union_box() SETTING parameter declarations. */
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex
  /* Label for restoring  neutron */
  mcabsorbCompchannel_11_analyzer_2_array_crystal_array_5:
  if (RESTORE) /* restore if needed */
  { RESTORE_NEUTRON(564,
      mcnlx,
      mcnly,
      mcnlz,
      mcnlvx,
      mcnlvy,
      mcnlvz,
      mcnlt,
      mcnlsx,
      mcnlsy,
      mcnlsz,
      mcnlp); }
#undef mcabsorbComp
#undef p
#undef sz
#undef sy
#undef sx
#undef t
#undef vz
#undef vy
#undef vx
#undef z
#undef y
#undef x
  mcDEBUG_STATE(
mcnlx,
mcnly,
mcnlz,
mcnlvx,
mcnlvy,
mcnlvz,
mcnlt,
mcnlsx,
mcnlsy,
mcnlsz,
mcnlp)

  /* TRACE Component channel_11_analyzer_2_array_crystal_array_6 [565] */
  mccoordschange(mcposrchannel_11_analyzer_2_array_crystal_array_6, mcrotrchannel_11_analyzer_2_array_crystal_array_6,
    &mcnlx,
    &mcnly,
    &mcnlz,
    &mcnlvx,
    &mcnlvy,
    &mcnlvz,
    &mcnlsx,
    &mcnlsy,
    &mcnlsz);
  /* define label inside component channel_11_analyzer_2_array_crystal_array_6 (without coords transformations) */
  mcJumpTrace_channel_11_analyzer_2_array_crystal_array_6:
  SIG_MESSAGE("channel_11_analyzer_2_array_crystal_array_6 (Trace)");
  mcDEBUG_COMP("channel_11_analyzer_2_array_crystal_array_6")
  mcDEBUG_STATE(
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp)
#define x mcnlx
#define y mcnly
#define z mcnlz
#define vx mcnlvx
#define vy mcnlvy
#define vz mcnlvz
#define t mcnlt
#define sx mcnlsx
#define sy mcnlsy
#define sz mcnlsz
#define p mcnlp

#define mcabsorbComp mcabsorbCompchannel_11_analyzer_2_array_crystal_array_6
  STORE_NEUTRON(565,
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp);
  mcScattered=0;
  mcRestore=0;
  mcNCounter[565]++;
  mcPCounter[565] += p;
  mcP2Counter[565] += p*p;
#define mccompcurname  channel_11_analyzer_2_array_crystal_array_6
#define mccompcurtype  Union_box
#define mccompcurindex 565
#define loop_index mccchannel_11_analyzer_2_array_crystal_array_6_loop_index
#define this_box_volume mccchannel_11_analyzer_2_array_crystal_array_6_this_box_volume
#define global_geometry_element mccchannel_11_analyzer_2_array_crystal_array_6_global_geometry_element
#define this_box_storage mccchannel_11_analyzer_2_array_crystal_array_6_this_box_storage
{   /* Declarations of channel_11_analyzer_2_array_crystal_array_6=Union_box() SETTING parameters. */
char* material_string = mccchannel_11_analyzer_2_array_crystal_array_6_material_string;
MCNUM priority = mccchannel_11_analyzer_2_array_crystal_array_6_priority;
MCNUM xwidth = mccchannel_11_analyzer_2_array_crystal_array_6_xwidth;
MCNUM yheight = mccchannel_11_analyzer_2_array_crystal_array_6_yheight;
MCNUM zdepth = mccchannel_11_analyzer_2_array_crystal_array_6_zdepth;
MCNUM xwidth2 = mccchannel_11_analyzer_2_array_crystal_array_6_xwidth2;
MCNUM yheight2 = mccchannel_11_analyzer_2_array_crystal_array_6_yheight2;
MCNUM visualize = mccchannel_11_analyzer_2_array_crystal_array_6_visualize;
int target_index = mccchannel_11_analyzer_2_array_crystal_array_6_target_index;
MCNUM target_x = mccchannel_11_analyzer_2_array_crystal_array_6_target_x;
MCNUM target_y = mccchannel_11_analyzer_2_array_crystal_array_6_target_y;
MCNUM target_z = mccchannel_11_analyzer_2_array_crystal_array_6_target_z;
MCNUM focus_aw = mccchannel_11_analyzer_2_array_crystal_array_6_focus_aw;
MCNUM focus_ah = mccchannel_11_analyzer_2_array_crystal_array_6_focus_ah;
MCNUM focus_xw = mccchannel_11_analyzer_2_array_crystal_array_6_focus_xw;
MCNUM focus_xh = mccchannel_11_analyzer_2_array_crystal_array_6_focus_xh;
MCNUM focus_r = mccchannel_11_analyzer_2_array_crystal_array_6_focus_r;
MCNUM p_interact = mccchannel_11_analyzer_2_array_crystal_array_6_p_interact;
char* mask_string = mccchannel_11_analyzer_2_array_crystal_array_6_mask_string;
char* mask_setting = mccchannel_11_analyzer_2_array_crystal_array_6_mask_setting;
MCNUM number_of_activations = mccchannel_11_analyzer_2_array_crystal_array_6_number_of_activations;
}   /* End of channel_11_analyzer_2_array_crystal_array_6=Union_box() SETTING parameter declarations. */
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex
  /* Label for restoring  neutron */
  mcabsorbCompchannel_11_analyzer_2_array_crystal_array_6:
  if (RESTORE) /* restore if needed */
  { RESTORE_NEUTRON(565,
      mcnlx,
      mcnly,
      mcnlz,
      mcnlvx,
      mcnlvy,
      mcnlvz,
      mcnlt,
      mcnlsx,
      mcnlsy,
      mcnlsz,
      mcnlp); }
#undef mcabsorbComp
#undef p
#undef sz
#undef sy
#undef sx
#undef t
#undef vz
#undef vy
#undef vx
#undef z
#undef y
#undef x
  mcDEBUG_STATE(
mcnlx,
mcnly,
mcnlz,
mcnlvx,
mcnlvy,
mcnlvz,
mcnlt,
mcnlsx,
mcnlsy,
mcnlsz,
mcnlp)

  /* TRACE Component channel_11_analyzer_2_array_crystal_array_7 [566] */
  mccoordschange(mcposrchannel_11_analyzer_2_array_crystal_array_7, mcrotrchannel_11_analyzer_2_array_crystal_array_7,
    &mcnlx,
    &mcnly,
    &mcnlz,
    &mcnlvx,
    &mcnlvy,
    &mcnlvz,
    &mcnlsx,
    &mcnlsy,
    &mcnlsz);
  /* define label inside component channel_11_analyzer_2_array_crystal_array_7 (without coords transformations) */
  mcJumpTrace_channel_11_analyzer_2_array_crystal_array_7:
  SIG_MESSAGE("channel_11_analyzer_2_array_crystal_array_7 (Trace)");
  mcDEBUG_COMP("channel_11_analyzer_2_array_crystal_array_7")
  mcDEBUG_STATE(
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp)
#define x mcnlx
#define y mcnly
#define z mcnlz
#define vx mcnlvx
#define vy mcnlvy
#define vz mcnlvz
#define t mcnlt
#define sx mcnlsx
#define sy mcnlsy
#define sz mcnlsz
#define p mcnlp

#define mcabsorbComp mcabsorbCompchannel_11_analyzer_2_array_crystal_array_7
  STORE_NEUTRON(566,
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp);
  mcScattered=0;
  mcRestore=0;
  mcNCounter[566]++;
  mcPCounter[566] += p;
  mcP2Counter[566] += p*p;
#define mccompcurname  channel_11_analyzer_2_array_crystal_array_7
#define mccompcurtype  Union_box
#define mccompcurindex 566
#define loop_index mccchannel_11_analyzer_2_array_crystal_array_7_loop_index
#define this_box_volume mccchannel_11_analyzer_2_array_crystal_array_7_this_box_volume
#define global_geometry_element mccchannel_11_analyzer_2_array_crystal_array_7_global_geometry_element
#define this_box_storage mccchannel_11_analyzer_2_array_crystal_array_7_this_box_storage
{   /* Declarations of channel_11_analyzer_2_array_crystal_array_7=Union_box() SETTING parameters. */
char* material_string = mccchannel_11_analyzer_2_array_crystal_array_7_material_string;
MCNUM priority = mccchannel_11_analyzer_2_array_crystal_array_7_priority;
MCNUM xwidth = mccchannel_11_analyzer_2_array_crystal_array_7_xwidth;
MCNUM yheight = mccchannel_11_analyzer_2_array_crystal_array_7_yheight;
MCNUM zdepth = mccchannel_11_analyzer_2_array_crystal_array_7_zdepth;
MCNUM xwidth2 = mccchannel_11_analyzer_2_array_crystal_array_7_xwidth2;
MCNUM yheight2 = mccchannel_11_analyzer_2_array_crystal_array_7_yheight2;
MCNUM visualize = mccchannel_11_analyzer_2_array_crystal_array_7_visualize;
int target_index = mccchannel_11_analyzer_2_array_crystal_array_7_target_index;
MCNUM target_x = mccchannel_11_analyzer_2_array_crystal_array_7_target_x;
MCNUM target_y = mccchannel_11_analyzer_2_array_crystal_array_7_target_y;
MCNUM target_z = mccchannel_11_analyzer_2_array_crystal_array_7_target_z;
MCNUM focus_aw = mccchannel_11_analyzer_2_array_crystal_array_7_focus_aw;
MCNUM focus_ah = mccchannel_11_analyzer_2_array_crystal_array_7_focus_ah;
MCNUM focus_xw = mccchannel_11_analyzer_2_array_crystal_array_7_focus_xw;
MCNUM focus_xh = mccchannel_11_analyzer_2_array_crystal_array_7_focus_xh;
MCNUM focus_r = mccchannel_11_analyzer_2_array_crystal_array_7_focus_r;
MCNUM p_interact = mccchannel_11_analyzer_2_array_crystal_array_7_p_interact;
char* mask_string = mccchannel_11_analyzer_2_array_crystal_array_7_mask_string;
char* mask_setting = mccchannel_11_analyzer_2_array_crystal_array_7_mask_setting;
MCNUM number_of_activations = mccchannel_11_analyzer_2_array_crystal_array_7_number_of_activations;
}   /* End of channel_11_analyzer_2_array_crystal_array_7=Union_box() SETTING parameter declarations. */
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex
  /* Label for restoring  neutron */
  mcabsorbCompchannel_11_analyzer_2_array_crystal_array_7:
  if (RESTORE) /* restore if needed */
  { RESTORE_NEUTRON(566,
      mcnlx,
      mcnly,
      mcnlz,
      mcnlvx,
      mcnlvy,
      mcnlvz,
      mcnlt,
      mcnlsx,
      mcnlsy,
      mcnlsz,
      mcnlp); }
#undef mcabsorbComp
#undef p
#undef sz
#undef sy
#undef sx
#undef t
#undef vz
#undef vy
#undef vx
#undef z
#undef y
#undef x
  mcDEBUG_STATE(
mcnlx,
mcnly,
mcnlz,
mcnlvx,
mcnlvy,
mcnlvz,
mcnlt,
mcnlsx,
mcnlsy,
mcnlsz,
mcnlp)

  /* TRACE Component channel_11_analyzer_2_array_crystal_array_8 [567] */
  mccoordschange(mcposrchannel_11_analyzer_2_array_crystal_array_8, mcrotrchannel_11_analyzer_2_array_crystal_array_8,
    &mcnlx,
    &mcnly,
    &mcnlz,
    &mcnlvx,
    &mcnlvy,
    &mcnlvz,
    &mcnlsx,
    &mcnlsy,
    &mcnlsz);
  /* define label inside component channel_11_analyzer_2_array_crystal_array_8 (without coords transformations) */
  mcJumpTrace_channel_11_analyzer_2_array_crystal_array_8:
  SIG_MESSAGE("channel_11_analyzer_2_array_crystal_array_8 (Trace)");
  mcDEBUG_COMP("channel_11_analyzer_2_array_crystal_array_8")
  mcDEBUG_STATE(
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp)
#define x mcnlx
#define y mcnly
#define z mcnlz
#define vx mcnlvx
#define vy mcnlvy
#define vz mcnlvz
#define t mcnlt
#define sx mcnlsx
#define sy mcnlsy
#define sz mcnlsz
#define p mcnlp

#define mcabsorbComp mcabsorbCompchannel_11_analyzer_2_array_crystal_array_8
  STORE_NEUTRON(567,
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp);
  mcScattered=0;
  mcRestore=0;
  mcNCounter[567]++;
  mcPCounter[567] += p;
  mcP2Counter[567] += p*p;
#define mccompcurname  channel_11_analyzer_2_array_crystal_array_8
#define mccompcurtype  Union_box
#define mccompcurindex 567
#define loop_index mccchannel_11_analyzer_2_array_crystal_array_8_loop_index
#define this_box_volume mccchannel_11_analyzer_2_array_crystal_array_8_this_box_volume
#define global_geometry_element mccchannel_11_analyzer_2_array_crystal_array_8_global_geometry_element
#define this_box_storage mccchannel_11_analyzer_2_array_crystal_array_8_this_box_storage
{   /* Declarations of channel_11_analyzer_2_array_crystal_array_8=Union_box() SETTING parameters. */
char* material_string = mccchannel_11_analyzer_2_array_crystal_array_8_material_string;
MCNUM priority = mccchannel_11_analyzer_2_array_crystal_array_8_priority;
MCNUM xwidth = mccchannel_11_analyzer_2_array_crystal_array_8_xwidth;
MCNUM yheight = mccchannel_11_analyzer_2_array_crystal_array_8_yheight;
MCNUM zdepth = mccchannel_11_analyzer_2_array_crystal_array_8_zdepth;
MCNUM xwidth2 = mccchannel_11_analyzer_2_array_crystal_array_8_xwidth2;
MCNUM yheight2 = mccchannel_11_analyzer_2_array_crystal_array_8_yheight2;
MCNUM visualize = mccchannel_11_analyzer_2_array_crystal_array_8_visualize;
int target_index = mccchannel_11_analyzer_2_array_crystal_array_8_target_index;
MCNUM target_x = mccchannel_11_analyzer_2_array_crystal_array_8_target_x;
MCNUM target_y = mccchannel_11_analyzer_2_array_crystal_array_8_target_y;
MCNUM target_z = mccchannel_11_analyzer_2_array_crystal_array_8_target_z;
MCNUM focus_aw = mccchannel_11_analyzer_2_array_crystal_array_8_focus_aw;
MCNUM focus_ah = mccchannel_11_analyzer_2_array_crystal_array_8_focus_ah;
MCNUM focus_xw = mccchannel_11_analyzer_2_array_crystal_array_8_focus_xw;
MCNUM focus_xh = mccchannel_11_analyzer_2_array_crystal_array_8_focus_xh;
MCNUM focus_r = mccchannel_11_analyzer_2_array_crystal_array_8_focus_r;
MCNUM p_interact = mccchannel_11_analyzer_2_array_crystal_array_8_p_interact;
char* mask_string = mccchannel_11_analyzer_2_array_crystal_array_8_mask_string;
char* mask_setting = mccchannel_11_analyzer_2_array_crystal_array_8_mask_setting;
MCNUM number_of_activations = mccchannel_11_analyzer_2_array_crystal_array_8_number_of_activations;
}   /* End of channel_11_analyzer_2_array_crystal_array_8=Union_box() SETTING parameter declarations. */
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex
  /* Label for restoring  neutron */
  mcabsorbCompchannel_11_analyzer_2_array_crystal_array_8:
  if (RESTORE) /* restore if needed */
  { RESTORE_NEUTRON(567,
      mcnlx,
      mcnly,
      mcnlz,
      mcnlvx,
      mcnlvy,
      mcnlvz,
      mcnlt,
      mcnlsx,
      mcnlsy,
      mcnlsz,
      mcnlp); }
#undef mcabsorbComp
#undef p
#undef sz
#undef sy
#undef sx
#undef t
#undef vz
#undef vy
#undef vx
#undef z
#undef y
#undef x
  mcDEBUG_STATE(
mcnlx,
mcnly,
mcnlz,
mcnlvx,
mcnlvy,
mcnlvz,
mcnlt,
mcnlsx,
mcnlsy,
mcnlsz,
mcnlp)

  /* TRACE Component channel_11_cave2_cyl1 [568] */
  mccoordschange(mcposrchannel_11_cave2_cyl1, mcrotrchannel_11_cave2_cyl1,
    &mcnlx,
    &mcnly,
    &mcnlz,
    &mcnlvx,
    &mcnlvy,
    &mcnlvz,
    &mcnlsx,
    &mcnlsy,
    &mcnlsz);
  /* define label inside component channel_11_cave2_cyl1 (without coords transformations) */
  mcJumpTrace_channel_11_cave2_cyl1:
  SIG_MESSAGE("channel_11_cave2_cyl1 (Trace)");
  mcDEBUG_COMP("channel_11_cave2_cyl1")
  mcDEBUG_STATE(
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp)
#define x mcnlx
#define y mcnly
#define z mcnlz
#define vx mcnlvx
#define vy mcnlvy
#define vz mcnlvz
#define t mcnlt
#define sx mcnlsx
#define sy mcnlsy
#define sz mcnlsz
#define p mcnlp

#define mcabsorbComp mcabsorbCompchannel_11_cave2_cyl1
  STORE_NEUTRON(568,
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp);
  mcScattered=0;
  mcRestore=0;
  mcNCounter[568]++;
  mcPCounter[568] += p;
  mcP2Counter[568] += p*p;
#define mccompcurname  channel_11_cave2_cyl1
#define mccompcurtype  Union_cylinder
#define mccompcurindex 568
#define loop_index mccchannel_11_cave2_cyl1_loop_index
#define this_cylinder_volume mccchannel_11_cave2_cyl1_this_cylinder_volume
#define global_geometry_element mccchannel_11_cave2_cyl1_global_geometry_element
#define this_cylinder_storage mccchannel_11_cave2_cyl1_this_cylinder_storage
{   /* Declarations of channel_11_cave2_cyl1=Union_cylinder() SETTING parameters. */
char* material_string = mccchannel_11_cave2_cyl1_material_string;
MCNUM priority = mccchannel_11_cave2_cyl1_priority;
MCNUM radius = mccchannel_11_cave2_cyl1_radius;
MCNUM yheight = mccchannel_11_cave2_cyl1_yheight;
MCNUM visualize = mccchannel_11_cave2_cyl1_visualize;
int target_index = mccchannel_11_cave2_cyl1_target_index;
MCNUM target_x = mccchannel_11_cave2_cyl1_target_x;
MCNUM target_y = mccchannel_11_cave2_cyl1_target_y;
MCNUM target_z = mccchannel_11_cave2_cyl1_target_z;
MCNUM focus_aw = mccchannel_11_cave2_cyl1_focus_aw;
MCNUM focus_ah = mccchannel_11_cave2_cyl1_focus_ah;
MCNUM focus_xw = mccchannel_11_cave2_cyl1_focus_xw;
MCNUM focus_xh = mccchannel_11_cave2_cyl1_focus_xh;
MCNUM focus_r = mccchannel_11_cave2_cyl1_focus_r;
MCNUM p_interact = mccchannel_11_cave2_cyl1_p_interact;
char* mask_string = mccchannel_11_cave2_cyl1_mask_string;
char* mask_setting = mccchannel_11_cave2_cyl1_mask_setting;
MCNUM number_of_activations = mccchannel_11_cave2_cyl1_number_of_activations;
#line 345 "Union_cylinder.comp"
{
dummy = 1;
}
#line 420369 "MACS_sample_kidney_box.c"
}   /* End of channel_11_cave2_cyl1=Union_cylinder() SETTING parameter declarations. */
#undef this_cylinder_storage
#undef global_geometry_element
#undef this_cylinder_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex
  /* Label for restoring  neutron */
  mcabsorbCompchannel_11_cave2_cyl1:
  if (RESTORE) /* restore if needed */
  { RESTORE_NEUTRON(568,
      mcnlx,
      mcnly,
      mcnlz,
      mcnlvx,
      mcnlvy,
      mcnlvz,
      mcnlt,
      mcnlsx,
      mcnlsy,
      mcnlsz,
      mcnlp); }
#undef mcabsorbComp
#undef p
#undef sz
#undef sy
#undef sx
#undef t
#undef vz
#undef vy
#undef vx
#undef z
#undef y
#undef x
  mcDEBUG_STATE(
mcnlx,
mcnly,
mcnlz,
mcnlvx,
mcnlvy,
mcnlvz,
mcnlt,
mcnlsx,
mcnlsy,
mcnlsz,
mcnlp)

  /* TRACE Component channel_11_cave2_box1 [569] */
  mccoordschange(mcposrchannel_11_cave2_box1, mcrotrchannel_11_cave2_box1,
    &mcnlx,
    &mcnly,
    &mcnlz,
    &mcnlvx,
    &mcnlvy,
    &mcnlvz,
    &mcnlsx,
    &mcnlsy,
    &mcnlsz);
  /* define label inside component channel_11_cave2_box1 (without coords transformations) */
  mcJumpTrace_channel_11_cave2_box1:
  SIG_MESSAGE("channel_11_cave2_box1 (Trace)");
  mcDEBUG_COMP("channel_11_cave2_box1")
  mcDEBUG_STATE(
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp)
#define x mcnlx
#define y mcnly
#define z mcnlz
#define vx mcnlvx
#define vy mcnlvy
#define vz mcnlvz
#define t mcnlt
#define sx mcnlsx
#define sy mcnlsy
#define sz mcnlsz
#define p mcnlp

#define mcabsorbComp mcabsorbCompchannel_11_cave2_box1
  STORE_NEUTRON(569,
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp);
  mcScattered=0;
  mcRestore=0;
  mcNCounter[569]++;
  mcPCounter[569] += p;
  mcP2Counter[569] += p*p;
#define mccompcurname  channel_11_cave2_box1
#define mccompcurtype  Union_box
#define mccompcurindex 569
#define loop_index mccchannel_11_cave2_box1_loop_index
#define this_box_volume mccchannel_11_cave2_box1_this_box_volume
#define global_geometry_element mccchannel_11_cave2_box1_global_geometry_element
#define this_box_storage mccchannel_11_cave2_box1_this_box_storage
{   /* Declarations of channel_11_cave2_box1=Union_box() SETTING parameters. */
char* material_string = mccchannel_11_cave2_box1_material_string;
MCNUM priority = mccchannel_11_cave2_box1_priority;
MCNUM xwidth = mccchannel_11_cave2_box1_xwidth;
MCNUM yheight = mccchannel_11_cave2_box1_yheight;
MCNUM zdepth = mccchannel_11_cave2_box1_zdepth;
MCNUM xwidth2 = mccchannel_11_cave2_box1_xwidth2;
MCNUM yheight2 = mccchannel_11_cave2_box1_yheight2;
MCNUM visualize = mccchannel_11_cave2_box1_visualize;
int target_index = mccchannel_11_cave2_box1_target_index;
MCNUM target_x = mccchannel_11_cave2_box1_target_x;
MCNUM target_y = mccchannel_11_cave2_box1_target_y;
MCNUM target_z = mccchannel_11_cave2_box1_target_z;
MCNUM focus_aw = mccchannel_11_cave2_box1_focus_aw;
MCNUM focus_ah = mccchannel_11_cave2_box1_focus_ah;
MCNUM focus_xw = mccchannel_11_cave2_box1_focus_xw;
MCNUM focus_xh = mccchannel_11_cave2_box1_focus_xh;
MCNUM focus_r = mccchannel_11_cave2_box1_focus_r;
MCNUM p_interact = mccchannel_11_cave2_box1_p_interact;
char* mask_string = mccchannel_11_cave2_box1_mask_string;
char* mask_setting = mccchannel_11_cave2_box1_mask_setting;
MCNUM number_of_activations = mccchannel_11_cave2_box1_number_of_activations;
}   /* End of channel_11_cave2_box1=Union_box() SETTING parameter declarations. */
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex
  /* Label for restoring  neutron */
  mcabsorbCompchannel_11_cave2_box1:
  if (RESTORE) /* restore if needed */
  { RESTORE_NEUTRON(569,
      mcnlx,
      mcnly,
      mcnlz,
      mcnlvx,
      mcnlvy,
      mcnlvz,
      mcnlt,
      mcnlsx,
      mcnlsy,
      mcnlsz,
      mcnlp); }
#undef mcabsorbComp
#undef p
#undef sz
#undef sy
#undef sx
#undef t
#undef vz
#undef vy
#undef vx
#undef z
#undef y
#undef x
  mcDEBUG_STATE(
mcnlx,
mcnly,
mcnlz,
mcnlvx,
mcnlvy,
mcnlvz,
mcnlt,
mcnlsx,
mcnlsy,
mcnlsz,
mcnlp)

  /* TRACE Component channel_11_cave2_box2 [570] */
  mccoordschange(mcposrchannel_11_cave2_box2, mcrotrchannel_11_cave2_box2,
    &mcnlx,
    &mcnly,
    &mcnlz,
    &mcnlvx,
    &mcnlvy,
    &mcnlvz,
    &mcnlsx,
    &mcnlsy,
    &mcnlsz);
  /* define label inside component channel_11_cave2_box2 (without coords transformations) */
  mcJumpTrace_channel_11_cave2_box2:
  SIG_MESSAGE("channel_11_cave2_box2 (Trace)");
  mcDEBUG_COMP("channel_11_cave2_box2")
  mcDEBUG_STATE(
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp)
#define x mcnlx
#define y mcnly
#define z mcnlz
#define vx mcnlvx
#define vy mcnlvy
#define vz mcnlvz
#define t mcnlt
#define sx mcnlsx
#define sy mcnlsy
#define sz mcnlsz
#define p mcnlp

#define mcabsorbComp mcabsorbCompchannel_11_cave2_box2
  STORE_NEUTRON(570,
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp);
  mcScattered=0;
  mcRestore=0;
  mcNCounter[570]++;
  mcPCounter[570] += p;
  mcP2Counter[570] += p*p;
#define mccompcurname  channel_11_cave2_box2
#define mccompcurtype  Union_box
#define mccompcurindex 570
#define loop_index mccchannel_11_cave2_box2_loop_index
#define this_box_volume mccchannel_11_cave2_box2_this_box_volume
#define global_geometry_element mccchannel_11_cave2_box2_global_geometry_element
#define this_box_storage mccchannel_11_cave2_box2_this_box_storage
{   /* Declarations of channel_11_cave2_box2=Union_box() SETTING parameters. */
char* material_string = mccchannel_11_cave2_box2_material_string;
MCNUM priority = mccchannel_11_cave2_box2_priority;
MCNUM xwidth = mccchannel_11_cave2_box2_xwidth;
MCNUM yheight = mccchannel_11_cave2_box2_yheight;
MCNUM zdepth = mccchannel_11_cave2_box2_zdepth;
MCNUM xwidth2 = mccchannel_11_cave2_box2_xwidth2;
MCNUM yheight2 = mccchannel_11_cave2_box2_yheight2;
MCNUM visualize = mccchannel_11_cave2_box2_visualize;
int target_index = mccchannel_11_cave2_box2_target_index;
MCNUM target_x = mccchannel_11_cave2_box2_target_x;
MCNUM target_y = mccchannel_11_cave2_box2_target_y;
MCNUM target_z = mccchannel_11_cave2_box2_target_z;
MCNUM focus_aw = mccchannel_11_cave2_box2_focus_aw;
MCNUM focus_ah = mccchannel_11_cave2_box2_focus_ah;
MCNUM focus_xw = mccchannel_11_cave2_box2_focus_xw;
MCNUM focus_xh = mccchannel_11_cave2_box2_focus_xh;
MCNUM focus_r = mccchannel_11_cave2_box2_focus_r;
MCNUM p_interact = mccchannel_11_cave2_box2_p_interact;
char* mask_string = mccchannel_11_cave2_box2_mask_string;
char* mask_setting = mccchannel_11_cave2_box2_mask_setting;
MCNUM number_of_activations = mccchannel_11_cave2_box2_number_of_activations;
}   /* End of channel_11_cave2_box2=Union_box() SETTING parameter declarations. */
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex
  /* Label for restoring  neutron */
  mcabsorbCompchannel_11_cave2_box2:
  if (RESTORE) /* restore if needed */
  { RESTORE_NEUTRON(570,
      mcnlx,
      mcnly,
      mcnlz,
      mcnlvx,
      mcnlvy,
      mcnlvz,
      mcnlt,
      mcnlsx,
      mcnlsy,
      mcnlsz,
      mcnlp); }
#undef mcabsorbComp
#undef p
#undef sz
#undef sy
#undef sx
#undef t
#undef vz
#undef vy
#undef vx
#undef z
#undef y
#undef x
  mcDEBUG_STATE(
mcnlx,
mcnly,
mcnlz,
mcnlvx,
mcnlvy,
mcnlvz,
mcnlt,
mcnlsx,
mcnlsy,
mcnlsz,
mcnlp)

  /* TRACE Component channel_11_cave2_box3 [571] */
  mccoordschange(mcposrchannel_11_cave2_box3, mcrotrchannel_11_cave2_box3,
    &mcnlx,
    &mcnly,
    &mcnlz,
    &mcnlvx,
    &mcnlvy,
    &mcnlvz,
    &mcnlsx,
    &mcnlsy,
    &mcnlsz);
  /* define label inside component channel_11_cave2_box3 (without coords transformations) */
  mcJumpTrace_channel_11_cave2_box3:
  SIG_MESSAGE("channel_11_cave2_box3 (Trace)");
  mcDEBUG_COMP("channel_11_cave2_box3")
  mcDEBUG_STATE(
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp)
#define x mcnlx
#define y mcnly
#define z mcnlz
#define vx mcnlvx
#define vy mcnlvy
#define vz mcnlvz
#define t mcnlt
#define sx mcnlsx
#define sy mcnlsy
#define sz mcnlsz
#define p mcnlp

#define mcabsorbComp mcabsorbCompchannel_11_cave2_box3
  STORE_NEUTRON(571,
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp);
  mcScattered=0;
  mcRestore=0;
  mcNCounter[571]++;
  mcPCounter[571] += p;
  mcP2Counter[571] += p*p;
#define mccompcurname  channel_11_cave2_box3
#define mccompcurtype  Union_box
#define mccompcurindex 571
#define loop_index mccchannel_11_cave2_box3_loop_index
#define this_box_volume mccchannel_11_cave2_box3_this_box_volume
#define global_geometry_element mccchannel_11_cave2_box3_global_geometry_element
#define this_box_storage mccchannel_11_cave2_box3_this_box_storage
{   /* Declarations of channel_11_cave2_box3=Union_box() SETTING parameters. */
char* material_string = mccchannel_11_cave2_box3_material_string;
MCNUM priority = mccchannel_11_cave2_box3_priority;
MCNUM xwidth = mccchannel_11_cave2_box3_xwidth;
MCNUM yheight = mccchannel_11_cave2_box3_yheight;
MCNUM zdepth = mccchannel_11_cave2_box3_zdepth;
MCNUM xwidth2 = mccchannel_11_cave2_box3_xwidth2;
MCNUM yheight2 = mccchannel_11_cave2_box3_yheight2;
MCNUM visualize = mccchannel_11_cave2_box3_visualize;
int target_index = mccchannel_11_cave2_box3_target_index;
MCNUM target_x = mccchannel_11_cave2_box3_target_x;
MCNUM target_y = mccchannel_11_cave2_box3_target_y;
MCNUM target_z = mccchannel_11_cave2_box3_target_z;
MCNUM focus_aw = mccchannel_11_cave2_box3_focus_aw;
MCNUM focus_ah = mccchannel_11_cave2_box3_focus_ah;
MCNUM focus_xw = mccchannel_11_cave2_box3_focus_xw;
MCNUM focus_xh = mccchannel_11_cave2_box3_focus_xh;
MCNUM focus_r = mccchannel_11_cave2_box3_focus_r;
MCNUM p_interact = mccchannel_11_cave2_box3_p_interact;
char* mask_string = mccchannel_11_cave2_box3_mask_string;
char* mask_setting = mccchannel_11_cave2_box3_mask_setting;
MCNUM number_of_activations = mccchannel_11_cave2_box3_number_of_activations;
}   /* End of channel_11_cave2_box3=Union_box() SETTING parameter declarations. */
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex
  /* Label for restoring  neutron */
  mcabsorbCompchannel_11_cave2_box3:
  if (RESTORE) /* restore if needed */
  { RESTORE_NEUTRON(571,
      mcnlx,
      mcnly,
      mcnlz,
      mcnlvx,
      mcnlvy,
      mcnlvz,
      mcnlt,
      mcnlsx,
      mcnlsy,
      mcnlsz,
      mcnlp); }
#undef mcabsorbComp
#undef p
#undef sz
#undef sy
#undef sx
#undef t
#undef vz
#undef vy
#undef vx
#undef z
#undef y
#undef x
  mcDEBUG_STATE(
mcnlx,
mcnly,
mcnlz,
mcnlvx,
mcnlvy,
mcnlvz,
mcnlt,
mcnlsx,
mcnlsy,
mcnlsz,
mcnlp)

  /* TRACE Component inter_analyzer_colimator_center_11 [572] */
  mccoordschange(mcposrinter_analyzer_colimator_center_11, mcrotrinter_analyzer_colimator_center_11,
    &mcnlx,
    &mcnly,
    &mcnlz,
    &mcnlvx,
    &mcnlvy,
    &mcnlvz,
    &mcnlsx,
    &mcnlsy,
    &mcnlsz);
  /* define label inside component inter_analyzer_colimator_center_11 (without coords transformations) */
  mcJumpTrace_inter_analyzer_colimator_center_11:
  SIG_MESSAGE("inter_analyzer_colimator_center_11 (Trace)");
  mcDEBUG_COMP("inter_analyzer_colimator_center_11")
  mcDEBUG_STATE(
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp)
#define x mcnlx
#define y mcnly
#define z mcnlz
#define vx mcnlvx
#define vy mcnlvy
#define vz mcnlvz
#define t mcnlt
#define sx mcnlsx
#define sy mcnlsy
#define sz mcnlsz
#define p mcnlp

#define mcabsorbComp mcabsorbCompinter_analyzer_colimator_center_11
  STORE_NEUTRON(572,
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp);
  mcScattered=0;
  mcRestore=0;
  mcNCounter[572]++;
  mcPCounter[572] += p;
  mcP2Counter[572] += p*p;
#define mccompcurname  inter_analyzer_colimator_center_11
#define mccompcurtype  Arm
#define mccompcurindex 572
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex
  /* Label for restoring  neutron */
  mcabsorbCompinter_analyzer_colimator_center_11:
  if (RESTORE) /* restore if needed */
  { RESTORE_NEUTRON(572,
      mcnlx,
      mcnly,
      mcnlz,
      mcnlvx,
      mcnlvy,
      mcnlvz,
      mcnlt,
      mcnlsx,
      mcnlsy,
      mcnlsz,
      mcnlp); }
#undef mcabsorbComp
#undef p
#undef sz
#undef sy
#undef sx
#undef t
#undef vz
#undef vy
#undef vx
#undef z
#undef y
#undef x
  mcDEBUG_STATE(
mcnlx,
mcnly,
mcnlz,
mcnlvx,
mcnlvy,
mcnlvz,
mcnlt,
mcnlsx,
mcnlsy,
mcnlsz,
mcnlp)

  /* TRACE Component inter_analyzer_colimator_11_blade_0 [573] */
  mccoordschange(mcposrinter_analyzer_colimator_11_blade_0, mcrotrinter_analyzer_colimator_11_blade_0,
    &mcnlx,
    &mcnly,
    &mcnlz,
    &mcnlvx,
    &mcnlvy,
    &mcnlvz,
    &mcnlsx,
    &mcnlsy,
    &mcnlsz);
  /* define label inside component inter_analyzer_colimator_11_blade_0 (without coords transformations) */
  mcJumpTrace_inter_analyzer_colimator_11_blade_0:
  SIG_MESSAGE("inter_analyzer_colimator_11_blade_0 (Trace)");
  mcDEBUG_COMP("inter_analyzer_colimator_11_blade_0")
  mcDEBUG_STATE(
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp)
#define x mcnlx
#define y mcnly
#define z mcnlz
#define vx mcnlvx
#define vy mcnlvy
#define vz mcnlvz
#define t mcnlt
#define sx mcnlsx
#define sy mcnlsy
#define sz mcnlsz
#define p mcnlp

#define mcabsorbComp mcabsorbCompinter_analyzer_colimator_11_blade_0
  STORE_NEUTRON(573,
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp);
  mcScattered=0;
  mcRestore=0;
  mcNCounter[573]++;
  mcPCounter[573] += p;
  mcP2Counter[573] += p*p;
#define mccompcurname  inter_analyzer_colimator_11_blade_0
#define mccompcurtype  Union_box
#define mccompcurindex 573
#define loop_index mccinter_analyzer_colimator_11_blade_0_loop_index
#define this_box_volume mccinter_analyzer_colimator_11_blade_0_this_box_volume
#define global_geometry_element mccinter_analyzer_colimator_11_blade_0_global_geometry_element
#define this_box_storage mccinter_analyzer_colimator_11_blade_0_this_box_storage
{   /* Declarations of inter_analyzer_colimator_11_blade_0=Union_box() SETTING parameters. */
char* material_string = mccinter_analyzer_colimator_11_blade_0_material_string;
MCNUM priority = mccinter_analyzer_colimator_11_blade_0_priority;
MCNUM xwidth = mccinter_analyzer_colimator_11_blade_0_xwidth;
MCNUM yheight = mccinter_analyzer_colimator_11_blade_0_yheight;
MCNUM zdepth = mccinter_analyzer_colimator_11_blade_0_zdepth;
MCNUM xwidth2 = mccinter_analyzer_colimator_11_blade_0_xwidth2;
MCNUM yheight2 = mccinter_analyzer_colimator_11_blade_0_yheight2;
MCNUM visualize = mccinter_analyzer_colimator_11_blade_0_visualize;
int target_index = mccinter_analyzer_colimator_11_blade_0_target_index;
MCNUM target_x = mccinter_analyzer_colimator_11_blade_0_target_x;
MCNUM target_y = mccinter_analyzer_colimator_11_blade_0_target_y;
MCNUM target_z = mccinter_analyzer_colimator_11_blade_0_target_z;
MCNUM focus_aw = mccinter_analyzer_colimator_11_blade_0_focus_aw;
MCNUM focus_ah = mccinter_analyzer_colimator_11_blade_0_focus_ah;
MCNUM focus_xw = mccinter_analyzer_colimator_11_blade_0_focus_xw;
MCNUM focus_xh = mccinter_analyzer_colimator_11_blade_0_focus_xh;
MCNUM focus_r = mccinter_analyzer_colimator_11_blade_0_focus_r;
MCNUM p_interact = mccinter_analyzer_colimator_11_blade_0_p_interact;
char* mask_string = mccinter_analyzer_colimator_11_blade_0_mask_string;
char* mask_setting = mccinter_analyzer_colimator_11_blade_0_mask_setting;
MCNUM number_of_activations = mccinter_analyzer_colimator_11_blade_0_number_of_activations;
}   /* End of inter_analyzer_colimator_11_blade_0=Union_box() SETTING parameter declarations. */
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex
  /* Label for restoring  neutron */
  mcabsorbCompinter_analyzer_colimator_11_blade_0:
  if (RESTORE) /* restore if needed */
  { RESTORE_NEUTRON(573,
      mcnlx,
      mcnly,
      mcnlz,
      mcnlvx,
      mcnlvy,
      mcnlvz,
      mcnlt,
      mcnlsx,
      mcnlsy,
      mcnlsz,
      mcnlp); }
#undef mcabsorbComp
#undef p
#undef sz
#undef sy
#undef sx
#undef t
#undef vz
#undef vy
#undef vx
#undef z
#undef y
#undef x
  mcDEBUG_STATE(
mcnlx,
mcnly,
mcnlz,
mcnlvx,
mcnlvy,
mcnlvz,
mcnlt,
mcnlsx,
mcnlsy,
mcnlsz,
mcnlp)

  /* TRACE Component inter_analyzer_colimator_11_blade_1 [574] */
  mccoordschange(mcposrinter_analyzer_colimator_11_blade_1, mcrotrinter_analyzer_colimator_11_blade_1,
    &mcnlx,
    &mcnly,
    &mcnlz,
    &mcnlvx,
    &mcnlvy,
    &mcnlvz,
    &mcnlsx,
    &mcnlsy,
    &mcnlsz);
  /* define label inside component inter_analyzer_colimator_11_blade_1 (without coords transformations) */
  mcJumpTrace_inter_analyzer_colimator_11_blade_1:
  SIG_MESSAGE("inter_analyzer_colimator_11_blade_1 (Trace)");
  mcDEBUG_COMP("inter_analyzer_colimator_11_blade_1")
  mcDEBUG_STATE(
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp)
#define x mcnlx
#define y mcnly
#define z mcnlz
#define vx mcnlvx
#define vy mcnlvy
#define vz mcnlvz
#define t mcnlt
#define sx mcnlsx
#define sy mcnlsy
#define sz mcnlsz
#define p mcnlp

#define mcabsorbComp mcabsorbCompinter_analyzer_colimator_11_blade_1
  STORE_NEUTRON(574,
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp);
  mcScattered=0;
  mcRestore=0;
  mcNCounter[574]++;
  mcPCounter[574] += p;
  mcP2Counter[574] += p*p;
#define mccompcurname  inter_analyzer_colimator_11_blade_1
#define mccompcurtype  Union_box
#define mccompcurindex 574
#define loop_index mccinter_analyzer_colimator_11_blade_1_loop_index
#define this_box_volume mccinter_analyzer_colimator_11_blade_1_this_box_volume
#define global_geometry_element mccinter_analyzer_colimator_11_blade_1_global_geometry_element
#define this_box_storage mccinter_analyzer_colimator_11_blade_1_this_box_storage
{   /* Declarations of inter_analyzer_colimator_11_blade_1=Union_box() SETTING parameters. */
char* material_string = mccinter_analyzer_colimator_11_blade_1_material_string;
MCNUM priority = mccinter_analyzer_colimator_11_blade_1_priority;
MCNUM xwidth = mccinter_analyzer_colimator_11_blade_1_xwidth;
MCNUM yheight = mccinter_analyzer_colimator_11_blade_1_yheight;
MCNUM zdepth = mccinter_analyzer_colimator_11_blade_1_zdepth;
MCNUM xwidth2 = mccinter_analyzer_colimator_11_blade_1_xwidth2;
MCNUM yheight2 = mccinter_analyzer_colimator_11_blade_1_yheight2;
MCNUM visualize = mccinter_analyzer_colimator_11_blade_1_visualize;
int target_index = mccinter_analyzer_colimator_11_blade_1_target_index;
MCNUM target_x = mccinter_analyzer_colimator_11_blade_1_target_x;
MCNUM target_y = mccinter_analyzer_colimator_11_blade_1_target_y;
MCNUM target_z = mccinter_analyzer_colimator_11_blade_1_target_z;
MCNUM focus_aw = mccinter_analyzer_colimator_11_blade_1_focus_aw;
MCNUM focus_ah = mccinter_analyzer_colimator_11_blade_1_focus_ah;
MCNUM focus_xw = mccinter_analyzer_colimator_11_blade_1_focus_xw;
MCNUM focus_xh = mccinter_analyzer_colimator_11_blade_1_focus_xh;
MCNUM focus_r = mccinter_analyzer_colimator_11_blade_1_focus_r;
MCNUM p_interact = mccinter_analyzer_colimator_11_blade_1_p_interact;
char* mask_string = mccinter_analyzer_colimator_11_blade_1_mask_string;
char* mask_setting = mccinter_analyzer_colimator_11_blade_1_mask_setting;
MCNUM number_of_activations = mccinter_analyzer_colimator_11_blade_1_number_of_activations;
}   /* End of inter_analyzer_colimator_11_blade_1=Union_box() SETTING parameter declarations. */
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex
  /* Label for restoring  neutron */
  mcabsorbCompinter_analyzer_colimator_11_blade_1:
  if (RESTORE) /* restore if needed */
  { RESTORE_NEUTRON(574,
      mcnlx,
      mcnly,
      mcnlz,
      mcnlvx,
      mcnlvy,
      mcnlvz,
      mcnlt,
      mcnlsx,
      mcnlsy,
      mcnlsz,
      mcnlp); }
#undef mcabsorbComp
#undef p
#undef sz
#undef sy
#undef sx
#undef t
#undef vz
#undef vy
#undef vx
#undef z
#undef y
#undef x
  mcDEBUG_STATE(
mcnlx,
mcnly,
mcnlz,
mcnlvx,
mcnlvy,
mcnlvz,
mcnlt,
mcnlsx,
mcnlsy,
mcnlsz,
mcnlp)

  /* TRACE Component inter_analyzer_colimator_11_blade_2 [575] */
  mccoordschange(mcposrinter_analyzer_colimator_11_blade_2, mcrotrinter_analyzer_colimator_11_blade_2,
    &mcnlx,
    &mcnly,
    &mcnlz,
    &mcnlvx,
    &mcnlvy,
    &mcnlvz,
    &mcnlsx,
    &mcnlsy,
    &mcnlsz);
  /* define label inside component inter_analyzer_colimator_11_blade_2 (without coords transformations) */
  mcJumpTrace_inter_analyzer_colimator_11_blade_2:
  SIG_MESSAGE("inter_analyzer_colimator_11_blade_2 (Trace)");
  mcDEBUG_COMP("inter_analyzer_colimator_11_blade_2")
  mcDEBUG_STATE(
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp)
#define x mcnlx
#define y mcnly
#define z mcnlz
#define vx mcnlvx
#define vy mcnlvy
#define vz mcnlvz
#define t mcnlt
#define sx mcnlsx
#define sy mcnlsy
#define sz mcnlsz
#define p mcnlp

#define mcabsorbComp mcabsorbCompinter_analyzer_colimator_11_blade_2
  STORE_NEUTRON(575,
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp);
  mcScattered=0;
  mcRestore=0;
  mcNCounter[575]++;
  mcPCounter[575] += p;
  mcP2Counter[575] += p*p;
#define mccompcurname  inter_analyzer_colimator_11_blade_2
#define mccompcurtype  Union_box
#define mccompcurindex 575
#define loop_index mccinter_analyzer_colimator_11_blade_2_loop_index
#define this_box_volume mccinter_analyzer_colimator_11_blade_2_this_box_volume
#define global_geometry_element mccinter_analyzer_colimator_11_blade_2_global_geometry_element
#define this_box_storage mccinter_analyzer_colimator_11_blade_2_this_box_storage
{   /* Declarations of inter_analyzer_colimator_11_blade_2=Union_box() SETTING parameters. */
char* material_string = mccinter_analyzer_colimator_11_blade_2_material_string;
MCNUM priority = mccinter_analyzer_colimator_11_blade_2_priority;
MCNUM xwidth = mccinter_analyzer_colimator_11_blade_2_xwidth;
MCNUM yheight = mccinter_analyzer_colimator_11_blade_2_yheight;
MCNUM zdepth = mccinter_analyzer_colimator_11_blade_2_zdepth;
MCNUM xwidth2 = mccinter_analyzer_colimator_11_blade_2_xwidth2;
MCNUM yheight2 = mccinter_analyzer_colimator_11_blade_2_yheight2;
MCNUM visualize = mccinter_analyzer_colimator_11_blade_2_visualize;
int target_index = mccinter_analyzer_colimator_11_blade_2_target_index;
MCNUM target_x = mccinter_analyzer_colimator_11_blade_2_target_x;
MCNUM target_y = mccinter_analyzer_colimator_11_blade_2_target_y;
MCNUM target_z = mccinter_analyzer_colimator_11_blade_2_target_z;
MCNUM focus_aw = mccinter_analyzer_colimator_11_blade_2_focus_aw;
MCNUM focus_ah = mccinter_analyzer_colimator_11_blade_2_focus_ah;
MCNUM focus_xw = mccinter_analyzer_colimator_11_blade_2_focus_xw;
MCNUM focus_xh = mccinter_analyzer_colimator_11_blade_2_focus_xh;
MCNUM focus_r = mccinter_analyzer_colimator_11_blade_2_focus_r;
MCNUM p_interact = mccinter_analyzer_colimator_11_blade_2_p_interact;
char* mask_string = mccinter_analyzer_colimator_11_blade_2_mask_string;
char* mask_setting = mccinter_analyzer_colimator_11_blade_2_mask_setting;
MCNUM number_of_activations = mccinter_analyzer_colimator_11_blade_2_number_of_activations;
}   /* End of inter_analyzer_colimator_11_blade_2=Union_box() SETTING parameter declarations. */
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex
  /* Label for restoring  neutron */
  mcabsorbCompinter_analyzer_colimator_11_blade_2:
  if (RESTORE) /* restore if needed */
  { RESTORE_NEUTRON(575,
      mcnlx,
      mcnly,
      mcnlz,
      mcnlvx,
      mcnlvy,
      mcnlvz,
      mcnlt,
      mcnlsx,
      mcnlsy,
      mcnlsz,
      mcnlp); }
#undef mcabsorbComp
#undef p
#undef sz
#undef sy
#undef sx
#undef t
#undef vz
#undef vy
#undef vx
#undef z
#undef y
#undef x
  mcDEBUG_STATE(
mcnlx,
mcnly,
mcnlz,
mcnlvx,
mcnlvy,
mcnlvz,
mcnlt,
mcnlsx,
mcnlsy,
mcnlsz,
mcnlp)

  /* TRACE Component inter_analyzer_colimator_11_blade_3 [576] */
  mccoordschange(mcposrinter_analyzer_colimator_11_blade_3, mcrotrinter_analyzer_colimator_11_blade_3,
    &mcnlx,
    &mcnly,
    &mcnlz,
    &mcnlvx,
    &mcnlvy,
    &mcnlvz,
    &mcnlsx,
    &mcnlsy,
    &mcnlsz);
  /* define label inside component inter_analyzer_colimator_11_blade_3 (without coords transformations) */
  mcJumpTrace_inter_analyzer_colimator_11_blade_3:
  SIG_MESSAGE("inter_analyzer_colimator_11_blade_3 (Trace)");
  mcDEBUG_COMP("inter_analyzer_colimator_11_blade_3")
  mcDEBUG_STATE(
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp)
#define x mcnlx
#define y mcnly
#define z mcnlz
#define vx mcnlvx
#define vy mcnlvy
#define vz mcnlvz
#define t mcnlt
#define sx mcnlsx
#define sy mcnlsy
#define sz mcnlsz
#define p mcnlp

#define mcabsorbComp mcabsorbCompinter_analyzer_colimator_11_blade_3
  STORE_NEUTRON(576,
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp);
  mcScattered=0;
  mcRestore=0;
  mcNCounter[576]++;
  mcPCounter[576] += p;
  mcP2Counter[576] += p*p;
#define mccompcurname  inter_analyzer_colimator_11_blade_3
#define mccompcurtype  Union_box
#define mccompcurindex 576
#define loop_index mccinter_analyzer_colimator_11_blade_3_loop_index
#define this_box_volume mccinter_analyzer_colimator_11_blade_3_this_box_volume
#define global_geometry_element mccinter_analyzer_colimator_11_blade_3_global_geometry_element
#define this_box_storage mccinter_analyzer_colimator_11_blade_3_this_box_storage
{   /* Declarations of inter_analyzer_colimator_11_blade_3=Union_box() SETTING parameters. */
char* material_string = mccinter_analyzer_colimator_11_blade_3_material_string;
MCNUM priority = mccinter_analyzer_colimator_11_blade_3_priority;
MCNUM xwidth = mccinter_analyzer_colimator_11_blade_3_xwidth;
MCNUM yheight = mccinter_analyzer_colimator_11_blade_3_yheight;
MCNUM zdepth = mccinter_analyzer_colimator_11_blade_3_zdepth;
MCNUM xwidth2 = mccinter_analyzer_colimator_11_blade_3_xwidth2;
MCNUM yheight2 = mccinter_analyzer_colimator_11_blade_3_yheight2;
MCNUM visualize = mccinter_analyzer_colimator_11_blade_3_visualize;
int target_index = mccinter_analyzer_colimator_11_blade_3_target_index;
MCNUM target_x = mccinter_analyzer_colimator_11_blade_3_target_x;
MCNUM target_y = mccinter_analyzer_colimator_11_blade_3_target_y;
MCNUM target_z = mccinter_analyzer_colimator_11_blade_3_target_z;
MCNUM focus_aw = mccinter_analyzer_colimator_11_blade_3_focus_aw;
MCNUM focus_ah = mccinter_analyzer_colimator_11_blade_3_focus_ah;
MCNUM focus_xw = mccinter_analyzer_colimator_11_blade_3_focus_xw;
MCNUM focus_xh = mccinter_analyzer_colimator_11_blade_3_focus_xh;
MCNUM focus_r = mccinter_analyzer_colimator_11_blade_3_focus_r;
MCNUM p_interact = mccinter_analyzer_colimator_11_blade_3_p_interact;
char* mask_string = mccinter_analyzer_colimator_11_blade_3_mask_string;
char* mask_setting = mccinter_analyzer_colimator_11_blade_3_mask_setting;
MCNUM number_of_activations = mccinter_analyzer_colimator_11_blade_3_number_of_activations;
}   /* End of inter_analyzer_colimator_11_blade_3=Union_box() SETTING parameter declarations. */
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex
  /* Label for restoring  neutron */
  mcabsorbCompinter_analyzer_colimator_11_blade_3:
  if (RESTORE) /* restore if needed */
  { RESTORE_NEUTRON(576,
      mcnlx,
      mcnly,
      mcnlz,
      mcnlvx,
      mcnlvy,
      mcnlvz,
      mcnlt,
      mcnlsx,
      mcnlsy,
      mcnlsz,
      mcnlp); }
#undef mcabsorbComp
#undef p
#undef sz
#undef sy
#undef sx
#undef t
#undef vz
#undef vy
#undef vx
#undef z
#undef y
#undef x
  mcDEBUG_STATE(
mcnlx,
mcnly,
mcnlz,
mcnlvx,
mcnlvy,
mcnlvz,
mcnlt,
mcnlsx,
mcnlsy,
mcnlsz,
mcnlp)

  /* TRACE Component inter_analyzer_colimator_11_blade_4 [577] */
  mccoordschange(mcposrinter_analyzer_colimator_11_blade_4, mcrotrinter_analyzer_colimator_11_blade_4,
    &mcnlx,
    &mcnly,
    &mcnlz,
    &mcnlvx,
    &mcnlvy,
    &mcnlvz,
    &mcnlsx,
    &mcnlsy,
    &mcnlsz);
  /* define label inside component inter_analyzer_colimator_11_blade_4 (without coords transformations) */
  mcJumpTrace_inter_analyzer_colimator_11_blade_4:
  SIG_MESSAGE("inter_analyzer_colimator_11_blade_4 (Trace)");
  mcDEBUG_COMP("inter_analyzer_colimator_11_blade_4")
  mcDEBUG_STATE(
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp)
#define x mcnlx
#define y mcnly
#define z mcnlz
#define vx mcnlvx
#define vy mcnlvy
#define vz mcnlvz
#define t mcnlt
#define sx mcnlsx
#define sy mcnlsy
#define sz mcnlsz
#define p mcnlp

#define mcabsorbComp mcabsorbCompinter_analyzer_colimator_11_blade_4
  STORE_NEUTRON(577,
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp);
  mcScattered=0;
  mcRestore=0;
  mcNCounter[577]++;
  mcPCounter[577] += p;
  mcP2Counter[577] += p*p;
#define mccompcurname  inter_analyzer_colimator_11_blade_4
#define mccompcurtype  Union_box
#define mccompcurindex 577
#define loop_index mccinter_analyzer_colimator_11_blade_4_loop_index
#define this_box_volume mccinter_analyzer_colimator_11_blade_4_this_box_volume
#define global_geometry_element mccinter_analyzer_colimator_11_blade_4_global_geometry_element
#define this_box_storage mccinter_analyzer_colimator_11_blade_4_this_box_storage
{   /* Declarations of inter_analyzer_colimator_11_blade_4=Union_box() SETTING parameters. */
char* material_string = mccinter_analyzer_colimator_11_blade_4_material_string;
MCNUM priority = mccinter_analyzer_colimator_11_blade_4_priority;
MCNUM xwidth = mccinter_analyzer_colimator_11_blade_4_xwidth;
MCNUM yheight = mccinter_analyzer_colimator_11_blade_4_yheight;
MCNUM zdepth = mccinter_analyzer_colimator_11_blade_4_zdepth;
MCNUM xwidth2 = mccinter_analyzer_colimator_11_blade_4_xwidth2;
MCNUM yheight2 = mccinter_analyzer_colimator_11_blade_4_yheight2;
MCNUM visualize = mccinter_analyzer_colimator_11_blade_4_visualize;
int target_index = mccinter_analyzer_colimator_11_blade_4_target_index;
MCNUM target_x = mccinter_analyzer_colimator_11_blade_4_target_x;
MCNUM target_y = mccinter_analyzer_colimator_11_blade_4_target_y;
MCNUM target_z = mccinter_analyzer_colimator_11_blade_4_target_z;
MCNUM focus_aw = mccinter_analyzer_colimator_11_blade_4_focus_aw;
MCNUM focus_ah = mccinter_analyzer_colimator_11_blade_4_focus_ah;
MCNUM focus_xw = mccinter_analyzer_colimator_11_blade_4_focus_xw;
MCNUM focus_xh = mccinter_analyzer_colimator_11_blade_4_focus_xh;
MCNUM focus_r = mccinter_analyzer_colimator_11_blade_4_focus_r;
MCNUM p_interact = mccinter_analyzer_colimator_11_blade_4_p_interact;
char* mask_string = mccinter_analyzer_colimator_11_blade_4_mask_string;
char* mask_setting = mccinter_analyzer_colimator_11_blade_4_mask_setting;
MCNUM number_of_activations = mccinter_analyzer_colimator_11_blade_4_number_of_activations;
}   /* End of inter_analyzer_colimator_11_blade_4=Union_box() SETTING parameter declarations. */
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex
  /* Label for restoring  neutron */
  mcabsorbCompinter_analyzer_colimator_11_blade_4:
  if (RESTORE) /* restore if needed */
  { RESTORE_NEUTRON(577,
      mcnlx,
      mcnly,
      mcnlz,
      mcnlvx,
      mcnlvy,
      mcnlvz,
      mcnlt,
      mcnlsx,
      mcnlsy,
      mcnlsz,
      mcnlp); }
#undef mcabsorbComp
#undef p
#undef sz
#undef sy
#undef sx
#undef t
#undef vz
#undef vy
#undef vx
#undef z
#undef y
#undef x
  mcDEBUG_STATE(
mcnlx,
mcnly,
mcnlz,
mcnlvx,
mcnlvy,
mcnlvz,
mcnlt,
mcnlsx,
mcnlsy,
mcnlsz,
mcnlp)

  /* TRACE Component diffraction_detector_11_exit_volume [578] */
  mccoordschange(mcposrdiffraction_detector_11_exit_volume, mcrotrdiffraction_detector_11_exit_volume,
    &mcnlx,
    &mcnly,
    &mcnlz,
    &mcnlvx,
    &mcnlvy,
    &mcnlvz,
    &mcnlsx,
    &mcnlsy,
    &mcnlsz);
  /* define label inside component diffraction_detector_11_exit_volume (without coords transformations) */
  mcJumpTrace_diffraction_detector_11_exit_volume:
  SIG_MESSAGE("diffraction_detector_11_exit_volume (Trace)");
  mcDEBUG_COMP("diffraction_detector_11_exit_volume")
  mcDEBUG_STATE(
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp)
#define x mcnlx
#define y mcnly
#define z mcnlz
#define vx mcnlvx
#define vy mcnlvy
#define vz mcnlvz
#define t mcnlt
#define sx mcnlsx
#define sy mcnlsy
#define sz mcnlsz
#define p mcnlp

#define mcabsorbComp mcabsorbCompdiffraction_detector_11_exit_volume
  STORE_NEUTRON(578,
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp);
  mcScattered=0;
  mcRestore=0;
  mcNCounter[578]++;
  mcPCounter[578] += p;
  mcP2Counter[578] += p*p;
#define mccompcurname  diffraction_detector_11_exit_volume
#define mccompcurtype  Union_box
#define mccompcurindex 578
#define loop_index mccdiffraction_detector_11_exit_volume_loop_index
#define this_box_volume mccdiffraction_detector_11_exit_volume_this_box_volume
#define global_geometry_element mccdiffraction_detector_11_exit_volume_global_geometry_element
#define this_box_storage mccdiffraction_detector_11_exit_volume_this_box_storage
{   /* Declarations of diffraction_detector_11_exit_volume=Union_box() SETTING parameters. */
char* material_string = mccdiffraction_detector_11_exit_volume_material_string;
MCNUM priority = mccdiffraction_detector_11_exit_volume_priority;
MCNUM xwidth = mccdiffraction_detector_11_exit_volume_xwidth;
MCNUM yheight = mccdiffraction_detector_11_exit_volume_yheight;
MCNUM zdepth = mccdiffraction_detector_11_exit_volume_zdepth;
MCNUM xwidth2 = mccdiffraction_detector_11_exit_volume_xwidth2;
MCNUM yheight2 = mccdiffraction_detector_11_exit_volume_yheight2;
MCNUM visualize = mccdiffraction_detector_11_exit_volume_visualize;
int target_index = mccdiffraction_detector_11_exit_volume_target_index;
MCNUM target_x = mccdiffraction_detector_11_exit_volume_target_x;
MCNUM target_y = mccdiffraction_detector_11_exit_volume_target_y;
MCNUM target_z = mccdiffraction_detector_11_exit_volume_target_z;
MCNUM focus_aw = mccdiffraction_detector_11_exit_volume_focus_aw;
MCNUM focus_ah = mccdiffraction_detector_11_exit_volume_focus_ah;
MCNUM focus_xw = mccdiffraction_detector_11_exit_volume_focus_xw;
MCNUM focus_xh = mccdiffraction_detector_11_exit_volume_focus_xh;
MCNUM focus_r = mccdiffraction_detector_11_exit_volume_focus_r;
MCNUM p_interact = mccdiffraction_detector_11_exit_volume_p_interact;
char* mask_string = mccdiffraction_detector_11_exit_volume_mask_string;
char* mask_setting = mccdiffraction_detector_11_exit_volume_mask_setting;
MCNUM number_of_activations = mccdiffraction_detector_11_exit_volume_number_of_activations;
}   /* End of diffraction_detector_11_exit_volume=Union_box() SETTING parameter declarations. */
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex
  /* Label for restoring  neutron */
  mcabsorbCompdiffraction_detector_11_exit_volume:
  if (RESTORE) /* restore if needed */
  { RESTORE_NEUTRON(578,
      mcnlx,
      mcnly,
      mcnlz,
      mcnlvx,
      mcnlvy,
      mcnlvz,
      mcnlt,
      mcnlsx,
      mcnlsy,
      mcnlsz,
      mcnlp); }
#undef mcabsorbComp
#undef p
#undef sz
#undef sy
#undef sx
#undef t
#undef vz
#undef vy
#undef vx
#undef z
#undef y
#undef x
  mcDEBUG_STATE(
mcnlx,
mcnly,
mcnlz,
mcnlvx,
mcnlvy,
mcnlvz,
mcnlt,
mcnlsx,
mcnlsy,
mcnlsz,
mcnlp)

  /* TRACE Component spec_detector_11_exit_volume [579] */
  mccoordschange(mcposrspec_detector_11_exit_volume, mcrotrspec_detector_11_exit_volume,
    &mcnlx,
    &mcnly,
    &mcnlz,
    &mcnlvx,
    &mcnlvy,
    &mcnlvz,
    &mcnlsx,
    &mcnlsy,
    &mcnlsz);
  /* define label inside component spec_detector_11_exit_volume (without coords transformations) */
  mcJumpTrace_spec_detector_11_exit_volume:
  SIG_MESSAGE("spec_detector_11_exit_volume (Trace)");
  mcDEBUG_COMP("spec_detector_11_exit_volume")
  mcDEBUG_STATE(
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp)
#define x mcnlx
#define y mcnly
#define z mcnlz
#define vx mcnlvx
#define vy mcnlvy
#define vz mcnlvz
#define t mcnlt
#define sx mcnlsx
#define sy mcnlsy
#define sz mcnlsz
#define p mcnlp

#define mcabsorbComp mcabsorbCompspec_detector_11_exit_volume
  STORE_NEUTRON(579,
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp);
  mcScattered=0;
  mcRestore=0;
  mcNCounter[579]++;
  mcPCounter[579] += p;
  mcP2Counter[579] += p*p;
#define mccompcurname  spec_detector_11_exit_volume
#define mccompcurtype  Union_box
#define mccompcurindex 579
#define loop_index mccspec_detector_11_exit_volume_loop_index
#define this_box_volume mccspec_detector_11_exit_volume_this_box_volume
#define global_geometry_element mccspec_detector_11_exit_volume_global_geometry_element
#define this_box_storage mccspec_detector_11_exit_volume_this_box_storage
{   /* Declarations of spec_detector_11_exit_volume=Union_box() SETTING parameters. */
char* material_string = mccspec_detector_11_exit_volume_material_string;
MCNUM priority = mccspec_detector_11_exit_volume_priority;
MCNUM xwidth = mccspec_detector_11_exit_volume_xwidth;
MCNUM yheight = mccspec_detector_11_exit_volume_yheight;
MCNUM zdepth = mccspec_detector_11_exit_volume_zdepth;
MCNUM xwidth2 = mccspec_detector_11_exit_volume_xwidth2;
MCNUM yheight2 = mccspec_detector_11_exit_volume_yheight2;
MCNUM visualize = mccspec_detector_11_exit_volume_visualize;
int target_index = mccspec_detector_11_exit_volume_target_index;
MCNUM target_x = mccspec_detector_11_exit_volume_target_x;
MCNUM target_y = mccspec_detector_11_exit_volume_target_y;
MCNUM target_z = mccspec_detector_11_exit_volume_target_z;
MCNUM focus_aw = mccspec_detector_11_exit_volume_focus_aw;
MCNUM focus_ah = mccspec_detector_11_exit_volume_focus_ah;
MCNUM focus_xw = mccspec_detector_11_exit_volume_focus_xw;
MCNUM focus_xh = mccspec_detector_11_exit_volume_focus_xh;
MCNUM focus_r = mccspec_detector_11_exit_volume_focus_r;
MCNUM p_interact = mccspec_detector_11_exit_volume_p_interact;
char* mask_string = mccspec_detector_11_exit_volume_mask_string;
char* mask_setting = mccspec_detector_11_exit_volume_mask_setting;
MCNUM number_of_activations = mccspec_detector_11_exit_volume_number_of_activations;
}   /* End of spec_detector_11_exit_volume=Union_box() SETTING parameter declarations. */
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex
  /* Label for restoring  neutron */
  mcabsorbCompspec_detector_11_exit_volume:
  if (RESTORE) /* restore if needed */
  { RESTORE_NEUTRON(579,
      mcnlx,
      mcnly,
      mcnlz,
      mcnlvx,
      mcnlvy,
      mcnlvz,
      mcnlt,
      mcnlsx,
      mcnlsy,
      mcnlsz,
      mcnlp); }
#undef mcabsorbComp
#undef p
#undef sz
#undef sy
#undef sx
#undef t
#undef vz
#undef vy
#undef vx
#undef z
#undef y
#undef x
  mcDEBUG_STATE(
mcnlx,
mcnly,
mcnlz,
mcnlvx,
mcnlvy,
mcnlvz,
mcnlt,
mcnlsx,
mcnlsy,
mcnlsz,
mcnlp)

  /* TRACE Component channel_12_cave1_box1 [580] */
  mccoordschange(mcposrchannel_12_cave1_box1, mcrotrchannel_12_cave1_box1,
    &mcnlx,
    &mcnly,
    &mcnlz,
    &mcnlvx,
    &mcnlvy,
    &mcnlvz,
    &mcnlsx,
    &mcnlsy,
    &mcnlsz);
  /* define label inside component channel_12_cave1_box1 (without coords transformations) */
  mcJumpTrace_channel_12_cave1_box1:
  SIG_MESSAGE("channel_12_cave1_box1 (Trace)");
  mcDEBUG_COMP("channel_12_cave1_box1")
  mcDEBUG_STATE(
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp)
#define x mcnlx
#define y mcnly
#define z mcnlz
#define vx mcnlvx
#define vy mcnlvy
#define vz mcnlvz
#define t mcnlt
#define sx mcnlsx
#define sy mcnlsy
#define sz mcnlsz
#define p mcnlp

#define mcabsorbComp mcabsorbCompchannel_12_cave1_box1
  STORE_NEUTRON(580,
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp);
  mcScattered=0;
  mcRestore=0;
  mcNCounter[580]++;
  mcPCounter[580] += p;
  mcP2Counter[580] += p*p;
#define mccompcurname  channel_12_cave1_box1
#define mccompcurtype  Union_box
#define mccompcurindex 580
#define loop_index mccchannel_12_cave1_box1_loop_index
#define this_box_volume mccchannel_12_cave1_box1_this_box_volume
#define global_geometry_element mccchannel_12_cave1_box1_global_geometry_element
#define this_box_storage mccchannel_12_cave1_box1_this_box_storage
{   /* Declarations of channel_12_cave1_box1=Union_box() SETTING parameters. */
char* material_string = mccchannel_12_cave1_box1_material_string;
MCNUM priority = mccchannel_12_cave1_box1_priority;
MCNUM xwidth = mccchannel_12_cave1_box1_xwidth;
MCNUM yheight = mccchannel_12_cave1_box1_yheight;
MCNUM zdepth = mccchannel_12_cave1_box1_zdepth;
MCNUM xwidth2 = mccchannel_12_cave1_box1_xwidth2;
MCNUM yheight2 = mccchannel_12_cave1_box1_yheight2;
MCNUM visualize = mccchannel_12_cave1_box1_visualize;
int target_index = mccchannel_12_cave1_box1_target_index;
MCNUM target_x = mccchannel_12_cave1_box1_target_x;
MCNUM target_y = mccchannel_12_cave1_box1_target_y;
MCNUM target_z = mccchannel_12_cave1_box1_target_z;
MCNUM focus_aw = mccchannel_12_cave1_box1_focus_aw;
MCNUM focus_ah = mccchannel_12_cave1_box1_focus_ah;
MCNUM focus_xw = mccchannel_12_cave1_box1_focus_xw;
MCNUM focus_xh = mccchannel_12_cave1_box1_focus_xh;
MCNUM focus_r = mccchannel_12_cave1_box1_focus_r;
MCNUM p_interact = mccchannel_12_cave1_box1_p_interact;
char* mask_string = mccchannel_12_cave1_box1_mask_string;
char* mask_setting = mccchannel_12_cave1_box1_mask_setting;
MCNUM number_of_activations = mccchannel_12_cave1_box1_number_of_activations;
}   /* End of channel_12_cave1_box1=Union_box() SETTING parameter declarations. */
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex
  /* Label for restoring  neutron */
  mcabsorbCompchannel_12_cave1_box1:
  if (RESTORE) /* restore if needed */
  { RESTORE_NEUTRON(580,
      mcnlx,
      mcnly,
      mcnlz,
      mcnlvx,
      mcnlvy,
      mcnlvz,
      mcnlt,
      mcnlsx,
      mcnlsy,
      mcnlsz,
      mcnlp); }
#undef mcabsorbComp
#undef p
#undef sz
#undef sy
#undef sx
#undef t
#undef vz
#undef vy
#undef vx
#undef z
#undef y
#undef x
  mcDEBUG_STATE(
mcnlx,
mcnly,
mcnlz,
mcnlvx,
mcnlvy,
mcnlvz,
mcnlt,
mcnlsx,
mcnlsy,
mcnlsz,
mcnlp)

  /* TRACE Component channel_12_cave1_box2 [581] */
  mccoordschange(mcposrchannel_12_cave1_box2, mcrotrchannel_12_cave1_box2,
    &mcnlx,
    &mcnly,
    &mcnlz,
    &mcnlvx,
    &mcnlvy,
    &mcnlvz,
    &mcnlsx,
    &mcnlsy,
    &mcnlsz);
  /* define label inside component channel_12_cave1_box2 (without coords transformations) */
  mcJumpTrace_channel_12_cave1_box2:
  SIG_MESSAGE("channel_12_cave1_box2 (Trace)");
  mcDEBUG_COMP("channel_12_cave1_box2")
  mcDEBUG_STATE(
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp)
#define x mcnlx
#define y mcnly
#define z mcnlz
#define vx mcnlvx
#define vy mcnlvy
#define vz mcnlvz
#define t mcnlt
#define sx mcnlsx
#define sy mcnlsy
#define sz mcnlsz
#define p mcnlp

#define mcabsorbComp mcabsorbCompchannel_12_cave1_box2
  STORE_NEUTRON(581,
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp);
  mcScattered=0;
  mcRestore=0;
  mcNCounter[581]++;
  mcPCounter[581] += p;
  mcP2Counter[581] += p*p;
#define mccompcurname  channel_12_cave1_box2
#define mccompcurtype  Union_box
#define mccompcurindex 581
#define loop_index mccchannel_12_cave1_box2_loop_index
#define this_box_volume mccchannel_12_cave1_box2_this_box_volume
#define global_geometry_element mccchannel_12_cave1_box2_global_geometry_element
#define this_box_storage mccchannel_12_cave1_box2_this_box_storage
{   /* Declarations of channel_12_cave1_box2=Union_box() SETTING parameters. */
char* material_string = mccchannel_12_cave1_box2_material_string;
MCNUM priority = mccchannel_12_cave1_box2_priority;
MCNUM xwidth = mccchannel_12_cave1_box2_xwidth;
MCNUM yheight = mccchannel_12_cave1_box2_yheight;
MCNUM zdepth = mccchannel_12_cave1_box2_zdepth;
MCNUM xwidth2 = mccchannel_12_cave1_box2_xwidth2;
MCNUM yheight2 = mccchannel_12_cave1_box2_yheight2;
MCNUM visualize = mccchannel_12_cave1_box2_visualize;
int target_index = mccchannel_12_cave1_box2_target_index;
MCNUM target_x = mccchannel_12_cave1_box2_target_x;
MCNUM target_y = mccchannel_12_cave1_box2_target_y;
MCNUM target_z = mccchannel_12_cave1_box2_target_z;
MCNUM focus_aw = mccchannel_12_cave1_box2_focus_aw;
MCNUM focus_ah = mccchannel_12_cave1_box2_focus_ah;
MCNUM focus_xw = mccchannel_12_cave1_box2_focus_xw;
MCNUM focus_xh = mccchannel_12_cave1_box2_focus_xh;
MCNUM focus_r = mccchannel_12_cave1_box2_focus_r;
MCNUM p_interact = mccchannel_12_cave1_box2_p_interact;
char* mask_string = mccchannel_12_cave1_box2_mask_string;
char* mask_setting = mccchannel_12_cave1_box2_mask_setting;
MCNUM number_of_activations = mccchannel_12_cave1_box2_number_of_activations;
}   /* End of channel_12_cave1_box2=Union_box() SETTING parameter declarations. */
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex
  /* Label for restoring  neutron */
  mcabsorbCompchannel_12_cave1_box2:
  if (RESTORE) /* restore if needed */
  { RESTORE_NEUTRON(581,
      mcnlx,
      mcnly,
      mcnlz,
      mcnlvx,
      mcnlvy,
      mcnlvz,
      mcnlt,
      mcnlsx,
      mcnlsy,
      mcnlsz,
      mcnlp); }
#undef mcabsorbComp
#undef p
#undef sz
#undef sy
#undef sx
#undef t
#undef vz
#undef vy
#undef vx
#undef z
#undef y
#undef x
  mcDEBUG_STATE(
mcnlx,
mcnly,
mcnlz,
mcnlvx,
mcnlvy,
mcnlvz,
mcnlt,
mcnlsx,
mcnlsy,
mcnlsz,
mcnlp)

  /* TRACE Component channel_12_cave1_box3 [582] */
  mccoordschange(mcposrchannel_12_cave1_box3, mcrotrchannel_12_cave1_box3,
    &mcnlx,
    &mcnly,
    &mcnlz,
    &mcnlvx,
    &mcnlvy,
    &mcnlvz,
    &mcnlsx,
    &mcnlsy,
    &mcnlsz);
  /* define label inside component channel_12_cave1_box3 (without coords transformations) */
  mcJumpTrace_channel_12_cave1_box3:
  SIG_MESSAGE("channel_12_cave1_box3 (Trace)");
  mcDEBUG_COMP("channel_12_cave1_box3")
  mcDEBUG_STATE(
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp)
#define x mcnlx
#define y mcnly
#define z mcnlz
#define vx mcnlvx
#define vy mcnlvy
#define vz mcnlvz
#define t mcnlt
#define sx mcnlsx
#define sy mcnlsy
#define sz mcnlsz
#define p mcnlp

#define mcabsorbComp mcabsorbCompchannel_12_cave1_box3
  STORE_NEUTRON(582,
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp);
  mcScattered=0;
  mcRestore=0;
  mcNCounter[582]++;
  mcPCounter[582] += p;
  mcP2Counter[582] += p*p;
#define mccompcurname  channel_12_cave1_box3
#define mccompcurtype  Union_box
#define mccompcurindex 582
#define loop_index mccchannel_12_cave1_box3_loop_index
#define this_box_volume mccchannel_12_cave1_box3_this_box_volume
#define global_geometry_element mccchannel_12_cave1_box3_global_geometry_element
#define this_box_storage mccchannel_12_cave1_box3_this_box_storage
{   /* Declarations of channel_12_cave1_box3=Union_box() SETTING parameters. */
char* material_string = mccchannel_12_cave1_box3_material_string;
MCNUM priority = mccchannel_12_cave1_box3_priority;
MCNUM xwidth = mccchannel_12_cave1_box3_xwidth;
MCNUM yheight = mccchannel_12_cave1_box3_yheight;
MCNUM zdepth = mccchannel_12_cave1_box3_zdepth;
MCNUM xwidth2 = mccchannel_12_cave1_box3_xwidth2;
MCNUM yheight2 = mccchannel_12_cave1_box3_yheight2;
MCNUM visualize = mccchannel_12_cave1_box3_visualize;
int target_index = mccchannel_12_cave1_box3_target_index;
MCNUM target_x = mccchannel_12_cave1_box3_target_x;
MCNUM target_y = mccchannel_12_cave1_box3_target_y;
MCNUM target_z = mccchannel_12_cave1_box3_target_z;
MCNUM focus_aw = mccchannel_12_cave1_box3_focus_aw;
MCNUM focus_ah = mccchannel_12_cave1_box3_focus_ah;
MCNUM focus_xw = mccchannel_12_cave1_box3_focus_xw;
MCNUM focus_xh = mccchannel_12_cave1_box3_focus_xh;
MCNUM focus_r = mccchannel_12_cave1_box3_focus_r;
MCNUM p_interact = mccchannel_12_cave1_box3_p_interact;
char* mask_string = mccchannel_12_cave1_box3_mask_string;
char* mask_setting = mccchannel_12_cave1_box3_mask_setting;
MCNUM number_of_activations = mccchannel_12_cave1_box3_number_of_activations;
}   /* End of channel_12_cave1_box3=Union_box() SETTING parameter declarations. */
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex
  /* Label for restoring  neutron */
  mcabsorbCompchannel_12_cave1_box3:
  if (RESTORE) /* restore if needed */
  { RESTORE_NEUTRON(582,
      mcnlx,
      mcnly,
      mcnlz,
      mcnlvx,
      mcnlvy,
      mcnlvz,
      mcnlt,
      mcnlsx,
      mcnlsy,
      mcnlsz,
      mcnlp); }
#undef mcabsorbComp
#undef p
#undef sz
#undef sy
#undef sx
#undef t
#undef vz
#undef vy
#undef vx
#undef z
#undef y
#undef x
  mcDEBUG_STATE(
mcnlx,
mcnly,
mcnlz,
mcnlvx,
mcnlvy,
mcnlvz,
mcnlt,
mcnlsx,
mcnlsy,
mcnlsz,
mcnlp)

  /* TRACE Component channel_12_cave1_cyl1 [583] */
  mccoordschange(mcposrchannel_12_cave1_cyl1, mcrotrchannel_12_cave1_cyl1,
    &mcnlx,
    &mcnly,
    &mcnlz,
    &mcnlvx,
    &mcnlvy,
    &mcnlvz,
    &mcnlsx,
    &mcnlsy,
    &mcnlsz);
  /* define label inside component channel_12_cave1_cyl1 (without coords transformations) */
  mcJumpTrace_channel_12_cave1_cyl1:
  SIG_MESSAGE("channel_12_cave1_cyl1 (Trace)");
  mcDEBUG_COMP("channel_12_cave1_cyl1")
  mcDEBUG_STATE(
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp)
#define x mcnlx
#define y mcnly
#define z mcnlz
#define vx mcnlvx
#define vy mcnlvy
#define vz mcnlvz
#define t mcnlt
#define sx mcnlsx
#define sy mcnlsy
#define sz mcnlsz
#define p mcnlp

#define mcabsorbComp mcabsorbCompchannel_12_cave1_cyl1
  STORE_NEUTRON(583,
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp);
  mcScattered=0;
  mcRestore=0;
  mcNCounter[583]++;
  mcPCounter[583] += p;
  mcP2Counter[583] += p*p;
#define mccompcurname  channel_12_cave1_cyl1
#define mccompcurtype  Union_cylinder
#define mccompcurindex 583
#define loop_index mccchannel_12_cave1_cyl1_loop_index
#define this_cylinder_volume mccchannel_12_cave1_cyl1_this_cylinder_volume
#define global_geometry_element mccchannel_12_cave1_cyl1_global_geometry_element
#define this_cylinder_storage mccchannel_12_cave1_cyl1_this_cylinder_storage
{   /* Declarations of channel_12_cave1_cyl1=Union_cylinder() SETTING parameters. */
char* material_string = mccchannel_12_cave1_cyl1_material_string;
MCNUM priority = mccchannel_12_cave1_cyl1_priority;
MCNUM radius = mccchannel_12_cave1_cyl1_radius;
MCNUM yheight = mccchannel_12_cave1_cyl1_yheight;
MCNUM visualize = mccchannel_12_cave1_cyl1_visualize;
int target_index = mccchannel_12_cave1_cyl1_target_index;
MCNUM target_x = mccchannel_12_cave1_cyl1_target_x;
MCNUM target_y = mccchannel_12_cave1_cyl1_target_y;
MCNUM target_z = mccchannel_12_cave1_cyl1_target_z;
MCNUM focus_aw = mccchannel_12_cave1_cyl1_focus_aw;
MCNUM focus_ah = mccchannel_12_cave1_cyl1_focus_ah;
MCNUM focus_xw = mccchannel_12_cave1_cyl1_focus_xw;
MCNUM focus_xh = mccchannel_12_cave1_cyl1_focus_xh;
MCNUM focus_r = mccchannel_12_cave1_cyl1_focus_r;
MCNUM p_interact = mccchannel_12_cave1_cyl1_p_interact;
char* mask_string = mccchannel_12_cave1_cyl1_mask_string;
char* mask_setting = mccchannel_12_cave1_cyl1_mask_setting;
MCNUM number_of_activations = mccchannel_12_cave1_cyl1_number_of_activations;
#line 345 "Union_cylinder.comp"
{
dummy = 1;
}
#line 422350 "MACS_sample_kidney_box.c"
}   /* End of channel_12_cave1_cyl1=Union_cylinder() SETTING parameter declarations. */
#undef this_cylinder_storage
#undef global_geometry_element
#undef this_cylinder_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex
  /* Label for restoring  neutron */
  mcabsorbCompchannel_12_cave1_cyl1:
  if (RESTORE) /* restore if needed */
  { RESTORE_NEUTRON(583,
      mcnlx,
      mcnly,
      mcnlz,
      mcnlvx,
      mcnlvy,
      mcnlvz,
      mcnlt,
      mcnlsx,
      mcnlsy,
      mcnlsz,
      mcnlp); }
#undef mcabsorbComp
#undef p
#undef sz
#undef sy
#undef sx
#undef t
#undef vz
#undef vy
#undef vx
#undef z
#undef y
#undef x
  mcDEBUG_STATE(
mcnlx,
mcnly,
mcnlz,
mcnlvx,
mcnlvy,
mcnlvz,
mcnlt,
mcnlsx,
mcnlsy,
mcnlsz,
mcnlp)

  /* TRACE Component channel_12_analyzer_1_center [584] */
  mccoordschange(mcposrchannel_12_analyzer_1_center, mcrotrchannel_12_analyzer_1_center,
    &mcnlx,
    &mcnly,
    &mcnlz,
    &mcnlvx,
    &mcnlvy,
    &mcnlvz,
    &mcnlsx,
    &mcnlsy,
    &mcnlsz);
  /* define label inside component channel_12_analyzer_1_center (without coords transformations) */
  mcJumpTrace_channel_12_analyzer_1_center:
  SIG_MESSAGE("channel_12_analyzer_1_center (Trace)");
  mcDEBUG_COMP("channel_12_analyzer_1_center")
  mcDEBUG_STATE(
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp)
#define x mcnlx
#define y mcnly
#define z mcnlz
#define vx mcnlvx
#define vy mcnlvy
#define vz mcnlvz
#define t mcnlt
#define sx mcnlsx
#define sy mcnlsy
#define sz mcnlsz
#define p mcnlp

#define mcabsorbComp mcabsorbCompchannel_12_analyzer_1_center
  STORE_NEUTRON(584,
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp);
  mcScattered=0;
  mcRestore=0;
  mcNCounter[584]++;
  mcPCounter[584] += p;
  mcP2Counter[584] += p*p;
#define mccompcurname  channel_12_analyzer_1_center
#define mccompcurtype  Arm
#define mccompcurindex 584
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex
  /* Label for restoring  neutron */
  mcabsorbCompchannel_12_analyzer_1_center:
  if (RESTORE) /* restore if needed */
  { RESTORE_NEUTRON(584,
      mcnlx,
      mcnly,
      mcnlz,
      mcnlvx,
      mcnlvy,
      mcnlvz,
      mcnlt,
      mcnlsx,
      mcnlsy,
      mcnlsz,
      mcnlp); }
#undef mcabsorbComp
#undef p
#undef sz
#undef sy
#undef sx
#undef t
#undef vz
#undef vy
#undef vx
#undef z
#undef y
#undef x
  mcDEBUG_STATE(
mcnlx,
mcnly,
mcnlz,
mcnlvx,
mcnlvy,
mcnlvz,
mcnlt,
mcnlsx,
mcnlsy,
mcnlsz,
mcnlp)

  /* TRACE Component channel_12_analyzer_1_rotated [585] */
  mccoordschange(mcposrchannel_12_analyzer_1_rotated, mcrotrchannel_12_analyzer_1_rotated,
    &mcnlx,
    &mcnly,
    &mcnlz,
    &mcnlvx,
    &mcnlvy,
    &mcnlvz,
    &mcnlsx,
    &mcnlsy,
    &mcnlsz);
  /* define label inside component channel_12_analyzer_1_rotated (without coords transformations) */
  mcJumpTrace_channel_12_analyzer_1_rotated:
  SIG_MESSAGE("channel_12_analyzer_1_rotated (Trace)");
  mcDEBUG_COMP("channel_12_analyzer_1_rotated")
  mcDEBUG_STATE(
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp)
#define x mcnlx
#define y mcnly
#define z mcnlz
#define vx mcnlvx
#define vy mcnlvy
#define vz mcnlvz
#define t mcnlt
#define sx mcnlsx
#define sy mcnlsy
#define sz mcnlsz
#define p mcnlp

#define mcabsorbComp mcabsorbCompchannel_12_analyzer_1_rotated
  STORE_NEUTRON(585,
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp);
  mcScattered=0;
  mcRestore=0;
  mcNCounter[585]++;
  mcPCounter[585] += p;
  mcP2Counter[585] += p*p;
#define mccompcurname  channel_12_analyzer_1_rotated
#define mccompcurtype  Arm
#define mccompcurindex 585
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex
  /* Label for restoring  neutron */
  mcabsorbCompchannel_12_analyzer_1_rotated:
  if (RESTORE) /* restore if needed */
  { RESTORE_NEUTRON(585,
      mcnlx,
      mcnly,
      mcnlz,
      mcnlvx,
      mcnlvy,
      mcnlvz,
      mcnlt,
      mcnlsx,
      mcnlsy,
      mcnlsz,
      mcnlp); }
#undef mcabsorbComp
#undef p
#undef sz
#undef sy
#undef sx
#undef t
#undef vz
#undef vy
#undef vx
#undef z
#undef y
#undef x
  mcDEBUG_STATE(
mcnlx,
mcnly,
mcnlz,
mcnlvx,
mcnlvy,
mcnlvz,
mcnlt,
mcnlsx,
mcnlsy,
mcnlsz,
mcnlp)

  /* TRACE Component channel_12_analyzer_1_array_crystal_array_0 [586] */
  mccoordschange(mcposrchannel_12_analyzer_1_array_crystal_array_0, mcrotrchannel_12_analyzer_1_array_crystal_array_0,
    &mcnlx,
    &mcnly,
    &mcnlz,
    &mcnlvx,
    &mcnlvy,
    &mcnlvz,
    &mcnlsx,
    &mcnlsy,
    &mcnlsz);
  /* define label inside component channel_12_analyzer_1_array_crystal_array_0 (without coords transformations) */
  mcJumpTrace_channel_12_analyzer_1_array_crystal_array_0:
  SIG_MESSAGE("channel_12_analyzer_1_array_crystal_array_0 (Trace)");
  mcDEBUG_COMP("channel_12_analyzer_1_array_crystal_array_0")
  mcDEBUG_STATE(
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp)
#define x mcnlx
#define y mcnly
#define z mcnlz
#define vx mcnlvx
#define vy mcnlvy
#define vz mcnlvz
#define t mcnlt
#define sx mcnlsx
#define sy mcnlsy
#define sz mcnlsz
#define p mcnlp

#define mcabsorbComp mcabsorbCompchannel_12_analyzer_1_array_crystal_array_0
  STORE_NEUTRON(586,
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp);
  mcScattered=0;
  mcRestore=0;
  mcNCounter[586]++;
  mcPCounter[586] += p;
  mcP2Counter[586] += p*p;
#define mccompcurname  channel_12_analyzer_1_array_crystal_array_0
#define mccompcurtype  Union_box
#define mccompcurindex 586
#define loop_index mccchannel_12_analyzer_1_array_crystal_array_0_loop_index
#define this_box_volume mccchannel_12_analyzer_1_array_crystal_array_0_this_box_volume
#define global_geometry_element mccchannel_12_analyzer_1_array_crystal_array_0_global_geometry_element
#define this_box_storage mccchannel_12_analyzer_1_array_crystal_array_0_this_box_storage
{   /* Declarations of channel_12_analyzer_1_array_crystal_array_0=Union_box() SETTING parameters. */
char* material_string = mccchannel_12_analyzer_1_array_crystal_array_0_material_string;
MCNUM priority = mccchannel_12_analyzer_1_array_crystal_array_0_priority;
MCNUM xwidth = mccchannel_12_analyzer_1_array_crystal_array_0_xwidth;
MCNUM yheight = mccchannel_12_analyzer_1_array_crystal_array_0_yheight;
MCNUM zdepth = mccchannel_12_analyzer_1_array_crystal_array_0_zdepth;
MCNUM xwidth2 = mccchannel_12_analyzer_1_array_crystal_array_0_xwidth2;
MCNUM yheight2 = mccchannel_12_analyzer_1_array_crystal_array_0_yheight2;
MCNUM visualize = mccchannel_12_analyzer_1_array_crystal_array_0_visualize;
int target_index = mccchannel_12_analyzer_1_array_crystal_array_0_target_index;
MCNUM target_x = mccchannel_12_analyzer_1_array_crystal_array_0_target_x;
MCNUM target_y = mccchannel_12_analyzer_1_array_crystal_array_0_target_y;
MCNUM target_z = mccchannel_12_analyzer_1_array_crystal_array_0_target_z;
MCNUM focus_aw = mccchannel_12_analyzer_1_array_crystal_array_0_focus_aw;
MCNUM focus_ah = mccchannel_12_analyzer_1_array_crystal_array_0_focus_ah;
MCNUM focus_xw = mccchannel_12_analyzer_1_array_crystal_array_0_focus_xw;
MCNUM focus_xh = mccchannel_12_analyzer_1_array_crystal_array_0_focus_xh;
MCNUM focus_r = mccchannel_12_analyzer_1_array_crystal_array_0_focus_r;
MCNUM p_interact = mccchannel_12_analyzer_1_array_crystal_array_0_p_interact;
char* mask_string = mccchannel_12_analyzer_1_array_crystal_array_0_mask_string;
char* mask_setting = mccchannel_12_analyzer_1_array_crystal_array_0_mask_setting;
MCNUM number_of_activations = mccchannel_12_analyzer_1_array_crystal_array_0_number_of_activations;
}   /* End of channel_12_analyzer_1_array_crystal_array_0=Union_box() SETTING parameter declarations. */
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex
  /* Label for restoring  neutron */
  mcabsorbCompchannel_12_analyzer_1_array_crystal_array_0:
  if (RESTORE) /* restore if needed */
  { RESTORE_NEUTRON(586,
      mcnlx,
      mcnly,
      mcnlz,
      mcnlvx,
      mcnlvy,
      mcnlvz,
      mcnlt,
      mcnlsx,
      mcnlsy,
      mcnlsz,
      mcnlp); }
#undef mcabsorbComp
#undef p
#undef sz
#undef sy
#undef sx
#undef t
#undef vz
#undef vy
#undef vx
#undef z
#undef y
#undef x
  mcDEBUG_STATE(
mcnlx,
mcnly,
mcnlz,
mcnlvx,
mcnlvy,
mcnlvz,
mcnlt,
mcnlsx,
mcnlsy,
mcnlsz,
mcnlp)

  /* TRACE Component channel_12_analyzer_1_array_crystal_array_1 [587] */
  mccoordschange(mcposrchannel_12_analyzer_1_array_crystal_array_1, mcrotrchannel_12_analyzer_1_array_crystal_array_1,
    &mcnlx,
    &mcnly,
    &mcnlz,
    &mcnlvx,
    &mcnlvy,
    &mcnlvz,
    &mcnlsx,
    &mcnlsy,
    &mcnlsz);
  /* define label inside component channel_12_analyzer_1_array_crystal_array_1 (without coords transformations) */
  mcJumpTrace_channel_12_analyzer_1_array_crystal_array_1:
  SIG_MESSAGE("channel_12_analyzer_1_array_crystal_array_1 (Trace)");
  mcDEBUG_COMP("channel_12_analyzer_1_array_crystal_array_1")
  mcDEBUG_STATE(
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp)
#define x mcnlx
#define y mcnly
#define z mcnlz
#define vx mcnlvx
#define vy mcnlvy
#define vz mcnlvz
#define t mcnlt
#define sx mcnlsx
#define sy mcnlsy
#define sz mcnlsz
#define p mcnlp

#define mcabsorbComp mcabsorbCompchannel_12_analyzer_1_array_crystal_array_1
  STORE_NEUTRON(587,
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp);
  mcScattered=0;
  mcRestore=0;
  mcNCounter[587]++;
  mcPCounter[587] += p;
  mcP2Counter[587] += p*p;
#define mccompcurname  channel_12_analyzer_1_array_crystal_array_1
#define mccompcurtype  Union_box
#define mccompcurindex 587
#define loop_index mccchannel_12_analyzer_1_array_crystal_array_1_loop_index
#define this_box_volume mccchannel_12_analyzer_1_array_crystal_array_1_this_box_volume
#define global_geometry_element mccchannel_12_analyzer_1_array_crystal_array_1_global_geometry_element
#define this_box_storage mccchannel_12_analyzer_1_array_crystal_array_1_this_box_storage
{   /* Declarations of channel_12_analyzer_1_array_crystal_array_1=Union_box() SETTING parameters. */
char* material_string = mccchannel_12_analyzer_1_array_crystal_array_1_material_string;
MCNUM priority = mccchannel_12_analyzer_1_array_crystal_array_1_priority;
MCNUM xwidth = mccchannel_12_analyzer_1_array_crystal_array_1_xwidth;
MCNUM yheight = mccchannel_12_analyzer_1_array_crystal_array_1_yheight;
MCNUM zdepth = mccchannel_12_analyzer_1_array_crystal_array_1_zdepth;
MCNUM xwidth2 = mccchannel_12_analyzer_1_array_crystal_array_1_xwidth2;
MCNUM yheight2 = mccchannel_12_analyzer_1_array_crystal_array_1_yheight2;
MCNUM visualize = mccchannel_12_analyzer_1_array_crystal_array_1_visualize;
int target_index = mccchannel_12_analyzer_1_array_crystal_array_1_target_index;
MCNUM target_x = mccchannel_12_analyzer_1_array_crystal_array_1_target_x;
MCNUM target_y = mccchannel_12_analyzer_1_array_crystal_array_1_target_y;
MCNUM target_z = mccchannel_12_analyzer_1_array_crystal_array_1_target_z;
MCNUM focus_aw = mccchannel_12_analyzer_1_array_crystal_array_1_focus_aw;
MCNUM focus_ah = mccchannel_12_analyzer_1_array_crystal_array_1_focus_ah;
MCNUM focus_xw = mccchannel_12_analyzer_1_array_crystal_array_1_focus_xw;
MCNUM focus_xh = mccchannel_12_analyzer_1_array_crystal_array_1_focus_xh;
MCNUM focus_r = mccchannel_12_analyzer_1_array_crystal_array_1_focus_r;
MCNUM p_interact = mccchannel_12_analyzer_1_array_crystal_array_1_p_interact;
char* mask_string = mccchannel_12_analyzer_1_array_crystal_array_1_mask_string;
char* mask_setting = mccchannel_12_analyzer_1_array_crystal_array_1_mask_setting;
MCNUM number_of_activations = mccchannel_12_analyzer_1_array_crystal_array_1_number_of_activations;
}   /* End of channel_12_analyzer_1_array_crystal_array_1=Union_box() SETTING parameter declarations. */
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex
  /* Label for restoring  neutron */
  mcabsorbCompchannel_12_analyzer_1_array_crystal_array_1:
  if (RESTORE) /* restore if needed */
  { RESTORE_NEUTRON(587,
      mcnlx,
      mcnly,
      mcnlz,
      mcnlvx,
      mcnlvy,
      mcnlvz,
      mcnlt,
      mcnlsx,
      mcnlsy,
      mcnlsz,
      mcnlp); }
#undef mcabsorbComp
#undef p
#undef sz
#undef sy
#undef sx
#undef t
#undef vz
#undef vy
#undef vx
#undef z
#undef y
#undef x
  mcDEBUG_STATE(
mcnlx,
mcnly,
mcnlz,
mcnlvx,
mcnlvy,
mcnlvz,
mcnlt,
mcnlsx,
mcnlsy,
mcnlsz,
mcnlp)

  /* TRACE Component channel_12_analyzer_1_array_crystal_array_2 [588] */
  mccoordschange(mcposrchannel_12_analyzer_1_array_crystal_array_2, mcrotrchannel_12_analyzer_1_array_crystal_array_2,
    &mcnlx,
    &mcnly,
    &mcnlz,
    &mcnlvx,
    &mcnlvy,
    &mcnlvz,
    &mcnlsx,
    &mcnlsy,
    &mcnlsz);
  /* define label inside component channel_12_analyzer_1_array_crystal_array_2 (without coords transformations) */
  mcJumpTrace_channel_12_analyzer_1_array_crystal_array_2:
  SIG_MESSAGE("channel_12_analyzer_1_array_crystal_array_2 (Trace)");
  mcDEBUG_COMP("channel_12_analyzer_1_array_crystal_array_2")
  mcDEBUG_STATE(
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp)
#define x mcnlx
#define y mcnly
#define z mcnlz
#define vx mcnlvx
#define vy mcnlvy
#define vz mcnlvz
#define t mcnlt
#define sx mcnlsx
#define sy mcnlsy
#define sz mcnlsz
#define p mcnlp

#define mcabsorbComp mcabsorbCompchannel_12_analyzer_1_array_crystal_array_2
  STORE_NEUTRON(588,
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp);
  mcScattered=0;
  mcRestore=0;
  mcNCounter[588]++;
  mcPCounter[588] += p;
  mcP2Counter[588] += p*p;
#define mccompcurname  channel_12_analyzer_1_array_crystal_array_2
#define mccompcurtype  Union_box
#define mccompcurindex 588
#define loop_index mccchannel_12_analyzer_1_array_crystal_array_2_loop_index
#define this_box_volume mccchannel_12_analyzer_1_array_crystal_array_2_this_box_volume
#define global_geometry_element mccchannel_12_analyzer_1_array_crystal_array_2_global_geometry_element
#define this_box_storage mccchannel_12_analyzer_1_array_crystal_array_2_this_box_storage
{   /* Declarations of channel_12_analyzer_1_array_crystal_array_2=Union_box() SETTING parameters. */
char* material_string = mccchannel_12_analyzer_1_array_crystal_array_2_material_string;
MCNUM priority = mccchannel_12_analyzer_1_array_crystal_array_2_priority;
MCNUM xwidth = mccchannel_12_analyzer_1_array_crystal_array_2_xwidth;
MCNUM yheight = mccchannel_12_analyzer_1_array_crystal_array_2_yheight;
MCNUM zdepth = mccchannel_12_analyzer_1_array_crystal_array_2_zdepth;
MCNUM xwidth2 = mccchannel_12_analyzer_1_array_crystal_array_2_xwidth2;
MCNUM yheight2 = mccchannel_12_analyzer_1_array_crystal_array_2_yheight2;
MCNUM visualize = mccchannel_12_analyzer_1_array_crystal_array_2_visualize;
int target_index = mccchannel_12_analyzer_1_array_crystal_array_2_target_index;
MCNUM target_x = mccchannel_12_analyzer_1_array_crystal_array_2_target_x;
MCNUM target_y = mccchannel_12_analyzer_1_array_crystal_array_2_target_y;
MCNUM target_z = mccchannel_12_analyzer_1_array_crystal_array_2_target_z;
MCNUM focus_aw = mccchannel_12_analyzer_1_array_crystal_array_2_focus_aw;
MCNUM focus_ah = mccchannel_12_analyzer_1_array_crystal_array_2_focus_ah;
MCNUM focus_xw = mccchannel_12_analyzer_1_array_crystal_array_2_focus_xw;
MCNUM focus_xh = mccchannel_12_analyzer_1_array_crystal_array_2_focus_xh;
MCNUM focus_r = mccchannel_12_analyzer_1_array_crystal_array_2_focus_r;
MCNUM p_interact = mccchannel_12_analyzer_1_array_crystal_array_2_p_interact;
char* mask_string = mccchannel_12_analyzer_1_array_crystal_array_2_mask_string;
char* mask_setting = mccchannel_12_analyzer_1_array_crystal_array_2_mask_setting;
MCNUM number_of_activations = mccchannel_12_analyzer_1_array_crystal_array_2_number_of_activations;
}   /* End of channel_12_analyzer_1_array_crystal_array_2=Union_box() SETTING parameter declarations. */
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex
  /* Label for restoring  neutron */
  mcabsorbCompchannel_12_analyzer_1_array_crystal_array_2:
  if (RESTORE) /* restore if needed */
  { RESTORE_NEUTRON(588,
      mcnlx,
      mcnly,
      mcnlz,
      mcnlvx,
      mcnlvy,
      mcnlvz,
      mcnlt,
      mcnlsx,
      mcnlsy,
      mcnlsz,
      mcnlp); }
#undef mcabsorbComp
#undef p
#undef sz
#undef sy
#undef sx
#undef t
#undef vz
#undef vy
#undef vx
#undef z
#undef y
#undef x
  mcDEBUG_STATE(
mcnlx,
mcnly,
mcnlz,
mcnlvx,
mcnlvy,
mcnlvz,
mcnlt,
mcnlsx,
mcnlsy,
mcnlsz,
mcnlp)

  /* TRACE Component channel_12_analyzer_1_array_crystal_array_3 [589] */
  mccoordschange(mcposrchannel_12_analyzer_1_array_crystal_array_3, mcrotrchannel_12_analyzer_1_array_crystal_array_3,
    &mcnlx,
    &mcnly,
    &mcnlz,
    &mcnlvx,
    &mcnlvy,
    &mcnlvz,
    &mcnlsx,
    &mcnlsy,
    &mcnlsz);
  /* define label inside component channel_12_analyzer_1_array_crystal_array_3 (without coords transformations) */
  mcJumpTrace_channel_12_analyzer_1_array_crystal_array_3:
  SIG_MESSAGE("channel_12_analyzer_1_array_crystal_array_3 (Trace)");
  mcDEBUG_COMP("channel_12_analyzer_1_array_crystal_array_3")
  mcDEBUG_STATE(
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp)
#define x mcnlx
#define y mcnly
#define z mcnlz
#define vx mcnlvx
#define vy mcnlvy
#define vz mcnlvz
#define t mcnlt
#define sx mcnlsx
#define sy mcnlsy
#define sz mcnlsz
#define p mcnlp

#define mcabsorbComp mcabsorbCompchannel_12_analyzer_1_array_crystal_array_3
  STORE_NEUTRON(589,
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp);
  mcScattered=0;
  mcRestore=0;
  mcNCounter[589]++;
  mcPCounter[589] += p;
  mcP2Counter[589] += p*p;
#define mccompcurname  channel_12_analyzer_1_array_crystal_array_3
#define mccompcurtype  Union_box
#define mccompcurindex 589
#define loop_index mccchannel_12_analyzer_1_array_crystal_array_3_loop_index
#define this_box_volume mccchannel_12_analyzer_1_array_crystal_array_3_this_box_volume
#define global_geometry_element mccchannel_12_analyzer_1_array_crystal_array_3_global_geometry_element
#define this_box_storage mccchannel_12_analyzer_1_array_crystal_array_3_this_box_storage
{   /* Declarations of channel_12_analyzer_1_array_crystal_array_3=Union_box() SETTING parameters. */
char* material_string = mccchannel_12_analyzer_1_array_crystal_array_3_material_string;
MCNUM priority = mccchannel_12_analyzer_1_array_crystal_array_3_priority;
MCNUM xwidth = mccchannel_12_analyzer_1_array_crystal_array_3_xwidth;
MCNUM yheight = mccchannel_12_analyzer_1_array_crystal_array_3_yheight;
MCNUM zdepth = mccchannel_12_analyzer_1_array_crystal_array_3_zdepth;
MCNUM xwidth2 = mccchannel_12_analyzer_1_array_crystal_array_3_xwidth2;
MCNUM yheight2 = mccchannel_12_analyzer_1_array_crystal_array_3_yheight2;
MCNUM visualize = mccchannel_12_analyzer_1_array_crystal_array_3_visualize;
int target_index = mccchannel_12_analyzer_1_array_crystal_array_3_target_index;
MCNUM target_x = mccchannel_12_analyzer_1_array_crystal_array_3_target_x;
MCNUM target_y = mccchannel_12_analyzer_1_array_crystal_array_3_target_y;
MCNUM target_z = mccchannel_12_analyzer_1_array_crystal_array_3_target_z;
MCNUM focus_aw = mccchannel_12_analyzer_1_array_crystal_array_3_focus_aw;
MCNUM focus_ah = mccchannel_12_analyzer_1_array_crystal_array_3_focus_ah;
MCNUM focus_xw = mccchannel_12_analyzer_1_array_crystal_array_3_focus_xw;
MCNUM focus_xh = mccchannel_12_analyzer_1_array_crystal_array_3_focus_xh;
MCNUM focus_r = mccchannel_12_analyzer_1_array_crystal_array_3_focus_r;
MCNUM p_interact = mccchannel_12_analyzer_1_array_crystal_array_3_p_interact;
char* mask_string = mccchannel_12_analyzer_1_array_crystal_array_3_mask_string;
char* mask_setting = mccchannel_12_analyzer_1_array_crystal_array_3_mask_setting;
MCNUM number_of_activations = mccchannel_12_analyzer_1_array_crystal_array_3_number_of_activations;
}   /* End of channel_12_analyzer_1_array_crystal_array_3=Union_box() SETTING parameter declarations. */
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex
  /* Label for restoring  neutron */
  mcabsorbCompchannel_12_analyzer_1_array_crystal_array_3:
  if (RESTORE) /* restore if needed */
  { RESTORE_NEUTRON(589,
      mcnlx,
      mcnly,
      mcnlz,
      mcnlvx,
      mcnlvy,
      mcnlvz,
      mcnlt,
      mcnlsx,
      mcnlsy,
      mcnlsz,
      mcnlp); }
#undef mcabsorbComp
#undef p
#undef sz
#undef sy
#undef sx
#undef t
#undef vz
#undef vy
#undef vx
#undef z
#undef y
#undef x
  mcDEBUG_STATE(
mcnlx,
mcnly,
mcnlz,
mcnlvx,
mcnlvy,
mcnlvz,
mcnlt,
mcnlsx,
mcnlsy,
mcnlsz,
mcnlp)

  /* TRACE Component channel_12_analyzer_1_array_crystal_array_4 [590] */
  mccoordschange(mcposrchannel_12_analyzer_1_array_crystal_array_4, mcrotrchannel_12_analyzer_1_array_crystal_array_4,
    &mcnlx,
    &mcnly,
    &mcnlz,
    &mcnlvx,
    &mcnlvy,
    &mcnlvz,
    &mcnlsx,
    &mcnlsy,
    &mcnlsz);
  /* define label inside component channel_12_analyzer_1_array_crystal_array_4 (without coords transformations) */
  mcJumpTrace_channel_12_analyzer_1_array_crystal_array_4:
  SIG_MESSAGE("channel_12_analyzer_1_array_crystal_array_4 (Trace)");
  mcDEBUG_COMP("channel_12_analyzer_1_array_crystal_array_4")
  mcDEBUG_STATE(
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp)
#define x mcnlx
#define y mcnly
#define z mcnlz
#define vx mcnlvx
#define vy mcnlvy
#define vz mcnlvz
#define t mcnlt
#define sx mcnlsx
#define sy mcnlsy
#define sz mcnlsz
#define p mcnlp

#define mcabsorbComp mcabsorbCompchannel_12_analyzer_1_array_crystal_array_4
  STORE_NEUTRON(590,
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp);
  mcScattered=0;
  mcRestore=0;
  mcNCounter[590]++;
  mcPCounter[590] += p;
  mcP2Counter[590] += p*p;
#define mccompcurname  channel_12_analyzer_1_array_crystal_array_4
#define mccompcurtype  Union_box
#define mccompcurindex 590
#define loop_index mccchannel_12_analyzer_1_array_crystal_array_4_loop_index
#define this_box_volume mccchannel_12_analyzer_1_array_crystal_array_4_this_box_volume
#define global_geometry_element mccchannel_12_analyzer_1_array_crystal_array_4_global_geometry_element
#define this_box_storage mccchannel_12_analyzer_1_array_crystal_array_4_this_box_storage
{   /* Declarations of channel_12_analyzer_1_array_crystal_array_4=Union_box() SETTING parameters. */
char* material_string = mccchannel_12_analyzer_1_array_crystal_array_4_material_string;
MCNUM priority = mccchannel_12_analyzer_1_array_crystal_array_4_priority;
MCNUM xwidth = mccchannel_12_analyzer_1_array_crystal_array_4_xwidth;
MCNUM yheight = mccchannel_12_analyzer_1_array_crystal_array_4_yheight;
MCNUM zdepth = mccchannel_12_analyzer_1_array_crystal_array_4_zdepth;
MCNUM xwidth2 = mccchannel_12_analyzer_1_array_crystal_array_4_xwidth2;
MCNUM yheight2 = mccchannel_12_analyzer_1_array_crystal_array_4_yheight2;
MCNUM visualize = mccchannel_12_analyzer_1_array_crystal_array_4_visualize;
int target_index = mccchannel_12_analyzer_1_array_crystal_array_4_target_index;
MCNUM target_x = mccchannel_12_analyzer_1_array_crystal_array_4_target_x;
MCNUM target_y = mccchannel_12_analyzer_1_array_crystal_array_4_target_y;
MCNUM target_z = mccchannel_12_analyzer_1_array_crystal_array_4_target_z;
MCNUM focus_aw = mccchannel_12_analyzer_1_array_crystal_array_4_focus_aw;
MCNUM focus_ah = mccchannel_12_analyzer_1_array_crystal_array_4_focus_ah;
MCNUM focus_xw = mccchannel_12_analyzer_1_array_crystal_array_4_focus_xw;
MCNUM focus_xh = mccchannel_12_analyzer_1_array_crystal_array_4_focus_xh;
MCNUM focus_r = mccchannel_12_analyzer_1_array_crystal_array_4_focus_r;
MCNUM p_interact = mccchannel_12_analyzer_1_array_crystal_array_4_p_interact;
char* mask_string = mccchannel_12_analyzer_1_array_crystal_array_4_mask_string;
char* mask_setting = mccchannel_12_analyzer_1_array_crystal_array_4_mask_setting;
MCNUM number_of_activations = mccchannel_12_analyzer_1_array_crystal_array_4_number_of_activations;
}   /* End of channel_12_analyzer_1_array_crystal_array_4=Union_box() SETTING parameter declarations. */
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex
  /* Label for restoring  neutron */
  mcabsorbCompchannel_12_analyzer_1_array_crystal_array_4:
  if (RESTORE) /* restore if needed */
  { RESTORE_NEUTRON(590,
      mcnlx,
      mcnly,
      mcnlz,
      mcnlvx,
      mcnlvy,
      mcnlvz,
      mcnlt,
      mcnlsx,
      mcnlsy,
      mcnlsz,
      mcnlp); }
#undef mcabsorbComp
#undef p
#undef sz
#undef sy
#undef sx
#undef t
#undef vz
#undef vy
#undef vx
#undef z
#undef y
#undef x
  mcDEBUG_STATE(
mcnlx,
mcnly,
mcnlz,
mcnlvx,
mcnlvy,
mcnlvz,
mcnlt,
mcnlsx,
mcnlsy,
mcnlsz,
mcnlp)

  /* TRACE Component channel_12_analyzer_1_array_crystal_array_5 [591] */
  mccoordschange(mcposrchannel_12_analyzer_1_array_crystal_array_5, mcrotrchannel_12_analyzer_1_array_crystal_array_5,
    &mcnlx,
    &mcnly,
    &mcnlz,
    &mcnlvx,
    &mcnlvy,
    &mcnlvz,
    &mcnlsx,
    &mcnlsy,
    &mcnlsz);
  /* define label inside component channel_12_analyzer_1_array_crystal_array_5 (without coords transformations) */
  mcJumpTrace_channel_12_analyzer_1_array_crystal_array_5:
  SIG_MESSAGE("channel_12_analyzer_1_array_crystal_array_5 (Trace)");
  mcDEBUG_COMP("channel_12_analyzer_1_array_crystal_array_5")
  mcDEBUG_STATE(
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp)
#define x mcnlx
#define y mcnly
#define z mcnlz
#define vx mcnlvx
#define vy mcnlvy
#define vz mcnlvz
#define t mcnlt
#define sx mcnlsx
#define sy mcnlsy
#define sz mcnlsz
#define p mcnlp

#define mcabsorbComp mcabsorbCompchannel_12_analyzer_1_array_crystal_array_5
  STORE_NEUTRON(591,
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp);
  mcScattered=0;
  mcRestore=0;
  mcNCounter[591]++;
  mcPCounter[591] += p;
  mcP2Counter[591] += p*p;
#define mccompcurname  channel_12_analyzer_1_array_crystal_array_5
#define mccompcurtype  Union_box
#define mccompcurindex 591
#define loop_index mccchannel_12_analyzer_1_array_crystal_array_5_loop_index
#define this_box_volume mccchannel_12_analyzer_1_array_crystal_array_5_this_box_volume
#define global_geometry_element mccchannel_12_analyzer_1_array_crystal_array_5_global_geometry_element
#define this_box_storage mccchannel_12_analyzer_1_array_crystal_array_5_this_box_storage
{   /* Declarations of channel_12_analyzer_1_array_crystal_array_5=Union_box() SETTING parameters. */
char* material_string = mccchannel_12_analyzer_1_array_crystal_array_5_material_string;
MCNUM priority = mccchannel_12_analyzer_1_array_crystal_array_5_priority;
MCNUM xwidth = mccchannel_12_analyzer_1_array_crystal_array_5_xwidth;
MCNUM yheight = mccchannel_12_analyzer_1_array_crystal_array_5_yheight;
MCNUM zdepth = mccchannel_12_analyzer_1_array_crystal_array_5_zdepth;
MCNUM xwidth2 = mccchannel_12_analyzer_1_array_crystal_array_5_xwidth2;
MCNUM yheight2 = mccchannel_12_analyzer_1_array_crystal_array_5_yheight2;
MCNUM visualize = mccchannel_12_analyzer_1_array_crystal_array_5_visualize;
int target_index = mccchannel_12_analyzer_1_array_crystal_array_5_target_index;
MCNUM target_x = mccchannel_12_analyzer_1_array_crystal_array_5_target_x;
MCNUM target_y = mccchannel_12_analyzer_1_array_crystal_array_5_target_y;
MCNUM target_z = mccchannel_12_analyzer_1_array_crystal_array_5_target_z;
MCNUM focus_aw = mccchannel_12_analyzer_1_array_crystal_array_5_focus_aw;
MCNUM focus_ah = mccchannel_12_analyzer_1_array_crystal_array_5_focus_ah;
MCNUM focus_xw = mccchannel_12_analyzer_1_array_crystal_array_5_focus_xw;
MCNUM focus_xh = mccchannel_12_analyzer_1_array_crystal_array_5_focus_xh;
MCNUM focus_r = mccchannel_12_analyzer_1_array_crystal_array_5_focus_r;
MCNUM p_interact = mccchannel_12_analyzer_1_array_crystal_array_5_p_interact;
char* mask_string = mccchannel_12_analyzer_1_array_crystal_array_5_mask_string;
char* mask_setting = mccchannel_12_analyzer_1_array_crystal_array_5_mask_setting;
MCNUM number_of_activations = mccchannel_12_analyzer_1_array_crystal_array_5_number_of_activations;
}   /* End of channel_12_analyzer_1_array_crystal_array_5=Union_box() SETTING parameter declarations. */
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex
  /* Label for restoring  neutron */
  mcabsorbCompchannel_12_analyzer_1_array_crystal_array_5:
  if (RESTORE) /* restore if needed */
  { RESTORE_NEUTRON(591,
      mcnlx,
      mcnly,
      mcnlz,
      mcnlvx,
      mcnlvy,
      mcnlvz,
      mcnlt,
      mcnlsx,
      mcnlsy,
      mcnlsz,
      mcnlp); }
#undef mcabsorbComp
#undef p
#undef sz
#undef sy
#undef sx
#undef t
#undef vz
#undef vy
#undef vx
#undef z
#undef y
#undef x
  mcDEBUG_STATE(
mcnlx,
mcnly,
mcnlz,
mcnlvx,
mcnlvy,
mcnlvz,
mcnlt,
mcnlsx,
mcnlsy,
mcnlsz,
mcnlp)

  /* TRACE Component channel_12_analyzer_1_array_crystal_array_6 [592] */
  mccoordschange(mcposrchannel_12_analyzer_1_array_crystal_array_6, mcrotrchannel_12_analyzer_1_array_crystal_array_6,
    &mcnlx,
    &mcnly,
    &mcnlz,
    &mcnlvx,
    &mcnlvy,
    &mcnlvz,
    &mcnlsx,
    &mcnlsy,
    &mcnlsz);
  /* define label inside component channel_12_analyzer_1_array_crystal_array_6 (without coords transformations) */
  mcJumpTrace_channel_12_analyzer_1_array_crystal_array_6:
  SIG_MESSAGE("channel_12_analyzer_1_array_crystal_array_6 (Trace)");
  mcDEBUG_COMP("channel_12_analyzer_1_array_crystal_array_6")
  mcDEBUG_STATE(
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp)
#define x mcnlx
#define y mcnly
#define z mcnlz
#define vx mcnlvx
#define vy mcnlvy
#define vz mcnlvz
#define t mcnlt
#define sx mcnlsx
#define sy mcnlsy
#define sz mcnlsz
#define p mcnlp

#define mcabsorbComp mcabsorbCompchannel_12_analyzer_1_array_crystal_array_6
  STORE_NEUTRON(592,
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp);
  mcScattered=0;
  mcRestore=0;
  mcNCounter[592]++;
  mcPCounter[592] += p;
  mcP2Counter[592] += p*p;
#define mccompcurname  channel_12_analyzer_1_array_crystal_array_6
#define mccompcurtype  Union_box
#define mccompcurindex 592
#define loop_index mccchannel_12_analyzer_1_array_crystal_array_6_loop_index
#define this_box_volume mccchannel_12_analyzer_1_array_crystal_array_6_this_box_volume
#define global_geometry_element mccchannel_12_analyzer_1_array_crystal_array_6_global_geometry_element
#define this_box_storage mccchannel_12_analyzer_1_array_crystal_array_6_this_box_storage
{   /* Declarations of channel_12_analyzer_1_array_crystal_array_6=Union_box() SETTING parameters. */
char* material_string = mccchannel_12_analyzer_1_array_crystal_array_6_material_string;
MCNUM priority = mccchannel_12_analyzer_1_array_crystal_array_6_priority;
MCNUM xwidth = mccchannel_12_analyzer_1_array_crystal_array_6_xwidth;
MCNUM yheight = mccchannel_12_analyzer_1_array_crystal_array_6_yheight;
MCNUM zdepth = mccchannel_12_analyzer_1_array_crystal_array_6_zdepth;
MCNUM xwidth2 = mccchannel_12_analyzer_1_array_crystal_array_6_xwidth2;
MCNUM yheight2 = mccchannel_12_analyzer_1_array_crystal_array_6_yheight2;
MCNUM visualize = mccchannel_12_analyzer_1_array_crystal_array_6_visualize;
int target_index = mccchannel_12_analyzer_1_array_crystal_array_6_target_index;
MCNUM target_x = mccchannel_12_analyzer_1_array_crystal_array_6_target_x;
MCNUM target_y = mccchannel_12_analyzer_1_array_crystal_array_6_target_y;
MCNUM target_z = mccchannel_12_analyzer_1_array_crystal_array_6_target_z;
MCNUM focus_aw = mccchannel_12_analyzer_1_array_crystal_array_6_focus_aw;
MCNUM focus_ah = mccchannel_12_analyzer_1_array_crystal_array_6_focus_ah;
MCNUM focus_xw = mccchannel_12_analyzer_1_array_crystal_array_6_focus_xw;
MCNUM focus_xh = mccchannel_12_analyzer_1_array_crystal_array_6_focus_xh;
MCNUM focus_r = mccchannel_12_analyzer_1_array_crystal_array_6_focus_r;
MCNUM p_interact = mccchannel_12_analyzer_1_array_crystal_array_6_p_interact;
char* mask_string = mccchannel_12_analyzer_1_array_crystal_array_6_mask_string;
char* mask_setting = mccchannel_12_analyzer_1_array_crystal_array_6_mask_setting;
MCNUM number_of_activations = mccchannel_12_analyzer_1_array_crystal_array_6_number_of_activations;
}   /* End of channel_12_analyzer_1_array_crystal_array_6=Union_box() SETTING parameter declarations. */
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex
  /* Label for restoring  neutron */
  mcabsorbCompchannel_12_analyzer_1_array_crystal_array_6:
  if (RESTORE) /* restore if needed */
  { RESTORE_NEUTRON(592,
      mcnlx,
      mcnly,
      mcnlz,
      mcnlvx,
      mcnlvy,
      mcnlvz,
      mcnlt,
      mcnlsx,
      mcnlsy,
      mcnlsz,
      mcnlp); }
#undef mcabsorbComp
#undef p
#undef sz
#undef sy
#undef sx
#undef t
#undef vz
#undef vy
#undef vx
#undef z
#undef y
#undef x
  mcDEBUG_STATE(
mcnlx,
mcnly,
mcnlz,
mcnlvx,
mcnlvy,
mcnlvz,
mcnlt,
mcnlsx,
mcnlsy,
mcnlsz,
mcnlp)

  /* TRACE Component channel_12_analyzer_1_array_crystal_array_7 [593] */
  mccoordschange(mcposrchannel_12_analyzer_1_array_crystal_array_7, mcrotrchannel_12_analyzer_1_array_crystal_array_7,
    &mcnlx,
    &mcnly,
    &mcnlz,
    &mcnlvx,
    &mcnlvy,
    &mcnlvz,
    &mcnlsx,
    &mcnlsy,
    &mcnlsz);
  /* define label inside component channel_12_analyzer_1_array_crystal_array_7 (without coords transformations) */
  mcJumpTrace_channel_12_analyzer_1_array_crystal_array_7:
  SIG_MESSAGE("channel_12_analyzer_1_array_crystal_array_7 (Trace)");
  mcDEBUG_COMP("channel_12_analyzer_1_array_crystal_array_7")
  mcDEBUG_STATE(
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp)
#define x mcnlx
#define y mcnly
#define z mcnlz
#define vx mcnlvx
#define vy mcnlvy
#define vz mcnlvz
#define t mcnlt
#define sx mcnlsx
#define sy mcnlsy
#define sz mcnlsz
#define p mcnlp

#define mcabsorbComp mcabsorbCompchannel_12_analyzer_1_array_crystal_array_7
  STORE_NEUTRON(593,
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp);
  mcScattered=0;
  mcRestore=0;
  mcNCounter[593]++;
  mcPCounter[593] += p;
  mcP2Counter[593] += p*p;
#define mccompcurname  channel_12_analyzer_1_array_crystal_array_7
#define mccompcurtype  Union_box
#define mccompcurindex 593
#define loop_index mccchannel_12_analyzer_1_array_crystal_array_7_loop_index
#define this_box_volume mccchannel_12_analyzer_1_array_crystal_array_7_this_box_volume
#define global_geometry_element mccchannel_12_analyzer_1_array_crystal_array_7_global_geometry_element
#define this_box_storage mccchannel_12_analyzer_1_array_crystal_array_7_this_box_storage
{   /* Declarations of channel_12_analyzer_1_array_crystal_array_7=Union_box() SETTING parameters. */
char* material_string = mccchannel_12_analyzer_1_array_crystal_array_7_material_string;
MCNUM priority = mccchannel_12_analyzer_1_array_crystal_array_7_priority;
MCNUM xwidth = mccchannel_12_analyzer_1_array_crystal_array_7_xwidth;
MCNUM yheight = mccchannel_12_analyzer_1_array_crystal_array_7_yheight;
MCNUM zdepth = mccchannel_12_analyzer_1_array_crystal_array_7_zdepth;
MCNUM xwidth2 = mccchannel_12_analyzer_1_array_crystal_array_7_xwidth2;
MCNUM yheight2 = mccchannel_12_analyzer_1_array_crystal_array_7_yheight2;
MCNUM visualize = mccchannel_12_analyzer_1_array_crystal_array_7_visualize;
int target_index = mccchannel_12_analyzer_1_array_crystal_array_7_target_index;
MCNUM target_x = mccchannel_12_analyzer_1_array_crystal_array_7_target_x;
MCNUM target_y = mccchannel_12_analyzer_1_array_crystal_array_7_target_y;
MCNUM target_z = mccchannel_12_analyzer_1_array_crystal_array_7_target_z;
MCNUM focus_aw = mccchannel_12_analyzer_1_array_crystal_array_7_focus_aw;
MCNUM focus_ah = mccchannel_12_analyzer_1_array_crystal_array_7_focus_ah;
MCNUM focus_xw = mccchannel_12_analyzer_1_array_crystal_array_7_focus_xw;
MCNUM focus_xh = mccchannel_12_analyzer_1_array_crystal_array_7_focus_xh;
MCNUM focus_r = mccchannel_12_analyzer_1_array_crystal_array_7_focus_r;
MCNUM p_interact = mccchannel_12_analyzer_1_array_crystal_array_7_p_interact;
char* mask_string = mccchannel_12_analyzer_1_array_crystal_array_7_mask_string;
char* mask_setting = mccchannel_12_analyzer_1_array_crystal_array_7_mask_setting;
MCNUM number_of_activations = mccchannel_12_analyzer_1_array_crystal_array_7_number_of_activations;
}   /* End of channel_12_analyzer_1_array_crystal_array_7=Union_box() SETTING parameter declarations. */
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex
  /* Label for restoring  neutron */
  mcabsorbCompchannel_12_analyzer_1_array_crystal_array_7:
  if (RESTORE) /* restore if needed */
  { RESTORE_NEUTRON(593,
      mcnlx,
      mcnly,
      mcnlz,
      mcnlvx,
      mcnlvy,
      mcnlvz,
      mcnlt,
      mcnlsx,
      mcnlsy,
      mcnlsz,
      mcnlp); }
#undef mcabsorbComp
#undef p
#undef sz
#undef sy
#undef sx
#undef t
#undef vz
#undef vy
#undef vx
#undef z
#undef y
#undef x
  mcDEBUG_STATE(
mcnlx,
mcnly,
mcnlz,
mcnlvx,
mcnlvy,
mcnlvz,
mcnlt,
mcnlsx,
mcnlsy,
mcnlsz,
mcnlp)

  /* TRACE Component channel_12_analyzer_1_array_crystal_array_8 [594] */
  mccoordschange(mcposrchannel_12_analyzer_1_array_crystal_array_8, mcrotrchannel_12_analyzer_1_array_crystal_array_8,
    &mcnlx,
    &mcnly,
    &mcnlz,
    &mcnlvx,
    &mcnlvy,
    &mcnlvz,
    &mcnlsx,
    &mcnlsy,
    &mcnlsz);
  /* define label inside component channel_12_analyzer_1_array_crystal_array_8 (without coords transformations) */
  mcJumpTrace_channel_12_analyzer_1_array_crystal_array_8:
  SIG_MESSAGE("channel_12_analyzer_1_array_crystal_array_8 (Trace)");
  mcDEBUG_COMP("channel_12_analyzer_1_array_crystal_array_8")
  mcDEBUG_STATE(
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp)
#define x mcnlx
#define y mcnly
#define z mcnlz
#define vx mcnlvx
#define vy mcnlvy
#define vz mcnlvz
#define t mcnlt
#define sx mcnlsx
#define sy mcnlsy
#define sz mcnlsz
#define p mcnlp

#define mcabsorbComp mcabsorbCompchannel_12_analyzer_1_array_crystal_array_8
  STORE_NEUTRON(594,
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp);
  mcScattered=0;
  mcRestore=0;
  mcNCounter[594]++;
  mcPCounter[594] += p;
  mcP2Counter[594] += p*p;
#define mccompcurname  channel_12_analyzer_1_array_crystal_array_8
#define mccompcurtype  Union_box
#define mccompcurindex 594
#define loop_index mccchannel_12_analyzer_1_array_crystal_array_8_loop_index
#define this_box_volume mccchannel_12_analyzer_1_array_crystal_array_8_this_box_volume
#define global_geometry_element mccchannel_12_analyzer_1_array_crystal_array_8_global_geometry_element
#define this_box_storage mccchannel_12_analyzer_1_array_crystal_array_8_this_box_storage
{   /* Declarations of channel_12_analyzer_1_array_crystal_array_8=Union_box() SETTING parameters. */
char* material_string = mccchannel_12_analyzer_1_array_crystal_array_8_material_string;
MCNUM priority = mccchannel_12_analyzer_1_array_crystal_array_8_priority;
MCNUM xwidth = mccchannel_12_analyzer_1_array_crystal_array_8_xwidth;
MCNUM yheight = mccchannel_12_analyzer_1_array_crystal_array_8_yheight;
MCNUM zdepth = mccchannel_12_analyzer_1_array_crystal_array_8_zdepth;
MCNUM xwidth2 = mccchannel_12_analyzer_1_array_crystal_array_8_xwidth2;
MCNUM yheight2 = mccchannel_12_analyzer_1_array_crystal_array_8_yheight2;
MCNUM visualize = mccchannel_12_analyzer_1_array_crystal_array_8_visualize;
int target_index = mccchannel_12_analyzer_1_array_crystal_array_8_target_index;
MCNUM target_x = mccchannel_12_analyzer_1_array_crystal_array_8_target_x;
MCNUM target_y = mccchannel_12_analyzer_1_array_crystal_array_8_target_y;
MCNUM target_z = mccchannel_12_analyzer_1_array_crystal_array_8_target_z;
MCNUM focus_aw = mccchannel_12_analyzer_1_array_crystal_array_8_focus_aw;
MCNUM focus_ah = mccchannel_12_analyzer_1_array_crystal_array_8_focus_ah;
MCNUM focus_xw = mccchannel_12_analyzer_1_array_crystal_array_8_focus_xw;
MCNUM focus_xh = mccchannel_12_analyzer_1_array_crystal_array_8_focus_xh;
MCNUM focus_r = mccchannel_12_analyzer_1_array_crystal_array_8_focus_r;
MCNUM p_interact = mccchannel_12_analyzer_1_array_crystal_array_8_p_interact;
char* mask_string = mccchannel_12_analyzer_1_array_crystal_array_8_mask_string;
char* mask_setting = mccchannel_12_analyzer_1_array_crystal_array_8_mask_setting;
MCNUM number_of_activations = mccchannel_12_analyzer_1_array_crystal_array_8_number_of_activations;
}   /* End of channel_12_analyzer_1_array_crystal_array_8=Union_box() SETTING parameter declarations. */
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex
  /* Label for restoring  neutron */
  mcabsorbCompchannel_12_analyzer_1_array_crystal_array_8:
  if (RESTORE) /* restore if needed */
  { RESTORE_NEUTRON(594,
      mcnlx,
      mcnly,
      mcnlz,
      mcnlvx,
      mcnlvy,
      mcnlvz,
      mcnlt,
      mcnlsx,
      mcnlsy,
      mcnlsz,
      mcnlp); }
#undef mcabsorbComp
#undef p
#undef sz
#undef sy
#undef sx
#undef t
#undef vz
#undef vy
#undef vx
#undef z
#undef y
#undef x
  mcDEBUG_STATE(
mcnlx,
mcnly,
mcnlz,
mcnlvx,
mcnlvy,
mcnlvz,
mcnlt,
mcnlsx,
mcnlsy,
mcnlsz,
mcnlp)

  /* TRACE Component channel_12_analyzer_2_center [595] */
  mccoordschange(mcposrchannel_12_analyzer_2_center, mcrotrchannel_12_analyzer_2_center,
    &mcnlx,
    &mcnly,
    &mcnlz,
    &mcnlvx,
    &mcnlvy,
    &mcnlvz,
    &mcnlsx,
    &mcnlsy,
    &mcnlsz);
  /* define label inside component channel_12_analyzer_2_center (without coords transformations) */
  mcJumpTrace_channel_12_analyzer_2_center:
  SIG_MESSAGE("channel_12_analyzer_2_center (Trace)");
  mcDEBUG_COMP("channel_12_analyzer_2_center")
  mcDEBUG_STATE(
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp)
#define x mcnlx
#define y mcnly
#define z mcnlz
#define vx mcnlvx
#define vy mcnlvy
#define vz mcnlvz
#define t mcnlt
#define sx mcnlsx
#define sy mcnlsy
#define sz mcnlsz
#define p mcnlp

#define mcabsorbComp mcabsorbCompchannel_12_analyzer_2_center
  STORE_NEUTRON(595,
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp);
  mcScattered=0;
  mcRestore=0;
  mcNCounter[595]++;
  mcPCounter[595] += p;
  mcP2Counter[595] += p*p;
#define mccompcurname  channel_12_analyzer_2_center
#define mccompcurtype  Arm
#define mccompcurindex 595
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex
  /* Label for restoring  neutron */
  mcabsorbCompchannel_12_analyzer_2_center:
  if (RESTORE) /* restore if needed */
  { RESTORE_NEUTRON(595,
      mcnlx,
      mcnly,
      mcnlz,
      mcnlvx,
      mcnlvy,
      mcnlvz,
      mcnlt,
      mcnlsx,
      mcnlsy,
      mcnlsz,
      mcnlp); }
#undef mcabsorbComp
#undef p
#undef sz
#undef sy
#undef sx
#undef t
#undef vz
#undef vy
#undef vx
#undef z
#undef y
#undef x
  mcDEBUG_STATE(
mcnlx,
mcnly,
mcnlz,
mcnlvx,
mcnlvy,
mcnlvz,
mcnlt,
mcnlsx,
mcnlsy,
mcnlsz,
mcnlp)

  /* TRACE Component channel_12_analyzer_2_rotated [596] */
  mccoordschange(mcposrchannel_12_analyzer_2_rotated, mcrotrchannel_12_analyzer_2_rotated,
    &mcnlx,
    &mcnly,
    &mcnlz,
    &mcnlvx,
    &mcnlvy,
    &mcnlvz,
    &mcnlsx,
    &mcnlsy,
    &mcnlsz);
  /* define label inside component channel_12_analyzer_2_rotated (without coords transformations) */
  mcJumpTrace_channel_12_analyzer_2_rotated:
  SIG_MESSAGE("channel_12_analyzer_2_rotated (Trace)");
  mcDEBUG_COMP("channel_12_analyzer_2_rotated")
  mcDEBUG_STATE(
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp)
#define x mcnlx
#define y mcnly
#define z mcnlz
#define vx mcnlvx
#define vy mcnlvy
#define vz mcnlvz
#define t mcnlt
#define sx mcnlsx
#define sy mcnlsy
#define sz mcnlsz
#define p mcnlp

#define mcabsorbComp mcabsorbCompchannel_12_analyzer_2_rotated
  STORE_NEUTRON(596,
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp);
  mcScattered=0;
  mcRestore=0;
  mcNCounter[596]++;
  mcPCounter[596] += p;
  mcP2Counter[596] += p*p;
#define mccompcurname  channel_12_analyzer_2_rotated
#define mccompcurtype  Arm
#define mccompcurindex 596
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex
  /* Label for restoring  neutron */
  mcabsorbCompchannel_12_analyzer_2_rotated:
  if (RESTORE) /* restore if needed */
  { RESTORE_NEUTRON(596,
      mcnlx,
      mcnly,
      mcnlz,
      mcnlvx,
      mcnlvy,
      mcnlvz,
      mcnlt,
      mcnlsx,
      mcnlsy,
      mcnlsz,
      mcnlp); }
#undef mcabsorbComp
#undef p
#undef sz
#undef sy
#undef sx
#undef t
#undef vz
#undef vy
#undef vx
#undef z
#undef y
#undef x
  mcDEBUG_STATE(
mcnlx,
mcnly,
mcnlz,
mcnlvx,
mcnlvy,
mcnlvz,
mcnlt,
mcnlsx,
mcnlsy,
mcnlsz,
mcnlp)

  /* TRACE Component channel_12_analyzer_2_array_crystal_array_0 [597] */
  mccoordschange(mcposrchannel_12_analyzer_2_array_crystal_array_0, mcrotrchannel_12_analyzer_2_array_crystal_array_0,
    &mcnlx,
    &mcnly,
    &mcnlz,
    &mcnlvx,
    &mcnlvy,
    &mcnlvz,
    &mcnlsx,
    &mcnlsy,
    &mcnlsz);
  /* define label inside component channel_12_analyzer_2_array_crystal_array_0 (without coords transformations) */
  mcJumpTrace_channel_12_analyzer_2_array_crystal_array_0:
  SIG_MESSAGE("channel_12_analyzer_2_array_crystal_array_0 (Trace)");
  mcDEBUG_COMP("channel_12_analyzer_2_array_crystal_array_0")
  mcDEBUG_STATE(
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp)
#define x mcnlx
#define y mcnly
#define z mcnlz
#define vx mcnlvx
#define vy mcnlvy
#define vz mcnlvz
#define t mcnlt
#define sx mcnlsx
#define sy mcnlsy
#define sz mcnlsz
#define p mcnlp

#define mcabsorbComp mcabsorbCompchannel_12_analyzer_2_array_crystal_array_0
  STORE_NEUTRON(597,
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp);
  mcScattered=0;
  mcRestore=0;
  mcNCounter[597]++;
  mcPCounter[597] += p;
  mcP2Counter[597] += p*p;
#define mccompcurname  channel_12_analyzer_2_array_crystal_array_0
#define mccompcurtype  Union_box
#define mccompcurindex 597
#define loop_index mccchannel_12_analyzer_2_array_crystal_array_0_loop_index
#define this_box_volume mccchannel_12_analyzer_2_array_crystal_array_0_this_box_volume
#define global_geometry_element mccchannel_12_analyzer_2_array_crystal_array_0_global_geometry_element
#define this_box_storage mccchannel_12_analyzer_2_array_crystal_array_0_this_box_storage
{   /* Declarations of channel_12_analyzer_2_array_crystal_array_0=Union_box() SETTING parameters. */
char* material_string = mccchannel_12_analyzer_2_array_crystal_array_0_material_string;
MCNUM priority = mccchannel_12_analyzer_2_array_crystal_array_0_priority;
MCNUM xwidth = mccchannel_12_analyzer_2_array_crystal_array_0_xwidth;
MCNUM yheight = mccchannel_12_analyzer_2_array_crystal_array_0_yheight;
MCNUM zdepth = mccchannel_12_analyzer_2_array_crystal_array_0_zdepth;
MCNUM xwidth2 = mccchannel_12_analyzer_2_array_crystal_array_0_xwidth2;
MCNUM yheight2 = mccchannel_12_analyzer_2_array_crystal_array_0_yheight2;
MCNUM visualize = mccchannel_12_analyzer_2_array_crystal_array_0_visualize;
int target_index = mccchannel_12_analyzer_2_array_crystal_array_0_target_index;
MCNUM target_x = mccchannel_12_analyzer_2_array_crystal_array_0_target_x;
MCNUM target_y = mccchannel_12_analyzer_2_array_crystal_array_0_target_y;
MCNUM target_z = mccchannel_12_analyzer_2_array_crystal_array_0_target_z;
MCNUM focus_aw = mccchannel_12_analyzer_2_array_crystal_array_0_focus_aw;
MCNUM focus_ah = mccchannel_12_analyzer_2_array_crystal_array_0_focus_ah;
MCNUM focus_xw = mccchannel_12_analyzer_2_array_crystal_array_0_focus_xw;
MCNUM focus_xh = mccchannel_12_analyzer_2_array_crystal_array_0_focus_xh;
MCNUM focus_r = mccchannel_12_analyzer_2_array_crystal_array_0_focus_r;
MCNUM p_interact = mccchannel_12_analyzer_2_array_crystal_array_0_p_interact;
char* mask_string = mccchannel_12_analyzer_2_array_crystal_array_0_mask_string;
char* mask_setting = mccchannel_12_analyzer_2_array_crystal_array_0_mask_setting;
MCNUM number_of_activations = mccchannel_12_analyzer_2_array_crystal_array_0_number_of_activations;
}   /* End of channel_12_analyzer_2_array_crystal_array_0=Union_box() SETTING parameter declarations. */
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex
  /* Label for restoring  neutron */
  mcabsorbCompchannel_12_analyzer_2_array_crystal_array_0:
  if (RESTORE) /* restore if needed */
  { RESTORE_NEUTRON(597,
      mcnlx,
      mcnly,
      mcnlz,
      mcnlvx,
      mcnlvy,
      mcnlvz,
      mcnlt,
      mcnlsx,
      mcnlsy,
      mcnlsz,
      mcnlp); }
#undef mcabsorbComp
#undef p
#undef sz
#undef sy
#undef sx
#undef t
#undef vz
#undef vy
#undef vx
#undef z
#undef y
#undef x
  mcDEBUG_STATE(
mcnlx,
mcnly,
mcnlz,
mcnlvx,
mcnlvy,
mcnlvz,
mcnlt,
mcnlsx,
mcnlsy,
mcnlsz,
mcnlp)

  /* TRACE Component channel_12_analyzer_2_array_crystal_array_1 [598] */
  mccoordschange(mcposrchannel_12_analyzer_2_array_crystal_array_1, mcrotrchannel_12_analyzer_2_array_crystal_array_1,
    &mcnlx,
    &mcnly,
    &mcnlz,
    &mcnlvx,
    &mcnlvy,
    &mcnlvz,
    &mcnlsx,
    &mcnlsy,
    &mcnlsz);
  /* define label inside component channel_12_analyzer_2_array_crystal_array_1 (without coords transformations) */
  mcJumpTrace_channel_12_analyzer_2_array_crystal_array_1:
  SIG_MESSAGE("channel_12_analyzer_2_array_crystal_array_1 (Trace)");
  mcDEBUG_COMP("channel_12_analyzer_2_array_crystal_array_1")
  mcDEBUG_STATE(
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp)
#define x mcnlx
#define y mcnly
#define z mcnlz
#define vx mcnlvx
#define vy mcnlvy
#define vz mcnlvz
#define t mcnlt
#define sx mcnlsx
#define sy mcnlsy
#define sz mcnlsz
#define p mcnlp

#define mcabsorbComp mcabsorbCompchannel_12_analyzer_2_array_crystal_array_1
  STORE_NEUTRON(598,
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp);
  mcScattered=0;
  mcRestore=0;
  mcNCounter[598]++;
  mcPCounter[598] += p;
  mcP2Counter[598] += p*p;
#define mccompcurname  channel_12_analyzer_2_array_crystal_array_1
#define mccompcurtype  Union_box
#define mccompcurindex 598
#define loop_index mccchannel_12_analyzer_2_array_crystal_array_1_loop_index
#define this_box_volume mccchannel_12_analyzer_2_array_crystal_array_1_this_box_volume
#define global_geometry_element mccchannel_12_analyzer_2_array_crystal_array_1_global_geometry_element
#define this_box_storage mccchannel_12_analyzer_2_array_crystal_array_1_this_box_storage
{   /* Declarations of channel_12_analyzer_2_array_crystal_array_1=Union_box() SETTING parameters. */
char* material_string = mccchannel_12_analyzer_2_array_crystal_array_1_material_string;
MCNUM priority = mccchannel_12_analyzer_2_array_crystal_array_1_priority;
MCNUM xwidth = mccchannel_12_analyzer_2_array_crystal_array_1_xwidth;
MCNUM yheight = mccchannel_12_analyzer_2_array_crystal_array_1_yheight;
MCNUM zdepth = mccchannel_12_analyzer_2_array_crystal_array_1_zdepth;
MCNUM xwidth2 = mccchannel_12_analyzer_2_array_crystal_array_1_xwidth2;
MCNUM yheight2 = mccchannel_12_analyzer_2_array_crystal_array_1_yheight2;
MCNUM visualize = mccchannel_12_analyzer_2_array_crystal_array_1_visualize;
int target_index = mccchannel_12_analyzer_2_array_crystal_array_1_target_index;
MCNUM target_x = mccchannel_12_analyzer_2_array_crystal_array_1_target_x;
MCNUM target_y = mccchannel_12_analyzer_2_array_crystal_array_1_target_y;
MCNUM target_z = mccchannel_12_analyzer_2_array_crystal_array_1_target_z;
MCNUM focus_aw = mccchannel_12_analyzer_2_array_crystal_array_1_focus_aw;
MCNUM focus_ah = mccchannel_12_analyzer_2_array_crystal_array_1_focus_ah;
MCNUM focus_xw = mccchannel_12_analyzer_2_array_crystal_array_1_focus_xw;
MCNUM focus_xh = mccchannel_12_analyzer_2_array_crystal_array_1_focus_xh;
MCNUM focus_r = mccchannel_12_analyzer_2_array_crystal_array_1_focus_r;
MCNUM p_interact = mccchannel_12_analyzer_2_array_crystal_array_1_p_interact;
char* mask_string = mccchannel_12_analyzer_2_array_crystal_array_1_mask_string;
char* mask_setting = mccchannel_12_analyzer_2_array_crystal_array_1_mask_setting;
MCNUM number_of_activations = mccchannel_12_analyzer_2_array_crystal_array_1_number_of_activations;
}   /* End of channel_12_analyzer_2_array_crystal_array_1=Union_box() SETTING parameter declarations. */
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex
  /* Label for restoring  neutron */
  mcabsorbCompchannel_12_analyzer_2_array_crystal_array_1:
  if (RESTORE) /* restore if needed */
  { RESTORE_NEUTRON(598,
      mcnlx,
      mcnly,
      mcnlz,
      mcnlvx,
      mcnlvy,
      mcnlvz,
      mcnlt,
      mcnlsx,
      mcnlsy,
      mcnlsz,
      mcnlp); }
#undef mcabsorbComp
#undef p
#undef sz
#undef sy
#undef sx
#undef t
#undef vz
#undef vy
#undef vx
#undef z
#undef y
#undef x
  mcDEBUG_STATE(
mcnlx,
mcnly,
mcnlz,
mcnlvx,
mcnlvy,
mcnlvz,
mcnlt,
mcnlsx,
mcnlsy,
mcnlsz,
mcnlp)

  /* TRACE Component channel_12_analyzer_2_array_crystal_array_2 [599] */
  mccoordschange(mcposrchannel_12_analyzer_2_array_crystal_array_2, mcrotrchannel_12_analyzer_2_array_crystal_array_2,
    &mcnlx,
    &mcnly,
    &mcnlz,
    &mcnlvx,
    &mcnlvy,
    &mcnlvz,
    &mcnlsx,
    &mcnlsy,
    &mcnlsz);
  /* define label inside component channel_12_analyzer_2_array_crystal_array_2 (without coords transformations) */
  mcJumpTrace_channel_12_analyzer_2_array_crystal_array_2:
  SIG_MESSAGE("channel_12_analyzer_2_array_crystal_array_2 (Trace)");
  mcDEBUG_COMP("channel_12_analyzer_2_array_crystal_array_2")
  mcDEBUG_STATE(
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp)
#define x mcnlx
#define y mcnly
#define z mcnlz
#define vx mcnlvx
#define vy mcnlvy
#define vz mcnlvz
#define t mcnlt
#define sx mcnlsx
#define sy mcnlsy
#define sz mcnlsz
#define p mcnlp

#define mcabsorbComp mcabsorbCompchannel_12_analyzer_2_array_crystal_array_2
  STORE_NEUTRON(599,
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp);
  mcScattered=0;
  mcRestore=0;
  mcNCounter[599]++;
  mcPCounter[599] += p;
  mcP2Counter[599] += p*p;
#define mccompcurname  channel_12_analyzer_2_array_crystal_array_2
#define mccompcurtype  Union_box
#define mccompcurindex 599
#define loop_index mccchannel_12_analyzer_2_array_crystal_array_2_loop_index
#define this_box_volume mccchannel_12_analyzer_2_array_crystal_array_2_this_box_volume
#define global_geometry_element mccchannel_12_analyzer_2_array_crystal_array_2_global_geometry_element
#define this_box_storage mccchannel_12_analyzer_2_array_crystal_array_2_this_box_storage
{   /* Declarations of channel_12_analyzer_2_array_crystal_array_2=Union_box() SETTING parameters. */
char* material_string = mccchannel_12_analyzer_2_array_crystal_array_2_material_string;
MCNUM priority = mccchannel_12_analyzer_2_array_crystal_array_2_priority;
MCNUM xwidth = mccchannel_12_analyzer_2_array_crystal_array_2_xwidth;
MCNUM yheight = mccchannel_12_analyzer_2_array_crystal_array_2_yheight;
MCNUM zdepth = mccchannel_12_analyzer_2_array_crystal_array_2_zdepth;
MCNUM xwidth2 = mccchannel_12_analyzer_2_array_crystal_array_2_xwidth2;
MCNUM yheight2 = mccchannel_12_analyzer_2_array_crystal_array_2_yheight2;
MCNUM visualize = mccchannel_12_analyzer_2_array_crystal_array_2_visualize;
int target_index = mccchannel_12_analyzer_2_array_crystal_array_2_target_index;
MCNUM target_x = mccchannel_12_analyzer_2_array_crystal_array_2_target_x;
MCNUM target_y = mccchannel_12_analyzer_2_array_crystal_array_2_target_y;
MCNUM target_z = mccchannel_12_analyzer_2_array_crystal_array_2_target_z;
MCNUM focus_aw = mccchannel_12_analyzer_2_array_crystal_array_2_focus_aw;
MCNUM focus_ah = mccchannel_12_analyzer_2_array_crystal_array_2_focus_ah;
MCNUM focus_xw = mccchannel_12_analyzer_2_array_crystal_array_2_focus_xw;
MCNUM focus_xh = mccchannel_12_analyzer_2_array_crystal_array_2_focus_xh;
MCNUM focus_r = mccchannel_12_analyzer_2_array_crystal_array_2_focus_r;
MCNUM p_interact = mccchannel_12_analyzer_2_array_crystal_array_2_p_interact;
char* mask_string = mccchannel_12_analyzer_2_array_crystal_array_2_mask_string;
char* mask_setting = mccchannel_12_analyzer_2_array_crystal_array_2_mask_setting;
MCNUM number_of_activations = mccchannel_12_analyzer_2_array_crystal_array_2_number_of_activations;
}   /* End of channel_12_analyzer_2_array_crystal_array_2=Union_box() SETTING parameter declarations. */
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex
  /* Label for restoring  neutron */
  mcabsorbCompchannel_12_analyzer_2_array_crystal_array_2:
  if (RESTORE) /* restore if needed */
  { RESTORE_NEUTRON(599,
      mcnlx,
      mcnly,
      mcnlz,
      mcnlvx,
      mcnlvy,
      mcnlvz,
      mcnlt,
      mcnlsx,
      mcnlsy,
      mcnlsz,
      mcnlp); }
#undef mcabsorbComp
#undef p
#undef sz
#undef sy
#undef sx
#undef t
#undef vz
#undef vy
#undef vx
#undef z
#undef y
#undef x
  mcDEBUG_STATE(
mcnlx,
mcnly,
mcnlz,
mcnlvx,
mcnlvy,
mcnlvz,
mcnlt,
mcnlsx,
mcnlsy,
mcnlsz,
mcnlp)

  /* TRACE Component channel_12_analyzer_2_array_crystal_array_3 [600] */
  mccoordschange(mcposrchannel_12_analyzer_2_array_crystal_array_3, mcrotrchannel_12_analyzer_2_array_crystal_array_3,
    &mcnlx,
    &mcnly,
    &mcnlz,
    &mcnlvx,
    &mcnlvy,
    &mcnlvz,
    &mcnlsx,
    &mcnlsy,
    &mcnlsz);
  /* define label inside component channel_12_analyzer_2_array_crystal_array_3 (without coords transformations) */
  mcJumpTrace_channel_12_analyzer_2_array_crystal_array_3:
  SIG_MESSAGE("channel_12_analyzer_2_array_crystal_array_3 (Trace)");
  mcDEBUG_COMP("channel_12_analyzer_2_array_crystal_array_3")
  mcDEBUG_STATE(
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp)
#define x mcnlx
#define y mcnly
#define z mcnlz
#define vx mcnlvx
#define vy mcnlvy
#define vz mcnlvz
#define t mcnlt
#define sx mcnlsx
#define sy mcnlsy
#define sz mcnlsz
#define p mcnlp

#define mcabsorbComp mcabsorbCompchannel_12_analyzer_2_array_crystal_array_3
  STORE_NEUTRON(600,
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp);
  mcScattered=0;
  mcRestore=0;
  mcNCounter[600]++;
  mcPCounter[600] += p;
  mcP2Counter[600] += p*p;
#define mccompcurname  channel_12_analyzer_2_array_crystal_array_3
#define mccompcurtype  Union_box
#define mccompcurindex 600
#define loop_index mccchannel_12_analyzer_2_array_crystal_array_3_loop_index
#define this_box_volume mccchannel_12_analyzer_2_array_crystal_array_3_this_box_volume
#define global_geometry_element mccchannel_12_analyzer_2_array_crystal_array_3_global_geometry_element
#define this_box_storage mccchannel_12_analyzer_2_array_crystal_array_3_this_box_storage
{   /* Declarations of channel_12_analyzer_2_array_crystal_array_3=Union_box() SETTING parameters. */
char* material_string = mccchannel_12_analyzer_2_array_crystal_array_3_material_string;
MCNUM priority = mccchannel_12_analyzer_2_array_crystal_array_3_priority;
MCNUM xwidth = mccchannel_12_analyzer_2_array_crystal_array_3_xwidth;
MCNUM yheight = mccchannel_12_analyzer_2_array_crystal_array_3_yheight;
MCNUM zdepth = mccchannel_12_analyzer_2_array_crystal_array_3_zdepth;
MCNUM xwidth2 = mccchannel_12_analyzer_2_array_crystal_array_3_xwidth2;
MCNUM yheight2 = mccchannel_12_analyzer_2_array_crystal_array_3_yheight2;
MCNUM visualize = mccchannel_12_analyzer_2_array_crystal_array_3_visualize;
int target_index = mccchannel_12_analyzer_2_array_crystal_array_3_target_index;
MCNUM target_x = mccchannel_12_analyzer_2_array_crystal_array_3_target_x;
MCNUM target_y = mccchannel_12_analyzer_2_array_crystal_array_3_target_y;
MCNUM target_z = mccchannel_12_analyzer_2_array_crystal_array_3_target_z;
MCNUM focus_aw = mccchannel_12_analyzer_2_array_crystal_array_3_focus_aw;
MCNUM focus_ah = mccchannel_12_analyzer_2_array_crystal_array_3_focus_ah;
MCNUM focus_xw = mccchannel_12_analyzer_2_array_crystal_array_3_focus_xw;
MCNUM focus_xh = mccchannel_12_analyzer_2_array_crystal_array_3_focus_xh;
MCNUM focus_r = mccchannel_12_analyzer_2_array_crystal_array_3_focus_r;
MCNUM p_interact = mccchannel_12_analyzer_2_array_crystal_array_3_p_interact;
char* mask_string = mccchannel_12_analyzer_2_array_crystal_array_3_mask_string;
char* mask_setting = mccchannel_12_analyzer_2_array_crystal_array_3_mask_setting;
MCNUM number_of_activations = mccchannel_12_analyzer_2_array_crystal_array_3_number_of_activations;
}   /* End of channel_12_analyzer_2_array_crystal_array_3=Union_box() SETTING parameter declarations. */
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex
  /* Label for restoring  neutron */
  mcabsorbCompchannel_12_analyzer_2_array_crystal_array_3:
  if (RESTORE) /* restore if needed */
  { RESTORE_NEUTRON(600,
      mcnlx,
      mcnly,
      mcnlz,
      mcnlvx,
      mcnlvy,
      mcnlvz,
      mcnlt,
      mcnlsx,
      mcnlsy,
      mcnlsz,
      mcnlp); }
#undef mcabsorbComp
#undef p
#undef sz
#undef sy
#undef sx
#undef t
#undef vz
#undef vy
#undef vx
#undef z
#undef y
#undef x
  mcDEBUG_STATE(
mcnlx,
mcnly,
mcnlz,
mcnlvx,
mcnlvy,
mcnlvz,
mcnlt,
mcnlsx,
mcnlsy,
mcnlsz,
mcnlp)

  /* TRACE Component channel_12_analyzer_2_array_crystal_array_4 [601] */
  mccoordschange(mcposrchannel_12_analyzer_2_array_crystal_array_4, mcrotrchannel_12_analyzer_2_array_crystal_array_4,
    &mcnlx,
    &mcnly,
    &mcnlz,
    &mcnlvx,
    &mcnlvy,
    &mcnlvz,
    &mcnlsx,
    &mcnlsy,
    &mcnlsz);
  /* define label inside component channel_12_analyzer_2_array_crystal_array_4 (without coords transformations) */
  mcJumpTrace_channel_12_analyzer_2_array_crystal_array_4:
  SIG_MESSAGE("channel_12_analyzer_2_array_crystal_array_4 (Trace)");
  mcDEBUG_COMP("channel_12_analyzer_2_array_crystal_array_4")
  mcDEBUG_STATE(
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp)
#define x mcnlx
#define y mcnly
#define z mcnlz
#define vx mcnlvx
#define vy mcnlvy
#define vz mcnlvz
#define t mcnlt
#define sx mcnlsx
#define sy mcnlsy
#define sz mcnlsz
#define p mcnlp

#define mcabsorbComp mcabsorbCompchannel_12_analyzer_2_array_crystal_array_4
  STORE_NEUTRON(601,
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp);
  mcScattered=0;
  mcRestore=0;
  mcNCounter[601]++;
  mcPCounter[601] += p;
  mcP2Counter[601] += p*p;
#define mccompcurname  channel_12_analyzer_2_array_crystal_array_4
#define mccompcurtype  Union_box
#define mccompcurindex 601
#define loop_index mccchannel_12_analyzer_2_array_crystal_array_4_loop_index
#define this_box_volume mccchannel_12_analyzer_2_array_crystal_array_4_this_box_volume
#define global_geometry_element mccchannel_12_analyzer_2_array_crystal_array_4_global_geometry_element
#define this_box_storage mccchannel_12_analyzer_2_array_crystal_array_4_this_box_storage
{   /* Declarations of channel_12_analyzer_2_array_crystal_array_4=Union_box() SETTING parameters. */
char* material_string = mccchannel_12_analyzer_2_array_crystal_array_4_material_string;
MCNUM priority = mccchannel_12_analyzer_2_array_crystal_array_4_priority;
MCNUM xwidth = mccchannel_12_analyzer_2_array_crystal_array_4_xwidth;
MCNUM yheight = mccchannel_12_analyzer_2_array_crystal_array_4_yheight;
MCNUM zdepth = mccchannel_12_analyzer_2_array_crystal_array_4_zdepth;
MCNUM xwidth2 = mccchannel_12_analyzer_2_array_crystal_array_4_xwidth2;
MCNUM yheight2 = mccchannel_12_analyzer_2_array_crystal_array_4_yheight2;
MCNUM visualize = mccchannel_12_analyzer_2_array_crystal_array_4_visualize;
int target_index = mccchannel_12_analyzer_2_array_crystal_array_4_target_index;
MCNUM target_x = mccchannel_12_analyzer_2_array_crystal_array_4_target_x;
MCNUM target_y = mccchannel_12_analyzer_2_array_crystal_array_4_target_y;
MCNUM target_z = mccchannel_12_analyzer_2_array_crystal_array_4_target_z;
MCNUM focus_aw = mccchannel_12_analyzer_2_array_crystal_array_4_focus_aw;
MCNUM focus_ah = mccchannel_12_analyzer_2_array_crystal_array_4_focus_ah;
MCNUM focus_xw = mccchannel_12_analyzer_2_array_crystal_array_4_focus_xw;
MCNUM focus_xh = mccchannel_12_analyzer_2_array_crystal_array_4_focus_xh;
MCNUM focus_r = mccchannel_12_analyzer_2_array_crystal_array_4_focus_r;
MCNUM p_interact = mccchannel_12_analyzer_2_array_crystal_array_4_p_interact;
char* mask_string = mccchannel_12_analyzer_2_array_crystal_array_4_mask_string;
char* mask_setting = mccchannel_12_analyzer_2_array_crystal_array_4_mask_setting;
MCNUM number_of_activations = mccchannel_12_analyzer_2_array_crystal_array_4_number_of_activations;
}   /* End of channel_12_analyzer_2_array_crystal_array_4=Union_box() SETTING parameter declarations. */
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex
  /* Label for restoring  neutron */
  mcabsorbCompchannel_12_analyzer_2_array_crystal_array_4:
  if (RESTORE) /* restore if needed */
  { RESTORE_NEUTRON(601,
      mcnlx,
      mcnly,
      mcnlz,
      mcnlvx,
      mcnlvy,
      mcnlvz,
      mcnlt,
      mcnlsx,
      mcnlsy,
      mcnlsz,
      mcnlp); }
#undef mcabsorbComp
#undef p
#undef sz
#undef sy
#undef sx
#undef t
#undef vz
#undef vy
#undef vx
#undef z
#undef y
#undef x
  mcDEBUG_STATE(
mcnlx,
mcnly,
mcnlz,
mcnlvx,
mcnlvy,
mcnlvz,
mcnlt,
mcnlsx,
mcnlsy,
mcnlsz,
mcnlp)

  /* TRACE Component channel_12_analyzer_2_array_crystal_array_5 [602] */
  mccoordschange(mcposrchannel_12_analyzer_2_array_crystal_array_5, mcrotrchannel_12_analyzer_2_array_crystal_array_5,
    &mcnlx,
    &mcnly,
    &mcnlz,
    &mcnlvx,
    &mcnlvy,
    &mcnlvz,
    &mcnlsx,
    &mcnlsy,
    &mcnlsz);
  /* define label inside component channel_12_analyzer_2_array_crystal_array_5 (without coords transformations) */
  mcJumpTrace_channel_12_analyzer_2_array_crystal_array_5:
  SIG_MESSAGE("channel_12_analyzer_2_array_crystal_array_5 (Trace)");
  mcDEBUG_COMP("channel_12_analyzer_2_array_crystal_array_5")
  mcDEBUG_STATE(
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp)
#define x mcnlx
#define y mcnly
#define z mcnlz
#define vx mcnlvx
#define vy mcnlvy
#define vz mcnlvz
#define t mcnlt
#define sx mcnlsx
#define sy mcnlsy
#define sz mcnlsz
#define p mcnlp

#define mcabsorbComp mcabsorbCompchannel_12_analyzer_2_array_crystal_array_5
  STORE_NEUTRON(602,
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp);
  mcScattered=0;
  mcRestore=0;
  mcNCounter[602]++;
  mcPCounter[602] += p;
  mcP2Counter[602] += p*p;
#define mccompcurname  channel_12_analyzer_2_array_crystal_array_5
#define mccompcurtype  Union_box
#define mccompcurindex 602
#define loop_index mccchannel_12_analyzer_2_array_crystal_array_5_loop_index
#define this_box_volume mccchannel_12_analyzer_2_array_crystal_array_5_this_box_volume
#define global_geometry_element mccchannel_12_analyzer_2_array_crystal_array_5_global_geometry_element
#define this_box_storage mccchannel_12_analyzer_2_array_crystal_array_5_this_box_storage
{   /* Declarations of channel_12_analyzer_2_array_crystal_array_5=Union_box() SETTING parameters. */
char* material_string = mccchannel_12_analyzer_2_array_crystal_array_5_material_string;
MCNUM priority = mccchannel_12_analyzer_2_array_crystal_array_5_priority;
MCNUM xwidth = mccchannel_12_analyzer_2_array_crystal_array_5_xwidth;
MCNUM yheight = mccchannel_12_analyzer_2_array_crystal_array_5_yheight;
MCNUM zdepth = mccchannel_12_analyzer_2_array_crystal_array_5_zdepth;
MCNUM xwidth2 = mccchannel_12_analyzer_2_array_crystal_array_5_xwidth2;
MCNUM yheight2 = mccchannel_12_analyzer_2_array_crystal_array_5_yheight2;
MCNUM visualize = mccchannel_12_analyzer_2_array_crystal_array_5_visualize;
int target_index = mccchannel_12_analyzer_2_array_crystal_array_5_target_index;
MCNUM target_x = mccchannel_12_analyzer_2_array_crystal_array_5_target_x;
MCNUM target_y = mccchannel_12_analyzer_2_array_crystal_array_5_target_y;
MCNUM target_z = mccchannel_12_analyzer_2_array_crystal_array_5_target_z;
MCNUM focus_aw = mccchannel_12_analyzer_2_array_crystal_array_5_focus_aw;
MCNUM focus_ah = mccchannel_12_analyzer_2_array_crystal_array_5_focus_ah;
MCNUM focus_xw = mccchannel_12_analyzer_2_array_crystal_array_5_focus_xw;
MCNUM focus_xh = mccchannel_12_analyzer_2_array_crystal_array_5_focus_xh;
MCNUM focus_r = mccchannel_12_analyzer_2_array_crystal_array_5_focus_r;
MCNUM p_interact = mccchannel_12_analyzer_2_array_crystal_array_5_p_interact;
char* mask_string = mccchannel_12_analyzer_2_array_crystal_array_5_mask_string;
char* mask_setting = mccchannel_12_analyzer_2_array_crystal_array_5_mask_setting;
MCNUM number_of_activations = mccchannel_12_analyzer_2_array_crystal_array_5_number_of_activations;
}   /* End of channel_12_analyzer_2_array_crystal_array_5=Union_box() SETTING parameter declarations. */
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex
  /* Label for restoring  neutron */
  mcabsorbCompchannel_12_analyzer_2_array_crystal_array_5:
  if (RESTORE) /* restore if needed */
  { RESTORE_NEUTRON(602,
      mcnlx,
      mcnly,
      mcnlz,
      mcnlvx,
      mcnlvy,
      mcnlvz,
      mcnlt,
      mcnlsx,
      mcnlsy,
      mcnlsz,
      mcnlp); }
#undef mcabsorbComp
#undef p
#undef sz
#undef sy
#undef sx
#undef t
#undef vz
#undef vy
#undef vx
#undef z
#undef y
#undef x
  mcDEBUG_STATE(
mcnlx,
mcnly,
mcnlz,
mcnlvx,
mcnlvy,
mcnlvz,
mcnlt,
mcnlsx,
mcnlsy,
mcnlsz,
mcnlp)

  /* TRACE Component channel_12_analyzer_2_array_crystal_array_6 [603] */
  mccoordschange(mcposrchannel_12_analyzer_2_array_crystal_array_6, mcrotrchannel_12_analyzer_2_array_crystal_array_6,
    &mcnlx,
    &mcnly,
    &mcnlz,
    &mcnlvx,
    &mcnlvy,
    &mcnlvz,
    &mcnlsx,
    &mcnlsy,
    &mcnlsz);
  /* define label inside component channel_12_analyzer_2_array_crystal_array_6 (without coords transformations) */
  mcJumpTrace_channel_12_analyzer_2_array_crystal_array_6:
  SIG_MESSAGE("channel_12_analyzer_2_array_crystal_array_6 (Trace)");
  mcDEBUG_COMP("channel_12_analyzer_2_array_crystal_array_6")
  mcDEBUG_STATE(
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp)
#define x mcnlx
#define y mcnly
#define z mcnlz
#define vx mcnlvx
#define vy mcnlvy
#define vz mcnlvz
#define t mcnlt
#define sx mcnlsx
#define sy mcnlsy
#define sz mcnlsz
#define p mcnlp

#define mcabsorbComp mcabsorbCompchannel_12_analyzer_2_array_crystal_array_6
  STORE_NEUTRON(603,
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp);
  mcScattered=0;
  mcRestore=0;
  mcNCounter[603]++;
  mcPCounter[603] += p;
  mcP2Counter[603] += p*p;
#define mccompcurname  channel_12_analyzer_2_array_crystal_array_6
#define mccompcurtype  Union_box
#define mccompcurindex 603
#define loop_index mccchannel_12_analyzer_2_array_crystal_array_6_loop_index
#define this_box_volume mccchannel_12_analyzer_2_array_crystal_array_6_this_box_volume
#define global_geometry_element mccchannel_12_analyzer_2_array_crystal_array_6_global_geometry_element
#define this_box_storage mccchannel_12_analyzer_2_array_crystal_array_6_this_box_storage
{   /* Declarations of channel_12_analyzer_2_array_crystal_array_6=Union_box() SETTING parameters. */
char* material_string = mccchannel_12_analyzer_2_array_crystal_array_6_material_string;
MCNUM priority = mccchannel_12_analyzer_2_array_crystal_array_6_priority;
MCNUM xwidth = mccchannel_12_analyzer_2_array_crystal_array_6_xwidth;
MCNUM yheight = mccchannel_12_analyzer_2_array_crystal_array_6_yheight;
MCNUM zdepth = mccchannel_12_analyzer_2_array_crystal_array_6_zdepth;
MCNUM xwidth2 = mccchannel_12_analyzer_2_array_crystal_array_6_xwidth2;
MCNUM yheight2 = mccchannel_12_analyzer_2_array_crystal_array_6_yheight2;
MCNUM visualize = mccchannel_12_analyzer_2_array_crystal_array_6_visualize;
int target_index = mccchannel_12_analyzer_2_array_crystal_array_6_target_index;
MCNUM target_x = mccchannel_12_analyzer_2_array_crystal_array_6_target_x;
MCNUM target_y = mccchannel_12_analyzer_2_array_crystal_array_6_target_y;
MCNUM target_z = mccchannel_12_analyzer_2_array_crystal_array_6_target_z;
MCNUM focus_aw = mccchannel_12_analyzer_2_array_crystal_array_6_focus_aw;
MCNUM focus_ah = mccchannel_12_analyzer_2_array_crystal_array_6_focus_ah;
MCNUM focus_xw = mccchannel_12_analyzer_2_array_crystal_array_6_focus_xw;
MCNUM focus_xh = mccchannel_12_analyzer_2_array_crystal_array_6_focus_xh;
MCNUM focus_r = mccchannel_12_analyzer_2_array_crystal_array_6_focus_r;
MCNUM p_interact = mccchannel_12_analyzer_2_array_crystal_array_6_p_interact;
char* mask_string = mccchannel_12_analyzer_2_array_crystal_array_6_mask_string;
char* mask_setting = mccchannel_12_analyzer_2_array_crystal_array_6_mask_setting;
MCNUM number_of_activations = mccchannel_12_analyzer_2_array_crystal_array_6_number_of_activations;
}   /* End of channel_12_analyzer_2_array_crystal_array_6=Union_box() SETTING parameter declarations. */
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex
  /* Label for restoring  neutron */
  mcabsorbCompchannel_12_analyzer_2_array_crystal_array_6:
  if (RESTORE) /* restore if needed */
  { RESTORE_NEUTRON(603,
      mcnlx,
      mcnly,
      mcnlz,
      mcnlvx,
      mcnlvy,
      mcnlvz,
      mcnlt,
      mcnlsx,
      mcnlsy,
      mcnlsz,
      mcnlp); }
#undef mcabsorbComp
#undef p
#undef sz
#undef sy
#undef sx
#undef t
#undef vz
#undef vy
#undef vx
#undef z
#undef y
#undef x
  mcDEBUG_STATE(
mcnlx,
mcnly,
mcnlz,
mcnlvx,
mcnlvy,
mcnlvz,
mcnlt,
mcnlsx,
mcnlsy,
mcnlsz,
mcnlp)

  /* TRACE Component channel_12_analyzer_2_array_crystal_array_7 [604] */
  mccoordschange(mcposrchannel_12_analyzer_2_array_crystal_array_7, mcrotrchannel_12_analyzer_2_array_crystal_array_7,
    &mcnlx,
    &mcnly,
    &mcnlz,
    &mcnlvx,
    &mcnlvy,
    &mcnlvz,
    &mcnlsx,
    &mcnlsy,
    &mcnlsz);
  /* define label inside component channel_12_analyzer_2_array_crystal_array_7 (without coords transformations) */
  mcJumpTrace_channel_12_analyzer_2_array_crystal_array_7:
  SIG_MESSAGE("channel_12_analyzer_2_array_crystal_array_7 (Trace)");
  mcDEBUG_COMP("channel_12_analyzer_2_array_crystal_array_7")
  mcDEBUG_STATE(
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp)
#define x mcnlx
#define y mcnly
#define z mcnlz
#define vx mcnlvx
#define vy mcnlvy
#define vz mcnlvz
#define t mcnlt
#define sx mcnlsx
#define sy mcnlsy
#define sz mcnlsz
#define p mcnlp

#define mcabsorbComp mcabsorbCompchannel_12_analyzer_2_array_crystal_array_7
  STORE_NEUTRON(604,
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp);
  mcScattered=0;
  mcRestore=0;
  mcNCounter[604]++;
  mcPCounter[604] += p;
  mcP2Counter[604] += p*p;
#define mccompcurname  channel_12_analyzer_2_array_crystal_array_7
#define mccompcurtype  Union_box
#define mccompcurindex 604
#define loop_index mccchannel_12_analyzer_2_array_crystal_array_7_loop_index
#define this_box_volume mccchannel_12_analyzer_2_array_crystal_array_7_this_box_volume
#define global_geometry_element mccchannel_12_analyzer_2_array_crystal_array_7_global_geometry_element
#define this_box_storage mccchannel_12_analyzer_2_array_crystal_array_7_this_box_storage
{   /* Declarations of channel_12_analyzer_2_array_crystal_array_7=Union_box() SETTING parameters. */
char* material_string = mccchannel_12_analyzer_2_array_crystal_array_7_material_string;
MCNUM priority = mccchannel_12_analyzer_2_array_crystal_array_7_priority;
MCNUM xwidth = mccchannel_12_analyzer_2_array_crystal_array_7_xwidth;
MCNUM yheight = mccchannel_12_analyzer_2_array_crystal_array_7_yheight;
MCNUM zdepth = mccchannel_12_analyzer_2_array_crystal_array_7_zdepth;
MCNUM xwidth2 = mccchannel_12_analyzer_2_array_crystal_array_7_xwidth2;
MCNUM yheight2 = mccchannel_12_analyzer_2_array_crystal_array_7_yheight2;
MCNUM visualize = mccchannel_12_analyzer_2_array_crystal_array_7_visualize;
int target_index = mccchannel_12_analyzer_2_array_crystal_array_7_target_index;
MCNUM target_x = mccchannel_12_analyzer_2_array_crystal_array_7_target_x;
MCNUM target_y = mccchannel_12_analyzer_2_array_crystal_array_7_target_y;
MCNUM target_z = mccchannel_12_analyzer_2_array_crystal_array_7_target_z;
MCNUM focus_aw = mccchannel_12_analyzer_2_array_crystal_array_7_focus_aw;
MCNUM focus_ah = mccchannel_12_analyzer_2_array_crystal_array_7_focus_ah;
MCNUM focus_xw = mccchannel_12_analyzer_2_array_crystal_array_7_focus_xw;
MCNUM focus_xh = mccchannel_12_analyzer_2_array_crystal_array_7_focus_xh;
MCNUM focus_r = mccchannel_12_analyzer_2_array_crystal_array_7_focus_r;
MCNUM p_interact = mccchannel_12_analyzer_2_array_crystal_array_7_p_interact;
char* mask_string = mccchannel_12_analyzer_2_array_crystal_array_7_mask_string;
char* mask_setting = mccchannel_12_analyzer_2_array_crystal_array_7_mask_setting;
MCNUM number_of_activations = mccchannel_12_analyzer_2_array_crystal_array_7_number_of_activations;
}   /* End of channel_12_analyzer_2_array_crystal_array_7=Union_box() SETTING parameter declarations. */
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex
  /* Label for restoring  neutron */
  mcabsorbCompchannel_12_analyzer_2_array_crystal_array_7:
  if (RESTORE) /* restore if needed */
  { RESTORE_NEUTRON(604,
      mcnlx,
      mcnly,
      mcnlz,
      mcnlvx,
      mcnlvy,
      mcnlvz,
      mcnlt,
      mcnlsx,
      mcnlsy,
      mcnlsz,
      mcnlp); }
#undef mcabsorbComp
#undef p
#undef sz
#undef sy
#undef sx
#undef t
#undef vz
#undef vy
#undef vx
#undef z
#undef y
#undef x
  mcDEBUG_STATE(
mcnlx,
mcnly,
mcnlz,
mcnlvx,
mcnlvy,
mcnlvz,
mcnlt,
mcnlsx,
mcnlsy,
mcnlsz,
mcnlp)

  /* TRACE Component channel_12_analyzer_2_array_crystal_array_8 [605] */
  mccoordschange(mcposrchannel_12_analyzer_2_array_crystal_array_8, mcrotrchannel_12_analyzer_2_array_crystal_array_8,
    &mcnlx,
    &mcnly,
    &mcnlz,
    &mcnlvx,
    &mcnlvy,
    &mcnlvz,
    &mcnlsx,
    &mcnlsy,
    &mcnlsz);
  /* define label inside component channel_12_analyzer_2_array_crystal_array_8 (without coords transformations) */
  mcJumpTrace_channel_12_analyzer_2_array_crystal_array_8:
  SIG_MESSAGE("channel_12_analyzer_2_array_crystal_array_8 (Trace)");
  mcDEBUG_COMP("channel_12_analyzer_2_array_crystal_array_8")
  mcDEBUG_STATE(
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp)
#define x mcnlx
#define y mcnly
#define z mcnlz
#define vx mcnlvx
#define vy mcnlvy
#define vz mcnlvz
#define t mcnlt
#define sx mcnlsx
#define sy mcnlsy
#define sz mcnlsz
#define p mcnlp

#define mcabsorbComp mcabsorbCompchannel_12_analyzer_2_array_crystal_array_8
  STORE_NEUTRON(605,
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp);
  mcScattered=0;
  mcRestore=0;
  mcNCounter[605]++;
  mcPCounter[605] += p;
  mcP2Counter[605] += p*p;
#define mccompcurname  channel_12_analyzer_2_array_crystal_array_8
#define mccompcurtype  Union_box
#define mccompcurindex 605
#define loop_index mccchannel_12_analyzer_2_array_crystal_array_8_loop_index
#define this_box_volume mccchannel_12_analyzer_2_array_crystal_array_8_this_box_volume
#define global_geometry_element mccchannel_12_analyzer_2_array_crystal_array_8_global_geometry_element
#define this_box_storage mccchannel_12_analyzer_2_array_crystal_array_8_this_box_storage
{   /* Declarations of channel_12_analyzer_2_array_crystal_array_8=Union_box() SETTING parameters. */
char* material_string = mccchannel_12_analyzer_2_array_crystal_array_8_material_string;
MCNUM priority = mccchannel_12_analyzer_2_array_crystal_array_8_priority;
MCNUM xwidth = mccchannel_12_analyzer_2_array_crystal_array_8_xwidth;
MCNUM yheight = mccchannel_12_analyzer_2_array_crystal_array_8_yheight;
MCNUM zdepth = mccchannel_12_analyzer_2_array_crystal_array_8_zdepth;
MCNUM xwidth2 = mccchannel_12_analyzer_2_array_crystal_array_8_xwidth2;
MCNUM yheight2 = mccchannel_12_analyzer_2_array_crystal_array_8_yheight2;
MCNUM visualize = mccchannel_12_analyzer_2_array_crystal_array_8_visualize;
int target_index = mccchannel_12_analyzer_2_array_crystal_array_8_target_index;
MCNUM target_x = mccchannel_12_analyzer_2_array_crystal_array_8_target_x;
MCNUM target_y = mccchannel_12_analyzer_2_array_crystal_array_8_target_y;
MCNUM target_z = mccchannel_12_analyzer_2_array_crystal_array_8_target_z;
MCNUM focus_aw = mccchannel_12_analyzer_2_array_crystal_array_8_focus_aw;
MCNUM focus_ah = mccchannel_12_analyzer_2_array_crystal_array_8_focus_ah;
MCNUM focus_xw = mccchannel_12_analyzer_2_array_crystal_array_8_focus_xw;
MCNUM focus_xh = mccchannel_12_analyzer_2_array_crystal_array_8_focus_xh;
MCNUM focus_r = mccchannel_12_analyzer_2_array_crystal_array_8_focus_r;
MCNUM p_interact = mccchannel_12_analyzer_2_array_crystal_array_8_p_interact;
char* mask_string = mccchannel_12_analyzer_2_array_crystal_array_8_mask_string;
char* mask_setting = mccchannel_12_analyzer_2_array_crystal_array_8_mask_setting;
MCNUM number_of_activations = mccchannel_12_analyzer_2_array_crystal_array_8_number_of_activations;
}   /* End of channel_12_analyzer_2_array_crystal_array_8=Union_box() SETTING parameter declarations. */
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex
  /* Label for restoring  neutron */
  mcabsorbCompchannel_12_analyzer_2_array_crystal_array_8:
  if (RESTORE) /* restore if needed */
  { RESTORE_NEUTRON(605,
      mcnlx,
      mcnly,
      mcnlz,
      mcnlvx,
      mcnlvy,
      mcnlvz,
      mcnlt,
      mcnlsx,
      mcnlsy,
      mcnlsz,
      mcnlp); }
#undef mcabsorbComp
#undef p
#undef sz
#undef sy
#undef sx
#undef t
#undef vz
#undef vy
#undef vx
#undef z
#undef y
#undef x
  mcDEBUG_STATE(
mcnlx,
mcnly,
mcnlz,
mcnlvx,
mcnlvy,
mcnlvz,
mcnlt,
mcnlsx,
mcnlsy,
mcnlsz,
mcnlp)

  /* TRACE Component channel_12_cave2_cyl1 [606] */
  mccoordschange(mcposrchannel_12_cave2_cyl1, mcrotrchannel_12_cave2_cyl1,
    &mcnlx,
    &mcnly,
    &mcnlz,
    &mcnlvx,
    &mcnlvy,
    &mcnlvz,
    &mcnlsx,
    &mcnlsy,
    &mcnlsz);
  /* define label inside component channel_12_cave2_cyl1 (without coords transformations) */
  mcJumpTrace_channel_12_cave2_cyl1:
  SIG_MESSAGE("channel_12_cave2_cyl1 (Trace)");
  mcDEBUG_COMP("channel_12_cave2_cyl1")
  mcDEBUG_STATE(
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp)
#define x mcnlx
#define y mcnly
#define z mcnlz
#define vx mcnlvx
#define vy mcnlvy
#define vz mcnlvz
#define t mcnlt
#define sx mcnlsx
#define sy mcnlsy
#define sz mcnlsz
#define p mcnlp

#define mcabsorbComp mcabsorbCompchannel_12_cave2_cyl1
  STORE_NEUTRON(606,
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp);
  mcScattered=0;
  mcRestore=0;
  mcNCounter[606]++;
  mcPCounter[606] += p;
  mcP2Counter[606] += p*p;
#define mccompcurname  channel_12_cave2_cyl1
#define mccompcurtype  Union_cylinder
#define mccompcurindex 606
#define loop_index mccchannel_12_cave2_cyl1_loop_index
#define this_cylinder_volume mccchannel_12_cave2_cyl1_this_cylinder_volume
#define global_geometry_element mccchannel_12_cave2_cyl1_global_geometry_element
#define this_cylinder_storage mccchannel_12_cave2_cyl1_this_cylinder_storage
{   /* Declarations of channel_12_cave2_cyl1=Union_cylinder() SETTING parameters. */
char* material_string = mccchannel_12_cave2_cyl1_material_string;
MCNUM priority = mccchannel_12_cave2_cyl1_priority;
MCNUM radius = mccchannel_12_cave2_cyl1_radius;
MCNUM yheight = mccchannel_12_cave2_cyl1_yheight;
MCNUM visualize = mccchannel_12_cave2_cyl1_visualize;
int target_index = mccchannel_12_cave2_cyl1_target_index;
MCNUM target_x = mccchannel_12_cave2_cyl1_target_x;
MCNUM target_y = mccchannel_12_cave2_cyl1_target_y;
MCNUM target_z = mccchannel_12_cave2_cyl1_target_z;
MCNUM focus_aw = mccchannel_12_cave2_cyl1_focus_aw;
MCNUM focus_ah = mccchannel_12_cave2_cyl1_focus_ah;
MCNUM focus_xw = mccchannel_12_cave2_cyl1_focus_xw;
MCNUM focus_xh = mccchannel_12_cave2_cyl1_focus_xh;
MCNUM focus_r = mccchannel_12_cave2_cyl1_focus_r;
MCNUM p_interact = mccchannel_12_cave2_cyl1_p_interact;
char* mask_string = mccchannel_12_cave2_cyl1_mask_string;
char* mask_setting = mccchannel_12_cave2_cyl1_mask_setting;
MCNUM number_of_activations = mccchannel_12_cave2_cyl1_number_of_activations;
#line 345 "Union_cylinder.comp"
{
dummy = 1;
}
#line 425310 "MACS_sample_kidney_box.c"
}   /* End of channel_12_cave2_cyl1=Union_cylinder() SETTING parameter declarations. */
#undef this_cylinder_storage
#undef global_geometry_element
#undef this_cylinder_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex
  /* Label for restoring  neutron */
  mcabsorbCompchannel_12_cave2_cyl1:
  if (RESTORE) /* restore if needed */
  { RESTORE_NEUTRON(606,
      mcnlx,
      mcnly,
      mcnlz,
      mcnlvx,
      mcnlvy,
      mcnlvz,
      mcnlt,
      mcnlsx,
      mcnlsy,
      mcnlsz,
      mcnlp); }
#undef mcabsorbComp
#undef p
#undef sz
#undef sy
#undef sx
#undef t
#undef vz
#undef vy
#undef vx
#undef z
#undef y
#undef x
  mcDEBUG_STATE(
mcnlx,
mcnly,
mcnlz,
mcnlvx,
mcnlvy,
mcnlvz,
mcnlt,
mcnlsx,
mcnlsy,
mcnlsz,
mcnlp)

  /* TRACE Component channel_12_cave2_box1 [607] */
  mccoordschange(mcposrchannel_12_cave2_box1, mcrotrchannel_12_cave2_box1,
    &mcnlx,
    &mcnly,
    &mcnlz,
    &mcnlvx,
    &mcnlvy,
    &mcnlvz,
    &mcnlsx,
    &mcnlsy,
    &mcnlsz);
  /* define label inside component channel_12_cave2_box1 (without coords transformations) */
  mcJumpTrace_channel_12_cave2_box1:
  SIG_MESSAGE("channel_12_cave2_box1 (Trace)");
  mcDEBUG_COMP("channel_12_cave2_box1")
  mcDEBUG_STATE(
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp)
#define x mcnlx
#define y mcnly
#define z mcnlz
#define vx mcnlvx
#define vy mcnlvy
#define vz mcnlvz
#define t mcnlt
#define sx mcnlsx
#define sy mcnlsy
#define sz mcnlsz
#define p mcnlp

#define mcabsorbComp mcabsorbCompchannel_12_cave2_box1
  STORE_NEUTRON(607,
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp);
  mcScattered=0;
  mcRestore=0;
  mcNCounter[607]++;
  mcPCounter[607] += p;
  mcP2Counter[607] += p*p;
#define mccompcurname  channel_12_cave2_box1
#define mccompcurtype  Union_box
#define mccompcurindex 607
#define loop_index mccchannel_12_cave2_box1_loop_index
#define this_box_volume mccchannel_12_cave2_box1_this_box_volume
#define global_geometry_element mccchannel_12_cave2_box1_global_geometry_element
#define this_box_storage mccchannel_12_cave2_box1_this_box_storage
{   /* Declarations of channel_12_cave2_box1=Union_box() SETTING parameters. */
char* material_string = mccchannel_12_cave2_box1_material_string;
MCNUM priority = mccchannel_12_cave2_box1_priority;
MCNUM xwidth = mccchannel_12_cave2_box1_xwidth;
MCNUM yheight = mccchannel_12_cave2_box1_yheight;
MCNUM zdepth = mccchannel_12_cave2_box1_zdepth;
MCNUM xwidth2 = mccchannel_12_cave2_box1_xwidth2;
MCNUM yheight2 = mccchannel_12_cave2_box1_yheight2;
MCNUM visualize = mccchannel_12_cave2_box1_visualize;
int target_index = mccchannel_12_cave2_box1_target_index;
MCNUM target_x = mccchannel_12_cave2_box1_target_x;
MCNUM target_y = mccchannel_12_cave2_box1_target_y;
MCNUM target_z = mccchannel_12_cave2_box1_target_z;
MCNUM focus_aw = mccchannel_12_cave2_box1_focus_aw;
MCNUM focus_ah = mccchannel_12_cave2_box1_focus_ah;
MCNUM focus_xw = mccchannel_12_cave2_box1_focus_xw;
MCNUM focus_xh = mccchannel_12_cave2_box1_focus_xh;
MCNUM focus_r = mccchannel_12_cave2_box1_focus_r;
MCNUM p_interact = mccchannel_12_cave2_box1_p_interact;
char* mask_string = mccchannel_12_cave2_box1_mask_string;
char* mask_setting = mccchannel_12_cave2_box1_mask_setting;
MCNUM number_of_activations = mccchannel_12_cave2_box1_number_of_activations;
}   /* End of channel_12_cave2_box1=Union_box() SETTING parameter declarations. */
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex
  /* Label for restoring  neutron */
  mcabsorbCompchannel_12_cave2_box1:
  if (RESTORE) /* restore if needed */
  { RESTORE_NEUTRON(607,
      mcnlx,
      mcnly,
      mcnlz,
      mcnlvx,
      mcnlvy,
      mcnlvz,
      mcnlt,
      mcnlsx,
      mcnlsy,
      mcnlsz,
      mcnlp); }
#undef mcabsorbComp
#undef p
#undef sz
#undef sy
#undef sx
#undef t
#undef vz
#undef vy
#undef vx
#undef z
#undef y
#undef x
  mcDEBUG_STATE(
mcnlx,
mcnly,
mcnlz,
mcnlvx,
mcnlvy,
mcnlvz,
mcnlt,
mcnlsx,
mcnlsy,
mcnlsz,
mcnlp)

  /* TRACE Component channel_12_cave2_box2 [608] */
  mccoordschange(mcposrchannel_12_cave2_box2, mcrotrchannel_12_cave2_box2,
    &mcnlx,
    &mcnly,
    &mcnlz,
    &mcnlvx,
    &mcnlvy,
    &mcnlvz,
    &mcnlsx,
    &mcnlsy,
    &mcnlsz);
  /* define label inside component channel_12_cave2_box2 (without coords transformations) */
  mcJumpTrace_channel_12_cave2_box2:
  SIG_MESSAGE("channel_12_cave2_box2 (Trace)");
  mcDEBUG_COMP("channel_12_cave2_box2")
  mcDEBUG_STATE(
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp)
#define x mcnlx
#define y mcnly
#define z mcnlz
#define vx mcnlvx
#define vy mcnlvy
#define vz mcnlvz
#define t mcnlt
#define sx mcnlsx
#define sy mcnlsy
#define sz mcnlsz
#define p mcnlp

#define mcabsorbComp mcabsorbCompchannel_12_cave2_box2
  STORE_NEUTRON(608,
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp);
  mcScattered=0;
  mcRestore=0;
  mcNCounter[608]++;
  mcPCounter[608] += p;
  mcP2Counter[608] += p*p;
#define mccompcurname  channel_12_cave2_box2
#define mccompcurtype  Union_box
#define mccompcurindex 608
#define loop_index mccchannel_12_cave2_box2_loop_index
#define this_box_volume mccchannel_12_cave2_box2_this_box_volume
#define global_geometry_element mccchannel_12_cave2_box2_global_geometry_element
#define this_box_storage mccchannel_12_cave2_box2_this_box_storage
{   /* Declarations of channel_12_cave2_box2=Union_box() SETTING parameters. */
char* material_string = mccchannel_12_cave2_box2_material_string;
MCNUM priority = mccchannel_12_cave2_box2_priority;
MCNUM xwidth = mccchannel_12_cave2_box2_xwidth;
MCNUM yheight = mccchannel_12_cave2_box2_yheight;
MCNUM zdepth = mccchannel_12_cave2_box2_zdepth;
MCNUM xwidth2 = mccchannel_12_cave2_box2_xwidth2;
MCNUM yheight2 = mccchannel_12_cave2_box2_yheight2;
MCNUM visualize = mccchannel_12_cave2_box2_visualize;
int target_index = mccchannel_12_cave2_box2_target_index;
MCNUM target_x = mccchannel_12_cave2_box2_target_x;
MCNUM target_y = mccchannel_12_cave2_box2_target_y;
MCNUM target_z = mccchannel_12_cave2_box2_target_z;
MCNUM focus_aw = mccchannel_12_cave2_box2_focus_aw;
MCNUM focus_ah = mccchannel_12_cave2_box2_focus_ah;
MCNUM focus_xw = mccchannel_12_cave2_box2_focus_xw;
MCNUM focus_xh = mccchannel_12_cave2_box2_focus_xh;
MCNUM focus_r = mccchannel_12_cave2_box2_focus_r;
MCNUM p_interact = mccchannel_12_cave2_box2_p_interact;
char* mask_string = mccchannel_12_cave2_box2_mask_string;
char* mask_setting = mccchannel_12_cave2_box2_mask_setting;
MCNUM number_of_activations = mccchannel_12_cave2_box2_number_of_activations;
}   /* End of channel_12_cave2_box2=Union_box() SETTING parameter declarations. */
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex
  /* Label for restoring  neutron */
  mcabsorbCompchannel_12_cave2_box2:
  if (RESTORE) /* restore if needed */
  { RESTORE_NEUTRON(608,
      mcnlx,
      mcnly,
      mcnlz,
      mcnlvx,
      mcnlvy,
      mcnlvz,
      mcnlt,
      mcnlsx,
      mcnlsy,
      mcnlsz,
      mcnlp); }
#undef mcabsorbComp
#undef p
#undef sz
#undef sy
#undef sx
#undef t
#undef vz
#undef vy
#undef vx
#undef z
#undef y
#undef x
  mcDEBUG_STATE(
mcnlx,
mcnly,
mcnlz,
mcnlvx,
mcnlvy,
mcnlvz,
mcnlt,
mcnlsx,
mcnlsy,
mcnlsz,
mcnlp)

  /* TRACE Component channel_12_cave2_box3 [609] */
  mccoordschange(mcposrchannel_12_cave2_box3, mcrotrchannel_12_cave2_box3,
    &mcnlx,
    &mcnly,
    &mcnlz,
    &mcnlvx,
    &mcnlvy,
    &mcnlvz,
    &mcnlsx,
    &mcnlsy,
    &mcnlsz);
  /* define label inside component channel_12_cave2_box3 (without coords transformations) */
  mcJumpTrace_channel_12_cave2_box3:
  SIG_MESSAGE("channel_12_cave2_box3 (Trace)");
  mcDEBUG_COMP("channel_12_cave2_box3")
  mcDEBUG_STATE(
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp)
#define x mcnlx
#define y mcnly
#define z mcnlz
#define vx mcnlvx
#define vy mcnlvy
#define vz mcnlvz
#define t mcnlt
#define sx mcnlsx
#define sy mcnlsy
#define sz mcnlsz
#define p mcnlp

#define mcabsorbComp mcabsorbCompchannel_12_cave2_box3
  STORE_NEUTRON(609,
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp);
  mcScattered=0;
  mcRestore=0;
  mcNCounter[609]++;
  mcPCounter[609] += p;
  mcP2Counter[609] += p*p;
#define mccompcurname  channel_12_cave2_box3
#define mccompcurtype  Union_box
#define mccompcurindex 609
#define loop_index mccchannel_12_cave2_box3_loop_index
#define this_box_volume mccchannel_12_cave2_box3_this_box_volume
#define global_geometry_element mccchannel_12_cave2_box3_global_geometry_element
#define this_box_storage mccchannel_12_cave2_box3_this_box_storage
{   /* Declarations of channel_12_cave2_box3=Union_box() SETTING parameters. */
char* material_string = mccchannel_12_cave2_box3_material_string;
MCNUM priority = mccchannel_12_cave2_box3_priority;
MCNUM xwidth = mccchannel_12_cave2_box3_xwidth;
MCNUM yheight = mccchannel_12_cave2_box3_yheight;
MCNUM zdepth = mccchannel_12_cave2_box3_zdepth;
MCNUM xwidth2 = mccchannel_12_cave2_box3_xwidth2;
MCNUM yheight2 = mccchannel_12_cave2_box3_yheight2;
MCNUM visualize = mccchannel_12_cave2_box3_visualize;
int target_index = mccchannel_12_cave2_box3_target_index;
MCNUM target_x = mccchannel_12_cave2_box3_target_x;
MCNUM target_y = mccchannel_12_cave2_box3_target_y;
MCNUM target_z = mccchannel_12_cave2_box3_target_z;
MCNUM focus_aw = mccchannel_12_cave2_box3_focus_aw;
MCNUM focus_ah = mccchannel_12_cave2_box3_focus_ah;
MCNUM focus_xw = mccchannel_12_cave2_box3_focus_xw;
MCNUM focus_xh = mccchannel_12_cave2_box3_focus_xh;
MCNUM focus_r = mccchannel_12_cave2_box3_focus_r;
MCNUM p_interact = mccchannel_12_cave2_box3_p_interact;
char* mask_string = mccchannel_12_cave2_box3_mask_string;
char* mask_setting = mccchannel_12_cave2_box3_mask_setting;
MCNUM number_of_activations = mccchannel_12_cave2_box3_number_of_activations;
}   /* End of channel_12_cave2_box3=Union_box() SETTING parameter declarations. */
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex
  /* Label for restoring  neutron */
  mcabsorbCompchannel_12_cave2_box3:
  if (RESTORE) /* restore if needed */
  { RESTORE_NEUTRON(609,
      mcnlx,
      mcnly,
      mcnlz,
      mcnlvx,
      mcnlvy,
      mcnlvz,
      mcnlt,
      mcnlsx,
      mcnlsy,
      mcnlsz,
      mcnlp); }
#undef mcabsorbComp
#undef p
#undef sz
#undef sy
#undef sx
#undef t
#undef vz
#undef vy
#undef vx
#undef z
#undef y
#undef x
  mcDEBUG_STATE(
mcnlx,
mcnly,
mcnlz,
mcnlvx,
mcnlvy,
mcnlvz,
mcnlt,
mcnlsx,
mcnlsy,
mcnlsz,
mcnlp)

  /* TRACE Component inter_analyzer_colimator_center_12 [610] */
  mccoordschange(mcposrinter_analyzer_colimator_center_12, mcrotrinter_analyzer_colimator_center_12,
    &mcnlx,
    &mcnly,
    &mcnlz,
    &mcnlvx,
    &mcnlvy,
    &mcnlvz,
    &mcnlsx,
    &mcnlsy,
    &mcnlsz);
  /* define label inside component inter_analyzer_colimator_center_12 (without coords transformations) */
  mcJumpTrace_inter_analyzer_colimator_center_12:
  SIG_MESSAGE("inter_analyzer_colimator_center_12 (Trace)");
  mcDEBUG_COMP("inter_analyzer_colimator_center_12")
  mcDEBUG_STATE(
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp)
#define x mcnlx
#define y mcnly
#define z mcnlz
#define vx mcnlvx
#define vy mcnlvy
#define vz mcnlvz
#define t mcnlt
#define sx mcnlsx
#define sy mcnlsy
#define sz mcnlsz
#define p mcnlp

#define mcabsorbComp mcabsorbCompinter_analyzer_colimator_center_12
  STORE_NEUTRON(610,
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp);
  mcScattered=0;
  mcRestore=0;
  mcNCounter[610]++;
  mcPCounter[610] += p;
  mcP2Counter[610] += p*p;
#define mccompcurname  inter_analyzer_colimator_center_12
#define mccompcurtype  Arm
#define mccompcurindex 610
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex
  /* Label for restoring  neutron */
  mcabsorbCompinter_analyzer_colimator_center_12:
  if (RESTORE) /* restore if needed */
  { RESTORE_NEUTRON(610,
      mcnlx,
      mcnly,
      mcnlz,
      mcnlvx,
      mcnlvy,
      mcnlvz,
      mcnlt,
      mcnlsx,
      mcnlsy,
      mcnlsz,
      mcnlp); }
#undef mcabsorbComp
#undef p
#undef sz
#undef sy
#undef sx
#undef t
#undef vz
#undef vy
#undef vx
#undef z
#undef y
#undef x
  mcDEBUG_STATE(
mcnlx,
mcnly,
mcnlz,
mcnlvx,
mcnlvy,
mcnlvz,
mcnlt,
mcnlsx,
mcnlsy,
mcnlsz,
mcnlp)

  /* TRACE Component inter_analyzer_colimator_12_blade_0 [611] */
  mccoordschange(mcposrinter_analyzer_colimator_12_blade_0, mcrotrinter_analyzer_colimator_12_blade_0,
    &mcnlx,
    &mcnly,
    &mcnlz,
    &mcnlvx,
    &mcnlvy,
    &mcnlvz,
    &mcnlsx,
    &mcnlsy,
    &mcnlsz);
  /* define label inside component inter_analyzer_colimator_12_blade_0 (without coords transformations) */
  mcJumpTrace_inter_analyzer_colimator_12_blade_0:
  SIG_MESSAGE("inter_analyzer_colimator_12_blade_0 (Trace)");
  mcDEBUG_COMP("inter_analyzer_colimator_12_blade_0")
  mcDEBUG_STATE(
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp)
#define x mcnlx
#define y mcnly
#define z mcnlz
#define vx mcnlvx
#define vy mcnlvy
#define vz mcnlvz
#define t mcnlt
#define sx mcnlsx
#define sy mcnlsy
#define sz mcnlsz
#define p mcnlp

#define mcabsorbComp mcabsorbCompinter_analyzer_colimator_12_blade_0
  STORE_NEUTRON(611,
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp);
  mcScattered=0;
  mcRestore=0;
  mcNCounter[611]++;
  mcPCounter[611] += p;
  mcP2Counter[611] += p*p;
#define mccompcurname  inter_analyzer_colimator_12_blade_0
#define mccompcurtype  Union_box
#define mccompcurindex 611
#define loop_index mccinter_analyzer_colimator_12_blade_0_loop_index
#define this_box_volume mccinter_analyzer_colimator_12_blade_0_this_box_volume
#define global_geometry_element mccinter_analyzer_colimator_12_blade_0_global_geometry_element
#define this_box_storage mccinter_analyzer_colimator_12_blade_0_this_box_storage
{   /* Declarations of inter_analyzer_colimator_12_blade_0=Union_box() SETTING parameters. */
char* material_string = mccinter_analyzer_colimator_12_blade_0_material_string;
MCNUM priority = mccinter_analyzer_colimator_12_blade_0_priority;
MCNUM xwidth = mccinter_analyzer_colimator_12_blade_0_xwidth;
MCNUM yheight = mccinter_analyzer_colimator_12_blade_0_yheight;
MCNUM zdepth = mccinter_analyzer_colimator_12_blade_0_zdepth;
MCNUM xwidth2 = mccinter_analyzer_colimator_12_blade_0_xwidth2;
MCNUM yheight2 = mccinter_analyzer_colimator_12_blade_0_yheight2;
MCNUM visualize = mccinter_analyzer_colimator_12_blade_0_visualize;
int target_index = mccinter_analyzer_colimator_12_blade_0_target_index;
MCNUM target_x = mccinter_analyzer_colimator_12_blade_0_target_x;
MCNUM target_y = mccinter_analyzer_colimator_12_blade_0_target_y;
MCNUM target_z = mccinter_analyzer_colimator_12_blade_0_target_z;
MCNUM focus_aw = mccinter_analyzer_colimator_12_blade_0_focus_aw;
MCNUM focus_ah = mccinter_analyzer_colimator_12_blade_0_focus_ah;
MCNUM focus_xw = mccinter_analyzer_colimator_12_blade_0_focus_xw;
MCNUM focus_xh = mccinter_analyzer_colimator_12_blade_0_focus_xh;
MCNUM focus_r = mccinter_analyzer_colimator_12_blade_0_focus_r;
MCNUM p_interact = mccinter_analyzer_colimator_12_blade_0_p_interact;
char* mask_string = mccinter_analyzer_colimator_12_blade_0_mask_string;
char* mask_setting = mccinter_analyzer_colimator_12_blade_0_mask_setting;
MCNUM number_of_activations = mccinter_analyzer_colimator_12_blade_0_number_of_activations;
}   /* End of inter_analyzer_colimator_12_blade_0=Union_box() SETTING parameter declarations. */
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex
  /* Label for restoring  neutron */
  mcabsorbCompinter_analyzer_colimator_12_blade_0:
  if (RESTORE) /* restore if needed */
  { RESTORE_NEUTRON(611,
      mcnlx,
      mcnly,
      mcnlz,
      mcnlvx,
      mcnlvy,
      mcnlvz,
      mcnlt,
      mcnlsx,
      mcnlsy,
      mcnlsz,
      mcnlp); }
#undef mcabsorbComp
#undef p
#undef sz
#undef sy
#undef sx
#undef t
#undef vz
#undef vy
#undef vx
#undef z
#undef y
#undef x
  mcDEBUG_STATE(
mcnlx,
mcnly,
mcnlz,
mcnlvx,
mcnlvy,
mcnlvz,
mcnlt,
mcnlsx,
mcnlsy,
mcnlsz,
mcnlp)

  /* TRACE Component inter_analyzer_colimator_12_blade_1 [612] */
  mccoordschange(mcposrinter_analyzer_colimator_12_blade_1, mcrotrinter_analyzer_colimator_12_blade_1,
    &mcnlx,
    &mcnly,
    &mcnlz,
    &mcnlvx,
    &mcnlvy,
    &mcnlvz,
    &mcnlsx,
    &mcnlsy,
    &mcnlsz);
  /* define label inside component inter_analyzer_colimator_12_blade_1 (without coords transformations) */
  mcJumpTrace_inter_analyzer_colimator_12_blade_1:
  SIG_MESSAGE("inter_analyzer_colimator_12_blade_1 (Trace)");
  mcDEBUG_COMP("inter_analyzer_colimator_12_blade_1")
  mcDEBUG_STATE(
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp)
#define x mcnlx
#define y mcnly
#define z mcnlz
#define vx mcnlvx
#define vy mcnlvy
#define vz mcnlvz
#define t mcnlt
#define sx mcnlsx
#define sy mcnlsy
#define sz mcnlsz
#define p mcnlp

#define mcabsorbComp mcabsorbCompinter_analyzer_colimator_12_blade_1
  STORE_NEUTRON(612,
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp);
  mcScattered=0;
  mcRestore=0;
  mcNCounter[612]++;
  mcPCounter[612] += p;
  mcP2Counter[612] += p*p;
#define mccompcurname  inter_analyzer_colimator_12_blade_1
#define mccompcurtype  Union_box
#define mccompcurindex 612
#define loop_index mccinter_analyzer_colimator_12_blade_1_loop_index
#define this_box_volume mccinter_analyzer_colimator_12_blade_1_this_box_volume
#define global_geometry_element mccinter_analyzer_colimator_12_blade_1_global_geometry_element
#define this_box_storage mccinter_analyzer_colimator_12_blade_1_this_box_storage
{   /* Declarations of inter_analyzer_colimator_12_blade_1=Union_box() SETTING parameters. */
char* material_string = mccinter_analyzer_colimator_12_blade_1_material_string;
MCNUM priority = mccinter_analyzer_colimator_12_blade_1_priority;
MCNUM xwidth = mccinter_analyzer_colimator_12_blade_1_xwidth;
MCNUM yheight = mccinter_analyzer_colimator_12_blade_1_yheight;
MCNUM zdepth = mccinter_analyzer_colimator_12_blade_1_zdepth;
MCNUM xwidth2 = mccinter_analyzer_colimator_12_blade_1_xwidth2;
MCNUM yheight2 = mccinter_analyzer_colimator_12_blade_1_yheight2;
MCNUM visualize = mccinter_analyzer_colimator_12_blade_1_visualize;
int target_index = mccinter_analyzer_colimator_12_blade_1_target_index;
MCNUM target_x = mccinter_analyzer_colimator_12_blade_1_target_x;
MCNUM target_y = mccinter_analyzer_colimator_12_blade_1_target_y;
MCNUM target_z = mccinter_analyzer_colimator_12_blade_1_target_z;
MCNUM focus_aw = mccinter_analyzer_colimator_12_blade_1_focus_aw;
MCNUM focus_ah = mccinter_analyzer_colimator_12_blade_1_focus_ah;
MCNUM focus_xw = mccinter_analyzer_colimator_12_blade_1_focus_xw;
MCNUM focus_xh = mccinter_analyzer_colimator_12_blade_1_focus_xh;
MCNUM focus_r = mccinter_analyzer_colimator_12_blade_1_focus_r;
MCNUM p_interact = mccinter_analyzer_colimator_12_blade_1_p_interact;
char* mask_string = mccinter_analyzer_colimator_12_blade_1_mask_string;
char* mask_setting = mccinter_analyzer_colimator_12_blade_1_mask_setting;
MCNUM number_of_activations = mccinter_analyzer_colimator_12_blade_1_number_of_activations;
}   /* End of inter_analyzer_colimator_12_blade_1=Union_box() SETTING parameter declarations. */
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex
  /* Label for restoring  neutron */
  mcabsorbCompinter_analyzer_colimator_12_blade_1:
  if (RESTORE) /* restore if needed */
  { RESTORE_NEUTRON(612,
      mcnlx,
      mcnly,
      mcnlz,
      mcnlvx,
      mcnlvy,
      mcnlvz,
      mcnlt,
      mcnlsx,
      mcnlsy,
      mcnlsz,
      mcnlp); }
#undef mcabsorbComp
#undef p
#undef sz
#undef sy
#undef sx
#undef t
#undef vz
#undef vy
#undef vx
#undef z
#undef y
#undef x
  mcDEBUG_STATE(
mcnlx,
mcnly,
mcnlz,
mcnlvx,
mcnlvy,
mcnlvz,
mcnlt,
mcnlsx,
mcnlsy,
mcnlsz,
mcnlp)

  /* TRACE Component inter_analyzer_colimator_12_blade_2 [613] */
  mccoordschange(mcposrinter_analyzer_colimator_12_blade_2, mcrotrinter_analyzer_colimator_12_blade_2,
    &mcnlx,
    &mcnly,
    &mcnlz,
    &mcnlvx,
    &mcnlvy,
    &mcnlvz,
    &mcnlsx,
    &mcnlsy,
    &mcnlsz);
  /* define label inside component inter_analyzer_colimator_12_blade_2 (without coords transformations) */
  mcJumpTrace_inter_analyzer_colimator_12_blade_2:
  SIG_MESSAGE("inter_analyzer_colimator_12_blade_2 (Trace)");
  mcDEBUG_COMP("inter_analyzer_colimator_12_blade_2")
  mcDEBUG_STATE(
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp)
#define x mcnlx
#define y mcnly
#define z mcnlz
#define vx mcnlvx
#define vy mcnlvy
#define vz mcnlvz
#define t mcnlt
#define sx mcnlsx
#define sy mcnlsy
#define sz mcnlsz
#define p mcnlp

#define mcabsorbComp mcabsorbCompinter_analyzer_colimator_12_blade_2
  STORE_NEUTRON(613,
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp);
  mcScattered=0;
  mcRestore=0;
  mcNCounter[613]++;
  mcPCounter[613] += p;
  mcP2Counter[613] += p*p;
#define mccompcurname  inter_analyzer_colimator_12_blade_2
#define mccompcurtype  Union_box
#define mccompcurindex 613
#define loop_index mccinter_analyzer_colimator_12_blade_2_loop_index
#define this_box_volume mccinter_analyzer_colimator_12_blade_2_this_box_volume
#define global_geometry_element mccinter_analyzer_colimator_12_blade_2_global_geometry_element
#define this_box_storage mccinter_analyzer_colimator_12_blade_2_this_box_storage
{   /* Declarations of inter_analyzer_colimator_12_blade_2=Union_box() SETTING parameters. */
char* material_string = mccinter_analyzer_colimator_12_blade_2_material_string;
MCNUM priority = mccinter_analyzer_colimator_12_blade_2_priority;
MCNUM xwidth = mccinter_analyzer_colimator_12_blade_2_xwidth;
MCNUM yheight = mccinter_analyzer_colimator_12_blade_2_yheight;
MCNUM zdepth = mccinter_analyzer_colimator_12_blade_2_zdepth;
MCNUM xwidth2 = mccinter_analyzer_colimator_12_blade_2_xwidth2;
MCNUM yheight2 = mccinter_analyzer_colimator_12_blade_2_yheight2;
MCNUM visualize = mccinter_analyzer_colimator_12_blade_2_visualize;
int target_index = mccinter_analyzer_colimator_12_blade_2_target_index;
MCNUM target_x = mccinter_analyzer_colimator_12_blade_2_target_x;
MCNUM target_y = mccinter_analyzer_colimator_12_blade_2_target_y;
MCNUM target_z = mccinter_analyzer_colimator_12_blade_2_target_z;
MCNUM focus_aw = mccinter_analyzer_colimator_12_blade_2_focus_aw;
MCNUM focus_ah = mccinter_analyzer_colimator_12_blade_2_focus_ah;
MCNUM focus_xw = mccinter_analyzer_colimator_12_blade_2_focus_xw;
MCNUM focus_xh = mccinter_analyzer_colimator_12_blade_2_focus_xh;
MCNUM focus_r = mccinter_analyzer_colimator_12_blade_2_focus_r;
MCNUM p_interact = mccinter_analyzer_colimator_12_blade_2_p_interact;
char* mask_string = mccinter_analyzer_colimator_12_blade_2_mask_string;
char* mask_setting = mccinter_analyzer_colimator_12_blade_2_mask_setting;
MCNUM number_of_activations = mccinter_analyzer_colimator_12_blade_2_number_of_activations;
}   /* End of inter_analyzer_colimator_12_blade_2=Union_box() SETTING parameter declarations. */
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex
  /* Label for restoring  neutron */
  mcabsorbCompinter_analyzer_colimator_12_blade_2:
  if (RESTORE) /* restore if needed */
  { RESTORE_NEUTRON(613,
      mcnlx,
      mcnly,
      mcnlz,
      mcnlvx,
      mcnlvy,
      mcnlvz,
      mcnlt,
      mcnlsx,
      mcnlsy,
      mcnlsz,
      mcnlp); }
#undef mcabsorbComp
#undef p
#undef sz
#undef sy
#undef sx
#undef t
#undef vz
#undef vy
#undef vx
#undef z
#undef y
#undef x
  mcDEBUG_STATE(
mcnlx,
mcnly,
mcnlz,
mcnlvx,
mcnlvy,
mcnlvz,
mcnlt,
mcnlsx,
mcnlsy,
mcnlsz,
mcnlp)

  /* TRACE Component inter_analyzer_colimator_12_blade_3 [614] */
  mccoordschange(mcposrinter_analyzer_colimator_12_blade_3, mcrotrinter_analyzer_colimator_12_blade_3,
    &mcnlx,
    &mcnly,
    &mcnlz,
    &mcnlvx,
    &mcnlvy,
    &mcnlvz,
    &mcnlsx,
    &mcnlsy,
    &mcnlsz);
  /* define label inside component inter_analyzer_colimator_12_blade_3 (without coords transformations) */
  mcJumpTrace_inter_analyzer_colimator_12_blade_3:
  SIG_MESSAGE("inter_analyzer_colimator_12_blade_3 (Trace)");
  mcDEBUG_COMP("inter_analyzer_colimator_12_blade_3")
  mcDEBUG_STATE(
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp)
#define x mcnlx
#define y mcnly
#define z mcnlz
#define vx mcnlvx
#define vy mcnlvy
#define vz mcnlvz
#define t mcnlt
#define sx mcnlsx
#define sy mcnlsy
#define sz mcnlsz
#define p mcnlp

#define mcabsorbComp mcabsorbCompinter_analyzer_colimator_12_blade_3
  STORE_NEUTRON(614,
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp);
  mcScattered=0;
  mcRestore=0;
  mcNCounter[614]++;
  mcPCounter[614] += p;
  mcP2Counter[614] += p*p;
#define mccompcurname  inter_analyzer_colimator_12_blade_3
#define mccompcurtype  Union_box
#define mccompcurindex 614
#define loop_index mccinter_analyzer_colimator_12_blade_3_loop_index
#define this_box_volume mccinter_analyzer_colimator_12_blade_3_this_box_volume
#define global_geometry_element mccinter_analyzer_colimator_12_blade_3_global_geometry_element
#define this_box_storage mccinter_analyzer_colimator_12_blade_3_this_box_storage
{   /* Declarations of inter_analyzer_colimator_12_blade_3=Union_box() SETTING parameters. */
char* material_string = mccinter_analyzer_colimator_12_blade_3_material_string;
MCNUM priority = mccinter_analyzer_colimator_12_blade_3_priority;
MCNUM xwidth = mccinter_analyzer_colimator_12_blade_3_xwidth;
MCNUM yheight = mccinter_analyzer_colimator_12_blade_3_yheight;
MCNUM zdepth = mccinter_analyzer_colimator_12_blade_3_zdepth;
MCNUM xwidth2 = mccinter_analyzer_colimator_12_blade_3_xwidth2;
MCNUM yheight2 = mccinter_analyzer_colimator_12_blade_3_yheight2;
MCNUM visualize = mccinter_analyzer_colimator_12_blade_3_visualize;
int target_index = mccinter_analyzer_colimator_12_blade_3_target_index;
MCNUM target_x = mccinter_analyzer_colimator_12_blade_3_target_x;
MCNUM target_y = mccinter_analyzer_colimator_12_blade_3_target_y;
MCNUM target_z = mccinter_analyzer_colimator_12_blade_3_target_z;
MCNUM focus_aw = mccinter_analyzer_colimator_12_blade_3_focus_aw;
MCNUM focus_ah = mccinter_analyzer_colimator_12_blade_3_focus_ah;
MCNUM focus_xw = mccinter_analyzer_colimator_12_blade_3_focus_xw;
MCNUM focus_xh = mccinter_analyzer_colimator_12_blade_3_focus_xh;
MCNUM focus_r = mccinter_analyzer_colimator_12_blade_3_focus_r;
MCNUM p_interact = mccinter_analyzer_colimator_12_blade_3_p_interact;
char* mask_string = mccinter_analyzer_colimator_12_blade_3_mask_string;
char* mask_setting = mccinter_analyzer_colimator_12_blade_3_mask_setting;
MCNUM number_of_activations = mccinter_analyzer_colimator_12_blade_3_number_of_activations;
}   /* End of inter_analyzer_colimator_12_blade_3=Union_box() SETTING parameter declarations. */
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex
  /* Label for restoring  neutron */
  mcabsorbCompinter_analyzer_colimator_12_blade_3:
  if (RESTORE) /* restore if needed */
  { RESTORE_NEUTRON(614,
      mcnlx,
      mcnly,
      mcnlz,
      mcnlvx,
      mcnlvy,
      mcnlvz,
      mcnlt,
      mcnlsx,
      mcnlsy,
      mcnlsz,
      mcnlp); }
#undef mcabsorbComp
#undef p
#undef sz
#undef sy
#undef sx
#undef t
#undef vz
#undef vy
#undef vx
#undef z
#undef y
#undef x
  mcDEBUG_STATE(
mcnlx,
mcnly,
mcnlz,
mcnlvx,
mcnlvy,
mcnlvz,
mcnlt,
mcnlsx,
mcnlsy,
mcnlsz,
mcnlp)

  /* TRACE Component inter_analyzer_colimator_12_blade_4 [615] */
  mccoordschange(mcposrinter_analyzer_colimator_12_blade_4, mcrotrinter_analyzer_colimator_12_blade_4,
    &mcnlx,
    &mcnly,
    &mcnlz,
    &mcnlvx,
    &mcnlvy,
    &mcnlvz,
    &mcnlsx,
    &mcnlsy,
    &mcnlsz);
  /* define label inside component inter_analyzer_colimator_12_blade_4 (without coords transformations) */
  mcJumpTrace_inter_analyzer_colimator_12_blade_4:
  SIG_MESSAGE("inter_analyzer_colimator_12_blade_4 (Trace)");
  mcDEBUG_COMP("inter_analyzer_colimator_12_blade_4")
  mcDEBUG_STATE(
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp)
#define x mcnlx
#define y mcnly
#define z mcnlz
#define vx mcnlvx
#define vy mcnlvy
#define vz mcnlvz
#define t mcnlt
#define sx mcnlsx
#define sy mcnlsy
#define sz mcnlsz
#define p mcnlp

#define mcabsorbComp mcabsorbCompinter_analyzer_colimator_12_blade_4
  STORE_NEUTRON(615,
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp);
  mcScattered=0;
  mcRestore=0;
  mcNCounter[615]++;
  mcPCounter[615] += p;
  mcP2Counter[615] += p*p;
#define mccompcurname  inter_analyzer_colimator_12_blade_4
#define mccompcurtype  Union_box
#define mccompcurindex 615
#define loop_index mccinter_analyzer_colimator_12_blade_4_loop_index
#define this_box_volume mccinter_analyzer_colimator_12_blade_4_this_box_volume
#define global_geometry_element mccinter_analyzer_colimator_12_blade_4_global_geometry_element
#define this_box_storage mccinter_analyzer_colimator_12_blade_4_this_box_storage
{   /* Declarations of inter_analyzer_colimator_12_blade_4=Union_box() SETTING parameters. */
char* material_string = mccinter_analyzer_colimator_12_blade_4_material_string;
MCNUM priority = mccinter_analyzer_colimator_12_blade_4_priority;
MCNUM xwidth = mccinter_analyzer_colimator_12_blade_4_xwidth;
MCNUM yheight = mccinter_analyzer_colimator_12_blade_4_yheight;
MCNUM zdepth = mccinter_analyzer_colimator_12_blade_4_zdepth;
MCNUM xwidth2 = mccinter_analyzer_colimator_12_blade_4_xwidth2;
MCNUM yheight2 = mccinter_analyzer_colimator_12_blade_4_yheight2;
MCNUM visualize = mccinter_analyzer_colimator_12_blade_4_visualize;
int target_index = mccinter_analyzer_colimator_12_blade_4_target_index;
MCNUM target_x = mccinter_analyzer_colimator_12_blade_4_target_x;
MCNUM target_y = mccinter_analyzer_colimator_12_blade_4_target_y;
MCNUM target_z = mccinter_analyzer_colimator_12_blade_4_target_z;
MCNUM focus_aw = mccinter_analyzer_colimator_12_blade_4_focus_aw;
MCNUM focus_ah = mccinter_analyzer_colimator_12_blade_4_focus_ah;
MCNUM focus_xw = mccinter_analyzer_colimator_12_blade_4_focus_xw;
MCNUM focus_xh = mccinter_analyzer_colimator_12_blade_4_focus_xh;
MCNUM focus_r = mccinter_analyzer_colimator_12_blade_4_focus_r;
MCNUM p_interact = mccinter_analyzer_colimator_12_blade_4_p_interact;
char* mask_string = mccinter_analyzer_colimator_12_blade_4_mask_string;
char* mask_setting = mccinter_analyzer_colimator_12_blade_4_mask_setting;
MCNUM number_of_activations = mccinter_analyzer_colimator_12_blade_4_number_of_activations;
}   /* End of inter_analyzer_colimator_12_blade_4=Union_box() SETTING parameter declarations. */
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex
  /* Label for restoring  neutron */
  mcabsorbCompinter_analyzer_colimator_12_blade_4:
  if (RESTORE) /* restore if needed */
  { RESTORE_NEUTRON(615,
      mcnlx,
      mcnly,
      mcnlz,
      mcnlvx,
      mcnlvy,
      mcnlvz,
      mcnlt,
      mcnlsx,
      mcnlsy,
      mcnlsz,
      mcnlp); }
#undef mcabsorbComp
#undef p
#undef sz
#undef sy
#undef sx
#undef t
#undef vz
#undef vy
#undef vx
#undef z
#undef y
#undef x
  mcDEBUG_STATE(
mcnlx,
mcnly,
mcnlz,
mcnlvx,
mcnlvy,
mcnlvz,
mcnlt,
mcnlsx,
mcnlsy,
mcnlsz,
mcnlp)

  /* TRACE Component diffraction_detector_12_exit_volume [616] */
  mccoordschange(mcposrdiffraction_detector_12_exit_volume, mcrotrdiffraction_detector_12_exit_volume,
    &mcnlx,
    &mcnly,
    &mcnlz,
    &mcnlvx,
    &mcnlvy,
    &mcnlvz,
    &mcnlsx,
    &mcnlsy,
    &mcnlsz);
  /* define label inside component diffraction_detector_12_exit_volume (without coords transformations) */
  mcJumpTrace_diffraction_detector_12_exit_volume:
  SIG_MESSAGE("diffraction_detector_12_exit_volume (Trace)");
  mcDEBUG_COMP("diffraction_detector_12_exit_volume")
  mcDEBUG_STATE(
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp)
#define x mcnlx
#define y mcnly
#define z mcnlz
#define vx mcnlvx
#define vy mcnlvy
#define vz mcnlvz
#define t mcnlt
#define sx mcnlsx
#define sy mcnlsy
#define sz mcnlsz
#define p mcnlp

#define mcabsorbComp mcabsorbCompdiffraction_detector_12_exit_volume
  STORE_NEUTRON(616,
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp);
  mcScattered=0;
  mcRestore=0;
  mcNCounter[616]++;
  mcPCounter[616] += p;
  mcP2Counter[616] += p*p;
#define mccompcurname  diffraction_detector_12_exit_volume
#define mccompcurtype  Union_box
#define mccompcurindex 616
#define loop_index mccdiffraction_detector_12_exit_volume_loop_index
#define this_box_volume mccdiffraction_detector_12_exit_volume_this_box_volume
#define global_geometry_element mccdiffraction_detector_12_exit_volume_global_geometry_element
#define this_box_storage mccdiffraction_detector_12_exit_volume_this_box_storage
{   /* Declarations of diffraction_detector_12_exit_volume=Union_box() SETTING parameters. */
char* material_string = mccdiffraction_detector_12_exit_volume_material_string;
MCNUM priority = mccdiffraction_detector_12_exit_volume_priority;
MCNUM xwidth = mccdiffraction_detector_12_exit_volume_xwidth;
MCNUM yheight = mccdiffraction_detector_12_exit_volume_yheight;
MCNUM zdepth = mccdiffraction_detector_12_exit_volume_zdepth;
MCNUM xwidth2 = mccdiffraction_detector_12_exit_volume_xwidth2;
MCNUM yheight2 = mccdiffraction_detector_12_exit_volume_yheight2;
MCNUM visualize = mccdiffraction_detector_12_exit_volume_visualize;
int target_index = mccdiffraction_detector_12_exit_volume_target_index;
MCNUM target_x = mccdiffraction_detector_12_exit_volume_target_x;
MCNUM target_y = mccdiffraction_detector_12_exit_volume_target_y;
MCNUM target_z = mccdiffraction_detector_12_exit_volume_target_z;
MCNUM focus_aw = mccdiffraction_detector_12_exit_volume_focus_aw;
MCNUM focus_ah = mccdiffraction_detector_12_exit_volume_focus_ah;
MCNUM focus_xw = mccdiffraction_detector_12_exit_volume_focus_xw;
MCNUM focus_xh = mccdiffraction_detector_12_exit_volume_focus_xh;
MCNUM focus_r = mccdiffraction_detector_12_exit_volume_focus_r;
MCNUM p_interact = mccdiffraction_detector_12_exit_volume_p_interact;
char* mask_string = mccdiffraction_detector_12_exit_volume_mask_string;
char* mask_setting = mccdiffraction_detector_12_exit_volume_mask_setting;
MCNUM number_of_activations = mccdiffraction_detector_12_exit_volume_number_of_activations;
}   /* End of diffraction_detector_12_exit_volume=Union_box() SETTING parameter declarations. */
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex
  /* Label for restoring  neutron */
  mcabsorbCompdiffraction_detector_12_exit_volume:
  if (RESTORE) /* restore if needed */
  { RESTORE_NEUTRON(616,
      mcnlx,
      mcnly,
      mcnlz,
      mcnlvx,
      mcnlvy,
      mcnlvz,
      mcnlt,
      mcnlsx,
      mcnlsy,
      mcnlsz,
      mcnlp); }
#undef mcabsorbComp
#undef p
#undef sz
#undef sy
#undef sx
#undef t
#undef vz
#undef vy
#undef vx
#undef z
#undef y
#undef x
  mcDEBUG_STATE(
mcnlx,
mcnly,
mcnlz,
mcnlvx,
mcnlvy,
mcnlvz,
mcnlt,
mcnlsx,
mcnlsy,
mcnlsz,
mcnlp)

  /* TRACE Component spec_detector_12_exit_volume [617] */
  mccoordschange(mcposrspec_detector_12_exit_volume, mcrotrspec_detector_12_exit_volume,
    &mcnlx,
    &mcnly,
    &mcnlz,
    &mcnlvx,
    &mcnlvy,
    &mcnlvz,
    &mcnlsx,
    &mcnlsy,
    &mcnlsz);
  /* define label inside component spec_detector_12_exit_volume (without coords transformations) */
  mcJumpTrace_spec_detector_12_exit_volume:
  SIG_MESSAGE("spec_detector_12_exit_volume (Trace)");
  mcDEBUG_COMP("spec_detector_12_exit_volume")
  mcDEBUG_STATE(
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp)
#define x mcnlx
#define y mcnly
#define z mcnlz
#define vx mcnlvx
#define vy mcnlvy
#define vz mcnlvz
#define t mcnlt
#define sx mcnlsx
#define sy mcnlsy
#define sz mcnlsz
#define p mcnlp

#define mcabsorbComp mcabsorbCompspec_detector_12_exit_volume
  STORE_NEUTRON(617,
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp);
  mcScattered=0;
  mcRestore=0;
  mcNCounter[617]++;
  mcPCounter[617] += p;
  mcP2Counter[617] += p*p;
#define mccompcurname  spec_detector_12_exit_volume
#define mccompcurtype  Union_box
#define mccompcurindex 617
#define loop_index mccspec_detector_12_exit_volume_loop_index
#define this_box_volume mccspec_detector_12_exit_volume_this_box_volume
#define global_geometry_element mccspec_detector_12_exit_volume_global_geometry_element
#define this_box_storage mccspec_detector_12_exit_volume_this_box_storage
{   /* Declarations of spec_detector_12_exit_volume=Union_box() SETTING parameters. */
char* material_string = mccspec_detector_12_exit_volume_material_string;
MCNUM priority = mccspec_detector_12_exit_volume_priority;
MCNUM xwidth = mccspec_detector_12_exit_volume_xwidth;
MCNUM yheight = mccspec_detector_12_exit_volume_yheight;
MCNUM zdepth = mccspec_detector_12_exit_volume_zdepth;
MCNUM xwidth2 = mccspec_detector_12_exit_volume_xwidth2;
MCNUM yheight2 = mccspec_detector_12_exit_volume_yheight2;
MCNUM visualize = mccspec_detector_12_exit_volume_visualize;
int target_index = mccspec_detector_12_exit_volume_target_index;
MCNUM target_x = mccspec_detector_12_exit_volume_target_x;
MCNUM target_y = mccspec_detector_12_exit_volume_target_y;
MCNUM target_z = mccspec_detector_12_exit_volume_target_z;
MCNUM focus_aw = mccspec_detector_12_exit_volume_focus_aw;
MCNUM focus_ah = mccspec_detector_12_exit_volume_focus_ah;
MCNUM focus_xw = mccspec_detector_12_exit_volume_focus_xw;
MCNUM focus_xh = mccspec_detector_12_exit_volume_focus_xh;
MCNUM focus_r = mccspec_detector_12_exit_volume_focus_r;
MCNUM p_interact = mccspec_detector_12_exit_volume_p_interact;
char* mask_string = mccspec_detector_12_exit_volume_mask_string;
char* mask_setting = mccspec_detector_12_exit_volume_mask_setting;
MCNUM number_of_activations = mccspec_detector_12_exit_volume_number_of_activations;
}   /* End of spec_detector_12_exit_volume=Union_box() SETTING parameter declarations. */
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex
  /* Label for restoring  neutron */
  mcabsorbCompspec_detector_12_exit_volume:
  if (RESTORE) /* restore if needed */
  { RESTORE_NEUTRON(617,
      mcnlx,
      mcnly,
      mcnlz,
      mcnlvx,
      mcnlvy,
      mcnlvz,
      mcnlt,
      mcnlsx,
      mcnlsy,
      mcnlsz,
      mcnlp); }
#undef mcabsorbComp
#undef p
#undef sz
#undef sy
#undef sx
#undef t
#undef vz
#undef vy
#undef vx
#undef z
#undef y
#undef x
  mcDEBUG_STATE(
mcnlx,
mcnly,
mcnlz,
mcnlvx,
mcnlvy,
mcnlvz,
mcnlt,
mcnlsx,
mcnlsy,
mcnlsz,
mcnlp)

  /* TRACE Component channel_13_cave1_box1 [618] */
  mccoordschange(mcposrchannel_13_cave1_box1, mcrotrchannel_13_cave1_box1,
    &mcnlx,
    &mcnly,
    &mcnlz,
    &mcnlvx,
    &mcnlvy,
    &mcnlvz,
    &mcnlsx,
    &mcnlsy,
    &mcnlsz);
  /* define label inside component channel_13_cave1_box1 (without coords transformations) */
  mcJumpTrace_channel_13_cave1_box1:
  SIG_MESSAGE("channel_13_cave1_box1 (Trace)");
  mcDEBUG_COMP("channel_13_cave1_box1")
  mcDEBUG_STATE(
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp)
#define x mcnlx
#define y mcnly
#define z mcnlz
#define vx mcnlvx
#define vy mcnlvy
#define vz mcnlvz
#define t mcnlt
#define sx mcnlsx
#define sy mcnlsy
#define sz mcnlsz
#define p mcnlp

#define mcabsorbComp mcabsorbCompchannel_13_cave1_box1
  STORE_NEUTRON(618,
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp);
  mcScattered=0;
  mcRestore=0;
  mcNCounter[618]++;
  mcPCounter[618] += p;
  mcP2Counter[618] += p*p;
#define mccompcurname  channel_13_cave1_box1
#define mccompcurtype  Union_box
#define mccompcurindex 618
#define loop_index mccchannel_13_cave1_box1_loop_index
#define this_box_volume mccchannel_13_cave1_box1_this_box_volume
#define global_geometry_element mccchannel_13_cave1_box1_global_geometry_element
#define this_box_storage mccchannel_13_cave1_box1_this_box_storage
{   /* Declarations of channel_13_cave1_box1=Union_box() SETTING parameters. */
char* material_string = mccchannel_13_cave1_box1_material_string;
MCNUM priority = mccchannel_13_cave1_box1_priority;
MCNUM xwidth = mccchannel_13_cave1_box1_xwidth;
MCNUM yheight = mccchannel_13_cave1_box1_yheight;
MCNUM zdepth = mccchannel_13_cave1_box1_zdepth;
MCNUM xwidth2 = mccchannel_13_cave1_box1_xwidth2;
MCNUM yheight2 = mccchannel_13_cave1_box1_yheight2;
MCNUM visualize = mccchannel_13_cave1_box1_visualize;
int target_index = mccchannel_13_cave1_box1_target_index;
MCNUM target_x = mccchannel_13_cave1_box1_target_x;
MCNUM target_y = mccchannel_13_cave1_box1_target_y;
MCNUM target_z = mccchannel_13_cave1_box1_target_z;
MCNUM focus_aw = mccchannel_13_cave1_box1_focus_aw;
MCNUM focus_ah = mccchannel_13_cave1_box1_focus_ah;
MCNUM focus_xw = mccchannel_13_cave1_box1_focus_xw;
MCNUM focus_xh = mccchannel_13_cave1_box1_focus_xh;
MCNUM focus_r = mccchannel_13_cave1_box1_focus_r;
MCNUM p_interact = mccchannel_13_cave1_box1_p_interact;
char* mask_string = mccchannel_13_cave1_box1_mask_string;
char* mask_setting = mccchannel_13_cave1_box1_mask_setting;
MCNUM number_of_activations = mccchannel_13_cave1_box1_number_of_activations;
}   /* End of channel_13_cave1_box1=Union_box() SETTING parameter declarations. */
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex
  /* Label for restoring  neutron */
  mcabsorbCompchannel_13_cave1_box1:
  if (RESTORE) /* restore if needed */
  { RESTORE_NEUTRON(618,
      mcnlx,
      mcnly,
      mcnlz,
      mcnlvx,
      mcnlvy,
      mcnlvz,
      mcnlt,
      mcnlsx,
      mcnlsy,
      mcnlsz,
      mcnlp); }
#undef mcabsorbComp
#undef p
#undef sz
#undef sy
#undef sx
#undef t
#undef vz
#undef vy
#undef vx
#undef z
#undef y
#undef x
  mcDEBUG_STATE(
mcnlx,
mcnly,
mcnlz,
mcnlvx,
mcnlvy,
mcnlvz,
mcnlt,
mcnlsx,
mcnlsy,
mcnlsz,
mcnlp)

  /* TRACE Component channel_13_cave1_box2 [619] */
  mccoordschange(mcposrchannel_13_cave1_box2, mcrotrchannel_13_cave1_box2,
    &mcnlx,
    &mcnly,
    &mcnlz,
    &mcnlvx,
    &mcnlvy,
    &mcnlvz,
    &mcnlsx,
    &mcnlsy,
    &mcnlsz);
  /* define label inside component channel_13_cave1_box2 (without coords transformations) */
  mcJumpTrace_channel_13_cave1_box2:
  SIG_MESSAGE("channel_13_cave1_box2 (Trace)");
  mcDEBUG_COMP("channel_13_cave1_box2")
  mcDEBUG_STATE(
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp)
#define x mcnlx
#define y mcnly
#define z mcnlz
#define vx mcnlvx
#define vy mcnlvy
#define vz mcnlvz
#define t mcnlt
#define sx mcnlsx
#define sy mcnlsy
#define sz mcnlsz
#define p mcnlp

#define mcabsorbComp mcabsorbCompchannel_13_cave1_box2
  STORE_NEUTRON(619,
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp);
  mcScattered=0;
  mcRestore=0;
  mcNCounter[619]++;
  mcPCounter[619] += p;
  mcP2Counter[619] += p*p;
#define mccompcurname  channel_13_cave1_box2
#define mccompcurtype  Union_box
#define mccompcurindex 619
#define loop_index mccchannel_13_cave1_box2_loop_index
#define this_box_volume mccchannel_13_cave1_box2_this_box_volume
#define global_geometry_element mccchannel_13_cave1_box2_global_geometry_element
#define this_box_storage mccchannel_13_cave1_box2_this_box_storage
{   /* Declarations of channel_13_cave1_box2=Union_box() SETTING parameters. */
char* material_string = mccchannel_13_cave1_box2_material_string;
MCNUM priority = mccchannel_13_cave1_box2_priority;
MCNUM xwidth = mccchannel_13_cave1_box2_xwidth;
MCNUM yheight = mccchannel_13_cave1_box2_yheight;
MCNUM zdepth = mccchannel_13_cave1_box2_zdepth;
MCNUM xwidth2 = mccchannel_13_cave1_box2_xwidth2;
MCNUM yheight2 = mccchannel_13_cave1_box2_yheight2;
MCNUM visualize = mccchannel_13_cave1_box2_visualize;
int target_index = mccchannel_13_cave1_box2_target_index;
MCNUM target_x = mccchannel_13_cave1_box2_target_x;
MCNUM target_y = mccchannel_13_cave1_box2_target_y;
MCNUM target_z = mccchannel_13_cave1_box2_target_z;
MCNUM focus_aw = mccchannel_13_cave1_box2_focus_aw;
MCNUM focus_ah = mccchannel_13_cave1_box2_focus_ah;
MCNUM focus_xw = mccchannel_13_cave1_box2_focus_xw;
MCNUM focus_xh = mccchannel_13_cave1_box2_focus_xh;
MCNUM focus_r = mccchannel_13_cave1_box2_focus_r;
MCNUM p_interact = mccchannel_13_cave1_box2_p_interact;
char* mask_string = mccchannel_13_cave1_box2_mask_string;
char* mask_setting = mccchannel_13_cave1_box2_mask_setting;
MCNUM number_of_activations = mccchannel_13_cave1_box2_number_of_activations;
}   /* End of channel_13_cave1_box2=Union_box() SETTING parameter declarations. */
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex
  /* Label for restoring  neutron */
  mcabsorbCompchannel_13_cave1_box2:
  if (RESTORE) /* restore if needed */
  { RESTORE_NEUTRON(619,
      mcnlx,
      mcnly,
      mcnlz,
      mcnlvx,
      mcnlvy,
      mcnlvz,
      mcnlt,
      mcnlsx,
      mcnlsy,
      mcnlsz,
      mcnlp); }
#undef mcabsorbComp
#undef p
#undef sz
#undef sy
#undef sx
#undef t
#undef vz
#undef vy
#undef vx
#undef z
#undef y
#undef x
  mcDEBUG_STATE(
mcnlx,
mcnly,
mcnlz,
mcnlvx,
mcnlvy,
mcnlvz,
mcnlt,
mcnlsx,
mcnlsy,
mcnlsz,
mcnlp)

  /* TRACE Component channel_13_cave1_box3 [620] */
  mccoordschange(mcposrchannel_13_cave1_box3, mcrotrchannel_13_cave1_box3,
    &mcnlx,
    &mcnly,
    &mcnlz,
    &mcnlvx,
    &mcnlvy,
    &mcnlvz,
    &mcnlsx,
    &mcnlsy,
    &mcnlsz);
  /* define label inside component channel_13_cave1_box3 (without coords transformations) */
  mcJumpTrace_channel_13_cave1_box3:
  SIG_MESSAGE("channel_13_cave1_box3 (Trace)");
  mcDEBUG_COMP("channel_13_cave1_box3")
  mcDEBUG_STATE(
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp)
#define x mcnlx
#define y mcnly
#define z mcnlz
#define vx mcnlvx
#define vy mcnlvy
#define vz mcnlvz
#define t mcnlt
#define sx mcnlsx
#define sy mcnlsy
#define sz mcnlsz
#define p mcnlp

#define mcabsorbComp mcabsorbCompchannel_13_cave1_box3
  STORE_NEUTRON(620,
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp);
  mcScattered=0;
  mcRestore=0;
  mcNCounter[620]++;
  mcPCounter[620] += p;
  mcP2Counter[620] += p*p;
#define mccompcurname  channel_13_cave1_box3
#define mccompcurtype  Union_box
#define mccompcurindex 620
#define loop_index mccchannel_13_cave1_box3_loop_index
#define this_box_volume mccchannel_13_cave1_box3_this_box_volume
#define global_geometry_element mccchannel_13_cave1_box3_global_geometry_element
#define this_box_storage mccchannel_13_cave1_box3_this_box_storage
{   /* Declarations of channel_13_cave1_box3=Union_box() SETTING parameters. */
char* material_string = mccchannel_13_cave1_box3_material_string;
MCNUM priority = mccchannel_13_cave1_box3_priority;
MCNUM xwidth = mccchannel_13_cave1_box3_xwidth;
MCNUM yheight = mccchannel_13_cave1_box3_yheight;
MCNUM zdepth = mccchannel_13_cave1_box3_zdepth;
MCNUM xwidth2 = mccchannel_13_cave1_box3_xwidth2;
MCNUM yheight2 = mccchannel_13_cave1_box3_yheight2;
MCNUM visualize = mccchannel_13_cave1_box3_visualize;
int target_index = mccchannel_13_cave1_box3_target_index;
MCNUM target_x = mccchannel_13_cave1_box3_target_x;
MCNUM target_y = mccchannel_13_cave1_box3_target_y;
MCNUM target_z = mccchannel_13_cave1_box3_target_z;
MCNUM focus_aw = mccchannel_13_cave1_box3_focus_aw;
MCNUM focus_ah = mccchannel_13_cave1_box3_focus_ah;
MCNUM focus_xw = mccchannel_13_cave1_box3_focus_xw;
MCNUM focus_xh = mccchannel_13_cave1_box3_focus_xh;
MCNUM focus_r = mccchannel_13_cave1_box3_focus_r;
MCNUM p_interact = mccchannel_13_cave1_box3_p_interact;
char* mask_string = mccchannel_13_cave1_box3_mask_string;
char* mask_setting = mccchannel_13_cave1_box3_mask_setting;
MCNUM number_of_activations = mccchannel_13_cave1_box3_number_of_activations;
}   /* End of channel_13_cave1_box3=Union_box() SETTING parameter declarations. */
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex
  /* Label for restoring  neutron */
  mcabsorbCompchannel_13_cave1_box3:
  if (RESTORE) /* restore if needed */
  { RESTORE_NEUTRON(620,
      mcnlx,
      mcnly,
      mcnlz,
      mcnlvx,
      mcnlvy,
      mcnlvz,
      mcnlt,
      mcnlsx,
      mcnlsy,
      mcnlsz,
      mcnlp); }
#undef mcabsorbComp
#undef p
#undef sz
#undef sy
#undef sx
#undef t
#undef vz
#undef vy
#undef vx
#undef z
#undef y
#undef x
  mcDEBUG_STATE(
mcnlx,
mcnly,
mcnlz,
mcnlvx,
mcnlvy,
mcnlvz,
mcnlt,
mcnlsx,
mcnlsy,
mcnlsz,
mcnlp)

  /* TRACE Component channel_13_cave1_cyl1 [621] */
  mccoordschange(mcposrchannel_13_cave1_cyl1, mcrotrchannel_13_cave1_cyl1,
    &mcnlx,
    &mcnly,
    &mcnlz,
    &mcnlvx,
    &mcnlvy,
    &mcnlvz,
    &mcnlsx,
    &mcnlsy,
    &mcnlsz);
  /* define label inside component channel_13_cave1_cyl1 (without coords transformations) */
  mcJumpTrace_channel_13_cave1_cyl1:
  SIG_MESSAGE("channel_13_cave1_cyl1 (Trace)");
  mcDEBUG_COMP("channel_13_cave1_cyl1")
  mcDEBUG_STATE(
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp)
#define x mcnlx
#define y mcnly
#define z mcnlz
#define vx mcnlvx
#define vy mcnlvy
#define vz mcnlvz
#define t mcnlt
#define sx mcnlsx
#define sy mcnlsy
#define sz mcnlsz
#define p mcnlp

#define mcabsorbComp mcabsorbCompchannel_13_cave1_cyl1
  STORE_NEUTRON(621,
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp);
  mcScattered=0;
  mcRestore=0;
  mcNCounter[621]++;
  mcPCounter[621] += p;
  mcP2Counter[621] += p*p;
#define mccompcurname  channel_13_cave1_cyl1
#define mccompcurtype  Union_cylinder
#define mccompcurindex 621
#define loop_index mccchannel_13_cave1_cyl1_loop_index
#define this_cylinder_volume mccchannel_13_cave1_cyl1_this_cylinder_volume
#define global_geometry_element mccchannel_13_cave1_cyl1_global_geometry_element
#define this_cylinder_storage mccchannel_13_cave1_cyl1_this_cylinder_storage
{   /* Declarations of channel_13_cave1_cyl1=Union_cylinder() SETTING parameters. */
char* material_string = mccchannel_13_cave1_cyl1_material_string;
MCNUM priority = mccchannel_13_cave1_cyl1_priority;
MCNUM radius = mccchannel_13_cave1_cyl1_radius;
MCNUM yheight = mccchannel_13_cave1_cyl1_yheight;
MCNUM visualize = mccchannel_13_cave1_cyl1_visualize;
int target_index = mccchannel_13_cave1_cyl1_target_index;
MCNUM target_x = mccchannel_13_cave1_cyl1_target_x;
MCNUM target_y = mccchannel_13_cave1_cyl1_target_y;
MCNUM target_z = mccchannel_13_cave1_cyl1_target_z;
MCNUM focus_aw = mccchannel_13_cave1_cyl1_focus_aw;
MCNUM focus_ah = mccchannel_13_cave1_cyl1_focus_ah;
MCNUM focus_xw = mccchannel_13_cave1_cyl1_focus_xw;
MCNUM focus_xh = mccchannel_13_cave1_cyl1_focus_xh;
MCNUM focus_r = mccchannel_13_cave1_cyl1_focus_r;
MCNUM p_interact = mccchannel_13_cave1_cyl1_p_interact;
char* mask_string = mccchannel_13_cave1_cyl1_mask_string;
char* mask_setting = mccchannel_13_cave1_cyl1_mask_setting;
MCNUM number_of_activations = mccchannel_13_cave1_cyl1_number_of_activations;
#line 345 "Union_cylinder.comp"
{
dummy = 1;
}
#line 427291 "MACS_sample_kidney_box.c"
}   /* End of channel_13_cave1_cyl1=Union_cylinder() SETTING parameter declarations. */
#undef this_cylinder_storage
#undef global_geometry_element
#undef this_cylinder_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex
  /* Label for restoring  neutron */
  mcabsorbCompchannel_13_cave1_cyl1:
  if (RESTORE) /* restore if needed */
  { RESTORE_NEUTRON(621,
      mcnlx,
      mcnly,
      mcnlz,
      mcnlvx,
      mcnlvy,
      mcnlvz,
      mcnlt,
      mcnlsx,
      mcnlsy,
      mcnlsz,
      mcnlp); }
#undef mcabsorbComp
#undef p
#undef sz
#undef sy
#undef sx
#undef t
#undef vz
#undef vy
#undef vx
#undef z
#undef y
#undef x
  mcDEBUG_STATE(
mcnlx,
mcnly,
mcnlz,
mcnlvx,
mcnlvy,
mcnlvz,
mcnlt,
mcnlsx,
mcnlsy,
mcnlsz,
mcnlp)

  /* TRACE Component channel_13_analyzer_1_center [622] */
  mccoordschange(mcposrchannel_13_analyzer_1_center, mcrotrchannel_13_analyzer_1_center,
    &mcnlx,
    &mcnly,
    &mcnlz,
    &mcnlvx,
    &mcnlvy,
    &mcnlvz,
    &mcnlsx,
    &mcnlsy,
    &mcnlsz);
  /* define label inside component channel_13_analyzer_1_center (without coords transformations) */
  mcJumpTrace_channel_13_analyzer_1_center:
  SIG_MESSAGE("channel_13_analyzer_1_center (Trace)");
  mcDEBUG_COMP("channel_13_analyzer_1_center")
  mcDEBUG_STATE(
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp)
#define x mcnlx
#define y mcnly
#define z mcnlz
#define vx mcnlvx
#define vy mcnlvy
#define vz mcnlvz
#define t mcnlt
#define sx mcnlsx
#define sy mcnlsy
#define sz mcnlsz
#define p mcnlp

#define mcabsorbComp mcabsorbCompchannel_13_analyzer_1_center
  STORE_NEUTRON(622,
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp);
  mcScattered=0;
  mcRestore=0;
  mcNCounter[622]++;
  mcPCounter[622] += p;
  mcP2Counter[622] += p*p;
#define mccompcurname  channel_13_analyzer_1_center
#define mccompcurtype  Arm
#define mccompcurindex 622
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex
  /* Label for restoring  neutron */
  mcabsorbCompchannel_13_analyzer_1_center:
  if (RESTORE) /* restore if needed */
  { RESTORE_NEUTRON(622,
      mcnlx,
      mcnly,
      mcnlz,
      mcnlvx,
      mcnlvy,
      mcnlvz,
      mcnlt,
      mcnlsx,
      mcnlsy,
      mcnlsz,
      mcnlp); }
#undef mcabsorbComp
#undef p
#undef sz
#undef sy
#undef sx
#undef t
#undef vz
#undef vy
#undef vx
#undef z
#undef y
#undef x
  mcDEBUG_STATE(
mcnlx,
mcnly,
mcnlz,
mcnlvx,
mcnlvy,
mcnlvz,
mcnlt,
mcnlsx,
mcnlsy,
mcnlsz,
mcnlp)

  /* TRACE Component channel_13_analyzer_1_rotated [623] */
  mccoordschange(mcposrchannel_13_analyzer_1_rotated, mcrotrchannel_13_analyzer_1_rotated,
    &mcnlx,
    &mcnly,
    &mcnlz,
    &mcnlvx,
    &mcnlvy,
    &mcnlvz,
    &mcnlsx,
    &mcnlsy,
    &mcnlsz);
  /* define label inside component channel_13_analyzer_1_rotated (without coords transformations) */
  mcJumpTrace_channel_13_analyzer_1_rotated:
  SIG_MESSAGE("channel_13_analyzer_1_rotated (Trace)");
  mcDEBUG_COMP("channel_13_analyzer_1_rotated")
  mcDEBUG_STATE(
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp)
#define x mcnlx
#define y mcnly
#define z mcnlz
#define vx mcnlvx
#define vy mcnlvy
#define vz mcnlvz
#define t mcnlt
#define sx mcnlsx
#define sy mcnlsy
#define sz mcnlsz
#define p mcnlp

#define mcabsorbComp mcabsorbCompchannel_13_analyzer_1_rotated
  STORE_NEUTRON(623,
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp);
  mcScattered=0;
  mcRestore=0;
  mcNCounter[623]++;
  mcPCounter[623] += p;
  mcP2Counter[623] += p*p;
#define mccompcurname  channel_13_analyzer_1_rotated
#define mccompcurtype  Arm
#define mccompcurindex 623
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex
  /* Label for restoring  neutron */
  mcabsorbCompchannel_13_analyzer_1_rotated:
  if (RESTORE) /* restore if needed */
  { RESTORE_NEUTRON(623,
      mcnlx,
      mcnly,
      mcnlz,
      mcnlvx,
      mcnlvy,
      mcnlvz,
      mcnlt,
      mcnlsx,
      mcnlsy,
      mcnlsz,
      mcnlp); }
#undef mcabsorbComp
#undef p
#undef sz
#undef sy
#undef sx
#undef t
#undef vz
#undef vy
#undef vx
#undef z
#undef y
#undef x
  mcDEBUG_STATE(
mcnlx,
mcnly,
mcnlz,
mcnlvx,
mcnlvy,
mcnlvz,
mcnlt,
mcnlsx,
mcnlsy,
mcnlsz,
mcnlp)

  /* TRACE Component channel_13_analyzer_1_array_crystal_array_0 [624] */
  mccoordschange(mcposrchannel_13_analyzer_1_array_crystal_array_0, mcrotrchannel_13_analyzer_1_array_crystal_array_0,
    &mcnlx,
    &mcnly,
    &mcnlz,
    &mcnlvx,
    &mcnlvy,
    &mcnlvz,
    &mcnlsx,
    &mcnlsy,
    &mcnlsz);
  /* define label inside component channel_13_analyzer_1_array_crystal_array_0 (without coords transformations) */
  mcJumpTrace_channel_13_analyzer_1_array_crystal_array_0:
  SIG_MESSAGE("channel_13_analyzer_1_array_crystal_array_0 (Trace)");
  mcDEBUG_COMP("channel_13_analyzer_1_array_crystal_array_0")
  mcDEBUG_STATE(
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp)
#define x mcnlx
#define y mcnly
#define z mcnlz
#define vx mcnlvx
#define vy mcnlvy
#define vz mcnlvz
#define t mcnlt
#define sx mcnlsx
#define sy mcnlsy
#define sz mcnlsz
#define p mcnlp

#define mcabsorbComp mcabsorbCompchannel_13_analyzer_1_array_crystal_array_0
  STORE_NEUTRON(624,
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp);
  mcScattered=0;
  mcRestore=0;
  mcNCounter[624]++;
  mcPCounter[624] += p;
  mcP2Counter[624] += p*p;
#define mccompcurname  channel_13_analyzer_1_array_crystal_array_0
#define mccompcurtype  Union_box
#define mccompcurindex 624
#define loop_index mccchannel_13_analyzer_1_array_crystal_array_0_loop_index
#define this_box_volume mccchannel_13_analyzer_1_array_crystal_array_0_this_box_volume
#define global_geometry_element mccchannel_13_analyzer_1_array_crystal_array_0_global_geometry_element
#define this_box_storage mccchannel_13_analyzer_1_array_crystal_array_0_this_box_storage
{   /* Declarations of channel_13_analyzer_1_array_crystal_array_0=Union_box() SETTING parameters. */
char* material_string = mccchannel_13_analyzer_1_array_crystal_array_0_material_string;
MCNUM priority = mccchannel_13_analyzer_1_array_crystal_array_0_priority;
MCNUM xwidth = mccchannel_13_analyzer_1_array_crystal_array_0_xwidth;
MCNUM yheight = mccchannel_13_analyzer_1_array_crystal_array_0_yheight;
MCNUM zdepth = mccchannel_13_analyzer_1_array_crystal_array_0_zdepth;
MCNUM xwidth2 = mccchannel_13_analyzer_1_array_crystal_array_0_xwidth2;
MCNUM yheight2 = mccchannel_13_analyzer_1_array_crystal_array_0_yheight2;
MCNUM visualize = mccchannel_13_analyzer_1_array_crystal_array_0_visualize;
int target_index = mccchannel_13_analyzer_1_array_crystal_array_0_target_index;
MCNUM target_x = mccchannel_13_analyzer_1_array_crystal_array_0_target_x;
MCNUM target_y = mccchannel_13_analyzer_1_array_crystal_array_0_target_y;
MCNUM target_z = mccchannel_13_analyzer_1_array_crystal_array_0_target_z;
MCNUM focus_aw = mccchannel_13_analyzer_1_array_crystal_array_0_focus_aw;
MCNUM focus_ah = mccchannel_13_analyzer_1_array_crystal_array_0_focus_ah;
MCNUM focus_xw = mccchannel_13_analyzer_1_array_crystal_array_0_focus_xw;
MCNUM focus_xh = mccchannel_13_analyzer_1_array_crystal_array_0_focus_xh;
MCNUM focus_r = mccchannel_13_analyzer_1_array_crystal_array_0_focus_r;
MCNUM p_interact = mccchannel_13_analyzer_1_array_crystal_array_0_p_interact;
char* mask_string = mccchannel_13_analyzer_1_array_crystal_array_0_mask_string;
char* mask_setting = mccchannel_13_analyzer_1_array_crystal_array_0_mask_setting;
MCNUM number_of_activations = mccchannel_13_analyzer_1_array_crystal_array_0_number_of_activations;
}   /* End of channel_13_analyzer_1_array_crystal_array_0=Union_box() SETTING parameter declarations. */
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex
  /* Label for restoring  neutron */
  mcabsorbCompchannel_13_analyzer_1_array_crystal_array_0:
  if (RESTORE) /* restore if needed */
  { RESTORE_NEUTRON(624,
      mcnlx,
      mcnly,
      mcnlz,
      mcnlvx,
      mcnlvy,
      mcnlvz,
      mcnlt,
      mcnlsx,
      mcnlsy,
      mcnlsz,
      mcnlp); }
#undef mcabsorbComp
#undef p
#undef sz
#undef sy
#undef sx
#undef t
#undef vz
#undef vy
#undef vx
#undef z
#undef y
#undef x
  mcDEBUG_STATE(
mcnlx,
mcnly,
mcnlz,
mcnlvx,
mcnlvy,
mcnlvz,
mcnlt,
mcnlsx,
mcnlsy,
mcnlsz,
mcnlp)

  /* TRACE Component channel_13_analyzer_1_array_crystal_array_1 [625] */
  mccoordschange(mcposrchannel_13_analyzer_1_array_crystal_array_1, mcrotrchannel_13_analyzer_1_array_crystal_array_1,
    &mcnlx,
    &mcnly,
    &mcnlz,
    &mcnlvx,
    &mcnlvy,
    &mcnlvz,
    &mcnlsx,
    &mcnlsy,
    &mcnlsz);
  /* define label inside component channel_13_analyzer_1_array_crystal_array_1 (without coords transformations) */
  mcJumpTrace_channel_13_analyzer_1_array_crystal_array_1:
  SIG_MESSAGE("channel_13_analyzer_1_array_crystal_array_1 (Trace)");
  mcDEBUG_COMP("channel_13_analyzer_1_array_crystal_array_1")
  mcDEBUG_STATE(
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp)
#define x mcnlx
#define y mcnly
#define z mcnlz
#define vx mcnlvx
#define vy mcnlvy
#define vz mcnlvz
#define t mcnlt
#define sx mcnlsx
#define sy mcnlsy
#define sz mcnlsz
#define p mcnlp

#define mcabsorbComp mcabsorbCompchannel_13_analyzer_1_array_crystal_array_1
  STORE_NEUTRON(625,
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp);
  mcScattered=0;
  mcRestore=0;
  mcNCounter[625]++;
  mcPCounter[625] += p;
  mcP2Counter[625] += p*p;
#define mccompcurname  channel_13_analyzer_1_array_crystal_array_1
#define mccompcurtype  Union_box
#define mccompcurindex 625
#define loop_index mccchannel_13_analyzer_1_array_crystal_array_1_loop_index
#define this_box_volume mccchannel_13_analyzer_1_array_crystal_array_1_this_box_volume
#define global_geometry_element mccchannel_13_analyzer_1_array_crystal_array_1_global_geometry_element
#define this_box_storage mccchannel_13_analyzer_1_array_crystal_array_1_this_box_storage
{   /* Declarations of channel_13_analyzer_1_array_crystal_array_1=Union_box() SETTING parameters. */
char* material_string = mccchannel_13_analyzer_1_array_crystal_array_1_material_string;
MCNUM priority = mccchannel_13_analyzer_1_array_crystal_array_1_priority;
MCNUM xwidth = mccchannel_13_analyzer_1_array_crystal_array_1_xwidth;
MCNUM yheight = mccchannel_13_analyzer_1_array_crystal_array_1_yheight;
MCNUM zdepth = mccchannel_13_analyzer_1_array_crystal_array_1_zdepth;
MCNUM xwidth2 = mccchannel_13_analyzer_1_array_crystal_array_1_xwidth2;
MCNUM yheight2 = mccchannel_13_analyzer_1_array_crystal_array_1_yheight2;
MCNUM visualize = mccchannel_13_analyzer_1_array_crystal_array_1_visualize;
int target_index = mccchannel_13_analyzer_1_array_crystal_array_1_target_index;
MCNUM target_x = mccchannel_13_analyzer_1_array_crystal_array_1_target_x;
MCNUM target_y = mccchannel_13_analyzer_1_array_crystal_array_1_target_y;
MCNUM target_z = mccchannel_13_analyzer_1_array_crystal_array_1_target_z;
MCNUM focus_aw = mccchannel_13_analyzer_1_array_crystal_array_1_focus_aw;
MCNUM focus_ah = mccchannel_13_analyzer_1_array_crystal_array_1_focus_ah;
MCNUM focus_xw = mccchannel_13_analyzer_1_array_crystal_array_1_focus_xw;
MCNUM focus_xh = mccchannel_13_analyzer_1_array_crystal_array_1_focus_xh;
MCNUM focus_r = mccchannel_13_analyzer_1_array_crystal_array_1_focus_r;
MCNUM p_interact = mccchannel_13_analyzer_1_array_crystal_array_1_p_interact;
char* mask_string = mccchannel_13_analyzer_1_array_crystal_array_1_mask_string;
char* mask_setting = mccchannel_13_analyzer_1_array_crystal_array_1_mask_setting;
MCNUM number_of_activations = mccchannel_13_analyzer_1_array_crystal_array_1_number_of_activations;
}   /* End of channel_13_analyzer_1_array_crystal_array_1=Union_box() SETTING parameter declarations. */
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex
  /* Label for restoring  neutron */
  mcabsorbCompchannel_13_analyzer_1_array_crystal_array_1:
  if (RESTORE) /* restore if needed */
  { RESTORE_NEUTRON(625,
      mcnlx,
      mcnly,
      mcnlz,
      mcnlvx,
      mcnlvy,
      mcnlvz,
      mcnlt,
      mcnlsx,
      mcnlsy,
      mcnlsz,
      mcnlp); }
#undef mcabsorbComp
#undef p
#undef sz
#undef sy
#undef sx
#undef t
#undef vz
#undef vy
#undef vx
#undef z
#undef y
#undef x
  mcDEBUG_STATE(
mcnlx,
mcnly,
mcnlz,
mcnlvx,
mcnlvy,
mcnlvz,
mcnlt,
mcnlsx,
mcnlsy,
mcnlsz,
mcnlp)

  /* TRACE Component channel_13_analyzer_1_array_crystal_array_2 [626] */
  mccoordschange(mcposrchannel_13_analyzer_1_array_crystal_array_2, mcrotrchannel_13_analyzer_1_array_crystal_array_2,
    &mcnlx,
    &mcnly,
    &mcnlz,
    &mcnlvx,
    &mcnlvy,
    &mcnlvz,
    &mcnlsx,
    &mcnlsy,
    &mcnlsz);
  /* define label inside component channel_13_analyzer_1_array_crystal_array_2 (without coords transformations) */
  mcJumpTrace_channel_13_analyzer_1_array_crystal_array_2:
  SIG_MESSAGE("channel_13_analyzer_1_array_crystal_array_2 (Trace)");
  mcDEBUG_COMP("channel_13_analyzer_1_array_crystal_array_2")
  mcDEBUG_STATE(
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp)
#define x mcnlx
#define y mcnly
#define z mcnlz
#define vx mcnlvx
#define vy mcnlvy
#define vz mcnlvz
#define t mcnlt
#define sx mcnlsx
#define sy mcnlsy
#define sz mcnlsz
#define p mcnlp

#define mcabsorbComp mcabsorbCompchannel_13_analyzer_1_array_crystal_array_2
  STORE_NEUTRON(626,
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp);
  mcScattered=0;
  mcRestore=0;
  mcNCounter[626]++;
  mcPCounter[626] += p;
  mcP2Counter[626] += p*p;
#define mccompcurname  channel_13_analyzer_1_array_crystal_array_2
#define mccompcurtype  Union_box
#define mccompcurindex 626
#define loop_index mccchannel_13_analyzer_1_array_crystal_array_2_loop_index
#define this_box_volume mccchannel_13_analyzer_1_array_crystal_array_2_this_box_volume
#define global_geometry_element mccchannel_13_analyzer_1_array_crystal_array_2_global_geometry_element
#define this_box_storage mccchannel_13_analyzer_1_array_crystal_array_2_this_box_storage
{   /* Declarations of channel_13_analyzer_1_array_crystal_array_2=Union_box() SETTING parameters. */
char* material_string = mccchannel_13_analyzer_1_array_crystal_array_2_material_string;
MCNUM priority = mccchannel_13_analyzer_1_array_crystal_array_2_priority;
MCNUM xwidth = mccchannel_13_analyzer_1_array_crystal_array_2_xwidth;
MCNUM yheight = mccchannel_13_analyzer_1_array_crystal_array_2_yheight;
MCNUM zdepth = mccchannel_13_analyzer_1_array_crystal_array_2_zdepth;
MCNUM xwidth2 = mccchannel_13_analyzer_1_array_crystal_array_2_xwidth2;
MCNUM yheight2 = mccchannel_13_analyzer_1_array_crystal_array_2_yheight2;
MCNUM visualize = mccchannel_13_analyzer_1_array_crystal_array_2_visualize;
int target_index = mccchannel_13_analyzer_1_array_crystal_array_2_target_index;
MCNUM target_x = mccchannel_13_analyzer_1_array_crystal_array_2_target_x;
MCNUM target_y = mccchannel_13_analyzer_1_array_crystal_array_2_target_y;
MCNUM target_z = mccchannel_13_analyzer_1_array_crystal_array_2_target_z;
MCNUM focus_aw = mccchannel_13_analyzer_1_array_crystal_array_2_focus_aw;
MCNUM focus_ah = mccchannel_13_analyzer_1_array_crystal_array_2_focus_ah;
MCNUM focus_xw = mccchannel_13_analyzer_1_array_crystal_array_2_focus_xw;
MCNUM focus_xh = mccchannel_13_analyzer_1_array_crystal_array_2_focus_xh;
MCNUM focus_r = mccchannel_13_analyzer_1_array_crystal_array_2_focus_r;
MCNUM p_interact = mccchannel_13_analyzer_1_array_crystal_array_2_p_interact;
char* mask_string = mccchannel_13_analyzer_1_array_crystal_array_2_mask_string;
char* mask_setting = mccchannel_13_analyzer_1_array_crystal_array_2_mask_setting;
MCNUM number_of_activations = mccchannel_13_analyzer_1_array_crystal_array_2_number_of_activations;
}   /* End of channel_13_analyzer_1_array_crystal_array_2=Union_box() SETTING parameter declarations. */
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex
  /* Label for restoring  neutron */
  mcabsorbCompchannel_13_analyzer_1_array_crystal_array_2:
  if (RESTORE) /* restore if needed */
  { RESTORE_NEUTRON(626,
      mcnlx,
      mcnly,
      mcnlz,
      mcnlvx,
      mcnlvy,
      mcnlvz,
      mcnlt,
      mcnlsx,
      mcnlsy,
      mcnlsz,
      mcnlp); }
#undef mcabsorbComp
#undef p
#undef sz
#undef sy
#undef sx
#undef t
#undef vz
#undef vy
#undef vx
#undef z
#undef y
#undef x
  mcDEBUG_STATE(
mcnlx,
mcnly,
mcnlz,
mcnlvx,
mcnlvy,
mcnlvz,
mcnlt,
mcnlsx,
mcnlsy,
mcnlsz,
mcnlp)

  /* TRACE Component channel_13_analyzer_1_array_crystal_array_3 [627] */
  mccoordschange(mcposrchannel_13_analyzer_1_array_crystal_array_3, mcrotrchannel_13_analyzer_1_array_crystal_array_3,
    &mcnlx,
    &mcnly,
    &mcnlz,
    &mcnlvx,
    &mcnlvy,
    &mcnlvz,
    &mcnlsx,
    &mcnlsy,
    &mcnlsz);
  /* define label inside component channel_13_analyzer_1_array_crystal_array_3 (without coords transformations) */
  mcJumpTrace_channel_13_analyzer_1_array_crystal_array_3:
  SIG_MESSAGE("channel_13_analyzer_1_array_crystal_array_3 (Trace)");
  mcDEBUG_COMP("channel_13_analyzer_1_array_crystal_array_3")
  mcDEBUG_STATE(
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp)
#define x mcnlx
#define y mcnly
#define z mcnlz
#define vx mcnlvx
#define vy mcnlvy
#define vz mcnlvz
#define t mcnlt
#define sx mcnlsx
#define sy mcnlsy
#define sz mcnlsz
#define p mcnlp

#define mcabsorbComp mcabsorbCompchannel_13_analyzer_1_array_crystal_array_3
  STORE_NEUTRON(627,
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp);
  mcScattered=0;
  mcRestore=0;
  mcNCounter[627]++;
  mcPCounter[627] += p;
  mcP2Counter[627] += p*p;
#define mccompcurname  channel_13_analyzer_1_array_crystal_array_3
#define mccompcurtype  Union_box
#define mccompcurindex 627
#define loop_index mccchannel_13_analyzer_1_array_crystal_array_3_loop_index
#define this_box_volume mccchannel_13_analyzer_1_array_crystal_array_3_this_box_volume
#define global_geometry_element mccchannel_13_analyzer_1_array_crystal_array_3_global_geometry_element
#define this_box_storage mccchannel_13_analyzer_1_array_crystal_array_3_this_box_storage
{   /* Declarations of channel_13_analyzer_1_array_crystal_array_3=Union_box() SETTING parameters. */
char* material_string = mccchannel_13_analyzer_1_array_crystal_array_3_material_string;
MCNUM priority = mccchannel_13_analyzer_1_array_crystal_array_3_priority;
MCNUM xwidth = mccchannel_13_analyzer_1_array_crystal_array_3_xwidth;
MCNUM yheight = mccchannel_13_analyzer_1_array_crystal_array_3_yheight;
MCNUM zdepth = mccchannel_13_analyzer_1_array_crystal_array_3_zdepth;
MCNUM xwidth2 = mccchannel_13_analyzer_1_array_crystal_array_3_xwidth2;
MCNUM yheight2 = mccchannel_13_analyzer_1_array_crystal_array_3_yheight2;
MCNUM visualize = mccchannel_13_analyzer_1_array_crystal_array_3_visualize;
int target_index = mccchannel_13_analyzer_1_array_crystal_array_3_target_index;
MCNUM target_x = mccchannel_13_analyzer_1_array_crystal_array_3_target_x;
MCNUM target_y = mccchannel_13_analyzer_1_array_crystal_array_3_target_y;
MCNUM target_z = mccchannel_13_analyzer_1_array_crystal_array_3_target_z;
MCNUM focus_aw = mccchannel_13_analyzer_1_array_crystal_array_3_focus_aw;
MCNUM focus_ah = mccchannel_13_analyzer_1_array_crystal_array_3_focus_ah;
MCNUM focus_xw = mccchannel_13_analyzer_1_array_crystal_array_3_focus_xw;
MCNUM focus_xh = mccchannel_13_analyzer_1_array_crystal_array_3_focus_xh;
MCNUM focus_r = mccchannel_13_analyzer_1_array_crystal_array_3_focus_r;
MCNUM p_interact = mccchannel_13_analyzer_1_array_crystal_array_3_p_interact;
char* mask_string = mccchannel_13_analyzer_1_array_crystal_array_3_mask_string;
char* mask_setting = mccchannel_13_analyzer_1_array_crystal_array_3_mask_setting;
MCNUM number_of_activations = mccchannel_13_analyzer_1_array_crystal_array_3_number_of_activations;
}   /* End of channel_13_analyzer_1_array_crystal_array_3=Union_box() SETTING parameter declarations. */
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex
  /* Label for restoring  neutron */
  mcabsorbCompchannel_13_analyzer_1_array_crystal_array_3:
  if (RESTORE) /* restore if needed */
  { RESTORE_NEUTRON(627,
      mcnlx,
      mcnly,
      mcnlz,
      mcnlvx,
      mcnlvy,
      mcnlvz,
      mcnlt,
      mcnlsx,
      mcnlsy,
      mcnlsz,
      mcnlp); }
#undef mcabsorbComp
#undef p
#undef sz
#undef sy
#undef sx
#undef t
#undef vz
#undef vy
#undef vx
#undef z
#undef y
#undef x
  mcDEBUG_STATE(
mcnlx,
mcnly,
mcnlz,
mcnlvx,
mcnlvy,
mcnlvz,
mcnlt,
mcnlsx,
mcnlsy,
mcnlsz,
mcnlp)

  /* TRACE Component channel_13_analyzer_1_array_crystal_array_4 [628] */
  mccoordschange(mcposrchannel_13_analyzer_1_array_crystal_array_4, mcrotrchannel_13_analyzer_1_array_crystal_array_4,
    &mcnlx,
    &mcnly,
    &mcnlz,
    &mcnlvx,
    &mcnlvy,
    &mcnlvz,
    &mcnlsx,
    &mcnlsy,
    &mcnlsz);
  /* define label inside component channel_13_analyzer_1_array_crystal_array_4 (without coords transformations) */
  mcJumpTrace_channel_13_analyzer_1_array_crystal_array_4:
  SIG_MESSAGE("channel_13_analyzer_1_array_crystal_array_4 (Trace)");
  mcDEBUG_COMP("channel_13_analyzer_1_array_crystal_array_4")
  mcDEBUG_STATE(
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp)
#define x mcnlx
#define y mcnly
#define z mcnlz
#define vx mcnlvx
#define vy mcnlvy
#define vz mcnlvz
#define t mcnlt
#define sx mcnlsx
#define sy mcnlsy
#define sz mcnlsz
#define p mcnlp

#define mcabsorbComp mcabsorbCompchannel_13_analyzer_1_array_crystal_array_4
  STORE_NEUTRON(628,
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp);
  mcScattered=0;
  mcRestore=0;
  mcNCounter[628]++;
  mcPCounter[628] += p;
  mcP2Counter[628] += p*p;
#define mccompcurname  channel_13_analyzer_1_array_crystal_array_4
#define mccompcurtype  Union_box
#define mccompcurindex 628
#define loop_index mccchannel_13_analyzer_1_array_crystal_array_4_loop_index
#define this_box_volume mccchannel_13_analyzer_1_array_crystal_array_4_this_box_volume
#define global_geometry_element mccchannel_13_analyzer_1_array_crystal_array_4_global_geometry_element
#define this_box_storage mccchannel_13_analyzer_1_array_crystal_array_4_this_box_storage
{   /* Declarations of channel_13_analyzer_1_array_crystal_array_4=Union_box() SETTING parameters. */
char* material_string = mccchannel_13_analyzer_1_array_crystal_array_4_material_string;
MCNUM priority = mccchannel_13_analyzer_1_array_crystal_array_4_priority;
MCNUM xwidth = mccchannel_13_analyzer_1_array_crystal_array_4_xwidth;
MCNUM yheight = mccchannel_13_analyzer_1_array_crystal_array_4_yheight;
MCNUM zdepth = mccchannel_13_analyzer_1_array_crystal_array_4_zdepth;
MCNUM xwidth2 = mccchannel_13_analyzer_1_array_crystal_array_4_xwidth2;
MCNUM yheight2 = mccchannel_13_analyzer_1_array_crystal_array_4_yheight2;
MCNUM visualize = mccchannel_13_analyzer_1_array_crystal_array_4_visualize;
int target_index = mccchannel_13_analyzer_1_array_crystal_array_4_target_index;
MCNUM target_x = mccchannel_13_analyzer_1_array_crystal_array_4_target_x;
MCNUM target_y = mccchannel_13_analyzer_1_array_crystal_array_4_target_y;
MCNUM target_z = mccchannel_13_analyzer_1_array_crystal_array_4_target_z;
MCNUM focus_aw = mccchannel_13_analyzer_1_array_crystal_array_4_focus_aw;
MCNUM focus_ah = mccchannel_13_analyzer_1_array_crystal_array_4_focus_ah;
MCNUM focus_xw = mccchannel_13_analyzer_1_array_crystal_array_4_focus_xw;
MCNUM focus_xh = mccchannel_13_analyzer_1_array_crystal_array_4_focus_xh;
MCNUM focus_r = mccchannel_13_analyzer_1_array_crystal_array_4_focus_r;
MCNUM p_interact = mccchannel_13_analyzer_1_array_crystal_array_4_p_interact;
char* mask_string = mccchannel_13_analyzer_1_array_crystal_array_4_mask_string;
char* mask_setting = mccchannel_13_analyzer_1_array_crystal_array_4_mask_setting;
MCNUM number_of_activations = mccchannel_13_analyzer_1_array_crystal_array_4_number_of_activations;
}   /* End of channel_13_analyzer_1_array_crystal_array_4=Union_box() SETTING parameter declarations. */
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex
  /* Label for restoring  neutron */
  mcabsorbCompchannel_13_analyzer_1_array_crystal_array_4:
  if (RESTORE) /* restore if needed */
  { RESTORE_NEUTRON(628,
      mcnlx,
      mcnly,
      mcnlz,
      mcnlvx,
      mcnlvy,
      mcnlvz,
      mcnlt,
      mcnlsx,
      mcnlsy,
      mcnlsz,
      mcnlp); }
#undef mcabsorbComp
#undef p
#undef sz
#undef sy
#undef sx
#undef t
#undef vz
#undef vy
#undef vx
#undef z
#undef y
#undef x
  mcDEBUG_STATE(
mcnlx,
mcnly,
mcnlz,
mcnlvx,
mcnlvy,
mcnlvz,
mcnlt,
mcnlsx,
mcnlsy,
mcnlsz,
mcnlp)

  /* TRACE Component channel_13_analyzer_1_array_crystal_array_5 [629] */
  mccoordschange(mcposrchannel_13_analyzer_1_array_crystal_array_5, mcrotrchannel_13_analyzer_1_array_crystal_array_5,
    &mcnlx,
    &mcnly,
    &mcnlz,
    &mcnlvx,
    &mcnlvy,
    &mcnlvz,
    &mcnlsx,
    &mcnlsy,
    &mcnlsz);
  /* define label inside component channel_13_analyzer_1_array_crystal_array_5 (without coords transformations) */
  mcJumpTrace_channel_13_analyzer_1_array_crystal_array_5:
  SIG_MESSAGE("channel_13_analyzer_1_array_crystal_array_5 (Trace)");
  mcDEBUG_COMP("channel_13_analyzer_1_array_crystal_array_5")
  mcDEBUG_STATE(
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp)
#define x mcnlx
#define y mcnly
#define z mcnlz
#define vx mcnlvx
#define vy mcnlvy
#define vz mcnlvz
#define t mcnlt
#define sx mcnlsx
#define sy mcnlsy
#define sz mcnlsz
#define p mcnlp

#define mcabsorbComp mcabsorbCompchannel_13_analyzer_1_array_crystal_array_5
  STORE_NEUTRON(629,
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp);
  mcScattered=0;
  mcRestore=0;
  mcNCounter[629]++;
  mcPCounter[629] += p;
  mcP2Counter[629] += p*p;
#define mccompcurname  channel_13_analyzer_1_array_crystal_array_5
#define mccompcurtype  Union_box
#define mccompcurindex 629
#define loop_index mccchannel_13_analyzer_1_array_crystal_array_5_loop_index
#define this_box_volume mccchannel_13_analyzer_1_array_crystal_array_5_this_box_volume
#define global_geometry_element mccchannel_13_analyzer_1_array_crystal_array_5_global_geometry_element
#define this_box_storage mccchannel_13_analyzer_1_array_crystal_array_5_this_box_storage
{   /* Declarations of channel_13_analyzer_1_array_crystal_array_5=Union_box() SETTING parameters. */
char* material_string = mccchannel_13_analyzer_1_array_crystal_array_5_material_string;
MCNUM priority = mccchannel_13_analyzer_1_array_crystal_array_5_priority;
MCNUM xwidth = mccchannel_13_analyzer_1_array_crystal_array_5_xwidth;
MCNUM yheight = mccchannel_13_analyzer_1_array_crystal_array_5_yheight;
MCNUM zdepth = mccchannel_13_analyzer_1_array_crystal_array_5_zdepth;
MCNUM xwidth2 = mccchannel_13_analyzer_1_array_crystal_array_5_xwidth2;
MCNUM yheight2 = mccchannel_13_analyzer_1_array_crystal_array_5_yheight2;
MCNUM visualize = mccchannel_13_analyzer_1_array_crystal_array_5_visualize;
int target_index = mccchannel_13_analyzer_1_array_crystal_array_5_target_index;
MCNUM target_x = mccchannel_13_analyzer_1_array_crystal_array_5_target_x;
MCNUM target_y = mccchannel_13_analyzer_1_array_crystal_array_5_target_y;
MCNUM target_z = mccchannel_13_analyzer_1_array_crystal_array_5_target_z;
MCNUM focus_aw = mccchannel_13_analyzer_1_array_crystal_array_5_focus_aw;
MCNUM focus_ah = mccchannel_13_analyzer_1_array_crystal_array_5_focus_ah;
MCNUM focus_xw = mccchannel_13_analyzer_1_array_crystal_array_5_focus_xw;
MCNUM focus_xh = mccchannel_13_analyzer_1_array_crystal_array_5_focus_xh;
MCNUM focus_r = mccchannel_13_analyzer_1_array_crystal_array_5_focus_r;
MCNUM p_interact = mccchannel_13_analyzer_1_array_crystal_array_5_p_interact;
char* mask_string = mccchannel_13_analyzer_1_array_crystal_array_5_mask_string;
char* mask_setting = mccchannel_13_analyzer_1_array_crystal_array_5_mask_setting;
MCNUM number_of_activations = mccchannel_13_analyzer_1_array_crystal_array_5_number_of_activations;
}   /* End of channel_13_analyzer_1_array_crystal_array_5=Union_box() SETTING parameter declarations. */
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex
  /* Label for restoring  neutron */
  mcabsorbCompchannel_13_analyzer_1_array_crystal_array_5:
  if (RESTORE) /* restore if needed */
  { RESTORE_NEUTRON(629,
      mcnlx,
      mcnly,
      mcnlz,
      mcnlvx,
      mcnlvy,
      mcnlvz,
      mcnlt,
      mcnlsx,
      mcnlsy,
      mcnlsz,
      mcnlp); }
#undef mcabsorbComp
#undef p
#undef sz
#undef sy
#undef sx
#undef t
#undef vz
#undef vy
#undef vx
#undef z
#undef y
#undef x
  mcDEBUG_STATE(
mcnlx,
mcnly,
mcnlz,
mcnlvx,
mcnlvy,
mcnlvz,
mcnlt,
mcnlsx,
mcnlsy,
mcnlsz,
mcnlp)

  /* TRACE Component channel_13_analyzer_1_array_crystal_array_6 [630] */
  mccoordschange(mcposrchannel_13_analyzer_1_array_crystal_array_6, mcrotrchannel_13_analyzer_1_array_crystal_array_6,
    &mcnlx,
    &mcnly,
    &mcnlz,
    &mcnlvx,
    &mcnlvy,
    &mcnlvz,
    &mcnlsx,
    &mcnlsy,
    &mcnlsz);
  /* define label inside component channel_13_analyzer_1_array_crystal_array_6 (without coords transformations) */
  mcJumpTrace_channel_13_analyzer_1_array_crystal_array_6:
  SIG_MESSAGE("channel_13_analyzer_1_array_crystal_array_6 (Trace)");
  mcDEBUG_COMP("channel_13_analyzer_1_array_crystal_array_6")
  mcDEBUG_STATE(
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp)
#define x mcnlx
#define y mcnly
#define z mcnlz
#define vx mcnlvx
#define vy mcnlvy
#define vz mcnlvz
#define t mcnlt
#define sx mcnlsx
#define sy mcnlsy
#define sz mcnlsz
#define p mcnlp

#define mcabsorbComp mcabsorbCompchannel_13_analyzer_1_array_crystal_array_6
  STORE_NEUTRON(630,
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp);
  mcScattered=0;
  mcRestore=0;
  mcNCounter[630]++;
  mcPCounter[630] += p;
  mcP2Counter[630] += p*p;
#define mccompcurname  channel_13_analyzer_1_array_crystal_array_6
#define mccompcurtype  Union_box
#define mccompcurindex 630
#define loop_index mccchannel_13_analyzer_1_array_crystal_array_6_loop_index
#define this_box_volume mccchannel_13_analyzer_1_array_crystal_array_6_this_box_volume
#define global_geometry_element mccchannel_13_analyzer_1_array_crystal_array_6_global_geometry_element
#define this_box_storage mccchannel_13_analyzer_1_array_crystal_array_6_this_box_storage
{   /* Declarations of channel_13_analyzer_1_array_crystal_array_6=Union_box() SETTING parameters. */
char* material_string = mccchannel_13_analyzer_1_array_crystal_array_6_material_string;
MCNUM priority = mccchannel_13_analyzer_1_array_crystal_array_6_priority;
MCNUM xwidth = mccchannel_13_analyzer_1_array_crystal_array_6_xwidth;
MCNUM yheight = mccchannel_13_analyzer_1_array_crystal_array_6_yheight;
MCNUM zdepth = mccchannel_13_analyzer_1_array_crystal_array_6_zdepth;
MCNUM xwidth2 = mccchannel_13_analyzer_1_array_crystal_array_6_xwidth2;
MCNUM yheight2 = mccchannel_13_analyzer_1_array_crystal_array_6_yheight2;
MCNUM visualize = mccchannel_13_analyzer_1_array_crystal_array_6_visualize;
int target_index = mccchannel_13_analyzer_1_array_crystal_array_6_target_index;
MCNUM target_x = mccchannel_13_analyzer_1_array_crystal_array_6_target_x;
MCNUM target_y = mccchannel_13_analyzer_1_array_crystal_array_6_target_y;
MCNUM target_z = mccchannel_13_analyzer_1_array_crystal_array_6_target_z;
MCNUM focus_aw = mccchannel_13_analyzer_1_array_crystal_array_6_focus_aw;
MCNUM focus_ah = mccchannel_13_analyzer_1_array_crystal_array_6_focus_ah;
MCNUM focus_xw = mccchannel_13_analyzer_1_array_crystal_array_6_focus_xw;
MCNUM focus_xh = mccchannel_13_analyzer_1_array_crystal_array_6_focus_xh;
MCNUM focus_r = mccchannel_13_analyzer_1_array_crystal_array_6_focus_r;
MCNUM p_interact = mccchannel_13_analyzer_1_array_crystal_array_6_p_interact;
char* mask_string = mccchannel_13_analyzer_1_array_crystal_array_6_mask_string;
char* mask_setting = mccchannel_13_analyzer_1_array_crystal_array_6_mask_setting;
MCNUM number_of_activations = mccchannel_13_analyzer_1_array_crystal_array_6_number_of_activations;
}   /* End of channel_13_analyzer_1_array_crystal_array_6=Union_box() SETTING parameter declarations. */
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex
  /* Label for restoring  neutron */
  mcabsorbCompchannel_13_analyzer_1_array_crystal_array_6:
  if (RESTORE) /* restore if needed */
  { RESTORE_NEUTRON(630,
      mcnlx,
      mcnly,
      mcnlz,
      mcnlvx,
      mcnlvy,
      mcnlvz,
      mcnlt,
      mcnlsx,
      mcnlsy,
      mcnlsz,
      mcnlp); }
#undef mcabsorbComp
#undef p
#undef sz
#undef sy
#undef sx
#undef t
#undef vz
#undef vy
#undef vx
#undef z
#undef y
#undef x
  mcDEBUG_STATE(
mcnlx,
mcnly,
mcnlz,
mcnlvx,
mcnlvy,
mcnlvz,
mcnlt,
mcnlsx,
mcnlsy,
mcnlsz,
mcnlp)

  /* TRACE Component channel_13_analyzer_1_array_crystal_array_7 [631] */
  mccoordschange(mcposrchannel_13_analyzer_1_array_crystal_array_7, mcrotrchannel_13_analyzer_1_array_crystal_array_7,
    &mcnlx,
    &mcnly,
    &mcnlz,
    &mcnlvx,
    &mcnlvy,
    &mcnlvz,
    &mcnlsx,
    &mcnlsy,
    &mcnlsz);
  /* define label inside component channel_13_analyzer_1_array_crystal_array_7 (without coords transformations) */
  mcJumpTrace_channel_13_analyzer_1_array_crystal_array_7:
  SIG_MESSAGE("channel_13_analyzer_1_array_crystal_array_7 (Trace)");
  mcDEBUG_COMP("channel_13_analyzer_1_array_crystal_array_7")
  mcDEBUG_STATE(
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp)
#define x mcnlx
#define y mcnly
#define z mcnlz
#define vx mcnlvx
#define vy mcnlvy
#define vz mcnlvz
#define t mcnlt
#define sx mcnlsx
#define sy mcnlsy
#define sz mcnlsz
#define p mcnlp

#define mcabsorbComp mcabsorbCompchannel_13_analyzer_1_array_crystal_array_7
  STORE_NEUTRON(631,
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp);
  mcScattered=0;
  mcRestore=0;
  mcNCounter[631]++;
  mcPCounter[631] += p;
  mcP2Counter[631] += p*p;
#define mccompcurname  channel_13_analyzer_1_array_crystal_array_7
#define mccompcurtype  Union_box
#define mccompcurindex 631
#define loop_index mccchannel_13_analyzer_1_array_crystal_array_7_loop_index
#define this_box_volume mccchannel_13_analyzer_1_array_crystal_array_7_this_box_volume
#define global_geometry_element mccchannel_13_analyzer_1_array_crystal_array_7_global_geometry_element
#define this_box_storage mccchannel_13_analyzer_1_array_crystal_array_7_this_box_storage
{   /* Declarations of channel_13_analyzer_1_array_crystal_array_7=Union_box() SETTING parameters. */
char* material_string = mccchannel_13_analyzer_1_array_crystal_array_7_material_string;
MCNUM priority = mccchannel_13_analyzer_1_array_crystal_array_7_priority;
MCNUM xwidth = mccchannel_13_analyzer_1_array_crystal_array_7_xwidth;
MCNUM yheight = mccchannel_13_analyzer_1_array_crystal_array_7_yheight;
MCNUM zdepth = mccchannel_13_analyzer_1_array_crystal_array_7_zdepth;
MCNUM xwidth2 = mccchannel_13_analyzer_1_array_crystal_array_7_xwidth2;
MCNUM yheight2 = mccchannel_13_analyzer_1_array_crystal_array_7_yheight2;
MCNUM visualize = mccchannel_13_analyzer_1_array_crystal_array_7_visualize;
int target_index = mccchannel_13_analyzer_1_array_crystal_array_7_target_index;
MCNUM target_x = mccchannel_13_analyzer_1_array_crystal_array_7_target_x;
MCNUM target_y = mccchannel_13_analyzer_1_array_crystal_array_7_target_y;
MCNUM target_z = mccchannel_13_analyzer_1_array_crystal_array_7_target_z;
MCNUM focus_aw = mccchannel_13_analyzer_1_array_crystal_array_7_focus_aw;
MCNUM focus_ah = mccchannel_13_analyzer_1_array_crystal_array_7_focus_ah;
MCNUM focus_xw = mccchannel_13_analyzer_1_array_crystal_array_7_focus_xw;
MCNUM focus_xh = mccchannel_13_analyzer_1_array_crystal_array_7_focus_xh;
MCNUM focus_r = mccchannel_13_analyzer_1_array_crystal_array_7_focus_r;
MCNUM p_interact = mccchannel_13_analyzer_1_array_crystal_array_7_p_interact;
char* mask_string = mccchannel_13_analyzer_1_array_crystal_array_7_mask_string;
char* mask_setting = mccchannel_13_analyzer_1_array_crystal_array_7_mask_setting;
MCNUM number_of_activations = mccchannel_13_analyzer_1_array_crystal_array_7_number_of_activations;
}   /* End of channel_13_analyzer_1_array_crystal_array_7=Union_box() SETTING parameter declarations. */
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex
  /* Label for restoring  neutron */
  mcabsorbCompchannel_13_analyzer_1_array_crystal_array_7:
  if (RESTORE) /* restore if needed */
  { RESTORE_NEUTRON(631,
      mcnlx,
      mcnly,
      mcnlz,
      mcnlvx,
      mcnlvy,
      mcnlvz,
      mcnlt,
      mcnlsx,
      mcnlsy,
      mcnlsz,
      mcnlp); }
#undef mcabsorbComp
#undef p
#undef sz
#undef sy
#undef sx
#undef t
#undef vz
#undef vy
#undef vx
#undef z
#undef y
#undef x
  mcDEBUG_STATE(
mcnlx,
mcnly,
mcnlz,
mcnlvx,
mcnlvy,
mcnlvz,
mcnlt,
mcnlsx,
mcnlsy,
mcnlsz,
mcnlp)

  /* TRACE Component channel_13_analyzer_1_array_crystal_array_8 [632] */
  mccoordschange(mcposrchannel_13_analyzer_1_array_crystal_array_8, mcrotrchannel_13_analyzer_1_array_crystal_array_8,
    &mcnlx,
    &mcnly,
    &mcnlz,
    &mcnlvx,
    &mcnlvy,
    &mcnlvz,
    &mcnlsx,
    &mcnlsy,
    &mcnlsz);
  /* define label inside component channel_13_analyzer_1_array_crystal_array_8 (without coords transformations) */
  mcJumpTrace_channel_13_analyzer_1_array_crystal_array_8:
  SIG_MESSAGE("channel_13_analyzer_1_array_crystal_array_8 (Trace)");
  mcDEBUG_COMP("channel_13_analyzer_1_array_crystal_array_8")
  mcDEBUG_STATE(
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp)
#define x mcnlx
#define y mcnly
#define z mcnlz
#define vx mcnlvx
#define vy mcnlvy
#define vz mcnlvz
#define t mcnlt
#define sx mcnlsx
#define sy mcnlsy
#define sz mcnlsz
#define p mcnlp

#define mcabsorbComp mcabsorbCompchannel_13_analyzer_1_array_crystal_array_8
  STORE_NEUTRON(632,
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp);
  mcScattered=0;
  mcRestore=0;
  mcNCounter[632]++;
  mcPCounter[632] += p;
  mcP2Counter[632] += p*p;
#define mccompcurname  channel_13_analyzer_1_array_crystal_array_8
#define mccompcurtype  Union_box
#define mccompcurindex 632
#define loop_index mccchannel_13_analyzer_1_array_crystal_array_8_loop_index
#define this_box_volume mccchannel_13_analyzer_1_array_crystal_array_8_this_box_volume
#define global_geometry_element mccchannel_13_analyzer_1_array_crystal_array_8_global_geometry_element
#define this_box_storage mccchannel_13_analyzer_1_array_crystal_array_8_this_box_storage
{   /* Declarations of channel_13_analyzer_1_array_crystal_array_8=Union_box() SETTING parameters. */
char* material_string = mccchannel_13_analyzer_1_array_crystal_array_8_material_string;
MCNUM priority = mccchannel_13_analyzer_1_array_crystal_array_8_priority;
MCNUM xwidth = mccchannel_13_analyzer_1_array_crystal_array_8_xwidth;
MCNUM yheight = mccchannel_13_analyzer_1_array_crystal_array_8_yheight;
MCNUM zdepth = mccchannel_13_analyzer_1_array_crystal_array_8_zdepth;
MCNUM xwidth2 = mccchannel_13_analyzer_1_array_crystal_array_8_xwidth2;
MCNUM yheight2 = mccchannel_13_analyzer_1_array_crystal_array_8_yheight2;
MCNUM visualize = mccchannel_13_analyzer_1_array_crystal_array_8_visualize;
int target_index = mccchannel_13_analyzer_1_array_crystal_array_8_target_index;
MCNUM target_x = mccchannel_13_analyzer_1_array_crystal_array_8_target_x;
MCNUM target_y = mccchannel_13_analyzer_1_array_crystal_array_8_target_y;
MCNUM target_z = mccchannel_13_analyzer_1_array_crystal_array_8_target_z;
MCNUM focus_aw = mccchannel_13_analyzer_1_array_crystal_array_8_focus_aw;
MCNUM focus_ah = mccchannel_13_analyzer_1_array_crystal_array_8_focus_ah;
MCNUM focus_xw = mccchannel_13_analyzer_1_array_crystal_array_8_focus_xw;
MCNUM focus_xh = mccchannel_13_analyzer_1_array_crystal_array_8_focus_xh;
MCNUM focus_r = mccchannel_13_analyzer_1_array_crystal_array_8_focus_r;
MCNUM p_interact = mccchannel_13_analyzer_1_array_crystal_array_8_p_interact;
char* mask_string = mccchannel_13_analyzer_1_array_crystal_array_8_mask_string;
char* mask_setting = mccchannel_13_analyzer_1_array_crystal_array_8_mask_setting;
MCNUM number_of_activations = mccchannel_13_analyzer_1_array_crystal_array_8_number_of_activations;
}   /* End of channel_13_analyzer_1_array_crystal_array_8=Union_box() SETTING parameter declarations. */
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex
  /* Label for restoring  neutron */
  mcabsorbCompchannel_13_analyzer_1_array_crystal_array_8:
  if (RESTORE) /* restore if needed */
  { RESTORE_NEUTRON(632,
      mcnlx,
      mcnly,
      mcnlz,
      mcnlvx,
      mcnlvy,
      mcnlvz,
      mcnlt,
      mcnlsx,
      mcnlsy,
      mcnlsz,
      mcnlp); }
#undef mcabsorbComp
#undef p
#undef sz
#undef sy
#undef sx
#undef t
#undef vz
#undef vy
#undef vx
#undef z
#undef y
#undef x
  mcDEBUG_STATE(
mcnlx,
mcnly,
mcnlz,
mcnlvx,
mcnlvy,
mcnlvz,
mcnlt,
mcnlsx,
mcnlsy,
mcnlsz,
mcnlp)

  /* TRACE Component channel_13_analyzer_2_center [633] */
  mccoordschange(mcposrchannel_13_analyzer_2_center, mcrotrchannel_13_analyzer_2_center,
    &mcnlx,
    &mcnly,
    &mcnlz,
    &mcnlvx,
    &mcnlvy,
    &mcnlvz,
    &mcnlsx,
    &mcnlsy,
    &mcnlsz);
  /* define label inside component channel_13_analyzer_2_center (without coords transformations) */
  mcJumpTrace_channel_13_analyzer_2_center:
  SIG_MESSAGE("channel_13_analyzer_2_center (Trace)");
  mcDEBUG_COMP("channel_13_analyzer_2_center")
  mcDEBUG_STATE(
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp)
#define x mcnlx
#define y mcnly
#define z mcnlz
#define vx mcnlvx
#define vy mcnlvy
#define vz mcnlvz
#define t mcnlt
#define sx mcnlsx
#define sy mcnlsy
#define sz mcnlsz
#define p mcnlp

#define mcabsorbComp mcabsorbCompchannel_13_analyzer_2_center
  STORE_NEUTRON(633,
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp);
  mcScattered=0;
  mcRestore=0;
  mcNCounter[633]++;
  mcPCounter[633] += p;
  mcP2Counter[633] += p*p;
#define mccompcurname  channel_13_analyzer_2_center
#define mccompcurtype  Arm
#define mccompcurindex 633
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex
  /* Label for restoring  neutron */
  mcabsorbCompchannel_13_analyzer_2_center:
  if (RESTORE) /* restore if needed */
  { RESTORE_NEUTRON(633,
      mcnlx,
      mcnly,
      mcnlz,
      mcnlvx,
      mcnlvy,
      mcnlvz,
      mcnlt,
      mcnlsx,
      mcnlsy,
      mcnlsz,
      mcnlp); }
#undef mcabsorbComp
#undef p
#undef sz
#undef sy
#undef sx
#undef t
#undef vz
#undef vy
#undef vx
#undef z
#undef y
#undef x
  mcDEBUG_STATE(
mcnlx,
mcnly,
mcnlz,
mcnlvx,
mcnlvy,
mcnlvz,
mcnlt,
mcnlsx,
mcnlsy,
mcnlsz,
mcnlp)

  /* TRACE Component channel_13_analyzer_2_rotated [634] */
  mccoordschange(mcposrchannel_13_analyzer_2_rotated, mcrotrchannel_13_analyzer_2_rotated,
    &mcnlx,
    &mcnly,
    &mcnlz,
    &mcnlvx,
    &mcnlvy,
    &mcnlvz,
    &mcnlsx,
    &mcnlsy,
    &mcnlsz);
  /* define label inside component channel_13_analyzer_2_rotated (without coords transformations) */
  mcJumpTrace_channel_13_analyzer_2_rotated:
  SIG_MESSAGE("channel_13_analyzer_2_rotated (Trace)");
  mcDEBUG_COMP("channel_13_analyzer_2_rotated")
  mcDEBUG_STATE(
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp)
#define x mcnlx
#define y mcnly
#define z mcnlz
#define vx mcnlvx
#define vy mcnlvy
#define vz mcnlvz
#define t mcnlt
#define sx mcnlsx
#define sy mcnlsy
#define sz mcnlsz
#define p mcnlp

#define mcabsorbComp mcabsorbCompchannel_13_analyzer_2_rotated
  STORE_NEUTRON(634,
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp);
  mcScattered=0;
  mcRestore=0;
  mcNCounter[634]++;
  mcPCounter[634] += p;
  mcP2Counter[634] += p*p;
#define mccompcurname  channel_13_analyzer_2_rotated
#define mccompcurtype  Arm
#define mccompcurindex 634
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex
  /* Label for restoring  neutron */
  mcabsorbCompchannel_13_analyzer_2_rotated:
  if (RESTORE) /* restore if needed */
  { RESTORE_NEUTRON(634,
      mcnlx,
      mcnly,
      mcnlz,
      mcnlvx,
      mcnlvy,
      mcnlvz,
      mcnlt,
      mcnlsx,
      mcnlsy,
      mcnlsz,
      mcnlp); }
#undef mcabsorbComp
#undef p
#undef sz
#undef sy
#undef sx
#undef t
#undef vz
#undef vy
#undef vx
#undef z
#undef y
#undef x
  mcDEBUG_STATE(
mcnlx,
mcnly,
mcnlz,
mcnlvx,
mcnlvy,
mcnlvz,
mcnlt,
mcnlsx,
mcnlsy,
mcnlsz,
mcnlp)

  /* TRACE Component channel_13_analyzer_2_array_crystal_array_0 [635] */
  mccoordschange(mcposrchannel_13_analyzer_2_array_crystal_array_0, mcrotrchannel_13_analyzer_2_array_crystal_array_0,
    &mcnlx,
    &mcnly,
    &mcnlz,
    &mcnlvx,
    &mcnlvy,
    &mcnlvz,
    &mcnlsx,
    &mcnlsy,
    &mcnlsz);
  /* define label inside component channel_13_analyzer_2_array_crystal_array_0 (without coords transformations) */
  mcJumpTrace_channel_13_analyzer_2_array_crystal_array_0:
  SIG_MESSAGE("channel_13_analyzer_2_array_crystal_array_0 (Trace)");
  mcDEBUG_COMP("channel_13_analyzer_2_array_crystal_array_0")
  mcDEBUG_STATE(
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp)
#define x mcnlx
#define y mcnly
#define z mcnlz
#define vx mcnlvx
#define vy mcnlvy
#define vz mcnlvz
#define t mcnlt
#define sx mcnlsx
#define sy mcnlsy
#define sz mcnlsz
#define p mcnlp

#define mcabsorbComp mcabsorbCompchannel_13_analyzer_2_array_crystal_array_0
  STORE_NEUTRON(635,
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp);
  mcScattered=0;
  mcRestore=0;
  mcNCounter[635]++;
  mcPCounter[635] += p;
  mcP2Counter[635] += p*p;
#define mccompcurname  channel_13_analyzer_2_array_crystal_array_0
#define mccompcurtype  Union_box
#define mccompcurindex 635
#define loop_index mccchannel_13_analyzer_2_array_crystal_array_0_loop_index
#define this_box_volume mccchannel_13_analyzer_2_array_crystal_array_0_this_box_volume
#define global_geometry_element mccchannel_13_analyzer_2_array_crystal_array_0_global_geometry_element
#define this_box_storage mccchannel_13_analyzer_2_array_crystal_array_0_this_box_storage
{   /* Declarations of channel_13_analyzer_2_array_crystal_array_0=Union_box() SETTING parameters. */
char* material_string = mccchannel_13_analyzer_2_array_crystal_array_0_material_string;
MCNUM priority = mccchannel_13_analyzer_2_array_crystal_array_0_priority;
MCNUM xwidth = mccchannel_13_analyzer_2_array_crystal_array_0_xwidth;
MCNUM yheight = mccchannel_13_analyzer_2_array_crystal_array_0_yheight;
MCNUM zdepth = mccchannel_13_analyzer_2_array_crystal_array_0_zdepth;
MCNUM xwidth2 = mccchannel_13_analyzer_2_array_crystal_array_0_xwidth2;
MCNUM yheight2 = mccchannel_13_analyzer_2_array_crystal_array_0_yheight2;
MCNUM visualize = mccchannel_13_analyzer_2_array_crystal_array_0_visualize;
int target_index = mccchannel_13_analyzer_2_array_crystal_array_0_target_index;
MCNUM target_x = mccchannel_13_analyzer_2_array_crystal_array_0_target_x;
MCNUM target_y = mccchannel_13_analyzer_2_array_crystal_array_0_target_y;
MCNUM target_z = mccchannel_13_analyzer_2_array_crystal_array_0_target_z;
MCNUM focus_aw = mccchannel_13_analyzer_2_array_crystal_array_0_focus_aw;
MCNUM focus_ah = mccchannel_13_analyzer_2_array_crystal_array_0_focus_ah;
MCNUM focus_xw = mccchannel_13_analyzer_2_array_crystal_array_0_focus_xw;
MCNUM focus_xh = mccchannel_13_analyzer_2_array_crystal_array_0_focus_xh;
MCNUM focus_r = mccchannel_13_analyzer_2_array_crystal_array_0_focus_r;
MCNUM p_interact = mccchannel_13_analyzer_2_array_crystal_array_0_p_interact;
char* mask_string = mccchannel_13_analyzer_2_array_crystal_array_0_mask_string;
char* mask_setting = mccchannel_13_analyzer_2_array_crystal_array_0_mask_setting;
MCNUM number_of_activations = mccchannel_13_analyzer_2_array_crystal_array_0_number_of_activations;
}   /* End of channel_13_analyzer_2_array_crystal_array_0=Union_box() SETTING parameter declarations. */
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex
  /* Label for restoring  neutron */
  mcabsorbCompchannel_13_analyzer_2_array_crystal_array_0:
  if (RESTORE) /* restore if needed */
  { RESTORE_NEUTRON(635,
      mcnlx,
      mcnly,
      mcnlz,
      mcnlvx,
      mcnlvy,
      mcnlvz,
      mcnlt,
      mcnlsx,
      mcnlsy,
      mcnlsz,
      mcnlp); }
#undef mcabsorbComp
#undef p
#undef sz
#undef sy
#undef sx
#undef t
#undef vz
#undef vy
#undef vx
#undef z
#undef y
#undef x
  mcDEBUG_STATE(
mcnlx,
mcnly,
mcnlz,
mcnlvx,
mcnlvy,
mcnlvz,
mcnlt,
mcnlsx,
mcnlsy,
mcnlsz,
mcnlp)

  /* TRACE Component channel_13_analyzer_2_array_crystal_array_1 [636] */
  mccoordschange(mcposrchannel_13_analyzer_2_array_crystal_array_1, mcrotrchannel_13_analyzer_2_array_crystal_array_1,
    &mcnlx,
    &mcnly,
    &mcnlz,
    &mcnlvx,
    &mcnlvy,
    &mcnlvz,
    &mcnlsx,
    &mcnlsy,
    &mcnlsz);
  /* define label inside component channel_13_analyzer_2_array_crystal_array_1 (without coords transformations) */
  mcJumpTrace_channel_13_analyzer_2_array_crystal_array_1:
  SIG_MESSAGE("channel_13_analyzer_2_array_crystal_array_1 (Trace)");
  mcDEBUG_COMP("channel_13_analyzer_2_array_crystal_array_1")
  mcDEBUG_STATE(
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp)
#define x mcnlx
#define y mcnly
#define z mcnlz
#define vx mcnlvx
#define vy mcnlvy
#define vz mcnlvz
#define t mcnlt
#define sx mcnlsx
#define sy mcnlsy
#define sz mcnlsz
#define p mcnlp

#define mcabsorbComp mcabsorbCompchannel_13_analyzer_2_array_crystal_array_1
  STORE_NEUTRON(636,
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp);
  mcScattered=0;
  mcRestore=0;
  mcNCounter[636]++;
  mcPCounter[636] += p;
  mcP2Counter[636] += p*p;
#define mccompcurname  channel_13_analyzer_2_array_crystal_array_1
#define mccompcurtype  Union_box
#define mccompcurindex 636
#define loop_index mccchannel_13_analyzer_2_array_crystal_array_1_loop_index
#define this_box_volume mccchannel_13_analyzer_2_array_crystal_array_1_this_box_volume
#define global_geometry_element mccchannel_13_analyzer_2_array_crystal_array_1_global_geometry_element
#define this_box_storage mccchannel_13_analyzer_2_array_crystal_array_1_this_box_storage
{   /* Declarations of channel_13_analyzer_2_array_crystal_array_1=Union_box() SETTING parameters. */
char* material_string = mccchannel_13_analyzer_2_array_crystal_array_1_material_string;
MCNUM priority = mccchannel_13_analyzer_2_array_crystal_array_1_priority;
MCNUM xwidth = mccchannel_13_analyzer_2_array_crystal_array_1_xwidth;
MCNUM yheight = mccchannel_13_analyzer_2_array_crystal_array_1_yheight;
MCNUM zdepth = mccchannel_13_analyzer_2_array_crystal_array_1_zdepth;
MCNUM xwidth2 = mccchannel_13_analyzer_2_array_crystal_array_1_xwidth2;
MCNUM yheight2 = mccchannel_13_analyzer_2_array_crystal_array_1_yheight2;
MCNUM visualize = mccchannel_13_analyzer_2_array_crystal_array_1_visualize;
int target_index = mccchannel_13_analyzer_2_array_crystal_array_1_target_index;
MCNUM target_x = mccchannel_13_analyzer_2_array_crystal_array_1_target_x;
MCNUM target_y = mccchannel_13_analyzer_2_array_crystal_array_1_target_y;
MCNUM target_z = mccchannel_13_analyzer_2_array_crystal_array_1_target_z;
MCNUM focus_aw = mccchannel_13_analyzer_2_array_crystal_array_1_focus_aw;
MCNUM focus_ah = mccchannel_13_analyzer_2_array_crystal_array_1_focus_ah;
MCNUM focus_xw = mccchannel_13_analyzer_2_array_crystal_array_1_focus_xw;
MCNUM focus_xh = mccchannel_13_analyzer_2_array_crystal_array_1_focus_xh;
MCNUM focus_r = mccchannel_13_analyzer_2_array_crystal_array_1_focus_r;
MCNUM p_interact = mccchannel_13_analyzer_2_array_crystal_array_1_p_interact;
char* mask_string = mccchannel_13_analyzer_2_array_crystal_array_1_mask_string;
char* mask_setting = mccchannel_13_analyzer_2_array_crystal_array_1_mask_setting;
MCNUM number_of_activations = mccchannel_13_analyzer_2_array_crystal_array_1_number_of_activations;
}   /* End of channel_13_analyzer_2_array_crystal_array_1=Union_box() SETTING parameter declarations. */
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex
  /* Label for restoring  neutron */
  mcabsorbCompchannel_13_analyzer_2_array_crystal_array_1:
  if (RESTORE) /* restore if needed */
  { RESTORE_NEUTRON(636,
      mcnlx,
      mcnly,
      mcnlz,
      mcnlvx,
      mcnlvy,
      mcnlvz,
      mcnlt,
      mcnlsx,
      mcnlsy,
      mcnlsz,
      mcnlp); }
#undef mcabsorbComp
#undef p
#undef sz
#undef sy
#undef sx
#undef t
#undef vz
#undef vy
#undef vx
#undef z
#undef y
#undef x
  mcDEBUG_STATE(
mcnlx,
mcnly,
mcnlz,
mcnlvx,
mcnlvy,
mcnlvz,
mcnlt,
mcnlsx,
mcnlsy,
mcnlsz,
mcnlp)

  /* TRACE Component channel_13_analyzer_2_array_crystal_array_2 [637] */
  mccoordschange(mcposrchannel_13_analyzer_2_array_crystal_array_2, mcrotrchannel_13_analyzer_2_array_crystal_array_2,
    &mcnlx,
    &mcnly,
    &mcnlz,
    &mcnlvx,
    &mcnlvy,
    &mcnlvz,
    &mcnlsx,
    &mcnlsy,
    &mcnlsz);
  /* define label inside component channel_13_analyzer_2_array_crystal_array_2 (without coords transformations) */
  mcJumpTrace_channel_13_analyzer_2_array_crystal_array_2:
  SIG_MESSAGE("channel_13_analyzer_2_array_crystal_array_2 (Trace)");
  mcDEBUG_COMP("channel_13_analyzer_2_array_crystal_array_2")
  mcDEBUG_STATE(
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp)
#define x mcnlx
#define y mcnly
#define z mcnlz
#define vx mcnlvx
#define vy mcnlvy
#define vz mcnlvz
#define t mcnlt
#define sx mcnlsx
#define sy mcnlsy
#define sz mcnlsz
#define p mcnlp

#define mcabsorbComp mcabsorbCompchannel_13_analyzer_2_array_crystal_array_2
  STORE_NEUTRON(637,
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp);
  mcScattered=0;
  mcRestore=0;
  mcNCounter[637]++;
  mcPCounter[637] += p;
  mcP2Counter[637] += p*p;
#define mccompcurname  channel_13_analyzer_2_array_crystal_array_2
#define mccompcurtype  Union_box
#define mccompcurindex 637
#define loop_index mccchannel_13_analyzer_2_array_crystal_array_2_loop_index
#define this_box_volume mccchannel_13_analyzer_2_array_crystal_array_2_this_box_volume
#define global_geometry_element mccchannel_13_analyzer_2_array_crystal_array_2_global_geometry_element
#define this_box_storage mccchannel_13_analyzer_2_array_crystal_array_2_this_box_storage
{   /* Declarations of channel_13_analyzer_2_array_crystal_array_2=Union_box() SETTING parameters. */
char* material_string = mccchannel_13_analyzer_2_array_crystal_array_2_material_string;
MCNUM priority = mccchannel_13_analyzer_2_array_crystal_array_2_priority;
MCNUM xwidth = mccchannel_13_analyzer_2_array_crystal_array_2_xwidth;
MCNUM yheight = mccchannel_13_analyzer_2_array_crystal_array_2_yheight;
MCNUM zdepth = mccchannel_13_analyzer_2_array_crystal_array_2_zdepth;
MCNUM xwidth2 = mccchannel_13_analyzer_2_array_crystal_array_2_xwidth2;
MCNUM yheight2 = mccchannel_13_analyzer_2_array_crystal_array_2_yheight2;
MCNUM visualize = mccchannel_13_analyzer_2_array_crystal_array_2_visualize;
int target_index = mccchannel_13_analyzer_2_array_crystal_array_2_target_index;
MCNUM target_x = mccchannel_13_analyzer_2_array_crystal_array_2_target_x;
MCNUM target_y = mccchannel_13_analyzer_2_array_crystal_array_2_target_y;
MCNUM target_z = mccchannel_13_analyzer_2_array_crystal_array_2_target_z;
MCNUM focus_aw = mccchannel_13_analyzer_2_array_crystal_array_2_focus_aw;
MCNUM focus_ah = mccchannel_13_analyzer_2_array_crystal_array_2_focus_ah;
MCNUM focus_xw = mccchannel_13_analyzer_2_array_crystal_array_2_focus_xw;
MCNUM focus_xh = mccchannel_13_analyzer_2_array_crystal_array_2_focus_xh;
MCNUM focus_r = mccchannel_13_analyzer_2_array_crystal_array_2_focus_r;
MCNUM p_interact = mccchannel_13_analyzer_2_array_crystal_array_2_p_interact;
char* mask_string = mccchannel_13_analyzer_2_array_crystal_array_2_mask_string;
char* mask_setting = mccchannel_13_analyzer_2_array_crystal_array_2_mask_setting;
MCNUM number_of_activations = mccchannel_13_analyzer_2_array_crystal_array_2_number_of_activations;
}   /* End of channel_13_analyzer_2_array_crystal_array_2=Union_box() SETTING parameter declarations. */
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex
  /* Label for restoring  neutron */
  mcabsorbCompchannel_13_analyzer_2_array_crystal_array_2:
  if (RESTORE) /* restore if needed */
  { RESTORE_NEUTRON(637,
      mcnlx,
      mcnly,
      mcnlz,
      mcnlvx,
      mcnlvy,
      mcnlvz,
      mcnlt,
      mcnlsx,
      mcnlsy,
      mcnlsz,
      mcnlp); }
#undef mcabsorbComp
#undef p
#undef sz
#undef sy
#undef sx
#undef t
#undef vz
#undef vy
#undef vx
#undef z
#undef y
#undef x
  mcDEBUG_STATE(
mcnlx,
mcnly,
mcnlz,
mcnlvx,
mcnlvy,
mcnlvz,
mcnlt,
mcnlsx,
mcnlsy,
mcnlsz,
mcnlp)

  /* TRACE Component channel_13_analyzer_2_array_crystal_array_3 [638] */
  mccoordschange(mcposrchannel_13_analyzer_2_array_crystal_array_3, mcrotrchannel_13_analyzer_2_array_crystal_array_3,
    &mcnlx,
    &mcnly,
    &mcnlz,
    &mcnlvx,
    &mcnlvy,
    &mcnlvz,
    &mcnlsx,
    &mcnlsy,
    &mcnlsz);
  /* define label inside component channel_13_analyzer_2_array_crystal_array_3 (without coords transformations) */
  mcJumpTrace_channel_13_analyzer_2_array_crystal_array_3:
  SIG_MESSAGE("channel_13_analyzer_2_array_crystal_array_3 (Trace)");
  mcDEBUG_COMP("channel_13_analyzer_2_array_crystal_array_3")
  mcDEBUG_STATE(
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp)
#define x mcnlx
#define y mcnly
#define z mcnlz
#define vx mcnlvx
#define vy mcnlvy
#define vz mcnlvz
#define t mcnlt
#define sx mcnlsx
#define sy mcnlsy
#define sz mcnlsz
#define p mcnlp

#define mcabsorbComp mcabsorbCompchannel_13_analyzer_2_array_crystal_array_3
  STORE_NEUTRON(638,
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp);
  mcScattered=0;
  mcRestore=0;
  mcNCounter[638]++;
  mcPCounter[638] += p;
  mcP2Counter[638] += p*p;
#define mccompcurname  channel_13_analyzer_2_array_crystal_array_3
#define mccompcurtype  Union_box
#define mccompcurindex 638
#define loop_index mccchannel_13_analyzer_2_array_crystal_array_3_loop_index
#define this_box_volume mccchannel_13_analyzer_2_array_crystal_array_3_this_box_volume
#define global_geometry_element mccchannel_13_analyzer_2_array_crystal_array_3_global_geometry_element
#define this_box_storage mccchannel_13_analyzer_2_array_crystal_array_3_this_box_storage
{   /* Declarations of channel_13_analyzer_2_array_crystal_array_3=Union_box() SETTING parameters. */
char* material_string = mccchannel_13_analyzer_2_array_crystal_array_3_material_string;
MCNUM priority = mccchannel_13_analyzer_2_array_crystal_array_3_priority;
MCNUM xwidth = mccchannel_13_analyzer_2_array_crystal_array_3_xwidth;
MCNUM yheight = mccchannel_13_analyzer_2_array_crystal_array_3_yheight;
MCNUM zdepth = mccchannel_13_analyzer_2_array_crystal_array_3_zdepth;
MCNUM xwidth2 = mccchannel_13_analyzer_2_array_crystal_array_3_xwidth2;
MCNUM yheight2 = mccchannel_13_analyzer_2_array_crystal_array_3_yheight2;
MCNUM visualize = mccchannel_13_analyzer_2_array_crystal_array_3_visualize;
int target_index = mccchannel_13_analyzer_2_array_crystal_array_3_target_index;
MCNUM target_x = mccchannel_13_analyzer_2_array_crystal_array_3_target_x;
MCNUM target_y = mccchannel_13_analyzer_2_array_crystal_array_3_target_y;
MCNUM target_z = mccchannel_13_analyzer_2_array_crystal_array_3_target_z;
MCNUM focus_aw = mccchannel_13_analyzer_2_array_crystal_array_3_focus_aw;
MCNUM focus_ah = mccchannel_13_analyzer_2_array_crystal_array_3_focus_ah;
MCNUM focus_xw = mccchannel_13_analyzer_2_array_crystal_array_3_focus_xw;
MCNUM focus_xh = mccchannel_13_analyzer_2_array_crystal_array_3_focus_xh;
MCNUM focus_r = mccchannel_13_analyzer_2_array_crystal_array_3_focus_r;
MCNUM p_interact = mccchannel_13_analyzer_2_array_crystal_array_3_p_interact;
char* mask_string = mccchannel_13_analyzer_2_array_crystal_array_3_mask_string;
char* mask_setting = mccchannel_13_analyzer_2_array_crystal_array_3_mask_setting;
MCNUM number_of_activations = mccchannel_13_analyzer_2_array_crystal_array_3_number_of_activations;
}   /* End of channel_13_analyzer_2_array_crystal_array_3=Union_box() SETTING parameter declarations. */
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex
  /* Label for restoring  neutron */
  mcabsorbCompchannel_13_analyzer_2_array_crystal_array_3:
  if (RESTORE) /* restore if needed */
  { RESTORE_NEUTRON(638,
      mcnlx,
      mcnly,
      mcnlz,
      mcnlvx,
      mcnlvy,
      mcnlvz,
      mcnlt,
      mcnlsx,
      mcnlsy,
      mcnlsz,
      mcnlp); }
#undef mcabsorbComp
#undef p
#undef sz
#undef sy
#undef sx
#undef t
#undef vz
#undef vy
#undef vx
#undef z
#undef y
#undef x
  mcDEBUG_STATE(
mcnlx,
mcnly,
mcnlz,
mcnlvx,
mcnlvy,
mcnlvz,
mcnlt,
mcnlsx,
mcnlsy,
mcnlsz,
mcnlp)

  /* TRACE Component channel_13_analyzer_2_array_crystal_array_4 [639] */
  mccoordschange(mcposrchannel_13_analyzer_2_array_crystal_array_4, mcrotrchannel_13_analyzer_2_array_crystal_array_4,
    &mcnlx,
    &mcnly,
    &mcnlz,
    &mcnlvx,
    &mcnlvy,
    &mcnlvz,
    &mcnlsx,
    &mcnlsy,
    &mcnlsz);
  /* define label inside component channel_13_analyzer_2_array_crystal_array_4 (without coords transformations) */
  mcJumpTrace_channel_13_analyzer_2_array_crystal_array_4:
  SIG_MESSAGE("channel_13_analyzer_2_array_crystal_array_4 (Trace)");
  mcDEBUG_COMP("channel_13_analyzer_2_array_crystal_array_4")
  mcDEBUG_STATE(
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp)
#define x mcnlx
#define y mcnly
#define z mcnlz
#define vx mcnlvx
#define vy mcnlvy
#define vz mcnlvz
#define t mcnlt
#define sx mcnlsx
#define sy mcnlsy
#define sz mcnlsz
#define p mcnlp

#define mcabsorbComp mcabsorbCompchannel_13_analyzer_2_array_crystal_array_4
  STORE_NEUTRON(639,
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp);
  mcScattered=0;
  mcRestore=0;
  mcNCounter[639]++;
  mcPCounter[639] += p;
  mcP2Counter[639] += p*p;
#define mccompcurname  channel_13_analyzer_2_array_crystal_array_4
#define mccompcurtype  Union_box
#define mccompcurindex 639
#define loop_index mccchannel_13_analyzer_2_array_crystal_array_4_loop_index
#define this_box_volume mccchannel_13_analyzer_2_array_crystal_array_4_this_box_volume
#define global_geometry_element mccchannel_13_analyzer_2_array_crystal_array_4_global_geometry_element
#define this_box_storage mccchannel_13_analyzer_2_array_crystal_array_4_this_box_storage
{   /* Declarations of channel_13_analyzer_2_array_crystal_array_4=Union_box() SETTING parameters. */
char* material_string = mccchannel_13_analyzer_2_array_crystal_array_4_material_string;
MCNUM priority = mccchannel_13_analyzer_2_array_crystal_array_4_priority;
MCNUM xwidth = mccchannel_13_analyzer_2_array_crystal_array_4_xwidth;
MCNUM yheight = mccchannel_13_analyzer_2_array_crystal_array_4_yheight;
MCNUM zdepth = mccchannel_13_analyzer_2_array_crystal_array_4_zdepth;
MCNUM xwidth2 = mccchannel_13_analyzer_2_array_crystal_array_4_xwidth2;
MCNUM yheight2 = mccchannel_13_analyzer_2_array_crystal_array_4_yheight2;
MCNUM visualize = mccchannel_13_analyzer_2_array_crystal_array_4_visualize;
int target_index = mccchannel_13_analyzer_2_array_crystal_array_4_target_index;
MCNUM target_x = mccchannel_13_analyzer_2_array_crystal_array_4_target_x;
MCNUM target_y = mccchannel_13_analyzer_2_array_crystal_array_4_target_y;
MCNUM target_z = mccchannel_13_analyzer_2_array_crystal_array_4_target_z;
MCNUM focus_aw = mccchannel_13_analyzer_2_array_crystal_array_4_focus_aw;
MCNUM focus_ah = mccchannel_13_analyzer_2_array_crystal_array_4_focus_ah;
MCNUM focus_xw = mccchannel_13_analyzer_2_array_crystal_array_4_focus_xw;
MCNUM focus_xh = mccchannel_13_analyzer_2_array_crystal_array_4_focus_xh;
MCNUM focus_r = mccchannel_13_analyzer_2_array_crystal_array_4_focus_r;
MCNUM p_interact = mccchannel_13_analyzer_2_array_crystal_array_4_p_interact;
char* mask_string = mccchannel_13_analyzer_2_array_crystal_array_4_mask_string;
char* mask_setting = mccchannel_13_analyzer_2_array_crystal_array_4_mask_setting;
MCNUM number_of_activations = mccchannel_13_analyzer_2_array_crystal_array_4_number_of_activations;
}   /* End of channel_13_analyzer_2_array_crystal_array_4=Union_box() SETTING parameter declarations. */
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex
  /* Label for restoring  neutron */
  mcabsorbCompchannel_13_analyzer_2_array_crystal_array_4:
  if (RESTORE) /* restore if needed */
  { RESTORE_NEUTRON(639,
      mcnlx,
      mcnly,
      mcnlz,
      mcnlvx,
      mcnlvy,
      mcnlvz,
      mcnlt,
      mcnlsx,
      mcnlsy,
      mcnlsz,
      mcnlp); }
#undef mcabsorbComp
#undef p
#undef sz
#undef sy
#undef sx
#undef t
#undef vz
#undef vy
#undef vx
#undef z
#undef y
#undef x
  mcDEBUG_STATE(
mcnlx,
mcnly,
mcnlz,
mcnlvx,
mcnlvy,
mcnlvz,
mcnlt,
mcnlsx,
mcnlsy,
mcnlsz,
mcnlp)

  /* TRACE Component channel_13_analyzer_2_array_crystal_array_5 [640] */
  mccoordschange(mcposrchannel_13_analyzer_2_array_crystal_array_5, mcrotrchannel_13_analyzer_2_array_crystal_array_5,
    &mcnlx,
    &mcnly,
    &mcnlz,
    &mcnlvx,
    &mcnlvy,
    &mcnlvz,
    &mcnlsx,
    &mcnlsy,
    &mcnlsz);
  /* define label inside component channel_13_analyzer_2_array_crystal_array_5 (without coords transformations) */
  mcJumpTrace_channel_13_analyzer_2_array_crystal_array_5:
  SIG_MESSAGE("channel_13_analyzer_2_array_crystal_array_5 (Trace)");
  mcDEBUG_COMP("channel_13_analyzer_2_array_crystal_array_5")
  mcDEBUG_STATE(
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp)
#define x mcnlx
#define y mcnly
#define z mcnlz
#define vx mcnlvx
#define vy mcnlvy
#define vz mcnlvz
#define t mcnlt
#define sx mcnlsx
#define sy mcnlsy
#define sz mcnlsz
#define p mcnlp

#define mcabsorbComp mcabsorbCompchannel_13_analyzer_2_array_crystal_array_5
  STORE_NEUTRON(640,
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp);
  mcScattered=0;
  mcRestore=0;
  mcNCounter[640]++;
  mcPCounter[640] += p;
  mcP2Counter[640] += p*p;
#define mccompcurname  channel_13_analyzer_2_array_crystal_array_5
#define mccompcurtype  Union_box
#define mccompcurindex 640
#define loop_index mccchannel_13_analyzer_2_array_crystal_array_5_loop_index
#define this_box_volume mccchannel_13_analyzer_2_array_crystal_array_5_this_box_volume
#define global_geometry_element mccchannel_13_analyzer_2_array_crystal_array_5_global_geometry_element
#define this_box_storage mccchannel_13_analyzer_2_array_crystal_array_5_this_box_storage
{   /* Declarations of channel_13_analyzer_2_array_crystal_array_5=Union_box() SETTING parameters. */
char* material_string = mccchannel_13_analyzer_2_array_crystal_array_5_material_string;
MCNUM priority = mccchannel_13_analyzer_2_array_crystal_array_5_priority;
MCNUM xwidth = mccchannel_13_analyzer_2_array_crystal_array_5_xwidth;
MCNUM yheight = mccchannel_13_analyzer_2_array_crystal_array_5_yheight;
MCNUM zdepth = mccchannel_13_analyzer_2_array_crystal_array_5_zdepth;
MCNUM xwidth2 = mccchannel_13_analyzer_2_array_crystal_array_5_xwidth2;
MCNUM yheight2 = mccchannel_13_analyzer_2_array_crystal_array_5_yheight2;
MCNUM visualize = mccchannel_13_analyzer_2_array_crystal_array_5_visualize;
int target_index = mccchannel_13_analyzer_2_array_crystal_array_5_target_index;
MCNUM target_x = mccchannel_13_analyzer_2_array_crystal_array_5_target_x;
MCNUM target_y = mccchannel_13_analyzer_2_array_crystal_array_5_target_y;
MCNUM target_z = mccchannel_13_analyzer_2_array_crystal_array_5_target_z;
MCNUM focus_aw = mccchannel_13_analyzer_2_array_crystal_array_5_focus_aw;
MCNUM focus_ah = mccchannel_13_analyzer_2_array_crystal_array_5_focus_ah;
MCNUM focus_xw = mccchannel_13_analyzer_2_array_crystal_array_5_focus_xw;
MCNUM focus_xh = mccchannel_13_analyzer_2_array_crystal_array_5_focus_xh;
MCNUM focus_r = mccchannel_13_analyzer_2_array_crystal_array_5_focus_r;
MCNUM p_interact = mccchannel_13_analyzer_2_array_crystal_array_5_p_interact;
char* mask_string = mccchannel_13_analyzer_2_array_crystal_array_5_mask_string;
char* mask_setting = mccchannel_13_analyzer_2_array_crystal_array_5_mask_setting;
MCNUM number_of_activations = mccchannel_13_analyzer_2_array_crystal_array_5_number_of_activations;
}   /* End of channel_13_analyzer_2_array_crystal_array_5=Union_box() SETTING parameter declarations. */
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex
  /* Label for restoring  neutron */
  mcabsorbCompchannel_13_analyzer_2_array_crystal_array_5:
  if (RESTORE) /* restore if needed */
  { RESTORE_NEUTRON(640,
      mcnlx,
      mcnly,
      mcnlz,
      mcnlvx,
      mcnlvy,
      mcnlvz,
      mcnlt,
      mcnlsx,
      mcnlsy,
      mcnlsz,
      mcnlp); }
#undef mcabsorbComp
#undef p
#undef sz
#undef sy
#undef sx
#undef t
#undef vz
#undef vy
#undef vx
#undef z
#undef y
#undef x
  mcDEBUG_STATE(
mcnlx,
mcnly,
mcnlz,
mcnlvx,
mcnlvy,
mcnlvz,
mcnlt,
mcnlsx,
mcnlsy,
mcnlsz,
mcnlp)

  /* TRACE Component channel_13_analyzer_2_array_crystal_array_6 [641] */
  mccoordschange(mcposrchannel_13_analyzer_2_array_crystal_array_6, mcrotrchannel_13_analyzer_2_array_crystal_array_6,
    &mcnlx,
    &mcnly,
    &mcnlz,
    &mcnlvx,
    &mcnlvy,
    &mcnlvz,
    &mcnlsx,
    &mcnlsy,
    &mcnlsz);
  /* define label inside component channel_13_analyzer_2_array_crystal_array_6 (without coords transformations) */
  mcJumpTrace_channel_13_analyzer_2_array_crystal_array_6:
  SIG_MESSAGE("channel_13_analyzer_2_array_crystal_array_6 (Trace)");
  mcDEBUG_COMP("channel_13_analyzer_2_array_crystal_array_6")
  mcDEBUG_STATE(
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp)
#define x mcnlx
#define y mcnly
#define z mcnlz
#define vx mcnlvx
#define vy mcnlvy
#define vz mcnlvz
#define t mcnlt
#define sx mcnlsx
#define sy mcnlsy
#define sz mcnlsz
#define p mcnlp

#define mcabsorbComp mcabsorbCompchannel_13_analyzer_2_array_crystal_array_6
  STORE_NEUTRON(641,
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp);
  mcScattered=0;
  mcRestore=0;
  mcNCounter[641]++;
  mcPCounter[641] += p;
  mcP2Counter[641] += p*p;
#define mccompcurname  channel_13_analyzer_2_array_crystal_array_6
#define mccompcurtype  Union_box
#define mccompcurindex 641
#define loop_index mccchannel_13_analyzer_2_array_crystal_array_6_loop_index
#define this_box_volume mccchannel_13_analyzer_2_array_crystal_array_6_this_box_volume
#define global_geometry_element mccchannel_13_analyzer_2_array_crystal_array_6_global_geometry_element
#define this_box_storage mccchannel_13_analyzer_2_array_crystal_array_6_this_box_storage
{   /* Declarations of channel_13_analyzer_2_array_crystal_array_6=Union_box() SETTING parameters. */
char* material_string = mccchannel_13_analyzer_2_array_crystal_array_6_material_string;
MCNUM priority = mccchannel_13_analyzer_2_array_crystal_array_6_priority;
MCNUM xwidth = mccchannel_13_analyzer_2_array_crystal_array_6_xwidth;
MCNUM yheight = mccchannel_13_analyzer_2_array_crystal_array_6_yheight;
MCNUM zdepth = mccchannel_13_analyzer_2_array_crystal_array_6_zdepth;
MCNUM xwidth2 = mccchannel_13_analyzer_2_array_crystal_array_6_xwidth2;
MCNUM yheight2 = mccchannel_13_analyzer_2_array_crystal_array_6_yheight2;
MCNUM visualize = mccchannel_13_analyzer_2_array_crystal_array_6_visualize;
int target_index = mccchannel_13_analyzer_2_array_crystal_array_6_target_index;
MCNUM target_x = mccchannel_13_analyzer_2_array_crystal_array_6_target_x;
MCNUM target_y = mccchannel_13_analyzer_2_array_crystal_array_6_target_y;
MCNUM target_z = mccchannel_13_analyzer_2_array_crystal_array_6_target_z;
MCNUM focus_aw = mccchannel_13_analyzer_2_array_crystal_array_6_focus_aw;
MCNUM focus_ah = mccchannel_13_analyzer_2_array_crystal_array_6_focus_ah;
MCNUM focus_xw = mccchannel_13_analyzer_2_array_crystal_array_6_focus_xw;
MCNUM focus_xh = mccchannel_13_analyzer_2_array_crystal_array_6_focus_xh;
MCNUM focus_r = mccchannel_13_analyzer_2_array_crystal_array_6_focus_r;
MCNUM p_interact = mccchannel_13_analyzer_2_array_crystal_array_6_p_interact;
char* mask_string = mccchannel_13_analyzer_2_array_crystal_array_6_mask_string;
char* mask_setting = mccchannel_13_analyzer_2_array_crystal_array_6_mask_setting;
MCNUM number_of_activations = mccchannel_13_analyzer_2_array_crystal_array_6_number_of_activations;
}   /* End of channel_13_analyzer_2_array_crystal_array_6=Union_box() SETTING parameter declarations. */
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex
  /* Label for restoring  neutron */
  mcabsorbCompchannel_13_analyzer_2_array_crystal_array_6:
  if (RESTORE) /* restore if needed */
  { RESTORE_NEUTRON(641,
      mcnlx,
      mcnly,
      mcnlz,
      mcnlvx,
      mcnlvy,
      mcnlvz,
      mcnlt,
      mcnlsx,
      mcnlsy,
      mcnlsz,
      mcnlp); }
#undef mcabsorbComp
#undef p
#undef sz
#undef sy
#undef sx
#undef t
#undef vz
#undef vy
#undef vx
#undef z
#undef y
#undef x
  mcDEBUG_STATE(
mcnlx,
mcnly,
mcnlz,
mcnlvx,
mcnlvy,
mcnlvz,
mcnlt,
mcnlsx,
mcnlsy,
mcnlsz,
mcnlp)

  /* TRACE Component channel_13_analyzer_2_array_crystal_array_7 [642] */
  mccoordschange(mcposrchannel_13_analyzer_2_array_crystal_array_7, mcrotrchannel_13_analyzer_2_array_crystal_array_7,
    &mcnlx,
    &mcnly,
    &mcnlz,
    &mcnlvx,
    &mcnlvy,
    &mcnlvz,
    &mcnlsx,
    &mcnlsy,
    &mcnlsz);
  /* define label inside component channel_13_analyzer_2_array_crystal_array_7 (without coords transformations) */
  mcJumpTrace_channel_13_analyzer_2_array_crystal_array_7:
  SIG_MESSAGE("channel_13_analyzer_2_array_crystal_array_7 (Trace)");
  mcDEBUG_COMP("channel_13_analyzer_2_array_crystal_array_7")
  mcDEBUG_STATE(
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp)
#define x mcnlx
#define y mcnly
#define z mcnlz
#define vx mcnlvx
#define vy mcnlvy
#define vz mcnlvz
#define t mcnlt
#define sx mcnlsx
#define sy mcnlsy
#define sz mcnlsz
#define p mcnlp

#define mcabsorbComp mcabsorbCompchannel_13_analyzer_2_array_crystal_array_7
  STORE_NEUTRON(642,
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp);
  mcScattered=0;
  mcRestore=0;
  mcNCounter[642]++;
  mcPCounter[642] += p;
  mcP2Counter[642] += p*p;
#define mccompcurname  channel_13_analyzer_2_array_crystal_array_7
#define mccompcurtype  Union_box
#define mccompcurindex 642
#define loop_index mccchannel_13_analyzer_2_array_crystal_array_7_loop_index
#define this_box_volume mccchannel_13_analyzer_2_array_crystal_array_7_this_box_volume
#define global_geometry_element mccchannel_13_analyzer_2_array_crystal_array_7_global_geometry_element
#define this_box_storage mccchannel_13_analyzer_2_array_crystal_array_7_this_box_storage
{   /* Declarations of channel_13_analyzer_2_array_crystal_array_7=Union_box() SETTING parameters. */
char* material_string = mccchannel_13_analyzer_2_array_crystal_array_7_material_string;
MCNUM priority = mccchannel_13_analyzer_2_array_crystal_array_7_priority;
MCNUM xwidth = mccchannel_13_analyzer_2_array_crystal_array_7_xwidth;
MCNUM yheight = mccchannel_13_analyzer_2_array_crystal_array_7_yheight;
MCNUM zdepth = mccchannel_13_analyzer_2_array_crystal_array_7_zdepth;
MCNUM xwidth2 = mccchannel_13_analyzer_2_array_crystal_array_7_xwidth2;
MCNUM yheight2 = mccchannel_13_analyzer_2_array_crystal_array_7_yheight2;
MCNUM visualize = mccchannel_13_analyzer_2_array_crystal_array_7_visualize;
int target_index = mccchannel_13_analyzer_2_array_crystal_array_7_target_index;
MCNUM target_x = mccchannel_13_analyzer_2_array_crystal_array_7_target_x;
MCNUM target_y = mccchannel_13_analyzer_2_array_crystal_array_7_target_y;
MCNUM target_z = mccchannel_13_analyzer_2_array_crystal_array_7_target_z;
MCNUM focus_aw = mccchannel_13_analyzer_2_array_crystal_array_7_focus_aw;
MCNUM focus_ah = mccchannel_13_analyzer_2_array_crystal_array_7_focus_ah;
MCNUM focus_xw = mccchannel_13_analyzer_2_array_crystal_array_7_focus_xw;
MCNUM focus_xh = mccchannel_13_analyzer_2_array_crystal_array_7_focus_xh;
MCNUM focus_r = mccchannel_13_analyzer_2_array_crystal_array_7_focus_r;
MCNUM p_interact = mccchannel_13_analyzer_2_array_crystal_array_7_p_interact;
char* mask_string = mccchannel_13_analyzer_2_array_crystal_array_7_mask_string;
char* mask_setting = mccchannel_13_analyzer_2_array_crystal_array_7_mask_setting;
MCNUM number_of_activations = mccchannel_13_analyzer_2_array_crystal_array_7_number_of_activations;
}   /* End of channel_13_analyzer_2_array_crystal_array_7=Union_box() SETTING parameter declarations. */
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex
  /* Label for restoring  neutron */
  mcabsorbCompchannel_13_analyzer_2_array_crystal_array_7:
  if (RESTORE) /* restore if needed */
  { RESTORE_NEUTRON(642,
      mcnlx,
      mcnly,
      mcnlz,
      mcnlvx,
      mcnlvy,
      mcnlvz,
      mcnlt,
      mcnlsx,
      mcnlsy,
      mcnlsz,
      mcnlp); }
#undef mcabsorbComp
#undef p
#undef sz
#undef sy
#undef sx
#undef t
#undef vz
#undef vy
#undef vx
#undef z
#undef y
#undef x
  mcDEBUG_STATE(
mcnlx,
mcnly,
mcnlz,
mcnlvx,
mcnlvy,
mcnlvz,
mcnlt,
mcnlsx,
mcnlsy,
mcnlsz,
mcnlp)

  /* TRACE Component channel_13_analyzer_2_array_crystal_array_8 [643] */
  mccoordschange(mcposrchannel_13_analyzer_2_array_crystal_array_8, mcrotrchannel_13_analyzer_2_array_crystal_array_8,
    &mcnlx,
    &mcnly,
    &mcnlz,
    &mcnlvx,
    &mcnlvy,
    &mcnlvz,
    &mcnlsx,
    &mcnlsy,
    &mcnlsz);
  /* define label inside component channel_13_analyzer_2_array_crystal_array_8 (without coords transformations) */
  mcJumpTrace_channel_13_analyzer_2_array_crystal_array_8:
  SIG_MESSAGE("channel_13_analyzer_2_array_crystal_array_8 (Trace)");
  mcDEBUG_COMP("channel_13_analyzer_2_array_crystal_array_8")
  mcDEBUG_STATE(
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp)
#define x mcnlx
#define y mcnly
#define z mcnlz
#define vx mcnlvx
#define vy mcnlvy
#define vz mcnlvz
#define t mcnlt
#define sx mcnlsx
#define sy mcnlsy
#define sz mcnlsz
#define p mcnlp

#define mcabsorbComp mcabsorbCompchannel_13_analyzer_2_array_crystal_array_8
  STORE_NEUTRON(643,
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp);
  mcScattered=0;
  mcRestore=0;
  mcNCounter[643]++;
  mcPCounter[643] += p;
  mcP2Counter[643] += p*p;
#define mccompcurname  channel_13_analyzer_2_array_crystal_array_8
#define mccompcurtype  Union_box
#define mccompcurindex 643
#define loop_index mccchannel_13_analyzer_2_array_crystal_array_8_loop_index
#define this_box_volume mccchannel_13_analyzer_2_array_crystal_array_8_this_box_volume
#define global_geometry_element mccchannel_13_analyzer_2_array_crystal_array_8_global_geometry_element
#define this_box_storage mccchannel_13_analyzer_2_array_crystal_array_8_this_box_storage
{   /* Declarations of channel_13_analyzer_2_array_crystal_array_8=Union_box() SETTING parameters. */
char* material_string = mccchannel_13_analyzer_2_array_crystal_array_8_material_string;
MCNUM priority = mccchannel_13_analyzer_2_array_crystal_array_8_priority;
MCNUM xwidth = mccchannel_13_analyzer_2_array_crystal_array_8_xwidth;
MCNUM yheight = mccchannel_13_analyzer_2_array_crystal_array_8_yheight;
MCNUM zdepth = mccchannel_13_analyzer_2_array_crystal_array_8_zdepth;
MCNUM xwidth2 = mccchannel_13_analyzer_2_array_crystal_array_8_xwidth2;
MCNUM yheight2 = mccchannel_13_analyzer_2_array_crystal_array_8_yheight2;
MCNUM visualize = mccchannel_13_analyzer_2_array_crystal_array_8_visualize;
int target_index = mccchannel_13_analyzer_2_array_crystal_array_8_target_index;
MCNUM target_x = mccchannel_13_analyzer_2_array_crystal_array_8_target_x;
MCNUM target_y = mccchannel_13_analyzer_2_array_crystal_array_8_target_y;
MCNUM target_z = mccchannel_13_analyzer_2_array_crystal_array_8_target_z;
MCNUM focus_aw = mccchannel_13_analyzer_2_array_crystal_array_8_focus_aw;
MCNUM focus_ah = mccchannel_13_analyzer_2_array_crystal_array_8_focus_ah;
MCNUM focus_xw = mccchannel_13_analyzer_2_array_crystal_array_8_focus_xw;
MCNUM focus_xh = mccchannel_13_analyzer_2_array_crystal_array_8_focus_xh;
MCNUM focus_r = mccchannel_13_analyzer_2_array_crystal_array_8_focus_r;
MCNUM p_interact = mccchannel_13_analyzer_2_array_crystal_array_8_p_interact;
char* mask_string = mccchannel_13_analyzer_2_array_crystal_array_8_mask_string;
char* mask_setting = mccchannel_13_analyzer_2_array_crystal_array_8_mask_setting;
MCNUM number_of_activations = mccchannel_13_analyzer_2_array_crystal_array_8_number_of_activations;
}   /* End of channel_13_analyzer_2_array_crystal_array_8=Union_box() SETTING parameter declarations. */
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex
  /* Label for restoring  neutron */
  mcabsorbCompchannel_13_analyzer_2_array_crystal_array_8:
  if (RESTORE) /* restore if needed */
  { RESTORE_NEUTRON(643,
      mcnlx,
      mcnly,
      mcnlz,
      mcnlvx,
      mcnlvy,
      mcnlvz,
      mcnlt,
      mcnlsx,
      mcnlsy,
      mcnlsz,
      mcnlp); }
#undef mcabsorbComp
#undef p
#undef sz
#undef sy
#undef sx
#undef t
#undef vz
#undef vy
#undef vx
#undef z
#undef y
#undef x
  mcDEBUG_STATE(
mcnlx,
mcnly,
mcnlz,
mcnlvx,
mcnlvy,
mcnlvz,
mcnlt,
mcnlsx,
mcnlsy,
mcnlsz,
mcnlp)

  /* TRACE Component channel_13_cave2_cyl1 [644] */
  mccoordschange(mcposrchannel_13_cave2_cyl1, mcrotrchannel_13_cave2_cyl1,
    &mcnlx,
    &mcnly,
    &mcnlz,
    &mcnlvx,
    &mcnlvy,
    &mcnlvz,
    &mcnlsx,
    &mcnlsy,
    &mcnlsz);
  /* define label inside component channel_13_cave2_cyl1 (without coords transformations) */
  mcJumpTrace_channel_13_cave2_cyl1:
  SIG_MESSAGE("channel_13_cave2_cyl1 (Trace)");
  mcDEBUG_COMP("channel_13_cave2_cyl1")
  mcDEBUG_STATE(
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp)
#define x mcnlx
#define y mcnly
#define z mcnlz
#define vx mcnlvx
#define vy mcnlvy
#define vz mcnlvz
#define t mcnlt
#define sx mcnlsx
#define sy mcnlsy
#define sz mcnlsz
#define p mcnlp

#define mcabsorbComp mcabsorbCompchannel_13_cave2_cyl1
  STORE_NEUTRON(644,
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp);
  mcScattered=0;
  mcRestore=0;
  mcNCounter[644]++;
  mcPCounter[644] += p;
  mcP2Counter[644] += p*p;
#define mccompcurname  channel_13_cave2_cyl1
#define mccompcurtype  Union_cylinder
#define mccompcurindex 644
#define loop_index mccchannel_13_cave2_cyl1_loop_index
#define this_cylinder_volume mccchannel_13_cave2_cyl1_this_cylinder_volume
#define global_geometry_element mccchannel_13_cave2_cyl1_global_geometry_element
#define this_cylinder_storage mccchannel_13_cave2_cyl1_this_cylinder_storage
{   /* Declarations of channel_13_cave2_cyl1=Union_cylinder() SETTING parameters. */
char* material_string = mccchannel_13_cave2_cyl1_material_string;
MCNUM priority = mccchannel_13_cave2_cyl1_priority;
MCNUM radius = mccchannel_13_cave2_cyl1_radius;
MCNUM yheight = mccchannel_13_cave2_cyl1_yheight;
MCNUM visualize = mccchannel_13_cave2_cyl1_visualize;
int target_index = mccchannel_13_cave2_cyl1_target_index;
MCNUM target_x = mccchannel_13_cave2_cyl1_target_x;
MCNUM target_y = mccchannel_13_cave2_cyl1_target_y;
MCNUM target_z = mccchannel_13_cave2_cyl1_target_z;
MCNUM focus_aw = mccchannel_13_cave2_cyl1_focus_aw;
MCNUM focus_ah = mccchannel_13_cave2_cyl1_focus_ah;
MCNUM focus_xw = mccchannel_13_cave2_cyl1_focus_xw;
MCNUM focus_xh = mccchannel_13_cave2_cyl1_focus_xh;
MCNUM focus_r = mccchannel_13_cave2_cyl1_focus_r;
MCNUM p_interact = mccchannel_13_cave2_cyl1_p_interact;
char* mask_string = mccchannel_13_cave2_cyl1_mask_string;
char* mask_setting = mccchannel_13_cave2_cyl1_mask_setting;
MCNUM number_of_activations = mccchannel_13_cave2_cyl1_number_of_activations;
#line 345 "Union_cylinder.comp"
{
dummy = 1;
}
#line 430251 "MACS_sample_kidney_box.c"
}   /* End of channel_13_cave2_cyl1=Union_cylinder() SETTING parameter declarations. */
#undef this_cylinder_storage
#undef global_geometry_element
#undef this_cylinder_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex
  /* Label for restoring  neutron */
  mcabsorbCompchannel_13_cave2_cyl1:
  if (RESTORE) /* restore if needed */
  { RESTORE_NEUTRON(644,
      mcnlx,
      mcnly,
      mcnlz,
      mcnlvx,
      mcnlvy,
      mcnlvz,
      mcnlt,
      mcnlsx,
      mcnlsy,
      mcnlsz,
      mcnlp); }
#undef mcabsorbComp
#undef p
#undef sz
#undef sy
#undef sx
#undef t
#undef vz
#undef vy
#undef vx
#undef z
#undef y
#undef x
  mcDEBUG_STATE(
mcnlx,
mcnly,
mcnlz,
mcnlvx,
mcnlvy,
mcnlvz,
mcnlt,
mcnlsx,
mcnlsy,
mcnlsz,
mcnlp)

  /* TRACE Component channel_13_cave2_box1 [645] */
  mccoordschange(mcposrchannel_13_cave2_box1, mcrotrchannel_13_cave2_box1,
    &mcnlx,
    &mcnly,
    &mcnlz,
    &mcnlvx,
    &mcnlvy,
    &mcnlvz,
    &mcnlsx,
    &mcnlsy,
    &mcnlsz);
  /* define label inside component channel_13_cave2_box1 (without coords transformations) */
  mcJumpTrace_channel_13_cave2_box1:
  SIG_MESSAGE("channel_13_cave2_box1 (Trace)");
  mcDEBUG_COMP("channel_13_cave2_box1")
  mcDEBUG_STATE(
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp)
#define x mcnlx
#define y mcnly
#define z mcnlz
#define vx mcnlvx
#define vy mcnlvy
#define vz mcnlvz
#define t mcnlt
#define sx mcnlsx
#define sy mcnlsy
#define sz mcnlsz
#define p mcnlp

#define mcabsorbComp mcabsorbCompchannel_13_cave2_box1
  STORE_NEUTRON(645,
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp);
  mcScattered=0;
  mcRestore=0;
  mcNCounter[645]++;
  mcPCounter[645] += p;
  mcP2Counter[645] += p*p;
#define mccompcurname  channel_13_cave2_box1
#define mccompcurtype  Union_box
#define mccompcurindex 645
#define loop_index mccchannel_13_cave2_box1_loop_index
#define this_box_volume mccchannel_13_cave2_box1_this_box_volume
#define global_geometry_element mccchannel_13_cave2_box1_global_geometry_element
#define this_box_storage mccchannel_13_cave2_box1_this_box_storage
{   /* Declarations of channel_13_cave2_box1=Union_box() SETTING parameters. */
char* material_string = mccchannel_13_cave2_box1_material_string;
MCNUM priority = mccchannel_13_cave2_box1_priority;
MCNUM xwidth = mccchannel_13_cave2_box1_xwidth;
MCNUM yheight = mccchannel_13_cave2_box1_yheight;
MCNUM zdepth = mccchannel_13_cave2_box1_zdepth;
MCNUM xwidth2 = mccchannel_13_cave2_box1_xwidth2;
MCNUM yheight2 = mccchannel_13_cave2_box1_yheight2;
MCNUM visualize = mccchannel_13_cave2_box1_visualize;
int target_index = mccchannel_13_cave2_box1_target_index;
MCNUM target_x = mccchannel_13_cave2_box1_target_x;
MCNUM target_y = mccchannel_13_cave2_box1_target_y;
MCNUM target_z = mccchannel_13_cave2_box1_target_z;
MCNUM focus_aw = mccchannel_13_cave2_box1_focus_aw;
MCNUM focus_ah = mccchannel_13_cave2_box1_focus_ah;
MCNUM focus_xw = mccchannel_13_cave2_box1_focus_xw;
MCNUM focus_xh = mccchannel_13_cave2_box1_focus_xh;
MCNUM focus_r = mccchannel_13_cave2_box1_focus_r;
MCNUM p_interact = mccchannel_13_cave2_box1_p_interact;
char* mask_string = mccchannel_13_cave2_box1_mask_string;
char* mask_setting = mccchannel_13_cave2_box1_mask_setting;
MCNUM number_of_activations = mccchannel_13_cave2_box1_number_of_activations;
}   /* End of channel_13_cave2_box1=Union_box() SETTING parameter declarations. */
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex
  /* Label for restoring  neutron */
  mcabsorbCompchannel_13_cave2_box1:
  if (RESTORE) /* restore if needed */
  { RESTORE_NEUTRON(645,
      mcnlx,
      mcnly,
      mcnlz,
      mcnlvx,
      mcnlvy,
      mcnlvz,
      mcnlt,
      mcnlsx,
      mcnlsy,
      mcnlsz,
      mcnlp); }
#undef mcabsorbComp
#undef p
#undef sz
#undef sy
#undef sx
#undef t
#undef vz
#undef vy
#undef vx
#undef z
#undef y
#undef x
  mcDEBUG_STATE(
mcnlx,
mcnly,
mcnlz,
mcnlvx,
mcnlvy,
mcnlvz,
mcnlt,
mcnlsx,
mcnlsy,
mcnlsz,
mcnlp)

  /* TRACE Component channel_13_cave2_box2 [646] */
  mccoordschange(mcposrchannel_13_cave2_box2, mcrotrchannel_13_cave2_box2,
    &mcnlx,
    &mcnly,
    &mcnlz,
    &mcnlvx,
    &mcnlvy,
    &mcnlvz,
    &mcnlsx,
    &mcnlsy,
    &mcnlsz);
  /* define label inside component channel_13_cave2_box2 (without coords transformations) */
  mcJumpTrace_channel_13_cave2_box2:
  SIG_MESSAGE("channel_13_cave2_box2 (Trace)");
  mcDEBUG_COMP("channel_13_cave2_box2")
  mcDEBUG_STATE(
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp)
#define x mcnlx
#define y mcnly
#define z mcnlz
#define vx mcnlvx
#define vy mcnlvy
#define vz mcnlvz
#define t mcnlt
#define sx mcnlsx
#define sy mcnlsy
#define sz mcnlsz
#define p mcnlp

#define mcabsorbComp mcabsorbCompchannel_13_cave2_box2
  STORE_NEUTRON(646,
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp);
  mcScattered=0;
  mcRestore=0;
  mcNCounter[646]++;
  mcPCounter[646] += p;
  mcP2Counter[646] += p*p;
#define mccompcurname  channel_13_cave2_box2
#define mccompcurtype  Union_box
#define mccompcurindex 646
#define loop_index mccchannel_13_cave2_box2_loop_index
#define this_box_volume mccchannel_13_cave2_box2_this_box_volume
#define global_geometry_element mccchannel_13_cave2_box2_global_geometry_element
#define this_box_storage mccchannel_13_cave2_box2_this_box_storage
{   /* Declarations of channel_13_cave2_box2=Union_box() SETTING parameters. */
char* material_string = mccchannel_13_cave2_box2_material_string;
MCNUM priority = mccchannel_13_cave2_box2_priority;
MCNUM xwidth = mccchannel_13_cave2_box2_xwidth;
MCNUM yheight = mccchannel_13_cave2_box2_yheight;
MCNUM zdepth = mccchannel_13_cave2_box2_zdepth;
MCNUM xwidth2 = mccchannel_13_cave2_box2_xwidth2;
MCNUM yheight2 = mccchannel_13_cave2_box2_yheight2;
MCNUM visualize = mccchannel_13_cave2_box2_visualize;
int target_index = mccchannel_13_cave2_box2_target_index;
MCNUM target_x = mccchannel_13_cave2_box2_target_x;
MCNUM target_y = mccchannel_13_cave2_box2_target_y;
MCNUM target_z = mccchannel_13_cave2_box2_target_z;
MCNUM focus_aw = mccchannel_13_cave2_box2_focus_aw;
MCNUM focus_ah = mccchannel_13_cave2_box2_focus_ah;
MCNUM focus_xw = mccchannel_13_cave2_box2_focus_xw;
MCNUM focus_xh = mccchannel_13_cave2_box2_focus_xh;
MCNUM focus_r = mccchannel_13_cave2_box2_focus_r;
MCNUM p_interact = mccchannel_13_cave2_box2_p_interact;
char* mask_string = mccchannel_13_cave2_box2_mask_string;
char* mask_setting = mccchannel_13_cave2_box2_mask_setting;
MCNUM number_of_activations = mccchannel_13_cave2_box2_number_of_activations;
}   /* End of channel_13_cave2_box2=Union_box() SETTING parameter declarations. */
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex
  /* Label for restoring  neutron */
  mcabsorbCompchannel_13_cave2_box2:
  if (RESTORE) /* restore if needed */
  { RESTORE_NEUTRON(646,
      mcnlx,
      mcnly,
      mcnlz,
      mcnlvx,
      mcnlvy,
      mcnlvz,
      mcnlt,
      mcnlsx,
      mcnlsy,
      mcnlsz,
      mcnlp); }
#undef mcabsorbComp
#undef p
#undef sz
#undef sy
#undef sx
#undef t
#undef vz
#undef vy
#undef vx
#undef z
#undef y
#undef x
  mcDEBUG_STATE(
mcnlx,
mcnly,
mcnlz,
mcnlvx,
mcnlvy,
mcnlvz,
mcnlt,
mcnlsx,
mcnlsy,
mcnlsz,
mcnlp)

  /* TRACE Component channel_13_cave2_box3 [647] */
  mccoordschange(mcposrchannel_13_cave2_box3, mcrotrchannel_13_cave2_box3,
    &mcnlx,
    &mcnly,
    &mcnlz,
    &mcnlvx,
    &mcnlvy,
    &mcnlvz,
    &mcnlsx,
    &mcnlsy,
    &mcnlsz);
  /* define label inside component channel_13_cave2_box3 (without coords transformations) */
  mcJumpTrace_channel_13_cave2_box3:
  SIG_MESSAGE("channel_13_cave2_box3 (Trace)");
  mcDEBUG_COMP("channel_13_cave2_box3")
  mcDEBUG_STATE(
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp)
#define x mcnlx
#define y mcnly
#define z mcnlz
#define vx mcnlvx
#define vy mcnlvy
#define vz mcnlvz
#define t mcnlt
#define sx mcnlsx
#define sy mcnlsy
#define sz mcnlsz
#define p mcnlp

#define mcabsorbComp mcabsorbCompchannel_13_cave2_box3
  STORE_NEUTRON(647,
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp);
  mcScattered=0;
  mcRestore=0;
  mcNCounter[647]++;
  mcPCounter[647] += p;
  mcP2Counter[647] += p*p;
#define mccompcurname  channel_13_cave2_box3
#define mccompcurtype  Union_box
#define mccompcurindex 647
#define loop_index mccchannel_13_cave2_box3_loop_index
#define this_box_volume mccchannel_13_cave2_box3_this_box_volume
#define global_geometry_element mccchannel_13_cave2_box3_global_geometry_element
#define this_box_storage mccchannel_13_cave2_box3_this_box_storage
{   /* Declarations of channel_13_cave2_box3=Union_box() SETTING parameters. */
char* material_string = mccchannel_13_cave2_box3_material_string;
MCNUM priority = mccchannel_13_cave2_box3_priority;
MCNUM xwidth = mccchannel_13_cave2_box3_xwidth;
MCNUM yheight = mccchannel_13_cave2_box3_yheight;
MCNUM zdepth = mccchannel_13_cave2_box3_zdepth;
MCNUM xwidth2 = mccchannel_13_cave2_box3_xwidth2;
MCNUM yheight2 = mccchannel_13_cave2_box3_yheight2;
MCNUM visualize = mccchannel_13_cave2_box3_visualize;
int target_index = mccchannel_13_cave2_box3_target_index;
MCNUM target_x = mccchannel_13_cave2_box3_target_x;
MCNUM target_y = mccchannel_13_cave2_box3_target_y;
MCNUM target_z = mccchannel_13_cave2_box3_target_z;
MCNUM focus_aw = mccchannel_13_cave2_box3_focus_aw;
MCNUM focus_ah = mccchannel_13_cave2_box3_focus_ah;
MCNUM focus_xw = mccchannel_13_cave2_box3_focus_xw;
MCNUM focus_xh = mccchannel_13_cave2_box3_focus_xh;
MCNUM focus_r = mccchannel_13_cave2_box3_focus_r;
MCNUM p_interact = mccchannel_13_cave2_box3_p_interact;
char* mask_string = mccchannel_13_cave2_box3_mask_string;
char* mask_setting = mccchannel_13_cave2_box3_mask_setting;
MCNUM number_of_activations = mccchannel_13_cave2_box3_number_of_activations;
}   /* End of channel_13_cave2_box3=Union_box() SETTING parameter declarations. */
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex
  /* Label for restoring  neutron */
  mcabsorbCompchannel_13_cave2_box3:
  if (RESTORE) /* restore if needed */
  { RESTORE_NEUTRON(647,
      mcnlx,
      mcnly,
      mcnlz,
      mcnlvx,
      mcnlvy,
      mcnlvz,
      mcnlt,
      mcnlsx,
      mcnlsy,
      mcnlsz,
      mcnlp); }
#undef mcabsorbComp
#undef p
#undef sz
#undef sy
#undef sx
#undef t
#undef vz
#undef vy
#undef vx
#undef z
#undef y
#undef x
  mcDEBUG_STATE(
mcnlx,
mcnly,
mcnlz,
mcnlvx,
mcnlvy,
mcnlvz,
mcnlt,
mcnlsx,
mcnlsy,
mcnlsz,
mcnlp)

  /* TRACE Component inter_analyzer_colimator_center_13 [648] */
  mccoordschange(mcposrinter_analyzer_colimator_center_13, mcrotrinter_analyzer_colimator_center_13,
    &mcnlx,
    &mcnly,
    &mcnlz,
    &mcnlvx,
    &mcnlvy,
    &mcnlvz,
    &mcnlsx,
    &mcnlsy,
    &mcnlsz);
  /* define label inside component inter_analyzer_colimator_center_13 (without coords transformations) */
  mcJumpTrace_inter_analyzer_colimator_center_13:
  SIG_MESSAGE("inter_analyzer_colimator_center_13 (Trace)");
  mcDEBUG_COMP("inter_analyzer_colimator_center_13")
  mcDEBUG_STATE(
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp)
#define x mcnlx
#define y mcnly
#define z mcnlz
#define vx mcnlvx
#define vy mcnlvy
#define vz mcnlvz
#define t mcnlt
#define sx mcnlsx
#define sy mcnlsy
#define sz mcnlsz
#define p mcnlp

#define mcabsorbComp mcabsorbCompinter_analyzer_colimator_center_13
  STORE_NEUTRON(648,
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp);
  mcScattered=0;
  mcRestore=0;
  mcNCounter[648]++;
  mcPCounter[648] += p;
  mcP2Counter[648] += p*p;
#define mccompcurname  inter_analyzer_colimator_center_13
#define mccompcurtype  Arm
#define mccompcurindex 648
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex
  /* Label for restoring  neutron */
  mcabsorbCompinter_analyzer_colimator_center_13:
  if (RESTORE) /* restore if needed */
  { RESTORE_NEUTRON(648,
      mcnlx,
      mcnly,
      mcnlz,
      mcnlvx,
      mcnlvy,
      mcnlvz,
      mcnlt,
      mcnlsx,
      mcnlsy,
      mcnlsz,
      mcnlp); }
#undef mcabsorbComp
#undef p
#undef sz
#undef sy
#undef sx
#undef t
#undef vz
#undef vy
#undef vx
#undef z
#undef y
#undef x
  mcDEBUG_STATE(
mcnlx,
mcnly,
mcnlz,
mcnlvx,
mcnlvy,
mcnlvz,
mcnlt,
mcnlsx,
mcnlsy,
mcnlsz,
mcnlp)

  /* TRACE Component inter_analyzer_colimator_13_blade_0 [649] */
  mccoordschange(mcposrinter_analyzer_colimator_13_blade_0, mcrotrinter_analyzer_colimator_13_blade_0,
    &mcnlx,
    &mcnly,
    &mcnlz,
    &mcnlvx,
    &mcnlvy,
    &mcnlvz,
    &mcnlsx,
    &mcnlsy,
    &mcnlsz);
  /* define label inside component inter_analyzer_colimator_13_blade_0 (without coords transformations) */
  mcJumpTrace_inter_analyzer_colimator_13_blade_0:
  SIG_MESSAGE("inter_analyzer_colimator_13_blade_0 (Trace)");
  mcDEBUG_COMP("inter_analyzer_colimator_13_blade_0")
  mcDEBUG_STATE(
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp)
#define x mcnlx
#define y mcnly
#define z mcnlz
#define vx mcnlvx
#define vy mcnlvy
#define vz mcnlvz
#define t mcnlt
#define sx mcnlsx
#define sy mcnlsy
#define sz mcnlsz
#define p mcnlp

#define mcabsorbComp mcabsorbCompinter_analyzer_colimator_13_blade_0
  STORE_NEUTRON(649,
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp);
  mcScattered=0;
  mcRestore=0;
  mcNCounter[649]++;
  mcPCounter[649] += p;
  mcP2Counter[649] += p*p;
#define mccompcurname  inter_analyzer_colimator_13_blade_0
#define mccompcurtype  Union_box
#define mccompcurindex 649
#define loop_index mccinter_analyzer_colimator_13_blade_0_loop_index
#define this_box_volume mccinter_analyzer_colimator_13_blade_0_this_box_volume
#define global_geometry_element mccinter_analyzer_colimator_13_blade_0_global_geometry_element
#define this_box_storage mccinter_analyzer_colimator_13_blade_0_this_box_storage
{   /* Declarations of inter_analyzer_colimator_13_blade_0=Union_box() SETTING parameters. */
char* material_string = mccinter_analyzer_colimator_13_blade_0_material_string;
MCNUM priority = mccinter_analyzer_colimator_13_blade_0_priority;
MCNUM xwidth = mccinter_analyzer_colimator_13_blade_0_xwidth;
MCNUM yheight = mccinter_analyzer_colimator_13_blade_0_yheight;
MCNUM zdepth = mccinter_analyzer_colimator_13_blade_0_zdepth;
MCNUM xwidth2 = mccinter_analyzer_colimator_13_blade_0_xwidth2;
MCNUM yheight2 = mccinter_analyzer_colimator_13_blade_0_yheight2;
MCNUM visualize = mccinter_analyzer_colimator_13_blade_0_visualize;
int target_index = mccinter_analyzer_colimator_13_blade_0_target_index;
MCNUM target_x = mccinter_analyzer_colimator_13_blade_0_target_x;
MCNUM target_y = mccinter_analyzer_colimator_13_blade_0_target_y;
MCNUM target_z = mccinter_analyzer_colimator_13_blade_0_target_z;
MCNUM focus_aw = mccinter_analyzer_colimator_13_blade_0_focus_aw;
MCNUM focus_ah = mccinter_analyzer_colimator_13_blade_0_focus_ah;
MCNUM focus_xw = mccinter_analyzer_colimator_13_blade_0_focus_xw;
MCNUM focus_xh = mccinter_analyzer_colimator_13_blade_0_focus_xh;
MCNUM focus_r = mccinter_analyzer_colimator_13_blade_0_focus_r;
MCNUM p_interact = mccinter_analyzer_colimator_13_blade_0_p_interact;
char* mask_string = mccinter_analyzer_colimator_13_blade_0_mask_string;
char* mask_setting = mccinter_analyzer_colimator_13_blade_0_mask_setting;
MCNUM number_of_activations = mccinter_analyzer_colimator_13_blade_0_number_of_activations;
}   /* End of inter_analyzer_colimator_13_blade_0=Union_box() SETTING parameter declarations. */
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex
  /* Label for restoring  neutron */
  mcabsorbCompinter_analyzer_colimator_13_blade_0:
  if (RESTORE) /* restore if needed */
  { RESTORE_NEUTRON(649,
      mcnlx,
      mcnly,
      mcnlz,
      mcnlvx,
      mcnlvy,
      mcnlvz,
      mcnlt,
      mcnlsx,
      mcnlsy,
      mcnlsz,
      mcnlp); }
#undef mcabsorbComp
#undef p
#undef sz
#undef sy
#undef sx
#undef t
#undef vz
#undef vy
#undef vx
#undef z
#undef y
#undef x
  mcDEBUG_STATE(
mcnlx,
mcnly,
mcnlz,
mcnlvx,
mcnlvy,
mcnlvz,
mcnlt,
mcnlsx,
mcnlsy,
mcnlsz,
mcnlp)

  /* TRACE Component inter_analyzer_colimator_13_blade_1 [650] */
  mccoordschange(mcposrinter_analyzer_colimator_13_blade_1, mcrotrinter_analyzer_colimator_13_blade_1,
    &mcnlx,
    &mcnly,
    &mcnlz,
    &mcnlvx,
    &mcnlvy,
    &mcnlvz,
    &mcnlsx,
    &mcnlsy,
    &mcnlsz);
  /* define label inside component inter_analyzer_colimator_13_blade_1 (without coords transformations) */
  mcJumpTrace_inter_analyzer_colimator_13_blade_1:
  SIG_MESSAGE("inter_analyzer_colimator_13_blade_1 (Trace)");
  mcDEBUG_COMP("inter_analyzer_colimator_13_blade_1")
  mcDEBUG_STATE(
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp)
#define x mcnlx
#define y mcnly
#define z mcnlz
#define vx mcnlvx
#define vy mcnlvy
#define vz mcnlvz
#define t mcnlt
#define sx mcnlsx
#define sy mcnlsy
#define sz mcnlsz
#define p mcnlp

#define mcabsorbComp mcabsorbCompinter_analyzer_colimator_13_blade_1
  STORE_NEUTRON(650,
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp);
  mcScattered=0;
  mcRestore=0;
  mcNCounter[650]++;
  mcPCounter[650] += p;
  mcP2Counter[650] += p*p;
#define mccompcurname  inter_analyzer_colimator_13_blade_1
#define mccompcurtype  Union_box
#define mccompcurindex 650
#define loop_index mccinter_analyzer_colimator_13_blade_1_loop_index
#define this_box_volume mccinter_analyzer_colimator_13_blade_1_this_box_volume
#define global_geometry_element mccinter_analyzer_colimator_13_blade_1_global_geometry_element
#define this_box_storage mccinter_analyzer_colimator_13_blade_1_this_box_storage
{   /* Declarations of inter_analyzer_colimator_13_blade_1=Union_box() SETTING parameters. */
char* material_string = mccinter_analyzer_colimator_13_blade_1_material_string;
MCNUM priority = mccinter_analyzer_colimator_13_blade_1_priority;
MCNUM xwidth = mccinter_analyzer_colimator_13_blade_1_xwidth;
MCNUM yheight = mccinter_analyzer_colimator_13_blade_1_yheight;
MCNUM zdepth = mccinter_analyzer_colimator_13_blade_1_zdepth;
MCNUM xwidth2 = mccinter_analyzer_colimator_13_blade_1_xwidth2;
MCNUM yheight2 = mccinter_analyzer_colimator_13_blade_1_yheight2;
MCNUM visualize = mccinter_analyzer_colimator_13_blade_1_visualize;
int target_index = mccinter_analyzer_colimator_13_blade_1_target_index;
MCNUM target_x = mccinter_analyzer_colimator_13_blade_1_target_x;
MCNUM target_y = mccinter_analyzer_colimator_13_blade_1_target_y;
MCNUM target_z = mccinter_analyzer_colimator_13_blade_1_target_z;
MCNUM focus_aw = mccinter_analyzer_colimator_13_blade_1_focus_aw;
MCNUM focus_ah = mccinter_analyzer_colimator_13_blade_1_focus_ah;
MCNUM focus_xw = mccinter_analyzer_colimator_13_blade_1_focus_xw;
MCNUM focus_xh = mccinter_analyzer_colimator_13_blade_1_focus_xh;
MCNUM focus_r = mccinter_analyzer_colimator_13_blade_1_focus_r;
MCNUM p_interact = mccinter_analyzer_colimator_13_blade_1_p_interact;
char* mask_string = mccinter_analyzer_colimator_13_blade_1_mask_string;
char* mask_setting = mccinter_analyzer_colimator_13_blade_1_mask_setting;
MCNUM number_of_activations = mccinter_analyzer_colimator_13_blade_1_number_of_activations;
}   /* End of inter_analyzer_colimator_13_blade_1=Union_box() SETTING parameter declarations. */
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex
  /* Label for restoring  neutron */
  mcabsorbCompinter_analyzer_colimator_13_blade_1:
  if (RESTORE) /* restore if needed */
  { RESTORE_NEUTRON(650,
      mcnlx,
      mcnly,
      mcnlz,
      mcnlvx,
      mcnlvy,
      mcnlvz,
      mcnlt,
      mcnlsx,
      mcnlsy,
      mcnlsz,
      mcnlp); }
#undef mcabsorbComp
#undef p
#undef sz
#undef sy
#undef sx
#undef t
#undef vz
#undef vy
#undef vx
#undef z
#undef y
#undef x
  mcDEBUG_STATE(
mcnlx,
mcnly,
mcnlz,
mcnlvx,
mcnlvy,
mcnlvz,
mcnlt,
mcnlsx,
mcnlsy,
mcnlsz,
mcnlp)

  /* TRACE Component inter_analyzer_colimator_13_blade_2 [651] */
  mccoordschange(mcposrinter_analyzer_colimator_13_blade_2, mcrotrinter_analyzer_colimator_13_blade_2,
    &mcnlx,
    &mcnly,
    &mcnlz,
    &mcnlvx,
    &mcnlvy,
    &mcnlvz,
    &mcnlsx,
    &mcnlsy,
    &mcnlsz);
  /* define label inside component inter_analyzer_colimator_13_blade_2 (without coords transformations) */
  mcJumpTrace_inter_analyzer_colimator_13_blade_2:
  SIG_MESSAGE("inter_analyzer_colimator_13_blade_2 (Trace)");
  mcDEBUG_COMP("inter_analyzer_colimator_13_blade_2")
  mcDEBUG_STATE(
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp)
#define x mcnlx
#define y mcnly
#define z mcnlz
#define vx mcnlvx
#define vy mcnlvy
#define vz mcnlvz
#define t mcnlt
#define sx mcnlsx
#define sy mcnlsy
#define sz mcnlsz
#define p mcnlp

#define mcabsorbComp mcabsorbCompinter_analyzer_colimator_13_blade_2
  STORE_NEUTRON(651,
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp);
  mcScattered=0;
  mcRestore=0;
  mcNCounter[651]++;
  mcPCounter[651] += p;
  mcP2Counter[651] += p*p;
#define mccompcurname  inter_analyzer_colimator_13_blade_2
#define mccompcurtype  Union_box
#define mccompcurindex 651
#define loop_index mccinter_analyzer_colimator_13_blade_2_loop_index
#define this_box_volume mccinter_analyzer_colimator_13_blade_2_this_box_volume
#define global_geometry_element mccinter_analyzer_colimator_13_blade_2_global_geometry_element
#define this_box_storage mccinter_analyzer_colimator_13_blade_2_this_box_storage
{   /* Declarations of inter_analyzer_colimator_13_blade_2=Union_box() SETTING parameters. */
char* material_string = mccinter_analyzer_colimator_13_blade_2_material_string;
MCNUM priority = mccinter_analyzer_colimator_13_blade_2_priority;
MCNUM xwidth = mccinter_analyzer_colimator_13_blade_2_xwidth;
MCNUM yheight = mccinter_analyzer_colimator_13_blade_2_yheight;
MCNUM zdepth = mccinter_analyzer_colimator_13_blade_2_zdepth;
MCNUM xwidth2 = mccinter_analyzer_colimator_13_blade_2_xwidth2;
MCNUM yheight2 = mccinter_analyzer_colimator_13_blade_2_yheight2;
MCNUM visualize = mccinter_analyzer_colimator_13_blade_2_visualize;
int target_index = mccinter_analyzer_colimator_13_blade_2_target_index;
MCNUM target_x = mccinter_analyzer_colimator_13_blade_2_target_x;
MCNUM target_y = mccinter_analyzer_colimator_13_blade_2_target_y;
MCNUM target_z = mccinter_analyzer_colimator_13_blade_2_target_z;
MCNUM focus_aw = mccinter_analyzer_colimator_13_blade_2_focus_aw;
MCNUM focus_ah = mccinter_analyzer_colimator_13_blade_2_focus_ah;
MCNUM focus_xw = mccinter_analyzer_colimator_13_blade_2_focus_xw;
MCNUM focus_xh = mccinter_analyzer_colimator_13_blade_2_focus_xh;
MCNUM focus_r = mccinter_analyzer_colimator_13_blade_2_focus_r;
MCNUM p_interact = mccinter_analyzer_colimator_13_blade_2_p_interact;
char* mask_string = mccinter_analyzer_colimator_13_blade_2_mask_string;
char* mask_setting = mccinter_analyzer_colimator_13_blade_2_mask_setting;
MCNUM number_of_activations = mccinter_analyzer_colimator_13_blade_2_number_of_activations;
}   /* End of inter_analyzer_colimator_13_blade_2=Union_box() SETTING parameter declarations. */
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex
  /* Label for restoring  neutron */
  mcabsorbCompinter_analyzer_colimator_13_blade_2:
  if (RESTORE) /* restore if needed */
  { RESTORE_NEUTRON(651,
      mcnlx,
      mcnly,
      mcnlz,
      mcnlvx,
      mcnlvy,
      mcnlvz,
      mcnlt,
      mcnlsx,
      mcnlsy,
      mcnlsz,
      mcnlp); }
#undef mcabsorbComp
#undef p
#undef sz
#undef sy
#undef sx
#undef t
#undef vz
#undef vy
#undef vx
#undef z
#undef y
#undef x
  mcDEBUG_STATE(
mcnlx,
mcnly,
mcnlz,
mcnlvx,
mcnlvy,
mcnlvz,
mcnlt,
mcnlsx,
mcnlsy,
mcnlsz,
mcnlp)

  /* TRACE Component inter_analyzer_colimator_13_blade_3 [652] */
  mccoordschange(mcposrinter_analyzer_colimator_13_blade_3, mcrotrinter_analyzer_colimator_13_blade_3,
    &mcnlx,
    &mcnly,
    &mcnlz,
    &mcnlvx,
    &mcnlvy,
    &mcnlvz,
    &mcnlsx,
    &mcnlsy,
    &mcnlsz);
  /* define label inside component inter_analyzer_colimator_13_blade_3 (without coords transformations) */
  mcJumpTrace_inter_analyzer_colimator_13_blade_3:
  SIG_MESSAGE("inter_analyzer_colimator_13_blade_3 (Trace)");
  mcDEBUG_COMP("inter_analyzer_colimator_13_blade_3")
  mcDEBUG_STATE(
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp)
#define x mcnlx
#define y mcnly
#define z mcnlz
#define vx mcnlvx
#define vy mcnlvy
#define vz mcnlvz
#define t mcnlt
#define sx mcnlsx
#define sy mcnlsy
#define sz mcnlsz
#define p mcnlp

#define mcabsorbComp mcabsorbCompinter_analyzer_colimator_13_blade_3
  STORE_NEUTRON(652,
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp);
  mcScattered=0;
  mcRestore=0;
  mcNCounter[652]++;
  mcPCounter[652] += p;
  mcP2Counter[652] += p*p;
#define mccompcurname  inter_analyzer_colimator_13_blade_3
#define mccompcurtype  Union_box
#define mccompcurindex 652
#define loop_index mccinter_analyzer_colimator_13_blade_3_loop_index
#define this_box_volume mccinter_analyzer_colimator_13_blade_3_this_box_volume
#define global_geometry_element mccinter_analyzer_colimator_13_blade_3_global_geometry_element
#define this_box_storage mccinter_analyzer_colimator_13_blade_3_this_box_storage
{   /* Declarations of inter_analyzer_colimator_13_blade_3=Union_box() SETTING parameters. */
char* material_string = mccinter_analyzer_colimator_13_blade_3_material_string;
MCNUM priority = mccinter_analyzer_colimator_13_blade_3_priority;
MCNUM xwidth = mccinter_analyzer_colimator_13_blade_3_xwidth;
MCNUM yheight = mccinter_analyzer_colimator_13_blade_3_yheight;
MCNUM zdepth = mccinter_analyzer_colimator_13_blade_3_zdepth;
MCNUM xwidth2 = mccinter_analyzer_colimator_13_blade_3_xwidth2;
MCNUM yheight2 = mccinter_analyzer_colimator_13_blade_3_yheight2;
MCNUM visualize = mccinter_analyzer_colimator_13_blade_3_visualize;
int target_index = mccinter_analyzer_colimator_13_blade_3_target_index;
MCNUM target_x = mccinter_analyzer_colimator_13_blade_3_target_x;
MCNUM target_y = mccinter_analyzer_colimator_13_blade_3_target_y;
MCNUM target_z = mccinter_analyzer_colimator_13_blade_3_target_z;
MCNUM focus_aw = mccinter_analyzer_colimator_13_blade_3_focus_aw;
MCNUM focus_ah = mccinter_analyzer_colimator_13_blade_3_focus_ah;
MCNUM focus_xw = mccinter_analyzer_colimator_13_blade_3_focus_xw;
MCNUM focus_xh = mccinter_analyzer_colimator_13_blade_3_focus_xh;
MCNUM focus_r = mccinter_analyzer_colimator_13_blade_3_focus_r;
MCNUM p_interact = mccinter_analyzer_colimator_13_blade_3_p_interact;
char* mask_string = mccinter_analyzer_colimator_13_blade_3_mask_string;
char* mask_setting = mccinter_analyzer_colimator_13_blade_3_mask_setting;
MCNUM number_of_activations = mccinter_analyzer_colimator_13_blade_3_number_of_activations;
}   /* End of inter_analyzer_colimator_13_blade_3=Union_box() SETTING parameter declarations. */
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex
  /* Label for restoring  neutron */
  mcabsorbCompinter_analyzer_colimator_13_blade_3:
  if (RESTORE) /* restore if needed */
  { RESTORE_NEUTRON(652,
      mcnlx,
      mcnly,
      mcnlz,
      mcnlvx,
      mcnlvy,
      mcnlvz,
      mcnlt,
      mcnlsx,
      mcnlsy,
      mcnlsz,
      mcnlp); }
#undef mcabsorbComp
#undef p
#undef sz
#undef sy
#undef sx
#undef t
#undef vz
#undef vy
#undef vx
#undef z
#undef y
#undef x
  mcDEBUG_STATE(
mcnlx,
mcnly,
mcnlz,
mcnlvx,
mcnlvy,
mcnlvz,
mcnlt,
mcnlsx,
mcnlsy,
mcnlsz,
mcnlp)

  /* TRACE Component inter_analyzer_colimator_13_blade_4 [653] */
  mccoordschange(mcposrinter_analyzer_colimator_13_blade_4, mcrotrinter_analyzer_colimator_13_blade_4,
    &mcnlx,
    &mcnly,
    &mcnlz,
    &mcnlvx,
    &mcnlvy,
    &mcnlvz,
    &mcnlsx,
    &mcnlsy,
    &mcnlsz);
  /* define label inside component inter_analyzer_colimator_13_blade_4 (without coords transformations) */
  mcJumpTrace_inter_analyzer_colimator_13_blade_4:
  SIG_MESSAGE("inter_analyzer_colimator_13_blade_4 (Trace)");
  mcDEBUG_COMP("inter_analyzer_colimator_13_blade_4")
  mcDEBUG_STATE(
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp)
#define x mcnlx
#define y mcnly
#define z mcnlz
#define vx mcnlvx
#define vy mcnlvy
#define vz mcnlvz
#define t mcnlt
#define sx mcnlsx
#define sy mcnlsy
#define sz mcnlsz
#define p mcnlp

#define mcabsorbComp mcabsorbCompinter_analyzer_colimator_13_blade_4
  STORE_NEUTRON(653,
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp);
  mcScattered=0;
  mcRestore=0;
  mcNCounter[653]++;
  mcPCounter[653] += p;
  mcP2Counter[653] += p*p;
#define mccompcurname  inter_analyzer_colimator_13_blade_4
#define mccompcurtype  Union_box
#define mccompcurindex 653
#define loop_index mccinter_analyzer_colimator_13_blade_4_loop_index
#define this_box_volume mccinter_analyzer_colimator_13_blade_4_this_box_volume
#define global_geometry_element mccinter_analyzer_colimator_13_blade_4_global_geometry_element
#define this_box_storage mccinter_analyzer_colimator_13_blade_4_this_box_storage
{   /* Declarations of inter_analyzer_colimator_13_blade_4=Union_box() SETTING parameters. */
char* material_string = mccinter_analyzer_colimator_13_blade_4_material_string;
MCNUM priority = mccinter_analyzer_colimator_13_blade_4_priority;
MCNUM xwidth = mccinter_analyzer_colimator_13_blade_4_xwidth;
MCNUM yheight = mccinter_analyzer_colimator_13_blade_4_yheight;
MCNUM zdepth = mccinter_analyzer_colimator_13_blade_4_zdepth;
MCNUM xwidth2 = mccinter_analyzer_colimator_13_blade_4_xwidth2;
MCNUM yheight2 = mccinter_analyzer_colimator_13_blade_4_yheight2;
MCNUM visualize = mccinter_analyzer_colimator_13_blade_4_visualize;
int target_index = mccinter_analyzer_colimator_13_blade_4_target_index;
MCNUM target_x = mccinter_analyzer_colimator_13_blade_4_target_x;
MCNUM target_y = mccinter_analyzer_colimator_13_blade_4_target_y;
MCNUM target_z = mccinter_analyzer_colimator_13_blade_4_target_z;
MCNUM focus_aw = mccinter_analyzer_colimator_13_blade_4_focus_aw;
MCNUM focus_ah = mccinter_analyzer_colimator_13_blade_4_focus_ah;
MCNUM focus_xw = mccinter_analyzer_colimator_13_blade_4_focus_xw;
MCNUM focus_xh = mccinter_analyzer_colimator_13_blade_4_focus_xh;
MCNUM focus_r = mccinter_analyzer_colimator_13_blade_4_focus_r;
MCNUM p_interact = mccinter_analyzer_colimator_13_blade_4_p_interact;
char* mask_string = mccinter_analyzer_colimator_13_blade_4_mask_string;
char* mask_setting = mccinter_analyzer_colimator_13_blade_4_mask_setting;
MCNUM number_of_activations = mccinter_analyzer_colimator_13_blade_4_number_of_activations;
}   /* End of inter_analyzer_colimator_13_blade_4=Union_box() SETTING parameter declarations. */
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex
  /* Label for restoring  neutron */
  mcabsorbCompinter_analyzer_colimator_13_blade_4:
  if (RESTORE) /* restore if needed */
  { RESTORE_NEUTRON(653,
      mcnlx,
      mcnly,
      mcnlz,
      mcnlvx,
      mcnlvy,
      mcnlvz,
      mcnlt,
      mcnlsx,
      mcnlsy,
      mcnlsz,
      mcnlp); }
#undef mcabsorbComp
#undef p
#undef sz
#undef sy
#undef sx
#undef t
#undef vz
#undef vy
#undef vx
#undef z
#undef y
#undef x
  mcDEBUG_STATE(
mcnlx,
mcnly,
mcnlz,
mcnlvx,
mcnlvy,
mcnlvz,
mcnlt,
mcnlsx,
mcnlsy,
mcnlsz,
mcnlp)

  /* TRACE Component diffraction_detector_13_exit_volume [654] */
  mccoordschange(mcposrdiffraction_detector_13_exit_volume, mcrotrdiffraction_detector_13_exit_volume,
    &mcnlx,
    &mcnly,
    &mcnlz,
    &mcnlvx,
    &mcnlvy,
    &mcnlvz,
    &mcnlsx,
    &mcnlsy,
    &mcnlsz);
  /* define label inside component diffraction_detector_13_exit_volume (without coords transformations) */
  mcJumpTrace_diffraction_detector_13_exit_volume:
  SIG_MESSAGE("diffraction_detector_13_exit_volume (Trace)");
  mcDEBUG_COMP("diffraction_detector_13_exit_volume")
  mcDEBUG_STATE(
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp)
#define x mcnlx
#define y mcnly
#define z mcnlz
#define vx mcnlvx
#define vy mcnlvy
#define vz mcnlvz
#define t mcnlt
#define sx mcnlsx
#define sy mcnlsy
#define sz mcnlsz
#define p mcnlp

#define mcabsorbComp mcabsorbCompdiffraction_detector_13_exit_volume
  STORE_NEUTRON(654,
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp);
  mcScattered=0;
  mcRestore=0;
  mcNCounter[654]++;
  mcPCounter[654] += p;
  mcP2Counter[654] += p*p;
#define mccompcurname  diffraction_detector_13_exit_volume
#define mccompcurtype  Union_box
#define mccompcurindex 654
#define loop_index mccdiffraction_detector_13_exit_volume_loop_index
#define this_box_volume mccdiffraction_detector_13_exit_volume_this_box_volume
#define global_geometry_element mccdiffraction_detector_13_exit_volume_global_geometry_element
#define this_box_storage mccdiffraction_detector_13_exit_volume_this_box_storage
{   /* Declarations of diffraction_detector_13_exit_volume=Union_box() SETTING parameters. */
char* material_string = mccdiffraction_detector_13_exit_volume_material_string;
MCNUM priority = mccdiffraction_detector_13_exit_volume_priority;
MCNUM xwidth = mccdiffraction_detector_13_exit_volume_xwidth;
MCNUM yheight = mccdiffraction_detector_13_exit_volume_yheight;
MCNUM zdepth = mccdiffraction_detector_13_exit_volume_zdepth;
MCNUM xwidth2 = mccdiffraction_detector_13_exit_volume_xwidth2;
MCNUM yheight2 = mccdiffraction_detector_13_exit_volume_yheight2;
MCNUM visualize = mccdiffraction_detector_13_exit_volume_visualize;
int target_index = mccdiffraction_detector_13_exit_volume_target_index;
MCNUM target_x = mccdiffraction_detector_13_exit_volume_target_x;
MCNUM target_y = mccdiffraction_detector_13_exit_volume_target_y;
MCNUM target_z = mccdiffraction_detector_13_exit_volume_target_z;
MCNUM focus_aw = mccdiffraction_detector_13_exit_volume_focus_aw;
MCNUM focus_ah = mccdiffraction_detector_13_exit_volume_focus_ah;
MCNUM focus_xw = mccdiffraction_detector_13_exit_volume_focus_xw;
MCNUM focus_xh = mccdiffraction_detector_13_exit_volume_focus_xh;
MCNUM focus_r = mccdiffraction_detector_13_exit_volume_focus_r;
MCNUM p_interact = mccdiffraction_detector_13_exit_volume_p_interact;
char* mask_string = mccdiffraction_detector_13_exit_volume_mask_string;
char* mask_setting = mccdiffraction_detector_13_exit_volume_mask_setting;
MCNUM number_of_activations = mccdiffraction_detector_13_exit_volume_number_of_activations;
}   /* End of diffraction_detector_13_exit_volume=Union_box() SETTING parameter declarations. */
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex
  /* Label for restoring  neutron */
  mcabsorbCompdiffraction_detector_13_exit_volume:
  if (RESTORE) /* restore if needed */
  { RESTORE_NEUTRON(654,
      mcnlx,
      mcnly,
      mcnlz,
      mcnlvx,
      mcnlvy,
      mcnlvz,
      mcnlt,
      mcnlsx,
      mcnlsy,
      mcnlsz,
      mcnlp); }
#undef mcabsorbComp
#undef p
#undef sz
#undef sy
#undef sx
#undef t
#undef vz
#undef vy
#undef vx
#undef z
#undef y
#undef x
  mcDEBUG_STATE(
mcnlx,
mcnly,
mcnlz,
mcnlvx,
mcnlvy,
mcnlvz,
mcnlt,
mcnlsx,
mcnlsy,
mcnlsz,
mcnlp)

  /* TRACE Component spec_detector_13_exit_volume [655] */
  mccoordschange(mcposrspec_detector_13_exit_volume, mcrotrspec_detector_13_exit_volume,
    &mcnlx,
    &mcnly,
    &mcnlz,
    &mcnlvx,
    &mcnlvy,
    &mcnlvz,
    &mcnlsx,
    &mcnlsy,
    &mcnlsz);
  /* define label inside component spec_detector_13_exit_volume (without coords transformations) */
  mcJumpTrace_spec_detector_13_exit_volume:
  SIG_MESSAGE("spec_detector_13_exit_volume (Trace)");
  mcDEBUG_COMP("spec_detector_13_exit_volume")
  mcDEBUG_STATE(
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp)
#define x mcnlx
#define y mcnly
#define z mcnlz
#define vx mcnlvx
#define vy mcnlvy
#define vz mcnlvz
#define t mcnlt
#define sx mcnlsx
#define sy mcnlsy
#define sz mcnlsz
#define p mcnlp

#define mcabsorbComp mcabsorbCompspec_detector_13_exit_volume
  STORE_NEUTRON(655,
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp);
  mcScattered=0;
  mcRestore=0;
  mcNCounter[655]++;
  mcPCounter[655] += p;
  mcP2Counter[655] += p*p;
#define mccompcurname  spec_detector_13_exit_volume
#define mccompcurtype  Union_box
#define mccompcurindex 655
#define loop_index mccspec_detector_13_exit_volume_loop_index
#define this_box_volume mccspec_detector_13_exit_volume_this_box_volume
#define global_geometry_element mccspec_detector_13_exit_volume_global_geometry_element
#define this_box_storage mccspec_detector_13_exit_volume_this_box_storage
{   /* Declarations of spec_detector_13_exit_volume=Union_box() SETTING parameters. */
char* material_string = mccspec_detector_13_exit_volume_material_string;
MCNUM priority = mccspec_detector_13_exit_volume_priority;
MCNUM xwidth = mccspec_detector_13_exit_volume_xwidth;
MCNUM yheight = mccspec_detector_13_exit_volume_yheight;
MCNUM zdepth = mccspec_detector_13_exit_volume_zdepth;
MCNUM xwidth2 = mccspec_detector_13_exit_volume_xwidth2;
MCNUM yheight2 = mccspec_detector_13_exit_volume_yheight2;
MCNUM visualize = mccspec_detector_13_exit_volume_visualize;
int target_index = mccspec_detector_13_exit_volume_target_index;
MCNUM target_x = mccspec_detector_13_exit_volume_target_x;
MCNUM target_y = mccspec_detector_13_exit_volume_target_y;
MCNUM target_z = mccspec_detector_13_exit_volume_target_z;
MCNUM focus_aw = mccspec_detector_13_exit_volume_focus_aw;
MCNUM focus_ah = mccspec_detector_13_exit_volume_focus_ah;
MCNUM focus_xw = mccspec_detector_13_exit_volume_focus_xw;
MCNUM focus_xh = mccspec_detector_13_exit_volume_focus_xh;
MCNUM focus_r = mccspec_detector_13_exit_volume_focus_r;
MCNUM p_interact = mccspec_detector_13_exit_volume_p_interact;
char* mask_string = mccspec_detector_13_exit_volume_mask_string;
char* mask_setting = mccspec_detector_13_exit_volume_mask_setting;
MCNUM number_of_activations = mccspec_detector_13_exit_volume_number_of_activations;
}   /* End of spec_detector_13_exit_volume=Union_box() SETTING parameter declarations. */
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex
  /* Label for restoring  neutron */
  mcabsorbCompspec_detector_13_exit_volume:
  if (RESTORE) /* restore if needed */
  { RESTORE_NEUTRON(655,
      mcnlx,
      mcnly,
      mcnlz,
      mcnlvx,
      mcnlvy,
      mcnlvz,
      mcnlt,
      mcnlsx,
      mcnlsy,
      mcnlsz,
      mcnlp); }
#undef mcabsorbComp
#undef p
#undef sz
#undef sy
#undef sx
#undef t
#undef vz
#undef vy
#undef vx
#undef z
#undef y
#undef x
  mcDEBUG_STATE(
mcnlx,
mcnly,
mcnlz,
mcnlvx,
mcnlvy,
mcnlvz,
mcnlt,
mcnlsx,
mcnlsy,
mcnlsz,
mcnlp)

  /* TRACE Component channel_14_cave1_box1 [656] */
  mccoordschange(mcposrchannel_14_cave1_box1, mcrotrchannel_14_cave1_box1,
    &mcnlx,
    &mcnly,
    &mcnlz,
    &mcnlvx,
    &mcnlvy,
    &mcnlvz,
    &mcnlsx,
    &mcnlsy,
    &mcnlsz);
  /* define label inside component channel_14_cave1_box1 (without coords transformations) */
  mcJumpTrace_channel_14_cave1_box1:
  SIG_MESSAGE("channel_14_cave1_box1 (Trace)");
  mcDEBUG_COMP("channel_14_cave1_box1")
  mcDEBUG_STATE(
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp)
#define x mcnlx
#define y mcnly
#define z mcnlz
#define vx mcnlvx
#define vy mcnlvy
#define vz mcnlvz
#define t mcnlt
#define sx mcnlsx
#define sy mcnlsy
#define sz mcnlsz
#define p mcnlp

#define mcabsorbComp mcabsorbCompchannel_14_cave1_box1
  STORE_NEUTRON(656,
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp);
  mcScattered=0;
  mcRestore=0;
  mcNCounter[656]++;
  mcPCounter[656] += p;
  mcP2Counter[656] += p*p;
#define mccompcurname  channel_14_cave1_box1
#define mccompcurtype  Union_box
#define mccompcurindex 656
#define loop_index mccchannel_14_cave1_box1_loop_index
#define this_box_volume mccchannel_14_cave1_box1_this_box_volume
#define global_geometry_element mccchannel_14_cave1_box1_global_geometry_element
#define this_box_storage mccchannel_14_cave1_box1_this_box_storage
{   /* Declarations of channel_14_cave1_box1=Union_box() SETTING parameters. */
char* material_string = mccchannel_14_cave1_box1_material_string;
MCNUM priority = mccchannel_14_cave1_box1_priority;
MCNUM xwidth = mccchannel_14_cave1_box1_xwidth;
MCNUM yheight = mccchannel_14_cave1_box1_yheight;
MCNUM zdepth = mccchannel_14_cave1_box1_zdepth;
MCNUM xwidth2 = mccchannel_14_cave1_box1_xwidth2;
MCNUM yheight2 = mccchannel_14_cave1_box1_yheight2;
MCNUM visualize = mccchannel_14_cave1_box1_visualize;
int target_index = mccchannel_14_cave1_box1_target_index;
MCNUM target_x = mccchannel_14_cave1_box1_target_x;
MCNUM target_y = mccchannel_14_cave1_box1_target_y;
MCNUM target_z = mccchannel_14_cave1_box1_target_z;
MCNUM focus_aw = mccchannel_14_cave1_box1_focus_aw;
MCNUM focus_ah = mccchannel_14_cave1_box1_focus_ah;
MCNUM focus_xw = mccchannel_14_cave1_box1_focus_xw;
MCNUM focus_xh = mccchannel_14_cave1_box1_focus_xh;
MCNUM focus_r = mccchannel_14_cave1_box1_focus_r;
MCNUM p_interact = mccchannel_14_cave1_box1_p_interact;
char* mask_string = mccchannel_14_cave1_box1_mask_string;
char* mask_setting = mccchannel_14_cave1_box1_mask_setting;
MCNUM number_of_activations = mccchannel_14_cave1_box1_number_of_activations;
}   /* End of channel_14_cave1_box1=Union_box() SETTING parameter declarations. */
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex
  /* Label for restoring  neutron */
  mcabsorbCompchannel_14_cave1_box1:
  if (RESTORE) /* restore if needed */
  { RESTORE_NEUTRON(656,
      mcnlx,
      mcnly,
      mcnlz,
      mcnlvx,
      mcnlvy,
      mcnlvz,
      mcnlt,
      mcnlsx,
      mcnlsy,
      mcnlsz,
      mcnlp); }
#undef mcabsorbComp
#undef p
#undef sz
#undef sy
#undef sx
#undef t
#undef vz
#undef vy
#undef vx
#undef z
#undef y
#undef x
  mcDEBUG_STATE(
mcnlx,
mcnly,
mcnlz,
mcnlvx,
mcnlvy,
mcnlvz,
mcnlt,
mcnlsx,
mcnlsy,
mcnlsz,
mcnlp)

  /* TRACE Component channel_14_cave1_box2 [657] */
  mccoordschange(mcposrchannel_14_cave1_box2, mcrotrchannel_14_cave1_box2,
    &mcnlx,
    &mcnly,
    &mcnlz,
    &mcnlvx,
    &mcnlvy,
    &mcnlvz,
    &mcnlsx,
    &mcnlsy,
    &mcnlsz);
  /* define label inside component channel_14_cave1_box2 (without coords transformations) */
  mcJumpTrace_channel_14_cave1_box2:
  SIG_MESSAGE("channel_14_cave1_box2 (Trace)");
  mcDEBUG_COMP("channel_14_cave1_box2")
  mcDEBUG_STATE(
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp)
#define x mcnlx
#define y mcnly
#define z mcnlz
#define vx mcnlvx
#define vy mcnlvy
#define vz mcnlvz
#define t mcnlt
#define sx mcnlsx
#define sy mcnlsy
#define sz mcnlsz
#define p mcnlp

#define mcabsorbComp mcabsorbCompchannel_14_cave1_box2
  STORE_NEUTRON(657,
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp);
  mcScattered=0;
  mcRestore=0;
  mcNCounter[657]++;
  mcPCounter[657] += p;
  mcP2Counter[657] += p*p;
#define mccompcurname  channel_14_cave1_box2
#define mccompcurtype  Union_box
#define mccompcurindex 657
#define loop_index mccchannel_14_cave1_box2_loop_index
#define this_box_volume mccchannel_14_cave1_box2_this_box_volume
#define global_geometry_element mccchannel_14_cave1_box2_global_geometry_element
#define this_box_storage mccchannel_14_cave1_box2_this_box_storage
{   /* Declarations of channel_14_cave1_box2=Union_box() SETTING parameters. */
char* material_string = mccchannel_14_cave1_box2_material_string;
MCNUM priority = mccchannel_14_cave1_box2_priority;
MCNUM xwidth = mccchannel_14_cave1_box2_xwidth;
MCNUM yheight = mccchannel_14_cave1_box2_yheight;
MCNUM zdepth = mccchannel_14_cave1_box2_zdepth;
MCNUM xwidth2 = mccchannel_14_cave1_box2_xwidth2;
MCNUM yheight2 = mccchannel_14_cave1_box2_yheight2;
MCNUM visualize = mccchannel_14_cave1_box2_visualize;
int target_index = mccchannel_14_cave1_box2_target_index;
MCNUM target_x = mccchannel_14_cave1_box2_target_x;
MCNUM target_y = mccchannel_14_cave1_box2_target_y;
MCNUM target_z = mccchannel_14_cave1_box2_target_z;
MCNUM focus_aw = mccchannel_14_cave1_box2_focus_aw;
MCNUM focus_ah = mccchannel_14_cave1_box2_focus_ah;
MCNUM focus_xw = mccchannel_14_cave1_box2_focus_xw;
MCNUM focus_xh = mccchannel_14_cave1_box2_focus_xh;
MCNUM focus_r = mccchannel_14_cave1_box2_focus_r;
MCNUM p_interact = mccchannel_14_cave1_box2_p_interact;
char* mask_string = mccchannel_14_cave1_box2_mask_string;
char* mask_setting = mccchannel_14_cave1_box2_mask_setting;
MCNUM number_of_activations = mccchannel_14_cave1_box2_number_of_activations;
}   /* End of channel_14_cave1_box2=Union_box() SETTING parameter declarations. */
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex
  /* Label for restoring  neutron */
  mcabsorbCompchannel_14_cave1_box2:
  if (RESTORE) /* restore if needed */
  { RESTORE_NEUTRON(657,
      mcnlx,
      mcnly,
      mcnlz,
      mcnlvx,
      mcnlvy,
      mcnlvz,
      mcnlt,
      mcnlsx,
      mcnlsy,
      mcnlsz,
      mcnlp); }
#undef mcabsorbComp
#undef p
#undef sz
#undef sy
#undef sx
#undef t
#undef vz
#undef vy
#undef vx
#undef z
#undef y
#undef x
  mcDEBUG_STATE(
mcnlx,
mcnly,
mcnlz,
mcnlvx,
mcnlvy,
mcnlvz,
mcnlt,
mcnlsx,
mcnlsy,
mcnlsz,
mcnlp)

  /* TRACE Component channel_14_cave1_box3 [658] */
  mccoordschange(mcposrchannel_14_cave1_box3, mcrotrchannel_14_cave1_box3,
    &mcnlx,
    &mcnly,
    &mcnlz,
    &mcnlvx,
    &mcnlvy,
    &mcnlvz,
    &mcnlsx,
    &mcnlsy,
    &mcnlsz);
  /* define label inside component channel_14_cave1_box3 (without coords transformations) */
  mcJumpTrace_channel_14_cave1_box3:
  SIG_MESSAGE("channel_14_cave1_box3 (Trace)");
  mcDEBUG_COMP("channel_14_cave1_box3")
  mcDEBUG_STATE(
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp)
#define x mcnlx
#define y mcnly
#define z mcnlz
#define vx mcnlvx
#define vy mcnlvy
#define vz mcnlvz
#define t mcnlt
#define sx mcnlsx
#define sy mcnlsy
#define sz mcnlsz
#define p mcnlp

#define mcabsorbComp mcabsorbCompchannel_14_cave1_box3
  STORE_NEUTRON(658,
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp);
  mcScattered=0;
  mcRestore=0;
  mcNCounter[658]++;
  mcPCounter[658] += p;
  mcP2Counter[658] += p*p;
#define mccompcurname  channel_14_cave1_box3
#define mccompcurtype  Union_box
#define mccompcurindex 658
#define loop_index mccchannel_14_cave1_box3_loop_index
#define this_box_volume mccchannel_14_cave1_box3_this_box_volume
#define global_geometry_element mccchannel_14_cave1_box3_global_geometry_element
#define this_box_storage mccchannel_14_cave1_box3_this_box_storage
{   /* Declarations of channel_14_cave1_box3=Union_box() SETTING parameters. */
char* material_string = mccchannel_14_cave1_box3_material_string;
MCNUM priority = mccchannel_14_cave1_box3_priority;
MCNUM xwidth = mccchannel_14_cave1_box3_xwidth;
MCNUM yheight = mccchannel_14_cave1_box3_yheight;
MCNUM zdepth = mccchannel_14_cave1_box3_zdepth;
MCNUM xwidth2 = mccchannel_14_cave1_box3_xwidth2;
MCNUM yheight2 = mccchannel_14_cave1_box3_yheight2;
MCNUM visualize = mccchannel_14_cave1_box3_visualize;
int target_index = mccchannel_14_cave1_box3_target_index;
MCNUM target_x = mccchannel_14_cave1_box3_target_x;
MCNUM target_y = mccchannel_14_cave1_box3_target_y;
MCNUM target_z = mccchannel_14_cave1_box3_target_z;
MCNUM focus_aw = mccchannel_14_cave1_box3_focus_aw;
MCNUM focus_ah = mccchannel_14_cave1_box3_focus_ah;
MCNUM focus_xw = mccchannel_14_cave1_box3_focus_xw;
MCNUM focus_xh = mccchannel_14_cave1_box3_focus_xh;
MCNUM focus_r = mccchannel_14_cave1_box3_focus_r;
MCNUM p_interact = mccchannel_14_cave1_box3_p_interact;
char* mask_string = mccchannel_14_cave1_box3_mask_string;
char* mask_setting = mccchannel_14_cave1_box3_mask_setting;
MCNUM number_of_activations = mccchannel_14_cave1_box3_number_of_activations;
}   /* End of channel_14_cave1_box3=Union_box() SETTING parameter declarations. */
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex
  /* Label for restoring  neutron */
  mcabsorbCompchannel_14_cave1_box3:
  if (RESTORE) /* restore if needed */
  { RESTORE_NEUTRON(658,
      mcnlx,
      mcnly,
      mcnlz,
      mcnlvx,
      mcnlvy,
      mcnlvz,
      mcnlt,
      mcnlsx,
      mcnlsy,
      mcnlsz,
      mcnlp); }
#undef mcabsorbComp
#undef p
#undef sz
#undef sy
#undef sx
#undef t
#undef vz
#undef vy
#undef vx
#undef z
#undef y
#undef x
  mcDEBUG_STATE(
mcnlx,
mcnly,
mcnlz,
mcnlvx,
mcnlvy,
mcnlvz,
mcnlt,
mcnlsx,
mcnlsy,
mcnlsz,
mcnlp)

  /* TRACE Component channel_14_cave1_cyl1 [659] */
  mccoordschange(mcposrchannel_14_cave1_cyl1, mcrotrchannel_14_cave1_cyl1,
    &mcnlx,
    &mcnly,
    &mcnlz,
    &mcnlvx,
    &mcnlvy,
    &mcnlvz,
    &mcnlsx,
    &mcnlsy,
    &mcnlsz);
  /* define label inside component channel_14_cave1_cyl1 (without coords transformations) */
  mcJumpTrace_channel_14_cave1_cyl1:
  SIG_MESSAGE("channel_14_cave1_cyl1 (Trace)");
  mcDEBUG_COMP("channel_14_cave1_cyl1")
  mcDEBUG_STATE(
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp)
#define x mcnlx
#define y mcnly
#define z mcnlz
#define vx mcnlvx
#define vy mcnlvy
#define vz mcnlvz
#define t mcnlt
#define sx mcnlsx
#define sy mcnlsy
#define sz mcnlsz
#define p mcnlp

#define mcabsorbComp mcabsorbCompchannel_14_cave1_cyl1
  STORE_NEUTRON(659,
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp);
  mcScattered=0;
  mcRestore=0;
  mcNCounter[659]++;
  mcPCounter[659] += p;
  mcP2Counter[659] += p*p;
#define mccompcurname  channel_14_cave1_cyl1
#define mccompcurtype  Union_cylinder
#define mccompcurindex 659
#define loop_index mccchannel_14_cave1_cyl1_loop_index
#define this_cylinder_volume mccchannel_14_cave1_cyl1_this_cylinder_volume
#define global_geometry_element mccchannel_14_cave1_cyl1_global_geometry_element
#define this_cylinder_storage mccchannel_14_cave1_cyl1_this_cylinder_storage
{   /* Declarations of channel_14_cave1_cyl1=Union_cylinder() SETTING parameters. */
char* material_string = mccchannel_14_cave1_cyl1_material_string;
MCNUM priority = mccchannel_14_cave1_cyl1_priority;
MCNUM radius = mccchannel_14_cave1_cyl1_radius;
MCNUM yheight = mccchannel_14_cave1_cyl1_yheight;
MCNUM visualize = mccchannel_14_cave1_cyl1_visualize;
int target_index = mccchannel_14_cave1_cyl1_target_index;
MCNUM target_x = mccchannel_14_cave1_cyl1_target_x;
MCNUM target_y = mccchannel_14_cave1_cyl1_target_y;
MCNUM target_z = mccchannel_14_cave1_cyl1_target_z;
MCNUM focus_aw = mccchannel_14_cave1_cyl1_focus_aw;
MCNUM focus_ah = mccchannel_14_cave1_cyl1_focus_ah;
MCNUM focus_xw = mccchannel_14_cave1_cyl1_focus_xw;
MCNUM focus_xh = mccchannel_14_cave1_cyl1_focus_xh;
MCNUM focus_r = mccchannel_14_cave1_cyl1_focus_r;
MCNUM p_interact = mccchannel_14_cave1_cyl1_p_interact;
char* mask_string = mccchannel_14_cave1_cyl1_mask_string;
char* mask_setting = mccchannel_14_cave1_cyl1_mask_setting;
MCNUM number_of_activations = mccchannel_14_cave1_cyl1_number_of_activations;
#line 345 "Union_cylinder.comp"
{
dummy = 1;
}
#line 432232 "MACS_sample_kidney_box.c"
}   /* End of channel_14_cave1_cyl1=Union_cylinder() SETTING parameter declarations. */
#undef this_cylinder_storage
#undef global_geometry_element
#undef this_cylinder_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex
  /* Label for restoring  neutron */
  mcabsorbCompchannel_14_cave1_cyl1:
  if (RESTORE) /* restore if needed */
  { RESTORE_NEUTRON(659,
      mcnlx,
      mcnly,
      mcnlz,
      mcnlvx,
      mcnlvy,
      mcnlvz,
      mcnlt,
      mcnlsx,
      mcnlsy,
      mcnlsz,
      mcnlp); }
#undef mcabsorbComp
#undef p
#undef sz
#undef sy
#undef sx
#undef t
#undef vz
#undef vy
#undef vx
#undef z
#undef y
#undef x
  mcDEBUG_STATE(
mcnlx,
mcnly,
mcnlz,
mcnlvx,
mcnlvy,
mcnlvz,
mcnlt,
mcnlsx,
mcnlsy,
mcnlsz,
mcnlp)

  /* TRACE Component channel_14_analyzer_1_center [660] */
  mccoordschange(mcposrchannel_14_analyzer_1_center, mcrotrchannel_14_analyzer_1_center,
    &mcnlx,
    &mcnly,
    &mcnlz,
    &mcnlvx,
    &mcnlvy,
    &mcnlvz,
    &mcnlsx,
    &mcnlsy,
    &mcnlsz);
  /* define label inside component channel_14_analyzer_1_center (without coords transformations) */
  mcJumpTrace_channel_14_analyzer_1_center:
  SIG_MESSAGE("channel_14_analyzer_1_center (Trace)");
  mcDEBUG_COMP("channel_14_analyzer_1_center")
  mcDEBUG_STATE(
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp)
#define x mcnlx
#define y mcnly
#define z mcnlz
#define vx mcnlvx
#define vy mcnlvy
#define vz mcnlvz
#define t mcnlt
#define sx mcnlsx
#define sy mcnlsy
#define sz mcnlsz
#define p mcnlp

#define mcabsorbComp mcabsorbCompchannel_14_analyzer_1_center
  STORE_NEUTRON(660,
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp);
  mcScattered=0;
  mcRestore=0;
  mcNCounter[660]++;
  mcPCounter[660] += p;
  mcP2Counter[660] += p*p;
#define mccompcurname  channel_14_analyzer_1_center
#define mccompcurtype  Arm
#define mccompcurindex 660
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex
  /* Label for restoring  neutron */
  mcabsorbCompchannel_14_analyzer_1_center:
  if (RESTORE) /* restore if needed */
  { RESTORE_NEUTRON(660,
      mcnlx,
      mcnly,
      mcnlz,
      mcnlvx,
      mcnlvy,
      mcnlvz,
      mcnlt,
      mcnlsx,
      mcnlsy,
      mcnlsz,
      mcnlp); }
#undef mcabsorbComp
#undef p
#undef sz
#undef sy
#undef sx
#undef t
#undef vz
#undef vy
#undef vx
#undef z
#undef y
#undef x
  mcDEBUG_STATE(
mcnlx,
mcnly,
mcnlz,
mcnlvx,
mcnlvy,
mcnlvz,
mcnlt,
mcnlsx,
mcnlsy,
mcnlsz,
mcnlp)

  /* TRACE Component channel_14_analyzer_1_rotated [661] */
  mccoordschange(mcposrchannel_14_analyzer_1_rotated, mcrotrchannel_14_analyzer_1_rotated,
    &mcnlx,
    &mcnly,
    &mcnlz,
    &mcnlvx,
    &mcnlvy,
    &mcnlvz,
    &mcnlsx,
    &mcnlsy,
    &mcnlsz);
  /* define label inside component channel_14_analyzer_1_rotated (without coords transformations) */
  mcJumpTrace_channel_14_analyzer_1_rotated:
  SIG_MESSAGE("channel_14_analyzer_1_rotated (Trace)");
  mcDEBUG_COMP("channel_14_analyzer_1_rotated")
  mcDEBUG_STATE(
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp)
#define x mcnlx
#define y mcnly
#define z mcnlz
#define vx mcnlvx
#define vy mcnlvy
#define vz mcnlvz
#define t mcnlt
#define sx mcnlsx
#define sy mcnlsy
#define sz mcnlsz
#define p mcnlp

#define mcabsorbComp mcabsorbCompchannel_14_analyzer_1_rotated
  STORE_NEUTRON(661,
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp);
  mcScattered=0;
  mcRestore=0;
  mcNCounter[661]++;
  mcPCounter[661] += p;
  mcP2Counter[661] += p*p;
#define mccompcurname  channel_14_analyzer_1_rotated
#define mccompcurtype  Arm
#define mccompcurindex 661
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex
  /* Label for restoring  neutron */
  mcabsorbCompchannel_14_analyzer_1_rotated:
  if (RESTORE) /* restore if needed */
  { RESTORE_NEUTRON(661,
      mcnlx,
      mcnly,
      mcnlz,
      mcnlvx,
      mcnlvy,
      mcnlvz,
      mcnlt,
      mcnlsx,
      mcnlsy,
      mcnlsz,
      mcnlp); }
#undef mcabsorbComp
#undef p
#undef sz
#undef sy
#undef sx
#undef t
#undef vz
#undef vy
#undef vx
#undef z
#undef y
#undef x
  mcDEBUG_STATE(
mcnlx,
mcnly,
mcnlz,
mcnlvx,
mcnlvy,
mcnlvz,
mcnlt,
mcnlsx,
mcnlsy,
mcnlsz,
mcnlp)

  /* TRACE Component channel_14_analyzer_1_array_crystal_array_0 [662] */
  mccoordschange(mcposrchannel_14_analyzer_1_array_crystal_array_0, mcrotrchannel_14_analyzer_1_array_crystal_array_0,
    &mcnlx,
    &mcnly,
    &mcnlz,
    &mcnlvx,
    &mcnlvy,
    &mcnlvz,
    &mcnlsx,
    &mcnlsy,
    &mcnlsz);
  /* define label inside component channel_14_analyzer_1_array_crystal_array_0 (without coords transformations) */
  mcJumpTrace_channel_14_analyzer_1_array_crystal_array_0:
  SIG_MESSAGE("channel_14_analyzer_1_array_crystal_array_0 (Trace)");
  mcDEBUG_COMP("channel_14_analyzer_1_array_crystal_array_0")
  mcDEBUG_STATE(
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp)
#define x mcnlx
#define y mcnly
#define z mcnlz
#define vx mcnlvx
#define vy mcnlvy
#define vz mcnlvz
#define t mcnlt
#define sx mcnlsx
#define sy mcnlsy
#define sz mcnlsz
#define p mcnlp

#define mcabsorbComp mcabsorbCompchannel_14_analyzer_1_array_crystal_array_0
  STORE_NEUTRON(662,
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp);
  mcScattered=0;
  mcRestore=0;
  mcNCounter[662]++;
  mcPCounter[662] += p;
  mcP2Counter[662] += p*p;
#define mccompcurname  channel_14_analyzer_1_array_crystal_array_0
#define mccompcurtype  Union_box
#define mccompcurindex 662
#define loop_index mccchannel_14_analyzer_1_array_crystal_array_0_loop_index
#define this_box_volume mccchannel_14_analyzer_1_array_crystal_array_0_this_box_volume
#define global_geometry_element mccchannel_14_analyzer_1_array_crystal_array_0_global_geometry_element
#define this_box_storage mccchannel_14_analyzer_1_array_crystal_array_0_this_box_storage
{   /* Declarations of channel_14_analyzer_1_array_crystal_array_0=Union_box() SETTING parameters. */
char* material_string = mccchannel_14_analyzer_1_array_crystal_array_0_material_string;
MCNUM priority = mccchannel_14_analyzer_1_array_crystal_array_0_priority;
MCNUM xwidth = mccchannel_14_analyzer_1_array_crystal_array_0_xwidth;
MCNUM yheight = mccchannel_14_analyzer_1_array_crystal_array_0_yheight;
MCNUM zdepth = mccchannel_14_analyzer_1_array_crystal_array_0_zdepth;
MCNUM xwidth2 = mccchannel_14_analyzer_1_array_crystal_array_0_xwidth2;
MCNUM yheight2 = mccchannel_14_analyzer_1_array_crystal_array_0_yheight2;
MCNUM visualize = mccchannel_14_analyzer_1_array_crystal_array_0_visualize;
int target_index = mccchannel_14_analyzer_1_array_crystal_array_0_target_index;
MCNUM target_x = mccchannel_14_analyzer_1_array_crystal_array_0_target_x;
MCNUM target_y = mccchannel_14_analyzer_1_array_crystal_array_0_target_y;
MCNUM target_z = mccchannel_14_analyzer_1_array_crystal_array_0_target_z;
MCNUM focus_aw = mccchannel_14_analyzer_1_array_crystal_array_0_focus_aw;
MCNUM focus_ah = mccchannel_14_analyzer_1_array_crystal_array_0_focus_ah;
MCNUM focus_xw = mccchannel_14_analyzer_1_array_crystal_array_0_focus_xw;
MCNUM focus_xh = mccchannel_14_analyzer_1_array_crystal_array_0_focus_xh;
MCNUM focus_r = mccchannel_14_analyzer_1_array_crystal_array_0_focus_r;
MCNUM p_interact = mccchannel_14_analyzer_1_array_crystal_array_0_p_interact;
char* mask_string = mccchannel_14_analyzer_1_array_crystal_array_0_mask_string;
char* mask_setting = mccchannel_14_analyzer_1_array_crystal_array_0_mask_setting;
MCNUM number_of_activations = mccchannel_14_analyzer_1_array_crystal_array_0_number_of_activations;
}   /* End of channel_14_analyzer_1_array_crystal_array_0=Union_box() SETTING parameter declarations. */
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex
  /* Label for restoring  neutron */
  mcabsorbCompchannel_14_analyzer_1_array_crystal_array_0:
  if (RESTORE) /* restore if needed */
  { RESTORE_NEUTRON(662,
      mcnlx,
      mcnly,
      mcnlz,
      mcnlvx,
      mcnlvy,
      mcnlvz,
      mcnlt,
      mcnlsx,
      mcnlsy,
      mcnlsz,
      mcnlp); }
#undef mcabsorbComp
#undef p
#undef sz
#undef sy
#undef sx
#undef t
#undef vz
#undef vy
#undef vx
#undef z
#undef y
#undef x
  mcDEBUG_STATE(
mcnlx,
mcnly,
mcnlz,
mcnlvx,
mcnlvy,
mcnlvz,
mcnlt,
mcnlsx,
mcnlsy,
mcnlsz,
mcnlp)

  /* TRACE Component channel_14_analyzer_1_array_crystal_array_1 [663] */
  mccoordschange(mcposrchannel_14_analyzer_1_array_crystal_array_1, mcrotrchannel_14_analyzer_1_array_crystal_array_1,
    &mcnlx,
    &mcnly,
    &mcnlz,
    &mcnlvx,
    &mcnlvy,
    &mcnlvz,
    &mcnlsx,
    &mcnlsy,
    &mcnlsz);
  /* define label inside component channel_14_analyzer_1_array_crystal_array_1 (without coords transformations) */
  mcJumpTrace_channel_14_analyzer_1_array_crystal_array_1:
  SIG_MESSAGE("channel_14_analyzer_1_array_crystal_array_1 (Trace)");
  mcDEBUG_COMP("channel_14_analyzer_1_array_crystal_array_1")
  mcDEBUG_STATE(
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp)
#define x mcnlx
#define y mcnly
#define z mcnlz
#define vx mcnlvx
#define vy mcnlvy
#define vz mcnlvz
#define t mcnlt
#define sx mcnlsx
#define sy mcnlsy
#define sz mcnlsz
#define p mcnlp

#define mcabsorbComp mcabsorbCompchannel_14_analyzer_1_array_crystal_array_1
  STORE_NEUTRON(663,
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp);
  mcScattered=0;
  mcRestore=0;
  mcNCounter[663]++;
  mcPCounter[663] += p;
  mcP2Counter[663] += p*p;
#define mccompcurname  channel_14_analyzer_1_array_crystal_array_1
#define mccompcurtype  Union_box
#define mccompcurindex 663
#define loop_index mccchannel_14_analyzer_1_array_crystal_array_1_loop_index
#define this_box_volume mccchannel_14_analyzer_1_array_crystal_array_1_this_box_volume
#define global_geometry_element mccchannel_14_analyzer_1_array_crystal_array_1_global_geometry_element
#define this_box_storage mccchannel_14_analyzer_1_array_crystal_array_1_this_box_storage
{   /* Declarations of channel_14_analyzer_1_array_crystal_array_1=Union_box() SETTING parameters. */
char* material_string = mccchannel_14_analyzer_1_array_crystal_array_1_material_string;
MCNUM priority = mccchannel_14_analyzer_1_array_crystal_array_1_priority;
MCNUM xwidth = mccchannel_14_analyzer_1_array_crystal_array_1_xwidth;
MCNUM yheight = mccchannel_14_analyzer_1_array_crystal_array_1_yheight;
MCNUM zdepth = mccchannel_14_analyzer_1_array_crystal_array_1_zdepth;
MCNUM xwidth2 = mccchannel_14_analyzer_1_array_crystal_array_1_xwidth2;
MCNUM yheight2 = mccchannel_14_analyzer_1_array_crystal_array_1_yheight2;
MCNUM visualize = mccchannel_14_analyzer_1_array_crystal_array_1_visualize;
int target_index = mccchannel_14_analyzer_1_array_crystal_array_1_target_index;
MCNUM target_x = mccchannel_14_analyzer_1_array_crystal_array_1_target_x;
MCNUM target_y = mccchannel_14_analyzer_1_array_crystal_array_1_target_y;
MCNUM target_z = mccchannel_14_analyzer_1_array_crystal_array_1_target_z;
MCNUM focus_aw = mccchannel_14_analyzer_1_array_crystal_array_1_focus_aw;
MCNUM focus_ah = mccchannel_14_analyzer_1_array_crystal_array_1_focus_ah;
MCNUM focus_xw = mccchannel_14_analyzer_1_array_crystal_array_1_focus_xw;
MCNUM focus_xh = mccchannel_14_analyzer_1_array_crystal_array_1_focus_xh;
MCNUM focus_r = mccchannel_14_analyzer_1_array_crystal_array_1_focus_r;
MCNUM p_interact = mccchannel_14_analyzer_1_array_crystal_array_1_p_interact;
char* mask_string = mccchannel_14_analyzer_1_array_crystal_array_1_mask_string;
char* mask_setting = mccchannel_14_analyzer_1_array_crystal_array_1_mask_setting;
MCNUM number_of_activations = mccchannel_14_analyzer_1_array_crystal_array_1_number_of_activations;
}   /* End of channel_14_analyzer_1_array_crystal_array_1=Union_box() SETTING parameter declarations. */
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex
  /* Label for restoring  neutron */
  mcabsorbCompchannel_14_analyzer_1_array_crystal_array_1:
  if (RESTORE) /* restore if needed */
  { RESTORE_NEUTRON(663,
      mcnlx,
      mcnly,
      mcnlz,
      mcnlvx,
      mcnlvy,
      mcnlvz,
      mcnlt,
      mcnlsx,
      mcnlsy,
      mcnlsz,
      mcnlp); }
#undef mcabsorbComp
#undef p
#undef sz
#undef sy
#undef sx
#undef t
#undef vz
#undef vy
#undef vx
#undef z
#undef y
#undef x
  mcDEBUG_STATE(
mcnlx,
mcnly,
mcnlz,
mcnlvx,
mcnlvy,
mcnlvz,
mcnlt,
mcnlsx,
mcnlsy,
mcnlsz,
mcnlp)

  /* TRACE Component channel_14_analyzer_1_array_crystal_array_2 [664] */
  mccoordschange(mcposrchannel_14_analyzer_1_array_crystal_array_2, mcrotrchannel_14_analyzer_1_array_crystal_array_2,
    &mcnlx,
    &mcnly,
    &mcnlz,
    &mcnlvx,
    &mcnlvy,
    &mcnlvz,
    &mcnlsx,
    &mcnlsy,
    &mcnlsz);
  /* define label inside component channel_14_analyzer_1_array_crystal_array_2 (without coords transformations) */
  mcJumpTrace_channel_14_analyzer_1_array_crystal_array_2:
  SIG_MESSAGE("channel_14_analyzer_1_array_crystal_array_2 (Trace)");
  mcDEBUG_COMP("channel_14_analyzer_1_array_crystal_array_2")
  mcDEBUG_STATE(
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp)
#define x mcnlx
#define y mcnly
#define z mcnlz
#define vx mcnlvx
#define vy mcnlvy
#define vz mcnlvz
#define t mcnlt
#define sx mcnlsx
#define sy mcnlsy
#define sz mcnlsz
#define p mcnlp

#define mcabsorbComp mcabsorbCompchannel_14_analyzer_1_array_crystal_array_2
  STORE_NEUTRON(664,
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp);
  mcScattered=0;
  mcRestore=0;
  mcNCounter[664]++;
  mcPCounter[664] += p;
  mcP2Counter[664] += p*p;
#define mccompcurname  channel_14_analyzer_1_array_crystal_array_2
#define mccompcurtype  Union_box
#define mccompcurindex 664
#define loop_index mccchannel_14_analyzer_1_array_crystal_array_2_loop_index
#define this_box_volume mccchannel_14_analyzer_1_array_crystal_array_2_this_box_volume
#define global_geometry_element mccchannel_14_analyzer_1_array_crystal_array_2_global_geometry_element
#define this_box_storage mccchannel_14_analyzer_1_array_crystal_array_2_this_box_storage
{   /* Declarations of channel_14_analyzer_1_array_crystal_array_2=Union_box() SETTING parameters. */
char* material_string = mccchannel_14_analyzer_1_array_crystal_array_2_material_string;
MCNUM priority = mccchannel_14_analyzer_1_array_crystal_array_2_priority;
MCNUM xwidth = mccchannel_14_analyzer_1_array_crystal_array_2_xwidth;
MCNUM yheight = mccchannel_14_analyzer_1_array_crystal_array_2_yheight;
MCNUM zdepth = mccchannel_14_analyzer_1_array_crystal_array_2_zdepth;
MCNUM xwidth2 = mccchannel_14_analyzer_1_array_crystal_array_2_xwidth2;
MCNUM yheight2 = mccchannel_14_analyzer_1_array_crystal_array_2_yheight2;
MCNUM visualize = mccchannel_14_analyzer_1_array_crystal_array_2_visualize;
int target_index = mccchannel_14_analyzer_1_array_crystal_array_2_target_index;
MCNUM target_x = mccchannel_14_analyzer_1_array_crystal_array_2_target_x;
MCNUM target_y = mccchannel_14_analyzer_1_array_crystal_array_2_target_y;
MCNUM target_z = mccchannel_14_analyzer_1_array_crystal_array_2_target_z;
MCNUM focus_aw = mccchannel_14_analyzer_1_array_crystal_array_2_focus_aw;
MCNUM focus_ah = mccchannel_14_analyzer_1_array_crystal_array_2_focus_ah;
MCNUM focus_xw = mccchannel_14_analyzer_1_array_crystal_array_2_focus_xw;
MCNUM focus_xh = mccchannel_14_analyzer_1_array_crystal_array_2_focus_xh;
MCNUM focus_r = mccchannel_14_analyzer_1_array_crystal_array_2_focus_r;
MCNUM p_interact = mccchannel_14_analyzer_1_array_crystal_array_2_p_interact;
char* mask_string = mccchannel_14_analyzer_1_array_crystal_array_2_mask_string;
char* mask_setting = mccchannel_14_analyzer_1_array_crystal_array_2_mask_setting;
MCNUM number_of_activations = mccchannel_14_analyzer_1_array_crystal_array_2_number_of_activations;
}   /* End of channel_14_analyzer_1_array_crystal_array_2=Union_box() SETTING parameter declarations. */
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex
  /* Label for restoring  neutron */
  mcabsorbCompchannel_14_analyzer_1_array_crystal_array_2:
  if (RESTORE) /* restore if needed */
  { RESTORE_NEUTRON(664,
      mcnlx,
      mcnly,
      mcnlz,
      mcnlvx,
      mcnlvy,
      mcnlvz,
      mcnlt,
      mcnlsx,
      mcnlsy,
      mcnlsz,
      mcnlp); }
#undef mcabsorbComp
#undef p
#undef sz
#undef sy
#undef sx
#undef t
#undef vz
#undef vy
#undef vx
#undef z
#undef y
#undef x
  mcDEBUG_STATE(
mcnlx,
mcnly,
mcnlz,
mcnlvx,
mcnlvy,
mcnlvz,
mcnlt,
mcnlsx,
mcnlsy,
mcnlsz,
mcnlp)

  /* TRACE Component channel_14_analyzer_1_array_crystal_array_3 [665] */
  mccoordschange(mcposrchannel_14_analyzer_1_array_crystal_array_3, mcrotrchannel_14_analyzer_1_array_crystal_array_3,
    &mcnlx,
    &mcnly,
    &mcnlz,
    &mcnlvx,
    &mcnlvy,
    &mcnlvz,
    &mcnlsx,
    &mcnlsy,
    &mcnlsz);
  /* define label inside component channel_14_analyzer_1_array_crystal_array_3 (without coords transformations) */
  mcJumpTrace_channel_14_analyzer_1_array_crystal_array_3:
  SIG_MESSAGE("channel_14_analyzer_1_array_crystal_array_3 (Trace)");
  mcDEBUG_COMP("channel_14_analyzer_1_array_crystal_array_3")
  mcDEBUG_STATE(
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp)
#define x mcnlx
#define y mcnly
#define z mcnlz
#define vx mcnlvx
#define vy mcnlvy
#define vz mcnlvz
#define t mcnlt
#define sx mcnlsx
#define sy mcnlsy
#define sz mcnlsz
#define p mcnlp

#define mcabsorbComp mcabsorbCompchannel_14_analyzer_1_array_crystal_array_3
  STORE_NEUTRON(665,
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp);
  mcScattered=0;
  mcRestore=0;
  mcNCounter[665]++;
  mcPCounter[665] += p;
  mcP2Counter[665] += p*p;
#define mccompcurname  channel_14_analyzer_1_array_crystal_array_3
#define mccompcurtype  Union_box
#define mccompcurindex 665
#define loop_index mccchannel_14_analyzer_1_array_crystal_array_3_loop_index
#define this_box_volume mccchannel_14_analyzer_1_array_crystal_array_3_this_box_volume
#define global_geometry_element mccchannel_14_analyzer_1_array_crystal_array_3_global_geometry_element
#define this_box_storage mccchannel_14_analyzer_1_array_crystal_array_3_this_box_storage
{   /* Declarations of channel_14_analyzer_1_array_crystal_array_3=Union_box() SETTING parameters. */
char* material_string = mccchannel_14_analyzer_1_array_crystal_array_3_material_string;
MCNUM priority = mccchannel_14_analyzer_1_array_crystal_array_3_priority;
MCNUM xwidth = mccchannel_14_analyzer_1_array_crystal_array_3_xwidth;
MCNUM yheight = mccchannel_14_analyzer_1_array_crystal_array_3_yheight;
MCNUM zdepth = mccchannel_14_analyzer_1_array_crystal_array_3_zdepth;
MCNUM xwidth2 = mccchannel_14_analyzer_1_array_crystal_array_3_xwidth2;
MCNUM yheight2 = mccchannel_14_analyzer_1_array_crystal_array_3_yheight2;
MCNUM visualize = mccchannel_14_analyzer_1_array_crystal_array_3_visualize;
int target_index = mccchannel_14_analyzer_1_array_crystal_array_3_target_index;
MCNUM target_x = mccchannel_14_analyzer_1_array_crystal_array_3_target_x;
MCNUM target_y = mccchannel_14_analyzer_1_array_crystal_array_3_target_y;
MCNUM target_z = mccchannel_14_analyzer_1_array_crystal_array_3_target_z;
MCNUM focus_aw = mccchannel_14_analyzer_1_array_crystal_array_3_focus_aw;
MCNUM focus_ah = mccchannel_14_analyzer_1_array_crystal_array_3_focus_ah;
MCNUM focus_xw = mccchannel_14_analyzer_1_array_crystal_array_3_focus_xw;
MCNUM focus_xh = mccchannel_14_analyzer_1_array_crystal_array_3_focus_xh;
MCNUM focus_r = mccchannel_14_analyzer_1_array_crystal_array_3_focus_r;
MCNUM p_interact = mccchannel_14_analyzer_1_array_crystal_array_3_p_interact;
char* mask_string = mccchannel_14_analyzer_1_array_crystal_array_3_mask_string;
char* mask_setting = mccchannel_14_analyzer_1_array_crystal_array_3_mask_setting;
MCNUM number_of_activations = mccchannel_14_analyzer_1_array_crystal_array_3_number_of_activations;
}   /* End of channel_14_analyzer_1_array_crystal_array_3=Union_box() SETTING parameter declarations. */
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex
  /* Label for restoring  neutron */
  mcabsorbCompchannel_14_analyzer_1_array_crystal_array_3:
  if (RESTORE) /* restore if needed */
  { RESTORE_NEUTRON(665,
      mcnlx,
      mcnly,
      mcnlz,
      mcnlvx,
      mcnlvy,
      mcnlvz,
      mcnlt,
      mcnlsx,
      mcnlsy,
      mcnlsz,
      mcnlp); }
#undef mcabsorbComp
#undef p
#undef sz
#undef sy
#undef sx
#undef t
#undef vz
#undef vy
#undef vx
#undef z
#undef y
#undef x
  mcDEBUG_STATE(
mcnlx,
mcnly,
mcnlz,
mcnlvx,
mcnlvy,
mcnlvz,
mcnlt,
mcnlsx,
mcnlsy,
mcnlsz,
mcnlp)

  /* TRACE Component channel_14_analyzer_1_array_crystal_array_4 [666] */
  mccoordschange(mcposrchannel_14_analyzer_1_array_crystal_array_4, mcrotrchannel_14_analyzer_1_array_crystal_array_4,
    &mcnlx,
    &mcnly,
    &mcnlz,
    &mcnlvx,
    &mcnlvy,
    &mcnlvz,
    &mcnlsx,
    &mcnlsy,
    &mcnlsz);
  /* define label inside component channel_14_analyzer_1_array_crystal_array_4 (without coords transformations) */
  mcJumpTrace_channel_14_analyzer_1_array_crystal_array_4:
  SIG_MESSAGE("channel_14_analyzer_1_array_crystal_array_4 (Trace)");
  mcDEBUG_COMP("channel_14_analyzer_1_array_crystal_array_4")
  mcDEBUG_STATE(
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp)
#define x mcnlx
#define y mcnly
#define z mcnlz
#define vx mcnlvx
#define vy mcnlvy
#define vz mcnlvz
#define t mcnlt
#define sx mcnlsx
#define sy mcnlsy
#define sz mcnlsz
#define p mcnlp

#define mcabsorbComp mcabsorbCompchannel_14_analyzer_1_array_crystal_array_4
  STORE_NEUTRON(666,
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp);
  mcScattered=0;
  mcRestore=0;
  mcNCounter[666]++;
  mcPCounter[666] += p;
  mcP2Counter[666] += p*p;
#define mccompcurname  channel_14_analyzer_1_array_crystal_array_4
#define mccompcurtype  Union_box
#define mccompcurindex 666
#define loop_index mccchannel_14_analyzer_1_array_crystal_array_4_loop_index
#define this_box_volume mccchannel_14_analyzer_1_array_crystal_array_4_this_box_volume
#define global_geometry_element mccchannel_14_analyzer_1_array_crystal_array_4_global_geometry_element
#define this_box_storage mccchannel_14_analyzer_1_array_crystal_array_4_this_box_storage
{   /* Declarations of channel_14_analyzer_1_array_crystal_array_4=Union_box() SETTING parameters. */
char* material_string = mccchannel_14_analyzer_1_array_crystal_array_4_material_string;
MCNUM priority = mccchannel_14_analyzer_1_array_crystal_array_4_priority;
MCNUM xwidth = mccchannel_14_analyzer_1_array_crystal_array_4_xwidth;
MCNUM yheight = mccchannel_14_analyzer_1_array_crystal_array_4_yheight;
MCNUM zdepth = mccchannel_14_analyzer_1_array_crystal_array_4_zdepth;
MCNUM xwidth2 = mccchannel_14_analyzer_1_array_crystal_array_4_xwidth2;
MCNUM yheight2 = mccchannel_14_analyzer_1_array_crystal_array_4_yheight2;
MCNUM visualize = mccchannel_14_analyzer_1_array_crystal_array_4_visualize;
int target_index = mccchannel_14_analyzer_1_array_crystal_array_4_target_index;
MCNUM target_x = mccchannel_14_analyzer_1_array_crystal_array_4_target_x;
MCNUM target_y = mccchannel_14_analyzer_1_array_crystal_array_4_target_y;
MCNUM target_z = mccchannel_14_analyzer_1_array_crystal_array_4_target_z;
MCNUM focus_aw = mccchannel_14_analyzer_1_array_crystal_array_4_focus_aw;
MCNUM focus_ah = mccchannel_14_analyzer_1_array_crystal_array_4_focus_ah;
MCNUM focus_xw = mccchannel_14_analyzer_1_array_crystal_array_4_focus_xw;
MCNUM focus_xh = mccchannel_14_analyzer_1_array_crystal_array_4_focus_xh;
MCNUM focus_r = mccchannel_14_analyzer_1_array_crystal_array_4_focus_r;
MCNUM p_interact = mccchannel_14_analyzer_1_array_crystal_array_4_p_interact;
char* mask_string = mccchannel_14_analyzer_1_array_crystal_array_4_mask_string;
char* mask_setting = mccchannel_14_analyzer_1_array_crystal_array_4_mask_setting;
MCNUM number_of_activations = mccchannel_14_analyzer_1_array_crystal_array_4_number_of_activations;
}   /* End of channel_14_analyzer_1_array_crystal_array_4=Union_box() SETTING parameter declarations. */
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex
  /* Label for restoring  neutron */
  mcabsorbCompchannel_14_analyzer_1_array_crystal_array_4:
  if (RESTORE) /* restore if needed */
  { RESTORE_NEUTRON(666,
      mcnlx,
      mcnly,
      mcnlz,
      mcnlvx,
      mcnlvy,
      mcnlvz,
      mcnlt,
      mcnlsx,
      mcnlsy,
      mcnlsz,
      mcnlp); }
#undef mcabsorbComp
#undef p
#undef sz
#undef sy
#undef sx
#undef t
#undef vz
#undef vy
#undef vx
#undef z
#undef y
#undef x
  mcDEBUG_STATE(
mcnlx,
mcnly,
mcnlz,
mcnlvx,
mcnlvy,
mcnlvz,
mcnlt,
mcnlsx,
mcnlsy,
mcnlsz,
mcnlp)

  /* TRACE Component channel_14_analyzer_1_array_crystal_array_5 [667] */
  mccoordschange(mcposrchannel_14_analyzer_1_array_crystal_array_5, mcrotrchannel_14_analyzer_1_array_crystal_array_5,
    &mcnlx,
    &mcnly,
    &mcnlz,
    &mcnlvx,
    &mcnlvy,
    &mcnlvz,
    &mcnlsx,
    &mcnlsy,
    &mcnlsz);
  /* define label inside component channel_14_analyzer_1_array_crystal_array_5 (without coords transformations) */
  mcJumpTrace_channel_14_analyzer_1_array_crystal_array_5:
  SIG_MESSAGE("channel_14_analyzer_1_array_crystal_array_5 (Trace)");
  mcDEBUG_COMP("channel_14_analyzer_1_array_crystal_array_5")
  mcDEBUG_STATE(
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp)
#define x mcnlx
#define y mcnly
#define z mcnlz
#define vx mcnlvx
#define vy mcnlvy
#define vz mcnlvz
#define t mcnlt
#define sx mcnlsx
#define sy mcnlsy
#define sz mcnlsz
#define p mcnlp

#define mcabsorbComp mcabsorbCompchannel_14_analyzer_1_array_crystal_array_5
  STORE_NEUTRON(667,
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp);
  mcScattered=0;
  mcRestore=0;
  mcNCounter[667]++;
  mcPCounter[667] += p;
  mcP2Counter[667] += p*p;
#define mccompcurname  channel_14_analyzer_1_array_crystal_array_5
#define mccompcurtype  Union_box
#define mccompcurindex 667
#define loop_index mccchannel_14_analyzer_1_array_crystal_array_5_loop_index
#define this_box_volume mccchannel_14_analyzer_1_array_crystal_array_5_this_box_volume
#define global_geometry_element mccchannel_14_analyzer_1_array_crystal_array_5_global_geometry_element
#define this_box_storage mccchannel_14_analyzer_1_array_crystal_array_5_this_box_storage
{   /* Declarations of channel_14_analyzer_1_array_crystal_array_5=Union_box() SETTING parameters. */
char* material_string = mccchannel_14_analyzer_1_array_crystal_array_5_material_string;
MCNUM priority = mccchannel_14_analyzer_1_array_crystal_array_5_priority;
MCNUM xwidth = mccchannel_14_analyzer_1_array_crystal_array_5_xwidth;
MCNUM yheight = mccchannel_14_analyzer_1_array_crystal_array_5_yheight;
MCNUM zdepth = mccchannel_14_analyzer_1_array_crystal_array_5_zdepth;
MCNUM xwidth2 = mccchannel_14_analyzer_1_array_crystal_array_5_xwidth2;
MCNUM yheight2 = mccchannel_14_analyzer_1_array_crystal_array_5_yheight2;
MCNUM visualize = mccchannel_14_analyzer_1_array_crystal_array_5_visualize;
int target_index = mccchannel_14_analyzer_1_array_crystal_array_5_target_index;
MCNUM target_x = mccchannel_14_analyzer_1_array_crystal_array_5_target_x;
MCNUM target_y = mccchannel_14_analyzer_1_array_crystal_array_5_target_y;
MCNUM target_z = mccchannel_14_analyzer_1_array_crystal_array_5_target_z;
MCNUM focus_aw = mccchannel_14_analyzer_1_array_crystal_array_5_focus_aw;
MCNUM focus_ah = mccchannel_14_analyzer_1_array_crystal_array_5_focus_ah;
MCNUM focus_xw = mccchannel_14_analyzer_1_array_crystal_array_5_focus_xw;
MCNUM focus_xh = mccchannel_14_analyzer_1_array_crystal_array_5_focus_xh;
MCNUM focus_r = mccchannel_14_analyzer_1_array_crystal_array_5_focus_r;
MCNUM p_interact = mccchannel_14_analyzer_1_array_crystal_array_5_p_interact;
char* mask_string = mccchannel_14_analyzer_1_array_crystal_array_5_mask_string;
char* mask_setting = mccchannel_14_analyzer_1_array_crystal_array_5_mask_setting;
MCNUM number_of_activations = mccchannel_14_analyzer_1_array_crystal_array_5_number_of_activations;
}   /* End of channel_14_analyzer_1_array_crystal_array_5=Union_box() SETTING parameter declarations. */
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex
  /* Label for restoring  neutron */
  mcabsorbCompchannel_14_analyzer_1_array_crystal_array_5:
  if (RESTORE) /* restore if needed */
  { RESTORE_NEUTRON(667,
      mcnlx,
      mcnly,
      mcnlz,
      mcnlvx,
      mcnlvy,
      mcnlvz,
      mcnlt,
      mcnlsx,
      mcnlsy,
      mcnlsz,
      mcnlp); }
#undef mcabsorbComp
#undef p
#undef sz
#undef sy
#undef sx
#undef t
#undef vz
#undef vy
#undef vx
#undef z
#undef y
#undef x
  mcDEBUG_STATE(
mcnlx,
mcnly,
mcnlz,
mcnlvx,
mcnlvy,
mcnlvz,
mcnlt,
mcnlsx,
mcnlsy,
mcnlsz,
mcnlp)

  /* TRACE Component channel_14_analyzer_1_array_crystal_array_6 [668] */
  mccoordschange(mcposrchannel_14_analyzer_1_array_crystal_array_6, mcrotrchannel_14_analyzer_1_array_crystal_array_6,
    &mcnlx,
    &mcnly,
    &mcnlz,
    &mcnlvx,
    &mcnlvy,
    &mcnlvz,
    &mcnlsx,
    &mcnlsy,
    &mcnlsz);
  /* define label inside component channel_14_analyzer_1_array_crystal_array_6 (without coords transformations) */
  mcJumpTrace_channel_14_analyzer_1_array_crystal_array_6:
  SIG_MESSAGE("channel_14_analyzer_1_array_crystal_array_6 (Trace)");
  mcDEBUG_COMP("channel_14_analyzer_1_array_crystal_array_6")
  mcDEBUG_STATE(
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp)
#define x mcnlx
#define y mcnly
#define z mcnlz
#define vx mcnlvx
#define vy mcnlvy
#define vz mcnlvz
#define t mcnlt
#define sx mcnlsx
#define sy mcnlsy
#define sz mcnlsz
#define p mcnlp

#define mcabsorbComp mcabsorbCompchannel_14_analyzer_1_array_crystal_array_6
  STORE_NEUTRON(668,
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp);
  mcScattered=0;
  mcRestore=0;
  mcNCounter[668]++;
  mcPCounter[668] += p;
  mcP2Counter[668] += p*p;
#define mccompcurname  channel_14_analyzer_1_array_crystal_array_6
#define mccompcurtype  Union_box
#define mccompcurindex 668
#define loop_index mccchannel_14_analyzer_1_array_crystal_array_6_loop_index
#define this_box_volume mccchannel_14_analyzer_1_array_crystal_array_6_this_box_volume
#define global_geometry_element mccchannel_14_analyzer_1_array_crystal_array_6_global_geometry_element
#define this_box_storage mccchannel_14_analyzer_1_array_crystal_array_6_this_box_storage
{   /* Declarations of channel_14_analyzer_1_array_crystal_array_6=Union_box() SETTING parameters. */
char* material_string = mccchannel_14_analyzer_1_array_crystal_array_6_material_string;
MCNUM priority = mccchannel_14_analyzer_1_array_crystal_array_6_priority;
MCNUM xwidth = mccchannel_14_analyzer_1_array_crystal_array_6_xwidth;
MCNUM yheight = mccchannel_14_analyzer_1_array_crystal_array_6_yheight;
MCNUM zdepth = mccchannel_14_analyzer_1_array_crystal_array_6_zdepth;
MCNUM xwidth2 = mccchannel_14_analyzer_1_array_crystal_array_6_xwidth2;
MCNUM yheight2 = mccchannel_14_analyzer_1_array_crystal_array_6_yheight2;
MCNUM visualize = mccchannel_14_analyzer_1_array_crystal_array_6_visualize;
int target_index = mccchannel_14_analyzer_1_array_crystal_array_6_target_index;
MCNUM target_x = mccchannel_14_analyzer_1_array_crystal_array_6_target_x;
MCNUM target_y = mccchannel_14_analyzer_1_array_crystal_array_6_target_y;
MCNUM target_z = mccchannel_14_analyzer_1_array_crystal_array_6_target_z;
MCNUM focus_aw = mccchannel_14_analyzer_1_array_crystal_array_6_focus_aw;
MCNUM focus_ah = mccchannel_14_analyzer_1_array_crystal_array_6_focus_ah;
MCNUM focus_xw = mccchannel_14_analyzer_1_array_crystal_array_6_focus_xw;
MCNUM focus_xh = mccchannel_14_analyzer_1_array_crystal_array_6_focus_xh;
MCNUM focus_r = mccchannel_14_analyzer_1_array_crystal_array_6_focus_r;
MCNUM p_interact = mccchannel_14_analyzer_1_array_crystal_array_6_p_interact;
char* mask_string = mccchannel_14_analyzer_1_array_crystal_array_6_mask_string;
char* mask_setting = mccchannel_14_analyzer_1_array_crystal_array_6_mask_setting;
MCNUM number_of_activations = mccchannel_14_analyzer_1_array_crystal_array_6_number_of_activations;
}   /* End of channel_14_analyzer_1_array_crystal_array_6=Union_box() SETTING parameter declarations. */
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex
  /* Label for restoring  neutron */
  mcabsorbCompchannel_14_analyzer_1_array_crystal_array_6:
  if (RESTORE) /* restore if needed */
  { RESTORE_NEUTRON(668,
      mcnlx,
      mcnly,
      mcnlz,
      mcnlvx,
      mcnlvy,
      mcnlvz,
      mcnlt,
      mcnlsx,
      mcnlsy,
      mcnlsz,
      mcnlp); }
#undef mcabsorbComp
#undef p
#undef sz
#undef sy
#undef sx
#undef t
#undef vz
#undef vy
#undef vx
#undef z
#undef y
#undef x
  mcDEBUG_STATE(
mcnlx,
mcnly,
mcnlz,
mcnlvx,
mcnlvy,
mcnlvz,
mcnlt,
mcnlsx,
mcnlsy,
mcnlsz,
mcnlp)

  /* TRACE Component channel_14_analyzer_1_array_crystal_array_7 [669] */
  mccoordschange(mcposrchannel_14_analyzer_1_array_crystal_array_7, mcrotrchannel_14_analyzer_1_array_crystal_array_7,
    &mcnlx,
    &mcnly,
    &mcnlz,
    &mcnlvx,
    &mcnlvy,
    &mcnlvz,
    &mcnlsx,
    &mcnlsy,
    &mcnlsz);
  /* define label inside component channel_14_analyzer_1_array_crystal_array_7 (without coords transformations) */
  mcJumpTrace_channel_14_analyzer_1_array_crystal_array_7:
  SIG_MESSAGE("channel_14_analyzer_1_array_crystal_array_7 (Trace)");
  mcDEBUG_COMP("channel_14_analyzer_1_array_crystal_array_7")
  mcDEBUG_STATE(
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp)
#define x mcnlx
#define y mcnly
#define z mcnlz
#define vx mcnlvx
#define vy mcnlvy
#define vz mcnlvz
#define t mcnlt
#define sx mcnlsx
#define sy mcnlsy
#define sz mcnlsz
#define p mcnlp

#define mcabsorbComp mcabsorbCompchannel_14_analyzer_1_array_crystal_array_7
  STORE_NEUTRON(669,
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp);
  mcScattered=0;
  mcRestore=0;
  mcNCounter[669]++;
  mcPCounter[669] += p;
  mcP2Counter[669] += p*p;
#define mccompcurname  channel_14_analyzer_1_array_crystal_array_7
#define mccompcurtype  Union_box
#define mccompcurindex 669
#define loop_index mccchannel_14_analyzer_1_array_crystal_array_7_loop_index
#define this_box_volume mccchannel_14_analyzer_1_array_crystal_array_7_this_box_volume
#define global_geometry_element mccchannel_14_analyzer_1_array_crystal_array_7_global_geometry_element
#define this_box_storage mccchannel_14_analyzer_1_array_crystal_array_7_this_box_storage
{   /* Declarations of channel_14_analyzer_1_array_crystal_array_7=Union_box() SETTING parameters. */
char* material_string = mccchannel_14_analyzer_1_array_crystal_array_7_material_string;
MCNUM priority = mccchannel_14_analyzer_1_array_crystal_array_7_priority;
MCNUM xwidth = mccchannel_14_analyzer_1_array_crystal_array_7_xwidth;
MCNUM yheight = mccchannel_14_analyzer_1_array_crystal_array_7_yheight;
MCNUM zdepth = mccchannel_14_analyzer_1_array_crystal_array_7_zdepth;
MCNUM xwidth2 = mccchannel_14_analyzer_1_array_crystal_array_7_xwidth2;
MCNUM yheight2 = mccchannel_14_analyzer_1_array_crystal_array_7_yheight2;
MCNUM visualize = mccchannel_14_analyzer_1_array_crystal_array_7_visualize;
int target_index = mccchannel_14_analyzer_1_array_crystal_array_7_target_index;
MCNUM target_x = mccchannel_14_analyzer_1_array_crystal_array_7_target_x;
MCNUM target_y = mccchannel_14_analyzer_1_array_crystal_array_7_target_y;
MCNUM target_z = mccchannel_14_analyzer_1_array_crystal_array_7_target_z;
MCNUM focus_aw = mccchannel_14_analyzer_1_array_crystal_array_7_focus_aw;
MCNUM focus_ah = mccchannel_14_analyzer_1_array_crystal_array_7_focus_ah;
MCNUM focus_xw = mccchannel_14_analyzer_1_array_crystal_array_7_focus_xw;
MCNUM focus_xh = mccchannel_14_analyzer_1_array_crystal_array_7_focus_xh;
MCNUM focus_r = mccchannel_14_analyzer_1_array_crystal_array_7_focus_r;
MCNUM p_interact = mccchannel_14_analyzer_1_array_crystal_array_7_p_interact;
char* mask_string = mccchannel_14_analyzer_1_array_crystal_array_7_mask_string;
char* mask_setting = mccchannel_14_analyzer_1_array_crystal_array_7_mask_setting;
MCNUM number_of_activations = mccchannel_14_analyzer_1_array_crystal_array_7_number_of_activations;
}   /* End of channel_14_analyzer_1_array_crystal_array_7=Union_box() SETTING parameter declarations. */
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex
  /* Label for restoring  neutron */
  mcabsorbCompchannel_14_analyzer_1_array_crystal_array_7:
  if (RESTORE) /* restore if needed */
  { RESTORE_NEUTRON(669,
      mcnlx,
      mcnly,
      mcnlz,
      mcnlvx,
      mcnlvy,
      mcnlvz,
      mcnlt,
      mcnlsx,
      mcnlsy,
      mcnlsz,
      mcnlp); }
#undef mcabsorbComp
#undef p
#undef sz
#undef sy
#undef sx
#undef t
#undef vz
#undef vy
#undef vx
#undef z
#undef y
#undef x
  mcDEBUG_STATE(
mcnlx,
mcnly,
mcnlz,
mcnlvx,
mcnlvy,
mcnlvz,
mcnlt,
mcnlsx,
mcnlsy,
mcnlsz,
mcnlp)

  /* TRACE Component channel_14_analyzer_1_array_crystal_array_8 [670] */
  mccoordschange(mcposrchannel_14_analyzer_1_array_crystal_array_8, mcrotrchannel_14_analyzer_1_array_crystal_array_8,
    &mcnlx,
    &mcnly,
    &mcnlz,
    &mcnlvx,
    &mcnlvy,
    &mcnlvz,
    &mcnlsx,
    &mcnlsy,
    &mcnlsz);
  /* define label inside component channel_14_analyzer_1_array_crystal_array_8 (without coords transformations) */
  mcJumpTrace_channel_14_analyzer_1_array_crystal_array_8:
  SIG_MESSAGE("channel_14_analyzer_1_array_crystal_array_8 (Trace)");
  mcDEBUG_COMP("channel_14_analyzer_1_array_crystal_array_8")
  mcDEBUG_STATE(
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp)
#define x mcnlx
#define y mcnly
#define z mcnlz
#define vx mcnlvx
#define vy mcnlvy
#define vz mcnlvz
#define t mcnlt
#define sx mcnlsx
#define sy mcnlsy
#define sz mcnlsz
#define p mcnlp

#define mcabsorbComp mcabsorbCompchannel_14_analyzer_1_array_crystal_array_8
  STORE_NEUTRON(670,
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp);
  mcScattered=0;
  mcRestore=0;
  mcNCounter[670]++;
  mcPCounter[670] += p;
  mcP2Counter[670] += p*p;
#define mccompcurname  channel_14_analyzer_1_array_crystal_array_8
#define mccompcurtype  Union_box
#define mccompcurindex 670
#define loop_index mccchannel_14_analyzer_1_array_crystal_array_8_loop_index
#define this_box_volume mccchannel_14_analyzer_1_array_crystal_array_8_this_box_volume
#define global_geometry_element mccchannel_14_analyzer_1_array_crystal_array_8_global_geometry_element
#define this_box_storage mccchannel_14_analyzer_1_array_crystal_array_8_this_box_storage
{   /* Declarations of channel_14_analyzer_1_array_crystal_array_8=Union_box() SETTING parameters. */
char* material_string = mccchannel_14_analyzer_1_array_crystal_array_8_material_string;
MCNUM priority = mccchannel_14_analyzer_1_array_crystal_array_8_priority;
MCNUM xwidth = mccchannel_14_analyzer_1_array_crystal_array_8_xwidth;
MCNUM yheight = mccchannel_14_analyzer_1_array_crystal_array_8_yheight;
MCNUM zdepth = mccchannel_14_analyzer_1_array_crystal_array_8_zdepth;
MCNUM xwidth2 = mccchannel_14_analyzer_1_array_crystal_array_8_xwidth2;
MCNUM yheight2 = mccchannel_14_analyzer_1_array_crystal_array_8_yheight2;
MCNUM visualize = mccchannel_14_analyzer_1_array_crystal_array_8_visualize;
int target_index = mccchannel_14_analyzer_1_array_crystal_array_8_target_index;
MCNUM target_x = mccchannel_14_analyzer_1_array_crystal_array_8_target_x;
MCNUM target_y = mccchannel_14_analyzer_1_array_crystal_array_8_target_y;
MCNUM target_z = mccchannel_14_analyzer_1_array_crystal_array_8_target_z;
MCNUM focus_aw = mccchannel_14_analyzer_1_array_crystal_array_8_focus_aw;
MCNUM focus_ah = mccchannel_14_analyzer_1_array_crystal_array_8_focus_ah;
MCNUM focus_xw = mccchannel_14_analyzer_1_array_crystal_array_8_focus_xw;
MCNUM focus_xh = mccchannel_14_analyzer_1_array_crystal_array_8_focus_xh;
MCNUM focus_r = mccchannel_14_analyzer_1_array_crystal_array_8_focus_r;
MCNUM p_interact = mccchannel_14_analyzer_1_array_crystal_array_8_p_interact;
char* mask_string = mccchannel_14_analyzer_1_array_crystal_array_8_mask_string;
char* mask_setting = mccchannel_14_analyzer_1_array_crystal_array_8_mask_setting;
MCNUM number_of_activations = mccchannel_14_analyzer_1_array_crystal_array_8_number_of_activations;
}   /* End of channel_14_analyzer_1_array_crystal_array_8=Union_box() SETTING parameter declarations. */
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex
  /* Label for restoring  neutron */
  mcabsorbCompchannel_14_analyzer_1_array_crystal_array_8:
  if (RESTORE) /* restore if needed */
  { RESTORE_NEUTRON(670,
      mcnlx,
      mcnly,
      mcnlz,
      mcnlvx,
      mcnlvy,
      mcnlvz,
      mcnlt,
      mcnlsx,
      mcnlsy,
      mcnlsz,
      mcnlp); }
#undef mcabsorbComp
#undef p
#undef sz
#undef sy
#undef sx
#undef t
#undef vz
#undef vy
#undef vx
#undef z
#undef y
#undef x
  mcDEBUG_STATE(
mcnlx,
mcnly,
mcnlz,
mcnlvx,
mcnlvy,
mcnlvz,
mcnlt,
mcnlsx,
mcnlsy,
mcnlsz,
mcnlp)

  /* TRACE Component channel_14_analyzer_2_center [671] */
  mccoordschange(mcposrchannel_14_analyzer_2_center, mcrotrchannel_14_analyzer_2_center,
    &mcnlx,
    &mcnly,
    &mcnlz,
    &mcnlvx,
    &mcnlvy,
    &mcnlvz,
    &mcnlsx,
    &mcnlsy,
    &mcnlsz);
  /* define label inside component channel_14_analyzer_2_center (without coords transformations) */
  mcJumpTrace_channel_14_analyzer_2_center:
  SIG_MESSAGE("channel_14_analyzer_2_center (Trace)");
  mcDEBUG_COMP("channel_14_analyzer_2_center")
  mcDEBUG_STATE(
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp)
#define x mcnlx
#define y mcnly
#define z mcnlz
#define vx mcnlvx
#define vy mcnlvy
#define vz mcnlvz
#define t mcnlt
#define sx mcnlsx
#define sy mcnlsy
#define sz mcnlsz
#define p mcnlp

#define mcabsorbComp mcabsorbCompchannel_14_analyzer_2_center
  STORE_NEUTRON(671,
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp);
  mcScattered=0;
  mcRestore=0;
  mcNCounter[671]++;
  mcPCounter[671] += p;
  mcP2Counter[671] += p*p;
#define mccompcurname  channel_14_analyzer_2_center
#define mccompcurtype  Arm
#define mccompcurindex 671
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex
  /* Label for restoring  neutron */
  mcabsorbCompchannel_14_analyzer_2_center:
  if (RESTORE) /* restore if needed */
  { RESTORE_NEUTRON(671,
      mcnlx,
      mcnly,
      mcnlz,
      mcnlvx,
      mcnlvy,
      mcnlvz,
      mcnlt,
      mcnlsx,
      mcnlsy,
      mcnlsz,
      mcnlp); }
#undef mcabsorbComp
#undef p
#undef sz
#undef sy
#undef sx
#undef t
#undef vz
#undef vy
#undef vx
#undef z
#undef y
#undef x
  mcDEBUG_STATE(
mcnlx,
mcnly,
mcnlz,
mcnlvx,
mcnlvy,
mcnlvz,
mcnlt,
mcnlsx,
mcnlsy,
mcnlsz,
mcnlp)

  /* TRACE Component channel_14_analyzer_2_rotated [672] */
  mccoordschange(mcposrchannel_14_analyzer_2_rotated, mcrotrchannel_14_analyzer_2_rotated,
    &mcnlx,
    &mcnly,
    &mcnlz,
    &mcnlvx,
    &mcnlvy,
    &mcnlvz,
    &mcnlsx,
    &mcnlsy,
    &mcnlsz);
  /* define label inside component channel_14_analyzer_2_rotated (without coords transformations) */
  mcJumpTrace_channel_14_analyzer_2_rotated:
  SIG_MESSAGE("channel_14_analyzer_2_rotated (Trace)");
  mcDEBUG_COMP("channel_14_analyzer_2_rotated")
  mcDEBUG_STATE(
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp)
#define x mcnlx
#define y mcnly
#define z mcnlz
#define vx mcnlvx
#define vy mcnlvy
#define vz mcnlvz
#define t mcnlt
#define sx mcnlsx
#define sy mcnlsy
#define sz mcnlsz
#define p mcnlp

#define mcabsorbComp mcabsorbCompchannel_14_analyzer_2_rotated
  STORE_NEUTRON(672,
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp);
  mcScattered=0;
  mcRestore=0;
  mcNCounter[672]++;
  mcPCounter[672] += p;
  mcP2Counter[672] += p*p;
#define mccompcurname  channel_14_analyzer_2_rotated
#define mccompcurtype  Arm
#define mccompcurindex 672
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex
  /* Label for restoring  neutron */
  mcabsorbCompchannel_14_analyzer_2_rotated:
  if (RESTORE) /* restore if needed */
  { RESTORE_NEUTRON(672,
      mcnlx,
      mcnly,
      mcnlz,
      mcnlvx,
      mcnlvy,
      mcnlvz,
      mcnlt,
      mcnlsx,
      mcnlsy,
      mcnlsz,
      mcnlp); }
#undef mcabsorbComp
#undef p
#undef sz
#undef sy
#undef sx
#undef t
#undef vz
#undef vy
#undef vx
#undef z
#undef y
#undef x
  mcDEBUG_STATE(
mcnlx,
mcnly,
mcnlz,
mcnlvx,
mcnlvy,
mcnlvz,
mcnlt,
mcnlsx,
mcnlsy,
mcnlsz,
mcnlp)

  /* TRACE Component channel_14_analyzer_2_array_crystal_array_0 [673] */
  mccoordschange(mcposrchannel_14_analyzer_2_array_crystal_array_0, mcrotrchannel_14_analyzer_2_array_crystal_array_0,
    &mcnlx,
    &mcnly,
    &mcnlz,
    &mcnlvx,
    &mcnlvy,
    &mcnlvz,
    &mcnlsx,
    &mcnlsy,
    &mcnlsz);
  /* define label inside component channel_14_analyzer_2_array_crystal_array_0 (without coords transformations) */
  mcJumpTrace_channel_14_analyzer_2_array_crystal_array_0:
  SIG_MESSAGE("channel_14_analyzer_2_array_crystal_array_0 (Trace)");
  mcDEBUG_COMP("channel_14_analyzer_2_array_crystal_array_0")
  mcDEBUG_STATE(
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp)
#define x mcnlx
#define y mcnly
#define z mcnlz
#define vx mcnlvx
#define vy mcnlvy
#define vz mcnlvz
#define t mcnlt
#define sx mcnlsx
#define sy mcnlsy
#define sz mcnlsz
#define p mcnlp

#define mcabsorbComp mcabsorbCompchannel_14_analyzer_2_array_crystal_array_0
  STORE_NEUTRON(673,
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp);
  mcScattered=0;
  mcRestore=0;
  mcNCounter[673]++;
  mcPCounter[673] += p;
  mcP2Counter[673] += p*p;
#define mccompcurname  channel_14_analyzer_2_array_crystal_array_0
#define mccompcurtype  Union_box
#define mccompcurindex 673
#define loop_index mccchannel_14_analyzer_2_array_crystal_array_0_loop_index
#define this_box_volume mccchannel_14_analyzer_2_array_crystal_array_0_this_box_volume
#define global_geometry_element mccchannel_14_analyzer_2_array_crystal_array_0_global_geometry_element
#define this_box_storage mccchannel_14_analyzer_2_array_crystal_array_0_this_box_storage
{   /* Declarations of channel_14_analyzer_2_array_crystal_array_0=Union_box() SETTING parameters. */
char* material_string = mccchannel_14_analyzer_2_array_crystal_array_0_material_string;
MCNUM priority = mccchannel_14_analyzer_2_array_crystal_array_0_priority;
MCNUM xwidth = mccchannel_14_analyzer_2_array_crystal_array_0_xwidth;
MCNUM yheight = mccchannel_14_analyzer_2_array_crystal_array_0_yheight;
MCNUM zdepth = mccchannel_14_analyzer_2_array_crystal_array_0_zdepth;
MCNUM xwidth2 = mccchannel_14_analyzer_2_array_crystal_array_0_xwidth2;
MCNUM yheight2 = mccchannel_14_analyzer_2_array_crystal_array_0_yheight2;
MCNUM visualize = mccchannel_14_analyzer_2_array_crystal_array_0_visualize;
int target_index = mccchannel_14_analyzer_2_array_crystal_array_0_target_index;
MCNUM target_x = mccchannel_14_analyzer_2_array_crystal_array_0_target_x;
MCNUM target_y = mccchannel_14_analyzer_2_array_crystal_array_0_target_y;
MCNUM target_z = mccchannel_14_analyzer_2_array_crystal_array_0_target_z;
MCNUM focus_aw = mccchannel_14_analyzer_2_array_crystal_array_0_focus_aw;
MCNUM focus_ah = mccchannel_14_analyzer_2_array_crystal_array_0_focus_ah;
MCNUM focus_xw = mccchannel_14_analyzer_2_array_crystal_array_0_focus_xw;
MCNUM focus_xh = mccchannel_14_analyzer_2_array_crystal_array_0_focus_xh;
MCNUM focus_r = mccchannel_14_analyzer_2_array_crystal_array_0_focus_r;
MCNUM p_interact = mccchannel_14_analyzer_2_array_crystal_array_0_p_interact;
char* mask_string = mccchannel_14_analyzer_2_array_crystal_array_0_mask_string;
char* mask_setting = mccchannel_14_analyzer_2_array_crystal_array_0_mask_setting;
MCNUM number_of_activations = mccchannel_14_analyzer_2_array_crystal_array_0_number_of_activations;
}   /* End of channel_14_analyzer_2_array_crystal_array_0=Union_box() SETTING parameter declarations. */
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex
  /* Label for restoring  neutron */
  mcabsorbCompchannel_14_analyzer_2_array_crystal_array_0:
  if (RESTORE) /* restore if needed */
  { RESTORE_NEUTRON(673,
      mcnlx,
      mcnly,
      mcnlz,
      mcnlvx,
      mcnlvy,
      mcnlvz,
      mcnlt,
      mcnlsx,
      mcnlsy,
      mcnlsz,
      mcnlp); }
#undef mcabsorbComp
#undef p
#undef sz
#undef sy
#undef sx
#undef t
#undef vz
#undef vy
#undef vx
#undef z
#undef y
#undef x
  mcDEBUG_STATE(
mcnlx,
mcnly,
mcnlz,
mcnlvx,
mcnlvy,
mcnlvz,
mcnlt,
mcnlsx,
mcnlsy,
mcnlsz,
mcnlp)

  /* TRACE Component channel_14_analyzer_2_array_crystal_array_1 [674] */
  mccoordschange(mcposrchannel_14_analyzer_2_array_crystal_array_1, mcrotrchannel_14_analyzer_2_array_crystal_array_1,
    &mcnlx,
    &mcnly,
    &mcnlz,
    &mcnlvx,
    &mcnlvy,
    &mcnlvz,
    &mcnlsx,
    &mcnlsy,
    &mcnlsz);
  /* define label inside component channel_14_analyzer_2_array_crystal_array_1 (without coords transformations) */
  mcJumpTrace_channel_14_analyzer_2_array_crystal_array_1:
  SIG_MESSAGE("channel_14_analyzer_2_array_crystal_array_1 (Trace)");
  mcDEBUG_COMP("channel_14_analyzer_2_array_crystal_array_1")
  mcDEBUG_STATE(
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp)
#define x mcnlx
#define y mcnly
#define z mcnlz
#define vx mcnlvx
#define vy mcnlvy
#define vz mcnlvz
#define t mcnlt
#define sx mcnlsx
#define sy mcnlsy
#define sz mcnlsz
#define p mcnlp

#define mcabsorbComp mcabsorbCompchannel_14_analyzer_2_array_crystal_array_1
  STORE_NEUTRON(674,
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp);
  mcScattered=0;
  mcRestore=0;
  mcNCounter[674]++;
  mcPCounter[674] += p;
  mcP2Counter[674] += p*p;
#define mccompcurname  channel_14_analyzer_2_array_crystal_array_1
#define mccompcurtype  Union_box
#define mccompcurindex 674
#define loop_index mccchannel_14_analyzer_2_array_crystal_array_1_loop_index
#define this_box_volume mccchannel_14_analyzer_2_array_crystal_array_1_this_box_volume
#define global_geometry_element mccchannel_14_analyzer_2_array_crystal_array_1_global_geometry_element
#define this_box_storage mccchannel_14_analyzer_2_array_crystal_array_1_this_box_storage
{   /* Declarations of channel_14_analyzer_2_array_crystal_array_1=Union_box() SETTING parameters. */
char* material_string = mccchannel_14_analyzer_2_array_crystal_array_1_material_string;
MCNUM priority = mccchannel_14_analyzer_2_array_crystal_array_1_priority;
MCNUM xwidth = mccchannel_14_analyzer_2_array_crystal_array_1_xwidth;
MCNUM yheight = mccchannel_14_analyzer_2_array_crystal_array_1_yheight;
MCNUM zdepth = mccchannel_14_analyzer_2_array_crystal_array_1_zdepth;
MCNUM xwidth2 = mccchannel_14_analyzer_2_array_crystal_array_1_xwidth2;
MCNUM yheight2 = mccchannel_14_analyzer_2_array_crystal_array_1_yheight2;
MCNUM visualize = mccchannel_14_analyzer_2_array_crystal_array_1_visualize;
int target_index = mccchannel_14_analyzer_2_array_crystal_array_1_target_index;
MCNUM target_x = mccchannel_14_analyzer_2_array_crystal_array_1_target_x;
MCNUM target_y = mccchannel_14_analyzer_2_array_crystal_array_1_target_y;
MCNUM target_z = mccchannel_14_analyzer_2_array_crystal_array_1_target_z;
MCNUM focus_aw = mccchannel_14_analyzer_2_array_crystal_array_1_focus_aw;
MCNUM focus_ah = mccchannel_14_analyzer_2_array_crystal_array_1_focus_ah;
MCNUM focus_xw = mccchannel_14_analyzer_2_array_crystal_array_1_focus_xw;
MCNUM focus_xh = mccchannel_14_analyzer_2_array_crystal_array_1_focus_xh;
MCNUM focus_r = mccchannel_14_analyzer_2_array_crystal_array_1_focus_r;
MCNUM p_interact = mccchannel_14_analyzer_2_array_crystal_array_1_p_interact;
char* mask_string = mccchannel_14_analyzer_2_array_crystal_array_1_mask_string;
char* mask_setting = mccchannel_14_analyzer_2_array_crystal_array_1_mask_setting;
MCNUM number_of_activations = mccchannel_14_analyzer_2_array_crystal_array_1_number_of_activations;
}   /* End of channel_14_analyzer_2_array_crystal_array_1=Union_box() SETTING parameter declarations. */
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex
  /* Label for restoring  neutron */
  mcabsorbCompchannel_14_analyzer_2_array_crystal_array_1:
  if (RESTORE) /* restore if needed */
  { RESTORE_NEUTRON(674,
      mcnlx,
      mcnly,
      mcnlz,
      mcnlvx,
      mcnlvy,
      mcnlvz,
      mcnlt,
      mcnlsx,
      mcnlsy,
      mcnlsz,
      mcnlp); }
#undef mcabsorbComp
#undef p
#undef sz
#undef sy
#undef sx
#undef t
#undef vz
#undef vy
#undef vx
#undef z
#undef y
#undef x
  mcDEBUG_STATE(
mcnlx,
mcnly,
mcnlz,
mcnlvx,
mcnlvy,
mcnlvz,
mcnlt,
mcnlsx,
mcnlsy,
mcnlsz,
mcnlp)

  /* TRACE Component channel_14_analyzer_2_array_crystal_array_2 [675] */
  mccoordschange(mcposrchannel_14_analyzer_2_array_crystal_array_2, mcrotrchannel_14_analyzer_2_array_crystal_array_2,
    &mcnlx,
    &mcnly,
    &mcnlz,
    &mcnlvx,
    &mcnlvy,
    &mcnlvz,
    &mcnlsx,
    &mcnlsy,
    &mcnlsz);
  /* define label inside component channel_14_analyzer_2_array_crystal_array_2 (without coords transformations) */
  mcJumpTrace_channel_14_analyzer_2_array_crystal_array_2:
  SIG_MESSAGE("channel_14_analyzer_2_array_crystal_array_2 (Trace)");
  mcDEBUG_COMP("channel_14_analyzer_2_array_crystal_array_2")
  mcDEBUG_STATE(
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp)
#define x mcnlx
#define y mcnly
#define z mcnlz
#define vx mcnlvx
#define vy mcnlvy
#define vz mcnlvz
#define t mcnlt
#define sx mcnlsx
#define sy mcnlsy
#define sz mcnlsz
#define p mcnlp

#define mcabsorbComp mcabsorbCompchannel_14_analyzer_2_array_crystal_array_2
  STORE_NEUTRON(675,
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp);
  mcScattered=0;
  mcRestore=0;
  mcNCounter[675]++;
  mcPCounter[675] += p;
  mcP2Counter[675] += p*p;
#define mccompcurname  channel_14_analyzer_2_array_crystal_array_2
#define mccompcurtype  Union_box
#define mccompcurindex 675
#define loop_index mccchannel_14_analyzer_2_array_crystal_array_2_loop_index
#define this_box_volume mccchannel_14_analyzer_2_array_crystal_array_2_this_box_volume
#define global_geometry_element mccchannel_14_analyzer_2_array_crystal_array_2_global_geometry_element
#define this_box_storage mccchannel_14_analyzer_2_array_crystal_array_2_this_box_storage
{   /* Declarations of channel_14_analyzer_2_array_crystal_array_2=Union_box() SETTING parameters. */
char* material_string = mccchannel_14_analyzer_2_array_crystal_array_2_material_string;
MCNUM priority = mccchannel_14_analyzer_2_array_crystal_array_2_priority;
MCNUM xwidth = mccchannel_14_analyzer_2_array_crystal_array_2_xwidth;
MCNUM yheight = mccchannel_14_analyzer_2_array_crystal_array_2_yheight;
MCNUM zdepth = mccchannel_14_analyzer_2_array_crystal_array_2_zdepth;
MCNUM xwidth2 = mccchannel_14_analyzer_2_array_crystal_array_2_xwidth2;
MCNUM yheight2 = mccchannel_14_analyzer_2_array_crystal_array_2_yheight2;
MCNUM visualize = mccchannel_14_analyzer_2_array_crystal_array_2_visualize;
int target_index = mccchannel_14_analyzer_2_array_crystal_array_2_target_index;
MCNUM target_x = mccchannel_14_analyzer_2_array_crystal_array_2_target_x;
MCNUM target_y = mccchannel_14_analyzer_2_array_crystal_array_2_target_y;
MCNUM target_z = mccchannel_14_analyzer_2_array_crystal_array_2_target_z;
MCNUM focus_aw = mccchannel_14_analyzer_2_array_crystal_array_2_focus_aw;
MCNUM focus_ah = mccchannel_14_analyzer_2_array_crystal_array_2_focus_ah;
MCNUM focus_xw = mccchannel_14_analyzer_2_array_crystal_array_2_focus_xw;
MCNUM focus_xh = mccchannel_14_analyzer_2_array_crystal_array_2_focus_xh;
MCNUM focus_r = mccchannel_14_analyzer_2_array_crystal_array_2_focus_r;
MCNUM p_interact = mccchannel_14_analyzer_2_array_crystal_array_2_p_interact;
char* mask_string = mccchannel_14_analyzer_2_array_crystal_array_2_mask_string;
char* mask_setting = mccchannel_14_analyzer_2_array_crystal_array_2_mask_setting;
MCNUM number_of_activations = mccchannel_14_analyzer_2_array_crystal_array_2_number_of_activations;
}   /* End of channel_14_analyzer_2_array_crystal_array_2=Union_box() SETTING parameter declarations. */
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex
  /* Label for restoring  neutron */
  mcabsorbCompchannel_14_analyzer_2_array_crystal_array_2:
  if (RESTORE) /* restore if needed */
  { RESTORE_NEUTRON(675,
      mcnlx,
      mcnly,
      mcnlz,
      mcnlvx,
      mcnlvy,
      mcnlvz,
      mcnlt,
      mcnlsx,
      mcnlsy,
      mcnlsz,
      mcnlp); }
#undef mcabsorbComp
#undef p
#undef sz
#undef sy
#undef sx
#undef t
#undef vz
#undef vy
#undef vx
#undef z
#undef y
#undef x
  mcDEBUG_STATE(
mcnlx,
mcnly,
mcnlz,
mcnlvx,
mcnlvy,
mcnlvz,
mcnlt,
mcnlsx,
mcnlsy,
mcnlsz,
mcnlp)

  /* TRACE Component channel_14_analyzer_2_array_crystal_array_3 [676] */
  mccoordschange(mcposrchannel_14_analyzer_2_array_crystal_array_3, mcrotrchannel_14_analyzer_2_array_crystal_array_3,
    &mcnlx,
    &mcnly,
    &mcnlz,
    &mcnlvx,
    &mcnlvy,
    &mcnlvz,
    &mcnlsx,
    &mcnlsy,
    &mcnlsz);
  /* define label inside component channel_14_analyzer_2_array_crystal_array_3 (without coords transformations) */
  mcJumpTrace_channel_14_analyzer_2_array_crystal_array_3:
  SIG_MESSAGE("channel_14_analyzer_2_array_crystal_array_3 (Trace)");
  mcDEBUG_COMP("channel_14_analyzer_2_array_crystal_array_3")
  mcDEBUG_STATE(
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp)
#define x mcnlx
#define y mcnly
#define z mcnlz
#define vx mcnlvx
#define vy mcnlvy
#define vz mcnlvz
#define t mcnlt
#define sx mcnlsx
#define sy mcnlsy
#define sz mcnlsz
#define p mcnlp

#define mcabsorbComp mcabsorbCompchannel_14_analyzer_2_array_crystal_array_3
  STORE_NEUTRON(676,
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp);
  mcScattered=0;
  mcRestore=0;
  mcNCounter[676]++;
  mcPCounter[676] += p;
  mcP2Counter[676] += p*p;
#define mccompcurname  channel_14_analyzer_2_array_crystal_array_3
#define mccompcurtype  Union_box
#define mccompcurindex 676
#define loop_index mccchannel_14_analyzer_2_array_crystal_array_3_loop_index
#define this_box_volume mccchannel_14_analyzer_2_array_crystal_array_3_this_box_volume
#define global_geometry_element mccchannel_14_analyzer_2_array_crystal_array_3_global_geometry_element
#define this_box_storage mccchannel_14_analyzer_2_array_crystal_array_3_this_box_storage
{   /* Declarations of channel_14_analyzer_2_array_crystal_array_3=Union_box() SETTING parameters. */
char* material_string = mccchannel_14_analyzer_2_array_crystal_array_3_material_string;
MCNUM priority = mccchannel_14_analyzer_2_array_crystal_array_3_priority;
MCNUM xwidth = mccchannel_14_analyzer_2_array_crystal_array_3_xwidth;
MCNUM yheight = mccchannel_14_analyzer_2_array_crystal_array_3_yheight;
MCNUM zdepth = mccchannel_14_analyzer_2_array_crystal_array_3_zdepth;
MCNUM xwidth2 = mccchannel_14_analyzer_2_array_crystal_array_3_xwidth2;
MCNUM yheight2 = mccchannel_14_analyzer_2_array_crystal_array_3_yheight2;
MCNUM visualize = mccchannel_14_analyzer_2_array_crystal_array_3_visualize;
int target_index = mccchannel_14_analyzer_2_array_crystal_array_3_target_index;
MCNUM target_x = mccchannel_14_analyzer_2_array_crystal_array_3_target_x;
MCNUM target_y = mccchannel_14_analyzer_2_array_crystal_array_3_target_y;
MCNUM target_z = mccchannel_14_analyzer_2_array_crystal_array_3_target_z;
MCNUM focus_aw = mccchannel_14_analyzer_2_array_crystal_array_3_focus_aw;
MCNUM focus_ah = mccchannel_14_analyzer_2_array_crystal_array_3_focus_ah;
MCNUM focus_xw = mccchannel_14_analyzer_2_array_crystal_array_3_focus_xw;
MCNUM focus_xh = mccchannel_14_analyzer_2_array_crystal_array_3_focus_xh;
MCNUM focus_r = mccchannel_14_analyzer_2_array_crystal_array_3_focus_r;
MCNUM p_interact = mccchannel_14_analyzer_2_array_crystal_array_3_p_interact;
char* mask_string = mccchannel_14_analyzer_2_array_crystal_array_3_mask_string;
char* mask_setting = mccchannel_14_analyzer_2_array_crystal_array_3_mask_setting;
MCNUM number_of_activations = mccchannel_14_analyzer_2_array_crystal_array_3_number_of_activations;
}   /* End of channel_14_analyzer_2_array_crystal_array_3=Union_box() SETTING parameter declarations. */
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex
  /* Label for restoring  neutron */
  mcabsorbCompchannel_14_analyzer_2_array_crystal_array_3:
  if (RESTORE) /* restore if needed */
  { RESTORE_NEUTRON(676,
      mcnlx,
      mcnly,
      mcnlz,
      mcnlvx,
      mcnlvy,
      mcnlvz,
      mcnlt,
      mcnlsx,
      mcnlsy,
      mcnlsz,
      mcnlp); }
#undef mcabsorbComp
#undef p
#undef sz
#undef sy
#undef sx
#undef t
#undef vz
#undef vy
#undef vx
#undef z
#undef y
#undef x
  mcDEBUG_STATE(
mcnlx,
mcnly,
mcnlz,
mcnlvx,
mcnlvy,
mcnlvz,
mcnlt,
mcnlsx,
mcnlsy,
mcnlsz,
mcnlp)

  /* TRACE Component channel_14_analyzer_2_array_crystal_array_4 [677] */
  mccoordschange(mcposrchannel_14_analyzer_2_array_crystal_array_4, mcrotrchannel_14_analyzer_2_array_crystal_array_4,
    &mcnlx,
    &mcnly,
    &mcnlz,
    &mcnlvx,
    &mcnlvy,
    &mcnlvz,
    &mcnlsx,
    &mcnlsy,
    &mcnlsz);
  /* define label inside component channel_14_analyzer_2_array_crystal_array_4 (without coords transformations) */
  mcJumpTrace_channel_14_analyzer_2_array_crystal_array_4:
  SIG_MESSAGE("channel_14_analyzer_2_array_crystal_array_4 (Trace)");
  mcDEBUG_COMP("channel_14_analyzer_2_array_crystal_array_4")
  mcDEBUG_STATE(
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp)
#define x mcnlx
#define y mcnly
#define z mcnlz
#define vx mcnlvx
#define vy mcnlvy
#define vz mcnlvz
#define t mcnlt
#define sx mcnlsx
#define sy mcnlsy
#define sz mcnlsz
#define p mcnlp

#define mcabsorbComp mcabsorbCompchannel_14_analyzer_2_array_crystal_array_4
  STORE_NEUTRON(677,
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp);
  mcScattered=0;
  mcRestore=0;
  mcNCounter[677]++;
  mcPCounter[677] += p;
  mcP2Counter[677] += p*p;
#define mccompcurname  channel_14_analyzer_2_array_crystal_array_4
#define mccompcurtype  Union_box
#define mccompcurindex 677
#define loop_index mccchannel_14_analyzer_2_array_crystal_array_4_loop_index
#define this_box_volume mccchannel_14_analyzer_2_array_crystal_array_4_this_box_volume
#define global_geometry_element mccchannel_14_analyzer_2_array_crystal_array_4_global_geometry_element
#define this_box_storage mccchannel_14_analyzer_2_array_crystal_array_4_this_box_storage
{   /* Declarations of channel_14_analyzer_2_array_crystal_array_4=Union_box() SETTING parameters. */
char* material_string = mccchannel_14_analyzer_2_array_crystal_array_4_material_string;
MCNUM priority = mccchannel_14_analyzer_2_array_crystal_array_4_priority;
MCNUM xwidth = mccchannel_14_analyzer_2_array_crystal_array_4_xwidth;
MCNUM yheight = mccchannel_14_analyzer_2_array_crystal_array_4_yheight;
MCNUM zdepth = mccchannel_14_analyzer_2_array_crystal_array_4_zdepth;
MCNUM xwidth2 = mccchannel_14_analyzer_2_array_crystal_array_4_xwidth2;
MCNUM yheight2 = mccchannel_14_analyzer_2_array_crystal_array_4_yheight2;
MCNUM visualize = mccchannel_14_analyzer_2_array_crystal_array_4_visualize;
int target_index = mccchannel_14_analyzer_2_array_crystal_array_4_target_index;
MCNUM target_x = mccchannel_14_analyzer_2_array_crystal_array_4_target_x;
MCNUM target_y = mccchannel_14_analyzer_2_array_crystal_array_4_target_y;
MCNUM target_z = mccchannel_14_analyzer_2_array_crystal_array_4_target_z;
MCNUM focus_aw = mccchannel_14_analyzer_2_array_crystal_array_4_focus_aw;
MCNUM focus_ah = mccchannel_14_analyzer_2_array_crystal_array_4_focus_ah;
MCNUM focus_xw = mccchannel_14_analyzer_2_array_crystal_array_4_focus_xw;
MCNUM focus_xh = mccchannel_14_analyzer_2_array_crystal_array_4_focus_xh;
MCNUM focus_r = mccchannel_14_analyzer_2_array_crystal_array_4_focus_r;
MCNUM p_interact = mccchannel_14_analyzer_2_array_crystal_array_4_p_interact;
char* mask_string = mccchannel_14_analyzer_2_array_crystal_array_4_mask_string;
char* mask_setting = mccchannel_14_analyzer_2_array_crystal_array_4_mask_setting;
MCNUM number_of_activations = mccchannel_14_analyzer_2_array_crystal_array_4_number_of_activations;
}   /* End of channel_14_analyzer_2_array_crystal_array_4=Union_box() SETTING parameter declarations. */
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex
  /* Label for restoring  neutron */
  mcabsorbCompchannel_14_analyzer_2_array_crystal_array_4:
  if (RESTORE) /* restore if needed */
  { RESTORE_NEUTRON(677,
      mcnlx,
      mcnly,
      mcnlz,
      mcnlvx,
      mcnlvy,
      mcnlvz,
      mcnlt,
      mcnlsx,
      mcnlsy,
      mcnlsz,
      mcnlp); }
#undef mcabsorbComp
#undef p
#undef sz
#undef sy
#undef sx
#undef t
#undef vz
#undef vy
#undef vx
#undef z
#undef y
#undef x
  mcDEBUG_STATE(
mcnlx,
mcnly,
mcnlz,
mcnlvx,
mcnlvy,
mcnlvz,
mcnlt,
mcnlsx,
mcnlsy,
mcnlsz,
mcnlp)

  /* TRACE Component channel_14_analyzer_2_array_crystal_array_5 [678] */
  mccoordschange(mcposrchannel_14_analyzer_2_array_crystal_array_5, mcrotrchannel_14_analyzer_2_array_crystal_array_5,
    &mcnlx,
    &mcnly,
    &mcnlz,
    &mcnlvx,
    &mcnlvy,
    &mcnlvz,
    &mcnlsx,
    &mcnlsy,
    &mcnlsz);
  /* define label inside component channel_14_analyzer_2_array_crystal_array_5 (without coords transformations) */
  mcJumpTrace_channel_14_analyzer_2_array_crystal_array_5:
  SIG_MESSAGE("channel_14_analyzer_2_array_crystal_array_5 (Trace)");
  mcDEBUG_COMP("channel_14_analyzer_2_array_crystal_array_5")
  mcDEBUG_STATE(
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp)
#define x mcnlx
#define y mcnly
#define z mcnlz
#define vx mcnlvx
#define vy mcnlvy
#define vz mcnlvz
#define t mcnlt
#define sx mcnlsx
#define sy mcnlsy
#define sz mcnlsz
#define p mcnlp

#define mcabsorbComp mcabsorbCompchannel_14_analyzer_2_array_crystal_array_5
  STORE_NEUTRON(678,
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp);
  mcScattered=0;
  mcRestore=0;
  mcNCounter[678]++;
  mcPCounter[678] += p;
  mcP2Counter[678] += p*p;
#define mccompcurname  channel_14_analyzer_2_array_crystal_array_5
#define mccompcurtype  Union_box
#define mccompcurindex 678
#define loop_index mccchannel_14_analyzer_2_array_crystal_array_5_loop_index
#define this_box_volume mccchannel_14_analyzer_2_array_crystal_array_5_this_box_volume
#define global_geometry_element mccchannel_14_analyzer_2_array_crystal_array_5_global_geometry_element
#define this_box_storage mccchannel_14_analyzer_2_array_crystal_array_5_this_box_storage
{   /* Declarations of channel_14_analyzer_2_array_crystal_array_5=Union_box() SETTING parameters. */
char* material_string = mccchannel_14_analyzer_2_array_crystal_array_5_material_string;
MCNUM priority = mccchannel_14_analyzer_2_array_crystal_array_5_priority;
MCNUM xwidth = mccchannel_14_analyzer_2_array_crystal_array_5_xwidth;
MCNUM yheight = mccchannel_14_analyzer_2_array_crystal_array_5_yheight;
MCNUM zdepth = mccchannel_14_analyzer_2_array_crystal_array_5_zdepth;
MCNUM xwidth2 = mccchannel_14_analyzer_2_array_crystal_array_5_xwidth2;
MCNUM yheight2 = mccchannel_14_analyzer_2_array_crystal_array_5_yheight2;
MCNUM visualize = mccchannel_14_analyzer_2_array_crystal_array_5_visualize;
int target_index = mccchannel_14_analyzer_2_array_crystal_array_5_target_index;
MCNUM target_x = mccchannel_14_analyzer_2_array_crystal_array_5_target_x;
MCNUM target_y = mccchannel_14_analyzer_2_array_crystal_array_5_target_y;
MCNUM target_z = mccchannel_14_analyzer_2_array_crystal_array_5_target_z;
MCNUM focus_aw = mccchannel_14_analyzer_2_array_crystal_array_5_focus_aw;
MCNUM focus_ah = mccchannel_14_analyzer_2_array_crystal_array_5_focus_ah;
MCNUM focus_xw = mccchannel_14_analyzer_2_array_crystal_array_5_focus_xw;
MCNUM focus_xh = mccchannel_14_analyzer_2_array_crystal_array_5_focus_xh;
MCNUM focus_r = mccchannel_14_analyzer_2_array_crystal_array_5_focus_r;
MCNUM p_interact = mccchannel_14_analyzer_2_array_crystal_array_5_p_interact;
char* mask_string = mccchannel_14_analyzer_2_array_crystal_array_5_mask_string;
char* mask_setting = mccchannel_14_analyzer_2_array_crystal_array_5_mask_setting;
MCNUM number_of_activations = mccchannel_14_analyzer_2_array_crystal_array_5_number_of_activations;
}   /* End of channel_14_analyzer_2_array_crystal_array_5=Union_box() SETTING parameter declarations. */
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex
  /* Label for restoring  neutron */
  mcabsorbCompchannel_14_analyzer_2_array_crystal_array_5:
  if (RESTORE) /* restore if needed */
  { RESTORE_NEUTRON(678,
      mcnlx,
      mcnly,
      mcnlz,
      mcnlvx,
      mcnlvy,
      mcnlvz,
      mcnlt,
      mcnlsx,
      mcnlsy,
      mcnlsz,
      mcnlp); }
#undef mcabsorbComp
#undef p
#undef sz
#undef sy
#undef sx
#undef t
#undef vz
#undef vy
#undef vx
#undef z
#undef y
#undef x
  mcDEBUG_STATE(
mcnlx,
mcnly,
mcnlz,
mcnlvx,
mcnlvy,
mcnlvz,
mcnlt,
mcnlsx,
mcnlsy,
mcnlsz,
mcnlp)

  /* TRACE Component channel_14_analyzer_2_array_crystal_array_6 [679] */
  mccoordschange(mcposrchannel_14_analyzer_2_array_crystal_array_6, mcrotrchannel_14_analyzer_2_array_crystal_array_6,
    &mcnlx,
    &mcnly,
    &mcnlz,
    &mcnlvx,
    &mcnlvy,
    &mcnlvz,
    &mcnlsx,
    &mcnlsy,
    &mcnlsz);
  /* define label inside component channel_14_analyzer_2_array_crystal_array_6 (without coords transformations) */
  mcJumpTrace_channel_14_analyzer_2_array_crystal_array_6:
  SIG_MESSAGE("channel_14_analyzer_2_array_crystal_array_6 (Trace)");
  mcDEBUG_COMP("channel_14_analyzer_2_array_crystal_array_6")
  mcDEBUG_STATE(
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp)
#define x mcnlx
#define y mcnly
#define z mcnlz
#define vx mcnlvx
#define vy mcnlvy
#define vz mcnlvz
#define t mcnlt
#define sx mcnlsx
#define sy mcnlsy
#define sz mcnlsz
#define p mcnlp

#define mcabsorbComp mcabsorbCompchannel_14_analyzer_2_array_crystal_array_6
  STORE_NEUTRON(679,
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp);
  mcScattered=0;
  mcRestore=0;
  mcNCounter[679]++;
  mcPCounter[679] += p;
  mcP2Counter[679] += p*p;
#define mccompcurname  channel_14_analyzer_2_array_crystal_array_6
#define mccompcurtype  Union_box
#define mccompcurindex 679
#define loop_index mccchannel_14_analyzer_2_array_crystal_array_6_loop_index
#define this_box_volume mccchannel_14_analyzer_2_array_crystal_array_6_this_box_volume
#define global_geometry_element mccchannel_14_analyzer_2_array_crystal_array_6_global_geometry_element
#define this_box_storage mccchannel_14_analyzer_2_array_crystal_array_6_this_box_storage
{   /* Declarations of channel_14_analyzer_2_array_crystal_array_6=Union_box() SETTING parameters. */
char* material_string = mccchannel_14_analyzer_2_array_crystal_array_6_material_string;
MCNUM priority = mccchannel_14_analyzer_2_array_crystal_array_6_priority;
MCNUM xwidth = mccchannel_14_analyzer_2_array_crystal_array_6_xwidth;
MCNUM yheight = mccchannel_14_analyzer_2_array_crystal_array_6_yheight;
MCNUM zdepth = mccchannel_14_analyzer_2_array_crystal_array_6_zdepth;
MCNUM xwidth2 = mccchannel_14_analyzer_2_array_crystal_array_6_xwidth2;
MCNUM yheight2 = mccchannel_14_analyzer_2_array_crystal_array_6_yheight2;
MCNUM visualize = mccchannel_14_analyzer_2_array_crystal_array_6_visualize;
int target_index = mccchannel_14_analyzer_2_array_crystal_array_6_target_index;
MCNUM target_x = mccchannel_14_analyzer_2_array_crystal_array_6_target_x;
MCNUM target_y = mccchannel_14_analyzer_2_array_crystal_array_6_target_y;
MCNUM target_z = mccchannel_14_analyzer_2_array_crystal_array_6_target_z;
MCNUM focus_aw = mccchannel_14_analyzer_2_array_crystal_array_6_focus_aw;
MCNUM focus_ah = mccchannel_14_analyzer_2_array_crystal_array_6_focus_ah;
MCNUM focus_xw = mccchannel_14_analyzer_2_array_crystal_array_6_focus_xw;
MCNUM focus_xh = mccchannel_14_analyzer_2_array_crystal_array_6_focus_xh;
MCNUM focus_r = mccchannel_14_analyzer_2_array_crystal_array_6_focus_r;
MCNUM p_interact = mccchannel_14_analyzer_2_array_crystal_array_6_p_interact;
char* mask_string = mccchannel_14_analyzer_2_array_crystal_array_6_mask_string;
char* mask_setting = mccchannel_14_analyzer_2_array_crystal_array_6_mask_setting;
MCNUM number_of_activations = mccchannel_14_analyzer_2_array_crystal_array_6_number_of_activations;
}   /* End of channel_14_analyzer_2_array_crystal_array_6=Union_box() SETTING parameter declarations. */
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex
  /* Label for restoring  neutron */
  mcabsorbCompchannel_14_analyzer_2_array_crystal_array_6:
  if (RESTORE) /* restore if needed */
  { RESTORE_NEUTRON(679,
      mcnlx,
      mcnly,
      mcnlz,
      mcnlvx,
      mcnlvy,
      mcnlvz,
      mcnlt,
      mcnlsx,
      mcnlsy,
      mcnlsz,
      mcnlp); }
#undef mcabsorbComp
#undef p
#undef sz
#undef sy
#undef sx
#undef t
#undef vz
#undef vy
#undef vx
#undef z
#undef y
#undef x
  mcDEBUG_STATE(
mcnlx,
mcnly,
mcnlz,
mcnlvx,
mcnlvy,
mcnlvz,
mcnlt,
mcnlsx,
mcnlsy,
mcnlsz,
mcnlp)

  /* TRACE Component channel_14_analyzer_2_array_crystal_array_7 [680] */
  mccoordschange(mcposrchannel_14_analyzer_2_array_crystal_array_7, mcrotrchannel_14_analyzer_2_array_crystal_array_7,
    &mcnlx,
    &mcnly,
    &mcnlz,
    &mcnlvx,
    &mcnlvy,
    &mcnlvz,
    &mcnlsx,
    &mcnlsy,
    &mcnlsz);
  /* define label inside component channel_14_analyzer_2_array_crystal_array_7 (without coords transformations) */
  mcJumpTrace_channel_14_analyzer_2_array_crystal_array_7:
  SIG_MESSAGE("channel_14_analyzer_2_array_crystal_array_7 (Trace)");
  mcDEBUG_COMP("channel_14_analyzer_2_array_crystal_array_7")
  mcDEBUG_STATE(
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp)
#define x mcnlx
#define y mcnly
#define z mcnlz
#define vx mcnlvx
#define vy mcnlvy
#define vz mcnlvz
#define t mcnlt
#define sx mcnlsx
#define sy mcnlsy
#define sz mcnlsz
#define p mcnlp

#define mcabsorbComp mcabsorbCompchannel_14_analyzer_2_array_crystal_array_7
  STORE_NEUTRON(680,
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp);
  mcScattered=0;
  mcRestore=0;
  mcNCounter[680]++;
  mcPCounter[680] += p;
  mcP2Counter[680] += p*p;
#define mccompcurname  channel_14_analyzer_2_array_crystal_array_7
#define mccompcurtype  Union_box
#define mccompcurindex 680
#define loop_index mccchannel_14_analyzer_2_array_crystal_array_7_loop_index
#define this_box_volume mccchannel_14_analyzer_2_array_crystal_array_7_this_box_volume
#define global_geometry_element mccchannel_14_analyzer_2_array_crystal_array_7_global_geometry_element
#define this_box_storage mccchannel_14_analyzer_2_array_crystal_array_7_this_box_storage
{   /* Declarations of channel_14_analyzer_2_array_crystal_array_7=Union_box() SETTING parameters. */
char* material_string = mccchannel_14_analyzer_2_array_crystal_array_7_material_string;
MCNUM priority = mccchannel_14_analyzer_2_array_crystal_array_7_priority;
MCNUM xwidth = mccchannel_14_analyzer_2_array_crystal_array_7_xwidth;
MCNUM yheight = mccchannel_14_analyzer_2_array_crystal_array_7_yheight;
MCNUM zdepth = mccchannel_14_analyzer_2_array_crystal_array_7_zdepth;
MCNUM xwidth2 = mccchannel_14_analyzer_2_array_crystal_array_7_xwidth2;
MCNUM yheight2 = mccchannel_14_analyzer_2_array_crystal_array_7_yheight2;
MCNUM visualize = mccchannel_14_analyzer_2_array_crystal_array_7_visualize;
int target_index = mccchannel_14_analyzer_2_array_crystal_array_7_target_index;
MCNUM target_x = mccchannel_14_analyzer_2_array_crystal_array_7_target_x;
MCNUM target_y = mccchannel_14_analyzer_2_array_crystal_array_7_target_y;
MCNUM target_z = mccchannel_14_analyzer_2_array_crystal_array_7_target_z;
MCNUM focus_aw = mccchannel_14_analyzer_2_array_crystal_array_7_focus_aw;
MCNUM focus_ah = mccchannel_14_analyzer_2_array_crystal_array_7_focus_ah;
MCNUM focus_xw = mccchannel_14_analyzer_2_array_crystal_array_7_focus_xw;
MCNUM focus_xh = mccchannel_14_analyzer_2_array_crystal_array_7_focus_xh;
MCNUM focus_r = mccchannel_14_analyzer_2_array_crystal_array_7_focus_r;
MCNUM p_interact = mccchannel_14_analyzer_2_array_crystal_array_7_p_interact;
char* mask_string = mccchannel_14_analyzer_2_array_crystal_array_7_mask_string;
char* mask_setting = mccchannel_14_analyzer_2_array_crystal_array_7_mask_setting;
MCNUM number_of_activations = mccchannel_14_analyzer_2_array_crystal_array_7_number_of_activations;
}   /* End of channel_14_analyzer_2_array_crystal_array_7=Union_box() SETTING parameter declarations. */
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex
  /* Label for restoring  neutron */
  mcabsorbCompchannel_14_analyzer_2_array_crystal_array_7:
  if (RESTORE) /* restore if needed */
  { RESTORE_NEUTRON(680,
      mcnlx,
      mcnly,
      mcnlz,
      mcnlvx,
      mcnlvy,
      mcnlvz,
      mcnlt,
      mcnlsx,
      mcnlsy,
      mcnlsz,
      mcnlp); }
#undef mcabsorbComp
#undef p
#undef sz
#undef sy
#undef sx
#undef t
#undef vz
#undef vy
#undef vx
#undef z
#undef y
#undef x
  mcDEBUG_STATE(
mcnlx,
mcnly,
mcnlz,
mcnlvx,
mcnlvy,
mcnlvz,
mcnlt,
mcnlsx,
mcnlsy,
mcnlsz,
mcnlp)

  /* TRACE Component channel_14_analyzer_2_array_crystal_array_8 [681] */
  mccoordschange(mcposrchannel_14_analyzer_2_array_crystal_array_8, mcrotrchannel_14_analyzer_2_array_crystal_array_8,
    &mcnlx,
    &mcnly,
    &mcnlz,
    &mcnlvx,
    &mcnlvy,
    &mcnlvz,
    &mcnlsx,
    &mcnlsy,
    &mcnlsz);
  /* define label inside component channel_14_analyzer_2_array_crystal_array_8 (without coords transformations) */
  mcJumpTrace_channel_14_analyzer_2_array_crystal_array_8:
  SIG_MESSAGE("channel_14_analyzer_2_array_crystal_array_8 (Trace)");
  mcDEBUG_COMP("channel_14_analyzer_2_array_crystal_array_8")
  mcDEBUG_STATE(
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp)
#define x mcnlx
#define y mcnly
#define z mcnlz
#define vx mcnlvx
#define vy mcnlvy
#define vz mcnlvz
#define t mcnlt
#define sx mcnlsx
#define sy mcnlsy
#define sz mcnlsz
#define p mcnlp

#define mcabsorbComp mcabsorbCompchannel_14_analyzer_2_array_crystal_array_8
  STORE_NEUTRON(681,
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp);
  mcScattered=0;
  mcRestore=0;
  mcNCounter[681]++;
  mcPCounter[681] += p;
  mcP2Counter[681] += p*p;
#define mccompcurname  channel_14_analyzer_2_array_crystal_array_8
#define mccompcurtype  Union_box
#define mccompcurindex 681
#define loop_index mccchannel_14_analyzer_2_array_crystal_array_8_loop_index
#define this_box_volume mccchannel_14_analyzer_2_array_crystal_array_8_this_box_volume
#define global_geometry_element mccchannel_14_analyzer_2_array_crystal_array_8_global_geometry_element
#define this_box_storage mccchannel_14_analyzer_2_array_crystal_array_8_this_box_storage
{   /* Declarations of channel_14_analyzer_2_array_crystal_array_8=Union_box() SETTING parameters. */
char* material_string = mccchannel_14_analyzer_2_array_crystal_array_8_material_string;
MCNUM priority = mccchannel_14_analyzer_2_array_crystal_array_8_priority;
MCNUM xwidth = mccchannel_14_analyzer_2_array_crystal_array_8_xwidth;
MCNUM yheight = mccchannel_14_analyzer_2_array_crystal_array_8_yheight;
MCNUM zdepth = mccchannel_14_analyzer_2_array_crystal_array_8_zdepth;
MCNUM xwidth2 = mccchannel_14_analyzer_2_array_crystal_array_8_xwidth2;
MCNUM yheight2 = mccchannel_14_analyzer_2_array_crystal_array_8_yheight2;
MCNUM visualize = mccchannel_14_analyzer_2_array_crystal_array_8_visualize;
int target_index = mccchannel_14_analyzer_2_array_crystal_array_8_target_index;
MCNUM target_x = mccchannel_14_analyzer_2_array_crystal_array_8_target_x;
MCNUM target_y = mccchannel_14_analyzer_2_array_crystal_array_8_target_y;
MCNUM target_z = mccchannel_14_analyzer_2_array_crystal_array_8_target_z;
MCNUM focus_aw = mccchannel_14_analyzer_2_array_crystal_array_8_focus_aw;
MCNUM focus_ah = mccchannel_14_analyzer_2_array_crystal_array_8_focus_ah;
MCNUM focus_xw = mccchannel_14_analyzer_2_array_crystal_array_8_focus_xw;
MCNUM focus_xh = mccchannel_14_analyzer_2_array_crystal_array_8_focus_xh;
MCNUM focus_r = mccchannel_14_analyzer_2_array_crystal_array_8_focus_r;
MCNUM p_interact = mccchannel_14_analyzer_2_array_crystal_array_8_p_interact;
char* mask_string = mccchannel_14_analyzer_2_array_crystal_array_8_mask_string;
char* mask_setting = mccchannel_14_analyzer_2_array_crystal_array_8_mask_setting;
MCNUM number_of_activations = mccchannel_14_analyzer_2_array_crystal_array_8_number_of_activations;
}   /* End of channel_14_analyzer_2_array_crystal_array_8=Union_box() SETTING parameter declarations. */
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex
  /* Label for restoring  neutron */
  mcabsorbCompchannel_14_analyzer_2_array_crystal_array_8:
  if (RESTORE) /* restore if needed */
  { RESTORE_NEUTRON(681,
      mcnlx,
      mcnly,
      mcnlz,
      mcnlvx,
      mcnlvy,
      mcnlvz,
      mcnlt,
      mcnlsx,
      mcnlsy,
      mcnlsz,
      mcnlp); }
#undef mcabsorbComp
#undef p
#undef sz
#undef sy
#undef sx
#undef t
#undef vz
#undef vy
#undef vx
#undef z
#undef y
#undef x
  mcDEBUG_STATE(
mcnlx,
mcnly,
mcnlz,
mcnlvx,
mcnlvy,
mcnlvz,
mcnlt,
mcnlsx,
mcnlsy,
mcnlsz,
mcnlp)

  /* TRACE Component channel_14_cave2_cyl1 [682] */
  mccoordschange(mcposrchannel_14_cave2_cyl1, mcrotrchannel_14_cave2_cyl1,
    &mcnlx,
    &mcnly,
    &mcnlz,
    &mcnlvx,
    &mcnlvy,
    &mcnlvz,
    &mcnlsx,
    &mcnlsy,
    &mcnlsz);
  /* define label inside component channel_14_cave2_cyl1 (without coords transformations) */
  mcJumpTrace_channel_14_cave2_cyl1:
  SIG_MESSAGE("channel_14_cave2_cyl1 (Trace)");
  mcDEBUG_COMP("channel_14_cave2_cyl1")
  mcDEBUG_STATE(
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp)
#define x mcnlx
#define y mcnly
#define z mcnlz
#define vx mcnlvx
#define vy mcnlvy
#define vz mcnlvz
#define t mcnlt
#define sx mcnlsx
#define sy mcnlsy
#define sz mcnlsz
#define p mcnlp

#define mcabsorbComp mcabsorbCompchannel_14_cave2_cyl1
  STORE_NEUTRON(682,
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp);
  mcScattered=0;
  mcRestore=0;
  mcNCounter[682]++;
  mcPCounter[682] += p;
  mcP2Counter[682] += p*p;
#define mccompcurname  channel_14_cave2_cyl1
#define mccompcurtype  Union_cylinder
#define mccompcurindex 682
#define loop_index mccchannel_14_cave2_cyl1_loop_index
#define this_cylinder_volume mccchannel_14_cave2_cyl1_this_cylinder_volume
#define global_geometry_element mccchannel_14_cave2_cyl1_global_geometry_element
#define this_cylinder_storage mccchannel_14_cave2_cyl1_this_cylinder_storage
{   /* Declarations of channel_14_cave2_cyl1=Union_cylinder() SETTING parameters. */
char* material_string = mccchannel_14_cave2_cyl1_material_string;
MCNUM priority = mccchannel_14_cave2_cyl1_priority;
MCNUM radius = mccchannel_14_cave2_cyl1_radius;
MCNUM yheight = mccchannel_14_cave2_cyl1_yheight;
MCNUM visualize = mccchannel_14_cave2_cyl1_visualize;
int target_index = mccchannel_14_cave2_cyl1_target_index;
MCNUM target_x = mccchannel_14_cave2_cyl1_target_x;
MCNUM target_y = mccchannel_14_cave2_cyl1_target_y;
MCNUM target_z = mccchannel_14_cave2_cyl1_target_z;
MCNUM focus_aw = mccchannel_14_cave2_cyl1_focus_aw;
MCNUM focus_ah = mccchannel_14_cave2_cyl1_focus_ah;
MCNUM focus_xw = mccchannel_14_cave2_cyl1_focus_xw;
MCNUM focus_xh = mccchannel_14_cave2_cyl1_focus_xh;
MCNUM focus_r = mccchannel_14_cave2_cyl1_focus_r;
MCNUM p_interact = mccchannel_14_cave2_cyl1_p_interact;
char* mask_string = mccchannel_14_cave2_cyl1_mask_string;
char* mask_setting = mccchannel_14_cave2_cyl1_mask_setting;
MCNUM number_of_activations = mccchannel_14_cave2_cyl1_number_of_activations;
#line 345 "Union_cylinder.comp"
{
dummy = 1;
}
#line 435192 "MACS_sample_kidney_box.c"
}   /* End of channel_14_cave2_cyl1=Union_cylinder() SETTING parameter declarations. */
#undef this_cylinder_storage
#undef global_geometry_element
#undef this_cylinder_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex
  /* Label for restoring  neutron */
  mcabsorbCompchannel_14_cave2_cyl1:
  if (RESTORE) /* restore if needed */
  { RESTORE_NEUTRON(682,
      mcnlx,
      mcnly,
      mcnlz,
      mcnlvx,
      mcnlvy,
      mcnlvz,
      mcnlt,
      mcnlsx,
      mcnlsy,
      mcnlsz,
      mcnlp); }
#undef mcabsorbComp
#undef p
#undef sz
#undef sy
#undef sx
#undef t
#undef vz
#undef vy
#undef vx
#undef z
#undef y
#undef x
  mcDEBUG_STATE(
mcnlx,
mcnly,
mcnlz,
mcnlvx,
mcnlvy,
mcnlvz,
mcnlt,
mcnlsx,
mcnlsy,
mcnlsz,
mcnlp)

  /* TRACE Component channel_14_cave2_box1 [683] */
  mccoordschange(mcposrchannel_14_cave2_box1, mcrotrchannel_14_cave2_box1,
    &mcnlx,
    &mcnly,
    &mcnlz,
    &mcnlvx,
    &mcnlvy,
    &mcnlvz,
    &mcnlsx,
    &mcnlsy,
    &mcnlsz);
  /* define label inside component channel_14_cave2_box1 (without coords transformations) */
  mcJumpTrace_channel_14_cave2_box1:
  SIG_MESSAGE("channel_14_cave2_box1 (Trace)");
  mcDEBUG_COMP("channel_14_cave2_box1")
  mcDEBUG_STATE(
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp)
#define x mcnlx
#define y mcnly
#define z mcnlz
#define vx mcnlvx
#define vy mcnlvy
#define vz mcnlvz
#define t mcnlt
#define sx mcnlsx
#define sy mcnlsy
#define sz mcnlsz
#define p mcnlp

#define mcabsorbComp mcabsorbCompchannel_14_cave2_box1
  STORE_NEUTRON(683,
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp);
  mcScattered=0;
  mcRestore=0;
  mcNCounter[683]++;
  mcPCounter[683] += p;
  mcP2Counter[683] += p*p;
#define mccompcurname  channel_14_cave2_box1
#define mccompcurtype  Union_box
#define mccompcurindex 683
#define loop_index mccchannel_14_cave2_box1_loop_index
#define this_box_volume mccchannel_14_cave2_box1_this_box_volume
#define global_geometry_element mccchannel_14_cave2_box1_global_geometry_element
#define this_box_storage mccchannel_14_cave2_box1_this_box_storage
{   /* Declarations of channel_14_cave2_box1=Union_box() SETTING parameters. */
char* material_string = mccchannel_14_cave2_box1_material_string;
MCNUM priority = mccchannel_14_cave2_box1_priority;
MCNUM xwidth = mccchannel_14_cave2_box1_xwidth;
MCNUM yheight = mccchannel_14_cave2_box1_yheight;
MCNUM zdepth = mccchannel_14_cave2_box1_zdepth;
MCNUM xwidth2 = mccchannel_14_cave2_box1_xwidth2;
MCNUM yheight2 = mccchannel_14_cave2_box1_yheight2;
MCNUM visualize = mccchannel_14_cave2_box1_visualize;
int target_index = mccchannel_14_cave2_box1_target_index;
MCNUM target_x = mccchannel_14_cave2_box1_target_x;
MCNUM target_y = mccchannel_14_cave2_box1_target_y;
MCNUM target_z = mccchannel_14_cave2_box1_target_z;
MCNUM focus_aw = mccchannel_14_cave2_box1_focus_aw;
MCNUM focus_ah = mccchannel_14_cave2_box1_focus_ah;
MCNUM focus_xw = mccchannel_14_cave2_box1_focus_xw;
MCNUM focus_xh = mccchannel_14_cave2_box1_focus_xh;
MCNUM focus_r = mccchannel_14_cave2_box1_focus_r;
MCNUM p_interact = mccchannel_14_cave2_box1_p_interact;
char* mask_string = mccchannel_14_cave2_box1_mask_string;
char* mask_setting = mccchannel_14_cave2_box1_mask_setting;
MCNUM number_of_activations = mccchannel_14_cave2_box1_number_of_activations;
}   /* End of channel_14_cave2_box1=Union_box() SETTING parameter declarations. */
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex
  /* Label for restoring  neutron */
  mcabsorbCompchannel_14_cave2_box1:
  if (RESTORE) /* restore if needed */
  { RESTORE_NEUTRON(683,
      mcnlx,
      mcnly,
      mcnlz,
      mcnlvx,
      mcnlvy,
      mcnlvz,
      mcnlt,
      mcnlsx,
      mcnlsy,
      mcnlsz,
      mcnlp); }
#undef mcabsorbComp
#undef p
#undef sz
#undef sy
#undef sx
#undef t
#undef vz
#undef vy
#undef vx
#undef z
#undef y
#undef x
  mcDEBUG_STATE(
mcnlx,
mcnly,
mcnlz,
mcnlvx,
mcnlvy,
mcnlvz,
mcnlt,
mcnlsx,
mcnlsy,
mcnlsz,
mcnlp)

  /* TRACE Component channel_14_cave2_box2 [684] */
  mccoordschange(mcposrchannel_14_cave2_box2, mcrotrchannel_14_cave2_box2,
    &mcnlx,
    &mcnly,
    &mcnlz,
    &mcnlvx,
    &mcnlvy,
    &mcnlvz,
    &mcnlsx,
    &mcnlsy,
    &mcnlsz);
  /* define label inside component channel_14_cave2_box2 (without coords transformations) */
  mcJumpTrace_channel_14_cave2_box2:
  SIG_MESSAGE("channel_14_cave2_box2 (Trace)");
  mcDEBUG_COMP("channel_14_cave2_box2")
  mcDEBUG_STATE(
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp)
#define x mcnlx
#define y mcnly
#define z mcnlz
#define vx mcnlvx
#define vy mcnlvy
#define vz mcnlvz
#define t mcnlt
#define sx mcnlsx
#define sy mcnlsy
#define sz mcnlsz
#define p mcnlp

#define mcabsorbComp mcabsorbCompchannel_14_cave2_box2
  STORE_NEUTRON(684,
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp);
  mcScattered=0;
  mcRestore=0;
  mcNCounter[684]++;
  mcPCounter[684] += p;
  mcP2Counter[684] += p*p;
#define mccompcurname  channel_14_cave2_box2
#define mccompcurtype  Union_box
#define mccompcurindex 684
#define loop_index mccchannel_14_cave2_box2_loop_index
#define this_box_volume mccchannel_14_cave2_box2_this_box_volume
#define global_geometry_element mccchannel_14_cave2_box2_global_geometry_element
#define this_box_storage mccchannel_14_cave2_box2_this_box_storage
{   /* Declarations of channel_14_cave2_box2=Union_box() SETTING parameters. */
char* material_string = mccchannel_14_cave2_box2_material_string;
MCNUM priority = mccchannel_14_cave2_box2_priority;
MCNUM xwidth = mccchannel_14_cave2_box2_xwidth;
MCNUM yheight = mccchannel_14_cave2_box2_yheight;
MCNUM zdepth = mccchannel_14_cave2_box2_zdepth;
MCNUM xwidth2 = mccchannel_14_cave2_box2_xwidth2;
MCNUM yheight2 = mccchannel_14_cave2_box2_yheight2;
MCNUM visualize = mccchannel_14_cave2_box2_visualize;
int target_index = mccchannel_14_cave2_box2_target_index;
MCNUM target_x = mccchannel_14_cave2_box2_target_x;
MCNUM target_y = mccchannel_14_cave2_box2_target_y;
MCNUM target_z = mccchannel_14_cave2_box2_target_z;
MCNUM focus_aw = mccchannel_14_cave2_box2_focus_aw;
MCNUM focus_ah = mccchannel_14_cave2_box2_focus_ah;
MCNUM focus_xw = mccchannel_14_cave2_box2_focus_xw;
MCNUM focus_xh = mccchannel_14_cave2_box2_focus_xh;
MCNUM focus_r = mccchannel_14_cave2_box2_focus_r;
MCNUM p_interact = mccchannel_14_cave2_box2_p_interact;
char* mask_string = mccchannel_14_cave2_box2_mask_string;
char* mask_setting = mccchannel_14_cave2_box2_mask_setting;
MCNUM number_of_activations = mccchannel_14_cave2_box2_number_of_activations;
}   /* End of channel_14_cave2_box2=Union_box() SETTING parameter declarations. */
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex
  /* Label for restoring  neutron */
  mcabsorbCompchannel_14_cave2_box2:
  if (RESTORE) /* restore if needed */
  { RESTORE_NEUTRON(684,
      mcnlx,
      mcnly,
      mcnlz,
      mcnlvx,
      mcnlvy,
      mcnlvz,
      mcnlt,
      mcnlsx,
      mcnlsy,
      mcnlsz,
      mcnlp); }
#undef mcabsorbComp
#undef p
#undef sz
#undef sy
#undef sx
#undef t
#undef vz
#undef vy
#undef vx
#undef z
#undef y
#undef x
  mcDEBUG_STATE(
mcnlx,
mcnly,
mcnlz,
mcnlvx,
mcnlvy,
mcnlvz,
mcnlt,
mcnlsx,
mcnlsy,
mcnlsz,
mcnlp)

  /* TRACE Component channel_14_cave2_box3 [685] */
  mccoordschange(mcposrchannel_14_cave2_box3, mcrotrchannel_14_cave2_box3,
    &mcnlx,
    &mcnly,
    &mcnlz,
    &mcnlvx,
    &mcnlvy,
    &mcnlvz,
    &mcnlsx,
    &mcnlsy,
    &mcnlsz);
  /* define label inside component channel_14_cave2_box3 (without coords transformations) */
  mcJumpTrace_channel_14_cave2_box3:
  SIG_MESSAGE("channel_14_cave2_box3 (Trace)");
  mcDEBUG_COMP("channel_14_cave2_box3")
  mcDEBUG_STATE(
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp)
#define x mcnlx
#define y mcnly
#define z mcnlz
#define vx mcnlvx
#define vy mcnlvy
#define vz mcnlvz
#define t mcnlt
#define sx mcnlsx
#define sy mcnlsy
#define sz mcnlsz
#define p mcnlp

#define mcabsorbComp mcabsorbCompchannel_14_cave2_box3
  STORE_NEUTRON(685,
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp);
  mcScattered=0;
  mcRestore=0;
  mcNCounter[685]++;
  mcPCounter[685] += p;
  mcP2Counter[685] += p*p;
#define mccompcurname  channel_14_cave2_box3
#define mccompcurtype  Union_box
#define mccompcurindex 685
#define loop_index mccchannel_14_cave2_box3_loop_index
#define this_box_volume mccchannel_14_cave2_box3_this_box_volume
#define global_geometry_element mccchannel_14_cave2_box3_global_geometry_element
#define this_box_storage mccchannel_14_cave2_box3_this_box_storage
{   /* Declarations of channel_14_cave2_box3=Union_box() SETTING parameters. */
char* material_string = mccchannel_14_cave2_box3_material_string;
MCNUM priority = mccchannel_14_cave2_box3_priority;
MCNUM xwidth = mccchannel_14_cave2_box3_xwidth;
MCNUM yheight = mccchannel_14_cave2_box3_yheight;
MCNUM zdepth = mccchannel_14_cave2_box3_zdepth;
MCNUM xwidth2 = mccchannel_14_cave2_box3_xwidth2;
MCNUM yheight2 = mccchannel_14_cave2_box3_yheight2;
MCNUM visualize = mccchannel_14_cave2_box3_visualize;
int target_index = mccchannel_14_cave2_box3_target_index;
MCNUM target_x = mccchannel_14_cave2_box3_target_x;
MCNUM target_y = mccchannel_14_cave2_box3_target_y;
MCNUM target_z = mccchannel_14_cave2_box3_target_z;
MCNUM focus_aw = mccchannel_14_cave2_box3_focus_aw;
MCNUM focus_ah = mccchannel_14_cave2_box3_focus_ah;
MCNUM focus_xw = mccchannel_14_cave2_box3_focus_xw;
MCNUM focus_xh = mccchannel_14_cave2_box3_focus_xh;
MCNUM focus_r = mccchannel_14_cave2_box3_focus_r;
MCNUM p_interact = mccchannel_14_cave2_box3_p_interact;
char* mask_string = mccchannel_14_cave2_box3_mask_string;
char* mask_setting = mccchannel_14_cave2_box3_mask_setting;
MCNUM number_of_activations = mccchannel_14_cave2_box3_number_of_activations;
}   /* End of channel_14_cave2_box3=Union_box() SETTING parameter declarations. */
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex
  /* Label for restoring  neutron */
  mcabsorbCompchannel_14_cave2_box3:
  if (RESTORE) /* restore if needed */
  { RESTORE_NEUTRON(685,
      mcnlx,
      mcnly,
      mcnlz,
      mcnlvx,
      mcnlvy,
      mcnlvz,
      mcnlt,
      mcnlsx,
      mcnlsy,
      mcnlsz,
      mcnlp); }
#undef mcabsorbComp
#undef p
#undef sz
#undef sy
#undef sx
#undef t
#undef vz
#undef vy
#undef vx
#undef z
#undef y
#undef x
  mcDEBUG_STATE(
mcnlx,
mcnly,
mcnlz,
mcnlvx,
mcnlvy,
mcnlvz,
mcnlt,
mcnlsx,
mcnlsy,
mcnlsz,
mcnlp)

  /* TRACE Component inter_analyzer_colimator_center_14 [686] */
  mccoordschange(mcposrinter_analyzer_colimator_center_14, mcrotrinter_analyzer_colimator_center_14,
    &mcnlx,
    &mcnly,
    &mcnlz,
    &mcnlvx,
    &mcnlvy,
    &mcnlvz,
    &mcnlsx,
    &mcnlsy,
    &mcnlsz);
  /* define label inside component inter_analyzer_colimator_center_14 (without coords transformations) */
  mcJumpTrace_inter_analyzer_colimator_center_14:
  SIG_MESSAGE("inter_analyzer_colimator_center_14 (Trace)");
  mcDEBUG_COMP("inter_analyzer_colimator_center_14")
  mcDEBUG_STATE(
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp)
#define x mcnlx
#define y mcnly
#define z mcnlz
#define vx mcnlvx
#define vy mcnlvy
#define vz mcnlvz
#define t mcnlt
#define sx mcnlsx
#define sy mcnlsy
#define sz mcnlsz
#define p mcnlp

#define mcabsorbComp mcabsorbCompinter_analyzer_colimator_center_14
  STORE_NEUTRON(686,
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp);
  mcScattered=0;
  mcRestore=0;
  mcNCounter[686]++;
  mcPCounter[686] += p;
  mcP2Counter[686] += p*p;
#define mccompcurname  inter_analyzer_colimator_center_14
#define mccompcurtype  Arm
#define mccompcurindex 686
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex
  /* Label for restoring  neutron */
  mcabsorbCompinter_analyzer_colimator_center_14:
  if (RESTORE) /* restore if needed */
  { RESTORE_NEUTRON(686,
      mcnlx,
      mcnly,
      mcnlz,
      mcnlvx,
      mcnlvy,
      mcnlvz,
      mcnlt,
      mcnlsx,
      mcnlsy,
      mcnlsz,
      mcnlp); }
#undef mcabsorbComp
#undef p
#undef sz
#undef sy
#undef sx
#undef t
#undef vz
#undef vy
#undef vx
#undef z
#undef y
#undef x
  mcDEBUG_STATE(
mcnlx,
mcnly,
mcnlz,
mcnlvx,
mcnlvy,
mcnlvz,
mcnlt,
mcnlsx,
mcnlsy,
mcnlsz,
mcnlp)

  /* TRACE Component inter_analyzer_colimator_14_blade_0 [687] */
  mccoordschange(mcposrinter_analyzer_colimator_14_blade_0, mcrotrinter_analyzer_colimator_14_blade_0,
    &mcnlx,
    &mcnly,
    &mcnlz,
    &mcnlvx,
    &mcnlvy,
    &mcnlvz,
    &mcnlsx,
    &mcnlsy,
    &mcnlsz);
  /* define label inside component inter_analyzer_colimator_14_blade_0 (without coords transformations) */
  mcJumpTrace_inter_analyzer_colimator_14_blade_0:
  SIG_MESSAGE("inter_analyzer_colimator_14_blade_0 (Trace)");
  mcDEBUG_COMP("inter_analyzer_colimator_14_blade_0")
  mcDEBUG_STATE(
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp)
#define x mcnlx
#define y mcnly
#define z mcnlz
#define vx mcnlvx
#define vy mcnlvy
#define vz mcnlvz
#define t mcnlt
#define sx mcnlsx
#define sy mcnlsy
#define sz mcnlsz
#define p mcnlp

#define mcabsorbComp mcabsorbCompinter_analyzer_colimator_14_blade_0
  STORE_NEUTRON(687,
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp);
  mcScattered=0;
  mcRestore=0;
  mcNCounter[687]++;
  mcPCounter[687] += p;
  mcP2Counter[687] += p*p;
#define mccompcurname  inter_analyzer_colimator_14_blade_0
#define mccompcurtype  Union_box
#define mccompcurindex 687
#define loop_index mccinter_analyzer_colimator_14_blade_0_loop_index
#define this_box_volume mccinter_analyzer_colimator_14_blade_0_this_box_volume
#define global_geometry_element mccinter_analyzer_colimator_14_blade_0_global_geometry_element
#define this_box_storage mccinter_analyzer_colimator_14_blade_0_this_box_storage
{   /* Declarations of inter_analyzer_colimator_14_blade_0=Union_box() SETTING parameters. */
char* material_string = mccinter_analyzer_colimator_14_blade_0_material_string;
MCNUM priority = mccinter_analyzer_colimator_14_blade_0_priority;
MCNUM xwidth = mccinter_analyzer_colimator_14_blade_0_xwidth;
MCNUM yheight = mccinter_analyzer_colimator_14_blade_0_yheight;
MCNUM zdepth = mccinter_analyzer_colimator_14_blade_0_zdepth;
MCNUM xwidth2 = mccinter_analyzer_colimator_14_blade_0_xwidth2;
MCNUM yheight2 = mccinter_analyzer_colimator_14_blade_0_yheight2;
MCNUM visualize = mccinter_analyzer_colimator_14_blade_0_visualize;
int target_index = mccinter_analyzer_colimator_14_blade_0_target_index;
MCNUM target_x = mccinter_analyzer_colimator_14_blade_0_target_x;
MCNUM target_y = mccinter_analyzer_colimator_14_blade_0_target_y;
MCNUM target_z = mccinter_analyzer_colimator_14_blade_0_target_z;
MCNUM focus_aw = mccinter_analyzer_colimator_14_blade_0_focus_aw;
MCNUM focus_ah = mccinter_analyzer_colimator_14_blade_0_focus_ah;
MCNUM focus_xw = mccinter_analyzer_colimator_14_blade_0_focus_xw;
MCNUM focus_xh = mccinter_analyzer_colimator_14_blade_0_focus_xh;
MCNUM focus_r = mccinter_analyzer_colimator_14_blade_0_focus_r;
MCNUM p_interact = mccinter_analyzer_colimator_14_blade_0_p_interact;
char* mask_string = mccinter_analyzer_colimator_14_blade_0_mask_string;
char* mask_setting = mccinter_analyzer_colimator_14_blade_0_mask_setting;
MCNUM number_of_activations = mccinter_analyzer_colimator_14_blade_0_number_of_activations;
}   /* End of inter_analyzer_colimator_14_blade_0=Union_box() SETTING parameter declarations. */
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex
  /* Label for restoring  neutron */
  mcabsorbCompinter_analyzer_colimator_14_blade_0:
  if (RESTORE) /* restore if needed */
  { RESTORE_NEUTRON(687,
      mcnlx,
      mcnly,
      mcnlz,
      mcnlvx,
      mcnlvy,
      mcnlvz,
      mcnlt,
      mcnlsx,
      mcnlsy,
      mcnlsz,
      mcnlp); }
#undef mcabsorbComp
#undef p
#undef sz
#undef sy
#undef sx
#undef t
#undef vz
#undef vy
#undef vx
#undef z
#undef y
#undef x
  mcDEBUG_STATE(
mcnlx,
mcnly,
mcnlz,
mcnlvx,
mcnlvy,
mcnlvz,
mcnlt,
mcnlsx,
mcnlsy,
mcnlsz,
mcnlp)

  /* TRACE Component inter_analyzer_colimator_14_blade_1 [688] */
  mccoordschange(mcposrinter_analyzer_colimator_14_blade_1, mcrotrinter_analyzer_colimator_14_blade_1,
    &mcnlx,
    &mcnly,
    &mcnlz,
    &mcnlvx,
    &mcnlvy,
    &mcnlvz,
    &mcnlsx,
    &mcnlsy,
    &mcnlsz);
  /* define label inside component inter_analyzer_colimator_14_blade_1 (without coords transformations) */
  mcJumpTrace_inter_analyzer_colimator_14_blade_1:
  SIG_MESSAGE("inter_analyzer_colimator_14_blade_1 (Trace)");
  mcDEBUG_COMP("inter_analyzer_colimator_14_blade_1")
  mcDEBUG_STATE(
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp)
#define x mcnlx
#define y mcnly
#define z mcnlz
#define vx mcnlvx
#define vy mcnlvy
#define vz mcnlvz
#define t mcnlt
#define sx mcnlsx
#define sy mcnlsy
#define sz mcnlsz
#define p mcnlp

#define mcabsorbComp mcabsorbCompinter_analyzer_colimator_14_blade_1
  STORE_NEUTRON(688,
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp);
  mcScattered=0;
  mcRestore=0;
  mcNCounter[688]++;
  mcPCounter[688] += p;
  mcP2Counter[688] += p*p;
#define mccompcurname  inter_analyzer_colimator_14_blade_1
#define mccompcurtype  Union_box
#define mccompcurindex 688
#define loop_index mccinter_analyzer_colimator_14_blade_1_loop_index
#define this_box_volume mccinter_analyzer_colimator_14_blade_1_this_box_volume
#define global_geometry_element mccinter_analyzer_colimator_14_blade_1_global_geometry_element
#define this_box_storage mccinter_analyzer_colimator_14_blade_1_this_box_storage
{   /* Declarations of inter_analyzer_colimator_14_blade_1=Union_box() SETTING parameters. */
char* material_string = mccinter_analyzer_colimator_14_blade_1_material_string;
MCNUM priority = mccinter_analyzer_colimator_14_blade_1_priority;
MCNUM xwidth = mccinter_analyzer_colimator_14_blade_1_xwidth;
MCNUM yheight = mccinter_analyzer_colimator_14_blade_1_yheight;
MCNUM zdepth = mccinter_analyzer_colimator_14_blade_1_zdepth;
MCNUM xwidth2 = mccinter_analyzer_colimator_14_blade_1_xwidth2;
MCNUM yheight2 = mccinter_analyzer_colimator_14_blade_1_yheight2;
MCNUM visualize = mccinter_analyzer_colimator_14_blade_1_visualize;
int target_index = mccinter_analyzer_colimator_14_blade_1_target_index;
MCNUM target_x = mccinter_analyzer_colimator_14_blade_1_target_x;
MCNUM target_y = mccinter_analyzer_colimator_14_blade_1_target_y;
MCNUM target_z = mccinter_analyzer_colimator_14_blade_1_target_z;
MCNUM focus_aw = mccinter_analyzer_colimator_14_blade_1_focus_aw;
MCNUM focus_ah = mccinter_analyzer_colimator_14_blade_1_focus_ah;
MCNUM focus_xw = mccinter_analyzer_colimator_14_blade_1_focus_xw;
MCNUM focus_xh = mccinter_analyzer_colimator_14_blade_1_focus_xh;
MCNUM focus_r = mccinter_analyzer_colimator_14_blade_1_focus_r;
MCNUM p_interact = mccinter_analyzer_colimator_14_blade_1_p_interact;
char* mask_string = mccinter_analyzer_colimator_14_blade_1_mask_string;
char* mask_setting = mccinter_analyzer_colimator_14_blade_1_mask_setting;
MCNUM number_of_activations = mccinter_analyzer_colimator_14_blade_1_number_of_activations;
}   /* End of inter_analyzer_colimator_14_blade_1=Union_box() SETTING parameter declarations. */
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex
  /* Label for restoring  neutron */
  mcabsorbCompinter_analyzer_colimator_14_blade_1:
  if (RESTORE) /* restore if needed */
  { RESTORE_NEUTRON(688,
      mcnlx,
      mcnly,
      mcnlz,
      mcnlvx,
      mcnlvy,
      mcnlvz,
      mcnlt,
      mcnlsx,
      mcnlsy,
      mcnlsz,
      mcnlp); }
#undef mcabsorbComp
#undef p
#undef sz
#undef sy
#undef sx
#undef t
#undef vz
#undef vy
#undef vx
#undef z
#undef y
#undef x
  mcDEBUG_STATE(
mcnlx,
mcnly,
mcnlz,
mcnlvx,
mcnlvy,
mcnlvz,
mcnlt,
mcnlsx,
mcnlsy,
mcnlsz,
mcnlp)

  /* TRACE Component inter_analyzer_colimator_14_blade_2 [689] */
  mccoordschange(mcposrinter_analyzer_colimator_14_blade_2, mcrotrinter_analyzer_colimator_14_blade_2,
    &mcnlx,
    &mcnly,
    &mcnlz,
    &mcnlvx,
    &mcnlvy,
    &mcnlvz,
    &mcnlsx,
    &mcnlsy,
    &mcnlsz);
  /* define label inside component inter_analyzer_colimator_14_blade_2 (without coords transformations) */
  mcJumpTrace_inter_analyzer_colimator_14_blade_2:
  SIG_MESSAGE("inter_analyzer_colimator_14_blade_2 (Trace)");
  mcDEBUG_COMP("inter_analyzer_colimator_14_blade_2")
  mcDEBUG_STATE(
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp)
#define x mcnlx
#define y mcnly
#define z mcnlz
#define vx mcnlvx
#define vy mcnlvy
#define vz mcnlvz
#define t mcnlt
#define sx mcnlsx
#define sy mcnlsy
#define sz mcnlsz
#define p mcnlp

#define mcabsorbComp mcabsorbCompinter_analyzer_colimator_14_blade_2
  STORE_NEUTRON(689,
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp);
  mcScattered=0;
  mcRestore=0;
  mcNCounter[689]++;
  mcPCounter[689] += p;
  mcP2Counter[689] += p*p;
#define mccompcurname  inter_analyzer_colimator_14_blade_2
#define mccompcurtype  Union_box
#define mccompcurindex 689
#define loop_index mccinter_analyzer_colimator_14_blade_2_loop_index
#define this_box_volume mccinter_analyzer_colimator_14_blade_2_this_box_volume
#define global_geometry_element mccinter_analyzer_colimator_14_blade_2_global_geometry_element
#define this_box_storage mccinter_analyzer_colimator_14_blade_2_this_box_storage
{   /* Declarations of inter_analyzer_colimator_14_blade_2=Union_box() SETTING parameters. */
char* material_string = mccinter_analyzer_colimator_14_blade_2_material_string;
MCNUM priority = mccinter_analyzer_colimator_14_blade_2_priority;
MCNUM xwidth = mccinter_analyzer_colimator_14_blade_2_xwidth;
MCNUM yheight = mccinter_analyzer_colimator_14_blade_2_yheight;
MCNUM zdepth = mccinter_analyzer_colimator_14_blade_2_zdepth;
MCNUM xwidth2 = mccinter_analyzer_colimator_14_blade_2_xwidth2;
MCNUM yheight2 = mccinter_analyzer_colimator_14_blade_2_yheight2;
MCNUM visualize = mccinter_analyzer_colimator_14_blade_2_visualize;
int target_index = mccinter_analyzer_colimator_14_blade_2_target_index;
MCNUM target_x = mccinter_analyzer_colimator_14_blade_2_target_x;
MCNUM target_y = mccinter_analyzer_colimator_14_blade_2_target_y;
MCNUM target_z = mccinter_analyzer_colimator_14_blade_2_target_z;
MCNUM focus_aw = mccinter_analyzer_colimator_14_blade_2_focus_aw;
MCNUM focus_ah = mccinter_analyzer_colimator_14_blade_2_focus_ah;
MCNUM focus_xw = mccinter_analyzer_colimator_14_blade_2_focus_xw;
MCNUM focus_xh = mccinter_analyzer_colimator_14_blade_2_focus_xh;
MCNUM focus_r = mccinter_analyzer_colimator_14_blade_2_focus_r;
MCNUM p_interact = mccinter_analyzer_colimator_14_blade_2_p_interact;
char* mask_string = mccinter_analyzer_colimator_14_blade_2_mask_string;
char* mask_setting = mccinter_analyzer_colimator_14_blade_2_mask_setting;
MCNUM number_of_activations = mccinter_analyzer_colimator_14_blade_2_number_of_activations;
}   /* End of inter_analyzer_colimator_14_blade_2=Union_box() SETTING parameter declarations. */
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex
  /* Label for restoring  neutron */
  mcabsorbCompinter_analyzer_colimator_14_blade_2:
  if (RESTORE) /* restore if needed */
  { RESTORE_NEUTRON(689,
      mcnlx,
      mcnly,
      mcnlz,
      mcnlvx,
      mcnlvy,
      mcnlvz,
      mcnlt,
      mcnlsx,
      mcnlsy,
      mcnlsz,
      mcnlp); }
#undef mcabsorbComp
#undef p
#undef sz
#undef sy
#undef sx
#undef t
#undef vz
#undef vy
#undef vx
#undef z
#undef y
#undef x
  mcDEBUG_STATE(
mcnlx,
mcnly,
mcnlz,
mcnlvx,
mcnlvy,
mcnlvz,
mcnlt,
mcnlsx,
mcnlsy,
mcnlsz,
mcnlp)

  /* TRACE Component inter_analyzer_colimator_14_blade_3 [690] */
  mccoordschange(mcposrinter_analyzer_colimator_14_blade_3, mcrotrinter_analyzer_colimator_14_blade_3,
    &mcnlx,
    &mcnly,
    &mcnlz,
    &mcnlvx,
    &mcnlvy,
    &mcnlvz,
    &mcnlsx,
    &mcnlsy,
    &mcnlsz);
  /* define label inside component inter_analyzer_colimator_14_blade_3 (without coords transformations) */
  mcJumpTrace_inter_analyzer_colimator_14_blade_3:
  SIG_MESSAGE("inter_analyzer_colimator_14_blade_3 (Trace)");
  mcDEBUG_COMP("inter_analyzer_colimator_14_blade_3")
  mcDEBUG_STATE(
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp)
#define x mcnlx
#define y mcnly
#define z mcnlz
#define vx mcnlvx
#define vy mcnlvy
#define vz mcnlvz
#define t mcnlt
#define sx mcnlsx
#define sy mcnlsy
#define sz mcnlsz
#define p mcnlp

#define mcabsorbComp mcabsorbCompinter_analyzer_colimator_14_blade_3
  STORE_NEUTRON(690,
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp);
  mcScattered=0;
  mcRestore=0;
  mcNCounter[690]++;
  mcPCounter[690] += p;
  mcP2Counter[690] += p*p;
#define mccompcurname  inter_analyzer_colimator_14_blade_3
#define mccompcurtype  Union_box
#define mccompcurindex 690
#define loop_index mccinter_analyzer_colimator_14_blade_3_loop_index
#define this_box_volume mccinter_analyzer_colimator_14_blade_3_this_box_volume
#define global_geometry_element mccinter_analyzer_colimator_14_blade_3_global_geometry_element
#define this_box_storage mccinter_analyzer_colimator_14_blade_3_this_box_storage
{   /* Declarations of inter_analyzer_colimator_14_blade_3=Union_box() SETTING parameters. */
char* material_string = mccinter_analyzer_colimator_14_blade_3_material_string;
MCNUM priority = mccinter_analyzer_colimator_14_blade_3_priority;
MCNUM xwidth = mccinter_analyzer_colimator_14_blade_3_xwidth;
MCNUM yheight = mccinter_analyzer_colimator_14_blade_3_yheight;
MCNUM zdepth = mccinter_analyzer_colimator_14_blade_3_zdepth;
MCNUM xwidth2 = mccinter_analyzer_colimator_14_blade_3_xwidth2;
MCNUM yheight2 = mccinter_analyzer_colimator_14_blade_3_yheight2;
MCNUM visualize = mccinter_analyzer_colimator_14_blade_3_visualize;
int target_index = mccinter_analyzer_colimator_14_blade_3_target_index;
MCNUM target_x = mccinter_analyzer_colimator_14_blade_3_target_x;
MCNUM target_y = mccinter_analyzer_colimator_14_blade_3_target_y;
MCNUM target_z = mccinter_analyzer_colimator_14_blade_3_target_z;
MCNUM focus_aw = mccinter_analyzer_colimator_14_blade_3_focus_aw;
MCNUM focus_ah = mccinter_analyzer_colimator_14_blade_3_focus_ah;
MCNUM focus_xw = mccinter_analyzer_colimator_14_blade_3_focus_xw;
MCNUM focus_xh = mccinter_analyzer_colimator_14_blade_3_focus_xh;
MCNUM focus_r = mccinter_analyzer_colimator_14_blade_3_focus_r;
MCNUM p_interact = mccinter_analyzer_colimator_14_blade_3_p_interact;
char* mask_string = mccinter_analyzer_colimator_14_blade_3_mask_string;
char* mask_setting = mccinter_analyzer_colimator_14_blade_3_mask_setting;
MCNUM number_of_activations = mccinter_analyzer_colimator_14_blade_3_number_of_activations;
}   /* End of inter_analyzer_colimator_14_blade_3=Union_box() SETTING parameter declarations. */
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex
  /* Label for restoring  neutron */
  mcabsorbCompinter_analyzer_colimator_14_blade_3:
  if (RESTORE) /* restore if needed */
  { RESTORE_NEUTRON(690,
      mcnlx,
      mcnly,
      mcnlz,
      mcnlvx,
      mcnlvy,
      mcnlvz,
      mcnlt,
      mcnlsx,
      mcnlsy,
      mcnlsz,
      mcnlp); }
#undef mcabsorbComp
#undef p
#undef sz
#undef sy
#undef sx
#undef t
#undef vz
#undef vy
#undef vx
#undef z
#undef y
#undef x
  mcDEBUG_STATE(
mcnlx,
mcnly,
mcnlz,
mcnlvx,
mcnlvy,
mcnlvz,
mcnlt,
mcnlsx,
mcnlsy,
mcnlsz,
mcnlp)

  /* TRACE Component inter_analyzer_colimator_14_blade_4 [691] */
  mccoordschange(mcposrinter_analyzer_colimator_14_blade_4, mcrotrinter_analyzer_colimator_14_blade_4,
    &mcnlx,
    &mcnly,
    &mcnlz,
    &mcnlvx,
    &mcnlvy,
    &mcnlvz,
    &mcnlsx,
    &mcnlsy,
    &mcnlsz);
  /* define label inside component inter_analyzer_colimator_14_blade_4 (without coords transformations) */
  mcJumpTrace_inter_analyzer_colimator_14_blade_4:
  SIG_MESSAGE("inter_analyzer_colimator_14_blade_4 (Trace)");
  mcDEBUG_COMP("inter_analyzer_colimator_14_blade_4")
  mcDEBUG_STATE(
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp)
#define x mcnlx
#define y mcnly
#define z mcnlz
#define vx mcnlvx
#define vy mcnlvy
#define vz mcnlvz
#define t mcnlt
#define sx mcnlsx
#define sy mcnlsy
#define sz mcnlsz
#define p mcnlp

#define mcabsorbComp mcabsorbCompinter_analyzer_colimator_14_blade_4
  STORE_NEUTRON(691,
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp);
  mcScattered=0;
  mcRestore=0;
  mcNCounter[691]++;
  mcPCounter[691] += p;
  mcP2Counter[691] += p*p;
#define mccompcurname  inter_analyzer_colimator_14_blade_4
#define mccompcurtype  Union_box
#define mccompcurindex 691
#define loop_index mccinter_analyzer_colimator_14_blade_4_loop_index
#define this_box_volume mccinter_analyzer_colimator_14_blade_4_this_box_volume
#define global_geometry_element mccinter_analyzer_colimator_14_blade_4_global_geometry_element
#define this_box_storage mccinter_analyzer_colimator_14_blade_4_this_box_storage
{   /* Declarations of inter_analyzer_colimator_14_blade_4=Union_box() SETTING parameters. */
char* material_string = mccinter_analyzer_colimator_14_blade_4_material_string;
MCNUM priority = mccinter_analyzer_colimator_14_blade_4_priority;
MCNUM xwidth = mccinter_analyzer_colimator_14_blade_4_xwidth;
MCNUM yheight = mccinter_analyzer_colimator_14_blade_4_yheight;
MCNUM zdepth = mccinter_analyzer_colimator_14_blade_4_zdepth;
MCNUM xwidth2 = mccinter_analyzer_colimator_14_blade_4_xwidth2;
MCNUM yheight2 = mccinter_analyzer_colimator_14_blade_4_yheight2;
MCNUM visualize = mccinter_analyzer_colimator_14_blade_4_visualize;
int target_index = mccinter_analyzer_colimator_14_blade_4_target_index;
MCNUM target_x = mccinter_analyzer_colimator_14_blade_4_target_x;
MCNUM target_y = mccinter_analyzer_colimator_14_blade_4_target_y;
MCNUM target_z = mccinter_analyzer_colimator_14_blade_4_target_z;
MCNUM focus_aw = mccinter_analyzer_colimator_14_blade_4_focus_aw;
MCNUM focus_ah = mccinter_analyzer_colimator_14_blade_4_focus_ah;
MCNUM focus_xw = mccinter_analyzer_colimator_14_blade_4_focus_xw;
MCNUM focus_xh = mccinter_analyzer_colimator_14_blade_4_focus_xh;
MCNUM focus_r = mccinter_analyzer_colimator_14_blade_4_focus_r;
MCNUM p_interact = mccinter_analyzer_colimator_14_blade_4_p_interact;
char* mask_string = mccinter_analyzer_colimator_14_blade_4_mask_string;
char* mask_setting = mccinter_analyzer_colimator_14_blade_4_mask_setting;
MCNUM number_of_activations = mccinter_analyzer_colimator_14_blade_4_number_of_activations;
}   /* End of inter_analyzer_colimator_14_blade_4=Union_box() SETTING parameter declarations. */
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex
  /* Label for restoring  neutron */
  mcabsorbCompinter_analyzer_colimator_14_blade_4:
  if (RESTORE) /* restore if needed */
  { RESTORE_NEUTRON(691,
      mcnlx,
      mcnly,
      mcnlz,
      mcnlvx,
      mcnlvy,
      mcnlvz,
      mcnlt,
      mcnlsx,
      mcnlsy,
      mcnlsz,
      mcnlp); }
#undef mcabsorbComp
#undef p
#undef sz
#undef sy
#undef sx
#undef t
#undef vz
#undef vy
#undef vx
#undef z
#undef y
#undef x
  mcDEBUG_STATE(
mcnlx,
mcnly,
mcnlz,
mcnlvx,
mcnlvy,
mcnlvz,
mcnlt,
mcnlsx,
mcnlsy,
mcnlsz,
mcnlp)

  /* TRACE Component diffraction_detector_14_exit_volume [692] */
  mccoordschange(mcposrdiffraction_detector_14_exit_volume, mcrotrdiffraction_detector_14_exit_volume,
    &mcnlx,
    &mcnly,
    &mcnlz,
    &mcnlvx,
    &mcnlvy,
    &mcnlvz,
    &mcnlsx,
    &mcnlsy,
    &mcnlsz);
  /* define label inside component diffraction_detector_14_exit_volume (without coords transformations) */
  mcJumpTrace_diffraction_detector_14_exit_volume:
  SIG_MESSAGE("diffraction_detector_14_exit_volume (Trace)");
  mcDEBUG_COMP("diffraction_detector_14_exit_volume")
  mcDEBUG_STATE(
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp)
#define x mcnlx
#define y mcnly
#define z mcnlz
#define vx mcnlvx
#define vy mcnlvy
#define vz mcnlvz
#define t mcnlt
#define sx mcnlsx
#define sy mcnlsy
#define sz mcnlsz
#define p mcnlp

#define mcabsorbComp mcabsorbCompdiffraction_detector_14_exit_volume
  STORE_NEUTRON(692,
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp);
  mcScattered=0;
  mcRestore=0;
  mcNCounter[692]++;
  mcPCounter[692] += p;
  mcP2Counter[692] += p*p;
#define mccompcurname  diffraction_detector_14_exit_volume
#define mccompcurtype  Union_box
#define mccompcurindex 692
#define loop_index mccdiffraction_detector_14_exit_volume_loop_index
#define this_box_volume mccdiffraction_detector_14_exit_volume_this_box_volume
#define global_geometry_element mccdiffraction_detector_14_exit_volume_global_geometry_element
#define this_box_storage mccdiffraction_detector_14_exit_volume_this_box_storage
{   /* Declarations of diffraction_detector_14_exit_volume=Union_box() SETTING parameters. */
char* material_string = mccdiffraction_detector_14_exit_volume_material_string;
MCNUM priority = mccdiffraction_detector_14_exit_volume_priority;
MCNUM xwidth = mccdiffraction_detector_14_exit_volume_xwidth;
MCNUM yheight = mccdiffraction_detector_14_exit_volume_yheight;
MCNUM zdepth = mccdiffraction_detector_14_exit_volume_zdepth;
MCNUM xwidth2 = mccdiffraction_detector_14_exit_volume_xwidth2;
MCNUM yheight2 = mccdiffraction_detector_14_exit_volume_yheight2;
MCNUM visualize = mccdiffraction_detector_14_exit_volume_visualize;
int target_index = mccdiffraction_detector_14_exit_volume_target_index;
MCNUM target_x = mccdiffraction_detector_14_exit_volume_target_x;
MCNUM target_y = mccdiffraction_detector_14_exit_volume_target_y;
MCNUM target_z = mccdiffraction_detector_14_exit_volume_target_z;
MCNUM focus_aw = mccdiffraction_detector_14_exit_volume_focus_aw;
MCNUM focus_ah = mccdiffraction_detector_14_exit_volume_focus_ah;
MCNUM focus_xw = mccdiffraction_detector_14_exit_volume_focus_xw;
MCNUM focus_xh = mccdiffraction_detector_14_exit_volume_focus_xh;
MCNUM focus_r = mccdiffraction_detector_14_exit_volume_focus_r;
MCNUM p_interact = mccdiffraction_detector_14_exit_volume_p_interact;
char* mask_string = mccdiffraction_detector_14_exit_volume_mask_string;
char* mask_setting = mccdiffraction_detector_14_exit_volume_mask_setting;
MCNUM number_of_activations = mccdiffraction_detector_14_exit_volume_number_of_activations;
}   /* End of diffraction_detector_14_exit_volume=Union_box() SETTING parameter declarations. */
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex
  /* Label for restoring  neutron */
  mcabsorbCompdiffraction_detector_14_exit_volume:
  if (RESTORE) /* restore if needed */
  { RESTORE_NEUTRON(692,
      mcnlx,
      mcnly,
      mcnlz,
      mcnlvx,
      mcnlvy,
      mcnlvz,
      mcnlt,
      mcnlsx,
      mcnlsy,
      mcnlsz,
      mcnlp); }
#undef mcabsorbComp
#undef p
#undef sz
#undef sy
#undef sx
#undef t
#undef vz
#undef vy
#undef vx
#undef z
#undef y
#undef x
  mcDEBUG_STATE(
mcnlx,
mcnly,
mcnlz,
mcnlvx,
mcnlvy,
mcnlvz,
mcnlt,
mcnlsx,
mcnlsy,
mcnlsz,
mcnlp)

  /* TRACE Component spec_detector_14_exit_volume [693] */
  mccoordschange(mcposrspec_detector_14_exit_volume, mcrotrspec_detector_14_exit_volume,
    &mcnlx,
    &mcnly,
    &mcnlz,
    &mcnlvx,
    &mcnlvy,
    &mcnlvz,
    &mcnlsx,
    &mcnlsy,
    &mcnlsz);
  /* define label inside component spec_detector_14_exit_volume (without coords transformations) */
  mcJumpTrace_spec_detector_14_exit_volume:
  SIG_MESSAGE("spec_detector_14_exit_volume (Trace)");
  mcDEBUG_COMP("spec_detector_14_exit_volume")
  mcDEBUG_STATE(
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp)
#define x mcnlx
#define y mcnly
#define z mcnlz
#define vx mcnlvx
#define vy mcnlvy
#define vz mcnlvz
#define t mcnlt
#define sx mcnlsx
#define sy mcnlsy
#define sz mcnlsz
#define p mcnlp

#define mcabsorbComp mcabsorbCompspec_detector_14_exit_volume
  STORE_NEUTRON(693,
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp);
  mcScattered=0;
  mcRestore=0;
  mcNCounter[693]++;
  mcPCounter[693] += p;
  mcP2Counter[693] += p*p;
#define mccompcurname  spec_detector_14_exit_volume
#define mccompcurtype  Union_box
#define mccompcurindex 693
#define loop_index mccspec_detector_14_exit_volume_loop_index
#define this_box_volume mccspec_detector_14_exit_volume_this_box_volume
#define global_geometry_element mccspec_detector_14_exit_volume_global_geometry_element
#define this_box_storage mccspec_detector_14_exit_volume_this_box_storage
{   /* Declarations of spec_detector_14_exit_volume=Union_box() SETTING parameters. */
char* material_string = mccspec_detector_14_exit_volume_material_string;
MCNUM priority = mccspec_detector_14_exit_volume_priority;
MCNUM xwidth = mccspec_detector_14_exit_volume_xwidth;
MCNUM yheight = mccspec_detector_14_exit_volume_yheight;
MCNUM zdepth = mccspec_detector_14_exit_volume_zdepth;
MCNUM xwidth2 = mccspec_detector_14_exit_volume_xwidth2;
MCNUM yheight2 = mccspec_detector_14_exit_volume_yheight2;
MCNUM visualize = mccspec_detector_14_exit_volume_visualize;
int target_index = mccspec_detector_14_exit_volume_target_index;
MCNUM target_x = mccspec_detector_14_exit_volume_target_x;
MCNUM target_y = mccspec_detector_14_exit_volume_target_y;
MCNUM target_z = mccspec_detector_14_exit_volume_target_z;
MCNUM focus_aw = mccspec_detector_14_exit_volume_focus_aw;
MCNUM focus_ah = mccspec_detector_14_exit_volume_focus_ah;
MCNUM focus_xw = mccspec_detector_14_exit_volume_focus_xw;
MCNUM focus_xh = mccspec_detector_14_exit_volume_focus_xh;
MCNUM focus_r = mccspec_detector_14_exit_volume_focus_r;
MCNUM p_interact = mccspec_detector_14_exit_volume_p_interact;
char* mask_string = mccspec_detector_14_exit_volume_mask_string;
char* mask_setting = mccspec_detector_14_exit_volume_mask_setting;
MCNUM number_of_activations = mccspec_detector_14_exit_volume_number_of_activations;
}   /* End of spec_detector_14_exit_volume=Union_box() SETTING parameter declarations. */
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex
  /* Label for restoring  neutron */
  mcabsorbCompspec_detector_14_exit_volume:
  if (RESTORE) /* restore if needed */
  { RESTORE_NEUTRON(693,
      mcnlx,
      mcnly,
      mcnlz,
      mcnlvx,
      mcnlvy,
      mcnlvz,
      mcnlt,
      mcnlsx,
      mcnlsy,
      mcnlsz,
      mcnlp); }
#undef mcabsorbComp
#undef p
#undef sz
#undef sy
#undef sx
#undef t
#undef vz
#undef vy
#undef vx
#undef z
#undef y
#undef x
  mcDEBUG_STATE(
mcnlx,
mcnly,
mcnlz,
mcnlvx,
mcnlvy,
mcnlvz,
mcnlt,
mcnlsx,
mcnlsy,
mcnlsz,
mcnlp)

  /* TRACE Component channel_15_cave1_box1 [694] */
  mccoordschange(mcposrchannel_15_cave1_box1, mcrotrchannel_15_cave1_box1,
    &mcnlx,
    &mcnly,
    &mcnlz,
    &mcnlvx,
    &mcnlvy,
    &mcnlvz,
    &mcnlsx,
    &mcnlsy,
    &mcnlsz);
  /* define label inside component channel_15_cave1_box1 (without coords transformations) */
  mcJumpTrace_channel_15_cave1_box1:
  SIG_MESSAGE("channel_15_cave1_box1 (Trace)");
  mcDEBUG_COMP("channel_15_cave1_box1")
  mcDEBUG_STATE(
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp)
#define x mcnlx
#define y mcnly
#define z mcnlz
#define vx mcnlvx
#define vy mcnlvy
#define vz mcnlvz
#define t mcnlt
#define sx mcnlsx
#define sy mcnlsy
#define sz mcnlsz
#define p mcnlp

#define mcabsorbComp mcabsorbCompchannel_15_cave1_box1
  STORE_NEUTRON(694,
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp);
  mcScattered=0;
  mcRestore=0;
  mcNCounter[694]++;
  mcPCounter[694] += p;
  mcP2Counter[694] += p*p;
#define mccompcurname  channel_15_cave1_box1
#define mccompcurtype  Union_box
#define mccompcurindex 694
#define loop_index mccchannel_15_cave1_box1_loop_index
#define this_box_volume mccchannel_15_cave1_box1_this_box_volume
#define global_geometry_element mccchannel_15_cave1_box1_global_geometry_element
#define this_box_storage mccchannel_15_cave1_box1_this_box_storage
{   /* Declarations of channel_15_cave1_box1=Union_box() SETTING parameters. */
char* material_string = mccchannel_15_cave1_box1_material_string;
MCNUM priority = mccchannel_15_cave1_box1_priority;
MCNUM xwidth = mccchannel_15_cave1_box1_xwidth;
MCNUM yheight = mccchannel_15_cave1_box1_yheight;
MCNUM zdepth = mccchannel_15_cave1_box1_zdepth;
MCNUM xwidth2 = mccchannel_15_cave1_box1_xwidth2;
MCNUM yheight2 = mccchannel_15_cave1_box1_yheight2;
MCNUM visualize = mccchannel_15_cave1_box1_visualize;
int target_index = mccchannel_15_cave1_box1_target_index;
MCNUM target_x = mccchannel_15_cave1_box1_target_x;
MCNUM target_y = mccchannel_15_cave1_box1_target_y;
MCNUM target_z = mccchannel_15_cave1_box1_target_z;
MCNUM focus_aw = mccchannel_15_cave1_box1_focus_aw;
MCNUM focus_ah = mccchannel_15_cave1_box1_focus_ah;
MCNUM focus_xw = mccchannel_15_cave1_box1_focus_xw;
MCNUM focus_xh = mccchannel_15_cave1_box1_focus_xh;
MCNUM focus_r = mccchannel_15_cave1_box1_focus_r;
MCNUM p_interact = mccchannel_15_cave1_box1_p_interact;
char* mask_string = mccchannel_15_cave1_box1_mask_string;
char* mask_setting = mccchannel_15_cave1_box1_mask_setting;
MCNUM number_of_activations = mccchannel_15_cave1_box1_number_of_activations;
}   /* End of channel_15_cave1_box1=Union_box() SETTING parameter declarations. */
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex
  /* Label for restoring  neutron */
  mcabsorbCompchannel_15_cave1_box1:
  if (RESTORE) /* restore if needed */
  { RESTORE_NEUTRON(694,
      mcnlx,
      mcnly,
      mcnlz,
      mcnlvx,
      mcnlvy,
      mcnlvz,
      mcnlt,
      mcnlsx,
      mcnlsy,
      mcnlsz,
      mcnlp); }
#undef mcabsorbComp
#undef p
#undef sz
#undef sy
#undef sx
#undef t
#undef vz
#undef vy
#undef vx
#undef z
#undef y
#undef x
  mcDEBUG_STATE(
mcnlx,
mcnly,
mcnlz,
mcnlvx,
mcnlvy,
mcnlvz,
mcnlt,
mcnlsx,
mcnlsy,
mcnlsz,
mcnlp)

  /* TRACE Component channel_15_cave1_box2 [695] */
  mccoordschange(mcposrchannel_15_cave1_box2, mcrotrchannel_15_cave1_box2,
    &mcnlx,
    &mcnly,
    &mcnlz,
    &mcnlvx,
    &mcnlvy,
    &mcnlvz,
    &mcnlsx,
    &mcnlsy,
    &mcnlsz);
  /* define label inside component channel_15_cave1_box2 (without coords transformations) */
  mcJumpTrace_channel_15_cave1_box2:
  SIG_MESSAGE("channel_15_cave1_box2 (Trace)");
  mcDEBUG_COMP("channel_15_cave1_box2")
  mcDEBUG_STATE(
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp)
#define x mcnlx
#define y mcnly
#define z mcnlz
#define vx mcnlvx
#define vy mcnlvy
#define vz mcnlvz
#define t mcnlt
#define sx mcnlsx
#define sy mcnlsy
#define sz mcnlsz
#define p mcnlp

#define mcabsorbComp mcabsorbCompchannel_15_cave1_box2
  STORE_NEUTRON(695,
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp);
  mcScattered=0;
  mcRestore=0;
  mcNCounter[695]++;
  mcPCounter[695] += p;
  mcP2Counter[695] += p*p;
#define mccompcurname  channel_15_cave1_box2
#define mccompcurtype  Union_box
#define mccompcurindex 695
#define loop_index mccchannel_15_cave1_box2_loop_index
#define this_box_volume mccchannel_15_cave1_box2_this_box_volume
#define global_geometry_element mccchannel_15_cave1_box2_global_geometry_element
#define this_box_storage mccchannel_15_cave1_box2_this_box_storage
{   /* Declarations of channel_15_cave1_box2=Union_box() SETTING parameters. */
char* material_string = mccchannel_15_cave1_box2_material_string;
MCNUM priority = mccchannel_15_cave1_box2_priority;
MCNUM xwidth = mccchannel_15_cave1_box2_xwidth;
MCNUM yheight = mccchannel_15_cave1_box2_yheight;
MCNUM zdepth = mccchannel_15_cave1_box2_zdepth;
MCNUM xwidth2 = mccchannel_15_cave1_box2_xwidth2;
MCNUM yheight2 = mccchannel_15_cave1_box2_yheight2;
MCNUM visualize = mccchannel_15_cave1_box2_visualize;
int target_index = mccchannel_15_cave1_box2_target_index;
MCNUM target_x = mccchannel_15_cave1_box2_target_x;
MCNUM target_y = mccchannel_15_cave1_box2_target_y;
MCNUM target_z = mccchannel_15_cave1_box2_target_z;
MCNUM focus_aw = mccchannel_15_cave1_box2_focus_aw;
MCNUM focus_ah = mccchannel_15_cave1_box2_focus_ah;
MCNUM focus_xw = mccchannel_15_cave1_box2_focus_xw;
MCNUM focus_xh = mccchannel_15_cave1_box2_focus_xh;
MCNUM focus_r = mccchannel_15_cave1_box2_focus_r;
MCNUM p_interact = mccchannel_15_cave1_box2_p_interact;
char* mask_string = mccchannel_15_cave1_box2_mask_string;
char* mask_setting = mccchannel_15_cave1_box2_mask_setting;
MCNUM number_of_activations = mccchannel_15_cave1_box2_number_of_activations;
}   /* End of channel_15_cave1_box2=Union_box() SETTING parameter declarations. */
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex
  /* Label for restoring  neutron */
  mcabsorbCompchannel_15_cave1_box2:
  if (RESTORE) /* restore if needed */
  { RESTORE_NEUTRON(695,
      mcnlx,
      mcnly,
      mcnlz,
      mcnlvx,
      mcnlvy,
      mcnlvz,
      mcnlt,
      mcnlsx,
      mcnlsy,
      mcnlsz,
      mcnlp); }
#undef mcabsorbComp
#undef p
#undef sz
#undef sy
#undef sx
#undef t
#undef vz
#undef vy
#undef vx
#undef z
#undef y
#undef x
  mcDEBUG_STATE(
mcnlx,
mcnly,
mcnlz,
mcnlvx,
mcnlvy,
mcnlvz,
mcnlt,
mcnlsx,
mcnlsy,
mcnlsz,
mcnlp)

  /* TRACE Component channel_15_cave1_box3 [696] */
  mccoordschange(mcposrchannel_15_cave1_box3, mcrotrchannel_15_cave1_box3,
    &mcnlx,
    &mcnly,
    &mcnlz,
    &mcnlvx,
    &mcnlvy,
    &mcnlvz,
    &mcnlsx,
    &mcnlsy,
    &mcnlsz);
  /* define label inside component channel_15_cave1_box3 (without coords transformations) */
  mcJumpTrace_channel_15_cave1_box3:
  SIG_MESSAGE("channel_15_cave1_box3 (Trace)");
  mcDEBUG_COMP("channel_15_cave1_box3")
  mcDEBUG_STATE(
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp)
#define x mcnlx
#define y mcnly
#define z mcnlz
#define vx mcnlvx
#define vy mcnlvy
#define vz mcnlvz
#define t mcnlt
#define sx mcnlsx
#define sy mcnlsy
#define sz mcnlsz
#define p mcnlp

#define mcabsorbComp mcabsorbCompchannel_15_cave1_box3
  STORE_NEUTRON(696,
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp);
  mcScattered=0;
  mcRestore=0;
  mcNCounter[696]++;
  mcPCounter[696] += p;
  mcP2Counter[696] += p*p;
#define mccompcurname  channel_15_cave1_box3
#define mccompcurtype  Union_box
#define mccompcurindex 696
#define loop_index mccchannel_15_cave1_box3_loop_index
#define this_box_volume mccchannel_15_cave1_box3_this_box_volume
#define global_geometry_element mccchannel_15_cave1_box3_global_geometry_element
#define this_box_storage mccchannel_15_cave1_box3_this_box_storage
{   /* Declarations of channel_15_cave1_box3=Union_box() SETTING parameters. */
char* material_string = mccchannel_15_cave1_box3_material_string;
MCNUM priority = mccchannel_15_cave1_box3_priority;
MCNUM xwidth = mccchannel_15_cave1_box3_xwidth;
MCNUM yheight = mccchannel_15_cave1_box3_yheight;
MCNUM zdepth = mccchannel_15_cave1_box3_zdepth;
MCNUM xwidth2 = mccchannel_15_cave1_box3_xwidth2;
MCNUM yheight2 = mccchannel_15_cave1_box3_yheight2;
MCNUM visualize = mccchannel_15_cave1_box3_visualize;
int target_index = mccchannel_15_cave1_box3_target_index;
MCNUM target_x = mccchannel_15_cave1_box3_target_x;
MCNUM target_y = mccchannel_15_cave1_box3_target_y;
MCNUM target_z = mccchannel_15_cave1_box3_target_z;
MCNUM focus_aw = mccchannel_15_cave1_box3_focus_aw;
MCNUM focus_ah = mccchannel_15_cave1_box3_focus_ah;
MCNUM focus_xw = mccchannel_15_cave1_box3_focus_xw;
MCNUM focus_xh = mccchannel_15_cave1_box3_focus_xh;
MCNUM focus_r = mccchannel_15_cave1_box3_focus_r;
MCNUM p_interact = mccchannel_15_cave1_box3_p_interact;
char* mask_string = mccchannel_15_cave1_box3_mask_string;
char* mask_setting = mccchannel_15_cave1_box3_mask_setting;
MCNUM number_of_activations = mccchannel_15_cave1_box3_number_of_activations;
}   /* End of channel_15_cave1_box3=Union_box() SETTING parameter declarations. */
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex
  /* Label for restoring  neutron */
  mcabsorbCompchannel_15_cave1_box3:
  if (RESTORE) /* restore if needed */
  { RESTORE_NEUTRON(696,
      mcnlx,
      mcnly,
      mcnlz,
      mcnlvx,
      mcnlvy,
      mcnlvz,
      mcnlt,
      mcnlsx,
      mcnlsy,
      mcnlsz,
      mcnlp); }
#undef mcabsorbComp
#undef p
#undef sz
#undef sy
#undef sx
#undef t
#undef vz
#undef vy
#undef vx
#undef z
#undef y
#undef x
  mcDEBUG_STATE(
mcnlx,
mcnly,
mcnlz,
mcnlvx,
mcnlvy,
mcnlvz,
mcnlt,
mcnlsx,
mcnlsy,
mcnlsz,
mcnlp)

  /* TRACE Component channel_15_cave1_cyl1 [697] */
  mccoordschange(mcposrchannel_15_cave1_cyl1, mcrotrchannel_15_cave1_cyl1,
    &mcnlx,
    &mcnly,
    &mcnlz,
    &mcnlvx,
    &mcnlvy,
    &mcnlvz,
    &mcnlsx,
    &mcnlsy,
    &mcnlsz);
  /* define label inside component channel_15_cave1_cyl1 (without coords transformations) */
  mcJumpTrace_channel_15_cave1_cyl1:
  SIG_MESSAGE("channel_15_cave1_cyl1 (Trace)");
  mcDEBUG_COMP("channel_15_cave1_cyl1")
  mcDEBUG_STATE(
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp)
#define x mcnlx
#define y mcnly
#define z mcnlz
#define vx mcnlvx
#define vy mcnlvy
#define vz mcnlvz
#define t mcnlt
#define sx mcnlsx
#define sy mcnlsy
#define sz mcnlsz
#define p mcnlp

#define mcabsorbComp mcabsorbCompchannel_15_cave1_cyl1
  STORE_NEUTRON(697,
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp);
  mcScattered=0;
  mcRestore=0;
  mcNCounter[697]++;
  mcPCounter[697] += p;
  mcP2Counter[697] += p*p;
#define mccompcurname  channel_15_cave1_cyl1
#define mccompcurtype  Union_cylinder
#define mccompcurindex 697
#define loop_index mccchannel_15_cave1_cyl1_loop_index
#define this_cylinder_volume mccchannel_15_cave1_cyl1_this_cylinder_volume
#define global_geometry_element mccchannel_15_cave1_cyl1_global_geometry_element
#define this_cylinder_storage mccchannel_15_cave1_cyl1_this_cylinder_storage
{   /* Declarations of channel_15_cave1_cyl1=Union_cylinder() SETTING parameters. */
char* material_string = mccchannel_15_cave1_cyl1_material_string;
MCNUM priority = mccchannel_15_cave1_cyl1_priority;
MCNUM radius = mccchannel_15_cave1_cyl1_radius;
MCNUM yheight = mccchannel_15_cave1_cyl1_yheight;
MCNUM visualize = mccchannel_15_cave1_cyl1_visualize;
int target_index = mccchannel_15_cave1_cyl1_target_index;
MCNUM target_x = mccchannel_15_cave1_cyl1_target_x;
MCNUM target_y = mccchannel_15_cave1_cyl1_target_y;
MCNUM target_z = mccchannel_15_cave1_cyl1_target_z;
MCNUM focus_aw = mccchannel_15_cave1_cyl1_focus_aw;
MCNUM focus_ah = mccchannel_15_cave1_cyl1_focus_ah;
MCNUM focus_xw = mccchannel_15_cave1_cyl1_focus_xw;
MCNUM focus_xh = mccchannel_15_cave1_cyl1_focus_xh;
MCNUM focus_r = mccchannel_15_cave1_cyl1_focus_r;
MCNUM p_interact = mccchannel_15_cave1_cyl1_p_interact;
char* mask_string = mccchannel_15_cave1_cyl1_mask_string;
char* mask_setting = mccchannel_15_cave1_cyl1_mask_setting;
MCNUM number_of_activations = mccchannel_15_cave1_cyl1_number_of_activations;
#line 345 "Union_cylinder.comp"
{
dummy = 1;
}
#line 437173 "MACS_sample_kidney_box.c"
}   /* End of channel_15_cave1_cyl1=Union_cylinder() SETTING parameter declarations. */
#undef this_cylinder_storage
#undef global_geometry_element
#undef this_cylinder_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex
  /* Label for restoring  neutron */
  mcabsorbCompchannel_15_cave1_cyl1:
  if (RESTORE) /* restore if needed */
  { RESTORE_NEUTRON(697,
      mcnlx,
      mcnly,
      mcnlz,
      mcnlvx,
      mcnlvy,
      mcnlvz,
      mcnlt,
      mcnlsx,
      mcnlsy,
      mcnlsz,
      mcnlp); }
#undef mcabsorbComp
#undef p
#undef sz
#undef sy
#undef sx
#undef t
#undef vz
#undef vy
#undef vx
#undef z
#undef y
#undef x
  mcDEBUG_STATE(
mcnlx,
mcnly,
mcnlz,
mcnlvx,
mcnlvy,
mcnlvz,
mcnlt,
mcnlsx,
mcnlsy,
mcnlsz,
mcnlp)

  /* TRACE Component channel_15_analyzer_1_center [698] */
  mccoordschange(mcposrchannel_15_analyzer_1_center, mcrotrchannel_15_analyzer_1_center,
    &mcnlx,
    &mcnly,
    &mcnlz,
    &mcnlvx,
    &mcnlvy,
    &mcnlvz,
    &mcnlsx,
    &mcnlsy,
    &mcnlsz);
  /* define label inside component channel_15_analyzer_1_center (without coords transformations) */
  mcJumpTrace_channel_15_analyzer_1_center:
  SIG_MESSAGE("channel_15_analyzer_1_center (Trace)");
  mcDEBUG_COMP("channel_15_analyzer_1_center")
  mcDEBUG_STATE(
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp)
#define x mcnlx
#define y mcnly
#define z mcnlz
#define vx mcnlvx
#define vy mcnlvy
#define vz mcnlvz
#define t mcnlt
#define sx mcnlsx
#define sy mcnlsy
#define sz mcnlsz
#define p mcnlp

#define mcabsorbComp mcabsorbCompchannel_15_analyzer_1_center
  STORE_NEUTRON(698,
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp);
  mcScattered=0;
  mcRestore=0;
  mcNCounter[698]++;
  mcPCounter[698] += p;
  mcP2Counter[698] += p*p;
#define mccompcurname  channel_15_analyzer_1_center
#define mccompcurtype  Arm
#define mccompcurindex 698
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex
  /* Label for restoring  neutron */
  mcabsorbCompchannel_15_analyzer_1_center:
  if (RESTORE) /* restore if needed */
  { RESTORE_NEUTRON(698,
      mcnlx,
      mcnly,
      mcnlz,
      mcnlvx,
      mcnlvy,
      mcnlvz,
      mcnlt,
      mcnlsx,
      mcnlsy,
      mcnlsz,
      mcnlp); }
#undef mcabsorbComp
#undef p
#undef sz
#undef sy
#undef sx
#undef t
#undef vz
#undef vy
#undef vx
#undef z
#undef y
#undef x
  mcDEBUG_STATE(
mcnlx,
mcnly,
mcnlz,
mcnlvx,
mcnlvy,
mcnlvz,
mcnlt,
mcnlsx,
mcnlsy,
mcnlsz,
mcnlp)

  /* TRACE Component channel_15_analyzer_1_rotated [699] */
  mccoordschange(mcposrchannel_15_analyzer_1_rotated, mcrotrchannel_15_analyzer_1_rotated,
    &mcnlx,
    &mcnly,
    &mcnlz,
    &mcnlvx,
    &mcnlvy,
    &mcnlvz,
    &mcnlsx,
    &mcnlsy,
    &mcnlsz);
  /* define label inside component channel_15_analyzer_1_rotated (without coords transformations) */
  mcJumpTrace_channel_15_analyzer_1_rotated:
  SIG_MESSAGE("channel_15_analyzer_1_rotated (Trace)");
  mcDEBUG_COMP("channel_15_analyzer_1_rotated")
  mcDEBUG_STATE(
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp)
#define x mcnlx
#define y mcnly
#define z mcnlz
#define vx mcnlvx
#define vy mcnlvy
#define vz mcnlvz
#define t mcnlt
#define sx mcnlsx
#define sy mcnlsy
#define sz mcnlsz
#define p mcnlp

#define mcabsorbComp mcabsorbCompchannel_15_analyzer_1_rotated
  STORE_NEUTRON(699,
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp);
  mcScattered=0;
  mcRestore=0;
  mcNCounter[699]++;
  mcPCounter[699] += p;
  mcP2Counter[699] += p*p;
#define mccompcurname  channel_15_analyzer_1_rotated
#define mccompcurtype  Arm
#define mccompcurindex 699
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex
  /* Label for restoring  neutron */
  mcabsorbCompchannel_15_analyzer_1_rotated:
  if (RESTORE) /* restore if needed */
  { RESTORE_NEUTRON(699,
      mcnlx,
      mcnly,
      mcnlz,
      mcnlvx,
      mcnlvy,
      mcnlvz,
      mcnlt,
      mcnlsx,
      mcnlsy,
      mcnlsz,
      mcnlp); }
#undef mcabsorbComp
#undef p
#undef sz
#undef sy
#undef sx
#undef t
#undef vz
#undef vy
#undef vx
#undef z
#undef y
#undef x
  mcDEBUG_STATE(
mcnlx,
mcnly,
mcnlz,
mcnlvx,
mcnlvy,
mcnlvz,
mcnlt,
mcnlsx,
mcnlsy,
mcnlsz,
mcnlp)

  /* TRACE Component channel_15_analyzer_1_array_crystal_array_0 [700] */
  mccoordschange(mcposrchannel_15_analyzer_1_array_crystal_array_0, mcrotrchannel_15_analyzer_1_array_crystal_array_0,
    &mcnlx,
    &mcnly,
    &mcnlz,
    &mcnlvx,
    &mcnlvy,
    &mcnlvz,
    &mcnlsx,
    &mcnlsy,
    &mcnlsz);
  /* define label inside component channel_15_analyzer_1_array_crystal_array_0 (without coords transformations) */
  mcJumpTrace_channel_15_analyzer_1_array_crystal_array_0:
  SIG_MESSAGE("channel_15_analyzer_1_array_crystal_array_0 (Trace)");
  mcDEBUG_COMP("channel_15_analyzer_1_array_crystal_array_0")
  mcDEBUG_STATE(
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp)
#define x mcnlx
#define y mcnly
#define z mcnlz
#define vx mcnlvx
#define vy mcnlvy
#define vz mcnlvz
#define t mcnlt
#define sx mcnlsx
#define sy mcnlsy
#define sz mcnlsz
#define p mcnlp

#define mcabsorbComp mcabsorbCompchannel_15_analyzer_1_array_crystal_array_0
  STORE_NEUTRON(700,
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp);
  mcScattered=0;
  mcRestore=0;
  mcNCounter[700]++;
  mcPCounter[700] += p;
  mcP2Counter[700] += p*p;
#define mccompcurname  channel_15_analyzer_1_array_crystal_array_0
#define mccompcurtype  Union_box
#define mccompcurindex 700
#define loop_index mccchannel_15_analyzer_1_array_crystal_array_0_loop_index
#define this_box_volume mccchannel_15_analyzer_1_array_crystal_array_0_this_box_volume
#define global_geometry_element mccchannel_15_analyzer_1_array_crystal_array_0_global_geometry_element
#define this_box_storage mccchannel_15_analyzer_1_array_crystal_array_0_this_box_storage
{   /* Declarations of channel_15_analyzer_1_array_crystal_array_0=Union_box() SETTING parameters. */
char* material_string = mccchannel_15_analyzer_1_array_crystal_array_0_material_string;
MCNUM priority = mccchannel_15_analyzer_1_array_crystal_array_0_priority;
MCNUM xwidth = mccchannel_15_analyzer_1_array_crystal_array_0_xwidth;
MCNUM yheight = mccchannel_15_analyzer_1_array_crystal_array_0_yheight;
MCNUM zdepth = mccchannel_15_analyzer_1_array_crystal_array_0_zdepth;
MCNUM xwidth2 = mccchannel_15_analyzer_1_array_crystal_array_0_xwidth2;
MCNUM yheight2 = mccchannel_15_analyzer_1_array_crystal_array_0_yheight2;
MCNUM visualize = mccchannel_15_analyzer_1_array_crystal_array_0_visualize;
int target_index = mccchannel_15_analyzer_1_array_crystal_array_0_target_index;
MCNUM target_x = mccchannel_15_analyzer_1_array_crystal_array_0_target_x;
MCNUM target_y = mccchannel_15_analyzer_1_array_crystal_array_0_target_y;
MCNUM target_z = mccchannel_15_analyzer_1_array_crystal_array_0_target_z;
MCNUM focus_aw = mccchannel_15_analyzer_1_array_crystal_array_0_focus_aw;
MCNUM focus_ah = mccchannel_15_analyzer_1_array_crystal_array_0_focus_ah;
MCNUM focus_xw = mccchannel_15_analyzer_1_array_crystal_array_0_focus_xw;
MCNUM focus_xh = mccchannel_15_analyzer_1_array_crystal_array_0_focus_xh;
MCNUM focus_r = mccchannel_15_analyzer_1_array_crystal_array_0_focus_r;
MCNUM p_interact = mccchannel_15_analyzer_1_array_crystal_array_0_p_interact;
char* mask_string = mccchannel_15_analyzer_1_array_crystal_array_0_mask_string;
char* mask_setting = mccchannel_15_analyzer_1_array_crystal_array_0_mask_setting;
MCNUM number_of_activations = mccchannel_15_analyzer_1_array_crystal_array_0_number_of_activations;
}   /* End of channel_15_analyzer_1_array_crystal_array_0=Union_box() SETTING parameter declarations. */
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex
  /* Label for restoring  neutron */
  mcabsorbCompchannel_15_analyzer_1_array_crystal_array_0:
  if (RESTORE) /* restore if needed */
  { RESTORE_NEUTRON(700,
      mcnlx,
      mcnly,
      mcnlz,
      mcnlvx,
      mcnlvy,
      mcnlvz,
      mcnlt,
      mcnlsx,
      mcnlsy,
      mcnlsz,
      mcnlp); }
#undef mcabsorbComp
#undef p
#undef sz
#undef sy
#undef sx
#undef t
#undef vz
#undef vy
#undef vx
#undef z
#undef y
#undef x
  mcDEBUG_STATE(
mcnlx,
mcnly,
mcnlz,
mcnlvx,
mcnlvy,
mcnlvz,
mcnlt,
mcnlsx,
mcnlsy,
mcnlsz,
mcnlp)

  /* TRACE Component channel_15_analyzer_1_array_crystal_array_1 [701] */
  mccoordschange(mcposrchannel_15_analyzer_1_array_crystal_array_1, mcrotrchannel_15_analyzer_1_array_crystal_array_1,
    &mcnlx,
    &mcnly,
    &mcnlz,
    &mcnlvx,
    &mcnlvy,
    &mcnlvz,
    &mcnlsx,
    &mcnlsy,
    &mcnlsz);
  /* define label inside component channel_15_analyzer_1_array_crystal_array_1 (without coords transformations) */
  mcJumpTrace_channel_15_analyzer_1_array_crystal_array_1:
  SIG_MESSAGE("channel_15_analyzer_1_array_crystal_array_1 (Trace)");
  mcDEBUG_COMP("channel_15_analyzer_1_array_crystal_array_1")
  mcDEBUG_STATE(
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp)
#define x mcnlx
#define y mcnly
#define z mcnlz
#define vx mcnlvx
#define vy mcnlvy
#define vz mcnlvz
#define t mcnlt
#define sx mcnlsx
#define sy mcnlsy
#define sz mcnlsz
#define p mcnlp

#define mcabsorbComp mcabsorbCompchannel_15_analyzer_1_array_crystal_array_1
  STORE_NEUTRON(701,
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp);
  mcScattered=0;
  mcRestore=0;
  mcNCounter[701]++;
  mcPCounter[701] += p;
  mcP2Counter[701] += p*p;
#define mccompcurname  channel_15_analyzer_1_array_crystal_array_1
#define mccompcurtype  Union_box
#define mccompcurindex 701
#define loop_index mccchannel_15_analyzer_1_array_crystal_array_1_loop_index
#define this_box_volume mccchannel_15_analyzer_1_array_crystal_array_1_this_box_volume
#define global_geometry_element mccchannel_15_analyzer_1_array_crystal_array_1_global_geometry_element
#define this_box_storage mccchannel_15_analyzer_1_array_crystal_array_1_this_box_storage
{   /* Declarations of channel_15_analyzer_1_array_crystal_array_1=Union_box() SETTING parameters. */
char* material_string = mccchannel_15_analyzer_1_array_crystal_array_1_material_string;
MCNUM priority = mccchannel_15_analyzer_1_array_crystal_array_1_priority;
MCNUM xwidth = mccchannel_15_analyzer_1_array_crystal_array_1_xwidth;
MCNUM yheight = mccchannel_15_analyzer_1_array_crystal_array_1_yheight;
MCNUM zdepth = mccchannel_15_analyzer_1_array_crystal_array_1_zdepth;
MCNUM xwidth2 = mccchannel_15_analyzer_1_array_crystal_array_1_xwidth2;
MCNUM yheight2 = mccchannel_15_analyzer_1_array_crystal_array_1_yheight2;
MCNUM visualize = mccchannel_15_analyzer_1_array_crystal_array_1_visualize;
int target_index = mccchannel_15_analyzer_1_array_crystal_array_1_target_index;
MCNUM target_x = mccchannel_15_analyzer_1_array_crystal_array_1_target_x;
MCNUM target_y = mccchannel_15_analyzer_1_array_crystal_array_1_target_y;
MCNUM target_z = mccchannel_15_analyzer_1_array_crystal_array_1_target_z;
MCNUM focus_aw = mccchannel_15_analyzer_1_array_crystal_array_1_focus_aw;
MCNUM focus_ah = mccchannel_15_analyzer_1_array_crystal_array_1_focus_ah;
MCNUM focus_xw = mccchannel_15_analyzer_1_array_crystal_array_1_focus_xw;
MCNUM focus_xh = mccchannel_15_analyzer_1_array_crystal_array_1_focus_xh;
MCNUM focus_r = mccchannel_15_analyzer_1_array_crystal_array_1_focus_r;
MCNUM p_interact = mccchannel_15_analyzer_1_array_crystal_array_1_p_interact;
char* mask_string = mccchannel_15_analyzer_1_array_crystal_array_1_mask_string;
char* mask_setting = mccchannel_15_analyzer_1_array_crystal_array_1_mask_setting;
MCNUM number_of_activations = mccchannel_15_analyzer_1_array_crystal_array_1_number_of_activations;
}   /* End of channel_15_analyzer_1_array_crystal_array_1=Union_box() SETTING parameter declarations. */
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex
  /* Label for restoring  neutron */
  mcabsorbCompchannel_15_analyzer_1_array_crystal_array_1:
  if (RESTORE) /* restore if needed */
  { RESTORE_NEUTRON(701,
      mcnlx,
      mcnly,
      mcnlz,
      mcnlvx,
      mcnlvy,
      mcnlvz,
      mcnlt,
      mcnlsx,
      mcnlsy,
      mcnlsz,
      mcnlp); }
#undef mcabsorbComp
#undef p
#undef sz
#undef sy
#undef sx
#undef t
#undef vz
#undef vy
#undef vx
#undef z
#undef y
#undef x
  mcDEBUG_STATE(
mcnlx,
mcnly,
mcnlz,
mcnlvx,
mcnlvy,
mcnlvz,
mcnlt,
mcnlsx,
mcnlsy,
mcnlsz,
mcnlp)

  /* TRACE Component channel_15_analyzer_1_array_crystal_array_2 [702] */
  mccoordschange(mcposrchannel_15_analyzer_1_array_crystal_array_2, mcrotrchannel_15_analyzer_1_array_crystal_array_2,
    &mcnlx,
    &mcnly,
    &mcnlz,
    &mcnlvx,
    &mcnlvy,
    &mcnlvz,
    &mcnlsx,
    &mcnlsy,
    &mcnlsz);
  /* define label inside component channel_15_analyzer_1_array_crystal_array_2 (without coords transformations) */
  mcJumpTrace_channel_15_analyzer_1_array_crystal_array_2:
  SIG_MESSAGE("channel_15_analyzer_1_array_crystal_array_2 (Trace)");
  mcDEBUG_COMP("channel_15_analyzer_1_array_crystal_array_2")
  mcDEBUG_STATE(
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp)
#define x mcnlx
#define y mcnly
#define z mcnlz
#define vx mcnlvx
#define vy mcnlvy
#define vz mcnlvz
#define t mcnlt
#define sx mcnlsx
#define sy mcnlsy
#define sz mcnlsz
#define p mcnlp

#define mcabsorbComp mcabsorbCompchannel_15_analyzer_1_array_crystal_array_2
  STORE_NEUTRON(702,
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp);
  mcScattered=0;
  mcRestore=0;
  mcNCounter[702]++;
  mcPCounter[702] += p;
  mcP2Counter[702] += p*p;
#define mccompcurname  channel_15_analyzer_1_array_crystal_array_2
#define mccompcurtype  Union_box
#define mccompcurindex 702
#define loop_index mccchannel_15_analyzer_1_array_crystal_array_2_loop_index
#define this_box_volume mccchannel_15_analyzer_1_array_crystal_array_2_this_box_volume
#define global_geometry_element mccchannel_15_analyzer_1_array_crystal_array_2_global_geometry_element
#define this_box_storage mccchannel_15_analyzer_1_array_crystal_array_2_this_box_storage
{   /* Declarations of channel_15_analyzer_1_array_crystal_array_2=Union_box() SETTING parameters. */
char* material_string = mccchannel_15_analyzer_1_array_crystal_array_2_material_string;
MCNUM priority = mccchannel_15_analyzer_1_array_crystal_array_2_priority;
MCNUM xwidth = mccchannel_15_analyzer_1_array_crystal_array_2_xwidth;
MCNUM yheight = mccchannel_15_analyzer_1_array_crystal_array_2_yheight;
MCNUM zdepth = mccchannel_15_analyzer_1_array_crystal_array_2_zdepth;
MCNUM xwidth2 = mccchannel_15_analyzer_1_array_crystal_array_2_xwidth2;
MCNUM yheight2 = mccchannel_15_analyzer_1_array_crystal_array_2_yheight2;
MCNUM visualize = mccchannel_15_analyzer_1_array_crystal_array_2_visualize;
int target_index = mccchannel_15_analyzer_1_array_crystal_array_2_target_index;
MCNUM target_x = mccchannel_15_analyzer_1_array_crystal_array_2_target_x;
MCNUM target_y = mccchannel_15_analyzer_1_array_crystal_array_2_target_y;
MCNUM target_z = mccchannel_15_analyzer_1_array_crystal_array_2_target_z;
MCNUM focus_aw = mccchannel_15_analyzer_1_array_crystal_array_2_focus_aw;
MCNUM focus_ah = mccchannel_15_analyzer_1_array_crystal_array_2_focus_ah;
MCNUM focus_xw = mccchannel_15_analyzer_1_array_crystal_array_2_focus_xw;
MCNUM focus_xh = mccchannel_15_analyzer_1_array_crystal_array_2_focus_xh;
MCNUM focus_r = mccchannel_15_analyzer_1_array_crystal_array_2_focus_r;
MCNUM p_interact = mccchannel_15_analyzer_1_array_crystal_array_2_p_interact;
char* mask_string = mccchannel_15_analyzer_1_array_crystal_array_2_mask_string;
char* mask_setting = mccchannel_15_analyzer_1_array_crystal_array_2_mask_setting;
MCNUM number_of_activations = mccchannel_15_analyzer_1_array_crystal_array_2_number_of_activations;
}   /* End of channel_15_analyzer_1_array_crystal_array_2=Union_box() SETTING parameter declarations. */
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex
  /* Label for restoring  neutron */
  mcabsorbCompchannel_15_analyzer_1_array_crystal_array_2:
  if (RESTORE) /* restore if needed */
  { RESTORE_NEUTRON(702,
      mcnlx,
      mcnly,
      mcnlz,
      mcnlvx,
      mcnlvy,
      mcnlvz,
      mcnlt,
      mcnlsx,
      mcnlsy,
      mcnlsz,
      mcnlp); }
#undef mcabsorbComp
#undef p
#undef sz
#undef sy
#undef sx
#undef t
#undef vz
#undef vy
#undef vx
#undef z
#undef y
#undef x
  mcDEBUG_STATE(
mcnlx,
mcnly,
mcnlz,
mcnlvx,
mcnlvy,
mcnlvz,
mcnlt,
mcnlsx,
mcnlsy,
mcnlsz,
mcnlp)

  /* TRACE Component channel_15_analyzer_1_array_crystal_array_3 [703] */
  mccoordschange(mcposrchannel_15_analyzer_1_array_crystal_array_3, mcrotrchannel_15_analyzer_1_array_crystal_array_3,
    &mcnlx,
    &mcnly,
    &mcnlz,
    &mcnlvx,
    &mcnlvy,
    &mcnlvz,
    &mcnlsx,
    &mcnlsy,
    &mcnlsz);
  /* define label inside component channel_15_analyzer_1_array_crystal_array_3 (without coords transformations) */
  mcJumpTrace_channel_15_analyzer_1_array_crystal_array_3:
  SIG_MESSAGE("channel_15_analyzer_1_array_crystal_array_3 (Trace)");
  mcDEBUG_COMP("channel_15_analyzer_1_array_crystal_array_3")
  mcDEBUG_STATE(
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp)
#define x mcnlx
#define y mcnly
#define z mcnlz
#define vx mcnlvx
#define vy mcnlvy
#define vz mcnlvz
#define t mcnlt
#define sx mcnlsx
#define sy mcnlsy
#define sz mcnlsz
#define p mcnlp

#define mcabsorbComp mcabsorbCompchannel_15_analyzer_1_array_crystal_array_3
  STORE_NEUTRON(703,
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp);
  mcScattered=0;
  mcRestore=0;
  mcNCounter[703]++;
  mcPCounter[703] += p;
  mcP2Counter[703] += p*p;
#define mccompcurname  channel_15_analyzer_1_array_crystal_array_3
#define mccompcurtype  Union_box
#define mccompcurindex 703
#define loop_index mccchannel_15_analyzer_1_array_crystal_array_3_loop_index
#define this_box_volume mccchannel_15_analyzer_1_array_crystal_array_3_this_box_volume
#define global_geometry_element mccchannel_15_analyzer_1_array_crystal_array_3_global_geometry_element
#define this_box_storage mccchannel_15_analyzer_1_array_crystal_array_3_this_box_storage
{   /* Declarations of channel_15_analyzer_1_array_crystal_array_3=Union_box() SETTING parameters. */
char* material_string = mccchannel_15_analyzer_1_array_crystal_array_3_material_string;
MCNUM priority = mccchannel_15_analyzer_1_array_crystal_array_3_priority;
MCNUM xwidth = mccchannel_15_analyzer_1_array_crystal_array_3_xwidth;
MCNUM yheight = mccchannel_15_analyzer_1_array_crystal_array_3_yheight;
MCNUM zdepth = mccchannel_15_analyzer_1_array_crystal_array_3_zdepth;
MCNUM xwidth2 = mccchannel_15_analyzer_1_array_crystal_array_3_xwidth2;
MCNUM yheight2 = mccchannel_15_analyzer_1_array_crystal_array_3_yheight2;
MCNUM visualize = mccchannel_15_analyzer_1_array_crystal_array_3_visualize;
int target_index = mccchannel_15_analyzer_1_array_crystal_array_3_target_index;
MCNUM target_x = mccchannel_15_analyzer_1_array_crystal_array_3_target_x;
MCNUM target_y = mccchannel_15_analyzer_1_array_crystal_array_3_target_y;
MCNUM target_z = mccchannel_15_analyzer_1_array_crystal_array_3_target_z;
MCNUM focus_aw = mccchannel_15_analyzer_1_array_crystal_array_3_focus_aw;
MCNUM focus_ah = mccchannel_15_analyzer_1_array_crystal_array_3_focus_ah;
MCNUM focus_xw = mccchannel_15_analyzer_1_array_crystal_array_3_focus_xw;
MCNUM focus_xh = mccchannel_15_analyzer_1_array_crystal_array_3_focus_xh;
MCNUM focus_r = mccchannel_15_analyzer_1_array_crystal_array_3_focus_r;
MCNUM p_interact = mccchannel_15_analyzer_1_array_crystal_array_3_p_interact;
char* mask_string = mccchannel_15_analyzer_1_array_crystal_array_3_mask_string;
char* mask_setting = mccchannel_15_analyzer_1_array_crystal_array_3_mask_setting;
MCNUM number_of_activations = mccchannel_15_analyzer_1_array_crystal_array_3_number_of_activations;
}   /* End of channel_15_analyzer_1_array_crystal_array_3=Union_box() SETTING parameter declarations. */
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex
  /* Label for restoring  neutron */
  mcabsorbCompchannel_15_analyzer_1_array_crystal_array_3:
  if (RESTORE) /* restore if needed */
  { RESTORE_NEUTRON(703,
      mcnlx,
      mcnly,
      mcnlz,
      mcnlvx,
      mcnlvy,
      mcnlvz,
      mcnlt,
      mcnlsx,
      mcnlsy,
      mcnlsz,
      mcnlp); }
#undef mcabsorbComp
#undef p
#undef sz
#undef sy
#undef sx
#undef t
#undef vz
#undef vy
#undef vx
#undef z
#undef y
#undef x
  mcDEBUG_STATE(
mcnlx,
mcnly,
mcnlz,
mcnlvx,
mcnlvy,
mcnlvz,
mcnlt,
mcnlsx,
mcnlsy,
mcnlsz,
mcnlp)

  /* TRACE Component channel_15_analyzer_1_array_crystal_array_4 [704] */
  mccoordschange(mcposrchannel_15_analyzer_1_array_crystal_array_4, mcrotrchannel_15_analyzer_1_array_crystal_array_4,
    &mcnlx,
    &mcnly,
    &mcnlz,
    &mcnlvx,
    &mcnlvy,
    &mcnlvz,
    &mcnlsx,
    &mcnlsy,
    &mcnlsz);
  /* define label inside component channel_15_analyzer_1_array_crystal_array_4 (without coords transformations) */
  mcJumpTrace_channel_15_analyzer_1_array_crystal_array_4:
  SIG_MESSAGE("channel_15_analyzer_1_array_crystal_array_4 (Trace)");
  mcDEBUG_COMP("channel_15_analyzer_1_array_crystal_array_4")
  mcDEBUG_STATE(
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp)
#define x mcnlx
#define y mcnly
#define z mcnlz
#define vx mcnlvx
#define vy mcnlvy
#define vz mcnlvz
#define t mcnlt
#define sx mcnlsx
#define sy mcnlsy
#define sz mcnlsz
#define p mcnlp

#define mcabsorbComp mcabsorbCompchannel_15_analyzer_1_array_crystal_array_4
  STORE_NEUTRON(704,
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp);
  mcScattered=0;
  mcRestore=0;
  mcNCounter[704]++;
  mcPCounter[704] += p;
  mcP2Counter[704] += p*p;
#define mccompcurname  channel_15_analyzer_1_array_crystal_array_4
#define mccompcurtype  Union_box
#define mccompcurindex 704
#define loop_index mccchannel_15_analyzer_1_array_crystal_array_4_loop_index
#define this_box_volume mccchannel_15_analyzer_1_array_crystal_array_4_this_box_volume
#define global_geometry_element mccchannel_15_analyzer_1_array_crystal_array_4_global_geometry_element
#define this_box_storage mccchannel_15_analyzer_1_array_crystal_array_4_this_box_storage
{   /* Declarations of channel_15_analyzer_1_array_crystal_array_4=Union_box() SETTING parameters. */
char* material_string = mccchannel_15_analyzer_1_array_crystal_array_4_material_string;
MCNUM priority = mccchannel_15_analyzer_1_array_crystal_array_4_priority;
MCNUM xwidth = mccchannel_15_analyzer_1_array_crystal_array_4_xwidth;
MCNUM yheight = mccchannel_15_analyzer_1_array_crystal_array_4_yheight;
MCNUM zdepth = mccchannel_15_analyzer_1_array_crystal_array_4_zdepth;
MCNUM xwidth2 = mccchannel_15_analyzer_1_array_crystal_array_4_xwidth2;
MCNUM yheight2 = mccchannel_15_analyzer_1_array_crystal_array_4_yheight2;
MCNUM visualize = mccchannel_15_analyzer_1_array_crystal_array_4_visualize;
int target_index = mccchannel_15_analyzer_1_array_crystal_array_4_target_index;
MCNUM target_x = mccchannel_15_analyzer_1_array_crystal_array_4_target_x;
MCNUM target_y = mccchannel_15_analyzer_1_array_crystal_array_4_target_y;
MCNUM target_z = mccchannel_15_analyzer_1_array_crystal_array_4_target_z;
MCNUM focus_aw = mccchannel_15_analyzer_1_array_crystal_array_4_focus_aw;
MCNUM focus_ah = mccchannel_15_analyzer_1_array_crystal_array_4_focus_ah;
MCNUM focus_xw = mccchannel_15_analyzer_1_array_crystal_array_4_focus_xw;
MCNUM focus_xh = mccchannel_15_analyzer_1_array_crystal_array_4_focus_xh;
MCNUM focus_r = mccchannel_15_analyzer_1_array_crystal_array_4_focus_r;
MCNUM p_interact = mccchannel_15_analyzer_1_array_crystal_array_4_p_interact;
char* mask_string = mccchannel_15_analyzer_1_array_crystal_array_4_mask_string;
char* mask_setting = mccchannel_15_analyzer_1_array_crystal_array_4_mask_setting;
MCNUM number_of_activations = mccchannel_15_analyzer_1_array_crystal_array_4_number_of_activations;
}   /* End of channel_15_analyzer_1_array_crystal_array_4=Union_box() SETTING parameter declarations. */
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex
  /* Label for restoring  neutron */
  mcabsorbCompchannel_15_analyzer_1_array_crystal_array_4:
  if (RESTORE) /* restore if needed */
  { RESTORE_NEUTRON(704,
      mcnlx,
      mcnly,
      mcnlz,
      mcnlvx,
      mcnlvy,
      mcnlvz,
      mcnlt,
      mcnlsx,
      mcnlsy,
      mcnlsz,
      mcnlp); }
#undef mcabsorbComp
#undef p
#undef sz
#undef sy
#undef sx
#undef t
#undef vz
#undef vy
#undef vx
#undef z
#undef y
#undef x
  mcDEBUG_STATE(
mcnlx,
mcnly,
mcnlz,
mcnlvx,
mcnlvy,
mcnlvz,
mcnlt,
mcnlsx,
mcnlsy,
mcnlsz,
mcnlp)

  /* TRACE Component channel_15_analyzer_1_array_crystal_array_5 [705] */
  mccoordschange(mcposrchannel_15_analyzer_1_array_crystal_array_5, mcrotrchannel_15_analyzer_1_array_crystal_array_5,
    &mcnlx,
    &mcnly,
    &mcnlz,
    &mcnlvx,
    &mcnlvy,
    &mcnlvz,
    &mcnlsx,
    &mcnlsy,
    &mcnlsz);
  /* define label inside component channel_15_analyzer_1_array_crystal_array_5 (without coords transformations) */
  mcJumpTrace_channel_15_analyzer_1_array_crystal_array_5:
  SIG_MESSAGE("channel_15_analyzer_1_array_crystal_array_5 (Trace)");
  mcDEBUG_COMP("channel_15_analyzer_1_array_crystal_array_5")
  mcDEBUG_STATE(
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp)
#define x mcnlx
#define y mcnly
#define z mcnlz
#define vx mcnlvx
#define vy mcnlvy
#define vz mcnlvz
#define t mcnlt
#define sx mcnlsx
#define sy mcnlsy
#define sz mcnlsz
#define p mcnlp

#define mcabsorbComp mcabsorbCompchannel_15_analyzer_1_array_crystal_array_5
  STORE_NEUTRON(705,
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp);
  mcScattered=0;
  mcRestore=0;
  mcNCounter[705]++;
  mcPCounter[705] += p;
  mcP2Counter[705] += p*p;
#define mccompcurname  channel_15_analyzer_1_array_crystal_array_5
#define mccompcurtype  Union_box
#define mccompcurindex 705
#define loop_index mccchannel_15_analyzer_1_array_crystal_array_5_loop_index
#define this_box_volume mccchannel_15_analyzer_1_array_crystal_array_5_this_box_volume
#define global_geometry_element mccchannel_15_analyzer_1_array_crystal_array_5_global_geometry_element
#define this_box_storage mccchannel_15_analyzer_1_array_crystal_array_5_this_box_storage
{   /* Declarations of channel_15_analyzer_1_array_crystal_array_5=Union_box() SETTING parameters. */
char* material_string = mccchannel_15_analyzer_1_array_crystal_array_5_material_string;
MCNUM priority = mccchannel_15_analyzer_1_array_crystal_array_5_priority;
MCNUM xwidth = mccchannel_15_analyzer_1_array_crystal_array_5_xwidth;
MCNUM yheight = mccchannel_15_analyzer_1_array_crystal_array_5_yheight;
MCNUM zdepth = mccchannel_15_analyzer_1_array_crystal_array_5_zdepth;
MCNUM xwidth2 = mccchannel_15_analyzer_1_array_crystal_array_5_xwidth2;
MCNUM yheight2 = mccchannel_15_analyzer_1_array_crystal_array_5_yheight2;
MCNUM visualize = mccchannel_15_analyzer_1_array_crystal_array_5_visualize;
int target_index = mccchannel_15_analyzer_1_array_crystal_array_5_target_index;
MCNUM target_x = mccchannel_15_analyzer_1_array_crystal_array_5_target_x;
MCNUM target_y = mccchannel_15_analyzer_1_array_crystal_array_5_target_y;
MCNUM target_z = mccchannel_15_analyzer_1_array_crystal_array_5_target_z;
MCNUM focus_aw = mccchannel_15_analyzer_1_array_crystal_array_5_focus_aw;
MCNUM focus_ah = mccchannel_15_analyzer_1_array_crystal_array_5_focus_ah;
MCNUM focus_xw = mccchannel_15_analyzer_1_array_crystal_array_5_focus_xw;
MCNUM focus_xh = mccchannel_15_analyzer_1_array_crystal_array_5_focus_xh;
MCNUM focus_r = mccchannel_15_analyzer_1_array_crystal_array_5_focus_r;
MCNUM p_interact = mccchannel_15_analyzer_1_array_crystal_array_5_p_interact;
char* mask_string = mccchannel_15_analyzer_1_array_crystal_array_5_mask_string;
char* mask_setting = mccchannel_15_analyzer_1_array_crystal_array_5_mask_setting;
MCNUM number_of_activations = mccchannel_15_analyzer_1_array_crystal_array_5_number_of_activations;
}   /* End of channel_15_analyzer_1_array_crystal_array_5=Union_box() SETTING parameter declarations. */
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex
  /* Label for restoring  neutron */
  mcabsorbCompchannel_15_analyzer_1_array_crystal_array_5:
  if (RESTORE) /* restore if needed */
  { RESTORE_NEUTRON(705,
      mcnlx,
      mcnly,
      mcnlz,
      mcnlvx,
      mcnlvy,
      mcnlvz,
      mcnlt,
      mcnlsx,
      mcnlsy,
      mcnlsz,
      mcnlp); }
#undef mcabsorbComp
#undef p
#undef sz
#undef sy
#undef sx
#undef t
#undef vz
#undef vy
#undef vx
#undef z
#undef y
#undef x
  mcDEBUG_STATE(
mcnlx,
mcnly,
mcnlz,
mcnlvx,
mcnlvy,
mcnlvz,
mcnlt,
mcnlsx,
mcnlsy,
mcnlsz,
mcnlp)

  /* TRACE Component channel_15_analyzer_1_array_crystal_array_6 [706] */
  mccoordschange(mcposrchannel_15_analyzer_1_array_crystal_array_6, mcrotrchannel_15_analyzer_1_array_crystal_array_6,
    &mcnlx,
    &mcnly,
    &mcnlz,
    &mcnlvx,
    &mcnlvy,
    &mcnlvz,
    &mcnlsx,
    &mcnlsy,
    &mcnlsz);
  /* define label inside component channel_15_analyzer_1_array_crystal_array_6 (without coords transformations) */
  mcJumpTrace_channel_15_analyzer_1_array_crystal_array_6:
  SIG_MESSAGE("channel_15_analyzer_1_array_crystal_array_6 (Trace)");
  mcDEBUG_COMP("channel_15_analyzer_1_array_crystal_array_6")
  mcDEBUG_STATE(
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp)
#define x mcnlx
#define y mcnly
#define z mcnlz
#define vx mcnlvx
#define vy mcnlvy
#define vz mcnlvz
#define t mcnlt
#define sx mcnlsx
#define sy mcnlsy
#define sz mcnlsz
#define p mcnlp

#define mcabsorbComp mcabsorbCompchannel_15_analyzer_1_array_crystal_array_6
  STORE_NEUTRON(706,
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp);
  mcScattered=0;
  mcRestore=0;
  mcNCounter[706]++;
  mcPCounter[706] += p;
  mcP2Counter[706] += p*p;
#define mccompcurname  channel_15_analyzer_1_array_crystal_array_6
#define mccompcurtype  Union_box
#define mccompcurindex 706
#define loop_index mccchannel_15_analyzer_1_array_crystal_array_6_loop_index
#define this_box_volume mccchannel_15_analyzer_1_array_crystal_array_6_this_box_volume
#define global_geometry_element mccchannel_15_analyzer_1_array_crystal_array_6_global_geometry_element
#define this_box_storage mccchannel_15_analyzer_1_array_crystal_array_6_this_box_storage
{   /* Declarations of channel_15_analyzer_1_array_crystal_array_6=Union_box() SETTING parameters. */
char* material_string = mccchannel_15_analyzer_1_array_crystal_array_6_material_string;
MCNUM priority = mccchannel_15_analyzer_1_array_crystal_array_6_priority;
MCNUM xwidth = mccchannel_15_analyzer_1_array_crystal_array_6_xwidth;
MCNUM yheight = mccchannel_15_analyzer_1_array_crystal_array_6_yheight;
MCNUM zdepth = mccchannel_15_analyzer_1_array_crystal_array_6_zdepth;
MCNUM xwidth2 = mccchannel_15_analyzer_1_array_crystal_array_6_xwidth2;
MCNUM yheight2 = mccchannel_15_analyzer_1_array_crystal_array_6_yheight2;
MCNUM visualize = mccchannel_15_analyzer_1_array_crystal_array_6_visualize;
int target_index = mccchannel_15_analyzer_1_array_crystal_array_6_target_index;
MCNUM target_x = mccchannel_15_analyzer_1_array_crystal_array_6_target_x;
MCNUM target_y = mccchannel_15_analyzer_1_array_crystal_array_6_target_y;
MCNUM target_z = mccchannel_15_analyzer_1_array_crystal_array_6_target_z;
MCNUM focus_aw = mccchannel_15_analyzer_1_array_crystal_array_6_focus_aw;
MCNUM focus_ah = mccchannel_15_analyzer_1_array_crystal_array_6_focus_ah;
MCNUM focus_xw = mccchannel_15_analyzer_1_array_crystal_array_6_focus_xw;
MCNUM focus_xh = mccchannel_15_analyzer_1_array_crystal_array_6_focus_xh;
MCNUM focus_r = mccchannel_15_analyzer_1_array_crystal_array_6_focus_r;
MCNUM p_interact = mccchannel_15_analyzer_1_array_crystal_array_6_p_interact;
char* mask_string = mccchannel_15_analyzer_1_array_crystal_array_6_mask_string;
char* mask_setting = mccchannel_15_analyzer_1_array_crystal_array_6_mask_setting;
MCNUM number_of_activations = mccchannel_15_analyzer_1_array_crystal_array_6_number_of_activations;
}   /* End of channel_15_analyzer_1_array_crystal_array_6=Union_box() SETTING parameter declarations. */
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex
  /* Label for restoring  neutron */
  mcabsorbCompchannel_15_analyzer_1_array_crystal_array_6:
  if (RESTORE) /* restore if needed */
  { RESTORE_NEUTRON(706,
      mcnlx,
      mcnly,
      mcnlz,
      mcnlvx,
      mcnlvy,
      mcnlvz,
      mcnlt,
      mcnlsx,
      mcnlsy,
      mcnlsz,
      mcnlp); }
#undef mcabsorbComp
#undef p
#undef sz
#undef sy
#undef sx
#undef t
#undef vz
#undef vy
#undef vx
#undef z
#undef y
#undef x
  mcDEBUG_STATE(
mcnlx,
mcnly,
mcnlz,
mcnlvx,
mcnlvy,
mcnlvz,
mcnlt,
mcnlsx,
mcnlsy,
mcnlsz,
mcnlp)

  /* TRACE Component channel_15_analyzer_1_array_crystal_array_7 [707] */
  mccoordschange(mcposrchannel_15_analyzer_1_array_crystal_array_7, mcrotrchannel_15_analyzer_1_array_crystal_array_7,
    &mcnlx,
    &mcnly,
    &mcnlz,
    &mcnlvx,
    &mcnlvy,
    &mcnlvz,
    &mcnlsx,
    &mcnlsy,
    &mcnlsz);
  /* define label inside component channel_15_analyzer_1_array_crystal_array_7 (without coords transformations) */
  mcJumpTrace_channel_15_analyzer_1_array_crystal_array_7:
  SIG_MESSAGE("channel_15_analyzer_1_array_crystal_array_7 (Trace)");
  mcDEBUG_COMP("channel_15_analyzer_1_array_crystal_array_7")
  mcDEBUG_STATE(
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp)
#define x mcnlx
#define y mcnly
#define z mcnlz
#define vx mcnlvx
#define vy mcnlvy
#define vz mcnlvz
#define t mcnlt
#define sx mcnlsx
#define sy mcnlsy
#define sz mcnlsz
#define p mcnlp

#define mcabsorbComp mcabsorbCompchannel_15_analyzer_1_array_crystal_array_7
  STORE_NEUTRON(707,
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp);
  mcScattered=0;
  mcRestore=0;
  mcNCounter[707]++;
  mcPCounter[707] += p;
  mcP2Counter[707] += p*p;
#define mccompcurname  channel_15_analyzer_1_array_crystal_array_7
#define mccompcurtype  Union_box
#define mccompcurindex 707
#define loop_index mccchannel_15_analyzer_1_array_crystal_array_7_loop_index
#define this_box_volume mccchannel_15_analyzer_1_array_crystal_array_7_this_box_volume
#define global_geometry_element mccchannel_15_analyzer_1_array_crystal_array_7_global_geometry_element
#define this_box_storage mccchannel_15_analyzer_1_array_crystal_array_7_this_box_storage
{   /* Declarations of channel_15_analyzer_1_array_crystal_array_7=Union_box() SETTING parameters. */
char* material_string = mccchannel_15_analyzer_1_array_crystal_array_7_material_string;
MCNUM priority = mccchannel_15_analyzer_1_array_crystal_array_7_priority;
MCNUM xwidth = mccchannel_15_analyzer_1_array_crystal_array_7_xwidth;
MCNUM yheight = mccchannel_15_analyzer_1_array_crystal_array_7_yheight;
MCNUM zdepth = mccchannel_15_analyzer_1_array_crystal_array_7_zdepth;
MCNUM xwidth2 = mccchannel_15_analyzer_1_array_crystal_array_7_xwidth2;
MCNUM yheight2 = mccchannel_15_analyzer_1_array_crystal_array_7_yheight2;
MCNUM visualize = mccchannel_15_analyzer_1_array_crystal_array_7_visualize;
int target_index = mccchannel_15_analyzer_1_array_crystal_array_7_target_index;
MCNUM target_x = mccchannel_15_analyzer_1_array_crystal_array_7_target_x;
MCNUM target_y = mccchannel_15_analyzer_1_array_crystal_array_7_target_y;
MCNUM target_z = mccchannel_15_analyzer_1_array_crystal_array_7_target_z;
MCNUM focus_aw = mccchannel_15_analyzer_1_array_crystal_array_7_focus_aw;
MCNUM focus_ah = mccchannel_15_analyzer_1_array_crystal_array_7_focus_ah;
MCNUM focus_xw = mccchannel_15_analyzer_1_array_crystal_array_7_focus_xw;
MCNUM focus_xh = mccchannel_15_analyzer_1_array_crystal_array_7_focus_xh;
MCNUM focus_r = mccchannel_15_analyzer_1_array_crystal_array_7_focus_r;
MCNUM p_interact = mccchannel_15_analyzer_1_array_crystal_array_7_p_interact;
char* mask_string = mccchannel_15_analyzer_1_array_crystal_array_7_mask_string;
char* mask_setting = mccchannel_15_analyzer_1_array_crystal_array_7_mask_setting;
MCNUM number_of_activations = mccchannel_15_analyzer_1_array_crystal_array_7_number_of_activations;
}   /* End of channel_15_analyzer_1_array_crystal_array_7=Union_box() SETTING parameter declarations. */
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex
  /* Label for restoring  neutron */
  mcabsorbCompchannel_15_analyzer_1_array_crystal_array_7:
  if (RESTORE) /* restore if needed */
  { RESTORE_NEUTRON(707,
      mcnlx,
      mcnly,
      mcnlz,
      mcnlvx,
      mcnlvy,
      mcnlvz,
      mcnlt,
      mcnlsx,
      mcnlsy,
      mcnlsz,
      mcnlp); }
#undef mcabsorbComp
#undef p
#undef sz
#undef sy
#undef sx
#undef t
#undef vz
#undef vy
#undef vx
#undef z
#undef y
#undef x
  mcDEBUG_STATE(
mcnlx,
mcnly,
mcnlz,
mcnlvx,
mcnlvy,
mcnlvz,
mcnlt,
mcnlsx,
mcnlsy,
mcnlsz,
mcnlp)

  /* TRACE Component channel_15_analyzer_1_array_crystal_array_8 [708] */
  mccoordschange(mcposrchannel_15_analyzer_1_array_crystal_array_8, mcrotrchannel_15_analyzer_1_array_crystal_array_8,
    &mcnlx,
    &mcnly,
    &mcnlz,
    &mcnlvx,
    &mcnlvy,
    &mcnlvz,
    &mcnlsx,
    &mcnlsy,
    &mcnlsz);
  /* define label inside component channel_15_analyzer_1_array_crystal_array_8 (without coords transformations) */
  mcJumpTrace_channel_15_analyzer_1_array_crystal_array_8:
  SIG_MESSAGE("channel_15_analyzer_1_array_crystal_array_8 (Trace)");
  mcDEBUG_COMP("channel_15_analyzer_1_array_crystal_array_8")
  mcDEBUG_STATE(
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp)
#define x mcnlx
#define y mcnly
#define z mcnlz
#define vx mcnlvx
#define vy mcnlvy
#define vz mcnlvz
#define t mcnlt
#define sx mcnlsx
#define sy mcnlsy
#define sz mcnlsz
#define p mcnlp

#define mcabsorbComp mcabsorbCompchannel_15_analyzer_1_array_crystal_array_8
  STORE_NEUTRON(708,
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp);
  mcScattered=0;
  mcRestore=0;
  mcNCounter[708]++;
  mcPCounter[708] += p;
  mcP2Counter[708] += p*p;
#define mccompcurname  channel_15_analyzer_1_array_crystal_array_8
#define mccompcurtype  Union_box
#define mccompcurindex 708
#define loop_index mccchannel_15_analyzer_1_array_crystal_array_8_loop_index
#define this_box_volume mccchannel_15_analyzer_1_array_crystal_array_8_this_box_volume
#define global_geometry_element mccchannel_15_analyzer_1_array_crystal_array_8_global_geometry_element
#define this_box_storage mccchannel_15_analyzer_1_array_crystal_array_8_this_box_storage
{   /* Declarations of channel_15_analyzer_1_array_crystal_array_8=Union_box() SETTING parameters. */
char* material_string = mccchannel_15_analyzer_1_array_crystal_array_8_material_string;
MCNUM priority = mccchannel_15_analyzer_1_array_crystal_array_8_priority;
MCNUM xwidth = mccchannel_15_analyzer_1_array_crystal_array_8_xwidth;
MCNUM yheight = mccchannel_15_analyzer_1_array_crystal_array_8_yheight;
MCNUM zdepth = mccchannel_15_analyzer_1_array_crystal_array_8_zdepth;
MCNUM xwidth2 = mccchannel_15_analyzer_1_array_crystal_array_8_xwidth2;
MCNUM yheight2 = mccchannel_15_analyzer_1_array_crystal_array_8_yheight2;
MCNUM visualize = mccchannel_15_analyzer_1_array_crystal_array_8_visualize;
int target_index = mccchannel_15_analyzer_1_array_crystal_array_8_target_index;
MCNUM target_x = mccchannel_15_analyzer_1_array_crystal_array_8_target_x;
MCNUM target_y = mccchannel_15_analyzer_1_array_crystal_array_8_target_y;
MCNUM target_z = mccchannel_15_analyzer_1_array_crystal_array_8_target_z;
MCNUM focus_aw = mccchannel_15_analyzer_1_array_crystal_array_8_focus_aw;
MCNUM focus_ah = mccchannel_15_analyzer_1_array_crystal_array_8_focus_ah;
MCNUM focus_xw = mccchannel_15_analyzer_1_array_crystal_array_8_focus_xw;
MCNUM focus_xh = mccchannel_15_analyzer_1_array_crystal_array_8_focus_xh;
MCNUM focus_r = mccchannel_15_analyzer_1_array_crystal_array_8_focus_r;
MCNUM p_interact = mccchannel_15_analyzer_1_array_crystal_array_8_p_interact;
char* mask_string = mccchannel_15_analyzer_1_array_crystal_array_8_mask_string;
char* mask_setting = mccchannel_15_analyzer_1_array_crystal_array_8_mask_setting;
MCNUM number_of_activations = mccchannel_15_analyzer_1_array_crystal_array_8_number_of_activations;
}   /* End of channel_15_analyzer_1_array_crystal_array_8=Union_box() SETTING parameter declarations. */
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex
  /* Label for restoring  neutron */
  mcabsorbCompchannel_15_analyzer_1_array_crystal_array_8:
  if (RESTORE) /* restore if needed */
  { RESTORE_NEUTRON(708,
      mcnlx,
      mcnly,
      mcnlz,
      mcnlvx,
      mcnlvy,
      mcnlvz,
      mcnlt,
      mcnlsx,
      mcnlsy,
      mcnlsz,
      mcnlp); }
#undef mcabsorbComp
#undef p
#undef sz
#undef sy
#undef sx
#undef t
#undef vz
#undef vy
#undef vx
#undef z
#undef y
#undef x
  mcDEBUG_STATE(
mcnlx,
mcnly,
mcnlz,
mcnlvx,
mcnlvy,
mcnlvz,
mcnlt,
mcnlsx,
mcnlsy,
mcnlsz,
mcnlp)

  /* TRACE Component channel_15_analyzer_2_center [709] */
  mccoordschange(mcposrchannel_15_analyzer_2_center, mcrotrchannel_15_analyzer_2_center,
    &mcnlx,
    &mcnly,
    &mcnlz,
    &mcnlvx,
    &mcnlvy,
    &mcnlvz,
    &mcnlsx,
    &mcnlsy,
    &mcnlsz);
  /* define label inside component channel_15_analyzer_2_center (without coords transformations) */
  mcJumpTrace_channel_15_analyzer_2_center:
  SIG_MESSAGE("channel_15_analyzer_2_center (Trace)");
  mcDEBUG_COMP("channel_15_analyzer_2_center")
  mcDEBUG_STATE(
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp)
#define x mcnlx
#define y mcnly
#define z mcnlz
#define vx mcnlvx
#define vy mcnlvy
#define vz mcnlvz
#define t mcnlt
#define sx mcnlsx
#define sy mcnlsy
#define sz mcnlsz
#define p mcnlp

#define mcabsorbComp mcabsorbCompchannel_15_analyzer_2_center
  STORE_NEUTRON(709,
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp);
  mcScattered=0;
  mcRestore=0;
  mcNCounter[709]++;
  mcPCounter[709] += p;
  mcP2Counter[709] += p*p;
#define mccompcurname  channel_15_analyzer_2_center
#define mccompcurtype  Arm
#define mccompcurindex 709
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex
  /* Label for restoring  neutron */
  mcabsorbCompchannel_15_analyzer_2_center:
  if (RESTORE) /* restore if needed */
  { RESTORE_NEUTRON(709,
      mcnlx,
      mcnly,
      mcnlz,
      mcnlvx,
      mcnlvy,
      mcnlvz,
      mcnlt,
      mcnlsx,
      mcnlsy,
      mcnlsz,
      mcnlp); }
#undef mcabsorbComp
#undef p
#undef sz
#undef sy
#undef sx
#undef t
#undef vz
#undef vy
#undef vx
#undef z
#undef y
#undef x
  mcDEBUG_STATE(
mcnlx,
mcnly,
mcnlz,
mcnlvx,
mcnlvy,
mcnlvz,
mcnlt,
mcnlsx,
mcnlsy,
mcnlsz,
mcnlp)

  /* TRACE Component channel_15_analyzer_2_rotated [710] */
  mccoordschange(mcposrchannel_15_analyzer_2_rotated, mcrotrchannel_15_analyzer_2_rotated,
    &mcnlx,
    &mcnly,
    &mcnlz,
    &mcnlvx,
    &mcnlvy,
    &mcnlvz,
    &mcnlsx,
    &mcnlsy,
    &mcnlsz);
  /* define label inside component channel_15_analyzer_2_rotated (without coords transformations) */
  mcJumpTrace_channel_15_analyzer_2_rotated:
  SIG_MESSAGE("channel_15_analyzer_2_rotated (Trace)");
  mcDEBUG_COMP("channel_15_analyzer_2_rotated")
  mcDEBUG_STATE(
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp)
#define x mcnlx
#define y mcnly
#define z mcnlz
#define vx mcnlvx
#define vy mcnlvy
#define vz mcnlvz
#define t mcnlt
#define sx mcnlsx
#define sy mcnlsy
#define sz mcnlsz
#define p mcnlp

#define mcabsorbComp mcabsorbCompchannel_15_analyzer_2_rotated
  STORE_NEUTRON(710,
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp);
  mcScattered=0;
  mcRestore=0;
  mcNCounter[710]++;
  mcPCounter[710] += p;
  mcP2Counter[710] += p*p;
#define mccompcurname  channel_15_analyzer_2_rotated
#define mccompcurtype  Arm
#define mccompcurindex 710
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex
  /* Label for restoring  neutron */
  mcabsorbCompchannel_15_analyzer_2_rotated:
  if (RESTORE) /* restore if needed */
  { RESTORE_NEUTRON(710,
      mcnlx,
      mcnly,
      mcnlz,
      mcnlvx,
      mcnlvy,
      mcnlvz,
      mcnlt,
      mcnlsx,
      mcnlsy,
      mcnlsz,
      mcnlp); }
#undef mcabsorbComp
#undef p
#undef sz
#undef sy
#undef sx
#undef t
#undef vz
#undef vy
#undef vx
#undef z
#undef y
#undef x
  mcDEBUG_STATE(
mcnlx,
mcnly,
mcnlz,
mcnlvx,
mcnlvy,
mcnlvz,
mcnlt,
mcnlsx,
mcnlsy,
mcnlsz,
mcnlp)

  /* TRACE Component channel_15_analyzer_2_array_crystal_array_0 [711] */
  mccoordschange(mcposrchannel_15_analyzer_2_array_crystal_array_0, mcrotrchannel_15_analyzer_2_array_crystal_array_0,
    &mcnlx,
    &mcnly,
    &mcnlz,
    &mcnlvx,
    &mcnlvy,
    &mcnlvz,
    &mcnlsx,
    &mcnlsy,
    &mcnlsz);
  /* define label inside component channel_15_analyzer_2_array_crystal_array_0 (without coords transformations) */
  mcJumpTrace_channel_15_analyzer_2_array_crystal_array_0:
  SIG_MESSAGE("channel_15_analyzer_2_array_crystal_array_0 (Trace)");
  mcDEBUG_COMP("channel_15_analyzer_2_array_crystal_array_0")
  mcDEBUG_STATE(
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp)
#define x mcnlx
#define y mcnly
#define z mcnlz
#define vx mcnlvx
#define vy mcnlvy
#define vz mcnlvz
#define t mcnlt
#define sx mcnlsx
#define sy mcnlsy
#define sz mcnlsz
#define p mcnlp

#define mcabsorbComp mcabsorbCompchannel_15_analyzer_2_array_crystal_array_0
  STORE_NEUTRON(711,
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp);
  mcScattered=0;
  mcRestore=0;
  mcNCounter[711]++;
  mcPCounter[711] += p;
  mcP2Counter[711] += p*p;
#define mccompcurname  channel_15_analyzer_2_array_crystal_array_0
#define mccompcurtype  Union_box
#define mccompcurindex 711
#define loop_index mccchannel_15_analyzer_2_array_crystal_array_0_loop_index
#define this_box_volume mccchannel_15_analyzer_2_array_crystal_array_0_this_box_volume
#define global_geometry_element mccchannel_15_analyzer_2_array_crystal_array_0_global_geometry_element
#define this_box_storage mccchannel_15_analyzer_2_array_crystal_array_0_this_box_storage
{   /* Declarations of channel_15_analyzer_2_array_crystal_array_0=Union_box() SETTING parameters. */
char* material_string = mccchannel_15_analyzer_2_array_crystal_array_0_material_string;
MCNUM priority = mccchannel_15_analyzer_2_array_crystal_array_0_priority;
MCNUM xwidth = mccchannel_15_analyzer_2_array_crystal_array_0_xwidth;
MCNUM yheight = mccchannel_15_analyzer_2_array_crystal_array_0_yheight;
MCNUM zdepth = mccchannel_15_analyzer_2_array_crystal_array_0_zdepth;
MCNUM xwidth2 = mccchannel_15_analyzer_2_array_crystal_array_0_xwidth2;
MCNUM yheight2 = mccchannel_15_analyzer_2_array_crystal_array_0_yheight2;
MCNUM visualize = mccchannel_15_analyzer_2_array_crystal_array_0_visualize;
int target_index = mccchannel_15_analyzer_2_array_crystal_array_0_target_index;
MCNUM target_x = mccchannel_15_analyzer_2_array_crystal_array_0_target_x;
MCNUM target_y = mccchannel_15_analyzer_2_array_crystal_array_0_target_y;
MCNUM target_z = mccchannel_15_analyzer_2_array_crystal_array_0_target_z;
MCNUM focus_aw = mccchannel_15_analyzer_2_array_crystal_array_0_focus_aw;
MCNUM focus_ah = mccchannel_15_analyzer_2_array_crystal_array_0_focus_ah;
MCNUM focus_xw = mccchannel_15_analyzer_2_array_crystal_array_0_focus_xw;
MCNUM focus_xh = mccchannel_15_analyzer_2_array_crystal_array_0_focus_xh;
MCNUM focus_r = mccchannel_15_analyzer_2_array_crystal_array_0_focus_r;
MCNUM p_interact = mccchannel_15_analyzer_2_array_crystal_array_0_p_interact;
char* mask_string = mccchannel_15_analyzer_2_array_crystal_array_0_mask_string;
char* mask_setting = mccchannel_15_analyzer_2_array_crystal_array_0_mask_setting;
MCNUM number_of_activations = mccchannel_15_analyzer_2_array_crystal_array_0_number_of_activations;
}   /* End of channel_15_analyzer_2_array_crystal_array_0=Union_box() SETTING parameter declarations. */
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex
  /* Label for restoring  neutron */
  mcabsorbCompchannel_15_analyzer_2_array_crystal_array_0:
  if (RESTORE) /* restore if needed */
  { RESTORE_NEUTRON(711,
      mcnlx,
      mcnly,
      mcnlz,
      mcnlvx,
      mcnlvy,
      mcnlvz,
      mcnlt,
      mcnlsx,
      mcnlsy,
      mcnlsz,
      mcnlp); }
#undef mcabsorbComp
#undef p
#undef sz
#undef sy
#undef sx
#undef t
#undef vz
#undef vy
#undef vx
#undef z
#undef y
#undef x
  mcDEBUG_STATE(
mcnlx,
mcnly,
mcnlz,
mcnlvx,
mcnlvy,
mcnlvz,
mcnlt,
mcnlsx,
mcnlsy,
mcnlsz,
mcnlp)

  /* TRACE Component channel_15_analyzer_2_array_crystal_array_1 [712] */
  mccoordschange(mcposrchannel_15_analyzer_2_array_crystal_array_1, mcrotrchannel_15_analyzer_2_array_crystal_array_1,
    &mcnlx,
    &mcnly,
    &mcnlz,
    &mcnlvx,
    &mcnlvy,
    &mcnlvz,
    &mcnlsx,
    &mcnlsy,
    &mcnlsz);
  /* define label inside component channel_15_analyzer_2_array_crystal_array_1 (without coords transformations) */
  mcJumpTrace_channel_15_analyzer_2_array_crystal_array_1:
  SIG_MESSAGE("channel_15_analyzer_2_array_crystal_array_1 (Trace)");
  mcDEBUG_COMP("channel_15_analyzer_2_array_crystal_array_1")
  mcDEBUG_STATE(
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp)
#define x mcnlx
#define y mcnly
#define z mcnlz
#define vx mcnlvx
#define vy mcnlvy
#define vz mcnlvz
#define t mcnlt
#define sx mcnlsx
#define sy mcnlsy
#define sz mcnlsz
#define p mcnlp

#define mcabsorbComp mcabsorbCompchannel_15_analyzer_2_array_crystal_array_1
  STORE_NEUTRON(712,
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp);
  mcScattered=0;
  mcRestore=0;
  mcNCounter[712]++;
  mcPCounter[712] += p;
  mcP2Counter[712] += p*p;
#define mccompcurname  channel_15_analyzer_2_array_crystal_array_1
#define mccompcurtype  Union_box
#define mccompcurindex 712
#define loop_index mccchannel_15_analyzer_2_array_crystal_array_1_loop_index
#define this_box_volume mccchannel_15_analyzer_2_array_crystal_array_1_this_box_volume
#define global_geometry_element mccchannel_15_analyzer_2_array_crystal_array_1_global_geometry_element
#define this_box_storage mccchannel_15_analyzer_2_array_crystal_array_1_this_box_storage
{   /* Declarations of channel_15_analyzer_2_array_crystal_array_1=Union_box() SETTING parameters. */
char* material_string = mccchannel_15_analyzer_2_array_crystal_array_1_material_string;
MCNUM priority = mccchannel_15_analyzer_2_array_crystal_array_1_priority;
MCNUM xwidth = mccchannel_15_analyzer_2_array_crystal_array_1_xwidth;
MCNUM yheight = mccchannel_15_analyzer_2_array_crystal_array_1_yheight;
MCNUM zdepth = mccchannel_15_analyzer_2_array_crystal_array_1_zdepth;
MCNUM xwidth2 = mccchannel_15_analyzer_2_array_crystal_array_1_xwidth2;
MCNUM yheight2 = mccchannel_15_analyzer_2_array_crystal_array_1_yheight2;
MCNUM visualize = mccchannel_15_analyzer_2_array_crystal_array_1_visualize;
int target_index = mccchannel_15_analyzer_2_array_crystal_array_1_target_index;
MCNUM target_x = mccchannel_15_analyzer_2_array_crystal_array_1_target_x;
MCNUM target_y = mccchannel_15_analyzer_2_array_crystal_array_1_target_y;
MCNUM target_z = mccchannel_15_analyzer_2_array_crystal_array_1_target_z;
MCNUM focus_aw = mccchannel_15_analyzer_2_array_crystal_array_1_focus_aw;
MCNUM focus_ah = mccchannel_15_analyzer_2_array_crystal_array_1_focus_ah;
MCNUM focus_xw = mccchannel_15_analyzer_2_array_crystal_array_1_focus_xw;
MCNUM focus_xh = mccchannel_15_analyzer_2_array_crystal_array_1_focus_xh;
MCNUM focus_r = mccchannel_15_analyzer_2_array_crystal_array_1_focus_r;
MCNUM p_interact = mccchannel_15_analyzer_2_array_crystal_array_1_p_interact;
char* mask_string = mccchannel_15_analyzer_2_array_crystal_array_1_mask_string;
char* mask_setting = mccchannel_15_analyzer_2_array_crystal_array_1_mask_setting;
MCNUM number_of_activations = mccchannel_15_analyzer_2_array_crystal_array_1_number_of_activations;
}   /* End of channel_15_analyzer_2_array_crystal_array_1=Union_box() SETTING parameter declarations. */
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex
  /* Label for restoring  neutron */
  mcabsorbCompchannel_15_analyzer_2_array_crystal_array_1:
  if (RESTORE) /* restore if needed */
  { RESTORE_NEUTRON(712,
      mcnlx,
      mcnly,
      mcnlz,
      mcnlvx,
      mcnlvy,
      mcnlvz,
      mcnlt,
      mcnlsx,
      mcnlsy,
      mcnlsz,
      mcnlp); }
#undef mcabsorbComp
#undef p
#undef sz
#undef sy
#undef sx
#undef t
#undef vz
#undef vy
#undef vx
#undef z
#undef y
#undef x
  mcDEBUG_STATE(
mcnlx,
mcnly,
mcnlz,
mcnlvx,
mcnlvy,
mcnlvz,
mcnlt,
mcnlsx,
mcnlsy,
mcnlsz,
mcnlp)

  /* TRACE Component channel_15_analyzer_2_array_crystal_array_2 [713] */
  mccoordschange(mcposrchannel_15_analyzer_2_array_crystal_array_2, mcrotrchannel_15_analyzer_2_array_crystal_array_2,
    &mcnlx,
    &mcnly,
    &mcnlz,
    &mcnlvx,
    &mcnlvy,
    &mcnlvz,
    &mcnlsx,
    &mcnlsy,
    &mcnlsz);
  /* define label inside component channel_15_analyzer_2_array_crystal_array_2 (without coords transformations) */
  mcJumpTrace_channel_15_analyzer_2_array_crystal_array_2:
  SIG_MESSAGE("channel_15_analyzer_2_array_crystal_array_2 (Trace)");
  mcDEBUG_COMP("channel_15_analyzer_2_array_crystal_array_2")
  mcDEBUG_STATE(
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp)
#define x mcnlx
#define y mcnly
#define z mcnlz
#define vx mcnlvx
#define vy mcnlvy
#define vz mcnlvz
#define t mcnlt
#define sx mcnlsx
#define sy mcnlsy
#define sz mcnlsz
#define p mcnlp

#define mcabsorbComp mcabsorbCompchannel_15_analyzer_2_array_crystal_array_2
  STORE_NEUTRON(713,
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp);
  mcScattered=0;
  mcRestore=0;
  mcNCounter[713]++;
  mcPCounter[713] += p;
  mcP2Counter[713] += p*p;
#define mccompcurname  channel_15_analyzer_2_array_crystal_array_2
#define mccompcurtype  Union_box
#define mccompcurindex 713
#define loop_index mccchannel_15_analyzer_2_array_crystal_array_2_loop_index
#define this_box_volume mccchannel_15_analyzer_2_array_crystal_array_2_this_box_volume
#define global_geometry_element mccchannel_15_analyzer_2_array_crystal_array_2_global_geometry_element
#define this_box_storage mccchannel_15_analyzer_2_array_crystal_array_2_this_box_storage
{   /* Declarations of channel_15_analyzer_2_array_crystal_array_2=Union_box() SETTING parameters. */
char* material_string = mccchannel_15_analyzer_2_array_crystal_array_2_material_string;
MCNUM priority = mccchannel_15_analyzer_2_array_crystal_array_2_priority;
MCNUM xwidth = mccchannel_15_analyzer_2_array_crystal_array_2_xwidth;
MCNUM yheight = mccchannel_15_analyzer_2_array_crystal_array_2_yheight;
MCNUM zdepth = mccchannel_15_analyzer_2_array_crystal_array_2_zdepth;
MCNUM xwidth2 = mccchannel_15_analyzer_2_array_crystal_array_2_xwidth2;
MCNUM yheight2 = mccchannel_15_analyzer_2_array_crystal_array_2_yheight2;
MCNUM visualize = mccchannel_15_analyzer_2_array_crystal_array_2_visualize;
int target_index = mccchannel_15_analyzer_2_array_crystal_array_2_target_index;
MCNUM target_x = mccchannel_15_analyzer_2_array_crystal_array_2_target_x;
MCNUM target_y = mccchannel_15_analyzer_2_array_crystal_array_2_target_y;
MCNUM target_z = mccchannel_15_analyzer_2_array_crystal_array_2_target_z;
MCNUM focus_aw = mccchannel_15_analyzer_2_array_crystal_array_2_focus_aw;
MCNUM focus_ah = mccchannel_15_analyzer_2_array_crystal_array_2_focus_ah;
MCNUM focus_xw = mccchannel_15_analyzer_2_array_crystal_array_2_focus_xw;
MCNUM focus_xh = mccchannel_15_analyzer_2_array_crystal_array_2_focus_xh;
MCNUM focus_r = mccchannel_15_analyzer_2_array_crystal_array_2_focus_r;
MCNUM p_interact = mccchannel_15_analyzer_2_array_crystal_array_2_p_interact;
char* mask_string = mccchannel_15_analyzer_2_array_crystal_array_2_mask_string;
char* mask_setting = mccchannel_15_analyzer_2_array_crystal_array_2_mask_setting;
MCNUM number_of_activations = mccchannel_15_analyzer_2_array_crystal_array_2_number_of_activations;
}   /* End of channel_15_analyzer_2_array_crystal_array_2=Union_box() SETTING parameter declarations. */
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex
  /* Label for restoring  neutron */
  mcabsorbCompchannel_15_analyzer_2_array_crystal_array_2:
  if (RESTORE) /* restore if needed */
  { RESTORE_NEUTRON(713,
      mcnlx,
      mcnly,
      mcnlz,
      mcnlvx,
      mcnlvy,
      mcnlvz,
      mcnlt,
      mcnlsx,
      mcnlsy,
      mcnlsz,
      mcnlp); }
#undef mcabsorbComp
#undef p
#undef sz
#undef sy
#undef sx
#undef t
#undef vz
#undef vy
#undef vx
#undef z
#undef y
#undef x
  mcDEBUG_STATE(
mcnlx,
mcnly,
mcnlz,
mcnlvx,
mcnlvy,
mcnlvz,
mcnlt,
mcnlsx,
mcnlsy,
mcnlsz,
mcnlp)

  /* TRACE Component channel_15_analyzer_2_array_crystal_array_3 [714] */
  mccoordschange(mcposrchannel_15_analyzer_2_array_crystal_array_3, mcrotrchannel_15_analyzer_2_array_crystal_array_3,
    &mcnlx,
    &mcnly,
    &mcnlz,
    &mcnlvx,
    &mcnlvy,
    &mcnlvz,
    &mcnlsx,
    &mcnlsy,
    &mcnlsz);
  /* define label inside component channel_15_analyzer_2_array_crystal_array_3 (without coords transformations) */
  mcJumpTrace_channel_15_analyzer_2_array_crystal_array_3:
  SIG_MESSAGE("channel_15_analyzer_2_array_crystal_array_3 (Trace)");
  mcDEBUG_COMP("channel_15_analyzer_2_array_crystal_array_3")
  mcDEBUG_STATE(
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp)
#define x mcnlx
#define y mcnly
#define z mcnlz
#define vx mcnlvx
#define vy mcnlvy
#define vz mcnlvz
#define t mcnlt
#define sx mcnlsx
#define sy mcnlsy
#define sz mcnlsz
#define p mcnlp

#define mcabsorbComp mcabsorbCompchannel_15_analyzer_2_array_crystal_array_3
  STORE_NEUTRON(714,
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp);
  mcScattered=0;
  mcRestore=0;
  mcNCounter[714]++;
  mcPCounter[714] += p;
  mcP2Counter[714] += p*p;
#define mccompcurname  channel_15_analyzer_2_array_crystal_array_3
#define mccompcurtype  Union_box
#define mccompcurindex 714
#define loop_index mccchannel_15_analyzer_2_array_crystal_array_3_loop_index
#define this_box_volume mccchannel_15_analyzer_2_array_crystal_array_3_this_box_volume
#define global_geometry_element mccchannel_15_analyzer_2_array_crystal_array_3_global_geometry_element
#define this_box_storage mccchannel_15_analyzer_2_array_crystal_array_3_this_box_storage
{   /* Declarations of channel_15_analyzer_2_array_crystal_array_3=Union_box() SETTING parameters. */
char* material_string = mccchannel_15_analyzer_2_array_crystal_array_3_material_string;
MCNUM priority = mccchannel_15_analyzer_2_array_crystal_array_3_priority;
MCNUM xwidth = mccchannel_15_analyzer_2_array_crystal_array_3_xwidth;
MCNUM yheight = mccchannel_15_analyzer_2_array_crystal_array_3_yheight;
MCNUM zdepth = mccchannel_15_analyzer_2_array_crystal_array_3_zdepth;
MCNUM xwidth2 = mccchannel_15_analyzer_2_array_crystal_array_3_xwidth2;
MCNUM yheight2 = mccchannel_15_analyzer_2_array_crystal_array_3_yheight2;
MCNUM visualize = mccchannel_15_analyzer_2_array_crystal_array_3_visualize;
int target_index = mccchannel_15_analyzer_2_array_crystal_array_3_target_index;
MCNUM target_x = mccchannel_15_analyzer_2_array_crystal_array_3_target_x;
MCNUM target_y = mccchannel_15_analyzer_2_array_crystal_array_3_target_y;
MCNUM target_z = mccchannel_15_analyzer_2_array_crystal_array_3_target_z;
MCNUM focus_aw = mccchannel_15_analyzer_2_array_crystal_array_3_focus_aw;
MCNUM focus_ah = mccchannel_15_analyzer_2_array_crystal_array_3_focus_ah;
MCNUM focus_xw = mccchannel_15_analyzer_2_array_crystal_array_3_focus_xw;
MCNUM focus_xh = mccchannel_15_analyzer_2_array_crystal_array_3_focus_xh;
MCNUM focus_r = mccchannel_15_analyzer_2_array_crystal_array_3_focus_r;
MCNUM p_interact = mccchannel_15_analyzer_2_array_crystal_array_3_p_interact;
char* mask_string = mccchannel_15_analyzer_2_array_crystal_array_3_mask_string;
char* mask_setting = mccchannel_15_analyzer_2_array_crystal_array_3_mask_setting;
MCNUM number_of_activations = mccchannel_15_analyzer_2_array_crystal_array_3_number_of_activations;
}   /* End of channel_15_analyzer_2_array_crystal_array_3=Union_box() SETTING parameter declarations. */
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex
  /* Label for restoring  neutron */
  mcabsorbCompchannel_15_analyzer_2_array_crystal_array_3:
  if (RESTORE) /* restore if needed */
  { RESTORE_NEUTRON(714,
      mcnlx,
      mcnly,
      mcnlz,
      mcnlvx,
      mcnlvy,
      mcnlvz,
      mcnlt,
      mcnlsx,
      mcnlsy,
      mcnlsz,
      mcnlp); }
#undef mcabsorbComp
#undef p
#undef sz
#undef sy
#undef sx
#undef t
#undef vz
#undef vy
#undef vx
#undef z
#undef y
#undef x
  mcDEBUG_STATE(
mcnlx,
mcnly,
mcnlz,
mcnlvx,
mcnlvy,
mcnlvz,
mcnlt,
mcnlsx,
mcnlsy,
mcnlsz,
mcnlp)

  /* TRACE Component channel_15_analyzer_2_array_crystal_array_4 [715] */
  mccoordschange(mcposrchannel_15_analyzer_2_array_crystal_array_4, mcrotrchannel_15_analyzer_2_array_crystal_array_4,
    &mcnlx,
    &mcnly,
    &mcnlz,
    &mcnlvx,
    &mcnlvy,
    &mcnlvz,
    &mcnlsx,
    &mcnlsy,
    &mcnlsz);
  /* define label inside component channel_15_analyzer_2_array_crystal_array_4 (without coords transformations) */
  mcJumpTrace_channel_15_analyzer_2_array_crystal_array_4:
  SIG_MESSAGE("channel_15_analyzer_2_array_crystal_array_4 (Trace)");
  mcDEBUG_COMP("channel_15_analyzer_2_array_crystal_array_4")
  mcDEBUG_STATE(
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp)
#define x mcnlx
#define y mcnly
#define z mcnlz
#define vx mcnlvx
#define vy mcnlvy
#define vz mcnlvz
#define t mcnlt
#define sx mcnlsx
#define sy mcnlsy
#define sz mcnlsz
#define p mcnlp

#define mcabsorbComp mcabsorbCompchannel_15_analyzer_2_array_crystal_array_4
  STORE_NEUTRON(715,
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp);
  mcScattered=0;
  mcRestore=0;
  mcNCounter[715]++;
  mcPCounter[715] += p;
  mcP2Counter[715] += p*p;
#define mccompcurname  channel_15_analyzer_2_array_crystal_array_4
#define mccompcurtype  Union_box
#define mccompcurindex 715
#define loop_index mccchannel_15_analyzer_2_array_crystal_array_4_loop_index
#define this_box_volume mccchannel_15_analyzer_2_array_crystal_array_4_this_box_volume
#define global_geometry_element mccchannel_15_analyzer_2_array_crystal_array_4_global_geometry_element
#define this_box_storage mccchannel_15_analyzer_2_array_crystal_array_4_this_box_storage
{   /* Declarations of channel_15_analyzer_2_array_crystal_array_4=Union_box() SETTING parameters. */
char* material_string = mccchannel_15_analyzer_2_array_crystal_array_4_material_string;
MCNUM priority = mccchannel_15_analyzer_2_array_crystal_array_4_priority;
MCNUM xwidth = mccchannel_15_analyzer_2_array_crystal_array_4_xwidth;
MCNUM yheight = mccchannel_15_analyzer_2_array_crystal_array_4_yheight;
MCNUM zdepth = mccchannel_15_analyzer_2_array_crystal_array_4_zdepth;
MCNUM xwidth2 = mccchannel_15_analyzer_2_array_crystal_array_4_xwidth2;
MCNUM yheight2 = mccchannel_15_analyzer_2_array_crystal_array_4_yheight2;
MCNUM visualize = mccchannel_15_analyzer_2_array_crystal_array_4_visualize;
int target_index = mccchannel_15_analyzer_2_array_crystal_array_4_target_index;
MCNUM target_x = mccchannel_15_analyzer_2_array_crystal_array_4_target_x;
MCNUM target_y = mccchannel_15_analyzer_2_array_crystal_array_4_target_y;
MCNUM target_z = mccchannel_15_analyzer_2_array_crystal_array_4_target_z;
MCNUM focus_aw = mccchannel_15_analyzer_2_array_crystal_array_4_focus_aw;
MCNUM focus_ah = mccchannel_15_analyzer_2_array_crystal_array_4_focus_ah;
MCNUM focus_xw = mccchannel_15_analyzer_2_array_crystal_array_4_focus_xw;
MCNUM focus_xh = mccchannel_15_analyzer_2_array_crystal_array_4_focus_xh;
MCNUM focus_r = mccchannel_15_analyzer_2_array_crystal_array_4_focus_r;
MCNUM p_interact = mccchannel_15_analyzer_2_array_crystal_array_4_p_interact;
char* mask_string = mccchannel_15_analyzer_2_array_crystal_array_4_mask_string;
char* mask_setting = mccchannel_15_analyzer_2_array_crystal_array_4_mask_setting;
MCNUM number_of_activations = mccchannel_15_analyzer_2_array_crystal_array_4_number_of_activations;
}   /* End of channel_15_analyzer_2_array_crystal_array_4=Union_box() SETTING parameter declarations. */
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex
  /* Label for restoring  neutron */
  mcabsorbCompchannel_15_analyzer_2_array_crystal_array_4:
  if (RESTORE) /* restore if needed */
  { RESTORE_NEUTRON(715,
      mcnlx,
      mcnly,
      mcnlz,
      mcnlvx,
      mcnlvy,
      mcnlvz,
      mcnlt,
      mcnlsx,
      mcnlsy,
      mcnlsz,
      mcnlp); }
#undef mcabsorbComp
#undef p
#undef sz
#undef sy
#undef sx
#undef t
#undef vz
#undef vy
#undef vx
#undef z
#undef y
#undef x
  mcDEBUG_STATE(
mcnlx,
mcnly,
mcnlz,
mcnlvx,
mcnlvy,
mcnlvz,
mcnlt,
mcnlsx,
mcnlsy,
mcnlsz,
mcnlp)

  /* TRACE Component channel_15_analyzer_2_array_crystal_array_5 [716] */
  mccoordschange(mcposrchannel_15_analyzer_2_array_crystal_array_5, mcrotrchannel_15_analyzer_2_array_crystal_array_5,
    &mcnlx,
    &mcnly,
    &mcnlz,
    &mcnlvx,
    &mcnlvy,
    &mcnlvz,
    &mcnlsx,
    &mcnlsy,
    &mcnlsz);
  /* define label inside component channel_15_analyzer_2_array_crystal_array_5 (without coords transformations) */
  mcJumpTrace_channel_15_analyzer_2_array_crystal_array_5:
  SIG_MESSAGE("channel_15_analyzer_2_array_crystal_array_5 (Trace)");
  mcDEBUG_COMP("channel_15_analyzer_2_array_crystal_array_5")
  mcDEBUG_STATE(
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp)
#define x mcnlx
#define y mcnly
#define z mcnlz
#define vx mcnlvx
#define vy mcnlvy
#define vz mcnlvz
#define t mcnlt
#define sx mcnlsx
#define sy mcnlsy
#define sz mcnlsz
#define p mcnlp

#define mcabsorbComp mcabsorbCompchannel_15_analyzer_2_array_crystal_array_5
  STORE_NEUTRON(716,
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp);
  mcScattered=0;
  mcRestore=0;
  mcNCounter[716]++;
  mcPCounter[716] += p;
  mcP2Counter[716] += p*p;
#define mccompcurname  channel_15_analyzer_2_array_crystal_array_5
#define mccompcurtype  Union_box
#define mccompcurindex 716
#define loop_index mccchannel_15_analyzer_2_array_crystal_array_5_loop_index
#define this_box_volume mccchannel_15_analyzer_2_array_crystal_array_5_this_box_volume
#define global_geometry_element mccchannel_15_analyzer_2_array_crystal_array_5_global_geometry_element
#define this_box_storage mccchannel_15_analyzer_2_array_crystal_array_5_this_box_storage
{   /* Declarations of channel_15_analyzer_2_array_crystal_array_5=Union_box() SETTING parameters. */
char* material_string = mccchannel_15_analyzer_2_array_crystal_array_5_material_string;
MCNUM priority = mccchannel_15_analyzer_2_array_crystal_array_5_priority;
MCNUM xwidth = mccchannel_15_analyzer_2_array_crystal_array_5_xwidth;
MCNUM yheight = mccchannel_15_analyzer_2_array_crystal_array_5_yheight;
MCNUM zdepth = mccchannel_15_analyzer_2_array_crystal_array_5_zdepth;
MCNUM xwidth2 = mccchannel_15_analyzer_2_array_crystal_array_5_xwidth2;
MCNUM yheight2 = mccchannel_15_analyzer_2_array_crystal_array_5_yheight2;
MCNUM visualize = mccchannel_15_analyzer_2_array_crystal_array_5_visualize;
int target_index = mccchannel_15_analyzer_2_array_crystal_array_5_target_index;
MCNUM target_x = mccchannel_15_analyzer_2_array_crystal_array_5_target_x;
MCNUM target_y = mccchannel_15_analyzer_2_array_crystal_array_5_target_y;
MCNUM target_z = mccchannel_15_analyzer_2_array_crystal_array_5_target_z;
MCNUM focus_aw = mccchannel_15_analyzer_2_array_crystal_array_5_focus_aw;
MCNUM focus_ah = mccchannel_15_analyzer_2_array_crystal_array_5_focus_ah;
MCNUM focus_xw = mccchannel_15_analyzer_2_array_crystal_array_5_focus_xw;
MCNUM focus_xh = mccchannel_15_analyzer_2_array_crystal_array_5_focus_xh;
MCNUM focus_r = mccchannel_15_analyzer_2_array_crystal_array_5_focus_r;
MCNUM p_interact = mccchannel_15_analyzer_2_array_crystal_array_5_p_interact;
char* mask_string = mccchannel_15_analyzer_2_array_crystal_array_5_mask_string;
char* mask_setting = mccchannel_15_analyzer_2_array_crystal_array_5_mask_setting;
MCNUM number_of_activations = mccchannel_15_analyzer_2_array_crystal_array_5_number_of_activations;
}   /* End of channel_15_analyzer_2_array_crystal_array_5=Union_box() SETTING parameter declarations. */
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex
  /* Label for restoring  neutron */
  mcabsorbCompchannel_15_analyzer_2_array_crystal_array_5:
  if (RESTORE) /* restore if needed */
  { RESTORE_NEUTRON(716,
      mcnlx,
      mcnly,
      mcnlz,
      mcnlvx,
      mcnlvy,
      mcnlvz,
      mcnlt,
      mcnlsx,
      mcnlsy,
      mcnlsz,
      mcnlp); }
#undef mcabsorbComp
#undef p
#undef sz
#undef sy
#undef sx
#undef t
#undef vz
#undef vy
#undef vx
#undef z
#undef y
#undef x
  mcDEBUG_STATE(
mcnlx,
mcnly,
mcnlz,
mcnlvx,
mcnlvy,
mcnlvz,
mcnlt,
mcnlsx,
mcnlsy,
mcnlsz,
mcnlp)

  /* TRACE Component channel_15_analyzer_2_array_crystal_array_6 [717] */
  mccoordschange(mcposrchannel_15_analyzer_2_array_crystal_array_6, mcrotrchannel_15_analyzer_2_array_crystal_array_6,
    &mcnlx,
    &mcnly,
    &mcnlz,
    &mcnlvx,
    &mcnlvy,
    &mcnlvz,
    &mcnlsx,
    &mcnlsy,
    &mcnlsz);
  /* define label inside component channel_15_analyzer_2_array_crystal_array_6 (without coords transformations) */
  mcJumpTrace_channel_15_analyzer_2_array_crystal_array_6:
  SIG_MESSAGE("channel_15_analyzer_2_array_crystal_array_6 (Trace)");
  mcDEBUG_COMP("channel_15_analyzer_2_array_crystal_array_6")
  mcDEBUG_STATE(
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp)
#define x mcnlx
#define y mcnly
#define z mcnlz
#define vx mcnlvx
#define vy mcnlvy
#define vz mcnlvz
#define t mcnlt
#define sx mcnlsx
#define sy mcnlsy
#define sz mcnlsz
#define p mcnlp

#define mcabsorbComp mcabsorbCompchannel_15_analyzer_2_array_crystal_array_6
  STORE_NEUTRON(717,
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp);
  mcScattered=0;
  mcRestore=0;
  mcNCounter[717]++;
  mcPCounter[717] += p;
  mcP2Counter[717] += p*p;
#define mccompcurname  channel_15_analyzer_2_array_crystal_array_6
#define mccompcurtype  Union_box
#define mccompcurindex 717
#define loop_index mccchannel_15_analyzer_2_array_crystal_array_6_loop_index
#define this_box_volume mccchannel_15_analyzer_2_array_crystal_array_6_this_box_volume
#define global_geometry_element mccchannel_15_analyzer_2_array_crystal_array_6_global_geometry_element
#define this_box_storage mccchannel_15_analyzer_2_array_crystal_array_6_this_box_storage
{   /* Declarations of channel_15_analyzer_2_array_crystal_array_6=Union_box() SETTING parameters. */
char* material_string = mccchannel_15_analyzer_2_array_crystal_array_6_material_string;
MCNUM priority = mccchannel_15_analyzer_2_array_crystal_array_6_priority;
MCNUM xwidth = mccchannel_15_analyzer_2_array_crystal_array_6_xwidth;
MCNUM yheight = mccchannel_15_analyzer_2_array_crystal_array_6_yheight;
MCNUM zdepth = mccchannel_15_analyzer_2_array_crystal_array_6_zdepth;
MCNUM xwidth2 = mccchannel_15_analyzer_2_array_crystal_array_6_xwidth2;
MCNUM yheight2 = mccchannel_15_analyzer_2_array_crystal_array_6_yheight2;
MCNUM visualize = mccchannel_15_analyzer_2_array_crystal_array_6_visualize;
int target_index = mccchannel_15_analyzer_2_array_crystal_array_6_target_index;
MCNUM target_x = mccchannel_15_analyzer_2_array_crystal_array_6_target_x;
MCNUM target_y = mccchannel_15_analyzer_2_array_crystal_array_6_target_y;
MCNUM target_z = mccchannel_15_analyzer_2_array_crystal_array_6_target_z;
MCNUM focus_aw = mccchannel_15_analyzer_2_array_crystal_array_6_focus_aw;
MCNUM focus_ah = mccchannel_15_analyzer_2_array_crystal_array_6_focus_ah;
MCNUM focus_xw = mccchannel_15_analyzer_2_array_crystal_array_6_focus_xw;
MCNUM focus_xh = mccchannel_15_analyzer_2_array_crystal_array_6_focus_xh;
MCNUM focus_r = mccchannel_15_analyzer_2_array_crystal_array_6_focus_r;
MCNUM p_interact = mccchannel_15_analyzer_2_array_crystal_array_6_p_interact;
char* mask_string = mccchannel_15_analyzer_2_array_crystal_array_6_mask_string;
char* mask_setting = mccchannel_15_analyzer_2_array_crystal_array_6_mask_setting;
MCNUM number_of_activations = mccchannel_15_analyzer_2_array_crystal_array_6_number_of_activations;
}   /* End of channel_15_analyzer_2_array_crystal_array_6=Union_box() SETTING parameter declarations. */
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex
  /* Label for restoring  neutron */
  mcabsorbCompchannel_15_analyzer_2_array_crystal_array_6:
  if (RESTORE) /* restore if needed */
  { RESTORE_NEUTRON(717,
      mcnlx,
      mcnly,
      mcnlz,
      mcnlvx,
      mcnlvy,
      mcnlvz,
      mcnlt,
      mcnlsx,
      mcnlsy,
      mcnlsz,
      mcnlp); }
#undef mcabsorbComp
#undef p
#undef sz
#undef sy
#undef sx
#undef t
#undef vz
#undef vy
#undef vx
#undef z
#undef y
#undef x
  mcDEBUG_STATE(
mcnlx,
mcnly,
mcnlz,
mcnlvx,
mcnlvy,
mcnlvz,
mcnlt,
mcnlsx,
mcnlsy,
mcnlsz,
mcnlp)

  /* TRACE Component channel_15_analyzer_2_array_crystal_array_7 [718] */
  mccoordschange(mcposrchannel_15_analyzer_2_array_crystal_array_7, mcrotrchannel_15_analyzer_2_array_crystal_array_7,
    &mcnlx,
    &mcnly,
    &mcnlz,
    &mcnlvx,
    &mcnlvy,
    &mcnlvz,
    &mcnlsx,
    &mcnlsy,
    &mcnlsz);
  /* define label inside component channel_15_analyzer_2_array_crystal_array_7 (without coords transformations) */
  mcJumpTrace_channel_15_analyzer_2_array_crystal_array_7:
  SIG_MESSAGE("channel_15_analyzer_2_array_crystal_array_7 (Trace)");
  mcDEBUG_COMP("channel_15_analyzer_2_array_crystal_array_7")
  mcDEBUG_STATE(
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp)
#define x mcnlx
#define y mcnly
#define z mcnlz
#define vx mcnlvx
#define vy mcnlvy
#define vz mcnlvz
#define t mcnlt
#define sx mcnlsx
#define sy mcnlsy
#define sz mcnlsz
#define p mcnlp

#define mcabsorbComp mcabsorbCompchannel_15_analyzer_2_array_crystal_array_7
  STORE_NEUTRON(718,
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp);
  mcScattered=0;
  mcRestore=0;
  mcNCounter[718]++;
  mcPCounter[718] += p;
  mcP2Counter[718] += p*p;
#define mccompcurname  channel_15_analyzer_2_array_crystal_array_7
#define mccompcurtype  Union_box
#define mccompcurindex 718
#define loop_index mccchannel_15_analyzer_2_array_crystal_array_7_loop_index
#define this_box_volume mccchannel_15_analyzer_2_array_crystal_array_7_this_box_volume
#define global_geometry_element mccchannel_15_analyzer_2_array_crystal_array_7_global_geometry_element
#define this_box_storage mccchannel_15_analyzer_2_array_crystal_array_7_this_box_storage
{   /* Declarations of channel_15_analyzer_2_array_crystal_array_7=Union_box() SETTING parameters. */
char* material_string = mccchannel_15_analyzer_2_array_crystal_array_7_material_string;
MCNUM priority = mccchannel_15_analyzer_2_array_crystal_array_7_priority;
MCNUM xwidth = mccchannel_15_analyzer_2_array_crystal_array_7_xwidth;
MCNUM yheight = mccchannel_15_analyzer_2_array_crystal_array_7_yheight;
MCNUM zdepth = mccchannel_15_analyzer_2_array_crystal_array_7_zdepth;
MCNUM xwidth2 = mccchannel_15_analyzer_2_array_crystal_array_7_xwidth2;
MCNUM yheight2 = mccchannel_15_analyzer_2_array_crystal_array_7_yheight2;
MCNUM visualize = mccchannel_15_analyzer_2_array_crystal_array_7_visualize;
int target_index = mccchannel_15_analyzer_2_array_crystal_array_7_target_index;
MCNUM target_x = mccchannel_15_analyzer_2_array_crystal_array_7_target_x;
MCNUM target_y = mccchannel_15_analyzer_2_array_crystal_array_7_target_y;
MCNUM target_z = mccchannel_15_analyzer_2_array_crystal_array_7_target_z;
MCNUM focus_aw = mccchannel_15_analyzer_2_array_crystal_array_7_focus_aw;
MCNUM focus_ah = mccchannel_15_analyzer_2_array_crystal_array_7_focus_ah;
MCNUM focus_xw = mccchannel_15_analyzer_2_array_crystal_array_7_focus_xw;
MCNUM focus_xh = mccchannel_15_analyzer_2_array_crystal_array_7_focus_xh;
MCNUM focus_r = mccchannel_15_analyzer_2_array_crystal_array_7_focus_r;
MCNUM p_interact = mccchannel_15_analyzer_2_array_crystal_array_7_p_interact;
char* mask_string = mccchannel_15_analyzer_2_array_crystal_array_7_mask_string;
char* mask_setting = mccchannel_15_analyzer_2_array_crystal_array_7_mask_setting;
MCNUM number_of_activations = mccchannel_15_analyzer_2_array_crystal_array_7_number_of_activations;
}   /* End of channel_15_analyzer_2_array_crystal_array_7=Union_box() SETTING parameter declarations. */
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex
  /* Label for restoring  neutron */
  mcabsorbCompchannel_15_analyzer_2_array_crystal_array_7:
  if (RESTORE) /* restore if needed */
  { RESTORE_NEUTRON(718,
      mcnlx,
      mcnly,
      mcnlz,
      mcnlvx,
      mcnlvy,
      mcnlvz,
      mcnlt,
      mcnlsx,
      mcnlsy,
      mcnlsz,
      mcnlp); }
#undef mcabsorbComp
#undef p
#undef sz
#undef sy
#undef sx
#undef t
#undef vz
#undef vy
#undef vx
#undef z
#undef y
#undef x
  mcDEBUG_STATE(
mcnlx,
mcnly,
mcnlz,
mcnlvx,
mcnlvy,
mcnlvz,
mcnlt,
mcnlsx,
mcnlsy,
mcnlsz,
mcnlp)

  /* TRACE Component channel_15_analyzer_2_array_crystal_array_8 [719] */
  mccoordschange(mcposrchannel_15_analyzer_2_array_crystal_array_8, mcrotrchannel_15_analyzer_2_array_crystal_array_8,
    &mcnlx,
    &mcnly,
    &mcnlz,
    &mcnlvx,
    &mcnlvy,
    &mcnlvz,
    &mcnlsx,
    &mcnlsy,
    &mcnlsz);
  /* define label inside component channel_15_analyzer_2_array_crystal_array_8 (without coords transformations) */
  mcJumpTrace_channel_15_analyzer_2_array_crystal_array_8:
  SIG_MESSAGE("channel_15_analyzer_2_array_crystal_array_8 (Trace)");
  mcDEBUG_COMP("channel_15_analyzer_2_array_crystal_array_8")
  mcDEBUG_STATE(
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp)
#define x mcnlx
#define y mcnly
#define z mcnlz
#define vx mcnlvx
#define vy mcnlvy
#define vz mcnlvz
#define t mcnlt
#define sx mcnlsx
#define sy mcnlsy
#define sz mcnlsz
#define p mcnlp

#define mcabsorbComp mcabsorbCompchannel_15_analyzer_2_array_crystal_array_8
  STORE_NEUTRON(719,
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp);
  mcScattered=0;
  mcRestore=0;
  mcNCounter[719]++;
  mcPCounter[719] += p;
  mcP2Counter[719] += p*p;
#define mccompcurname  channel_15_analyzer_2_array_crystal_array_8
#define mccompcurtype  Union_box
#define mccompcurindex 719
#define loop_index mccchannel_15_analyzer_2_array_crystal_array_8_loop_index
#define this_box_volume mccchannel_15_analyzer_2_array_crystal_array_8_this_box_volume
#define global_geometry_element mccchannel_15_analyzer_2_array_crystal_array_8_global_geometry_element
#define this_box_storage mccchannel_15_analyzer_2_array_crystal_array_8_this_box_storage
{   /* Declarations of channel_15_analyzer_2_array_crystal_array_8=Union_box() SETTING parameters. */
char* material_string = mccchannel_15_analyzer_2_array_crystal_array_8_material_string;
MCNUM priority = mccchannel_15_analyzer_2_array_crystal_array_8_priority;
MCNUM xwidth = mccchannel_15_analyzer_2_array_crystal_array_8_xwidth;
MCNUM yheight = mccchannel_15_analyzer_2_array_crystal_array_8_yheight;
MCNUM zdepth = mccchannel_15_analyzer_2_array_crystal_array_8_zdepth;
MCNUM xwidth2 = mccchannel_15_analyzer_2_array_crystal_array_8_xwidth2;
MCNUM yheight2 = mccchannel_15_analyzer_2_array_crystal_array_8_yheight2;
MCNUM visualize = mccchannel_15_analyzer_2_array_crystal_array_8_visualize;
int target_index = mccchannel_15_analyzer_2_array_crystal_array_8_target_index;
MCNUM target_x = mccchannel_15_analyzer_2_array_crystal_array_8_target_x;
MCNUM target_y = mccchannel_15_analyzer_2_array_crystal_array_8_target_y;
MCNUM target_z = mccchannel_15_analyzer_2_array_crystal_array_8_target_z;
MCNUM focus_aw = mccchannel_15_analyzer_2_array_crystal_array_8_focus_aw;
MCNUM focus_ah = mccchannel_15_analyzer_2_array_crystal_array_8_focus_ah;
MCNUM focus_xw = mccchannel_15_analyzer_2_array_crystal_array_8_focus_xw;
MCNUM focus_xh = mccchannel_15_analyzer_2_array_crystal_array_8_focus_xh;
MCNUM focus_r = mccchannel_15_analyzer_2_array_crystal_array_8_focus_r;
MCNUM p_interact = mccchannel_15_analyzer_2_array_crystal_array_8_p_interact;
char* mask_string = mccchannel_15_analyzer_2_array_crystal_array_8_mask_string;
char* mask_setting = mccchannel_15_analyzer_2_array_crystal_array_8_mask_setting;
MCNUM number_of_activations = mccchannel_15_analyzer_2_array_crystal_array_8_number_of_activations;
}   /* End of channel_15_analyzer_2_array_crystal_array_8=Union_box() SETTING parameter declarations. */
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex
  /* Label for restoring  neutron */
  mcabsorbCompchannel_15_analyzer_2_array_crystal_array_8:
  if (RESTORE) /* restore if needed */
  { RESTORE_NEUTRON(719,
      mcnlx,
      mcnly,
      mcnlz,
      mcnlvx,
      mcnlvy,
      mcnlvz,
      mcnlt,
      mcnlsx,
      mcnlsy,
      mcnlsz,
      mcnlp); }
#undef mcabsorbComp
#undef p
#undef sz
#undef sy
#undef sx
#undef t
#undef vz
#undef vy
#undef vx
#undef z
#undef y
#undef x
  mcDEBUG_STATE(
mcnlx,
mcnly,
mcnlz,
mcnlvx,
mcnlvy,
mcnlvz,
mcnlt,
mcnlsx,
mcnlsy,
mcnlsz,
mcnlp)

  /* TRACE Component channel_15_cave2_cyl1 [720] */
  mccoordschange(mcposrchannel_15_cave2_cyl1, mcrotrchannel_15_cave2_cyl1,
    &mcnlx,
    &mcnly,
    &mcnlz,
    &mcnlvx,
    &mcnlvy,
    &mcnlvz,
    &mcnlsx,
    &mcnlsy,
    &mcnlsz);
  /* define label inside component channel_15_cave2_cyl1 (without coords transformations) */
  mcJumpTrace_channel_15_cave2_cyl1:
  SIG_MESSAGE("channel_15_cave2_cyl1 (Trace)");
  mcDEBUG_COMP("channel_15_cave2_cyl1")
  mcDEBUG_STATE(
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp)
#define x mcnlx
#define y mcnly
#define z mcnlz
#define vx mcnlvx
#define vy mcnlvy
#define vz mcnlvz
#define t mcnlt
#define sx mcnlsx
#define sy mcnlsy
#define sz mcnlsz
#define p mcnlp

#define mcabsorbComp mcabsorbCompchannel_15_cave2_cyl1
  STORE_NEUTRON(720,
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp);
  mcScattered=0;
  mcRestore=0;
  mcNCounter[720]++;
  mcPCounter[720] += p;
  mcP2Counter[720] += p*p;
#define mccompcurname  channel_15_cave2_cyl1
#define mccompcurtype  Union_cylinder
#define mccompcurindex 720
#define loop_index mccchannel_15_cave2_cyl1_loop_index
#define this_cylinder_volume mccchannel_15_cave2_cyl1_this_cylinder_volume
#define global_geometry_element mccchannel_15_cave2_cyl1_global_geometry_element
#define this_cylinder_storage mccchannel_15_cave2_cyl1_this_cylinder_storage
{   /* Declarations of channel_15_cave2_cyl1=Union_cylinder() SETTING parameters. */
char* material_string = mccchannel_15_cave2_cyl1_material_string;
MCNUM priority = mccchannel_15_cave2_cyl1_priority;
MCNUM radius = mccchannel_15_cave2_cyl1_radius;
MCNUM yheight = mccchannel_15_cave2_cyl1_yheight;
MCNUM visualize = mccchannel_15_cave2_cyl1_visualize;
int target_index = mccchannel_15_cave2_cyl1_target_index;
MCNUM target_x = mccchannel_15_cave2_cyl1_target_x;
MCNUM target_y = mccchannel_15_cave2_cyl1_target_y;
MCNUM target_z = mccchannel_15_cave2_cyl1_target_z;
MCNUM focus_aw = mccchannel_15_cave2_cyl1_focus_aw;
MCNUM focus_ah = mccchannel_15_cave2_cyl1_focus_ah;
MCNUM focus_xw = mccchannel_15_cave2_cyl1_focus_xw;
MCNUM focus_xh = mccchannel_15_cave2_cyl1_focus_xh;
MCNUM focus_r = mccchannel_15_cave2_cyl1_focus_r;
MCNUM p_interact = mccchannel_15_cave2_cyl1_p_interact;
char* mask_string = mccchannel_15_cave2_cyl1_mask_string;
char* mask_setting = mccchannel_15_cave2_cyl1_mask_setting;
MCNUM number_of_activations = mccchannel_15_cave2_cyl1_number_of_activations;
#line 345 "Union_cylinder.comp"
{
dummy = 1;
}
#line 440133 "MACS_sample_kidney_box.c"
}   /* End of channel_15_cave2_cyl1=Union_cylinder() SETTING parameter declarations. */
#undef this_cylinder_storage
#undef global_geometry_element
#undef this_cylinder_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex
  /* Label for restoring  neutron */
  mcabsorbCompchannel_15_cave2_cyl1:
  if (RESTORE) /* restore if needed */
  { RESTORE_NEUTRON(720,
      mcnlx,
      mcnly,
      mcnlz,
      mcnlvx,
      mcnlvy,
      mcnlvz,
      mcnlt,
      mcnlsx,
      mcnlsy,
      mcnlsz,
      mcnlp); }
#undef mcabsorbComp
#undef p
#undef sz
#undef sy
#undef sx
#undef t
#undef vz
#undef vy
#undef vx
#undef z
#undef y
#undef x
  mcDEBUG_STATE(
mcnlx,
mcnly,
mcnlz,
mcnlvx,
mcnlvy,
mcnlvz,
mcnlt,
mcnlsx,
mcnlsy,
mcnlsz,
mcnlp)

  /* TRACE Component channel_15_cave2_box1 [721] */
  mccoordschange(mcposrchannel_15_cave2_box1, mcrotrchannel_15_cave2_box1,
    &mcnlx,
    &mcnly,
    &mcnlz,
    &mcnlvx,
    &mcnlvy,
    &mcnlvz,
    &mcnlsx,
    &mcnlsy,
    &mcnlsz);
  /* define label inside component channel_15_cave2_box1 (without coords transformations) */
  mcJumpTrace_channel_15_cave2_box1:
  SIG_MESSAGE("channel_15_cave2_box1 (Trace)");
  mcDEBUG_COMP("channel_15_cave2_box1")
  mcDEBUG_STATE(
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp)
#define x mcnlx
#define y mcnly
#define z mcnlz
#define vx mcnlvx
#define vy mcnlvy
#define vz mcnlvz
#define t mcnlt
#define sx mcnlsx
#define sy mcnlsy
#define sz mcnlsz
#define p mcnlp

#define mcabsorbComp mcabsorbCompchannel_15_cave2_box1
  STORE_NEUTRON(721,
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp);
  mcScattered=0;
  mcRestore=0;
  mcNCounter[721]++;
  mcPCounter[721] += p;
  mcP2Counter[721] += p*p;
#define mccompcurname  channel_15_cave2_box1
#define mccompcurtype  Union_box
#define mccompcurindex 721
#define loop_index mccchannel_15_cave2_box1_loop_index
#define this_box_volume mccchannel_15_cave2_box1_this_box_volume
#define global_geometry_element mccchannel_15_cave2_box1_global_geometry_element
#define this_box_storage mccchannel_15_cave2_box1_this_box_storage
{   /* Declarations of channel_15_cave2_box1=Union_box() SETTING parameters. */
char* material_string = mccchannel_15_cave2_box1_material_string;
MCNUM priority = mccchannel_15_cave2_box1_priority;
MCNUM xwidth = mccchannel_15_cave2_box1_xwidth;
MCNUM yheight = mccchannel_15_cave2_box1_yheight;
MCNUM zdepth = mccchannel_15_cave2_box1_zdepth;
MCNUM xwidth2 = mccchannel_15_cave2_box1_xwidth2;
MCNUM yheight2 = mccchannel_15_cave2_box1_yheight2;
MCNUM visualize = mccchannel_15_cave2_box1_visualize;
int target_index = mccchannel_15_cave2_box1_target_index;
MCNUM target_x = mccchannel_15_cave2_box1_target_x;
MCNUM target_y = mccchannel_15_cave2_box1_target_y;
MCNUM target_z = mccchannel_15_cave2_box1_target_z;
MCNUM focus_aw = mccchannel_15_cave2_box1_focus_aw;
MCNUM focus_ah = mccchannel_15_cave2_box1_focus_ah;
MCNUM focus_xw = mccchannel_15_cave2_box1_focus_xw;
MCNUM focus_xh = mccchannel_15_cave2_box1_focus_xh;
MCNUM focus_r = mccchannel_15_cave2_box1_focus_r;
MCNUM p_interact = mccchannel_15_cave2_box1_p_interact;
char* mask_string = mccchannel_15_cave2_box1_mask_string;
char* mask_setting = mccchannel_15_cave2_box1_mask_setting;
MCNUM number_of_activations = mccchannel_15_cave2_box1_number_of_activations;
}   /* End of channel_15_cave2_box1=Union_box() SETTING parameter declarations. */
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex
  /* Label for restoring  neutron */
  mcabsorbCompchannel_15_cave2_box1:
  if (RESTORE) /* restore if needed */
  { RESTORE_NEUTRON(721,
      mcnlx,
      mcnly,
      mcnlz,
      mcnlvx,
      mcnlvy,
      mcnlvz,
      mcnlt,
      mcnlsx,
      mcnlsy,
      mcnlsz,
      mcnlp); }
#undef mcabsorbComp
#undef p
#undef sz
#undef sy
#undef sx
#undef t
#undef vz
#undef vy
#undef vx
#undef z
#undef y
#undef x
  mcDEBUG_STATE(
mcnlx,
mcnly,
mcnlz,
mcnlvx,
mcnlvy,
mcnlvz,
mcnlt,
mcnlsx,
mcnlsy,
mcnlsz,
mcnlp)

  /* TRACE Component channel_15_cave2_box2 [722] */
  mccoordschange(mcposrchannel_15_cave2_box2, mcrotrchannel_15_cave2_box2,
    &mcnlx,
    &mcnly,
    &mcnlz,
    &mcnlvx,
    &mcnlvy,
    &mcnlvz,
    &mcnlsx,
    &mcnlsy,
    &mcnlsz);
  /* define label inside component channel_15_cave2_box2 (without coords transformations) */
  mcJumpTrace_channel_15_cave2_box2:
  SIG_MESSAGE("channel_15_cave2_box2 (Trace)");
  mcDEBUG_COMP("channel_15_cave2_box2")
  mcDEBUG_STATE(
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp)
#define x mcnlx
#define y mcnly
#define z mcnlz
#define vx mcnlvx
#define vy mcnlvy
#define vz mcnlvz
#define t mcnlt
#define sx mcnlsx
#define sy mcnlsy
#define sz mcnlsz
#define p mcnlp

#define mcabsorbComp mcabsorbCompchannel_15_cave2_box2
  STORE_NEUTRON(722,
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp);
  mcScattered=0;
  mcRestore=0;
  mcNCounter[722]++;
  mcPCounter[722] += p;
  mcP2Counter[722] += p*p;
#define mccompcurname  channel_15_cave2_box2
#define mccompcurtype  Union_box
#define mccompcurindex 722
#define loop_index mccchannel_15_cave2_box2_loop_index
#define this_box_volume mccchannel_15_cave2_box2_this_box_volume
#define global_geometry_element mccchannel_15_cave2_box2_global_geometry_element
#define this_box_storage mccchannel_15_cave2_box2_this_box_storage
{   /* Declarations of channel_15_cave2_box2=Union_box() SETTING parameters. */
char* material_string = mccchannel_15_cave2_box2_material_string;
MCNUM priority = mccchannel_15_cave2_box2_priority;
MCNUM xwidth = mccchannel_15_cave2_box2_xwidth;
MCNUM yheight = mccchannel_15_cave2_box2_yheight;
MCNUM zdepth = mccchannel_15_cave2_box2_zdepth;
MCNUM xwidth2 = mccchannel_15_cave2_box2_xwidth2;
MCNUM yheight2 = mccchannel_15_cave2_box2_yheight2;
MCNUM visualize = mccchannel_15_cave2_box2_visualize;
int target_index = mccchannel_15_cave2_box2_target_index;
MCNUM target_x = mccchannel_15_cave2_box2_target_x;
MCNUM target_y = mccchannel_15_cave2_box2_target_y;
MCNUM target_z = mccchannel_15_cave2_box2_target_z;
MCNUM focus_aw = mccchannel_15_cave2_box2_focus_aw;
MCNUM focus_ah = mccchannel_15_cave2_box2_focus_ah;
MCNUM focus_xw = mccchannel_15_cave2_box2_focus_xw;
MCNUM focus_xh = mccchannel_15_cave2_box2_focus_xh;
MCNUM focus_r = mccchannel_15_cave2_box2_focus_r;
MCNUM p_interact = mccchannel_15_cave2_box2_p_interact;
char* mask_string = mccchannel_15_cave2_box2_mask_string;
char* mask_setting = mccchannel_15_cave2_box2_mask_setting;
MCNUM number_of_activations = mccchannel_15_cave2_box2_number_of_activations;
}   /* End of channel_15_cave2_box2=Union_box() SETTING parameter declarations. */
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex
  /* Label for restoring  neutron */
  mcabsorbCompchannel_15_cave2_box2:
  if (RESTORE) /* restore if needed */
  { RESTORE_NEUTRON(722,
      mcnlx,
      mcnly,
      mcnlz,
      mcnlvx,
      mcnlvy,
      mcnlvz,
      mcnlt,
      mcnlsx,
      mcnlsy,
      mcnlsz,
      mcnlp); }
#undef mcabsorbComp
#undef p
#undef sz
#undef sy
#undef sx
#undef t
#undef vz
#undef vy
#undef vx
#undef z
#undef y
#undef x
  mcDEBUG_STATE(
mcnlx,
mcnly,
mcnlz,
mcnlvx,
mcnlvy,
mcnlvz,
mcnlt,
mcnlsx,
mcnlsy,
mcnlsz,
mcnlp)

  /* TRACE Component channel_15_cave2_box3 [723] */
  mccoordschange(mcposrchannel_15_cave2_box3, mcrotrchannel_15_cave2_box3,
    &mcnlx,
    &mcnly,
    &mcnlz,
    &mcnlvx,
    &mcnlvy,
    &mcnlvz,
    &mcnlsx,
    &mcnlsy,
    &mcnlsz);
  /* define label inside component channel_15_cave2_box3 (without coords transformations) */
  mcJumpTrace_channel_15_cave2_box3:
  SIG_MESSAGE("channel_15_cave2_box3 (Trace)");
  mcDEBUG_COMP("channel_15_cave2_box3")
  mcDEBUG_STATE(
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp)
#define x mcnlx
#define y mcnly
#define z mcnlz
#define vx mcnlvx
#define vy mcnlvy
#define vz mcnlvz
#define t mcnlt
#define sx mcnlsx
#define sy mcnlsy
#define sz mcnlsz
#define p mcnlp

#define mcabsorbComp mcabsorbCompchannel_15_cave2_box3
  STORE_NEUTRON(723,
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp);
  mcScattered=0;
  mcRestore=0;
  mcNCounter[723]++;
  mcPCounter[723] += p;
  mcP2Counter[723] += p*p;
#define mccompcurname  channel_15_cave2_box3
#define mccompcurtype  Union_box
#define mccompcurindex 723
#define loop_index mccchannel_15_cave2_box3_loop_index
#define this_box_volume mccchannel_15_cave2_box3_this_box_volume
#define global_geometry_element mccchannel_15_cave2_box3_global_geometry_element
#define this_box_storage mccchannel_15_cave2_box3_this_box_storage
{   /* Declarations of channel_15_cave2_box3=Union_box() SETTING parameters. */
char* material_string = mccchannel_15_cave2_box3_material_string;
MCNUM priority = mccchannel_15_cave2_box3_priority;
MCNUM xwidth = mccchannel_15_cave2_box3_xwidth;
MCNUM yheight = mccchannel_15_cave2_box3_yheight;
MCNUM zdepth = mccchannel_15_cave2_box3_zdepth;
MCNUM xwidth2 = mccchannel_15_cave2_box3_xwidth2;
MCNUM yheight2 = mccchannel_15_cave2_box3_yheight2;
MCNUM visualize = mccchannel_15_cave2_box3_visualize;
int target_index = mccchannel_15_cave2_box3_target_index;
MCNUM target_x = mccchannel_15_cave2_box3_target_x;
MCNUM target_y = mccchannel_15_cave2_box3_target_y;
MCNUM target_z = mccchannel_15_cave2_box3_target_z;
MCNUM focus_aw = mccchannel_15_cave2_box3_focus_aw;
MCNUM focus_ah = mccchannel_15_cave2_box3_focus_ah;
MCNUM focus_xw = mccchannel_15_cave2_box3_focus_xw;
MCNUM focus_xh = mccchannel_15_cave2_box3_focus_xh;
MCNUM focus_r = mccchannel_15_cave2_box3_focus_r;
MCNUM p_interact = mccchannel_15_cave2_box3_p_interact;
char* mask_string = mccchannel_15_cave2_box3_mask_string;
char* mask_setting = mccchannel_15_cave2_box3_mask_setting;
MCNUM number_of_activations = mccchannel_15_cave2_box3_number_of_activations;
}   /* End of channel_15_cave2_box3=Union_box() SETTING parameter declarations. */
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex
  /* Label for restoring  neutron */
  mcabsorbCompchannel_15_cave2_box3:
  if (RESTORE) /* restore if needed */
  { RESTORE_NEUTRON(723,
      mcnlx,
      mcnly,
      mcnlz,
      mcnlvx,
      mcnlvy,
      mcnlvz,
      mcnlt,
      mcnlsx,
      mcnlsy,
      mcnlsz,
      mcnlp); }
#undef mcabsorbComp
#undef p
#undef sz
#undef sy
#undef sx
#undef t
#undef vz
#undef vy
#undef vx
#undef z
#undef y
#undef x
  mcDEBUG_STATE(
mcnlx,
mcnly,
mcnlz,
mcnlvx,
mcnlvy,
mcnlvz,
mcnlt,
mcnlsx,
mcnlsy,
mcnlsz,
mcnlp)

  /* TRACE Component inter_analyzer_colimator_center_15 [724] */
  mccoordschange(mcposrinter_analyzer_colimator_center_15, mcrotrinter_analyzer_colimator_center_15,
    &mcnlx,
    &mcnly,
    &mcnlz,
    &mcnlvx,
    &mcnlvy,
    &mcnlvz,
    &mcnlsx,
    &mcnlsy,
    &mcnlsz);
  /* define label inside component inter_analyzer_colimator_center_15 (without coords transformations) */
  mcJumpTrace_inter_analyzer_colimator_center_15:
  SIG_MESSAGE("inter_analyzer_colimator_center_15 (Trace)");
  mcDEBUG_COMP("inter_analyzer_colimator_center_15")
  mcDEBUG_STATE(
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp)
#define x mcnlx
#define y mcnly
#define z mcnlz
#define vx mcnlvx
#define vy mcnlvy
#define vz mcnlvz
#define t mcnlt
#define sx mcnlsx
#define sy mcnlsy
#define sz mcnlsz
#define p mcnlp

#define mcabsorbComp mcabsorbCompinter_analyzer_colimator_center_15
  STORE_NEUTRON(724,
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp);
  mcScattered=0;
  mcRestore=0;
  mcNCounter[724]++;
  mcPCounter[724] += p;
  mcP2Counter[724] += p*p;
#define mccompcurname  inter_analyzer_colimator_center_15
#define mccompcurtype  Arm
#define mccompcurindex 724
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex
  /* Label for restoring  neutron */
  mcabsorbCompinter_analyzer_colimator_center_15:
  if (RESTORE) /* restore if needed */
  { RESTORE_NEUTRON(724,
      mcnlx,
      mcnly,
      mcnlz,
      mcnlvx,
      mcnlvy,
      mcnlvz,
      mcnlt,
      mcnlsx,
      mcnlsy,
      mcnlsz,
      mcnlp); }
#undef mcabsorbComp
#undef p
#undef sz
#undef sy
#undef sx
#undef t
#undef vz
#undef vy
#undef vx
#undef z
#undef y
#undef x
  mcDEBUG_STATE(
mcnlx,
mcnly,
mcnlz,
mcnlvx,
mcnlvy,
mcnlvz,
mcnlt,
mcnlsx,
mcnlsy,
mcnlsz,
mcnlp)

  /* TRACE Component inter_analyzer_colimator_15_blade_0 [725] */
  mccoordschange(mcposrinter_analyzer_colimator_15_blade_0, mcrotrinter_analyzer_colimator_15_blade_0,
    &mcnlx,
    &mcnly,
    &mcnlz,
    &mcnlvx,
    &mcnlvy,
    &mcnlvz,
    &mcnlsx,
    &mcnlsy,
    &mcnlsz);
  /* define label inside component inter_analyzer_colimator_15_blade_0 (without coords transformations) */
  mcJumpTrace_inter_analyzer_colimator_15_blade_0:
  SIG_MESSAGE("inter_analyzer_colimator_15_blade_0 (Trace)");
  mcDEBUG_COMP("inter_analyzer_colimator_15_blade_0")
  mcDEBUG_STATE(
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp)
#define x mcnlx
#define y mcnly
#define z mcnlz
#define vx mcnlvx
#define vy mcnlvy
#define vz mcnlvz
#define t mcnlt
#define sx mcnlsx
#define sy mcnlsy
#define sz mcnlsz
#define p mcnlp

#define mcabsorbComp mcabsorbCompinter_analyzer_colimator_15_blade_0
  STORE_NEUTRON(725,
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp);
  mcScattered=0;
  mcRestore=0;
  mcNCounter[725]++;
  mcPCounter[725] += p;
  mcP2Counter[725] += p*p;
#define mccompcurname  inter_analyzer_colimator_15_blade_0
#define mccompcurtype  Union_box
#define mccompcurindex 725
#define loop_index mccinter_analyzer_colimator_15_blade_0_loop_index
#define this_box_volume mccinter_analyzer_colimator_15_blade_0_this_box_volume
#define global_geometry_element mccinter_analyzer_colimator_15_blade_0_global_geometry_element
#define this_box_storage mccinter_analyzer_colimator_15_blade_0_this_box_storage
{   /* Declarations of inter_analyzer_colimator_15_blade_0=Union_box() SETTING parameters. */
char* material_string = mccinter_analyzer_colimator_15_blade_0_material_string;
MCNUM priority = mccinter_analyzer_colimator_15_blade_0_priority;
MCNUM xwidth = mccinter_analyzer_colimator_15_blade_0_xwidth;
MCNUM yheight = mccinter_analyzer_colimator_15_blade_0_yheight;
MCNUM zdepth = mccinter_analyzer_colimator_15_blade_0_zdepth;
MCNUM xwidth2 = mccinter_analyzer_colimator_15_blade_0_xwidth2;
MCNUM yheight2 = mccinter_analyzer_colimator_15_blade_0_yheight2;
MCNUM visualize = mccinter_analyzer_colimator_15_blade_0_visualize;
int target_index = mccinter_analyzer_colimator_15_blade_0_target_index;
MCNUM target_x = mccinter_analyzer_colimator_15_blade_0_target_x;
MCNUM target_y = mccinter_analyzer_colimator_15_blade_0_target_y;
MCNUM target_z = mccinter_analyzer_colimator_15_blade_0_target_z;
MCNUM focus_aw = mccinter_analyzer_colimator_15_blade_0_focus_aw;
MCNUM focus_ah = mccinter_analyzer_colimator_15_blade_0_focus_ah;
MCNUM focus_xw = mccinter_analyzer_colimator_15_blade_0_focus_xw;
MCNUM focus_xh = mccinter_analyzer_colimator_15_blade_0_focus_xh;
MCNUM focus_r = mccinter_analyzer_colimator_15_blade_0_focus_r;
MCNUM p_interact = mccinter_analyzer_colimator_15_blade_0_p_interact;
char* mask_string = mccinter_analyzer_colimator_15_blade_0_mask_string;
char* mask_setting = mccinter_analyzer_colimator_15_blade_0_mask_setting;
MCNUM number_of_activations = mccinter_analyzer_colimator_15_blade_0_number_of_activations;
}   /* End of inter_analyzer_colimator_15_blade_0=Union_box() SETTING parameter declarations. */
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex
  /* Label for restoring  neutron */
  mcabsorbCompinter_analyzer_colimator_15_blade_0:
  if (RESTORE) /* restore if needed */
  { RESTORE_NEUTRON(725,
      mcnlx,
      mcnly,
      mcnlz,
      mcnlvx,
      mcnlvy,
      mcnlvz,
      mcnlt,
      mcnlsx,
      mcnlsy,
      mcnlsz,
      mcnlp); }
#undef mcabsorbComp
#undef p
#undef sz
#undef sy
#undef sx
#undef t
#undef vz
#undef vy
#undef vx
#undef z
#undef y
#undef x
  mcDEBUG_STATE(
mcnlx,
mcnly,
mcnlz,
mcnlvx,
mcnlvy,
mcnlvz,
mcnlt,
mcnlsx,
mcnlsy,
mcnlsz,
mcnlp)

  /* TRACE Component inter_analyzer_colimator_15_blade_1 [726] */
  mccoordschange(mcposrinter_analyzer_colimator_15_blade_1, mcrotrinter_analyzer_colimator_15_blade_1,
    &mcnlx,
    &mcnly,
    &mcnlz,
    &mcnlvx,
    &mcnlvy,
    &mcnlvz,
    &mcnlsx,
    &mcnlsy,
    &mcnlsz);
  /* define label inside component inter_analyzer_colimator_15_blade_1 (without coords transformations) */
  mcJumpTrace_inter_analyzer_colimator_15_blade_1:
  SIG_MESSAGE("inter_analyzer_colimator_15_blade_1 (Trace)");
  mcDEBUG_COMP("inter_analyzer_colimator_15_blade_1")
  mcDEBUG_STATE(
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp)
#define x mcnlx
#define y mcnly
#define z mcnlz
#define vx mcnlvx
#define vy mcnlvy
#define vz mcnlvz
#define t mcnlt
#define sx mcnlsx
#define sy mcnlsy
#define sz mcnlsz
#define p mcnlp

#define mcabsorbComp mcabsorbCompinter_analyzer_colimator_15_blade_1
  STORE_NEUTRON(726,
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp);
  mcScattered=0;
  mcRestore=0;
  mcNCounter[726]++;
  mcPCounter[726] += p;
  mcP2Counter[726] += p*p;
#define mccompcurname  inter_analyzer_colimator_15_blade_1
#define mccompcurtype  Union_box
#define mccompcurindex 726
#define loop_index mccinter_analyzer_colimator_15_blade_1_loop_index
#define this_box_volume mccinter_analyzer_colimator_15_blade_1_this_box_volume
#define global_geometry_element mccinter_analyzer_colimator_15_blade_1_global_geometry_element
#define this_box_storage mccinter_analyzer_colimator_15_blade_1_this_box_storage
{   /* Declarations of inter_analyzer_colimator_15_blade_1=Union_box() SETTING parameters. */
char* material_string = mccinter_analyzer_colimator_15_blade_1_material_string;
MCNUM priority = mccinter_analyzer_colimator_15_blade_1_priority;
MCNUM xwidth = mccinter_analyzer_colimator_15_blade_1_xwidth;
MCNUM yheight = mccinter_analyzer_colimator_15_blade_1_yheight;
MCNUM zdepth = mccinter_analyzer_colimator_15_blade_1_zdepth;
MCNUM xwidth2 = mccinter_analyzer_colimator_15_blade_1_xwidth2;
MCNUM yheight2 = mccinter_analyzer_colimator_15_blade_1_yheight2;
MCNUM visualize = mccinter_analyzer_colimator_15_blade_1_visualize;
int target_index = mccinter_analyzer_colimator_15_blade_1_target_index;
MCNUM target_x = mccinter_analyzer_colimator_15_blade_1_target_x;
MCNUM target_y = mccinter_analyzer_colimator_15_blade_1_target_y;
MCNUM target_z = mccinter_analyzer_colimator_15_blade_1_target_z;
MCNUM focus_aw = mccinter_analyzer_colimator_15_blade_1_focus_aw;
MCNUM focus_ah = mccinter_analyzer_colimator_15_blade_1_focus_ah;
MCNUM focus_xw = mccinter_analyzer_colimator_15_blade_1_focus_xw;
MCNUM focus_xh = mccinter_analyzer_colimator_15_blade_1_focus_xh;
MCNUM focus_r = mccinter_analyzer_colimator_15_blade_1_focus_r;
MCNUM p_interact = mccinter_analyzer_colimator_15_blade_1_p_interact;
char* mask_string = mccinter_analyzer_colimator_15_blade_1_mask_string;
char* mask_setting = mccinter_analyzer_colimator_15_blade_1_mask_setting;
MCNUM number_of_activations = mccinter_analyzer_colimator_15_blade_1_number_of_activations;
}   /* End of inter_analyzer_colimator_15_blade_1=Union_box() SETTING parameter declarations. */
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex
  /* Label for restoring  neutron */
  mcabsorbCompinter_analyzer_colimator_15_blade_1:
  if (RESTORE) /* restore if needed */
  { RESTORE_NEUTRON(726,
      mcnlx,
      mcnly,
      mcnlz,
      mcnlvx,
      mcnlvy,
      mcnlvz,
      mcnlt,
      mcnlsx,
      mcnlsy,
      mcnlsz,
      mcnlp); }
#undef mcabsorbComp
#undef p
#undef sz
#undef sy
#undef sx
#undef t
#undef vz
#undef vy
#undef vx
#undef z
#undef y
#undef x
  mcDEBUG_STATE(
mcnlx,
mcnly,
mcnlz,
mcnlvx,
mcnlvy,
mcnlvz,
mcnlt,
mcnlsx,
mcnlsy,
mcnlsz,
mcnlp)

  /* TRACE Component inter_analyzer_colimator_15_blade_2 [727] */
  mccoordschange(mcposrinter_analyzer_colimator_15_blade_2, mcrotrinter_analyzer_colimator_15_blade_2,
    &mcnlx,
    &mcnly,
    &mcnlz,
    &mcnlvx,
    &mcnlvy,
    &mcnlvz,
    &mcnlsx,
    &mcnlsy,
    &mcnlsz);
  /* define label inside component inter_analyzer_colimator_15_blade_2 (without coords transformations) */
  mcJumpTrace_inter_analyzer_colimator_15_blade_2:
  SIG_MESSAGE("inter_analyzer_colimator_15_blade_2 (Trace)");
  mcDEBUG_COMP("inter_analyzer_colimator_15_blade_2")
  mcDEBUG_STATE(
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp)
#define x mcnlx
#define y mcnly
#define z mcnlz
#define vx mcnlvx
#define vy mcnlvy
#define vz mcnlvz
#define t mcnlt
#define sx mcnlsx
#define sy mcnlsy
#define sz mcnlsz
#define p mcnlp

#define mcabsorbComp mcabsorbCompinter_analyzer_colimator_15_blade_2
  STORE_NEUTRON(727,
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp);
  mcScattered=0;
  mcRestore=0;
  mcNCounter[727]++;
  mcPCounter[727] += p;
  mcP2Counter[727] += p*p;
#define mccompcurname  inter_analyzer_colimator_15_blade_2
#define mccompcurtype  Union_box
#define mccompcurindex 727
#define loop_index mccinter_analyzer_colimator_15_blade_2_loop_index
#define this_box_volume mccinter_analyzer_colimator_15_blade_2_this_box_volume
#define global_geometry_element mccinter_analyzer_colimator_15_blade_2_global_geometry_element
#define this_box_storage mccinter_analyzer_colimator_15_blade_2_this_box_storage
{   /* Declarations of inter_analyzer_colimator_15_blade_2=Union_box() SETTING parameters. */
char* material_string = mccinter_analyzer_colimator_15_blade_2_material_string;
MCNUM priority = mccinter_analyzer_colimator_15_blade_2_priority;
MCNUM xwidth = mccinter_analyzer_colimator_15_blade_2_xwidth;
MCNUM yheight = mccinter_analyzer_colimator_15_blade_2_yheight;
MCNUM zdepth = mccinter_analyzer_colimator_15_blade_2_zdepth;
MCNUM xwidth2 = mccinter_analyzer_colimator_15_blade_2_xwidth2;
MCNUM yheight2 = mccinter_analyzer_colimator_15_blade_2_yheight2;
MCNUM visualize = mccinter_analyzer_colimator_15_blade_2_visualize;
int target_index = mccinter_analyzer_colimator_15_blade_2_target_index;
MCNUM target_x = mccinter_analyzer_colimator_15_blade_2_target_x;
MCNUM target_y = mccinter_analyzer_colimator_15_blade_2_target_y;
MCNUM target_z = mccinter_analyzer_colimator_15_blade_2_target_z;
MCNUM focus_aw = mccinter_analyzer_colimator_15_blade_2_focus_aw;
MCNUM focus_ah = mccinter_analyzer_colimator_15_blade_2_focus_ah;
MCNUM focus_xw = mccinter_analyzer_colimator_15_blade_2_focus_xw;
MCNUM focus_xh = mccinter_analyzer_colimator_15_blade_2_focus_xh;
MCNUM focus_r = mccinter_analyzer_colimator_15_blade_2_focus_r;
MCNUM p_interact = mccinter_analyzer_colimator_15_blade_2_p_interact;
char* mask_string = mccinter_analyzer_colimator_15_blade_2_mask_string;
char* mask_setting = mccinter_analyzer_colimator_15_blade_2_mask_setting;
MCNUM number_of_activations = mccinter_analyzer_colimator_15_blade_2_number_of_activations;
}   /* End of inter_analyzer_colimator_15_blade_2=Union_box() SETTING parameter declarations. */
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex
  /* Label for restoring  neutron */
  mcabsorbCompinter_analyzer_colimator_15_blade_2:
  if (RESTORE) /* restore if needed */
  { RESTORE_NEUTRON(727,
      mcnlx,
      mcnly,
      mcnlz,
      mcnlvx,
      mcnlvy,
      mcnlvz,
      mcnlt,
      mcnlsx,
      mcnlsy,
      mcnlsz,
      mcnlp); }
#undef mcabsorbComp
#undef p
#undef sz
#undef sy
#undef sx
#undef t
#undef vz
#undef vy
#undef vx
#undef z
#undef y
#undef x
  mcDEBUG_STATE(
mcnlx,
mcnly,
mcnlz,
mcnlvx,
mcnlvy,
mcnlvz,
mcnlt,
mcnlsx,
mcnlsy,
mcnlsz,
mcnlp)

  /* TRACE Component inter_analyzer_colimator_15_blade_3 [728] */
  mccoordschange(mcposrinter_analyzer_colimator_15_blade_3, mcrotrinter_analyzer_colimator_15_blade_3,
    &mcnlx,
    &mcnly,
    &mcnlz,
    &mcnlvx,
    &mcnlvy,
    &mcnlvz,
    &mcnlsx,
    &mcnlsy,
    &mcnlsz);
  /* define label inside component inter_analyzer_colimator_15_blade_3 (without coords transformations) */
  mcJumpTrace_inter_analyzer_colimator_15_blade_3:
  SIG_MESSAGE("inter_analyzer_colimator_15_blade_3 (Trace)");
  mcDEBUG_COMP("inter_analyzer_colimator_15_blade_3")
  mcDEBUG_STATE(
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp)
#define x mcnlx
#define y mcnly
#define z mcnlz
#define vx mcnlvx
#define vy mcnlvy
#define vz mcnlvz
#define t mcnlt
#define sx mcnlsx
#define sy mcnlsy
#define sz mcnlsz
#define p mcnlp

#define mcabsorbComp mcabsorbCompinter_analyzer_colimator_15_blade_3
  STORE_NEUTRON(728,
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp);
  mcScattered=0;
  mcRestore=0;
  mcNCounter[728]++;
  mcPCounter[728] += p;
  mcP2Counter[728] += p*p;
#define mccompcurname  inter_analyzer_colimator_15_blade_3
#define mccompcurtype  Union_box
#define mccompcurindex 728
#define loop_index mccinter_analyzer_colimator_15_blade_3_loop_index
#define this_box_volume mccinter_analyzer_colimator_15_blade_3_this_box_volume
#define global_geometry_element mccinter_analyzer_colimator_15_blade_3_global_geometry_element
#define this_box_storage mccinter_analyzer_colimator_15_blade_3_this_box_storage
{   /* Declarations of inter_analyzer_colimator_15_blade_3=Union_box() SETTING parameters. */
char* material_string = mccinter_analyzer_colimator_15_blade_3_material_string;
MCNUM priority = mccinter_analyzer_colimator_15_blade_3_priority;
MCNUM xwidth = mccinter_analyzer_colimator_15_blade_3_xwidth;
MCNUM yheight = mccinter_analyzer_colimator_15_blade_3_yheight;
MCNUM zdepth = mccinter_analyzer_colimator_15_blade_3_zdepth;
MCNUM xwidth2 = mccinter_analyzer_colimator_15_blade_3_xwidth2;
MCNUM yheight2 = mccinter_analyzer_colimator_15_blade_3_yheight2;
MCNUM visualize = mccinter_analyzer_colimator_15_blade_3_visualize;
int target_index = mccinter_analyzer_colimator_15_blade_3_target_index;
MCNUM target_x = mccinter_analyzer_colimator_15_blade_3_target_x;
MCNUM target_y = mccinter_analyzer_colimator_15_blade_3_target_y;
MCNUM target_z = mccinter_analyzer_colimator_15_blade_3_target_z;
MCNUM focus_aw = mccinter_analyzer_colimator_15_blade_3_focus_aw;
MCNUM focus_ah = mccinter_analyzer_colimator_15_blade_3_focus_ah;
MCNUM focus_xw = mccinter_analyzer_colimator_15_blade_3_focus_xw;
MCNUM focus_xh = mccinter_analyzer_colimator_15_blade_3_focus_xh;
MCNUM focus_r = mccinter_analyzer_colimator_15_blade_3_focus_r;
MCNUM p_interact = mccinter_analyzer_colimator_15_blade_3_p_interact;
char* mask_string = mccinter_analyzer_colimator_15_blade_3_mask_string;
char* mask_setting = mccinter_analyzer_colimator_15_blade_3_mask_setting;
MCNUM number_of_activations = mccinter_analyzer_colimator_15_blade_3_number_of_activations;
}   /* End of inter_analyzer_colimator_15_blade_3=Union_box() SETTING parameter declarations. */
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex
  /* Label for restoring  neutron */
  mcabsorbCompinter_analyzer_colimator_15_blade_3:
  if (RESTORE) /* restore if needed */
  { RESTORE_NEUTRON(728,
      mcnlx,
      mcnly,
      mcnlz,
      mcnlvx,
      mcnlvy,
      mcnlvz,
      mcnlt,
      mcnlsx,
      mcnlsy,
      mcnlsz,
      mcnlp); }
#undef mcabsorbComp
#undef p
#undef sz
#undef sy
#undef sx
#undef t
#undef vz
#undef vy
#undef vx
#undef z
#undef y
#undef x
  mcDEBUG_STATE(
mcnlx,
mcnly,
mcnlz,
mcnlvx,
mcnlvy,
mcnlvz,
mcnlt,
mcnlsx,
mcnlsy,
mcnlsz,
mcnlp)

  /* TRACE Component inter_analyzer_colimator_15_blade_4 [729] */
  mccoordschange(mcposrinter_analyzer_colimator_15_blade_4, mcrotrinter_analyzer_colimator_15_blade_4,
    &mcnlx,
    &mcnly,
    &mcnlz,
    &mcnlvx,
    &mcnlvy,
    &mcnlvz,
    &mcnlsx,
    &mcnlsy,
    &mcnlsz);
  /* define label inside component inter_analyzer_colimator_15_blade_4 (without coords transformations) */
  mcJumpTrace_inter_analyzer_colimator_15_blade_4:
  SIG_MESSAGE("inter_analyzer_colimator_15_blade_4 (Trace)");
  mcDEBUG_COMP("inter_analyzer_colimator_15_blade_4")
  mcDEBUG_STATE(
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp)
#define x mcnlx
#define y mcnly
#define z mcnlz
#define vx mcnlvx
#define vy mcnlvy
#define vz mcnlvz
#define t mcnlt
#define sx mcnlsx
#define sy mcnlsy
#define sz mcnlsz
#define p mcnlp

#define mcabsorbComp mcabsorbCompinter_analyzer_colimator_15_blade_4
  STORE_NEUTRON(729,
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp);
  mcScattered=0;
  mcRestore=0;
  mcNCounter[729]++;
  mcPCounter[729] += p;
  mcP2Counter[729] += p*p;
#define mccompcurname  inter_analyzer_colimator_15_blade_4
#define mccompcurtype  Union_box
#define mccompcurindex 729
#define loop_index mccinter_analyzer_colimator_15_blade_4_loop_index
#define this_box_volume mccinter_analyzer_colimator_15_blade_4_this_box_volume
#define global_geometry_element mccinter_analyzer_colimator_15_blade_4_global_geometry_element
#define this_box_storage mccinter_analyzer_colimator_15_blade_4_this_box_storage
{   /* Declarations of inter_analyzer_colimator_15_blade_4=Union_box() SETTING parameters. */
char* material_string = mccinter_analyzer_colimator_15_blade_4_material_string;
MCNUM priority = mccinter_analyzer_colimator_15_blade_4_priority;
MCNUM xwidth = mccinter_analyzer_colimator_15_blade_4_xwidth;
MCNUM yheight = mccinter_analyzer_colimator_15_blade_4_yheight;
MCNUM zdepth = mccinter_analyzer_colimator_15_blade_4_zdepth;
MCNUM xwidth2 = mccinter_analyzer_colimator_15_blade_4_xwidth2;
MCNUM yheight2 = mccinter_analyzer_colimator_15_blade_4_yheight2;
MCNUM visualize = mccinter_analyzer_colimator_15_blade_4_visualize;
int target_index = mccinter_analyzer_colimator_15_blade_4_target_index;
MCNUM target_x = mccinter_analyzer_colimator_15_blade_4_target_x;
MCNUM target_y = mccinter_analyzer_colimator_15_blade_4_target_y;
MCNUM target_z = mccinter_analyzer_colimator_15_blade_4_target_z;
MCNUM focus_aw = mccinter_analyzer_colimator_15_blade_4_focus_aw;
MCNUM focus_ah = mccinter_analyzer_colimator_15_blade_4_focus_ah;
MCNUM focus_xw = mccinter_analyzer_colimator_15_blade_4_focus_xw;
MCNUM focus_xh = mccinter_analyzer_colimator_15_blade_4_focus_xh;
MCNUM focus_r = mccinter_analyzer_colimator_15_blade_4_focus_r;
MCNUM p_interact = mccinter_analyzer_colimator_15_blade_4_p_interact;
char* mask_string = mccinter_analyzer_colimator_15_blade_4_mask_string;
char* mask_setting = mccinter_analyzer_colimator_15_blade_4_mask_setting;
MCNUM number_of_activations = mccinter_analyzer_colimator_15_blade_4_number_of_activations;
}   /* End of inter_analyzer_colimator_15_blade_4=Union_box() SETTING parameter declarations. */
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex
  /* Label for restoring  neutron */
  mcabsorbCompinter_analyzer_colimator_15_blade_4:
  if (RESTORE) /* restore if needed */
  { RESTORE_NEUTRON(729,
      mcnlx,
      mcnly,
      mcnlz,
      mcnlvx,
      mcnlvy,
      mcnlvz,
      mcnlt,
      mcnlsx,
      mcnlsy,
      mcnlsz,
      mcnlp); }
#undef mcabsorbComp
#undef p
#undef sz
#undef sy
#undef sx
#undef t
#undef vz
#undef vy
#undef vx
#undef z
#undef y
#undef x
  mcDEBUG_STATE(
mcnlx,
mcnly,
mcnlz,
mcnlvx,
mcnlvy,
mcnlvz,
mcnlt,
mcnlsx,
mcnlsy,
mcnlsz,
mcnlp)

  /* TRACE Component diffraction_detector_15_exit_volume [730] */
  mccoordschange(mcposrdiffraction_detector_15_exit_volume, mcrotrdiffraction_detector_15_exit_volume,
    &mcnlx,
    &mcnly,
    &mcnlz,
    &mcnlvx,
    &mcnlvy,
    &mcnlvz,
    &mcnlsx,
    &mcnlsy,
    &mcnlsz);
  /* define label inside component diffraction_detector_15_exit_volume (without coords transformations) */
  mcJumpTrace_diffraction_detector_15_exit_volume:
  SIG_MESSAGE("diffraction_detector_15_exit_volume (Trace)");
  mcDEBUG_COMP("diffraction_detector_15_exit_volume")
  mcDEBUG_STATE(
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp)
#define x mcnlx
#define y mcnly
#define z mcnlz
#define vx mcnlvx
#define vy mcnlvy
#define vz mcnlvz
#define t mcnlt
#define sx mcnlsx
#define sy mcnlsy
#define sz mcnlsz
#define p mcnlp

#define mcabsorbComp mcabsorbCompdiffraction_detector_15_exit_volume
  STORE_NEUTRON(730,
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp);
  mcScattered=0;
  mcRestore=0;
  mcNCounter[730]++;
  mcPCounter[730] += p;
  mcP2Counter[730] += p*p;
#define mccompcurname  diffraction_detector_15_exit_volume
#define mccompcurtype  Union_box
#define mccompcurindex 730
#define loop_index mccdiffraction_detector_15_exit_volume_loop_index
#define this_box_volume mccdiffraction_detector_15_exit_volume_this_box_volume
#define global_geometry_element mccdiffraction_detector_15_exit_volume_global_geometry_element
#define this_box_storage mccdiffraction_detector_15_exit_volume_this_box_storage
{   /* Declarations of diffraction_detector_15_exit_volume=Union_box() SETTING parameters. */
char* material_string = mccdiffraction_detector_15_exit_volume_material_string;
MCNUM priority = mccdiffraction_detector_15_exit_volume_priority;
MCNUM xwidth = mccdiffraction_detector_15_exit_volume_xwidth;
MCNUM yheight = mccdiffraction_detector_15_exit_volume_yheight;
MCNUM zdepth = mccdiffraction_detector_15_exit_volume_zdepth;
MCNUM xwidth2 = mccdiffraction_detector_15_exit_volume_xwidth2;
MCNUM yheight2 = mccdiffraction_detector_15_exit_volume_yheight2;
MCNUM visualize = mccdiffraction_detector_15_exit_volume_visualize;
int target_index = mccdiffraction_detector_15_exit_volume_target_index;
MCNUM target_x = mccdiffraction_detector_15_exit_volume_target_x;
MCNUM target_y = mccdiffraction_detector_15_exit_volume_target_y;
MCNUM target_z = mccdiffraction_detector_15_exit_volume_target_z;
MCNUM focus_aw = mccdiffraction_detector_15_exit_volume_focus_aw;
MCNUM focus_ah = mccdiffraction_detector_15_exit_volume_focus_ah;
MCNUM focus_xw = mccdiffraction_detector_15_exit_volume_focus_xw;
MCNUM focus_xh = mccdiffraction_detector_15_exit_volume_focus_xh;
MCNUM focus_r = mccdiffraction_detector_15_exit_volume_focus_r;
MCNUM p_interact = mccdiffraction_detector_15_exit_volume_p_interact;
char* mask_string = mccdiffraction_detector_15_exit_volume_mask_string;
char* mask_setting = mccdiffraction_detector_15_exit_volume_mask_setting;
MCNUM number_of_activations = mccdiffraction_detector_15_exit_volume_number_of_activations;
}   /* End of diffraction_detector_15_exit_volume=Union_box() SETTING parameter declarations. */
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex
  /* Label for restoring  neutron */
  mcabsorbCompdiffraction_detector_15_exit_volume:
  if (RESTORE) /* restore if needed */
  { RESTORE_NEUTRON(730,
      mcnlx,
      mcnly,
      mcnlz,
      mcnlvx,
      mcnlvy,
      mcnlvz,
      mcnlt,
      mcnlsx,
      mcnlsy,
      mcnlsz,
      mcnlp); }
#undef mcabsorbComp
#undef p
#undef sz
#undef sy
#undef sx
#undef t
#undef vz
#undef vy
#undef vx
#undef z
#undef y
#undef x
  mcDEBUG_STATE(
mcnlx,
mcnly,
mcnlz,
mcnlvx,
mcnlvy,
mcnlvz,
mcnlt,
mcnlsx,
mcnlsy,
mcnlsz,
mcnlp)

  /* TRACE Component spec_detector_15_exit_volume [731] */
  mccoordschange(mcposrspec_detector_15_exit_volume, mcrotrspec_detector_15_exit_volume,
    &mcnlx,
    &mcnly,
    &mcnlz,
    &mcnlvx,
    &mcnlvy,
    &mcnlvz,
    &mcnlsx,
    &mcnlsy,
    &mcnlsz);
  /* define label inside component spec_detector_15_exit_volume (without coords transformations) */
  mcJumpTrace_spec_detector_15_exit_volume:
  SIG_MESSAGE("spec_detector_15_exit_volume (Trace)");
  mcDEBUG_COMP("spec_detector_15_exit_volume")
  mcDEBUG_STATE(
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp)
#define x mcnlx
#define y mcnly
#define z mcnlz
#define vx mcnlvx
#define vy mcnlvy
#define vz mcnlvz
#define t mcnlt
#define sx mcnlsx
#define sy mcnlsy
#define sz mcnlsz
#define p mcnlp

#define mcabsorbComp mcabsorbCompspec_detector_15_exit_volume
  STORE_NEUTRON(731,
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp);
  mcScattered=0;
  mcRestore=0;
  mcNCounter[731]++;
  mcPCounter[731] += p;
  mcP2Counter[731] += p*p;
#define mccompcurname  spec_detector_15_exit_volume
#define mccompcurtype  Union_box
#define mccompcurindex 731
#define loop_index mccspec_detector_15_exit_volume_loop_index
#define this_box_volume mccspec_detector_15_exit_volume_this_box_volume
#define global_geometry_element mccspec_detector_15_exit_volume_global_geometry_element
#define this_box_storage mccspec_detector_15_exit_volume_this_box_storage
{   /* Declarations of spec_detector_15_exit_volume=Union_box() SETTING parameters. */
char* material_string = mccspec_detector_15_exit_volume_material_string;
MCNUM priority = mccspec_detector_15_exit_volume_priority;
MCNUM xwidth = mccspec_detector_15_exit_volume_xwidth;
MCNUM yheight = mccspec_detector_15_exit_volume_yheight;
MCNUM zdepth = mccspec_detector_15_exit_volume_zdepth;
MCNUM xwidth2 = mccspec_detector_15_exit_volume_xwidth2;
MCNUM yheight2 = mccspec_detector_15_exit_volume_yheight2;
MCNUM visualize = mccspec_detector_15_exit_volume_visualize;
int target_index = mccspec_detector_15_exit_volume_target_index;
MCNUM target_x = mccspec_detector_15_exit_volume_target_x;
MCNUM target_y = mccspec_detector_15_exit_volume_target_y;
MCNUM target_z = mccspec_detector_15_exit_volume_target_z;
MCNUM focus_aw = mccspec_detector_15_exit_volume_focus_aw;
MCNUM focus_ah = mccspec_detector_15_exit_volume_focus_ah;
MCNUM focus_xw = mccspec_detector_15_exit_volume_focus_xw;
MCNUM focus_xh = mccspec_detector_15_exit_volume_focus_xh;
MCNUM focus_r = mccspec_detector_15_exit_volume_focus_r;
MCNUM p_interact = mccspec_detector_15_exit_volume_p_interact;
char* mask_string = mccspec_detector_15_exit_volume_mask_string;
char* mask_setting = mccspec_detector_15_exit_volume_mask_setting;
MCNUM number_of_activations = mccspec_detector_15_exit_volume_number_of_activations;
}   /* End of spec_detector_15_exit_volume=Union_box() SETTING parameter declarations. */
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex
  /* Label for restoring  neutron */
  mcabsorbCompspec_detector_15_exit_volume:
  if (RESTORE) /* restore if needed */
  { RESTORE_NEUTRON(731,
      mcnlx,
      mcnly,
      mcnlz,
      mcnlvx,
      mcnlvy,
      mcnlvz,
      mcnlt,
      mcnlsx,
      mcnlsy,
      mcnlsz,
      mcnlp); }
#undef mcabsorbComp
#undef p
#undef sz
#undef sy
#undef sx
#undef t
#undef vz
#undef vy
#undef vx
#undef z
#undef y
#undef x
  mcDEBUG_STATE(
mcnlx,
mcnly,
mcnlz,
mcnlvx,
mcnlvy,
mcnlvz,
mcnlt,
mcnlsx,
mcnlsy,
mcnlsz,
mcnlp)

  /* TRACE Component channel_16_cave1_box1 [732] */
  mccoordschange(mcposrchannel_16_cave1_box1, mcrotrchannel_16_cave1_box1,
    &mcnlx,
    &mcnly,
    &mcnlz,
    &mcnlvx,
    &mcnlvy,
    &mcnlvz,
    &mcnlsx,
    &mcnlsy,
    &mcnlsz);
  /* define label inside component channel_16_cave1_box1 (without coords transformations) */
  mcJumpTrace_channel_16_cave1_box1:
  SIG_MESSAGE("channel_16_cave1_box1 (Trace)");
  mcDEBUG_COMP("channel_16_cave1_box1")
  mcDEBUG_STATE(
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp)
#define x mcnlx
#define y mcnly
#define z mcnlz
#define vx mcnlvx
#define vy mcnlvy
#define vz mcnlvz
#define t mcnlt
#define sx mcnlsx
#define sy mcnlsy
#define sz mcnlsz
#define p mcnlp

#define mcabsorbComp mcabsorbCompchannel_16_cave1_box1
  STORE_NEUTRON(732,
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp);
  mcScattered=0;
  mcRestore=0;
  mcNCounter[732]++;
  mcPCounter[732] += p;
  mcP2Counter[732] += p*p;
#define mccompcurname  channel_16_cave1_box1
#define mccompcurtype  Union_box
#define mccompcurindex 732
#define loop_index mccchannel_16_cave1_box1_loop_index
#define this_box_volume mccchannel_16_cave1_box1_this_box_volume
#define global_geometry_element mccchannel_16_cave1_box1_global_geometry_element
#define this_box_storage mccchannel_16_cave1_box1_this_box_storage
{   /* Declarations of channel_16_cave1_box1=Union_box() SETTING parameters. */
char* material_string = mccchannel_16_cave1_box1_material_string;
MCNUM priority = mccchannel_16_cave1_box1_priority;
MCNUM xwidth = mccchannel_16_cave1_box1_xwidth;
MCNUM yheight = mccchannel_16_cave1_box1_yheight;
MCNUM zdepth = mccchannel_16_cave1_box1_zdepth;
MCNUM xwidth2 = mccchannel_16_cave1_box1_xwidth2;
MCNUM yheight2 = mccchannel_16_cave1_box1_yheight2;
MCNUM visualize = mccchannel_16_cave1_box1_visualize;
int target_index = mccchannel_16_cave1_box1_target_index;
MCNUM target_x = mccchannel_16_cave1_box1_target_x;
MCNUM target_y = mccchannel_16_cave1_box1_target_y;
MCNUM target_z = mccchannel_16_cave1_box1_target_z;
MCNUM focus_aw = mccchannel_16_cave1_box1_focus_aw;
MCNUM focus_ah = mccchannel_16_cave1_box1_focus_ah;
MCNUM focus_xw = mccchannel_16_cave1_box1_focus_xw;
MCNUM focus_xh = mccchannel_16_cave1_box1_focus_xh;
MCNUM focus_r = mccchannel_16_cave1_box1_focus_r;
MCNUM p_interact = mccchannel_16_cave1_box1_p_interact;
char* mask_string = mccchannel_16_cave1_box1_mask_string;
char* mask_setting = mccchannel_16_cave1_box1_mask_setting;
MCNUM number_of_activations = mccchannel_16_cave1_box1_number_of_activations;
}   /* End of channel_16_cave1_box1=Union_box() SETTING parameter declarations. */
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex
  /* Label for restoring  neutron */
  mcabsorbCompchannel_16_cave1_box1:
  if (RESTORE) /* restore if needed */
  { RESTORE_NEUTRON(732,
      mcnlx,
      mcnly,
      mcnlz,
      mcnlvx,
      mcnlvy,
      mcnlvz,
      mcnlt,
      mcnlsx,
      mcnlsy,
      mcnlsz,
      mcnlp); }
#undef mcabsorbComp
#undef p
#undef sz
#undef sy
#undef sx
#undef t
#undef vz
#undef vy
#undef vx
#undef z
#undef y
#undef x
  mcDEBUG_STATE(
mcnlx,
mcnly,
mcnlz,
mcnlvx,
mcnlvy,
mcnlvz,
mcnlt,
mcnlsx,
mcnlsy,
mcnlsz,
mcnlp)

  /* TRACE Component channel_16_cave1_box2 [733] */
  mccoordschange(mcposrchannel_16_cave1_box2, mcrotrchannel_16_cave1_box2,
    &mcnlx,
    &mcnly,
    &mcnlz,
    &mcnlvx,
    &mcnlvy,
    &mcnlvz,
    &mcnlsx,
    &mcnlsy,
    &mcnlsz);
  /* define label inside component channel_16_cave1_box2 (without coords transformations) */
  mcJumpTrace_channel_16_cave1_box2:
  SIG_MESSAGE("channel_16_cave1_box2 (Trace)");
  mcDEBUG_COMP("channel_16_cave1_box2")
  mcDEBUG_STATE(
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp)
#define x mcnlx
#define y mcnly
#define z mcnlz
#define vx mcnlvx
#define vy mcnlvy
#define vz mcnlvz
#define t mcnlt
#define sx mcnlsx
#define sy mcnlsy
#define sz mcnlsz
#define p mcnlp

#define mcabsorbComp mcabsorbCompchannel_16_cave1_box2
  STORE_NEUTRON(733,
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp);
  mcScattered=0;
  mcRestore=0;
  mcNCounter[733]++;
  mcPCounter[733] += p;
  mcP2Counter[733] += p*p;
#define mccompcurname  channel_16_cave1_box2
#define mccompcurtype  Union_box
#define mccompcurindex 733
#define loop_index mccchannel_16_cave1_box2_loop_index
#define this_box_volume mccchannel_16_cave1_box2_this_box_volume
#define global_geometry_element mccchannel_16_cave1_box2_global_geometry_element
#define this_box_storage mccchannel_16_cave1_box2_this_box_storage
{   /* Declarations of channel_16_cave1_box2=Union_box() SETTING parameters. */
char* material_string = mccchannel_16_cave1_box2_material_string;
MCNUM priority = mccchannel_16_cave1_box2_priority;
MCNUM xwidth = mccchannel_16_cave1_box2_xwidth;
MCNUM yheight = mccchannel_16_cave1_box2_yheight;
MCNUM zdepth = mccchannel_16_cave1_box2_zdepth;
MCNUM xwidth2 = mccchannel_16_cave1_box2_xwidth2;
MCNUM yheight2 = mccchannel_16_cave1_box2_yheight2;
MCNUM visualize = mccchannel_16_cave1_box2_visualize;
int target_index = mccchannel_16_cave1_box2_target_index;
MCNUM target_x = mccchannel_16_cave1_box2_target_x;
MCNUM target_y = mccchannel_16_cave1_box2_target_y;
MCNUM target_z = mccchannel_16_cave1_box2_target_z;
MCNUM focus_aw = mccchannel_16_cave1_box2_focus_aw;
MCNUM focus_ah = mccchannel_16_cave1_box2_focus_ah;
MCNUM focus_xw = mccchannel_16_cave1_box2_focus_xw;
MCNUM focus_xh = mccchannel_16_cave1_box2_focus_xh;
MCNUM focus_r = mccchannel_16_cave1_box2_focus_r;
MCNUM p_interact = mccchannel_16_cave1_box2_p_interact;
char* mask_string = mccchannel_16_cave1_box2_mask_string;
char* mask_setting = mccchannel_16_cave1_box2_mask_setting;
MCNUM number_of_activations = mccchannel_16_cave1_box2_number_of_activations;
}   /* End of channel_16_cave1_box2=Union_box() SETTING parameter declarations. */
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex
  /* Label for restoring  neutron */
  mcabsorbCompchannel_16_cave1_box2:
  if (RESTORE) /* restore if needed */
  { RESTORE_NEUTRON(733,
      mcnlx,
      mcnly,
      mcnlz,
      mcnlvx,
      mcnlvy,
      mcnlvz,
      mcnlt,
      mcnlsx,
      mcnlsy,
      mcnlsz,
      mcnlp); }
#undef mcabsorbComp
#undef p
#undef sz
#undef sy
#undef sx
#undef t
#undef vz
#undef vy
#undef vx
#undef z
#undef y
#undef x
  mcDEBUG_STATE(
mcnlx,
mcnly,
mcnlz,
mcnlvx,
mcnlvy,
mcnlvz,
mcnlt,
mcnlsx,
mcnlsy,
mcnlsz,
mcnlp)

  /* TRACE Component channel_16_cave1_box3 [734] */
  mccoordschange(mcposrchannel_16_cave1_box3, mcrotrchannel_16_cave1_box3,
    &mcnlx,
    &mcnly,
    &mcnlz,
    &mcnlvx,
    &mcnlvy,
    &mcnlvz,
    &mcnlsx,
    &mcnlsy,
    &mcnlsz);
  /* define label inside component channel_16_cave1_box3 (without coords transformations) */
  mcJumpTrace_channel_16_cave1_box3:
  SIG_MESSAGE("channel_16_cave1_box3 (Trace)");
  mcDEBUG_COMP("channel_16_cave1_box3")
  mcDEBUG_STATE(
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp)
#define x mcnlx
#define y mcnly
#define z mcnlz
#define vx mcnlvx
#define vy mcnlvy
#define vz mcnlvz
#define t mcnlt
#define sx mcnlsx
#define sy mcnlsy
#define sz mcnlsz
#define p mcnlp

#define mcabsorbComp mcabsorbCompchannel_16_cave1_box3
  STORE_NEUTRON(734,
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp);
  mcScattered=0;
  mcRestore=0;
  mcNCounter[734]++;
  mcPCounter[734] += p;
  mcP2Counter[734] += p*p;
#define mccompcurname  channel_16_cave1_box3
#define mccompcurtype  Union_box
#define mccompcurindex 734
#define loop_index mccchannel_16_cave1_box3_loop_index
#define this_box_volume mccchannel_16_cave1_box3_this_box_volume
#define global_geometry_element mccchannel_16_cave1_box3_global_geometry_element
#define this_box_storage mccchannel_16_cave1_box3_this_box_storage
{   /* Declarations of channel_16_cave1_box3=Union_box() SETTING parameters. */
char* material_string = mccchannel_16_cave1_box3_material_string;
MCNUM priority = mccchannel_16_cave1_box3_priority;
MCNUM xwidth = mccchannel_16_cave1_box3_xwidth;
MCNUM yheight = mccchannel_16_cave1_box3_yheight;
MCNUM zdepth = mccchannel_16_cave1_box3_zdepth;
MCNUM xwidth2 = mccchannel_16_cave1_box3_xwidth2;
MCNUM yheight2 = mccchannel_16_cave1_box3_yheight2;
MCNUM visualize = mccchannel_16_cave1_box3_visualize;
int target_index = mccchannel_16_cave1_box3_target_index;
MCNUM target_x = mccchannel_16_cave1_box3_target_x;
MCNUM target_y = mccchannel_16_cave1_box3_target_y;
MCNUM target_z = mccchannel_16_cave1_box3_target_z;
MCNUM focus_aw = mccchannel_16_cave1_box3_focus_aw;
MCNUM focus_ah = mccchannel_16_cave1_box3_focus_ah;
MCNUM focus_xw = mccchannel_16_cave1_box3_focus_xw;
MCNUM focus_xh = mccchannel_16_cave1_box3_focus_xh;
MCNUM focus_r = mccchannel_16_cave1_box3_focus_r;
MCNUM p_interact = mccchannel_16_cave1_box3_p_interact;
char* mask_string = mccchannel_16_cave1_box3_mask_string;
char* mask_setting = mccchannel_16_cave1_box3_mask_setting;
MCNUM number_of_activations = mccchannel_16_cave1_box3_number_of_activations;
}   /* End of channel_16_cave1_box3=Union_box() SETTING parameter declarations. */
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex
  /* Label for restoring  neutron */
  mcabsorbCompchannel_16_cave1_box3:
  if (RESTORE) /* restore if needed */
  { RESTORE_NEUTRON(734,
      mcnlx,
      mcnly,
      mcnlz,
      mcnlvx,
      mcnlvy,
      mcnlvz,
      mcnlt,
      mcnlsx,
      mcnlsy,
      mcnlsz,
      mcnlp); }
#undef mcabsorbComp
#undef p
#undef sz
#undef sy
#undef sx
#undef t
#undef vz
#undef vy
#undef vx
#undef z
#undef y
#undef x
  mcDEBUG_STATE(
mcnlx,
mcnly,
mcnlz,
mcnlvx,
mcnlvy,
mcnlvz,
mcnlt,
mcnlsx,
mcnlsy,
mcnlsz,
mcnlp)

  /* TRACE Component channel_16_cave1_cyl1 [735] */
  mccoordschange(mcposrchannel_16_cave1_cyl1, mcrotrchannel_16_cave1_cyl1,
    &mcnlx,
    &mcnly,
    &mcnlz,
    &mcnlvx,
    &mcnlvy,
    &mcnlvz,
    &mcnlsx,
    &mcnlsy,
    &mcnlsz);
  /* define label inside component channel_16_cave1_cyl1 (without coords transformations) */
  mcJumpTrace_channel_16_cave1_cyl1:
  SIG_MESSAGE("channel_16_cave1_cyl1 (Trace)");
  mcDEBUG_COMP("channel_16_cave1_cyl1")
  mcDEBUG_STATE(
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp)
#define x mcnlx
#define y mcnly
#define z mcnlz
#define vx mcnlvx
#define vy mcnlvy
#define vz mcnlvz
#define t mcnlt
#define sx mcnlsx
#define sy mcnlsy
#define sz mcnlsz
#define p mcnlp

#define mcabsorbComp mcabsorbCompchannel_16_cave1_cyl1
  STORE_NEUTRON(735,
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp);
  mcScattered=0;
  mcRestore=0;
  mcNCounter[735]++;
  mcPCounter[735] += p;
  mcP2Counter[735] += p*p;
#define mccompcurname  channel_16_cave1_cyl1
#define mccompcurtype  Union_cylinder
#define mccompcurindex 735
#define loop_index mccchannel_16_cave1_cyl1_loop_index
#define this_cylinder_volume mccchannel_16_cave1_cyl1_this_cylinder_volume
#define global_geometry_element mccchannel_16_cave1_cyl1_global_geometry_element
#define this_cylinder_storage mccchannel_16_cave1_cyl1_this_cylinder_storage
{   /* Declarations of channel_16_cave1_cyl1=Union_cylinder() SETTING parameters. */
char* material_string = mccchannel_16_cave1_cyl1_material_string;
MCNUM priority = mccchannel_16_cave1_cyl1_priority;
MCNUM radius = mccchannel_16_cave1_cyl1_radius;
MCNUM yheight = mccchannel_16_cave1_cyl1_yheight;
MCNUM visualize = mccchannel_16_cave1_cyl1_visualize;
int target_index = mccchannel_16_cave1_cyl1_target_index;
MCNUM target_x = mccchannel_16_cave1_cyl1_target_x;
MCNUM target_y = mccchannel_16_cave1_cyl1_target_y;
MCNUM target_z = mccchannel_16_cave1_cyl1_target_z;
MCNUM focus_aw = mccchannel_16_cave1_cyl1_focus_aw;
MCNUM focus_ah = mccchannel_16_cave1_cyl1_focus_ah;
MCNUM focus_xw = mccchannel_16_cave1_cyl1_focus_xw;
MCNUM focus_xh = mccchannel_16_cave1_cyl1_focus_xh;
MCNUM focus_r = mccchannel_16_cave1_cyl1_focus_r;
MCNUM p_interact = mccchannel_16_cave1_cyl1_p_interact;
char* mask_string = mccchannel_16_cave1_cyl1_mask_string;
char* mask_setting = mccchannel_16_cave1_cyl1_mask_setting;
MCNUM number_of_activations = mccchannel_16_cave1_cyl1_number_of_activations;
#line 345 "Union_cylinder.comp"
{
dummy = 1;
}
#line 442114 "MACS_sample_kidney_box.c"
}   /* End of channel_16_cave1_cyl1=Union_cylinder() SETTING parameter declarations. */
#undef this_cylinder_storage
#undef global_geometry_element
#undef this_cylinder_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex
  /* Label for restoring  neutron */
  mcabsorbCompchannel_16_cave1_cyl1:
  if (RESTORE) /* restore if needed */
  { RESTORE_NEUTRON(735,
      mcnlx,
      mcnly,
      mcnlz,
      mcnlvx,
      mcnlvy,
      mcnlvz,
      mcnlt,
      mcnlsx,
      mcnlsy,
      mcnlsz,
      mcnlp); }
#undef mcabsorbComp
#undef p
#undef sz
#undef sy
#undef sx
#undef t
#undef vz
#undef vy
#undef vx
#undef z
#undef y
#undef x
  mcDEBUG_STATE(
mcnlx,
mcnly,
mcnlz,
mcnlvx,
mcnlvy,
mcnlvz,
mcnlt,
mcnlsx,
mcnlsy,
mcnlsz,
mcnlp)

  /* TRACE Component channel_16_analyzer_1_center [736] */
  mccoordschange(mcposrchannel_16_analyzer_1_center, mcrotrchannel_16_analyzer_1_center,
    &mcnlx,
    &mcnly,
    &mcnlz,
    &mcnlvx,
    &mcnlvy,
    &mcnlvz,
    &mcnlsx,
    &mcnlsy,
    &mcnlsz);
  /* define label inside component channel_16_analyzer_1_center (without coords transformations) */
  mcJumpTrace_channel_16_analyzer_1_center:
  SIG_MESSAGE("channel_16_analyzer_1_center (Trace)");
  mcDEBUG_COMP("channel_16_analyzer_1_center")
  mcDEBUG_STATE(
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp)
#define x mcnlx
#define y mcnly
#define z mcnlz
#define vx mcnlvx
#define vy mcnlvy
#define vz mcnlvz
#define t mcnlt
#define sx mcnlsx
#define sy mcnlsy
#define sz mcnlsz
#define p mcnlp

#define mcabsorbComp mcabsorbCompchannel_16_analyzer_1_center
  STORE_NEUTRON(736,
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp);
  mcScattered=0;
  mcRestore=0;
  mcNCounter[736]++;
  mcPCounter[736] += p;
  mcP2Counter[736] += p*p;
#define mccompcurname  channel_16_analyzer_1_center
#define mccompcurtype  Arm
#define mccompcurindex 736
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex
  /* Label for restoring  neutron */
  mcabsorbCompchannel_16_analyzer_1_center:
  if (RESTORE) /* restore if needed */
  { RESTORE_NEUTRON(736,
      mcnlx,
      mcnly,
      mcnlz,
      mcnlvx,
      mcnlvy,
      mcnlvz,
      mcnlt,
      mcnlsx,
      mcnlsy,
      mcnlsz,
      mcnlp); }
#undef mcabsorbComp
#undef p
#undef sz
#undef sy
#undef sx
#undef t
#undef vz
#undef vy
#undef vx
#undef z
#undef y
#undef x
  mcDEBUG_STATE(
mcnlx,
mcnly,
mcnlz,
mcnlvx,
mcnlvy,
mcnlvz,
mcnlt,
mcnlsx,
mcnlsy,
mcnlsz,
mcnlp)

  /* TRACE Component channel_16_analyzer_1_rotated [737] */
  mccoordschange(mcposrchannel_16_analyzer_1_rotated, mcrotrchannel_16_analyzer_1_rotated,
    &mcnlx,
    &mcnly,
    &mcnlz,
    &mcnlvx,
    &mcnlvy,
    &mcnlvz,
    &mcnlsx,
    &mcnlsy,
    &mcnlsz);
  /* define label inside component channel_16_analyzer_1_rotated (without coords transformations) */
  mcJumpTrace_channel_16_analyzer_1_rotated:
  SIG_MESSAGE("channel_16_analyzer_1_rotated (Trace)");
  mcDEBUG_COMP("channel_16_analyzer_1_rotated")
  mcDEBUG_STATE(
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp)
#define x mcnlx
#define y mcnly
#define z mcnlz
#define vx mcnlvx
#define vy mcnlvy
#define vz mcnlvz
#define t mcnlt
#define sx mcnlsx
#define sy mcnlsy
#define sz mcnlsz
#define p mcnlp

#define mcabsorbComp mcabsorbCompchannel_16_analyzer_1_rotated
  STORE_NEUTRON(737,
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp);
  mcScattered=0;
  mcRestore=0;
  mcNCounter[737]++;
  mcPCounter[737] += p;
  mcP2Counter[737] += p*p;
#define mccompcurname  channel_16_analyzer_1_rotated
#define mccompcurtype  Arm
#define mccompcurindex 737
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex
  /* Label for restoring  neutron */
  mcabsorbCompchannel_16_analyzer_1_rotated:
  if (RESTORE) /* restore if needed */
  { RESTORE_NEUTRON(737,
      mcnlx,
      mcnly,
      mcnlz,
      mcnlvx,
      mcnlvy,
      mcnlvz,
      mcnlt,
      mcnlsx,
      mcnlsy,
      mcnlsz,
      mcnlp); }
#undef mcabsorbComp
#undef p
#undef sz
#undef sy
#undef sx
#undef t
#undef vz
#undef vy
#undef vx
#undef z
#undef y
#undef x
  mcDEBUG_STATE(
mcnlx,
mcnly,
mcnlz,
mcnlvx,
mcnlvy,
mcnlvz,
mcnlt,
mcnlsx,
mcnlsy,
mcnlsz,
mcnlp)

  /* TRACE Component channel_16_analyzer_1_array_crystal_array_0 [738] */
  mccoordschange(mcposrchannel_16_analyzer_1_array_crystal_array_0, mcrotrchannel_16_analyzer_1_array_crystal_array_0,
    &mcnlx,
    &mcnly,
    &mcnlz,
    &mcnlvx,
    &mcnlvy,
    &mcnlvz,
    &mcnlsx,
    &mcnlsy,
    &mcnlsz);
  /* define label inside component channel_16_analyzer_1_array_crystal_array_0 (without coords transformations) */
  mcJumpTrace_channel_16_analyzer_1_array_crystal_array_0:
  SIG_MESSAGE("channel_16_analyzer_1_array_crystal_array_0 (Trace)");
  mcDEBUG_COMP("channel_16_analyzer_1_array_crystal_array_0")
  mcDEBUG_STATE(
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp)
#define x mcnlx
#define y mcnly
#define z mcnlz
#define vx mcnlvx
#define vy mcnlvy
#define vz mcnlvz
#define t mcnlt
#define sx mcnlsx
#define sy mcnlsy
#define sz mcnlsz
#define p mcnlp

#define mcabsorbComp mcabsorbCompchannel_16_analyzer_1_array_crystal_array_0
  STORE_NEUTRON(738,
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp);
  mcScattered=0;
  mcRestore=0;
  mcNCounter[738]++;
  mcPCounter[738] += p;
  mcP2Counter[738] += p*p;
#define mccompcurname  channel_16_analyzer_1_array_crystal_array_0
#define mccompcurtype  Union_box
#define mccompcurindex 738
#define loop_index mccchannel_16_analyzer_1_array_crystal_array_0_loop_index
#define this_box_volume mccchannel_16_analyzer_1_array_crystal_array_0_this_box_volume
#define global_geometry_element mccchannel_16_analyzer_1_array_crystal_array_0_global_geometry_element
#define this_box_storage mccchannel_16_analyzer_1_array_crystal_array_0_this_box_storage
{   /* Declarations of channel_16_analyzer_1_array_crystal_array_0=Union_box() SETTING parameters. */
char* material_string = mccchannel_16_analyzer_1_array_crystal_array_0_material_string;
MCNUM priority = mccchannel_16_analyzer_1_array_crystal_array_0_priority;
MCNUM xwidth = mccchannel_16_analyzer_1_array_crystal_array_0_xwidth;
MCNUM yheight = mccchannel_16_analyzer_1_array_crystal_array_0_yheight;
MCNUM zdepth = mccchannel_16_analyzer_1_array_crystal_array_0_zdepth;
MCNUM xwidth2 = mccchannel_16_analyzer_1_array_crystal_array_0_xwidth2;
MCNUM yheight2 = mccchannel_16_analyzer_1_array_crystal_array_0_yheight2;
MCNUM visualize = mccchannel_16_analyzer_1_array_crystal_array_0_visualize;
int target_index = mccchannel_16_analyzer_1_array_crystal_array_0_target_index;
MCNUM target_x = mccchannel_16_analyzer_1_array_crystal_array_0_target_x;
MCNUM target_y = mccchannel_16_analyzer_1_array_crystal_array_0_target_y;
MCNUM target_z = mccchannel_16_analyzer_1_array_crystal_array_0_target_z;
MCNUM focus_aw = mccchannel_16_analyzer_1_array_crystal_array_0_focus_aw;
MCNUM focus_ah = mccchannel_16_analyzer_1_array_crystal_array_0_focus_ah;
MCNUM focus_xw = mccchannel_16_analyzer_1_array_crystal_array_0_focus_xw;
MCNUM focus_xh = mccchannel_16_analyzer_1_array_crystal_array_0_focus_xh;
MCNUM focus_r = mccchannel_16_analyzer_1_array_crystal_array_0_focus_r;
MCNUM p_interact = mccchannel_16_analyzer_1_array_crystal_array_0_p_interact;
char* mask_string = mccchannel_16_analyzer_1_array_crystal_array_0_mask_string;
char* mask_setting = mccchannel_16_analyzer_1_array_crystal_array_0_mask_setting;
MCNUM number_of_activations = mccchannel_16_analyzer_1_array_crystal_array_0_number_of_activations;
}   /* End of channel_16_analyzer_1_array_crystal_array_0=Union_box() SETTING parameter declarations. */
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex
  /* Label for restoring  neutron */
  mcabsorbCompchannel_16_analyzer_1_array_crystal_array_0:
  if (RESTORE) /* restore if needed */
  { RESTORE_NEUTRON(738,
      mcnlx,
      mcnly,
      mcnlz,
      mcnlvx,
      mcnlvy,
      mcnlvz,
      mcnlt,
      mcnlsx,
      mcnlsy,
      mcnlsz,
      mcnlp); }
#undef mcabsorbComp
#undef p
#undef sz
#undef sy
#undef sx
#undef t
#undef vz
#undef vy
#undef vx
#undef z
#undef y
#undef x
  mcDEBUG_STATE(
mcnlx,
mcnly,
mcnlz,
mcnlvx,
mcnlvy,
mcnlvz,
mcnlt,
mcnlsx,
mcnlsy,
mcnlsz,
mcnlp)

  /* TRACE Component channel_16_analyzer_1_array_crystal_array_1 [739] */
  mccoordschange(mcposrchannel_16_analyzer_1_array_crystal_array_1, mcrotrchannel_16_analyzer_1_array_crystal_array_1,
    &mcnlx,
    &mcnly,
    &mcnlz,
    &mcnlvx,
    &mcnlvy,
    &mcnlvz,
    &mcnlsx,
    &mcnlsy,
    &mcnlsz);
  /* define label inside component channel_16_analyzer_1_array_crystal_array_1 (without coords transformations) */
  mcJumpTrace_channel_16_analyzer_1_array_crystal_array_1:
  SIG_MESSAGE("channel_16_analyzer_1_array_crystal_array_1 (Trace)");
  mcDEBUG_COMP("channel_16_analyzer_1_array_crystal_array_1")
  mcDEBUG_STATE(
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp)
#define x mcnlx
#define y mcnly
#define z mcnlz
#define vx mcnlvx
#define vy mcnlvy
#define vz mcnlvz
#define t mcnlt
#define sx mcnlsx
#define sy mcnlsy
#define sz mcnlsz
#define p mcnlp

#define mcabsorbComp mcabsorbCompchannel_16_analyzer_1_array_crystal_array_1
  STORE_NEUTRON(739,
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp);
  mcScattered=0;
  mcRestore=0;
  mcNCounter[739]++;
  mcPCounter[739] += p;
  mcP2Counter[739] += p*p;
#define mccompcurname  channel_16_analyzer_1_array_crystal_array_1
#define mccompcurtype  Union_box
#define mccompcurindex 739
#define loop_index mccchannel_16_analyzer_1_array_crystal_array_1_loop_index
#define this_box_volume mccchannel_16_analyzer_1_array_crystal_array_1_this_box_volume
#define global_geometry_element mccchannel_16_analyzer_1_array_crystal_array_1_global_geometry_element
#define this_box_storage mccchannel_16_analyzer_1_array_crystal_array_1_this_box_storage
{   /* Declarations of channel_16_analyzer_1_array_crystal_array_1=Union_box() SETTING parameters. */
char* material_string = mccchannel_16_analyzer_1_array_crystal_array_1_material_string;
MCNUM priority = mccchannel_16_analyzer_1_array_crystal_array_1_priority;
MCNUM xwidth = mccchannel_16_analyzer_1_array_crystal_array_1_xwidth;
MCNUM yheight = mccchannel_16_analyzer_1_array_crystal_array_1_yheight;
MCNUM zdepth = mccchannel_16_analyzer_1_array_crystal_array_1_zdepth;
MCNUM xwidth2 = mccchannel_16_analyzer_1_array_crystal_array_1_xwidth2;
MCNUM yheight2 = mccchannel_16_analyzer_1_array_crystal_array_1_yheight2;
MCNUM visualize = mccchannel_16_analyzer_1_array_crystal_array_1_visualize;
int target_index = mccchannel_16_analyzer_1_array_crystal_array_1_target_index;
MCNUM target_x = mccchannel_16_analyzer_1_array_crystal_array_1_target_x;
MCNUM target_y = mccchannel_16_analyzer_1_array_crystal_array_1_target_y;
MCNUM target_z = mccchannel_16_analyzer_1_array_crystal_array_1_target_z;
MCNUM focus_aw = mccchannel_16_analyzer_1_array_crystal_array_1_focus_aw;
MCNUM focus_ah = mccchannel_16_analyzer_1_array_crystal_array_1_focus_ah;
MCNUM focus_xw = mccchannel_16_analyzer_1_array_crystal_array_1_focus_xw;
MCNUM focus_xh = mccchannel_16_analyzer_1_array_crystal_array_1_focus_xh;
MCNUM focus_r = mccchannel_16_analyzer_1_array_crystal_array_1_focus_r;
MCNUM p_interact = mccchannel_16_analyzer_1_array_crystal_array_1_p_interact;
char* mask_string = mccchannel_16_analyzer_1_array_crystal_array_1_mask_string;
char* mask_setting = mccchannel_16_analyzer_1_array_crystal_array_1_mask_setting;
MCNUM number_of_activations = mccchannel_16_analyzer_1_array_crystal_array_1_number_of_activations;
}   /* End of channel_16_analyzer_1_array_crystal_array_1=Union_box() SETTING parameter declarations. */
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex
  /* Label for restoring  neutron */
  mcabsorbCompchannel_16_analyzer_1_array_crystal_array_1:
  if (RESTORE) /* restore if needed */
  { RESTORE_NEUTRON(739,
      mcnlx,
      mcnly,
      mcnlz,
      mcnlvx,
      mcnlvy,
      mcnlvz,
      mcnlt,
      mcnlsx,
      mcnlsy,
      mcnlsz,
      mcnlp); }
#undef mcabsorbComp
#undef p
#undef sz
#undef sy
#undef sx
#undef t
#undef vz
#undef vy
#undef vx
#undef z
#undef y
#undef x
  mcDEBUG_STATE(
mcnlx,
mcnly,
mcnlz,
mcnlvx,
mcnlvy,
mcnlvz,
mcnlt,
mcnlsx,
mcnlsy,
mcnlsz,
mcnlp)

  /* TRACE Component channel_16_analyzer_1_array_crystal_array_2 [740] */
  mccoordschange(mcposrchannel_16_analyzer_1_array_crystal_array_2, mcrotrchannel_16_analyzer_1_array_crystal_array_2,
    &mcnlx,
    &mcnly,
    &mcnlz,
    &mcnlvx,
    &mcnlvy,
    &mcnlvz,
    &mcnlsx,
    &mcnlsy,
    &mcnlsz);
  /* define label inside component channel_16_analyzer_1_array_crystal_array_2 (without coords transformations) */
  mcJumpTrace_channel_16_analyzer_1_array_crystal_array_2:
  SIG_MESSAGE("channel_16_analyzer_1_array_crystal_array_2 (Trace)");
  mcDEBUG_COMP("channel_16_analyzer_1_array_crystal_array_2")
  mcDEBUG_STATE(
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp)
#define x mcnlx
#define y mcnly
#define z mcnlz
#define vx mcnlvx
#define vy mcnlvy
#define vz mcnlvz
#define t mcnlt
#define sx mcnlsx
#define sy mcnlsy
#define sz mcnlsz
#define p mcnlp

#define mcabsorbComp mcabsorbCompchannel_16_analyzer_1_array_crystal_array_2
  STORE_NEUTRON(740,
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp);
  mcScattered=0;
  mcRestore=0;
  mcNCounter[740]++;
  mcPCounter[740] += p;
  mcP2Counter[740] += p*p;
#define mccompcurname  channel_16_analyzer_1_array_crystal_array_2
#define mccompcurtype  Union_box
#define mccompcurindex 740
#define loop_index mccchannel_16_analyzer_1_array_crystal_array_2_loop_index
#define this_box_volume mccchannel_16_analyzer_1_array_crystal_array_2_this_box_volume
#define global_geometry_element mccchannel_16_analyzer_1_array_crystal_array_2_global_geometry_element
#define this_box_storage mccchannel_16_analyzer_1_array_crystal_array_2_this_box_storage
{   /* Declarations of channel_16_analyzer_1_array_crystal_array_2=Union_box() SETTING parameters. */
char* material_string = mccchannel_16_analyzer_1_array_crystal_array_2_material_string;
MCNUM priority = mccchannel_16_analyzer_1_array_crystal_array_2_priority;
MCNUM xwidth = mccchannel_16_analyzer_1_array_crystal_array_2_xwidth;
MCNUM yheight = mccchannel_16_analyzer_1_array_crystal_array_2_yheight;
MCNUM zdepth = mccchannel_16_analyzer_1_array_crystal_array_2_zdepth;
MCNUM xwidth2 = mccchannel_16_analyzer_1_array_crystal_array_2_xwidth2;
MCNUM yheight2 = mccchannel_16_analyzer_1_array_crystal_array_2_yheight2;
MCNUM visualize = mccchannel_16_analyzer_1_array_crystal_array_2_visualize;
int target_index = mccchannel_16_analyzer_1_array_crystal_array_2_target_index;
MCNUM target_x = mccchannel_16_analyzer_1_array_crystal_array_2_target_x;
MCNUM target_y = mccchannel_16_analyzer_1_array_crystal_array_2_target_y;
MCNUM target_z = mccchannel_16_analyzer_1_array_crystal_array_2_target_z;
MCNUM focus_aw = mccchannel_16_analyzer_1_array_crystal_array_2_focus_aw;
MCNUM focus_ah = mccchannel_16_analyzer_1_array_crystal_array_2_focus_ah;
MCNUM focus_xw = mccchannel_16_analyzer_1_array_crystal_array_2_focus_xw;
MCNUM focus_xh = mccchannel_16_analyzer_1_array_crystal_array_2_focus_xh;
MCNUM focus_r = mccchannel_16_analyzer_1_array_crystal_array_2_focus_r;
MCNUM p_interact = mccchannel_16_analyzer_1_array_crystal_array_2_p_interact;
char* mask_string = mccchannel_16_analyzer_1_array_crystal_array_2_mask_string;
char* mask_setting = mccchannel_16_analyzer_1_array_crystal_array_2_mask_setting;
MCNUM number_of_activations = mccchannel_16_analyzer_1_array_crystal_array_2_number_of_activations;
}   /* End of channel_16_analyzer_1_array_crystal_array_2=Union_box() SETTING parameter declarations. */
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex
  /* Label for restoring  neutron */
  mcabsorbCompchannel_16_analyzer_1_array_crystal_array_2:
  if (RESTORE) /* restore if needed */
  { RESTORE_NEUTRON(740,
      mcnlx,
      mcnly,
      mcnlz,
      mcnlvx,
      mcnlvy,
      mcnlvz,
      mcnlt,
      mcnlsx,
      mcnlsy,
      mcnlsz,
      mcnlp); }
#undef mcabsorbComp
#undef p
#undef sz
#undef sy
#undef sx
#undef t
#undef vz
#undef vy
#undef vx
#undef z
#undef y
#undef x
  mcDEBUG_STATE(
mcnlx,
mcnly,
mcnlz,
mcnlvx,
mcnlvy,
mcnlvz,
mcnlt,
mcnlsx,
mcnlsy,
mcnlsz,
mcnlp)

  /* TRACE Component channel_16_analyzer_1_array_crystal_array_3 [741] */
  mccoordschange(mcposrchannel_16_analyzer_1_array_crystal_array_3, mcrotrchannel_16_analyzer_1_array_crystal_array_3,
    &mcnlx,
    &mcnly,
    &mcnlz,
    &mcnlvx,
    &mcnlvy,
    &mcnlvz,
    &mcnlsx,
    &mcnlsy,
    &mcnlsz);
  /* define label inside component channel_16_analyzer_1_array_crystal_array_3 (without coords transformations) */
  mcJumpTrace_channel_16_analyzer_1_array_crystal_array_3:
  SIG_MESSAGE("channel_16_analyzer_1_array_crystal_array_3 (Trace)");
  mcDEBUG_COMP("channel_16_analyzer_1_array_crystal_array_3")
  mcDEBUG_STATE(
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp)
#define x mcnlx
#define y mcnly
#define z mcnlz
#define vx mcnlvx
#define vy mcnlvy
#define vz mcnlvz
#define t mcnlt
#define sx mcnlsx
#define sy mcnlsy
#define sz mcnlsz
#define p mcnlp

#define mcabsorbComp mcabsorbCompchannel_16_analyzer_1_array_crystal_array_3
  STORE_NEUTRON(741,
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp);
  mcScattered=0;
  mcRestore=0;
  mcNCounter[741]++;
  mcPCounter[741] += p;
  mcP2Counter[741] += p*p;
#define mccompcurname  channel_16_analyzer_1_array_crystal_array_3
#define mccompcurtype  Union_box
#define mccompcurindex 741
#define loop_index mccchannel_16_analyzer_1_array_crystal_array_3_loop_index
#define this_box_volume mccchannel_16_analyzer_1_array_crystal_array_3_this_box_volume
#define global_geometry_element mccchannel_16_analyzer_1_array_crystal_array_3_global_geometry_element
#define this_box_storage mccchannel_16_analyzer_1_array_crystal_array_3_this_box_storage
{   /* Declarations of channel_16_analyzer_1_array_crystal_array_3=Union_box() SETTING parameters. */
char* material_string = mccchannel_16_analyzer_1_array_crystal_array_3_material_string;
MCNUM priority = mccchannel_16_analyzer_1_array_crystal_array_3_priority;
MCNUM xwidth = mccchannel_16_analyzer_1_array_crystal_array_3_xwidth;
MCNUM yheight = mccchannel_16_analyzer_1_array_crystal_array_3_yheight;
MCNUM zdepth = mccchannel_16_analyzer_1_array_crystal_array_3_zdepth;
MCNUM xwidth2 = mccchannel_16_analyzer_1_array_crystal_array_3_xwidth2;
MCNUM yheight2 = mccchannel_16_analyzer_1_array_crystal_array_3_yheight2;
MCNUM visualize = mccchannel_16_analyzer_1_array_crystal_array_3_visualize;
int target_index = mccchannel_16_analyzer_1_array_crystal_array_3_target_index;
MCNUM target_x = mccchannel_16_analyzer_1_array_crystal_array_3_target_x;
MCNUM target_y = mccchannel_16_analyzer_1_array_crystal_array_3_target_y;
MCNUM target_z = mccchannel_16_analyzer_1_array_crystal_array_3_target_z;
MCNUM focus_aw = mccchannel_16_analyzer_1_array_crystal_array_3_focus_aw;
MCNUM focus_ah = mccchannel_16_analyzer_1_array_crystal_array_3_focus_ah;
MCNUM focus_xw = mccchannel_16_analyzer_1_array_crystal_array_3_focus_xw;
MCNUM focus_xh = mccchannel_16_analyzer_1_array_crystal_array_3_focus_xh;
MCNUM focus_r = mccchannel_16_analyzer_1_array_crystal_array_3_focus_r;
MCNUM p_interact = mccchannel_16_analyzer_1_array_crystal_array_3_p_interact;
char* mask_string = mccchannel_16_analyzer_1_array_crystal_array_3_mask_string;
char* mask_setting = mccchannel_16_analyzer_1_array_crystal_array_3_mask_setting;
MCNUM number_of_activations = mccchannel_16_analyzer_1_array_crystal_array_3_number_of_activations;
}   /* End of channel_16_analyzer_1_array_crystal_array_3=Union_box() SETTING parameter declarations. */
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex
  /* Label for restoring  neutron */
  mcabsorbCompchannel_16_analyzer_1_array_crystal_array_3:
  if (RESTORE) /* restore if needed */
  { RESTORE_NEUTRON(741,
      mcnlx,
      mcnly,
      mcnlz,
      mcnlvx,
      mcnlvy,
      mcnlvz,
      mcnlt,
      mcnlsx,
      mcnlsy,
      mcnlsz,
      mcnlp); }
#undef mcabsorbComp
#undef p
#undef sz
#undef sy
#undef sx
#undef t
#undef vz
#undef vy
#undef vx
#undef z
#undef y
#undef x
  mcDEBUG_STATE(
mcnlx,
mcnly,
mcnlz,
mcnlvx,
mcnlvy,
mcnlvz,
mcnlt,
mcnlsx,
mcnlsy,
mcnlsz,
mcnlp)

  /* TRACE Component channel_16_analyzer_1_array_crystal_array_4 [742] */
  mccoordschange(mcposrchannel_16_analyzer_1_array_crystal_array_4, mcrotrchannel_16_analyzer_1_array_crystal_array_4,
    &mcnlx,
    &mcnly,
    &mcnlz,
    &mcnlvx,
    &mcnlvy,
    &mcnlvz,
    &mcnlsx,
    &mcnlsy,
    &mcnlsz);
  /* define label inside component channel_16_analyzer_1_array_crystal_array_4 (without coords transformations) */
  mcJumpTrace_channel_16_analyzer_1_array_crystal_array_4:
  SIG_MESSAGE("channel_16_analyzer_1_array_crystal_array_4 (Trace)");
  mcDEBUG_COMP("channel_16_analyzer_1_array_crystal_array_4")
  mcDEBUG_STATE(
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp)
#define x mcnlx
#define y mcnly
#define z mcnlz
#define vx mcnlvx
#define vy mcnlvy
#define vz mcnlvz
#define t mcnlt
#define sx mcnlsx
#define sy mcnlsy
#define sz mcnlsz
#define p mcnlp

#define mcabsorbComp mcabsorbCompchannel_16_analyzer_1_array_crystal_array_4
  STORE_NEUTRON(742,
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp);
  mcScattered=0;
  mcRestore=0;
  mcNCounter[742]++;
  mcPCounter[742] += p;
  mcP2Counter[742] += p*p;
#define mccompcurname  channel_16_analyzer_1_array_crystal_array_4
#define mccompcurtype  Union_box
#define mccompcurindex 742
#define loop_index mccchannel_16_analyzer_1_array_crystal_array_4_loop_index
#define this_box_volume mccchannel_16_analyzer_1_array_crystal_array_4_this_box_volume
#define global_geometry_element mccchannel_16_analyzer_1_array_crystal_array_4_global_geometry_element
#define this_box_storage mccchannel_16_analyzer_1_array_crystal_array_4_this_box_storage
{   /* Declarations of channel_16_analyzer_1_array_crystal_array_4=Union_box() SETTING parameters. */
char* material_string = mccchannel_16_analyzer_1_array_crystal_array_4_material_string;
MCNUM priority = mccchannel_16_analyzer_1_array_crystal_array_4_priority;
MCNUM xwidth = mccchannel_16_analyzer_1_array_crystal_array_4_xwidth;
MCNUM yheight = mccchannel_16_analyzer_1_array_crystal_array_4_yheight;
MCNUM zdepth = mccchannel_16_analyzer_1_array_crystal_array_4_zdepth;
MCNUM xwidth2 = mccchannel_16_analyzer_1_array_crystal_array_4_xwidth2;
MCNUM yheight2 = mccchannel_16_analyzer_1_array_crystal_array_4_yheight2;
MCNUM visualize = mccchannel_16_analyzer_1_array_crystal_array_4_visualize;
int target_index = mccchannel_16_analyzer_1_array_crystal_array_4_target_index;
MCNUM target_x = mccchannel_16_analyzer_1_array_crystal_array_4_target_x;
MCNUM target_y = mccchannel_16_analyzer_1_array_crystal_array_4_target_y;
MCNUM target_z = mccchannel_16_analyzer_1_array_crystal_array_4_target_z;
MCNUM focus_aw = mccchannel_16_analyzer_1_array_crystal_array_4_focus_aw;
MCNUM focus_ah = mccchannel_16_analyzer_1_array_crystal_array_4_focus_ah;
MCNUM focus_xw = mccchannel_16_analyzer_1_array_crystal_array_4_focus_xw;
MCNUM focus_xh = mccchannel_16_analyzer_1_array_crystal_array_4_focus_xh;
MCNUM focus_r = mccchannel_16_analyzer_1_array_crystal_array_4_focus_r;
MCNUM p_interact = mccchannel_16_analyzer_1_array_crystal_array_4_p_interact;
char* mask_string = mccchannel_16_analyzer_1_array_crystal_array_4_mask_string;
char* mask_setting = mccchannel_16_analyzer_1_array_crystal_array_4_mask_setting;
MCNUM number_of_activations = mccchannel_16_analyzer_1_array_crystal_array_4_number_of_activations;
}   /* End of channel_16_analyzer_1_array_crystal_array_4=Union_box() SETTING parameter declarations. */
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex
  /* Label for restoring  neutron */
  mcabsorbCompchannel_16_analyzer_1_array_crystal_array_4:
  if (RESTORE) /* restore if needed */
  { RESTORE_NEUTRON(742,
      mcnlx,
      mcnly,
      mcnlz,
      mcnlvx,
      mcnlvy,
      mcnlvz,
      mcnlt,
      mcnlsx,
      mcnlsy,
      mcnlsz,
      mcnlp); }
#undef mcabsorbComp
#undef p
#undef sz
#undef sy
#undef sx
#undef t
#undef vz
#undef vy
#undef vx
#undef z
#undef y
#undef x
  mcDEBUG_STATE(
mcnlx,
mcnly,
mcnlz,
mcnlvx,
mcnlvy,
mcnlvz,
mcnlt,
mcnlsx,
mcnlsy,
mcnlsz,
mcnlp)

  /* TRACE Component channel_16_analyzer_1_array_crystal_array_5 [743] */
  mccoordschange(mcposrchannel_16_analyzer_1_array_crystal_array_5, mcrotrchannel_16_analyzer_1_array_crystal_array_5,
    &mcnlx,
    &mcnly,
    &mcnlz,
    &mcnlvx,
    &mcnlvy,
    &mcnlvz,
    &mcnlsx,
    &mcnlsy,
    &mcnlsz);
  /* define label inside component channel_16_analyzer_1_array_crystal_array_5 (without coords transformations) */
  mcJumpTrace_channel_16_analyzer_1_array_crystal_array_5:
  SIG_MESSAGE("channel_16_analyzer_1_array_crystal_array_5 (Trace)");
  mcDEBUG_COMP("channel_16_analyzer_1_array_crystal_array_5")
  mcDEBUG_STATE(
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp)
#define x mcnlx
#define y mcnly
#define z mcnlz
#define vx mcnlvx
#define vy mcnlvy
#define vz mcnlvz
#define t mcnlt
#define sx mcnlsx
#define sy mcnlsy
#define sz mcnlsz
#define p mcnlp

#define mcabsorbComp mcabsorbCompchannel_16_analyzer_1_array_crystal_array_5
  STORE_NEUTRON(743,
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp);
  mcScattered=0;
  mcRestore=0;
  mcNCounter[743]++;
  mcPCounter[743] += p;
  mcP2Counter[743] += p*p;
#define mccompcurname  channel_16_analyzer_1_array_crystal_array_5
#define mccompcurtype  Union_box
#define mccompcurindex 743
#define loop_index mccchannel_16_analyzer_1_array_crystal_array_5_loop_index
#define this_box_volume mccchannel_16_analyzer_1_array_crystal_array_5_this_box_volume
#define global_geometry_element mccchannel_16_analyzer_1_array_crystal_array_5_global_geometry_element
#define this_box_storage mccchannel_16_analyzer_1_array_crystal_array_5_this_box_storage
{   /* Declarations of channel_16_analyzer_1_array_crystal_array_5=Union_box() SETTING parameters. */
char* material_string = mccchannel_16_analyzer_1_array_crystal_array_5_material_string;
MCNUM priority = mccchannel_16_analyzer_1_array_crystal_array_5_priority;
MCNUM xwidth = mccchannel_16_analyzer_1_array_crystal_array_5_xwidth;
MCNUM yheight = mccchannel_16_analyzer_1_array_crystal_array_5_yheight;
MCNUM zdepth = mccchannel_16_analyzer_1_array_crystal_array_5_zdepth;
MCNUM xwidth2 = mccchannel_16_analyzer_1_array_crystal_array_5_xwidth2;
MCNUM yheight2 = mccchannel_16_analyzer_1_array_crystal_array_5_yheight2;
MCNUM visualize = mccchannel_16_analyzer_1_array_crystal_array_5_visualize;
int target_index = mccchannel_16_analyzer_1_array_crystal_array_5_target_index;
MCNUM target_x = mccchannel_16_analyzer_1_array_crystal_array_5_target_x;
MCNUM target_y = mccchannel_16_analyzer_1_array_crystal_array_5_target_y;
MCNUM target_z = mccchannel_16_analyzer_1_array_crystal_array_5_target_z;
MCNUM focus_aw = mccchannel_16_analyzer_1_array_crystal_array_5_focus_aw;
MCNUM focus_ah = mccchannel_16_analyzer_1_array_crystal_array_5_focus_ah;
MCNUM focus_xw = mccchannel_16_analyzer_1_array_crystal_array_5_focus_xw;
MCNUM focus_xh = mccchannel_16_analyzer_1_array_crystal_array_5_focus_xh;
MCNUM focus_r = mccchannel_16_analyzer_1_array_crystal_array_5_focus_r;
MCNUM p_interact = mccchannel_16_analyzer_1_array_crystal_array_5_p_interact;
char* mask_string = mccchannel_16_analyzer_1_array_crystal_array_5_mask_string;
char* mask_setting = mccchannel_16_analyzer_1_array_crystal_array_5_mask_setting;
MCNUM number_of_activations = mccchannel_16_analyzer_1_array_crystal_array_5_number_of_activations;
}   /* End of channel_16_analyzer_1_array_crystal_array_5=Union_box() SETTING parameter declarations. */
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex
  /* Label for restoring  neutron */
  mcabsorbCompchannel_16_analyzer_1_array_crystal_array_5:
  if (RESTORE) /* restore if needed */
  { RESTORE_NEUTRON(743,
      mcnlx,
      mcnly,
      mcnlz,
      mcnlvx,
      mcnlvy,
      mcnlvz,
      mcnlt,
      mcnlsx,
      mcnlsy,
      mcnlsz,
      mcnlp); }
#undef mcabsorbComp
#undef p
#undef sz
#undef sy
#undef sx
#undef t
#undef vz
#undef vy
#undef vx
#undef z
#undef y
#undef x
  mcDEBUG_STATE(
mcnlx,
mcnly,
mcnlz,
mcnlvx,
mcnlvy,
mcnlvz,
mcnlt,
mcnlsx,
mcnlsy,
mcnlsz,
mcnlp)

  /* TRACE Component channel_16_analyzer_1_array_crystal_array_6 [744] */
  mccoordschange(mcposrchannel_16_analyzer_1_array_crystal_array_6, mcrotrchannel_16_analyzer_1_array_crystal_array_6,
    &mcnlx,
    &mcnly,
    &mcnlz,
    &mcnlvx,
    &mcnlvy,
    &mcnlvz,
    &mcnlsx,
    &mcnlsy,
    &mcnlsz);
  /* define label inside component channel_16_analyzer_1_array_crystal_array_6 (without coords transformations) */
  mcJumpTrace_channel_16_analyzer_1_array_crystal_array_6:
  SIG_MESSAGE("channel_16_analyzer_1_array_crystal_array_6 (Trace)");
  mcDEBUG_COMP("channel_16_analyzer_1_array_crystal_array_6")
  mcDEBUG_STATE(
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp)
#define x mcnlx
#define y mcnly
#define z mcnlz
#define vx mcnlvx
#define vy mcnlvy
#define vz mcnlvz
#define t mcnlt
#define sx mcnlsx
#define sy mcnlsy
#define sz mcnlsz
#define p mcnlp

#define mcabsorbComp mcabsorbCompchannel_16_analyzer_1_array_crystal_array_6
  STORE_NEUTRON(744,
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp);
  mcScattered=0;
  mcRestore=0;
  mcNCounter[744]++;
  mcPCounter[744] += p;
  mcP2Counter[744] += p*p;
#define mccompcurname  channel_16_analyzer_1_array_crystal_array_6
#define mccompcurtype  Union_box
#define mccompcurindex 744
#define loop_index mccchannel_16_analyzer_1_array_crystal_array_6_loop_index
#define this_box_volume mccchannel_16_analyzer_1_array_crystal_array_6_this_box_volume
#define global_geometry_element mccchannel_16_analyzer_1_array_crystal_array_6_global_geometry_element
#define this_box_storage mccchannel_16_analyzer_1_array_crystal_array_6_this_box_storage
{   /* Declarations of channel_16_analyzer_1_array_crystal_array_6=Union_box() SETTING parameters. */
char* material_string = mccchannel_16_analyzer_1_array_crystal_array_6_material_string;
MCNUM priority = mccchannel_16_analyzer_1_array_crystal_array_6_priority;
MCNUM xwidth = mccchannel_16_analyzer_1_array_crystal_array_6_xwidth;
MCNUM yheight = mccchannel_16_analyzer_1_array_crystal_array_6_yheight;
MCNUM zdepth = mccchannel_16_analyzer_1_array_crystal_array_6_zdepth;
MCNUM xwidth2 = mccchannel_16_analyzer_1_array_crystal_array_6_xwidth2;
MCNUM yheight2 = mccchannel_16_analyzer_1_array_crystal_array_6_yheight2;
MCNUM visualize = mccchannel_16_analyzer_1_array_crystal_array_6_visualize;
int target_index = mccchannel_16_analyzer_1_array_crystal_array_6_target_index;
MCNUM target_x = mccchannel_16_analyzer_1_array_crystal_array_6_target_x;
MCNUM target_y = mccchannel_16_analyzer_1_array_crystal_array_6_target_y;
MCNUM target_z = mccchannel_16_analyzer_1_array_crystal_array_6_target_z;
MCNUM focus_aw = mccchannel_16_analyzer_1_array_crystal_array_6_focus_aw;
MCNUM focus_ah = mccchannel_16_analyzer_1_array_crystal_array_6_focus_ah;
MCNUM focus_xw = mccchannel_16_analyzer_1_array_crystal_array_6_focus_xw;
MCNUM focus_xh = mccchannel_16_analyzer_1_array_crystal_array_6_focus_xh;
MCNUM focus_r = mccchannel_16_analyzer_1_array_crystal_array_6_focus_r;
MCNUM p_interact = mccchannel_16_analyzer_1_array_crystal_array_6_p_interact;
char* mask_string = mccchannel_16_analyzer_1_array_crystal_array_6_mask_string;
char* mask_setting = mccchannel_16_analyzer_1_array_crystal_array_6_mask_setting;
MCNUM number_of_activations = mccchannel_16_analyzer_1_array_crystal_array_6_number_of_activations;
}   /* End of channel_16_analyzer_1_array_crystal_array_6=Union_box() SETTING parameter declarations. */
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex
  /* Label for restoring  neutron */
  mcabsorbCompchannel_16_analyzer_1_array_crystal_array_6:
  if (RESTORE) /* restore if needed */
  { RESTORE_NEUTRON(744,
      mcnlx,
      mcnly,
      mcnlz,
      mcnlvx,
      mcnlvy,
      mcnlvz,
      mcnlt,
      mcnlsx,
      mcnlsy,
      mcnlsz,
      mcnlp); }
#undef mcabsorbComp
#undef p
#undef sz
#undef sy
#undef sx
#undef t
#undef vz
#undef vy
#undef vx
#undef z
#undef y
#undef x
  mcDEBUG_STATE(
mcnlx,
mcnly,
mcnlz,
mcnlvx,
mcnlvy,
mcnlvz,
mcnlt,
mcnlsx,
mcnlsy,
mcnlsz,
mcnlp)

  /* TRACE Component channel_16_analyzer_1_array_crystal_array_7 [745] */
  mccoordschange(mcposrchannel_16_analyzer_1_array_crystal_array_7, mcrotrchannel_16_analyzer_1_array_crystal_array_7,
    &mcnlx,
    &mcnly,
    &mcnlz,
    &mcnlvx,
    &mcnlvy,
    &mcnlvz,
    &mcnlsx,
    &mcnlsy,
    &mcnlsz);
  /* define label inside component channel_16_analyzer_1_array_crystal_array_7 (without coords transformations) */
  mcJumpTrace_channel_16_analyzer_1_array_crystal_array_7:
  SIG_MESSAGE("channel_16_analyzer_1_array_crystal_array_7 (Trace)");
  mcDEBUG_COMP("channel_16_analyzer_1_array_crystal_array_7")
  mcDEBUG_STATE(
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp)
#define x mcnlx
#define y mcnly
#define z mcnlz
#define vx mcnlvx
#define vy mcnlvy
#define vz mcnlvz
#define t mcnlt
#define sx mcnlsx
#define sy mcnlsy
#define sz mcnlsz
#define p mcnlp

#define mcabsorbComp mcabsorbCompchannel_16_analyzer_1_array_crystal_array_7
  STORE_NEUTRON(745,
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp);
  mcScattered=0;
  mcRestore=0;
  mcNCounter[745]++;
  mcPCounter[745] += p;
  mcP2Counter[745] += p*p;
#define mccompcurname  channel_16_analyzer_1_array_crystal_array_7
#define mccompcurtype  Union_box
#define mccompcurindex 745
#define loop_index mccchannel_16_analyzer_1_array_crystal_array_7_loop_index
#define this_box_volume mccchannel_16_analyzer_1_array_crystal_array_7_this_box_volume
#define global_geometry_element mccchannel_16_analyzer_1_array_crystal_array_7_global_geometry_element
#define this_box_storage mccchannel_16_analyzer_1_array_crystal_array_7_this_box_storage
{   /* Declarations of channel_16_analyzer_1_array_crystal_array_7=Union_box() SETTING parameters. */
char* material_string = mccchannel_16_analyzer_1_array_crystal_array_7_material_string;
MCNUM priority = mccchannel_16_analyzer_1_array_crystal_array_7_priority;
MCNUM xwidth = mccchannel_16_analyzer_1_array_crystal_array_7_xwidth;
MCNUM yheight = mccchannel_16_analyzer_1_array_crystal_array_7_yheight;
MCNUM zdepth = mccchannel_16_analyzer_1_array_crystal_array_7_zdepth;
MCNUM xwidth2 = mccchannel_16_analyzer_1_array_crystal_array_7_xwidth2;
MCNUM yheight2 = mccchannel_16_analyzer_1_array_crystal_array_7_yheight2;
MCNUM visualize = mccchannel_16_analyzer_1_array_crystal_array_7_visualize;
int target_index = mccchannel_16_analyzer_1_array_crystal_array_7_target_index;
MCNUM target_x = mccchannel_16_analyzer_1_array_crystal_array_7_target_x;
MCNUM target_y = mccchannel_16_analyzer_1_array_crystal_array_7_target_y;
MCNUM target_z = mccchannel_16_analyzer_1_array_crystal_array_7_target_z;
MCNUM focus_aw = mccchannel_16_analyzer_1_array_crystal_array_7_focus_aw;
MCNUM focus_ah = mccchannel_16_analyzer_1_array_crystal_array_7_focus_ah;
MCNUM focus_xw = mccchannel_16_analyzer_1_array_crystal_array_7_focus_xw;
MCNUM focus_xh = mccchannel_16_analyzer_1_array_crystal_array_7_focus_xh;
MCNUM focus_r = mccchannel_16_analyzer_1_array_crystal_array_7_focus_r;
MCNUM p_interact = mccchannel_16_analyzer_1_array_crystal_array_7_p_interact;
char* mask_string = mccchannel_16_analyzer_1_array_crystal_array_7_mask_string;
char* mask_setting = mccchannel_16_analyzer_1_array_crystal_array_7_mask_setting;
MCNUM number_of_activations = mccchannel_16_analyzer_1_array_crystal_array_7_number_of_activations;
}   /* End of channel_16_analyzer_1_array_crystal_array_7=Union_box() SETTING parameter declarations. */
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex
  /* Label for restoring  neutron */
  mcabsorbCompchannel_16_analyzer_1_array_crystal_array_7:
  if (RESTORE) /* restore if needed */
  { RESTORE_NEUTRON(745,
      mcnlx,
      mcnly,
      mcnlz,
      mcnlvx,
      mcnlvy,
      mcnlvz,
      mcnlt,
      mcnlsx,
      mcnlsy,
      mcnlsz,
      mcnlp); }
#undef mcabsorbComp
#undef p
#undef sz
#undef sy
#undef sx
#undef t
#undef vz
#undef vy
#undef vx
#undef z
#undef y
#undef x
  mcDEBUG_STATE(
mcnlx,
mcnly,
mcnlz,
mcnlvx,
mcnlvy,
mcnlvz,
mcnlt,
mcnlsx,
mcnlsy,
mcnlsz,
mcnlp)

  /* TRACE Component channel_16_analyzer_1_array_crystal_array_8 [746] */
  mccoordschange(mcposrchannel_16_analyzer_1_array_crystal_array_8, mcrotrchannel_16_analyzer_1_array_crystal_array_8,
    &mcnlx,
    &mcnly,
    &mcnlz,
    &mcnlvx,
    &mcnlvy,
    &mcnlvz,
    &mcnlsx,
    &mcnlsy,
    &mcnlsz);
  /* define label inside component channel_16_analyzer_1_array_crystal_array_8 (without coords transformations) */
  mcJumpTrace_channel_16_analyzer_1_array_crystal_array_8:
  SIG_MESSAGE("channel_16_analyzer_1_array_crystal_array_8 (Trace)");
  mcDEBUG_COMP("channel_16_analyzer_1_array_crystal_array_8")
  mcDEBUG_STATE(
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp)
#define x mcnlx
#define y mcnly
#define z mcnlz
#define vx mcnlvx
#define vy mcnlvy
#define vz mcnlvz
#define t mcnlt
#define sx mcnlsx
#define sy mcnlsy
#define sz mcnlsz
#define p mcnlp

#define mcabsorbComp mcabsorbCompchannel_16_analyzer_1_array_crystal_array_8
  STORE_NEUTRON(746,
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp);
  mcScattered=0;
  mcRestore=0;
  mcNCounter[746]++;
  mcPCounter[746] += p;
  mcP2Counter[746] += p*p;
#define mccompcurname  channel_16_analyzer_1_array_crystal_array_8
#define mccompcurtype  Union_box
#define mccompcurindex 746
#define loop_index mccchannel_16_analyzer_1_array_crystal_array_8_loop_index
#define this_box_volume mccchannel_16_analyzer_1_array_crystal_array_8_this_box_volume
#define global_geometry_element mccchannel_16_analyzer_1_array_crystal_array_8_global_geometry_element
#define this_box_storage mccchannel_16_analyzer_1_array_crystal_array_8_this_box_storage
{   /* Declarations of channel_16_analyzer_1_array_crystal_array_8=Union_box() SETTING parameters. */
char* material_string = mccchannel_16_analyzer_1_array_crystal_array_8_material_string;
MCNUM priority = mccchannel_16_analyzer_1_array_crystal_array_8_priority;
MCNUM xwidth = mccchannel_16_analyzer_1_array_crystal_array_8_xwidth;
MCNUM yheight = mccchannel_16_analyzer_1_array_crystal_array_8_yheight;
MCNUM zdepth = mccchannel_16_analyzer_1_array_crystal_array_8_zdepth;
MCNUM xwidth2 = mccchannel_16_analyzer_1_array_crystal_array_8_xwidth2;
MCNUM yheight2 = mccchannel_16_analyzer_1_array_crystal_array_8_yheight2;
MCNUM visualize = mccchannel_16_analyzer_1_array_crystal_array_8_visualize;
int target_index = mccchannel_16_analyzer_1_array_crystal_array_8_target_index;
MCNUM target_x = mccchannel_16_analyzer_1_array_crystal_array_8_target_x;
MCNUM target_y = mccchannel_16_analyzer_1_array_crystal_array_8_target_y;
MCNUM target_z = mccchannel_16_analyzer_1_array_crystal_array_8_target_z;
MCNUM focus_aw = mccchannel_16_analyzer_1_array_crystal_array_8_focus_aw;
MCNUM focus_ah = mccchannel_16_analyzer_1_array_crystal_array_8_focus_ah;
MCNUM focus_xw = mccchannel_16_analyzer_1_array_crystal_array_8_focus_xw;
MCNUM focus_xh = mccchannel_16_analyzer_1_array_crystal_array_8_focus_xh;
MCNUM focus_r = mccchannel_16_analyzer_1_array_crystal_array_8_focus_r;
MCNUM p_interact = mccchannel_16_analyzer_1_array_crystal_array_8_p_interact;
char* mask_string = mccchannel_16_analyzer_1_array_crystal_array_8_mask_string;
char* mask_setting = mccchannel_16_analyzer_1_array_crystal_array_8_mask_setting;
MCNUM number_of_activations = mccchannel_16_analyzer_1_array_crystal_array_8_number_of_activations;
}   /* End of channel_16_analyzer_1_array_crystal_array_8=Union_box() SETTING parameter declarations. */
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex
  /* Label for restoring  neutron */
  mcabsorbCompchannel_16_analyzer_1_array_crystal_array_8:
  if (RESTORE) /* restore if needed */
  { RESTORE_NEUTRON(746,
      mcnlx,
      mcnly,
      mcnlz,
      mcnlvx,
      mcnlvy,
      mcnlvz,
      mcnlt,
      mcnlsx,
      mcnlsy,
      mcnlsz,
      mcnlp); }
#undef mcabsorbComp
#undef p
#undef sz
#undef sy
#undef sx
#undef t
#undef vz
#undef vy
#undef vx
#undef z
#undef y
#undef x
  mcDEBUG_STATE(
mcnlx,
mcnly,
mcnlz,
mcnlvx,
mcnlvy,
mcnlvz,
mcnlt,
mcnlsx,
mcnlsy,
mcnlsz,
mcnlp)

  /* TRACE Component channel_16_analyzer_2_center [747] */
  mccoordschange(mcposrchannel_16_analyzer_2_center, mcrotrchannel_16_analyzer_2_center,
    &mcnlx,
    &mcnly,
    &mcnlz,
    &mcnlvx,
    &mcnlvy,
    &mcnlvz,
    &mcnlsx,
    &mcnlsy,
    &mcnlsz);
  /* define label inside component channel_16_analyzer_2_center (without coords transformations) */
  mcJumpTrace_channel_16_analyzer_2_center:
  SIG_MESSAGE("channel_16_analyzer_2_center (Trace)");
  mcDEBUG_COMP("channel_16_analyzer_2_center")
  mcDEBUG_STATE(
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp)
#define x mcnlx
#define y mcnly
#define z mcnlz
#define vx mcnlvx
#define vy mcnlvy
#define vz mcnlvz
#define t mcnlt
#define sx mcnlsx
#define sy mcnlsy
#define sz mcnlsz
#define p mcnlp

#define mcabsorbComp mcabsorbCompchannel_16_analyzer_2_center
  STORE_NEUTRON(747,
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp);
  mcScattered=0;
  mcRestore=0;
  mcNCounter[747]++;
  mcPCounter[747] += p;
  mcP2Counter[747] += p*p;
#define mccompcurname  channel_16_analyzer_2_center
#define mccompcurtype  Arm
#define mccompcurindex 747
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex
  /* Label for restoring  neutron */
  mcabsorbCompchannel_16_analyzer_2_center:
  if (RESTORE) /* restore if needed */
  { RESTORE_NEUTRON(747,
      mcnlx,
      mcnly,
      mcnlz,
      mcnlvx,
      mcnlvy,
      mcnlvz,
      mcnlt,
      mcnlsx,
      mcnlsy,
      mcnlsz,
      mcnlp); }
#undef mcabsorbComp
#undef p
#undef sz
#undef sy
#undef sx
#undef t
#undef vz
#undef vy
#undef vx
#undef z
#undef y
#undef x
  mcDEBUG_STATE(
mcnlx,
mcnly,
mcnlz,
mcnlvx,
mcnlvy,
mcnlvz,
mcnlt,
mcnlsx,
mcnlsy,
mcnlsz,
mcnlp)

  /* TRACE Component channel_16_analyzer_2_rotated [748] */
  mccoordschange(mcposrchannel_16_analyzer_2_rotated, mcrotrchannel_16_analyzer_2_rotated,
    &mcnlx,
    &mcnly,
    &mcnlz,
    &mcnlvx,
    &mcnlvy,
    &mcnlvz,
    &mcnlsx,
    &mcnlsy,
    &mcnlsz);
  /* define label inside component channel_16_analyzer_2_rotated (without coords transformations) */
  mcJumpTrace_channel_16_analyzer_2_rotated:
  SIG_MESSAGE("channel_16_analyzer_2_rotated (Trace)");
  mcDEBUG_COMP("channel_16_analyzer_2_rotated")
  mcDEBUG_STATE(
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp)
#define x mcnlx
#define y mcnly
#define z mcnlz
#define vx mcnlvx
#define vy mcnlvy
#define vz mcnlvz
#define t mcnlt
#define sx mcnlsx
#define sy mcnlsy
#define sz mcnlsz
#define p mcnlp

#define mcabsorbComp mcabsorbCompchannel_16_analyzer_2_rotated
  STORE_NEUTRON(748,
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp);
  mcScattered=0;
  mcRestore=0;
  mcNCounter[748]++;
  mcPCounter[748] += p;
  mcP2Counter[748] += p*p;
#define mccompcurname  channel_16_analyzer_2_rotated
#define mccompcurtype  Arm
#define mccompcurindex 748
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex
  /* Label for restoring  neutron */
  mcabsorbCompchannel_16_analyzer_2_rotated:
  if (RESTORE) /* restore if needed */
  { RESTORE_NEUTRON(748,
      mcnlx,
      mcnly,
      mcnlz,
      mcnlvx,
      mcnlvy,
      mcnlvz,
      mcnlt,
      mcnlsx,
      mcnlsy,
      mcnlsz,
      mcnlp); }
#undef mcabsorbComp
#undef p
#undef sz
#undef sy
#undef sx
#undef t
#undef vz
#undef vy
#undef vx
#undef z
#undef y
#undef x
  mcDEBUG_STATE(
mcnlx,
mcnly,
mcnlz,
mcnlvx,
mcnlvy,
mcnlvz,
mcnlt,
mcnlsx,
mcnlsy,
mcnlsz,
mcnlp)

  /* TRACE Component channel_16_analyzer_2_array_crystal_array_0 [749] */
  mccoordschange(mcposrchannel_16_analyzer_2_array_crystal_array_0, mcrotrchannel_16_analyzer_2_array_crystal_array_0,
    &mcnlx,
    &mcnly,
    &mcnlz,
    &mcnlvx,
    &mcnlvy,
    &mcnlvz,
    &mcnlsx,
    &mcnlsy,
    &mcnlsz);
  /* define label inside component channel_16_analyzer_2_array_crystal_array_0 (without coords transformations) */
  mcJumpTrace_channel_16_analyzer_2_array_crystal_array_0:
  SIG_MESSAGE("channel_16_analyzer_2_array_crystal_array_0 (Trace)");
  mcDEBUG_COMP("channel_16_analyzer_2_array_crystal_array_0")
  mcDEBUG_STATE(
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp)
#define x mcnlx
#define y mcnly
#define z mcnlz
#define vx mcnlvx
#define vy mcnlvy
#define vz mcnlvz
#define t mcnlt
#define sx mcnlsx
#define sy mcnlsy
#define sz mcnlsz
#define p mcnlp

#define mcabsorbComp mcabsorbCompchannel_16_analyzer_2_array_crystal_array_0
  STORE_NEUTRON(749,
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp);
  mcScattered=0;
  mcRestore=0;
  mcNCounter[749]++;
  mcPCounter[749] += p;
  mcP2Counter[749] += p*p;
#define mccompcurname  channel_16_analyzer_2_array_crystal_array_0
#define mccompcurtype  Union_box
#define mccompcurindex 749
#define loop_index mccchannel_16_analyzer_2_array_crystal_array_0_loop_index
#define this_box_volume mccchannel_16_analyzer_2_array_crystal_array_0_this_box_volume
#define global_geometry_element mccchannel_16_analyzer_2_array_crystal_array_0_global_geometry_element
#define this_box_storage mccchannel_16_analyzer_2_array_crystal_array_0_this_box_storage
{   /* Declarations of channel_16_analyzer_2_array_crystal_array_0=Union_box() SETTING parameters. */
char* material_string = mccchannel_16_analyzer_2_array_crystal_array_0_material_string;
MCNUM priority = mccchannel_16_analyzer_2_array_crystal_array_0_priority;
MCNUM xwidth = mccchannel_16_analyzer_2_array_crystal_array_0_xwidth;
MCNUM yheight = mccchannel_16_analyzer_2_array_crystal_array_0_yheight;
MCNUM zdepth = mccchannel_16_analyzer_2_array_crystal_array_0_zdepth;
MCNUM xwidth2 = mccchannel_16_analyzer_2_array_crystal_array_0_xwidth2;
MCNUM yheight2 = mccchannel_16_analyzer_2_array_crystal_array_0_yheight2;
MCNUM visualize = mccchannel_16_analyzer_2_array_crystal_array_0_visualize;
int target_index = mccchannel_16_analyzer_2_array_crystal_array_0_target_index;
MCNUM target_x = mccchannel_16_analyzer_2_array_crystal_array_0_target_x;
MCNUM target_y = mccchannel_16_analyzer_2_array_crystal_array_0_target_y;
MCNUM target_z = mccchannel_16_analyzer_2_array_crystal_array_0_target_z;
MCNUM focus_aw = mccchannel_16_analyzer_2_array_crystal_array_0_focus_aw;
MCNUM focus_ah = mccchannel_16_analyzer_2_array_crystal_array_0_focus_ah;
MCNUM focus_xw = mccchannel_16_analyzer_2_array_crystal_array_0_focus_xw;
MCNUM focus_xh = mccchannel_16_analyzer_2_array_crystal_array_0_focus_xh;
MCNUM focus_r = mccchannel_16_analyzer_2_array_crystal_array_0_focus_r;
MCNUM p_interact = mccchannel_16_analyzer_2_array_crystal_array_0_p_interact;
char* mask_string = mccchannel_16_analyzer_2_array_crystal_array_0_mask_string;
char* mask_setting = mccchannel_16_analyzer_2_array_crystal_array_0_mask_setting;
MCNUM number_of_activations = mccchannel_16_analyzer_2_array_crystal_array_0_number_of_activations;
}   /* End of channel_16_analyzer_2_array_crystal_array_0=Union_box() SETTING parameter declarations. */
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex
  /* Label for restoring  neutron */
  mcabsorbCompchannel_16_analyzer_2_array_crystal_array_0:
  if (RESTORE) /* restore if needed */
  { RESTORE_NEUTRON(749,
      mcnlx,
      mcnly,
      mcnlz,
      mcnlvx,
      mcnlvy,
      mcnlvz,
      mcnlt,
      mcnlsx,
      mcnlsy,
      mcnlsz,
      mcnlp); }
#undef mcabsorbComp
#undef p
#undef sz
#undef sy
#undef sx
#undef t
#undef vz
#undef vy
#undef vx
#undef z
#undef y
#undef x
  mcDEBUG_STATE(
mcnlx,
mcnly,
mcnlz,
mcnlvx,
mcnlvy,
mcnlvz,
mcnlt,
mcnlsx,
mcnlsy,
mcnlsz,
mcnlp)

  /* TRACE Component channel_16_analyzer_2_array_crystal_array_1 [750] */
  mccoordschange(mcposrchannel_16_analyzer_2_array_crystal_array_1, mcrotrchannel_16_analyzer_2_array_crystal_array_1,
    &mcnlx,
    &mcnly,
    &mcnlz,
    &mcnlvx,
    &mcnlvy,
    &mcnlvz,
    &mcnlsx,
    &mcnlsy,
    &mcnlsz);
  /* define label inside component channel_16_analyzer_2_array_crystal_array_1 (without coords transformations) */
  mcJumpTrace_channel_16_analyzer_2_array_crystal_array_1:
  SIG_MESSAGE("channel_16_analyzer_2_array_crystal_array_1 (Trace)");
  mcDEBUG_COMP("channel_16_analyzer_2_array_crystal_array_1")
  mcDEBUG_STATE(
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp)
#define x mcnlx
#define y mcnly
#define z mcnlz
#define vx mcnlvx
#define vy mcnlvy
#define vz mcnlvz
#define t mcnlt
#define sx mcnlsx
#define sy mcnlsy
#define sz mcnlsz
#define p mcnlp

#define mcabsorbComp mcabsorbCompchannel_16_analyzer_2_array_crystal_array_1
  STORE_NEUTRON(750,
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp);
  mcScattered=0;
  mcRestore=0;
  mcNCounter[750]++;
  mcPCounter[750] += p;
  mcP2Counter[750] += p*p;
#define mccompcurname  channel_16_analyzer_2_array_crystal_array_1
#define mccompcurtype  Union_box
#define mccompcurindex 750
#define loop_index mccchannel_16_analyzer_2_array_crystal_array_1_loop_index
#define this_box_volume mccchannel_16_analyzer_2_array_crystal_array_1_this_box_volume
#define global_geometry_element mccchannel_16_analyzer_2_array_crystal_array_1_global_geometry_element
#define this_box_storage mccchannel_16_analyzer_2_array_crystal_array_1_this_box_storage
{   /* Declarations of channel_16_analyzer_2_array_crystal_array_1=Union_box() SETTING parameters. */
char* material_string = mccchannel_16_analyzer_2_array_crystal_array_1_material_string;
MCNUM priority = mccchannel_16_analyzer_2_array_crystal_array_1_priority;
MCNUM xwidth = mccchannel_16_analyzer_2_array_crystal_array_1_xwidth;
MCNUM yheight = mccchannel_16_analyzer_2_array_crystal_array_1_yheight;
MCNUM zdepth = mccchannel_16_analyzer_2_array_crystal_array_1_zdepth;
MCNUM xwidth2 = mccchannel_16_analyzer_2_array_crystal_array_1_xwidth2;
MCNUM yheight2 = mccchannel_16_analyzer_2_array_crystal_array_1_yheight2;
MCNUM visualize = mccchannel_16_analyzer_2_array_crystal_array_1_visualize;
int target_index = mccchannel_16_analyzer_2_array_crystal_array_1_target_index;
MCNUM target_x = mccchannel_16_analyzer_2_array_crystal_array_1_target_x;
MCNUM target_y = mccchannel_16_analyzer_2_array_crystal_array_1_target_y;
MCNUM target_z = mccchannel_16_analyzer_2_array_crystal_array_1_target_z;
MCNUM focus_aw = mccchannel_16_analyzer_2_array_crystal_array_1_focus_aw;
MCNUM focus_ah = mccchannel_16_analyzer_2_array_crystal_array_1_focus_ah;
MCNUM focus_xw = mccchannel_16_analyzer_2_array_crystal_array_1_focus_xw;
MCNUM focus_xh = mccchannel_16_analyzer_2_array_crystal_array_1_focus_xh;
MCNUM focus_r = mccchannel_16_analyzer_2_array_crystal_array_1_focus_r;
MCNUM p_interact = mccchannel_16_analyzer_2_array_crystal_array_1_p_interact;
char* mask_string = mccchannel_16_analyzer_2_array_crystal_array_1_mask_string;
char* mask_setting = mccchannel_16_analyzer_2_array_crystal_array_1_mask_setting;
MCNUM number_of_activations = mccchannel_16_analyzer_2_array_crystal_array_1_number_of_activations;
}   /* End of channel_16_analyzer_2_array_crystal_array_1=Union_box() SETTING parameter declarations. */
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex
  /* Label for restoring  neutron */
  mcabsorbCompchannel_16_analyzer_2_array_crystal_array_1:
  if (RESTORE) /* restore if needed */
  { RESTORE_NEUTRON(750,
      mcnlx,
      mcnly,
      mcnlz,
      mcnlvx,
      mcnlvy,
      mcnlvz,
      mcnlt,
      mcnlsx,
      mcnlsy,
      mcnlsz,
      mcnlp); }
#undef mcabsorbComp
#undef p
#undef sz
#undef sy
#undef sx
#undef t
#undef vz
#undef vy
#undef vx
#undef z
#undef y
#undef x
  mcDEBUG_STATE(
mcnlx,
mcnly,
mcnlz,
mcnlvx,
mcnlvy,
mcnlvz,
mcnlt,
mcnlsx,
mcnlsy,
mcnlsz,
mcnlp)

  /* TRACE Component channel_16_analyzer_2_array_crystal_array_2 [751] */
  mccoordschange(mcposrchannel_16_analyzer_2_array_crystal_array_2, mcrotrchannel_16_analyzer_2_array_crystal_array_2,
    &mcnlx,
    &mcnly,
    &mcnlz,
    &mcnlvx,
    &mcnlvy,
    &mcnlvz,
    &mcnlsx,
    &mcnlsy,
    &mcnlsz);
  /* define label inside component channel_16_analyzer_2_array_crystal_array_2 (without coords transformations) */
  mcJumpTrace_channel_16_analyzer_2_array_crystal_array_2:
  SIG_MESSAGE("channel_16_analyzer_2_array_crystal_array_2 (Trace)");
  mcDEBUG_COMP("channel_16_analyzer_2_array_crystal_array_2")
  mcDEBUG_STATE(
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp)
#define x mcnlx
#define y mcnly
#define z mcnlz
#define vx mcnlvx
#define vy mcnlvy
#define vz mcnlvz
#define t mcnlt
#define sx mcnlsx
#define sy mcnlsy
#define sz mcnlsz
#define p mcnlp

#define mcabsorbComp mcabsorbCompchannel_16_analyzer_2_array_crystal_array_2
  STORE_NEUTRON(751,
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp);
  mcScattered=0;
  mcRestore=0;
  mcNCounter[751]++;
  mcPCounter[751] += p;
  mcP2Counter[751] += p*p;
#define mccompcurname  channel_16_analyzer_2_array_crystal_array_2
#define mccompcurtype  Union_box
#define mccompcurindex 751
#define loop_index mccchannel_16_analyzer_2_array_crystal_array_2_loop_index
#define this_box_volume mccchannel_16_analyzer_2_array_crystal_array_2_this_box_volume
#define global_geometry_element mccchannel_16_analyzer_2_array_crystal_array_2_global_geometry_element
#define this_box_storage mccchannel_16_analyzer_2_array_crystal_array_2_this_box_storage
{   /* Declarations of channel_16_analyzer_2_array_crystal_array_2=Union_box() SETTING parameters. */
char* material_string = mccchannel_16_analyzer_2_array_crystal_array_2_material_string;
MCNUM priority = mccchannel_16_analyzer_2_array_crystal_array_2_priority;
MCNUM xwidth = mccchannel_16_analyzer_2_array_crystal_array_2_xwidth;
MCNUM yheight = mccchannel_16_analyzer_2_array_crystal_array_2_yheight;
MCNUM zdepth = mccchannel_16_analyzer_2_array_crystal_array_2_zdepth;
MCNUM xwidth2 = mccchannel_16_analyzer_2_array_crystal_array_2_xwidth2;
MCNUM yheight2 = mccchannel_16_analyzer_2_array_crystal_array_2_yheight2;
MCNUM visualize = mccchannel_16_analyzer_2_array_crystal_array_2_visualize;
int target_index = mccchannel_16_analyzer_2_array_crystal_array_2_target_index;
MCNUM target_x = mccchannel_16_analyzer_2_array_crystal_array_2_target_x;
MCNUM target_y = mccchannel_16_analyzer_2_array_crystal_array_2_target_y;
MCNUM target_z = mccchannel_16_analyzer_2_array_crystal_array_2_target_z;
MCNUM focus_aw = mccchannel_16_analyzer_2_array_crystal_array_2_focus_aw;
MCNUM focus_ah = mccchannel_16_analyzer_2_array_crystal_array_2_focus_ah;
MCNUM focus_xw = mccchannel_16_analyzer_2_array_crystal_array_2_focus_xw;
MCNUM focus_xh = mccchannel_16_analyzer_2_array_crystal_array_2_focus_xh;
MCNUM focus_r = mccchannel_16_analyzer_2_array_crystal_array_2_focus_r;
MCNUM p_interact = mccchannel_16_analyzer_2_array_crystal_array_2_p_interact;
char* mask_string = mccchannel_16_analyzer_2_array_crystal_array_2_mask_string;
char* mask_setting = mccchannel_16_analyzer_2_array_crystal_array_2_mask_setting;
MCNUM number_of_activations = mccchannel_16_analyzer_2_array_crystal_array_2_number_of_activations;
}   /* End of channel_16_analyzer_2_array_crystal_array_2=Union_box() SETTING parameter declarations. */
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex
  /* Label for restoring  neutron */
  mcabsorbCompchannel_16_analyzer_2_array_crystal_array_2:
  if (RESTORE) /* restore if needed */
  { RESTORE_NEUTRON(751,
      mcnlx,
      mcnly,
      mcnlz,
      mcnlvx,
      mcnlvy,
      mcnlvz,
      mcnlt,
      mcnlsx,
      mcnlsy,
      mcnlsz,
      mcnlp); }
#undef mcabsorbComp
#undef p
#undef sz
#undef sy
#undef sx
#undef t
#undef vz
#undef vy
#undef vx
#undef z
#undef y
#undef x
  mcDEBUG_STATE(
mcnlx,
mcnly,
mcnlz,
mcnlvx,
mcnlvy,
mcnlvz,
mcnlt,
mcnlsx,
mcnlsy,
mcnlsz,
mcnlp)

  /* TRACE Component channel_16_analyzer_2_array_crystal_array_3 [752] */
  mccoordschange(mcposrchannel_16_analyzer_2_array_crystal_array_3, mcrotrchannel_16_analyzer_2_array_crystal_array_3,
    &mcnlx,
    &mcnly,
    &mcnlz,
    &mcnlvx,
    &mcnlvy,
    &mcnlvz,
    &mcnlsx,
    &mcnlsy,
    &mcnlsz);
  /* define label inside component channel_16_analyzer_2_array_crystal_array_3 (without coords transformations) */
  mcJumpTrace_channel_16_analyzer_2_array_crystal_array_3:
  SIG_MESSAGE("channel_16_analyzer_2_array_crystal_array_3 (Trace)");
  mcDEBUG_COMP("channel_16_analyzer_2_array_crystal_array_3")
  mcDEBUG_STATE(
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp)
#define x mcnlx
#define y mcnly
#define z mcnlz
#define vx mcnlvx
#define vy mcnlvy
#define vz mcnlvz
#define t mcnlt
#define sx mcnlsx
#define sy mcnlsy
#define sz mcnlsz
#define p mcnlp

#define mcabsorbComp mcabsorbCompchannel_16_analyzer_2_array_crystal_array_3
  STORE_NEUTRON(752,
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp);
  mcScattered=0;
  mcRestore=0;
  mcNCounter[752]++;
  mcPCounter[752] += p;
  mcP2Counter[752] += p*p;
#define mccompcurname  channel_16_analyzer_2_array_crystal_array_3
#define mccompcurtype  Union_box
#define mccompcurindex 752
#define loop_index mccchannel_16_analyzer_2_array_crystal_array_3_loop_index
#define this_box_volume mccchannel_16_analyzer_2_array_crystal_array_3_this_box_volume
#define global_geometry_element mccchannel_16_analyzer_2_array_crystal_array_3_global_geometry_element
#define this_box_storage mccchannel_16_analyzer_2_array_crystal_array_3_this_box_storage
{   /* Declarations of channel_16_analyzer_2_array_crystal_array_3=Union_box() SETTING parameters. */
char* material_string = mccchannel_16_analyzer_2_array_crystal_array_3_material_string;
MCNUM priority = mccchannel_16_analyzer_2_array_crystal_array_3_priority;
MCNUM xwidth = mccchannel_16_analyzer_2_array_crystal_array_3_xwidth;
MCNUM yheight = mccchannel_16_analyzer_2_array_crystal_array_3_yheight;
MCNUM zdepth = mccchannel_16_analyzer_2_array_crystal_array_3_zdepth;
MCNUM xwidth2 = mccchannel_16_analyzer_2_array_crystal_array_3_xwidth2;
MCNUM yheight2 = mccchannel_16_analyzer_2_array_crystal_array_3_yheight2;
MCNUM visualize = mccchannel_16_analyzer_2_array_crystal_array_3_visualize;
int target_index = mccchannel_16_analyzer_2_array_crystal_array_3_target_index;
MCNUM target_x = mccchannel_16_analyzer_2_array_crystal_array_3_target_x;
MCNUM target_y = mccchannel_16_analyzer_2_array_crystal_array_3_target_y;
MCNUM target_z = mccchannel_16_analyzer_2_array_crystal_array_3_target_z;
MCNUM focus_aw = mccchannel_16_analyzer_2_array_crystal_array_3_focus_aw;
MCNUM focus_ah = mccchannel_16_analyzer_2_array_crystal_array_3_focus_ah;
MCNUM focus_xw = mccchannel_16_analyzer_2_array_crystal_array_3_focus_xw;
MCNUM focus_xh = mccchannel_16_analyzer_2_array_crystal_array_3_focus_xh;
MCNUM focus_r = mccchannel_16_analyzer_2_array_crystal_array_3_focus_r;
MCNUM p_interact = mccchannel_16_analyzer_2_array_crystal_array_3_p_interact;
char* mask_string = mccchannel_16_analyzer_2_array_crystal_array_3_mask_string;
char* mask_setting = mccchannel_16_analyzer_2_array_crystal_array_3_mask_setting;
MCNUM number_of_activations = mccchannel_16_analyzer_2_array_crystal_array_3_number_of_activations;
}   /* End of channel_16_analyzer_2_array_crystal_array_3=Union_box() SETTING parameter declarations. */
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex
  /* Label for restoring  neutron */
  mcabsorbCompchannel_16_analyzer_2_array_crystal_array_3:
  if (RESTORE) /* restore if needed */
  { RESTORE_NEUTRON(752,
      mcnlx,
      mcnly,
      mcnlz,
      mcnlvx,
      mcnlvy,
      mcnlvz,
      mcnlt,
      mcnlsx,
      mcnlsy,
      mcnlsz,
      mcnlp); }
#undef mcabsorbComp
#undef p
#undef sz
#undef sy
#undef sx
#undef t
#undef vz
#undef vy
#undef vx
#undef z
#undef y
#undef x
  mcDEBUG_STATE(
mcnlx,
mcnly,
mcnlz,
mcnlvx,
mcnlvy,
mcnlvz,
mcnlt,
mcnlsx,
mcnlsy,
mcnlsz,
mcnlp)

  /* TRACE Component channel_16_analyzer_2_array_crystal_array_4 [753] */
  mccoordschange(mcposrchannel_16_analyzer_2_array_crystal_array_4, mcrotrchannel_16_analyzer_2_array_crystal_array_4,
    &mcnlx,
    &mcnly,
    &mcnlz,
    &mcnlvx,
    &mcnlvy,
    &mcnlvz,
    &mcnlsx,
    &mcnlsy,
    &mcnlsz);
  /* define label inside component channel_16_analyzer_2_array_crystal_array_4 (without coords transformations) */
  mcJumpTrace_channel_16_analyzer_2_array_crystal_array_4:
  SIG_MESSAGE("channel_16_analyzer_2_array_crystal_array_4 (Trace)");
  mcDEBUG_COMP("channel_16_analyzer_2_array_crystal_array_4")
  mcDEBUG_STATE(
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp)
#define x mcnlx
#define y mcnly
#define z mcnlz
#define vx mcnlvx
#define vy mcnlvy
#define vz mcnlvz
#define t mcnlt
#define sx mcnlsx
#define sy mcnlsy
#define sz mcnlsz
#define p mcnlp

#define mcabsorbComp mcabsorbCompchannel_16_analyzer_2_array_crystal_array_4
  STORE_NEUTRON(753,
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp);
  mcScattered=0;
  mcRestore=0;
  mcNCounter[753]++;
  mcPCounter[753] += p;
  mcP2Counter[753] += p*p;
#define mccompcurname  channel_16_analyzer_2_array_crystal_array_4
#define mccompcurtype  Union_box
#define mccompcurindex 753
#define loop_index mccchannel_16_analyzer_2_array_crystal_array_4_loop_index
#define this_box_volume mccchannel_16_analyzer_2_array_crystal_array_4_this_box_volume
#define global_geometry_element mccchannel_16_analyzer_2_array_crystal_array_4_global_geometry_element
#define this_box_storage mccchannel_16_analyzer_2_array_crystal_array_4_this_box_storage
{   /* Declarations of channel_16_analyzer_2_array_crystal_array_4=Union_box() SETTING parameters. */
char* material_string = mccchannel_16_analyzer_2_array_crystal_array_4_material_string;
MCNUM priority = mccchannel_16_analyzer_2_array_crystal_array_4_priority;
MCNUM xwidth = mccchannel_16_analyzer_2_array_crystal_array_4_xwidth;
MCNUM yheight = mccchannel_16_analyzer_2_array_crystal_array_4_yheight;
MCNUM zdepth = mccchannel_16_analyzer_2_array_crystal_array_4_zdepth;
MCNUM xwidth2 = mccchannel_16_analyzer_2_array_crystal_array_4_xwidth2;
MCNUM yheight2 = mccchannel_16_analyzer_2_array_crystal_array_4_yheight2;
MCNUM visualize = mccchannel_16_analyzer_2_array_crystal_array_4_visualize;
int target_index = mccchannel_16_analyzer_2_array_crystal_array_4_target_index;
MCNUM target_x = mccchannel_16_analyzer_2_array_crystal_array_4_target_x;
MCNUM target_y = mccchannel_16_analyzer_2_array_crystal_array_4_target_y;
MCNUM target_z = mccchannel_16_analyzer_2_array_crystal_array_4_target_z;
MCNUM focus_aw = mccchannel_16_analyzer_2_array_crystal_array_4_focus_aw;
MCNUM focus_ah = mccchannel_16_analyzer_2_array_crystal_array_4_focus_ah;
MCNUM focus_xw = mccchannel_16_analyzer_2_array_crystal_array_4_focus_xw;
MCNUM focus_xh = mccchannel_16_analyzer_2_array_crystal_array_4_focus_xh;
MCNUM focus_r = mccchannel_16_analyzer_2_array_crystal_array_4_focus_r;
MCNUM p_interact = mccchannel_16_analyzer_2_array_crystal_array_4_p_interact;
char* mask_string = mccchannel_16_analyzer_2_array_crystal_array_4_mask_string;
char* mask_setting = mccchannel_16_analyzer_2_array_crystal_array_4_mask_setting;
MCNUM number_of_activations = mccchannel_16_analyzer_2_array_crystal_array_4_number_of_activations;
}   /* End of channel_16_analyzer_2_array_crystal_array_4=Union_box() SETTING parameter declarations. */
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex
  /* Label for restoring  neutron */
  mcabsorbCompchannel_16_analyzer_2_array_crystal_array_4:
  if (RESTORE) /* restore if needed */
  { RESTORE_NEUTRON(753,
      mcnlx,
      mcnly,
      mcnlz,
      mcnlvx,
      mcnlvy,
      mcnlvz,
      mcnlt,
      mcnlsx,
      mcnlsy,
      mcnlsz,
      mcnlp); }
#undef mcabsorbComp
#undef p
#undef sz
#undef sy
#undef sx
#undef t
#undef vz
#undef vy
#undef vx
#undef z
#undef y
#undef x
  mcDEBUG_STATE(
mcnlx,
mcnly,
mcnlz,
mcnlvx,
mcnlvy,
mcnlvz,
mcnlt,
mcnlsx,
mcnlsy,
mcnlsz,
mcnlp)

  /* TRACE Component channel_16_analyzer_2_array_crystal_array_5 [754] */
  mccoordschange(mcposrchannel_16_analyzer_2_array_crystal_array_5, mcrotrchannel_16_analyzer_2_array_crystal_array_5,
    &mcnlx,
    &mcnly,
    &mcnlz,
    &mcnlvx,
    &mcnlvy,
    &mcnlvz,
    &mcnlsx,
    &mcnlsy,
    &mcnlsz);
  /* define label inside component channel_16_analyzer_2_array_crystal_array_5 (without coords transformations) */
  mcJumpTrace_channel_16_analyzer_2_array_crystal_array_5:
  SIG_MESSAGE("channel_16_analyzer_2_array_crystal_array_5 (Trace)");
  mcDEBUG_COMP("channel_16_analyzer_2_array_crystal_array_5")
  mcDEBUG_STATE(
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp)
#define x mcnlx
#define y mcnly
#define z mcnlz
#define vx mcnlvx
#define vy mcnlvy
#define vz mcnlvz
#define t mcnlt
#define sx mcnlsx
#define sy mcnlsy
#define sz mcnlsz
#define p mcnlp

#define mcabsorbComp mcabsorbCompchannel_16_analyzer_2_array_crystal_array_5
  STORE_NEUTRON(754,
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp);
  mcScattered=0;
  mcRestore=0;
  mcNCounter[754]++;
  mcPCounter[754] += p;
  mcP2Counter[754] += p*p;
#define mccompcurname  channel_16_analyzer_2_array_crystal_array_5
#define mccompcurtype  Union_box
#define mccompcurindex 754
#define loop_index mccchannel_16_analyzer_2_array_crystal_array_5_loop_index
#define this_box_volume mccchannel_16_analyzer_2_array_crystal_array_5_this_box_volume
#define global_geometry_element mccchannel_16_analyzer_2_array_crystal_array_5_global_geometry_element
#define this_box_storage mccchannel_16_analyzer_2_array_crystal_array_5_this_box_storage
{   /* Declarations of channel_16_analyzer_2_array_crystal_array_5=Union_box() SETTING parameters. */
char* material_string = mccchannel_16_analyzer_2_array_crystal_array_5_material_string;
MCNUM priority = mccchannel_16_analyzer_2_array_crystal_array_5_priority;
MCNUM xwidth = mccchannel_16_analyzer_2_array_crystal_array_5_xwidth;
MCNUM yheight = mccchannel_16_analyzer_2_array_crystal_array_5_yheight;
MCNUM zdepth = mccchannel_16_analyzer_2_array_crystal_array_5_zdepth;
MCNUM xwidth2 = mccchannel_16_analyzer_2_array_crystal_array_5_xwidth2;
MCNUM yheight2 = mccchannel_16_analyzer_2_array_crystal_array_5_yheight2;
MCNUM visualize = mccchannel_16_analyzer_2_array_crystal_array_5_visualize;
int target_index = mccchannel_16_analyzer_2_array_crystal_array_5_target_index;
MCNUM target_x = mccchannel_16_analyzer_2_array_crystal_array_5_target_x;
MCNUM target_y = mccchannel_16_analyzer_2_array_crystal_array_5_target_y;
MCNUM target_z = mccchannel_16_analyzer_2_array_crystal_array_5_target_z;
MCNUM focus_aw = mccchannel_16_analyzer_2_array_crystal_array_5_focus_aw;
MCNUM focus_ah = mccchannel_16_analyzer_2_array_crystal_array_5_focus_ah;
MCNUM focus_xw = mccchannel_16_analyzer_2_array_crystal_array_5_focus_xw;
MCNUM focus_xh = mccchannel_16_analyzer_2_array_crystal_array_5_focus_xh;
MCNUM focus_r = mccchannel_16_analyzer_2_array_crystal_array_5_focus_r;
MCNUM p_interact = mccchannel_16_analyzer_2_array_crystal_array_5_p_interact;
char* mask_string = mccchannel_16_analyzer_2_array_crystal_array_5_mask_string;
char* mask_setting = mccchannel_16_analyzer_2_array_crystal_array_5_mask_setting;
MCNUM number_of_activations = mccchannel_16_analyzer_2_array_crystal_array_5_number_of_activations;
}   /* End of channel_16_analyzer_2_array_crystal_array_5=Union_box() SETTING parameter declarations. */
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex
  /* Label for restoring  neutron */
  mcabsorbCompchannel_16_analyzer_2_array_crystal_array_5:
  if (RESTORE) /* restore if needed */
  { RESTORE_NEUTRON(754,
      mcnlx,
      mcnly,
      mcnlz,
      mcnlvx,
      mcnlvy,
      mcnlvz,
      mcnlt,
      mcnlsx,
      mcnlsy,
      mcnlsz,
      mcnlp); }
#undef mcabsorbComp
#undef p
#undef sz
#undef sy
#undef sx
#undef t
#undef vz
#undef vy
#undef vx
#undef z
#undef y
#undef x
  mcDEBUG_STATE(
mcnlx,
mcnly,
mcnlz,
mcnlvx,
mcnlvy,
mcnlvz,
mcnlt,
mcnlsx,
mcnlsy,
mcnlsz,
mcnlp)

  /* TRACE Component channel_16_analyzer_2_array_crystal_array_6 [755] */
  mccoordschange(mcposrchannel_16_analyzer_2_array_crystal_array_6, mcrotrchannel_16_analyzer_2_array_crystal_array_6,
    &mcnlx,
    &mcnly,
    &mcnlz,
    &mcnlvx,
    &mcnlvy,
    &mcnlvz,
    &mcnlsx,
    &mcnlsy,
    &mcnlsz);
  /* define label inside component channel_16_analyzer_2_array_crystal_array_6 (without coords transformations) */
  mcJumpTrace_channel_16_analyzer_2_array_crystal_array_6:
  SIG_MESSAGE("channel_16_analyzer_2_array_crystal_array_6 (Trace)");
  mcDEBUG_COMP("channel_16_analyzer_2_array_crystal_array_6")
  mcDEBUG_STATE(
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp)
#define x mcnlx
#define y mcnly
#define z mcnlz
#define vx mcnlvx
#define vy mcnlvy
#define vz mcnlvz
#define t mcnlt
#define sx mcnlsx
#define sy mcnlsy
#define sz mcnlsz
#define p mcnlp

#define mcabsorbComp mcabsorbCompchannel_16_analyzer_2_array_crystal_array_6
  STORE_NEUTRON(755,
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp);
  mcScattered=0;
  mcRestore=0;
  mcNCounter[755]++;
  mcPCounter[755] += p;
  mcP2Counter[755] += p*p;
#define mccompcurname  channel_16_analyzer_2_array_crystal_array_6
#define mccompcurtype  Union_box
#define mccompcurindex 755
#define loop_index mccchannel_16_analyzer_2_array_crystal_array_6_loop_index
#define this_box_volume mccchannel_16_analyzer_2_array_crystal_array_6_this_box_volume
#define global_geometry_element mccchannel_16_analyzer_2_array_crystal_array_6_global_geometry_element
#define this_box_storage mccchannel_16_analyzer_2_array_crystal_array_6_this_box_storage
{   /* Declarations of channel_16_analyzer_2_array_crystal_array_6=Union_box() SETTING parameters. */
char* material_string = mccchannel_16_analyzer_2_array_crystal_array_6_material_string;
MCNUM priority = mccchannel_16_analyzer_2_array_crystal_array_6_priority;
MCNUM xwidth = mccchannel_16_analyzer_2_array_crystal_array_6_xwidth;
MCNUM yheight = mccchannel_16_analyzer_2_array_crystal_array_6_yheight;
MCNUM zdepth = mccchannel_16_analyzer_2_array_crystal_array_6_zdepth;
MCNUM xwidth2 = mccchannel_16_analyzer_2_array_crystal_array_6_xwidth2;
MCNUM yheight2 = mccchannel_16_analyzer_2_array_crystal_array_6_yheight2;
MCNUM visualize = mccchannel_16_analyzer_2_array_crystal_array_6_visualize;
int target_index = mccchannel_16_analyzer_2_array_crystal_array_6_target_index;
MCNUM target_x = mccchannel_16_analyzer_2_array_crystal_array_6_target_x;
MCNUM target_y = mccchannel_16_analyzer_2_array_crystal_array_6_target_y;
MCNUM target_z = mccchannel_16_analyzer_2_array_crystal_array_6_target_z;
MCNUM focus_aw = mccchannel_16_analyzer_2_array_crystal_array_6_focus_aw;
MCNUM focus_ah = mccchannel_16_analyzer_2_array_crystal_array_6_focus_ah;
MCNUM focus_xw = mccchannel_16_analyzer_2_array_crystal_array_6_focus_xw;
MCNUM focus_xh = mccchannel_16_analyzer_2_array_crystal_array_6_focus_xh;
MCNUM focus_r = mccchannel_16_analyzer_2_array_crystal_array_6_focus_r;
MCNUM p_interact = mccchannel_16_analyzer_2_array_crystal_array_6_p_interact;
char* mask_string = mccchannel_16_analyzer_2_array_crystal_array_6_mask_string;
char* mask_setting = mccchannel_16_analyzer_2_array_crystal_array_6_mask_setting;
MCNUM number_of_activations = mccchannel_16_analyzer_2_array_crystal_array_6_number_of_activations;
}   /* End of channel_16_analyzer_2_array_crystal_array_6=Union_box() SETTING parameter declarations. */
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex
  /* Label for restoring  neutron */
  mcabsorbCompchannel_16_analyzer_2_array_crystal_array_6:
  if (RESTORE) /* restore if needed */
  { RESTORE_NEUTRON(755,
      mcnlx,
      mcnly,
      mcnlz,
      mcnlvx,
      mcnlvy,
      mcnlvz,
      mcnlt,
      mcnlsx,
      mcnlsy,
      mcnlsz,
      mcnlp); }
#undef mcabsorbComp
#undef p
#undef sz
#undef sy
#undef sx
#undef t
#undef vz
#undef vy
#undef vx
#undef z
#undef y
#undef x
  mcDEBUG_STATE(
mcnlx,
mcnly,
mcnlz,
mcnlvx,
mcnlvy,
mcnlvz,
mcnlt,
mcnlsx,
mcnlsy,
mcnlsz,
mcnlp)

  /* TRACE Component channel_16_analyzer_2_array_crystal_array_7 [756] */
  mccoordschange(mcposrchannel_16_analyzer_2_array_crystal_array_7, mcrotrchannel_16_analyzer_2_array_crystal_array_7,
    &mcnlx,
    &mcnly,
    &mcnlz,
    &mcnlvx,
    &mcnlvy,
    &mcnlvz,
    &mcnlsx,
    &mcnlsy,
    &mcnlsz);
  /* define label inside component channel_16_analyzer_2_array_crystal_array_7 (without coords transformations) */
  mcJumpTrace_channel_16_analyzer_2_array_crystal_array_7:
  SIG_MESSAGE("channel_16_analyzer_2_array_crystal_array_7 (Trace)");
  mcDEBUG_COMP("channel_16_analyzer_2_array_crystal_array_7")
  mcDEBUG_STATE(
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp)
#define x mcnlx
#define y mcnly
#define z mcnlz
#define vx mcnlvx
#define vy mcnlvy
#define vz mcnlvz
#define t mcnlt
#define sx mcnlsx
#define sy mcnlsy
#define sz mcnlsz
#define p mcnlp

#define mcabsorbComp mcabsorbCompchannel_16_analyzer_2_array_crystal_array_7
  STORE_NEUTRON(756,
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp);
  mcScattered=0;
  mcRestore=0;
  mcNCounter[756]++;
  mcPCounter[756] += p;
  mcP2Counter[756] += p*p;
#define mccompcurname  channel_16_analyzer_2_array_crystal_array_7
#define mccompcurtype  Union_box
#define mccompcurindex 756
#define loop_index mccchannel_16_analyzer_2_array_crystal_array_7_loop_index
#define this_box_volume mccchannel_16_analyzer_2_array_crystal_array_7_this_box_volume
#define global_geometry_element mccchannel_16_analyzer_2_array_crystal_array_7_global_geometry_element
#define this_box_storage mccchannel_16_analyzer_2_array_crystal_array_7_this_box_storage
{   /* Declarations of channel_16_analyzer_2_array_crystal_array_7=Union_box() SETTING parameters. */
char* material_string = mccchannel_16_analyzer_2_array_crystal_array_7_material_string;
MCNUM priority = mccchannel_16_analyzer_2_array_crystal_array_7_priority;
MCNUM xwidth = mccchannel_16_analyzer_2_array_crystal_array_7_xwidth;
MCNUM yheight = mccchannel_16_analyzer_2_array_crystal_array_7_yheight;
MCNUM zdepth = mccchannel_16_analyzer_2_array_crystal_array_7_zdepth;
MCNUM xwidth2 = mccchannel_16_analyzer_2_array_crystal_array_7_xwidth2;
MCNUM yheight2 = mccchannel_16_analyzer_2_array_crystal_array_7_yheight2;
MCNUM visualize = mccchannel_16_analyzer_2_array_crystal_array_7_visualize;
int target_index = mccchannel_16_analyzer_2_array_crystal_array_7_target_index;
MCNUM target_x = mccchannel_16_analyzer_2_array_crystal_array_7_target_x;
MCNUM target_y = mccchannel_16_analyzer_2_array_crystal_array_7_target_y;
MCNUM target_z = mccchannel_16_analyzer_2_array_crystal_array_7_target_z;
MCNUM focus_aw = mccchannel_16_analyzer_2_array_crystal_array_7_focus_aw;
MCNUM focus_ah = mccchannel_16_analyzer_2_array_crystal_array_7_focus_ah;
MCNUM focus_xw = mccchannel_16_analyzer_2_array_crystal_array_7_focus_xw;
MCNUM focus_xh = mccchannel_16_analyzer_2_array_crystal_array_7_focus_xh;
MCNUM focus_r = mccchannel_16_analyzer_2_array_crystal_array_7_focus_r;
MCNUM p_interact = mccchannel_16_analyzer_2_array_crystal_array_7_p_interact;
char* mask_string = mccchannel_16_analyzer_2_array_crystal_array_7_mask_string;
char* mask_setting = mccchannel_16_analyzer_2_array_crystal_array_7_mask_setting;
MCNUM number_of_activations = mccchannel_16_analyzer_2_array_crystal_array_7_number_of_activations;
}   /* End of channel_16_analyzer_2_array_crystal_array_7=Union_box() SETTING parameter declarations. */
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex
  /* Label for restoring  neutron */
  mcabsorbCompchannel_16_analyzer_2_array_crystal_array_7:
  if (RESTORE) /* restore if needed */
  { RESTORE_NEUTRON(756,
      mcnlx,
      mcnly,
      mcnlz,
      mcnlvx,
      mcnlvy,
      mcnlvz,
      mcnlt,
      mcnlsx,
      mcnlsy,
      mcnlsz,
      mcnlp); }
#undef mcabsorbComp
#undef p
#undef sz
#undef sy
#undef sx
#undef t
#undef vz
#undef vy
#undef vx
#undef z
#undef y
#undef x
  mcDEBUG_STATE(
mcnlx,
mcnly,
mcnlz,
mcnlvx,
mcnlvy,
mcnlvz,
mcnlt,
mcnlsx,
mcnlsy,
mcnlsz,
mcnlp)

  /* TRACE Component channel_16_analyzer_2_array_crystal_array_8 [757] */
  mccoordschange(mcposrchannel_16_analyzer_2_array_crystal_array_8, mcrotrchannel_16_analyzer_2_array_crystal_array_8,
    &mcnlx,
    &mcnly,
    &mcnlz,
    &mcnlvx,
    &mcnlvy,
    &mcnlvz,
    &mcnlsx,
    &mcnlsy,
    &mcnlsz);
  /* define label inside component channel_16_analyzer_2_array_crystal_array_8 (without coords transformations) */
  mcJumpTrace_channel_16_analyzer_2_array_crystal_array_8:
  SIG_MESSAGE("channel_16_analyzer_2_array_crystal_array_8 (Trace)");
  mcDEBUG_COMP("channel_16_analyzer_2_array_crystal_array_8")
  mcDEBUG_STATE(
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp)
#define x mcnlx
#define y mcnly
#define z mcnlz
#define vx mcnlvx
#define vy mcnlvy
#define vz mcnlvz
#define t mcnlt
#define sx mcnlsx
#define sy mcnlsy
#define sz mcnlsz
#define p mcnlp

#define mcabsorbComp mcabsorbCompchannel_16_analyzer_2_array_crystal_array_8
  STORE_NEUTRON(757,
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp);
  mcScattered=0;
  mcRestore=0;
  mcNCounter[757]++;
  mcPCounter[757] += p;
  mcP2Counter[757] += p*p;
#define mccompcurname  channel_16_analyzer_2_array_crystal_array_8
#define mccompcurtype  Union_box
#define mccompcurindex 757
#define loop_index mccchannel_16_analyzer_2_array_crystal_array_8_loop_index
#define this_box_volume mccchannel_16_analyzer_2_array_crystal_array_8_this_box_volume
#define global_geometry_element mccchannel_16_analyzer_2_array_crystal_array_8_global_geometry_element
#define this_box_storage mccchannel_16_analyzer_2_array_crystal_array_8_this_box_storage
{   /* Declarations of channel_16_analyzer_2_array_crystal_array_8=Union_box() SETTING parameters. */
char* material_string = mccchannel_16_analyzer_2_array_crystal_array_8_material_string;
MCNUM priority = mccchannel_16_analyzer_2_array_crystal_array_8_priority;
MCNUM xwidth = mccchannel_16_analyzer_2_array_crystal_array_8_xwidth;
MCNUM yheight = mccchannel_16_analyzer_2_array_crystal_array_8_yheight;
MCNUM zdepth = mccchannel_16_analyzer_2_array_crystal_array_8_zdepth;
MCNUM xwidth2 = mccchannel_16_analyzer_2_array_crystal_array_8_xwidth2;
MCNUM yheight2 = mccchannel_16_analyzer_2_array_crystal_array_8_yheight2;
MCNUM visualize = mccchannel_16_analyzer_2_array_crystal_array_8_visualize;
int target_index = mccchannel_16_analyzer_2_array_crystal_array_8_target_index;
MCNUM target_x = mccchannel_16_analyzer_2_array_crystal_array_8_target_x;
MCNUM target_y = mccchannel_16_analyzer_2_array_crystal_array_8_target_y;
MCNUM target_z = mccchannel_16_analyzer_2_array_crystal_array_8_target_z;
MCNUM focus_aw = mccchannel_16_analyzer_2_array_crystal_array_8_focus_aw;
MCNUM focus_ah = mccchannel_16_analyzer_2_array_crystal_array_8_focus_ah;
MCNUM focus_xw = mccchannel_16_analyzer_2_array_crystal_array_8_focus_xw;
MCNUM focus_xh = mccchannel_16_analyzer_2_array_crystal_array_8_focus_xh;
MCNUM focus_r = mccchannel_16_analyzer_2_array_crystal_array_8_focus_r;
MCNUM p_interact = mccchannel_16_analyzer_2_array_crystal_array_8_p_interact;
char* mask_string = mccchannel_16_analyzer_2_array_crystal_array_8_mask_string;
char* mask_setting = mccchannel_16_analyzer_2_array_crystal_array_8_mask_setting;
MCNUM number_of_activations = mccchannel_16_analyzer_2_array_crystal_array_8_number_of_activations;
}   /* End of channel_16_analyzer_2_array_crystal_array_8=Union_box() SETTING parameter declarations. */
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex
  /* Label for restoring  neutron */
  mcabsorbCompchannel_16_analyzer_2_array_crystal_array_8:
  if (RESTORE) /* restore if needed */
  { RESTORE_NEUTRON(757,
      mcnlx,
      mcnly,
      mcnlz,
      mcnlvx,
      mcnlvy,
      mcnlvz,
      mcnlt,
      mcnlsx,
      mcnlsy,
      mcnlsz,
      mcnlp); }
#undef mcabsorbComp
#undef p
#undef sz
#undef sy
#undef sx
#undef t
#undef vz
#undef vy
#undef vx
#undef z
#undef y
#undef x
  mcDEBUG_STATE(
mcnlx,
mcnly,
mcnlz,
mcnlvx,
mcnlvy,
mcnlvz,
mcnlt,
mcnlsx,
mcnlsy,
mcnlsz,
mcnlp)

  /* TRACE Component channel_16_cave2_cyl1 [758] */
  mccoordschange(mcposrchannel_16_cave2_cyl1, mcrotrchannel_16_cave2_cyl1,
    &mcnlx,
    &mcnly,
    &mcnlz,
    &mcnlvx,
    &mcnlvy,
    &mcnlvz,
    &mcnlsx,
    &mcnlsy,
    &mcnlsz);
  /* define label inside component channel_16_cave2_cyl1 (without coords transformations) */
  mcJumpTrace_channel_16_cave2_cyl1:
  SIG_MESSAGE("channel_16_cave2_cyl1 (Trace)");
  mcDEBUG_COMP("channel_16_cave2_cyl1")
  mcDEBUG_STATE(
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp)
#define x mcnlx
#define y mcnly
#define z mcnlz
#define vx mcnlvx
#define vy mcnlvy
#define vz mcnlvz
#define t mcnlt
#define sx mcnlsx
#define sy mcnlsy
#define sz mcnlsz
#define p mcnlp

#define mcabsorbComp mcabsorbCompchannel_16_cave2_cyl1
  STORE_NEUTRON(758,
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp);
  mcScattered=0;
  mcRestore=0;
  mcNCounter[758]++;
  mcPCounter[758] += p;
  mcP2Counter[758] += p*p;
#define mccompcurname  channel_16_cave2_cyl1
#define mccompcurtype  Union_cylinder
#define mccompcurindex 758
#define loop_index mccchannel_16_cave2_cyl1_loop_index
#define this_cylinder_volume mccchannel_16_cave2_cyl1_this_cylinder_volume
#define global_geometry_element mccchannel_16_cave2_cyl1_global_geometry_element
#define this_cylinder_storage mccchannel_16_cave2_cyl1_this_cylinder_storage
{   /* Declarations of channel_16_cave2_cyl1=Union_cylinder() SETTING parameters. */
char* material_string = mccchannel_16_cave2_cyl1_material_string;
MCNUM priority = mccchannel_16_cave2_cyl1_priority;
MCNUM radius = mccchannel_16_cave2_cyl1_radius;
MCNUM yheight = mccchannel_16_cave2_cyl1_yheight;
MCNUM visualize = mccchannel_16_cave2_cyl1_visualize;
int target_index = mccchannel_16_cave2_cyl1_target_index;
MCNUM target_x = mccchannel_16_cave2_cyl1_target_x;
MCNUM target_y = mccchannel_16_cave2_cyl1_target_y;
MCNUM target_z = mccchannel_16_cave2_cyl1_target_z;
MCNUM focus_aw = mccchannel_16_cave2_cyl1_focus_aw;
MCNUM focus_ah = mccchannel_16_cave2_cyl1_focus_ah;
MCNUM focus_xw = mccchannel_16_cave2_cyl1_focus_xw;
MCNUM focus_xh = mccchannel_16_cave2_cyl1_focus_xh;
MCNUM focus_r = mccchannel_16_cave2_cyl1_focus_r;
MCNUM p_interact = mccchannel_16_cave2_cyl1_p_interact;
char* mask_string = mccchannel_16_cave2_cyl1_mask_string;
char* mask_setting = mccchannel_16_cave2_cyl1_mask_setting;
MCNUM number_of_activations = mccchannel_16_cave2_cyl1_number_of_activations;
#line 345 "Union_cylinder.comp"
{
dummy = 1;
}
#line 445074 "MACS_sample_kidney_box.c"
}   /* End of channel_16_cave2_cyl1=Union_cylinder() SETTING parameter declarations. */
#undef this_cylinder_storage
#undef global_geometry_element
#undef this_cylinder_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex
  /* Label for restoring  neutron */
  mcabsorbCompchannel_16_cave2_cyl1:
  if (RESTORE) /* restore if needed */
  { RESTORE_NEUTRON(758,
      mcnlx,
      mcnly,
      mcnlz,
      mcnlvx,
      mcnlvy,
      mcnlvz,
      mcnlt,
      mcnlsx,
      mcnlsy,
      mcnlsz,
      mcnlp); }
#undef mcabsorbComp
#undef p
#undef sz
#undef sy
#undef sx
#undef t
#undef vz
#undef vy
#undef vx
#undef z
#undef y
#undef x
  mcDEBUG_STATE(
mcnlx,
mcnly,
mcnlz,
mcnlvx,
mcnlvy,
mcnlvz,
mcnlt,
mcnlsx,
mcnlsy,
mcnlsz,
mcnlp)

  /* TRACE Component channel_16_cave2_box1 [759] */
  mccoordschange(mcposrchannel_16_cave2_box1, mcrotrchannel_16_cave2_box1,
    &mcnlx,
    &mcnly,
    &mcnlz,
    &mcnlvx,
    &mcnlvy,
    &mcnlvz,
    &mcnlsx,
    &mcnlsy,
    &mcnlsz);
  /* define label inside component channel_16_cave2_box1 (without coords transformations) */
  mcJumpTrace_channel_16_cave2_box1:
  SIG_MESSAGE("channel_16_cave2_box1 (Trace)");
  mcDEBUG_COMP("channel_16_cave2_box1")
  mcDEBUG_STATE(
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp)
#define x mcnlx
#define y mcnly
#define z mcnlz
#define vx mcnlvx
#define vy mcnlvy
#define vz mcnlvz
#define t mcnlt
#define sx mcnlsx
#define sy mcnlsy
#define sz mcnlsz
#define p mcnlp

#define mcabsorbComp mcabsorbCompchannel_16_cave2_box1
  STORE_NEUTRON(759,
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp);
  mcScattered=0;
  mcRestore=0;
  mcNCounter[759]++;
  mcPCounter[759] += p;
  mcP2Counter[759] += p*p;
#define mccompcurname  channel_16_cave2_box1
#define mccompcurtype  Union_box
#define mccompcurindex 759
#define loop_index mccchannel_16_cave2_box1_loop_index
#define this_box_volume mccchannel_16_cave2_box1_this_box_volume
#define global_geometry_element mccchannel_16_cave2_box1_global_geometry_element
#define this_box_storage mccchannel_16_cave2_box1_this_box_storage
{   /* Declarations of channel_16_cave2_box1=Union_box() SETTING parameters. */
char* material_string = mccchannel_16_cave2_box1_material_string;
MCNUM priority = mccchannel_16_cave2_box1_priority;
MCNUM xwidth = mccchannel_16_cave2_box1_xwidth;
MCNUM yheight = mccchannel_16_cave2_box1_yheight;
MCNUM zdepth = mccchannel_16_cave2_box1_zdepth;
MCNUM xwidth2 = mccchannel_16_cave2_box1_xwidth2;
MCNUM yheight2 = mccchannel_16_cave2_box1_yheight2;
MCNUM visualize = mccchannel_16_cave2_box1_visualize;
int target_index = mccchannel_16_cave2_box1_target_index;
MCNUM target_x = mccchannel_16_cave2_box1_target_x;
MCNUM target_y = mccchannel_16_cave2_box1_target_y;
MCNUM target_z = mccchannel_16_cave2_box1_target_z;
MCNUM focus_aw = mccchannel_16_cave2_box1_focus_aw;
MCNUM focus_ah = mccchannel_16_cave2_box1_focus_ah;
MCNUM focus_xw = mccchannel_16_cave2_box1_focus_xw;
MCNUM focus_xh = mccchannel_16_cave2_box1_focus_xh;
MCNUM focus_r = mccchannel_16_cave2_box1_focus_r;
MCNUM p_interact = mccchannel_16_cave2_box1_p_interact;
char* mask_string = mccchannel_16_cave2_box1_mask_string;
char* mask_setting = mccchannel_16_cave2_box1_mask_setting;
MCNUM number_of_activations = mccchannel_16_cave2_box1_number_of_activations;
}   /* End of channel_16_cave2_box1=Union_box() SETTING parameter declarations. */
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex
  /* Label for restoring  neutron */
  mcabsorbCompchannel_16_cave2_box1:
  if (RESTORE) /* restore if needed */
  { RESTORE_NEUTRON(759,
      mcnlx,
      mcnly,
      mcnlz,
      mcnlvx,
      mcnlvy,
      mcnlvz,
      mcnlt,
      mcnlsx,
      mcnlsy,
      mcnlsz,
      mcnlp); }
#undef mcabsorbComp
#undef p
#undef sz
#undef sy
#undef sx
#undef t
#undef vz
#undef vy
#undef vx
#undef z
#undef y
#undef x
  mcDEBUG_STATE(
mcnlx,
mcnly,
mcnlz,
mcnlvx,
mcnlvy,
mcnlvz,
mcnlt,
mcnlsx,
mcnlsy,
mcnlsz,
mcnlp)

  /* TRACE Component channel_16_cave2_box2 [760] */
  mccoordschange(mcposrchannel_16_cave2_box2, mcrotrchannel_16_cave2_box2,
    &mcnlx,
    &mcnly,
    &mcnlz,
    &mcnlvx,
    &mcnlvy,
    &mcnlvz,
    &mcnlsx,
    &mcnlsy,
    &mcnlsz);
  /* define label inside component channel_16_cave2_box2 (without coords transformations) */
  mcJumpTrace_channel_16_cave2_box2:
  SIG_MESSAGE("channel_16_cave2_box2 (Trace)");
  mcDEBUG_COMP("channel_16_cave2_box2")
  mcDEBUG_STATE(
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp)
#define x mcnlx
#define y mcnly
#define z mcnlz
#define vx mcnlvx
#define vy mcnlvy
#define vz mcnlvz
#define t mcnlt
#define sx mcnlsx
#define sy mcnlsy
#define sz mcnlsz
#define p mcnlp

#define mcabsorbComp mcabsorbCompchannel_16_cave2_box2
  STORE_NEUTRON(760,
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp);
  mcScattered=0;
  mcRestore=0;
  mcNCounter[760]++;
  mcPCounter[760] += p;
  mcP2Counter[760] += p*p;
#define mccompcurname  channel_16_cave2_box2
#define mccompcurtype  Union_box
#define mccompcurindex 760
#define loop_index mccchannel_16_cave2_box2_loop_index
#define this_box_volume mccchannel_16_cave2_box2_this_box_volume
#define global_geometry_element mccchannel_16_cave2_box2_global_geometry_element
#define this_box_storage mccchannel_16_cave2_box2_this_box_storage
{   /* Declarations of channel_16_cave2_box2=Union_box() SETTING parameters. */
char* material_string = mccchannel_16_cave2_box2_material_string;
MCNUM priority = mccchannel_16_cave2_box2_priority;
MCNUM xwidth = mccchannel_16_cave2_box2_xwidth;
MCNUM yheight = mccchannel_16_cave2_box2_yheight;
MCNUM zdepth = mccchannel_16_cave2_box2_zdepth;
MCNUM xwidth2 = mccchannel_16_cave2_box2_xwidth2;
MCNUM yheight2 = mccchannel_16_cave2_box2_yheight2;
MCNUM visualize = mccchannel_16_cave2_box2_visualize;
int target_index = mccchannel_16_cave2_box2_target_index;
MCNUM target_x = mccchannel_16_cave2_box2_target_x;
MCNUM target_y = mccchannel_16_cave2_box2_target_y;
MCNUM target_z = mccchannel_16_cave2_box2_target_z;
MCNUM focus_aw = mccchannel_16_cave2_box2_focus_aw;
MCNUM focus_ah = mccchannel_16_cave2_box2_focus_ah;
MCNUM focus_xw = mccchannel_16_cave2_box2_focus_xw;
MCNUM focus_xh = mccchannel_16_cave2_box2_focus_xh;
MCNUM focus_r = mccchannel_16_cave2_box2_focus_r;
MCNUM p_interact = mccchannel_16_cave2_box2_p_interact;
char* mask_string = mccchannel_16_cave2_box2_mask_string;
char* mask_setting = mccchannel_16_cave2_box2_mask_setting;
MCNUM number_of_activations = mccchannel_16_cave2_box2_number_of_activations;
}   /* End of channel_16_cave2_box2=Union_box() SETTING parameter declarations. */
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex
  /* Label for restoring  neutron */
  mcabsorbCompchannel_16_cave2_box2:
  if (RESTORE) /* restore if needed */
  { RESTORE_NEUTRON(760,
      mcnlx,
      mcnly,
      mcnlz,
      mcnlvx,
      mcnlvy,
      mcnlvz,
      mcnlt,
      mcnlsx,
      mcnlsy,
      mcnlsz,
      mcnlp); }
#undef mcabsorbComp
#undef p
#undef sz
#undef sy
#undef sx
#undef t
#undef vz
#undef vy
#undef vx
#undef z
#undef y
#undef x
  mcDEBUG_STATE(
mcnlx,
mcnly,
mcnlz,
mcnlvx,
mcnlvy,
mcnlvz,
mcnlt,
mcnlsx,
mcnlsy,
mcnlsz,
mcnlp)

  /* TRACE Component channel_16_cave2_box3 [761] */
  mccoordschange(mcposrchannel_16_cave2_box3, mcrotrchannel_16_cave2_box3,
    &mcnlx,
    &mcnly,
    &mcnlz,
    &mcnlvx,
    &mcnlvy,
    &mcnlvz,
    &mcnlsx,
    &mcnlsy,
    &mcnlsz);
  /* define label inside component channel_16_cave2_box3 (without coords transformations) */
  mcJumpTrace_channel_16_cave2_box3:
  SIG_MESSAGE("channel_16_cave2_box3 (Trace)");
  mcDEBUG_COMP("channel_16_cave2_box3")
  mcDEBUG_STATE(
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp)
#define x mcnlx
#define y mcnly
#define z mcnlz
#define vx mcnlvx
#define vy mcnlvy
#define vz mcnlvz
#define t mcnlt
#define sx mcnlsx
#define sy mcnlsy
#define sz mcnlsz
#define p mcnlp

#define mcabsorbComp mcabsorbCompchannel_16_cave2_box3
  STORE_NEUTRON(761,
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp);
  mcScattered=0;
  mcRestore=0;
  mcNCounter[761]++;
  mcPCounter[761] += p;
  mcP2Counter[761] += p*p;
#define mccompcurname  channel_16_cave2_box3
#define mccompcurtype  Union_box
#define mccompcurindex 761
#define loop_index mccchannel_16_cave2_box3_loop_index
#define this_box_volume mccchannel_16_cave2_box3_this_box_volume
#define global_geometry_element mccchannel_16_cave2_box3_global_geometry_element
#define this_box_storage mccchannel_16_cave2_box3_this_box_storage
{   /* Declarations of channel_16_cave2_box3=Union_box() SETTING parameters. */
char* material_string = mccchannel_16_cave2_box3_material_string;
MCNUM priority = mccchannel_16_cave2_box3_priority;
MCNUM xwidth = mccchannel_16_cave2_box3_xwidth;
MCNUM yheight = mccchannel_16_cave2_box3_yheight;
MCNUM zdepth = mccchannel_16_cave2_box3_zdepth;
MCNUM xwidth2 = mccchannel_16_cave2_box3_xwidth2;
MCNUM yheight2 = mccchannel_16_cave2_box3_yheight2;
MCNUM visualize = mccchannel_16_cave2_box3_visualize;
int target_index = mccchannel_16_cave2_box3_target_index;
MCNUM target_x = mccchannel_16_cave2_box3_target_x;
MCNUM target_y = mccchannel_16_cave2_box3_target_y;
MCNUM target_z = mccchannel_16_cave2_box3_target_z;
MCNUM focus_aw = mccchannel_16_cave2_box3_focus_aw;
MCNUM focus_ah = mccchannel_16_cave2_box3_focus_ah;
MCNUM focus_xw = mccchannel_16_cave2_box3_focus_xw;
MCNUM focus_xh = mccchannel_16_cave2_box3_focus_xh;
MCNUM focus_r = mccchannel_16_cave2_box3_focus_r;
MCNUM p_interact = mccchannel_16_cave2_box3_p_interact;
char* mask_string = mccchannel_16_cave2_box3_mask_string;
char* mask_setting = mccchannel_16_cave2_box3_mask_setting;
MCNUM number_of_activations = mccchannel_16_cave2_box3_number_of_activations;
}   /* End of channel_16_cave2_box3=Union_box() SETTING parameter declarations. */
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex
  /* Label for restoring  neutron */
  mcabsorbCompchannel_16_cave2_box3:
  if (RESTORE) /* restore if needed */
  { RESTORE_NEUTRON(761,
      mcnlx,
      mcnly,
      mcnlz,
      mcnlvx,
      mcnlvy,
      mcnlvz,
      mcnlt,
      mcnlsx,
      mcnlsy,
      mcnlsz,
      mcnlp); }
#undef mcabsorbComp
#undef p
#undef sz
#undef sy
#undef sx
#undef t
#undef vz
#undef vy
#undef vx
#undef z
#undef y
#undef x
  mcDEBUG_STATE(
mcnlx,
mcnly,
mcnlz,
mcnlvx,
mcnlvy,
mcnlvz,
mcnlt,
mcnlsx,
mcnlsy,
mcnlsz,
mcnlp)

  /* TRACE Component inter_analyzer_colimator_center_16 [762] */
  mccoordschange(mcposrinter_analyzer_colimator_center_16, mcrotrinter_analyzer_colimator_center_16,
    &mcnlx,
    &mcnly,
    &mcnlz,
    &mcnlvx,
    &mcnlvy,
    &mcnlvz,
    &mcnlsx,
    &mcnlsy,
    &mcnlsz);
  /* define label inside component inter_analyzer_colimator_center_16 (without coords transformations) */
  mcJumpTrace_inter_analyzer_colimator_center_16:
  SIG_MESSAGE("inter_analyzer_colimator_center_16 (Trace)");
  mcDEBUG_COMP("inter_analyzer_colimator_center_16")
  mcDEBUG_STATE(
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp)
#define x mcnlx
#define y mcnly
#define z mcnlz
#define vx mcnlvx
#define vy mcnlvy
#define vz mcnlvz
#define t mcnlt
#define sx mcnlsx
#define sy mcnlsy
#define sz mcnlsz
#define p mcnlp

#define mcabsorbComp mcabsorbCompinter_analyzer_colimator_center_16
  STORE_NEUTRON(762,
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp);
  mcScattered=0;
  mcRestore=0;
  mcNCounter[762]++;
  mcPCounter[762] += p;
  mcP2Counter[762] += p*p;
#define mccompcurname  inter_analyzer_colimator_center_16
#define mccompcurtype  Arm
#define mccompcurindex 762
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex
  /* Label for restoring  neutron */
  mcabsorbCompinter_analyzer_colimator_center_16:
  if (RESTORE) /* restore if needed */
  { RESTORE_NEUTRON(762,
      mcnlx,
      mcnly,
      mcnlz,
      mcnlvx,
      mcnlvy,
      mcnlvz,
      mcnlt,
      mcnlsx,
      mcnlsy,
      mcnlsz,
      mcnlp); }
#undef mcabsorbComp
#undef p
#undef sz
#undef sy
#undef sx
#undef t
#undef vz
#undef vy
#undef vx
#undef z
#undef y
#undef x
  mcDEBUG_STATE(
mcnlx,
mcnly,
mcnlz,
mcnlvx,
mcnlvy,
mcnlvz,
mcnlt,
mcnlsx,
mcnlsy,
mcnlsz,
mcnlp)

  /* TRACE Component inter_analyzer_colimator_16_blade_0 [763] */
  mccoordschange(mcposrinter_analyzer_colimator_16_blade_0, mcrotrinter_analyzer_colimator_16_blade_0,
    &mcnlx,
    &mcnly,
    &mcnlz,
    &mcnlvx,
    &mcnlvy,
    &mcnlvz,
    &mcnlsx,
    &mcnlsy,
    &mcnlsz);
  /* define label inside component inter_analyzer_colimator_16_blade_0 (without coords transformations) */
  mcJumpTrace_inter_analyzer_colimator_16_blade_0:
  SIG_MESSAGE("inter_analyzer_colimator_16_blade_0 (Trace)");
  mcDEBUG_COMP("inter_analyzer_colimator_16_blade_0")
  mcDEBUG_STATE(
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp)
#define x mcnlx
#define y mcnly
#define z mcnlz
#define vx mcnlvx
#define vy mcnlvy
#define vz mcnlvz
#define t mcnlt
#define sx mcnlsx
#define sy mcnlsy
#define sz mcnlsz
#define p mcnlp

#define mcabsorbComp mcabsorbCompinter_analyzer_colimator_16_blade_0
  STORE_NEUTRON(763,
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp);
  mcScattered=0;
  mcRestore=0;
  mcNCounter[763]++;
  mcPCounter[763] += p;
  mcP2Counter[763] += p*p;
#define mccompcurname  inter_analyzer_colimator_16_blade_0
#define mccompcurtype  Union_box
#define mccompcurindex 763
#define loop_index mccinter_analyzer_colimator_16_blade_0_loop_index
#define this_box_volume mccinter_analyzer_colimator_16_blade_0_this_box_volume
#define global_geometry_element mccinter_analyzer_colimator_16_blade_0_global_geometry_element
#define this_box_storage mccinter_analyzer_colimator_16_blade_0_this_box_storage
{   /* Declarations of inter_analyzer_colimator_16_blade_0=Union_box() SETTING parameters. */
char* material_string = mccinter_analyzer_colimator_16_blade_0_material_string;
MCNUM priority = mccinter_analyzer_colimator_16_blade_0_priority;
MCNUM xwidth = mccinter_analyzer_colimator_16_blade_0_xwidth;
MCNUM yheight = mccinter_analyzer_colimator_16_blade_0_yheight;
MCNUM zdepth = mccinter_analyzer_colimator_16_blade_0_zdepth;
MCNUM xwidth2 = mccinter_analyzer_colimator_16_blade_0_xwidth2;
MCNUM yheight2 = mccinter_analyzer_colimator_16_blade_0_yheight2;
MCNUM visualize = mccinter_analyzer_colimator_16_blade_0_visualize;
int target_index = mccinter_analyzer_colimator_16_blade_0_target_index;
MCNUM target_x = mccinter_analyzer_colimator_16_blade_0_target_x;
MCNUM target_y = mccinter_analyzer_colimator_16_blade_0_target_y;
MCNUM target_z = mccinter_analyzer_colimator_16_blade_0_target_z;
MCNUM focus_aw = mccinter_analyzer_colimator_16_blade_0_focus_aw;
MCNUM focus_ah = mccinter_analyzer_colimator_16_blade_0_focus_ah;
MCNUM focus_xw = mccinter_analyzer_colimator_16_blade_0_focus_xw;
MCNUM focus_xh = mccinter_analyzer_colimator_16_blade_0_focus_xh;
MCNUM focus_r = mccinter_analyzer_colimator_16_blade_0_focus_r;
MCNUM p_interact = mccinter_analyzer_colimator_16_blade_0_p_interact;
char* mask_string = mccinter_analyzer_colimator_16_blade_0_mask_string;
char* mask_setting = mccinter_analyzer_colimator_16_blade_0_mask_setting;
MCNUM number_of_activations = mccinter_analyzer_colimator_16_blade_0_number_of_activations;
}   /* End of inter_analyzer_colimator_16_blade_0=Union_box() SETTING parameter declarations. */
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex
  /* Label for restoring  neutron */
  mcabsorbCompinter_analyzer_colimator_16_blade_0:
  if (RESTORE) /* restore if needed */
  { RESTORE_NEUTRON(763,
      mcnlx,
      mcnly,
      mcnlz,
      mcnlvx,
      mcnlvy,
      mcnlvz,
      mcnlt,
      mcnlsx,
      mcnlsy,
      mcnlsz,
      mcnlp); }
#undef mcabsorbComp
#undef p
#undef sz
#undef sy
#undef sx
#undef t
#undef vz
#undef vy
#undef vx
#undef z
#undef y
#undef x
  mcDEBUG_STATE(
mcnlx,
mcnly,
mcnlz,
mcnlvx,
mcnlvy,
mcnlvz,
mcnlt,
mcnlsx,
mcnlsy,
mcnlsz,
mcnlp)

  /* TRACE Component inter_analyzer_colimator_16_blade_1 [764] */
  mccoordschange(mcposrinter_analyzer_colimator_16_blade_1, mcrotrinter_analyzer_colimator_16_blade_1,
    &mcnlx,
    &mcnly,
    &mcnlz,
    &mcnlvx,
    &mcnlvy,
    &mcnlvz,
    &mcnlsx,
    &mcnlsy,
    &mcnlsz);
  /* define label inside component inter_analyzer_colimator_16_blade_1 (without coords transformations) */
  mcJumpTrace_inter_analyzer_colimator_16_blade_1:
  SIG_MESSAGE("inter_analyzer_colimator_16_blade_1 (Trace)");
  mcDEBUG_COMP("inter_analyzer_colimator_16_blade_1")
  mcDEBUG_STATE(
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp)
#define x mcnlx
#define y mcnly
#define z mcnlz
#define vx mcnlvx
#define vy mcnlvy
#define vz mcnlvz
#define t mcnlt
#define sx mcnlsx
#define sy mcnlsy
#define sz mcnlsz
#define p mcnlp

#define mcabsorbComp mcabsorbCompinter_analyzer_colimator_16_blade_1
  STORE_NEUTRON(764,
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp);
  mcScattered=0;
  mcRestore=0;
  mcNCounter[764]++;
  mcPCounter[764] += p;
  mcP2Counter[764] += p*p;
#define mccompcurname  inter_analyzer_colimator_16_blade_1
#define mccompcurtype  Union_box
#define mccompcurindex 764
#define loop_index mccinter_analyzer_colimator_16_blade_1_loop_index
#define this_box_volume mccinter_analyzer_colimator_16_blade_1_this_box_volume
#define global_geometry_element mccinter_analyzer_colimator_16_blade_1_global_geometry_element
#define this_box_storage mccinter_analyzer_colimator_16_blade_1_this_box_storage
{   /* Declarations of inter_analyzer_colimator_16_blade_1=Union_box() SETTING parameters. */
char* material_string = mccinter_analyzer_colimator_16_blade_1_material_string;
MCNUM priority = mccinter_analyzer_colimator_16_blade_1_priority;
MCNUM xwidth = mccinter_analyzer_colimator_16_blade_1_xwidth;
MCNUM yheight = mccinter_analyzer_colimator_16_blade_1_yheight;
MCNUM zdepth = mccinter_analyzer_colimator_16_blade_1_zdepth;
MCNUM xwidth2 = mccinter_analyzer_colimator_16_blade_1_xwidth2;
MCNUM yheight2 = mccinter_analyzer_colimator_16_blade_1_yheight2;
MCNUM visualize = mccinter_analyzer_colimator_16_blade_1_visualize;
int target_index = mccinter_analyzer_colimator_16_blade_1_target_index;
MCNUM target_x = mccinter_analyzer_colimator_16_blade_1_target_x;
MCNUM target_y = mccinter_analyzer_colimator_16_blade_1_target_y;
MCNUM target_z = mccinter_analyzer_colimator_16_blade_1_target_z;
MCNUM focus_aw = mccinter_analyzer_colimator_16_blade_1_focus_aw;
MCNUM focus_ah = mccinter_analyzer_colimator_16_blade_1_focus_ah;
MCNUM focus_xw = mccinter_analyzer_colimator_16_blade_1_focus_xw;
MCNUM focus_xh = mccinter_analyzer_colimator_16_blade_1_focus_xh;
MCNUM focus_r = mccinter_analyzer_colimator_16_blade_1_focus_r;
MCNUM p_interact = mccinter_analyzer_colimator_16_blade_1_p_interact;
char* mask_string = mccinter_analyzer_colimator_16_blade_1_mask_string;
char* mask_setting = mccinter_analyzer_colimator_16_blade_1_mask_setting;
MCNUM number_of_activations = mccinter_analyzer_colimator_16_blade_1_number_of_activations;
}   /* End of inter_analyzer_colimator_16_blade_1=Union_box() SETTING parameter declarations. */
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex
  /* Label for restoring  neutron */
  mcabsorbCompinter_analyzer_colimator_16_blade_1:
  if (RESTORE) /* restore if needed */
  { RESTORE_NEUTRON(764,
      mcnlx,
      mcnly,
      mcnlz,
      mcnlvx,
      mcnlvy,
      mcnlvz,
      mcnlt,
      mcnlsx,
      mcnlsy,
      mcnlsz,
      mcnlp); }
#undef mcabsorbComp
#undef p
#undef sz
#undef sy
#undef sx
#undef t
#undef vz
#undef vy
#undef vx
#undef z
#undef y
#undef x
  mcDEBUG_STATE(
mcnlx,
mcnly,
mcnlz,
mcnlvx,
mcnlvy,
mcnlvz,
mcnlt,
mcnlsx,
mcnlsy,
mcnlsz,
mcnlp)

  /* TRACE Component inter_analyzer_colimator_16_blade_2 [765] */
  mccoordschange(mcposrinter_analyzer_colimator_16_blade_2, mcrotrinter_analyzer_colimator_16_blade_2,
    &mcnlx,
    &mcnly,
    &mcnlz,
    &mcnlvx,
    &mcnlvy,
    &mcnlvz,
    &mcnlsx,
    &mcnlsy,
    &mcnlsz);
  /* define label inside component inter_analyzer_colimator_16_blade_2 (without coords transformations) */
  mcJumpTrace_inter_analyzer_colimator_16_blade_2:
  SIG_MESSAGE("inter_analyzer_colimator_16_blade_2 (Trace)");
  mcDEBUG_COMP("inter_analyzer_colimator_16_blade_2")
  mcDEBUG_STATE(
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp)
#define x mcnlx
#define y mcnly
#define z mcnlz
#define vx mcnlvx
#define vy mcnlvy
#define vz mcnlvz
#define t mcnlt
#define sx mcnlsx
#define sy mcnlsy
#define sz mcnlsz
#define p mcnlp

#define mcabsorbComp mcabsorbCompinter_analyzer_colimator_16_blade_2
  STORE_NEUTRON(765,
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp);
  mcScattered=0;
  mcRestore=0;
  mcNCounter[765]++;
  mcPCounter[765] += p;
  mcP2Counter[765] += p*p;
#define mccompcurname  inter_analyzer_colimator_16_blade_2
#define mccompcurtype  Union_box
#define mccompcurindex 765
#define loop_index mccinter_analyzer_colimator_16_blade_2_loop_index
#define this_box_volume mccinter_analyzer_colimator_16_blade_2_this_box_volume
#define global_geometry_element mccinter_analyzer_colimator_16_blade_2_global_geometry_element
#define this_box_storage mccinter_analyzer_colimator_16_blade_2_this_box_storage
{   /* Declarations of inter_analyzer_colimator_16_blade_2=Union_box() SETTING parameters. */
char* material_string = mccinter_analyzer_colimator_16_blade_2_material_string;
MCNUM priority = mccinter_analyzer_colimator_16_blade_2_priority;
MCNUM xwidth = mccinter_analyzer_colimator_16_blade_2_xwidth;
MCNUM yheight = mccinter_analyzer_colimator_16_blade_2_yheight;
MCNUM zdepth = mccinter_analyzer_colimator_16_blade_2_zdepth;
MCNUM xwidth2 = mccinter_analyzer_colimator_16_blade_2_xwidth2;
MCNUM yheight2 = mccinter_analyzer_colimator_16_blade_2_yheight2;
MCNUM visualize = mccinter_analyzer_colimator_16_blade_2_visualize;
int target_index = mccinter_analyzer_colimator_16_blade_2_target_index;
MCNUM target_x = mccinter_analyzer_colimator_16_blade_2_target_x;
MCNUM target_y = mccinter_analyzer_colimator_16_blade_2_target_y;
MCNUM target_z = mccinter_analyzer_colimator_16_blade_2_target_z;
MCNUM focus_aw = mccinter_analyzer_colimator_16_blade_2_focus_aw;
MCNUM focus_ah = mccinter_analyzer_colimator_16_blade_2_focus_ah;
MCNUM focus_xw = mccinter_analyzer_colimator_16_blade_2_focus_xw;
MCNUM focus_xh = mccinter_analyzer_colimator_16_blade_2_focus_xh;
MCNUM focus_r = mccinter_analyzer_colimator_16_blade_2_focus_r;
MCNUM p_interact = mccinter_analyzer_colimator_16_blade_2_p_interact;
char* mask_string = mccinter_analyzer_colimator_16_blade_2_mask_string;
char* mask_setting = mccinter_analyzer_colimator_16_blade_2_mask_setting;
MCNUM number_of_activations = mccinter_analyzer_colimator_16_blade_2_number_of_activations;
}   /* End of inter_analyzer_colimator_16_blade_2=Union_box() SETTING parameter declarations. */
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex
  /* Label for restoring  neutron */
  mcabsorbCompinter_analyzer_colimator_16_blade_2:
  if (RESTORE) /* restore if needed */
  { RESTORE_NEUTRON(765,
      mcnlx,
      mcnly,
      mcnlz,
      mcnlvx,
      mcnlvy,
      mcnlvz,
      mcnlt,
      mcnlsx,
      mcnlsy,
      mcnlsz,
      mcnlp); }
#undef mcabsorbComp
#undef p
#undef sz
#undef sy
#undef sx
#undef t
#undef vz
#undef vy
#undef vx
#undef z
#undef y
#undef x
  mcDEBUG_STATE(
mcnlx,
mcnly,
mcnlz,
mcnlvx,
mcnlvy,
mcnlvz,
mcnlt,
mcnlsx,
mcnlsy,
mcnlsz,
mcnlp)

  /* TRACE Component inter_analyzer_colimator_16_blade_3 [766] */
  mccoordschange(mcposrinter_analyzer_colimator_16_blade_3, mcrotrinter_analyzer_colimator_16_blade_3,
    &mcnlx,
    &mcnly,
    &mcnlz,
    &mcnlvx,
    &mcnlvy,
    &mcnlvz,
    &mcnlsx,
    &mcnlsy,
    &mcnlsz);
  /* define label inside component inter_analyzer_colimator_16_blade_3 (without coords transformations) */
  mcJumpTrace_inter_analyzer_colimator_16_blade_3:
  SIG_MESSAGE("inter_analyzer_colimator_16_blade_3 (Trace)");
  mcDEBUG_COMP("inter_analyzer_colimator_16_blade_3")
  mcDEBUG_STATE(
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp)
#define x mcnlx
#define y mcnly
#define z mcnlz
#define vx mcnlvx
#define vy mcnlvy
#define vz mcnlvz
#define t mcnlt
#define sx mcnlsx
#define sy mcnlsy
#define sz mcnlsz
#define p mcnlp

#define mcabsorbComp mcabsorbCompinter_analyzer_colimator_16_blade_3
  STORE_NEUTRON(766,
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp);
  mcScattered=0;
  mcRestore=0;
  mcNCounter[766]++;
  mcPCounter[766] += p;
  mcP2Counter[766] += p*p;
#define mccompcurname  inter_analyzer_colimator_16_blade_3
#define mccompcurtype  Union_box
#define mccompcurindex 766
#define loop_index mccinter_analyzer_colimator_16_blade_3_loop_index
#define this_box_volume mccinter_analyzer_colimator_16_blade_3_this_box_volume
#define global_geometry_element mccinter_analyzer_colimator_16_blade_3_global_geometry_element
#define this_box_storage mccinter_analyzer_colimator_16_blade_3_this_box_storage
{   /* Declarations of inter_analyzer_colimator_16_blade_3=Union_box() SETTING parameters. */
char* material_string = mccinter_analyzer_colimator_16_blade_3_material_string;
MCNUM priority = mccinter_analyzer_colimator_16_blade_3_priority;
MCNUM xwidth = mccinter_analyzer_colimator_16_blade_3_xwidth;
MCNUM yheight = mccinter_analyzer_colimator_16_blade_3_yheight;
MCNUM zdepth = mccinter_analyzer_colimator_16_blade_3_zdepth;
MCNUM xwidth2 = mccinter_analyzer_colimator_16_blade_3_xwidth2;
MCNUM yheight2 = mccinter_analyzer_colimator_16_blade_3_yheight2;
MCNUM visualize = mccinter_analyzer_colimator_16_blade_3_visualize;
int target_index = mccinter_analyzer_colimator_16_blade_3_target_index;
MCNUM target_x = mccinter_analyzer_colimator_16_blade_3_target_x;
MCNUM target_y = mccinter_analyzer_colimator_16_blade_3_target_y;
MCNUM target_z = mccinter_analyzer_colimator_16_blade_3_target_z;
MCNUM focus_aw = mccinter_analyzer_colimator_16_blade_3_focus_aw;
MCNUM focus_ah = mccinter_analyzer_colimator_16_blade_3_focus_ah;
MCNUM focus_xw = mccinter_analyzer_colimator_16_blade_3_focus_xw;
MCNUM focus_xh = mccinter_analyzer_colimator_16_blade_3_focus_xh;
MCNUM focus_r = mccinter_analyzer_colimator_16_blade_3_focus_r;
MCNUM p_interact = mccinter_analyzer_colimator_16_blade_3_p_interact;
char* mask_string = mccinter_analyzer_colimator_16_blade_3_mask_string;
char* mask_setting = mccinter_analyzer_colimator_16_blade_3_mask_setting;
MCNUM number_of_activations = mccinter_analyzer_colimator_16_blade_3_number_of_activations;
}   /* End of inter_analyzer_colimator_16_blade_3=Union_box() SETTING parameter declarations. */
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex
  /* Label for restoring  neutron */
  mcabsorbCompinter_analyzer_colimator_16_blade_3:
  if (RESTORE) /* restore if needed */
  { RESTORE_NEUTRON(766,
      mcnlx,
      mcnly,
      mcnlz,
      mcnlvx,
      mcnlvy,
      mcnlvz,
      mcnlt,
      mcnlsx,
      mcnlsy,
      mcnlsz,
      mcnlp); }
#undef mcabsorbComp
#undef p
#undef sz
#undef sy
#undef sx
#undef t
#undef vz
#undef vy
#undef vx
#undef z
#undef y
#undef x
  mcDEBUG_STATE(
mcnlx,
mcnly,
mcnlz,
mcnlvx,
mcnlvy,
mcnlvz,
mcnlt,
mcnlsx,
mcnlsy,
mcnlsz,
mcnlp)

  /* TRACE Component inter_analyzer_colimator_16_blade_4 [767] */
  mccoordschange(mcposrinter_analyzer_colimator_16_blade_4, mcrotrinter_analyzer_colimator_16_blade_4,
    &mcnlx,
    &mcnly,
    &mcnlz,
    &mcnlvx,
    &mcnlvy,
    &mcnlvz,
    &mcnlsx,
    &mcnlsy,
    &mcnlsz);
  /* define label inside component inter_analyzer_colimator_16_blade_4 (without coords transformations) */
  mcJumpTrace_inter_analyzer_colimator_16_blade_4:
  SIG_MESSAGE("inter_analyzer_colimator_16_blade_4 (Trace)");
  mcDEBUG_COMP("inter_analyzer_colimator_16_blade_4")
  mcDEBUG_STATE(
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp)
#define x mcnlx
#define y mcnly
#define z mcnlz
#define vx mcnlvx
#define vy mcnlvy
#define vz mcnlvz
#define t mcnlt
#define sx mcnlsx
#define sy mcnlsy
#define sz mcnlsz
#define p mcnlp

#define mcabsorbComp mcabsorbCompinter_analyzer_colimator_16_blade_4
  STORE_NEUTRON(767,
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp);
  mcScattered=0;
  mcRestore=0;
  mcNCounter[767]++;
  mcPCounter[767] += p;
  mcP2Counter[767] += p*p;
#define mccompcurname  inter_analyzer_colimator_16_blade_4
#define mccompcurtype  Union_box
#define mccompcurindex 767
#define loop_index mccinter_analyzer_colimator_16_blade_4_loop_index
#define this_box_volume mccinter_analyzer_colimator_16_blade_4_this_box_volume
#define global_geometry_element mccinter_analyzer_colimator_16_blade_4_global_geometry_element
#define this_box_storage mccinter_analyzer_colimator_16_blade_4_this_box_storage
{   /* Declarations of inter_analyzer_colimator_16_blade_4=Union_box() SETTING parameters. */
char* material_string = mccinter_analyzer_colimator_16_blade_4_material_string;
MCNUM priority = mccinter_analyzer_colimator_16_blade_4_priority;
MCNUM xwidth = mccinter_analyzer_colimator_16_blade_4_xwidth;
MCNUM yheight = mccinter_analyzer_colimator_16_blade_4_yheight;
MCNUM zdepth = mccinter_analyzer_colimator_16_blade_4_zdepth;
MCNUM xwidth2 = mccinter_analyzer_colimator_16_blade_4_xwidth2;
MCNUM yheight2 = mccinter_analyzer_colimator_16_blade_4_yheight2;
MCNUM visualize = mccinter_analyzer_colimator_16_blade_4_visualize;
int target_index = mccinter_analyzer_colimator_16_blade_4_target_index;
MCNUM target_x = mccinter_analyzer_colimator_16_blade_4_target_x;
MCNUM target_y = mccinter_analyzer_colimator_16_blade_4_target_y;
MCNUM target_z = mccinter_analyzer_colimator_16_blade_4_target_z;
MCNUM focus_aw = mccinter_analyzer_colimator_16_blade_4_focus_aw;
MCNUM focus_ah = mccinter_analyzer_colimator_16_blade_4_focus_ah;
MCNUM focus_xw = mccinter_analyzer_colimator_16_blade_4_focus_xw;
MCNUM focus_xh = mccinter_analyzer_colimator_16_blade_4_focus_xh;
MCNUM focus_r = mccinter_analyzer_colimator_16_blade_4_focus_r;
MCNUM p_interact = mccinter_analyzer_colimator_16_blade_4_p_interact;
char* mask_string = mccinter_analyzer_colimator_16_blade_4_mask_string;
char* mask_setting = mccinter_analyzer_colimator_16_blade_4_mask_setting;
MCNUM number_of_activations = mccinter_analyzer_colimator_16_blade_4_number_of_activations;
}   /* End of inter_analyzer_colimator_16_blade_4=Union_box() SETTING parameter declarations. */
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex
  /* Label for restoring  neutron */
  mcabsorbCompinter_analyzer_colimator_16_blade_4:
  if (RESTORE) /* restore if needed */
  { RESTORE_NEUTRON(767,
      mcnlx,
      mcnly,
      mcnlz,
      mcnlvx,
      mcnlvy,
      mcnlvz,
      mcnlt,
      mcnlsx,
      mcnlsy,
      mcnlsz,
      mcnlp); }
#undef mcabsorbComp
#undef p
#undef sz
#undef sy
#undef sx
#undef t
#undef vz
#undef vy
#undef vx
#undef z
#undef y
#undef x
  mcDEBUG_STATE(
mcnlx,
mcnly,
mcnlz,
mcnlvx,
mcnlvy,
mcnlvz,
mcnlt,
mcnlsx,
mcnlsy,
mcnlsz,
mcnlp)

  /* TRACE Component diffraction_detector_16_exit_volume [768] */
  mccoordschange(mcposrdiffraction_detector_16_exit_volume, mcrotrdiffraction_detector_16_exit_volume,
    &mcnlx,
    &mcnly,
    &mcnlz,
    &mcnlvx,
    &mcnlvy,
    &mcnlvz,
    &mcnlsx,
    &mcnlsy,
    &mcnlsz);
  /* define label inside component diffraction_detector_16_exit_volume (without coords transformations) */
  mcJumpTrace_diffraction_detector_16_exit_volume:
  SIG_MESSAGE("diffraction_detector_16_exit_volume (Trace)");
  mcDEBUG_COMP("diffraction_detector_16_exit_volume")
  mcDEBUG_STATE(
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp)
#define x mcnlx
#define y mcnly
#define z mcnlz
#define vx mcnlvx
#define vy mcnlvy
#define vz mcnlvz
#define t mcnlt
#define sx mcnlsx
#define sy mcnlsy
#define sz mcnlsz
#define p mcnlp

#define mcabsorbComp mcabsorbCompdiffraction_detector_16_exit_volume
  STORE_NEUTRON(768,
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp);
  mcScattered=0;
  mcRestore=0;
  mcNCounter[768]++;
  mcPCounter[768] += p;
  mcP2Counter[768] += p*p;
#define mccompcurname  diffraction_detector_16_exit_volume
#define mccompcurtype  Union_box
#define mccompcurindex 768
#define loop_index mccdiffraction_detector_16_exit_volume_loop_index
#define this_box_volume mccdiffraction_detector_16_exit_volume_this_box_volume
#define global_geometry_element mccdiffraction_detector_16_exit_volume_global_geometry_element
#define this_box_storage mccdiffraction_detector_16_exit_volume_this_box_storage
{   /* Declarations of diffraction_detector_16_exit_volume=Union_box() SETTING parameters. */
char* material_string = mccdiffraction_detector_16_exit_volume_material_string;
MCNUM priority = mccdiffraction_detector_16_exit_volume_priority;
MCNUM xwidth = mccdiffraction_detector_16_exit_volume_xwidth;
MCNUM yheight = mccdiffraction_detector_16_exit_volume_yheight;
MCNUM zdepth = mccdiffraction_detector_16_exit_volume_zdepth;
MCNUM xwidth2 = mccdiffraction_detector_16_exit_volume_xwidth2;
MCNUM yheight2 = mccdiffraction_detector_16_exit_volume_yheight2;
MCNUM visualize = mccdiffraction_detector_16_exit_volume_visualize;
int target_index = mccdiffraction_detector_16_exit_volume_target_index;
MCNUM target_x = mccdiffraction_detector_16_exit_volume_target_x;
MCNUM target_y = mccdiffraction_detector_16_exit_volume_target_y;
MCNUM target_z = mccdiffraction_detector_16_exit_volume_target_z;
MCNUM focus_aw = mccdiffraction_detector_16_exit_volume_focus_aw;
MCNUM focus_ah = mccdiffraction_detector_16_exit_volume_focus_ah;
MCNUM focus_xw = mccdiffraction_detector_16_exit_volume_focus_xw;
MCNUM focus_xh = mccdiffraction_detector_16_exit_volume_focus_xh;
MCNUM focus_r = mccdiffraction_detector_16_exit_volume_focus_r;
MCNUM p_interact = mccdiffraction_detector_16_exit_volume_p_interact;
char* mask_string = mccdiffraction_detector_16_exit_volume_mask_string;
char* mask_setting = mccdiffraction_detector_16_exit_volume_mask_setting;
MCNUM number_of_activations = mccdiffraction_detector_16_exit_volume_number_of_activations;
}   /* End of diffraction_detector_16_exit_volume=Union_box() SETTING parameter declarations. */
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex
  /* Label for restoring  neutron */
  mcabsorbCompdiffraction_detector_16_exit_volume:
  if (RESTORE) /* restore if needed */
  { RESTORE_NEUTRON(768,
      mcnlx,
      mcnly,
      mcnlz,
      mcnlvx,
      mcnlvy,
      mcnlvz,
      mcnlt,
      mcnlsx,
      mcnlsy,
      mcnlsz,
      mcnlp); }
#undef mcabsorbComp
#undef p
#undef sz
#undef sy
#undef sx
#undef t
#undef vz
#undef vy
#undef vx
#undef z
#undef y
#undef x
  mcDEBUG_STATE(
mcnlx,
mcnly,
mcnlz,
mcnlvx,
mcnlvy,
mcnlvz,
mcnlt,
mcnlsx,
mcnlsy,
mcnlsz,
mcnlp)

  /* TRACE Component spec_detector_16_exit_volume [769] */
  mccoordschange(mcposrspec_detector_16_exit_volume, mcrotrspec_detector_16_exit_volume,
    &mcnlx,
    &mcnly,
    &mcnlz,
    &mcnlvx,
    &mcnlvy,
    &mcnlvz,
    &mcnlsx,
    &mcnlsy,
    &mcnlsz);
  /* define label inside component spec_detector_16_exit_volume (without coords transformations) */
  mcJumpTrace_spec_detector_16_exit_volume:
  SIG_MESSAGE("spec_detector_16_exit_volume (Trace)");
  mcDEBUG_COMP("spec_detector_16_exit_volume")
  mcDEBUG_STATE(
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp)
#define x mcnlx
#define y mcnly
#define z mcnlz
#define vx mcnlvx
#define vy mcnlvy
#define vz mcnlvz
#define t mcnlt
#define sx mcnlsx
#define sy mcnlsy
#define sz mcnlsz
#define p mcnlp

#define mcabsorbComp mcabsorbCompspec_detector_16_exit_volume
  STORE_NEUTRON(769,
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp);
  mcScattered=0;
  mcRestore=0;
  mcNCounter[769]++;
  mcPCounter[769] += p;
  mcP2Counter[769] += p*p;
#define mccompcurname  spec_detector_16_exit_volume
#define mccompcurtype  Union_box
#define mccompcurindex 769
#define loop_index mccspec_detector_16_exit_volume_loop_index
#define this_box_volume mccspec_detector_16_exit_volume_this_box_volume
#define global_geometry_element mccspec_detector_16_exit_volume_global_geometry_element
#define this_box_storage mccspec_detector_16_exit_volume_this_box_storage
{   /* Declarations of spec_detector_16_exit_volume=Union_box() SETTING parameters. */
char* material_string = mccspec_detector_16_exit_volume_material_string;
MCNUM priority = mccspec_detector_16_exit_volume_priority;
MCNUM xwidth = mccspec_detector_16_exit_volume_xwidth;
MCNUM yheight = mccspec_detector_16_exit_volume_yheight;
MCNUM zdepth = mccspec_detector_16_exit_volume_zdepth;
MCNUM xwidth2 = mccspec_detector_16_exit_volume_xwidth2;
MCNUM yheight2 = mccspec_detector_16_exit_volume_yheight2;
MCNUM visualize = mccspec_detector_16_exit_volume_visualize;
int target_index = mccspec_detector_16_exit_volume_target_index;
MCNUM target_x = mccspec_detector_16_exit_volume_target_x;
MCNUM target_y = mccspec_detector_16_exit_volume_target_y;
MCNUM target_z = mccspec_detector_16_exit_volume_target_z;
MCNUM focus_aw = mccspec_detector_16_exit_volume_focus_aw;
MCNUM focus_ah = mccspec_detector_16_exit_volume_focus_ah;
MCNUM focus_xw = mccspec_detector_16_exit_volume_focus_xw;
MCNUM focus_xh = mccspec_detector_16_exit_volume_focus_xh;
MCNUM focus_r = mccspec_detector_16_exit_volume_focus_r;
MCNUM p_interact = mccspec_detector_16_exit_volume_p_interact;
char* mask_string = mccspec_detector_16_exit_volume_mask_string;
char* mask_setting = mccspec_detector_16_exit_volume_mask_setting;
MCNUM number_of_activations = mccspec_detector_16_exit_volume_number_of_activations;
}   /* End of spec_detector_16_exit_volume=Union_box() SETTING parameter declarations. */
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex
  /* Label for restoring  neutron */
  mcabsorbCompspec_detector_16_exit_volume:
  if (RESTORE) /* restore if needed */
  { RESTORE_NEUTRON(769,
      mcnlx,
      mcnly,
      mcnlz,
      mcnlvx,
      mcnlvy,
      mcnlvz,
      mcnlt,
      mcnlsx,
      mcnlsy,
      mcnlsz,
      mcnlp); }
#undef mcabsorbComp
#undef p
#undef sz
#undef sy
#undef sx
#undef t
#undef vz
#undef vy
#undef vx
#undef z
#undef y
#undef x
  mcDEBUG_STATE(
mcnlx,
mcnly,
mcnlz,
mcnlvx,
mcnlvy,
mcnlvz,
mcnlt,
mcnlsx,
mcnlsy,
mcnlsz,
mcnlp)

  /* TRACE Component channel_17_cave1_box1 [770] */
  mccoordschange(mcposrchannel_17_cave1_box1, mcrotrchannel_17_cave1_box1,
    &mcnlx,
    &mcnly,
    &mcnlz,
    &mcnlvx,
    &mcnlvy,
    &mcnlvz,
    &mcnlsx,
    &mcnlsy,
    &mcnlsz);
  /* define label inside component channel_17_cave1_box1 (without coords transformations) */
  mcJumpTrace_channel_17_cave1_box1:
  SIG_MESSAGE("channel_17_cave1_box1 (Trace)");
  mcDEBUG_COMP("channel_17_cave1_box1")
  mcDEBUG_STATE(
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp)
#define x mcnlx
#define y mcnly
#define z mcnlz
#define vx mcnlvx
#define vy mcnlvy
#define vz mcnlvz
#define t mcnlt
#define sx mcnlsx
#define sy mcnlsy
#define sz mcnlsz
#define p mcnlp

#define mcabsorbComp mcabsorbCompchannel_17_cave1_box1
  STORE_NEUTRON(770,
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp);
  mcScattered=0;
  mcRestore=0;
  mcNCounter[770]++;
  mcPCounter[770] += p;
  mcP2Counter[770] += p*p;
#define mccompcurname  channel_17_cave1_box1
#define mccompcurtype  Union_box
#define mccompcurindex 770
#define loop_index mccchannel_17_cave1_box1_loop_index
#define this_box_volume mccchannel_17_cave1_box1_this_box_volume
#define global_geometry_element mccchannel_17_cave1_box1_global_geometry_element
#define this_box_storage mccchannel_17_cave1_box1_this_box_storage
{   /* Declarations of channel_17_cave1_box1=Union_box() SETTING parameters. */
char* material_string = mccchannel_17_cave1_box1_material_string;
MCNUM priority = mccchannel_17_cave1_box1_priority;
MCNUM xwidth = mccchannel_17_cave1_box1_xwidth;
MCNUM yheight = mccchannel_17_cave1_box1_yheight;
MCNUM zdepth = mccchannel_17_cave1_box1_zdepth;
MCNUM xwidth2 = mccchannel_17_cave1_box1_xwidth2;
MCNUM yheight2 = mccchannel_17_cave1_box1_yheight2;
MCNUM visualize = mccchannel_17_cave1_box1_visualize;
int target_index = mccchannel_17_cave1_box1_target_index;
MCNUM target_x = mccchannel_17_cave1_box1_target_x;
MCNUM target_y = mccchannel_17_cave1_box1_target_y;
MCNUM target_z = mccchannel_17_cave1_box1_target_z;
MCNUM focus_aw = mccchannel_17_cave1_box1_focus_aw;
MCNUM focus_ah = mccchannel_17_cave1_box1_focus_ah;
MCNUM focus_xw = mccchannel_17_cave1_box1_focus_xw;
MCNUM focus_xh = mccchannel_17_cave1_box1_focus_xh;
MCNUM focus_r = mccchannel_17_cave1_box1_focus_r;
MCNUM p_interact = mccchannel_17_cave1_box1_p_interact;
char* mask_string = mccchannel_17_cave1_box1_mask_string;
char* mask_setting = mccchannel_17_cave1_box1_mask_setting;
MCNUM number_of_activations = mccchannel_17_cave1_box1_number_of_activations;
}   /* End of channel_17_cave1_box1=Union_box() SETTING parameter declarations. */
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex
  /* Label for restoring  neutron */
  mcabsorbCompchannel_17_cave1_box1:
  if (RESTORE) /* restore if needed */
  { RESTORE_NEUTRON(770,
      mcnlx,
      mcnly,
      mcnlz,
      mcnlvx,
      mcnlvy,
      mcnlvz,
      mcnlt,
      mcnlsx,
      mcnlsy,
      mcnlsz,
      mcnlp); }
#undef mcabsorbComp
#undef p
#undef sz
#undef sy
#undef sx
#undef t
#undef vz
#undef vy
#undef vx
#undef z
#undef y
#undef x
  mcDEBUG_STATE(
mcnlx,
mcnly,
mcnlz,
mcnlvx,
mcnlvy,
mcnlvz,
mcnlt,
mcnlsx,
mcnlsy,
mcnlsz,
mcnlp)

  /* TRACE Component channel_17_cave1_box2 [771] */
  mccoordschange(mcposrchannel_17_cave1_box2, mcrotrchannel_17_cave1_box2,
    &mcnlx,
    &mcnly,
    &mcnlz,
    &mcnlvx,
    &mcnlvy,
    &mcnlvz,
    &mcnlsx,
    &mcnlsy,
    &mcnlsz);
  /* define label inside component channel_17_cave1_box2 (without coords transformations) */
  mcJumpTrace_channel_17_cave1_box2:
  SIG_MESSAGE("channel_17_cave1_box2 (Trace)");
  mcDEBUG_COMP("channel_17_cave1_box2")
  mcDEBUG_STATE(
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp)
#define x mcnlx
#define y mcnly
#define z mcnlz
#define vx mcnlvx
#define vy mcnlvy
#define vz mcnlvz
#define t mcnlt
#define sx mcnlsx
#define sy mcnlsy
#define sz mcnlsz
#define p mcnlp

#define mcabsorbComp mcabsorbCompchannel_17_cave1_box2
  STORE_NEUTRON(771,
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp);
  mcScattered=0;
  mcRestore=0;
  mcNCounter[771]++;
  mcPCounter[771] += p;
  mcP2Counter[771] += p*p;
#define mccompcurname  channel_17_cave1_box2
#define mccompcurtype  Union_box
#define mccompcurindex 771
#define loop_index mccchannel_17_cave1_box2_loop_index
#define this_box_volume mccchannel_17_cave1_box2_this_box_volume
#define global_geometry_element mccchannel_17_cave1_box2_global_geometry_element
#define this_box_storage mccchannel_17_cave1_box2_this_box_storage
{   /* Declarations of channel_17_cave1_box2=Union_box() SETTING parameters. */
char* material_string = mccchannel_17_cave1_box2_material_string;
MCNUM priority = mccchannel_17_cave1_box2_priority;
MCNUM xwidth = mccchannel_17_cave1_box2_xwidth;
MCNUM yheight = mccchannel_17_cave1_box2_yheight;
MCNUM zdepth = mccchannel_17_cave1_box2_zdepth;
MCNUM xwidth2 = mccchannel_17_cave1_box2_xwidth2;
MCNUM yheight2 = mccchannel_17_cave1_box2_yheight2;
MCNUM visualize = mccchannel_17_cave1_box2_visualize;
int target_index = mccchannel_17_cave1_box2_target_index;
MCNUM target_x = mccchannel_17_cave1_box2_target_x;
MCNUM target_y = mccchannel_17_cave1_box2_target_y;
MCNUM target_z = mccchannel_17_cave1_box2_target_z;
MCNUM focus_aw = mccchannel_17_cave1_box2_focus_aw;
MCNUM focus_ah = mccchannel_17_cave1_box2_focus_ah;
MCNUM focus_xw = mccchannel_17_cave1_box2_focus_xw;
MCNUM focus_xh = mccchannel_17_cave1_box2_focus_xh;
MCNUM focus_r = mccchannel_17_cave1_box2_focus_r;
MCNUM p_interact = mccchannel_17_cave1_box2_p_interact;
char* mask_string = mccchannel_17_cave1_box2_mask_string;
char* mask_setting = mccchannel_17_cave1_box2_mask_setting;
MCNUM number_of_activations = mccchannel_17_cave1_box2_number_of_activations;
}   /* End of channel_17_cave1_box2=Union_box() SETTING parameter declarations. */
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex
  /* Label for restoring  neutron */
  mcabsorbCompchannel_17_cave1_box2:
  if (RESTORE) /* restore if needed */
  { RESTORE_NEUTRON(771,
      mcnlx,
      mcnly,
      mcnlz,
      mcnlvx,
      mcnlvy,
      mcnlvz,
      mcnlt,
      mcnlsx,
      mcnlsy,
      mcnlsz,
      mcnlp); }
#undef mcabsorbComp
#undef p
#undef sz
#undef sy
#undef sx
#undef t
#undef vz
#undef vy
#undef vx
#undef z
#undef y
#undef x
  mcDEBUG_STATE(
mcnlx,
mcnly,
mcnlz,
mcnlvx,
mcnlvy,
mcnlvz,
mcnlt,
mcnlsx,
mcnlsy,
mcnlsz,
mcnlp)

  /* TRACE Component channel_17_cave1_box3 [772] */
  mccoordschange(mcposrchannel_17_cave1_box3, mcrotrchannel_17_cave1_box3,
    &mcnlx,
    &mcnly,
    &mcnlz,
    &mcnlvx,
    &mcnlvy,
    &mcnlvz,
    &mcnlsx,
    &mcnlsy,
    &mcnlsz);
  /* define label inside component channel_17_cave1_box3 (without coords transformations) */
  mcJumpTrace_channel_17_cave1_box3:
  SIG_MESSAGE("channel_17_cave1_box3 (Trace)");
  mcDEBUG_COMP("channel_17_cave1_box3")
  mcDEBUG_STATE(
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp)
#define x mcnlx
#define y mcnly
#define z mcnlz
#define vx mcnlvx
#define vy mcnlvy
#define vz mcnlvz
#define t mcnlt
#define sx mcnlsx
#define sy mcnlsy
#define sz mcnlsz
#define p mcnlp

#define mcabsorbComp mcabsorbCompchannel_17_cave1_box3
  STORE_NEUTRON(772,
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp);
  mcScattered=0;
  mcRestore=0;
  mcNCounter[772]++;
  mcPCounter[772] += p;
  mcP2Counter[772] += p*p;
#define mccompcurname  channel_17_cave1_box3
#define mccompcurtype  Union_box
#define mccompcurindex 772
#define loop_index mccchannel_17_cave1_box3_loop_index
#define this_box_volume mccchannel_17_cave1_box3_this_box_volume
#define global_geometry_element mccchannel_17_cave1_box3_global_geometry_element
#define this_box_storage mccchannel_17_cave1_box3_this_box_storage
{   /* Declarations of channel_17_cave1_box3=Union_box() SETTING parameters. */
char* material_string = mccchannel_17_cave1_box3_material_string;
MCNUM priority = mccchannel_17_cave1_box3_priority;
MCNUM xwidth = mccchannel_17_cave1_box3_xwidth;
MCNUM yheight = mccchannel_17_cave1_box3_yheight;
MCNUM zdepth = mccchannel_17_cave1_box3_zdepth;
MCNUM xwidth2 = mccchannel_17_cave1_box3_xwidth2;
MCNUM yheight2 = mccchannel_17_cave1_box3_yheight2;
MCNUM visualize = mccchannel_17_cave1_box3_visualize;
int target_index = mccchannel_17_cave1_box3_target_index;
MCNUM target_x = mccchannel_17_cave1_box3_target_x;
MCNUM target_y = mccchannel_17_cave1_box3_target_y;
MCNUM target_z = mccchannel_17_cave1_box3_target_z;
MCNUM focus_aw = mccchannel_17_cave1_box3_focus_aw;
MCNUM focus_ah = mccchannel_17_cave1_box3_focus_ah;
MCNUM focus_xw = mccchannel_17_cave1_box3_focus_xw;
MCNUM focus_xh = mccchannel_17_cave1_box3_focus_xh;
MCNUM focus_r = mccchannel_17_cave1_box3_focus_r;
MCNUM p_interact = mccchannel_17_cave1_box3_p_interact;
char* mask_string = mccchannel_17_cave1_box3_mask_string;
char* mask_setting = mccchannel_17_cave1_box3_mask_setting;
MCNUM number_of_activations = mccchannel_17_cave1_box3_number_of_activations;
}   /* End of channel_17_cave1_box3=Union_box() SETTING parameter declarations. */
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex
  /* Label for restoring  neutron */
  mcabsorbCompchannel_17_cave1_box3:
  if (RESTORE) /* restore if needed */
  { RESTORE_NEUTRON(772,
      mcnlx,
      mcnly,
      mcnlz,
      mcnlvx,
      mcnlvy,
      mcnlvz,
      mcnlt,
      mcnlsx,
      mcnlsy,
      mcnlsz,
      mcnlp); }
#undef mcabsorbComp
#undef p
#undef sz
#undef sy
#undef sx
#undef t
#undef vz
#undef vy
#undef vx
#undef z
#undef y
#undef x
  mcDEBUG_STATE(
mcnlx,
mcnly,
mcnlz,
mcnlvx,
mcnlvy,
mcnlvz,
mcnlt,
mcnlsx,
mcnlsy,
mcnlsz,
mcnlp)

  /* TRACE Component channel_17_cave1_cyl1 [773] */
  mccoordschange(mcposrchannel_17_cave1_cyl1, mcrotrchannel_17_cave1_cyl1,
    &mcnlx,
    &mcnly,
    &mcnlz,
    &mcnlvx,
    &mcnlvy,
    &mcnlvz,
    &mcnlsx,
    &mcnlsy,
    &mcnlsz);
  /* define label inside component channel_17_cave1_cyl1 (without coords transformations) */
  mcJumpTrace_channel_17_cave1_cyl1:
  SIG_MESSAGE("channel_17_cave1_cyl1 (Trace)");
  mcDEBUG_COMP("channel_17_cave1_cyl1")
  mcDEBUG_STATE(
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp)
#define x mcnlx
#define y mcnly
#define z mcnlz
#define vx mcnlvx
#define vy mcnlvy
#define vz mcnlvz
#define t mcnlt
#define sx mcnlsx
#define sy mcnlsy
#define sz mcnlsz
#define p mcnlp

#define mcabsorbComp mcabsorbCompchannel_17_cave1_cyl1
  STORE_NEUTRON(773,
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp);
  mcScattered=0;
  mcRestore=0;
  mcNCounter[773]++;
  mcPCounter[773] += p;
  mcP2Counter[773] += p*p;
#define mccompcurname  channel_17_cave1_cyl1
#define mccompcurtype  Union_cylinder
#define mccompcurindex 773
#define loop_index mccchannel_17_cave1_cyl1_loop_index
#define this_cylinder_volume mccchannel_17_cave1_cyl1_this_cylinder_volume
#define global_geometry_element mccchannel_17_cave1_cyl1_global_geometry_element
#define this_cylinder_storage mccchannel_17_cave1_cyl1_this_cylinder_storage
{   /* Declarations of channel_17_cave1_cyl1=Union_cylinder() SETTING parameters. */
char* material_string = mccchannel_17_cave1_cyl1_material_string;
MCNUM priority = mccchannel_17_cave1_cyl1_priority;
MCNUM radius = mccchannel_17_cave1_cyl1_radius;
MCNUM yheight = mccchannel_17_cave1_cyl1_yheight;
MCNUM visualize = mccchannel_17_cave1_cyl1_visualize;
int target_index = mccchannel_17_cave1_cyl1_target_index;
MCNUM target_x = mccchannel_17_cave1_cyl1_target_x;
MCNUM target_y = mccchannel_17_cave1_cyl1_target_y;
MCNUM target_z = mccchannel_17_cave1_cyl1_target_z;
MCNUM focus_aw = mccchannel_17_cave1_cyl1_focus_aw;
MCNUM focus_ah = mccchannel_17_cave1_cyl1_focus_ah;
MCNUM focus_xw = mccchannel_17_cave1_cyl1_focus_xw;
MCNUM focus_xh = mccchannel_17_cave1_cyl1_focus_xh;
MCNUM focus_r = mccchannel_17_cave1_cyl1_focus_r;
MCNUM p_interact = mccchannel_17_cave1_cyl1_p_interact;
char* mask_string = mccchannel_17_cave1_cyl1_mask_string;
char* mask_setting = mccchannel_17_cave1_cyl1_mask_setting;
MCNUM number_of_activations = mccchannel_17_cave1_cyl1_number_of_activations;
#line 345 "Union_cylinder.comp"
{
dummy = 1;
}
#line 447055 "MACS_sample_kidney_box.c"
}   /* End of channel_17_cave1_cyl1=Union_cylinder() SETTING parameter declarations. */
#undef this_cylinder_storage
#undef global_geometry_element
#undef this_cylinder_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex
  /* Label for restoring  neutron */
  mcabsorbCompchannel_17_cave1_cyl1:
  if (RESTORE) /* restore if needed */
  { RESTORE_NEUTRON(773,
      mcnlx,
      mcnly,
      mcnlz,
      mcnlvx,
      mcnlvy,
      mcnlvz,
      mcnlt,
      mcnlsx,
      mcnlsy,
      mcnlsz,
      mcnlp); }
#undef mcabsorbComp
#undef p
#undef sz
#undef sy
#undef sx
#undef t
#undef vz
#undef vy
#undef vx
#undef z
#undef y
#undef x
  mcDEBUG_STATE(
mcnlx,
mcnly,
mcnlz,
mcnlvx,
mcnlvy,
mcnlvz,
mcnlt,
mcnlsx,
mcnlsy,
mcnlsz,
mcnlp)

  /* TRACE Component channel_17_analyzer_1_center [774] */
  mccoordschange(mcposrchannel_17_analyzer_1_center, mcrotrchannel_17_analyzer_1_center,
    &mcnlx,
    &mcnly,
    &mcnlz,
    &mcnlvx,
    &mcnlvy,
    &mcnlvz,
    &mcnlsx,
    &mcnlsy,
    &mcnlsz);
  /* define label inside component channel_17_analyzer_1_center (without coords transformations) */
  mcJumpTrace_channel_17_analyzer_1_center:
  SIG_MESSAGE("channel_17_analyzer_1_center (Trace)");
  mcDEBUG_COMP("channel_17_analyzer_1_center")
  mcDEBUG_STATE(
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp)
#define x mcnlx
#define y mcnly
#define z mcnlz
#define vx mcnlvx
#define vy mcnlvy
#define vz mcnlvz
#define t mcnlt
#define sx mcnlsx
#define sy mcnlsy
#define sz mcnlsz
#define p mcnlp

#define mcabsorbComp mcabsorbCompchannel_17_analyzer_1_center
  STORE_NEUTRON(774,
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp);
  mcScattered=0;
  mcRestore=0;
  mcNCounter[774]++;
  mcPCounter[774] += p;
  mcP2Counter[774] += p*p;
#define mccompcurname  channel_17_analyzer_1_center
#define mccompcurtype  Arm
#define mccompcurindex 774
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex
  /* Label for restoring  neutron */
  mcabsorbCompchannel_17_analyzer_1_center:
  if (RESTORE) /* restore if needed */
  { RESTORE_NEUTRON(774,
      mcnlx,
      mcnly,
      mcnlz,
      mcnlvx,
      mcnlvy,
      mcnlvz,
      mcnlt,
      mcnlsx,
      mcnlsy,
      mcnlsz,
      mcnlp); }
#undef mcabsorbComp
#undef p
#undef sz
#undef sy
#undef sx
#undef t
#undef vz
#undef vy
#undef vx
#undef z
#undef y
#undef x
  mcDEBUG_STATE(
mcnlx,
mcnly,
mcnlz,
mcnlvx,
mcnlvy,
mcnlvz,
mcnlt,
mcnlsx,
mcnlsy,
mcnlsz,
mcnlp)

  /* TRACE Component channel_17_analyzer_1_rotated [775] */
  mccoordschange(mcposrchannel_17_analyzer_1_rotated, mcrotrchannel_17_analyzer_1_rotated,
    &mcnlx,
    &mcnly,
    &mcnlz,
    &mcnlvx,
    &mcnlvy,
    &mcnlvz,
    &mcnlsx,
    &mcnlsy,
    &mcnlsz);
  /* define label inside component channel_17_analyzer_1_rotated (without coords transformations) */
  mcJumpTrace_channel_17_analyzer_1_rotated:
  SIG_MESSAGE("channel_17_analyzer_1_rotated (Trace)");
  mcDEBUG_COMP("channel_17_analyzer_1_rotated")
  mcDEBUG_STATE(
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp)
#define x mcnlx
#define y mcnly
#define z mcnlz
#define vx mcnlvx
#define vy mcnlvy
#define vz mcnlvz
#define t mcnlt
#define sx mcnlsx
#define sy mcnlsy
#define sz mcnlsz
#define p mcnlp

#define mcabsorbComp mcabsorbCompchannel_17_analyzer_1_rotated
  STORE_NEUTRON(775,
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp);
  mcScattered=0;
  mcRestore=0;
  mcNCounter[775]++;
  mcPCounter[775] += p;
  mcP2Counter[775] += p*p;
#define mccompcurname  channel_17_analyzer_1_rotated
#define mccompcurtype  Arm
#define mccompcurindex 775
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex
  /* Label for restoring  neutron */
  mcabsorbCompchannel_17_analyzer_1_rotated:
  if (RESTORE) /* restore if needed */
  { RESTORE_NEUTRON(775,
      mcnlx,
      mcnly,
      mcnlz,
      mcnlvx,
      mcnlvy,
      mcnlvz,
      mcnlt,
      mcnlsx,
      mcnlsy,
      mcnlsz,
      mcnlp); }
#undef mcabsorbComp
#undef p
#undef sz
#undef sy
#undef sx
#undef t
#undef vz
#undef vy
#undef vx
#undef z
#undef y
#undef x
  mcDEBUG_STATE(
mcnlx,
mcnly,
mcnlz,
mcnlvx,
mcnlvy,
mcnlvz,
mcnlt,
mcnlsx,
mcnlsy,
mcnlsz,
mcnlp)

  /* TRACE Component channel_17_analyzer_1_array_crystal_array_0 [776] */
  mccoordschange(mcposrchannel_17_analyzer_1_array_crystal_array_0, mcrotrchannel_17_analyzer_1_array_crystal_array_0,
    &mcnlx,
    &mcnly,
    &mcnlz,
    &mcnlvx,
    &mcnlvy,
    &mcnlvz,
    &mcnlsx,
    &mcnlsy,
    &mcnlsz);
  /* define label inside component channel_17_analyzer_1_array_crystal_array_0 (without coords transformations) */
  mcJumpTrace_channel_17_analyzer_1_array_crystal_array_0:
  SIG_MESSAGE("channel_17_analyzer_1_array_crystal_array_0 (Trace)");
  mcDEBUG_COMP("channel_17_analyzer_1_array_crystal_array_0")
  mcDEBUG_STATE(
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp)
#define x mcnlx
#define y mcnly
#define z mcnlz
#define vx mcnlvx
#define vy mcnlvy
#define vz mcnlvz
#define t mcnlt
#define sx mcnlsx
#define sy mcnlsy
#define sz mcnlsz
#define p mcnlp

#define mcabsorbComp mcabsorbCompchannel_17_analyzer_1_array_crystal_array_0
  STORE_NEUTRON(776,
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp);
  mcScattered=0;
  mcRestore=0;
  mcNCounter[776]++;
  mcPCounter[776] += p;
  mcP2Counter[776] += p*p;
#define mccompcurname  channel_17_analyzer_1_array_crystal_array_0
#define mccompcurtype  Union_box
#define mccompcurindex 776
#define loop_index mccchannel_17_analyzer_1_array_crystal_array_0_loop_index
#define this_box_volume mccchannel_17_analyzer_1_array_crystal_array_0_this_box_volume
#define global_geometry_element mccchannel_17_analyzer_1_array_crystal_array_0_global_geometry_element
#define this_box_storage mccchannel_17_analyzer_1_array_crystal_array_0_this_box_storage
{   /* Declarations of channel_17_analyzer_1_array_crystal_array_0=Union_box() SETTING parameters. */
char* material_string = mccchannel_17_analyzer_1_array_crystal_array_0_material_string;
MCNUM priority = mccchannel_17_analyzer_1_array_crystal_array_0_priority;
MCNUM xwidth = mccchannel_17_analyzer_1_array_crystal_array_0_xwidth;
MCNUM yheight = mccchannel_17_analyzer_1_array_crystal_array_0_yheight;
MCNUM zdepth = mccchannel_17_analyzer_1_array_crystal_array_0_zdepth;
MCNUM xwidth2 = mccchannel_17_analyzer_1_array_crystal_array_0_xwidth2;
MCNUM yheight2 = mccchannel_17_analyzer_1_array_crystal_array_0_yheight2;
MCNUM visualize = mccchannel_17_analyzer_1_array_crystal_array_0_visualize;
int target_index = mccchannel_17_analyzer_1_array_crystal_array_0_target_index;
MCNUM target_x = mccchannel_17_analyzer_1_array_crystal_array_0_target_x;
MCNUM target_y = mccchannel_17_analyzer_1_array_crystal_array_0_target_y;
MCNUM target_z = mccchannel_17_analyzer_1_array_crystal_array_0_target_z;
MCNUM focus_aw = mccchannel_17_analyzer_1_array_crystal_array_0_focus_aw;
MCNUM focus_ah = mccchannel_17_analyzer_1_array_crystal_array_0_focus_ah;
MCNUM focus_xw = mccchannel_17_analyzer_1_array_crystal_array_0_focus_xw;
MCNUM focus_xh = mccchannel_17_analyzer_1_array_crystal_array_0_focus_xh;
MCNUM focus_r = mccchannel_17_analyzer_1_array_crystal_array_0_focus_r;
MCNUM p_interact = mccchannel_17_analyzer_1_array_crystal_array_0_p_interact;
char* mask_string = mccchannel_17_analyzer_1_array_crystal_array_0_mask_string;
char* mask_setting = mccchannel_17_analyzer_1_array_crystal_array_0_mask_setting;
MCNUM number_of_activations = mccchannel_17_analyzer_1_array_crystal_array_0_number_of_activations;
}   /* End of channel_17_analyzer_1_array_crystal_array_0=Union_box() SETTING parameter declarations. */
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex
  /* Label for restoring  neutron */
  mcabsorbCompchannel_17_analyzer_1_array_crystal_array_0:
  if (RESTORE) /* restore if needed */
  { RESTORE_NEUTRON(776,
      mcnlx,
      mcnly,
      mcnlz,
      mcnlvx,
      mcnlvy,
      mcnlvz,
      mcnlt,
      mcnlsx,
      mcnlsy,
      mcnlsz,
      mcnlp); }
#undef mcabsorbComp
#undef p
#undef sz
#undef sy
#undef sx
#undef t
#undef vz
#undef vy
#undef vx
#undef z
#undef y
#undef x
  mcDEBUG_STATE(
mcnlx,
mcnly,
mcnlz,
mcnlvx,
mcnlvy,
mcnlvz,
mcnlt,
mcnlsx,
mcnlsy,
mcnlsz,
mcnlp)

  /* TRACE Component channel_17_analyzer_1_array_crystal_array_1 [777] */
  mccoordschange(mcposrchannel_17_analyzer_1_array_crystal_array_1, mcrotrchannel_17_analyzer_1_array_crystal_array_1,
    &mcnlx,
    &mcnly,
    &mcnlz,
    &mcnlvx,
    &mcnlvy,
    &mcnlvz,
    &mcnlsx,
    &mcnlsy,
    &mcnlsz);
  /* define label inside component channel_17_analyzer_1_array_crystal_array_1 (without coords transformations) */
  mcJumpTrace_channel_17_analyzer_1_array_crystal_array_1:
  SIG_MESSAGE("channel_17_analyzer_1_array_crystal_array_1 (Trace)");
  mcDEBUG_COMP("channel_17_analyzer_1_array_crystal_array_1")
  mcDEBUG_STATE(
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp)
#define x mcnlx
#define y mcnly
#define z mcnlz
#define vx mcnlvx
#define vy mcnlvy
#define vz mcnlvz
#define t mcnlt
#define sx mcnlsx
#define sy mcnlsy
#define sz mcnlsz
#define p mcnlp

#define mcabsorbComp mcabsorbCompchannel_17_analyzer_1_array_crystal_array_1
  STORE_NEUTRON(777,
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp);
  mcScattered=0;
  mcRestore=0;
  mcNCounter[777]++;
  mcPCounter[777] += p;
  mcP2Counter[777] += p*p;
#define mccompcurname  channel_17_analyzer_1_array_crystal_array_1
#define mccompcurtype  Union_box
#define mccompcurindex 777
#define loop_index mccchannel_17_analyzer_1_array_crystal_array_1_loop_index
#define this_box_volume mccchannel_17_analyzer_1_array_crystal_array_1_this_box_volume
#define global_geometry_element mccchannel_17_analyzer_1_array_crystal_array_1_global_geometry_element
#define this_box_storage mccchannel_17_analyzer_1_array_crystal_array_1_this_box_storage
{   /* Declarations of channel_17_analyzer_1_array_crystal_array_1=Union_box() SETTING parameters. */
char* material_string = mccchannel_17_analyzer_1_array_crystal_array_1_material_string;
MCNUM priority = mccchannel_17_analyzer_1_array_crystal_array_1_priority;
MCNUM xwidth = mccchannel_17_analyzer_1_array_crystal_array_1_xwidth;
MCNUM yheight = mccchannel_17_analyzer_1_array_crystal_array_1_yheight;
MCNUM zdepth = mccchannel_17_analyzer_1_array_crystal_array_1_zdepth;
MCNUM xwidth2 = mccchannel_17_analyzer_1_array_crystal_array_1_xwidth2;
MCNUM yheight2 = mccchannel_17_analyzer_1_array_crystal_array_1_yheight2;
MCNUM visualize = mccchannel_17_analyzer_1_array_crystal_array_1_visualize;
int target_index = mccchannel_17_analyzer_1_array_crystal_array_1_target_index;
MCNUM target_x = mccchannel_17_analyzer_1_array_crystal_array_1_target_x;
MCNUM target_y = mccchannel_17_analyzer_1_array_crystal_array_1_target_y;
MCNUM target_z = mccchannel_17_analyzer_1_array_crystal_array_1_target_z;
MCNUM focus_aw = mccchannel_17_analyzer_1_array_crystal_array_1_focus_aw;
MCNUM focus_ah = mccchannel_17_analyzer_1_array_crystal_array_1_focus_ah;
MCNUM focus_xw = mccchannel_17_analyzer_1_array_crystal_array_1_focus_xw;
MCNUM focus_xh = mccchannel_17_analyzer_1_array_crystal_array_1_focus_xh;
MCNUM focus_r = mccchannel_17_analyzer_1_array_crystal_array_1_focus_r;
MCNUM p_interact = mccchannel_17_analyzer_1_array_crystal_array_1_p_interact;
char* mask_string = mccchannel_17_analyzer_1_array_crystal_array_1_mask_string;
char* mask_setting = mccchannel_17_analyzer_1_array_crystal_array_1_mask_setting;
MCNUM number_of_activations = mccchannel_17_analyzer_1_array_crystal_array_1_number_of_activations;
}   /* End of channel_17_analyzer_1_array_crystal_array_1=Union_box() SETTING parameter declarations. */
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex
  /* Label for restoring  neutron */
  mcabsorbCompchannel_17_analyzer_1_array_crystal_array_1:
  if (RESTORE) /* restore if needed */
  { RESTORE_NEUTRON(777,
      mcnlx,
      mcnly,
      mcnlz,
      mcnlvx,
      mcnlvy,
      mcnlvz,
      mcnlt,
      mcnlsx,
      mcnlsy,
      mcnlsz,
      mcnlp); }
#undef mcabsorbComp
#undef p
#undef sz
#undef sy
#undef sx
#undef t
#undef vz
#undef vy
#undef vx
#undef z
#undef y
#undef x
  mcDEBUG_STATE(
mcnlx,
mcnly,
mcnlz,
mcnlvx,
mcnlvy,
mcnlvz,
mcnlt,
mcnlsx,
mcnlsy,
mcnlsz,
mcnlp)

  /* TRACE Component channel_17_analyzer_1_array_crystal_array_2 [778] */
  mccoordschange(mcposrchannel_17_analyzer_1_array_crystal_array_2, mcrotrchannel_17_analyzer_1_array_crystal_array_2,
    &mcnlx,
    &mcnly,
    &mcnlz,
    &mcnlvx,
    &mcnlvy,
    &mcnlvz,
    &mcnlsx,
    &mcnlsy,
    &mcnlsz);
  /* define label inside component channel_17_analyzer_1_array_crystal_array_2 (without coords transformations) */
  mcJumpTrace_channel_17_analyzer_1_array_crystal_array_2:
  SIG_MESSAGE("channel_17_analyzer_1_array_crystal_array_2 (Trace)");
  mcDEBUG_COMP("channel_17_analyzer_1_array_crystal_array_2")
  mcDEBUG_STATE(
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp)
#define x mcnlx
#define y mcnly
#define z mcnlz
#define vx mcnlvx
#define vy mcnlvy
#define vz mcnlvz
#define t mcnlt
#define sx mcnlsx
#define sy mcnlsy
#define sz mcnlsz
#define p mcnlp

#define mcabsorbComp mcabsorbCompchannel_17_analyzer_1_array_crystal_array_2
  STORE_NEUTRON(778,
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp);
  mcScattered=0;
  mcRestore=0;
  mcNCounter[778]++;
  mcPCounter[778] += p;
  mcP2Counter[778] += p*p;
#define mccompcurname  channel_17_analyzer_1_array_crystal_array_2
#define mccompcurtype  Union_box
#define mccompcurindex 778
#define loop_index mccchannel_17_analyzer_1_array_crystal_array_2_loop_index
#define this_box_volume mccchannel_17_analyzer_1_array_crystal_array_2_this_box_volume
#define global_geometry_element mccchannel_17_analyzer_1_array_crystal_array_2_global_geometry_element
#define this_box_storage mccchannel_17_analyzer_1_array_crystal_array_2_this_box_storage
{   /* Declarations of channel_17_analyzer_1_array_crystal_array_2=Union_box() SETTING parameters. */
char* material_string = mccchannel_17_analyzer_1_array_crystal_array_2_material_string;
MCNUM priority = mccchannel_17_analyzer_1_array_crystal_array_2_priority;
MCNUM xwidth = mccchannel_17_analyzer_1_array_crystal_array_2_xwidth;
MCNUM yheight = mccchannel_17_analyzer_1_array_crystal_array_2_yheight;
MCNUM zdepth = mccchannel_17_analyzer_1_array_crystal_array_2_zdepth;
MCNUM xwidth2 = mccchannel_17_analyzer_1_array_crystal_array_2_xwidth2;
MCNUM yheight2 = mccchannel_17_analyzer_1_array_crystal_array_2_yheight2;
MCNUM visualize = mccchannel_17_analyzer_1_array_crystal_array_2_visualize;
int target_index = mccchannel_17_analyzer_1_array_crystal_array_2_target_index;
MCNUM target_x = mccchannel_17_analyzer_1_array_crystal_array_2_target_x;
MCNUM target_y = mccchannel_17_analyzer_1_array_crystal_array_2_target_y;
MCNUM target_z = mccchannel_17_analyzer_1_array_crystal_array_2_target_z;
MCNUM focus_aw = mccchannel_17_analyzer_1_array_crystal_array_2_focus_aw;
MCNUM focus_ah = mccchannel_17_analyzer_1_array_crystal_array_2_focus_ah;
MCNUM focus_xw = mccchannel_17_analyzer_1_array_crystal_array_2_focus_xw;
MCNUM focus_xh = mccchannel_17_analyzer_1_array_crystal_array_2_focus_xh;
MCNUM focus_r = mccchannel_17_analyzer_1_array_crystal_array_2_focus_r;
MCNUM p_interact = mccchannel_17_analyzer_1_array_crystal_array_2_p_interact;
char* mask_string = mccchannel_17_analyzer_1_array_crystal_array_2_mask_string;
char* mask_setting = mccchannel_17_analyzer_1_array_crystal_array_2_mask_setting;
MCNUM number_of_activations = mccchannel_17_analyzer_1_array_crystal_array_2_number_of_activations;
}   /* End of channel_17_analyzer_1_array_crystal_array_2=Union_box() SETTING parameter declarations. */
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex
  /* Label for restoring  neutron */
  mcabsorbCompchannel_17_analyzer_1_array_crystal_array_2:
  if (RESTORE) /* restore if needed */
  { RESTORE_NEUTRON(778,
      mcnlx,
      mcnly,
      mcnlz,
      mcnlvx,
      mcnlvy,
      mcnlvz,
      mcnlt,
      mcnlsx,
      mcnlsy,
      mcnlsz,
      mcnlp); }
#undef mcabsorbComp
#undef p
#undef sz
#undef sy
#undef sx
#undef t
#undef vz
#undef vy
#undef vx
#undef z
#undef y
#undef x
  mcDEBUG_STATE(
mcnlx,
mcnly,
mcnlz,
mcnlvx,
mcnlvy,
mcnlvz,
mcnlt,
mcnlsx,
mcnlsy,
mcnlsz,
mcnlp)

  /* TRACE Component channel_17_analyzer_1_array_crystal_array_3 [779] */
  mccoordschange(mcposrchannel_17_analyzer_1_array_crystal_array_3, mcrotrchannel_17_analyzer_1_array_crystal_array_3,
    &mcnlx,
    &mcnly,
    &mcnlz,
    &mcnlvx,
    &mcnlvy,
    &mcnlvz,
    &mcnlsx,
    &mcnlsy,
    &mcnlsz);
  /* define label inside component channel_17_analyzer_1_array_crystal_array_3 (without coords transformations) */
  mcJumpTrace_channel_17_analyzer_1_array_crystal_array_3:
  SIG_MESSAGE("channel_17_analyzer_1_array_crystal_array_3 (Trace)");
  mcDEBUG_COMP("channel_17_analyzer_1_array_crystal_array_3")
  mcDEBUG_STATE(
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp)
#define x mcnlx
#define y mcnly
#define z mcnlz
#define vx mcnlvx
#define vy mcnlvy
#define vz mcnlvz
#define t mcnlt
#define sx mcnlsx
#define sy mcnlsy
#define sz mcnlsz
#define p mcnlp

#define mcabsorbComp mcabsorbCompchannel_17_analyzer_1_array_crystal_array_3
  STORE_NEUTRON(779,
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp);
  mcScattered=0;
  mcRestore=0;
  mcNCounter[779]++;
  mcPCounter[779] += p;
  mcP2Counter[779] += p*p;
#define mccompcurname  channel_17_analyzer_1_array_crystal_array_3
#define mccompcurtype  Union_box
#define mccompcurindex 779
#define loop_index mccchannel_17_analyzer_1_array_crystal_array_3_loop_index
#define this_box_volume mccchannel_17_analyzer_1_array_crystal_array_3_this_box_volume
#define global_geometry_element mccchannel_17_analyzer_1_array_crystal_array_3_global_geometry_element
#define this_box_storage mccchannel_17_analyzer_1_array_crystal_array_3_this_box_storage
{   /* Declarations of channel_17_analyzer_1_array_crystal_array_3=Union_box() SETTING parameters. */
char* material_string = mccchannel_17_analyzer_1_array_crystal_array_3_material_string;
MCNUM priority = mccchannel_17_analyzer_1_array_crystal_array_3_priority;
MCNUM xwidth = mccchannel_17_analyzer_1_array_crystal_array_3_xwidth;
MCNUM yheight = mccchannel_17_analyzer_1_array_crystal_array_3_yheight;
MCNUM zdepth = mccchannel_17_analyzer_1_array_crystal_array_3_zdepth;
MCNUM xwidth2 = mccchannel_17_analyzer_1_array_crystal_array_3_xwidth2;
MCNUM yheight2 = mccchannel_17_analyzer_1_array_crystal_array_3_yheight2;
MCNUM visualize = mccchannel_17_analyzer_1_array_crystal_array_3_visualize;
int target_index = mccchannel_17_analyzer_1_array_crystal_array_3_target_index;
MCNUM target_x = mccchannel_17_analyzer_1_array_crystal_array_3_target_x;
MCNUM target_y = mccchannel_17_analyzer_1_array_crystal_array_3_target_y;
MCNUM target_z = mccchannel_17_analyzer_1_array_crystal_array_3_target_z;
MCNUM focus_aw = mccchannel_17_analyzer_1_array_crystal_array_3_focus_aw;
MCNUM focus_ah = mccchannel_17_analyzer_1_array_crystal_array_3_focus_ah;
MCNUM focus_xw = mccchannel_17_analyzer_1_array_crystal_array_3_focus_xw;
MCNUM focus_xh = mccchannel_17_analyzer_1_array_crystal_array_3_focus_xh;
MCNUM focus_r = mccchannel_17_analyzer_1_array_crystal_array_3_focus_r;
MCNUM p_interact = mccchannel_17_analyzer_1_array_crystal_array_3_p_interact;
char* mask_string = mccchannel_17_analyzer_1_array_crystal_array_3_mask_string;
char* mask_setting = mccchannel_17_analyzer_1_array_crystal_array_3_mask_setting;
MCNUM number_of_activations = mccchannel_17_analyzer_1_array_crystal_array_3_number_of_activations;
}   /* End of channel_17_analyzer_1_array_crystal_array_3=Union_box() SETTING parameter declarations. */
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex
  /* Label for restoring  neutron */
  mcabsorbCompchannel_17_analyzer_1_array_crystal_array_3:
  if (RESTORE) /* restore if needed */
  { RESTORE_NEUTRON(779,
      mcnlx,
      mcnly,
      mcnlz,
      mcnlvx,
      mcnlvy,
      mcnlvz,
      mcnlt,
      mcnlsx,
      mcnlsy,
      mcnlsz,
      mcnlp); }
#undef mcabsorbComp
#undef p
#undef sz
#undef sy
#undef sx
#undef t
#undef vz
#undef vy
#undef vx
#undef z
#undef y
#undef x
  mcDEBUG_STATE(
mcnlx,
mcnly,
mcnlz,
mcnlvx,
mcnlvy,
mcnlvz,
mcnlt,
mcnlsx,
mcnlsy,
mcnlsz,
mcnlp)

  /* TRACE Component channel_17_analyzer_1_array_crystal_array_4 [780] */
  mccoordschange(mcposrchannel_17_analyzer_1_array_crystal_array_4, mcrotrchannel_17_analyzer_1_array_crystal_array_4,
    &mcnlx,
    &mcnly,
    &mcnlz,
    &mcnlvx,
    &mcnlvy,
    &mcnlvz,
    &mcnlsx,
    &mcnlsy,
    &mcnlsz);
  /* define label inside component channel_17_analyzer_1_array_crystal_array_4 (without coords transformations) */
  mcJumpTrace_channel_17_analyzer_1_array_crystal_array_4:
  SIG_MESSAGE("channel_17_analyzer_1_array_crystal_array_4 (Trace)");
  mcDEBUG_COMP("channel_17_analyzer_1_array_crystal_array_4")
  mcDEBUG_STATE(
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp)
#define x mcnlx
#define y mcnly
#define z mcnlz
#define vx mcnlvx
#define vy mcnlvy
#define vz mcnlvz
#define t mcnlt
#define sx mcnlsx
#define sy mcnlsy
#define sz mcnlsz
#define p mcnlp

#define mcabsorbComp mcabsorbCompchannel_17_analyzer_1_array_crystal_array_4
  STORE_NEUTRON(780,
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp);
  mcScattered=0;
  mcRestore=0;
  mcNCounter[780]++;
  mcPCounter[780] += p;
  mcP2Counter[780] += p*p;
#define mccompcurname  channel_17_analyzer_1_array_crystal_array_4
#define mccompcurtype  Union_box
#define mccompcurindex 780
#define loop_index mccchannel_17_analyzer_1_array_crystal_array_4_loop_index
#define this_box_volume mccchannel_17_analyzer_1_array_crystal_array_4_this_box_volume
#define global_geometry_element mccchannel_17_analyzer_1_array_crystal_array_4_global_geometry_element
#define this_box_storage mccchannel_17_analyzer_1_array_crystal_array_4_this_box_storage
{   /* Declarations of channel_17_analyzer_1_array_crystal_array_4=Union_box() SETTING parameters. */
char* material_string = mccchannel_17_analyzer_1_array_crystal_array_4_material_string;
MCNUM priority = mccchannel_17_analyzer_1_array_crystal_array_4_priority;
MCNUM xwidth = mccchannel_17_analyzer_1_array_crystal_array_4_xwidth;
MCNUM yheight = mccchannel_17_analyzer_1_array_crystal_array_4_yheight;
MCNUM zdepth = mccchannel_17_analyzer_1_array_crystal_array_4_zdepth;
MCNUM xwidth2 = mccchannel_17_analyzer_1_array_crystal_array_4_xwidth2;
MCNUM yheight2 = mccchannel_17_analyzer_1_array_crystal_array_4_yheight2;
MCNUM visualize = mccchannel_17_analyzer_1_array_crystal_array_4_visualize;
int target_index = mccchannel_17_analyzer_1_array_crystal_array_4_target_index;
MCNUM target_x = mccchannel_17_analyzer_1_array_crystal_array_4_target_x;
MCNUM target_y = mccchannel_17_analyzer_1_array_crystal_array_4_target_y;
MCNUM target_z = mccchannel_17_analyzer_1_array_crystal_array_4_target_z;
MCNUM focus_aw = mccchannel_17_analyzer_1_array_crystal_array_4_focus_aw;
MCNUM focus_ah = mccchannel_17_analyzer_1_array_crystal_array_4_focus_ah;
MCNUM focus_xw = mccchannel_17_analyzer_1_array_crystal_array_4_focus_xw;
MCNUM focus_xh = mccchannel_17_analyzer_1_array_crystal_array_4_focus_xh;
MCNUM focus_r = mccchannel_17_analyzer_1_array_crystal_array_4_focus_r;
MCNUM p_interact = mccchannel_17_analyzer_1_array_crystal_array_4_p_interact;
char* mask_string = mccchannel_17_analyzer_1_array_crystal_array_4_mask_string;
char* mask_setting = mccchannel_17_analyzer_1_array_crystal_array_4_mask_setting;
MCNUM number_of_activations = mccchannel_17_analyzer_1_array_crystal_array_4_number_of_activations;
}   /* End of channel_17_analyzer_1_array_crystal_array_4=Union_box() SETTING parameter declarations. */
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex
  /* Label for restoring  neutron */
  mcabsorbCompchannel_17_analyzer_1_array_crystal_array_4:
  if (RESTORE) /* restore if needed */
  { RESTORE_NEUTRON(780,
      mcnlx,
      mcnly,
      mcnlz,
      mcnlvx,
      mcnlvy,
      mcnlvz,
      mcnlt,
      mcnlsx,
      mcnlsy,
      mcnlsz,
      mcnlp); }
#undef mcabsorbComp
#undef p
#undef sz
#undef sy
#undef sx
#undef t
#undef vz
#undef vy
#undef vx
#undef z
#undef y
#undef x
  mcDEBUG_STATE(
mcnlx,
mcnly,
mcnlz,
mcnlvx,
mcnlvy,
mcnlvz,
mcnlt,
mcnlsx,
mcnlsy,
mcnlsz,
mcnlp)

  /* TRACE Component channel_17_analyzer_1_array_crystal_array_5 [781] */
  mccoordschange(mcposrchannel_17_analyzer_1_array_crystal_array_5, mcrotrchannel_17_analyzer_1_array_crystal_array_5,
    &mcnlx,
    &mcnly,
    &mcnlz,
    &mcnlvx,
    &mcnlvy,
    &mcnlvz,
    &mcnlsx,
    &mcnlsy,
    &mcnlsz);
  /* define label inside component channel_17_analyzer_1_array_crystal_array_5 (without coords transformations) */
  mcJumpTrace_channel_17_analyzer_1_array_crystal_array_5:
  SIG_MESSAGE("channel_17_analyzer_1_array_crystal_array_5 (Trace)");
  mcDEBUG_COMP("channel_17_analyzer_1_array_crystal_array_5")
  mcDEBUG_STATE(
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp)
#define x mcnlx
#define y mcnly
#define z mcnlz
#define vx mcnlvx
#define vy mcnlvy
#define vz mcnlvz
#define t mcnlt
#define sx mcnlsx
#define sy mcnlsy
#define sz mcnlsz
#define p mcnlp

#define mcabsorbComp mcabsorbCompchannel_17_analyzer_1_array_crystal_array_5
  STORE_NEUTRON(781,
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp);
  mcScattered=0;
  mcRestore=0;
  mcNCounter[781]++;
  mcPCounter[781] += p;
  mcP2Counter[781] += p*p;
#define mccompcurname  channel_17_analyzer_1_array_crystal_array_5
#define mccompcurtype  Union_box
#define mccompcurindex 781
#define loop_index mccchannel_17_analyzer_1_array_crystal_array_5_loop_index
#define this_box_volume mccchannel_17_analyzer_1_array_crystal_array_5_this_box_volume
#define global_geometry_element mccchannel_17_analyzer_1_array_crystal_array_5_global_geometry_element
#define this_box_storage mccchannel_17_analyzer_1_array_crystal_array_5_this_box_storage
{   /* Declarations of channel_17_analyzer_1_array_crystal_array_5=Union_box() SETTING parameters. */
char* material_string = mccchannel_17_analyzer_1_array_crystal_array_5_material_string;
MCNUM priority = mccchannel_17_analyzer_1_array_crystal_array_5_priority;
MCNUM xwidth = mccchannel_17_analyzer_1_array_crystal_array_5_xwidth;
MCNUM yheight = mccchannel_17_analyzer_1_array_crystal_array_5_yheight;
MCNUM zdepth = mccchannel_17_analyzer_1_array_crystal_array_5_zdepth;
MCNUM xwidth2 = mccchannel_17_analyzer_1_array_crystal_array_5_xwidth2;
MCNUM yheight2 = mccchannel_17_analyzer_1_array_crystal_array_5_yheight2;
MCNUM visualize = mccchannel_17_analyzer_1_array_crystal_array_5_visualize;
int target_index = mccchannel_17_analyzer_1_array_crystal_array_5_target_index;
MCNUM target_x = mccchannel_17_analyzer_1_array_crystal_array_5_target_x;
MCNUM target_y = mccchannel_17_analyzer_1_array_crystal_array_5_target_y;
MCNUM target_z = mccchannel_17_analyzer_1_array_crystal_array_5_target_z;
MCNUM focus_aw = mccchannel_17_analyzer_1_array_crystal_array_5_focus_aw;
MCNUM focus_ah = mccchannel_17_analyzer_1_array_crystal_array_5_focus_ah;
MCNUM focus_xw = mccchannel_17_analyzer_1_array_crystal_array_5_focus_xw;
MCNUM focus_xh = mccchannel_17_analyzer_1_array_crystal_array_5_focus_xh;
MCNUM focus_r = mccchannel_17_analyzer_1_array_crystal_array_5_focus_r;
MCNUM p_interact = mccchannel_17_analyzer_1_array_crystal_array_5_p_interact;
char* mask_string = mccchannel_17_analyzer_1_array_crystal_array_5_mask_string;
char* mask_setting = mccchannel_17_analyzer_1_array_crystal_array_5_mask_setting;
MCNUM number_of_activations = mccchannel_17_analyzer_1_array_crystal_array_5_number_of_activations;
}   /* End of channel_17_analyzer_1_array_crystal_array_5=Union_box() SETTING parameter declarations. */
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex
  /* Label for restoring  neutron */
  mcabsorbCompchannel_17_analyzer_1_array_crystal_array_5:
  if (RESTORE) /* restore if needed */
  { RESTORE_NEUTRON(781,
      mcnlx,
      mcnly,
      mcnlz,
      mcnlvx,
      mcnlvy,
      mcnlvz,
      mcnlt,
      mcnlsx,
      mcnlsy,
      mcnlsz,
      mcnlp); }
#undef mcabsorbComp
#undef p
#undef sz
#undef sy
#undef sx
#undef t
#undef vz
#undef vy
#undef vx
#undef z
#undef y
#undef x
  mcDEBUG_STATE(
mcnlx,
mcnly,
mcnlz,
mcnlvx,
mcnlvy,
mcnlvz,
mcnlt,
mcnlsx,
mcnlsy,
mcnlsz,
mcnlp)

  /* TRACE Component channel_17_analyzer_1_array_crystal_array_6 [782] */
  mccoordschange(mcposrchannel_17_analyzer_1_array_crystal_array_6, mcrotrchannel_17_analyzer_1_array_crystal_array_6,
    &mcnlx,
    &mcnly,
    &mcnlz,
    &mcnlvx,
    &mcnlvy,
    &mcnlvz,
    &mcnlsx,
    &mcnlsy,
    &mcnlsz);
  /* define label inside component channel_17_analyzer_1_array_crystal_array_6 (without coords transformations) */
  mcJumpTrace_channel_17_analyzer_1_array_crystal_array_6:
  SIG_MESSAGE("channel_17_analyzer_1_array_crystal_array_6 (Trace)");
  mcDEBUG_COMP("channel_17_analyzer_1_array_crystal_array_6")
  mcDEBUG_STATE(
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp)
#define x mcnlx
#define y mcnly
#define z mcnlz
#define vx mcnlvx
#define vy mcnlvy
#define vz mcnlvz
#define t mcnlt
#define sx mcnlsx
#define sy mcnlsy
#define sz mcnlsz
#define p mcnlp

#define mcabsorbComp mcabsorbCompchannel_17_analyzer_1_array_crystal_array_6
  STORE_NEUTRON(782,
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp);
  mcScattered=0;
  mcRestore=0;
  mcNCounter[782]++;
  mcPCounter[782] += p;
  mcP2Counter[782] += p*p;
#define mccompcurname  channel_17_analyzer_1_array_crystal_array_6
#define mccompcurtype  Union_box
#define mccompcurindex 782
#define loop_index mccchannel_17_analyzer_1_array_crystal_array_6_loop_index
#define this_box_volume mccchannel_17_analyzer_1_array_crystal_array_6_this_box_volume
#define global_geometry_element mccchannel_17_analyzer_1_array_crystal_array_6_global_geometry_element
#define this_box_storage mccchannel_17_analyzer_1_array_crystal_array_6_this_box_storage
{   /* Declarations of channel_17_analyzer_1_array_crystal_array_6=Union_box() SETTING parameters. */
char* material_string = mccchannel_17_analyzer_1_array_crystal_array_6_material_string;
MCNUM priority = mccchannel_17_analyzer_1_array_crystal_array_6_priority;
MCNUM xwidth = mccchannel_17_analyzer_1_array_crystal_array_6_xwidth;
MCNUM yheight = mccchannel_17_analyzer_1_array_crystal_array_6_yheight;
MCNUM zdepth = mccchannel_17_analyzer_1_array_crystal_array_6_zdepth;
MCNUM xwidth2 = mccchannel_17_analyzer_1_array_crystal_array_6_xwidth2;
MCNUM yheight2 = mccchannel_17_analyzer_1_array_crystal_array_6_yheight2;
MCNUM visualize = mccchannel_17_analyzer_1_array_crystal_array_6_visualize;
int target_index = mccchannel_17_analyzer_1_array_crystal_array_6_target_index;
MCNUM target_x = mccchannel_17_analyzer_1_array_crystal_array_6_target_x;
MCNUM target_y = mccchannel_17_analyzer_1_array_crystal_array_6_target_y;
MCNUM target_z = mccchannel_17_analyzer_1_array_crystal_array_6_target_z;
MCNUM focus_aw = mccchannel_17_analyzer_1_array_crystal_array_6_focus_aw;
MCNUM focus_ah = mccchannel_17_analyzer_1_array_crystal_array_6_focus_ah;
MCNUM focus_xw = mccchannel_17_analyzer_1_array_crystal_array_6_focus_xw;
MCNUM focus_xh = mccchannel_17_analyzer_1_array_crystal_array_6_focus_xh;
MCNUM focus_r = mccchannel_17_analyzer_1_array_crystal_array_6_focus_r;
MCNUM p_interact = mccchannel_17_analyzer_1_array_crystal_array_6_p_interact;
char* mask_string = mccchannel_17_analyzer_1_array_crystal_array_6_mask_string;
char* mask_setting = mccchannel_17_analyzer_1_array_crystal_array_6_mask_setting;
MCNUM number_of_activations = mccchannel_17_analyzer_1_array_crystal_array_6_number_of_activations;
}   /* End of channel_17_analyzer_1_array_crystal_array_6=Union_box() SETTING parameter declarations. */
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex
  /* Label for restoring  neutron */
  mcabsorbCompchannel_17_analyzer_1_array_crystal_array_6:
  if (RESTORE) /* restore if needed */
  { RESTORE_NEUTRON(782,
      mcnlx,
      mcnly,
      mcnlz,
      mcnlvx,
      mcnlvy,
      mcnlvz,
      mcnlt,
      mcnlsx,
      mcnlsy,
      mcnlsz,
      mcnlp); }
#undef mcabsorbComp
#undef p
#undef sz
#undef sy
#undef sx
#undef t
#undef vz
#undef vy
#undef vx
#undef z
#undef y
#undef x
  mcDEBUG_STATE(
mcnlx,
mcnly,
mcnlz,
mcnlvx,
mcnlvy,
mcnlvz,
mcnlt,
mcnlsx,
mcnlsy,
mcnlsz,
mcnlp)

  /* TRACE Component channel_17_analyzer_1_array_crystal_array_7 [783] */
  mccoordschange(mcposrchannel_17_analyzer_1_array_crystal_array_7, mcrotrchannel_17_analyzer_1_array_crystal_array_7,
    &mcnlx,
    &mcnly,
    &mcnlz,
    &mcnlvx,
    &mcnlvy,
    &mcnlvz,
    &mcnlsx,
    &mcnlsy,
    &mcnlsz);
  /* define label inside component channel_17_analyzer_1_array_crystal_array_7 (without coords transformations) */
  mcJumpTrace_channel_17_analyzer_1_array_crystal_array_7:
  SIG_MESSAGE("channel_17_analyzer_1_array_crystal_array_7 (Trace)");
  mcDEBUG_COMP("channel_17_analyzer_1_array_crystal_array_7")
  mcDEBUG_STATE(
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp)
#define x mcnlx
#define y mcnly
#define z mcnlz
#define vx mcnlvx
#define vy mcnlvy
#define vz mcnlvz
#define t mcnlt
#define sx mcnlsx
#define sy mcnlsy
#define sz mcnlsz
#define p mcnlp

#define mcabsorbComp mcabsorbCompchannel_17_analyzer_1_array_crystal_array_7
  STORE_NEUTRON(783,
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp);
  mcScattered=0;
  mcRestore=0;
  mcNCounter[783]++;
  mcPCounter[783] += p;
  mcP2Counter[783] += p*p;
#define mccompcurname  channel_17_analyzer_1_array_crystal_array_7
#define mccompcurtype  Union_box
#define mccompcurindex 783
#define loop_index mccchannel_17_analyzer_1_array_crystal_array_7_loop_index
#define this_box_volume mccchannel_17_analyzer_1_array_crystal_array_7_this_box_volume
#define global_geometry_element mccchannel_17_analyzer_1_array_crystal_array_7_global_geometry_element
#define this_box_storage mccchannel_17_analyzer_1_array_crystal_array_7_this_box_storage
{   /* Declarations of channel_17_analyzer_1_array_crystal_array_7=Union_box() SETTING parameters. */
char* material_string = mccchannel_17_analyzer_1_array_crystal_array_7_material_string;
MCNUM priority = mccchannel_17_analyzer_1_array_crystal_array_7_priority;
MCNUM xwidth = mccchannel_17_analyzer_1_array_crystal_array_7_xwidth;
MCNUM yheight = mccchannel_17_analyzer_1_array_crystal_array_7_yheight;
MCNUM zdepth = mccchannel_17_analyzer_1_array_crystal_array_7_zdepth;
MCNUM xwidth2 = mccchannel_17_analyzer_1_array_crystal_array_7_xwidth2;
MCNUM yheight2 = mccchannel_17_analyzer_1_array_crystal_array_7_yheight2;
MCNUM visualize = mccchannel_17_analyzer_1_array_crystal_array_7_visualize;
int target_index = mccchannel_17_analyzer_1_array_crystal_array_7_target_index;
MCNUM target_x = mccchannel_17_analyzer_1_array_crystal_array_7_target_x;
MCNUM target_y = mccchannel_17_analyzer_1_array_crystal_array_7_target_y;
MCNUM target_z = mccchannel_17_analyzer_1_array_crystal_array_7_target_z;
MCNUM focus_aw = mccchannel_17_analyzer_1_array_crystal_array_7_focus_aw;
MCNUM focus_ah = mccchannel_17_analyzer_1_array_crystal_array_7_focus_ah;
MCNUM focus_xw = mccchannel_17_analyzer_1_array_crystal_array_7_focus_xw;
MCNUM focus_xh = mccchannel_17_analyzer_1_array_crystal_array_7_focus_xh;
MCNUM focus_r = mccchannel_17_analyzer_1_array_crystal_array_7_focus_r;
MCNUM p_interact = mccchannel_17_analyzer_1_array_crystal_array_7_p_interact;
char* mask_string = mccchannel_17_analyzer_1_array_crystal_array_7_mask_string;
char* mask_setting = mccchannel_17_analyzer_1_array_crystal_array_7_mask_setting;
MCNUM number_of_activations = mccchannel_17_analyzer_1_array_crystal_array_7_number_of_activations;
}   /* End of channel_17_analyzer_1_array_crystal_array_7=Union_box() SETTING parameter declarations. */
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex
  /* Label for restoring  neutron */
  mcabsorbCompchannel_17_analyzer_1_array_crystal_array_7:
  if (RESTORE) /* restore if needed */
  { RESTORE_NEUTRON(783,
      mcnlx,
      mcnly,
      mcnlz,
      mcnlvx,
      mcnlvy,
      mcnlvz,
      mcnlt,
      mcnlsx,
      mcnlsy,
      mcnlsz,
      mcnlp); }
#undef mcabsorbComp
#undef p
#undef sz
#undef sy
#undef sx
#undef t
#undef vz
#undef vy
#undef vx
#undef z
#undef y
#undef x
  mcDEBUG_STATE(
mcnlx,
mcnly,
mcnlz,
mcnlvx,
mcnlvy,
mcnlvz,
mcnlt,
mcnlsx,
mcnlsy,
mcnlsz,
mcnlp)

  /* TRACE Component channel_17_analyzer_1_array_crystal_array_8 [784] */
  mccoordschange(mcposrchannel_17_analyzer_1_array_crystal_array_8, mcrotrchannel_17_analyzer_1_array_crystal_array_8,
    &mcnlx,
    &mcnly,
    &mcnlz,
    &mcnlvx,
    &mcnlvy,
    &mcnlvz,
    &mcnlsx,
    &mcnlsy,
    &mcnlsz);
  /* define label inside component channel_17_analyzer_1_array_crystal_array_8 (without coords transformations) */
  mcJumpTrace_channel_17_analyzer_1_array_crystal_array_8:
  SIG_MESSAGE("channel_17_analyzer_1_array_crystal_array_8 (Trace)");
  mcDEBUG_COMP("channel_17_analyzer_1_array_crystal_array_8")
  mcDEBUG_STATE(
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp)
#define x mcnlx
#define y mcnly
#define z mcnlz
#define vx mcnlvx
#define vy mcnlvy
#define vz mcnlvz
#define t mcnlt
#define sx mcnlsx
#define sy mcnlsy
#define sz mcnlsz
#define p mcnlp

#define mcabsorbComp mcabsorbCompchannel_17_analyzer_1_array_crystal_array_8
  STORE_NEUTRON(784,
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp);
  mcScattered=0;
  mcRestore=0;
  mcNCounter[784]++;
  mcPCounter[784] += p;
  mcP2Counter[784] += p*p;
#define mccompcurname  channel_17_analyzer_1_array_crystal_array_8
#define mccompcurtype  Union_box
#define mccompcurindex 784
#define loop_index mccchannel_17_analyzer_1_array_crystal_array_8_loop_index
#define this_box_volume mccchannel_17_analyzer_1_array_crystal_array_8_this_box_volume
#define global_geometry_element mccchannel_17_analyzer_1_array_crystal_array_8_global_geometry_element
#define this_box_storage mccchannel_17_analyzer_1_array_crystal_array_8_this_box_storage
{   /* Declarations of channel_17_analyzer_1_array_crystal_array_8=Union_box() SETTING parameters. */
char* material_string = mccchannel_17_analyzer_1_array_crystal_array_8_material_string;
MCNUM priority = mccchannel_17_analyzer_1_array_crystal_array_8_priority;
MCNUM xwidth = mccchannel_17_analyzer_1_array_crystal_array_8_xwidth;
MCNUM yheight = mccchannel_17_analyzer_1_array_crystal_array_8_yheight;
MCNUM zdepth = mccchannel_17_analyzer_1_array_crystal_array_8_zdepth;
MCNUM xwidth2 = mccchannel_17_analyzer_1_array_crystal_array_8_xwidth2;
MCNUM yheight2 = mccchannel_17_analyzer_1_array_crystal_array_8_yheight2;
MCNUM visualize = mccchannel_17_analyzer_1_array_crystal_array_8_visualize;
int target_index = mccchannel_17_analyzer_1_array_crystal_array_8_target_index;
MCNUM target_x = mccchannel_17_analyzer_1_array_crystal_array_8_target_x;
MCNUM target_y = mccchannel_17_analyzer_1_array_crystal_array_8_target_y;
MCNUM target_z = mccchannel_17_analyzer_1_array_crystal_array_8_target_z;
MCNUM focus_aw = mccchannel_17_analyzer_1_array_crystal_array_8_focus_aw;
MCNUM focus_ah = mccchannel_17_analyzer_1_array_crystal_array_8_focus_ah;
MCNUM focus_xw = mccchannel_17_analyzer_1_array_crystal_array_8_focus_xw;
MCNUM focus_xh = mccchannel_17_analyzer_1_array_crystal_array_8_focus_xh;
MCNUM focus_r = mccchannel_17_analyzer_1_array_crystal_array_8_focus_r;
MCNUM p_interact = mccchannel_17_analyzer_1_array_crystal_array_8_p_interact;
char* mask_string = mccchannel_17_analyzer_1_array_crystal_array_8_mask_string;
char* mask_setting = mccchannel_17_analyzer_1_array_crystal_array_8_mask_setting;
MCNUM number_of_activations = mccchannel_17_analyzer_1_array_crystal_array_8_number_of_activations;
}   /* End of channel_17_analyzer_1_array_crystal_array_8=Union_box() SETTING parameter declarations. */
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex
  /* Label for restoring  neutron */
  mcabsorbCompchannel_17_analyzer_1_array_crystal_array_8:
  if (RESTORE) /* restore if needed */
  { RESTORE_NEUTRON(784,
      mcnlx,
      mcnly,
      mcnlz,
      mcnlvx,
      mcnlvy,
      mcnlvz,
      mcnlt,
      mcnlsx,
      mcnlsy,
      mcnlsz,
      mcnlp); }
#undef mcabsorbComp
#undef p
#undef sz
#undef sy
#undef sx
#undef t
#undef vz
#undef vy
#undef vx
#undef z
#undef y
#undef x
  mcDEBUG_STATE(
mcnlx,
mcnly,
mcnlz,
mcnlvx,
mcnlvy,
mcnlvz,
mcnlt,
mcnlsx,
mcnlsy,
mcnlsz,
mcnlp)

  /* TRACE Component channel_17_analyzer_2_center [785] */
  mccoordschange(mcposrchannel_17_analyzer_2_center, mcrotrchannel_17_analyzer_2_center,
    &mcnlx,
    &mcnly,
    &mcnlz,
    &mcnlvx,
    &mcnlvy,
    &mcnlvz,
    &mcnlsx,
    &mcnlsy,
    &mcnlsz);
  /* define label inside component channel_17_analyzer_2_center (without coords transformations) */
  mcJumpTrace_channel_17_analyzer_2_center:
  SIG_MESSAGE("channel_17_analyzer_2_center (Trace)");
  mcDEBUG_COMP("channel_17_analyzer_2_center")
  mcDEBUG_STATE(
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp)
#define x mcnlx
#define y mcnly
#define z mcnlz
#define vx mcnlvx
#define vy mcnlvy
#define vz mcnlvz
#define t mcnlt
#define sx mcnlsx
#define sy mcnlsy
#define sz mcnlsz
#define p mcnlp

#define mcabsorbComp mcabsorbCompchannel_17_analyzer_2_center
  STORE_NEUTRON(785,
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp);
  mcScattered=0;
  mcRestore=0;
  mcNCounter[785]++;
  mcPCounter[785] += p;
  mcP2Counter[785] += p*p;
#define mccompcurname  channel_17_analyzer_2_center
#define mccompcurtype  Arm
#define mccompcurindex 785
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex
  /* Label for restoring  neutron */
  mcabsorbCompchannel_17_analyzer_2_center:
  if (RESTORE) /* restore if needed */
  { RESTORE_NEUTRON(785,
      mcnlx,
      mcnly,
      mcnlz,
      mcnlvx,
      mcnlvy,
      mcnlvz,
      mcnlt,
      mcnlsx,
      mcnlsy,
      mcnlsz,
      mcnlp); }
#undef mcabsorbComp
#undef p
#undef sz
#undef sy
#undef sx
#undef t
#undef vz
#undef vy
#undef vx
#undef z
#undef y
#undef x
  mcDEBUG_STATE(
mcnlx,
mcnly,
mcnlz,
mcnlvx,
mcnlvy,
mcnlvz,
mcnlt,
mcnlsx,
mcnlsy,
mcnlsz,
mcnlp)

  /* TRACE Component channel_17_analyzer_2_rotated [786] */
  mccoordschange(mcposrchannel_17_analyzer_2_rotated, mcrotrchannel_17_analyzer_2_rotated,
    &mcnlx,
    &mcnly,
    &mcnlz,
    &mcnlvx,
    &mcnlvy,
    &mcnlvz,
    &mcnlsx,
    &mcnlsy,
    &mcnlsz);
  /* define label inside component channel_17_analyzer_2_rotated (without coords transformations) */
  mcJumpTrace_channel_17_analyzer_2_rotated:
  SIG_MESSAGE("channel_17_analyzer_2_rotated (Trace)");
  mcDEBUG_COMP("channel_17_analyzer_2_rotated")
  mcDEBUG_STATE(
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp)
#define x mcnlx
#define y mcnly
#define z mcnlz
#define vx mcnlvx
#define vy mcnlvy
#define vz mcnlvz
#define t mcnlt
#define sx mcnlsx
#define sy mcnlsy
#define sz mcnlsz
#define p mcnlp

#define mcabsorbComp mcabsorbCompchannel_17_analyzer_2_rotated
  STORE_NEUTRON(786,
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp);
  mcScattered=0;
  mcRestore=0;
  mcNCounter[786]++;
  mcPCounter[786] += p;
  mcP2Counter[786] += p*p;
#define mccompcurname  channel_17_analyzer_2_rotated
#define mccompcurtype  Arm
#define mccompcurindex 786
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex
  /* Label for restoring  neutron */
  mcabsorbCompchannel_17_analyzer_2_rotated:
  if (RESTORE) /* restore if needed */
  { RESTORE_NEUTRON(786,
      mcnlx,
      mcnly,
      mcnlz,
      mcnlvx,
      mcnlvy,
      mcnlvz,
      mcnlt,
      mcnlsx,
      mcnlsy,
      mcnlsz,
      mcnlp); }
#undef mcabsorbComp
#undef p
#undef sz
#undef sy
#undef sx
#undef t
#undef vz
#undef vy
#undef vx
#undef z
#undef y
#undef x
  mcDEBUG_STATE(
mcnlx,
mcnly,
mcnlz,
mcnlvx,
mcnlvy,
mcnlvz,
mcnlt,
mcnlsx,
mcnlsy,
mcnlsz,
mcnlp)

  /* TRACE Component channel_17_analyzer_2_array_crystal_array_0 [787] */
  mccoordschange(mcposrchannel_17_analyzer_2_array_crystal_array_0, mcrotrchannel_17_analyzer_2_array_crystal_array_0,
    &mcnlx,
    &mcnly,
    &mcnlz,
    &mcnlvx,
    &mcnlvy,
    &mcnlvz,
    &mcnlsx,
    &mcnlsy,
    &mcnlsz);
  /* define label inside component channel_17_analyzer_2_array_crystal_array_0 (without coords transformations) */
  mcJumpTrace_channel_17_analyzer_2_array_crystal_array_0:
  SIG_MESSAGE("channel_17_analyzer_2_array_crystal_array_0 (Trace)");
  mcDEBUG_COMP("channel_17_analyzer_2_array_crystal_array_0")
  mcDEBUG_STATE(
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp)
#define x mcnlx
#define y mcnly
#define z mcnlz
#define vx mcnlvx
#define vy mcnlvy
#define vz mcnlvz
#define t mcnlt
#define sx mcnlsx
#define sy mcnlsy
#define sz mcnlsz
#define p mcnlp

#define mcabsorbComp mcabsorbCompchannel_17_analyzer_2_array_crystal_array_0
  STORE_NEUTRON(787,
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp);
  mcScattered=0;
  mcRestore=0;
  mcNCounter[787]++;
  mcPCounter[787] += p;
  mcP2Counter[787] += p*p;
#define mccompcurname  channel_17_analyzer_2_array_crystal_array_0
#define mccompcurtype  Union_box
#define mccompcurindex 787
#define loop_index mccchannel_17_analyzer_2_array_crystal_array_0_loop_index
#define this_box_volume mccchannel_17_analyzer_2_array_crystal_array_0_this_box_volume
#define global_geometry_element mccchannel_17_analyzer_2_array_crystal_array_0_global_geometry_element
#define this_box_storage mccchannel_17_analyzer_2_array_crystal_array_0_this_box_storage
{   /* Declarations of channel_17_analyzer_2_array_crystal_array_0=Union_box() SETTING parameters. */
char* material_string = mccchannel_17_analyzer_2_array_crystal_array_0_material_string;
MCNUM priority = mccchannel_17_analyzer_2_array_crystal_array_0_priority;
MCNUM xwidth = mccchannel_17_analyzer_2_array_crystal_array_0_xwidth;
MCNUM yheight = mccchannel_17_analyzer_2_array_crystal_array_0_yheight;
MCNUM zdepth = mccchannel_17_analyzer_2_array_crystal_array_0_zdepth;
MCNUM xwidth2 = mccchannel_17_analyzer_2_array_crystal_array_0_xwidth2;
MCNUM yheight2 = mccchannel_17_analyzer_2_array_crystal_array_0_yheight2;
MCNUM visualize = mccchannel_17_analyzer_2_array_crystal_array_0_visualize;
int target_index = mccchannel_17_analyzer_2_array_crystal_array_0_target_index;
MCNUM target_x = mccchannel_17_analyzer_2_array_crystal_array_0_target_x;
MCNUM target_y = mccchannel_17_analyzer_2_array_crystal_array_0_target_y;
MCNUM target_z = mccchannel_17_analyzer_2_array_crystal_array_0_target_z;
MCNUM focus_aw = mccchannel_17_analyzer_2_array_crystal_array_0_focus_aw;
MCNUM focus_ah = mccchannel_17_analyzer_2_array_crystal_array_0_focus_ah;
MCNUM focus_xw = mccchannel_17_analyzer_2_array_crystal_array_0_focus_xw;
MCNUM focus_xh = mccchannel_17_analyzer_2_array_crystal_array_0_focus_xh;
MCNUM focus_r = mccchannel_17_analyzer_2_array_crystal_array_0_focus_r;
MCNUM p_interact = mccchannel_17_analyzer_2_array_crystal_array_0_p_interact;
char* mask_string = mccchannel_17_analyzer_2_array_crystal_array_0_mask_string;
char* mask_setting = mccchannel_17_analyzer_2_array_crystal_array_0_mask_setting;
MCNUM number_of_activations = mccchannel_17_analyzer_2_array_crystal_array_0_number_of_activations;
}   /* End of channel_17_analyzer_2_array_crystal_array_0=Union_box() SETTING parameter declarations. */
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex
  /* Label for restoring  neutron */
  mcabsorbCompchannel_17_analyzer_2_array_crystal_array_0:
  if (RESTORE) /* restore if needed */
  { RESTORE_NEUTRON(787,
      mcnlx,
      mcnly,
      mcnlz,
      mcnlvx,
      mcnlvy,
      mcnlvz,
      mcnlt,
      mcnlsx,
      mcnlsy,
      mcnlsz,
      mcnlp); }
#undef mcabsorbComp
#undef p
#undef sz
#undef sy
#undef sx
#undef t
#undef vz
#undef vy
#undef vx
#undef z
#undef y
#undef x
  mcDEBUG_STATE(
mcnlx,
mcnly,
mcnlz,
mcnlvx,
mcnlvy,
mcnlvz,
mcnlt,
mcnlsx,
mcnlsy,
mcnlsz,
mcnlp)

  /* TRACE Component channel_17_analyzer_2_array_crystal_array_1 [788] */
  mccoordschange(mcposrchannel_17_analyzer_2_array_crystal_array_1, mcrotrchannel_17_analyzer_2_array_crystal_array_1,
    &mcnlx,
    &mcnly,
    &mcnlz,
    &mcnlvx,
    &mcnlvy,
    &mcnlvz,
    &mcnlsx,
    &mcnlsy,
    &mcnlsz);
  /* define label inside component channel_17_analyzer_2_array_crystal_array_1 (without coords transformations) */
  mcJumpTrace_channel_17_analyzer_2_array_crystal_array_1:
  SIG_MESSAGE("channel_17_analyzer_2_array_crystal_array_1 (Trace)");
  mcDEBUG_COMP("channel_17_analyzer_2_array_crystal_array_1")
  mcDEBUG_STATE(
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp)
#define x mcnlx
#define y mcnly
#define z mcnlz
#define vx mcnlvx
#define vy mcnlvy
#define vz mcnlvz
#define t mcnlt
#define sx mcnlsx
#define sy mcnlsy
#define sz mcnlsz
#define p mcnlp

#define mcabsorbComp mcabsorbCompchannel_17_analyzer_2_array_crystal_array_1
  STORE_NEUTRON(788,
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp);
  mcScattered=0;
  mcRestore=0;
  mcNCounter[788]++;
  mcPCounter[788] += p;
  mcP2Counter[788] += p*p;
#define mccompcurname  channel_17_analyzer_2_array_crystal_array_1
#define mccompcurtype  Union_box
#define mccompcurindex 788
#define loop_index mccchannel_17_analyzer_2_array_crystal_array_1_loop_index
#define this_box_volume mccchannel_17_analyzer_2_array_crystal_array_1_this_box_volume
#define global_geometry_element mccchannel_17_analyzer_2_array_crystal_array_1_global_geometry_element
#define this_box_storage mccchannel_17_analyzer_2_array_crystal_array_1_this_box_storage
{   /* Declarations of channel_17_analyzer_2_array_crystal_array_1=Union_box() SETTING parameters. */
char* material_string = mccchannel_17_analyzer_2_array_crystal_array_1_material_string;
MCNUM priority = mccchannel_17_analyzer_2_array_crystal_array_1_priority;
MCNUM xwidth = mccchannel_17_analyzer_2_array_crystal_array_1_xwidth;
MCNUM yheight = mccchannel_17_analyzer_2_array_crystal_array_1_yheight;
MCNUM zdepth = mccchannel_17_analyzer_2_array_crystal_array_1_zdepth;
MCNUM xwidth2 = mccchannel_17_analyzer_2_array_crystal_array_1_xwidth2;
MCNUM yheight2 = mccchannel_17_analyzer_2_array_crystal_array_1_yheight2;
MCNUM visualize = mccchannel_17_analyzer_2_array_crystal_array_1_visualize;
int target_index = mccchannel_17_analyzer_2_array_crystal_array_1_target_index;
MCNUM target_x = mccchannel_17_analyzer_2_array_crystal_array_1_target_x;
MCNUM target_y = mccchannel_17_analyzer_2_array_crystal_array_1_target_y;
MCNUM target_z = mccchannel_17_analyzer_2_array_crystal_array_1_target_z;
MCNUM focus_aw = mccchannel_17_analyzer_2_array_crystal_array_1_focus_aw;
MCNUM focus_ah = mccchannel_17_analyzer_2_array_crystal_array_1_focus_ah;
MCNUM focus_xw = mccchannel_17_analyzer_2_array_crystal_array_1_focus_xw;
MCNUM focus_xh = mccchannel_17_analyzer_2_array_crystal_array_1_focus_xh;
MCNUM focus_r = mccchannel_17_analyzer_2_array_crystal_array_1_focus_r;
MCNUM p_interact = mccchannel_17_analyzer_2_array_crystal_array_1_p_interact;
char* mask_string = mccchannel_17_analyzer_2_array_crystal_array_1_mask_string;
char* mask_setting = mccchannel_17_analyzer_2_array_crystal_array_1_mask_setting;
MCNUM number_of_activations = mccchannel_17_analyzer_2_array_crystal_array_1_number_of_activations;
}   /* End of channel_17_analyzer_2_array_crystal_array_1=Union_box() SETTING parameter declarations. */
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex
  /* Label for restoring  neutron */
  mcabsorbCompchannel_17_analyzer_2_array_crystal_array_1:
  if (RESTORE) /* restore if needed */
  { RESTORE_NEUTRON(788,
      mcnlx,
      mcnly,
      mcnlz,
      mcnlvx,
      mcnlvy,
      mcnlvz,
      mcnlt,
      mcnlsx,
      mcnlsy,
      mcnlsz,
      mcnlp); }
#undef mcabsorbComp
#undef p
#undef sz
#undef sy
#undef sx
#undef t
#undef vz
#undef vy
#undef vx
#undef z
#undef y
#undef x
  mcDEBUG_STATE(
mcnlx,
mcnly,
mcnlz,
mcnlvx,
mcnlvy,
mcnlvz,
mcnlt,
mcnlsx,
mcnlsy,
mcnlsz,
mcnlp)

  /* TRACE Component channel_17_analyzer_2_array_crystal_array_2 [789] */
  mccoordschange(mcposrchannel_17_analyzer_2_array_crystal_array_2, mcrotrchannel_17_analyzer_2_array_crystal_array_2,
    &mcnlx,
    &mcnly,
    &mcnlz,
    &mcnlvx,
    &mcnlvy,
    &mcnlvz,
    &mcnlsx,
    &mcnlsy,
    &mcnlsz);
  /* define label inside component channel_17_analyzer_2_array_crystal_array_2 (without coords transformations) */
  mcJumpTrace_channel_17_analyzer_2_array_crystal_array_2:
  SIG_MESSAGE("channel_17_analyzer_2_array_crystal_array_2 (Trace)");
  mcDEBUG_COMP("channel_17_analyzer_2_array_crystal_array_2")
  mcDEBUG_STATE(
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp)
#define x mcnlx
#define y mcnly
#define z mcnlz
#define vx mcnlvx
#define vy mcnlvy
#define vz mcnlvz
#define t mcnlt
#define sx mcnlsx
#define sy mcnlsy
#define sz mcnlsz
#define p mcnlp

#define mcabsorbComp mcabsorbCompchannel_17_analyzer_2_array_crystal_array_2
  STORE_NEUTRON(789,
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp);
  mcScattered=0;
  mcRestore=0;
  mcNCounter[789]++;
  mcPCounter[789] += p;
  mcP2Counter[789] += p*p;
#define mccompcurname  channel_17_analyzer_2_array_crystal_array_2
#define mccompcurtype  Union_box
#define mccompcurindex 789
#define loop_index mccchannel_17_analyzer_2_array_crystal_array_2_loop_index
#define this_box_volume mccchannel_17_analyzer_2_array_crystal_array_2_this_box_volume
#define global_geometry_element mccchannel_17_analyzer_2_array_crystal_array_2_global_geometry_element
#define this_box_storage mccchannel_17_analyzer_2_array_crystal_array_2_this_box_storage
{   /* Declarations of channel_17_analyzer_2_array_crystal_array_2=Union_box() SETTING parameters. */
char* material_string = mccchannel_17_analyzer_2_array_crystal_array_2_material_string;
MCNUM priority = mccchannel_17_analyzer_2_array_crystal_array_2_priority;
MCNUM xwidth = mccchannel_17_analyzer_2_array_crystal_array_2_xwidth;
MCNUM yheight = mccchannel_17_analyzer_2_array_crystal_array_2_yheight;
MCNUM zdepth = mccchannel_17_analyzer_2_array_crystal_array_2_zdepth;
MCNUM xwidth2 = mccchannel_17_analyzer_2_array_crystal_array_2_xwidth2;
MCNUM yheight2 = mccchannel_17_analyzer_2_array_crystal_array_2_yheight2;
MCNUM visualize = mccchannel_17_analyzer_2_array_crystal_array_2_visualize;
int target_index = mccchannel_17_analyzer_2_array_crystal_array_2_target_index;
MCNUM target_x = mccchannel_17_analyzer_2_array_crystal_array_2_target_x;
MCNUM target_y = mccchannel_17_analyzer_2_array_crystal_array_2_target_y;
MCNUM target_z = mccchannel_17_analyzer_2_array_crystal_array_2_target_z;
MCNUM focus_aw = mccchannel_17_analyzer_2_array_crystal_array_2_focus_aw;
MCNUM focus_ah = mccchannel_17_analyzer_2_array_crystal_array_2_focus_ah;
MCNUM focus_xw = mccchannel_17_analyzer_2_array_crystal_array_2_focus_xw;
MCNUM focus_xh = mccchannel_17_analyzer_2_array_crystal_array_2_focus_xh;
MCNUM focus_r = mccchannel_17_analyzer_2_array_crystal_array_2_focus_r;
MCNUM p_interact = mccchannel_17_analyzer_2_array_crystal_array_2_p_interact;
char* mask_string = mccchannel_17_analyzer_2_array_crystal_array_2_mask_string;
char* mask_setting = mccchannel_17_analyzer_2_array_crystal_array_2_mask_setting;
MCNUM number_of_activations = mccchannel_17_analyzer_2_array_crystal_array_2_number_of_activations;
}   /* End of channel_17_analyzer_2_array_crystal_array_2=Union_box() SETTING parameter declarations. */
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex
  /* Label for restoring  neutron */
  mcabsorbCompchannel_17_analyzer_2_array_crystal_array_2:
  if (RESTORE) /* restore if needed */
  { RESTORE_NEUTRON(789,
      mcnlx,
      mcnly,
      mcnlz,
      mcnlvx,
      mcnlvy,
      mcnlvz,
      mcnlt,
      mcnlsx,
      mcnlsy,
      mcnlsz,
      mcnlp); }
#undef mcabsorbComp
#undef p
#undef sz
#undef sy
#undef sx
#undef t
#undef vz
#undef vy
#undef vx
#undef z
#undef y
#undef x
  mcDEBUG_STATE(
mcnlx,
mcnly,
mcnlz,
mcnlvx,
mcnlvy,
mcnlvz,
mcnlt,
mcnlsx,
mcnlsy,
mcnlsz,
mcnlp)

  /* TRACE Component channel_17_analyzer_2_array_crystal_array_3 [790] */
  mccoordschange(mcposrchannel_17_analyzer_2_array_crystal_array_3, mcrotrchannel_17_analyzer_2_array_crystal_array_3,
    &mcnlx,
    &mcnly,
    &mcnlz,
    &mcnlvx,
    &mcnlvy,
    &mcnlvz,
    &mcnlsx,
    &mcnlsy,
    &mcnlsz);
  /* define label inside component channel_17_analyzer_2_array_crystal_array_3 (without coords transformations) */
  mcJumpTrace_channel_17_analyzer_2_array_crystal_array_3:
  SIG_MESSAGE("channel_17_analyzer_2_array_crystal_array_3 (Trace)");
  mcDEBUG_COMP("channel_17_analyzer_2_array_crystal_array_3")
  mcDEBUG_STATE(
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp)
#define x mcnlx
#define y mcnly
#define z mcnlz
#define vx mcnlvx
#define vy mcnlvy
#define vz mcnlvz
#define t mcnlt
#define sx mcnlsx
#define sy mcnlsy
#define sz mcnlsz
#define p mcnlp

#define mcabsorbComp mcabsorbCompchannel_17_analyzer_2_array_crystal_array_3
  STORE_NEUTRON(790,
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp);
  mcScattered=0;
  mcRestore=0;
  mcNCounter[790]++;
  mcPCounter[790] += p;
  mcP2Counter[790] += p*p;
#define mccompcurname  channel_17_analyzer_2_array_crystal_array_3
#define mccompcurtype  Union_box
#define mccompcurindex 790
#define loop_index mccchannel_17_analyzer_2_array_crystal_array_3_loop_index
#define this_box_volume mccchannel_17_analyzer_2_array_crystal_array_3_this_box_volume
#define global_geometry_element mccchannel_17_analyzer_2_array_crystal_array_3_global_geometry_element
#define this_box_storage mccchannel_17_analyzer_2_array_crystal_array_3_this_box_storage
{   /* Declarations of channel_17_analyzer_2_array_crystal_array_3=Union_box() SETTING parameters. */
char* material_string = mccchannel_17_analyzer_2_array_crystal_array_3_material_string;
MCNUM priority = mccchannel_17_analyzer_2_array_crystal_array_3_priority;
MCNUM xwidth = mccchannel_17_analyzer_2_array_crystal_array_3_xwidth;
MCNUM yheight = mccchannel_17_analyzer_2_array_crystal_array_3_yheight;
MCNUM zdepth = mccchannel_17_analyzer_2_array_crystal_array_3_zdepth;
MCNUM xwidth2 = mccchannel_17_analyzer_2_array_crystal_array_3_xwidth2;
MCNUM yheight2 = mccchannel_17_analyzer_2_array_crystal_array_3_yheight2;
MCNUM visualize = mccchannel_17_analyzer_2_array_crystal_array_3_visualize;
int target_index = mccchannel_17_analyzer_2_array_crystal_array_3_target_index;
MCNUM target_x = mccchannel_17_analyzer_2_array_crystal_array_3_target_x;
MCNUM target_y = mccchannel_17_analyzer_2_array_crystal_array_3_target_y;
MCNUM target_z = mccchannel_17_analyzer_2_array_crystal_array_3_target_z;
MCNUM focus_aw = mccchannel_17_analyzer_2_array_crystal_array_3_focus_aw;
MCNUM focus_ah = mccchannel_17_analyzer_2_array_crystal_array_3_focus_ah;
MCNUM focus_xw = mccchannel_17_analyzer_2_array_crystal_array_3_focus_xw;
MCNUM focus_xh = mccchannel_17_analyzer_2_array_crystal_array_3_focus_xh;
MCNUM focus_r = mccchannel_17_analyzer_2_array_crystal_array_3_focus_r;
MCNUM p_interact = mccchannel_17_analyzer_2_array_crystal_array_3_p_interact;
char* mask_string = mccchannel_17_analyzer_2_array_crystal_array_3_mask_string;
char* mask_setting = mccchannel_17_analyzer_2_array_crystal_array_3_mask_setting;
MCNUM number_of_activations = mccchannel_17_analyzer_2_array_crystal_array_3_number_of_activations;
}   /* End of channel_17_analyzer_2_array_crystal_array_3=Union_box() SETTING parameter declarations. */
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex
  /* Label for restoring  neutron */
  mcabsorbCompchannel_17_analyzer_2_array_crystal_array_3:
  if (RESTORE) /* restore if needed */
  { RESTORE_NEUTRON(790,
      mcnlx,
      mcnly,
      mcnlz,
      mcnlvx,
      mcnlvy,
      mcnlvz,
      mcnlt,
      mcnlsx,
      mcnlsy,
      mcnlsz,
      mcnlp); }
#undef mcabsorbComp
#undef p
#undef sz
#undef sy
#undef sx
#undef t
#undef vz
#undef vy
#undef vx
#undef z
#undef y
#undef x
  mcDEBUG_STATE(
mcnlx,
mcnly,
mcnlz,
mcnlvx,
mcnlvy,
mcnlvz,
mcnlt,
mcnlsx,
mcnlsy,
mcnlsz,
mcnlp)

  /* TRACE Component channel_17_analyzer_2_array_crystal_array_4 [791] */
  mccoordschange(mcposrchannel_17_analyzer_2_array_crystal_array_4, mcrotrchannel_17_analyzer_2_array_crystal_array_4,
    &mcnlx,
    &mcnly,
    &mcnlz,
    &mcnlvx,
    &mcnlvy,
    &mcnlvz,
    &mcnlsx,
    &mcnlsy,
    &mcnlsz);
  /* define label inside component channel_17_analyzer_2_array_crystal_array_4 (without coords transformations) */
  mcJumpTrace_channel_17_analyzer_2_array_crystal_array_4:
  SIG_MESSAGE("channel_17_analyzer_2_array_crystal_array_4 (Trace)");
  mcDEBUG_COMP("channel_17_analyzer_2_array_crystal_array_4")
  mcDEBUG_STATE(
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp)
#define x mcnlx
#define y mcnly
#define z mcnlz
#define vx mcnlvx
#define vy mcnlvy
#define vz mcnlvz
#define t mcnlt
#define sx mcnlsx
#define sy mcnlsy
#define sz mcnlsz
#define p mcnlp

#define mcabsorbComp mcabsorbCompchannel_17_analyzer_2_array_crystal_array_4
  STORE_NEUTRON(791,
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp);
  mcScattered=0;
  mcRestore=0;
  mcNCounter[791]++;
  mcPCounter[791] += p;
  mcP2Counter[791] += p*p;
#define mccompcurname  channel_17_analyzer_2_array_crystal_array_4
#define mccompcurtype  Union_box
#define mccompcurindex 791
#define loop_index mccchannel_17_analyzer_2_array_crystal_array_4_loop_index
#define this_box_volume mccchannel_17_analyzer_2_array_crystal_array_4_this_box_volume
#define global_geometry_element mccchannel_17_analyzer_2_array_crystal_array_4_global_geometry_element
#define this_box_storage mccchannel_17_analyzer_2_array_crystal_array_4_this_box_storage
{   /* Declarations of channel_17_analyzer_2_array_crystal_array_4=Union_box() SETTING parameters. */
char* material_string = mccchannel_17_analyzer_2_array_crystal_array_4_material_string;
MCNUM priority = mccchannel_17_analyzer_2_array_crystal_array_4_priority;
MCNUM xwidth = mccchannel_17_analyzer_2_array_crystal_array_4_xwidth;
MCNUM yheight = mccchannel_17_analyzer_2_array_crystal_array_4_yheight;
MCNUM zdepth = mccchannel_17_analyzer_2_array_crystal_array_4_zdepth;
MCNUM xwidth2 = mccchannel_17_analyzer_2_array_crystal_array_4_xwidth2;
MCNUM yheight2 = mccchannel_17_analyzer_2_array_crystal_array_4_yheight2;
MCNUM visualize = mccchannel_17_analyzer_2_array_crystal_array_4_visualize;
int target_index = mccchannel_17_analyzer_2_array_crystal_array_4_target_index;
MCNUM target_x = mccchannel_17_analyzer_2_array_crystal_array_4_target_x;
MCNUM target_y = mccchannel_17_analyzer_2_array_crystal_array_4_target_y;
MCNUM target_z = mccchannel_17_analyzer_2_array_crystal_array_4_target_z;
MCNUM focus_aw = mccchannel_17_analyzer_2_array_crystal_array_4_focus_aw;
MCNUM focus_ah = mccchannel_17_analyzer_2_array_crystal_array_4_focus_ah;
MCNUM focus_xw = mccchannel_17_analyzer_2_array_crystal_array_4_focus_xw;
MCNUM focus_xh = mccchannel_17_analyzer_2_array_crystal_array_4_focus_xh;
MCNUM focus_r = mccchannel_17_analyzer_2_array_crystal_array_4_focus_r;
MCNUM p_interact = mccchannel_17_analyzer_2_array_crystal_array_4_p_interact;
char* mask_string = mccchannel_17_analyzer_2_array_crystal_array_4_mask_string;
char* mask_setting = mccchannel_17_analyzer_2_array_crystal_array_4_mask_setting;
MCNUM number_of_activations = mccchannel_17_analyzer_2_array_crystal_array_4_number_of_activations;
}   /* End of channel_17_analyzer_2_array_crystal_array_4=Union_box() SETTING parameter declarations. */
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex
  /* Label for restoring  neutron */
  mcabsorbCompchannel_17_analyzer_2_array_crystal_array_4:
  if (RESTORE) /* restore if needed */
  { RESTORE_NEUTRON(791,
      mcnlx,
      mcnly,
      mcnlz,
      mcnlvx,
      mcnlvy,
      mcnlvz,
      mcnlt,
      mcnlsx,
      mcnlsy,
      mcnlsz,
      mcnlp); }
#undef mcabsorbComp
#undef p
#undef sz
#undef sy
#undef sx
#undef t
#undef vz
#undef vy
#undef vx
#undef z
#undef y
#undef x
  mcDEBUG_STATE(
mcnlx,
mcnly,
mcnlz,
mcnlvx,
mcnlvy,
mcnlvz,
mcnlt,
mcnlsx,
mcnlsy,
mcnlsz,
mcnlp)

  /* TRACE Component channel_17_analyzer_2_array_crystal_array_5 [792] */
  mccoordschange(mcposrchannel_17_analyzer_2_array_crystal_array_5, mcrotrchannel_17_analyzer_2_array_crystal_array_5,
    &mcnlx,
    &mcnly,
    &mcnlz,
    &mcnlvx,
    &mcnlvy,
    &mcnlvz,
    &mcnlsx,
    &mcnlsy,
    &mcnlsz);
  /* define label inside component channel_17_analyzer_2_array_crystal_array_5 (without coords transformations) */
  mcJumpTrace_channel_17_analyzer_2_array_crystal_array_5:
  SIG_MESSAGE("channel_17_analyzer_2_array_crystal_array_5 (Trace)");
  mcDEBUG_COMP("channel_17_analyzer_2_array_crystal_array_5")
  mcDEBUG_STATE(
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp)
#define x mcnlx
#define y mcnly
#define z mcnlz
#define vx mcnlvx
#define vy mcnlvy
#define vz mcnlvz
#define t mcnlt
#define sx mcnlsx
#define sy mcnlsy
#define sz mcnlsz
#define p mcnlp

#define mcabsorbComp mcabsorbCompchannel_17_analyzer_2_array_crystal_array_5
  STORE_NEUTRON(792,
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp);
  mcScattered=0;
  mcRestore=0;
  mcNCounter[792]++;
  mcPCounter[792] += p;
  mcP2Counter[792] += p*p;
#define mccompcurname  channel_17_analyzer_2_array_crystal_array_5
#define mccompcurtype  Union_box
#define mccompcurindex 792
#define loop_index mccchannel_17_analyzer_2_array_crystal_array_5_loop_index
#define this_box_volume mccchannel_17_analyzer_2_array_crystal_array_5_this_box_volume
#define global_geometry_element mccchannel_17_analyzer_2_array_crystal_array_5_global_geometry_element
#define this_box_storage mccchannel_17_analyzer_2_array_crystal_array_5_this_box_storage
{   /* Declarations of channel_17_analyzer_2_array_crystal_array_5=Union_box() SETTING parameters. */
char* material_string = mccchannel_17_analyzer_2_array_crystal_array_5_material_string;
MCNUM priority = mccchannel_17_analyzer_2_array_crystal_array_5_priority;
MCNUM xwidth = mccchannel_17_analyzer_2_array_crystal_array_5_xwidth;
MCNUM yheight = mccchannel_17_analyzer_2_array_crystal_array_5_yheight;
MCNUM zdepth = mccchannel_17_analyzer_2_array_crystal_array_5_zdepth;
MCNUM xwidth2 = mccchannel_17_analyzer_2_array_crystal_array_5_xwidth2;
MCNUM yheight2 = mccchannel_17_analyzer_2_array_crystal_array_5_yheight2;
MCNUM visualize = mccchannel_17_analyzer_2_array_crystal_array_5_visualize;
int target_index = mccchannel_17_analyzer_2_array_crystal_array_5_target_index;
MCNUM target_x = mccchannel_17_analyzer_2_array_crystal_array_5_target_x;
MCNUM target_y = mccchannel_17_analyzer_2_array_crystal_array_5_target_y;
MCNUM target_z = mccchannel_17_analyzer_2_array_crystal_array_5_target_z;
MCNUM focus_aw = mccchannel_17_analyzer_2_array_crystal_array_5_focus_aw;
MCNUM focus_ah = mccchannel_17_analyzer_2_array_crystal_array_5_focus_ah;
MCNUM focus_xw = mccchannel_17_analyzer_2_array_crystal_array_5_focus_xw;
MCNUM focus_xh = mccchannel_17_analyzer_2_array_crystal_array_5_focus_xh;
MCNUM focus_r = mccchannel_17_analyzer_2_array_crystal_array_5_focus_r;
MCNUM p_interact = mccchannel_17_analyzer_2_array_crystal_array_5_p_interact;
char* mask_string = mccchannel_17_analyzer_2_array_crystal_array_5_mask_string;
char* mask_setting = mccchannel_17_analyzer_2_array_crystal_array_5_mask_setting;
MCNUM number_of_activations = mccchannel_17_analyzer_2_array_crystal_array_5_number_of_activations;
}   /* End of channel_17_analyzer_2_array_crystal_array_5=Union_box() SETTING parameter declarations. */
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex
  /* Label for restoring  neutron */
  mcabsorbCompchannel_17_analyzer_2_array_crystal_array_5:
  if (RESTORE) /* restore if needed */
  { RESTORE_NEUTRON(792,
      mcnlx,
      mcnly,
      mcnlz,
      mcnlvx,
      mcnlvy,
      mcnlvz,
      mcnlt,
      mcnlsx,
      mcnlsy,
      mcnlsz,
      mcnlp); }
#undef mcabsorbComp
#undef p
#undef sz
#undef sy
#undef sx
#undef t
#undef vz
#undef vy
#undef vx
#undef z
#undef y
#undef x
  mcDEBUG_STATE(
mcnlx,
mcnly,
mcnlz,
mcnlvx,
mcnlvy,
mcnlvz,
mcnlt,
mcnlsx,
mcnlsy,
mcnlsz,
mcnlp)

  /* TRACE Component channel_17_analyzer_2_array_crystal_array_6 [793] */
  mccoordschange(mcposrchannel_17_analyzer_2_array_crystal_array_6, mcrotrchannel_17_analyzer_2_array_crystal_array_6,
    &mcnlx,
    &mcnly,
    &mcnlz,
    &mcnlvx,
    &mcnlvy,
    &mcnlvz,
    &mcnlsx,
    &mcnlsy,
    &mcnlsz);
  /* define label inside component channel_17_analyzer_2_array_crystal_array_6 (without coords transformations) */
  mcJumpTrace_channel_17_analyzer_2_array_crystal_array_6:
  SIG_MESSAGE("channel_17_analyzer_2_array_crystal_array_6 (Trace)");
  mcDEBUG_COMP("channel_17_analyzer_2_array_crystal_array_6")
  mcDEBUG_STATE(
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp)
#define x mcnlx
#define y mcnly
#define z mcnlz
#define vx mcnlvx
#define vy mcnlvy
#define vz mcnlvz
#define t mcnlt
#define sx mcnlsx
#define sy mcnlsy
#define sz mcnlsz
#define p mcnlp

#define mcabsorbComp mcabsorbCompchannel_17_analyzer_2_array_crystal_array_6
  STORE_NEUTRON(793,
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp);
  mcScattered=0;
  mcRestore=0;
  mcNCounter[793]++;
  mcPCounter[793] += p;
  mcP2Counter[793] += p*p;
#define mccompcurname  channel_17_analyzer_2_array_crystal_array_6
#define mccompcurtype  Union_box
#define mccompcurindex 793
#define loop_index mccchannel_17_analyzer_2_array_crystal_array_6_loop_index
#define this_box_volume mccchannel_17_analyzer_2_array_crystal_array_6_this_box_volume
#define global_geometry_element mccchannel_17_analyzer_2_array_crystal_array_6_global_geometry_element
#define this_box_storage mccchannel_17_analyzer_2_array_crystal_array_6_this_box_storage
{   /* Declarations of channel_17_analyzer_2_array_crystal_array_6=Union_box() SETTING parameters. */
char* material_string = mccchannel_17_analyzer_2_array_crystal_array_6_material_string;
MCNUM priority = mccchannel_17_analyzer_2_array_crystal_array_6_priority;
MCNUM xwidth = mccchannel_17_analyzer_2_array_crystal_array_6_xwidth;
MCNUM yheight = mccchannel_17_analyzer_2_array_crystal_array_6_yheight;
MCNUM zdepth = mccchannel_17_analyzer_2_array_crystal_array_6_zdepth;
MCNUM xwidth2 = mccchannel_17_analyzer_2_array_crystal_array_6_xwidth2;
MCNUM yheight2 = mccchannel_17_analyzer_2_array_crystal_array_6_yheight2;
MCNUM visualize = mccchannel_17_analyzer_2_array_crystal_array_6_visualize;
int target_index = mccchannel_17_analyzer_2_array_crystal_array_6_target_index;
MCNUM target_x = mccchannel_17_analyzer_2_array_crystal_array_6_target_x;
MCNUM target_y = mccchannel_17_analyzer_2_array_crystal_array_6_target_y;
MCNUM target_z = mccchannel_17_analyzer_2_array_crystal_array_6_target_z;
MCNUM focus_aw = mccchannel_17_analyzer_2_array_crystal_array_6_focus_aw;
MCNUM focus_ah = mccchannel_17_analyzer_2_array_crystal_array_6_focus_ah;
MCNUM focus_xw = mccchannel_17_analyzer_2_array_crystal_array_6_focus_xw;
MCNUM focus_xh = mccchannel_17_analyzer_2_array_crystal_array_6_focus_xh;
MCNUM focus_r = mccchannel_17_analyzer_2_array_crystal_array_6_focus_r;
MCNUM p_interact = mccchannel_17_analyzer_2_array_crystal_array_6_p_interact;
char* mask_string = mccchannel_17_analyzer_2_array_crystal_array_6_mask_string;
char* mask_setting = mccchannel_17_analyzer_2_array_crystal_array_6_mask_setting;
MCNUM number_of_activations = mccchannel_17_analyzer_2_array_crystal_array_6_number_of_activations;
}   /* End of channel_17_analyzer_2_array_crystal_array_6=Union_box() SETTING parameter declarations. */
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex
  /* Label for restoring  neutron */
  mcabsorbCompchannel_17_analyzer_2_array_crystal_array_6:
  if (RESTORE) /* restore if needed */
  { RESTORE_NEUTRON(793,
      mcnlx,
      mcnly,
      mcnlz,
      mcnlvx,
      mcnlvy,
      mcnlvz,
      mcnlt,
      mcnlsx,
      mcnlsy,
      mcnlsz,
      mcnlp); }
#undef mcabsorbComp
#undef p
#undef sz
#undef sy
#undef sx
#undef t
#undef vz
#undef vy
#undef vx
#undef z
#undef y
#undef x
  mcDEBUG_STATE(
mcnlx,
mcnly,
mcnlz,
mcnlvx,
mcnlvy,
mcnlvz,
mcnlt,
mcnlsx,
mcnlsy,
mcnlsz,
mcnlp)

  /* TRACE Component channel_17_analyzer_2_array_crystal_array_7 [794] */
  mccoordschange(mcposrchannel_17_analyzer_2_array_crystal_array_7, mcrotrchannel_17_analyzer_2_array_crystal_array_7,
    &mcnlx,
    &mcnly,
    &mcnlz,
    &mcnlvx,
    &mcnlvy,
    &mcnlvz,
    &mcnlsx,
    &mcnlsy,
    &mcnlsz);
  /* define label inside component channel_17_analyzer_2_array_crystal_array_7 (without coords transformations) */
  mcJumpTrace_channel_17_analyzer_2_array_crystal_array_7:
  SIG_MESSAGE("channel_17_analyzer_2_array_crystal_array_7 (Trace)");
  mcDEBUG_COMP("channel_17_analyzer_2_array_crystal_array_7")
  mcDEBUG_STATE(
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp)
#define x mcnlx
#define y mcnly
#define z mcnlz
#define vx mcnlvx
#define vy mcnlvy
#define vz mcnlvz
#define t mcnlt
#define sx mcnlsx
#define sy mcnlsy
#define sz mcnlsz
#define p mcnlp

#define mcabsorbComp mcabsorbCompchannel_17_analyzer_2_array_crystal_array_7
  STORE_NEUTRON(794,
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp);
  mcScattered=0;
  mcRestore=0;
  mcNCounter[794]++;
  mcPCounter[794] += p;
  mcP2Counter[794] += p*p;
#define mccompcurname  channel_17_analyzer_2_array_crystal_array_7
#define mccompcurtype  Union_box
#define mccompcurindex 794
#define loop_index mccchannel_17_analyzer_2_array_crystal_array_7_loop_index
#define this_box_volume mccchannel_17_analyzer_2_array_crystal_array_7_this_box_volume
#define global_geometry_element mccchannel_17_analyzer_2_array_crystal_array_7_global_geometry_element
#define this_box_storage mccchannel_17_analyzer_2_array_crystal_array_7_this_box_storage
{   /* Declarations of channel_17_analyzer_2_array_crystal_array_7=Union_box() SETTING parameters. */
char* material_string = mccchannel_17_analyzer_2_array_crystal_array_7_material_string;
MCNUM priority = mccchannel_17_analyzer_2_array_crystal_array_7_priority;
MCNUM xwidth = mccchannel_17_analyzer_2_array_crystal_array_7_xwidth;
MCNUM yheight = mccchannel_17_analyzer_2_array_crystal_array_7_yheight;
MCNUM zdepth = mccchannel_17_analyzer_2_array_crystal_array_7_zdepth;
MCNUM xwidth2 = mccchannel_17_analyzer_2_array_crystal_array_7_xwidth2;
MCNUM yheight2 = mccchannel_17_analyzer_2_array_crystal_array_7_yheight2;
MCNUM visualize = mccchannel_17_analyzer_2_array_crystal_array_7_visualize;
int target_index = mccchannel_17_analyzer_2_array_crystal_array_7_target_index;
MCNUM target_x = mccchannel_17_analyzer_2_array_crystal_array_7_target_x;
MCNUM target_y = mccchannel_17_analyzer_2_array_crystal_array_7_target_y;
MCNUM target_z = mccchannel_17_analyzer_2_array_crystal_array_7_target_z;
MCNUM focus_aw = mccchannel_17_analyzer_2_array_crystal_array_7_focus_aw;
MCNUM focus_ah = mccchannel_17_analyzer_2_array_crystal_array_7_focus_ah;
MCNUM focus_xw = mccchannel_17_analyzer_2_array_crystal_array_7_focus_xw;
MCNUM focus_xh = mccchannel_17_analyzer_2_array_crystal_array_7_focus_xh;
MCNUM focus_r = mccchannel_17_analyzer_2_array_crystal_array_7_focus_r;
MCNUM p_interact = mccchannel_17_analyzer_2_array_crystal_array_7_p_interact;
char* mask_string = mccchannel_17_analyzer_2_array_crystal_array_7_mask_string;
char* mask_setting = mccchannel_17_analyzer_2_array_crystal_array_7_mask_setting;
MCNUM number_of_activations = mccchannel_17_analyzer_2_array_crystal_array_7_number_of_activations;
}   /* End of channel_17_analyzer_2_array_crystal_array_7=Union_box() SETTING parameter declarations. */
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex
  /* Label for restoring  neutron */
  mcabsorbCompchannel_17_analyzer_2_array_crystal_array_7:
  if (RESTORE) /* restore if needed */
  { RESTORE_NEUTRON(794,
      mcnlx,
      mcnly,
      mcnlz,
      mcnlvx,
      mcnlvy,
      mcnlvz,
      mcnlt,
      mcnlsx,
      mcnlsy,
      mcnlsz,
      mcnlp); }
#undef mcabsorbComp
#undef p
#undef sz
#undef sy
#undef sx
#undef t
#undef vz
#undef vy
#undef vx
#undef z
#undef y
#undef x
  mcDEBUG_STATE(
mcnlx,
mcnly,
mcnlz,
mcnlvx,
mcnlvy,
mcnlvz,
mcnlt,
mcnlsx,
mcnlsy,
mcnlsz,
mcnlp)

  /* TRACE Component channel_17_analyzer_2_array_crystal_array_8 [795] */
  mccoordschange(mcposrchannel_17_analyzer_2_array_crystal_array_8, mcrotrchannel_17_analyzer_2_array_crystal_array_8,
    &mcnlx,
    &mcnly,
    &mcnlz,
    &mcnlvx,
    &mcnlvy,
    &mcnlvz,
    &mcnlsx,
    &mcnlsy,
    &mcnlsz);
  /* define label inside component channel_17_analyzer_2_array_crystal_array_8 (without coords transformations) */
  mcJumpTrace_channel_17_analyzer_2_array_crystal_array_8:
  SIG_MESSAGE("channel_17_analyzer_2_array_crystal_array_8 (Trace)");
  mcDEBUG_COMP("channel_17_analyzer_2_array_crystal_array_8")
  mcDEBUG_STATE(
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp)
#define x mcnlx
#define y mcnly
#define z mcnlz
#define vx mcnlvx
#define vy mcnlvy
#define vz mcnlvz
#define t mcnlt
#define sx mcnlsx
#define sy mcnlsy
#define sz mcnlsz
#define p mcnlp

#define mcabsorbComp mcabsorbCompchannel_17_analyzer_2_array_crystal_array_8
  STORE_NEUTRON(795,
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp);
  mcScattered=0;
  mcRestore=0;
  mcNCounter[795]++;
  mcPCounter[795] += p;
  mcP2Counter[795] += p*p;
#define mccompcurname  channel_17_analyzer_2_array_crystal_array_8
#define mccompcurtype  Union_box
#define mccompcurindex 795
#define loop_index mccchannel_17_analyzer_2_array_crystal_array_8_loop_index
#define this_box_volume mccchannel_17_analyzer_2_array_crystal_array_8_this_box_volume
#define global_geometry_element mccchannel_17_analyzer_2_array_crystal_array_8_global_geometry_element
#define this_box_storage mccchannel_17_analyzer_2_array_crystal_array_8_this_box_storage
{   /* Declarations of channel_17_analyzer_2_array_crystal_array_8=Union_box() SETTING parameters. */
char* material_string = mccchannel_17_analyzer_2_array_crystal_array_8_material_string;
MCNUM priority = mccchannel_17_analyzer_2_array_crystal_array_8_priority;
MCNUM xwidth = mccchannel_17_analyzer_2_array_crystal_array_8_xwidth;
MCNUM yheight = mccchannel_17_analyzer_2_array_crystal_array_8_yheight;
MCNUM zdepth = mccchannel_17_analyzer_2_array_crystal_array_8_zdepth;
MCNUM xwidth2 = mccchannel_17_analyzer_2_array_crystal_array_8_xwidth2;
MCNUM yheight2 = mccchannel_17_analyzer_2_array_crystal_array_8_yheight2;
MCNUM visualize = mccchannel_17_analyzer_2_array_crystal_array_8_visualize;
int target_index = mccchannel_17_analyzer_2_array_crystal_array_8_target_index;
MCNUM target_x = mccchannel_17_analyzer_2_array_crystal_array_8_target_x;
MCNUM target_y = mccchannel_17_analyzer_2_array_crystal_array_8_target_y;
MCNUM target_z = mccchannel_17_analyzer_2_array_crystal_array_8_target_z;
MCNUM focus_aw = mccchannel_17_analyzer_2_array_crystal_array_8_focus_aw;
MCNUM focus_ah = mccchannel_17_analyzer_2_array_crystal_array_8_focus_ah;
MCNUM focus_xw = mccchannel_17_analyzer_2_array_crystal_array_8_focus_xw;
MCNUM focus_xh = mccchannel_17_analyzer_2_array_crystal_array_8_focus_xh;
MCNUM focus_r = mccchannel_17_analyzer_2_array_crystal_array_8_focus_r;
MCNUM p_interact = mccchannel_17_analyzer_2_array_crystal_array_8_p_interact;
char* mask_string = mccchannel_17_analyzer_2_array_crystal_array_8_mask_string;
char* mask_setting = mccchannel_17_analyzer_2_array_crystal_array_8_mask_setting;
MCNUM number_of_activations = mccchannel_17_analyzer_2_array_crystal_array_8_number_of_activations;
}   /* End of channel_17_analyzer_2_array_crystal_array_8=Union_box() SETTING parameter declarations. */
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex
  /* Label for restoring  neutron */
  mcabsorbCompchannel_17_analyzer_2_array_crystal_array_8:
  if (RESTORE) /* restore if needed */
  { RESTORE_NEUTRON(795,
      mcnlx,
      mcnly,
      mcnlz,
      mcnlvx,
      mcnlvy,
      mcnlvz,
      mcnlt,
      mcnlsx,
      mcnlsy,
      mcnlsz,
      mcnlp); }
#undef mcabsorbComp
#undef p
#undef sz
#undef sy
#undef sx
#undef t
#undef vz
#undef vy
#undef vx
#undef z
#undef y
#undef x
  mcDEBUG_STATE(
mcnlx,
mcnly,
mcnlz,
mcnlvx,
mcnlvy,
mcnlvz,
mcnlt,
mcnlsx,
mcnlsy,
mcnlsz,
mcnlp)

  /* TRACE Component channel_17_cave2_cyl1 [796] */
  mccoordschange(mcposrchannel_17_cave2_cyl1, mcrotrchannel_17_cave2_cyl1,
    &mcnlx,
    &mcnly,
    &mcnlz,
    &mcnlvx,
    &mcnlvy,
    &mcnlvz,
    &mcnlsx,
    &mcnlsy,
    &mcnlsz);
  /* define label inside component channel_17_cave2_cyl1 (without coords transformations) */
  mcJumpTrace_channel_17_cave2_cyl1:
  SIG_MESSAGE("channel_17_cave2_cyl1 (Trace)");
  mcDEBUG_COMP("channel_17_cave2_cyl1")
  mcDEBUG_STATE(
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp)
#define x mcnlx
#define y mcnly
#define z mcnlz
#define vx mcnlvx
#define vy mcnlvy
#define vz mcnlvz
#define t mcnlt
#define sx mcnlsx
#define sy mcnlsy
#define sz mcnlsz
#define p mcnlp

#define mcabsorbComp mcabsorbCompchannel_17_cave2_cyl1
  STORE_NEUTRON(796,
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp);
  mcScattered=0;
  mcRestore=0;
  mcNCounter[796]++;
  mcPCounter[796] += p;
  mcP2Counter[796] += p*p;
#define mccompcurname  channel_17_cave2_cyl1
#define mccompcurtype  Union_cylinder
#define mccompcurindex 796
#define loop_index mccchannel_17_cave2_cyl1_loop_index
#define this_cylinder_volume mccchannel_17_cave2_cyl1_this_cylinder_volume
#define global_geometry_element mccchannel_17_cave2_cyl1_global_geometry_element
#define this_cylinder_storage mccchannel_17_cave2_cyl1_this_cylinder_storage
{   /* Declarations of channel_17_cave2_cyl1=Union_cylinder() SETTING parameters. */
char* material_string = mccchannel_17_cave2_cyl1_material_string;
MCNUM priority = mccchannel_17_cave2_cyl1_priority;
MCNUM radius = mccchannel_17_cave2_cyl1_radius;
MCNUM yheight = mccchannel_17_cave2_cyl1_yheight;
MCNUM visualize = mccchannel_17_cave2_cyl1_visualize;
int target_index = mccchannel_17_cave2_cyl1_target_index;
MCNUM target_x = mccchannel_17_cave2_cyl1_target_x;
MCNUM target_y = mccchannel_17_cave2_cyl1_target_y;
MCNUM target_z = mccchannel_17_cave2_cyl1_target_z;
MCNUM focus_aw = mccchannel_17_cave2_cyl1_focus_aw;
MCNUM focus_ah = mccchannel_17_cave2_cyl1_focus_ah;
MCNUM focus_xw = mccchannel_17_cave2_cyl1_focus_xw;
MCNUM focus_xh = mccchannel_17_cave2_cyl1_focus_xh;
MCNUM focus_r = mccchannel_17_cave2_cyl1_focus_r;
MCNUM p_interact = mccchannel_17_cave2_cyl1_p_interact;
char* mask_string = mccchannel_17_cave2_cyl1_mask_string;
char* mask_setting = mccchannel_17_cave2_cyl1_mask_setting;
MCNUM number_of_activations = mccchannel_17_cave2_cyl1_number_of_activations;
#line 345 "Union_cylinder.comp"
{
dummy = 1;
}
#line 450015 "MACS_sample_kidney_box.c"
}   /* End of channel_17_cave2_cyl1=Union_cylinder() SETTING parameter declarations. */
#undef this_cylinder_storage
#undef global_geometry_element
#undef this_cylinder_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex
  /* Label for restoring  neutron */
  mcabsorbCompchannel_17_cave2_cyl1:
  if (RESTORE) /* restore if needed */
  { RESTORE_NEUTRON(796,
      mcnlx,
      mcnly,
      mcnlz,
      mcnlvx,
      mcnlvy,
      mcnlvz,
      mcnlt,
      mcnlsx,
      mcnlsy,
      mcnlsz,
      mcnlp); }
#undef mcabsorbComp
#undef p
#undef sz
#undef sy
#undef sx
#undef t
#undef vz
#undef vy
#undef vx
#undef z
#undef y
#undef x
  mcDEBUG_STATE(
mcnlx,
mcnly,
mcnlz,
mcnlvx,
mcnlvy,
mcnlvz,
mcnlt,
mcnlsx,
mcnlsy,
mcnlsz,
mcnlp)

  /* TRACE Component channel_17_cave2_box1 [797] */
  mccoordschange(mcposrchannel_17_cave2_box1, mcrotrchannel_17_cave2_box1,
    &mcnlx,
    &mcnly,
    &mcnlz,
    &mcnlvx,
    &mcnlvy,
    &mcnlvz,
    &mcnlsx,
    &mcnlsy,
    &mcnlsz);
  /* define label inside component channel_17_cave2_box1 (without coords transformations) */
  mcJumpTrace_channel_17_cave2_box1:
  SIG_MESSAGE("channel_17_cave2_box1 (Trace)");
  mcDEBUG_COMP("channel_17_cave2_box1")
  mcDEBUG_STATE(
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp)
#define x mcnlx
#define y mcnly
#define z mcnlz
#define vx mcnlvx
#define vy mcnlvy
#define vz mcnlvz
#define t mcnlt
#define sx mcnlsx
#define sy mcnlsy
#define sz mcnlsz
#define p mcnlp

#define mcabsorbComp mcabsorbCompchannel_17_cave2_box1
  STORE_NEUTRON(797,
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp);
  mcScattered=0;
  mcRestore=0;
  mcNCounter[797]++;
  mcPCounter[797] += p;
  mcP2Counter[797] += p*p;
#define mccompcurname  channel_17_cave2_box1
#define mccompcurtype  Union_box
#define mccompcurindex 797
#define loop_index mccchannel_17_cave2_box1_loop_index
#define this_box_volume mccchannel_17_cave2_box1_this_box_volume
#define global_geometry_element mccchannel_17_cave2_box1_global_geometry_element
#define this_box_storage mccchannel_17_cave2_box1_this_box_storage
{   /* Declarations of channel_17_cave2_box1=Union_box() SETTING parameters. */
char* material_string = mccchannel_17_cave2_box1_material_string;
MCNUM priority = mccchannel_17_cave2_box1_priority;
MCNUM xwidth = mccchannel_17_cave2_box1_xwidth;
MCNUM yheight = mccchannel_17_cave2_box1_yheight;
MCNUM zdepth = mccchannel_17_cave2_box1_zdepth;
MCNUM xwidth2 = mccchannel_17_cave2_box1_xwidth2;
MCNUM yheight2 = mccchannel_17_cave2_box1_yheight2;
MCNUM visualize = mccchannel_17_cave2_box1_visualize;
int target_index = mccchannel_17_cave2_box1_target_index;
MCNUM target_x = mccchannel_17_cave2_box1_target_x;
MCNUM target_y = mccchannel_17_cave2_box1_target_y;
MCNUM target_z = mccchannel_17_cave2_box1_target_z;
MCNUM focus_aw = mccchannel_17_cave2_box1_focus_aw;
MCNUM focus_ah = mccchannel_17_cave2_box1_focus_ah;
MCNUM focus_xw = mccchannel_17_cave2_box1_focus_xw;
MCNUM focus_xh = mccchannel_17_cave2_box1_focus_xh;
MCNUM focus_r = mccchannel_17_cave2_box1_focus_r;
MCNUM p_interact = mccchannel_17_cave2_box1_p_interact;
char* mask_string = mccchannel_17_cave2_box1_mask_string;
char* mask_setting = mccchannel_17_cave2_box1_mask_setting;
MCNUM number_of_activations = mccchannel_17_cave2_box1_number_of_activations;
}   /* End of channel_17_cave2_box1=Union_box() SETTING parameter declarations. */
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex
  /* Label for restoring  neutron */
  mcabsorbCompchannel_17_cave2_box1:
  if (RESTORE) /* restore if needed */
  { RESTORE_NEUTRON(797,
      mcnlx,
      mcnly,
      mcnlz,
      mcnlvx,
      mcnlvy,
      mcnlvz,
      mcnlt,
      mcnlsx,
      mcnlsy,
      mcnlsz,
      mcnlp); }
#undef mcabsorbComp
#undef p
#undef sz
#undef sy
#undef sx
#undef t
#undef vz
#undef vy
#undef vx
#undef z
#undef y
#undef x
  mcDEBUG_STATE(
mcnlx,
mcnly,
mcnlz,
mcnlvx,
mcnlvy,
mcnlvz,
mcnlt,
mcnlsx,
mcnlsy,
mcnlsz,
mcnlp)

  /* TRACE Component channel_17_cave2_box2 [798] */
  mccoordschange(mcposrchannel_17_cave2_box2, mcrotrchannel_17_cave2_box2,
    &mcnlx,
    &mcnly,
    &mcnlz,
    &mcnlvx,
    &mcnlvy,
    &mcnlvz,
    &mcnlsx,
    &mcnlsy,
    &mcnlsz);
  /* define label inside component channel_17_cave2_box2 (without coords transformations) */
  mcJumpTrace_channel_17_cave2_box2:
  SIG_MESSAGE("channel_17_cave2_box2 (Trace)");
  mcDEBUG_COMP("channel_17_cave2_box2")
  mcDEBUG_STATE(
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp)
#define x mcnlx
#define y mcnly
#define z mcnlz
#define vx mcnlvx
#define vy mcnlvy
#define vz mcnlvz
#define t mcnlt
#define sx mcnlsx
#define sy mcnlsy
#define sz mcnlsz
#define p mcnlp

#define mcabsorbComp mcabsorbCompchannel_17_cave2_box2
  STORE_NEUTRON(798,
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp);
  mcScattered=0;
  mcRestore=0;
  mcNCounter[798]++;
  mcPCounter[798] += p;
  mcP2Counter[798] += p*p;
#define mccompcurname  channel_17_cave2_box2
#define mccompcurtype  Union_box
#define mccompcurindex 798
#define loop_index mccchannel_17_cave2_box2_loop_index
#define this_box_volume mccchannel_17_cave2_box2_this_box_volume
#define global_geometry_element mccchannel_17_cave2_box2_global_geometry_element
#define this_box_storage mccchannel_17_cave2_box2_this_box_storage
{   /* Declarations of channel_17_cave2_box2=Union_box() SETTING parameters. */
char* material_string = mccchannel_17_cave2_box2_material_string;
MCNUM priority = mccchannel_17_cave2_box2_priority;
MCNUM xwidth = mccchannel_17_cave2_box2_xwidth;
MCNUM yheight = mccchannel_17_cave2_box2_yheight;
MCNUM zdepth = mccchannel_17_cave2_box2_zdepth;
MCNUM xwidth2 = mccchannel_17_cave2_box2_xwidth2;
MCNUM yheight2 = mccchannel_17_cave2_box2_yheight2;
MCNUM visualize = mccchannel_17_cave2_box2_visualize;
int target_index = mccchannel_17_cave2_box2_target_index;
MCNUM target_x = mccchannel_17_cave2_box2_target_x;
MCNUM target_y = mccchannel_17_cave2_box2_target_y;
MCNUM target_z = mccchannel_17_cave2_box2_target_z;
MCNUM focus_aw = mccchannel_17_cave2_box2_focus_aw;
MCNUM focus_ah = mccchannel_17_cave2_box2_focus_ah;
MCNUM focus_xw = mccchannel_17_cave2_box2_focus_xw;
MCNUM focus_xh = mccchannel_17_cave2_box2_focus_xh;
MCNUM focus_r = mccchannel_17_cave2_box2_focus_r;
MCNUM p_interact = mccchannel_17_cave2_box2_p_interact;
char* mask_string = mccchannel_17_cave2_box2_mask_string;
char* mask_setting = mccchannel_17_cave2_box2_mask_setting;
MCNUM number_of_activations = mccchannel_17_cave2_box2_number_of_activations;
}   /* End of channel_17_cave2_box2=Union_box() SETTING parameter declarations. */
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex
  /* Label for restoring  neutron */
  mcabsorbCompchannel_17_cave2_box2:
  if (RESTORE) /* restore if needed */
  { RESTORE_NEUTRON(798,
      mcnlx,
      mcnly,
      mcnlz,
      mcnlvx,
      mcnlvy,
      mcnlvz,
      mcnlt,
      mcnlsx,
      mcnlsy,
      mcnlsz,
      mcnlp); }
#undef mcabsorbComp
#undef p
#undef sz
#undef sy
#undef sx
#undef t
#undef vz
#undef vy
#undef vx
#undef z
#undef y
#undef x
  mcDEBUG_STATE(
mcnlx,
mcnly,
mcnlz,
mcnlvx,
mcnlvy,
mcnlvz,
mcnlt,
mcnlsx,
mcnlsy,
mcnlsz,
mcnlp)

  /* TRACE Component channel_17_cave2_box3 [799] */
  mccoordschange(mcposrchannel_17_cave2_box3, mcrotrchannel_17_cave2_box3,
    &mcnlx,
    &mcnly,
    &mcnlz,
    &mcnlvx,
    &mcnlvy,
    &mcnlvz,
    &mcnlsx,
    &mcnlsy,
    &mcnlsz);
  /* define label inside component channel_17_cave2_box3 (without coords transformations) */
  mcJumpTrace_channel_17_cave2_box3:
  SIG_MESSAGE("channel_17_cave2_box3 (Trace)");
  mcDEBUG_COMP("channel_17_cave2_box3")
  mcDEBUG_STATE(
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp)
#define x mcnlx
#define y mcnly
#define z mcnlz
#define vx mcnlvx
#define vy mcnlvy
#define vz mcnlvz
#define t mcnlt
#define sx mcnlsx
#define sy mcnlsy
#define sz mcnlsz
#define p mcnlp

#define mcabsorbComp mcabsorbCompchannel_17_cave2_box3
  STORE_NEUTRON(799,
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp);
  mcScattered=0;
  mcRestore=0;
  mcNCounter[799]++;
  mcPCounter[799] += p;
  mcP2Counter[799] += p*p;
#define mccompcurname  channel_17_cave2_box3
#define mccompcurtype  Union_box
#define mccompcurindex 799
#define loop_index mccchannel_17_cave2_box3_loop_index
#define this_box_volume mccchannel_17_cave2_box3_this_box_volume
#define global_geometry_element mccchannel_17_cave2_box3_global_geometry_element
#define this_box_storage mccchannel_17_cave2_box3_this_box_storage
{   /* Declarations of channel_17_cave2_box3=Union_box() SETTING parameters. */
char* material_string = mccchannel_17_cave2_box3_material_string;
MCNUM priority = mccchannel_17_cave2_box3_priority;
MCNUM xwidth = mccchannel_17_cave2_box3_xwidth;
MCNUM yheight = mccchannel_17_cave2_box3_yheight;
MCNUM zdepth = mccchannel_17_cave2_box3_zdepth;
MCNUM xwidth2 = mccchannel_17_cave2_box3_xwidth2;
MCNUM yheight2 = mccchannel_17_cave2_box3_yheight2;
MCNUM visualize = mccchannel_17_cave2_box3_visualize;
int target_index = mccchannel_17_cave2_box3_target_index;
MCNUM target_x = mccchannel_17_cave2_box3_target_x;
MCNUM target_y = mccchannel_17_cave2_box3_target_y;
MCNUM target_z = mccchannel_17_cave2_box3_target_z;
MCNUM focus_aw = mccchannel_17_cave2_box3_focus_aw;
MCNUM focus_ah = mccchannel_17_cave2_box3_focus_ah;
MCNUM focus_xw = mccchannel_17_cave2_box3_focus_xw;
MCNUM focus_xh = mccchannel_17_cave2_box3_focus_xh;
MCNUM focus_r = mccchannel_17_cave2_box3_focus_r;
MCNUM p_interact = mccchannel_17_cave2_box3_p_interact;
char* mask_string = mccchannel_17_cave2_box3_mask_string;
char* mask_setting = mccchannel_17_cave2_box3_mask_setting;
MCNUM number_of_activations = mccchannel_17_cave2_box3_number_of_activations;
}   /* End of channel_17_cave2_box3=Union_box() SETTING parameter declarations. */
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex
  /* Label for restoring  neutron */
  mcabsorbCompchannel_17_cave2_box3:
  if (RESTORE) /* restore if needed */
  { RESTORE_NEUTRON(799,
      mcnlx,
      mcnly,
      mcnlz,
      mcnlvx,
      mcnlvy,
      mcnlvz,
      mcnlt,
      mcnlsx,
      mcnlsy,
      mcnlsz,
      mcnlp); }
#undef mcabsorbComp
#undef p
#undef sz
#undef sy
#undef sx
#undef t
#undef vz
#undef vy
#undef vx
#undef z
#undef y
#undef x
  mcDEBUG_STATE(
mcnlx,
mcnly,
mcnlz,
mcnlvx,
mcnlvy,
mcnlvz,
mcnlt,
mcnlsx,
mcnlsy,
mcnlsz,
mcnlp)

  /* TRACE Component inter_analyzer_colimator_center_17 [800] */
  mccoordschange(mcposrinter_analyzer_colimator_center_17, mcrotrinter_analyzer_colimator_center_17,
    &mcnlx,
    &mcnly,
    &mcnlz,
    &mcnlvx,
    &mcnlvy,
    &mcnlvz,
    &mcnlsx,
    &mcnlsy,
    &mcnlsz);
  /* define label inside component inter_analyzer_colimator_center_17 (without coords transformations) */
  mcJumpTrace_inter_analyzer_colimator_center_17:
  SIG_MESSAGE("inter_analyzer_colimator_center_17 (Trace)");
  mcDEBUG_COMP("inter_analyzer_colimator_center_17")
  mcDEBUG_STATE(
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp)
#define x mcnlx
#define y mcnly
#define z mcnlz
#define vx mcnlvx
#define vy mcnlvy
#define vz mcnlvz
#define t mcnlt
#define sx mcnlsx
#define sy mcnlsy
#define sz mcnlsz
#define p mcnlp

#define mcabsorbComp mcabsorbCompinter_analyzer_colimator_center_17
  STORE_NEUTRON(800,
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp);
  mcScattered=0;
  mcRestore=0;
  mcNCounter[800]++;
  mcPCounter[800] += p;
  mcP2Counter[800] += p*p;
#define mccompcurname  inter_analyzer_colimator_center_17
#define mccompcurtype  Arm
#define mccompcurindex 800
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex
  /* Label for restoring  neutron */
  mcabsorbCompinter_analyzer_colimator_center_17:
  if (RESTORE) /* restore if needed */
  { RESTORE_NEUTRON(800,
      mcnlx,
      mcnly,
      mcnlz,
      mcnlvx,
      mcnlvy,
      mcnlvz,
      mcnlt,
      mcnlsx,
      mcnlsy,
      mcnlsz,
      mcnlp); }
#undef mcabsorbComp
#undef p
#undef sz
#undef sy
#undef sx
#undef t
#undef vz
#undef vy
#undef vx
#undef z
#undef y
#undef x
  mcDEBUG_STATE(
mcnlx,
mcnly,
mcnlz,
mcnlvx,
mcnlvy,
mcnlvz,
mcnlt,
mcnlsx,
mcnlsy,
mcnlsz,
mcnlp)

  /* TRACE Component inter_analyzer_colimator_17_blade_0 [801] */
  mccoordschange(mcposrinter_analyzer_colimator_17_blade_0, mcrotrinter_analyzer_colimator_17_blade_0,
    &mcnlx,
    &mcnly,
    &mcnlz,
    &mcnlvx,
    &mcnlvy,
    &mcnlvz,
    &mcnlsx,
    &mcnlsy,
    &mcnlsz);
  /* define label inside component inter_analyzer_colimator_17_blade_0 (without coords transformations) */
  mcJumpTrace_inter_analyzer_colimator_17_blade_0:
  SIG_MESSAGE("inter_analyzer_colimator_17_blade_0 (Trace)");
  mcDEBUG_COMP("inter_analyzer_colimator_17_blade_0")
  mcDEBUG_STATE(
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp)
#define x mcnlx
#define y mcnly
#define z mcnlz
#define vx mcnlvx
#define vy mcnlvy
#define vz mcnlvz
#define t mcnlt
#define sx mcnlsx
#define sy mcnlsy
#define sz mcnlsz
#define p mcnlp

#define mcabsorbComp mcabsorbCompinter_analyzer_colimator_17_blade_0
  STORE_NEUTRON(801,
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp);
  mcScattered=0;
  mcRestore=0;
  mcNCounter[801]++;
  mcPCounter[801] += p;
  mcP2Counter[801] += p*p;
#define mccompcurname  inter_analyzer_colimator_17_blade_0
#define mccompcurtype  Union_box
#define mccompcurindex 801
#define loop_index mccinter_analyzer_colimator_17_blade_0_loop_index
#define this_box_volume mccinter_analyzer_colimator_17_blade_0_this_box_volume
#define global_geometry_element mccinter_analyzer_colimator_17_blade_0_global_geometry_element
#define this_box_storage mccinter_analyzer_colimator_17_blade_0_this_box_storage
{   /* Declarations of inter_analyzer_colimator_17_blade_0=Union_box() SETTING parameters. */
char* material_string = mccinter_analyzer_colimator_17_blade_0_material_string;
MCNUM priority = mccinter_analyzer_colimator_17_blade_0_priority;
MCNUM xwidth = mccinter_analyzer_colimator_17_blade_0_xwidth;
MCNUM yheight = mccinter_analyzer_colimator_17_blade_0_yheight;
MCNUM zdepth = mccinter_analyzer_colimator_17_blade_0_zdepth;
MCNUM xwidth2 = mccinter_analyzer_colimator_17_blade_0_xwidth2;
MCNUM yheight2 = mccinter_analyzer_colimator_17_blade_0_yheight2;
MCNUM visualize = mccinter_analyzer_colimator_17_blade_0_visualize;
int target_index = mccinter_analyzer_colimator_17_blade_0_target_index;
MCNUM target_x = mccinter_analyzer_colimator_17_blade_0_target_x;
MCNUM target_y = mccinter_analyzer_colimator_17_blade_0_target_y;
MCNUM target_z = mccinter_analyzer_colimator_17_blade_0_target_z;
MCNUM focus_aw = mccinter_analyzer_colimator_17_blade_0_focus_aw;
MCNUM focus_ah = mccinter_analyzer_colimator_17_blade_0_focus_ah;
MCNUM focus_xw = mccinter_analyzer_colimator_17_blade_0_focus_xw;
MCNUM focus_xh = mccinter_analyzer_colimator_17_blade_0_focus_xh;
MCNUM focus_r = mccinter_analyzer_colimator_17_blade_0_focus_r;
MCNUM p_interact = mccinter_analyzer_colimator_17_blade_0_p_interact;
char* mask_string = mccinter_analyzer_colimator_17_blade_0_mask_string;
char* mask_setting = mccinter_analyzer_colimator_17_blade_0_mask_setting;
MCNUM number_of_activations = mccinter_analyzer_colimator_17_blade_0_number_of_activations;
}   /* End of inter_analyzer_colimator_17_blade_0=Union_box() SETTING parameter declarations. */
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex
  /* Label for restoring  neutron */
  mcabsorbCompinter_analyzer_colimator_17_blade_0:
  if (RESTORE) /* restore if needed */
  { RESTORE_NEUTRON(801,
      mcnlx,
      mcnly,
      mcnlz,
      mcnlvx,
      mcnlvy,
      mcnlvz,
      mcnlt,
      mcnlsx,
      mcnlsy,
      mcnlsz,
      mcnlp); }
#undef mcabsorbComp
#undef p
#undef sz
#undef sy
#undef sx
#undef t
#undef vz
#undef vy
#undef vx
#undef z
#undef y
#undef x
  mcDEBUG_STATE(
mcnlx,
mcnly,
mcnlz,
mcnlvx,
mcnlvy,
mcnlvz,
mcnlt,
mcnlsx,
mcnlsy,
mcnlsz,
mcnlp)

  /* TRACE Component inter_analyzer_colimator_17_blade_1 [802] */
  mccoordschange(mcposrinter_analyzer_colimator_17_blade_1, mcrotrinter_analyzer_colimator_17_blade_1,
    &mcnlx,
    &mcnly,
    &mcnlz,
    &mcnlvx,
    &mcnlvy,
    &mcnlvz,
    &mcnlsx,
    &mcnlsy,
    &mcnlsz);
  /* define label inside component inter_analyzer_colimator_17_blade_1 (without coords transformations) */
  mcJumpTrace_inter_analyzer_colimator_17_blade_1:
  SIG_MESSAGE("inter_analyzer_colimator_17_blade_1 (Trace)");
  mcDEBUG_COMP("inter_analyzer_colimator_17_blade_1")
  mcDEBUG_STATE(
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp)
#define x mcnlx
#define y mcnly
#define z mcnlz
#define vx mcnlvx
#define vy mcnlvy
#define vz mcnlvz
#define t mcnlt
#define sx mcnlsx
#define sy mcnlsy
#define sz mcnlsz
#define p mcnlp

#define mcabsorbComp mcabsorbCompinter_analyzer_colimator_17_blade_1
  STORE_NEUTRON(802,
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp);
  mcScattered=0;
  mcRestore=0;
  mcNCounter[802]++;
  mcPCounter[802] += p;
  mcP2Counter[802] += p*p;
#define mccompcurname  inter_analyzer_colimator_17_blade_1
#define mccompcurtype  Union_box
#define mccompcurindex 802
#define loop_index mccinter_analyzer_colimator_17_blade_1_loop_index
#define this_box_volume mccinter_analyzer_colimator_17_blade_1_this_box_volume
#define global_geometry_element mccinter_analyzer_colimator_17_blade_1_global_geometry_element
#define this_box_storage mccinter_analyzer_colimator_17_blade_1_this_box_storage
{   /* Declarations of inter_analyzer_colimator_17_blade_1=Union_box() SETTING parameters. */
char* material_string = mccinter_analyzer_colimator_17_blade_1_material_string;
MCNUM priority = mccinter_analyzer_colimator_17_blade_1_priority;
MCNUM xwidth = mccinter_analyzer_colimator_17_blade_1_xwidth;
MCNUM yheight = mccinter_analyzer_colimator_17_blade_1_yheight;
MCNUM zdepth = mccinter_analyzer_colimator_17_blade_1_zdepth;
MCNUM xwidth2 = mccinter_analyzer_colimator_17_blade_1_xwidth2;
MCNUM yheight2 = mccinter_analyzer_colimator_17_blade_1_yheight2;
MCNUM visualize = mccinter_analyzer_colimator_17_blade_1_visualize;
int target_index = mccinter_analyzer_colimator_17_blade_1_target_index;
MCNUM target_x = mccinter_analyzer_colimator_17_blade_1_target_x;
MCNUM target_y = mccinter_analyzer_colimator_17_blade_1_target_y;
MCNUM target_z = mccinter_analyzer_colimator_17_blade_1_target_z;
MCNUM focus_aw = mccinter_analyzer_colimator_17_blade_1_focus_aw;
MCNUM focus_ah = mccinter_analyzer_colimator_17_blade_1_focus_ah;
MCNUM focus_xw = mccinter_analyzer_colimator_17_blade_1_focus_xw;
MCNUM focus_xh = mccinter_analyzer_colimator_17_blade_1_focus_xh;
MCNUM focus_r = mccinter_analyzer_colimator_17_blade_1_focus_r;
MCNUM p_interact = mccinter_analyzer_colimator_17_blade_1_p_interact;
char* mask_string = mccinter_analyzer_colimator_17_blade_1_mask_string;
char* mask_setting = mccinter_analyzer_colimator_17_blade_1_mask_setting;
MCNUM number_of_activations = mccinter_analyzer_colimator_17_blade_1_number_of_activations;
}   /* End of inter_analyzer_colimator_17_blade_1=Union_box() SETTING parameter declarations. */
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex
  /* Label for restoring  neutron */
  mcabsorbCompinter_analyzer_colimator_17_blade_1:
  if (RESTORE) /* restore if needed */
  { RESTORE_NEUTRON(802,
      mcnlx,
      mcnly,
      mcnlz,
      mcnlvx,
      mcnlvy,
      mcnlvz,
      mcnlt,
      mcnlsx,
      mcnlsy,
      mcnlsz,
      mcnlp); }
#undef mcabsorbComp
#undef p
#undef sz
#undef sy
#undef sx
#undef t
#undef vz
#undef vy
#undef vx
#undef z
#undef y
#undef x
  mcDEBUG_STATE(
mcnlx,
mcnly,
mcnlz,
mcnlvx,
mcnlvy,
mcnlvz,
mcnlt,
mcnlsx,
mcnlsy,
mcnlsz,
mcnlp)

  /* TRACE Component inter_analyzer_colimator_17_blade_2 [803] */
  mccoordschange(mcposrinter_analyzer_colimator_17_blade_2, mcrotrinter_analyzer_colimator_17_blade_2,
    &mcnlx,
    &mcnly,
    &mcnlz,
    &mcnlvx,
    &mcnlvy,
    &mcnlvz,
    &mcnlsx,
    &mcnlsy,
    &mcnlsz);
  /* define label inside component inter_analyzer_colimator_17_blade_2 (without coords transformations) */
  mcJumpTrace_inter_analyzer_colimator_17_blade_2:
  SIG_MESSAGE("inter_analyzer_colimator_17_blade_2 (Trace)");
  mcDEBUG_COMP("inter_analyzer_colimator_17_blade_2")
  mcDEBUG_STATE(
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp)
#define x mcnlx
#define y mcnly
#define z mcnlz
#define vx mcnlvx
#define vy mcnlvy
#define vz mcnlvz
#define t mcnlt
#define sx mcnlsx
#define sy mcnlsy
#define sz mcnlsz
#define p mcnlp

#define mcabsorbComp mcabsorbCompinter_analyzer_colimator_17_blade_2
  STORE_NEUTRON(803,
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp);
  mcScattered=0;
  mcRestore=0;
  mcNCounter[803]++;
  mcPCounter[803] += p;
  mcP2Counter[803] += p*p;
#define mccompcurname  inter_analyzer_colimator_17_blade_2
#define mccompcurtype  Union_box
#define mccompcurindex 803
#define loop_index mccinter_analyzer_colimator_17_blade_2_loop_index
#define this_box_volume mccinter_analyzer_colimator_17_blade_2_this_box_volume
#define global_geometry_element mccinter_analyzer_colimator_17_blade_2_global_geometry_element
#define this_box_storage mccinter_analyzer_colimator_17_blade_2_this_box_storage
{   /* Declarations of inter_analyzer_colimator_17_blade_2=Union_box() SETTING parameters. */
char* material_string = mccinter_analyzer_colimator_17_blade_2_material_string;
MCNUM priority = mccinter_analyzer_colimator_17_blade_2_priority;
MCNUM xwidth = mccinter_analyzer_colimator_17_blade_2_xwidth;
MCNUM yheight = mccinter_analyzer_colimator_17_blade_2_yheight;
MCNUM zdepth = mccinter_analyzer_colimator_17_blade_2_zdepth;
MCNUM xwidth2 = mccinter_analyzer_colimator_17_blade_2_xwidth2;
MCNUM yheight2 = mccinter_analyzer_colimator_17_blade_2_yheight2;
MCNUM visualize = mccinter_analyzer_colimator_17_blade_2_visualize;
int target_index = mccinter_analyzer_colimator_17_blade_2_target_index;
MCNUM target_x = mccinter_analyzer_colimator_17_blade_2_target_x;
MCNUM target_y = mccinter_analyzer_colimator_17_blade_2_target_y;
MCNUM target_z = mccinter_analyzer_colimator_17_blade_2_target_z;
MCNUM focus_aw = mccinter_analyzer_colimator_17_blade_2_focus_aw;
MCNUM focus_ah = mccinter_analyzer_colimator_17_blade_2_focus_ah;
MCNUM focus_xw = mccinter_analyzer_colimator_17_blade_2_focus_xw;
MCNUM focus_xh = mccinter_analyzer_colimator_17_blade_2_focus_xh;
MCNUM focus_r = mccinter_analyzer_colimator_17_blade_2_focus_r;
MCNUM p_interact = mccinter_analyzer_colimator_17_blade_2_p_interact;
char* mask_string = mccinter_analyzer_colimator_17_blade_2_mask_string;
char* mask_setting = mccinter_analyzer_colimator_17_blade_2_mask_setting;
MCNUM number_of_activations = mccinter_analyzer_colimator_17_blade_2_number_of_activations;
}   /* End of inter_analyzer_colimator_17_blade_2=Union_box() SETTING parameter declarations. */
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex
  /* Label for restoring  neutron */
  mcabsorbCompinter_analyzer_colimator_17_blade_2:
  if (RESTORE) /* restore if needed */
  { RESTORE_NEUTRON(803,
      mcnlx,
      mcnly,
      mcnlz,
      mcnlvx,
      mcnlvy,
      mcnlvz,
      mcnlt,
      mcnlsx,
      mcnlsy,
      mcnlsz,
      mcnlp); }
#undef mcabsorbComp
#undef p
#undef sz
#undef sy
#undef sx
#undef t
#undef vz
#undef vy
#undef vx
#undef z
#undef y
#undef x
  mcDEBUG_STATE(
mcnlx,
mcnly,
mcnlz,
mcnlvx,
mcnlvy,
mcnlvz,
mcnlt,
mcnlsx,
mcnlsy,
mcnlsz,
mcnlp)

  /* TRACE Component inter_analyzer_colimator_17_blade_3 [804] */
  mccoordschange(mcposrinter_analyzer_colimator_17_blade_3, mcrotrinter_analyzer_colimator_17_blade_3,
    &mcnlx,
    &mcnly,
    &mcnlz,
    &mcnlvx,
    &mcnlvy,
    &mcnlvz,
    &mcnlsx,
    &mcnlsy,
    &mcnlsz);
  /* define label inside component inter_analyzer_colimator_17_blade_3 (without coords transformations) */
  mcJumpTrace_inter_analyzer_colimator_17_blade_3:
  SIG_MESSAGE("inter_analyzer_colimator_17_blade_3 (Trace)");
  mcDEBUG_COMP("inter_analyzer_colimator_17_blade_3")
  mcDEBUG_STATE(
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp)
#define x mcnlx
#define y mcnly
#define z mcnlz
#define vx mcnlvx
#define vy mcnlvy
#define vz mcnlvz
#define t mcnlt
#define sx mcnlsx
#define sy mcnlsy
#define sz mcnlsz
#define p mcnlp

#define mcabsorbComp mcabsorbCompinter_analyzer_colimator_17_blade_3
  STORE_NEUTRON(804,
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp);
  mcScattered=0;
  mcRestore=0;
  mcNCounter[804]++;
  mcPCounter[804] += p;
  mcP2Counter[804] += p*p;
#define mccompcurname  inter_analyzer_colimator_17_blade_3
#define mccompcurtype  Union_box
#define mccompcurindex 804
#define loop_index mccinter_analyzer_colimator_17_blade_3_loop_index
#define this_box_volume mccinter_analyzer_colimator_17_blade_3_this_box_volume
#define global_geometry_element mccinter_analyzer_colimator_17_blade_3_global_geometry_element
#define this_box_storage mccinter_analyzer_colimator_17_blade_3_this_box_storage
{   /* Declarations of inter_analyzer_colimator_17_blade_3=Union_box() SETTING parameters. */
char* material_string = mccinter_analyzer_colimator_17_blade_3_material_string;
MCNUM priority = mccinter_analyzer_colimator_17_blade_3_priority;
MCNUM xwidth = mccinter_analyzer_colimator_17_blade_3_xwidth;
MCNUM yheight = mccinter_analyzer_colimator_17_blade_3_yheight;
MCNUM zdepth = mccinter_analyzer_colimator_17_blade_3_zdepth;
MCNUM xwidth2 = mccinter_analyzer_colimator_17_blade_3_xwidth2;
MCNUM yheight2 = mccinter_analyzer_colimator_17_blade_3_yheight2;
MCNUM visualize = mccinter_analyzer_colimator_17_blade_3_visualize;
int target_index = mccinter_analyzer_colimator_17_blade_3_target_index;
MCNUM target_x = mccinter_analyzer_colimator_17_blade_3_target_x;
MCNUM target_y = mccinter_analyzer_colimator_17_blade_3_target_y;
MCNUM target_z = mccinter_analyzer_colimator_17_blade_3_target_z;
MCNUM focus_aw = mccinter_analyzer_colimator_17_blade_3_focus_aw;
MCNUM focus_ah = mccinter_analyzer_colimator_17_blade_3_focus_ah;
MCNUM focus_xw = mccinter_analyzer_colimator_17_blade_3_focus_xw;
MCNUM focus_xh = mccinter_analyzer_colimator_17_blade_3_focus_xh;
MCNUM focus_r = mccinter_analyzer_colimator_17_blade_3_focus_r;
MCNUM p_interact = mccinter_analyzer_colimator_17_blade_3_p_interact;
char* mask_string = mccinter_analyzer_colimator_17_blade_3_mask_string;
char* mask_setting = mccinter_analyzer_colimator_17_blade_3_mask_setting;
MCNUM number_of_activations = mccinter_analyzer_colimator_17_blade_3_number_of_activations;
}   /* End of inter_analyzer_colimator_17_blade_3=Union_box() SETTING parameter declarations. */
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex
  /* Label for restoring  neutron */
  mcabsorbCompinter_analyzer_colimator_17_blade_3:
  if (RESTORE) /* restore if needed */
  { RESTORE_NEUTRON(804,
      mcnlx,
      mcnly,
      mcnlz,
      mcnlvx,
      mcnlvy,
      mcnlvz,
      mcnlt,
      mcnlsx,
      mcnlsy,
      mcnlsz,
      mcnlp); }
#undef mcabsorbComp
#undef p
#undef sz
#undef sy
#undef sx
#undef t
#undef vz
#undef vy
#undef vx
#undef z
#undef y
#undef x
  mcDEBUG_STATE(
mcnlx,
mcnly,
mcnlz,
mcnlvx,
mcnlvy,
mcnlvz,
mcnlt,
mcnlsx,
mcnlsy,
mcnlsz,
mcnlp)

  /* TRACE Component inter_analyzer_colimator_17_blade_4 [805] */
  mccoordschange(mcposrinter_analyzer_colimator_17_blade_4, mcrotrinter_analyzer_colimator_17_blade_4,
    &mcnlx,
    &mcnly,
    &mcnlz,
    &mcnlvx,
    &mcnlvy,
    &mcnlvz,
    &mcnlsx,
    &mcnlsy,
    &mcnlsz);
  /* define label inside component inter_analyzer_colimator_17_blade_4 (without coords transformations) */
  mcJumpTrace_inter_analyzer_colimator_17_blade_4:
  SIG_MESSAGE("inter_analyzer_colimator_17_blade_4 (Trace)");
  mcDEBUG_COMP("inter_analyzer_colimator_17_blade_4")
  mcDEBUG_STATE(
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp)
#define x mcnlx
#define y mcnly
#define z mcnlz
#define vx mcnlvx
#define vy mcnlvy
#define vz mcnlvz
#define t mcnlt
#define sx mcnlsx
#define sy mcnlsy
#define sz mcnlsz
#define p mcnlp

#define mcabsorbComp mcabsorbCompinter_analyzer_colimator_17_blade_4
  STORE_NEUTRON(805,
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp);
  mcScattered=0;
  mcRestore=0;
  mcNCounter[805]++;
  mcPCounter[805] += p;
  mcP2Counter[805] += p*p;
#define mccompcurname  inter_analyzer_colimator_17_blade_4
#define mccompcurtype  Union_box
#define mccompcurindex 805
#define loop_index mccinter_analyzer_colimator_17_blade_4_loop_index
#define this_box_volume mccinter_analyzer_colimator_17_blade_4_this_box_volume
#define global_geometry_element mccinter_analyzer_colimator_17_blade_4_global_geometry_element
#define this_box_storage mccinter_analyzer_colimator_17_blade_4_this_box_storage
{   /* Declarations of inter_analyzer_colimator_17_blade_4=Union_box() SETTING parameters. */
char* material_string = mccinter_analyzer_colimator_17_blade_4_material_string;
MCNUM priority = mccinter_analyzer_colimator_17_blade_4_priority;
MCNUM xwidth = mccinter_analyzer_colimator_17_blade_4_xwidth;
MCNUM yheight = mccinter_analyzer_colimator_17_blade_4_yheight;
MCNUM zdepth = mccinter_analyzer_colimator_17_blade_4_zdepth;
MCNUM xwidth2 = mccinter_analyzer_colimator_17_blade_4_xwidth2;
MCNUM yheight2 = mccinter_analyzer_colimator_17_blade_4_yheight2;
MCNUM visualize = mccinter_analyzer_colimator_17_blade_4_visualize;
int target_index = mccinter_analyzer_colimator_17_blade_4_target_index;
MCNUM target_x = mccinter_analyzer_colimator_17_blade_4_target_x;
MCNUM target_y = mccinter_analyzer_colimator_17_blade_4_target_y;
MCNUM target_z = mccinter_analyzer_colimator_17_blade_4_target_z;
MCNUM focus_aw = mccinter_analyzer_colimator_17_blade_4_focus_aw;
MCNUM focus_ah = mccinter_analyzer_colimator_17_blade_4_focus_ah;
MCNUM focus_xw = mccinter_analyzer_colimator_17_blade_4_focus_xw;
MCNUM focus_xh = mccinter_analyzer_colimator_17_blade_4_focus_xh;
MCNUM focus_r = mccinter_analyzer_colimator_17_blade_4_focus_r;
MCNUM p_interact = mccinter_analyzer_colimator_17_blade_4_p_interact;
char* mask_string = mccinter_analyzer_colimator_17_blade_4_mask_string;
char* mask_setting = mccinter_analyzer_colimator_17_blade_4_mask_setting;
MCNUM number_of_activations = mccinter_analyzer_colimator_17_blade_4_number_of_activations;
}   /* End of inter_analyzer_colimator_17_blade_4=Union_box() SETTING parameter declarations. */
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex
  /* Label for restoring  neutron */
  mcabsorbCompinter_analyzer_colimator_17_blade_4:
  if (RESTORE) /* restore if needed */
  { RESTORE_NEUTRON(805,
      mcnlx,
      mcnly,
      mcnlz,
      mcnlvx,
      mcnlvy,
      mcnlvz,
      mcnlt,
      mcnlsx,
      mcnlsy,
      mcnlsz,
      mcnlp); }
#undef mcabsorbComp
#undef p
#undef sz
#undef sy
#undef sx
#undef t
#undef vz
#undef vy
#undef vx
#undef z
#undef y
#undef x
  mcDEBUG_STATE(
mcnlx,
mcnly,
mcnlz,
mcnlvx,
mcnlvy,
mcnlvz,
mcnlt,
mcnlsx,
mcnlsy,
mcnlsz,
mcnlp)

  /* TRACE Component diffraction_detector_17_exit_volume [806] */
  mccoordschange(mcposrdiffraction_detector_17_exit_volume, mcrotrdiffraction_detector_17_exit_volume,
    &mcnlx,
    &mcnly,
    &mcnlz,
    &mcnlvx,
    &mcnlvy,
    &mcnlvz,
    &mcnlsx,
    &mcnlsy,
    &mcnlsz);
  /* define label inside component diffraction_detector_17_exit_volume (without coords transformations) */
  mcJumpTrace_diffraction_detector_17_exit_volume:
  SIG_MESSAGE("diffraction_detector_17_exit_volume (Trace)");
  mcDEBUG_COMP("diffraction_detector_17_exit_volume")
  mcDEBUG_STATE(
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp)
#define x mcnlx
#define y mcnly
#define z mcnlz
#define vx mcnlvx
#define vy mcnlvy
#define vz mcnlvz
#define t mcnlt
#define sx mcnlsx
#define sy mcnlsy
#define sz mcnlsz
#define p mcnlp

#define mcabsorbComp mcabsorbCompdiffraction_detector_17_exit_volume
  STORE_NEUTRON(806,
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp);
  mcScattered=0;
  mcRestore=0;
  mcNCounter[806]++;
  mcPCounter[806] += p;
  mcP2Counter[806] += p*p;
#define mccompcurname  diffraction_detector_17_exit_volume
#define mccompcurtype  Union_box
#define mccompcurindex 806
#define loop_index mccdiffraction_detector_17_exit_volume_loop_index
#define this_box_volume mccdiffraction_detector_17_exit_volume_this_box_volume
#define global_geometry_element mccdiffraction_detector_17_exit_volume_global_geometry_element
#define this_box_storage mccdiffraction_detector_17_exit_volume_this_box_storage
{   /* Declarations of diffraction_detector_17_exit_volume=Union_box() SETTING parameters. */
char* material_string = mccdiffraction_detector_17_exit_volume_material_string;
MCNUM priority = mccdiffraction_detector_17_exit_volume_priority;
MCNUM xwidth = mccdiffraction_detector_17_exit_volume_xwidth;
MCNUM yheight = mccdiffraction_detector_17_exit_volume_yheight;
MCNUM zdepth = mccdiffraction_detector_17_exit_volume_zdepth;
MCNUM xwidth2 = mccdiffraction_detector_17_exit_volume_xwidth2;
MCNUM yheight2 = mccdiffraction_detector_17_exit_volume_yheight2;
MCNUM visualize = mccdiffraction_detector_17_exit_volume_visualize;
int target_index = mccdiffraction_detector_17_exit_volume_target_index;
MCNUM target_x = mccdiffraction_detector_17_exit_volume_target_x;
MCNUM target_y = mccdiffraction_detector_17_exit_volume_target_y;
MCNUM target_z = mccdiffraction_detector_17_exit_volume_target_z;
MCNUM focus_aw = mccdiffraction_detector_17_exit_volume_focus_aw;
MCNUM focus_ah = mccdiffraction_detector_17_exit_volume_focus_ah;
MCNUM focus_xw = mccdiffraction_detector_17_exit_volume_focus_xw;
MCNUM focus_xh = mccdiffraction_detector_17_exit_volume_focus_xh;
MCNUM focus_r = mccdiffraction_detector_17_exit_volume_focus_r;
MCNUM p_interact = mccdiffraction_detector_17_exit_volume_p_interact;
char* mask_string = mccdiffraction_detector_17_exit_volume_mask_string;
char* mask_setting = mccdiffraction_detector_17_exit_volume_mask_setting;
MCNUM number_of_activations = mccdiffraction_detector_17_exit_volume_number_of_activations;
}   /* End of diffraction_detector_17_exit_volume=Union_box() SETTING parameter declarations. */
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex
  /* Label for restoring  neutron */
  mcabsorbCompdiffraction_detector_17_exit_volume:
  if (RESTORE) /* restore if needed */
  { RESTORE_NEUTRON(806,
      mcnlx,
      mcnly,
      mcnlz,
      mcnlvx,
      mcnlvy,
      mcnlvz,
      mcnlt,
      mcnlsx,
      mcnlsy,
      mcnlsz,
      mcnlp); }
#undef mcabsorbComp
#undef p
#undef sz
#undef sy
#undef sx
#undef t
#undef vz
#undef vy
#undef vx
#undef z
#undef y
#undef x
  mcDEBUG_STATE(
mcnlx,
mcnly,
mcnlz,
mcnlvx,
mcnlvy,
mcnlvz,
mcnlt,
mcnlsx,
mcnlsy,
mcnlsz,
mcnlp)

  /* TRACE Component spec_detector_17_exit_volume [807] */
  mccoordschange(mcposrspec_detector_17_exit_volume, mcrotrspec_detector_17_exit_volume,
    &mcnlx,
    &mcnly,
    &mcnlz,
    &mcnlvx,
    &mcnlvy,
    &mcnlvz,
    &mcnlsx,
    &mcnlsy,
    &mcnlsz);
  /* define label inside component spec_detector_17_exit_volume (without coords transformations) */
  mcJumpTrace_spec_detector_17_exit_volume:
  SIG_MESSAGE("spec_detector_17_exit_volume (Trace)");
  mcDEBUG_COMP("spec_detector_17_exit_volume")
  mcDEBUG_STATE(
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp)
#define x mcnlx
#define y mcnly
#define z mcnlz
#define vx mcnlvx
#define vy mcnlvy
#define vz mcnlvz
#define t mcnlt
#define sx mcnlsx
#define sy mcnlsy
#define sz mcnlsz
#define p mcnlp

#define mcabsorbComp mcabsorbCompspec_detector_17_exit_volume
  STORE_NEUTRON(807,
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp);
  mcScattered=0;
  mcRestore=0;
  mcNCounter[807]++;
  mcPCounter[807] += p;
  mcP2Counter[807] += p*p;
#define mccompcurname  spec_detector_17_exit_volume
#define mccompcurtype  Union_box
#define mccompcurindex 807
#define loop_index mccspec_detector_17_exit_volume_loop_index
#define this_box_volume mccspec_detector_17_exit_volume_this_box_volume
#define global_geometry_element mccspec_detector_17_exit_volume_global_geometry_element
#define this_box_storage mccspec_detector_17_exit_volume_this_box_storage
{   /* Declarations of spec_detector_17_exit_volume=Union_box() SETTING parameters. */
char* material_string = mccspec_detector_17_exit_volume_material_string;
MCNUM priority = mccspec_detector_17_exit_volume_priority;
MCNUM xwidth = mccspec_detector_17_exit_volume_xwidth;
MCNUM yheight = mccspec_detector_17_exit_volume_yheight;
MCNUM zdepth = mccspec_detector_17_exit_volume_zdepth;
MCNUM xwidth2 = mccspec_detector_17_exit_volume_xwidth2;
MCNUM yheight2 = mccspec_detector_17_exit_volume_yheight2;
MCNUM visualize = mccspec_detector_17_exit_volume_visualize;
int target_index = mccspec_detector_17_exit_volume_target_index;
MCNUM target_x = mccspec_detector_17_exit_volume_target_x;
MCNUM target_y = mccspec_detector_17_exit_volume_target_y;
MCNUM target_z = mccspec_detector_17_exit_volume_target_z;
MCNUM focus_aw = mccspec_detector_17_exit_volume_focus_aw;
MCNUM focus_ah = mccspec_detector_17_exit_volume_focus_ah;
MCNUM focus_xw = mccspec_detector_17_exit_volume_focus_xw;
MCNUM focus_xh = mccspec_detector_17_exit_volume_focus_xh;
MCNUM focus_r = mccspec_detector_17_exit_volume_focus_r;
MCNUM p_interact = mccspec_detector_17_exit_volume_p_interact;
char* mask_string = mccspec_detector_17_exit_volume_mask_string;
char* mask_setting = mccspec_detector_17_exit_volume_mask_setting;
MCNUM number_of_activations = mccspec_detector_17_exit_volume_number_of_activations;
}   /* End of spec_detector_17_exit_volume=Union_box() SETTING parameter declarations. */
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex
  /* Label for restoring  neutron */
  mcabsorbCompspec_detector_17_exit_volume:
  if (RESTORE) /* restore if needed */
  { RESTORE_NEUTRON(807,
      mcnlx,
      mcnly,
      mcnlz,
      mcnlvx,
      mcnlvy,
      mcnlvz,
      mcnlt,
      mcnlsx,
      mcnlsy,
      mcnlsz,
      mcnlp); }
#undef mcabsorbComp
#undef p
#undef sz
#undef sy
#undef sx
#undef t
#undef vz
#undef vy
#undef vx
#undef z
#undef y
#undef x
  mcDEBUG_STATE(
mcnlx,
mcnly,
mcnlz,
mcnlvx,
mcnlvy,
mcnlvz,
mcnlt,
mcnlsx,
mcnlsy,
mcnlsz,
mcnlp)

  /* TRACE Component channel_18_cave1_box1 [808] */
  mccoordschange(mcposrchannel_18_cave1_box1, mcrotrchannel_18_cave1_box1,
    &mcnlx,
    &mcnly,
    &mcnlz,
    &mcnlvx,
    &mcnlvy,
    &mcnlvz,
    &mcnlsx,
    &mcnlsy,
    &mcnlsz);
  /* define label inside component channel_18_cave1_box1 (without coords transformations) */
  mcJumpTrace_channel_18_cave1_box1:
  SIG_MESSAGE("channel_18_cave1_box1 (Trace)");
  mcDEBUG_COMP("channel_18_cave1_box1")
  mcDEBUG_STATE(
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp)
#define x mcnlx
#define y mcnly
#define z mcnlz
#define vx mcnlvx
#define vy mcnlvy
#define vz mcnlvz
#define t mcnlt
#define sx mcnlsx
#define sy mcnlsy
#define sz mcnlsz
#define p mcnlp

#define mcabsorbComp mcabsorbCompchannel_18_cave1_box1
  STORE_NEUTRON(808,
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp);
  mcScattered=0;
  mcRestore=0;
  mcNCounter[808]++;
  mcPCounter[808] += p;
  mcP2Counter[808] += p*p;
#define mccompcurname  channel_18_cave1_box1
#define mccompcurtype  Union_box
#define mccompcurindex 808
#define loop_index mccchannel_18_cave1_box1_loop_index
#define this_box_volume mccchannel_18_cave1_box1_this_box_volume
#define global_geometry_element mccchannel_18_cave1_box1_global_geometry_element
#define this_box_storage mccchannel_18_cave1_box1_this_box_storage
{   /* Declarations of channel_18_cave1_box1=Union_box() SETTING parameters. */
char* material_string = mccchannel_18_cave1_box1_material_string;
MCNUM priority = mccchannel_18_cave1_box1_priority;
MCNUM xwidth = mccchannel_18_cave1_box1_xwidth;
MCNUM yheight = mccchannel_18_cave1_box1_yheight;
MCNUM zdepth = mccchannel_18_cave1_box1_zdepth;
MCNUM xwidth2 = mccchannel_18_cave1_box1_xwidth2;
MCNUM yheight2 = mccchannel_18_cave1_box1_yheight2;
MCNUM visualize = mccchannel_18_cave1_box1_visualize;
int target_index = mccchannel_18_cave1_box1_target_index;
MCNUM target_x = mccchannel_18_cave1_box1_target_x;
MCNUM target_y = mccchannel_18_cave1_box1_target_y;
MCNUM target_z = mccchannel_18_cave1_box1_target_z;
MCNUM focus_aw = mccchannel_18_cave1_box1_focus_aw;
MCNUM focus_ah = mccchannel_18_cave1_box1_focus_ah;
MCNUM focus_xw = mccchannel_18_cave1_box1_focus_xw;
MCNUM focus_xh = mccchannel_18_cave1_box1_focus_xh;
MCNUM focus_r = mccchannel_18_cave1_box1_focus_r;
MCNUM p_interact = mccchannel_18_cave1_box1_p_interact;
char* mask_string = mccchannel_18_cave1_box1_mask_string;
char* mask_setting = mccchannel_18_cave1_box1_mask_setting;
MCNUM number_of_activations = mccchannel_18_cave1_box1_number_of_activations;
}   /* End of channel_18_cave1_box1=Union_box() SETTING parameter declarations. */
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex
  /* Label for restoring  neutron */
  mcabsorbCompchannel_18_cave1_box1:
  if (RESTORE) /* restore if needed */
  { RESTORE_NEUTRON(808,
      mcnlx,
      mcnly,
      mcnlz,
      mcnlvx,
      mcnlvy,
      mcnlvz,
      mcnlt,
      mcnlsx,
      mcnlsy,
      mcnlsz,
      mcnlp); }
#undef mcabsorbComp
#undef p
#undef sz
#undef sy
#undef sx
#undef t
#undef vz
#undef vy
#undef vx
#undef z
#undef y
#undef x
  mcDEBUG_STATE(
mcnlx,
mcnly,
mcnlz,
mcnlvx,
mcnlvy,
mcnlvz,
mcnlt,
mcnlsx,
mcnlsy,
mcnlsz,
mcnlp)

  /* TRACE Component channel_18_cave1_box2 [809] */
  mccoordschange(mcposrchannel_18_cave1_box2, mcrotrchannel_18_cave1_box2,
    &mcnlx,
    &mcnly,
    &mcnlz,
    &mcnlvx,
    &mcnlvy,
    &mcnlvz,
    &mcnlsx,
    &mcnlsy,
    &mcnlsz);
  /* define label inside component channel_18_cave1_box2 (without coords transformations) */
  mcJumpTrace_channel_18_cave1_box2:
  SIG_MESSAGE("channel_18_cave1_box2 (Trace)");
  mcDEBUG_COMP("channel_18_cave1_box2")
  mcDEBUG_STATE(
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp)
#define x mcnlx
#define y mcnly
#define z mcnlz
#define vx mcnlvx
#define vy mcnlvy
#define vz mcnlvz
#define t mcnlt
#define sx mcnlsx
#define sy mcnlsy
#define sz mcnlsz
#define p mcnlp

#define mcabsorbComp mcabsorbCompchannel_18_cave1_box2
  STORE_NEUTRON(809,
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp);
  mcScattered=0;
  mcRestore=0;
  mcNCounter[809]++;
  mcPCounter[809] += p;
  mcP2Counter[809] += p*p;
#define mccompcurname  channel_18_cave1_box2
#define mccompcurtype  Union_box
#define mccompcurindex 809
#define loop_index mccchannel_18_cave1_box2_loop_index
#define this_box_volume mccchannel_18_cave1_box2_this_box_volume
#define global_geometry_element mccchannel_18_cave1_box2_global_geometry_element
#define this_box_storage mccchannel_18_cave1_box2_this_box_storage
{   /* Declarations of channel_18_cave1_box2=Union_box() SETTING parameters. */
char* material_string = mccchannel_18_cave1_box2_material_string;
MCNUM priority = mccchannel_18_cave1_box2_priority;
MCNUM xwidth = mccchannel_18_cave1_box2_xwidth;
MCNUM yheight = mccchannel_18_cave1_box2_yheight;
MCNUM zdepth = mccchannel_18_cave1_box2_zdepth;
MCNUM xwidth2 = mccchannel_18_cave1_box2_xwidth2;
MCNUM yheight2 = mccchannel_18_cave1_box2_yheight2;
MCNUM visualize = mccchannel_18_cave1_box2_visualize;
int target_index = mccchannel_18_cave1_box2_target_index;
MCNUM target_x = mccchannel_18_cave1_box2_target_x;
MCNUM target_y = mccchannel_18_cave1_box2_target_y;
MCNUM target_z = mccchannel_18_cave1_box2_target_z;
MCNUM focus_aw = mccchannel_18_cave1_box2_focus_aw;
MCNUM focus_ah = mccchannel_18_cave1_box2_focus_ah;
MCNUM focus_xw = mccchannel_18_cave1_box2_focus_xw;
MCNUM focus_xh = mccchannel_18_cave1_box2_focus_xh;
MCNUM focus_r = mccchannel_18_cave1_box2_focus_r;
MCNUM p_interact = mccchannel_18_cave1_box2_p_interact;
char* mask_string = mccchannel_18_cave1_box2_mask_string;
char* mask_setting = mccchannel_18_cave1_box2_mask_setting;
MCNUM number_of_activations = mccchannel_18_cave1_box2_number_of_activations;
}   /* End of channel_18_cave1_box2=Union_box() SETTING parameter declarations. */
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex
  /* Label for restoring  neutron */
  mcabsorbCompchannel_18_cave1_box2:
  if (RESTORE) /* restore if needed */
  { RESTORE_NEUTRON(809,
      mcnlx,
      mcnly,
      mcnlz,
      mcnlvx,
      mcnlvy,
      mcnlvz,
      mcnlt,
      mcnlsx,
      mcnlsy,
      mcnlsz,
      mcnlp); }
#undef mcabsorbComp
#undef p
#undef sz
#undef sy
#undef sx
#undef t
#undef vz
#undef vy
#undef vx
#undef z
#undef y
#undef x
  mcDEBUG_STATE(
mcnlx,
mcnly,
mcnlz,
mcnlvx,
mcnlvy,
mcnlvz,
mcnlt,
mcnlsx,
mcnlsy,
mcnlsz,
mcnlp)

  /* TRACE Component channel_18_cave1_box3 [810] */
  mccoordschange(mcposrchannel_18_cave1_box3, mcrotrchannel_18_cave1_box3,
    &mcnlx,
    &mcnly,
    &mcnlz,
    &mcnlvx,
    &mcnlvy,
    &mcnlvz,
    &mcnlsx,
    &mcnlsy,
    &mcnlsz);
  /* define label inside component channel_18_cave1_box3 (without coords transformations) */
  mcJumpTrace_channel_18_cave1_box3:
  SIG_MESSAGE("channel_18_cave1_box3 (Trace)");
  mcDEBUG_COMP("channel_18_cave1_box3")
  mcDEBUG_STATE(
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp)
#define x mcnlx
#define y mcnly
#define z mcnlz
#define vx mcnlvx
#define vy mcnlvy
#define vz mcnlvz
#define t mcnlt
#define sx mcnlsx
#define sy mcnlsy
#define sz mcnlsz
#define p mcnlp

#define mcabsorbComp mcabsorbCompchannel_18_cave1_box3
  STORE_NEUTRON(810,
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp);
  mcScattered=0;
  mcRestore=0;
  mcNCounter[810]++;
  mcPCounter[810] += p;
  mcP2Counter[810] += p*p;
#define mccompcurname  channel_18_cave1_box3
#define mccompcurtype  Union_box
#define mccompcurindex 810
#define loop_index mccchannel_18_cave1_box3_loop_index
#define this_box_volume mccchannel_18_cave1_box3_this_box_volume
#define global_geometry_element mccchannel_18_cave1_box3_global_geometry_element
#define this_box_storage mccchannel_18_cave1_box3_this_box_storage
{   /* Declarations of channel_18_cave1_box3=Union_box() SETTING parameters. */
char* material_string = mccchannel_18_cave1_box3_material_string;
MCNUM priority = mccchannel_18_cave1_box3_priority;
MCNUM xwidth = mccchannel_18_cave1_box3_xwidth;
MCNUM yheight = mccchannel_18_cave1_box3_yheight;
MCNUM zdepth = mccchannel_18_cave1_box3_zdepth;
MCNUM xwidth2 = mccchannel_18_cave1_box3_xwidth2;
MCNUM yheight2 = mccchannel_18_cave1_box3_yheight2;
MCNUM visualize = mccchannel_18_cave1_box3_visualize;
int target_index = mccchannel_18_cave1_box3_target_index;
MCNUM target_x = mccchannel_18_cave1_box3_target_x;
MCNUM target_y = mccchannel_18_cave1_box3_target_y;
MCNUM target_z = mccchannel_18_cave1_box3_target_z;
MCNUM focus_aw = mccchannel_18_cave1_box3_focus_aw;
MCNUM focus_ah = mccchannel_18_cave1_box3_focus_ah;
MCNUM focus_xw = mccchannel_18_cave1_box3_focus_xw;
MCNUM focus_xh = mccchannel_18_cave1_box3_focus_xh;
MCNUM focus_r = mccchannel_18_cave1_box3_focus_r;
MCNUM p_interact = mccchannel_18_cave1_box3_p_interact;
char* mask_string = mccchannel_18_cave1_box3_mask_string;
char* mask_setting = mccchannel_18_cave1_box3_mask_setting;
MCNUM number_of_activations = mccchannel_18_cave1_box3_number_of_activations;
}   /* End of channel_18_cave1_box3=Union_box() SETTING parameter declarations. */
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex
  /* Label for restoring  neutron */
  mcabsorbCompchannel_18_cave1_box3:
  if (RESTORE) /* restore if needed */
  { RESTORE_NEUTRON(810,
      mcnlx,
      mcnly,
      mcnlz,
      mcnlvx,
      mcnlvy,
      mcnlvz,
      mcnlt,
      mcnlsx,
      mcnlsy,
      mcnlsz,
      mcnlp); }
#undef mcabsorbComp
#undef p
#undef sz
#undef sy
#undef sx
#undef t
#undef vz
#undef vy
#undef vx
#undef z
#undef y
#undef x
  mcDEBUG_STATE(
mcnlx,
mcnly,
mcnlz,
mcnlvx,
mcnlvy,
mcnlvz,
mcnlt,
mcnlsx,
mcnlsy,
mcnlsz,
mcnlp)

  /* TRACE Component channel_18_cave1_cyl1 [811] */
  mccoordschange(mcposrchannel_18_cave1_cyl1, mcrotrchannel_18_cave1_cyl1,
    &mcnlx,
    &mcnly,
    &mcnlz,
    &mcnlvx,
    &mcnlvy,
    &mcnlvz,
    &mcnlsx,
    &mcnlsy,
    &mcnlsz);
  /* define label inside component channel_18_cave1_cyl1 (without coords transformations) */
  mcJumpTrace_channel_18_cave1_cyl1:
  SIG_MESSAGE("channel_18_cave1_cyl1 (Trace)");
  mcDEBUG_COMP("channel_18_cave1_cyl1")
  mcDEBUG_STATE(
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp)
#define x mcnlx
#define y mcnly
#define z mcnlz
#define vx mcnlvx
#define vy mcnlvy
#define vz mcnlvz
#define t mcnlt
#define sx mcnlsx
#define sy mcnlsy
#define sz mcnlsz
#define p mcnlp

#define mcabsorbComp mcabsorbCompchannel_18_cave1_cyl1
  STORE_NEUTRON(811,
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp);
  mcScattered=0;
  mcRestore=0;
  mcNCounter[811]++;
  mcPCounter[811] += p;
  mcP2Counter[811] += p*p;
#define mccompcurname  channel_18_cave1_cyl1
#define mccompcurtype  Union_cylinder
#define mccompcurindex 811
#define loop_index mccchannel_18_cave1_cyl1_loop_index
#define this_cylinder_volume mccchannel_18_cave1_cyl1_this_cylinder_volume
#define global_geometry_element mccchannel_18_cave1_cyl1_global_geometry_element
#define this_cylinder_storage mccchannel_18_cave1_cyl1_this_cylinder_storage
{   /* Declarations of channel_18_cave1_cyl1=Union_cylinder() SETTING parameters. */
char* material_string = mccchannel_18_cave1_cyl1_material_string;
MCNUM priority = mccchannel_18_cave1_cyl1_priority;
MCNUM radius = mccchannel_18_cave1_cyl1_radius;
MCNUM yheight = mccchannel_18_cave1_cyl1_yheight;
MCNUM visualize = mccchannel_18_cave1_cyl1_visualize;
int target_index = mccchannel_18_cave1_cyl1_target_index;
MCNUM target_x = mccchannel_18_cave1_cyl1_target_x;
MCNUM target_y = mccchannel_18_cave1_cyl1_target_y;
MCNUM target_z = mccchannel_18_cave1_cyl1_target_z;
MCNUM focus_aw = mccchannel_18_cave1_cyl1_focus_aw;
MCNUM focus_ah = mccchannel_18_cave1_cyl1_focus_ah;
MCNUM focus_xw = mccchannel_18_cave1_cyl1_focus_xw;
MCNUM focus_xh = mccchannel_18_cave1_cyl1_focus_xh;
MCNUM focus_r = mccchannel_18_cave1_cyl1_focus_r;
MCNUM p_interact = mccchannel_18_cave1_cyl1_p_interact;
char* mask_string = mccchannel_18_cave1_cyl1_mask_string;
char* mask_setting = mccchannel_18_cave1_cyl1_mask_setting;
MCNUM number_of_activations = mccchannel_18_cave1_cyl1_number_of_activations;
#line 345 "Union_cylinder.comp"
{
dummy = 1;
}
#line 451996 "MACS_sample_kidney_box.c"
}   /* End of channel_18_cave1_cyl1=Union_cylinder() SETTING parameter declarations. */
#undef this_cylinder_storage
#undef global_geometry_element
#undef this_cylinder_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex
  /* Label for restoring  neutron */
  mcabsorbCompchannel_18_cave1_cyl1:
  if (RESTORE) /* restore if needed */
  { RESTORE_NEUTRON(811,
      mcnlx,
      mcnly,
      mcnlz,
      mcnlvx,
      mcnlvy,
      mcnlvz,
      mcnlt,
      mcnlsx,
      mcnlsy,
      mcnlsz,
      mcnlp); }
#undef mcabsorbComp
#undef p
#undef sz
#undef sy
#undef sx
#undef t
#undef vz
#undef vy
#undef vx
#undef z
#undef y
#undef x
  mcDEBUG_STATE(
mcnlx,
mcnly,
mcnlz,
mcnlvx,
mcnlvy,
mcnlvz,
mcnlt,
mcnlsx,
mcnlsy,
mcnlsz,
mcnlp)

  /* TRACE Component channel_18_analyzer_1_center [812] */
  mccoordschange(mcposrchannel_18_analyzer_1_center, mcrotrchannel_18_analyzer_1_center,
    &mcnlx,
    &mcnly,
    &mcnlz,
    &mcnlvx,
    &mcnlvy,
    &mcnlvz,
    &mcnlsx,
    &mcnlsy,
    &mcnlsz);
  /* define label inside component channel_18_analyzer_1_center (without coords transformations) */
  mcJumpTrace_channel_18_analyzer_1_center:
  SIG_MESSAGE("channel_18_analyzer_1_center (Trace)");
  mcDEBUG_COMP("channel_18_analyzer_1_center")
  mcDEBUG_STATE(
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp)
#define x mcnlx
#define y mcnly
#define z mcnlz
#define vx mcnlvx
#define vy mcnlvy
#define vz mcnlvz
#define t mcnlt
#define sx mcnlsx
#define sy mcnlsy
#define sz mcnlsz
#define p mcnlp

#define mcabsorbComp mcabsorbCompchannel_18_analyzer_1_center
  STORE_NEUTRON(812,
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp);
  mcScattered=0;
  mcRestore=0;
  mcNCounter[812]++;
  mcPCounter[812] += p;
  mcP2Counter[812] += p*p;
#define mccompcurname  channel_18_analyzer_1_center
#define mccompcurtype  Arm
#define mccompcurindex 812
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex
  /* Label for restoring  neutron */
  mcabsorbCompchannel_18_analyzer_1_center:
  if (RESTORE) /* restore if needed */
  { RESTORE_NEUTRON(812,
      mcnlx,
      mcnly,
      mcnlz,
      mcnlvx,
      mcnlvy,
      mcnlvz,
      mcnlt,
      mcnlsx,
      mcnlsy,
      mcnlsz,
      mcnlp); }
#undef mcabsorbComp
#undef p
#undef sz
#undef sy
#undef sx
#undef t
#undef vz
#undef vy
#undef vx
#undef z
#undef y
#undef x
  mcDEBUG_STATE(
mcnlx,
mcnly,
mcnlz,
mcnlvx,
mcnlvy,
mcnlvz,
mcnlt,
mcnlsx,
mcnlsy,
mcnlsz,
mcnlp)

  /* TRACE Component channel_18_analyzer_1_rotated [813] */
  mccoordschange(mcposrchannel_18_analyzer_1_rotated, mcrotrchannel_18_analyzer_1_rotated,
    &mcnlx,
    &mcnly,
    &mcnlz,
    &mcnlvx,
    &mcnlvy,
    &mcnlvz,
    &mcnlsx,
    &mcnlsy,
    &mcnlsz);
  /* define label inside component channel_18_analyzer_1_rotated (without coords transformations) */
  mcJumpTrace_channel_18_analyzer_1_rotated:
  SIG_MESSAGE("channel_18_analyzer_1_rotated (Trace)");
  mcDEBUG_COMP("channel_18_analyzer_1_rotated")
  mcDEBUG_STATE(
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp)
#define x mcnlx
#define y mcnly
#define z mcnlz
#define vx mcnlvx
#define vy mcnlvy
#define vz mcnlvz
#define t mcnlt
#define sx mcnlsx
#define sy mcnlsy
#define sz mcnlsz
#define p mcnlp

#define mcabsorbComp mcabsorbCompchannel_18_analyzer_1_rotated
  STORE_NEUTRON(813,
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp);
  mcScattered=0;
  mcRestore=0;
  mcNCounter[813]++;
  mcPCounter[813] += p;
  mcP2Counter[813] += p*p;
#define mccompcurname  channel_18_analyzer_1_rotated
#define mccompcurtype  Arm
#define mccompcurindex 813
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex
  /* Label for restoring  neutron */
  mcabsorbCompchannel_18_analyzer_1_rotated:
  if (RESTORE) /* restore if needed */
  { RESTORE_NEUTRON(813,
      mcnlx,
      mcnly,
      mcnlz,
      mcnlvx,
      mcnlvy,
      mcnlvz,
      mcnlt,
      mcnlsx,
      mcnlsy,
      mcnlsz,
      mcnlp); }
#undef mcabsorbComp
#undef p
#undef sz
#undef sy
#undef sx
#undef t
#undef vz
#undef vy
#undef vx
#undef z
#undef y
#undef x
  mcDEBUG_STATE(
mcnlx,
mcnly,
mcnlz,
mcnlvx,
mcnlvy,
mcnlvz,
mcnlt,
mcnlsx,
mcnlsy,
mcnlsz,
mcnlp)

  /* TRACE Component channel_18_analyzer_1_array_crystal_array_0 [814] */
  mccoordschange(mcposrchannel_18_analyzer_1_array_crystal_array_0, mcrotrchannel_18_analyzer_1_array_crystal_array_0,
    &mcnlx,
    &mcnly,
    &mcnlz,
    &mcnlvx,
    &mcnlvy,
    &mcnlvz,
    &mcnlsx,
    &mcnlsy,
    &mcnlsz);
  /* define label inside component channel_18_analyzer_1_array_crystal_array_0 (without coords transformations) */
  mcJumpTrace_channel_18_analyzer_1_array_crystal_array_0:
  SIG_MESSAGE("channel_18_analyzer_1_array_crystal_array_0 (Trace)");
  mcDEBUG_COMP("channel_18_analyzer_1_array_crystal_array_0")
  mcDEBUG_STATE(
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp)
#define x mcnlx
#define y mcnly
#define z mcnlz
#define vx mcnlvx
#define vy mcnlvy
#define vz mcnlvz
#define t mcnlt
#define sx mcnlsx
#define sy mcnlsy
#define sz mcnlsz
#define p mcnlp

#define mcabsorbComp mcabsorbCompchannel_18_analyzer_1_array_crystal_array_0
  STORE_NEUTRON(814,
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp);
  mcScattered=0;
  mcRestore=0;
  mcNCounter[814]++;
  mcPCounter[814] += p;
  mcP2Counter[814] += p*p;
#define mccompcurname  channel_18_analyzer_1_array_crystal_array_0
#define mccompcurtype  Union_box
#define mccompcurindex 814
#define loop_index mccchannel_18_analyzer_1_array_crystal_array_0_loop_index
#define this_box_volume mccchannel_18_analyzer_1_array_crystal_array_0_this_box_volume
#define global_geometry_element mccchannel_18_analyzer_1_array_crystal_array_0_global_geometry_element
#define this_box_storage mccchannel_18_analyzer_1_array_crystal_array_0_this_box_storage
{   /* Declarations of channel_18_analyzer_1_array_crystal_array_0=Union_box() SETTING parameters. */
char* material_string = mccchannel_18_analyzer_1_array_crystal_array_0_material_string;
MCNUM priority = mccchannel_18_analyzer_1_array_crystal_array_0_priority;
MCNUM xwidth = mccchannel_18_analyzer_1_array_crystal_array_0_xwidth;
MCNUM yheight = mccchannel_18_analyzer_1_array_crystal_array_0_yheight;
MCNUM zdepth = mccchannel_18_analyzer_1_array_crystal_array_0_zdepth;
MCNUM xwidth2 = mccchannel_18_analyzer_1_array_crystal_array_0_xwidth2;
MCNUM yheight2 = mccchannel_18_analyzer_1_array_crystal_array_0_yheight2;
MCNUM visualize = mccchannel_18_analyzer_1_array_crystal_array_0_visualize;
int target_index = mccchannel_18_analyzer_1_array_crystal_array_0_target_index;
MCNUM target_x = mccchannel_18_analyzer_1_array_crystal_array_0_target_x;
MCNUM target_y = mccchannel_18_analyzer_1_array_crystal_array_0_target_y;
MCNUM target_z = mccchannel_18_analyzer_1_array_crystal_array_0_target_z;
MCNUM focus_aw = mccchannel_18_analyzer_1_array_crystal_array_0_focus_aw;
MCNUM focus_ah = mccchannel_18_analyzer_1_array_crystal_array_0_focus_ah;
MCNUM focus_xw = mccchannel_18_analyzer_1_array_crystal_array_0_focus_xw;
MCNUM focus_xh = mccchannel_18_analyzer_1_array_crystal_array_0_focus_xh;
MCNUM focus_r = mccchannel_18_analyzer_1_array_crystal_array_0_focus_r;
MCNUM p_interact = mccchannel_18_analyzer_1_array_crystal_array_0_p_interact;
char* mask_string = mccchannel_18_analyzer_1_array_crystal_array_0_mask_string;
char* mask_setting = mccchannel_18_analyzer_1_array_crystal_array_0_mask_setting;
MCNUM number_of_activations = mccchannel_18_analyzer_1_array_crystal_array_0_number_of_activations;
}   /* End of channel_18_analyzer_1_array_crystal_array_0=Union_box() SETTING parameter declarations. */
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex
  /* Label for restoring  neutron */
  mcabsorbCompchannel_18_analyzer_1_array_crystal_array_0:
  if (RESTORE) /* restore if needed */
  { RESTORE_NEUTRON(814,
      mcnlx,
      mcnly,
      mcnlz,
      mcnlvx,
      mcnlvy,
      mcnlvz,
      mcnlt,
      mcnlsx,
      mcnlsy,
      mcnlsz,
      mcnlp); }
#undef mcabsorbComp
#undef p
#undef sz
#undef sy
#undef sx
#undef t
#undef vz
#undef vy
#undef vx
#undef z
#undef y
#undef x
  mcDEBUG_STATE(
mcnlx,
mcnly,
mcnlz,
mcnlvx,
mcnlvy,
mcnlvz,
mcnlt,
mcnlsx,
mcnlsy,
mcnlsz,
mcnlp)

  /* TRACE Component channel_18_analyzer_1_array_crystal_array_1 [815] */
  mccoordschange(mcposrchannel_18_analyzer_1_array_crystal_array_1, mcrotrchannel_18_analyzer_1_array_crystal_array_1,
    &mcnlx,
    &mcnly,
    &mcnlz,
    &mcnlvx,
    &mcnlvy,
    &mcnlvz,
    &mcnlsx,
    &mcnlsy,
    &mcnlsz);
  /* define label inside component channel_18_analyzer_1_array_crystal_array_1 (without coords transformations) */
  mcJumpTrace_channel_18_analyzer_1_array_crystal_array_1:
  SIG_MESSAGE("channel_18_analyzer_1_array_crystal_array_1 (Trace)");
  mcDEBUG_COMP("channel_18_analyzer_1_array_crystal_array_1")
  mcDEBUG_STATE(
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp)
#define x mcnlx
#define y mcnly
#define z mcnlz
#define vx mcnlvx
#define vy mcnlvy
#define vz mcnlvz
#define t mcnlt
#define sx mcnlsx
#define sy mcnlsy
#define sz mcnlsz
#define p mcnlp

#define mcabsorbComp mcabsorbCompchannel_18_analyzer_1_array_crystal_array_1
  STORE_NEUTRON(815,
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp);
  mcScattered=0;
  mcRestore=0;
  mcNCounter[815]++;
  mcPCounter[815] += p;
  mcP2Counter[815] += p*p;
#define mccompcurname  channel_18_analyzer_1_array_crystal_array_1
#define mccompcurtype  Union_box
#define mccompcurindex 815
#define loop_index mccchannel_18_analyzer_1_array_crystal_array_1_loop_index
#define this_box_volume mccchannel_18_analyzer_1_array_crystal_array_1_this_box_volume
#define global_geometry_element mccchannel_18_analyzer_1_array_crystal_array_1_global_geometry_element
#define this_box_storage mccchannel_18_analyzer_1_array_crystal_array_1_this_box_storage
{   /* Declarations of channel_18_analyzer_1_array_crystal_array_1=Union_box() SETTING parameters. */
char* material_string = mccchannel_18_analyzer_1_array_crystal_array_1_material_string;
MCNUM priority = mccchannel_18_analyzer_1_array_crystal_array_1_priority;
MCNUM xwidth = mccchannel_18_analyzer_1_array_crystal_array_1_xwidth;
MCNUM yheight = mccchannel_18_analyzer_1_array_crystal_array_1_yheight;
MCNUM zdepth = mccchannel_18_analyzer_1_array_crystal_array_1_zdepth;
MCNUM xwidth2 = mccchannel_18_analyzer_1_array_crystal_array_1_xwidth2;
MCNUM yheight2 = mccchannel_18_analyzer_1_array_crystal_array_1_yheight2;
MCNUM visualize = mccchannel_18_analyzer_1_array_crystal_array_1_visualize;
int target_index = mccchannel_18_analyzer_1_array_crystal_array_1_target_index;
MCNUM target_x = mccchannel_18_analyzer_1_array_crystal_array_1_target_x;
MCNUM target_y = mccchannel_18_analyzer_1_array_crystal_array_1_target_y;
MCNUM target_z = mccchannel_18_analyzer_1_array_crystal_array_1_target_z;
MCNUM focus_aw = mccchannel_18_analyzer_1_array_crystal_array_1_focus_aw;
MCNUM focus_ah = mccchannel_18_analyzer_1_array_crystal_array_1_focus_ah;
MCNUM focus_xw = mccchannel_18_analyzer_1_array_crystal_array_1_focus_xw;
MCNUM focus_xh = mccchannel_18_analyzer_1_array_crystal_array_1_focus_xh;
MCNUM focus_r = mccchannel_18_analyzer_1_array_crystal_array_1_focus_r;
MCNUM p_interact = mccchannel_18_analyzer_1_array_crystal_array_1_p_interact;
char* mask_string = mccchannel_18_analyzer_1_array_crystal_array_1_mask_string;
char* mask_setting = mccchannel_18_analyzer_1_array_crystal_array_1_mask_setting;
MCNUM number_of_activations = mccchannel_18_analyzer_1_array_crystal_array_1_number_of_activations;
}   /* End of channel_18_analyzer_1_array_crystal_array_1=Union_box() SETTING parameter declarations. */
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex
  /* Label for restoring  neutron */
  mcabsorbCompchannel_18_analyzer_1_array_crystal_array_1:
  if (RESTORE) /* restore if needed */
  { RESTORE_NEUTRON(815,
      mcnlx,
      mcnly,
      mcnlz,
      mcnlvx,
      mcnlvy,
      mcnlvz,
      mcnlt,
      mcnlsx,
      mcnlsy,
      mcnlsz,
      mcnlp); }
#undef mcabsorbComp
#undef p
#undef sz
#undef sy
#undef sx
#undef t
#undef vz
#undef vy
#undef vx
#undef z
#undef y
#undef x
  mcDEBUG_STATE(
mcnlx,
mcnly,
mcnlz,
mcnlvx,
mcnlvy,
mcnlvz,
mcnlt,
mcnlsx,
mcnlsy,
mcnlsz,
mcnlp)

  /* TRACE Component channel_18_analyzer_1_array_crystal_array_2 [816] */
  mccoordschange(mcposrchannel_18_analyzer_1_array_crystal_array_2, mcrotrchannel_18_analyzer_1_array_crystal_array_2,
    &mcnlx,
    &mcnly,
    &mcnlz,
    &mcnlvx,
    &mcnlvy,
    &mcnlvz,
    &mcnlsx,
    &mcnlsy,
    &mcnlsz);
  /* define label inside component channel_18_analyzer_1_array_crystal_array_2 (without coords transformations) */
  mcJumpTrace_channel_18_analyzer_1_array_crystal_array_2:
  SIG_MESSAGE("channel_18_analyzer_1_array_crystal_array_2 (Trace)");
  mcDEBUG_COMP("channel_18_analyzer_1_array_crystal_array_2")
  mcDEBUG_STATE(
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp)
#define x mcnlx
#define y mcnly
#define z mcnlz
#define vx mcnlvx
#define vy mcnlvy
#define vz mcnlvz
#define t mcnlt
#define sx mcnlsx
#define sy mcnlsy
#define sz mcnlsz
#define p mcnlp

#define mcabsorbComp mcabsorbCompchannel_18_analyzer_1_array_crystal_array_2
  STORE_NEUTRON(816,
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp);
  mcScattered=0;
  mcRestore=0;
  mcNCounter[816]++;
  mcPCounter[816] += p;
  mcP2Counter[816] += p*p;
#define mccompcurname  channel_18_analyzer_1_array_crystal_array_2
#define mccompcurtype  Union_box
#define mccompcurindex 816
#define loop_index mccchannel_18_analyzer_1_array_crystal_array_2_loop_index
#define this_box_volume mccchannel_18_analyzer_1_array_crystal_array_2_this_box_volume
#define global_geometry_element mccchannel_18_analyzer_1_array_crystal_array_2_global_geometry_element
#define this_box_storage mccchannel_18_analyzer_1_array_crystal_array_2_this_box_storage
{   /* Declarations of channel_18_analyzer_1_array_crystal_array_2=Union_box() SETTING parameters. */
char* material_string = mccchannel_18_analyzer_1_array_crystal_array_2_material_string;
MCNUM priority = mccchannel_18_analyzer_1_array_crystal_array_2_priority;
MCNUM xwidth = mccchannel_18_analyzer_1_array_crystal_array_2_xwidth;
MCNUM yheight = mccchannel_18_analyzer_1_array_crystal_array_2_yheight;
MCNUM zdepth = mccchannel_18_analyzer_1_array_crystal_array_2_zdepth;
MCNUM xwidth2 = mccchannel_18_analyzer_1_array_crystal_array_2_xwidth2;
MCNUM yheight2 = mccchannel_18_analyzer_1_array_crystal_array_2_yheight2;
MCNUM visualize = mccchannel_18_analyzer_1_array_crystal_array_2_visualize;
int target_index = mccchannel_18_analyzer_1_array_crystal_array_2_target_index;
MCNUM target_x = mccchannel_18_analyzer_1_array_crystal_array_2_target_x;
MCNUM target_y = mccchannel_18_analyzer_1_array_crystal_array_2_target_y;
MCNUM target_z = mccchannel_18_analyzer_1_array_crystal_array_2_target_z;
MCNUM focus_aw = mccchannel_18_analyzer_1_array_crystal_array_2_focus_aw;
MCNUM focus_ah = mccchannel_18_analyzer_1_array_crystal_array_2_focus_ah;
MCNUM focus_xw = mccchannel_18_analyzer_1_array_crystal_array_2_focus_xw;
MCNUM focus_xh = mccchannel_18_analyzer_1_array_crystal_array_2_focus_xh;
MCNUM focus_r = mccchannel_18_analyzer_1_array_crystal_array_2_focus_r;
MCNUM p_interact = mccchannel_18_analyzer_1_array_crystal_array_2_p_interact;
char* mask_string = mccchannel_18_analyzer_1_array_crystal_array_2_mask_string;
char* mask_setting = mccchannel_18_analyzer_1_array_crystal_array_2_mask_setting;
MCNUM number_of_activations = mccchannel_18_analyzer_1_array_crystal_array_2_number_of_activations;
}   /* End of channel_18_analyzer_1_array_crystal_array_2=Union_box() SETTING parameter declarations. */
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex
  /* Label for restoring  neutron */
  mcabsorbCompchannel_18_analyzer_1_array_crystal_array_2:
  if (RESTORE) /* restore if needed */
  { RESTORE_NEUTRON(816,
      mcnlx,
      mcnly,
      mcnlz,
      mcnlvx,
      mcnlvy,
      mcnlvz,
      mcnlt,
      mcnlsx,
      mcnlsy,
      mcnlsz,
      mcnlp); }
#undef mcabsorbComp
#undef p
#undef sz
#undef sy
#undef sx
#undef t
#undef vz
#undef vy
#undef vx
#undef z
#undef y
#undef x
  mcDEBUG_STATE(
mcnlx,
mcnly,
mcnlz,
mcnlvx,
mcnlvy,
mcnlvz,
mcnlt,
mcnlsx,
mcnlsy,
mcnlsz,
mcnlp)

  /* TRACE Component channel_18_analyzer_1_array_crystal_array_3 [817] */
  mccoordschange(mcposrchannel_18_analyzer_1_array_crystal_array_3, mcrotrchannel_18_analyzer_1_array_crystal_array_3,
    &mcnlx,
    &mcnly,
    &mcnlz,
    &mcnlvx,
    &mcnlvy,
    &mcnlvz,
    &mcnlsx,
    &mcnlsy,
    &mcnlsz);
  /* define label inside component channel_18_analyzer_1_array_crystal_array_3 (without coords transformations) */
  mcJumpTrace_channel_18_analyzer_1_array_crystal_array_3:
  SIG_MESSAGE("channel_18_analyzer_1_array_crystal_array_3 (Trace)");
  mcDEBUG_COMP("channel_18_analyzer_1_array_crystal_array_3")
  mcDEBUG_STATE(
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp)
#define x mcnlx
#define y mcnly
#define z mcnlz
#define vx mcnlvx
#define vy mcnlvy
#define vz mcnlvz
#define t mcnlt
#define sx mcnlsx
#define sy mcnlsy
#define sz mcnlsz
#define p mcnlp

#define mcabsorbComp mcabsorbCompchannel_18_analyzer_1_array_crystal_array_3
  STORE_NEUTRON(817,
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp);
  mcScattered=0;
  mcRestore=0;
  mcNCounter[817]++;
  mcPCounter[817] += p;
  mcP2Counter[817] += p*p;
#define mccompcurname  channel_18_analyzer_1_array_crystal_array_3
#define mccompcurtype  Union_box
#define mccompcurindex 817
#define loop_index mccchannel_18_analyzer_1_array_crystal_array_3_loop_index
#define this_box_volume mccchannel_18_analyzer_1_array_crystal_array_3_this_box_volume
#define global_geometry_element mccchannel_18_analyzer_1_array_crystal_array_3_global_geometry_element
#define this_box_storage mccchannel_18_analyzer_1_array_crystal_array_3_this_box_storage
{   /* Declarations of channel_18_analyzer_1_array_crystal_array_3=Union_box() SETTING parameters. */
char* material_string = mccchannel_18_analyzer_1_array_crystal_array_3_material_string;
MCNUM priority = mccchannel_18_analyzer_1_array_crystal_array_3_priority;
MCNUM xwidth = mccchannel_18_analyzer_1_array_crystal_array_3_xwidth;
MCNUM yheight = mccchannel_18_analyzer_1_array_crystal_array_3_yheight;
MCNUM zdepth = mccchannel_18_analyzer_1_array_crystal_array_3_zdepth;
MCNUM xwidth2 = mccchannel_18_analyzer_1_array_crystal_array_3_xwidth2;
MCNUM yheight2 = mccchannel_18_analyzer_1_array_crystal_array_3_yheight2;
MCNUM visualize = mccchannel_18_analyzer_1_array_crystal_array_3_visualize;
int target_index = mccchannel_18_analyzer_1_array_crystal_array_3_target_index;
MCNUM target_x = mccchannel_18_analyzer_1_array_crystal_array_3_target_x;
MCNUM target_y = mccchannel_18_analyzer_1_array_crystal_array_3_target_y;
MCNUM target_z = mccchannel_18_analyzer_1_array_crystal_array_3_target_z;
MCNUM focus_aw = mccchannel_18_analyzer_1_array_crystal_array_3_focus_aw;
MCNUM focus_ah = mccchannel_18_analyzer_1_array_crystal_array_3_focus_ah;
MCNUM focus_xw = mccchannel_18_analyzer_1_array_crystal_array_3_focus_xw;
MCNUM focus_xh = mccchannel_18_analyzer_1_array_crystal_array_3_focus_xh;
MCNUM focus_r = mccchannel_18_analyzer_1_array_crystal_array_3_focus_r;
MCNUM p_interact = mccchannel_18_analyzer_1_array_crystal_array_3_p_interact;
char* mask_string = mccchannel_18_analyzer_1_array_crystal_array_3_mask_string;
char* mask_setting = mccchannel_18_analyzer_1_array_crystal_array_3_mask_setting;
MCNUM number_of_activations = mccchannel_18_analyzer_1_array_crystal_array_3_number_of_activations;
}   /* End of channel_18_analyzer_1_array_crystal_array_3=Union_box() SETTING parameter declarations. */
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex
  /* Label for restoring  neutron */
  mcabsorbCompchannel_18_analyzer_1_array_crystal_array_3:
  if (RESTORE) /* restore if needed */
  { RESTORE_NEUTRON(817,
      mcnlx,
      mcnly,
      mcnlz,
      mcnlvx,
      mcnlvy,
      mcnlvz,
      mcnlt,
      mcnlsx,
      mcnlsy,
      mcnlsz,
      mcnlp); }
#undef mcabsorbComp
#undef p
#undef sz
#undef sy
#undef sx
#undef t
#undef vz
#undef vy
#undef vx
#undef z
#undef y
#undef x
  mcDEBUG_STATE(
mcnlx,
mcnly,
mcnlz,
mcnlvx,
mcnlvy,
mcnlvz,
mcnlt,
mcnlsx,
mcnlsy,
mcnlsz,
mcnlp)

  /* TRACE Component channel_18_analyzer_1_array_crystal_array_4 [818] */
  mccoordschange(mcposrchannel_18_analyzer_1_array_crystal_array_4, mcrotrchannel_18_analyzer_1_array_crystal_array_4,
    &mcnlx,
    &mcnly,
    &mcnlz,
    &mcnlvx,
    &mcnlvy,
    &mcnlvz,
    &mcnlsx,
    &mcnlsy,
    &mcnlsz);
  /* define label inside component channel_18_analyzer_1_array_crystal_array_4 (without coords transformations) */
  mcJumpTrace_channel_18_analyzer_1_array_crystal_array_4:
  SIG_MESSAGE("channel_18_analyzer_1_array_crystal_array_4 (Trace)");
  mcDEBUG_COMP("channel_18_analyzer_1_array_crystal_array_4")
  mcDEBUG_STATE(
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp)
#define x mcnlx
#define y mcnly
#define z mcnlz
#define vx mcnlvx
#define vy mcnlvy
#define vz mcnlvz
#define t mcnlt
#define sx mcnlsx
#define sy mcnlsy
#define sz mcnlsz
#define p mcnlp

#define mcabsorbComp mcabsorbCompchannel_18_analyzer_1_array_crystal_array_4
  STORE_NEUTRON(818,
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp);
  mcScattered=0;
  mcRestore=0;
  mcNCounter[818]++;
  mcPCounter[818] += p;
  mcP2Counter[818] += p*p;
#define mccompcurname  channel_18_analyzer_1_array_crystal_array_4
#define mccompcurtype  Union_box
#define mccompcurindex 818
#define loop_index mccchannel_18_analyzer_1_array_crystal_array_4_loop_index
#define this_box_volume mccchannel_18_analyzer_1_array_crystal_array_4_this_box_volume
#define global_geometry_element mccchannel_18_analyzer_1_array_crystal_array_4_global_geometry_element
#define this_box_storage mccchannel_18_analyzer_1_array_crystal_array_4_this_box_storage
{   /* Declarations of channel_18_analyzer_1_array_crystal_array_4=Union_box() SETTING parameters. */
char* material_string = mccchannel_18_analyzer_1_array_crystal_array_4_material_string;
MCNUM priority = mccchannel_18_analyzer_1_array_crystal_array_4_priority;
MCNUM xwidth = mccchannel_18_analyzer_1_array_crystal_array_4_xwidth;
MCNUM yheight = mccchannel_18_analyzer_1_array_crystal_array_4_yheight;
MCNUM zdepth = mccchannel_18_analyzer_1_array_crystal_array_4_zdepth;
MCNUM xwidth2 = mccchannel_18_analyzer_1_array_crystal_array_4_xwidth2;
MCNUM yheight2 = mccchannel_18_analyzer_1_array_crystal_array_4_yheight2;
MCNUM visualize = mccchannel_18_analyzer_1_array_crystal_array_4_visualize;
int target_index = mccchannel_18_analyzer_1_array_crystal_array_4_target_index;
MCNUM target_x = mccchannel_18_analyzer_1_array_crystal_array_4_target_x;
MCNUM target_y = mccchannel_18_analyzer_1_array_crystal_array_4_target_y;
MCNUM target_z = mccchannel_18_analyzer_1_array_crystal_array_4_target_z;
MCNUM focus_aw = mccchannel_18_analyzer_1_array_crystal_array_4_focus_aw;
MCNUM focus_ah = mccchannel_18_analyzer_1_array_crystal_array_4_focus_ah;
MCNUM focus_xw = mccchannel_18_analyzer_1_array_crystal_array_4_focus_xw;
MCNUM focus_xh = mccchannel_18_analyzer_1_array_crystal_array_4_focus_xh;
MCNUM focus_r = mccchannel_18_analyzer_1_array_crystal_array_4_focus_r;
MCNUM p_interact = mccchannel_18_analyzer_1_array_crystal_array_4_p_interact;
char* mask_string = mccchannel_18_analyzer_1_array_crystal_array_4_mask_string;
char* mask_setting = mccchannel_18_analyzer_1_array_crystal_array_4_mask_setting;
MCNUM number_of_activations = mccchannel_18_analyzer_1_array_crystal_array_4_number_of_activations;
}   /* End of channel_18_analyzer_1_array_crystal_array_4=Union_box() SETTING parameter declarations. */
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex
  /* Label for restoring  neutron */
  mcabsorbCompchannel_18_analyzer_1_array_crystal_array_4:
  if (RESTORE) /* restore if needed */
  { RESTORE_NEUTRON(818,
      mcnlx,
      mcnly,
      mcnlz,
      mcnlvx,
      mcnlvy,
      mcnlvz,
      mcnlt,
      mcnlsx,
      mcnlsy,
      mcnlsz,
      mcnlp); }
#undef mcabsorbComp
#undef p
#undef sz
#undef sy
#undef sx
#undef t
#undef vz
#undef vy
#undef vx
#undef z
#undef y
#undef x
  mcDEBUG_STATE(
mcnlx,
mcnly,
mcnlz,
mcnlvx,
mcnlvy,
mcnlvz,
mcnlt,
mcnlsx,
mcnlsy,
mcnlsz,
mcnlp)

  /* TRACE Component channel_18_analyzer_1_array_crystal_array_5 [819] */
  mccoordschange(mcposrchannel_18_analyzer_1_array_crystal_array_5, mcrotrchannel_18_analyzer_1_array_crystal_array_5,
    &mcnlx,
    &mcnly,
    &mcnlz,
    &mcnlvx,
    &mcnlvy,
    &mcnlvz,
    &mcnlsx,
    &mcnlsy,
    &mcnlsz);
  /* define label inside component channel_18_analyzer_1_array_crystal_array_5 (without coords transformations) */
  mcJumpTrace_channel_18_analyzer_1_array_crystal_array_5:
  SIG_MESSAGE("channel_18_analyzer_1_array_crystal_array_5 (Trace)");
  mcDEBUG_COMP("channel_18_analyzer_1_array_crystal_array_5")
  mcDEBUG_STATE(
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp)
#define x mcnlx
#define y mcnly
#define z mcnlz
#define vx mcnlvx
#define vy mcnlvy
#define vz mcnlvz
#define t mcnlt
#define sx mcnlsx
#define sy mcnlsy
#define sz mcnlsz
#define p mcnlp

#define mcabsorbComp mcabsorbCompchannel_18_analyzer_1_array_crystal_array_5
  STORE_NEUTRON(819,
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp);
  mcScattered=0;
  mcRestore=0;
  mcNCounter[819]++;
  mcPCounter[819] += p;
  mcP2Counter[819] += p*p;
#define mccompcurname  channel_18_analyzer_1_array_crystal_array_5
#define mccompcurtype  Union_box
#define mccompcurindex 819
#define loop_index mccchannel_18_analyzer_1_array_crystal_array_5_loop_index
#define this_box_volume mccchannel_18_analyzer_1_array_crystal_array_5_this_box_volume
#define global_geometry_element mccchannel_18_analyzer_1_array_crystal_array_5_global_geometry_element
#define this_box_storage mccchannel_18_analyzer_1_array_crystal_array_5_this_box_storage
{   /* Declarations of channel_18_analyzer_1_array_crystal_array_5=Union_box() SETTING parameters. */
char* material_string = mccchannel_18_analyzer_1_array_crystal_array_5_material_string;
MCNUM priority = mccchannel_18_analyzer_1_array_crystal_array_5_priority;
MCNUM xwidth = mccchannel_18_analyzer_1_array_crystal_array_5_xwidth;
MCNUM yheight = mccchannel_18_analyzer_1_array_crystal_array_5_yheight;
MCNUM zdepth = mccchannel_18_analyzer_1_array_crystal_array_5_zdepth;
MCNUM xwidth2 = mccchannel_18_analyzer_1_array_crystal_array_5_xwidth2;
MCNUM yheight2 = mccchannel_18_analyzer_1_array_crystal_array_5_yheight2;
MCNUM visualize = mccchannel_18_analyzer_1_array_crystal_array_5_visualize;
int target_index = mccchannel_18_analyzer_1_array_crystal_array_5_target_index;
MCNUM target_x = mccchannel_18_analyzer_1_array_crystal_array_5_target_x;
MCNUM target_y = mccchannel_18_analyzer_1_array_crystal_array_5_target_y;
MCNUM target_z = mccchannel_18_analyzer_1_array_crystal_array_5_target_z;
MCNUM focus_aw = mccchannel_18_analyzer_1_array_crystal_array_5_focus_aw;
MCNUM focus_ah = mccchannel_18_analyzer_1_array_crystal_array_5_focus_ah;
MCNUM focus_xw = mccchannel_18_analyzer_1_array_crystal_array_5_focus_xw;
MCNUM focus_xh = mccchannel_18_analyzer_1_array_crystal_array_5_focus_xh;
MCNUM focus_r = mccchannel_18_analyzer_1_array_crystal_array_5_focus_r;
MCNUM p_interact = mccchannel_18_analyzer_1_array_crystal_array_5_p_interact;
char* mask_string = mccchannel_18_analyzer_1_array_crystal_array_5_mask_string;
char* mask_setting = mccchannel_18_analyzer_1_array_crystal_array_5_mask_setting;
MCNUM number_of_activations = mccchannel_18_analyzer_1_array_crystal_array_5_number_of_activations;
}   /* End of channel_18_analyzer_1_array_crystal_array_5=Union_box() SETTING parameter declarations. */
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex
  /* Label for restoring  neutron */
  mcabsorbCompchannel_18_analyzer_1_array_crystal_array_5:
  if (RESTORE) /* restore if needed */
  { RESTORE_NEUTRON(819,
      mcnlx,
      mcnly,
      mcnlz,
      mcnlvx,
      mcnlvy,
      mcnlvz,
      mcnlt,
      mcnlsx,
      mcnlsy,
      mcnlsz,
      mcnlp); }
#undef mcabsorbComp
#undef p
#undef sz
#undef sy
#undef sx
#undef t
#undef vz
#undef vy
#undef vx
#undef z
#undef y
#undef x
  mcDEBUG_STATE(
mcnlx,
mcnly,
mcnlz,
mcnlvx,
mcnlvy,
mcnlvz,
mcnlt,
mcnlsx,
mcnlsy,
mcnlsz,
mcnlp)

  /* TRACE Component channel_18_analyzer_1_array_crystal_array_6 [820] */
  mccoordschange(mcposrchannel_18_analyzer_1_array_crystal_array_6, mcrotrchannel_18_analyzer_1_array_crystal_array_6,
    &mcnlx,
    &mcnly,
    &mcnlz,
    &mcnlvx,
    &mcnlvy,
    &mcnlvz,
    &mcnlsx,
    &mcnlsy,
    &mcnlsz);
  /* define label inside component channel_18_analyzer_1_array_crystal_array_6 (without coords transformations) */
  mcJumpTrace_channel_18_analyzer_1_array_crystal_array_6:
  SIG_MESSAGE("channel_18_analyzer_1_array_crystal_array_6 (Trace)");
  mcDEBUG_COMP("channel_18_analyzer_1_array_crystal_array_6")
  mcDEBUG_STATE(
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp)
#define x mcnlx
#define y mcnly
#define z mcnlz
#define vx mcnlvx
#define vy mcnlvy
#define vz mcnlvz
#define t mcnlt
#define sx mcnlsx
#define sy mcnlsy
#define sz mcnlsz
#define p mcnlp

#define mcabsorbComp mcabsorbCompchannel_18_analyzer_1_array_crystal_array_6
  STORE_NEUTRON(820,
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp);
  mcScattered=0;
  mcRestore=0;
  mcNCounter[820]++;
  mcPCounter[820] += p;
  mcP2Counter[820] += p*p;
#define mccompcurname  channel_18_analyzer_1_array_crystal_array_6
#define mccompcurtype  Union_box
#define mccompcurindex 820
#define loop_index mccchannel_18_analyzer_1_array_crystal_array_6_loop_index
#define this_box_volume mccchannel_18_analyzer_1_array_crystal_array_6_this_box_volume
#define global_geometry_element mccchannel_18_analyzer_1_array_crystal_array_6_global_geometry_element
#define this_box_storage mccchannel_18_analyzer_1_array_crystal_array_6_this_box_storage
{   /* Declarations of channel_18_analyzer_1_array_crystal_array_6=Union_box() SETTING parameters. */
char* material_string = mccchannel_18_analyzer_1_array_crystal_array_6_material_string;
MCNUM priority = mccchannel_18_analyzer_1_array_crystal_array_6_priority;
MCNUM xwidth = mccchannel_18_analyzer_1_array_crystal_array_6_xwidth;
MCNUM yheight = mccchannel_18_analyzer_1_array_crystal_array_6_yheight;
MCNUM zdepth = mccchannel_18_analyzer_1_array_crystal_array_6_zdepth;
MCNUM xwidth2 = mccchannel_18_analyzer_1_array_crystal_array_6_xwidth2;
MCNUM yheight2 = mccchannel_18_analyzer_1_array_crystal_array_6_yheight2;
MCNUM visualize = mccchannel_18_analyzer_1_array_crystal_array_6_visualize;
int target_index = mccchannel_18_analyzer_1_array_crystal_array_6_target_index;
MCNUM target_x = mccchannel_18_analyzer_1_array_crystal_array_6_target_x;
MCNUM target_y = mccchannel_18_analyzer_1_array_crystal_array_6_target_y;
MCNUM target_z = mccchannel_18_analyzer_1_array_crystal_array_6_target_z;
MCNUM focus_aw = mccchannel_18_analyzer_1_array_crystal_array_6_focus_aw;
MCNUM focus_ah = mccchannel_18_analyzer_1_array_crystal_array_6_focus_ah;
MCNUM focus_xw = mccchannel_18_analyzer_1_array_crystal_array_6_focus_xw;
MCNUM focus_xh = mccchannel_18_analyzer_1_array_crystal_array_6_focus_xh;
MCNUM focus_r = mccchannel_18_analyzer_1_array_crystal_array_6_focus_r;
MCNUM p_interact = mccchannel_18_analyzer_1_array_crystal_array_6_p_interact;
char* mask_string = mccchannel_18_analyzer_1_array_crystal_array_6_mask_string;
char* mask_setting = mccchannel_18_analyzer_1_array_crystal_array_6_mask_setting;
MCNUM number_of_activations = mccchannel_18_analyzer_1_array_crystal_array_6_number_of_activations;
}   /* End of channel_18_analyzer_1_array_crystal_array_6=Union_box() SETTING parameter declarations. */
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex
  /* Label for restoring  neutron */
  mcabsorbCompchannel_18_analyzer_1_array_crystal_array_6:
  if (RESTORE) /* restore if needed */
  { RESTORE_NEUTRON(820,
      mcnlx,
      mcnly,
      mcnlz,
      mcnlvx,
      mcnlvy,
      mcnlvz,
      mcnlt,
      mcnlsx,
      mcnlsy,
      mcnlsz,
      mcnlp); }
#undef mcabsorbComp
#undef p
#undef sz
#undef sy
#undef sx
#undef t
#undef vz
#undef vy
#undef vx
#undef z
#undef y
#undef x
  mcDEBUG_STATE(
mcnlx,
mcnly,
mcnlz,
mcnlvx,
mcnlvy,
mcnlvz,
mcnlt,
mcnlsx,
mcnlsy,
mcnlsz,
mcnlp)

  /* TRACE Component channel_18_analyzer_1_array_crystal_array_7 [821] */
  mccoordschange(mcposrchannel_18_analyzer_1_array_crystal_array_7, mcrotrchannel_18_analyzer_1_array_crystal_array_7,
    &mcnlx,
    &mcnly,
    &mcnlz,
    &mcnlvx,
    &mcnlvy,
    &mcnlvz,
    &mcnlsx,
    &mcnlsy,
    &mcnlsz);
  /* define label inside component channel_18_analyzer_1_array_crystal_array_7 (without coords transformations) */
  mcJumpTrace_channel_18_analyzer_1_array_crystal_array_7:
  SIG_MESSAGE("channel_18_analyzer_1_array_crystal_array_7 (Trace)");
  mcDEBUG_COMP("channel_18_analyzer_1_array_crystal_array_7")
  mcDEBUG_STATE(
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp)
#define x mcnlx
#define y mcnly
#define z mcnlz
#define vx mcnlvx
#define vy mcnlvy
#define vz mcnlvz
#define t mcnlt
#define sx mcnlsx
#define sy mcnlsy
#define sz mcnlsz
#define p mcnlp

#define mcabsorbComp mcabsorbCompchannel_18_analyzer_1_array_crystal_array_7
  STORE_NEUTRON(821,
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp);
  mcScattered=0;
  mcRestore=0;
  mcNCounter[821]++;
  mcPCounter[821] += p;
  mcP2Counter[821] += p*p;
#define mccompcurname  channel_18_analyzer_1_array_crystal_array_7
#define mccompcurtype  Union_box
#define mccompcurindex 821
#define loop_index mccchannel_18_analyzer_1_array_crystal_array_7_loop_index
#define this_box_volume mccchannel_18_analyzer_1_array_crystal_array_7_this_box_volume
#define global_geometry_element mccchannel_18_analyzer_1_array_crystal_array_7_global_geometry_element
#define this_box_storage mccchannel_18_analyzer_1_array_crystal_array_7_this_box_storage
{   /* Declarations of channel_18_analyzer_1_array_crystal_array_7=Union_box() SETTING parameters. */
char* material_string = mccchannel_18_analyzer_1_array_crystal_array_7_material_string;
MCNUM priority = mccchannel_18_analyzer_1_array_crystal_array_7_priority;
MCNUM xwidth = mccchannel_18_analyzer_1_array_crystal_array_7_xwidth;
MCNUM yheight = mccchannel_18_analyzer_1_array_crystal_array_7_yheight;
MCNUM zdepth = mccchannel_18_analyzer_1_array_crystal_array_7_zdepth;
MCNUM xwidth2 = mccchannel_18_analyzer_1_array_crystal_array_7_xwidth2;
MCNUM yheight2 = mccchannel_18_analyzer_1_array_crystal_array_7_yheight2;
MCNUM visualize = mccchannel_18_analyzer_1_array_crystal_array_7_visualize;
int target_index = mccchannel_18_analyzer_1_array_crystal_array_7_target_index;
MCNUM target_x = mccchannel_18_analyzer_1_array_crystal_array_7_target_x;
MCNUM target_y = mccchannel_18_analyzer_1_array_crystal_array_7_target_y;
MCNUM target_z = mccchannel_18_analyzer_1_array_crystal_array_7_target_z;
MCNUM focus_aw = mccchannel_18_analyzer_1_array_crystal_array_7_focus_aw;
MCNUM focus_ah = mccchannel_18_analyzer_1_array_crystal_array_7_focus_ah;
MCNUM focus_xw = mccchannel_18_analyzer_1_array_crystal_array_7_focus_xw;
MCNUM focus_xh = mccchannel_18_analyzer_1_array_crystal_array_7_focus_xh;
MCNUM focus_r = mccchannel_18_analyzer_1_array_crystal_array_7_focus_r;
MCNUM p_interact = mccchannel_18_analyzer_1_array_crystal_array_7_p_interact;
char* mask_string = mccchannel_18_analyzer_1_array_crystal_array_7_mask_string;
char* mask_setting = mccchannel_18_analyzer_1_array_crystal_array_7_mask_setting;
MCNUM number_of_activations = mccchannel_18_analyzer_1_array_crystal_array_7_number_of_activations;
}   /* End of channel_18_analyzer_1_array_crystal_array_7=Union_box() SETTING parameter declarations. */
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex
  /* Label for restoring  neutron */
  mcabsorbCompchannel_18_analyzer_1_array_crystal_array_7:
  if (RESTORE) /* restore if needed */
  { RESTORE_NEUTRON(821,
      mcnlx,
      mcnly,
      mcnlz,
      mcnlvx,
      mcnlvy,
      mcnlvz,
      mcnlt,
      mcnlsx,
      mcnlsy,
      mcnlsz,
      mcnlp); }
#undef mcabsorbComp
#undef p
#undef sz
#undef sy
#undef sx
#undef t
#undef vz
#undef vy
#undef vx
#undef z
#undef y
#undef x
  mcDEBUG_STATE(
mcnlx,
mcnly,
mcnlz,
mcnlvx,
mcnlvy,
mcnlvz,
mcnlt,
mcnlsx,
mcnlsy,
mcnlsz,
mcnlp)

  /* TRACE Component channel_18_analyzer_1_array_crystal_array_8 [822] */
  mccoordschange(mcposrchannel_18_analyzer_1_array_crystal_array_8, mcrotrchannel_18_analyzer_1_array_crystal_array_8,
    &mcnlx,
    &mcnly,
    &mcnlz,
    &mcnlvx,
    &mcnlvy,
    &mcnlvz,
    &mcnlsx,
    &mcnlsy,
    &mcnlsz);
  /* define label inside component channel_18_analyzer_1_array_crystal_array_8 (without coords transformations) */
  mcJumpTrace_channel_18_analyzer_1_array_crystal_array_8:
  SIG_MESSAGE("channel_18_analyzer_1_array_crystal_array_8 (Trace)");
  mcDEBUG_COMP("channel_18_analyzer_1_array_crystal_array_8")
  mcDEBUG_STATE(
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp)
#define x mcnlx
#define y mcnly
#define z mcnlz
#define vx mcnlvx
#define vy mcnlvy
#define vz mcnlvz
#define t mcnlt
#define sx mcnlsx
#define sy mcnlsy
#define sz mcnlsz
#define p mcnlp

#define mcabsorbComp mcabsorbCompchannel_18_analyzer_1_array_crystal_array_8
  STORE_NEUTRON(822,
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp);
  mcScattered=0;
  mcRestore=0;
  mcNCounter[822]++;
  mcPCounter[822] += p;
  mcP2Counter[822] += p*p;
#define mccompcurname  channel_18_analyzer_1_array_crystal_array_8
#define mccompcurtype  Union_box
#define mccompcurindex 822
#define loop_index mccchannel_18_analyzer_1_array_crystal_array_8_loop_index
#define this_box_volume mccchannel_18_analyzer_1_array_crystal_array_8_this_box_volume
#define global_geometry_element mccchannel_18_analyzer_1_array_crystal_array_8_global_geometry_element
#define this_box_storage mccchannel_18_analyzer_1_array_crystal_array_8_this_box_storage
{   /* Declarations of channel_18_analyzer_1_array_crystal_array_8=Union_box() SETTING parameters. */
char* material_string = mccchannel_18_analyzer_1_array_crystal_array_8_material_string;
MCNUM priority = mccchannel_18_analyzer_1_array_crystal_array_8_priority;
MCNUM xwidth = mccchannel_18_analyzer_1_array_crystal_array_8_xwidth;
MCNUM yheight = mccchannel_18_analyzer_1_array_crystal_array_8_yheight;
MCNUM zdepth = mccchannel_18_analyzer_1_array_crystal_array_8_zdepth;
MCNUM xwidth2 = mccchannel_18_analyzer_1_array_crystal_array_8_xwidth2;
MCNUM yheight2 = mccchannel_18_analyzer_1_array_crystal_array_8_yheight2;
MCNUM visualize = mccchannel_18_analyzer_1_array_crystal_array_8_visualize;
int target_index = mccchannel_18_analyzer_1_array_crystal_array_8_target_index;
MCNUM target_x = mccchannel_18_analyzer_1_array_crystal_array_8_target_x;
MCNUM target_y = mccchannel_18_analyzer_1_array_crystal_array_8_target_y;
MCNUM target_z = mccchannel_18_analyzer_1_array_crystal_array_8_target_z;
MCNUM focus_aw = mccchannel_18_analyzer_1_array_crystal_array_8_focus_aw;
MCNUM focus_ah = mccchannel_18_analyzer_1_array_crystal_array_8_focus_ah;
MCNUM focus_xw = mccchannel_18_analyzer_1_array_crystal_array_8_focus_xw;
MCNUM focus_xh = mccchannel_18_analyzer_1_array_crystal_array_8_focus_xh;
MCNUM focus_r = mccchannel_18_analyzer_1_array_crystal_array_8_focus_r;
MCNUM p_interact = mccchannel_18_analyzer_1_array_crystal_array_8_p_interact;
char* mask_string = mccchannel_18_analyzer_1_array_crystal_array_8_mask_string;
char* mask_setting = mccchannel_18_analyzer_1_array_crystal_array_8_mask_setting;
MCNUM number_of_activations = mccchannel_18_analyzer_1_array_crystal_array_8_number_of_activations;
}   /* End of channel_18_analyzer_1_array_crystal_array_8=Union_box() SETTING parameter declarations. */
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex
  /* Label for restoring  neutron */
  mcabsorbCompchannel_18_analyzer_1_array_crystal_array_8:
  if (RESTORE) /* restore if needed */
  { RESTORE_NEUTRON(822,
      mcnlx,
      mcnly,
      mcnlz,
      mcnlvx,
      mcnlvy,
      mcnlvz,
      mcnlt,
      mcnlsx,
      mcnlsy,
      mcnlsz,
      mcnlp); }
#undef mcabsorbComp
#undef p
#undef sz
#undef sy
#undef sx
#undef t
#undef vz
#undef vy
#undef vx
#undef z
#undef y
#undef x
  mcDEBUG_STATE(
mcnlx,
mcnly,
mcnlz,
mcnlvx,
mcnlvy,
mcnlvz,
mcnlt,
mcnlsx,
mcnlsy,
mcnlsz,
mcnlp)

  /* TRACE Component channel_18_analyzer_2_center [823] */
  mccoordschange(mcposrchannel_18_analyzer_2_center, mcrotrchannel_18_analyzer_2_center,
    &mcnlx,
    &mcnly,
    &mcnlz,
    &mcnlvx,
    &mcnlvy,
    &mcnlvz,
    &mcnlsx,
    &mcnlsy,
    &mcnlsz);
  /* define label inside component channel_18_analyzer_2_center (without coords transformations) */
  mcJumpTrace_channel_18_analyzer_2_center:
  SIG_MESSAGE("channel_18_analyzer_2_center (Trace)");
  mcDEBUG_COMP("channel_18_analyzer_2_center")
  mcDEBUG_STATE(
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp)
#define x mcnlx
#define y mcnly
#define z mcnlz
#define vx mcnlvx
#define vy mcnlvy
#define vz mcnlvz
#define t mcnlt
#define sx mcnlsx
#define sy mcnlsy
#define sz mcnlsz
#define p mcnlp

#define mcabsorbComp mcabsorbCompchannel_18_analyzer_2_center
  STORE_NEUTRON(823,
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp);
  mcScattered=0;
  mcRestore=0;
  mcNCounter[823]++;
  mcPCounter[823] += p;
  mcP2Counter[823] += p*p;
#define mccompcurname  channel_18_analyzer_2_center
#define mccompcurtype  Arm
#define mccompcurindex 823
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex
  /* Label for restoring  neutron */
  mcabsorbCompchannel_18_analyzer_2_center:
  if (RESTORE) /* restore if needed */
  { RESTORE_NEUTRON(823,
      mcnlx,
      mcnly,
      mcnlz,
      mcnlvx,
      mcnlvy,
      mcnlvz,
      mcnlt,
      mcnlsx,
      mcnlsy,
      mcnlsz,
      mcnlp); }
#undef mcabsorbComp
#undef p
#undef sz
#undef sy
#undef sx
#undef t
#undef vz
#undef vy
#undef vx
#undef z
#undef y
#undef x
  mcDEBUG_STATE(
mcnlx,
mcnly,
mcnlz,
mcnlvx,
mcnlvy,
mcnlvz,
mcnlt,
mcnlsx,
mcnlsy,
mcnlsz,
mcnlp)

  /* TRACE Component channel_18_analyzer_2_rotated [824] */
  mccoordschange(mcposrchannel_18_analyzer_2_rotated, mcrotrchannel_18_analyzer_2_rotated,
    &mcnlx,
    &mcnly,
    &mcnlz,
    &mcnlvx,
    &mcnlvy,
    &mcnlvz,
    &mcnlsx,
    &mcnlsy,
    &mcnlsz);
  /* define label inside component channel_18_analyzer_2_rotated (without coords transformations) */
  mcJumpTrace_channel_18_analyzer_2_rotated:
  SIG_MESSAGE("channel_18_analyzer_2_rotated (Trace)");
  mcDEBUG_COMP("channel_18_analyzer_2_rotated")
  mcDEBUG_STATE(
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp)
#define x mcnlx
#define y mcnly
#define z mcnlz
#define vx mcnlvx
#define vy mcnlvy
#define vz mcnlvz
#define t mcnlt
#define sx mcnlsx
#define sy mcnlsy
#define sz mcnlsz
#define p mcnlp

#define mcabsorbComp mcabsorbCompchannel_18_analyzer_2_rotated
  STORE_NEUTRON(824,
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp);
  mcScattered=0;
  mcRestore=0;
  mcNCounter[824]++;
  mcPCounter[824] += p;
  mcP2Counter[824] += p*p;
#define mccompcurname  channel_18_analyzer_2_rotated
#define mccompcurtype  Arm
#define mccompcurindex 824
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex
  /* Label for restoring  neutron */
  mcabsorbCompchannel_18_analyzer_2_rotated:
  if (RESTORE) /* restore if needed */
  { RESTORE_NEUTRON(824,
      mcnlx,
      mcnly,
      mcnlz,
      mcnlvx,
      mcnlvy,
      mcnlvz,
      mcnlt,
      mcnlsx,
      mcnlsy,
      mcnlsz,
      mcnlp); }
#undef mcabsorbComp
#undef p
#undef sz
#undef sy
#undef sx
#undef t
#undef vz
#undef vy
#undef vx
#undef z
#undef y
#undef x
  mcDEBUG_STATE(
mcnlx,
mcnly,
mcnlz,
mcnlvx,
mcnlvy,
mcnlvz,
mcnlt,
mcnlsx,
mcnlsy,
mcnlsz,
mcnlp)

  /* TRACE Component channel_18_analyzer_2_array_crystal_array_0 [825] */
  mccoordschange(mcposrchannel_18_analyzer_2_array_crystal_array_0, mcrotrchannel_18_analyzer_2_array_crystal_array_0,
    &mcnlx,
    &mcnly,
    &mcnlz,
    &mcnlvx,
    &mcnlvy,
    &mcnlvz,
    &mcnlsx,
    &mcnlsy,
    &mcnlsz);
  /* define label inside component channel_18_analyzer_2_array_crystal_array_0 (without coords transformations) */
  mcJumpTrace_channel_18_analyzer_2_array_crystal_array_0:
  SIG_MESSAGE("channel_18_analyzer_2_array_crystal_array_0 (Trace)");
  mcDEBUG_COMP("channel_18_analyzer_2_array_crystal_array_0")
  mcDEBUG_STATE(
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp)
#define x mcnlx
#define y mcnly
#define z mcnlz
#define vx mcnlvx
#define vy mcnlvy
#define vz mcnlvz
#define t mcnlt
#define sx mcnlsx
#define sy mcnlsy
#define sz mcnlsz
#define p mcnlp

#define mcabsorbComp mcabsorbCompchannel_18_analyzer_2_array_crystal_array_0
  STORE_NEUTRON(825,
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp);
  mcScattered=0;
  mcRestore=0;
  mcNCounter[825]++;
  mcPCounter[825] += p;
  mcP2Counter[825] += p*p;
#define mccompcurname  channel_18_analyzer_2_array_crystal_array_0
#define mccompcurtype  Union_box
#define mccompcurindex 825
#define loop_index mccchannel_18_analyzer_2_array_crystal_array_0_loop_index
#define this_box_volume mccchannel_18_analyzer_2_array_crystal_array_0_this_box_volume
#define global_geometry_element mccchannel_18_analyzer_2_array_crystal_array_0_global_geometry_element
#define this_box_storage mccchannel_18_analyzer_2_array_crystal_array_0_this_box_storage
{   /* Declarations of channel_18_analyzer_2_array_crystal_array_0=Union_box() SETTING parameters. */
char* material_string = mccchannel_18_analyzer_2_array_crystal_array_0_material_string;
MCNUM priority = mccchannel_18_analyzer_2_array_crystal_array_0_priority;
MCNUM xwidth = mccchannel_18_analyzer_2_array_crystal_array_0_xwidth;
MCNUM yheight = mccchannel_18_analyzer_2_array_crystal_array_0_yheight;
MCNUM zdepth = mccchannel_18_analyzer_2_array_crystal_array_0_zdepth;
MCNUM xwidth2 = mccchannel_18_analyzer_2_array_crystal_array_0_xwidth2;
MCNUM yheight2 = mccchannel_18_analyzer_2_array_crystal_array_0_yheight2;
MCNUM visualize = mccchannel_18_analyzer_2_array_crystal_array_0_visualize;
int target_index = mccchannel_18_analyzer_2_array_crystal_array_0_target_index;
MCNUM target_x = mccchannel_18_analyzer_2_array_crystal_array_0_target_x;
MCNUM target_y = mccchannel_18_analyzer_2_array_crystal_array_0_target_y;
MCNUM target_z = mccchannel_18_analyzer_2_array_crystal_array_0_target_z;
MCNUM focus_aw = mccchannel_18_analyzer_2_array_crystal_array_0_focus_aw;
MCNUM focus_ah = mccchannel_18_analyzer_2_array_crystal_array_0_focus_ah;
MCNUM focus_xw = mccchannel_18_analyzer_2_array_crystal_array_0_focus_xw;
MCNUM focus_xh = mccchannel_18_analyzer_2_array_crystal_array_0_focus_xh;
MCNUM focus_r = mccchannel_18_analyzer_2_array_crystal_array_0_focus_r;
MCNUM p_interact = mccchannel_18_analyzer_2_array_crystal_array_0_p_interact;
char* mask_string = mccchannel_18_analyzer_2_array_crystal_array_0_mask_string;
char* mask_setting = mccchannel_18_analyzer_2_array_crystal_array_0_mask_setting;
MCNUM number_of_activations = mccchannel_18_analyzer_2_array_crystal_array_0_number_of_activations;
}   /* End of channel_18_analyzer_2_array_crystal_array_0=Union_box() SETTING parameter declarations. */
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex
  /* Label for restoring  neutron */
  mcabsorbCompchannel_18_analyzer_2_array_crystal_array_0:
  if (RESTORE) /* restore if needed */
  { RESTORE_NEUTRON(825,
      mcnlx,
      mcnly,
      mcnlz,
      mcnlvx,
      mcnlvy,
      mcnlvz,
      mcnlt,
      mcnlsx,
      mcnlsy,
      mcnlsz,
      mcnlp); }
#undef mcabsorbComp
#undef p
#undef sz
#undef sy
#undef sx
#undef t
#undef vz
#undef vy
#undef vx
#undef z
#undef y
#undef x
  mcDEBUG_STATE(
mcnlx,
mcnly,
mcnlz,
mcnlvx,
mcnlvy,
mcnlvz,
mcnlt,
mcnlsx,
mcnlsy,
mcnlsz,
mcnlp)

  /* TRACE Component channel_18_analyzer_2_array_crystal_array_1 [826] */
  mccoordschange(mcposrchannel_18_analyzer_2_array_crystal_array_1, mcrotrchannel_18_analyzer_2_array_crystal_array_1,
    &mcnlx,
    &mcnly,
    &mcnlz,
    &mcnlvx,
    &mcnlvy,
    &mcnlvz,
    &mcnlsx,
    &mcnlsy,
    &mcnlsz);
  /* define label inside component channel_18_analyzer_2_array_crystal_array_1 (without coords transformations) */
  mcJumpTrace_channel_18_analyzer_2_array_crystal_array_1:
  SIG_MESSAGE("channel_18_analyzer_2_array_crystal_array_1 (Trace)");
  mcDEBUG_COMP("channel_18_analyzer_2_array_crystal_array_1")
  mcDEBUG_STATE(
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp)
#define x mcnlx
#define y mcnly
#define z mcnlz
#define vx mcnlvx
#define vy mcnlvy
#define vz mcnlvz
#define t mcnlt
#define sx mcnlsx
#define sy mcnlsy
#define sz mcnlsz
#define p mcnlp

#define mcabsorbComp mcabsorbCompchannel_18_analyzer_2_array_crystal_array_1
  STORE_NEUTRON(826,
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp);
  mcScattered=0;
  mcRestore=0;
  mcNCounter[826]++;
  mcPCounter[826] += p;
  mcP2Counter[826] += p*p;
#define mccompcurname  channel_18_analyzer_2_array_crystal_array_1
#define mccompcurtype  Union_box
#define mccompcurindex 826
#define loop_index mccchannel_18_analyzer_2_array_crystal_array_1_loop_index
#define this_box_volume mccchannel_18_analyzer_2_array_crystal_array_1_this_box_volume
#define global_geometry_element mccchannel_18_analyzer_2_array_crystal_array_1_global_geometry_element
#define this_box_storage mccchannel_18_analyzer_2_array_crystal_array_1_this_box_storage
{   /* Declarations of channel_18_analyzer_2_array_crystal_array_1=Union_box() SETTING parameters. */
char* material_string = mccchannel_18_analyzer_2_array_crystal_array_1_material_string;
MCNUM priority = mccchannel_18_analyzer_2_array_crystal_array_1_priority;
MCNUM xwidth = mccchannel_18_analyzer_2_array_crystal_array_1_xwidth;
MCNUM yheight = mccchannel_18_analyzer_2_array_crystal_array_1_yheight;
MCNUM zdepth = mccchannel_18_analyzer_2_array_crystal_array_1_zdepth;
MCNUM xwidth2 = mccchannel_18_analyzer_2_array_crystal_array_1_xwidth2;
MCNUM yheight2 = mccchannel_18_analyzer_2_array_crystal_array_1_yheight2;
MCNUM visualize = mccchannel_18_analyzer_2_array_crystal_array_1_visualize;
int target_index = mccchannel_18_analyzer_2_array_crystal_array_1_target_index;
MCNUM target_x = mccchannel_18_analyzer_2_array_crystal_array_1_target_x;
MCNUM target_y = mccchannel_18_analyzer_2_array_crystal_array_1_target_y;
MCNUM target_z = mccchannel_18_analyzer_2_array_crystal_array_1_target_z;
MCNUM focus_aw = mccchannel_18_analyzer_2_array_crystal_array_1_focus_aw;
MCNUM focus_ah = mccchannel_18_analyzer_2_array_crystal_array_1_focus_ah;
MCNUM focus_xw = mccchannel_18_analyzer_2_array_crystal_array_1_focus_xw;
MCNUM focus_xh = mccchannel_18_analyzer_2_array_crystal_array_1_focus_xh;
MCNUM focus_r = mccchannel_18_analyzer_2_array_crystal_array_1_focus_r;
MCNUM p_interact = mccchannel_18_analyzer_2_array_crystal_array_1_p_interact;
char* mask_string = mccchannel_18_analyzer_2_array_crystal_array_1_mask_string;
char* mask_setting = mccchannel_18_analyzer_2_array_crystal_array_1_mask_setting;
MCNUM number_of_activations = mccchannel_18_analyzer_2_array_crystal_array_1_number_of_activations;
}   /* End of channel_18_analyzer_2_array_crystal_array_1=Union_box() SETTING parameter declarations. */
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex
  /* Label for restoring  neutron */
  mcabsorbCompchannel_18_analyzer_2_array_crystal_array_1:
  if (RESTORE) /* restore if needed */
  { RESTORE_NEUTRON(826,
      mcnlx,
      mcnly,
      mcnlz,
      mcnlvx,
      mcnlvy,
      mcnlvz,
      mcnlt,
      mcnlsx,
      mcnlsy,
      mcnlsz,
      mcnlp); }
#undef mcabsorbComp
#undef p
#undef sz
#undef sy
#undef sx
#undef t
#undef vz
#undef vy
#undef vx
#undef z
#undef y
#undef x
  mcDEBUG_STATE(
mcnlx,
mcnly,
mcnlz,
mcnlvx,
mcnlvy,
mcnlvz,
mcnlt,
mcnlsx,
mcnlsy,
mcnlsz,
mcnlp)

  /* TRACE Component channel_18_analyzer_2_array_crystal_array_2 [827] */
  mccoordschange(mcposrchannel_18_analyzer_2_array_crystal_array_2, mcrotrchannel_18_analyzer_2_array_crystal_array_2,
    &mcnlx,
    &mcnly,
    &mcnlz,
    &mcnlvx,
    &mcnlvy,
    &mcnlvz,
    &mcnlsx,
    &mcnlsy,
    &mcnlsz);
  /* define label inside component channel_18_analyzer_2_array_crystal_array_2 (without coords transformations) */
  mcJumpTrace_channel_18_analyzer_2_array_crystal_array_2:
  SIG_MESSAGE("channel_18_analyzer_2_array_crystal_array_2 (Trace)");
  mcDEBUG_COMP("channel_18_analyzer_2_array_crystal_array_2")
  mcDEBUG_STATE(
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp)
#define x mcnlx
#define y mcnly
#define z mcnlz
#define vx mcnlvx
#define vy mcnlvy
#define vz mcnlvz
#define t mcnlt
#define sx mcnlsx
#define sy mcnlsy
#define sz mcnlsz
#define p mcnlp

#define mcabsorbComp mcabsorbCompchannel_18_analyzer_2_array_crystal_array_2
  STORE_NEUTRON(827,
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp);
  mcScattered=0;
  mcRestore=0;
  mcNCounter[827]++;
  mcPCounter[827] += p;
  mcP2Counter[827] += p*p;
#define mccompcurname  channel_18_analyzer_2_array_crystal_array_2
#define mccompcurtype  Union_box
#define mccompcurindex 827
#define loop_index mccchannel_18_analyzer_2_array_crystal_array_2_loop_index
#define this_box_volume mccchannel_18_analyzer_2_array_crystal_array_2_this_box_volume
#define global_geometry_element mccchannel_18_analyzer_2_array_crystal_array_2_global_geometry_element
#define this_box_storage mccchannel_18_analyzer_2_array_crystal_array_2_this_box_storage
{   /* Declarations of channel_18_analyzer_2_array_crystal_array_2=Union_box() SETTING parameters. */
char* material_string = mccchannel_18_analyzer_2_array_crystal_array_2_material_string;
MCNUM priority = mccchannel_18_analyzer_2_array_crystal_array_2_priority;
MCNUM xwidth = mccchannel_18_analyzer_2_array_crystal_array_2_xwidth;
MCNUM yheight = mccchannel_18_analyzer_2_array_crystal_array_2_yheight;
MCNUM zdepth = mccchannel_18_analyzer_2_array_crystal_array_2_zdepth;
MCNUM xwidth2 = mccchannel_18_analyzer_2_array_crystal_array_2_xwidth2;
MCNUM yheight2 = mccchannel_18_analyzer_2_array_crystal_array_2_yheight2;
MCNUM visualize = mccchannel_18_analyzer_2_array_crystal_array_2_visualize;
int target_index = mccchannel_18_analyzer_2_array_crystal_array_2_target_index;
MCNUM target_x = mccchannel_18_analyzer_2_array_crystal_array_2_target_x;
MCNUM target_y = mccchannel_18_analyzer_2_array_crystal_array_2_target_y;
MCNUM target_z = mccchannel_18_analyzer_2_array_crystal_array_2_target_z;
MCNUM focus_aw = mccchannel_18_analyzer_2_array_crystal_array_2_focus_aw;
MCNUM focus_ah = mccchannel_18_analyzer_2_array_crystal_array_2_focus_ah;
MCNUM focus_xw = mccchannel_18_analyzer_2_array_crystal_array_2_focus_xw;
MCNUM focus_xh = mccchannel_18_analyzer_2_array_crystal_array_2_focus_xh;
MCNUM focus_r = mccchannel_18_analyzer_2_array_crystal_array_2_focus_r;
MCNUM p_interact = mccchannel_18_analyzer_2_array_crystal_array_2_p_interact;
char* mask_string = mccchannel_18_analyzer_2_array_crystal_array_2_mask_string;
char* mask_setting = mccchannel_18_analyzer_2_array_crystal_array_2_mask_setting;
MCNUM number_of_activations = mccchannel_18_analyzer_2_array_crystal_array_2_number_of_activations;
}   /* End of channel_18_analyzer_2_array_crystal_array_2=Union_box() SETTING parameter declarations. */
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex
  /* Label for restoring  neutron */
  mcabsorbCompchannel_18_analyzer_2_array_crystal_array_2:
  if (RESTORE) /* restore if needed */
  { RESTORE_NEUTRON(827,
      mcnlx,
      mcnly,
      mcnlz,
      mcnlvx,
      mcnlvy,
      mcnlvz,
      mcnlt,
      mcnlsx,
      mcnlsy,
      mcnlsz,
      mcnlp); }
#undef mcabsorbComp
#undef p
#undef sz
#undef sy
#undef sx
#undef t
#undef vz
#undef vy
#undef vx
#undef z
#undef y
#undef x
  mcDEBUG_STATE(
mcnlx,
mcnly,
mcnlz,
mcnlvx,
mcnlvy,
mcnlvz,
mcnlt,
mcnlsx,
mcnlsy,
mcnlsz,
mcnlp)

  /* TRACE Component channel_18_analyzer_2_array_crystal_array_3 [828] */
  mccoordschange(mcposrchannel_18_analyzer_2_array_crystal_array_3, mcrotrchannel_18_analyzer_2_array_crystal_array_3,
    &mcnlx,
    &mcnly,
    &mcnlz,
    &mcnlvx,
    &mcnlvy,
    &mcnlvz,
    &mcnlsx,
    &mcnlsy,
    &mcnlsz);
  /* define label inside component channel_18_analyzer_2_array_crystal_array_3 (without coords transformations) */
  mcJumpTrace_channel_18_analyzer_2_array_crystal_array_3:
  SIG_MESSAGE("channel_18_analyzer_2_array_crystal_array_3 (Trace)");
  mcDEBUG_COMP("channel_18_analyzer_2_array_crystal_array_3")
  mcDEBUG_STATE(
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp)
#define x mcnlx
#define y mcnly
#define z mcnlz
#define vx mcnlvx
#define vy mcnlvy
#define vz mcnlvz
#define t mcnlt
#define sx mcnlsx
#define sy mcnlsy
#define sz mcnlsz
#define p mcnlp

#define mcabsorbComp mcabsorbCompchannel_18_analyzer_2_array_crystal_array_3
  STORE_NEUTRON(828,
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp);
  mcScattered=0;
  mcRestore=0;
  mcNCounter[828]++;
  mcPCounter[828] += p;
  mcP2Counter[828] += p*p;
#define mccompcurname  channel_18_analyzer_2_array_crystal_array_3
#define mccompcurtype  Union_box
#define mccompcurindex 828
#define loop_index mccchannel_18_analyzer_2_array_crystal_array_3_loop_index
#define this_box_volume mccchannel_18_analyzer_2_array_crystal_array_3_this_box_volume
#define global_geometry_element mccchannel_18_analyzer_2_array_crystal_array_3_global_geometry_element
#define this_box_storage mccchannel_18_analyzer_2_array_crystal_array_3_this_box_storage
{   /* Declarations of channel_18_analyzer_2_array_crystal_array_3=Union_box() SETTING parameters. */
char* material_string = mccchannel_18_analyzer_2_array_crystal_array_3_material_string;
MCNUM priority = mccchannel_18_analyzer_2_array_crystal_array_3_priority;
MCNUM xwidth = mccchannel_18_analyzer_2_array_crystal_array_3_xwidth;
MCNUM yheight = mccchannel_18_analyzer_2_array_crystal_array_3_yheight;
MCNUM zdepth = mccchannel_18_analyzer_2_array_crystal_array_3_zdepth;
MCNUM xwidth2 = mccchannel_18_analyzer_2_array_crystal_array_3_xwidth2;
MCNUM yheight2 = mccchannel_18_analyzer_2_array_crystal_array_3_yheight2;
MCNUM visualize = mccchannel_18_analyzer_2_array_crystal_array_3_visualize;
int target_index = mccchannel_18_analyzer_2_array_crystal_array_3_target_index;
MCNUM target_x = mccchannel_18_analyzer_2_array_crystal_array_3_target_x;
MCNUM target_y = mccchannel_18_analyzer_2_array_crystal_array_3_target_y;
MCNUM target_z = mccchannel_18_analyzer_2_array_crystal_array_3_target_z;
MCNUM focus_aw = mccchannel_18_analyzer_2_array_crystal_array_3_focus_aw;
MCNUM focus_ah = mccchannel_18_analyzer_2_array_crystal_array_3_focus_ah;
MCNUM focus_xw = mccchannel_18_analyzer_2_array_crystal_array_3_focus_xw;
MCNUM focus_xh = mccchannel_18_analyzer_2_array_crystal_array_3_focus_xh;
MCNUM focus_r = mccchannel_18_analyzer_2_array_crystal_array_3_focus_r;
MCNUM p_interact = mccchannel_18_analyzer_2_array_crystal_array_3_p_interact;
char* mask_string = mccchannel_18_analyzer_2_array_crystal_array_3_mask_string;
char* mask_setting = mccchannel_18_analyzer_2_array_crystal_array_3_mask_setting;
MCNUM number_of_activations = mccchannel_18_analyzer_2_array_crystal_array_3_number_of_activations;
}   /* End of channel_18_analyzer_2_array_crystal_array_3=Union_box() SETTING parameter declarations. */
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex
  /* Label for restoring  neutron */
  mcabsorbCompchannel_18_analyzer_2_array_crystal_array_3:
  if (RESTORE) /* restore if needed */
  { RESTORE_NEUTRON(828,
      mcnlx,
      mcnly,
      mcnlz,
      mcnlvx,
      mcnlvy,
      mcnlvz,
      mcnlt,
      mcnlsx,
      mcnlsy,
      mcnlsz,
      mcnlp); }
#undef mcabsorbComp
#undef p
#undef sz
#undef sy
#undef sx
#undef t
#undef vz
#undef vy
#undef vx
#undef z
#undef y
#undef x
  mcDEBUG_STATE(
mcnlx,
mcnly,
mcnlz,
mcnlvx,
mcnlvy,
mcnlvz,
mcnlt,
mcnlsx,
mcnlsy,
mcnlsz,
mcnlp)

  /* TRACE Component channel_18_analyzer_2_array_crystal_array_4 [829] */
  mccoordschange(mcposrchannel_18_analyzer_2_array_crystal_array_4, mcrotrchannel_18_analyzer_2_array_crystal_array_4,
    &mcnlx,
    &mcnly,
    &mcnlz,
    &mcnlvx,
    &mcnlvy,
    &mcnlvz,
    &mcnlsx,
    &mcnlsy,
    &mcnlsz);
  /* define label inside component channel_18_analyzer_2_array_crystal_array_4 (without coords transformations) */
  mcJumpTrace_channel_18_analyzer_2_array_crystal_array_4:
  SIG_MESSAGE("channel_18_analyzer_2_array_crystal_array_4 (Trace)");
  mcDEBUG_COMP("channel_18_analyzer_2_array_crystal_array_4")
  mcDEBUG_STATE(
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp)
#define x mcnlx
#define y mcnly
#define z mcnlz
#define vx mcnlvx
#define vy mcnlvy
#define vz mcnlvz
#define t mcnlt
#define sx mcnlsx
#define sy mcnlsy
#define sz mcnlsz
#define p mcnlp

#define mcabsorbComp mcabsorbCompchannel_18_analyzer_2_array_crystal_array_4
  STORE_NEUTRON(829,
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp);
  mcScattered=0;
  mcRestore=0;
  mcNCounter[829]++;
  mcPCounter[829] += p;
  mcP2Counter[829] += p*p;
#define mccompcurname  channel_18_analyzer_2_array_crystal_array_4
#define mccompcurtype  Union_box
#define mccompcurindex 829
#define loop_index mccchannel_18_analyzer_2_array_crystal_array_4_loop_index
#define this_box_volume mccchannel_18_analyzer_2_array_crystal_array_4_this_box_volume
#define global_geometry_element mccchannel_18_analyzer_2_array_crystal_array_4_global_geometry_element
#define this_box_storage mccchannel_18_analyzer_2_array_crystal_array_4_this_box_storage
{   /* Declarations of channel_18_analyzer_2_array_crystal_array_4=Union_box() SETTING parameters. */
char* material_string = mccchannel_18_analyzer_2_array_crystal_array_4_material_string;
MCNUM priority = mccchannel_18_analyzer_2_array_crystal_array_4_priority;
MCNUM xwidth = mccchannel_18_analyzer_2_array_crystal_array_4_xwidth;
MCNUM yheight = mccchannel_18_analyzer_2_array_crystal_array_4_yheight;
MCNUM zdepth = mccchannel_18_analyzer_2_array_crystal_array_4_zdepth;
MCNUM xwidth2 = mccchannel_18_analyzer_2_array_crystal_array_4_xwidth2;
MCNUM yheight2 = mccchannel_18_analyzer_2_array_crystal_array_4_yheight2;
MCNUM visualize = mccchannel_18_analyzer_2_array_crystal_array_4_visualize;
int target_index = mccchannel_18_analyzer_2_array_crystal_array_4_target_index;
MCNUM target_x = mccchannel_18_analyzer_2_array_crystal_array_4_target_x;
MCNUM target_y = mccchannel_18_analyzer_2_array_crystal_array_4_target_y;
MCNUM target_z = mccchannel_18_analyzer_2_array_crystal_array_4_target_z;
MCNUM focus_aw = mccchannel_18_analyzer_2_array_crystal_array_4_focus_aw;
MCNUM focus_ah = mccchannel_18_analyzer_2_array_crystal_array_4_focus_ah;
MCNUM focus_xw = mccchannel_18_analyzer_2_array_crystal_array_4_focus_xw;
MCNUM focus_xh = mccchannel_18_analyzer_2_array_crystal_array_4_focus_xh;
MCNUM focus_r = mccchannel_18_analyzer_2_array_crystal_array_4_focus_r;
MCNUM p_interact = mccchannel_18_analyzer_2_array_crystal_array_4_p_interact;
char* mask_string = mccchannel_18_analyzer_2_array_crystal_array_4_mask_string;
char* mask_setting = mccchannel_18_analyzer_2_array_crystal_array_4_mask_setting;
MCNUM number_of_activations = mccchannel_18_analyzer_2_array_crystal_array_4_number_of_activations;
}   /* End of channel_18_analyzer_2_array_crystal_array_4=Union_box() SETTING parameter declarations. */
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex
  /* Label for restoring  neutron */
  mcabsorbCompchannel_18_analyzer_2_array_crystal_array_4:
  if (RESTORE) /* restore if needed */
  { RESTORE_NEUTRON(829,
      mcnlx,
      mcnly,
      mcnlz,
      mcnlvx,
      mcnlvy,
      mcnlvz,
      mcnlt,
      mcnlsx,
      mcnlsy,
      mcnlsz,
      mcnlp); }
#undef mcabsorbComp
#undef p
#undef sz
#undef sy
#undef sx
#undef t
#undef vz
#undef vy
#undef vx
#undef z
#undef y
#undef x
  mcDEBUG_STATE(
mcnlx,
mcnly,
mcnlz,
mcnlvx,
mcnlvy,
mcnlvz,
mcnlt,
mcnlsx,
mcnlsy,
mcnlsz,
mcnlp)

  /* TRACE Component channel_18_analyzer_2_array_crystal_array_5 [830] */
  mccoordschange(mcposrchannel_18_analyzer_2_array_crystal_array_5, mcrotrchannel_18_analyzer_2_array_crystal_array_5,
    &mcnlx,
    &mcnly,
    &mcnlz,
    &mcnlvx,
    &mcnlvy,
    &mcnlvz,
    &mcnlsx,
    &mcnlsy,
    &mcnlsz);
  /* define label inside component channel_18_analyzer_2_array_crystal_array_5 (without coords transformations) */
  mcJumpTrace_channel_18_analyzer_2_array_crystal_array_5:
  SIG_MESSAGE("channel_18_analyzer_2_array_crystal_array_5 (Trace)");
  mcDEBUG_COMP("channel_18_analyzer_2_array_crystal_array_5")
  mcDEBUG_STATE(
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp)
#define x mcnlx
#define y mcnly
#define z mcnlz
#define vx mcnlvx
#define vy mcnlvy
#define vz mcnlvz
#define t mcnlt
#define sx mcnlsx
#define sy mcnlsy
#define sz mcnlsz
#define p mcnlp

#define mcabsorbComp mcabsorbCompchannel_18_analyzer_2_array_crystal_array_5
  STORE_NEUTRON(830,
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp);
  mcScattered=0;
  mcRestore=0;
  mcNCounter[830]++;
  mcPCounter[830] += p;
  mcP2Counter[830] += p*p;
#define mccompcurname  channel_18_analyzer_2_array_crystal_array_5
#define mccompcurtype  Union_box
#define mccompcurindex 830
#define loop_index mccchannel_18_analyzer_2_array_crystal_array_5_loop_index
#define this_box_volume mccchannel_18_analyzer_2_array_crystal_array_5_this_box_volume
#define global_geometry_element mccchannel_18_analyzer_2_array_crystal_array_5_global_geometry_element
#define this_box_storage mccchannel_18_analyzer_2_array_crystal_array_5_this_box_storage
{   /* Declarations of channel_18_analyzer_2_array_crystal_array_5=Union_box() SETTING parameters. */
char* material_string = mccchannel_18_analyzer_2_array_crystal_array_5_material_string;
MCNUM priority = mccchannel_18_analyzer_2_array_crystal_array_5_priority;
MCNUM xwidth = mccchannel_18_analyzer_2_array_crystal_array_5_xwidth;
MCNUM yheight = mccchannel_18_analyzer_2_array_crystal_array_5_yheight;
MCNUM zdepth = mccchannel_18_analyzer_2_array_crystal_array_5_zdepth;
MCNUM xwidth2 = mccchannel_18_analyzer_2_array_crystal_array_5_xwidth2;
MCNUM yheight2 = mccchannel_18_analyzer_2_array_crystal_array_5_yheight2;
MCNUM visualize = mccchannel_18_analyzer_2_array_crystal_array_5_visualize;
int target_index = mccchannel_18_analyzer_2_array_crystal_array_5_target_index;
MCNUM target_x = mccchannel_18_analyzer_2_array_crystal_array_5_target_x;
MCNUM target_y = mccchannel_18_analyzer_2_array_crystal_array_5_target_y;
MCNUM target_z = mccchannel_18_analyzer_2_array_crystal_array_5_target_z;
MCNUM focus_aw = mccchannel_18_analyzer_2_array_crystal_array_5_focus_aw;
MCNUM focus_ah = mccchannel_18_analyzer_2_array_crystal_array_5_focus_ah;
MCNUM focus_xw = mccchannel_18_analyzer_2_array_crystal_array_5_focus_xw;
MCNUM focus_xh = mccchannel_18_analyzer_2_array_crystal_array_5_focus_xh;
MCNUM focus_r = mccchannel_18_analyzer_2_array_crystal_array_5_focus_r;
MCNUM p_interact = mccchannel_18_analyzer_2_array_crystal_array_5_p_interact;
char* mask_string = mccchannel_18_analyzer_2_array_crystal_array_5_mask_string;
char* mask_setting = mccchannel_18_analyzer_2_array_crystal_array_5_mask_setting;
MCNUM number_of_activations = mccchannel_18_analyzer_2_array_crystal_array_5_number_of_activations;
}   /* End of channel_18_analyzer_2_array_crystal_array_5=Union_box() SETTING parameter declarations. */
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex
  /* Label for restoring  neutron */
  mcabsorbCompchannel_18_analyzer_2_array_crystal_array_5:
  if (RESTORE) /* restore if needed */
  { RESTORE_NEUTRON(830,
      mcnlx,
      mcnly,
      mcnlz,
      mcnlvx,
      mcnlvy,
      mcnlvz,
      mcnlt,
      mcnlsx,
      mcnlsy,
      mcnlsz,
      mcnlp); }
#undef mcabsorbComp
#undef p
#undef sz
#undef sy
#undef sx
#undef t
#undef vz
#undef vy
#undef vx
#undef z
#undef y
#undef x
  mcDEBUG_STATE(
mcnlx,
mcnly,
mcnlz,
mcnlvx,
mcnlvy,
mcnlvz,
mcnlt,
mcnlsx,
mcnlsy,
mcnlsz,
mcnlp)

  /* TRACE Component channel_18_analyzer_2_array_crystal_array_6 [831] */
  mccoordschange(mcposrchannel_18_analyzer_2_array_crystal_array_6, mcrotrchannel_18_analyzer_2_array_crystal_array_6,
    &mcnlx,
    &mcnly,
    &mcnlz,
    &mcnlvx,
    &mcnlvy,
    &mcnlvz,
    &mcnlsx,
    &mcnlsy,
    &mcnlsz);
  /* define label inside component channel_18_analyzer_2_array_crystal_array_6 (without coords transformations) */
  mcJumpTrace_channel_18_analyzer_2_array_crystal_array_6:
  SIG_MESSAGE("channel_18_analyzer_2_array_crystal_array_6 (Trace)");
  mcDEBUG_COMP("channel_18_analyzer_2_array_crystal_array_6")
  mcDEBUG_STATE(
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp)
#define x mcnlx
#define y mcnly
#define z mcnlz
#define vx mcnlvx
#define vy mcnlvy
#define vz mcnlvz
#define t mcnlt
#define sx mcnlsx
#define sy mcnlsy
#define sz mcnlsz
#define p mcnlp

#define mcabsorbComp mcabsorbCompchannel_18_analyzer_2_array_crystal_array_6
  STORE_NEUTRON(831,
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp);
  mcScattered=0;
  mcRestore=0;
  mcNCounter[831]++;
  mcPCounter[831] += p;
  mcP2Counter[831] += p*p;
#define mccompcurname  channel_18_analyzer_2_array_crystal_array_6
#define mccompcurtype  Union_box
#define mccompcurindex 831
#define loop_index mccchannel_18_analyzer_2_array_crystal_array_6_loop_index
#define this_box_volume mccchannel_18_analyzer_2_array_crystal_array_6_this_box_volume
#define global_geometry_element mccchannel_18_analyzer_2_array_crystal_array_6_global_geometry_element
#define this_box_storage mccchannel_18_analyzer_2_array_crystal_array_6_this_box_storage
{   /* Declarations of channel_18_analyzer_2_array_crystal_array_6=Union_box() SETTING parameters. */
char* material_string = mccchannel_18_analyzer_2_array_crystal_array_6_material_string;
MCNUM priority = mccchannel_18_analyzer_2_array_crystal_array_6_priority;
MCNUM xwidth = mccchannel_18_analyzer_2_array_crystal_array_6_xwidth;
MCNUM yheight = mccchannel_18_analyzer_2_array_crystal_array_6_yheight;
MCNUM zdepth = mccchannel_18_analyzer_2_array_crystal_array_6_zdepth;
MCNUM xwidth2 = mccchannel_18_analyzer_2_array_crystal_array_6_xwidth2;
MCNUM yheight2 = mccchannel_18_analyzer_2_array_crystal_array_6_yheight2;
MCNUM visualize = mccchannel_18_analyzer_2_array_crystal_array_6_visualize;
int target_index = mccchannel_18_analyzer_2_array_crystal_array_6_target_index;
MCNUM target_x = mccchannel_18_analyzer_2_array_crystal_array_6_target_x;
MCNUM target_y = mccchannel_18_analyzer_2_array_crystal_array_6_target_y;
MCNUM target_z = mccchannel_18_analyzer_2_array_crystal_array_6_target_z;
MCNUM focus_aw = mccchannel_18_analyzer_2_array_crystal_array_6_focus_aw;
MCNUM focus_ah = mccchannel_18_analyzer_2_array_crystal_array_6_focus_ah;
MCNUM focus_xw = mccchannel_18_analyzer_2_array_crystal_array_6_focus_xw;
MCNUM focus_xh = mccchannel_18_analyzer_2_array_crystal_array_6_focus_xh;
MCNUM focus_r = mccchannel_18_analyzer_2_array_crystal_array_6_focus_r;
MCNUM p_interact = mccchannel_18_analyzer_2_array_crystal_array_6_p_interact;
char* mask_string = mccchannel_18_analyzer_2_array_crystal_array_6_mask_string;
char* mask_setting = mccchannel_18_analyzer_2_array_crystal_array_6_mask_setting;
MCNUM number_of_activations = mccchannel_18_analyzer_2_array_crystal_array_6_number_of_activations;
}   /* End of channel_18_analyzer_2_array_crystal_array_6=Union_box() SETTING parameter declarations. */
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex
  /* Label for restoring  neutron */
  mcabsorbCompchannel_18_analyzer_2_array_crystal_array_6:
  if (RESTORE) /* restore if needed */
  { RESTORE_NEUTRON(831,
      mcnlx,
      mcnly,
      mcnlz,
      mcnlvx,
      mcnlvy,
      mcnlvz,
      mcnlt,
      mcnlsx,
      mcnlsy,
      mcnlsz,
      mcnlp); }
#undef mcabsorbComp
#undef p
#undef sz
#undef sy
#undef sx
#undef t
#undef vz
#undef vy
#undef vx
#undef z
#undef y
#undef x
  mcDEBUG_STATE(
mcnlx,
mcnly,
mcnlz,
mcnlvx,
mcnlvy,
mcnlvz,
mcnlt,
mcnlsx,
mcnlsy,
mcnlsz,
mcnlp)

  /* TRACE Component channel_18_analyzer_2_array_crystal_array_7 [832] */
  mccoordschange(mcposrchannel_18_analyzer_2_array_crystal_array_7, mcrotrchannel_18_analyzer_2_array_crystal_array_7,
    &mcnlx,
    &mcnly,
    &mcnlz,
    &mcnlvx,
    &mcnlvy,
    &mcnlvz,
    &mcnlsx,
    &mcnlsy,
    &mcnlsz);
  /* define label inside component channel_18_analyzer_2_array_crystal_array_7 (without coords transformations) */
  mcJumpTrace_channel_18_analyzer_2_array_crystal_array_7:
  SIG_MESSAGE("channel_18_analyzer_2_array_crystal_array_7 (Trace)");
  mcDEBUG_COMP("channel_18_analyzer_2_array_crystal_array_7")
  mcDEBUG_STATE(
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp)
#define x mcnlx
#define y mcnly
#define z mcnlz
#define vx mcnlvx
#define vy mcnlvy
#define vz mcnlvz
#define t mcnlt
#define sx mcnlsx
#define sy mcnlsy
#define sz mcnlsz
#define p mcnlp

#define mcabsorbComp mcabsorbCompchannel_18_analyzer_2_array_crystal_array_7
  STORE_NEUTRON(832,
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp);
  mcScattered=0;
  mcRestore=0;
  mcNCounter[832]++;
  mcPCounter[832] += p;
  mcP2Counter[832] += p*p;
#define mccompcurname  channel_18_analyzer_2_array_crystal_array_7
#define mccompcurtype  Union_box
#define mccompcurindex 832
#define loop_index mccchannel_18_analyzer_2_array_crystal_array_7_loop_index
#define this_box_volume mccchannel_18_analyzer_2_array_crystal_array_7_this_box_volume
#define global_geometry_element mccchannel_18_analyzer_2_array_crystal_array_7_global_geometry_element
#define this_box_storage mccchannel_18_analyzer_2_array_crystal_array_7_this_box_storage
{   /* Declarations of channel_18_analyzer_2_array_crystal_array_7=Union_box() SETTING parameters. */
char* material_string = mccchannel_18_analyzer_2_array_crystal_array_7_material_string;
MCNUM priority = mccchannel_18_analyzer_2_array_crystal_array_7_priority;
MCNUM xwidth = mccchannel_18_analyzer_2_array_crystal_array_7_xwidth;
MCNUM yheight = mccchannel_18_analyzer_2_array_crystal_array_7_yheight;
MCNUM zdepth = mccchannel_18_analyzer_2_array_crystal_array_7_zdepth;
MCNUM xwidth2 = mccchannel_18_analyzer_2_array_crystal_array_7_xwidth2;
MCNUM yheight2 = mccchannel_18_analyzer_2_array_crystal_array_7_yheight2;
MCNUM visualize = mccchannel_18_analyzer_2_array_crystal_array_7_visualize;
int target_index = mccchannel_18_analyzer_2_array_crystal_array_7_target_index;
MCNUM target_x = mccchannel_18_analyzer_2_array_crystal_array_7_target_x;
MCNUM target_y = mccchannel_18_analyzer_2_array_crystal_array_7_target_y;
MCNUM target_z = mccchannel_18_analyzer_2_array_crystal_array_7_target_z;
MCNUM focus_aw = mccchannel_18_analyzer_2_array_crystal_array_7_focus_aw;
MCNUM focus_ah = mccchannel_18_analyzer_2_array_crystal_array_7_focus_ah;
MCNUM focus_xw = mccchannel_18_analyzer_2_array_crystal_array_7_focus_xw;
MCNUM focus_xh = mccchannel_18_analyzer_2_array_crystal_array_7_focus_xh;
MCNUM focus_r = mccchannel_18_analyzer_2_array_crystal_array_7_focus_r;
MCNUM p_interact = mccchannel_18_analyzer_2_array_crystal_array_7_p_interact;
char* mask_string = mccchannel_18_analyzer_2_array_crystal_array_7_mask_string;
char* mask_setting = mccchannel_18_analyzer_2_array_crystal_array_7_mask_setting;
MCNUM number_of_activations = mccchannel_18_analyzer_2_array_crystal_array_7_number_of_activations;
}   /* End of channel_18_analyzer_2_array_crystal_array_7=Union_box() SETTING parameter declarations. */
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex
  /* Label for restoring  neutron */
  mcabsorbCompchannel_18_analyzer_2_array_crystal_array_7:
  if (RESTORE) /* restore if needed */
  { RESTORE_NEUTRON(832,
      mcnlx,
      mcnly,
      mcnlz,
      mcnlvx,
      mcnlvy,
      mcnlvz,
      mcnlt,
      mcnlsx,
      mcnlsy,
      mcnlsz,
      mcnlp); }
#undef mcabsorbComp
#undef p
#undef sz
#undef sy
#undef sx
#undef t
#undef vz
#undef vy
#undef vx
#undef z
#undef y
#undef x
  mcDEBUG_STATE(
mcnlx,
mcnly,
mcnlz,
mcnlvx,
mcnlvy,
mcnlvz,
mcnlt,
mcnlsx,
mcnlsy,
mcnlsz,
mcnlp)

  /* TRACE Component channel_18_analyzer_2_array_crystal_array_8 [833] */
  mccoordschange(mcposrchannel_18_analyzer_2_array_crystal_array_8, mcrotrchannel_18_analyzer_2_array_crystal_array_8,
    &mcnlx,
    &mcnly,
    &mcnlz,
    &mcnlvx,
    &mcnlvy,
    &mcnlvz,
    &mcnlsx,
    &mcnlsy,
    &mcnlsz);
  /* define label inside component channel_18_analyzer_2_array_crystal_array_8 (without coords transformations) */
  mcJumpTrace_channel_18_analyzer_2_array_crystal_array_8:
  SIG_MESSAGE("channel_18_analyzer_2_array_crystal_array_8 (Trace)");
  mcDEBUG_COMP("channel_18_analyzer_2_array_crystal_array_8")
  mcDEBUG_STATE(
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp)
#define x mcnlx
#define y mcnly
#define z mcnlz
#define vx mcnlvx
#define vy mcnlvy
#define vz mcnlvz
#define t mcnlt
#define sx mcnlsx
#define sy mcnlsy
#define sz mcnlsz
#define p mcnlp

#define mcabsorbComp mcabsorbCompchannel_18_analyzer_2_array_crystal_array_8
  STORE_NEUTRON(833,
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp);
  mcScattered=0;
  mcRestore=0;
  mcNCounter[833]++;
  mcPCounter[833] += p;
  mcP2Counter[833] += p*p;
#define mccompcurname  channel_18_analyzer_2_array_crystal_array_8
#define mccompcurtype  Union_box
#define mccompcurindex 833
#define loop_index mccchannel_18_analyzer_2_array_crystal_array_8_loop_index
#define this_box_volume mccchannel_18_analyzer_2_array_crystal_array_8_this_box_volume
#define global_geometry_element mccchannel_18_analyzer_2_array_crystal_array_8_global_geometry_element
#define this_box_storage mccchannel_18_analyzer_2_array_crystal_array_8_this_box_storage
{   /* Declarations of channel_18_analyzer_2_array_crystal_array_8=Union_box() SETTING parameters. */
char* material_string = mccchannel_18_analyzer_2_array_crystal_array_8_material_string;
MCNUM priority = mccchannel_18_analyzer_2_array_crystal_array_8_priority;
MCNUM xwidth = mccchannel_18_analyzer_2_array_crystal_array_8_xwidth;
MCNUM yheight = mccchannel_18_analyzer_2_array_crystal_array_8_yheight;
MCNUM zdepth = mccchannel_18_analyzer_2_array_crystal_array_8_zdepth;
MCNUM xwidth2 = mccchannel_18_analyzer_2_array_crystal_array_8_xwidth2;
MCNUM yheight2 = mccchannel_18_analyzer_2_array_crystal_array_8_yheight2;
MCNUM visualize = mccchannel_18_analyzer_2_array_crystal_array_8_visualize;
int target_index = mccchannel_18_analyzer_2_array_crystal_array_8_target_index;
MCNUM target_x = mccchannel_18_analyzer_2_array_crystal_array_8_target_x;
MCNUM target_y = mccchannel_18_analyzer_2_array_crystal_array_8_target_y;
MCNUM target_z = mccchannel_18_analyzer_2_array_crystal_array_8_target_z;
MCNUM focus_aw = mccchannel_18_analyzer_2_array_crystal_array_8_focus_aw;
MCNUM focus_ah = mccchannel_18_analyzer_2_array_crystal_array_8_focus_ah;
MCNUM focus_xw = mccchannel_18_analyzer_2_array_crystal_array_8_focus_xw;
MCNUM focus_xh = mccchannel_18_analyzer_2_array_crystal_array_8_focus_xh;
MCNUM focus_r = mccchannel_18_analyzer_2_array_crystal_array_8_focus_r;
MCNUM p_interact = mccchannel_18_analyzer_2_array_crystal_array_8_p_interact;
char* mask_string = mccchannel_18_analyzer_2_array_crystal_array_8_mask_string;
char* mask_setting = mccchannel_18_analyzer_2_array_crystal_array_8_mask_setting;
MCNUM number_of_activations = mccchannel_18_analyzer_2_array_crystal_array_8_number_of_activations;
}   /* End of channel_18_analyzer_2_array_crystal_array_8=Union_box() SETTING parameter declarations. */
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex
  /* Label for restoring  neutron */
  mcabsorbCompchannel_18_analyzer_2_array_crystal_array_8:
  if (RESTORE) /* restore if needed */
  { RESTORE_NEUTRON(833,
      mcnlx,
      mcnly,
      mcnlz,
      mcnlvx,
      mcnlvy,
      mcnlvz,
      mcnlt,
      mcnlsx,
      mcnlsy,
      mcnlsz,
      mcnlp); }
#undef mcabsorbComp
#undef p
#undef sz
#undef sy
#undef sx
#undef t
#undef vz
#undef vy
#undef vx
#undef z
#undef y
#undef x
  mcDEBUG_STATE(
mcnlx,
mcnly,
mcnlz,
mcnlvx,
mcnlvy,
mcnlvz,
mcnlt,
mcnlsx,
mcnlsy,
mcnlsz,
mcnlp)

  /* TRACE Component channel_18_cave2_cyl1 [834] */
  mccoordschange(mcposrchannel_18_cave2_cyl1, mcrotrchannel_18_cave2_cyl1,
    &mcnlx,
    &mcnly,
    &mcnlz,
    &mcnlvx,
    &mcnlvy,
    &mcnlvz,
    &mcnlsx,
    &mcnlsy,
    &mcnlsz);
  /* define label inside component channel_18_cave2_cyl1 (without coords transformations) */
  mcJumpTrace_channel_18_cave2_cyl1:
  SIG_MESSAGE("channel_18_cave2_cyl1 (Trace)");
  mcDEBUG_COMP("channel_18_cave2_cyl1")
  mcDEBUG_STATE(
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp)
#define x mcnlx
#define y mcnly
#define z mcnlz
#define vx mcnlvx
#define vy mcnlvy
#define vz mcnlvz
#define t mcnlt
#define sx mcnlsx
#define sy mcnlsy
#define sz mcnlsz
#define p mcnlp

#define mcabsorbComp mcabsorbCompchannel_18_cave2_cyl1
  STORE_NEUTRON(834,
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp);
  mcScattered=0;
  mcRestore=0;
  mcNCounter[834]++;
  mcPCounter[834] += p;
  mcP2Counter[834] += p*p;
#define mccompcurname  channel_18_cave2_cyl1
#define mccompcurtype  Union_cylinder
#define mccompcurindex 834
#define loop_index mccchannel_18_cave2_cyl1_loop_index
#define this_cylinder_volume mccchannel_18_cave2_cyl1_this_cylinder_volume
#define global_geometry_element mccchannel_18_cave2_cyl1_global_geometry_element
#define this_cylinder_storage mccchannel_18_cave2_cyl1_this_cylinder_storage
{   /* Declarations of channel_18_cave2_cyl1=Union_cylinder() SETTING parameters. */
char* material_string = mccchannel_18_cave2_cyl1_material_string;
MCNUM priority = mccchannel_18_cave2_cyl1_priority;
MCNUM radius = mccchannel_18_cave2_cyl1_radius;
MCNUM yheight = mccchannel_18_cave2_cyl1_yheight;
MCNUM visualize = mccchannel_18_cave2_cyl1_visualize;
int target_index = mccchannel_18_cave2_cyl1_target_index;
MCNUM target_x = mccchannel_18_cave2_cyl1_target_x;
MCNUM target_y = mccchannel_18_cave2_cyl1_target_y;
MCNUM target_z = mccchannel_18_cave2_cyl1_target_z;
MCNUM focus_aw = mccchannel_18_cave2_cyl1_focus_aw;
MCNUM focus_ah = mccchannel_18_cave2_cyl1_focus_ah;
MCNUM focus_xw = mccchannel_18_cave2_cyl1_focus_xw;
MCNUM focus_xh = mccchannel_18_cave2_cyl1_focus_xh;
MCNUM focus_r = mccchannel_18_cave2_cyl1_focus_r;
MCNUM p_interact = mccchannel_18_cave2_cyl1_p_interact;
char* mask_string = mccchannel_18_cave2_cyl1_mask_string;
char* mask_setting = mccchannel_18_cave2_cyl1_mask_setting;
MCNUM number_of_activations = mccchannel_18_cave2_cyl1_number_of_activations;
#line 345 "Union_cylinder.comp"
{
dummy = 1;
}
#line 454956 "MACS_sample_kidney_box.c"
}   /* End of channel_18_cave2_cyl1=Union_cylinder() SETTING parameter declarations. */
#undef this_cylinder_storage
#undef global_geometry_element
#undef this_cylinder_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex
  /* Label for restoring  neutron */
  mcabsorbCompchannel_18_cave2_cyl1:
  if (RESTORE) /* restore if needed */
  { RESTORE_NEUTRON(834,
      mcnlx,
      mcnly,
      mcnlz,
      mcnlvx,
      mcnlvy,
      mcnlvz,
      mcnlt,
      mcnlsx,
      mcnlsy,
      mcnlsz,
      mcnlp); }
#undef mcabsorbComp
#undef p
#undef sz
#undef sy
#undef sx
#undef t
#undef vz
#undef vy
#undef vx
#undef z
#undef y
#undef x
  mcDEBUG_STATE(
mcnlx,
mcnly,
mcnlz,
mcnlvx,
mcnlvy,
mcnlvz,
mcnlt,
mcnlsx,
mcnlsy,
mcnlsz,
mcnlp)

  /* TRACE Component channel_18_cave2_box1 [835] */
  mccoordschange(mcposrchannel_18_cave2_box1, mcrotrchannel_18_cave2_box1,
    &mcnlx,
    &mcnly,
    &mcnlz,
    &mcnlvx,
    &mcnlvy,
    &mcnlvz,
    &mcnlsx,
    &mcnlsy,
    &mcnlsz);
  /* define label inside component channel_18_cave2_box1 (without coords transformations) */
  mcJumpTrace_channel_18_cave2_box1:
  SIG_MESSAGE("channel_18_cave2_box1 (Trace)");
  mcDEBUG_COMP("channel_18_cave2_box1")
  mcDEBUG_STATE(
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp)
#define x mcnlx
#define y mcnly
#define z mcnlz
#define vx mcnlvx
#define vy mcnlvy
#define vz mcnlvz
#define t mcnlt
#define sx mcnlsx
#define sy mcnlsy
#define sz mcnlsz
#define p mcnlp

#define mcabsorbComp mcabsorbCompchannel_18_cave2_box1
  STORE_NEUTRON(835,
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp);
  mcScattered=0;
  mcRestore=0;
  mcNCounter[835]++;
  mcPCounter[835] += p;
  mcP2Counter[835] += p*p;
#define mccompcurname  channel_18_cave2_box1
#define mccompcurtype  Union_box
#define mccompcurindex 835
#define loop_index mccchannel_18_cave2_box1_loop_index
#define this_box_volume mccchannel_18_cave2_box1_this_box_volume
#define global_geometry_element mccchannel_18_cave2_box1_global_geometry_element
#define this_box_storage mccchannel_18_cave2_box1_this_box_storage
{   /* Declarations of channel_18_cave2_box1=Union_box() SETTING parameters. */
char* material_string = mccchannel_18_cave2_box1_material_string;
MCNUM priority = mccchannel_18_cave2_box1_priority;
MCNUM xwidth = mccchannel_18_cave2_box1_xwidth;
MCNUM yheight = mccchannel_18_cave2_box1_yheight;
MCNUM zdepth = mccchannel_18_cave2_box1_zdepth;
MCNUM xwidth2 = mccchannel_18_cave2_box1_xwidth2;
MCNUM yheight2 = mccchannel_18_cave2_box1_yheight2;
MCNUM visualize = mccchannel_18_cave2_box1_visualize;
int target_index = mccchannel_18_cave2_box1_target_index;
MCNUM target_x = mccchannel_18_cave2_box1_target_x;
MCNUM target_y = mccchannel_18_cave2_box1_target_y;
MCNUM target_z = mccchannel_18_cave2_box1_target_z;
MCNUM focus_aw = mccchannel_18_cave2_box1_focus_aw;
MCNUM focus_ah = mccchannel_18_cave2_box1_focus_ah;
MCNUM focus_xw = mccchannel_18_cave2_box1_focus_xw;
MCNUM focus_xh = mccchannel_18_cave2_box1_focus_xh;
MCNUM focus_r = mccchannel_18_cave2_box1_focus_r;
MCNUM p_interact = mccchannel_18_cave2_box1_p_interact;
char* mask_string = mccchannel_18_cave2_box1_mask_string;
char* mask_setting = mccchannel_18_cave2_box1_mask_setting;
MCNUM number_of_activations = mccchannel_18_cave2_box1_number_of_activations;
}   /* End of channel_18_cave2_box1=Union_box() SETTING parameter declarations. */
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex
  /* Label for restoring  neutron */
  mcabsorbCompchannel_18_cave2_box1:
  if (RESTORE) /* restore if needed */
  { RESTORE_NEUTRON(835,
      mcnlx,
      mcnly,
      mcnlz,
      mcnlvx,
      mcnlvy,
      mcnlvz,
      mcnlt,
      mcnlsx,
      mcnlsy,
      mcnlsz,
      mcnlp); }
#undef mcabsorbComp
#undef p
#undef sz
#undef sy
#undef sx
#undef t
#undef vz
#undef vy
#undef vx
#undef z
#undef y
#undef x
  mcDEBUG_STATE(
mcnlx,
mcnly,
mcnlz,
mcnlvx,
mcnlvy,
mcnlvz,
mcnlt,
mcnlsx,
mcnlsy,
mcnlsz,
mcnlp)

  /* TRACE Component channel_18_cave2_box2 [836] */
  mccoordschange(mcposrchannel_18_cave2_box2, mcrotrchannel_18_cave2_box2,
    &mcnlx,
    &mcnly,
    &mcnlz,
    &mcnlvx,
    &mcnlvy,
    &mcnlvz,
    &mcnlsx,
    &mcnlsy,
    &mcnlsz);
  /* define label inside component channel_18_cave2_box2 (without coords transformations) */
  mcJumpTrace_channel_18_cave2_box2:
  SIG_MESSAGE("channel_18_cave2_box2 (Trace)");
  mcDEBUG_COMP("channel_18_cave2_box2")
  mcDEBUG_STATE(
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp)
#define x mcnlx
#define y mcnly
#define z mcnlz
#define vx mcnlvx
#define vy mcnlvy
#define vz mcnlvz
#define t mcnlt
#define sx mcnlsx
#define sy mcnlsy
#define sz mcnlsz
#define p mcnlp

#define mcabsorbComp mcabsorbCompchannel_18_cave2_box2
  STORE_NEUTRON(836,
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp);
  mcScattered=0;
  mcRestore=0;
  mcNCounter[836]++;
  mcPCounter[836] += p;
  mcP2Counter[836] += p*p;
#define mccompcurname  channel_18_cave2_box2
#define mccompcurtype  Union_box
#define mccompcurindex 836
#define loop_index mccchannel_18_cave2_box2_loop_index
#define this_box_volume mccchannel_18_cave2_box2_this_box_volume
#define global_geometry_element mccchannel_18_cave2_box2_global_geometry_element
#define this_box_storage mccchannel_18_cave2_box2_this_box_storage
{   /* Declarations of channel_18_cave2_box2=Union_box() SETTING parameters. */
char* material_string = mccchannel_18_cave2_box2_material_string;
MCNUM priority = mccchannel_18_cave2_box2_priority;
MCNUM xwidth = mccchannel_18_cave2_box2_xwidth;
MCNUM yheight = mccchannel_18_cave2_box2_yheight;
MCNUM zdepth = mccchannel_18_cave2_box2_zdepth;
MCNUM xwidth2 = mccchannel_18_cave2_box2_xwidth2;
MCNUM yheight2 = mccchannel_18_cave2_box2_yheight2;
MCNUM visualize = mccchannel_18_cave2_box2_visualize;
int target_index = mccchannel_18_cave2_box2_target_index;
MCNUM target_x = mccchannel_18_cave2_box2_target_x;
MCNUM target_y = mccchannel_18_cave2_box2_target_y;
MCNUM target_z = mccchannel_18_cave2_box2_target_z;
MCNUM focus_aw = mccchannel_18_cave2_box2_focus_aw;
MCNUM focus_ah = mccchannel_18_cave2_box2_focus_ah;
MCNUM focus_xw = mccchannel_18_cave2_box2_focus_xw;
MCNUM focus_xh = mccchannel_18_cave2_box2_focus_xh;
MCNUM focus_r = mccchannel_18_cave2_box2_focus_r;
MCNUM p_interact = mccchannel_18_cave2_box2_p_interact;
char* mask_string = mccchannel_18_cave2_box2_mask_string;
char* mask_setting = mccchannel_18_cave2_box2_mask_setting;
MCNUM number_of_activations = mccchannel_18_cave2_box2_number_of_activations;
}   /* End of channel_18_cave2_box2=Union_box() SETTING parameter declarations. */
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex
  /* Label for restoring  neutron */
  mcabsorbCompchannel_18_cave2_box2:
  if (RESTORE) /* restore if needed */
  { RESTORE_NEUTRON(836,
      mcnlx,
      mcnly,
      mcnlz,
      mcnlvx,
      mcnlvy,
      mcnlvz,
      mcnlt,
      mcnlsx,
      mcnlsy,
      mcnlsz,
      mcnlp); }
#undef mcabsorbComp
#undef p
#undef sz
#undef sy
#undef sx
#undef t
#undef vz
#undef vy
#undef vx
#undef z
#undef y
#undef x
  mcDEBUG_STATE(
mcnlx,
mcnly,
mcnlz,
mcnlvx,
mcnlvy,
mcnlvz,
mcnlt,
mcnlsx,
mcnlsy,
mcnlsz,
mcnlp)

  /* TRACE Component channel_18_cave2_box3 [837] */
  mccoordschange(mcposrchannel_18_cave2_box3, mcrotrchannel_18_cave2_box3,
    &mcnlx,
    &mcnly,
    &mcnlz,
    &mcnlvx,
    &mcnlvy,
    &mcnlvz,
    &mcnlsx,
    &mcnlsy,
    &mcnlsz);
  /* define label inside component channel_18_cave2_box3 (without coords transformations) */
  mcJumpTrace_channel_18_cave2_box3:
  SIG_MESSAGE("channel_18_cave2_box3 (Trace)");
  mcDEBUG_COMP("channel_18_cave2_box3")
  mcDEBUG_STATE(
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp)
#define x mcnlx
#define y mcnly
#define z mcnlz
#define vx mcnlvx
#define vy mcnlvy
#define vz mcnlvz
#define t mcnlt
#define sx mcnlsx
#define sy mcnlsy
#define sz mcnlsz
#define p mcnlp

#define mcabsorbComp mcabsorbCompchannel_18_cave2_box3
  STORE_NEUTRON(837,
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp);
  mcScattered=0;
  mcRestore=0;
  mcNCounter[837]++;
  mcPCounter[837] += p;
  mcP2Counter[837] += p*p;
#define mccompcurname  channel_18_cave2_box3
#define mccompcurtype  Union_box
#define mccompcurindex 837
#define loop_index mccchannel_18_cave2_box3_loop_index
#define this_box_volume mccchannel_18_cave2_box3_this_box_volume
#define global_geometry_element mccchannel_18_cave2_box3_global_geometry_element
#define this_box_storage mccchannel_18_cave2_box3_this_box_storage
{   /* Declarations of channel_18_cave2_box3=Union_box() SETTING parameters. */
char* material_string = mccchannel_18_cave2_box3_material_string;
MCNUM priority = mccchannel_18_cave2_box3_priority;
MCNUM xwidth = mccchannel_18_cave2_box3_xwidth;
MCNUM yheight = mccchannel_18_cave2_box3_yheight;
MCNUM zdepth = mccchannel_18_cave2_box3_zdepth;
MCNUM xwidth2 = mccchannel_18_cave2_box3_xwidth2;
MCNUM yheight2 = mccchannel_18_cave2_box3_yheight2;
MCNUM visualize = mccchannel_18_cave2_box3_visualize;
int target_index = mccchannel_18_cave2_box3_target_index;
MCNUM target_x = mccchannel_18_cave2_box3_target_x;
MCNUM target_y = mccchannel_18_cave2_box3_target_y;
MCNUM target_z = mccchannel_18_cave2_box3_target_z;
MCNUM focus_aw = mccchannel_18_cave2_box3_focus_aw;
MCNUM focus_ah = mccchannel_18_cave2_box3_focus_ah;
MCNUM focus_xw = mccchannel_18_cave2_box3_focus_xw;
MCNUM focus_xh = mccchannel_18_cave2_box3_focus_xh;
MCNUM focus_r = mccchannel_18_cave2_box3_focus_r;
MCNUM p_interact = mccchannel_18_cave2_box3_p_interact;
char* mask_string = mccchannel_18_cave2_box3_mask_string;
char* mask_setting = mccchannel_18_cave2_box3_mask_setting;
MCNUM number_of_activations = mccchannel_18_cave2_box3_number_of_activations;
}   /* End of channel_18_cave2_box3=Union_box() SETTING parameter declarations. */
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex
  /* Label for restoring  neutron */
  mcabsorbCompchannel_18_cave2_box3:
  if (RESTORE) /* restore if needed */
  { RESTORE_NEUTRON(837,
      mcnlx,
      mcnly,
      mcnlz,
      mcnlvx,
      mcnlvy,
      mcnlvz,
      mcnlt,
      mcnlsx,
      mcnlsy,
      mcnlsz,
      mcnlp); }
#undef mcabsorbComp
#undef p
#undef sz
#undef sy
#undef sx
#undef t
#undef vz
#undef vy
#undef vx
#undef z
#undef y
#undef x
  mcDEBUG_STATE(
mcnlx,
mcnly,
mcnlz,
mcnlvx,
mcnlvy,
mcnlvz,
mcnlt,
mcnlsx,
mcnlsy,
mcnlsz,
mcnlp)

  /* TRACE Component inter_analyzer_colimator_center_18 [838] */
  mccoordschange(mcposrinter_analyzer_colimator_center_18, mcrotrinter_analyzer_colimator_center_18,
    &mcnlx,
    &mcnly,
    &mcnlz,
    &mcnlvx,
    &mcnlvy,
    &mcnlvz,
    &mcnlsx,
    &mcnlsy,
    &mcnlsz);
  /* define label inside component inter_analyzer_colimator_center_18 (without coords transformations) */
  mcJumpTrace_inter_analyzer_colimator_center_18:
  SIG_MESSAGE("inter_analyzer_colimator_center_18 (Trace)");
  mcDEBUG_COMP("inter_analyzer_colimator_center_18")
  mcDEBUG_STATE(
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp)
#define x mcnlx
#define y mcnly
#define z mcnlz
#define vx mcnlvx
#define vy mcnlvy
#define vz mcnlvz
#define t mcnlt
#define sx mcnlsx
#define sy mcnlsy
#define sz mcnlsz
#define p mcnlp

#define mcabsorbComp mcabsorbCompinter_analyzer_colimator_center_18
  STORE_NEUTRON(838,
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp);
  mcScattered=0;
  mcRestore=0;
  mcNCounter[838]++;
  mcPCounter[838] += p;
  mcP2Counter[838] += p*p;
#define mccompcurname  inter_analyzer_colimator_center_18
#define mccompcurtype  Arm
#define mccompcurindex 838
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex
  /* Label for restoring  neutron */
  mcabsorbCompinter_analyzer_colimator_center_18:
  if (RESTORE) /* restore if needed */
  { RESTORE_NEUTRON(838,
      mcnlx,
      mcnly,
      mcnlz,
      mcnlvx,
      mcnlvy,
      mcnlvz,
      mcnlt,
      mcnlsx,
      mcnlsy,
      mcnlsz,
      mcnlp); }
#undef mcabsorbComp
#undef p
#undef sz
#undef sy
#undef sx
#undef t
#undef vz
#undef vy
#undef vx
#undef z
#undef y
#undef x
  mcDEBUG_STATE(
mcnlx,
mcnly,
mcnlz,
mcnlvx,
mcnlvy,
mcnlvz,
mcnlt,
mcnlsx,
mcnlsy,
mcnlsz,
mcnlp)

  /* TRACE Component inter_analyzer_colimator_18_blade_0 [839] */
  mccoordschange(mcposrinter_analyzer_colimator_18_blade_0, mcrotrinter_analyzer_colimator_18_blade_0,
    &mcnlx,
    &mcnly,
    &mcnlz,
    &mcnlvx,
    &mcnlvy,
    &mcnlvz,
    &mcnlsx,
    &mcnlsy,
    &mcnlsz);
  /* define label inside component inter_analyzer_colimator_18_blade_0 (without coords transformations) */
  mcJumpTrace_inter_analyzer_colimator_18_blade_0:
  SIG_MESSAGE("inter_analyzer_colimator_18_blade_0 (Trace)");
  mcDEBUG_COMP("inter_analyzer_colimator_18_blade_0")
  mcDEBUG_STATE(
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp)
#define x mcnlx
#define y mcnly
#define z mcnlz
#define vx mcnlvx
#define vy mcnlvy
#define vz mcnlvz
#define t mcnlt
#define sx mcnlsx
#define sy mcnlsy
#define sz mcnlsz
#define p mcnlp

#define mcabsorbComp mcabsorbCompinter_analyzer_colimator_18_blade_0
  STORE_NEUTRON(839,
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp);
  mcScattered=0;
  mcRestore=0;
  mcNCounter[839]++;
  mcPCounter[839] += p;
  mcP2Counter[839] += p*p;
#define mccompcurname  inter_analyzer_colimator_18_blade_0
#define mccompcurtype  Union_box
#define mccompcurindex 839
#define loop_index mccinter_analyzer_colimator_18_blade_0_loop_index
#define this_box_volume mccinter_analyzer_colimator_18_blade_0_this_box_volume
#define global_geometry_element mccinter_analyzer_colimator_18_blade_0_global_geometry_element
#define this_box_storage mccinter_analyzer_colimator_18_blade_0_this_box_storage
{   /* Declarations of inter_analyzer_colimator_18_blade_0=Union_box() SETTING parameters. */
char* material_string = mccinter_analyzer_colimator_18_blade_0_material_string;
MCNUM priority = mccinter_analyzer_colimator_18_blade_0_priority;
MCNUM xwidth = mccinter_analyzer_colimator_18_blade_0_xwidth;
MCNUM yheight = mccinter_analyzer_colimator_18_blade_0_yheight;
MCNUM zdepth = mccinter_analyzer_colimator_18_blade_0_zdepth;
MCNUM xwidth2 = mccinter_analyzer_colimator_18_blade_0_xwidth2;
MCNUM yheight2 = mccinter_analyzer_colimator_18_blade_0_yheight2;
MCNUM visualize = mccinter_analyzer_colimator_18_blade_0_visualize;
int target_index = mccinter_analyzer_colimator_18_blade_0_target_index;
MCNUM target_x = mccinter_analyzer_colimator_18_blade_0_target_x;
MCNUM target_y = mccinter_analyzer_colimator_18_blade_0_target_y;
MCNUM target_z = mccinter_analyzer_colimator_18_blade_0_target_z;
MCNUM focus_aw = mccinter_analyzer_colimator_18_blade_0_focus_aw;
MCNUM focus_ah = mccinter_analyzer_colimator_18_blade_0_focus_ah;
MCNUM focus_xw = mccinter_analyzer_colimator_18_blade_0_focus_xw;
MCNUM focus_xh = mccinter_analyzer_colimator_18_blade_0_focus_xh;
MCNUM focus_r = mccinter_analyzer_colimator_18_blade_0_focus_r;
MCNUM p_interact = mccinter_analyzer_colimator_18_blade_0_p_interact;
char* mask_string = mccinter_analyzer_colimator_18_blade_0_mask_string;
char* mask_setting = mccinter_analyzer_colimator_18_blade_0_mask_setting;
MCNUM number_of_activations = mccinter_analyzer_colimator_18_blade_0_number_of_activations;
}   /* End of inter_analyzer_colimator_18_blade_0=Union_box() SETTING parameter declarations. */
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex
  /* Label for restoring  neutron */
  mcabsorbCompinter_analyzer_colimator_18_blade_0:
  if (RESTORE) /* restore if needed */
  { RESTORE_NEUTRON(839,
      mcnlx,
      mcnly,
      mcnlz,
      mcnlvx,
      mcnlvy,
      mcnlvz,
      mcnlt,
      mcnlsx,
      mcnlsy,
      mcnlsz,
      mcnlp); }
#undef mcabsorbComp
#undef p
#undef sz
#undef sy
#undef sx
#undef t
#undef vz
#undef vy
#undef vx
#undef z
#undef y
#undef x
  mcDEBUG_STATE(
mcnlx,
mcnly,
mcnlz,
mcnlvx,
mcnlvy,
mcnlvz,
mcnlt,
mcnlsx,
mcnlsy,
mcnlsz,
mcnlp)

  /* TRACE Component inter_analyzer_colimator_18_blade_1 [840] */
  mccoordschange(mcposrinter_analyzer_colimator_18_blade_1, mcrotrinter_analyzer_colimator_18_blade_1,
    &mcnlx,
    &mcnly,
    &mcnlz,
    &mcnlvx,
    &mcnlvy,
    &mcnlvz,
    &mcnlsx,
    &mcnlsy,
    &mcnlsz);
  /* define label inside component inter_analyzer_colimator_18_blade_1 (without coords transformations) */
  mcJumpTrace_inter_analyzer_colimator_18_blade_1:
  SIG_MESSAGE("inter_analyzer_colimator_18_blade_1 (Trace)");
  mcDEBUG_COMP("inter_analyzer_colimator_18_blade_1")
  mcDEBUG_STATE(
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp)
#define x mcnlx
#define y mcnly
#define z mcnlz
#define vx mcnlvx
#define vy mcnlvy
#define vz mcnlvz
#define t mcnlt
#define sx mcnlsx
#define sy mcnlsy
#define sz mcnlsz
#define p mcnlp

#define mcabsorbComp mcabsorbCompinter_analyzer_colimator_18_blade_1
  STORE_NEUTRON(840,
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp);
  mcScattered=0;
  mcRestore=0;
  mcNCounter[840]++;
  mcPCounter[840] += p;
  mcP2Counter[840] += p*p;
#define mccompcurname  inter_analyzer_colimator_18_blade_1
#define mccompcurtype  Union_box
#define mccompcurindex 840
#define loop_index mccinter_analyzer_colimator_18_blade_1_loop_index
#define this_box_volume mccinter_analyzer_colimator_18_blade_1_this_box_volume
#define global_geometry_element mccinter_analyzer_colimator_18_blade_1_global_geometry_element
#define this_box_storage mccinter_analyzer_colimator_18_blade_1_this_box_storage
{   /* Declarations of inter_analyzer_colimator_18_blade_1=Union_box() SETTING parameters. */
char* material_string = mccinter_analyzer_colimator_18_blade_1_material_string;
MCNUM priority = mccinter_analyzer_colimator_18_blade_1_priority;
MCNUM xwidth = mccinter_analyzer_colimator_18_blade_1_xwidth;
MCNUM yheight = mccinter_analyzer_colimator_18_blade_1_yheight;
MCNUM zdepth = mccinter_analyzer_colimator_18_blade_1_zdepth;
MCNUM xwidth2 = mccinter_analyzer_colimator_18_blade_1_xwidth2;
MCNUM yheight2 = mccinter_analyzer_colimator_18_blade_1_yheight2;
MCNUM visualize = mccinter_analyzer_colimator_18_blade_1_visualize;
int target_index = mccinter_analyzer_colimator_18_blade_1_target_index;
MCNUM target_x = mccinter_analyzer_colimator_18_blade_1_target_x;
MCNUM target_y = mccinter_analyzer_colimator_18_blade_1_target_y;
MCNUM target_z = mccinter_analyzer_colimator_18_blade_1_target_z;
MCNUM focus_aw = mccinter_analyzer_colimator_18_blade_1_focus_aw;
MCNUM focus_ah = mccinter_analyzer_colimator_18_blade_1_focus_ah;
MCNUM focus_xw = mccinter_analyzer_colimator_18_blade_1_focus_xw;
MCNUM focus_xh = mccinter_analyzer_colimator_18_blade_1_focus_xh;
MCNUM focus_r = mccinter_analyzer_colimator_18_blade_1_focus_r;
MCNUM p_interact = mccinter_analyzer_colimator_18_blade_1_p_interact;
char* mask_string = mccinter_analyzer_colimator_18_blade_1_mask_string;
char* mask_setting = mccinter_analyzer_colimator_18_blade_1_mask_setting;
MCNUM number_of_activations = mccinter_analyzer_colimator_18_blade_1_number_of_activations;
}   /* End of inter_analyzer_colimator_18_blade_1=Union_box() SETTING parameter declarations. */
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex
  /* Label for restoring  neutron */
  mcabsorbCompinter_analyzer_colimator_18_blade_1:
  if (RESTORE) /* restore if needed */
  { RESTORE_NEUTRON(840,
      mcnlx,
      mcnly,
      mcnlz,
      mcnlvx,
      mcnlvy,
      mcnlvz,
      mcnlt,
      mcnlsx,
      mcnlsy,
      mcnlsz,
      mcnlp); }
#undef mcabsorbComp
#undef p
#undef sz
#undef sy
#undef sx
#undef t
#undef vz
#undef vy
#undef vx
#undef z
#undef y
#undef x
  mcDEBUG_STATE(
mcnlx,
mcnly,
mcnlz,
mcnlvx,
mcnlvy,
mcnlvz,
mcnlt,
mcnlsx,
mcnlsy,
mcnlsz,
mcnlp)

  /* TRACE Component inter_analyzer_colimator_18_blade_2 [841] */
  mccoordschange(mcposrinter_analyzer_colimator_18_blade_2, mcrotrinter_analyzer_colimator_18_blade_2,
    &mcnlx,
    &mcnly,
    &mcnlz,
    &mcnlvx,
    &mcnlvy,
    &mcnlvz,
    &mcnlsx,
    &mcnlsy,
    &mcnlsz);
  /* define label inside component inter_analyzer_colimator_18_blade_2 (without coords transformations) */
  mcJumpTrace_inter_analyzer_colimator_18_blade_2:
  SIG_MESSAGE("inter_analyzer_colimator_18_blade_2 (Trace)");
  mcDEBUG_COMP("inter_analyzer_colimator_18_blade_2")
  mcDEBUG_STATE(
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp)
#define x mcnlx
#define y mcnly
#define z mcnlz
#define vx mcnlvx
#define vy mcnlvy
#define vz mcnlvz
#define t mcnlt
#define sx mcnlsx
#define sy mcnlsy
#define sz mcnlsz
#define p mcnlp

#define mcabsorbComp mcabsorbCompinter_analyzer_colimator_18_blade_2
  STORE_NEUTRON(841,
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp);
  mcScattered=0;
  mcRestore=0;
  mcNCounter[841]++;
  mcPCounter[841] += p;
  mcP2Counter[841] += p*p;
#define mccompcurname  inter_analyzer_colimator_18_blade_2
#define mccompcurtype  Union_box
#define mccompcurindex 841
#define loop_index mccinter_analyzer_colimator_18_blade_2_loop_index
#define this_box_volume mccinter_analyzer_colimator_18_blade_2_this_box_volume
#define global_geometry_element mccinter_analyzer_colimator_18_blade_2_global_geometry_element
#define this_box_storage mccinter_analyzer_colimator_18_blade_2_this_box_storage
{   /* Declarations of inter_analyzer_colimator_18_blade_2=Union_box() SETTING parameters. */
char* material_string = mccinter_analyzer_colimator_18_blade_2_material_string;
MCNUM priority = mccinter_analyzer_colimator_18_blade_2_priority;
MCNUM xwidth = mccinter_analyzer_colimator_18_blade_2_xwidth;
MCNUM yheight = mccinter_analyzer_colimator_18_blade_2_yheight;
MCNUM zdepth = mccinter_analyzer_colimator_18_blade_2_zdepth;
MCNUM xwidth2 = mccinter_analyzer_colimator_18_blade_2_xwidth2;
MCNUM yheight2 = mccinter_analyzer_colimator_18_blade_2_yheight2;
MCNUM visualize = mccinter_analyzer_colimator_18_blade_2_visualize;
int target_index = mccinter_analyzer_colimator_18_blade_2_target_index;
MCNUM target_x = mccinter_analyzer_colimator_18_blade_2_target_x;
MCNUM target_y = mccinter_analyzer_colimator_18_blade_2_target_y;
MCNUM target_z = mccinter_analyzer_colimator_18_blade_2_target_z;
MCNUM focus_aw = mccinter_analyzer_colimator_18_blade_2_focus_aw;
MCNUM focus_ah = mccinter_analyzer_colimator_18_blade_2_focus_ah;
MCNUM focus_xw = mccinter_analyzer_colimator_18_blade_2_focus_xw;
MCNUM focus_xh = mccinter_analyzer_colimator_18_blade_2_focus_xh;
MCNUM focus_r = mccinter_analyzer_colimator_18_blade_2_focus_r;
MCNUM p_interact = mccinter_analyzer_colimator_18_blade_2_p_interact;
char* mask_string = mccinter_analyzer_colimator_18_blade_2_mask_string;
char* mask_setting = mccinter_analyzer_colimator_18_blade_2_mask_setting;
MCNUM number_of_activations = mccinter_analyzer_colimator_18_blade_2_number_of_activations;
}   /* End of inter_analyzer_colimator_18_blade_2=Union_box() SETTING parameter declarations. */
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex
  /* Label for restoring  neutron */
  mcabsorbCompinter_analyzer_colimator_18_blade_2:
  if (RESTORE) /* restore if needed */
  { RESTORE_NEUTRON(841,
      mcnlx,
      mcnly,
      mcnlz,
      mcnlvx,
      mcnlvy,
      mcnlvz,
      mcnlt,
      mcnlsx,
      mcnlsy,
      mcnlsz,
      mcnlp); }
#undef mcabsorbComp
#undef p
#undef sz
#undef sy
#undef sx
#undef t
#undef vz
#undef vy
#undef vx
#undef z
#undef y
#undef x
  mcDEBUG_STATE(
mcnlx,
mcnly,
mcnlz,
mcnlvx,
mcnlvy,
mcnlvz,
mcnlt,
mcnlsx,
mcnlsy,
mcnlsz,
mcnlp)

  /* TRACE Component inter_analyzer_colimator_18_blade_3 [842] */
  mccoordschange(mcposrinter_analyzer_colimator_18_blade_3, mcrotrinter_analyzer_colimator_18_blade_3,
    &mcnlx,
    &mcnly,
    &mcnlz,
    &mcnlvx,
    &mcnlvy,
    &mcnlvz,
    &mcnlsx,
    &mcnlsy,
    &mcnlsz);
  /* define label inside component inter_analyzer_colimator_18_blade_3 (without coords transformations) */
  mcJumpTrace_inter_analyzer_colimator_18_blade_3:
  SIG_MESSAGE("inter_analyzer_colimator_18_blade_3 (Trace)");
  mcDEBUG_COMP("inter_analyzer_colimator_18_blade_3")
  mcDEBUG_STATE(
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp)
#define x mcnlx
#define y mcnly
#define z mcnlz
#define vx mcnlvx
#define vy mcnlvy
#define vz mcnlvz
#define t mcnlt
#define sx mcnlsx
#define sy mcnlsy
#define sz mcnlsz
#define p mcnlp

#define mcabsorbComp mcabsorbCompinter_analyzer_colimator_18_blade_3
  STORE_NEUTRON(842,
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp);
  mcScattered=0;
  mcRestore=0;
  mcNCounter[842]++;
  mcPCounter[842] += p;
  mcP2Counter[842] += p*p;
#define mccompcurname  inter_analyzer_colimator_18_blade_3
#define mccompcurtype  Union_box
#define mccompcurindex 842
#define loop_index mccinter_analyzer_colimator_18_blade_3_loop_index
#define this_box_volume mccinter_analyzer_colimator_18_blade_3_this_box_volume
#define global_geometry_element mccinter_analyzer_colimator_18_blade_3_global_geometry_element
#define this_box_storage mccinter_analyzer_colimator_18_blade_3_this_box_storage
{   /* Declarations of inter_analyzer_colimator_18_blade_3=Union_box() SETTING parameters. */
char* material_string = mccinter_analyzer_colimator_18_blade_3_material_string;
MCNUM priority = mccinter_analyzer_colimator_18_blade_3_priority;
MCNUM xwidth = mccinter_analyzer_colimator_18_blade_3_xwidth;
MCNUM yheight = mccinter_analyzer_colimator_18_blade_3_yheight;
MCNUM zdepth = mccinter_analyzer_colimator_18_blade_3_zdepth;
MCNUM xwidth2 = mccinter_analyzer_colimator_18_blade_3_xwidth2;
MCNUM yheight2 = mccinter_analyzer_colimator_18_blade_3_yheight2;
MCNUM visualize = mccinter_analyzer_colimator_18_blade_3_visualize;
int target_index = mccinter_analyzer_colimator_18_blade_3_target_index;
MCNUM target_x = mccinter_analyzer_colimator_18_blade_3_target_x;
MCNUM target_y = mccinter_analyzer_colimator_18_blade_3_target_y;
MCNUM target_z = mccinter_analyzer_colimator_18_blade_3_target_z;
MCNUM focus_aw = mccinter_analyzer_colimator_18_blade_3_focus_aw;
MCNUM focus_ah = mccinter_analyzer_colimator_18_blade_3_focus_ah;
MCNUM focus_xw = mccinter_analyzer_colimator_18_blade_3_focus_xw;
MCNUM focus_xh = mccinter_analyzer_colimator_18_blade_3_focus_xh;
MCNUM focus_r = mccinter_analyzer_colimator_18_blade_3_focus_r;
MCNUM p_interact = mccinter_analyzer_colimator_18_blade_3_p_interact;
char* mask_string = mccinter_analyzer_colimator_18_blade_3_mask_string;
char* mask_setting = mccinter_analyzer_colimator_18_blade_3_mask_setting;
MCNUM number_of_activations = mccinter_analyzer_colimator_18_blade_3_number_of_activations;
}   /* End of inter_analyzer_colimator_18_blade_3=Union_box() SETTING parameter declarations. */
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex
  /* Label for restoring  neutron */
  mcabsorbCompinter_analyzer_colimator_18_blade_3:
  if (RESTORE) /* restore if needed */
  { RESTORE_NEUTRON(842,
      mcnlx,
      mcnly,
      mcnlz,
      mcnlvx,
      mcnlvy,
      mcnlvz,
      mcnlt,
      mcnlsx,
      mcnlsy,
      mcnlsz,
      mcnlp); }
#undef mcabsorbComp
#undef p
#undef sz
#undef sy
#undef sx
#undef t
#undef vz
#undef vy
#undef vx
#undef z
#undef y
#undef x
  mcDEBUG_STATE(
mcnlx,
mcnly,
mcnlz,
mcnlvx,
mcnlvy,
mcnlvz,
mcnlt,
mcnlsx,
mcnlsy,
mcnlsz,
mcnlp)

  /* TRACE Component inter_analyzer_colimator_18_blade_4 [843] */
  mccoordschange(mcposrinter_analyzer_colimator_18_blade_4, mcrotrinter_analyzer_colimator_18_blade_4,
    &mcnlx,
    &mcnly,
    &mcnlz,
    &mcnlvx,
    &mcnlvy,
    &mcnlvz,
    &mcnlsx,
    &mcnlsy,
    &mcnlsz);
  /* define label inside component inter_analyzer_colimator_18_blade_4 (without coords transformations) */
  mcJumpTrace_inter_analyzer_colimator_18_blade_4:
  SIG_MESSAGE("inter_analyzer_colimator_18_blade_4 (Trace)");
  mcDEBUG_COMP("inter_analyzer_colimator_18_blade_4")
  mcDEBUG_STATE(
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp)
#define x mcnlx
#define y mcnly
#define z mcnlz
#define vx mcnlvx
#define vy mcnlvy
#define vz mcnlvz
#define t mcnlt
#define sx mcnlsx
#define sy mcnlsy
#define sz mcnlsz
#define p mcnlp

#define mcabsorbComp mcabsorbCompinter_analyzer_colimator_18_blade_4
  STORE_NEUTRON(843,
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp);
  mcScattered=0;
  mcRestore=0;
  mcNCounter[843]++;
  mcPCounter[843] += p;
  mcP2Counter[843] += p*p;
#define mccompcurname  inter_analyzer_colimator_18_blade_4
#define mccompcurtype  Union_box
#define mccompcurindex 843
#define loop_index mccinter_analyzer_colimator_18_blade_4_loop_index
#define this_box_volume mccinter_analyzer_colimator_18_blade_4_this_box_volume
#define global_geometry_element mccinter_analyzer_colimator_18_blade_4_global_geometry_element
#define this_box_storage mccinter_analyzer_colimator_18_blade_4_this_box_storage
{   /* Declarations of inter_analyzer_colimator_18_blade_4=Union_box() SETTING parameters. */
char* material_string = mccinter_analyzer_colimator_18_blade_4_material_string;
MCNUM priority = mccinter_analyzer_colimator_18_blade_4_priority;
MCNUM xwidth = mccinter_analyzer_colimator_18_blade_4_xwidth;
MCNUM yheight = mccinter_analyzer_colimator_18_blade_4_yheight;
MCNUM zdepth = mccinter_analyzer_colimator_18_blade_4_zdepth;
MCNUM xwidth2 = mccinter_analyzer_colimator_18_blade_4_xwidth2;
MCNUM yheight2 = mccinter_analyzer_colimator_18_blade_4_yheight2;
MCNUM visualize = mccinter_analyzer_colimator_18_blade_4_visualize;
int target_index = mccinter_analyzer_colimator_18_blade_4_target_index;
MCNUM target_x = mccinter_analyzer_colimator_18_blade_4_target_x;
MCNUM target_y = mccinter_analyzer_colimator_18_blade_4_target_y;
MCNUM target_z = mccinter_analyzer_colimator_18_blade_4_target_z;
MCNUM focus_aw = mccinter_analyzer_colimator_18_blade_4_focus_aw;
MCNUM focus_ah = mccinter_analyzer_colimator_18_blade_4_focus_ah;
MCNUM focus_xw = mccinter_analyzer_colimator_18_blade_4_focus_xw;
MCNUM focus_xh = mccinter_analyzer_colimator_18_blade_4_focus_xh;
MCNUM focus_r = mccinter_analyzer_colimator_18_blade_4_focus_r;
MCNUM p_interact = mccinter_analyzer_colimator_18_blade_4_p_interact;
char* mask_string = mccinter_analyzer_colimator_18_blade_4_mask_string;
char* mask_setting = mccinter_analyzer_colimator_18_blade_4_mask_setting;
MCNUM number_of_activations = mccinter_analyzer_colimator_18_blade_4_number_of_activations;
}   /* End of inter_analyzer_colimator_18_blade_4=Union_box() SETTING parameter declarations. */
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex
  /* Label for restoring  neutron */
  mcabsorbCompinter_analyzer_colimator_18_blade_4:
  if (RESTORE) /* restore if needed */
  { RESTORE_NEUTRON(843,
      mcnlx,
      mcnly,
      mcnlz,
      mcnlvx,
      mcnlvy,
      mcnlvz,
      mcnlt,
      mcnlsx,
      mcnlsy,
      mcnlsz,
      mcnlp); }
#undef mcabsorbComp
#undef p
#undef sz
#undef sy
#undef sx
#undef t
#undef vz
#undef vy
#undef vx
#undef z
#undef y
#undef x
  mcDEBUG_STATE(
mcnlx,
mcnly,
mcnlz,
mcnlvx,
mcnlvy,
mcnlvz,
mcnlt,
mcnlsx,
mcnlsy,
mcnlsz,
mcnlp)

  /* TRACE Component diffraction_detector_18_exit_volume [844] */
  mccoordschange(mcposrdiffraction_detector_18_exit_volume, mcrotrdiffraction_detector_18_exit_volume,
    &mcnlx,
    &mcnly,
    &mcnlz,
    &mcnlvx,
    &mcnlvy,
    &mcnlvz,
    &mcnlsx,
    &mcnlsy,
    &mcnlsz);
  /* define label inside component diffraction_detector_18_exit_volume (without coords transformations) */
  mcJumpTrace_diffraction_detector_18_exit_volume:
  SIG_MESSAGE("diffraction_detector_18_exit_volume (Trace)");
  mcDEBUG_COMP("diffraction_detector_18_exit_volume")
  mcDEBUG_STATE(
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp)
#define x mcnlx
#define y mcnly
#define z mcnlz
#define vx mcnlvx
#define vy mcnlvy
#define vz mcnlvz
#define t mcnlt
#define sx mcnlsx
#define sy mcnlsy
#define sz mcnlsz
#define p mcnlp

#define mcabsorbComp mcabsorbCompdiffraction_detector_18_exit_volume
  STORE_NEUTRON(844,
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp);
  mcScattered=0;
  mcRestore=0;
  mcNCounter[844]++;
  mcPCounter[844] += p;
  mcP2Counter[844] += p*p;
#define mccompcurname  diffraction_detector_18_exit_volume
#define mccompcurtype  Union_box
#define mccompcurindex 844
#define loop_index mccdiffraction_detector_18_exit_volume_loop_index
#define this_box_volume mccdiffraction_detector_18_exit_volume_this_box_volume
#define global_geometry_element mccdiffraction_detector_18_exit_volume_global_geometry_element
#define this_box_storage mccdiffraction_detector_18_exit_volume_this_box_storage
{   /* Declarations of diffraction_detector_18_exit_volume=Union_box() SETTING parameters. */
char* material_string = mccdiffraction_detector_18_exit_volume_material_string;
MCNUM priority = mccdiffraction_detector_18_exit_volume_priority;
MCNUM xwidth = mccdiffraction_detector_18_exit_volume_xwidth;
MCNUM yheight = mccdiffraction_detector_18_exit_volume_yheight;
MCNUM zdepth = mccdiffraction_detector_18_exit_volume_zdepth;
MCNUM xwidth2 = mccdiffraction_detector_18_exit_volume_xwidth2;
MCNUM yheight2 = mccdiffraction_detector_18_exit_volume_yheight2;
MCNUM visualize = mccdiffraction_detector_18_exit_volume_visualize;
int target_index = mccdiffraction_detector_18_exit_volume_target_index;
MCNUM target_x = mccdiffraction_detector_18_exit_volume_target_x;
MCNUM target_y = mccdiffraction_detector_18_exit_volume_target_y;
MCNUM target_z = mccdiffraction_detector_18_exit_volume_target_z;
MCNUM focus_aw = mccdiffraction_detector_18_exit_volume_focus_aw;
MCNUM focus_ah = mccdiffraction_detector_18_exit_volume_focus_ah;
MCNUM focus_xw = mccdiffraction_detector_18_exit_volume_focus_xw;
MCNUM focus_xh = mccdiffraction_detector_18_exit_volume_focus_xh;
MCNUM focus_r = mccdiffraction_detector_18_exit_volume_focus_r;
MCNUM p_interact = mccdiffraction_detector_18_exit_volume_p_interact;
char* mask_string = mccdiffraction_detector_18_exit_volume_mask_string;
char* mask_setting = mccdiffraction_detector_18_exit_volume_mask_setting;
MCNUM number_of_activations = mccdiffraction_detector_18_exit_volume_number_of_activations;
}   /* End of diffraction_detector_18_exit_volume=Union_box() SETTING parameter declarations. */
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex
  /* Label for restoring  neutron */
  mcabsorbCompdiffraction_detector_18_exit_volume:
  if (RESTORE) /* restore if needed */
  { RESTORE_NEUTRON(844,
      mcnlx,
      mcnly,
      mcnlz,
      mcnlvx,
      mcnlvy,
      mcnlvz,
      mcnlt,
      mcnlsx,
      mcnlsy,
      mcnlsz,
      mcnlp); }
#undef mcabsorbComp
#undef p
#undef sz
#undef sy
#undef sx
#undef t
#undef vz
#undef vy
#undef vx
#undef z
#undef y
#undef x
  mcDEBUG_STATE(
mcnlx,
mcnly,
mcnlz,
mcnlvx,
mcnlvy,
mcnlvz,
mcnlt,
mcnlsx,
mcnlsy,
mcnlsz,
mcnlp)

  /* TRACE Component spec_detector_18_exit_volume [845] */
  mccoordschange(mcposrspec_detector_18_exit_volume, mcrotrspec_detector_18_exit_volume,
    &mcnlx,
    &mcnly,
    &mcnlz,
    &mcnlvx,
    &mcnlvy,
    &mcnlvz,
    &mcnlsx,
    &mcnlsy,
    &mcnlsz);
  /* define label inside component spec_detector_18_exit_volume (without coords transformations) */
  mcJumpTrace_spec_detector_18_exit_volume:
  SIG_MESSAGE("spec_detector_18_exit_volume (Trace)");
  mcDEBUG_COMP("spec_detector_18_exit_volume")
  mcDEBUG_STATE(
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp)
#define x mcnlx
#define y mcnly
#define z mcnlz
#define vx mcnlvx
#define vy mcnlvy
#define vz mcnlvz
#define t mcnlt
#define sx mcnlsx
#define sy mcnlsy
#define sz mcnlsz
#define p mcnlp

#define mcabsorbComp mcabsorbCompspec_detector_18_exit_volume
  STORE_NEUTRON(845,
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp);
  mcScattered=0;
  mcRestore=0;
  mcNCounter[845]++;
  mcPCounter[845] += p;
  mcP2Counter[845] += p*p;
#define mccompcurname  spec_detector_18_exit_volume
#define mccompcurtype  Union_box
#define mccompcurindex 845
#define loop_index mccspec_detector_18_exit_volume_loop_index
#define this_box_volume mccspec_detector_18_exit_volume_this_box_volume
#define global_geometry_element mccspec_detector_18_exit_volume_global_geometry_element
#define this_box_storage mccspec_detector_18_exit_volume_this_box_storage
{   /* Declarations of spec_detector_18_exit_volume=Union_box() SETTING parameters. */
char* material_string = mccspec_detector_18_exit_volume_material_string;
MCNUM priority = mccspec_detector_18_exit_volume_priority;
MCNUM xwidth = mccspec_detector_18_exit_volume_xwidth;
MCNUM yheight = mccspec_detector_18_exit_volume_yheight;
MCNUM zdepth = mccspec_detector_18_exit_volume_zdepth;
MCNUM xwidth2 = mccspec_detector_18_exit_volume_xwidth2;
MCNUM yheight2 = mccspec_detector_18_exit_volume_yheight2;
MCNUM visualize = mccspec_detector_18_exit_volume_visualize;
int target_index = mccspec_detector_18_exit_volume_target_index;
MCNUM target_x = mccspec_detector_18_exit_volume_target_x;
MCNUM target_y = mccspec_detector_18_exit_volume_target_y;
MCNUM target_z = mccspec_detector_18_exit_volume_target_z;
MCNUM focus_aw = mccspec_detector_18_exit_volume_focus_aw;
MCNUM focus_ah = mccspec_detector_18_exit_volume_focus_ah;
MCNUM focus_xw = mccspec_detector_18_exit_volume_focus_xw;
MCNUM focus_xh = mccspec_detector_18_exit_volume_focus_xh;
MCNUM focus_r = mccspec_detector_18_exit_volume_focus_r;
MCNUM p_interact = mccspec_detector_18_exit_volume_p_interact;
char* mask_string = mccspec_detector_18_exit_volume_mask_string;
char* mask_setting = mccspec_detector_18_exit_volume_mask_setting;
MCNUM number_of_activations = mccspec_detector_18_exit_volume_number_of_activations;
}   /* End of spec_detector_18_exit_volume=Union_box() SETTING parameter declarations. */
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex
  /* Label for restoring  neutron */
  mcabsorbCompspec_detector_18_exit_volume:
  if (RESTORE) /* restore if needed */
  { RESTORE_NEUTRON(845,
      mcnlx,
      mcnly,
      mcnlz,
      mcnlvx,
      mcnlvy,
      mcnlvz,
      mcnlt,
      mcnlsx,
      mcnlsy,
      mcnlsz,
      mcnlp); }
#undef mcabsorbComp
#undef p
#undef sz
#undef sy
#undef sx
#undef t
#undef vz
#undef vy
#undef vx
#undef z
#undef y
#undef x
  mcDEBUG_STATE(
mcnlx,
mcnly,
mcnlz,
mcnlvx,
mcnlvy,
mcnlvz,
mcnlt,
mcnlsx,
mcnlsy,
mcnlsz,
mcnlp)

  /* TRACE Component channel_19_cave1_box1 [846] */
  mccoordschange(mcposrchannel_19_cave1_box1, mcrotrchannel_19_cave1_box1,
    &mcnlx,
    &mcnly,
    &mcnlz,
    &mcnlvx,
    &mcnlvy,
    &mcnlvz,
    &mcnlsx,
    &mcnlsy,
    &mcnlsz);
  /* define label inside component channel_19_cave1_box1 (without coords transformations) */
  mcJumpTrace_channel_19_cave1_box1:
  SIG_MESSAGE("channel_19_cave1_box1 (Trace)");
  mcDEBUG_COMP("channel_19_cave1_box1")
  mcDEBUG_STATE(
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp)
#define x mcnlx
#define y mcnly
#define z mcnlz
#define vx mcnlvx
#define vy mcnlvy
#define vz mcnlvz
#define t mcnlt
#define sx mcnlsx
#define sy mcnlsy
#define sz mcnlsz
#define p mcnlp

#define mcabsorbComp mcabsorbCompchannel_19_cave1_box1
  STORE_NEUTRON(846,
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp);
  mcScattered=0;
  mcRestore=0;
  mcNCounter[846]++;
  mcPCounter[846] += p;
  mcP2Counter[846] += p*p;
#define mccompcurname  channel_19_cave1_box1
#define mccompcurtype  Union_box
#define mccompcurindex 846
#define loop_index mccchannel_19_cave1_box1_loop_index
#define this_box_volume mccchannel_19_cave1_box1_this_box_volume
#define global_geometry_element mccchannel_19_cave1_box1_global_geometry_element
#define this_box_storage mccchannel_19_cave1_box1_this_box_storage
{   /* Declarations of channel_19_cave1_box1=Union_box() SETTING parameters. */
char* material_string = mccchannel_19_cave1_box1_material_string;
MCNUM priority = mccchannel_19_cave1_box1_priority;
MCNUM xwidth = mccchannel_19_cave1_box1_xwidth;
MCNUM yheight = mccchannel_19_cave1_box1_yheight;
MCNUM zdepth = mccchannel_19_cave1_box1_zdepth;
MCNUM xwidth2 = mccchannel_19_cave1_box1_xwidth2;
MCNUM yheight2 = mccchannel_19_cave1_box1_yheight2;
MCNUM visualize = mccchannel_19_cave1_box1_visualize;
int target_index = mccchannel_19_cave1_box1_target_index;
MCNUM target_x = mccchannel_19_cave1_box1_target_x;
MCNUM target_y = mccchannel_19_cave1_box1_target_y;
MCNUM target_z = mccchannel_19_cave1_box1_target_z;
MCNUM focus_aw = mccchannel_19_cave1_box1_focus_aw;
MCNUM focus_ah = mccchannel_19_cave1_box1_focus_ah;
MCNUM focus_xw = mccchannel_19_cave1_box1_focus_xw;
MCNUM focus_xh = mccchannel_19_cave1_box1_focus_xh;
MCNUM focus_r = mccchannel_19_cave1_box1_focus_r;
MCNUM p_interact = mccchannel_19_cave1_box1_p_interact;
char* mask_string = mccchannel_19_cave1_box1_mask_string;
char* mask_setting = mccchannel_19_cave1_box1_mask_setting;
MCNUM number_of_activations = mccchannel_19_cave1_box1_number_of_activations;
}   /* End of channel_19_cave1_box1=Union_box() SETTING parameter declarations. */
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex
  /* Label for restoring  neutron */
  mcabsorbCompchannel_19_cave1_box1:
  if (RESTORE) /* restore if needed */
  { RESTORE_NEUTRON(846,
      mcnlx,
      mcnly,
      mcnlz,
      mcnlvx,
      mcnlvy,
      mcnlvz,
      mcnlt,
      mcnlsx,
      mcnlsy,
      mcnlsz,
      mcnlp); }
#undef mcabsorbComp
#undef p
#undef sz
#undef sy
#undef sx
#undef t
#undef vz
#undef vy
#undef vx
#undef z
#undef y
#undef x
  mcDEBUG_STATE(
mcnlx,
mcnly,
mcnlz,
mcnlvx,
mcnlvy,
mcnlvz,
mcnlt,
mcnlsx,
mcnlsy,
mcnlsz,
mcnlp)

  /* TRACE Component channel_19_cave1_box2 [847] */
  mccoordschange(mcposrchannel_19_cave1_box2, mcrotrchannel_19_cave1_box2,
    &mcnlx,
    &mcnly,
    &mcnlz,
    &mcnlvx,
    &mcnlvy,
    &mcnlvz,
    &mcnlsx,
    &mcnlsy,
    &mcnlsz);
  /* define label inside component channel_19_cave1_box2 (without coords transformations) */
  mcJumpTrace_channel_19_cave1_box2:
  SIG_MESSAGE("channel_19_cave1_box2 (Trace)");
  mcDEBUG_COMP("channel_19_cave1_box2")
  mcDEBUG_STATE(
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp)
#define x mcnlx
#define y mcnly
#define z mcnlz
#define vx mcnlvx
#define vy mcnlvy
#define vz mcnlvz
#define t mcnlt
#define sx mcnlsx
#define sy mcnlsy
#define sz mcnlsz
#define p mcnlp

#define mcabsorbComp mcabsorbCompchannel_19_cave1_box2
  STORE_NEUTRON(847,
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp);
  mcScattered=0;
  mcRestore=0;
  mcNCounter[847]++;
  mcPCounter[847] += p;
  mcP2Counter[847] += p*p;
#define mccompcurname  channel_19_cave1_box2
#define mccompcurtype  Union_box
#define mccompcurindex 847
#define loop_index mccchannel_19_cave1_box2_loop_index
#define this_box_volume mccchannel_19_cave1_box2_this_box_volume
#define global_geometry_element mccchannel_19_cave1_box2_global_geometry_element
#define this_box_storage mccchannel_19_cave1_box2_this_box_storage
{   /* Declarations of channel_19_cave1_box2=Union_box() SETTING parameters. */
char* material_string = mccchannel_19_cave1_box2_material_string;
MCNUM priority = mccchannel_19_cave1_box2_priority;
MCNUM xwidth = mccchannel_19_cave1_box2_xwidth;
MCNUM yheight = mccchannel_19_cave1_box2_yheight;
MCNUM zdepth = mccchannel_19_cave1_box2_zdepth;
MCNUM xwidth2 = mccchannel_19_cave1_box2_xwidth2;
MCNUM yheight2 = mccchannel_19_cave1_box2_yheight2;
MCNUM visualize = mccchannel_19_cave1_box2_visualize;
int target_index = mccchannel_19_cave1_box2_target_index;
MCNUM target_x = mccchannel_19_cave1_box2_target_x;
MCNUM target_y = mccchannel_19_cave1_box2_target_y;
MCNUM target_z = mccchannel_19_cave1_box2_target_z;
MCNUM focus_aw = mccchannel_19_cave1_box2_focus_aw;
MCNUM focus_ah = mccchannel_19_cave1_box2_focus_ah;
MCNUM focus_xw = mccchannel_19_cave1_box2_focus_xw;
MCNUM focus_xh = mccchannel_19_cave1_box2_focus_xh;
MCNUM focus_r = mccchannel_19_cave1_box2_focus_r;
MCNUM p_interact = mccchannel_19_cave1_box2_p_interact;
char* mask_string = mccchannel_19_cave1_box2_mask_string;
char* mask_setting = mccchannel_19_cave1_box2_mask_setting;
MCNUM number_of_activations = mccchannel_19_cave1_box2_number_of_activations;
}   /* End of channel_19_cave1_box2=Union_box() SETTING parameter declarations. */
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex
  /* Label for restoring  neutron */
  mcabsorbCompchannel_19_cave1_box2:
  if (RESTORE) /* restore if needed */
  { RESTORE_NEUTRON(847,
      mcnlx,
      mcnly,
      mcnlz,
      mcnlvx,
      mcnlvy,
      mcnlvz,
      mcnlt,
      mcnlsx,
      mcnlsy,
      mcnlsz,
      mcnlp); }
#undef mcabsorbComp
#undef p
#undef sz
#undef sy
#undef sx
#undef t
#undef vz
#undef vy
#undef vx
#undef z
#undef y
#undef x
  mcDEBUG_STATE(
mcnlx,
mcnly,
mcnlz,
mcnlvx,
mcnlvy,
mcnlvz,
mcnlt,
mcnlsx,
mcnlsy,
mcnlsz,
mcnlp)

  /* TRACE Component channel_19_cave1_box3 [848] */
  mccoordschange(mcposrchannel_19_cave1_box3, mcrotrchannel_19_cave1_box3,
    &mcnlx,
    &mcnly,
    &mcnlz,
    &mcnlvx,
    &mcnlvy,
    &mcnlvz,
    &mcnlsx,
    &mcnlsy,
    &mcnlsz);
  /* define label inside component channel_19_cave1_box3 (without coords transformations) */
  mcJumpTrace_channel_19_cave1_box3:
  SIG_MESSAGE("channel_19_cave1_box3 (Trace)");
  mcDEBUG_COMP("channel_19_cave1_box3")
  mcDEBUG_STATE(
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp)
#define x mcnlx
#define y mcnly
#define z mcnlz
#define vx mcnlvx
#define vy mcnlvy
#define vz mcnlvz
#define t mcnlt
#define sx mcnlsx
#define sy mcnlsy
#define sz mcnlsz
#define p mcnlp

#define mcabsorbComp mcabsorbCompchannel_19_cave1_box3
  STORE_NEUTRON(848,
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp);
  mcScattered=0;
  mcRestore=0;
  mcNCounter[848]++;
  mcPCounter[848] += p;
  mcP2Counter[848] += p*p;
#define mccompcurname  channel_19_cave1_box3
#define mccompcurtype  Union_box
#define mccompcurindex 848
#define loop_index mccchannel_19_cave1_box3_loop_index
#define this_box_volume mccchannel_19_cave1_box3_this_box_volume
#define global_geometry_element mccchannel_19_cave1_box3_global_geometry_element
#define this_box_storage mccchannel_19_cave1_box3_this_box_storage
{   /* Declarations of channel_19_cave1_box3=Union_box() SETTING parameters. */
char* material_string = mccchannel_19_cave1_box3_material_string;
MCNUM priority = mccchannel_19_cave1_box3_priority;
MCNUM xwidth = mccchannel_19_cave1_box3_xwidth;
MCNUM yheight = mccchannel_19_cave1_box3_yheight;
MCNUM zdepth = mccchannel_19_cave1_box3_zdepth;
MCNUM xwidth2 = mccchannel_19_cave1_box3_xwidth2;
MCNUM yheight2 = mccchannel_19_cave1_box3_yheight2;
MCNUM visualize = mccchannel_19_cave1_box3_visualize;
int target_index = mccchannel_19_cave1_box3_target_index;
MCNUM target_x = mccchannel_19_cave1_box3_target_x;
MCNUM target_y = mccchannel_19_cave1_box3_target_y;
MCNUM target_z = mccchannel_19_cave1_box3_target_z;
MCNUM focus_aw = mccchannel_19_cave1_box3_focus_aw;
MCNUM focus_ah = mccchannel_19_cave1_box3_focus_ah;
MCNUM focus_xw = mccchannel_19_cave1_box3_focus_xw;
MCNUM focus_xh = mccchannel_19_cave1_box3_focus_xh;
MCNUM focus_r = mccchannel_19_cave1_box3_focus_r;
MCNUM p_interact = mccchannel_19_cave1_box3_p_interact;
char* mask_string = mccchannel_19_cave1_box3_mask_string;
char* mask_setting = mccchannel_19_cave1_box3_mask_setting;
MCNUM number_of_activations = mccchannel_19_cave1_box3_number_of_activations;
}   /* End of channel_19_cave1_box3=Union_box() SETTING parameter declarations. */
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex
  /* Label for restoring  neutron */
  mcabsorbCompchannel_19_cave1_box3:
  if (RESTORE) /* restore if needed */
  { RESTORE_NEUTRON(848,
      mcnlx,
      mcnly,
      mcnlz,
      mcnlvx,
      mcnlvy,
      mcnlvz,
      mcnlt,
      mcnlsx,
      mcnlsy,
      mcnlsz,
      mcnlp); }
#undef mcabsorbComp
#undef p
#undef sz
#undef sy
#undef sx
#undef t
#undef vz
#undef vy
#undef vx
#undef z
#undef y
#undef x
  mcDEBUG_STATE(
mcnlx,
mcnly,
mcnlz,
mcnlvx,
mcnlvy,
mcnlvz,
mcnlt,
mcnlsx,
mcnlsy,
mcnlsz,
mcnlp)

  /* TRACE Component channel_19_cave1_cyl1 [849] */
  mccoordschange(mcposrchannel_19_cave1_cyl1, mcrotrchannel_19_cave1_cyl1,
    &mcnlx,
    &mcnly,
    &mcnlz,
    &mcnlvx,
    &mcnlvy,
    &mcnlvz,
    &mcnlsx,
    &mcnlsy,
    &mcnlsz);
  /* define label inside component channel_19_cave1_cyl1 (without coords transformations) */
  mcJumpTrace_channel_19_cave1_cyl1:
  SIG_MESSAGE("channel_19_cave1_cyl1 (Trace)");
  mcDEBUG_COMP("channel_19_cave1_cyl1")
  mcDEBUG_STATE(
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp)
#define x mcnlx
#define y mcnly
#define z mcnlz
#define vx mcnlvx
#define vy mcnlvy
#define vz mcnlvz
#define t mcnlt
#define sx mcnlsx
#define sy mcnlsy
#define sz mcnlsz
#define p mcnlp

#define mcabsorbComp mcabsorbCompchannel_19_cave1_cyl1
  STORE_NEUTRON(849,
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp);
  mcScattered=0;
  mcRestore=0;
  mcNCounter[849]++;
  mcPCounter[849] += p;
  mcP2Counter[849] += p*p;
#define mccompcurname  channel_19_cave1_cyl1
#define mccompcurtype  Union_cylinder
#define mccompcurindex 849
#define loop_index mccchannel_19_cave1_cyl1_loop_index
#define this_cylinder_volume mccchannel_19_cave1_cyl1_this_cylinder_volume
#define global_geometry_element mccchannel_19_cave1_cyl1_global_geometry_element
#define this_cylinder_storage mccchannel_19_cave1_cyl1_this_cylinder_storage
{   /* Declarations of channel_19_cave1_cyl1=Union_cylinder() SETTING parameters. */
char* material_string = mccchannel_19_cave1_cyl1_material_string;
MCNUM priority = mccchannel_19_cave1_cyl1_priority;
MCNUM radius = mccchannel_19_cave1_cyl1_radius;
MCNUM yheight = mccchannel_19_cave1_cyl1_yheight;
MCNUM visualize = mccchannel_19_cave1_cyl1_visualize;
int target_index = mccchannel_19_cave1_cyl1_target_index;
MCNUM target_x = mccchannel_19_cave1_cyl1_target_x;
MCNUM target_y = mccchannel_19_cave1_cyl1_target_y;
MCNUM target_z = mccchannel_19_cave1_cyl1_target_z;
MCNUM focus_aw = mccchannel_19_cave1_cyl1_focus_aw;
MCNUM focus_ah = mccchannel_19_cave1_cyl1_focus_ah;
MCNUM focus_xw = mccchannel_19_cave1_cyl1_focus_xw;
MCNUM focus_xh = mccchannel_19_cave1_cyl1_focus_xh;
MCNUM focus_r = mccchannel_19_cave1_cyl1_focus_r;
MCNUM p_interact = mccchannel_19_cave1_cyl1_p_interact;
char* mask_string = mccchannel_19_cave1_cyl1_mask_string;
char* mask_setting = mccchannel_19_cave1_cyl1_mask_setting;
MCNUM number_of_activations = mccchannel_19_cave1_cyl1_number_of_activations;
#line 345 "Union_cylinder.comp"
{
dummy = 1;
}
#line 456937 "MACS_sample_kidney_box.c"
}   /* End of channel_19_cave1_cyl1=Union_cylinder() SETTING parameter declarations. */
#undef this_cylinder_storage
#undef global_geometry_element
#undef this_cylinder_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex
  /* Label for restoring  neutron */
  mcabsorbCompchannel_19_cave1_cyl1:
  if (RESTORE) /* restore if needed */
  { RESTORE_NEUTRON(849,
      mcnlx,
      mcnly,
      mcnlz,
      mcnlvx,
      mcnlvy,
      mcnlvz,
      mcnlt,
      mcnlsx,
      mcnlsy,
      mcnlsz,
      mcnlp); }
#undef mcabsorbComp
#undef p
#undef sz
#undef sy
#undef sx
#undef t
#undef vz
#undef vy
#undef vx
#undef z
#undef y
#undef x
  mcDEBUG_STATE(
mcnlx,
mcnly,
mcnlz,
mcnlvx,
mcnlvy,
mcnlvz,
mcnlt,
mcnlsx,
mcnlsy,
mcnlsz,
mcnlp)

  /* TRACE Component channel_19_analyzer_1_center [850] */
  mccoordschange(mcposrchannel_19_analyzer_1_center, mcrotrchannel_19_analyzer_1_center,
    &mcnlx,
    &mcnly,
    &mcnlz,
    &mcnlvx,
    &mcnlvy,
    &mcnlvz,
    &mcnlsx,
    &mcnlsy,
    &mcnlsz);
  /* define label inside component channel_19_analyzer_1_center (without coords transformations) */
  mcJumpTrace_channel_19_analyzer_1_center:
  SIG_MESSAGE("channel_19_analyzer_1_center (Trace)");
  mcDEBUG_COMP("channel_19_analyzer_1_center")
  mcDEBUG_STATE(
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp)
#define x mcnlx
#define y mcnly
#define z mcnlz
#define vx mcnlvx
#define vy mcnlvy
#define vz mcnlvz
#define t mcnlt
#define sx mcnlsx
#define sy mcnlsy
#define sz mcnlsz
#define p mcnlp

#define mcabsorbComp mcabsorbCompchannel_19_analyzer_1_center
  STORE_NEUTRON(850,
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp);
  mcScattered=0;
  mcRestore=0;
  mcNCounter[850]++;
  mcPCounter[850] += p;
  mcP2Counter[850] += p*p;
#define mccompcurname  channel_19_analyzer_1_center
#define mccompcurtype  Arm
#define mccompcurindex 850
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex
  /* Label for restoring  neutron */
  mcabsorbCompchannel_19_analyzer_1_center:
  if (RESTORE) /* restore if needed */
  { RESTORE_NEUTRON(850,
      mcnlx,
      mcnly,
      mcnlz,
      mcnlvx,
      mcnlvy,
      mcnlvz,
      mcnlt,
      mcnlsx,
      mcnlsy,
      mcnlsz,
      mcnlp); }
#undef mcabsorbComp
#undef p
#undef sz
#undef sy
#undef sx
#undef t
#undef vz
#undef vy
#undef vx
#undef z
#undef y
#undef x
  mcDEBUG_STATE(
mcnlx,
mcnly,
mcnlz,
mcnlvx,
mcnlvy,
mcnlvz,
mcnlt,
mcnlsx,
mcnlsy,
mcnlsz,
mcnlp)

  /* TRACE Component channel_19_analyzer_1_rotated [851] */
  mccoordschange(mcposrchannel_19_analyzer_1_rotated, mcrotrchannel_19_analyzer_1_rotated,
    &mcnlx,
    &mcnly,
    &mcnlz,
    &mcnlvx,
    &mcnlvy,
    &mcnlvz,
    &mcnlsx,
    &mcnlsy,
    &mcnlsz);
  /* define label inside component channel_19_analyzer_1_rotated (without coords transformations) */
  mcJumpTrace_channel_19_analyzer_1_rotated:
  SIG_MESSAGE("channel_19_analyzer_1_rotated (Trace)");
  mcDEBUG_COMP("channel_19_analyzer_1_rotated")
  mcDEBUG_STATE(
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp)
#define x mcnlx
#define y mcnly
#define z mcnlz
#define vx mcnlvx
#define vy mcnlvy
#define vz mcnlvz
#define t mcnlt
#define sx mcnlsx
#define sy mcnlsy
#define sz mcnlsz
#define p mcnlp

#define mcabsorbComp mcabsorbCompchannel_19_analyzer_1_rotated
  STORE_NEUTRON(851,
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp);
  mcScattered=0;
  mcRestore=0;
  mcNCounter[851]++;
  mcPCounter[851] += p;
  mcP2Counter[851] += p*p;
#define mccompcurname  channel_19_analyzer_1_rotated
#define mccompcurtype  Arm
#define mccompcurindex 851
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex
  /* Label for restoring  neutron */
  mcabsorbCompchannel_19_analyzer_1_rotated:
  if (RESTORE) /* restore if needed */
  { RESTORE_NEUTRON(851,
      mcnlx,
      mcnly,
      mcnlz,
      mcnlvx,
      mcnlvy,
      mcnlvz,
      mcnlt,
      mcnlsx,
      mcnlsy,
      mcnlsz,
      mcnlp); }
#undef mcabsorbComp
#undef p
#undef sz
#undef sy
#undef sx
#undef t
#undef vz
#undef vy
#undef vx
#undef z
#undef y
#undef x
  mcDEBUG_STATE(
mcnlx,
mcnly,
mcnlz,
mcnlvx,
mcnlvy,
mcnlvz,
mcnlt,
mcnlsx,
mcnlsy,
mcnlsz,
mcnlp)

  /* TRACE Component channel_19_analyzer_1_array_crystal_array_0 [852] */
  mccoordschange(mcposrchannel_19_analyzer_1_array_crystal_array_0, mcrotrchannel_19_analyzer_1_array_crystal_array_0,
    &mcnlx,
    &mcnly,
    &mcnlz,
    &mcnlvx,
    &mcnlvy,
    &mcnlvz,
    &mcnlsx,
    &mcnlsy,
    &mcnlsz);
  /* define label inside component channel_19_analyzer_1_array_crystal_array_0 (without coords transformations) */
  mcJumpTrace_channel_19_analyzer_1_array_crystal_array_0:
  SIG_MESSAGE("channel_19_analyzer_1_array_crystal_array_0 (Trace)");
  mcDEBUG_COMP("channel_19_analyzer_1_array_crystal_array_0")
  mcDEBUG_STATE(
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp)
#define x mcnlx
#define y mcnly
#define z mcnlz
#define vx mcnlvx
#define vy mcnlvy
#define vz mcnlvz
#define t mcnlt
#define sx mcnlsx
#define sy mcnlsy
#define sz mcnlsz
#define p mcnlp

#define mcabsorbComp mcabsorbCompchannel_19_analyzer_1_array_crystal_array_0
  STORE_NEUTRON(852,
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp);
  mcScattered=0;
  mcRestore=0;
  mcNCounter[852]++;
  mcPCounter[852] += p;
  mcP2Counter[852] += p*p;
#define mccompcurname  channel_19_analyzer_1_array_crystal_array_0
#define mccompcurtype  Union_box
#define mccompcurindex 852
#define loop_index mccchannel_19_analyzer_1_array_crystal_array_0_loop_index
#define this_box_volume mccchannel_19_analyzer_1_array_crystal_array_0_this_box_volume
#define global_geometry_element mccchannel_19_analyzer_1_array_crystal_array_0_global_geometry_element
#define this_box_storage mccchannel_19_analyzer_1_array_crystal_array_0_this_box_storage
{   /* Declarations of channel_19_analyzer_1_array_crystal_array_0=Union_box() SETTING parameters. */
char* material_string = mccchannel_19_analyzer_1_array_crystal_array_0_material_string;
MCNUM priority = mccchannel_19_analyzer_1_array_crystal_array_0_priority;
MCNUM xwidth = mccchannel_19_analyzer_1_array_crystal_array_0_xwidth;
MCNUM yheight = mccchannel_19_analyzer_1_array_crystal_array_0_yheight;
MCNUM zdepth = mccchannel_19_analyzer_1_array_crystal_array_0_zdepth;
MCNUM xwidth2 = mccchannel_19_analyzer_1_array_crystal_array_0_xwidth2;
MCNUM yheight2 = mccchannel_19_analyzer_1_array_crystal_array_0_yheight2;
MCNUM visualize = mccchannel_19_analyzer_1_array_crystal_array_0_visualize;
int target_index = mccchannel_19_analyzer_1_array_crystal_array_0_target_index;
MCNUM target_x = mccchannel_19_analyzer_1_array_crystal_array_0_target_x;
MCNUM target_y = mccchannel_19_analyzer_1_array_crystal_array_0_target_y;
MCNUM target_z = mccchannel_19_analyzer_1_array_crystal_array_0_target_z;
MCNUM focus_aw = mccchannel_19_analyzer_1_array_crystal_array_0_focus_aw;
MCNUM focus_ah = mccchannel_19_analyzer_1_array_crystal_array_0_focus_ah;
MCNUM focus_xw = mccchannel_19_analyzer_1_array_crystal_array_0_focus_xw;
MCNUM focus_xh = mccchannel_19_analyzer_1_array_crystal_array_0_focus_xh;
MCNUM focus_r = mccchannel_19_analyzer_1_array_crystal_array_0_focus_r;
MCNUM p_interact = mccchannel_19_analyzer_1_array_crystal_array_0_p_interact;
char* mask_string = mccchannel_19_analyzer_1_array_crystal_array_0_mask_string;
char* mask_setting = mccchannel_19_analyzer_1_array_crystal_array_0_mask_setting;
MCNUM number_of_activations = mccchannel_19_analyzer_1_array_crystal_array_0_number_of_activations;
}   /* End of channel_19_analyzer_1_array_crystal_array_0=Union_box() SETTING parameter declarations. */
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex
  /* Label for restoring  neutron */
  mcabsorbCompchannel_19_analyzer_1_array_crystal_array_0:
  if (RESTORE) /* restore if needed */
  { RESTORE_NEUTRON(852,
      mcnlx,
      mcnly,
      mcnlz,
      mcnlvx,
      mcnlvy,
      mcnlvz,
      mcnlt,
      mcnlsx,
      mcnlsy,
      mcnlsz,
      mcnlp); }
#undef mcabsorbComp
#undef p
#undef sz
#undef sy
#undef sx
#undef t
#undef vz
#undef vy
#undef vx
#undef z
#undef y
#undef x
  mcDEBUG_STATE(
mcnlx,
mcnly,
mcnlz,
mcnlvx,
mcnlvy,
mcnlvz,
mcnlt,
mcnlsx,
mcnlsy,
mcnlsz,
mcnlp)

  /* TRACE Component channel_19_analyzer_1_array_crystal_array_1 [853] */
  mccoordschange(mcposrchannel_19_analyzer_1_array_crystal_array_1, mcrotrchannel_19_analyzer_1_array_crystal_array_1,
    &mcnlx,
    &mcnly,
    &mcnlz,
    &mcnlvx,
    &mcnlvy,
    &mcnlvz,
    &mcnlsx,
    &mcnlsy,
    &mcnlsz);
  /* define label inside component channel_19_analyzer_1_array_crystal_array_1 (without coords transformations) */
  mcJumpTrace_channel_19_analyzer_1_array_crystal_array_1:
  SIG_MESSAGE("channel_19_analyzer_1_array_crystal_array_1 (Trace)");
  mcDEBUG_COMP("channel_19_analyzer_1_array_crystal_array_1")
  mcDEBUG_STATE(
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp)
#define x mcnlx
#define y mcnly
#define z mcnlz
#define vx mcnlvx
#define vy mcnlvy
#define vz mcnlvz
#define t mcnlt
#define sx mcnlsx
#define sy mcnlsy
#define sz mcnlsz
#define p mcnlp

#define mcabsorbComp mcabsorbCompchannel_19_analyzer_1_array_crystal_array_1
  STORE_NEUTRON(853,
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp);
  mcScattered=0;
  mcRestore=0;
  mcNCounter[853]++;
  mcPCounter[853] += p;
  mcP2Counter[853] += p*p;
#define mccompcurname  channel_19_analyzer_1_array_crystal_array_1
#define mccompcurtype  Union_box
#define mccompcurindex 853
#define loop_index mccchannel_19_analyzer_1_array_crystal_array_1_loop_index
#define this_box_volume mccchannel_19_analyzer_1_array_crystal_array_1_this_box_volume
#define global_geometry_element mccchannel_19_analyzer_1_array_crystal_array_1_global_geometry_element
#define this_box_storage mccchannel_19_analyzer_1_array_crystal_array_1_this_box_storage
{   /* Declarations of channel_19_analyzer_1_array_crystal_array_1=Union_box() SETTING parameters. */
char* material_string = mccchannel_19_analyzer_1_array_crystal_array_1_material_string;
MCNUM priority = mccchannel_19_analyzer_1_array_crystal_array_1_priority;
MCNUM xwidth = mccchannel_19_analyzer_1_array_crystal_array_1_xwidth;
MCNUM yheight = mccchannel_19_analyzer_1_array_crystal_array_1_yheight;
MCNUM zdepth = mccchannel_19_analyzer_1_array_crystal_array_1_zdepth;
MCNUM xwidth2 = mccchannel_19_analyzer_1_array_crystal_array_1_xwidth2;
MCNUM yheight2 = mccchannel_19_analyzer_1_array_crystal_array_1_yheight2;
MCNUM visualize = mccchannel_19_analyzer_1_array_crystal_array_1_visualize;
int target_index = mccchannel_19_analyzer_1_array_crystal_array_1_target_index;
MCNUM target_x = mccchannel_19_analyzer_1_array_crystal_array_1_target_x;
MCNUM target_y = mccchannel_19_analyzer_1_array_crystal_array_1_target_y;
MCNUM target_z = mccchannel_19_analyzer_1_array_crystal_array_1_target_z;
MCNUM focus_aw = mccchannel_19_analyzer_1_array_crystal_array_1_focus_aw;
MCNUM focus_ah = mccchannel_19_analyzer_1_array_crystal_array_1_focus_ah;
MCNUM focus_xw = mccchannel_19_analyzer_1_array_crystal_array_1_focus_xw;
MCNUM focus_xh = mccchannel_19_analyzer_1_array_crystal_array_1_focus_xh;
MCNUM focus_r = mccchannel_19_analyzer_1_array_crystal_array_1_focus_r;
MCNUM p_interact = mccchannel_19_analyzer_1_array_crystal_array_1_p_interact;
char* mask_string = mccchannel_19_analyzer_1_array_crystal_array_1_mask_string;
char* mask_setting = mccchannel_19_analyzer_1_array_crystal_array_1_mask_setting;
MCNUM number_of_activations = mccchannel_19_analyzer_1_array_crystal_array_1_number_of_activations;
}   /* End of channel_19_analyzer_1_array_crystal_array_1=Union_box() SETTING parameter declarations. */
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex
  /* Label for restoring  neutron */
  mcabsorbCompchannel_19_analyzer_1_array_crystal_array_1:
  if (RESTORE) /* restore if needed */
  { RESTORE_NEUTRON(853,
      mcnlx,
      mcnly,
      mcnlz,
      mcnlvx,
      mcnlvy,
      mcnlvz,
      mcnlt,
      mcnlsx,
      mcnlsy,
      mcnlsz,
      mcnlp); }
#undef mcabsorbComp
#undef p
#undef sz
#undef sy
#undef sx
#undef t
#undef vz
#undef vy
#undef vx
#undef z
#undef y
#undef x
  mcDEBUG_STATE(
mcnlx,
mcnly,
mcnlz,
mcnlvx,
mcnlvy,
mcnlvz,
mcnlt,
mcnlsx,
mcnlsy,
mcnlsz,
mcnlp)

  /* TRACE Component channel_19_analyzer_1_array_crystal_array_2 [854] */
  mccoordschange(mcposrchannel_19_analyzer_1_array_crystal_array_2, mcrotrchannel_19_analyzer_1_array_crystal_array_2,
    &mcnlx,
    &mcnly,
    &mcnlz,
    &mcnlvx,
    &mcnlvy,
    &mcnlvz,
    &mcnlsx,
    &mcnlsy,
    &mcnlsz);
  /* define label inside component channel_19_analyzer_1_array_crystal_array_2 (without coords transformations) */
  mcJumpTrace_channel_19_analyzer_1_array_crystal_array_2:
  SIG_MESSAGE("channel_19_analyzer_1_array_crystal_array_2 (Trace)");
  mcDEBUG_COMP("channel_19_analyzer_1_array_crystal_array_2")
  mcDEBUG_STATE(
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp)
#define x mcnlx
#define y mcnly
#define z mcnlz
#define vx mcnlvx
#define vy mcnlvy
#define vz mcnlvz
#define t mcnlt
#define sx mcnlsx
#define sy mcnlsy
#define sz mcnlsz
#define p mcnlp

#define mcabsorbComp mcabsorbCompchannel_19_analyzer_1_array_crystal_array_2
  STORE_NEUTRON(854,
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp);
  mcScattered=0;
  mcRestore=0;
  mcNCounter[854]++;
  mcPCounter[854] += p;
  mcP2Counter[854] += p*p;
#define mccompcurname  channel_19_analyzer_1_array_crystal_array_2
#define mccompcurtype  Union_box
#define mccompcurindex 854
#define loop_index mccchannel_19_analyzer_1_array_crystal_array_2_loop_index
#define this_box_volume mccchannel_19_analyzer_1_array_crystal_array_2_this_box_volume
#define global_geometry_element mccchannel_19_analyzer_1_array_crystal_array_2_global_geometry_element
#define this_box_storage mccchannel_19_analyzer_1_array_crystal_array_2_this_box_storage
{   /* Declarations of channel_19_analyzer_1_array_crystal_array_2=Union_box() SETTING parameters. */
char* material_string = mccchannel_19_analyzer_1_array_crystal_array_2_material_string;
MCNUM priority = mccchannel_19_analyzer_1_array_crystal_array_2_priority;
MCNUM xwidth = mccchannel_19_analyzer_1_array_crystal_array_2_xwidth;
MCNUM yheight = mccchannel_19_analyzer_1_array_crystal_array_2_yheight;
MCNUM zdepth = mccchannel_19_analyzer_1_array_crystal_array_2_zdepth;
MCNUM xwidth2 = mccchannel_19_analyzer_1_array_crystal_array_2_xwidth2;
MCNUM yheight2 = mccchannel_19_analyzer_1_array_crystal_array_2_yheight2;
MCNUM visualize = mccchannel_19_analyzer_1_array_crystal_array_2_visualize;
int target_index = mccchannel_19_analyzer_1_array_crystal_array_2_target_index;
MCNUM target_x = mccchannel_19_analyzer_1_array_crystal_array_2_target_x;
MCNUM target_y = mccchannel_19_analyzer_1_array_crystal_array_2_target_y;
MCNUM target_z = mccchannel_19_analyzer_1_array_crystal_array_2_target_z;
MCNUM focus_aw = mccchannel_19_analyzer_1_array_crystal_array_2_focus_aw;
MCNUM focus_ah = mccchannel_19_analyzer_1_array_crystal_array_2_focus_ah;
MCNUM focus_xw = mccchannel_19_analyzer_1_array_crystal_array_2_focus_xw;
MCNUM focus_xh = mccchannel_19_analyzer_1_array_crystal_array_2_focus_xh;
MCNUM focus_r = mccchannel_19_analyzer_1_array_crystal_array_2_focus_r;
MCNUM p_interact = mccchannel_19_analyzer_1_array_crystal_array_2_p_interact;
char* mask_string = mccchannel_19_analyzer_1_array_crystal_array_2_mask_string;
char* mask_setting = mccchannel_19_analyzer_1_array_crystal_array_2_mask_setting;
MCNUM number_of_activations = mccchannel_19_analyzer_1_array_crystal_array_2_number_of_activations;
}   /* End of channel_19_analyzer_1_array_crystal_array_2=Union_box() SETTING parameter declarations. */
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex
  /* Label for restoring  neutron */
  mcabsorbCompchannel_19_analyzer_1_array_crystal_array_2:
  if (RESTORE) /* restore if needed */
  { RESTORE_NEUTRON(854,
      mcnlx,
      mcnly,
      mcnlz,
      mcnlvx,
      mcnlvy,
      mcnlvz,
      mcnlt,
      mcnlsx,
      mcnlsy,
      mcnlsz,
      mcnlp); }
#undef mcabsorbComp
#undef p
#undef sz
#undef sy
#undef sx
#undef t
#undef vz
#undef vy
#undef vx
#undef z
#undef y
#undef x
  mcDEBUG_STATE(
mcnlx,
mcnly,
mcnlz,
mcnlvx,
mcnlvy,
mcnlvz,
mcnlt,
mcnlsx,
mcnlsy,
mcnlsz,
mcnlp)

  /* TRACE Component channel_19_analyzer_1_array_crystal_array_3 [855] */
  mccoordschange(mcposrchannel_19_analyzer_1_array_crystal_array_3, mcrotrchannel_19_analyzer_1_array_crystal_array_3,
    &mcnlx,
    &mcnly,
    &mcnlz,
    &mcnlvx,
    &mcnlvy,
    &mcnlvz,
    &mcnlsx,
    &mcnlsy,
    &mcnlsz);
  /* define label inside component channel_19_analyzer_1_array_crystal_array_3 (without coords transformations) */
  mcJumpTrace_channel_19_analyzer_1_array_crystal_array_3:
  SIG_MESSAGE("channel_19_analyzer_1_array_crystal_array_3 (Trace)");
  mcDEBUG_COMP("channel_19_analyzer_1_array_crystal_array_3")
  mcDEBUG_STATE(
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp)
#define x mcnlx
#define y mcnly
#define z mcnlz
#define vx mcnlvx
#define vy mcnlvy
#define vz mcnlvz
#define t mcnlt
#define sx mcnlsx
#define sy mcnlsy
#define sz mcnlsz
#define p mcnlp

#define mcabsorbComp mcabsorbCompchannel_19_analyzer_1_array_crystal_array_3
  STORE_NEUTRON(855,
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp);
  mcScattered=0;
  mcRestore=0;
  mcNCounter[855]++;
  mcPCounter[855] += p;
  mcP2Counter[855] += p*p;
#define mccompcurname  channel_19_analyzer_1_array_crystal_array_3
#define mccompcurtype  Union_box
#define mccompcurindex 855
#define loop_index mccchannel_19_analyzer_1_array_crystal_array_3_loop_index
#define this_box_volume mccchannel_19_analyzer_1_array_crystal_array_3_this_box_volume
#define global_geometry_element mccchannel_19_analyzer_1_array_crystal_array_3_global_geometry_element
#define this_box_storage mccchannel_19_analyzer_1_array_crystal_array_3_this_box_storage
{   /* Declarations of channel_19_analyzer_1_array_crystal_array_3=Union_box() SETTING parameters. */
char* material_string = mccchannel_19_analyzer_1_array_crystal_array_3_material_string;
MCNUM priority = mccchannel_19_analyzer_1_array_crystal_array_3_priority;
MCNUM xwidth = mccchannel_19_analyzer_1_array_crystal_array_3_xwidth;
MCNUM yheight = mccchannel_19_analyzer_1_array_crystal_array_3_yheight;
MCNUM zdepth = mccchannel_19_analyzer_1_array_crystal_array_3_zdepth;
MCNUM xwidth2 = mccchannel_19_analyzer_1_array_crystal_array_3_xwidth2;
MCNUM yheight2 = mccchannel_19_analyzer_1_array_crystal_array_3_yheight2;
MCNUM visualize = mccchannel_19_analyzer_1_array_crystal_array_3_visualize;
int target_index = mccchannel_19_analyzer_1_array_crystal_array_3_target_index;
MCNUM target_x = mccchannel_19_analyzer_1_array_crystal_array_3_target_x;
MCNUM target_y = mccchannel_19_analyzer_1_array_crystal_array_3_target_y;
MCNUM target_z = mccchannel_19_analyzer_1_array_crystal_array_3_target_z;
MCNUM focus_aw = mccchannel_19_analyzer_1_array_crystal_array_3_focus_aw;
MCNUM focus_ah = mccchannel_19_analyzer_1_array_crystal_array_3_focus_ah;
MCNUM focus_xw = mccchannel_19_analyzer_1_array_crystal_array_3_focus_xw;
MCNUM focus_xh = mccchannel_19_analyzer_1_array_crystal_array_3_focus_xh;
MCNUM focus_r = mccchannel_19_analyzer_1_array_crystal_array_3_focus_r;
MCNUM p_interact = mccchannel_19_analyzer_1_array_crystal_array_3_p_interact;
char* mask_string = mccchannel_19_analyzer_1_array_crystal_array_3_mask_string;
char* mask_setting = mccchannel_19_analyzer_1_array_crystal_array_3_mask_setting;
MCNUM number_of_activations = mccchannel_19_analyzer_1_array_crystal_array_3_number_of_activations;
}   /* End of channel_19_analyzer_1_array_crystal_array_3=Union_box() SETTING parameter declarations. */
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex
  /* Label for restoring  neutron */
  mcabsorbCompchannel_19_analyzer_1_array_crystal_array_3:
  if (RESTORE) /* restore if needed */
  { RESTORE_NEUTRON(855,
      mcnlx,
      mcnly,
      mcnlz,
      mcnlvx,
      mcnlvy,
      mcnlvz,
      mcnlt,
      mcnlsx,
      mcnlsy,
      mcnlsz,
      mcnlp); }
#undef mcabsorbComp
#undef p
#undef sz
#undef sy
#undef sx
#undef t
#undef vz
#undef vy
#undef vx
#undef z
#undef y
#undef x
  mcDEBUG_STATE(
mcnlx,
mcnly,
mcnlz,
mcnlvx,
mcnlvy,
mcnlvz,
mcnlt,
mcnlsx,
mcnlsy,
mcnlsz,
mcnlp)

  /* TRACE Component channel_19_analyzer_1_array_crystal_array_4 [856] */
  mccoordschange(mcposrchannel_19_analyzer_1_array_crystal_array_4, mcrotrchannel_19_analyzer_1_array_crystal_array_4,
    &mcnlx,
    &mcnly,
    &mcnlz,
    &mcnlvx,
    &mcnlvy,
    &mcnlvz,
    &mcnlsx,
    &mcnlsy,
    &mcnlsz);
  /* define label inside component channel_19_analyzer_1_array_crystal_array_4 (without coords transformations) */
  mcJumpTrace_channel_19_analyzer_1_array_crystal_array_4:
  SIG_MESSAGE("channel_19_analyzer_1_array_crystal_array_4 (Trace)");
  mcDEBUG_COMP("channel_19_analyzer_1_array_crystal_array_4")
  mcDEBUG_STATE(
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp)
#define x mcnlx
#define y mcnly
#define z mcnlz
#define vx mcnlvx
#define vy mcnlvy
#define vz mcnlvz
#define t mcnlt
#define sx mcnlsx
#define sy mcnlsy
#define sz mcnlsz
#define p mcnlp

#define mcabsorbComp mcabsorbCompchannel_19_analyzer_1_array_crystal_array_4
  STORE_NEUTRON(856,
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp);
  mcScattered=0;
  mcRestore=0;
  mcNCounter[856]++;
  mcPCounter[856] += p;
  mcP2Counter[856] += p*p;
#define mccompcurname  channel_19_analyzer_1_array_crystal_array_4
#define mccompcurtype  Union_box
#define mccompcurindex 856
#define loop_index mccchannel_19_analyzer_1_array_crystal_array_4_loop_index
#define this_box_volume mccchannel_19_analyzer_1_array_crystal_array_4_this_box_volume
#define global_geometry_element mccchannel_19_analyzer_1_array_crystal_array_4_global_geometry_element
#define this_box_storage mccchannel_19_analyzer_1_array_crystal_array_4_this_box_storage
{   /* Declarations of channel_19_analyzer_1_array_crystal_array_4=Union_box() SETTING parameters. */
char* material_string = mccchannel_19_analyzer_1_array_crystal_array_4_material_string;
MCNUM priority = mccchannel_19_analyzer_1_array_crystal_array_4_priority;
MCNUM xwidth = mccchannel_19_analyzer_1_array_crystal_array_4_xwidth;
MCNUM yheight = mccchannel_19_analyzer_1_array_crystal_array_4_yheight;
MCNUM zdepth = mccchannel_19_analyzer_1_array_crystal_array_4_zdepth;
MCNUM xwidth2 = mccchannel_19_analyzer_1_array_crystal_array_4_xwidth2;
MCNUM yheight2 = mccchannel_19_analyzer_1_array_crystal_array_4_yheight2;
MCNUM visualize = mccchannel_19_analyzer_1_array_crystal_array_4_visualize;
int target_index = mccchannel_19_analyzer_1_array_crystal_array_4_target_index;
MCNUM target_x = mccchannel_19_analyzer_1_array_crystal_array_4_target_x;
MCNUM target_y = mccchannel_19_analyzer_1_array_crystal_array_4_target_y;
MCNUM target_z = mccchannel_19_analyzer_1_array_crystal_array_4_target_z;
MCNUM focus_aw = mccchannel_19_analyzer_1_array_crystal_array_4_focus_aw;
MCNUM focus_ah = mccchannel_19_analyzer_1_array_crystal_array_4_focus_ah;
MCNUM focus_xw = mccchannel_19_analyzer_1_array_crystal_array_4_focus_xw;
MCNUM focus_xh = mccchannel_19_analyzer_1_array_crystal_array_4_focus_xh;
MCNUM focus_r = mccchannel_19_analyzer_1_array_crystal_array_4_focus_r;
MCNUM p_interact = mccchannel_19_analyzer_1_array_crystal_array_4_p_interact;
char* mask_string = mccchannel_19_analyzer_1_array_crystal_array_4_mask_string;
char* mask_setting = mccchannel_19_analyzer_1_array_crystal_array_4_mask_setting;
MCNUM number_of_activations = mccchannel_19_analyzer_1_array_crystal_array_4_number_of_activations;
}   /* End of channel_19_analyzer_1_array_crystal_array_4=Union_box() SETTING parameter declarations. */
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex
  /* Label for restoring  neutron */
  mcabsorbCompchannel_19_analyzer_1_array_crystal_array_4:
  if (RESTORE) /* restore if needed */
  { RESTORE_NEUTRON(856,
      mcnlx,
      mcnly,
      mcnlz,
      mcnlvx,
      mcnlvy,
      mcnlvz,
      mcnlt,
      mcnlsx,
      mcnlsy,
      mcnlsz,
      mcnlp); }
#undef mcabsorbComp
#undef p
#undef sz
#undef sy
#undef sx
#undef t
#undef vz
#undef vy
#undef vx
#undef z
#undef y
#undef x
  mcDEBUG_STATE(
mcnlx,
mcnly,
mcnlz,
mcnlvx,
mcnlvy,
mcnlvz,
mcnlt,
mcnlsx,
mcnlsy,
mcnlsz,
mcnlp)

  /* TRACE Component channel_19_analyzer_1_array_crystal_array_5 [857] */
  mccoordschange(mcposrchannel_19_analyzer_1_array_crystal_array_5, mcrotrchannel_19_analyzer_1_array_crystal_array_5,
    &mcnlx,
    &mcnly,
    &mcnlz,
    &mcnlvx,
    &mcnlvy,
    &mcnlvz,
    &mcnlsx,
    &mcnlsy,
    &mcnlsz);
  /* define label inside component channel_19_analyzer_1_array_crystal_array_5 (without coords transformations) */
  mcJumpTrace_channel_19_analyzer_1_array_crystal_array_5:
  SIG_MESSAGE("channel_19_analyzer_1_array_crystal_array_5 (Trace)");
  mcDEBUG_COMP("channel_19_analyzer_1_array_crystal_array_5")
  mcDEBUG_STATE(
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp)
#define x mcnlx
#define y mcnly
#define z mcnlz
#define vx mcnlvx
#define vy mcnlvy
#define vz mcnlvz
#define t mcnlt
#define sx mcnlsx
#define sy mcnlsy
#define sz mcnlsz
#define p mcnlp

#define mcabsorbComp mcabsorbCompchannel_19_analyzer_1_array_crystal_array_5
  STORE_NEUTRON(857,
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp);
  mcScattered=0;
  mcRestore=0;
  mcNCounter[857]++;
  mcPCounter[857] += p;
  mcP2Counter[857] += p*p;
#define mccompcurname  channel_19_analyzer_1_array_crystal_array_5
#define mccompcurtype  Union_box
#define mccompcurindex 857
#define loop_index mccchannel_19_analyzer_1_array_crystal_array_5_loop_index
#define this_box_volume mccchannel_19_analyzer_1_array_crystal_array_5_this_box_volume
#define global_geometry_element mccchannel_19_analyzer_1_array_crystal_array_5_global_geometry_element
#define this_box_storage mccchannel_19_analyzer_1_array_crystal_array_5_this_box_storage
{   /* Declarations of channel_19_analyzer_1_array_crystal_array_5=Union_box() SETTING parameters. */
char* material_string = mccchannel_19_analyzer_1_array_crystal_array_5_material_string;
MCNUM priority = mccchannel_19_analyzer_1_array_crystal_array_5_priority;
MCNUM xwidth = mccchannel_19_analyzer_1_array_crystal_array_5_xwidth;
MCNUM yheight = mccchannel_19_analyzer_1_array_crystal_array_5_yheight;
MCNUM zdepth = mccchannel_19_analyzer_1_array_crystal_array_5_zdepth;
MCNUM xwidth2 = mccchannel_19_analyzer_1_array_crystal_array_5_xwidth2;
MCNUM yheight2 = mccchannel_19_analyzer_1_array_crystal_array_5_yheight2;
MCNUM visualize = mccchannel_19_analyzer_1_array_crystal_array_5_visualize;
int target_index = mccchannel_19_analyzer_1_array_crystal_array_5_target_index;
MCNUM target_x = mccchannel_19_analyzer_1_array_crystal_array_5_target_x;
MCNUM target_y = mccchannel_19_analyzer_1_array_crystal_array_5_target_y;
MCNUM target_z = mccchannel_19_analyzer_1_array_crystal_array_5_target_z;
MCNUM focus_aw = mccchannel_19_analyzer_1_array_crystal_array_5_focus_aw;
MCNUM focus_ah = mccchannel_19_analyzer_1_array_crystal_array_5_focus_ah;
MCNUM focus_xw = mccchannel_19_analyzer_1_array_crystal_array_5_focus_xw;
MCNUM focus_xh = mccchannel_19_analyzer_1_array_crystal_array_5_focus_xh;
MCNUM focus_r = mccchannel_19_analyzer_1_array_crystal_array_5_focus_r;
MCNUM p_interact = mccchannel_19_analyzer_1_array_crystal_array_5_p_interact;
char* mask_string = mccchannel_19_analyzer_1_array_crystal_array_5_mask_string;
char* mask_setting = mccchannel_19_analyzer_1_array_crystal_array_5_mask_setting;
MCNUM number_of_activations = mccchannel_19_analyzer_1_array_crystal_array_5_number_of_activations;
}   /* End of channel_19_analyzer_1_array_crystal_array_5=Union_box() SETTING parameter declarations. */
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex
  /* Label for restoring  neutron */
  mcabsorbCompchannel_19_analyzer_1_array_crystal_array_5:
  if (RESTORE) /* restore if needed */
  { RESTORE_NEUTRON(857,
      mcnlx,
      mcnly,
      mcnlz,
      mcnlvx,
      mcnlvy,
      mcnlvz,
      mcnlt,
      mcnlsx,
      mcnlsy,
      mcnlsz,
      mcnlp); }
#undef mcabsorbComp
#undef p
#undef sz
#undef sy
#undef sx
#undef t
#undef vz
#undef vy
#undef vx
#undef z
#undef y
#undef x
  mcDEBUG_STATE(
mcnlx,
mcnly,
mcnlz,
mcnlvx,
mcnlvy,
mcnlvz,
mcnlt,
mcnlsx,
mcnlsy,
mcnlsz,
mcnlp)

  /* TRACE Component channel_19_analyzer_1_array_crystal_array_6 [858] */
  mccoordschange(mcposrchannel_19_analyzer_1_array_crystal_array_6, mcrotrchannel_19_analyzer_1_array_crystal_array_6,
    &mcnlx,
    &mcnly,
    &mcnlz,
    &mcnlvx,
    &mcnlvy,
    &mcnlvz,
    &mcnlsx,
    &mcnlsy,
    &mcnlsz);
  /* define label inside component channel_19_analyzer_1_array_crystal_array_6 (without coords transformations) */
  mcJumpTrace_channel_19_analyzer_1_array_crystal_array_6:
  SIG_MESSAGE("channel_19_analyzer_1_array_crystal_array_6 (Trace)");
  mcDEBUG_COMP("channel_19_analyzer_1_array_crystal_array_6")
  mcDEBUG_STATE(
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp)
#define x mcnlx
#define y mcnly
#define z mcnlz
#define vx mcnlvx
#define vy mcnlvy
#define vz mcnlvz
#define t mcnlt
#define sx mcnlsx
#define sy mcnlsy
#define sz mcnlsz
#define p mcnlp

#define mcabsorbComp mcabsorbCompchannel_19_analyzer_1_array_crystal_array_6
  STORE_NEUTRON(858,
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp);
  mcScattered=0;
  mcRestore=0;
  mcNCounter[858]++;
  mcPCounter[858] += p;
  mcP2Counter[858] += p*p;
#define mccompcurname  channel_19_analyzer_1_array_crystal_array_6
#define mccompcurtype  Union_box
#define mccompcurindex 858
#define loop_index mccchannel_19_analyzer_1_array_crystal_array_6_loop_index
#define this_box_volume mccchannel_19_analyzer_1_array_crystal_array_6_this_box_volume
#define global_geometry_element mccchannel_19_analyzer_1_array_crystal_array_6_global_geometry_element
#define this_box_storage mccchannel_19_analyzer_1_array_crystal_array_6_this_box_storage
{   /* Declarations of channel_19_analyzer_1_array_crystal_array_6=Union_box() SETTING parameters. */
char* material_string = mccchannel_19_analyzer_1_array_crystal_array_6_material_string;
MCNUM priority = mccchannel_19_analyzer_1_array_crystal_array_6_priority;
MCNUM xwidth = mccchannel_19_analyzer_1_array_crystal_array_6_xwidth;
MCNUM yheight = mccchannel_19_analyzer_1_array_crystal_array_6_yheight;
MCNUM zdepth = mccchannel_19_analyzer_1_array_crystal_array_6_zdepth;
MCNUM xwidth2 = mccchannel_19_analyzer_1_array_crystal_array_6_xwidth2;
MCNUM yheight2 = mccchannel_19_analyzer_1_array_crystal_array_6_yheight2;
MCNUM visualize = mccchannel_19_analyzer_1_array_crystal_array_6_visualize;
int target_index = mccchannel_19_analyzer_1_array_crystal_array_6_target_index;
MCNUM target_x = mccchannel_19_analyzer_1_array_crystal_array_6_target_x;
MCNUM target_y = mccchannel_19_analyzer_1_array_crystal_array_6_target_y;
MCNUM target_z = mccchannel_19_analyzer_1_array_crystal_array_6_target_z;
MCNUM focus_aw = mccchannel_19_analyzer_1_array_crystal_array_6_focus_aw;
MCNUM focus_ah = mccchannel_19_analyzer_1_array_crystal_array_6_focus_ah;
MCNUM focus_xw = mccchannel_19_analyzer_1_array_crystal_array_6_focus_xw;
MCNUM focus_xh = mccchannel_19_analyzer_1_array_crystal_array_6_focus_xh;
MCNUM focus_r = mccchannel_19_analyzer_1_array_crystal_array_6_focus_r;
MCNUM p_interact = mccchannel_19_analyzer_1_array_crystal_array_6_p_interact;
char* mask_string = mccchannel_19_analyzer_1_array_crystal_array_6_mask_string;
char* mask_setting = mccchannel_19_analyzer_1_array_crystal_array_6_mask_setting;
MCNUM number_of_activations = mccchannel_19_analyzer_1_array_crystal_array_6_number_of_activations;
}   /* End of channel_19_analyzer_1_array_crystal_array_6=Union_box() SETTING parameter declarations. */
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex
  /* Label for restoring  neutron */
  mcabsorbCompchannel_19_analyzer_1_array_crystal_array_6:
  if (RESTORE) /* restore if needed */
  { RESTORE_NEUTRON(858,
      mcnlx,
      mcnly,
      mcnlz,
      mcnlvx,
      mcnlvy,
      mcnlvz,
      mcnlt,
      mcnlsx,
      mcnlsy,
      mcnlsz,
      mcnlp); }
#undef mcabsorbComp
#undef p
#undef sz
#undef sy
#undef sx
#undef t
#undef vz
#undef vy
#undef vx
#undef z
#undef y
#undef x
  mcDEBUG_STATE(
mcnlx,
mcnly,
mcnlz,
mcnlvx,
mcnlvy,
mcnlvz,
mcnlt,
mcnlsx,
mcnlsy,
mcnlsz,
mcnlp)

  /* TRACE Component channel_19_analyzer_1_array_crystal_array_7 [859] */
  mccoordschange(mcposrchannel_19_analyzer_1_array_crystal_array_7, mcrotrchannel_19_analyzer_1_array_crystal_array_7,
    &mcnlx,
    &mcnly,
    &mcnlz,
    &mcnlvx,
    &mcnlvy,
    &mcnlvz,
    &mcnlsx,
    &mcnlsy,
    &mcnlsz);
  /* define label inside component channel_19_analyzer_1_array_crystal_array_7 (without coords transformations) */
  mcJumpTrace_channel_19_analyzer_1_array_crystal_array_7:
  SIG_MESSAGE("channel_19_analyzer_1_array_crystal_array_7 (Trace)");
  mcDEBUG_COMP("channel_19_analyzer_1_array_crystal_array_7")
  mcDEBUG_STATE(
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp)
#define x mcnlx
#define y mcnly
#define z mcnlz
#define vx mcnlvx
#define vy mcnlvy
#define vz mcnlvz
#define t mcnlt
#define sx mcnlsx
#define sy mcnlsy
#define sz mcnlsz
#define p mcnlp

#define mcabsorbComp mcabsorbCompchannel_19_analyzer_1_array_crystal_array_7
  STORE_NEUTRON(859,
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp);
  mcScattered=0;
  mcRestore=0;
  mcNCounter[859]++;
  mcPCounter[859] += p;
  mcP2Counter[859] += p*p;
#define mccompcurname  channel_19_analyzer_1_array_crystal_array_7
#define mccompcurtype  Union_box
#define mccompcurindex 859
#define loop_index mccchannel_19_analyzer_1_array_crystal_array_7_loop_index
#define this_box_volume mccchannel_19_analyzer_1_array_crystal_array_7_this_box_volume
#define global_geometry_element mccchannel_19_analyzer_1_array_crystal_array_7_global_geometry_element
#define this_box_storage mccchannel_19_analyzer_1_array_crystal_array_7_this_box_storage
{   /* Declarations of channel_19_analyzer_1_array_crystal_array_7=Union_box() SETTING parameters. */
char* material_string = mccchannel_19_analyzer_1_array_crystal_array_7_material_string;
MCNUM priority = mccchannel_19_analyzer_1_array_crystal_array_7_priority;
MCNUM xwidth = mccchannel_19_analyzer_1_array_crystal_array_7_xwidth;
MCNUM yheight = mccchannel_19_analyzer_1_array_crystal_array_7_yheight;
MCNUM zdepth = mccchannel_19_analyzer_1_array_crystal_array_7_zdepth;
MCNUM xwidth2 = mccchannel_19_analyzer_1_array_crystal_array_7_xwidth2;
MCNUM yheight2 = mccchannel_19_analyzer_1_array_crystal_array_7_yheight2;
MCNUM visualize = mccchannel_19_analyzer_1_array_crystal_array_7_visualize;
int target_index = mccchannel_19_analyzer_1_array_crystal_array_7_target_index;
MCNUM target_x = mccchannel_19_analyzer_1_array_crystal_array_7_target_x;
MCNUM target_y = mccchannel_19_analyzer_1_array_crystal_array_7_target_y;
MCNUM target_z = mccchannel_19_analyzer_1_array_crystal_array_7_target_z;
MCNUM focus_aw = mccchannel_19_analyzer_1_array_crystal_array_7_focus_aw;
MCNUM focus_ah = mccchannel_19_analyzer_1_array_crystal_array_7_focus_ah;
MCNUM focus_xw = mccchannel_19_analyzer_1_array_crystal_array_7_focus_xw;
MCNUM focus_xh = mccchannel_19_analyzer_1_array_crystal_array_7_focus_xh;
MCNUM focus_r = mccchannel_19_analyzer_1_array_crystal_array_7_focus_r;
MCNUM p_interact = mccchannel_19_analyzer_1_array_crystal_array_7_p_interact;
char* mask_string = mccchannel_19_analyzer_1_array_crystal_array_7_mask_string;
char* mask_setting = mccchannel_19_analyzer_1_array_crystal_array_7_mask_setting;
MCNUM number_of_activations = mccchannel_19_analyzer_1_array_crystal_array_7_number_of_activations;
}   /* End of channel_19_analyzer_1_array_crystal_array_7=Union_box() SETTING parameter declarations. */
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex
  /* Label for restoring  neutron */
  mcabsorbCompchannel_19_analyzer_1_array_crystal_array_7:
  if (RESTORE) /* restore if needed */
  { RESTORE_NEUTRON(859,
      mcnlx,
      mcnly,
      mcnlz,
      mcnlvx,
      mcnlvy,
      mcnlvz,
      mcnlt,
      mcnlsx,
      mcnlsy,
      mcnlsz,
      mcnlp); }
#undef mcabsorbComp
#undef p
#undef sz
#undef sy
#undef sx
#undef t
#undef vz
#undef vy
#undef vx
#undef z
#undef y
#undef x
  mcDEBUG_STATE(
mcnlx,
mcnly,
mcnlz,
mcnlvx,
mcnlvy,
mcnlvz,
mcnlt,
mcnlsx,
mcnlsy,
mcnlsz,
mcnlp)

  /* TRACE Component channel_19_analyzer_1_array_crystal_array_8 [860] */
  mccoordschange(mcposrchannel_19_analyzer_1_array_crystal_array_8, mcrotrchannel_19_analyzer_1_array_crystal_array_8,
    &mcnlx,
    &mcnly,
    &mcnlz,
    &mcnlvx,
    &mcnlvy,
    &mcnlvz,
    &mcnlsx,
    &mcnlsy,
    &mcnlsz);
  /* define label inside component channel_19_analyzer_1_array_crystal_array_8 (without coords transformations) */
  mcJumpTrace_channel_19_analyzer_1_array_crystal_array_8:
  SIG_MESSAGE("channel_19_analyzer_1_array_crystal_array_8 (Trace)");
  mcDEBUG_COMP("channel_19_analyzer_1_array_crystal_array_8")
  mcDEBUG_STATE(
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp)
#define x mcnlx
#define y mcnly
#define z mcnlz
#define vx mcnlvx
#define vy mcnlvy
#define vz mcnlvz
#define t mcnlt
#define sx mcnlsx
#define sy mcnlsy
#define sz mcnlsz
#define p mcnlp

#define mcabsorbComp mcabsorbCompchannel_19_analyzer_1_array_crystal_array_8
  STORE_NEUTRON(860,
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp);
  mcScattered=0;
  mcRestore=0;
  mcNCounter[860]++;
  mcPCounter[860] += p;
  mcP2Counter[860] += p*p;
#define mccompcurname  channel_19_analyzer_1_array_crystal_array_8
#define mccompcurtype  Union_box
#define mccompcurindex 860
#define loop_index mccchannel_19_analyzer_1_array_crystal_array_8_loop_index
#define this_box_volume mccchannel_19_analyzer_1_array_crystal_array_8_this_box_volume
#define global_geometry_element mccchannel_19_analyzer_1_array_crystal_array_8_global_geometry_element
#define this_box_storage mccchannel_19_analyzer_1_array_crystal_array_8_this_box_storage
{   /* Declarations of channel_19_analyzer_1_array_crystal_array_8=Union_box() SETTING parameters. */
char* material_string = mccchannel_19_analyzer_1_array_crystal_array_8_material_string;
MCNUM priority = mccchannel_19_analyzer_1_array_crystal_array_8_priority;
MCNUM xwidth = mccchannel_19_analyzer_1_array_crystal_array_8_xwidth;
MCNUM yheight = mccchannel_19_analyzer_1_array_crystal_array_8_yheight;
MCNUM zdepth = mccchannel_19_analyzer_1_array_crystal_array_8_zdepth;
MCNUM xwidth2 = mccchannel_19_analyzer_1_array_crystal_array_8_xwidth2;
MCNUM yheight2 = mccchannel_19_analyzer_1_array_crystal_array_8_yheight2;
MCNUM visualize = mccchannel_19_analyzer_1_array_crystal_array_8_visualize;
int target_index = mccchannel_19_analyzer_1_array_crystal_array_8_target_index;
MCNUM target_x = mccchannel_19_analyzer_1_array_crystal_array_8_target_x;
MCNUM target_y = mccchannel_19_analyzer_1_array_crystal_array_8_target_y;
MCNUM target_z = mccchannel_19_analyzer_1_array_crystal_array_8_target_z;
MCNUM focus_aw = mccchannel_19_analyzer_1_array_crystal_array_8_focus_aw;
MCNUM focus_ah = mccchannel_19_analyzer_1_array_crystal_array_8_focus_ah;
MCNUM focus_xw = mccchannel_19_analyzer_1_array_crystal_array_8_focus_xw;
MCNUM focus_xh = mccchannel_19_analyzer_1_array_crystal_array_8_focus_xh;
MCNUM focus_r = mccchannel_19_analyzer_1_array_crystal_array_8_focus_r;
MCNUM p_interact = mccchannel_19_analyzer_1_array_crystal_array_8_p_interact;
char* mask_string = mccchannel_19_analyzer_1_array_crystal_array_8_mask_string;
char* mask_setting = mccchannel_19_analyzer_1_array_crystal_array_8_mask_setting;
MCNUM number_of_activations = mccchannel_19_analyzer_1_array_crystal_array_8_number_of_activations;
}   /* End of channel_19_analyzer_1_array_crystal_array_8=Union_box() SETTING parameter declarations. */
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex
  /* Label for restoring  neutron */
  mcabsorbCompchannel_19_analyzer_1_array_crystal_array_8:
  if (RESTORE) /* restore if needed */
  { RESTORE_NEUTRON(860,
      mcnlx,
      mcnly,
      mcnlz,
      mcnlvx,
      mcnlvy,
      mcnlvz,
      mcnlt,
      mcnlsx,
      mcnlsy,
      mcnlsz,
      mcnlp); }
#undef mcabsorbComp
#undef p
#undef sz
#undef sy
#undef sx
#undef t
#undef vz
#undef vy
#undef vx
#undef z
#undef y
#undef x
  mcDEBUG_STATE(
mcnlx,
mcnly,
mcnlz,
mcnlvx,
mcnlvy,
mcnlvz,
mcnlt,
mcnlsx,
mcnlsy,
mcnlsz,
mcnlp)

  /* TRACE Component channel_19_analyzer_2_center [861] */
  mccoordschange(mcposrchannel_19_analyzer_2_center, mcrotrchannel_19_analyzer_2_center,
    &mcnlx,
    &mcnly,
    &mcnlz,
    &mcnlvx,
    &mcnlvy,
    &mcnlvz,
    &mcnlsx,
    &mcnlsy,
    &mcnlsz);
  /* define label inside component channel_19_analyzer_2_center (without coords transformations) */
  mcJumpTrace_channel_19_analyzer_2_center:
  SIG_MESSAGE("channel_19_analyzer_2_center (Trace)");
  mcDEBUG_COMP("channel_19_analyzer_2_center")
  mcDEBUG_STATE(
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp)
#define x mcnlx
#define y mcnly
#define z mcnlz
#define vx mcnlvx
#define vy mcnlvy
#define vz mcnlvz
#define t mcnlt
#define sx mcnlsx
#define sy mcnlsy
#define sz mcnlsz
#define p mcnlp

#define mcabsorbComp mcabsorbCompchannel_19_analyzer_2_center
  STORE_NEUTRON(861,
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp);
  mcScattered=0;
  mcRestore=0;
  mcNCounter[861]++;
  mcPCounter[861] += p;
  mcP2Counter[861] += p*p;
#define mccompcurname  channel_19_analyzer_2_center
#define mccompcurtype  Arm
#define mccompcurindex 861
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex
  /* Label for restoring  neutron */
  mcabsorbCompchannel_19_analyzer_2_center:
  if (RESTORE) /* restore if needed */
  { RESTORE_NEUTRON(861,
      mcnlx,
      mcnly,
      mcnlz,
      mcnlvx,
      mcnlvy,
      mcnlvz,
      mcnlt,
      mcnlsx,
      mcnlsy,
      mcnlsz,
      mcnlp); }
#undef mcabsorbComp
#undef p
#undef sz
#undef sy
#undef sx
#undef t
#undef vz
#undef vy
#undef vx
#undef z
#undef y
#undef x
  mcDEBUG_STATE(
mcnlx,
mcnly,
mcnlz,
mcnlvx,
mcnlvy,
mcnlvz,
mcnlt,
mcnlsx,
mcnlsy,
mcnlsz,
mcnlp)

  /* TRACE Component channel_19_analyzer_2_rotated [862] */
  mccoordschange(mcposrchannel_19_analyzer_2_rotated, mcrotrchannel_19_analyzer_2_rotated,
    &mcnlx,
    &mcnly,
    &mcnlz,
    &mcnlvx,
    &mcnlvy,
    &mcnlvz,
    &mcnlsx,
    &mcnlsy,
    &mcnlsz);
  /* define label inside component channel_19_analyzer_2_rotated (without coords transformations) */
  mcJumpTrace_channel_19_analyzer_2_rotated:
  SIG_MESSAGE("channel_19_analyzer_2_rotated (Trace)");
  mcDEBUG_COMP("channel_19_analyzer_2_rotated")
  mcDEBUG_STATE(
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp)
#define x mcnlx
#define y mcnly
#define z mcnlz
#define vx mcnlvx
#define vy mcnlvy
#define vz mcnlvz
#define t mcnlt
#define sx mcnlsx
#define sy mcnlsy
#define sz mcnlsz
#define p mcnlp

#define mcabsorbComp mcabsorbCompchannel_19_analyzer_2_rotated
  STORE_NEUTRON(862,
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp);
  mcScattered=0;
  mcRestore=0;
  mcNCounter[862]++;
  mcPCounter[862] += p;
  mcP2Counter[862] += p*p;
#define mccompcurname  channel_19_analyzer_2_rotated
#define mccompcurtype  Arm
#define mccompcurindex 862
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex
  /* Label for restoring  neutron */
  mcabsorbCompchannel_19_analyzer_2_rotated:
  if (RESTORE) /* restore if needed */
  { RESTORE_NEUTRON(862,
      mcnlx,
      mcnly,
      mcnlz,
      mcnlvx,
      mcnlvy,
      mcnlvz,
      mcnlt,
      mcnlsx,
      mcnlsy,
      mcnlsz,
      mcnlp); }
#undef mcabsorbComp
#undef p
#undef sz
#undef sy
#undef sx
#undef t
#undef vz
#undef vy
#undef vx
#undef z
#undef y
#undef x
  mcDEBUG_STATE(
mcnlx,
mcnly,
mcnlz,
mcnlvx,
mcnlvy,
mcnlvz,
mcnlt,
mcnlsx,
mcnlsy,
mcnlsz,
mcnlp)

  /* TRACE Component channel_19_analyzer_2_array_crystal_array_0 [863] */
  mccoordschange(mcposrchannel_19_analyzer_2_array_crystal_array_0, mcrotrchannel_19_analyzer_2_array_crystal_array_0,
    &mcnlx,
    &mcnly,
    &mcnlz,
    &mcnlvx,
    &mcnlvy,
    &mcnlvz,
    &mcnlsx,
    &mcnlsy,
    &mcnlsz);
  /* define label inside component channel_19_analyzer_2_array_crystal_array_0 (without coords transformations) */
  mcJumpTrace_channel_19_analyzer_2_array_crystal_array_0:
  SIG_MESSAGE("channel_19_analyzer_2_array_crystal_array_0 (Trace)");
  mcDEBUG_COMP("channel_19_analyzer_2_array_crystal_array_0")
  mcDEBUG_STATE(
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp)
#define x mcnlx
#define y mcnly
#define z mcnlz
#define vx mcnlvx
#define vy mcnlvy
#define vz mcnlvz
#define t mcnlt
#define sx mcnlsx
#define sy mcnlsy
#define sz mcnlsz
#define p mcnlp

#define mcabsorbComp mcabsorbCompchannel_19_analyzer_2_array_crystal_array_0
  STORE_NEUTRON(863,
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp);
  mcScattered=0;
  mcRestore=0;
  mcNCounter[863]++;
  mcPCounter[863] += p;
  mcP2Counter[863] += p*p;
#define mccompcurname  channel_19_analyzer_2_array_crystal_array_0
#define mccompcurtype  Union_box
#define mccompcurindex 863
#define loop_index mccchannel_19_analyzer_2_array_crystal_array_0_loop_index
#define this_box_volume mccchannel_19_analyzer_2_array_crystal_array_0_this_box_volume
#define global_geometry_element mccchannel_19_analyzer_2_array_crystal_array_0_global_geometry_element
#define this_box_storage mccchannel_19_analyzer_2_array_crystal_array_0_this_box_storage
{   /* Declarations of channel_19_analyzer_2_array_crystal_array_0=Union_box() SETTING parameters. */
char* material_string = mccchannel_19_analyzer_2_array_crystal_array_0_material_string;
MCNUM priority = mccchannel_19_analyzer_2_array_crystal_array_0_priority;
MCNUM xwidth = mccchannel_19_analyzer_2_array_crystal_array_0_xwidth;
MCNUM yheight = mccchannel_19_analyzer_2_array_crystal_array_0_yheight;
MCNUM zdepth = mccchannel_19_analyzer_2_array_crystal_array_0_zdepth;
MCNUM xwidth2 = mccchannel_19_analyzer_2_array_crystal_array_0_xwidth2;
MCNUM yheight2 = mccchannel_19_analyzer_2_array_crystal_array_0_yheight2;
MCNUM visualize = mccchannel_19_analyzer_2_array_crystal_array_0_visualize;
int target_index = mccchannel_19_analyzer_2_array_crystal_array_0_target_index;
MCNUM target_x = mccchannel_19_analyzer_2_array_crystal_array_0_target_x;
MCNUM target_y = mccchannel_19_analyzer_2_array_crystal_array_0_target_y;
MCNUM target_z = mccchannel_19_analyzer_2_array_crystal_array_0_target_z;
MCNUM focus_aw = mccchannel_19_analyzer_2_array_crystal_array_0_focus_aw;
MCNUM focus_ah = mccchannel_19_analyzer_2_array_crystal_array_0_focus_ah;
MCNUM focus_xw = mccchannel_19_analyzer_2_array_crystal_array_0_focus_xw;
MCNUM focus_xh = mccchannel_19_analyzer_2_array_crystal_array_0_focus_xh;
MCNUM focus_r = mccchannel_19_analyzer_2_array_crystal_array_0_focus_r;
MCNUM p_interact = mccchannel_19_analyzer_2_array_crystal_array_0_p_interact;
char* mask_string = mccchannel_19_analyzer_2_array_crystal_array_0_mask_string;
char* mask_setting = mccchannel_19_analyzer_2_array_crystal_array_0_mask_setting;
MCNUM number_of_activations = mccchannel_19_analyzer_2_array_crystal_array_0_number_of_activations;
}   /* End of channel_19_analyzer_2_array_crystal_array_0=Union_box() SETTING parameter declarations. */
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex
  /* Label for restoring  neutron */
  mcabsorbCompchannel_19_analyzer_2_array_crystal_array_0:
  if (RESTORE) /* restore if needed */
  { RESTORE_NEUTRON(863,
      mcnlx,
      mcnly,
      mcnlz,
      mcnlvx,
      mcnlvy,
      mcnlvz,
      mcnlt,
      mcnlsx,
      mcnlsy,
      mcnlsz,
      mcnlp); }
#undef mcabsorbComp
#undef p
#undef sz
#undef sy
#undef sx
#undef t
#undef vz
#undef vy
#undef vx
#undef z
#undef y
#undef x
  mcDEBUG_STATE(
mcnlx,
mcnly,
mcnlz,
mcnlvx,
mcnlvy,
mcnlvz,
mcnlt,
mcnlsx,
mcnlsy,
mcnlsz,
mcnlp)

  /* TRACE Component channel_19_analyzer_2_array_crystal_array_1 [864] */
  mccoordschange(mcposrchannel_19_analyzer_2_array_crystal_array_1, mcrotrchannel_19_analyzer_2_array_crystal_array_1,
    &mcnlx,
    &mcnly,
    &mcnlz,
    &mcnlvx,
    &mcnlvy,
    &mcnlvz,
    &mcnlsx,
    &mcnlsy,
    &mcnlsz);
  /* define label inside component channel_19_analyzer_2_array_crystal_array_1 (without coords transformations) */
  mcJumpTrace_channel_19_analyzer_2_array_crystal_array_1:
  SIG_MESSAGE("channel_19_analyzer_2_array_crystal_array_1 (Trace)");
  mcDEBUG_COMP("channel_19_analyzer_2_array_crystal_array_1")
  mcDEBUG_STATE(
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp)
#define x mcnlx
#define y mcnly
#define z mcnlz
#define vx mcnlvx
#define vy mcnlvy
#define vz mcnlvz
#define t mcnlt
#define sx mcnlsx
#define sy mcnlsy
#define sz mcnlsz
#define p mcnlp

#define mcabsorbComp mcabsorbCompchannel_19_analyzer_2_array_crystal_array_1
  STORE_NEUTRON(864,
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp);
  mcScattered=0;
  mcRestore=0;
  mcNCounter[864]++;
  mcPCounter[864] += p;
  mcP2Counter[864] += p*p;
#define mccompcurname  channel_19_analyzer_2_array_crystal_array_1
#define mccompcurtype  Union_box
#define mccompcurindex 864
#define loop_index mccchannel_19_analyzer_2_array_crystal_array_1_loop_index
#define this_box_volume mccchannel_19_analyzer_2_array_crystal_array_1_this_box_volume
#define global_geometry_element mccchannel_19_analyzer_2_array_crystal_array_1_global_geometry_element
#define this_box_storage mccchannel_19_analyzer_2_array_crystal_array_1_this_box_storage
{   /* Declarations of channel_19_analyzer_2_array_crystal_array_1=Union_box() SETTING parameters. */
char* material_string = mccchannel_19_analyzer_2_array_crystal_array_1_material_string;
MCNUM priority = mccchannel_19_analyzer_2_array_crystal_array_1_priority;
MCNUM xwidth = mccchannel_19_analyzer_2_array_crystal_array_1_xwidth;
MCNUM yheight = mccchannel_19_analyzer_2_array_crystal_array_1_yheight;
MCNUM zdepth = mccchannel_19_analyzer_2_array_crystal_array_1_zdepth;
MCNUM xwidth2 = mccchannel_19_analyzer_2_array_crystal_array_1_xwidth2;
MCNUM yheight2 = mccchannel_19_analyzer_2_array_crystal_array_1_yheight2;
MCNUM visualize = mccchannel_19_analyzer_2_array_crystal_array_1_visualize;
int target_index = mccchannel_19_analyzer_2_array_crystal_array_1_target_index;
MCNUM target_x = mccchannel_19_analyzer_2_array_crystal_array_1_target_x;
MCNUM target_y = mccchannel_19_analyzer_2_array_crystal_array_1_target_y;
MCNUM target_z = mccchannel_19_analyzer_2_array_crystal_array_1_target_z;
MCNUM focus_aw = mccchannel_19_analyzer_2_array_crystal_array_1_focus_aw;
MCNUM focus_ah = mccchannel_19_analyzer_2_array_crystal_array_1_focus_ah;
MCNUM focus_xw = mccchannel_19_analyzer_2_array_crystal_array_1_focus_xw;
MCNUM focus_xh = mccchannel_19_analyzer_2_array_crystal_array_1_focus_xh;
MCNUM focus_r = mccchannel_19_analyzer_2_array_crystal_array_1_focus_r;
MCNUM p_interact = mccchannel_19_analyzer_2_array_crystal_array_1_p_interact;
char* mask_string = mccchannel_19_analyzer_2_array_crystal_array_1_mask_string;
char* mask_setting = mccchannel_19_analyzer_2_array_crystal_array_1_mask_setting;
MCNUM number_of_activations = mccchannel_19_analyzer_2_array_crystal_array_1_number_of_activations;
}   /* End of channel_19_analyzer_2_array_crystal_array_1=Union_box() SETTING parameter declarations. */
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex
  /* Label for restoring  neutron */
  mcabsorbCompchannel_19_analyzer_2_array_crystal_array_1:
  if (RESTORE) /* restore if needed */
  { RESTORE_NEUTRON(864,
      mcnlx,
      mcnly,
      mcnlz,
      mcnlvx,
      mcnlvy,
      mcnlvz,
      mcnlt,
      mcnlsx,
      mcnlsy,
      mcnlsz,
      mcnlp); }
#undef mcabsorbComp
#undef p
#undef sz
#undef sy
#undef sx
#undef t
#undef vz
#undef vy
#undef vx
#undef z
#undef y
#undef x
  mcDEBUG_STATE(
mcnlx,
mcnly,
mcnlz,
mcnlvx,
mcnlvy,
mcnlvz,
mcnlt,
mcnlsx,
mcnlsy,
mcnlsz,
mcnlp)

  /* TRACE Component channel_19_analyzer_2_array_crystal_array_2 [865] */
  mccoordschange(mcposrchannel_19_analyzer_2_array_crystal_array_2, mcrotrchannel_19_analyzer_2_array_crystal_array_2,
    &mcnlx,
    &mcnly,
    &mcnlz,
    &mcnlvx,
    &mcnlvy,
    &mcnlvz,
    &mcnlsx,
    &mcnlsy,
    &mcnlsz);
  /* define label inside component channel_19_analyzer_2_array_crystal_array_2 (without coords transformations) */
  mcJumpTrace_channel_19_analyzer_2_array_crystal_array_2:
  SIG_MESSAGE("channel_19_analyzer_2_array_crystal_array_2 (Trace)");
  mcDEBUG_COMP("channel_19_analyzer_2_array_crystal_array_2")
  mcDEBUG_STATE(
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp)
#define x mcnlx
#define y mcnly
#define z mcnlz
#define vx mcnlvx
#define vy mcnlvy
#define vz mcnlvz
#define t mcnlt
#define sx mcnlsx
#define sy mcnlsy
#define sz mcnlsz
#define p mcnlp

#define mcabsorbComp mcabsorbCompchannel_19_analyzer_2_array_crystal_array_2
  STORE_NEUTRON(865,
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp);
  mcScattered=0;
  mcRestore=0;
  mcNCounter[865]++;
  mcPCounter[865] += p;
  mcP2Counter[865] += p*p;
#define mccompcurname  channel_19_analyzer_2_array_crystal_array_2
#define mccompcurtype  Union_box
#define mccompcurindex 865
#define loop_index mccchannel_19_analyzer_2_array_crystal_array_2_loop_index
#define this_box_volume mccchannel_19_analyzer_2_array_crystal_array_2_this_box_volume
#define global_geometry_element mccchannel_19_analyzer_2_array_crystal_array_2_global_geometry_element
#define this_box_storage mccchannel_19_analyzer_2_array_crystal_array_2_this_box_storage
{   /* Declarations of channel_19_analyzer_2_array_crystal_array_2=Union_box() SETTING parameters. */
char* material_string = mccchannel_19_analyzer_2_array_crystal_array_2_material_string;
MCNUM priority = mccchannel_19_analyzer_2_array_crystal_array_2_priority;
MCNUM xwidth = mccchannel_19_analyzer_2_array_crystal_array_2_xwidth;
MCNUM yheight = mccchannel_19_analyzer_2_array_crystal_array_2_yheight;
MCNUM zdepth = mccchannel_19_analyzer_2_array_crystal_array_2_zdepth;
MCNUM xwidth2 = mccchannel_19_analyzer_2_array_crystal_array_2_xwidth2;
MCNUM yheight2 = mccchannel_19_analyzer_2_array_crystal_array_2_yheight2;
MCNUM visualize = mccchannel_19_analyzer_2_array_crystal_array_2_visualize;
int target_index = mccchannel_19_analyzer_2_array_crystal_array_2_target_index;
MCNUM target_x = mccchannel_19_analyzer_2_array_crystal_array_2_target_x;
MCNUM target_y = mccchannel_19_analyzer_2_array_crystal_array_2_target_y;
MCNUM target_z = mccchannel_19_analyzer_2_array_crystal_array_2_target_z;
MCNUM focus_aw = mccchannel_19_analyzer_2_array_crystal_array_2_focus_aw;
MCNUM focus_ah = mccchannel_19_analyzer_2_array_crystal_array_2_focus_ah;
MCNUM focus_xw = mccchannel_19_analyzer_2_array_crystal_array_2_focus_xw;
MCNUM focus_xh = mccchannel_19_analyzer_2_array_crystal_array_2_focus_xh;
MCNUM focus_r = mccchannel_19_analyzer_2_array_crystal_array_2_focus_r;
MCNUM p_interact = mccchannel_19_analyzer_2_array_crystal_array_2_p_interact;
char* mask_string = mccchannel_19_analyzer_2_array_crystal_array_2_mask_string;
char* mask_setting = mccchannel_19_analyzer_2_array_crystal_array_2_mask_setting;
MCNUM number_of_activations = mccchannel_19_analyzer_2_array_crystal_array_2_number_of_activations;
}   /* End of channel_19_analyzer_2_array_crystal_array_2=Union_box() SETTING parameter declarations. */
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex
  /* Label for restoring  neutron */
  mcabsorbCompchannel_19_analyzer_2_array_crystal_array_2:
  if (RESTORE) /* restore if needed */
  { RESTORE_NEUTRON(865,
      mcnlx,
      mcnly,
      mcnlz,
      mcnlvx,
      mcnlvy,
      mcnlvz,
      mcnlt,
      mcnlsx,
      mcnlsy,
      mcnlsz,
      mcnlp); }
#undef mcabsorbComp
#undef p
#undef sz
#undef sy
#undef sx
#undef t
#undef vz
#undef vy
#undef vx
#undef z
#undef y
#undef x
  mcDEBUG_STATE(
mcnlx,
mcnly,
mcnlz,
mcnlvx,
mcnlvy,
mcnlvz,
mcnlt,
mcnlsx,
mcnlsy,
mcnlsz,
mcnlp)

  /* TRACE Component channel_19_analyzer_2_array_crystal_array_3 [866] */
  mccoordschange(mcposrchannel_19_analyzer_2_array_crystal_array_3, mcrotrchannel_19_analyzer_2_array_crystal_array_3,
    &mcnlx,
    &mcnly,
    &mcnlz,
    &mcnlvx,
    &mcnlvy,
    &mcnlvz,
    &mcnlsx,
    &mcnlsy,
    &mcnlsz);
  /* define label inside component channel_19_analyzer_2_array_crystal_array_3 (without coords transformations) */
  mcJumpTrace_channel_19_analyzer_2_array_crystal_array_3:
  SIG_MESSAGE("channel_19_analyzer_2_array_crystal_array_3 (Trace)");
  mcDEBUG_COMP("channel_19_analyzer_2_array_crystal_array_3")
  mcDEBUG_STATE(
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp)
#define x mcnlx
#define y mcnly
#define z mcnlz
#define vx mcnlvx
#define vy mcnlvy
#define vz mcnlvz
#define t mcnlt
#define sx mcnlsx
#define sy mcnlsy
#define sz mcnlsz
#define p mcnlp

#define mcabsorbComp mcabsorbCompchannel_19_analyzer_2_array_crystal_array_3
  STORE_NEUTRON(866,
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp);
  mcScattered=0;
  mcRestore=0;
  mcNCounter[866]++;
  mcPCounter[866] += p;
  mcP2Counter[866] += p*p;
#define mccompcurname  channel_19_analyzer_2_array_crystal_array_3
#define mccompcurtype  Union_box
#define mccompcurindex 866
#define loop_index mccchannel_19_analyzer_2_array_crystal_array_3_loop_index
#define this_box_volume mccchannel_19_analyzer_2_array_crystal_array_3_this_box_volume
#define global_geometry_element mccchannel_19_analyzer_2_array_crystal_array_3_global_geometry_element
#define this_box_storage mccchannel_19_analyzer_2_array_crystal_array_3_this_box_storage
{   /* Declarations of channel_19_analyzer_2_array_crystal_array_3=Union_box() SETTING parameters. */
char* material_string = mccchannel_19_analyzer_2_array_crystal_array_3_material_string;
MCNUM priority = mccchannel_19_analyzer_2_array_crystal_array_3_priority;
MCNUM xwidth = mccchannel_19_analyzer_2_array_crystal_array_3_xwidth;
MCNUM yheight = mccchannel_19_analyzer_2_array_crystal_array_3_yheight;
MCNUM zdepth = mccchannel_19_analyzer_2_array_crystal_array_3_zdepth;
MCNUM xwidth2 = mccchannel_19_analyzer_2_array_crystal_array_3_xwidth2;
MCNUM yheight2 = mccchannel_19_analyzer_2_array_crystal_array_3_yheight2;
MCNUM visualize = mccchannel_19_analyzer_2_array_crystal_array_3_visualize;
int target_index = mccchannel_19_analyzer_2_array_crystal_array_3_target_index;
MCNUM target_x = mccchannel_19_analyzer_2_array_crystal_array_3_target_x;
MCNUM target_y = mccchannel_19_analyzer_2_array_crystal_array_3_target_y;
MCNUM target_z = mccchannel_19_analyzer_2_array_crystal_array_3_target_z;
MCNUM focus_aw = mccchannel_19_analyzer_2_array_crystal_array_3_focus_aw;
MCNUM focus_ah = mccchannel_19_analyzer_2_array_crystal_array_3_focus_ah;
MCNUM focus_xw = mccchannel_19_analyzer_2_array_crystal_array_3_focus_xw;
MCNUM focus_xh = mccchannel_19_analyzer_2_array_crystal_array_3_focus_xh;
MCNUM focus_r = mccchannel_19_analyzer_2_array_crystal_array_3_focus_r;
MCNUM p_interact = mccchannel_19_analyzer_2_array_crystal_array_3_p_interact;
char* mask_string = mccchannel_19_analyzer_2_array_crystal_array_3_mask_string;
char* mask_setting = mccchannel_19_analyzer_2_array_crystal_array_3_mask_setting;
MCNUM number_of_activations = mccchannel_19_analyzer_2_array_crystal_array_3_number_of_activations;
}   /* End of channel_19_analyzer_2_array_crystal_array_3=Union_box() SETTING parameter declarations. */
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex
  /* Label for restoring  neutron */
  mcabsorbCompchannel_19_analyzer_2_array_crystal_array_3:
  if (RESTORE) /* restore if needed */
  { RESTORE_NEUTRON(866,
      mcnlx,
      mcnly,
      mcnlz,
      mcnlvx,
      mcnlvy,
      mcnlvz,
      mcnlt,
      mcnlsx,
      mcnlsy,
      mcnlsz,
      mcnlp); }
#undef mcabsorbComp
#undef p
#undef sz
#undef sy
#undef sx
#undef t
#undef vz
#undef vy
#undef vx
#undef z
#undef y
#undef x
  mcDEBUG_STATE(
mcnlx,
mcnly,
mcnlz,
mcnlvx,
mcnlvy,
mcnlvz,
mcnlt,
mcnlsx,
mcnlsy,
mcnlsz,
mcnlp)

  /* TRACE Component channel_19_analyzer_2_array_crystal_array_4 [867] */
  mccoordschange(mcposrchannel_19_analyzer_2_array_crystal_array_4, mcrotrchannel_19_analyzer_2_array_crystal_array_4,
    &mcnlx,
    &mcnly,
    &mcnlz,
    &mcnlvx,
    &mcnlvy,
    &mcnlvz,
    &mcnlsx,
    &mcnlsy,
    &mcnlsz);
  /* define label inside component channel_19_analyzer_2_array_crystal_array_4 (without coords transformations) */
  mcJumpTrace_channel_19_analyzer_2_array_crystal_array_4:
  SIG_MESSAGE("channel_19_analyzer_2_array_crystal_array_4 (Trace)");
  mcDEBUG_COMP("channel_19_analyzer_2_array_crystal_array_4")
  mcDEBUG_STATE(
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp)
#define x mcnlx
#define y mcnly
#define z mcnlz
#define vx mcnlvx
#define vy mcnlvy
#define vz mcnlvz
#define t mcnlt
#define sx mcnlsx
#define sy mcnlsy
#define sz mcnlsz
#define p mcnlp

#define mcabsorbComp mcabsorbCompchannel_19_analyzer_2_array_crystal_array_4
  STORE_NEUTRON(867,
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp);
  mcScattered=0;
  mcRestore=0;
  mcNCounter[867]++;
  mcPCounter[867] += p;
  mcP2Counter[867] += p*p;
#define mccompcurname  channel_19_analyzer_2_array_crystal_array_4
#define mccompcurtype  Union_box
#define mccompcurindex 867
#define loop_index mccchannel_19_analyzer_2_array_crystal_array_4_loop_index
#define this_box_volume mccchannel_19_analyzer_2_array_crystal_array_4_this_box_volume
#define global_geometry_element mccchannel_19_analyzer_2_array_crystal_array_4_global_geometry_element
#define this_box_storage mccchannel_19_analyzer_2_array_crystal_array_4_this_box_storage
{   /* Declarations of channel_19_analyzer_2_array_crystal_array_4=Union_box() SETTING parameters. */
char* material_string = mccchannel_19_analyzer_2_array_crystal_array_4_material_string;
MCNUM priority = mccchannel_19_analyzer_2_array_crystal_array_4_priority;
MCNUM xwidth = mccchannel_19_analyzer_2_array_crystal_array_4_xwidth;
MCNUM yheight = mccchannel_19_analyzer_2_array_crystal_array_4_yheight;
MCNUM zdepth = mccchannel_19_analyzer_2_array_crystal_array_4_zdepth;
MCNUM xwidth2 = mccchannel_19_analyzer_2_array_crystal_array_4_xwidth2;
MCNUM yheight2 = mccchannel_19_analyzer_2_array_crystal_array_4_yheight2;
MCNUM visualize = mccchannel_19_analyzer_2_array_crystal_array_4_visualize;
int target_index = mccchannel_19_analyzer_2_array_crystal_array_4_target_index;
MCNUM target_x = mccchannel_19_analyzer_2_array_crystal_array_4_target_x;
MCNUM target_y = mccchannel_19_analyzer_2_array_crystal_array_4_target_y;
MCNUM target_z = mccchannel_19_analyzer_2_array_crystal_array_4_target_z;
MCNUM focus_aw = mccchannel_19_analyzer_2_array_crystal_array_4_focus_aw;
MCNUM focus_ah = mccchannel_19_analyzer_2_array_crystal_array_4_focus_ah;
MCNUM focus_xw = mccchannel_19_analyzer_2_array_crystal_array_4_focus_xw;
MCNUM focus_xh = mccchannel_19_analyzer_2_array_crystal_array_4_focus_xh;
MCNUM focus_r = mccchannel_19_analyzer_2_array_crystal_array_4_focus_r;
MCNUM p_interact = mccchannel_19_analyzer_2_array_crystal_array_4_p_interact;
char* mask_string = mccchannel_19_analyzer_2_array_crystal_array_4_mask_string;
char* mask_setting = mccchannel_19_analyzer_2_array_crystal_array_4_mask_setting;
MCNUM number_of_activations = mccchannel_19_analyzer_2_array_crystal_array_4_number_of_activations;
}   /* End of channel_19_analyzer_2_array_crystal_array_4=Union_box() SETTING parameter declarations. */
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex
  /* Label for restoring  neutron */
  mcabsorbCompchannel_19_analyzer_2_array_crystal_array_4:
  if (RESTORE) /* restore if needed */
  { RESTORE_NEUTRON(867,
      mcnlx,
      mcnly,
      mcnlz,
      mcnlvx,
      mcnlvy,
      mcnlvz,
      mcnlt,
      mcnlsx,
      mcnlsy,
      mcnlsz,
      mcnlp); }
#undef mcabsorbComp
#undef p
#undef sz
#undef sy
#undef sx
#undef t
#undef vz
#undef vy
#undef vx
#undef z
#undef y
#undef x
  mcDEBUG_STATE(
mcnlx,
mcnly,
mcnlz,
mcnlvx,
mcnlvy,
mcnlvz,
mcnlt,
mcnlsx,
mcnlsy,
mcnlsz,
mcnlp)

  /* TRACE Component channel_19_analyzer_2_array_crystal_array_5 [868] */
  mccoordschange(mcposrchannel_19_analyzer_2_array_crystal_array_5, mcrotrchannel_19_analyzer_2_array_crystal_array_5,
    &mcnlx,
    &mcnly,
    &mcnlz,
    &mcnlvx,
    &mcnlvy,
    &mcnlvz,
    &mcnlsx,
    &mcnlsy,
    &mcnlsz);
  /* define label inside component channel_19_analyzer_2_array_crystal_array_5 (without coords transformations) */
  mcJumpTrace_channel_19_analyzer_2_array_crystal_array_5:
  SIG_MESSAGE("channel_19_analyzer_2_array_crystal_array_5 (Trace)");
  mcDEBUG_COMP("channel_19_analyzer_2_array_crystal_array_5")
  mcDEBUG_STATE(
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp)
#define x mcnlx
#define y mcnly
#define z mcnlz
#define vx mcnlvx
#define vy mcnlvy
#define vz mcnlvz
#define t mcnlt
#define sx mcnlsx
#define sy mcnlsy
#define sz mcnlsz
#define p mcnlp

#define mcabsorbComp mcabsorbCompchannel_19_analyzer_2_array_crystal_array_5
  STORE_NEUTRON(868,
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp);
  mcScattered=0;
  mcRestore=0;
  mcNCounter[868]++;
  mcPCounter[868] += p;
  mcP2Counter[868] += p*p;
#define mccompcurname  channel_19_analyzer_2_array_crystal_array_5
#define mccompcurtype  Union_box
#define mccompcurindex 868
#define loop_index mccchannel_19_analyzer_2_array_crystal_array_5_loop_index
#define this_box_volume mccchannel_19_analyzer_2_array_crystal_array_5_this_box_volume
#define global_geometry_element mccchannel_19_analyzer_2_array_crystal_array_5_global_geometry_element
#define this_box_storage mccchannel_19_analyzer_2_array_crystal_array_5_this_box_storage
{   /* Declarations of channel_19_analyzer_2_array_crystal_array_5=Union_box() SETTING parameters. */
char* material_string = mccchannel_19_analyzer_2_array_crystal_array_5_material_string;
MCNUM priority = mccchannel_19_analyzer_2_array_crystal_array_5_priority;
MCNUM xwidth = mccchannel_19_analyzer_2_array_crystal_array_5_xwidth;
MCNUM yheight = mccchannel_19_analyzer_2_array_crystal_array_5_yheight;
MCNUM zdepth = mccchannel_19_analyzer_2_array_crystal_array_5_zdepth;
MCNUM xwidth2 = mccchannel_19_analyzer_2_array_crystal_array_5_xwidth2;
MCNUM yheight2 = mccchannel_19_analyzer_2_array_crystal_array_5_yheight2;
MCNUM visualize = mccchannel_19_analyzer_2_array_crystal_array_5_visualize;
int target_index = mccchannel_19_analyzer_2_array_crystal_array_5_target_index;
MCNUM target_x = mccchannel_19_analyzer_2_array_crystal_array_5_target_x;
MCNUM target_y = mccchannel_19_analyzer_2_array_crystal_array_5_target_y;
MCNUM target_z = mccchannel_19_analyzer_2_array_crystal_array_5_target_z;
MCNUM focus_aw = mccchannel_19_analyzer_2_array_crystal_array_5_focus_aw;
MCNUM focus_ah = mccchannel_19_analyzer_2_array_crystal_array_5_focus_ah;
MCNUM focus_xw = mccchannel_19_analyzer_2_array_crystal_array_5_focus_xw;
MCNUM focus_xh = mccchannel_19_analyzer_2_array_crystal_array_5_focus_xh;
MCNUM focus_r = mccchannel_19_analyzer_2_array_crystal_array_5_focus_r;
MCNUM p_interact = mccchannel_19_analyzer_2_array_crystal_array_5_p_interact;
char* mask_string = mccchannel_19_analyzer_2_array_crystal_array_5_mask_string;
char* mask_setting = mccchannel_19_analyzer_2_array_crystal_array_5_mask_setting;
MCNUM number_of_activations = mccchannel_19_analyzer_2_array_crystal_array_5_number_of_activations;
}   /* End of channel_19_analyzer_2_array_crystal_array_5=Union_box() SETTING parameter declarations. */
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex
  /* Label for restoring  neutron */
  mcabsorbCompchannel_19_analyzer_2_array_crystal_array_5:
  if (RESTORE) /* restore if needed */
  { RESTORE_NEUTRON(868,
      mcnlx,
      mcnly,
      mcnlz,
      mcnlvx,
      mcnlvy,
      mcnlvz,
      mcnlt,
      mcnlsx,
      mcnlsy,
      mcnlsz,
      mcnlp); }
#undef mcabsorbComp
#undef p
#undef sz
#undef sy
#undef sx
#undef t
#undef vz
#undef vy
#undef vx
#undef z
#undef y
#undef x
  mcDEBUG_STATE(
mcnlx,
mcnly,
mcnlz,
mcnlvx,
mcnlvy,
mcnlvz,
mcnlt,
mcnlsx,
mcnlsy,
mcnlsz,
mcnlp)

  /* TRACE Component channel_19_analyzer_2_array_crystal_array_6 [869] */
  mccoordschange(mcposrchannel_19_analyzer_2_array_crystal_array_6, mcrotrchannel_19_analyzer_2_array_crystal_array_6,
    &mcnlx,
    &mcnly,
    &mcnlz,
    &mcnlvx,
    &mcnlvy,
    &mcnlvz,
    &mcnlsx,
    &mcnlsy,
    &mcnlsz);
  /* define label inside component channel_19_analyzer_2_array_crystal_array_6 (without coords transformations) */
  mcJumpTrace_channel_19_analyzer_2_array_crystal_array_6:
  SIG_MESSAGE("channel_19_analyzer_2_array_crystal_array_6 (Trace)");
  mcDEBUG_COMP("channel_19_analyzer_2_array_crystal_array_6")
  mcDEBUG_STATE(
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp)
#define x mcnlx
#define y mcnly
#define z mcnlz
#define vx mcnlvx
#define vy mcnlvy
#define vz mcnlvz
#define t mcnlt
#define sx mcnlsx
#define sy mcnlsy
#define sz mcnlsz
#define p mcnlp

#define mcabsorbComp mcabsorbCompchannel_19_analyzer_2_array_crystal_array_6
  STORE_NEUTRON(869,
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp);
  mcScattered=0;
  mcRestore=0;
  mcNCounter[869]++;
  mcPCounter[869] += p;
  mcP2Counter[869] += p*p;
#define mccompcurname  channel_19_analyzer_2_array_crystal_array_6
#define mccompcurtype  Union_box
#define mccompcurindex 869
#define loop_index mccchannel_19_analyzer_2_array_crystal_array_6_loop_index
#define this_box_volume mccchannel_19_analyzer_2_array_crystal_array_6_this_box_volume
#define global_geometry_element mccchannel_19_analyzer_2_array_crystal_array_6_global_geometry_element
#define this_box_storage mccchannel_19_analyzer_2_array_crystal_array_6_this_box_storage
{   /* Declarations of channel_19_analyzer_2_array_crystal_array_6=Union_box() SETTING parameters. */
char* material_string = mccchannel_19_analyzer_2_array_crystal_array_6_material_string;
MCNUM priority = mccchannel_19_analyzer_2_array_crystal_array_6_priority;
MCNUM xwidth = mccchannel_19_analyzer_2_array_crystal_array_6_xwidth;
MCNUM yheight = mccchannel_19_analyzer_2_array_crystal_array_6_yheight;
MCNUM zdepth = mccchannel_19_analyzer_2_array_crystal_array_6_zdepth;
MCNUM xwidth2 = mccchannel_19_analyzer_2_array_crystal_array_6_xwidth2;
MCNUM yheight2 = mccchannel_19_analyzer_2_array_crystal_array_6_yheight2;
MCNUM visualize = mccchannel_19_analyzer_2_array_crystal_array_6_visualize;
int target_index = mccchannel_19_analyzer_2_array_crystal_array_6_target_index;
MCNUM target_x = mccchannel_19_analyzer_2_array_crystal_array_6_target_x;
MCNUM target_y = mccchannel_19_analyzer_2_array_crystal_array_6_target_y;
MCNUM target_z = mccchannel_19_analyzer_2_array_crystal_array_6_target_z;
MCNUM focus_aw = mccchannel_19_analyzer_2_array_crystal_array_6_focus_aw;
MCNUM focus_ah = mccchannel_19_analyzer_2_array_crystal_array_6_focus_ah;
MCNUM focus_xw = mccchannel_19_analyzer_2_array_crystal_array_6_focus_xw;
MCNUM focus_xh = mccchannel_19_analyzer_2_array_crystal_array_6_focus_xh;
MCNUM focus_r = mccchannel_19_analyzer_2_array_crystal_array_6_focus_r;
MCNUM p_interact = mccchannel_19_analyzer_2_array_crystal_array_6_p_interact;
char* mask_string = mccchannel_19_analyzer_2_array_crystal_array_6_mask_string;
char* mask_setting = mccchannel_19_analyzer_2_array_crystal_array_6_mask_setting;
MCNUM number_of_activations = mccchannel_19_analyzer_2_array_crystal_array_6_number_of_activations;
}   /* End of channel_19_analyzer_2_array_crystal_array_6=Union_box() SETTING parameter declarations. */
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex
  /* Label for restoring  neutron */
  mcabsorbCompchannel_19_analyzer_2_array_crystal_array_6:
  if (RESTORE) /* restore if needed */
  { RESTORE_NEUTRON(869,
      mcnlx,
      mcnly,
      mcnlz,
      mcnlvx,
      mcnlvy,
      mcnlvz,
      mcnlt,
      mcnlsx,
      mcnlsy,
      mcnlsz,
      mcnlp); }
#undef mcabsorbComp
#undef p
#undef sz
#undef sy
#undef sx
#undef t
#undef vz
#undef vy
#undef vx
#undef z
#undef y
#undef x
  mcDEBUG_STATE(
mcnlx,
mcnly,
mcnlz,
mcnlvx,
mcnlvy,
mcnlvz,
mcnlt,
mcnlsx,
mcnlsy,
mcnlsz,
mcnlp)

  /* TRACE Component channel_19_analyzer_2_array_crystal_array_7 [870] */
  mccoordschange(mcposrchannel_19_analyzer_2_array_crystal_array_7, mcrotrchannel_19_analyzer_2_array_crystal_array_7,
    &mcnlx,
    &mcnly,
    &mcnlz,
    &mcnlvx,
    &mcnlvy,
    &mcnlvz,
    &mcnlsx,
    &mcnlsy,
    &mcnlsz);
  /* define label inside component channel_19_analyzer_2_array_crystal_array_7 (without coords transformations) */
  mcJumpTrace_channel_19_analyzer_2_array_crystal_array_7:
  SIG_MESSAGE("channel_19_analyzer_2_array_crystal_array_7 (Trace)");
  mcDEBUG_COMP("channel_19_analyzer_2_array_crystal_array_7")
  mcDEBUG_STATE(
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp)
#define x mcnlx
#define y mcnly
#define z mcnlz
#define vx mcnlvx
#define vy mcnlvy
#define vz mcnlvz
#define t mcnlt
#define sx mcnlsx
#define sy mcnlsy
#define sz mcnlsz
#define p mcnlp

#define mcabsorbComp mcabsorbCompchannel_19_analyzer_2_array_crystal_array_7
  STORE_NEUTRON(870,
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp);
  mcScattered=0;
  mcRestore=0;
  mcNCounter[870]++;
  mcPCounter[870] += p;
  mcP2Counter[870] += p*p;
#define mccompcurname  channel_19_analyzer_2_array_crystal_array_7
#define mccompcurtype  Union_box
#define mccompcurindex 870
#define loop_index mccchannel_19_analyzer_2_array_crystal_array_7_loop_index
#define this_box_volume mccchannel_19_analyzer_2_array_crystal_array_7_this_box_volume
#define global_geometry_element mccchannel_19_analyzer_2_array_crystal_array_7_global_geometry_element
#define this_box_storage mccchannel_19_analyzer_2_array_crystal_array_7_this_box_storage
{   /* Declarations of channel_19_analyzer_2_array_crystal_array_7=Union_box() SETTING parameters. */
char* material_string = mccchannel_19_analyzer_2_array_crystal_array_7_material_string;
MCNUM priority = mccchannel_19_analyzer_2_array_crystal_array_7_priority;
MCNUM xwidth = mccchannel_19_analyzer_2_array_crystal_array_7_xwidth;
MCNUM yheight = mccchannel_19_analyzer_2_array_crystal_array_7_yheight;
MCNUM zdepth = mccchannel_19_analyzer_2_array_crystal_array_7_zdepth;
MCNUM xwidth2 = mccchannel_19_analyzer_2_array_crystal_array_7_xwidth2;
MCNUM yheight2 = mccchannel_19_analyzer_2_array_crystal_array_7_yheight2;
MCNUM visualize = mccchannel_19_analyzer_2_array_crystal_array_7_visualize;
int target_index = mccchannel_19_analyzer_2_array_crystal_array_7_target_index;
MCNUM target_x = mccchannel_19_analyzer_2_array_crystal_array_7_target_x;
MCNUM target_y = mccchannel_19_analyzer_2_array_crystal_array_7_target_y;
MCNUM target_z = mccchannel_19_analyzer_2_array_crystal_array_7_target_z;
MCNUM focus_aw = mccchannel_19_analyzer_2_array_crystal_array_7_focus_aw;
MCNUM focus_ah = mccchannel_19_analyzer_2_array_crystal_array_7_focus_ah;
MCNUM focus_xw = mccchannel_19_analyzer_2_array_crystal_array_7_focus_xw;
MCNUM focus_xh = mccchannel_19_analyzer_2_array_crystal_array_7_focus_xh;
MCNUM focus_r = mccchannel_19_analyzer_2_array_crystal_array_7_focus_r;
MCNUM p_interact = mccchannel_19_analyzer_2_array_crystal_array_7_p_interact;
char* mask_string = mccchannel_19_analyzer_2_array_crystal_array_7_mask_string;
char* mask_setting = mccchannel_19_analyzer_2_array_crystal_array_7_mask_setting;
MCNUM number_of_activations = mccchannel_19_analyzer_2_array_crystal_array_7_number_of_activations;
}   /* End of channel_19_analyzer_2_array_crystal_array_7=Union_box() SETTING parameter declarations. */
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex
  /* Label for restoring  neutron */
  mcabsorbCompchannel_19_analyzer_2_array_crystal_array_7:
  if (RESTORE) /* restore if needed */
  { RESTORE_NEUTRON(870,
      mcnlx,
      mcnly,
      mcnlz,
      mcnlvx,
      mcnlvy,
      mcnlvz,
      mcnlt,
      mcnlsx,
      mcnlsy,
      mcnlsz,
      mcnlp); }
#undef mcabsorbComp
#undef p
#undef sz
#undef sy
#undef sx
#undef t
#undef vz
#undef vy
#undef vx
#undef z
#undef y
#undef x
  mcDEBUG_STATE(
mcnlx,
mcnly,
mcnlz,
mcnlvx,
mcnlvy,
mcnlvz,
mcnlt,
mcnlsx,
mcnlsy,
mcnlsz,
mcnlp)

  /* TRACE Component channel_19_analyzer_2_array_crystal_array_8 [871] */
  mccoordschange(mcposrchannel_19_analyzer_2_array_crystal_array_8, mcrotrchannel_19_analyzer_2_array_crystal_array_8,
    &mcnlx,
    &mcnly,
    &mcnlz,
    &mcnlvx,
    &mcnlvy,
    &mcnlvz,
    &mcnlsx,
    &mcnlsy,
    &mcnlsz);
  /* define label inside component channel_19_analyzer_2_array_crystal_array_8 (without coords transformations) */
  mcJumpTrace_channel_19_analyzer_2_array_crystal_array_8:
  SIG_MESSAGE("channel_19_analyzer_2_array_crystal_array_8 (Trace)");
  mcDEBUG_COMP("channel_19_analyzer_2_array_crystal_array_8")
  mcDEBUG_STATE(
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp)
#define x mcnlx
#define y mcnly
#define z mcnlz
#define vx mcnlvx
#define vy mcnlvy
#define vz mcnlvz
#define t mcnlt
#define sx mcnlsx
#define sy mcnlsy
#define sz mcnlsz
#define p mcnlp

#define mcabsorbComp mcabsorbCompchannel_19_analyzer_2_array_crystal_array_8
  STORE_NEUTRON(871,
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp);
  mcScattered=0;
  mcRestore=0;
  mcNCounter[871]++;
  mcPCounter[871] += p;
  mcP2Counter[871] += p*p;
#define mccompcurname  channel_19_analyzer_2_array_crystal_array_8
#define mccompcurtype  Union_box
#define mccompcurindex 871
#define loop_index mccchannel_19_analyzer_2_array_crystal_array_8_loop_index
#define this_box_volume mccchannel_19_analyzer_2_array_crystal_array_8_this_box_volume
#define global_geometry_element mccchannel_19_analyzer_2_array_crystal_array_8_global_geometry_element
#define this_box_storage mccchannel_19_analyzer_2_array_crystal_array_8_this_box_storage
{   /* Declarations of channel_19_analyzer_2_array_crystal_array_8=Union_box() SETTING parameters. */
char* material_string = mccchannel_19_analyzer_2_array_crystal_array_8_material_string;
MCNUM priority = mccchannel_19_analyzer_2_array_crystal_array_8_priority;
MCNUM xwidth = mccchannel_19_analyzer_2_array_crystal_array_8_xwidth;
MCNUM yheight = mccchannel_19_analyzer_2_array_crystal_array_8_yheight;
MCNUM zdepth = mccchannel_19_analyzer_2_array_crystal_array_8_zdepth;
MCNUM xwidth2 = mccchannel_19_analyzer_2_array_crystal_array_8_xwidth2;
MCNUM yheight2 = mccchannel_19_analyzer_2_array_crystal_array_8_yheight2;
MCNUM visualize = mccchannel_19_analyzer_2_array_crystal_array_8_visualize;
int target_index = mccchannel_19_analyzer_2_array_crystal_array_8_target_index;
MCNUM target_x = mccchannel_19_analyzer_2_array_crystal_array_8_target_x;
MCNUM target_y = mccchannel_19_analyzer_2_array_crystal_array_8_target_y;
MCNUM target_z = mccchannel_19_analyzer_2_array_crystal_array_8_target_z;
MCNUM focus_aw = mccchannel_19_analyzer_2_array_crystal_array_8_focus_aw;
MCNUM focus_ah = mccchannel_19_analyzer_2_array_crystal_array_8_focus_ah;
MCNUM focus_xw = mccchannel_19_analyzer_2_array_crystal_array_8_focus_xw;
MCNUM focus_xh = mccchannel_19_analyzer_2_array_crystal_array_8_focus_xh;
MCNUM focus_r = mccchannel_19_analyzer_2_array_crystal_array_8_focus_r;
MCNUM p_interact = mccchannel_19_analyzer_2_array_crystal_array_8_p_interact;
char* mask_string = mccchannel_19_analyzer_2_array_crystal_array_8_mask_string;
char* mask_setting = mccchannel_19_analyzer_2_array_crystal_array_8_mask_setting;
MCNUM number_of_activations = mccchannel_19_analyzer_2_array_crystal_array_8_number_of_activations;
}   /* End of channel_19_analyzer_2_array_crystal_array_8=Union_box() SETTING parameter declarations. */
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex
  /* Label for restoring  neutron */
  mcabsorbCompchannel_19_analyzer_2_array_crystal_array_8:
  if (RESTORE) /* restore if needed */
  { RESTORE_NEUTRON(871,
      mcnlx,
      mcnly,
      mcnlz,
      mcnlvx,
      mcnlvy,
      mcnlvz,
      mcnlt,
      mcnlsx,
      mcnlsy,
      mcnlsz,
      mcnlp); }
#undef mcabsorbComp
#undef p
#undef sz
#undef sy
#undef sx
#undef t
#undef vz
#undef vy
#undef vx
#undef z
#undef y
#undef x
  mcDEBUG_STATE(
mcnlx,
mcnly,
mcnlz,
mcnlvx,
mcnlvy,
mcnlvz,
mcnlt,
mcnlsx,
mcnlsy,
mcnlsz,
mcnlp)

  /* TRACE Component channel_19_cave2_cyl1 [872] */
  mccoordschange(mcposrchannel_19_cave2_cyl1, mcrotrchannel_19_cave2_cyl1,
    &mcnlx,
    &mcnly,
    &mcnlz,
    &mcnlvx,
    &mcnlvy,
    &mcnlvz,
    &mcnlsx,
    &mcnlsy,
    &mcnlsz);
  /* define label inside component channel_19_cave2_cyl1 (without coords transformations) */
  mcJumpTrace_channel_19_cave2_cyl1:
  SIG_MESSAGE("channel_19_cave2_cyl1 (Trace)");
  mcDEBUG_COMP("channel_19_cave2_cyl1")
  mcDEBUG_STATE(
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp)
#define x mcnlx
#define y mcnly
#define z mcnlz
#define vx mcnlvx
#define vy mcnlvy
#define vz mcnlvz
#define t mcnlt
#define sx mcnlsx
#define sy mcnlsy
#define sz mcnlsz
#define p mcnlp

#define mcabsorbComp mcabsorbCompchannel_19_cave2_cyl1
  STORE_NEUTRON(872,
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp);
  mcScattered=0;
  mcRestore=0;
  mcNCounter[872]++;
  mcPCounter[872] += p;
  mcP2Counter[872] += p*p;
#define mccompcurname  channel_19_cave2_cyl1
#define mccompcurtype  Union_cylinder
#define mccompcurindex 872
#define loop_index mccchannel_19_cave2_cyl1_loop_index
#define this_cylinder_volume mccchannel_19_cave2_cyl1_this_cylinder_volume
#define global_geometry_element mccchannel_19_cave2_cyl1_global_geometry_element
#define this_cylinder_storage mccchannel_19_cave2_cyl1_this_cylinder_storage
{   /* Declarations of channel_19_cave2_cyl1=Union_cylinder() SETTING parameters. */
char* material_string = mccchannel_19_cave2_cyl1_material_string;
MCNUM priority = mccchannel_19_cave2_cyl1_priority;
MCNUM radius = mccchannel_19_cave2_cyl1_radius;
MCNUM yheight = mccchannel_19_cave2_cyl1_yheight;
MCNUM visualize = mccchannel_19_cave2_cyl1_visualize;
int target_index = mccchannel_19_cave2_cyl1_target_index;
MCNUM target_x = mccchannel_19_cave2_cyl1_target_x;
MCNUM target_y = mccchannel_19_cave2_cyl1_target_y;
MCNUM target_z = mccchannel_19_cave2_cyl1_target_z;
MCNUM focus_aw = mccchannel_19_cave2_cyl1_focus_aw;
MCNUM focus_ah = mccchannel_19_cave2_cyl1_focus_ah;
MCNUM focus_xw = mccchannel_19_cave2_cyl1_focus_xw;
MCNUM focus_xh = mccchannel_19_cave2_cyl1_focus_xh;
MCNUM focus_r = mccchannel_19_cave2_cyl1_focus_r;
MCNUM p_interact = mccchannel_19_cave2_cyl1_p_interact;
char* mask_string = mccchannel_19_cave2_cyl1_mask_string;
char* mask_setting = mccchannel_19_cave2_cyl1_mask_setting;
MCNUM number_of_activations = mccchannel_19_cave2_cyl1_number_of_activations;
#line 345 "Union_cylinder.comp"
{
dummy = 1;
}
#line 459897 "MACS_sample_kidney_box.c"
}   /* End of channel_19_cave2_cyl1=Union_cylinder() SETTING parameter declarations. */
#undef this_cylinder_storage
#undef global_geometry_element
#undef this_cylinder_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex
  /* Label for restoring  neutron */
  mcabsorbCompchannel_19_cave2_cyl1:
  if (RESTORE) /* restore if needed */
  { RESTORE_NEUTRON(872,
      mcnlx,
      mcnly,
      mcnlz,
      mcnlvx,
      mcnlvy,
      mcnlvz,
      mcnlt,
      mcnlsx,
      mcnlsy,
      mcnlsz,
      mcnlp); }
#undef mcabsorbComp
#undef p
#undef sz
#undef sy
#undef sx
#undef t
#undef vz
#undef vy
#undef vx
#undef z
#undef y
#undef x
  mcDEBUG_STATE(
mcnlx,
mcnly,
mcnlz,
mcnlvx,
mcnlvy,
mcnlvz,
mcnlt,
mcnlsx,
mcnlsy,
mcnlsz,
mcnlp)

  /* TRACE Component channel_19_cave2_box1 [873] */
  mccoordschange(mcposrchannel_19_cave2_box1, mcrotrchannel_19_cave2_box1,
    &mcnlx,
    &mcnly,
    &mcnlz,
    &mcnlvx,
    &mcnlvy,
    &mcnlvz,
    &mcnlsx,
    &mcnlsy,
    &mcnlsz);
  /* define label inside component channel_19_cave2_box1 (without coords transformations) */
  mcJumpTrace_channel_19_cave2_box1:
  SIG_MESSAGE("channel_19_cave2_box1 (Trace)");
  mcDEBUG_COMP("channel_19_cave2_box1")
  mcDEBUG_STATE(
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp)
#define x mcnlx
#define y mcnly
#define z mcnlz
#define vx mcnlvx
#define vy mcnlvy
#define vz mcnlvz
#define t mcnlt
#define sx mcnlsx
#define sy mcnlsy
#define sz mcnlsz
#define p mcnlp

#define mcabsorbComp mcabsorbCompchannel_19_cave2_box1
  STORE_NEUTRON(873,
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp);
  mcScattered=0;
  mcRestore=0;
  mcNCounter[873]++;
  mcPCounter[873] += p;
  mcP2Counter[873] += p*p;
#define mccompcurname  channel_19_cave2_box1
#define mccompcurtype  Union_box
#define mccompcurindex 873
#define loop_index mccchannel_19_cave2_box1_loop_index
#define this_box_volume mccchannel_19_cave2_box1_this_box_volume
#define global_geometry_element mccchannel_19_cave2_box1_global_geometry_element
#define this_box_storage mccchannel_19_cave2_box1_this_box_storage
{   /* Declarations of channel_19_cave2_box1=Union_box() SETTING parameters. */
char* material_string = mccchannel_19_cave2_box1_material_string;
MCNUM priority = mccchannel_19_cave2_box1_priority;
MCNUM xwidth = mccchannel_19_cave2_box1_xwidth;
MCNUM yheight = mccchannel_19_cave2_box1_yheight;
MCNUM zdepth = mccchannel_19_cave2_box1_zdepth;
MCNUM xwidth2 = mccchannel_19_cave2_box1_xwidth2;
MCNUM yheight2 = mccchannel_19_cave2_box1_yheight2;
MCNUM visualize = mccchannel_19_cave2_box1_visualize;
int target_index = mccchannel_19_cave2_box1_target_index;
MCNUM target_x = mccchannel_19_cave2_box1_target_x;
MCNUM target_y = mccchannel_19_cave2_box1_target_y;
MCNUM target_z = mccchannel_19_cave2_box1_target_z;
MCNUM focus_aw = mccchannel_19_cave2_box1_focus_aw;
MCNUM focus_ah = mccchannel_19_cave2_box1_focus_ah;
MCNUM focus_xw = mccchannel_19_cave2_box1_focus_xw;
MCNUM focus_xh = mccchannel_19_cave2_box1_focus_xh;
MCNUM focus_r = mccchannel_19_cave2_box1_focus_r;
MCNUM p_interact = mccchannel_19_cave2_box1_p_interact;
char* mask_string = mccchannel_19_cave2_box1_mask_string;
char* mask_setting = mccchannel_19_cave2_box1_mask_setting;
MCNUM number_of_activations = mccchannel_19_cave2_box1_number_of_activations;
}   /* End of channel_19_cave2_box1=Union_box() SETTING parameter declarations. */
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex
  /* Label for restoring  neutron */
  mcabsorbCompchannel_19_cave2_box1:
  if (RESTORE) /* restore if needed */
  { RESTORE_NEUTRON(873,
      mcnlx,
      mcnly,
      mcnlz,
      mcnlvx,
      mcnlvy,
      mcnlvz,
      mcnlt,
      mcnlsx,
      mcnlsy,
      mcnlsz,
      mcnlp); }
#undef mcabsorbComp
#undef p
#undef sz
#undef sy
#undef sx
#undef t
#undef vz
#undef vy
#undef vx
#undef z
#undef y
#undef x
  mcDEBUG_STATE(
mcnlx,
mcnly,
mcnlz,
mcnlvx,
mcnlvy,
mcnlvz,
mcnlt,
mcnlsx,
mcnlsy,
mcnlsz,
mcnlp)

  /* TRACE Component channel_19_cave2_box2 [874] */
  mccoordschange(mcposrchannel_19_cave2_box2, mcrotrchannel_19_cave2_box2,
    &mcnlx,
    &mcnly,
    &mcnlz,
    &mcnlvx,
    &mcnlvy,
    &mcnlvz,
    &mcnlsx,
    &mcnlsy,
    &mcnlsz);
  /* define label inside component channel_19_cave2_box2 (without coords transformations) */
  mcJumpTrace_channel_19_cave2_box2:
  SIG_MESSAGE("channel_19_cave2_box2 (Trace)");
  mcDEBUG_COMP("channel_19_cave2_box2")
  mcDEBUG_STATE(
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp)
#define x mcnlx
#define y mcnly
#define z mcnlz
#define vx mcnlvx
#define vy mcnlvy
#define vz mcnlvz
#define t mcnlt
#define sx mcnlsx
#define sy mcnlsy
#define sz mcnlsz
#define p mcnlp

#define mcabsorbComp mcabsorbCompchannel_19_cave2_box2
  STORE_NEUTRON(874,
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp);
  mcScattered=0;
  mcRestore=0;
  mcNCounter[874]++;
  mcPCounter[874] += p;
  mcP2Counter[874] += p*p;
#define mccompcurname  channel_19_cave2_box2
#define mccompcurtype  Union_box
#define mccompcurindex 874
#define loop_index mccchannel_19_cave2_box2_loop_index
#define this_box_volume mccchannel_19_cave2_box2_this_box_volume
#define global_geometry_element mccchannel_19_cave2_box2_global_geometry_element
#define this_box_storage mccchannel_19_cave2_box2_this_box_storage
{   /* Declarations of channel_19_cave2_box2=Union_box() SETTING parameters. */
char* material_string = mccchannel_19_cave2_box2_material_string;
MCNUM priority = mccchannel_19_cave2_box2_priority;
MCNUM xwidth = mccchannel_19_cave2_box2_xwidth;
MCNUM yheight = mccchannel_19_cave2_box2_yheight;
MCNUM zdepth = mccchannel_19_cave2_box2_zdepth;
MCNUM xwidth2 = mccchannel_19_cave2_box2_xwidth2;
MCNUM yheight2 = mccchannel_19_cave2_box2_yheight2;
MCNUM visualize = mccchannel_19_cave2_box2_visualize;
int target_index = mccchannel_19_cave2_box2_target_index;
MCNUM target_x = mccchannel_19_cave2_box2_target_x;
MCNUM target_y = mccchannel_19_cave2_box2_target_y;
MCNUM target_z = mccchannel_19_cave2_box2_target_z;
MCNUM focus_aw = mccchannel_19_cave2_box2_focus_aw;
MCNUM focus_ah = mccchannel_19_cave2_box2_focus_ah;
MCNUM focus_xw = mccchannel_19_cave2_box2_focus_xw;
MCNUM focus_xh = mccchannel_19_cave2_box2_focus_xh;
MCNUM focus_r = mccchannel_19_cave2_box2_focus_r;
MCNUM p_interact = mccchannel_19_cave2_box2_p_interact;
char* mask_string = mccchannel_19_cave2_box2_mask_string;
char* mask_setting = mccchannel_19_cave2_box2_mask_setting;
MCNUM number_of_activations = mccchannel_19_cave2_box2_number_of_activations;
}   /* End of channel_19_cave2_box2=Union_box() SETTING parameter declarations. */
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex
  /* Label for restoring  neutron */
  mcabsorbCompchannel_19_cave2_box2:
  if (RESTORE) /* restore if needed */
  { RESTORE_NEUTRON(874,
      mcnlx,
      mcnly,
      mcnlz,
      mcnlvx,
      mcnlvy,
      mcnlvz,
      mcnlt,
      mcnlsx,
      mcnlsy,
      mcnlsz,
      mcnlp); }
#undef mcabsorbComp
#undef p
#undef sz
#undef sy
#undef sx
#undef t
#undef vz
#undef vy
#undef vx
#undef z
#undef y
#undef x
  mcDEBUG_STATE(
mcnlx,
mcnly,
mcnlz,
mcnlvx,
mcnlvy,
mcnlvz,
mcnlt,
mcnlsx,
mcnlsy,
mcnlsz,
mcnlp)

  /* TRACE Component channel_19_cave2_box3 [875] */
  mccoordschange(mcposrchannel_19_cave2_box3, mcrotrchannel_19_cave2_box3,
    &mcnlx,
    &mcnly,
    &mcnlz,
    &mcnlvx,
    &mcnlvy,
    &mcnlvz,
    &mcnlsx,
    &mcnlsy,
    &mcnlsz);
  /* define label inside component channel_19_cave2_box3 (without coords transformations) */
  mcJumpTrace_channel_19_cave2_box3:
  SIG_MESSAGE("channel_19_cave2_box3 (Trace)");
  mcDEBUG_COMP("channel_19_cave2_box3")
  mcDEBUG_STATE(
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp)
#define x mcnlx
#define y mcnly
#define z mcnlz
#define vx mcnlvx
#define vy mcnlvy
#define vz mcnlvz
#define t mcnlt
#define sx mcnlsx
#define sy mcnlsy
#define sz mcnlsz
#define p mcnlp

#define mcabsorbComp mcabsorbCompchannel_19_cave2_box3
  STORE_NEUTRON(875,
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp);
  mcScattered=0;
  mcRestore=0;
  mcNCounter[875]++;
  mcPCounter[875] += p;
  mcP2Counter[875] += p*p;
#define mccompcurname  channel_19_cave2_box3
#define mccompcurtype  Union_box
#define mccompcurindex 875
#define loop_index mccchannel_19_cave2_box3_loop_index
#define this_box_volume mccchannel_19_cave2_box3_this_box_volume
#define global_geometry_element mccchannel_19_cave2_box3_global_geometry_element
#define this_box_storage mccchannel_19_cave2_box3_this_box_storage
{   /* Declarations of channel_19_cave2_box3=Union_box() SETTING parameters. */
char* material_string = mccchannel_19_cave2_box3_material_string;
MCNUM priority = mccchannel_19_cave2_box3_priority;
MCNUM xwidth = mccchannel_19_cave2_box3_xwidth;
MCNUM yheight = mccchannel_19_cave2_box3_yheight;
MCNUM zdepth = mccchannel_19_cave2_box3_zdepth;
MCNUM xwidth2 = mccchannel_19_cave2_box3_xwidth2;
MCNUM yheight2 = mccchannel_19_cave2_box3_yheight2;
MCNUM visualize = mccchannel_19_cave2_box3_visualize;
int target_index = mccchannel_19_cave2_box3_target_index;
MCNUM target_x = mccchannel_19_cave2_box3_target_x;
MCNUM target_y = mccchannel_19_cave2_box3_target_y;
MCNUM target_z = mccchannel_19_cave2_box3_target_z;
MCNUM focus_aw = mccchannel_19_cave2_box3_focus_aw;
MCNUM focus_ah = mccchannel_19_cave2_box3_focus_ah;
MCNUM focus_xw = mccchannel_19_cave2_box3_focus_xw;
MCNUM focus_xh = mccchannel_19_cave2_box3_focus_xh;
MCNUM focus_r = mccchannel_19_cave2_box3_focus_r;
MCNUM p_interact = mccchannel_19_cave2_box3_p_interact;
char* mask_string = mccchannel_19_cave2_box3_mask_string;
char* mask_setting = mccchannel_19_cave2_box3_mask_setting;
MCNUM number_of_activations = mccchannel_19_cave2_box3_number_of_activations;
}   /* End of channel_19_cave2_box3=Union_box() SETTING parameter declarations. */
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex
  /* Label for restoring  neutron */
  mcabsorbCompchannel_19_cave2_box3:
  if (RESTORE) /* restore if needed */
  { RESTORE_NEUTRON(875,
      mcnlx,
      mcnly,
      mcnlz,
      mcnlvx,
      mcnlvy,
      mcnlvz,
      mcnlt,
      mcnlsx,
      mcnlsy,
      mcnlsz,
      mcnlp); }
#undef mcabsorbComp
#undef p
#undef sz
#undef sy
#undef sx
#undef t
#undef vz
#undef vy
#undef vx
#undef z
#undef y
#undef x
  mcDEBUG_STATE(
mcnlx,
mcnly,
mcnlz,
mcnlvx,
mcnlvy,
mcnlvz,
mcnlt,
mcnlsx,
mcnlsy,
mcnlsz,
mcnlp)

  /* TRACE Component inter_analyzer_colimator_center_19 [876] */
  mccoordschange(mcposrinter_analyzer_colimator_center_19, mcrotrinter_analyzer_colimator_center_19,
    &mcnlx,
    &mcnly,
    &mcnlz,
    &mcnlvx,
    &mcnlvy,
    &mcnlvz,
    &mcnlsx,
    &mcnlsy,
    &mcnlsz);
  /* define label inside component inter_analyzer_colimator_center_19 (without coords transformations) */
  mcJumpTrace_inter_analyzer_colimator_center_19:
  SIG_MESSAGE("inter_analyzer_colimator_center_19 (Trace)");
  mcDEBUG_COMP("inter_analyzer_colimator_center_19")
  mcDEBUG_STATE(
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp)
#define x mcnlx
#define y mcnly
#define z mcnlz
#define vx mcnlvx
#define vy mcnlvy
#define vz mcnlvz
#define t mcnlt
#define sx mcnlsx
#define sy mcnlsy
#define sz mcnlsz
#define p mcnlp

#define mcabsorbComp mcabsorbCompinter_analyzer_colimator_center_19
  STORE_NEUTRON(876,
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp);
  mcScattered=0;
  mcRestore=0;
  mcNCounter[876]++;
  mcPCounter[876] += p;
  mcP2Counter[876] += p*p;
#define mccompcurname  inter_analyzer_colimator_center_19
#define mccompcurtype  Arm
#define mccompcurindex 876
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex
  /* Label for restoring  neutron */
  mcabsorbCompinter_analyzer_colimator_center_19:
  if (RESTORE) /* restore if needed */
  { RESTORE_NEUTRON(876,
      mcnlx,
      mcnly,
      mcnlz,
      mcnlvx,
      mcnlvy,
      mcnlvz,
      mcnlt,
      mcnlsx,
      mcnlsy,
      mcnlsz,
      mcnlp); }
#undef mcabsorbComp
#undef p
#undef sz
#undef sy
#undef sx
#undef t
#undef vz
#undef vy
#undef vx
#undef z
#undef y
#undef x
  mcDEBUG_STATE(
mcnlx,
mcnly,
mcnlz,
mcnlvx,
mcnlvy,
mcnlvz,
mcnlt,
mcnlsx,
mcnlsy,
mcnlsz,
mcnlp)

  /* TRACE Component inter_analyzer_colimator_19_blade_0 [877] */
  mccoordschange(mcposrinter_analyzer_colimator_19_blade_0, mcrotrinter_analyzer_colimator_19_blade_0,
    &mcnlx,
    &mcnly,
    &mcnlz,
    &mcnlvx,
    &mcnlvy,
    &mcnlvz,
    &mcnlsx,
    &mcnlsy,
    &mcnlsz);
  /* define label inside component inter_analyzer_colimator_19_blade_0 (without coords transformations) */
  mcJumpTrace_inter_analyzer_colimator_19_blade_0:
  SIG_MESSAGE("inter_analyzer_colimator_19_blade_0 (Trace)");
  mcDEBUG_COMP("inter_analyzer_colimator_19_blade_0")
  mcDEBUG_STATE(
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp)
#define x mcnlx
#define y mcnly
#define z mcnlz
#define vx mcnlvx
#define vy mcnlvy
#define vz mcnlvz
#define t mcnlt
#define sx mcnlsx
#define sy mcnlsy
#define sz mcnlsz
#define p mcnlp

#define mcabsorbComp mcabsorbCompinter_analyzer_colimator_19_blade_0
  STORE_NEUTRON(877,
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp);
  mcScattered=0;
  mcRestore=0;
  mcNCounter[877]++;
  mcPCounter[877] += p;
  mcP2Counter[877] += p*p;
#define mccompcurname  inter_analyzer_colimator_19_blade_0
#define mccompcurtype  Union_box
#define mccompcurindex 877
#define loop_index mccinter_analyzer_colimator_19_blade_0_loop_index
#define this_box_volume mccinter_analyzer_colimator_19_blade_0_this_box_volume
#define global_geometry_element mccinter_analyzer_colimator_19_blade_0_global_geometry_element
#define this_box_storage mccinter_analyzer_colimator_19_blade_0_this_box_storage
{   /* Declarations of inter_analyzer_colimator_19_blade_0=Union_box() SETTING parameters. */
char* material_string = mccinter_analyzer_colimator_19_blade_0_material_string;
MCNUM priority = mccinter_analyzer_colimator_19_blade_0_priority;
MCNUM xwidth = mccinter_analyzer_colimator_19_blade_0_xwidth;
MCNUM yheight = mccinter_analyzer_colimator_19_blade_0_yheight;
MCNUM zdepth = mccinter_analyzer_colimator_19_blade_0_zdepth;
MCNUM xwidth2 = mccinter_analyzer_colimator_19_blade_0_xwidth2;
MCNUM yheight2 = mccinter_analyzer_colimator_19_blade_0_yheight2;
MCNUM visualize = mccinter_analyzer_colimator_19_blade_0_visualize;
int target_index = mccinter_analyzer_colimator_19_blade_0_target_index;
MCNUM target_x = mccinter_analyzer_colimator_19_blade_0_target_x;
MCNUM target_y = mccinter_analyzer_colimator_19_blade_0_target_y;
MCNUM target_z = mccinter_analyzer_colimator_19_blade_0_target_z;
MCNUM focus_aw = mccinter_analyzer_colimator_19_blade_0_focus_aw;
MCNUM focus_ah = mccinter_analyzer_colimator_19_blade_0_focus_ah;
MCNUM focus_xw = mccinter_analyzer_colimator_19_blade_0_focus_xw;
MCNUM focus_xh = mccinter_analyzer_colimator_19_blade_0_focus_xh;
MCNUM focus_r = mccinter_analyzer_colimator_19_blade_0_focus_r;
MCNUM p_interact = mccinter_analyzer_colimator_19_blade_0_p_interact;
char* mask_string = mccinter_analyzer_colimator_19_blade_0_mask_string;
char* mask_setting = mccinter_analyzer_colimator_19_blade_0_mask_setting;
MCNUM number_of_activations = mccinter_analyzer_colimator_19_blade_0_number_of_activations;
}   /* End of inter_analyzer_colimator_19_blade_0=Union_box() SETTING parameter declarations. */
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex
  /* Label for restoring  neutron */
  mcabsorbCompinter_analyzer_colimator_19_blade_0:
  if (RESTORE) /* restore if needed */
  { RESTORE_NEUTRON(877,
      mcnlx,
      mcnly,
      mcnlz,
      mcnlvx,
      mcnlvy,
      mcnlvz,
      mcnlt,
      mcnlsx,
      mcnlsy,
      mcnlsz,
      mcnlp); }
#undef mcabsorbComp
#undef p
#undef sz
#undef sy
#undef sx
#undef t
#undef vz
#undef vy
#undef vx
#undef z
#undef y
#undef x
  mcDEBUG_STATE(
mcnlx,
mcnly,
mcnlz,
mcnlvx,
mcnlvy,
mcnlvz,
mcnlt,
mcnlsx,
mcnlsy,
mcnlsz,
mcnlp)

  /* TRACE Component inter_analyzer_colimator_19_blade_1 [878] */
  mccoordschange(mcposrinter_analyzer_colimator_19_blade_1, mcrotrinter_analyzer_colimator_19_blade_1,
    &mcnlx,
    &mcnly,
    &mcnlz,
    &mcnlvx,
    &mcnlvy,
    &mcnlvz,
    &mcnlsx,
    &mcnlsy,
    &mcnlsz);
  /* define label inside component inter_analyzer_colimator_19_blade_1 (without coords transformations) */
  mcJumpTrace_inter_analyzer_colimator_19_blade_1:
  SIG_MESSAGE("inter_analyzer_colimator_19_blade_1 (Trace)");
  mcDEBUG_COMP("inter_analyzer_colimator_19_blade_1")
  mcDEBUG_STATE(
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp)
#define x mcnlx
#define y mcnly
#define z mcnlz
#define vx mcnlvx
#define vy mcnlvy
#define vz mcnlvz
#define t mcnlt
#define sx mcnlsx
#define sy mcnlsy
#define sz mcnlsz
#define p mcnlp

#define mcabsorbComp mcabsorbCompinter_analyzer_colimator_19_blade_1
  STORE_NEUTRON(878,
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp);
  mcScattered=0;
  mcRestore=0;
  mcNCounter[878]++;
  mcPCounter[878] += p;
  mcP2Counter[878] += p*p;
#define mccompcurname  inter_analyzer_colimator_19_blade_1
#define mccompcurtype  Union_box
#define mccompcurindex 878
#define loop_index mccinter_analyzer_colimator_19_blade_1_loop_index
#define this_box_volume mccinter_analyzer_colimator_19_blade_1_this_box_volume
#define global_geometry_element mccinter_analyzer_colimator_19_blade_1_global_geometry_element
#define this_box_storage mccinter_analyzer_colimator_19_blade_1_this_box_storage
{   /* Declarations of inter_analyzer_colimator_19_blade_1=Union_box() SETTING parameters. */
char* material_string = mccinter_analyzer_colimator_19_blade_1_material_string;
MCNUM priority = mccinter_analyzer_colimator_19_blade_1_priority;
MCNUM xwidth = mccinter_analyzer_colimator_19_blade_1_xwidth;
MCNUM yheight = mccinter_analyzer_colimator_19_blade_1_yheight;
MCNUM zdepth = mccinter_analyzer_colimator_19_blade_1_zdepth;
MCNUM xwidth2 = mccinter_analyzer_colimator_19_blade_1_xwidth2;
MCNUM yheight2 = mccinter_analyzer_colimator_19_blade_1_yheight2;
MCNUM visualize = mccinter_analyzer_colimator_19_blade_1_visualize;
int target_index = mccinter_analyzer_colimator_19_blade_1_target_index;
MCNUM target_x = mccinter_analyzer_colimator_19_blade_1_target_x;
MCNUM target_y = mccinter_analyzer_colimator_19_blade_1_target_y;
MCNUM target_z = mccinter_analyzer_colimator_19_blade_1_target_z;
MCNUM focus_aw = mccinter_analyzer_colimator_19_blade_1_focus_aw;
MCNUM focus_ah = mccinter_analyzer_colimator_19_blade_1_focus_ah;
MCNUM focus_xw = mccinter_analyzer_colimator_19_blade_1_focus_xw;
MCNUM focus_xh = mccinter_analyzer_colimator_19_blade_1_focus_xh;
MCNUM focus_r = mccinter_analyzer_colimator_19_blade_1_focus_r;
MCNUM p_interact = mccinter_analyzer_colimator_19_blade_1_p_interact;
char* mask_string = mccinter_analyzer_colimator_19_blade_1_mask_string;
char* mask_setting = mccinter_analyzer_colimator_19_blade_1_mask_setting;
MCNUM number_of_activations = mccinter_analyzer_colimator_19_blade_1_number_of_activations;
}   /* End of inter_analyzer_colimator_19_blade_1=Union_box() SETTING parameter declarations. */
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex
  /* Label for restoring  neutron */
  mcabsorbCompinter_analyzer_colimator_19_blade_1:
  if (RESTORE) /* restore if needed */
  { RESTORE_NEUTRON(878,
      mcnlx,
      mcnly,
      mcnlz,
      mcnlvx,
      mcnlvy,
      mcnlvz,
      mcnlt,
      mcnlsx,
      mcnlsy,
      mcnlsz,
      mcnlp); }
#undef mcabsorbComp
#undef p
#undef sz
#undef sy
#undef sx
#undef t
#undef vz
#undef vy
#undef vx
#undef z
#undef y
#undef x
  mcDEBUG_STATE(
mcnlx,
mcnly,
mcnlz,
mcnlvx,
mcnlvy,
mcnlvz,
mcnlt,
mcnlsx,
mcnlsy,
mcnlsz,
mcnlp)

  /* TRACE Component inter_analyzer_colimator_19_blade_2 [879] */
  mccoordschange(mcposrinter_analyzer_colimator_19_blade_2, mcrotrinter_analyzer_colimator_19_blade_2,
    &mcnlx,
    &mcnly,
    &mcnlz,
    &mcnlvx,
    &mcnlvy,
    &mcnlvz,
    &mcnlsx,
    &mcnlsy,
    &mcnlsz);
  /* define label inside component inter_analyzer_colimator_19_blade_2 (without coords transformations) */
  mcJumpTrace_inter_analyzer_colimator_19_blade_2:
  SIG_MESSAGE("inter_analyzer_colimator_19_blade_2 (Trace)");
  mcDEBUG_COMP("inter_analyzer_colimator_19_blade_2")
  mcDEBUG_STATE(
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp)
#define x mcnlx
#define y mcnly
#define z mcnlz
#define vx mcnlvx
#define vy mcnlvy
#define vz mcnlvz
#define t mcnlt
#define sx mcnlsx
#define sy mcnlsy
#define sz mcnlsz
#define p mcnlp

#define mcabsorbComp mcabsorbCompinter_analyzer_colimator_19_blade_2
  STORE_NEUTRON(879,
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp);
  mcScattered=0;
  mcRestore=0;
  mcNCounter[879]++;
  mcPCounter[879] += p;
  mcP2Counter[879] += p*p;
#define mccompcurname  inter_analyzer_colimator_19_blade_2
#define mccompcurtype  Union_box
#define mccompcurindex 879
#define loop_index mccinter_analyzer_colimator_19_blade_2_loop_index
#define this_box_volume mccinter_analyzer_colimator_19_blade_2_this_box_volume
#define global_geometry_element mccinter_analyzer_colimator_19_blade_2_global_geometry_element
#define this_box_storage mccinter_analyzer_colimator_19_blade_2_this_box_storage
{   /* Declarations of inter_analyzer_colimator_19_blade_2=Union_box() SETTING parameters. */
char* material_string = mccinter_analyzer_colimator_19_blade_2_material_string;
MCNUM priority = mccinter_analyzer_colimator_19_blade_2_priority;
MCNUM xwidth = mccinter_analyzer_colimator_19_blade_2_xwidth;
MCNUM yheight = mccinter_analyzer_colimator_19_blade_2_yheight;
MCNUM zdepth = mccinter_analyzer_colimator_19_blade_2_zdepth;
MCNUM xwidth2 = mccinter_analyzer_colimator_19_blade_2_xwidth2;
MCNUM yheight2 = mccinter_analyzer_colimator_19_blade_2_yheight2;
MCNUM visualize = mccinter_analyzer_colimator_19_blade_2_visualize;
int target_index = mccinter_analyzer_colimator_19_blade_2_target_index;
MCNUM target_x = mccinter_analyzer_colimator_19_blade_2_target_x;
MCNUM target_y = mccinter_analyzer_colimator_19_blade_2_target_y;
MCNUM target_z = mccinter_analyzer_colimator_19_blade_2_target_z;
MCNUM focus_aw = mccinter_analyzer_colimator_19_blade_2_focus_aw;
MCNUM focus_ah = mccinter_analyzer_colimator_19_blade_2_focus_ah;
MCNUM focus_xw = mccinter_analyzer_colimator_19_blade_2_focus_xw;
MCNUM focus_xh = mccinter_analyzer_colimator_19_blade_2_focus_xh;
MCNUM focus_r = mccinter_analyzer_colimator_19_blade_2_focus_r;
MCNUM p_interact = mccinter_analyzer_colimator_19_blade_2_p_interact;
char* mask_string = mccinter_analyzer_colimator_19_blade_2_mask_string;
char* mask_setting = mccinter_analyzer_colimator_19_blade_2_mask_setting;
MCNUM number_of_activations = mccinter_analyzer_colimator_19_blade_2_number_of_activations;
}   /* End of inter_analyzer_colimator_19_blade_2=Union_box() SETTING parameter declarations. */
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex
  /* Label for restoring  neutron */
  mcabsorbCompinter_analyzer_colimator_19_blade_2:
  if (RESTORE) /* restore if needed */
  { RESTORE_NEUTRON(879,
      mcnlx,
      mcnly,
      mcnlz,
      mcnlvx,
      mcnlvy,
      mcnlvz,
      mcnlt,
      mcnlsx,
      mcnlsy,
      mcnlsz,
      mcnlp); }
#undef mcabsorbComp
#undef p
#undef sz
#undef sy
#undef sx
#undef t
#undef vz
#undef vy
#undef vx
#undef z
#undef y
#undef x
  mcDEBUG_STATE(
mcnlx,
mcnly,
mcnlz,
mcnlvx,
mcnlvy,
mcnlvz,
mcnlt,
mcnlsx,
mcnlsy,
mcnlsz,
mcnlp)

  /* TRACE Component inter_analyzer_colimator_19_blade_3 [880] */
  mccoordschange(mcposrinter_analyzer_colimator_19_blade_3, mcrotrinter_analyzer_colimator_19_blade_3,
    &mcnlx,
    &mcnly,
    &mcnlz,
    &mcnlvx,
    &mcnlvy,
    &mcnlvz,
    &mcnlsx,
    &mcnlsy,
    &mcnlsz);
  /* define label inside component inter_analyzer_colimator_19_blade_3 (without coords transformations) */
  mcJumpTrace_inter_analyzer_colimator_19_blade_3:
  SIG_MESSAGE("inter_analyzer_colimator_19_blade_3 (Trace)");
  mcDEBUG_COMP("inter_analyzer_colimator_19_blade_3")
  mcDEBUG_STATE(
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp)
#define x mcnlx
#define y mcnly
#define z mcnlz
#define vx mcnlvx
#define vy mcnlvy
#define vz mcnlvz
#define t mcnlt
#define sx mcnlsx
#define sy mcnlsy
#define sz mcnlsz
#define p mcnlp

#define mcabsorbComp mcabsorbCompinter_analyzer_colimator_19_blade_3
  STORE_NEUTRON(880,
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp);
  mcScattered=0;
  mcRestore=0;
  mcNCounter[880]++;
  mcPCounter[880] += p;
  mcP2Counter[880] += p*p;
#define mccompcurname  inter_analyzer_colimator_19_blade_3
#define mccompcurtype  Union_box
#define mccompcurindex 880
#define loop_index mccinter_analyzer_colimator_19_blade_3_loop_index
#define this_box_volume mccinter_analyzer_colimator_19_blade_3_this_box_volume
#define global_geometry_element mccinter_analyzer_colimator_19_blade_3_global_geometry_element
#define this_box_storage mccinter_analyzer_colimator_19_blade_3_this_box_storage
{   /* Declarations of inter_analyzer_colimator_19_blade_3=Union_box() SETTING parameters. */
char* material_string = mccinter_analyzer_colimator_19_blade_3_material_string;
MCNUM priority = mccinter_analyzer_colimator_19_blade_3_priority;
MCNUM xwidth = mccinter_analyzer_colimator_19_blade_3_xwidth;
MCNUM yheight = mccinter_analyzer_colimator_19_blade_3_yheight;
MCNUM zdepth = mccinter_analyzer_colimator_19_blade_3_zdepth;
MCNUM xwidth2 = mccinter_analyzer_colimator_19_blade_3_xwidth2;
MCNUM yheight2 = mccinter_analyzer_colimator_19_blade_3_yheight2;
MCNUM visualize = mccinter_analyzer_colimator_19_blade_3_visualize;
int target_index = mccinter_analyzer_colimator_19_blade_3_target_index;
MCNUM target_x = mccinter_analyzer_colimator_19_blade_3_target_x;
MCNUM target_y = mccinter_analyzer_colimator_19_blade_3_target_y;
MCNUM target_z = mccinter_analyzer_colimator_19_blade_3_target_z;
MCNUM focus_aw = mccinter_analyzer_colimator_19_blade_3_focus_aw;
MCNUM focus_ah = mccinter_analyzer_colimator_19_blade_3_focus_ah;
MCNUM focus_xw = mccinter_analyzer_colimator_19_blade_3_focus_xw;
MCNUM focus_xh = mccinter_analyzer_colimator_19_blade_3_focus_xh;
MCNUM focus_r = mccinter_analyzer_colimator_19_blade_3_focus_r;
MCNUM p_interact = mccinter_analyzer_colimator_19_blade_3_p_interact;
char* mask_string = mccinter_analyzer_colimator_19_blade_3_mask_string;
char* mask_setting = mccinter_analyzer_colimator_19_blade_3_mask_setting;
MCNUM number_of_activations = mccinter_analyzer_colimator_19_blade_3_number_of_activations;
}   /* End of inter_analyzer_colimator_19_blade_3=Union_box() SETTING parameter declarations. */
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex
  /* Label for restoring  neutron */
  mcabsorbCompinter_analyzer_colimator_19_blade_3:
  if (RESTORE) /* restore if needed */
  { RESTORE_NEUTRON(880,
      mcnlx,
      mcnly,
      mcnlz,
      mcnlvx,
      mcnlvy,
      mcnlvz,
      mcnlt,
      mcnlsx,
      mcnlsy,
      mcnlsz,
      mcnlp); }
#undef mcabsorbComp
#undef p
#undef sz
#undef sy
#undef sx
#undef t
#undef vz
#undef vy
#undef vx
#undef z
#undef y
#undef x
  mcDEBUG_STATE(
mcnlx,
mcnly,
mcnlz,
mcnlvx,
mcnlvy,
mcnlvz,
mcnlt,
mcnlsx,
mcnlsy,
mcnlsz,
mcnlp)

  /* TRACE Component inter_analyzer_colimator_19_blade_4 [881] */
  mccoordschange(mcposrinter_analyzer_colimator_19_blade_4, mcrotrinter_analyzer_colimator_19_blade_4,
    &mcnlx,
    &mcnly,
    &mcnlz,
    &mcnlvx,
    &mcnlvy,
    &mcnlvz,
    &mcnlsx,
    &mcnlsy,
    &mcnlsz);
  /* define label inside component inter_analyzer_colimator_19_blade_4 (without coords transformations) */
  mcJumpTrace_inter_analyzer_colimator_19_blade_4:
  SIG_MESSAGE("inter_analyzer_colimator_19_blade_4 (Trace)");
  mcDEBUG_COMP("inter_analyzer_colimator_19_blade_4")
  mcDEBUG_STATE(
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp)
#define x mcnlx
#define y mcnly
#define z mcnlz
#define vx mcnlvx
#define vy mcnlvy
#define vz mcnlvz
#define t mcnlt
#define sx mcnlsx
#define sy mcnlsy
#define sz mcnlsz
#define p mcnlp

#define mcabsorbComp mcabsorbCompinter_analyzer_colimator_19_blade_4
  STORE_NEUTRON(881,
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp);
  mcScattered=0;
  mcRestore=0;
  mcNCounter[881]++;
  mcPCounter[881] += p;
  mcP2Counter[881] += p*p;
#define mccompcurname  inter_analyzer_colimator_19_blade_4
#define mccompcurtype  Union_box
#define mccompcurindex 881
#define loop_index mccinter_analyzer_colimator_19_blade_4_loop_index
#define this_box_volume mccinter_analyzer_colimator_19_blade_4_this_box_volume
#define global_geometry_element mccinter_analyzer_colimator_19_blade_4_global_geometry_element
#define this_box_storage mccinter_analyzer_colimator_19_blade_4_this_box_storage
{   /* Declarations of inter_analyzer_colimator_19_blade_4=Union_box() SETTING parameters. */
char* material_string = mccinter_analyzer_colimator_19_blade_4_material_string;
MCNUM priority = mccinter_analyzer_colimator_19_blade_4_priority;
MCNUM xwidth = mccinter_analyzer_colimator_19_blade_4_xwidth;
MCNUM yheight = mccinter_analyzer_colimator_19_blade_4_yheight;
MCNUM zdepth = mccinter_analyzer_colimator_19_blade_4_zdepth;
MCNUM xwidth2 = mccinter_analyzer_colimator_19_blade_4_xwidth2;
MCNUM yheight2 = mccinter_analyzer_colimator_19_blade_4_yheight2;
MCNUM visualize = mccinter_analyzer_colimator_19_blade_4_visualize;
int target_index = mccinter_analyzer_colimator_19_blade_4_target_index;
MCNUM target_x = mccinter_analyzer_colimator_19_blade_4_target_x;
MCNUM target_y = mccinter_analyzer_colimator_19_blade_4_target_y;
MCNUM target_z = mccinter_analyzer_colimator_19_blade_4_target_z;
MCNUM focus_aw = mccinter_analyzer_colimator_19_blade_4_focus_aw;
MCNUM focus_ah = mccinter_analyzer_colimator_19_blade_4_focus_ah;
MCNUM focus_xw = mccinter_analyzer_colimator_19_blade_4_focus_xw;
MCNUM focus_xh = mccinter_analyzer_colimator_19_blade_4_focus_xh;
MCNUM focus_r = mccinter_analyzer_colimator_19_blade_4_focus_r;
MCNUM p_interact = mccinter_analyzer_colimator_19_blade_4_p_interact;
char* mask_string = mccinter_analyzer_colimator_19_blade_4_mask_string;
char* mask_setting = mccinter_analyzer_colimator_19_blade_4_mask_setting;
MCNUM number_of_activations = mccinter_analyzer_colimator_19_blade_4_number_of_activations;
}   /* End of inter_analyzer_colimator_19_blade_4=Union_box() SETTING parameter declarations. */
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex
  /* Label for restoring  neutron */
  mcabsorbCompinter_analyzer_colimator_19_blade_4:
  if (RESTORE) /* restore if needed */
  { RESTORE_NEUTRON(881,
      mcnlx,
      mcnly,
      mcnlz,
      mcnlvx,
      mcnlvy,
      mcnlvz,
      mcnlt,
      mcnlsx,
      mcnlsy,
      mcnlsz,
      mcnlp); }
#undef mcabsorbComp
#undef p
#undef sz
#undef sy
#undef sx
#undef t
#undef vz
#undef vy
#undef vx
#undef z
#undef y
#undef x
  mcDEBUG_STATE(
mcnlx,
mcnly,
mcnlz,
mcnlvx,
mcnlvy,
mcnlvz,
mcnlt,
mcnlsx,
mcnlsy,
mcnlsz,
mcnlp)

  /* TRACE Component diffraction_detector_19_exit_volume [882] */
  mccoordschange(mcposrdiffraction_detector_19_exit_volume, mcrotrdiffraction_detector_19_exit_volume,
    &mcnlx,
    &mcnly,
    &mcnlz,
    &mcnlvx,
    &mcnlvy,
    &mcnlvz,
    &mcnlsx,
    &mcnlsy,
    &mcnlsz);
  /* define label inside component diffraction_detector_19_exit_volume (without coords transformations) */
  mcJumpTrace_diffraction_detector_19_exit_volume:
  SIG_MESSAGE("diffraction_detector_19_exit_volume (Trace)");
  mcDEBUG_COMP("diffraction_detector_19_exit_volume")
  mcDEBUG_STATE(
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp)
#define x mcnlx
#define y mcnly
#define z mcnlz
#define vx mcnlvx
#define vy mcnlvy
#define vz mcnlvz
#define t mcnlt
#define sx mcnlsx
#define sy mcnlsy
#define sz mcnlsz
#define p mcnlp

#define mcabsorbComp mcabsorbCompdiffraction_detector_19_exit_volume
  STORE_NEUTRON(882,
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp);
  mcScattered=0;
  mcRestore=0;
  mcNCounter[882]++;
  mcPCounter[882] += p;
  mcP2Counter[882] += p*p;
#define mccompcurname  diffraction_detector_19_exit_volume
#define mccompcurtype  Union_box
#define mccompcurindex 882
#define loop_index mccdiffraction_detector_19_exit_volume_loop_index
#define this_box_volume mccdiffraction_detector_19_exit_volume_this_box_volume
#define global_geometry_element mccdiffraction_detector_19_exit_volume_global_geometry_element
#define this_box_storage mccdiffraction_detector_19_exit_volume_this_box_storage
{   /* Declarations of diffraction_detector_19_exit_volume=Union_box() SETTING parameters. */
char* material_string = mccdiffraction_detector_19_exit_volume_material_string;
MCNUM priority = mccdiffraction_detector_19_exit_volume_priority;
MCNUM xwidth = mccdiffraction_detector_19_exit_volume_xwidth;
MCNUM yheight = mccdiffraction_detector_19_exit_volume_yheight;
MCNUM zdepth = mccdiffraction_detector_19_exit_volume_zdepth;
MCNUM xwidth2 = mccdiffraction_detector_19_exit_volume_xwidth2;
MCNUM yheight2 = mccdiffraction_detector_19_exit_volume_yheight2;
MCNUM visualize = mccdiffraction_detector_19_exit_volume_visualize;
int target_index = mccdiffraction_detector_19_exit_volume_target_index;
MCNUM target_x = mccdiffraction_detector_19_exit_volume_target_x;
MCNUM target_y = mccdiffraction_detector_19_exit_volume_target_y;
MCNUM target_z = mccdiffraction_detector_19_exit_volume_target_z;
MCNUM focus_aw = mccdiffraction_detector_19_exit_volume_focus_aw;
MCNUM focus_ah = mccdiffraction_detector_19_exit_volume_focus_ah;
MCNUM focus_xw = mccdiffraction_detector_19_exit_volume_focus_xw;
MCNUM focus_xh = mccdiffraction_detector_19_exit_volume_focus_xh;
MCNUM focus_r = mccdiffraction_detector_19_exit_volume_focus_r;
MCNUM p_interact = mccdiffraction_detector_19_exit_volume_p_interact;
char* mask_string = mccdiffraction_detector_19_exit_volume_mask_string;
char* mask_setting = mccdiffraction_detector_19_exit_volume_mask_setting;
MCNUM number_of_activations = mccdiffraction_detector_19_exit_volume_number_of_activations;
}   /* End of diffraction_detector_19_exit_volume=Union_box() SETTING parameter declarations. */
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex
  /* Label for restoring  neutron */
  mcabsorbCompdiffraction_detector_19_exit_volume:
  if (RESTORE) /* restore if needed */
  { RESTORE_NEUTRON(882,
      mcnlx,
      mcnly,
      mcnlz,
      mcnlvx,
      mcnlvy,
      mcnlvz,
      mcnlt,
      mcnlsx,
      mcnlsy,
      mcnlsz,
      mcnlp); }
#undef mcabsorbComp
#undef p
#undef sz
#undef sy
#undef sx
#undef t
#undef vz
#undef vy
#undef vx
#undef z
#undef y
#undef x
  mcDEBUG_STATE(
mcnlx,
mcnly,
mcnlz,
mcnlvx,
mcnlvy,
mcnlvz,
mcnlt,
mcnlsx,
mcnlsy,
mcnlsz,
mcnlp)

  /* TRACE Component spec_detector_19_exit_volume [883] */
  mccoordschange(mcposrspec_detector_19_exit_volume, mcrotrspec_detector_19_exit_volume,
    &mcnlx,
    &mcnly,
    &mcnlz,
    &mcnlvx,
    &mcnlvy,
    &mcnlvz,
    &mcnlsx,
    &mcnlsy,
    &mcnlsz);
  /* define label inside component spec_detector_19_exit_volume (without coords transformations) */
  mcJumpTrace_spec_detector_19_exit_volume:
  SIG_MESSAGE("spec_detector_19_exit_volume (Trace)");
  mcDEBUG_COMP("spec_detector_19_exit_volume")
  mcDEBUG_STATE(
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp)
#define x mcnlx
#define y mcnly
#define z mcnlz
#define vx mcnlvx
#define vy mcnlvy
#define vz mcnlvz
#define t mcnlt
#define sx mcnlsx
#define sy mcnlsy
#define sz mcnlsz
#define p mcnlp

#define mcabsorbComp mcabsorbCompspec_detector_19_exit_volume
  STORE_NEUTRON(883,
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp);
  mcScattered=0;
  mcRestore=0;
  mcNCounter[883]++;
  mcPCounter[883] += p;
  mcP2Counter[883] += p*p;
#define mccompcurname  spec_detector_19_exit_volume
#define mccompcurtype  Union_box
#define mccompcurindex 883
#define loop_index mccspec_detector_19_exit_volume_loop_index
#define this_box_volume mccspec_detector_19_exit_volume_this_box_volume
#define global_geometry_element mccspec_detector_19_exit_volume_global_geometry_element
#define this_box_storage mccspec_detector_19_exit_volume_this_box_storage
{   /* Declarations of spec_detector_19_exit_volume=Union_box() SETTING parameters. */
char* material_string = mccspec_detector_19_exit_volume_material_string;
MCNUM priority = mccspec_detector_19_exit_volume_priority;
MCNUM xwidth = mccspec_detector_19_exit_volume_xwidth;
MCNUM yheight = mccspec_detector_19_exit_volume_yheight;
MCNUM zdepth = mccspec_detector_19_exit_volume_zdepth;
MCNUM xwidth2 = mccspec_detector_19_exit_volume_xwidth2;
MCNUM yheight2 = mccspec_detector_19_exit_volume_yheight2;
MCNUM visualize = mccspec_detector_19_exit_volume_visualize;
int target_index = mccspec_detector_19_exit_volume_target_index;
MCNUM target_x = mccspec_detector_19_exit_volume_target_x;
MCNUM target_y = mccspec_detector_19_exit_volume_target_y;
MCNUM target_z = mccspec_detector_19_exit_volume_target_z;
MCNUM focus_aw = mccspec_detector_19_exit_volume_focus_aw;
MCNUM focus_ah = mccspec_detector_19_exit_volume_focus_ah;
MCNUM focus_xw = mccspec_detector_19_exit_volume_focus_xw;
MCNUM focus_xh = mccspec_detector_19_exit_volume_focus_xh;
MCNUM focus_r = mccspec_detector_19_exit_volume_focus_r;
MCNUM p_interact = mccspec_detector_19_exit_volume_p_interact;
char* mask_string = mccspec_detector_19_exit_volume_mask_string;
char* mask_setting = mccspec_detector_19_exit_volume_mask_setting;
MCNUM number_of_activations = mccspec_detector_19_exit_volume_number_of_activations;
}   /* End of spec_detector_19_exit_volume=Union_box() SETTING parameter declarations. */
#undef this_box_storage
#undef global_geometry_element
#undef this_box_volume
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex
  /* Label for restoring  neutron */
  mcabsorbCompspec_detector_19_exit_volume:
  if (RESTORE) /* restore if needed */
  { RESTORE_NEUTRON(883,
      mcnlx,
      mcnly,
      mcnlz,
      mcnlvx,
      mcnlvy,
      mcnlvz,
      mcnlt,
      mcnlsx,
      mcnlsy,
      mcnlsz,
      mcnlp); }
#undef mcabsorbComp
#undef p
#undef sz
#undef sy
#undef sx
#undef t
#undef vz
#undef vy
#undef vx
#undef z
#undef y
#undef x
  mcDEBUG_STATE(
mcnlx,
mcnly,
mcnlz,
mcnlvx,
mcnlvy,
mcnlvz,
mcnlt,
mcnlsx,
mcnlsy,
mcnlsz,
mcnlp)

  /* TRACE Component kidney_union_master [884] */
  mccoordschange(mcposrkidney_union_master, mcrotrkidney_union_master,
    &mcnlx,
    &mcnly,
    &mcnlz,
    &mcnlvx,
    &mcnlvy,
    &mcnlvz,
    &mcnlsx,
    &mcnlsy,
    &mcnlsz);
  /* define label inside component kidney_union_master (without coords transformations) */
  mcJumpTrace_kidney_union_master:
  SIG_MESSAGE("kidney_union_master (Trace)");
  mcDEBUG_COMP("kidney_union_master")
  mcDEBUG_STATE(
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp)
#define x mcnlx
#define y mcnly
#define z mcnlz
#define vx mcnlvx
#define vy mcnlvy
#define vz mcnlvz
#define t mcnlt
#define sx mcnlsx
#define sy mcnlsy
#define sz mcnlsz
#define p mcnlp

#define mcabsorbComp mcabsorbCompkidney_union_master
  STORE_NEUTRON(884,
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp);
  mcScattered=0;
  mcRestore=0;
  mcNCounter[884]++;
  mcPCounter[884] += p;
  mcP2Counter[884] += p*p;
#define mccompcurname  kidney_union_master
#define mccompcurtype  Union_master
#define mccompcurindex 884
#define verbal mcckidney_union_master_verbal
#define list_verbal mcckidney_union_master_list_verbal
#define trace_verbal mcckidney_union_master_trace_verbal
#define finally_verbal mcckidney_union_master_finally_verbal
#define starting_volume_warning mcckidney_union_master_starting_volume_warning
#define global_master_element mcckidney_union_master_global_master_element
#define this_global_master_index mcckidney_union_master_this_global_master_index
#define previous_master_index mcckidney_union_master_previous_master_index
#define geometry_list_index mcckidney_union_master_geometry_list_index
#define intersection_time_table mcckidney_union_master_intersection_time_table
#define Volumes mcckidney_union_master_Volumes
#define Geometries mcckidney_union_master_Geometries
#define starting_lists mcckidney_union_master_starting_lists
#define r mcckidney_union_master_r
#define r_start mcckidney_union_master_r_start
#define v mcckidney_union_master_v
#define error_msg mcckidney_union_master_error_msg
#define component_error_msg mcckidney_union_master_component_error_msg
#define string_output mcckidney_union_master_string_output
#define number_of_volumes mcckidney_union_master_number_of_volumes
#define volume_index mcckidney_union_master_volume_index
#define process_index mcckidney_union_master_process_index
#define solutions mcckidney_union_master_solutions
#define max_number_of_processes mcckidney_union_master_max_number_of_processes
#define limit mcckidney_union_master_limit
#define solution mcckidney_union_master_solution
#define min_solution mcckidney_union_master_min_solution
#define min_volume mcckidney_union_master_min_volume
#define time_found mcckidney_union_master_time_found
#define intersection_time mcckidney_union_master_intersection_time
#define min_intersection_time mcckidney_union_master_min_intersection_time
#define process mcckidney_union_master_process
#define process_start mcckidney_union_master_process_start
#define my_trace mcckidney_union_master_my_trace
#define p_my_trace mcckidney_union_master_p_my_trace
#define my_trace_fraction_control mcckidney_union_master_my_trace_fraction_control
#define k mcckidney_union_master_k
#define k_new mcckidney_union_master_k_new
#define k_old mcckidney_union_master_k_old
#define v_length mcckidney_union_master_v_length
#define my_sum mcckidney_union_master_my_sum
#define my_sum_plus_abs mcckidney_union_master_my_sum_plus_abs
#define culmative_probability mcckidney_union_master_culmative_probability
#define mc_prop mcckidney_union_master_mc_prop
#define time_to_scattering mcckidney_union_master_time_to_scattering
#define length_to_scattering mcckidney_union_master_length_to_scattering
#define length_to_boundery mcckidney_union_master_length_to_boundery
#define time_to_boundery mcckidney_union_master_time_to_boundery
#define selected_process mcckidney_union_master_selected_process
#define scattering_event mcckidney_union_master_scattering_event
#define time_propagated_without_scattering mcckidney_union_master_time_propagated_without_scattering
#define a_next_volume_found mcckidney_union_master_a_next_volume_found
#define next_volume mcckidney_union_master_next_volume
#define next_volume_priority mcckidney_union_master_next_volume_priority
#define done mcckidney_union_master_done
#define current_volume mcckidney_union_master_current_volume
#define number_of_solutions mcckidney_union_master_number_of_solutions
#define number_of_solutions_static mcckidney_union_master_number_of_solutions_static
#define check mcckidney_union_master_check
#define start mcckidney_union_master_start
#define intersection_with_children mcckidney_union_master_intersection_with_children
#define geometry_output mcckidney_union_master_geometry_output
#define tree_next_volume mcckidney_union_master_tree_next_volume
#define pre_allocated1 mcckidney_union_master_pre_allocated1
#define pre_allocated2 mcckidney_union_master_pre_allocated2
#define pre_allocated3 mcckidney_union_master_pre_allocated3
#define ray_position mcckidney_union_master_ray_position
#define ray_velocity mcckidney_union_master_ray_velocity
#define ray_velocity_final mcckidney_union_master_ray_velocity_final
#define volume_0_found mcckidney_union_master_volume_0_found
#define scattered_flag mcckidney_union_master_scattered_flag
#define scattered_flag_VP mcckidney_union_master_scattered_flag_VP
#define master_transposed_rotation_matrix mcckidney_union_master_master_transposed_rotation_matrix
#define temp_rotation_matrix mcckidney_union_master_temp_rotation_matrix
#define non_rotated_position mcckidney_union_master_non_rotated_position
#define rotated_position mcckidney_union_master_rotated_position
#define enable_tagging mcckidney_union_master_enable_tagging
#define stop_tagging_ray mcckidney_union_master_stop_tagging_ray
#define stop_creating_nodes mcckidney_union_master_stop_creating_nodes
#define enable_tagging_check mcckidney_union_master_enable_tagging_check
#define master_tagging_node_list mcckidney_union_master_master_tagging_node_list
#define current_tagging_node mcckidney_union_master_current_tagging_node
#define tagging_leaf_counter mcckidney_union_master_tagging_leaf_counter
#define number_of_scattering_events mcckidney_union_master_number_of_scattering_events
#define real_transmission_probability mcckidney_union_master_real_transmission_probability
#define mc_transmission_probability mcckidney_union_master_mc_transmission_probability
#define number_of_masks mcckidney_union_master_number_of_masks
#define number_of_masked_volumes mcckidney_union_master_number_of_masked_volumes
#define need_to_run_within_which_volume mcckidney_union_master_need_to_run_within_which_volume
#define mask_index_main mcckidney_union_master_mask_index_main
#define mask_iterate mcckidney_union_master_mask_iterate
#define mask_status_list mcckidney_union_master_mask_status_list
#define current_mask_intersect_list_status mcckidney_union_master_current_mask_intersect_list_status
#define mask_volume_index_list mcckidney_union_master_mask_volume_index_list
#define geometry_component_index_list mcckidney_union_master_geometry_component_index_list
#define Volume_copies_allocated mcckidney_union_master_Volume_copies_allocated
#define p_old mcckidney_union_master_p_old
#define this_logger mcckidney_union_master_this_logger
#define conditional_status mcckidney_union_master_conditional_status
#define tagging_conditional_list mcckidney_union_master_tagging_conditional_list
#define free_tagging_conditioanl_list mcckidney_union_master_free_tagging_conditioanl_list
#define logger_conditional_extend_array mcckidney_union_master_logger_conditional_extend_array
#define tagging_conditional_extend mcckidney_union_master_tagging_conditional_extend
#define max_conditional_extend_index mcckidney_union_master_max_conditional_extend_index
#define safty_distance mcckidney_union_master_safty_distance
#define safty_distance2 mcckidney_union_master_safty_distance2
#define number_of_processes_array mcckidney_union_master_number_of_processes_array
#define temporary_focus_data mcckidney_union_master_temporary_focus_data
#define focus_data_index mcckidney_union_master_focus_data_index
{   /* Declarations of kidney_union_master=Union_master() SETTING parameters. */
MCNUM allow_inside_start = mcckidney_union_master_allow_inside_start;
MCNUM history_limit = mcckidney_union_master_history_limit;
MCNUM enable_conditionals = mcckidney_union_master_enable_conditionals;
MCNUM inherit_number_of_scattering_events = mcckidney_union_master_inherit_number_of_scattering_events;
#line 856 "Union_master.comp"
{
  
  #ifdef Union_trace_verbal_setting
    printf("\n\n\n\n\n----------- NEW RAY -------------------------------------------------\n");
    printf("Union_master component name: %s \n \n",NAME_CURRENT_COMP);
  #endif
  
  // Initialize logic
  done = 0;
  error_msg = 0;
  clear_intersection_table(&intersection_time_table);
  
  time_propagated_without_scattering = 0;
  v_length = sqrt(vx*vx+vy*vy+vz*vz);
  
  // Initialize logger system / Statistics
  number_of_scattering_events = 0;
  
  if (inherit_number_of_scattering_events==1) // Continue number of scattering from previous Union_master
    number_of_scattering_events = global_master_list.elements[this_global_master_index-1].stored_number_of_scattering_events;
  
  // Zero scattered_flag_VP data
  for (volume_index = 1;volume_index<number_of_volumes;volume_index++) { // No reason to update volume 0, as scattering doesn't happen there
    scattered_flag[volume_index] = 0;
    for (process_index=0;process_index<number_of_processes_array[volume_index];process_index++)
      scattered_flag_VP[volume_index][process_index] = 0;
  }
  
  // If first Union_master in instrument, reset loggers_with_data_array and clean unused data.
  // Unused data happens when logging data is passed to the next Union_master, but the ray is absorbed on the way.
  // Could be improved by using the precompiler instead as ncount times the number of Union_masters could be avoided.
  if (global_master_list.elements[0].component_index == INDEX_CURRENT_COMP) {
    // If this is the first Union master, clean up logger data for rays that did not make it through Union components
    for (log_index=loggers_with_data_array.used_elements-1;log_index>-1;log_index--) {
      loggers_with_data_array.logger_pointers[log_index]->function_pointers.clear_temp(&loggers_with_data_array.logger_pointers[log_index]->data_union);
    }
    loggers_with_data_array.used_elements = 0;
  }
    
  tagging_conditional_extend = 0;
  for (iterate=0;iterate<max_conditional_extend_index+1;iterate++) {
    logger_conditional_extend_array[iterate] = 0;
  }

  // Need to clean up the double notation for position and velocity. // REVIEW_LINE
  r_start[0] = x; r_start[1] = y; r_start[2] = z;
  r[0]=x;r[1]=y;r[2]=z;v[0]=vx;v[1]=vy;v[2]=vz; // REVIEW_LINE r and v are bad names
  
  ray_position = coords_set(x,y,z);
  ray_velocity = coords_set(vx,vy,vz);
  
  // Mask update: need to check the mask status for the initial position
  // mask status for a mask is 1 if the ray position is inside, 0 if it is outside
  for (iterate=0;iterate<number_of_masks;iterate++) {
    if(Volumes[mask_volume_index_list.elements[iterate]]->geometry.within_function(ray_position,&Volumes[mask_volume_index_list.elements[iterate]]->geometry) == 1) {
      mask_status_list.elements[iterate] = 1;
    } else {
      mask_status_list.elements[iterate] = 0;
    }
  }
  
  #ifdef Union_trace_verbal_setting
    print_1d_int_list(mask_status_list,"Initial mask status list");
  #endif
  
  // Now the initial current_volume can be found, which requires the up to date mask_status_list
  current_volume = within_which_volume(ray_position,starting_lists.reduced_start_list,starting_lists.starting_destinations_list,Volumes,&mask_status_list,number_of_volumes,pre_allocated1,pre_allocated2,pre_allocated3);
  
  // Using the mask_status_list and the current volume, the current_mask_intersect_list_status can be made
  //  it contains the effective mask status of all volumes on the current volumes mask intersect list, which needs to be calculated,
  //  but only when the current volume or mask status changes, not under for example scattering inside the current volume
  update_current_mask_intersect_status(&current_mask_intersect_list_status, &mask_status_list, Volumes, &current_volume);
  
  #ifdef Union_trace_verbal_setting
    printf("Starting current_volume = %d\n",current_volume);
  #endif
  
  // Check if the ray appeared in an allowed starting volume, unless this check is disabled by the user for advanced cases
  if (allow_inside_start == 0 && starting_lists.allowed_starting_volume_logic_list.elements[current_volume] == 0) {
    printf("ERROR, ray ''teleported'' into Union component %s, if intentional, set allow_inside_start=1\n",NAME_CURRENT_COMP);
    exit(1);
  }
  // Warn the user that rays have appeared inside a volume instead of outside as expected
  if (starting_volume_warning == 0 && current_volume != 0) {
        printf("WARNING: Ray started in volume ''%s'' rather than the surrounding vacuum in component %s. This warning is only shown once.\n",Volumes[current_volume]->name,NAME_CURRENT_COMP);
        starting_volume_warning = 1;
  }
  
  // Placing the new ray at the start of the tagging tree corresponding to current volume
  // A history limit can be imposed so that no new nodes are created after this limit (may be necessary to fit in memory)
  // Rays can still follow the nodes created before even when no additional nodes are created, but if a situation that
  //  requires a new node is encountered, stop_tagging_ray is set to 1, stopping further tagging and preventing the data
  //  for that ray to be used further.
  if (enable_tagging) {
    current_tagging_node = master_tagging_node_list.elements[current_volume];
    stop_tagging_ray = 0; // Allow this ray to be tracked
    if (tagging_leaf_counter > history_limit) stop_creating_nodes = 1;
  }
  
  #ifdef Union_trace_verbal_setting
    if (enable_tagging) printf("current_tagging_node->intensity = %f\n",current_tagging_node->intensity);
    if (enable_tagging) printf("current_tagging_node->number_of_rays = %d \n",current_tagging_node->number_of_rays);
  #endif
  
  // Propagation loop including scattering
  // This while loop continues until the ray leaves the ensamble of user defined volumes either through volume 0
  //  or a dedicated exit volume. The loop is cancelled after a large number of iterations as a failsafe for errors.
  // A single run of the loop will either be a propagation to the next volume along the path of the ray, or a
  //  scattering event at some point along the path of the ray in the current volume.
  limit = 100000;
  while (done == 0) {
    limit--;
    
    #ifdef Union_trace_verbal_setting
      printf("----------- START OF WHILE LOOP --------------------------------------\n");
      print_intersection_table(intersection_time_table);
      printf("current_volume = %d \n",current_volume);
    #endif
    
    // Calculating intersections with the necessary volumes. The relevant set of volumes depend on the current volume and the mask status array.
    // First the volumes on the current volumes intersect list is checked, then its mask interset list. Before checking the volume itself, it is
    //  checked if any children of the current volume is intersected, in which case the intersection calculation with the current volume can be
    //  skipped.
    
    // Checking intersections for all volumes in the intersect list.
    for (start=check=Volumes[current_volume]->geometry.intersect_check_list.elements;check-start<Volumes[current_volume]->geometry.intersect_check_list.num_elements;check++) {
    // This will leave check as a pointer to the intergers in the intersect_check_list and iccrement nicely
        #ifdef Union_trace_verbal_setting
          printf("Intersect_list = %d being checked \n",*check);
        #endif
    
        if (intersection_time_table.calculated[*check] == 0) {
             #ifdef Union_trace_verbal_setting
               printf("running intersection for intersect_list with *check = %d \n",*check);
               // if (trace_verbal) printf("r = (%f,%f,%f) v = (%f,%f,%f) \n",r[0],r[1],r[2],v[0],v[1],v[2]);
             #endif
            // Calculate intersections using intersect function imbedded in the relevant volume structure using parameters
            //  that are also imbedded in the structure.
            geometry_output = Volumes[*check]->geometry.intersect_function(intersection_time_table.intersection_times[*check],number_of_solutions,r_start,v,&Volumes[*check]->geometry);
            intersection_time_table.calculated[*check] = 1;
            // if (trace_verbal) printf("succesfully calculated intersection times for volume *check = %d \n",*check);
        }
    }
    
    // Mask update: add additional loop for checking intersections with masked volumes depending on mask statuses
    for (mask_iterate=0;mask_iterate<Volumes[current_volume]->geometry.mask_intersect_list.num_elements;mask_iterate++) {
      if (current_mask_intersect_list_status.elements[mask_iterate] == 1) { // Only check if the mask is active
        #ifdef Union_trace_verbal_setting
          printf("Mask Intersect_list = %d being checked \n",Volumes[current_volume]->geometry.mask_intersect_list.elements[mask_iterate]);
        #endif
        if (intersection_time_table.calculated[Volumes[current_volume]->geometry.mask_intersect_list.elements[mask_iterate]] == 0) {
          #ifdef Union_trace_verbal_setting
            printf("running intersection for mask_intersect_list element = %d \n",Volumes[current_volume]->geometry.mask_intersect_list.elements[mask_iterate]);
          //  printf("r = (%f,%f,%f) v = (%f,%f,%f) \n",r[0],r[1],r[2],v[0],v[1],v[2]);
          #endif
          // Calculate intersections using intersect function imbedded in the relevant volume structure using parameters
            //  that are also imbedded in the structure.
          geometry_output = Volumes[Volumes[current_volume]->geometry.mask_intersect_list.elements[mask_iterate]]->geometry.intersect_function(intersection_time_table.intersection_times[Volumes[current_volume]->geometry.mask_intersect_list.elements[mask_iterate]],number_of_solutions,r_start,v,&Volumes[Volumes[current_volume]->geometry.mask_intersect_list.elements[mask_iterate]]->geometry);
          intersection_time_table.calculated[Volumes[current_volume]->geometry.mask_intersect_list.elements[mask_iterate]] = 1;
          // if (trace_verbal) printf("succesfully calculated intersection times for volume *check = %d \n",*check);
        }
      }
    }
    
    // Checking if there are intersections with children of current volume, which means there is an intersection before current_volume, and thus can be skipped. But only if they have not been overwritten. In case current_volume is 0, there is no need to do this regardless.
    if (current_volume != 0 && intersection_time_table.calculated[current_volume] == 0) {
        #ifdef Union_trace_verbal_setting
          printf("Checking if children of current_volume = %d have intersections. \n",current_volume);
        #endif
        intersection_with_children = 0;
        //for (start = check = Volumes[current_volume]->geometry.direct_children.elements;check - start < Volumes[current_volume]->geometry.children.num_elements;check++) { // REVIEW LINE. Caused bug with masks.
        for (start = check = Volumes[current_volume]->geometry.children.elements;check - start < Volumes[current_volume]->geometry.children.num_elements;check++) {
            #ifdef Union_trace_verbal_setting
              printf("Checking if child %d of current_volume = %d have intersections. \n",*check,current_volume);
            #endif
            // Only check the first of the two results in the intersection table, as they are ordered, and the second is of no interest
            if (intersection_time_table.calculated[*check] == 1 && intersection_time_table.intersection_times[*check][0] > time_propagated_without_scattering) {
                // If this child is masked, its mask status need to be 1 in order to be taken into account
                if (Volumes[*check]->geometry.is_masked_volume == 0) {
                  #ifdef Union_trace_verbal_setting
                    printf("Found an child of current_volume with an intersection. Skips calculating for current_volume \n");
                  #endif
                  intersection_with_children = 1;
                  break; // No need to check more, if there is just one it is not necessary to calculate intersection with current_volume yet
                } else {
                  #ifdef Union_trace_verbal_setting
                    printf("Found an child of current_volume with an intersection, but it is masked. Check to see if it can skip calculating for current_volume \n");
                  #endif
                  
                  if (Volumes[*check]->geometry.mask_mode == 2) { // ANY mask mode
                    tree_next_volume = 0;
                    for (mask_start=mask_check=Volumes[*check]->geometry.masked_by_mask_index_list.elements;mask_check-mask_start<Volumes[*check]->geometry.masked_by_mask_index_list.num_elements;mask_check++) {
                       if (mask_status_list.elements[*mask_check] == 1) {
                         intersection_with_children = 1;
                         break;
                       }
                    }
                  } else { // ALL mask mode
                    intersection_with_children = 1;
                    for (mask_start=mask_check=Volumes[*check]->geometry.masked_by_mask_index_list.elements;mask_check-mask_start<Volumes[*check]->geometry.masked_by_mask_index_list.num_elements;mask_check++) {
                      if (mask_status_list.elements[*mask_check] == 0) {
                        intersection_with_children = 0;
                        break;
                      }
                    }
                  }
                  #ifdef Union_trace_verbal_setting
                    printf("The mask status was 1, can actually skip intersection calculation for current volume \n");
                  #endif
                  if (intersection_with_children == 1) break;
                }
            }
        }
        #ifdef Union_trace_verbal_setting
          printf("intersection_with_children = %d \n",intersection_with_children);
        #endif
        if (intersection_with_children == 0) {
            geometry_output = Volumes[current_volume]->geometry.intersect_function(intersection_time_table.intersection_times[current_volume],number_of_solutions,r_start,v,&Volumes[current_volume]->geometry);
            intersection_time_table.calculated[current_volume] = 1;
        }
    }

    // At this point, intersection_time_table is updated with intersection times of all possible intersections.
    #ifdef Union_trace_verbal_setting
      print_intersection_table(intersection_time_table);
    #endif
    
    // Next task is to find the next intersection time. The next intersection must be greater than the time_propagated_without_scattering (0 at start of loop)
    // Loops are eqvialent to the 3 intersection calculation loops already completed
    
    // First loop for checking intersect_check_list
    time_found = 0;
    for (start=check=Volumes[current_volume]->geometry.intersect_check_list.elements;check-start<Volumes[current_volume]->geometry.intersect_check_list.num_elements;check++) {
        for (solution = 0;solution<intersection_time_table.n_elements[*check];solution++) {
            if (time_found) {
                if ((intersection_time = intersection_time_table.intersection_times[*check][solution]) > time_propagated_without_scattering &&  intersection_time < min_intersection_time) {
                    min_intersection_time = intersection_time;min_solution = solution;min_volume = *check;
                }
            } else {
                if ((intersection_time = intersection_time_table.intersection_times[*check][solution]) > time_propagated_without_scattering) {
                    min_intersection_time = intersection_time;min_solution = solution;min_volume = *check;
                    time_found = 1;
                }
            }
        }
    }
    
    // Now check the masked_intersect_list, but only the ones that are currently active
    for (mask_iterate=0;mask_iterate<Volumes[current_volume]->geometry.mask_intersect_list.num_elements;mask_iterate++) {
      if (current_mask_intersect_list_status.elements[mask_iterate] == 1) {
        for (solution = 0;solution<intersection_time_table.n_elements[Volumes[current_volume]->geometry.mask_intersect_list.elements[mask_iterate]];solution++) {
            if (time_found) {
                if ((intersection_time = intersection_time_table.intersection_times[Volumes[current_volume]->geometry.mask_intersect_list.elements[mask_iterate]][solution]) > time_propagated_without_scattering &&  intersection_time < min_intersection_time) {
                    min_intersection_time = intersection_time;min_solution = solution;min_volume = Volumes[current_volume]->geometry.mask_intersect_list.elements[mask_iterate];
                }
            } else {
                if ((intersection_time = intersection_time_table.intersection_times[Volumes[current_volume]->geometry.mask_intersect_list.elements[mask_iterate]][solution]) > time_propagated_without_scattering) {
                    min_intersection_time = intersection_time;min_solution = solution;min_volume = Volumes[current_volume]->geometry.mask_intersect_list.elements[mask_iterate];
                    time_found = 1;
                }
            }
        }
      }
    }
    
    // And check the current_volume
    for (solution = 0;solution<intersection_time_table.n_elements[current_volume];solution++) {
        if (time_found) {
            if ((intersection_time = intersection_time_table.intersection_times[current_volume][solution]) > time_propagated_without_scattering && intersection_time < min_intersection_time) {
                min_intersection_time = intersection_time;min_solution = solution;min_volume = current_volume;
            }
        } else {
            if ((intersection_time = intersection_time_table.intersection_times[current_volume][solution]) > time_propagated_without_scattering) {
                min_intersection_time = intersection_time;min_solution = solution;min_volume = current_volume;
                time_found = 1;
            }
        }
    }
    
    #ifdef Union_trace_verbal_setting
      printf("min_intersection_time = %f \n",min_intersection_time);
      printf("min_solution          = %d \n",min_solution);
      printf("min_volume            = %d \n",min_volume);
      printf("time_found            = %d \n",time_found);
    #endif

    // If a time is found, propagation continues, and it will be checked if a scattering occurs before the next intersection.
    // If a time is not found, the ray must be leaving the ensamble of volumes and the loop will be concluded
    if (time_found) {
        time_to_boundery = min_intersection_time - time_propagated_without_scattering; // calculate the time remaining before the next intersection
        scattering_event = 0; // Assume a scattering event will not occur
        
        // Check if a scattering event should occur
        if (current_volume != 0) { // Volume 0 is always vacuum, and if this is the current volume, an event will not occur
          if (Volumes[current_volume]->p_physics->number_of_processes == 0) { // If there are no processes, the volume could be vacuum or an absorber
            if (Volumes[current_volume]->p_physics->is_vacuum == 0)
              // This volume does not have physical processes but does have an absorption cross section, so the ray weight is reduced accordingly
              p *= exp(-Volumes[current_volume]->p_physics->my_a*2200*time_to_boundery);
    
    
              //#ifdef Union_trace_verbal_setting
              //printf("name of material: %s \n",Volumes[current_volume]->name);
              //printf("length to boundery  = %f\n",length_to_boundery);
              //printf("absorption cross section  = %f\n",Volumes[current_volume]->p_physics->my_a);
              //printf("chance to get through this length of absorber: %f \%\n",100*exp(-Volumes[current_volume]->p_physics->my_a*length_to_boundery));
              //#endif
                    
          } else {
            // Since there is a non-zero number of processes in this material, all the scattering cross section for these are calculated
            my_sum = 0; k[0] = V2K*vx; k[1] = V2K*vy; k[2] = V2K*vz; p_my_trace = my_trace; wavevector = coords_set(k[0],k[1],k[2]);
            for (process_start = process = Volumes[current_volume]->p_physics->p_scattering_array;process - process_start < Volumes[current_volume]->p_physics->number_of_processes;process++) {
            
              if (Volumes[current_volume]->p_physics->p_scattering_array[process - process_start].non_isotropic_rot_index != -1) {
                // If the process is not isotropic, the wavevector is transformed into the local coordinate system of the process
                wavevector_rotated = rot_apply(Volumes[current_volume]->geometry.process_rot_matrix_array[Volumes[current_volume]->p_physics->p_scattering_array[process - process_start].non_isotropic_rot_index],wavevector);
                
                coords_get(wavevector_rotated,&k_rotated[0],&k_rotated[1],&k_rotated[2]);

              } else {
                k_rotated[0] = k[0]; k_rotated[1] = k[1]; k_rotated[2] = k[2];
              }
              
              // Find correct focus_data_array index for this volume/process
              focus_data_index = Volumes[current_volume]->geometry.focus_array_indices.elements[process - process_start];
              
              // Call the probability for scattering function assighed to this specific procress (the process pointer is updated in the for loop)
              process->probability_for_scattering_function(p_my_trace,k_rotated,process->data_transfer,&Volumes[current_volume]->geometry.focus_data_array.elements[focus_data_index]);
              
              my_sum += *p_my_trace;
              #ifdef Union_trace_verbal_setting
                printf("my_trace = %f, my_sum = %f\n",*p_my_trace,my_sum);
              #endif
              p_my_trace++; // increment the pointer so that it point to the next element (max number of process in any material is allocated)
            }
            
            #ifdef Union_trace_verbal_setting
              printf("time_propagated_without_scattering = %f.\n",time_propagated_without_scattering);
              printf("v_length                           = %f.\n",v_length);
            #endif
            
            length_to_boundery = time_to_boundery * v_length;
            
            #ifdef Union_trace_verbal_setting
              printf("exp(- length_to_boundery*my_sum) = %f. length_to_boundery = %f. my_sum = %f.\n",exp(-length_to_boundery*my_sum),length_to_boundery,my_sum);
            #endif
            
            // Selecting if a scattering takes place, and what scattering process.
            // This section have too many if statements, and unessecary calculations
            // Could make seperate functions for p_interact on/off and interact_fraction on/off,
            //   and set function pointers to these in initialize, thus avoiding many unessecary if statements and calculations of x/x.
            
            my_sum_plus_abs = my_sum + Volumes[current_volume]->p_physics->my_a*(2200/v_length);
            
            if (my_sum < 1E-18) {
                // The scattering cross section is basicly zero, no scattering should occur.
                scattering_event = 0;
                p *= exp(-length_to_boundery*my_sum_plus_abs); // Correct for absorption and the almost zero scattering
            } else if (length_to_boundery < safty_distance2) {
                // Too close to boundery to safly make another scattering, attenuate
                p *= exp(-length_to_boundery*my_sum_plus_abs); // Attentuate the beam for the small distance
                scattering_event = 0;
            } else {
                // The scattering cross section is above zero and the distance to the boundery is sufficient for a scattering
                if (Volumes[current_volume]->geometry.geometry_p_interact != 0) {
                    // a fraction of the beam (geometry_p_interact) is forced to scatter
                    real_transmission_probability = exp(-length_to_boundery*my_sum_plus_abs);
                    mc_transmission_probability = (1.0 - Volumes[current_volume]->geometry.geometry_p_interact);
                    if ((scattering_event = (rand01() > mc_transmission_probability))) {
                        // Scattering event happens, this is the correction for the weight
                        p *= (1.0-real_transmission_probability)/(1.0-mc_transmission_probability); // Absorption simulated in weight
                        // Find length to next scattering knowing the ray will scatter.
                        length_to_scattering = safty_distance -log(1.0 - rand0max((1.0 - exp(-my_sum_plus_abs*(length_to_boundery-safty_distance2))))) / my_sum_plus_abs;
                    } else {
                        // Scattering event does not happen, this is the appropriate correction
                        p *= real_transmission_probability/mc_transmission_probability; // Absorption simulated in weight
                    }
                } else {
                    // probability to scatter is the natural value
                    if(my_sum*length_to_boundery < 1e-6) { // Scattering probability very small, linear method is used as exponential is unreliable
                      if (length_to_boundery > safty_distance2) {
                        if (rand01() < exp(-length_to_boundery*my_sum_plus_abs)) {
                          // Scattering happens, use linear description to select scattering position
                          length_to_scattering = safty_distance + rand0max(length_to_boundery - safty_distance2);
                          // Weight factor necessary to correct for using the linear scattering position distribution
                          p *= length_to_boundery*my_sum*exp(-length_to_scattering*my_sum_plus_abs); // Absorption simulated in weight
                          scattering_event = 1;
                        } else scattering_event = 0;
                      } else {
                        // The distance is too short to reliably make a scattering event (in comparison to accuraccy of intersect functions)
                        p *= exp(-length_to_boundery*my_sum_plus_abs); // Attentuate the beam for the small distance
                        scattering_event = 0;
                      }
                    } else {
                        // Strong scattering, use exponential description to select scattering position between safetydistance and infinity
                        length_to_scattering = safty_distance -log(1 - rand01() ) / my_sum_plus_abs;
                        // Scattering happens if the scattering position is before the boundery (and safty distance)
                        if (length_to_scattering < length_to_boundery - safty_distance) scattering_event = 1;
                        else scattering_event = 0;
                    }
                }
                
                if (scattering_event == 1) {
                  // Adjust weight for absorption
                  p *= my_sum/my_sum_plus_abs;
                  // Safety feature, alert in case of nonsense my results / negative absorption
                  if (my_sum/my_sum_plus_abs > 1.0) printf("WARNING: Absorption weight factor above 1! Should not happen! \n");
                  // Select process
                  if (Volumes[current_volume]->p_physics->number_of_processes == 1) { // trivial case
                    // Select the only available process, which will always have index 0
                    selected_process = 0;
                  } else {
                    if (Volumes[current_volume]->p_physics->interact_control == 1) {
                      // Interact_fraction is used to influence the choice of process in this material
                      mc_prop = rand01();culmative_probability=0;total_process_interact=1.0;
                  
                      // If any of the processes have probability 0, they are excluded from the selection
                      for (iterate = 0;iterate < Volumes[current_volume]->p_physics->number_of_processes;iterate++) {
                        if (my_trace[iterate] < 1E-18) {
                          // When this happens, the total force probability is corrected and the probability for this particular instance is set to 0
                          total_process_interact -= Volumes[current_volume]->p_physics->p_scattering_array[iterate].process_p_interact;
                          my_trace_fraction_control[iterate] = 0;
                          // In cases where my_trace is not zero, the forced fraction is still used.
                        } else my_trace_fraction_control[iterate] = Volumes[current_volume]->p_physics->p_scattering_array[iterate].process_p_interact;
                      }
                      // Randomly select a process using the weights stored in my_trace_fraction_control divided by total_process_interact
                      for (iterate = 0;iterate < Volumes[current_volume]->p_physics->number_of_processes;iterate++) {
                        culmative_probability += my_trace_fraction_control[iterate]/total_process_interact;
                        if (culmative_probability > mc_prop) {
                          selected_process = iterate;
                          p *= (my_trace[iterate]/my_sum)*(total_process_interact/my_trace_fraction_control[iterate]);
                          break;
                        }
                      }
                    
                    } else {
                      // Select a process based on their relative attenuations factors
                      mc_prop = rand01();culmative_probability=0;
                      for (iterate = 0;iterate < Volumes[current_volume]->p_physics->number_of_processes;iterate++) {
                        culmative_probability += my_trace[iterate]/my_sum;
                        if (culmative_probability > mc_prop) {
                          selected_process = iterate;
                          break;
                        }
                      }
                    }
                  }
                } // end of select process
            }
            
          }
        } // Done checking for scttering event and in case of scattering selecting a process
     
        if (scattering_event == 1) {
            #ifdef Union_trace_verbal_setting
              printf("SCATTERING EVENT \n");
              printf("current_volume            = %d \n",current_volume);
              printf("r = (%f,%f,%f) v = (%f,%f,%f) \n",r[0],r[1],r[2],v[0],v[1],v[2]);
            // printf("did scatter: my_trace = %E = %f \n",my_trace[selected_process],my_trace[selected_process]);
            #endif
            
            // Calculate the time to scattering
            time_to_scattering = length_to_scattering/v_length;
            
            #ifdef Union_trace_verbal_setting
              printf("time to scattering        = %2.20f \n",time_to_scattering);
            #endif
            
            //#ifdef Union_trace_verbal_setting
            //printf("length to boundery = %f, length to scattering = %f \n",length_to_boundery,length_to_scattering);
            //#endif
            
            //PROP_DT(time_to_scattering); // May be replace by version without gravity
            
            // Reduce the double book keeping done here // REVIEW LINE
            x += time_to_scattering*vx; y += time_to_scattering*vy; z += time_to_scattering*vz; t += time_to_scattering;
            r_start[0] = x; r_start[1] = y; r_start[2] = z;
            r[0] = x; r[1] = y; r[2] = z;
            ray_position = coords_set(x,y,z);
            ray_velocity = coords_set(vx,vy,vz);
            
            // Safe check that should be unecessary. Used to fine tune how close to the edge of a volume a scattering event is allowed to take place (1E-14 m away currently).
            if (Volumes[current_volume]->geometry.within_function(ray_position,&Volumes[current_volume]->geometry) == 0) {
              printf("\nERROR, propagated out of current volume instead of to a point within!\n");
              printf("length_to_scattering_specified = %2.20f\n             length propagated = %2.20f\n            length_to_boundery = %2.20f \n   current_position = (%lf,%lf,%lf) \n",length_to_scattering,sqrt(time_to_scattering*time_to_scattering*vx*vx+time_to_scattering*time_to_scattering*vy*vy+time_to_scattering*time_to_scattering*vz*vz),length_to_boundery,x,y,z);
              
              volume_index = within_which_volume(ray_position,starting_lists.reduced_start_list,starting_lists.starting_destinations_list,Volumes,&mask_status_list,number_of_volumes,pre_allocated1,pre_allocated2,pre_allocated3);
              
              printf("Debug info: Volumes[current_volume]->name = %s, but now inside volume number %d named %s.\n",Volumes[current_volume]->name,volume_index,Volumes[volume_index]->name);
              printf("Ray absorbed \n");
              ABSORB;
            }
            
            // Save information before scattering event needed in logging section
            p_old = p;
            k_old[0] = k[0];k_old[1] = k[1];k_old[2] = k[2];
            
            // Find correct focus_data_array index for this volume/process
            focus_data_index = Volumes[current_volume]->geometry.focus_array_indices.elements[selected_process];
        
            // Rotation to local process coordinate system (for non isotropic processes)
            if (Volumes[current_volume]->p_physics->p_scattering_array[selected_process].non_isotropic_rot_index != -1) {
                ray_velocity_rotated = rot_apply(Volumes[current_volume]->geometry.process_rot_matrix_array[Volumes[current_volume]->p_physics->p_scattering_array[selected_process].non_isotropic_rot_index],ray_velocity);
            } else {
                ray_velocity_rotated = ray_velocity;
            }
                
            // test_physics_scattering(double *k_final, double *k_initial, union data_transfer_union data_transfer) {
            //k[0] = V2K*ray_velocity.x; k[1] = V2K*ray_velocity.y; k[2] = V2K*ray_velocity.z;
            coords_get(coords_scalar_mult(ray_velocity_rotated,V2K),&k[0],&k[1],&k[2]);
            
            // I may replace a intial and final k with one instance that serves as both input and output
            if (0 == Volumes[current_volume]->p_physics->p_scattering_array[selected_process].scattering_function(k_new,k,&p,Volumes[current_volume]->p_physics->p_scattering_array[selected_process].data_transfer,&Volumes[current_volume]->geometry.focus_data_array.elements[0])) {
              /*
              // PowderN and Single_crystal requires the option of absorbing the neutron, which is weird. If there is a scattering probability, there should be a new direction.
              // It can arise from need to simplify sampling process and end up in cases where weight factor is 0, and the ray should be absorbed in these cases
              printf("ERROR: Union_master: %s.Absorbed ray because scattering function returned 0 (error/absorb)\n",NAME_CURRENT_COMP);
              component_error_msg++;
              if (component_error_msg > 100) {
                printf("To many errors encountered, exiting. \n");
                exit(1);
              }
              */
              ABSORB;
            }
            
            // Update velocity using k
            ray_velocity_rotated = coords_set(K2V*k_new[0],K2V*k_new[1],K2V*k_new[2]);
            
            // Transformation back to main coordinate system (maybe one should only do this when multiple scattering in that volume was over, especially if there is only one non isotropic frame)
            if (Volumes[current_volume]->p_physics->p_scattering_array[selected_process].non_isotropic_rot_index != -1) {
                ray_velocity_final = rot_apply(Volumes[current_volume]->geometry.transpose_process_rot_matrix_array[Volumes[current_volume]->p_physics->p_scattering_array[selected_process].non_isotropic_rot_index],ray_velocity_rotated);
            } else {
               ray_velocity_final = ray_velocity_rotated;
            }
            
            // Write velocity to global variable (temp, only really necessary at final)
            //vx = ray_velocity.x; vy = ray_velocity.y; vz = ray_velocity.z;
            coords_get(ray_velocity_final,&vx,&vy,&vz);
            
            // Write velocity in array format as it is still used by intersect functions (temp, they need to be updated to ray_position / ray_velocity)
            v[0] = vx; v[1] = vy; v[2] = vz;
            v_length = sqrt(vx*vx+vy*vy+vz*vz);
            k_new[0] = V2K*vx; k_new[1] = V2K*vy; k_new[2] = V2K*vz;
            if (verbal) if (v_length < 1) printf("velocity set to less than 1\n");
            
            #ifdef Union_trace_verbal_setting
              printf("Running logger system for specific volumes \n");
            #endif
            // Logging for detector components assosiated with this volume
            for (log_index=0;log_index<Volumes[current_volume]->loggers.num_elements;log_index++) {
              //printf("logging time! Volume specific version. Volume name = %s \n",Volumes[current_volume]->name);
              //printf("  log_index = %d \n",log_index);
              if (Volumes[current_volume]->loggers.p_logger_volume[log_index].p_logger_process[selected_process] != NULL) {
                // Technically the scattering function could edit k, the wavevector before the scattering, even though there would be little point to doing that.
                // Could save a secure copy and pass that instead to be certain that no scattering process accidently tampers with the logging.
                // printf("  the logging function pointer was not NULL \n");
                // PV (number of time scattered in this volume/process combination is not recorded. Need to expand scattering_flag to contain 2D, volume and process
                
                // This function calls a logger function which in turn stores some data among the passed, and possibly performs some basic data analysis
                Volumes[current_volume]->loggers.p_logger_volume[log_index].p_logger_process[selected_process]->function_pointers.active_record_function(&ray_position,k_new,k_old,p,p_old,t,scattered_flag[current_volume],scattered_flag_VP[current_volume][selected_process],number_of_scattering_events,Volumes[current_volume]->loggers.p_logger_volume[log_index].p_logger_process[selected_process],&loggers_with_data_array);
                // If the logging component have a conditional attatched, the collected data will be written to a temporary place
                // At the end of the rays life, it will be checked if the condition is met
                //  if it is met, the temporary data is transfered to permanent, and temp is cleared.
                //  if it is not met, the temporary data is cleared.
              }
            }
            
            #ifdef Union_trace_verbal_setting
              printf("Running logger system for all volumes \n");
            #endif
            for (log_index=0;log_index<global_all_volume_logger_list.num_elements;log_index++) {
              //printf("logging time! Global version. log_index = %d \n",log_index);
              // As above, but on a global scale, meaning scattering in all volumes are logged
              
              // Problems with VN, PV, as there is no assosiated volume or process. The functions however need to have the same input to make the logger components general.
              // Could be interesting to have a monitor that just globally measurres the second scattering event in any volume (must be two in the same). Weird but not meaningless.
              global_all_volume_logger_list.elements[log_index].logger->function_pointers.active_record_function(&ray_position,k_new,k_old,p,p_old,t,scattered_flag[current_volume],scattered_flag_VP[current_volume][selected_process],number_of_scattering_events,global_all_volume_logger_list.elements[log_index].logger,&loggers_with_data_array);
            }
            
            
            SCATTER;
            ++number_of_scattering_events;
            ++scattered_flag[current_volume];
            ++scattered_flag_VP[current_volume][selected_process];
            

            // Empty intersection time lists
            clear_intersection_table(&intersection_time_table);
            time_propagated_without_scattering = 0.0;
            #ifdef Union_trace_verbal_setting
              printf("SCATTERED SUCSSESFULLY \n");
              printf("r = (%f,%f,%f) v = (%f,%f,%f) \n",x,y,z,vx,vy,vz);
            
              if (enable_tagging && stop_tagging_ray == 0) printf("Before new process node: current_tagging_node->intensity = %f\n",current_tagging_node->intensity);
              if (enable_tagging && stop_tagging_ray == 0) printf("Before new process node: current_tagging_node->number_of_rays = %d\n",current_tagging_node->number_of_rays);
            #endif
            
            if (enable_tagging && stop_tagging_ray == 0)
                current_tagging_node = goto_process_node(current_tagging_node,selected_process,Volumes[current_volume],&stop_tagging_ray,stop_creating_nodes);
            
            #ifdef Union_trace_verbal_setting
              if (enable_tagging && stop_tagging_ray == 0) printf("After new process node: current_tagging_node->intensity = %f\n",current_tagging_node->intensity);
              if (enable_tagging && stop_tagging_ray == 0) printf("After new process node: current_tagging_node->number_of_rays = %d\n",current_tagging_node->number_of_rays);
            #endif
            
        } else {
            #ifdef Union_trace_verbal_setting
              printf("Propagate out of volume %d\n", current_volume);
              printf("r = (%f,%f,%f) v = (%f,%f,%f) \n",x,y,z,vx,vy,vz);
            #endif
            // Propagate neutron to found minimum time
            // PROP_DT(min_intersection_time - time_propagated_without_scattering);
            //time_to_boundery = min_intersection_time - time_propagated_without_scattering;
            x += time_to_boundery*vx;
            y += time_to_boundery*vy;
            z += time_to_boundery*vz;
            t += time_to_boundery;
            r[0] = x; r[1] = y; r[2] = z;
            ray_position = coords_set(x,y,z);
            ray_velocity = coords_set(vx,vy,vz);
            
            /*
            // Absorption moved to before testing if scattering occurs
            if (current_volume != 0) {
                if (Volumes[current_volume]->p_physics->is_vacuum == 0) {
                    // Absorption is done explicitly when propagating out of a volume, but between all scattering events is done implicitly
                   
                    // Old version
                    //length_to_boundery = (min_intersection_time - time_propagated_without_scattering) * v_length;
                    //p *= exp(-Volumes[current_volume]->p_physics->my_a*(2200/v_length)*length_to_boundery);
                    
                    if (Volumes[current_volume]->p_physics->number_of_processes == 0) {
                      // Optimized version
                      //p *= exp(-Volumes[current_volume]->p_physics->my_a*2200*time_to_boundery);
                    
                    //printf("name of material: %s \n",Volumes[current_volume]->name);
                    //printf("length to boundery  = %f\n",length_to_boundery);
                    //printf("absorption cross section  = %f\n",Volumes[current_volume]->p_physics->my_a);
                    //printf("chance to get through this length of absorber: %f \%\n",100*exp(-Volumes[current_volume]->p_physics->my_a*length_to_boundery));
                    }
                }
            }
            */
            
            time_propagated_without_scattering = min_intersection_time;
            SCATTER; // For debugging purposes
            #ifdef Union_trace_verbal_setting
              printf("r = (%f,%f,%f) v = (%f,%f,%f) \n",x,y,z,vx,vy,vz);
            #endif
            // Remove this entry from the intersection_time_table
            intersection_time_table.intersection_times[min_volume][min_solution] = -1;
            
            // Use destination list for corresponding intersection entry n,i) to find next volume
            #ifdef Union_trace_verbal_setting
              printf("PROPAGATION FROM VOLUME %d \n",current_volume);
            #endif
            if (min_volume == current_volume) {
                #ifdef Union_trace_verbal_setting
                  printf("min_volume == current_volume \n");
                #endif
                // List approach to finding the next volume.
                // When the ray intersects the current volume, the next volume must be on the destination list of the current volume
                // However, the reduced_destination_list can be investigated first, and depending on the results, the
                //  direct children of the volumes on the reduced destination list are investigated.
                // In the worst case, all direct children are investigated, which is eqvivalent to the entire destination list.
                // There is however a certain overhead in the logic needed to set up this tree, avoid duplicates of direct children, and so on.
                // This method is only faster than just checking the destination list when there are direct children (nested structures),
                //  but in general the tree method scales better with complexity, and is only slightly slower in simple cases.
                
                if (Volumes[current_volume]->geometry.destinations_list.num_elements == 1)
                    tree_next_volume = Volumes[current_volume]->geometry.destinations_list.elements[0];
                else {
                    ray_position = coords_set(x,y,z);
                    ray_velocity = coords_set(vx,vy,vz);
                    tree_next_volume = within_which_volume(ray_position,Volumes[current_volume]->geometry.reduced_destinations_list,Volumes[current_volume]->geometry.destinations_list,Volumes,&mask_status_list,number_of_volumes,pre_allocated1,pre_allocated2,pre_allocated3);
                }

                #ifdef Union_trace_verbal_setting
                  if (trace_verbal) printf("tree method moves from %d to %d\n",current_volume,tree_next_volume);
                
                  if (enable_tagging && stop_tagging_ray == 0) printf("Before new tree volume node: current_tagging_node->intensity = %f\n",current_tagging_node->intensity);
                  if (enable_tagging && stop_tagging_ray == 0) printf("Before new tree volume node: current_tagging_node->number_of_rays = %d\n",current_tagging_node->number_of_rays);
                #endif
                
                if (enable_tagging && stop_tagging_ray == 0)
                    current_tagging_node = goto_volume_node(current_tagging_node, current_volume, tree_next_volume, Volumes,&stop_tagging_ray,stop_creating_nodes);
                
                #ifdef Union_trace_verbal_setting
                  if (enable_tagging && stop_tagging_ray == 0) printf("After new tree volume node: current_tagging_node->intensity = %f\n",current_tagging_node->intensity);
                  if (enable_tagging && stop_tagging_ray == 0) printf("After new tree volume node: current_tagging_node->number_of_rays = %d\n",current_tagging_node->number_of_rays);
                #endif
                
                // Set next volume to the solution found in the tree method
                current_volume = tree_next_volume;
                update_current_mask_intersect_status(&current_mask_intersect_list_status, &mask_status_list, Volumes, &current_volume);
                #ifdef Union_trace_verbal_setting
                  print_1d_int_list(current_mask_intersect_list_status,"Updated current_mask_intersect_list_status");
                #endif
                
                
                // Debugging phase
                /*
                if (tree_next_volume == 0) {
                    volume_0_found=0;
                    for (start = check = Volumes[current_volume]->geometry.destinations_list.elements;check - start < Volumes[current_volume]->geometry.destinations_list.num_elements;check++) {
                        if (*check == 0) {
                            volume_0_found = 1;
                        }
                    }
                    if (volume_0_found==0) printf("ERROR The within_which_volume function returned 0 for a volume where volume 0 is not on the destination list!\n");
                }
                */
                
            } else {
                #ifdef Union_trace_verbal_setting
                  if (enable_tagging && stop_tagging_ray == 0) printf("Before new intersection volume node: current_tagging_node->intensity = %f\n",current_tagging_node->intensity);
                  if (enable_tagging && stop_tagging_ray == 0) printf("Before new intersection volume node: current_tagging_node->number_of_rays = %d\n",current_tagging_node->number_of_rays);
                #endif
            
                //if (enable_tagging) current_tagging_node = goto_volume_node(current_tagging_node, current_volume, min_volume, Volumes);
                
                
                
                // Mask update: If the min_volume is not a mask, things are simple, current_volume = min_volume.
                //               however, if it is a mask, the mask status will switch.
                //               if the mask status becomes one, the masked volumes inside may be the next volume (unless they are children of the mask)
                //               if the mask status becomes zero (and the current volume is masked by min_volume), the destinations list of the mask is searched
                //               if the mask status becomes zero (and the current volume is NOT masked by min volume), the current volume doesn't change
                
                
                if (Volumes[min_volume]->geometry.is_mask_volume == 0) {
                  #ifdef Union_trace_verbal_setting
                    printf("Min volume is not a mask, next volume = min volume\n");
                  #endif
                  if (enable_tagging && stop_tagging_ray == 0) current_tagging_node = goto_volume_node(current_tagging_node, current_volume, min_volume, Volumes,&stop_tagging_ray,stop_creating_nodes);
                  current_volume = min_volume;
                  //update_current_mask_intersect_status(&current_mask_intersect_list_status, &mask_status_list, Volumes, &current_volume);
                } else {
                  #ifdef Union_trace_verbal_setting
                    printf("Current volume is not a mask, complex decision tree\n");
                  #endif
                  if (mask_status_list.elements[Volumes[min_volume]->geometry.mask_index] == 1) {
                    // We are leaving the mask, change the status
                    #ifdef Union_trace_verbal_setting
                      printf("mask status changed from 1 to 0 as a mask is left\n");
                    #endif
                    mask_status_list.elements[Volumes[min_volume]->geometry.mask_index] = 0;
                    // If the current volume is masked by this mask, run within_which_volume using the masks destination list, otherwise keep the current volume
                    //if (on_int_list(Volumes[min_volume]->geometry.mask_list,current_volume))
                    if (on_int_list(Volumes[current_volume]->geometry.masked_by_list,min_volume) == 1) {
                      #ifdef Union_trace_verbal_setting
                        printf("The current volume was masked by this mask, and my need updating\n");
                      #endif
                      // In case of ANY mode, need to see if another mask on the masked_by list of the current volume is active, and if so, nothing happens
                      need_to_run_within_which_volume = 1;
                      if (Volumes[current_volume]->geometry.mask_mode == 2) {
                        for (mask_start=mask_check=Volumes[current_volume]->geometry.masked_by_mask_index_list.elements;mask_check-mask_start<Volumes[current_volume]->geometry.masked_by_mask_index_list.num_elements;mask_check++) {
                          if (mask_status_list.elements[*mask_check] == 1) {
                            // Nothing needs to be done, the effective mask status of the current volume is still 1
                            need_to_run_within_which_volume = 0;
                            break;
                          }
                        }
                      }
                      if (need_to_run_within_which_volume == 1) {
                        #ifdef Union_trace_verbal_setting
                          printf("The current volume was masked by this mask, and does need updating\n");
                        #endif
                        if (Volumes[min_volume]->geometry.destinations_list.num_elements == 1) {
                          #ifdef Union_trace_verbal_setting
                            printf("Only one element in the destination tree of the mask\n");
                          #endif
                          // If there is only one element on the destinations list (quite common) there is no reason to run within_which_volume
                          // Instead the mask status is calculated here
                          if (Volumes[Volumes[min_volume]->geometry.destinations_list.elements[0]]->geometry.is_masked_volume == 1) {
                            #ifdef Union_trace_verbal_setting
                              printf("The one element is however masked, so the mask status need to be calculated\n");
                            #endif
                            // figure out the effective mask status of this volume
                            if (Volumes[Volumes[min_volume]->geometry.destinations_list.elements[0]]->geometry.mask_mode == 2) { // ANY mask mode
                              tree_next_volume = 0;
                              for (mask_start=mask_check=Volumes[Volumes[min_volume]->geometry.destinations_list.elements[0]]->geometry.masked_by_mask_index_list.elements;mask_check-mask_start<Volumes[Volumes[min_volume]->geometry.destinations_list.elements[0]]->geometry.masked_by_mask_index_list.num_elements;mask_check++) {
                                if (mask_status_list.elements[*mask_check] == 1) {
                                  tree_next_volume = Volumes[min_volume]->geometry.destinations_list.elements[0];
                                  break;
                                }
                              }
                            } else { // ALL mask mode
                              tree_next_volume = Volumes[min_volume]->geometry.destinations_list.elements[0];
                              for (mask_start=mask_check=Volumes[Volumes[min_volume]->geometry.destinations_list.elements[0]]->geometry.masked_by_mask_index_list.elements;mask_check-mask_start<Volumes[Volumes[min_volume]->geometry.destinations_list.elements[0]]->geometry.masked_by_mask_index_list.num_elements;mask_check++) {
                                if (mask_status_list.elements[*mask_check] == 0) {
                                  tree_next_volume = 0;
                                  break;
                                }
                              }
                            }
                          } else tree_next_volume = Volumes[min_volume]->geometry.destinations_list.elements[0];
                          #ifdef Union_trace_verbal_setting
                            printf("The method found the next tree volume to be %d\n",tree_next_volume);
                          #endif
                          if (enable_tagging && stop_tagging_ray == 0) current_tagging_node = goto_volume_node(current_tagging_node, current_volume, tree_next_volume, Volumes,&stop_tagging_ray,stop_creating_nodes);
                          current_volume = tree_next_volume;
                          //update_current_mask_intersect_status(&current_mask_intersect_list_status, &mask_status_list, Volumes, &current_volume);
                        } else {
                          #ifdef Union_trace_verbal_setting
                            printf("Many elements in destinations list, use within_which_volume\n");
                          #endif
                          ray_position = coords_set(x,y,z);
                          ray_velocity = coords_set(vx,vy,vz);
                          tree_next_volume = within_which_volume(ray_position,Volumes[min_volume]->geometry.reduced_destinations_list,Volumes[min_volume]->geometry.destinations_list,Volumes,&mask_status_list,number_of_volumes,pre_allocated1,pre_allocated2,pre_allocated3);
                        // } Bug fixed on 27/11/2016
                          if (enable_tagging && stop_tagging_ray == 0) current_tagging_node = goto_volume_node(current_tagging_node, current_volume, tree_next_volume, Volumes,&stop_tagging_ray,stop_creating_nodes);
                          current_volume = tree_next_volume;
                          #ifdef Union_trace_verbal_setting
                            printf("Set new new volume to %d\n",tree_next_volume);
                          #endif
                        } // Moved here on 27/11/2016, problem was two calls to current_tagging_node when only one element in destinations list
                        //update_current_mask_intersect_status(&current_mask_intersect_list_status, &mask_status_list, Volumes, &current_volume);
                      } else {
                        #ifdef Union_trace_verbal_setting
                          printf("Did not need updating, as another mask was covering the volume\n");
                        #endif
                      }
                    }

                  } else {
                    // Here beccause the mask status of the mask that is intersected was 0, and it is thus switched to 1
                    mask_status_list.elements[Volumes[min_volume]->geometry.mask_index] = 1;
                    // When entering a mask, the new highest priority volume may be one of the masked volumes, if not we keep the current volume
                    ray_position = coords_set(x,y,z);
                    ray_velocity = coords_set(vx,vy,vz);
                    //tree_next_volume = within_which_volume(ray_position,Volumes[min_volume]->geometry.mask_list,Volumes[min_volume]->geometry.destinations_list,Volumes,&mask_status_list,number_of_volumes,pre_allocated1,pre_allocated2,pre_allocated3);
                    // Bug found on the 2/9 2016, the destinations_list of a mask does not contain the volumes inside it. Could make an additional list for this.
                    // The temporary fix will be to use the mask list for both reduced destinations list and destinations list.
                    tree_next_volume = within_which_volume(ray_position,Volumes[min_volume]->geometry.mask_list,Volumes[min_volume]->geometry.mask_list,Volumes,&mask_status_list,number_of_volumes,pre_allocated1,pre_allocated2,pre_allocated3);
                    // if within_which_volume returns 0, no result was found (volume 0 can not be masked, so it could not be on the mask list)
                    if (tree_next_volume != 0) {
                      if (Volumes[tree_next_volume]->geometry.priority_value > Volumes[current_volume]->geometry.priority_value) {
                        // In case the current volume has a higher priority, nothing happens, otherwise change current volume
                        if (enable_tagging && stop_tagging_ray == 0) current_tagging_node = goto_volume_node(current_tagging_node, current_volume, tree_next_volume, Volumes,&stop_tagging_ray,stop_creating_nodes);
                        current_volume = tree_next_volume;
                      }
                    }
                    //update_current_mask_intersect_status(&current_mask_intersect_list_status, &mask_status_list, Volumes, &current_volume);
                  }
                }
                
                // Regardless of the outcome of the above code, either the mask status or current volume have changed, and thus a effective mask update is needed.
                update_current_mask_intersect_status(&current_mask_intersect_list_status, &mask_status_list, Volumes, &current_volume);
                #ifdef Union_trace_verbal_setting
                  print_1d_int_list(mask_status_list,"Updated mask status list");
                  print_1d_int_list(current_mask_intersect_list_status,"Updated current_mask_intersect_list_status");
                
                  if (enable_tagging) printf("After new intersection volume node: current_tagging_node->intensity = %f\n",current_tagging_node->intensity);
                  if (enable_tagging) printf("After new intersection volume node: current_tagging_node->number_of_rays = %d\n",current_tagging_node->number_of_rays);
                #endif
                
            }
            if (Volumes[current_volume]->geometry.is_exit_volume==1) {
                    done = 1; // Exit volumes allow the ray to escape the component
                    ray_sucseeded = 1; // Allows the ray to
                    /*
                    // Moved to after while loop to collect code
                    if (enable_tagging && stop_tagging_ray == 0)
                        add_statistics_to_node(current_tagging_node,&ray_position, &ray_velocity, &p, &tagging_leaf_counter);
                
                    x += vx*1E-9; y += vy*1E-9; z += vz*1E-9; t += 1E-9;
                    */
            }
            #ifdef Union_trace_verbal_setting
              printf(" TO VOLUME %d \n",current_volume);
            #endif
        }
    } else { // Here because a shortest time is not found
        if (current_volume == 0) {
            done = 1;
            ray_sucseeded = 1;
            
        } else { // Check for errors (debugging phase)
            if (error_msg == 0) {
              component_error_msg++;
              ray_sucseeded = 0;
              done = 1; // stop the loop
              printf("\n----------------------------------------------------------------------------------------------------\n");
              printf("Union_master %s: Somehow reached a situation with no intersection time found, but still inside volume %d instead of 0\n",NAME_CURRENT_COMP,current_volume);
              for (volume_index = 1; volume_index < number_of_volumes; volume_index++) {
                if (Volumes[volume_index]->geometry.within_function(ray_position,&Volumes[volume_index]->geometry) == 1)
                    printf("The ray is in volume       %d\n",volume_index);
              }
              
              print_1d_int_list(mask_status_list,"mask status list");
              for (iterate=0;iterate<number_of_volumes;iterate++)
                 printf("%d:%d - ",iterate,scattered_flag[iterate]);
              printf("\n");
              printf("r = (%f,%f,%f) v = (%f,%f,%f) \n",x,y,z,vx,vy,vz);
              
              printf("Trace error number (%d/100) \n",component_error_msg);
              //print_intersection_table(intersection_time_table);
              //printf("Cluster is loosing the thread, debug for this behavior\n");
              //printf("global_all_volume_logger_list.num_elements = %d\n",global_all_volume_logger_list.num_elements);
              //printf("global_specific_volumes_logger_list.num_elements = %d\n",global_specific_volumes_logger_list.num_elements);
              
              //exit(1); // Temporary
            }
            error_msg++;
            
            //exit(1); // temp for debug
            
            if (component_error_msg > 100) {
                printf("To many errors encountered, exiting. \n");
                exit(1);
            }
        }
    }
    /*
    */
    if (limit == 0) {done = 1; ray_sucseeded = 0; printf("Reached limit on number of interactions, and discarded the neutron, was in volume %d\n",current_volume);ABSORB;}
    #ifdef Union_trace_verbal_setting
      printf("----------- END OF WHILE LOOP --------------------------------------\n");
    #endif
    //printf("This ray did %d iterations in the while loop\n",1000-limit);
    
  }
  // Could move all add_statistics and similar to this point, but need to filter for failed rays
  if (ray_sucseeded == 1) {
    
    /*
    // Instead of keeping global and specific loggers apart, lets do them in one loop using the loggers_with_data_array
    // Only needed for conditionals
    // Loop over global loggers, may or may not have a conditional, only necessary to do anything here when they do.
    for (log_index=0;log_index<global_all_volume_logger_list.num_elements;log_index++) {
      if (global_all_volume_logger_list.elements[log_index].logger->has_conditional == 1) {
        if (1 == conditional_return = global_all_volume_logger_list.elements[log_index].logger->conditional(scattered_flag,scattered_flag_VP,global_loggers.elements[log_index].conditional_data_union,k_final,current_volume,x,y,z)) {
          global_all_volume_logger_list.elements[log_index].logger->function_pointers->temp_to_perm(global_loggers.elements[log_index].logger_data_union);
          
        }
        if (global_all_volume_logger_list.elements[log_index].logger->conditional_extend_index != -1)
          // The user can set a condtional_extend_index, so that the evaluation of this specific conditional can be taken easily from extend
          conditional_extend_array.elements[global_all_volume_logger_list.elements[log_index].logger->conditional_extend_index] = conditional_return;
          // Do not need to reset these to 0, as they will be manually set to 0 if not fulfilled
      }
    }
    */
    #ifdef Union_trace_verbal_setting
      printf("----------- logger loop --------------------------------------\n");
    #endif
    // Loggers attatched to specific volumes need to be handled with care to avoid looping over all loggers for every ray
    //for (log_index=0;log_index<loggers_with_data_array.used_elements;log_index++) {
    // TEST
    if (enable_conditionals == 1) {
      for (log_index=loggers_with_data_array.used_elements-1;log_index>-1;log_index--) {
        // Check all conditionals attatched to the current logger
        this_logger = loggers_with_data_array.logger_pointers[log_index];
        conditional_status = 1;
        for (iterate=0;iterate<loggers_with_data_array.logger_pointers[log_index]->conditional_list.num_elements;iterate++) {
          // Call this particular conditional. If it fails, report the status and break
          //printf("checking conditional! \n");
          #ifdef Union_trace_verbal_setting
            printf("Checking conditional number %d for logger named %s \n",iterate,loggers_with_data_array.logger_pointers[log_index]->name);
          #endif
          if (0 == this_logger->conditional_list.conditional_functions[iterate](
                         this_logger->conditional_list.p_data_unions[iterate],
                         &ray_position,&ray_velocity,&p,&t,&current_volume,
                         &number_of_scattering_events,scattered_flag,scattered_flag_VP)) {
            conditional_status = 0;
            break;
          }
        }
        if (conditional_status == 1) {
          // If a logger does not have a conditional, it will write directly to perm, and not even add it to the loggers_with_data_array, thus we know the temp_to_perm function needs to be called
          // The input for the temp_to_perm function is a pointer to the logger_data_union for the appropriate logger
          
          if (loggers_with_data_array.logger_pointers[log_index]->function_pointers.select_t_to_p == 1) {
            loggers_with_data_array.logger_pointers[log_index]->function_pointers.temp_to_perm(&loggers_with_data_array.logger_pointers[log_index]->data_union);
          }
          else if (loggers_with_data_array.logger_pointers[log_index]->function_pointers.select_t_to_p == 2) {
            loggers_with_data_array.logger_pointers[log_index]->function_pointers.temp_to_perm_final_p(&loggers_with_data_array.logger_pointers[log_index]->data_union,p);
          }
        
          // Luxury feature to be added later
          if (loggers_with_data_array.logger_pointers[log_index]->logger_extend_index != -1) {
            #ifdef Union_trace_verbal_setting
              printf("Updating logger_conditional_extend_array[%d] to 1 (max length = %d)\n",loggers_with_data_array.logger_pointers[log_index]->logger_extend_index,max_conditional_extend_index);
            #endif
            // The user can set a condtional_extend_index, so that the evaluation of this specific conditional can be taken easily from extend
            logger_conditional_extend_array[loggers_with_data_array.logger_pointers[log_index]->logger_extend_index] = 1;
            // Are all reset to 0 for each new ray
            #ifdef Union_trace_verbal_setting
              printf("Updated extend index sucessfully\n");
            #endif
          
            //printf("extend_array[%d] = 1 \n",loggers_with_data_array.logger_pointers[log_index]->logger_extend_index);
          }
        
          // Need to remove the current element from logger_with_data as it has been cleared and written to disk
          // The remaining elements is passed on to the next Union_master as it may fulfill the conditional after that master
          if (global_master_list.elements[global_master_list.num_elements-1].component_index != INDEX_CURRENT_COMP) {
            // Move current logger pointer in logger_with_data to end position
            loggers_with_data_array.logger_pointers[log_index] = loggers_with_data_array.logger_pointers[loggers_with_data_array.used_elements-1];
            // Decrease logger_with_data.used_elements with 1
            loggers_with_data_array.used_elements--;
          
          }
        
        
        } else {
           // Conditional status was 0, clear temp data for this logger, but only if this is the last Union_master,
           //  as the logger data can be written if one of the ray fulfills the conditional afer one of the
           //  subsequent Union masters.
           // The job of cleaning was moved to the start of trace on 15/5/2017
           //if (global_master_list.elements[global_master_list.num_elements-1].component_index == INDEX_CURRENT_COMP)
           //  loggers_with_data_array.logger_pointers[log_index]->function_pointers.clear_temp(&loggers_with_data_array.logger_pointers[log_index]->data_union);
        }
      }
    }
    
    if (enable_tagging && stop_tagging_ray == 0) {
      conditional_status = 1;
      for (iterate=0;iterate<tagging_conditional_list->num_elements;iterate++) {
        // Call this particular conditional. If it fails, report the status and break
        // Since a conditional can work for a logger and master_tagging at the same time, it may be evaluated twice
        //printf("checking conditional! \n");
        #ifdef Union_trace_verbal_setting
          printf("Checking tagging conditional number %d\n",iterate);
        #endif
        if (0 == tagging_conditional_list->conditional_functions[iterate](
                         tagging_conditional_list->p_data_unions[iterate],
                         &ray_position,&ray_velocity,&p,&t,&current_volume,
                         &number_of_scattering_events,scattered_flag,scattered_flag_VP)) {
          conditional_status = 0;
          break;
        }
      }
      if (conditional_status == 1) {
        tagging_conditional_extend = 1;
        #ifdef Union_trace_verbal_setting
          printf("Before adding statistics to node: current_tagging_nodbe->intensity = %f\n",current_tagging_node->intensity);
          printf("Before adding statistics to node: current_tagging_node->number_of_rays = %d\n",current_tagging_node->number_of_rays);
        #endif
        
          add_statistics_to_node(current_tagging_node,&ray_position, &ray_velocity, &p, &tagging_leaf_counter);
        
        #ifdef Union_trace_verbal_setting
          printf("After adding statistics to node: current_tagging_node->intensity = %f\n",current_tagging_node->intensity);
          printf("After adding statistics to node: current_tagging_node->number_of_rays = %d\n",current_tagging_node->number_of_rays);
        #endif
      }
    }
    
    // Move the rays a nano meter away from the surface it left, in case activation counter > 1, this will prevent the ray from starting on a volume boundery
    x += vx*1E-9; y += vy*1E-9; z += vz*1E-9; t += 1E-9;
        
  } else {
    ABSORB; // Absorb rays that didn't exit correctly for whatever reason
    // Could error log here
  }
  
  // TEST
  // Stores nubmer of scattering events in global master list so that another master with inherit_number_of_scattering_events can continue
  global_master_list.elements[this_global_master_index].stored_number_of_scattering_events = number_of_scattering_events;
  
  
}
#line 462627 "MACS_sample_kidney_box.c"
}   /* End of kidney_union_master=Union_master() SETTING parameter declarations. */
#undef focus_data_index
#undef temporary_focus_data
#undef number_of_processes_array
#undef safty_distance2
#undef safty_distance
#undef max_conditional_extend_index
#undef tagging_conditional_extend
#undef logger_conditional_extend_array
#undef free_tagging_conditioanl_list
#undef tagging_conditional_list
#undef conditional_status
#undef this_logger
#undef p_old
#undef Volume_copies_allocated
#undef geometry_component_index_list
#undef mask_volume_index_list
#undef current_mask_intersect_list_status
#undef mask_status_list
#undef mask_iterate
#undef mask_index_main
#undef need_to_run_within_which_volume
#undef number_of_masked_volumes
#undef number_of_masks
#undef mc_transmission_probability
#undef real_transmission_probability
#undef number_of_scattering_events
#undef tagging_leaf_counter
#undef current_tagging_node
#undef master_tagging_node_list
#undef enable_tagging_check
#undef stop_creating_nodes
#undef stop_tagging_ray
#undef enable_tagging
#undef rotated_position
#undef non_rotated_position
#undef temp_rotation_matrix
#undef master_transposed_rotation_matrix
#undef scattered_flag_VP
#undef scattered_flag
#undef volume_0_found
#undef ray_velocity_final
#undef ray_velocity
#undef ray_position
#undef pre_allocated3
#undef pre_allocated2
#undef pre_allocated1
#undef tree_next_volume
#undef geometry_output
#undef intersection_with_children
#undef start
#undef check
#undef number_of_solutions_static
#undef number_of_solutions
#undef current_volume
#undef done
#undef next_volume_priority
#undef next_volume
#undef a_next_volume_found
#undef time_propagated_without_scattering
#undef scattering_event
#undef selected_process
#undef time_to_boundery
#undef length_to_boundery
#undef length_to_scattering
#undef time_to_scattering
#undef mc_prop
#undef culmative_probability
#undef my_sum_plus_abs
#undef my_sum
#undef v_length
#undef k_old
#undef k_new
#undef k
#undef my_trace_fraction_control
#undef p_my_trace
#undef my_trace
#undef process_start
#undef process
#undef min_intersection_time
#undef intersection_time
#undef time_found
#undef min_volume
#undef min_solution
#undef solution
#undef limit
#undef max_number_of_processes
#undef solutions
#undef process_index
#undef volume_index
#undef number_of_volumes
#undef string_output
#undef component_error_msg
#undef error_msg
#undef v
#undef r_start
#undef r
#undef starting_lists
#undef Geometries
#undef Volumes
#undef intersection_time_table
#undef geometry_list_index
#undef previous_master_index
#undef this_global_master_index
#undef global_master_element
#undef starting_volume_warning
#undef finally_verbal
#undef trace_verbal
#undef list_verbal
#undef verbal
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex
  /* Label for restoring  neutron */
  mcabsorbCompkidney_union_master:
  if (RESTORE) /* restore if needed */
  { RESTORE_NEUTRON(884,
      mcnlx,
      mcnly,
      mcnlz,
      mcnlvx,
      mcnlvy,
      mcnlvz,
      mcnlt,
      mcnlsx,
      mcnlsy,
      mcnlsz,
      mcnlp); }
#undef mcabsorbComp
#undef p
#undef sz
#undef sy
#undef sx
#undef t
#undef vz
#undef vy
#undef vx
#undef z
#undef y
#undef x
  mcDEBUG_STATE(
mcnlx,
mcnly,
mcnlz,
mcnlvx,
mcnlvy,
mcnlvz,
mcnlt,
mcnlsx,
mcnlsy,
mcnlsz,
mcnlp)

  /* TRACE Component diffraction_detector_0 [885] */
  mccoordschange(mcposrdiffraction_detector_0, mcrotrdiffraction_detector_0,
    &mcnlx,
    &mcnly,
    &mcnlz,
    &mcnlvx,
    &mcnlvy,
    &mcnlvz,
    &mcnlsx,
    &mcnlsy,
    &mcnlsz);
  /* define label inside component diffraction_detector_0 (without coords transformations) */
  mcJumpTrace_diffraction_detector_0:
  SIG_MESSAGE("diffraction_detector_0 (Trace)");
  mcDEBUG_COMP("diffraction_detector_0")
  mcDEBUG_STATE(
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp)
#define x mcnlx
#define y mcnly
#define z mcnlz
#define vx mcnlvx
#define vy mcnlvy
#define vz mcnlvz
#define t mcnlt
#define sx mcnlsx
#define sy mcnlsy
#define sz mcnlsz
#define p mcnlp

#define mcabsorbComp mcabsorbCompdiffraction_detector_0
  STORE_NEUTRON(885,
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp);
  mcScattered=0;
  mcRestore=0;
  mcNCounter[885]++;
  mcPCounter[885] += p;
  mcP2Counter[885] += p*p;
  if (!mcGroupdetector_group) { /* previous comps of GROUP have not SCATTERED yet */
#undef mcabsorb
/* if ABSORBed in GROUP/comp, will go to end of component */
RESTORE=1;
#define mcabsorb mcabsorbCompdiffraction_detector_0
#define mccompcurname  diffraction_detector_0
#define mccompcurtype  PSD_monitor
#define mccompcurindex 885
#define PSD_N mccdiffraction_detector_0_PSD_N
#define PSD_p mccdiffraction_detector_0_PSD_p
#define PSD_p2 mccdiffraction_detector_0_PSD_p2
{   /* Declarations of diffraction_detector_0=PSD_monitor() SETTING parameters. */
int nx = mccdiffraction_detector_0_nx;
int ny = mccdiffraction_detector_0_ny;
char* filename = mccdiffraction_detector_0_filename;
MCNUM xmin = mccdiffraction_detector_0_xmin;
MCNUM xmax = mccdiffraction_detector_0_xmax;
MCNUM ymin = mccdiffraction_detector_0_ymin;
MCNUM ymax = mccdiffraction_detector_0_ymax;
MCNUM xwidth = mccdiffraction_detector_0_xwidth;
MCNUM yheight = mccdiffraction_detector_0_yheight;
MCNUM restore_neutron = mccdiffraction_detector_0_restore_neutron;
#line 94 "/usr/share/mcstas/2.7/monitors/PSD_monitor.comp"
{
  PROP_Z0;
  if (x>xmin && x<xmax && y>ymin && y<ymax){
    int i = floor((x - xmin)*nx/(xmax - xmin));
    int j = floor((y - ymin)*ny/(ymax - ymin));
    PSD_N[i][j]++;
    PSD_p[i][j] += p;
    PSD_p2[i][j] += p*p;
    SCATTER;
  }
  if (restore_neutron) {
    RESTORE_NEUTRON(INDEX_CURRENT_COMP, x, y, z, vx, vy, vz, t, sx, sy, sz, p);
  }
}
#line 462875 "MACS_sample_kidney_box.c"
/* 'diffraction_detector_0=PSD_monitor()' component instance extend code */
    SIG_MESSAGE("diffraction_detector_0 (Trace:Extend)");
#line 4974 "generated_includes/kidney_trace.c"
    if (SCATTERED) {
      detector_channel_diff =0;
      detector_channel_spec =-1;
      detector_found = 1;
    }
#line 462884 "MACS_sample_kidney_box.c"
}   /* End of diffraction_detector_0=PSD_monitor() SETTING parameter declarations. */
#undef PSD_p2
#undef PSD_p
#undef PSD_N
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex
#undef mcabsorb
#define mcabsorb mcabsorbAll
  } /* end comp diffraction_detector_0 in GROUP detector_group */
  if (SCATTERED) {
    mcGroupdetector_group=885;
    RESTORE=0;
  }
  /* Label for restoring  neutron */
  mcabsorbCompdiffraction_detector_0:
  if (RESTORE) /* restore if needed */
  { RESTORE_NEUTRON(885,
      mcnlx,
      mcnly,
      mcnlz,
      mcnlvx,
      mcnlvy,
      mcnlvz,
      mcnlt,
      mcnlsx,
      mcnlsy,
      mcnlsz,
      mcnlp); }
#undef mcabsorbComp
#undef p
#undef sz
#undef sy
#undef sx
#undef t
#undef vz
#undef vy
#undef vx
#undef z
#undef y
#undef x
  mcDEBUG_STATE(
mcnlx,
mcnly,
mcnlz,
mcnlvx,
mcnlvy,
mcnlvz,
mcnlt,
mcnlsx,
mcnlsy,
mcnlsz,
mcnlp)

  /* TRACE Component spec_detector_0 [886] */
  mccoordschange(mcposrspec_detector_0, mcrotrspec_detector_0,
    &mcnlx,
    &mcnly,
    &mcnlz,
    &mcnlvx,
    &mcnlvy,
    &mcnlvz,
    &mcnlsx,
    &mcnlsy,
    &mcnlsz);
  /* define label inside component spec_detector_0 (without coords transformations) */
  mcJumpTrace_spec_detector_0:
  SIG_MESSAGE("spec_detector_0 (Trace)");
  mcDEBUG_COMP("spec_detector_0")
  mcDEBUG_STATE(
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp)
#define x mcnlx
#define y mcnly
#define z mcnlz
#define vx mcnlvx
#define vy mcnlvy
#define vz mcnlvz
#define t mcnlt
#define sx mcnlsx
#define sy mcnlsy
#define sz mcnlsz
#define p mcnlp

#define mcabsorbComp mcabsorbCompspec_detector_0
  STORE_NEUTRON(886,
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp);
  mcScattered=0;
  mcRestore=0;
  mcNCounter[886]++;
  mcPCounter[886] += p;
  mcP2Counter[886] += p*p;
  if (!mcGroupdetector_group) { /* previous comps of GROUP have not SCATTERED yet */
#undef mcabsorb
/* if ABSORBed in GROUP/comp, will go to end of component */
RESTORE=1;
#define mcabsorb mcabsorbCompspec_detector_0
#define mccompcurname  spec_detector_0
#define mccompcurtype  PSD_monitor
#define mccompcurindex 886
#define PSD_N mccspec_detector_0_PSD_N
#define PSD_p mccspec_detector_0_PSD_p
#define PSD_p2 mccspec_detector_0_PSD_p2
{   /* Declarations of spec_detector_0=PSD_monitor() SETTING parameters. */
int nx = mccspec_detector_0_nx;
int ny = mccspec_detector_0_ny;
char* filename = mccspec_detector_0_filename;
MCNUM xmin = mccspec_detector_0_xmin;
MCNUM xmax = mccspec_detector_0_xmax;
MCNUM ymin = mccspec_detector_0_ymin;
MCNUM ymax = mccspec_detector_0_ymax;
MCNUM xwidth = mccspec_detector_0_xwidth;
MCNUM yheight = mccspec_detector_0_yheight;
MCNUM restore_neutron = mccspec_detector_0_restore_neutron;
#line 94 "/usr/share/mcstas/2.7/monitors/PSD_monitor.comp"
{
  PROP_Z0;
  if (x>xmin && x<xmax && y>ymin && y<ymax){
    int i = floor((x - xmin)*nx/(xmax - xmin));
    int j = floor((y - ymin)*ny/(ymax - ymin));
    PSD_N[i][j]++;
    PSD_p[i][j] += p;
    PSD_p2[i][j] += p*p;
    SCATTER;
  }
  if (restore_neutron) {
    RESTORE_NEUTRON(INDEX_CURRENT_COMP, x, y, z, vx, vy, vz, t, sx, sy, sz, p);
  }
}
#line 463030 "MACS_sample_kidney_box.c"
/* 'spec_detector_0=PSD_monitor()' component instance extend code */
    SIG_MESSAGE("spec_detector_0 (Trace:Extend)");
#line 4988 "generated_includes/kidney_trace.c"
    if (SCATTERED) {
      detector_channel_spec =0;
      detector_channel_diff =-1;
      detector_found = 1;
    }
#line 463039 "MACS_sample_kidney_box.c"
}   /* End of spec_detector_0=PSD_monitor() SETTING parameter declarations. */
#undef PSD_p2
#undef PSD_p
#undef PSD_N
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex
#undef mcabsorb
#define mcabsorb mcabsorbAll
  } /* end comp spec_detector_0 in GROUP detector_group */
  if (SCATTERED) {
    mcGroupdetector_group=886;
    RESTORE=0;
  }
  /* Label for restoring  neutron */
  mcabsorbCompspec_detector_0:
  if (RESTORE) /* restore if needed */
  { RESTORE_NEUTRON(886,
      mcnlx,
      mcnly,
      mcnlz,
      mcnlvx,
      mcnlvy,
      mcnlvz,
      mcnlt,
      mcnlsx,
      mcnlsy,
      mcnlsz,
      mcnlp); }
#undef mcabsorbComp
#undef p
#undef sz
#undef sy
#undef sx
#undef t
#undef vz
#undef vy
#undef vx
#undef z
#undef y
#undef x
  mcDEBUG_STATE(
mcnlx,
mcnly,
mcnlz,
mcnlvx,
mcnlvy,
mcnlvz,
mcnlt,
mcnlsx,
mcnlsy,
mcnlsz,
mcnlp)

  /* TRACE Component diffraction_detector_1 [887] */
  mccoordschange(mcposrdiffraction_detector_1, mcrotrdiffraction_detector_1,
    &mcnlx,
    &mcnly,
    &mcnlz,
    &mcnlvx,
    &mcnlvy,
    &mcnlvz,
    &mcnlsx,
    &mcnlsy,
    &mcnlsz);
  /* define label inside component diffraction_detector_1 (without coords transformations) */
  mcJumpTrace_diffraction_detector_1:
  SIG_MESSAGE("diffraction_detector_1 (Trace)");
  mcDEBUG_COMP("diffraction_detector_1")
  mcDEBUG_STATE(
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp)
#define x mcnlx
#define y mcnly
#define z mcnlz
#define vx mcnlvx
#define vy mcnlvy
#define vz mcnlvz
#define t mcnlt
#define sx mcnlsx
#define sy mcnlsy
#define sz mcnlsz
#define p mcnlp

#define mcabsorbComp mcabsorbCompdiffraction_detector_1
  STORE_NEUTRON(887,
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp);
  mcScattered=0;
  mcRestore=0;
  mcNCounter[887]++;
  mcPCounter[887] += p;
  mcP2Counter[887] += p*p;
  if (!mcGroupdetector_group) { /* previous comps of GROUP have not SCATTERED yet */
#undef mcabsorb
/* if ABSORBed in GROUP/comp, will go to end of component */
RESTORE=1;
#define mcabsorb mcabsorbCompdiffraction_detector_1
#define mccompcurname  diffraction_detector_1
#define mccompcurtype  PSD_monitor
#define mccompcurindex 887
#define PSD_N mccdiffraction_detector_1_PSD_N
#define PSD_p mccdiffraction_detector_1_PSD_p
#define PSD_p2 mccdiffraction_detector_1_PSD_p2
{   /* Declarations of diffraction_detector_1=PSD_monitor() SETTING parameters. */
int nx = mccdiffraction_detector_1_nx;
int ny = mccdiffraction_detector_1_ny;
char* filename = mccdiffraction_detector_1_filename;
MCNUM xmin = mccdiffraction_detector_1_xmin;
MCNUM xmax = mccdiffraction_detector_1_xmax;
MCNUM ymin = mccdiffraction_detector_1_ymin;
MCNUM ymax = mccdiffraction_detector_1_ymax;
MCNUM xwidth = mccdiffraction_detector_1_xwidth;
MCNUM yheight = mccdiffraction_detector_1_yheight;
MCNUM restore_neutron = mccdiffraction_detector_1_restore_neutron;
#line 94 "/usr/share/mcstas/2.7/monitors/PSD_monitor.comp"
{
  PROP_Z0;
  if (x>xmin && x<xmax && y>ymin && y<ymax){
    int i = floor((x - xmin)*nx/(xmax - xmin));
    int j = floor((y - ymin)*ny/(ymax - ymin));
    PSD_N[i][j]++;
    PSD_p[i][j] += p;
    PSD_p2[i][j] += p*p;
    SCATTER;
  }
  if (restore_neutron) {
    RESTORE_NEUTRON(INDEX_CURRENT_COMP, x, y, z, vx, vy, vz, t, sx, sy, sz, p);
  }
}
#line 463185 "MACS_sample_kidney_box.c"
/* 'diffraction_detector_1=PSD_monitor()' component instance extend code */
    SIG_MESSAGE("diffraction_detector_1 (Trace:Extend)");
#line 5002 "generated_includes/kidney_trace.c"
    if (SCATTERED) {
      detector_channel_diff =1;
      detector_channel_spec =-1;
      detector_found = 1;
    }
#line 463194 "MACS_sample_kidney_box.c"
}   /* End of diffraction_detector_1=PSD_monitor() SETTING parameter declarations. */
#undef PSD_p2
#undef PSD_p
#undef PSD_N
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex
#undef mcabsorb
#define mcabsorb mcabsorbAll
  } /* end comp diffraction_detector_1 in GROUP detector_group */
  if (SCATTERED) {
    mcGroupdetector_group=887;
    RESTORE=0;
  }
  /* Label for restoring  neutron */
  mcabsorbCompdiffraction_detector_1:
  if (RESTORE) /* restore if needed */
  { RESTORE_NEUTRON(887,
      mcnlx,
      mcnly,
      mcnlz,
      mcnlvx,
      mcnlvy,
      mcnlvz,
      mcnlt,
      mcnlsx,
      mcnlsy,
      mcnlsz,
      mcnlp); }
#undef mcabsorbComp
#undef p
#undef sz
#undef sy
#undef sx
#undef t
#undef vz
#undef vy
#undef vx
#undef z
#undef y
#undef x
  mcDEBUG_STATE(
mcnlx,
mcnly,
mcnlz,
mcnlvx,
mcnlvy,
mcnlvz,
mcnlt,
mcnlsx,
mcnlsy,
mcnlsz,
mcnlp)

  /* TRACE Component spec_detector_1 [888] */
  mccoordschange(mcposrspec_detector_1, mcrotrspec_detector_1,
    &mcnlx,
    &mcnly,
    &mcnlz,
    &mcnlvx,
    &mcnlvy,
    &mcnlvz,
    &mcnlsx,
    &mcnlsy,
    &mcnlsz);
  /* define label inside component spec_detector_1 (without coords transformations) */
  mcJumpTrace_spec_detector_1:
  SIG_MESSAGE("spec_detector_1 (Trace)");
  mcDEBUG_COMP("spec_detector_1")
  mcDEBUG_STATE(
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp)
#define x mcnlx
#define y mcnly
#define z mcnlz
#define vx mcnlvx
#define vy mcnlvy
#define vz mcnlvz
#define t mcnlt
#define sx mcnlsx
#define sy mcnlsy
#define sz mcnlsz
#define p mcnlp

#define mcabsorbComp mcabsorbCompspec_detector_1
  STORE_NEUTRON(888,
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp);
  mcScattered=0;
  mcRestore=0;
  mcNCounter[888]++;
  mcPCounter[888] += p;
  mcP2Counter[888] += p*p;
  if (!mcGroupdetector_group) { /* previous comps of GROUP have not SCATTERED yet */
#undef mcabsorb
/* if ABSORBed in GROUP/comp, will go to end of component */
RESTORE=1;
#define mcabsorb mcabsorbCompspec_detector_1
#define mccompcurname  spec_detector_1
#define mccompcurtype  PSD_monitor
#define mccompcurindex 888
#define PSD_N mccspec_detector_1_PSD_N
#define PSD_p mccspec_detector_1_PSD_p
#define PSD_p2 mccspec_detector_1_PSD_p2
{   /* Declarations of spec_detector_1=PSD_monitor() SETTING parameters. */
int nx = mccspec_detector_1_nx;
int ny = mccspec_detector_1_ny;
char* filename = mccspec_detector_1_filename;
MCNUM xmin = mccspec_detector_1_xmin;
MCNUM xmax = mccspec_detector_1_xmax;
MCNUM ymin = mccspec_detector_1_ymin;
MCNUM ymax = mccspec_detector_1_ymax;
MCNUM xwidth = mccspec_detector_1_xwidth;
MCNUM yheight = mccspec_detector_1_yheight;
MCNUM restore_neutron = mccspec_detector_1_restore_neutron;
#line 94 "/usr/share/mcstas/2.7/monitors/PSD_monitor.comp"
{
  PROP_Z0;
  if (x>xmin && x<xmax && y>ymin && y<ymax){
    int i = floor((x - xmin)*nx/(xmax - xmin));
    int j = floor((y - ymin)*ny/(ymax - ymin));
    PSD_N[i][j]++;
    PSD_p[i][j] += p;
    PSD_p2[i][j] += p*p;
    SCATTER;
  }
  if (restore_neutron) {
    RESTORE_NEUTRON(INDEX_CURRENT_COMP, x, y, z, vx, vy, vz, t, sx, sy, sz, p);
  }
}
#line 463340 "MACS_sample_kidney_box.c"
/* 'spec_detector_1=PSD_monitor()' component instance extend code */
    SIG_MESSAGE("spec_detector_1 (Trace:Extend)");
#line 5016 "generated_includes/kidney_trace.c"
    if (SCATTERED) {
      detector_channel_spec =1;
      detector_channel_diff =-1;
      detector_found = 1;
    }
#line 463349 "MACS_sample_kidney_box.c"
}   /* End of spec_detector_1=PSD_monitor() SETTING parameter declarations. */
#undef PSD_p2
#undef PSD_p
#undef PSD_N
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex
#undef mcabsorb
#define mcabsorb mcabsorbAll
  } /* end comp spec_detector_1 in GROUP detector_group */
  if (SCATTERED) {
    mcGroupdetector_group=888;
    RESTORE=0;
  }
  /* Label for restoring  neutron */
  mcabsorbCompspec_detector_1:
  if (RESTORE) /* restore if needed */
  { RESTORE_NEUTRON(888,
      mcnlx,
      mcnly,
      mcnlz,
      mcnlvx,
      mcnlvy,
      mcnlvz,
      mcnlt,
      mcnlsx,
      mcnlsy,
      mcnlsz,
      mcnlp); }
#undef mcabsorbComp
#undef p
#undef sz
#undef sy
#undef sx
#undef t
#undef vz
#undef vy
#undef vx
#undef z
#undef y
#undef x
  mcDEBUG_STATE(
mcnlx,
mcnly,
mcnlz,
mcnlvx,
mcnlvy,
mcnlvz,
mcnlt,
mcnlsx,
mcnlsy,
mcnlsz,
mcnlp)

  /* TRACE Component diffraction_detector_2 [889] */
  mccoordschange(mcposrdiffraction_detector_2, mcrotrdiffraction_detector_2,
    &mcnlx,
    &mcnly,
    &mcnlz,
    &mcnlvx,
    &mcnlvy,
    &mcnlvz,
    &mcnlsx,
    &mcnlsy,
    &mcnlsz);
  /* define label inside component diffraction_detector_2 (without coords transformations) */
  mcJumpTrace_diffraction_detector_2:
  SIG_MESSAGE("diffraction_detector_2 (Trace)");
  mcDEBUG_COMP("diffraction_detector_2")
  mcDEBUG_STATE(
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp)
#define x mcnlx
#define y mcnly
#define z mcnlz
#define vx mcnlvx
#define vy mcnlvy
#define vz mcnlvz
#define t mcnlt
#define sx mcnlsx
#define sy mcnlsy
#define sz mcnlsz
#define p mcnlp

#define mcabsorbComp mcabsorbCompdiffraction_detector_2
  STORE_NEUTRON(889,
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp);
  mcScattered=0;
  mcRestore=0;
  mcNCounter[889]++;
  mcPCounter[889] += p;
  mcP2Counter[889] += p*p;
  if (!mcGroupdetector_group) { /* previous comps of GROUP have not SCATTERED yet */
#undef mcabsorb
/* if ABSORBed in GROUP/comp, will go to end of component */
RESTORE=1;
#define mcabsorb mcabsorbCompdiffraction_detector_2
#define mccompcurname  diffraction_detector_2
#define mccompcurtype  PSD_monitor
#define mccompcurindex 889
#define PSD_N mccdiffraction_detector_2_PSD_N
#define PSD_p mccdiffraction_detector_2_PSD_p
#define PSD_p2 mccdiffraction_detector_2_PSD_p2
{   /* Declarations of diffraction_detector_2=PSD_monitor() SETTING parameters. */
int nx = mccdiffraction_detector_2_nx;
int ny = mccdiffraction_detector_2_ny;
char* filename = mccdiffraction_detector_2_filename;
MCNUM xmin = mccdiffraction_detector_2_xmin;
MCNUM xmax = mccdiffraction_detector_2_xmax;
MCNUM ymin = mccdiffraction_detector_2_ymin;
MCNUM ymax = mccdiffraction_detector_2_ymax;
MCNUM xwidth = mccdiffraction_detector_2_xwidth;
MCNUM yheight = mccdiffraction_detector_2_yheight;
MCNUM restore_neutron = mccdiffraction_detector_2_restore_neutron;
#line 94 "/usr/share/mcstas/2.7/monitors/PSD_monitor.comp"
{
  PROP_Z0;
  if (x>xmin && x<xmax && y>ymin && y<ymax){
    int i = floor((x - xmin)*nx/(xmax - xmin));
    int j = floor((y - ymin)*ny/(ymax - ymin));
    PSD_N[i][j]++;
    PSD_p[i][j] += p;
    PSD_p2[i][j] += p*p;
    SCATTER;
  }
  if (restore_neutron) {
    RESTORE_NEUTRON(INDEX_CURRENT_COMP, x, y, z, vx, vy, vz, t, sx, sy, sz, p);
  }
}
#line 463495 "MACS_sample_kidney_box.c"
/* 'diffraction_detector_2=PSD_monitor()' component instance extend code */
    SIG_MESSAGE("diffraction_detector_2 (Trace:Extend)");
#line 5030 "generated_includes/kidney_trace.c"
    if (SCATTERED) {
      detector_channel_diff =2;
      detector_channel_spec =-1;
      detector_found = 1;
    }
#line 463504 "MACS_sample_kidney_box.c"
}   /* End of diffraction_detector_2=PSD_monitor() SETTING parameter declarations. */
#undef PSD_p2
#undef PSD_p
#undef PSD_N
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex
#undef mcabsorb
#define mcabsorb mcabsorbAll
  } /* end comp diffraction_detector_2 in GROUP detector_group */
  if (SCATTERED) {
    mcGroupdetector_group=889;
    RESTORE=0;
  }
  /* Label for restoring  neutron */
  mcabsorbCompdiffraction_detector_2:
  if (RESTORE) /* restore if needed */
  { RESTORE_NEUTRON(889,
      mcnlx,
      mcnly,
      mcnlz,
      mcnlvx,
      mcnlvy,
      mcnlvz,
      mcnlt,
      mcnlsx,
      mcnlsy,
      mcnlsz,
      mcnlp); }
#undef mcabsorbComp
#undef p
#undef sz
#undef sy
#undef sx
#undef t
#undef vz
#undef vy
#undef vx
#undef z
#undef y
#undef x
  mcDEBUG_STATE(
mcnlx,
mcnly,
mcnlz,
mcnlvx,
mcnlvy,
mcnlvz,
mcnlt,
mcnlsx,
mcnlsy,
mcnlsz,
mcnlp)

  /* TRACE Component spec_detector_2 [890] */
  mccoordschange(mcposrspec_detector_2, mcrotrspec_detector_2,
    &mcnlx,
    &mcnly,
    &mcnlz,
    &mcnlvx,
    &mcnlvy,
    &mcnlvz,
    &mcnlsx,
    &mcnlsy,
    &mcnlsz);
  /* define label inside component spec_detector_2 (without coords transformations) */
  mcJumpTrace_spec_detector_2:
  SIG_MESSAGE("spec_detector_2 (Trace)");
  mcDEBUG_COMP("spec_detector_2")
  mcDEBUG_STATE(
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp)
#define x mcnlx
#define y mcnly
#define z mcnlz
#define vx mcnlvx
#define vy mcnlvy
#define vz mcnlvz
#define t mcnlt
#define sx mcnlsx
#define sy mcnlsy
#define sz mcnlsz
#define p mcnlp

#define mcabsorbComp mcabsorbCompspec_detector_2
  STORE_NEUTRON(890,
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp);
  mcScattered=0;
  mcRestore=0;
  mcNCounter[890]++;
  mcPCounter[890] += p;
  mcP2Counter[890] += p*p;
  if (!mcGroupdetector_group) { /* previous comps of GROUP have not SCATTERED yet */
#undef mcabsorb
/* if ABSORBed in GROUP/comp, will go to end of component */
RESTORE=1;
#define mcabsorb mcabsorbCompspec_detector_2
#define mccompcurname  spec_detector_2
#define mccompcurtype  PSD_monitor
#define mccompcurindex 890
#define PSD_N mccspec_detector_2_PSD_N
#define PSD_p mccspec_detector_2_PSD_p
#define PSD_p2 mccspec_detector_2_PSD_p2
{   /* Declarations of spec_detector_2=PSD_monitor() SETTING parameters. */
int nx = mccspec_detector_2_nx;
int ny = mccspec_detector_2_ny;
char* filename = mccspec_detector_2_filename;
MCNUM xmin = mccspec_detector_2_xmin;
MCNUM xmax = mccspec_detector_2_xmax;
MCNUM ymin = mccspec_detector_2_ymin;
MCNUM ymax = mccspec_detector_2_ymax;
MCNUM xwidth = mccspec_detector_2_xwidth;
MCNUM yheight = mccspec_detector_2_yheight;
MCNUM restore_neutron = mccspec_detector_2_restore_neutron;
#line 94 "/usr/share/mcstas/2.7/monitors/PSD_monitor.comp"
{
  PROP_Z0;
  if (x>xmin && x<xmax && y>ymin && y<ymax){
    int i = floor((x - xmin)*nx/(xmax - xmin));
    int j = floor((y - ymin)*ny/(ymax - ymin));
    PSD_N[i][j]++;
    PSD_p[i][j] += p;
    PSD_p2[i][j] += p*p;
    SCATTER;
  }
  if (restore_neutron) {
    RESTORE_NEUTRON(INDEX_CURRENT_COMP, x, y, z, vx, vy, vz, t, sx, sy, sz, p);
  }
}
#line 463650 "MACS_sample_kidney_box.c"
/* 'spec_detector_2=PSD_monitor()' component instance extend code */
    SIG_MESSAGE("spec_detector_2 (Trace:Extend)");
#line 5044 "generated_includes/kidney_trace.c"
    if (SCATTERED) {
      detector_channel_spec =2;
      detector_channel_diff =-1;
      detector_found = 1;
    }
#line 463659 "MACS_sample_kidney_box.c"
}   /* End of spec_detector_2=PSD_monitor() SETTING parameter declarations. */
#undef PSD_p2
#undef PSD_p
#undef PSD_N
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex
#undef mcabsorb
#define mcabsorb mcabsorbAll
  } /* end comp spec_detector_2 in GROUP detector_group */
  if (SCATTERED) {
    mcGroupdetector_group=890;
    RESTORE=0;
  }
  /* Label for restoring  neutron */
  mcabsorbCompspec_detector_2:
  if (RESTORE) /* restore if needed */
  { RESTORE_NEUTRON(890,
      mcnlx,
      mcnly,
      mcnlz,
      mcnlvx,
      mcnlvy,
      mcnlvz,
      mcnlt,
      mcnlsx,
      mcnlsy,
      mcnlsz,
      mcnlp); }
#undef mcabsorbComp
#undef p
#undef sz
#undef sy
#undef sx
#undef t
#undef vz
#undef vy
#undef vx
#undef z
#undef y
#undef x
  mcDEBUG_STATE(
mcnlx,
mcnly,
mcnlz,
mcnlvx,
mcnlvy,
mcnlvz,
mcnlt,
mcnlsx,
mcnlsy,
mcnlsz,
mcnlp)

  /* TRACE Component diffraction_detector_3 [891] */
  mccoordschange(mcposrdiffraction_detector_3, mcrotrdiffraction_detector_3,
    &mcnlx,
    &mcnly,
    &mcnlz,
    &mcnlvx,
    &mcnlvy,
    &mcnlvz,
    &mcnlsx,
    &mcnlsy,
    &mcnlsz);
  /* define label inside component diffraction_detector_3 (without coords transformations) */
  mcJumpTrace_diffraction_detector_3:
  SIG_MESSAGE("diffraction_detector_3 (Trace)");
  mcDEBUG_COMP("diffraction_detector_3")
  mcDEBUG_STATE(
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp)
#define x mcnlx
#define y mcnly
#define z mcnlz
#define vx mcnlvx
#define vy mcnlvy
#define vz mcnlvz
#define t mcnlt
#define sx mcnlsx
#define sy mcnlsy
#define sz mcnlsz
#define p mcnlp

#define mcabsorbComp mcabsorbCompdiffraction_detector_3
  STORE_NEUTRON(891,
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp);
  mcScattered=0;
  mcRestore=0;
  mcNCounter[891]++;
  mcPCounter[891] += p;
  mcP2Counter[891] += p*p;
  if (!mcGroupdetector_group) { /* previous comps of GROUP have not SCATTERED yet */
#undef mcabsorb
/* if ABSORBed in GROUP/comp, will go to end of component */
RESTORE=1;
#define mcabsorb mcabsorbCompdiffraction_detector_3
#define mccompcurname  diffraction_detector_3
#define mccompcurtype  PSD_monitor
#define mccompcurindex 891
#define PSD_N mccdiffraction_detector_3_PSD_N
#define PSD_p mccdiffraction_detector_3_PSD_p
#define PSD_p2 mccdiffraction_detector_3_PSD_p2
{   /* Declarations of diffraction_detector_3=PSD_monitor() SETTING parameters. */
int nx = mccdiffraction_detector_3_nx;
int ny = mccdiffraction_detector_3_ny;
char* filename = mccdiffraction_detector_3_filename;
MCNUM xmin = mccdiffraction_detector_3_xmin;
MCNUM xmax = mccdiffraction_detector_3_xmax;
MCNUM ymin = mccdiffraction_detector_3_ymin;
MCNUM ymax = mccdiffraction_detector_3_ymax;
MCNUM xwidth = mccdiffraction_detector_3_xwidth;
MCNUM yheight = mccdiffraction_detector_3_yheight;
MCNUM restore_neutron = mccdiffraction_detector_3_restore_neutron;
#line 94 "/usr/share/mcstas/2.7/monitors/PSD_monitor.comp"
{
  PROP_Z0;
  if (x>xmin && x<xmax && y>ymin && y<ymax){
    int i = floor((x - xmin)*nx/(xmax - xmin));
    int j = floor((y - ymin)*ny/(ymax - ymin));
    PSD_N[i][j]++;
    PSD_p[i][j] += p;
    PSD_p2[i][j] += p*p;
    SCATTER;
  }
  if (restore_neutron) {
    RESTORE_NEUTRON(INDEX_CURRENT_COMP, x, y, z, vx, vy, vz, t, sx, sy, sz, p);
  }
}
#line 463805 "MACS_sample_kidney_box.c"
/* 'diffraction_detector_3=PSD_monitor()' component instance extend code */
    SIG_MESSAGE("diffraction_detector_3 (Trace:Extend)");
#line 5058 "generated_includes/kidney_trace.c"
    if (SCATTERED) {
      detector_channel_diff =3;
      detector_channel_spec =-1;
      detector_found = 1;
    }
#line 463814 "MACS_sample_kidney_box.c"
}   /* End of diffraction_detector_3=PSD_monitor() SETTING parameter declarations. */
#undef PSD_p2
#undef PSD_p
#undef PSD_N
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex
#undef mcabsorb
#define mcabsorb mcabsorbAll
  } /* end comp diffraction_detector_3 in GROUP detector_group */
  if (SCATTERED) {
    mcGroupdetector_group=891;
    RESTORE=0;
  }
  /* Label for restoring  neutron */
  mcabsorbCompdiffraction_detector_3:
  if (RESTORE) /* restore if needed */
  { RESTORE_NEUTRON(891,
      mcnlx,
      mcnly,
      mcnlz,
      mcnlvx,
      mcnlvy,
      mcnlvz,
      mcnlt,
      mcnlsx,
      mcnlsy,
      mcnlsz,
      mcnlp); }
#undef mcabsorbComp
#undef p
#undef sz
#undef sy
#undef sx
#undef t
#undef vz
#undef vy
#undef vx
#undef z
#undef y
#undef x
  mcDEBUG_STATE(
mcnlx,
mcnly,
mcnlz,
mcnlvx,
mcnlvy,
mcnlvz,
mcnlt,
mcnlsx,
mcnlsy,
mcnlsz,
mcnlp)

  /* TRACE Component spec_detector_3 [892] */
  mccoordschange(mcposrspec_detector_3, mcrotrspec_detector_3,
    &mcnlx,
    &mcnly,
    &mcnlz,
    &mcnlvx,
    &mcnlvy,
    &mcnlvz,
    &mcnlsx,
    &mcnlsy,
    &mcnlsz);
  /* define label inside component spec_detector_3 (without coords transformations) */
  mcJumpTrace_spec_detector_3:
  SIG_MESSAGE("spec_detector_3 (Trace)");
  mcDEBUG_COMP("spec_detector_3")
  mcDEBUG_STATE(
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp)
#define x mcnlx
#define y mcnly
#define z mcnlz
#define vx mcnlvx
#define vy mcnlvy
#define vz mcnlvz
#define t mcnlt
#define sx mcnlsx
#define sy mcnlsy
#define sz mcnlsz
#define p mcnlp

#define mcabsorbComp mcabsorbCompspec_detector_3
  STORE_NEUTRON(892,
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp);
  mcScattered=0;
  mcRestore=0;
  mcNCounter[892]++;
  mcPCounter[892] += p;
  mcP2Counter[892] += p*p;
  if (!mcGroupdetector_group) { /* previous comps of GROUP have not SCATTERED yet */
#undef mcabsorb
/* if ABSORBed in GROUP/comp, will go to end of component */
RESTORE=1;
#define mcabsorb mcabsorbCompspec_detector_3
#define mccompcurname  spec_detector_3
#define mccompcurtype  PSD_monitor
#define mccompcurindex 892
#define PSD_N mccspec_detector_3_PSD_N
#define PSD_p mccspec_detector_3_PSD_p
#define PSD_p2 mccspec_detector_3_PSD_p2
{   /* Declarations of spec_detector_3=PSD_monitor() SETTING parameters. */
int nx = mccspec_detector_3_nx;
int ny = mccspec_detector_3_ny;
char* filename = mccspec_detector_3_filename;
MCNUM xmin = mccspec_detector_3_xmin;
MCNUM xmax = mccspec_detector_3_xmax;
MCNUM ymin = mccspec_detector_3_ymin;
MCNUM ymax = mccspec_detector_3_ymax;
MCNUM xwidth = mccspec_detector_3_xwidth;
MCNUM yheight = mccspec_detector_3_yheight;
MCNUM restore_neutron = mccspec_detector_3_restore_neutron;
#line 94 "/usr/share/mcstas/2.7/monitors/PSD_monitor.comp"
{
  PROP_Z0;
  if (x>xmin && x<xmax && y>ymin && y<ymax){
    int i = floor((x - xmin)*nx/(xmax - xmin));
    int j = floor((y - ymin)*ny/(ymax - ymin));
    PSD_N[i][j]++;
    PSD_p[i][j] += p;
    PSD_p2[i][j] += p*p;
    SCATTER;
  }
  if (restore_neutron) {
    RESTORE_NEUTRON(INDEX_CURRENT_COMP, x, y, z, vx, vy, vz, t, sx, sy, sz, p);
  }
}
#line 463960 "MACS_sample_kidney_box.c"
/* 'spec_detector_3=PSD_monitor()' component instance extend code */
    SIG_MESSAGE("spec_detector_3 (Trace:Extend)");
#line 5072 "generated_includes/kidney_trace.c"
    if (SCATTERED) {
      detector_channel_spec =3;
      detector_channel_diff =-1;
      detector_found = 1;
    }
#line 463969 "MACS_sample_kidney_box.c"
}   /* End of spec_detector_3=PSD_monitor() SETTING parameter declarations. */
#undef PSD_p2
#undef PSD_p
#undef PSD_N
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex
#undef mcabsorb
#define mcabsorb mcabsorbAll
  } /* end comp spec_detector_3 in GROUP detector_group */
  if (SCATTERED) {
    mcGroupdetector_group=892;
    RESTORE=0;
  }
  /* Label for restoring  neutron */
  mcabsorbCompspec_detector_3:
  if (RESTORE) /* restore if needed */
  { RESTORE_NEUTRON(892,
      mcnlx,
      mcnly,
      mcnlz,
      mcnlvx,
      mcnlvy,
      mcnlvz,
      mcnlt,
      mcnlsx,
      mcnlsy,
      mcnlsz,
      mcnlp); }
#undef mcabsorbComp
#undef p
#undef sz
#undef sy
#undef sx
#undef t
#undef vz
#undef vy
#undef vx
#undef z
#undef y
#undef x
  mcDEBUG_STATE(
mcnlx,
mcnly,
mcnlz,
mcnlvx,
mcnlvy,
mcnlvz,
mcnlt,
mcnlsx,
mcnlsy,
mcnlsz,
mcnlp)

  /* TRACE Component diffraction_detector_4 [893] */
  mccoordschange(mcposrdiffraction_detector_4, mcrotrdiffraction_detector_4,
    &mcnlx,
    &mcnly,
    &mcnlz,
    &mcnlvx,
    &mcnlvy,
    &mcnlvz,
    &mcnlsx,
    &mcnlsy,
    &mcnlsz);
  /* define label inside component diffraction_detector_4 (without coords transformations) */
  mcJumpTrace_diffraction_detector_4:
  SIG_MESSAGE("diffraction_detector_4 (Trace)");
  mcDEBUG_COMP("diffraction_detector_4")
  mcDEBUG_STATE(
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp)
#define x mcnlx
#define y mcnly
#define z mcnlz
#define vx mcnlvx
#define vy mcnlvy
#define vz mcnlvz
#define t mcnlt
#define sx mcnlsx
#define sy mcnlsy
#define sz mcnlsz
#define p mcnlp

#define mcabsorbComp mcabsorbCompdiffraction_detector_4
  STORE_NEUTRON(893,
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp);
  mcScattered=0;
  mcRestore=0;
  mcNCounter[893]++;
  mcPCounter[893] += p;
  mcP2Counter[893] += p*p;
  if (!mcGroupdetector_group) { /* previous comps of GROUP have not SCATTERED yet */
#undef mcabsorb
/* if ABSORBed in GROUP/comp, will go to end of component */
RESTORE=1;
#define mcabsorb mcabsorbCompdiffraction_detector_4
#define mccompcurname  diffraction_detector_4
#define mccompcurtype  PSD_monitor
#define mccompcurindex 893
#define PSD_N mccdiffraction_detector_4_PSD_N
#define PSD_p mccdiffraction_detector_4_PSD_p
#define PSD_p2 mccdiffraction_detector_4_PSD_p2
{   /* Declarations of diffraction_detector_4=PSD_monitor() SETTING parameters. */
int nx = mccdiffraction_detector_4_nx;
int ny = mccdiffraction_detector_4_ny;
char* filename = mccdiffraction_detector_4_filename;
MCNUM xmin = mccdiffraction_detector_4_xmin;
MCNUM xmax = mccdiffraction_detector_4_xmax;
MCNUM ymin = mccdiffraction_detector_4_ymin;
MCNUM ymax = mccdiffraction_detector_4_ymax;
MCNUM xwidth = mccdiffraction_detector_4_xwidth;
MCNUM yheight = mccdiffraction_detector_4_yheight;
MCNUM restore_neutron = mccdiffraction_detector_4_restore_neutron;
#line 94 "/usr/share/mcstas/2.7/monitors/PSD_monitor.comp"
{
  PROP_Z0;
  if (x>xmin && x<xmax && y>ymin && y<ymax){
    int i = floor((x - xmin)*nx/(xmax - xmin));
    int j = floor((y - ymin)*ny/(ymax - ymin));
    PSD_N[i][j]++;
    PSD_p[i][j] += p;
    PSD_p2[i][j] += p*p;
    SCATTER;
  }
  if (restore_neutron) {
    RESTORE_NEUTRON(INDEX_CURRENT_COMP, x, y, z, vx, vy, vz, t, sx, sy, sz, p);
  }
}
#line 464115 "MACS_sample_kidney_box.c"
/* 'diffraction_detector_4=PSD_monitor()' component instance extend code */
    SIG_MESSAGE("diffraction_detector_4 (Trace:Extend)");
#line 5086 "generated_includes/kidney_trace.c"
    if (SCATTERED) {
      detector_channel_diff =4;
      detector_channel_spec =-1;
      detector_found = 1;
    }
#line 464124 "MACS_sample_kidney_box.c"
}   /* End of diffraction_detector_4=PSD_monitor() SETTING parameter declarations. */
#undef PSD_p2
#undef PSD_p
#undef PSD_N
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex
#undef mcabsorb
#define mcabsorb mcabsorbAll
  } /* end comp diffraction_detector_4 in GROUP detector_group */
  if (SCATTERED) {
    mcGroupdetector_group=893;
    RESTORE=0;
  }
  /* Label for restoring  neutron */
  mcabsorbCompdiffraction_detector_4:
  if (RESTORE) /* restore if needed */
  { RESTORE_NEUTRON(893,
      mcnlx,
      mcnly,
      mcnlz,
      mcnlvx,
      mcnlvy,
      mcnlvz,
      mcnlt,
      mcnlsx,
      mcnlsy,
      mcnlsz,
      mcnlp); }
#undef mcabsorbComp
#undef p
#undef sz
#undef sy
#undef sx
#undef t
#undef vz
#undef vy
#undef vx
#undef z
#undef y
#undef x
  mcDEBUG_STATE(
mcnlx,
mcnly,
mcnlz,
mcnlvx,
mcnlvy,
mcnlvz,
mcnlt,
mcnlsx,
mcnlsy,
mcnlsz,
mcnlp)

  /* TRACE Component spec_detector_4 [894] */
  mccoordschange(mcposrspec_detector_4, mcrotrspec_detector_4,
    &mcnlx,
    &mcnly,
    &mcnlz,
    &mcnlvx,
    &mcnlvy,
    &mcnlvz,
    &mcnlsx,
    &mcnlsy,
    &mcnlsz);
  /* define label inside component spec_detector_4 (without coords transformations) */
  mcJumpTrace_spec_detector_4:
  SIG_MESSAGE("spec_detector_4 (Trace)");
  mcDEBUG_COMP("spec_detector_4")
  mcDEBUG_STATE(
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp)
#define x mcnlx
#define y mcnly
#define z mcnlz
#define vx mcnlvx
#define vy mcnlvy
#define vz mcnlvz
#define t mcnlt
#define sx mcnlsx
#define sy mcnlsy
#define sz mcnlsz
#define p mcnlp

#define mcabsorbComp mcabsorbCompspec_detector_4
  STORE_NEUTRON(894,
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp);
  mcScattered=0;
  mcRestore=0;
  mcNCounter[894]++;
  mcPCounter[894] += p;
  mcP2Counter[894] += p*p;
  if (!mcGroupdetector_group) { /* previous comps of GROUP have not SCATTERED yet */
#undef mcabsorb
/* if ABSORBed in GROUP/comp, will go to end of component */
RESTORE=1;
#define mcabsorb mcabsorbCompspec_detector_4
#define mccompcurname  spec_detector_4
#define mccompcurtype  PSD_monitor
#define mccompcurindex 894
#define PSD_N mccspec_detector_4_PSD_N
#define PSD_p mccspec_detector_4_PSD_p
#define PSD_p2 mccspec_detector_4_PSD_p2
{   /* Declarations of spec_detector_4=PSD_monitor() SETTING parameters. */
int nx = mccspec_detector_4_nx;
int ny = mccspec_detector_4_ny;
char* filename = mccspec_detector_4_filename;
MCNUM xmin = mccspec_detector_4_xmin;
MCNUM xmax = mccspec_detector_4_xmax;
MCNUM ymin = mccspec_detector_4_ymin;
MCNUM ymax = mccspec_detector_4_ymax;
MCNUM xwidth = mccspec_detector_4_xwidth;
MCNUM yheight = mccspec_detector_4_yheight;
MCNUM restore_neutron = mccspec_detector_4_restore_neutron;
#line 94 "/usr/share/mcstas/2.7/monitors/PSD_monitor.comp"
{
  PROP_Z0;
  if (x>xmin && x<xmax && y>ymin && y<ymax){
    int i = floor((x - xmin)*nx/(xmax - xmin));
    int j = floor((y - ymin)*ny/(ymax - ymin));
    PSD_N[i][j]++;
    PSD_p[i][j] += p;
    PSD_p2[i][j] += p*p;
    SCATTER;
  }
  if (restore_neutron) {
    RESTORE_NEUTRON(INDEX_CURRENT_COMP, x, y, z, vx, vy, vz, t, sx, sy, sz, p);
  }
}
#line 464270 "MACS_sample_kidney_box.c"
/* 'spec_detector_4=PSD_monitor()' component instance extend code */
    SIG_MESSAGE("spec_detector_4 (Trace:Extend)");
#line 5100 "generated_includes/kidney_trace.c"
    if (SCATTERED) {
      detector_channel_spec =4;
      detector_channel_diff =-1;
      detector_found = 1;
    }
#line 464279 "MACS_sample_kidney_box.c"
}   /* End of spec_detector_4=PSD_monitor() SETTING parameter declarations. */
#undef PSD_p2
#undef PSD_p
#undef PSD_N
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex
#undef mcabsorb
#define mcabsorb mcabsorbAll
  } /* end comp spec_detector_4 in GROUP detector_group */
  if (SCATTERED) {
    mcGroupdetector_group=894;
    RESTORE=0;
  }
  /* Label for restoring  neutron */
  mcabsorbCompspec_detector_4:
  if (RESTORE) /* restore if needed */
  { RESTORE_NEUTRON(894,
      mcnlx,
      mcnly,
      mcnlz,
      mcnlvx,
      mcnlvy,
      mcnlvz,
      mcnlt,
      mcnlsx,
      mcnlsy,
      mcnlsz,
      mcnlp); }
#undef mcabsorbComp
#undef p
#undef sz
#undef sy
#undef sx
#undef t
#undef vz
#undef vy
#undef vx
#undef z
#undef y
#undef x
  mcDEBUG_STATE(
mcnlx,
mcnly,
mcnlz,
mcnlvx,
mcnlvy,
mcnlvz,
mcnlt,
mcnlsx,
mcnlsy,
mcnlsz,
mcnlp)

  /* TRACE Component diffraction_detector_5 [895] */
  mccoordschange(mcposrdiffraction_detector_5, mcrotrdiffraction_detector_5,
    &mcnlx,
    &mcnly,
    &mcnlz,
    &mcnlvx,
    &mcnlvy,
    &mcnlvz,
    &mcnlsx,
    &mcnlsy,
    &mcnlsz);
  /* define label inside component diffraction_detector_5 (without coords transformations) */
  mcJumpTrace_diffraction_detector_5:
  SIG_MESSAGE("diffraction_detector_5 (Trace)");
  mcDEBUG_COMP("diffraction_detector_5")
  mcDEBUG_STATE(
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp)
#define x mcnlx
#define y mcnly
#define z mcnlz
#define vx mcnlvx
#define vy mcnlvy
#define vz mcnlvz
#define t mcnlt
#define sx mcnlsx
#define sy mcnlsy
#define sz mcnlsz
#define p mcnlp

#define mcabsorbComp mcabsorbCompdiffraction_detector_5
  STORE_NEUTRON(895,
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp);
  mcScattered=0;
  mcRestore=0;
  mcNCounter[895]++;
  mcPCounter[895] += p;
  mcP2Counter[895] += p*p;
  if (!mcGroupdetector_group) { /* previous comps of GROUP have not SCATTERED yet */
#undef mcabsorb
/* if ABSORBed in GROUP/comp, will go to end of component */
RESTORE=1;
#define mcabsorb mcabsorbCompdiffraction_detector_5
#define mccompcurname  diffraction_detector_5
#define mccompcurtype  PSD_monitor
#define mccompcurindex 895
#define PSD_N mccdiffraction_detector_5_PSD_N
#define PSD_p mccdiffraction_detector_5_PSD_p
#define PSD_p2 mccdiffraction_detector_5_PSD_p2
{   /* Declarations of diffraction_detector_5=PSD_monitor() SETTING parameters. */
int nx = mccdiffraction_detector_5_nx;
int ny = mccdiffraction_detector_5_ny;
char* filename = mccdiffraction_detector_5_filename;
MCNUM xmin = mccdiffraction_detector_5_xmin;
MCNUM xmax = mccdiffraction_detector_5_xmax;
MCNUM ymin = mccdiffraction_detector_5_ymin;
MCNUM ymax = mccdiffraction_detector_5_ymax;
MCNUM xwidth = mccdiffraction_detector_5_xwidth;
MCNUM yheight = mccdiffraction_detector_5_yheight;
MCNUM restore_neutron = mccdiffraction_detector_5_restore_neutron;
#line 94 "/usr/share/mcstas/2.7/monitors/PSD_monitor.comp"
{
  PROP_Z0;
  if (x>xmin && x<xmax && y>ymin && y<ymax){
    int i = floor((x - xmin)*nx/(xmax - xmin));
    int j = floor((y - ymin)*ny/(ymax - ymin));
    PSD_N[i][j]++;
    PSD_p[i][j] += p;
    PSD_p2[i][j] += p*p;
    SCATTER;
  }
  if (restore_neutron) {
    RESTORE_NEUTRON(INDEX_CURRENT_COMP, x, y, z, vx, vy, vz, t, sx, sy, sz, p);
  }
}
#line 464425 "MACS_sample_kidney_box.c"
/* 'diffraction_detector_5=PSD_monitor()' component instance extend code */
    SIG_MESSAGE("diffraction_detector_5 (Trace:Extend)");
#line 5114 "generated_includes/kidney_trace.c"
    if (SCATTERED) {
      detector_channel_diff =5;
      detector_channel_spec =-1;
      detector_found = 1;
    }
#line 464434 "MACS_sample_kidney_box.c"
}   /* End of diffraction_detector_5=PSD_monitor() SETTING parameter declarations. */
#undef PSD_p2
#undef PSD_p
#undef PSD_N
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex
#undef mcabsorb
#define mcabsorb mcabsorbAll
  } /* end comp diffraction_detector_5 in GROUP detector_group */
  if (SCATTERED) {
    mcGroupdetector_group=895;
    RESTORE=0;
  }
  /* Label for restoring  neutron */
  mcabsorbCompdiffraction_detector_5:
  if (RESTORE) /* restore if needed */
  { RESTORE_NEUTRON(895,
      mcnlx,
      mcnly,
      mcnlz,
      mcnlvx,
      mcnlvy,
      mcnlvz,
      mcnlt,
      mcnlsx,
      mcnlsy,
      mcnlsz,
      mcnlp); }
#undef mcabsorbComp
#undef p
#undef sz
#undef sy
#undef sx
#undef t
#undef vz
#undef vy
#undef vx
#undef z
#undef y
#undef x
  mcDEBUG_STATE(
mcnlx,
mcnly,
mcnlz,
mcnlvx,
mcnlvy,
mcnlvz,
mcnlt,
mcnlsx,
mcnlsy,
mcnlsz,
mcnlp)

  /* TRACE Component spec_detector_5 [896] */
  mccoordschange(mcposrspec_detector_5, mcrotrspec_detector_5,
    &mcnlx,
    &mcnly,
    &mcnlz,
    &mcnlvx,
    &mcnlvy,
    &mcnlvz,
    &mcnlsx,
    &mcnlsy,
    &mcnlsz);
  /* define label inside component spec_detector_5 (without coords transformations) */
  mcJumpTrace_spec_detector_5:
  SIG_MESSAGE("spec_detector_5 (Trace)");
  mcDEBUG_COMP("spec_detector_5")
  mcDEBUG_STATE(
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp)
#define x mcnlx
#define y mcnly
#define z mcnlz
#define vx mcnlvx
#define vy mcnlvy
#define vz mcnlvz
#define t mcnlt
#define sx mcnlsx
#define sy mcnlsy
#define sz mcnlsz
#define p mcnlp

#define mcabsorbComp mcabsorbCompspec_detector_5
  STORE_NEUTRON(896,
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp);
  mcScattered=0;
  mcRestore=0;
  mcNCounter[896]++;
  mcPCounter[896] += p;
  mcP2Counter[896] += p*p;
  if (!mcGroupdetector_group) { /* previous comps of GROUP have not SCATTERED yet */
#undef mcabsorb
/* if ABSORBed in GROUP/comp, will go to end of component */
RESTORE=1;
#define mcabsorb mcabsorbCompspec_detector_5
#define mccompcurname  spec_detector_5
#define mccompcurtype  PSD_monitor
#define mccompcurindex 896
#define PSD_N mccspec_detector_5_PSD_N
#define PSD_p mccspec_detector_5_PSD_p
#define PSD_p2 mccspec_detector_5_PSD_p2
{   /* Declarations of spec_detector_5=PSD_monitor() SETTING parameters. */
int nx = mccspec_detector_5_nx;
int ny = mccspec_detector_5_ny;
char* filename = mccspec_detector_5_filename;
MCNUM xmin = mccspec_detector_5_xmin;
MCNUM xmax = mccspec_detector_5_xmax;
MCNUM ymin = mccspec_detector_5_ymin;
MCNUM ymax = mccspec_detector_5_ymax;
MCNUM xwidth = mccspec_detector_5_xwidth;
MCNUM yheight = mccspec_detector_5_yheight;
MCNUM restore_neutron = mccspec_detector_5_restore_neutron;
#line 94 "/usr/share/mcstas/2.7/monitors/PSD_monitor.comp"
{
  PROP_Z0;
  if (x>xmin && x<xmax && y>ymin && y<ymax){
    int i = floor((x - xmin)*nx/(xmax - xmin));
    int j = floor((y - ymin)*ny/(ymax - ymin));
    PSD_N[i][j]++;
    PSD_p[i][j] += p;
    PSD_p2[i][j] += p*p;
    SCATTER;
  }
  if (restore_neutron) {
    RESTORE_NEUTRON(INDEX_CURRENT_COMP, x, y, z, vx, vy, vz, t, sx, sy, sz, p);
  }
}
#line 464580 "MACS_sample_kidney_box.c"
/* 'spec_detector_5=PSD_monitor()' component instance extend code */
    SIG_MESSAGE("spec_detector_5 (Trace:Extend)");
#line 5128 "generated_includes/kidney_trace.c"
    if (SCATTERED) {
      detector_channel_spec =5;
      detector_channel_diff =-1;
      detector_found = 1;
    }
#line 464589 "MACS_sample_kidney_box.c"
}   /* End of spec_detector_5=PSD_monitor() SETTING parameter declarations. */
#undef PSD_p2
#undef PSD_p
#undef PSD_N
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex
#undef mcabsorb
#define mcabsorb mcabsorbAll
  } /* end comp spec_detector_5 in GROUP detector_group */
  if (SCATTERED) {
    mcGroupdetector_group=896;
    RESTORE=0;
  }
  /* Label for restoring  neutron */
  mcabsorbCompspec_detector_5:
  if (RESTORE) /* restore if needed */
  { RESTORE_NEUTRON(896,
      mcnlx,
      mcnly,
      mcnlz,
      mcnlvx,
      mcnlvy,
      mcnlvz,
      mcnlt,
      mcnlsx,
      mcnlsy,
      mcnlsz,
      mcnlp); }
#undef mcabsorbComp
#undef p
#undef sz
#undef sy
#undef sx
#undef t
#undef vz
#undef vy
#undef vx
#undef z
#undef y
#undef x
  mcDEBUG_STATE(
mcnlx,
mcnly,
mcnlz,
mcnlvx,
mcnlvy,
mcnlvz,
mcnlt,
mcnlsx,
mcnlsy,
mcnlsz,
mcnlp)

  /* TRACE Component diffraction_detector_6 [897] */
  mccoordschange(mcposrdiffraction_detector_6, mcrotrdiffraction_detector_6,
    &mcnlx,
    &mcnly,
    &mcnlz,
    &mcnlvx,
    &mcnlvy,
    &mcnlvz,
    &mcnlsx,
    &mcnlsy,
    &mcnlsz);
  /* define label inside component diffraction_detector_6 (without coords transformations) */
  mcJumpTrace_diffraction_detector_6:
  SIG_MESSAGE("diffraction_detector_6 (Trace)");
  mcDEBUG_COMP("diffraction_detector_6")
  mcDEBUG_STATE(
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp)
#define x mcnlx
#define y mcnly
#define z mcnlz
#define vx mcnlvx
#define vy mcnlvy
#define vz mcnlvz
#define t mcnlt
#define sx mcnlsx
#define sy mcnlsy
#define sz mcnlsz
#define p mcnlp

#define mcabsorbComp mcabsorbCompdiffraction_detector_6
  STORE_NEUTRON(897,
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp);
  mcScattered=0;
  mcRestore=0;
  mcNCounter[897]++;
  mcPCounter[897] += p;
  mcP2Counter[897] += p*p;
  if (!mcGroupdetector_group) { /* previous comps of GROUP have not SCATTERED yet */
#undef mcabsorb
/* if ABSORBed in GROUP/comp, will go to end of component */
RESTORE=1;
#define mcabsorb mcabsorbCompdiffraction_detector_6
#define mccompcurname  diffraction_detector_6
#define mccompcurtype  PSD_monitor
#define mccompcurindex 897
#define PSD_N mccdiffraction_detector_6_PSD_N
#define PSD_p mccdiffraction_detector_6_PSD_p
#define PSD_p2 mccdiffraction_detector_6_PSD_p2
{   /* Declarations of diffraction_detector_6=PSD_monitor() SETTING parameters. */
int nx = mccdiffraction_detector_6_nx;
int ny = mccdiffraction_detector_6_ny;
char* filename = mccdiffraction_detector_6_filename;
MCNUM xmin = mccdiffraction_detector_6_xmin;
MCNUM xmax = mccdiffraction_detector_6_xmax;
MCNUM ymin = mccdiffraction_detector_6_ymin;
MCNUM ymax = mccdiffraction_detector_6_ymax;
MCNUM xwidth = mccdiffraction_detector_6_xwidth;
MCNUM yheight = mccdiffraction_detector_6_yheight;
MCNUM restore_neutron = mccdiffraction_detector_6_restore_neutron;
#line 94 "/usr/share/mcstas/2.7/monitors/PSD_monitor.comp"
{
  PROP_Z0;
  if (x>xmin && x<xmax && y>ymin && y<ymax){
    int i = floor((x - xmin)*nx/(xmax - xmin));
    int j = floor((y - ymin)*ny/(ymax - ymin));
    PSD_N[i][j]++;
    PSD_p[i][j] += p;
    PSD_p2[i][j] += p*p;
    SCATTER;
  }
  if (restore_neutron) {
    RESTORE_NEUTRON(INDEX_CURRENT_COMP, x, y, z, vx, vy, vz, t, sx, sy, sz, p);
  }
}
#line 464735 "MACS_sample_kidney_box.c"
/* 'diffraction_detector_6=PSD_monitor()' component instance extend code */
    SIG_MESSAGE("diffraction_detector_6 (Trace:Extend)");
#line 5142 "generated_includes/kidney_trace.c"
    if (SCATTERED) {
      detector_channel_diff =6;
      detector_channel_spec =-1;
      detector_found = 1;
    }
#line 464744 "MACS_sample_kidney_box.c"
}   /* End of diffraction_detector_6=PSD_monitor() SETTING parameter declarations. */
#undef PSD_p2
#undef PSD_p
#undef PSD_N
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex
#undef mcabsorb
#define mcabsorb mcabsorbAll
  } /* end comp diffraction_detector_6 in GROUP detector_group */
  if (SCATTERED) {
    mcGroupdetector_group=897;
    RESTORE=0;
  }
  /* Label for restoring  neutron */
  mcabsorbCompdiffraction_detector_6:
  if (RESTORE) /* restore if needed */
  { RESTORE_NEUTRON(897,
      mcnlx,
      mcnly,
      mcnlz,
      mcnlvx,
      mcnlvy,
      mcnlvz,
      mcnlt,
      mcnlsx,
      mcnlsy,
      mcnlsz,
      mcnlp); }
#undef mcabsorbComp
#undef p
#undef sz
#undef sy
#undef sx
#undef t
#undef vz
#undef vy
#undef vx
#undef z
#undef y
#undef x
  mcDEBUG_STATE(
mcnlx,
mcnly,
mcnlz,
mcnlvx,
mcnlvy,
mcnlvz,
mcnlt,
mcnlsx,
mcnlsy,
mcnlsz,
mcnlp)

  /* TRACE Component spec_detector_6 [898] */
  mccoordschange(mcposrspec_detector_6, mcrotrspec_detector_6,
    &mcnlx,
    &mcnly,
    &mcnlz,
    &mcnlvx,
    &mcnlvy,
    &mcnlvz,
    &mcnlsx,
    &mcnlsy,
    &mcnlsz);
  /* define label inside component spec_detector_6 (without coords transformations) */
  mcJumpTrace_spec_detector_6:
  SIG_MESSAGE("spec_detector_6 (Trace)");
  mcDEBUG_COMP("spec_detector_6")
  mcDEBUG_STATE(
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp)
#define x mcnlx
#define y mcnly
#define z mcnlz
#define vx mcnlvx
#define vy mcnlvy
#define vz mcnlvz
#define t mcnlt
#define sx mcnlsx
#define sy mcnlsy
#define sz mcnlsz
#define p mcnlp

#define mcabsorbComp mcabsorbCompspec_detector_6
  STORE_NEUTRON(898,
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp);
  mcScattered=0;
  mcRestore=0;
  mcNCounter[898]++;
  mcPCounter[898] += p;
  mcP2Counter[898] += p*p;
  if (!mcGroupdetector_group) { /* previous comps of GROUP have not SCATTERED yet */
#undef mcabsorb
/* if ABSORBed in GROUP/comp, will go to end of component */
RESTORE=1;
#define mcabsorb mcabsorbCompspec_detector_6
#define mccompcurname  spec_detector_6
#define mccompcurtype  PSD_monitor
#define mccompcurindex 898
#define PSD_N mccspec_detector_6_PSD_N
#define PSD_p mccspec_detector_6_PSD_p
#define PSD_p2 mccspec_detector_6_PSD_p2
{   /* Declarations of spec_detector_6=PSD_monitor() SETTING parameters. */
int nx = mccspec_detector_6_nx;
int ny = mccspec_detector_6_ny;
char* filename = mccspec_detector_6_filename;
MCNUM xmin = mccspec_detector_6_xmin;
MCNUM xmax = mccspec_detector_6_xmax;
MCNUM ymin = mccspec_detector_6_ymin;
MCNUM ymax = mccspec_detector_6_ymax;
MCNUM xwidth = mccspec_detector_6_xwidth;
MCNUM yheight = mccspec_detector_6_yheight;
MCNUM restore_neutron = mccspec_detector_6_restore_neutron;
#line 94 "/usr/share/mcstas/2.7/monitors/PSD_monitor.comp"
{
  PROP_Z0;
  if (x>xmin && x<xmax && y>ymin && y<ymax){
    int i = floor((x - xmin)*nx/(xmax - xmin));
    int j = floor((y - ymin)*ny/(ymax - ymin));
    PSD_N[i][j]++;
    PSD_p[i][j] += p;
    PSD_p2[i][j] += p*p;
    SCATTER;
  }
  if (restore_neutron) {
    RESTORE_NEUTRON(INDEX_CURRENT_COMP, x, y, z, vx, vy, vz, t, sx, sy, sz, p);
  }
}
#line 464890 "MACS_sample_kidney_box.c"
/* 'spec_detector_6=PSD_monitor()' component instance extend code */
    SIG_MESSAGE("spec_detector_6 (Trace:Extend)");
#line 5156 "generated_includes/kidney_trace.c"
    if (SCATTERED) {
      detector_channel_spec =6;
      detector_channel_diff =-1;
      detector_found = 1;
    }
#line 464899 "MACS_sample_kidney_box.c"
}   /* End of spec_detector_6=PSD_monitor() SETTING parameter declarations. */
#undef PSD_p2
#undef PSD_p
#undef PSD_N
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex
#undef mcabsorb
#define mcabsorb mcabsorbAll
  } /* end comp spec_detector_6 in GROUP detector_group */
  if (SCATTERED) {
    mcGroupdetector_group=898;
    RESTORE=0;
  }
  /* Label for restoring  neutron */
  mcabsorbCompspec_detector_6:
  if (RESTORE) /* restore if needed */
  { RESTORE_NEUTRON(898,
      mcnlx,
      mcnly,
      mcnlz,
      mcnlvx,
      mcnlvy,
      mcnlvz,
      mcnlt,
      mcnlsx,
      mcnlsy,
      mcnlsz,
      mcnlp); }
#undef mcabsorbComp
#undef p
#undef sz
#undef sy
#undef sx
#undef t
#undef vz
#undef vy
#undef vx
#undef z
#undef y
#undef x
  mcDEBUG_STATE(
mcnlx,
mcnly,
mcnlz,
mcnlvx,
mcnlvy,
mcnlvz,
mcnlt,
mcnlsx,
mcnlsy,
mcnlsz,
mcnlp)

  /* TRACE Component diffraction_detector_7 [899] */
  mccoordschange(mcposrdiffraction_detector_7, mcrotrdiffraction_detector_7,
    &mcnlx,
    &mcnly,
    &mcnlz,
    &mcnlvx,
    &mcnlvy,
    &mcnlvz,
    &mcnlsx,
    &mcnlsy,
    &mcnlsz);
  /* define label inside component diffraction_detector_7 (without coords transformations) */
  mcJumpTrace_diffraction_detector_7:
  SIG_MESSAGE("diffraction_detector_7 (Trace)");
  mcDEBUG_COMP("diffraction_detector_7")
  mcDEBUG_STATE(
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp)
#define x mcnlx
#define y mcnly
#define z mcnlz
#define vx mcnlvx
#define vy mcnlvy
#define vz mcnlvz
#define t mcnlt
#define sx mcnlsx
#define sy mcnlsy
#define sz mcnlsz
#define p mcnlp

#define mcabsorbComp mcabsorbCompdiffraction_detector_7
  STORE_NEUTRON(899,
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp);
  mcScattered=0;
  mcRestore=0;
  mcNCounter[899]++;
  mcPCounter[899] += p;
  mcP2Counter[899] += p*p;
  if (!mcGroupdetector_group) { /* previous comps of GROUP have not SCATTERED yet */
#undef mcabsorb
/* if ABSORBed in GROUP/comp, will go to end of component */
RESTORE=1;
#define mcabsorb mcabsorbCompdiffraction_detector_7
#define mccompcurname  diffraction_detector_7
#define mccompcurtype  PSD_monitor
#define mccompcurindex 899
#define PSD_N mccdiffraction_detector_7_PSD_N
#define PSD_p mccdiffraction_detector_7_PSD_p
#define PSD_p2 mccdiffraction_detector_7_PSD_p2
{   /* Declarations of diffraction_detector_7=PSD_monitor() SETTING parameters. */
int nx = mccdiffraction_detector_7_nx;
int ny = mccdiffraction_detector_7_ny;
char* filename = mccdiffraction_detector_7_filename;
MCNUM xmin = mccdiffraction_detector_7_xmin;
MCNUM xmax = mccdiffraction_detector_7_xmax;
MCNUM ymin = mccdiffraction_detector_7_ymin;
MCNUM ymax = mccdiffraction_detector_7_ymax;
MCNUM xwidth = mccdiffraction_detector_7_xwidth;
MCNUM yheight = mccdiffraction_detector_7_yheight;
MCNUM restore_neutron = mccdiffraction_detector_7_restore_neutron;
#line 94 "/usr/share/mcstas/2.7/monitors/PSD_monitor.comp"
{
  PROP_Z0;
  if (x>xmin && x<xmax && y>ymin && y<ymax){
    int i = floor((x - xmin)*nx/(xmax - xmin));
    int j = floor((y - ymin)*ny/(ymax - ymin));
    PSD_N[i][j]++;
    PSD_p[i][j] += p;
    PSD_p2[i][j] += p*p;
    SCATTER;
  }
  if (restore_neutron) {
    RESTORE_NEUTRON(INDEX_CURRENT_COMP, x, y, z, vx, vy, vz, t, sx, sy, sz, p);
  }
}
#line 465045 "MACS_sample_kidney_box.c"
/* 'diffraction_detector_7=PSD_monitor()' component instance extend code */
    SIG_MESSAGE("diffraction_detector_7 (Trace:Extend)");
#line 5170 "generated_includes/kidney_trace.c"
    if (SCATTERED) {
      detector_channel_diff =7;
      detector_channel_spec =-1;
      detector_found = 1;
    }
#line 465054 "MACS_sample_kidney_box.c"
}   /* End of diffraction_detector_7=PSD_monitor() SETTING parameter declarations. */
#undef PSD_p2
#undef PSD_p
#undef PSD_N
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex
#undef mcabsorb
#define mcabsorb mcabsorbAll
  } /* end comp diffraction_detector_7 in GROUP detector_group */
  if (SCATTERED) {
    mcGroupdetector_group=899;
    RESTORE=0;
  }
  /* Label for restoring  neutron */
  mcabsorbCompdiffraction_detector_7:
  if (RESTORE) /* restore if needed */
  { RESTORE_NEUTRON(899,
      mcnlx,
      mcnly,
      mcnlz,
      mcnlvx,
      mcnlvy,
      mcnlvz,
      mcnlt,
      mcnlsx,
      mcnlsy,
      mcnlsz,
      mcnlp); }
#undef mcabsorbComp
#undef p
#undef sz
#undef sy
#undef sx
#undef t
#undef vz
#undef vy
#undef vx
#undef z
#undef y
#undef x
  mcDEBUG_STATE(
mcnlx,
mcnly,
mcnlz,
mcnlvx,
mcnlvy,
mcnlvz,
mcnlt,
mcnlsx,
mcnlsy,
mcnlsz,
mcnlp)

  /* TRACE Component spec_detector_7 [900] */
  mccoordschange(mcposrspec_detector_7, mcrotrspec_detector_7,
    &mcnlx,
    &mcnly,
    &mcnlz,
    &mcnlvx,
    &mcnlvy,
    &mcnlvz,
    &mcnlsx,
    &mcnlsy,
    &mcnlsz);
  /* define label inside component spec_detector_7 (without coords transformations) */
  mcJumpTrace_spec_detector_7:
  SIG_MESSAGE("spec_detector_7 (Trace)");
  mcDEBUG_COMP("spec_detector_7")
  mcDEBUG_STATE(
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp)
#define x mcnlx
#define y mcnly
#define z mcnlz
#define vx mcnlvx
#define vy mcnlvy
#define vz mcnlvz
#define t mcnlt
#define sx mcnlsx
#define sy mcnlsy
#define sz mcnlsz
#define p mcnlp

#define mcabsorbComp mcabsorbCompspec_detector_7
  STORE_NEUTRON(900,
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp);
  mcScattered=0;
  mcRestore=0;
  mcNCounter[900]++;
  mcPCounter[900] += p;
  mcP2Counter[900] += p*p;
  if (!mcGroupdetector_group) { /* previous comps of GROUP have not SCATTERED yet */
#undef mcabsorb
/* if ABSORBed in GROUP/comp, will go to end of component */
RESTORE=1;
#define mcabsorb mcabsorbCompspec_detector_7
#define mccompcurname  spec_detector_7
#define mccompcurtype  PSD_monitor
#define mccompcurindex 900
#define PSD_N mccspec_detector_7_PSD_N
#define PSD_p mccspec_detector_7_PSD_p
#define PSD_p2 mccspec_detector_7_PSD_p2
{   /* Declarations of spec_detector_7=PSD_monitor() SETTING parameters. */
int nx = mccspec_detector_7_nx;
int ny = mccspec_detector_7_ny;
char* filename = mccspec_detector_7_filename;
MCNUM xmin = mccspec_detector_7_xmin;
MCNUM xmax = mccspec_detector_7_xmax;
MCNUM ymin = mccspec_detector_7_ymin;
MCNUM ymax = mccspec_detector_7_ymax;
MCNUM xwidth = mccspec_detector_7_xwidth;
MCNUM yheight = mccspec_detector_7_yheight;
MCNUM restore_neutron = mccspec_detector_7_restore_neutron;
#line 94 "/usr/share/mcstas/2.7/monitors/PSD_monitor.comp"
{
  PROP_Z0;
  if (x>xmin && x<xmax && y>ymin && y<ymax){
    int i = floor((x - xmin)*nx/(xmax - xmin));
    int j = floor((y - ymin)*ny/(ymax - ymin));
    PSD_N[i][j]++;
    PSD_p[i][j] += p;
    PSD_p2[i][j] += p*p;
    SCATTER;
  }
  if (restore_neutron) {
    RESTORE_NEUTRON(INDEX_CURRENT_COMP, x, y, z, vx, vy, vz, t, sx, sy, sz, p);
  }
}
#line 465200 "MACS_sample_kidney_box.c"
/* 'spec_detector_7=PSD_monitor()' component instance extend code */
    SIG_MESSAGE("spec_detector_7 (Trace:Extend)");
#line 5184 "generated_includes/kidney_trace.c"
    if (SCATTERED) {
      detector_channel_spec =7;
      detector_channel_diff =-1;
      detector_found = 1;
    }
#line 465209 "MACS_sample_kidney_box.c"
}   /* End of spec_detector_7=PSD_monitor() SETTING parameter declarations. */
#undef PSD_p2
#undef PSD_p
#undef PSD_N
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex
#undef mcabsorb
#define mcabsorb mcabsorbAll
  } /* end comp spec_detector_7 in GROUP detector_group */
  if (SCATTERED) {
    mcGroupdetector_group=900;
    RESTORE=0;
  }
  /* Label for restoring  neutron */
  mcabsorbCompspec_detector_7:
  if (RESTORE) /* restore if needed */
  { RESTORE_NEUTRON(900,
      mcnlx,
      mcnly,
      mcnlz,
      mcnlvx,
      mcnlvy,
      mcnlvz,
      mcnlt,
      mcnlsx,
      mcnlsy,
      mcnlsz,
      mcnlp); }
#undef mcabsorbComp
#undef p
#undef sz
#undef sy
#undef sx
#undef t
#undef vz
#undef vy
#undef vx
#undef z
#undef y
#undef x
  mcDEBUG_STATE(
mcnlx,
mcnly,
mcnlz,
mcnlvx,
mcnlvy,
mcnlvz,
mcnlt,
mcnlsx,
mcnlsy,
mcnlsz,
mcnlp)

  /* TRACE Component diffraction_detector_8 [901] */
  mccoordschange(mcposrdiffraction_detector_8, mcrotrdiffraction_detector_8,
    &mcnlx,
    &mcnly,
    &mcnlz,
    &mcnlvx,
    &mcnlvy,
    &mcnlvz,
    &mcnlsx,
    &mcnlsy,
    &mcnlsz);
  /* define label inside component diffraction_detector_8 (without coords transformations) */
  mcJumpTrace_diffraction_detector_8:
  SIG_MESSAGE("diffraction_detector_8 (Trace)");
  mcDEBUG_COMP("diffraction_detector_8")
  mcDEBUG_STATE(
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp)
#define x mcnlx
#define y mcnly
#define z mcnlz
#define vx mcnlvx
#define vy mcnlvy
#define vz mcnlvz
#define t mcnlt
#define sx mcnlsx
#define sy mcnlsy
#define sz mcnlsz
#define p mcnlp

#define mcabsorbComp mcabsorbCompdiffraction_detector_8
  STORE_NEUTRON(901,
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp);
  mcScattered=0;
  mcRestore=0;
  mcNCounter[901]++;
  mcPCounter[901] += p;
  mcP2Counter[901] += p*p;
  if (!mcGroupdetector_group) { /* previous comps of GROUP have not SCATTERED yet */
#undef mcabsorb
/* if ABSORBed in GROUP/comp, will go to end of component */
RESTORE=1;
#define mcabsorb mcabsorbCompdiffraction_detector_8
#define mccompcurname  diffraction_detector_8
#define mccompcurtype  PSD_monitor
#define mccompcurindex 901
#define PSD_N mccdiffraction_detector_8_PSD_N
#define PSD_p mccdiffraction_detector_8_PSD_p
#define PSD_p2 mccdiffraction_detector_8_PSD_p2
{   /* Declarations of diffraction_detector_8=PSD_monitor() SETTING parameters. */
int nx = mccdiffraction_detector_8_nx;
int ny = mccdiffraction_detector_8_ny;
char* filename = mccdiffraction_detector_8_filename;
MCNUM xmin = mccdiffraction_detector_8_xmin;
MCNUM xmax = mccdiffraction_detector_8_xmax;
MCNUM ymin = mccdiffraction_detector_8_ymin;
MCNUM ymax = mccdiffraction_detector_8_ymax;
MCNUM xwidth = mccdiffraction_detector_8_xwidth;
MCNUM yheight = mccdiffraction_detector_8_yheight;
MCNUM restore_neutron = mccdiffraction_detector_8_restore_neutron;
#line 94 "/usr/share/mcstas/2.7/monitors/PSD_monitor.comp"
{
  PROP_Z0;
  if (x>xmin && x<xmax && y>ymin && y<ymax){
    int i = floor((x - xmin)*nx/(xmax - xmin));
    int j = floor((y - ymin)*ny/(ymax - ymin));
    PSD_N[i][j]++;
    PSD_p[i][j] += p;
    PSD_p2[i][j] += p*p;
    SCATTER;
  }
  if (restore_neutron) {
    RESTORE_NEUTRON(INDEX_CURRENT_COMP, x, y, z, vx, vy, vz, t, sx, sy, sz, p);
  }
}
#line 465355 "MACS_sample_kidney_box.c"
/* 'diffraction_detector_8=PSD_monitor()' component instance extend code */
    SIG_MESSAGE("diffraction_detector_8 (Trace:Extend)");
#line 5198 "generated_includes/kidney_trace.c"
    if (SCATTERED) {
      detector_channel_diff =8;
      detector_channel_spec =-1;
      detector_found = 1;
    }
#line 465364 "MACS_sample_kidney_box.c"
}   /* End of diffraction_detector_8=PSD_monitor() SETTING parameter declarations. */
#undef PSD_p2
#undef PSD_p
#undef PSD_N
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex
#undef mcabsorb
#define mcabsorb mcabsorbAll
  } /* end comp diffraction_detector_8 in GROUP detector_group */
  if (SCATTERED) {
    mcGroupdetector_group=901;
    RESTORE=0;
  }
  /* Label for restoring  neutron */
  mcabsorbCompdiffraction_detector_8:
  if (RESTORE) /* restore if needed */
  { RESTORE_NEUTRON(901,
      mcnlx,
      mcnly,
      mcnlz,
      mcnlvx,
      mcnlvy,
      mcnlvz,
      mcnlt,
      mcnlsx,
      mcnlsy,
      mcnlsz,
      mcnlp); }
#undef mcabsorbComp
#undef p
#undef sz
#undef sy
#undef sx
#undef t
#undef vz
#undef vy
#undef vx
#undef z
#undef y
#undef x
  mcDEBUG_STATE(
mcnlx,
mcnly,
mcnlz,
mcnlvx,
mcnlvy,
mcnlvz,
mcnlt,
mcnlsx,
mcnlsy,
mcnlsz,
mcnlp)

  /* TRACE Component spec_detector_8 [902] */
  mccoordschange(mcposrspec_detector_8, mcrotrspec_detector_8,
    &mcnlx,
    &mcnly,
    &mcnlz,
    &mcnlvx,
    &mcnlvy,
    &mcnlvz,
    &mcnlsx,
    &mcnlsy,
    &mcnlsz);
  /* define label inside component spec_detector_8 (without coords transformations) */
  mcJumpTrace_spec_detector_8:
  SIG_MESSAGE("spec_detector_8 (Trace)");
  mcDEBUG_COMP("spec_detector_8")
  mcDEBUG_STATE(
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp)
#define x mcnlx
#define y mcnly
#define z mcnlz
#define vx mcnlvx
#define vy mcnlvy
#define vz mcnlvz
#define t mcnlt
#define sx mcnlsx
#define sy mcnlsy
#define sz mcnlsz
#define p mcnlp

#define mcabsorbComp mcabsorbCompspec_detector_8
  STORE_NEUTRON(902,
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp);
  mcScattered=0;
  mcRestore=0;
  mcNCounter[902]++;
  mcPCounter[902] += p;
  mcP2Counter[902] += p*p;
  if (!mcGroupdetector_group) { /* previous comps of GROUP have not SCATTERED yet */
#undef mcabsorb
/* if ABSORBed in GROUP/comp, will go to end of component */
RESTORE=1;
#define mcabsorb mcabsorbCompspec_detector_8
#define mccompcurname  spec_detector_8
#define mccompcurtype  PSD_monitor
#define mccompcurindex 902
#define PSD_N mccspec_detector_8_PSD_N
#define PSD_p mccspec_detector_8_PSD_p
#define PSD_p2 mccspec_detector_8_PSD_p2
{   /* Declarations of spec_detector_8=PSD_monitor() SETTING parameters. */
int nx = mccspec_detector_8_nx;
int ny = mccspec_detector_8_ny;
char* filename = mccspec_detector_8_filename;
MCNUM xmin = mccspec_detector_8_xmin;
MCNUM xmax = mccspec_detector_8_xmax;
MCNUM ymin = mccspec_detector_8_ymin;
MCNUM ymax = mccspec_detector_8_ymax;
MCNUM xwidth = mccspec_detector_8_xwidth;
MCNUM yheight = mccspec_detector_8_yheight;
MCNUM restore_neutron = mccspec_detector_8_restore_neutron;
#line 94 "/usr/share/mcstas/2.7/monitors/PSD_monitor.comp"
{
  PROP_Z0;
  if (x>xmin && x<xmax && y>ymin && y<ymax){
    int i = floor((x - xmin)*nx/(xmax - xmin));
    int j = floor((y - ymin)*ny/(ymax - ymin));
    PSD_N[i][j]++;
    PSD_p[i][j] += p;
    PSD_p2[i][j] += p*p;
    SCATTER;
  }
  if (restore_neutron) {
    RESTORE_NEUTRON(INDEX_CURRENT_COMP, x, y, z, vx, vy, vz, t, sx, sy, sz, p);
  }
}
#line 465510 "MACS_sample_kidney_box.c"
/* 'spec_detector_8=PSD_monitor()' component instance extend code */
    SIG_MESSAGE("spec_detector_8 (Trace:Extend)");
#line 5212 "generated_includes/kidney_trace.c"
    if (SCATTERED) {
      detector_channel_spec =8;
      detector_channel_diff =-1;
      detector_found = 1;
    }
#line 465519 "MACS_sample_kidney_box.c"
}   /* End of spec_detector_8=PSD_monitor() SETTING parameter declarations. */
#undef PSD_p2
#undef PSD_p
#undef PSD_N
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex
#undef mcabsorb
#define mcabsorb mcabsorbAll
  } /* end comp spec_detector_8 in GROUP detector_group */
  if (SCATTERED) {
    mcGroupdetector_group=902;
    RESTORE=0;
  }
  /* Label for restoring  neutron */
  mcabsorbCompspec_detector_8:
  if (RESTORE) /* restore if needed */
  { RESTORE_NEUTRON(902,
      mcnlx,
      mcnly,
      mcnlz,
      mcnlvx,
      mcnlvy,
      mcnlvz,
      mcnlt,
      mcnlsx,
      mcnlsy,
      mcnlsz,
      mcnlp); }
#undef mcabsorbComp
#undef p
#undef sz
#undef sy
#undef sx
#undef t
#undef vz
#undef vy
#undef vx
#undef z
#undef y
#undef x
  mcDEBUG_STATE(
mcnlx,
mcnly,
mcnlz,
mcnlvx,
mcnlvy,
mcnlvz,
mcnlt,
mcnlsx,
mcnlsy,
mcnlsz,
mcnlp)

  /* TRACE Component diffraction_detector_9 [903] */
  mccoordschange(mcposrdiffraction_detector_9, mcrotrdiffraction_detector_9,
    &mcnlx,
    &mcnly,
    &mcnlz,
    &mcnlvx,
    &mcnlvy,
    &mcnlvz,
    &mcnlsx,
    &mcnlsy,
    &mcnlsz);
  /* define label inside component diffraction_detector_9 (without coords transformations) */
  mcJumpTrace_diffraction_detector_9:
  SIG_MESSAGE("diffraction_detector_9 (Trace)");
  mcDEBUG_COMP("diffraction_detector_9")
  mcDEBUG_STATE(
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp)
#define x mcnlx
#define y mcnly
#define z mcnlz
#define vx mcnlvx
#define vy mcnlvy
#define vz mcnlvz
#define t mcnlt
#define sx mcnlsx
#define sy mcnlsy
#define sz mcnlsz
#define p mcnlp

#define mcabsorbComp mcabsorbCompdiffraction_detector_9
  STORE_NEUTRON(903,
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp);
  mcScattered=0;
  mcRestore=0;
  mcNCounter[903]++;
  mcPCounter[903] += p;
  mcP2Counter[903] += p*p;
  if (!mcGroupdetector_group) { /* previous comps of GROUP have not SCATTERED yet */
#undef mcabsorb
/* if ABSORBed in GROUP/comp, will go to end of component */
RESTORE=1;
#define mcabsorb mcabsorbCompdiffraction_detector_9
#define mccompcurname  diffraction_detector_9
#define mccompcurtype  PSD_monitor
#define mccompcurindex 903
#define PSD_N mccdiffraction_detector_9_PSD_N
#define PSD_p mccdiffraction_detector_9_PSD_p
#define PSD_p2 mccdiffraction_detector_9_PSD_p2
{   /* Declarations of diffraction_detector_9=PSD_monitor() SETTING parameters. */
int nx = mccdiffraction_detector_9_nx;
int ny = mccdiffraction_detector_9_ny;
char* filename = mccdiffraction_detector_9_filename;
MCNUM xmin = mccdiffraction_detector_9_xmin;
MCNUM xmax = mccdiffraction_detector_9_xmax;
MCNUM ymin = mccdiffraction_detector_9_ymin;
MCNUM ymax = mccdiffraction_detector_9_ymax;
MCNUM xwidth = mccdiffraction_detector_9_xwidth;
MCNUM yheight = mccdiffraction_detector_9_yheight;
MCNUM restore_neutron = mccdiffraction_detector_9_restore_neutron;
#line 94 "/usr/share/mcstas/2.7/monitors/PSD_monitor.comp"
{
  PROP_Z0;
  if (x>xmin && x<xmax && y>ymin && y<ymax){
    int i = floor((x - xmin)*nx/(xmax - xmin));
    int j = floor((y - ymin)*ny/(ymax - ymin));
    PSD_N[i][j]++;
    PSD_p[i][j] += p;
    PSD_p2[i][j] += p*p;
    SCATTER;
  }
  if (restore_neutron) {
    RESTORE_NEUTRON(INDEX_CURRENT_COMP, x, y, z, vx, vy, vz, t, sx, sy, sz, p);
  }
}
#line 465665 "MACS_sample_kidney_box.c"
/* 'diffraction_detector_9=PSD_monitor()' component instance extend code */
    SIG_MESSAGE("diffraction_detector_9 (Trace:Extend)");
#line 5226 "generated_includes/kidney_trace.c"
    if (SCATTERED) {
      detector_channel_diff =9;
      detector_channel_spec =-1;
      detector_found = 1;
    }
#line 465674 "MACS_sample_kidney_box.c"
}   /* End of diffraction_detector_9=PSD_monitor() SETTING parameter declarations. */
#undef PSD_p2
#undef PSD_p
#undef PSD_N
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex
#undef mcabsorb
#define mcabsorb mcabsorbAll
  } /* end comp diffraction_detector_9 in GROUP detector_group */
  if (SCATTERED) {
    mcGroupdetector_group=903;
    RESTORE=0;
  }
  /* Label for restoring  neutron */
  mcabsorbCompdiffraction_detector_9:
  if (RESTORE) /* restore if needed */
  { RESTORE_NEUTRON(903,
      mcnlx,
      mcnly,
      mcnlz,
      mcnlvx,
      mcnlvy,
      mcnlvz,
      mcnlt,
      mcnlsx,
      mcnlsy,
      mcnlsz,
      mcnlp); }
#undef mcabsorbComp
#undef p
#undef sz
#undef sy
#undef sx
#undef t
#undef vz
#undef vy
#undef vx
#undef z
#undef y
#undef x
  mcDEBUG_STATE(
mcnlx,
mcnly,
mcnlz,
mcnlvx,
mcnlvy,
mcnlvz,
mcnlt,
mcnlsx,
mcnlsy,
mcnlsz,
mcnlp)

  /* TRACE Component spec_detector_9 [904] */
  mccoordschange(mcposrspec_detector_9, mcrotrspec_detector_9,
    &mcnlx,
    &mcnly,
    &mcnlz,
    &mcnlvx,
    &mcnlvy,
    &mcnlvz,
    &mcnlsx,
    &mcnlsy,
    &mcnlsz);
  /* define label inside component spec_detector_9 (without coords transformations) */
  mcJumpTrace_spec_detector_9:
  SIG_MESSAGE("spec_detector_9 (Trace)");
  mcDEBUG_COMP("spec_detector_9")
  mcDEBUG_STATE(
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp)
#define x mcnlx
#define y mcnly
#define z mcnlz
#define vx mcnlvx
#define vy mcnlvy
#define vz mcnlvz
#define t mcnlt
#define sx mcnlsx
#define sy mcnlsy
#define sz mcnlsz
#define p mcnlp

#define mcabsorbComp mcabsorbCompspec_detector_9
  STORE_NEUTRON(904,
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp);
  mcScattered=0;
  mcRestore=0;
  mcNCounter[904]++;
  mcPCounter[904] += p;
  mcP2Counter[904] += p*p;
  if (!mcGroupdetector_group) { /* previous comps of GROUP have not SCATTERED yet */
#undef mcabsorb
/* if ABSORBed in GROUP/comp, will go to end of component */
RESTORE=1;
#define mcabsorb mcabsorbCompspec_detector_9
#define mccompcurname  spec_detector_9
#define mccompcurtype  PSD_monitor
#define mccompcurindex 904
#define PSD_N mccspec_detector_9_PSD_N
#define PSD_p mccspec_detector_9_PSD_p
#define PSD_p2 mccspec_detector_9_PSD_p2
{   /* Declarations of spec_detector_9=PSD_monitor() SETTING parameters. */
int nx = mccspec_detector_9_nx;
int ny = mccspec_detector_9_ny;
char* filename = mccspec_detector_9_filename;
MCNUM xmin = mccspec_detector_9_xmin;
MCNUM xmax = mccspec_detector_9_xmax;
MCNUM ymin = mccspec_detector_9_ymin;
MCNUM ymax = mccspec_detector_9_ymax;
MCNUM xwidth = mccspec_detector_9_xwidth;
MCNUM yheight = mccspec_detector_9_yheight;
MCNUM restore_neutron = mccspec_detector_9_restore_neutron;
#line 94 "/usr/share/mcstas/2.7/monitors/PSD_monitor.comp"
{
  PROP_Z0;
  if (x>xmin && x<xmax && y>ymin && y<ymax){
    int i = floor((x - xmin)*nx/(xmax - xmin));
    int j = floor((y - ymin)*ny/(ymax - ymin));
    PSD_N[i][j]++;
    PSD_p[i][j] += p;
    PSD_p2[i][j] += p*p;
    SCATTER;
  }
  if (restore_neutron) {
    RESTORE_NEUTRON(INDEX_CURRENT_COMP, x, y, z, vx, vy, vz, t, sx, sy, sz, p);
  }
}
#line 465820 "MACS_sample_kidney_box.c"
/* 'spec_detector_9=PSD_monitor()' component instance extend code */
    SIG_MESSAGE("spec_detector_9 (Trace:Extend)");
#line 5240 "generated_includes/kidney_trace.c"
    if (SCATTERED) {
      detector_channel_spec =9;
      detector_channel_diff =-1;
      detector_found = 1;
    }
#line 465829 "MACS_sample_kidney_box.c"
}   /* End of spec_detector_9=PSD_monitor() SETTING parameter declarations. */
#undef PSD_p2
#undef PSD_p
#undef PSD_N
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex
#undef mcabsorb
#define mcabsorb mcabsorbAll
  } /* end comp spec_detector_9 in GROUP detector_group */
  if (SCATTERED) {
    mcGroupdetector_group=904;
    RESTORE=0;
  }
  /* Label for restoring  neutron */
  mcabsorbCompspec_detector_9:
  if (RESTORE) /* restore if needed */
  { RESTORE_NEUTRON(904,
      mcnlx,
      mcnly,
      mcnlz,
      mcnlvx,
      mcnlvy,
      mcnlvz,
      mcnlt,
      mcnlsx,
      mcnlsy,
      mcnlsz,
      mcnlp); }
#undef mcabsorbComp
#undef p
#undef sz
#undef sy
#undef sx
#undef t
#undef vz
#undef vy
#undef vx
#undef z
#undef y
#undef x
  mcDEBUG_STATE(
mcnlx,
mcnly,
mcnlz,
mcnlvx,
mcnlvy,
mcnlvz,
mcnlt,
mcnlsx,
mcnlsy,
mcnlsz,
mcnlp)

  /* TRACE Component diffraction_detector_10 [905] */
  mccoordschange(mcposrdiffraction_detector_10, mcrotrdiffraction_detector_10,
    &mcnlx,
    &mcnly,
    &mcnlz,
    &mcnlvx,
    &mcnlvy,
    &mcnlvz,
    &mcnlsx,
    &mcnlsy,
    &mcnlsz);
  /* define label inside component diffraction_detector_10 (without coords transformations) */
  mcJumpTrace_diffraction_detector_10:
  SIG_MESSAGE("diffraction_detector_10 (Trace)");
  mcDEBUG_COMP("diffraction_detector_10")
  mcDEBUG_STATE(
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp)
#define x mcnlx
#define y mcnly
#define z mcnlz
#define vx mcnlvx
#define vy mcnlvy
#define vz mcnlvz
#define t mcnlt
#define sx mcnlsx
#define sy mcnlsy
#define sz mcnlsz
#define p mcnlp

#define mcabsorbComp mcabsorbCompdiffraction_detector_10
  STORE_NEUTRON(905,
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp);
  mcScattered=0;
  mcRestore=0;
  mcNCounter[905]++;
  mcPCounter[905] += p;
  mcP2Counter[905] += p*p;
  if (!mcGroupdetector_group) { /* previous comps of GROUP have not SCATTERED yet */
#undef mcabsorb
/* if ABSORBed in GROUP/comp, will go to end of component */
RESTORE=1;
#define mcabsorb mcabsorbCompdiffraction_detector_10
#define mccompcurname  diffraction_detector_10
#define mccompcurtype  PSD_monitor
#define mccompcurindex 905
#define PSD_N mccdiffraction_detector_10_PSD_N
#define PSD_p mccdiffraction_detector_10_PSD_p
#define PSD_p2 mccdiffraction_detector_10_PSD_p2
{   /* Declarations of diffraction_detector_10=PSD_monitor() SETTING parameters. */
int nx = mccdiffraction_detector_10_nx;
int ny = mccdiffraction_detector_10_ny;
char* filename = mccdiffraction_detector_10_filename;
MCNUM xmin = mccdiffraction_detector_10_xmin;
MCNUM xmax = mccdiffraction_detector_10_xmax;
MCNUM ymin = mccdiffraction_detector_10_ymin;
MCNUM ymax = mccdiffraction_detector_10_ymax;
MCNUM xwidth = mccdiffraction_detector_10_xwidth;
MCNUM yheight = mccdiffraction_detector_10_yheight;
MCNUM restore_neutron = mccdiffraction_detector_10_restore_neutron;
#line 94 "/usr/share/mcstas/2.7/monitors/PSD_monitor.comp"
{
  PROP_Z0;
  if (x>xmin && x<xmax && y>ymin && y<ymax){
    int i = floor((x - xmin)*nx/(xmax - xmin));
    int j = floor((y - ymin)*ny/(ymax - ymin));
    PSD_N[i][j]++;
    PSD_p[i][j] += p;
    PSD_p2[i][j] += p*p;
    SCATTER;
  }
  if (restore_neutron) {
    RESTORE_NEUTRON(INDEX_CURRENT_COMP, x, y, z, vx, vy, vz, t, sx, sy, sz, p);
  }
}
#line 465975 "MACS_sample_kidney_box.c"
/* 'diffraction_detector_10=PSD_monitor()' component instance extend code */
    SIG_MESSAGE("diffraction_detector_10 (Trace:Extend)");
#line 5254 "generated_includes/kidney_trace.c"
    if (SCATTERED) {
      detector_channel_diff =10;
      detector_channel_spec =-1;
      detector_found = 1;
    }
#line 465984 "MACS_sample_kidney_box.c"
}   /* End of diffraction_detector_10=PSD_monitor() SETTING parameter declarations. */
#undef PSD_p2
#undef PSD_p
#undef PSD_N
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex
#undef mcabsorb
#define mcabsorb mcabsorbAll
  } /* end comp diffraction_detector_10 in GROUP detector_group */
  if (SCATTERED) {
    mcGroupdetector_group=905;
    RESTORE=0;
  }
  /* Label for restoring  neutron */
  mcabsorbCompdiffraction_detector_10:
  if (RESTORE) /* restore if needed */
  { RESTORE_NEUTRON(905,
      mcnlx,
      mcnly,
      mcnlz,
      mcnlvx,
      mcnlvy,
      mcnlvz,
      mcnlt,
      mcnlsx,
      mcnlsy,
      mcnlsz,
      mcnlp); }
#undef mcabsorbComp
#undef p
#undef sz
#undef sy
#undef sx
#undef t
#undef vz
#undef vy
#undef vx
#undef z
#undef y
#undef x
  mcDEBUG_STATE(
mcnlx,
mcnly,
mcnlz,
mcnlvx,
mcnlvy,
mcnlvz,
mcnlt,
mcnlsx,
mcnlsy,
mcnlsz,
mcnlp)

  /* TRACE Component spec_detector_10 [906] */
  mccoordschange(mcposrspec_detector_10, mcrotrspec_detector_10,
    &mcnlx,
    &mcnly,
    &mcnlz,
    &mcnlvx,
    &mcnlvy,
    &mcnlvz,
    &mcnlsx,
    &mcnlsy,
    &mcnlsz);
  /* define label inside component spec_detector_10 (without coords transformations) */
  mcJumpTrace_spec_detector_10:
  SIG_MESSAGE("spec_detector_10 (Trace)");
  mcDEBUG_COMP("spec_detector_10")
  mcDEBUG_STATE(
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp)
#define x mcnlx
#define y mcnly
#define z mcnlz
#define vx mcnlvx
#define vy mcnlvy
#define vz mcnlvz
#define t mcnlt
#define sx mcnlsx
#define sy mcnlsy
#define sz mcnlsz
#define p mcnlp

#define mcabsorbComp mcabsorbCompspec_detector_10
  STORE_NEUTRON(906,
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp);
  mcScattered=0;
  mcRestore=0;
  mcNCounter[906]++;
  mcPCounter[906] += p;
  mcP2Counter[906] += p*p;
  if (!mcGroupdetector_group) { /* previous comps of GROUP have not SCATTERED yet */
#undef mcabsorb
/* if ABSORBed in GROUP/comp, will go to end of component */
RESTORE=1;
#define mcabsorb mcabsorbCompspec_detector_10
#define mccompcurname  spec_detector_10
#define mccompcurtype  PSD_monitor
#define mccompcurindex 906
#define PSD_N mccspec_detector_10_PSD_N
#define PSD_p mccspec_detector_10_PSD_p
#define PSD_p2 mccspec_detector_10_PSD_p2
{   /* Declarations of spec_detector_10=PSD_monitor() SETTING parameters. */
int nx = mccspec_detector_10_nx;
int ny = mccspec_detector_10_ny;
char* filename = mccspec_detector_10_filename;
MCNUM xmin = mccspec_detector_10_xmin;
MCNUM xmax = mccspec_detector_10_xmax;
MCNUM ymin = mccspec_detector_10_ymin;
MCNUM ymax = mccspec_detector_10_ymax;
MCNUM xwidth = mccspec_detector_10_xwidth;
MCNUM yheight = mccspec_detector_10_yheight;
MCNUM restore_neutron = mccspec_detector_10_restore_neutron;
#line 94 "/usr/share/mcstas/2.7/monitors/PSD_monitor.comp"
{
  PROP_Z0;
  if (x>xmin && x<xmax && y>ymin && y<ymax){
    int i = floor((x - xmin)*nx/(xmax - xmin));
    int j = floor((y - ymin)*ny/(ymax - ymin));
    PSD_N[i][j]++;
    PSD_p[i][j] += p;
    PSD_p2[i][j] += p*p;
    SCATTER;
  }
  if (restore_neutron) {
    RESTORE_NEUTRON(INDEX_CURRENT_COMP, x, y, z, vx, vy, vz, t, sx, sy, sz, p);
  }
}
#line 466130 "MACS_sample_kidney_box.c"
/* 'spec_detector_10=PSD_monitor()' component instance extend code */
    SIG_MESSAGE("spec_detector_10 (Trace:Extend)");
#line 5268 "generated_includes/kidney_trace.c"
    if (SCATTERED) {
      detector_channel_spec =10;
      detector_channel_diff =-1;
      detector_found = 1;
    }
#line 466139 "MACS_sample_kidney_box.c"
}   /* End of spec_detector_10=PSD_monitor() SETTING parameter declarations. */
#undef PSD_p2
#undef PSD_p
#undef PSD_N
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex
#undef mcabsorb
#define mcabsorb mcabsorbAll
  } /* end comp spec_detector_10 in GROUP detector_group */
  if (SCATTERED) {
    mcGroupdetector_group=906;
    RESTORE=0;
  }
  /* Label for restoring  neutron */
  mcabsorbCompspec_detector_10:
  if (RESTORE) /* restore if needed */
  { RESTORE_NEUTRON(906,
      mcnlx,
      mcnly,
      mcnlz,
      mcnlvx,
      mcnlvy,
      mcnlvz,
      mcnlt,
      mcnlsx,
      mcnlsy,
      mcnlsz,
      mcnlp); }
#undef mcabsorbComp
#undef p
#undef sz
#undef sy
#undef sx
#undef t
#undef vz
#undef vy
#undef vx
#undef z
#undef y
#undef x
  mcDEBUG_STATE(
mcnlx,
mcnly,
mcnlz,
mcnlvx,
mcnlvy,
mcnlvz,
mcnlt,
mcnlsx,
mcnlsy,
mcnlsz,
mcnlp)

  /* TRACE Component diffraction_detector_11 [907] */
  mccoordschange(mcposrdiffraction_detector_11, mcrotrdiffraction_detector_11,
    &mcnlx,
    &mcnly,
    &mcnlz,
    &mcnlvx,
    &mcnlvy,
    &mcnlvz,
    &mcnlsx,
    &mcnlsy,
    &mcnlsz);
  /* define label inside component diffraction_detector_11 (without coords transformations) */
  mcJumpTrace_diffraction_detector_11:
  SIG_MESSAGE("diffraction_detector_11 (Trace)");
  mcDEBUG_COMP("diffraction_detector_11")
  mcDEBUG_STATE(
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp)
#define x mcnlx
#define y mcnly
#define z mcnlz
#define vx mcnlvx
#define vy mcnlvy
#define vz mcnlvz
#define t mcnlt
#define sx mcnlsx
#define sy mcnlsy
#define sz mcnlsz
#define p mcnlp

#define mcabsorbComp mcabsorbCompdiffraction_detector_11
  STORE_NEUTRON(907,
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp);
  mcScattered=0;
  mcRestore=0;
  mcNCounter[907]++;
  mcPCounter[907] += p;
  mcP2Counter[907] += p*p;
  if (!mcGroupdetector_group) { /* previous comps of GROUP have not SCATTERED yet */
#undef mcabsorb
/* if ABSORBed in GROUP/comp, will go to end of component */
RESTORE=1;
#define mcabsorb mcabsorbCompdiffraction_detector_11
#define mccompcurname  diffraction_detector_11
#define mccompcurtype  PSD_monitor
#define mccompcurindex 907
#define PSD_N mccdiffraction_detector_11_PSD_N
#define PSD_p mccdiffraction_detector_11_PSD_p
#define PSD_p2 mccdiffraction_detector_11_PSD_p2
{   /* Declarations of diffraction_detector_11=PSD_monitor() SETTING parameters. */
int nx = mccdiffraction_detector_11_nx;
int ny = mccdiffraction_detector_11_ny;
char* filename = mccdiffraction_detector_11_filename;
MCNUM xmin = mccdiffraction_detector_11_xmin;
MCNUM xmax = mccdiffraction_detector_11_xmax;
MCNUM ymin = mccdiffraction_detector_11_ymin;
MCNUM ymax = mccdiffraction_detector_11_ymax;
MCNUM xwidth = mccdiffraction_detector_11_xwidth;
MCNUM yheight = mccdiffraction_detector_11_yheight;
MCNUM restore_neutron = mccdiffraction_detector_11_restore_neutron;
#line 94 "/usr/share/mcstas/2.7/monitors/PSD_monitor.comp"
{
  PROP_Z0;
  if (x>xmin && x<xmax && y>ymin && y<ymax){
    int i = floor((x - xmin)*nx/(xmax - xmin));
    int j = floor((y - ymin)*ny/(ymax - ymin));
    PSD_N[i][j]++;
    PSD_p[i][j] += p;
    PSD_p2[i][j] += p*p;
    SCATTER;
  }
  if (restore_neutron) {
    RESTORE_NEUTRON(INDEX_CURRENT_COMP, x, y, z, vx, vy, vz, t, sx, sy, sz, p);
  }
}
#line 466285 "MACS_sample_kidney_box.c"
/* 'diffraction_detector_11=PSD_monitor()' component instance extend code */
    SIG_MESSAGE("diffraction_detector_11 (Trace:Extend)");
#line 5282 "generated_includes/kidney_trace.c"
    if (SCATTERED) {
      detector_channel_diff =11;
      detector_channel_spec =-1;
      detector_found = 1;
    }
#line 466294 "MACS_sample_kidney_box.c"
}   /* End of diffraction_detector_11=PSD_monitor() SETTING parameter declarations. */
#undef PSD_p2
#undef PSD_p
#undef PSD_N
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex
#undef mcabsorb
#define mcabsorb mcabsorbAll
  } /* end comp diffraction_detector_11 in GROUP detector_group */
  if (SCATTERED) {
    mcGroupdetector_group=907;
    RESTORE=0;
  }
  /* Label for restoring  neutron */
  mcabsorbCompdiffraction_detector_11:
  if (RESTORE) /* restore if needed */
  { RESTORE_NEUTRON(907,
      mcnlx,
      mcnly,
      mcnlz,
      mcnlvx,
      mcnlvy,
      mcnlvz,
      mcnlt,
      mcnlsx,
      mcnlsy,
      mcnlsz,
      mcnlp); }
#undef mcabsorbComp
#undef p
#undef sz
#undef sy
#undef sx
#undef t
#undef vz
#undef vy
#undef vx
#undef z
#undef y
#undef x
  mcDEBUG_STATE(
mcnlx,
mcnly,
mcnlz,
mcnlvx,
mcnlvy,
mcnlvz,
mcnlt,
mcnlsx,
mcnlsy,
mcnlsz,
mcnlp)

  /* TRACE Component spec_detector_11 [908] */
  mccoordschange(mcposrspec_detector_11, mcrotrspec_detector_11,
    &mcnlx,
    &mcnly,
    &mcnlz,
    &mcnlvx,
    &mcnlvy,
    &mcnlvz,
    &mcnlsx,
    &mcnlsy,
    &mcnlsz);
  /* define label inside component spec_detector_11 (without coords transformations) */
  mcJumpTrace_spec_detector_11:
  SIG_MESSAGE("spec_detector_11 (Trace)");
  mcDEBUG_COMP("spec_detector_11")
  mcDEBUG_STATE(
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp)
#define x mcnlx
#define y mcnly
#define z mcnlz
#define vx mcnlvx
#define vy mcnlvy
#define vz mcnlvz
#define t mcnlt
#define sx mcnlsx
#define sy mcnlsy
#define sz mcnlsz
#define p mcnlp

#define mcabsorbComp mcabsorbCompspec_detector_11
  STORE_NEUTRON(908,
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp);
  mcScattered=0;
  mcRestore=0;
  mcNCounter[908]++;
  mcPCounter[908] += p;
  mcP2Counter[908] += p*p;
  if (!mcGroupdetector_group) { /* previous comps of GROUP have not SCATTERED yet */
#undef mcabsorb
/* if ABSORBed in GROUP/comp, will go to end of component */
RESTORE=1;
#define mcabsorb mcabsorbCompspec_detector_11
#define mccompcurname  spec_detector_11
#define mccompcurtype  PSD_monitor
#define mccompcurindex 908
#define PSD_N mccspec_detector_11_PSD_N
#define PSD_p mccspec_detector_11_PSD_p
#define PSD_p2 mccspec_detector_11_PSD_p2
{   /* Declarations of spec_detector_11=PSD_monitor() SETTING parameters. */
int nx = mccspec_detector_11_nx;
int ny = mccspec_detector_11_ny;
char* filename = mccspec_detector_11_filename;
MCNUM xmin = mccspec_detector_11_xmin;
MCNUM xmax = mccspec_detector_11_xmax;
MCNUM ymin = mccspec_detector_11_ymin;
MCNUM ymax = mccspec_detector_11_ymax;
MCNUM xwidth = mccspec_detector_11_xwidth;
MCNUM yheight = mccspec_detector_11_yheight;
MCNUM restore_neutron = mccspec_detector_11_restore_neutron;
#line 94 "/usr/share/mcstas/2.7/monitors/PSD_monitor.comp"
{
  PROP_Z0;
  if (x>xmin && x<xmax && y>ymin && y<ymax){
    int i = floor((x - xmin)*nx/(xmax - xmin));
    int j = floor((y - ymin)*ny/(ymax - ymin));
    PSD_N[i][j]++;
    PSD_p[i][j] += p;
    PSD_p2[i][j] += p*p;
    SCATTER;
  }
  if (restore_neutron) {
    RESTORE_NEUTRON(INDEX_CURRENT_COMP, x, y, z, vx, vy, vz, t, sx, sy, sz, p);
  }
}
#line 466440 "MACS_sample_kidney_box.c"
/* 'spec_detector_11=PSD_monitor()' component instance extend code */
    SIG_MESSAGE("spec_detector_11 (Trace:Extend)");
#line 5296 "generated_includes/kidney_trace.c"
    if (SCATTERED) {
      detector_channel_spec =11;
      detector_channel_diff =-1;
      detector_found = 1;
    }
#line 466449 "MACS_sample_kidney_box.c"
}   /* End of spec_detector_11=PSD_monitor() SETTING parameter declarations. */
#undef PSD_p2
#undef PSD_p
#undef PSD_N
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex
#undef mcabsorb
#define mcabsorb mcabsorbAll
  } /* end comp spec_detector_11 in GROUP detector_group */
  if (SCATTERED) {
    mcGroupdetector_group=908;
    RESTORE=0;
  }
  /* Label for restoring  neutron */
  mcabsorbCompspec_detector_11:
  if (RESTORE) /* restore if needed */
  { RESTORE_NEUTRON(908,
      mcnlx,
      mcnly,
      mcnlz,
      mcnlvx,
      mcnlvy,
      mcnlvz,
      mcnlt,
      mcnlsx,
      mcnlsy,
      mcnlsz,
      mcnlp); }
#undef mcabsorbComp
#undef p
#undef sz
#undef sy
#undef sx
#undef t
#undef vz
#undef vy
#undef vx
#undef z
#undef y
#undef x
  mcDEBUG_STATE(
mcnlx,
mcnly,
mcnlz,
mcnlvx,
mcnlvy,
mcnlvz,
mcnlt,
mcnlsx,
mcnlsy,
mcnlsz,
mcnlp)

  /* TRACE Component diffraction_detector_12 [909] */
  mccoordschange(mcposrdiffraction_detector_12, mcrotrdiffraction_detector_12,
    &mcnlx,
    &mcnly,
    &mcnlz,
    &mcnlvx,
    &mcnlvy,
    &mcnlvz,
    &mcnlsx,
    &mcnlsy,
    &mcnlsz);
  /* define label inside component diffraction_detector_12 (without coords transformations) */
  mcJumpTrace_diffraction_detector_12:
  SIG_MESSAGE("diffraction_detector_12 (Trace)");
  mcDEBUG_COMP("diffraction_detector_12")
  mcDEBUG_STATE(
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp)
#define x mcnlx
#define y mcnly
#define z mcnlz
#define vx mcnlvx
#define vy mcnlvy
#define vz mcnlvz
#define t mcnlt
#define sx mcnlsx
#define sy mcnlsy
#define sz mcnlsz
#define p mcnlp

#define mcabsorbComp mcabsorbCompdiffraction_detector_12
  STORE_NEUTRON(909,
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp);
  mcScattered=0;
  mcRestore=0;
  mcNCounter[909]++;
  mcPCounter[909] += p;
  mcP2Counter[909] += p*p;
  if (!mcGroupdetector_group) { /* previous comps of GROUP have not SCATTERED yet */
#undef mcabsorb
/* if ABSORBed in GROUP/comp, will go to end of component */
RESTORE=1;
#define mcabsorb mcabsorbCompdiffraction_detector_12
#define mccompcurname  diffraction_detector_12
#define mccompcurtype  PSD_monitor
#define mccompcurindex 909
#define PSD_N mccdiffraction_detector_12_PSD_N
#define PSD_p mccdiffraction_detector_12_PSD_p
#define PSD_p2 mccdiffraction_detector_12_PSD_p2
{   /* Declarations of diffraction_detector_12=PSD_monitor() SETTING parameters. */
int nx = mccdiffraction_detector_12_nx;
int ny = mccdiffraction_detector_12_ny;
char* filename = mccdiffraction_detector_12_filename;
MCNUM xmin = mccdiffraction_detector_12_xmin;
MCNUM xmax = mccdiffraction_detector_12_xmax;
MCNUM ymin = mccdiffraction_detector_12_ymin;
MCNUM ymax = mccdiffraction_detector_12_ymax;
MCNUM xwidth = mccdiffraction_detector_12_xwidth;
MCNUM yheight = mccdiffraction_detector_12_yheight;
MCNUM restore_neutron = mccdiffraction_detector_12_restore_neutron;
#line 94 "/usr/share/mcstas/2.7/monitors/PSD_monitor.comp"
{
  PROP_Z0;
  if (x>xmin && x<xmax && y>ymin && y<ymax){
    int i = floor((x - xmin)*nx/(xmax - xmin));
    int j = floor((y - ymin)*ny/(ymax - ymin));
    PSD_N[i][j]++;
    PSD_p[i][j] += p;
    PSD_p2[i][j] += p*p;
    SCATTER;
  }
  if (restore_neutron) {
    RESTORE_NEUTRON(INDEX_CURRENT_COMP, x, y, z, vx, vy, vz, t, sx, sy, sz, p);
  }
}
#line 466595 "MACS_sample_kidney_box.c"
/* 'diffraction_detector_12=PSD_monitor()' component instance extend code */
    SIG_MESSAGE("diffraction_detector_12 (Trace:Extend)");
#line 5310 "generated_includes/kidney_trace.c"
    if (SCATTERED) {
      detector_channel_diff =12;
      detector_channel_spec =-1;
      detector_found = 1;
    }
#line 466604 "MACS_sample_kidney_box.c"
}   /* End of diffraction_detector_12=PSD_monitor() SETTING parameter declarations. */
#undef PSD_p2
#undef PSD_p
#undef PSD_N
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex
#undef mcabsorb
#define mcabsorb mcabsorbAll
  } /* end comp diffraction_detector_12 in GROUP detector_group */
  if (SCATTERED) {
    mcGroupdetector_group=909;
    RESTORE=0;
  }
  /* Label for restoring  neutron */
  mcabsorbCompdiffraction_detector_12:
  if (RESTORE) /* restore if needed */
  { RESTORE_NEUTRON(909,
      mcnlx,
      mcnly,
      mcnlz,
      mcnlvx,
      mcnlvy,
      mcnlvz,
      mcnlt,
      mcnlsx,
      mcnlsy,
      mcnlsz,
      mcnlp); }
#undef mcabsorbComp
#undef p
#undef sz
#undef sy
#undef sx
#undef t
#undef vz
#undef vy
#undef vx
#undef z
#undef y
#undef x
  mcDEBUG_STATE(
mcnlx,
mcnly,
mcnlz,
mcnlvx,
mcnlvy,
mcnlvz,
mcnlt,
mcnlsx,
mcnlsy,
mcnlsz,
mcnlp)

  /* TRACE Component spec_detector_12 [910] */
  mccoordschange(mcposrspec_detector_12, mcrotrspec_detector_12,
    &mcnlx,
    &mcnly,
    &mcnlz,
    &mcnlvx,
    &mcnlvy,
    &mcnlvz,
    &mcnlsx,
    &mcnlsy,
    &mcnlsz);
  /* define label inside component spec_detector_12 (without coords transformations) */
  mcJumpTrace_spec_detector_12:
  SIG_MESSAGE("spec_detector_12 (Trace)");
  mcDEBUG_COMP("spec_detector_12")
  mcDEBUG_STATE(
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp)
#define x mcnlx
#define y mcnly
#define z mcnlz
#define vx mcnlvx
#define vy mcnlvy
#define vz mcnlvz
#define t mcnlt
#define sx mcnlsx
#define sy mcnlsy
#define sz mcnlsz
#define p mcnlp

#define mcabsorbComp mcabsorbCompspec_detector_12
  STORE_NEUTRON(910,
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp);
  mcScattered=0;
  mcRestore=0;
  mcNCounter[910]++;
  mcPCounter[910] += p;
  mcP2Counter[910] += p*p;
  if (!mcGroupdetector_group) { /* previous comps of GROUP have not SCATTERED yet */
#undef mcabsorb
/* if ABSORBed in GROUP/comp, will go to end of component */
RESTORE=1;
#define mcabsorb mcabsorbCompspec_detector_12
#define mccompcurname  spec_detector_12
#define mccompcurtype  PSD_monitor
#define mccompcurindex 910
#define PSD_N mccspec_detector_12_PSD_N
#define PSD_p mccspec_detector_12_PSD_p
#define PSD_p2 mccspec_detector_12_PSD_p2
{   /* Declarations of spec_detector_12=PSD_monitor() SETTING parameters. */
int nx = mccspec_detector_12_nx;
int ny = mccspec_detector_12_ny;
char* filename = mccspec_detector_12_filename;
MCNUM xmin = mccspec_detector_12_xmin;
MCNUM xmax = mccspec_detector_12_xmax;
MCNUM ymin = mccspec_detector_12_ymin;
MCNUM ymax = mccspec_detector_12_ymax;
MCNUM xwidth = mccspec_detector_12_xwidth;
MCNUM yheight = mccspec_detector_12_yheight;
MCNUM restore_neutron = mccspec_detector_12_restore_neutron;
#line 94 "/usr/share/mcstas/2.7/monitors/PSD_monitor.comp"
{
  PROP_Z0;
  if (x>xmin && x<xmax && y>ymin && y<ymax){
    int i = floor((x - xmin)*nx/(xmax - xmin));
    int j = floor((y - ymin)*ny/(ymax - ymin));
    PSD_N[i][j]++;
    PSD_p[i][j] += p;
    PSD_p2[i][j] += p*p;
    SCATTER;
  }
  if (restore_neutron) {
    RESTORE_NEUTRON(INDEX_CURRENT_COMP, x, y, z, vx, vy, vz, t, sx, sy, sz, p);
  }
}
#line 466750 "MACS_sample_kidney_box.c"
/* 'spec_detector_12=PSD_monitor()' component instance extend code */
    SIG_MESSAGE("spec_detector_12 (Trace:Extend)");
#line 5324 "generated_includes/kidney_trace.c"
    if (SCATTERED) {
      detector_channel_spec =12;
      detector_channel_diff =-1;
      detector_found = 1;
    }
#line 466759 "MACS_sample_kidney_box.c"
}   /* End of spec_detector_12=PSD_monitor() SETTING parameter declarations. */
#undef PSD_p2
#undef PSD_p
#undef PSD_N
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex
#undef mcabsorb
#define mcabsorb mcabsorbAll
  } /* end comp spec_detector_12 in GROUP detector_group */
  if (SCATTERED) {
    mcGroupdetector_group=910;
    RESTORE=0;
  }
  /* Label for restoring  neutron */
  mcabsorbCompspec_detector_12:
  if (RESTORE) /* restore if needed */
  { RESTORE_NEUTRON(910,
      mcnlx,
      mcnly,
      mcnlz,
      mcnlvx,
      mcnlvy,
      mcnlvz,
      mcnlt,
      mcnlsx,
      mcnlsy,
      mcnlsz,
      mcnlp); }
#undef mcabsorbComp
#undef p
#undef sz
#undef sy
#undef sx
#undef t
#undef vz
#undef vy
#undef vx
#undef z
#undef y
#undef x
  mcDEBUG_STATE(
mcnlx,
mcnly,
mcnlz,
mcnlvx,
mcnlvy,
mcnlvz,
mcnlt,
mcnlsx,
mcnlsy,
mcnlsz,
mcnlp)

  /* TRACE Component diffraction_detector_13 [911] */
  mccoordschange(mcposrdiffraction_detector_13, mcrotrdiffraction_detector_13,
    &mcnlx,
    &mcnly,
    &mcnlz,
    &mcnlvx,
    &mcnlvy,
    &mcnlvz,
    &mcnlsx,
    &mcnlsy,
    &mcnlsz);
  /* define label inside component diffraction_detector_13 (without coords transformations) */
  mcJumpTrace_diffraction_detector_13:
  SIG_MESSAGE("diffraction_detector_13 (Trace)");
  mcDEBUG_COMP("diffraction_detector_13")
  mcDEBUG_STATE(
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp)
#define x mcnlx
#define y mcnly
#define z mcnlz
#define vx mcnlvx
#define vy mcnlvy
#define vz mcnlvz
#define t mcnlt
#define sx mcnlsx
#define sy mcnlsy
#define sz mcnlsz
#define p mcnlp

#define mcabsorbComp mcabsorbCompdiffraction_detector_13
  STORE_NEUTRON(911,
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp);
  mcScattered=0;
  mcRestore=0;
  mcNCounter[911]++;
  mcPCounter[911] += p;
  mcP2Counter[911] += p*p;
  if (!mcGroupdetector_group) { /* previous comps of GROUP have not SCATTERED yet */
#undef mcabsorb
/* if ABSORBed in GROUP/comp, will go to end of component */
RESTORE=1;
#define mcabsorb mcabsorbCompdiffraction_detector_13
#define mccompcurname  diffraction_detector_13
#define mccompcurtype  PSD_monitor
#define mccompcurindex 911
#define PSD_N mccdiffraction_detector_13_PSD_N
#define PSD_p mccdiffraction_detector_13_PSD_p
#define PSD_p2 mccdiffraction_detector_13_PSD_p2
{   /* Declarations of diffraction_detector_13=PSD_monitor() SETTING parameters. */
int nx = mccdiffraction_detector_13_nx;
int ny = mccdiffraction_detector_13_ny;
char* filename = mccdiffraction_detector_13_filename;
MCNUM xmin = mccdiffraction_detector_13_xmin;
MCNUM xmax = mccdiffraction_detector_13_xmax;
MCNUM ymin = mccdiffraction_detector_13_ymin;
MCNUM ymax = mccdiffraction_detector_13_ymax;
MCNUM xwidth = mccdiffraction_detector_13_xwidth;
MCNUM yheight = mccdiffraction_detector_13_yheight;
MCNUM restore_neutron = mccdiffraction_detector_13_restore_neutron;
#line 94 "/usr/share/mcstas/2.7/monitors/PSD_monitor.comp"
{
  PROP_Z0;
  if (x>xmin && x<xmax && y>ymin && y<ymax){
    int i = floor((x - xmin)*nx/(xmax - xmin));
    int j = floor((y - ymin)*ny/(ymax - ymin));
    PSD_N[i][j]++;
    PSD_p[i][j] += p;
    PSD_p2[i][j] += p*p;
    SCATTER;
  }
  if (restore_neutron) {
    RESTORE_NEUTRON(INDEX_CURRENT_COMP, x, y, z, vx, vy, vz, t, sx, sy, sz, p);
  }
}
#line 466905 "MACS_sample_kidney_box.c"
/* 'diffraction_detector_13=PSD_monitor()' component instance extend code */
    SIG_MESSAGE("diffraction_detector_13 (Trace:Extend)");
#line 5338 "generated_includes/kidney_trace.c"
    if (SCATTERED) {
      detector_channel_diff =13;
      detector_channel_spec =-1;
      detector_found = 1;
    }
#line 466914 "MACS_sample_kidney_box.c"
}   /* End of diffraction_detector_13=PSD_monitor() SETTING parameter declarations. */
#undef PSD_p2
#undef PSD_p
#undef PSD_N
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex
#undef mcabsorb
#define mcabsorb mcabsorbAll
  } /* end comp diffraction_detector_13 in GROUP detector_group */
  if (SCATTERED) {
    mcGroupdetector_group=911;
    RESTORE=0;
  }
  /* Label for restoring  neutron */
  mcabsorbCompdiffraction_detector_13:
  if (RESTORE) /* restore if needed */
  { RESTORE_NEUTRON(911,
      mcnlx,
      mcnly,
      mcnlz,
      mcnlvx,
      mcnlvy,
      mcnlvz,
      mcnlt,
      mcnlsx,
      mcnlsy,
      mcnlsz,
      mcnlp); }
#undef mcabsorbComp
#undef p
#undef sz
#undef sy
#undef sx
#undef t
#undef vz
#undef vy
#undef vx
#undef z
#undef y
#undef x
  mcDEBUG_STATE(
mcnlx,
mcnly,
mcnlz,
mcnlvx,
mcnlvy,
mcnlvz,
mcnlt,
mcnlsx,
mcnlsy,
mcnlsz,
mcnlp)

  /* TRACE Component spec_detector_13 [912] */
  mccoordschange(mcposrspec_detector_13, mcrotrspec_detector_13,
    &mcnlx,
    &mcnly,
    &mcnlz,
    &mcnlvx,
    &mcnlvy,
    &mcnlvz,
    &mcnlsx,
    &mcnlsy,
    &mcnlsz);
  /* define label inside component spec_detector_13 (without coords transformations) */
  mcJumpTrace_spec_detector_13:
  SIG_MESSAGE("spec_detector_13 (Trace)");
  mcDEBUG_COMP("spec_detector_13")
  mcDEBUG_STATE(
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp)
#define x mcnlx
#define y mcnly
#define z mcnlz
#define vx mcnlvx
#define vy mcnlvy
#define vz mcnlvz
#define t mcnlt
#define sx mcnlsx
#define sy mcnlsy
#define sz mcnlsz
#define p mcnlp

#define mcabsorbComp mcabsorbCompspec_detector_13
  STORE_NEUTRON(912,
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp);
  mcScattered=0;
  mcRestore=0;
  mcNCounter[912]++;
  mcPCounter[912] += p;
  mcP2Counter[912] += p*p;
  if (!mcGroupdetector_group) { /* previous comps of GROUP have not SCATTERED yet */
#undef mcabsorb
/* if ABSORBed in GROUP/comp, will go to end of component */
RESTORE=1;
#define mcabsorb mcabsorbCompspec_detector_13
#define mccompcurname  spec_detector_13
#define mccompcurtype  PSD_monitor
#define mccompcurindex 912
#define PSD_N mccspec_detector_13_PSD_N
#define PSD_p mccspec_detector_13_PSD_p
#define PSD_p2 mccspec_detector_13_PSD_p2
{   /* Declarations of spec_detector_13=PSD_monitor() SETTING parameters. */
int nx = mccspec_detector_13_nx;
int ny = mccspec_detector_13_ny;
char* filename = mccspec_detector_13_filename;
MCNUM xmin = mccspec_detector_13_xmin;
MCNUM xmax = mccspec_detector_13_xmax;
MCNUM ymin = mccspec_detector_13_ymin;
MCNUM ymax = mccspec_detector_13_ymax;
MCNUM xwidth = mccspec_detector_13_xwidth;
MCNUM yheight = mccspec_detector_13_yheight;
MCNUM restore_neutron = mccspec_detector_13_restore_neutron;
#line 94 "/usr/share/mcstas/2.7/monitors/PSD_monitor.comp"
{
  PROP_Z0;
  if (x>xmin && x<xmax && y>ymin && y<ymax){
    int i = floor((x - xmin)*nx/(xmax - xmin));
    int j = floor((y - ymin)*ny/(ymax - ymin));
    PSD_N[i][j]++;
    PSD_p[i][j] += p;
    PSD_p2[i][j] += p*p;
    SCATTER;
  }
  if (restore_neutron) {
    RESTORE_NEUTRON(INDEX_CURRENT_COMP, x, y, z, vx, vy, vz, t, sx, sy, sz, p);
  }
}
#line 467060 "MACS_sample_kidney_box.c"
/* 'spec_detector_13=PSD_monitor()' component instance extend code */
    SIG_MESSAGE("spec_detector_13 (Trace:Extend)");
#line 5352 "generated_includes/kidney_trace.c"
    if (SCATTERED) {
      detector_channel_spec =13;
      detector_channel_diff =-1;
      detector_found = 1;
    }
#line 467069 "MACS_sample_kidney_box.c"
}   /* End of spec_detector_13=PSD_monitor() SETTING parameter declarations. */
#undef PSD_p2
#undef PSD_p
#undef PSD_N
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex
#undef mcabsorb
#define mcabsorb mcabsorbAll
  } /* end comp spec_detector_13 in GROUP detector_group */
  if (SCATTERED) {
    mcGroupdetector_group=912;
    RESTORE=0;
  }
  /* Label for restoring  neutron */
  mcabsorbCompspec_detector_13:
  if (RESTORE) /* restore if needed */
  { RESTORE_NEUTRON(912,
      mcnlx,
      mcnly,
      mcnlz,
      mcnlvx,
      mcnlvy,
      mcnlvz,
      mcnlt,
      mcnlsx,
      mcnlsy,
      mcnlsz,
      mcnlp); }
#undef mcabsorbComp
#undef p
#undef sz
#undef sy
#undef sx
#undef t
#undef vz
#undef vy
#undef vx
#undef z
#undef y
#undef x
  mcDEBUG_STATE(
mcnlx,
mcnly,
mcnlz,
mcnlvx,
mcnlvy,
mcnlvz,
mcnlt,
mcnlsx,
mcnlsy,
mcnlsz,
mcnlp)

  /* TRACE Component diffraction_detector_14 [913] */
  mccoordschange(mcposrdiffraction_detector_14, mcrotrdiffraction_detector_14,
    &mcnlx,
    &mcnly,
    &mcnlz,
    &mcnlvx,
    &mcnlvy,
    &mcnlvz,
    &mcnlsx,
    &mcnlsy,
    &mcnlsz);
  /* define label inside component diffraction_detector_14 (without coords transformations) */
  mcJumpTrace_diffraction_detector_14:
  SIG_MESSAGE("diffraction_detector_14 (Trace)");
  mcDEBUG_COMP("diffraction_detector_14")
  mcDEBUG_STATE(
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp)
#define x mcnlx
#define y mcnly
#define z mcnlz
#define vx mcnlvx
#define vy mcnlvy
#define vz mcnlvz
#define t mcnlt
#define sx mcnlsx
#define sy mcnlsy
#define sz mcnlsz
#define p mcnlp

#define mcabsorbComp mcabsorbCompdiffraction_detector_14
  STORE_NEUTRON(913,
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp);
  mcScattered=0;
  mcRestore=0;
  mcNCounter[913]++;
  mcPCounter[913] += p;
  mcP2Counter[913] += p*p;
  if (!mcGroupdetector_group) { /* previous comps of GROUP have not SCATTERED yet */
#undef mcabsorb
/* if ABSORBed in GROUP/comp, will go to end of component */
RESTORE=1;
#define mcabsorb mcabsorbCompdiffraction_detector_14
#define mccompcurname  diffraction_detector_14
#define mccompcurtype  PSD_monitor
#define mccompcurindex 913
#define PSD_N mccdiffraction_detector_14_PSD_N
#define PSD_p mccdiffraction_detector_14_PSD_p
#define PSD_p2 mccdiffraction_detector_14_PSD_p2
{   /* Declarations of diffraction_detector_14=PSD_monitor() SETTING parameters. */
int nx = mccdiffraction_detector_14_nx;
int ny = mccdiffraction_detector_14_ny;
char* filename = mccdiffraction_detector_14_filename;
MCNUM xmin = mccdiffraction_detector_14_xmin;
MCNUM xmax = mccdiffraction_detector_14_xmax;
MCNUM ymin = mccdiffraction_detector_14_ymin;
MCNUM ymax = mccdiffraction_detector_14_ymax;
MCNUM xwidth = mccdiffraction_detector_14_xwidth;
MCNUM yheight = mccdiffraction_detector_14_yheight;
MCNUM restore_neutron = mccdiffraction_detector_14_restore_neutron;
#line 94 "/usr/share/mcstas/2.7/monitors/PSD_monitor.comp"
{
  PROP_Z0;
  if (x>xmin && x<xmax && y>ymin && y<ymax){
    int i = floor((x - xmin)*nx/(xmax - xmin));
    int j = floor((y - ymin)*ny/(ymax - ymin));
    PSD_N[i][j]++;
    PSD_p[i][j] += p;
    PSD_p2[i][j] += p*p;
    SCATTER;
  }
  if (restore_neutron) {
    RESTORE_NEUTRON(INDEX_CURRENT_COMP, x, y, z, vx, vy, vz, t, sx, sy, sz, p);
  }
}
#line 467215 "MACS_sample_kidney_box.c"
/* 'diffraction_detector_14=PSD_monitor()' component instance extend code */
    SIG_MESSAGE("diffraction_detector_14 (Trace:Extend)");
#line 5366 "generated_includes/kidney_trace.c"
    if (SCATTERED) {
      detector_channel_diff =14;
      detector_channel_spec =-1;
      detector_found = 1;
    }
#line 467224 "MACS_sample_kidney_box.c"
}   /* End of diffraction_detector_14=PSD_monitor() SETTING parameter declarations. */
#undef PSD_p2
#undef PSD_p
#undef PSD_N
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex
#undef mcabsorb
#define mcabsorb mcabsorbAll
  } /* end comp diffraction_detector_14 in GROUP detector_group */
  if (SCATTERED) {
    mcGroupdetector_group=913;
    RESTORE=0;
  }
  /* Label for restoring  neutron */
  mcabsorbCompdiffraction_detector_14:
  if (RESTORE) /* restore if needed */
  { RESTORE_NEUTRON(913,
      mcnlx,
      mcnly,
      mcnlz,
      mcnlvx,
      mcnlvy,
      mcnlvz,
      mcnlt,
      mcnlsx,
      mcnlsy,
      mcnlsz,
      mcnlp); }
#undef mcabsorbComp
#undef p
#undef sz
#undef sy
#undef sx
#undef t
#undef vz
#undef vy
#undef vx
#undef z
#undef y
#undef x
  mcDEBUG_STATE(
mcnlx,
mcnly,
mcnlz,
mcnlvx,
mcnlvy,
mcnlvz,
mcnlt,
mcnlsx,
mcnlsy,
mcnlsz,
mcnlp)

  /* TRACE Component spec_detector_14 [914] */
  mccoordschange(mcposrspec_detector_14, mcrotrspec_detector_14,
    &mcnlx,
    &mcnly,
    &mcnlz,
    &mcnlvx,
    &mcnlvy,
    &mcnlvz,
    &mcnlsx,
    &mcnlsy,
    &mcnlsz);
  /* define label inside component spec_detector_14 (without coords transformations) */
  mcJumpTrace_spec_detector_14:
  SIG_MESSAGE("spec_detector_14 (Trace)");
  mcDEBUG_COMP("spec_detector_14")
  mcDEBUG_STATE(
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp)
#define x mcnlx
#define y mcnly
#define z mcnlz
#define vx mcnlvx
#define vy mcnlvy
#define vz mcnlvz
#define t mcnlt
#define sx mcnlsx
#define sy mcnlsy
#define sz mcnlsz
#define p mcnlp

#define mcabsorbComp mcabsorbCompspec_detector_14
  STORE_NEUTRON(914,
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp);
  mcScattered=0;
  mcRestore=0;
  mcNCounter[914]++;
  mcPCounter[914] += p;
  mcP2Counter[914] += p*p;
  if (!mcGroupdetector_group) { /* previous comps of GROUP have not SCATTERED yet */
#undef mcabsorb
/* if ABSORBed in GROUP/comp, will go to end of component */
RESTORE=1;
#define mcabsorb mcabsorbCompspec_detector_14
#define mccompcurname  spec_detector_14
#define mccompcurtype  PSD_monitor
#define mccompcurindex 914
#define PSD_N mccspec_detector_14_PSD_N
#define PSD_p mccspec_detector_14_PSD_p
#define PSD_p2 mccspec_detector_14_PSD_p2
{   /* Declarations of spec_detector_14=PSD_monitor() SETTING parameters. */
int nx = mccspec_detector_14_nx;
int ny = mccspec_detector_14_ny;
char* filename = mccspec_detector_14_filename;
MCNUM xmin = mccspec_detector_14_xmin;
MCNUM xmax = mccspec_detector_14_xmax;
MCNUM ymin = mccspec_detector_14_ymin;
MCNUM ymax = mccspec_detector_14_ymax;
MCNUM xwidth = mccspec_detector_14_xwidth;
MCNUM yheight = mccspec_detector_14_yheight;
MCNUM restore_neutron = mccspec_detector_14_restore_neutron;
#line 94 "/usr/share/mcstas/2.7/monitors/PSD_monitor.comp"
{
  PROP_Z0;
  if (x>xmin && x<xmax && y>ymin && y<ymax){
    int i = floor((x - xmin)*nx/(xmax - xmin));
    int j = floor((y - ymin)*ny/(ymax - ymin));
    PSD_N[i][j]++;
    PSD_p[i][j] += p;
    PSD_p2[i][j] += p*p;
    SCATTER;
  }
  if (restore_neutron) {
    RESTORE_NEUTRON(INDEX_CURRENT_COMP, x, y, z, vx, vy, vz, t, sx, sy, sz, p);
  }
}
#line 467370 "MACS_sample_kidney_box.c"
/* 'spec_detector_14=PSD_monitor()' component instance extend code */
    SIG_MESSAGE("spec_detector_14 (Trace:Extend)");
#line 5380 "generated_includes/kidney_trace.c"
    if (SCATTERED) {
      detector_channel_spec =14;
      detector_channel_diff =-1;
      detector_found = 1;
    }
#line 467379 "MACS_sample_kidney_box.c"
}   /* End of spec_detector_14=PSD_monitor() SETTING parameter declarations. */
#undef PSD_p2
#undef PSD_p
#undef PSD_N
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex
#undef mcabsorb
#define mcabsorb mcabsorbAll
  } /* end comp spec_detector_14 in GROUP detector_group */
  if (SCATTERED) {
    mcGroupdetector_group=914;
    RESTORE=0;
  }
  /* Label for restoring  neutron */
  mcabsorbCompspec_detector_14:
  if (RESTORE) /* restore if needed */
  { RESTORE_NEUTRON(914,
      mcnlx,
      mcnly,
      mcnlz,
      mcnlvx,
      mcnlvy,
      mcnlvz,
      mcnlt,
      mcnlsx,
      mcnlsy,
      mcnlsz,
      mcnlp); }
#undef mcabsorbComp
#undef p
#undef sz
#undef sy
#undef sx
#undef t
#undef vz
#undef vy
#undef vx
#undef z
#undef y
#undef x
  mcDEBUG_STATE(
mcnlx,
mcnly,
mcnlz,
mcnlvx,
mcnlvy,
mcnlvz,
mcnlt,
mcnlsx,
mcnlsy,
mcnlsz,
mcnlp)

  /* TRACE Component diffraction_detector_15 [915] */
  mccoordschange(mcposrdiffraction_detector_15, mcrotrdiffraction_detector_15,
    &mcnlx,
    &mcnly,
    &mcnlz,
    &mcnlvx,
    &mcnlvy,
    &mcnlvz,
    &mcnlsx,
    &mcnlsy,
    &mcnlsz);
  /* define label inside component diffraction_detector_15 (without coords transformations) */
  mcJumpTrace_diffraction_detector_15:
  SIG_MESSAGE("diffraction_detector_15 (Trace)");
  mcDEBUG_COMP("diffraction_detector_15")
  mcDEBUG_STATE(
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp)
#define x mcnlx
#define y mcnly
#define z mcnlz
#define vx mcnlvx
#define vy mcnlvy
#define vz mcnlvz
#define t mcnlt
#define sx mcnlsx
#define sy mcnlsy
#define sz mcnlsz
#define p mcnlp

#define mcabsorbComp mcabsorbCompdiffraction_detector_15
  STORE_NEUTRON(915,
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp);
  mcScattered=0;
  mcRestore=0;
  mcNCounter[915]++;
  mcPCounter[915] += p;
  mcP2Counter[915] += p*p;
  if (!mcGroupdetector_group) { /* previous comps of GROUP have not SCATTERED yet */
#undef mcabsorb
/* if ABSORBed in GROUP/comp, will go to end of component */
RESTORE=1;
#define mcabsorb mcabsorbCompdiffraction_detector_15
#define mccompcurname  diffraction_detector_15
#define mccompcurtype  PSD_monitor
#define mccompcurindex 915
#define PSD_N mccdiffraction_detector_15_PSD_N
#define PSD_p mccdiffraction_detector_15_PSD_p
#define PSD_p2 mccdiffraction_detector_15_PSD_p2
{   /* Declarations of diffraction_detector_15=PSD_monitor() SETTING parameters. */
int nx = mccdiffraction_detector_15_nx;
int ny = mccdiffraction_detector_15_ny;
char* filename = mccdiffraction_detector_15_filename;
MCNUM xmin = mccdiffraction_detector_15_xmin;
MCNUM xmax = mccdiffraction_detector_15_xmax;
MCNUM ymin = mccdiffraction_detector_15_ymin;
MCNUM ymax = mccdiffraction_detector_15_ymax;
MCNUM xwidth = mccdiffraction_detector_15_xwidth;
MCNUM yheight = mccdiffraction_detector_15_yheight;
MCNUM restore_neutron = mccdiffraction_detector_15_restore_neutron;
#line 94 "/usr/share/mcstas/2.7/monitors/PSD_monitor.comp"
{
  PROP_Z0;
  if (x>xmin && x<xmax && y>ymin && y<ymax){
    int i = floor((x - xmin)*nx/(xmax - xmin));
    int j = floor((y - ymin)*ny/(ymax - ymin));
    PSD_N[i][j]++;
    PSD_p[i][j] += p;
    PSD_p2[i][j] += p*p;
    SCATTER;
  }
  if (restore_neutron) {
    RESTORE_NEUTRON(INDEX_CURRENT_COMP, x, y, z, vx, vy, vz, t, sx, sy, sz, p);
  }
}
#line 467525 "MACS_sample_kidney_box.c"
/* 'diffraction_detector_15=PSD_monitor()' component instance extend code */
    SIG_MESSAGE("diffraction_detector_15 (Trace:Extend)");
#line 5394 "generated_includes/kidney_trace.c"
    if (SCATTERED) {
      detector_channel_diff =15;
      detector_channel_spec =-1;
      detector_found = 1;
    }
#line 467534 "MACS_sample_kidney_box.c"
}   /* End of diffraction_detector_15=PSD_monitor() SETTING parameter declarations. */
#undef PSD_p2
#undef PSD_p
#undef PSD_N
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex
#undef mcabsorb
#define mcabsorb mcabsorbAll
  } /* end comp diffraction_detector_15 in GROUP detector_group */
  if (SCATTERED) {
    mcGroupdetector_group=915;
    RESTORE=0;
  }
  /* Label for restoring  neutron */
  mcabsorbCompdiffraction_detector_15:
  if (RESTORE) /* restore if needed */
  { RESTORE_NEUTRON(915,
      mcnlx,
      mcnly,
      mcnlz,
      mcnlvx,
      mcnlvy,
      mcnlvz,
      mcnlt,
      mcnlsx,
      mcnlsy,
      mcnlsz,
      mcnlp); }
#undef mcabsorbComp
#undef p
#undef sz
#undef sy
#undef sx
#undef t
#undef vz
#undef vy
#undef vx
#undef z
#undef y
#undef x
  mcDEBUG_STATE(
mcnlx,
mcnly,
mcnlz,
mcnlvx,
mcnlvy,
mcnlvz,
mcnlt,
mcnlsx,
mcnlsy,
mcnlsz,
mcnlp)

  /* TRACE Component spec_detector_15 [916] */
  mccoordschange(mcposrspec_detector_15, mcrotrspec_detector_15,
    &mcnlx,
    &mcnly,
    &mcnlz,
    &mcnlvx,
    &mcnlvy,
    &mcnlvz,
    &mcnlsx,
    &mcnlsy,
    &mcnlsz);
  /* define label inside component spec_detector_15 (without coords transformations) */
  mcJumpTrace_spec_detector_15:
  SIG_MESSAGE("spec_detector_15 (Trace)");
  mcDEBUG_COMP("spec_detector_15")
  mcDEBUG_STATE(
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp)
#define x mcnlx
#define y mcnly
#define z mcnlz
#define vx mcnlvx
#define vy mcnlvy
#define vz mcnlvz
#define t mcnlt
#define sx mcnlsx
#define sy mcnlsy
#define sz mcnlsz
#define p mcnlp

#define mcabsorbComp mcabsorbCompspec_detector_15
  STORE_NEUTRON(916,
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp);
  mcScattered=0;
  mcRestore=0;
  mcNCounter[916]++;
  mcPCounter[916] += p;
  mcP2Counter[916] += p*p;
  if (!mcGroupdetector_group) { /* previous comps of GROUP have not SCATTERED yet */
#undef mcabsorb
/* if ABSORBed in GROUP/comp, will go to end of component */
RESTORE=1;
#define mcabsorb mcabsorbCompspec_detector_15
#define mccompcurname  spec_detector_15
#define mccompcurtype  PSD_monitor
#define mccompcurindex 916
#define PSD_N mccspec_detector_15_PSD_N
#define PSD_p mccspec_detector_15_PSD_p
#define PSD_p2 mccspec_detector_15_PSD_p2
{   /* Declarations of spec_detector_15=PSD_monitor() SETTING parameters. */
int nx = mccspec_detector_15_nx;
int ny = mccspec_detector_15_ny;
char* filename = mccspec_detector_15_filename;
MCNUM xmin = mccspec_detector_15_xmin;
MCNUM xmax = mccspec_detector_15_xmax;
MCNUM ymin = mccspec_detector_15_ymin;
MCNUM ymax = mccspec_detector_15_ymax;
MCNUM xwidth = mccspec_detector_15_xwidth;
MCNUM yheight = mccspec_detector_15_yheight;
MCNUM restore_neutron = mccspec_detector_15_restore_neutron;
#line 94 "/usr/share/mcstas/2.7/monitors/PSD_monitor.comp"
{
  PROP_Z0;
  if (x>xmin && x<xmax && y>ymin && y<ymax){
    int i = floor((x - xmin)*nx/(xmax - xmin));
    int j = floor((y - ymin)*ny/(ymax - ymin));
    PSD_N[i][j]++;
    PSD_p[i][j] += p;
    PSD_p2[i][j] += p*p;
    SCATTER;
  }
  if (restore_neutron) {
    RESTORE_NEUTRON(INDEX_CURRENT_COMP, x, y, z, vx, vy, vz, t, sx, sy, sz, p);
  }
}
#line 467680 "MACS_sample_kidney_box.c"
/* 'spec_detector_15=PSD_monitor()' component instance extend code */
    SIG_MESSAGE("spec_detector_15 (Trace:Extend)");
#line 5408 "generated_includes/kidney_trace.c"
    if (SCATTERED) {
      detector_channel_spec =15;
      detector_channel_diff =-1;
      detector_found = 1;
    }
#line 467689 "MACS_sample_kidney_box.c"
}   /* End of spec_detector_15=PSD_monitor() SETTING parameter declarations. */
#undef PSD_p2
#undef PSD_p
#undef PSD_N
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex
#undef mcabsorb
#define mcabsorb mcabsorbAll
  } /* end comp spec_detector_15 in GROUP detector_group */
  if (SCATTERED) {
    mcGroupdetector_group=916;
    RESTORE=0;
  }
  /* Label for restoring  neutron */
  mcabsorbCompspec_detector_15:
  if (RESTORE) /* restore if needed */
  { RESTORE_NEUTRON(916,
      mcnlx,
      mcnly,
      mcnlz,
      mcnlvx,
      mcnlvy,
      mcnlvz,
      mcnlt,
      mcnlsx,
      mcnlsy,
      mcnlsz,
      mcnlp); }
#undef mcabsorbComp
#undef p
#undef sz
#undef sy
#undef sx
#undef t
#undef vz
#undef vy
#undef vx
#undef z
#undef y
#undef x
  mcDEBUG_STATE(
mcnlx,
mcnly,
mcnlz,
mcnlvx,
mcnlvy,
mcnlvz,
mcnlt,
mcnlsx,
mcnlsy,
mcnlsz,
mcnlp)

  /* TRACE Component diffraction_detector_16 [917] */
  mccoordschange(mcposrdiffraction_detector_16, mcrotrdiffraction_detector_16,
    &mcnlx,
    &mcnly,
    &mcnlz,
    &mcnlvx,
    &mcnlvy,
    &mcnlvz,
    &mcnlsx,
    &mcnlsy,
    &mcnlsz);
  /* define label inside component diffraction_detector_16 (without coords transformations) */
  mcJumpTrace_diffraction_detector_16:
  SIG_MESSAGE("diffraction_detector_16 (Trace)");
  mcDEBUG_COMP("diffraction_detector_16")
  mcDEBUG_STATE(
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp)
#define x mcnlx
#define y mcnly
#define z mcnlz
#define vx mcnlvx
#define vy mcnlvy
#define vz mcnlvz
#define t mcnlt
#define sx mcnlsx
#define sy mcnlsy
#define sz mcnlsz
#define p mcnlp

#define mcabsorbComp mcabsorbCompdiffraction_detector_16
  STORE_NEUTRON(917,
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp);
  mcScattered=0;
  mcRestore=0;
  mcNCounter[917]++;
  mcPCounter[917] += p;
  mcP2Counter[917] += p*p;
  if (!mcGroupdetector_group) { /* previous comps of GROUP have not SCATTERED yet */
#undef mcabsorb
/* if ABSORBed in GROUP/comp, will go to end of component */
RESTORE=1;
#define mcabsorb mcabsorbCompdiffraction_detector_16
#define mccompcurname  diffraction_detector_16
#define mccompcurtype  PSD_monitor
#define mccompcurindex 917
#define PSD_N mccdiffraction_detector_16_PSD_N
#define PSD_p mccdiffraction_detector_16_PSD_p
#define PSD_p2 mccdiffraction_detector_16_PSD_p2
{   /* Declarations of diffraction_detector_16=PSD_monitor() SETTING parameters. */
int nx = mccdiffraction_detector_16_nx;
int ny = mccdiffraction_detector_16_ny;
char* filename = mccdiffraction_detector_16_filename;
MCNUM xmin = mccdiffraction_detector_16_xmin;
MCNUM xmax = mccdiffraction_detector_16_xmax;
MCNUM ymin = mccdiffraction_detector_16_ymin;
MCNUM ymax = mccdiffraction_detector_16_ymax;
MCNUM xwidth = mccdiffraction_detector_16_xwidth;
MCNUM yheight = mccdiffraction_detector_16_yheight;
MCNUM restore_neutron = mccdiffraction_detector_16_restore_neutron;
#line 94 "/usr/share/mcstas/2.7/monitors/PSD_monitor.comp"
{
  PROP_Z0;
  if (x>xmin && x<xmax && y>ymin && y<ymax){
    int i = floor((x - xmin)*nx/(xmax - xmin));
    int j = floor((y - ymin)*ny/(ymax - ymin));
    PSD_N[i][j]++;
    PSD_p[i][j] += p;
    PSD_p2[i][j] += p*p;
    SCATTER;
  }
  if (restore_neutron) {
    RESTORE_NEUTRON(INDEX_CURRENT_COMP, x, y, z, vx, vy, vz, t, sx, sy, sz, p);
  }
}
#line 467835 "MACS_sample_kidney_box.c"
/* 'diffraction_detector_16=PSD_monitor()' component instance extend code */
    SIG_MESSAGE("diffraction_detector_16 (Trace:Extend)");
#line 5422 "generated_includes/kidney_trace.c"
    if (SCATTERED) {
      detector_channel_diff =16;
      detector_channel_spec =-1;
      detector_found = 1;
    }
#line 467844 "MACS_sample_kidney_box.c"
}   /* End of diffraction_detector_16=PSD_monitor() SETTING parameter declarations. */
#undef PSD_p2
#undef PSD_p
#undef PSD_N
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex
#undef mcabsorb
#define mcabsorb mcabsorbAll
  } /* end comp diffraction_detector_16 in GROUP detector_group */
  if (SCATTERED) {
    mcGroupdetector_group=917;
    RESTORE=0;
  }
  /* Label for restoring  neutron */
  mcabsorbCompdiffraction_detector_16:
  if (RESTORE) /* restore if needed */
  { RESTORE_NEUTRON(917,
      mcnlx,
      mcnly,
      mcnlz,
      mcnlvx,
      mcnlvy,
      mcnlvz,
      mcnlt,
      mcnlsx,
      mcnlsy,
      mcnlsz,
      mcnlp); }
#undef mcabsorbComp
#undef p
#undef sz
#undef sy
#undef sx
#undef t
#undef vz
#undef vy
#undef vx
#undef z
#undef y
#undef x
  mcDEBUG_STATE(
mcnlx,
mcnly,
mcnlz,
mcnlvx,
mcnlvy,
mcnlvz,
mcnlt,
mcnlsx,
mcnlsy,
mcnlsz,
mcnlp)

  /* TRACE Component spec_detector_16 [918] */
  mccoordschange(mcposrspec_detector_16, mcrotrspec_detector_16,
    &mcnlx,
    &mcnly,
    &mcnlz,
    &mcnlvx,
    &mcnlvy,
    &mcnlvz,
    &mcnlsx,
    &mcnlsy,
    &mcnlsz);
  /* define label inside component spec_detector_16 (without coords transformations) */
  mcJumpTrace_spec_detector_16:
  SIG_MESSAGE("spec_detector_16 (Trace)");
  mcDEBUG_COMP("spec_detector_16")
  mcDEBUG_STATE(
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp)
#define x mcnlx
#define y mcnly
#define z mcnlz
#define vx mcnlvx
#define vy mcnlvy
#define vz mcnlvz
#define t mcnlt
#define sx mcnlsx
#define sy mcnlsy
#define sz mcnlsz
#define p mcnlp

#define mcabsorbComp mcabsorbCompspec_detector_16
  STORE_NEUTRON(918,
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp);
  mcScattered=0;
  mcRestore=0;
  mcNCounter[918]++;
  mcPCounter[918] += p;
  mcP2Counter[918] += p*p;
  if (!mcGroupdetector_group) { /* previous comps of GROUP have not SCATTERED yet */
#undef mcabsorb
/* if ABSORBed in GROUP/comp, will go to end of component */
RESTORE=1;
#define mcabsorb mcabsorbCompspec_detector_16
#define mccompcurname  spec_detector_16
#define mccompcurtype  PSD_monitor
#define mccompcurindex 918
#define PSD_N mccspec_detector_16_PSD_N
#define PSD_p mccspec_detector_16_PSD_p
#define PSD_p2 mccspec_detector_16_PSD_p2
{   /* Declarations of spec_detector_16=PSD_monitor() SETTING parameters. */
int nx = mccspec_detector_16_nx;
int ny = mccspec_detector_16_ny;
char* filename = mccspec_detector_16_filename;
MCNUM xmin = mccspec_detector_16_xmin;
MCNUM xmax = mccspec_detector_16_xmax;
MCNUM ymin = mccspec_detector_16_ymin;
MCNUM ymax = mccspec_detector_16_ymax;
MCNUM xwidth = mccspec_detector_16_xwidth;
MCNUM yheight = mccspec_detector_16_yheight;
MCNUM restore_neutron = mccspec_detector_16_restore_neutron;
#line 94 "/usr/share/mcstas/2.7/monitors/PSD_monitor.comp"
{
  PROP_Z0;
  if (x>xmin && x<xmax && y>ymin && y<ymax){
    int i = floor((x - xmin)*nx/(xmax - xmin));
    int j = floor((y - ymin)*ny/(ymax - ymin));
    PSD_N[i][j]++;
    PSD_p[i][j] += p;
    PSD_p2[i][j] += p*p;
    SCATTER;
  }
  if (restore_neutron) {
    RESTORE_NEUTRON(INDEX_CURRENT_COMP, x, y, z, vx, vy, vz, t, sx, sy, sz, p);
  }
}
#line 467990 "MACS_sample_kidney_box.c"
/* 'spec_detector_16=PSD_monitor()' component instance extend code */
    SIG_MESSAGE("spec_detector_16 (Trace:Extend)");
#line 5436 "generated_includes/kidney_trace.c"
    if (SCATTERED) {
      detector_channel_spec =16;
      detector_channel_diff =-1;
      detector_found = 1;
    }
#line 467999 "MACS_sample_kidney_box.c"
}   /* End of spec_detector_16=PSD_monitor() SETTING parameter declarations. */
#undef PSD_p2
#undef PSD_p
#undef PSD_N
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex
#undef mcabsorb
#define mcabsorb mcabsorbAll
  } /* end comp spec_detector_16 in GROUP detector_group */
  if (SCATTERED) {
    mcGroupdetector_group=918;
    RESTORE=0;
  }
  /* Label for restoring  neutron */
  mcabsorbCompspec_detector_16:
  if (RESTORE) /* restore if needed */
  { RESTORE_NEUTRON(918,
      mcnlx,
      mcnly,
      mcnlz,
      mcnlvx,
      mcnlvy,
      mcnlvz,
      mcnlt,
      mcnlsx,
      mcnlsy,
      mcnlsz,
      mcnlp); }
#undef mcabsorbComp
#undef p
#undef sz
#undef sy
#undef sx
#undef t
#undef vz
#undef vy
#undef vx
#undef z
#undef y
#undef x
  mcDEBUG_STATE(
mcnlx,
mcnly,
mcnlz,
mcnlvx,
mcnlvy,
mcnlvz,
mcnlt,
mcnlsx,
mcnlsy,
mcnlsz,
mcnlp)

  /* TRACE Component diffraction_detector_17 [919] */
  mccoordschange(mcposrdiffraction_detector_17, mcrotrdiffraction_detector_17,
    &mcnlx,
    &mcnly,
    &mcnlz,
    &mcnlvx,
    &mcnlvy,
    &mcnlvz,
    &mcnlsx,
    &mcnlsy,
    &mcnlsz);
  /* define label inside component diffraction_detector_17 (without coords transformations) */
  mcJumpTrace_diffraction_detector_17:
  SIG_MESSAGE("diffraction_detector_17 (Trace)");
  mcDEBUG_COMP("diffraction_detector_17")
  mcDEBUG_STATE(
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp)
#define x mcnlx
#define y mcnly
#define z mcnlz
#define vx mcnlvx
#define vy mcnlvy
#define vz mcnlvz
#define t mcnlt
#define sx mcnlsx
#define sy mcnlsy
#define sz mcnlsz
#define p mcnlp

#define mcabsorbComp mcabsorbCompdiffraction_detector_17
  STORE_NEUTRON(919,
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp);
  mcScattered=0;
  mcRestore=0;
  mcNCounter[919]++;
  mcPCounter[919] += p;
  mcP2Counter[919] += p*p;
  if (!mcGroupdetector_group) { /* previous comps of GROUP have not SCATTERED yet */
#undef mcabsorb
/* if ABSORBed in GROUP/comp, will go to end of component */
RESTORE=1;
#define mcabsorb mcabsorbCompdiffraction_detector_17
#define mccompcurname  diffraction_detector_17
#define mccompcurtype  PSD_monitor
#define mccompcurindex 919
#define PSD_N mccdiffraction_detector_17_PSD_N
#define PSD_p mccdiffraction_detector_17_PSD_p
#define PSD_p2 mccdiffraction_detector_17_PSD_p2
{   /* Declarations of diffraction_detector_17=PSD_monitor() SETTING parameters. */
int nx = mccdiffraction_detector_17_nx;
int ny = mccdiffraction_detector_17_ny;
char* filename = mccdiffraction_detector_17_filename;
MCNUM xmin = mccdiffraction_detector_17_xmin;
MCNUM xmax = mccdiffraction_detector_17_xmax;
MCNUM ymin = mccdiffraction_detector_17_ymin;
MCNUM ymax = mccdiffraction_detector_17_ymax;
MCNUM xwidth = mccdiffraction_detector_17_xwidth;
MCNUM yheight = mccdiffraction_detector_17_yheight;
MCNUM restore_neutron = mccdiffraction_detector_17_restore_neutron;
#line 94 "/usr/share/mcstas/2.7/monitors/PSD_monitor.comp"
{
  PROP_Z0;
  if (x>xmin && x<xmax && y>ymin && y<ymax){
    int i = floor((x - xmin)*nx/(xmax - xmin));
    int j = floor((y - ymin)*ny/(ymax - ymin));
    PSD_N[i][j]++;
    PSD_p[i][j] += p;
    PSD_p2[i][j] += p*p;
    SCATTER;
  }
  if (restore_neutron) {
    RESTORE_NEUTRON(INDEX_CURRENT_COMP, x, y, z, vx, vy, vz, t, sx, sy, sz, p);
  }
}
#line 468145 "MACS_sample_kidney_box.c"
/* 'diffraction_detector_17=PSD_monitor()' component instance extend code */
    SIG_MESSAGE("diffraction_detector_17 (Trace:Extend)");
#line 5450 "generated_includes/kidney_trace.c"
    if (SCATTERED) {
      detector_channel_diff =17;
      detector_channel_spec =-1;
      detector_found = 1;
    }
#line 468154 "MACS_sample_kidney_box.c"
}   /* End of diffraction_detector_17=PSD_monitor() SETTING parameter declarations. */
#undef PSD_p2
#undef PSD_p
#undef PSD_N
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex
#undef mcabsorb
#define mcabsorb mcabsorbAll
  } /* end comp diffraction_detector_17 in GROUP detector_group */
  if (SCATTERED) {
    mcGroupdetector_group=919;
    RESTORE=0;
  }
  /* Label for restoring  neutron */
  mcabsorbCompdiffraction_detector_17:
  if (RESTORE) /* restore if needed */
  { RESTORE_NEUTRON(919,
      mcnlx,
      mcnly,
      mcnlz,
      mcnlvx,
      mcnlvy,
      mcnlvz,
      mcnlt,
      mcnlsx,
      mcnlsy,
      mcnlsz,
      mcnlp); }
#undef mcabsorbComp
#undef p
#undef sz
#undef sy
#undef sx
#undef t
#undef vz
#undef vy
#undef vx
#undef z
#undef y
#undef x
  mcDEBUG_STATE(
mcnlx,
mcnly,
mcnlz,
mcnlvx,
mcnlvy,
mcnlvz,
mcnlt,
mcnlsx,
mcnlsy,
mcnlsz,
mcnlp)

  /* TRACE Component spec_detector_17 [920] */
  mccoordschange(mcposrspec_detector_17, mcrotrspec_detector_17,
    &mcnlx,
    &mcnly,
    &mcnlz,
    &mcnlvx,
    &mcnlvy,
    &mcnlvz,
    &mcnlsx,
    &mcnlsy,
    &mcnlsz);
  /* define label inside component spec_detector_17 (without coords transformations) */
  mcJumpTrace_spec_detector_17:
  SIG_MESSAGE("spec_detector_17 (Trace)");
  mcDEBUG_COMP("spec_detector_17")
  mcDEBUG_STATE(
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp)
#define x mcnlx
#define y mcnly
#define z mcnlz
#define vx mcnlvx
#define vy mcnlvy
#define vz mcnlvz
#define t mcnlt
#define sx mcnlsx
#define sy mcnlsy
#define sz mcnlsz
#define p mcnlp

#define mcabsorbComp mcabsorbCompspec_detector_17
  STORE_NEUTRON(920,
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp);
  mcScattered=0;
  mcRestore=0;
  mcNCounter[920]++;
  mcPCounter[920] += p;
  mcP2Counter[920] += p*p;
  if (!mcGroupdetector_group) { /* previous comps of GROUP have not SCATTERED yet */
#undef mcabsorb
/* if ABSORBed in GROUP/comp, will go to end of component */
RESTORE=1;
#define mcabsorb mcabsorbCompspec_detector_17
#define mccompcurname  spec_detector_17
#define mccompcurtype  PSD_monitor
#define mccompcurindex 920
#define PSD_N mccspec_detector_17_PSD_N
#define PSD_p mccspec_detector_17_PSD_p
#define PSD_p2 mccspec_detector_17_PSD_p2
{   /* Declarations of spec_detector_17=PSD_monitor() SETTING parameters. */
int nx = mccspec_detector_17_nx;
int ny = mccspec_detector_17_ny;
char* filename = mccspec_detector_17_filename;
MCNUM xmin = mccspec_detector_17_xmin;
MCNUM xmax = mccspec_detector_17_xmax;
MCNUM ymin = mccspec_detector_17_ymin;
MCNUM ymax = mccspec_detector_17_ymax;
MCNUM xwidth = mccspec_detector_17_xwidth;
MCNUM yheight = mccspec_detector_17_yheight;
MCNUM restore_neutron = mccspec_detector_17_restore_neutron;
#line 94 "/usr/share/mcstas/2.7/monitors/PSD_monitor.comp"
{
  PROP_Z0;
  if (x>xmin && x<xmax && y>ymin && y<ymax){
    int i = floor((x - xmin)*nx/(xmax - xmin));
    int j = floor((y - ymin)*ny/(ymax - ymin));
    PSD_N[i][j]++;
    PSD_p[i][j] += p;
    PSD_p2[i][j] += p*p;
    SCATTER;
  }
  if (restore_neutron) {
    RESTORE_NEUTRON(INDEX_CURRENT_COMP, x, y, z, vx, vy, vz, t, sx, sy, sz, p);
  }
}
#line 468300 "MACS_sample_kidney_box.c"
/* 'spec_detector_17=PSD_monitor()' component instance extend code */
    SIG_MESSAGE("spec_detector_17 (Trace:Extend)");
#line 5464 "generated_includes/kidney_trace.c"
    if (SCATTERED) {
      detector_channel_spec =17;
      detector_channel_diff =-1;
      detector_found = 1;
    }
#line 468309 "MACS_sample_kidney_box.c"
}   /* End of spec_detector_17=PSD_monitor() SETTING parameter declarations. */
#undef PSD_p2
#undef PSD_p
#undef PSD_N
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex
#undef mcabsorb
#define mcabsorb mcabsorbAll
  } /* end comp spec_detector_17 in GROUP detector_group */
  if (SCATTERED) {
    mcGroupdetector_group=920;
    RESTORE=0;
  }
  /* Label for restoring  neutron */
  mcabsorbCompspec_detector_17:
  if (RESTORE) /* restore if needed */
  { RESTORE_NEUTRON(920,
      mcnlx,
      mcnly,
      mcnlz,
      mcnlvx,
      mcnlvy,
      mcnlvz,
      mcnlt,
      mcnlsx,
      mcnlsy,
      mcnlsz,
      mcnlp); }
#undef mcabsorbComp
#undef p
#undef sz
#undef sy
#undef sx
#undef t
#undef vz
#undef vy
#undef vx
#undef z
#undef y
#undef x
  mcDEBUG_STATE(
mcnlx,
mcnly,
mcnlz,
mcnlvx,
mcnlvy,
mcnlvz,
mcnlt,
mcnlsx,
mcnlsy,
mcnlsz,
mcnlp)

  /* TRACE Component diffraction_detector_18 [921] */
  mccoordschange(mcposrdiffraction_detector_18, mcrotrdiffraction_detector_18,
    &mcnlx,
    &mcnly,
    &mcnlz,
    &mcnlvx,
    &mcnlvy,
    &mcnlvz,
    &mcnlsx,
    &mcnlsy,
    &mcnlsz);
  /* define label inside component diffraction_detector_18 (without coords transformations) */
  mcJumpTrace_diffraction_detector_18:
  SIG_MESSAGE("diffraction_detector_18 (Trace)");
  mcDEBUG_COMP("diffraction_detector_18")
  mcDEBUG_STATE(
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp)
#define x mcnlx
#define y mcnly
#define z mcnlz
#define vx mcnlvx
#define vy mcnlvy
#define vz mcnlvz
#define t mcnlt
#define sx mcnlsx
#define sy mcnlsy
#define sz mcnlsz
#define p mcnlp

#define mcabsorbComp mcabsorbCompdiffraction_detector_18
  STORE_NEUTRON(921,
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp);
  mcScattered=0;
  mcRestore=0;
  mcNCounter[921]++;
  mcPCounter[921] += p;
  mcP2Counter[921] += p*p;
  if (!mcGroupdetector_group) { /* previous comps of GROUP have not SCATTERED yet */
#undef mcabsorb
/* if ABSORBed in GROUP/comp, will go to end of component */
RESTORE=1;
#define mcabsorb mcabsorbCompdiffraction_detector_18
#define mccompcurname  diffraction_detector_18
#define mccompcurtype  PSD_monitor
#define mccompcurindex 921
#define PSD_N mccdiffraction_detector_18_PSD_N
#define PSD_p mccdiffraction_detector_18_PSD_p
#define PSD_p2 mccdiffraction_detector_18_PSD_p2
{   /* Declarations of diffraction_detector_18=PSD_monitor() SETTING parameters. */
int nx = mccdiffraction_detector_18_nx;
int ny = mccdiffraction_detector_18_ny;
char* filename = mccdiffraction_detector_18_filename;
MCNUM xmin = mccdiffraction_detector_18_xmin;
MCNUM xmax = mccdiffraction_detector_18_xmax;
MCNUM ymin = mccdiffraction_detector_18_ymin;
MCNUM ymax = mccdiffraction_detector_18_ymax;
MCNUM xwidth = mccdiffraction_detector_18_xwidth;
MCNUM yheight = mccdiffraction_detector_18_yheight;
MCNUM restore_neutron = mccdiffraction_detector_18_restore_neutron;
#line 94 "/usr/share/mcstas/2.7/monitors/PSD_monitor.comp"
{
  PROP_Z0;
  if (x>xmin && x<xmax && y>ymin && y<ymax){
    int i = floor((x - xmin)*nx/(xmax - xmin));
    int j = floor((y - ymin)*ny/(ymax - ymin));
    PSD_N[i][j]++;
    PSD_p[i][j] += p;
    PSD_p2[i][j] += p*p;
    SCATTER;
  }
  if (restore_neutron) {
    RESTORE_NEUTRON(INDEX_CURRENT_COMP, x, y, z, vx, vy, vz, t, sx, sy, sz, p);
  }
}
#line 468455 "MACS_sample_kidney_box.c"
/* 'diffraction_detector_18=PSD_monitor()' component instance extend code */
    SIG_MESSAGE("diffraction_detector_18 (Trace:Extend)");
#line 5478 "generated_includes/kidney_trace.c"
    if (SCATTERED) {
      detector_channel_diff =18;
      detector_channel_spec =-1;
      detector_found = 1;
    }
#line 468464 "MACS_sample_kidney_box.c"
}   /* End of diffraction_detector_18=PSD_monitor() SETTING parameter declarations. */
#undef PSD_p2
#undef PSD_p
#undef PSD_N
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex
#undef mcabsorb
#define mcabsorb mcabsorbAll
  } /* end comp diffraction_detector_18 in GROUP detector_group */
  if (SCATTERED) {
    mcGroupdetector_group=921;
    RESTORE=0;
  }
  /* Label for restoring  neutron */
  mcabsorbCompdiffraction_detector_18:
  if (RESTORE) /* restore if needed */
  { RESTORE_NEUTRON(921,
      mcnlx,
      mcnly,
      mcnlz,
      mcnlvx,
      mcnlvy,
      mcnlvz,
      mcnlt,
      mcnlsx,
      mcnlsy,
      mcnlsz,
      mcnlp); }
#undef mcabsorbComp
#undef p
#undef sz
#undef sy
#undef sx
#undef t
#undef vz
#undef vy
#undef vx
#undef z
#undef y
#undef x
  mcDEBUG_STATE(
mcnlx,
mcnly,
mcnlz,
mcnlvx,
mcnlvy,
mcnlvz,
mcnlt,
mcnlsx,
mcnlsy,
mcnlsz,
mcnlp)

  /* TRACE Component spec_detector_18 [922] */
  mccoordschange(mcposrspec_detector_18, mcrotrspec_detector_18,
    &mcnlx,
    &mcnly,
    &mcnlz,
    &mcnlvx,
    &mcnlvy,
    &mcnlvz,
    &mcnlsx,
    &mcnlsy,
    &mcnlsz);
  /* define label inside component spec_detector_18 (without coords transformations) */
  mcJumpTrace_spec_detector_18:
  SIG_MESSAGE("spec_detector_18 (Trace)");
  mcDEBUG_COMP("spec_detector_18")
  mcDEBUG_STATE(
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp)
#define x mcnlx
#define y mcnly
#define z mcnlz
#define vx mcnlvx
#define vy mcnlvy
#define vz mcnlvz
#define t mcnlt
#define sx mcnlsx
#define sy mcnlsy
#define sz mcnlsz
#define p mcnlp

#define mcabsorbComp mcabsorbCompspec_detector_18
  STORE_NEUTRON(922,
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp);
  mcScattered=0;
  mcRestore=0;
  mcNCounter[922]++;
  mcPCounter[922] += p;
  mcP2Counter[922] += p*p;
  if (!mcGroupdetector_group) { /* previous comps of GROUP have not SCATTERED yet */
#undef mcabsorb
/* if ABSORBed in GROUP/comp, will go to end of component */
RESTORE=1;
#define mcabsorb mcabsorbCompspec_detector_18
#define mccompcurname  spec_detector_18
#define mccompcurtype  PSD_monitor
#define mccompcurindex 922
#define PSD_N mccspec_detector_18_PSD_N
#define PSD_p mccspec_detector_18_PSD_p
#define PSD_p2 mccspec_detector_18_PSD_p2
{   /* Declarations of spec_detector_18=PSD_monitor() SETTING parameters. */
int nx = mccspec_detector_18_nx;
int ny = mccspec_detector_18_ny;
char* filename = mccspec_detector_18_filename;
MCNUM xmin = mccspec_detector_18_xmin;
MCNUM xmax = mccspec_detector_18_xmax;
MCNUM ymin = mccspec_detector_18_ymin;
MCNUM ymax = mccspec_detector_18_ymax;
MCNUM xwidth = mccspec_detector_18_xwidth;
MCNUM yheight = mccspec_detector_18_yheight;
MCNUM restore_neutron = mccspec_detector_18_restore_neutron;
#line 94 "/usr/share/mcstas/2.7/monitors/PSD_monitor.comp"
{
  PROP_Z0;
  if (x>xmin && x<xmax && y>ymin && y<ymax){
    int i = floor((x - xmin)*nx/(xmax - xmin));
    int j = floor((y - ymin)*ny/(ymax - ymin));
    PSD_N[i][j]++;
    PSD_p[i][j] += p;
    PSD_p2[i][j] += p*p;
    SCATTER;
  }
  if (restore_neutron) {
    RESTORE_NEUTRON(INDEX_CURRENT_COMP, x, y, z, vx, vy, vz, t, sx, sy, sz, p);
  }
}
#line 468610 "MACS_sample_kidney_box.c"
/* 'spec_detector_18=PSD_monitor()' component instance extend code */
    SIG_MESSAGE("spec_detector_18 (Trace:Extend)");
#line 5492 "generated_includes/kidney_trace.c"
    if (SCATTERED) {
      detector_channel_spec =18;
      detector_channel_diff =-1;
      detector_found = 1;
    }
#line 468619 "MACS_sample_kidney_box.c"
}   /* End of spec_detector_18=PSD_monitor() SETTING parameter declarations. */
#undef PSD_p2
#undef PSD_p
#undef PSD_N
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex
#undef mcabsorb
#define mcabsorb mcabsorbAll
  } /* end comp spec_detector_18 in GROUP detector_group */
  if (SCATTERED) {
    mcGroupdetector_group=922;
    RESTORE=0;
  }
  /* Label for restoring  neutron */
  mcabsorbCompspec_detector_18:
  if (RESTORE) /* restore if needed */
  { RESTORE_NEUTRON(922,
      mcnlx,
      mcnly,
      mcnlz,
      mcnlvx,
      mcnlvy,
      mcnlvz,
      mcnlt,
      mcnlsx,
      mcnlsy,
      mcnlsz,
      mcnlp); }
#undef mcabsorbComp
#undef p
#undef sz
#undef sy
#undef sx
#undef t
#undef vz
#undef vy
#undef vx
#undef z
#undef y
#undef x
  mcDEBUG_STATE(
mcnlx,
mcnly,
mcnlz,
mcnlvx,
mcnlvy,
mcnlvz,
mcnlt,
mcnlsx,
mcnlsy,
mcnlsz,
mcnlp)

  /* TRACE Component diffraction_detector_19 [923] */
  mccoordschange(mcposrdiffraction_detector_19, mcrotrdiffraction_detector_19,
    &mcnlx,
    &mcnly,
    &mcnlz,
    &mcnlvx,
    &mcnlvy,
    &mcnlvz,
    &mcnlsx,
    &mcnlsy,
    &mcnlsz);
  /* define label inside component diffraction_detector_19 (without coords transformations) */
  mcJumpTrace_diffraction_detector_19:
  SIG_MESSAGE("diffraction_detector_19 (Trace)");
  mcDEBUG_COMP("diffraction_detector_19")
  mcDEBUG_STATE(
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp)
#define x mcnlx
#define y mcnly
#define z mcnlz
#define vx mcnlvx
#define vy mcnlvy
#define vz mcnlvz
#define t mcnlt
#define sx mcnlsx
#define sy mcnlsy
#define sz mcnlsz
#define p mcnlp

#define mcabsorbComp mcabsorbCompdiffraction_detector_19
  STORE_NEUTRON(923,
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp);
  mcScattered=0;
  mcRestore=0;
  mcNCounter[923]++;
  mcPCounter[923] += p;
  mcP2Counter[923] += p*p;
  if (!mcGroupdetector_group) { /* previous comps of GROUP have not SCATTERED yet */
#undef mcabsorb
/* if ABSORBed in GROUP/comp, will go to end of component */
RESTORE=1;
#define mcabsorb mcabsorbCompdiffraction_detector_19
#define mccompcurname  diffraction_detector_19
#define mccompcurtype  PSD_monitor
#define mccompcurindex 923
#define PSD_N mccdiffraction_detector_19_PSD_N
#define PSD_p mccdiffraction_detector_19_PSD_p
#define PSD_p2 mccdiffraction_detector_19_PSD_p2
{   /* Declarations of diffraction_detector_19=PSD_monitor() SETTING parameters. */
int nx = mccdiffraction_detector_19_nx;
int ny = mccdiffraction_detector_19_ny;
char* filename = mccdiffraction_detector_19_filename;
MCNUM xmin = mccdiffraction_detector_19_xmin;
MCNUM xmax = mccdiffraction_detector_19_xmax;
MCNUM ymin = mccdiffraction_detector_19_ymin;
MCNUM ymax = mccdiffraction_detector_19_ymax;
MCNUM xwidth = mccdiffraction_detector_19_xwidth;
MCNUM yheight = mccdiffraction_detector_19_yheight;
MCNUM restore_neutron = mccdiffraction_detector_19_restore_neutron;
#line 94 "/usr/share/mcstas/2.7/monitors/PSD_monitor.comp"
{
  PROP_Z0;
  if (x>xmin && x<xmax && y>ymin && y<ymax){
    int i = floor((x - xmin)*nx/(xmax - xmin));
    int j = floor((y - ymin)*ny/(ymax - ymin));
    PSD_N[i][j]++;
    PSD_p[i][j] += p;
    PSD_p2[i][j] += p*p;
    SCATTER;
  }
  if (restore_neutron) {
    RESTORE_NEUTRON(INDEX_CURRENT_COMP, x, y, z, vx, vy, vz, t, sx, sy, sz, p);
  }
}
#line 468765 "MACS_sample_kidney_box.c"
/* 'diffraction_detector_19=PSD_monitor()' component instance extend code */
    SIG_MESSAGE("diffraction_detector_19 (Trace:Extend)");
#line 5506 "generated_includes/kidney_trace.c"
    if (SCATTERED) {
      detector_channel_diff =19;
      detector_channel_spec =-1;
      detector_found = 1;
    }
#line 468774 "MACS_sample_kidney_box.c"
}   /* End of diffraction_detector_19=PSD_monitor() SETTING parameter declarations. */
#undef PSD_p2
#undef PSD_p
#undef PSD_N
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex
#undef mcabsorb
#define mcabsorb mcabsorbAll
  } /* end comp diffraction_detector_19 in GROUP detector_group */
  if (SCATTERED) {
    mcGroupdetector_group=923;
    RESTORE=0;
  }
  /* Label for restoring  neutron */
  mcabsorbCompdiffraction_detector_19:
  if (RESTORE) /* restore if needed */
  { RESTORE_NEUTRON(923,
      mcnlx,
      mcnly,
      mcnlz,
      mcnlvx,
      mcnlvy,
      mcnlvz,
      mcnlt,
      mcnlsx,
      mcnlsy,
      mcnlsz,
      mcnlp); }
#undef mcabsorbComp
#undef p
#undef sz
#undef sy
#undef sx
#undef t
#undef vz
#undef vy
#undef vx
#undef z
#undef y
#undef x
  mcDEBUG_STATE(
mcnlx,
mcnly,
mcnlz,
mcnlvx,
mcnlvy,
mcnlvz,
mcnlt,
mcnlsx,
mcnlsy,
mcnlsz,
mcnlp)

  /* TRACE Component spec_detector_19 [924] */
  mccoordschange(mcposrspec_detector_19, mcrotrspec_detector_19,
    &mcnlx,
    &mcnly,
    &mcnlz,
    &mcnlvx,
    &mcnlvy,
    &mcnlvz,
    &mcnlsx,
    &mcnlsy,
    &mcnlsz);
  /* define label inside component spec_detector_19 (without coords transformations) */
  mcJumpTrace_spec_detector_19:
  SIG_MESSAGE("spec_detector_19 (Trace)");
  mcDEBUG_COMP("spec_detector_19")
  mcDEBUG_STATE(
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp)
#define x mcnlx
#define y mcnly
#define z mcnlz
#define vx mcnlvx
#define vy mcnlvy
#define vz mcnlvz
#define t mcnlt
#define sx mcnlsx
#define sy mcnlsy
#define sz mcnlsz
#define p mcnlp

#define mcabsorbComp mcabsorbCompspec_detector_19
  STORE_NEUTRON(924,
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp);
  mcScattered=0;
  mcRestore=0;
  mcNCounter[924]++;
  mcPCounter[924] += p;
  mcP2Counter[924] += p*p;
  if (!mcGroupdetector_group) { /* previous comps of GROUP have not SCATTERED yet */
#undef mcabsorb
/* if ABSORBed in GROUP/comp, will go to end of component */
RESTORE=1;
#define mcabsorb mcabsorbCompspec_detector_19
#define mccompcurname  spec_detector_19
#define mccompcurtype  PSD_monitor
#define mccompcurindex 924
#define PSD_N mccspec_detector_19_PSD_N
#define PSD_p mccspec_detector_19_PSD_p
#define PSD_p2 mccspec_detector_19_PSD_p2
{   /* Declarations of spec_detector_19=PSD_monitor() SETTING parameters. */
int nx = mccspec_detector_19_nx;
int ny = mccspec_detector_19_ny;
char* filename = mccspec_detector_19_filename;
MCNUM xmin = mccspec_detector_19_xmin;
MCNUM xmax = mccspec_detector_19_xmax;
MCNUM ymin = mccspec_detector_19_ymin;
MCNUM ymax = mccspec_detector_19_ymax;
MCNUM xwidth = mccspec_detector_19_xwidth;
MCNUM yheight = mccspec_detector_19_yheight;
MCNUM restore_neutron = mccspec_detector_19_restore_neutron;
#line 94 "/usr/share/mcstas/2.7/monitors/PSD_monitor.comp"
{
  PROP_Z0;
  if (x>xmin && x<xmax && y>ymin && y<ymax){
    int i = floor((x - xmin)*nx/(xmax - xmin));
    int j = floor((y - ymin)*ny/(ymax - ymin));
    PSD_N[i][j]++;
    PSD_p[i][j] += p;
    PSD_p2[i][j] += p*p;
    SCATTER;
  }
  if (restore_neutron) {
    RESTORE_NEUTRON(INDEX_CURRENT_COMP, x, y, z, vx, vy, vz, t, sx, sy, sz, p);
  }
}
#line 468920 "MACS_sample_kidney_box.c"
/* 'spec_detector_19=PSD_monitor()' component instance extend code */
    SIG_MESSAGE("spec_detector_19 (Trace:Extend)");
#line 5520 "generated_includes/kidney_trace.c"
    if (SCATTERED) {
      detector_channel_spec =19;
      detector_channel_diff =-1;
      detector_found = 1;
    }
#line 468929 "MACS_sample_kidney_box.c"
}   /* End of spec_detector_19=PSD_monitor() SETTING parameter declarations. */
#undef PSD_p2
#undef PSD_p
#undef PSD_N
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex
#undef mcabsorb
#define mcabsorb mcabsorbAll
  } /* end comp spec_detector_19 in GROUP detector_group */
  if (SCATTERED) {
    mcGroupdetector_group=924;
    RESTORE=0;
  }
  /* Label for restoring  neutron */
  mcabsorbCompspec_detector_19:
  if (RESTORE) /* restore if needed */
  { RESTORE_NEUTRON(924,
      mcnlx,
      mcnly,
      mcnlz,
      mcnlvx,
      mcnlvy,
      mcnlvz,
      mcnlt,
      mcnlsx,
      mcnlsy,
      mcnlsz,
      mcnlp); }
/* end of GROUP detector_group */
  if (!mcGroupdetector_group) ABSORB; /* absorb neutron non scattered in GROUP */
  mcGroupdetector_group=0; /* reset group scattered flag */
#undef mcabsorbComp
#undef p
#undef sz
#undef sy
#undef sx
#undef t
#undef vz
#undef vy
#undef vx
#undef z
#undef y
#undef x
  mcDEBUG_STATE(
mcnlx,
mcnly,
mcnlz,
mcnlvx,
mcnlvy,
mcnlvz,
mcnlt,
mcnlsx,
mcnlsy,
mcnlsz,
mcnlp)

  /* TRACE Component spec_detector_history_0 [925] */
  mccoordschange(mcposrspec_detector_history_0, mcrotrspec_detector_history_0,
    &mcnlx,
    &mcnly,
    &mcnlz,
    &mcnlvx,
    &mcnlvy,
    &mcnlvz,
    &mcnlsx,
    &mcnlsy,
    &mcnlsz);
  /* define label inside component spec_detector_history_0 (without coords transformations) */
  mcJumpTrace_spec_detector_history_0:
  SIG_MESSAGE("spec_detector_history_0 (Trace)");
  mcDEBUG_COMP("spec_detector_history_0")
  mcDEBUG_STATE(
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp)
#define x mcnlx
#define y mcnly
#define z mcnlz
#define vx mcnlvx
#define vy mcnlvy
#define vz mcnlvz
#define t mcnlt
#define sx mcnlsx
#define sy mcnlsy
#define sz mcnlsz
#define p mcnlp

#define mcabsorbComp mcabsorbCompspec_detector_history_0
  STORE_NEUTRON(925,
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp);
  mcScattered=0;
  mcRestore=0;
  mcNCounter[925]++;
  mcPCounter[925] += p;
  mcP2Counter[925] += p*p;
#define mccompcurname  spec_detector_history_0
#define mccompcurtype  extend_monitor
#define mccompcurindex 925
#define nb mccspec_detector_history_0_nb
#define C_N mccspec_detector_history_0_C_N
#define C_p mccspec_detector_history_0_C_p
#define C_p2 mccspec_detector_history_0_C_p2
{   /* Declarations of spec_detector_history_0=extend_monitor() SETTING parameters. */
char* filename = mccspec_detector_history_0_filename;
MCNUM xmin = mccspec_detector_history_0_xmin;
MCNUM xmax = mccspec_detector_history_0_xmax;
MCNUM ymin = mccspec_detector_history_0_ymin;
MCNUM ymax = mccspec_detector_history_0_ymax;
MCNUM xwidth = mccspec_detector_history_0_xwidth;
MCNUM yheight = mccspec_detector_history_0_yheight;
MCNUM restore_neutron = mccspec_detector_history_0_restore_neutron;
/* 'spec_detector_history_0=extend_monitor()' component instance has conditional execution */
if (( detector_channel_spec == 0 && detector_found == 1 ))

#line 85 "extend_monitor.comp"
{
    int i;

    PROP_Z0;
    if (x>xmin && x<xmax && y>ymin && y<ymax)
    {
        C_N[0]++;
        C_p[0] += p;
        C_p2[0] += p*p;
        SCATTER;
    }
    if (restore_neutron) {
      RESTORE_NEUTRON(INDEX_CURRENT_COMP, x, y, z, vx, vy, vz, t, sx, sy, sz, p);
    }
}
#line 469075 "MACS_sample_kidney_box.c"
/* 'spec_detector_history_0=extend_monitor()' component instance extend code */
    SIG_MESSAGE("spec_detector_history_0 (Trace:Extend)");
if (( detector_channel_spec == 0 && detector_found == 1 )) {

#line 5534 "generated_includes/kidney_trace.c"
    if (SCATTERED) {
      flag_sum=0;
      for (flag_index=1;flag_index<MAX_VOLUME_HISTORY_LENGTH;flag_index++) {
        if (scattering_history_sample_master[flag_index] > 0) {
          C_N[flag_index+1]++;
          C_p[flag_index+1] += p;
          C_p2[flag_index+1] += p*p;
          flag_sum++;
          flag_single = flag_index;
        };
      };
      if (flag_sum == 0) {
        C_N[1]++;
        C_p[1] += p;
        C_p2[1] += p*p;
      };
      if (flag_sum == 1) {
        if (scattering_history_sample_master[flag_single] == 1) {
          C_N[MAX_VOLUME_HISTORY_LENGTH+flag_single+1]++;
          C_p[MAX_VOLUME_HISTORY_LENGTH+flag_single+1] += p;
          C_p2[MAX_VOLUME_HISTORY_LENGTH+flag_single+1] += p*p;
        };
      };
    };
#line 469104 "MACS_sample_kidney_box.c"
}

}   /* End of spec_detector_history_0=extend_monitor() SETTING parameter declarations. */
#undef C_p2
#undef C_p
#undef C_N
#undef nb
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex
  /* Label for restoring  neutron */
  mcabsorbCompspec_detector_history_0:
  if (RESTORE) /* restore if needed */
  { RESTORE_NEUTRON(925,
      mcnlx,
      mcnly,
      mcnlz,
      mcnlvx,
      mcnlvy,
      mcnlvz,
      mcnlt,
      mcnlsx,
      mcnlsy,
      mcnlsz,
      mcnlp); }
#undef mcabsorbComp
#undef p
#undef sz
#undef sy
#undef sx
#undef t
#undef vz
#undef vy
#undef vx
#undef z
#undef y
#undef x
  mcDEBUG_STATE(
mcnlx,
mcnly,
mcnlz,
mcnlvx,
mcnlvy,
mcnlvz,
mcnlt,
mcnlsx,
mcnlsy,
mcnlsz,
mcnlp)

  /* TRACE Component spec_detector_history_1 [926] */
  mccoordschange(mcposrspec_detector_history_1, mcrotrspec_detector_history_1,
    &mcnlx,
    &mcnly,
    &mcnlz,
    &mcnlvx,
    &mcnlvy,
    &mcnlvz,
    &mcnlsx,
    &mcnlsy,
    &mcnlsz);
  /* define label inside component spec_detector_history_1 (without coords transformations) */
  mcJumpTrace_spec_detector_history_1:
  SIG_MESSAGE("spec_detector_history_1 (Trace)");
  mcDEBUG_COMP("spec_detector_history_1")
  mcDEBUG_STATE(
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp)
#define x mcnlx
#define y mcnly
#define z mcnlz
#define vx mcnlvx
#define vy mcnlvy
#define vz mcnlvz
#define t mcnlt
#define sx mcnlsx
#define sy mcnlsy
#define sz mcnlsz
#define p mcnlp

#define mcabsorbComp mcabsorbCompspec_detector_history_1
  STORE_NEUTRON(926,
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp);
  mcScattered=0;
  mcRestore=0;
  mcNCounter[926]++;
  mcPCounter[926] += p;
  mcP2Counter[926] += p*p;
#define mccompcurname  spec_detector_history_1
#define mccompcurtype  extend_monitor
#define mccompcurindex 926
#define nb mccspec_detector_history_1_nb
#define C_N mccspec_detector_history_1_C_N
#define C_p mccspec_detector_history_1_C_p
#define C_p2 mccspec_detector_history_1_C_p2
{   /* Declarations of spec_detector_history_1=extend_monitor() SETTING parameters. */
char* filename = mccspec_detector_history_1_filename;
MCNUM xmin = mccspec_detector_history_1_xmin;
MCNUM xmax = mccspec_detector_history_1_xmax;
MCNUM ymin = mccspec_detector_history_1_ymin;
MCNUM ymax = mccspec_detector_history_1_ymax;
MCNUM xwidth = mccspec_detector_history_1_xwidth;
MCNUM yheight = mccspec_detector_history_1_yheight;
MCNUM restore_neutron = mccspec_detector_history_1_restore_neutron;
/* 'spec_detector_history_1=extend_monitor()' component instance has conditional execution */
if (( detector_channel_spec == 1 && detector_found == 1 ))

#line 85 "extend_monitor.comp"
{
    int i;

    PROP_Z0;
    if (x>xmin && x<xmax && y>ymin && y<ymax)
    {
        C_N[0]++;
        C_p[0] += p;
        C_p2[0] += p*p;
        SCATTER;
    }
    if (restore_neutron) {
      RESTORE_NEUTRON(INDEX_CURRENT_COMP, x, y, z, vx, vy, vz, t, sx, sy, sz, p);
    }
}
#line 469245 "MACS_sample_kidney_box.c"
/* 'spec_detector_history_1=extend_monitor()' component instance extend code */
    SIG_MESSAGE("spec_detector_history_1 (Trace:Extend)");
if (( detector_channel_spec == 1 && detector_found == 1 )) {

#line 5567 "generated_includes/kidney_trace.c"
    if (SCATTERED) {
      flag_sum=0;
      for (flag_index=1;flag_index<MAX_VOLUME_HISTORY_LENGTH;flag_index++) {
        if (scattering_history_sample_master[flag_index] > 0) {
          C_N[flag_index+1]++;
          C_p[flag_index+1] += p;
          C_p2[flag_index+1] += p*p;
          flag_sum++;
          flag_single = flag_index;
        };
      };
      if (flag_sum == 0) {
        C_N[1]++;
        C_p[1] += p;
        C_p2[1] += p*p;
      };
      if (flag_sum == 1) {
        if (scattering_history_sample_master[flag_single] == 1) {
          C_N[MAX_VOLUME_HISTORY_LENGTH+flag_single+1]++;
          C_p[MAX_VOLUME_HISTORY_LENGTH+flag_single+1] += p;
          C_p2[MAX_VOLUME_HISTORY_LENGTH+flag_single+1] += p*p;
        };
      };
    };
#line 469274 "MACS_sample_kidney_box.c"
}

}   /* End of spec_detector_history_1=extend_monitor() SETTING parameter declarations. */
#undef C_p2
#undef C_p
#undef C_N
#undef nb
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex
  /* Label for restoring  neutron */
  mcabsorbCompspec_detector_history_1:
  if (RESTORE) /* restore if needed */
  { RESTORE_NEUTRON(926,
      mcnlx,
      mcnly,
      mcnlz,
      mcnlvx,
      mcnlvy,
      mcnlvz,
      mcnlt,
      mcnlsx,
      mcnlsy,
      mcnlsz,
      mcnlp); }
#undef mcabsorbComp
#undef p
#undef sz
#undef sy
#undef sx
#undef t
#undef vz
#undef vy
#undef vx
#undef z
#undef y
#undef x
  mcDEBUG_STATE(
mcnlx,
mcnly,
mcnlz,
mcnlvx,
mcnlvy,
mcnlvz,
mcnlt,
mcnlsx,
mcnlsy,
mcnlsz,
mcnlp)

  /* TRACE Component spec_detector_history_2 [927] */
  mccoordschange(mcposrspec_detector_history_2, mcrotrspec_detector_history_2,
    &mcnlx,
    &mcnly,
    &mcnlz,
    &mcnlvx,
    &mcnlvy,
    &mcnlvz,
    &mcnlsx,
    &mcnlsy,
    &mcnlsz);
  /* define label inside component spec_detector_history_2 (without coords transformations) */
  mcJumpTrace_spec_detector_history_2:
  SIG_MESSAGE("spec_detector_history_2 (Trace)");
  mcDEBUG_COMP("spec_detector_history_2")
  mcDEBUG_STATE(
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp)
#define x mcnlx
#define y mcnly
#define z mcnlz
#define vx mcnlvx
#define vy mcnlvy
#define vz mcnlvz
#define t mcnlt
#define sx mcnlsx
#define sy mcnlsy
#define sz mcnlsz
#define p mcnlp

#define mcabsorbComp mcabsorbCompspec_detector_history_2
  STORE_NEUTRON(927,
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp);
  mcScattered=0;
  mcRestore=0;
  mcNCounter[927]++;
  mcPCounter[927] += p;
  mcP2Counter[927] += p*p;
#define mccompcurname  spec_detector_history_2
#define mccompcurtype  extend_monitor
#define mccompcurindex 927
#define nb mccspec_detector_history_2_nb
#define C_N mccspec_detector_history_2_C_N
#define C_p mccspec_detector_history_2_C_p
#define C_p2 mccspec_detector_history_2_C_p2
{   /* Declarations of spec_detector_history_2=extend_monitor() SETTING parameters. */
char* filename = mccspec_detector_history_2_filename;
MCNUM xmin = mccspec_detector_history_2_xmin;
MCNUM xmax = mccspec_detector_history_2_xmax;
MCNUM ymin = mccspec_detector_history_2_ymin;
MCNUM ymax = mccspec_detector_history_2_ymax;
MCNUM xwidth = mccspec_detector_history_2_xwidth;
MCNUM yheight = mccspec_detector_history_2_yheight;
MCNUM restore_neutron = mccspec_detector_history_2_restore_neutron;
/* 'spec_detector_history_2=extend_monitor()' component instance has conditional execution */
if (( detector_channel_spec == 2 && detector_found == 1 ))

#line 85 "extend_monitor.comp"
{
    int i;

    PROP_Z0;
    if (x>xmin && x<xmax && y>ymin && y<ymax)
    {
        C_N[0]++;
        C_p[0] += p;
        C_p2[0] += p*p;
        SCATTER;
    }
    if (restore_neutron) {
      RESTORE_NEUTRON(INDEX_CURRENT_COMP, x, y, z, vx, vy, vz, t, sx, sy, sz, p);
    }
}
#line 469415 "MACS_sample_kidney_box.c"
/* 'spec_detector_history_2=extend_monitor()' component instance extend code */
    SIG_MESSAGE("spec_detector_history_2 (Trace:Extend)");
if (( detector_channel_spec == 2 && detector_found == 1 )) {

#line 5600 "generated_includes/kidney_trace.c"
    if (SCATTERED) {
      flag_sum=0;
      for (flag_index=1;flag_index<MAX_VOLUME_HISTORY_LENGTH;flag_index++) {
        if (scattering_history_sample_master[flag_index] > 0) {
          C_N[flag_index+1]++;
          C_p[flag_index+1] += p;
          C_p2[flag_index+1] += p*p;
          flag_sum++;
          flag_single = flag_index;
        };
      };
      if (flag_sum == 0) {
        C_N[1]++;
        C_p[1] += p;
        C_p2[1] += p*p;
      };
      if (flag_sum == 1) {
        if (scattering_history_sample_master[flag_single] == 1) {
          C_N[MAX_VOLUME_HISTORY_LENGTH+flag_single+1]++;
          C_p[MAX_VOLUME_HISTORY_LENGTH+flag_single+1] += p;
          C_p2[MAX_VOLUME_HISTORY_LENGTH+flag_single+1] += p*p;
        };
      };
    };
#line 469444 "MACS_sample_kidney_box.c"
}

}   /* End of spec_detector_history_2=extend_monitor() SETTING parameter declarations. */
#undef C_p2
#undef C_p
#undef C_N
#undef nb
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex
  /* Label for restoring  neutron */
  mcabsorbCompspec_detector_history_2:
  if (RESTORE) /* restore if needed */
  { RESTORE_NEUTRON(927,
      mcnlx,
      mcnly,
      mcnlz,
      mcnlvx,
      mcnlvy,
      mcnlvz,
      mcnlt,
      mcnlsx,
      mcnlsy,
      mcnlsz,
      mcnlp); }
#undef mcabsorbComp
#undef p
#undef sz
#undef sy
#undef sx
#undef t
#undef vz
#undef vy
#undef vx
#undef z
#undef y
#undef x
  mcDEBUG_STATE(
mcnlx,
mcnly,
mcnlz,
mcnlvx,
mcnlvy,
mcnlvz,
mcnlt,
mcnlsx,
mcnlsy,
mcnlsz,
mcnlp)

  /* TRACE Component spec_detector_history_3 [928] */
  mccoordschange(mcposrspec_detector_history_3, mcrotrspec_detector_history_3,
    &mcnlx,
    &mcnly,
    &mcnlz,
    &mcnlvx,
    &mcnlvy,
    &mcnlvz,
    &mcnlsx,
    &mcnlsy,
    &mcnlsz);
  /* define label inside component spec_detector_history_3 (without coords transformations) */
  mcJumpTrace_spec_detector_history_3:
  SIG_MESSAGE("spec_detector_history_3 (Trace)");
  mcDEBUG_COMP("spec_detector_history_3")
  mcDEBUG_STATE(
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp)
#define x mcnlx
#define y mcnly
#define z mcnlz
#define vx mcnlvx
#define vy mcnlvy
#define vz mcnlvz
#define t mcnlt
#define sx mcnlsx
#define sy mcnlsy
#define sz mcnlsz
#define p mcnlp

#define mcabsorbComp mcabsorbCompspec_detector_history_3
  STORE_NEUTRON(928,
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp);
  mcScattered=0;
  mcRestore=0;
  mcNCounter[928]++;
  mcPCounter[928] += p;
  mcP2Counter[928] += p*p;
#define mccompcurname  spec_detector_history_3
#define mccompcurtype  extend_monitor
#define mccompcurindex 928
#define nb mccspec_detector_history_3_nb
#define C_N mccspec_detector_history_3_C_N
#define C_p mccspec_detector_history_3_C_p
#define C_p2 mccspec_detector_history_3_C_p2
{   /* Declarations of spec_detector_history_3=extend_monitor() SETTING parameters. */
char* filename = mccspec_detector_history_3_filename;
MCNUM xmin = mccspec_detector_history_3_xmin;
MCNUM xmax = mccspec_detector_history_3_xmax;
MCNUM ymin = mccspec_detector_history_3_ymin;
MCNUM ymax = mccspec_detector_history_3_ymax;
MCNUM xwidth = mccspec_detector_history_3_xwidth;
MCNUM yheight = mccspec_detector_history_3_yheight;
MCNUM restore_neutron = mccspec_detector_history_3_restore_neutron;
/* 'spec_detector_history_3=extend_monitor()' component instance has conditional execution */
if (( detector_channel_spec == 3 && detector_found == 1 ))

#line 85 "extend_monitor.comp"
{
    int i;

    PROP_Z0;
    if (x>xmin && x<xmax && y>ymin && y<ymax)
    {
        C_N[0]++;
        C_p[0] += p;
        C_p2[0] += p*p;
        SCATTER;
    }
    if (restore_neutron) {
      RESTORE_NEUTRON(INDEX_CURRENT_COMP, x, y, z, vx, vy, vz, t, sx, sy, sz, p);
    }
}
#line 469585 "MACS_sample_kidney_box.c"
/* 'spec_detector_history_3=extend_monitor()' component instance extend code */
    SIG_MESSAGE("spec_detector_history_3 (Trace:Extend)");
if (( detector_channel_spec == 3 && detector_found == 1 )) {

#line 5633 "generated_includes/kidney_trace.c"
    if (SCATTERED) {
      flag_sum=0;
      for (flag_index=1;flag_index<MAX_VOLUME_HISTORY_LENGTH;flag_index++) {
        if (scattering_history_sample_master[flag_index] > 0) {
          C_N[flag_index+1]++;
          C_p[flag_index+1] += p;
          C_p2[flag_index+1] += p*p;
          flag_sum++;
          flag_single = flag_index;
        };
      };
      if (flag_sum == 0) {
        C_N[1]++;
        C_p[1] += p;
        C_p2[1] += p*p;
      };
      if (flag_sum == 1) {
        if (scattering_history_sample_master[flag_single] == 1) {
          C_N[MAX_VOLUME_HISTORY_LENGTH+flag_single+1]++;
          C_p[MAX_VOLUME_HISTORY_LENGTH+flag_single+1] += p;
          C_p2[MAX_VOLUME_HISTORY_LENGTH+flag_single+1] += p*p;
        };
      };
    };
#line 469614 "MACS_sample_kidney_box.c"
}

}   /* End of spec_detector_history_3=extend_monitor() SETTING parameter declarations. */
#undef C_p2
#undef C_p
#undef C_N
#undef nb
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex
  /* Label for restoring  neutron */
  mcabsorbCompspec_detector_history_3:
  if (RESTORE) /* restore if needed */
  { RESTORE_NEUTRON(928,
      mcnlx,
      mcnly,
      mcnlz,
      mcnlvx,
      mcnlvy,
      mcnlvz,
      mcnlt,
      mcnlsx,
      mcnlsy,
      mcnlsz,
      mcnlp); }
#undef mcabsorbComp
#undef p
#undef sz
#undef sy
#undef sx
#undef t
#undef vz
#undef vy
#undef vx
#undef z
#undef y
#undef x
  mcDEBUG_STATE(
mcnlx,
mcnly,
mcnlz,
mcnlvx,
mcnlvy,
mcnlvz,
mcnlt,
mcnlsx,
mcnlsy,
mcnlsz,
mcnlp)

  /* TRACE Component spec_detector_history_4 [929] */
  mccoordschange(mcposrspec_detector_history_4, mcrotrspec_detector_history_4,
    &mcnlx,
    &mcnly,
    &mcnlz,
    &mcnlvx,
    &mcnlvy,
    &mcnlvz,
    &mcnlsx,
    &mcnlsy,
    &mcnlsz);
  /* define label inside component spec_detector_history_4 (without coords transformations) */
  mcJumpTrace_spec_detector_history_4:
  SIG_MESSAGE("spec_detector_history_4 (Trace)");
  mcDEBUG_COMP("spec_detector_history_4")
  mcDEBUG_STATE(
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp)
#define x mcnlx
#define y mcnly
#define z mcnlz
#define vx mcnlvx
#define vy mcnlvy
#define vz mcnlvz
#define t mcnlt
#define sx mcnlsx
#define sy mcnlsy
#define sz mcnlsz
#define p mcnlp

#define mcabsorbComp mcabsorbCompspec_detector_history_4
  STORE_NEUTRON(929,
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp);
  mcScattered=0;
  mcRestore=0;
  mcNCounter[929]++;
  mcPCounter[929] += p;
  mcP2Counter[929] += p*p;
#define mccompcurname  spec_detector_history_4
#define mccompcurtype  extend_monitor
#define mccompcurindex 929
#define nb mccspec_detector_history_4_nb
#define C_N mccspec_detector_history_4_C_N
#define C_p mccspec_detector_history_4_C_p
#define C_p2 mccspec_detector_history_4_C_p2
{   /* Declarations of spec_detector_history_4=extend_monitor() SETTING parameters. */
char* filename = mccspec_detector_history_4_filename;
MCNUM xmin = mccspec_detector_history_4_xmin;
MCNUM xmax = mccspec_detector_history_4_xmax;
MCNUM ymin = mccspec_detector_history_4_ymin;
MCNUM ymax = mccspec_detector_history_4_ymax;
MCNUM xwidth = mccspec_detector_history_4_xwidth;
MCNUM yheight = mccspec_detector_history_4_yheight;
MCNUM restore_neutron = mccspec_detector_history_4_restore_neutron;
/* 'spec_detector_history_4=extend_monitor()' component instance has conditional execution */
if (( detector_channel_spec == 4 && detector_found == 1 ))

#line 85 "extend_monitor.comp"
{
    int i;

    PROP_Z0;
    if (x>xmin && x<xmax && y>ymin && y<ymax)
    {
        C_N[0]++;
        C_p[0] += p;
        C_p2[0] += p*p;
        SCATTER;
    }
    if (restore_neutron) {
      RESTORE_NEUTRON(INDEX_CURRENT_COMP, x, y, z, vx, vy, vz, t, sx, sy, sz, p);
    }
}
#line 469755 "MACS_sample_kidney_box.c"
/* 'spec_detector_history_4=extend_monitor()' component instance extend code */
    SIG_MESSAGE("spec_detector_history_4 (Trace:Extend)");
if (( detector_channel_spec == 4 && detector_found == 1 )) {

#line 5666 "generated_includes/kidney_trace.c"
    if (SCATTERED) {
      flag_sum=0;
      for (flag_index=1;flag_index<MAX_VOLUME_HISTORY_LENGTH;flag_index++) {
        if (scattering_history_sample_master[flag_index] > 0) {
          C_N[flag_index+1]++;
          C_p[flag_index+1] += p;
          C_p2[flag_index+1] += p*p;
          flag_sum++;
          flag_single = flag_index;
        };
      };
      if (flag_sum == 0) {
        C_N[1]++;
        C_p[1] += p;
        C_p2[1] += p*p;
      };
      if (flag_sum == 1) {
        if (scattering_history_sample_master[flag_single] == 1) {
          C_N[MAX_VOLUME_HISTORY_LENGTH+flag_single+1]++;
          C_p[MAX_VOLUME_HISTORY_LENGTH+flag_single+1] += p;
          C_p2[MAX_VOLUME_HISTORY_LENGTH+flag_single+1] += p*p;
        };
      };
    };
#line 469784 "MACS_sample_kidney_box.c"
}

}   /* End of spec_detector_history_4=extend_monitor() SETTING parameter declarations. */
#undef C_p2
#undef C_p
#undef C_N
#undef nb
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex
  /* Label for restoring  neutron */
  mcabsorbCompspec_detector_history_4:
  if (RESTORE) /* restore if needed */
  { RESTORE_NEUTRON(929,
      mcnlx,
      mcnly,
      mcnlz,
      mcnlvx,
      mcnlvy,
      mcnlvz,
      mcnlt,
      mcnlsx,
      mcnlsy,
      mcnlsz,
      mcnlp); }
#undef mcabsorbComp
#undef p
#undef sz
#undef sy
#undef sx
#undef t
#undef vz
#undef vy
#undef vx
#undef z
#undef y
#undef x
  mcDEBUG_STATE(
mcnlx,
mcnly,
mcnlz,
mcnlvx,
mcnlvy,
mcnlvz,
mcnlt,
mcnlsx,
mcnlsy,
mcnlsz,
mcnlp)

  /* TRACE Component spec_detector_history_5 [930] */
  mccoordschange(mcposrspec_detector_history_5, mcrotrspec_detector_history_5,
    &mcnlx,
    &mcnly,
    &mcnlz,
    &mcnlvx,
    &mcnlvy,
    &mcnlvz,
    &mcnlsx,
    &mcnlsy,
    &mcnlsz);
  /* define label inside component spec_detector_history_5 (without coords transformations) */
  mcJumpTrace_spec_detector_history_5:
  SIG_MESSAGE("spec_detector_history_5 (Trace)");
  mcDEBUG_COMP("spec_detector_history_5")
  mcDEBUG_STATE(
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp)
#define x mcnlx
#define y mcnly
#define z mcnlz
#define vx mcnlvx
#define vy mcnlvy
#define vz mcnlvz
#define t mcnlt
#define sx mcnlsx
#define sy mcnlsy
#define sz mcnlsz
#define p mcnlp

#define mcabsorbComp mcabsorbCompspec_detector_history_5
  STORE_NEUTRON(930,
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp);
  mcScattered=0;
  mcRestore=0;
  mcNCounter[930]++;
  mcPCounter[930] += p;
  mcP2Counter[930] += p*p;
#define mccompcurname  spec_detector_history_5
#define mccompcurtype  extend_monitor
#define mccompcurindex 930
#define nb mccspec_detector_history_5_nb
#define C_N mccspec_detector_history_5_C_N
#define C_p mccspec_detector_history_5_C_p
#define C_p2 mccspec_detector_history_5_C_p2
{   /* Declarations of spec_detector_history_5=extend_monitor() SETTING parameters. */
char* filename = mccspec_detector_history_5_filename;
MCNUM xmin = mccspec_detector_history_5_xmin;
MCNUM xmax = mccspec_detector_history_5_xmax;
MCNUM ymin = mccspec_detector_history_5_ymin;
MCNUM ymax = mccspec_detector_history_5_ymax;
MCNUM xwidth = mccspec_detector_history_5_xwidth;
MCNUM yheight = mccspec_detector_history_5_yheight;
MCNUM restore_neutron = mccspec_detector_history_5_restore_neutron;
/* 'spec_detector_history_5=extend_monitor()' component instance has conditional execution */
if (( detector_channel_spec == 5 && detector_found == 1 ))

#line 85 "extend_monitor.comp"
{
    int i;

    PROP_Z0;
    if (x>xmin && x<xmax && y>ymin && y<ymax)
    {
        C_N[0]++;
        C_p[0] += p;
        C_p2[0] += p*p;
        SCATTER;
    }
    if (restore_neutron) {
      RESTORE_NEUTRON(INDEX_CURRENT_COMP, x, y, z, vx, vy, vz, t, sx, sy, sz, p);
    }
}
#line 469925 "MACS_sample_kidney_box.c"
/* 'spec_detector_history_5=extend_monitor()' component instance extend code */
    SIG_MESSAGE("spec_detector_history_5 (Trace:Extend)");
if (( detector_channel_spec == 5 && detector_found == 1 )) {

#line 5699 "generated_includes/kidney_trace.c"
    if (SCATTERED) {
      flag_sum=0;
      for (flag_index=1;flag_index<MAX_VOLUME_HISTORY_LENGTH;flag_index++) {
        if (scattering_history_sample_master[flag_index] > 0) {
          C_N[flag_index+1]++;
          C_p[flag_index+1] += p;
          C_p2[flag_index+1] += p*p;
          flag_sum++;
          flag_single = flag_index;
        };
      };
      if (flag_sum == 0) {
        C_N[1]++;
        C_p[1] += p;
        C_p2[1] += p*p;
      };
      if (flag_sum == 1) {
        if (scattering_history_sample_master[flag_single] == 1) {
          C_N[MAX_VOLUME_HISTORY_LENGTH+flag_single+1]++;
          C_p[MAX_VOLUME_HISTORY_LENGTH+flag_single+1] += p;
          C_p2[MAX_VOLUME_HISTORY_LENGTH+flag_single+1] += p*p;
        };
      };
    };
#line 469954 "MACS_sample_kidney_box.c"
}

}   /* End of spec_detector_history_5=extend_monitor() SETTING parameter declarations. */
#undef C_p2
#undef C_p
#undef C_N
#undef nb
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex
  /* Label for restoring  neutron */
  mcabsorbCompspec_detector_history_5:
  if (RESTORE) /* restore if needed */
  { RESTORE_NEUTRON(930,
      mcnlx,
      mcnly,
      mcnlz,
      mcnlvx,
      mcnlvy,
      mcnlvz,
      mcnlt,
      mcnlsx,
      mcnlsy,
      mcnlsz,
      mcnlp); }
#undef mcabsorbComp
#undef p
#undef sz
#undef sy
#undef sx
#undef t
#undef vz
#undef vy
#undef vx
#undef z
#undef y
#undef x
  mcDEBUG_STATE(
mcnlx,
mcnly,
mcnlz,
mcnlvx,
mcnlvy,
mcnlvz,
mcnlt,
mcnlsx,
mcnlsy,
mcnlsz,
mcnlp)

  /* TRACE Component spec_detector_history_6 [931] */
  mccoordschange(mcposrspec_detector_history_6, mcrotrspec_detector_history_6,
    &mcnlx,
    &mcnly,
    &mcnlz,
    &mcnlvx,
    &mcnlvy,
    &mcnlvz,
    &mcnlsx,
    &mcnlsy,
    &mcnlsz);
  /* define label inside component spec_detector_history_6 (without coords transformations) */
  mcJumpTrace_spec_detector_history_6:
  SIG_MESSAGE("spec_detector_history_6 (Trace)");
  mcDEBUG_COMP("spec_detector_history_6")
  mcDEBUG_STATE(
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp)
#define x mcnlx
#define y mcnly
#define z mcnlz
#define vx mcnlvx
#define vy mcnlvy
#define vz mcnlvz
#define t mcnlt
#define sx mcnlsx
#define sy mcnlsy
#define sz mcnlsz
#define p mcnlp

#define mcabsorbComp mcabsorbCompspec_detector_history_6
  STORE_NEUTRON(931,
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp);
  mcScattered=0;
  mcRestore=0;
  mcNCounter[931]++;
  mcPCounter[931] += p;
  mcP2Counter[931] += p*p;
#define mccompcurname  spec_detector_history_6
#define mccompcurtype  extend_monitor
#define mccompcurindex 931
#define nb mccspec_detector_history_6_nb
#define C_N mccspec_detector_history_6_C_N
#define C_p mccspec_detector_history_6_C_p
#define C_p2 mccspec_detector_history_6_C_p2
{   /* Declarations of spec_detector_history_6=extend_monitor() SETTING parameters. */
char* filename = mccspec_detector_history_6_filename;
MCNUM xmin = mccspec_detector_history_6_xmin;
MCNUM xmax = mccspec_detector_history_6_xmax;
MCNUM ymin = mccspec_detector_history_6_ymin;
MCNUM ymax = mccspec_detector_history_6_ymax;
MCNUM xwidth = mccspec_detector_history_6_xwidth;
MCNUM yheight = mccspec_detector_history_6_yheight;
MCNUM restore_neutron = mccspec_detector_history_6_restore_neutron;
/* 'spec_detector_history_6=extend_monitor()' component instance has conditional execution */
if (( detector_channel_spec == 6 && detector_found == 1 ))

#line 85 "extend_monitor.comp"
{
    int i;

    PROP_Z0;
    if (x>xmin && x<xmax && y>ymin && y<ymax)
    {
        C_N[0]++;
        C_p[0] += p;
        C_p2[0] += p*p;
        SCATTER;
    }
    if (restore_neutron) {
      RESTORE_NEUTRON(INDEX_CURRENT_COMP, x, y, z, vx, vy, vz, t, sx, sy, sz, p);
    }
}
#line 470095 "MACS_sample_kidney_box.c"
/* 'spec_detector_history_6=extend_monitor()' component instance extend code */
    SIG_MESSAGE("spec_detector_history_6 (Trace:Extend)");
if (( detector_channel_spec == 6 && detector_found == 1 )) {

#line 5732 "generated_includes/kidney_trace.c"
    if (SCATTERED) {
      flag_sum=0;
      for (flag_index=1;flag_index<MAX_VOLUME_HISTORY_LENGTH;flag_index++) {
        if (scattering_history_sample_master[flag_index] > 0) {
          C_N[flag_index+1]++;
          C_p[flag_index+1] += p;
          C_p2[flag_index+1] += p*p;
          flag_sum++;
          flag_single = flag_index;
        };
      };
      if (flag_sum == 0) {
        C_N[1]++;
        C_p[1] += p;
        C_p2[1] += p*p;
      };
      if (flag_sum == 1) {
        if (scattering_history_sample_master[flag_single] == 1) {
          C_N[MAX_VOLUME_HISTORY_LENGTH+flag_single+1]++;
          C_p[MAX_VOLUME_HISTORY_LENGTH+flag_single+1] += p;
          C_p2[MAX_VOLUME_HISTORY_LENGTH+flag_single+1] += p*p;
        };
      };
    };
#line 470124 "MACS_sample_kidney_box.c"
}

}   /* End of spec_detector_history_6=extend_monitor() SETTING parameter declarations. */
#undef C_p2
#undef C_p
#undef C_N
#undef nb
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex
  /* Label for restoring  neutron */
  mcabsorbCompspec_detector_history_6:
  if (RESTORE) /* restore if needed */
  { RESTORE_NEUTRON(931,
      mcnlx,
      mcnly,
      mcnlz,
      mcnlvx,
      mcnlvy,
      mcnlvz,
      mcnlt,
      mcnlsx,
      mcnlsy,
      mcnlsz,
      mcnlp); }
#undef mcabsorbComp
#undef p
#undef sz
#undef sy
#undef sx
#undef t
#undef vz
#undef vy
#undef vx
#undef z
#undef y
#undef x
  mcDEBUG_STATE(
mcnlx,
mcnly,
mcnlz,
mcnlvx,
mcnlvy,
mcnlvz,
mcnlt,
mcnlsx,
mcnlsy,
mcnlsz,
mcnlp)

  /* TRACE Component spec_detector_history_7 [932] */
  mccoordschange(mcposrspec_detector_history_7, mcrotrspec_detector_history_7,
    &mcnlx,
    &mcnly,
    &mcnlz,
    &mcnlvx,
    &mcnlvy,
    &mcnlvz,
    &mcnlsx,
    &mcnlsy,
    &mcnlsz);
  /* define label inside component spec_detector_history_7 (without coords transformations) */
  mcJumpTrace_spec_detector_history_7:
  SIG_MESSAGE("spec_detector_history_7 (Trace)");
  mcDEBUG_COMP("spec_detector_history_7")
  mcDEBUG_STATE(
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp)
#define x mcnlx
#define y mcnly
#define z mcnlz
#define vx mcnlvx
#define vy mcnlvy
#define vz mcnlvz
#define t mcnlt
#define sx mcnlsx
#define sy mcnlsy
#define sz mcnlsz
#define p mcnlp

#define mcabsorbComp mcabsorbCompspec_detector_history_7
  STORE_NEUTRON(932,
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp);
  mcScattered=0;
  mcRestore=0;
  mcNCounter[932]++;
  mcPCounter[932] += p;
  mcP2Counter[932] += p*p;
#define mccompcurname  spec_detector_history_7
#define mccompcurtype  extend_monitor
#define mccompcurindex 932
#define nb mccspec_detector_history_7_nb
#define C_N mccspec_detector_history_7_C_N
#define C_p mccspec_detector_history_7_C_p
#define C_p2 mccspec_detector_history_7_C_p2
{   /* Declarations of spec_detector_history_7=extend_monitor() SETTING parameters. */
char* filename = mccspec_detector_history_7_filename;
MCNUM xmin = mccspec_detector_history_7_xmin;
MCNUM xmax = mccspec_detector_history_7_xmax;
MCNUM ymin = mccspec_detector_history_7_ymin;
MCNUM ymax = mccspec_detector_history_7_ymax;
MCNUM xwidth = mccspec_detector_history_7_xwidth;
MCNUM yheight = mccspec_detector_history_7_yheight;
MCNUM restore_neutron = mccspec_detector_history_7_restore_neutron;
/* 'spec_detector_history_7=extend_monitor()' component instance has conditional execution */
if (( detector_channel_spec == 7 && detector_found == 1 ))

#line 85 "extend_monitor.comp"
{
    int i;

    PROP_Z0;
    if (x>xmin && x<xmax && y>ymin && y<ymax)
    {
        C_N[0]++;
        C_p[0] += p;
        C_p2[0] += p*p;
        SCATTER;
    }
    if (restore_neutron) {
      RESTORE_NEUTRON(INDEX_CURRENT_COMP, x, y, z, vx, vy, vz, t, sx, sy, sz, p);
    }
}
#line 470265 "MACS_sample_kidney_box.c"
/* 'spec_detector_history_7=extend_monitor()' component instance extend code */
    SIG_MESSAGE("spec_detector_history_7 (Trace:Extend)");
if (( detector_channel_spec == 7 && detector_found == 1 )) {

#line 5765 "generated_includes/kidney_trace.c"
    if (SCATTERED) {
      flag_sum=0;
      for (flag_index=1;flag_index<MAX_VOLUME_HISTORY_LENGTH;flag_index++) {
        if (scattering_history_sample_master[flag_index] > 0) {
          C_N[flag_index+1]++;
          C_p[flag_index+1] += p;
          C_p2[flag_index+1] += p*p;
          flag_sum++;
          flag_single = flag_index;
        };
      };
      if (flag_sum == 0) {
        C_N[1]++;
        C_p[1] += p;
        C_p2[1] += p*p;
      };
      if (flag_sum == 1) {
        if (scattering_history_sample_master[flag_single] == 1) {
          C_N[MAX_VOLUME_HISTORY_LENGTH+flag_single+1]++;
          C_p[MAX_VOLUME_HISTORY_LENGTH+flag_single+1] += p;
          C_p2[MAX_VOLUME_HISTORY_LENGTH+flag_single+1] += p*p;
        };
      };
    };
#line 470294 "MACS_sample_kidney_box.c"
}

}   /* End of spec_detector_history_7=extend_monitor() SETTING parameter declarations. */
#undef C_p2
#undef C_p
#undef C_N
#undef nb
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex
  /* Label for restoring  neutron */
  mcabsorbCompspec_detector_history_7:
  if (RESTORE) /* restore if needed */
  { RESTORE_NEUTRON(932,
      mcnlx,
      mcnly,
      mcnlz,
      mcnlvx,
      mcnlvy,
      mcnlvz,
      mcnlt,
      mcnlsx,
      mcnlsy,
      mcnlsz,
      mcnlp); }
#undef mcabsorbComp
#undef p
#undef sz
#undef sy
#undef sx
#undef t
#undef vz
#undef vy
#undef vx
#undef z
#undef y
#undef x
  mcDEBUG_STATE(
mcnlx,
mcnly,
mcnlz,
mcnlvx,
mcnlvy,
mcnlvz,
mcnlt,
mcnlsx,
mcnlsy,
mcnlsz,
mcnlp)

  /* TRACE Component spec_detector_history_8 [933] */
  mccoordschange(mcposrspec_detector_history_8, mcrotrspec_detector_history_8,
    &mcnlx,
    &mcnly,
    &mcnlz,
    &mcnlvx,
    &mcnlvy,
    &mcnlvz,
    &mcnlsx,
    &mcnlsy,
    &mcnlsz);
  /* define label inside component spec_detector_history_8 (without coords transformations) */
  mcJumpTrace_spec_detector_history_8:
  SIG_MESSAGE("spec_detector_history_8 (Trace)");
  mcDEBUG_COMP("spec_detector_history_8")
  mcDEBUG_STATE(
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp)
#define x mcnlx
#define y mcnly
#define z mcnlz
#define vx mcnlvx
#define vy mcnlvy
#define vz mcnlvz
#define t mcnlt
#define sx mcnlsx
#define sy mcnlsy
#define sz mcnlsz
#define p mcnlp

#define mcabsorbComp mcabsorbCompspec_detector_history_8
  STORE_NEUTRON(933,
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp);
  mcScattered=0;
  mcRestore=0;
  mcNCounter[933]++;
  mcPCounter[933] += p;
  mcP2Counter[933] += p*p;
#define mccompcurname  spec_detector_history_8
#define mccompcurtype  extend_monitor
#define mccompcurindex 933
#define nb mccspec_detector_history_8_nb
#define C_N mccspec_detector_history_8_C_N
#define C_p mccspec_detector_history_8_C_p
#define C_p2 mccspec_detector_history_8_C_p2
{   /* Declarations of spec_detector_history_8=extend_monitor() SETTING parameters. */
char* filename = mccspec_detector_history_8_filename;
MCNUM xmin = mccspec_detector_history_8_xmin;
MCNUM xmax = mccspec_detector_history_8_xmax;
MCNUM ymin = mccspec_detector_history_8_ymin;
MCNUM ymax = mccspec_detector_history_8_ymax;
MCNUM xwidth = mccspec_detector_history_8_xwidth;
MCNUM yheight = mccspec_detector_history_8_yheight;
MCNUM restore_neutron = mccspec_detector_history_8_restore_neutron;
/* 'spec_detector_history_8=extend_monitor()' component instance has conditional execution */
if (( detector_channel_spec == 8 && detector_found == 1 ))

#line 85 "extend_monitor.comp"
{
    int i;

    PROP_Z0;
    if (x>xmin && x<xmax && y>ymin && y<ymax)
    {
        C_N[0]++;
        C_p[0] += p;
        C_p2[0] += p*p;
        SCATTER;
    }
    if (restore_neutron) {
      RESTORE_NEUTRON(INDEX_CURRENT_COMP, x, y, z, vx, vy, vz, t, sx, sy, sz, p);
    }
}
#line 470435 "MACS_sample_kidney_box.c"
/* 'spec_detector_history_8=extend_monitor()' component instance extend code */
    SIG_MESSAGE("spec_detector_history_8 (Trace:Extend)");
if (( detector_channel_spec == 8 && detector_found == 1 )) {

#line 5798 "generated_includes/kidney_trace.c"
    if (SCATTERED) {
      flag_sum=0;
      for (flag_index=1;flag_index<MAX_VOLUME_HISTORY_LENGTH;flag_index++) {
        if (scattering_history_sample_master[flag_index] > 0) {
          C_N[flag_index+1]++;
          C_p[flag_index+1] += p;
          C_p2[flag_index+1] += p*p;
          flag_sum++;
          flag_single = flag_index;
        };
      };
      if (flag_sum == 0) {
        C_N[1]++;
        C_p[1] += p;
        C_p2[1] += p*p;
      };
      if (flag_sum == 1) {
        if (scattering_history_sample_master[flag_single] == 1) {
          C_N[MAX_VOLUME_HISTORY_LENGTH+flag_single+1]++;
          C_p[MAX_VOLUME_HISTORY_LENGTH+flag_single+1] += p;
          C_p2[MAX_VOLUME_HISTORY_LENGTH+flag_single+1] += p*p;
        };
      };
    };
#line 470464 "MACS_sample_kidney_box.c"
}

}   /* End of spec_detector_history_8=extend_monitor() SETTING parameter declarations. */
#undef C_p2
#undef C_p
#undef C_N
#undef nb
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex
  /* Label for restoring  neutron */
  mcabsorbCompspec_detector_history_8:
  if (RESTORE) /* restore if needed */
  { RESTORE_NEUTRON(933,
      mcnlx,
      mcnly,
      mcnlz,
      mcnlvx,
      mcnlvy,
      mcnlvz,
      mcnlt,
      mcnlsx,
      mcnlsy,
      mcnlsz,
      mcnlp); }
#undef mcabsorbComp
#undef p
#undef sz
#undef sy
#undef sx
#undef t
#undef vz
#undef vy
#undef vx
#undef z
#undef y
#undef x
  mcDEBUG_STATE(
mcnlx,
mcnly,
mcnlz,
mcnlvx,
mcnlvy,
mcnlvz,
mcnlt,
mcnlsx,
mcnlsy,
mcnlsz,
mcnlp)

  /* TRACE Component spec_detector_history_9 [934] */
  mccoordschange(mcposrspec_detector_history_9, mcrotrspec_detector_history_9,
    &mcnlx,
    &mcnly,
    &mcnlz,
    &mcnlvx,
    &mcnlvy,
    &mcnlvz,
    &mcnlsx,
    &mcnlsy,
    &mcnlsz);
  /* define label inside component spec_detector_history_9 (without coords transformations) */
  mcJumpTrace_spec_detector_history_9:
  SIG_MESSAGE("spec_detector_history_9 (Trace)");
  mcDEBUG_COMP("spec_detector_history_9")
  mcDEBUG_STATE(
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp)
#define x mcnlx
#define y mcnly
#define z mcnlz
#define vx mcnlvx
#define vy mcnlvy
#define vz mcnlvz
#define t mcnlt
#define sx mcnlsx
#define sy mcnlsy
#define sz mcnlsz
#define p mcnlp

#define mcabsorbComp mcabsorbCompspec_detector_history_9
  STORE_NEUTRON(934,
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp);
  mcScattered=0;
  mcRestore=0;
  mcNCounter[934]++;
  mcPCounter[934] += p;
  mcP2Counter[934] += p*p;
#define mccompcurname  spec_detector_history_9
#define mccompcurtype  extend_monitor
#define mccompcurindex 934
#define nb mccspec_detector_history_9_nb
#define C_N mccspec_detector_history_9_C_N
#define C_p mccspec_detector_history_9_C_p
#define C_p2 mccspec_detector_history_9_C_p2
{   /* Declarations of spec_detector_history_9=extend_monitor() SETTING parameters. */
char* filename = mccspec_detector_history_9_filename;
MCNUM xmin = mccspec_detector_history_9_xmin;
MCNUM xmax = mccspec_detector_history_9_xmax;
MCNUM ymin = mccspec_detector_history_9_ymin;
MCNUM ymax = mccspec_detector_history_9_ymax;
MCNUM xwidth = mccspec_detector_history_9_xwidth;
MCNUM yheight = mccspec_detector_history_9_yheight;
MCNUM restore_neutron = mccspec_detector_history_9_restore_neutron;
/* 'spec_detector_history_9=extend_monitor()' component instance has conditional execution */
if (( detector_channel_spec == 9 && detector_found == 1 ))

#line 85 "extend_monitor.comp"
{
    int i;

    PROP_Z0;
    if (x>xmin && x<xmax && y>ymin && y<ymax)
    {
        C_N[0]++;
        C_p[0] += p;
        C_p2[0] += p*p;
        SCATTER;
    }
    if (restore_neutron) {
      RESTORE_NEUTRON(INDEX_CURRENT_COMP, x, y, z, vx, vy, vz, t, sx, sy, sz, p);
    }
}
#line 470605 "MACS_sample_kidney_box.c"
/* 'spec_detector_history_9=extend_monitor()' component instance extend code */
    SIG_MESSAGE("spec_detector_history_9 (Trace:Extend)");
if (( detector_channel_spec == 9 && detector_found == 1 )) {

#line 5831 "generated_includes/kidney_trace.c"
    if (SCATTERED) {
      flag_sum=0;
      for (flag_index=1;flag_index<MAX_VOLUME_HISTORY_LENGTH;flag_index++) {
        if (scattering_history_sample_master[flag_index] > 0) {
          C_N[flag_index+1]++;
          C_p[flag_index+1] += p;
          C_p2[flag_index+1] += p*p;
          flag_sum++;
          flag_single = flag_index;
        };
      };
      if (flag_sum == 0) {
        C_N[1]++;
        C_p[1] += p;
        C_p2[1] += p*p;
      };
      if (flag_sum == 1) {
        if (scattering_history_sample_master[flag_single] == 1) {
          C_N[MAX_VOLUME_HISTORY_LENGTH+flag_single+1]++;
          C_p[MAX_VOLUME_HISTORY_LENGTH+flag_single+1] += p;
          C_p2[MAX_VOLUME_HISTORY_LENGTH+flag_single+1] += p*p;
        };
      };
    };
#line 470634 "MACS_sample_kidney_box.c"
}

}   /* End of spec_detector_history_9=extend_monitor() SETTING parameter declarations. */
#undef C_p2
#undef C_p
#undef C_N
#undef nb
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex
  /* Label for restoring  neutron */
  mcabsorbCompspec_detector_history_9:
  if (RESTORE) /* restore if needed */
  { RESTORE_NEUTRON(934,
      mcnlx,
      mcnly,
      mcnlz,
      mcnlvx,
      mcnlvy,
      mcnlvz,
      mcnlt,
      mcnlsx,
      mcnlsy,
      mcnlsz,
      mcnlp); }
#undef mcabsorbComp
#undef p
#undef sz
#undef sy
#undef sx
#undef t
#undef vz
#undef vy
#undef vx
#undef z
#undef y
#undef x
  mcDEBUG_STATE(
mcnlx,
mcnly,
mcnlz,
mcnlvx,
mcnlvy,
mcnlvz,
mcnlt,
mcnlsx,
mcnlsy,
mcnlsz,
mcnlp)

  /* TRACE Component spec_detector_history_10 [935] */
  mccoordschange(mcposrspec_detector_history_10, mcrotrspec_detector_history_10,
    &mcnlx,
    &mcnly,
    &mcnlz,
    &mcnlvx,
    &mcnlvy,
    &mcnlvz,
    &mcnlsx,
    &mcnlsy,
    &mcnlsz);
  /* define label inside component spec_detector_history_10 (without coords transformations) */
  mcJumpTrace_spec_detector_history_10:
  SIG_MESSAGE("spec_detector_history_10 (Trace)");
  mcDEBUG_COMP("spec_detector_history_10")
  mcDEBUG_STATE(
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp)
#define x mcnlx
#define y mcnly
#define z mcnlz
#define vx mcnlvx
#define vy mcnlvy
#define vz mcnlvz
#define t mcnlt
#define sx mcnlsx
#define sy mcnlsy
#define sz mcnlsz
#define p mcnlp

#define mcabsorbComp mcabsorbCompspec_detector_history_10
  STORE_NEUTRON(935,
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp);
  mcScattered=0;
  mcRestore=0;
  mcNCounter[935]++;
  mcPCounter[935] += p;
  mcP2Counter[935] += p*p;
#define mccompcurname  spec_detector_history_10
#define mccompcurtype  extend_monitor
#define mccompcurindex 935
#define nb mccspec_detector_history_10_nb
#define C_N mccspec_detector_history_10_C_N
#define C_p mccspec_detector_history_10_C_p
#define C_p2 mccspec_detector_history_10_C_p2
{   /* Declarations of spec_detector_history_10=extend_monitor() SETTING parameters. */
char* filename = mccspec_detector_history_10_filename;
MCNUM xmin = mccspec_detector_history_10_xmin;
MCNUM xmax = mccspec_detector_history_10_xmax;
MCNUM ymin = mccspec_detector_history_10_ymin;
MCNUM ymax = mccspec_detector_history_10_ymax;
MCNUM xwidth = mccspec_detector_history_10_xwidth;
MCNUM yheight = mccspec_detector_history_10_yheight;
MCNUM restore_neutron = mccspec_detector_history_10_restore_neutron;
/* 'spec_detector_history_10=extend_monitor()' component instance has conditional execution */
if (( detector_channel_spec == 10 && detector_found == 1 ))

#line 85 "extend_monitor.comp"
{
    int i;

    PROP_Z0;
    if (x>xmin && x<xmax && y>ymin && y<ymax)
    {
        C_N[0]++;
        C_p[0] += p;
        C_p2[0] += p*p;
        SCATTER;
    }
    if (restore_neutron) {
      RESTORE_NEUTRON(INDEX_CURRENT_COMP, x, y, z, vx, vy, vz, t, sx, sy, sz, p);
    }
}
#line 470775 "MACS_sample_kidney_box.c"
/* 'spec_detector_history_10=extend_monitor()' component instance extend code */
    SIG_MESSAGE("spec_detector_history_10 (Trace:Extend)");
if (( detector_channel_spec == 10 && detector_found == 1 )) {

#line 5864 "generated_includes/kidney_trace.c"
    if (SCATTERED) {
      flag_sum=0;
      for (flag_index=1;flag_index<MAX_VOLUME_HISTORY_LENGTH;flag_index++) {
        if (scattering_history_sample_master[flag_index] > 0) {
          C_N[flag_index+1]++;
          C_p[flag_index+1] += p;
          C_p2[flag_index+1] += p*p;
          flag_sum++;
          flag_single = flag_index;
        };
      };
      if (flag_sum == 0) {
        C_N[1]++;
        C_p[1] += p;
        C_p2[1] += p*p;
      };
      if (flag_sum == 1) {
        if (scattering_history_sample_master[flag_single] == 1) {
          C_N[MAX_VOLUME_HISTORY_LENGTH+flag_single+1]++;
          C_p[MAX_VOLUME_HISTORY_LENGTH+flag_single+1] += p;
          C_p2[MAX_VOLUME_HISTORY_LENGTH+flag_single+1] += p*p;
        };
      };
    };
#line 470804 "MACS_sample_kidney_box.c"
}

}   /* End of spec_detector_history_10=extend_monitor() SETTING parameter declarations. */
#undef C_p2
#undef C_p
#undef C_N
#undef nb
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex
  /* Label for restoring  neutron */
  mcabsorbCompspec_detector_history_10:
  if (RESTORE) /* restore if needed */
  { RESTORE_NEUTRON(935,
      mcnlx,
      mcnly,
      mcnlz,
      mcnlvx,
      mcnlvy,
      mcnlvz,
      mcnlt,
      mcnlsx,
      mcnlsy,
      mcnlsz,
      mcnlp); }
#undef mcabsorbComp
#undef p
#undef sz
#undef sy
#undef sx
#undef t
#undef vz
#undef vy
#undef vx
#undef z
#undef y
#undef x
  mcDEBUG_STATE(
mcnlx,
mcnly,
mcnlz,
mcnlvx,
mcnlvy,
mcnlvz,
mcnlt,
mcnlsx,
mcnlsy,
mcnlsz,
mcnlp)

  /* TRACE Component spec_detector_history_11 [936] */
  mccoordschange(mcposrspec_detector_history_11, mcrotrspec_detector_history_11,
    &mcnlx,
    &mcnly,
    &mcnlz,
    &mcnlvx,
    &mcnlvy,
    &mcnlvz,
    &mcnlsx,
    &mcnlsy,
    &mcnlsz);
  /* define label inside component spec_detector_history_11 (without coords transformations) */
  mcJumpTrace_spec_detector_history_11:
  SIG_MESSAGE("spec_detector_history_11 (Trace)");
  mcDEBUG_COMP("spec_detector_history_11")
  mcDEBUG_STATE(
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp)
#define x mcnlx
#define y mcnly
#define z mcnlz
#define vx mcnlvx
#define vy mcnlvy
#define vz mcnlvz
#define t mcnlt
#define sx mcnlsx
#define sy mcnlsy
#define sz mcnlsz
#define p mcnlp

#define mcabsorbComp mcabsorbCompspec_detector_history_11
  STORE_NEUTRON(936,
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp);
  mcScattered=0;
  mcRestore=0;
  mcNCounter[936]++;
  mcPCounter[936] += p;
  mcP2Counter[936] += p*p;
#define mccompcurname  spec_detector_history_11
#define mccompcurtype  extend_monitor
#define mccompcurindex 936
#define nb mccspec_detector_history_11_nb
#define C_N mccspec_detector_history_11_C_N
#define C_p mccspec_detector_history_11_C_p
#define C_p2 mccspec_detector_history_11_C_p2
{   /* Declarations of spec_detector_history_11=extend_monitor() SETTING parameters. */
char* filename = mccspec_detector_history_11_filename;
MCNUM xmin = mccspec_detector_history_11_xmin;
MCNUM xmax = mccspec_detector_history_11_xmax;
MCNUM ymin = mccspec_detector_history_11_ymin;
MCNUM ymax = mccspec_detector_history_11_ymax;
MCNUM xwidth = mccspec_detector_history_11_xwidth;
MCNUM yheight = mccspec_detector_history_11_yheight;
MCNUM restore_neutron = mccspec_detector_history_11_restore_neutron;
/* 'spec_detector_history_11=extend_monitor()' component instance has conditional execution */
if (( detector_channel_spec == 11 && detector_found == 1 ))

#line 85 "extend_monitor.comp"
{
    int i;

    PROP_Z0;
    if (x>xmin && x<xmax && y>ymin && y<ymax)
    {
        C_N[0]++;
        C_p[0] += p;
        C_p2[0] += p*p;
        SCATTER;
    }
    if (restore_neutron) {
      RESTORE_NEUTRON(INDEX_CURRENT_COMP, x, y, z, vx, vy, vz, t, sx, sy, sz, p);
    }
}
#line 470945 "MACS_sample_kidney_box.c"
/* 'spec_detector_history_11=extend_monitor()' component instance extend code */
    SIG_MESSAGE("spec_detector_history_11 (Trace:Extend)");
if (( detector_channel_spec == 11 && detector_found == 1 )) {

#line 5897 "generated_includes/kidney_trace.c"
    if (SCATTERED) {
      flag_sum=0;
      for (flag_index=1;flag_index<MAX_VOLUME_HISTORY_LENGTH;flag_index++) {
        if (scattering_history_sample_master[flag_index] > 0) {
          C_N[flag_index+1]++;
          C_p[flag_index+1] += p;
          C_p2[flag_index+1] += p*p;
          flag_sum++;
          flag_single = flag_index;
        };
      };
      if (flag_sum == 0) {
        C_N[1]++;
        C_p[1] += p;
        C_p2[1] += p*p;
      };
      if (flag_sum == 1) {
        if (scattering_history_sample_master[flag_single] == 1) {
          C_N[MAX_VOLUME_HISTORY_LENGTH+flag_single+1]++;
          C_p[MAX_VOLUME_HISTORY_LENGTH+flag_single+1] += p;
          C_p2[MAX_VOLUME_HISTORY_LENGTH+flag_single+1] += p*p;
        };
      };
    };
#line 470974 "MACS_sample_kidney_box.c"
}

}   /* End of spec_detector_history_11=extend_monitor() SETTING parameter declarations. */
#undef C_p2
#undef C_p
#undef C_N
#undef nb
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex
  /* Label for restoring  neutron */
  mcabsorbCompspec_detector_history_11:
  if (RESTORE) /* restore if needed */
  { RESTORE_NEUTRON(936,
      mcnlx,
      mcnly,
      mcnlz,
      mcnlvx,
      mcnlvy,
      mcnlvz,
      mcnlt,
      mcnlsx,
      mcnlsy,
      mcnlsz,
      mcnlp); }
#undef mcabsorbComp
#undef p
#undef sz
#undef sy
#undef sx
#undef t
#undef vz
#undef vy
#undef vx
#undef z
#undef y
#undef x
  mcDEBUG_STATE(
mcnlx,
mcnly,
mcnlz,
mcnlvx,
mcnlvy,
mcnlvz,
mcnlt,
mcnlsx,
mcnlsy,
mcnlsz,
mcnlp)

  /* TRACE Component spec_detector_history_12 [937] */
  mccoordschange(mcposrspec_detector_history_12, mcrotrspec_detector_history_12,
    &mcnlx,
    &mcnly,
    &mcnlz,
    &mcnlvx,
    &mcnlvy,
    &mcnlvz,
    &mcnlsx,
    &mcnlsy,
    &mcnlsz);
  /* define label inside component spec_detector_history_12 (without coords transformations) */
  mcJumpTrace_spec_detector_history_12:
  SIG_MESSAGE("spec_detector_history_12 (Trace)");
  mcDEBUG_COMP("spec_detector_history_12")
  mcDEBUG_STATE(
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp)
#define x mcnlx
#define y mcnly
#define z mcnlz
#define vx mcnlvx
#define vy mcnlvy
#define vz mcnlvz
#define t mcnlt
#define sx mcnlsx
#define sy mcnlsy
#define sz mcnlsz
#define p mcnlp

#define mcabsorbComp mcabsorbCompspec_detector_history_12
  STORE_NEUTRON(937,
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp);
  mcScattered=0;
  mcRestore=0;
  mcNCounter[937]++;
  mcPCounter[937] += p;
  mcP2Counter[937] += p*p;
#define mccompcurname  spec_detector_history_12
#define mccompcurtype  extend_monitor
#define mccompcurindex 937
#define nb mccspec_detector_history_12_nb
#define C_N mccspec_detector_history_12_C_N
#define C_p mccspec_detector_history_12_C_p
#define C_p2 mccspec_detector_history_12_C_p2
{   /* Declarations of spec_detector_history_12=extend_monitor() SETTING parameters. */
char* filename = mccspec_detector_history_12_filename;
MCNUM xmin = mccspec_detector_history_12_xmin;
MCNUM xmax = mccspec_detector_history_12_xmax;
MCNUM ymin = mccspec_detector_history_12_ymin;
MCNUM ymax = mccspec_detector_history_12_ymax;
MCNUM xwidth = mccspec_detector_history_12_xwidth;
MCNUM yheight = mccspec_detector_history_12_yheight;
MCNUM restore_neutron = mccspec_detector_history_12_restore_neutron;
/* 'spec_detector_history_12=extend_monitor()' component instance has conditional execution */
if (( detector_channel_spec == 12 && detector_found == 1 ))

#line 85 "extend_monitor.comp"
{
    int i;

    PROP_Z0;
    if (x>xmin && x<xmax && y>ymin && y<ymax)
    {
        C_N[0]++;
        C_p[0] += p;
        C_p2[0] += p*p;
        SCATTER;
    }
    if (restore_neutron) {
      RESTORE_NEUTRON(INDEX_CURRENT_COMP, x, y, z, vx, vy, vz, t, sx, sy, sz, p);
    }
}
#line 471115 "MACS_sample_kidney_box.c"
/* 'spec_detector_history_12=extend_monitor()' component instance extend code */
    SIG_MESSAGE("spec_detector_history_12 (Trace:Extend)");
if (( detector_channel_spec == 12 && detector_found == 1 )) {

#line 5930 "generated_includes/kidney_trace.c"
    if (SCATTERED) {
      flag_sum=0;
      for (flag_index=1;flag_index<MAX_VOLUME_HISTORY_LENGTH;flag_index++) {
        if (scattering_history_sample_master[flag_index] > 0) {
          C_N[flag_index+1]++;
          C_p[flag_index+1] += p;
          C_p2[flag_index+1] += p*p;
          flag_sum++;
          flag_single = flag_index;
        };
      };
      if (flag_sum == 0) {
        C_N[1]++;
        C_p[1] += p;
        C_p2[1] += p*p;
      };
      if (flag_sum == 1) {
        if (scattering_history_sample_master[flag_single] == 1) {
          C_N[MAX_VOLUME_HISTORY_LENGTH+flag_single+1]++;
          C_p[MAX_VOLUME_HISTORY_LENGTH+flag_single+1] += p;
          C_p2[MAX_VOLUME_HISTORY_LENGTH+flag_single+1] += p*p;
        };
      };
    };
#line 471144 "MACS_sample_kidney_box.c"
}

}   /* End of spec_detector_history_12=extend_monitor() SETTING parameter declarations. */
#undef C_p2
#undef C_p
#undef C_N
#undef nb
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex
  /* Label for restoring  neutron */
  mcabsorbCompspec_detector_history_12:
  if (RESTORE) /* restore if needed */
  { RESTORE_NEUTRON(937,
      mcnlx,
      mcnly,
      mcnlz,
      mcnlvx,
      mcnlvy,
      mcnlvz,
      mcnlt,
      mcnlsx,
      mcnlsy,
      mcnlsz,
      mcnlp); }
#undef mcabsorbComp
#undef p
#undef sz
#undef sy
#undef sx
#undef t
#undef vz
#undef vy
#undef vx
#undef z
#undef y
#undef x
  mcDEBUG_STATE(
mcnlx,
mcnly,
mcnlz,
mcnlvx,
mcnlvy,
mcnlvz,
mcnlt,
mcnlsx,
mcnlsy,
mcnlsz,
mcnlp)

  /* TRACE Component spec_detector_history_13 [938] */
  mccoordschange(mcposrspec_detector_history_13, mcrotrspec_detector_history_13,
    &mcnlx,
    &mcnly,
    &mcnlz,
    &mcnlvx,
    &mcnlvy,
    &mcnlvz,
    &mcnlsx,
    &mcnlsy,
    &mcnlsz);
  /* define label inside component spec_detector_history_13 (without coords transformations) */
  mcJumpTrace_spec_detector_history_13:
  SIG_MESSAGE("spec_detector_history_13 (Trace)");
  mcDEBUG_COMP("spec_detector_history_13")
  mcDEBUG_STATE(
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp)
#define x mcnlx
#define y mcnly
#define z mcnlz
#define vx mcnlvx
#define vy mcnlvy
#define vz mcnlvz
#define t mcnlt
#define sx mcnlsx
#define sy mcnlsy
#define sz mcnlsz
#define p mcnlp

#define mcabsorbComp mcabsorbCompspec_detector_history_13
  STORE_NEUTRON(938,
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp);
  mcScattered=0;
  mcRestore=0;
  mcNCounter[938]++;
  mcPCounter[938] += p;
  mcP2Counter[938] += p*p;
#define mccompcurname  spec_detector_history_13
#define mccompcurtype  extend_monitor
#define mccompcurindex 938
#define nb mccspec_detector_history_13_nb
#define C_N mccspec_detector_history_13_C_N
#define C_p mccspec_detector_history_13_C_p
#define C_p2 mccspec_detector_history_13_C_p2
{   /* Declarations of spec_detector_history_13=extend_monitor() SETTING parameters. */
char* filename = mccspec_detector_history_13_filename;
MCNUM xmin = mccspec_detector_history_13_xmin;
MCNUM xmax = mccspec_detector_history_13_xmax;
MCNUM ymin = mccspec_detector_history_13_ymin;
MCNUM ymax = mccspec_detector_history_13_ymax;
MCNUM xwidth = mccspec_detector_history_13_xwidth;
MCNUM yheight = mccspec_detector_history_13_yheight;
MCNUM restore_neutron = mccspec_detector_history_13_restore_neutron;
/* 'spec_detector_history_13=extend_monitor()' component instance has conditional execution */
if (( detector_channel_spec == 13 && detector_found == 1 ))

#line 85 "extend_monitor.comp"
{
    int i;

    PROP_Z0;
    if (x>xmin && x<xmax && y>ymin && y<ymax)
    {
        C_N[0]++;
        C_p[0] += p;
        C_p2[0] += p*p;
        SCATTER;
    }
    if (restore_neutron) {
      RESTORE_NEUTRON(INDEX_CURRENT_COMP, x, y, z, vx, vy, vz, t, sx, sy, sz, p);
    }
}
#line 471285 "MACS_sample_kidney_box.c"
/* 'spec_detector_history_13=extend_monitor()' component instance extend code */
    SIG_MESSAGE("spec_detector_history_13 (Trace:Extend)");
if (( detector_channel_spec == 13 && detector_found == 1 )) {

#line 5963 "generated_includes/kidney_trace.c"
    if (SCATTERED) {
      flag_sum=0;
      for (flag_index=1;flag_index<MAX_VOLUME_HISTORY_LENGTH;flag_index++) {
        if (scattering_history_sample_master[flag_index] > 0) {
          C_N[flag_index+1]++;
          C_p[flag_index+1] += p;
          C_p2[flag_index+1] += p*p;
          flag_sum++;
          flag_single = flag_index;
        };
      };
      if (flag_sum == 0) {
        C_N[1]++;
        C_p[1] += p;
        C_p2[1] += p*p;
      };
      if (flag_sum == 1) {
        if (scattering_history_sample_master[flag_single] == 1) {
          C_N[MAX_VOLUME_HISTORY_LENGTH+flag_single+1]++;
          C_p[MAX_VOLUME_HISTORY_LENGTH+flag_single+1] += p;
          C_p2[MAX_VOLUME_HISTORY_LENGTH+flag_single+1] += p*p;
        };
      };
    };
#line 471314 "MACS_sample_kidney_box.c"
}

}   /* End of spec_detector_history_13=extend_monitor() SETTING parameter declarations. */
#undef C_p2
#undef C_p
#undef C_N
#undef nb
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex
  /* Label for restoring  neutron */
  mcabsorbCompspec_detector_history_13:
  if (RESTORE) /* restore if needed */
  { RESTORE_NEUTRON(938,
      mcnlx,
      mcnly,
      mcnlz,
      mcnlvx,
      mcnlvy,
      mcnlvz,
      mcnlt,
      mcnlsx,
      mcnlsy,
      mcnlsz,
      mcnlp); }
#undef mcabsorbComp
#undef p
#undef sz
#undef sy
#undef sx
#undef t
#undef vz
#undef vy
#undef vx
#undef z
#undef y
#undef x
  mcDEBUG_STATE(
mcnlx,
mcnly,
mcnlz,
mcnlvx,
mcnlvy,
mcnlvz,
mcnlt,
mcnlsx,
mcnlsy,
mcnlsz,
mcnlp)

  /* TRACE Component spec_detector_history_14 [939] */
  mccoordschange(mcposrspec_detector_history_14, mcrotrspec_detector_history_14,
    &mcnlx,
    &mcnly,
    &mcnlz,
    &mcnlvx,
    &mcnlvy,
    &mcnlvz,
    &mcnlsx,
    &mcnlsy,
    &mcnlsz);
  /* define label inside component spec_detector_history_14 (without coords transformations) */
  mcJumpTrace_spec_detector_history_14:
  SIG_MESSAGE("spec_detector_history_14 (Trace)");
  mcDEBUG_COMP("spec_detector_history_14")
  mcDEBUG_STATE(
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp)
#define x mcnlx
#define y mcnly
#define z mcnlz
#define vx mcnlvx
#define vy mcnlvy
#define vz mcnlvz
#define t mcnlt
#define sx mcnlsx
#define sy mcnlsy
#define sz mcnlsz
#define p mcnlp

#define mcabsorbComp mcabsorbCompspec_detector_history_14
  STORE_NEUTRON(939,
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp);
  mcScattered=0;
  mcRestore=0;
  mcNCounter[939]++;
  mcPCounter[939] += p;
  mcP2Counter[939] += p*p;
#define mccompcurname  spec_detector_history_14
#define mccompcurtype  extend_monitor
#define mccompcurindex 939
#define nb mccspec_detector_history_14_nb
#define C_N mccspec_detector_history_14_C_N
#define C_p mccspec_detector_history_14_C_p
#define C_p2 mccspec_detector_history_14_C_p2
{   /* Declarations of spec_detector_history_14=extend_monitor() SETTING parameters. */
char* filename = mccspec_detector_history_14_filename;
MCNUM xmin = mccspec_detector_history_14_xmin;
MCNUM xmax = mccspec_detector_history_14_xmax;
MCNUM ymin = mccspec_detector_history_14_ymin;
MCNUM ymax = mccspec_detector_history_14_ymax;
MCNUM xwidth = mccspec_detector_history_14_xwidth;
MCNUM yheight = mccspec_detector_history_14_yheight;
MCNUM restore_neutron = mccspec_detector_history_14_restore_neutron;
/* 'spec_detector_history_14=extend_monitor()' component instance has conditional execution */
if (( detector_channel_spec == 14 && detector_found == 1 ))

#line 85 "extend_monitor.comp"
{
    int i;

    PROP_Z0;
    if (x>xmin && x<xmax && y>ymin && y<ymax)
    {
        C_N[0]++;
        C_p[0] += p;
        C_p2[0] += p*p;
        SCATTER;
    }
    if (restore_neutron) {
      RESTORE_NEUTRON(INDEX_CURRENT_COMP, x, y, z, vx, vy, vz, t, sx, sy, sz, p);
    }
}
#line 471455 "MACS_sample_kidney_box.c"
/* 'spec_detector_history_14=extend_monitor()' component instance extend code */
    SIG_MESSAGE("spec_detector_history_14 (Trace:Extend)");
if (( detector_channel_spec == 14 && detector_found == 1 )) {

#line 5996 "generated_includes/kidney_trace.c"
    if (SCATTERED) {
      flag_sum=0;
      for (flag_index=1;flag_index<MAX_VOLUME_HISTORY_LENGTH;flag_index++) {
        if (scattering_history_sample_master[flag_index] > 0) {
          C_N[flag_index+1]++;
          C_p[flag_index+1] += p;
          C_p2[flag_index+1] += p*p;
          flag_sum++;
          flag_single = flag_index;
        };
      };
      if (flag_sum == 0) {
        C_N[1]++;
        C_p[1] += p;
        C_p2[1] += p*p;
      };
      if (flag_sum == 1) {
        if (scattering_history_sample_master[flag_single] == 1) {
          C_N[MAX_VOLUME_HISTORY_LENGTH+flag_single+1]++;
          C_p[MAX_VOLUME_HISTORY_LENGTH+flag_single+1] += p;
          C_p2[MAX_VOLUME_HISTORY_LENGTH+flag_single+1] += p*p;
        };
      };
    };
#line 471484 "MACS_sample_kidney_box.c"
}

}   /* End of spec_detector_history_14=extend_monitor() SETTING parameter declarations. */
#undef C_p2
#undef C_p
#undef C_N
#undef nb
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex
  /* Label for restoring  neutron */
  mcabsorbCompspec_detector_history_14:
  if (RESTORE) /* restore if needed */
  { RESTORE_NEUTRON(939,
      mcnlx,
      mcnly,
      mcnlz,
      mcnlvx,
      mcnlvy,
      mcnlvz,
      mcnlt,
      mcnlsx,
      mcnlsy,
      mcnlsz,
      mcnlp); }
#undef mcabsorbComp
#undef p
#undef sz
#undef sy
#undef sx
#undef t
#undef vz
#undef vy
#undef vx
#undef z
#undef y
#undef x
  mcDEBUG_STATE(
mcnlx,
mcnly,
mcnlz,
mcnlvx,
mcnlvy,
mcnlvz,
mcnlt,
mcnlsx,
mcnlsy,
mcnlsz,
mcnlp)

  /* TRACE Component spec_detector_history_15 [940] */
  mccoordschange(mcposrspec_detector_history_15, mcrotrspec_detector_history_15,
    &mcnlx,
    &mcnly,
    &mcnlz,
    &mcnlvx,
    &mcnlvy,
    &mcnlvz,
    &mcnlsx,
    &mcnlsy,
    &mcnlsz);
  /* define label inside component spec_detector_history_15 (without coords transformations) */
  mcJumpTrace_spec_detector_history_15:
  SIG_MESSAGE("spec_detector_history_15 (Trace)");
  mcDEBUG_COMP("spec_detector_history_15")
  mcDEBUG_STATE(
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp)
#define x mcnlx
#define y mcnly
#define z mcnlz
#define vx mcnlvx
#define vy mcnlvy
#define vz mcnlvz
#define t mcnlt
#define sx mcnlsx
#define sy mcnlsy
#define sz mcnlsz
#define p mcnlp

#define mcabsorbComp mcabsorbCompspec_detector_history_15
  STORE_NEUTRON(940,
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp);
  mcScattered=0;
  mcRestore=0;
  mcNCounter[940]++;
  mcPCounter[940] += p;
  mcP2Counter[940] += p*p;
#define mccompcurname  spec_detector_history_15
#define mccompcurtype  extend_monitor
#define mccompcurindex 940
#define nb mccspec_detector_history_15_nb
#define C_N mccspec_detector_history_15_C_N
#define C_p mccspec_detector_history_15_C_p
#define C_p2 mccspec_detector_history_15_C_p2
{   /* Declarations of spec_detector_history_15=extend_monitor() SETTING parameters. */
char* filename = mccspec_detector_history_15_filename;
MCNUM xmin = mccspec_detector_history_15_xmin;
MCNUM xmax = mccspec_detector_history_15_xmax;
MCNUM ymin = mccspec_detector_history_15_ymin;
MCNUM ymax = mccspec_detector_history_15_ymax;
MCNUM xwidth = mccspec_detector_history_15_xwidth;
MCNUM yheight = mccspec_detector_history_15_yheight;
MCNUM restore_neutron = mccspec_detector_history_15_restore_neutron;
/* 'spec_detector_history_15=extend_monitor()' component instance has conditional execution */
if (( detector_channel_spec == 15 && detector_found == 1 ))

#line 85 "extend_monitor.comp"
{
    int i;

    PROP_Z0;
    if (x>xmin && x<xmax && y>ymin && y<ymax)
    {
        C_N[0]++;
        C_p[0] += p;
        C_p2[0] += p*p;
        SCATTER;
    }
    if (restore_neutron) {
      RESTORE_NEUTRON(INDEX_CURRENT_COMP, x, y, z, vx, vy, vz, t, sx, sy, sz, p);
    }
}
#line 471625 "MACS_sample_kidney_box.c"
/* 'spec_detector_history_15=extend_monitor()' component instance extend code */
    SIG_MESSAGE("spec_detector_history_15 (Trace:Extend)");
if (( detector_channel_spec == 15 && detector_found == 1 )) {

#line 6029 "generated_includes/kidney_trace.c"
    if (SCATTERED) {
      flag_sum=0;
      for (flag_index=1;flag_index<MAX_VOLUME_HISTORY_LENGTH;flag_index++) {
        if (scattering_history_sample_master[flag_index] > 0) {
          C_N[flag_index+1]++;
          C_p[flag_index+1] += p;
          C_p2[flag_index+1] += p*p;
          flag_sum++;
          flag_single = flag_index;
        };
      };
      if (flag_sum == 0) {
        C_N[1]++;
        C_p[1] += p;
        C_p2[1] += p*p;
      };
      if (flag_sum == 1) {
        if (scattering_history_sample_master[flag_single] == 1) {
          C_N[MAX_VOLUME_HISTORY_LENGTH+flag_single+1]++;
          C_p[MAX_VOLUME_HISTORY_LENGTH+flag_single+1] += p;
          C_p2[MAX_VOLUME_HISTORY_LENGTH+flag_single+1] += p*p;
        };
      };
    };
#line 471654 "MACS_sample_kidney_box.c"
}

}   /* End of spec_detector_history_15=extend_monitor() SETTING parameter declarations. */
#undef C_p2
#undef C_p
#undef C_N
#undef nb
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex
  /* Label for restoring  neutron */
  mcabsorbCompspec_detector_history_15:
  if (RESTORE) /* restore if needed */
  { RESTORE_NEUTRON(940,
      mcnlx,
      mcnly,
      mcnlz,
      mcnlvx,
      mcnlvy,
      mcnlvz,
      mcnlt,
      mcnlsx,
      mcnlsy,
      mcnlsz,
      mcnlp); }
#undef mcabsorbComp
#undef p
#undef sz
#undef sy
#undef sx
#undef t
#undef vz
#undef vy
#undef vx
#undef z
#undef y
#undef x
  mcDEBUG_STATE(
mcnlx,
mcnly,
mcnlz,
mcnlvx,
mcnlvy,
mcnlvz,
mcnlt,
mcnlsx,
mcnlsy,
mcnlsz,
mcnlp)

  /* TRACE Component spec_detector_history_16 [941] */
  mccoordschange(mcposrspec_detector_history_16, mcrotrspec_detector_history_16,
    &mcnlx,
    &mcnly,
    &mcnlz,
    &mcnlvx,
    &mcnlvy,
    &mcnlvz,
    &mcnlsx,
    &mcnlsy,
    &mcnlsz);
  /* define label inside component spec_detector_history_16 (without coords transformations) */
  mcJumpTrace_spec_detector_history_16:
  SIG_MESSAGE("spec_detector_history_16 (Trace)");
  mcDEBUG_COMP("spec_detector_history_16")
  mcDEBUG_STATE(
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp)
#define x mcnlx
#define y mcnly
#define z mcnlz
#define vx mcnlvx
#define vy mcnlvy
#define vz mcnlvz
#define t mcnlt
#define sx mcnlsx
#define sy mcnlsy
#define sz mcnlsz
#define p mcnlp

#define mcabsorbComp mcabsorbCompspec_detector_history_16
  STORE_NEUTRON(941,
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp);
  mcScattered=0;
  mcRestore=0;
  mcNCounter[941]++;
  mcPCounter[941] += p;
  mcP2Counter[941] += p*p;
#define mccompcurname  spec_detector_history_16
#define mccompcurtype  extend_monitor
#define mccompcurindex 941
#define nb mccspec_detector_history_16_nb
#define C_N mccspec_detector_history_16_C_N
#define C_p mccspec_detector_history_16_C_p
#define C_p2 mccspec_detector_history_16_C_p2
{   /* Declarations of spec_detector_history_16=extend_monitor() SETTING parameters. */
char* filename = mccspec_detector_history_16_filename;
MCNUM xmin = mccspec_detector_history_16_xmin;
MCNUM xmax = mccspec_detector_history_16_xmax;
MCNUM ymin = mccspec_detector_history_16_ymin;
MCNUM ymax = mccspec_detector_history_16_ymax;
MCNUM xwidth = mccspec_detector_history_16_xwidth;
MCNUM yheight = mccspec_detector_history_16_yheight;
MCNUM restore_neutron = mccspec_detector_history_16_restore_neutron;
/* 'spec_detector_history_16=extend_monitor()' component instance has conditional execution */
if (( detector_channel_spec == 16 && detector_found == 1 ))

#line 85 "extend_monitor.comp"
{
    int i;

    PROP_Z0;
    if (x>xmin && x<xmax && y>ymin && y<ymax)
    {
        C_N[0]++;
        C_p[0] += p;
        C_p2[0] += p*p;
        SCATTER;
    }
    if (restore_neutron) {
      RESTORE_NEUTRON(INDEX_CURRENT_COMP, x, y, z, vx, vy, vz, t, sx, sy, sz, p);
    }
}
#line 471795 "MACS_sample_kidney_box.c"
/* 'spec_detector_history_16=extend_monitor()' component instance extend code */
    SIG_MESSAGE("spec_detector_history_16 (Trace:Extend)");
if (( detector_channel_spec == 16 && detector_found == 1 )) {

#line 6062 "generated_includes/kidney_trace.c"
    if (SCATTERED) {
      flag_sum=0;
      for (flag_index=1;flag_index<MAX_VOLUME_HISTORY_LENGTH;flag_index++) {
        if (scattering_history_sample_master[flag_index] > 0) {
          C_N[flag_index+1]++;
          C_p[flag_index+1] += p;
          C_p2[flag_index+1] += p*p;
          flag_sum++;
          flag_single = flag_index;
        };
      };
      if (flag_sum == 0) {
        C_N[1]++;
        C_p[1] += p;
        C_p2[1] += p*p;
      };
      if (flag_sum == 1) {
        if (scattering_history_sample_master[flag_single] == 1) {
          C_N[MAX_VOLUME_HISTORY_LENGTH+flag_single+1]++;
          C_p[MAX_VOLUME_HISTORY_LENGTH+flag_single+1] += p;
          C_p2[MAX_VOLUME_HISTORY_LENGTH+flag_single+1] += p*p;
        };
      };
    };
#line 471824 "MACS_sample_kidney_box.c"
}

}   /* End of spec_detector_history_16=extend_monitor() SETTING parameter declarations. */
#undef C_p2
#undef C_p
#undef C_N
#undef nb
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex
  /* Label for restoring  neutron */
  mcabsorbCompspec_detector_history_16:
  if (RESTORE) /* restore if needed */
  { RESTORE_NEUTRON(941,
      mcnlx,
      mcnly,
      mcnlz,
      mcnlvx,
      mcnlvy,
      mcnlvz,
      mcnlt,
      mcnlsx,
      mcnlsy,
      mcnlsz,
      mcnlp); }
#undef mcabsorbComp
#undef p
#undef sz
#undef sy
#undef sx
#undef t
#undef vz
#undef vy
#undef vx
#undef z
#undef y
#undef x
  mcDEBUG_STATE(
mcnlx,
mcnly,
mcnlz,
mcnlvx,
mcnlvy,
mcnlvz,
mcnlt,
mcnlsx,
mcnlsy,
mcnlsz,
mcnlp)

  /* TRACE Component spec_detector_history_17 [942] */
  mccoordschange(mcposrspec_detector_history_17, mcrotrspec_detector_history_17,
    &mcnlx,
    &mcnly,
    &mcnlz,
    &mcnlvx,
    &mcnlvy,
    &mcnlvz,
    &mcnlsx,
    &mcnlsy,
    &mcnlsz);
  /* define label inside component spec_detector_history_17 (without coords transformations) */
  mcJumpTrace_spec_detector_history_17:
  SIG_MESSAGE("spec_detector_history_17 (Trace)");
  mcDEBUG_COMP("spec_detector_history_17")
  mcDEBUG_STATE(
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp)
#define x mcnlx
#define y mcnly
#define z mcnlz
#define vx mcnlvx
#define vy mcnlvy
#define vz mcnlvz
#define t mcnlt
#define sx mcnlsx
#define sy mcnlsy
#define sz mcnlsz
#define p mcnlp

#define mcabsorbComp mcabsorbCompspec_detector_history_17
  STORE_NEUTRON(942,
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp);
  mcScattered=0;
  mcRestore=0;
  mcNCounter[942]++;
  mcPCounter[942] += p;
  mcP2Counter[942] += p*p;
#define mccompcurname  spec_detector_history_17
#define mccompcurtype  extend_monitor
#define mccompcurindex 942
#define nb mccspec_detector_history_17_nb
#define C_N mccspec_detector_history_17_C_N
#define C_p mccspec_detector_history_17_C_p
#define C_p2 mccspec_detector_history_17_C_p2
{   /* Declarations of spec_detector_history_17=extend_monitor() SETTING parameters. */
char* filename = mccspec_detector_history_17_filename;
MCNUM xmin = mccspec_detector_history_17_xmin;
MCNUM xmax = mccspec_detector_history_17_xmax;
MCNUM ymin = mccspec_detector_history_17_ymin;
MCNUM ymax = mccspec_detector_history_17_ymax;
MCNUM xwidth = mccspec_detector_history_17_xwidth;
MCNUM yheight = mccspec_detector_history_17_yheight;
MCNUM restore_neutron = mccspec_detector_history_17_restore_neutron;
/* 'spec_detector_history_17=extend_monitor()' component instance has conditional execution */
if (( detector_channel_spec == 17 && detector_found == 1 ))

#line 85 "extend_monitor.comp"
{
    int i;

    PROP_Z0;
    if (x>xmin && x<xmax && y>ymin && y<ymax)
    {
        C_N[0]++;
        C_p[0] += p;
        C_p2[0] += p*p;
        SCATTER;
    }
    if (restore_neutron) {
      RESTORE_NEUTRON(INDEX_CURRENT_COMP, x, y, z, vx, vy, vz, t, sx, sy, sz, p);
    }
}
#line 471965 "MACS_sample_kidney_box.c"
/* 'spec_detector_history_17=extend_monitor()' component instance extend code */
    SIG_MESSAGE("spec_detector_history_17 (Trace:Extend)");
if (( detector_channel_spec == 17 && detector_found == 1 )) {

#line 6095 "generated_includes/kidney_trace.c"
    if (SCATTERED) {
      flag_sum=0;
      for (flag_index=1;flag_index<MAX_VOLUME_HISTORY_LENGTH;flag_index++) {
        if (scattering_history_sample_master[flag_index] > 0) {
          C_N[flag_index+1]++;
          C_p[flag_index+1] += p;
          C_p2[flag_index+1] += p*p;
          flag_sum++;
          flag_single = flag_index;
        };
      };
      if (flag_sum == 0) {
        C_N[1]++;
        C_p[1] += p;
        C_p2[1] += p*p;
      };
      if (flag_sum == 1) {
        if (scattering_history_sample_master[flag_single] == 1) {
          C_N[MAX_VOLUME_HISTORY_LENGTH+flag_single+1]++;
          C_p[MAX_VOLUME_HISTORY_LENGTH+flag_single+1] += p;
          C_p2[MAX_VOLUME_HISTORY_LENGTH+flag_single+1] += p*p;
        };
      };
    };
#line 471994 "MACS_sample_kidney_box.c"
}

}   /* End of spec_detector_history_17=extend_monitor() SETTING parameter declarations. */
#undef C_p2
#undef C_p
#undef C_N
#undef nb
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex
  /* Label for restoring  neutron */
  mcabsorbCompspec_detector_history_17:
  if (RESTORE) /* restore if needed */
  { RESTORE_NEUTRON(942,
      mcnlx,
      mcnly,
      mcnlz,
      mcnlvx,
      mcnlvy,
      mcnlvz,
      mcnlt,
      mcnlsx,
      mcnlsy,
      mcnlsz,
      mcnlp); }
#undef mcabsorbComp
#undef p
#undef sz
#undef sy
#undef sx
#undef t
#undef vz
#undef vy
#undef vx
#undef z
#undef y
#undef x
  mcDEBUG_STATE(
mcnlx,
mcnly,
mcnlz,
mcnlvx,
mcnlvy,
mcnlvz,
mcnlt,
mcnlsx,
mcnlsy,
mcnlsz,
mcnlp)

  /* TRACE Component spec_detector_history_18 [943] */
  mccoordschange(mcposrspec_detector_history_18, mcrotrspec_detector_history_18,
    &mcnlx,
    &mcnly,
    &mcnlz,
    &mcnlvx,
    &mcnlvy,
    &mcnlvz,
    &mcnlsx,
    &mcnlsy,
    &mcnlsz);
  /* define label inside component spec_detector_history_18 (without coords transformations) */
  mcJumpTrace_spec_detector_history_18:
  SIG_MESSAGE("spec_detector_history_18 (Trace)");
  mcDEBUG_COMP("spec_detector_history_18")
  mcDEBUG_STATE(
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp)
#define x mcnlx
#define y mcnly
#define z mcnlz
#define vx mcnlvx
#define vy mcnlvy
#define vz mcnlvz
#define t mcnlt
#define sx mcnlsx
#define sy mcnlsy
#define sz mcnlsz
#define p mcnlp

#define mcabsorbComp mcabsorbCompspec_detector_history_18
  STORE_NEUTRON(943,
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp);
  mcScattered=0;
  mcRestore=0;
  mcNCounter[943]++;
  mcPCounter[943] += p;
  mcP2Counter[943] += p*p;
#define mccompcurname  spec_detector_history_18
#define mccompcurtype  extend_monitor
#define mccompcurindex 943
#define nb mccspec_detector_history_18_nb
#define C_N mccspec_detector_history_18_C_N
#define C_p mccspec_detector_history_18_C_p
#define C_p2 mccspec_detector_history_18_C_p2
{   /* Declarations of spec_detector_history_18=extend_monitor() SETTING parameters. */
char* filename = mccspec_detector_history_18_filename;
MCNUM xmin = mccspec_detector_history_18_xmin;
MCNUM xmax = mccspec_detector_history_18_xmax;
MCNUM ymin = mccspec_detector_history_18_ymin;
MCNUM ymax = mccspec_detector_history_18_ymax;
MCNUM xwidth = mccspec_detector_history_18_xwidth;
MCNUM yheight = mccspec_detector_history_18_yheight;
MCNUM restore_neutron = mccspec_detector_history_18_restore_neutron;
/* 'spec_detector_history_18=extend_monitor()' component instance has conditional execution */
if (( detector_channel_spec == 18 && detector_found == 1 ))

#line 85 "extend_monitor.comp"
{
    int i;

    PROP_Z0;
    if (x>xmin && x<xmax && y>ymin && y<ymax)
    {
        C_N[0]++;
        C_p[0] += p;
        C_p2[0] += p*p;
        SCATTER;
    }
    if (restore_neutron) {
      RESTORE_NEUTRON(INDEX_CURRENT_COMP, x, y, z, vx, vy, vz, t, sx, sy, sz, p);
    }
}
#line 472135 "MACS_sample_kidney_box.c"
/* 'spec_detector_history_18=extend_monitor()' component instance extend code */
    SIG_MESSAGE("spec_detector_history_18 (Trace:Extend)");
if (( detector_channel_spec == 18 && detector_found == 1 )) {

#line 6128 "generated_includes/kidney_trace.c"
    if (SCATTERED) {
      flag_sum=0;
      for (flag_index=1;flag_index<MAX_VOLUME_HISTORY_LENGTH;flag_index++) {
        if (scattering_history_sample_master[flag_index] > 0) {
          C_N[flag_index+1]++;
          C_p[flag_index+1] += p;
          C_p2[flag_index+1] += p*p;
          flag_sum++;
          flag_single = flag_index;
        };
      };
      if (flag_sum == 0) {
        C_N[1]++;
        C_p[1] += p;
        C_p2[1] += p*p;
      };
      if (flag_sum == 1) {
        if (scattering_history_sample_master[flag_single] == 1) {
          C_N[MAX_VOLUME_HISTORY_LENGTH+flag_single+1]++;
          C_p[MAX_VOLUME_HISTORY_LENGTH+flag_single+1] += p;
          C_p2[MAX_VOLUME_HISTORY_LENGTH+flag_single+1] += p*p;
        };
      };
    };
#line 472164 "MACS_sample_kidney_box.c"
}

}   /* End of spec_detector_history_18=extend_monitor() SETTING parameter declarations. */
#undef C_p2
#undef C_p
#undef C_N
#undef nb
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex
  /* Label for restoring  neutron */
  mcabsorbCompspec_detector_history_18:
  if (RESTORE) /* restore if needed */
  { RESTORE_NEUTRON(943,
      mcnlx,
      mcnly,
      mcnlz,
      mcnlvx,
      mcnlvy,
      mcnlvz,
      mcnlt,
      mcnlsx,
      mcnlsy,
      mcnlsz,
      mcnlp); }
#undef mcabsorbComp
#undef p
#undef sz
#undef sy
#undef sx
#undef t
#undef vz
#undef vy
#undef vx
#undef z
#undef y
#undef x
  mcDEBUG_STATE(
mcnlx,
mcnly,
mcnlz,
mcnlvx,
mcnlvy,
mcnlvz,
mcnlt,
mcnlsx,
mcnlsy,
mcnlsz,
mcnlp)

  /* TRACE Component spec_detector_history_19 [944] */
  mccoordschange(mcposrspec_detector_history_19, mcrotrspec_detector_history_19,
    &mcnlx,
    &mcnly,
    &mcnlz,
    &mcnlvx,
    &mcnlvy,
    &mcnlvz,
    &mcnlsx,
    &mcnlsy,
    &mcnlsz);
  /* define label inside component spec_detector_history_19 (without coords transformations) */
  mcJumpTrace_spec_detector_history_19:
  SIG_MESSAGE("spec_detector_history_19 (Trace)");
  mcDEBUG_COMP("spec_detector_history_19")
  mcDEBUG_STATE(
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp)
#define x mcnlx
#define y mcnly
#define z mcnlz
#define vx mcnlvx
#define vy mcnlvy
#define vz mcnlvz
#define t mcnlt
#define sx mcnlsx
#define sy mcnlsy
#define sz mcnlsz
#define p mcnlp

#define mcabsorbComp mcabsorbCompspec_detector_history_19
  STORE_NEUTRON(944,
    mcnlx,
    mcnly,
    mcnlz,
    mcnlvx,
    mcnlvy,
    mcnlvz,
    mcnlt,
    mcnlsx,
    mcnlsy,
    mcnlsz,
    mcnlp);
  mcScattered=0;
  mcRestore=0;
  mcNCounter[944]++;
  mcPCounter[944] += p;
  mcP2Counter[944] += p*p;
#define mccompcurname  spec_detector_history_19
#define mccompcurtype  extend_monitor
#define mccompcurindex 944
#define nb mccspec_detector_history_19_nb
#define C_N mccspec_detector_history_19_C_N
#define C_p mccspec_detector_history_19_C_p
#define C_p2 mccspec_detector_history_19_C_p2
{   /* Declarations of spec_detector_history_19=extend_monitor() SETTING parameters. */
char* filename = mccspec_detector_history_19_filename;
MCNUM xmin = mccspec_detector_history_19_xmin;
MCNUM xmax = mccspec_detector_history_19_xmax;
MCNUM ymin = mccspec_detector_history_19_ymin;
MCNUM ymax = mccspec_detector_history_19_ymax;
MCNUM xwidth = mccspec_detector_history_19_xwidth;
MCNUM yheight = mccspec_detector_history_19_yheight;
MCNUM restore_neutron = mccspec_detector_history_19_restore_neutron;
/* 'spec_detector_history_19=extend_monitor()' component instance has conditional execution */
if (( detector_channel_spec == 19 && detector_found == 1 ))

#line 85 "extend_monitor.comp"
{
    int i;

    PROP_Z0;
    if (x>xmin && x<xmax && y>ymin && y<ymax)
    {
        C_N[0]++;
        C_p[0] += p;
        C_p2[0] += p*p;
        SCATTER;
    }
    if (restore_neutron) {
      RESTORE_NEUTRON(INDEX_CURRENT_COMP, x, y, z, vx, vy, vz, t, sx, sy, sz, p);
    }
}
#line 472305 "MACS_sample_kidney_box.c"
/* 'spec_detector_history_19=extend_monitor()' component instance extend code */
    SIG_MESSAGE("spec_detector_history_19 (Trace:Extend)");
if (( detector_channel_spec == 19 && detector_found == 1 )) {

#line 6161 "generated_includes/kidney_trace.c"
    if (SCATTERED) {
      flag_sum=0;
      for (flag_index=1;flag_index<MAX_VOLUME_HISTORY_LENGTH;flag_index++) {
        if (scattering_history_sample_master[flag_index] > 0) {
          C_N[flag_index+1]++;
          C_p[flag_index+1] += p;
          C_p2[flag_index+1] += p*p;
          flag_sum++;
          flag_single = flag_index;
        };
      };
      if (flag_sum == 0) {
        C_N[1]++;
        C_p[1] += p;
        C_p2[1] += p*p;
      };
      if (flag_sum == 1) {
        if (scattering_history_sample_master[flag_single] == 1) {
          C_N[MAX_VOLUME_HISTORY_LENGTH+flag_single+1]++;
          C_p[MAX_VOLUME_HISTORY_LENGTH+flag_single+1] += p;
          C_p2[MAX_VOLUME_HISTORY_LENGTH+flag_single+1] += p*p;
        };
      };
    };
#line 472334 "MACS_sample_kidney_box.c"
}

}   /* End of spec_detector_history_19=extend_monitor() SETTING parameter declarations. */
#undef C_p2
#undef C_p
#undef C_N
#undef nb
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex
  /* Label for restoring  neutron */
  mcabsorbCompspec_detector_history_19:
  if (RESTORE) /* restore if needed */
  { RESTORE_NEUTRON(944,
      mcnlx,
      mcnly,
      mcnlz,
      mcnlvx,
      mcnlvy,
      mcnlvz,
      mcnlt,
      mcnlsx,
      mcnlsy,
      mcnlsz,
      mcnlp); }
#undef mcabsorbComp
#undef p
#undef sz
#undef sy
#undef sx
#undef t
#undef vz
#undef vy
#undef vx
#undef z
#undef y
#undef x
  mcDEBUG_STATE(
mcnlx,
mcnly,
mcnlz,
mcnlvx,
mcnlvy,
mcnlvz,
mcnlt,
mcnlsx,
mcnlsy,
mcnlsz,
mcnlp)

  mcabsorbAll:
  mcDEBUG_LEAVE()
  mcDEBUG_STATE(
mcnlx,
mcnly,
mcnlz,
mcnlvx,
mcnlvy,
mcnlvz,
mcnlt,
mcnlsx,
mcnlsy,
mcnlsz,
mcnlp)
  /* Copy neutron state to global variables. */
  mcnx = mcnlx;
  mcny = mcnly;
  mcnz = mcnlz;
  mcnvx = mcnlvx;
  mcnvy = mcnlvy;
  mcnvz = mcnlvz;
  mcnt = mcnlt;
  mcnsx = mcnlsx;
  mcnsy = mcnlsy;
  mcnsz = mcnlsz;
  mcnp = mcnlp;

} /* end trace */

void mcsave(FILE *handle) {
  if (!handle) mcsiminfo_init(NULL);
  /* User component SAVE code. */

  /* User SAVE code for component 'Arm0'. */
  SIG_MESSAGE("Arm0 (Save)");
#define mccompcurname  Arm0
#define mccompcurtype  Progress_bar
#define mccompcurindex 12
#define IntermediateCnts mccArm0_IntermediateCnts
#define StartTime mccArm0_StartTime
#define EndTime mccArm0_EndTime
#define CurrentTime mccArm0_CurrentTime
{   /* Declarations of Arm0=Progress_bar() SETTING parameters. */
char* profile = mccArm0_profile;
MCNUM percent = mccArm0_percent;
MCNUM flag_save = mccArm0_flag_save;
MCNUM minutes = mccArm0_minutes;
#line 115 "/usr/share/mcstas/2.7/misc/Progress_bar.comp"
{
  MPI_MASTER(fprintf(stdout, "\nSave [%s]\n", mcinstrument_name););
  if (profile && strlen(profile) && strcmp(profile,"NULL") && strcmp(profile,"0")) {
    char filename[256];
    if (!strlen(profile) || !strcmp(profile,"NULL") || !strcmp(profile,"0")) strcpy(filename, mcinstrument_name);
    else strcpy(filename, profile);
    DETECTOR_OUT_1D(
        "Intensity profiler",
        "Component index [1]",
        "Intensity",
        "prof", 1, mcNUMCOMP, mcNUMCOMP-1,
        &mcNCounter[1],&mcPCounter[1],&mcP2Counter[1],
        filename);

  }
}
#line 472448 "MACS_sample_kidney_box.c"
}   /* End of Arm0=Progress_bar() SETTING parameter declarations. */
#undef CurrentTime
#undef EndTime
#undef StartTime
#undef IntermediateCnts
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

  /* User SAVE code for component 'diffraction_detector_0'. */
  SIG_MESSAGE("diffraction_detector_0 (Save)");
#define mccompcurname  diffraction_detector_0
#define mccompcurtype  PSD_monitor
#define mccompcurindex 885
#define PSD_N mccdiffraction_detector_0_PSD_N
#define PSD_p mccdiffraction_detector_0_PSD_p
#define PSD_p2 mccdiffraction_detector_0_PSD_p2
{   /* Declarations of diffraction_detector_0=PSD_monitor() SETTING parameters. */
int nx = mccdiffraction_detector_0_nx;
int ny = mccdiffraction_detector_0_ny;
char* filename = mccdiffraction_detector_0_filename;
MCNUM xmin = mccdiffraction_detector_0_xmin;
MCNUM xmax = mccdiffraction_detector_0_xmax;
MCNUM ymin = mccdiffraction_detector_0_ymin;
MCNUM ymax = mccdiffraction_detector_0_ymax;
MCNUM xwidth = mccdiffraction_detector_0_xwidth;
MCNUM yheight = mccdiffraction_detector_0_yheight;
MCNUM restore_neutron = mccdiffraction_detector_0_restore_neutron;
#line 110 "/usr/share/mcstas/2.7/monitors/PSD_monitor.comp"
{
  DETECTOR_OUT_2D(
    "PSD monitor",
    "X position [cm]",
    "Y position [cm]",
    xmin*100.0, xmax*100.0, ymin*100.0, ymax*100.0,
    nx, ny,
    &PSD_N[0][0],&PSD_p[0][0],&PSD_p2[0][0],
    filename);
}
#line 472488 "MACS_sample_kidney_box.c"
}   /* End of diffraction_detector_0=PSD_monitor() SETTING parameter declarations. */
#undef PSD_p2
#undef PSD_p
#undef PSD_N
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

  /* User SAVE code for component 'spec_detector_0'. */
  SIG_MESSAGE("spec_detector_0 (Save)");
#define mccompcurname  spec_detector_0
#define mccompcurtype  PSD_monitor
#define mccompcurindex 886
#define PSD_N mccspec_detector_0_PSD_N
#define PSD_p mccspec_detector_0_PSD_p
#define PSD_p2 mccspec_detector_0_PSD_p2
{   /* Declarations of spec_detector_0=PSD_monitor() SETTING parameters. */
int nx = mccspec_detector_0_nx;
int ny = mccspec_detector_0_ny;
char* filename = mccspec_detector_0_filename;
MCNUM xmin = mccspec_detector_0_xmin;
MCNUM xmax = mccspec_detector_0_xmax;
MCNUM ymin = mccspec_detector_0_ymin;
MCNUM ymax = mccspec_detector_0_ymax;
MCNUM xwidth = mccspec_detector_0_xwidth;
MCNUM yheight = mccspec_detector_0_yheight;
MCNUM restore_neutron = mccspec_detector_0_restore_neutron;
#line 110 "/usr/share/mcstas/2.7/monitors/PSD_monitor.comp"
{
  DETECTOR_OUT_2D(
    "PSD monitor",
    "X position [cm]",
    "Y position [cm]",
    xmin*100.0, xmax*100.0, ymin*100.0, ymax*100.0,
    nx, ny,
    &PSD_N[0][0],&PSD_p[0][0],&PSD_p2[0][0],
    filename);
}
#line 472527 "MACS_sample_kidney_box.c"
}   /* End of spec_detector_0=PSD_monitor() SETTING parameter declarations. */
#undef PSD_p2
#undef PSD_p
#undef PSD_N
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

  /* User SAVE code for component 'diffraction_detector_1'. */
  SIG_MESSAGE("diffraction_detector_1 (Save)");
#define mccompcurname  diffraction_detector_1
#define mccompcurtype  PSD_monitor
#define mccompcurindex 887
#define PSD_N mccdiffraction_detector_1_PSD_N
#define PSD_p mccdiffraction_detector_1_PSD_p
#define PSD_p2 mccdiffraction_detector_1_PSD_p2
{   /* Declarations of diffraction_detector_1=PSD_monitor() SETTING parameters. */
int nx = mccdiffraction_detector_1_nx;
int ny = mccdiffraction_detector_1_ny;
char* filename = mccdiffraction_detector_1_filename;
MCNUM xmin = mccdiffraction_detector_1_xmin;
MCNUM xmax = mccdiffraction_detector_1_xmax;
MCNUM ymin = mccdiffraction_detector_1_ymin;
MCNUM ymax = mccdiffraction_detector_1_ymax;
MCNUM xwidth = mccdiffraction_detector_1_xwidth;
MCNUM yheight = mccdiffraction_detector_1_yheight;
MCNUM restore_neutron = mccdiffraction_detector_1_restore_neutron;
#line 110 "/usr/share/mcstas/2.7/monitors/PSD_monitor.comp"
{
  DETECTOR_OUT_2D(
    "PSD monitor",
    "X position [cm]",
    "Y position [cm]",
    xmin*100.0, xmax*100.0, ymin*100.0, ymax*100.0,
    nx, ny,
    &PSD_N[0][0],&PSD_p[0][0],&PSD_p2[0][0],
    filename);
}
#line 472566 "MACS_sample_kidney_box.c"
}   /* End of diffraction_detector_1=PSD_monitor() SETTING parameter declarations. */
#undef PSD_p2
#undef PSD_p
#undef PSD_N
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

  /* User SAVE code for component 'spec_detector_1'. */
  SIG_MESSAGE("spec_detector_1 (Save)");
#define mccompcurname  spec_detector_1
#define mccompcurtype  PSD_monitor
#define mccompcurindex 888
#define PSD_N mccspec_detector_1_PSD_N
#define PSD_p mccspec_detector_1_PSD_p
#define PSD_p2 mccspec_detector_1_PSD_p2
{   /* Declarations of spec_detector_1=PSD_monitor() SETTING parameters. */
int nx = mccspec_detector_1_nx;
int ny = mccspec_detector_1_ny;
char* filename = mccspec_detector_1_filename;
MCNUM xmin = mccspec_detector_1_xmin;
MCNUM xmax = mccspec_detector_1_xmax;
MCNUM ymin = mccspec_detector_1_ymin;
MCNUM ymax = mccspec_detector_1_ymax;
MCNUM xwidth = mccspec_detector_1_xwidth;
MCNUM yheight = mccspec_detector_1_yheight;
MCNUM restore_neutron = mccspec_detector_1_restore_neutron;
#line 110 "/usr/share/mcstas/2.7/monitors/PSD_monitor.comp"
{
  DETECTOR_OUT_2D(
    "PSD monitor",
    "X position [cm]",
    "Y position [cm]",
    xmin*100.0, xmax*100.0, ymin*100.0, ymax*100.0,
    nx, ny,
    &PSD_N[0][0],&PSD_p[0][0],&PSD_p2[0][0],
    filename);
}
#line 472605 "MACS_sample_kidney_box.c"
}   /* End of spec_detector_1=PSD_monitor() SETTING parameter declarations. */
#undef PSD_p2
#undef PSD_p
#undef PSD_N
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

  /* User SAVE code for component 'diffraction_detector_2'. */
  SIG_MESSAGE("diffraction_detector_2 (Save)");
#define mccompcurname  diffraction_detector_2
#define mccompcurtype  PSD_monitor
#define mccompcurindex 889
#define PSD_N mccdiffraction_detector_2_PSD_N
#define PSD_p mccdiffraction_detector_2_PSD_p
#define PSD_p2 mccdiffraction_detector_2_PSD_p2
{   /* Declarations of diffraction_detector_2=PSD_monitor() SETTING parameters. */
int nx = mccdiffraction_detector_2_nx;
int ny = mccdiffraction_detector_2_ny;
char* filename = mccdiffraction_detector_2_filename;
MCNUM xmin = mccdiffraction_detector_2_xmin;
MCNUM xmax = mccdiffraction_detector_2_xmax;
MCNUM ymin = mccdiffraction_detector_2_ymin;
MCNUM ymax = mccdiffraction_detector_2_ymax;
MCNUM xwidth = mccdiffraction_detector_2_xwidth;
MCNUM yheight = mccdiffraction_detector_2_yheight;
MCNUM restore_neutron = mccdiffraction_detector_2_restore_neutron;
#line 110 "/usr/share/mcstas/2.7/monitors/PSD_monitor.comp"
{
  DETECTOR_OUT_2D(
    "PSD monitor",
    "X position [cm]",
    "Y position [cm]",
    xmin*100.0, xmax*100.0, ymin*100.0, ymax*100.0,
    nx, ny,
    &PSD_N[0][0],&PSD_p[0][0],&PSD_p2[0][0],
    filename);
}
#line 472644 "MACS_sample_kidney_box.c"
}   /* End of diffraction_detector_2=PSD_monitor() SETTING parameter declarations. */
#undef PSD_p2
#undef PSD_p
#undef PSD_N
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

  /* User SAVE code for component 'spec_detector_2'. */
  SIG_MESSAGE("spec_detector_2 (Save)");
#define mccompcurname  spec_detector_2
#define mccompcurtype  PSD_monitor
#define mccompcurindex 890
#define PSD_N mccspec_detector_2_PSD_N
#define PSD_p mccspec_detector_2_PSD_p
#define PSD_p2 mccspec_detector_2_PSD_p2
{   /* Declarations of spec_detector_2=PSD_monitor() SETTING parameters. */
int nx = mccspec_detector_2_nx;
int ny = mccspec_detector_2_ny;
char* filename = mccspec_detector_2_filename;
MCNUM xmin = mccspec_detector_2_xmin;
MCNUM xmax = mccspec_detector_2_xmax;
MCNUM ymin = mccspec_detector_2_ymin;
MCNUM ymax = mccspec_detector_2_ymax;
MCNUM xwidth = mccspec_detector_2_xwidth;
MCNUM yheight = mccspec_detector_2_yheight;
MCNUM restore_neutron = mccspec_detector_2_restore_neutron;
#line 110 "/usr/share/mcstas/2.7/monitors/PSD_monitor.comp"
{
  DETECTOR_OUT_2D(
    "PSD monitor",
    "X position [cm]",
    "Y position [cm]",
    xmin*100.0, xmax*100.0, ymin*100.0, ymax*100.0,
    nx, ny,
    &PSD_N[0][0],&PSD_p[0][0],&PSD_p2[0][0],
    filename);
}
#line 472683 "MACS_sample_kidney_box.c"
}   /* End of spec_detector_2=PSD_monitor() SETTING parameter declarations. */
#undef PSD_p2
#undef PSD_p
#undef PSD_N
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

  /* User SAVE code for component 'diffraction_detector_3'. */
  SIG_MESSAGE("diffraction_detector_3 (Save)");
#define mccompcurname  diffraction_detector_3
#define mccompcurtype  PSD_monitor
#define mccompcurindex 891
#define PSD_N mccdiffraction_detector_3_PSD_N
#define PSD_p mccdiffraction_detector_3_PSD_p
#define PSD_p2 mccdiffraction_detector_3_PSD_p2
{   /* Declarations of diffraction_detector_3=PSD_monitor() SETTING parameters. */
int nx = mccdiffraction_detector_3_nx;
int ny = mccdiffraction_detector_3_ny;
char* filename = mccdiffraction_detector_3_filename;
MCNUM xmin = mccdiffraction_detector_3_xmin;
MCNUM xmax = mccdiffraction_detector_3_xmax;
MCNUM ymin = mccdiffraction_detector_3_ymin;
MCNUM ymax = mccdiffraction_detector_3_ymax;
MCNUM xwidth = mccdiffraction_detector_3_xwidth;
MCNUM yheight = mccdiffraction_detector_3_yheight;
MCNUM restore_neutron = mccdiffraction_detector_3_restore_neutron;
#line 110 "/usr/share/mcstas/2.7/monitors/PSD_monitor.comp"
{
  DETECTOR_OUT_2D(
    "PSD monitor",
    "X position [cm]",
    "Y position [cm]",
    xmin*100.0, xmax*100.0, ymin*100.0, ymax*100.0,
    nx, ny,
    &PSD_N[0][0],&PSD_p[0][0],&PSD_p2[0][0],
    filename);
}
#line 472722 "MACS_sample_kidney_box.c"
}   /* End of diffraction_detector_3=PSD_monitor() SETTING parameter declarations. */
#undef PSD_p2
#undef PSD_p
#undef PSD_N
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

  /* User SAVE code for component 'spec_detector_3'. */
  SIG_MESSAGE("spec_detector_3 (Save)");
#define mccompcurname  spec_detector_3
#define mccompcurtype  PSD_monitor
#define mccompcurindex 892
#define PSD_N mccspec_detector_3_PSD_N
#define PSD_p mccspec_detector_3_PSD_p
#define PSD_p2 mccspec_detector_3_PSD_p2
{   /* Declarations of spec_detector_3=PSD_monitor() SETTING parameters. */
int nx = mccspec_detector_3_nx;
int ny = mccspec_detector_3_ny;
char* filename = mccspec_detector_3_filename;
MCNUM xmin = mccspec_detector_3_xmin;
MCNUM xmax = mccspec_detector_3_xmax;
MCNUM ymin = mccspec_detector_3_ymin;
MCNUM ymax = mccspec_detector_3_ymax;
MCNUM xwidth = mccspec_detector_3_xwidth;
MCNUM yheight = mccspec_detector_3_yheight;
MCNUM restore_neutron = mccspec_detector_3_restore_neutron;
#line 110 "/usr/share/mcstas/2.7/monitors/PSD_monitor.comp"
{
  DETECTOR_OUT_2D(
    "PSD monitor",
    "X position [cm]",
    "Y position [cm]",
    xmin*100.0, xmax*100.0, ymin*100.0, ymax*100.0,
    nx, ny,
    &PSD_N[0][0],&PSD_p[0][0],&PSD_p2[0][0],
    filename);
}
#line 472761 "MACS_sample_kidney_box.c"
}   /* End of spec_detector_3=PSD_monitor() SETTING parameter declarations. */
#undef PSD_p2
#undef PSD_p
#undef PSD_N
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

  /* User SAVE code for component 'diffraction_detector_4'. */
  SIG_MESSAGE("diffraction_detector_4 (Save)");
#define mccompcurname  diffraction_detector_4
#define mccompcurtype  PSD_monitor
#define mccompcurindex 893
#define PSD_N mccdiffraction_detector_4_PSD_N
#define PSD_p mccdiffraction_detector_4_PSD_p
#define PSD_p2 mccdiffraction_detector_4_PSD_p2
{   /* Declarations of diffraction_detector_4=PSD_monitor() SETTING parameters. */
int nx = mccdiffraction_detector_4_nx;
int ny = mccdiffraction_detector_4_ny;
char* filename = mccdiffraction_detector_4_filename;
MCNUM xmin = mccdiffraction_detector_4_xmin;
MCNUM xmax = mccdiffraction_detector_4_xmax;
MCNUM ymin = mccdiffraction_detector_4_ymin;
MCNUM ymax = mccdiffraction_detector_4_ymax;
MCNUM xwidth = mccdiffraction_detector_4_xwidth;
MCNUM yheight = mccdiffraction_detector_4_yheight;
MCNUM restore_neutron = mccdiffraction_detector_4_restore_neutron;
#line 110 "/usr/share/mcstas/2.7/monitors/PSD_monitor.comp"
{
  DETECTOR_OUT_2D(
    "PSD monitor",
    "X position [cm]",
    "Y position [cm]",
    xmin*100.0, xmax*100.0, ymin*100.0, ymax*100.0,
    nx, ny,
    &PSD_N[0][0],&PSD_p[0][0],&PSD_p2[0][0],
    filename);
}
#line 472800 "MACS_sample_kidney_box.c"
}   /* End of diffraction_detector_4=PSD_monitor() SETTING parameter declarations. */
#undef PSD_p2
#undef PSD_p
#undef PSD_N
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

  /* User SAVE code for component 'spec_detector_4'. */
  SIG_MESSAGE("spec_detector_4 (Save)");
#define mccompcurname  spec_detector_4
#define mccompcurtype  PSD_monitor
#define mccompcurindex 894
#define PSD_N mccspec_detector_4_PSD_N
#define PSD_p mccspec_detector_4_PSD_p
#define PSD_p2 mccspec_detector_4_PSD_p2
{   /* Declarations of spec_detector_4=PSD_monitor() SETTING parameters. */
int nx = mccspec_detector_4_nx;
int ny = mccspec_detector_4_ny;
char* filename = mccspec_detector_4_filename;
MCNUM xmin = mccspec_detector_4_xmin;
MCNUM xmax = mccspec_detector_4_xmax;
MCNUM ymin = mccspec_detector_4_ymin;
MCNUM ymax = mccspec_detector_4_ymax;
MCNUM xwidth = mccspec_detector_4_xwidth;
MCNUM yheight = mccspec_detector_4_yheight;
MCNUM restore_neutron = mccspec_detector_4_restore_neutron;
#line 110 "/usr/share/mcstas/2.7/monitors/PSD_monitor.comp"
{
  DETECTOR_OUT_2D(
    "PSD monitor",
    "X position [cm]",
    "Y position [cm]",
    xmin*100.0, xmax*100.0, ymin*100.0, ymax*100.0,
    nx, ny,
    &PSD_N[0][0],&PSD_p[0][0],&PSD_p2[0][0],
    filename);
}
#line 472839 "MACS_sample_kidney_box.c"
}   /* End of spec_detector_4=PSD_monitor() SETTING parameter declarations. */
#undef PSD_p2
#undef PSD_p
#undef PSD_N
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

  /* User SAVE code for component 'diffraction_detector_5'. */
  SIG_MESSAGE("diffraction_detector_5 (Save)");
#define mccompcurname  diffraction_detector_5
#define mccompcurtype  PSD_monitor
#define mccompcurindex 895
#define PSD_N mccdiffraction_detector_5_PSD_N
#define PSD_p mccdiffraction_detector_5_PSD_p
#define PSD_p2 mccdiffraction_detector_5_PSD_p2
{   /* Declarations of diffraction_detector_5=PSD_monitor() SETTING parameters. */
int nx = mccdiffraction_detector_5_nx;
int ny = mccdiffraction_detector_5_ny;
char* filename = mccdiffraction_detector_5_filename;
MCNUM xmin = mccdiffraction_detector_5_xmin;
MCNUM xmax = mccdiffraction_detector_5_xmax;
MCNUM ymin = mccdiffraction_detector_5_ymin;
MCNUM ymax = mccdiffraction_detector_5_ymax;
MCNUM xwidth = mccdiffraction_detector_5_xwidth;
MCNUM yheight = mccdiffraction_detector_5_yheight;
MCNUM restore_neutron = mccdiffraction_detector_5_restore_neutron;
#line 110 "/usr/share/mcstas/2.7/monitors/PSD_monitor.comp"
{
  DETECTOR_OUT_2D(
    "PSD monitor",
    "X position [cm]",
    "Y position [cm]",
    xmin*100.0, xmax*100.0, ymin*100.0, ymax*100.0,
    nx, ny,
    &PSD_N[0][0],&PSD_p[0][0],&PSD_p2[0][0],
    filename);
}
#line 472878 "MACS_sample_kidney_box.c"
}   /* End of diffraction_detector_5=PSD_monitor() SETTING parameter declarations. */
#undef PSD_p2
#undef PSD_p
#undef PSD_N
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

  /* User SAVE code for component 'spec_detector_5'. */
  SIG_MESSAGE("spec_detector_5 (Save)");
#define mccompcurname  spec_detector_5
#define mccompcurtype  PSD_monitor
#define mccompcurindex 896
#define PSD_N mccspec_detector_5_PSD_N
#define PSD_p mccspec_detector_5_PSD_p
#define PSD_p2 mccspec_detector_5_PSD_p2
{   /* Declarations of spec_detector_5=PSD_monitor() SETTING parameters. */
int nx = mccspec_detector_5_nx;
int ny = mccspec_detector_5_ny;
char* filename = mccspec_detector_5_filename;
MCNUM xmin = mccspec_detector_5_xmin;
MCNUM xmax = mccspec_detector_5_xmax;
MCNUM ymin = mccspec_detector_5_ymin;
MCNUM ymax = mccspec_detector_5_ymax;
MCNUM xwidth = mccspec_detector_5_xwidth;
MCNUM yheight = mccspec_detector_5_yheight;
MCNUM restore_neutron = mccspec_detector_5_restore_neutron;
#line 110 "/usr/share/mcstas/2.7/monitors/PSD_monitor.comp"
{
  DETECTOR_OUT_2D(
    "PSD monitor",
    "X position [cm]",
    "Y position [cm]",
    xmin*100.0, xmax*100.0, ymin*100.0, ymax*100.0,
    nx, ny,
    &PSD_N[0][0],&PSD_p[0][0],&PSD_p2[0][0],
    filename);
}
#line 472917 "MACS_sample_kidney_box.c"
}   /* End of spec_detector_5=PSD_monitor() SETTING parameter declarations. */
#undef PSD_p2
#undef PSD_p
#undef PSD_N
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

  /* User SAVE code for component 'diffraction_detector_6'. */
  SIG_MESSAGE("diffraction_detector_6 (Save)");
#define mccompcurname  diffraction_detector_6
#define mccompcurtype  PSD_monitor
#define mccompcurindex 897
#define PSD_N mccdiffraction_detector_6_PSD_N
#define PSD_p mccdiffraction_detector_6_PSD_p
#define PSD_p2 mccdiffraction_detector_6_PSD_p2
{   /* Declarations of diffraction_detector_6=PSD_monitor() SETTING parameters. */
int nx = mccdiffraction_detector_6_nx;
int ny = mccdiffraction_detector_6_ny;
char* filename = mccdiffraction_detector_6_filename;
MCNUM xmin = mccdiffraction_detector_6_xmin;
MCNUM xmax = mccdiffraction_detector_6_xmax;
MCNUM ymin = mccdiffraction_detector_6_ymin;
MCNUM ymax = mccdiffraction_detector_6_ymax;
MCNUM xwidth = mccdiffraction_detector_6_xwidth;
MCNUM yheight = mccdiffraction_detector_6_yheight;
MCNUM restore_neutron = mccdiffraction_detector_6_restore_neutron;
#line 110 "/usr/share/mcstas/2.7/monitors/PSD_monitor.comp"
{
  DETECTOR_OUT_2D(
    "PSD monitor",
    "X position [cm]",
    "Y position [cm]",
    xmin*100.0, xmax*100.0, ymin*100.0, ymax*100.0,
    nx, ny,
    &PSD_N[0][0],&PSD_p[0][0],&PSD_p2[0][0],
    filename);
}
#line 472956 "MACS_sample_kidney_box.c"
}   /* End of diffraction_detector_6=PSD_monitor() SETTING parameter declarations. */
#undef PSD_p2
#undef PSD_p
#undef PSD_N
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

  /* User SAVE code for component 'spec_detector_6'. */
  SIG_MESSAGE("spec_detector_6 (Save)");
#define mccompcurname  spec_detector_6
#define mccompcurtype  PSD_monitor
#define mccompcurindex 898
#define PSD_N mccspec_detector_6_PSD_N
#define PSD_p mccspec_detector_6_PSD_p
#define PSD_p2 mccspec_detector_6_PSD_p2
{   /* Declarations of spec_detector_6=PSD_monitor() SETTING parameters. */
int nx = mccspec_detector_6_nx;
int ny = mccspec_detector_6_ny;
char* filename = mccspec_detector_6_filename;
MCNUM xmin = mccspec_detector_6_xmin;
MCNUM xmax = mccspec_detector_6_xmax;
MCNUM ymin = mccspec_detector_6_ymin;
MCNUM ymax = mccspec_detector_6_ymax;
MCNUM xwidth = mccspec_detector_6_xwidth;
MCNUM yheight = mccspec_detector_6_yheight;
MCNUM restore_neutron = mccspec_detector_6_restore_neutron;
#line 110 "/usr/share/mcstas/2.7/monitors/PSD_monitor.comp"
{
  DETECTOR_OUT_2D(
    "PSD monitor",
    "X position [cm]",
    "Y position [cm]",
    xmin*100.0, xmax*100.0, ymin*100.0, ymax*100.0,
    nx, ny,
    &PSD_N[0][0],&PSD_p[0][0],&PSD_p2[0][0],
    filename);
}
#line 472995 "MACS_sample_kidney_box.c"
}   /* End of spec_detector_6=PSD_monitor() SETTING parameter declarations. */
#undef PSD_p2
#undef PSD_p
#undef PSD_N
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

  /* User SAVE code for component 'diffraction_detector_7'. */
  SIG_MESSAGE("diffraction_detector_7 (Save)");
#define mccompcurname  diffraction_detector_7
#define mccompcurtype  PSD_monitor
#define mccompcurindex 899
#define PSD_N mccdiffraction_detector_7_PSD_N
#define PSD_p mccdiffraction_detector_7_PSD_p
#define PSD_p2 mccdiffraction_detector_7_PSD_p2
{   /* Declarations of diffraction_detector_7=PSD_monitor() SETTING parameters. */
int nx = mccdiffraction_detector_7_nx;
int ny = mccdiffraction_detector_7_ny;
char* filename = mccdiffraction_detector_7_filename;
MCNUM xmin = mccdiffraction_detector_7_xmin;
MCNUM xmax = mccdiffraction_detector_7_xmax;
MCNUM ymin = mccdiffraction_detector_7_ymin;
MCNUM ymax = mccdiffraction_detector_7_ymax;
MCNUM xwidth = mccdiffraction_detector_7_xwidth;
MCNUM yheight = mccdiffraction_detector_7_yheight;
MCNUM restore_neutron = mccdiffraction_detector_7_restore_neutron;
#line 110 "/usr/share/mcstas/2.7/monitors/PSD_monitor.comp"
{
  DETECTOR_OUT_2D(
    "PSD monitor",
    "X position [cm]",
    "Y position [cm]",
    xmin*100.0, xmax*100.0, ymin*100.0, ymax*100.0,
    nx, ny,
    &PSD_N[0][0],&PSD_p[0][0],&PSD_p2[0][0],
    filename);
}
#line 473034 "MACS_sample_kidney_box.c"
}   /* End of diffraction_detector_7=PSD_monitor() SETTING parameter declarations. */
#undef PSD_p2
#undef PSD_p
#undef PSD_N
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

  /* User SAVE code for component 'spec_detector_7'. */
  SIG_MESSAGE("spec_detector_7 (Save)");
#define mccompcurname  spec_detector_7
#define mccompcurtype  PSD_monitor
#define mccompcurindex 900
#define PSD_N mccspec_detector_7_PSD_N
#define PSD_p mccspec_detector_7_PSD_p
#define PSD_p2 mccspec_detector_7_PSD_p2
{   /* Declarations of spec_detector_7=PSD_monitor() SETTING parameters. */
int nx = mccspec_detector_7_nx;
int ny = mccspec_detector_7_ny;
char* filename = mccspec_detector_7_filename;
MCNUM xmin = mccspec_detector_7_xmin;
MCNUM xmax = mccspec_detector_7_xmax;
MCNUM ymin = mccspec_detector_7_ymin;
MCNUM ymax = mccspec_detector_7_ymax;
MCNUM xwidth = mccspec_detector_7_xwidth;
MCNUM yheight = mccspec_detector_7_yheight;
MCNUM restore_neutron = mccspec_detector_7_restore_neutron;
#line 110 "/usr/share/mcstas/2.7/monitors/PSD_monitor.comp"
{
  DETECTOR_OUT_2D(
    "PSD monitor",
    "X position [cm]",
    "Y position [cm]",
    xmin*100.0, xmax*100.0, ymin*100.0, ymax*100.0,
    nx, ny,
    &PSD_N[0][0],&PSD_p[0][0],&PSD_p2[0][0],
    filename);
}
#line 473073 "MACS_sample_kidney_box.c"
}   /* End of spec_detector_7=PSD_monitor() SETTING parameter declarations. */
#undef PSD_p2
#undef PSD_p
#undef PSD_N
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

  /* User SAVE code for component 'diffraction_detector_8'. */
  SIG_MESSAGE("diffraction_detector_8 (Save)");
#define mccompcurname  diffraction_detector_8
#define mccompcurtype  PSD_monitor
#define mccompcurindex 901
#define PSD_N mccdiffraction_detector_8_PSD_N
#define PSD_p mccdiffraction_detector_8_PSD_p
#define PSD_p2 mccdiffraction_detector_8_PSD_p2
{   /* Declarations of diffraction_detector_8=PSD_monitor() SETTING parameters. */
int nx = mccdiffraction_detector_8_nx;
int ny = mccdiffraction_detector_8_ny;
char* filename = mccdiffraction_detector_8_filename;
MCNUM xmin = mccdiffraction_detector_8_xmin;
MCNUM xmax = mccdiffraction_detector_8_xmax;
MCNUM ymin = mccdiffraction_detector_8_ymin;
MCNUM ymax = mccdiffraction_detector_8_ymax;
MCNUM xwidth = mccdiffraction_detector_8_xwidth;
MCNUM yheight = mccdiffraction_detector_8_yheight;
MCNUM restore_neutron = mccdiffraction_detector_8_restore_neutron;
#line 110 "/usr/share/mcstas/2.7/monitors/PSD_monitor.comp"
{
  DETECTOR_OUT_2D(
    "PSD monitor",
    "X position [cm]",
    "Y position [cm]",
    xmin*100.0, xmax*100.0, ymin*100.0, ymax*100.0,
    nx, ny,
    &PSD_N[0][0],&PSD_p[0][0],&PSD_p2[0][0],
    filename);
}
#line 473112 "MACS_sample_kidney_box.c"
}   /* End of diffraction_detector_8=PSD_monitor() SETTING parameter declarations. */
#undef PSD_p2
#undef PSD_p
#undef PSD_N
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

  /* User SAVE code for component 'spec_detector_8'. */
  SIG_MESSAGE("spec_detector_8 (Save)");
#define mccompcurname  spec_detector_8
#define mccompcurtype  PSD_monitor
#define mccompcurindex 902
#define PSD_N mccspec_detector_8_PSD_N
#define PSD_p mccspec_detector_8_PSD_p
#define PSD_p2 mccspec_detector_8_PSD_p2
{   /* Declarations of spec_detector_8=PSD_monitor() SETTING parameters. */
int nx = mccspec_detector_8_nx;
int ny = mccspec_detector_8_ny;
char* filename = mccspec_detector_8_filename;
MCNUM xmin = mccspec_detector_8_xmin;
MCNUM xmax = mccspec_detector_8_xmax;
MCNUM ymin = mccspec_detector_8_ymin;
MCNUM ymax = mccspec_detector_8_ymax;
MCNUM xwidth = mccspec_detector_8_xwidth;
MCNUM yheight = mccspec_detector_8_yheight;
MCNUM restore_neutron = mccspec_detector_8_restore_neutron;
#line 110 "/usr/share/mcstas/2.7/monitors/PSD_monitor.comp"
{
  DETECTOR_OUT_2D(
    "PSD monitor",
    "X position [cm]",
    "Y position [cm]",
    xmin*100.0, xmax*100.0, ymin*100.0, ymax*100.0,
    nx, ny,
    &PSD_N[0][0],&PSD_p[0][0],&PSD_p2[0][0],
    filename);
}
#line 473151 "MACS_sample_kidney_box.c"
}   /* End of spec_detector_8=PSD_monitor() SETTING parameter declarations. */
#undef PSD_p2
#undef PSD_p
#undef PSD_N
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

  /* User SAVE code for component 'diffraction_detector_9'. */
  SIG_MESSAGE("diffraction_detector_9 (Save)");
#define mccompcurname  diffraction_detector_9
#define mccompcurtype  PSD_monitor
#define mccompcurindex 903
#define PSD_N mccdiffraction_detector_9_PSD_N
#define PSD_p mccdiffraction_detector_9_PSD_p
#define PSD_p2 mccdiffraction_detector_9_PSD_p2
{   /* Declarations of diffraction_detector_9=PSD_monitor() SETTING parameters. */
int nx = mccdiffraction_detector_9_nx;
int ny = mccdiffraction_detector_9_ny;
char* filename = mccdiffraction_detector_9_filename;
MCNUM xmin = mccdiffraction_detector_9_xmin;
MCNUM xmax = mccdiffraction_detector_9_xmax;
MCNUM ymin = mccdiffraction_detector_9_ymin;
MCNUM ymax = mccdiffraction_detector_9_ymax;
MCNUM xwidth = mccdiffraction_detector_9_xwidth;
MCNUM yheight = mccdiffraction_detector_9_yheight;
MCNUM restore_neutron = mccdiffraction_detector_9_restore_neutron;
#line 110 "/usr/share/mcstas/2.7/monitors/PSD_monitor.comp"
{
  DETECTOR_OUT_2D(
    "PSD monitor",
    "X position [cm]",
    "Y position [cm]",
    xmin*100.0, xmax*100.0, ymin*100.0, ymax*100.0,
    nx, ny,
    &PSD_N[0][0],&PSD_p[0][0],&PSD_p2[0][0],
    filename);
}
#line 473190 "MACS_sample_kidney_box.c"
}   /* End of diffraction_detector_9=PSD_monitor() SETTING parameter declarations. */
#undef PSD_p2
#undef PSD_p
#undef PSD_N
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

  /* User SAVE code for component 'spec_detector_9'. */
  SIG_MESSAGE("spec_detector_9 (Save)");
#define mccompcurname  spec_detector_9
#define mccompcurtype  PSD_monitor
#define mccompcurindex 904
#define PSD_N mccspec_detector_9_PSD_N
#define PSD_p mccspec_detector_9_PSD_p
#define PSD_p2 mccspec_detector_9_PSD_p2
{   /* Declarations of spec_detector_9=PSD_monitor() SETTING parameters. */
int nx = mccspec_detector_9_nx;
int ny = mccspec_detector_9_ny;
char* filename = mccspec_detector_9_filename;
MCNUM xmin = mccspec_detector_9_xmin;
MCNUM xmax = mccspec_detector_9_xmax;
MCNUM ymin = mccspec_detector_9_ymin;
MCNUM ymax = mccspec_detector_9_ymax;
MCNUM xwidth = mccspec_detector_9_xwidth;
MCNUM yheight = mccspec_detector_9_yheight;
MCNUM restore_neutron = mccspec_detector_9_restore_neutron;
#line 110 "/usr/share/mcstas/2.7/monitors/PSD_monitor.comp"
{
  DETECTOR_OUT_2D(
    "PSD monitor",
    "X position [cm]",
    "Y position [cm]",
    xmin*100.0, xmax*100.0, ymin*100.0, ymax*100.0,
    nx, ny,
    &PSD_N[0][0],&PSD_p[0][0],&PSD_p2[0][0],
    filename);
}
#line 473229 "MACS_sample_kidney_box.c"
}   /* End of spec_detector_9=PSD_monitor() SETTING parameter declarations. */
#undef PSD_p2
#undef PSD_p
#undef PSD_N
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

  /* User SAVE code for component 'diffraction_detector_10'. */
  SIG_MESSAGE("diffraction_detector_10 (Save)");
#define mccompcurname  diffraction_detector_10
#define mccompcurtype  PSD_monitor
#define mccompcurindex 905
#define PSD_N mccdiffraction_detector_10_PSD_N
#define PSD_p mccdiffraction_detector_10_PSD_p
#define PSD_p2 mccdiffraction_detector_10_PSD_p2
{   /* Declarations of diffraction_detector_10=PSD_monitor() SETTING parameters. */
int nx = mccdiffraction_detector_10_nx;
int ny = mccdiffraction_detector_10_ny;
char* filename = mccdiffraction_detector_10_filename;
MCNUM xmin = mccdiffraction_detector_10_xmin;
MCNUM xmax = mccdiffraction_detector_10_xmax;
MCNUM ymin = mccdiffraction_detector_10_ymin;
MCNUM ymax = mccdiffraction_detector_10_ymax;
MCNUM xwidth = mccdiffraction_detector_10_xwidth;
MCNUM yheight = mccdiffraction_detector_10_yheight;
MCNUM restore_neutron = mccdiffraction_detector_10_restore_neutron;
#line 110 "/usr/share/mcstas/2.7/monitors/PSD_monitor.comp"
{
  DETECTOR_OUT_2D(
    "PSD monitor",
    "X position [cm]",
    "Y position [cm]",
    xmin*100.0, xmax*100.0, ymin*100.0, ymax*100.0,
    nx, ny,
    &PSD_N[0][0],&PSD_p[0][0],&PSD_p2[0][0],
    filename);
}
#line 473268 "MACS_sample_kidney_box.c"
}   /* End of diffraction_detector_10=PSD_monitor() SETTING parameter declarations. */
#undef PSD_p2
#undef PSD_p
#undef PSD_N
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

  /* User SAVE code for component 'spec_detector_10'. */
  SIG_MESSAGE("spec_detector_10 (Save)");
#define mccompcurname  spec_detector_10
#define mccompcurtype  PSD_monitor
#define mccompcurindex 906
#define PSD_N mccspec_detector_10_PSD_N
#define PSD_p mccspec_detector_10_PSD_p
#define PSD_p2 mccspec_detector_10_PSD_p2
{   /* Declarations of spec_detector_10=PSD_monitor() SETTING parameters. */
int nx = mccspec_detector_10_nx;
int ny = mccspec_detector_10_ny;
char* filename = mccspec_detector_10_filename;
MCNUM xmin = mccspec_detector_10_xmin;
MCNUM xmax = mccspec_detector_10_xmax;
MCNUM ymin = mccspec_detector_10_ymin;
MCNUM ymax = mccspec_detector_10_ymax;
MCNUM xwidth = mccspec_detector_10_xwidth;
MCNUM yheight = mccspec_detector_10_yheight;
MCNUM restore_neutron = mccspec_detector_10_restore_neutron;
#line 110 "/usr/share/mcstas/2.7/monitors/PSD_monitor.comp"
{
  DETECTOR_OUT_2D(
    "PSD monitor",
    "X position [cm]",
    "Y position [cm]",
    xmin*100.0, xmax*100.0, ymin*100.0, ymax*100.0,
    nx, ny,
    &PSD_N[0][0],&PSD_p[0][0],&PSD_p2[0][0],
    filename);
}
#line 473307 "MACS_sample_kidney_box.c"
}   /* End of spec_detector_10=PSD_monitor() SETTING parameter declarations. */
#undef PSD_p2
#undef PSD_p
#undef PSD_N
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

  /* User SAVE code for component 'diffraction_detector_11'. */
  SIG_MESSAGE("diffraction_detector_11 (Save)");
#define mccompcurname  diffraction_detector_11
#define mccompcurtype  PSD_monitor
#define mccompcurindex 907
#define PSD_N mccdiffraction_detector_11_PSD_N
#define PSD_p mccdiffraction_detector_11_PSD_p
#define PSD_p2 mccdiffraction_detector_11_PSD_p2
{   /* Declarations of diffraction_detector_11=PSD_monitor() SETTING parameters. */
int nx = mccdiffraction_detector_11_nx;
int ny = mccdiffraction_detector_11_ny;
char* filename = mccdiffraction_detector_11_filename;
MCNUM xmin = mccdiffraction_detector_11_xmin;
MCNUM xmax = mccdiffraction_detector_11_xmax;
MCNUM ymin = mccdiffraction_detector_11_ymin;
MCNUM ymax = mccdiffraction_detector_11_ymax;
MCNUM xwidth = mccdiffraction_detector_11_xwidth;
MCNUM yheight = mccdiffraction_detector_11_yheight;
MCNUM restore_neutron = mccdiffraction_detector_11_restore_neutron;
#line 110 "/usr/share/mcstas/2.7/monitors/PSD_monitor.comp"
{
  DETECTOR_OUT_2D(
    "PSD monitor",
    "X position [cm]",
    "Y position [cm]",
    xmin*100.0, xmax*100.0, ymin*100.0, ymax*100.0,
    nx, ny,
    &PSD_N[0][0],&PSD_p[0][0],&PSD_p2[0][0],
    filename);
}
#line 473346 "MACS_sample_kidney_box.c"
}   /* End of diffraction_detector_11=PSD_monitor() SETTING parameter declarations. */
#undef PSD_p2
#undef PSD_p
#undef PSD_N
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

  /* User SAVE code for component 'spec_detector_11'. */
  SIG_MESSAGE("spec_detector_11 (Save)");
#define mccompcurname  spec_detector_11
#define mccompcurtype  PSD_monitor
#define mccompcurindex 908
#define PSD_N mccspec_detector_11_PSD_N
#define PSD_p mccspec_detector_11_PSD_p
#define PSD_p2 mccspec_detector_11_PSD_p2
{   /* Declarations of spec_detector_11=PSD_monitor() SETTING parameters. */
int nx = mccspec_detector_11_nx;
int ny = mccspec_detector_11_ny;
char* filename = mccspec_detector_11_filename;
MCNUM xmin = mccspec_detector_11_xmin;
MCNUM xmax = mccspec_detector_11_xmax;
MCNUM ymin = mccspec_detector_11_ymin;
MCNUM ymax = mccspec_detector_11_ymax;
MCNUM xwidth = mccspec_detector_11_xwidth;
MCNUM yheight = mccspec_detector_11_yheight;
MCNUM restore_neutron = mccspec_detector_11_restore_neutron;
#line 110 "/usr/share/mcstas/2.7/monitors/PSD_monitor.comp"
{
  DETECTOR_OUT_2D(
    "PSD monitor",
    "X position [cm]",
    "Y position [cm]",
    xmin*100.0, xmax*100.0, ymin*100.0, ymax*100.0,
    nx, ny,
    &PSD_N[0][0],&PSD_p[0][0],&PSD_p2[0][0],
    filename);
}
#line 473385 "MACS_sample_kidney_box.c"
}   /* End of spec_detector_11=PSD_monitor() SETTING parameter declarations. */
#undef PSD_p2
#undef PSD_p
#undef PSD_N
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

  /* User SAVE code for component 'diffraction_detector_12'. */
  SIG_MESSAGE("diffraction_detector_12 (Save)");
#define mccompcurname  diffraction_detector_12
#define mccompcurtype  PSD_monitor
#define mccompcurindex 909
#define PSD_N mccdiffraction_detector_12_PSD_N
#define PSD_p mccdiffraction_detector_12_PSD_p
#define PSD_p2 mccdiffraction_detector_12_PSD_p2
{   /* Declarations of diffraction_detector_12=PSD_monitor() SETTING parameters. */
int nx = mccdiffraction_detector_12_nx;
int ny = mccdiffraction_detector_12_ny;
char* filename = mccdiffraction_detector_12_filename;
MCNUM xmin = mccdiffraction_detector_12_xmin;
MCNUM xmax = mccdiffraction_detector_12_xmax;
MCNUM ymin = mccdiffraction_detector_12_ymin;
MCNUM ymax = mccdiffraction_detector_12_ymax;
MCNUM xwidth = mccdiffraction_detector_12_xwidth;
MCNUM yheight = mccdiffraction_detector_12_yheight;
MCNUM restore_neutron = mccdiffraction_detector_12_restore_neutron;
#line 110 "/usr/share/mcstas/2.7/monitors/PSD_monitor.comp"
{
  DETECTOR_OUT_2D(
    "PSD monitor",
    "X position [cm]",
    "Y position [cm]",
    xmin*100.0, xmax*100.0, ymin*100.0, ymax*100.0,
    nx, ny,
    &PSD_N[0][0],&PSD_p[0][0],&PSD_p2[0][0],
    filename);
}
#line 473424 "MACS_sample_kidney_box.c"
}   /* End of diffraction_detector_12=PSD_monitor() SETTING parameter declarations. */
#undef PSD_p2
#undef PSD_p
#undef PSD_N
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

  /* User SAVE code for component 'spec_detector_12'. */
  SIG_MESSAGE("spec_detector_12 (Save)");
#define mccompcurname  spec_detector_12
#define mccompcurtype  PSD_monitor
#define mccompcurindex 910
#define PSD_N mccspec_detector_12_PSD_N
#define PSD_p mccspec_detector_12_PSD_p
#define PSD_p2 mccspec_detector_12_PSD_p2
{   /* Declarations of spec_detector_12=PSD_monitor() SETTING parameters. */
int nx = mccspec_detector_12_nx;
int ny = mccspec_detector_12_ny;
char* filename = mccspec_detector_12_filename;
MCNUM xmin = mccspec_detector_12_xmin;
MCNUM xmax = mccspec_detector_12_xmax;
MCNUM ymin = mccspec_detector_12_ymin;
MCNUM ymax = mccspec_detector_12_ymax;
MCNUM xwidth = mccspec_detector_12_xwidth;
MCNUM yheight = mccspec_detector_12_yheight;
MCNUM restore_neutron = mccspec_detector_12_restore_neutron;
#line 110 "/usr/share/mcstas/2.7/monitors/PSD_monitor.comp"
{
  DETECTOR_OUT_2D(
    "PSD monitor",
    "X position [cm]",
    "Y position [cm]",
    xmin*100.0, xmax*100.0, ymin*100.0, ymax*100.0,
    nx, ny,
    &PSD_N[0][0],&PSD_p[0][0],&PSD_p2[0][0],
    filename);
}
#line 473463 "MACS_sample_kidney_box.c"
}   /* End of spec_detector_12=PSD_monitor() SETTING parameter declarations. */
#undef PSD_p2
#undef PSD_p
#undef PSD_N
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

  /* User SAVE code for component 'diffraction_detector_13'. */
  SIG_MESSAGE("diffraction_detector_13 (Save)");
#define mccompcurname  diffraction_detector_13
#define mccompcurtype  PSD_monitor
#define mccompcurindex 911
#define PSD_N mccdiffraction_detector_13_PSD_N
#define PSD_p mccdiffraction_detector_13_PSD_p
#define PSD_p2 mccdiffraction_detector_13_PSD_p2
{   /* Declarations of diffraction_detector_13=PSD_monitor() SETTING parameters. */
int nx = mccdiffraction_detector_13_nx;
int ny = mccdiffraction_detector_13_ny;
char* filename = mccdiffraction_detector_13_filename;
MCNUM xmin = mccdiffraction_detector_13_xmin;
MCNUM xmax = mccdiffraction_detector_13_xmax;
MCNUM ymin = mccdiffraction_detector_13_ymin;
MCNUM ymax = mccdiffraction_detector_13_ymax;
MCNUM xwidth = mccdiffraction_detector_13_xwidth;
MCNUM yheight = mccdiffraction_detector_13_yheight;
MCNUM restore_neutron = mccdiffraction_detector_13_restore_neutron;
#line 110 "/usr/share/mcstas/2.7/monitors/PSD_monitor.comp"
{
  DETECTOR_OUT_2D(
    "PSD monitor",
    "X position [cm]",
    "Y position [cm]",
    xmin*100.0, xmax*100.0, ymin*100.0, ymax*100.0,
    nx, ny,
    &PSD_N[0][0],&PSD_p[0][0],&PSD_p2[0][0],
    filename);
}
#line 473502 "MACS_sample_kidney_box.c"
}   /* End of diffraction_detector_13=PSD_monitor() SETTING parameter declarations. */
#undef PSD_p2
#undef PSD_p
#undef PSD_N
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

  /* User SAVE code for component 'spec_detector_13'. */
  SIG_MESSAGE("spec_detector_13 (Save)");
#define mccompcurname  spec_detector_13
#define mccompcurtype  PSD_monitor
#define mccompcurindex 912
#define PSD_N mccspec_detector_13_PSD_N
#define PSD_p mccspec_detector_13_PSD_p
#define PSD_p2 mccspec_detector_13_PSD_p2
{   /* Declarations of spec_detector_13=PSD_monitor() SETTING parameters. */
int nx = mccspec_detector_13_nx;
int ny = mccspec_detector_13_ny;
char* filename = mccspec_detector_13_filename;
MCNUM xmin = mccspec_detector_13_xmin;
MCNUM xmax = mccspec_detector_13_xmax;
MCNUM ymin = mccspec_detector_13_ymin;
MCNUM ymax = mccspec_detector_13_ymax;
MCNUM xwidth = mccspec_detector_13_xwidth;
MCNUM yheight = mccspec_detector_13_yheight;
MCNUM restore_neutron = mccspec_detector_13_restore_neutron;
#line 110 "/usr/share/mcstas/2.7/monitors/PSD_monitor.comp"
{
  DETECTOR_OUT_2D(
    "PSD monitor",
    "X position [cm]",
    "Y position [cm]",
    xmin*100.0, xmax*100.0, ymin*100.0, ymax*100.0,
    nx, ny,
    &PSD_N[0][0],&PSD_p[0][0],&PSD_p2[0][0],
    filename);
}
#line 473541 "MACS_sample_kidney_box.c"
}   /* End of spec_detector_13=PSD_monitor() SETTING parameter declarations. */
#undef PSD_p2
#undef PSD_p
#undef PSD_N
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

  /* User SAVE code for component 'diffraction_detector_14'. */
  SIG_MESSAGE("diffraction_detector_14 (Save)");
#define mccompcurname  diffraction_detector_14
#define mccompcurtype  PSD_monitor
#define mccompcurindex 913
#define PSD_N mccdiffraction_detector_14_PSD_N
#define PSD_p mccdiffraction_detector_14_PSD_p
#define PSD_p2 mccdiffraction_detector_14_PSD_p2
{   /* Declarations of diffraction_detector_14=PSD_monitor() SETTING parameters. */
int nx = mccdiffraction_detector_14_nx;
int ny = mccdiffraction_detector_14_ny;
char* filename = mccdiffraction_detector_14_filename;
MCNUM xmin = mccdiffraction_detector_14_xmin;
MCNUM xmax = mccdiffraction_detector_14_xmax;
MCNUM ymin = mccdiffraction_detector_14_ymin;
MCNUM ymax = mccdiffraction_detector_14_ymax;
MCNUM xwidth = mccdiffraction_detector_14_xwidth;
MCNUM yheight = mccdiffraction_detector_14_yheight;
MCNUM restore_neutron = mccdiffraction_detector_14_restore_neutron;
#line 110 "/usr/share/mcstas/2.7/monitors/PSD_monitor.comp"
{
  DETECTOR_OUT_2D(
    "PSD monitor",
    "X position [cm]",
    "Y position [cm]",
    xmin*100.0, xmax*100.0, ymin*100.0, ymax*100.0,
    nx, ny,
    &PSD_N[0][0],&PSD_p[0][0],&PSD_p2[0][0],
    filename);
}
#line 473580 "MACS_sample_kidney_box.c"
}   /* End of diffraction_detector_14=PSD_monitor() SETTING parameter declarations. */
#undef PSD_p2
#undef PSD_p
#undef PSD_N
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

  /* User SAVE code for component 'spec_detector_14'. */
  SIG_MESSAGE("spec_detector_14 (Save)");
#define mccompcurname  spec_detector_14
#define mccompcurtype  PSD_monitor
#define mccompcurindex 914
#define PSD_N mccspec_detector_14_PSD_N
#define PSD_p mccspec_detector_14_PSD_p
#define PSD_p2 mccspec_detector_14_PSD_p2
{   /* Declarations of spec_detector_14=PSD_monitor() SETTING parameters. */
int nx = mccspec_detector_14_nx;
int ny = mccspec_detector_14_ny;
char* filename = mccspec_detector_14_filename;
MCNUM xmin = mccspec_detector_14_xmin;
MCNUM xmax = mccspec_detector_14_xmax;
MCNUM ymin = mccspec_detector_14_ymin;
MCNUM ymax = mccspec_detector_14_ymax;
MCNUM xwidth = mccspec_detector_14_xwidth;
MCNUM yheight = mccspec_detector_14_yheight;
MCNUM restore_neutron = mccspec_detector_14_restore_neutron;
#line 110 "/usr/share/mcstas/2.7/monitors/PSD_monitor.comp"
{
  DETECTOR_OUT_2D(
    "PSD monitor",
    "X position [cm]",
    "Y position [cm]",
    xmin*100.0, xmax*100.0, ymin*100.0, ymax*100.0,
    nx, ny,
    &PSD_N[0][0],&PSD_p[0][0],&PSD_p2[0][0],
    filename);
}
#line 473619 "MACS_sample_kidney_box.c"
}   /* End of spec_detector_14=PSD_monitor() SETTING parameter declarations. */
#undef PSD_p2
#undef PSD_p
#undef PSD_N
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

  /* User SAVE code for component 'diffraction_detector_15'. */
  SIG_MESSAGE("diffraction_detector_15 (Save)");
#define mccompcurname  diffraction_detector_15
#define mccompcurtype  PSD_monitor
#define mccompcurindex 915
#define PSD_N mccdiffraction_detector_15_PSD_N
#define PSD_p mccdiffraction_detector_15_PSD_p
#define PSD_p2 mccdiffraction_detector_15_PSD_p2
{   /* Declarations of diffraction_detector_15=PSD_monitor() SETTING parameters. */
int nx = mccdiffraction_detector_15_nx;
int ny = mccdiffraction_detector_15_ny;
char* filename = mccdiffraction_detector_15_filename;
MCNUM xmin = mccdiffraction_detector_15_xmin;
MCNUM xmax = mccdiffraction_detector_15_xmax;
MCNUM ymin = mccdiffraction_detector_15_ymin;
MCNUM ymax = mccdiffraction_detector_15_ymax;
MCNUM xwidth = mccdiffraction_detector_15_xwidth;
MCNUM yheight = mccdiffraction_detector_15_yheight;
MCNUM restore_neutron = mccdiffraction_detector_15_restore_neutron;
#line 110 "/usr/share/mcstas/2.7/monitors/PSD_monitor.comp"
{
  DETECTOR_OUT_2D(
    "PSD monitor",
    "X position [cm]",
    "Y position [cm]",
    xmin*100.0, xmax*100.0, ymin*100.0, ymax*100.0,
    nx, ny,
    &PSD_N[0][0],&PSD_p[0][0],&PSD_p2[0][0],
    filename);
}
#line 473658 "MACS_sample_kidney_box.c"
}   /* End of diffraction_detector_15=PSD_monitor() SETTING parameter declarations. */
#undef PSD_p2
#undef PSD_p
#undef PSD_N
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

  /* User SAVE code for component 'spec_detector_15'. */
  SIG_MESSAGE("spec_detector_15 (Save)");
#define mccompcurname  spec_detector_15
#define mccompcurtype  PSD_monitor
#define mccompcurindex 916
#define PSD_N mccspec_detector_15_PSD_N
#define PSD_p mccspec_detector_15_PSD_p
#define PSD_p2 mccspec_detector_15_PSD_p2
{   /* Declarations of spec_detector_15=PSD_monitor() SETTING parameters. */
int nx = mccspec_detector_15_nx;
int ny = mccspec_detector_15_ny;
char* filename = mccspec_detector_15_filename;
MCNUM xmin = mccspec_detector_15_xmin;
MCNUM xmax = mccspec_detector_15_xmax;
MCNUM ymin = mccspec_detector_15_ymin;
MCNUM ymax = mccspec_detector_15_ymax;
MCNUM xwidth = mccspec_detector_15_xwidth;
MCNUM yheight = mccspec_detector_15_yheight;
MCNUM restore_neutron = mccspec_detector_15_restore_neutron;
#line 110 "/usr/share/mcstas/2.7/monitors/PSD_monitor.comp"
{
  DETECTOR_OUT_2D(
    "PSD monitor",
    "X position [cm]",
    "Y position [cm]",
    xmin*100.0, xmax*100.0, ymin*100.0, ymax*100.0,
    nx, ny,
    &PSD_N[0][0],&PSD_p[0][0],&PSD_p2[0][0],
    filename);
}
#line 473697 "MACS_sample_kidney_box.c"
}   /* End of spec_detector_15=PSD_monitor() SETTING parameter declarations. */
#undef PSD_p2
#undef PSD_p
#undef PSD_N
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

  /* User SAVE code for component 'diffraction_detector_16'. */
  SIG_MESSAGE("diffraction_detector_16 (Save)");
#define mccompcurname  diffraction_detector_16
#define mccompcurtype  PSD_monitor
#define mccompcurindex 917
#define PSD_N mccdiffraction_detector_16_PSD_N
#define PSD_p mccdiffraction_detector_16_PSD_p
#define PSD_p2 mccdiffraction_detector_16_PSD_p2
{   /* Declarations of diffraction_detector_16=PSD_monitor() SETTING parameters. */
int nx = mccdiffraction_detector_16_nx;
int ny = mccdiffraction_detector_16_ny;
char* filename = mccdiffraction_detector_16_filename;
MCNUM xmin = mccdiffraction_detector_16_xmin;
MCNUM xmax = mccdiffraction_detector_16_xmax;
MCNUM ymin = mccdiffraction_detector_16_ymin;
MCNUM ymax = mccdiffraction_detector_16_ymax;
MCNUM xwidth = mccdiffraction_detector_16_xwidth;
MCNUM yheight = mccdiffraction_detector_16_yheight;
MCNUM restore_neutron = mccdiffraction_detector_16_restore_neutron;
#line 110 "/usr/share/mcstas/2.7/monitors/PSD_monitor.comp"
{
  DETECTOR_OUT_2D(
    "PSD monitor",
    "X position [cm]",
    "Y position [cm]",
    xmin*100.0, xmax*100.0, ymin*100.0, ymax*100.0,
    nx, ny,
    &PSD_N[0][0],&PSD_p[0][0],&PSD_p2[0][0],
    filename);
}
#line 473736 "MACS_sample_kidney_box.c"
}   /* End of diffraction_detector_16=PSD_monitor() SETTING parameter declarations. */
#undef PSD_p2
#undef PSD_p
#undef PSD_N
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

  /* User SAVE code for component 'spec_detector_16'. */
  SIG_MESSAGE("spec_detector_16 (Save)");
#define mccompcurname  spec_detector_16
#define mccompcurtype  PSD_monitor
#define mccompcurindex 918
#define PSD_N mccspec_detector_16_PSD_N
#define PSD_p mccspec_detector_16_PSD_p
#define PSD_p2 mccspec_detector_16_PSD_p2
{   /* Declarations of spec_detector_16=PSD_monitor() SETTING parameters. */
int nx = mccspec_detector_16_nx;
int ny = mccspec_detector_16_ny;
char* filename = mccspec_detector_16_filename;
MCNUM xmin = mccspec_detector_16_xmin;
MCNUM xmax = mccspec_detector_16_xmax;
MCNUM ymin = mccspec_detector_16_ymin;
MCNUM ymax = mccspec_detector_16_ymax;
MCNUM xwidth = mccspec_detector_16_xwidth;
MCNUM yheight = mccspec_detector_16_yheight;
MCNUM restore_neutron = mccspec_detector_16_restore_neutron;
#line 110 "/usr/share/mcstas/2.7/monitors/PSD_monitor.comp"
{
  DETECTOR_OUT_2D(
    "PSD monitor",
    "X position [cm]",
    "Y position [cm]",
    xmin*100.0, xmax*100.0, ymin*100.0, ymax*100.0,
    nx, ny,
    &PSD_N[0][0],&PSD_p[0][0],&PSD_p2[0][0],
    filename);
}
#line 473775 "MACS_sample_kidney_box.c"
}   /* End of spec_detector_16=PSD_monitor() SETTING parameter declarations. */
#undef PSD_p2
#undef PSD_p
#undef PSD_N
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

  /* User SAVE code for component 'diffraction_detector_17'. */
  SIG_MESSAGE("diffraction_detector_17 (Save)");
#define mccompcurname  diffraction_detector_17
#define mccompcurtype  PSD_monitor
#define mccompcurindex 919
#define PSD_N mccdiffraction_detector_17_PSD_N
#define PSD_p mccdiffraction_detector_17_PSD_p
#define PSD_p2 mccdiffraction_detector_17_PSD_p2
{   /* Declarations of diffraction_detector_17=PSD_monitor() SETTING parameters. */
int nx = mccdiffraction_detector_17_nx;
int ny = mccdiffraction_detector_17_ny;
char* filename = mccdiffraction_detector_17_filename;
MCNUM xmin = mccdiffraction_detector_17_xmin;
MCNUM xmax = mccdiffraction_detector_17_xmax;
MCNUM ymin = mccdiffraction_detector_17_ymin;
MCNUM ymax = mccdiffraction_detector_17_ymax;
MCNUM xwidth = mccdiffraction_detector_17_xwidth;
MCNUM yheight = mccdiffraction_detector_17_yheight;
MCNUM restore_neutron = mccdiffraction_detector_17_restore_neutron;
#line 110 "/usr/share/mcstas/2.7/monitors/PSD_monitor.comp"
{
  DETECTOR_OUT_2D(
    "PSD monitor",
    "X position [cm]",
    "Y position [cm]",
    xmin*100.0, xmax*100.0, ymin*100.0, ymax*100.0,
    nx, ny,
    &PSD_N[0][0],&PSD_p[0][0],&PSD_p2[0][0],
    filename);
}
#line 473814 "MACS_sample_kidney_box.c"
}   /* End of diffraction_detector_17=PSD_monitor() SETTING parameter declarations. */
#undef PSD_p2
#undef PSD_p
#undef PSD_N
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

  /* User SAVE code for component 'spec_detector_17'. */
  SIG_MESSAGE("spec_detector_17 (Save)");
#define mccompcurname  spec_detector_17
#define mccompcurtype  PSD_monitor
#define mccompcurindex 920
#define PSD_N mccspec_detector_17_PSD_N
#define PSD_p mccspec_detector_17_PSD_p
#define PSD_p2 mccspec_detector_17_PSD_p2
{   /* Declarations of spec_detector_17=PSD_monitor() SETTING parameters. */
int nx = mccspec_detector_17_nx;
int ny = mccspec_detector_17_ny;
char* filename = mccspec_detector_17_filename;
MCNUM xmin = mccspec_detector_17_xmin;
MCNUM xmax = mccspec_detector_17_xmax;
MCNUM ymin = mccspec_detector_17_ymin;
MCNUM ymax = mccspec_detector_17_ymax;
MCNUM xwidth = mccspec_detector_17_xwidth;
MCNUM yheight = mccspec_detector_17_yheight;
MCNUM restore_neutron = mccspec_detector_17_restore_neutron;
#line 110 "/usr/share/mcstas/2.7/monitors/PSD_monitor.comp"
{
  DETECTOR_OUT_2D(
    "PSD monitor",
    "X position [cm]",
    "Y position [cm]",
    xmin*100.0, xmax*100.0, ymin*100.0, ymax*100.0,
    nx, ny,
    &PSD_N[0][0],&PSD_p[0][0],&PSD_p2[0][0],
    filename);
}
#line 473853 "MACS_sample_kidney_box.c"
}   /* End of spec_detector_17=PSD_monitor() SETTING parameter declarations. */
#undef PSD_p2
#undef PSD_p
#undef PSD_N
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

  /* User SAVE code for component 'diffraction_detector_18'. */
  SIG_MESSAGE("diffraction_detector_18 (Save)");
#define mccompcurname  diffraction_detector_18
#define mccompcurtype  PSD_monitor
#define mccompcurindex 921
#define PSD_N mccdiffraction_detector_18_PSD_N
#define PSD_p mccdiffraction_detector_18_PSD_p
#define PSD_p2 mccdiffraction_detector_18_PSD_p2
{   /* Declarations of diffraction_detector_18=PSD_monitor() SETTING parameters. */
int nx = mccdiffraction_detector_18_nx;
int ny = mccdiffraction_detector_18_ny;
char* filename = mccdiffraction_detector_18_filename;
MCNUM xmin = mccdiffraction_detector_18_xmin;
MCNUM xmax = mccdiffraction_detector_18_xmax;
MCNUM ymin = mccdiffraction_detector_18_ymin;
MCNUM ymax = mccdiffraction_detector_18_ymax;
MCNUM xwidth = mccdiffraction_detector_18_xwidth;
MCNUM yheight = mccdiffraction_detector_18_yheight;
MCNUM restore_neutron = mccdiffraction_detector_18_restore_neutron;
#line 110 "/usr/share/mcstas/2.7/monitors/PSD_monitor.comp"
{
  DETECTOR_OUT_2D(
    "PSD monitor",
    "X position [cm]",
    "Y position [cm]",
    xmin*100.0, xmax*100.0, ymin*100.0, ymax*100.0,
    nx, ny,
    &PSD_N[0][0],&PSD_p[0][0],&PSD_p2[0][0],
    filename);
}
#line 473892 "MACS_sample_kidney_box.c"
}   /* End of diffraction_detector_18=PSD_monitor() SETTING parameter declarations. */
#undef PSD_p2
#undef PSD_p
#undef PSD_N
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

  /* User SAVE code for component 'spec_detector_18'. */
  SIG_MESSAGE("spec_detector_18 (Save)");
#define mccompcurname  spec_detector_18
#define mccompcurtype  PSD_monitor
#define mccompcurindex 922
#define PSD_N mccspec_detector_18_PSD_N
#define PSD_p mccspec_detector_18_PSD_p
#define PSD_p2 mccspec_detector_18_PSD_p2
{   /* Declarations of spec_detector_18=PSD_monitor() SETTING parameters. */
int nx = mccspec_detector_18_nx;
int ny = mccspec_detector_18_ny;
char* filename = mccspec_detector_18_filename;
MCNUM xmin = mccspec_detector_18_xmin;
MCNUM xmax = mccspec_detector_18_xmax;
MCNUM ymin = mccspec_detector_18_ymin;
MCNUM ymax = mccspec_detector_18_ymax;
MCNUM xwidth = mccspec_detector_18_xwidth;
MCNUM yheight = mccspec_detector_18_yheight;
MCNUM restore_neutron = mccspec_detector_18_restore_neutron;
#line 110 "/usr/share/mcstas/2.7/monitors/PSD_monitor.comp"
{
  DETECTOR_OUT_2D(
    "PSD monitor",
    "X position [cm]",
    "Y position [cm]",
    xmin*100.0, xmax*100.0, ymin*100.0, ymax*100.0,
    nx, ny,
    &PSD_N[0][0],&PSD_p[0][0],&PSD_p2[0][0],
    filename);
}
#line 473931 "MACS_sample_kidney_box.c"
}   /* End of spec_detector_18=PSD_monitor() SETTING parameter declarations. */
#undef PSD_p2
#undef PSD_p
#undef PSD_N
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

  /* User SAVE code for component 'diffraction_detector_19'. */
  SIG_MESSAGE("diffraction_detector_19 (Save)");
#define mccompcurname  diffraction_detector_19
#define mccompcurtype  PSD_monitor
#define mccompcurindex 923
#define PSD_N mccdiffraction_detector_19_PSD_N
#define PSD_p mccdiffraction_detector_19_PSD_p
#define PSD_p2 mccdiffraction_detector_19_PSD_p2
{   /* Declarations of diffraction_detector_19=PSD_monitor() SETTING parameters. */
int nx = mccdiffraction_detector_19_nx;
int ny = mccdiffraction_detector_19_ny;
char* filename = mccdiffraction_detector_19_filename;
MCNUM xmin = mccdiffraction_detector_19_xmin;
MCNUM xmax = mccdiffraction_detector_19_xmax;
MCNUM ymin = mccdiffraction_detector_19_ymin;
MCNUM ymax = mccdiffraction_detector_19_ymax;
MCNUM xwidth = mccdiffraction_detector_19_xwidth;
MCNUM yheight = mccdiffraction_detector_19_yheight;
MCNUM restore_neutron = mccdiffraction_detector_19_restore_neutron;
#line 110 "/usr/share/mcstas/2.7/monitors/PSD_monitor.comp"
{
  DETECTOR_OUT_2D(
    "PSD monitor",
    "X position [cm]",
    "Y position [cm]",
    xmin*100.0, xmax*100.0, ymin*100.0, ymax*100.0,
    nx, ny,
    &PSD_N[0][0],&PSD_p[0][0],&PSD_p2[0][0],
    filename);
}
#line 473970 "MACS_sample_kidney_box.c"
}   /* End of diffraction_detector_19=PSD_monitor() SETTING parameter declarations. */
#undef PSD_p2
#undef PSD_p
#undef PSD_N
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

  /* User SAVE code for component 'spec_detector_19'. */
  SIG_MESSAGE("spec_detector_19 (Save)");
#define mccompcurname  spec_detector_19
#define mccompcurtype  PSD_monitor
#define mccompcurindex 924
#define PSD_N mccspec_detector_19_PSD_N
#define PSD_p mccspec_detector_19_PSD_p
#define PSD_p2 mccspec_detector_19_PSD_p2
{   /* Declarations of spec_detector_19=PSD_monitor() SETTING parameters. */
int nx = mccspec_detector_19_nx;
int ny = mccspec_detector_19_ny;
char* filename = mccspec_detector_19_filename;
MCNUM xmin = mccspec_detector_19_xmin;
MCNUM xmax = mccspec_detector_19_xmax;
MCNUM ymin = mccspec_detector_19_ymin;
MCNUM ymax = mccspec_detector_19_ymax;
MCNUM xwidth = mccspec_detector_19_xwidth;
MCNUM yheight = mccspec_detector_19_yheight;
MCNUM restore_neutron = mccspec_detector_19_restore_neutron;
#line 110 "/usr/share/mcstas/2.7/monitors/PSD_monitor.comp"
{
  DETECTOR_OUT_2D(
    "PSD monitor",
    "X position [cm]",
    "Y position [cm]",
    xmin*100.0, xmax*100.0, ymin*100.0, ymax*100.0,
    nx, ny,
    &PSD_N[0][0],&PSD_p[0][0],&PSD_p2[0][0],
    filename);
}
#line 474009 "MACS_sample_kidney_box.c"
}   /* End of spec_detector_19=PSD_monitor() SETTING parameter declarations. */
#undef PSD_p2
#undef PSD_p
#undef PSD_N
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

  /* User SAVE code for component 'spec_detector_history_0'. */
  SIG_MESSAGE("spec_detector_history_0 (Save)");
#define mccompcurname  spec_detector_history_0
#define mccompcurtype  extend_monitor
#define mccompcurindex 925
#define nb mccspec_detector_history_0_nb
#define C_N mccspec_detector_history_0_C_N
#define C_p mccspec_detector_history_0_C_p
#define C_p2 mccspec_detector_history_0_C_p2
{   /* Declarations of spec_detector_history_0=extend_monitor() SETTING parameters. */
char* filename = mccspec_detector_history_0_filename;
MCNUM xmin = mccspec_detector_history_0_xmin;
MCNUM xmax = mccspec_detector_history_0_xmax;
MCNUM ymin = mccspec_detector_history_0_ymin;
MCNUM ymax = mccspec_detector_history_0_ymax;
MCNUM xwidth = mccspec_detector_history_0_xwidth;
MCNUM yheight = mccspec_detector_history_0_yheight;
MCNUM restore_neutron = mccspec_detector_history_0_restore_neutron;
#line 102 "extend_monitor.comp"
{
    DETECTOR_OUT_1D(
        "extend monitor",
        "channel number [1]",
        "Intensity",
        "bin", -0.5, nb-0.5, nb,
        &C_N[0],&C_p[0],&C_p2[0],
        filename);
}
#line 474046 "MACS_sample_kidney_box.c"
}   /* End of spec_detector_history_0=extend_monitor() SETTING parameter declarations. */
#undef C_p2
#undef C_p
#undef C_N
#undef nb
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

  /* User SAVE code for component 'spec_detector_history_1'. */
  SIG_MESSAGE("spec_detector_history_1 (Save)");
#define mccompcurname  spec_detector_history_1
#define mccompcurtype  extend_monitor
#define mccompcurindex 926
#define nb mccspec_detector_history_1_nb
#define C_N mccspec_detector_history_1_C_N
#define C_p mccspec_detector_history_1_C_p
#define C_p2 mccspec_detector_history_1_C_p2
{   /* Declarations of spec_detector_history_1=extend_monitor() SETTING parameters. */
char* filename = mccspec_detector_history_1_filename;
MCNUM xmin = mccspec_detector_history_1_xmin;
MCNUM xmax = mccspec_detector_history_1_xmax;
MCNUM ymin = mccspec_detector_history_1_ymin;
MCNUM ymax = mccspec_detector_history_1_ymax;
MCNUM xwidth = mccspec_detector_history_1_xwidth;
MCNUM yheight = mccspec_detector_history_1_yheight;
MCNUM restore_neutron = mccspec_detector_history_1_restore_neutron;
#line 102 "extend_monitor.comp"
{
    DETECTOR_OUT_1D(
        "extend monitor",
        "channel number [1]",
        "Intensity",
        "bin", -0.5, nb-0.5, nb,
        &C_N[0],&C_p[0],&C_p2[0],
        filename);
}
#line 474084 "MACS_sample_kidney_box.c"
}   /* End of spec_detector_history_1=extend_monitor() SETTING parameter declarations. */
#undef C_p2
#undef C_p
#undef C_N
#undef nb
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

  /* User SAVE code for component 'spec_detector_history_2'. */
  SIG_MESSAGE("spec_detector_history_2 (Save)");
#define mccompcurname  spec_detector_history_2
#define mccompcurtype  extend_monitor
#define mccompcurindex 927
#define nb mccspec_detector_history_2_nb
#define C_N mccspec_detector_history_2_C_N
#define C_p mccspec_detector_history_2_C_p
#define C_p2 mccspec_detector_history_2_C_p2
{   /* Declarations of spec_detector_history_2=extend_monitor() SETTING parameters. */
char* filename = mccspec_detector_history_2_filename;
MCNUM xmin = mccspec_detector_history_2_xmin;
MCNUM xmax = mccspec_detector_history_2_xmax;
MCNUM ymin = mccspec_detector_history_2_ymin;
MCNUM ymax = mccspec_detector_history_2_ymax;
MCNUM xwidth = mccspec_detector_history_2_xwidth;
MCNUM yheight = mccspec_detector_history_2_yheight;
MCNUM restore_neutron = mccspec_detector_history_2_restore_neutron;
#line 102 "extend_monitor.comp"
{
    DETECTOR_OUT_1D(
        "extend monitor",
        "channel number [1]",
        "Intensity",
        "bin", -0.5, nb-0.5, nb,
        &C_N[0],&C_p[0],&C_p2[0],
        filename);
}
#line 474122 "MACS_sample_kidney_box.c"
}   /* End of spec_detector_history_2=extend_monitor() SETTING parameter declarations. */
#undef C_p2
#undef C_p
#undef C_N
#undef nb
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

  /* User SAVE code for component 'spec_detector_history_3'. */
  SIG_MESSAGE("spec_detector_history_3 (Save)");
#define mccompcurname  spec_detector_history_3
#define mccompcurtype  extend_monitor
#define mccompcurindex 928
#define nb mccspec_detector_history_3_nb
#define C_N mccspec_detector_history_3_C_N
#define C_p mccspec_detector_history_3_C_p
#define C_p2 mccspec_detector_history_3_C_p2
{   /* Declarations of spec_detector_history_3=extend_monitor() SETTING parameters. */
char* filename = mccspec_detector_history_3_filename;
MCNUM xmin = mccspec_detector_history_3_xmin;
MCNUM xmax = mccspec_detector_history_3_xmax;
MCNUM ymin = mccspec_detector_history_3_ymin;
MCNUM ymax = mccspec_detector_history_3_ymax;
MCNUM xwidth = mccspec_detector_history_3_xwidth;
MCNUM yheight = mccspec_detector_history_3_yheight;
MCNUM restore_neutron = mccspec_detector_history_3_restore_neutron;
#line 102 "extend_monitor.comp"
{
    DETECTOR_OUT_1D(
        "extend monitor",
        "channel number [1]",
        "Intensity",
        "bin", -0.5, nb-0.5, nb,
        &C_N[0],&C_p[0],&C_p2[0],
        filename);
}
#line 474160 "MACS_sample_kidney_box.c"
}   /* End of spec_detector_history_3=extend_monitor() SETTING parameter declarations. */
#undef C_p2
#undef C_p
#undef C_N
#undef nb
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

  /* User SAVE code for component 'spec_detector_history_4'. */
  SIG_MESSAGE("spec_detector_history_4 (Save)");
#define mccompcurname  spec_detector_history_4
#define mccompcurtype  extend_monitor
#define mccompcurindex 929
#define nb mccspec_detector_history_4_nb
#define C_N mccspec_detector_history_4_C_N
#define C_p mccspec_detector_history_4_C_p
#define C_p2 mccspec_detector_history_4_C_p2
{   /* Declarations of spec_detector_history_4=extend_monitor() SETTING parameters. */
char* filename = mccspec_detector_history_4_filename;
MCNUM xmin = mccspec_detector_history_4_xmin;
MCNUM xmax = mccspec_detector_history_4_xmax;
MCNUM ymin = mccspec_detector_history_4_ymin;
MCNUM ymax = mccspec_detector_history_4_ymax;
MCNUM xwidth = mccspec_detector_history_4_xwidth;
MCNUM yheight = mccspec_detector_history_4_yheight;
MCNUM restore_neutron = mccspec_detector_history_4_restore_neutron;
#line 102 "extend_monitor.comp"
{
    DETECTOR_OUT_1D(
        "extend monitor",
        "channel number [1]",
        "Intensity",
        "bin", -0.5, nb-0.5, nb,
        &C_N[0],&C_p[0],&C_p2[0],
        filename);
}
#line 474198 "MACS_sample_kidney_box.c"
}   /* End of spec_detector_history_4=extend_monitor() SETTING parameter declarations. */
#undef C_p2
#undef C_p
#undef C_N
#undef nb
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

  /* User SAVE code for component 'spec_detector_history_5'. */
  SIG_MESSAGE("spec_detector_history_5 (Save)");
#define mccompcurname  spec_detector_history_5
#define mccompcurtype  extend_monitor
#define mccompcurindex 930
#define nb mccspec_detector_history_5_nb
#define C_N mccspec_detector_history_5_C_N
#define C_p mccspec_detector_history_5_C_p
#define C_p2 mccspec_detector_history_5_C_p2
{   /* Declarations of spec_detector_history_5=extend_monitor() SETTING parameters. */
char* filename = mccspec_detector_history_5_filename;
MCNUM xmin = mccspec_detector_history_5_xmin;
MCNUM xmax = mccspec_detector_history_5_xmax;
MCNUM ymin = mccspec_detector_history_5_ymin;
MCNUM ymax = mccspec_detector_history_5_ymax;
MCNUM xwidth = mccspec_detector_history_5_xwidth;
MCNUM yheight = mccspec_detector_history_5_yheight;
MCNUM restore_neutron = mccspec_detector_history_5_restore_neutron;
#line 102 "extend_monitor.comp"
{
    DETECTOR_OUT_1D(
        "extend monitor",
        "channel number [1]",
        "Intensity",
        "bin", -0.5, nb-0.5, nb,
        &C_N[0],&C_p[0],&C_p2[0],
        filename);
}
#line 474236 "MACS_sample_kidney_box.c"
}   /* End of spec_detector_history_5=extend_monitor() SETTING parameter declarations. */
#undef C_p2
#undef C_p
#undef C_N
#undef nb
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

  /* User SAVE code for component 'spec_detector_history_6'. */
  SIG_MESSAGE("spec_detector_history_6 (Save)");
#define mccompcurname  spec_detector_history_6
#define mccompcurtype  extend_monitor
#define mccompcurindex 931
#define nb mccspec_detector_history_6_nb
#define C_N mccspec_detector_history_6_C_N
#define C_p mccspec_detector_history_6_C_p
#define C_p2 mccspec_detector_history_6_C_p2
{   /* Declarations of spec_detector_history_6=extend_monitor() SETTING parameters. */
char* filename = mccspec_detector_history_6_filename;
MCNUM xmin = mccspec_detector_history_6_xmin;
MCNUM xmax = mccspec_detector_history_6_xmax;
MCNUM ymin = mccspec_detector_history_6_ymin;
MCNUM ymax = mccspec_detector_history_6_ymax;
MCNUM xwidth = mccspec_detector_history_6_xwidth;
MCNUM yheight = mccspec_detector_history_6_yheight;
MCNUM restore_neutron = mccspec_detector_history_6_restore_neutron;
#line 102 "extend_monitor.comp"
{
    DETECTOR_OUT_1D(
        "extend monitor",
        "channel number [1]",
        "Intensity",
        "bin", -0.5, nb-0.5, nb,
        &C_N[0],&C_p[0],&C_p2[0],
        filename);
}
#line 474274 "MACS_sample_kidney_box.c"
}   /* End of spec_detector_history_6=extend_monitor() SETTING parameter declarations. */
#undef C_p2
#undef C_p
#undef C_N
#undef nb
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

  /* User SAVE code for component 'spec_detector_history_7'. */
  SIG_MESSAGE("spec_detector_history_7 (Save)");
#define mccompcurname  spec_detector_history_7
#define mccompcurtype  extend_monitor
#define mccompcurindex 932
#define nb mccspec_detector_history_7_nb
#define C_N mccspec_detector_history_7_C_N
#define C_p mccspec_detector_history_7_C_p
#define C_p2 mccspec_detector_history_7_C_p2
{   /* Declarations of spec_detector_history_7=extend_monitor() SETTING parameters. */
char* filename = mccspec_detector_history_7_filename;
MCNUM xmin = mccspec_detector_history_7_xmin;
MCNUM xmax = mccspec_detector_history_7_xmax;
MCNUM ymin = mccspec_detector_history_7_ymin;
MCNUM ymax = mccspec_detector_history_7_ymax;
MCNUM xwidth = mccspec_detector_history_7_xwidth;
MCNUM yheight = mccspec_detector_history_7_yheight;
MCNUM restore_neutron = mccspec_detector_history_7_restore_neutron;
#line 102 "extend_monitor.comp"
{
    DETECTOR_OUT_1D(
        "extend monitor",
        "channel number [1]",
        "Intensity",
        "bin", -0.5, nb-0.5, nb,
        &C_N[0],&C_p[0],&C_p2[0],
        filename);
}
#line 474312 "MACS_sample_kidney_box.c"
}   /* End of spec_detector_history_7=extend_monitor() SETTING parameter declarations. */
#undef C_p2
#undef C_p
#undef C_N
#undef nb
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

  /* User SAVE code for component 'spec_detector_history_8'. */
  SIG_MESSAGE("spec_detector_history_8 (Save)");
#define mccompcurname  spec_detector_history_8
#define mccompcurtype  extend_monitor
#define mccompcurindex 933
#define nb mccspec_detector_history_8_nb
#define C_N mccspec_detector_history_8_C_N
#define C_p mccspec_detector_history_8_C_p
#define C_p2 mccspec_detector_history_8_C_p2
{   /* Declarations of spec_detector_history_8=extend_monitor() SETTING parameters. */
char* filename = mccspec_detector_history_8_filename;
MCNUM xmin = mccspec_detector_history_8_xmin;
MCNUM xmax = mccspec_detector_history_8_xmax;
MCNUM ymin = mccspec_detector_history_8_ymin;
MCNUM ymax = mccspec_detector_history_8_ymax;
MCNUM xwidth = mccspec_detector_history_8_xwidth;
MCNUM yheight = mccspec_detector_history_8_yheight;
MCNUM restore_neutron = mccspec_detector_history_8_restore_neutron;
#line 102 "extend_monitor.comp"
{
    DETECTOR_OUT_1D(
        "extend monitor",
        "channel number [1]",
        "Intensity",
        "bin", -0.5, nb-0.5, nb,
        &C_N[0],&C_p[0],&C_p2[0],
        filename);
}
#line 474350 "MACS_sample_kidney_box.c"
}   /* End of spec_detector_history_8=extend_monitor() SETTING parameter declarations. */
#undef C_p2
#undef C_p
#undef C_N
#undef nb
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

  /* User SAVE code for component 'spec_detector_history_9'. */
  SIG_MESSAGE("spec_detector_history_9 (Save)");
#define mccompcurname  spec_detector_history_9
#define mccompcurtype  extend_monitor
#define mccompcurindex 934
#define nb mccspec_detector_history_9_nb
#define C_N mccspec_detector_history_9_C_N
#define C_p mccspec_detector_history_9_C_p
#define C_p2 mccspec_detector_history_9_C_p2
{   /* Declarations of spec_detector_history_9=extend_monitor() SETTING parameters. */
char* filename = mccspec_detector_history_9_filename;
MCNUM xmin = mccspec_detector_history_9_xmin;
MCNUM xmax = mccspec_detector_history_9_xmax;
MCNUM ymin = mccspec_detector_history_9_ymin;
MCNUM ymax = mccspec_detector_history_9_ymax;
MCNUM xwidth = mccspec_detector_history_9_xwidth;
MCNUM yheight = mccspec_detector_history_9_yheight;
MCNUM restore_neutron = mccspec_detector_history_9_restore_neutron;
#line 102 "extend_monitor.comp"
{
    DETECTOR_OUT_1D(
        "extend monitor",
        "channel number [1]",
        "Intensity",
        "bin", -0.5, nb-0.5, nb,
        &C_N[0],&C_p[0],&C_p2[0],
        filename);
}
#line 474388 "MACS_sample_kidney_box.c"
}   /* End of spec_detector_history_9=extend_monitor() SETTING parameter declarations. */
#undef C_p2
#undef C_p
#undef C_N
#undef nb
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

  /* User SAVE code for component 'spec_detector_history_10'. */
  SIG_MESSAGE("spec_detector_history_10 (Save)");
#define mccompcurname  spec_detector_history_10
#define mccompcurtype  extend_monitor
#define mccompcurindex 935
#define nb mccspec_detector_history_10_nb
#define C_N mccspec_detector_history_10_C_N
#define C_p mccspec_detector_history_10_C_p
#define C_p2 mccspec_detector_history_10_C_p2
{   /* Declarations of spec_detector_history_10=extend_monitor() SETTING parameters. */
char* filename = mccspec_detector_history_10_filename;
MCNUM xmin = mccspec_detector_history_10_xmin;
MCNUM xmax = mccspec_detector_history_10_xmax;
MCNUM ymin = mccspec_detector_history_10_ymin;
MCNUM ymax = mccspec_detector_history_10_ymax;
MCNUM xwidth = mccspec_detector_history_10_xwidth;
MCNUM yheight = mccspec_detector_history_10_yheight;
MCNUM restore_neutron = mccspec_detector_history_10_restore_neutron;
#line 102 "extend_monitor.comp"
{
    DETECTOR_OUT_1D(
        "extend monitor",
        "channel number [1]",
        "Intensity",
        "bin", -0.5, nb-0.5, nb,
        &C_N[0],&C_p[0],&C_p2[0],
        filename);
}
#line 474426 "MACS_sample_kidney_box.c"
}   /* End of spec_detector_history_10=extend_monitor() SETTING parameter declarations. */
#undef C_p2
#undef C_p
#undef C_N
#undef nb
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

  /* User SAVE code for component 'spec_detector_history_11'. */
  SIG_MESSAGE("spec_detector_history_11 (Save)");
#define mccompcurname  spec_detector_history_11
#define mccompcurtype  extend_monitor
#define mccompcurindex 936
#define nb mccspec_detector_history_11_nb
#define C_N mccspec_detector_history_11_C_N
#define C_p mccspec_detector_history_11_C_p
#define C_p2 mccspec_detector_history_11_C_p2
{   /* Declarations of spec_detector_history_11=extend_monitor() SETTING parameters. */
char* filename = mccspec_detector_history_11_filename;
MCNUM xmin = mccspec_detector_history_11_xmin;
MCNUM xmax = mccspec_detector_history_11_xmax;
MCNUM ymin = mccspec_detector_history_11_ymin;
MCNUM ymax = mccspec_detector_history_11_ymax;
MCNUM xwidth = mccspec_detector_history_11_xwidth;
MCNUM yheight = mccspec_detector_history_11_yheight;
MCNUM restore_neutron = mccspec_detector_history_11_restore_neutron;
#line 102 "extend_monitor.comp"
{
    DETECTOR_OUT_1D(
        "extend monitor",
        "channel number [1]",
        "Intensity",
        "bin", -0.5, nb-0.5, nb,
        &C_N[0],&C_p[0],&C_p2[0],
        filename);
}
#line 474464 "MACS_sample_kidney_box.c"
}   /* End of spec_detector_history_11=extend_monitor() SETTING parameter declarations. */
#undef C_p2
#undef C_p
#undef C_N
#undef nb
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

  /* User SAVE code for component 'spec_detector_history_12'. */
  SIG_MESSAGE("spec_detector_history_12 (Save)");
#define mccompcurname  spec_detector_history_12
#define mccompcurtype  extend_monitor
#define mccompcurindex 937
#define nb mccspec_detector_history_12_nb
#define C_N mccspec_detector_history_12_C_N
#define C_p mccspec_detector_history_12_C_p
#define C_p2 mccspec_detector_history_12_C_p2
{   /* Declarations of spec_detector_history_12=extend_monitor() SETTING parameters. */
char* filename = mccspec_detector_history_12_filename;
MCNUM xmin = mccspec_detector_history_12_xmin;
MCNUM xmax = mccspec_detector_history_12_xmax;
MCNUM ymin = mccspec_detector_history_12_ymin;
MCNUM ymax = mccspec_detector_history_12_ymax;
MCNUM xwidth = mccspec_detector_history_12_xwidth;
MCNUM yheight = mccspec_detector_history_12_yheight;
MCNUM restore_neutron = mccspec_detector_history_12_restore_neutron;
#line 102 "extend_monitor.comp"
{
    DETECTOR_OUT_1D(
        "extend monitor",
        "channel number [1]",
        "Intensity",
        "bin", -0.5, nb-0.5, nb,
        &C_N[0],&C_p[0],&C_p2[0],
        filename);
}
#line 474502 "MACS_sample_kidney_box.c"
}   /* End of spec_detector_history_12=extend_monitor() SETTING parameter declarations. */
#undef C_p2
#undef C_p
#undef C_N
#undef nb
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

  /* User SAVE code for component 'spec_detector_history_13'. */
  SIG_MESSAGE("spec_detector_history_13 (Save)");
#define mccompcurname  spec_detector_history_13
#define mccompcurtype  extend_monitor
#define mccompcurindex 938
#define nb mccspec_detector_history_13_nb
#define C_N mccspec_detector_history_13_C_N
#define C_p mccspec_detector_history_13_C_p
#define C_p2 mccspec_detector_history_13_C_p2
{   /* Declarations of spec_detector_history_13=extend_monitor() SETTING parameters. */
char* filename = mccspec_detector_history_13_filename;
MCNUM xmin = mccspec_detector_history_13_xmin;
MCNUM xmax = mccspec_detector_history_13_xmax;
MCNUM ymin = mccspec_detector_history_13_ymin;
MCNUM ymax = mccspec_detector_history_13_ymax;
MCNUM xwidth = mccspec_detector_history_13_xwidth;
MCNUM yheight = mccspec_detector_history_13_yheight;
MCNUM restore_neutron = mccspec_detector_history_13_restore_neutron;
#line 102 "extend_monitor.comp"
{
    DETECTOR_OUT_1D(
        "extend monitor",
        "channel number [1]",
        "Intensity",
        "bin", -0.5, nb-0.5, nb,
        &C_N[0],&C_p[0],&C_p2[0],
        filename);
}
#line 474540 "MACS_sample_kidney_box.c"
}   /* End of spec_detector_history_13=extend_monitor() SETTING parameter declarations. */
#undef C_p2
#undef C_p
#undef C_N
#undef nb
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

  /* User SAVE code for component 'spec_detector_history_14'. */
  SIG_MESSAGE("spec_detector_history_14 (Save)");
#define mccompcurname  spec_detector_history_14
#define mccompcurtype  extend_monitor
#define mccompcurindex 939
#define nb mccspec_detector_history_14_nb
#define C_N mccspec_detector_history_14_C_N
#define C_p mccspec_detector_history_14_C_p
#define C_p2 mccspec_detector_history_14_C_p2
{   /* Declarations of spec_detector_history_14=extend_monitor() SETTING parameters. */
char* filename = mccspec_detector_history_14_filename;
MCNUM xmin = mccspec_detector_history_14_xmin;
MCNUM xmax = mccspec_detector_history_14_xmax;
MCNUM ymin = mccspec_detector_history_14_ymin;
MCNUM ymax = mccspec_detector_history_14_ymax;
MCNUM xwidth = mccspec_detector_history_14_xwidth;
MCNUM yheight = mccspec_detector_history_14_yheight;
MCNUM restore_neutron = mccspec_detector_history_14_restore_neutron;
#line 102 "extend_monitor.comp"
{
    DETECTOR_OUT_1D(
        "extend monitor",
        "channel number [1]",
        "Intensity",
        "bin", -0.5, nb-0.5, nb,
        &C_N[0],&C_p[0],&C_p2[0],
        filename);
}
#line 474578 "MACS_sample_kidney_box.c"
}   /* End of spec_detector_history_14=extend_monitor() SETTING parameter declarations. */
#undef C_p2
#undef C_p
#undef C_N
#undef nb
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

  /* User SAVE code for component 'spec_detector_history_15'. */
  SIG_MESSAGE("spec_detector_history_15 (Save)");
#define mccompcurname  spec_detector_history_15
#define mccompcurtype  extend_monitor
#define mccompcurindex 940
#define nb mccspec_detector_history_15_nb
#define C_N mccspec_detector_history_15_C_N
#define C_p mccspec_detector_history_15_C_p
#define C_p2 mccspec_detector_history_15_C_p2
{   /* Declarations of spec_detector_history_15=extend_monitor() SETTING parameters. */
char* filename = mccspec_detector_history_15_filename;
MCNUM xmin = mccspec_detector_history_15_xmin;
MCNUM xmax = mccspec_detector_history_15_xmax;
MCNUM ymin = mccspec_detector_history_15_ymin;
MCNUM ymax = mccspec_detector_history_15_ymax;
MCNUM xwidth = mccspec_detector_history_15_xwidth;
MCNUM yheight = mccspec_detector_history_15_yheight;
MCNUM restore_neutron = mccspec_detector_history_15_restore_neutron;
#line 102 "extend_monitor.comp"
{
    DETECTOR_OUT_1D(
        "extend monitor",
        "channel number [1]",
        "Intensity",
        "bin", -0.5, nb-0.5, nb,
        &C_N[0],&C_p[0],&C_p2[0],
        filename);
}
#line 474616 "MACS_sample_kidney_box.c"
}   /* End of spec_detector_history_15=extend_monitor() SETTING parameter declarations. */
#undef C_p2
#undef C_p
#undef C_N
#undef nb
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

  /* User SAVE code for component 'spec_detector_history_16'. */
  SIG_MESSAGE("spec_detector_history_16 (Save)");
#define mccompcurname  spec_detector_history_16
#define mccompcurtype  extend_monitor
#define mccompcurindex 941
#define nb mccspec_detector_history_16_nb
#define C_N mccspec_detector_history_16_C_N
#define C_p mccspec_detector_history_16_C_p
#define C_p2 mccspec_detector_history_16_C_p2
{   /* Declarations of spec_detector_history_16=extend_monitor() SETTING parameters. */
char* filename = mccspec_detector_history_16_filename;
MCNUM xmin = mccspec_detector_history_16_xmin;
MCNUM xmax = mccspec_detector_history_16_xmax;
MCNUM ymin = mccspec_detector_history_16_ymin;
MCNUM ymax = mccspec_detector_history_16_ymax;
MCNUM xwidth = mccspec_detector_history_16_xwidth;
MCNUM yheight = mccspec_detector_history_16_yheight;
MCNUM restore_neutron = mccspec_detector_history_16_restore_neutron;
#line 102 "extend_monitor.comp"
{
    DETECTOR_OUT_1D(
        "extend monitor",
        "channel number [1]",
        "Intensity",
        "bin", -0.5, nb-0.5, nb,
        &C_N[0],&C_p[0],&C_p2[0],
        filename);
}
#line 474654 "MACS_sample_kidney_box.c"
}   /* End of spec_detector_history_16=extend_monitor() SETTING parameter declarations. */
#undef C_p2
#undef C_p
#undef C_N
#undef nb
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

  /* User SAVE code for component 'spec_detector_history_17'. */
  SIG_MESSAGE("spec_detector_history_17 (Save)");
#define mccompcurname  spec_detector_history_17
#define mccompcurtype  extend_monitor
#define mccompcurindex 942
#define nb mccspec_detector_history_17_nb
#define C_N mccspec_detector_history_17_C_N
#define C_p mccspec_detector_history_17_C_p
#define C_p2 mccspec_detector_history_17_C_p2
{   /* Declarations of spec_detector_history_17=extend_monitor() SETTING parameters. */
char* filename = mccspec_detector_history_17_filename;
MCNUM xmin = mccspec_detector_history_17_xmin;
MCNUM xmax = mccspec_detector_history_17_xmax;
MCNUM ymin = mccspec_detector_history_17_ymin;
MCNUM ymax = mccspec_detector_history_17_ymax;
MCNUM xwidth = mccspec_detector_history_17_xwidth;
MCNUM yheight = mccspec_detector_history_17_yheight;
MCNUM restore_neutron = mccspec_detector_history_17_restore_neutron;
#line 102 "extend_monitor.comp"
{
    DETECTOR_OUT_1D(
        "extend monitor",
        "channel number [1]",
        "Intensity",
        "bin", -0.5, nb-0.5, nb,
        &C_N[0],&C_p[0],&C_p2[0],
        filename);
}
#line 474692 "MACS_sample_kidney_box.c"
}   /* End of spec_detector_history_17=extend_monitor() SETTING parameter declarations. */
#undef C_p2
#undef C_p
#undef C_N
#undef nb
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

  /* User SAVE code for component 'spec_detector_history_18'. */
  SIG_MESSAGE("spec_detector_history_18 (Save)");
#define mccompcurname  spec_detector_history_18
#define mccompcurtype  extend_monitor
#define mccompcurindex 943
#define nb mccspec_detector_history_18_nb
#define C_N mccspec_detector_history_18_C_N
#define C_p mccspec_detector_history_18_C_p
#define C_p2 mccspec_detector_history_18_C_p2
{   /* Declarations of spec_detector_history_18=extend_monitor() SETTING parameters. */
char* filename = mccspec_detector_history_18_filename;
MCNUM xmin = mccspec_detector_history_18_xmin;
MCNUM xmax = mccspec_detector_history_18_xmax;
MCNUM ymin = mccspec_detector_history_18_ymin;
MCNUM ymax = mccspec_detector_history_18_ymax;
MCNUM xwidth = mccspec_detector_history_18_xwidth;
MCNUM yheight = mccspec_detector_history_18_yheight;
MCNUM restore_neutron = mccspec_detector_history_18_restore_neutron;
#line 102 "extend_monitor.comp"
{
    DETECTOR_OUT_1D(
        "extend monitor",
        "channel number [1]",
        "Intensity",
        "bin", -0.5, nb-0.5, nb,
        &C_N[0],&C_p[0],&C_p2[0],
        filename);
}
#line 474730 "MACS_sample_kidney_box.c"
}   /* End of spec_detector_history_18=extend_monitor() SETTING parameter declarations. */
#undef C_p2
#undef C_p
#undef C_N
#undef nb
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

  /* User SAVE code for component 'spec_detector_history_19'. */
  SIG_MESSAGE("spec_detector_history_19 (Save)");
#define mccompcurname  spec_detector_history_19
#define mccompcurtype  extend_monitor
#define mccompcurindex 944
#define nb mccspec_detector_history_19_nb
#define C_N mccspec_detector_history_19_C_N
#define C_p mccspec_detector_history_19_C_p
#define C_p2 mccspec_detector_history_19_C_p2
{   /* Declarations of spec_detector_history_19=extend_monitor() SETTING parameters. */
char* filename = mccspec_detector_history_19_filename;
MCNUM xmin = mccspec_detector_history_19_xmin;
MCNUM xmax = mccspec_detector_history_19_xmax;
MCNUM ymin = mccspec_detector_history_19_ymin;
MCNUM ymax = mccspec_detector_history_19_ymax;
MCNUM xwidth = mccspec_detector_history_19_xwidth;
MCNUM yheight = mccspec_detector_history_19_yheight;
MCNUM restore_neutron = mccspec_detector_history_19_restore_neutron;
#line 102 "extend_monitor.comp"
{
    DETECTOR_OUT_1D(
        "extend monitor",
        "channel number [1]",
        "Intensity",
        "bin", -0.5, nb-0.5, nb,
        &C_N[0],&C_p[0],&C_p2[0],
        filename);
}
#line 474768 "MACS_sample_kidney_box.c"
}   /* End of spec_detector_history_19=extend_monitor() SETTING parameter declarations. */
#undef C_p2
#undef C_p
#undef C_N
#undef nb
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

  if (!handle) mcsiminfo_close(); 
} /* end save */
void mcfinally(void) {
  /* User component FINALLY code. */
  mcsiminfo_init(NULL);
  mcsave(mcsiminfo_file); /* save data when simulation ends */

  /* User FINALLY code for component 'Al_incoherent'. */
  SIG_MESSAGE("Al_incoherent (Finally)");
#define mccompcurname  Al_incoherent
#define mccompcurtype  Incoherent_process
#define mccompcurindex 1
#define This_process mccAl_incoherent_This_process
#define Incoherent_storage mccAl_incoherent_Incoherent_storage
#define effective_my_scattering mccAl_incoherent_effective_my_scattering
{   /* Declarations of Al_incoherent=Incoherent_process() SETTING parameters. */
MCNUM sigma = mccAl_incoherent_sigma;
MCNUM f_QE = mccAl_incoherent_f_QE;
MCNUM gamma = mccAl_incoherent_gamma;
MCNUM packing_factor = mccAl_incoherent_packing_factor;
MCNUM unit_cell_volume = mccAl_incoherent_unit_cell_volume;
MCNUM interact_fraction = mccAl_incoherent_interact_fraction;
#line 171 "Incoherent_process.comp"
{
// Since the process and it's storage is a static allocation, there is nothing to deallocate

}
#line 474805 "MACS_sample_kidney_box.c"
}   /* End of Al_incoherent=Incoherent_process() SETTING parameter declarations. */
#undef effective_my_scattering
#undef Incoherent_storage
#undef This_process
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

    if (!mcNCounter[1]) fprintf(stderr, "Warning: No neutron could reach Component[1] Al_incoherent\n");
    if (mcAbsorbProp[1]) fprintf(stderr, "Warning: %g events were removed in Component[1] Al_incoherent=Incoherent_process()\n"
"         (negative time, miss next components, rounding errors, Nan, Inf).\n", mcAbsorbProp[1]);
  /* User FINALLY code for component 'Al_powder'. */
  SIG_MESSAGE("Al_powder (Finally)");
#define mccompcurname  Al_powder
#define mccompcurtype  Powder_process
#define mccompcurindex 2
#define format mccAl_powder_format
#define This_process mccAl_powder_This_process
#define Powder_storage mccAl_powder_Powder_storage
#define effective_my_scattering mccAl_powder_effective_my_scattering
#define d_phi mccAl_powder_d_phi
#define line_info mccAl_powder_line_info
#define columns mccAl_powder_columns
{   /* Declarations of Al_powder=Powder_process() SETTING parameters. */
char* reflections = mccAl_powder_reflections;
MCNUM packing_factor = mccAl_powder_packing_factor;
MCNUM Vc = mccAl_powder_Vc;
MCNUM delta_d_d = mccAl_powder_delta_d_d;
MCNUM DW = mccAl_powder_DW;
MCNUM nb_atoms = mccAl_powder_nb_atoms;
MCNUM d_phi = mccAl_powder_d_phi;
MCNUM density = mccAl_powder_density;
MCNUM weight = mccAl_powder_weight;
MCNUM barns = mccAl_powder_barns;
MCNUM Strain = mccAl_powder_Strain;
MCNUM interact_fraction = mccAl_powder_interact_fraction;
#line 766 "Powder_process.comp"
{
  free(line_info.list);
  free(line_info.q_v);
  free(line_info.w_v);
  free(line_info.my_s_v2);
}
#line 474848 "MACS_sample_kidney_box.c"
}   /* End of Al_powder=Powder_process() SETTING parameter declarations. */
#undef columns
#undef line_info
#undef d_phi
#undef effective_my_scattering
#undef Powder_storage
#undef This_process
#undef format
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

    if (!mcNCounter[2]) fprintf(stderr, "Warning: No neutron could reach Component[2] Al_powder\n");
    if (mcAbsorbProp[2]) fprintf(stderr, "Warning: %g events were removed in Component[2] Al_powder=Powder_process()\n"
"         (negative time, miss next components, rounding errors, Nan, Inf).\n", mcAbsorbProp[2]);
  /* User FINALLY code for component 'Al'. */
  SIG_MESSAGE("Al (Finally)");
#define mccompcurname  Al
#define mccompcurtype  Union_make_material
#define mccompcurindex 3
#define loop_index mccAl_loop_index
#define this_material mccAl_this_material
#define accepted_processes mccAl_accepted_processes
#define global_material_element mccAl_global_material_element
{   /* Declarations of Al=Union_make_material() SETTING parameters. */
char* process_string = mccAl_process_string;
MCNUM my_absorption = mccAl_my_absorption;
MCNUM absorber = mccAl_absorber;
#line 259 "Union_make_material.comp"
{
// The elements of the scattering array used static allocation and is thus deallocated automatically
if (this_material.number_of_processes > 0) free(this_material.p_scattering_array);
if (accepted_processes.num_elements > 0) free(accepted_processes.elements);

// Checking if any Union volumes are defined after the master component
#ifdef MASTER_DETECTOR
  #ifdef ANY_GEOMETRY_DETECTOR_DECLARE
    #ifndef MASTER_DETECTOR_WARNING
      for (loop_index=0;loop_index<global_geometry_list.num_elements;loop_index++) {
        if (global_geometry_list.elements[loop_index].component_index > global_master_list.elements[global_master_list.num_elements-1].component_index) {
          printf("WARNING: No Union_master component defined after Union volume named %s, this components did not affect the simulation in any way.\n",global_geometry_list.elements[loop_index].name);
        }
      }
      // Decided to have this as a warning without exiting the simulation
      // In order to only show this warning once, the MASTER_DETECTOR_WARNING is defined
      #define MASTER_DETECTOR_WARNING dummy
    #endif
  #endif
#endif

// Checking if the user remembered to put in a Union_master
#ifndef MASTER_DETECTOR
  #ifdef ANY_GEOMETRY_DETECTOR_DECLARE
    #ifndef MASTER_DETECTOR_WARNING
      printf("\nWARNING: No Union_master component used, these components did not affect the simulation in any way:\n");
      for (loop_index=0;loop_index<global_geometry_list.num_elements;loop_index++)
        printf("  %s\n",global_geometry_list.elements[loop_index].name);
      printf("\n");
      // Decided to have this as a warning without exiting the simulation
      // In order to only show this warning once, the MASTER_DETECTOR_WARNING is defined
      #define MASTER_DETECTOR_WARNING dummy
    #endif
  #endif
#endif


}
#line 474915 "MACS_sample_kidney_box.c"
}   /* End of Al=Union_make_material() SETTING parameter declarations. */
#undef global_material_element
#undef accepted_processes
#undef this_material
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

    if (!mcNCounter[3]) fprintf(stderr, "Warning: No neutron could reach Component[3] Al\n");
    if (mcAbsorbProp[3]) fprintf(stderr, "Warning: %g events were removed in Component[3] Al=Union_make_material()\n"
"         (negative time, miss next components, rounding errors, Nan, Inf).\n", mcAbsorbProp[3]);
  /* User FINALLY code for component 'TiO2_incoherent'. */
  SIG_MESSAGE("TiO2_incoherent (Finally)");
#define mccompcurname  TiO2_incoherent
#define mccompcurtype  Incoherent_process
#define mccompcurindex 4
#define This_process mccTiO2_incoherent_This_process
#define Incoherent_storage mccTiO2_incoherent_Incoherent_storage
#define effective_my_scattering mccTiO2_incoherent_effective_my_scattering
{   /* Declarations of TiO2_incoherent=Incoherent_process() SETTING parameters. */
MCNUM sigma = mccTiO2_incoherent_sigma;
MCNUM f_QE = mccTiO2_incoherent_f_QE;
MCNUM gamma = mccTiO2_incoherent_gamma;
MCNUM packing_factor = mccTiO2_incoherent_packing_factor;
MCNUM unit_cell_volume = mccTiO2_incoherent_unit_cell_volume;
MCNUM interact_fraction = mccTiO2_incoherent_interact_fraction;
#line 171 "Incoherent_process.comp"
{
// Since the process and it's storage is a static allocation, there is nothing to deallocate

}
#line 474947 "MACS_sample_kidney_box.c"
}   /* End of TiO2_incoherent=Incoherent_process() SETTING parameter declarations. */
#undef effective_my_scattering
#undef Incoherent_storage
#undef This_process
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

    if (!mcNCounter[4]) fprintf(stderr, "Warning: No neutron could reach Component[4] TiO2_incoherent\n");
    if (mcAbsorbProp[4]) fprintf(stderr, "Warning: %g events were removed in Component[4] TiO2_incoherent=Incoherent_process()\n"
"         (negative time, miss next components, rounding errors, Nan, Inf).\n", mcAbsorbProp[4]);
    if (!mcNCounter[5]) fprintf(stderr, "Warning: No neutron could reach Component[5] TiO2_single_crystal\n");
    if (mcAbsorbProp[5]) fprintf(stderr, "Warning: %g events were removed in Component[5] TiO2_single_crystal=Single_crystal_process()\n"
"         (negative time, miss next components, rounding errors, Nan, Inf).\n", mcAbsorbProp[5]);
  /* User FINALLY code for component 'TiO2'. */
  SIG_MESSAGE("TiO2 (Finally)");
#define mccompcurname  TiO2
#define mccompcurtype  Union_make_material
#define mccompcurindex 6
#define loop_index mccTiO2_loop_index
#define this_material mccTiO2_this_material
#define accepted_processes mccTiO2_accepted_processes
#define global_material_element mccTiO2_global_material_element
{   /* Declarations of TiO2=Union_make_material() SETTING parameters. */
char* process_string = mccTiO2_process_string;
MCNUM my_absorption = mccTiO2_my_absorption;
MCNUM absorber = mccTiO2_absorber;
#line 259 "Union_make_material.comp"
{
// The elements of the scattering array used static allocation and is thus deallocated automatically
if (this_material.number_of_processes > 0) free(this_material.p_scattering_array);
if (accepted_processes.num_elements > 0) free(accepted_processes.elements);

// Checking if any Union volumes are defined after the master component
#ifdef MASTER_DETECTOR
  #ifdef ANY_GEOMETRY_DETECTOR_DECLARE
    #ifndef MASTER_DETECTOR_WARNING
      for (loop_index=0;loop_index<global_geometry_list.num_elements;loop_index++) {
        if (global_geometry_list.elements[loop_index].component_index > global_master_list.elements[global_master_list.num_elements-1].component_index) {
          printf("WARNING: No Union_master component defined after Union volume named %s, this components did not affect the simulation in any way.\n",global_geometry_list.elements[loop_index].name);
        }
      }
      // Decided to have this as a warning without exiting the simulation
      // In order to only show this warning once, the MASTER_DETECTOR_WARNING is defined
      #define MASTER_DETECTOR_WARNING dummy
    #endif
  #endif
#endif

// Checking if the user remembered to put in a Union_master
#ifndef MASTER_DETECTOR
  #ifdef ANY_GEOMETRY_DETECTOR_DECLARE
    #ifndef MASTER_DETECTOR_WARNING
      printf("\nWARNING: No Union_master component used, these components did not affect the simulation in any way:\n");
      for (loop_index=0;loop_index<global_geometry_list.num_elements;loop_index++)
        printf("  %s\n",global_geometry_list.elements[loop_index].name);
      printf("\n");
      // Decided to have this as a warning without exiting the simulation
      // In order to only show this warning once, the MASTER_DETECTOR_WARNING is defined
      #define MASTER_DETECTOR_WARNING dummy
    #endif
  #endif
#endif


}
#line 475012 "MACS_sample_kidney_box.c"
}   /* End of TiO2=Union_make_material() SETTING parameter declarations. */
#undef global_material_element
#undef accepted_processes
#undef this_material
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

    if (!mcNCounter[6]) fprintf(stderr, "Warning: No neutron could reach Component[6] TiO2\n");
    if (mcAbsorbProp[6]) fprintf(stderr, "Warning: %g events were removed in Component[6] TiO2=Union_make_material()\n"
"         (negative time, miss next components, rounding errors, Nan, Inf).\n", mcAbsorbProp[6]);
  /* User FINALLY code for component 'TiO2_poly_incoherent'. */
  SIG_MESSAGE("TiO2_poly_incoherent (Finally)");
#define mccompcurname  TiO2_poly_incoherent
#define mccompcurtype  Incoherent_process
#define mccompcurindex 7
#define This_process mccTiO2_poly_incoherent_This_process
#define Incoherent_storage mccTiO2_poly_incoherent_Incoherent_storage
#define effective_my_scattering mccTiO2_poly_incoherent_effective_my_scattering
{   /* Declarations of TiO2_poly_incoherent=Incoherent_process() SETTING parameters. */
MCNUM sigma = mccTiO2_poly_incoherent_sigma;
MCNUM f_QE = mccTiO2_poly_incoherent_f_QE;
MCNUM gamma = mccTiO2_poly_incoherent_gamma;
MCNUM packing_factor = mccTiO2_poly_incoherent_packing_factor;
MCNUM unit_cell_volume = mccTiO2_poly_incoherent_unit_cell_volume;
MCNUM interact_fraction = mccTiO2_poly_incoherent_interact_fraction;
#line 171 "Incoherent_process.comp"
{
// Since the process and it's storage is a static allocation, there is nothing to deallocate

}
#line 475044 "MACS_sample_kidney_box.c"
}   /* End of TiO2_poly_incoherent=Incoherent_process() SETTING parameter declarations. */
#undef effective_my_scattering
#undef Incoherent_storage
#undef This_process
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

    if (!mcNCounter[7]) fprintf(stderr, "Warning: No neutron could reach Component[7] TiO2_poly_incoherent\n");
    if (mcAbsorbProp[7]) fprintf(stderr, "Warning: %g events were removed in Component[7] TiO2_poly_incoherent=Incoherent_process()\n"
"         (negative time, miss next components, rounding errors, Nan, Inf).\n", mcAbsorbProp[7]);
  /* User FINALLY code for component 'TiO2_poly'. */
  SIG_MESSAGE("TiO2_poly (Finally)");
#define mccompcurname  TiO2_poly
#define mccompcurtype  Union_make_material
#define mccompcurindex 8
#define loop_index mccTiO2_poly_loop_index
#define this_material mccTiO2_poly_this_material
#define accepted_processes mccTiO2_poly_accepted_processes
#define global_material_element mccTiO2_poly_global_material_element
{   /* Declarations of TiO2_poly=Union_make_material() SETTING parameters. */
char* process_string = mccTiO2_poly_process_string;
MCNUM my_absorption = mccTiO2_poly_my_absorption;
MCNUM absorber = mccTiO2_poly_absorber;
#line 259 "Union_make_material.comp"
{
// The elements of the scattering array used static allocation and is thus deallocated automatically
if (this_material.number_of_processes > 0) free(this_material.p_scattering_array);
if (accepted_processes.num_elements > 0) free(accepted_processes.elements);

// Checking if any Union volumes are defined after the master component
#ifdef MASTER_DETECTOR
  #ifdef ANY_GEOMETRY_DETECTOR_DECLARE
    #ifndef MASTER_DETECTOR_WARNING
      for (loop_index=0;loop_index<global_geometry_list.num_elements;loop_index++) {
        if (global_geometry_list.elements[loop_index].component_index > global_master_list.elements[global_master_list.num_elements-1].component_index) {
          printf("WARNING: No Union_master component defined after Union volume named %s, this components did not affect the simulation in any way.\n",global_geometry_list.elements[loop_index].name);
        }
      }
      // Decided to have this as a warning without exiting the simulation
      // In order to only show this warning once, the MASTER_DETECTOR_WARNING is defined
      #define MASTER_DETECTOR_WARNING dummy
    #endif
  #endif
#endif

// Checking if the user remembered to put in a Union_master
#ifndef MASTER_DETECTOR
  #ifdef ANY_GEOMETRY_DETECTOR_DECLARE
    #ifndef MASTER_DETECTOR_WARNING
      printf("\nWARNING: No Union_master component used, these components did not affect the simulation in any way:\n");
      for (loop_index=0;loop_index<global_geometry_list.num_elements;loop_index++)
        printf("  %s\n",global_geometry_list.elements[loop_index].name);
      printf("\n");
      // Decided to have this as a warning without exiting the simulation
      // In order to only show this warning once, the MASTER_DETECTOR_WARNING is defined
      #define MASTER_DETECTOR_WARNING dummy
    #endif
  #endif
#endif


}
#line 475107 "MACS_sample_kidney_box.c"
}   /* End of TiO2_poly=Union_make_material() SETTING parameter declarations. */
#undef global_material_element
#undef accepted_processes
#undef this_material
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

    if (!mcNCounter[8]) fprintf(stderr, "Warning: No neutron could reach Component[8] TiO2_poly\n");
    if (mcAbsorbProp[8]) fprintf(stderr, "Warning: %g events were removed in Component[8] TiO2_poly=Union_make_material()\n"
"         (negative time, miss next components, rounding errors, Nan, Inf).\n", mcAbsorbProp[8]);
  /* User FINALLY code for component 'Al_incoherent_B'. */
  SIG_MESSAGE("Al_incoherent_B (Finally)");
#define mccompcurname  Al_incoherent_B
#define mccompcurtype  Incoherent_process
#define mccompcurindex 9
#define This_process mccAl_incoherent_B_This_process
#define Incoherent_storage mccAl_incoherent_B_Incoherent_storage
#define effective_my_scattering mccAl_incoherent_B_effective_my_scattering
{   /* Declarations of Al_incoherent_B=Incoherent_process() SETTING parameters. */
MCNUM sigma = mccAl_incoherent_B_sigma;
MCNUM f_QE = mccAl_incoherent_B_f_QE;
MCNUM gamma = mccAl_incoherent_B_gamma;
MCNUM packing_factor = mccAl_incoherent_B_packing_factor;
MCNUM unit_cell_volume = mccAl_incoherent_B_unit_cell_volume;
MCNUM interact_fraction = mccAl_incoherent_B_interact_fraction;
#line 171 "Incoherent_process.comp"
{
// Since the process and it's storage is a static allocation, there is nothing to deallocate

}
#line 475139 "MACS_sample_kidney_box.c"
}   /* End of Al_incoherent_B=Incoherent_process() SETTING parameter declarations. */
#undef effective_my_scattering
#undef Incoherent_storage
#undef This_process
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

    if (!mcNCounter[9]) fprintf(stderr, "Warning: No neutron could reach Component[9] Al_incoherent_B\n");
    if (mcAbsorbProp[9]) fprintf(stderr, "Warning: %g events were removed in Component[9] Al_incoherent_B=Incoherent_process()\n"
"         (negative time, miss next components, rounding errors, Nan, Inf).\n", mcAbsorbProp[9]);
  /* User FINALLY code for component 'Al_powder_B'. */
  SIG_MESSAGE("Al_powder_B (Finally)");
#define mccompcurname  Al_powder_B
#define mccompcurtype  Powder_process
#define mccompcurindex 10
#define format mccAl_powder_B_format
#define This_process mccAl_powder_B_This_process
#define Powder_storage mccAl_powder_B_Powder_storage
#define effective_my_scattering mccAl_powder_B_effective_my_scattering
#define d_phi mccAl_powder_B_d_phi
#define line_info mccAl_powder_B_line_info
#define columns mccAl_powder_B_columns
{   /* Declarations of Al_powder_B=Powder_process() SETTING parameters. */
char* reflections = mccAl_powder_B_reflections;
MCNUM packing_factor = mccAl_powder_B_packing_factor;
MCNUM Vc = mccAl_powder_B_Vc;
MCNUM delta_d_d = mccAl_powder_B_delta_d_d;
MCNUM DW = mccAl_powder_B_DW;
MCNUM nb_atoms = mccAl_powder_B_nb_atoms;
MCNUM d_phi = mccAl_powder_B_d_phi;
MCNUM density = mccAl_powder_B_density;
MCNUM weight = mccAl_powder_B_weight;
MCNUM barns = mccAl_powder_B_barns;
MCNUM Strain = mccAl_powder_B_Strain;
MCNUM interact_fraction = mccAl_powder_B_interact_fraction;
#line 766 "Powder_process.comp"
{
  free(line_info.list);
  free(line_info.q_v);
  free(line_info.w_v);
  free(line_info.my_s_v2);
}
#line 475182 "MACS_sample_kidney_box.c"
}   /* End of Al_powder_B=Powder_process() SETTING parameter declarations. */
#undef columns
#undef line_info
#undef d_phi
#undef effective_my_scattering
#undef Powder_storage
#undef This_process
#undef format
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

    if (!mcNCounter[10]) fprintf(stderr, "Warning: No neutron could reach Component[10] Al_powder_B\n");
    if (mcAbsorbProp[10]) fprintf(stderr, "Warning: %g events were removed in Component[10] Al_powder_B=Powder_process()\n"
"         (negative time, miss next components, rounding errors, Nan, Inf).\n", mcAbsorbProp[10]);
  /* User FINALLY code for component 'Al_B'. */
  SIG_MESSAGE("Al_B (Finally)");
#define mccompcurname  Al_B
#define mccompcurtype  Union_make_material
#define mccompcurindex 11
#define loop_index mccAl_B_loop_index
#define this_material mccAl_B_this_material
#define accepted_processes mccAl_B_accepted_processes
#define global_material_element mccAl_B_global_material_element
{   /* Declarations of Al_B=Union_make_material() SETTING parameters. */
char* process_string = mccAl_B_process_string;
MCNUM my_absorption = mccAl_B_my_absorption;
MCNUM absorber = mccAl_B_absorber;
#line 259 "Union_make_material.comp"
{
// The elements of the scattering array used static allocation and is thus deallocated automatically
if (this_material.number_of_processes > 0) free(this_material.p_scattering_array);
if (accepted_processes.num_elements > 0) free(accepted_processes.elements);

// Checking if any Union volumes are defined after the master component
#ifdef MASTER_DETECTOR
  #ifdef ANY_GEOMETRY_DETECTOR_DECLARE
    #ifndef MASTER_DETECTOR_WARNING
      for (loop_index=0;loop_index<global_geometry_list.num_elements;loop_index++) {
        if (global_geometry_list.elements[loop_index].component_index > global_master_list.elements[global_master_list.num_elements-1].component_index) {
          printf("WARNING: No Union_master component defined after Union volume named %s, this components did not affect the simulation in any way.\n",global_geometry_list.elements[loop_index].name);
        }
      }
      // Decided to have this as a warning without exiting the simulation
      // In order to only show this warning once, the MASTER_DETECTOR_WARNING is defined
      #define MASTER_DETECTOR_WARNING dummy
    #endif
  #endif
#endif

// Checking if the user remembered to put in a Union_master
#ifndef MASTER_DETECTOR
  #ifdef ANY_GEOMETRY_DETECTOR_DECLARE
    #ifndef MASTER_DETECTOR_WARNING
      printf("\nWARNING: No Union_master component used, these components did not affect the simulation in any way:\n");
      for (loop_index=0;loop_index<global_geometry_list.num_elements;loop_index++)
        printf("  %s\n",global_geometry_list.elements[loop_index].name);
      printf("\n");
      // Decided to have this as a warning without exiting the simulation
      // In order to only show this warning once, the MASTER_DETECTOR_WARNING is defined
      #define MASTER_DETECTOR_WARNING dummy
    #endif
  #endif
#endif


}
#line 475249 "MACS_sample_kidney_box.c"
}   /* End of Al_B=Union_make_material() SETTING parameter declarations. */
#undef global_material_element
#undef accepted_processes
#undef this_material
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

    if (!mcNCounter[11]) fprintf(stderr, "Warning: No neutron could reach Component[11] Al_B\n");
    if (mcAbsorbProp[11]) fprintf(stderr, "Warning: %g events were removed in Component[11] Al_B=Union_make_material()\n"
"         (negative time, miss next components, rounding errors, Nan, Inf).\n", mcAbsorbProp[11]);
  /* User FINALLY code for component 'Arm0'. */
  SIG_MESSAGE("Arm0 (Finally)");
#define mccompcurname  Arm0
#define mccompcurtype  Progress_bar
#define mccompcurindex 12
#define IntermediateCnts mccArm0_IntermediateCnts
#define StartTime mccArm0_StartTime
#define EndTime mccArm0_EndTime
#define CurrentTime mccArm0_CurrentTime
{   /* Declarations of Arm0=Progress_bar() SETTING parameters. */
char* profile = mccArm0_profile;
MCNUM percent = mccArm0_percent;
MCNUM flag_save = mccArm0_flag_save;
MCNUM minutes = mccArm0_minutes;
#line 133 "/usr/share/mcstas/2.7/misc/Progress_bar.comp"
{
  time_t NowTime;
  time(&NowTime);
  fprintf(stdout, "\nFinally [%s: %s]. Time: ", mcinstrument_name, mcdirname ? mcdirname : ".");
  if (difftime(NowTime,StartTime) < 60.0)
    fprintf(stdout, "%g [s] ", difftime(NowTime,StartTime));
  else if (difftime(NowTime,StartTime) > 3600.0)
    fprintf(stdout, "%g [h] ", difftime(NowTime,StartTime)/3660.0);
  else
    fprintf(stdout, "%g [min] ", difftime(NowTime,StartTime)/60.0);
  fprintf(stdout, "\n");
}
#line 475288 "MACS_sample_kidney_box.c"
}   /* End of Arm0=Progress_bar() SETTING parameter declarations. */
#undef CurrentTime
#undef EndTime
#undef StartTime
#undef IntermediateCnts
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

    if (!mcNCounter[12]) fprintf(stderr, "Warning: No neutron could reach Component[12] Arm0\n");
    if (mcAbsorbProp[12]) fprintf(stderr, "Warning: %g events were removed in Component[12] Arm0=Progress_bar()\n"
"         (negative time, miss next components, rounding errors, Nan, Inf).\n", mcAbsorbProp[12]);
  /* User FINALLY code for component 'Guide_end'. */
  SIG_MESSAGE("Guide_end (Finally)");
#define mccompcurname  Guide_end
#define mccompcurtype  Virtual_input
#define mccompcurindex 13
#define read_block mccGuide_end_read_block
#define pos mccGuide_end_pos
#define nrows mccGuide_end_nrows
#define Offset mccGuide_end_Offset
#define rTable mccGuide_end_rTable
#define repeat_number mccGuide_end_repeat_number
#define filename_ncount mccGuide_end_filename_ncount
#define mean_vx mccGuide_end_mean_vx
#define mean_vy mccGuide_end_mean_vy
#define mean_vz mccGuide_end_mean_vz
#define mean_dx mccGuide_end_mean_dx
#define mean_dy mccGuide_end_mean_dy
#define mean_dz mccGuide_end_mean_dz
#define n_neutrons mccGuide_end_n_neutrons
#define min_x mccGuide_end_min_x
#define min_y mccGuide_end_min_y
#define min_z mccGuide_end_min_z
#define max_x mccGuide_end_max_x
#define max_y mccGuide_end_max_y
#define max_z mccGuide_end_max_z
#define min_vx mccGuide_end_min_vx
#define min_vy mccGuide_end_min_vy
#define min_vz mccGuide_end_min_vz
#define max_vx mccGuide_end_max_vx
#define max_vy mccGuide_end_max_vy
#define max_vz mccGuide_end_max_vz
#define first_block mccGuide_end_first_block
#define mean_x mccGuide_end_mean_x
#define mean_y mccGuide_end_mean_y
#define mean_z mccGuide_end_mean_z
#define end_reading mccGuide_end_end_reading
#define n_count_extrapolated mccGuide_end_n_count_extrapolated
#define repeat_cnt mccGuide_end_repeat_cnt
{   /* Declarations of Guide_end=Virtual_input() SETTING parameters. */
char* filename = mccGuide_end_filename;
MCNUM verbose = mccGuide_end_verbose;
MCNUM repeat_count = mccGuide_end_repeat_count;
MCNUM smooth = mccGuide_end_smooth;
MCNUM display = mccGuide_end_display;
#line 335 "/usr/share/mcstas/2.7/obsolete/Virtual_input.comp"
{
  Table_Free(&rTable);
  if (!filename_ncount) {
    printf("Warning: Virtual_input: %s: filename '%s' was not used entirely.\n"
           "               Intensities may be wrong. Increase ncount value\n",
           NAME_CURRENT_COMP, filename);
  } else {
    double tmp;
    tmp = (double)mcget_ncount()/filename_ncount;
    if (fabs(rint(tmp)/tmp-1) > 0.02)
      printf("Warning: Virtual_input: %s: simulation finished in the middle of filename '%s'\n"
             "               ncount=%g but filename contains %g events\n"
             "               Intensities may be wrong.\n"
             "               Increase ncount value to %g or higher.\n",
	     NAME_CURRENT_COMP, filename, (double)mcget_ncount(), filename_ncount, filename_ncount*repeat_cnt);
    if (mcget_ncount() < filename_ncount*repeat_cnt)
      printf("Warning: Virtual_input: %s: not all source %s repetitions were generated.\n"
             "               Intensities may be wrong.\n"
             "               Increase ncount value to %g or higher.\n",
             NAME_CURRENT_COMP, filename, filename_ncount*repeat_cnt);
  }
}
#line 475367 "MACS_sample_kidney_box.c"
}   /* End of Guide_end=Virtual_input() SETTING parameter declarations. */
#undef repeat_cnt
#undef n_count_extrapolated
#undef end_reading
#undef mean_z
#undef mean_y
#undef mean_x
#undef first_block
#undef max_vz
#undef max_vy
#undef max_vx
#undef min_vz
#undef min_vy
#undef min_vx
#undef max_z
#undef max_y
#undef max_x
#undef min_z
#undef min_y
#undef min_x
#undef n_neutrons
#undef mean_dz
#undef mean_dy
#undef mean_dx
#undef mean_vz
#undef mean_vy
#undef mean_vx
#undef filename_ncount
#undef repeat_number
#undef rTable
#undef Offset
#undef nrows
#undef pos
#undef read_block
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

    if (!mcNCounter[13]) fprintf(stderr, "Warning: No neutron could reach Component[13] Guide_end\n");
    if (mcAbsorbProp[13]) fprintf(stderr, "Warning: %g events were removed in Component[13] Guide_end=Virtual_input()\n"
"         (negative time, miss next components, rounding errors, Nan, Inf).\n", mcAbsorbProp[13]);
    if (!mcNCounter[14]) fprintf(stderr, "Warning: No neutron could reach Component[14] main_slit\n");
    if (mcAbsorbProp[14]) fprintf(stderr, "Warning: %g events were removed in Component[14] main_slit=Slit()\n"
"         (negative time, miss next components, rounding errors, Nan, Inf).\n", mcAbsorbProp[14]);
    if (!mcNCounter[15]) fprintf(stderr, "Warning: No neutron could reach Component[15] target\n");
    if (mcAbsorbProp[15]) fprintf(stderr, "Warning: %g events were removed in Component[15] target=Arm()\n"
"         (negative time, miss next components, rounding errors, Nan, Inf).\n", mcAbsorbProp[15]);
    if (!mcNCounter[16]) fprintf(stderr, "Warning: No neutron could reach Component[16] cryostat_center\n");
    if (mcAbsorbProp[16]) fprintf(stderr, "Warning: %g events were removed in Component[16] cryostat_center=Arm()\n"
"         (negative time, miss next components, rounding errors, Nan, Inf).\n", mcAbsorbProp[16]);
    if (!mcNCounter[17]) fprintf(stderr, "Warning: No neutron could reach Component[17] drum_center\n");
    if (mcAbsorbProp[17]) fprintf(stderr, "Warning: %g events were removed in Component[17] drum_center=Arm()\n"
"         (negative time, miss next components, rounding errors, Nan, Inf).\n", mcAbsorbProp[17]);
    if (!mcNCounter[18]) fprintf(stderr, "Warning: No neutron could reach Component[18] crystal_assembly\n");
    if (mcAbsorbProp[18]) fprintf(stderr, "Warning: %g events were removed in Component[18] crystal_assembly=Arm()\n"
"         (negative time, miss next components, rounding errors, Nan, Inf).\n", mcAbsorbProp[18]);
    if (!mcNCounter[19]) fprintf(stderr, "Warning: No neutron could reach Component[19] crystal_axis\n");
    if (mcAbsorbProp[19]) fprintf(stderr, "Warning: %g events were removed in Component[19] crystal_axis=Arm()\n"
"         (negative time, miss next components, rounding errors, Nan, Inf).\n", mcAbsorbProp[19]);
    if (!mcNCounter[20]) fprintf(stderr, "Warning: No neutron could reach Component[20] sample\n");
    if (mcAbsorbProp[20]) fprintf(stderr, "Warning: %g events were removed in Component[20] sample=Union_box()\n"
"         (negative time, miss next components, rounding errors, Nan, Inf).\n", mcAbsorbProp[20]);
    if (!mcNCounter[21]) fprintf(stderr, "Warning: No neutron could reach Component[21] sample_plate\n");
    if (mcAbsorbProp[21]) fprintf(stderr, "Warning: %g events were removed in Component[21] sample_plate=Union_cylinder()\n"
"         (negative time, miss next components, rounding errors, Nan, Inf).\n", mcAbsorbProp[21]);
    if (!mcNCounter[22]) fprintf(stderr, "Warning: No neutron could reach Component[22] sample_plate_rod\n");
    if (mcAbsorbProp[22]) fprintf(stderr, "Warning: %g events were removed in Component[22] sample_plate_rod=Union_cylinder()\n"
"         (negative time, miss next components, rounding errors, Nan, Inf).\n", mcAbsorbProp[22]);
    if (!mcNCounter[23]) fprintf(stderr, "Warning: No neutron could reach Component[23] sample_base\n");
    if (mcAbsorbProp[23]) fprintf(stderr, "Warning: %g events were removed in Component[23] sample_base=Union_cylinder()\n"
"         (negative time, miss next components, rounding errors, Nan, Inf).\n", mcAbsorbProp[23]);
    if (!mcNCounter[24]) fprintf(stderr, "Warning: No neutron could reach Component[24] sample_base_gap\n");
    if (mcAbsorbProp[24]) fprintf(stderr, "Warning: %g events were removed in Component[24] sample_base_gap=Union_cylinder()\n"
"         (negative time, miss next components, rounding errors, Nan, Inf).\n", mcAbsorbProp[24]);
    if (!mcNCounter[25]) fprintf(stderr, "Warning: No neutron could reach Component[25] cryostat_mountin_plate\n");
    if (mcAbsorbProp[25]) fprintf(stderr, "Warning: %g events were removed in Component[25] cryostat_mountin_plate=Union_cylinder()\n"
"         (negative time, miss next components, rounding errors, Nan, Inf).\n", mcAbsorbProp[25]);
    if (!mcNCounter[26]) fprintf(stderr, "Warning: No neutron could reach Component[26] cryostat_drum_walls\n");
    if (mcAbsorbProp[26]) fprintf(stderr, "Warning: %g events were removed in Component[26] cryostat_drum_walls=Union_cylinder()\n"
"         (negative time, miss next components, rounding errors, Nan, Inf).\n", mcAbsorbProp[26]);
    if (!mcNCounter[27]) fprintf(stderr, "Warning: No neutron could reach Component[27] cryostat_drum_vacuum\n");
    if (mcAbsorbProp[27]) fprintf(stderr, "Warning: %g events were removed in Component[27] cryostat_drum_vacuum=Union_cylinder()\n"
"         (negative time, miss next components, rounding errors, Nan, Inf).\n", mcAbsorbProp[27]);
    if (!mcNCounter[28]) fprintf(stderr, "Warning: No neutron could reach Component[28] outer_cryostat_wall\n");
    if (mcAbsorbProp[28]) fprintf(stderr, "Warning: %g events were removed in Component[28] outer_cryostat_wall=Union_cylinder()\n"
"         (negative time, miss next components, rounding errors, Nan, Inf).\n", mcAbsorbProp[28]);
    if (!mcNCounter[29]) fprintf(stderr, "Warning: No neutron could reach Component[29] outer_cryostat_vacuum\n");
    if (mcAbsorbProp[29]) fprintf(stderr, "Warning: %g events were removed in Component[29] outer_cryostat_vacuum=Union_cylinder()\n"
"         (negative time, miss next components, rounding errors, Nan, Inf).\n", mcAbsorbProp[29]);
    if (!mcNCounter[30]) fprintf(stderr, "Warning: No neutron could reach Component[30] inner_cryostat_wall\n");
    if (mcAbsorbProp[30]) fprintf(stderr, "Warning: %g events were removed in Component[30] inner_cryostat_wall=Union_cylinder()\n"
"         (negative time, miss next components, rounding errors, Nan, Inf).\n", mcAbsorbProp[30]);
    if (!mcNCounter[31]) fprintf(stderr, "Warning: No neutron could reach Component[31] inner_cryostat_vacuum\n");
    if (mcAbsorbProp[31]) fprintf(stderr, "Warning: %g events were removed in Component[31] inner_cryostat_vacuum=Union_cylinder()\n"
"         (negative time, miss next components, rounding errors, Nan, Inf).\n", mcAbsorbProp[31]);
    if (!mcNCounter[32]) fprintf(stderr, "Warning: No neutron could reach Component[32] sample_stick_walls\n");
    if (mcAbsorbProp[32]) fprintf(stderr, "Warning: %g events were removed in Component[32] sample_stick_walls=Union_cylinder()\n"
"         (negative time, miss next components, rounding errors, Nan, Inf).\n", mcAbsorbProp[32]);
    if (!mcNCounter[33]) fprintf(stderr, "Warning: No neutron could reach Component[33] sample_stick_vacuum\n");
    if (mcAbsorbProp[33]) fprintf(stderr, "Warning: %g events were removed in Component[33] sample_stick_vacuum=Union_cylinder()\n"
"         (negative time, miss next components, rounding errors, Nan, Inf).\n", mcAbsorbProp[33]);
    if (!mcNCounter[34]) fprintf(stderr, "Warning: No neutron could reach Component[34] sample_rod_bottom\n");
    if (mcAbsorbProp[34]) fprintf(stderr, "Warning: %g events were removed in Component[34] sample_rod_bottom=Arm()\n"
"         (negative time, miss next components, rounding errors, Nan, Inf).\n", mcAbsorbProp[34]);
    if (!mcNCounter[35]) fprintf(stderr, "Warning: No neutron could reach Component[35] sample_rod\n");
    if (mcAbsorbProp[35]) fprintf(stderr, "Warning: %g events were removed in Component[35] sample_rod=Union_cylinder()\n"
"         (negative time, miss next components, rounding errors, Nan, Inf).\n", mcAbsorbProp[35]);
    if (!mcNCounter[36]) fprintf(stderr, "Warning: No neutron could reach Component[36] sample_rod_collar_1\n");
    if (mcAbsorbProp[36]) fprintf(stderr, "Warning: %g events were removed in Component[36] sample_rod_collar_1=Union_cylinder()\n"
"         (negative time, miss next components, rounding errors, Nan, Inf).\n", mcAbsorbProp[36]);
    if (!mcNCounter[37]) fprintf(stderr, "Warning: No neutron could reach Component[37] sample_rod_collar_2\n");
    if (mcAbsorbProp[37]) fprintf(stderr, "Warning: %g events were removed in Component[37] sample_rod_collar_2=Union_cylinder()\n"
"         (negative time, miss next components, rounding errors, Nan, Inf).\n", mcAbsorbProp[37]);
    if (!mcNCounter[38]) fprintf(stderr, "Warning: No neutron could reach Component[38] sample_rod_collar_3\n");
    if (mcAbsorbProp[38]) fprintf(stderr, "Warning: %g events were removed in Component[38] sample_rod_collar_3=Union_cylinder()\n"
"         (negative time, miss next components, rounding errors, Nan, Inf).\n", mcAbsorbProp[38]);
    if (!mcNCounter[39]) fprintf(stderr, "Warning: No neutron could reach Component[39] sample_rod_collar_4\n");
    if (mcAbsorbProp[39]) fprintf(stderr, "Warning: %g events were removed in Component[39] sample_rod_collar_4=Union_cylinder()\n"
"         (negative time, miss next components, rounding errors, Nan, Inf).\n", mcAbsorbProp[39]);
    if (!mcNCounter[40]) fprintf(stderr, "Warning: No neutron could reach Component[40] sample_rod_collar_1_vacuum\n");
    if (mcAbsorbProp[40]) fprintf(stderr, "Warning: %g events were removed in Component[40] sample_rod_collar_1_vacuum=Union_cylinder()\n"
"         (negative time, miss next components, rounding errors, Nan, Inf).\n", mcAbsorbProp[40]);
    if (!mcNCounter[41]) fprintf(stderr, "Warning: No neutron could reach Component[41] sample_rod_collar_2_vacuum\n");
    if (mcAbsorbProp[41]) fprintf(stderr, "Warning: %g events were removed in Component[41] sample_rod_collar_2_vacuum=Union_cylinder()\n"
"         (negative time, miss next components, rounding errors, Nan, Inf).\n", mcAbsorbProp[41]);
    if (!mcNCounter[42]) fprintf(stderr, "Warning: No neutron could reach Component[42] sample_rod_collar_3_vacuum\n");
    if (mcAbsorbProp[42]) fprintf(stderr, "Warning: %g events were removed in Component[42] sample_rod_collar_3_vacuum=Union_cylinder()\n"
"         (negative time, miss next components, rounding errors, Nan, Inf).\n", mcAbsorbProp[42]);
    if (!mcNCounter[43]) fprintf(stderr, "Warning: No neutron could reach Component[43] sample_rod_collar_4_vacuum\n");
    if (mcAbsorbProp[43]) fprintf(stderr, "Warning: %g events were removed in Component[43] sample_rod_collar_4_vacuum=Union_cylinder()\n"
"         (negative time, miss next components, rounding errors, Nan, Inf).\n", mcAbsorbProp[43]);
    if (!mcNCounter[44]) fprintf(stderr, "Warning: No neutron could reach Component[44] resolution_sample_exit\n");
    if (mcAbsorbProp[44]) fprintf(stderr, "Warning: %g events were removed in Component[44] resolution_sample_exit=Union_cylinder()\n"
"         (negative time, miss next components, rounding errors, Nan, Inf).\n", mcAbsorbProp[44]);
  /* User FINALLY code for component 'sample_cryostat'. */
  SIG_MESSAGE("sample_cryostat (Finally)");
#define mccompcurname  sample_cryostat
#define mccompcurtype  Union_master
#define mccompcurindex 45
#define verbal mccsample_cryostat_verbal
#define list_verbal mccsample_cryostat_list_verbal
#define trace_verbal mccsample_cryostat_trace_verbal
#define finally_verbal mccsample_cryostat_finally_verbal
#define starting_volume_warning mccsample_cryostat_starting_volume_warning
#define global_master_element mccsample_cryostat_global_master_element
#define this_global_master_index mccsample_cryostat_this_global_master_index
#define previous_master_index mccsample_cryostat_previous_master_index
#define geometry_list_index mccsample_cryostat_geometry_list_index
#define intersection_time_table mccsample_cryostat_intersection_time_table
#define Volumes mccsample_cryostat_Volumes
#define Geometries mccsample_cryostat_Geometries
#define starting_lists mccsample_cryostat_starting_lists
#define r mccsample_cryostat_r
#define r_start mccsample_cryostat_r_start
#define v mccsample_cryostat_v
#define error_msg mccsample_cryostat_error_msg
#define component_error_msg mccsample_cryostat_component_error_msg
#define string_output mccsample_cryostat_string_output
#define number_of_volumes mccsample_cryostat_number_of_volumes
#define volume_index mccsample_cryostat_volume_index
#define process_index mccsample_cryostat_process_index
#define solutions mccsample_cryostat_solutions
#define max_number_of_processes mccsample_cryostat_max_number_of_processes
#define limit mccsample_cryostat_limit
#define solution mccsample_cryostat_solution
#define min_solution mccsample_cryostat_min_solution
#define min_volume mccsample_cryostat_min_volume
#define time_found mccsample_cryostat_time_found
#define intersection_time mccsample_cryostat_intersection_time
#define min_intersection_time mccsample_cryostat_min_intersection_time
#define process mccsample_cryostat_process
#define process_start mccsample_cryostat_process_start
#define my_trace mccsample_cryostat_my_trace
#define p_my_trace mccsample_cryostat_p_my_trace
#define my_trace_fraction_control mccsample_cryostat_my_trace_fraction_control
#define k mccsample_cryostat_k
#define k_new mccsample_cryostat_k_new
#define k_old mccsample_cryostat_k_old
#define v_length mccsample_cryostat_v_length
#define my_sum mccsample_cryostat_my_sum
#define my_sum_plus_abs mccsample_cryostat_my_sum_plus_abs
#define culmative_probability mccsample_cryostat_culmative_probability
#define mc_prop mccsample_cryostat_mc_prop
#define time_to_scattering mccsample_cryostat_time_to_scattering
#define length_to_scattering mccsample_cryostat_length_to_scattering
#define length_to_boundery mccsample_cryostat_length_to_boundery
#define time_to_boundery mccsample_cryostat_time_to_boundery
#define selected_process mccsample_cryostat_selected_process
#define scattering_event mccsample_cryostat_scattering_event
#define time_propagated_without_scattering mccsample_cryostat_time_propagated_without_scattering
#define a_next_volume_found mccsample_cryostat_a_next_volume_found
#define next_volume mccsample_cryostat_next_volume
#define next_volume_priority mccsample_cryostat_next_volume_priority
#define done mccsample_cryostat_done
#define current_volume mccsample_cryostat_current_volume
#define number_of_solutions mccsample_cryostat_number_of_solutions
#define number_of_solutions_static mccsample_cryostat_number_of_solutions_static
#define check mccsample_cryostat_check
#define start mccsample_cryostat_start
#define intersection_with_children mccsample_cryostat_intersection_with_children
#define geometry_output mccsample_cryostat_geometry_output
#define tree_next_volume mccsample_cryostat_tree_next_volume
#define pre_allocated1 mccsample_cryostat_pre_allocated1
#define pre_allocated2 mccsample_cryostat_pre_allocated2
#define pre_allocated3 mccsample_cryostat_pre_allocated3
#define ray_position mccsample_cryostat_ray_position
#define ray_velocity mccsample_cryostat_ray_velocity
#define ray_velocity_final mccsample_cryostat_ray_velocity_final
#define volume_0_found mccsample_cryostat_volume_0_found
#define scattered_flag mccsample_cryostat_scattered_flag
#define scattered_flag_VP mccsample_cryostat_scattered_flag_VP
#define master_transposed_rotation_matrix mccsample_cryostat_master_transposed_rotation_matrix
#define temp_rotation_matrix mccsample_cryostat_temp_rotation_matrix
#define non_rotated_position mccsample_cryostat_non_rotated_position
#define rotated_position mccsample_cryostat_rotated_position
#define enable_tagging mccsample_cryostat_enable_tagging
#define stop_tagging_ray mccsample_cryostat_stop_tagging_ray
#define stop_creating_nodes mccsample_cryostat_stop_creating_nodes
#define enable_tagging_check mccsample_cryostat_enable_tagging_check
#define master_tagging_node_list mccsample_cryostat_master_tagging_node_list
#define current_tagging_node mccsample_cryostat_current_tagging_node
#define tagging_leaf_counter mccsample_cryostat_tagging_leaf_counter
#define number_of_scattering_events mccsample_cryostat_number_of_scattering_events
#define real_transmission_probability mccsample_cryostat_real_transmission_probability
#define mc_transmission_probability mccsample_cryostat_mc_transmission_probability
#define number_of_masks mccsample_cryostat_number_of_masks
#define number_of_masked_volumes mccsample_cryostat_number_of_masked_volumes
#define need_to_run_within_which_volume mccsample_cryostat_need_to_run_within_which_volume
#define mask_index_main mccsample_cryostat_mask_index_main
#define mask_iterate mccsample_cryostat_mask_iterate
#define mask_status_list mccsample_cryostat_mask_status_list
#define current_mask_intersect_list_status mccsample_cryostat_current_mask_intersect_list_status
#define mask_volume_index_list mccsample_cryostat_mask_volume_index_list
#define geometry_component_index_list mccsample_cryostat_geometry_component_index_list
#define Volume_copies_allocated mccsample_cryostat_Volume_copies_allocated
#define p_old mccsample_cryostat_p_old
#define this_logger mccsample_cryostat_this_logger
#define conditional_status mccsample_cryostat_conditional_status
#define tagging_conditional_list mccsample_cryostat_tagging_conditional_list
#define free_tagging_conditioanl_list mccsample_cryostat_free_tagging_conditioanl_list
#define logger_conditional_extend_array mccsample_cryostat_logger_conditional_extend_array
#define tagging_conditional_extend mccsample_cryostat_tagging_conditional_extend
#define max_conditional_extend_index mccsample_cryostat_max_conditional_extend_index
#define safty_distance mccsample_cryostat_safty_distance
#define safty_distance2 mccsample_cryostat_safty_distance2
#define number_of_processes_array mccsample_cryostat_number_of_processes_array
#define temporary_focus_data mccsample_cryostat_temporary_focus_data
#define focus_data_index mccsample_cryostat_focus_data_index
{   /* Declarations of sample_cryostat=Union_master() SETTING parameters. */
MCNUM allow_inside_start = mccsample_cryostat_allow_inside_start;
MCNUM history_limit = mccsample_cryostat_history_limit;
MCNUM enable_conditionals = mccsample_cryostat_enable_conditionals;
MCNUM inherit_number_of_scattering_events = mccsample_cryostat_inherit_number_of_scattering_events;
#line 1927 "Union_master.comp"
{
// write out histories from tagging system if enabled
if (enable_tagging) {
    if (finally_verbal) printf("Writing tagging tree to disk \n");
    if (finally_verbal) printf("Number of leafs = %d \n",tagging_leaf_counter);
    // While writing the tagging tree to disk, all the leafs are deallocated
    write_tagging_tree(&master_tagging_node_list, Volumes, tagging_leaf_counter, number_of_volumes);
}
if (master_tagging_node_list.num_elements > 0) free(master_tagging_node_list.elements);




if (finally_verbal) printf("Freeing variables which are always allocated \n");
// free allocated arrays specific to this master union component
free(scattered_flag);
free(my_trace);
free(pre_allocated1);
free(pre_allocated2);
free(pre_allocated3);
free(number_of_processes_array);

if (finally_verbal) printf("Freeing intersection_time_table \n");
for (iterate = 1;iterate < intersection_time_table.num_volumes;iterate++){
    free(intersection_time_table.intersection_times[iterate]);
}

free(intersection_time_table.n_elements);
free(intersection_time_table.calculated);
free(intersection_time_table.intersection_times);

if (free_tagging_conditioanl_list == 1) free(tagging_conditional_list);

/*
if (tagging_conditional_list->num_elements > 0) {
  free(tagging_conditional_list.conditional_functions);
  free(tagging_conditional_list.p_data_unions);
}
*/

if (finally_verbal) printf("Freeing lists for individual volumes \n");
for (volume_index=0;volume_index<number_of_volumes;volume_index++) {
  
  if (Volumes[volume_index]->geometry.intersect_check_list.num_elements > 0) free(Volumes[volume_index]->geometry.intersect_check_list.elements);
  if (Volumes[volume_index]->geometry.destinations_list.num_elements > 0) free(Volumes[volume_index]->geometry.destinations_list.elements);
  if (Volumes[volume_index]->geometry.reduced_destinations_list.num_elements > 0) free(Volumes[volume_index]->geometry.reduced_destinations_list.elements);
  if (Volumes[volume_index]->geometry.children.num_elements > 0) free(Volumes[volume_index]->geometry.children.elements);
  if (Volumes[volume_index]->geometry.direct_children.num_elements > 0) free(Volumes[volume_index]->geometry.direct_children.elements);
  if (Volumes[volume_index]->geometry.masked_by_list.num_elements > 0) free(Volumes[volume_index]->geometry.masked_by_list.elements);
  if (Volumes[volume_index]->geometry.masked_by_mask_index_list.num_elements > 0) free(Volumes[volume_index]->geometry.masked_by_mask_index_list.elements);
  if (Volumes[volume_index]->geometry.mask_list.num_elements > 0) free(Volumes[volume_index]->geometry.mask_list.elements);
  if (Volumes[volume_index]->geometry.mask_intersect_list.num_elements > 0) free(Volumes[volume_index]->geometry.mask_intersect_list.elements);
  if (enable_tagging)
    if (Volumes[volume_index]->geometry.next_volume_list.num_elements > 0) free(Volumes[volume_index]->geometry.next_volume_list.elements);
  // Add dealocation of logging
  

  if (volume_index > 0) { // Volume 0 does not have physical properties allocated
    free(scattered_flag_VP[volume_index]);
    if (Volumes[volume_index]->geometry.process_rot_allocated == 1) {
          free(Volumes[volume_index]->geometry.process_rot_matrix_array);
          free(Volumes[volume_index]->geometry.transpose_process_rot_matrix_array);
          Volumes[volume_index]->geometry.process_rot_allocated = 0;
    }
    if (on_int_list(Volume_copies_allocated,volume_index))
      // This is a local copy of a volume, deallocate that local copy (all the allocated memory attachted to it was just deallocated, so this should not leave any leaks)
      free(Volumes[volume_index]);
    else
      // Only free p_physics for vacuum volumes for the original at the end (there is a p_physics allocated for each vacuum volume)
      if (Volumes[volume_index]->p_physics->is_vacuum == 1 ) free(Volumes[volume_index]->p_physics);
  }
  
  if (Volumes[volume_index]->loggers.num_elements >0) {
    for (iterate=0;iterate<Volumes[volume_index]->loggers.num_elements;iterate++) {
      free(Volumes[volume_index]->loggers.p_logger_volume[iterate].p_logger_process);
    }
    free(Volumes[volume_index]->loggers.p_logger_volume);
  }
  
}

free(scattered_flag_VP);

if (finally_verbal) printf("Freeing starting lists \n");
if (starting_lists.allowed_starting_volume_logic_list.num_elements > 0) free(starting_lists.allowed_starting_volume_logic_list.elements);
if (starting_lists.reduced_start_list.num_elements > 0) free(starting_lists.reduced_start_list.elements);
if (starting_lists.start_logic_list.num_elements > 0) free(starting_lists.start_logic_list.elements);

if (finally_verbal) printf("Freeing mask lists \n");
if (mask_status_list.num_elements>0) free(mask_status_list.elements);
if (current_mask_intersect_list_status.num_elements>0) free(current_mask_intersect_list_status.elements);
if (mask_volume_index_list.num_elements>0) free(mask_volume_index_list.elements);

if (finally_verbal) printf("Freeing component index list \n");
if (geometry_component_index_list.num_elements>0) free(geometry_component_index_list.elements);


if (finally_verbal) printf("Freeing Volumes \n");
free(Volumes);

// Free global allocated arrays if this is the last master union component in the instrument file

if (global_master_list.elements[global_master_list.num_elements-1].component_index == INDEX_CURRENT_COMP) {
    if (finally_verbal) printf("Freeing global arrays because this is the last Union master component\n");
    
    // Freeing lists allocated in Union_initialization
    //#ifdef PROCESS_DETECTOR
        if (finally_verbal) printf("Freeing global process list \n");
        if (global_process_list.num_elements > 0) free(global_process_list.elements);
    //#endif

    //#ifdef MATERIAL_DETECTOR
        if (finally_verbal) printf("Freeing global material list \n");
        if (global_material_list.num_elements > 0) free(global_material_list.elements);
    //#endif

    //#ifdef ANY_GEOMETRY_DETECTOR_DECLARE
        if (finally_verbal) printf("Freeing global geometry list \n");
        if (global_geometry_list.num_elements > 0) free(global_geometry_list.elements);
    //#endif
    
    //#ifdef MASTER_DETECTOR
        if (finally_verbal) printf("Freeing global master list \n");
        if (global_master_list.num_elements > 0) free(global_master_list.elements);
    //#endif
    
    
    //#ifdef UNION_LOGGER_DECLARE
    if (finally_verbal) printf("Freeing global logger lists \n");
    for (iterate=0;iterate<global_all_volume_logger_list.num_elements;iterate++) {
      if (global_all_volume_logger_list.elements[iterate].logger->conditional_list.num_elements > 0) {
        free(global_all_volume_logger_list.elements[iterate].logger->conditional_list.conditional_functions);
        free(global_all_volume_logger_list.elements[iterate].logger->conditional_list.p_data_unions);
      }
    }
    if (global_all_volume_logger_list.num_elements > 0) free(global_all_volume_logger_list.elements);
    
    
    for (iterate=0;iterate<global_specific_volumes_logger_list.num_elements;iterate++) {
      if (global_specific_volumes_logger_list.elements[iterate].logger->conditional_list.num_elements > 0) {
        free(global_specific_volumes_logger_list.elements[iterate].logger->conditional_list.conditional_functions);
        free(global_specific_volumes_logger_list.elements[iterate].logger->conditional_list.p_data_unions);
      }
    }
    if (global_specific_volumes_logger_list.num_elements > 0) free(global_specific_volumes_logger_list.elements);
    //#endif
    
    for (iterate=0;iterate<global_tagging_conditional_list.num_elements;iterate++) {
      if (global_tagging_conditional_list.elements[iterate].conditional_list.num_elements > 0) {
        free(global_tagging_conditional_list.elements[iterate].conditional_list.conditional_functions);
        free(global_tagging_conditional_list.elements[iterate].conditional_list.p_data_unions);
      }
    }
    if (global_tagging_conditional_list.num_elements>0) free(global_tagging_conditional_list.elements);
    
    /*
    if (finally_verbal) printf("Freeing global tagging conditional list \n");
    if (global_tagging_conditional_list.num_elements > 0) free(global_tagging_conditional_list.elements);
    */
}

}
#line 475752 "MACS_sample_kidney_box.c"
}   /* End of sample_cryostat=Union_master() SETTING parameter declarations. */
#undef focus_data_index
#undef temporary_focus_data
#undef number_of_processes_array
#undef safty_distance2
#undef safty_distance
#undef max_conditional_extend_index
#undef tagging_conditional_extend
#undef logger_conditional_extend_array
#undef free_tagging_conditioanl_list
#undef tagging_conditional_list
#undef conditional_status
#undef this_logger
#undef p_old
#undef Volume_copies_allocated
#undef geometry_component_index_list
#undef mask_volume_index_list
#undef current_mask_intersect_list_status
#undef mask_status_list
#undef mask_iterate
#undef mask_index_main
#undef need_to_run_within_which_volume
#undef number_of_masked_volumes
#undef number_of_masks
#undef mc_transmission_probability
#undef real_transmission_probability
#undef number_of_scattering_events
#undef tagging_leaf_counter
#undef current_tagging_node
#undef master_tagging_node_list
#undef enable_tagging_check
#undef stop_creating_nodes
#undef stop_tagging_ray
#undef enable_tagging
#undef rotated_position
#undef non_rotated_position
#undef temp_rotation_matrix
#undef master_transposed_rotation_matrix
#undef scattered_flag_VP
#undef scattered_flag
#undef volume_0_found
#undef ray_velocity_final
#undef ray_velocity
#undef ray_position
#undef pre_allocated3
#undef pre_allocated2
#undef pre_allocated1
#undef tree_next_volume
#undef geometry_output
#undef intersection_with_children
#undef start
#undef check
#undef number_of_solutions_static
#undef number_of_solutions
#undef current_volume
#undef done
#undef next_volume_priority
#undef next_volume
#undef a_next_volume_found
#undef time_propagated_without_scattering
#undef scattering_event
#undef selected_process
#undef time_to_boundery
#undef length_to_boundery
#undef length_to_scattering
#undef time_to_scattering
#undef mc_prop
#undef culmative_probability
#undef my_sum_plus_abs
#undef my_sum
#undef v_length
#undef k_old
#undef k_new
#undef k
#undef my_trace_fraction_control
#undef p_my_trace
#undef my_trace
#undef process_start
#undef process
#undef min_intersection_time
#undef intersection_time
#undef time_found
#undef min_volume
#undef min_solution
#undef solution
#undef limit
#undef max_number_of_processes
#undef solutions
#undef process_index
#undef volume_index
#undef number_of_volumes
#undef string_output
#undef component_error_msg
#undef error_msg
#undef v
#undef r_start
#undef r
#undef starting_lists
#undef Geometries
#undef Volumes
#undef intersection_time_table
#undef geometry_list_index
#undef previous_master_index
#undef this_global_master_index
#undef global_master_element
#undef starting_volume_warning
#undef finally_verbal
#undef trace_verbal
#undef list_verbal
#undef verbal
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

    if (!mcNCounter[45]) fprintf(stderr, "Warning: No neutron could reach Component[45] sample_cryostat\n");
    if (mcAbsorbProp[45]) fprintf(stderr, "Warning: %g events were removed in Component[45] sample_cryostat=Union_master()\n"
"         (negative time, miss next components, rounding errors, Nan, Inf).\n", mcAbsorbProp[45]);
    if (!mcNCounter[46]) fprintf(stderr, "Warning: No neutron could reach Component[46] Resolution_sample\n");
    if (mcAbsorbProp[46]) fprintf(stderr, "Warning: %g events were removed in Component[46] Resolution_sample=Res_sample()\n"
"         (negative time, miss next components, rounding errors, Nan, Inf).\n", mcAbsorbProp[46]);
    if (!mcNCounter[47]) fprintf(stderr, "Warning: No neutron could reach Component[47] post_sample_beamstop\n");
    if (mcAbsorbProp[47]) fprintf(stderr, "Warning: %g events were removed in Component[47] post_sample_beamstop=Beamstop()\n"
"         (negative time, miss next components, rounding errors, Nan, Inf).\n", mcAbsorbProp[47]);
    if (!mcNCounter[48]) fprintf(stderr, "Warning: No neutron could reach Component[48] kidney_master\n");
    if (mcAbsorbProp[48]) fprintf(stderr, "Warning: %g events were removed in Component[48] kidney_master=Arm()\n"
"         (negative time, miss next components, rounding errors, Nan, Inf).\n", mcAbsorbProp[48]);
    if (!mcNCounter[49]) fprintf(stderr, "Warning: No neutron could reach Component[49] kidney_channel_0\n");
    if (mcAbsorbProp[49]) fprintf(stderr, "Warning: %g events were removed in Component[49] kidney_channel_0=Arm()\n"
"         (negative time, miss next components, rounding errors, Nan, Inf).\n", mcAbsorbProp[49]);
    if (!mcNCounter[50]) fprintf(stderr, "Warning: No neutron could reach Component[50] kidney_channel_1\n");
    if (mcAbsorbProp[50]) fprintf(stderr, "Warning: %g events were removed in Component[50] kidney_channel_1=Arm()\n"
"         (negative time, miss next components, rounding errors, Nan, Inf).\n", mcAbsorbProp[50]);
    if (!mcNCounter[51]) fprintf(stderr, "Warning: No neutron could reach Component[51] kidney_channel_2\n");
    if (mcAbsorbProp[51]) fprintf(stderr, "Warning: %g events were removed in Component[51] kidney_channel_2=Arm()\n"
"         (negative time, miss next components, rounding errors, Nan, Inf).\n", mcAbsorbProp[51]);
    if (!mcNCounter[52]) fprintf(stderr, "Warning: No neutron could reach Component[52] kidney_channel_3\n");
    if (mcAbsorbProp[52]) fprintf(stderr, "Warning: %g events were removed in Component[52] kidney_channel_3=Arm()\n"
"         (negative time, miss next components, rounding errors, Nan, Inf).\n", mcAbsorbProp[52]);
    if (!mcNCounter[53]) fprintf(stderr, "Warning: No neutron could reach Component[53] kidney_channel_4\n");
    if (mcAbsorbProp[53]) fprintf(stderr, "Warning: %g events were removed in Component[53] kidney_channel_4=Arm()\n"
"         (negative time, miss next components, rounding errors, Nan, Inf).\n", mcAbsorbProp[53]);
    if (!mcNCounter[54]) fprintf(stderr, "Warning: No neutron could reach Component[54] kidney_channel_5\n");
    if (mcAbsorbProp[54]) fprintf(stderr, "Warning: %g events were removed in Component[54] kidney_channel_5=Arm()\n"
"         (negative time, miss next components, rounding errors, Nan, Inf).\n", mcAbsorbProp[54]);
    if (!mcNCounter[55]) fprintf(stderr, "Warning: No neutron could reach Component[55] kidney_channel_6\n");
    if (mcAbsorbProp[55]) fprintf(stderr, "Warning: %g events were removed in Component[55] kidney_channel_6=Arm()\n"
"         (negative time, miss next components, rounding errors, Nan, Inf).\n", mcAbsorbProp[55]);
    if (!mcNCounter[56]) fprintf(stderr, "Warning: No neutron could reach Component[56] kidney_channel_7\n");
    if (mcAbsorbProp[56]) fprintf(stderr, "Warning: %g events were removed in Component[56] kidney_channel_7=Arm()\n"
"         (negative time, miss next components, rounding errors, Nan, Inf).\n", mcAbsorbProp[56]);
    if (!mcNCounter[57]) fprintf(stderr, "Warning: No neutron could reach Component[57] kidney_channel_8\n");
    if (mcAbsorbProp[57]) fprintf(stderr, "Warning: %g events were removed in Component[57] kidney_channel_8=Arm()\n"
"         (negative time, miss next components, rounding errors, Nan, Inf).\n", mcAbsorbProp[57]);
    if (!mcNCounter[58]) fprintf(stderr, "Warning: No neutron could reach Component[58] kidney_channel_9\n");
    if (mcAbsorbProp[58]) fprintf(stderr, "Warning: %g events were removed in Component[58] kidney_channel_9=Arm()\n"
"         (negative time, miss next components, rounding errors, Nan, Inf).\n", mcAbsorbProp[58]);
    if (!mcNCounter[59]) fprintf(stderr, "Warning: No neutron could reach Component[59] kidney_channel_10\n");
    if (mcAbsorbProp[59]) fprintf(stderr, "Warning: %g events were removed in Component[59] kidney_channel_10=Arm()\n"
"         (negative time, miss next components, rounding errors, Nan, Inf).\n", mcAbsorbProp[59]);
    if (!mcNCounter[60]) fprintf(stderr, "Warning: No neutron could reach Component[60] kidney_channel_11\n");
    if (mcAbsorbProp[60]) fprintf(stderr, "Warning: %g events were removed in Component[60] kidney_channel_11=Arm()\n"
"         (negative time, miss next components, rounding errors, Nan, Inf).\n", mcAbsorbProp[60]);
    if (!mcNCounter[61]) fprintf(stderr, "Warning: No neutron could reach Component[61] kidney_channel_12\n");
    if (mcAbsorbProp[61]) fprintf(stderr, "Warning: %g events were removed in Component[61] kidney_channel_12=Arm()\n"
"         (negative time, miss next components, rounding errors, Nan, Inf).\n", mcAbsorbProp[61]);
    if (!mcNCounter[62]) fprintf(stderr, "Warning: No neutron could reach Component[62] kidney_channel_13\n");
    if (mcAbsorbProp[62]) fprintf(stderr, "Warning: %g events were removed in Component[62] kidney_channel_13=Arm()\n"
"         (negative time, miss next components, rounding errors, Nan, Inf).\n", mcAbsorbProp[62]);
    if (!mcNCounter[63]) fprintf(stderr, "Warning: No neutron could reach Component[63] kidney_channel_14\n");
    if (mcAbsorbProp[63]) fprintf(stderr, "Warning: %g events were removed in Component[63] kidney_channel_14=Arm()\n"
"         (negative time, miss next components, rounding errors, Nan, Inf).\n", mcAbsorbProp[63]);
    if (!mcNCounter[64]) fprintf(stderr, "Warning: No neutron could reach Component[64] kidney_channel_15\n");
    if (mcAbsorbProp[64]) fprintf(stderr, "Warning: %g events were removed in Component[64] kidney_channel_15=Arm()\n"
"         (negative time, miss next components, rounding errors, Nan, Inf).\n", mcAbsorbProp[64]);
    if (!mcNCounter[65]) fprintf(stderr, "Warning: No neutron could reach Component[65] kidney_channel_16\n");
    if (mcAbsorbProp[65]) fprintf(stderr, "Warning: %g events were removed in Component[65] kidney_channel_16=Arm()\n"
"         (negative time, miss next components, rounding errors, Nan, Inf).\n", mcAbsorbProp[65]);
    if (!mcNCounter[66]) fprintf(stderr, "Warning: No neutron could reach Component[66] kidney_channel_17\n");
    if (mcAbsorbProp[66]) fprintf(stderr, "Warning: %g events were removed in Component[66] kidney_channel_17=Arm()\n"
"         (negative time, miss next components, rounding errors, Nan, Inf).\n", mcAbsorbProp[66]);
    if (!mcNCounter[67]) fprintf(stderr, "Warning: No neutron could reach Component[67] kidney_channel_18\n");
    if (mcAbsorbProp[67]) fprintf(stderr, "Warning: %g events were removed in Component[67] kidney_channel_18=Arm()\n"
"         (negative time, miss next components, rounding errors, Nan, Inf).\n", mcAbsorbProp[67]);
    if (!mcNCounter[68]) fprintf(stderr, "Warning: No neutron could reach Component[68] kidney_channel_19\n");
    if (mcAbsorbProp[68]) fprintf(stderr, "Warning: %g events were removed in Component[68] kidney_channel_19=Arm()\n"
"         (negative time, miss next components, rounding errors, Nan, Inf).\n", mcAbsorbProp[68]);
    if (!mcNCounter[69]) fprintf(stderr, "Warning: No neutron could reach Component[69] channel_0_filter\n");
    if (mcAbsorbProp[69]) fprintf(stderr, "Warning: %g events were removed in Component[69] channel_0_filter=Slit_MACS()\n"
"         (negative time, miss next components, rounding errors, Nan, Inf).\n", mcAbsorbProp[69]);
    if (!mcNCounter[70]) fprintf(stderr, "Warning: No neutron could reach Component[70] channel_1_filter\n");
    if (mcAbsorbProp[70]) fprintf(stderr, "Warning: %g events were removed in Component[70] channel_1_filter=Slit_MACS()\n"
"         (negative time, miss next components, rounding errors, Nan, Inf).\n", mcAbsorbProp[70]);
    if (!mcNCounter[71]) fprintf(stderr, "Warning: No neutron could reach Component[71] channel_2_filter\n");
    if (mcAbsorbProp[71]) fprintf(stderr, "Warning: %g events were removed in Component[71] channel_2_filter=Slit_MACS()\n"
"         (negative time, miss next components, rounding errors, Nan, Inf).\n", mcAbsorbProp[71]);
    if (!mcNCounter[72]) fprintf(stderr, "Warning: No neutron could reach Component[72] channel_3_filter\n");
    if (mcAbsorbProp[72]) fprintf(stderr, "Warning: %g events were removed in Component[72] channel_3_filter=Slit_MACS()\n"
"         (negative time, miss next components, rounding errors, Nan, Inf).\n", mcAbsorbProp[72]);
    if (!mcNCounter[73]) fprintf(stderr, "Warning: No neutron could reach Component[73] channel_4_filter\n");
    if (mcAbsorbProp[73]) fprintf(stderr, "Warning: %g events were removed in Component[73] channel_4_filter=Slit_MACS()\n"
"         (negative time, miss next components, rounding errors, Nan, Inf).\n", mcAbsorbProp[73]);
    if (!mcNCounter[74]) fprintf(stderr, "Warning: No neutron could reach Component[74] channel_5_filter\n");
    if (mcAbsorbProp[74]) fprintf(stderr, "Warning: %g events were removed in Component[74] channel_5_filter=Slit_MACS()\n"
"         (negative time, miss next components, rounding errors, Nan, Inf).\n", mcAbsorbProp[74]);
    if (!mcNCounter[75]) fprintf(stderr, "Warning: No neutron could reach Component[75] channel_6_filter\n");
    if (mcAbsorbProp[75]) fprintf(stderr, "Warning: %g events were removed in Component[75] channel_6_filter=Slit_MACS()\n"
"         (negative time, miss next components, rounding errors, Nan, Inf).\n", mcAbsorbProp[75]);
    if (!mcNCounter[76]) fprintf(stderr, "Warning: No neutron could reach Component[76] channel_7_filter\n");
    if (mcAbsorbProp[76]) fprintf(stderr, "Warning: %g events were removed in Component[76] channel_7_filter=Slit_MACS()\n"
"         (negative time, miss next components, rounding errors, Nan, Inf).\n", mcAbsorbProp[76]);
    if (!mcNCounter[77]) fprintf(stderr, "Warning: No neutron could reach Component[77] channel_8_filter\n");
    if (mcAbsorbProp[77]) fprintf(stderr, "Warning: %g events were removed in Component[77] channel_8_filter=Slit_MACS()\n"
"         (negative time, miss next components, rounding errors, Nan, Inf).\n", mcAbsorbProp[77]);
    if (!mcNCounter[78]) fprintf(stderr, "Warning: No neutron could reach Component[78] channel_9_filter\n");
    if (mcAbsorbProp[78]) fprintf(stderr, "Warning: %g events were removed in Component[78] channel_9_filter=Slit_MACS()\n"
"         (negative time, miss next components, rounding errors, Nan, Inf).\n", mcAbsorbProp[78]);
    if (!mcNCounter[79]) fprintf(stderr, "Warning: No neutron could reach Component[79] channel_10_filter\n");
    if (mcAbsorbProp[79]) fprintf(stderr, "Warning: %g events were removed in Component[79] channel_10_filter=Slit_MACS()\n"
"         (negative time, miss next components, rounding errors, Nan, Inf).\n", mcAbsorbProp[79]);
    if (!mcNCounter[80]) fprintf(stderr, "Warning: No neutron could reach Component[80] channel_11_filter\n");
    if (mcAbsorbProp[80]) fprintf(stderr, "Warning: %g events were removed in Component[80] channel_11_filter=Slit_MACS()\n"
"         (negative time, miss next components, rounding errors, Nan, Inf).\n", mcAbsorbProp[80]);
    if (!mcNCounter[81]) fprintf(stderr, "Warning: No neutron could reach Component[81] channel_12_filter\n");
    if (mcAbsorbProp[81]) fprintf(stderr, "Warning: %g events were removed in Component[81] channel_12_filter=Slit_MACS()\n"
"         (negative time, miss next components, rounding errors, Nan, Inf).\n", mcAbsorbProp[81]);
    if (!mcNCounter[82]) fprintf(stderr, "Warning: No neutron could reach Component[82] channel_13_filter\n");
    if (mcAbsorbProp[82]) fprintf(stderr, "Warning: %g events were removed in Component[82] channel_13_filter=Slit_MACS()\n"
"         (negative time, miss next components, rounding errors, Nan, Inf).\n", mcAbsorbProp[82]);
    if (!mcNCounter[83]) fprintf(stderr, "Warning: No neutron could reach Component[83] channel_14_filter\n");
    if (mcAbsorbProp[83]) fprintf(stderr, "Warning: %g events were removed in Component[83] channel_14_filter=Slit_MACS()\n"
"         (negative time, miss next components, rounding errors, Nan, Inf).\n", mcAbsorbProp[83]);
    if (!mcNCounter[84]) fprintf(stderr, "Warning: No neutron could reach Component[84] channel_15_filter\n");
    if (mcAbsorbProp[84]) fprintf(stderr, "Warning: %g events were removed in Component[84] channel_15_filter=Slit_MACS()\n"
"         (negative time, miss next components, rounding errors, Nan, Inf).\n", mcAbsorbProp[84]);
    if (!mcNCounter[85]) fprintf(stderr, "Warning: No neutron could reach Component[85] channel_16_filter\n");
    if (mcAbsorbProp[85]) fprintf(stderr, "Warning: %g events were removed in Component[85] channel_16_filter=Slit_MACS()\n"
"         (negative time, miss next components, rounding errors, Nan, Inf).\n", mcAbsorbProp[85]);
    if (!mcNCounter[86]) fprintf(stderr, "Warning: No neutron could reach Component[86] channel_17_filter\n");
    if (mcAbsorbProp[86]) fprintf(stderr, "Warning: %g events were removed in Component[86] channel_17_filter=Slit_MACS()\n"
"         (negative time, miss next components, rounding errors, Nan, Inf).\n", mcAbsorbProp[86]);
    if (!mcNCounter[87]) fprintf(stderr, "Warning: No neutron could reach Component[87] channel_18_filter\n");
    if (mcAbsorbProp[87]) fprintf(stderr, "Warning: %g events were removed in Component[87] channel_18_filter=Slit_MACS()\n"
"         (negative time, miss next components, rounding errors, Nan, Inf).\n", mcAbsorbProp[87]);
    if (!mcNCounter[88]) fprintf(stderr, "Warning: No neutron could reach Component[88] channel_19_filter\n");
    if (mcAbsorbProp[88]) fprintf(stderr, "Warning: %g events were removed in Component[88] channel_19_filter=Slit_MACS()\n"
"         (negative time, miss next components, rounding errors, Nan, Inf).\n", mcAbsorbProp[88]);
    if (!mcNCounter[89]) fprintf(stderr, "Warning: No neutron could reach Component[89] channel_selector\n");
    if (mcAbsorbProp[89]) fprintf(stderr, "Warning: %g events were removed in Component[89] channel_selector=Arm()\n"
"         (negative time, miss next components, rounding errors, Nan, Inf).\n", mcAbsorbProp[89]);
    if (!mcNCounter[90]) fprintf(stderr, "Warning: No neutron could reach Component[90] channel_0_colimator\n");
    if (mcAbsorbProp[90]) fprintf(stderr, "Warning: %g events were removed in Component[90] channel_0_colimator=Collimator_linear()\n"
"         (negative time, miss next components, rounding errors, Nan, Inf).\n", mcAbsorbProp[90]);
    if (!mcNCounter[91]) fprintf(stderr, "Warning: No neutron could reach Component[91] channel_1_colimator\n");
    if (mcAbsorbProp[91]) fprintf(stderr, "Warning: %g events were removed in Component[91] channel_1_colimator=Collimator_linear()\n"
"         (negative time, miss next components, rounding errors, Nan, Inf).\n", mcAbsorbProp[91]);
    if (!mcNCounter[92]) fprintf(stderr, "Warning: No neutron could reach Component[92] channel_2_colimator\n");
    if (mcAbsorbProp[92]) fprintf(stderr, "Warning: %g events were removed in Component[92] channel_2_colimator=Collimator_linear()\n"
"         (negative time, miss next components, rounding errors, Nan, Inf).\n", mcAbsorbProp[92]);
    if (!mcNCounter[93]) fprintf(stderr, "Warning: No neutron could reach Component[93] channel_3_colimator\n");
    if (mcAbsorbProp[93]) fprintf(stderr, "Warning: %g events were removed in Component[93] channel_3_colimator=Collimator_linear()\n"
"         (negative time, miss next components, rounding errors, Nan, Inf).\n", mcAbsorbProp[93]);
    if (!mcNCounter[94]) fprintf(stderr, "Warning: No neutron could reach Component[94] channel_4_colimator\n");
    if (mcAbsorbProp[94]) fprintf(stderr, "Warning: %g events were removed in Component[94] channel_4_colimator=Collimator_linear()\n"
"         (negative time, miss next components, rounding errors, Nan, Inf).\n", mcAbsorbProp[94]);
    if (!mcNCounter[95]) fprintf(stderr, "Warning: No neutron could reach Component[95] channel_5_colimator\n");
    if (mcAbsorbProp[95]) fprintf(stderr, "Warning: %g events were removed in Component[95] channel_5_colimator=Collimator_linear()\n"
"         (negative time, miss next components, rounding errors, Nan, Inf).\n", mcAbsorbProp[95]);
    if (!mcNCounter[96]) fprintf(stderr, "Warning: No neutron could reach Component[96] channel_6_colimator\n");
    if (mcAbsorbProp[96]) fprintf(stderr, "Warning: %g events were removed in Component[96] channel_6_colimator=Collimator_linear()\n"
"         (negative time, miss next components, rounding errors, Nan, Inf).\n", mcAbsorbProp[96]);
    if (!mcNCounter[97]) fprintf(stderr, "Warning: No neutron could reach Component[97] channel_7_colimator\n");
    if (mcAbsorbProp[97]) fprintf(stderr, "Warning: %g events were removed in Component[97] channel_7_colimator=Collimator_linear()\n"
"         (negative time, miss next components, rounding errors, Nan, Inf).\n", mcAbsorbProp[97]);
    if (!mcNCounter[98]) fprintf(stderr, "Warning: No neutron could reach Component[98] channel_8_colimator\n");
    if (mcAbsorbProp[98]) fprintf(stderr, "Warning: %g events were removed in Component[98] channel_8_colimator=Collimator_linear()\n"
"         (negative time, miss next components, rounding errors, Nan, Inf).\n", mcAbsorbProp[98]);
    if (!mcNCounter[99]) fprintf(stderr, "Warning: No neutron could reach Component[99] channel_9_colimator\n");
    if (mcAbsorbProp[99]) fprintf(stderr, "Warning: %g events were removed in Component[99] channel_9_colimator=Collimator_linear()\n"
"         (negative time, miss next components, rounding errors, Nan, Inf).\n", mcAbsorbProp[99]);
    if (!mcNCounter[100]) fprintf(stderr, "Warning: No neutron could reach Component[100] channel_10_colimator\n");
    if (mcAbsorbProp[100]) fprintf(stderr, "Warning: %g events were removed in Component[100] channel_10_colimator=Collimator_linear()\n"
"         (negative time, miss next components, rounding errors, Nan, Inf).\n", mcAbsorbProp[100]);
    if (!mcNCounter[101]) fprintf(stderr, "Warning: No neutron could reach Component[101] channel_11_colimator\n");
    if (mcAbsorbProp[101]) fprintf(stderr, "Warning: %g events were removed in Component[101] channel_11_colimator=Collimator_linear()\n"
"         (negative time, miss next components, rounding errors, Nan, Inf).\n", mcAbsorbProp[101]);
    if (!mcNCounter[102]) fprintf(stderr, "Warning: No neutron could reach Component[102] channel_12_colimator\n");
    if (mcAbsorbProp[102]) fprintf(stderr, "Warning: %g events were removed in Component[102] channel_12_colimator=Collimator_linear()\n"
"         (negative time, miss next components, rounding errors, Nan, Inf).\n", mcAbsorbProp[102]);
    if (!mcNCounter[103]) fprintf(stderr, "Warning: No neutron could reach Component[103] channel_13_colimator\n");
    if (mcAbsorbProp[103]) fprintf(stderr, "Warning: %g events were removed in Component[103] channel_13_colimator=Collimator_linear()\n"
"         (negative time, miss next components, rounding errors, Nan, Inf).\n", mcAbsorbProp[103]);
    if (!mcNCounter[104]) fprintf(stderr, "Warning: No neutron could reach Component[104] channel_14_colimator\n");
    if (mcAbsorbProp[104]) fprintf(stderr, "Warning: %g events were removed in Component[104] channel_14_colimator=Collimator_linear()\n"
"         (negative time, miss next components, rounding errors, Nan, Inf).\n", mcAbsorbProp[104]);
    if (!mcNCounter[105]) fprintf(stderr, "Warning: No neutron could reach Component[105] channel_15_colimator\n");
    if (mcAbsorbProp[105]) fprintf(stderr, "Warning: %g events were removed in Component[105] channel_15_colimator=Collimator_linear()\n"
"         (negative time, miss next components, rounding errors, Nan, Inf).\n", mcAbsorbProp[105]);
    if (!mcNCounter[106]) fprintf(stderr, "Warning: No neutron could reach Component[106] channel_16_colimator\n");
    if (mcAbsorbProp[106]) fprintf(stderr, "Warning: %g events were removed in Component[106] channel_16_colimator=Collimator_linear()\n"
"         (negative time, miss next components, rounding errors, Nan, Inf).\n", mcAbsorbProp[106]);
    if (!mcNCounter[107]) fprintf(stderr, "Warning: No neutron could reach Component[107] channel_17_colimator\n");
    if (mcAbsorbProp[107]) fprintf(stderr, "Warning: %g events were removed in Component[107] channel_17_colimator=Collimator_linear()\n"
"         (negative time, miss next components, rounding errors, Nan, Inf).\n", mcAbsorbProp[107]);
    if (!mcNCounter[108]) fprintf(stderr, "Warning: No neutron could reach Component[108] channel_18_colimator\n");
    if (mcAbsorbProp[108]) fprintf(stderr, "Warning: %g events were removed in Component[108] channel_18_colimator=Collimator_linear()\n"
"         (negative time, miss next components, rounding errors, Nan, Inf).\n", mcAbsorbProp[108]);
    if (!mcNCounter[109]) fprintf(stderr, "Warning: No neutron could reach Component[109] channel_19_colimator\n");
    if (mcAbsorbProp[109]) fprintf(stderr, "Warning: %g events were removed in Component[109] channel_19_colimator=Collimator_linear()\n"
"         (negative time, miss next components, rounding errors, Nan, Inf).\n", mcAbsorbProp[109]);
  /* User FINALLY code for component 'boron_plastic_incoherent'. */
  SIG_MESSAGE("boron_plastic_incoherent (Finally)");
#define mccompcurname  boron_plastic_incoherent
#define mccompcurtype  Incoherent_process
#define mccompcurindex 110
#define This_process mccboron_plastic_incoherent_This_process
#define Incoherent_storage mccboron_plastic_incoherent_Incoherent_storage
#define effective_my_scattering mccboron_plastic_incoherent_effective_my_scattering
{   /* Declarations of boron_plastic_incoherent=Incoherent_process() SETTING parameters. */
MCNUM sigma = mccboron_plastic_incoherent_sigma;
MCNUM f_QE = mccboron_plastic_incoherent_f_QE;
MCNUM gamma = mccboron_plastic_incoherent_gamma;
MCNUM packing_factor = mccboron_plastic_incoherent_packing_factor;
MCNUM unit_cell_volume = mccboron_plastic_incoherent_unit_cell_volume;
MCNUM interact_fraction = mccboron_plastic_incoherent_interact_fraction;
#line 171 "Incoherent_process.comp"
{
// Since the process and it's storage is a static allocation, there is nothing to deallocate

}
#line 476017 "MACS_sample_kidney_box.c"
}   /* End of boron_plastic_incoherent=Incoherent_process() SETTING parameter declarations. */
#undef effective_my_scattering
#undef Incoherent_storage
#undef This_process
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

    if (!mcNCounter[110]) fprintf(stderr, "Warning: No neutron could reach Component[110] boron_plastic_incoherent\n");
    if (mcAbsorbProp[110]) fprintf(stderr, "Warning: %g events were removed in Component[110] boron_plastic_incoherent=Incoherent_process()\n"
"         (negative time, miss next components, rounding errors, Nan, Inf).\n", mcAbsorbProp[110]);
  /* User FINALLY code for component 'boron_plastic'. */
  SIG_MESSAGE("boron_plastic (Finally)");
#define mccompcurname  boron_plastic
#define mccompcurtype  Union_make_material
#define mccompcurindex 111
#define loop_index mccboron_plastic_loop_index
#define this_material mccboron_plastic_this_material
#define accepted_processes mccboron_plastic_accepted_processes
#define global_material_element mccboron_plastic_global_material_element
{   /* Declarations of boron_plastic=Union_make_material() SETTING parameters. */
char* process_string = mccboron_plastic_process_string;
MCNUM my_absorption = mccboron_plastic_my_absorption;
MCNUM absorber = mccboron_plastic_absorber;
#line 259 "Union_make_material.comp"
{
// The elements of the scattering array used static allocation and is thus deallocated automatically
if (this_material.number_of_processes > 0) free(this_material.p_scattering_array);
if (accepted_processes.num_elements > 0) free(accepted_processes.elements);

// Checking if any Union volumes are defined after the master component
#ifdef MASTER_DETECTOR
  #ifdef ANY_GEOMETRY_DETECTOR_DECLARE
    #ifndef MASTER_DETECTOR_WARNING
      for (loop_index=0;loop_index<global_geometry_list.num_elements;loop_index++) {
        if (global_geometry_list.elements[loop_index].component_index > global_master_list.elements[global_master_list.num_elements-1].component_index) {
          printf("WARNING: No Union_master component defined after Union volume named %s, this components did not affect the simulation in any way.\n",global_geometry_list.elements[loop_index].name);
        }
      }
      // Decided to have this as a warning without exiting the simulation
      // In order to only show this warning once, the MASTER_DETECTOR_WARNING is defined
      #define MASTER_DETECTOR_WARNING dummy
    #endif
  #endif
#endif

// Checking if the user remembered to put in a Union_master
#ifndef MASTER_DETECTOR
  #ifdef ANY_GEOMETRY_DETECTOR_DECLARE
    #ifndef MASTER_DETECTOR_WARNING
      printf("\nWARNING: No Union_master component used, these components did not affect the simulation in any way:\n");
      for (loop_index=0;loop_index<global_geometry_list.num_elements;loop_index++)
        printf("  %s\n",global_geometry_list.elements[loop_index].name);
      printf("\n");
      // Decided to have this as a warning without exiting the simulation
      // In order to only show this warning once, the MASTER_DETECTOR_WARNING is defined
      #define MASTER_DETECTOR_WARNING dummy
    #endif
  #endif
#endif


}
#line 476080 "MACS_sample_kidney_box.c"
}   /* End of boron_plastic=Union_make_material() SETTING parameter declarations. */
#undef global_material_element
#undef accepted_processes
#undef this_material
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

    if (!mcNCounter[111]) fprintf(stderr, "Warning: No neutron could reach Component[111] boron_plastic\n");
    if (mcAbsorbProp[111]) fprintf(stderr, "Warning: %g events were removed in Component[111] boron_plastic=Union_make_material()\n"
"         (negative time, miss next components, rounding errors, Nan, Inf).\n", mcAbsorbProp[111]);
  /* User FINALLY code for component 'boron_plastic_enriched_incoherent'. */
  SIG_MESSAGE("boron_plastic_enriched_incoherent (Finally)");
#define mccompcurname  boron_plastic_enriched_incoherent
#define mccompcurtype  Incoherent_process
#define mccompcurindex 112
#define This_process mccboron_plastic_enriched_incoherent_This_process
#define Incoherent_storage mccboron_plastic_enriched_incoherent_Incoherent_storage
#define effective_my_scattering mccboron_plastic_enriched_incoherent_effective_my_scattering
{   /* Declarations of boron_plastic_enriched_incoherent=Incoherent_process() SETTING parameters. */
MCNUM sigma = mccboron_plastic_enriched_incoherent_sigma;
MCNUM f_QE = mccboron_plastic_enriched_incoherent_f_QE;
MCNUM gamma = mccboron_plastic_enriched_incoherent_gamma;
MCNUM packing_factor = mccboron_plastic_enriched_incoherent_packing_factor;
MCNUM unit_cell_volume = mccboron_plastic_enriched_incoherent_unit_cell_volume;
MCNUM interact_fraction = mccboron_plastic_enriched_incoherent_interact_fraction;
#line 171 "Incoherent_process.comp"
{
// Since the process and it's storage is a static allocation, there is nothing to deallocate

}
#line 476112 "MACS_sample_kidney_box.c"
}   /* End of boron_plastic_enriched_incoherent=Incoherent_process() SETTING parameter declarations. */
#undef effective_my_scattering
#undef Incoherent_storage
#undef This_process
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

    if (!mcNCounter[112]) fprintf(stderr, "Warning: No neutron could reach Component[112] boron_plastic_enriched_incoherent\n");
    if (mcAbsorbProp[112]) fprintf(stderr, "Warning: %g events were removed in Component[112] boron_plastic_enriched_incoherent=Incoherent_process()\n"
"         (negative time, miss next components, rounding errors, Nan, Inf).\n", mcAbsorbProp[112]);
  /* User FINALLY code for component 'boron_plastic_enriched'. */
  SIG_MESSAGE("boron_plastic_enriched (Finally)");
#define mccompcurname  boron_plastic_enriched
#define mccompcurtype  Union_make_material
#define mccompcurindex 113
#define loop_index mccboron_plastic_enriched_loop_index
#define this_material mccboron_plastic_enriched_this_material
#define accepted_processes mccboron_plastic_enriched_accepted_processes
#define global_material_element mccboron_plastic_enriched_global_material_element
{   /* Declarations of boron_plastic_enriched=Union_make_material() SETTING parameters. */
char* process_string = mccboron_plastic_enriched_process_string;
MCNUM my_absorption = mccboron_plastic_enriched_my_absorption;
MCNUM absorber = mccboron_plastic_enriched_absorber;
#line 259 "Union_make_material.comp"
{
// The elements of the scattering array used static allocation and is thus deallocated automatically
if (this_material.number_of_processes > 0) free(this_material.p_scattering_array);
if (accepted_processes.num_elements > 0) free(accepted_processes.elements);

// Checking if any Union volumes are defined after the master component
#ifdef MASTER_DETECTOR
  #ifdef ANY_GEOMETRY_DETECTOR_DECLARE
    #ifndef MASTER_DETECTOR_WARNING
      for (loop_index=0;loop_index<global_geometry_list.num_elements;loop_index++) {
        if (global_geometry_list.elements[loop_index].component_index > global_master_list.elements[global_master_list.num_elements-1].component_index) {
          printf("WARNING: No Union_master component defined after Union volume named %s, this components did not affect the simulation in any way.\n",global_geometry_list.elements[loop_index].name);
        }
      }
      // Decided to have this as a warning without exiting the simulation
      // In order to only show this warning once, the MASTER_DETECTOR_WARNING is defined
      #define MASTER_DETECTOR_WARNING dummy
    #endif
  #endif
#endif

// Checking if the user remembered to put in a Union_master
#ifndef MASTER_DETECTOR
  #ifdef ANY_GEOMETRY_DETECTOR_DECLARE
    #ifndef MASTER_DETECTOR_WARNING
      printf("\nWARNING: No Union_master component used, these components did not affect the simulation in any way:\n");
      for (loop_index=0;loop_index<global_geometry_list.num_elements;loop_index++)
        printf("  %s\n",global_geometry_list.elements[loop_index].name);
      printf("\n");
      // Decided to have this as a warning without exiting the simulation
      // In order to only show this warning once, the MASTER_DETECTOR_WARNING is defined
      #define MASTER_DETECTOR_WARNING dummy
    #endif
  #endif
#endif


}
#line 476175 "MACS_sample_kidney_box.c"
}   /* End of boron_plastic_enriched=Union_make_material() SETTING parameter declarations. */
#undef global_material_element
#undef accepted_processes
#undef this_material
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

    if (!mcNCounter[113]) fprintf(stderr, "Warning: No neutron could reach Component[113] boron_plastic_enriched\n");
    if (mcAbsorbProp[113]) fprintf(stderr, "Warning: %g events were removed in Component[113] boron_plastic_enriched=Union_make_material()\n"
"         (negative time, miss next components, rounding errors, Nan, Inf).\n", mcAbsorbProp[113]);
  /* User FINALLY code for component 'Collimator_gad'. */
  SIG_MESSAGE("Collimator_gad (Finally)");
#define mccompcurname  Collimator_gad
#define mccompcurtype  Union_make_material
#define mccompcurindex 114
#define loop_index mccCollimator_gad_loop_index
#define this_material mccCollimator_gad_this_material
#define accepted_processes mccCollimator_gad_accepted_processes
#define global_material_element mccCollimator_gad_global_material_element
{   /* Declarations of Collimator_gad=Union_make_material() SETTING parameters. */
char* process_string = mccCollimator_gad_process_string;
MCNUM my_absorption = mccCollimator_gad_my_absorption;
MCNUM absorber = mccCollimator_gad_absorber;
#line 259 "Union_make_material.comp"
{
// The elements of the scattering array used static allocation and is thus deallocated automatically
if (this_material.number_of_processes > 0) free(this_material.p_scattering_array);
if (accepted_processes.num_elements > 0) free(accepted_processes.elements);

// Checking if any Union volumes are defined after the master component
#ifdef MASTER_DETECTOR
  #ifdef ANY_GEOMETRY_DETECTOR_DECLARE
    #ifndef MASTER_DETECTOR_WARNING
      for (loop_index=0;loop_index<global_geometry_list.num_elements;loop_index++) {
        if (global_geometry_list.elements[loop_index].component_index > global_master_list.elements[global_master_list.num_elements-1].component_index) {
          printf("WARNING: No Union_master component defined after Union volume named %s, this components did not affect the simulation in any way.\n",global_geometry_list.elements[loop_index].name);
        }
      }
      // Decided to have this as a warning without exiting the simulation
      // In order to only show this warning once, the MASTER_DETECTOR_WARNING is defined
      #define MASTER_DETECTOR_WARNING dummy
    #endif
  #endif
#endif

// Checking if the user remembered to put in a Union_master
#ifndef MASTER_DETECTOR
  #ifdef ANY_GEOMETRY_DETECTOR_DECLARE
    #ifndef MASTER_DETECTOR_WARNING
      printf("\nWARNING: No Union_master component used, these components did not affect the simulation in any way:\n");
      for (loop_index=0;loop_index<global_geometry_list.num_elements;loop_index++)
        printf("  %s\n",global_geometry_list.elements[loop_index].name);
      printf("\n");
      // Decided to have this as a warning without exiting the simulation
      // In order to only show this warning once, the MASTER_DETECTOR_WARNING is defined
      #define MASTER_DETECTOR_WARNING dummy
    #endif
  #endif
#endif


}
#line 476239 "MACS_sample_kidney_box.c"
}   /* End of Collimator_gad=Union_make_material() SETTING parameter declarations. */
#undef global_material_element
#undef accepted_processes
#undef this_material
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

    if (!mcNCounter[114]) fprintf(stderr, "Warning: No neutron could reach Component[114] Collimator_gad\n");
    if (mcAbsorbProp[114]) fprintf(stderr, "Warning: %g events were removed in Component[114] Collimator_gad=Union_make_material()\n"
"         (negative time, miss next components, rounding errors, Nan, Inf).\n", mcAbsorbProp[114]);
  /* User FINALLY code for component 'Incoherent_PG_analyzer'. */
  SIG_MESSAGE("Incoherent_PG_analyzer (Finally)");
#define mccompcurname  Incoherent_PG_analyzer
#define mccompcurtype  Incoherent_process
#define mccompcurindex 115
#define This_process mccIncoherent_PG_analyzer_This_process
#define Incoherent_storage mccIncoherent_PG_analyzer_Incoherent_storage
#define effective_my_scattering mccIncoherent_PG_analyzer_effective_my_scattering
{   /* Declarations of Incoherent_PG_analyzer=Incoherent_process() SETTING parameters. */
MCNUM sigma = mccIncoherent_PG_analyzer_sigma;
MCNUM f_QE = mccIncoherent_PG_analyzer_f_QE;
MCNUM gamma = mccIncoherent_PG_analyzer_gamma;
MCNUM packing_factor = mccIncoherent_PG_analyzer_packing_factor;
MCNUM unit_cell_volume = mccIncoherent_PG_analyzer_unit_cell_volume;
MCNUM interact_fraction = mccIncoherent_PG_analyzer_interact_fraction;
#line 171 "Incoherent_process.comp"
{
// Since the process and it's storage is a static allocation, there is nothing to deallocate

}
#line 476271 "MACS_sample_kidney_box.c"
}   /* End of Incoherent_PG_analyzer=Incoherent_process() SETTING parameter declarations. */
#undef effective_my_scattering
#undef Incoherent_storage
#undef This_process
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

    if (!mcNCounter[115]) fprintf(stderr, "Warning: No neutron could reach Component[115] Incoherent_PG_analyzer\n");
    if (mcAbsorbProp[115]) fprintf(stderr, "Warning: %g events were removed in Component[115] Incoherent_PG_analyzer=Incoherent_process()\n"
"         (negative time, miss next components, rounding errors, Nan, Inf).\n", mcAbsorbProp[115]);
    if (!mcNCounter[116]) fprintf(stderr, "Warning: No neutron could reach Component[116] Single_crystal_PG_analyzer\n");
    if (mcAbsorbProp[116]) fprintf(stderr, "Warning: %g events were removed in Component[116] Single_crystal_PG_analyzer=Single_crystal_process()\n"
"         (negative time, miss next components, rounding errors, Nan, Inf).\n", mcAbsorbProp[116]);
  /* User FINALLY code for component 'PG_analyzer'. */
  SIG_MESSAGE("PG_analyzer (Finally)");
#define mccompcurname  PG_analyzer
#define mccompcurtype  Union_make_material
#define mccompcurindex 117
#define loop_index mccPG_analyzer_loop_index
#define this_material mccPG_analyzer_this_material
#define accepted_processes mccPG_analyzer_accepted_processes
#define global_material_element mccPG_analyzer_global_material_element
{   /* Declarations of PG_analyzer=Union_make_material() SETTING parameters. */
char* process_string = mccPG_analyzer_process_string;
MCNUM my_absorption = mccPG_analyzer_my_absorption;
MCNUM absorber = mccPG_analyzer_absorber;
#line 259 "Union_make_material.comp"
{
// The elements of the scattering array used static allocation and is thus deallocated automatically
if (this_material.number_of_processes > 0) free(this_material.p_scattering_array);
if (accepted_processes.num_elements > 0) free(accepted_processes.elements);

// Checking if any Union volumes are defined after the master component
#ifdef MASTER_DETECTOR
  #ifdef ANY_GEOMETRY_DETECTOR_DECLARE
    #ifndef MASTER_DETECTOR_WARNING
      for (loop_index=0;loop_index<global_geometry_list.num_elements;loop_index++) {
        if (global_geometry_list.elements[loop_index].component_index > global_master_list.elements[global_master_list.num_elements-1].component_index) {
          printf("WARNING: No Union_master component defined after Union volume named %s, this components did not affect the simulation in any way.\n",global_geometry_list.elements[loop_index].name);
        }
      }
      // Decided to have this as a warning without exiting the simulation
      // In order to only show this warning once, the MASTER_DETECTOR_WARNING is defined
      #define MASTER_DETECTOR_WARNING dummy
    #endif
  #endif
#endif

// Checking if the user remembered to put in a Union_master
#ifndef MASTER_DETECTOR
  #ifdef ANY_GEOMETRY_DETECTOR_DECLARE
    #ifndef MASTER_DETECTOR_WARNING
      printf("\nWARNING: No Union_master component used, these components did not affect the simulation in any way:\n");
      for (loop_index=0;loop_index<global_geometry_list.num_elements;loop_index++)
        printf("  %s\n",global_geometry_list.elements[loop_index].name);
      printf("\n");
      // Decided to have this as a warning without exiting the simulation
      // In order to only show this warning once, the MASTER_DETECTOR_WARNING is defined
      #define MASTER_DETECTOR_WARNING dummy
    #endif
  #endif
#endif


}
#line 476336 "MACS_sample_kidney_box.c"
}   /* End of PG_analyzer=Union_make_material() SETTING parameter declarations. */
#undef global_material_element
#undef accepted_processes
#undef this_material
#undef loop_index
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

    if (!mcNCounter[117]) fprintf(stderr, "Warning: No neutron could reach Component[117] PG_analyzer\n");
    if (mcAbsorbProp[117]) fprintf(stderr, "Warning: %g events were removed in Component[117] PG_analyzer=Union_make_material()\n"
"         (negative time, miss next components, rounding errors, Nan, Inf).\n", mcAbsorbProp[117]);
    if (!mcNCounter[118]) fprintf(stderr, "Warning: No neutron could reach Component[118] kidney_hull\n");
    if (mcAbsorbProp[118]) fprintf(stderr, "Warning: %g events were removed in Component[118] kidney_hull=Union_cylinder()\n"
"         (negative time, miss next components, rounding errors, Nan, Inf).\n", mcAbsorbProp[118]);
    if (!mcNCounter[119]) fprintf(stderr, "Warning: No neutron could reach Component[119] kidney_hull_cut\n");
    if (mcAbsorbProp[119]) fprintf(stderr, "Warning: %g events were removed in Component[119] kidney_hull_cut=Union_cylinder()\n"
"         (negative time, miss next components, rounding errors, Nan, Inf).\n", mcAbsorbProp[119]);
    if (!mcNCounter[120]) fprintf(stderr, "Warning: No neutron could reach Component[120] kidney_hull_box_cut_arm1\n");
    if (mcAbsorbProp[120]) fprintf(stderr, "Warning: %g events were removed in Component[120] kidney_hull_box_cut_arm1=Arm()\n"
"         (negative time, miss next components, rounding errors, Nan, Inf).\n", mcAbsorbProp[120]);
    if (!mcNCounter[121]) fprintf(stderr, "Warning: No neutron could reach Component[121] kidney_hull_box_cut1\n");
    if (mcAbsorbProp[121]) fprintf(stderr, "Warning: %g events were removed in Component[121] kidney_hull_box_cut1=Union_box()\n"
"         (negative time, miss next components, rounding errors, Nan, Inf).\n", mcAbsorbProp[121]);
    if (!mcNCounter[122]) fprintf(stderr, "Warning: No neutron could reach Component[122] kidney_hull_box_cut_arm2\n");
    if (mcAbsorbProp[122]) fprintf(stderr, "Warning: %g events were removed in Component[122] kidney_hull_box_cut_arm2=Arm()\n"
"         (negative time, miss next components, rounding errors, Nan, Inf).\n", mcAbsorbProp[122]);
    if (!mcNCounter[123]) fprintf(stderr, "Warning: No neutron could reach Component[123] kidney_hull_box_cut2\n");
    if (mcAbsorbProp[123]) fprintf(stderr, "Warning: %g events were removed in Component[123] kidney_hull_box_cut2=Union_box()\n"
"         (negative time, miss next components, rounding errors, Nan, Inf).\n", mcAbsorbProp[123]);
    if (!mcNCounter[124]) fprintf(stderr, "Warning: No neutron could reach Component[124] channel_0_cave1_box1\n");
    if (mcAbsorbProp[124]) fprintf(stderr, "Warning: %g events were removed in Component[124] channel_0_cave1_box1=Union_box()\n"
"         (negative time, miss next components, rounding errors, Nan, Inf).\n", mcAbsorbProp[124]);
    if (!mcNCounter[125]) fprintf(stderr, "Warning: No neutron could reach Component[125] channel_0_cave1_box2\n");
    if (mcAbsorbProp[125]) fprintf(stderr, "Warning: %g events were removed in Component[125] channel_0_cave1_box2=Union_box()\n"
"         (negative time, miss next components, rounding errors, Nan, Inf).\n", mcAbsorbProp[125]);
    if (!mcNCounter[126]) fprintf(stderr, "Warning: No neutron could reach Component[126] channel_0_cave1_box3\n");
    if (mcAbsorbProp[126]) fprintf(stderr, "Warning: %g events were removed in Component[126] channel_0_cave1_box3=Union_box()\n"
"         (negative time, miss next components, rounding errors, Nan, Inf).\n", mcAbsorbProp[126]);
    if (!mcNCounter[127]) fprintf(stderr, "Warning: No neutron could reach Component[127] channel_0_cave1_cyl1\n");
    if (mcAbsorbProp[127]) fprintf(stderr, "Warning: %g events were removed in Component[127] channel_0_cave1_cyl1=Union_cylinder()\n"
"         (negative time, miss next components, rounding errors, Nan, Inf).\n", mcAbsorbProp[127]);
    if (!mcNCounter[128]) fprintf(stderr, "Warning: No neutron could reach Component[128] channel_0_analyzer_1_center\n");
    if (mcAbsorbProp[128]) fprintf(stderr, "Warning: %g events were removed in Component[128] channel_0_analyzer_1_center=Arm()\n"
"         (negative time, miss next components, rounding errors, Nan, Inf).\n", mcAbsorbProp[128]);
    if (!mcNCounter[129]) fprintf(stderr, "Warning: No neutron could reach Component[129] channel_0_analyzer_1_rotated\n");
    if (mcAbsorbProp[129]) fprintf(stderr, "Warning: %g events were removed in Component[129] channel_0_analyzer_1_rotated=Arm()\n"
"         (negative time, miss next components, rounding errors, Nan, Inf).\n", mcAbsorbProp[129]);
    if (!mcNCounter[130]) fprintf(stderr, "Warning: No neutron could reach Component[130] channel_0_analyzer_1_array_crystal_array_0\n");
    if (mcAbsorbProp[130]) fprintf(stderr, "Warning: %g events were removed in Component[130] channel_0_analyzer_1_array_crystal_array_0=Union_box()\n"
"         (negative time, miss next components, rounding errors, Nan, Inf).\n", mcAbsorbProp[130]);
    if (!mcNCounter[131]) fprintf(stderr, "Warning: No neutron could reach Component[131] channel_0_analyzer_1_array_crystal_array_1\n");
    if (mcAbsorbProp[131]) fprintf(stderr, "Warning: %g events were removed in Component[131] channel_0_analyzer_1_array_crystal_array_1=Union_box()\n"
"         (negative time, miss next components, rounding errors, Nan, Inf).\n", mcAbsorbProp[131]);
    if (!mcNCounter[132]) fprintf(stderr, "Warning: No neutron could reach Component[132] channel_0_analyzer_1_array_crystal_array_2\n");
    if (mcAbsorbProp[132]) fprintf(stderr, "Warning: %g events were removed in Component[132] channel_0_analyzer_1_array_crystal_array_2=Union_box()\n"
"         (negative time, miss next components, rounding errors, Nan, Inf).\n", mcAbsorbProp[132]);
    if (!mcNCounter[133]) fprintf(stderr, "Warning: No neutron could reach Component[133] channel_0_analyzer_1_array_crystal_array_3\n");
    if (mcAbsorbProp[133]) fprintf(stderr, "Warning: %g events were removed in Component[133] channel_0_analyzer_1_array_crystal_array_3=Union_box()\n"
"         (negative time, miss next components, rounding errors, Nan, Inf).\n", mcAbsorbProp[133]);
    if (!mcNCounter[134]) fprintf(stderr, "Warning: No neutron could reach Component[134] channel_0_analyzer_1_array_crystal_array_4\n");
    if (mcAbsorbProp[134]) fprintf(stderr, "Warning: %g events were removed in Component[134] channel_0_analyzer_1_array_crystal_array_4=Union_box()\n"
"         (negative time, miss next components, rounding errors, Nan, Inf).\n", mcAbsorbProp[134]);
    if (!mcNCounter[135]) fprintf(stderr, "Warning: No neutron could reach Component[135] channel_0_analyzer_1_array_crystal_array_5\n");
    if (mcAbsorbProp[135]) fprintf(stderr, "Warning: %g events were removed in Component[135] channel_0_analyzer_1_array_crystal_array_5=Union_box()\n"
"         (negative time, miss next components, rounding errors, Nan, Inf).\n", mcAbsorbProp[135]);
    if (!mcNCounter[136]) fprintf(stderr, "Warning: No neutron could reach Component[136] channel_0_analyzer_1_array_crystal_array_6\n");
    if (mcAbsorbProp[136]) fprintf(stderr, "Warning: %g events were removed in Component[136] channel_0_analyzer_1_array_crystal_array_6=Union_box()\n"
"         (negative time, miss next components, rounding errors, Nan, Inf).\n", mcAbsorbProp[136]);
    if (!mcNCounter[137]) fprintf(stderr, "Warning: No neutron could reach Component[137] channel_0_analyzer_1_array_crystal_array_7\n");
    if (mcAbsorbProp[137]) fprintf(stderr, "Warning: %g events were removed in Component[137] channel_0_analyzer_1_array_crystal_array_7=Union_box()\n"
"         (negative time, miss next components, rounding errors, Nan, Inf).\n", mcAbsorbProp[137]);
    if (!mcNCounter[138]) fprintf(stderr, "Warning: No neutron could reach Component[138] channel_0_analyzer_1_array_crystal_array_8\n");
    if (mcAbsorbProp[138]) fprintf(stderr, "Warning: %g events were removed in Component[138] channel_0_analyzer_1_array_crystal_array_8=Union_box()\n"
"         (negative time, miss next components, rounding errors, Nan, Inf).\n", mcAbsorbProp[138]);
    if (!mcNCounter[139]) fprintf(stderr, "Warning: No neutron could reach Component[139] channel_0_analyzer_2_center\n");
    if (mcAbsorbProp[139]) fprintf(stderr, "Warning: %g events were removed in Component[139] channel_0_analyzer_2_center=Arm()\n"
"         (negative time, miss next components, rounding errors, Nan, Inf).\n", mcAbsorbProp[139]);
    if (!mcNCounter[140]) fprintf(stderr, "Warning: No neutron could reach Component[140] channel_0_analyzer_2_rotated\n");
    if (mcAbsorbProp[140]) fprintf(stderr, "Warning: %g events were removed in Component[140] channel_0_analyzer_2_rotated=Arm()\n"
"         (negative time, miss next components, rounding errors, Nan, Inf).\n", mcAbsorbProp[140]);
    if (!mcNCounter[141]) fprintf(stderr, "Warning: No neutron could reach Component[141] channel_0_analyzer_2_array_crystal_array_0\n");
    if (mcAbsorbProp[141]) fprintf(stderr, "Warning: %g events were removed in Component[141] channel_0_analyzer_2_array_crystal_array_0=Union_box()\n"
"         (negative time, miss next components, rounding errors, Nan, Inf).\n", mcAbsorbProp[141]);
    if (!mcNCounter[142]) fprintf(stderr, "Warning: No neutron could reach Component[142] channel_0_analyzer_2_array_crystal_array_1\n");
    if (mcAbsorbProp[142]) fprintf(stderr, "Warning: %g events were removed in Component[142] channel_0_analyzer_2_array_crystal_array_1=Union_box()\n"
"         (negative time, miss next components, rounding errors, Nan, Inf).\n", mcAbsorbProp[142]);
    if (!mcNCounter[143]) fprintf(stderr, "Warning: No neutron could reach Component[143] channel_0_analyzer_2_array_crystal_array_2\n");
    if (mcAbsorbProp[143]) fprintf(stderr, "Warning: %g events were removed in Component[143] channel_0_analyzer_2_array_crystal_array_2=Union_box()\n"
"         (negative time, miss next components, rounding errors, Nan, Inf).\n", mcAbsorbProp[143]);
    if (!mcNCounter[144]) fprintf(stderr, "Warning: No neutron could reach Component[144] channel_0_analyzer_2_array_crystal_array_3\n");
    if (mcAbsorbProp[144]) fprintf(stderr, "Warning: %g events were removed in Component[144] channel_0_analyzer_2_array_crystal_array_3=Union_box()\n"
"         (negative time, miss next components, rounding errors, Nan, Inf).\n", mcAbsorbProp[144]);
    if (!mcNCounter[145]) fprintf(stderr, "Warning: No neutron could reach Component[145] channel_0_analyzer_2_array_crystal_array_4\n");
    if (mcAbsorbProp[145]) fprintf(stderr, "Warning: %g events were removed in Component[145] channel_0_analyzer_2_array_crystal_array_4=Union_box()\n"
"         (negative time, miss next components, rounding errors, Nan, Inf).\n", mcAbsorbProp[145]);
    if (!mcNCounter[146]) fprintf(stderr, "Warning: No neutron could reach Component[146] channel_0_analyzer_2_array_crystal_array_5\n");
    if (mcAbsorbProp[146]) fprintf(stderr, "Warning: %g events were removed in Component[146] channel_0_analyzer_2_array_crystal_array_5=Union_box()\n"
"         (negative time, miss next components, rounding errors, Nan, Inf).\n", mcAbsorbProp[146]);
    if (!mcNCounter[147]) fprintf(stderr, "Warning: No neutron could reach Component[147] channel_0_analyzer_2_array_crystal_array_6\n");
    if (mcAbsorbProp[147]) fprintf(stderr, "Warning: %g events were removed in Component[147] channel_0_analyzer_2_array_crystal_array_6=Union_box()\n"
"         (negative time, miss next components, rounding errors, Nan, Inf).\n", mcAbsorbProp[147]);
    if (!mcNCounter[148]) fprintf(stderr, "Warning: No neutron could reach Component[148] channel_0_analyzer_2_array_crystal_array_7\n");
    if (mcAbsorbProp[148]) fprintf(stderr, "Warning: %g events were removed in Component[148] channel_0_analyzer_2_array_crystal_array_7=Union_box()\n"
"         (negative time, miss next components, rounding errors, Nan, Inf).\n", mcAbsorbProp[148]);
    if (!mcNCounter[149]) fprintf(stderr, "Warning: No neutron could reach Component[149] channel_0_analyzer_2_array_crystal_array_8\n");
    if (mcAbsorbProp[149]) fprintf(stderr, "Warning: %g events were removed in Component[149] channel_0_analyzer_2_array_crystal_array_8=Union_box()\n"
"         (negative time, miss next components, rounding errors, Nan, Inf).\n", mcAbsorbProp[149]);
    if (!mcNCounter[150]) fprintf(stderr, "Warning: No neutron could reach Component[150] channel_0_cave2_cyl1\n");
    if (mcAbsorbProp[150]) fprintf(stderr, "Warning: %g events were removed in Component[150] channel_0_cave2_cyl1=Union_cylinder()\n"
"         (negative time, miss next components, rounding errors, Nan, Inf).\n", mcAbsorbProp[150]);
    if (!mcNCounter[151]) fprintf(stderr, "Warning: No neutron could reach Component[151] channel_0_cave2_box1\n");
    if (mcAbsorbProp[151]) fprintf(stderr, "Warning: %g events were removed in Component[151] channel_0_cave2_box1=Union_box()\n"
"         (negative time, miss next components, rounding errors, Nan, Inf).\n", mcAbsorbProp[151]);
    if (!mcNCounter[152]) fprintf(stderr, "Warning: No neutron could reach Component[152] channel_0_cave2_box2\n");
    if (mcAbsorbProp[152]) fprintf(stderr, "Warning: %g events were removed in Component[152] channel_0_cave2_box2=Union_box()\n"
"         (negative time, miss next components, rounding errors, Nan, Inf).\n", mcAbsorbProp[152]);
    if (!mcNCounter[153]) fprintf(stderr, "Warning: No neutron could reach Component[153] channel_0_cave2_box3\n");
    if (mcAbsorbProp[153]) fprintf(stderr, "Warning: %g events were removed in Component[153] channel_0_cave2_box3=Union_box()\n"
"         (negative time, miss next components, rounding errors, Nan, Inf).\n", mcAbsorbProp[153]);
    if (!mcNCounter[154]) fprintf(stderr, "Warning: No neutron could reach Component[154] inter_analyzer_colimator_center_0\n");
    if (mcAbsorbProp[154]) fprintf(stderr, "Warning: %g events were removed in Component[154] inter_analyzer_colimator_center_0=Arm()\n"
"         (negative time, miss next components, rounding errors, Nan, Inf).\n", mcAbsorbProp[154]);
    if (!mcNCounter[155]) fprintf(stderr, "Warning: No neutron could reach Component[155] inter_analyzer_colimator_0_blade_0\n");
    if (mcAbsorbProp[155]) fprintf(stderr, "Warning: %g events were removed in Component[155] inter_analyzer_colimator_0_blade_0=Union_box()\n"
"         (negative time, miss next components, rounding errors, Nan, Inf).\n", mcAbsorbProp[155]);
    if (!mcNCounter[156]) fprintf(stderr, "Warning: No neutron could reach Component[156] inter_analyzer_colimator_0_blade_1\n");
    if (mcAbsorbProp[156]) fprintf(stderr, "Warning: %g events were removed in Component[156] inter_analyzer_colimator_0_blade_1=Union_box()\n"
"         (negative time, miss next components, rounding errors, Nan, Inf).\n", mcAbsorbProp[156]);
    if (!mcNCounter[157]) fprintf(stderr, "Warning: No neutron could reach Component[157] inter_analyzer_colimator_0_blade_2\n");
    if (mcAbsorbProp[157]) fprintf(stderr, "Warning: %g events were removed in Component[157] inter_analyzer_colimator_0_blade_2=Union_box()\n"
"         (negative time, miss next components, rounding errors, Nan, Inf).\n", mcAbsorbProp[157]);
    if (!mcNCounter[158]) fprintf(stderr, "Warning: No neutron could reach Component[158] inter_analyzer_colimator_0_blade_3\n");
    if (mcAbsorbProp[158]) fprintf(stderr, "Warning: %g events were removed in Component[158] inter_analyzer_colimator_0_blade_3=Union_box()\n"
"         (negative time, miss next components, rounding errors, Nan, Inf).\n", mcAbsorbProp[158]);
    if (!mcNCounter[159]) fprintf(stderr, "Warning: No neutron could reach Component[159] inter_analyzer_colimator_0_blade_4\n");
    if (mcAbsorbProp[159]) fprintf(stderr, "Warning: %g events were removed in Component[159] inter_analyzer_colimator_0_blade_4=Union_box()\n"
"         (negative time, miss next components, rounding errors, Nan, Inf).\n", mcAbsorbProp[159]);
    if (!mcNCounter[160]) fprintf(stderr, "Warning: No neutron could reach Component[160] diffraction_detector_0_exit_volume\n");
    if (mcAbsorbProp[160]) fprintf(stderr, "Warning: %g events were removed in Component[160] diffraction_detector_0_exit_volume=Union_box()\n"
"         (negative time, miss next components, rounding errors, Nan, Inf).\n", mcAbsorbProp[160]);
    if (!mcNCounter[161]) fprintf(stderr, "Warning: No neutron could reach Component[161] spec_detector_0_exit_volume\n");
    if (mcAbsorbProp[161]) fprintf(stderr, "Warning: %g events were removed in Component[161] spec_detector_0_exit_volume=Union_box()\n"
"         (negative time, miss next components, rounding errors, Nan, Inf).\n", mcAbsorbProp[161]);
    if (!mcNCounter[162]) fprintf(stderr, "Warning: No neutron could reach Component[162] channel_1_cave1_box1\n");
    if (mcAbsorbProp[162]) fprintf(stderr, "Warning: %g events were removed in Component[162] channel_1_cave1_box1=Union_box()\n"
"         (negative time, miss next components, rounding errors, Nan, Inf).\n", mcAbsorbProp[162]);
    if (!mcNCounter[163]) fprintf(stderr, "Warning: No neutron could reach Component[163] channel_1_cave1_box2\n");
    if (mcAbsorbProp[163]) fprintf(stderr, "Warning: %g events were removed in Component[163] channel_1_cave1_box2=Union_box()\n"
"         (negative time, miss next components, rounding errors, Nan, Inf).\n", mcAbsorbProp[163]);
    if (!mcNCounter[164]) fprintf(stderr, "Warning: No neutron could reach Component[164] channel_1_cave1_box3\n");
    if (mcAbsorbProp[164]) fprintf(stderr, "Warning: %g events were removed in Component[164] channel_1_cave1_box3=Union_box()\n"
"         (negative time, miss next components, rounding errors, Nan, Inf).\n", mcAbsorbProp[164]);
    if (!mcNCounter[165]) fprintf(stderr, "Warning: No neutron could reach Component[165] channel_1_cave1_cyl1\n");
    if (mcAbsorbProp[165]) fprintf(stderr, "Warning: %g events were removed in Component[165] channel_1_cave1_cyl1=Union_cylinder()\n"
"         (negative time, miss next components, rounding errors, Nan, Inf).\n", mcAbsorbProp[165]);
    if (!mcNCounter[166]) fprintf(stderr, "Warning: No neutron could reach Component[166] channel_1_analyzer_1_center\n");
    if (mcAbsorbProp[166]) fprintf(stderr, "Warning: %g events were removed in Component[166] channel_1_analyzer_1_center=Arm()\n"
"         (negative time, miss next components, rounding errors, Nan, Inf).\n", mcAbsorbProp[166]);
    if (!mcNCounter[167]) fprintf(stderr, "Warning: No neutron could reach Component[167] channel_1_analyzer_1_rotated\n");
    if (mcAbsorbProp[167]) fprintf(stderr, "Warning: %g events were removed in Component[167] channel_1_analyzer_1_rotated=Arm()\n"
"         (negative time, miss next components, rounding errors, Nan, Inf).\n", mcAbsorbProp[167]);
    if (!mcNCounter[168]) fprintf(stderr, "Warning: No neutron could reach Component[168] channel_1_analyzer_1_array_crystal_array_0\n");
    if (mcAbsorbProp[168]) fprintf(stderr, "Warning: %g events were removed in Component[168] channel_1_analyzer_1_array_crystal_array_0=Union_box()\n"
"         (negative time, miss next components, rounding errors, Nan, Inf).\n", mcAbsorbProp[168]);
    if (!mcNCounter[169]) fprintf(stderr, "Warning: No neutron could reach Component[169] channel_1_analyzer_1_array_crystal_array_1\n");
    if (mcAbsorbProp[169]) fprintf(stderr, "Warning: %g events were removed in Component[169] channel_1_analyzer_1_array_crystal_array_1=Union_box()\n"
"         (negative time, miss next components, rounding errors, Nan, Inf).\n", mcAbsorbProp[169]);
    if (!mcNCounter[170]) fprintf(stderr, "Warning: No neutron could reach Component[170] channel_1_analyzer_1_array_crystal_array_2\n");
    if (mcAbsorbProp[170]) fprintf(stderr, "Warning: %g events were removed in Component[170] channel_1_analyzer_1_array_crystal_array_2=Union_box()\n"
"         (negative time, miss next components, rounding errors, Nan, Inf).\n", mcAbsorbProp[170]);
    if (!mcNCounter[171]) fprintf(stderr, "Warning: No neutron could reach Component[171] channel_1_analyzer_1_array_crystal_array_3\n");
    if (mcAbsorbProp[171]) fprintf(stderr, "Warning: %g events were removed in Component[171] channel_1_analyzer_1_array_crystal_array_3=Union_box()\n"
"         (negative time, miss next components, rounding errors, Nan, Inf).\n", mcAbsorbProp[171]);
    if (!mcNCounter[172]) fprintf(stderr, "Warning: No neutron could reach Component[172] channel_1_analyzer_1_array_crystal_array_4\n");
    if (mcAbsorbProp[172]) fprintf(stderr, "Warning: %g events were removed in Component[172] channel_1_analyzer_1_array_crystal_array_4=Union_box()\n"
"         (negative time, miss next components, rounding errors, Nan, Inf).\n", mcAbsorbProp[172]);
    if (!mcNCounter[173]) fprintf(stderr, "Warning: No neutron could reach Component[173] channel_1_analyzer_1_array_crystal_array_5\n");
    if (mcAbsorbProp[173]) fprintf(stderr, "Warning: %g events were removed in Component[173] channel_1_analyzer_1_array_crystal_array_5=Union_box()\n"
"         (negative time, miss next components, rounding errors, Nan, Inf).\n", mcAbsorbProp[173]);
    if (!mcNCounter[174]) fprintf(stderr, "Warning: No neutron could reach Component[174] channel_1_analyzer_1_array_crystal_array_6\n");
    if (mcAbsorbProp[174]) fprintf(stderr, "Warning: %g events were removed in Component[174] channel_1_analyzer_1_array_crystal_array_6=Union_box()\n"
"         (negative time, miss next components, rounding errors, Nan, Inf).\n", mcAbsorbProp[174]);
    if (!mcNCounter[175]) fprintf(stderr, "Warning: No neutron could reach Component[175] channel_1_analyzer_1_array_crystal_array_7\n");
    if (mcAbsorbProp[175]) fprintf(stderr, "Warning: %g events were removed in Component[175] channel_1_analyzer_1_array_crystal_array_7=Union_box()\n"
"         (negative time, miss next components, rounding errors, Nan, Inf).\n", mcAbsorbProp[175]);
    if (!mcNCounter[176]) fprintf(stderr, "Warning: No neutron could reach Component[176] channel_1_analyzer_1_array_crystal_array_8\n");
    if (mcAbsorbProp[176]) fprintf(stderr, "Warning: %g events were removed in Component[176] channel_1_analyzer_1_array_crystal_array_8=Union_box()\n"
"         (negative time, miss next components, rounding errors, Nan, Inf).\n", mcAbsorbProp[176]);
    if (!mcNCounter[177]) fprintf(stderr, "Warning: No neutron could reach Component[177] channel_1_analyzer_2_center\n");
    if (mcAbsorbProp[177]) fprintf(stderr, "Warning: %g events were removed in Component[177] channel_1_analyzer_2_center=Arm()\n"
"         (negative time, miss next components, rounding errors, Nan, Inf).\n", mcAbsorbProp[177]);
    if (!mcNCounter[178]) fprintf(stderr, "Warning: No neutron could reach Component[178] channel_1_analyzer_2_rotated\n");
    if (mcAbsorbProp[178]) fprintf(stderr, "Warning: %g events were removed in Component[178] channel_1_analyzer_2_rotated=Arm()\n"
"         (negative time, miss next components, rounding errors, Nan, Inf).\n", mcAbsorbProp[178]);
    if (!mcNCounter[179]) fprintf(stderr, "Warning: No neutron could reach Component[179] channel_1_analyzer_2_array_crystal_array_0\n");
    if (mcAbsorbProp[179]) fprintf(stderr, "Warning: %g events were removed in Component[179] channel_1_analyzer_2_array_crystal_array_0=Union_box()\n"
"         (negative time, miss next components, rounding errors, Nan, Inf).\n", mcAbsorbProp[179]);
    if (!mcNCounter[180]) fprintf(stderr, "Warning: No neutron could reach Component[180] channel_1_analyzer_2_array_crystal_array_1\n");
    if (mcAbsorbProp[180]) fprintf(stderr, "Warning: %g events were removed in Component[180] channel_1_analyzer_2_array_crystal_array_1=Union_box()\n"
"         (negative time, miss next components, rounding errors, Nan, Inf).\n", mcAbsorbProp[180]);
    if (!mcNCounter[181]) fprintf(stderr, "Warning: No neutron could reach Component[181] channel_1_analyzer_2_array_crystal_array_2\n");
    if (mcAbsorbProp[181]) fprintf(stderr, "Warning: %g events were removed in Component[181] channel_1_analyzer_2_array_crystal_array_2=Union_box()\n"
"         (negative time, miss next components, rounding errors, Nan, Inf).\n", mcAbsorbProp[181]);
    if (!mcNCounter[182]) fprintf(stderr, "Warning: No neutron could reach Component[182] channel_1_analyzer_2_array_crystal_array_3\n");
    if (mcAbsorbProp[182]) fprintf(stderr, "Warning: %g events were removed in Component[182] channel_1_analyzer_2_array_crystal_array_3=Union_box()\n"
"         (negative time, miss next components, rounding errors, Nan, Inf).\n", mcAbsorbProp[182]);
    if (!mcNCounter[183]) fprintf(stderr, "Warning: No neutron could reach Component[183] channel_1_analyzer_2_array_crystal_array_4\n");
    if (mcAbsorbProp[183]) fprintf(stderr, "Warning: %g events were removed in Component[183] channel_1_analyzer_2_array_crystal_array_4=Union_box()\n"
"         (negative time, miss next components, rounding errors, Nan, Inf).\n", mcAbsorbProp[183]);
    if (!mcNCounter[184]) fprintf(stderr, "Warning: No neutron could reach Component[184] channel_1_analyzer_2_array_crystal_array_5\n");
    if (mcAbsorbProp[184]) fprintf(stderr, "Warning: %g events were removed in Component[184] channel_1_analyzer_2_array_crystal_array_5=Union_box()\n"
"         (negative time, miss next components, rounding errors, Nan, Inf).\n", mcAbsorbProp[184]);
    if (!mcNCounter[185]) fprintf(stderr, "Warning: No neutron could reach Component[185] channel_1_analyzer_2_array_crystal_array_6\n");
    if (mcAbsorbProp[185]) fprintf(stderr, "Warning: %g events were removed in Component[185] channel_1_analyzer_2_array_crystal_array_6=Union_box()\n"
"         (negative time, miss next components, rounding errors, Nan, Inf).\n", mcAbsorbProp[185]);
    if (!mcNCounter[186]) fprintf(stderr, "Warning: No neutron could reach Component[186] channel_1_analyzer_2_array_crystal_array_7\n");
    if (mcAbsorbProp[186]) fprintf(stderr, "Warning: %g events were removed in Component[186] channel_1_analyzer_2_array_crystal_array_7=Union_box()\n"
"         (negative time, miss next components, rounding errors, Nan, Inf).\n", mcAbsorbProp[186]);
    if (!mcNCounter[187]) fprintf(stderr, "Warning: No neutron could reach Component[187] channel_1_analyzer_2_array_crystal_array_8\n");
    if (mcAbsorbProp[187]) fprintf(stderr, "Warning: %g events were removed in Component[187] channel_1_analyzer_2_array_crystal_array_8=Union_box()\n"
"         (negative time, miss next components, rounding errors, Nan, Inf).\n", mcAbsorbProp[187]);
    if (!mcNCounter[188]) fprintf(stderr, "Warning: No neutron could reach Component[188] channel_1_cave2_cyl1\n");
    if (mcAbsorbProp[188]) fprintf(stderr, "Warning: %g events were removed in Component[188] channel_1_cave2_cyl1=Union_cylinder()\n"
"         (negative time, miss next components, rounding errors, Nan, Inf).\n", mcAbsorbProp[188]);
    if (!mcNCounter[189]) fprintf(stderr, "Warning: No neutron could reach Component[189] channel_1_cave2_box1\n");
    if (mcAbsorbProp[189]) fprintf(stderr, "Warning: %g events were removed in Component[189] channel_1_cave2_box1=Union_box()\n"
"         (negative time, miss next components, rounding errors, Nan, Inf).\n", mcAbsorbProp[189]);
    if (!mcNCounter[190]) fprintf(stderr, "Warning: No neutron could reach Component[190] channel_1_cave2_box2\n");
    if (mcAbsorbProp[190]) fprintf(stderr, "Warning: %g events were removed in Component[190] channel_1_cave2_box2=Union_box()\n"
"         (negative time, miss next components, rounding errors, Nan, Inf).\n", mcAbsorbProp[190]);
    if (!mcNCounter[191]) fprintf(stderr, "Warning: No neutron could reach Component[191] channel_1_cave2_box3\n");
    if (mcAbsorbProp[191]) fprintf(stderr, "Warning: %g events were removed in Component[191] channel_1_cave2_box3=Union_box()\n"
"         (negative time, miss next components, rounding errors, Nan, Inf).\n", mcAbsorbProp[191]);
    if (!mcNCounter[192]) fprintf(stderr, "Warning: No neutron could reach Component[192] inter_analyzer_colimator_center_1\n");
    if (mcAbsorbProp[192]) fprintf(stderr, "Warning: %g events were removed in Component[192] inter_analyzer_colimator_center_1=Arm()\n"
"         (negative time, miss next components, rounding errors, Nan, Inf).\n", mcAbsorbProp[192]);
    if (!mcNCounter[193]) fprintf(stderr, "Warning: No neutron could reach Component[193] inter_analyzer_colimator_1_blade_0\n");
    if (mcAbsorbProp[193]) fprintf(stderr, "Warning: %g events were removed in Component[193] inter_analyzer_colimator_1_blade_0=Union_box()\n"
"         (negative time, miss next components, rounding errors, Nan, Inf).\n", mcAbsorbProp[193]);
    if (!mcNCounter[194]) fprintf(stderr, "Warning: No neutron could reach Component[194] inter_analyzer_colimator_1_blade_1\n");
    if (mcAbsorbProp[194]) fprintf(stderr, "Warning: %g events were removed in Component[194] inter_analyzer_colimator_1_blade_1=Union_box()\n"
"         (negative time, miss next components, rounding errors, Nan, Inf).\n", mcAbsorbProp[194]);
    if (!mcNCounter[195]) fprintf(stderr, "Warning: No neutron could reach Component[195] inter_analyzer_colimator_1_blade_2\n");
    if (mcAbsorbProp[195]) fprintf(stderr, "Warning: %g events were removed in Component[195] inter_analyzer_colimator_1_blade_2=Union_box()\n"
"         (negative time, miss next components, rounding errors, Nan, Inf).\n", mcAbsorbProp[195]);
    if (!mcNCounter[196]) fprintf(stderr, "Warning: No neutron could reach Component[196] inter_analyzer_colimator_1_blade_3\n");
    if (mcAbsorbProp[196]) fprintf(stderr, "Warning: %g events were removed in Component[196] inter_analyzer_colimator_1_blade_3=Union_box()\n"
"         (negative time, miss next components, rounding errors, Nan, Inf).\n", mcAbsorbProp[196]);
    if (!mcNCounter[197]) fprintf(stderr, "Warning: No neutron could reach Component[197] inter_analyzer_colimator_1_blade_4\n");
    if (mcAbsorbProp[197]) fprintf(stderr, "Warning: %g events were removed in Component[197] inter_analyzer_colimator_1_blade_4=Union_box()\n"
"         (negative time, miss next components, rounding errors, Nan, Inf).\n", mcAbsorbProp[197]);
    if (!mcNCounter[198]) fprintf(stderr, "Warning: No neutron could reach Component[198] diffraction_detector_1_exit_volume\n");
    if (mcAbsorbProp[198]) fprintf(stderr, "Warning: %g events were removed in Component[198] diffraction_detector_1_exit_volume=Union_box()\n"
"         (negative time, miss next components, rounding errors, Nan, Inf).\n", mcAbsorbProp[198]);
    if (!mcNCounter[199]) fprintf(stderr, "Warning: No neutron could reach Component[199] spec_detector_1_exit_volume\n");
    if (mcAbsorbProp[199]) fprintf(stderr, "Warning: %g events were removed in Component[199] spec_detector_1_exit_volume=Union_box()\n"
"         (negative time, miss next components, rounding errors, Nan, Inf).\n", mcAbsorbProp[199]);
    if (!mcNCounter[200]) fprintf(stderr, "Warning: No neutron could reach Component[200] channel_2_cave1_box1\n");
    if (mcAbsorbProp[200]) fprintf(stderr, "Warning: %g events were removed in Component[200] channel_2_cave1_box1=Union_box()\n"
"         (negative time, miss next components, rounding errors, Nan, Inf).\n", mcAbsorbProp[200]);
    if (!mcNCounter[201]) fprintf(stderr, "Warning: No neutron could reach Component[201] channel_2_cave1_box2\n");
    if (mcAbsorbProp[201]) fprintf(stderr, "Warning: %g events were removed in Component[201] channel_2_cave1_box2=Union_box()\n"
"         (negative time, miss next components, rounding errors, Nan, Inf).\n", mcAbsorbProp[201]);
    if (!mcNCounter[202]) fprintf(stderr, "Warning: No neutron could reach Component[202] channel_2_cave1_box3\n");
    if (mcAbsorbProp[202]) fprintf(stderr, "Warning: %g events were removed in Component[202] channel_2_cave1_box3=Union_box()\n"
"         (negative time, miss next components, rounding errors, Nan, Inf).\n", mcAbsorbProp[202]);
    if (!mcNCounter[203]) fprintf(stderr, "Warning: No neutron could reach Component[203] channel_2_cave1_cyl1\n");
    if (mcAbsorbProp[203]) fprintf(stderr, "Warning: %g events were removed in Component[203] channel_2_cave1_cyl1=Union_cylinder()\n"
"         (negative time, miss next components, rounding errors, Nan, Inf).\n", mcAbsorbProp[203]);
    if (!mcNCounter[204]) fprintf(stderr, "Warning: No neutron could reach Component[204] channel_2_analyzer_1_center\n");
    if (mcAbsorbProp[204]) fprintf(stderr, "Warning: %g events were removed in Component[204] channel_2_analyzer_1_center=Arm()\n"
"         (negative time, miss next components, rounding errors, Nan, Inf).\n", mcAbsorbProp[204]);
    if (!mcNCounter[205]) fprintf(stderr, "Warning: No neutron could reach Component[205] channel_2_analyzer_1_rotated\n");
    if (mcAbsorbProp[205]) fprintf(stderr, "Warning: %g events were removed in Component[205] channel_2_analyzer_1_rotated=Arm()\n"
"         (negative time, miss next components, rounding errors, Nan, Inf).\n", mcAbsorbProp[205]);
    if (!mcNCounter[206]) fprintf(stderr, "Warning: No neutron could reach Component[206] channel_2_analyzer_1_array_crystal_array_0\n");
    if (mcAbsorbProp[206]) fprintf(stderr, "Warning: %g events were removed in Component[206] channel_2_analyzer_1_array_crystal_array_0=Union_box()\n"
"         (negative time, miss next components, rounding errors, Nan, Inf).\n", mcAbsorbProp[206]);
    if (!mcNCounter[207]) fprintf(stderr, "Warning: No neutron could reach Component[207] channel_2_analyzer_1_array_crystal_array_1\n");
    if (mcAbsorbProp[207]) fprintf(stderr, "Warning: %g events were removed in Component[207] channel_2_analyzer_1_array_crystal_array_1=Union_box()\n"
"         (negative time, miss next components, rounding errors, Nan, Inf).\n", mcAbsorbProp[207]);
    if (!mcNCounter[208]) fprintf(stderr, "Warning: No neutron could reach Component[208] channel_2_analyzer_1_array_crystal_array_2\n");
    if (mcAbsorbProp[208]) fprintf(stderr, "Warning: %g events were removed in Component[208] channel_2_analyzer_1_array_crystal_array_2=Union_box()\n"
"         (negative time, miss next components, rounding errors, Nan, Inf).\n", mcAbsorbProp[208]);
    if (!mcNCounter[209]) fprintf(stderr, "Warning: No neutron could reach Component[209] channel_2_analyzer_1_array_crystal_array_3\n");
    if (mcAbsorbProp[209]) fprintf(stderr, "Warning: %g events were removed in Component[209] channel_2_analyzer_1_array_crystal_array_3=Union_box()\n"
"         (negative time, miss next components, rounding errors, Nan, Inf).\n", mcAbsorbProp[209]);
    if (!mcNCounter[210]) fprintf(stderr, "Warning: No neutron could reach Component[210] channel_2_analyzer_1_array_crystal_array_4\n");
    if (mcAbsorbProp[210]) fprintf(stderr, "Warning: %g events were removed in Component[210] channel_2_analyzer_1_array_crystal_array_4=Union_box()\n"
"         (negative time, miss next components, rounding errors, Nan, Inf).\n", mcAbsorbProp[210]);
    if (!mcNCounter[211]) fprintf(stderr, "Warning: No neutron could reach Component[211] channel_2_analyzer_1_array_crystal_array_5\n");
    if (mcAbsorbProp[211]) fprintf(stderr, "Warning: %g events were removed in Component[211] channel_2_analyzer_1_array_crystal_array_5=Union_box()\n"
"         (negative time, miss next components, rounding errors, Nan, Inf).\n", mcAbsorbProp[211]);
    if (!mcNCounter[212]) fprintf(stderr, "Warning: No neutron could reach Component[212] channel_2_analyzer_1_array_crystal_array_6\n");
    if (mcAbsorbProp[212]) fprintf(stderr, "Warning: %g events were removed in Component[212] channel_2_analyzer_1_array_crystal_array_6=Union_box()\n"
"         (negative time, miss next components, rounding errors, Nan, Inf).\n", mcAbsorbProp[212]);
    if (!mcNCounter[213]) fprintf(stderr, "Warning: No neutron could reach Component[213] channel_2_analyzer_1_array_crystal_array_7\n");
    if (mcAbsorbProp[213]) fprintf(stderr, "Warning: %g events were removed in Component[213] channel_2_analyzer_1_array_crystal_array_7=Union_box()\n"
"         (negative time, miss next components, rounding errors, Nan, Inf).\n", mcAbsorbProp[213]);
    if (!mcNCounter[214]) fprintf(stderr, "Warning: No neutron could reach Component[214] channel_2_analyzer_1_array_crystal_array_8\n");
    if (mcAbsorbProp[214]) fprintf(stderr, "Warning: %g events were removed in Component[214] channel_2_analyzer_1_array_crystal_array_8=Union_box()\n"
"         (negative time, miss next components, rounding errors, Nan, Inf).\n", mcAbsorbProp[214]);
    if (!mcNCounter[215]) fprintf(stderr, "Warning: No neutron could reach Component[215] channel_2_analyzer_2_center\n");
    if (mcAbsorbProp[215]) fprintf(stderr, "Warning: %g events were removed in Component[215] channel_2_analyzer_2_center=Arm()\n"
"         (negative time, miss next components, rounding errors, Nan, Inf).\n", mcAbsorbProp[215]);
    if (!mcNCounter[216]) fprintf(stderr, "Warning: No neutron could reach Component[216] channel_2_analyzer_2_rotated\n");
    if (mcAbsorbProp[216]) fprintf(stderr, "Warning: %g events were removed in Component[216] channel_2_analyzer_2_rotated=Arm()\n"
"         (negative time, miss next components, rounding errors, Nan, Inf).\n", mcAbsorbProp[216]);
    if (!mcNCounter[217]) fprintf(stderr, "Warning: No neutron could reach Component[217] channel_2_analyzer_2_array_crystal_array_0\n");
    if (mcAbsorbProp[217]) fprintf(stderr, "Warning: %g events were removed in Component[217] channel_2_analyzer_2_array_crystal_array_0=Union_box()\n"
"         (negative time, miss next components, rounding errors, Nan, Inf).\n", mcAbsorbProp[217]);
    if (!mcNCounter[218]) fprintf(stderr, "Warning: No neutron could reach Component[218] channel_2_analyzer_2_array_crystal_array_1\n");
    if (mcAbsorbProp[218]) fprintf(stderr, "Warning: %g events were removed in Component[218] channel_2_analyzer_2_array_crystal_array_1=Union_box()\n"
"         (negative time, miss next components, rounding errors, Nan, Inf).\n", mcAbsorbProp[218]);
    if (!mcNCounter[219]) fprintf(stderr, "Warning: No neutron could reach Component[219] channel_2_analyzer_2_array_crystal_array_2\n");
    if (mcAbsorbProp[219]) fprintf(stderr, "Warning: %g events were removed in Component[219] channel_2_analyzer_2_array_crystal_array_2=Union_box()\n"
"         (negative time, miss next components, rounding errors, Nan, Inf).\n", mcAbsorbProp[219]);
    if (!mcNCounter[220]) fprintf(stderr, "Warning: No neutron could reach Component[220] channel_2_analyzer_2_array_crystal_array_3\n");
    if (mcAbsorbProp[220]) fprintf(stderr, "Warning: %g events were removed in Component[220] channel_2_analyzer_2_array_crystal_array_3=Union_box()\n"
"         (negative time, miss next components, rounding errors, Nan, Inf).\n", mcAbsorbProp[220]);
    if (!mcNCounter[221]) fprintf(stderr, "Warning: No neutron could reach Component[221] channel_2_analyzer_2_array_crystal_array_4\n");
    if (mcAbsorbProp[221]) fprintf(stderr, "Warning: %g events were removed in Component[221] channel_2_analyzer_2_array_crystal_array_4=Union_box()\n"
"         (negative time, miss next components, rounding errors, Nan, Inf).\n", mcAbsorbProp[221]);
    if (!mcNCounter[222]) fprintf(stderr, "Warning: No neutron could reach Component[222] channel_2_analyzer_2_array_crystal_array_5\n");
    if (mcAbsorbProp[222]) fprintf(stderr, "Warning: %g events were removed in Component[222] channel_2_analyzer_2_array_crystal_array_5=Union_box()\n"
"         (negative time, miss next components, rounding errors, Nan, Inf).\n", mcAbsorbProp[222]);
    if (!mcNCounter[223]) fprintf(stderr, "Warning: No neutron could reach Component[223] channel_2_analyzer_2_array_crystal_array_6\n");
    if (mcAbsorbProp[223]) fprintf(stderr, "Warning: %g events were removed in Component[223] channel_2_analyzer_2_array_crystal_array_6=Union_box()\n"
"         (negative time, miss next components, rounding errors, Nan, Inf).\n", mcAbsorbProp[223]);
    if (!mcNCounter[224]) fprintf(stderr, "Warning: No neutron could reach Component[224] channel_2_analyzer_2_array_crystal_array_7\n");
    if (mcAbsorbProp[224]) fprintf(stderr, "Warning: %g events were removed in Component[224] channel_2_analyzer_2_array_crystal_array_7=Union_box()\n"
"         (negative time, miss next components, rounding errors, Nan, Inf).\n", mcAbsorbProp[224]);
    if (!mcNCounter[225]) fprintf(stderr, "Warning: No neutron could reach Component[225] channel_2_analyzer_2_array_crystal_array_8\n");
    if (mcAbsorbProp[225]) fprintf(stderr, "Warning: %g events were removed in Component[225] channel_2_analyzer_2_array_crystal_array_8=Union_box()\n"
"         (negative time, miss next components, rounding errors, Nan, Inf).\n", mcAbsorbProp[225]);
    if (!mcNCounter[226]) fprintf(stderr, "Warning: No neutron could reach Component[226] channel_2_cave2_cyl1\n");
    if (mcAbsorbProp[226]) fprintf(stderr, "Warning: %g events were removed in Component[226] channel_2_cave2_cyl1=Union_cylinder()\n"
"         (negative time, miss next components, rounding errors, Nan, Inf).\n", mcAbsorbProp[226]);
    if (!mcNCounter[227]) fprintf(stderr, "Warning: No neutron could reach Component[227] channel_2_cave2_box1\n");
    if (mcAbsorbProp[227]) fprintf(stderr, "Warning: %g events were removed in Component[227] channel_2_cave2_box1=Union_box()\n"
"         (negative time, miss next components, rounding errors, Nan, Inf).\n", mcAbsorbProp[227]);
    if (!mcNCounter[228]) fprintf(stderr, "Warning: No neutron could reach Component[228] channel_2_cave2_box2\n");
    if (mcAbsorbProp[228]) fprintf(stderr, "Warning: %g events were removed in Component[228] channel_2_cave2_box2=Union_box()\n"
"         (negative time, miss next components, rounding errors, Nan, Inf).\n", mcAbsorbProp[228]);
    if (!mcNCounter[229]) fprintf(stderr, "Warning: No neutron could reach Component[229] channel_2_cave2_box3\n");
    if (mcAbsorbProp[229]) fprintf(stderr, "Warning: %g events were removed in Component[229] channel_2_cave2_box3=Union_box()\n"
"         (negative time, miss next components, rounding errors, Nan, Inf).\n", mcAbsorbProp[229]);
    if (!mcNCounter[230]) fprintf(stderr, "Warning: No neutron could reach Component[230] inter_analyzer_colimator_center_2\n");
    if (mcAbsorbProp[230]) fprintf(stderr, "Warning: %g events were removed in Component[230] inter_analyzer_colimator_center_2=Arm()\n"
"         (negative time, miss next components, rounding errors, Nan, Inf).\n", mcAbsorbProp[230]);
    if (!mcNCounter[231]) fprintf(stderr, "Warning: No neutron could reach Component[231] inter_analyzer_colimator_2_blade_0\n");
    if (mcAbsorbProp[231]) fprintf(stderr, "Warning: %g events were removed in Component[231] inter_analyzer_colimator_2_blade_0=Union_box()\n"
"         (negative time, miss next components, rounding errors, Nan, Inf).\n", mcAbsorbProp[231]);
    if (!mcNCounter[232]) fprintf(stderr, "Warning: No neutron could reach Component[232] inter_analyzer_colimator_2_blade_1\n");
    if (mcAbsorbProp[232]) fprintf(stderr, "Warning: %g events were removed in Component[232] inter_analyzer_colimator_2_blade_1=Union_box()\n"
"         (negative time, miss next components, rounding errors, Nan, Inf).\n", mcAbsorbProp[232]);
    if (!mcNCounter[233]) fprintf(stderr, "Warning: No neutron could reach Component[233] inter_analyzer_colimator_2_blade_2\n");
    if (mcAbsorbProp[233]) fprintf(stderr, "Warning: %g events were removed in Component[233] inter_analyzer_colimator_2_blade_2=Union_box()\n"
"         (negative time, miss next components, rounding errors, Nan, Inf).\n", mcAbsorbProp[233]);
    if (!mcNCounter[234]) fprintf(stderr, "Warning: No neutron could reach Component[234] inter_analyzer_colimator_2_blade_3\n");
    if (mcAbsorbProp[234]) fprintf(stderr, "Warning: %g events were removed in Component[234] inter_analyzer_colimator_2_blade_3=Union_box()\n"
"         (negative time, miss next components, rounding errors, Nan, Inf).\n", mcAbsorbProp[234]);
    if (!mcNCounter[235]) fprintf(stderr, "Warning: No neutron could reach Component[235] inter_analyzer_colimator_2_blade_4\n");
    if (mcAbsorbProp[235]) fprintf(stderr, "Warning: %g events were removed in Component[235] inter_analyzer_colimator_2_blade_4=Union_box()\n"
"         (negative time, miss next components, rounding errors, Nan, Inf).\n", mcAbsorbProp[235]);
    if (!mcNCounter[236]) fprintf(stderr, "Warning: No neutron could reach Component[236] diffraction_detector_2_exit_volume\n");
    if (mcAbsorbProp[236]) fprintf(stderr, "Warning: %g events were removed in Component[236] diffraction_detector_2_exit_volume=Union_box()\n"
"         (negative time, miss next components, rounding errors, Nan, Inf).\n", mcAbsorbProp[236]);
    if (!mcNCounter[237]) fprintf(stderr, "Warning: No neutron could reach Component[237] spec_detector_2_exit_volume\n");
    if (mcAbsorbProp[237]) fprintf(stderr, "Warning: %g events were removed in Component[237] spec_detector_2_exit_volume=Union_box()\n"
"         (negative time, miss next components, rounding errors, Nan, Inf).\n", mcAbsorbProp[237]);
    if (!mcNCounter[238]) fprintf(stderr, "Warning: No neutron could reach Component[238] channel_3_cave1_box1\n");
    if (mcAbsorbProp[238]) fprintf(stderr, "Warning: %g events were removed in Component[238] channel_3_cave1_box1=Union_box()\n"
"         (negative time, miss next components, rounding errors, Nan, Inf).\n", mcAbsorbProp[238]);
    if (!mcNCounter[239]) fprintf(stderr, "Warning: No neutron could reach Component[239] channel_3_cave1_box2\n");
    if (mcAbsorbProp[239]) fprintf(stderr, "Warning: %g events were removed in Component[239] channel_3_cave1_box2=Union_box()\n"
"         (negative time, miss next components, rounding errors, Nan, Inf).\n", mcAbsorbProp[239]);
    if (!mcNCounter[240]) fprintf(stderr, "Warning: No neutron could reach Component[240] channel_3_cave1_box3\n");
    if (mcAbsorbProp[240]) fprintf(stderr, "Warning: %g events were removed in Component[240] channel_3_cave1_box3=Union_box()\n"
"         (negative time, miss next components, rounding errors, Nan, Inf).\n", mcAbsorbProp[240]);
    if (!mcNCounter[241]) fprintf(stderr, "Warning: No neutron could reach Component[241] channel_3_cave1_cyl1\n");
    if (mcAbsorbProp[241]) fprintf(stderr, "Warning: %g events were removed in Component[241] channel_3_cave1_cyl1=Union_cylinder()\n"
"         (negative time, miss next components, rounding errors, Nan, Inf).\n", mcAbsorbProp[241]);
    if (!mcNCounter[242]) fprintf(stderr, "Warning: No neutron could reach Component[242] channel_3_analyzer_1_center\n");
    if (mcAbsorbProp[242]) fprintf(stderr, "Warning: %g events were removed in Component[242] channel_3_analyzer_1_center=Arm()\n"
"         (negative time, miss next components, rounding errors, Nan, Inf).\n", mcAbsorbProp[242]);
    if (!mcNCounter[243]) fprintf(stderr, "Warning: No neutron could reach Component[243] channel_3_analyzer_1_rotated\n");
    if (mcAbsorbProp[243]) fprintf(stderr, "Warning: %g events were removed in Component[243] channel_3_analyzer_1_rotated=Arm()\n"
"         (negative time, miss next components, rounding errors, Nan, Inf).\n", mcAbsorbProp[243]);
    if (!mcNCounter[244]) fprintf(stderr, "Warning: No neutron could reach Component[244] channel_3_analyzer_1_array_crystal_array_0\n");
    if (mcAbsorbProp[244]) fprintf(stderr, "Warning: %g events were removed in Component[244] channel_3_analyzer_1_array_crystal_array_0=Union_box()\n"
"         (negative time, miss next components, rounding errors, Nan, Inf).\n", mcAbsorbProp[244]);
    if (!mcNCounter[245]) fprintf(stderr, "Warning: No neutron could reach Component[245] channel_3_analyzer_1_array_crystal_array_1\n");
    if (mcAbsorbProp[245]) fprintf(stderr, "Warning: %g events were removed in Component[245] channel_3_analyzer_1_array_crystal_array_1=Union_box()\n"
"         (negative time, miss next components, rounding errors, Nan, Inf).\n", mcAbsorbProp[245]);
    if (!mcNCounter[246]) fprintf(stderr, "Warning: No neutron could reach Component[246] channel_3_analyzer_1_array_crystal_array_2\n");
    if (mcAbsorbProp[246]) fprintf(stderr, "Warning: %g events were removed in Component[246] channel_3_analyzer_1_array_crystal_array_2=Union_box()\n"
"         (negative time, miss next components, rounding errors, Nan, Inf).\n", mcAbsorbProp[246]);
    if (!mcNCounter[247]) fprintf(stderr, "Warning: No neutron could reach Component[247] channel_3_analyzer_1_array_crystal_array_3\n");
    if (mcAbsorbProp[247]) fprintf(stderr, "Warning: %g events were removed in Component[247] channel_3_analyzer_1_array_crystal_array_3=Union_box()\n"
"         (negative time, miss next components, rounding errors, Nan, Inf).\n", mcAbsorbProp[247]);
    if (!mcNCounter[248]) fprintf(stderr, "Warning: No neutron could reach Component[248] channel_3_analyzer_1_array_crystal_array_4\n");
    if (mcAbsorbProp[248]) fprintf(stderr, "Warning: %g events were removed in Component[248] channel_3_analyzer_1_array_crystal_array_4=Union_box()\n"
"         (negative time, miss next components, rounding errors, Nan, Inf).\n", mcAbsorbProp[248]);
    if (!mcNCounter[249]) fprintf(stderr, "Warning: No neutron could reach Component[249] channel_3_analyzer_1_array_crystal_array_5\n");
    if (mcAbsorbProp[249]) fprintf(stderr, "Warning: %g events were removed in Component[249] channel_3_analyzer_1_array_crystal_array_5=Union_box()\n"
"         (negative time, miss next components, rounding errors, Nan, Inf).\n", mcAbsorbProp[249]);
    if (!mcNCounter[250]) fprintf(stderr, "Warning: No neutron could reach Component[250] channel_3_analyzer_1_array_crystal_array_6\n");
    if (mcAbsorbProp[250]) fprintf(stderr, "Warning: %g events were removed in Component[250] channel_3_analyzer_1_array_crystal_array_6=Union_box()\n"
"         (negative time, miss next components, rounding errors, Nan, Inf).\n", mcAbsorbProp[250]);
    if (!mcNCounter[251]) fprintf(stderr, "Warning: No neutron could reach Component[251] channel_3_analyzer_1_array_crystal_array_7\n");
    if (mcAbsorbProp[251]) fprintf(stderr, "Warning: %g events were removed in Component[251] channel_3_analyzer_1_array_crystal_array_7=Union_box()\n"
"         (negative time, miss next components, rounding errors, Nan, Inf).\n", mcAbsorbProp[251]);
    if (!mcNCounter[252]) fprintf(stderr, "Warning: No neutron could reach Component[252] channel_3_analyzer_1_array_crystal_array_8\n");
    if (mcAbsorbProp[252]) fprintf(stderr, "Warning: %g events were removed in Component[252] channel_3_analyzer_1_array_crystal_array_8=Union_box()\n"
"         (negative time, miss next components, rounding errors, Nan, Inf).\n", mcAbsorbProp[252]);
    if (!mcNCounter[253]) fprintf(stderr, "Warning: No neutron could reach Component[253] channel_3_analyzer_2_center\n");
    if (mcAbsorbProp[253]) fprintf(stderr, "Warning: %g events were removed in Component[253] channel_3_analyzer_2_center=Arm()\n"
"         (negative time, miss next components, rounding errors, Nan, Inf).\n", mcAbsorbProp[253]);
    if (!mcNCounter[254]) fprintf(stderr, "Warning: No neutron could reach Component[254] channel_3_analyzer_2_rotated\n");
    if (mcAbsorbProp[254]) fprintf(stderr, "Warning: %g events were removed in Component[254] channel_3_analyzer_2_rotated=Arm()\n"
"         (negative time, miss next components, rounding errors, Nan, Inf).\n", mcAbsorbProp[254]);
    if (!mcNCounter[255]) fprintf(stderr, "Warning: No neutron could reach Component[255] channel_3_analyzer_2_array_crystal_array_0\n");
    if (mcAbsorbProp[255]) fprintf(stderr, "Warning: %g events were removed in Component[255] channel_3_analyzer_2_array_crystal_array_0=Union_box()\n"
"         (negative time, miss next components, rounding errors, Nan, Inf).\n", mcAbsorbProp[255]);
    if (!mcNCounter[256]) fprintf(stderr, "Warning: No neutron could reach Component[256] channel_3_analyzer_2_array_crystal_array_1\n");
    if (mcAbsorbProp[256]) fprintf(stderr, "Warning: %g events were removed in Component[256] channel_3_analyzer_2_array_crystal_array_1=Union_box()\n"
"         (negative time, miss next components, rounding errors, Nan, Inf).\n", mcAbsorbProp[256]);
    if (!mcNCounter[257]) fprintf(stderr, "Warning: No neutron could reach Component[257] channel_3_analyzer_2_array_crystal_array_2\n");
    if (mcAbsorbProp[257]) fprintf(stderr, "Warning: %g events were removed in Component[257] channel_3_analyzer_2_array_crystal_array_2=Union_box()\n"
"         (negative time, miss next components, rounding errors, Nan, Inf).\n", mcAbsorbProp[257]);
    if (!mcNCounter[258]) fprintf(stderr, "Warning: No neutron could reach Component[258] channel_3_analyzer_2_array_crystal_array_3\n");
    if (mcAbsorbProp[258]) fprintf(stderr, "Warning: %g events were removed in Component[258] channel_3_analyzer_2_array_crystal_array_3=Union_box()\n"
"         (negative time, miss next components, rounding errors, Nan, Inf).\n", mcAbsorbProp[258]);
    if (!mcNCounter[259]) fprintf(stderr, "Warning: No neutron could reach Component[259] channel_3_analyzer_2_array_crystal_array_4\n");
    if (mcAbsorbProp[259]) fprintf(stderr, "Warning: %g events were removed in Component[259] channel_3_analyzer_2_array_crystal_array_4=Union_box()\n"
"         (negative time, miss next components, rounding errors, Nan, Inf).\n", mcAbsorbProp[259]);
    if (!mcNCounter[260]) fprintf(stderr, "Warning: No neutron could reach Component[260] channel_3_analyzer_2_array_crystal_array_5\n");
    if (mcAbsorbProp[260]) fprintf(stderr, "Warning: %g events were removed in Component[260] channel_3_analyzer_2_array_crystal_array_5=Union_box()\n"
"         (negative time, miss next components, rounding errors, Nan, Inf).\n", mcAbsorbProp[260]);
    if (!mcNCounter[261]) fprintf(stderr, "Warning: No neutron could reach Component[261] channel_3_analyzer_2_array_crystal_array_6\n");
    if (mcAbsorbProp[261]) fprintf(stderr, "Warning: %g events were removed in Component[261] channel_3_analyzer_2_array_crystal_array_6=Union_box()\n"
"         (negative time, miss next components, rounding errors, Nan, Inf).\n", mcAbsorbProp[261]);
    if (!mcNCounter[262]) fprintf(stderr, "Warning: No neutron could reach Component[262] channel_3_analyzer_2_array_crystal_array_7\n");
    if (mcAbsorbProp[262]) fprintf(stderr, "Warning: %g events were removed in Component[262] channel_3_analyzer_2_array_crystal_array_7=Union_box()\n"
"         (negative time, miss next components, rounding errors, Nan, Inf).\n", mcAbsorbProp[262]);
    if (!mcNCounter[263]) fprintf(stderr, "Warning: No neutron could reach Component[263] channel_3_analyzer_2_array_crystal_array_8\n");
    if (mcAbsorbProp[263]) fprintf(stderr, "Warning: %g events were removed in Component[263] channel_3_analyzer_2_array_crystal_array_8=Union_box()\n"
"         (negative time, miss next components, rounding errors, Nan, Inf).\n", mcAbsorbProp[263]);
    if (!mcNCounter[264]) fprintf(stderr, "Warning: No neutron could reach Component[264] channel_3_cave2_cyl1\n");
    if (mcAbsorbProp[264]) fprintf(stderr, "Warning: %g events were removed in Component[264] channel_3_cave2_cyl1=Union_cylinder()\n"
"         (negative time, miss next components, rounding errors, Nan, Inf).\n", mcAbsorbProp[264]);
    if (!mcNCounter[265]) fprintf(stderr, "Warning: No neutron could reach Component[265] channel_3_cave2_box1\n");
    if (mcAbsorbProp[265]) fprintf(stderr, "Warning: %g events were removed in Component[265] channel_3_cave2_box1=Union_box()\n"
"         (negative time, miss next components, rounding errors, Nan, Inf).\n", mcAbsorbProp[265]);
    if (!mcNCounter[266]) fprintf(stderr, "Warning: No neutron could reach Component[266] channel_3_cave2_box2\n");
    if (mcAbsorbProp[266]) fprintf(stderr, "Warning: %g events were removed in Component[266] channel_3_cave2_box2=Union_box()\n"
"         (negative time, miss next components, rounding errors, Nan, Inf).\n", mcAbsorbProp[266]);
    if (!mcNCounter[267]) fprintf(stderr, "Warning: No neutron could reach Component[267] channel_3_cave2_box3\n");
    if (mcAbsorbProp[267]) fprintf(stderr, "Warning: %g events were removed in Component[267] channel_3_cave2_box3=Union_box()\n"
"         (negative time, miss next components, rounding errors, Nan, Inf).\n", mcAbsorbProp[267]);
    if (!mcNCounter[268]) fprintf(stderr, "Warning: No neutron could reach Component[268] inter_analyzer_colimator_center_3\n");
    if (mcAbsorbProp[268]) fprintf(stderr, "Warning: %g events were removed in Component[268] inter_analyzer_colimator_center_3=Arm()\n"
"         (negative time, miss next components, rounding errors, Nan, Inf).\n", mcAbsorbProp[268]);
    if (!mcNCounter[269]) fprintf(stderr, "Warning: No neutron could reach Component[269] inter_analyzer_colimator_3_blade_0\n");
    if (mcAbsorbProp[269]) fprintf(stderr, "Warning: %g events were removed in Component[269] inter_analyzer_colimator_3_blade_0=Union_box()\n"
"         (negative time, miss next components, rounding errors, Nan, Inf).\n", mcAbsorbProp[269]);
    if (!mcNCounter[270]) fprintf(stderr, "Warning: No neutron could reach Component[270] inter_analyzer_colimator_3_blade_1\n");
    if (mcAbsorbProp[270]) fprintf(stderr, "Warning: %g events were removed in Component[270] inter_analyzer_colimator_3_blade_1=Union_box()\n"
"         (negative time, miss next components, rounding errors, Nan, Inf).\n", mcAbsorbProp[270]);
    if (!mcNCounter[271]) fprintf(stderr, "Warning: No neutron could reach Component[271] inter_analyzer_colimator_3_blade_2\n");
    if (mcAbsorbProp[271]) fprintf(stderr, "Warning: %g events were removed in Component[271] inter_analyzer_colimator_3_blade_2=Union_box()\n"
"         (negative time, miss next components, rounding errors, Nan, Inf).\n", mcAbsorbProp[271]);
    if (!mcNCounter[272]) fprintf(stderr, "Warning: No neutron could reach Component[272] inter_analyzer_colimator_3_blade_3\n");
    if (mcAbsorbProp[272]) fprintf(stderr, "Warning: %g events were removed in Component[272] inter_analyzer_colimator_3_blade_3=Union_box()\n"
"         (negative time, miss next components, rounding errors, Nan, Inf).\n", mcAbsorbProp[272]);
    if (!mcNCounter[273]) fprintf(stderr, "Warning: No neutron could reach Component[273] inter_analyzer_colimator_3_blade_4\n");
    if (mcAbsorbProp[273]) fprintf(stderr, "Warning: %g events were removed in Component[273] inter_analyzer_colimator_3_blade_4=Union_box()\n"
"         (negative time, miss next components, rounding errors, Nan, Inf).\n", mcAbsorbProp[273]);
    if (!mcNCounter[274]) fprintf(stderr, "Warning: No neutron could reach Component[274] diffraction_detector_3_exit_volume\n");
    if (mcAbsorbProp[274]) fprintf(stderr, "Warning: %g events were removed in Component[274] diffraction_detector_3_exit_volume=Union_box()\n"
"         (negative time, miss next components, rounding errors, Nan, Inf).\n", mcAbsorbProp[274]);
    if (!mcNCounter[275]) fprintf(stderr, "Warning: No neutron could reach Component[275] spec_detector_3_exit_volume\n");
    if (mcAbsorbProp[275]) fprintf(stderr, "Warning: %g events were removed in Component[275] spec_detector_3_exit_volume=Union_box()\n"
"         (negative time, miss next components, rounding errors, Nan, Inf).\n", mcAbsorbProp[275]);
    if (!mcNCounter[276]) fprintf(stderr, "Warning: No neutron could reach Component[276] channel_4_cave1_box1\n");
    if (mcAbsorbProp[276]) fprintf(stderr, "Warning: %g events were removed in Component[276] channel_4_cave1_box1=Union_box()\n"
"         (negative time, miss next components, rounding errors, Nan, Inf).\n", mcAbsorbProp[276]);
    if (!mcNCounter[277]) fprintf(stderr, "Warning: No neutron could reach Component[277] channel_4_cave1_box2\n");
    if (mcAbsorbProp[277]) fprintf(stderr, "Warning: %g events were removed in Component[277] channel_4_cave1_box2=Union_box()\n"
"         (negative time, miss next components, rounding errors, Nan, Inf).\n", mcAbsorbProp[277]);
    if (!mcNCounter[278]) fprintf(stderr, "Warning: No neutron could reach Component[278] channel_4_cave1_box3\n");
    if (mcAbsorbProp[278]) fprintf(stderr, "Warning: %g events were removed in Component[278] channel_4_cave1_box3=Union_box()\n"
"         (negative time, miss next components, rounding errors, Nan, Inf).\n", mcAbsorbProp[278]);
    if (!mcNCounter[279]) fprintf(stderr, "Warning: No neutron could reach Component[279] channel_4_cave1_cyl1\n");
    if (mcAbsorbProp[279]) fprintf(stderr, "Warning: %g events were removed in Component[279] channel_4_cave1_cyl1=Union_cylinder()\n"
"         (negative time, miss next components, rounding errors, Nan, Inf).\n", mcAbsorbProp[279]);
    if (!mcNCounter[280]) fprintf(stderr, "Warning: No neutron could reach Component[280] channel_4_analyzer_1_center\n");
    if (mcAbsorbProp[280]) fprintf(stderr, "Warning: %g events were removed in Component[280] channel_4_analyzer_1_center=Arm()\n"
"         (negative time, miss next components, rounding errors, Nan, Inf).\n", mcAbsorbProp[280]);
    if (!mcNCounter[281]) fprintf(stderr, "Warning: No neutron could reach Component[281] channel_4_analyzer_1_rotated\n");
    if (mcAbsorbProp[281]) fprintf(stderr, "Warning: %g events were removed in Component[281] channel_4_analyzer_1_rotated=Arm()\n"
"         (negative time, miss next components, rounding errors, Nan, Inf).\n", mcAbsorbProp[281]);
    if (!mcNCounter[282]) fprintf(stderr, "Warning: No neutron could reach Component[282] channel_4_analyzer_1_array_crystal_array_0\n");
    if (mcAbsorbProp[282]) fprintf(stderr, "Warning: %g events were removed in Component[282] channel_4_analyzer_1_array_crystal_array_0=Union_box()\n"
"         (negative time, miss next components, rounding errors, Nan, Inf).\n", mcAbsorbProp[282]);
    if (!mcNCounter[283]) fprintf(stderr, "Warning: No neutron could reach Component[283] channel_4_analyzer_1_array_crystal_array_1\n");
    if (mcAbsorbProp[283]) fprintf(stderr, "Warning: %g events were removed in Component[283] channel_4_analyzer_1_array_crystal_array_1=Union_box()\n"
"         (negative time, miss next components, rounding errors, Nan, Inf).\n", mcAbsorbProp[283]);
    if (!mcNCounter[284]) fprintf(stderr, "Warning: No neutron could reach Component[284] channel_4_analyzer_1_array_crystal_array_2\n");
    if (mcAbsorbProp[284]) fprintf(stderr, "Warning: %g events were removed in Component[284] channel_4_analyzer_1_array_crystal_array_2=Union_box()\n"
"         (negative time, miss next components, rounding errors, Nan, Inf).\n", mcAbsorbProp[284]);
    if (!mcNCounter[285]) fprintf(stderr, "Warning: No neutron could reach Component[285] channel_4_analyzer_1_array_crystal_array_3\n");
    if (mcAbsorbProp[285]) fprintf(stderr, "Warning: %g events were removed in Component[285] channel_4_analyzer_1_array_crystal_array_3=Union_box()\n"
"         (negative time, miss next components, rounding errors, Nan, Inf).\n", mcAbsorbProp[285]);
    if (!mcNCounter[286]) fprintf(stderr, "Warning: No neutron could reach Component[286] channel_4_analyzer_1_array_crystal_array_4\n");
    if (mcAbsorbProp[286]) fprintf(stderr, "Warning: %g events were removed in Component[286] channel_4_analyzer_1_array_crystal_array_4=Union_box()\n"
"         (negative time, miss next components, rounding errors, Nan, Inf).\n", mcAbsorbProp[286]);
    if (!mcNCounter[287]) fprintf(stderr, "Warning: No neutron could reach Component[287] channel_4_analyzer_1_array_crystal_array_5\n");
    if (mcAbsorbProp[287]) fprintf(stderr, "Warning: %g events were removed in Component[287] channel_4_analyzer_1_array_crystal_array_5=Union_box()\n"
"         (negative time, miss next components, rounding errors, Nan, Inf).\n", mcAbsorbProp[287]);
    if (!mcNCounter[288]) fprintf(stderr, "Warning: No neutron could reach Component[288] channel_4_analyzer_1_array_crystal_array_6\n");
    if (mcAbsorbProp[288]) fprintf(stderr, "Warning: %g events were removed in Component[288] channel_4_analyzer_1_array_crystal_array_6=Union_box()\n"
"         (negative time, miss next components, rounding errors, Nan, Inf).\n", mcAbsorbProp[288]);
    if (!mcNCounter[289]) fprintf(stderr, "Warning: No neutron could reach Component[289] channel_4_analyzer_1_array_crystal_array_7\n");
    if (mcAbsorbProp[289]) fprintf(stderr, "Warning: %g events were removed in Component[289] channel_4_analyzer_1_array_crystal_array_7=Union_box()\n"
"         (negative time, miss next components, rounding errors, Nan, Inf).\n", mcAbsorbProp[289]);
    if (!mcNCounter[290]) fprintf(stderr, "Warning: No neutron could reach Component[290] channel_4_analyzer_1_array_crystal_array_8\n");
    if (mcAbsorbProp[290]) fprintf(stderr, "Warning: %g events were removed in Component[290] channel_4_analyzer_1_array_crystal_array_8=Union_box()\n"
"         (negative time, miss next components, rounding errors, Nan, Inf).\n", mcAbsorbProp[290]);
    if (!mcNCounter[291]) fprintf(stderr, "Warning: No neutron could reach Component[291] channel_4_analyzer_2_center\n");
    if (mcAbsorbProp[291]) fprintf(stderr, "Warning: %g events were removed in Component[291] channel_4_analyzer_2_center=Arm()\n"
"         (negative time, miss next components, rounding errors, Nan, Inf).\n", mcAbsorbProp[291]);
    if (!mcNCounter[292]) fprintf(stderr, "Warning: No neutron could reach Component[292] channel_4_analyzer_2_rotated\n");
    if (mcAbsorbProp[292]) fprintf(stderr, "Warning: %g events were removed in Component[292] channel_4_analyzer_2_rotated=Arm()\n"
"         (negative time, miss next components, rounding errors, Nan, Inf).\n", mcAbsorbProp[292]);
    if (!mcNCounter[293]) fprintf(stderr, "Warning: No neutron could reach Component[293] channel_4_analyzer_2_array_crystal_array_0\n");
    if (mcAbsorbProp[293]) fprintf(stderr, "Warning: %g events were removed in Component[293] channel_4_analyzer_2_array_crystal_array_0=Union_box()\n"
"         (negative time, miss next components, rounding errors, Nan, Inf).\n", mcAbsorbProp[293]);
    if (!mcNCounter[294]) fprintf(stderr, "Warning: No neutron could reach Component[294] channel_4_analyzer_2_array_crystal_array_1\n");
    if (mcAbsorbProp[294]) fprintf(stderr, "Warning: %g events were removed in Component[294] channel_4_analyzer_2_array_crystal_array_1=Union_box()\n"
"         (negative time, miss next components, rounding errors, Nan, Inf).\n", mcAbsorbProp[294]);
    if (!mcNCounter[295]) fprintf(stderr, "Warning: No neutron could reach Component[295] channel_4_analyzer_2_array_crystal_array_2\n");
    if (mcAbsorbProp[295]) fprintf(stderr, "Warning: %g events were removed in Component[295] channel_4_analyzer_2_array_crystal_array_2=Union_box()\n"
"         (negative time, miss next components, rounding errors, Nan, Inf).\n", mcAbsorbProp[295]);
    if (!mcNCounter[296]) fprintf(stderr, "Warning: No neutron could reach Component[296] channel_4_analyzer_2_array_crystal_array_3\n");
    if (mcAbsorbProp[296]) fprintf(stderr, "Warning: %g events were removed in Component[296] channel_4_analyzer_2_array_crystal_array_3=Union_box()\n"
"         (negative time, miss next components, rounding errors, Nan, Inf).\n", mcAbsorbProp[296]);
    if (!mcNCounter[297]) fprintf(stderr, "Warning: No neutron could reach Component[297] channel_4_analyzer_2_array_crystal_array_4\n");
    if (mcAbsorbProp[297]) fprintf(stderr, "Warning: %g events were removed in Component[297] channel_4_analyzer_2_array_crystal_array_4=Union_box()\n"
"         (negative time, miss next components, rounding errors, Nan, Inf).\n", mcAbsorbProp[297]);
    if (!mcNCounter[298]) fprintf(stderr, "Warning: No neutron could reach Component[298] channel_4_analyzer_2_array_crystal_array_5\n");
    if (mcAbsorbProp[298]) fprintf(stderr, "Warning: %g events were removed in Component[298] channel_4_analyzer_2_array_crystal_array_5=Union_box()\n"
"         (negative time, miss next components, rounding errors, Nan, Inf).\n", mcAbsorbProp[298]);
    if (!mcNCounter[299]) fprintf(stderr, "Warning: No neutron could reach Component[299] channel_4_analyzer_2_array_crystal_array_6\n");
    if (mcAbsorbProp[299]) fprintf(stderr, "Warning: %g events were removed in Component[299] channel_4_analyzer_2_array_crystal_array_6=Union_box()\n"
"         (negative time, miss next components, rounding errors, Nan, Inf).\n", mcAbsorbProp[299]);
    if (!mcNCounter[300]) fprintf(stderr, "Warning: No neutron could reach Component[300] channel_4_analyzer_2_array_crystal_array_7\n");
    if (mcAbsorbProp[300]) fprintf(stderr, "Warning: %g events were removed in Component[300] channel_4_analyzer_2_array_crystal_array_7=Union_box()\n"
"         (negative time, miss next components, rounding errors, Nan, Inf).\n", mcAbsorbProp[300]);
    if (!mcNCounter[301]) fprintf(stderr, "Warning: No neutron could reach Component[301] channel_4_analyzer_2_array_crystal_array_8\n");
    if (mcAbsorbProp[301]) fprintf(stderr, "Warning: %g events were removed in Component[301] channel_4_analyzer_2_array_crystal_array_8=Union_box()\n"
"         (negative time, miss next components, rounding errors, Nan, Inf).\n", mcAbsorbProp[301]);
    if (!mcNCounter[302]) fprintf(stderr, "Warning: No neutron could reach Component[302] channel_4_cave2_cyl1\n");
    if (mcAbsorbProp[302]) fprintf(stderr, "Warning: %g events were removed in Component[302] channel_4_cave2_cyl1=Union_cylinder()\n"
"         (negative time, miss next components, rounding errors, Nan, Inf).\n", mcAbsorbProp[302]);
    if (!mcNCounter[303]) fprintf(stderr, "Warning: No neutron could reach Component[303] channel_4_cave2_box1\n");
    if (mcAbsorbProp[303]) fprintf(stderr, "Warning: %g events were removed in Component[303] channel_4_cave2_box1=Union_box()\n"
"         (negative time, miss next components, rounding errors, Nan, Inf).\n", mcAbsorbProp[303]);
    if (!mcNCounter[304]) fprintf(stderr, "Warning: No neutron could reach Component[304] channel_4_cave2_box2\n");
    if (mcAbsorbProp[304]) fprintf(stderr, "Warning: %g events were removed in Component[304] channel_4_cave2_box2=Union_box()\n"
"         (negative time, miss next components, rounding errors, Nan, Inf).\n", mcAbsorbProp[304]);
    if (!mcNCounter[305]) fprintf(stderr, "Warning: No neutron could reach Component[305] channel_4_cave2_box3\n");
    if (mcAbsorbProp[305]) fprintf(stderr, "Warning: %g events were removed in Component[305] channel_4_cave2_box3=Union_box()\n"
"         (negative time, miss next components, rounding errors, Nan, Inf).\n", mcAbsorbProp[305]);
    if (!mcNCounter[306]) fprintf(stderr, "Warning: No neutron could reach Component[306] inter_analyzer_colimator_center_4\n");
    if (mcAbsorbProp[306]) fprintf(stderr, "Warning: %g events were removed in Component[306] inter_analyzer_colimator_center_4=Arm()\n"
"         (negative time, miss next components, rounding errors, Nan, Inf).\n", mcAbsorbProp[306]);
    if (!mcNCounter[307]) fprintf(stderr, "Warning: No neutron could reach Component[307] inter_analyzer_colimator_4_blade_0\n");
    if (mcAbsorbProp[307]) fprintf(stderr, "Warning: %g events were removed in Component[307] inter_analyzer_colimator_4_blade_0=Union_box()\n"
"         (negative time, miss next components, rounding errors, Nan, Inf).\n", mcAbsorbProp[307]);
    if (!mcNCounter[308]) fprintf(stderr, "Warning: No neutron could reach Component[308] inter_analyzer_colimator_4_blade_1\n");
    if (mcAbsorbProp[308]) fprintf(stderr, "Warning: %g events were removed in Component[308] inter_analyzer_colimator_4_blade_1=Union_box()\n"
"         (negative time, miss next components, rounding errors, Nan, Inf).\n", mcAbsorbProp[308]);
    if (!mcNCounter[309]) fprintf(stderr, "Warning: No neutron could reach Component[309] inter_analyzer_colimator_4_blade_2\n");
    if (mcAbsorbProp[309]) fprintf(stderr, "Warning: %g events were removed in Component[309] inter_analyzer_colimator_4_blade_2=Union_box()\n"
"         (negative time, miss next components, rounding errors, Nan, Inf).\n", mcAbsorbProp[309]);
    if (!mcNCounter[310]) fprintf(stderr, "Warning: No neutron could reach Component[310] inter_analyzer_colimator_4_blade_3\n");
    if (mcAbsorbProp[310]) fprintf(stderr, "Warning: %g events were removed in Component[310] inter_analyzer_colimator_4_blade_3=Union_box()\n"
"         (negative time, miss next components, rounding errors, Nan, Inf).\n", mcAbsorbProp[310]);
    if (!mcNCounter[311]) fprintf(stderr, "Warning: No neutron could reach Component[311] inter_analyzer_colimator_4_blade_4\n");
    if (mcAbsorbProp[311]) fprintf(stderr, "Warning: %g events were removed in Component[311] inter_analyzer_colimator_4_blade_4=Union_box()\n"
"         (negative time, miss next components, rounding errors, Nan, Inf).\n", mcAbsorbProp[311]);
    if (!mcNCounter[312]) fprintf(stderr, "Warning: No neutron could reach Component[312] diffraction_detector_4_exit_volume\n");
    if (mcAbsorbProp[312]) fprintf(stderr, "Warning: %g events were removed in Component[312] diffraction_detector_4_exit_volume=Union_box()\n"
"         (negative time, miss next components, rounding errors, Nan, Inf).\n", mcAbsorbProp[312]);
    if (!mcNCounter[313]) fprintf(stderr, "Warning: No neutron could reach Component[313] spec_detector_4_exit_volume\n");
    if (mcAbsorbProp[313]) fprintf(stderr, "Warning: %g events were removed in Component[313] spec_detector_4_exit_volume=Union_box()\n"
"         (negative time, miss next components, rounding errors, Nan, Inf).\n", mcAbsorbProp[313]);
    if (!mcNCounter[314]) fprintf(stderr, "Warning: No neutron could reach Component[314] channel_5_cave1_box1\n");
    if (mcAbsorbProp[314]) fprintf(stderr, "Warning: %g events were removed in Component[314] channel_5_cave1_box1=Union_box()\n"
"         (negative time, miss next components, rounding errors, Nan, Inf).\n", mcAbsorbProp[314]);
    if (!mcNCounter[315]) fprintf(stderr, "Warning: No neutron could reach Component[315] channel_5_cave1_box2\n");
    if (mcAbsorbProp[315]) fprintf(stderr, "Warning: %g events were removed in Component[315] channel_5_cave1_box2=Union_box()\n"
"         (negative time, miss next components, rounding errors, Nan, Inf).\n", mcAbsorbProp[315]);
    if (!mcNCounter[316]) fprintf(stderr, "Warning: No neutron could reach Component[316] channel_5_cave1_box3\n");
    if (mcAbsorbProp[316]) fprintf(stderr, "Warning: %g events were removed in Component[316] channel_5_cave1_box3=Union_box()\n"
"         (negative time, miss next components, rounding errors, Nan, Inf).\n", mcAbsorbProp[316]);
    if (!mcNCounter[317]) fprintf(stderr, "Warning: No neutron could reach Component[317] channel_5_cave1_cyl1\n");
    if (mcAbsorbProp[317]) fprintf(stderr, "Warning: %g events were removed in Component[317] channel_5_cave1_cyl1=Union_cylinder()\n"
"         (negative time, miss next components, rounding errors, Nan, Inf).\n", mcAbsorbProp[317]);
    if (!mcNCounter[318]) fprintf(stderr, "Warning: No neutron could reach Component[318] channel_5_analyzer_1_center\n");
    if (mcAbsorbProp[318]) fprintf(stderr, "Warning: %g events were removed in Component[318] channel_5_analyzer_1_center=Arm()\n"
"         (negative time, miss next components, rounding errors, Nan, Inf).\n", mcAbsorbProp[318]);
    if (!mcNCounter[319]) fprintf(stderr, "Warning: No neutron could reach Component[319] channel_5_analyzer_1_rotated\n");
    if (mcAbsorbProp[319]) fprintf(stderr, "Warning: %g events were removed in Component[319] channel_5_analyzer_1_rotated=Arm()\n"
"         (negative time, miss next components, rounding errors, Nan, Inf).\n", mcAbsorbProp[319]);
    if (!mcNCounter[320]) fprintf(stderr, "Warning: No neutron could reach Component[320] channel_5_analyzer_1_array_crystal_array_0\n");
    if (mcAbsorbProp[320]) fprintf(stderr, "Warning: %g events were removed in Component[320] channel_5_analyzer_1_array_crystal_array_0=Union_box()\n"
"         (negative time, miss next components, rounding errors, Nan, Inf).\n", mcAbsorbProp[320]);
    if (!mcNCounter[321]) fprintf(stderr, "Warning: No neutron could reach Component[321] channel_5_analyzer_1_array_crystal_array_1\n");
    if (mcAbsorbProp[321]) fprintf(stderr, "Warning: %g events were removed in Component[321] channel_5_analyzer_1_array_crystal_array_1=Union_box()\n"
"         (negative time, miss next components, rounding errors, Nan, Inf).\n", mcAbsorbProp[321]);
    if (!mcNCounter[322]) fprintf(stderr, "Warning: No neutron could reach Component[322] channel_5_analyzer_1_array_crystal_array_2\n");
    if (mcAbsorbProp[322]) fprintf(stderr, "Warning: %g events were removed in Component[322] channel_5_analyzer_1_array_crystal_array_2=Union_box()\n"
"         (negative time, miss next components, rounding errors, Nan, Inf).\n", mcAbsorbProp[322]);
    if (!mcNCounter[323]) fprintf(stderr, "Warning: No neutron could reach Component[323] channel_5_analyzer_1_array_crystal_array_3\n");
    if (mcAbsorbProp[323]) fprintf(stderr, "Warning: %g events were removed in Component[323] channel_5_analyzer_1_array_crystal_array_3=Union_box()\n"
"         (negative time, miss next components, rounding errors, Nan, Inf).\n", mcAbsorbProp[323]);
    if (!mcNCounter[324]) fprintf(stderr, "Warning: No neutron could reach Component[324] channel_5_analyzer_1_array_crystal_array_4\n");
    if (mcAbsorbProp[324]) fprintf(stderr, "Warning: %g events were removed in Component[324] channel_5_analyzer_1_array_crystal_array_4=Union_box()\n"
"         (negative time, miss next components, rounding errors, Nan, Inf).\n", mcAbsorbProp[324]);
    if (!mcNCounter[325]) fprintf(stderr, "Warning: No neutron could reach Component[325] channel_5_analyzer_1_array_crystal_array_5\n");
    if (mcAbsorbProp[325]) fprintf(stderr, "Warning: %g events were removed in Component[325] channel_5_analyzer_1_array_crystal_array_5=Union_box()\n"
"         (negative time, miss next components, rounding errors, Nan, Inf).\n", mcAbsorbProp[325]);
    if (!mcNCounter[326]) fprintf(stderr, "Warning: No neutron could reach Component[326] channel_5_analyzer_1_array_crystal_array_6\n");
    if (mcAbsorbProp[326]) fprintf(stderr, "Warning: %g events were removed in Component[326] channel_5_analyzer_1_array_crystal_array_6=Union_box()\n"
"         (negative time, miss next components, rounding errors, Nan, Inf).\n", mcAbsorbProp[326]);
    if (!mcNCounter[327]) fprintf(stderr, "Warning: No neutron could reach Component[327] channel_5_analyzer_1_array_crystal_array_7\n");
    if (mcAbsorbProp[327]) fprintf(stderr, "Warning: %g events were removed in Component[327] channel_5_analyzer_1_array_crystal_array_7=Union_box()\n"
"         (negative time, miss next components, rounding errors, Nan, Inf).\n", mcAbsorbProp[327]);
    if (!mcNCounter[328]) fprintf(stderr, "Warning: No neutron could reach Component[328] channel_5_analyzer_1_array_crystal_array_8\n");
    if (mcAbsorbProp[328]) fprintf(stderr, "Warning: %g events were removed in Component[328] channel_5_analyzer_1_array_crystal_array_8=Union_box()\n"
"         (negative time, miss next components, rounding errors, Nan, Inf).\n", mcAbsorbProp[328]);
    if (!mcNCounter[329]) fprintf(stderr, "Warning: No neutron could reach Component[329] channel_5_analyzer_2_center\n");
    if (mcAbsorbProp[329]) fprintf(stderr, "Warning: %g events were removed in Component[329] channel_5_analyzer_2_center=Arm()\n"
"         (negative time, miss next components, rounding errors, Nan, Inf).\n", mcAbsorbProp[329]);
    if (!mcNCounter[330]) fprintf(stderr, "Warning: No neutron could reach Component[330] channel_5_analyzer_2_rotated\n");
    if (mcAbsorbProp[330]) fprintf(stderr, "Warning: %g events were removed in Component[330] channel_5_analyzer_2_rotated=Arm()\n"
"         (negative time, miss next components, rounding errors, Nan, Inf).\n", mcAbsorbProp[330]);
    if (!mcNCounter[331]) fprintf(stderr, "Warning: No neutron could reach Component[331] channel_5_analyzer_2_array_crystal_array_0\n");
    if (mcAbsorbProp[331]) fprintf(stderr, "Warning: %g events were removed in Component[331] channel_5_analyzer_2_array_crystal_array_0=Union_box()\n"
"         (negative time, miss next components, rounding errors, Nan, Inf).\n", mcAbsorbProp[331]);
    if (!mcNCounter[332]) fprintf(stderr, "Warning: No neutron could reach Component[332] channel_5_analyzer_2_array_crystal_array_1\n");
    if (mcAbsorbProp[332]) fprintf(stderr, "Warning: %g events were removed in Component[332] channel_5_analyzer_2_array_crystal_array_1=Union_box()\n"
"         (negative time, miss next components, rounding errors, Nan, Inf).\n", mcAbsorbProp[332]);
    if (!mcNCounter[333]) fprintf(stderr, "Warning: No neutron could reach Component[333] channel_5_analyzer_2_array_crystal_array_2\n");
    if (mcAbsorbProp[333]) fprintf(stderr, "Warning: %g events were removed in Component[333] channel_5_analyzer_2_array_crystal_array_2=Union_box()\n"
"         (negative time, miss next components, rounding errors, Nan, Inf).\n", mcAbsorbProp[333]);
    if (!mcNCounter[334]) fprintf(stderr, "Warning: No neutron could reach Component[334] channel_5_analyzer_2_array_crystal_array_3\n");
    if (mcAbsorbProp[334]) fprintf(stderr, "Warning: %g events were removed in Component[334] channel_5_analyzer_2_array_crystal_array_3=Union_box()\n"
"         (negative time, miss next components, rounding errors, Nan, Inf).\n", mcAbsorbProp[334]);
    if (!mcNCounter[335]) fprintf(stderr, "Warning: No neutron could reach Component[335] channel_5_analyzer_2_array_crystal_array_4\n");
    if (mcAbsorbProp[335]) fprintf(stderr, "Warning: %g events were removed in Component[335] channel_5_analyzer_2_array_crystal_array_4=Union_box()\n"
"         (negative time, miss next components, rounding errors, Nan, Inf).\n", mcAbsorbProp[335]);
    if (!mcNCounter[336]) fprintf(stderr, "Warning: No neutron could reach Component[336] channel_5_analyzer_2_array_crystal_array_5\n");
    if (mcAbsorbProp[336]) fprintf(stderr, "Warning: %g events were removed in Component[336] channel_5_analyzer_2_array_crystal_array_5=Union_box()\n"
"         (negative time, miss next components, rounding errors, Nan, Inf).\n", mcAbsorbProp[336]);
    if (!mcNCounter[337]) fprintf(stderr, "Warning: No neutron could reach Component[337] channel_5_analyzer_2_array_crystal_array_6\n");
    if (mcAbsorbProp[337]) fprintf(stderr, "Warning: %g events were removed in Component[337] channel_5_analyzer_2_array_crystal_array_6=Union_box()\n"
"         (negative time, miss next components, rounding errors, Nan, Inf).\n", mcAbsorbProp[337]);
    if (!mcNCounter[338]) fprintf(stderr, "Warning: No neutron could reach Component[338] channel_5_analyzer_2_array_crystal_array_7\n");
    if (mcAbsorbProp[338]) fprintf(stderr, "Warning: %g events were removed in Component[338] channel_5_analyzer_2_array_crystal_array_7=Union_box()\n"
"         (negative time, miss next components, rounding errors, Nan, Inf).\n", mcAbsorbProp[338]);
    if (!mcNCounter[339]) fprintf(stderr, "Warning: No neutron could reach Component[339] channel_5_analyzer_2_array_crystal_array_8\n");
    if (mcAbsorbProp[339]) fprintf(stderr, "Warning: %g events were removed in Component[339] channel_5_analyzer_2_array_crystal_array_8=Union_box()\n"
"         (negative time, miss next components, rounding errors, Nan, Inf).\n", mcAbsorbProp[339]);
    if (!mcNCounter[340]) fprintf(stderr, "Warning: No neutron could reach Component[340] channel_5_cave2_cyl1\n");
    if (mcAbsorbProp[340]) fprintf(stderr, "Warning: %g events were removed in Component[340] channel_5_cave2_cyl1=Union_cylinder()\n"
"         (negative time, miss next components, rounding errors, Nan, Inf).\n", mcAbsorbProp[340]);
    if (!mcNCounter[341]) fprintf(stderr, "Warning: No neutron could reach Component[341] channel_5_cave2_box1\n");
    if (mcAbsorbProp[341]) fprintf(stderr, "Warning: %g events were removed in Component[341] channel_5_cave2_box1=Union_box()\n"
"         (negative time, miss next components, rounding errors, Nan, Inf).\n", mcAbsorbProp[341]);
    if (!mcNCounter[342]) fprintf(stderr, "Warning: No neutron could reach Component[342] channel_5_cave2_box2\n");
    if (mcAbsorbProp[342]) fprintf(stderr, "Warning: %g events were removed in Component[342] channel_5_cave2_box2=Union_box()\n"
"         (negative time, miss next components, rounding errors, Nan, Inf).\n", mcAbsorbProp[342]);
    if (!mcNCounter[343]) fprintf(stderr, "Warning: No neutron could reach Component[343] channel_5_cave2_box3\n");
    if (mcAbsorbProp[343]) fprintf(stderr, "Warning: %g events were removed in Component[343] channel_5_cave2_box3=Union_box()\n"
"         (negative time, miss next components, rounding errors, Nan, Inf).\n", mcAbsorbProp[343]);
    if (!mcNCounter[344]) fprintf(stderr, "Warning: No neutron could reach Component[344] inter_analyzer_colimator_center_5\n");
    if (mcAbsorbProp[344]) fprintf(stderr, "Warning: %g events were removed in Component[344] inter_analyzer_colimator_center_5=Arm()\n"
"         (negative time, miss next components, rounding errors, Nan, Inf).\n", mcAbsorbProp[344]);
    if (!mcNCounter[345]) fprintf(stderr, "Warning: No neutron could reach Component[345] inter_analyzer_colimator_5_blade_0\n");
    if (mcAbsorbProp[345]) fprintf(stderr, "Warning: %g events were removed in Component[345] inter_analyzer_colimator_5_blade_0=Union_box()\n"
"         (negative time, miss next components, rounding errors, Nan, Inf).\n", mcAbsorbProp[345]);
    if (!mcNCounter[346]) fprintf(stderr, "Warning: No neutron could reach Component[346] inter_analyzer_colimator_5_blade_1\n");
    if (mcAbsorbProp[346]) fprintf(stderr, "Warning: %g events were removed in Component[346] inter_analyzer_colimator_5_blade_1=Union_box()\n"
"         (negative time, miss next components, rounding errors, Nan, Inf).\n", mcAbsorbProp[346]);
    if (!mcNCounter[347]) fprintf(stderr, "Warning: No neutron could reach Component[347] inter_analyzer_colimator_5_blade_2\n");
    if (mcAbsorbProp[347]) fprintf(stderr, "Warning: %g events were removed in Component[347] inter_analyzer_colimator_5_blade_2=Union_box()\n"
"         (negative time, miss next components, rounding errors, Nan, Inf).\n", mcAbsorbProp[347]);
    if (!mcNCounter[348]) fprintf(stderr, "Warning: No neutron could reach Component[348] inter_analyzer_colimator_5_blade_3\n");
    if (mcAbsorbProp[348]) fprintf(stderr, "Warning: %g events were removed in Component[348] inter_analyzer_colimator_5_blade_3=Union_box()\n"
"         (negative time, miss next components, rounding errors, Nan, Inf).\n", mcAbsorbProp[348]);
    if (!mcNCounter[349]) fprintf(stderr, "Warning: No neutron could reach Component[349] inter_analyzer_colimator_5_blade_4\n");
    if (mcAbsorbProp[349]) fprintf(stderr, "Warning: %g events were removed in Component[349] inter_analyzer_colimator_5_blade_4=Union_box()\n"
"         (negative time, miss next components, rounding errors, Nan, Inf).\n", mcAbsorbProp[349]);
    if (!mcNCounter[350]) fprintf(stderr, "Warning: No neutron could reach Component[350] diffraction_detector_5_exit_volume\n");
    if (mcAbsorbProp[350]) fprintf(stderr, "Warning: %g events were removed in Component[350] diffraction_detector_5_exit_volume=Union_box()\n"
"         (negative time, miss next components, rounding errors, Nan, Inf).\n", mcAbsorbProp[350]);
    if (!mcNCounter[351]) fprintf(stderr, "Warning: No neutron could reach Component[351] spec_detector_5_exit_volume\n");
    if (mcAbsorbProp[351]) fprintf(stderr, "Warning: %g events were removed in Component[351] spec_detector_5_exit_volume=Union_box()\n"
"         (negative time, miss next components, rounding errors, Nan, Inf).\n", mcAbsorbProp[351]);
    if (!mcNCounter[352]) fprintf(stderr, "Warning: No neutron could reach Component[352] channel_6_cave1_box1\n");
    if (mcAbsorbProp[352]) fprintf(stderr, "Warning: %g events were removed in Component[352] channel_6_cave1_box1=Union_box()\n"
"         (negative time, miss next components, rounding errors, Nan, Inf).\n", mcAbsorbProp[352]);
    if (!mcNCounter[353]) fprintf(stderr, "Warning: No neutron could reach Component[353] channel_6_cave1_box2\n");
    if (mcAbsorbProp[353]) fprintf(stderr, "Warning: %g events were removed in Component[353] channel_6_cave1_box2=Union_box()\n"
"         (negative time, miss next components, rounding errors, Nan, Inf).\n", mcAbsorbProp[353]);
    if (!mcNCounter[354]) fprintf(stderr, "Warning: No neutron could reach Component[354] channel_6_cave1_box3\n");
    if (mcAbsorbProp[354]) fprintf(stderr, "Warning: %g events were removed in Component[354] channel_6_cave1_box3=Union_box()\n"
"         (negative time, miss next components, rounding errors, Nan, Inf).\n", mcAbsorbProp[354]);
    if (!mcNCounter[355]) fprintf(stderr, "Warning: No neutron could reach Component[355] channel_6_cave1_cyl1\n");
    if (mcAbsorbProp[355]) fprintf(stderr, "Warning: %g events were removed in Component[355] channel_6_cave1_cyl1=Union_cylinder()\n"
"         (negative time, miss next components, rounding errors, Nan, Inf).\n", mcAbsorbProp[355]);
    if (!mcNCounter[356]) fprintf(stderr, "Warning: No neutron could reach Component[356] channel_6_analyzer_1_center\n");
    if (mcAbsorbProp[356]) fprintf(stderr, "Warning: %g events were removed in Component[356] channel_6_analyzer_1_center=Arm()\n"
"         (negative time, miss next components, rounding errors, Nan, Inf).\n", mcAbsorbProp[356]);
    if (!mcNCounter[357]) fprintf(stderr, "Warning: No neutron could reach Component[357] channel_6_analyzer_1_rotated\n");
    if (mcAbsorbProp[357]) fprintf(stderr, "Warning: %g events were removed in Component[357] channel_6_analyzer_1_rotated=Arm()\n"
"         (negative time, miss next components, rounding errors, Nan, Inf).\n", mcAbsorbProp[357]);
    if (!mcNCounter[358]) fprintf(stderr, "Warning: No neutron could reach Component[358] channel_6_analyzer_1_array_crystal_array_0\n");
    if (mcAbsorbProp[358]) fprintf(stderr, "Warning: %g events were removed in Component[358] channel_6_analyzer_1_array_crystal_array_0=Union_box()\n"
"         (negative time, miss next components, rounding errors, Nan, Inf).\n", mcAbsorbProp[358]);
    if (!mcNCounter[359]) fprintf(stderr, "Warning: No neutron could reach Component[359] channel_6_analyzer_1_array_crystal_array_1\n");
    if (mcAbsorbProp[359]) fprintf(stderr, "Warning: %g events were removed in Component[359] channel_6_analyzer_1_array_crystal_array_1=Union_box()\n"
"         (negative time, miss next components, rounding errors, Nan, Inf).\n", mcAbsorbProp[359]);
    if (!mcNCounter[360]) fprintf(stderr, "Warning: No neutron could reach Component[360] channel_6_analyzer_1_array_crystal_array_2\n");
    if (mcAbsorbProp[360]) fprintf(stderr, "Warning: %g events were removed in Component[360] channel_6_analyzer_1_array_crystal_array_2=Union_box()\n"
"         (negative time, miss next components, rounding errors, Nan, Inf).\n", mcAbsorbProp[360]);
    if (!mcNCounter[361]) fprintf(stderr, "Warning: No neutron could reach Component[361] channel_6_analyzer_1_array_crystal_array_3\n");
    if (mcAbsorbProp[361]) fprintf(stderr, "Warning: %g events were removed in Component[361] channel_6_analyzer_1_array_crystal_array_3=Union_box()\n"
"         (negative time, miss next components, rounding errors, Nan, Inf).\n", mcAbsorbProp[361]);
    if (!mcNCounter[362]) fprintf(stderr, "Warning: No neutron could reach Component[362] channel_6_analyzer_1_array_crystal_array_4\n");
    if (mcAbsorbProp[362]) fprintf(stderr, "Warning: %g events were removed in Component[362] channel_6_analyzer_1_array_crystal_array_4=Union_box()\n"
"         (negative time, miss next components, rounding errors, Nan, Inf).\n", mcAbsorbProp[362]);
    if (!mcNCounter[363]) fprintf(stderr, "Warning: No neutron could reach Component[363] channel_6_analyzer_1_array_crystal_array_5\n");
    if (mcAbsorbProp[363]) fprintf(stderr, "Warning: %g events were removed in Component[363] channel_6_analyzer_1_array_crystal_array_5=Union_box()\n"
"         (negative time, miss next components, rounding errors, Nan, Inf).\n", mcAbsorbProp[363]);
    if (!mcNCounter[364]) fprintf(stderr, "Warning: No neutron could reach Component[364] channel_6_analyzer_1_array_crystal_array_6\n");
    if (mcAbsorbProp[364]) fprintf(stderr, "Warning: %g events were removed in Component[364] channel_6_analyzer_1_array_crystal_array_6=Union_box()\n"
"         (negative time, miss next components, rounding errors, Nan, Inf).\n", mcAbsorbProp[364]);
    if (!mcNCounter[365]) fprintf(stderr, "Warning: No neutron could reach Component[365] channel_6_analyzer_1_array_crystal_array_7\n");
    if (mcAbsorbProp[365]) fprintf(stderr, "Warning: %g events were removed in Component[365] channel_6_analyzer_1_array_crystal_array_7=Union_box()\n"
"         (negative time, miss next components, rounding errors, Nan, Inf).\n", mcAbsorbProp[365]);
    if (!mcNCounter[366]) fprintf(stderr, "Warning: No neutron could reach Component[366] channel_6_analyzer_1_array_crystal_array_8\n");
    if (mcAbsorbProp[366]) fprintf(stderr, "Warning: %g events were removed in Component[366] channel_6_analyzer_1_array_crystal_array_8=Union_box()\n"
"         (negative time, miss next components, rounding errors, Nan, Inf).\n", mcAbsorbProp[366]);
    if (!mcNCounter[367]) fprintf(stderr, "Warning: No neutron could reach Component[367] channel_6_analyzer_2_center\n");
    if (mcAbsorbProp[367]) fprintf(stderr, "Warning: %g events were removed in Component[367] channel_6_analyzer_2_center=Arm()\n"
"         (negative time, miss next components, rounding errors, Nan, Inf).\n", mcAbsorbProp[367]);
    if (!mcNCounter[368]) fprintf(stderr, "Warning: No neutron could reach Component[368] channel_6_analyzer_2_rotated\n");
    if (mcAbsorbProp[368]) fprintf(stderr, "Warning: %g events were removed in Component[368] channel_6_analyzer_2_rotated=Arm()\n"
"         (negative time, miss next components, rounding errors, Nan, Inf).\n", mcAbsorbProp[368]);
    if (!mcNCounter[369]) fprintf(stderr, "Warning: No neutron could reach Component[369] channel_6_analyzer_2_array_crystal_array_0\n");
    if (mcAbsorbProp[369]) fprintf(stderr, "Warning: %g events were removed in Component[369] channel_6_analyzer_2_array_crystal_array_0=Union_box()\n"
"         (negative time, miss next components, rounding errors, Nan, Inf).\n", mcAbsorbProp[369]);
    if (!mcNCounter[370]) fprintf(stderr, "Warning: No neutron could reach Component[370] channel_6_analyzer_2_array_crystal_array_1\n");
    if (mcAbsorbProp[370]) fprintf(stderr, "Warning: %g events were removed in Component[370] channel_6_analyzer_2_array_crystal_array_1=Union_box()\n"
"         (negative time, miss next components, rounding errors, Nan, Inf).\n", mcAbsorbProp[370]);
    if (!mcNCounter[371]) fprintf(stderr, "Warning: No neutron could reach Component[371] channel_6_analyzer_2_array_crystal_array_2\n");
    if (mcAbsorbProp[371]) fprintf(stderr, "Warning: %g events were removed in Component[371] channel_6_analyzer_2_array_crystal_array_2=Union_box()\n"
"         (negative time, miss next components, rounding errors, Nan, Inf).\n", mcAbsorbProp[371]);
    if (!mcNCounter[372]) fprintf(stderr, "Warning: No neutron could reach Component[372] channel_6_analyzer_2_array_crystal_array_3\n");
    if (mcAbsorbProp[372]) fprintf(stderr, "Warning: %g events were removed in Component[372] channel_6_analyzer_2_array_crystal_array_3=Union_box()\n"
"         (negative time, miss next components, rounding errors, Nan, Inf).\n", mcAbsorbProp[372]);
    if (!mcNCounter[373]) fprintf(stderr, "Warning: No neutron could reach Component[373] channel_6_analyzer_2_array_crystal_array_4\n");
    if (mcAbsorbProp[373]) fprintf(stderr, "Warning: %g events were removed in Component[373] channel_6_analyzer_2_array_crystal_array_4=Union_box()\n"
"         (negative time, miss next components, rounding errors, Nan, Inf).\n", mcAbsorbProp[373]);
    if (!mcNCounter[374]) fprintf(stderr, "Warning: No neutron could reach Component[374] channel_6_analyzer_2_array_crystal_array_5\n");
    if (mcAbsorbProp[374]) fprintf(stderr, "Warning: %g events were removed in Component[374] channel_6_analyzer_2_array_crystal_array_5=Union_box()\n"
"         (negative time, miss next components, rounding errors, Nan, Inf).\n", mcAbsorbProp[374]);
    if (!mcNCounter[375]) fprintf(stderr, "Warning: No neutron could reach Component[375] channel_6_analyzer_2_array_crystal_array_6\n");
    if (mcAbsorbProp[375]) fprintf(stderr, "Warning: %g events were removed in Component[375] channel_6_analyzer_2_array_crystal_array_6=Union_box()\n"
"         (negative time, miss next components, rounding errors, Nan, Inf).\n", mcAbsorbProp[375]);
    if (!mcNCounter[376]) fprintf(stderr, "Warning: No neutron could reach Component[376] channel_6_analyzer_2_array_crystal_array_7\n");
    if (mcAbsorbProp[376]) fprintf(stderr, "Warning: %g events were removed in Component[376] channel_6_analyzer_2_array_crystal_array_7=Union_box()\n"
"         (negative time, miss next components, rounding errors, Nan, Inf).\n", mcAbsorbProp[376]);
    if (!mcNCounter[377]) fprintf(stderr, "Warning: No neutron could reach Component[377] channel_6_analyzer_2_array_crystal_array_8\n");
    if (mcAbsorbProp[377]) fprintf(stderr, "Warning: %g events were removed in Component[377] channel_6_analyzer_2_array_crystal_array_8=Union_box()\n"
"         (negative time, miss next components, rounding errors, Nan, Inf).\n", mcAbsorbProp[377]);
    if (!mcNCounter[378]) fprintf(stderr, "Warning: No neutron could reach Component[378] channel_6_cave2_cyl1\n");
    if (mcAbsorbProp[378]) fprintf(stderr, "Warning: %g events were removed in Component[378] channel_6_cave2_cyl1=Union_cylinder()\n"
"         (negative time, miss next components, rounding errors, Nan, Inf).\n", mcAbsorbProp[378]);
    if (!mcNCounter[379]) fprintf(stderr, "Warning: No neutron could reach Component[379] channel_6_cave2_box1\n");
    if (mcAbsorbProp[379]) fprintf(stderr, "Warning: %g events were removed in Component[379] channel_6_cave2_box1=Union_box()\n"
"         (negative time, miss next components, rounding errors, Nan, Inf).\n", mcAbsorbProp[379]);
    if (!mcNCounter[380]) fprintf(stderr, "Warning: No neutron could reach Component[380] channel_6_cave2_box2\n");
    if (mcAbsorbProp[380]) fprintf(stderr, "Warning: %g events were removed in Component[380] channel_6_cave2_box2=Union_box()\n"
"         (negative time, miss next components, rounding errors, Nan, Inf).\n", mcAbsorbProp[380]);
    if (!mcNCounter[381]) fprintf(stderr, "Warning: No neutron could reach Component[381] channel_6_cave2_box3\n");
    if (mcAbsorbProp[381]) fprintf(stderr, "Warning: %g events were removed in Component[381] channel_6_cave2_box3=Union_box()\n"
"         (negative time, miss next components, rounding errors, Nan, Inf).\n", mcAbsorbProp[381]);
    if (!mcNCounter[382]) fprintf(stderr, "Warning: No neutron could reach Component[382] inter_analyzer_colimator_center_6\n");
    if (mcAbsorbProp[382]) fprintf(stderr, "Warning: %g events were removed in Component[382] inter_analyzer_colimator_center_6=Arm()\n"
"         (negative time, miss next components, rounding errors, Nan, Inf).\n", mcAbsorbProp[382]);
    if (!mcNCounter[383]) fprintf(stderr, "Warning: No neutron could reach Component[383] inter_analyzer_colimator_6_blade_0\n");
    if (mcAbsorbProp[383]) fprintf(stderr, "Warning: %g events were removed in Component[383] inter_analyzer_colimator_6_blade_0=Union_box()\n"
"         (negative time, miss next components, rounding errors, Nan, Inf).\n", mcAbsorbProp[383]);
    if (!mcNCounter[384]) fprintf(stderr, "Warning: No neutron could reach Component[384] inter_analyzer_colimator_6_blade_1\n");
    if (mcAbsorbProp[384]) fprintf(stderr, "Warning: %g events were removed in Component[384] inter_analyzer_colimator_6_blade_1=Union_box()\n"
"         (negative time, miss next components, rounding errors, Nan, Inf).\n", mcAbsorbProp[384]);
    if (!mcNCounter[385]) fprintf(stderr, "Warning: No neutron could reach Component[385] inter_analyzer_colimator_6_blade_2\n");
    if (mcAbsorbProp[385]) fprintf(stderr, "Warning: %g events were removed in Component[385] inter_analyzer_colimator_6_blade_2=Union_box()\n"
"         (negative time, miss next components, rounding errors, Nan, Inf).\n", mcAbsorbProp[385]);
    if (!mcNCounter[386]) fprintf(stderr, "Warning: No neutron could reach Component[386] inter_analyzer_colimator_6_blade_3\n");
    if (mcAbsorbProp[386]) fprintf(stderr, "Warning: %g events were removed in Component[386] inter_analyzer_colimator_6_blade_3=Union_box()\n"
"         (negative time, miss next components, rounding errors, Nan, Inf).\n", mcAbsorbProp[386]);
    if (!mcNCounter[387]) fprintf(stderr, "Warning: No neutron could reach Component[387] inter_analyzer_colimator_6_blade_4\n");
    if (mcAbsorbProp[387]) fprintf(stderr, "Warning: %g events were removed in Component[387] inter_analyzer_colimator_6_blade_4=Union_box()\n"
"         (negative time, miss next components, rounding errors, Nan, Inf).\n", mcAbsorbProp[387]);
    if (!mcNCounter[388]) fprintf(stderr, "Warning: No neutron could reach Component[388] diffraction_detector_6_exit_volume\n");
    if (mcAbsorbProp[388]) fprintf(stderr, "Warning: %g events were removed in Component[388] diffraction_detector_6_exit_volume=Union_box()\n"
"         (negative time, miss next components, rounding errors, Nan, Inf).\n", mcAbsorbProp[388]);
    if (!mcNCounter[389]) fprintf(stderr, "Warning: No neutron could reach Component[389] spec_detector_6_exit_volume\n");
    if (mcAbsorbProp[389]) fprintf(stderr, "Warning: %g events were removed in Component[389] spec_detector_6_exit_volume=Union_box()\n"
"         (negative time, miss next components, rounding errors, Nan, Inf).\n", mcAbsorbProp[389]);
    if (!mcNCounter[390]) fprintf(stderr, "Warning: No neutron could reach Component[390] channel_7_cave1_box1\n");
    if (mcAbsorbProp[390]) fprintf(stderr, "Warning: %g events were removed in Component[390] channel_7_cave1_box1=Union_box()\n"
"         (negative time, miss next components, rounding errors, Nan, Inf).\n", mcAbsorbProp[390]);
    if (!mcNCounter[391]) fprintf(stderr, "Warning: No neutron could reach Component[391] channel_7_cave1_box2\n");
    if (mcAbsorbProp[391]) fprintf(stderr, "Warning: %g events were removed in Component[391] channel_7_cave1_box2=Union_box()\n"
"         (negative time, miss next components, rounding errors, Nan, Inf).\n", mcAbsorbProp[391]);
    if (!mcNCounter[392]) fprintf(stderr, "Warning: No neutron could reach Component[392] channel_7_cave1_box3\n");
    if (mcAbsorbProp[392]) fprintf(stderr, "Warning: %g events were removed in Component[392] channel_7_cave1_box3=Union_box()\n"
"         (negative time, miss next components, rounding errors, Nan, Inf).\n", mcAbsorbProp[392]);
    if (!mcNCounter[393]) fprintf(stderr, "Warning: No neutron could reach Component[393] channel_7_cave1_cyl1\n");
    if (mcAbsorbProp[393]) fprintf(stderr, "Warning: %g events were removed in Component[393] channel_7_cave1_cyl1=Union_cylinder()\n"
"         (negative time, miss next components, rounding errors, Nan, Inf).\n", mcAbsorbProp[393]);
    if (!mcNCounter[394]) fprintf(stderr, "Warning: No neutron could reach Component[394] channel_7_analyzer_1_center\n");
    if (mcAbsorbProp[394]) fprintf(stderr, "Warning: %g events were removed in Component[394] channel_7_analyzer_1_center=Arm()\n"
"         (negative time, miss next components, rounding errors, Nan, Inf).\n", mcAbsorbProp[394]);
    if (!mcNCounter[395]) fprintf(stderr, "Warning: No neutron could reach Component[395] channel_7_analyzer_1_rotated\n");
    if (mcAbsorbProp[395]) fprintf(stderr, "Warning: %g events were removed in Component[395] channel_7_analyzer_1_rotated=Arm()\n"
"         (negative time, miss next components, rounding errors, Nan, Inf).\n", mcAbsorbProp[395]);
    if (!mcNCounter[396]) fprintf(stderr, "Warning: No neutron could reach Component[396] channel_7_analyzer_1_array_crystal_array_0\n");
    if (mcAbsorbProp[396]) fprintf(stderr, "Warning: %g events were removed in Component[396] channel_7_analyzer_1_array_crystal_array_0=Union_box()\n"
"         (negative time, miss next components, rounding errors, Nan, Inf).\n", mcAbsorbProp[396]);
    if (!mcNCounter[397]) fprintf(stderr, "Warning: No neutron could reach Component[397] channel_7_analyzer_1_array_crystal_array_1\n");
    if (mcAbsorbProp[397]) fprintf(stderr, "Warning: %g events were removed in Component[397] channel_7_analyzer_1_array_crystal_array_1=Union_box()\n"
"         (negative time, miss next components, rounding errors, Nan, Inf).\n", mcAbsorbProp[397]);
    if (!mcNCounter[398]) fprintf(stderr, "Warning: No neutron could reach Component[398] channel_7_analyzer_1_array_crystal_array_2\n");
    if (mcAbsorbProp[398]) fprintf(stderr, "Warning: %g events were removed in Component[398] channel_7_analyzer_1_array_crystal_array_2=Union_box()\n"
"         (negative time, miss next components, rounding errors, Nan, Inf).\n", mcAbsorbProp[398]);
    if (!mcNCounter[399]) fprintf(stderr, "Warning: No neutron could reach Component[399] channel_7_analyzer_1_array_crystal_array_3\n");
    if (mcAbsorbProp[399]) fprintf(stderr, "Warning: %g events were removed in Component[399] channel_7_analyzer_1_array_crystal_array_3=Union_box()\n"
"         (negative time, miss next components, rounding errors, Nan, Inf).\n", mcAbsorbProp[399]);
    if (!mcNCounter[400]) fprintf(stderr, "Warning: No neutron could reach Component[400] channel_7_analyzer_1_array_crystal_array_4\n");
    if (mcAbsorbProp[400]) fprintf(stderr, "Warning: %g events were removed in Component[400] channel_7_analyzer_1_array_crystal_array_4=Union_box()\n"
"         (negative time, miss next components, rounding errors, Nan, Inf).\n", mcAbsorbProp[400]);
    if (!mcNCounter[401]) fprintf(stderr, "Warning: No neutron could reach Component[401] channel_7_analyzer_1_array_crystal_array_5\n");
    if (mcAbsorbProp[401]) fprintf(stderr, "Warning: %g events were removed in Component[401] channel_7_analyzer_1_array_crystal_array_5=Union_box()\n"
"         (negative time, miss next components, rounding errors, Nan, Inf).\n", mcAbsorbProp[401]);
    if (!mcNCounter[402]) fprintf(stderr, "Warning: No neutron could reach Component[402] channel_7_analyzer_1_array_crystal_array_6\n");
    if (mcAbsorbProp[402]) fprintf(stderr, "Warning: %g events were removed in Component[402] channel_7_analyzer_1_array_crystal_array_6=Union_box()\n"
"         (negative time, miss next components, rounding errors, Nan, Inf).\n", mcAbsorbProp[402]);
    if (!mcNCounter[403]) fprintf(stderr, "Warning: No neutron could reach Component[403] channel_7_analyzer_1_array_crystal_array_7\n");
    if (mcAbsorbProp[403]) fprintf(stderr, "Warning: %g events were removed in Component[403] channel_7_analyzer_1_array_crystal_array_7=Union_box()\n"
"         (negative time, miss next components, rounding errors, Nan, Inf).\n", mcAbsorbProp[403]);
    if (!mcNCounter[404]) fprintf(stderr, "Warning: No neutron could reach Component[404] channel_7_analyzer_1_array_crystal_array_8\n");
    if (mcAbsorbProp[404]) fprintf(stderr, "Warning: %g events were removed in Component[404] channel_7_analyzer_1_array_crystal_array_8=Union_box()\n"
"         (negative time, miss next components, rounding errors, Nan, Inf).\n", mcAbsorbProp[404]);
    if (!mcNCounter[405]) fprintf(stderr, "Warning: No neutron could reach Component[405] channel_7_analyzer_2_center\n");
    if (mcAbsorbProp[405]) fprintf(stderr, "Warning: %g events were removed in Component[405] channel_7_analyzer_2_center=Arm()\n"
"         (negative time, miss next components, rounding errors, Nan, Inf).\n", mcAbsorbProp[405]);
    if (!mcNCounter[406]) fprintf(stderr, "Warning: No neutron could reach Component[406] channel_7_analyzer_2_rotated\n");
    if (mcAbsorbProp[406]) fprintf(stderr, "Warning: %g events were removed in Component[406] channel_7_analyzer_2_rotated=Arm()\n"
"         (negative time, miss next components, rounding errors, Nan, Inf).\n", mcAbsorbProp[406]);
    if (!mcNCounter[407]) fprintf(stderr, "Warning: No neutron could reach Component[407] channel_7_analyzer_2_array_crystal_array_0\n");
    if (mcAbsorbProp[407]) fprintf(stderr, "Warning: %g events were removed in Component[407] channel_7_analyzer_2_array_crystal_array_0=Union_box()\n"
"         (negative time, miss next components, rounding errors, Nan, Inf).\n", mcAbsorbProp[407]);
    if (!mcNCounter[408]) fprintf(stderr, "Warning: No neutron could reach Component[408] channel_7_analyzer_2_array_crystal_array_1\n");
    if (mcAbsorbProp[408]) fprintf(stderr, "Warning: %g events were removed in Component[408] channel_7_analyzer_2_array_crystal_array_1=Union_box()\n"
"         (negative time, miss next components, rounding errors, Nan, Inf).\n", mcAbsorbProp[408]);
    if (!mcNCounter[409]) fprintf(stderr, "Warning: No neutron could reach Component[409] channel_7_analyzer_2_array_crystal_array_2\n");
    if (mcAbsorbProp[409]) fprintf(stderr, "Warning: %g events were removed in Component[409] channel_7_analyzer_2_array_crystal_array_2=Union_box()\n"
"         (negative time, miss next components, rounding errors, Nan, Inf).\n", mcAbsorbProp[409]);
    if (!mcNCounter[410]) fprintf(stderr, "Warning: No neutron could reach Component[410] channel_7_analyzer_2_array_crystal_array_3\n");
    if (mcAbsorbProp[410]) fprintf(stderr, "Warning: %g events were removed in Component[410] channel_7_analyzer_2_array_crystal_array_3=Union_box()\n"
"         (negative time, miss next components, rounding errors, Nan, Inf).\n", mcAbsorbProp[410]);
    if (!mcNCounter[411]) fprintf(stderr, "Warning: No neutron could reach Component[411] channel_7_analyzer_2_array_crystal_array_4\n");
    if (mcAbsorbProp[411]) fprintf(stderr, "Warning: %g events were removed in Component[411] channel_7_analyzer_2_array_crystal_array_4=Union_box()\n"
"         (negative time, miss next components, rounding errors, Nan, Inf).\n", mcAbsorbProp[411]);
    if (!mcNCounter[412]) fprintf(stderr, "Warning: No neutron could reach Component[412] channel_7_analyzer_2_array_crystal_array_5\n");
    if (mcAbsorbProp[412]) fprintf(stderr, "Warning: %g events were removed in Component[412] channel_7_analyzer_2_array_crystal_array_5=Union_box()\n"
"         (negative time, miss next components, rounding errors, Nan, Inf).\n", mcAbsorbProp[412]);
    if (!mcNCounter[413]) fprintf(stderr, "Warning: No neutron could reach Component[413] channel_7_analyzer_2_array_crystal_array_6\n");
    if (mcAbsorbProp[413]) fprintf(stderr, "Warning: %g events were removed in Component[413] channel_7_analyzer_2_array_crystal_array_6=Union_box()\n"
"         (negative time, miss next components, rounding errors, Nan, Inf).\n", mcAbsorbProp[413]);
    if (!mcNCounter[414]) fprintf(stderr, "Warning: No neutron could reach Component[414] channel_7_analyzer_2_array_crystal_array_7\n");
    if (mcAbsorbProp[414]) fprintf(stderr, "Warning: %g events were removed in Component[414] channel_7_analyzer_2_array_crystal_array_7=Union_box()\n"
"         (negative time, miss next components, rounding errors, Nan, Inf).\n", mcAbsorbProp[414]);
    if (!mcNCounter[415]) fprintf(stderr, "Warning: No neutron could reach Component[415] channel_7_analyzer_2_array_crystal_array_8\n");
    if (mcAbsorbProp[415]) fprintf(stderr, "Warning: %g events were removed in Component[415] channel_7_analyzer_2_array_crystal_array_8=Union_box()\n"
"         (negative time, miss next components, rounding errors, Nan, Inf).\n", mcAbsorbProp[415]);
    if (!mcNCounter[416]) fprintf(stderr, "Warning: No neutron could reach Component[416] channel_7_cave2_cyl1\n");
    if (mcAbsorbProp[416]) fprintf(stderr, "Warning: %g events were removed in Component[416] channel_7_cave2_cyl1=Union_cylinder()\n"
"         (negative time, miss next components, rounding errors, Nan, Inf).\n", mcAbsorbProp[416]);
    if (!mcNCounter[417]) fprintf(stderr, "Warning: No neutron could reach Component[417] channel_7_cave2_box1\n");
    if (mcAbsorbProp[417]) fprintf(stderr, "Warning: %g events were removed in Component[417] channel_7_cave2_box1=Union_box()\n"
"         (negative time, miss next components, rounding errors, Nan, Inf).\n", mcAbsorbProp[417]);
    if (!mcNCounter[418]) fprintf(stderr, "Warning: No neutron could reach Component[418] channel_7_cave2_box2\n");
    if (mcAbsorbProp[418]) fprintf(stderr, "Warning: %g events were removed in Component[418] channel_7_cave2_box2=Union_box()\n"
"         (negative time, miss next components, rounding errors, Nan, Inf).\n", mcAbsorbProp[418]);
    if (!mcNCounter[419]) fprintf(stderr, "Warning: No neutron could reach Component[419] channel_7_cave2_box3\n");
    if (mcAbsorbProp[419]) fprintf(stderr, "Warning: %g events were removed in Component[419] channel_7_cave2_box3=Union_box()\n"
"         (negative time, miss next components, rounding errors, Nan, Inf).\n", mcAbsorbProp[419]);
    if (!mcNCounter[420]) fprintf(stderr, "Warning: No neutron could reach Component[420] inter_analyzer_colimator_center_7\n");
    if (mcAbsorbProp[420]) fprintf(stderr, "Warning: %g events were removed in Component[420] inter_analyzer_colimator_center_7=Arm()\n"
"         (negative time, miss next components, rounding errors, Nan, Inf).\n", mcAbsorbProp[420]);
    if (!mcNCounter[421]) fprintf(stderr, "Warning: No neutron could reach Component[421] inter_analyzer_colimator_7_blade_0\n");
    if (mcAbsorbProp[421]) fprintf(stderr, "Warning: %g events were removed in Component[421] inter_analyzer_colimator_7_blade_0=Union_box()\n"
"         (negative time, miss next components, rounding errors, Nan, Inf).\n", mcAbsorbProp[421]);
    if (!mcNCounter[422]) fprintf(stderr, "Warning: No neutron could reach Component[422] inter_analyzer_colimator_7_blade_1\n");
    if (mcAbsorbProp[422]) fprintf(stderr, "Warning: %g events were removed in Component[422] inter_analyzer_colimator_7_blade_1=Union_box()\n"
"         (negative time, miss next components, rounding errors, Nan, Inf).\n", mcAbsorbProp[422]);
    if (!mcNCounter[423]) fprintf(stderr, "Warning: No neutron could reach Component[423] inter_analyzer_colimator_7_blade_2\n");
    if (mcAbsorbProp[423]) fprintf(stderr, "Warning: %g events were removed in Component[423] inter_analyzer_colimator_7_blade_2=Union_box()\n"
"         (negative time, miss next components, rounding errors, Nan, Inf).\n", mcAbsorbProp[423]);
    if (!mcNCounter[424]) fprintf(stderr, "Warning: No neutron could reach Component[424] inter_analyzer_colimator_7_blade_3\n");
    if (mcAbsorbProp[424]) fprintf(stderr, "Warning: %g events were removed in Component[424] inter_analyzer_colimator_7_blade_3=Union_box()\n"
"         (negative time, miss next components, rounding errors, Nan, Inf).\n", mcAbsorbProp[424]);
    if (!mcNCounter[425]) fprintf(stderr, "Warning: No neutron could reach Component[425] inter_analyzer_colimator_7_blade_4\n");
    if (mcAbsorbProp[425]) fprintf(stderr, "Warning: %g events were removed in Component[425] inter_analyzer_colimator_7_blade_4=Union_box()\n"
"         (negative time, miss next components, rounding errors, Nan, Inf).\n", mcAbsorbProp[425]);
    if (!mcNCounter[426]) fprintf(stderr, "Warning: No neutron could reach Component[426] diffraction_detector_7_exit_volume\n");
    if (mcAbsorbProp[426]) fprintf(stderr, "Warning: %g events were removed in Component[426] diffraction_detector_7_exit_volume=Union_box()\n"
"         (negative time, miss next components, rounding errors, Nan, Inf).\n", mcAbsorbProp[426]);
    if (!mcNCounter[427]) fprintf(stderr, "Warning: No neutron could reach Component[427] spec_detector_7_exit_volume\n");
    if (mcAbsorbProp[427]) fprintf(stderr, "Warning: %g events were removed in Component[427] spec_detector_7_exit_volume=Union_box()\n"
"         (negative time, miss next components, rounding errors, Nan, Inf).\n", mcAbsorbProp[427]);
    if (!mcNCounter[428]) fprintf(stderr, "Warning: No neutron could reach Component[428] channel_8_cave1_box1\n");
    if (mcAbsorbProp[428]) fprintf(stderr, "Warning: %g events were removed in Component[428] channel_8_cave1_box1=Union_box()\n"
"         (negative time, miss next components, rounding errors, Nan, Inf).\n", mcAbsorbProp[428]);
    if (!mcNCounter[429]) fprintf(stderr, "Warning: No neutron could reach Component[429] channel_8_cave1_box2\n");
    if (mcAbsorbProp[429]) fprintf(stderr, "Warning: %g events were removed in Component[429] channel_8_cave1_box2=Union_box()\n"
"         (negative time, miss next components, rounding errors, Nan, Inf).\n", mcAbsorbProp[429]);
    if (!mcNCounter[430]) fprintf(stderr, "Warning: No neutron could reach Component[430] channel_8_cave1_box3\n");
    if (mcAbsorbProp[430]) fprintf(stderr, "Warning: %g events were removed in Component[430] channel_8_cave1_box3=Union_box()\n"
"         (negative time, miss next components, rounding errors, Nan, Inf).\n", mcAbsorbProp[430]);
    if (!mcNCounter[431]) fprintf(stderr, "Warning: No neutron could reach Component[431] channel_8_cave1_cyl1\n");
    if (mcAbsorbProp[431]) fprintf(stderr, "Warning: %g events were removed in Component[431] channel_8_cave1_cyl1=Union_cylinder()\n"
"         (negative time, miss next components, rounding errors, Nan, Inf).\n", mcAbsorbProp[431]);
    if (!mcNCounter[432]) fprintf(stderr, "Warning: No neutron could reach Component[432] channel_8_analyzer_1_center\n");
    if (mcAbsorbProp[432]) fprintf(stderr, "Warning: %g events were removed in Component[432] channel_8_analyzer_1_center=Arm()\n"
"         (negative time, miss next components, rounding errors, Nan, Inf).\n", mcAbsorbProp[432]);
    if (!mcNCounter[433]) fprintf(stderr, "Warning: No neutron could reach Component[433] channel_8_analyzer_1_rotated\n");
    if (mcAbsorbProp[433]) fprintf(stderr, "Warning: %g events were removed in Component[433] channel_8_analyzer_1_rotated=Arm()\n"
"         (negative time, miss next components, rounding errors, Nan, Inf).\n", mcAbsorbProp[433]);
    if (!mcNCounter[434]) fprintf(stderr, "Warning: No neutron could reach Component[434] channel_8_analyzer_1_array_crystal_array_0\n");
    if (mcAbsorbProp[434]) fprintf(stderr, "Warning: %g events were removed in Component[434] channel_8_analyzer_1_array_crystal_array_0=Union_box()\n"
"         (negative time, miss next components, rounding errors, Nan, Inf).\n", mcAbsorbProp[434]);
    if (!mcNCounter[435]) fprintf(stderr, "Warning: No neutron could reach Component[435] channel_8_analyzer_1_array_crystal_array_1\n");
    if (mcAbsorbProp[435]) fprintf(stderr, "Warning: %g events were removed in Component[435] channel_8_analyzer_1_array_crystal_array_1=Union_box()\n"
"         (negative time, miss next components, rounding errors, Nan, Inf).\n", mcAbsorbProp[435]);
    if (!mcNCounter[436]) fprintf(stderr, "Warning: No neutron could reach Component[436] channel_8_analyzer_1_array_crystal_array_2\n");
    if (mcAbsorbProp[436]) fprintf(stderr, "Warning: %g events were removed in Component[436] channel_8_analyzer_1_array_crystal_array_2=Union_box()\n"
"         (negative time, miss next components, rounding errors, Nan, Inf).\n", mcAbsorbProp[436]);
    if (!mcNCounter[437]) fprintf(stderr, "Warning: No neutron could reach Component[437] channel_8_analyzer_1_array_crystal_array_3\n");
    if (mcAbsorbProp[437]) fprintf(stderr, "Warning: %g events were removed in Component[437] channel_8_analyzer_1_array_crystal_array_3=Union_box()\n"
"         (negative time, miss next components, rounding errors, Nan, Inf).\n", mcAbsorbProp[437]);
    if (!mcNCounter[438]) fprintf(stderr, "Warning: No neutron could reach Component[438] channel_8_analyzer_1_array_crystal_array_4\n");
    if (mcAbsorbProp[438]) fprintf(stderr, "Warning: %g events were removed in Component[438] channel_8_analyzer_1_array_crystal_array_4=Union_box()\n"
"         (negative time, miss next components, rounding errors, Nan, Inf).\n", mcAbsorbProp[438]);
    if (!mcNCounter[439]) fprintf(stderr, "Warning: No neutron could reach Component[439] channel_8_analyzer_1_array_crystal_array_5\n");
    if (mcAbsorbProp[439]) fprintf(stderr, "Warning: %g events were removed in Component[439] channel_8_analyzer_1_array_crystal_array_5=Union_box()\n"
"         (negative time, miss next components, rounding errors, Nan, Inf).\n", mcAbsorbProp[439]);
    if (!mcNCounter[440]) fprintf(stderr, "Warning: No neutron could reach Component[440] channel_8_analyzer_1_array_crystal_array_6\n");
    if (mcAbsorbProp[440]) fprintf(stderr, "Warning: %g events were removed in Component[440] channel_8_analyzer_1_array_crystal_array_6=Union_box()\n"
"         (negative time, miss next components, rounding errors, Nan, Inf).\n", mcAbsorbProp[440]);
    if (!mcNCounter[441]) fprintf(stderr, "Warning: No neutron could reach Component[441] channel_8_analyzer_1_array_crystal_array_7\n");
    if (mcAbsorbProp[441]) fprintf(stderr, "Warning: %g events were removed in Component[441] channel_8_analyzer_1_array_crystal_array_7=Union_box()\n"
"         (negative time, miss next components, rounding errors, Nan, Inf).\n", mcAbsorbProp[441]);
    if (!mcNCounter[442]) fprintf(stderr, "Warning: No neutron could reach Component[442] channel_8_analyzer_1_array_crystal_array_8\n");
    if (mcAbsorbProp[442]) fprintf(stderr, "Warning: %g events were removed in Component[442] channel_8_analyzer_1_array_crystal_array_8=Union_box()\n"
"         (negative time, miss next components, rounding errors, Nan, Inf).\n", mcAbsorbProp[442]);
    if (!mcNCounter[443]) fprintf(stderr, "Warning: No neutron could reach Component[443] channel_8_analyzer_2_center\n");
    if (mcAbsorbProp[443]) fprintf(stderr, "Warning: %g events were removed in Component[443] channel_8_analyzer_2_center=Arm()\n"
"         (negative time, miss next components, rounding errors, Nan, Inf).\n", mcAbsorbProp[443]);
    if (!mcNCounter[444]) fprintf(stderr, "Warning: No neutron could reach Component[444] channel_8_analyzer_2_rotated\n");
    if (mcAbsorbProp[444]) fprintf(stderr, "Warning: %g events were removed in Component[444] channel_8_analyzer_2_rotated=Arm()\n"
"         (negative time, miss next components, rounding errors, Nan, Inf).\n", mcAbsorbProp[444]);
    if (!mcNCounter[445]) fprintf(stderr, "Warning: No neutron could reach Component[445] channel_8_analyzer_2_array_crystal_array_0\n");
    if (mcAbsorbProp[445]) fprintf(stderr, "Warning: %g events were removed in Component[445] channel_8_analyzer_2_array_crystal_array_0=Union_box()\n"
"         (negative time, miss next components, rounding errors, Nan, Inf).\n", mcAbsorbProp[445]);
    if (!mcNCounter[446]) fprintf(stderr, "Warning: No neutron could reach Component[446] channel_8_analyzer_2_array_crystal_array_1\n");
    if (mcAbsorbProp[446]) fprintf(stderr, "Warning: %g events were removed in Component[446] channel_8_analyzer_2_array_crystal_array_1=Union_box()\n"
"         (negative time, miss next components, rounding errors, Nan, Inf).\n", mcAbsorbProp[446]);
    if (!mcNCounter[447]) fprintf(stderr, "Warning: No neutron could reach Component[447] channel_8_analyzer_2_array_crystal_array_2\n");
    if (mcAbsorbProp[447]) fprintf(stderr, "Warning: %g events were removed in Component[447] channel_8_analyzer_2_array_crystal_array_2=Union_box()\n"
"         (negative time, miss next components, rounding errors, Nan, Inf).\n", mcAbsorbProp[447]);
    if (!mcNCounter[448]) fprintf(stderr, "Warning: No neutron could reach Component[448] channel_8_analyzer_2_array_crystal_array_3\n");
    if (mcAbsorbProp[448]) fprintf(stderr, "Warning: %g events were removed in Component[448] channel_8_analyzer_2_array_crystal_array_3=Union_box()\n"
"         (negative time, miss next components, rounding errors, Nan, Inf).\n", mcAbsorbProp[448]);
    if (!mcNCounter[449]) fprintf(stderr, "Warning: No neutron could reach Component[449] channel_8_analyzer_2_array_crystal_array_4\n");
    if (mcAbsorbProp[449]) fprintf(stderr, "Warning: %g events were removed in Component[449] channel_8_analyzer_2_array_crystal_array_4=Union_box()\n"
"         (negative time, miss next components, rounding errors, Nan, Inf).\n", mcAbsorbProp[449]);
    if (!mcNCounter[450]) fprintf(stderr, "Warning: No neutron could reach Component[450] channel_8_analyzer_2_array_crystal_array_5\n");
    if (mcAbsorbProp[450]) fprintf(stderr, "Warning: %g events were removed in Component[450] channel_8_analyzer_2_array_crystal_array_5=Union_box()\n"
"         (negative time, miss next components, rounding errors, Nan, Inf).\n", mcAbsorbProp[450]);
    if (!mcNCounter[451]) fprintf(stderr, "Warning: No neutron could reach Component[451] channel_8_analyzer_2_array_crystal_array_6\n");
    if (mcAbsorbProp[451]) fprintf(stderr, "Warning: %g events were removed in Component[451] channel_8_analyzer_2_array_crystal_array_6=Union_box()\n"
"         (negative time, miss next components, rounding errors, Nan, Inf).\n", mcAbsorbProp[451]);
    if (!mcNCounter[452]) fprintf(stderr, "Warning: No neutron could reach Component[452] channel_8_analyzer_2_array_crystal_array_7\n");
    if (mcAbsorbProp[452]) fprintf(stderr, "Warning: %g events were removed in Component[452] channel_8_analyzer_2_array_crystal_array_7=Union_box()\n"
"         (negative time, miss next components, rounding errors, Nan, Inf).\n", mcAbsorbProp[452]);
    if (!mcNCounter[453]) fprintf(stderr, "Warning: No neutron could reach Component[453] channel_8_analyzer_2_array_crystal_array_8\n");
    if (mcAbsorbProp[453]) fprintf(stderr, "Warning: %g events were removed in Component[453] channel_8_analyzer_2_array_crystal_array_8=Union_box()\n"
"         (negative time, miss next components, rounding errors, Nan, Inf).\n", mcAbsorbProp[453]);
    if (!mcNCounter[454]) fprintf(stderr, "Warning: No neutron could reach Component[454] channel_8_cave2_cyl1\n");
    if (mcAbsorbProp[454]) fprintf(stderr, "Warning: %g events were removed in Component[454] channel_8_cave2_cyl1=Union_cylinder()\n"
"         (negative time, miss next components, rounding errors, Nan, Inf).\n", mcAbsorbProp[454]);
    if (!mcNCounter[455]) fprintf(stderr, "Warning: No neutron could reach Component[455] channel_8_cave2_box1\n");
    if (mcAbsorbProp[455]) fprintf(stderr, "Warning: %g events were removed in Component[455] channel_8_cave2_box1=Union_box()\n"
"         (negative time, miss next components, rounding errors, Nan, Inf).\n", mcAbsorbProp[455]);
    if (!mcNCounter[456]) fprintf(stderr, "Warning: No neutron could reach Component[456] channel_8_cave2_box2\n");
    if (mcAbsorbProp[456]) fprintf(stderr, "Warning: %g events were removed in Component[456] channel_8_cave2_box2=Union_box()\n"
"         (negative time, miss next components, rounding errors, Nan, Inf).\n", mcAbsorbProp[456]);
    if (!mcNCounter[457]) fprintf(stderr, "Warning: No neutron could reach Component[457] channel_8_cave2_box3\n");
    if (mcAbsorbProp[457]) fprintf(stderr, "Warning: %g events were removed in Component[457] channel_8_cave2_box3=Union_box()\n"
"         (negative time, miss next components, rounding errors, Nan, Inf).\n", mcAbsorbProp[457]);
    if (!mcNCounter[458]) fprintf(stderr, "Warning: No neutron could reach Component[458] inter_analyzer_colimator_center_8\n");
    if (mcAbsorbProp[458]) fprintf(stderr, "Warning: %g events were removed in Component[458] inter_analyzer_colimator_center_8=Arm()\n"
"         (negative time, miss next components, rounding errors, Nan, Inf).\n", mcAbsorbProp[458]);
    if (!mcNCounter[459]) fprintf(stderr, "Warning: No neutron could reach Component[459] inter_analyzer_colimator_8_blade_0\n");
    if (mcAbsorbProp[459]) fprintf(stderr, "Warning: %g events were removed in Component[459] inter_analyzer_colimator_8_blade_0=Union_box()\n"
"         (negative time, miss next components, rounding errors, Nan, Inf).\n", mcAbsorbProp[459]);
    if (!mcNCounter[460]) fprintf(stderr, "Warning: No neutron could reach Component[460] inter_analyzer_colimator_8_blade_1\n");
    if (mcAbsorbProp[460]) fprintf(stderr, "Warning: %g events were removed in Component[460] inter_analyzer_colimator_8_blade_1=Union_box()\n"
"         (negative time, miss next components, rounding errors, Nan, Inf).\n", mcAbsorbProp[460]);
    if (!mcNCounter[461]) fprintf(stderr, "Warning: No neutron could reach Component[461] inter_analyzer_colimator_8_blade_2\n");
    if (mcAbsorbProp[461]) fprintf(stderr, "Warning: %g events were removed in Component[461] inter_analyzer_colimator_8_blade_2=Union_box()\n"
"         (negative time, miss next components, rounding errors, Nan, Inf).\n", mcAbsorbProp[461]);
    if (!mcNCounter[462]) fprintf(stderr, "Warning: No neutron could reach Component[462] inter_analyzer_colimator_8_blade_3\n");
    if (mcAbsorbProp[462]) fprintf(stderr, "Warning: %g events were removed in Component[462] inter_analyzer_colimator_8_blade_3=Union_box()\n"
"         (negative time, miss next components, rounding errors, Nan, Inf).\n", mcAbsorbProp[462]);
    if (!mcNCounter[463]) fprintf(stderr, "Warning: No neutron could reach Component[463] inter_analyzer_colimator_8_blade_4\n");
    if (mcAbsorbProp[463]) fprintf(stderr, "Warning: %g events were removed in Component[463] inter_analyzer_colimator_8_blade_4=Union_box()\n"
"         (negative time, miss next components, rounding errors, Nan, Inf).\n", mcAbsorbProp[463]);
    if (!mcNCounter[464]) fprintf(stderr, "Warning: No neutron could reach Component[464] diffraction_detector_8_exit_volume\n");
    if (mcAbsorbProp[464]) fprintf(stderr, "Warning: %g events were removed in Component[464] diffraction_detector_8_exit_volume=Union_box()\n"
"         (negative time, miss next components, rounding errors, Nan, Inf).\n", mcAbsorbProp[464]);
    if (!mcNCounter[465]) fprintf(stderr, "Warning: No neutron could reach Component[465] spec_detector_8_exit_volume\n");
    if (mcAbsorbProp[465]) fprintf(stderr, "Warning: %g events were removed in Component[465] spec_detector_8_exit_volume=Union_box()\n"
"         (negative time, miss next components, rounding errors, Nan, Inf).\n", mcAbsorbProp[465]);
    if (!mcNCounter[466]) fprintf(stderr, "Warning: No neutron could reach Component[466] channel_9_cave1_box1\n");
    if (mcAbsorbProp[466]) fprintf(stderr, "Warning: %g events were removed in Component[466] channel_9_cave1_box1=Union_box()\n"
"         (negative time, miss next components, rounding errors, Nan, Inf).\n", mcAbsorbProp[466]);
    if (!mcNCounter[467]) fprintf(stderr, "Warning: No neutron could reach Component[467] channel_9_cave1_box2\n");
    if (mcAbsorbProp[467]) fprintf(stderr, "Warning: %g events were removed in Component[467] channel_9_cave1_box2=Union_box()\n"
"         (negative time, miss next components, rounding errors, Nan, Inf).\n", mcAbsorbProp[467]);
    if (!mcNCounter[468]) fprintf(stderr, "Warning: No neutron could reach Component[468] channel_9_cave1_box3\n");
    if (mcAbsorbProp[468]) fprintf(stderr, "Warning: %g events were removed in Component[468] channel_9_cave1_box3=Union_box()\n"
"         (negative time, miss next components, rounding errors, Nan, Inf).\n", mcAbsorbProp[468]);
    if (!mcNCounter[469]) fprintf(stderr, "Warning: No neutron could reach Component[469] channel_9_cave1_cyl1\n");
    if (mcAbsorbProp[469]) fprintf(stderr, "Warning: %g events were removed in Component[469] channel_9_cave1_cyl1=Union_cylinder()\n"
"         (negative time, miss next components, rounding errors, Nan, Inf).\n", mcAbsorbProp[469]);
    if (!mcNCounter[470]) fprintf(stderr, "Warning: No neutron could reach Component[470] channel_9_analyzer_1_center\n");
    if (mcAbsorbProp[470]) fprintf(stderr, "Warning: %g events were removed in Component[470] channel_9_analyzer_1_center=Arm()\n"
"         (negative time, miss next components, rounding errors, Nan, Inf).\n", mcAbsorbProp[470]);
    if (!mcNCounter[471]) fprintf(stderr, "Warning: No neutron could reach Component[471] channel_9_analyzer_1_rotated\n");
    if (mcAbsorbProp[471]) fprintf(stderr, "Warning: %g events were removed in Component[471] channel_9_analyzer_1_rotated=Arm()\n"
"         (negative time, miss next components, rounding errors, Nan, Inf).\n", mcAbsorbProp[471]);
    if (!mcNCounter[472]) fprintf(stderr, "Warning: No neutron could reach Component[472] channel_9_analyzer_1_array_crystal_array_0\n");
    if (mcAbsorbProp[472]) fprintf(stderr, "Warning: %g events were removed in Component[472] channel_9_analyzer_1_array_crystal_array_0=Union_box()\n"
"         (negative time, miss next components, rounding errors, Nan, Inf).\n", mcAbsorbProp[472]);
    if (!mcNCounter[473]) fprintf(stderr, "Warning: No neutron could reach Component[473] channel_9_analyzer_1_array_crystal_array_1\n");
    if (mcAbsorbProp[473]) fprintf(stderr, "Warning: %g events were removed in Component[473] channel_9_analyzer_1_array_crystal_array_1=Union_box()\n"
"         (negative time, miss next components, rounding errors, Nan, Inf).\n", mcAbsorbProp[473]);
    if (!mcNCounter[474]) fprintf(stderr, "Warning: No neutron could reach Component[474] channel_9_analyzer_1_array_crystal_array_2\n");
    if (mcAbsorbProp[474]) fprintf(stderr, "Warning: %g events were removed in Component[474] channel_9_analyzer_1_array_crystal_array_2=Union_box()\n"
"         (negative time, miss next components, rounding errors, Nan, Inf).\n", mcAbsorbProp[474]);
    if (!mcNCounter[475]) fprintf(stderr, "Warning: No neutron could reach Component[475] channel_9_analyzer_1_array_crystal_array_3\n");
    if (mcAbsorbProp[475]) fprintf(stderr, "Warning: %g events were removed in Component[475] channel_9_analyzer_1_array_crystal_array_3=Union_box()\n"
"         (negative time, miss next components, rounding errors, Nan, Inf).\n", mcAbsorbProp[475]);
    if (!mcNCounter[476]) fprintf(stderr, "Warning: No neutron could reach Component[476] channel_9_analyzer_1_array_crystal_array_4\n");
    if (mcAbsorbProp[476]) fprintf(stderr, "Warning: %g events were removed in Component[476] channel_9_analyzer_1_array_crystal_array_4=Union_box()\n"
"         (negative time, miss next components, rounding errors, Nan, Inf).\n", mcAbsorbProp[476]);
    if (!mcNCounter[477]) fprintf(stderr, "Warning: No neutron could reach Component[477] channel_9_analyzer_1_array_crystal_array_5\n");
    if (mcAbsorbProp[477]) fprintf(stderr, "Warning: %g events were removed in Component[477] channel_9_analyzer_1_array_crystal_array_5=Union_box()\n"
"         (negative time, miss next components, rounding errors, Nan, Inf).\n", mcAbsorbProp[477]);
    if (!mcNCounter[478]) fprintf(stderr, "Warning: No neutron could reach Component[478] channel_9_analyzer_1_array_crystal_array_6\n");
    if (mcAbsorbProp[478]) fprintf(stderr, "Warning: %g events were removed in Component[478] channel_9_analyzer_1_array_crystal_array_6=Union_box()\n"
"         (negative time, miss next components, rounding errors, Nan, Inf).\n", mcAbsorbProp[478]);
    if (!mcNCounter[479]) fprintf(stderr, "Warning: No neutron could reach Component[479] channel_9_analyzer_1_array_crystal_array_7\n");
    if (mcAbsorbProp[479]) fprintf(stderr, "Warning: %g events were removed in Component[479] channel_9_analyzer_1_array_crystal_array_7=Union_box()\n"
"         (negative time, miss next components, rounding errors, Nan, Inf).\n", mcAbsorbProp[479]);
    if (!mcNCounter[480]) fprintf(stderr, "Warning: No neutron could reach Component[480] channel_9_analyzer_1_array_crystal_array_8\n");
    if (mcAbsorbProp[480]) fprintf(stderr, "Warning: %g events were removed in Component[480] channel_9_analyzer_1_array_crystal_array_8=Union_box()\n"
"         (negative time, miss next components, rounding errors, Nan, Inf).\n", mcAbsorbProp[480]);
    if (!mcNCounter[481]) fprintf(stderr, "Warning: No neutron could reach Component[481] channel_9_analyzer_2_center\n");
    if (mcAbsorbProp[481]) fprintf(stderr, "Warning: %g events were removed in Component[481] channel_9_analyzer_2_center=Arm()\n"
"         (negative time, miss next components, rounding errors, Nan, Inf).\n", mcAbsorbProp[481]);
    if (!mcNCounter[482]) fprintf(stderr, "Warning: No neutron could reach Component[482] channel_9_analyzer_2_rotated\n");
    if (mcAbsorbProp[482]) fprintf(stderr, "Warning: %g events were removed in Component[482] channel_9_analyzer_2_rotated=Arm()\n"
"         (negative time, miss next components, rounding errors, Nan, Inf).\n", mcAbsorbProp[482]);
    if (!mcNCounter[483]) fprintf(stderr, "Warning: No neutron could reach Component[483] channel_9_analyzer_2_array_crystal_array_0\n");
    if (mcAbsorbProp[483]) fprintf(stderr, "Warning: %g events were removed in Component[483] channel_9_analyzer_2_array_crystal_array_0=Union_box()\n"
"         (negative time, miss next components, rounding errors, Nan, Inf).\n", mcAbsorbProp[483]);
    if (!mcNCounter[484]) fprintf(stderr, "Warning: No neutron could reach Component[484] channel_9_analyzer_2_array_crystal_array_1\n");
    if (mcAbsorbProp[484]) fprintf(stderr, "Warning: %g events were removed in Component[484] channel_9_analyzer_2_array_crystal_array_1=Union_box()\n"
"         (negative time, miss next components, rounding errors, Nan, Inf).\n", mcAbsorbProp[484]);
    if (!mcNCounter[485]) fprintf(stderr, "Warning: No neutron could reach Component[485] channel_9_analyzer_2_array_crystal_array_2\n");
    if (mcAbsorbProp[485]) fprintf(stderr, "Warning: %g events were removed in Component[485] channel_9_analyzer_2_array_crystal_array_2=Union_box()\n"
"         (negative time, miss next components, rounding errors, Nan, Inf).\n", mcAbsorbProp[485]);
    if (!mcNCounter[486]) fprintf(stderr, "Warning: No neutron could reach Component[486] channel_9_analyzer_2_array_crystal_array_3\n");
    if (mcAbsorbProp[486]) fprintf(stderr, "Warning: %g events were removed in Component[486] channel_9_analyzer_2_array_crystal_array_3=Union_box()\n"
"         (negative time, miss next components, rounding errors, Nan, Inf).\n", mcAbsorbProp[486]);
    if (!mcNCounter[487]) fprintf(stderr, "Warning: No neutron could reach Component[487] channel_9_analyzer_2_array_crystal_array_4\n");
    if (mcAbsorbProp[487]) fprintf(stderr, "Warning: %g events were removed in Component[487] channel_9_analyzer_2_array_crystal_array_4=Union_box()\n"
"         (negative time, miss next components, rounding errors, Nan, Inf).\n", mcAbsorbProp[487]);
    if (!mcNCounter[488]) fprintf(stderr, "Warning: No neutron could reach Component[488] channel_9_analyzer_2_array_crystal_array_5\n");
    if (mcAbsorbProp[488]) fprintf(stderr, "Warning: %g events were removed in Component[488] channel_9_analyzer_2_array_crystal_array_5=Union_box()\n"
"         (negative time, miss next components, rounding errors, Nan, Inf).\n", mcAbsorbProp[488]);
    if (!mcNCounter[489]) fprintf(stderr, "Warning: No neutron could reach Component[489] channel_9_analyzer_2_array_crystal_array_6\n");
    if (mcAbsorbProp[489]) fprintf(stderr, "Warning: %g events were removed in Component[489] channel_9_analyzer_2_array_crystal_array_6=Union_box()\n"
"         (negative time, miss next components, rounding errors, Nan, Inf).\n", mcAbsorbProp[489]);
    if (!mcNCounter[490]) fprintf(stderr, "Warning: No neutron could reach Component[490] channel_9_analyzer_2_array_crystal_array_7\n");
    if (mcAbsorbProp[490]) fprintf(stderr, "Warning: %g events were removed in Component[490] channel_9_analyzer_2_array_crystal_array_7=Union_box()\n"
"         (negative time, miss next components, rounding errors, Nan, Inf).\n", mcAbsorbProp[490]);
    if (!mcNCounter[491]) fprintf(stderr, "Warning: No neutron could reach Component[491] channel_9_analyzer_2_array_crystal_array_8\n");
    if (mcAbsorbProp[491]) fprintf(stderr, "Warning: %g events were removed in Component[491] channel_9_analyzer_2_array_crystal_array_8=Union_box()\n"
"         (negative time, miss next components, rounding errors, Nan, Inf).\n", mcAbsorbProp[491]);
    if (!mcNCounter[492]) fprintf(stderr, "Warning: No neutron could reach Component[492] channel_9_cave2_cyl1\n");
    if (mcAbsorbProp[492]) fprintf(stderr, "Warning: %g events were removed in Component[492] channel_9_cave2_cyl1=Union_cylinder()\n"
"         (negative time, miss next components, rounding errors, Nan, Inf).\n", mcAbsorbProp[492]);
    if (!mcNCounter[493]) fprintf(stderr, "Warning: No neutron could reach Component[493] channel_9_cave2_box1\n");
    if (mcAbsorbProp[493]) fprintf(stderr, "Warning: %g events were removed in Component[493] channel_9_cave2_box1=Union_box()\n"
"         (negative time, miss next components, rounding errors, Nan, Inf).\n", mcAbsorbProp[493]);
    if (!mcNCounter[494]) fprintf(stderr, "Warning: No neutron could reach Component[494] channel_9_cave2_box2\n");
    if (mcAbsorbProp[494]) fprintf(stderr, "Warning: %g events were removed in Component[494] channel_9_cave2_box2=Union_box()\n"
"         (negative time, miss next components, rounding errors, Nan, Inf).\n", mcAbsorbProp[494]);
    if (!mcNCounter[495]) fprintf(stderr, "Warning: No neutron could reach Component[495] channel_9_cave2_box3\n");
    if (mcAbsorbProp[495]) fprintf(stderr, "Warning: %g events were removed in Component[495] channel_9_cave2_box3=Union_box()\n"
"         (negative time, miss next components, rounding errors, Nan, Inf).\n", mcAbsorbProp[495]);
    if (!mcNCounter[496]) fprintf(stderr, "Warning: No neutron could reach Component[496] inter_analyzer_colimator_center_9\n");
    if (mcAbsorbProp[496]) fprintf(stderr, "Warning: %g events were removed in Component[496] inter_analyzer_colimator_center_9=Arm()\n"
"         (negative time, miss next components, rounding errors, Nan, Inf).\n", mcAbsorbProp[496]);
    if (!mcNCounter[497]) fprintf(stderr, "Warning: No neutron could reach Component[497] inter_analyzer_colimator_9_blade_0\n");
    if (mcAbsorbProp[497]) fprintf(stderr, "Warning: %g events were removed in Component[497] inter_analyzer_colimator_9_blade_0=Union_box()\n"
"         (negative time, miss next components, rounding errors, Nan, Inf).\n", mcAbsorbProp[497]);
    if (!mcNCounter[498]) fprintf(stderr, "Warning: No neutron could reach Component[498] inter_analyzer_colimator_9_blade_1\n");
    if (mcAbsorbProp[498]) fprintf(stderr, "Warning: %g events were removed in Component[498] inter_analyzer_colimator_9_blade_1=Union_box()\n"
"         (negative time, miss next components, rounding errors, Nan, Inf).\n", mcAbsorbProp[498]);
    if (!mcNCounter[499]) fprintf(stderr, "Warning: No neutron could reach Component[499] inter_analyzer_colimator_9_blade_2\n");
    if (mcAbsorbProp[499]) fprintf(stderr, "Warning: %g events were removed in Component[499] inter_analyzer_colimator_9_blade_2=Union_box()\n"
"         (negative time, miss next components, rounding errors, Nan, Inf).\n", mcAbsorbProp[499]);
    if (!mcNCounter[500]) fprintf(stderr, "Warning: No neutron could reach Component[500] inter_analyzer_colimator_9_blade_3\n");
    if (mcAbsorbProp[500]) fprintf(stderr, "Warning: %g events were removed in Component[500] inter_analyzer_colimator_9_blade_3=Union_box()\n"
"         (negative time, miss next components, rounding errors, Nan, Inf).\n", mcAbsorbProp[500]);
    if (!mcNCounter[501]) fprintf(stderr, "Warning: No neutron could reach Component[501] inter_analyzer_colimator_9_blade_4\n");
    if (mcAbsorbProp[501]) fprintf(stderr, "Warning: %g events were removed in Component[501] inter_analyzer_colimator_9_blade_4=Union_box()\n"
"         (negative time, miss next components, rounding errors, Nan, Inf).\n", mcAbsorbProp[501]);
    if (!mcNCounter[502]) fprintf(stderr, "Warning: No neutron could reach Component[502] diffraction_detector_9_exit_volume\n");
    if (mcAbsorbProp[502]) fprintf(stderr, "Warning: %g events were removed in Component[502] diffraction_detector_9_exit_volume=Union_box()\n"
"         (negative time, miss next components, rounding errors, Nan, Inf).\n", mcAbsorbProp[502]);
    if (!mcNCounter[503]) fprintf(stderr, "Warning: No neutron could reach Component[503] spec_detector_9_exit_volume\n");
    if (mcAbsorbProp[503]) fprintf(stderr, "Warning: %g events were removed in Component[503] spec_detector_9_exit_volume=Union_box()\n"
"         (negative time, miss next components, rounding errors, Nan, Inf).\n", mcAbsorbProp[503]);
    if (!mcNCounter[504]) fprintf(stderr, "Warning: No neutron could reach Component[504] channel_10_cave1_box1\n");
    if (mcAbsorbProp[504]) fprintf(stderr, "Warning: %g events were removed in Component[504] channel_10_cave1_box1=Union_box()\n"
"         (negative time, miss next components, rounding errors, Nan, Inf).\n", mcAbsorbProp[504]);
    if (!mcNCounter[505]) fprintf(stderr, "Warning: No neutron could reach Component[505] channel_10_cave1_box2\n");
    if (mcAbsorbProp[505]) fprintf(stderr, "Warning: %g events were removed in Component[505] channel_10_cave1_box2=Union_box()\n"
"         (negative time, miss next components, rounding errors, Nan, Inf).\n", mcAbsorbProp[505]);
    if (!mcNCounter[506]) fprintf(stderr, "Warning: No neutron could reach Component[506] channel_10_cave1_box3\n");
    if (mcAbsorbProp[506]) fprintf(stderr, "Warning: %g events were removed in Component[506] channel_10_cave1_box3=Union_box()\n"
"         (negative time, miss next components, rounding errors, Nan, Inf).\n", mcAbsorbProp[506]);
    if (!mcNCounter[507]) fprintf(stderr, "Warning: No neutron could reach Component[507] channel_10_cave1_cyl1\n");
    if (mcAbsorbProp[507]) fprintf(stderr, "Warning: %g events were removed in Component[507] channel_10_cave1_cyl1=Union_cylinder()\n"
"         (negative time, miss next components, rounding errors, Nan, Inf).\n", mcAbsorbProp[507]);
    if (!mcNCounter[508]) fprintf(stderr, "Warning: No neutron could reach Component[508] channel_10_analyzer_1_center\n");
    if (mcAbsorbProp[508]) fprintf(stderr, "Warning: %g events were removed in Component[508] channel_10_analyzer_1_center=Arm()\n"
"         (negative time, miss next components, rounding errors, Nan, Inf).\n", mcAbsorbProp[508]);
    if (!mcNCounter[509]) fprintf(stderr, "Warning: No neutron could reach Component[509] channel_10_analyzer_1_rotated\n");
    if (mcAbsorbProp[509]) fprintf(stderr, "Warning: %g events were removed in Component[509] channel_10_analyzer_1_rotated=Arm()\n"
"         (negative time, miss next components, rounding errors, Nan, Inf).\n", mcAbsorbProp[509]);
    if (!mcNCounter[510]) fprintf(stderr, "Warning: No neutron could reach Component[510] channel_10_analyzer_1_array_crystal_array_0\n");
    if (mcAbsorbProp[510]) fprintf(stderr, "Warning: %g events were removed in Component[510] channel_10_analyzer_1_array_crystal_array_0=Union_box()\n"
"         (negative time, miss next components, rounding errors, Nan, Inf).\n", mcAbsorbProp[510]);
    if (!mcNCounter[511]) fprintf(stderr, "Warning: No neutron could reach Component[511] channel_10_analyzer_1_array_crystal_array_1\n");
    if (mcAbsorbProp[511]) fprintf(stderr, "Warning: %g events were removed in Component[511] channel_10_analyzer_1_array_crystal_array_1=Union_box()\n"
"         (negative time, miss next components, rounding errors, Nan, Inf).\n", mcAbsorbProp[511]);
    if (!mcNCounter[512]) fprintf(stderr, "Warning: No neutron could reach Component[512] channel_10_analyzer_1_array_crystal_array_2\n");
    if (mcAbsorbProp[512]) fprintf(stderr, "Warning: %g events were removed in Component[512] channel_10_analyzer_1_array_crystal_array_2=Union_box()\n"
"         (negative time, miss next components, rounding errors, Nan, Inf).\n", mcAbsorbProp[512]);
    if (!mcNCounter[513]) fprintf(stderr, "Warning: No neutron could reach Component[513] channel_10_analyzer_1_array_crystal_array_3\n");
    if (mcAbsorbProp[513]) fprintf(stderr, "Warning: %g events were removed in Component[513] channel_10_analyzer_1_array_crystal_array_3=Union_box()\n"
"         (negative time, miss next components, rounding errors, Nan, Inf).\n", mcAbsorbProp[513]);
    if (!mcNCounter[514]) fprintf(stderr, "Warning: No neutron could reach Component[514] channel_10_analyzer_1_array_crystal_array_4\n");
    if (mcAbsorbProp[514]) fprintf(stderr, "Warning: %g events were removed in Component[514] channel_10_analyzer_1_array_crystal_array_4=Union_box()\n"
"         (negative time, miss next components, rounding errors, Nan, Inf).\n", mcAbsorbProp[514]);
    if (!mcNCounter[515]) fprintf(stderr, "Warning: No neutron could reach Component[515] channel_10_analyzer_1_array_crystal_array_5\n");
    if (mcAbsorbProp[515]) fprintf(stderr, "Warning: %g events were removed in Component[515] channel_10_analyzer_1_array_crystal_array_5=Union_box()\n"
"         (negative time, miss next components, rounding errors, Nan, Inf).\n", mcAbsorbProp[515]);
    if (!mcNCounter[516]) fprintf(stderr, "Warning: No neutron could reach Component[516] channel_10_analyzer_1_array_crystal_array_6\n");
    if (mcAbsorbProp[516]) fprintf(stderr, "Warning: %g events were removed in Component[516] channel_10_analyzer_1_array_crystal_array_6=Union_box()\n"
"         (negative time, miss next components, rounding errors, Nan, Inf).\n", mcAbsorbProp[516]);
    if (!mcNCounter[517]) fprintf(stderr, "Warning: No neutron could reach Component[517] channel_10_analyzer_1_array_crystal_array_7\n");
    if (mcAbsorbProp[517]) fprintf(stderr, "Warning: %g events were removed in Component[517] channel_10_analyzer_1_array_crystal_array_7=Union_box()\n"
"         (negative time, miss next components, rounding errors, Nan, Inf).\n", mcAbsorbProp[517]);
    if (!mcNCounter[518]) fprintf(stderr, "Warning: No neutron could reach Component[518] channel_10_analyzer_1_array_crystal_array_8\n");
    if (mcAbsorbProp[518]) fprintf(stderr, "Warning: %g events were removed in Component[518] channel_10_analyzer_1_array_crystal_array_8=Union_box()\n"
"         (negative time, miss next components, rounding errors, Nan, Inf).\n", mcAbsorbProp[518]);
    if (!mcNCounter[519]) fprintf(stderr, "Warning: No neutron could reach Component[519] channel_10_analyzer_2_center\n");
    if (mcAbsorbProp[519]) fprintf(stderr, "Warning: %g events were removed in Component[519] channel_10_analyzer_2_center=Arm()\n"
"         (negative time, miss next components, rounding errors, Nan, Inf).\n", mcAbsorbProp[519]);
    if (!mcNCounter[520]) fprintf(stderr, "Warning: No neutron could reach Component[520] channel_10_analyzer_2_rotated\n");
    if (mcAbsorbProp[520]) fprintf(stderr, "Warning: %g events were removed in Component[520] channel_10_analyzer_2_rotated=Arm()\n"
"         (negative time, miss next components, rounding errors, Nan, Inf).\n", mcAbsorbProp[520]);
    if (!mcNCounter[521]) fprintf(stderr, "Warning: No neutron could reach Component[521] channel_10_analyzer_2_array_crystal_array_0\n");
    if (mcAbsorbProp[521]) fprintf(stderr, "Warning: %g events were removed in Component[521] channel_10_analyzer_2_array_crystal_array_0=Union_box()\n"
"         (negative time, miss next components, rounding errors, Nan, Inf).\n", mcAbsorbProp[521]);
    if (!mcNCounter[522]) fprintf(stderr, "Warning: No neutron could reach Component[522] channel_10_analyzer_2_array_crystal_array_1\n");
    if (mcAbsorbProp[522]) fprintf(stderr, "Warning: %g events were removed in Component[522] channel_10_analyzer_2_array_crystal_array_1=Union_box()\n"
"         (negative time, miss next components, rounding errors, Nan, Inf).\n", mcAbsorbProp[522]);
    if (!mcNCounter[523]) fprintf(stderr, "Warning: No neutron could reach Component[523] channel_10_analyzer_2_array_crystal_array_2\n");
    if (mcAbsorbProp[523]) fprintf(stderr, "Warning: %g events were removed in Component[523] channel_10_analyzer_2_array_crystal_array_2=Union_box()\n"
"         (negative time, miss next components, rounding errors, Nan, Inf).\n", mcAbsorbProp[523]);
    if (!mcNCounter[524]) fprintf(stderr, "Warning: No neutron could reach Component[524] channel_10_analyzer_2_array_crystal_array_3\n");
    if (mcAbsorbProp[524]) fprintf(stderr, "Warning: %g events were removed in Component[524] channel_10_analyzer_2_array_crystal_array_3=Union_box()\n"
"         (negative time, miss next components, rounding errors, Nan, Inf).\n", mcAbsorbProp[524]);
    if (!mcNCounter[525]) fprintf(stderr, "Warning: No neutron could reach Component[525] channel_10_analyzer_2_array_crystal_array_4\n");
    if (mcAbsorbProp[525]) fprintf(stderr, "Warning: %g events were removed in Component[525] channel_10_analyzer_2_array_crystal_array_4=Union_box()\n"
"         (negative time, miss next components, rounding errors, Nan, Inf).\n", mcAbsorbProp[525]);
    if (!mcNCounter[526]) fprintf(stderr, "Warning: No neutron could reach Component[526] channel_10_analyzer_2_array_crystal_array_5\n");
    if (mcAbsorbProp[526]) fprintf(stderr, "Warning: %g events were removed in Component[526] channel_10_analyzer_2_array_crystal_array_5=Union_box()\n"
"         (negative time, miss next components, rounding errors, Nan, Inf).\n", mcAbsorbProp[526]);
    if (!mcNCounter[527]) fprintf(stderr, "Warning: No neutron could reach Component[527] channel_10_analyzer_2_array_crystal_array_6\n");
    if (mcAbsorbProp[527]) fprintf(stderr, "Warning: %g events were removed in Component[527] channel_10_analyzer_2_array_crystal_array_6=Union_box()\n"
"         (negative time, miss next components, rounding errors, Nan, Inf).\n", mcAbsorbProp[527]);
    if (!mcNCounter[528]) fprintf(stderr, "Warning: No neutron could reach Component[528] channel_10_analyzer_2_array_crystal_array_7\n");
    if (mcAbsorbProp[528]) fprintf(stderr, "Warning: %g events were removed in Component[528] channel_10_analyzer_2_array_crystal_array_7=Union_box()\n"
"         (negative time, miss next components, rounding errors, Nan, Inf).\n", mcAbsorbProp[528]);
    if (!mcNCounter[529]) fprintf(stderr, "Warning: No neutron could reach Component[529] channel_10_analyzer_2_array_crystal_array_8\n");
    if (mcAbsorbProp[529]) fprintf(stderr, "Warning: %g events were removed in Component[529] channel_10_analyzer_2_array_crystal_array_8=Union_box()\n"
"         (negative time, miss next components, rounding errors, Nan, Inf).\n", mcAbsorbProp[529]);
    if (!mcNCounter[530]) fprintf(stderr, "Warning: No neutron could reach Component[530] channel_10_cave2_cyl1\n");
    if (mcAbsorbProp[530]) fprintf(stderr, "Warning: %g events were removed in Component[530] channel_10_cave2_cyl1=Union_cylinder()\n"
"         (negative time, miss next components, rounding errors, Nan, Inf).\n", mcAbsorbProp[530]);
    if (!mcNCounter[531]) fprintf(stderr, "Warning: No neutron could reach Component[531] channel_10_cave2_box1\n");
    if (mcAbsorbProp[531]) fprintf(stderr, "Warning: %g events were removed in Component[531] channel_10_cave2_box1=Union_box()\n"
"         (negative time, miss next components, rounding errors, Nan, Inf).\n", mcAbsorbProp[531]);
    if (!mcNCounter[532]) fprintf(stderr, "Warning: No neutron could reach Component[532] channel_10_cave2_box2\n");
    if (mcAbsorbProp[532]) fprintf(stderr, "Warning: %g events were removed in Component[532] channel_10_cave2_box2=Union_box()\n"
"         (negative time, miss next components, rounding errors, Nan, Inf).\n", mcAbsorbProp[532]);
    if (!mcNCounter[533]) fprintf(stderr, "Warning: No neutron could reach Component[533] channel_10_cave2_box3\n");
    if (mcAbsorbProp[533]) fprintf(stderr, "Warning: %g events were removed in Component[533] channel_10_cave2_box3=Union_box()\n"
"         (negative time, miss next components, rounding errors, Nan, Inf).\n", mcAbsorbProp[533]);
    if (!mcNCounter[534]) fprintf(stderr, "Warning: No neutron could reach Component[534] inter_analyzer_colimator_center_10\n");
    if (mcAbsorbProp[534]) fprintf(stderr, "Warning: %g events were removed in Component[534] inter_analyzer_colimator_center_10=Arm()\n"
"         (negative time, miss next components, rounding errors, Nan, Inf).\n", mcAbsorbProp[534]);
    if (!mcNCounter[535]) fprintf(stderr, "Warning: No neutron could reach Component[535] inter_analyzer_colimator_10_blade_0\n");
    if (mcAbsorbProp[535]) fprintf(stderr, "Warning: %g events were removed in Component[535] inter_analyzer_colimator_10_blade_0=Union_box()\n"
"         (negative time, miss next components, rounding errors, Nan, Inf).\n", mcAbsorbProp[535]);
    if (!mcNCounter[536]) fprintf(stderr, "Warning: No neutron could reach Component[536] inter_analyzer_colimator_10_blade_1\n");
    if (mcAbsorbProp[536]) fprintf(stderr, "Warning: %g events were removed in Component[536] inter_analyzer_colimator_10_blade_1=Union_box()\n"
"         (negative time, miss next components, rounding errors, Nan, Inf).\n", mcAbsorbProp[536]);
    if (!mcNCounter[537]) fprintf(stderr, "Warning: No neutron could reach Component[537] inter_analyzer_colimator_10_blade_2\n");
    if (mcAbsorbProp[537]) fprintf(stderr, "Warning: %g events were removed in Component[537] inter_analyzer_colimator_10_blade_2=Union_box()\n"
"         (negative time, miss next components, rounding errors, Nan, Inf).\n", mcAbsorbProp[537]);
    if (!mcNCounter[538]) fprintf(stderr, "Warning: No neutron could reach Component[538] inter_analyzer_colimator_10_blade_3\n");
    if (mcAbsorbProp[538]) fprintf(stderr, "Warning: %g events were removed in Component[538] inter_analyzer_colimator_10_blade_3=Union_box()\n"
"         (negative time, miss next components, rounding errors, Nan, Inf).\n", mcAbsorbProp[538]);
    if (!mcNCounter[539]) fprintf(stderr, "Warning: No neutron could reach Component[539] inter_analyzer_colimator_10_blade_4\n");
    if (mcAbsorbProp[539]) fprintf(stderr, "Warning: %g events were removed in Component[539] inter_analyzer_colimator_10_blade_4=Union_box()\n"
"         (negative time, miss next components, rounding errors, Nan, Inf).\n", mcAbsorbProp[539]);
    if (!mcNCounter[540]) fprintf(stderr, "Warning: No neutron could reach Component[540] diffraction_detector_10_exit_volume\n");
    if (mcAbsorbProp[540]) fprintf(stderr, "Warning: %g events were removed in Component[540] diffraction_detector_10_exit_volume=Union_box()\n"
"         (negative time, miss next components, rounding errors, Nan, Inf).\n", mcAbsorbProp[540]);
    if (!mcNCounter[541]) fprintf(stderr, "Warning: No neutron could reach Component[541] spec_detector_10_exit_volume\n");
    if (mcAbsorbProp[541]) fprintf(stderr, "Warning: %g events were removed in Component[541] spec_detector_10_exit_volume=Union_box()\n"
"         (negative time, miss next components, rounding errors, Nan, Inf).\n", mcAbsorbProp[541]);
    if (!mcNCounter[542]) fprintf(stderr, "Warning: No neutron could reach Component[542] channel_11_cave1_box1\n");
    if (mcAbsorbProp[542]) fprintf(stderr, "Warning: %g events were removed in Component[542] channel_11_cave1_box1=Union_box()\n"
"         (negative time, miss next components, rounding errors, Nan, Inf).\n", mcAbsorbProp[542]);
    if (!mcNCounter[543]) fprintf(stderr, "Warning: No neutron could reach Component[543] channel_11_cave1_box2\n");
    if (mcAbsorbProp[543]) fprintf(stderr, "Warning: %g events were removed in Component[543] channel_11_cave1_box2=Union_box()\n"
"         (negative time, miss next components, rounding errors, Nan, Inf).\n", mcAbsorbProp[543]);
    if (!mcNCounter[544]) fprintf(stderr, "Warning: No neutron could reach Component[544] channel_11_cave1_box3\n");
    if (mcAbsorbProp[544]) fprintf(stderr, "Warning: %g events were removed in Component[544] channel_11_cave1_box3=Union_box()\n"
"         (negative time, miss next components, rounding errors, Nan, Inf).\n", mcAbsorbProp[544]);
    if (!mcNCounter[545]) fprintf(stderr, "Warning: No neutron could reach Component[545] channel_11_cave1_cyl1\n");
    if (mcAbsorbProp[545]) fprintf(stderr, "Warning: %g events were removed in Component[545] channel_11_cave1_cyl1=Union_cylinder()\n"
"         (negative time, miss next components, rounding errors, Nan, Inf).\n", mcAbsorbProp[545]);
    if (!mcNCounter[546]) fprintf(stderr, "Warning: No neutron could reach Component[546] channel_11_analyzer_1_center\n");
    if (mcAbsorbProp[546]) fprintf(stderr, "Warning: %g events were removed in Component[546] channel_11_analyzer_1_center=Arm()\n"
"         (negative time, miss next components, rounding errors, Nan, Inf).\n", mcAbsorbProp[546]);
    if (!mcNCounter[547]) fprintf(stderr, "Warning: No neutron could reach Component[547] channel_11_analyzer_1_rotated\n");
    if (mcAbsorbProp[547]) fprintf(stderr, "Warning: %g events were removed in Component[547] channel_11_analyzer_1_rotated=Arm()\n"
"         (negative time, miss next components, rounding errors, Nan, Inf).\n", mcAbsorbProp[547]);
    if (!mcNCounter[548]) fprintf(stderr, "Warning: No neutron could reach Component[548] channel_11_analyzer_1_array_crystal_array_0\n");
    if (mcAbsorbProp[548]) fprintf(stderr, "Warning: %g events were removed in Component[548] channel_11_analyzer_1_array_crystal_array_0=Union_box()\n"
"         (negative time, miss next components, rounding errors, Nan, Inf).\n", mcAbsorbProp[548]);
    if (!mcNCounter[549]) fprintf(stderr, "Warning: No neutron could reach Component[549] channel_11_analyzer_1_array_crystal_array_1\n");
    if (mcAbsorbProp[549]) fprintf(stderr, "Warning: %g events were removed in Component[549] channel_11_analyzer_1_array_crystal_array_1=Union_box()\n"
"         (negative time, miss next components, rounding errors, Nan, Inf).\n", mcAbsorbProp[549]);
    if (!mcNCounter[550]) fprintf(stderr, "Warning: No neutron could reach Component[550] channel_11_analyzer_1_array_crystal_array_2\n");
    if (mcAbsorbProp[550]) fprintf(stderr, "Warning: %g events were removed in Component[550] channel_11_analyzer_1_array_crystal_array_2=Union_box()\n"
"         (negative time, miss next components, rounding errors, Nan, Inf).\n", mcAbsorbProp[550]);
    if (!mcNCounter[551]) fprintf(stderr, "Warning: No neutron could reach Component[551] channel_11_analyzer_1_array_crystal_array_3\n");
    if (mcAbsorbProp[551]) fprintf(stderr, "Warning: %g events were removed in Component[551] channel_11_analyzer_1_array_crystal_array_3=Union_box()\n"
"         (negative time, miss next components, rounding errors, Nan, Inf).\n", mcAbsorbProp[551]);
    if (!mcNCounter[552]) fprintf(stderr, "Warning: No neutron could reach Component[552] channel_11_analyzer_1_array_crystal_array_4\n");
    if (mcAbsorbProp[552]) fprintf(stderr, "Warning: %g events were removed in Component[552] channel_11_analyzer_1_array_crystal_array_4=Union_box()\n"
"         (negative time, miss next components, rounding errors, Nan, Inf).\n", mcAbsorbProp[552]);
    if (!mcNCounter[553]) fprintf(stderr, "Warning: No neutron could reach Component[553] channel_11_analyzer_1_array_crystal_array_5\n");
    if (mcAbsorbProp[553]) fprintf(stderr, "Warning: %g events were removed in Component[553] channel_11_analyzer_1_array_crystal_array_5=Union_box()\n"
"         (negative time, miss next components, rounding errors, Nan, Inf).\n", mcAbsorbProp[553]);
    if (!mcNCounter[554]) fprintf(stderr, "Warning: No neutron could reach Component[554] channel_11_analyzer_1_array_crystal_array_6\n");
    if (mcAbsorbProp[554]) fprintf(stderr, "Warning: %g events were removed in Component[554] channel_11_analyzer_1_array_crystal_array_6=Union_box()\n"
"         (negative time, miss next components, rounding errors, Nan, Inf).\n", mcAbsorbProp[554]);
    if (!mcNCounter[555]) fprintf(stderr, "Warning: No neutron could reach Component[555] channel_11_analyzer_1_array_crystal_array_7\n");
    if (mcAbsorbProp[555]) fprintf(stderr, "Warning: %g events were removed in Component[555] channel_11_analyzer_1_array_crystal_array_7=Union_box()\n"
"         (negative time, miss next components, rounding errors, Nan, Inf).\n", mcAbsorbProp[555]);
    if (!mcNCounter[556]) fprintf(stderr, "Warning: No neutron could reach Component[556] channel_11_analyzer_1_array_crystal_array_8\n");
    if (mcAbsorbProp[556]) fprintf(stderr, "Warning: %g events were removed in Component[556] channel_11_analyzer_1_array_crystal_array_8=Union_box()\n"
"         (negative time, miss next components, rounding errors, Nan, Inf).\n", mcAbsorbProp[556]);
    if (!mcNCounter[557]) fprintf(stderr, "Warning: No neutron could reach Component[557] channel_11_analyzer_2_center\n");
    if (mcAbsorbProp[557]) fprintf(stderr, "Warning: %g events were removed in Component[557] channel_11_analyzer_2_center=Arm()\n"
"         (negative time, miss next components, rounding errors, Nan, Inf).\n", mcAbsorbProp[557]);
    if (!mcNCounter[558]) fprintf(stderr, "Warning: No neutron could reach Component[558] channel_11_analyzer_2_rotated\n");
    if (mcAbsorbProp[558]) fprintf(stderr, "Warning: %g events were removed in Component[558] channel_11_analyzer_2_rotated=Arm()\n"
"         (negative time, miss next components, rounding errors, Nan, Inf).\n", mcAbsorbProp[558]);
    if (!mcNCounter[559]) fprintf(stderr, "Warning: No neutron could reach Component[559] channel_11_analyzer_2_array_crystal_array_0\n");
    if (mcAbsorbProp[559]) fprintf(stderr, "Warning: %g events were removed in Component[559] channel_11_analyzer_2_array_crystal_array_0=Union_box()\n"
"         (negative time, miss next components, rounding errors, Nan, Inf).\n", mcAbsorbProp[559]);
    if (!mcNCounter[560]) fprintf(stderr, "Warning: No neutron could reach Component[560] channel_11_analyzer_2_array_crystal_array_1\n");
    if (mcAbsorbProp[560]) fprintf(stderr, "Warning: %g events were removed in Component[560] channel_11_analyzer_2_array_crystal_array_1=Union_box()\n"
"         (negative time, miss next components, rounding errors, Nan, Inf).\n", mcAbsorbProp[560]);
    if (!mcNCounter[561]) fprintf(stderr, "Warning: No neutron could reach Component[561] channel_11_analyzer_2_array_crystal_array_2\n");
    if (mcAbsorbProp[561]) fprintf(stderr, "Warning: %g events were removed in Component[561] channel_11_analyzer_2_array_crystal_array_2=Union_box()\n"
"         (negative time, miss next components, rounding errors, Nan, Inf).\n", mcAbsorbProp[561]);
    if (!mcNCounter[562]) fprintf(stderr, "Warning: No neutron could reach Component[562] channel_11_analyzer_2_array_crystal_array_3\n");
    if (mcAbsorbProp[562]) fprintf(stderr, "Warning: %g events were removed in Component[562] channel_11_analyzer_2_array_crystal_array_3=Union_box()\n"
"         (negative time, miss next components, rounding errors, Nan, Inf).\n", mcAbsorbProp[562]);
    if (!mcNCounter[563]) fprintf(stderr, "Warning: No neutron could reach Component[563] channel_11_analyzer_2_array_crystal_array_4\n");
    if (mcAbsorbProp[563]) fprintf(stderr, "Warning: %g events were removed in Component[563] channel_11_analyzer_2_array_crystal_array_4=Union_box()\n"
"         (negative time, miss next components, rounding errors, Nan, Inf).\n", mcAbsorbProp[563]);
    if (!mcNCounter[564]) fprintf(stderr, "Warning: No neutron could reach Component[564] channel_11_analyzer_2_array_crystal_array_5\n");
    if (mcAbsorbProp[564]) fprintf(stderr, "Warning: %g events were removed in Component[564] channel_11_analyzer_2_array_crystal_array_5=Union_box()\n"
"         (negative time, miss next components, rounding errors, Nan, Inf).\n", mcAbsorbProp[564]);
    if (!mcNCounter[565]) fprintf(stderr, "Warning: No neutron could reach Component[565] channel_11_analyzer_2_array_crystal_array_6\n");
    if (mcAbsorbProp[565]) fprintf(stderr, "Warning: %g events were removed in Component[565] channel_11_analyzer_2_array_crystal_array_6=Union_box()\n"
"         (negative time, miss next components, rounding errors, Nan, Inf).\n", mcAbsorbProp[565]);
    if (!mcNCounter[566]) fprintf(stderr, "Warning: No neutron could reach Component[566] channel_11_analyzer_2_array_crystal_array_7\n");
    if (mcAbsorbProp[566]) fprintf(stderr, "Warning: %g events were removed in Component[566] channel_11_analyzer_2_array_crystal_array_7=Union_box()\n"
"         (negative time, miss next components, rounding errors, Nan, Inf).\n", mcAbsorbProp[566]);
    if (!mcNCounter[567]) fprintf(stderr, "Warning: No neutron could reach Component[567] channel_11_analyzer_2_array_crystal_array_8\n");
    if (mcAbsorbProp[567]) fprintf(stderr, "Warning: %g events were removed in Component[567] channel_11_analyzer_2_array_crystal_array_8=Union_box()\n"
"         (negative time, miss next components, rounding errors, Nan, Inf).\n", mcAbsorbProp[567]);
    if (!mcNCounter[568]) fprintf(stderr, "Warning: No neutron could reach Component[568] channel_11_cave2_cyl1\n");
    if (mcAbsorbProp[568]) fprintf(stderr, "Warning: %g events were removed in Component[568] channel_11_cave2_cyl1=Union_cylinder()\n"
"         (negative time, miss next components, rounding errors, Nan, Inf).\n", mcAbsorbProp[568]);
    if (!mcNCounter[569]) fprintf(stderr, "Warning: No neutron could reach Component[569] channel_11_cave2_box1\n");
    if (mcAbsorbProp[569]) fprintf(stderr, "Warning: %g events were removed in Component[569] channel_11_cave2_box1=Union_box()\n"
"         (negative time, miss next components, rounding errors, Nan, Inf).\n", mcAbsorbProp[569]);
    if (!mcNCounter[570]) fprintf(stderr, "Warning: No neutron could reach Component[570] channel_11_cave2_box2\n");
    if (mcAbsorbProp[570]) fprintf(stderr, "Warning: %g events were removed in Component[570] channel_11_cave2_box2=Union_box()\n"
"         (negative time, miss next components, rounding errors, Nan, Inf).\n", mcAbsorbProp[570]);
    if (!mcNCounter[571]) fprintf(stderr, "Warning: No neutron could reach Component[571] channel_11_cave2_box3\n");
    if (mcAbsorbProp[571]) fprintf(stderr, "Warning: %g events were removed in Component[571] channel_11_cave2_box3=Union_box()\n"
"         (negative time, miss next components, rounding errors, Nan, Inf).\n", mcAbsorbProp[571]);
    if (!mcNCounter[572]) fprintf(stderr, "Warning: No neutron could reach Component[572] inter_analyzer_colimator_center_11\n");
    if (mcAbsorbProp[572]) fprintf(stderr, "Warning: %g events were removed in Component[572] inter_analyzer_colimator_center_11=Arm()\n"
"         (negative time, miss next components, rounding errors, Nan, Inf).\n", mcAbsorbProp[572]);
    if (!mcNCounter[573]) fprintf(stderr, "Warning: No neutron could reach Component[573] inter_analyzer_colimator_11_blade_0\n");
    if (mcAbsorbProp[573]) fprintf(stderr, "Warning: %g events were removed in Component[573] inter_analyzer_colimator_11_blade_0=Union_box()\n"
"         (negative time, miss next components, rounding errors, Nan, Inf).\n", mcAbsorbProp[573]);
    if (!mcNCounter[574]) fprintf(stderr, "Warning: No neutron could reach Component[574] inter_analyzer_colimator_11_blade_1\n");
    if (mcAbsorbProp[574]) fprintf(stderr, "Warning: %g events were removed in Component[574] inter_analyzer_colimator_11_blade_1=Union_box()\n"
"         (negative time, miss next components, rounding errors, Nan, Inf).\n", mcAbsorbProp[574]);
    if (!mcNCounter[575]) fprintf(stderr, "Warning: No neutron could reach Component[575] inter_analyzer_colimator_11_blade_2\n");
    if (mcAbsorbProp[575]) fprintf(stderr, "Warning: %g events were removed in Component[575] inter_analyzer_colimator_11_blade_2=Union_box()\n"
"         (negative time, miss next components, rounding errors, Nan, Inf).\n", mcAbsorbProp[575]);
    if (!mcNCounter[576]) fprintf(stderr, "Warning: No neutron could reach Component[576] inter_analyzer_colimator_11_blade_3\n");
    if (mcAbsorbProp[576]) fprintf(stderr, "Warning: %g events were removed in Component[576] inter_analyzer_colimator_11_blade_3=Union_box()\n"
"         (negative time, miss next components, rounding errors, Nan, Inf).\n", mcAbsorbProp[576]);
    if (!mcNCounter[577]) fprintf(stderr, "Warning: No neutron could reach Component[577] inter_analyzer_colimator_11_blade_4\n");
    if (mcAbsorbProp[577]) fprintf(stderr, "Warning: %g events were removed in Component[577] inter_analyzer_colimator_11_blade_4=Union_box()\n"
"         (negative time, miss next components, rounding errors, Nan, Inf).\n", mcAbsorbProp[577]);
    if (!mcNCounter[578]) fprintf(stderr, "Warning: No neutron could reach Component[578] diffraction_detector_11_exit_volume\n");
    if (mcAbsorbProp[578]) fprintf(stderr, "Warning: %g events were removed in Component[578] diffraction_detector_11_exit_volume=Union_box()\n"
"         (negative time, miss next components, rounding errors, Nan, Inf).\n", mcAbsorbProp[578]);
    if (!mcNCounter[579]) fprintf(stderr, "Warning: No neutron could reach Component[579] spec_detector_11_exit_volume\n");
    if (mcAbsorbProp[579]) fprintf(stderr, "Warning: %g events were removed in Component[579] spec_detector_11_exit_volume=Union_box()\n"
"         (negative time, miss next components, rounding errors, Nan, Inf).\n", mcAbsorbProp[579]);
    if (!mcNCounter[580]) fprintf(stderr, "Warning: No neutron could reach Component[580] channel_12_cave1_box1\n");
    if (mcAbsorbProp[580]) fprintf(stderr, "Warning: %g events were removed in Component[580] channel_12_cave1_box1=Union_box()\n"
"         (negative time, miss next components, rounding errors, Nan, Inf).\n", mcAbsorbProp[580]);
    if (!mcNCounter[581]) fprintf(stderr, "Warning: No neutron could reach Component[581] channel_12_cave1_box2\n");
    if (mcAbsorbProp[581]) fprintf(stderr, "Warning: %g events were removed in Component[581] channel_12_cave1_box2=Union_box()\n"
"         (negative time, miss next components, rounding errors, Nan, Inf).\n", mcAbsorbProp[581]);
    if (!mcNCounter[582]) fprintf(stderr, "Warning: No neutron could reach Component[582] channel_12_cave1_box3\n");
    if (mcAbsorbProp[582]) fprintf(stderr, "Warning: %g events were removed in Component[582] channel_12_cave1_box3=Union_box()\n"
"         (negative time, miss next components, rounding errors, Nan, Inf).\n", mcAbsorbProp[582]);
    if (!mcNCounter[583]) fprintf(stderr, "Warning: No neutron could reach Component[583] channel_12_cave1_cyl1\n");
    if (mcAbsorbProp[583]) fprintf(stderr, "Warning: %g events were removed in Component[583] channel_12_cave1_cyl1=Union_cylinder()\n"
"         (negative time, miss next components, rounding errors, Nan, Inf).\n", mcAbsorbProp[583]);
    if (!mcNCounter[584]) fprintf(stderr, "Warning: No neutron could reach Component[584] channel_12_analyzer_1_center\n");
    if (mcAbsorbProp[584]) fprintf(stderr, "Warning: %g events were removed in Component[584] channel_12_analyzer_1_center=Arm()\n"
"         (negative time, miss next components, rounding errors, Nan, Inf).\n", mcAbsorbProp[584]);
    if (!mcNCounter[585]) fprintf(stderr, "Warning: No neutron could reach Component[585] channel_12_analyzer_1_rotated\n");
    if (mcAbsorbProp[585]) fprintf(stderr, "Warning: %g events were removed in Component[585] channel_12_analyzer_1_rotated=Arm()\n"
"         (negative time, miss next components, rounding errors, Nan, Inf).\n", mcAbsorbProp[585]);
    if (!mcNCounter[586]) fprintf(stderr, "Warning: No neutron could reach Component[586] channel_12_analyzer_1_array_crystal_array_0\n");
    if (mcAbsorbProp[586]) fprintf(stderr, "Warning: %g events were removed in Component[586] channel_12_analyzer_1_array_crystal_array_0=Union_box()\n"
"         (negative time, miss next components, rounding errors, Nan, Inf).\n", mcAbsorbProp[586]);
    if (!mcNCounter[587]) fprintf(stderr, "Warning: No neutron could reach Component[587] channel_12_analyzer_1_array_crystal_array_1\n");
    if (mcAbsorbProp[587]) fprintf(stderr, "Warning: %g events were removed in Component[587] channel_12_analyzer_1_array_crystal_array_1=Union_box()\n"
"         (negative time, miss next components, rounding errors, Nan, Inf).\n", mcAbsorbProp[587]);
    if (!mcNCounter[588]) fprintf(stderr, "Warning: No neutron could reach Component[588] channel_12_analyzer_1_array_crystal_array_2\n");
    if (mcAbsorbProp[588]) fprintf(stderr, "Warning: %g events were removed in Component[588] channel_12_analyzer_1_array_crystal_array_2=Union_box()\n"
"         (negative time, miss next components, rounding errors, Nan, Inf).\n", mcAbsorbProp[588]);
    if (!mcNCounter[589]) fprintf(stderr, "Warning: No neutron could reach Component[589] channel_12_analyzer_1_array_crystal_array_3\n");
    if (mcAbsorbProp[589]) fprintf(stderr, "Warning: %g events were removed in Component[589] channel_12_analyzer_1_array_crystal_array_3=Union_box()\n"
"         (negative time, miss next components, rounding errors, Nan, Inf).\n", mcAbsorbProp[589]);
    if (!mcNCounter[590]) fprintf(stderr, "Warning: No neutron could reach Component[590] channel_12_analyzer_1_array_crystal_array_4\n");
    if (mcAbsorbProp[590]) fprintf(stderr, "Warning: %g events were removed in Component[590] channel_12_analyzer_1_array_crystal_array_4=Union_box()\n"
"         (negative time, miss next components, rounding errors, Nan, Inf).\n", mcAbsorbProp[590]);
    if (!mcNCounter[591]) fprintf(stderr, "Warning: No neutron could reach Component[591] channel_12_analyzer_1_array_crystal_array_5\n");
    if (mcAbsorbProp[591]) fprintf(stderr, "Warning: %g events were removed in Component[591] channel_12_analyzer_1_array_crystal_array_5=Union_box()\n"
"         (negative time, miss next components, rounding errors, Nan, Inf).\n", mcAbsorbProp[591]);
    if (!mcNCounter[592]) fprintf(stderr, "Warning: No neutron could reach Component[592] channel_12_analyzer_1_array_crystal_array_6\n");
    if (mcAbsorbProp[592]) fprintf(stderr, "Warning: %g events were removed in Component[592] channel_12_analyzer_1_array_crystal_array_6=Union_box()\n"
"         (negative time, miss next components, rounding errors, Nan, Inf).\n", mcAbsorbProp[592]);
    if (!mcNCounter[593]) fprintf(stderr, "Warning: No neutron could reach Component[593] channel_12_analyzer_1_array_crystal_array_7\n");
    if (mcAbsorbProp[593]) fprintf(stderr, "Warning: %g events were removed in Component[593] channel_12_analyzer_1_array_crystal_array_7=Union_box()\n"
"         (negative time, miss next components, rounding errors, Nan, Inf).\n", mcAbsorbProp[593]);
    if (!mcNCounter[594]) fprintf(stderr, "Warning: No neutron could reach Component[594] channel_12_analyzer_1_array_crystal_array_8\n");
    if (mcAbsorbProp[594]) fprintf(stderr, "Warning: %g events were removed in Component[594] channel_12_analyzer_1_array_crystal_array_8=Union_box()\n"
"         (negative time, miss next components, rounding errors, Nan, Inf).\n", mcAbsorbProp[594]);
    if (!mcNCounter[595]) fprintf(stderr, "Warning: No neutron could reach Component[595] channel_12_analyzer_2_center\n");
    if (mcAbsorbProp[595]) fprintf(stderr, "Warning: %g events were removed in Component[595] channel_12_analyzer_2_center=Arm()\n"
"         (negative time, miss next components, rounding errors, Nan, Inf).\n", mcAbsorbProp[595]);
    if (!mcNCounter[596]) fprintf(stderr, "Warning: No neutron could reach Component[596] channel_12_analyzer_2_rotated\n");
    if (mcAbsorbProp[596]) fprintf(stderr, "Warning: %g events were removed in Component[596] channel_12_analyzer_2_rotated=Arm()\n"
"         (negative time, miss next components, rounding errors, Nan, Inf).\n", mcAbsorbProp[596]);
    if (!mcNCounter[597]) fprintf(stderr, "Warning: No neutron could reach Component[597] channel_12_analyzer_2_array_crystal_array_0\n");
    if (mcAbsorbProp[597]) fprintf(stderr, "Warning: %g events were removed in Component[597] channel_12_analyzer_2_array_crystal_array_0=Union_box()\n"
"         (negative time, miss next components, rounding errors, Nan, Inf).\n", mcAbsorbProp[597]);
    if (!mcNCounter[598]) fprintf(stderr, "Warning: No neutron could reach Component[598] channel_12_analyzer_2_array_crystal_array_1\n");
    if (mcAbsorbProp[598]) fprintf(stderr, "Warning: %g events were removed in Component[598] channel_12_analyzer_2_array_crystal_array_1=Union_box()\n"
"         (negative time, miss next components, rounding errors, Nan, Inf).\n", mcAbsorbProp[598]);
    if (!mcNCounter[599]) fprintf(stderr, "Warning: No neutron could reach Component[599] channel_12_analyzer_2_array_crystal_array_2\n");
    if (mcAbsorbProp[599]) fprintf(stderr, "Warning: %g events were removed in Component[599] channel_12_analyzer_2_array_crystal_array_2=Union_box()\n"
"         (negative time, miss next components, rounding errors, Nan, Inf).\n", mcAbsorbProp[599]);
    if (!mcNCounter[600]) fprintf(stderr, "Warning: No neutron could reach Component[600] channel_12_analyzer_2_array_crystal_array_3\n");
    if (mcAbsorbProp[600]) fprintf(stderr, "Warning: %g events were removed in Component[600] channel_12_analyzer_2_array_crystal_array_3=Union_box()\n"
"         (negative time, miss next components, rounding errors, Nan, Inf).\n", mcAbsorbProp[600]);
    if (!mcNCounter[601]) fprintf(stderr, "Warning: No neutron could reach Component[601] channel_12_analyzer_2_array_crystal_array_4\n");
    if (mcAbsorbProp[601]) fprintf(stderr, "Warning: %g events were removed in Component[601] channel_12_analyzer_2_array_crystal_array_4=Union_box()\n"
"         (negative time, miss next components, rounding errors, Nan, Inf).\n", mcAbsorbProp[601]);
    if (!mcNCounter[602]) fprintf(stderr, "Warning: No neutron could reach Component[602] channel_12_analyzer_2_array_crystal_array_5\n");
    if (mcAbsorbProp[602]) fprintf(stderr, "Warning: %g events were removed in Component[602] channel_12_analyzer_2_array_crystal_array_5=Union_box()\n"
"         (negative time, miss next components, rounding errors, Nan, Inf).\n", mcAbsorbProp[602]);
    if (!mcNCounter[603]) fprintf(stderr, "Warning: No neutron could reach Component[603] channel_12_analyzer_2_array_crystal_array_6\n");
    if (mcAbsorbProp[603]) fprintf(stderr, "Warning: %g events were removed in Component[603] channel_12_analyzer_2_array_crystal_array_6=Union_box()\n"
"         (negative time, miss next components, rounding errors, Nan, Inf).\n", mcAbsorbProp[603]);
    if (!mcNCounter[604]) fprintf(stderr, "Warning: No neutron could reach Component[604] channel_12_analyzer_2_array_crystal_array_7\n");
    if (mcAbsorbProp[604]) fprintf(stderr, "Warning: %g events were removed in Component[604] channel_12_analyzer_2_array_crystal_array_7=Union_box()\n"
"         (negative time, miss next components, rounding errors, Nan, Inf).\n", mcAbsorbProp[604]);
    if (!mcNCounter[605]) fprintf(stderr, "Warning: No neutron could reach Component[605] channel_12_analyzer_2_array_crystal_array_8\n");
    if (mcAbsorbProp[605]) fprintf(stderr, "Warning: %g events were removed in Component[605] channel_12_analyzer_2_array_crystal_array_8=Union_box()\n"
"         (negative time, miss next components, rounding errors, Nan, Inf).\n", mcAbsorbProp[605]);
    if (!mcNCounter[606]) fprintf(stderr, "Warning: No neutron could reach Component[606] channel_12_cave2_cyl1\n");
    if (mcAbsorbProp[606]) fprintf(stderr, "Warning: %g events were removed in Component[606] channel_12_cave2_cyl1=Union_cylinder()\n"
"         (negative time, miss next components, rounding errors, Nan, Inf).\n", mcAbsorbProp[606]);
    if (!mcNCounter[607]) fprintf(stderr, "Warning: No neutron could reach Component[607] channel_12_cave2_box1\n");
    if (mcAbsorbProp[607]) fprintf(stderr, "Warning: %g events were removed in Component[607] channel_12_cave2_box1=Union_box()\n"
"         (negative time, miss next components, rounding errors, Nan, Inf).\n", mcAbsorbProp[607]);
    if (!mcNCounter[608]) fprintf(stderr, "Warning: No neutron could reach Component[608] channel_12_cave2_box2\n");
    if (mcAbsorbProp[608]) fprintf(stderr, "Warning: %g events were removed in Component[608] channel_12_cave2_box2=Union_box()\n"
"         (negative time, miss next components, rounding errors, Nan, Inf).\n", mcAbsorbProp[608]);
    if (!mcNCounter[609]) fprintf(stderr, "Warning: No neutron could reach Component[609] channel_12_cave2_box3\n");
    if (mcAbsorbProp[609]) fprintf(stderr, "Warning: %g events were removed in Component[609] channel_12_cave2_box3=Union_box()\n"
"         (negative time, miss next components, rounding errors, Nan, Inf).\n", mcAbsorbProp[609]);
    if (!mcNCounter[610]) fprintf(stderr, "Warning: No neutron could reach Component[610] inter_analyzer_colimator_center_12\n");
    if (mcAbsorbProp[610]) fprintf(stderr, "Warning: %g events were removed in Component[610] inter_analyzer_colimator_center_12=Arm()\n"
"         (negative time, miss next components, rounding errors, Nan, Inf).\n", mcAbsorbProp[610]);
    if (!mcNCounter[611]) fprintf(stderr, "Warning: No neutron could reach Component[611] inter_analyzer_colimator_12_blade_0\n");
    if (mcAbsorbProp[611]) fprintf(stderr, "Warning: %g events were removed in Component[611] inter_analyzer_colimator_12_blade_0=Union_box()\n"
"         (negative time, miss next components, rounding errors, Nan, Inf).\n", mcAbsorbProp[611]);
    if (!mcNCounter[612]) fprintf(stderr, "Warning: No neutron could reach Component[612] inter_analyzer_colimator_12_blade_1\n");
    if (mcAbsorbProp[612]) fprintf(stderr, "Warning: %g events were removed in Component[612] inter_analyzer_colimator_12_blade_1=Union_box()\n"
"         (negative time, miss next components, rounding errors, Nan, Inf).\n", mcAbsorbProp[612]);
    if (!mcNCounter[613]) fprintf(stderr, "Warning: No neutron could reach Component[613] inter_analyzer_colimator_12_blade_2\n");
    if (mcAbsorbProp[613]) fprintf(stderr, "Warning: %g events were removed in Component[613] inter_analyzer_colimator_12_blade_2=Union_box()\n"
"         (negative time, miss next components, rounding errors, Nan, Inf).\n", mcAbsorbProp[613]);
    if (!mcNCounter[614]) fprintf(stderr, "Warning: No neutron could reach Component[614] inter_analyzer_colimator_12_blade_3\n");
    if (mcAbsorbProp[614]) fprintf(stderr, "Warning: %g events were removed in Component[614] inter_analyzer_colimator_12_blade_3=Union_box()\n"
"         (negative time, miss next components, rounding errors, Nan, Inf).\n", mcAbsorbProp[614]);
    if (!mcNCounter[615]) fprintf(stderr, "Warning: No neutron could reach Component[615] inter_analyzer_colimator_12_blade_4\n");
    if (mcAbsorbProp[615]) fprintf(stderr, "Warning: %g events were removed in Component[615] inter_analyzer_colimator_12_blade_4=Union_box()\n"
"         (negative time, miss next components, rounding errors, Nan, Inf).\n", mcAbsorbProp[615]);
    if (!mcNCounter[616]) fprintf(stderr, "Warning: No neutron could reach Component[616] diffraction_detector_12_exit_volume\n");
    if (mcAbsorbProp[616]) fprintf(stderr, "Warning: %g events were removed in Component[616] diffraction_detector_12_exit_volume=Union_box()\n"
"         (negative time, miss next components, rounding errors, Nan, Inf).\n", mcAbsorbProp[616]);
    if (!mcNCounter[617]) fprintf(stderr, "Warning: No neutron could reach Component[617] spec_detector_12_exit_volume\n");
    if (mcAbsorbProp[617]) fprintf(stderr, "Warning: %g events were removed in Component[617] spec_detector_12_exit_volume=Union_box()\n"
"         (negative time, miss next components, rounding errors, Nan, Inf).\n", mcAbsorbProp[617]);
    if (!mcNCounter[618]) fprintf(stderr, "Warning: No neutron could reach Component[618] channel_13_cave1_box1\n");
    if (mcAbsorbProp[618]) fprintf(stderr, "Warning: %g events were removed in Component[618] channel_13_cave1_box1=Union_box()\n"
"         (negative time, miss next components, rounding errors, Nan, Inf).\n", mcAbsorbProp[618]);
    if (!mcNCounter[619]) fprintf(stderr, "Warning: No neutron could reach Component[619] channel_13_cave1_box2\n");
    if (mcAbsorbProp[619]) fprintf(stderr, "Warning: %g events were removed in Component[619] channel_13_cave1_box2=Union_box()\n"
"         (negative time, miss next components, rounding errors, Nan, Inf).\n", mcAbsorbProp[619]);
    if (!mcNCounter[620]) fprintf(stderr, "Warning: No neutron could reach Component[620] channel_13_cave1_box3\n");
    if (mcAbsorbProp[620]) fprintf(stderr, "Warning: %g events were removed in Component[620] channel_13_cave1_box3=Union_box()\n"
"         (negative time, miss next components, rounding errors, Nan, Inf).\n", mcAbsorbProp[620]);
    if (!mcNCounter[621]) fprintf(stderr, "Warning: No neutron could reach Component[621] channel_13_cave1_cyl1\n");
    if (mcAbsorbProp[621]) fprintf(stderr, "Warning: %g events were removed in Component[621] channel_13_cave1_cyl1=Union_cylinder()\n"
"         (negative time, miss next components, rounding errors, Nan, Inf).\n", mcAbsorbProp[621]);
    if (!mcNCounter[622]) fprintf(stderr, "Warning: No neutron could reach Component[622] channel_13_analyzer_1_center\n");
    if (mcAbsorbProp[622]) fprintf(stderr, "Warning: %g events were removed in Component[622] channel_13_analyzer_1_center=Arm()\n"
"         (negative time, miss next components, rounding errors, Nan, Inf).\n", mcAbsorbProp[622]);
    if (!mcNCounter[623]) fprintf(stderr, "Warning: No neutron could reach Component[623] channel_13_analyzer_1_rotated\n");
    if (mcAbsorbProp[623]) fprintf(stderr, "Warning: %g events were removed in Component[623] channel_13_analyzer_1_rotated=Arm()\n"
"         (negative time, miss next components, rounding errors, Nan, Inf).\n", mcAbsorbProp[623]);
    if (!mcNCounter[624]) fprintf(stderr, "Warning: No neutron could reach Component[624] channel_13_analyzer_1_array_crystal_array_0\n");
    if (mcAbsorbProp[624]) fprintf(stderr, "Warning: %g events were removed in Component[624] channel_13_analyzer_1_array_crystal_array_0=Union_box()\n"
"         (negative time, miss next components, rounding errors, Nan, Inf).\n", mcAbsorbProp[624]);
    if (!mcNCounter[625]) fprintf(stderr, "Warning: No neutron could reach Component[625] channel_13_analyzer_1_array_crystal_array_1\n");
    if (mcAbsorbProp[625]) fprintf(stderr, "Warning: %g events were removed in Component[625] channel_13_analyzer_1_array_crystal_array_1=Union_box()\n"
"         (negative time, miss next components, rounding errors, Nan, Inf).\n", mcAbsorbProp[625]);
    if (!mcNCounter[626]) fprintf(stderr, "Warning: No neutron could reach Component[626] channel_13_analyzer_1_array_crystal_array_2\n");
    if (mcAbsorbProp[626]) fprintf(stderr, "Warning: %g events were removed in Component[626] channel_13_analyzer_1_array_crystal_array_2=Union_box()\n"
"         (negative time, miss next components, rounding errors, Nan, Inf).\n", mcAbsorbProp[626]);
    if (!mcNCounter[627]) fprintf(stderr, "Warning: No neutron could reach Component[627] channel_13_analyzer_1_array_crystal_array_3\n");
    if (mcAbsorbProp[627]) fprintf(stderr, "Warning: %g events were removed in Component[627] channel_13_analyzer_1_array_crystal_array_3=Union_box()\n"
"         (negative time, miss next components, rounding errors, Nan, Inf).\n", mcAbsorbProp[627]);
    if (!mcNCounter[628]) fprintf(stderr, "Warning: No neutron could reach Component[628] channel_13_analyzer_1_array_crystal_array_4\n");
    if (mcAbsorbProp[628]) fprintf(stderr, "Warning: %g events were removed in Component[628] channel_13_analyzer_1_array_crystal_array_4=Union_box()\n"
"         (negative time, miss next components, rounding errors, Nan, Inf).\n", mcAbsorbProp[628]);
    if (!mcNCounter[629]) fprintf(stderr, "Warning: No neutron could reach Component[629] channel_13_analyzer_1_array_crystal_array_5\n");
    if (mcAbsorbProp[629]) fprintf(stderr, "Warning: %g events were removed in Component[629] channel_13_analyzer_1_array_crystal_array_5=Union_box()\n"
"         (negative time, miss next components, rounding errors, Nan, Inf).\n", mcAbsorbProp[629]);
    if (!mcNCounter[630]) fprintf(stderr, "Warning: No neutron could reach Component[630] channel_13_analyzer_1_array_crystal_array_6\n");
    if (mcAbsorbProp[630]) fprintf(stderr, "Warning: %g events were removed in Component[630] channel_13_analyzer_1_array_crystal_array_6=Union_box()\n"
"         (negative time, miss next components, rounding errors, Nan, Inf).\n", mcAbsorbProp[630]);
    if (!mcNCounter[631]) fprintf(stderr, "Warning: No neutron could reach Component[631] channel_13_analyzer_1_array_crystal_array_7\n");
    if (mcAbsorbProp[631]) fprintf(stderr, "Warning: %g events were removed in Component[631] channel_13_analyzer_1_array_crystal_array_7=Union_box()\n"
"         (negative time, miss next components, rounding errors, Nan, Inf).\n", mcAbsorbProp[631]);
    if (!mcNCounter[632]) fprintf(stderr, "Warning: No neutron could reach Component[632] channel_13_analyzer_1_array_crystal_array_8\n");
    if (mcAbsorbProp[632]) fprintf(stderr, "Warning: %g events were removed in Component[632] channel_13_analyzer_1_array_crystal_array_8=Union_box()\n"
"         (negative time, miss next components, rounding errors, Nan, Inf).\n", mcAbsorbProp[632]);
    if (!mcNCounter[633]) fprintf(stderr, "Warning: No neutron could reach Component[633] channel_13_analyzer_2_center\n");
    if (mcAbsorbProp[633]) fprintf(stderr, "Warning: %g events were removed in Component[633] channel_13_analyzer_2_center=Arm()\n"
"         (negative time, miss next components, rounding errors, Nan, Inf).\n", mcAbsorbProp[633]);
    if (!mcNCounter[634]) fprintf(stderr, "Warning: No neutron could reach Component[634] channel_13_analyzer_2_rotated\n");
    if (mcAbsorbProp[634]) fprintf(stderr, "Warning: %g events were removed in Component[634] channel_13_analyzer_2_rotated=Arm()\n"
"         (negative time, miss next components, rounding errors, Nan, Inf).\n", mcAbsorbProp[634]);
    if (!mcNCounter[635]) fprintf(stderr, "Warning: No neutron could reach Component[635] channel_13_analyzer_2_array_crystal_array_0\n");
    if (mcAbsorbProp[635]) fprintf(stderr, "Warning: %g events were removed in Component[635] channel_13_analyzer_2_array_crystal_array_0=Union_box()\n"
"         (negative time, miss next components, rounding errors, Nan, Inf).\n", mcAbsorbProp[635]);
    if (!mcNCounter[636]) fprintf(stderr, "Warning: No neutron could reach Component[636] channel_13_analyzer_2_array_crystal_array_1\n");
    if (mcAbsorbProp[636]) fprintf(stderr, "Warning: %g events were removed in Component[636] channel_13_analyzer_2_array_crystal_array_1=Union_box()\n"
"         (negative time, miss next components, rounding errors, Nan, Inf).\n", mcAbsorbProp[636]);
    if (!mcNCounter[637]) fprintf(stderr, "Warning: No neutron could reach Component[637] channel_13_analyzer_2_array_crystal_array_2\n");
    if (mcAbsorbProp[637]) fprintf(stderr, "Warning: %g events were removed in Component[637] channel_13_analyzer_2_array_crystal_array_2=Union_box()\n"
"         (negative time, miss next components, rounding errors, Nan, Inf).\n", mcAbsorbProp[637]);
    if (!mcNCounter[638]) fprintf(stderr, "Warning: No neutron could reach Component[638] channel_13_analyzer_2_array_crystal_array_3\n");
    if (mcAbsorbProp[638]) fprintf(stderr, "Warning: %g events were removed in Component[638] channel_13_analyzer_2_array_crystal_array_3=Union_box()\n"
"         (negative time, miss next components, rounding errors, Nan, Inf).\n", mcAbsorbProp[638]);
    if (!mcNCounter[639]) fprintf(stderr, "Warning: No neutron could reach Component[639] channel_13_analyzer_2_array_crystal_array_4\n");
    if (mcAbsorbProp[639]) fprintf(stderr, "Warning: %g events were removed in Component[639] channel_13_analyzer_2_array_crystal_array_4=Union_box()\n"
"         (negative time, miss next components, rounding errors, Nan, Inf).\n", mcAbsorbProp[639]);
    if (!mcNCounter[640]) fprintf(stderr, "Warning: No neutron could reach Component[640] channel_13_analyzer_2_array_crystal_array_5\n");
    if (mcAbsorbProp[640]) fprintf(stderr, "Warning: %g events were removed in Component[640] channel_13_analyzer_2_array_crystal_array_5=Union_box()\n"
"         (negative time, miss next components, rounding errors, Nan, Inf).\n", mcAbsorbProp[640]);
    if (!mcNCounter[641]) fprintf(stderr, "Warning: No neutron could reach Component[641] channel_13_analyzer_2_array_crystal_array_6\n");
    if (mcAbsorbProp[641]) fprintf(stderr, "Warning: %g events were removed in Component[641] channel_13_analyzer_2_array_crystal_array_6=Union_box()\n"
"         (negative time, miss next components, rounding errors, Nan, Inf).\n", mcAbsorbProp[641]);
    if (!mcNCounter[642]) fprintf(stderr, "Warning: No neutron could reach Component[642] channel_13_analyzer_2_array_crystal_array_7\n");
    if (mcAbsorbProp[642]) fprintf(stderr, "Warning: %g events were removed in Component[642] channel_13_analyzer_2_array_crystal_array_7=Union_box()\n"
"         (negative time, miss next components, rounding errors, Nan, Inf).\n", mcAbsorbProp[642]);
    if (!mcNCounter[643]) fprintf(stderr, "Warning: No neutron could reach Component[643] channel_13_analyzer_2_array_crystal_array_8\n");
    if (mcAbsorbProp[643]) fprintf(stderr, "Warning: %g events were removed in Component[643] channel_13_analyzer_2_array_crystal_array_8=Union_box()\n"
"         (negative time, miss next components, rounding errors, Nan, Inf).\n", mcAbsorbProp[643]);
    if (!mcNCounter[644]) fprintf(stderr, "Warning: No neutron could reach Component[644] channel_13_cave2_cyl1\n");
    if (mcAbsorbProp[644]) fprintf(stderr, "Warning: %g events were removed in Component[644] channel_13_cave2_cyl1=Union_cylinder()\n"
"         (negative time, miss next components, rounding errors, Nan, Inf).\n", mcAbsorbProp[644]);
    if (!mcNCounter[645]) fprintf(stderr, "Warning: No neutron could reach Component[645] channel_13_cave2_box1\n");
    if (mcAbsorbProp[645]) fprintf(stderr, "Warning: %g events were removed in Component[645] channel_13_cave2_box1=Union_box()\n"
"         (negative time, miss next components, rounding errors, Nan, Inf).\n", mcAbsorbProp[645]);
    if (!mcNCounter[646]) fprintf(stderr, "Warning: No neutron could reach Component[646] channel_13_cave2_box2\n");
    if (mcAbsorbProp[646]) fprintf(stderr, "Warning: %g events were removed in Component[646] channel_13_cave2_box2=Union_box()\n"
"         (negative time, miss next components, rounding errors, Nan, Inf).\n", mcAbsorbProp[646]);
    if (!mcNCounter[647]) fprintf(stderr, "Warning: No neutron could reach Component[647] channel_13_cave2_box3\n");
    if (mcAbsorbProp[647]) fprintf(stderr, "Warning: %g events were removed in Component[647] channel_13_cave2_box3=Union_box()\n"
"         (negative time, miss next components, rounding errors, Nan, Inf).\n", mcAbsorbProp[647]);
    if (!mcNCounter[648]) fprintf(stderr, "Warning: No neutron could reach Component[648] inter_analyzer_colimator_center_13\n");
    if (mcAbsorbProp[648]) fprintf(stderr, "Warning: %g events were removed in Component[648] inter_analyzer_colimator_center_13=Arm()\n"
"         (negative time, miss next components, rounding errors, Nan, Inf).\n", mcAbsorbProp[648]);
    if (!mcNCounter[649]) fprintf(stderr, "Warning: No neutron could reach Component[649] inter_analyzer_colimator_13_blade_0\n");
    if (mcAbsorbProp[649]) fprintf(stderr, "Warning: %g events were removed in Component[649] inter_analyzer_colimator_13_blade_0=Union_box()\n"
"         (negative time, miss next components, rounding errors, Nan, Inf).\n", mcAbsorbProp[649]);
    if (!mcNCounter[650]) fprintf(stderr, "Warning: No neutron could reach Component[650] inter_analyzer_colimator_13_blade_1\n");
    if (mcAbsorbProp[650]) fprintf(stderr, "Warning: %g events were removed in Component[650] inter_analyzer_colimator_13_blade_1=Union_box()\n"
"         (negative time, miss next components, rounding errors, Nan, Inf).\n", mcAbsorbProp[650]);
    if (!mcNCounter[651]) fprintf(stderr, "Warning: No neutron could reach Component[651] inter_analyzer_colimator_13_blade_2\n");
    if (mcAbsorbProp[651]) fprintf(stderr, "Warning: %g events were removed in Component[651] inter_analyzer_colimator_13_blade_2=Union_box()\n"
"         (negative time, miss next components, rounding errors, Nan, Inf).\n", mcAbsorbProp[651]);
    if (!mcNCounter[652]) fprintf(stderr, "Warning: No neutron could reach Component[652] inter_analyzer_colimator_13_blade_3\n");
    if (mcAbsorbProp[652]) fprintf(stderr, "Warning: %g events were removed in Component[652] inter_analyzer_colimator_13_blade_3=Union_box()\n"
"         (negative time, miss next components, rounding errors, Nan, Inf).\n", mcAbsorbProp[652]);
    if (!mcNCounter[653]) fprintf(stderr, "Warning: No neutron could reach Component[653] inter_analyzer_colimator_13_blade_4\n");
    if (mcAbsorbProp[653]) fprintf(stderr, "Warning: %g events were removed in Component[653] inter_analyzer_colimator_13_blade_4=Union_box()\n"
"         (negative time, miss next components, rounding errors, Nan, Inf).\n", mcAbsorbProp[653]);
    if (!mcNCounter[654]) fprintf(stderr, "Warning: No neutron could reach Component[654] diffraction_detector_13_exit_volume\n");
    if (mcAbsorbProp[654]) fprintf(stderr, "Warning: %g events were removed in Component[654] diffraction_detector_13_exit_volume=Union_box()\n"
"         (negative time, miss next components, rounding errors, Nan, Inf).\n", mcAbsorbProp[654]);
    if (!mcNCounter[655]) fprintf(stderr, "Warning: No neutron could reach Component[655] spec_detector_13_exit_volume\n");
    if (mcAbsorbProp[655]) fprintf(stderr, "Warning: %g events were removed in Component[655] spec_detector_13_exit_volume=Union_box()\n"
"         (negative time, miss next components, rounding errors, Nan, Inf).\n", mcAbsorbProp[655]);
    if (!mcNCounter[656]) fprintf(stderr, "Warning: No neutron could reach Component[656] channel_14_cave1_box1\n");
    if (mcAbsorbProp[656]) fprintf(stderr, "Warning: %g events were removed in Component[656] channel_14_cave1_box1=Union_box()\n"
"         (negative time, miss next components, rounding errors, Nan, Inf).\n", mcAbsorbProp[656]);
    if (!mcNCounter[657]) fprintf(stderr, "Warning: No neutron could reach Component[657] channel_14_cave1_box2\n");
    if (mcAbsorbProp[657]) fprintf(stderr, "Warning: %g events were removed in Component[657] channel_14_cave1_box2=Union_box()\n"
"         (negative time, miss next components, rounding errors, Nan, Inf).\n", mcAbsorbProp[657]);
    if (!mcNCounter[658]) fprintf(stderr, "Warning: No neutron could reach Component[658] channel_14_cave1_box3\n");
    if (mcAbsorbProp[658]) fprintf(stderr, "Warning: %g events were removed in Component[658] channel_14_cave1_box3=Union_box()\n"
"         (negative time, miss next components, rounding errors, Nan, Inf).\n", mcAbsorbProp[658]);
    if (!mcNCounter[659]) fprintf(stderr, "Warning: No neutron could reach Component[659] channel_14_cave1_cyl1\n");
    if (mcAbsorbProp[659]) fprintf(stderr, "Warning: %g events were removed in Component[659] channel_14_cave1_cyl1=Union_cylinder()\n"
"         (negative time, miss next components, rounding errors, Nan, Inf).\n", mcAbsorbProp[659]);
    if (!mcNCounter[660]) fprintf(stderr, "Warning: No neutron could reach Component[660] channel_14_analyzer_1_center\n");
    if (mcAbsorbProp[660]) fprintf(stderr, "Warning: %g events were removed in Component[660] channel_14_analyzer_1_center=Arm()\n"
"         (negative time, miss next components, rounding errors, Nan, Inf).\n", mcAbsorbProp[660]);
    if (!mcNCounter[661]) fprintf(stderr, "Warning: No neutron could reach Component[661] channel_14_analyzer_1_rotated\n");
    if (mcAbsorbProp[661]) fprintf(stderr, "Warning: %g events were removed in Component[661] channel_14_analyzer_1_rotated=Arm()\n"
"         (negative time, miss next components, rounding errors, Nan, Inf).\n", mcAbsorbProp[661]);
    if (!mcNCounter[662]) fprintf(stderr, "Warning: No neutron could reach Component[662] channel_14_analyzer_1_array_crystal_array_0\n");
    if (mcAbsorbProp[662]) fprintf(stderr, "Warning: %g events were removed in Component[662] channel_14_analyzer_1_array_crystal_array_0=Union_box()\n"
"         (negative time, miss next components, rounding errors, Nan, Inf).\n", mcAbsorbProp[662]);
    if (!mcNCounter[663]) fprintf(stderr, "Warning: No neutron could reach Component[663] channel_14_analyzer_1_array_crystal_array_1\n");
    if (mcAbsorbProp[663]) fprintf(stderr, "Warning: %g events were removed in Component[663] channel_14_analyzer_1_array_crystal_array_1=Union_box()\n"
"         (negative time, miss next components, rounding errors, Nan, Inf).\n", mcAbsorbProp[663]);
    if (!mcNCounter[664]) fprintf(stderr, "Warning: No neutron could reach Component[664] channel_14_analyzer_1_array_crystal_array_2\n");
    if (mcAbsorbProp[664]) fprintf(stderr, "Warning: %g events were removed in Component[664] channel_14_analyzer_1_array_crystal_array_2=Union_box()\n"
"         (negative time, miss next components, rounding errors, Nan, Inf).\n", mcAbsorbProp[664]);
    if (!mcNCounter[665]) fprintf(stderr, "Warning: No neutron could reach Component[665] channel_14_analyzer_1_array_crystal_array_3\n");
    if (mcAbsorbProp[665]) fprintf(stderr, "Warning: %g events were removed in Component[665] channel_14_analyzer_1_array_crystal_array_3=Union_box()\n"
"         (negative time, miss next components, rounding errors, Nan, Inf).\n", mcAbsorbProp[665]);
    if (!mcNCounter[666]) fprintf(stderr, "Warning: No neutron could reach Component[666] channel_14_analyzer_1_array_crystal_array_4\n");
    if (mcAbsorbProp[666]) fprintf(stderr, "Warning: %g events were removed in Component[666] channel_14_analyzer_1_array_crystal_array_4=Union_box()\n"
"         (negative time, miss next components, rounding errors, Nan, Inf).\n", mcAbsorbProp[666]);
    if (!mcNCounter[667]) fprintf(stderr, "Warning: No neutron could reach Component[667] channel_14_analyzer_1_array_crystal_array_5\n");
    if (mcAbsorbProp[667]) fprintf(stderr, "Warning: %g events were removed in Component[667] channel_14_analyzer_1_array_crystal_array_5=Union_box()\n"
"         (negative time, miss next components, rounding errors, Nan, Inf).\n", mcAbsorbProp[667]);
    if (!mcNCounter[668]) fprintf(stderr, "Warning: No neutron could reach Component[668] channel_14_analyzer_1_array_crystal_array_6\n");
    if (mcAbsorbProp[668]) fprintf(stderr, "Warning: %g events were removed in Component[668] channel_14_analyzer_1_array_crystal_array_6=Union_box()\n"
"         (negative time, miss next components, rounding errors, Nan, Inf).\n", mcAbsorbProp[668]);
    if (!mcNCounter[669]) fprintf(stderr, "Warning: No neutron could reach Component[669] channel_14_analyzer_1_array_crystal_array_7\n");
    if (mcAbsorbProp[669]) fprintf(stderr, "Warning: %g events were removed in Component[669] channel_14_analyzer_1_array_crystal_array_7=Union_box()\n"
"         (negative time, miss next components, rounding errors, Nan, Inf).\n", mcAbsorbProp[669]);
    if (!mcNCounter[670]) fprintf(stderr, "Warning: No neutron could reach Component[670] channel_14_analyzer_1_array_crystal_array_8\n");
    if (mcAbsorbProp[670]) fprintf(stderr, "Warning: %g events were removed in Component[670] channel_14_analyzer_1_array_crystal_array_8=Union_box()\n"
"         (negative time, miss next components, rounding errors, Nan, Inf).\n", mcAbsorbProp[670]);
    if (!mcNCounter[671]) fprintf(stderr, "Warning: No neutron could reach Component[671] channel_14_analyzer_2_center\n");
    if (mcAbsorbProp[671]) fprintf(stderr, "Warning: %g events were removed in Component[671] channel_14_analyzer_2_center=Arm()\n"
"         (negative time, miss next components, rounding errors, Nan, Inf).\n", mcAbsorbProp[671]);
    if (!mcNCounter[672]) fprintf(stderr, "Warning: No neutron could reach Component[672] channel_14_analyzer_2_rotated\n");
    if (mcAbsorbProp[672]) fprintf(stderr, "Warning: %g events were removed in Component[672] channel_14_analyzer_2_rotated=Arm()\n"
"         (negative time, miss next components, rounding errors, Nan, Inf).\n", mcAbsorbProp[672]);
    if (!mcNCounter[673]) fprintf(stderr, "Warning: No neutron could reach Component[673] channel_14_analyzer_2_array_crystal_array_0\n");
    if (mcAbsorbProp[673]) fprintf(stderr, "Warning: %g events were removed in Component[673] channel_14_analyzer_2_array_crystal_array_0=Union_box()\n"
"         (negative time, miss next components, rounding errors, Nan, Inf).\n", mcAbsorbProp[673]);
    if (!mcNCounter[674]) fprintf(stderr, "Warning: No neutron could reach Component[674] channel_14_analyzer_2_array_crystal_array_1\n");
    if (mcAbsorbProp[674]) fprintf(stderr, "Warning: %g events were removed in Component[674] channel_14_analyzer_2_array_crystal_array_1=Union_box()\n"
"         (negative time, miss next components, rounding errors, Nan, Inf).\n", mcAbsorbProp[674]);
    if (!mcNCounter[675]) fprintf(stderr, "Warning: No neutron could reach Component[675] channel_14_analyzer_2_array_crystal_array_2\n");
    if (mcAbsorbProp[675]) fprintf(stderr, "Warning: %g events were removed in Component[675] channel_14_analyzer_2_array_crystal_array_2=Union_box()\n"
"         (negative time, miss next components, rounding errors, Nan, Inf).\n", mcAbsorbProp[675]);
    if (!mcNCounter[676]) fprintf(stderr, "Warning: No neutron could reach Component[676] channel_14_analyzer_2_array_crystal_array_3\n");
    if (mcAbsorbProp[676]) fprintf(stderr, "Warning: %g events were removed in Component[676] channel_14_analyzer_2_array_crystal_array_3=Union_box()\n"
"         (negative time, miss next components, rounding errors, Nan, Inf).\n", mcAbsorbProp[676]);
    if (!mcNCounter[677]) fprintf(stderr, "Warning: No neutron could reach Component[677] channel_14_analyzer_2_array_crystal_array_4\n");
    if (mcAbsorbProp[677]) fprintf(stderr, "Warning: %g events were removed in Component[677] channel_14_analyzer_2_array_crystal_array_4=Union_box()\n"
"         (negative time, miss next components, rounding errors, Nan, Inf).\n", mcAbsorbProp[677]);
    if (!mcNCounter[678]) fprintf(stderr, "Warning: No neutron could reach Component[678] channel_14_analyzer_2_array_crystal_array_5\n");
    if (mcAbsorbProp[678]) fprintf(stderr, "Warning: %g events were removed in Component[678] channel_14_analyzer_2_array_crystal_array_5=Union_box()\n"
"         (negative time, miss next components, rounding errors, Nan, Inf).\n", mcAbsorbProp[678]);
    if (!mcNCounter[679]) fprintf(stderr, "Warning: No neutron could reach Component[679] channel_14_analyzer_2_array_crystal_array_6\n");
    if (mcAbsorbProp[679]) fprintf(stderr, "Warning: %g events were removed in Component[679] channel_14_analyzer_2_array_crystal_array_6=Union_box()\n"
"         (negative time, miss next components, rounding errors, Nan, Inf).\n", mcAbsorbProp[679]);
    if (!mcNCounter[680]) fprintf(stderr, "Warning: No neutron could reach Component[680] channel_14_analyzer_2_array_crystal_array_7\n");
    if (mcAbsorbProp[680]) fprintf(stderr, "Warning: %g events were removed in Component[680] channel_14_analyzer_2_array_crystal_array_7=Union_box()\n"
"         (negative time, miss next components, rounding errors, Nan, Inf).\n", mcAbsorbProp[680]);
    if (!mcNCounter[681]) fprintf(stderr, "Warning: No neutron could reach Component[681] channel_14_analyzer_2_array_crystal_array_8\n");
    if (mcAbsorbProp[681]) fprintf(stderr, "Warning: %g events were removed in Component[681] channel_14_analyzer_2_array_crystal_array_8=Union_box()\n"
"         (negative time, miss next components, rounding errors, Nan, Inf).\n", mcAbsorbProp[681]);
    if (!mcNCounter[682]) fprintf(stderr, "Warning: No neutron could reach Component[682] channel_14_cave2_cyl1\n");
    if (mcAbsorbProp[682]) fprintf(stderr, "Warning: %g events were removed in Component[682] channel_14_cave2_cyl1=Union_cylinder()\n"
"         (negative time, miss next components, rounding errors, Nan, Inf).\n", mcAbsorbProp[682]);
    if (!mcNCounter[683]) fprintf(stderr, "Warning: No neutron could reach Component[683] channel_14_cave2_box1\n");
    if (mcAbsorbProp[683]) fprintf(stderr, "Warning: %g events were removed in Component[683] channel_14_cave2_box1=Union_box()\n"
"         (negative time, miss next components, rounding errors, Nan, Inf).\n", mcAbsorbProp[683]);
    if (!mcNCounter[684]) fprintf(stderr, "Warning: No neutron could reach Component[684] channel_14_cave2_box2\n");
    if (mcAbsorbProp[684]) fprintf(stderr, "Warning: %g events were removed in Component[684] channel_14_cave2_box2=Union_box()\n"
"         (negative time, miss next components, rounding errors, Nan, Inf).\n", mcAbsorbProp[684]);
    if (!mcNCounter[685]) fprintf(stderr, "Warning: No neutron could reach Component[685] channel_14_cave2_box3\n");
    if (mcAbsorbProp[685]) fprintf(stderr, "Warning: %g events were removed in Component[685] channel_14_cave2_box3=Union_box()\n"
"         (negative time, miss next components, rounding errors, Nan, Inf).\n", mcAbsorbProp[685]);
    if (!mcNCounter[686]) fprintf(stderr, "Warning: No neutron could reach Component[686] inter_analyzer_colimator_center_14\n");
    if (mcAbsorbProp[686]) fprintf(stderr, "Warning: %g events were removed in Component[686] inter_analyzer_colimator_center_14=Arm()\n"
"         (negative time, miss next components, rounding errors, Nan, Inf).\n", mcAbsorbProp[686]);
    if (!mcNCounter[687]) fprintf(stderr, "Warning: No neutron could reach Component[687] inter_analyzer_colimator_14_blade_0\n");
    if (mcAbsorbProp[687]) fprintf(stderr, "Warning: %g events were removed in Component[687] inter_analyzer_colimator_14_blade_0=Union_box()\n"
"         (negative time, miss next components, rounding errors, Nan, Inf).\n", mcAbsorbProp[687]);
    if (!mcNCounter[688]) fprintf(stderr, "Warning: No neutron could reach Component[688] inter_analyzer_colimator_14_blade_1\n");
    if (mcAbsorbProp[688]) fprintf(stderr, "Warning: %g events were removed in Component[688] inter_analyzer_colimator_14_blade_1=Union_box()\n"
"         (negative time, miss next components, rounding errors, Nan, Inf).\n", mcAbsorbProp[688]);
    if (!mcNCounter[689]) fprintf(stderr, "Warning: No neutron could reach Component[689] inter_analyzer_colimator_14_blade_2\n");
    if (mcAbsorbProp[689]) fprintf(stderr, "Warning: %g events were removed in Component[689] inter_analyzer_colimator_14_blade_2=Union_box()\n"
"         (negative time, miss next components, rounding errors, Nan, Inf).\n", mcAbsorbProp[689]);
    if (!mcNCounter[690]) fprintf(stderr, "Warning: No neutron could reach Component[690] inter_analyzer_colimator_14_blade_3\n");
    if (mcAbsorbProp[690]) fprintf(stderr, "Warning: %g events were removed in Component[690] inter_analyzer_colimator_14_blade_3=Union_box()\n"
"         (negative time, miss next components, rounding errors, Nan, Inf).\n", mcAbsorbProp[690]);
    if (!mcNCounter[691]) fprintf(stderr, "Warning: No neutron could reach Component[691] inter_analyzer_colimator_14_blade_4\n");
    if (mcAbsorbProp[691]) fprintf(stderr, "Warning: %g events were removed in Component[691] inter_analyzer_colimator_14_blade_4=Union_box()\n"
"         (negative time, miss next components, rounding errors, Nan, Inf).\n", mcAbsorbProp[691]);
    if (!mcNCounter[692]) fprintf(stderr, "Warning: No neutron could reach Component[692] diffraction_detector_14_exit_volume\n");
    if (mcAbsorbProp[692]) fprintf(stderr, "Warning: %g events were removed in Component[692] diffraction_detector_14_exit_volume=Union_box()\n"
"         (negative time, miss next components, rounding errors, Nan, Inf).\n", mcAbsorbProp[692]);
    if (!mcNCounter[693]) fprintf(stderr, "Warning: No neutron could reach Component[693] spec_detector_14_exit_volume\n");
    if (mcAbsorbProp[693]) fprintf(stderr, "Warning: %g events were removed in Component[693] spec_detector_14_exit_volume=Union_box()\n"
"         (negative time, miss next components, rounding errors, Nan, Inf).\n", mcAbsorbProp[693]);
    if (!mcNCounter[694]) fprintf(stderr, "Warning: No neutron could reach Component[694] channel_15_cave1_box1\n");
    if (mcAbsorbProp[694]) fprintf(stderr, "Warning: %g events were removed in Component[694] channel_15_cave1_box1=Union_box()\n"
"         (negative time, miss next components, rounding errors, Nan, Inf).\n", mcAbsorbProp[694]);
    if (!mcNCounter[695]) fprintf(stderr, "Warning: No neutron could reach Component[695] channel_15_cave1_box2\n");
    if (mcAbsorbProp[695]) fprintf(stderr, "Warning: %g events were removed in Component[695] channel_15_cave1_box2=Union_box()\n"
"         (negative time, miss next components, rounding errors, Nan, Inf).\n", mcAbsorbProp[695]);
    if (!mcNCounter[696]) fprintf(stderr, "Warning: No neutron could reach Component[696] channel_15_cave1_box3\n");
    if (mcAbsorbProp[696]) fprintf(stderr, "Warning: %g events were removed in Component[696] channel_15_cave1_box3=Union_box()\n"
"         (negative time, miss next components, rounding errors, Nan, Inf).\n", mcAbsorbProp[696]);
    if (!mcNCounter[697]) fprintf(stderr, "Warning: No neutron could reach Component[697] channel_15_cave1_cyl1\n");
    if (mcAbsorbProp[697]) fprintf(stderr, "Warning: %g events were removed in Component[697] channel_15_cave1_cyl1=Union_cylinder()\n"
"         (negative time, miss next components, rounding errors, Nan, Inf).\n", mcAbsorbProp[697]);
    if (!mcNCounter[698]) fprintf(stderr, "Warning: No neutron could reach Component[698] channel_15_analyzer_1_center\n");
    if (mcAbsorbProp[698]) fprintf(stderr, "Warning: %g events were removed in Component[698] channel_15_analyzer_1_center=Arm()\n"
"         (negative time, miss next components, rounding errors, Nan, Inf).\n", mcAbsorbProp[698]);
    if (!mcNCounter[699]) fprintf(stderr, "Warning: No neutron could reach Component[699] channel_15_analyzer_1_rotated\n");
    if (mcAbsorbProp[699]) fprintf(stderr, "Warning: %g events were removed in Component[699] channel_15_analyzer_1_rotated=Arm()\n"
"         (negative time, miss next components, rounding errors, Nan, Inf).\n", mcAbsorbProp[699]);
    if (!mcNCounter[700]) fprintf(stderr, "Warning: No neutron could reach Component[700] channel_15_analyzer_1_array_crystal_array_0\n");
    if (mcAbsorbProp[700]) fprintf(stderr, "Warning: %g events were removed in Component[700] channel_15_analyzer_1_array_crystal_array_0=Union_box()\n"
"         (negative time, miss next components, rounding errors, Nan, Inf).\n", mcAbsorbProp[700]);
    if (!mcNCounter[701]) fprintf(stderr, "Warning: No neutron could reach Component[701] channel_15_analyzer_1_array_crystal_array_1\n");
    if (mcAbsorbProp[701]) fprintf(stderr, "Warning: %g events were removed in Component[701] channel_15_analyzer_1_array_crystal_array_1=Union_box()\n"
"         (negative time, miss next components, rounding errors, Nan, Inf).\n", mcAbsorbProp[701]);
    if (!mcNCounter[702]) fprintf(stderr, "Warning: No neutron could reach Component[702] channel_15_analyzer_1_array_crystal_array_2\n");
    if (mcAbsorbProp[702]) fprintf(stderr, "Warning: %g events were removed in Component[702] channel_15_analyzer_1_array_crystal_array_2=Union_box()\n"
"         (negative time, miss next components, rounding errors, Nan, Inf).\n", mcAbsorbProp[702]);
    if (!mcNCounter[703]) fprintf(stderr, "Warning: No neutron could reach Component[703] channel_15_analyzer_1_array_crystal_array_3\n");
    if (mcAbsorbProp[703]) fprintf(stderr, "Warning: %g events were removed in Component[703] channel_15_analyzer_1_array_crystal_array_3=Union_box()\n"
"         (negative time, miss next components, rounding errors, Nan, Inf).\n", mcAbsorbProp[703]);
    if (!mcNCounter[704]) fprintf(stderr, "Warning: No neutron could reach Component[704] channel_15_analyzer_1_array_crystal_array_4\n");
    if (mcAbsorbProp[704]) fprintf(stderr, "Warning: %g events were removed in Component[704] channel_15_analyzer_1_array_crystal_array_4=Union_box()\n"
"         (negative time, miss next components, rounding errors, Nan, Inf).\n", mcAbsorbProp[704]);
    if (!mcNCounter[705]) fprintf(stderr, "Warning: No neutron could reach Component[705] channel_15_analyzer_1_array_crystal_array_5\n");
    if (mcAbsorbProp[705]) fprintf(stderr, "Warning: %g events were removed in Component[705] channel_15_analyzer_1_array_crystal_array_5=Union_box()\n"
"         (negative time, miss next components, rounding errors, Nan, Inf).\n", mcAbsorbProp[705]);
    if (!mcNCounter[706]) fprintf(stderr, "Warning: No neutron could reach Component[706] channel_15_analyzer_1_array_crystal_array_6\n");
    if (mcAbsorbProp[706]) fprintf(stderr, "Warning: %g events were removed in Component[706] channel_15_analyzer_1_array_crystal_array_6=Union_box()\n"
"         (negative time, miss next components, rounding errors, Nan, Inf).\n", mcAbsorbProp[706]);
    if (!mcNCounter[707]) fprintf(stderr, "Warning: No neutron could reach Component[707] channel_15_analyzer_1_array_crystal_array_7\n");
    if (mcAbsorbProp[707]) fprintf(stderr, "Warning: %g events were removed in Component[707] channel_15_analyzer_1_array_crystal_array_7=Union_box()\n"
"         (negative time, miss next components, rounding errors, Nan, Inf).\n", mcAbsorbProp[707]);
    if (!mcNCounter[708]) fprintf(stderr, "Warning: No neutron could reach Component[708] channel_15_analyzer_1_array_crystal_array_8\n");
    if (mcAbsorbProp[708]) fprintf(stderr, "Warning: %g events were removed in Component[708] channel_15_analyzer_1_array_crystal_array_8=Union_box()\n"
"         (negative time, miss next components, rounding errors, Nan, Inf).\n", mcAbsorbProp[708]);
    if (!mcNCounter[709]) fprintf(stderr, "Warning: No neutron could reach Component[709] channel_15_analyzer_2_center\n");
    if (mcAbsorbProp[709]) fprintf(stderr, "Warning: %g events were removed in Component[709] channel_15_analyzer_2_center=Arm()\n"
"         (negative time, miss next components, rounding errors, Nan, Inf).\n", mcAbsorbProp[709]);
    if (!mcNCounter[710]) fprintf(stderr, "Warning: No neutron could reach Component[710] channel_15_analyzer_2_rotated\n");
    if (mcAbsorbProp[710]) fprintf(stderr, "Warning: %g events were removed in Component[710] channel_15_analyzer_2_rotated=Arm()\n"
"         (negative time, miss next components, rounding errors, Nan, Inf).\n", mcAbsorbProp[710]);
    if (!mcNCounter[711]) fprintf(stderr, "Warning: No neutron could reach Component[711] channel_15_analyzer_2_array_crystal_array_0\n");
    if (mcAbsorbProp[711]) fprintf(stderr, "Warning: %g events were removed in Component[711] channel_15_analyzer_2_array_crystal_array_0=Union_box()\n"
"         (negative time, miss next components, rounding errors, Nan, Inf).\n", mcAbsorbProp[711]);
    if (!mcNCounter[712]) fprintf(stderr, "Warning: No neutron could reach Component[712] channel_15_analyzer_2_array_crystal_array_1\n");
    if (mcAbsorbProp[712]) fprintf(stderr, "Warning: %g events were removed in Component[712] channel_15_analyzer_2_array_crystal_array_1=Union_box()\n"
"         (negative time, miss next components, rounding errors, Nan, Inf).\n", mcAbsorbProp[712]);
    if (!mcNCounter[713]) fprintf(stderr, "Warning: No neutron could reach Component[713] channel_15_analyzer_2_array_crystal_array_2\n");
    if (mcAbsorbProp[713]) fprintf(stderr, "Warning: %g events were removed in Component[713] channel_15_analyzer_2_array_crystal_array_2=Union_box()\n"
"         (negative time, miss next components, rounding errors, Nan, Inf).\n", mcAbsorbProp[713]);
    if (!mcNCounter[714]) fprintf(stderr, "Warning: No neutron could reach Component[714] channel_15_analyzer_2_array_crystal_array_3\n");
    if (mcAbsorbProp[714]) fprintf(stderr, "Warning: %g events were removed in Component[714] channel_15_analyzer_2_array_crystal_array_3=Union_box()\n"
"         (negative time, miss next components, rounding errors, Nan, Inf).\n", mcAbsorbProp[714]);
    if (!mcNCounter[715]) fprintf(stderr, "Warning: No neutron could reach Component[715] channel_15_analyzer_2_array_crystal_array_4\n");
    if (mcAbsorbProp[715]) fprintf(stderr, "Warning: %g events were removed in Component[715] channel_15_analyzer_2_array_crystal_array_4=Union_box()\n"
"         (negative time, miss next components, rounding errors, Nan, Inf).\n", mcAbsorbProp[715]);
    if (!mcNCounter[716]) fprintf(stderr, "Warning: No neutron could reach Component[716] channel_15_analyzer_2_array_crystal_array_5\n");
    if (mcAbsorbProp[716]) fprintf(stderr, "Warning: %g events were removed in Component[716] channel_15_analyzer_2_array_crystal_array_5=Union_box()\n"
"         (negative time, miss next components, rounding errors, Nan, Inf).\n", mcAbsorbProp[716]);
    if (!mcNCounter[717]) fprintf(stderr, "Warning: No neutron could reach Component[717] channel_15_analyzer_2_array_crystal_array_6\n");
    if (mcAbsorbProp[717]) fprintf(stderr, "Warning: %g events were removed in Component[717] channel_15_analyzer_2_array_crystal_array_6=Union_box()\n"
"         (negative time, miss next components, rounding errors, Nan, Inf).\n", mcAbsorbProp[717]);
    if (!mcNCounter[718]) fprintf(stderr, "Warning: No neutron could reach Component[718] channel_15_analyzer_2_array_crystal_array_7\n");
    if (mcAbsorbProp[718]) fprintf(stderr, "Warning: %g events were removed in Component[718] channel_15_analyzer_2_array_crystal_array_7=Union_box()\n"
"         (negative time, miss next components, rounding errors, Nan, Inf).\n", mcAbsorbProp[718]);
    if (!mcNCounter[719]) fprintf(stderr, "Warning: No neutron could reach Component[719] channel_15_analyzer_2_array_crystal_array_8\n");
    if (mcAbsorbProp[719]) fprintf(stderr, "Warning: %g events were removed in Component[719] channel_15_analyzer_2_array_crystal_array_8=Union_box()\n"
"         (negative time, miss next components, rounding errors, Nan, Inf).\n", mcAbsorbProp[719]);
    if (!mcNCounter[720]) fprintf(stderr, "Warning: No neutron could reach Component[720] channel_15_cave2_cyl1\n");
    if (mcAbsorbProp[720]) fprintf(stderr, "Warning: %g events were removed in Component[720] channel_15_cave2_cyl1=Union_cylinder()\n"
"         (negative time, miss next components, rounding errors, Nan, Inf).\n", mcAbsorbProp[720]);
    if (!mcNCounter[721]) fprintf(stderr, "Warning: No neutron could reach Component[721] channel_15_cave2_box1\n");
    if (mcAbsorbProp[721]) fprintf(stderr, "Warning: %g events were removed in Component[721] channel_15_cave2_box1=Union_box()\n"
"         (negative time, miss next components, rounding errors, Nan, Inf).\n", mcAbsorbProp[721]);
    if (!mcNCounter[722]) fprintf(stderr, "Warning: No neutron could reach Component[722] channel_15_cave2_box2\n");
    if (mcAbsorbProp[722]) fprintf(stderr, "Warning: %g events were removed in Component[722] channel_15_cave2_box2=Union_box()\n"
"         (negative time, miss next components, rounding errors, Nan, Inf).\n", mcAbsorbProp[722]);
    if (!mcNCounter[723]) fprintf(stderr, "Warning: No neutron could reach Component[723] channel_15_cave2_box3\n");
    if (mcAbsorbProp[723]) fprintf(stderr, "Warning: %g events were removed in Component[723] channel_15_cave2_box3=Union_box()\n"
"         (negative time, miss next components, rounding errors, Nan, Inf).\n", mcAbsorbProp[723]);
    if (!mcNCounter[724]) fprintf(stderr, "Warning: No neutron could reach Component[724] inter_analyzer_colimator_center_15\n");
    if (mcAbsorbProp[724]) fprintf(stderr, "Warning: %g events were removed in Component[724] inter_analyzer_colimator_center_15=Arm()\n"
"         (negative time, miss next components, rounding errors, Nan, Inf).\n", mcAbsorbProp[724]);
    if (!mcNCounter[725]) fprintf(stderr, "Warning: No neutron could reach Component[725] inter_analyzer_colimator_15_blade_0\n");
    if (mcAbsorbProp[725]) fprintf(stderr, "Warning: %g events were removed in Component[725] inter_analyzer_colimator_15_blade_0=Union_box()\n"
"         (negative time, miss next components, rounding errors, Nan, Inf).\n", mcAbsorbProp[725]);
    if (!mcNCounter[726]) fprintf(stderr, "Warning: No neutron could reach Component[726] inter_analyzer_colimator_15_blade_1\n");
    if (mcAbsorbProp[726]) fprintf(stderr, "Warning: %g events were removed in Component[726] inter_analyzer_colimator_15_blade_1=Union_box()\n"
"         (negative time, miss next components, rounding errors, Nan, Inf).\n", mcAbsorbProp[726]);
    if (!mcNCounter[727]) fprintf(stderr, "Warning: No neutron could reach Component[727] inter_analyzer_colimator_15_blade_2\n");
    if (mcAbsorbProp[727]) fprintf(stderr, "Warning: %g events were removed in Component[727] inter_analyzer_colimator_15_blade_2=Union_box()\n"
"         (negative time, miss next components, rounding errors, Nan, Inf).\n", mcAbsorbProp[727]);
    if (!mcNCounter[728]) fprintf(stderr, "Warning: No neutron could reach Component[728] inter_analyzer_colimator_15_blade_3\n");
    if (mcAbsorbProp[728]) fprintf(stderr, "Warning: %g events were removed in Component[728] inter_analyzer_colimator_15_blade_3=Union_box()\n"
"         (negative time, miss next components, rounding errors, Nan, Inf).\n", mcAbsorbProp[728]);
    if (!mcNCounter[729]) fprintf(stderr, "Warning: No neutron could reach Component[729] inter_analyzer_colimator_15_blade_4\n");
    if (mcAbsorbProp[729]) fprintf(stderr, "Warning: %g events were removed in Component[729] inter_analyzer_colimator_15_blade_4=Union_box()\n"
"         (negative time, miss next components, rounding errors, Nan, Inf).\n", mcAbsorbProp[729]);
    if (!mcNCounter[730]) fprintf(stderr, "Warning: No neutron could reach Component[730] diffraction_detector_15_exit_volume\n");
    if (mcAbsorbProp[730]) fprintf(stderr, "Warning: %g events were removed in Component[730] diffraction_detector_15_exit_volume=Union_box()\n"
"         (negative time, miss next components, rounding errors, Nan, Inf).\n", mcAbsorbProp[730]);
    if (!mcNCounter[731]) fprintf(stderr, "Warning: No neutron could reach Component[731] spec_detector_15_exit_volume\n");
    if (mcAbsorbProp[731]) fprintf(stderr, "Warning: %g events were removed in Component[731] spec_detector_15_exit_volume=Union_box()\n"
"         (negative time, miss next components, rounding errors, Nan, Inf).\n", mcAbsorbProp[731]);
    if (!mcNCounter[732]) fprintf(stderr, "Warning: No neutron could reach Component[732] channel_16_cave1_box1\n");
    if (mcAbsorbProp[732]) fprintf(stderr, "Warning: %g events were removed in Component[732] channel_16_cave1_box1=Union_box()\n"
"         (negative time, miss next components, rounding errors, Nan, Inf).\n", mcAbsorbProp[732]);
    if (!mcNCounter[733]) fprintf(stderr, "Warning: No neutron could reach Component[733] channel_16_cave1_box2\n");
    if (mcAbsorbProp[733]) fprintf(stderr, "Warning: %g events were removed in Component[733] channel_16_cave1_box2=Union_box()\n"
"         (negative time, miss next components, rounding errors, Nan, Inf).\n", mcAbsorbProp[733]);
    if (!mcNCounter[734]) fprintf(stderr, "Warning: No neutron could reach Component[734] channel_16_cave1_box3\n");
    if (mcAbsorbProp[734]) fprintf(stderr, "Warning: %g events were removed in Component[734] channel_16_cave1_box3=Union_box()\n"
"         (negative time, miss next components, rounding errors, Nan, Inf).\n", mcAbsorbProp[734]);
    if (!mcNCounter[735]) fprintf(stderr, "Warning: No neutron could reach Component[735] channel_16_cave1_cyl1\n");
    if (mcAbsorbProp[735]) fprintf(stderr, "Warning: %g events were removed in Component[735] channel_16_cave1_cyl1=Union_cylinder()\n"
"         (negative time, miss next components, rounding errors, Nan, Inf).\n", mcAbsorbProp[735]);
    if (!mcNCounter[736]) fprintf(stderr, "Warning: No neutron could reach Component[736] channel_16_analyzer_1_center\n");
    if (mcAbsorbProp[736]) fprintf(stderr, "Warning: %g events were removed in Component[736] channel_16_analyzer_1_center=Arm()\n"
"         (negative time, miss next components, rounding errors, Nan, Inf).\n", mcAbsorbProp[736]);
    if (!mcNCounter[737]) fprintf(stderr, "Warning: No neutron could reach Component[737] channel_16_analyzer_1_rotated\n");
    if (mcAbsorbProp[737]) fprintf(stderr, "Warning: %g events were removed in Component[737] channel_16_analyzer_1_rotated=Arm()\n"
"         (negative time, miss next components, rounding errors, Nan, Inf).\n", mcAbsorbProp[737]);
    if (!mcNCounter[738]) fprintf(stderr, "Warning: No neutron could reach Component[738] channel_16_analyzer_1_array_crystal_array_0\n");
    if (mcAbsorbProp[738]) fprintf(stderr, "Warning: %g events were removed in Component[738] channel_16_analyzer_1_array_crystal_array_0=Union_box()\n"
"         (negative time, miss next components, rounding errors, Nan, Inf).\n", mcAbsorbProp[738]);
    if (!mcNCounter[739]) fprintf(stderr, "Warning: No neutron could reach Component[739] channel_16_analyzer_1_array_crystal_array_1\n");
    if (mcAbsorbProp[739]) fprintf(stderr, "Warning: %g events were removed in Component[739] channel_16_analyzer_1_array_crystal_array_1=Union_box()\n"
"         (negative time, miss next components, rounding errors, Nan, Inf).\n", mcAbsorbProp[739]);
    if (!mcNCounter[740]) fprintf(stderr, "Warning: No neutron could reach Component[740] channel_16_analyzer_1_array_crystal_array_2\n");
    if (mcAbsorbProp[740]) fprintf(stderr, "Warning: %g events were removed in Component[740] channel_16_analyzer_1_array_crystal_array_2=Union_box()\n"
"         (negative time, miss next components, rounding errors, Nan, Inf).\n", mcAbsorbProp[740]);
    if (!mcNCounter[741]) fprintf(stderr, "Warning: No neutron could reach Component[741] channel_16_analyzer_1_array_crystal_array_3\n");
    if (mcAbsorbProp[741]) fprintf(stderr, "Warning: %g events were removed in Component[741] channel_16_analyzer_1_array_crystal_array_3=Union_box()\n"
"         (negative time, miss next components, rounding errors, Nan, Inf).\n", mcAbsorbProp[741]);
    if (!mcNCounter[742]) fprintf(stderr, "Warning: No neutron could reach Component[742] channel_16_analyzer_1_array_crystal_array_4\n");
    if (mcAbsorbProp[742]) fprintf(stderr, "Warning: %g events were removed in Component[742] channel_16_analyzer_1_array_crystal_array_4=Union_box()\n"
"         (negative time, miss next components, rounding errors, Nan, Inf).\n", mcAbsorbProp[742]);
    if (!mcNCounter[743]) fprintf(stderr, "Warning: No neutron could reach Component[743] channel_16_analyzer_1_array_crystal_array_5\n");
    if (mcAbsorbProp[743]) fprintf(stderr, "Warning: %g events were removed in Component[743] channel_16_analyzer_1_array_crystal_array_5=Union_box()\n"
"         (negative time, miss next components, rounding errors, Nan, Inf).\n", mcAbsorbProp[743]);
    if (!mcNCounter[744]) fprintf(stderr, "Warning: No neutron could reach Component[744] channel_16_analyzer_1_array_crystal_array_6\n");
    if (mcAbsorbProp[744]) fprintf(stderr, "Warning: %g events were removed in Component[744] channel_16_analyzer_1_array_crystal_array_6=Union_box()\n"
"         (negative time, miss next components, rounding errors, Nan, Inf).\n", mcAbsorbProp[744]);
    if (!mcNCounter[745]) fprintf(stderr, "Warning: No neutron could reach Component[745] channel_16_analyzer_1_array_crystal_array_7\n");
    if (mcAbsorbProp[745]) fprintf(stderr, "Warning: %g events were removed in Component[745] channel_16_analyzer_1_array_crystal_array_7=Union_box()\n"
"         (negative time, miss next components, rounding errors, Nan, Inf).\n", mcAbsorbProp[745]);
    if (!mcNCounter[746]) fprintf(stderr, "Warning: No neutron could reach Component[746] channel_16_analyzer_1_array_crystal_array_8\n");
    if (mcAbsorbProp[746]) fprintf(stderr, "Warning: %g events were removed in Component[746] channel_16_analyzer_1_array_crystal_array_8=Union_box()\n"
"         (negative time, miss next components, rounding errors, Nan, Inf).\n", mcAbsorbProp[746]);
    if (!mcNCounter[747]) fprintf(stderr, "Warning: No neutron could reach Component[747] channel_16_analyzer_2_center\n");
    if (mcAbsorbProp[747]) fprintf(stderr, "Warning: %g events were removed in Component[747] channel_16_analyzer_2_center=Arm()\n"
"         (negative time, miss next components, rounding errors, Nan, Inf).\n", mcAbsorbProp[747]);
    if (!mcNCounter[748]) fprintf(stderr, "Warning: No neutron could reach Component[748] channel_16_analyzer_2_rotated\n");
    if (mcAbsorbProp[748]) fprintf(stderr, "Warning: %g events were removed in Component[748] channel_16_analyzer_2_rotated=Arm()\n"
"         (negative time, miss next components, rounding errors, Nan, Inf).\n", mcAbsorbProp[748]);
    if (!mcNCounter[749]) fprintf(stderr, "Warning: No neutron could reach Component[749] channel_16_analyzer_2_array_crystal_array_0\n");
    if (mcAbsorbProp[749]) fprintf(stderr, "Warning: %g events were removed in Component[749] channel_16_analyzer_2_array_crystal_array_0=Union_box()\n"
"         (negative time, miss next components, rounding errors, Nan, Inf).\n", mcAbsorbProp[749]);
    if (!mcNCounter[750]) fprintf(stderr, "Warning: No neutron could reach Component[750] channel_16_analyzer_2_array_crystal_array_1\n");
    if (mcAbsorbProp[750]) fprintf(stderr, "Warning: %g events were removed in Component[750] channel_16_analyzer_2_array_crystal_array_1=Union_box()\n"
"         (negative time, miss next components, rounding errors, Nan, Inf).\n", mcAbsorbProp[750]);
    if (!mcNCounter[751]) fprintf(stderr, "Warning: No neutron could reach Component[751] channel_16_analyzer_2_array_crystal_array_2\n");
    if (mcAbsorbProp[751]) fprintf(stderr, "Warning: %g events were removed in Component[751] channel_16_analyzer_2_array_crystal_array_2=Union_box()\n"
"         (negative time, miss next components, rounding errors, Nan, Inf).\n", mcAbsorbProp[751]);
    if (!mcNCounter[752]) fprintf(stderr, "Warning: No neutron could reach Component[752] channel_16_analyzer_2_array_crystal_array_3\n");
    if (mcAbsorbProp[752]) fprintf(stderr, "Warning: %g events were removed in Component[752] channel_16_analyzer_2_array_crystal_array_3=Union_box()\n"
"         (negative time, miss next components, rounding errors, Nan, Inf).\n", mcAbsorbProp[752]);
    if (!mcNCounter[753]) fprintf(stderr, "Warning: No neutron could reach Component[753] channel_16_analyzer_2_array_crystal_array_4\n");
    if (mcAbsorbProp[753]) fprintf(stderr, "Warning: %g events were removed in Component[753] channel_16_analyzer_2_array_crystal_array_4=Union_box()\n"
"         (negative time, miss next components, rounding errors, Nan, Inf).\n", mcAbsorbProp[753]);
    if (!mcNCounter[754]) fprintf(stderr, "Warning: No neutron could reach Component[754] channel_16_analyzer_2_array_crystal_array_5\n");
    if (mcAbsorbProp[754]) fprintf(stderr, "Warning: %g events were removed in Component[754] channel_16_analyzer_2_array_crystal_array_5=Union_box()\n"
"         (negative time, miss next components, rounding errors, Nan, Inf).\n", mcAbsorbProp[754]);
    if (!mcNCounter[755]) fprintf(stderr, "Warning: No neutron could reach Component[755] channel_16_analyzer_2_array_crystal_array_6\n");
    if (mcAbsorbProp[755]) fprintf(stderr, "Warning: %g events were removed in Component[755] channel_16_analyzer_2_array_crystal_array_6=Union_box()\n"
"         (negative time, miss next components, rounding errors, Nan, Inf).\n", mcAbsorbProp[755]);
    if (!mcNCounter[756]) fprintf(stderr, "Warning: No neutron could reach Component[756] channel_16_analyzer_2_array_crystal_array_7\n");
    if (mcAbsorbProp[756]) fprintf(stderr, "Warning: %g events were removed in Component[756] channel_16_analyzer_2_array_crystal_array_7=Union_box()\n"
"         (negative time, miss next components, rounding errors, Nan, Inf).\n", mcAbsorbProp[756]);
    if (!mcNCounter[757]) fprintf(stderr, "Warning: No neutron could reach Component[757] channel_16_analyzer_2_array_crystal_array_8\n");
    if (mcAbsorbProp[757]) fprintf(stderr, "Warning: %g events were removed in Component[757] channel_16_analyzer_2_array_crystal_array_8=Union_box()\n"
"         (negative time, miss next components, rounding errors, Nan, Inf).\n", mcAbsorbProp[757]);
    if (!mcNCounter[758]) fprintf(stderr, "Warning: No neutron could reach Component[758] channel_16_cave2_cyl1\n");
    if (mcAbsorbProp[758]) fprintf(stderr, "Warning: %g events were removed in Component[758] channel_16_cave2_cyl1=Union_cylinder()\n"
"         (negative time, miss next components, rounding errors, Nan, Inf).\n", mcAbsorbProp[758]);
    if (!mcNCounter[759]) fprintf(stderr, "Warning: No neutron could reach Component[759] channel_16_cave2_box1\n");
    if (mcAbsorbProp[759]) fprintf(stderr, "Warning: %g events were removed in Component[759] channel_16_cave2_box1=Union_box()\n"
"         (negative time, miss next components, rounding errors, Nan, Inf).\n", mcAbsorbProp[759]);
    if (!mcNCounter[760]) fprintf(stderr, "Warning: No neutron could reach Component[760] channel_16_cave2_box2\n");
    if (mcAbsorbProp[760]) fprintf(stderr, "Warning: %g events were removed in Component[760] channel_16_cave2_box2=Union_box()\n"
"         (negative time, miss next components, rounding errors, Nan, Inf).\n", mcAbsorbProp[760]);
    if (!mcNCounter[761]) fprintf(stderr, "Warning: No neutron could reach Component[761] channel_16_cave2_box3\n");
    if (mcAbsorbProp[761]) fprintf(stderr, "Warning: %g events were removed in Component[761] channel_16_cave2_box3=Union_box()\n"
"         (negative time, miss next components, rounding errors, Nan, Inf).\n", mcAbsorbProp[761]);
    if (!mcNCounter[762]) fprintf(stderr, "Warning: No neutron could reach Component[762] inter_analyzer_colimator_center_16\n");
    if (mcAbsorbProp[762]) fprintf(stderr, "Warning: %g events were removed in Component[762] inter_analyzer_colimator_center_16=Arm()\n"
"         (negative time, miss next components, rounding errors, Nan, Inf).\n", mcAbsorbProp[762]);
    if (!mcNCounter[763]) fprintf(stderr, "Warning: No neutron could reach Component[763] inter_analyzer_colimator_16_blade_0\n");
    if (mcAbsorbProp[763]) fprintf(stderr, "Warning: %g events were removed in Component[763] inter_analyzer_colimator_16_blade_0=Union_box()\n"
"         (negative time, miss next components, rounding errors, Nan, Inf).\n", mcAbsorbProp[763]);
    if (!mcNCounter[764]) fprintf(stderr, "Warning: No neutron could reach Component[764] inter_analyzer_colimator_16_blade_1\n");
    if (mcAbsorbProp[764]) fprintf(stderr, "Warning: %g events were removed in Component[764] inter_analyzer_colimator_16_blade_1=Union_box()\n"
"         (negative time, miss next components, rounding errors, Nan, Inf).\n", mcAbsorbProp[764]);
    if (!mcNCounter[765]) fprintf(stderr, "Warning: No neutron could reach Component[765] inter_analyzer_colimator_16_blade_2\n");
    if (mcAbsorbProp[765]) fprintf(stderr, "Warning: %g events were removed in Component[765] inter_analyzer_colimator_16_blade_2=Union_box()\n"
"         (negative time, miss next components, rounding errors, Nan, Inf).\n", mcAbsorbProp[765]);
    if (!mcNCounter[766]) fprintf(stderr, "Warning: No neutron could reach Component[766] inter_analyzer_colimator_16_blade_3\n");
    if (mcAbsorbProp[766]) fprintf(stderr, "Warning: %g events were removed in Component[766] inter_analyzer_colimator_16_blade_3=Union_box()\n"
"         (negative time, miss next components, rounding errors, Nan, Inf).\n", mcAbsorbProp[766]);
    if (!mcNCounter[767]) fprintf(stderr, "Warning: No neutron could reach Component[767] inter_analyzer_colimator_16_blade_4\n");
    if (mcAbsorbProp[767]) fprintf(stderr, "Warning: %g events were removed in Component[767] inter_analyzer_colimator_16_blade_4=Union_box()\n"
"         (negative time, miss next components, rounding errors, Nan, Inf).\n", mcAbsorbProp[767]);
    if (!mcNCounter[768]) fprintf(stderr, "Warning: No neutron could reach Component[768] diffraction_detector_16_exit_volume\n");
    if (mcAbsorbProp[768]) fprintf(stderr, "Warning: %g events were removed in Component[768] diffraction_detector_16_exit_volume=Union_box()\n"
"         (negative time, miss next components, rounding errors, Nan, Inf).\n", mcAbsorbProp[768]);
    if (!mcNCounter[769]) fprintf(stderr, "Warning: No neutron could reach Component[769] spec_detector_16_exit_volume\n");
    if (mcAbsorbProp[769]) fprintf(stderr, "Warning: %g events were removed in Component[769] spec_detector_16_exit_volume=Union_box()\n"
"         (negative time, miss next components, rounding errors, Nan, Inf).\n", mcAbsorbProp[769]);
    if (!mcNCounter[770]) fprintf(stderr, "Warning: No neutron could reach Component[770] channel_17_cave1_box1\n");
    if (mcAbsorbProp[770]) fprintf(stderr, "Warning: %g events were removed in Component[770] channel_17_cave1_box1=Union_box()\n"
"         (negative time, miss next components, rounding errors, Nan, Inf).\n", mcAbsorbProp[770]);
    if (!mcNCounter[771]) fprintf(stderr, "Warning: No neutron could reach Component[771] channel_17_cave1_box2\n");
    if (mcAbsorbProp[771]) fprintf(stderr, "Warning: %g events were removed in Component[771] channel_17_cave1_box2=Union_box()\n"
"         (negative time, miss next components, rounding errors, Nan, Inf).\n", mcAbsorbProp[771]);
    if (!mcNCounter[772]) fprintf(stderr, "Warning: No neutron could reach Component[772] channel_17_cave1_box3\n");
    if (mcAbsorbProp[772]) fprintf(stderr, "Warning: %g events were removed in Component[772] channel_17_cave1_box3=Union_box()\n"
"         (negative time, miss next components, rounding errors, Nan, Inf).\n", mcAbsorbProp[772]);
    if (!mcNCounter[773]) fprintf(stderr, "Warning: No neutron could reach Component[773] channel_17_cave1_cyl1\n");
    if (mcAbsorbProp[773]) fprintf(stderr, "Warning: %g events were removed in Component[773] channel_17_cave1_cyl1=Union_cylinder()\n"
"         (negative time, miss next components, rounding errors, Nan, Inf).\n", mcAbsorbProp[773]);
    if (!mcNCounter[774]) fprintf(stderr, "Warning: No neutron could reach Component[774] channel_17_analyzer_1_center\n");
    if (mcAbsorbProp[774]) fprintf(stderr, "Warning: %g events were removed in Component[774] channel_17_analyzer_1_center=Arm()\n"
"         (negative time, miss next components, rounding errors, Nan, Inf).\n", mcAbsorbProp[774]);
    if (!mcNCounter[775]) fprintf(stderr, "Warning: No neutron could reach Component[775] channel_17_analyzer_1_rotated\n");
    if (mcAbsorbProp[775]) fprintf(stderr, "Warning: %g events were removed in Component[775] channel_17_analyzer_1_rotated=Arm()\n"
"         (negative time, miss next components, rounding errors, Nan, Inf).\n", mcAbsorbProp[775]);
    if (!mcNCounter[776]) fprintf(stderr, "Warning: No neutron could reach Component[776] channel_17_analyzer_1_array_crystal_array_0\n");
    if (mcAbsorbProp[776]) fprintf(stderr, "Warning: %g events were removed in Component[776] channel_17_analyzer_1_array_crystal_array_0=Union_box()\n"
"         (negative time, miss next components, rounding errors, Nan, Inf).\n", mcAbsorbProp[776]);
    if (!mcNCounter[777]) fprintf(stderr, "Warning: No neutron could reach Component[777] channel_17_analyzer_1_array_crystal_array_1\n");
    if (mcAbsorbProp[777]) fprintf(stderr, "Warning: %g events were removed in Component[777] channel_17_analyzer_1_array_crystal_array_1=Union_box()\n"
"         (negative time, miss next components, rounding errors, Nan, Inf).\n", mcAbsorbProp[777]);
    if (!mcNCounter[778]) fprintf(stderr, "Warning: No neutron could reach Component[778] channel_17_analyzer_1_array_crystal_array_2\n");
    if (mcAbsorbProp[778]) fprintf(stderr, "Warning: %g events were removed in Component[778] channel_17_analyzer_1_array_crystal_array_2=Union_box()\n"
"         (negative time, miss next components, rounding errors, Nan, Inf).\n", mcAbsorbProp[778]);
    if (!mcNCounter[779]) fprintf(stderr, "Warning: No neutron could reach Component[779] channel_17_analyzer_1_array_crystal_array_3\n");
    if (mcAbsorbProp[779]) fprintf(stderr, "Warning: %g events were removed in Component[779] channel_17_analyzer_1_array_crystal_array_3=Union_box()\n"
"         (negative time, miss next components, rounding errors, Nan, Inf).\n", mcAbsorbProp[779]);
    if (!mcNCounter[780]) fprintf(stderr, "Warning: No neutron could reach Component[780] channel_17_analyzer_1_array_crystal_array_4\n");
    if (mcAbsorbProp[780]) fprintf(stderr, "Warning: %g events were removed in Component[780] channel_17_analyzer_1_array_crystal_array_4=Union_box()\n"
"         (negative time, miss next components, rounding errors, Nan, Inf).\n", mcAbsorbProp[780]);
    if (!mcNCounter[781]) fprintf(stderr, "Warning: No neutron could reach Component[781] channel_17_analyzer_1_array_crystal_array_5\n");
    if (mcAbsorbProp[781]) fprintf(stderr, "Warning: %g events were removed in Component[781] channel_17_analyzer_1_array_crystal_array_5=Union_box()\n"
"         (negative time, miss next components, rounding errors, Nan, Inf).\n", mcAbsorbProp[781]);
    if (!mcNCounter[782]) fprintf(stderr, "Warning: No neutron could reach Component[782] channel_17_analyzer_1_array_crystal_array_6\n");
    if (mcAbsorbProp[782]) fprintf(stderr, "Warning: %g events were removed in Component[782] channel_17_analyzer_1_array_crystal_array_6=Union_box()\n"
"         (negative time, miss next components, rounding errors, Nan, Inf).\n", mcAbsorbProp[782]);
    if (!mcNCounter[783]) fprintf(stderr, "Warning: No neutron could reach Component[783] channel_17_analyzer_1_array_crystal_array_7\n");
    if (mcAbsorbProp[783]) fprintf(stderr, "Warning: %g events were removed in Component[783] channel_17_analyzer_1_array_crystal_array_7=Union_box()\n"
"         (negative time, miss next components, rounding errors, Nan, Inf).\n", mcAbsorbProp[783]);
    if (!mcNCounter[784]) fprintf(stderr, "Warning: No neutron could reach Component[784] channel_17_analyzer_1_array_crystal_array_8\n");
    if (mcAbsorbProp[784]) fprintf(stderr, "Warning: %g events were removed in Component[784] channel_17_analyzer_1_array_crystal_array_8=Union_box()\n"
"         (negative time, miss next components, rounding errors, Nan, Inf).\n", mcAbsorbProp[784]);
    if (!mcNCounter[785]) fprintf(stderr, "Warning: No neutron could reach Component[785] channel_17_analyzer_2_center\n");
    if (mcAbsorbProp[785]) fprintf(stderr, "Warning: %g events were removed in Component[785] channel_17_analyzer_2_center=Arm()\n"
"         (negative time, miss next components, rounding errors, Nan, Inf).\n", mcAbsorbProp[785]);
    if (!mcNCounter[786]) fprintf(stderr, "Warning: No neutron could reach Component[786] channel_17_analyzer_2_rotated\n");
    if (mcAbsorbProp[786]) fprintf(stderr, "Warning: %g events were removed in Component[786] channel_17_analyzer_2_rotated=Arm()\n"
"         (negative time, miss next components, rounding errors, Nan, Inf).\n", mcAbsorbProp[786]);
    if (!mcNCounter[787]) fprintf(stderr, "Warning: No neutron could reach Component[787] channel_17_analyzer_2_array_crystal_array_0\n");
    if (mcAbsorbProp[787]) fprintf(stderr, "Warning: %g events were removed in Component[787] channel_17_analyzer_2_array_crystal_array_0=Union_box()\n"
"         (negative time, miss next components, rounding errors, Nan, Inf).\n", mcAbsorbProp[787]);
    if (!mcNCounter[788]) fprintf(stderr, "Warning: No neutron could reach Component[788] channel_17_analyzer_2_array_crystal_array_1\n");
    if (mcAbsorbProp[788]) fprintf(stderr, "Warning: %g events were removed in Component[788] channel_17_analyzer_2_array_crystal_array_1=Union_box()\n"
"         (negative time, miss next components, rounding errors, Nan, Inf).\n", mcAbsorbProp[788]);
    if (!mcNCounter[789]) fprintf(stderr, "Warning: No neutron could reach Component[789] channel_17_analyzer_2_array_crystal_array_2\n");
    if (mcAbsorbProp[789]) fprintf(stderr, "Warning: %g events were removed in Component[789] channel_17_analyzer_2_array_crystal_array_2=Union_box()\n"
"         (negative time, miss next components, rounding errors, Nan, Inf).\n", mcAbsorbProp[789]);
    if (!mcNCounter[790]) fprintf(stderr, "Warning: No neutron could reach Component[790] channel_17_analyzer_2_array_crystal_array_3\n");
    if (mcAbsorbProp[790]) fprintf(stderr, "Warning: %g events were removed in Component[790] channel_17_analyzer_2_array_crystal_array_3=Union_box()\n"
"         (negative time, miss next components, rounding errors, Nan, Inf).\n", mcAbsorbProp[790]);
    if (!mcNCounter[791]) fprintf(stderr, "Warning: No neutron could reach Component[791] channel_17_analyzer_2_array_crystal_array_4\n");
    if (mcAbsorbProp[791]) fprintf(stderr, "Warning: %g events were removed in Component[791] channel_17_analyzer_2_array_crystal_array_4=Union_box()\n"
"         (negative time, miss next components, rounding errors, Nan, Inf).\n", mcAbsorbProp[791]);
    if (!mcNCounter[792]) fprintf(stderr, "Warning: No neutron could reach Component[792] channel_17_analyzer_2_array_crystal_array_5\n");
    if (mcAbsorbProp[792]) fprintf(stderr, "Warning: %g events were removed in Component[792] channel_17_analyzer_2_array_crystal_array_5=Union_box()\n"
"         (negative time, miss next components, rounding errors, Nan, Inf).\n", mcAbsorbProp[792]);
    if (!mcNCounter[793]) fprintf(stderr, "Warning: No neutron could reach Component[793] channel_17_analyzer_2_array_crystal_array_6\n");
    if (mcAbsorbProp[793]) fprintf(stderr, "Warning: %g events were removed in Component[793] channel_17_analyzer_2_array_crystal_array_6=Union_box()\n"
"         (negative time, miss next components, rounding errors, Nan, Inf).\n", mcAbsorbProp[793]);
    if (!mcNCounter[794]) fprintf(stderr, "Warning: No neutron could reach Component[794] channel_17_analyzer_2_array_crystal_array_7\n");
    if (mcAbsorbProp[794]) fprintf(stderr, "Warning: %g events were removed in Component[794] channel_17_analyzer_2_array_crystal_array_7=Union_box()\n"
"         (negative time, miss next components, rounding errors, Nan, Inf).\n", mcAbsorbProp[794]);
    if (!mcNCounter[795]) fprintf(stderr, "Warning: No neutron could reach Component[795] channel_17_analyzer_2_array_crystal_array_8\n");
    if (mcAbsorbProp[795]) fprintf(stderr, "Warning: %g events were removed in Component[795] channel_17_analyzer_2_array_crystal_array_8=Union_box()\n"
"         (negative time, miss next components, rounding errors, Nan, Inf).\n", mcAbsorbProp[795]);
    if (!mcNCounter[796]) fprintf(stderr, "Warning: No neutron could reach Component[796] channel_17_cave2_cyl1\n");
    if (mcAbsorbProp[796]) fprintf(stderr, "Warning: %g events were removed in Component[796] channel_17_cave2_cyl1=Union_cylinder()\n"
"         (negative time, miss next components, rounding errors, Nan, Inf).\n", mcAbsorbProp[796]);
    if (!mcNCounter[797]) fprintf(stderr, "Warning: No neutron could reach Component[797] channel_17_cave2_box1\n");
    if (mcAbsorbProp[797]) fprintf(stderr, "Warning: %g events were removed in Component[797] channel_17_cave2_box1=Union_box()\n"
"         (negative time, miss next components, rounding errors, Nan, Inf).\n", mcAbsorbProp[797]);
    if (!mcNCounter[798]) fprintf(stderr, "Warning: No neutron could reach Component[798] channel_17_cave2_box2\n");
    if (mcAbsorbProp[798]) fprintf(stderr, "Warning: %g events were removed in Component[798] channel_17_cave2_box2=Union_box()\n"
"         (negative time, miss next components, rounding errors, Nan, Inf).\n", mcAbsorbProp[798]);
    if (!mcNCounter[799]) fprintf(stderr, "Warning: No neutron could reach Component[799] channel_17_cave2_box3\n");
    if (mcAbsorbProp[799]) fprintf(stderr, "Warning: %g events were removed in Component[799] channel_17_cave2_box3=Union_box()\n"
"         (negative time, miss next components, rounding errors, Nan, Inf).\n", mcAbsorbProp[799]);
    if (!mcNCounter[800]) fprintf(stderr, "Warning: No neutron could reach Component[800] inter_analyzer_colimator_center_17\n");
    if (mcAbsorbProp[800]) fprintf(stderr, "Warning: %g events were removed in Component[800] inter_analyzer_colimator_center_17=Arm()\n"
"         (negative time, miss next components, rounding errors, Nan, Inf).\n", mcAbsorbProp[800]);
    if (!mcNCounter[801]) fprintf(stderr, "Warning: No neutron could reach Component[801] inter_analyzer_colimator_17_blade_0\n");
    if (mcAbsorbProp[801]) fprintf(stderr, "Warning: %g events were removed in Component[801] inter_analyzer_colimator_17_blade_0=Union_box()\n"
"         (negative time, miss next components, rounding errors, Nan, Inf).\n", mcAbsorbProp[801]);
    if (!mcNCounter[802]) fprintf(stderr, "Warning: No neutron could reach Component[802] inter_analyzer_colimator_17_blade_1\n");
    if (mcAbsorbProp[802]) fprintf(stderr, "Warning: %g events were removed in Component[802] inter_analyzer_colimator_17_blade_1=Union_box()\n"
"         (negative time, miss next components, rounding errors, Nan, Inf).\n", mcAbsorbProp[802]);
    if (!mcNCounter[803]) fprintf(stderr, "Warning: No neutron could reach Component[803] inter_analyzer_colimator_17_blade_2\n");
    if (mcAbsorbProp[803]) fprintf(stderr, "Warning: %g events were removed in Component[803] inter_analyzer_colimator_17_blade_2=Union_box()\n"
"         (negative time, miss next components, rounding errors, Nan, Inf).\n", mcAbsorbProp[803]);
    if (!mcNCounter[804]) fprintf(stderr, "Warning: No neutron could reach Component[804] inter_analyzer_colimator_17_blade_3\n");
    if (mcAbsorbProp[804]) fprintf(stderr, "Warning: %g events were removed in Component[804] inter_analyzer_colimator_17_blade_3=Union_box()\n"
"         (negative time, miss next components, rounding errors, Nan, Inf).\n", mcAbsorbProp[804]);
    if (!mcNCounter[805]) fprintf(stderr, "Warning: No neutron could reach Component[805] inter_analyzer_colimator_17_blade_4\n");
    if (mcAbsorbProp[805]) fprintf(stderr, "Warning: %g events were removed in Component[805] inter_analyzer_colimator_17_blade_4=Union_box()\n"
"         (negative time, miss next components, rounding errors, Nan, Inf).\n", mcAbsorbProp[805]);
    if (!mcNCounter[806]) fprintf(stderr, "Warning: No neutron could reach Component[806] diffraction_detector_17_exit_volume\n");
    if (mcAbsorbProp[806]) fprintf(stderr, "Warning: %g events were removed in Component[806] diffraction_detector_17_exit_volume=Union_box()\n"
"         (negative time, miss next components, rounding errors, Nan, Inf).\n", mcAbsorbProp[806]);
    if (!mcNCounter[807]) fprintf(stderr, "Warning: No neutron could reach Component[807] spec_detector_17_exit_volume\n");
    if (mcAbsorbProp[807]) fprintf(stderr, "Warning: %g events were removed in Component[807] spec_detector_17_exit_volume=Union_box()\n"
"         (negative time, miss next components, rounding errors, Nan, Inf).\n", mcAbsorbProp[807]);
    if (!mcNCounter[808]) fprintf(stderr, "Warning: No neutron could reach Component[808] channel_18_cave1_box1\n");
    if (mcAbsorbProp[808]) fprintf(stderr, "Warning: %g events were removed in Component[808] channel_18_cave1_box1=Union_box()\n"
"         (negative time, miss next components, rounding errors, Nan, Inf).\n", mcAbsorbProp[808]);
    if (!mcNCounter[809]) fprintf(stderr, "Warning: No neutron could reach Component[809] channel_18_cave1_box2\n");
    if (mcAbsorbProp[809]) fprintf(stderr, "Warning: %g events were removed in Component[809] channel_18_cave1_box2=Union_box()\n"
"         (negative time, miss next components, rounding errors, Nan, Inf).\n", mcAbsorbProp[809]);
    if (!mcNCounter[810]) fprintf(stderr, "Warning: No neutron could reach Component[810] channel_18_cave1_box3\n");
    if (mcAbsorbProp[810]) fprintf(stderr, "Warning: %g events were removed in Component[810] channel_18_cave1_box3=Union_box()\n"
"         (negative time, miss next components, rounding errors, Nan, Inf).\n", mcAbsorbProp[810]);
    if (!mcNCounter[811]) fprintf(stderr, "Warning: No neutron could reach Component[811] channel_18_cave1_cyl1\n");
    if (mcAbsorbProp[811]) fprintf(stderr, "Warning: %g events were removed in Component[811] channel_18_cave1_cyl1=Union_cylinder()\n"
"         (negative time, miss next components, rounding errors, Nan, Inf).\n", mcAbsorbProp[811]);
    if (!mcNCounter[812]) fprintf(stderr, "Warning: No neutron could reach Component[812] channel_18_analyzer_1_center\n");
    if (mcAbsorbProp[812]) fprintf(stderr, "Warning: %g events were removed in Component[812] channel_18_analyzer_1_center=Arm()\n"
"         (negative time, miss next components, rounding errors, Nan, Inf).\n", mcAbsorbProp[812]);
    if (!mcNCounter[813]) fprintf(stderr, "Warning: No neutron could reach Component[813] channel_18_analyzer_1_rotated\n");
    if (mcAbsorbProp[813]) fprintf(stderr, "Warning: %g events were removed in Component[813] channel_18_analyzer_1_rotated=Arm()\n"
"         (negative time, miss next components, rounding errors, Nan, Inf).\n", mcAbsorbProp[813]);
    if (!mcNCounter[814]) fprintf(stderr, "Warning: No neutron could reach Component[814] channel_18_analyzer_1_array_crystal_array_0\n");
    if (mcAbsorbProp[814]) fprintf(stderr, "Warning: %g events were removed in Component[814] channel_18_analyzer_1_array_crystal_array_0=Union_box()\n"
"         (negative time, miss next components, rounding errors, Nan, Inf).\n", mcAbsorbProp[814]);
    if (!mcNCounter[815]) fprintf(stderr, "Warning: No neutron could reach Component[815] channel_18_analyzer_1_array_crystal_array_1\n");
    if (mcAbsorbProp[815]) fprintf(stderr, "Warning: %g events were removed in Component[815] channel_18_analyzer_1_array_crystal_array_1=Union_box()\n"
"         (negative time, miss next components, rounding errors, Nan, Inf).\n", mcAbsorbProp[815]);
    if (!mcNCounter[816]) fprintf(stderr, "Warning: No neutron could reach Component[816] channel_18_analyzer_1_array_crystal_array_2\n");
    if (mcAbsorbProp[816]) fprintf(stderr, "Warning: %g events were removed in Component[816] channel_18_analyzer_1_array_crystal_array_2=Union_box()\n"
"         (negative time, miss next components, rounding errors, Nan, Inf).\n", mcAbsorbProp[816]);
    if (!mcNCounter[817]) fprintf(stderr, "Warning: No neutron could reach Component[817] channel_18_analyzer_1_array_crystal_array_3\n");
    if (mcAbsorbProp[817]) fprintf(stderr, "Warning: %g events were removed in Component[817] channel_18_analyzer_1_array_crystal_array_3=Union_box()\n"
"         (negative time, miss next components, rounding errors, Nan, Inf).\n", mcAbsorbProp[817]);
    if (!mcNCounter[818]) fprintf(stderr, "Warning: No neutron could reach Component[818] channel_18_analyzer_1_array_crystal_array_4\n");
    if (mcAbsorbProp[818]) fprintf(stderr, "Warning: %g events were removed in Component[818] channel_18_analyzer_1_array_crystal_array_4=Union_box()\n"
"         (negative time, miss next components, rounding errors, Nan, Inf).\n", mcAbsorbProp[818]);
    if (!mcNCounter[819]) fprintf(stderr, "Warning: No neutron could reach Component[819] channel_18_analyzer_1_array_crystal_array_5\n");
    if (mcAbsorbProp[819]) fprintf(stderr, "Warning: %g events were removed in Component[819] channel_18_analyzer_1_array_crystal_array_5=Union_box()\n"
"         (negative time, miss next components, rounding errors, Nan, Inf).\n", mcAbsorbProp[819]);
    if (!mcNCounter[820]) fprintf(stderr, "Warning: No neutron could reach Component[820] channel_18_analyzer_1_array_crystal_array_6\n");
    if (mcAbsorbProp[820]) fprintf(stderr, "Warning: %g events were removed in Component[820] channel_18_analyzer_1_array_crystal_array_6=Union_box()\n"
"         (negative time, miss next components, rounding errors, Nan, Inf).\n", mcAbsorbProp[820]);
    if (!mcNCounter[821]) fprintf(stderr, "Warning: No neutron could reach Component[821] channel_18_analyzer_1_array_crystal_array_7\n");
    if (mcAbsorbProp[821]) fprintf(stderr, "Warning: %g events were removed in Component[821] channel_18_analyzer_1_array_crystal_array_7=Union_box()\n"
"         (negative time, miss next components, rounding errors, Nan, Inf).\n", mcAbsorbProp[821]);
    if (!mcNCounter[822]) fprintf(stderr, "Warning: No neutron could reach Component[822] channel_18_analyzer_1_array_crystal_array_8\n");
    if (mcAbsorbProp[822]) fprintf(stderr, "Warning: %g events were removed in Component[822] channel_18_analyzer_1_array_crystal_array_8=Union_box()\n"
"         (negative time, miss next components, rounding errors, Nan, Inf).\n", mcAbsorbProp[822]);
    if (!mcNCounter[823]) fprintf(stderr, "Warning: No neutron could reach Component[823] channel_18_analyzer_2_center\n");
    if (mcAbsorbProp[823]) fprintf(stderr, "Warning: %g events were removed in Component[823] channel_18_analyzer_2_center=Arm()\n"
"         (negative time, miss next components, rounding errors, Nan, Inf).\n", mcAbsorbProp[823]);
    if (!mcNCounter[824]) fprintf(stderr, "Warning: No neutron could reach Component[824] channel_18_analyzer_2_rotated\n");
    if (mcAbsorbProp[824]) fprintf(stderr, "Warning: %g events were removed in Component[824] channel_18_analyzer_2_rotated=Arm()\n"
"         (negative time, miss next components, rounding errors, Nan, Inf).\n", mcAbsorbProp[824]);
    if (!mcNCounter[825]) fprintf(stderr, "Warning: No neutron could reach Component[825] channel_18_analyzer_2_array_crystal_array_0\n");
    if (mcAbsorbProp[825]) fprintf(stderr, "Warning: %g events were removed in Component[825] channel_18_analyzer_2_array_crystal_array_0=Union_box()\n"
"         (negative time, miss next components, rounding errors, Nan, Inf).\n", mcAbsorbProp[825]);
    if (!mcNCounter[826]) fprintf(stderr, "Warning: No neutron could reach Component[826] channel_18_analyzer_2_array_crystal_array_1\n");
    if (mcAbsorbProp[826]) fprintf(stderr, "Warning: %g events were removed in Component[826] channel_18_analyzer_2_array_crystal_array_1=Union_box()\n"
"         (negative time, miss next components, rounding errors, Nan, Inf).\n", mcAbsorbProp[826]);
    if (!mcNCounter[827]) fprintf(stderr, "Warning: No neutron could reach Component[827] channel_18_analyzer_2_array_crystal_array_2\n");
    if (mcAbsorbProp[827]) fprintf(stderr, "Warning: %g events were removed in Component[827] channel_18_analyzer_2_array_crystal_array_2=Union_box()\n"
"         (negative time, miss next components, rounding errors, Nan, Inf).\n", mcAbsorbProp[827]);
    if (!mcNCounter[828]) fprintf(stderr, "Warning: No neutron could reach Component[828] channel_18_analyzer_2_array_crystal_array_3\n");
    if (mcAbsorbProp[828]) fprintf(stderr, "Warning: %g events were removed in Component[828] channel_18_analyzer_2_array_crystal_array_3=Union_box()\n"
"         (negative time, miss next components, rounding errors, Nan, Inf).\n", mcAbsorbProp[828]);
    if (!mcNCounter[829]) fprintf(stderr, "Warning: No neutron could reach Component[829] channel_18_analyzer_2_array_crystal_array_4\n");
    if (mcAbsorbProp[829]) fprintf(stderr, "Warning: %g events were removed in Component[829] channel_18_analyzer_2_array_crystal_array_4=Union_box()\n"
"         (negative time, miss next components, rounding errors, Nan, Inf).\n", mcAbsorbProp[829]);
    if (!mcNCounter[830]) fprintf(stderr, "Warning: No neutron could reach Component[830] channel_18_analyzer_2_array_crystal_array_5\n");
    if (mcAbsorbProp[830]) fprintf(stderr, "Warning: %g events were removed in Component[830] channel_18_analyzer_2_array_crystal_array_5=Union_box()\n"
"         (negative time, miss next components, rounding errors, Nan, Inf).\n", mcAbsorbProp[830]);
    if (!mcNCounter[831]) fprintf(stderr, "Warning: No neutron could reach Component[831] channel_18_analyzer_2_array_crystal_array_6\n");
    if (mcAbsorbProp[831]) fprintf(stderr, "Warning: %g events were removed in Component[831] channel_18_analyzer_2_array_crystal_array_6=Union_box()\n"
"         (negative time, miss next components, rounding errors, Nan, Inf).\n", mcAbsorbProp[831]);
    if (!mcNCounter[832]) fprintf(stderr, "Warning: No neutron could reach Component[832] channel_18_analyzer_2_array_crystal_array_7\n");
    if (mcAbsorbProp[832]) fprintf(stderr, "Warning: %g events were removed in Component[832] channel_18_analyzer_2_array_crystal_array_7=Union_box()\n"
"         (negative time, miss next components, rounding errors, Nan, Inf).\n", mcAbsorbProp[832]);
    if (!mcNCounter[833]) fprintf(stderr, "Warning: No neutron could reach Component[833] channel_18_analyzer_2_array_crystal_array_8\n");
    if (mcAbsorbProp[833]) fprintf(stderr, "Warning: %g events were removed in Component[833] channel_18_analyzer_2_array_crystal_array_8=Union_box()\n"
"         (negative time, miss next components, rounding errors, Nan, Inf).\n", mcAbsorbProp[833]);
    if (!mcNCounter[834]) fprintf(stderr, "Warning: No neutron could reach Component[834] channel_18_cave2_cyl1\n");
    if (mcAbsorbProp[834]) fprintf(stderr, "Warning: %g events were removed in Component[834] channel_18_cave2_cyl1=Union_cylinder()\n"
"         (negative time, miss next components, rounding errors, Nan, Inf).\n", mcAbsorbProp[834]);
    if (!mcNCounter[835]) fprintf(stderr, "Warning: No neutron could reach Component[835] channel_18_cave2_box1\n");
    if (mcAbsorbProp[835]) fprintf(stderr, "Warning: %g events were removed in Component[835] channel_18_cave2_box1=Union_box()\n"
"         (negative time, miss next components, rounding errors, Nan, Inf).\n", mcAbsorbProp[835]);
    if (!mcNCounter[836]) fprintf(stderr, "Warning: No neutron could reach Component[836] channel_18_cave2_box2\n");
    if (mcAbsorbProp[836]) fprintf(stderr, "Warning: %g events were removed in Component[836] channel_18_cave2_box2=Union_box()\n"
"         (negative time, miss next components, rounding errors, Nan, Inf).\n", mcAbsorbProp[836]);
    if (!mcNCounter[837]) fprintf(stderr, "Warning: No neutron could reach Component[837] channel_18_cave2_box3\n");
    if (mcAbsorbProp[837]) fprintf(stderr, "Warning: %g events were removed in Component[837] channel_18_cave2_box3=Union_box()\n"
"         (negative time, miss next components, rounding errors, Nan, Inf).\n", mcAbsorbProp[837]);
    if (!mcNCounter[838]) fprintf(stderr, "Warning: No neutron could reach Component[838] inter_analyzer_colimator_center_18\n");
    if (mcAbsorbProp[838]) fprintf(stderr, "Warning: %g events were removed in Component[838] inter_analyzer_colimator_center_18=Arm()\n"
"         (negative time, miss next components, rounding errors, Nan, Inf).\n", mcAbsorbProp[838]);
    if (!mcNCounter[839]) fprintf(stderr, "Warning: No neutron could reach Component[839] inter_analyzer_colimator_18_blade_0\n");
    if (mcAbsorbProp[839]) fprintf(stderr, "Warning: %g events were removed in Component[839] inter_analyzer_colimator_18_blade_0=Union_box()\n"
"         (negative time, miss next components, rounding errors, Nan, Inf).\n", mcAbsorbProp[839]);
    if (!mcNCounter[840]) fprintf(stderr, "Warning: No neutron could reach Component[840] inter_analyzer_colimator_18_blade_1\n");
    if (mcAbsorbProp[840]) fprintf(stderr, "Warning: %g events were removed in Component[840] inter_analyzer_colimator_18_blade_1=Union_box()\n"
"         (negative time, miss next components, rounding errors, Nan, Inf).\n", mcAbsorbProp[840]);
    if (!mcNCounter[841]) fprintf(stderr, "Warning: No neutron could reach Component[841] inter_analyzer_colimator_18_blade_2\n");
    if (mcAbsorbProp[841]) fprintf(stderr, "Warning: %g events were removed in Component[841] inter_analyzer_colimator_18_blade_2=Union_box()\n"
"         (negative time, miss next components, rounding errors, Nan, Inf).\n", mcAbsorbProp[841]);
    if (!mcNCounter[842]) fprintf(stderr, "Warning: No neutron could reach Component[842] inter_analyzer_colimator_18_blade_3\n");
    if (mcAbsorbProp[842]) fprintf(stderr, "Warning: %g events were removed in Component[842] inter_analyzer_colimator_18_blade_3=Union_box()\n"
"         (negative time, miss next components, rounding errors, Nan, Inf).\n", mcAbsorbProp[842]);
    if (!mcNCounter[843]) fprintf(stderr, "Warning: No neutron could reach Component[843] inter_analyzer_colimator_18_blade_4\n");
    if (mcAbsorbProp[843]) fprintf(stderr, "Warning: %g events were removed in Component[843] inter_analyzer_colimator_18_blade_4=Union_box()\n"
"         (negative time, miss next components, rounding errors, Nan, Inf).\n", mcAbsorbProp[843]);
    if (!mcNCounter[844]) fprintf(stderr, "Warning: No neutron could reach Component[844] diffraction_detector_18_exit_volume\n");
    if (mcAbsorbProp[844]) fprintf(stderr, "Warning: %g events were removed in Component[844] diffraction_detector_18_exit_volume=Union_box()\n"
"         (negative time, miss next components, rounding errors, Nan, Inf).\n", mcAbsorbProp[844]);
    if (!mcNCounter[845]) fprintf(stderr, "Warning: No neutron could reach Component[845] spec_detector_18_exit_volume\n");
    if (mcAbsorbProp[845]) fprintf(stderr, "Warning: %g events were removed in Component[845] spec_detector_18_exit_volume=Union_box()\n"
"         (negative time, miss next components, rounding errors, Nan, Inf).\n", mcAbsorbProp[845]);
    if (!mcNCounter[846]) fprintf(stderr, "Warning: No neutron could reach Component[846] channel_19_cave1_box1\n");
    if (mcAbsorbProp[846]) fprintf(stderr, "Warning: %g events were removed in Component[846] channel_19_cave1_box1=Union_box()\n"
"         (negative time, miss next components, rounding errors, Nan, Inf).\n", mcAbsorbProp[846]);
    if (!mcNCounter[847]) fprintf(stderr, "Warning: No neutron could reach Component[847] channel_19_cave1_box2\n");
    if (mcAbsorbProp[847]) fprintf(stderr, "Warning: %g events were removed in Component[847] channel_19_cave1_box2=Union_box()\n"
"         (negative time, miss next components, rounding errors, Nan, Inf).\n", mcAbsorbProp[847]);
    if (!mcNCounter[848]) fprintf(stderr, "Warning: No neutron could reach Component[848] channel_19_cave1_box3\n");
    if (mcAbsorbProp[848]) fprintf(stderr, "Warning: %g events were removed in Component[848] channel_19_cave1_box3=Union_box()\n"
"         (negative time, miss next components, rounding errors, Nan, Inf).\n", mcAbsorbProp[848]);
    if (!mcNCounter[849]) fprintf(stderr, "Warning: No neutron could reach Component[849] channel_19_cave1_cyl1\n");
    if (mcAbsorbProp[849]) fprintf(stderr, "Warning: %g events were removed in Component[849] channel_19_cave1_cyl1=Union_cylinder()\n"
"         (negative time, miss next components, rounding errors, Nan, Inf).\n", mcAbsorbProp[849]);
    if (!mcNCounter[850]) fprintf(stderr, "Warning: No neutron could reach Component[850] channel_19_analyzer_1_center\n");
    if (mcAbsorbProp[850]) fprintf(stderr, "Warning: %g events were removed in Component[850] channel_19_analyzer_1_center=Arm()\n"
"         (negative time, miss next components, rounding errors, Nan, Inf).\n", mcAbsorbProp[850]);
    if (!mcNCounter[851]) fprintf(stderr, "Warning: No neutron could reach Component[851] channel_19_analyzer_1_rotated\n");
    if (mcAbsorbProp[851]) fprintf(stderr, "Warning: %g events were removed in Component[851] channel_19_analyzer_1_rotated=Arm()\n"
"         (negative time, miss next components, rounding errors, Nan, Inf).\n", mcAbsorbProp[851]);
    if (!mcNCounter[852]) fprintf(stderr, "Warning: No neutron could reach Component[852] channel_19_analyzer_1_array_crystal_array_0\n");
    if (mcAbsorbProp[852]) fprintf(stderr, "Warning: %g events were removed in Component[852] channel_19_analyzer_1_array_crystal_array_0=Union_box()\n"
"         (negative time, miss next components, rounding errors, Nan, Inf).\n", mcAbsorbProp[852]);
    if (!mcNCounter[853]) fprintf(stderr, "Warning: No neutron could reach Component[853] channel_19_analyzer_1_array_crystal_array_1\n");
    if (mcAbsorbProp[853]) fprintf(stderr, "Warning: %g events were removed in Component[853] channel_19_analyzer_1_array_crystal_array_1=Union_box()\n"
"         (negative time, miss next components, rounding errors, Nan, Inf).\n", mcAbsorbProp[853]);
    if (!mcNCounter[854]) fprintf(stderr, "Warning: No neutron could reach Component[854] channel_19_analyzer_1_array_crystal_array_2\n");
    if (mcAbsorbProp[854]) fprintf(stderr, "Warning: %g events were removed in Component[854] channel_19_analyzer_1_array_crystal_array_2=Union_box()\n"
"         (negative time, miss next components, rounding errors, Nan, Inf).\n", mcAbsorbProp[854]);
    if (!mcNCounter[855]) fprintf(stderr, "Warning: No neutron could reach Component[855] channel_19_analyzer_1_array_crystal_array_3\n");
    if (mcAbsorbProp[855]) fprintf(stderr, "Warning: %g events were removed in Component[855] channel_19_analyzer_1_array_crystal_array_3=Union_box()\n"
"         (negative time, miss next components, rounding errors, Nan, Inf).\n", mcAbsorbProp[855]);
    if (!mcNCounter[856]) fprintf(stderr, "Warning: No neutron could reach Component[856] channel_19_analyzer_1_array_crystal_array_4\n");
    if (mcAbsorbProp[856]) fprintf(stderr, "Warning: %g events were removed in Component[856] channel_19_analyzer_1_array_crystal_array_4=Union_box()\n"
"         (negative time, miss next components, rounding errors, Nan, Inf).\n", mcAbsorbProp[856]);
    if (!mcNCounter[857]) fprintf(stderr, "Warning: No neutron could reach Component[857] channel_19_analyzer_1_array_crystal_array_5\n");
    if (mcAbsorbProp[857]) fprintf(stderr, "Warning: %g events were removed in Component[857] channel_19_analyzer_1_array_crystal_array_5=Union_box()\n"
"         (negative time, miss next components, rounding errors, Nan, Inf).\n", mcAbsorbProp[857]);
    if (!mcNCounter[858]) fprintf(stderr, "Warning: No neutron could reach Component[858] channel_19_analyzer_1_array_crystal_array_6\n");
    if (mcAbsorbProp[858]) fprintf(stderr, "Warning: %g events were removed in Component[858] channel_19_analyzer_1_array_crystal_array_6=Union_box()\n"
"         (negative time, miss next components, rounding errors, Nan, Inf).\n", mcAbsorbProp[858]);
    if (!mcNCounter[859]) fprintf(stderr, "Warning: No neutron could reach Component[859] channel_19_analyzer_1_array_crystal_array_7\n");
    if (mcAbsorbProp[859]) fprintf(stderr, "Warning: %g events were removed in Component[859] channel_19_analyzer_1_array_crystal_array_7=Union_box()\n"
"         (negative time, miss next components, rounding errors, Nan, Inf).\n", mcAbsorbProp[859]);
    if (!mcNCounter[860]) fprintf(stderr, "Warning: No neutron could reach Component[860] channel_19_analyzer_1_array_crystal_array_8\n");
    if (mcAbsorbProp[860]) fprintf(stderr, "Warning: %g events were removed in Component[860] channel_19_analyzer_1_array_crystal_array_8=Union_box()\n"
"         (negative time, miss next components, rounding errors, Nan, Inf).\n", mcAbsorbProp[860]);
    if (!mcNCounter[861]) fprintf(stderr, "Warning: No neutron could reach Component[861] channel_19_analyzer_2_center\n");
    if (mcAbsorbProp[861]) fprintf(stderr, "Warning: %g events were removed in Component[861] channel_19_analyzer_2_center=Arm()\n"
"         (negative time, miss next components, rounding errors, Nan, Inf).\n", mcAbsorbProp[861]);
    if (!mcNCounter[862]) fprintf(stderr, "Warning: No neutron could reach Component[862] channel_19_analyzer_2_rotated\n");
    if (mcAbsorbProp[862]) fprintf(stderr, "Warning: %g events were removed in Component[862] channel_19_analyzer_2_rotated=Arm()\n"
"         (negative time, miss next components, rounding errors, Nan, Inf).\n", mcAbsorbProp[862]);
    if (!mcNCounter[863]) fprintf(stderr, "Warning: No neutron could reach Component[863] channel_19_analyzer_2_array_crystal_array_0\n");
    if (mcAbsorbProp[863]) fprintf(stderr, "Warning: %g events were removed in Component[863] channel_19_analyzer_2_array_crystal_array_0=Union_box()\n"
"         (negative time, miss next components, rounding errors, Nan, Inf).\n", mcAbsorbProp[863]);
    if (!mcNCounter[864]) fprintf(stderr, "Warning: No neutron could reach Component[864] channel_19_analyzer_2_array_crystal_array_1\n");
    if (mcAbsorbProp[864]) fprintf(stderr, "Warning: %g events were removed in Component[864] channel_19_analyzer_2_array_crystal_array_1=Union_box()\n"
"         (negative time, miss next components, rounding errors, Nan, Inf).\n", mcAbsorbProp[864]);
    if (!mcNCounter[865]) fprintf(stderr, "Warning: No neutron could reach Component[865] channel_19_analyzer_2_array_crystal_array_2\n");
    if (mcAbsorbProp[865]) fprintf(stderr, "Warning: %g events were removed in Component[865] channel_19_analyzer_2_array_crystal_array_2=Union_box()\n"
"         (negative time, miss next components, rounding errors, Nan, Inf).\n", mcAbsorbProp[865]);
    if (!mcNCounter[866]) fprintf(stderr, "Warning: No neutron could reach Component[866] channel_19_analyzer_2_array_crystal_array_3\n");
    if (mcAbsorbProp[866]) fprintf(stderr, "Warning: %g events were removed in Component[866] channel_19_analyzer_2_array_crystal_array_3=Union_box()\n"
"         (negative time, miss next components, rounding errors, Nan, Inf).\n", mcAbsorbProp[866]);
    if (!mcNCounter[867]) fprintf(stderr, "Warning: No neutron could reach Component[867] channel_19_analyzer_2_array_crystal_array_4\n");
    if (mcAbsorbProp[867]) fprintf(stderr, "Warning: %g events were removed in Component[867] channel_19_analyzer_2_array_crystal_array_4=Union_box()\n"
"         (negative time, miss next components, rounding errors, Nan, Inf).\n", mcAbsorbProp[867]);
    if (!mcNCounter[868]) fprintf(stderr, "Warning: No neutron could reach Component[868] channel_19_analyzer_2_array_crystal_array_5\n");
    if (mcAbsorbProp[868]) fprintf(stderr, "Warning: %g events were removed in Component[868] channel_19_analyzer_2_array_crystal_array_5=Union_box()\n"
"         (negative time, miss next components, rounding errors, Nan, Inf).\n", mcAbsorbProp[868]);
    if (!mcNCounter[869]) fprintf(stderr, "Warning: No neutron could reach Component[869] channel_19_analyzer_2_array_crystal_array_6\n");
    if (mcAbsorbProp[869]) fprintf(stderr, "Warning: %g events were removed in Component[869] channel_19_analyzer_2_array_crystal_array_6=Union_box()\n"
"         (negative time, miss next components, rounding errors, Nan, Inf).\n", mcAbsorbProp[869]);
    if (!mcNCounter[870]) fprintf(stderr, "Warning: No neutron could reach Component[870] channel_19_analyzer_2_array_crystal_array_7\n");
    if (mcAbsorbProp[870]) fprintf(stderr, "Warning: %g events were removed in Component[870] channel_19_analyzer_2_array_crystal_array_7=Union_box()\n"
"         (negative time, miss next components, rounding errors, Nan, Inf).\n", mcAbsorbProp[870]);
    if (!mcNCounter[871]) fprintf(stderr, "Warning: No neutron could reach Component[871] channel_19_analyzer_2_array_crystal_array_8\n");
    if (mcAbsorbProp[871]) fprintf(stderr, "Warning: %g events were removed in Component[871] channel_19_analyzer_2_array_crystal_array_8=Union_box()\n"
"         (negative time, miss next components, rounding errors, Nan, Inf).\n", mcAbsorbProp[871]);
    if (!mcNCounter[872]) fprintf(stderr, "Warning: No neutron could reach Component[872] channel_19_cave2_cyl1\n");
    if (mcAbsorbProp[872]) fprintf(stderr, "Warning: %g events were removed in Component[872] channel_19_cave2_cyl1=Union_cylinder()\n"
"         (negative time, miss next components, rounding errors, Nan, Inf).\n", mcAbsorbProp[872]);
    if (!mcNCounter[873]) fprintf(stderr, "Warning: No neutron could reach Component[873] channel_19_cave2_box1\n");
    if (mcAbsorbProp[873]) fprintf(stderr, "Warning: %g events were removed in Component[873] channel_19_cave2_box1=Union_box()\n"
"         (negative time, miss next components, rounding errors, Nan, Inf).\n", mcAbsorbProp[873]);
    if (!mcNCounter[874]) fprintf(stderr, "Warning: No neutron could reach Component[874] channel_19_cave2_box2\n");
    if (mcAbsorbProp[874]) fprintf(stderr, "Warning: %g events were removed in Component[874] channel_19_cave2_box2=Union_box()\n"
"         (negative time, miss next components, rounding errors, Nan, Inf).\n", mcAbsorbProp[874]);
    if (!mcNCounter[875]) fprintf(stderr, "Warning: No neutron could reach Component[875] channel_19_cave2_box3\n");
    if (mcAbsorbProp[875]) fprintf(stderr, "Warning: %g events were removed in Component[875] channel_19_cave2_box3=Union_box()\n"
"         (negative time, miss next components, rounding errors, Nan, Inf).\n", mcAbsorbProp[875]);
    if (!mcNCounter[876]) fprintf(stderr, "Warning: No neutron could reach Component[876] inter_analyzer_colimator_center_19\n");
    if (mcAbsorbProp[876]) fprintf(stderr, "Warning: %g events were removed in Component[876] inter_analyzer_colimator_center_19=Arm()\n"
"         (negative time, miss next components, rounding errors, Nan, Inf).\n", mcAbsorbProp[876]);
    if (!mcNCounter[877]) fprintf(stderr, "Warning: No neutron could reach Component[877] inter_analyzer_colimator_19_blade_0\n");
    if (mcAbsorbProp[877]) fprintf(stderr, "Warning: %g events were removed in Component[877] inter_analyzer_colimator_19_blade_0=Union_box()\n"
"         (negative time, miss next components, rounding errors, Nan, Inf).\n", mcAbsorbProp[877]);
    if (!mcNCounter[878]) fprintf(stderr, "Warning: No neutron could reach Component[878] inter_analyzer_colimator_19_blade_1\n");
    if (mcAbsorbProp[878]) fprintf(stderr, "Warning: %g events were removed in Component[878] inter_analyzer_colimator_19_blade_1=Union_box()\n"
"         (negative time, miss next components, rounding errors, Nan, Inf).\n", mcAbsorbProp[878]);
    if (!mcNCounter[879]) fprintf(stderr, "Warning: No neutron could reach Component[879] inter_analyzer_colimator_19_blade_2\n");
    if (mcAbsorbProp[879]) fprintf(stderr, "Warning: %g events were removed in Component[879] inter_analyzer_colimator_19_blade_2=Union_box()\n"
"         (negative time, miss next components, rounding errors, Nan, Inf).\n", mcAbsorbProp[879]);
    if (!mcNCounter[880]) fprintf(stderr, "Warning: No neutron could reach Component[880] inter_analyzer_colimator_19_blade_3\n");
    if (mcAbsorbProp[880]) fprintf(stderr, "Warning: %g events were removed in Component[880] inter_analyzer_colimator_19_blade_3=Union_box()\n"
"         (negative time, miss next components, rounding errors, Nan, Inf).\n", mcAbsorbProp[880]);
    if (!mcNCounter[881]) fprintf(stderr, "Warning: No neutron could reach Component[881] inter_analyzer_colimator_19_blade_4\n");
    if (mcAbsorbProp[881]) fprintf(stderr, "Warning: %g events were removed in Component[881] inter_analyzer_colimator_19_blade_4=Union_box()\n"
"         (negative time, miss next components, rounding errors, Nan, Inf).\n", mcAbsorbProp[881]);
    if (!mcNCounter[882]) fprintf(stderr, "Warning: No neutron could reach Component[882] diffraction_detector_19_exit_volume\n");
    if (mcAbsorbProp[882]) fprintf(stderr, "Warning: %g events were removed in Component[882] diffraction_detector_19_exit_volume=Union_box()\n"
"         (negative time, miss next components, rounding errors, Nan, Inf).\n", mcAbsorbProp[882]);
    if (!mcNCounter[883]) fprintf(stderr, "Warning: No neutron could reach Component[883] spec_detector_19_exit_volume\n");
    if (mcAbsorbProp[883]) fprintf(stderr, "Warning: %g events were removed in Component[883] spec_detector_19_exit_volume=Union_box()\n"
"         (negative time, miss next components, rounding errors, Nan, Inf).\n", mcAbsorbProp[883]);
  /* User FINALLY code for component 'kidney_union_master'. */
  SIG_MESSAGE("kidney_union_master (Finally)");
#define mccompcurname  kidney_union_master
#define mccompcurtype  Union_master
#define mccompcurindex 884
#define verbal mcckidney_union_master_verbal
#define list_verbal mcckidney_union_master_list_verbal
#define trace_verbal mcckidney_union_master_trace_verbal
#define finally_verbal mcckidney_union_master_finally_verbal
#define starting_volume_warning mcckidney_union_master_starting_volume_warning
#define global_master_element mcckidney_union_master_global_master_element
#define this_global_master_index mcckidney_union_master_this_global_master_index
#define previous_master_index mcckidney_union_master_previous_master_index
#define geometry_list_index mcckidney_union_master_geometry_list_index
#define intersection_time_table mcckidney_union_master_intersection_time_table
#define Volumes mcckidney_union_master_Volumes
#define Geometries mcckidney_union_master_Geometries
#define starting_lists mcckidney_union_master_starting_lists
#define r mcckidney_union_master_r
#define r_start mcckidney_union_master_r_start
#define v mcckidney_union_master_v
#define error_msg mcckidney_union_master_error_msg
#define component_error_msg mcckidney_union_master_component_error_msg
#define string_output mcckidney_union_master_string_output
#define number_of_volumes mcckidney_union_master_number_of_volumes
#define volume_index mcckidney_union_master_volume_index
#define process_index mcckidney_union_master_process_index
#define solutions mcckidney_union_master_solutions
#define max_number_of_processes mcckidney_union_master_max_number_of_processes
#define limit mcckidney_union_master_limit
#define solution mcckidney_union_master_solution
#define min_solution mcckidney_union_master_min_solution
#define min_volume mcckidney_union_master_min_volume
#define time_found mcckidney_union_master_time_found
#define intersection_time mcckidney_union_master_intersection_time
#define min_intersection_time mcckidney_union_master_min_intersection_time
#define process mcckidney_union_master_process
#define process_start mcckidney_union_master_process_start
#define my_trace mcckidney_union_master_my_trace
#define p_my_trace mcckidney_union_master_p_my_trace
#define my_trace_fraction_control mcckidney_union_master_my_trace_fraction_control
#define k mcckidney_union_master_k
#define k_new mcckidney_union_master_k_new
#define k_old mcckidney_union_master_k_old
#define v_length mcckidney_union_master_v_length
#define my_sum mcckidney_union_master_my_sum
#define my_sum_plus_abs mcckidney_union_master_my_sum_plus_abs
#define culmative_probability mcckidney_union_master_culmative_probability
#define mc_prop mcckidney_union_master_mc_prop
#define time_to_scattering mcckidney_union_master_time_to_scattering
#define length_to_scattering mcckidney_union_master_length_to_scattering
#define length_to_boundery mcckidney_union_master_length_to_boundery
#define time_to_boundery mcckidney_union_master_time_to_boundery
#define selected_process mcckidney_union_master_selected_process
#define scattering_event mcckidney_union_master_scattering_event
#define time_propagated_without_scattering mcckidney_union_master_time_propagated_without_scattering
#define a_next_volume_found mcckidney_union_master_a_next_volume_found
#define next_volume mcckidney_union_master_next_volume
#define next_volume_priority mcckidney_union_master_next_volume_priority
#define done mcckidney_union_master_done
#define current_volume mcckidney_union_master_current_volume
#define number_of_solutions mcckidney_union_master_number_of_solutions
#define number_of_solutions_static mcckidney_union_master_number_of_solutions_static
#define check mcckidney_union_master_check
#define start mcckidney_union_master_start
#define intersection_with_children mcckidney_union_master_intersection_with_children
#define geometry_output mcckidney_union_master_geometry_output
#define tree_next_volume mcckidney_union_master_tree_next_volume
#define pre_allocated1 mcckidney_union_master_pre_allocated1
#define pre_allocated2 mcckidney_union_master_pre_allocated2
#define pre_allocated3 mcckidney_union_master_pre_allocated3
#define ray_position mcckidney_union_master_ray_position
#define ray_velocity mcckidney_union_master_ray_velocity
#define ray_velocity_final mcckidney_union_master_ray_velocity_final
#define volume_0_found mcckidney_union_master_volume_0_found
#define scattered_flag mcckidney_union_master_scattered_flag
#define scattered_flag_VP mcckidney_union_master_scattered_flag_VP
#define master_transposed_rotation_matrix mcckidney_union_master_master_transposed_rotation_matrix
#define temp_rotation_matrix mcckidney_union_master_temp_rotation_matrix
#define non_rotated_position mcckidney_union_master_non_rotated_position
#define rotated_position mcckidney_union_master_rotated_position
#define enable_tagging mcckidney_union_master_enable_tagging
#define stop_tagging_ray mcckidney_union_master_stop_tagging_ray
#define stop_creating_nodes mcckidney_union_master_stop_creating_nodes
#define enable_tagging_check mcckidney_union_master_enable_tagging_check
#define master_tagging_node_list mcckidney_union_master_master_tagging_node_list
#define current_tagging_node mcckidney_union_master_current_tagging_node
#define tagging_leaf_counter mcckidney_union_master_tagging_leaf_counter
#define number_of_scattering_events mcckidney_union_master_number_of_scattering_events
#define real_transmission_probability mcckidney_union_master_real_transmission_probability
#define mc_transmission_probability mcckidney_union_master_mc_transmission_probability
#define number_of_masks mcckidney_union_master_number_of_masks
#define number_of_masked_volumes mcckidney_union_master_number_of_masked_volumes
#define need_to_run_within_which_volume mcckidney_union_master_need_to_run_within_which_volume
#define mask_index_main mcckidney_union_master_mask_index_main
#define mask_iterate mcckidney_union_master_mask_iterate
#define mask_status_list mcckidney_union_master_mask_status_list
#define current_mask_intersect_list_status mcckidney_union_master_current_mask_intersect_list_status
#define mask_volume_index_list mcckidney_union_master_mask_volume_index_list
#define geometry_component_index_list mcckidney_union_master_geometry_component_index_list
#define Volume_copies_allocated mcckidney_union_master_Volume_copies_allocated
#define p_old mcckidney_union_master_p_old
#define this_logger mcckidney_union_master_this_logger
#define conditional_status mcckidney_union_master_conditional_status
#define tagging_conditional_list mcckidney_union_master_tagging_conditional_list
#define free_tagging_conditioanl_list mcckidney_union_master_free_tagging_conditioanl_list
#define logger_conditional_extend_array mcckidney_union_master_logger_conditional_extend_array
#define tagging_conditional_extend mcckidney_union_master_tagging_conditional_extend
#define max_conditional_extend_index mcckidney_union_master_max_conditional_extend_index
#define safty_distance mcckidney_union_master_safty_distance
#define safty_distance2 mcckidney_union_master_safty_distance2
#define number_of_processes_array mcckidney_union_master_number_of_processes_array
#define temporary_focus_data mcckidney_union_master_temporary_focus_data
#define focus_data_index mcckidney_union_master_focus_data_index
{   /* Declarations of kidney_union_master=Union_master() SETTING parameters. */
MCNUM allow_inside_start = mcckidney_union_master_allow_inside_start;
MCNUM history_limit = mcckidney_union_master_history_limit;
MCNUM enable_conditionals = mcckidney_union_master_enable_conditionals;
MCNUM inherit_number_of_scattering_events = mcckidney_union_master_inherit_number_of_scattering_events;
#line 1927 "Union_master.comp"
{
// write out histories from tagging system if enabled
if (enable_tagging) {
    if (finally_verbal) printf("Writing tagging tree to disk \n");
    if (finally_verbal) printf("Number of leafs = %d \n",tagging_leaf_counter);
    // While writing the tagging tree to disk, all the leafs are deallocated
    write_tagging_tree(&master_tagging_node_list, Volumes, tagging_leaf_counter, number_of_volumes);
}
if (master_tagging_node_list.num_elements > 0) free(master_tagging_node_list.elements);




if (finally_verbal) printf("Freeing variables which are always allocated \n");
// free allocated arrays specific to this master union component
free(scattered_flag);
free(my_trace);
free(pre_allocated1);
free(pre_allocated2);
free(pre_allocated3);
free(number_of_processes_array);

if (finally_verbal) printf("Freeing intersection_time_table \n");
for (iterate = 1;iterate < intersection_time_table.num_volumes;iterate++){
    free(intersection_time_table.intersection_times[iterate]);
}

free(intersection_time_table.n_elements);
free(intersection_time_table.calculated);
free(intersection_time_table.intersection_times);

if (free_tagging_conditioanl_list == 1) free(tagging_conditional_list);

/*
if (tagging_conditional_list->num_elements > 0) {
  free(tagging_conditional_list.conditional_functions);
  free(tagging_conditional_list.p_data_unions);
}
*/

if (finally_verbal) printf("Freeing lists for individual volumes \n");
for (volume_index=0;volume_index<number_of_volumes;volume_index++) {
  
  if (Volumes[volume_index]->geometry.intersect_check_list.num_elements > 0) free(Volumes[volume_index]->geometry.intersect_check_list.elements);
  if (Volumes[volume_index]->geometry.destinations_list.num_elements > 0) free(Volumes[volume_index]->geometry.destinations_list.elements);
  if (Volumes[volume_index]->geometry.reduced_destinations_list.num_elements > 0) free(Volumes[volume_index]->geometry.reduced_destinations_list.elements);
  if (Volumes[volume_index]->geometry.children.num_elements > 0) free(Volumes[volume_index]->geometry.children.elements);
  if (Volumes[volume_index]->geometry.direct_children.num_elements > 0) free(Volumes[volume_index]->geometry.direct_children.elements);
  if (Volumes[volume_index]->geometry.masked_by_list.num_elements > 0) free(Volumes[volume_index]->geometry.masked_by_list.elements);
  if (Volumes[volume_index]->geometry.masked_by_mask_index_list.num_elements > 0) free(Volumes[volume_index]->geometry.masked_by_mask_index_list.elements);
  if (Volumes[volume_index]->geometry.mask_list.num_elements > 0) free(Volumes[volume_index]->geometry.mask_list.elements);
  if (Volumes[volume_index]->geometry.mask_intersect_list.num_elements > 0) free(Volumes[volume_index]->geometry.mask_intersect_list.elements);
  if (enable_tagging)
    if (Volumes[volume_index]->geometry.next_volume_list.num_elements > 0) free(Volumes[volume_index]->geometry.next_volume_list.elements);
  // Add dealocation of logging
  

  if (volume_index > 0) { // Volume 0 does not have physical properties allocated
    free(scattered_flag_VP[volume_index]);
    if (Volumes[volume_index]->geometry.process_rot_allocated == 1) {
          free(Volumes[volume_index]->geometry.process_rot_matrix_array);
          free(Volumes[volume_index]->geometry.transpose_process_rot_matrix_array);
          Volumes[volume_index]->geometry.process_rot_allocated = 0;
    }
    if (on_int_list(Volume_copies_allocated,volume_index))
      // This is a local copy of a volume, deallocate that local copy (all the allocated memory attachted to it was just deallocated, so this should not leave any leaks)
      free(Volumes[volume_index]);
    else
      // Only free p_physics for vacuum volumes for the original at the end (there is a p_physics allocated for each vacuum volume)
      if (Volumes[volume_index]->p_physics->is_vacuum == 1 ) free(Volumes[volume_index]->p_physics);
  }
  
  if (Volumes[volume_index]->loggers.num_elements >0) {
    for (iterate=0;iterate<Volumes[volume_index]->loggers.num_elements;iterate++) {
      free(Volumes[volume_index]->loggers.p_logger_volume[iterate].p_logger_process);
    }
    free(Volumes[volume_index]->loggers.p_logger_volume);
  }
  
}

free(scattered_flag_VP);

if (finally_verbal) printf("Freeing starting lists \n");
if (starting_lists.allowed_starting_volume_logic_list.num_elements > 0) free(starting_lists.allowed_starting_volume_logic_list.elements);
if (starting_lists.reduced_start_list.num_elements > 0) free(starting_lists.reduced_start_list.elements);
if (starting_lists.start_logic_list.num_elements > 0) free(starting_lists.start_logic_list.elements);

if (finally_verbal) printf("Freeing mask lists \n");
if (mask_status_list.num_elements>0) free(mask_status_list.elements);
if (current_mask_intersect_list_status.num_elements>0) free(current_mask_intersect_list_status.elements);
if (mask_volume_index_list.num_elements>0) free(mask_volume_index_list.elements);

if (finally_verbal) printf("Freeing component index list \n");
if (geometry_component_index_list.num_elements>0) free(geometry_component_index_list.elements);


if (finally_verbal) printf("Freeing Volumes \n");
free(Volumes);

// Free global allocated arrays if this is the last master union component in the instrument file

if (global_master_list.elements[global_master_list.num_elements-1].component_index == INDEX_CURRENT_COMP) {
    if (finally_verbal) printf("Freeing global arrays because this is the last Union master component\n");
    
    // Freeing lists allocated in Union_initialization
    //#ifdef PROCESS_DETECTOR
        if (finally_verbal) printf("Freeing global process list \n");
        if (global_process_list.num_elements > 0) free(global_process_list.elements);
    //#endif

    //#ifdef MATERIAL_DETECTOR
        if (finally_verbal) printf("Freeing global material list \n");
        if (global_material_list.num_elements > 0) free(global_material_list.elements);
    //#endif

    //#ifdef ANY_GEOMETRY_DETECTOR_DECLARE
        if (finally_verbal) printf("Freeing global geometry list \n");
        if (global_geometry_list.num_elements > 0) free(global_geometry_list.elements);
    //#endif
    
    //#ifdef MASTER_DETECTOR
        if (finally_verbal) printf("Freeing global master list \n");
        if (global_master_list.num_elements > 0) free(global_master_list.elements);
    //#endif
    
    
    //#ifdef UNION_LOGGER_DECLARE
    if (finally_verbal) printf("Freeing global logger lists \n");
    for (iterate=0;iterate<global_all_volume_logger_list.num_elements;iterate++) {
      if (global_all_volume_logger_list.elements[iterate].logger->conditional_list.num_elements > 0) {
        free(global_all_volume_logger_list.elements[iterate].logger->conditional_list.conditional_functions);
        free(global_all_volume_logger_list.elements[iterate].logger->conditional_list.p_data_unions);
      }
    }
    if (global_all_volume_logger_list.num_elements > 0) free(global_all_volume_logger_list.elements);
    
    
    for (iterate=0;iterate<global_specific_volumes_logger_list.num_elements;iterate++) {
      if (global_specific_volumes_logger_list.elements[iterate].logger->conditional_list.num_elements > 0) {
        free(global_specific_volumes_logger_list.elements[iterate].logger->conditional_list.conditional_functions);
        free(global_specific_volumes_logger_list.elements[iterate].logger->conditional_list.p_data_unions);
      }
    }
    if (global_specific_volumes_logger_list.num_elements > 0) free(global_specific_volumes_logger_list.elements);
    //#endif
    
    for (iterate=0;iterate<global_tagging_conditional_list.num_elements;iterate++) {
      if (global_tagging_conditional_list.elements[iterate].conditional_list.num_elements > 0) {
        free(global_tagging_conditional_list.elements[iterate].conditional_list.conditional_functions);
        free(global_tagging_conditional_list.elements[iterate].conditional_list.p_data_unions);
      }
    }
    if (global_tagging_conditional_list.num_elements>0) free(global_tagging_conditional_list.elements);
    
    /*
    if (finally_verbal) printf("Freeing global tagging conditional list \n");
    if (global_tagging_conditional_list.num_elements > 0) free(global_tagging_conditional_list.elements);
    */
}

}
#line 478162 "MACS_sample_kidney_box.c"
}   /* End of kidney_union_master=Union_master() SETTING parameter declarations. */
#undef focus_data_index
#undef temporary_focus_data
#undef number_of_processes_array
#undef safty_distance2
#undef safty_distance
#undef max_conditional_extend_index
#undef tagging_conditional_extend
#undef logger_conditional_extend_array
#undef free_tagging_conditioanl_list
#undef tagging_conditional_list
#undef conditional_status
#undef this_logger
#undef p_old
#undef Volume_copies_allocated
#undef geometry_component_index_list
#undef mask_volume_index_list
#undef current_mask_intersect_list_status
#undef mask_status_list
#undef mask_iterate
#undef mask_index_main
#undef need_to_run_within_which_volume
#undef number_of_masked_volumes
#undef number_of_masks
#undef mc_transmission_probability
#undef real_transmission_probability
#undef number_of_scattering_events
#undef tagging_leaf_counter
#undef current_tagging_node
#undef master_tagging_node_list
#undef enable_tagging_check
#undef stop_creating_nodes
#undef stop_tagging_ray
#undef enable_tagging
#undef rotated_position
#undef non_rotated_position
#undef temp_rotation_matrix
#undef master_transposed_rotation_matrix
#undef scattered_flag_VP
#undef scattered_flag
#undef volume_0_found
#undef ray_velocity_final
#undef ray_velocity
#undef ray_position
#undef pre_allocated3
#undef pre_allocated2
#undef pre_allocated1
#undef tree_next_volume
#undef geometry_output
#undef intersection_with_children
#undef start
#undef check
#undef number_of_solutions_static
#undef number_of_solutions
#undef current_volume
#undef done
#undef next_volume_priority
#undef next_volume
#undef a_next_volume_found
#undef time_propagated_without_scattering
#undef scattering_event
#undef selected_process
#undef time_to_boundery
#undef length_to_boundery
#undef length_to_scattering
#undef time_to_scattering
#undef mc_prop
#undef culmative_probability
#undef my_sum_plus_abs
#undef my_sum
#undef v_length
#undef k_old
#undef k_new
#undef k
#undef my_trace_fraction_control
#undef p_my_trace
#undef my_trace
#undef process_start
#undef process
#undef min_intersection_time
#undef intersection_time
#undef time_found
#undef min_volume
#undef min_solution
#undef solution
#undef limit
#undef max_number_of_processes
#undef solutions
#undef process_index
#undef volume_index
#undef number_of_volumes
#undef string_output
#undef component_error_msg
#undef error_msg
#undef v
#undef r_start
#undef r
#undef starting_lists
#undef Geometries
#undef Volumes
#undef intersection_time_table
#undef geometry_list_index
#undef previous_master_index
#undef this_global_master_index
#undef global_master_element
#undef starting_volume_warning
#undef finally_verbal
#undef trace_verbal
#undef list_verbal
#undef verbal
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

    if (!mcNCounter[884]) fprintf(stderr, "Warning: No neutron could reach Component[884] kidney_union_master\n");
    if (mcAbsorbProp[884]) fprintf(stderr, "Warning: %g events were removed in Component[884] kidney_union_master=Union_master()\n"
"         (negative time, miss next components, rounding errors, Nan, Inf).\n", mcAbsorbProp[884]);
  /* User FINALLY code for component 'diffraction_detector_0'. */
  SIG_MESSAGE("diffraction_detector_0 (Finally)");
#define mccompcurname  diffraction_detector_0
#define mccompcurtype  PSD_monitor
#define mccompcurindex 885
#define PSD_N mccdiffraction_detector_0_PSD_N
#define PSD_p mccdiffraction_detector_0_PSD_p
#define PSD_p2 mccdiffraction_detector_0_PSD_p2
{   /* Declarations of diffraction_detector_0=PSD_monitor() SETTING parameters. */
int nx = mccdiffraction_detector_0_nx;
int ny = mccdiffraction_detector_0_ny;
char* filename = mccdiffraction_detector_0_filename;
MCNUM xmin = mccdiffraction_detector_0_xmin;
MCNUM xmax = mccdiffraction_detector_0_xmax;
MCNUM ymin = mccdiffraction_detector_0_ymin;
MCNUM ymax = mccdiffraction_detector_0_ymax;
MCNUM xwidth = mccdiffraction_detector_0_xwidth;
MCNUM yheight = mccdiffraction_detector_0_yheight;
MCNUM restore_neutron = mccdiffraction_detector_0_restore_neutron;
#line 122 "/usr/share/mcstas/2.7/monitors/PSD_monitor.comp"
{
  destroy_darr2d(PSD_N);
  destroy_darr2d(PSD_p);
  destroy_darr2d(PSD_p2);
}
#line 478304 "MACS_sample_kidney_box.c"
}   /* End of diffraction_detector_0=PSD_monitor() SETTING parameter declarations. */
#undef PSD_p2
#undef PSD_p
#undef PSD_N
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

    if (!mcNCounter[885]) fprintf(stderr, "Warning: No neutron could reach Component[885] diffraction_detector_0\n");
    if (mcAbsorbProp[885]) fprintf(stderr, "Warning: %g events were removed in Component[885] diffraction_detector_0=PSD_monitor()\n"
"         (negative time, miss next components, rounding errors, Nan, Inf).\n", mcAbsorbProp[885]);
  /* User FINALLY code for component 'spec_detector_0'. */
  SIG_MESSAGE("spec_detector_0 (Finally)");
#define mccompcurname  spec_detector_0
#define mccompcurtype  PSD_monitor
#define mccompcurindex 886
#define PSD_N mccspec_detector_0_PSD_N
#define PSD_p mccspec_detector_0_PSD_p
#define PSD_p2 mccspec_detector_0_PSD_p2
{   /* Declarations of spec_detector_0=PSD_monitor() SETTING parameters. */
int nx = mccspec_detector_0_nx;
int ny = mccspec_detector_0_ny;
char* filename = mccspec_detector_0_filename;
MCNUM xmin = mccspec_detector_0_xmin;
MCNUM xmax = mccspec_detector_0_xmax;
MCNUM ymin = mccspec_detector_0_ymin;
MCNUM ymax = mccspec_detector_0_ymax;
MCNUM xwidth = mccspec_detector_0_xwidth;
MCNUM yheight = mccspec_detector_0_yheight;
MCNUM restore_neutron = mccspec_detector_0_restore_neutron;
#line 122 "/usr/share/mcstas/2.7/monitors/PSD_monitor.comp"
{
  destroy_darr2d(PSD_N);
  destroy_darr2d(PSD_p);
  destroy_darr2d(PSD_p2);
}
#line 478340 "MACS_sample_kidney_box.c"
}   /* End of spec_detector_0=PSD_monitor() SETTING parameter declarations. */
#undef PSD_p2
#undef PSD_p
#undef PSD_N
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

    if (!mcNCounter[886]) fprintf(stderr, "Warning: No neutron could reach Component[886] spec_detector_0\n");
    if (mcAbsorbProp[886]) fprintf(stderr, "Warning: %g events were removed in Component[886] spec_detector_0=PSD_monitor()\n"
"         (negative time, miss next components, rounding errors, Nan, Inf).\n", mcAbsorbProp[886]);
  /* User FINALLY code for component 'diffraction_detector_1'. */
  SIG_MESSAGE("diffraction_detector_1 (Finally)");
#define mccompcurname  diffraction_detector_1
#define mccompcurtype  PSD_monitor
#define mccompcurindex 887
#define PSD_N mccdiffraction_detector_1_PSD_N
#define PSD_p mccdiffraction_detector_1_PSD_p
#define PSD_p2 mccdiffraction_detector_1_PSD_p2
{   /* Declarations of diffraction_detector_1=PSD_monitor() SETTING parameters. */
int nx = mccdiffraction_detector_1_nx;
int ny = mccdiffraction_detector_1_ny;
char* filename = mccdiffraction_detector_1_filename;
MCNUM xmin = mccdiffraction_detector_1_xmin;
MCNUM xmax = mccdiffraction_detector_1_xmax;
MCNUM ymin = mccdiffraction_detector_1_ymin;
MCNUM ymax = mccdiffraction_detector_1_ymax;
MCNUM xwidth = mccdiffraction_detector_1_xwidth;
MCNUM yheight = mccdiffraction_detector_1_yheight;
MCNUM restore_neutron = mccdiffraction_detector_1_restore_neutron;
#line 122 "/usr/share/mcstas/2.7/monitors/PSD_monitor.comp"
{
  destroy_darr2d(PSD_N);
  destroy_darr2d(PSD_p);
  destroy_darr2d(PSD_p2);
}
#line 478376 "MACS_sample_kidney_box.c"
}   /* End of diffraction_detector_1=PSD_monitor() SETTING parameter declarations. */
#undef PSD_p2
#undef PSD_p
#undef PSD_N
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

    if (!mcNCounter[887]) fprintf(stderr, "Warning: No neutron could reach Component[887] diffraction_detector_1\n");
    if (mcAbsorbProp[887]) fprintf(stderr, "Warning: %g events were removed in Component[887] diffraction_detector_1=PSD_monitor()\n"
"         (negative time, miss next components, rounding errors, Nan, Inf).\n", mcAbsorbProp[887]);
  /* User FINALLY code for component 'spec_detector_1'. */
  SIG_MESSAGE("spec_detector_1 (Finally)");
#define mccompcurname  spec_detector_1
#define mccompcurtype  PSD_monitor
#define mccompcurindex 888
#define PSD_N mccspec_detector_1_PSD_N
#define PSD_p mccspec_detector_1_PSD_p
#define PSD_p2 mccspec_detector_1_PSD_p2
{   /* Declarations of spec_detector_1=PSD_monitor() SETTING parameters. */
int nx = mccspec_detector_1_nx;
int ny = mccspec_detector_1_ny;
char* filename = mccspec_detector_1_filename;
MCNUM xmin = mccspec_detector_1_xmin;
MCNUM xmax = mccspec_detector_1_xmax;
MCNUM ymin = mccspec_detector_1_ymin;
MCNUM ymax = mccspec_detector_1_ymax;
MCNUM xwidth = mccspec_detector_1_xwidth;
MCNUM yheight = mccspec_detector_1_yheight;
MCNUM restore_neutron = mccspec_detector_1_restore_neutron;
#line 122 "/usr/share/mcstas/2.7/monitors/PSD_monitor.comp"
{
  destroy_darr2d(PSD_N);
  destroy_darr2d(PSD_p);
  destroy_darr2d(PSD_p2);
}
#line 478412 "MACS_sample_kidney_box.c"
}   /* End of spec_detector_1=PSD_monitor() SETTING parameter declarations. */
#undef PSD_p2
#undef PSD_p
#undef PSD_N
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

    if (!mcNCounter[888]) fprintf(stderr, "Warning: No neutron could reach Component[888] spec_detector_1\n");
    if (mcAbsorbProp[888]) fprintf(stderr, "Warning: %g events were removed in Component[888] spec_detector_1=PSD_monitor()\n"
"         (negative time, miss next components, rounding errors, Nan, Inf).\n", mcAbsorbProp[888]);
  /* User FINALLY code for component 'diffraction_detector_2'. */
  SIG_MESSAGE("diffraction_detector_2 (Finally)");
#define mccompcurname  diffraction_detector_2
#define mccompcurtype  PSD_monitor
#define mccompcurindex 889
#define PSD_N mccdiffraction_detector_2_PSD_N
#define PSD_p mccdiffraction_detector_2_PSD_p
#define PSD_p2 mccdiffraction_detector_2_PSD_p2
{   /* Declarations of diffraction_detector_2=PSD_monitor() SETTING parameters. */
int nx = mccdiffraction_detector_2_nx;
int ny = mccdiffraction_detector_2_ny;
char* filename = mccdiffraction_detector_2_filename;
MCNUM xmin = mccdiffraction_detector_2_xmin;
MCNUM xmax = mccdiffraction_detector_2_xmax;
MCNUM ymin = mccdiffraction_detector_2_ymin;
MCNUM ymax = mccdiffraction_detector_2_ymax;
MCNUM xwidth = mccdiffraction_detector_2_xwidth;
MCNUM yheight = mccdiffraction_detector_2_yheight;
MCNUM restore_neutron = mccdiffraction_detector_2_restore_neutron;
#line 122 "/usr/share/mcstas/2.7/monitors/PSD_monitor.comp"
{
  destroy_darr2d(PSD_N);
  destroy_darr2d(PSD_p);
  destroy_darr2d(PSD_p2);
}
#line 478448 "MACS_sample_kidney_box.c"
}   /* End of diffraction_detector_2=PSD_monitor() SETTING parameter declarations. */
#undef PSD_p2
#undef PSD_p
#undef PSD_N
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

    if (!mcNCounter[889]) fprintf(stderr, "Warning: No neutron could reach Component[889] diffraction_detector_2\n");
    if (mcAbsorbProp[889]) fprintf(stderr, "Warning: %g events were removed in Component[889] diffraction_detector_2=PSD_monitor()\n"
"         (negative time, miss next components, rounding errors, Nan, Inf).\n", mcAbsorbProp[889]);
  /* User FINALLY code for component 'spec_detector_2'. */
  SIG_MESSAGE("spec_detector_2 (Finally)");
#define mccompcurname  spec_detector_2
#define mccompcurtype  PSD_monitor
#define mccompcurindex 890
#define PSD_N mccspec_detector_2_PSD_N
#define PSD_p mccspec_detector_2_PSD_p
#define PSD_p2 mccspec_detector_2_PSD_p2
{   /* Declarations of spec_detector_2=PSD_monitor() SETTING parameters. */
int nx = mccspec_detector_2_nx;
int ny = mccspec_detector_2_ny;
char* filename = mccspec_detector_2_filename;
MCNUM xmin = mccspec_detector_2_xmin;
MCNUM xmax = mccspec_detector_2_xmax;
MCNUM ymin = mccspec_detector_2_ymin;
MCNUM ymax = mccspec_detector_2_ymax;
MCNUM xwidth = mccspec_detector_2_xwidth;
MCNUM yheight = mccspec_detector_2_yheight;
MCNUM restore_neutron = mccspec_detector_2_restore_neutron;
#line 122 "/usr/share/mcstas/2.7/monitors/PSD_monitor.comp"
{
  destroy_darr2d(PSD_N);
  destroy_darr2d(PSD_p);
  destroy_darr2d(PSD_p2);
}
#line 478484 "MACS_sample_kidney_box.c"
}   /* End of spec_detector_2=PSD_monitor() SETTING parameter declarations. */
#undef PSD_p2
#undef PSD_p
#undef PSD_N
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

    if (!mcNCounter[890]) fprintf(stderr, "Warning: No neutron could reach Component[890] spec_detector_2\n");
    if (mcAbsorbProp[890]) fprintf(stderr, "Warning: %g events were removed in Component[890] spec_detector_2=PSD_monitor()\n"
"         (negative time, miss next components, rounding errors, Nan, Inf).\n", mcAbsorbProp[890]);
  /* User FINALLY code for component 'diffraction_detector_3'. */
  SIG_MESSAGE("diffraction_detector_3 (Finally)");
#define mccompcurname  diffraction_detector_3
#define mccompcurtype  PSD_monitor
#define mccompcurindex 891
#define PSD_N mccdiffraction_detector_3_PSD_N
#define PSD_p mccdiffraction_detector_3_PSD_p
#define PSD_p2 mccdiffraction_detector_3_PSD_p2
{   /* Declarations of diffraction_detector_3=PSD_monitor() SETTING parameters. */
int nx = mccdiffraction_detector_3_nx;
int ny = mccdiffraction_detector_3_ny;
char* filename = mccdiffraction_detector_3_filename;
MCNUM xmin = mccdiffraction_detector_3_xmin;
MCNUM xmax = mccdiffraction_detector_3_xmax;
MCNUM ymin = mccdiffraction_detector_3_ymin;
MCNUM ymax = mccdiffraction_detector_3_ymax;
MCNUM xwidth = mccdiffraction_detector_3_xwidth;
MCNUM yheight = mccdiffraction_detector_3_yheight;
MCNUM restore_neutron = mccdiffraction_detector_3_restore_neutron;
#line 122 "/usr/share/mcstas/2.7/monitors/PSD_monitor.comp"
{
  destroy_darr2d(PSD_N);
  destroy_darr2d(PSD_p);
  destroy_darr2d(PSD_p2);
}
#line 478520 "MACS_sample_kidney_box.c"
}   /* End of diffraction_detector_3=PSD_monitor() SETTING parameter declarations. */
#undef PSD_p2
#undef PSD_p
#undef PSD_N
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

    if (!mcNCounter[891]) fprintf(stderr, "Warning: No neutron could reach Component[891] diffraction_detector_3\n");
    if (mcAbsorbProp[891]) fprintf(stderr, "Warning: %g events were removed in Component[891] diffraction_detector_3=PSD_monitor()\n"
"         (negative time, miss next components, rounding errors, Nan, Inf).\n", mcAbsorbProp[891]);
  /* User FINALLY code for component 'spec_detector_3'. */
  SIG_MESSAGE("spec_detector_3 (Finally)");
#define mccompcurname  spec_detector_3
#define mccompcurtype  PSD_monitor
#define mccompcurindex 892
#define PSD_N mccspec_detector_3_PSD_N
#define PSD_p mccspec_detector_3_PSD_p
#define PSD_p2 mccspec_detector_3_PSD_p2
{   /* Declarations of spec_detector_3=PSD_monitor() SETTING parameters. */
int nx = mccspec_detector_3_nx;
int ny = mccspec_detector_3_ny;
char* filename = mccspec_detector_3_filename;
MCNUM xmin = mccspec_detector_3_xmin;
MCNUM xmax = mccspec_detector_3_xmax;
MCNUM ymin = mccspec_detector_3_ymin;
MCNUM ymax = mccspec_detector_3_ymax;
MCNUM xwidth = mccspec_detector_3_xwidth;
MCNUM yheight = mccspec_detector_3_yheight;
MCNUM restore_neutron = mccspec_detector_3_restore_neutron;
#line 122 "/usr/share/mcstas/2.7/monitors/PSD_monitor.comp"
{
  destroy_darr2d(PSD_N);
  destroy_darr2d(PSD_p);
  destroy_darr2d(PSD_p2);
}
#line 478556 "MACS_sample_kidney_box.c"
}   /* End of spec_detector_3=PSD_monitor() SETTING parameter declarations. */
#undef PSD_p2
#undef PSD_p
#undef PSD_N
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

    if (!mcNCounter[892]) fprintf(stderr, "Warning: No neutron could reach Component[892] spec_detector_3\n");
    if (mcAbsorbProp[892]) fprintf(stderr, "Warning: %g events were removed in Component[892] spec_detector_3=PSD_monitor()\n"
"         (negative time, miss next components, rounding errors, Nan, Inf).\n", mcAbsorbProp[892]);
  /* User FINALLY code for component 'diffraction_detector_4'. */
  SIG_MESSAGE("diffraction_detector_4 (Finally)");
#define mccompcurname  diffraction_detector_4
#define mccompcurtype  PSD_monitor
#define mccompcurindex 893
#define PSD_N mccdiffraction_detector_4_PSD_N
#define PSD_p mccdiffraction_detector_4_PSD_p
#define PSD_p2 mccdiffraction_detector_4_PSD_p2
{   /* Declarations of diffraction_detector_4=PSD_monitor() SETTING parameters. */
int nx = mccdiffraction_detector_4_nx;
int ny = mccdiffraction_detector_4_ny;
char* filename = mccdiffraction_detector_4_filename;
MCNUM xmin = mccdiffraction_detector_4_xmin;
MCNUM xmax = mccdiffraction_detector_4_xmax;
MCNUM ymin = mccdiffraction_detector_4_ymin;
MCNUM ymax = mccdiffraction_detector_4_ymax;
MCNUM xwidth = mccdiffraction_detector_4_xwidth;
MCNUM yheight = mccdiffraction_detector_4_yheight;
MCNUM restore_neutron = mccdiffraction_detector_4_restore_neutron;
#line 122 "/usr/share/mcstas/2.7/monitors/PSD_monitor.comp"
{
  destroy_darr2d(PSD_N);
  destroy_darr2d(PSD_p);
  destroy_darr2d(PSD_p2);
}
#line 478592 "MACS_sample_kidney_box.c"
}   /* End of diffraction_detector_4=PSD_monitor() SETTING parameter declarations. */
#undef PSD_p2
#undef PSD_p
#undef PSD_N
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

    if (!mcNCounter[893]) fprintf(stderr, "Warning: No neutron could reach Component[893] diffraction_detector_4\n");
    if (mcAbsorbProp[893]) fprintf(stderr, "Warning: %g events were removed in Component[893] diffraction_detector_4=PSD_monitor()\n"
"         (negative time, miss next components, rounding errors, Nan, Inf).\n", mcAbsorbProp[893]);
  /* User FINALLY code for component 'spec_detector_4'. */
  SIG_MESSAGE("spec_detector_4 (Finally)");
#define mccompcurname  spec_detector_4
#define mccompcurtype  PSD_monitor
#define mccompcurindex 894
#define PSD_N mccspec_detector_4_PSD_N
#define PSD_p mccspec_detector_4_PSD_p
#define PSD_p2 mccspec_detector_4_PSD_p2
{   /* Declarations of spec_detector_4=PSD_monitor() SETTING parameters. */
int nx = mccspec_detector_4_nx;
int ny = mccspec_detector_4_ny;
char* filename = mccspec_detector_4_filename;
MCNUM xmin = mccspec_detector_4_xmin;
MCNUM xmax = mccspec_detector_4_xmax;
MCNUM ymin = mccspec_detector_4_ymin;
MCNUM ymax = mccspec_detector_4_ymax;
MCNUM xwidth = mccspec_detector_4_xwidth;
MCNUM yheight = mccspec_detector_4_yheight;
MCNUM restore_neutron = mccspec_detector_4_restore_neutron;
#line 122 "/usr/share/mcstas/2.7/monitors/PSD_monitor.comp"
{
  destroy_darr2d(PSD_N);
  destroy_darr2d(PSD_p);
  destroy_darr2d(PSD_p2);
}
#line 478628 "MACS_sample_kidney_box.c"
}   /* End of spec_detector_4=PSD_monitor() SETTING parameter declarations. */
#undef PSD_p2
#undef PSD_p
#undef PSD_N
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

    if (!mcNCounter[894]) fprintf(stderr, "Warning: No neutron could reach Component[894] spec_detector_4\n");
    if (mcAbsorbProp[894]) fprintf(stderr, "Warning: %g events were removed in Component[894] spec_detector_4=PSD_monitor()\n"
"         (negative time, miss next components, rounding errors, Nan, Inf).\n", mcAbsorbProp[894]);
  /* User FINALLY code for component 'diffraction_detector_5'. */
  SIG_MESSAGE("diffraction_detector_5 (Finally)");
#define mccompcurname  diffraction_detector_5
#define mccompcurtype  PSD_monitor
#define mccompcurindex 895
#define PSD_N mccdiffraction_detector_5_PSD_N
#define PSD_p mccdiffraction_detector_5_PSD_p
#define PSD_p2 mccdiffraction_detector_5_PSD_p2
{   /* Declarations of diffraction_detector_5=PSD_monitor() SETTING parameters. */
int nx = mccdiffraction_detector_5_nx;
int ny = mccdiffraction_detector_5_ny;
char* filename = mccdiffraction_detector_5_filename;
MCNUM xmin = mccdiffraction_detector_5_xmin;
MCNUM xmax = mccdiffraction_detector_5_xmax;
MCNUM ymin = mccdiffraction_detector_5_ymin;
MCNUM ymax = mccdiffraction_detector_5_ymax;
MCNUM xwidth = mccdiffraction_detector_5_xwidth;
MCNUM yheight = mccdiffraction_detector_5_yheight;
MCNUM restore_neutron = mccdiffraction_detector_5_restore_neutron;
#line 122 "/usr/share/mcstas/2.7/monitors/PSD_monitor.comp"
{
  destroy_darr2d(PSD_N);
  destroy_darr2d(PSD_p);
  destroy_darr2d(PSD_p2);
}
#line 478664 "MACS_sample_kidney_box.c"
}   /* End of diffraction_detector_5=PSD_monitor() SETTING parameter declarations. */
#undef PSD_p2
#undef PSD_p
#undef PSD_N
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

    if (!mcNCounter[895]) fprintf(stderr, "Warning: No neutron could reach Component[895] diffraction_detector_5\n");
    if (mcAbsorbProp[895]) fprintf(stderr, "Warning: %g events were removed in Component[895] diffraction_detector_5=PSD_monitor()\n"
"         (negative time, miss next components, rounding errors, Nan, Inf).\n", mcAbsorbProp[895]);
  /* User FINALLY code for component 'spec_detector_5'. */
  SIG_MESSAGE("spec_detector_5 (Finally)");
#define mccompcurname  spec_detector_5
#define mccompcurtype  PSD_monitor
#define mccompcurindex 896
#define PSD_N mccspec_detector_5_PSD_N
#define PSD_p mccspec_detector_5_PSD_p
#define PSD_p2 mccspec_detector_5_PSD_p2
{   /* Declarations of spec_detector_5=PSD_monitor() SETTING parameters. */
int nx = mccspec_detector_5_nx;
int ny = mccspec_detector_5_ny;
char* filename = mccspec_detector_5_filename;
MCNUM xmin = mccspec_detector_5_xmin;
MCNUM xmax = mccspec_detector_5_xmax;
MCNUM ymin = mccspec_detector_5_ymin;
MCNUM ymax = mccspec_detector_5_ymax;
MCNUM xwidth = mccspec_detector_5_xwidth;
MCNUM yheight = mccspec_detector_5_yheight;
MCNUM restore_neutron = mccspec_detector_5_restore_neutron;
#line 122 "/usr/share/mcstas/2.7/monitors/PSD_monitor.comp"
{
  destroy_darr2d(PSD_N);
  destroy_darr2d(PSD_p);
  destroy_darr2d(PSD_p2);
}
#line 478700 "MACS_sample_kidney_box.c"
}   /* End of spec_detector_5=PSD_monitor() SETTING parameter declarations. */
#undef PSD_p2
#undef PSD_p
#undef PSD_N
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

    if (!mcNCounter[896]) fprintf(stderr, "Warning: No neutron could reach Component[896] spec_detector_5\n");
    if (mcAbsorbProp[896]) fprintf(stderr, "Warning: %g events were removed in Component[896] spec_detector_5=PSD_monitor()\n"
"         (negative time, miss next components, rounding errors, Nan, Inf).\n", mcAbsorbProp[896]);
  /* User FINALLY code for component 'diffraction_detector_6'. */
  SIG_MESSAGE("diffraction_detector_6 (Finally)");
#define mccompcurname  diffraction_detector_6
#define mccompcurtype  PSD_monitor
#define mccompcurindex 897
#define PSD_N mccdiffraction_detector_6_PSD_N
#define PSD_p mccdiffraction_detector_6_PSD_p
#define PSD_p2 mccdiffraction_detector_6_PSD_p2
{   /* Declarations of diffraction_detector_6=PSD_monitor() SETTING parameters. */
int nx = mccdiffraction_detector_6_nx;
int ny = mccdiffraction_detector_6_ny;
char* filename = mccdiffraction_detector_6_filename;
MCNUM xmin = mccdiffraction_detector_6_xmin;
MCNUM xmax = mccdiffraction_detector_6_xmax;
MCNUM ymin = mccdiffraction_detector_6_ymin;
MCNUM ymax = mccdiffraction_detector_6_ymax;
MCNUM xwidth = mccdiffraction_detector_6_xwidth;
MCNUM yheight = mccdiffraction_detector_6_yheight;
MCNUM restore_neutron = mccdiffraction_detector_6_restore_neutron;
#line 122 "/usr/share/mcstas/2.7/monitors/PSD_monitor.comp"
{
  destroy_darr2d(PSD_N);
  destroy_darr2d(PSD_p);
  destroy_darr2d(PSD_p2);
}
#line 478736 "MACS_sample_kidney_box.c"
}   /* End of diffraction_detector_6=PSD_monitor() SETTING parameter declarations. */
#undef PSD_p2
#undef PSD_p
#undef PSD_N
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

    if (!mcNCounter[897]) fprintf(stderr, "Warning: No neutron could reach Component[897] diffraction_detector_6\n");
    if (mcAbsorbProp[897]) fprintf(stderr, "Warning: %g events were removed in Component[897] diffraction_detector_6=PSD_monitor()\n"
"         (negative time, miss next components, rounding errors, Nan, Inf).\n", mcAbsorbProp[897]);
  /* User FINALLY code for component 'spec_detector_6'. */
  SIG_MESSAGE("spec_detector_6 (Finally)");
#define mccompcurname  spec_detector_6
#define mccompcurtype  PSD_monitor
#define mccompcurindex 898
#define PSD_N mccspec_detector_6_PSD_N
#define PSD_p mccspec_detector_6_PSD_p
#define PSD_p2 mccspec_detector_6_PSD_p2
{   /* Declarations of spec_detector_6=PSD_monitor() SETTING parameters. */
int nx = mccspec_detector_6_nx;
int ny = mccspec_detector_6_ny;
char* filename = mccspec_detector_6_filename;
MCNUM xmin = mccspec_detector_6_xmin;
MCNUM xmax = mccspec_detector_6_xmax;
MCNUM ymin = mccspec_detector_6_ymin;
MCNUM ymax = mccspec_detector_6_ymax;
MCNUM xwidth = mccspec_detector_6_xwidth;
MCNUM yheight = mccspec_detector_6_yheight;
MCNUM restore_neutron = mccspec_detector_6_restore_neutron;
#line 122 "/usr/share/mcstas/2.7/monitors/PSD_monitor.comp"
{
  destroy_darr2d(PSD_N);
  destroy_darr2d(PSD_p);
  destroy_darr2d(PSD_p2);
}
#line 478772 "MACS_sample_kidney_box.c"
}   /* End of spec_detector_6=PSD_monitor() SETTING parameter declarations. */
#undef PSD_p2
#undef PSD_p
#undef PSD_N
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

    if (!mcNCounter[898]) fprintf(stderr, "Warning: No neutron could reach Component[898] spec_detector_6\n");
    if (mcAbsorbProp[898]) fprintf(stderr, "Warning: %g events were removed in Component[898] spec_detector_6=PSD_monitor()\n"
"         (negative time, miss next components, rounding errors, Nan, Inf).\n", mcAbsorbProp[898]);
  /* User FINALLY code for component 'diffraction_detector_7'. */
  SIG_MESSAGE("diffraction_detector_7 (Finally)");
#define mccompcurname  diffraction_detector_7
#define mccompcurtype  PSD_monitor
#define mccompcurindex 899
#define PSD_N mccdiffraction_detector_7_PSD_N
#define PSD_p mccdiffraction_detector_7_PSD_p
#define PSD_p2 mccdiffraction_detector_7_PSD_p2
{   /* Declarations of diffraction_detector_7=PSD_monitor() SETTING parameters. */
int nx = mccdiffraction_detector_7_nx;
int ny = mccdiffraction_detector_7_ny;
char* filename = mccdiffraction_detector_7_filename;
MCNUM xmin = mccdiffraction_detector_7_xmin;
MCNUM xmax = mccdiffraction_detector_7_xmax;
MCNUM ymin = mccdiffraction_detector_7_ymin;
MCNUM ymax = mccdiffraction_detector_7_ymax;
MCNUM xwidth = mccdiffraction_detector_7_xwidth;
MCNUM yheight = mccdiffraction_detector_7_yheight;
MCNUM restore_neutron = mccdiffraction_detector_7_restore_neutron;
#line 122 "/usr/share/mcstas/2.7/monitors/PSD_monitor.comp"
{
  destroy_darr2d(PSD_N);
  destroy_darr2d(PSD_p);
  destroy_darr2d(PSD_p2);
}
#line 478808 "MACS_sample_kidney_box.c"
}   /* End of diffraction_detector_7=PSD_monitor() SETTING parameter declarations. */
#undef PSD_p2
#undef PSD_p
#undef PSD_N
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

    if (!mcNCounter[899]) fprintf(stderr, "Warning: No neutron could reach Component[899] diffraction_detector_7\n");
    if (mcAbsorbProp[899]) fprintf(stderr, "Warning: %g events were removed in Component[899] diffraction_detector_7=PSD_monitor()\n"
"         (negative time, miss next components, rounding errors, Nan, Inf).\n", mcAbsorbProp[899]);
  /* User FINALLY code for component 'spec_detector_7'. */
  SIG_MESSAGE("spec_detector_7 (Finally)");
#define mccompcurname  spec_detector_7
#define mccompcurtype  PSD_monitor
#define mccompcurindex 900
#define PSD_N mccspec_detector_7_PSD_N
#define PSD_p mccspec_detector_7_PSD_p
#define PSD_p2 mccspec_detector_7_PSD_p2
{   /* Declarations of spec_detector_7=PSD_monitor() SETTING parameters. */
int nx = mccspec_detector_7_nx;
int ny = mccspec_detector_7_ny;
char* filename = mccspec_detector_7_filename;
MCNUM xmin = mccspec_detector_7_xmin;
MCNUM xmax = mccspec_detector_7_xmax;
MCNUM ymin = mccspec_detector_7_ymin;
MCNUM ymax = mccspec_detector_7_ymax;
MCNUM xwidth = mccspec_detector_7_xwidth;
MCNUM yheight = mccspec_detector_7_yheight;
MCNUM restore_neutron = mccspec_detector_7_restore_neutron;
#line 122 "/usr/share/mcstas/2.7/monitors/PSD_monitor.comp"
{
  destroy_darr2d(PSD_N);
  destroy_darr2d(PSD_p);
  destroy_darr2d(PSD_p2);
}
#line 478844 "MACS_sample_kidney_box.c"
}   /* End of spec_detector_7=PSD_monitor() SETTING parameter declarations. */
#undef PSD_p2
#undef PSD_p
#undef PSD_N
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

    if (!mcNCounter[900]) fprintf(stderr, "Warning: No neutron could reach Component[900] spec_detector_7\n");
    if (mcAbsorbProp[900]) fprintf(stderr, "Warning: %g events were removed in Component[900] spec_detector_7=PSD_monitor()\n"
"         (negative time, miss next components, rounding errors, Nan, Inf).\n", mcAbsorbProp[900]);
  /* User FINALLY code for component 'diffraction_detector_8'. */
  SIG_MESSAGE("diffraction_detector_8 (Finally)");
#define mccompcurname  diffraction_detector_8
#define mccompcurtype  PSD_monitor
#define mccompcurindex 901
#define PSD_N mccdiffraction_detector_8_PSD_N
#define PSD_p mccdiffraction_detector_8_PSD_p
#define PSD_p2 mccdiffraction_detector_8_PSD_p2
{   /* Declarations of diffraction_detector_8=PSD_monitor() SETTING parameters. */
int nx = mccdiffraction_detector_8_nx;
int ny = mccdiffraction_detector_8_ny;
char* filename = mccdiffraction_detector_8_filename;
MCNUM xmin = mccdiffraction_detector_8_xmin;
MCNUM xmax = mccdiffraction_detector_8_xmax;
MCNUM ymin = mccdiffraction_detector_8_ymin;
MCNUM ymax = mccdiffraction_detector_8_ymax;
MCNUM xwidth = mccdiffraction_detector_8_xwidth;
MCNUM yheight = mccdiffraction_detector_8_yheight;
MCNUM restore_neutron = mccdiffraction_detector_8_restore_neutron;
#line 122 "/usr/share/mcstas/2.7/monitors/PSD_monitor.comp"
{
  destroy_darr2d(PSD_N);
  destroy_darr2d(PSD_p);
  destroy_darr2d(PSD_p2);
}
#line 478880 "MACS_sample_kidney_box.c"
}   /* End of diffraction_detector_8=PSD_monitor() SETTING parameter declarations. */
#undef PSD_p2
#undef PSD_p
#undef PSD_N
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

    if (!mcNCounter[901]) fprintf(stderr, "Warning: No neutron could reach Component[901] diffraction_detector_8\n");
    if (mcAbsorbProp[901]) fprintf(stderr, "Warning: %g events were removed in Component[901] diffraction_detector_8=PSD_monitor()\n"
"         (negative time, miss next components, rounding errors, Nan, Inf).\n", mcAbsorbProp[901]);
  /* User FINALLY code for component 'spec_detector_8'. */
  SIG_MESSAGE("spec_detector_8 (Finally)");
#define mccompcurname  spec_detector_8
#define mccompcurtype  PSD_monitor
#define mccompcurindex 902
#define PSD_N mccspec_detector_8_PSD_N
#define PSD_p mccspec_detector_8_PSD_p
#define PSD_p2 mccspec_detector_8_PSD_p2
{   /* Declarations of spec_detector_8=PSD_monitor() SETTING parameters. */
int nx = mccspec_detector_8_nx;
int ny = mccspec_detector_8_ny;
char* filename = mccspec_detector_8_filename;
MCNUM xmin = mccspec_detector_8_xmin;
MCNUM xmax = mccspec_detector_8_xmax;
MCNUM ymin = mccspec_detector_8_ymin;
MCNUM ymax = mccspec_detector_8_ymax;
MCNUM xwidth = mccspec_detector_8_xwidth;
MCNUM yheight = mccspec_detector_8_yheight;
MCNUM restore_neutron = mccspec_detector_8_restore_neutron;
#line 122 "/usr/share/mcstas/2.7/monitors/PSD_monitor.comp"
{
  destroy_darr2d(PSD_N);
  destroy_darr2d(PSD_p);
  destroy_darr2d(PSD_p2);
}
#line 478916 "MACS_sample_kidney_box.c"
}   /* End of spec_detector_8=PSD_monitor() SETTING parameter declarations. */
#undef PSD_p2
#undef PSD_p
#undef PSD_N
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

    if (!mcNCounter[902]) fprintf(stderr, "Warning: No neutron could reach Component[902] spec_detector_8\n");
    if (mcAbsorbProp[902]) fprintf(stderr, "Warning: %g events were removed in Component[902] spec_detector_8=PSD_monitor()\n"
"         (negative time, miss next components, rounding errors, Nan, Inf).\n", mcAbsorbProp[902]);
  /* User FINALLY code for component 'diffraction_detector_9'. */
  SIG_MESSAGE("diffraction_detector_9 (Finally)");
#define mccompcurname  diffraction_detector_9
#define mccompcurtype  PSD_monitor
#define mccompcurindex 903
#define PSD_N mccdiffraction_detector_9_PSD_N
#define PSD_p mccdiffraction_detector_9_PSD_p
#define PSD_p2 mccdiffraction_detector_9_PSD_p2
{   /* Declarations of diffraction_detector_9=PSD_monitor() SETTING parameters. */
int nx = mccdiffraction_detector_9_nx;
int ny = mccdiffraction_detector_9_ny;
char* filename = mccdiffraction_detector_9_filename;
MCNUM xmin = mccdiffraction_detector_9_xmin;
MCNUM xmax = mccdiffraction_detector_9_xmax;
MCNUM ymin = mccdiffraction_detector_9_ymin;
MCNUM ymax = mccdiffraction_detector_9_ymax;
MCNUM xwidth = mccdiffraction_detector_9_xwidth;
MCNUM yheight = mccdiffraction_detector_9_yheight;
MCNUM restore_neutron = mccdiffraction_detector_9_restore_neutron;
#line 122 "/usr/share/mcstas/2.7/monitors/PSD_monitor.comp"
{
  destroy_darr2d(PSD_N);
  destroy_darr2d(PSD_p);
  destroy_darr2d(PSD_p2);
}
#line 478952 "MACS_sample_kidney_box.c"
}   /* End of diffraction_detector_9=PSD_monitor() SETTING parameter declarations. */
#undef PSD_p2
#undef PSD_p
#undef PSD_N
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

    if (!mcNCounter[903]) fprintf(stderr, "Warning: No neutron could reach Component[903] diffraction_detector_9\n");
    if (mcAbsorbProp[903]) fprintf(stderr, "Warning: %g events were removed in Component[903] diffraction_detector_9=PSD_monitor()\n"
"         (negative time, miss next components, rounding errors, Nan, Inf).\n", mcAbsorbProp[903]);
  /* User FINALLY code for component 'spec_detector_9'. */
  SIG_MESSAGE("spec_detector_9 (Finally)");
#define mccompcurname  spec_detector_9
#define mccompcurtype  PSD_monitor
#define mccompcurindex 904
#define PSD_N mccspec_detector_9_PSD_N
#define PSD_p mccspec_detector_9_PSD_p
#define PSD_p2 mccspec_detector_9_PSD_p2
{   /* Declarations of spec_detector_9=PSD_monitor() SETTING parameters. */
int nx = mccspec_detector_9_nx;
int ny = mccspec_detector_9_ny;
char* filename = mccspec_detector_9_filename;
MCNUM xmin = mccspec_detector_9_xmin;
MCNUM xmax = mccspec_detector_9_xmax;
MCNUM ymin = mccspec_detector_9_ymin;
MCNUM ymax = mccspec_detector_9_ymax;
MCNUM xwidth = mccspec_detector_9_xwidth;
MCNUM yheight = mccspec_detector_9_yheight;
MCNUM restore_neutron = mccspec_detector_9_restore_neutron;
#line 122 "/usr/share/mcstas/2.7/monitors/PSD_monitor.comp"
{
  destroy_darr2d(PSD_N);
  destroy_darr2d(PSD_p);
  destroy_darr2d(PSD_p2);
}
#line 478988 "MACS_sample_kidney_box.c"
}   /* End of spec_detector_9=PSD_monitor() SETTING parameter declarations. */
#undef PSD_p2
#undef PSD_p
#undef PSD_N
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

    if (!mcNCounter[904]) fprintf(stderr, "Warning: No neutron could reach Component[904] spec_detector_9\n");
    if (mcAbsorbProp[904]) fprintf(stderr, "Warning: %g events were removed in Component[904] spec_detector_9=PSD_monitor()\n"
"         (negative time, miss next components, rounding errors, Nan, Inf).\n", mcAbsorbProp[904]);
  /* User FINALLY code for component 'diffraction_detector_10'. */
  SIG_MESSAGE("diffraction_detector_10 (Finally)");
#define mccompcurname  diffraction_detector_10
#define mccompcurtype  PSD_monitor
#define mccompcurindex 905
#define PSD_N mccdiffraction_detector_10_PSD_N
#define PSD_p mccdiffraction_detector_10_PSD_p
#define PSD_p2 mccdiffraction_detector_10_PSD_p2
{   /* Declarations of diffraction_detector_10=PSD_monitor() SETTING parameters. */
int nx = mccdiffraction_detector_10_nx;
int ny = mccdiffraction_detector_10_ny;
char* filename = mccdiffraction_detector_10_filename;
MCNUM xmin = mccdiffraction_detector_10_xmin;
MCNUM xmax = mccdiffraction_detector_10_xmax;
MCNUM ymin = mccdiffraction_detector_10_ymin;
MCNUM ymax = mccdiffraction_detector_10_ymax;
MCNUM xwidth = mccdiffraction_detector_10_xwidth;
MCNUM yheight = mccdiffraction_detector_10_yheight;
MCNUM restore_neutron = mccdiffraction_detector_10_restore_neutron;
#line 122 "/usr/share/mcstas/2.7/monitors/PSD_monitor.comp"
{
  destroy_darr2d(PSD_N);
  destroy_darr2d(PSD_p);
  destroy_darr2d(PSD_p2);
}
#line 479024 "MACS_sample_kidney_box.c"
}   /* End of diffraction_detector_10=PSD_monitor() SETTING parameter declarations. */
#undef PSD_p2
#undef PSD_p
#undef PSD_N
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

    if (!mcNCounter[905]) fprintf(stderr, "Warning: No neutron could reach Component[905] diffraction_detector_10\n");
    if (mcAbsorbProp[905]) fprintf(stderr, "Warning: %g events were removed in Component[905] diffraction_detector_10=PSD_monitor()\n"
"         (negative time, miss next components, rounding errors, Nan, Inf).\n", mcAbsorbProp[905]);
  /* User FINALLY code for component 'spec_detector_10'. */
  SIG_MESSAGE("spec_detector_10 (Finally)");
#define mccompcurname  spec_detector_10
#define mccompcurtype  PSD_monitor
#define mccompcurindex 906
#define PSD_N mccspec_detector_10_PSD_N
#define PSD_p mccspec_detector_10_PSD_p
#define PSD_p2 mccspec_detector_10_PSD_p2
{   /* Declarations of spec_detector_10=PSD_monitor() SETTING parameters. */
int nx = mccspec_detector_10_nx;
int ny = mccspec_detector_10_ny;
char* filename = mccspec_detector_10_filename;
MCNUM xmin = mccspec_detector_10_xmin;
MCNUM xmax = mccspec_detector_10_xmax;
MCNUM ymin = mccspec_detector_10_ymin;
MCNUM ymax = mccspec_detector_10_ymax;
MCNUM xwidth = mccspec_detector_10_xwidth;
MCNUM yheight = mccspec_detector_10_yheight;
MCNUM restore_neutron = mccspec_detector_10_restore_neutron;
#line 122 "/usr/share/mcstas/2.7/monitors/PSD_monitor.comp"
{
  destroy_darr2d(PSD_N);
  destroy_darr2d(PSD_p);
  destroy_darr2d(PSD_p2);
}
#line 479060 "MACS_sample_kidney_box.c"
}   /* End of spec_detector_10=PSD_monitor() SETTING parameter declarations. */
#undef PSD_p2
#undef PSD_p
#undef PSD_N
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

    if (!mcNCounter[906]) fprintf(stderr, "Warning: No neutron could reach Component[906] spec_detector_10\n");
    if (mcAbsorbProp[906]) fprintf(stderr, "Warning: %g events were removed in Component[906] spec_detector_10=PSD_monitor()\n"
"         (negative time, miss next components, rounding errors, Nan, Inf).\n", mcAbsorbProp[906]);
  /* User FINALLY code for component 'diffraction_detector_11'. */
  SIG_MESSAGE("diffraction_detector_11 (Finally)");
#define mccompcurname  diffraction_detector_11
#define mccompcurtype  PSD_monitor
#define mccompcurindex 907
#define PSD_N mccdiffraction_detector_11_PSD_N
#define PSD_p mccdiffraction_detector_11_PSD_p
#define PSD_p2 mccdiffraction_detector_11_PSD_p2
{   /* Declarations of diffraction_detector_11=PSD_monitor() SETTING parameters. */
int nx = mccdiffraction_detector_11_nx;
int ny = mccdiffraction_detector_11_ny;
char* filename = mccdiffraction_detector_11_filename;
MCNUM xmin = mccdiffraction_detector_11_xmin;
MCNUM xmax = mccdiffraction_detector_11_xmax;
MCNUM ymin = mccdiffraction_detector_11_ymin;
MCNUM ymax = mccdiffraction_detector_11_ymax;
MCNUM xwidth = mccdiffraction_detector_11_xwidth;
MCNUM yheight = mccdiffraction_detector_11_yheight;
MCNUM restore_neutron = mccdiffraction_detector_11_restore_neutron;
#line 122 "/usr/share/mcstas/2.7/monitors/PSD_monitor.comp"
{
  destroy_darr2d(PSD_N);
  destroy_darr2d(PSD_p);
  destroy_darr2d(PSD_p2);
}
#line 479096 "MACS_sample_kidney_box.c"
}   /* End of diffraction_detector_11=PSD_monitor() SETTING parameter declarations. */
#undef PSD_p2
#undef PSD_p
#undef PSD_N
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

    if (!mcNCounter[907]) fprintf(stderr, "Warning: No neutron could reach Component[907] diffraction_detector_11\n");
    if (mcAbsorbProp[907]) fprintf(stderr, "Warning: %g events were removed in Component[907] diffraction_detector_11=PSD_monitor()\n"
"         (negative time, miss next components, rounding errors, Nan, Inf).\n", mcAbsorbProp[907]);
  /* User FINALLY code for component 'spec_detector_11'. */
  SIG_MESSAGE("spec_detector_11 (Finally)");
#define mccompcurname  spec_detector_11
#define mccompcurtype  PSD_monitor
#define mccompcurindex 908
#define PSD_N mccspec_detector_11_PSD_N
#define PSD_p mccspec_detector_11_PSD_p
#define PSD_p2 mccspec_detector_11_PSD_p2
{   /* Declarations of spec_detector_11=PSD_monitor() SETTING parameters. */
int nx = mccspec_detector_11_nx;
int ny = mccspec_detector_11_ny;
char* filename = mccspec_detector_11_filename;
MCNUM xmin = mccspec_detector_11_xmin;
MCNUM xmax = mccspec_detector_11_xmax;
MCNUM ymin = mccspec_detector_11_ymin;
MCNUM ymax = mccspec_detector_11_ymax;
MCNUM xwidth = mccspec_detector_11_xwidth;
MCNUM yheight = mccspec_detector_11_yheight;
MCNUM restore_neutron = mccspec_detector_11_restore_neutron;
#line 122 "/usr/share/mcstas/2.7/monitors/PSD_monitor.comp"
{
  destroy_darr2d(PSD_N);
  destroy_darr2d(PSD_p);
  destroy_darr2d(PSD_p2);
}
#line 479132 "MACS_sample_kidney_box.c"
}   /* End of spec_detector_11=PSD_monitor() SETTING parameter declarations. */
#undef PSD_p2
#undef PSD_p
#undef PSD_N
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

    if (!mcNCounter[908]) fprintf(stderr, "Warning: No neutron could reach Component[908] spec_detector_11\n");
    if (mcAbsorbProp[908]) fprintf(stderr, "Warning: %g events were removed in Component[908] spec_detector_11=PSD_monitor()\n"
"         (negative time, miss next components, rounding errors, Nan, Inf).\n", mcAbsorbProp[908]);
  /* User FINALLY code for component 'diffraction_detector_12'. */
  SIG_MESSAGE("diffraction_detector_12 (Finally)");
#define mccompcurname  diffraction_detector_12
#define mccompcurtype  PSD_monitor
#define mccompcurindex 909
#define PSD_N mccdiffraction_detector_12_PSD_N
#define PSD_p mccdiffraction_detector_12_PSD_p
#define PSD_p2 mccdiffraction_detector_12_PSD_p2
{   /* Declarations of diffraction_detector_12=PSD_monitor() SETTING parameters. */
int nx = mccdiffraction_detector_12_nx;
int ny = mccdiffraction_detector_12_ny;
char* filename = mccdiffraction_detector_12_filename;
MCNUM xmin = mccdiffraction_detector_12_xmin;
MCNUM xmax = mccdiffraction_detector_12_xmax;
MCNUM ymin = mccdiffraction_detector_12_ymin;
MCNUM ymax = mccdiffraction_detector_12_ymax;
MCNUM xwidth = mccdiffraction_detector_12_xwidth;
MCNUM yheight = mccdiffraction_detector_12_yheight;
MCNUM restore_neutron = mccdiffraction_detector_12_restore_neutron;
#line 122 "/usr/share/mcstas/2.7/monitors/PSD_monitor.comp"
{
  destroy_darr2d(PSD_N);
  destroy_darr2d(PSD_p);
  destroy_darr2d(PSD_p2);
}
#line 479168 "MACS_sample_kidney_box.c"
}   /* End of diffraction_detector_12=PSD_monitor() SETTING parameter declarations. */
#undef PSD_p2
#undef PSD_p
#undef PSD_N
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

    if (!mcNCounter[909]) fprintf(stderr, "Warning: No neutron could reach Component[909] diffraction_detector_12\n");
    if (mcAbsorbProp[909]) fprintf(stderr, "Warning: %g events were removed in Component[909] diffraction_detector_12=PSD_monitor()\n"
"         (negative time, miss next components, rounding errors, Nan, Inf).\n", mcAbsorbProp[909]);
  /* User FINALLY code for component 'spec_detector_12'. */
  SIG_MESSAGE("spec_detector_12 (Finally)");
#define mccompcurname  spec_detector_12
#define mccompcurtype  PSD_monitor
#define mccompcurindex 910
#define PSD_N mccspec_detector_12_PSD_N
#define PSD_p mccspec_detector_12_PSD_p
#define PSD_p2 mccspec_detector_12_PSD_p2
{   /* Declarations of spec_detector_12=PSD_monitor() SETTING parameters. */
int nx = mccspec_detector_12_nx;
int ny = mccspec_detector_12_ny;
char* filename = mccspec_detector_12_filename;
MCNUM xmin = mccspec_detector_12_xmin;
MCNUM xmax = mccspec_detector_12_xmax;
MCNUM ymin = mccspec_detector_12_ymin;
MCNUM ymax = mccspec_detector_12_ymax;
MCNUM xwidth = mccspec_detector_12_xwidth;
MCNUM yheight = mccspec_detector_12_yheight;
MCNUM restore_neutron = mccspec_detector_12_restore_neutron;
#line 122 "/usr/share/mcstas/2.7/monitors/PSD_monitor.comp"
{
  destroy_darr2d(PSD_N);
  destroy_darr2d(PSD_p);
  destroy_darr2d(PSD_p2);
}
#line 479204 "MACS_sample_kidney_box.c"
}   /* End of spec_detector_12=PSD_monitor() SETTING parameter declarations. */
#undef PSD_p2
#undef PSD_p
#undef PSD_N
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

    if (!mcNCounter[910]) fprintf(stderr, "Warning: No neutron could reach Component[910] spec_detector_12\n");
    if (mcAbsorbProp[910]) fprintf(stderr, "Warning: %g events were removed in Component[910] spec_detector_12=PSD_monitor()\n"
"         (negative time, miss next components, rounding errors, Nan, Inf).\n", mcAbsorbProp[910]);
  /* User FINALLY code for component 'diffraction_detector_13'. */
  SIG_MESSAGE("diffraction_detector_13 (Finally)");
#define mccompcurname  diffraction_detector_13
#define mccompcurtype  PSD_monitor
#define mccompcurindex 911
#define PSD_N mccdiffraction_detector_13_PSD_N
#define PSD_p mccdiffraction_detector_13_PSD_p
#define PSD_p2 mccdiffraction_detector_13_PSD_p2
{   /* Declarations of diffraction_detector_13=PSD_monitor() SETTING parameters. */
int nx = mccdiffraction_detector_13_nx;
int ny = mccdiffraction_detector_13_ny;
char* filename = mccdiffraction_detector_13_filename;
MCNUM xmin = mccdiffraction_detector_13_xmin;
MCNUM xmax = mccdiffraction_detector_13_xmax;
MCNUM ymin = mccdiffraction_detector_13_ymin;
MCNUM ymax = mccdiffraction_detector_13_ymax;
MCNUM xwidth = mccdiffraction_detector_13_xwidth;
MCNUM yheight = mccdiffraction_detector_13_yheight;
MCNUM restore_neutron = mccdiffraction_detector_13_restore_neutron;
#line 122 "/usr/share/mcstas/2.7/monitors/PSD_monitor.comp"
{
  destroy_darr2d(PSD_N);
  destroy_darr2d(PSD_p);
  destroy_darr2d(PSD_p2);
}
#line 479240 "MACS_sample_kidney_box.c"
}   /* End of diffraction_detector_13=PSD_monitor() SETTING parameter declarations. */
#undef PSD_p2
#undef PSD_p
#undef PSD_N
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

    if (!mcNCounter[911]) fprintf(stderr, "Warning: No neutron could reach Component[911] diffraction_detector_13\n");
    if (mcAbsorbProp[911]) fprintf(stderr, "Warning: %g events were removed in Component[911] diffraction_detector_13=PSD_monitor()\n"
"         (negative time, miss next components, rounding errors, Nan, Inf).\n", mcAbsorbProp[911]);
  /* User FINALLY code for component 'spec_detector_13'. */
  SIG_MESSAGE("spec_detector_13 (Finally)");
#define mccompcurname  spec_detector_13
#define mccompcurtype  PSD_monitor
#define mccompcurindex 912
#define PSD_N mccspec_detector_13_PSD_N
#define PSD_p mccspec_detector_13_PSD_p
#define PSD_p2 mccspec_detector_13_PSD_p2
{   /* Declarations of spec_detector_13=PSD_monitor() SETTING parameters. */
int nx = mccspec_detector_13_nx;
int ny = mccspec_detector_13_ny;
char* filename = mccspec_detector_13_filename;
MCNUM xmin = mccspec_detector_13_xmin;
MCNUM xmax = mccspec_detector_13_xmax;
MCNUM ymin = mccspec_detector_13_ymin;
MCNUM ymax = mccspec_detector_13_ymax;
MCNUM xwidth = mccspec_detector_13_xwidth;
MCNUM yheight = mccspec_detector_13_yheight;
MCNUM restore_neutron = mccspec_detector_13_restore_neutron;
#line 122 "/usr/share/mcstas/2.7/monitors/PSD_monitor.comp"
{
  destroy_darr2d(PSD_N);
  destroy_darr2d(PSD_p);
  destroy_darr2d(PSD_p2);
}
#line 479276 "MACS_sample_kidney_box.c"
}   /* End of spec_detector_13=PSD_monitor() SETTING parameter declarations. */
#undef PSD_p2
#undef PSD_p
#undef PSD_N
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

    if (!mcNCounter[912]) fprintf(stderr, "Warning: No neutron could reach Component[912] spec_detector_13\n");
    if (mcAbsorbProp[912]) fprintf(stderr, "Warning: %g events were removed in Component[912] spec_detector_13=PSD_monitor()\n"
"         (negative time, miss next components, rounding errors, Nan, Inf).\n", mcAbsorbProp[912]);
  /* User FINALLY code for component 'diffraction_detector_14'. */
  SIG_MESSAGE("diffraction_detector_14 (Finally)");
#define mccompcurname  diffraction_detector_14
#define mccompcurtype  PSD_monitor
#define mccompcurindex 913
#define PSD_N mccdiffraction_detector_14_PSD_N
#define PSD_p mccdiffraction_detector_14_PSD_p
#define PSD_p2 mccdiffraction_detector_14_PSD_p2
{   /* Declarations of diffraction_detector_14=PSD_monitor() SETTING parameters. */
int nx = mccdiffraction_detector_14_nx;
int ny = mccdiffraction_detector_14_ny;
char* filename = mccdiffraction_detector_14_filename;
MCNUM xmin = mccdiffraction_detector_14_xmin;
MCNUM xmax = mccdiffraction_detector_14_xmax;
MCNUM ymin = mccdiffraction_detector_14_ymin;
MCNUM ymax = mccdiffraction_detector_14_ymax;
MCNUM xwidth = mccdiffraction_detector_14_xwidth;
MCNUM yheight = mccdiffraction_detector_14_yheight;
MCNUM restore_neutron = mccdiffraction_detector_14_restore_neutron;
#line 122 "/usr/share/mcstas/2.7/monitors/PSD_monitor.comp"
{
  destroy_darr2d(PSD_N);
  destroy_darr2d(PSD_p);
  destroy_darr2d(PSD_p2);
}
#line 479312 "MACS_sample_kidney_box.c"
}   /* End of diffraction_detector_14=PSD_monitor() SETTING parameter declarations. */
#undef PSD_p2
#undef PSD_p
#undef PSD_N
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

    if (!mcNCounter[913]) fprintf(stderr, "Warning: No neutron could reach Component[913] diffraction_detector_14\n");
    if (mcAbsorbProp[913]) fprintf(stderr, "Warning: %g events were removed in Component[913] diffraction_detector_14=PSD_monitor()\n"
"         (negative time, miss next components, rounding errors, Nan, Inf).\n", mcAbsorbProp[913]);
  /* User FINALLY code for component 'spec_detector_14'. */
  SIG_MESSAGE("spec_detector_14 (Finally)");
#define mccompcurname  spec_detector_14
#define mccompcurtype  PSD_monitor
#define mccompcurindex 914
#define PSD_N mccspec_detector_14_PSD_N
#define PSD_p mccspec_detector_14_PSD_p
#define PSD_p2 mccspec_detector_14_PSD_p2
{   /* Declarations of spec_detector_14=PSD_monitor() SETTING parameters. */
int nx = mccspec_detector_14_nx;
int ny = mccspec_detector_14_ny;
char* filename = mccspec_detector_14_filename;
MCNUM xmin = mccspec_detector_14_xmin;
MCNUM xmax = mccspec_detector_14_xmax;
MCNUM ymin = mccspec_detector_14_ymin;
MCNUM ymax = mccspec_detector_14_ymax;
MCNUM xwidth = mccspec_detector_14_xwidth;
MCNUM yheight = mccspec_detector_14_yheight;
MCNUM restore_neutron = mccspec_detector_14_restore_neutron;
#line 122 "/usr/share/mcstas/2.7/monitors/PSD_monitor.comp"
{
  destroy_darr2d(PSD_N);
  destroy_darr2d(PSD_p);
  destroy_darr2d(PSD_p2);
}
#line 479348 "MACS_sample_kidney_box.c"
}   /* End of spec_detector_14=PSD_monitor() SETTING parameter declarations. */
#undef PSD_p2
#undef PSD_p
#undef PSD_N
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

    if (!mcNCounter[914]) fprintf(stderr, "Warning: No neutron could reach Component[914] spec_detector_14\n");
    if (mcAbsorbProp[914]) fprintf(stderr, "Warning: %g events were removed in Component[914] spec_detector_14=PSD_monitor()\n"
"         (negative time, miss next components, rounding errors, Nan, Inf).\n", mcAbsorbProp[914]);
  /* User FINALLY code for component 'diffraction_detector_15'. */
  SIG_MESSAGE("diffraction_detector_15 (Finally)");
#define mccompcurname  diffraction_detector_15
#define mccompcurtype  PSD_monitor
#define mccompcurindex 915
#define PSD_N mccdiffraction_detector_15_PSD_N
#define PSD_p mccdiffraction_detector_15_PSD_p
#define PSD_p2 mccdiffraction_detector_15_PSD_p2
{   /* Declarations of diffraction_detector_15=PSD_monitor() SETTING parameters. */
int nx = mccdiffraction_detector_15_nx;
int ny = mccdiffraction_detector_15_ny;
char* filename = mccdiffraction_detector_15_filename;
MCNUM xmin = mccdiffraction_detector_15_xmin;
MCNUM xmax = mccdiffraction_detector_15_xmax;
MCNUM ymin = mccdiffraction_detector_15_ymin;
MCNUM ymax = mccdiffraction_detector_15_ymax;
MCNUM xwidth = mccdiffraction_detector_15_xwidth;
MCNUM yheight = mccdiffraction_detector_15_yheight;
MCNUM restore_neutron = mccdiffraction_detector_15_restore_neutron;
#line 122 "/usr/share/mcstas/2.7/monitors/PSD_monitor.comp"
{
  destroy_darr2d(PSD_N);
  destroy_darr2d(PSD_p);
  destroy_darr2d(PSD_p2);
}
#line 479384 "MACS_sample_kidney_box.c"
}   /* End of diffraction_detector_15=PSD_monitor() SETTING parameter declarations. */
#undef PSD_p2
#undef PSD_p
#undef PSD_N
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

    if (!mcNCounter[915]) fprintf(stderr, "Warning: No neutron could reach Component[915] diffraction_detector_15\n");
    if (mcAbsorbProp[915]) fprintf(stderr, "Warning: %g events were removed in Component[915] diffraction_detector_15=PSD_monitor()\n"
"         (negative time, miss next components, rounding errors, Nan, Inf).\n", mcAbsorbProp[915]);
  /* User FINALLY code for component 'spec_detector_15'. */
  SIG_MESSAGE("spec_detector_15 (Finally)");
#define mccompcurname  spec_detector_15
#define mccompcurtype  PSD_monitor
#define mccompcurindex 916
#define PSD_N mccspec_detector_15_PSD_N
#define PSD_p mccspec_detector_15_PSD_p
#define PSD_p2 mccspec_detector_15_PSD_p2
{   /* Declarations of spec_detector_15=PSD_monitor() SETTING parameters. */
int nx = mccspec_detector_15_nx;
int ny = mccspec_detector_15_ny;
char* filename = mccspec_detector_15_filename;
MCNUM xmin = mccspec_detector_15_xmin;
MCNUM xmax = mccspec_detector_15_xmax;
MCNUM ymin = mccspec_detector_15_ymin;
MCNUM ymax = mccspec_detector_15_ymax;
MCNUM xwidth = mccspec_detector_15_xwidth;
MCNUM yheight = mccspec_detector_15_yheight;
MCNUM restore_neutron = mccspec_detector_15_restore_neutron;
#line 122 "/usr/share/mcstas/2.7/monitors/PSD_monitor.comp"
{
  destroy_darr2d(PSD_N);
  destroy_darr2d(PSD_p);
  destroy_darr2d(PSD_p2);
}
#line 479420 "MACS_sample_kidney_box.c"
}   /* End of spec_detector_15=PSD_monitor() SETTING parameter declarations. */
#undef PSD_p2
#undef PSD_p
#undef PSD_N
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

    if (!mcNCounter[916]) fprintf(stderr, "Warning: No neutron could reach Component[916] spec_detector_15\n");
    if (mcAbsorbProp[916]) fprintf(stderr, "Warning: %g events were removed in Component[916] spec_detector_15=PSD_monitor()\n"
"         (negative time, miss next components, rounding errors, Nan, Inf).\n", mcAbsorbProp[916]);
  /* User FINALLY code for component 'diffraction_detector_16'. */
  SIG_MESSAGE("diffraction_detector_16 (Finally)");
#define mccompcurname  diffraction_detector_16
#define mccompcurtype  PSD_monitor
#define mccompcurindex 917
#define PSD_N mccdiffraction_detector_16_PSD_N
#define PSD_p mccdiffraction_detector_16_PSD_p
#define PSD_p2 mccdiffraction_detector_16_PSD_p2
{   /* Declarations of diffraction_detector_16=PSD_monitor() SETTING parameters. */
int nx = mccdiffraction_detector_16_nx;
int ny = mccdiffraction_detector_16_ny;
char* filename = mccdiffraction_detector_16_filename;
MCNUM xmin = mccdiffraction_detector_16_xmin;
MCNUM xmax = mccdiffraction_detector_16_xmax;
MCNUM ymin = mccdiffraction_detector_16_ymin;
MCNUM ymax = mccdiffraction_detector_16_ymax;
MCNUM xwidth = mccdiffraction_detector_16_xwidth;
MCNUM yheight = mccdiffraction_detector_16_yheight;
MCNUM restore_neutron = mccdiffraction_detector_16_restore_neutron;
#line 122 "/usr/share/mcstas/2.7/monitors/PSD_monitor.comp"
{
  destroy_darr2d(PSD_N);
  destroy_darr2d(PSD_p);
  destroy_darr2d(PSD_p2);
}
#line 479456 "MACS_sample_kidney_box.c"
}   /* End of diffraction_detector_16=PSD_monitor() SETTING parameter declarations. */
#undef PSD_p2
#undef PSD_p
#undef PSD_N
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

    if (!mcNCounter[917]) fprintf(stderr, "Warning: No neutron could reach Component[917] diffraction_detector_16\n");
    if (mcAbsorbProp[917]) fprintf(stderr, "Warning: %g events were removed in Component[917] diffraction_detector_16=PSD_monitor()\n"
"         (negative time, miss next components, rounding errors, Nan, Inf).\n", mcAbsorbProp[917]);
  /* User FINALLY code for component 'spec_detector_16'. */
  SIG_MESSAGE("spec_detector_16 (Finally)");
#define mccompcurname  spec_detector_16
#define mccompcurtype  PSD_monitor
#define mccompcurindex 918
#define PSD_N mccspec_detector_16_PSD_N
#define PSD_p mccspec_detector_16_PSD_p
#define PSD_p2 mccspec_detector_16_PSD_p2
{   /* Declarations of spec_detector_16=PSD_monitor() SETTING parameters. */
int nx = mccspec_detector_16_nx;
int ny = mccspec_detector_16_ny;
char* filename = mccspec_detector_16_filename;
MCNUM xmin = mccspec_detector_16_xmin;
MCNUM xmax = mccspec_detector_16_xmax;
MCNUM ymin = mccspec_detector_16_ymin;
MCNUM ymax = mccspec_detector_16_ymax;
MCNUM xwidth = mccspec_detector_16_xwidth;
MCNUM yheight = mccspec_detector_16_yheight;
MCNUM restore_neutron = mccspec_detector_16_restore_neutron;
#line 122 "/usr/share/mcstas/2.7/monitors/PSD_monitor.comp"
{
  destroy_darr2d(PSD_N);
  destroy_darr2d(PSD_p);
  destroy_darr2d(PSD_p2);
}
#line 479492 "MACS_sample_kidney_box.c"
}   /* End of spec_detector_16=PSD_monitor() SETTING parameter declarations. */
#undef PSD_p2
#undef PSD_p
#undef PSD_N
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

    if (!mcNCounter[918]) fprintf(stderr, "Warning: No neutron could reach Component[918] spec_detector_16\n");
    if (mcAbsorbProp[918]) fprintf(stderr, "Warning: %g events were removed in Component[918] spec_detector_16=PSD_monitor()\n"
"         (negative time, miss next components, rounding errors, Nan, Inf).\n", mcAbsorbProp[918]);
  /* User FINALLY code for component 'diffraction_detector_17'. */
  SIG_MESSAGE("diffraction_detector_17 (Finally)");
#define mccompcurname  diffraction_detector_17
#define mccompcurtype  PSD_monitor
#define mccompcurindex 919
#define PSD_N mccdiffraction_detector_17_PSD_N
#define PSD_p mccdiffraction_detector_17_PSD_p
#define PSD_p2 mccdiffraction_detector_17_PSD_p2
{   /* Declarations of diffraction_detector_17=PSD_monitor() SETTING parameters. */
int nx = mccdiffraction_detector_17_nx;
int ny = mccdiffraction_detector_17_ny;
char* filename = mccdiffraction_detector_17_filename;
MCNUM xmin = mccdiffraction_detector_17_xmin;
MCNUM xmax = mccdiffraction_detector_17_xmax;
MCNUM ymin = mccdiffraction_detector_17_ymin;
MCNUM ymax = mccdiffraction_detector_17_ymax;
MCNUM xwidth = mccdiffraction_detector_17_xwidth;
MCNUM yheight = mccdiffraction_detector_17_yheight;
MCNUM restore_neutron = mccdiffraction_detector_17_restore_neutron;
#line 122 "/usr/share/mcstas/2.7/monitors/PSD_monitor.comp"
{
  destroy_darr2d(PSD_N);
  destroy_darr2d(PSD_p);
  destroy_darr2d(PSD_p2);
}
#line 479528 "MACS_sample_kidney_box.c"
}   /* End of diffraction_detector_17=PSD_monitor() SETTING parameter declarations. */
#undef PSD_p2
#undef PSD_p
#undef PSD_N
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

    if (!mcNCounter[919]) fprintf(stderr, "Warning: No neutron could reach Component[919] diffraction_detector_17\n");
    if (mcAbsorbProp[919]) fprintf(stderr, "Warning: %g events were removed in Component[919] diffraction_detector_17=PSD_monitor()\n"
"         (negative time, miss next components, rounding errors, Nan, Inf).\n", mcAbsorbProp[919]);
  /* User FINALLY code for component 'spec_detector_17'. */
  SIG_MESSAGE("spec_detector_17 (Finally)");
#define mccompcurname  spec_detector_17
#define mccompcurtype  PSD_monitor
#define mccompcurindex 920
#define PSD_N mccspec_detector_17_PSD_N
#define PSD_p mccspec_detector_17_PSD_p
#define PSD_p2 mccspec_detector_17_PSD_p2
{   /* Declarations of spec_detector_17=PSD_monitor() SETTING parameters. */
int nx = mccspec_detector_17_nx;
int ny = mccspec_detector_17_ny;
char* filename = mccspec_detector_17_filename;
MCNUM xmin = mccspec_detector_17_xmin;
MCNUM xmax = mccspec_detector_17_xmax;
MCNUM ymin = mccspec_detector_17_ymin;
MCNUM ymax = mccspec_detector_17_ymax;
MCNUM xwidth = mccspec_detector_17_xwidth;
MCNUM yheight = mccspec_detector_17_yheight;
MCNUM restore_neutron = mccspec_detector_17_restore_neutron;
#line 122 "/usr/share/mcstas/2.7/monitors/PSD_monitor.comp"
{
  destroy_darr2d(PSD_N);
  destroy_darr2d(PSD_p);
  destroy_darr2d(PSD_p2);
}
#line 479564 "MACS_sample_kidney_box.c"
}   /* End of spec_detector_17=PSD_monitor() SETTING parameter declarations. */
#undef PSD_p2
#undef PSD_p
#undef PSD_N
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

    if (!mcNCounter[920]) fprintf(stderr, "Warning: No neutron could reach Component[920] spec_detector_17\n");
    if (mcAbsorbProp[920]) fprintf(stderr, "Warning: %g events were removed in Component[920] spec_detector_17=PSD_monitor()\n"
"         (negative time, miss next components, rounding errors, Nan, Inf).\n", mcAbsorbProp[920]);
  /* User FINALLY code for component 'diffraction_detector_18'. */
  SIG_MESSAGE("diffraction_detector_18 (Finally)");
#define mccompcurname  diffraction_detector_18
#define mccompcurtype  PSD_monitor
#define mccompcurindex 921
#define PSD_N mccdiffraction_detector_18_PSD_N
#define PSD_p mccdiffraction_detector_18_PSD_p
#define PSD_p2 mccdiffraction_detector_18_PSD_p2
{   /* Declarations of diffraction_detector_18=PSD_monitor() SETTING parameters. */
int nx = mccdiffraction_detector_18_nx;
int ny = mccdiffraction_detector_18_ny;
char* filename = mccdiffraction_detector_18_filename;
MCNUM xmin = mccdiffraction_detector_18_xmin;
MCNUM xmax = mccdiffraction_detector_18_xmax;
MCNUM ymin = mccdiffraction_detector_18_ymin;
MCNUM ymax = mccdiffraction_detector_18_ymax;
MCNUM xwidth = mccdiffraction_detector_18_xwidth;
MCNUM yheight = mccdiffraction_detector_18_yheight;
MCNUM restore_neutron = mccdiffraction_detector_18_restore_neutron;
#line 122 "/usr/share/mcstas/2.7/monitors/PSD_monitor.comp"
{
  destroy_darr2d(PSD_N);
  destroy_darr2d(PSD_p);
  destroy_darr2d(PSD_p2);
}
#line 479600 "MACS_sample_kidney_box.c"
}   /* End of diffraction_detector_18=PSD_monitor() SETTING parameter declarations. */
#undef PSD_p2
#undef PSD_p
#undef PSD_N
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

    if (!mcNCounter[921]) fprintf(stderr, "Warning: No neutron could reach Component[921] diffraction_detector_18\n");
    if (mcAbsorbProp[921]) fprintf(stderr, "Warning: %g events were removed in Component[921] diffraction_detector_18=PSD_monitor()\n"
"         (negative time, miss next components, rounding errors, Nan, Inf).\n", mcAbsorbProp[921]);
  /* User FINALLY code for component 'spec_detector_18'. */
  SIG_MESSAGE("spec_detector_18 (Finally)");
#define mccompcurname  spec_detector_18
#define mccompcurtype  PSD_monitor
#define mccompcurindex 922
#define PSD_N mccspec_detector_18_PSD_N
#define PSD_p mccspec_detector_18_PSD_p
#define PSD_p2 mccspec_detector_18_PSD_p2
{   /* Declarations of spec_detector_18=PSD_monitor() SETTING parameters. */
int nx = mccspec_detector_18_nx;
int ny = mccspec_detector_18_ny;
char* filename = mccspec_detector_18_filename;
MCNUM xmin = mccspec_detector_18_xmin;
MCNUM xmax = mccspec_detector_18_xmax;
MCNUM ymin = mccspec_detector_18_ymin;
MCNUM ymax = mccspec_detector_18_ymax;
MCNUM xwidth = mccspec_detector_18_xwidth;
MCNUM yheight = mccspec_detector_18_yheight;
MCNUM restore_neutron = mccspec_detector_18_restore_neutron;
#line 122 "/usr/share/mcstas/2.7/monitors/PSD_monitor.comp"
{
  destroy_darr2d(PSD_N);
  destroy_darr2d(PSD_p);
  destroy_darr2d(PSD_p2);
}
#line 479636 "MACS_sample_kidney_box.c"
}   /* End of spec_detector_18=PSD_monitor() SETTING parameter declarations. */
#undef PSD_p2
#undef PSD_p
#undef PSD_N
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

    if (!mcNCounter[922]) fprintf(stderr, "Warning: No neutron could reach Component[922] spec_detector_18\n");
    if (mcAbsorbProp[922]) fprintf(stderr, "Warning: %g events were removed in Component[922] spec_detector_18=PSD_monitor()\n"
"         (negative time, miss next components, rounding errors, Nan, Inf).\n", mcAbsorbProp[922]);
  /* User FINALLY code for component 'diffraction_detector_19'. */
  SIG_MESSAGE("diffraction_detector_19 (Finally)");
#define mccompcurname  diffraction_detector_19
#define mccompcurtype  PSD_monitor
#define mccompcurindex 923
#define PSD_N mccdiffraction_detector_19_PSD_N
#define PSD_p mccdiffraction_detector_19_PSD_p
#define PSD_p2 mccdiffraction_detector_19_PSD_p2
{   /* Declarations of diffraction_detector_19=PSD_monitor() SETTING parameters. */
int nx = mccdiffraction_detector_19_nx;
int ny = mccdiffraction_detector_19_ny;
char* filename = mccdiffraction_detector_19_filename;
MCNUM xmin = mccdiffraction_detector_19_xmin;
MCNUM xmax = mccdiffraction_detector_19_xmax;
MCNUM ymin = mccdiffraction_detector_19_ymin;
MCNUM ymax = mccdiffraction_detector_19_ymax;
MCNUM xwidth = mccdiffraction_detector_19_xwidth;
MCNUM yheight = mccdiffraction_detector_19_yheight;
MCNUM restore_neutron = mccdiffraction_detector_19_restore_neutron;
#line 122 "/usr/share/mcstas/2.7/monitors/PSD_monitor.comp"
{
  destroy_darr2d(PSD_N);
  destroy_darr2d(PSD_p);
  destroy_darr2d(PSD_p2);
}
#line 479672 "MACS_sample_kidney_box.c"
}   /* End of diffraction_detector_19=PSD_monitor() SETTING parameter declarations. */
#undef PSD_p2
#undef PSD_p
#undef PSD_N
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

    if (!mcNCounter[923]) fprintf(stderr, "Warning: No neutron could reach Component[923] diffraction_detector_19\n");
    if (mcAbsorbProp[923]) fprintf(stderr, "Warning: %g events were removed in Component[923] diffraction_detector_19=PSD_monitor()\n"
"         (negative time, miss next components, rounding errors, Nan, Inf).\n", mcAbsorbProp[923]);
  /* User FINALLY code for component 'spec_detector_19'. */
  SIG_MESSAGE("spec_detector_19 (Finally)");
#define mccompcurname  spec_detector_19
#define mccompcurtype  PSD_monitor
#define mccompcurindex 924
#define PSD_N mccspec_detector_19_PSD_N
#define PSD_p mccspec_detector_19_PSD_p
#define PSD_p2 mccspec_detector_19_PSD_p2
{   /* Declarations of spec_detector_19=PSD_monitor() SETTING parameters. */
int nx = mccspec_detector_19_nx;
int ny = mccspec_detector_19_ny;
char* filename = mccspec_detector_19_filename;
MCNUM xmin = mccspec_detector_19_xmin;
MCNUM xmax = mccspec_detector_19_xmax;
MCNUM ymin = mccspec_detector_19_ymin;
MCNUM ymax = mccspec_detector_19_ymax;
MCNUM xwidth = mccspec_detector_19_xwidth;
MCNUM yheight = mccspec_detector_19_yheight;
MCNUM restore_neutron = mccspec_detector_19_restore_neutron;
#line 122 "/usr/share/mcstas/2.7/monitors/PSD_monitor.comp"
{
  destroy_darr2d(PSD_N);
  destroy_darr2d(PSD_p);
  destroy_darr2d(PSD_p2);
}
#line 479708 "MACS_sample_kidney_box.c"
}   /* End of spec_detector_19=PSD_monitor() SETTING parameter declarations. */
#undef PSD_p2
#undef PSD_p
#undef PSD_N
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

    if (!mcNCounter[924]) fprintf(stderr, "Warning: No neutron could reach Component[924] spec_detector_19\n");
    if (mcAbsorbProp[924]) fprintf(stderr, "Warning: %g events were removed in Component[924] spec_detector_19=PSD_monitor()\n"
"         (negative time, miss next components, rounding errors, Nan, Inf).\n", mcAbsorbProp[924]);
    if (!mcNCounter[925]) fprintf(stderr, "Warning: No neutron could reach Component[925] spec_detector_history_0\n");
    if (mcAbsorbProp[925]) fprintf(stderr, "Warning: %g events were removed in Component[925] spec_detector_history_0=extend_monitor()\n"
"         (negative time, miss next components, rounding errors, Nan, Inf).\n", mcAbsorbProp[925]);
    if (!mcNCounter[926]) fprintf(stderr, "Warning: No neutron could reach Component[926] spec_detector_history_1\n");
    if (mcAbsorbProp[926]) fprintf(stderr, "Warning: %g events were removed in Component[926] spec_detector_history_1=extend_monitor()\n"
"         (negative time, miss next components, rounding errors, Nan, Inf).\n", mcAbsorbProp[926]);
    if (!mcNCounter[927]) fprintf(stderr, "Warning: No neutron could reach Component[927] spec_detector_history_2\n");
    if (mcAbsorbProp[927]) fprintf(stderr, "Warning: %g events were removed in Component[927] spec_detector_history_2=extend_monitor()\n"
"         (negative time, miss next components, rounding errors, Nan, Inf).\n", mcAbsorbProp[927]);
    if (!mcNCounter[928]) fprintf(stderr, "Warning: No neutron could reach Component[928] spec_detector_history_3\n");
    if (mcAbsorbProp[928]) fprintf(stderr, "Warning: %g events were removed in Component[928] spec_detector_history_3=extend_monitor()\n"
"         (negative time, miss next components, rounding errors, Nan, Inf).\n", mcAbsorbProp[928]);
    if (!mcNCounter[929]) fprintf(stderr, "Warning: No neutron could reach Component[929] spec_detector_history_4\n");
    if (mcAbsorbProp[929]) fprintf(stderr, "Warning: %g events were removed in Component[929] spec_detector_history_4=extend_monitor()\n"
"         (negative time, miss next components, rounding errors, Nan, Inf).\n", mcAbsorbProp[929]);
    if (!mcNCounter[930]) fprintf(stderr, "Warning: No neutron could reach Component[930] spec_detector_history_5\n");
    if (mcAbsorbProp[930]) fprintf(stderr, "Warning: %g events were removed in Component[930] spec_detector_history_5=extend_monitor()\n"
"         (negative time, miss next components, rounding errors, Nan, Inf).\n", mcAbsorbProp[930]);
    if (!mcNCounter[931]) fprintf(stderr, "Warning: No neutron could reach Component[931] spec_detector_history_6\n");
    if (mcAbsorbProp[931]) fprintf(stderr, "Warning: %g events were removed in Component[931] spec_detector_history_6=extend_monitor()\n"
"         (negative time, miss next components, rounding errors, Nan, Inf).\n", mcAbsorbProp[931]);
    if (!mcNCounter[932]) fprintf(stderr, "Warning: No neutron could reach Component[932] spec_detector_history_7\n");
    if (mcAbsorbProp[932]) fprintf(stderr, "Warning: %g events were removed in Component[932] spec_detector_history_7=extend_monitor()\n"
"         (negative time, miss next components, rounding errors, Nan, Inf).\n", mcAbsorbProp[932]);
    if (!mcNCounter[933]) fprintf(stderr, "Warning: No neutron could reach Component[933] spec_detector_history_8\n");
    if (mcAbsorbProp[933]) fprintf(stderr, "Warning: %g events were removed in Component[933] spec_detector_history_8=extend_monitor()\n"
"         (negative time, miss next components, rounding errors, Nan, Inf).\n", mcAbsorbProp[933]);
    if (!mcNCounter[934]) fprintf(stderr, "Warning: No neutron could reach Component[934] spec_detector_history_9\n");
    if (mcAbsorbProp[934]) fprintf(stderr, "Warning: %g events were removed in Component[934] spec_detector_history_9=extend_monitor()\n"
"         (negative time, miss next components, rounding errors, Nan, Inf).\n", mcAbsorbProp[934]);
    if (!mcNCounter[935]) fprintf(stderr, "Warning: No neutron could reach Component[935] spec_detector_history_10\n");
    if (mcAbsorbProp[935]) fprintf(stderr, "Warning: %g events were removed in Component[935] spec_detector_history_10=extend_monitor()\n"
"         (negative time, miss next components, rounding errors, Nan, Inf).\n", mcAbsorbProp[935]);
    if (!mcNCounter[936]) fprintf(stderr, "Warning: No neutron could reach Component[936] spec_detector_history_11\n");
    if (mcAbsorbProp[936]) fprintf(stderr, "Warning: %g events were removed in Component[936] spec_detector_history_11=extend_monitor()\n"
"         (negative time, miss next components, rounding errors, Nan, Inf).\n", mcAbsorbProp[936]);
    if (!mcNCounter[937]) fprintf(stderr, "Warning: No neutron could reach Component[937] spec_detector_history_12\n");
    if (mcAbsorbProp[937]) fprintf(stderr, "Warning: %g events were removed in Component[937] spec_detector_history_12=extend_monitor()\n"
"         (negative time, miss next components, rounding errors, Nan, Inf).\n", mcAbsorbProp[937]);
    if (!mcNCounter[938]) fprintf(stderr, "Warning: No neutron could reach Component[938] spec_detector_history_13\n");
    if (mcAbsorbProp[938]) fprintf(stderr, "Warning: %g events were removed in Component[938] spec_detector_history_13=extend_monitor()\n"
"         (negative time, miss next components, rounding errors, Nan, Inf).\n", mcAbsorbProp[938]);
    if (!mcNCounter[939]) fprintf(stderr, "Warning: No neutron could reach Component[939] spec_detector_history_14\n");
    if (mcAbsorbProp[939]) fprintf(stderr, "Warning: %g events were removed in Component[939] spec_detector_history_14=extend_monitor()\n"
"         (negative time, miss next components, rounding errors, Nan, Inf).\n", mcAbsorbProp[939]);
    if (!mcNCounter[940]) fprintf(stderr, "Warning: No neutron could reach Component[940] spec_detector_history_15\n");
    if (mcAbsorbProp[940]) fprintf(stderr, "Warning: %g events were removed in Component[940] spec_detector_history_15=extend_monitor()\n"
"         (negative time, miss next components, rounding errors, Nan, Inf).\n", mcAbsorbProp[940]);
    if (!mcNCounter[941]) fprintf(stderr, "Warning: No neutron could reach Component[941] spec_detector_history_16\n");
    if (mcAbsorbProp[941]) fprintf(stderr, "Warning: %g events were removed in Component[941] spec_detector_history_16=extend_monitor()\n"
"         (negative time, miss next components, rounding errors, Nan, Inf).\n", mcAbsorbProp[941]);
    if (!mcNCounter[942]) fprintf(stderr, "Warning: No neutron could reach Component[942] spec_detector_history_17\n");
    if (mcAbsorbProp[942]) fprintf(stderr, "Warning: %g events were removed in Component[942] spec_detector_history_17=extend_monitor()\n"
"         (negative time, miss next components, rounding errors, Nan, Inf).\n", mcAbsorbProp[942]);
    if (!mcNCounter[943]) fprintf(stderr, "Warning: No neutron could reach Component[943] spec_detector_history_18\n");
    if (mcAbsorbProp[943]) fprintf(stderr, "Warning: %g events were removed in Component[943] spec_detector_history_18=extend_monitor()\n"
"         (negative time, miss next components, rounding errors, Nan, Inf).\n", mcAbsorbProp[943]);
    if (!mcNCounter[944]) fprintf(stderr, "Warning: No neutron could reach Component[944] spec_detector_history_19\n");
    if (mcAbsorbProp[944]) fprintf(stderr, "Warning: %g events were removed in Component[944] spec_detector_history_19=extend_monitor()\n"
"         (negative time, miss next components, rounding errors, Nan, Inf).\n", mcAbsorbProp[944]);
  mcsiminfo_close(); 
} /* end finally */
#define magnify mcdis_magnify
#define line mcdis_line
#define dashed_line mcdis_dashed_line
#define multiline mcdis_multiline
#define rectangle mcdis_rectangle
#define box mcdis_box
#define circle mcdis_circle
#define cylinder mcdis_cylinder
#define sphere mcdis_sphere
void mcdisplay(void) {
  printf("MCDISPLAY: start\n");
  /* Components MCDISPLAY code. */

  /* MCDISPLAY code for component 'Arm0'. */
  SIG_MESSAGE("Arm0 (McDisplay)");
  printf("MCDISPLAY: component %s\n", "Arm0");
#define mccompcurname  Arm0
#define mccompcurtype  Progress_bar
#define mccompcurindex 12
#define IntermediateCnts mccArm0_IntermediateCnts
#define StartTime mccArm0_StartTime
#define EndTime mccArm0_EndTime
#define CurrentTime mccArm0_CurrentTime
{   /* Declarations of Arm0=Progress_bar() SETTING parameters. */
char* profile = mccArm0_profile;
MCNUM percent = mccArm0_percent;
MCNUM flag_save = mccArm0_flag_save;
MCNUM minutes = mccArm0_minutes;
#line 147 "/usr/share/mcstas/2.7/misc/Progress_bar.comp"
{
  
}
#line 479793 "MACS_sample_kidney_box.c"
}   /* End of Arm0=Progress_bar() SETTING parameter declarations. */
#undef CurrentTime
#undef EndTime
#undef StartTime
#undef IntermediateCnts
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

  /* MCDISPLAY code for component 'Guide_end'. */
  SIG_MESSAGE("Guide_end (McDisplay)");
  printf("MCDISPLAY: component %s\n", "Guide_end");
#define mccompcurname  Guide_end
#define mccompcurtype  Virtual_input
#define mccompcurindex 13
#define read_block mccGuide_end_read_block
#define pos mccGuide_end_pos
#define nrows mccGuide_end_nrows
#define Offset mccGuide_end_Offset
#define rTable mccGuide_end_rTable
#define repeat_number mccGuide_end_repeat_number
#define filename_ncount mccGuide_end_filename_ncount
#define mean_vx mccGuide_end_mean_vx
#define mean_vy mccGuide_end_mean_vy
#define mean_vz mccGuide_end_mean_vz
#define mean_dx mccGuide_end_mean_dx
#define mean_dy mccGuide_end_mean_dy
#define mean_dz mccGuide_end_mean_dz
#define n_neutrons mccGuide_end_n_neutrons
#define min_x mccGuide_end_min_x
#define min_y mccGuide_end_min_y
#define min_z mccGuide_end_min_z
#define max_x mccGuide_end_max_x
#define max_y mccGuide_end_max_y
#define max_z mccGuide_end_max_z
#define min_vx mccGuide_end_min_vx
#define min_vy mccGuide_end_min_vy
#define min_vz mccGuide_end_min_vz
#define max_vx mccGuide_end_max_vx
#define max_vy mccGuide_end_max_vy
#define max_vz mccGuide_end_max_vz
#define first_block mccGuide_end_first_block
#define mean_x mccGuide_end_mean_x
#define mean_y mccGuide_end_mean_y
#define mean_z mccGuide_end_mean_z
#define end_reading mccGuide_end_end_reading
#define n_count_extrapolated mccGuide_end_n_count_extrapolated
#define repeat_cnt mccGuide_end_repeat_cnt
{   /* Declarations of Guide_end=Virtual_input() SETTING parameters. */
char* filename = mccGuide_end_filename;
MCNUM verbose = mccGuide_end_verbose;
MCNUM repeat_count = mccGuide_end_repeat_count;
MCNUM smooth = mccGuide_end_smooth;
MCNUM display = mccGuide_end_display;
#line 359 "/usr/share/mcstas/2.7/obsolete/Virtual_input.comp"
{
  if (display) {
    mcdis_box(mean_x, mean_y, mean_z, max_x-min_x, max_y-min_y, max_z-min_z);
    /* a line in the main beam direction */
    line(mean_x, mean_y, mean_z,mean_dx,mean_dy,mean_dz);
  }
}
#line 479856 "MACS_sample_kidney_box.c"
}   /* End of Guide_end=Virtual_input() SETTING parameter declarations. */
#undef repeat_cnt
#undef n_count_extrapolated
#undef end_reading
#undef mean_z
#undef mean_y
#undef mean_x
#undef first_block
#undef max_vz
#undef max_vy
#undef max_vx
#undef min_vz
#undef min_vy
#undef min_vx
#undef max_z
#undef max_y
#undef max_x
#undef min_z
#undef min_y
#undef min_x
#undef n_neutrons
#undef mean_dz
#undef mean_dy
#undef mean_dx
#undef mean_vz
#undef mean_vy
#undef mean_vx
#undef filename_ncount
#undef repeat_number
#undef rTable
#undef Offset
#undef nrows
#undef pos
#undef read_block
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

  /* MCDISPLAY code for component 'main_slit'. */
  SIG_MESSAGE("main_slit (McDisplay)");
  printf("MCDISPLAY: component %s\n", "main_slit");
#define mccompcurname  main_slit
#define mccompcurtype  Slit
#define mccompcurindex 14
{   /* Declarations of main_slit=Slit() SETTING parameters. */
MCNUM xmin = mccmain_slit_xmin;
MCNUM xmax = mccmain_slit_xmax;
MCNUM ymin = mccmain_slit_ymin;
MCNUM ymax = mccmain_slit_ymax;
MCNUM radius = mccmain_slit_radius;
MCNUM xwidth = mccmain_slit_xwidth;
MCNUM yheight = mccmain_slit_yheight;
#line 83 "/usr/share/mcstas/2.7/optics/Slit.comp"
{
  
  if (radius == 0) {
    double xw, yh;
    xw = (xmax - xmin)/2.0;
    yh = (ymax - ymin)/2.0;
    multiline(3, xmin-xw, (double)ymax, 0.0,
              (double)xmin, (double)ymax, 0.0,
              (double)xmin, ymax+yh, 0.0);
    multiline(3, xmax+xw, (double)ymax, 0.0,
              (double)xmax, (double)ymax, 0.0,
              (double)xmax, ymax+yh, 0.0);
    multiline(3, xmin-xw, (double)ymin, 0.0,
              (double)xmin, (double)ymin, 0.0,
              (double)xmin, ymin-yh, 0.0);
    multiline(3, xmax+xw, (double)ymin, 0.0,
              (double)xmax, (double)ymin, 0.0,
              (double)xmax, ymin-yh, 0.0);
  } else {
    circle("xy",0,0,0,radius);
  }
}
#line 479932 "MACS_sample_kidney_box.c"
}   /* End of main_slit=Slit() SETTING parameter declarations. */
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

  /* MCDISPLAY code for component 'target'. */
  SIG_MESSAGE("target (McDisplay)");
  printf("MCDISPLAY: component %s\n", "target");
#define mccompcurname  target
#define mccompcurtype  Arm
#define mccompcurindex 15
#line 40 "/usr/share/mcstas/2.7/optics/Arm.comp"
{
  /* A bit ugly; hard-coded dimensions. */
  
  line(0,0,0,0.2,0,0);
  line(0,0,0,0,0.2,0);
  line(0,0,0,0,0,0.2);
}
#line 479952 "MACS_sample_kidney_box.c"
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

  /* MCDISPLAY code for component 'cryostat_center'. */
  SIG_MESSAGE("cryostat_center (McDisplay)");
  printf("MCDISPLAY: component %s\n", "cryostat_center");
#define mccompcurname  cryostat_center
#define mccompcurtype  Arm
#define mccompcurindex 16
#line 40 "/usr/share/mcstas/2.7/optics/Arm.comp"
{
  /* A bit ugly; hard-coded dimensions. */
  
  line(0,0,0,0.2,0,0);
  line(0,0,0,0,0.2,0);
  line(0,0,0,0,0,0.2);
}
#line 479971 "MACS_sample_kidney_box.c"
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

  /* MCDISPLAY code for component 'drum_center'. */
  SIG_MESSAGE("drum_center (McDisplay)");
  printf("MCDISPLAY: component %s\n", "drum_center");
#define mccompcurname  drum_center
#define mccompcurtype  Arm
#define mccompcurindex 17
#line 40 "/usr/share/mcstas/2.7/optics/Arm.comp"
{
  /* A bit ugly; hard-coded dimensions. */
  
  line(0,0,0,0.2,0,0);
  line(0,0,0,0,0.2,0);
  line(0,0,0,0,0,0.2);
}
#line 479990 "MACS_sample_kidney_box.c"
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

  /* MCDISPLAY code for component 'crystal_assembly'. */
  SIG_MESSAGE("crystal_assembly (McDisplay)");
  printf("MCDISPLAY: component %s\n", "crystal_assembly");
#define mccompcurname  crystal_assembly
#define mccompcurtype  Arm
#define mccompcurindex 18
#line 40 "/usr/share/mcstas/2.7/optics/Arm.comp"
{
  /* A bit ugly; hard-coded dimensions. */
  
  line(0,0,0,0.2,0,0);
  line(0,0,0,0,0.2,0);
  line(0,0,0,0,0,0.2);
}
#line 480009 "MACS_sample_kidney_box.c"
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

  /* MCDISPLAY code for component 'crystal_axis'. */
  SIG_MESSAGE("crystal_axis (McDisplay)");
  printf("MCDISPLAY: component %s\n", "crystal_axis");
#define mccompcurname  crystal_axis
#define mccompcurtype  Arm
#define mccompcurindex 19
#line 40 "/usr/share/mcstas/2.7/optics/Arm.comp"
{
  /* A bit ugly; hard-coded dimensions. */
  
  line(0,0,0,0.2,0,0);
  line(0,0,0,0,0.2,0);
  line(0,0,0,0,0,0.2);
}
#line 480028 "MACS_sample_kidney_box.c"
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

  /* MCDISPLAY code for component 'sample_rod_bottom'. */
  SIG_MESSAGE("sample_rod_bottom (McDisplay)");
  printf("MCDISPLAY: component %s\n", "sample_rod_bottom");
#define mccompcurname  sample_rod_bottom
#define mccompcurtype  Arm
#define mccompcurindex 34
#line 40 "/usr/share/mcstas/2.7/optics/Arm.comp"
{
  /* A bit ugly; hard-coded dimensions. */
  
  line(0,0,0,0.2,0,0);
  line(0,0,0,0,0.2,0);
  line(0,0,0,0,0,0.2);
}
#line 480047 "MACS_sample_kidney_box.c"
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

  /* MCDISPLAY code for component 'sample_cryostat'. */
  SIG_MESSAGE("sample_cryostat (McDisplay)");
  printf("MCDISPLAY: component %s\n", "sample_cryostat");
#define mccompcurname  sample_cryostat
#define mccompcurtype  Union_master
#define mccompcurindex 45
#define verbal mccsample_cryostat_verbal
#define list_verbal mccsample_cryostat_list_verbal
#define trace_verbal mccsample_cryostat_trace_verbal
#define finally_verbal mccsample_cryostat_finally_verbal
#define starting_volume_warning mccsample_cryostat_starting_volume_warning
#define global_master_element mccsample_cryostat_global_master_element
#define this_global_master_index mccsample_cryostat_this_global_master_index
#define previous_master_index mccsample_cryostat_previous_master_index
#define geometry_list_index mccsample_cryostat_geometry_list_index
#define intersection_time_table mccsample_cryostat_intersection_time_table
#define Volumes mccsample_cryostat_Volumes
#define Geometries mccsample_cryostat_Geometries
#define starting_lists mccsample_cryostat_starting_lists
#define r mccsample_cryostat_r
#define r_start mccsample_cryostat_r_start
#define v mccsample_cryostat_v
#define error_msg mccsample_cryostat_error_msg
#define component_error_msg mccsample_cryostat_component_error_msg
#define string_output mccsample_cryostat_string_output
#define number_of_volumes mccsample_cryostat_number_of_volumes
#define volume_index mccsample_cryostat_volume_index
#define process_index mccsample_cryostat_process_index
#define solutions mccsample_cryostat_solutions
#define max_number_of_processes mccsample_cryostat_max_number_of_processes
#define limit mccsample_cryostat_limit
#define solution mccsample_cryostat_solution
#define min_solution mccsample_cryostat_min_solution
#define min_volume mccsample_cryostat_min_volume
#define time_found mccsample_cryostat_time_found
#define intersection_time mccsample_cryostat_intersection_time
#define min_intersection_time mccsample_cryostat_min_intersection_time
#define process mccsample_cryostat_process
#define process_start mccsample_cryostat_process_start
#define my_trace mccsample_cryostat_my_trace
#define p_my_trace mccsample_cryostat_p_my_trace
#define my_trace_fraction_control mccsample_cryostat_my_trace_fraction_control
#define k mccsample_cryostat_k
#define k_new mccsample_cryostat_k_new
#define k_old mccsample_cryostat_k_old
#define v_length mccsample_cryostat_v_length
#define my_sum mccsample_cryostat_my_sum
#define my_sum_plus_abs mccsample_cryostat_my_sum_plus_abs
#define culmative_probability mccsample_cryostat_culmative_probability
#define mc_prop mccsample_cryostat_mc_prop
#define time_to_scattering mccsample_cryostat_time_to_scattering
#define length_to_scattering mccsample_cryostat_length_to_scattering
#define length_to_boundery mccsample_cryostat_length_to_boundery
#define time_to_boundery mccsample_cryostat_time_to_boundery
#define selected_process mccsample_cryostat_selected_process
#define scattering_event mccsample_cryostat_scattering_event
#define time_propagated_without_scattering mccsample_cryostat_time_propagated_without_scattering
#define a_next_volume_found mccsample_cryostat_a_next_volume_found
#define next_volume mccsample_cryostat_next_volume
#define next_volume_priority mccsample_cryostat_next_volume_priority
#define done mccsample_cryostat_done
#define current_volume mccsample_cryostat_current_volume
#define number_of_solutions mccsample_cryostat_number_of_solutions
#define number_of_solutions_static mccsample_cryostat_number_of_solutions_static
#define check mccsample_cryostat_check
#define start mccsample_cryostat_start
#define intersection_with_children mccsample_cryostat_intersection_with_children
#define geometry_output mccsample_cryostat_geometry_output
#define tree_next_volume mccsample_cryostat_tree_next_volume
#define pre_allocated1 mccsample_cryostat_pre_allocated1
#define pre_allocated2 mccsample_cryostat_pre_allocated2
#define pre_allocated3 mccsample_cryostat_pre_allocated3
#define ray_position mccsample_cryostat_ray_position
#define ray_velocity mccsample_cryostat_ray_velocity
#define ray_velocity_final mccsample_cryostat_ray_velocity_final
#define volume_0_found mccsample_cryostat_volume_0_found
#define scattered_flag mccsample_cryostat_scattered_flag
#define scattered_flag_VP mccsample_cryostat_scattered_flag_VP
#define master_transposed_rotation_matrix mccsample_cryostat_master_transposed_rotation_matrix
#define temp_rotation_matrix mccsample_cryostat_temp_rotation_matrix
#define non_rotated_position mccsample_cryostat_non_rotated_position
#define rotated_position mccsample_cryostat_rotated_position
#define enable_tagging mccsample_cryostat_enable_tagging
#define stop_tagging_ray mccsample_cryostat_stop_tagging_ray
#define stop_creating_nodes mccsample_cryostat_stop_creating_nodes
#define enable_tagging_check mccsample_cryostat_enable_tagging_check
#define master_tagging_node_list mccsample_cryostat_master_tagging_node_list
#define current_tagging_node mccsample_cryostat_current_tagging_node
#define tagging_leaf_counter mccsample_cryostat_tagging_leaf_counter
#define number_of_scattering_events mccsample_cryostat_number_of_scattering_events
#define real_transmission_probability mccsample_cryostat_real_transmission_probability
#define mc_transmission_probability mccsample_cryostat_mc_transmission_probability
#define number_of_masks mccsample_cryostat_number_of_masks
#define number_of_masked_volumes mccsample_cryostat_number_of_masked_volumes
#define need_to_run_within_which_volume mccsample_cryostat_need_to_run_within_which_volume
#define mask_index_main mccsample_cryostat_mask_index_main
#define mask_iterate mccsample_cryostat_mask_iterate
#define mask_status_list mccsample_cryostat_mask_status_list
#define current_mask_intersect_list_status mccsample_cryostat_current_mask_intersect_list_status
#define mask_volume_index_list mccsample_cryostat_mask_volume_index_list
#define geometry_component_index_list mccsample_cryostat_geometry_component_index_list
#define Volume_copies_allocated mccsample_cryostat_Volume_copies_allocated
#define p_old mccsample_cryostat_p_old
#define this_logger mccsample_cryostat_this_logger
#define conditional_status mccsample_cryostat_conditional_status
#define tagging_conditional_list mccsample_cryostat_tagging_conditional_list
#define free_tagging_conditioanl_list mccsample_cryostat_free_tagging_conditioanl_list
#define logger_conditional_extend_array mccsample_cryostat_logger_conditional_extend_array
#define tagging_conditional_extend mccsample_cryostat_tagging_conditional_extend
#define max_conditional_extend_index mccsample_cryostat_max_conditional_extend_index
#define safty_distance mccsample_cryostat_safty_distance
#define safty_distance2 mccsample_cryostat_safty_distance2
#define number_of_processes_array mccsample_cryostat_number_of_processes_array
#define temporary_focus_data mccsample_cryostat_temporary_focus_data
#define focus_data_index mccsample_cryostat_focus_data_index
{   /* Declarations of sample_cryostat=Union_master() SETTING parameters. */
MCNUM allow_inside_start = mccsample_cryostat_allow_inside_start;
MCNUM history_limit = mccsample_cryostat_history_limit;
MCNUM enable_conditionals = mccsample_cryostat_enable_conditionals;
MCNUM inherit_number_of_scattering_events = mccsample_cryostat_inherit_number_of_scattering_events;
#line 2092 "Union_master.comp"
{
  // mcdisplay is handled in the component files for each geometry and called here. The line function is only available in this section, and not through functions,
  //   so all the lines to be drawn for each volume are collected in a structure that is then drawn here.
  magnify("xyz");
  struct lines_to_draw lines_to_draw_master;
  for (volume_index = 1; volume_index < number_of_volumes; volume_index++) {
        if (Volumes[volume_index]->geometry.visualization_on == 1) {
            lines_to_draw_master.number_of_lines = 0;
            
            Volumes[volume_index]->geometry.mcdisplay_function(&lines_to_draw_master,volume_index,Geometries,number_of_volumes);
            
            for (iterate = 0;iterate<lines_to_draw_master.number_of_lines;iterate++) {
               if (lines_to_draw_master.lines[iterate].number_of_dashes == 1) {
                 line(lines_to_draw_master.lines[iterate].point1.x,lines_to_draw_master.lines[iterate].point1.y,lines_to_draw_master.lines[iterate].point1.z,lines_to_draw_master.lines[iterate].point2.x,lines_to_draw_master.lines[iterate].point2.y,lines_to_draw_master.lines[iterate].point2.z);
               }
               else {
                 dashed_line(lines_to_draw_master.lines[iterate].point1.x,lines_to_draw_master.lines[iterate].point1.y,lines_to_draw_master.lines[iterate].point1.z,lines_to_draw_master.lines[iterate].point2.x,lines_to_draw_master.lines[iterate].point2.y,lines_to_draw_master.lines[iterate].point2.z,lines_to_draw_master.lines[iterate].number_of_dashes);
               }
            }
            
            if (lines_to_draw_master.number_of_lines>0) free(lines_to_draw_master.lines);
        }
   }

}
#line 480198 "MACS_sample_kidney_box.c"
}   /* End of sample_cryostat=Union_master() SETTING parameter declarations. */
#undef focus_data_index
#undef temporary_focus_data
#undef number_of_processes_array
#undef safty_distance2
#undef safty_distance
#undef max_conditional_extend_index
#undef tagging_conditional_extend
#undef logger_conditional_extend_array
#undef free_tagging_conditioanl_list
#undef tagging_conditional_list
#undef conditional_status
#undef this_logger
#undef p_old
#undef Volume_copies_allocated
#undef geometry_component_index_list
#undef mask_volume_index_list
#undef current_mask_intersect_list_status
#undef mask_status_list
#undef mask_iterate
#undef mask_index_main
#undef need_to_run_within_which_volume
#undef number_of_masked_volumes
#undef number_of_masks
#undef mc_transmission_probability
#undef real_transmission_probability
#undef number_of_scattering_events
#undef tagging_leaf_counter
#undef current_tagging_node
#undef master_tagging_node_list
#undef enable_tagging_check
#undef stop_creating_nodes
#undef stop_tagging_ray
#undef enable_tagging
#undef rotated_position
#undef non_rotated_position
#undef temp_rotation_matrix
#undef master_transposed_rotation_matrix
#undef scattered_flag_VP
#undef scattered_flag
#undef volume_0_found
#undef ray_velocity_final
#undef ray_velocity
#undef ray_position
#undef pre_allocated3
#undef pre_allocated2
#undef pre_allocated1
#undef tree_next_volume
#undef geometry_output
#undef intersection_with_children
#undef start
#undef check
#undef number_of_solutions_static
#undef number_of_solutions
#undef current_volume
#undef done
#undef next_volume_priority
#undef next_volume
#undef a_next_volume_found
#undef time_propagated_without_scattering
#undef scattering_event
#undef selected_process
#undef time_to_boundery
#undef length_to_boundery
#undef length_to_scattering
#undef time_to_scattering
#undef mc_prop
#undef culmative_probability
#undef my_sum_plus_abs
#undef my_sum
#undef v_length
#undef k_old
#undef k_new
#undef k
#undef my_trace_fraction_control
#undef p_my_trace
#undef my_trace
#undef process_start
#undef process
#undef min_intersection_time
#undef intersection_time
#undef time_found
#undef min_volume
#undef min_solution
#undef solution
#undef limit
#undef max_number_of_processes
#undef solutions
#undef process_index
#undef volume_index
#undef number_of_volumes
#undef string_output
#undef component_error_msg
#undef error_msg
#undef v
#undef r_start
#undef r
#undef starting_lists
#undef Geometries
#undef Volumes
#undef intersection_time_table
#undef geometry_list_index
#undef previous_master_index
#undef this_global_master_index
#undef global_master_element
#undef starting_volume_warning
#undef finally_verbal
#undef trace_verbal
#undef list_verbal
#undef verbal
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

  /* MCDISPLAY code for component 'Resolution_sample'. */
  SIG_MESSAGE("Resolution_sample (McDisplay)");
  printf("MCDISPLAY: component %s\n", "Resolution_sample");
#define mccompcurname  Resolution_sample
#define mccompcurtype  Res_sample
#define mccompcurindex 46
#define res_struct mccResolution_sample_res_struct
{   /* Declarations of Resolution_sample=Res_sample() SETTING parameters. */
MCNUM thickness = mccResolution_sample_thickness;
MCNUM radius = mccResolution_sample_radius;
MCNUM focus_r = mccResolution_sample_focus_r;
MCNUM E0 = mccResolution_sample_E0;
MCNUM dE = mccResolution_sample_dE;
MCNUM target_x = mccResolution_sample_target_x;
MCNUM target_y = mccResolution_sample_target_y;
MCNUM target_z = mccResolution_sample_target_z;
MCNUM focus_xw = mccResolution_sample_focus_xw;
MCNUM focus_yh = mccResolution_sample_focus_yh;
MCNUM focus_aw = mccResolution_sample_focus_aw;
MCNUM focus_ah = mccResolution_sample_focus_ah;
MCNUM xwidth = mccResolution_sample_xwidth;
MCNUM yheight = mccResolution_sample_yheight;
MCNUM zdepth = mccResolution_sample_zdepth;
int target_index = mccResolution_sample_target_index;
#line 206 "/usr/share/mcstas/2.7/samples/Res_sample.comp"
{
  
  if(res_struct.isrect)
  {                             /* Flat sample. */
    double xmin = -0.5*xwidth;
    double xmax =  0.5*xwidth;
    double ymin = -0.5*yheight;
    double ymax =  0.5*yheight;
    double len = zdepth/2;
    multiline(5, xmin, ymin, -len,
                 xmax, ymin, -len,
                 xmax, ymax, -len,
                 xmin, ymax, -len,
                 xmin, ymin, -len);
    multiline(5, xmin, ymin, len,
                 xmax, ymin, len,
                 xmax, ymax, len,
                 xmin, ymax, len,
                 xmin, ymin, len);
    line(xmin, ymin, -len, xmin, ymin, len);
    line(xmax, ymin, -len, xmax, ymin, len);
    line(xmin, ymax, -len, xmin, ymax, len);
    line(xmax, ymax, -len, xmax, ymax, len);
  }
  else
  {
    circle("xz", 0,  yheight/2.0, 0, radius);
    circle("xz", 0, -yheight/2.0, 0, radius);
    line(-radius, -yheight/2.0, 0, -radius, +yheight/2.0, 0);
    line(+radius, -yheight/2.0, 0, +radius, +yheight/2.0, 0);
    line(0, -yheight/2.0, -radius, 0, +yheight/2.0, -radius);
    line(0, -yheight/2.0, +radius, 0, +yheight/2.0, +radius);
    if (thickness) {
      double radius_i=radius-thickness;
      circle("xz", 0,  yheight/2.0, 0, radius_i);
      circle("xz", 0, -yheight/2.0, 0, radius_i);
      line(-radius_i, -yheight/2.0, 0, -radius_i, +yheight/2.0, 0);
      line(+radius_i, -yheight/2.0, 0, +radius_i, +yheight/2.0, 0);
      line(0, -yheight/2.0, -radius_i, 0, +yheight/2.0, -radius_i);
      line(0, -yheight/2.0, +radius_i, 0, +yheight/2.0, +radius_i);
    }
  }
}
#line 480381 "MACS_sample_kidney_box.c"
}   /* End of Resolution_sample=Res_sample() SETTING parameter declarations. */
#undef res_struct
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

  /* MCDISPLAY code for component 'post_sample_beamstop'. */
  SIG_MESSAGE("post_sample_beamstop (McDisplay)");
  printf("MCDISPLAY: component %s\n", "post_sample_beamstop");
#define mccompcurname  post_sample_beamstop
#define mccompcurtype  Beamstop
#define mccompcurindex 47
{   /* Declarations of post_sample_beamstop=Beamstop() SETTING parameters. */
MCNUM xmin = mccpost_sample_beamstop_xmin;
MCNUM xmax = mccpost_sample_beamstop_xmax;
MCNUM ymin = mccpost_sample_beamstop_ymin;
MCNUM ymax = mccpost_sample_beamstop_ymax;
MCNUM xwidth = mccpost_sample_beamstop_xwidth;
MCNUM yheight = mccpost_sample_beamstop_yheight;
MCNUM radius = mccpost_sample_beamstop_radius;
#line 72 "/usr/share/mcstas/2.7/optics/Beamstop.comp"
{
  
  if (radius != 0)
    circle("xy", 0, 0, 0, radius);
  else
    multiline(5, (double)xmin, (double)ymin, 0.0,
               (double)xmax, (double)ymin, 0.0,
               (double)xmax, (double)ymax, 0.0,
               (double)xmin, (double)ymax, 0.0,
               (double)xmin, (double)ymin, 0.0);
}
#line 480414 "MACS_sample_kidney_box.c"
}   /* End of post_sample_beamstop=Beamstop() SETTING parameter declarations. */
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

  /* MCDISPLAY code for component 'kidney_master'. */
  SIG_MESSAGE("kidney_master (McDisplay)");
  printf("MCDISPLAY: component %s\n", "kidney_master");
#define mccompcurname  kidney_master
#define mccompcurtype  Arm
#define mccompcurindex 48
#line 40 "/usr/share/mcstas/2.7/optics/Arm.comp"
{
  /* A bit ugly; hard-coded dimensions. */
  
  line(0,0,0,0.2,0,0);
  line(0,0,0,0,0.2,0);
  line(0,0,0,0,0,0.2);
}
#line 480434 "MACS_sample_kidney_box.c"
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

  /* MCDISPLAY code for component 'kidney_channel_0'. */
  SIG_MESSAGE("kidney_channel_0 (McDisplay)");
  printf("MCDISPLAY: component %s\n", "kidney_channel_0");
#define mccompcurname  kidney_channel_0
#define mccompcurtype  Arm
#define mccompcurindex 49
#line 40 "/usr/share/mcstas/2.7/optics/Arm.comp"
{
  /* A bit ugly; hard-coded dimensions. */
  
  line(0,0,0,0.2,0,0);
  line(0,0,0,0,0.2,0);
  line(0,0,0,0,0,0.2);
}
#line 480453 "MACS_sample_kidney_box.c"
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

  /* MCDISPLAY code for component 'kidney_channel_1'. */
  SIG_MESSAGE("kidney_channel_1 (McDisplay)");
  printf("MCDISPLAY: component %s\n", "kidney_channel_1");
#define mccompcurname  kidney_channel_1
#define mccompcurtype  Arm
#define mccompcurindex 50
#line 40 "/usr/share/mcstas/2.7/optics/Arm.comp"
{
  /* A bit ugly; hard-coded dimensions. */
  
  line(0,0,0,0.2,0,0);
  line(0,0,0,0,0.2,0);
  line(0,0,0,0,0,0.2);
}
#line 480472 "MACS_sample_kidney_box.c"
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

  /* MCDISPLAY code for component 'kidney_channel_2'. */
  SIG_MESSAGE("kidney_channel_2 (McDisplay)");
  printf("MCDISPLAY: component %s\n", "kidney_channel_2");
#define mccompcurname  kidney_channel_2
#define mccompcurtype  Arm
#define mccompcurindex 51
#line 40 "/usr/share/mcstas/2.7/optics/Arm.comp"
{
  /* A bit ugly; hard-coded dimensions. */
  
  line(0,0,0,0.2,0,0);
  line(0,0,0,0,0.2,0);
  line(0,0,0,0,0,0.2);
}
#line 480491 "MACS_sample_kidney_box.c"
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

  /* MCDISPLAY code for component 'kidney_channel_3'. */
  SIG_MESSAGE("kidney_channel_3 (McDisplay)");
  printf("MCDISPLAY: component %s\n", "kidney_channel_3");
#define mccompcurname  kidney_channel_3
#define mccompcurtype  Arm
#define mccompcurindex 52
#line 40 "/usr/share/mcstas/2.7/optics/Arm.comp"
{
  /* A bit ugly; hard-coded dimensions. */
  
  line(0,0,0,0.2,0,0);
  line(0,0,0,0,0.2,0);
  line(0,0,0,0,0,0.2);
}
#line 480510 "MACS_sample_kidney_box.c"
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

  /* MCDISPLAY code for component 'kidney_channel_4'. */
  SIG_MESSAGE("kidney_channel_4 (McDisplay)");
  printf("MCDISPLAY: component %s\n", "kidney_channel_4");
#define mccompcurname  kidney_channel_4
#define mccompcurtype  Arm
#define mccompcurindex 53
#line 40 "/usr/share/mcstas/2.7/optics/Arm.comp"
{
  /* A bit ugly; hard-coded dimensions. */
  
  line(0,0,0,0.2,0,0);
  line(0,0,0,0,0.2,0);
  line(0,0,0,0,0,0.2);
}
#line 480529 "MACS_sample_kidney_box.c"
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

  /* MCDISPLAY code for component 'kidney_channel_5'. */
  SIG_MESSAGE("kidney_channel_5 (McDisplay)");
  printf("MCDISPLAY: component %s\n", "kidney_channel_5");
#define mccompcurname  kidney_channel_5
#define mccompcurtype  Arm
#define mccompcurindex 54
#line 40 "/usr/share/mcstas/2.7/optics/Arm.comp"
{
  /* A bit ugly; hard-coded dimensions. */
  
  line(0,0,0,0.2,0,0);
  line(0,0,0,0,0.2,0);
  line(0,0,0,0,0,0.2);
}
#line 480548 "MACS_sample_kidney_box.c"
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

  /* MCDISPLAY code for component 'kidney_channel_6'. */
  SIG_MESSAGE("kidney_channel_6 (McDisplay)");
  printf("MCDISPLAY: component %s\n", "kidney_channel_6");
#define mccompcurname  kidney_channel_6
#define mccompcurtype  Arm
#define mccompcurindex 55
#line 40 "/usr/share/mcstas/2.7/optics/Arm.comp"
{
  /* A bit ugly; hard-coded dimensions. */
  
  line(0,0,0,0.2,0,0);
  line(0,0,0,0,0.2,0);
  line(0,0,0,0,0,0.2);
}
#line 480567 "MACS_sample_kidney_box.c"
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

  /* MCDISPLAY code for component 'kidney_channel_7'. */
  SIG_MESSAGE("kidney_channel_7 (McDisplay)");
  printf("MCDISPLAY: component %s\n", "kidney_channel_7");
#define mccompcurname  kidney_channel_7
#define mccompcurtype  Arm
#define mccompcurindex 56
#line 40 "/usr/share/mcstas/2.7/optics/Arm.comp"
{
  /* A bit ugly; hard-coded dimensions. */
  
  line(0,0,0,0.2,0,0);
  line(0,0,0,0,0.2,0);
  line(0,0,0,0,0,0.2);
}
#line 480586 "MACS_sample_kidney_box.c"
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

  /* MCDISPLAY code for component 'kidney_channel_8'. */
  SIG_MESSAGE("kidney_channel_8 (McDisplay)");
  printf("MCDISPLAY: component %s\n", "kidney_channel_8");
#define mccompcurname  kidney_channel_8
#define mccompcurtype  Arm
#define mccompcurindex 57
#line 40 "/usr/share/mcstas/2.7/optics/Arm.comp"
{
  /* A bit ugly; hard-coded dimensions. */
  
  line(0,0,0,0.2,0,0);
  line(0,0,0,0,0.2,0);
  line(0,0,0,0,0,0.2);
}
#line 480605 "MACS_sample_kidney_box.c"
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

  /* MCDISPLAY code for component 'kidney_channel_9'. */
  SIG_MESSAGE("kidney_channel_9 (McDisplay)");
  printf("MCDISPLAY: component %s\n", "kidney_channel_9");
#define mccompcurname  kidney_channel_9
#define mccompcurtype  Arm
#define mccompcurindex 58
#line 40 "/usr/share/mcstas/2.7/optics/Arm.comp"
{
  /* A bit ugly; hard-coded dimensions. */
  
  line(0,0,0,0.2,0,0);
  line(0,0,0,0,0.2,0);
  line(0,0,0,0,0,0.2);
}
#line 480624 "MACS_sample_kidney_box.c"
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

  /* MCDISPLAY code for component 'kidney_channel_10'. */
  SIG_MESSAGE("kidney_channel_10 (McDisplay)");
  printf("MCDISPLAY: component %s\n", "kidney_channel_10");
#define mccompcurname  kidney_channel_10
#define mccompcurtype  Arm
#define mccompcurindex 59
#line 40 "/usr/share/mcstas/2.7/optics/Arm.comp"
{
  /* A bit ugly; hard-coded dimensions. */
  
  line(0,0,0,0.2,0,0);
  line(0,0,0,0,0.2,0);
  line(0,0,0,0,0,0.2);
}
#line 480643 "MACS_sample_kidney_box.c"
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

  /* MCDISPLAY code for component 'kidney_channel_11'. */
  SIG_MESSAGE("kidney_channel_11 (McDisplay)");
  printf("MCDISPLAY: component %s\n", "kidney_channel_11");
#define mccompcurname  kidney_channel_11
#define mccompcurtype  Arm
#define mccompcurindex 60
#line 40 "/usr/share/mcstas/2.7/optics/Arm.comp"
{
  /* A bit ugly; hard-coded dimensions. */
  
  line(0,0,0,0.2,0,0);
  line(0,0,0,0,0.2,0);
  line(0,0,0,0,0,0.2);
}
#line 480662 "MACS_sample_kidney_box.c"
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

  /* MCDISPLAY code for component 'kidney_channel_12'. */
  SIG_MESSAGE("kidney_channel_12 (McDisplay)");
  printf("MCDISPLAY: component %s\n", "kidney_channel_12");
#define mccompcurname  kidney_channel_12
#define mccompcurtype  Arm
#define mccompcurindex 61
#line 40 "/usr/share/mcstas/2.7/optics/Arm.comp"
{
  /* A bit ugly; hard-coded dimensions. */
  
  line(0,0,0,0.2,0,0);
  line(0,0,0,0,0.2,0);
  line(0,0,0,0,0,0.2);
}
#line 480681 "MACS_sample_kidney_box.c"
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

  /* MCDISPLAY code for component 'kidney_channel_13'. */
  SIG_MESSAGE("kidney_channel_13 (McDisplay)");
  printf("MCDISPLAY: component %s\n", "kidney_channel_13");
#define mccompcurname  kidney_channel_13
#define mccompcurtype  Arm
#define mccompcurindex 62
#line 40 "/usr/share/mcstas/2.7/optics/Arm.comp"
{
  /* A bit ugly; hard-coded dimensions. */
  
  line(0,0,0,0.2,0,0);
  line(0,0,0,0,0.2,0);
  line(0,0,0,0,0,0.2);
}
#line 480700 "MACS_sample_kidney_box.c"
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

  /* MCDISPLAY code for component 'kidney_channel_14'. */
  SIG_MESSAGE("kidney_channel_14 (McDisplay)");
  printf("MCDISPLAY: component %s\n", "kidney_channel_14");
#define mccompcurname  kidney_channel_14
#define mccompcurtype  Arm
#define mccompcurindex 63
#line 40 "/usr/share/mcstas/2.7/optics/Arm.comp"
{
  /* A bit ugly; hard-coded dimensions. */
  
  line(0,0,0,0.2,0,0);
  line(0,0,0,0,0.2,0);
  line(0,0,0,0,0,0.2);
}
#line 480719 "MACS_sample_kidney_box.c"
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

  /* MCDISPLAY code for component 'kidney_channel_15'. */
  SIG_MESSAGE("kidney_channel_15 (McDisplay)");
  printf("MCDISPLAY: component %s\n", "kidney_channel_15");
#define mccompcurname  kidney_channel_15
#define mccompcurtype  Arm
#define mccompcurindex 64
#line 40 "/usr/share/mcstas/2.7/optics/Arm.comp"
{
  /* A bit ugly; hard-coded dimensions. */
  
  line(0,0,0,0.2,0,0);
  line(0,0,0,0,0.2,0);
  line(0,0,0,0,0,0.2);
}
#line 480738 "MACS_sample_kidney_box.c"
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

  /* MCDISPLAY code for component 'kidney_channel_16'. */
  SIG_MESSAGE("kidney_channel_16 (McDisplay)");
  printf("MCDISPLAY: component %s\n", "kidney_channel_16");
#define mccompcurname  kidney_channel_16
#define mccompcurtype  Arm
#define mccompcurindex 65
#line 40 "/usr/share/mcstas/2.7/optics/Arm.comp"
{
  /* A bit ugly; hard-coded dimensions. */
  
  line(0,0,0,0.2,0,0);
  line(0,0,0,0,0.2,0);
  line(0,0,0,0,0,0.2);
}
#line 480757 "MACS_sample_kidney_box.c"
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

  /* MCDISPLAY code for component 'kidney_channel_17'. */
  SIG_MESSAGE("kidney_channel_17 (McDisplay)");
  printf("MCDISPLAY: component %s\n", "kidney_channel_17");
#define mccompcurname  kidney_channel_17
#define mccompcurtype  Arm
#define mccompcurindex 66
#line 40 "/usr/share/mcstas/2.7/optics/Arm.comp"
{
  /* A bit ugly; hard-coded dimensions. */
  
  line(0,0,0,0.2,0,0);
  line(0,0,0,0,0.2,0);
  line(0,0,0,0,0,0.2);
}
#line 480776 "MACS_sample_kidney_box.c"
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

  /* MCDISPLAY code for component 'kidney_channel_18'. */
  SIG_MESSAGE("kidney_channel_18 (McDisplay)");
  printf("MCDISPLAY: component %s\n", "kidney_channel_18");
#define mccompcurname  kidney_channel_18
#define mccompcurtype  Arm
#define mccompcurindex 67
#line 40 "/usr/share/mcstas/2.7/optics/Arm.comp"
{
  /* A bit ugly; hard-coded dimensions. */
  
  line(0,0,0,0.2,0,0);
  line(0,0,0,0,0.2,0);
  line(0,0,0,0,0,0.2);
}
#line 480795 "MACS_sample_kidney_box.c"
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

  /* MCDISPLAY code for component 'kidney_channel_19'. */
  SIG_MESSAGE("kidney_channel_19 (McDisplay)");
  printf("MCDISPLAY: component %s\n", "kidney_channel_19");
#define mccompcurname  kidney_channel_19
#define mccompcurtype  Arm
#define mccompcurindex 68
#line 40 "/usr/share/mcstas/2.7/optics/Arm.comp"
{
  /* A bit ugly; hard-coded dimensions. */
  
  line(0,0,0,0.2,0,0);
  line(0,0,0,0,0.2,0);
  line(0,0,0,0,0,0.2);
}
#line 480814 "MACS_sample_kidney_box.c"
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

  /* MCDISPLAY code for component 'channel_0_filter'. */
  SIG_MESSAGE("channel_0_filter (McDisplay)");
  printf("MCDISPLAY: component %s\n", "channel_0_filter");
#define mccompcurname  channel_0_filter
#define mccompcurtype  Slit_MACS
#define mccompcurindex 69
{   /* Declarations of channel_0_filter=Slit_MACS() SETTING parameters. */
MCNUM xmin = mccchannel_0_filter_xmin;
MCNUM xmax = mccchannel_0_filter_xmax;
MCNUM ymin = mccchannel_0_filter_ymin;
MCNUM ymax = mccchannel_0_filter_ymax;
MCNUM radius = mccchannel_0_filter_radius;
MCNUM xwidth = mccchannel_0_filter_xwidth;
MCNUM yheight = mccchannel_0_filter_yheight;
#line 84 "Slit_MACS.comp"
{
  
  if (radius == 0) {
    double xw, yh;
    xw = (xmax - xmin)/2.0;
    yh = (ymax - ymin)/2.0;
    multiline(3, xmin-xw, (double)ymax, 0.0,
              (double)xmin, (double)ymax, 0.0,
              (double)xmin, ymax+yh, 0.0);
    multiline(3, xmax+xw, (double)ymax, 0.0,
              (double)xmax, (double)ymax, 0.0,
              (double)xmax, ymax+yh, 0.0);
    multiline(3, xmin-xw, (double)ymin, 0.0,
              (double)xmin, (double)ymin, 0.0,
              (double)xmin, ymin-yh, 0.0);
    multiline(3, xmax+xw, (double)ymin, 0.0,
              (double)xmax, (double)ymin, 0.0,
              (double)xmax, ymin-yh, 0.0);
  } else {
    circle("xy",0,0,0,radius);
  }
}
#line 480856 "MACS_sample_kidney_box.c"
}   /* End of channel_0_filter=Slit_MACS() SETTING parameter declarations. */
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

  /* MCDISPLAY code for component 'channel_1_filter'. */
  SIG_MESSAGE("channel_1_filter (McDisplay)");
  printf("MCDISPLAY: component %s\n", "channel_1_filter");
#define mccompcurname  channel_1_filter
#define mccompcurtype  Slit_MACS
#define mccompcurindex 70
{   /* Declarations of channel_1_filter=Slit_MACS() SETTING parameters. */
MCNUM xmin = mccchannel_1_filter_xmin;
MCNUM xmax = mccchannel_1_filter_xmax;
MCNUM ymin = mccchannel_1_filter_ymin;
MCNUM ymax = mccchannel_1_filter_ymax;
MCNUM radius = mccchannel_1_filter_radius;
MCNUM xwidth = mccchannel_1_filter_xwidth;
MCNUM yheight = mccchannel_1_filter_yheight;
#line 84 "Slit_MACS.comp"
{
  
  if (radius == 0) {
    double xw, yh;
    xw = (xmax - xmin)/2.0;
    yh = (ymax - ymin)/2.0;
    multiline(3, xmin-xw, (double)ymax, 0.0,
              (double)xmin, (double)ymax, 0.0,
              (double)xmin, ymax+yh, 0.0);
    multiline(3, xmax+xw, (double)ymax, 0.0,
              (double)xmax, (double)ymax, 0.0,
              (double)xmax, ymax+yh, 0.0);
    multiline(3, xmin-xw, (double)ymin, 0.0,
              (double)xmin, (double)ymin, 0.0,
              (double)xmin, ymin-yh, 0.0);
    multiline(3, xmax+xw, (double)ymin, 0.0,
              (double)xmax, (double)ymin, 0.0,
              (double)xmax, ymin-yh, 0.0);
  } else {
    circle("xy",0,0,0,radius);
  }
}
#line 480899 "MACS_sample_kidney_box.c"
}   /* End of channel_1_filter=Slit_MACS() SETTING parameter declarations. */
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

  /* MCDISPLAY code for component 'channel_2_filter'. */
  SIG_MESSAGE("channel_2_filter (McDisplay)");
  printf("MCDISPLAY: component %s\n", "channel_2_filter");
#define mccompcurname  channel_2_filter
#define mccompcurtype  Slit_MACS
#define mccompcurindex 71
{   /* Declarations of channel_2_filter=Slit_MACS() SETTING parameters. */
MCNUM xmin = mccchannel_2_filter_xmin;
MCNUM xmax = mccchannel_2_filter_xmax;
MCNUM ymin = mccchannel_2_filter_ymin;
MCNUM ymax = mccchannel_2_filter_ymax;
MCNUM radius = mccchannel_2_filter_radius;
MCNUM xwidth = mccchannel_2_filter_xwidth;
MCNUM yheight = mccchannel_2_filter_yheight;
#line 84 "Slit_MACS.comp"
{
  
  if (radius == 0) {
    double xw, yh;
    xw = (xmax - xmin)/2.0;
    yh = (ymax - ymin)/2.0;
    multiline(3, xmin-xw, (double)ymax, 0.0,
              (double)xmin, (double)ymax, 0.0,
              (double)xmin, ymax+yh, 0.0);
    multiline(3, xmax+xw, (double)ymax, 0.0,
              (double)xmax, (double)ymax, 0.0,
              (double)xmax, ymax+yh, 0.0);
    multiline(3, xmin-xw, (double)ymin, 0.0,
              (double)xmin, (double)ymin, 0.0,
              (double)xmin, ymin-yh, 0.0);
    multiline(3, xmax+xw, (double)ymin, 0.0,
              (double)xmax, (double)ymin, 0.0,
              (double)xmax, ymin-yh, 0.0);
  } else {
    circle("xy",0,0,0,radius);
  }
}
#line 480942 "MACS_sample_kidney_box.c"
}   /* End of channel_2_filter=Slit_MACS() SETTING parameter declarations. */
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

  /* MCDISPLAY code for component 'channel_3_filter'. */
  SIG_MESSAGE("channel_3_filter (McDisplay)");
  printf("MCDISPLAY: component %s\n", "channel_3_filter");
#define mccompcurname  channel_3_filter
#define mccompcurtype  Slit_MACS
#define mccompcurindex 72
{   /* Declarations of channel_3_filter=Slit_MACS() SETTING parameters. */
MCNUM xmin = mccchannel_3_filter_xmin;
MCNUM xmax = mccchannel_3_filter_xmax;
MCNUM ymin = mccchannel_3_filter_ymin;
MCNUM ymax = mccchannel_3_filter_ymax;
MCNUM radius = mccchannel_3_filter_radius;
MCNUM xwidth = mccchannel_3_filter_xwidth;
MCNUM yheight = mccchannel_3_filter_yheight;
#line 84 "Slit_MACS.comp"
{
  
  if (radius == 0) {
    double xw, yh;
    xw = (xmax - xmin)/2.0;
    yh = (ymax - ymin)/2.0;
    multiline(3, xmin-xw, (double)ymax, 0.0,
              (double)xmin, (double)ymax, 0.0,
              (double)xmin, ymax+yh, 0.0);
    multiline(3, xmax+xw, (double)ymax, 0.0,
              (double)xmax, (double)ymax, 0.0,
              (double)xmax, ymax+yh, 0.0);
    multiline(3, xmin-xw, (double)ymin, 0.0,
              (double)xmin, (double)ymin, 0.0,
              (double)xmin, ymin-yh, 0.0);
    multiline(3, xmax+xw, (double)ymin, 0.0,
              (double)xmax, (double)ymin, 0.0,
              (double)xmax, ymin-yh, 0.0);
  } else {
    circle("xy",0,0,0,radius);
  }
}
#line 480985 "MACS_sample_kidney_box.c"
}   /* End of channel_3_filter=Slit_MACS() SETTING parameter declarations. */
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

  /* MCDISPLAY code for component 'channel_4_filter'. */
  SIG_MESSAGE("channel_4_filter (McDisplay)");
  printf("MCDISPLAY: component %s\n", "channel_4_filter");
#define mccompcurname  channel_4_filter
#define mccompcurtype  Slit_MACS
#define mccompcurindex 73
{   /* Declarations of channel_4_filter=Slit_MACS() SETTING parameters. */
MCNUM xmin = mccchannel_4_filter_xmin;
MCNUM xmax = mccchannel_4_filter_xmax;
MCNUM ymin = mccchannel_4_filter_ymin;
MCNUM ymax = mccchannel_4_filter_ymax;
MCNUM radius = mccchannel_4_filter_radius;
MCNUM xwidth = mccchannel_4_filter_xwidth;
MCNUM yheight = mccchannel_4_filter_yheight;
#line 84 "Slit_MACS.comp"
{
  
  if (radius == 0) {
    double xw, yh;
    xw = (xmax - xmin)/2.0;
    yh = (ymax - ymin)/2.0;
    multiline(3, xmin-xw, (double)ymax, 0.0,
              (double)xmin, (double)ymax, 0.0,
              (double)xmin, ymax+yh, 0.0);
    multiline(3, xmax+xw, (double)ymax, 0.0,
              (double)xmax, (double)ymax, 0.0,
              (double)xmax, ymax+yh, 0.0);
    multiline(3, xmin-xw, (double)ymin, 0.0,
              (double)xmin, (double)ymin, 0.0,
              (double)xmin, ymin-yh, 0.0);
    multiline(3, xmax+xw, (double)ymin, 0.0,
              (double)xmax, (double)ymin, 0.0,
              (double)xmax, ymin-yh, 0.0);
  } else {
    circle("xy",0,0,0,radius);
  }
}
#line 481028 "MACS_sample_kidney_box.c"
}   /* End of channel_4_filter=Slit_MACS() SETTING parameter declarations. */
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

  /* MCDISPLAY code for component 'channel_5_filter'. */
  SIG_MESSAGE("channel_5_filter (McDisplay)");
  printf("MCDISPLAY: component %s\n", "channel_5_filter");
#define mccompcurname  channel_5_filter
#define mccompcurtype  Slit_MACS
#define mccompcurindex 74
{   /* Declarations of channel_5_filter=Slit_MACS() SETTING parameters. */
MCNUM xmin = mccchannel_5_filter_xmin;
MCNUM xmax = mccchannel_5_filter_xmax;
MCNUM ymin = mccchannel_5_filter_ymin;
MCNUM ymax = mccchannel_5_filter_ymax;
MCNUM radius = mccchannel_5_filter_radius;
MCNUM xwidth = mccchannel_5_filter_xwidth;
MCNUM yheight = mccchannel_5_filter_yheight;
#line 84 "Slit_MACS.comp"
{
  
  if (radius == 0) {
    double xw, yh;
    xw = (xmax - xmin)/2.0;
    yh = (ymax - ymin)/2.0;
    multiline(3, xmin-xw, (double)ymax, 0.0,
              (double)xmin, (double)ymax, 0.0,
              (double)xmin, ymax+yh, 0.0);
    multiline(3, xmax+xw, (double)ymax, 0.0,
              (double)xmax, (double)ymax, 0.0,
              (double)xmax, ymax+yh, 0.0);
    multiline(3, xmin-xw, (double)ymin, 0.0,
              (double)xmin, (double)ymin, 0.0,
              (double)xmin, ymin-yh, 0.0);
    multiline(3, xmax+xw, (double)ymin, 0.0,
              (double)xmax, (double)ymin, 0.0,
              (double)xmax, ymin-yh, 0.0);
  } else {
    circle("xy",0,0,0,radius);
  }
}
#line 481071 "MACS_sample_kidney_box.c"
}   /* End of channel_5_filter=Slit_MACS() SETTING parameter declarations. */
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

  /* MCDISPLAY code for component 'channel_6_filter'. */
  SIG_MESSAGE("channel_6_filter (McDisplay)");
  printf("MCDISPLAY: component %s\n", "channel_6_filter");
#define mccompcurname  channel_6_filter
#define mccompcurtype  Slit_MACS
#define mccompcurindex 75
{   /* Declarations of channel_6_filter=Slit_MACS() SETTING parameters. */
MCNUM xmin = mccchannel_6_filter_xmin;
MCNUM xmax = mccchannel_6_filter_xmax;
MCNUM ymin = mccchannel_6_filter_ymin;
MCNUM ymax = mccchannel_6_filter_ymax;
MCNUM radius = mccchannel_6_filter_radius;
MCNUM xwidth = mccchannel_6_filter_xwidth;
MCNUM yheight = mccchannel_6_filter_yheight;
#line 84 "Slit_MACS.comp"
{
  
  if (radius == 0) {
    double xw, yh;
    xw = (xmax - xmin)/2.0;
    yh = (ymax - ymin)/2.0;
    multiline(3, xmin-xw, (double)ymax, 0.0,
              (double)xmin, (double)ymax, 0.0,
              (double)xmin, ymax+yh, 0.0);
    multiline(3, xmax+xw, (double)ymax, 0.0,
              (double)xmax, (double)ymax, 0.0,
              (double)xmax, ymax+yh, 0.0);
    multiline(3, xmin-xw, (double)ymin, 0.0,
              (double)xmin, (double)ymin, 0.0,
              (double)xmin, ymin-yh, 0.0);
    multiline(3, xmax+xw, (double)ymin, 0.0,
              (double)xmax, (double)ymin, 0.0,
              (double)xmax, ymin-yh, 0.0);
  } else {
    circle("xy",0,0,0,radius);
  }
}
#line 481114 "MACS_sample_kidney_box.c"
}   /* End of channel_6_filter=Slit_MACS() SETTING parameter declarations. */
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

  /* MCDISPLAY code for component 'channel_7_filter'. */
  SIG_MESSAGE("channel_7_filter (McDisplay)");
  printf("MCDISPLAY: component %s\n", "channel_7_filter");
#define mccompcurname  channel_7_filter
#define mccompcurtype  Slit_MACS
#define mccompcurindex 76
{   /* Declarations of channel_7_filter=Slit_MACS() SETTING parameters. */
MCNUM xmin = mccchannel_7_filter_xmin;
MCNUM xmax = mccchannel_7_filter_xmax;
MCNUM ymin = mccchannel_7_filter_ymin;
MCNUM ymax = mccchannel_7_filter_ymax;
MCNUM radius = mccchannel_7_filter_radius;
MCNUM xwidth = mccchannel_7_filter_xwidth;
MCNUM yheight = mccchannel_7_filter_yheight;
#line 84 "Slit_MACS.comp"
{
  
  if (radius == 0) {
    double xw, yh;
    xw = (xmax - xmin)/2.0;
    yh = (ymax - ymin)/2.0;
    multiline(3, xmin-xw, (double)ymax, 0.0,
              (double)xmin, (double)ymax, 0.0,
              (double)xmin, ymax+yh, 0.0);
    multiline(3, xmax+xw, (double)ymax, 0.0,
              (double)xmax, (double)ymax, 0.0,
              (double)xmax, ymax+yh, 0.0);
    multiline(3, xmin-xw, (double)ymin, 0.0,
              (double)xmin, (double)ymin, 0.0,
              (double)xmin, ymin-yh, 0.0);
    multiline(3, xmax+xw, (double)ymin, 0.0,
              (double)xmax, (double)ymin, 0.0,
              (double)xmax, ymin-yh, 0.0);
  } else {
    circle("xy",0,0,0,radius);
  }
}
#line 481157 "MACS_sample_kidney_box.c"
}   /* End of channel_7_filter=Slit_MACS() SETTING parameter declarations. */
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

  /* MCDISPLAY code for component 'channel_8_filter'. */
  SIG_MESSAGE("channel_8_filter (McDisplay)");
  printf("MCDISPLAY: component %s\n", "channel_8_filter");
#define mccompcurname  channel_8_filter
#define mccompcurtype  Slit_MACS
#define mccompcurindex 77
{   /* Declarations of channel_8_filter=Slit_MACS() SETTING parameters. */
MCNUM xmin = mccchannel_8_filter_xmin;
MCNUM xmax = mccchannel_8_filter_xmax;
MCNUM ymin = mccchannel_8_filter_ymin;
MCNUM ymax = mccchannel_8_filter_ymax;
MCNUM radius = mccchannel_8_filter_radius;
MCNUM xwidth = mccchannel_8_filter_xwidth;
MCNUM yheight = mccchannel_8_filter_yheight;
#line 84 "Slit_MACS.comp"
{
  
  if (radius == 0) {
    double xw, yh;
    xw = (xmax - xmin)/2.0;
    yh = (ymax - ymin)/2.0;
    multiline(3, xmin-xw, (double)ymax, 0.0,
              (double)xmin, (double)ymax, 0.0,
              (double)xmin, ymax+yh, 0.0);
    multiline(3, xmax+xw, (double)ymax, 0.0,
              (double)xmax, (double)ymax, 0.0,
              (double)xmax, ymax+yh, 0.0);
    multiline(3, xmin-xw, (double)ymin, 0.0,
              (double)xmin, (double)ymin, 0.0,
              (double)xmin, ymin-yh, 0.0);
    multiline(3, xmax+xw, (double)ymin, 0.0,
              (double)xmax, (double)ymin, 0.0,
              (double)xmax, ymin-yh, 0.0);
  } else {
    circle("xy",0,0,0,radius);
  }
}
#line 481200 "MACS_sample_kidney_box.c"
}   /* End of channel_8_filter=Slit_MACS() SETTING parameter declarations. */
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

  /* MCDISPLAY code for component 'channel_9_filter'. */
  SIG_MESSAGE("channel_9_filter (McDisplay)");
  printf("MCDISPLAY: component %s\n", "channel_9_filter");
#define mccompcurname  channel_9_filter
#define mccompcurtype  Slit_MACS
#define mccompcurindex 78
{   /* Declarations of channel_9_filter=Slit_MACS() SETTING parameters. */
MCNUM xmin = mccchannel_9_filter_xmin;
MCNUM xmax = mccchannel_9_filter_xmax;
MCNUM ymin = mccchannel_9_filter_ymin;
MCNUM ymax = mccchannel_9_filter_ymax;
MCNUM radius = mccchannel_9_filter_radius;
MCNUM xwidth = mccchannel_9_filter_xwidth;
MCNUM yheight = mccchannel_9_filter_yheight;
#line 84 "Slit_MACS.comp"
{
  
  if (radius == 0) {
    double xw, yh;
    xw = (xmax - xmin)/2.0;
    yh = (ymax - ymin)/2.0;
    multiline(3, xmin-xw, (double)ymax, 0.0,
              (double)xmin, (double)ymax, 0.0,
              (double)xmin, ymax+yh, 0.0);
    multiline(3, xmax+xw, (double)ymax, 0.0,
              (double)xmax, (double)ymax, 0.0,
              (double)xmax, ymax+yh, 0.0);
    multiline(3, xmin-xw, (double)ymin, 0.0,
              (double)xmin, (double)ymin, 0.0,
              (double)xmin, ymin-yh, 0.0);
    multiline(3, xmax+xw, (double)ymin, 0.0,
              (double)xmax, (double)ymin, 0.0,
              (double)xmax, ymin-yh, 0.0);
  } else {
    circle("xy",0,0,0,radius);
  }
}
#line 481243 "MACS_sample_kidney_box.c"
}   /* End of channel_9_filter=Slit_MACS() SETTING parameter declarations. */
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

  /* MCDISPLAY code for component 'channel_10_filter'. */
  SIG_MESSAGE("channel_10_filter (McDisplay)");
  printf("MCDISPLAY: component %s\n", "channel_10_filter");
#define mccompcurname  channel_10_filter
#define mccompcurtype  Slit_MACS
#define mccompcurindex 79
{   /* Declarations of channel_10_filter=Slit_MACS() SETTING parameters. */
MCNUM xmin = mccchannel_10_filter_xmin;
MCNUM xmax = mccchannel_10_filter_xmax;
MCNUM ymin = mccchannel_10_filter_ymin;
MCNUM ymax = mccchannel_10_filter_ymax;
MCNUM radius = mccchannel_10_filter_radius;
MCNUM xwidth = mccchannel_10_filter_xwidth;
MCNUM yheight = mccchannel_10_filter_yheight;
#line 84 "Slit_MACS.comp"
{
  
  if (radius == 0) {
    double xw, yh;
    xw = (xmax - xmin)/2.0;
    yh = (ymax - ymin)/2.0;
    multiline(3, xmin-xw, (double)ymax, 0.0,
              (double)xmin, (double)ymax, 0.0,
              (double)xmin, ymax+yh, 0.0);
    multiline(3, xmax+xw, (double)ymax, 0.0,
              (double)xmax, (double)ymax, 0.0,
              (double)xmax, ymax+yh, 0.0);
    multiline(3, xmin-xw, (double)ymin, 0.0,
              (double)xmin, (double)ymin, 0.0,
              (double)xmin, ymin-yh, 0.0);
    multiline(3, xmax+xw, (double)ymin, 0.0,
              (double)xmax, (double)ymin, 0.0,
              (double)xmax, ymin-yh, 0.0);
  } else {
    circle("xy",0,0,0,radius);
  }
}
#line 481286 "MACS_sample_kidney_box.c"
}   /* End of channel_10_filter=Slit_MACS() SETTING parameter declarations. */
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

  /* MCDISPLAY code for component 'channel_11_filter'. */
  SIG_MESSAGE("channel_11_filter (McDisplay)");
  printf("MCDISPLAY: component %s\n", "channel_11_filter");
#define mccompcurname  channel_11_filter
#define mccompcurtype  Slit_MACS
#define mccompcurindex 80
{   /* Declarations of channel_11_filter=Slit_MACS() SETTING parameters. */
MCNUM xmin = mccchannel_11_filter_xmin;
MCNUM xmax = mccchannel_11_filter_xmax;
MCNUM ymin = mccchannel_11_filter_ymin;
MCNUM ymax = mccchannel_11_filter_ymax;
MCNUM radius = mccchannel_11_filter_radius;
MCNUM xwidth = mccchannel_11_filter_xwidth;
MCNUM yheight = mccchannel_11_filter_yheight;
#line 84 "Slit_MACS.comp"
{
  
  if (radius == 0) {
    double xw, yh;
    xw = (xmax - xmin)/2.0;
    yh = (ymax - ymin)/2.0;
    multiline(3, xmin-xw, (double)ymax, 0.0,
              (double)xmin, (double)ymax, 0.0,
              (double)xmin, ymax+yh, 0.0);
    multiline(3, xmax+xw, (double)ymax, 0.0,
              (double)xmax, (double)ymax, 0.0,
              (double)xmax, ymax+yh, 0.0);
    multiline(3, xmin-xw, (double)ymin, 0.0,
              (double)xmin, (double)ymin, 0.0,
              (double)xmin, ymin-yh, 0.0);
    multiline(3, xmax+xw, (double)ymin, 0.0,
              (double)xmax, (double)ymin, 0.0,
              (double)xmax, ymin-yh, 0.0);
  } else {
    circle("xy",0,0,0,radius);
  }
}
#line 481329 "MACS_sample_kidney_box.c"
}   /* End of channel_11_filter=Slit_MACS() SETTING parameter declarations. */
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

  /* MCDISPLAY code for component 'channel_12_filter'. */
  SIG_MESSAGE("channel_12_filter (McDisplay)");
  printf("MCDISPLAY: component %s\n", "channel_12_filter");
#define mccompcurname  channel_12_filter
#define mccompcurtype  Slit_MACS
#define mccompcurindex 81
{   /* Declarations of channel_12_filter=Slit_MACS() SETTING parameters. */
MCNUM xmin = mccchannel_12_filter_xmin;
MCNUM xmax = mccchannel_12_filter_xmax;
MCNUM ymin = mccchannel_12_filter_ymin;
MCNUM ymax = mccchannel_12_filter_ymax;
MCNUM radius = mccchannel_12_filter_radius;
MCNUM xwidth = mccchannel_12_filter_xwidth;
MCNUM yheight = mccchannel_12_filter_yheight;
#line 84 "Slit_MACS.comp"
{
  
  if (radius == 0) {
    double xw, yh;
    xw = (xmax - xmin)/2.0;
    yh = (ymax - ymin)/2.0;
    multiline(3, xmin-xw, (double)ymax, 0.0,
              (double)xmin, (double)ymax, 0.0,
              (double)xmin, ymax+yh, 0.0);
    multiline(3, xmax+xw, (double)ymax, 0.0,
              (double)xmax, (double)ymax, 0.0,
              (double)xmax, ymax+yh, 0.0);
    multiline(3, xmin-xw, (double)ymin, 0.0,
              (double)xmin, (double)ymin, 0.0,
              (double)xmin, ymin-yh, 0.0);
    multiline(3, xmax+xw, (double)ymin, 0.0,
              (double)xmax, (double)ymin, 0.0,
              (double)xmax, ymin-yh, 0.0);
  } else {
    circle("xy",0,0,0,radius);
  }
}
#line 481372 "MACS_sample_kidney_box.c"
}   /* End of channel_12_filter=Slit_MACS() SETTING parameter declarations. */
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

  /* MCDISPLAY code for component 'channel_13_filter'. */
  SIG_MESSAGE("channel_13_filter (McDisplay)");
  printf("MCDISPLAY: component %s\n", "channel_13_filter");
#define mccompcurname  channel_13_filter
#define mccompcurtype  Slit_MACS
#define mccompcurindex 82
{   /* Declarations of channel_13_filter=Slit_MACS() SETTING parameters. */
MCNUM xmin = mccchannel_13_filter_xmin;
MCNUM xmax = mccchannel_13_filter_xmax;
MCNUM ymin = mccchannel_13_filter_ymin;
MCNUM ymax = mccchannel_13_filter_ymax;
MCNUM radius = mccchannel_13_filter_radius;
MCNUM xwidth = mccchannel_13_filter_xwidth;
MCNUM yheight = mccchannel_13_filter_yheight;
#line 84 "Slit_MACS.comp"
{
  
  if (radius == 0) {
    double xw, yh;
    xw = (xmax - xmin)/2.0;
    yh = (ymax - ymin)/2.0;
    multiline(3, xmin-xw, (double)ymax, 0.0,
              (double)xmin, (double)ymax, 0.0,
              (double)xmin, ymax+yh, 0.0);
    multiline(3, xmax+xw, (double)ymax, 0.0,
              (double)xmax, (double)ymax, 0.0,
              (double)xmax, ymax+yh, 0.0);
    multiline(3, xmin-xw, (double)ymin, 0.0,
              (double)xmin, (double)ymin, 0.0,
              (double)xmin, ymin-yh, 0.0);
    multiline(3, xmax+xw, (double)ymin, 0.0,
              (double)xmax, (double)ymin, 0.0,
              (double)xmax, ymin-yh, 0.0);
  } else {
    circle("xy",0,0,0,radius);
  }
}
#line 481415 "MACS_sample_kidney_box.c"
}   /* End of channel_13_filter=Slit_MACS() SETTING parameter declarations. */
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

  /* MCDISPLAY code for component 'channel_14_filter'. */
  SIG_MESSAGE("channel_14_filter (McDisplay)");
  printf("MCDISPLAY: component %s\n", "channel_14_filter");
#define mccompcurname  channel_14_filter
#define mccompcurtype  Slit_MACS
#define mccompcurindex 83
{   /* Declarations of channel_14_filter=Slit_MACS() SETTING parameters. */
MCNUM xmin = mccchannel_14_filter_xmin;
MCNUM xmax = mccchannel_14_filter_xmax;
MCNUM ymin = mccchannel_14_filter_ymin;
MCNUM ymax = mccchannel_14_filter_ymax;
MCNUM radius = mccchannel_14_filter_radius;
MCNUM xwidth = mccchannel_14_filter_xwidth;
MCNUM yheight = mccchannel_14_filter_yheight;
#line 84 "Slit_MACS.comp"
{
  
  if (radius == 0) {
    double xw, yh;
    xw = (xmax - xmin)/2.0;
    yh = (ymax - ymin)/2.0;
    multiline(3, xmin-xw, (double)ymax, 0.0,
              (double)xmin, (double)ymax, 0.0,
              (double)xmin, ymax+yh, 0.0);
    multiline(3, xmax+xw, (double)ymax, 0.0,
              (double)xmax, (double)ymax, 0.0,
              (double)xmax, ymax+yh, 0.0);
    multiline(3, xmin-xw, (double)ymin, 0.0,
              (double)xmin, (double)ymin, 0.0,
              (double)xmin, ymin-yh, 0.0);
    multiline(3, xmax+xw, (double)ymin, 0.0,
              (double)xmax, (double)ymin, 0.0,
              (double)xmax, ymin-yh, 0.0);
  } else {
    circle("xy",0,0,0,radius);
  }
}
#line 481458 "MACS_sample_kidney_box.c"
}   /* End of channel_14_filter=Slit_MACS() SETTING parameter declarations. */
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

  /* MCDISPLAY code for component 'channel_15_filter'. */
  SIG_MESSAGE("channel_15_filter (McDisplay)");
  printf("MCDISPLAY: component %s\n", "channel_15_filter");
#define mccompcurname  channel_15_filter
#define mccompcurtype  Slit_MACS
#define mccompcurindex 84
{   /* Declarations of channel_15_filter=Slit_MACS() SETTING parameters. */
MCNUM xmin = mccchannel_15_filter_xmin;
MCNUM xmax = mccchannel_15_filter_xmax;
MCNUM ymin = mccchannel_15_filter_ymin;
MCNUM ymax = mccchannel_15_filter_ymax;
MCNUM radius = mccchannel_15_filter_radius;
MCNUM xwidth = mccchannel_15_filter_xwidth;
MCNUM yheight = mccchannel_15_filter_yheight;
#line 84 "Slit_MACS.comp"
{
  
  if (radius == 0) {
    double xw, yh;
    xw = (xmax - xmin)/2.0;
    yh = (ymax - ymin)/2.0;
    multiline(3, xmin-xw, (double)ymax, 0.0,
              (double)xmin, (double)ymax, 0.0,
              (double)xmin, ymax+yh, 0.0);
    multiline(3, xmax+xw, (double)ymax, 0.0,
              (double)xmax, (double)ymax, 0.0,
              (double)xmax, ymax+yh, 0.0);
    multiline(3, xmin-xw, (double)ymin, 0.0,
              (double)xmin, (double)ymin, 0.0,
              (double)xmin, ymin-yh, 0.0);
    multiline(3, xmax+xw, (double)ymin, 0.0,
              (double)xmax, (double)ymin, 0.0,
              (double)xmax, ymin-yh, 0.0);
  } else {
    circle("xy",0,0,0,radius);
  }
}
#line 481501 "MACS_sample_kidney_box.c"
}   /* End of channel_15_filter=Slit_MACS() SETTING parameter declarations. */
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

  /* MCDISPLAY code for component 'channel_16_filter'. */
  SIG_MESSAGE("channel_16_filter (McDisplay)");
  printf("MCDISPLAY: component %s\n", "channel_16_filter");
#define mccompcurname  channel_16_filter
#define mccompcurtype  Slit_MACS
#define mccompcurindex 85
{   /* Declarations of channel_16_filter=Slit_MACS() SETTING parameters. */
MCNUM xmin = mccchannel_16_filter_xmin;
MCNUM xmax = mccchannel_16_filter_xmax;
MCNUM ymin = mccchannel_16_filter_ymin;
MCNUM ymax = mccchannel_16_filter_ymax;
MCNUM radius = mccchannel_16_filter_radius;
MCNUM xwidth = mccchannel_16_filter_xwidth;
MCNUM yheight = mccchannel_16_filter_yheight;
#line 84 "Slit_MACS.comp"
{
  
  if (radius == 0) {
    double xw, yh;
    xw = (xmax - xmin)/2.0;
    yh = (ymax - ymin)/2.0;
    multiline(3, xmin-xw, (double)ymax, 0.0,
              (double)xmin, (double)ymax, 0.0,
              (double)xmin, ymax+yh, 0.0);
    multiline(3, xmax+xw, (double)ymax, 0.0,
              (double)xmax, (double)ymax, 0.0,
              (double)xmax, ymax+yh, 0.0);
    multiline(3, xmin-xw, (double)ymin, 0.0,
              (double)xmin, (double)ymin, 0.0,
              (double)xmin, ymin-yh, 0.0);
    multiline(3, xmax+xw, (double)ymin, 0.0,
              (double)xmax, (double)ymin, 0.0,
              (double)xmax, ymin-yh, 0.0);
  } else {
    circle("xy",0,0,0,radius);
  }
}
#line 481544 "MACS_sample_kidney_box.c"
}   /* End of channel_16_filter=Slit_MACS() SETTING parameter declarations. */
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

  /* MCDISPLAY code for component 'channel_17_filter'. */
  SIG_MESSAGE("channel_17_filter (McDisplay)");
  printf("MCDISPLAY: component %s\n", "channel_17_filter");
#define mccompcurname  channel_17_filter
#define mccompcurtype  Slit_MACS
#define mccompcurindex 86
{   /* Declarations of channel_17_filter=Slit_MACS() SETTING parameters. */
MCNUM xmin = mccchannel_17_filter_xmin;
MCNUM xmax = mccchannel_17_filter_xmax;
MCNUM ymin = mccchannel_17_filter_ymin;
MCNUM ymax = mccchannel_17_filter_ymax;
MCNUM radius = mccchannel_17_filter_radius;
MCNUM xwidth = mccchannel_17_filter_xwidth;
MCNUM yheight = mccchannel_17_filter_yheight;
#line 84 "Slit_MACS.comp"
{
  
  if (radius == 0) {
    double xw, yh;
    xw = (xmax - xmin)/2.0;
    yh = (ymax - ymin)/2.0;
    multiline(3, xmin-xw, (double)ymax, 0.0,
              (double)xmin, (double)ymax, 0.0,
              (double)xmin, ymax+yh, 0.0);
    multiline(3, xmax+xw, (double)ymax, 0.0,
              (double)xmax, (double)ymax, 0.0,
              (double)xmax, ymax+yh, 0.0);
    multiline(3, xmin-xw, (double)ymin, 0.0,
              (double)xmin, (double)ymin, 0.0,
              (double)xmin, ymin-yh, 0.0);
    multiline(3, xmax+xw, (double)ymin, 0.0,
              (double)xmax, (double)ymin, 0.0,
              (double)xmax, ymin-yh, 0.0);
  } else {
    circle("xy",0,0,0,radius);
  }
}
#line 481587 "MACS_sample_kidney_box.c"
}   /* End of channel_17_filter=Slit_MACS() SETTING parameter declarations. */
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

  /* MCDISPLAY code for component 'channel_18_filter'. */
  SIG_MESSAGE("channel_18_filter (McDisplay)");
  printf("MCDISPLAY: component %s\n", "channel_18_filter");
#define mccompcurname  channel_18_filter
#define mccompcurtype  Slit_MACS
#define mccompcurindex 87
{   /* Declarations of channel_18_filter=Slit_MACS() SETTING parameters. */
MCNUM xmin = mccchannel_18_filter_xmin;
MCNUM xmax = mccchannel_18_filter_xmax;
MCNUM ymin = mccchannel_18_filter_ymin;
MCNUM ymax = mccchannel_18_filter_ymax;
MCNUM radius = mccchannel_18_filter_radius;
MCNUM xwidth = mccchannel_18_filter_xwidth;
MCNUM yheight = mccchannel_18_filter_yheight;
#line 84 "Slit_MACS.comp"
{
  
  if (radius == 0) {
    double xw, yh;
    xw = (xmax - xmin)/2.0;
    yh = (ymax - ymin)/2.0;
    multiline(3, xmin-xw, (double)ymax, 0.0,
              (double)xmin, (double)ymax, 0.0,
              (double)xmin, ymax+yh, 0.0);
    multiline(3, xmax+xw, (double)ymax, 0.0,
              (double)xmax, (double)ymax, 0.0,
              (double)xmax, ymax+yh, 0.0);
    multiline(3, xmin-xw, (double)ymin, 0.0,
              (double)xmin, (double)ymin, 0.0,
              (double)xmin, ymin-yh, 0.0);
    multiline(3, xmax+xw, (double)ymin, 0.0,
              (double)xmax, (double)ymin, 0.0,
              (double)xmax, ymin-yh, 0.0);
  } else {
    circle("xy",0,0,0,radius);
  }
}
#line 481630 "MACS_sample_kidney_box.c"
}   /* End of channel_18_filter=Slit_MACS() SETTING parameter declarations. */
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

  /* MCDISPLAY code for component 'channel_19_filter'. */
  SIG_MESSAGE("channel_19_filter (McDisplay)");
  printf("MCDISPLAY: component %s\n", "channel_19_filter");
#define mccompcurname  channel_19_filter
#define mccompcurtype  Slit_MACS
#define mccompcurindex 88
{   /* Declarations of channel_19_filter=Slit_MACS() SETTING parameters. */
MCNUM xmin = mccchannel_19_filter_xmin;
MCNUM xmax = mccchannel_19_filter_xmax;
MCNUM ymin = mccchannel_19_filter_ymin;
MCNUM ymax = mccchannel_19_filter_ymax;
MCNUM radius = mccchannel_19_filter_radius;
MCNUM xwidth = mccchannel_19_filter_xwidth;
MCNUM yheight = mccchannel_19_filter_yheight;
#line 84 "Slit_MACS.comp"
{
  
  if (radius == 0) {
    double xw, yh;
    xw = (xmax - xmin)/2.0;
    yh = (ymax - ymin)/2.0;
    multiline(3, xmin-xw, (double)ymax, 0.0,
              (double)xmin, (double)ymax, 0.0,
              (double)xmin, ymax+yh, 0.0);
    multiline(3, xmax+xw, (double)ymax, 0.0,
              (double)xmax, (double)ymax, 0.0,
              (double)xmax, ymax+yh, 0.0);
    multiline(3, xmin-xw, (double)ymin, 0.0,
              (double)xmin, (double)ymin, 0.0,
              (double)xmin, ymin-yh, 0.0);
    multiline(3, xmax+xw, (double)ymin, 0.0,
              (double)xmax, (double)ymin, 0.0,
              (double)xmax, ymin-yh, 0.0);
  } else {
    circle("xy",0,0,0,radius);
  }
}
#line 481673 "MACS_sample_kidney_box.c"
}   /* End of channel_19_filter=Slit_MACS() SETTING parameter declarations. */
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

  /* MCDISPLAY code for component 'channel_selector'. */
  SIG_MESSAGE("channel_selector (McDisplay)");
  printf("MCDISPLAY: component %s\n", "channel_selector");
#define mccompcurname  channel_selector
#define mccompcurtype  Arm
#define mccompcurindex 89
#line 40 "/usr/share/mcstas/2.7/optics/Arm.comp"
{
  /* A bit ugly; hard-coded dimensions. */
  
  line(0,0,0,0.2,0,0);
  line(0,0,0,0,0.2,0);
  line(0,0,0,0,0,0.2);
}
#line 481693 "MACS_sample_kidney_box.c"
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

  /* MCDISPLAY code for component 'channel_0_colimator'. */
  SIG_MESSAGE("channel_0_colimator (McDisplay)");
  printf("MCDISPLAY: component %s\n", "channel_0_colimator");
#define mccompcurname  channel_0_colimator
#define mccompcurtype  Collimator_linear
#define mccompcurindex 90
#define slope mccchannel_0_colimator_slope
#define slopeV mccchannel_0_colimator_slopeV
{   /* Declarations of channel_0_colimator=Collimator_linear() SETTING parameters. */
MCNUM xmin = mccchannel_0_colimator_xmin;
MCNUM xmax = mccchannel_0_colimator_xmax;
MCNUM ymin = mccchannel_0_colimator_ymin;
MCNUM ymax = mccchannel_0_colimator_ymax;
MCNUM xwidth = mccchannel_0_colimator_xwidth;
MCNUM yheight = mccchannel_0_colimator_yheight;
MCNUM length = mccchannel_0_colimator_length;
MCNUM divergence = mccchannel_0_colimator_divergence;
MCNUM transmission = mccchannel_0_colimator_transmission;
MCNUM divergenceV = mccchannel_0_colimator_divergenceV;
#line 100 "/usr/share/mcstas/2.7/optics/Collimator_linear.comp"
{
  double x;
  int i;

  
  for(x = xmin, i = 0; i <= 3; i++, x += (xmax - xmin)/3.0)
    multiline(5, x, (double)ymin, 0.0, x, (double)ymax, 0.0,
              x, (double)ymax, (double)length, x, (double)ymin, (double)length,
              x, (double)ymin, 0.0);
  line(xmin, ymin, 0,   xmax, ymin, 0);
  line(xmin, ymax, 0,   xmax, ymax, 0);
  line(xmin, ymin, length, xmax, ymin, length);
  line(xmin, ymax, length, xmax, ymax, length);
}
#line 481732 "MACS_sample_kidney_box.c"
}   /* End of channel_0_colimator=Collimator_linear() SETTING parameter declarations. */
#undef slopeV
#undef slope
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

  /* MCDISPLAY code for component 'channel_1_colimator'. */
  SIG_MESSAGE("channel_1_colimator (McDisplay)");
  printf("MCDISPLAY: component %s\n", "channel_1_colimator");
#define mccompcurname  channel_1_colimator
#define mccompcurtype  Collimator_linear
#define mccompcurindex 91
#define slope mccchannel_1_colimator_slope
#define slopeV mccchannel_1_colimator_slopeV
{   /* Declarations of channel_1_colimator=Collimator_linear() SETTING parameters. */
MCNUM xmin = mccchannel_1_colimator_xmin;
MCNUM xmax = mccchannel_1_colimator_xmax;
MCNUM ymin = mccchannel_1_colimator_ymin;
MCNUM ymax = mccchannel_1_colimator_ymax;
MCNUM xwidth = mccchannel_1_colimator_xwidth;
MCNUM yheight = mccchannel_1_colimator_yheight;
MCNUM length = mccchannel_1_colimator_length;
MCNUM divergence = mccchannel_1_colimator_divergence;
MCNUM transmission = mccchannel_1_colimator_transmission;
MCNUM divergenceV = mccchannel_1_colimator_divergenceV;
#line 100 "/usr/share/mcstas/2.7/optics/Collimator_linear.comp"
{
  double x;
  int i;

  
  for(x = xmin, i = 0; i <= 3; i++, x += (xmax - xmin)/3.0)
    multiline(5, x, (double)ymin, 0.0, x, (double)ymax, 0.0,
              x, (double)ymax, (double)length, x, (double)ymin, (double)length,
              x, (double)ymin, 0.0);
  line(xmin, ymin, 0,   xmax, ymin, 0);
  line(xmin, ymax, 0,   xmax, ymax, 0);
  line(xmin, ymin, length, xmax, ymin, length);
  line(xmin, ymax, length, xmax, ymax, length);
}
#line 481774 "MACS_sample_kidney_box.c"
}   /* End of channel_1_colimator=Collimator_linear() SETTING parameter declarations. */
#undef slopeV
#undef slope
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

  /* MCDISPLAY code for component 'channel_2_colimator'. */
  SIG_MESSAGE("channel_2_colimator (McDisplay)");
  printf("MCDISPLAY: component %s\n", "channel_2_colimator");
#define mccompcurname  channel_2_colimator
#define mccompcurtype  Collimator_linear
#define mccompcurindex 92
#define slope mccchannel_2_colimator_slope
#define slopeV mccchannel_2_colimator_slopeV
{   /* Declarations of channel_2_colimator=Collimator_linear() SETTING parameters. */
MCNUM xmin = mccchannel_2_colimator_xmin;
MCNUM xmax = mccchannel_2_colimator_xmax;
MCNUM ymin = mccchannel_2_colimator_ymin;
MCNUM ymax = mccchannel_2_colimator_ymax;
MCNUM xwidth = mccchannel_2_colimator_xwidth;
MCNUM yheight = mccchannel_2_colimator_yheight;
MCNUM length = mccchannel_2_colimator_length;
MCNUM divergence = mccchannel_2_colimator_divergence;
MCNUM transmission = mccchannel_2_colimator_transmission;
MCNUM divergenceV = mccchannel_2_colimator_divergenceV;
#line 100 "/usr/share/mcstas/2.7/optics/Collimator_linear.comp"
{
  double x;
  int i;

  
  for(x = xmin, i = 0; i <= 3; i++, x += (xmax - xmin)/3.0)
    multiline(5, x, (double)ymin, 0.0, x, (double)ymax, 0.0,
              x, (double)ymax, (double)length, x, (double)ymin, (double)length,
              x, (double)ymin, 0.0);
  line(xmin, ymin, 0,   xmax, ymin, 0);
  line(xmin, ymax, 0,   xmax, ymax, 0);
  line(xmin, ymin, length, xmax, ymin, length);
  line(xmin, ymax, length, xmax, ymax, length);
}
#line 481816 "MACS_sample_kidney_box.c"
}   /* End of channel_2_colimator=Collimator_linear() SETTING parameter declarations. */
#undef slopeV
#undef slope
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

  /* MCDISPLAY code for component 'channel_3_colimator'. */
  SIG_MESSAGE("channel_3_colimator (McDisplay)");
  printf("MCDISPLAY: component %s\n", "channel_3_colimator");
#define mccompcurname  channel_3_colimator
#define mccompcurtype  Collimator_linear
#define mccompcurindex 93
#define slope mccchannel_3_colimator_slope
#define slopeV mccchannel_3_colimator_slopeV
{   /* Declarations of channel_3_colimator=Collimator_linear() SETTING parameters. */
MCNUM xmin = mccchannel_3_colimator_xmin;
MCNUM xmax = mccchannel_3_colimator_xmax;
MCNUM ymin = mccchannel_3_colimator_ymin;
MCNUM ymax = mccchannel_3_colimator_ymax;
MCNUM xwidth = mccchannel_3_colimator_xwidth;
MCNUM yheight = mccchannel_3_colimator_yheight;
MCNUM length = mccchannel_3_colimator_length;
MCNUM divergence = mccchannel_3_colimator_divergence;
MCNUM transmission = mccchannel_3_colimator_transmission;
MCNUM divergenceV = mccchannel_3_colimator_divergenceV;
#line 100 "/usr/share/mcstas/2.7/optics/Collimator_linear.comp"
{
  double x;
  int i;

  
  for(x = xmin, i = 0; i <= 3; i++, x += (xmax - xmin)/3.0)
    multiline(5, x, (double)ymin, 0.0, x, (double)ymax, 0.0,
              x, (double)ymax, (double)length, x, (double)ymin, (double)length,
              x, (double)ymin, 0.0);
  line(xmin, ymin, 0,   xmax, ymin, 0);
  line(xmin, ymax, 0,   xmax, ymax, 0);
  line(xmin, ymin, length, xmax, ymin, length);
  line(xmin, ymax, length, xmax, ymax, length);
}
#line 481858 "MACS_sample_kidney_box.c"
}   /* End of channel_3_colimator=Collimator_linear() SETTING parameter declarations. */
#undef slopeV
#undef slope
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

  /* MCDISPLAY code for component 'channel_4_colimator'. */
  SIG_MESSAGE("channel_4_colimator (McDisplay)");
  printf("MCDISPLAY: component %s\n", "channel_4_colimator");
#define mccompcurname  channel_4_colimator
#define mccompcurtype  Collimator_linear
#define mccompcurindex 94
#define slope mccchannel_4_colimator_slope
#define slopeV mccchannel_4_colimator_slopeV
{   /* Declarations of channel_4_colimator=Collimator_linear() SETTING parameters. */
MCNUM xmin = mccchannel_4_colimator_xmin;
MCNUM xmax = mccchannel_4_colimator_xmax;
MCNUM ymin = mccchannel_4_colimator_ymin;
MCNUM ymax = mccchannel_4_colimator_ymax;
MCNUM xwidth = mccchannel_4_colimator_xwidth;
MCNUM yheight = mccchannel_4_colimator_yheight;
MCNUM length = mccchannel_4_colimator_length;
MCNUM divergence = mccchannel_4_colimator_divergence;
MCNUM transmission = mccchannel_4_colimator_transmission;
MCNUM divergenceV = mccchannel_4_colimator_divergenceV;
#line 100 "/usr/share/mcstas/2.7/optics/Collimator_linear.comp"
{
  double x;
  int i;

  
  for(x = xmin, i = 0; i <= 3; i++, x += (xmax - xmin)/3.0)
    multiline(5, x, (double)ymin, 0.0, x, (double)ymax, 0.0,
              x, (double)ymax, (double)length, x, (double)ymin, (double)length,
              x, (double)ymin, 0.0);
  line(xmin, ymin, 0,   xmax, ymin, 0);
  line(xmin, ymax, 0,   xmax, ymax, 0);
  line(xmin, ymin, length, xmax, ymin, length);
  line(xmin, ymax, length, xmax, ymax, length);
}
#line 481900 "MACS_sample_kidney_box.c"
}   /* End of channel_4_colimator=Collimator_linear() SETTING parameter declarations. */
#undef slopeV
#undef slope
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

  /* MCDISPLAY code for component 'channel_5_colimator'. */
  SIG_MESSAGE("channel_5_colimator (McDisplay)");
  printf("MCDISPLAY: component %s\n", "channel_5_colimator");
#define mccompcurname  channel_5_colimator
#define mccompcurtype  Collimator_linear
#define mccompcurindex 95
#define slope mccchannel_5_colimator_slope
#define slopeV mccchannel_5_colimator_slopeV
{   /* Declarations of channel_5_colimator=Collimator_linear() SETTING parameters. */
MCNUM xmin = mccchannel_5_colimator_xmin;
MCNUM xmax = mccchannel_5_colimator_xmax;
MCNUM ymin = mccchannel_5_colimator_ymin;
MCNUM ymax = mccchannel_5_colimator_ymax;
MCNUM xwidth = mccchannel_5_colimator_xwidth;
MCNUM yheight = mccchannel_5_colimator_yheight;
MCNUM length = mccchannel_5_colimator_length;
MCNUM divergence = mccchannel_5_colimator_divergence;
MCNUM transmission = mccchannel_5_colimator_transmission;
MCNUM divergenceV = mccchannel_5_colimator_divergenceV;
#line 100 "/usr/share/mcstas/2.7/optics/Collimator_linear.comp"
{
  double x;
  int i;

  
  for(x = xmin, i = 0; i <= 3; i++, x += (xmax - xmin)/3.0)
    multiline(5, x, (double)ymin, 0.0, x, (double)ymax, 0.0,
              x, (double)ymax, (double)length, x, (double)ymin, (double)length,
              x, (double)ymin, 0.0);
  line(xmin, ymin, 0,   xmax, ymin, 0);
  line(xmin, ymax, 0,   xmax, ymax, 0);
  line(xmin, ymin, length, xmax, ymin, length);
  line(xmin, ymax, length, xmax, ymax, length);
}
#line 481942 "MACS_sample_kidney_box.c"
}   /* End of channel_5_colimator=Collimator_linear() SETTING parameter declarations. */
#undef slopeV
#undef slope
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

  /* MCDISPLAY code for component 'channel_6_colimator'. */
  SIG_MESSAGE("channel_6_colimator (McDisplay)");
  printf("MCDISPLAY: component %s\n", "channel_6_colimator");
#define mccompcurname  channel_6_colimator
#define mccompcurtype  Collimator_linear
#define mccompcurindex 96
#define slope mccchannel_6_colimator_slope
#define slopeV mccchannel_6_colimator_slopeV
{   /* Declarations of channel_6_colimator=Collimator_linear() SETTING parameters. */
MCNUM xmin = mccchannel_6_colimator_xmin;
MCNUM xmax = mccchannel_6_colimator_xmax;
MCNUM ymin = mccchannel_6_colimator_ymin;
MCNUM ymax = mccchannel_6_colimator_ymax;
MCNUM xwidth = mccchannel_6_colimator_xwidth;
MCNUM yheight = mccchannel_6_colimator_yheight;
MCNUM length = mccchannel_6_colimator_length;
MCNUM divergence = mccchannel_6_colimator_divergence;
MCNUM transmission = mccchannel_6_colimator_transmission;
MCNUM divergenceV = mccchannel_6_colimator_divergenceV;
#line 100 "/usr/share/mcstas/2.7/optics/Collimator_linear.comp"
{
  double x;
  int i;

  
  for(x = xmin, i = 0; i <= 3; i++, x += (xmax - xmin)/3.0)
    multiline(5, x, (double)ymin, 0.0, x, (double)ymax, 0.0,
              x, (double)ymax, (double)length, x, (double)ymin, (double)length,
              x, (double)ymin, 0.0);
  line(xmin, ymin, 0,   xmax, ymin, 0);
  line(xmin, ymax, 0,   xmax, ymax, 0);
  line(xmin, ymin, length, xmax, ymin, length);
  line(xmin, ymax, length, xmax, ymax, length);
}
#line 481984 "MACS_sample_kidney_box.c"
}   /* End of channel_6_colimator=Collimator_linear() SETTING parameter declarations. */
#undef slopeV
#undef slope
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

  /* MCDISPLAY code for component 'channel_7_colimator'. */
  SIG_MESSAGE("channel_7_colimator (McDisplay)");
  printf("MCDISPLAY: component %s\n", "channel_7_colimator");
#define mccompcurname  channel_7_colimator
#define mccompcurtype  Collimator_linear
#define mccompcurindex 97
#define slope mccchannel_7_colimator_slope
#define slopeV mccchannel_7_colimator_slopeV
{   /* Declarations of channel_7_colimator=Collimator_linear() SETTING parameters. */
MCNUM xmin = mccchannel_7_colimator_xmin;
MCNUM xmax = mccchannel_7_colimator_xmax;
MCNUM ymin = mccchannel_7_colimator_ymin;
MCNUM ymax = mccchannel_7_colimator_ymax;
MCNUM xwidth = mccchannel_7_colimator_xwidth;
MCNUM yheight = mccchannel_7_colimator_yheight;
MCNUM length = mccchannel_7_colimator_length;
MCNUM divergence = mccchannel_7_colimator_divergence;
MCNUM transmission = mccchannel_7_colimator_transmission;
MCNUM divergenceV = mccchannel_7_colimator_divergenceV;
#line 100 "/usr/share/mcstas/2.7/optics/Collimator_linear.comp"
{
  double x;
  int i;

  
  for(x = xmin, i = 0; i <= 3; i++, x += (xmax - xmin)/3.0)
    multiline(5, x, (double)ymin, 0.0, x, (double)ymax, 0.0,
              x, (double)ymax, (double)length, x, (double)ymin, (double)length,
              x, (double)ymin, 0.0);
  line(xmin, ymin, 0,   xmax, ymin, 0);
  line(xmin, ymax, 0,   xmax, ymax, 0);
  line(xmin, ymin, length, xmax, ymin, length);
  line(xmin, ymax, length, xmax, ymax, length);
}
#line 482026 "MACS_sample_kidney_box.c"
}   /* End of channel_7_colimator=Collimator_linear() SETTING parameter declarations. */
#undef slopeV
#undef slope
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

  /* MCDISPLAY code for component 'channel_8_colimator'. */
  SIG_MESSAGE("channel_8_colimator (McDisplay)");
  printf("MCDISPLAY: component %s\n", "channel_8_colimator");
#define mccompcurname  channel_8_colimator
#define mccompcurtype  Collimator_linear
#define mccompcurindex 98
#define slope mccchannel_8_colimator_slope
#define slopeV mccchannel_8_colimator_slopeV
{   /* Declarations of channel_8_colimator=Collimator_linear() SETTING parameters. */
MCNUM xmin = mccchannel_8_colimator_xmin;
MCNUM xmax = mccchannel_8_colimator_xmax;
MCNUM ymin = mccchannel_8_colimator_ymin;
MCNUM ymax = mccchannel_8_colimator_ymax;
MCNUM xwidth = mccchannel_8_colimator_xwidth;
MCNUM yheight = mccchannel_8_colimator_yheight;
MCNUM length = mccchannel_8_colimator_length;
MCNUM divergence = mccchannel_8_colimator_divergence;
MCNUM transmission = mccchannel_8_colimator_transmission;
MCNUM divergenceV = mccchannel_8_colimator_divergenceV;
#line 100 "/usr/share/mcstas/2.7/optics/Collimator_linear.comp"
{
  double x;
  int i;

  
  for(x = xmin, i = 0; i <= 3; i++, x += (xmax - xmin)/3.0)
    multiline(5, x, (double)ymin, 0.0, x, (double)ymax, 0.0,
              x, (double)ymax, (double)length, x, (double)ymin, (double)length,
              x, (double)ymin, 0.0);
  line(xmin, ymin, 0,   xmax, ymin, 0);
  line(xmin, ymax, 0,   xmax, ymax, 0);
  line(xmin, ymin, length, xmax, ymin, length);
  line(xmin, ymax, length, xmax, ymax, length);
}
#line 482068 "MACS_sample_kidney_box.c"
}   /* End of channel_8_colimator=Collimator_linear() SETTING parameter declarations. */
#undef slopeV
#undef slope
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

  /* MCDISPLAY code for component 'channel_9_colimator'. */
  SIG_MESSAGE("channel_9_colimator (McDisplay)");
  printf("MCDISPLAY: component %s\n", "channel_9_colimator");
#define mccompcurname  channel_9_colimator
#define mccompcurtype  Collimator_linear
#define mccompcurindex 99
#define slope mccchannel_9_colimator_slope
#define slopeV mccchannel_9_colimator_slopeV
{   /* Declarations of channel_9_colimator=Collimator_linear() SETTING parameters. */
MCNUM xmin = mccchannel_9_colimator_xmin;
MCNUM xmax = mccchannel_9_colimator_xmax;
MCNUM ymin = mccchannel_9_colimator_ymin;
MCNUM ymax = mccchannel_9_colimator_ymax;
MCNUM xwidth = mccchannel_9_colimator_xwidth;
MCNUM yheight = mccchannel_9_colimator_yheight;
MCNUM length = mccchannel_9_colimator_length;
MCNUM divergence = mccchannel_9_colimator_divergence;
MCNUM transmission = mccchannel_9_colimator_transmission;
MCNUM divergenceV = mccchannel_9_colimator_divergenceV;
#line 100 "/usr/share/mcstas/2.7/optics/Collimator_linear.comp"
{
  double x;
  int i;

  
  for(x = xmin, i = 0; i <= 3; i++, x += (xmax - xmin)/3.0)
    multiline(5, x, (double)ymin, 0.0, x, (double)ymax, 0.0,
              x, (double)ymax, (double)length, x, (double)ymin, (double)length,
              x, (double)ymin, 0.0);
  line(xmin, ymin, 0,   xmax, ymin, 0);
  line(xmin, ymax, 0,   xmax, ymax, 0);
  line(xmin, ymin, length, xmax, ymin, length);
  line(xmin, ymax, length, xmax, ymax, length);
}
#line 482110 "MACS_sample_kidney_box.c"
}   /* End of channel_9_colimator=Collimator_linear() SETTING parameter declarations. */
#undef slopeV
#undef slope
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

  /* MCDISPLAY code for component 'channel_10_colimator'. */
  SIG_MESSAGE("channel_10_colimator (McDisplay)");
  printf("MCDISPLAY: component %s\n", "channel_10_colimator");
#define mccompcurname  channel_10_colimator
#define mccompcurtype  Collimator_linear
#define mccompcurindex 100
#define slope mccchannel_10_colimator_slope
#define slopeV mccchannel_10_colimator_slopeV
{   /* Declarations of channel_10_colimator=Collimator_linear() SETTING parameters. */
MCNUM xmin = mccchannel_10_colimator_xmin;
MCNUM xmax = mccchannel_10_colimator_xmax;
MCNUM ymin = mccchannel_10_colimator_ymin;
MCNUM ymax = mccchannel_10_colimator_ymax;
MCNUM xwidth = mccchannel_10_colimator_xwidth;
MCNUM yheight = mccchannel_10_colimator_yheight;
MCNUM length = mccchannel_10_colimator_length;
MCNUM divergence = mccchannel_10_colimator_divergence;
MCNUM transmission = mccchannel_10_colimator_transmission;
MCNUM divergenceV = mccchannel_10_colimator_divergenceV;
#line 100 "/usr/share/mcstas/2.7/optics/Collimator_linear.comp"
{
  double x;
  int i;

  
  for(x = xmin, i = 0; i <= 3; i++, x += (xmax - xmin)/3.0)
    multiline(5, x, (double)ymin, 0.0, x, (double)ymax, 0.0,
              x, (double)ymax, (double)length, x, (double)ymin, (double)length,
              x, (double)ymin, 0.0);
  line(xmin, ymin, 0,   xmax, ymin, 0);
  line(xmin, ymax, 0,   xmax, ymax, 0);
  line(xmin, ymin, length, xmax, ymin, length);
  line(xmin, ymax, length, xmax, ymax, length);
}
#line 482152 "MACS_sample_kidney_box.c"
}   /* End of channel_10_colimator=Collimator_linear() SETTING parameter declarations. */
#undef slopeV
#undef slope
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

  /* MCDISPLAY code for component 'channel_11_colimator'. */
  SIG_MESSAGE("channel_11_colimator (McDisplay)");
  printf("MCDISPLAY: component %s\n", "channel_11_colimator");
#define mccompcurname  channel_11_colimator
#define mccompcurtype  Collimator_linear
#define mccompcurindex 101
#define slope mccchannel_11_colimator_slope
#define slopeV mccchannel_11_colimator_slopeV
{   /* Declarations of channel_11_colimator=Collimator_linear() SETTING parameters. */
MCNUM xmin = mccchannel_11_colimator_xmin;
MCNUM xmax = mccchannel_11_colimator_xmax;
MCNUM ymin = mccchannel_11_colimator_ymin;
MCNUM ymax = mccchannel_11_colimator_ymax;
MCNUM xwidth = mccchannel_11_colimator_xwidth;
MCNUM yheight = mccchannel_11_colimator_yheight;
MCNUM length = mccchannel_11_colimator_length;
MCNUM divergence = mccchannel_11_colimator_divergence;
MCNUM transmission = mccchannel_11_colimator_transmission;
MCNUM divergenceV = mccchannel_11_colimator_divergenceV;
#line 100 "/usr/share/mcstas/2.7/optics/Collimator_linear.comp"
{
  double x;
  int i;

  
  for(x = xmin, i = 0; i <= 3; i++, x += (xmax - xmin)/3.0)
    multiline(5, x, (double)ymin, 0.0, x, (double)ymax, 0.0,
              x, (double)ymax, (double)length, x, (double)ymin, (double)length,
              x, (double)ymin, 0.0);
  line(xmin, ymin, 0,   xmax, ymin, 0);
  line(xmin, ymax, 0,   xmax, ymax, 0);
  line(xmin, ymin, length, xmax, ymin, length);
  line(xmin, ymax, length, xmax, ymax, length);
}
#line 482194 "MACS_sample_kidney_box.c"
}   /* End of channel_11_colimator=Collimator_linear() SETTING parameter declarations. */
#undef slopeV
#undef slope
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

  /* MCDISPLAY code for component 'channel_12_colimator'. */
  SIG_MESSAGE("channel_12_colimator (McDisplay)");
  printf("MCDISPLAY: component %s\n", "channel_12_colimator");
#define mccompcurname  channel_12_colimator
#define mccompcurtype  Collimator_linear
#define mccompcurindex 102
#define slope mccchannel_12_colimator_slope
#define slopeV mccchannel_12_colimator_slopeV
{   /* Declarations of channel_12_colimator=Collimator_linear() SETTING parameters. */
MCNUM xmin = mccchannel_12_colimator_xmin;
MCNUM xmax = mccchannel_12_colimator_xmax;
MCNUM ymin = mccchannel_12_colimator_ymin;
MCNUM ymax = mccchannel_12_colimator_ymax;
MCNUM xwidth = mccchannel_12_colimator_xwidth;
MCNUM yheight = mccchannel_12_colimator_yheight;
MCNUM length = mccchannel_12_colimator_length;
MCNUM divergence = mccchannel_12_colimator_divergence;
MCNUM transmission = mccchannel_12_colimator_transmission;
MCNUM divergenceV = mccchannel_12_colimator_divergenceV;
#line 100 "/usr/share/mcstas/2.7/optics/Collimator_linear.comp"
{
  double x;
  int i;

  
  for(x = xmin, i = 0; i <= 3; i++, x += (xmax - xmin)/3.0)
    multiline(5, x, (double)ymin, 0.0, x, (double)ymax, 0.0,
              x, (double)ymax, (double)length, x, (double)ymin, (double)length,
              x, (double)ymin, 0.0);
  line(xmin, ymin, 0,   xmax, ymin, 0);
  line(xmin, ymax, 0,   xmax, ymax, 0);
  line(xmin, ymin, length, xmax, ymin, length);
  line(xmin, ymax, length, xmax, ymax, length);
}
#line 482236 "MACS_sample_kidney_box.c"
}   /* End of channel_12_colimator=Collimator_linear() SETTING parameter declarations. */
#undef slopeV
#undef slope
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

  /* MCDISPLAY code for component 'channel_13_colimator'. */
  SIG_MESSAGE("channel_13_colimator (McDisplay)");
  printf("MCDISPLAY: component %s\n", "channel_13_colimator");
#define mccompcurname  channel_13_colimator
#define mccompcurtype  Collimator_linear
#define mccompcurindex 103
#define slope mccchannel_13_colimator_slope
#define slopeV mccchannel_13_colimator_slopeV
{   /* Declarations of channel_13_colimator=Collimator_linear() SETTING parameters. */
MCNUM xmin = mccchannel_13_colimator_xmin;
MCNUM xmax = mccchannel_13_colimator_xmax;
MCNUM ymin = mccchannel_13_colimator_ymin;
MCNUM ymax = mccchannel_13_colimator_ymax;
MCNUM xwidth = mccchannel_13_colimator_xwidth;
MCNUM yheight = mccchannel_13_colimator_yheight;
MCNUM length = mccchannel_13_colimator_length;
MCNUM divergence = mccchannel_13_colimator_divergence;
MCNUM transmission = mccchannel_13_colimator_transmission;
MCNUM divergenceV = mccchannel_13_colimator_divergenceV;
#line 100 "/usr/share/mcstas/2.7/optics/Collimator_linear.comp"
{
  double x;
  int i;

  
  for(x = xmin, i = 0; i <= 3; i++, x += (xmax - xmin)/3.0)
    multiline(5, x, (double)ymin, 0.0, x, (double)ymax, 0.0,
              x, (double)ymax, (double)length, x, (double)ymin, (double)length,
              x, (double)ymin, 0.0);
  line(xmin, ymin, 0,   xmax, ymin, 0);
  line(xmin, ymax, 0,   xmax, ymax, 0);
  line(xmin, ymin, length, xmax, ymin, length);
  line(xmin, ymax, length, xmax, ymax, length);
}
#line 482278 "MACS_sample_kidney_box.c"
}   /* End of channel_13_colimator=Collimator_linear() SETTING parameter declarations. */
#undef slopeV
#undef slope
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

  /* MCDISPLAY code for component 'channel_14_colimator'. */
  SIG_MESSAGE("channel_14_colimator (McDisplay)");
  printf("MCDISPLAY: component %s\n", "channel_14_colimator");
#define mccompcurname  channel_14_colimator
#define mccompcurtype  Collimator_linear
#define mccompcurindex 104
#define slope mccchannel_14_colimator_slope
#define slopeV mccchannel_14_colimator_slopeV
{   /* Declarations of channel_14_colimator=Collimator_linear() SETTING parameters. */
MCNUM xmin = mccchannel_14_colimator_xmin;
MCNUM xmax = mccchannel_14_colimator_xmax;
MCNUM ymin = mccchannel_14_colimator_ymin;
MCNUM ymax = mccchannel_14_colimator_ymax;
MCNUM xwidth = mccchannel_14_colimator_xwidth;
MCNUM yheight = mccchannel_14_colimator_yheight;
MCNUM length = mccchannel_14_colimator_length;
MCNUM divergence = mccchannel_14_colimator_divergence;
MCNUM transmission = mccchannel_14_colimator_transmission;
MCNUM divergenceV = mccchannel_14_colimator_divergenceV;
#line 100 "/usr/share/mcstas/2.7/optics/Collimator_linear.comp"
{
  double x;
  int i;

  
  for(x = xmin, i = 0; i <= 3; i++, x += (xmax - xmin)/3.0)
    multiline(5, x, (double)ymin, 0.0, x, (double)ymax, 0.0,
              x, (double)ymax, (double)length, x, (double)ymin, (double)length,
              x, (double)ymin, 0.0);
  line(xmin, ymin, 0,   xmax, ymin, 0);
  line(xmin, ymax, 0,   xmax, ymax, 0);
  line(xmin, ymin, length, xmax, ymin, length);
  line(xmin, ymax, length, xmax, ymax, length);
}
#line 482320 "MACS_sample_kidney_box.c"
}   /* End of channel_14_colimator=Collimator_linear() SETTING parameter declarations. */
#undef slopeV
#undef slope
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

  /* MCDISPLAY code for component 'channel_15_colimator'. */
  SIG_MESSAGE("channel_15_colimator (McDisplay)");
  printf("MCDISPLAY: component %s\n", "channel_15_colimator");
#define mccompcurname  channel_15_colimator
#define mccompcurtype  Collimator_linear
#define mccompcurindex 105
#define slope mccchannel_15_colimator_slope
#define slopeV mccchannel_15_colimator_slopeV
{   /* Declarations of channel_15_colimator=Collimator_linear() SETTING parameters. */
MCNUM xmin = mccchannel_15_colimator_xmin;
MCNUM xmax = mccchannel_15_colimator_xmax;
MCNUM ymin = mccchannel_15_colimator_ymin;
MCNUM ymax = mccchannel_15_colimator_ymax;
MCNUM xwidth = mccchannel_15_colimator_xwidth;
MCNUM yheight = mccchannel_15_colimator_yheight;
MCNUM length = mccchannel_15_colimator_length;
MCNUM divergence = mccchannel_15_colimator_divergence;
MCNUM transmission = mccchannel_15_colimator_transmission;
MCNUM divergenceV = mccchannel_15_colimator_divergenceV;
#line 100 "/usr/share/mcstas/2.7/optics/Collimator_linear.comp"
{
  double x;
  int i;

  
  for(x = xmin, i = 0; i <= 3; i++, x += (xmax - xmin)/3.0)
    multiline(5, x, (double)ymin, 0.0, x, (double)ymax, 0.0,
              x, (double)ymax, (double)length, x, (double)ymin, (double)length,
              x, (double)ymin, 0.0);
  line(xmin, ymin, 0,   xmax, ymin, 0);
  line(xmin, ymax, 0,   xmax, ymax, 0);
  line(xmin, ymin, length, xmax, ymin, length);
  line(xmin, ymax, length, xmax, ymax, length);
}
#line 482362 "MACS_sample_kidney_box.c"
}   /* End of channel_15_colimator=Collimator_linear() SETTING parameter declarations. */
#undef slopeV
#undef slope
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

  /* MCDISPLAY code for component 'channel_16_colimator'. */
  SIG_MESSAGE("channel_16_colimator (McDisplay)");
  printf("MCDISPLAY: component %s\n", "channel_16_colimator");
#define mccompcurname  channel_16_colimator
#define mccompcurtype  Collimator_linear
#define mccompcurindex 106
#define slope mccchannel_16_colimator_slope
#define slopeV mccchannel_16_colimator_slopeV
{   /* Declarations of channel_16_colimator=Collimator_linear() SETTING parameters. */
MCNUM xmin = mccchannel_16_colimator_xmin;
MCNUM xmax = mccchannel_16_colimator_xmax;
MCNUM ymin = mccchannel_16_colimator_ymin;
MCNUM ymax = mccchannel_16_colimator_ymax;
MCNUM xwidth = mccchannel_16_colimator_xwidth;
MCNUM yheight = mccchannel_16_colimator_yheight;
MCNUM length = mccchannel_16_colimator_length;
MCNUM divergence = mccchannel_16_colimator_divergence;
MCNUM transmission = mccchannel_16_colimator_transmission;
MCNUM divergenceV = mccchannel_16_colimator_divergenceV;
#line 100 "/usr/share/mcstas/2.7/optics/Collimator_linear.comp"
{
  double x;
  int i;

  
  for(x = xmin, i = 0; i <= 3; i++, x += (xmax - xmin)/3.0)
    multiline(5, x, (double)ymin, 0.0, x, (double)ymax, 0.0,
              x, (double)ymax, (double)length, x, (double)ymin, (double)length,
              x, (double)ymin, 0.0);
  line(xmin, ymin, 0,   xmax, ymin, 0);
  line(xmin, ymax, 0,   xmax, ymax, 0);
  line(xmin, ymin, length, xmax, ymin, length);
  line(xmin, ymax, length, xmax, ymax, length);
}
#line 482404 "MACS_sample_kidney_box.c"
}   /* End of channel_16_colimator=Collimator_linear() SETTING parameter declarations. */
#undef slopeV
#undef slope
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

  /* MCDISPLAY code for component 'channel_17_colimator'. */
  SIG_MESSAGE("channel_17_colimator (McDisplay)");
  printf("MCDISPLAY: component %s\n", "channel_17_colimator");
#define mccompcurname  channel_17_colimator
#define mccompcurtype  Collimator_linear
#define mccompcurindex 107
#define slope mccchannel_17_colimator_slope
#define slopeV mccchannel_17_colimator_slopeV
{   /* Declarations of channel_17_colimator=Collimator_linear() SETTING parameters. */
MCNUM xmin = mccchannel_17_colimator_xmin;
MCNUM xmax = mccchannel_17_colimator_xmax;
MCNUM ymin = mccchannel_17_colimator_ymin;
MCNUM ymax = mccchannel_17_colimator_ymax;
MCNUM xwidth = mccchannel_17_colimator_xwidth;
MCNUM yheight = mccchannel_17_colimator_yheight;
MCNUM length = mccchannel_17_colimator_length;
MCNUM divergence = mccchannel_17_colimator_divergence;
MCNUM transmission = mccchannel_17_colimator_transmission;
MCNUM divergenceV = mccchannel_17_colimator_divergenceV;
#line 100 "/usr/share/mcstas/2.7/optics/Collimator_linear.comp"
{
  double x;
  int i;

  
  for(x = xmin, i = 0; i <= 3; i++, x += (xmax - xmin)/3.0)
    multiline(5, x, (double)ymin, 0.0, x, (double)ymax, 0.0,
              x, (double)ymax, (double)length, x, (double)ymin, (double)length,
              x, (double)ymin, 0.0);
  line(xmin, ymin, 0,   xmax, ymin, 0);
  line(xmin, ymax, 0,   xmax, ymax, 0);
  line(xmin, ymin, length, xmax, ymin, length);
  line(xmin, ymax, length, xmax, ymax, length);
}
#line 482446 "MACS_sample_kidney_box.c"
}   /* End of channel_17_colimator=Collimator_linear() SETTING parameter declarations. */
#undef slopeV
#undef slope
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

  /* MCDISPLAY code for component 'channel_18_colimator'. */
  SIG_MESSAGE("channel_18_colimator (McDisplay)");
  printf("MCDISPLAY: component %s\n", "channel_18_colimator");
#define mccompcurname  channel_18_colimator
#define mccompcurtype  Collimator_linear
#define mccompcurindex 108
#define slope mccchannel_18_colimator_slope
#define slopeV mccchannel_18_colimator_slopeV
{   /* Declarations of channel_18_colimator=Collimator_linear() SETTING parameters. */
MCNUM xmin = mccchannel_18_colimator_xmin;
MCNUM xmax = mccchannel_18_colimator_xmax;
MCNUM ymin = mccchannel_18_colimator_ymin;
MCNUM ymax = mccchannel_18_colimator_ymax;
MCNUM xwidth = mccchannel_18_colimator_xwidth;
MCNUM yheight = mccchannel_18_colimator_yheight;
MCNUM length = mccchannel_18_colimator_length;
MCNUM divergence = mccchannel_18_colimator_divergence;
MCNUM transmission = mccchannel_18_colimator_transmission;
MCNUM divergenceV = mccchannel_18_colimator_divergenceV;
#line 100 "/usr/share/mcstas/2.7/optics/Collimator_linear.comp"
{
  double x;
  int i;

  
  for(x = xmin, i = 0; i <= 3; i++, x += (xmax - xmin)/3.0)
    multiline(5, x, (double)ymin, 0.0, x, (double)ymax, 0.0,
              x, (double)ymax, (double)length, x, (double)ymin, (double)length,
              x, (double)ymin, 0.0);
  line(xmin, ymin, 0,   xmax, ymin, 0);
  line(xmin, ymax, 0,   xmax, ymax, 0);
  line(xmin, ymin, length, xmax, ymin, length);
  line(xmin, ymax, length, xmax, ymax, length);
}
#line 482488 "MACS_sample_kidney_box.c"
}   /* End of channel_18_colimator=Collimator_linear() SETTING parameter declarations. */
#undef slopeV
#undef slope
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

  /* MCDISPLAY code for component 'channel_19_colimator'. */
  SIG_MESSAGE("channel_19_colimator (McDisplay)");
  printf("MCDISPLAY: component %s\n", "channel_19_colimator");
#define mccompcurname  channel_19_colimator
#define mccompcurtype  Collimator_linear
#define mccompcurindex 109
#define slope mccchannel_19_colimator_slope
#define slopeV mccchannel_19_colimator_slopeV
{   /* Declarations of channel_19_colimator=Collimator_linear() SETTING parameters. */
MCNUM xmin = mccchannel_19_colimator_xmin;
MCNUM xmax = mccchannel_19_colimator_xmax;
MCNUM ymin = mccchannel_19_colimator_ymin;
MCNUM ymax = mccchannel_19_colimator_ymax;
MCNUM xwidth = mccchannel_19_colimator_xwidth;
MCNUM yheight = mccchannel_19_colimator_yheight;
MCNUM length = mccchannel_19_colimator_length;
MCNUM divergence = mccchannel_19_colimator_divergence;
MCNUM transmission = mccchannel_19_colimator_transmission;
MCNUM divergenceV = mccchannel_19_colimator_divergenceV;
#line 100 "/usr/share/mcstas/2.7/optics/Collimator_linear.comp"
{
  double x;
  int i;

  
  for(x = xmin, i = 0; i <= 3; i++, x += (xmax - xmin)/3.0)
    multiline(5, x, (double)ymin, 0.0, x, (double)ymax, 0.0,
              x, (double)ymax, (double)length, x, (double)ymin, (double)length,
              x, (double)ymin, 0.0);
  line(xmin, ymin, 0,   xmax, ymin, 0);
  line(xmin, ymax, 0,   xmax, ymax, 0);
  line(xmin, ymin, length, xmax, ymin, length);
  line(xmin, ymax, length, xmax, ymax, length);
}
#line 482530 "MACS_sample_kidney_box.c"
}   /* End of channel_19_colimator=Collimator_linear() SETTING parameter declarations. */
#undef slopeV
#undef slope
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

  /* MCDISPLAY code for component 'kidney_hull_box_cut_arm1'. */
  SIG_MESSAGE("kidney_hull_box_cut_arm1 (McDisplay)");
  printf("MCDISPLAY: component %s\n", "kidney_hull_box_cut_arm1");
#define mccompcurname  kidney_hull_box_cut_arm1
#define mccompcurtype  Arm
#define mccompcurindex 120
#line 40 "/usr/share/mcstas/2.7/optics/Arm.comp"
{
  /* A bit ugly; hard-coded dimensions. */
  
  line(0,0,0,0.2,0,0);
  line(0,0,0,0,0.2,0);
  line(0,0,0,0,0,0.2);
}
#line 482552 "MACS_sample_kidney_box.c"
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

  /* MCDISPLAY code for component 'kidney_hull_box_cut_arm2'. */
  SIG_MESSAGE("kidney_hull_box_cut_arm2 (McDisplay)");
  printf("MCDISPLAY: component %s\n", "kidney_hull_box_cut_arm2");
#define mccompcurname  kidney_hull_box_cut_arm2
#define mccompcurtype  Arm
#define mccompcurindex 122
#line 40 "/usr/share/mcstas/2.7/optics/Arm.comp"
{
  /* A bit ugly; hard-coded dimensions. */
  
  line(0,0,0,0.2,0,0);
  line(0,0,0,0,0.2,0);
  line(0,0,0,0,0,0.2);
}
#line 482571 "MACS_sample_kidney_box.c"
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

  /* MCDISPLAY code for component 'channel_0_analyzer_1_center'. */
  SIG_MESSAGE("channel_0_analyzer_1_center (McDisplay)");
  printf("MCDISPLAY: component %s\n", "channel_0_analyzer_1_center");
#define mccompcurname  channel_0_analyzer_1_center
#define mccompcurtype  Arm
#define mccompcurindex 128
#line 40 "/usr/share/mcstas/2.7/optics/Arm.comp"
{
  /* A bit ugly; hard-coded dimensions. */
  
  line(0,0,0,0.2,0,0);
  line(0,0,0,0,0.2,0);
  line(0,0,0,0,0,0.2);
}
#line 482590 "MACS_sample_kidney_box.c"
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

  /* MCDISPLAY code for component 'channel_0_analyzer_1_rotated'. */
  SIG_MESSAGE("channel_0_analyzer_1_rotated (McDisplay)");
  printf("MCDISPLAY: component %s\n", "channel_0_analyzer_1_rotated");
#define mccompcurname  channel_0_analyzer_1_rotated
#define mccompcurtype  Arm
#define mccompcurindex 129
#line 40 "/usr/share/mcstas/2.7/optics/Arm.comp"
{
  /* A bit ugly; hard-coded dimensions. */
  
  line(0,0,0,0.2,0,0);
  line(0,0,0,0,0.2,0);
  line(0,0,0,0,0,0.2);
}
#line 482609 "MACS_sample_kidney_box.c"
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

  /* MCDISPLAY code for component 'channel_0_analyzer_2_center'. */
  SIG_MESSAGE("channel_0_analyzer_2_center (McDisplay)");
  printf("MCDISPLAY: component %s\n", "channel_0_analyzer_2_center");
#define mccompcurname  channel_0_analyzer_2_center
#define mccompcurtype  Arm
#define mccompcurindex 139
#line 40 "/usr/share/mcstas/2.7/optics/Arm.comp"
{
  /* A bit ugly; hard-coded dimensions. */
  
  line(0,0,0,0.2,0,0);
  line(0,0,0,0,0.2,0);
  line(0,0,0,0,0,0.2);
}
#line 482628 "MACS_sample_kidney_box.c"
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

  /* MCDISPLAY code for component 'channel_0_analyzer_2_rotated'. */
  SIG_MESSAGE("channel_0_analyzer_2_rotated (McDisplay)");
  printf("MCDISPLAY: component %s\n", "channel_0_analyzer_2_rotated");
#define mccompcurname  channel_0_analyzer_2_rotated
#define mccompcurtype  Arm
#define mccompcurindex 140
#line 40 "/usr/share/mcstas/2.7/optics/Arm.comp"
{
  /* A bit ugly; hard-coded dimensions. */
  
  line(0,0,0,0.2,0,0);
  line(0,0,0,0,0.2,0);
  line(0,0,0,0,0,0.2);
}
#line 482647 "MACS_sample_kidney_box.c"
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

  /* MCDISPLAY code for component 'inter_analyzer_colimator_center_0'. */
  SIG_MESSAGE("inter_analyzer_colimator_center_0 (McDisplay)");
  printf("MCDISPLAY: component %s\n", "inter_analyzer_colimator_center_0");
#define mccompcurname  inter_analyzer_colimator_center_0
#define mccompcurtype  Arm
#define mccompcurindex 154
#line 40 "/usr/share/mcstas/2.7/optics/Arm.comp"
{
  /* A bit ugly; hard-coded dimensions. */
  
  line(0,0,0,0.2,0,0);
  line(0,0,0,0,0.2,0);
  line(0,0,0,0,0,0.2);
}
#line 482666 "MACS_sample_kidney_box.c"
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

  /* MCDISPLAY code for component 'channel_1_analyzer_1_center'. */
  SIG_MESSAGE("channel_1_analyzer_1_center (McDisplay)");
  printf("MCDISPLAY: component %s\n", "channel_1_analyzer_1_center");
#define mccompcurname  channel_1_analyzer_1_center
#define mccompcurtype  Arm
#define mccompcurindex 166
#line 40 "/usr/share/mcstas/2.7/optics/Arm.comp"
{
  /* A bit ugly; hard-coded dimensions. */
  
  line(0,0,0,0.2,0,0);
  line(0,0,0,0,0.2,0);
  line(0,0,0,0,0,0.2);
}
#line 482685 "MACS_sample_kidney_box.c"
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

  /* MCDISPLAY code for component 'channel_1_analyzer_1_rotated'. */
  SIG_MESSAGE("channel_1_analyzer_1_rotated (McDisplay)");
  printf("MCDISPLAY: component %s\n", "channel_1_analyzer_1_rotated");
#define mccompcurname  channel_1_analyzer_1_rotated
#define mccompcurtype  Arm
#define mccompcurindex 167
#line 40 "/usr/share/mcstas/2.7/optics/Arm.comp"
{
  /* A bit ugly; hard-coded dimensions. */
  
  line(0,0,0,0.2,0,0);
  line(0,0,0,0,0.2,0);
  line(0,0,0,0,0,0.2);
}
#line 482704 "MACS_sample_kidney_box.c"
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

  /* MCDISPLAY code for component 'channel_1_analyzer_2_center'. */
  SIG_MESSAGE("channel_1_analyzer_2_center (McDisplay)");
  printf("MCDISPLAY: component %s\n", "channel_1_analyzer_2_center");
#define mccompcurname  channel_1_analyzer_2_center
#define mccompcurtype  Arm
#define mccompcurindex 177
#line 40 "/usr/share/mcstas/2.7/optics/Arm.comp"
{
  /* A bit ugly; hard-coded dimensions. */
  
  line(0,0,0,0.2,0,0);
  line(0,0,0,0,0.2,0);
  line(0,0,0,0,0,0.2);
}
#line 482723 "MACS_sample_kidney_box.c"
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

  /* MCDISPLAY code for component 'channel_1_analyzer_2_rotated'. */
  SIG_MESSAGE("channel_1_analyzer_2_rotated (McDisplay)");
  printf("MCDISPLAY: component %s\n", "channel_1_analyzer_2_rotated");
#define mccompcurname  channel_1_analyzer_2_rotated
#define mccompcurtype  Arm
#define mccompcurindex 178
#line 40 "/usr/share/mcstas/2.7/optics/Arm.comp"
{
  /* A bit ugly; hard-coded dimensions. */
  
  line(0,0,0,0.2,0,0);
  line(0,0,0,0,0.2,0);
  line(0,0,0,0,0,0.2);
}
#line 482742 "MACS_sample_kidney_box.c"
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

  /* MCDISPLAY code for component 'inter_analyzer_colimator_center_1'. */
  SIG_MESSAGE("inter_analyzer_colimator_center_1 (McDisplay)");
  printf("MCDISPLAY: component %s\n", "inter_analyzer_colimator_center_1");
#define mccompcurname  inter_analyzer_colimator_center_1
#define mccompcurtype  Arm
#define mccompcurindex 192
#line 40 "/usr/share/mcstas/2.7/optics/Arm.comp"
{
  /* A bit ugly; hard-coded dimensions. */
  
  line(0,0,0,0.2,0,0);
  line(0,0,0,0,0.2,0);
  line(0,0,0,0,0,0.2);
}
#line 482761 "MACS_sample_kidney_box.c"
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

  /* MCDISPLAY code for component 'channel_2_analyzer_1_center'. */
  SIG_MESSAGE("channel_2_analyzer_1_center (McDisplay)");
  printf("MCDISPLAY: component %s\n", "channel_2_analyzer_1_center");
#define mccompcurname  channel_2_analyzer_1_center
#define mccompcurtype  Arm
#define mccompcurindex 204
#line 40 "/usr/share/mcstas/2.7/optics/Arm.comp"
{
  /* A bit ugly; hard-coded dimensions. */
  
  line(0,0,0,0.2,0,0);
  line(0,0,0,0,0.2,0);
  line(0,0,0,0,0,0.2);
}
#line 482780 "MACS_sample_kidney_box.c"
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

  /* MCDISPLAY code for component 'channel_2_analyzer_1_rotated'. */
  SIG_MESSAGE("channel_2_analyzer_1_rotated (McDisplay)");
  printf("MCDISPLAY: component %s\n", "channel_2_analyzer_1_rotated");
#define mccompcurname  channel_2_analyzer_1_rotated
#define mccompcurtype  Arm
#define mccompcurindex 205
#line 40 "/usr/share/mcstas/2.7/optics/Arm.comp"
{
  /* A bit ugly; hard-coded dimensions. */
  
  line(0,0,0,0.2,0,0);
  line(0,0,0,0,0.2,0);
  line(0,0,0,0,0,0.2);
}
#line 482799 "MACS_sample_kidney_box.c"
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

  /* MCDISPLAY code for component 'channel_2_analyzer_2_center'. */
  SIG_MESSAGE("channel_2_analyzer_2_center (McDisplay)");
  printf("MCDISPLAY: component %s\n", "channel_2_analyzer_2_center");
#define mccompcurname  channel_2_analyzer_2_center
#define mccompcurtype  Arm
#define mccompcurindex 215
#line 40 "/usr/share/mcstas/2.7/optics/Arm.comp"
{
  /* A bit ugly; hard-coded dimensions. */
  
  line(0,0,0,0.2,0,0);
  line(0,0,0,0,0.2,0);
  line(0,0,0,0,0,0.2);
}
#line 482818 "MACS_sample_kidney_box.c"
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

  /* MCDISPLAY code for component 'channel_2_analyzer_2_rotated'. */
  SIG_MESSAGE("channel_2_analyzer_2_rotated (McDisplay)");
  printf("MCDISPLAY: component %s\n", "channel_2_analyzer_2_rotated");
#define mccompcurname  channel_2_analyzer_2_rotated
#define mccompcurtype  Arm
#define mccompcurindex 216
#line 40 "/usr/share/mcstas/2.7/optics/Arm.comp"
{
  /* A bit ugly; hard-coded dimensions. */
  
  line(0,0,0,0.2,0,0);
  line(0,0,0,0,0.2,0);
  line(0,0,0,0,0,0.2);
}
#line 482837 "MACS_sample_kidney_box.c"
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

  /* MCDISPLAY code for component 'inter_analyzer_colimator_center_2'. */
  SIG_MESSAGE("inter_analyzer_colimator_center_2 (McDisplay)");
  printf("MCDISPLAY: component %s\n", "inter_analyzer_colimator_center_2");
#define mccompcurname  inter_analyzer_colimator_center_2
#define mccompcurtype  Arm
#define mccompcurindex 230
#line 40 "/usr/share/mcstas/2.7/optics/Arm.comp"
{
  /* A bit ugly; hard-coded dimensions. */
  
  line(0,0,0,0.2,0,0);
  line(0,0,0,0,0.2,0);
  line(0,0,0,0,0,0.2);
}
#line 482856 "MACS_sample_kidney_box.c"
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

  /* MCDISPLAY code for component 'channel_3_analyzer_1_center'. */
  SIG_MESSAGE("channel_3_analyzer_1_center (McDisplay)");
  printf("MCDISPLAY: component %s\n", "channel_3_analyzer_1_center");
#define mccompcurname  channel_3_analyzer_1_center
#define mccompcurtype  Arm
#define mccompcurindex 242
#line 40 "/usr/share/mcstas/2.7/optics/Arm.comp"
{
  /* A bit ugly; hard-coded dimensions. */
  
  line(0,0,0,0.2,0,0);
  line(0,0,0,0,0.2,0);
  line(0,0,0,0,0,0.2);
}
#line 482875 "MACS_sample_kidney_box.c"
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

  /* MCDISPLAY code for component 'channel_3_analyzer_1_rotated'. */
  SIG_MESSAGE("channel_3_analyzer_1_rotated (McDisplay)");
  printf("MCDISPLAY: component %s\n", "channel_3_analyzer_1_rotated");
#define mccompcurname  channel_3_analyzer_1_rotated
#define mccompcurtype  Arm
#define mccompcurindex 243
#line 40 "/usr/share/mcstas/2.7/optics/Arm.comp"
{
  /* A bit ugly; hard-coded dimensions. */
  
  line(0,0,0,0.2,0,0);
  line(0,0,0,0,0.2,0);
  line(0,0,0,0,0,0.2);
}
#line 482894 "MACS_sample_kidney_box.c"
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

  /* MCDISPLAY code for component 'channel_3_analyzer_2_center'. */
  SIG_MESSAGE("channel_3_analyzer_2_center (McDisplay)");
  printf("MCDISPLAY: component %s\n", "channel_3_analyzer_2_center");
#define mccompcurname  channel_3_analyzer_2_center
#define mccompcurtype  Arm
#define mccompcurindex 253
#line 40 "/usr/share/mcstas/2.7/optics/Arm.comp"
{
  /* A bit ugly; hard-coded dimensions. */
  
  line(0,0,0,0.2,0,0);
  line(0,0,0,0,0.2,0);
  line(0,0,0,0,0,0.2);
}
#line 482913 "MACS_sample_kidney_box.c"
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

  /* MCDISPLAY code for component 'channel_3_analyzer_2_rotated'. */
  SIG_MESSAGE("channel_3_analyzer_2_rotated (McDisplay)");
  printf("MCDISPLAY: component %s\n", "channel_3_analyzer_2_rotated");
#define mccompcurname  channel_3_analyzer_2_rotated
#define mccompcurtype  Arm
#define mccompcurindex 254
#line 40 "/usr/share/mcstas/2.7/optics/Arm.comp"
{
  /* A bit ugly; hard-coded dimensions. */
  
  line(0,0,0,0.2,0,0);
  line(0,0,0,0,0.2,0);
  line(0,0,0,0,0,0.2);
}
#line 482932 "MACS_sample_kidney_box.c"
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

  /* MCDISPLAY code for component 'inter_analyzer_colimator_center_3'. */
  SIG_MESSAGE("inter_analyzer_colimator_center_3 (McDisplay)");
  printf("MCDISPLAY: component %s\n", "inter_analyzer_colimator_center_3");
#define mccompcurname  inter_analyzer_colimator_center_3
#define mccompcurtype  Arm
#define mccompcurindex 268
#line 40 "/usr/share/mcstas/2.7/optics/Arm.comp"
{
  /* A bit ugly; hard-coded dimensions. */
  
  line(0,0,0,0.2,0,0);
  line(0,0,0,0,0.2,0);
  line(0,0,0,0,0,0.2);
}
#line 482951 "MACS_sample_kidney_box.c"
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

  /* MCDISPLAY code for component 'channel_4_analyzer_1_center'. */
  SIG_MESSAGE("channel_4_analyzer_1_center (McDisplay)");
  printf("MCDISPLAY: component %s\n", "channel_4_analyzer_1_center");
#define mccompcurname  channel_4_analyzer_1_center
#define mccompcurtype  Arm
#define mccompcurindex 280
#line 40 "/usr/share/mcstas/2.7/optics/Arm.comp"
{
  /* A bit ugly; hard-coded dimensions. */
  
  line(0,0,0,0.2,0,0);
  line(0,0,0,0,0.2,0);
  line(0,0,0,0,0,0.2);
}
#line 482970 "MACS_sample_kidney_box.c"
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

  /* MCDISPLAY code for component 'channel_4_analyzer_1_rotated'. */
  SIG_MESSAGE("channel_4_analyzer_1_rotated (McDisplay)");
  printf("MCDISPLAY: component %s\n", "channel_4_analyzer_1_rotated");
#define mccompcurname  channel_4_analyzer_1_rotated
#define mccompcurtype  Arm
#define mccompcurindex 281
#line 40 "/usr/share/mcstas/2.7/optics/Arm.comp"
{
  /* A bit ugly; hard-coded dimensions. */
  
  line(0,0,0,0.2,0,0);
  line(0,0,0,0,0.2,0);
  line(0,0,0,0,0,0.2);
}
#line 482989 "MACS_sample_kidney_box.c"
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

  /* MCDISPLAY code for component 'channel_4_analyzer_2_center'. */
  SIG_MESSAGE("channel_4_analyzer_2_center (McDisplay)");
  printf("MCDISPLAY: component %s\n", "channel_4_analyzer_2_center");
#define mccompcurname  channel_4_analyzer_2_center
#define mccompcurtype  Arm
#define mccompcurindex 291
#line 40 "/usr/share/mcstas/2.7/optics/Arm.comp"
{
  /* A bit ugly; hard-coded dimensions. */
  
  line(0,0,0,0.2,0,0);
  line(0,0,0,0,0.2,0);
  line(0,0,0,0,0,0.2);
}
#line 483008 "MACS_sample_kidney_box.c"
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

  /* MCDISPLAY code for component 'channel_4_analyzer_2_rotated'. */
  SIG_MESSAGE("channel_4_analyzer_2_rotated (McDisplay)");
  printf("MCDISPLAY: component %s\n", "channel_4_analyzer_2_rotated");
#define mccompcurname  channel_4_analyzer_2_rotated
#define mccompcurtype  Arm
#define mccompcurindex 292
#line 40 "/usr/share/mcstas/2.7/optics/Arm.comp"
{
  /* A bit ugly; hard-coded dimensions. */
  
  line(0,0,0,0.2,0,0);
  line(0,0,0,0,0.2,0);
  line(0,0,0,0,0,0.2);
}
#line 483027 "MACS_sample_kidney_box.c"
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

  /* MCDISPLAY code for component 'inter_analyzer_colimator_center_4'. */
  SIG_MESSAGE("inter_analyzer_colimator_center_4 (McDisplay)");
  printf("MCDISPLAY: component %s\n", "inter_analyzer_colimator_center_4");
#define mccompcurname  inter_analyzer_colimator_center_4
#define mccompcurtype  Arm
#define mccompcurindex 306
#line 40 "/usr/share/mcstas/2.7/optics/Arm.comp"
{
  /* A bit ugly; hard-coded dimensions. */
  
  line(0,0,0,0.2,0,0);
  line(0,0,0,0,0.2,0);
  line(0,0,0,0,0,0.2);
}
#line 483046 "MACS_sample_kidney_box.c"
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

  /* MCDISPLAY code for component 'channel_5_analyzer_1_center'. */
  SIG_MESSAGE("channel_5_analyzer_1_center (McDisplay)");
  printf("MCDISPLAY: component %s\n", "channel_5_analyzer_1_center");
#define mccompcurname  channel_5_analyzer_1_center
#define mccompcurtype  Arm
#define mccompcurindex 318
#line 40 "/usr/share/mcstas/2.7/optics/Arm.comp"
{
  /* A bit ugly; hard-coded dimensions. */
  
  line(0,0,0,0.2,0,0);
  line(0,0,0,0,0.2,0);
  line(0,0,0,0,0,0.2);
}
#line 483065 "MACS_sample_kidney_box.c"
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

  /* MCDISPLAY code for component 'channel_5_analyzer_1_rotated'. */
  SIG_MESSAGE("channel_5_analyzer_1_rotated (McDisplay)");
  printf("MCDISPLAY: component %s\n", "channel_5_analyzer_1_rotated");
#define mccompcurname  channel_5_analyzer_1_rotated
#define mccompcurtype  Arm
#define mccompcurindex 319
#line 40 "/usr/share/mcstas/2.7/optics/Arm.comp"
{
  /* A bit ugly; hard-coded dimensions. */
  
  line(0,0,0,0.2,0,0);
  line(0,0,0,0,0.2,0);
  line(0,0,0,0,0,0.2);
}
#line 483084 "MACS_sample_kidney_box.c"
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

  /* MCDISPLAY code for component 'channel_5_analyzer_2_center'. */
  SIG_MESSAGE("channel_5_analyzer_2_center (McDisplay)");
  printf("MCDISPLAY: component %s\n", "channel_5_analyzer_2_center");
#define mccompcurname  channel_5_analyzer_2_center
#define mccompcurtype  Arm
#define mccompcurindex 329
#line 40 "/usr/share/mcstas/2.7/optics/Arm.comp"
{
  /* A bit ugly; hard-coded dimensions. */
  
  line(0,0,0,0.2,0,0);
  line(0,0,0,0,0.2,0);
  line(0,0,0,0,0,0.2);
}
#line 483103 "MACS_sample_kidney_box.c"
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

  /* MCDISPLAY code for component 'channel_5_analyzer_2_rotated'. */
  SIG_MESSAGE("channel_5_analyzer_2_rotated (McDisplay)");
  printf("MCDISPLAY: component %s\n", "channel_5_analyzer_2_rotated");
#define mccompcurname  channel_5_analyzer_2_rotated
#define mccompcurtype  Arm
#define mccompcurindex 330
#line 40 "/usr/share/mcstas/2.7/optics/Arm.comp"
{
  /* A bit ugly; hard-coded dimensions. */
  
  line(0,0,0,0.2,0,0);
  line(0,0,0,0,0.2,0);
  line(0,0,0,0,0,0.2);
}
#line 483122 "MACS_sample_kidney_box.c"
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

  /* MCDISPLAY code for component 'inter_analyzer_colimator_center_5'. */
  SIG_MESSAGE("inter_analyzer_colimator_center_5 (McDisplay)");
  printf("MCDISPLAY: component %s\n", "inter_analyzer_colimator_center_5");
#define mccompcurname  inter_analyzer_colimator_center_5
#define mccompcurtype  Arm
#define mccompcurindex 344
#line 40 "/usr/share/mcstas/2.7/optics/Arm.comp"
{
  /* A bit ugly; hard-coded dimensions. */
  
  line(0,0,0,0.2,0,0);
  line(0,0,0,0,0.2,0);
  line(0,0,0,0,0,0.2);
}
#line 483141 "MACS_sample_kidney_box.c"
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

  /* MCDISPLAY code for component 'channel_6_analyzer_1_center'. */
  SIG_MESSAGE("channel_6_analyzer_1_center (McDisplay)");
  printf("MCDISPLAY: component %s\n", "channel_6_analyzer_1_center");
#define mccompcurname  channel_6_analyzer_1_center
#define mccompcurtype  Arm
#define mccompcurindex 356
#line 40 "/usr/share/mcstas/2.7/optics/Arm.comp"
{
  /* A bit ugly; hard-coded dimensions. */
  
  line(0,0,0,0.2,0,0);
  line(0,0,0,0,0.2,0);
  line(0,0,0,0,0,0.2);
}
#line 483160 "MACS_sample_kidney_box.c"
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

  /* MCDISPLAY code for component 'channel_6_analyzer_1_rotated'. */
  SIG_MESSAGE("channel_6_analyzer_1_rotated (McDisplay)");
  printf("MCDISPLAY: component %s\n", "channel_6_analyzer_1_rotated");
#define mccompcurname  channel_6_analyzer_1_rotated
#define mccompcurtype  Arm
#define mccompcurindex 357
#line 40 "/usr/share/mcstas/2.7/optics/Arm.comp"
{
  /* A bit ugly; hard-coded dimensions. */
  
  line(0,0,0,0.2,0,0);
  line(0,0,0,0,0.2,0);
  line(0,0,0,0,0,0.2);
}
#line 483179 "MACS_sample_kidney_box.c"
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

  /* MCDISPLAY code for component 'channel_6_analyzer_2_center'. */
  SIG_MESSAGE("channel_6_analyzer_2_center (McDisplay)");
  printf("MCDISPLAY: component %s\n", "channel_6_analyzer_2_center");
#define mccompcurname  channel_6_analyzer_2_center
#define mccompcurtype  Arm
#define mccompcurindex 367
#line 40 "/usr/share/mcstas/2.7/optics/Arm.comp"
{
  /* A bit ugly; hard-coded dimensions. */
  
  line(0,0,0,0.2,0,0);
  line(0,0,0,0,0.2,0);
  line(0,0,0,0,0,0.2);
}
#line 483198 "MACS_sample_kidney_box.c"
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

  /* MCDISPLAY code for component 'channel_6_analyzer_2_rotated'. */
  SIG_MESSAGE("channel_6_analyzer_2_rotated (McDisplay)");
  printf("MCDISPLAY: component %s\n", "channel_6_analyzer_2_rotated");
#define mccompcurname  channel_6_analyzer_2_rotated
#define mccompcurtype  Arm
#define mccompcurindex 368
#line 40 "/usr/share/mcstas/2.7/optics/Arm.comp"
{
  /* A bit ugly; hard-coded dimensions. */
  
  line(0,0,0,0.2,0,0);
  line(0,0,0,0,0.2,0);
  line(0,0,0,0,0,0.2);
}
#line 483217 "MACS_sample_kidney_box.c"
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

  /* MCDISPLAY code for component 'inter_analyzer_colimator_center_6'. */
  SIG_MESSAGE("inter_analyzer_colimator_center_6 (McDisplay)");
  printf("MCDISPLAY: component %s\n", "inter_analyzer_colimator_center_6");
#define mccompcurname  inter_analyzer_colimator_center_6
#define mccompcurtype  Arm
#define mccompcurindex 382
#line 40 "/usr/share/mcstas/2.7/optics/Arm.comp"
{
  /* A bit ugly; hard-coded dimensions. */
  
  line(0,0,0,0.2,0,0);
  line(0,0,0,0,0.2,0);
  line(0,0,0,0,0,0.2);
}
#line 483236 "MACS_sample_kidney_box.c"
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

  /* MCDISPLAY code for component 'channel_7_analyzer_1_center'. */
  SIG_MESSAGE("channel_7_analyzer_1_center (McDisplay)");
  printf("MCDISPLAY: component %s\n", "channel_7_analyzer_1_center");
#define mccompcurname  channel_7_analyzer_1_center
#define mccompcurtype  Arm
#define mccompcurindex 394
#line 40 "/usr/share/mcstas/2.7/optics/Arm.comp"
{
  /* A bit ugly; hard-coded dimensions. */
  
  line(0,0,0,0.2,0,0);
  line(0,0,0,0,0.2,0);
  line(0,0,0,0,0,0.2);
}
#line 483255 "MACS_sample_kidney_box.c"
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

  /* MCDISPLAY code for component 'channel_7_analyzer_1_rotated'. */
  SIG_MESSAGE("channel_7_analyzer_1_rotated (McDisplay)");
  printf("MCDISPLAY: component %s\n", "channel_7_analyzer_1_rotated");
#define mccompcurname  channel_7_analyzer_1_rotated
#define mccompcurtype  Arm
#define mccompcurindex 395
#line 40 "/usr/share/mcstas/2.7/optics/Arm.comp"
{
  /* A bit ugly; hard-coded dimensions. */
  
  line(0,0,0,0.2,0,0);
  line(0,0,0,0,0.2,0);
  line(0,0,0,0,0,0.2);
}
#line 483274 "MACS_sample_kidney_box.c"
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

  /* MCDISPLAY code for component 'channel_7_analyzer_2_center'. */
  SIG_MESSAGE("channel_7_analyzer_2_center (McDisplay)");
  printf("MCDISPLAY: component %s\n", "channel_7_analyzer_2_center");
#define mccompcurname  channel_7_analyzer_2_center
#define mccompcurtype  Arm
#define mccompcurindex 405
#line 40 "/usr/share/mcstas/2.7/optics/Arm.comp"
{
  /* A bit ugly; hard-coded dimensions. */
  
  line(0,0,0,0.2,0,0);
  line(0,0,0,0,0.2,0);
  line(0,0,0,0,0,0.2);
}
#line 483293 "MACS_sample_kidney_box.c"
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

  /* MCDISPLAY code for component 'channel_7_analyzer_2_rotated'. */
  SIG_MESSAGE("channel_7_analyzer_2_rotated (McDisplay)");
  printf("MCDISPLAY: component %s\n", "channel_7_analyzer_2_rotated");
#define mccompcurname  channel_7_analyzer_2_rotated
#define mccompcurtype  Arm
#define mccompcurindex 406
#line 40 "/usr/share/mcstas/2.7/optics/Arm.comp"
{
  /* A bit ugly; hard-coded dimensions. */
  
  line(0,0,0,0.2,0,0);
  line(0,0,0,0,0.2,0);
  line(0,0,0,0,0,0.2);
}
#line 483312 "MACS_sample_kidney_box.c"
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

  /* MCDISPLAY code for component 'inter_analyzer_colimator_center_7'. */
  SIG_MESSAGE("inter_analyzer_colimator_center_7 (McDisplay)");
  printf("MCDISPLAY: component %s\n", "inter_analyzer_colimator_center_7");
#define mccompcurname  inter_analyzer_colimator_center_7
#define mccompcurtype  Arm
#define mccompcurindex 420
#line 40 "/usr/share/mcstas/2.7/optics/Arm.comp"
{
  /* A bit ugly; hard-coded dimensions. */
  
  line(0,0,0,0.2,0,0);
  line(0,0,0,0,0.2,0);
  line(0,0,0,0,0,0.2);
}
#line 483331 "MACS_sample_kidney_box.c"
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

  /* MCDISPLAY code for component 'channel_8_analyzer_1_center'. */
  SIG_MESSAGE("channel_8_analyzer_1_center (McDisplay)");
  printf("MCDISPLAY: component %s\n", "channel_8_analyzer_1_center");
#define mccompcurname  channel_8_analyzer_1_center
#define mccompcurtype  Arm
#define mccompcurindex 432
#line 40 "/usr/share/mcstas/2.7/optics/Arm.comp"
{
  /* A bit ugly; hard-coded dimensions. */
  
  line(0,0,0,0.2,0,0);
  line(0,0,0,0,0.2,0);
  line(0,0,0,0,0,0.2);
}
#line 483350 "MACS_sample_kidney_box.c"
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

  /* MCDISPLAY code for component 'channel_8_analyzer_1_rotated'. */
  SIG_MESSAGE("channel_8_analyzer_1_rotated (McDisplay)");
  printf("MCDISPLAY: component %s\n", "channel_8_analyzer_1_rotated");
#define mccompcurname  channel_8_analyzer_1_rotated
#define mccompcurtype  Arm
#define mccompcurindex 433
#line 40 "/usr/share/mcstas/2.7/optics/Arm.comp"
{
  /* A bit ugly; hard-coded dimensions. */
  
  line(0,0,0,0.2,0,0);
  line(0,0,0,0,0.2,0);
  line(0,0,0,0,0,0.2);
}
#line 483369 "MACS_sample_kidney_box.c"
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

  /* MCDISPLAY code for component 'channel_8_analyzer_2_center'. */
  SIG_MESSAGE("channel_8_analyzer_2_center (McDisplay)");
  printf("MCDISPLAY: component %s\n", "channel_8_analyzer_2_center");
#define mccompcurname  channel_8_analyzer_2_center
#define mccompcurtype  Arm
#define mccompcurindex 443
#line 40 "/usr/share/mcstas/2.7/optics/Arm.comp"
{
  /* A bit ugly; hard-coded dimensions. */
  
  line(0,0,0,0.2,0,0);
  line(0,0,0,0,0.2,0);
  line(0,0,0,0,0,0.2);
}
#line 483388 "MACS_sample_kidney_box.c"
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

  /* MCDISPLAY code for component 'channel_8_analyzer_2_rotated'. */
  SIG_MESSAGE("channel_8_analyzer_2_rotated (McDisplay)");
  printf("MCDISPLAY: component %s\n", "channel_8_analyzer_2_rotated");
#define mccompcurname  channel_8_analyzer_2_rotated
#define mccompcurtype  Arm
#define mccompcurindex 444
#line 40 "/usr/share/mcstas/2.7/optics/Arm.comp"
{
  /* A bit ugly; hard-coded dimensions. */
  
  line(0,0,0,0.2,0,0);
  line(0,0,0,0,0.2,0);
  line(0,0,0,0,0,0.2);
}
#line 483407 "MACS_sample_kidney_box.c"
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

  /* MCDISPLAY code for component 'inter_analyzer_colimator_center_8'. */
  SIG_MESSAGE("inter_analyzer_colimator_center_8 (McDisplay)");
  printf("MCDISPLAY: component %s\n", "inter_analyzer_colimator_center_8");
#define mccompcurname  inter_analyzer_colimator_center_8
#define mccompcurtype  Arm
#define mccompcurindex 458
#line 40 "/usr/share/mcstas/2.7/optics/Arm.comp"
{
  /* A bit ugly; hard-coded dimensions. */
  
  line(0,0,0,0.2,0,0);
  line(0,0,0,0,0.2,0);
  line(0,0,0,0,0,0.2);
}
#line 483426 "MACS_sample_kidney_box.c"
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

  /* MCDISPLAY code for component 'channel_9_analyzer_1_center'. */
  SIG_MESSAGE("channel_9_analyzer_1_center (McDisplay)");
  printf("MCDISPLAY: component %s\n", "channel_9_analyzer_1_center");
#define mccompcurname  channel_9_analyzer_1_center
#define mccompcurtype  Arm
#define mccompcurindex 470
#line 40 "/usr/share/mcstas/2.7/optics/Arm.comp"
{
  /* A bit ugly; hard-coded dimensions. */
  
  line(0,0,0,0.2,0,0);
  line(0,0,0,0,0.2,0);
  line(0,0,0,0,0,0.2);
}
#line 483445 "MACS_sample_kidney_box.c"
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

  /* MCDISPLAY code for component 'channel_9_analyzer_1_rotated'. */
  SIG_MESSAGE("channel_9_analyzer_1_rotated (McDisplay)");
  printf("MCDISPLAY: component %s\n", "channel_9_analyzer_1_rotated");
#define mccompcurname  channel_9_analyzer_1_rotated
#define mccompcurtype  Arm
#define mccompcurindex 471
#line 40 "/usr/share/mcstas/2.7/optics/Arm.comp"
{
  /* A bit ugly; hard-coded dimensions. */
  
  line(0,0,0,0.2,0,0);
  line(0,0,0,0,0.2,0);
  line(0,0,0,0,0,0.2);
}
#line 483464 "MACS_sample_kidney_box.c"
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

  /* MCDISPLAY code for component 'channel_9_analyzer_2_center'. */
  SIG_MESSAGE("channel_9_analyzer_2_center (McDisplay)");
  printf("MCDISPLAY: component %s\n", "channel_9_analyzer_2_center");
#define mccompcurname  channel_9_analyzer_2_center
#define mccompcurtype  Arm
#define mccompcurindex 481
#line 40 "/usr/share/mcstas/2.7/optics/Arm.comp"
{
  /* A bit ugly; hard-coded dimensions. */
  
  line(0,0,0,0.2,0,0);
  line(0,0,0,0,0.2,0);
  line(0,0,0,0,0,0.2);
}
#line 483483 "MACS_sample_kidney_box.c"
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

  /* MCDISPLAY code for component 'channel_9_analyzer_2_rotated'. */
  SIG_MESSAGE("channel_9_analyzer_2_rotated (McDisplay)");
  printf("MCDISPLAY: component %s\n", "channel_9_analyzer_2_rotated");
#define mccompcurname  channel_9_analyzer_2_rotated
#define mccompcurtype  Arm
#define mccompcurindex 482
#line 40 "/usr/share/mcstas/2.7/optics/Arm.comp"
{
  /* A bit ugly; hard-coded dimensions. */
  
  line(0,0,0,0.2,0,0);
  line(0,0,0,0,0.2,0);
  line(0,0,0,0,0,0.2);
}
#line 483502 "MACS_sample_kidney_box.c"
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

  /* MCDISPLAY code for component 'inter_analyzer_colimator_center_9'. */
  SIG_MESSAGE("inter_analyzer_colimator_center_9 (McDisplay)");
  printf("MCDISPLAY: component %s\n", "inter_analyzer_colimator_center_9");
#define mccompcurname  inter_analyzer_colimator_center_9
#define mccompcurtype  Arm
#define mccompcurindex 496
#line 40 "/usr/share/mcstas/2.7/optics/Arm.comp"
{
  /* A bit ugly; hard-coded dimensions. */
  
  line(0,0,0,0.2,0,0);
  line(0,0,0,0,0.2,0);
  line(0,0,0,0,0,0.2);
}
#line 483521 "MACS_sample_kidney_box.c"
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

  /* MCDISPLAY code for component 'channel_10_analyzer_1_center'. */
  SIG_MESSAGE("channel_10_analyzer_1_center (McDisplay)");
  printf("MCDISPLAY: component %s\n", "channel_10_analyzer_1_center");
#define mccompcurname  channel_10_analyzer_1_center
#define mccompcurtype  Arm
#define mccompcurindex 508
#line 40 "/usr/share/mcstas/2.7/optics/Arm.comp"
{
  /* A bit ugly; hard-coded dimensions. */
  
  line(0,0,0,0.2,0,0);
  line(0,0,0,0,0.2,0);
  line(0,0,0,0,0,0.2);
}
#line 483540 "MACS_sample_kidney_box.c"
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

  /* MCDISPLAY code for component 'channel_10_analyzer_1_rotated'. */
  SIG_MESSAGE("channel_10_analyzer_1_rotated (McDisplay)");
  printf("MCDISPLAY: component %s\n", "channel_10_analyzer_1_rotated");
#define mccompcurname  channel_10_analyzer_1_rotated
#define mccompcurtype  Arm
#define mccompcurindex 509
#line 40 "/usr/share/mcstas/2.7/optics/Arm.comp"
{
  /* A bit ugly; hard-coded dimensions. */
  
  line(0,0,0,0.2,0,0);
  line(0,0,0,0,0.2,0);
  line(0,0,0,0,0,0.2);
}
#line 483559 "MACS_sample_kidney_box.c"
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

  /* MCDISPLAY code for component 'channel_10_analyzer_2_center'. */
  SIG_MESSAGE("channel_10_analyzer_2_center (McDisplay)");
  printf("MCDISPLAY: component %s\n", "channel_10_analyzer_2_center");
#define mccompcurname  channel_10_analyzer_2_center
#define mccompcurtype  Arm
#define mccompcurindex 519
#line 40 "/usr/share/mcstas/2.7/optics/Arm.comp"
{
  /* A bit ugly; hard-coded dimensions. */
  
  line(0,0,0,0.2,0,0);
  line(0,0,0,0,0.2,0);
  line(0,0,0,0,0,0.2);
}
#line 483578 "MACS_sample_kidney_box.c"
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

  /* MCDISPLAY code for component 'channel_10_analyzer_2_rotated'. */
  SIG_MESSAGE("channel_10_analyzer_2_rotated (McDisplay)");
  printf("MCDISPLAY: component %s\n", "channel_10_analyzer_2_rotated");
#define mccompcurname  channel_10_analyzer_2_rotated
#define mccompcurtype  Arm
#define mccompcurindex 520
#line 40 "/usr/share/mcstas/2.7/optics/Arm.comp"
{
  /* A bit ugly; hard-coded dimensions. */
  
  line(0,0,0,0.2,0,0);
  line(0,0,0,0,0.2,0);
  line(0,0,0,0,0,0.2);
}
#line 483597 "MACS_sample_kidney_box.c"
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

  /* MCDISPLAY code for component 'inter_analyzer_colimator_center_10'. */
  SIG_MESSAGE("inter_analyzer_colimator_center_10 (McDisplay)");
  printf("MCDISPLAY: component %s\n", "inter_analyzer_colimator_center_10");
#define mccompcurname  inter_analyzer_colimator_center_10
#define mccompcurtype  Arm
#define mccompcurindex 534
#line 40 "/usr/share/mcstas/2.7/optics/Arm.comp"
{
  /* A bit ugly; hard-coded dimensions. */
  
  line(0,0,0,0.2,0,0);
  line(0,0,0,0,0.2,0);
  line(0,0,0,0,0,0.2);
}
#line 483616 "MACS_sample_kidney_box.c"
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

  /* MCDISPLAY code for component 'channel_11_analyzer_1_center'. */
  SIG_MESSAGE("channel_11_analyzer_1_center (McDisplay)");
  printf("MCDISPLAY: component %s\n", "channel_11_analyzer_1_center");
#define mccompcurname  channel_11_analyzer_1_center
#define mccompcurtype  Arm
#define mccompcurindex 546
#line 40 "/usr/share/mcstas/2.7/optics/Arm.comp"
{
  /* A bit ugly; hard-coded dimensions. */
  
  line(0,0,0,0.2,0,0);
  line(0,0,0,0,0.2,0);
  line(0,0,0,0,0,0.2);
}
#line 483635 "MACS_sample_kidney_box.c"
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

  /* MCDISPLAY code for component 'channel_11_analyzer_1_rotated'. */
  SIG_MESSAGE("channel_11_analyzer_1_rotated (McDisplay)");
  printf("MCDISPLAY: component %s\n", "channel_11_analyzer_1_rotated");
#define mccompcurname  channel_11_analyzer_1_rotated
#define mccompcurtype  Arm
#define mccompcurindex 547
#line 40 "/usr/share/mcstas/2.7/optics/Arm.comp"
{
  /* A bit ugly; hard-coded dimensions. */
  
  line(0,0,0,0.2,0,0);
  line(0,0,0,0,0.2,0);
  line(0,0,0,0,0,0.2);
}
#line 483654 "MACS_sample_kidney_box.c"
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

  /* MCDISPLAY code for component 'channel_11_analyzer_2_center'. */
  SIG_MESSAGE("channel_11_analyzer_2_center (McDisplay)");
  printf("MCDISPLAY: component %s\n", "channel_11_analyzer_2_center");
#define mccompcurname  channel_11_analyzer_2_center
#define mccompcurtype  Arm
#define mccompcurindex 557
#line 40 "/usr/share/mcstas/2.7/optics/Arm.comp"
{
  /* A bit ugly; hard-coded dimensions. */
  
  line(0,0,0,0.2,0,0);
  line(0,0,0,0,0.2,0);
  line(0,0,0,0,0,0.2);
}
#line 483673 "MACS_sample_kidney_box.c"
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

  /* MCDISPLAY code for component 'channel_11_analyzer_2_rotated'. */
  SIG_MESSAGE("channel_11_analyzer_2_rotated (McDisplay)");
  printf("MCDISPLAY: component %s\n", "channel_11_analyzer_2_rotated");
#define mccompcurname  channel_11_analyzer_2_rotated
#define mccompcurtype  Arm
#define mccompcurindex 558
#line 40 "/usr/share/mcstas/2.7/optics/Arm.comp"
{
  /* A bit ugly; hard-coded dimensions. */
  
  line(0,0,0,0.2,0,0);
  line(0,0,0,0,0.2,0);
  line(0,0,0,0,0,0.2);
}
#line 483692 "MACS_sample_kidney_box.c"
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

  /* MCDISPLAY code for component 'inter_analyzer_colimator_center_11'. */
  SIG_MESSAGE("inter_analyzer_colimator_center_11 (McDisplay)");
  printf("MCDISPLAY: component %s\n", "inter_analyzer_colimator_center_11");
#define mccompcurname  inter_analyzer_colimator_center_11
#define mccompcurtype  Arm
#define mccompcurindex 572
#line 40 "/usr/share/mcstas/2.7/optics/Arm.comp"
{
  /* A bit ugly; hard-coded dimensions. */
  
  line(0,0,0,0.2,0,0);
  line(0,0,0,0,0.2,0);
  line(0,0,0,0,0,0.2);
}
#line 483711 "MACS_sample_kidney_box.c"
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

  /* MCDISPLAY code for component 'channel_12_analyzer_1_center'. */
  SIG_MESSAGE("channel_12_analyzer_1_center (McDisplay)");
  printf("MCDISPLAY: component %s\n", "channel_12_analyzer_1_center");
#define mccompcurname  channel_12_analyzer_1_center
#define mccompcurtype  Arm
#define mccompcurindex 584
#line 40 "/usr/share/mcstas/2.7/optics/Arm.comp"
{
  /* A bit ugly; hard-coded dimensions. */
  
  line(0,0,0,0.2,0,0);
  line(0,0,0,0,0.2,0);
  line(0,0,0,0,0,0.2);
}
#line 483730 "MACS_sample_kidney_box.c"
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

  /* MCDISPLAY code for component 'channel_12_analyzer_1_rotated'. */
  SIG_MESSAGE("channel_12_analyzer_1_rotated (McDisplay)");
  printf("MCDISPLAY: component %s\n", "channel_12_analyzer_1_rotated");
#define mccompcurname  channel_12_analyzer_1_rotated
#define mccompcurtype  Arm
#define mccompcurindex 585
#line 40 "/usr/share/mcstas/2.7/optics/Arm.comp"
{
  /* A bit ugly; hard-coded dimensions. */
  
  line(0,0,0,0.2,0,0);
  line(0,0,0,0,0.2,0);
  line(0,0,0,0,0,0.2);
}
#line 483749 "MACS_sample_kidney_box.c"
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

  /* MCDISPLAY code for component 'channel_12_analyzer_2_center'. */
  SIG_MESSAGE("channel_12_analyzer_2_center (McDisplay)");
  printf("MCDISPLAY: component %s\n", "channel_12_analyzer_2_center");
#define mccompcurname  channel_12_analyzer_2_center
#define mccompcurtype  Arm
#define mccompcurindex 595
#line 40 "/usr/share/mcstas/2.7/optics/Arm.comp"
{
  /* A bit ugly; hard-coded dimensions. */
  
  line(0,0,0,0.2,0,0);
  line(0,0,0,0,0.2,0);
  line(0,0,0,0,0,0.2);
}
#line 483768 "MACS_sample_kidney_box.c"
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

  /* MCDISPLAY code for component 'channel_12_analyzer_2_rotated'. */
  SIG_MESSAGE("channel_12_analyzer_2_rotated (McDisplay)");
  printf("MCDISPLAY: component %s\n", "channel_12_analyzer_2_rotated");
#define mccompcurname  channel_12_analyzer_2_rotated
#define mccompcurtype  Arm
#define mccompcurindex 596
#line 40 "/usr/share/mcstas/2.7/optics/Arm.comp"
{
  /* A bit ugly; hard-coded dimensions. */
  
  line(0,0,0,0.2,0,0);
  line(0,0,0,0,0.2,0);
  line(0,0,0,0,0,0.2);
}
#line 483787 "MACS_sample_kidney_box.c"
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

  /* MCDISPLAY code for component 'inter_analyzer_colimator_center_12'. */
  SIG_MESSAGE("inter_analyzer_colimator_center_12 (McDisplay)");
  printf("MCDISPLAY: component %s\n", "inter_analyzer_colimator_center_12");
#define mccompcurname  inter_analyzer_colimator_center_12
#define mccompcurtype  Arm
#define mccompcurindex 610
#line 40 "/usr/share/mcstas/2.7/optics/Arm.comp"
{
  /* A bit ugly; hard-coded dimensions. */
  
  line(0,0,0,0.2,0,0);
  line(0,0,0,0,0.2,0);
  line(0,0,0,0,0,0.2);
}
#line 483806 "MACS_sample_kidney_box.c"
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

  /* MCDISPLAY code for component 'channel_13_analyzer_1_center'. */
  SIG_MESSAGE("channel_13_analyzer_1_center (McDisplay)");
  printf("MCDISPLAY: component %s\n", "channel_13_analyzer_1_center");
#define mccompcurname  channel_13_analyzer_1_center
#define mccompcurtype  Arm
#define mccompcurindex 622
#line 40 "/usr/share/mcstas/2.7/optics/Arm.comp"
{
  /* A bit ugly; hard-coded dimensions. */
  
  line(0,0,0,0.2,0,0);
  line(0,0,0,0,0.2,0);
  line(0,0,0,0,0,0.2);
}
#line 483825 "MACS_sample_kidney_box.c"
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

  /* MCDISPLAY code for component 'channel_13_analyzer_1_rotated'. */
  SIG_MESSAGE("channel_13_analyzer_1_rotated (McDisplay)");
  printf("MCDISPLAY: component %s\n", "channel_13_analyzer_1_rotated");
#define mccompcurname  channel_13_analyzer_1_rotated
#define mccompcurtype  Arm
#define mccompcurindex 623
#line 40 "/usr/share/mcstas/2.7/optics/Arm.comp"
{
  /* A bit ugly; hard-coded dimensions. */
  
  line(0,0,0,0.2,0,0);
  line(0,0,0,0,0.2,0);
  line(0,0,0,0,0,0.2);
}
#line 483844 "MACS_sample_kidney_box.c"
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

  /* MCDISPLAY code for component 'channel_13_analyzer_2_center'. */
  SIG_MESSAGE("channel_13_analyzer_2_center (McDisplay)");
  printf("MCDISPLAY: component %s\n", "channel_13_analyzer_2_center");
#define mccompcurname  channel_13_analyzer_2_center
#define mccompcurtype  Arm
#define mccompcurindex 633
#line 40 "/usr/share/mcstas/2.7/optics/Arm.comp"
{
  /* A bit ugly; hard-coded dimensions. */
  
  line(0,0,0,0.2,0,0);
  line(0,0,0,0,0.2,0);
  line(0,0,0,0,0,0.2);
}
#line 483863 "MACS_sample_kidney_box.c"
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

  /* MCDISPLAY code for component 'channel_13_analyzer_2_rotated'. */
  SIG_MESSAGE("channel_13_analyzer_2_rotated (McDisplay)");
  printf("MCDISPLAY: component %s\n", "channel_13_analyzer_2_rotated");
#define mccompcurname  channel_13_analyzer_2_rotated
#define mccompcurtype  Arm
#define mccompcurindex 634
#line 40 "/usr/share/mcstas/2.7/optics/Arm.comp"
{
  /* A bit ugly; hard-coded dimensions. */
  
  line(0,0,0,0.2,0,0);
  line(0,0,0,0,0.2,0);
  line(0,0,0,0,0,0.2);
}
#line 483882 "MACS_sample_kidney_box.c"
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

  /* MCDISPLAY code for component 'inter_analyzer_colimator_center_13'. */
  SIG_MESSAGE("inter_analyzer_colimator_center_13 (McDisplay)");
  printf("MCDISPLAY: component %s\n", "inter_analyzer_colimator_center_13");
#define mccompcurname  inter_analyzer_colimator_center_13
#define mccompcurtype  Arm
#define mccompcurindex 648
#line 40 "/usr/share/mcstas/2.7/optics/Arm.comp"
{
  /* A bit ugly; hard-coded dimensions. */
  
  line(0,0,0,0.2,0,0);
  line(0,0,0,0,0.2,0);
  line(0,0,0,0,0,0.2);
}
#line 483901 "MACS_sample_kidney_box.c"
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

  /* MCDISPLAY code for component 'channel_14_analyzer_1_center'. */
  SIG_MESSAGE("channel_14_analyzer_1_center (McDisplay)");
  printf("MCDISPLAY: component %s\n", "channel_14_analyzer_1_center");
#define mccompcurname  channel_14_analyzer_1_center
#define mccompcurtype  Arm
#define mccompcurindex 660
#line 40 "/usr/share/mcstas/2.7/optics/Arm.comp"
{
  /* A bit ugly; hard-coded dimensions. */
  
  line(0,0,0,0.2,0,0);
  line(0,0,0,0,0.2,0);
  line(0,0,0,0,0,0.2);
}
#line 483920 "MACS_sample_kidney_box.c"
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

  /* MCDISPLAY code for component 'channel_14_analyzer_1_rotated'. */
  SIG_MESSAGE("channel_14_analyzer_1_rotated (McDisplay)");
  printf("MCDISPLAY: component %s\n", "channel_14_analyzer_1_rotated");
#define mccompcurname  channel_14_analyzer_1_rotated
#define mccompcurtype  Arm
#define mccompcurindex 661
#line 40 "/usr/share/mcstas/2.7/optics/Arm.comp"
{
  /* A bit ugly; hard-coded dimensions. */
  
  line(0,0,0,0.2,0,0);
  line(0,0,0,0,0.2,0);
  line(0,0,0,0,0,0.2);
}
#line 483939 "MACS_sample_kidney_box.c"
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

  /* MCDISPLAY code for component 'channel_14_analyzer_2_center'. */
  SIG_MESSAGE("channel_14_analyzer_2_center (McDisplay)");
  printf("MCDISPLAY: component %s\n", "channel_14_analyzer_2_center");
#define mccompcurname  channel_14_analyzer_2_center
#define mccompcurtype  Arm
#define mccompcurindex 671
#line 40 "/usr/share/mcstas/2.7/optics/Arm.comp"
{
  /* A bit ugly; hard-coded dimensions. */
  
  line(0,0,0,0.2,0,0);
  line(0,0,0,0,0.2,0);
  line(0,0,0,0,0,0.2);
}
#line 483958 "MACS_sample_kidney_box.c"
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

  /* MCDISPLAY code for component 'channel_14_analyzer_2_rotated'. */
  SIG_MESSAGE("channel_14_analyzer_2_rotated (McDisplay)");
  printf("MCDISPLAY: component %s\n", "channel_14_analyzer_2_rotated");
#define mccompcurname  channel_14_analyzer_2_rotated
#define mccompcurtype  Arm
#define mccompcurindex 672
#line 40 "/usr/share/mcstas/2.7/optics/Arm.comp"
{
  /* A bit ugly; hard-coded dimensions. */
  
  line(0,0,0,0.2,0,0);
  line(0,0,0,0,0.2,0);
  line(0,0,0,0,0,0.2);
}
#line 483977 "MACS_sample_kidney_box.c"
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

  /* MCDISPLAY code for component 'inter_analyzer_colimator_center_14'. */
  SIG_MESSAGE("inter_analyzer_colimator_center_14 (McDisplay)");
  printf("MCDISPLAY: component %s\n", "inter_analyzer_colimator_center_14");
#define mccompcurname  inter_analyzer_colimator_center_14
#define mccompcurtype  Arm
#define mccompcurindex 686
#line 40 "/usr/share/mcstas/2.7/optics/Arm.comp"
{
  /* A bit ugly; hard-coded dimensions. */
  
  line(0,0,0,0.2,0,0);
  line(0,0,0,0,0.2,0);
  line(0,0,0,0,0,0.2);
}
#line 483996 "MACS_sample_kidney_box.c"
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

  /* MCDISPLAY code for component 'channel_15_analyzer_1_center'. */
  SIG_MESSAGE("channel_15_analyzer_1_center (McDisplay)");
  printf("MCDISPLAY: component %s\n", "channel_15_analyzer_1_center");
#define mccompcurname  channel_15_analyzer_1_center
#define mccompcurtype  Arm
#define mccompcurindex 698
#line 40 "/usr/share/mcstas/2.7/optics/Arm.comp"
{
  /* A bit ugly; hard-coded dimensions. */
  
  line(0,0,0,0.2,0,0);
  line(0,0,0,0,0.2,0);
  line(0,0,0,0,0,0.2);
}
#line 484015 "MACS_sample_kidney_box.c"
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

  /* MCDISPLAY code for component 'channel_15_analyzer_1_rotated'. */
  SIG_MESSAGE("channel_15_analyzer_1_rotated (McDisplay)");
  printf("MCDISPLAY: component %s\n", "channel_15_analyzer_1_rotated");
#define mccompcurname  channel_15_analyzer_1_rotated
#define mccompcurtype  Arm
#define mccompcurindex 699
#line 40 "/usr/share/mcstas/2.7/optics/Arm.comp"
{
  /* A bit ugly; hard-coded dimensions. */
  
  line(0,0,0,0.2,0,0);
  line(0,0,0,0,0.2,0);
  line(0,0,0,0,0,0.2);
}
#line 484034 "MACS_sample_kidney_box.c"
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

  /* MCDISPLAY code for component 'channel_15_analyzer_2_center'. */
  SIG_MESSAGE("channel_15_analyzer_2_center (McDisplay)");
  printf("MCDISPLAY: component %s\n", "channel_15_analyzer_2_center");
#define mccompcurname  channel_15_analyzer_2_center
#define mccompcurtype  Arm
#define mccompcurindex 709
#line 40 "/usr/share/mcstas/2.7/optics/Arm.comp"
{
  /* A bit ugly; hard-coded dimensions. */
  
  line(0,0,0,0.2,0,0);
  line(0,0,0,0,0.2,0);
  line(0,0,0,0,0,0.2);
}
#line 484053 "MACS_sample_kidney_box.c"
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

  /* MCDISPLAY code for component 'channel_15_analyzer_2_rotated'. */
  SIG_MESSAGE("channel_15_analyzer_2_rotated (McDisplay)");
  printf("MCDISPLAY: component %s\n", "channel_15_analyzer_2_rotated");
#define mccompcurname  channel_15_analyzer_2_rotated
#define mccompcurtype  Arm
#define mccompcurindex 710
#line 40 "/usr/share/mcstas/2.7/optics/Arm.comp"
{
  /* A bit ugly; hard-coded dimensions. */
  
  line(0,0,0,0.2,0,0);
  line(0,0,0,0,0.2,0);
  line(0,0,0,0,0,0.2);
}
#line 484072 "MACS_sample_kidney_box.c"
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

  /* MCDISPLAY code for component 'inter_analyzer_colimator_center_15'. */
  SIG_MESSAGE("inter_analyzer_colimator_center_15 (McDisplay)");
  printf("MCDISPLAY: component %s\n", "inter_analyzer_colimator_center_15");
#define mccompcurname  inter_analyzer_colimator_center_15
#define mccompcurtype  Arm
#define mccompcurindex 724
#line 40 "/usr/share/mcstas/2.7/optics/Arm.comp"
{
  /* A bit ugly; hard-coded dimensions. */
  
  line(0,0,0,0.2,0,0);
  line(0,0,0,0,0.2,0);
  line(0,0,0,0,0,0.2);
}
#line 484091 "MACS_sample_kidney_box.c"
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

  /* MCDISPLAY code for component 'channel_16_analyzer_1_center'. */
  SIG_MESSAGE("channel_16_analyzer_1_center (McDisplay)");
  printf("MCDISPLAY: component %s\n", "channel_16_analyzer_1_center");
#define mccompcurname  channel_16_analyzer_1_center
#define mccompcurtype  Arm
#define mccompcurindex 736
#line 40 "/usr/share/mcstas/2.7/optics/Arm.comp"
{
  /* A bit ugly; hard-coded dimensions. */
  
  line(0,0,0,0.2,0,0);
  line(0,0,0,0,0.2,0);
  line(0,0,0,0,0,0.2);
}
#line 484110 "MACS_sample_kidney_box.c"
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

  /* MCDISPLAY code for component 'channel_16_analyzer_1_rotated'. */
  SIG_MESSAGE("channel_16_analyzer_1_rotated (McDisplay)");
  printf("MCDISPLAY: component %s\n", "channel_16_analyzer_1_rotated");
#define mccompcurname  channel_16_analyzer_1_rotated
#define mccompcurtype  Arm
#define mccompcurindex 737
#line 40 "/usr/share/mcstas/2.7/optics/Arm.comp"
{
  /* A bit ugly; hard-coded dimensions. */
  
  line(0,0,0,0.2,0,0);
  line(0,0,0,0,0.2,0);
  line(0,0,0,0,0,0.2);
}
#line 484129 "MACS_sample_kidney_box.c"
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

  /* MCDISPLAY code for component 'channel_16_analyzer_2_center'. */
  SIG_MESSAGE("channel_16_analyzer_2_center (McDisplay)");
  printf("MCDISPLAY: component %s\n", "channel_16_analyzer_2_center");
#define mccompcurname  channel_16_analyzer_2_center
#define mccompcurtype  Arm
#define mccompcurindex 747
#line 40 "/usr/share/mcstas/2.7/optics/Arm.comp"
{
  /* A bit ugly; hard-coded dimensions. */
  
  line(0,0,0,0.2,0,0);
  line(0,0,0,0,0.2,0);
  line(0,0,0,0,0,0.2);
}
#line 484148 "MACS_sample_kidney_box.c"
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

  /* MCDISPLAY code for component 'channel_16_analyzer_2_rotated'. */
  SIG_MESSAGE("channel_16_analyzer_2_rotated (McDisplay)");
  printf("MCDISPLAY: component %s\n", "channel_16_analyzer_2_rotated");
#define mccompcurname  channel_16_analyzer_2_rotated
#define mccompcurtype  Arm
#define mccompcurindex 748
#line 40 "/usr/share/mcstas/2.7/optics/Arm.comp"
{
  /* A bit ugly; hard-coded dimensions. */
  
  line(0,0,0,0.2,0,0);
  line(0,0,0,0,0.2,0);
  line(0,0,0,0,0,0.2);
}
#line 484167 "MACS_sample_kidney_box.c"
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

  /* MCDISPLAY code for component 'inter_analyzer_colimator_center_16'. */
  SIG_MESSAGE("inter_analyzer_colimator_center_16 (McDisplay)");
  printf("MCDISPLAY: component %s\n", "inter_analyzer_colimator_center_16");
#define mccompcurname  inter_analyzer_colimator_center_16
#define mccompcurtype  Arm
#define mccompcurindex 762
#line 40 "/usr/share/mcstas/2.7/optics/Arm.comp"
{
  /* A bit ugly; hard-coded dimensions. */
  
  line(0,0,0,0.2,0,0);
  line(0,0,0,0,0.2,0);
  line(0,0,0,0,0,0.2);
}
#line 484186 "MACS_sample_kidney_box.c"
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

  /* MCDISPLAY code for component 'channel_17_analyzer_1_center'. */
  SIG_MESSAGE("channel_17_analyzer_1_center (McDisplay)");
  printf("MCDISPLAY: component %s\n", "channel_17_analyzer_1_center");
#define mccompcurname  channel_17_analyzer_1_center
#define mccompcurtype  Arm
#define mccompcurindex 774
#line 40 "/usr/share/mcstas/2.7/optics/Arm.comp"
{
  /* A bit ugly; hard-coded dimensions. */
  
  line(0,0,0,0.2,0,0);
  line(0,0,0,0,0.2,0);
  line(0,0,0,0,0,0.2);
}
#line 484205 "MACS_sample_kidney_box.c"
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

  /* MCDISPLAY code for component 'channel_17_analyzer_1_rotated'. */
  SIG_MESSAGE("channel_17_analyzer_1_rotated (McDisplay)");
  printf("MCDISPLAY: component %s\n", "channel_17_analyzer_1_rotated");
#define mccompcurname  channel_17_analyzer_1_rotated
#define mccompcurtype  Arm
#define mccompcurindex 775
#line 40 "/usr/share/mcstas/2.7/optics/Arm.comp"
{
  /* A bit ugly; hard-coded dimensions. */
  
  line(0,0,0,0.2,0,0);
  line(0,0,0,0,0.2,0);
  line(0,0,0,0,0,0.2);
}
#line 484224 "MACS_sample_kidney_box.c"
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

  /* MCDISPLAY code for component 'channel_17_analyzer_2_center'. */
  SIG_MESSAGE("channel_17_analyzer_2_center (McDisplay)");
  printf("MCDISPLAY: component %s\n", "channel_17_analyzer_2_center");
#define mccompcurname  channel_17_analyzer_2_center
#define mccompcurtype  Arm
#define mccompcurindex 785
#line 40 "/usr/share/mcstas/2.7/optics/Arm.comp"
{
  /* A bit ugly; hard-coded dimensions. */
  
  line(0,0,0,0.2,0,0);
  line(0,0,0,0,0.2,0);
  line(0,0,0,0,0,0.2);
}
#line 484243 "MACS_sample_kidney_box.c"
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

  /* MCDISPLAY code for component 'channel_17_analyzer_2_rotated'. */
  SIG_MESSAGE("channel_17_analyzer_2_rotated (McDisplay)");
  printf("MCDISPLAY: component %s\n", "channel_17_analyzer_2_rotated");
#define mccompcurname  channel_17_analyzer_2_rotated
#define mccompcurtype  Arm
#define mccompcurindex 786
#line 40 "/usr/share/mcstas/2.7/optics/Arm.comp"
{
  /* A bit ugly; hard-coded dimensions. */
  
  line(0,0,0,0.2,0,0);
  line(0,0,0,0,0.2,0);
  line(0,0,0,0,0,0.2);
}
#line 484262 "MACS_sample_kidney_box.c"
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

  /* MCDISPLAY code for component 'inter_analyzer_colimator_center_17'. */
  SIG_MESSAGE("inter_analyzer_colimator_center_17 (McDisplay)");
  printf("MCDISPLAY: component %s\n", "inter_analyzer_colimator_center_17");
#define mccompcurname  inter_analyzer_colimator_center_17
#define mccompcurtype  Arm
#define mccompcurindex 800
#line 40 "/usr/share/mcstas/2.7/optics/Arm.comp"
{
  /* A bit ugly; hard-coded dimensions. */
  
  line(0,0,0,0.2,0,0);
  line(0,0,0,0,0.2,0);
  line(0,0,0,0,0,0.2);
}
#line 484281 "MACS_sample_kidney_box.c"
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

  /* MCDISPLAY code for component 'channel_18_analyzer_1_center'. */
  SIG_MESSAGE("channel_18_analyzer_1_center (McDisplay)");
  printf("MCDISPLAY: component %s\n", "channel_18_analyzer_1_center");
#define mccompcurname  channel_18_analyzer_1_center
#define mccompcurtype  Arm
#define mccompcurindex 812
#line 40 "/usr/share/mcstas/2.7/optics/Arm.comp"
{
  /* A bit ugly; hard-coded dimensions. */
  
  line(0,0,0,0.2,0,0);
  line(0,0,0,0,0.2,0);
  line(0,0,0,0,0,0.2);
}
#line 484300 "MACS_sample_kidney_box.c"
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

  /* MCDISPLAY code for component 'channel_18_analyzer_1_rotated'. */
  SIG_MESSAGE("channel_18_analyzer_1_rotated (McDisplay)");
  printf("MCDISPLAY: component %s\n", "channel_18_analyzer_1_rotated");
#define mccompcurname  channel_18_analyzer_1_rotated
#define mccompcurtype  Arm
#define mccompcurindex 813
#line 40 "/usr/share/mcstas/2.7/optics/Arm.comp"
{
  /* A bit ugly; hard-coded dimensions. */
  
  line(0,0,0,0.2,0,0);
  line(0,0,0,0,0.2,0);
  line(0,0,0,0,0,0.2);
}
#line 484319 "MACS_sample_kidney_box.c"
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

  /* MCDISPLAY code for component 'channel_18_analyzer_2_center'. */
  SIG_MESSAGE("channel_18_analyzer_2_center (McDisplay)");
  printf("MCDISPLAY: component %s\n", "channel_18_analyzer_2_center");
#define mccompcurname  channel_18_analyzer_2_center
#define mccompcurtype  Arm
#define mccompcurindex 823
#line 40 "/usr/share/mcstas/2.7/optics/Arm.comp"
{
  /* A bit ugly; hard-coded dimensions. */
  
  line(0,0,0,0.2,0,0);
  line(0,0,0,0,0.2,0);
  line(0,0,0,0,0,0.2);
}
#line 484338 "MACS_sample_kidney_box.c"
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

  /* MCDISPLAY code for component 'channel_18_analyzer_2_rotated'. */
  SIG_MESSAGE("channel_18_analyzer_2_rotated (McDisplay)");
  printf("MCDISPLAY: component %s\n", "channel_18_analyzer_2_rotated");
#define mccompcurname  channel_18_analyzer_2_rotated
#define mccompcurtype  Arm
#define mccompcurindex 824
#line 40 "/usr/share/mcstas/2.7/optics/Arm.comp"
{
  /* A bit ugly; hard-coded dimensions. */
  
  line(0,0,0,0.2,0,0);
  line(0,0,0,0,0.2,0);
  line(0,0,0,0,0,0.2);
}
#line 484357 "MACS_sample_kidney_box.c"
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

  /* MCDISPLAY code for component 'inter_analyzer_colimator_center_18'. */
  SIG_MESSAGE("inter_analyzer_colimator_center_18 (McDisplay)");
  printf("MCDISPLAY: component %s\n", "inter_analyzer_colimator_center_18");
#define mccompcurname  inter_analyzer_colimator_center_18
#define mccompcurtype  Arm
#define mccompcurindex 838
#line 40 "/usr/share/mcstas/2.7/optics/Arm.comp"
{
  /* A bit ugly; hard-coded dimensions. */
  
  line(0,0,0,0.2,0,0);
  line(0,0,0,0,0.2,0);
  line(0,0,0,0,0,0.2);
}
#line 484376 "MACS_sample_kidney_box.c"
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

  /* MCDISPLAY code for component 'channel_19_analyzer_1_center'. */
  SIG_MESSAGE("channel_19_analyzer_1_center (McDisplay)");
  printf("MCDISPLAY: component %s\n", "channel_19_analyzer_1_center");
#define mccompcurname  channel_19_analyzer_1_center
#define mccompcurtype  Arm
#define mccompcurindex 850
#line 40 "/usr/share/mcstas/2.7/optics/Arm.comp"
{
  /* A bit ugly; hard-coded dimensions. */
  
  line(0,0,0,0.2,0,0);
  line(0,0,0,0,0.2,0);
  line(0,0,0,0,0,0.2);
}
#line 484395 "MACS_sample_kidney_box.c"
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

  /* MCDISPLAY code for component 'channel_19_analyzer_1_rotated'. */
  SIG_MESSAGE("channel_19_analyzer_1_rotated (McDisplay)");
  printf("MCDISPLAY: component %s\n", "channel_19_analyzer_1_rotated");
#define mccompcurname  channel_19_analyzer_1_rotated
#define mccompcurtype  Arm
#define mccompcurindex 851
#line 40 "/usr/share/mcstas/2.7/optics/Arm.comp"
{
  /* A bit ugly; hard-coded dimensions. */
  
  line(0,0,0,0.2,0,0);
  line(0,0,0,0,0.2,0);
  line(0,0,0,0,0,0.2);
}
#line 484414 "MACS_sample_kidney_box.c"
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

  /* MCDISPLAY code for component 'channel_19_analyzer_2_center'. */
  SIG_MESSAGE("channel_19_analyzer_2_center (McDisplay)");
  printf("MCDISPLAY: component %s\n", "channel_19_analyzer_2_center");
#define mccompcurname  channel_19_analyzer_2_center
#define mccompcurtype  Arm
#define mccompcurindex 861
#line 40 "/usr/share/mcstas/2.7/optics/Arm.comp"
{
  /* A bit ugly; hard-coded dimensions. */
  
  line(0,0,0,0.2,0,0);
  line(0,0,0,0,0.2,0);
  line(0,0,0,0,0,0.2);
}
#line 484433 "MACS_sample_kidney_box.c"
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

  /* MCDISPLAY code for component 'channel_19_analyzer_2_rotated'. */
  SIG_MESSAGE("channel_19_analyzer_2_rotated (McDisplay)");
  printf("MCDISPLAY: component %s\n", "channel_19_analyzer_2_rotated");
#define mccompcurname  channel_19_analyzer_2_rotated
#define mccompcurtype  Arm
#define mccompcurindex 862
#line 40 "/usr/share/mcstas/2.7/optics/Arm.comp"
{
  /* A bit ugly; hard-coded dimensions. */
  
  line(0,0,0,0.2,0,0);
  line(0,0,0,0,0.2,0);
  line(0,0,0,0,0,0.2);
}
#line 484452 "MACS_sample_kidney_box.c"
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

  /* MCDISPLAY code for component 'inter_analyzer_colimator_center_19'. */
  SIG_MESSAGE("inter_analyzer_colimator_center_19 (McDisplay)");
  printf("MCDISPLAY: component %s\n", "inter_analyzer_colimator_center_19");
#define mccompcurname  inter_analyzer_colimator_center_19
#define mccompcurtype  Arm
#define mccompcurindex 876
#line 40 "/usr/share/mcstas/2.7/optics/Arm.comp"
{
  /* A bit ugly; hard-coded dimensions. */
  
  line(0,0,0,0.2,0,0);
  line(0,0,0,0,0.2,0);
  line(0,0,0,0,0,0.2);
}
#line 484471 "MACS_sample_kidney_box.c"
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

  /* MCDISPLAY code for component 'kidney_union_master'. */
  SIG_MESSAGE("kidney_union_master (McDisplay)");
  printf("MCDISPLAY: component %s\n", "kidney_union_master");
#define mccompcurname  kidney_union_master
#define mccompcurtype  Union_master
#define mccompcurindex 884
#define verbal mcckidney_union_master_verbal
#define list_verbal mcckidney_union_master_list_verbal
#define trace_verbal mcckidney_union_master_trace_verbal
#define finally_verbal mcckidney_union_master_finally_verbal
#define starting_volume_warning mcckidney_union_master_starting_volume_warning
#define global_master_element mcckidney_union_master_global_master_element
#define this_global_master_index mcckidney_union_master_this_global_master_index
#define previous_master_index mcckidney_union_master_previous_master_index
#define geometry_list_index mcckidney_union_master_geometry_list_index
#define intersection_time_table mcckidney_union_master_intersection_time_table
#define Volumes mcckidney_union_master_Volumes
#define Geometries mcckidney_union_master_Geometries
#define starting_lists mcckidney_union_master_starting_lists
#define r mcckidney_union_master_r
#define r_start mcckidney_union_master_r_start
#define v mcckidney_union_master_v
#define error_msg mcckidney_union_master_error_msg
#define component_error_msg mcckidney_union_master_component_error_msg
#define string_output mcckidney_union_master_string_output
#define number_of_volumes mcckidney_union_master_number_of_volumes
#define volume_index mcckidney_union_master_volume_index
#define process_index mcckidney_union_master_process_index
#define solutions mcckidney_union_master_solutions
#define max_number_of_processes mcckidney_union_master_max_number_of_processes
#define limit mcckidney_union_master_limit
#define solution mcckidney_union_master_solution
#define min_solution mcckidney_union_master_min_solution
#define min_volume mcckidney_union_master_min_volume
#define time_found mcckidney_union_master_time_found
#define intersection_time mcckidney_union_master_intersection_time
#define min_intersection_time mcckidney_union_master_min_intersection_time
#define process mcckidney_union_master_process
#define process_start mcckidney_union_master_process_start
#define my_trace mcckidney_union_master_my_trace
#define p_my_trace mcckidney_union_master_p_my_trace
#define my_trace_fraction_control mcckidney_union_master_my_trace_fraction_control
#define k mcckidney_union_master_k
#define k_new mcckidney_union_master_k_new
#define k_old mcckidney_union_master_k_old
#define v_length mcckidney_union_master_v_length
#define my_sum mcckidney_union_master_my_sum
#define my_sum_plus_abs mcckidney_union_master_my_sum_plus_abs
#define culmative_probability mcckidney_union_master_culmative_probability
#define mc_prop mcckidney_union_master_mc_prop
#define time_to_scattering mcckidney_union_master_time_to_scattering
#define length_to_scattering mcckidney_union_master_length_to_scattering
#define length_to_boundery mcckidney_union_master_length_to_boundery
#define time_to_boundery mcckidney_union_master_time_to_boundery
#define selected_process mcckidney_union_master_selected_process
#define scattering_event mcckidney_union_master_scattering_event
#define time_propagated_without_scattering mcckidney_union_master_time_propagated_without_scattering
#define a_next_volume_found mcckidney_union_master_a_next_volume_found
#define next_volume mcckidney_union_master_next_volume
#define next_volume_priority mcckidney_union_master_next_volume_priority
#define done mcckidney_union_master_done
#define current_volume mcckidney_union_master_current_volume
#define number_of_solutions mcckidney_union_master_number_of_solutions
#define number_of_solutions_static mcckidney_union_master_number_of_solutions_static
#define check mcckidney_union_master_check
#define start mcckidney_union_master_start
#define intersection_with_children mcckidney_union_master_intersection_with_children
#define geometry_output mcckidney_union_master_geometry_output
#define tree_next_volume mcckidney_union_master_tree_next_volume
#define pre_allocated1 mcckidney_union_master_pre_allocated1
#define pre_allocated2 mcckidney_union_master_pre_allocated2
#define pre_allocated3 mcckidney_union_master_pre_allocated3
#define ray_position mcckidney_union_master_ray_position
#define ray_velocity mcckidney_union_master_ray_velocity
#define ray_velocity_final mcckidney_union_master_ray_velocity_final
#define volume_0_found mcckidney_union_master_volume_0_found
#define scattered_flag mcckidney_union_master_scattered_flag
#define scattered_flag_VP mcckidney_union_master_scattered_flag_VP
#define master_transposed_rotation_matrix mcckidney_union_master_master_transposed_rotation_matrix
#define temp_rotation_matrix mcckidney_union_master_temp_rotation_matrix
#define non_rotated_position mcckidney_union_master_non_rotated_position
#define rotated_position mcckidney_union_master_rotated_position
#define enable_tagging mcckidney_union_master_enable_tagging
#define stop_tagging_ray mcckidney_union_master_stop_tagging_ray
#define stop_creating_nodes mcckidney_union_master_stop_creating_nodes
#define enable_tagging_check mcckidney_union_master_enable_tagging_check
#define master_tagging_node_list mcckidney_union_master_master_tagging_node_list
#define current_tagging_node mcckidney_union_master_current_tagging_node
#define tagging_leaf_counter mcckidney_union_master_tagging_leaf_counter
#define number_of_scattering_events mcckidney_union_master_number_of_scattering_events
#define real_transmission_probability mcckidney_union_master_real_transmission_probability
#define mc_transmission_probability mcckidney_union_master_mc_transmission_probability
#define number_of_masks mcckidney_union_master_number_of_masks
#define number_of_masked_volumes mcckidney_union_master_number_of_masked_volumes
#define need_to_run_within_which_volume mcckidney_union_master_need_to_run_within_which_volume
#define mask_index_main mcckidney_union_master_mask_index_main
#define mask_iterate mcckidney_union_master_mask_iterate
#define mask_status_list mcckidney_union_master_mask_status_list
#define current_mask_intersect_list_status mcckidney_union_master_current_mask_intersect_list_status
#define mask_volume_index_list mcckidney_union_master_mask_volume_index_list
#define geometry_component_index_list mcckidney_union_master_geometry_component_index_list
#define Volume_copies_allocated mcckidney_union_master_Volume_copies_allocated
#define p_old mcckidney_union_master_p_old
#define this_logger mcckidney_union_master_this_logger
#define conditional_status mcckidney_union_master_conditional_status
#define tagging_conditional_list mcckidney_union_master_tagging_conditional_list
#define free_tagging_conditioanl_list mcckidney_union_master_free_tagging_conditioanl_list
#define logger_conditional_extend_array mcckidney_union_master_logger_conditional_extend_array
#define tagging_conditional_extend mcckidney_union_master_tagging_conditional_extend
#define max_conditional_extend_index mcckidney_union_master_max_conditional_extend_index
#define safty_distance mcckidney_union_master_safty_distance
#define safty_distance2 mcckidney_union_master_safty_distance2
#define number_of_processes_array mcckidney_union_master_number_of_processes_array
#define temporary_focus_data mcckidney_union_master_temporary_focus_data
#define focus_data_index mcckidney_union_master_focus_data_index
{   /* Declarations of kidney_union_master=Union_master() SETTING parameters. */
MCNUM allow_inside_start = mcckidney_union_master_allow_inside_start;
MCNUM history_limit = mcckidney_union_master_history_limit;
MCNUM enable_conditionals = mcckidney_union_master_enable_conditionals;
MCNUM inherit_number_of_scattering_events = mcckidney_union_master_inherit_number_of_scattering_events;
#line 2092 "Union_master.comp"
{
  // mcdisplay is handled in the component files for each geometry and called here. The line function is only available in this section, and not through functions,
  //   so all the lines to be drawn for each volume are collected in a structure that is then drawn here.
  magnify("xyz");
  struct lines_to_draw lines_to_draw_master;
  for (volume_index = 1; volume_index < number_of_volumes; volume_index++) {
        if (Volumes[volume_index]->geometry.visualization_on == 1) {
            lines_to_draw_master.number_of_lines = 0;
            
            Volumes[volume_index]->geometry.mcdisplay_function(&lines_to_draw_master,volume_index,Geometries,number_of_volumes);
            
            for (iterate = 0;iterate<lines_to_draw_master.number_of_lines;iterate++) {
               if (lines_to_draw_master.lines[iterate].number_of_dashes == 1) {
                 line(lines_to_draw_master.lines[iterate].point1.x,lines_to_draw_master.lines[iterate].point1.y,lines_to_draw_master.lines[iterate].point1.z,lines_to_draw_master.lines[iterate].point2.x,lines_to_draw_master.lines[iterate].point2.y,lines_to_draw_master.lines[iterate].point2.z);
               }
               else {
                 dashed_line(lines_to_draw_master.lines[iterate].point1.x,lines_to_draw_master.lines[iterate].point1.y,lines_to_draw_master.lines[iterate].point1.z,lines_to_draw_master.lines[iterate].point2.x,lines_to_draw_master.lines[iterate].point2.y,lines_to_draw_master.lines[iterate].point2.z,lines_to_draw_master.lines[iterate].number_of_dashes);
               }
            }
            
            if (lines_to_draw_master.number_of_lines>0) free(lines_to_draw_master.lines);
        }
   }

}
#line 484622 "MACS_sample_kidney_box.c"
}   /* End of kidney_union_master=Union_master() SETTING parameter declarations. */
#undef focus_data_index
#undef temporary_focus_data
#undef number_of_processes_array
#undef safty_distance2
#undef safty_distance
#undef max_conditional_extend_index
#undef tagging_conditional_extend
#undef logger_conditional_extend_array
#undef free_tagging_conditioanl_list
#undef tagging_conditional_list
#undef conditional_status
#undef this_logger
#undef p_old
#undef Volume_copies_allocated
#undef geometry_component_index_list
#undef mask_volume_index_list
#undef current_mask_intersect_list_status
#undef mask_status_list
#undef mask_iterate
#undef mask_index_main
#undef need_to_run_within_which_volume
#undef number_of_masked_volumes
#undef number_of_masks
#undef mc_transmission_probability
#undef real_transmission_probability
#undef number_of_scattering_events
#undef tagging_leaf_counter
#undef current_tagging_node
#undef master_tagging_node_list
#undef enable_tagging_check
#undef stop_creating_nodes
#undef stop_tagging_ray
#undef enable_tagging
#undef rotated_position
#undef non_rotated_position
#undef temp_rotation_matrix
#undef master_transposed_rotation_matrix
#undef scattered_flag_VP
#undef scattered_flag
#undef volume_0_found
#undef ray_velocity_final
#undef ray_velocity
#undef ray_position
#undef pre_allocated3
#undef pre_allocated2
#undef pre_allocated1
#undef tree_next_volume
#undef geometry_output
#undef intersection_with_children
#undef start
#undef check
#undef number_of_solutions_static
#undef number_of_solutions
#undef current_volume
#undef done
#undef next_volume_priority
#undef next_volume
#undef a_next_volume_found
#undef time_propagated_without_scattering
#undef scattering_event
#undef selected_process
#undef time_to_boundery
#undef length_to_boundery
#undef length_to_scattering
#undef time_to_scattering
#undef mc_prop
#undef culmative_probability
#undef my_sum_plus_abs
#undef my_sum
#undef v_length
#undef k_old
#undef k_new
#undef k
#undef my_trace_fraction_control
#undef p_my_trace
#undef my_trace
#undef process_start
#undef process
#undef min_intersection_time
#undef intersection_time
#undef time_found
#undef min_volume
#undef min_solution
#undef solution
#undef limit
#undef max_number_of_processes
#undef solutions
#undef process_index
#undef volume_index
#undef number_of_volumes
#undef string_output
#undef component_error_msg
#undef error_msg
#undef v
#undef r_start
#undef r
#undef starting_lists
#undef Geometries
#undef Volumes
#undef intersection_time_table
#undef geometry_list_index
#undef previous_master_index
#undef this_global_master_index
#undef global_master_element
#undef starting_volume_warning
#undef finally_verbal
#undef trace_verbal
#undef list_verbal
#undef verbal
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

  /* MCDISPLAY code for component 'diffraction_detector_0'. */
  SIG_MESSAGE("diffraction_detector_0 (McDisplay)");
  printf("MCDISPLAY: component %s\n", "diffraction_detector_0");
#define mccompcurname  diffraction_detector_0
#define mccompcurtype  PSD_monitor
#define mccompcurindex 885
#define PSD_N mccdiffraction_detector_0_PSD_N
#define PSD_p mccdiffraction_detector_0_PSD_p
#define PSD_p2 mccdiffraction_detector_0_PSD_p2
{   /* Declarations of diffraction_detector_0=PSD_monitor() SETTING parameters. */
int nx = mccdiffraction_detector_0_nx;
int ny = mccdiffraction_detector_0_ny;
char* filename = mccdiffraction_detector_0_filename;
MCNUM xmin = mccdiffraction_detector_0_xmin;
MCNUM xmax = mccdiffraction_detector_0_xmax;
MCNUM ymin = mccdiffraction_detector_0_ymin;
MCNUM ymax = mccdiffraction_detector_0_ymax;
MCNUM xwidth = mccdiffraction_detector_0_xwidth;
MCNUM yheight = mccdiffraction_detector_0_yheight;
MCNUM restore_neutron = mccdiffraction_detector_0_restore_neutron;
#line 129 "/usr/share/mcstas/2.7/monitors/PSD_monitor.comp"
{
  multiline(5,
    (double)xmin, (double)ymin, 0.0,
    (double)xmax, (double)ymin, 0.0,
    (double)xmax, (double)ymax, 0.0,
    (double)xmin, (double)ymax, 0.0,
    (double)xmin, (double)ymin, 0.0);
}
#line 484766 "MACS_sample_kidney_box.c"
}   /* End of diffraction_detector_0=PSD_monitor() SETTING parameter declarations. */
#undef PSD_p2
#undef PSD_p
#undef PSD_N
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

  /* MCDISPLAY code for component 'spec_detector_0'. */
  SIG_MESSAGE("spec_detector_0 (McDisplay)");
  printf("MCDISPLAY: component %s\n", "spec_detector_0");
#define mccompcurname  spec_detector_0
#define mccompcurtype  PSD_monitor
#define mccompcurindex 886
#define PSD_N mccspec_detector_0_PSD_N
#define PSD_p mccspec_detector_0_PSD_p
#define PSD_p2 mccspec_detector_0_PSD_p2
{   /* Declarations of spec_detector_0=PSD_monitor() SETTING parameters. */
int nx = mccspec_detector_0_nx;
int ny = mccspec_detector_0_ny;
char* filename = mccspec_detector_0_filename;
MCNUM xmin = mccspec_detector_0_xmin;
MCNUM xmax = mccspec_detector_0_xmax;
MCNUM ymin = mccspec_detector_0_ymin;
MCNUM ymax = mccspec_detector_0_ymax;
MCNUM xwidth = mccspec_detector_0_xwidth;
MCNUM yheight = mccspec_detector_0_yheight;
MCNUM restore_neutron = mccspec_detector_0_restore_neutron;
#line 129 "/usr/share/mcstas/2.7/monitors/PSD_monitor.comp"
{
  multiline(5,
    (double)xmin, (double)ymin, 0.0,
    (double)xmax, (double)ymin, 0.0,
    (double)xmax, (double)ymax, 0.0,
    (double)xmin, (double)ymax, 0.0,
    (double)xmin, (double)ymin, 0.0);
}
#line 484804 "MACS_sample_kidney_box.c"
}   /* End of spec_detector_0=PSD_monitor() SETTING parameter declarations. */
#undef PSD_p2
#undef PSD_p
#undef PSD_N
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

  /* MCDISPLAY code for component 'diffraction_detector_1'. */
  SIG_MESSAGE("diffraction_detector_1 (McDisplay)");
  printf("MCDISPLAY: component %s\n", "diffraction_detector_1");
#define mccompcurname  diffraction_detector_1
#define mccompcurtype  PSD_monitor
#define mccompcurindex 887
#define PSD_N mccdiffraction_detector_1_PSD_N
#define PSD_p mccdiffraction_detector_1_PSD_p
#define PSD_p2 mccdiffraction_detector_1_PSD_p2
{   /* Declarations of diffraction_detector_1=PSD_monitor() SETTING parameters. */
int nx = mccdiffraction_detector_1_nx;
int ny = mccdiffraction_detector_1_ny;
char* filename = mccdiffraction_detector_1_filename;
MCNUM xmin = mccdiffraction_detector_1_xmin;
MCNUM xmax = mccdiffraction_detector_1_xmax;
MCNUM ymin = mccdiffraction_detector_1_ymin;
MCNUM ymax = mccdiffraction_detector_1_ymax;
MCNUM xwidth = mccdiffraction_detector_1_xwidth;
MCNUM yheight = mccdiffraction_detector_1_yheight;
MCNUM restore_neutron = mccdiffraction_detector_1_restore_neutron;
#line 129 "/usr/share/mcstas/2.7/monitors/PSD_monitor.comp"
{
  multiline(5,
    (double)xmin, (double)ymin, 0.0,
    (double)xmax, (double)ymin, 0.0,
    (double)xmax, (double)ymax, 0.0,
    (double)xmin, (double)ymax, 0.0,
    (double)xmin, (double)ymin, 0.0);
}
#line 484842 "MACS_sample_kidney_box.c"
}   /* End of diffraction_detector_1=PSD_monitor() SETTING parameter declarations. */
#undef PSD_p2
#undef PSD_p
#undef PSD_N
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

  /* MCDISPLAY code for component 'spec_detector_1'. */
  SIG_MESSAGE("spec_detector_1 (McDisplay)");
  printf("MCDISPLAY: component %s\n", "spec_detector_1");
#define mccompcurname  spec_detector_1
#define mccompcurtype  PSD_monitor
#define mccompcurindex 888
#define PSD_N mccspec_detector_1_PSD_N
#define PSD_p mccspec_detector_1_PSD_p
#define PSD_p2 mccspec_detector_1_PSD_p2
{   /* Declarations of spec_detector_1=PSD_monitor() SETTING parameters. */
int nx = mccspec_detector_1_nx;
int ny = mccspec_detector_1_ny;
char* filename = mccspec_detector_1_filename;
MCNUM xmin = mccspec_detector_1_xmin;
MCNUM xmax = mccspec_detector_1_xmax;
MCNUM ymin = mccspec_detector_1_ymin;
MCNUM ymax = mccspec_detector_1_ymax;
MCNUM xwidth = mccspec_detector_1_xwidth;
MCNUM yheight = mccspec_detector_1_yheight;
MCNUM restore_neutron = mccspec_detector_1_restore_neutron;
#line 129 "/usr/share/mcstas/2.7/monitors/PSD_monitor.comp"
{
  multiline(5,
    (double)xmin, (double)ymin, 0.0,
    (double)xmax, (double)ymin, 0.0,
    (double)xmax, (double)ymax, 0.0,
    (double)xmin, (double)ymax, 0.0,
    (double)xmin, (double)ymin, 0.0);
}
#line 484880 "MACS_sample_kidney_box.c"
}   /* End of spec_detector_1=PSD_monitor() SETTING parameter declarations. */
#undef PSD_p2
#undef PSD_p
#undef PSD_N
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

  /* MCDISPLAY code for component 'diffraction_detector_2'. */
  SIG_MESSAGE("diffraction_detector_2 (McDisplay)");
  printf("MCDISPLAY: component %s\n", "diffraction_detector_2");
#define mccompcurname  diffraction_detector_2
#define mccompcurtype  PSD_monitor
#define mccompcurindex 889
#define PSD_N mccdiffraction_detector_2_PSD_N
#define PSD_p mccdiffraction_detector_2_PSD_p
#define PSD_p2 mccdiffraction_detector_2_PSD_p2
{   /* Declarations of diffraction_detector_2=PSD_monitor() SETTING parameters. */
int nx = mccdiffraction_detector_2_nx;
int ny = mccdiffraction_detector_2_ny;
char* filename = mccdiffraction_detector_2_filename;
MCNUM xmin = mccdiffraction_detector_2_xmin;
MCNUM xmax = mccdiffraction_detector_2_xmax;
MCNUM ymin = mccdiffraction_detector_2_ymin;
MCNUM ymax = mccdiffraction_detector_2_ymax;
MCNUM xwidth = mccdiffraction_detector_2_xwidth;
MCNUM yheight = mccdiffraction_detector_2_yheight;
MCNUM restore_neutron = mccdiffraction_detector_2_restore_neutron;
#line 129 "/usr/share/mcstas/2.7/monitors/PSD_monitor.comp"
{
  multiline(5,
    (double)xmin, (double)ymin, 0.0,
    (double)xmax, (double)ymin, 0.0,
    (double)xmax, (double)ymax, 0.0,
    (double)xmin, (double)ymax, 0.0,
    (double)xmin, (double)ymin, 0.0);
}
#line 484918 "MACS_sample_kidney_box.c"
}   /* End of diffraction_detector_2=PSD_monitor() SETTING parameter declarations. */
#undef PSD_p2
#undef PSD_p
#undef PSD_N
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

  /* MCDISPLAY code for component 'spec_detector_2'. */
  SIG_MESSAGE("spec_detector_2 (McDisplay)");
  printf("MCDISPLAY: component %s\n", "spec_detector_2");
#define mccompcurname  spec_detector_2
#define mccompcurtype  PSD_monitor
#define mccompcurindex 890
#define PSD_N mccspec_detector_2_PSD_N
#define PSD_p mccspec_detector_2_PSD_p
#define PSD_p2 mccspec_detector_2_PSD_p2
{   /* Declarations of spec_detector_2=PSD_monitor() SETTING parameters. */
int nx = mccspec_detector_2_nx;
int ny = mccspec_detector_2_ny;
char* filename = mccspec_detector_2_filename;
MCNUM xmin = mccspec_detector_2_xmin;
MCNUM xmax = mccspec_detector_2_xmax;
MCNUM ymin = mccspec_detector_2_ymin;
MCNUM ymax = mccspec_detector_2_ymax;
MCNUM xwidth = mccspec_detector_2_xwidth;
MCNUM yheight = mccspec_detector_2_yheight;
MCNUM restore_neutron = mccspec_detector_2_restore_neutron;
#line 129 "/usr/share/mcstas/2.7/monitors/PSD_monitor.comp"
{
  multiline(5,
    (double)xmin, (double)ymin, 0.0,
    (double)xmax, (double)ymin, 0.0,
    (double)xmax, (double)ymax, 0.0,
    (double)xmin, (double)ymax, 0.0,
    (double)xmin, (double)ymin, 0.0);
}
#line 484956 "MACS_sample_kidney_box.c"
}   /* End of spec_detector_2=PSD_monitor() SETTING parameter declarations. */
#undef PSD_p2
#undef PSD_p
#undef PSD_N
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

  /* MCDISPLAY code for component 'diffraction_detector_3'. */
  SIG_MESSAGE("diffraction_detector_3 (McDisplay)");
  printf("MCDISPLAY: component %s\n", "diffraction_detector_3");
#define mccompcurname  diffraction_detector_3
#define mccompcurtype  PSD_monitor
#define mccompcurindex 891
#define PSD_N mccdiffraction_detector_3_PSD_N
#define PSD_p mccdiffraction_detector_3_PSD_p
#define PSD_p2 mccdiffraction_detector_3_PSD_p2
{   /* Declarations of diffraction_detector_3=PSD_monitor() SETTING parameters. */
int nx = mccdiffraction_detector_3_nx;
int ny = mccdiffraction_detector_3_ny;
char* filename = mccdiffraction_detector_3_filename;
MCNUM xmin = mccdiffraction_detector_3_xmin;
MCNUM xmax = mccdiffraction_detector_3_xmax;
MCNUM ymin = mccdiffraction_detector_3_ymin;
MCNUM ymax = mccdiffraction_detector_3_ymax;
MCNUM xwidth = mccdiffraction_detector_3_xwidth;
MCNUM yheight = mccdiffraction_detector_3_yheight;
MCNUM restore_neutron = mccdiffraction_detector_3_restore_neutron;
#line 129 "/usr/share/mcstas/2.7/monitors/PSD_monitor.comp"
{
  multiline(5,
    (double)xmin, (double)ymin, 0.0,
    (double)xmax, (double)ymin, 0.0,
    (double)xmax, (double)ymax, 0.0,
    (double)xmin, (double)ymax, 0.0,
    (double)xmin, (double)ymin, 0.0);
}
#line 484994 "MACS_sample_kidney_box.c"
}   /* End of diffraction_detector_3=PSD_monitor() SETTING parameter declarations. */
#undef PSD_p2
#undef PSD_p
#undef PSD_N
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

  /* MCDISPLAY code for component 'spec_detector_3'. */
  SIG_MESSAGE("spec_detector_3 (McDisplay)");
  printf("MCDISPLAY: component %s\n", "spec_detector_3");
#define mccompcurname  spec_detector_3
#define mccompcurtype  PSD_monitor
#define mccompcurindex 892
#define PSD_N mccspec_detector_3_PSD_N
#define PSD_p mccspec_detector_3_PSD_p
#define PSD_p2 mccspec_detector_3_PSD_p2
{   /* Declarations of spec_detector_3=PSD_monitor() SETTING parameters. */
int nx = mccspec_detector_3_nx;
int ny = mccspec_detector_3_ny;
char* filename = mccspec_detector_3_filename;
MCNUM xmin = mccspec_detector_3_xmin;
MCNUM xmax = mccspec_detector_3_xmax;
MCNUM ymin = mccspec_detector_3_ymin;
MCNUM ymax = mccspec_detector_3_ymax;
MCNUM xwidth = mccspec_detector_3_xwidth;
MCNUM yheight = mccspec_detector_3_yheight;
MCNUM restore_neutron = mccspec_detector_3_restore_neutron;
#line 129 "/usr/share/mcstas/2.7/monitors/PSD_monitor.comp"
{
  multiline(5,
    (double)xmin, (double)ymin, 0.0,
    (double)xmax, (double)ymin, 0.0,
    (double)xmax, (double)ymax, 0.0,
    (double)xmin, (double)ymax, 0.0,
    (double)xmin, (double)ymin, 0.0);
}
#line 485032 "MACS_sample_kidney_box.c"
}   /* End of spec_detector_3=PSD_monitor() SETTING parameter declarations. */
#undef PSD_p2
#undef PSD_p
#undef PSD_N
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

  /* MCDISPLAY code for component 'diffraction_detector_4'. */
  SIG_MESSAGE("diffraction_detector_4 (McDisplay)");
  printf("MCDISPLAY: component %s\n", "diffraction_detector_4");
#define mccompcurname  diffraction_detector_4
#define mccompcurtype  PSD_monitor
#define mccompcurindex 893
#define PSD_N mccdiffraction_detector_4_PSD_N
#define PSD_p mccdiffraction_detector_4_PSD_p
#define PSD_p2 mccdiffraction_detector_4_PSD_p2
{   /* Declarations of diffraction_detector_4=PSD_monitor() SETTING parameters. */
int nx = mccdiffraction_detector_4_nx;
int ny = mccdiffraction_detector_4_ny;
char* filename = mccdiffraction_detector_4_filename;
MCNUM xmin = mccdiffraction_detector_4_xmin;
MCNUM xmax = mccdiffraction_detector_4_xmax;
MCNUM ymin = mccdiffraction_detector_4_ymin;
MCNUM ymax = mccdiffraction_detector_4_ymax;
MCNUM xwidth = mccdiffraction_detector_4_xwidth;
MCNUM yheight = mccdiffraction_detector_4_yheight;
MCNUM restore_neutron = mccdiffraction_detector_4_restore_neutron;
#line 129 "/usr/share/mcstas/2.7/monitors/PSD_monitor.comp"
{
  multiline(5,
    (double)xmin, (double)ymin, 0.0,
    (double)xmax, (double)ymin, 0.0,
    (double)xmax, (double)ymax, 0.0,
    (double)xmin, (double)ymax, 0.0,
    (double)xmin, (double)ymin, 0.0);
}
#line 485070 "MACS_sample_kidney_box.c"
}   /* End of diffraction_detector_4=PSD_monitor() SETTING parameter declarations. */
#undef PSD_p2
#undef PSD_p
#undef PSD_N
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

  /* MCDISPLAY code for component 'spec_detector_4'. */
  SIG_MESSAGE("spec_detector_4 (McDisplay)");
  printf("MCDISPLAY: component %s\n", "spec_detector_4");
#define mccompcurname  spec_detector_4
#define mccompcurtype  PSD_monitor
#define mccompcurindex 894
#define PSD_N mccspec_detector_4_PSD_N
#define PSD_p mccspec_detector_4_PSD_p
#define PSD_p2 mccspec_detector_4_PSD_p2
{   /* Declarations of spec_detector_4=PSD_monitor() SETTING parameters. */
int nx = mccspec_detector_4_nx;
int ny = mccspec_detector_4_ny;
char* filename = mccspec_detector_4_filename;
MCNUM xmin = mccspec_detector_4_xmin;
MCNUM xmax = mccspec_detector_4_xmax;
MCNUM ymin = mccspec_detector_4_ymin;
MCNUM ymax = mccspec_detector_4_ymax;
MCNUM xwidth = mccspec_detector_4_xwidth;
MCNUM yheight = mccspec_detector_4_yheight;
MCNUM restore_neutron = mccspec_detector_4_restore_neutron;
#line 129 "/usr/share/mcstas/2.7/monitors/PSD_monitor.comp"
{
  multiline(5,
    (double)xmin, (double)ymin, 0.0,
    (double)xmax, (double)ymin, 0.0,
    (double)xmax, (double)ymax, 0.0,
    (double)xmin, (double)ymax, 0.0,
    (double)xmin, (double)ymin, 0.0);
}
#line 485108 "MACS_sample_kidney_box.c"
}   /* End of spec_detector_4=PSD_monitor() SETTING parameter declarations. */
#undef PSD_p2
#undef PSD_p
#undef PSD_N
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

  /* MCDISPLAY code for component 'diffraction_detector_5'. */
  SIG_MESSAGE("diffraction_detector_5 (McDisplay)");
  printf("MCDISPLAY: component %s\n", "diffraction_detector_5");
#define mccompcurname  diffraction_detector_5
#define mccompcurtype  PSD_monitor
#define mccompcurindex 895
#define PSD_N mccdiffraction_detector_5_PSD_N
#define PSD_p mccdiffraction_detector_5_PSD_p
#define PSD_p2 mccdiffraction_detector_5_PSD_p2
{   /* Declarations of diffraction_detector_5=PSD_monitor() SETTING parameters. */
int nx = mccdiffraction_detector_5_nx;
int ny = mccdiffraction_detector_5_ny;
char* filename = mccdiffraction_detector_5_filename;
MCNUM xmin = mccdiffraction_detector_5_xmin;
MCNUM xmax = mccdiffraction_detector_5_xmax;
MCNUM ymin = mccdiffraction_detector_5_ymin;
MCNUM ymax = mccdiffraction_detector_5_ymax;
MCNUM xwidth = mccdiffraction_detector_5_xwidth;
MCNUM yheight = mccdiffraction_detector_5_yheight;
MCNUM restore_neutron = mccdiffraction_detector_5_restore_neutron;
#line 129 "/usr/share/mcstas/2.7/monitors/PSD_monitor.comp"
{
  multiline(5,
    (double)xmin, (double)ymin, 0.0,
    (double)xmax, (double)ymin, 0.0,
    (double)xmax, (double)ymax, 0.0,
    (double)xmin, (double)ymax, 0.0,
    (double)xmin, (double)ymin, 0.0);
}
#line 485146 "MACS_sample_kidney_box.c"
}   /* End of diffraction_detector_5=PSD_monitor() SETTING parameter declarations. */
#undef PSD_p2
#undef PSD_p
#undef PSD_N
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

  /* MCDISPLAY code for component 'spec_detector_5'. */
  SIG_MESSAGE("spec_detector_5 (McDisplay)");
  printf("MCDISPLAY: component %s\n", "spec_detector_5");
#define mccompcurname  spec_detector_5
#define mccompcurtype  PSD_monitor
#define mccompcurindex 896
#define PSD_N mccspec_detector_5_PSD_N
#define PSD_p mccspec_detector_5_PSD_p
#define PSD_p2 mccspec_detector_5_PSD_p2
{   /* Declarations of spec_detector_5=PSD_monitor() SETTING parameters. */
int nx = mccspec_detector_5_nx;
int ny = mccspec_detector_5_ny;
char* filename = mccspec_detector_5_filename;
MCNUM xmin = mccspec_detector_5_xmin;
MCNUM xmax = mccspec_detector_5_xmax;
MCNUM ymin = mccspec_detector_5_ymin;
MCNUM ymax = mccspec_detector_5_ymax;
MCNUM xwidth = mccspec_detector_5_xwidth;
MCNUM yheight = mccspec_detector_5_yheight;
MCNUM restore_neutron = mccspec_detector_5_restore_neutron;
#line 129 "/usr/share/mcstas/2.7/monitors/PSD_monitor.comp"
{
  multiline(5,
    (double)xmin, (double)ymin, 0.0,
    (double)xmax, (double)ymin, 0.0,
    (double)xmax, (double)ymax, 0.0,
    (double)xmin, (double)ymax, 0.0,
    (double)xmin, (double)ymin, 0.0);
}
#line 485184 "MACS_sample_kidney_box.c"
}   /* End of spec_detector_5=PSD_monitor() SETTING parameter declarations. */
#undef PSD_p2
#undef PSD_p
#undef PSD_N
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

  /* MCDISPLAY code for component 'diffraction_detector_6'. */
  SIG_MESSAGE("diffraction_detector_6 (McDisplay)");
  printf("MCDISPLAY: component %s\n", "diffraction_detector_6");
#define mccompcurname  diffraction_detector_6
#define mccompcurtype  PSD_monitor
#define mccompcurindex 897
#define PSD_N mccdiffraction_detector_6_PSD_N
#define PSD_p mccdiffraction_detector_6_PSD_p
#define PSD_p2 mccdiffraction_detector_6_PSD_p2
{   /* Declarations of diffraction_detector_6=PSD_monitor() SETTING parameters. */
int nx = mccdiffraction_detector_6_nx;
int ny = mccdiffraction_detector_6_ny;
char* filename = mccdiffraction_detector_6_filename;
MCNUM xmin = mccdiffraction_detector_6_xmin;
MCNUM xmax = mccdiffraction_detector_6_xmax;
MCNUM ymin = mccdiffraction_detector_6_ymin;
MCNUM ymax = mccdiffraction_detector_6_ymax;
MCNUM xwidth = mccdiffraction_detector_6_xwidth;
MCNUM yheight = mccdiffraction_detector_6_yheight;
MCNUM restore_neutron = mccdiffraction_detector_6_restore_neutron;
#line 129 "/usr/share/mcstas/2.7/monitors/PSD_monitor.comp"
{
  multiline(5,
    (double)xmin, (double)ymin, 0.0,
    (double)xmax, (double)ymin, 0.0,
    (double)xmax, (double)ymax, 0.0,
    (double)xmin, (double)ymax, 0.0,
    (double)xmin, (double)ymin, 0.0);
}
#line 485222 "MACS_sample_kidney_box.c"
}   /* End of diffraction_detector_6=PSD_monitor() SETTING parameter declarations. */
#undef PSD_p2
#undef PSD_p
#undef PSD_N
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

  /* MCDISPLAY code for component 'spec_detector_6'. */
  SIG_MESSAGE("spec_detector_6 (McDisplay)");
  printf("MCDISPLAY: component %s\n", "spec_detector_6");
#define mccompcurname  spec_detector_6
#define mccompcurtype  PSD_monitor
#define mccompcurindex 898
#define PSD_N mccspec_detector_6_PSD_N
#define PSD_p mccspec_detector_6_PSD_p
#define PSD_p2 mccspec_detector_6_PSD_p2
{   /* Declarations of spec_detector_6=PSD_monitor() SETTING parameters. */
int nx = mccspec_detector_6_nx;
int ny = mccspec_detector_6_ny;
char* filename = mccspec_detector_6_filename;
MCNUM xmin = mccspec_detector_6_xmin;
MCNUM xmax = mccspec_detector_6_xmax;
MCNUM ymin = mccspec_detector_6_ymin;
MCNUM ymax = mccspec_detector_6_ymax;
MCNUM xwidth = mccspec_detector_6_xwidth;
MCNUM yheight = mccspec_detector_6_yheight;
MCNUM restore_neutron = mccspec_detector_6_restore_neutron;
#line 129 "/usr/share/mcstas/2.7/monitors/PSD_monitor.comp"
{
  multiline(5,
    (double)xmin, (double)ymin, 0.0,
    (double)xmax, (double)ymin, 0.0,
    (double)xmax, (double)ymax, 0.0,
    (double)xmin, (double)ymax, 0.0,
    (double)xmin, (double)ymin, 0.0);
}
#line 485260 "MACS_sample_kidney_box.c"
}   /* End of spec_detector_6=PSD_monitor() SETTING parameter declarations. */
#undef PSD_p2
#undef PSD_p
#undef PSD_N
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

  /* MCDISPLAY code for component 'diffraction_detector_7'. */
  SIG_MESSAGE("diffraction_detector_7 (McDisplay)");
  printf("MCDISPLAY: component %s\n", "diffraction_detector_7");
#define mccompcurname  diffraction_detector_7
#define mccompcurtype  PSD_monitor
#define mccompcurindex 899
#define PSD_N mccdiffraction_detector_7_PSD_N
#define PSD_p mccdiffraction_detector_7_PSD_p
#define PSD_p2 mccdiffraction_detector_7_PSD_p2
{   /* Declarations of diffraction_detector_7=PSD_monitor() SETTING parameters. */
int nx = mccdiffraction_detector_7_nx;
int ny = mccdiffraction_detector_7_ny;
char* filename = mccdiffraction_detector_7_filename;
MCNUM xmin = mccdiffraction_detector_7_xmin;
MCNUM xmax = mccdiffraction_detector_7_xmax;
MCNUM ymin = mccdiffraction_detector_7_ymin;
MCNUM ymax = mccdiffraction_detector_7_ymax;
MCNUM xwidth = mccdiffraction_detector_7_xwidth;
MCNUM yheight = mccdiffraction_detector_7_yheight;
MCNUM restore_neutron = mccdiffraction_detector_7_restore_neutron;
#line 129 "/usr/share/mcstas/2.7/monitors/PSD_monitor.comp"
{
  multiline(5,
    (double)xmin, (double)ymin, 0.0,
    (double)xmax, (double)ymin, 0.0,
    (double)xmax, (double)ymax, 0.0,
    (double)xmin, (double)ymax, 0.0,
    (double)xmin, (double)ymin, 0.0);
}
#line 485298 "MACS_sample_kidney_box.c"
}   /* End of diffraction_detector_7=PSD_monitor() SETTING parameter declarations. */
#undef PSD_p2
#undef PSD_p
#undef PSD_N
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

  /* MCDISPLAY code for component 'spec_detector_7'. */
  SIG_MESSAGE("spec_detector_7 (McDisplay)");
  printf("MCDISPLAY: component %s\n", "spec_detector_7");
#define mccompcurname  spec_detector_7
#define mccompcurtype  PSD_monitor
#define mccompcurindex 900
#define PSD_N mccspec_detector_7_PSD_N
#define PSD_p mccspec_detector_7_PSD_p
#define PSD_p2 mccspec_detector_7_PSD_p2
{   /* Declarations of spec_detector_7=PSD_monitor() SETTING parameters. */
int nx = mccspec_detector_7_nx;
int ny = mccspec_detector_7_ny;
char* filename = mccspec_detector_7_filename;
MCNUM xmin = mccspec_detector_7_xmin;
MCNUM xmax = mccspec_detector_7_xmax;
MCNUM ymin = mccspec_detector_7_ymin;
MCNUM ymax = mccspec_detector_7_ymax;
MCNUM xwidth = mccspec_detector_7_xwidth;
MCNUM yheight = mccspec_detector_7_yheight;
MCNUM restore_neutron = mccspec_detector_7_restore_neutron;
#line 129 "/usr/share/mcstas/2.7/monitors/PSD_monitor.comp"
{
  multiline(5,
    (double)xmin, (double)ymin, 0.0,
    (double)xmax, (double)ymin, 0.0,
    (double)xmax, (double)ymax, 0.0,
    (double)xmin, (double)ymax, 0.0,
    (double)xmin, (double)ymin, 0.0);
}
#line 485336 "MACS_sample_kidney_box.c"
}   /* End of spec_detector_7=PSD_monitor() SETTING parameter declarations. */
#undef PSD_p2
#undef PSD_p
#undef PSD_N
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

  /* MCDISPLAY code for component 'diffraction_detector_8'. */
  SIG_MESSAGE("diffraction_detector_8 (McDisplay)");
  printf("MCDISPLAY: component %s\n", "diffraction_detector_8");
#define mccompcurname  diffraction_detector_8
#define mccompcurtype  PSD_monitor
#define mccompcurindex 901
#define PSD_N mccdiffraction_detector_8_PSD_N
#define PSD_p mccdiffraction_detector_8_PSD_p
#define PSD_p2 mccdiffraction_detector_8_PSD_p2
{   /* Declarations of diffraction_detector_8=PSD_monitor() SETTING parameters. */
int nx = mccdiffraction_detector_8_nx;
int ny = mccdiffraction_detector_8_ny;
char* filename = mccdiffraction_detector_8_filename;
MCNUM xmin = mccdiffraction_detector_8_xmin;
MCNUM xmax = mccdiffraction_detector_8_xmax;
MCNUM ymin = mccdiffraction_detector_8_ymin;
MCNUM ymax = mccdiffraction_detector_8_ymax;
MCNUM xwidth = mccdiffraction_detector_8_xwidth;
MCNUM yheight = mccdiffraction_detector_8_yheight;
MCNUM restore_neutron = mccdiffraction_detector_8_restore_neutron;
#line 129 "/usr/share/mcstas/2.7/monitors/PSD_monitor.comp"
{
  multiline(5,
    (double)xmin, (double)ymin, 0.0,
    (double)xmax, (double)ymin, 0.0,
    (double)xmax, (double)ymax, 0.0,
    (double)xmin, (double)ymax, 0.0,
    (double)xmin, (double)ymin, 0.0);
}
#line 485374 "MACS_sample_kidney_box.c"
}   /* End of diffraction_detector_8=PSD_monitor() SETTING parameter declarations. */
#undef PSD_p2
#undef PSD_p
#undef PSD_N
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

  /* MCDISPLAY code for component 'spec_detector_8'. */
  SIG_MESSAGE("spec_detector_8 (McDisplay)");
  printf("MCDISPLAY: component %s\n", "spec_detector_8");
#define mccompcurname  spec_detector_8
#define mccompcurtype  PSD_monitor
#define mccompcurindex 902
#define PSD_N mccspec_detector_8_PSD_N
#define PSD_p mccspec_detector_8_PSD_p
#define PSD_p2 mccspec_detector_8_PSD_p2
{   /* Declarations of spec_detector_8=PSD_monitor() SETTING parameters. */
int nx = mccspec_detector_8_nx;
int ny = mccspec_detector_8_ny;
char* filename = mccspec_detector_8_filename;
MCNUM xmin = mccspec_detector_8_xmin;
MCNUM xmax = mccspec_detector_8_xmax;
MCNUM ymin = mccspec_detector_8_ymin;
MCNUM ymax = mccspec_detector_8_ymax;
MCNUM xwidth = mccspec_detector_8_xwidth;
MCNUM yheight = mccspec_detector_8_yheight;
MCNUM restore_neutron = mccspec_detector_8_restore_neutron;
#line 129 "/usr/share/mcstas/2.7/monitors/PSD_monitor.comp"
{
  multiline(5,
    (double)xmin, (double)ymin, 0.0,
    (double)xmax, (double)ymin, 0.0,
    (double)xmax, (double)ymax, 0.0,
    (double)xmin, (double)ymax, 0.0,
    (double)xmin, (double)ymin, 0.0);
}
#line 485412 "MACS_sample_kidney_box.c"
}   /* End of spec_detector_8=PSD_monitor() SETTING parameter declarations. */
#undef PSD_p2
#undef PSD_p
#undef PSD_N
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

  /* MCDISPLAY code for component 'diffraction_detector_9'. */
  SIG_MESSAGE("diffraction_detector_9 (McDisplay)");
  printf("MCDISPLAY: component %s\n", "diffraction_detector_9");
#define mccompcurname  diffraction_detector_9
#define mccompcurtype  PSD_monitor
#define mccompcurindex 903
#define PSD_N mccdiffraction_detector_9_PSD_N
#define PSD_p mccdiffraction_detector_9_PSD_p
#define PSD_p2 mccdiffraction_detector_9_PSD_p2
{   /* Declarations of diffraction_detector_9=PSD_monitor() SETTING parameters. */
int nx = mccdiffraction_detector_9_nx;
int ny = mccdiffraction_detector_9_ny;
char* filename = mccdiffraction_detector_9_filename;
MCNUM xmin = mccdiffraction_detector_9_xmin;
MCNUM xmax = mccdiffraction_detector_9_xmax;
MCNUM ymin = mccdiffraction_detector_9_ymin;
MCNUM ymax = mccdiffraction_detector_9_ymax;
MCNUM xwidth = mccdiffraction_detector_9_xwidth;
MCNUM yheight = mccdiffraction_detector_9_yheight;
MCNUM restore_neutron = mccdiffraction_detector_9_restore_neutron;
#line 129 "/usr/share/mcstas/2.7/monitors/PSD_monitor.comp"
{
  multiline(5,
    (double)xmin, (double)ymin, 0.0,
    (double)xmax, (double)ymin, 0.0,
    (double)xmax, (double)ymax, 0.0,
    (double)xmin, (double)ymax, 0.0,
    (double)xmin, (double)ymin, 0.0);
}
#line 485450 "MACS_sample_kidney_box.c"
}   /* End of diffraction_detector_9=PSD_monitor() SETTING parameter declarations. */
#undef PSD_p2
#undef PSD_p
#undef PSD_N
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

  /* MCDISPLAY code for component 'spec_detector_9'. */
  SIG_MESSAGE("spec_detector_9 (McDisplay)");
  printf("MCDISPLAY: component %s\n", "spec_detector_9");
#define mccompcurname  spec_detector_9
#define mccompcurtype  PSD_monitor
#define mccompcurindex 904
#define PSD_N mccspec_detector_9_PSD_N
#define PSD_p mccspec_detector_9_PSD_p
#define PSD_p2 mccspec_detector_9_PSD_p2
{   /* Declarations of spec_detector_9=PSD_monitor() SETTING parameters. */
int nx = mccspec_detector_9_nx;
int ny = mccspec_detector_9_ny;
char* filename = mccspec_detector_9_filename;
MCNUM xmin = mccspec_detector_9_xmin;
MCNUM xmax = mccspec_detector_9_xmax;
MCNUM ymin = mccspec_detector_9_ymin;
MCNUM ymax = mccspec_detector_9_ymax;
MCNUM xwidth = mccspec_detector_9_xwidth;
MCNUM yheight = mccspec_detector_9_yheight;
MCNUM restore_neutron = mccspec_detector_9_restore_neutron;
#line 129 "/usr/share/mcstas/2.7/monitors/PSD_monitor.comp"
{
  multiline(5,
    (double)xmin, (double)ymin, 0.0,
    (double)xmax, (double)ymin, 0.0,
    (double)xmax, (double)ymax, 0.0,
    (double)xmin, (double)ymax, 0.0,
    (double)xmin, (double)ymin, 0.0);
}
#line 485488 "MACS_sample_kidney_box.c"
}   /* End of spec_detector_9=PSD_monitor() SETTING parameter declarations. */
#undef PSD_p2
#undef PSD_p
#undef PSD_N
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

  /* MCDISPLAY code for component 'diffraction_detector_10'. */
  SIG_MESSAGE("diffraction_detector_10 (McDisplay)");
  printf("MCDISPLAY: component %s\n", "diffraction_detector_10");
#define mccompcurname  diffraction_detector_10
#define mccompcurtype  PSD_monitor
#define mccompcurindex 905
#define PSD_N mccdiffraction_detector_10_PSD_N
#define PSD_p mccdiffraction_detector_10_PSD_p
#define PSD_p2 mccdiffraction_detector_10_PSD_p2
{   /* Declarations of diffraction_detector_10=PSD_monitor() SETTING parameters. */
int nx = mccdiffraction_detector_10_nx;
int ny = mccdiffraction_detector_10_ny;
char* filename = mccdiffraction_detector_10_filename;
MCNUM xmin = mccdiffraction_detector_10_xmin;
MCNUM xmax = mccdiffraction_detector_10_xmax;
MCNUM ymin = mccdiffraction_detector_10_ymin;
MCNUM ymax = mccdiffraction_detector_10_ymax;
MCNUM xwidth = mccdiffraction_detector_10_xwidth;
MCNUM yheight = mccdiffraction_detector_10_yheight;
MCNUM restore_neutron = mccdiffraction_detector_10_restore_neutron;
#line 129 "/usr/share/mcstas/2.7/monitors/PSD_monitor.comp"
{
  multiline(5,
    (double)xmin, (double)ymin, 0.0,
    (double)xmax, (double)ymin, 0.0,
    (double)xmax, (double)ymax, 0.0,
    (double)xmin, (double)ymax, 0.0,
    (double)xmin, (double)ymin, 0.0);
}
#line 485526 "MACS_sample_kidney_box.c"
}   /* End of diffraction_detector_10=PSD_monitor() SETTING parameter declarations. */
#undef PSD_p2
#undef PSD_p
#undef PSD_N
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

  /* MCDISPLAY code for component 'spec_detector_10'. */
  SIG_MESSAGE("spec_detector_10 (McDisplay)");
  printf("MCDISPLAY: component %s\n", "spec_detector_10");
#define mccompcurname  spec_detector_10
#define mccompcurtype  PSD_monitor
#define mccompcurindex 906
#define PSD_N mccspec_detector_10_PSD_N
#define PSD_p mccspec_detector_10_PSD_p
#define PSD_p2 mccspec_detector_10_PSD_p2
{   /* Declarations of spec_detector_10=PSD_monitor() SETTING parameters. */
int nx = mccspec_detector_10_nx;
int ny = mccspec_detector_10_ny;
char* filename = mccspec_detector_10_filename;
MCNUM xmin = mccspec_detector_10_xmin;
MCNUM xmax = mccspec_detector_10_xmax;
MCNUM ymin = mccspec_detector_10_ymin;
MCNUM ymax = mccspec_detector_10_ymax;
MCNUM xwidth = mccspec_detector_10_xwidth;
MCNUM yheight = mccspec_detector_10_yheight;
MCNUM restore_neutron = mccspec_detector_10_restore_neutron;
#line 129 "/usr/share/mcstas/2.7/monitors/PSD_monitor.comp"
{
  multiline(5,
    (double)xmin, (double)ymin, 0.0,
    (double)xmax, (double)ymin, 0.0,
    (double)xmax, (double)ymax, 0.0,
    (double)xmin, (double)ymax, 0.0,
    (double)xmin, (double)ymin, 0.0);
}
#line 485564 "MACS_sample_kidney_box.c"
}   /* End of spec_detector_10=PSD_monitor() SETTING parameter declarations. */
#undef PSD_p2
#undef PSD_p
#undef PSD_N
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

  /* MCDISPLAY code for component 'diffraction_detector_11'. */
  SIG_MESSAGE("diffraction_detector_11 (McDisplay)");
  printf("MCDISPLAY: component %s\n", "diffraction_detector_11");
#define mccompcurname  diffraction_detector_11
#define mccompcurtype  PSD_monitor
#define mccompcurindex 907
#define PSD_N mccdiffraction_detector_11_PSD_N
#define PSD_p mccdiffraction_detector_11_PSD_p
#define PSD_p2 mccdiffraction_detector_11_PSD_p2
{   /* Declarations of diffraction_detector_11=PSD_monitor() SETTING parameters. */
int nx = mccdiffraction_detector_11_nx;
int ny = mccdiffraction_detector_11_ny;
char* filename = mccdiffraction_detector_11_filename;
MCNUM xmin = mccdiffraction_detector_11_xmin;
MCNUM xmax = mccdiffraction_detector_11_xmax;
MCNUM ymin = mccdiffraction_detector_11_ymin;
MCNUM ymax = mccdiffraction_detector_11_ymax;
MCNUM xwidth = mccdiffraction_detector_11_xwidth;
MCNUM yheight = mccdiffraction_detector_11_yheight;
MCNUM restore_neutron = mccdiffraction_detector_11_restore_neutron;
#line 129 "/usr/share/mcstas/2.7/monitors/PSD_monitor.comp"
{
  multiline(5,
    (double)xmin, (double)ymin, 0.0,
    (double)xmax, (double)ymin, 0.0,
    (double)xmax, (double)ymax, 0.0,
    (double)xmin, (double)ymax, 0.0,
    (double)xmin, (double)ymin, 0.0);
}
#line 485602 "MACS_sample_kidney_box.c"
}   /* End of diffraction_detector_11=PSD_monitor() SETTING parameter declarations. */
#undef PSD_p2
#undef PSD_p
#undef PSD_N
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

  /* MCDISPLAY code for component 'spec_detector_11'. */
  SIG_MESSAGE("spec_detector_11 (McDisplay)");
  printf("MCDISPLAY: component %s\n", "spec_detector_11");
#define mccompcurname  spec_detector_11
#define mccompcurtype  PSD_monitor
#define mccompcurindex 908
#define PSD_N mccspec_detector_11_PSD_N
#define PSD_p mccspec_detector_11_PSD_p
#define PSD_p2 mccspec_detector_11_PSD_p2
{   /* Declarations of spec_detector_11=PSD_monitor() SETTING parameters. */
int nx = mccspec_detector_11_nx;
int ny = mccspec_detector_11_ny;
char* filename = mccspec_detector_11_filename;
MCNUM xmin = mccspec_detector_11_xmin;
MCNUM xmax = mccspec_detector_11_xmax;
MCNUM ymin = mccspec_detector_11_ymin;
MCNUM ymax = mccspec_detector_11_ymax;
MCNUM xwidth = mccspec_detector_11_xwidth;
MCNUM yheight = mccspec_detector_11_yheight;
MCNUM restore_neutron = mccspec_detector_11_restore_neutron;
#line 129 "/usr/share/mcstas/2.7/monitors/PSD_monitor.comp"
{
  multiline(5,
    (double)xmin, (double)ymin, 0.0,
    (double)xmax, (double)ymin, 0.0,
    (double)xmax, (double)ymax, 0.0,
    (double)xmin, (double)ymax, 0.0,
    (double)xmin, (double)ymin, 0.0);
}
#line 485640 "MACS_sample_kidney_box.c"
}   /* End of spec_detector_11=PSD_monitor() SETTING parameter declarations. */
#undef PSD_p2
#undef PSD_p
#undef PSD_N
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

  /* MCDISPLAY code for component 'diffraction_detector_12'. */
  SIG_MESSAGE("diffraction_detector_12 (McDisplay)");
  printf("MCDISPLAY: component %s\n", "diffraction_detector_12");
#define mccompcurname  diffraction_detector_12
#define mccompcurtype  PSD_monitor
#define mccompcurindex 909
#define PSD_N mccdiffraction_detector_12_PSD_N
#define PSD_p mccdiffraction_detector_12_PSD_p
#define PSD_p2 mccdiffraction_detector_12_PSD_p2
{   /* Declarations of diffraction_detector_12=PSD_monitor() SETTING parameters. */
int nx = mccdiffraction_detector_12_nx;
int ny = mccdiffraction_detector_12_ny;
char* filename = mccdiffraction_detector_12_filename;
MCNUM xmin = mccdiffraction_detector_12_xmin;
MCNUM xmax = mccdiffraction_detector_12_xmax;
MCNUM ymin = mccdiffraction_detector_12_ymin;
MCNUM ymax = mccdiffraction_detector_12_ymax;
MCNUM xwidth = mccdiffraction_detector_12_xwidth;
MCNUM yheight = mccdiffraction_detector_12_yheight;
MCNUM restore_neutron = mccdiffraction_detector_12_restore_neutron;
#line 129 "/usr/share/mcstas/2.7/monitors/PSD_monitor.comp"
{
  multiline(5,
    (double)xmin, (double)ymin, 0.0,
    (double)xmax, (double)ymin, 0.0,
    (double)xmax, (double)ymax, 0.0,
    (double)xmin, (double)ymax, 0.0,
    (double)xmin, (double)ymin, 0.0);
}
#line 485678 "MACS_sample_kidney_box.c"
}   /* End of diffraction_detector_12=PSD_monitor() SETTING parameter declarations. */
#undef PSD_p2
#undef PSD_p
#undef PSD_N
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

  /* MCDISPLAY code for component 'spec_detector_12'. */
  SIG_MESSAGE("spec_detector_12 (McDisplay)");
  printf("MCDISPLAY: component %s\n", "spec_detector_12");
#define mccompcurname  spec_detector_12
#define mccompcurtype  PSD_monitor
#define mccompcurindex 910
#define PSD_N mccspec_detector_12_PSD_N
#define PSD_p mccspec_detector_12_PSD_p
#define PSD_p2 mccspec_detector_12_PSD_p2
{   /* Declarations of spec_detector_12=PSD_monitor() SETTING parameters. */
int nx = mccspec_detector_12_nx;
int ny = mccspec_detector_12_ny;
char* filename = mccspec_detector_12_filename;
MCNUM xmin = mccspec_detector_12_xmin;
MCNUM xmax = mccspec_detector_12_xmax;
MCNUM ymin = mccspec_detector_12_ymin;
MCNUM ymax = mccspec_detector_12_ymax;
MCNUM xwidth = mccspec_detector_12_xwidth;
MCNUM yheight = mccspec_detector_12_yheight;
MCNUM restore_neutron = mccspec_detector_12_restore_neutron;
#line 129 "/usr/share/mcstas/2.7/monitors/PSD_monitor.comp"
{
  multiline(5,
    (double)xmin, (double)ymin, 0.0,
    (double)xmax, (double)ymin, 0.0,
    (double)xmax, (double)ymax, 0.0,
    (double)xmin, (double)ymax, 0.0,
    (double)xmin, (double)ymin, 0.0);
}
#line 485716 "MACS_sample_kidney_box.c"
}   /* End of spec_detector_12=PSD_monitor() SETTING parameter declarations. */
#undef PSD_p2
#undef PSD_p
#undef PSD_N
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

  /* MCDISPLAY code for component 'diffraction_detector_13'. */
  SIG_MESSAGE("diffraction_detector_13 (McDisplay)");
  printf("MCDISPLAY: component %s\n", "diffraction_detector_13");
#define mccompcurname  diffraction_detector_13
#define mccompcurtype  PSD_monitor
#define mccompcurindex 911
#define PSD_N mccdiffraction_detector_13_PSD_N
#define PSD_p mccdiffraction_detector_13_PSD_p
#define PSD_p2 mccdiffraction_detector_13_PSD_p2
{   /* Declarations of diffraction_detector_13=PSD_monitor() SETTING parameters. */
int nx = mccdiffraction_detector_13_nx;
int ny = mccdiffraction_detector_13_ny;
char* filename = mccdiffraction_detector_13_filename;
MCNUM xmin = mccdiffraction_detector_13_xmin;
MCNUM xmax = mccdiffraction_detector_13_xmax;
MCNUM ymin = mccdiffraction_detector_13_ymin;
MCNUM ymax = mccdiffraction_detector_13_ymax;
MCNUM xwidth = mccdiffraction_detector_13_xwidth;
MCNUM yheight = mccdiffraction_detector_13_yheight;
MCNUM restore_neutron = mccdiffraction_detector_13_restore_neutron;
#line 129 "/usr/share/mcstas/2.7/monitors/PSD_monitor.comp"
{
  multiline(5,
    (double)xmin, (double)ymin, 0.0,
    (double)xmax, (double)ymin, 0.0,
    (double)xmax, (double)ymax, 0.0,
    (double)xmin, (double)ymax, 0.0,
    (double)xmin, (double)ymin, 0.0);
}
#line 485754 "MACS_sample_kidney_box.c"
}   /* End of diffraction_detector_13=PSD_monitor() SETTING parameter declarations. */
#undef PSD_p2
#undef PSD_p
#undef PSD_N
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

  /* MCDISPLAY code for component 'spec_detector_13'. */
  SIG_MESSAGE("spec_detector_13 (McDisplay)");
  printf("MCDISPLAY: component %s\n", "spec_detector_13");
#define mccompcurname  spec_detector_13
#define mccompcurtype  PSD_monitor
#define mccompcurindex 912
#define PSD_N mccspec_detector_13_PSD_N
#define PSD_p mccspec_detector_13_PSD_p
#define PSD_p2 mccspec_detector_13_PSD_p2
{   /* Declarations of spec_detector_13=PSD_monitor() SETTING parameters. */
int nx = mccspec_detector_13_nx;
int ny = mccspec_detector_13_ny;
char* filename = mccspec_detector_13_filename;
MCNUM xmin = mccspec_detector_13_xmin;
MCNUM xmax = mccspec_detector_13_xmax;
MCNUM ymin = mccspec_detector_13_ymin;
MCNUM ymax = mccspec_detector_13_ymax;
MCNUM xwidth = mccspec_detector_13_xwidth;
MCNUM yheight = mccspec_detector_13_yheight;
MCNUM restore_neutron = mccspec_detector_13_restore_neutron;
#line 129 "/usr/share/mcstas/2.7/monitors/PSD_monitor.comp"
{
  multiline(5,
    (double)xmin, (double)ymin, 0.0,
    (double)xmax, (double)ymin, 0.0,
    (double)xmax, (double)ymax, 0.0,
    (double)xmin, (double)ymax, 0.0,
    (double)xmin, (double)ymin, 0.0);
}
#line 485792 "MACS_sample_kidney_box.c"
}   /* End of spec_detector_13=PSD_monitor() SETTING parameter declarations. */
#undef PSD_p2
#undef PSD_p
#undef PSD_N
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

  /* MCDISPLAY code for component 'diffraction_detector_14'. */
  SIG_MESSAGE("diffraction_detector_14 (McDisplay)");
  printf("MCDISPLAY: component %s\n", "diffraction_detector_14");
#define mccompcurname  diffraction_detector_14
#define mccompcurtype  PSD_monitor
#define mccompcurindex 913
#define PSD_N mccdiffraction_detector_14_PSD_N
#define PSD_p mccdiffraction_detector_14_PSD_p
#define PSD_p2 mccdiffraction_detector_14_PSD_p2
{   /* Declarations of diffraction_detector_14=PSD_monitor() SETTING parameters. */
int nx = mccdiffraction_detector_14_nx;
int ny = mccdiffraction_detector_14_ny;
char* filename = mccdiffraction_detector_14_filename;
MCNUM xmin = mccdiffraction_detector_14_xmin;
MCNUM xmax = mccdiffraction_detector_14_xmax;
MCNUM ymin = mccdiffraction_detector_14_ymin;
MCNUM ymax = mccdiffraction_detector_14_ymax;
MCNUM xwidth = mccdiffraction_detector_14_xwidth;
MCNUM yheight = mccdiffraction_detector_14_yheight;
MCNUM restore_neutron = mccdiffraction_detector_14_restore_neutron;
#line 129 "/usr/share/mcstas/2.7/monitors/PSD_monitor.comp"
{
  multiline(5,
    (double)xmin, (double)ymin, 0.0,
    (double)xmax, (double)ymin, 0.0,
    (double)xmax, (double)ymax, 0.0,
    (double)xmin, (double)ymax, 0.0,
    (double)xmin, (double)ymin, 0.0);
}
#line 485830 "MACS_sample_kidney_box.c"
}   /* End of diffraction_detector_14=PSD_monitor() SETTING parameter declarations. */
#undef PSD_p2
#undef PSD_p
#undef PSD_N
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

  /* MCDISPLAY code for component 'spec_detector_14'. */
  SIG_MESSAGE("spec_detector_14 (McDisplay)");
  printf("MCDISPLAY: component %s\n", "spec_detector_14");
#define mccompcurname  spec_detector_14
#define mccompcurtype  PSD_monitor
#define mccompcurindex 914
#define PSD_N mccspec_detector_14_PSD_N
#define PSD_p mccspec_detector_14_PSD_p
#define PSD_p2 mccspec_detector_14_PSD_p2
{   /* Declarations of spec_detector_14=PSD_monitor() SETTING parameters. */
int nx = mccspec_detector_14_nx;
int ny = mccspec_detector_14_ny;
char* filename = mccspec_detector_14_filename;
MCNUM xmin = mccspec_detector_14_xmin;
MCNUM xmax = mccspec_detector_14_xmax;
MCNUM ymin = mccspec_detector_14_ymin;
MCNUM ymax = mccspec_detector_14_ymax;
MCNUM xwidth = mccspec_detector_14_xwidth;
MCNUM yheight = mccspec_detector_14_yheight;
MCNUM restore_neutron = mccspec_detector_14_restore_neutron;
#line 129 "/usr/share/mcstas/2.7/monitors/PSD_monitor.comp"
{
  multiline(5,
    (double)xmin, (double)ymin, 0.0,
    (double)xmax, (double)ymin, 0.0,
    (double)xmax, (double)ymax, 0.0,
    (double)xmin, (double)ymax, 0.0,
    (double)xmin, (double)ymin, 0.0);
}
#line 485868 "MACS_sample_kidney_box.c"
}   /* End of spec_detector_14=PSD_monitor() SETTING parameter declarations. */
#undef PSD_p2
#undef PSD_p
#undef PSD_N
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

  /* MCDISPLAY code for component 'diffraction_detector_15'. */
  SIG_MESSAGE("diffraction_detector_15 (McDisplay)");
  printf("MCDISPLAY: component %s\n", "diffraction_detector_15");
#define mccompcurname  diffraction_detector_15
#define mccompcurtype  PSD_monitor
#define mccompcurindex 915
#define PSD_N mccdiffraction_detector_15_PSD_N
#define PSD_p mccdiffraction_detector_15_PSD_p
#define PSD_p2 mccdiffraction_detector_15_PSD_p2
{   /* Declarations of diffraction_detector_15=PSD_monitor() SETTING parameters. */
int nx = mccdiffraction_detector_15_nx;
int ny = mccdiffraction_detector_15_ny;
char* filename = mccdiffraction_detector_15_filename;
MCNUM xmin = mccdiffraction_detector_15_xmin;
MCNUM xmax = mccdiffraction_detector_15_xmax;
MCNUM ymin = mccdiffraction_detector_15_ymin;
MCNUM ymax = mccdiffraction_detector_15_ymax;
MCNUM xwidth = mccdiffraction_detector_15_xwidth;
MCNUM yheight = mccdiffraction_detector_15_yheight;
MCNUM restore_neutron = mccdiffraction_detector_15_restore_neutron;
#line 129 "/usr/share/mcstas/2.7/monitors/PSD_monitor.comp"
{
  multiline(5,
    (double)xmin, (double)ymin, 0.0,
    (double)xmax, (double)ymin, 0.0,
    (double)xmax, (double)ymax, 0.0,
    (double)xmin, (double)ymax, 0.0,
    (double)xmin, (double)ymin, 0.0);
}
#line 485906 "MACS_sample_kidney_box.c"
}   /* End of diffraction_detector_15=PSD_monitor() SETTING parameter declarations. */
#undef PSD_p2
#undef PSD_p
#undef PSD_N
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

  /* MCDISPLAY code for component 'spec_detector_15'. */
  SIG_MESSAGE("spec_detector_15 (McDisplay)");
  printf("MCDISPLAY: component %s\n", "spec_detector_15");
#define mccompcurname  spec_detector_15
#define mccompcurtype  PSD_monitor
#define mccompcurindex 916
#define PSD_N mccspec_detector_15_PSD_N
#define PSD_p mccspec_detector_15_PSD_p
#define PSD_p2 mccspec_detector_15_PSD_p2
{   /* Declarations of spec_detector_15=PSD_monitor() SETTING parameters. */
int nx = mccspec_detector_15_nx;
int ny = mccspec_detector_15_ny;
char* filename = mccspec_detector_15_filename;
MCNUM xmin = mccspec_detector_15_xmin;
MCNUM xmax = mccspec_detector_15_xmax;
MCNUM ymin = mccspec_detector_15_ymin;
MCNUM ymax = mccspec_detector_15_ymax;
MCNUM xwidth = mccspec_detector_15_xwidth;
MCNUM yheight = mccspec_detector_15_yheight;
MCNUM restore_neutron = mccspec_detector_15_restore_neutron;
#line 129 "/usr/share/mcstas/2.7/monitors/PSD_monitor.comp"
{
  multiline(5,
    (double)xmin, (double)ymin, 0.0,
    (double)xmax, (double)ymin, 0.0,
    (double)xmax, (double)ymax, 0.0,
    (double)xmin, (double)ymax, 0.0,
    (double)xmin, (double)ymin, 0.0);
}
#line 485944 "MACS_sample_kidney_box.c"
}   /* End of spec_detector_15=PSD_monitor() SETTING parameter declarations. */
#undef PSD_p2
#undef PSD_p
#undef PSD_N
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

  /* MCDISPLAY code for component 'diffraction_detector_16'. */
  SIG_MESSAGE("diffraction_detector_16 (McDisplay)");
  printf("MCDISPLAY: component %s\n", "diffraction_detector_16");
#define mccompcurname  diffraction_detector_16
#define mccompcurtype  PSD_monitor
#define mccompcurindex 917
#define PSD_N mccdiffraction_detector_16_PSD_N
#define PSD_p mccdiffraction_detector_16_PSD_p
#define PSD_p2 mccdiffraction_detector_16_PSD_p2
{   /* Declarations of diffraction_detector_16=PSD_monitor() SETTING parameters. */
int nx = mccdiffraction_detector_16_nx;
int ny = mccdiffraction_detector_16_ny;
char* filename = mccdiffraction_detector_16_filename;
MCNUM xmin = mccdiffraction_detector_16_xmin;
MCNUM xmax = mccdiffraction_detector_16_xmax;
MCNUM ymin = mccdiffraction_detector_16_ymin;
MCNUM ymax = mccdiffraction_detector_16_ymax;
MCNUM xwidth = mccdiffraction_detector_16_xwidth;
MCNUM yheight = mccdiffraction_detector_16_yheight;
MCNUM restore_neutron = mccdiffraction_detector_16_restore_neutron;
#line 129 "/usr/share/mcstas/2.7/monitors/PSD_monitor.comp"
{
  multiline(5,
    (double)xmin, (double)ymin, 0.0,
    (double)xmax, (double)ymin, 0.0,
    (double)xmax, (double)ymax, 0.0,
    (double)xmin, (double)ymax, 0.0,
    (double)xmin, (double)ymin, 0.0);
}
#line 485982 "MACS_sample_kidney_box.c"
}   /* End of diffraction_detector_16=PSD_monitor() SETTING parameter declarations. */
#undef PSD_p2
#undef PSD_p
#undef PSD_N
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

  /* MCDISPLAY code for component 'spec_detector_16'. */
  SIG_MESSAGE("spec_detector_16 (McDisplay)");
  printf("MCDISPLAY: component %s\n", "spec_detector_16");
#define mccompcurname  spec_detector_16
#define mccompcurtype  PSD_monitor
#define mccompcurindex 918
#define PSD_N mccspec_detector_16_PSD_N
#define PSD_p mccspec_detector_16_PSD_p
#define PSD_p2 mccspec_detector_16_PSD_p2
{   /* Declarations of spec_detector_16=PSD_monitor() SETTING parameters. */
int nx = mccspec_detector_16_nx;
int ny = mccspec_detector_16_ny;
char* filename = mccspec_detector_16_filename;
MCNUM xmin = mccspec_detector_16_xmin;
MCNUM xmax = mccspec_detector_16_xmax;
MCNUM ymin = mccspec_detector_16_ymin;
MCNUM ymax = mccspec_detector_16_ymax;
MCNUM xwidth = mccspec_detector_16_xwidth;
MCNUM yheight = mccspec_detector_16_yheight;
MCNUM restore_neutron = mccspec_detector_16_restore_neutron;
#line 129 "/usr/share/mcstas/2.7/monitors/PSD_monitor.comp"
{
  multiline(5,
    (double)xmin, (double)ymin, 0.0,
    (double)xmax, (double)ymin, 0.0,
    (double)xmax, (double)ymax, 0.0,
    (double)xmin, (double)ymax, 0.0,
    (double)xmin, (double)ymin, 0.0);
}
#line 486020 "MACS_sample_kidney_box.c"
}   /* End of spec_detector_16=PSD_monitor() SETTING parameter declarations. */
#undef PSD_p2
#undef PSD_p
#undef PSD_N
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

  /* MCDISPLAY code for component 'diffraction_detector_17'. */
  SIG_MESSAGE("diffraction_detector_17 (McDisplay)");
  printf("MCDISPLAY: component %s\n", "diffraction_detector_17");
#define mccompcurname  diffraction_detector_17
#define mccompcurtype  PSD_monitor
#define mccompcurindex 919
#define PSD_N mccdiffraction_detector_17_PSD_N
#define PSD_p mccdiffraction_detector_17_PSD_p
#define PSD_p2 mccdiffraction_detector_17_PSD_p2
{   /* Declarations of diffraction_detector_17=PSD_monitor() SETTING parameters. */
int nx = mccdiffraction_detector_17_nx;
int ny = mccdiffraction_detector_17_ny;
char* filename = mccdiffraction_detector_17_filename;
MCNUM xmin = mccdiffraction_detector_17_xmin;
MCNUM xmax = mccdiffraction_detector_17_xmax;
MCNUM ymin = mccdiffraction_detector_17_ymin;
MCNUM ymax = mccdiffraction_detector_17_ymax;
MCNUM xwidth = mccdiffraction_detector_17_xwidth;
MCNUM yheight = mccdiffraction_detector_17_yheight;
MCNUM restore_neutron = mccdiffraction_detector_17_restore_neutron;
#line 129 "/usr/share/mcstas/2.7/monitors/PSD_monitor.comp"
{
  multiline(5,
    (double)xmin, (double)ymin, 0.0,
    (double)xmax, (double)ymin, 0.0,
    (double)xmax, (double)ymax, 0.0,
    (double)xmin, (double)ymax, 0.0,
    (double)xmin, (double)ymin, 0.0);
}
#line 486058 "MACS_sample_kidney_box.c"
}   /* End of diffraction_detector_17=PSD_monitor() SETTING parameter declarations. */
#undef PSD_p2
#undef PSD_p
#undef PSD_N
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

  /* MCDISPLAY code for component 'spec_detector_17'. */
  SIG_MESSAGE("spec_detector_17 (McDisplay)");
  printf("MCDISPLAY: component %s\n", "spec_detector_17");
#define mccompcurname  spec_detector_17
#define mccompcurtype  PSD_monitor
#define mccompcurindex 920
#define PSD_N mccspec_detector_17_PSD_N
#define PSD_p mccspec_detector_17_PSD_p
#define PSD_p2 mccspec_detector_17_PSD_p2
{   /* Declarations of spec_detector_17=PSD_monitor() SETTING parameters. */
int nx = mccspec_detector_17_nx;
int ny = mccspec_detector_17_ny;
char* filename = mccspec_detector_17_filename;
MCNUM xmin = mccspec_detector_17_xmin;
MCNUM xmax = mccspec_detector_17_xmax;
MCNUM ymin = mccspec_detector_17_ymin;
MCNUM ymax = mccspec_detector_17_ymax;
MCNUM xwidth = mccspec_detector_17_xwidth;
MCNUM yheight = mccspec_detector_17_yheight;
MCNUM restore_neutron = mccspec_detector_17_restore_neutron;
#line 129 "/usr/share/mcstas/2.7/monitors/PSD_monitor.comp"
{
  multiline(5,
    (double)xmin, (double)ymin, 0.0,
    (double)xmax, (double)ymin, 0.0,
    (double)xmax, (double)ymax, 0.0,
    (double)xmin, (double)ymax, 0.0,
    (double)xmin, (double)ymin, 0.0);
}
#line 486096 "MACS_sample_kidney_box.c"
}   /* End of spec_detector_17=PSD_monitor() SETTING parameter declarations. */
#undef PSD_p2
#undef PSD_p
#undef PSD_N
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

  /* MCDISPLAY code for component 'diffraction_detector_18'. */
  SIG_MESSAGE("diffraction_detector_18 (McDisplay)");
  printf("MCDISPLAY: component %s\n", "diffraction_detector_18");
#define mccompcurname  diffraction_detector_18
#define mccompcurtype  PSD_monitor
#define mccompcurindex 921
#define PSD_N mccdiffraction_detector_18_PSD_N
#define PSD_p mccdiffraction_detector_18_PSD_p
#define PSD_p2 mccdiffraction_detector_18_PSD_p2
{   /* Declarations of diffraction_detector_18=PSD_monitor() SETTING parameters. */
int nx = mccdiffraction_detector_18_nx;
int ny = mccdiffraction_detector_18_ny;
char* filename = mccdiffraction_detector_18_filename;
MCNUM xmin = mccdiffraction_detector_18_xmin;
MCNUM xmax = mccdiffraction_detector_18_xmax;
MCNUM ymin = mccdiffraction_detector_18_ymin;
MCNUM ymax = mccdiffraction_detector_18_ymax;
MCNUM xwidth = mccdiffraction_detector_18_xwidth;
MCNUM yheight = mccdiffraction_detector_18_yheight;
MCNUM restore_neutron = mccdiffraction_detector_18_restore_neutron;
#line 129 "/usr/share/mcstas/2.7/monitors/PSD_monitor.comp"
{
  multiline(5,
    (double)xmin, (double)ymin, 0.0,
    (double)xmax, (double)ymin, 0.0,
    (double)xmax, (double)ymax, 0.0,
    (double)xmin, (double)ymax, 0.0,
    (double)xmin, (double)ymin, 0.0);
}
#line 486134 "MACS_sample_kidney_box.c"
}   /* End of diffraction_detector_18=PSD_monitor() SETTING parameter declarations. */
#undef PSD_p2
#undef PSD_p
#undef PSD_N
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

  /* MCDISPLAY code for component 'spec_detector_18'. */
  SIG_MESSAGE("spec_detector_18 (McDisplay)");
  printf("MCDISPLAY: component %s\n", "spec_detector_18");
#define mccompcurname  spec_detector_18
#define mccompcurtype  PSD_monitor
#define mccompcurindex 922
#define PSD_N mccspec_detector_18_PSD_N
#define PSD_p mccspec_detector_18_PSD_p
#define PSD_p2 mccspec_detector_18_PSD_p2
{   /* Declarations of spec_detector_18=PSD_monitor() SETTING parameters. */
int nx = mccspec_detector_18_nx;
int ny = mccspec_detector_18_ny;
char* filename = mccspec_detector_18_filename;
MCNUM xmin = mccspec_detector_18_xmin;
MCNUM xmax = mccspec_detector_18_xmax;
MCNUM ymin = mccspec_detector_18_ymin;
MCNUM ymax = mccspec_detector_18_ymax;
MCNUM xwidth = mccspec_detector_18_xwidth;
MCNUM yheight = mccspec_detector_18_yheight;
MCNUM restore_neutron = mccspec_detector_18_restore_neutron;
#line 129 "/usr/share/mcstas/2.7/monitors/PSD_monitor.comp"
{
  multiline(5,
    (double)xmin, (double)ymin, 0.0,
    (double)xmax, (double)ymin, 0.0,
    (double)xmax, (double)ymax, 0.0,
    (double)xmin, (double)ymax, 0.0,
    (double)xmin, (double)ymin, 0.0);
}
#line 486172 "MACS_sample_kidney_box.c"
}   /* End of spec_detector_18=PSD_monitor() SETTING parameter declarations. */
#undef PSD_p2
#undef PSD_p
#undef PSD_N
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

  /* MCDISPLAY code for component 'diffraction_detector_19'. */
  SIG_MESSAGE("diffraction_detector_19 (McDisplay)");
  printf("MCDISPLAY: component %s\n", "diffraction_detector_19");
#define mccompcurname  diffraction_detector_19
#define mccompcurtype  PSD_monitor
#define mccompcurindex 923
#define PSD_N mccdiffraction_detector_19_PSD_N
#define PSD_p mccdiffraction_detector_19_PSD_p
#define PSD_p2 mccdiffraction_detector_19_PSD_p2
{   /* Declarations of diffraction_detector_19=PSD_monitor() SETTING parameters. */
int nx = mccdiffraction_detector_19_nx;
int ny = mccdiffraction_detector_19_ny;
char* filename = mccdiffraction_detector_19_filename;
MCNUM xmin = mccdiffraction_detector_19_xmin;
MCNUM xmax = mccdiffraction_detector_19_xmax;
MCNUM ymin = mccdiffraction_detector_19_ymin;
MCNUM ymax = mccdiffraction_detector_19_ymax;
MCNUM xwidth = mccdiffraction_detector_19_xwidth;
MCNUM yheight = mccdiffraction_detector_19_yheight;
MCNUM restore_neutron = mccdiffraction_detector_19_restore_neutron;
#line 129 "/usr/share/mcstas/2.7/monitors/PSD_monitor.comp"
{
  multiline(5,
    (double)xmin, (double)ymin, 0.0,
    (double)xmax, (double)ymin, 0.0,
    (double)xmax, (double)ymax, 0.0,
    (double)xmin, (double)ymax, 0.0,
    (double)xmin, (double)ymin, 0.0);
}
#line 486210 "MACS_sample_kidney_box.c"
}   /* End of diffraction_detector_19=PSD_monitor() SETTING parameter declarations. */
#undef PSD_p2
#undef PSD_p
#undef PSD_N
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

  /* MCDISPLAY code for component 'spec_detector_19'. */
  SIG_MESSAGE("spec_detector_19 (McDisplay)");
  printf("MCDISPLAY: component %s\n", "spec_detector_19");
#define mccompcurname  spec_detector_19
#define mccompcurtype  PSD_monitor
#define mccompcurindex 924
#define PSD_N mccspec_detector_19_PSD_N
#define PSD_p mccspec_detector_19_PSD_p
#define PSD_p2 mccspec_detector_19_PSD_p2
{   /* Declarations of spec_detector_19=PSD_monitor() SETTING parameters. */
int nx = mccspec_detector_19_nx;
int ny = mccspec_detector_19_ny;
char* filename = mccspec_detector_19_filename;
MCNUM xmin = mccspec_detector_19_xmin;
MCNUM xmax = mccspec_detector_19_xmax;
MCNUM ymin = mccspec_detector_19_ymin;
MCNUM ymax = mccspec_detector_19_ymax;
MCNUM xwidth = mccspec_detector_19_xwidth;
MCNUM yheight = mccspec_detector_19_yheight;
MCNUM restore_neutron = mccspec_detector_19_restore_neutron;
#line 129 "/usr/share/mcstas/2.7/monitors/PSD_monitor.comp"
{
  multiline(5,
    (double)xmin, (double)ymin, 0.0,
    (double)xmax, (double)ymin, 0.0,
    (double)xmax, (double)ymax, 0.0,
    (double)xmin, (double)ymax, 0.0,
    (double)xmin, (double)ymin, 0.0);
}
#line 486248 "MACS_sample_kidney_box.c"
}   /* End of spec_detector_19=PSD_monitor() SETTING parameter declarations. */
#undef PSD_p2
#undef PSD_p
#undef PSD_N
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

  /* MCDISPLAY code for component 'spec_detector_history_0'. */
  SIG_MESSAGE("spec_detector_history_0 (McDisplay)");
  printf("MCDISPLAY: component %s\n", "spec_detector_history_0");
#define mccompcurname  spec_detector_history_0
#define mccompcurtype  extend_monitor
#define mccompcurindex 925
#define nb mccspec_detector_history_0_nb
#define C_N mccspec_detector_history_0_C_N
#define C_p mccspec_detector_history_0_C_p
#define C_p2 mccspec_detector_history_0_C_p2
{   /* Declarations of spec_detector_history_0=extend_monitor() SETTING parameters. */
char* filename = mccspec_detector_history_0_filename;
MCNUM xmin = mccspec_detector_history_0_xmin;
MCNUM xmax = mccspec_detector_history_0_xmax;
MCNUM ymin = mccspec_detector_history_0_ymin;
MCNUM ymax = mccspec_detector_history_0_ymax;
MCNUM xwidth = mccspec_detector_history_0_xwidth;
MCNUM yheight = mccspec_detector_history_0_yheight;
MCNUM restore_neutron = mccspec_detector_history_0_restore_neutron;
#line 113 "extend_monitor.comp"
{
  magnify("xy");
  multiline(5, (double)xmin, (double)ymin, 0.0,
               (double)xmax, (double)ymin, 0.0,
               (double)xmax, (double)ymax, 0.0,
               (double)xmin, (double)ymax, 0.0,
               (double)xmin, (double)ymin, 0.0);
}
#line 486285 "MACS_sample_kidney_box.c"
}   /* End of spec_detector_history_0=extend_monitor() SETTING parameter declarations. */
#undef C_p2
#undef C_p
#undef C_N
#undef nb
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

  /* MCDISPLAY code for component 'spec_detector_history_1'. */
  SIG_MESSAGE("spec_detector_history_1 (McDisplay)");
  printf("MCDISPLAY: component %s\n", "spec_detector_history_1");
#define mccompcurname  spec_detector_history_1
#define mccompcurtype  extend_monitor
#define mccompcurindex 926
#define nb mccspec_detector_history_1_nb
#define C_N mccspec_detector_history_1_C_N
#define C_p mccspec_detector_history_1_C_p
#define C_p2 mccspec_detector_history_1_C_p2
{   /* Declarations of spec_detector_history_1=extend_monitor() SETTING parameters. */
char* filename = mccspec_detector_history_1_filename;
MCNUM xmin = mccspec_detector_history_1_xmin;
MCNUM xmax = mccspec_detector_history_1_xmax;
MCNUM ymin = mccspec_detector_history_1_ymin;
MCNUM ymax = mccspec_detector_history_1_ymax;
MCNUM xwidth = mccspec_detector_history_1_xwidth;
MCNUM yheight = mccspec_detector_history_1_yheight;
MCNUM restore_neutron = mccspec_detector_history_1_restore_neutron;
#line 113 "extend_monitor.comp"
{
  magnify("xy");
  multiline(5, (double)xmin, (double)ymin, 0.0,
               (double)xmax, (double)ymin, 0.0,
               (double)xmax, (double)ymax, 0.0,
               (double)xmin, (double)ymax, 0.0,
               (double)xmin, (double)ymin, 0.0);
}
#line 486323 "MACS_sample_kidney_box.c"
}   /* End of spec_detector_history_1=extend_monitor() SETTING parameter declarations. */
#undef C_p2
#undef C_p
#undef C_N
#undef nb
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

  /* MCDISPLAY code for component 'spec_detector_history_2'. */
  SIG_MESSAGE("spec_detector_history_2 (McDisplay)");
  printf("MCDISPLAY: component %s\n", "spec_detector_history_2");
#define mccompcurname  spec_detector_history_2
#define mccompcurtype  extend_monitor
#define mccompcurindex 927
#define nb mccspec_detector_history_2_nb
#define C_N mccspec_detector_history_2_C_N
#define C_p mccspec_detector_history_2_C_p
#define C_p2 mccspec_detector_history_2_C_p2
{   /* Declarations of spec_detector_history_2=extend_monitor() SETTING parameters. */
char* filename = mccspec_detector_history_2_filename;
MCNUM xmin = mccspec_detector_history_2_xmin;
MCNUM xmax = mccspec_detector_history_2_xmax;
MCNUM ymin = mccspec_detector_history_2_ymin;
MCNUM ymax = mccspec_detector_history_2_ymax;
MCNUM xwidth = mccspec_detector_history_2_xwidth;
MCNUM yheight = mccspec_detector_history_2_yheight;
MCNUM restore_neutron = mccspec_detector_history_2_restore_neutron;
#line 113 "extend_monitor.comp"
{
  magnify("xy");
  multiline(5, (double)xmin, (double)ymin, 0.0,
               (double)xmax, (double)ymin, 0.0,
               (double)xmax, (double)ymax, 0.0,
               (double)xmin, (double)ymax, 0.0,
               (double)xmin, (double)ymin, 0.0);
}
#line 486361 "MACS_sample_kidney_box.c"
}   /* End of spec_detector_history_2=extend_monitor() SETTING parameter declarations. */
#undef C_p2
#undef C_p
#undef C_N
#undef nb
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

  /* MCDISPLAY code for component 'spec_detector_history_3'. */
  SIG_MESSAGE("spec_detector_history_3 (McDisplay)");
  printf("MCDISPLAY: component %s\n", "spec_detector_history_3");
#define mccompcurname  spec_detector_history_3
#define mccompcurtype  extend_monitor
#define mccompcurindex 928
#define nb mccspec_detector_history_3_nb
#define C_N mccspec_detector_history_3_C_N
#define C_p mccspec_detector_history_3_C_p
#define C_p2 mccspec_detector_history_3_C_p2
{   /* Declarations of spec_detector_history_3=extend_monitor() SETTING parameters. */
char* filename = mccspec_detector_history_3_filename;
MCNUM xmin = mccspec_detector_history_3_xmin;
MCNUM xmax = mccspec_detector_history_3_xmax;
MCNUM ymin = mccspec_detector_history_3_ymin;
MCNUM ymax = mccspec_detector_history_3_ymax;
MCNUM xwidth = mccspec_detector_history_3_xwidth;
MCNUM yheight = mccspec_detector_history_3_yheight;
MCNUM restore_neutron = mccspec_detector_history_3_restore_neutron;
#line 113 "extend_monitor.comp"
{
  magnify("xy");
  multiline(5, (double)xmin, (double)ymin, 0.0,
               (double)xmax, (double)ymin, 0.0,
               (double)xmax, (double)ymax, 0.0,
               (double)xmin, (double)ymax, 0.0,
               (double)xmin, (double)ymin, 0.0);
}
#line 486399 "MACS_sample_kidney_box.c"
}   /* End of spec_detector_history_3=extend_monitor() SETTING parameter declarations. */
#undef C_p2
#undef C_p
#undef C_N
#undef nb
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

  /* MCDISPLAY code for component 'spec_detector_history_4'. */
  SIG_MESSAGE("spec_detector_history_4 (McDisplay)");
  printf("MCDISPLAY: component %s\n", "spec_detector_history_4");
#define mccompcurname  spec_detector_history_4
#define mccompcurtype  extend_monitor
#define mccompcurindex 929
#define nb mccspec_detector_history_4_nb
#define C_N mccspec_detector_history_4_C_N
#define C_p mccspec_detector_history_4_C_p
#define C_p2 mccspec_detector_history_4_C_p2
{   /* Declarations of spec_detector_history_4=extend_monitor() SETTING parameters. */
char* filename = mccspec_detector_history_4_filename;
MCNUM xmin = mccspec_detector_history_4_xmin;
MCNUM xmax = mccspec_detector_history_4_xmax;
MCNUM ymin = mccspec_detector_history_4_ymin;
MCNUM ymax = mccspec_detector_history_4_ymax;
MCNUM xwidth = mccspec_detector_history_4_xwidth;
MCNUM yheight = mccspec_detector_history_4_yheight;
MCNUM restore_neutron = mccspec_detector_history_4_restore_neutron;
#line 113 "extend_monitor.comp"
{
  magnify("xy");
  multiline(5, (double)xmin, (double)ymin, 0.0,
               (double)xmax, (double)ymin, 0.0,
               (double)xmax, (double)ymax, 0.0,
               (double)xmin, (double)ymax, 0.0,
               (double)xmin, (double)ymin, 0.0);
}
#line 486437 "MACS_sample_kidney_box.c"
}   /* End of spec_detector_history_4=extend_monitor() SETTING parameter declarations. */
#undef C_p2
#undef C_p
#undef C_N
#undef nb
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

  /* MCDISPLAY code for component 'spec_detector_history_5'. */
  SIG_MESSAGE("spec_detector_history_5 (McDisplay)");
  printf("MCDISPLAY: component %s\n", "spec_detector_history_5");
#define mccompcurname  spec_detector_history_5
#define mccompcurtype  extend_monitor
#define mccompcurindex 930
#define nb mccspec_detector_history_5_nb
#define C_N mccspec_detector_history_5_C_N
#define C_p mccspec_detector_history_5_C_p
#define C_p2 mccspec_detector_history_5_C_p2
{   /* Declarations of spec_detector_history_5=extend_monitor() SETTING parameters. */
char* filename = mccspec_detector_history_5_filename;
MCNUM xmin = mccspec_detector_history_5_xmin;
MCNUM xmax = mccspec_detector_history_5_xmax;
MCNUM ymin = mccspec_detector_history_5_ymin;
MCNUM ymax = mccspec_detector_history_5_ymax;
MCNUM xwidth = mccspec_detector_history_5_xwidth;
MCNUM yheight = mccspec_detector_history_5_yheight;
MCNUM restore_neutron = mccspec_detector_history_5_restore_neutron;
#line 113 "extend_monitor.comp"
{
  magnify("xy");
  multiline(5, (double)xmin, (double)ymin, 0.0,
               (double)xmax, (double)ymin, 0.0,
               (double)xmax, (double)ymax, 0.0,
               (double)xmin, (double)ymax, 0.0,
               (double)xmin, (double)ymin, 0.0);
}
#line 486475 "MACS_sample_kidney_box.c"
}   /* End of spec_detector_history_5=extend_monitor() SETTING parameter declarations. */
#undef C_p2
#undef C_p
#undef C_N
#undef nb
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

  /* MCDISPLAY code for component 'spec_detector_history_6'. */
  SIG_MESSAGE("spec_detector_history_6 (McDisplay)");
  printf("MCDISPLAY: component %s\n", "spec_detector_history_6");
#define mccompcurname  spec_detector_history_6
#define mccompcurtype  extend_monitor
#define mccompcurindex 931
#define nb mccspec_detector_history_6_nb
#define C_N mccspec_detector_history_6_C_N
#define C_p mccspec_detector_history_6_C_p
#define C_p2 mccspec_detector_history_6_C_p2
{   /* Declarations of spec_detector_history_6=extend_monitor() SETTING parameters. */
char* filename = mccspec_detector_history_6_filename;
MCNUM xmin = mccspec_detector_history_6_xmin;
MCNUM xmax = mccspec_detector_history_6_xmax;
MCNUM ymin = mccspec_detector_history_6_ymin;
MCNUM ymax = mccspec_detector_history_6_ymax;
MCNUM xwidth = mccspec_detector_history_6_xwidth;
MCNUM yheight = mccspec_detector_history_6_yheight;
MCNUM restore_neutron = mccspec_detector_history_6_restore_neutron;
#line 113 "extend_monitor.comp"
{
  magnify("xy");
  multiline(5, (double)xmin, (double)ymin, 0.0,
               (double)xmax, (double)ymin, 0.0,
               (double)xmax, (double)ymax, 0.0,
               (double)xmin, (double)ymax, 0.0,
               (double)xmin, (double)ymin, 0.0);
}
#line 486513 "MACS_sample_kidney_box.c"
}   /* End of spec_detector_history_6=extend_monitor() SETTING parameter declarations. */
#undef C_p2
#undef C_p
#undef C_N
#undef nb
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

  /* MCDISPLAY code for component 'spec_detector_history_7'. */
  SIG_MESSAGE("spec_detector_history_7 (McDisplay)");
  printf("MCDISPLAY: component %s\n", "spec_detector_history_7");
#define mccompcurname  spec_detector_history_7
#define mccompcurtype  extend_monitor
#define mccompcurindex 932
#define nb mccspec_detector_history_7_nb
#define C_N mccspec_detector_history_7_C_N
#define C_p mccspec_detector_history_7_C_p
#define C_p2 mccspec_detector_history_7_C_p2
{   /* Declarations of spec_detector_history_7=extend_monitor() SETTING parameters. */
char* filename = mccspec_detector_history_7_filename;
MCNUM xmin = mccspec_detector_history_7_xmin;
MCNUM xmax = mccspec_detector_history_7_xmax;
MCNUM ymin = mccspec_detector_history_7_ymin;
MCNUM ymax = mccspec_detector_history_7_ymax;
MCNUM xwidth = mccspec_detector_history_7_xwidth;
MCNUM yheight = mccspec_detector_history_7_yheight;
MCNUM restore_neutron = mccspec_detector_history_7_restore_neutron;
#line 113 "extend_monitor.comp"
{
  magnify("xy");
  multiline(5, (double)xmin, (double)ymin, 0.0,
               (double)xmax, (double)ymin, 0.0,
               (double)xmax, (double)ymax, 0.0,
               (double)xmin, (double)ymax, 0.0,
               (double)xmin, (double)ymin, 0.0);
}
#line 486551 "MACS_sample_kidney_box.c"
}   /* End of spec_detector_history_7=extend_monitor() SETTING parameter declarations. */
#undef C_p2
#undef C_p
#undef C_N
#undef nb
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

  /* MCDISPLAY code for component 'spec_detector_history_8'. */
  SIG_MESSAGE("spec_detector_history_8 (McDisplay)");
  printf("MCDISPLAY: component %s\n", "spec_detector_history_8");
#define mccompcurname  spec_detector_history_8
#define mccompcurtype  extend_monitor
#define mccompcurindex 933
#define nb mccspec_detector_history_8_nb
#define C_N mccspec_detector_history_8_C_N
#define C_p mccspec_detector_history_8_C_p
#define C_p2 mccspec_detector_history_8_C_p2
{   /* Declarations of spec_detector_history_8=extend_monitor() SETTING parameters. */
char* filename = mccspec_detector_history_8_filename;
MCNUM xmin = mccspec_detector_history_8_xmin;
MCNUM xmax = mccspec_detector_history_8_xmax;
MCNUM ymin = mccspec_detector_history_8_ymin;
MCNUM ymax = mccspec_detector_history_8_ymax;
MCNUM xwidth = mccspec_detector_history_8_xwidth;
MCNUM yheight = mccspec_detector_history_8_yheight;
MCNUM restore_neutron = mccspec_detector_history_8_restore_neutron;
#line 113 "extend_monitor.comp"
{
  magnify("xy");
  multiline(5, (double)xmin, (double)ymin, 0.0,
               (double)xmax, (double)ymin, 0.0,
               (double)xmax, (double)ymax, 0.0,
               (double)xmin, (double)ymax, 0.0,
               (double)xmin, (double)ymin, 0.0);
}
#line 486589 "MACS_sample_kidney_box.c"
}   /* End of spec_detector_history_8=extend_monitor() SETTING parameter declarations. */
#undef C_p2
#undef C_p
#undef C_N
#undef nb
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

  /* MCDISPLAY code for component 'spec_detector_history_9'. */
  SIG_MESSAGE("spec_detector_history_9 (McDisplay)");
  printf("MCDISPLAY: component %s\n", "spec_detector_history_9");
#define mccompcurname  spec_detector_history_9
#define mccompcurtype  extend_monitor
#define mccompcurindex 934
#define nb mccspec_detector_history_9_nb
#define C_N mccspec_detector_history_9_C_N
#define C_p mccspec_detector_history_9_C_p
#define C_p2 mccspec_detector_history_9_C_p2
{   /* Declarations of spec_detector_history_9=extend_monitor() SETTING parameters. */
char* filename = mccspec_detector_history_9_filename;
MCNUM xmin = mccspec_detector_history_9_xmin;
MCNUM xmax = mccspec_detector_history_9_xmax;
MCNUM ymin = mccspec_detector_history_9_ymin;
MCNUM ymax = mccspec_detector_history_9_ymax;
MCNUM xwidth = mccspec_detector_history_9_xwidth;
MCNUM yheight = mccspec_detector_history_9_yheight;
MCNUM restore_neutron = mccspec_detector_history_9_restore_neutron;
#line 113 "extend_monitor.comp"
{
  magnify("xy");
  multiline(5, (double)xmin, (double)ymin, 0.0,
               (double)xmax, (double)ymin, 0.0,
               (double)xmax, (double)ymax, 0.0,
               (double)xmin, (double)ymax, 0.0,
               (double)xmin, (double)ymin, 0.0);
}
#line 486627 "MACS_sample_kidney_box.c"
}   /* End of spec_detector_history_9=extend_monitor() SETTING parameter declarations. */
#undef C_p2
#undef C_p
#undef C_N
#undef nb
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

  /* MCDISPLAY code for component 'spec_detector_history_10'. */
  SIG_MESSAGE("spec_detector_history_10 (McDisplay)");
  printf("MCDISPLAY: component %s\n", "spec_detector_history_10");
#define mccompcurname  spec_detector_history_10
#define mccompcurtype  extend_monitor
#define mccompcurindex 935
#define nb mccspec_detector_history_10_nb
#define C_N mccspec_detector_history_10_C_N
#define C_p mccspec_detector_history_10_C_p
#define C_p2 mccspec_detector_history_10_C_p2
{   /* Declarations of spec_detector_history_10=extend_monitor() SETTING parameters. */
char* filename = mccspec_detector_history_10_filename;
MCNUM xmin = mccspec_detector_history_10_xmin;
MCNUM xmax = mccspec_detector_history_10_xmax;
MCNUM ymin = mccspec_detector_history_10_ymin;
MCNUM ymax = mccspec_detector_history_10_ymax;
MCNUM xwidth = mccspec_detector_history_10_xwidth;
MCNUM yheight = mccspec_detector_history_10_yheight;
MCNUM restore_neutron = mccspec_detector_history_10_restore_neutron;
#line 113 "extend_monitor.comp"
{
  magnify("xy");
  multiline(5, (double)xmin, (double)ymin, 0.0,
               (double)xmax, (double)ymin, 0.0,
               (double)xmax, (double)ymax, 0.0,
               (double)xmin, (double)ymax, 0.0,
               (double)xmin, (double)ymin, 0.0);
}
#line 486665 "MACS_sample_kidney_box.c"
}   /* End of spec_detector_history_10=extend_monitor() SETTING parameter declarations. */
#undef C_p2
#undef C_p
#undef C_N
#undef nb
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

  /* MCDISPLAY code for component 'spec_detector_history_11'. */
  SIG_MESSAGE("spec_detector_history_11 (McDisplay)");
  printf("MCDISPLAY: component %s\n", "spec_detector_history_11");
#define mccompcurname  spec_detector_history_11
#define mccompcurtype  extend_monitor
#define mccompcurindex 936
#define nb mccspec_detector_history_11_nb
#define C_N mccspec_detector_history_11_C_N
#define C_p mccspec_detector_history_11_C_p
#define C_p2 mccspec_detector_history_11_C_p2
{   /* Declarations of spec_detector_history_11=extend_monitor() SETTING parameters. */
char* filename = mccspec_detector_history_11_filename;
MCNUM xmin = mccspec_detector_history_11_xmin;
MCNUM xmax = mccspec_detector_history_11_xmax;
MCNUM ymin = mccspec_detector_history_11_ymin;
MCNUM ymax = mccspec_detector_history_11_ymax;
MCNUM xwidth = mccspec_detector_history_11_xwidth;
MCNUM yheight = mccspec_detector_history_11_yheight;
MCNUM restore_neutron = mccspec_detector_history_11_restore_neutron;
#line 113 "extend_monitor.comp"
{
  magnify("xy");
  multiline(5, (double)xmin, (double)ymin, 0.0,
               (double)xmax, (double)ymin, 0.0,
               (double)xmax, (double)ymax, 0.0,
               (double)xmin, (double)ymax, 0.0,
               (double)xmin, (double)ymin, 0.0);
}
#line 486703 "MACS_sample_kidney_box.c"
}   /* End of spec_detector_history_11=extend_monitor() SETTING parameter declarations. */
#undef C_p2
#undef C_p
#undef C_N
#undef nb
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

  /* MCDISPLAY code for component 'spec_detector_history_12'. */
  SIG_MESSAGE("spec_detector_history_12 (McDisplay)");
  printf("MCDISPLAY: component %s\n", "spec_detector_history_12");
#define mccompcurname  spec_detector_history_12
#define mccompcurtype  extend_monitor
#define mccompcurindex 937
#define nb mccspec_detector_history_12_nb
#define C_N mccspec_detector_history_12_C_N
#define C_p mccspec_detector_history_12_C_p
#define C_p2 mccspec_detector_history_12_C_p2
{   /* Declarations of spec_detector_history_12=extend_monitor() SETTING parameters. */
char* filename = mccspec_detector_history_12_filename;
MCNUM xmin = mccspec_detector_history_12_xmin;
MCNUM xmax = mccspec_detector_history_12_xmax;
MCNUM ymin = mccspec_detector_history_12_ymin;
MCNUM ymax = mccspec_detector_history_12_ymax;
MCNUM xwidth = mccspec_detector_history_12_xwidth;
MCNUM yheight = mccspec_detector_history_12_yheight;
MCNUM restore_neutron = mccspec_detector_history_12_restore_neutron;
#line 113 "extend_monitor.comp"
{
  magnify("xy");
  multiline(5, (double)xmin, (double)ymin, 0.0,
               (double)xmax, (double)ymin, 0.0,
               (double)xmax, (double)ymax, 0.0,
               (double)xmin, (double)ymax, 0.0,
               (double)xmin, (double)ymin, 0.0);
}
#line 486741 "MACS_sample_kidney_box.c"
}   /* End of spec_detector_history_12=extend_monitor() SETTING parameter declarations. */
#undef C_p2
#undef C_p
#undef C_N
#undef nb
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

  /* MCDISPLAY code for component 'spec_detector_history_13'. */
  SIG_MESSAGE("spec_detector_history_13 (McDisplay)");
  printf("MCDISPLAY: component %s\n", "spec_detector_history_13");
#define mccompcurname  spec_detector_history_13
#define mccompcurtype  extend_monitor
#define mccompcurindex 938
#define nb mccspec_detector_history_13_nb
#define C_N mccspec_detector_history_13_C_N
#define C_p mccspec_detector_history_13_C_p
#define C_p2 mccspec_detector_history_13_C_p2
{   /* Declarations of spec_detector_history_13=extend_monitor() SETTING parameters. */
char* filename = mccspec_detector_history_13_filename;
MCNUM xmin = mccspec_detector_history_13_xmin;
MCNUM xmax = mccspec_detector_history_13_xmax;
MCNUM ymin = mccspec_detector_history_13_ymin;
MCNUM ymax = mccspec_detector_history_13_ymax;
MCNUM xwidth = mccspec_detector_history_13_xwidth;
MCNUM yheight = mccspec_detector_history_13_yheight;
MCNUM restore_neutron = mccspec_detector_history_13_restore_neutron;
#line 113 "extend_monitor.comp"
{
  magnify("xy");
  multiline(5, (double)xmin, (double)ymin, 0.0,
               (double)xmax, (double)ymin, 0.0,
               (double)xmax, (double)ymax, 0.0,
               (double)xmin, (double)ymax, 0.0,
               (double)xmin, (double)ymin, 0.0);
}
#line 486779 "MACS_sample_kidney_box.c"
}   /* End of spec_detector_history_13=extend_monitor() SETTING parameter declarations. */
#undef C_p2
#undef C_p
#undef C_N
#undef nb
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

  /* MCDISPLAY code for component 'spec_detector_history_14'. */
  SIG_MESSAGE("spec_detector_history_14 (McDisplay)");
  printf("MCDISPLAY: component %s\n", "spec_detector_history_14");
#define mccompcurname  spec_detector_history_14
#define mccompcurtype  extend_monitor
#define mccompcurindex 939
#define nb mccspec_detector_history_14_nb
#define C_N mccspec_detector_history_14_C_N
#define C_p mccspec_detector_history_14_C_p
#define C_p2 mccspec_detector_history_14_C_p2
{   /* Declarations of spec_detector_history_14=extend_monitor() SETTING parameters. */
char* filename = mccspec_detector_history_14_filename;
MCNUM xmin = mccspec_detector_history_14_xmin;
MCNUM xmax = mccspec_detector_history_14_xmax;
MCNUM ymin = mccspec_detector_history_14_ymin;
MCNUM ymax = mccspec_detector_history_14_ymax;
MCNUM xwidth = mccspec_detector_history_14_xwidth;
MCNUM yheight = mccspec_detector_history_14_yheight;
MCNUM restore_neutron = mccspec_detector_history_14_restore_neutron;
#line 113 "extend_monitor.comp"
{
  magnify("xy");
  multiline(5, (double)xmin, (double)ymin, 0.0,
               (double)xmax, (double)ymin, 0.0,
               (double)xmax, (double)ymax, 0.0,
               (double)xmin, (double)ymax, 0.0,
               (double)xmin, (double)ymin, 0.0);
}
#line 486817 "MACS_sample_kidney_box.c"
}   /* End of spec_detector_history_14=extend_monitor() SETTING parameter declarations. */
#undef C_p2
#undef C_p
#undef C_N
#undef nb
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

  /* MCDISPLAY code for component 'spec_detector_history_15'. */
  SIG_MESSAGE("spec_detector_history_15 (McDisplay)");
  printf("MCDISPLAY: component %s\n", "spec_detector_history_15");
#define mccompcurname  spec_detector_history_15
#define mccompcurtype  extend_monitor
#define mccompcurindex 940
#define nb mccspec_detector_history_15_nb
#define C_N mccspec_detector_history_15_C_N
#define C_p mccspec_detector_history_15_C_p
#define C_p2 mccspec_detector_history_15_C_p2
{   /* Declarations of spec_detector_history_15=extend_monitor() SETTING parameters. */
char* filename = mccspec_detector_history_15_filename;
MCNUM xmin = mccspec_detector_history_15_xmin;
MCNUM xmax = mccspec_detector_history_15_xmax;
MCNUM ymin = mccspec_detector_history_15_ymin;
MCNUM ymax = mccspec_detector_history_15_ymax;
MCNUM xwidth = mccspec_detector_history_15_xwidth;
MCNUM yheight = mccspec_detector_history_15_yheight;
MCNUM restore_neutron = mccspec_detector_history_15_restore_neutron;
#line 113 "extend_monitor.comp"
{
  magnify("xy");
  multiline(5, (double)xmin, (double)ymin, 0.0,
               (double)xmax, (double)ymin, 0.0,
               (double)xmax, (double)ymax, 0.0,
               (double)xmin, (double)ymax, 0.0,
               (double)xmin, (double)ymin, 0.0);
}
#line 486855 "MACS_sample_kidney_box.c"
}   /* End of spec_detector_history_15=extend_monitor() SETTING parameter declarations. */
#undef C_p2
#undef C_p
#undef C_N
#undef nb
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

  /* MCDISPLAY code for component 'spec_detector_history_16'. */
  SIG_MESSAGE("spec_detector_history_16 (McDisplay)");
  printf("MCDISPLAY: component %s\n", "spec_detector_history_16");
#define mccompcurname  spec_detector_history_16
#define mccompcurtype  extend_monitor
#define mccompcurindex 941
#define nb mccspec_detector_history_16_nb
#define C_N mccspec_detector_history_16_C_N
#define C_p mccspec_detector_history_16_C_p
#define C_p2 mccspec_detector_history_16_C_p2
{   /* Declarations of spec_detector_history_16=extend_monitor() SETTING parameters. */
char* filename = mccspec_detector_history_16_filename;
MCNUM xmin = mccspec_detector_history_16_xmin;
MCNUM xmax = mccspec_detector_history_16_xmax;
MCNUM ymin = mccspec_detector_history_16_ymin;
MCNUM ymax = mccspec_detector_history_16_ymax;
MCNUM xwidth = mccspec_detector_history_16_xwidth;
MCNUM yheight = mccspec_detector_history_16_yheight;
MCNUM restore_neutron = mccspec_detector_history_16_restore_neutron;
#line 113 "extend_monitor.comp"
{
  magnify("xy");
  multiline(5, (double)xmin, (double)ymin, 0.0,
               (double)xmax, (double)ymin, 0.0,
               (double)xmax, (double)ymax, 0.0,
               (double)xmin, (double)ymax, 0.0,
               (double)xmin, (double)ymin, 0.0);
}
#line 486893 "MACS_sample_kidney_box.c"
}   /* End of spec_detector_history_16=extend_monitor() SETTING parameter declarations. */
#undef C_p2
#undef C_p
#undef C_N
#undef nb
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

  /* MCDISPLAY code for component 'spec_detector_history_17'. */
  SIG_MESSAGE("spec_detector_history_17 (McDisplay)");
  printf("MCDISPLAY: component %s\n", "spec_detector_history_17");
#define mccompcurname  spec_detector_history_17
#define mccompcurtype  extend_monitor
#define mccompcurindex 942
#define nb mccspec_detector_history_17_nb
#define C_N mccspec_detector_history_17_C_N
#define C_p mccspec_detector_history_17_C_p
#define C_p2 mccspec_detector_history_17_C_p2
{   /* Declarations of spec_detector_history_17=extend_monitor() SETTING parameters. */
char* filename = mccspec_detector_history_17_filename;
MCNUM xmin = mccspec_detector_history_17_xmin;
MCNUM xmax = mccspec_detector_history_17_xmax;
MCNUM ymin = mccspec_detector_history_17_ymin;
MCNUM ymax = mccspec_detector_history_17_ymax;
MCNUM xwidth = mccspec_detector_history_17_xwidth;
MCNUM yheight = mccspec_detector_history_17_yheight;
MCNUM restore_neutron = mccspec_detector_history_17_restore_neutron;
#line 113 "extend_monitor.comp"
{
  magnify("xy");
  multiline(5, (double)xmin, (double)ymin, 0.0,
               (double)xmax, (double)ymin, 0.0,
               (double)xmax, (double)ymax, 0.0,
               (double)xmin, (double)ymax, 0.0,
               (double)xmin, (double)ymin, 0.0);
}
#line 486931 "MACS_sample_kidney_box.c"
}   /* End of spec_detector_history_17=extend_monitor() SETTING parameter declarations. */
#undef C_p2
#undef C_p
#undef C_N
#undef nb
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

  /* MCDISPLAY code for component 'spec_detector_history_18'. */
  SIG_MESSAGE("spec_detector_history_18 (McDisplay)");
  printf("MCDISPLAY: component %s\n", "spec_detector_history_18");
#define mccompcurname  spec_detector_history_18
#define mccompcurtype  extend_monitor
#define mccompcurindex 943
#define nb mccspec_detector_history_18_nb
#define C_N mccspec_detector_history_18_C_N
#define C_p mccspec_detector_history_18_C_p
#define C_p2 mccspec_detector_history_18_C_p2
{   /* Declarations of spec_detector_history_18=extend_monitor() SETTING parameters. */
char* filename = mccspec_detector_history_18_filename;
MCNUM xmin = mccspec_detector_history_18_xmin;
MCNUM xmax = mccspec_detector_history_18_xmax;
MCNUM ymin = mccspec_detector_history_18_ymin;
MCNUM ymax = mccspec_detector_history_18_ymax;
MCNUM xwidth = mccspec_detector_history_18_xwidth;
MCNUM yheight = mccspec_detector_history_18_yheight;
MCNUM restore_neutron = mccspec_detector_history_18_restore_neutron;
#line 113 "extend_monitor.comp"
{
  magnify("xy");
  multiline(5, (double)xmin, (double)ymin, 0.0,
               (double)xmax, (double)ymin, 0.0,
               (double)xmax, (double)ymax, 0.0,
               (double)xmin, (double)ymax, 0.0,
               (double)xmin, (double)ymin, 0.0);
}
#line 486969 "MACS_sample_kidney_box.c"
}   /* End of spec_detector_history_18=extend_monitor() SETTING parameter declarations. */
#undef C_p2
#undef C_p
#undef C_N
#undef nb
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

  /* MCDISPLAY code for component 'spec_detector_history_19'. */
  SIG_MESSAGE("spec_detector_history_19 (McDisplay)");
  printf("MCDISPLAY: component %s\n", "spec_detector_history_19");
#define mccompcurname  spec_detector_history_19
#define mccompcurtype  extend_monitor
#define mccompcurindex 944
#define nb mccspec_detector_history_19_nb
#define C_N mccspec_detector_history_19_C_N
#define C_p mccspec_detector_history_19_C_p
#define C_p2 mccspec_detector_history_19_C_p2
{   /* Declarations of spec_detector_history_19=extend_monitor() SETTING parameters. */
char* filename = mccspec_detector_history_19_filename;
MCNUM xmin = mccspec_detector_history_19_xmin;
MCNUM xmax = mccspec_detector_history_19_xmax;
MCNUM ymin = mccspec_detector_history_19_ymin;
MCNUM ymax = mccspec_detector_history_19_ymax;
MCNUM xwidth = mccspec_detector_history_19_xwidth;
MCNUM yheight = mccspec_detector_history_19_yheight;
MCNUM restore_neutron = mccspec_detector_history_19_restore_neutron;
#line 113 "extend_monitor.comp"
{
  magnify("xy");
  multiline(5, (double)xmin, (double)ymin, 0.0,
               (double)xmax, (double)ymin, 0.0,
               (double)xmax, (double)ymax, 0.0,
               (double)xmin, (double)ymax, 0.0,
               (double)xmin, (double)ymin, 0.0);
}
#line 487007 "MACS_sample_kidney_box.c"
}   /* End of spec_detector_history_19=extend_monitor() SETTING parameter declarations. */
#undef C_p2
#undef C_p
#undef C_N
#undef nb
#undef mccompcurname
#undef mccompcurtype
#undef mccompcurindex

  printf("MCDISPLAY: end\n");
} /* end display */
#undef magnify
#undef line
#undef dashed_line
#undef multiline
#undef rectangle
#undef box
#undef circle
#undef cylinder
#undef sphere
/* end of generated C code MACS_sample_kidney_box.c */
